        /cc/od/metapps/src/lib/emos/pbio/README


   i)   FORTRAN
        -------

        This file describes a number of subroutines which can be called
        from FORTRAN to handle an unblocked binary file:

        PBGRIB          to read GRIB products
        PBBUFR          to read BUFR products
        PBOPEN          to open the file (must be used before the other
                                          routines are called)
        PBCLOSE         to close the file
        PBSEEK          to position the file (optional)
        PBREAD          to read from the file
        PBREAD2         to read from the file (different behaviour on hitting
                                               end-of-file)
        PBWRITE         to write to the file

        The subroutines are written in C and use standard library functions
        for file handling (fopen, fclose, fseek, fread and fwrite).



  ii)   C
        _

        There are three additional C functions to handle unblocked binary files:

        readgrib        to read GRIB products
        readbufr        to read BUFR products
        readnext        to read any mixture of products

        These functions  are written in C and use standard library functions
        for file handling (fopen, fclose, fseek, fread and fwrite).





 iii)   LIBRARIES
        ---------

        A library (libemos.a) has been made for the BUFR and GRIB binary
	file reading and writing routines.  It is planned to put future 
	software updates into libemos.a and make no changes to the original 
	emoslib.a.

        The original emoslib.a library ( /home/ecmwf/emos_sms/lib/emoslib.a )
        still exists and still contains the original BUFR/GRIB handling 
	routines.


        One set of the binary read/write sources is maintained, hard-linked 
	into the three directories:

                /home/ecmwf/emos_sms/src/libemos/sun4

                /home/ecmwf/emos_sms/src/libemos/sgimips

                /home/ecmwf/emos_sms/src/libemos/unicos


        An object library containing the routines has been made for CRAY, 
	SGI and SUN:

                /usr/local/lib/libemos.a 


        The library names follow the normal UNIX convention and can be 
        specified in the compile/link command using the standard ld 
        convention, for example:

        cc -o program program.c  -lemos





        PBGRIB
        ------

        A subroutine which can be called from FORTRAN to retrieve GRIB 
        products from an unblocked binary file.  The subroutine is an 
        interface to a set of C routines which handle the binary file 
        as a stream of bytes.

        The GRIB products are delivered one per call to a user array.  The
        format and arguments for the subroutine are as follows:

        
        SUBROUTINE PBGRIB(KUNIT,KARRAY,KINLEN,KOUTLEN,KRET)

        where:


        Input parameters are INTEGERs:
        -----

        KUNIT =         unit number for the file; this must have been
                        obtained by calling PBOPEN (see below) - it is
                        a C FILE pointer and not a FORTRAN unit number.

        KARRAY =        FORTRAN array big enough to hold the GRIB product.

        KINLEN =        size in BYTES of the FORTRAN array.


        Output parameters are INTEGERs:
        ------

        KOUTLEN =       actual size in BYTES of the GRIB product read into
                        KARRAY. 

        KRET =           0  if a GRIB product has been successfully read.

                        -1  if end-of-file is hit before a GRIB product is read.
                            (Note that EOF does not cause a program fail, so
                             this value must be explicitly caught by the caller
                             to avoid looping at the EOF)

                        -2  if there is an error in the file-handling (eg. if
                            the file contains a truncated GRIB product).

                        -3  if the size of KARRAY is not sufficient for the 
                            GRIB product.







        PBBUFR
        ------

        A subroutine which can be called from FORTRAN to retrieve BUFR 
        products from an unblocked binary file.  The subroutine is an 
        interface to a set of C routines which handle the binary file 
        as a stream of bytes.

        The BUFR products are delivered one per call to a user array.  The
        format and arguments for the subroutine are as follows:

        
        SUBROUTINE PBBUFR(KUNIT,KARRAY,KINLEN,KOUTLEN,KRET)

        where:


        Input parameters are INTEGERs:
        -----

        KUNIT =         unit number for the file; this must have been
                        obtained by calling PBOPEN (see below) - it is
                        a C FILE pointer and not a FORTRAN unit number.

        KARRAY =        FORTRAN array big enough to hold the BUFR product.

        KINLEN =        size in BYTES of the FORTRAN array.


        Output parameters are INTEGERs:
        ------

        KOUTLEN =       actual size in BYTES of the BUFR product read into
                        KARRAY. 

        KRET =           0  if a BUFR product has been successfully read.

                        -1  if end-of-file is hit before a BUFR product is read.
                            (Note that EOF does not cause a program fail, so
                             this value must be explicitly caught by the caller
                             to avoid looping at the EOF)

                        -2  if there is an error in the file-handling (eg. if
                            the file contains a truncated BUFR product).

                        -3  if the size of KARRAY is not sufficient for the 
                            BUFR product.








        readgrib
        --------

        A C function which can be invoked to retrieve GRIB products from 
        an unblocked binary file.  

        The GRIB products are delivered one per call to a user array.  The
        format and arguments for the function are as follows:


        long readgrib(FILE * file, char * buffer, long * grib_prod_len)
 

        file          =  file pointer returned from PBOPEN

        buffer        = buffer big enough to hold the GRIB product

        grib_prod_len = size of the buffer on input, becomes size in BYTES of 
                        the GRIB product read.  If the end-of-file is hit, the
                        value is returned unchanged (ie. when the function 
                        return code is -1).


        Function returns:

        0  if a GRIB product has been successfully read

       -1  if end-of-file is hit before a GRIB product is read
           (Note that EOF does not cause a program fail, so
           this value must be explicitly caught by the caller
           to avoid looping at the EOF)

       -2  if there is an error in the file-handling 
           (eg. if the file contains a truncated GRIB product)

       -3  if the size of buffer is not sufficient for the GRIB product.
           In this case, the buffer is filled with bytes from the product
           and the file is positioned at the beginning of the following
           product, if any.

       -4  if the user buffer is too small to allow any processing of the
           product at all (eg. less than 8 bytes long)


        If the second parameter is a NULL pointer, the function will pass
        back the length of the next product and will position the file on
        the byte following the end of the product.




        readbufr
        --------

        A C function which can be invoked to retrieve BUFR products from 
        an unblocked binary file.  

        The BUFR products are delivered one per call to a user array.  The
        format and arguments for the function are as follows:


        long readbufr(FILE * file, char * buffer, long * bufr_prod_len)
 

        file          =  file pointer returned from PBOPEN

        buffer        = buffer big enough to hold the BUFR product

        bufr_prod_len = size of the buffer on input, becomes size in BYTES of 
                        the BUFR product read.  If the end-of-file is hit, the
                        value is returned unchanged (ie. when the function 
                        return code is -1).


        Function returns:

        0  if a BUFR product has been successfully read

       -1  if end-of-file is hit before a BUFR product is read
           (Note that EOF does not cause a program fail, so
           this value must be explicitly caught by the caller
           to avoid looping at the EOF)

       -2  if there is an error in the file-handling 
           (eg. if the file contains a truncated BUFR product)

       -3  if the size of buffer is not sufficient for the BUFR product.
           In this case, the buffer is filled with bytes from the product
           and the file is positioned at the beginning of the following
           product, if any.

       -4  if the user buffer is too small to allow any processing of the
           product at all (eg. less than 8 bytes long)


        If the second parameter is a NULL pointer, the function will pass
        back the length of the next product and will position the file on




        readnext
        --------

        A C function which can be invoked to retrieve GRIB or BUFR products 
        from an unblocked binary file.  

        The products are delivered one per call to a user array.  The
        format and arguments for the function are as follows:


        long readnext(char * buffer, long * prod_len, 
              long (*read_func)(char *, long , void *), void * stream)

    Where:
    ------

    buffer        = buffer big enough to hold the GRIB product.
                    If buffer = NULL, the function will create its own 
                    internal buffer and will return the length of the
                    product, but not the product itself.

    prod_len =      size of the buffer on input, becomes size in BYTES of 
                    the product read.  If the end-of-file is hit, this
                    value is returned unchanged (ie. when the function 
                    return code is -1).

    read_func     = function to read input stream

    stream        = data for read_function, eg. file pointer returned 
                    from PBOPEN


        If the second parameter is a NULL pointer, the function will pass
        back the length of the next product and will position the file on
        the byte following the end of the product.



    Function returns:

        0  if a product has been successfully read

       -1  if end-of-file is hit before a product is read

       -3  if the size of buffer is not sufficient for the product

       -4  if the user buffer is too small to start processing product





        PBOPEN
        ------

        A subroutine which can be called from FORTRAN to open an unblocked 
        binary file and return a suitable unit number for use in calls to 
        PBGRIB, PBBUFR, PBSEEK, PBREAD, PBREAD2 and PBWRITE.

        The format and arguments for the subroutine are as follows:

        SUBROUTINE PBOPEN(KUNIT,FILENAME,MODE,KRET)

        where:


        Input parameters are CHARACTERs:
        -----
 
        FILENAME =      a character string describing the file

        MODE     =      a character string describing the mode of
                        access to the file:
                                r       for read
                                w       for write
                                a       for append



        Output parameters are INTEGERs:
        ------

        KUNIT =         unit number for the file - it is a C FILE pointer
                        and not a FORTRAN unit number.

        KRET     =      -1 = Could not open file.
                        -2 = Invalid file name.
                        -3 = Invalid open mode specified
                         0 = OK.








        PBCLOSE
        -------

        A subroutine which can be called from FORTRAN to close an unblocked 
        binary file previously opened with PBOPEN.

        The format and arguments for the subroutine are as follows:

        SUBROUTINE PBCLOSE(KUNIT,KRET)

        where:


        Input parameter is an INTEGER:
        -----
 
        KUNIT =         unit number for the file; this must have been
                        obtained by calling PBOPEN (see below) - it is
                        a C FILE pointer and not a FORTRAN unit number.



        Output parameter is an INTEGER:
        ------

        KRET     =      -1 error in handling the file.
                         0 = OK.






        PBSEEK
        ------

        A subroutine which can be called from FORTRAN to position an 
        unblocked binary file at any desired byte position.

        The format and arguments for the subroutine are as follows:

        SUBROUTINE PBSEEK(KUNIT,KOFFSET,KSTART,KRET)

        where:


        Input parameters are INTEGERs:
        -----

        KUNIT =         unit number for the file; this must have been
                        obtained by calling PBOPEN (see below) - it is
                        a C FILE pointer and not a FORTRAN unit number.

        KOFFSET =       number of bytes to offset the file; this is used
                        as either an absolute or relative offset depending
                        on the value of KSTART.

        KSTART  =       0       if KOFFSET is an absolute count from the
                                beginning of the file,

                        1       if KOFFSET is a relative offset from the
                                current byte position in the file,

                        2       if KOFFSET is an absolute offset from the
                                end of file.


        Output parameter is an INTEGER:
        ------

        KRET    =       -2      if there is an error in handling the file

                        -1      if end-of-file is encountered
                                (Note that EOF does not cause a program fail, 
                                so this value must be explicitly caught by 
                                the caller to avoid looping at the EOF)

                        >= 0    byte offset from the start of file after
                                positioning.







        PBREAD
        ------

        A subroutine which can be called from FORTRAN to read a block of 
        bytes from an unblocked binary file.  ( Note that this routine
        behaves differently from PBREAD2 on hitting end-of-file. )

        The format and arguments for the subroutine are as follows:

        SUBROUTINE PBREAD(KUNIT,KARRAY,KOUNT,KRET)

        where:


        Input parameters are INTEGERs:
        -----

        KUNIT =         unit number for the file; this must have been
                        obtained by calling PBOPEN (see below) - it is
                        a C FILE pointer and not a FORTRAN unit number.

        KOUNT   =       number of BYTES to read from the file.



        Output parameters are INTEGERs:
        ------

        KARRAY =        an INTEGER array to accept the bytes from the read.

        KRET    =       -2      if there is an error in handling the file

                        -1      if end-of-file is encountered
                                (Note that EOF does not cause a program fail, 
                                so this value must be explicitly caught by 
                                the caller to avoid looping at the EOF)

                        >= 0    number of BYTES read from the file.







        PBREAD2
        -------

        A subroutine which can be called from FORTRAN to read a block of 
        bytes from an unblocked binary file.  ( Note that this routine
        behaves differently from PBREAD on hitting end-of-file. )

        The format and arguments for the subroutine are as follows:

        SUBROUTINE PBREAD2(KUNIT,KARRAY,KOUNT,KRET)

        where:


        Input parameters are INTEGERs:
        -----

        KUNIT =         unit number for the file; this must have been
                        obtained by calling PBOPEN (see below) - it is
                        a C FILE pointer and not a FORTRAN unit number.

        KOUNT   =       number of BYTES to read from the file.



        Output parameters are INTEGERs:
        ------

        KARRAY =        an INTEGER array to accept the bytes from the read.

        KRET    =       -2      if there is an error in handling the file

                        >= 0    number of BYTES read from the file.
                                If end-of-file is encountered, KRET returns
                                the number of bytes actually read.  The
                                caller must check this value against the
                                number of bytes requested to detect EOF.




        PBWRITE
        -------

        A subroutine which can be called from FORTRAN to write a block of 
        bytes to an unblocked binary file.

        The format and arguments for the subroutine are as follows:

        SUBROUTINE PBWRITE(KUNIT,KARRAY,KOUNT,KRET)

        where:


        Input parameters are INTEGERs:
        -----

        KUNIT =         unit number for the file; this must have been
                        obtained by calling PBOPEN (see below) - it is
                        a C FILE pointer and not a FORTRAN unit number.

        KARRAY =        an INTEGER array holding the bytes for the write.

        KOUNT   =       number of BYTES to write to the file.



        Output parameter is an INTEGER:
        ------

        KRET    =       -1      if there is an error in writing to the file

                        >= 0    number of BYTES written to the file.







C
C       A sample FORTRAN program
C

        program test3 
C
        integer iret
        integer length
        integer buff(50000)
        integer buflen
        data buflen/200000/
        character*1 moder,modew,modea
        data moder/'r'/,modew/'w'/,modea/'a'/
        character*24 filename
        data filename/'bufr.u'/
        character*24 newfilename
        data newfilename/'bufr.ext'/

C open - for read
        call pbopen(iunit1,filename,moder,iret)
        write(*,*) 'After PBOPEN, iret = ', iret
        if ( iret .ne. 0 ) stop 'open failed'

C open - for write
        call pbopen(iunit2,newfilename,modew,iret)
        write(*,*) 'After PBOPEN, iret = ', iret
        if ( iret .ne. 0 ) stop 'open failed'

        do loop =1,500
C Get the next BUFR product
                call pbbufr(iunit1, buff, buflen, length, iret)
                write (*,*) 'BUFR product number= ', loop
                write (*,*) 'Length of BUFR product = ', length
                write (*,*) 'iret = ', iret

                if (iret .eq. -1 ) stop 'EOF'
                if (iret .eq. -2 ) stop 'file handling problem'
                if (iret .eq. -3 ) stop 'array too small for product'

C Write product to new file 
C               buff(length/4) = o
                call pbwrite(iunit2,buff,length,iret)
                write(*,*) 'After PBWRITE, iret = ', iret
                if ( iret .lt. 0 ) stop 'write failed'
        enddo

C Close files
        call pbclose(iunit1,iret)
        write(*,*) 'After PBCLOSE, iret = ', iret
        if ( iret .ne. 0 ) stop 'close failed'

        call pbclose(iunit2,iret)
        write(*,*) 'After PBCLOSE, iret = ', iret
        if ( iret .ne. 0 ) stop 'close failed'

        stop

        end

This directory contains software from the BUFR decoding and encoding update
library.

bbuprs0.F	 	Print BUFR section 0 (?)
bbuprs1.F	 	Print BUFR section 1 (?)
bbuprs2.F	 	Print BUFR section 2 (?)
bbuprs3.F	 	Print BUFR section 3 (?)
bbuprt.F	 	Print BUFR (?)
bbuprtbox.F	 	Print BUFR box (?)

buaug.F		 	Update augmented Bufr table B.
bubox.F		 	??
bucomp.F	 	Pack number of subsets in a compressed form.
bucrkey.F	 	Extract elements needed for RDB key definition(update).
bucrekey.F	 	Extract elements needed for RDB key definition.
buedd.F		 	Expand section 3 of Bufr message
buens0.F	 	Pack section 0 of Bufrsage.
buens1.F	 	Pack section 1 of Bufr message.
buens2.F	 	Pack section 2 of Bufr message.
buens3.F	 	Pack section 3 of Bufr message.
buens4.F	 	Pack preliminary items/data of sect.4 of Bufr message.
buens5.F	 	Pack sect.5 of Bufr message.
buepmrk.F	 	Process marker operator, replace with table B descriptor
buepmrkc.F	 	Process marker operator, replace with table B descriptor
buepwt.F	 	Updates working tables (name,unit,scale,ref,data width)
buepwtc.F	 	Updates working tables (name,unit,scale,ref,data width)
buerr.F		 	Print error code.
buetab.F	 	Load Bufr table B, D and C according to Bufr code.
buetd.F		 	Expand sect.3 of Bufr message.
buetdr.F	 	Solve Bufr table D reference.
buevar.F	 	Initialize constants and variables.
buexs0.F	 	Expands sect.0 of Bufr message.
buexs1.F	 	Expands sect.1 of Bufr message.
buexs2.F	 	Expands sect.2 of Bufr message.
buexs3.F	 	Expand sect.3 of Bufr message.
buexs3p.F	 	Expand sect.3 of Bufr message. (preliminary items)
buexs4.F	 	Expand sect.4 of Bufr message.
buexs5.F	 	Expands sect.5 of Bufr message.
bufren.F	 	Encode Bufr message.
bufrex.F	 	Decode Bufr message into fully expanded form
bugbts.F	 	Load Bufr table B, D and C according to Bufr code.
bugetbm.F	 	Create bit map to resolve marker operators.
buivar.F	 	Initialize constants and variables.
bunexs.F	 	Sets word/bit pointers at the start of next Bufr sect.
bunpck.F	 	Unpack bit string
bunpks.F	 	Unpack bit string of KSIZE bits.
buoctn.F	 	Calculate number of octets from bit position.
buoper.F	 	Process Bufr operator.
buoperc.F	 	Process Bufr operator.
bupck.F		 	Pack value *KS* in *KSI* bits
bupkey.F	 	Pack local ECMWF information (rdb key)
bupks.F		 	Pack bit string of KSIZE bits
bupmrk.F	 	Process marker operator, relace with table B descriptor.
buprco.F	 	Process Bufr operator.
buprq.F		 	Sets variable KPMISS,KPRUS into common block.
buprs0.F	 	Print sect.0 of Bufr message.
buprs1.F	 	Print sect.1 of bufr message.
buprs2.F	 	Print sect.2 of bufr message (expanded RDB key).
buprs3.F	 	Print sect.3 of Bufr message.
buprt.F		 	Print expanded Bufr message.
buprtbox.F	 	Print boxed expanded bufr message.
burep.F		 	Resolve data descriptor replication problem.
burepc.F		 	Resolve data descriptor replication problem.
burqc.F		 	Create parameters needed for partial expansion of Bufr
burquc.F	 	Create parameters needed for partial expansion of Bufr
bus012.F	 	Expands sect.0,1 AND 2 of Bufr message.
busel.F		 	Returns Data Descriptors as in Section 3  of Bufr
buset.F		 	Set flags in common block (?)
busrp.F		 	Resolve data descriptor replication problem.
busrq.F		 	Set Bufr table B references for partial expansion.
bustdr.F	 	Solve Bufr table D reference.
buuatb.F	 	Update augmented Bufr table B.
buukey.F	 	Expands local ECMWF information from sect.2.
buunp.F		 	Unpack bit string of KSIZE bits
buunps.F	 	Unpack bit string of KSIZE bits
buupwt.F	 	Updates working tables (name,unit,scale,ref,data width)
buxdes.F	 	Expand data descriptors to show user's template
fmmh.F		 	Find max/min latitude/longitude.
mbbuprs0.F  	 	Mars version of routine (without leading m)
mbbuprs1.F  	 	Mars version of routine (without leading m)
mbbuprs2.F  	 	Mars version of routine (without leading m)
mbbuprs3.F  	 	Mars version of routine (without leading m)
mbbuprt.F   	 	Mars version of routine (without leading m)
mbbuprtbox.F 	 	Mars version of routine (without leading m)
mbuaug.F    	 	Mars version of routine (without leading m)
mbubox.F    	 	Mars version of routine (without leading m)
mbucomp.F   	 	Mars version of routine (without leading m)
mbucrekey.F 	 	Mars version of routine (without leading m)
mbucrkey.F  	 	Mars version of routine (without leading m)
mbuedd.F    	 	Mars version of routine (without leading m)
mbuens0.F   	 	Mars version of routine (without leading m)
mbuens1.F   	 	Mars version of routine (without leading m)
mbuens2.F   	 	Mars version of routine (without leading m)
mbuens3.F   	 	Mars version of routine (without leading m)
mbuens4.F   	 	Mars version of routine (without leading m)
mbuens5.F   	 	Mars version of routine (without leading m)
mbuepmrk.F  	 	Mars version of routine (without leading m)
mbuepmrkc.F 	 	Mars version of routine (without leading m)
mbuepwt.F   	 	Mars version of routine (without leading m)
mbuepwtc.F  	 	Mars version of routine (without leading m)
mbuerr.F    	 	Mars version of routine (without leading m)
mbuetab.F   	 	Mars version of routine (without leading m)
mbuetd.F    	 	Mars version of routine (without leading m)
mbuetdr.F   	 	Mars version of routine (without leading m)
mbuevar.F   	 	Mars version of routine (without leading m)
mbuexs0.F   	 	Mars version of routine (without leading m)
mbuexs1.F   	 	Mars version of routine (without leading m)
mbuexs2.F   	 	Mars version of routine (without leading m)
mbuexs3.F   	 	Mars version of routine (without leading m)
mbuexs3p.F  	 	Mars version of routine (without leading m)
mbuexs4.F   	 	Mars version of routine (without leading m)
mbuexs5.F   	 	Mars version of routine (without leading m)
mbufr_mars_filter.F  	 	Mars version of routine (without leading m)
mbufren.F   	 	Mars version of routine (without leading m)
mbufrex.F   	 	Mars version of routine (without leading m)
mbugbts.F   	 	Mars version of routine (without leading m)
mbugetbm.F  	 	Mars version of routine (without leading m)
mbuivar.F   	 	Mars version of routine (without leading m)
mbunexs.F   	 	Mars version of routine (without leading m)
mbunpck.F   	 	Mars version of routine (without leading m)
mbunpks.F   	 	Mars version of routine (without leading m)
mbuoctn.F   	 	Mars version of routine (without leading m)
mbuoper.F   	 	Mars version of routine (without leading m)
mbuoperc.F  	 	Mars version of routine (without leading m)
mbupck.F    	 	Mars version of routine (without leading m)
mbupkey.F   	 	Mars version of routine (without leading m)
mbupks.F    	 	Mars version of routine (without leading m)
mbupmrk.F   	 	Mars version of routine (without leading m)
mbuprco.F   	 	Mars version of routine (without leading m)
mbuprq.F    	 	Mars version of routine (without leading m)
mbuprs0.F   	 	Mars version of routine (without leading m)
mbuprs1.F   	 	Mars version of routine (without leading m)
mbuprs2.F   	 	Mars version of routine (without leading m)
mbuprs3.F   	 	Mars version of routine (without leading m)
mbuprt.F    	 	Mars version of routine (without leading m)
mbuprtbox.F 	 	Mars version of routine (without leading m)
mburep.F    	 	Mars version of routine (without leading m)
mburepc.F   	 	Mars version of routine (without leading m)
mburqc.F    	 	Mars version of routine (without leading m)
mburquc.F   	 	Mars version of routine (without leading m)
mbus012.F   	 	Mars version of routine (without leading m)
mbusel.F    	 	Mars version of routine (without leading m)
mbuset.F    	 	Mars version of routine (without leading m)
mbusrp.F    	 	Mars version of routine (without leading m)
mbusrq.F    	 	Mars version of routine (without leading m)
mbustdr.F   	 	Mars version of routine (without leading m)
mbuuatb.F   	 	Mars version of routine (without leading m)
mbuukey.F   	 	Mars version of routine (without leading m)
mbuunp.F    	 	Mars version of routine (without leading m)
mbuunps.F   	 	Mars version of routine (without leading m)
mbuupwt.F   	 	Mars version of routine (without leading m)
mbuxdes.F   	 	Mars version of routine (without leading m)
mfmmh.F     	 	Mars version of routine (without leading m)
msetlalo.F  	 	Mars version of routine (without leading m)
setlalo.F	    	Return indices for latitude and longitude.
sources	        	Sources

This directory contains a mixture of software, most of which was in the GRIB 
decoding and encoding update library.  The software in this directory is used 
to make part of the libemos library.

John Chambers 30th July 1993.

gfortran -o singlePointInterpolation singlePointInterpolation.F $EMOSLIB

or 

pgf90 -o singlePointInterpolation singlePointInterpolation.F $EMOSLIB


################ OLD and WRONG? COMMENT ##############

it works just for spectral input fields

The Great CMake CookOff
=======================


This is a repository of usefull and less than usefull cmake recipes.  It is distributed under the
[MIT License](http://opensource.org/licenses/MIT)


Adding [Eigen](http://eigen.tuxfamily.org/) to a project
========================================================

Looks for the Eigen installed on system. If not found, then uses external project to download it.
Usage is as follows:

```cmake
# Tell cmake to look into GreatCMakeCookOff for recipes
set(CMAKE_MODULE_PATH ${PROJECT_SOURCE_DIR}/GreatCMakeCookOff) 

# Optionally, tell cmake where to download eigen, if needed.
# Defaults to value below.
set(EXTERNAL_ROOT ${PROJECT_BINARY_DIR}/external)

# Now look for cmake.
find_package(Eigen)
```

**NOTE:** After building the first time, run cmake again. It will find the eigen it downloaded
previously, and it will stop checking for updates. 

Adding [GTest](https://code.google.com/p/googletest/) to a project
==================================================================

For googly reasons, whether valid or 404, GTest prefers to be compiled for each an every project. 
This script does two things:

- it adds GTest as an external project
- it provides a function to add gtests to ctest

This implies that GTest is downloaded the first time that make runs. Furthermore, it will be
checked each and every time that makes runs. So, make now requires a working internet connection.
Unlike Eigen above, there is currently no option avoid checking for updates.

The CMakeLists.txt file could look like this:

```cmake
option(tests          "Enable testing."                         on)

if(tests) 
  find_package(GTest)
  enable_testing()
endif(tests)
```

And adding a test comes down to

```cmake
if(tests)

  add_gtest(testme testme.cc mylib)

endif(tests)
```

- first argument: name of the test
- second argument: list of source files
- other arguments: additional libraries to add during linking

The test do expect an explicit main function. See the test generated in ``tests/addgtest.cmake``.

**NOTE:** When using c++11, it is recommended to first include the c++11 flag script
``AddCPP11Flags.cmake`` (see below) so that the gtest can be compiled with ``GTEST_LANG_CXX11``. 

C++11
=====

Checking for specific features
------------------------------

Look for some c++11 features. Uses a script modified from [here](http://pageant.ghulbus.eu/?p=664).
Usage is given below.

```cmake
# First need to enable c++
enable_language(CXX)

# The following will print out all available features.
cxx11_find_all_features(ALL_FEATURES)
message(STATUS "[c++11] features we can check for: ${ALL_FEATURES}")

# The following checks for all features
cxx11_feature_check()

# An internal value is set if a particular feature exists.
if(HAS_CXX11_AUTO)
  message(STATUS "[c++11] has auto.")
endif()
if(HAS_CXX11_LAMBDA)
  message(STATUS "[c++11] has lambda.")
endif()
```

Alternatively, only a subset of features can be checked for, and some can be required:
```cmake
cxx11_feature_check(auto lambda REQUIRED long_long share_ptr variadic_templates)
```
The previous statement will fail if ``long long``, ``std::shared_ptr<...>``, and variadic templates
are not available. It will also check for the availability of ``auto`` and ``lambda``, but without
failing.

Figuring out flags for some compilers
-------------------------------------

The script checks the existence of a few flags to enable c++11 features on different compilers.
The output is somewhat verbose, but it seems to do the job for gcc, darwin-gcc, and microsoft visual
studio. In addition, the intel compilers have to be told to use an external c++11 standard library.
This script cannot figure where this library would be (hint: g++ provides it), so that is left up to
the user. The script can be activated with a one liner.

```cmake
include("path/to/cookoff/AddCPP11Flags.cmake")
```

**NOTE:** On windows + visual studio, disables warnings 4251 and ups fake variadic templates to 10.


Figure out ``isnan``
====================

Each and every vendor provides a different ``isnan``. There is a script to help define a portable
c++ macro. It is meant to be used within a configuration file as follows:

```cmake
include("path/to/cookoff/CheckIsNaN.cmake")
if(NOT ISNAN_VARIATION)
  message(STATUS "Could not find working isnan.")
endif(NOT ISNAN_VARIATION)

configure_file(/path/to/config.h.in /path/to/config.h)
```

Two cmake variables are defined:

- ISNAN_HEADERS will the header(s) relevant to the local ``isnan`` definition
- ISNAN_VARIATIOPN is the fully qualified name to the local ``isnan`` definition

They can be used as follows in a the configuration file ``config.h.in``:

``cpp
@ISNAN_HEADERS@

#define not_a_number(X) @ISNAN_VARIATION@
``

One should then use the macro ``not_a_number`` in-place of any ``isnan`` flavour.

In c++11, it is also possible to define a function that takes only arithmetic type, thus obviating
the need for a macro:

```cpp
@ISNAN_HEADERS@
#include <type_traits>

template<class T>
  typename std::enable_if<std::is_arithmetic<T>::value, bool> :: type 
    not_a_number(T const &_in) { return @ISNAN_VARIATION@(_in); }
```

Testing CMake scripts
=====================

The file ``TestCMake.cmake`` contains a function to test cmake scripts. It converts an input cmake
file into a project which is then configured, built, and run using ``ctest``. Unless an optional
"SOURCE" is provided as argument, the test program is an empty ``main`` function returning 0. If the
keyword is provided, then a ``main.cc`` or ``main.c`` file should provided the cmake script.

For examples, look at the tests in this package.

After creating bufr library go to station_list directory

   make
if you use Prtland compilers please specify
   make CNAME=_pgf90

There are 5 files in this directory

1) wmo_a.pl   

   Script which format ftp WMO Volume A station list
   suitable for wmo_make_station program

2) wmo_make_station

   creates binary station list station_amend.dat.
   mv station_amend.dat station_list.dat to be used by 
   synop2bufr program

3)  wmo_make_station.f  source program for 2)


4) wmo.txt input text station list for wmo_make_station program

5) important_stations.dat  read by wmo_make_station program


  Steps to be done:

 a)  ftp station list from WMO http://www.wmo.int/pages/prog/www/ois/volume-a/vola-home.htm 

  The ftp-ed file is like Pub9volA090928.flatfile

 b)  wmo_a.pl Pub9volA090928.flatfile  outputfile


  sort -k2,2 outputfile > outputfile.1

  mv outputfile.1 wmo.txt

  edit wmo.txt ;remove the last line and save file

  If you want to add your own stations edit wmo.txt file.

  you can add station anywhere but it is important to
  sort the file upon block number ( 2 field ).

  sort -k2,2 wmo.txt > a

  move a wmo.txt

  mv a wmo.txt

 c) create binary station list 

    ./wmo_make_station

   It will create station_amend.dat which is new binary station list

   cp station_amend.dat ~PP_BASE/dat/statlion_list.dat

 d) Create station list which contains instrument height fileds as missing values
    This values has to set to proper values for each station from the Country.

    ./make_synop2bufr_station

    The input is wmo.txt and file synop2bufr_station.txt shall be created

    The last 4 fields in the synop2bufr_station.txt are heights above ground in m for:

    
    temperature
    visibility
    precipitation
    wind    


 e) Edit synop2bufr_station.txt and fill in instrument heights for above elements
    for your stations. The example is synop2bufr_station.txt.greece

    save the file and cp synop2bufr_station.txt ~PP_BASE/dat/.


 f) Make sure that binary version and text version of stations contain the same stations.

If you want to run test program before instal library and Bufr tables
just run small script:

./test.sh

that will set requered environment variables
and run: 

./synop2bufr -i data/greek.gts -o data/greek.gts.bufr -c 87

   This directory contains example for the GRIB decoding and how to handle
a Unix file containing GRIB edition 1 products in an indexed fashion.

   GRIB data are in ../data directory.

   make

   will compile both examples

   Before you run you have to set two environment variables:
   ECMWF_LOCAL_TABLE_PATH and LOCAL_DEFINITION_TEMPLATES

   or just run:

   ./test.sh

agrdemo.F :

Executable version of agrdemo.F can be run:
 
./agrdemo -i ../data/latlon.grib

   It will print a listing of the Grib header records together
with a few of the data values.
   Also, you can run ./agrdemo for different sort of grib data:
gaussian.grib , spectral.grib , latlon.grib

find_t.F :

 This program uses PBGPARM to locate temperature fields in a file of GRIB
products and writes them to a target file.

./find_t -i ../data/850ght.grib -o outputfile

Program can be easy modified to select the geopotencial field instead

    This directory contains example for the BUFR decoding and programs
for conversion between BUFR and CREX

Note:
Conversion programs can be compiled only if you have installed both
crex and bufr libraries!!!

Compilation of C program for decoding bufr_decode.c is optional
and if you want to compile it please type:

make bufr_decode

This is available only on Linux platform for Gnu compilers g77 and gcc,
for pgf77 and pgfcc.

    Relevant data in BUFR format are in data directory.

decode_bufr.f :


make
 
will compile examples

If you want to run example programs before instal library and Bufr tables
just run small script:

./test.sh

that will set temporary environment variable: BUFR_TABLES
and run: 

./decode_bufr -i  data/input_bufr 

Answer the prompts as in the Bufr User's Manual example


y
n
n
1
press return 
press return 
press return 
press return 
y
1
1


where:
     input_bufr - file name containing BUFR data

	The result will be description of data and its values.
    bufr_example can be run  for different sort of observation data:
synop.buf, amdar.bufr, atovs.bufr, satob.bufr, synop_ship.bufr, temp.bufr

bufr2crex.f :

    It very useful if there is need for automatic conversion between BUFR and
CREX data formats, when some centres can not handle meteorogical binary data

./bufr2crex -i input_bufr -o out_crex

where:
     out_crex - file name containing CREX data



crex2bufr.f :

    CREX to BUFR conversion program.

./crex2bufr -i input_crex -o out_bufr 

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE BUXDES(K,KSEC1,KTDLEN,KTDLST,KDLEN,KDATA,KELEM,
     2                  KTDEXL,KTDEXP,CNAMES,CUNITS,KERR)
C
C**** *BUXDES*
C
C
C     PURPOSE.
C     --------
C          EXPAND DATA DESCRIPTORS TO SHOW USER TEMPLATE HE
C          DESCRIBED BY ARAY KTDLST AND KDATA.
C
C
C**   INTERFACE.
C     ----------
C
C               *CALL BUXDES(K,KSEC1,KTDLEN,KTDLST,KDLEN,KDATA,KELEM,
C                            KTDEXL,KTDEXP,CNAMES,CUNITS,KERR)
C
C        INPUT :
C
C               *K*       -  AN INTEGER, PRINTING SWITCH 0 - NO PRINT
C                                                        1 - PRINT
C               *KSEC1*   -  INTEGER ARRAY OF AT LEAST 40 WORDS CONTAINING
C                            SECTION 1 INFORMATION
C               *KTDLEN*  -  INTEGER NUMBER OF DATA DESCRIPTORS IN SECTION 3
C               *KTDLST*  -  INTEGER ARRAY OF AT LEAST KTDLEN WORDS
C                            CONTAINING DATA DESCRIPTORS FOR BUFR SECTION 3
C               *KDLEN*   -  INTEGER (DIMENSION OF KDATA ARRAY)
C               *KDATA*   -  INTEGER ARRAY CONTAINING DATA NEEDED FOR DATA
C                            DESCRIPTOR EXPANSION (DELAYED REPLICATION FACTORS)
C                            WHICH APPEAR IN THE VALUES ARRAY
C
C               *KELEM*   -  INTEGER NUMBER OF ELEMENTS IN BUFR TEMPLATE.
C
C        OUTPUT:
C               *KTDEXL*  - AN INTEGER CONTAINING NUMBER OF EXPANDED ELEMENTS
C               *KTDEXP*  - AN INTEGER ARRAY CONTAINING EXPANDED LIST OF DESCRIPTORS
C               *CNAMES*  - CHARACTER*64 ARRAY OF KELEM CONTAINING ELEMENT NAMES
C               *CUNITS*  - CHARACTER*24 ARRAY OF KELEM CONTAINING ELEMENT UNITS
C               *KERR*    -  RETURN ERROR CODE
C
C
C     METHOD.
C     -------
C
C
C     EXTERNALS.
C     ----------
C
C
C     REFERENCE.
C     ----------
C
C          NONE.
C
C     AUTHOR.
C     -------
C
C          M. DRAGOSAVAC    *ECMWF*       15/06/93.
C
C
C     MODIFICATIONS.
C     --------------
C
C          NONE.
C
C
      IMPLICIT LOGICAL(L,O,G), CHARACTER*8(C,H,Y)
C
C
#     include "parameter.F"
#     include "bcomunit.F"
#     include "bcmwork.F"
#     include "bcmdefc.F"
#     include "bcmbef.F"
#     include "bcmwt.F"
C
      DIMENSION  KSEC1(JSEC1),KSEC3(JSEC3)
#ifndef R_4
      REAL*8 VALUES(JCVAL)
      REAL*8 RVIND
      REAL*8 EPS
#else
      REAL  VALUES(JCVAL)
      REAL  RVIND
      REAL  EPS
#endif
      DIMENSION  KTDLST(KTDLEN)
      DIMENSION  KDATA(KDLEN)
      DIMENSION  KTDEXP(KELEM)
C
      CHARACTER*4   CECMWF,CUSER
      CHARACTER*64  CNAMES(KELEM)
      CHARACTER*24  CUNITS(KELEM)

C
C     ------------------------------------------------------------------
C
C*          1.   SET CONSTANTS.
C                --------------
 100  CONTINUE
C
      KERR=0
      IF(CECMWF.NE.'ECMF') THEN
         CALL BUIVAR(KERR)
         KPT   = 0
         CECMWF='ECMF'
      END IF
C
C     -----------------------------------------------------------------
C*          2.   LOAD BUFR TABLES.
C                -----------------
 200  CONTINUE
C
      CALL BUETAB(KSEC1,KERR)
      IF(KERR.GT.0) RETURN
C
C     ------------------------------------------------------------------
C          6.  EXPAND DATA DESCRIPTORS.
C              ------------------------
 600  CONTINUE
C

      CALL BUEDD(KPT,KTDLEN,KTDLST,KDLEN,KDATA,KSEC3,
     1           KVALS,VALUES,KELEM,CNAMES,CUNITS,KERR)
C
      IF(KERR.GT.0) RETURN
C
      KTDEXL =M
      DO 301 I=1,KTDEXL
      KTDEXP(I)=NWTR(I)
 301  CONTINUE
C
      IF(K.EQ.1) THEN
C
         WRITE(KNTN,'(1H ,//)')
         WRITE(KNTN,'(1H ,A)')    '       DATA DESCRIPTORS (UNEXPANDED)'
C
         WRITE(KNTN,'(1H )')
         DO 110 I=1,KTDLEN
          WRITE(KNTN,'(1H ,I4,2X,I6.6)') I,KTDLST(I)
 110     CONTINUE
C
         WRITE(KNTN,'(1H ,/)')
         WRITE(KNTN,'(1H ,A)')    '       DATA DESCRIPTORS (EXPANDED)'
         WRITE(KNTN,'(1H )')
         WRITE(KNTN,'(1H ,A,A)')'               ELEMENT NAME',
     1   '                                                      UNIT'
         WRITE(KNTN,'(1H )')
C
         DO 120 I=1,KTDEXL
          WRITE(KNTN,'(1H ,I5,2X,I6.6,2X,A,2X,A)') I,KTDEXP(I),
     1                      CNAMES(I)(1:64),CUNITS(I)(1:24)
 120     CONTINUE
      END IF
C
C
C     -----------------------------------------------------------------
      RETURN
C
      END

       PROGRAM Msort
!
!
!**** *Msort*
!
!
!     Purpose.
!     --------
!
!           Sort input list in ascending order. Search the list
!           for requested value.
!
!**   Interface.
!     ----------
!
!
!     Method.
!     -------
!
!           A quick_sort method is used for sorting, and
!           Binary search is used for matching.
!
!
!     Externals.
!     ----------
!
!          NONE.
!
!     Reference.
!     ----------
!
!          Fortran 90 for Scientist & Engineers : Brian D. Hahn 1994
!
!     Author.
!     -------
!
!          M. Dragosavac    *ECMWF*       15/01/95.
!
!
!     Modifications.
!     --------------
!
!          NONE.
!------------------------------------------------------------------------------------------

       implicit none


       integer, parameter :: jsup =   9
       integer, parameter :: jsec0=   3
       integer, parameter :: jsec1=  40
       integer, parameter :: jsec2=  4096
       integer, parameter :: jsec3=   4
       integer, parameter :: jsec4=   2 
       integer, parameter :: jelem=160000
       integer, parameter :: jbufl=512000
#ifdef JBPW_64
       integer, parameter :: jbpw =  64
#else
       integer, parameter :: jbpw =  32
#endif
       integer, parameter :: jwork=4096000
       integer, parameter :: jkey=46
       integer, parameter :: jbyte=512000
       integer, parameter :: kelem=400
       integer, parameter :: kvals=400
       integer, parameter :: ill=48/(jbpw/8)+1
       
       integer, dimension(jbufl) :: kbuff, kbufr
       integer, dimension(jsup)  :: ksup
       integer, dimension(jsec0) :: ksec0
       integer, dimension(jsec1) :: ksec1
       integer, dimension(jsec2) :: ksec2
       integer, dimension(jsec3) :: ksec3
       integer, dimension(jsec4) :: ksec4
       integer, dimension(jkey)  :: key
       real*8,    dimension(kvals) :: values, value
       integer, dimension(kelem) :: ktdlst,ktdlst1
       integer, dimension(kelem) :: kdata


       integer, parameter :: nnn=100000         ! size of list
       integer, dimension(nnn,ill) :: list    ! list to be sorted
       integer i,j,n,is,iln,iz                 ! counter
       integer ipos, kval,ij,i1,id,ic

       integer narg,nvind,iy,ilen,kel,jx 
       integer ix,ilength , ktdlen, kdlen
       real    r                                           ! random number
       real*8     eps, rvind                             
       integer iunit,iunit1,iret,ierr,iword
       integer nbytpw,kbufl,ioff,istart,iargc

       character(256) cfin, cfout
       character(256), dimension(10)   :: carg
       character(64), dimension(kelem) :: cnames
       character(24), dimension(kelem) :: cunits
       character(80), dimension(kvals) :: cvals

       external bus012,pbbufr,pbwrite
!       external iargc,getarg



!     ----------------------------------------------------------
!     Get input and output file name.

      cfin=' '
      cfout=' '
      narg=iargc()

      if(narg < 4) then
         print*,'Usage -- bufr_merge -i inputfile -o outputfile'
         stop
      end if

      do  j=1,narg
      call getarg(j,carg(j))
      end do

      do j=1,narg,2
         if(carg(j) == '-i') then
            cfin=carg(j+1)
         elseif(carg(j) == '-o') then
            cfout=carg(j+1)
         else
             print*,'Usage -- bufr_merge -i inputfile -o outputfile'
             stop
         end if
      end do

!     Initialize variables and constants
!     ----------------------------------

      nbytpw=jbpw/8           ! number of bytes per word
      rvind=1.7D38            ! missing value indicator
      nvind=2147483647        ! missing value indicator
      n=0
      eps=10.E-10
      ktdlst1( 1)=301042      ! list of descriptors for merged satellite template
      ktdlst1( 2)=303031
      ktdlst1( 3)=303032
      ktdlst1( 4)=101015
      ktdlst1( 5)=303023
      ktdlst1( 6)=101003
      ktdlst1( 7)=303024
      ktdlst1( 8)=222000
      ktdlst1( 9)=101108
      ktdlst1(10)=031031
      ktdlst1(11)=001031
      ktdlst1(12)=001201
      ktdlst1(13)=101108
      ktdlst1(14)=033007
      ktdlen=14

      do i=1,400
         value(i)=rvind
      end do



!     Open input and output files
!     ---------------------------

      ic=index(cfin,' ')
      id=index(cfout,' ')
      iret=0
      call pbopen(iunit,cfin(1:ic),'r',iret)

      if(iret == -1) stop 'Open failed'
      if(iret == -2) stop 'Invalid input file name'
      if(iret == -3) stop 'Invalid open mode specified'

      call pbopen(iunit1,cfout(1:id),'w',iret)

      if(iret == -1) stop 'Open failed'
      if(iret == -2) stop 'Invalid output file name'
      if(iret == -3) stop 'Invalid open mode specified'

      iret=0




!     Read in bufr file and create list of RDB keys
!     ---------------------------------------------



      do while(iret >= 0)

         call pbbufr(iunit,kbuff,jbyte,kbufl,iret)
         if(iret == -1) exit  

         ierr=0
         ksec1(7)=0
         iword=kbufl/nbytpw+1
         call bus012(iword,kbuff,ksup,ksec0,ksec1,ksec2,ierr)
         if(ierr /= 0) then
             print*,'bus012 : ierr=',ierr
             call my_exit(2)
         end if
 
         is=ksec1(7)

         if(is >= 61 .and. is <= 63 .or. is >= 71 .and. is <= 73) then
 
            n=n+1
            if( n > nnn ) then
               print*,'Too many records to be merged.'
               print*,'Maximum is ',nnn
               call my_exit(2)
            end if

!           Get absolute record offset

            call pbseek(iunit,0,1,iln)
            if(iln < 0) then
                print*,'pbseek error :',ierr
                call my_exit(2)
            end if

            ksec2(1)=iln-kbufl      ! offset for record

            do iz=1,ill
            list(n,iz)=ksec2(iz)
            end do

         else

!           Write bufr message in output file
!           ---------------------------------

            iret=0
            call pbwrite(iunit1,kbuff,kbufl,iret)
            if(iret < 0) then
               print*,'Error writing into ',cfout
               call my_exit(2)
            end if


         end if

      end do


!     Make a quick sort of list array containing RDB keys
!     ---------------------------------------------------

      print*,n,' records to be sorted'


      call quick_sort(list,ill,1,n)

      print*,n,' records sorted'




!      Merge satellite data
!      --------------------



      i1=0
      i=1

      do while( i < n)
!
!        set data present indicator to present for all elements.
!
         i1=0

         do iy=1,327
           value(iy)=rvind
           if(iy >= 110 .and. iy <= 217) value(iy)=0.0
         end do
!

         do while (i1 == 0 )

!
           ioff=list(i,1)
!
           istart=0
           call pbseek(iunit,ioff,istart,iret)
           if(iret < 0) then
              print*,'pbseek: error ',iret
           end if
!
           iret=0
           call pbbufr(iunit,kbuff,jbyte,kbufl,iret)
           if(iret == -1) then
             print*,'pbbufr : error ',iret
             stop 'EOF'
           end if
           if(iret == -2) stop 'File handling problem'
           if(iret == -3) stop 'Array too small for product'

           iword=kbufl/nbytpw+1

           kel=kelem
           if(ksup(6) > 1)  kel=jwork/ksup(6)

           ierr=0
           call bufrex(iword,kbuff,ksup,ksec0 ,ksec1,ksec2 ,ksec3 , &
                       ksec4,kel,cnames,cunits,kvals,values,cvals,ierr)

           if(ierr /= 0)  then
              print*,'bufrex : error=',ierr
              call my_exit(2)
           end if

           if(ksec1(7) < 61 .or. ksec1(7) > 73) then
              print*,'subtype ',ksec1(7),' found for record ',n
              call my_exit(2)
           end if

!            5. Merge Satem or 250 km tovs.
!               ---------------------------

!          copy low level data

           if(ksec1(7) == 61 .or. ksec1(7) == 71) then
              jx=0
              do ix=1,63
                jx=jx+1
                value(jx)=values(ix)
              end do

!             copy data present indicator

              jx=109
              do ix=65,127
                jx=jx+1
                value(jx)=values(ix)
              end do

!             % confidence

              jx=219
              do ix=130,192
                jx=jx+1
                value(jx)=values(ix)
              end do

              value(109)=values(64)
              value(218)=values(128)
              value(219)=values(129)

           elseif(ksec1(7) == 62 .or. ksec1(7) == 72) then

!              copy precipitable water

              jx=0
              do ix=1,18
                jx=jx+1
                if(values(ix) /= rvind) value(jx)=values(ix)
              end do 

              jx=93
              do ix=19,33
                jx=jx+1
                value(jx)=values(ix)
              end do

!             copy data present indicator

              jx=109
              do ix=35,52
                jx=jx+1
                value(jx)=values(ix)
              end do

              jx=202
              do ix=53,67
                jx=jx+1
                value(jx)=values(ix)
              end do

!             copy % confidence

              jx=219
              do ix=70,87
                jx=jx+1
                value(jx)=values(ix)
              end do

              jx=312
              do ix=88,102
                jx=jx+1
                value(jx)=values(ix)
              end do

              value(109)=values(34)
              value(218)=values(68)
              value(219)=values(69)

           elseif(ksec1(7) == 63 .or. ksec1(7) == 73) then

!             copy high level data

              jx=0
              do ix=1,18
                jx=jx+1
                if(values(ix) /= rvind) value(jx)=values(ix)
              end do

              jx=63
              do ix=19,48
                jx=jx+1
                value(jx)=values(ix)
              end do

!             copy data present indicator

              jx=109
              do ix=50,67
                jx=jx+1
                value(jx)=values(ix)
              end do

              jx=172
              do ix=68,97
                jx=jx+1
                value(jx)=values(ix)
              end do

!             copy % confidence

              jx=219
              do ix=100,117
                jx=jx+1
                value(jx)=values(ix)
              end do

              jx=282
              do ix=118,147
                jx=jx+1
                value(jx)=values(ix)
              end do

              value(109)=values(49)
              value(218)=values(98)
              value(219)=values(99)
           else
              print*,'File contain other than satem/250 tovs data.'
              print*,'Subtype ',ksec1(7),' found.'
           end if


           i1=keycomp(list(i,1:ill),list(i+1,1:ill))
           
           if( i1 == 0) i=i+1

         end do

!            6. Pack merged bufr message
!               ------------------------

         ierr=0
         call buukey(ksec1,ksec2,key,ksup,ierr)
         if(ierr /= 0) then
            print*,'buukey : error ',ierr
            call my_exit(2)
         end if

         if(ksec1(7) >= 61 .and. ksec1(7) <= 63) key(3)=65
         if(ksec1(7) >= 71 .and. ksec1(7) <= 73) key(3)=75

         call bupkey(key,ksec1,ksec2,ierr)
         if(ierr /= 0) then
            print*,'bupkey : error ',ierr
            call my_exit(2)
         end if

         ksec1(7)=key(3)
         call bufren( ksec0,ksec1,ksec2,ksec3,ksec4,  &  
                      ktdlen,ktdlst1,kdlen,kdata,kel, & 
                      kvals,value,cvals,kbufl,kbufr,ierr)

         if(ierr > 0) then
            print*,'bufren : error ',ierr
            call my_exit(2)
         end if

!            7. Write merged message into target file
!               -------------------------------------

         ilength=kbufl*nbytpw

         ierr=0
         call pbwrite(iunit1,kbufr,ilength,ierr)
         if(ierr < 0) then
            print*,'Error writing into output file.'
            call my_exit(2)
         END IF

         i=i+1
         i1=0

      end do


       contains

       RECURSIVE SUBROUTINE QUICK_SORT(X,Y,L,R)
!
!
!**** *QUICK_SORT*
!
!
!     Purpose.
!     --------
!
!           Sort input list in ascending order.
!
!**   Interface.
!     ----------
!
!
!     Method.
!     -------
!
!           A quick_sort method is used for sorting.
!
!
!     Externals.
!     ----------
!
!          NONE.
!
!     Reference.
!     ----------
!
!          Fortran 90 for Scientist & Engineers : Brian D. Hahn 1994
!
!     Author.
!     -------
!
!          M. Dragosavac    *ECMWF*       15/01/95.
!
!
!     Modifications.
!     --------------
!
!          NONE.
!

       implicit none



      integer, dimension(:,:), intent(inout) :: x    ! list
      integer, intent(in)               :: l,r  ! left,right bounds
      integer, intent(in)               :: Y
      integer l1, r1
      integer icomp

      if( l<r) then
        l1=l
        r1=r

        icomp=keycomp(x(l1,1:Y),x(l,1:Y))
        do
          do while( l1 < r .and. (icomp ==2 .or. icomp == 0))  ! shift l1 right
             l1=l1+1
             icomp=keycomp(x(l1,1:Y),x(l,1:Y))
          end do

          icomp=keycomp(x(r1,1:Y),x(l,1:Y))
          do while ( l< r1 .and. (icomp ==1 .or. icomp == 0))  !  shift r1 left
             r1=r1-1
             icomp= keycomp(x(r1,1:Y),x(l,1:Y))
          end do

          if( l1<r1 ) call swop( x(l1,1:Y),x(r1,1:Y),Y)     ! swop
          if( l1>=r1) exit                        ! crossower_partition
          
        end do

        call swop( x(l,1:Y),x(r1,1:Y),Y)     ! partition with x(l) at r1
        call quick_sort( x,Y,l,r1-1)         ! now attack left subproblem
        call quick_sort( x,Y,r1+1,r)         ! don't forget right subproblem

      end if

      END SUBROUTINE QUICK_SORT

      SUBROUTINE SWOP(A,B,C)
!
!
!**** *SWOP*
!
!
!     Purpose.
!     --------
!
!           Swops content of two variables.
!        
!
!**   Interface.
!     ----------
!
!
!     Method.
!     -------
!
!           None.
!
!     Externals.
!     ----------
!
!          NONE.
!
!     Reference.
!     ----------
!
!          Fortran 90 for Scientist & Engineers : Brian D. Hahn 1994
!
!     Author.
!     -------
!
!          M. Dragosavac    *ECMWF*       15/01/95.
!
!
!     Modifications.
!     --------------
!
!          NONE.
!

      implicit none


#ifdef JBPW_64
      integer, parameter :: jbpw=64
#else
      integer, parameter :: jbpw=32
#endif
      integer, parameter :: ill=48/(jbpw/8)+1

      integer, dimension(:), intent(inout)   :: a,b
      integer, dimension(ill)    :: temp
      integer C

      do i=1,C


      temp(i) = a(i)
      a(i)=b(i)
      b(i)=temp(i)

      end do

      END SUBROUTINE SWOP

      SUBROUTINE SEARCH(KARRAY,K,KVAL,KINDEX)
!
!
!**** *SEARCH*
!
!
!     Purpose.
!     --------
!
!           Search an input  list for the requested value.
!
!**   Interface.
!     ----------
!
!
!     Method.
!     -------
!
!           Binary search is used for matching.
!
!
!     Externals.
!     ----------
!
!          NONE.
!
!     Reference.
!     ----------
!
!          Fortran 90 for Scientist & Engineers : Brian D. Hahn 1994
!
!     Author.
!     -------
!
!          M. Dragosavac    *ECMWF*       15/01/95.
!
!
!     Modifications.
!     --------------
!
!          NONE.
!

       implicit none



      integer, dimension (*)    :: karray
      integer k
      integer kval 
      integer kindex
      integer ihigh
      integer ilow
      integer i
      integer numbis
      integer count
      logical found
      integer mid

!         1.   Binary search. 

      count=0
      found=.false.
      kindex=0
      numbis= int(log(real(k))/log(2.0)) +1    

      ihigh = K+1
      ilow  = 1

      do while(.not.found .and.count /= numbis) 

            mid = (ihigh + ilow)/2
            if(karray(mid).eq.kval) then
               found=.true.
            elseif(kval .lt.karray(mid)) then
               ihigh= mid
            elseif(kval.gt.karray(mid)) then
               ilow= mid
            end if
            count=count+1
      end do

      if(found) kindex=mid

      END SUBROUTINE SEARCH


      INTEGER FUNCTION KEYCOMP(X,Y)

#ifdef JBPW_64
       integer, parameter    :: jbpw=64
#else
       integer, parameter    :: jbpw=32
#endif
       integer, parameter    :: ilast=32/(jbpw/8)
       integer, parameter    :: ifirst=(jbpw/8-2)*8-1
       integer, dimension(:) :: x 
       integer, dimension(:) :: y 
       integer  j,jj

       logical o1,o2


!      keycomp=0  two arrays are equal
!      keycomp=1  array X > array Y
!      keycomp=2  array Y > array X

       keycomp=0

       do j= ifirst,0,-1

       o1 = btest(x(2),j)
       o2 = btest(y(2),j) 

       if(o1.and..not.o2) then
          keycomp=1
          return
       elseif(.not. o1 .and. o2) then
          keycomp=2
          return
       end if
       end do

       if(keycomp.eq.0) then

          do jj=3,ilast

             do j=jbpw-1,0,-1  

             o1 = btest(x(jj),j)
             o2 = btest(y(jj),j)
   
             if(o1 .and. .not. o2) then

                keycomp=1
                return
             elseif(.not. o1 .and. o2) then
                keycomp=2
                return
             end if

             end do
          end do

       end if

       return
       end function
      END PROGRAM Msort

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

C
      COMMON /BCOMRQ/ NWORDP(JWORK),NBITP(JWORK)
C
C           NWORDP     - ARRAY CONTAINING WORD POINTERS TO
C                        REQUESTED ELEMENTS
C           NBITP      - ARRAY CONTAINING BIT POINTERS TO
C                        REQUESTED ELEMENTS
C

C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE FMMH(KLA,KLO,KELEM,VALUES,KSEC3,RMINLAT,RMINLON,
     1                RMAXLAT,RMAXLON)
C
C**** *FMM*
C
C
C     PURPOSE.
C     --------
C         FIND MINIMUM AND MAXIMUM LATITUDE AND LOGITUDE.
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *FMMH(KLA,KLO,VALUES,KSEC3,RMINLAT,RMINLON,
C                      RMAXLAT,RMAXLON)*
C
C     METHOD.
C     -------
C
C          NONE.
C
C
C     EXTERNALS.
C     ----------
C
C         NONE.
C
C     REFERENCE.
C     ----------
C
C          NONE.
C
C     AUTHOR.
C     -------
C
C          M. DRAGOSAVAC    *ECMWF*       15/04/1991.
C
C
C     MODIFICATIONS.
C     --------------
C
C          NONE.
C
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
C
C
      DIMENSION KSEC3(*)
#ifndef R_4
      REAL*8 VALUES(*)
      REAL*8 RNLON
      REAL*8 RNLAT
      REAL*8 RMINLAT
      REAL*8 RMINLON
      REAL*8 RMAXLAT
      REAL*8 RMAXLON
      REAL*8 RVIND
      REAL*8 EPS
#else
      REAL VALUES(*)
      REAL RNLON
      REAL RNLAT
      REAL RMINLAT
      REAL RMINLON
      REAL RMAXLAT
      REAL RMAXLON
      REAL RVIND
      REAL EPS

#endif
C     -----------------------------------------------------------------
C*          1.   FIND MIN/MAX LATITUDES/LONGITUDES.
C                ----------------------------------
 100  CONTINUE
C
      RVIND=1.7D38
      EPS=10.D-7
C
      ISUB=KSEC3(3)
C
C
      DO 101 I=1,ISUB
      KLAI=KELEM*(I-1)+KLA
      IF(ABS(VALUES( KLAI)-RVIND)/RVIND.GT.EPS)
     1   THEN
            RMINLAT=VALUES( KLAI)
            GO TO 105
         END IF
 101  CONTINUE
C
 105  CONTINUE
C
      DO 110 I=1,ISUB
C
      KLAI=KELEM*(I-1)+KLA
      IF(ABS(VALUES( KLAI)-RVIND)/RVIND.LT.EPS) GO TO 110
      RNLAT=VALUES( KLAI)
      IF(RNLAT.LT.RMINLAT) RMINLAT=RNLAT
C
 110  CONTINUE
C
      DO 111 I=1,ISUB
      KLOI=KELEM*(I-1)+KLO
      IF(ABS(VALUES( KLOI)-RVIND)/RVIND.GT.EPS) THEN
         RMINLON=VALUES( KLOI)+180.
         GO TO 115
      END IF
 111  CONTINUE
C
 115  CONTINUE
C
      DO 120 I=1,ISUB
C
      KLOI=KELEM*(I-1)+KLO
      IF(ABS(VALUES( KLOI)-RVIND)/RVIND.LT.EPS) GO TO 120
      RNLON=VALUES( KLOI)+180.
      IF(RNLON.LT.RMINLON) RMINLON=RNLON
C
 120  CONTINUE
C
      DO 121 I=1,ISUB
      KLAI=KELEM*(I-1)+KLA
      IF(ABS(VALUES(KLAI)-RVIND)/RVIND.GT.EPS) THEN
         RMAXLAT=VALUES( KLAI)
         GO TO 125
      END IF
 121  CONTINUE
C
 125  CONTINUE
C
      DO 130 I=1,ISUB
C
      KLAI=KELEM*(I-1)+KLA
      IF(ABS(VALUES( KLAI)-RVIND)/RVIND.LT.EPS) GO TO 130
      RNLAT=VALUES( KLAI)
      IF(RNLAT.GT.RMAXLAT) RMAXLAT=RNLAT
C
 130  CONTINUE
C
C
      DO 131 I=1,ISUB
      KLOI=KELEM*(I-1)+KLO
      IF(ABS(VALUES( KLOI)-RVIND)/RVIND.GT.EPS) THEN
         RMAXLON=VALUES( KLOI)+180.
         GO TO 135
      END IF
 131  CONTINUE
C
 135  CONTINUE
C
      DO 140 I=1,ISUB
C
      KLOI=KELEM*(I-1)+KLO
      IF(ABS(VALUES( KLOI)-RVIND)/RVIND.LT.EPS) GO TO 140
      RNLON=VALUES( KLOI)+180.
      IF(RNLON.GT.RMAXLON) RMAXLON=RNLON
C
 140  CONTINUE
C
      RMINLON=RMINLON-180.

      RMAXLON=RMAXLON-180.
C
C
C*          2. CHECK IF ALL OBSERVATION FITS IN THE BOX.
C              -----------------------------------------
 200  CONTINUE
C
      DO 201 I=1,ISUB
C
      KLAI=KELEM*(I-1)+KLA
      KLOI=KELEM*(I-1)+KLO
      IF((VALUES( KLAI).LT.RMINLAT.AND.VALUES( KLAI).GT.RMAXLAT).OR.
     1   (VALUES( KLOI).LT.RMINLON.AND.VALUES( KLOI).GT.RMAXLON) )
     2   GO TO 210
 201  CONTINUE
C
C     ALL DATA IN THE BOX
C
      RETURN
C
C*          2.1 FIND MAX NEGATIVE LONGITUDE AND MIN POSITIVE LONGITUDE.
C               -------------------------------------------------------
 210  CONTINUE
C
      DO 211 I=1,ISUB
      KLOI=KELEM*(I-1)+KLO
      IF(ABS(VALUES( KLOI)-RVIND)/RVIND.GT.EPS) THEN
         IF(VALUES( KLOI).LT.0) THEN
            RMAXLON=VALUES( KLOI)
            GO TO 215
         END IF
      END IF
 211  CONTINUE
C
C     NEGATIVE LONGITUDES NOT FOUND
C
      PRINT*,'FMM:NEGATIVE LONGITUDES NOT FOUND'
      RETURN
C
 215  CONTINUE
C
      DO 220 I=1,ISUB
C
      KLOI=KELEM*(I-1)+KLO
      IF(ABS(VALUES( KLOI)-RVIND)/RVIND.LT.EPS) GO TO 220
      IF(VALUES( KLOI).LT.0) THEN
         RNLON=VALUES( KLOI)

         IF(RNLON.GT.RMAXLON) RMAXLON=RNLON
      END IF
C
 220  CONTINUE
C
C*          2.3 FIND MIN POSITIVE LONGITUDE.
C
 230  CONTINUE
      DO 231 I=1,ISUB
      KLOI=KELEM*(I-1)+KLO
      IF(ABS(VALUES( KLOI)-RVIND)/RVIND.GT.EPS) THEN
         IF(VALUES( KLOI).GE.0) THEN
            RMINLON=VALUES( KLOI)
            GO TO 235
         END IF
      END IF
 231  CONTINUE
C
C     POSITIVE LONGITUDES NOT FOUND
C
      PRINT*,'FMM:POSITIVE LONGITUDES NOT FOUND'
      RETURN
C
 235  CONTINUE
C
      DO 232 I=1,ISUB
C
      KLOI=KELEM*(I-1)+KLO
      IF(ABS(VALUES( KLOI)-RVIND)/RVIND.LT.EPS) GO TO 232
      IF(VALUES( KLOI).GE.0) THEN
         RNLON=VALUES( KLOI)
         IF(RNLON.LT.RMINLON) RMINLON=RNLON
      END IF
C
 232  CONTINUE

      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      COMMON /BCMROOT/ CROOT,OPRINT
C
C            CROOT    -  PATH FOR BUFR TABLES
C            OPRINT   -  LOGICAL SWITCH TO PRINT TABLE NAMES
C

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE BBUPRS3(KNT,KSEC3,KTDLEN,KTDLST,KTDEXL,
     1                  KTDEXP,KELEM,CNAMES)
C
C**** *BUPRS3*
C
C
C     PURPOSE.
C     --------
C           PRINT SECTION 3 OF BUFR MESSAGE.
C
C
C**   INTERFACE.
C     ----------
C
C           *CALL* *BUPRS3(KNT,KSEC3,KTDLEN,KTDLST,KTDEXL,KTDEXP,
C                          KELEM,CNAMES)*
C
C        INPUT :
C               *KNT*     -  UNIT NUMBER IO
C               *KSEC3*   -  ARRAY CONTAINING SECTION 3 INFORMATION
C                            KSEC3( 1)-- LENGTH OF SECTION 3 (BYTES)
C                            KSEC3( 2)-- RESERVED
C                            KSEC3( 3)-- NUMBER OF SUBSETS
C                            KSEC3( 4)-- FLAG (DATA TYPE,DATA COMPRESSION)
C               *KTDLEN*  -  NUMBER OF DATA DESCRIPTORS IN SECTION 3
C               *KTDLST*  -  ARRAY CONTAINING DATA DESCRIPTORS IN SECTION 3
C               *KTDEXL*  -  NUMBER OF ENTRIES IN LIST OF EXPANDED DATA
C                            DESCRIPTORS
C               *KTDEXP*  -  ARRAY CONTAINIG EXPANDED DATA DESCRIPTORS
C               *KELEM*   -  DIMENSION OF CNAMES, CUNITS ARRAY
C               *CNAMES*  -  CHARACTER ARRAY CONTAINING ELEMENT NAMES
C
C
C     METHOD.
C     -------
C
C            NONE
C
C     EXTERNALS.
C     ----------
C
C            NONE.
C
C     REFERENCE.
C     ----------
C
C          NONE.
C
C     AUTHOR.
C     -------
C
C          M. DRAGOSAVAC    *ECMWF*       04/02/91.
C
C     MODIFICATIONS.
C     --------------
C
C          NONE.
C
      IMPLICIT LOGICAL(L,O,G), CHARACTER*8(C,H,Y)
C
C
#     include "parameter.F"
C
      DIMENSION KSEC3(JSEC3)
      DIMENSION KTDLST(KTDLEN)
      DIMENSION KTDEXP(KTDEXL)
C
      CHARACTER*64 CNAMES(KELEM)
C
C     ------------------------------------------------------------------
C
C*          1.   PRINT SECTION 3.
C                ----------------
 100  CONTINUE
C
      WRITE(KNT,'(1H1)')
C
      WRITE(KNT,'(1H ,A)')    '         BUFR SECTION 3    '
      WRITE(KNT,'(1H )')
      WRITE(KNT,'(1H ,A,I5)') 'LENGTH OF SECTION 3 (BYTES)         ',
     1                       KSEC3(1)
      WRITE(KNT,'(1H ,A,I5)') 'RESERVED                            ',
     1                       KSEC3(2)
      WRITE(KNT,'(1H ,A,I5)') 'NUMBER OF DATA SUBSETS              ',
     1                       KSEC3(3)
      WRITE(KNT,'(1H ,A,I5)') 'FLAG (DATA TYPE/DATA COMPRESSION)   ',
     1                       KSEC3(4)
C
      WRITE(KNT,'(1H ,//)')
      WRITE(KNT,'(1H ,A)')    '       DATA DESCRIPTORS (UNEXPANDED)'
C
      WRITE(KNT,'(1H )')
      DO 110 I=1,KTDLEN
       WRITE(KNT,'(1H ,I4,2X,I6.6)') I,KTDLST(I)
 110  CONTINUE
C
      WRITE(KNT,'(1H ,/)')
      WRITE(KNT,'(1H ,A)')    '       DATA DESCRIPTORS (EXPANDED)'
      WRITE(KNT,'(1H )')
      DO 120 I=1,KTDEXL
       WRITE(KNT,'(1H ,I5,2X,I6.6,2X,A)') I,KTDEXP(I),CNAMES(I)
 120  CONTINUE

      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities
C granted to it by virtue of its status as an intergovernmental organisation
C nor does it submit to any jurisdiction.
C

      INTEGER FUNCTION IGTOG (PIFELD, KIWE, KINS, KOWE, KONS, KWEIND,
     1   KNSIND, PWFACT, POFELD, KPR, KERR)
C
C---->
C**** *IGTOG*
C
C     Purpose
C     -------
C
C     Perform basic interpolation between regular input and output
C     fields.
C
C     Interface
C     ---------
C
C     IERR = IGTOG (PIFELD, KIWE, KINS, KOWE, KONS, KWEIND, KNSIND,
C    1   PWFACT, POFELD, KPR, KERR)
C
C     Input parameters
C     ----------------
C
C     PIFELD     - The input field provided by the calling routine.
C
C     KIWE       - The number of points in the West-East direction in
C                  the input field.
C
C     KINS       - The number of points in the North-South direction
C                  in the input field.
C
C     KOWE       - The number of points in the West-East direction in
C                  the output field.
C
C     KONS       - The number of points in the North-South direction
C                  in the output field.
C
C     KWEIND     - This array contains the array offsets of the West
C                  and East points in the input array required for
C                  interpolation.
C
C     KNSIND     - This array contains the array offsets of the North
C                  and South points in the input array required for
C                  interpolation.
C
C     PWFACT     - The array of interpolating weights to the four
C                  neighbouring points for every output point.
C
C     KPR        - The debug print switch.
C                  0  , No debugging output.
C                  1  , Produce debugging output.
C
C     KERR       - The error control flag.
C                  -ve, No error message. Return error code.
C                  0  , Hard failure with error message.
C                  +ve, Print error message. Return error code.
C
C     Output parameters
C     -----------------
C
C     POFELD     - The output field returned to the calling routine.
C
C     Return value
C     ------------
C
C     The error indicator (INTEGER).
C
C     Common block usage
C     ------------------
C
C     None
C
C     Externals
C     ---------
C
C     INTLOG - Logs messages
C     FORCED_NEAREST_NEIGHBOUR - check forced interpolation method
C
C
C     Method
C     ------
C
C     This routine performs basic linear interpolation using the four
C     neighbouring points in the input array to generate the output
C     array.
C
C     Reference
C     ---------
C
C     None
C
C     Comments
C     --------
C
C     None
C
C     Author
C     ------
C
C     K. Fielding      *ECMWF*      Oct 1993
C
C     Modifications
C     -------------
C
C     Allow for missing data values
C     J.D.Chambers      ECMWF       August 2000
C
C     Force nearest neighbour processing with env variable or
C     INTOUT parameter
C     S.Curic           ECMWF       September 2005
C
C----<
C     -----------------------------------------------------------------|
C*    Section 0. Definition of variables.
C     -----------------------------------------------------------------|
C
      IMPLICIT NONE
C
#include "parim.h"
#include "nifld.common"
#include "nofld.common"
C
C     Function arguments
C
      INTEGER KIWE, KINS, KOWE, KONS, KPR, KERR
      INTEGER KWEIND (2, KOWE), KNSIND (2, KONS)
      REAL PIFELD (KIWE, KINS), POFELD (KOWE, KONS)
      REAL PWFACT (4, KOWE, KONS)
C
C     Local variables
C
      INTEGER ILATN, ILATS, JOLAT, JOLON, COUNT
      REAL NEAREST
      LOGICAL LVEGGY
C
C     Externals
C
      LOGICAL FORCED_NEAREST_NEIGHBOUR
C
C     Statement function
C
      REAL A, B
      LOGICAL NOTEQ
      NOTEQ(A,B) = (ABS((A)-(B)).GT.(ABS(A)*1E-3))
C
C     -----------------------------------------------------------------|
C*    Section 1. Initialisation
C     -----------------------------------------------------------------|
C
  100 CONTINUE
C
      IF( KPR.GE.1 ) CALL INTLOG(JP_DEBUG,'IGTOG: Section 1.',JPQUIET)
C
      IGTOG = 0
C
      IF( KPR.GE.1 ) THEN
        CALL INTLOG(JP_DEBUG,'IGTOG: Input parameters.',JPQUIET)
        CALL INTLOG(JP_DEBUG,'IGTOG: No.input fld longitudes = ',KIWE)
        CALL INTLOG(JP_DEBUG,'IGTOG: No.input fld latitudes  = ',KINS)
        CALL INTLOG(JP_DEBUG,'IGTOG: No.output fld longitudes = ',KOWE)
        CALL INTLOG(JP_DEBUG,'IGTOG: No.output fld latitudes  = ',KONS)
      ENDIF
C
C     Use nearest neighbour if required
      LVEGGY = FORCED_NEAREST_NEIGHBOUR(LMETHOD,NITABLE,NIPARAM)
      IF( LVEGGY ) CALL INTLOG(JP_DEBUG,
     X  'IGTOG: nearest neighbour processing',JPQUIET)
C
C     -----------------------------------------------------------------|
C*    Section 2. Basic interpolation
C     -----------------------------------------------------------------|
C
  200 CONTINUE
C
      IF( KPR.GE.1 ) CALL INTLOG(JP_DEBUG,'IGTOG: Section 2.',JPQUIET)
C
      DO JOLAT = 1, KONS
C
        ILATN = KNSIND(JP_I_N,JOLAT)
        ILATS = KNSIND(JP_I_S,JOLAT)
C
        DO JOLON = 1, KOWE
C
C         Count non-missing data values
C
          IF( LIMISSV ) THEN
            COUNT = 0
            IF( NOTEQ(PIFELD(KWEIND(JP_I_W,JOLON),ILATN), RMISSGV) )
     X        COUNT = COUNT + 1
            IF( NOTEQ(PIFELD(KWEIND(JP_I_W,JOLON),ILATS), RMISSGV) )
     X        COUNT = COUNT + 1
            IF( NOTEQ(PIFELD(KWEIND(JP_I_E,JOLON),ILATN), RMISSGV) )
     X        COUNT = COUNT + 1
            IF( NOTEQ(PIFELD(KWEIND(JP_I_E,JOLON),ILATS), RMISSGV) )
     X        COUNT = COUNT + 1
          ELSE
            COUNT = 4
          ENDIF
C
C         Interpolate using four neighbours if none are missing
C
          IF( (COUNT.EQ.4).AND.(.NOT.LVEGGY) ) THEN
            POFELD(JOLON,JOLAT) =
     X        PIFELD(KWEIND(JP_I_W,JOLON),ILATN) *
     X          PWFACT(JP_I_NW,JOLON,JOLAT) +
     X        PIFELD(KWEIND(JP_I_W,JOLON),ILATS) *
     X          PWFACT(JP_I_SW,JOLON,JOLAT) +
     X        PIFELD(KWEIND(JP_I_E,JOLON),ILATN) *
     X          PWFACT(JP_I_NE,JOLON,JOLAT) +
     X        PIFELD(KWEIND(JP_I_E,JOLON),ILATS) *
     X          PWFACT(JP_I_SE,JOLON,JOLAT)
C
C         Set missing if all neighbours are missing
C
          ELSE IF( COUNT.EQ.0 ) THEN
            POFELD(JOLON,JOLAT) = RMISSGV
C
C         Otherwise, use the nearest neighbour
C
          ELSE
            NEAREST = PWFACT(JP_I_NW,JOLON,JOLAT)
            POFELD(JOLON,JOLAT) =
     X        PIFELD(KWEIND(JP_I_W,JOLON),ILATN)
C
            IF( PWFACT(JP_I_NE,JOLON,JOLAT).GT.NEAREST ) THEN
              NEAREST = PWFACT(JP_I_NE,JOLON,JOLAT)
              POFELD(JOLON,JOLAT) =
     X          PIFELD(KWEIND(JP_I_E,JOLON),ILATN)
            ENDIF
C
            IF( PWFACT(JP_I_SW,JOLON,JOLAT).GT.NEAREST ) THEN
              NEAREST = PWFACT(JP_I_SW,JOLON,JOLAT)
              POFELD(JOLON,JOLAT) =
     X          PIFELD(KWEIND(JP_I_W,JOLON),ILATS)
            ENDIF
C
            IF( PWFACT(JP_I_SE,JOLON,JOLAT).GT.NEAREST ) THEN
              NEAREST = PWFACT(JP_I_SE,JOLON,JOLAT)
              POFELD(JOLON,JOLAT) =
     X          PIFELD(KWEIND(JP_I_E,JOLON),ILATS)
            ENDIF
C
          ENDIF
C
        ENDDO
C
      ENDDO
C
C     -----------------------------------------------------------------|
C*    Section 9. Return to calling routine. Format statements
C     -----------------------------------------------------------------|
C
  900 CONTINUE
C
      IF( KPR.GE.1 ) CALL INTLOG(JP_DEBUG,'IGTOG: Section 9.',JPQUIET)
C
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE FMMH(KLA,KLO,KELEM,VALUES,KSEC3,RMINLAT,RMINLON,
     1                RMAXLAT,RMAXLON)
C
C**** *FMM*
C
C
C     PURPOSE.
C     --------
C         FIND MINIMUM AND MAXIMUM LATITUDE AND LOGITUDE.
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *FMMH(KLA,KLO,VALUES,KSEC3,RMINLAT,RMINLON,
C                      RMAXLAT,RMAXLON)*
C
C     METHOD.
C     -------
C
C          NONE.
C
C
C     EXTERNALS.
C     ----------
C
C         NONE.
C
C     REFERENCE.
C     ----------
C
C          NONE.
C
C     AUTHOR.
C     -------
C
C          M. DRAGOSAVAC    *ECMWF*       15/04/1991.
C
C
C     MODIFICATIONS.
C     --------------
C
C          NONE.
C
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
C
C
      DIMENSION KSEC3(*)
#ifndef R_4
      REAL*8 VALUES(*)
      REAL*8 RNLON
      REAL*8 RNLAT
      REAL*8 RMINLAT
      REAL*8 RMINLON
      REAL*8 RMAXLAT
      REAL*8 RMAXLON
      REAL*8 RVIND
      REAL*8 EPS
#else
      REAL VALUES(*)
      REAL RNLON
      REAL RNLAT
      REAL RMINLAT
      REAL RMINLON
      REAL RMAXLAT
      REAL RMAXLON
      REAL RVIND
      REAL EPS

#endif
C     -----------------------------------------------------------------
C*          1.   FIND MIN/MAX LATITUDES/LONGITUDES.
C                ----------------------------------
 100  CONTINUE
C
      RVIND=1.7D38
      EPS=10.D-7
C
      ISUB=KSEC3(3)
C
C
      DO 101 I=1,ISUB
      KLAI=KELEM*(I-1)+KLA
      IF(ABS(VALUES( KLAI)-RVIND)/RVIND.GT.EPS)
     1   THEN
            RMINLAT=VALUES( KLAI)
            GO TO 105
         END IF
 101  CONTINUE
C
 105  CONTINUE
C
      DO 110 I=1,ISUB
C
      KLAI=KELEM*(I-1)+KLA
      IF(ABS(VALUES( KLAI)-RVIND)/RVIND.LT.EPS) GO TO 110
      RNLAT=VALUES( KLAI)
      IF(RNLAT.LT.RMINLAT) RMINLAT=RNLAT
C
 110  CONTINUE
C
      DO 111 I=1,ISUB
      KLOI=KELEM*(I-1)+KLO
      IF(ABS(VALUES( KLOI)-RVIND)/RVIND.GT.EPS) THEN
         RMINLON=VALUES( KLOI)+180.
         GO TO 115
      END IF
 111  CONTINUE
C
 115  CONTINUE
C
      DO 120 I=1,ISUB
C
      KLOI=KELEM*(I-1)+KLO
      IF(ABS(VALUES( KLOI)-RVIND)/RVIND.LT.EPS) GO TO 120
      RNLON=VALUES( KLOI)+180.
      IF(RNLON.LT.RMINLON) RMINLON=RNLON
C
 120  CONTINUE
C
      DO 121 I=1,ISUB
      KLAI=KELEM*(I-1)+KLA
      IF(ABS(VALUES(KLAI)-RVIND)/RVIND.GT.EPS) THEN
         RMAXLAT=VALUES( KLAI)
         GO TO 125
      END IF
 121  CONTINUE
C
 125  CONTINUE
C
      DO 130 I=1,ISUB
C
      KLAI=KELEM*(I-1)+KLA
      IF(ABS(VALUES( KLAI)-RVIND)/RVIND.LT.EPS) GO TO 130
      RNLAT=VALUES( KLAI)
      IF(RNLAT.GT.RMAXLAT) RMAXLAT=RNLAT
C
 130  CONTINUE
C
C
      DO 131 I=1,ISUB
      KLOI=KELEM*(I-1)+KLO
      IF(ABS(VALUES( KLOI)-RVIND)/RVIND.GT.EPS) THEN
         RMAXLON=VALUES( KLOI)+180.
         GO TO 135
      END IF
 131  CONTINUE
C
 135  CONTINUE
C
      DO 140 I=1,ISUB
C
      KLOI=KELEM*(I-1)+KLO
      IF(ABS(VALUES( KLOI)-RVIND)/RVIND.LT.EPS) GO TO 140
      RNLON=VALUES( KLOI)+180.
      IF(RNLON.GT.RMAXLON) RMAXLON=RNLON
C
 140  CONTINUE
C
      RMINLON=RMINLON-180.

      RMAXLON=RMAXLON-180.
C
C
C*          2. CHECK IF ALL OBSERVATION FITS IN THE BOX.
C              -----------------------------------------
 200  CONTINUE
C
      DO 201 I=1,ISUB
C
      KLAI=KELEM*(I-1)+KLA
      KLOI=KELEM*(I-1)+KLO
      IF((VALUES( KLAI).LT.RMINLAT.AND.VALUES( KLAI).GT.RMAXLAT).OR.
     1   (VALUES( KLOI).LT.RMINLON.AND.VALUES( KLOI).GT.RMAXLON) )
     2   GO TO 210
 201  CONTINUE
C
C     ALL DATA IN THE BOX
C
      RETURN
C
C*          2.1 FIND MAX NEGATIVE LONGITUDE AND MIN POSITIVE LONGITUDE.
C               -------------------------------------------------------
 210  CONTINUE
C
      DO 211 I=1,ISUB
      KLOI=KELEM*(I-1)+KLO
      IF(ABS(VALUES( KLOI)-RVIND)/RVIND.GT.EPS) THEN
         IF(VALUES( KLOI).LT.0) THEN
            RMAXLON=VALUES( KLOI)
            GO TO 215
         END IF
      END IF
 211  CONTINUE
C
C     NEGATIVE LONGITUDES NOT FOUND
C
      PRINT*,'FMM:NEGATIVE LONGITUDES NOT FOUND'
      RETURN
C
 215  CONTINUE
C
      DO 220 I=1,ISUB
C
      KLOI=KELEM*(I-1)+KLO
      IF(ABS(VALUES( KLOI)-RVIND)/RVIND.LT.EPS) GO TO 220
      IF(VALUES( KLOI).LT.0) THEN
         RNLON=VALUES( KLOI)

         IF(RNLON.GT.RMAXLON) RMAXLON=RNLON
      END IF
C
 220  CONTINUE
C
C*          2.3 FIND MIN POSITIVE LONGITUDE.
C
 230  CONTINUE
      DO 231 I=1,ISUB
      KLOI=KELEM*(I-1)+KLO
      IF(ABS(VALUES( KLOI)-RVIND)/RVIND.GT.EPS) THEN
         IF(VALUES( KLOI).GE.0) THEN
            RMINLON=VALUES( KLOI)
            GO TO 235
         END IF
      END IF
 231  CONTINUE
C
C     POSITIVE LONGITUDES NOT FOUND
C
      PRINT*,'FMM:POSITIVE LONGITUDES NOT FOUND'
      RETURN
C
 235  CONTINUE
C
      DO 232 I=1,ISUB
C
      KLOI=KELEM*(I-1)+KLO
      IF(ABS(VALUES( KLOI)-RVIND)/RVIND.LT.EPS) GO TO 232
      IF(VALUES( KLOI).GE.0) THEN
         RNLON=VALUES( KLOI)
         IF(RNLON.LT.RMINLON) RMINLON=RNLON
      END IF
C
 232  CONTINUE

      RETURN
      END

C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE GET_UNITS(KY,KERR)
C**** *GET_UNITS*
C
C
C     PURPOSE.
C     --------
C
C          Get units for the code number KY
C
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *GET_UNITS(KY,KERR)*
C
C     METHOD.
C     -------
C
C          NONE.
C
C
C     EXTERNALS.
C     ----------
C
C          NONE.
C
C     REFERENCE.
C     ----------
C
C          NONE.
C
C     AUTHOR.
C     -------
C
C          MILAN DRAGOSAVAC    *ECMWF*       07/01/2004
C
C
C     MODIFICATIONS.
C     --------------
C
C          NONE.
C
C
      IMPLICIT LOGICAL(L,O,G), CHARACTER*8(C,H,Y)
C

c
      PARAMETER(JSUP =   9,JSEC0=   3,JSEC1= 40,JSEC2= 64 ,JSEC3=    4,
     1          JSEC4=   2,JELEM=40000,JSUBS=400,JCVAL=150 ,JBUFL=40000,
     2          JBPW =  32,JTAB =3000,JCTAB=120,JCTST=1800,JCTEXT= 200,
     3          JWORK=360000,JKEY=46)

      COMMON /CREXUT/ YUNIT,CUNITNAME,CIA5,CIA2,NCODE,NRECORDS
c
c             NCODE  - array containing unit code number
c             CUNITNAME - array containing unit name
c             CIA5 - array  containing unit CCITTIA5 name
c             CIA2 - array  containing unit CCITTIA2 name
c             NRECORDS - number of entries in the list
c
      DIMENSION NCODE(JCTEXT)
      CHARACTER*30 CUNITNAME(JCTEXT)
      CHARACTER*24 CIA5(JCTEXT)
      CHARACTER*24 CIA2(JCTEXT)
      CHARACTER*24 YUNIT
c
      KERR=0
      DO I=1,NRECORDS
        IF(NCODE(I).EQ.KY) THEN
         YUNIT=CIA5(I)
         RETURN
        END IF
      END DO
c
      KERR=47
      CALL CREXERR(KERR)
c
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      INTEGER FUNCTION IGLGRID (KSTRIDE, KAREA, KLONG, KNWE, KLATG,
     1   KNNS, OWEGLOBE, KPR, KERR)
C
C---->
C**** *IGLGRID*
C
C     PURPOSE
C     _______
C
C     Generate the arrays of latitude and longitude points for a
C     regular latitude longitude grid.
C
C     INTERFACE
C     _________
C
C     IERR = IGLGRID (KSTRIDE, KAREA, KLONG, KNWE, KLATG, KNNS,
C    1   OWEGLOBE, KPR, KERR)
C
C     Input parameters
C     ________________
C
C     KSTRIDE    - The grid definition (WE, NS) provided by the
C                  calling routine.
C
C     KAREA      - The area definition (N, W, S, E) provided by the
C                  calling routine.
C
C     KNWE       - The number of points in the West-East direction in
C                  this field.
C
C     KNNS       - The number of points in the North-South direction
C                  in this field.
C
C     OWEGLOBE   - This variable will be true if the array of
C                  longitudes spans the globe and this is an input
C                  field.
C
C     KPR        - The debug print switch.
C                  0  , No debugging output.
C                  1  , Produce debugging output.
C
C     KERR       - The error control flag.
C                  -ve, No error message. Return error code.
C                  0  , Hard failure with error message.
C                  +ve, Print error message. Return error code.
C
C     Output parameters
C     ________________
C
C     KLONG      - The array of longitudes for the stride and area.
C                  If OEWGLOBE is true the West-East field array has
C                  element KNWE + 1 set equal to element 1 to help
C                  with recognising where an output grid 
C                  "wraps around" the break in the input grid.
C
C     KLATG      - The array of latitudes for the stride and area.
C
C     Return value
C     ____________
C
C     The error indicator (INTEGER).
C
C     Error and Warning Return Values
C     _______________________________
C
C     None
C
C     Common block usage
C     __________________
C
C     None
C
C     EXTERNALS
C     _________
C
C     INTLOG(R)    - Logs messages.
C
C     METHOD
C     ______
C
C     The arrays of longitudes and latitudes are generated using the
C     information provided by the other parameters.
C
C     REFERENCE
C     _________
C
C     None
C
C     COMMENTS
C     ________
C
C     Program contains sections 0 to 3 and 9
C
C     AUTHOR
C     ______
C
C     K. Fielding      *ECMWF*      Oct 1993
C
C     MODIFICATIONS
C     _____________
C
C     None
C
C----<
C     _______________________________________________________
C
C
C*    Section 0. Definition of variables.
C     _______________________________________________________
C
C*    Prefix conventions for variable names
C
C     Logical      L (but not LP), global or common.
C                  O, dummy argument
C                  G, local variable
C                  LP, parameter.
C     Character    C, global or common.
C                  H, dummy argument
C                  Y (but not YP), local variable
C                  YP, parameter.
C     Integer      M and N, global or common.
C                  K, dummy argument
C                  I, local variable
C                  J (but not JP), loop control
C                  JP, parameter.
C     REAL         A to F and Q to X, global or common.
C                  P (but not PP), dummy argument
C                  Z, local variable
C                  PP, parameter.
C
C     Implicit statement to force declarations
C
      IMPLICIT NONE
C
#include "parim.h"
C
C     Dummy arguments
      LOGICAL OWEGLOBE
      INTEGER KNWE, KNNS, KPR, KERR
      INTEGER KSTRIDE (2), KAREA (4)
      INTEGER KLONG (KNWE + 1), KLATG (KNNS)
C
C     Local variables
      INTEGER IEAST, IWEST
      INTEGER JLONG, JLAT
      INTEGER JPROUTINE
      PARAMETER (JPROUTINE = 24900)
C
C     _______________________________________________________
C
C*    Section 1. Initialisation
C     _______________________________________________________
C
  100 CONTINUE
C
      IF (KPR.GE.1) CALL INTLOG(JP_DEBUG,'IGLGRID: Section 1.',JPQUIET)
C
      IGLGRID = 0
C
      IF (KPR .GE. 1) THEN
        CALL INTLOG(JP_DEBUG,'IGLGRID: Input parameters.',JPQUIET)
        CALL INTLOG(JP_DEBUG,'IGLGRID: No.long.pts = ',KNWE)
        CALL INTLOG(JP_DEBUG,'IGLGRID: No.lat. pts = ',KNNS)
        CALL INTLOG(JP_DEBUG,'IGLGRID: Grid stride WE = ',KSTRIDE(1))
        CALL INTLOG(JP_DEBUG,'IGLGRID: Grid stride NS = ',KSTRIDE(2))
        CALL INTLOG(JP_DEBUG,'IGLGRID: Area North = ', KAREA(1))
        CALL INTLOG(JP_DEBUG,'IGLGRID: Area West  = ', KAREA(2))
        CALL INTLOG(JP_DEBUG,'IGLGRID: Area South = ', KAREA(3))
        CALL INTLOG(JP_DEBUG,'IGLGRID: Area East  = ', KAREA(4))
        IF( OWEGLOBE ) THEN
          CALL INTLOG(JP_DEBUG,
     X      'IGLGRID: Input W-E fld is global.',JPQUIET)
        ELSE
          CALL INTLOG(JP_DEBUG,
     X      'IGLGRID: Input W-E fld is NOT global.',JPQUIET)
        ENDIF
      ENDIF
C
      IEAST = KAREA (JPEAST)
      IWEST = KAREA (JPWEST)
C
C     _______________________________________________________
C
C
C*    Section 2. Generate points around a line of latitude.
C     _______________________________________________________
C
  200 CONTINUE
C
      IF (KPR.GE.1) CALL INTLOG(JP_DEBUG,'IGLGRID: Section 2.',JPQUIET)
C
C     Standardise range so that EAST > WEST
C
      IF (IEAST .LT. IWEST ) THEN
C
         IF (IEAST .LT. 0) THEN
            IEAST = IEAST + JP360
         ELSE
            IWEST = IWEST - JP360
         ENDIF
C
      ENDIF
C
C     Generate points in standardised range (0, jp360)
C
      DO 210 JLONG = 1, KNWE
C
         KLONG (JLONG) = IWEST + KSTRIDE (JPWESTEP) * (JLONG - 1)
C
         IF (KLONG (JLONG) .LT. 0)
     1      KLONG (JLONG) = KLONG (JLONG) + JP360
C
  210 CONTINUE
C
C     Add first point to end of list if global
C
      IF (OWEGLOBE)
     1   KLONG (KNWE + 1) = KLONG (1)
C
C     _______________________________________________________
C
C
C*    Section 3. Generate points along a line of meridian
C     _______________________________________________________
C
  300 CONTINUE
C
      IF (KPR.GE.1) CALL INTLOG(JP_DEBUG,'IGLGRID: Section 3.',JPQUIET)
C
      DO 310 JLAT = 1, KNNS
C
         KLATG (JLAT) = KAREA (JPNORTH) -
     1      KSTRIDE (JPNSSTEP) * (JLAT - 1)
C
  310 CONTINUE
C
C     _______________________________________________________
C
C
C*    Section 9. Return to calling routine. Format statements
C     _______________________________________________________
C
  900 CONTINUE
C
      IF (KPR.GE.1) CALL INTLOG(JP_DEBUG,'IGLGRID: Section 9.',JPQUIET)
C
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE GET_UNITS(KY,KERR)
C**** *GET_UNITS*
C
C
C     PURPOSE.
C     --------
C
C          Get units for the code number KY
C
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *GET_UNITS(KY,KERR)*
C
C     METHOD.
C     -------
C
C          NONE.
C
C
C     EXTERNALS.
C     ----------
C
C          NONE.
C
C     REFERENCE.
C     ----------
C
C          NONE.
C
C     AUTHOR.
C     -------
C
C          MILAN DRAGOSAVAC    *ECMWF*       07/01/2004
C
C
C     MODIFICATIONS.
C     --------------
C
C          NONE.
C
C
      IMPLICIT LOGICAL(L,O,G), CHARACTER*8(C,H,Y)
C

c
      PARAMETER(JSUP =   9,JSEC0=   3,JSEC1= 40,JSEC2= 64 ,JSEC3=    4,
     1          JSEC4=   2,JELEM=40000,JSUBS=400,JCVAL=150 ,JBUFL=40000,
     2          JBPW =  32,JTAB =3000,JCTAB=120,JCTST=1800,JCTEXT= 200,
     3          JWORK=360000,JKEY=46)

      COMMON /CREXUT/ YUNIT,CUNITNAME,CIA5,CIA2,NCODE,NRECORDS
c
c             NCODE  - array containing unit code number
c             CUNITNAME - array containing unit name
c             CIA5 - array  containing unit CCITTIA5 name
c             CIA2 - array  containing unit CCITTIA2 name
c             NRECORDS - number of entries in the list
c
      DIMENSION NCODE(JCTEXT)
      CHARACTER*30 CUNITNAME(JCTEXT)
      CHARACTER*24 CIA5(JCTEXT)
      CHARACTER*24 CIA2(JCTEXT)
      CHARACTER*24 YUNIT
c
      KERR=0
      DO I=1,NRECORDS
        IF(NCODE(I).EQ.KY) THEN
         YUNIT=CIA5(I)
         RETURN
        END IF
      END DO
c
      KERR=47
      CALL CREXERR(KERR)
c
      RETURN
      END

C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE BUNEXS( KLEN)
C
C**** *BUNEXS*
C
C
C     PURPOSE.
C     --------
C           SETS WORD (NWPT) AND BIT(NBPT) POINTERS AT THE BEGINING
C     OF NEXT SECTION OF BUFR MESSAGE.
C
C**   INTERFACE.
C     ----------
C
C            *CALL* *BUNEXS( KLEN)*
C
C        INPUT :
C                 *KLEN*     - LENGTH OF SECTION IN BYTES
C
C     METHOD.
C     -------
C
C          LENGTH OF EACH SECTION IS ADDED UP. WORD AND BIT POINTERS
C     POINTING TO THE BEGINING OF NEXT SECTION ARE CALCULATED.
C
C     EXTERNALS.
C     ----------
C
C           NONE.
C
C     REFERENCE.
C     ----------
C
C          NONE.
C
C     AUTHOR.
C     -------
C
C          M. DRAGOSAVAC    *ECMWF*       16/01/91.
C
C     MODIFICATIONS.
C     --------------
C
C          NONE.
C
      IMPLICIT LOGICAL(L,O,G), CHARACTER*8(C,H,Y)
C
C
C
#     include "parameter.F"
#     include "bcomunit.F"
#     include "bcomwork.F"
C
#ifndef R_4
      REAL*8 RVIND
      REAL*8 EPS
#else
      REAL   RVIND
      REAL   EPS
#endif
C
C     ------------------------------------------------------------------
C
C*          1.   SET UP POINTERS AT THE BEGINING OF THE NEXT SECTION.
C                -----------------------------------------------------
 100  CONTINUE
C
      IBIT = (NWPT - 1)*NBPW +NBPT +KLEN * 8 - 24
C
      NWPTB = IBIT/NBPW + 1
      NBPTB = IBIT - (NWPTB - 1)*NBPW
C
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE BUNEXS( KLEN)
C
C**** *BUNEXS*
C
C
C     PURPOSE.
C     --------
C           SETS WORD (NWPT) AND BIT(NBPT) POINTERS AT THE BEGINING
C     OF NEXT SECTION OF BUFR MESSAGE.
C
C**   INTERFACE.
C     ----------
C
C            *CALL* *BUNEXS( KLEN)*
C
C        INPUT :
C                 *KLEN*     - LENGTH OF SECTION IN BYTES
C
C     METHOD.
C     -------
C
C          LENGTH OF EACH SECTION IS ADDED UP. WORD AND BIT POINTERS
C     POINTING TO THE BEGINING OF NEXT SECTION ARE CALCULATED.
C
C     EXTERNALS.
C     ----------
C
C           NONE.
C
C     REFERENCE.
C     ----------
C
C          NONE.
C
C     AUTHOR.
C     -------
C
C          M. DRAGOSAVAC    *ECMWF*       16/01/91.
C
C     MODIFICATIONS.
C     --------------
C
C          NONE.
C
      IMPLICIT LOGICAL(L,O,G), CHARACTER*8(C,H,Y)
C
C
C
#     include "parameter.F"
#     include "bcomunit.F"
#     include "bcomwork.F"
C
#ifndef R_4
      REAL*8 RVIND
      REAL*8 EPS
#else
      REAL   RVIND
      REAL   EPS
#endif
C
C     ------------------------------------------------------------------
C
C*          1.   SET UP POINTERS AT THE BEGINING OF THE NEXT SECTION.
C                -----------------------------------------------------
 100  CONTINUE
C
      IBIT = (NWPT - 1)*NBPW +NBPT +KLEN * 8 - 24
C
      NWPTB = IBIT/NBPW + 1
      NBPTB = IBIT - (NWPTB - 1)*NBPW
C
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities
C granted to it by virtue of its status as an intergovernmental organisation
C nor does it submit to any jurisdiction.
C

      INTEGER FUNCTION OCEANU( INOCEAN, INLEN, OUTOCEAN, OUTLEN)
C
C---->
C**** OCEANU
C
C     Purpose
C     -------
C
C     Interpolate input ocean field to ocean
C     field.
C
C
C     Interface
C     ---------
C
C     IRET = OCEANU( INOCEAN, INLEN, OUTOCEAN, OUTLEN)
C
C     Input
C     -----
C
C     INOCEAN - Input ocean field
C     INLEN   - Input field length (words).
C
C
C     Output
C     ------
C
C     OUTOCEAN - Output ocean field
C     OUTLEN  - Output field length (words).
C
C
C     Method
C     ------
C
C     Interpolate ocean field.
C
C     If requested X grid increment does not match input GRIB
C     increment, do a full interpolation in both x and y. Otherwise,
C     interpolate only to make grid regular.
C
C     Externals
C     ---------
C
C     JDEBUG  - Tests if debug output required.
C     GRIBEX  - GRIB decoding/encoding.
C     INTLOG  - Log error message.
C     JMEMHAN - Allocate/deallocate scratch memory.
C     INTOCN  - Carry out ocean field to field interpolation.
C
C
C     Author
C     ------
C
C     J.D.Chambers     ECMWF        Mar 1997
C     Allow for full or partial interpolation
C     (F or R option in call to INTOCN).
C
C----<
C
      IMPLICIT NONE
C
C     Function arguments
C
      INTEGER INLEN, OUTLEN
      REAL INOCEAN, OUTOCEAN
      DIMENSION INOCEAN(*),OUTOCEAN(*)
C
#include "parim.h"
#include "nifld.common"
#include "nofld.common"
C
C     Parameters
C
      INTEGER JPROUTINE, JPALLOC, JPDEALL, JPSCR3, JPSCR4
      INTEGER JP_LAT, JP_LONG, JP_GUESS
      PARAMETER (JPROUTINE = 36900 )
      PARAMETER (JPALLOC = 1)
      PARAMETER (JPDEALL = 0)
      PARAMETER (JPSCR3 = 3)
      PARAMETER (JPSCR4 = 4)
      PARAMETER (JP_LONG = 3)
      PARAMETER (JP_LAT  = 4)
      PARAMETER (JP_GUESS  = 18049691)
cs    PARAMETER (JP_GUESS  = 1675245)
cs    PARAMETER (JP_GUESS  = 1237104)
cs    PARAMETER (JP_GUESS  = 1038240)
C                          `---> allow for 0.25*0.25 interpolated grid
C
C     Local variables
C
      LOGICAL LHORIZN, LFLIP
c     CHARACTER*1 HFUNC
      CHARACTER*1 HINTOPT
      CHARACTER*6 YFLAG
      INTEGER IOLDN, IOLDW, IOLDS, IOLDE, IOLDEW, IOLDNS
      INTEGER LOOPLAT, LOOPLON, I, J, IOS, LOOP
      REAL ZTEMP
      INTEGER IERR, KPR, IOLDSIZ, INEWSIZ, IINTPOL, ISTAGP
      INTEGER NXP, NYP, INEWP, ITEMP
      REAL RTOP, RBOTT, RRIGHT, RLEFT, RYRES, RXRES
      REAL XARR, YARR
      DIMENSION XARR(JPGRIB_ISEC1), YARR(JPGRIB_ISEC1)
      REAL NEW
      POINTER ( INEW, NEW )
      DIMENSION NEW( 1 )
C
C     Externals
C
      INTEGER INTOCNU, FIXAREA
C
C     -----------------------------------------------------------------|
C*    Section 1.   Initialise
C     -----------------------------------------------------------------|
C
  100 CONTINUE
C
C     Test if debug output required.
C
      CALL JDEBUG()
C
      CALL INTLOG(JP_DEBUG,
     X  'OCEANU: Trying to interpolate an ocean field.',JPQUIET)
C
      IF( .NOT.LNOGRID ) THEN
        CALL INTLOG(JP_FATAL,
     X    'OCEANU: GRID must be specified to interpolate an ocean field'
     X    , JPQUIET)
        OCEANU = JPROUTINE + 1
        GOTO 960
      ENDIF
C
      OCEANU = 0
      IERR   = 0
      KPR    = 0
      LFLIP = .FALSE.
C
C     Save the original area and grid definitions
C
       NOOCO3  = NIOCO3
       NOOCO4  = NIOCO4
       NOOCO4F = NIOCO4F
       NOOCO3F = NIOCO3F
       NOOCO4L = NIOCO4L
       NOOCO3L = NIOCO3L
       NOOIINC = NIOIINC
       NOOJINC = NIOJINC
       NOOIRGR = NIOIRGR
       NOONOST = NIONOST

      IOLDN  = NOAREA(1)
      IOLDW  = NOAREA(2)
      IOLDS  = NOAREA(3)
      IOLDE  = NOAREA(4)
      IOLDEW = NOGRID(1)
      IOLDNS = NOGRID(2)
C
C     -----------------------------------------------------------------|
C*    Section 2.   Unpack the input ocean field.
C     -----------------------------------------------------------------|
C
  200 CONTINUE
C
      LHORIZN = (NIOCO3.EQ.JP_LONG).AND.(NIOCO4.EQ.JP_LAT)
      IF( LHORIZN ) CALL INTLOG(JP_DEBUG,
     X  'OCEANU: Horizontal (lat/long) field interpolation.',JPQUIET)
C
C     Get scratch memory for unpacking the input ocean field.
C
      IOLDSIZ = NINS * NIWE
C
C     For horizontal field, match the desired area to the grid
C
      IERR = FIXAREA()
      IF( IERR.NE.0 ) THEN
        CALL INTLOG(JP_ERROR, 'OCEANU: FIXAREA failed.',JPQUIET)
        OCEANU = IERR
        GOTO 940
      ENDIF
C
C     Get scratch memory for output ocean field.
C     Have to guess how big the interpolated grid will be.
C
      IF(NOGRID(1).GT.0.AND.NOGRID(1).GT.0) THEN
         INEWSIZ = (JP360/NOGRID(1) + 1) * (JP180 / NOGRID(2) + 1)*2
      ELSE
         INEWSIZ = JP_GUESS
      ENDIF
cs    print*,'OCEANU INEWSIZ ',INEWSIZ
cs    print*,'OCEANU JP_GUESS ',JP_GUESS
cs    print*,'OCEANU NOGRID(1): ',NOGRID(1),' NOGRID(2): ',NOGRID(2)
      CALL JMEMHAN(JPSCR3, INEW, INEWSIZ*2, JPALLOC, IERR)
      IF( IERR.NE.0 ) THEN
        CALL INTLOG(JP_ERROR,
     X    'OCEANU: Scratch memory(3) allocation failed.',JPQUIET)
        OCEANU = IERR
        GOTO 940
      ENDIF
      INEWP = 1
      ITEMP = 1 + INEWSIZ
C
C     -----------------------------------------------------------------|
C*    Section 4.   Interpolate ocean field.
C     -----------------------------------------------------------------|
C
  400 CONTINUE
C
      RTOP   = FLOAT( NOAREA(1) ) / PPMULT
      RBOTT  = FLOAT( NOAREA(3) ) / PPMULT
      RRIGHT = FLOAT( NOAREA(4) ) / PPMULT
      RLEFT  = FLOAT( NOAREA(2) ) / PPMULT
C
      RYRES = FLOAT( NOGRID(2) ) / PPMULT
      RXRES = FLOAT( NOGRID(1) ) / PPMULT
C
C     Select the interpolation option
C     (default = 'R' = interpolate only to make grid regular)
C     If requested X grid increment does not match input GRIB
C     increment, interpolate in x and y ('F' = full)
C
      HINTOPT = 'R'
      IF( NOGRID(1).NE.NIGRID(1) ) HINTOPT = 'F'
C
      IERR = INTOCNU(HINTOPT,'D',
     X              RTOP, RBOTT, RRIGHT, RLEFT, RYRES, RXRES,
     X              INOCEAN, IOLDSIZ,
     X              INEWSIZ, NEW(ITEMP), XARR, YARR, NXP, NYP,
     X              NEW(INEWP),
     X              IINTPOL, ISTAGP)
      IF( IERR.NE.0 ) THEN
        CALL INTLOG(JP_ERROR, 'OCEANU: Interpolation failed.',JPQUIET)
        OCEANU = IERR
        GOTO 900
      ENDIF
C
      NOAREA(1) = NINT( (YARR(1) + YARR(2)*(NYP-1)) * PPMULT )
      NOAREA(2) = NINT( XARR(1) * PPMULT )
      NOAREA(3) = NINT( YARR(1) * PPMULT )
      NOAREA(4) = NINT( (XARR(1) + XARR(2)*(NXP-1)) * PPMULT )
C
      NOAAPI(1) = NOAREA(1)
      NOAAPI(2) = NOAREA(2)
      NOAAPI(3) = NOAREA(3)
      NOAAPI(4) = NOAREA(4)
      NOGRID(1) = NINT( ABS(XARR(2)) * PPMULT )
      NOGRID(2) = NINT( ABS(YARR(2)) * PPMULT )
      NONS = NYP
      NOWE = NXP
C
C     -----------------------------------------------------------------|
C*    Section 5.   Code new field into GRIB.
C     -----------------------------------------------------------------|
C
  500 CONTINUE
C
C     Re-order the rows from south to north to be north to south
C     (ECMWF convention).
C
      IF( LHORIZN.OR.(NOAREA(1).LT.NOAREA(3)) ) THEN
        LFLIP = .TRUE.
        DO LOOPLAT = 1, NYP/2
          I = (LOOPLAT - 1)*NXP
          J = (NYP - LOOPLAT)*NXP
          DO LOOPLON = 1, NXP
            I = I + 1
            J = J + 1
            ZTEMP  = NEW(I)
            NEW(I) = NEW(J)
            NEW(J) = ZTEMP
          ENDDO
        ENDDO
C
        IF( .NOT.LHORIZN ) THEN
          ITEMP     = NOAREA(1)
          NOAREA(1) = NOAREA(3)
          NOAREA(3) = ITEMP
C
          ITEMP     = NOAAPI(1)
          NOAAPI(1) = NOAAPI(3)
          NOAAPI(3) = ITEMP
        ENDIF
      ENDIF
C
C     Setup GRIB sections for the output product:
C
C
      IF( LHORIZN ) THEN
c
        NOOCO4F = NOAREA(1)*10
        NOOCO3F = NOAREA(2)*10
        NOOCO4L = NOAREA(3)*10
        NOOCO3L = NOAREA(4)*10
        NOOIINC = NOGRID(1)*10
        NOOJINC = NOGRID(2)*10
        IF( LFLIP ) NOOJINC = - NOOJINC
        NOOIRGR = 0
        NOONOST = 0
C
C       Standard section 2 format for horizontal sections
C
        NOAAPI(1) = NOAREA(1)
        NOAAPI(2) = NOAREA(2)
        NOAAPI(3) = NOAREA(3)
        NOAAPI(4) = NOAREA(4)
        NOWE = NXP
        NONS = NYP
      ELSE
C Tim-Correct headers for vertical sections
        IF( NIOCO3.EQ.3 ) THEN
          NOOCO3F = NOAREA(2)*10
        ELSEIF( NIOCO3.EQ.4 ) THEN
          NOOCO3F = NOAREA(2)*10
        ENDIF
        IF( NIOCO4.EQ.3 ) THEN
          NOOCO4F = NOAREA(1)*10
        ELSEIF( NIOCO4.EQ.4 ) THEN
          NOOCO4F = NOAREA(1)*10
        ENDIF
C
        IF( NIOCO4.EQ.1 ) THEN
          NOOCO4L = NOOCO4F + NINT((NYP-1)*RYRES*1.0)
          NOOCO3L = NOOCO3F + NINT((NXP-1)*RXRES*1000000.0)
          NOOIINC = NOGRID(1)*NINT(1000000.0/PPMULT)
          NOOJINC = NOGRID(2)/(PPMULT/1.0)
        ELSE
          NOOCO4L = NOOCO4F + NINT((NYP-1)*RYRES*1000.0)
          NOOCO3L = NOOCO3F + NINT((NXP-1)*RXRES*1000000.0)
          NOOIINC = NOGRID(1)*NINT(1000000.0/PPMULT)
          NOOJINC = NOGRID(2)/(PPMULT/1000.0)
        ENDIF
C
        IF( LFLIP ) NOOJINC = - NOOJINC
        NOOIRGR = 0
C
C       Special ECMWF ocean short form of GRIB section 2
C
cs        ISEC2(1) = 192
cs        ISEC2(2) = NXP
cs        ISEC2(3) = NYP
Cjdc    ISEC2(4) = NOAREA(1)/100000
Cjdc    ISEC2(5) = NOAREA(2)/100
Cjdc    ISEC2(6) = 0
Cjdc    ISEC2(7) = NOAREA(3)/100000
Cjdc    ISEC2(8) = NOAREA(4)/100
Cjdc    DO LOOPLAT = 9, 22
Cjdc      ISEC2(LOOPLAT) = 0
Cjdc    ENDDO
      ENDIF
C
C     Ensure there is a section 3 in case there is missing data in the
C     output area
C
cs      ISEC1(5) = 192
cs      ISEC3(1) = 0
cs      ZSEC3(2) = -999.9
C
cs      ISEC4(1) = NXP *  NYP
C
C     If grid-point output, setup for 2nd order packing if requested.
C
cs      IF( (NOREPR.NE.JPSPHERE).AND.(NOREPR.NE.JPSPHROT) ) THEN
cs        HFUNC = 'C'
cs        IF( NOHFUNC.EQ.'K' ) THEN
cs          HFUNC = 'K'
cs          ISEC4(4)  = 64
cs          ISEC4(6)  = 16
cs          ISEC4(9)  = 32
cs          ISEC4(10) = 16
cs          ISEC4(12) = 8
cs          ISEC4(13) = 4
cs          ISEC4(14) = 0
cs          ISEC4(15) = -1
cs        ELSE
cs          ISEC4(4)  = 0
cs          ISEC4(6)  = 0
cs        ENDIF
cs      ELSE
cs        HFUNC = 'C'
cs        IF( NOHFUNC.EQ.'C' ) THEN
cs          ISEC2(6) = 2
cs          ISEC4(4) = 64
cs        ELSE IF( NOHFUNC.EQ.'S' ) THEN
cs          ISEC2(6) = 1
cs          ISEC4(4) = 0
cs        ENDIF
cs      ENDIF
C
C
      OUTLEN = NXP*NYP
          DO I = 1, OUTLEN
            OUTOCEAN(I)  = NEW(I)
          ENDDO
        CALL GETENV('DATA_CHECK', YFLAG)
        IF( YFLAG(1:1).EQ.'1' ) THEN
          OPEN (UNIT=18,FILE='./out_ocean_gribapi.dat',STATUS='UNKNOWN',
     &    FORM='UNFORMATTED',IOSTAT=IOS)
          IF (IOS.EQ.0) THEN
            WRITE (18)(OUTOCEAN(LOOP),LOOP=1,OUTLEN)
          ENDIF
          CLOSE(18)
        ENDIF
C
C
C     -----------------------------------------------------------------|
C*    Section 9.   Closedown.
C     -----------------------------------------------------------------|
C
  900 CONTINUE
C
C     Clear change flags for next product processing
C
      LCHANGE = .FALSE.
      LSMCHNG = .FALSE.
C
C     Return the scratch memory.
C
      CALL JMEMHAN( JPSCR3, INEW, INEWSIZ*2, JPDEALL, IERR)
      IF ( IERR .NE. 0 ) THEN
        CALL INTLOG(JP_ERROR,
     X    'OCEANU: Scratch memory(3) reallocation failed.',JPQUIET)
        OCEANU = IERR
      ENDIF
C
  940 CONTINUE
C
C
  950 CONTINUE
C
C     Restore the original area and grid definitions
C
cs      NOAREA(1) = IOLDN
cs      NOAREA(2) = IOLDW
cs      NOAREA(3) = IOLDS
cs      NOAREA(4) = IOLDE
cs      NOGRID(1) = IOLDEW
cs      NOGRID(2) = IOLDNS
C
  960 CONTINUE
C
      CALL INTLOG(JP_DEBUG,
     X  'OCEANU: Returning from interpolating an ocean field.',JPQUIET)
C
      RETURN
      END

      PROGRAM BUFR_SIMULATE
!
!**** *BUFR_SIMULATE*
!
!
!     PURPOSE.
!     --------
!        PACKS SIMULATED OBSERVATIONS INTO BUFR FORM.
!
!
!**   INTERFACE.
!     ----------
!
!          NONE.
!
!     METHOD.
!     -------
!
!          INPUT FILE CONTAING SIMULATED DATA IN SPECIFIC
!          FORMAT CREATED BY DATA ASSIMILATION IS READ AND
!          CONVERTED INTO CORRESPONDING BUFR TEMPLATES FOR 
!          OBSERVATIONS ADDING QUALITY CONTROL INFORMATION.
!          
!
!     EXTERNALS.
!     ----------
!          BUFR SOFTWARE FROM EMOSLIB
!
!     REFERENCE.
!     ----------
!
!          NONE.
!
!     AUTHOR.
!     -------
!
!          M. DRAGOSAVAC    *ECMWF*       MAY 1996
!
!
!     MODIFICATIONS.
!     --------------
!
      IMPLICIT NONE

      INTEGER, PARAMETER :: JSUP=9
      INTEGER, PARAMETER :: JSEC0=3
      INTEGER, PARAMETER :: JSEC1=40
      INTEGER, PARAMETER :: JSEC2=4096
      INTEGER, PARAMETER :: JSEC3=4
      INTEGER, PARAMETER :: JSEC4=2
      INTEGER, PARAMETER :: JELEM=160000
      INTEGER, PARAMETER :: JBUFL=4000
#ifdef JBPW_64
      INTEGER, PARAMETER :: JBPW=64
#else
      INTEGER, PARAMETER :: JBPW=32
#endif
      INTEGER, PARAMETER :: JWORK=4096000

      INTEGER, PARAMETER :: KELEM=10000
      INTEGER, PARAMETER :: KVALS=360000


      INTEGER, DIMENSION(JBUFL) :: KBUFR
      INTEGER, DIMENSION(JSUP)  :: KSUP
      INTEGER, DIMENSION(JSEC0) :: KSEC0
      INTEGER, DIMENSION(JSEC1) :: KSEC1
      INTEGER, DIMENSION(JSEC2) :: KSEC2
      INTEGER, DIMENSION(JSEC3) :: KSEC3
      INTEGER, DIMENSION(JSEC4) :: KSEC4
      
      REAL*8,    DIMENSION(KVALS) :: VALUES
      REAL*8                         RVIND
      REAL*8                         EPS

      INTEGER  NBYTPW
      INTEGER  IRET
      INTEGER  HEADER_LENGTH
      INTEGER  LENGTH
      INTEGER  TYPE
      INTEGER  SUBTYPE
      INTEGER  LATITUDE
      INTEGER  LONGITUDE
      INTEGER  STATION_ALTITUDE
      INTEGER  REPORT_DATE
      INTEGER  REPORT_TIME
      INTEGER  NUMBER_OF_LEVELS
      INTEGER  REPORT_QC
      INTEGER  REPORT_BODY_LENGTH
      INTEGER  PRESSURE
      INTEGER  MSL_PRESSURE
      INTEGER  WIND_DIRECTION
      INTEGER  WIND_SPEED
      INTEGER  GEOPOTENTIAL_HEIGHT
      INTEGER  TEMPERATURE
      INTEGER  DEW_POINT_TEMPERATURE
      INTEGER  PRECIPITABLE_WATER
      INTEGER  RADIANCES
      INTEGER  SIGMA_0,LEVELS
      INTEGER  NUMBER_OF_RECORDS
      INTEGER  OFFSET
      INTEGER  JCB
      INTEGER  II
      INTEGER  JJ 
      INTEGER  IUNIT,I,JB,IO,KTDLEN,KDLEN,ILEN,KBUFL

      REAL     ANALYSIS_DATA,ANALYSIS_TIME

      REAL, DIMENSION(10)  :: HEADER,BODY
      REAL, DIMENSION(1360):: REPORT

 
      INTEGER, DIMENSION(JELEM) :: KTDLST
      INTEGER, DIMENSION(JELEM) :: KTDEXP
      INTEGER, DIMENSION(200)   :: KDATA
 
      CHARACTER(256)  CF,CF1,COUTFILE,CINFILE
      CHARACTER(256), DIMENSION(4)     ::  CARG
      CHARACTER(80),  DIMENSION(KVALS) ::  CVALS
      
      INTEGER  NARG,J
      INTEGER IARGC
 
!s      EXTERNAL GETARG


!          1. INITIALIZE CONSTANTS 
!              -------------------
 
!     MISSING VALUE INDICATOR
 
      RVIND=1.7D38
      EPS=10.D-8
      NBYTPW=JBPW/8
 
!          2. GET INPUT AND OUTPUT FILE NAME.
!             -------------------------------
 
      NARG=IARGC()
 
      IF(NARG < 4) THEN
         PRINT*,'USAGE -- bufr_simulate -i infile -o outfile'
         STOP
      END IF
 
      DO  J=1,NARG
        CALL GETARG(J,CARG(J))
      END DO
 
      DO J=1,NARG,2
        IF(CARG(J).EQ.'-i') THEN
           CINFILE=CARG(J+1)
        ELSEIF(CARG(J).EQ.'-o') THEN
           COUTFILE=CARG(J+1)
        ELSE
            PRINT*,'USAGE -- bufr_simulate -i infile -o outfile'
            STOP
        END IF
      END DO
 
      II=LEN_TRIM(CINFILE)
      JJ=LEN_TRIM(COUTFILE)

 
!           3.  OPEN INPUT AND OUTPUT FILE.
!               ---------------------------
 
      OPEN(UNIT=9,FILE=CINFILE(1:II),IOSTAT=IO)
      IF(IO /= 0) THEN
         PRINT*,'OPEN FAILED ON INPUT FILE'
         STOP
      END IF
      
      IRET=0 
      CALL PBOPEN(IUNIT,COUTFILE(1:JJ),'W',IRET)
      IF(IRET.EQ.-1) STOP 'OPEN FAILED ON '
      IF(IRET.EQ.-2) STOP 'INVALID FILE NAME'
      IF(IRET.EQ.-3) STOP 'INVALID OPEN MODE SPECIFIED'


      LENGTH=1
      HEADER_LENGTH=10
      TYPE=2
      SUBTYPE=3
      LATITUDE=4
      LONGITUDE=5
      STATION_ALTITUDE=6
      REPORT_DATE=7           ! YYYYMMDD
      REPORT_TIME=8           ! HHMMSS
      NUMBER_OF_LEVELS=9
      REPORT_QC=10
      REPORT_BODY_LENGTH=10
      PRESSURE=1
      MSL_PRESSURE=2
      WIND_DIRECTION=3
      WIND_SPEED=4
      GEOPOTENTIAL_HEIGHT=5
      TEMPERATURE=6
      DEW_POINT_TEMPERATURE=7
      PRECIPITABLE_WATER=8
      RADIANCES=9 
      SIGMA_0=10

!            4. READ ANALYSIS DATE AND TIME
!               ---------------------------

      READ(9,*,IOSTAT=IO) ANALYSIS_DATA,ANALYSIS_TIME

!            5.  READ HEADER AND THE BODY
!                ------------------------


      IO = 0
      DO WHILE (IO == 0 )

        READ(9,*,IOSTAT=IO) (HEADER(I),I=1,HEADER_LENGTH)
        IF(IO == 0 ) THEN
           LEVELS=NINT(HEADER(NUMBER_OF_LEVELS))
           DO I=1,HEADER_LENGTH
             REPORT(I)=HEADER(I)
           END DO

           NUMBER_OF_RECORDS=NUMBER_OF_RECORDS + 1


!             5.1  GET LEVEL DATA
!                   --------------

           OFFSET=HEADER_LENGTH - REPORT_BODY_LENGTH

           DO J=1,LEVELS
             OFFSET = OFFSET + REPORT_BODY_LENGTH
             READ(9,*,IOSTAT=IO) (BODY(JB),JB=1,REPORT_BODY_LENGTH)
             IF(IO == 0) THEN
                DO JCB=1,REPORT_BODY_LENGTH
                  REPORT(OFFSET+JCB)=BODY(JCB)
                END DO
             END IF
           END DO


!             5.2   PACK REPORT INTO BUFR MESSAGE
!                    ------------------------------

           IRET=0 
           CALL BUFR_PACK(REPORT,KSEC0,KSEC1,KSEC2,KSEC3,KSEC4,  &
                          KTDLEN,KTDLST,KDLEN,KDATA,KELEM,KVALS, &
                          VALUES,CVALS,IRET)


           KBUFL=JBUFL
           IF(IRET == 0 ) THEN
              CALL BUFREN(KSEC0,KSEC1,KSEC2,KSEC3,KSEC4,   &
                          KTDLEN,KTDLST,KDLEN,KDATA,KELEM, &
                          KVALS,VALUES,CVALS,KBUFL,KBUFR,IRET)
              IF(IRET == 0) THEN


!             5.3   WRITE DATA INTO TARGET FILE
!                   ---------------------------

                 ILEN=KBUFL*NBYTPW

                 IRET=0
                 CALL PBWRITE(IUNIT,KBUFR,ILEN,IRET)
                 IF(IRET.LT.0) THEN
                    PRINT*,'ERROR WRITING INTO TARGET FILE.'
                    CALL EXIT(2)
                 END IF
              ELSE
!                 CALL EXIT(2)
              END IF
           END IF
        END IF
      END DO

      PRINT*,' '
      PRINT*,'NUMBER OF RECORDS PROCESSED',NUMBER_OF_RECORDS

      CONTAINS


      SUBROUTINE BUFR_PACK(REPORT,KSEC0,KSEC1,KSEC2,KSEC3,KSEC4,  &
                          KTDLEN,KTDLST,KDLEN,KDATA,KELEM,KVALS,  & 
                          VALUES,CVALS,IRET)
!**** *BUFR_PACK*
!
!
!     PURPOSE.
!     --------
!
!           CREATES BUFR MESSAGE.
!
!
!**   INTERFACE.
!     ----------
!
!           CALL  BUFR_PACK(REPORT,KSEC0,KSEC1,KSEC2,KSEC3,KSEC4,
!                           KTDLEN,KTDLST,KDLEN,KDATA,KELEM,KVALS,
!                           VALUES,CVALS,IRET)
!     METHOD.
!     -------
!
!
!           NONE.
!
!
!     EXTERNALS.
!     ----------
!
!           NONE.
!
!     REFERENCE.
!     ----------
!
!
!
!     AUTHOR.
!     -------
!
!          M. DRAGOSAVAC    *ECMWF*       MAY 1996
!
!
!     MODIFICATIONS.
!     --------------
!
!          NONE.
!---------------------------------------------------------------------------

      IMPLICIT NONE


      REAL,        DIMENSION(:), INTENT(INOUT)   :: REPORT
      INTEGER,     DIMENSION(:), INTENT(INOUT)   :: KSEC0
      INTEGER,     DIMENSION(:), INTENT(INOUT)   :: KSEC1
      INTEGER,     DIMENSION(:), INTENT(INOUT)   :: KSEC2
      INTEGER,     DIMENSION(:), INTENT(INOUT)   :: KSEC3
      INTEGER,     DIMENSION(:), INTENT(INOUT)   :: KSEC4
      INTEGER,                   INTENT(INOUT)   :: KTDLEN
      INTEGER,     DIMENSION(:), INTENT(INOUT)   :: KTDLST
      INTEGER,                   INTENT(INOUT)   :: KDLEN 
      INTEGER,     DIMENSION(:), INTENT(INOUT)   :: KDATA
      INTEGER,                   INTENT(IN)      :: KELEM
      INTEGER,                   INTENT(IN)      :: KVALS
      REAL*8,        DIMENSION(:), INTENT(INOUT)   :: VALUES
      CHARACTER(*),DIMENSION(:), INTENT(INOUT)   :: CVALS
      INTEGER,                   INTENT(INOUT)   :: IRET


      INTEGER REPORT_SUBTYPE
      REAL*8, PARAMETER :: MISSING_VALUE=1.7D38
      
      REPORT_SUBTYPE=NINT(REPORT(3))

      SELECT CASE (REPORT_SUBTYPE)
         CASE(  1)
           CALL SECTIONS01234(REPORT,KSEC0,KSEC1,KSEC2,KSEC3,KSEC4,IRET)
           CALL CONVERT_1(REPORT,KTDLEN,KTDLST,KDLEN,KDATA, &
                            VALUES,CVALS,IRET)
         CASE( 11)
           CALL SECTIONS01234(REPORT,KSEC0,KSEC1,KSEC2,KSEC3,KSEC4,IRET)
           CALL CONVERT_11(REPORT,KTDLEN,KTDLST,KDLEN,KDATA, &
                            VALUES,CVALS,IRET)
         CASE( 21)
           CALL SECTIONS01234(REPORT,KSEC0,KSEC1,KSEC2,KSEC3,KSEC4,IRET)
           CALL CONVERT_21(REPORT,KTDLEN,KTDLST,KDLEN,KDATA, &
                            VALUES,CVALS,IRET)
         CASE( 51)
           CALL SECTIONS01234(REPORT,KSEC0,KSEC1,KSEC2,KSEC3,KSEC4,IRET)
           CALL CONVERT_51(REPORT,KTDLEN,KTDLST,KDLEN,KDATA, &
                            VALUES,CVALS,IRET)
         CASE( 75)
           CALL SECTIONS01234(REPORT,KSEC0,KSEC1,KSEC2,KSEC3,KSEC4,IRET)
           CALL CONVERT_75(REPORT,KTDLEN,KTDLST,KDLEN,KDATA, &
                           VALUES,CVALS,IRET)
         CASE( 82)
           CALL SECTIONS01234(REPORT,KSEC0,KSEC1,KSEC2,KSEC3,KSEC4,IRET)
           CALL CONVERT_82(REPORT,KTDLEN,KTDLST,KDLEN,KDATA, &
                           VALUES,CVALS,IRET)
         CASE( 91)
           CALL SECTIONS01234(REPORT,KSEC0,KSEC1,KSEC2,KSEC3,KSEC4,IRET)
           CALL CONVERT_91(REPORT,KTDLEN,KTDLST,KDLEN,KDATA, &
                           VALUES,CVALS,IRET)
         CASE(101)
           CALL SECTIONS01234(REPORT,KSEC0,KSEC1,KSEC2,KSEC3,KSEC4,IRET)
           CALL CONVERT_101(REPORT,KTDLEN,KTDLST,KDLEN,KDATA, &
                            VALUES,CVALS,IRET)
         CASE(142)
           CALL SECTIONS01234(REPORT,KSEC0,KSEC1,KSEC2,KSEC3,KSEC4,IRET)
           CALL CONVERT_142(REPORT,KTDLEN,KTDLST,KDLEN,KDATA, &
                            VALUES,CVALS,IRET)
         CASE(145)
           CALL SECTIONS01234(REPORT,KSEC0,KSEC1,KSEC2,KSEC3,KSEC4,IRET)
           CALL CONVERT_145(REPORT,KTDLEN,KTDLST,KDLEN,KDATA, &
                            VALUES,CVALS,IRET)
         CASE(164)
           CALL SECTIONS01234(REPORT,KSEC0,KSEC1,KSEC2,KSEC3,KSEC4,IRET)
           CALL CONVERT_164(REPORT,KTDLEN,KTDLST,KDLEN,KDATA, &
                            VALUES,CVALS,IRET)
         CASE DEFAULT
           PRINT*,' '
           PRINT*,'WARNING ++++ NO CONVERSION PERFORMED FOR SUBTYPE ', &
                   REPORT_SUBTYPE,' +++++'
           IRET=1
           RETURN
      END SELECT

      END SUBROUTINE BUFR_PACK

      SUBROUTINE SECTIONS01234(REPORT,KSEC0,KSEC1,KSEC2,KSEC3,KSEC4,IRET)
!
!
!**** *SECTIONS01234*
!
!
!     PURPOSE.
!     --------
!
!           FILL IN DATA NEEDED FOR BUFR SECTIONS 1 TO 4
!
!
!**   INTERFACE.
!     ----------
!
!           CALL SECTIONS01234(REPORT,KSEC0,KSEC1,KSEC2,KSEC3,KSEC4,IRET)*
!
!     METHOD.
!     -------
!
!
!           NONE.
!
!
!     EXTERNALS.
!     ----------
!
!
!
!     REFERENCE.
!     ----------
!
!
!
!     AUTHOR.
!     -------
!
!          M. DRAGOSAVAC    *ECMWF*       MAY  1996
!
!
!     MODIFICATIONS.
!     --------------
!
!          NONE.
!---------------------------------------------------------------------------

      IMPLICIT NONE

      INTEGER  I,YEAR,MONTH,DAY,HOUR,MINUTE,SECOND, DATE
      REAL,    DIMENSION(:), INTENT(INOUT)   :: REPORT
      INTEGER, DIMENSION(:), INTENT (INOUT) :: KSEC0
      INTEGER, DIMENSION(:), INTENT (INOUT) :: KSEC1
      INTEGER, DIMENSION(:), INTENT (INOUT) :: KSEC2
      INTEGER, DIMENSION(:), INTENT (INOUT) :: KSEC3
      INTEGER, DIMENSION(:), INTENT (INOUT) :: KSEC4
      INTEGER,               INTENT (INOUT) :: IRET

      INTEGER, DIMENSION(46) :: KEY
      INTEGER  BUFR_TYPE,RDB_TYPE,RDB_SUBTYPE
      INTEGER  REPORT_SUBTYPE

      CALL OBSDATE(NINT(REPORT(7)),YEAR,MONTH,DAY) 
      CALL OBSTIME(NINT(REPORT(8)),HOUR,MINUTE,SECOND)

      REPORT_SUBTYPE=NINT(REPORT(3))

      SELECT CASE (REPORT_SUBTYPE)
         CASE(  1)
            BUFR_TYPE=0
            RDB_TYPE=1
            RDB_SUBTYPE=1
         CASE(  11)
            BUFR_TYPE=1
            RDB_TYPE=1
            RDB_SUBTYPE=11
         CASE(  21)
            BUFR_TYPE=1
            RDB_TYPE=1
            RDB_SUBTYPE=21
         CASE( 51)
            BUFR_TYPE=3
            RDB_TYPE=2
            RDB_SUBTYPE=51
         CASE( 75)
            BUFR_TYPE=3
            RDB_TYPE=2
            RDB_SUBTYPE=75
         CASE( 82)
            BUFR_TYPE=5
            RDB_TYPE=3
            RDB_SUBTYPE=82
         CASE( 91)
            BUFR_TYPE=2
            RDB_TYPE=4
            RDB_SUBTYPE=91
         CASE( 92)
            BUFR_TYPE=2
            RDB_TYPE=4
            RDB_SUBTYPE=92
         CASE(101)
            BUFR_TYPE=2
            RDB_TYPE=5
            RDB_SUBTYPE=101
         CASE(102)
            BUFR_TYPE=2
            RDB_TYPE=5
            RDB_SUBTYPE=102
         CASE(142)
            BUFR_TYPE=4
            RDB_TYPE=7
            RDB_SUBTYPE=142
         CASE(145)
            BUFR_TYPE=4
            RDB_TYPE=7
            RDB_SUBTYPE=145
         CASE(164)
            BUFR_TYPE=253
            RDB_TYPE=253
            RDB_SUBTYPE=164
         CASE DEFAULT
            PRINT*,' '
            PRINT*,'WARNING +++++ NOT SUPPORTED SUBTYPE ',  &
                    REPORT_SUBTYPE,' +++++'
            IRET=1
            RETURN
      END SELECT


      KSEC0(1)=0
      KSEC0(2)=0
      KSEC0(3)=3

      KSEC1(1)=18
      KSEC1(2)=3
      KSEC1(3)=98
      KSEC1(4)=1
      KSEC1(5)=128
      KSEC1(6)=BUFR_TYPE
      KSEC1(7)=RDB_SUBTYPE
      KSEC1(8)=1
      KSEC1(9)=YEAR-1900
      KSEC1(10)=MONTH
      KSEC1(11)=DAY
      KSEC1(12)=HOUR
      KSEC1(13)=MINUTE
      KSEC1(14)=0
      KSEC1(15)=6
      KSEC1(16)=0

      KSEC2( 1)=52

      KSEC3( 1)=0
      KSEC3( 2)=0
      KSEC3( 3)=1
      KSEC3( 4)=128

      KSEC4( 1)=0
      KSEC4( 2)=0

      DO I=1,46
        KEY(I)=0
      END DO

      KEY( 1)=52
      KEY( 2)=RDB_TYPE
      KEY( 3)=RDB_SUBTYPE
      KEY( 4)=YEAR
      KEY( 5)=MONTH
      KEY( 6)=DAY
      KEY( 7)=HOUR
      KEY( 8)=MINUTE
      KEY( 9)=SECOND
      KEY(10)=REPORT(5)*100000+18000000
      KEY(11)=REPORT(4)*100000+9000000
      KEY(12)=KEY(10)
      KEY(13)=KEY(11)
      KEY(14)=1
      IF(RDB_SUBTYPE >= 51 .AND. RDB_SUBTYPE <= 85) THEN
         KEY(15)=999
      ELSE
         KEY(15)=0
      END IF
      IF(RDB_SUBTYPE >=  9 .AND. RDB_SUBTYPE <=  19 .OR.   &
         RDB_SUBTYPE >=142 .AND. RDB_SUBTYPE <= 145 .OR.   &
         RDB_SUBTYPE == 92 .OR.  RDB_SUBTYPE == 102 .OR.   &
         RDB_SUBTYPE == 164 ) THEN
         KEY(16)=83       ! S
         KEY(17)=73       ! I
         KEY(18)=77       ! M
         KEY(19)=85       ! U
         KEY(20)=76       ! L
         KEY(21)=65       ! A
         KEY(22)=84       ! T
         KEY(23)=69       ! E
         KEY(24)=32
      ELSE 
         KEY(16)=57
         KEY(17)=57
         KEY(18)=50
         KEY(19)=53
         KEY(20)=52
         KEY(21)=32
         KEY(22)=32
         KEY(23)=32
         KEY(24)=32
      END IF
      KEY(25)=0
     


      IRET=0
      CALL BUPKEY(KEY,KSEC1,KSEC2,IRET)
      IF(IRET /= 0) THEN
         PRINT*,'ERROR PACKING KEY'
         RETURN
      END IF

      END SUBROUTINE SECTIONS01234




      SUBROUTINE CONVERT_1(REPORT,KTDLEN,KTDLST,KDLEN,KDATA,VALUES,CVALS,IRET)
!**** *CONVERT_1*
!
!
!     PURPOSE.
!     --------
!
!           CREATES BUFR TEMPLATE FOR SYNOP LAND DATA
!
!
!**   INTERFACE.
!     ----------
!
!           CALL CONVERT_1(REPORT,KTDLEN,KTDLST,KDLEN,KDATA,VALUES,CVALS,IRET)
!
!     METHOD.
!     -------
!
!           NONE.
!
!
!
!     EXTERNALS.
!     ----------
!
!           NONE.
!
!     REFERENCE.
!     ----------
!
!           NONE.
!
!     AUTHOR.
!     -------
!
!          M. DRAGOSAVAC    *ECMWF*       
!
!
!     MODIFICATIONS.
!     --------------
!
!          NONE.
!---------------------------------------------------------------------------

      IMPLICIT NONE

      INTEGER YEAR,MONTH,DAY,HOUR,MINUTE,SECOND,I
      REAL, PARAMETER :: MISSING_VALUE=1.7E38

      REAL,    DIMENSION(:), INTENT(INOUT)  :: REPORT
      INTEGER,               INTENT(OUT) :: KTDLEN 
      INTEGER, DIMENSION(:), INTENT(OUT) :: KTDLST
      INTEGER,               INTENT(OUT) :: KDLEN
      INTEGER, DIMENSION(:), INTENT(OUT) :: KDATA
      REAL*8,    DIMENSION(:), INTENT(OUT) :: VALUES
      CHARACTER(*), DIMENSION(:), INTENT(OUT) :: CVALS
      INTEGER,               INTENT(OUT) :: IRET
      REAL*8 , PARAMETER ::EPS=10D-8
      INTEGER IV

!     INITIALIZE ARRAYS
!     -----------------

      DO I=1,SIZE(VALUES) 
        VALUES(I)=MISSING_VALUE
      END DO

      DO I=1,SIZE(CVALS)
        CVALS(I)=' '
      END DO

      DO I=1,1360
        IF(ABS(REPORT(I)-(-99999.)) < EPS) THEN
           REPORT(I)=MISSING_VALUE
        END IF
      END DO

!     SET LIST OF DATA DESCRIPTORS FOR SECTION 3
!     ------------------------------------------
      KTDLST(1)=307005
      KTDLST(2)=013023
      KTDLST(3)=013013
      KTDLST(4)=222000
      KTDLST(5)=101049
      KTDLST(6)=031031
      KTDLST(7)=001031
      KTDLST(8)=001032
      KTDLST(9)=101049
      KTDLST(10)=033007

      KTDLEN=10

!     SET DELAYED REPLICATION FACTORS IF ANY.
!     ---------------------------------------

      KDLEN=1
      KDATA(1)=0

!     SET VALUES FOR SYNOP OBSERVATION
!     --------------------------------


      CALL OBSDATE(NINT(REPORT(7)),YEAR,MONTH,DAY)
      CALL OBSTIME(NINT(REPORT(8)),HOUR,MINUTE,SECOND)

      VALUES(  1)=99                      ! BLOCK
      VALUES(  2)=254                     ! STATION
      VALUES(  4)=FLOAT(YEAR)               ! YEAR
      VALUES(  5)=FLOAT(MONTH)                   ! MONTH
      VALUES(  6)=FLOAT(DAY)                     ! DAY
      VALUES(  7)=FLOAT(HOUR)
      VALUES(  8)=FLOAT(MINUTE)
      VALUES(  9)=REPORT(4)               ! LATITUDE
      VALUES( 10)=REPORT(5)               ! LONGITUDE
      VALUES( 11)=REPORT(6)               ! STATION HEIGHT
      VALUES( 12)=REPORT(11)              ! PRESSURE
      VALUES( 13)=REPORT(12)              ! MSL PRESSURE
      VALUES( 16)=REPORT(13)              ! WIND DIRECTION
      VALUES( 17)=REPORT(14)              ! WIND SPEED
      VALUES( 18)=REPORT(16)              ! T
      VALUES( 19)=REPORT(17)              ! TD
      VALUES(50)=222000.

      IV=50
      DO I=1,49
        IV=IV+1
        VALUES(IV)=0.
      END DO
      
      VALUES(100)=98.
      VALUES(101)=1.

      IV=101
      DO I=1,49
        IV=IV+1
        VALUES(IV)=70.
      END DO
      
      END SUBROUTINE CONVERT_1
 
      SUBROUTINE CONVERT_11(REPORT,KTDLEN,KTDLST,KDLEN,KDATA,VALUES,CVALS,IRET)
!**** *CONVERT_11*
!
!
!     PURPOSE.
!     --------
!
!            SET UP SYNOP SHIP TEMPLATE.
!
!
!**   INTERFACE.
!     ----------
!
!              CALL CONVERT_11(REPORT,KTDLEN,KTDLST,KDLEN,KDATA,
!                              VALUES,CVALS,IRET)
!
!     METHOD.
!     -------
!
!
!           NONE.
!
!
!     EXTERNALS.
!     ----------
!
!           NONE.
!
!     REFERENCE.
!     ----------
!
!           NONE.
!
!     AUTHOR.
!     -------
!
!          M. DRAGOSAVAC    *ECMWF*       
!
!
!     MODIFICATIONS.
!     --------------
!
!          NONE.
!---------------------------------------------------------------------------

      IMPLICIT NONE

      INTEGER YEAR,MONTH,DAY,HOUR,MINUTE,SECOND,I
      REAL*8, PARAMETER :: MISSING_VALUE=1.7D38

      REAL,    DIMENSION(:), INTENT(INOUT)  :: REPORT
      INTEGER,               INTENT(OUT) :: KTDLEN
      INTEGER, DIMENSION(:), INTENT(OUT) :: KTDLST
      INTEGER,               INTENT(OUT) :: KDLEN
      INTEGER, DIMENSION(:), INTENT(OUT) :: KDATA
      REAL*8,    DIMENSION(:), INTENT(OUT) :: VALUES
      CHARACTER(*), DIMENSION(:), INTENT(OUT) :: CVALS
      INTEGER,               INTENT(OUT) :: IRET
      REAL*8 , PARAMETER ::EPS=10D-8
      INTEGER IV

!     INITIALIZE ARRAYS
!     -----------------


      DO I=1,SIZE(VALUES)
        VALUES(I)=MISSING_VALUE
      END DO

      DO I=1,SIZE(CVALS)
        CVALS(I)=' '
      END DO


      DO I=1,1360
        IF(ABS(REPORT(I)-(-99999.)) < EPS) THEN
           REPORT(I)=MISSING_VALUE
        END IF
      END DO


!     SET LIST OF DATA DESCRIPTORS FOR SECTION 3
!     ------------------------------------------


      KTDLST(1)=308004
      KTDLST(2)=012005
      KTDLST(3)=222000
      KTDLST(4)=101033
      KTDLST(5)=031031
      KTDLST(6)=001031
      KTDLST(7)=001032
      KTDLST(8)=101033
      KTDLST(9)=033007


      KTDLEN=9

!     SET DELAYED REPLICATION FACTORS IF ANY.
!     ---------------------------------------

      KDLEN=1
      KDATA(1)=0

!     SET VALUES FOR SYNOP SHIP OBSERVATION
!     -------------------------------------


      CALL OBSDATE(NINT(REPORT(7)),YEAR,MONTH,DAY)
      CALL OBSTIME(NINT(REPORT(8)),HOUR,MINUTE,SECOND)


      VALUES( 1)=1009.
      CVALS(  1)='SIMULATE'
      VALUES( 5)=YEAR
      VALUES( 6)=MONTH
      VALUES( 7)=FLOAT(DAY)
      VALUES( 8)=HOUR
      VALUES( 9)=MINUTE
      VALUES(10)=REPORT(4)
      VALUES(11)=REPORT(5)
      VALUES(12)=REPORT(11)
      VALUES(16)=REPORT(13)
      VALUES(17)=REPORT(14)
      VALUES(18)=REPORT(16)
      VALUES(19)=REPORT(17)

      VALUES(34)=222000.

      IV=34
      DO I=1,33
        IV=IV+1
        VALUES(IV)=0.
      END DO

      VALUES(68)=98.
      VALUES(69)=1.

      IV=69
      DO I=1,33
        IV=IV+1
        VALUES(IV)=70.
      END DO
      END SUBROUTINE CONVERT_11


      SUBROUTINE CONVERT_21(REPORT,KTDLEN,KTDLST,KDLEN,KDATA, &
                             VALUES,CVALS,IRET)
!**** *CONVERT_21*
!
!
!     PURPOSE.
!     --------
!
! 
!
!
!**   INTERFACE.
!     ----------
!
!
!     METHOD.
!     -------
!
!
!
!
!
!     EXTERNALS.
!     ----------
!
!
!
!     REFERENCE.
!     ----------
!
!
!
!     AUTHOR.
!     -------
!
!          M. DRAGOSAVAC    *ECMWF*       
!
!
!     MODIFICATIONS.
!     --------------
!
!          NONE.
!---------------------------------------------------------------------------

      IMPLICIT NONE

      INTEGER YEAR,MONTH,DAY,HOUR,MINUTE,SECOND,I
      REAL*8, PARAMETER :: MISSING_VALUE=1.7D38

      REAL,    DIMENSION(:), INTENT(INOUT)  :: REPORT
      INTEGER,               INTENT(OUT) :: KTDLEN
      INTEGER, DIMENSION(:), INTENT(OUT) :: KTDLST
      INTEGER,               INTENT(OUT) :: KDLEN
      INTEGER, DIMENSION(:), INTENT(OUT) :: KDATA
      REAL*8,    DIMENSION(:), INTENT(OUT) :: VALUES
      CHARACTER(*), DIMENSION(:), INTENT(OUT) :: CVALS
      INTEGER,               INTENT(OUT) :: IRET
      REAL*8 , PARAMETER ::EPS=10D-8
      INTEGER IV


!     INITIALIZE ARRAYS
!     -----------------


      DO I=1,SIZE(VALUES)
        VALUES(I)=MISSING_VALUE
      END DO

      DO I=1,SIZE(CVALS)
        CVALS(I)=' '
      END DO

      DO I=1,1360
        IF(ABS(REPORT(I)-(-99999.)) < EPS) THEN
           REPORT(I)=MISSING_VALUE
        END IF
      END DO



!     SET LIST OF DATA DESCRIPTORS FOR SECTION 3
!     ------------------------------------------
      KTDLST(1)=308003
      KTDLST(2)=222000
      KTDLST(3)=101032
      KTDLST(4)=031031
      KTDLST(5)=001031
      KTDLST(6)=001032
      KTDLST(7)=101032
      KTDLST(8)=033007

      KTDLEN=8

!     SET DELAYED REPLICATION FACTORS IF ANY.
!     ---------------------------------------

      KDLEN=1
      KDATA(1)=0

!     SET VALUES FOR BUOY OBSERVATION
!     --------------------------------

      CALL OBSDATE(NINT(REPORT(7)),YEAR,MONTH,DAY)
      CALL OBSTIME(NINT(REPORT(8)),HOUR,MINUTE,SECOND)


      VALUES(  1)=99254                     ! BUOY/PLATFORM ID
      VALUES(  5)=YEAR               ! YEAR
      VALUES(  6)=MONTH                   ! MONTH
      VALUES(  7)=DAY                     ! DAY
      VALUES(  8)=FLOAT(HOUR)
      VALUES(  9)=FLOAT(MINUTE)
      VALUES( 10)=REPORT(4)               ! LATITUDE
      VALUES( 11)=REPORT(5)               ! LONGITUDE
      VALUES( 12)=REPORT(11)              ! PRESSURE
      VALUES( 13)=REPORT(12)              ! MSL PRESSURE
      VALUES( 16)=REPORT(13)              ! WIND DIRECTION
      VALUES( 17)=REPORT(14)              ! WIND SPEED
      VALUES( 18)=REPORT(16)              ! T
      VALUES( 19)=REPORT(17)              ! TD

      VALUES(33)=222000.
 
      IV=33
      DO I=1,32
        IV=IV+1
        VALUES(IV)=0.
      END DO

      VALUES(66)=98.
      VALUES(67)=1.

      IV=67
      DO I=1,32
        IV=IV+1
        VALUES(IV)=70.
      END DO

      END SUBROUTINE CONVERT_21





      SUBROUTINE CONVERT_51(REPORT,KTDLEN,KTDLST,KDLEN,KDATA, &
                             VALUES,CVALS,IRET)
!**** *CONVERT_51*
!
!
!     PURPOSE.
!     --------
!
! 
!
!
!**   INTERFACE.
!     ----------
!
!
!     METHOD.
!     -------
!
!
!
!
!
!     EXTERNALS.
!     ----------
!
!
!
!     REFERENCE.
!     ----------
!
!
!
!     AUTHOR.
!     -------
!
!          M. DRAGOSAVAC    *ECMWF*       
!
!
!     MODIFICATIONS.
!     --------------
!
!          NONE.
!---------------------------------------------------------------------------

      IMPLICIT NONE

      INTEGER YEAR,MONTH,DAY,HOUR,MINUTE,SECOND,I
      REAL*8, PARAMETER :: MISSING_VALUE=1.7D38

      REAL,    DIMENSION(:), INTENT(INOUT)  :: REPORT
      INTEGER,               INTENT(OUT) :: KTDLEN
      INTEGER, DIMENSION(:), INTENT(OUT) :: KTDLST
      INTEGER,               INTENT(OUT) :: KDLEN
      INTEGER, DIMENSION(:), INTENT(OUT) :: KDATA
      REAL*8,    DIMENSION(:), INTENT(OUT) :: VALUES
      CHARACTER(*), DIMENSION(:), INTENT(OUT) :: CVALS
      INTEGER,               INTENT(OUT) :: IRET
      REAL*8 , PARAMETER ::EPS=10D-8
      INTEGER IR,IV,IV0,CHANNEL_NUMBER,IC


!     INITIALIZE ARRAYS
!     -----------------


      DO I=1,SIZE(VALUES)
        VALUES(I)=MISSING_VALUE
      END DO

      DO I=1,SIZE(CVALS)
        CVALS(I)=' '
      END DO

      DO I=1,1360
        IF(ABS(REPORT(I)-(-99999.)) < EPS) THEN
           REPORT(I)=MISSING_VALUE
        END IF
      END DO



!     SET LIST OF DATA DESCRIPTORS FOR SECTION 3
!     ------------------------------------------
      KTDLST( 1)=001007
      KTDLST( 2)=004001
      KTDLST( 3)=004002
      KTDLST( 4)=004003
      KTDLST( 5)=004004
      KTDLST( 6)=004005
      KTDLST( 7)=004006
      KTDLST( 8)=005002
      KTDLST( 9)=006002
      KTDLST(10)=007022
      KTDLST(11)=002025
      KTDLST(12)=002022
      KTDLST(13)=027020
      KTDLST(14)=008003
      KTDLST(15)=015001
      KTDLST(16)=008003
      KTDLST(17)=010004
      KTDLST(18)=020010
      KTDLST(19)=008003
      KTDLST(20)=008012
      KTDLST(21)=010001
      KTDLST(22)=012061
      KTDLST(23)=010004
      KTDLST(24)=008003
      KTDLST(25)=103015
      KTDLST(26)=007004
      KTDLST(27)=007004
      KTDLST(28)=012007
      KTDLST(29)=008003
      KTDLST(30)=103003
      KTDLST(31)=007004
      KTDLST(32)=007004
      KTDLST(33)=013016
      KTDLST(34)=008003
      KTDLST(35)=101019
      KTDLST(36)=012062
      KTDLST(37)=201132
      KTDLST(38)=012062
      KTDLST(39)=201000
      KTDLST(40)=101007
      KTDLST(41)=012062
      KTDLST(42)=008003
      KTDLST(43)=010004
      KTDLST(44)=012001

      KTDLEN=44

!     SET DELAYED REPLICATION FACTORS IF ANY.
!     ---------------------------------------

      KDLEN=1
      KDATA(1)=0

!     SET VALUES FOR SYNOP OBSERVATION
!     --------------------------------

      CALL OBSDATE(NINT(REPORT(7)),YEAR,MONTH,DAY)
      CALL OBSTIME(NINT(REPORT(8)),HOUR,MINUTE,SECOND)


      VALUES( 1)=999
      VALUES( 2)=YEAR
      VALUES( 3)=MONTH
      VALUES( 4)=DAY
      VALUES( 5)=HOUR
      VALUES( 6)=MINUTE
      VALUES( 7)=SECOND
      VALUES( 8)=REPORT(4)
      VALUES( 9)=REPORT(5)
      VALUES(21)=REPORT(6)

      IV0=80
      IR=9
      IC=1
      DO I=1,NINT(REPORT(9))
        IR=IR+10
        IC=IC+10
        CHANNEL_NUMBER=NINT(REPORT(IC))
        IV=IV0+CHANNEL_NUMBER
        VALUES(IV)=REPORT(IR)
      END DO

      END SUBROUTINE CONVERT_51




      SUBROUTINE CONVERT_75(REPORT,KTDLEN,KTDLST,KDLEN,KDATA, &
                             VALUES,CVALS,IRET)
!**** *CONVERT_75*
!
!
!     PURPOSE.
!     --------
!
! 
!
!
!**   INTERFACE.
!     ----------
!
!
!     METHOD.
!     -------
!
!
!
!
!
!     EXTERNALS.
!     ----------
!
!
!
!     REFERENCE.
!     ----------
!
!
!
!     AUTHOR.
!     -------
!
!          M. DRAGOSAVAC    *ECMWF*       
!
!
!     MODIFICATIONS.
!     --------------
!
!          NONE.
!---------------------------------------------------------------------------

      IMPLICIT NONE

      INTEGER YEAR,MONTH,DAY,HOUR,MINUTE,SECOND,I
      REAL*8, PARAMETER :: MISSING_VALUE=1.7D38

      REAL,    DIMENSION(:), INTENT(INOUT)  :: REPORT
      INTEGER,               INTENT(OUT) :: KTDLEN
      INTEGER, DIMENSION(:), INTENT(OUT) :: KTDLST
      INTEGER,               INTENT(OUT) :: KDLEN
      INTEGER, DIMENSION(:), INTENT(OUT) :: KDATA
      REAL*8,    DIMENSION(:), INTENT(OUT) :: VALUES
      CHARACTER(*), DIMENSION(:), INTENT(OUT) :: CVALS
      INTEGER,               INTENT(OUT) :: IRET
      REAL*8 , PARAMETER ::EPS=10D-8
      INTEGER IV
      INTEGER IR

!     INITIALIZE ARRAYS
!     -----------------


      DO I=1,SIZE(VALUES)
        VALUES(I)=MISSING_VALUE
      END DO

      DO I=1,SIZE(CVALS)
        CVALS(I)=' '
      END DO

      DO I=1,1360
        IF(ABS(REPORT(I)-(-99999.)) < EPS) THEN
           REPORT(I)=MISSING_VALUE
        END IF
      END DO



!     SET LIST OF DATA DESCRIPTORS FOR SECTION 3
!     ------------------------------------------

      KTDLST( 1)=301042
      KTDLST( 2)=303031
      KTDLST( 3)=303032
      KTDLST( 4)=101015
      KTDLST( 5)=303023
      KTDLST( 6)=101003
      KTDLST( 7)=303024
      KTDLST( 8)=222000
      KTDLST( 9)=101108
      KTDLST( 10)=031031
      KTDLST( 11)=001031
      KTDLST( 12)=001032
      KTDLST( 13)=101108
      KTDLST( 14)=033007

      KTDLEN=14



!     SET DELAYED REPLICATION FACTORS IF ANY.
!     ---------------------------------------

      KDLEN=1
      KDATA(1)=0

!     SET VALUES FOR TOVS OBSERVATION
!     --------------------------------

      CALL OBSDATE(NINT(REPORT(7)),YEAR,MONTH,DAY)
      CALL OBSTIME(NINT(REPORT(8)),HOUR,MINUTE,SECOND)

      VALUES( 1)=999.
      VALUES( 4)=YEAR
      VALUES( 5)=MONTH
      VALUES( 6)=DAY
      VALUES( 7)=HOUR
      VALUES( 8)=MINUTE
      VALUES( 9)=REPORT(4)
      VALUES(10)=REPORT(5)

!     MEAN LAYER TEMPERATURES

      IV=19
      IR=11
      DO I=1,NINT(REPORT(9))

        IF(ABS(REPORT(IR+5)-MISSING_VALUE) > EPS) THEN
           VALUES(IV)=REPORT(IR)
           VALUES(IV+1)=REPORT(IR+1)
           VALUES(IV+4)=REPORT(IR+5)    ! T
        END IF

        IV=IV+5
        IR=IR+10

      END DO

!     PRECIPITABLE WATER

      IV=94
      IR=11
      DO I=1,NINT(REPORT(9))

        IF(ABS(REPORT(IR+7)-MISSING_VALUE) > EPS) THEN
           VALUES(IV)=REPORT(IR)
           VALUES(IV+1)=REPORT(IR+1)
           VALUES(IV+4)=REPORT(IR+7)    ! T
        END IF

        IV=IV+5
        IR=IR+10

      END DO

      VALUES(109)=222000.
      IV=109
      DO I=1,108
        IV=IV+1
        VALUES(IV)=0.
      END DO

      IV=IV+1
      VALUES(IV)=98.
      IV=IV+1
      VALUES(IV)=1.

      DO I=1,108
        IV=IV+1
        VALUES(IV)=70.
      END DO

      END SUBROUTINE CONVERT_75





      SUBROUTINE CONVERT_82(REPORT,KTDLEN,KTDLST,KDLEN,KDATA, &
                             VALUES,CVALS,IRET)
!**** *CONVERT_82*
!
!
!     PURPOSE.
!     --------
!
! 
!
!
!**   INTERFACE.
!     ----------
!
!
!     METHOD.
!     -------
!
!
!
!
!
!     EXTERNALS.
!     ----------
!
!
!
!     REFERENCE.
!     ----------
!
!
!
!     AUTHOR.
!     -------
!
!          M. DRAGOSAVAC    *ECMWF*       
!
!
!     MODIFICATIONS.
!     --------------
!
!          NONE.
!---------------------------------------------------------------------------

      IMPLICIT NONE

      INTEGER YEAR,MONTH,DAY,HOUR,MINUTE,SECOND,I
      REAL*8, PARAMETER :: MISSING_VALUE=1.7D38

      REAL,    DIMENSION(:), INTENT(INOUT)  :: REPORT
      INTEGER,               INTENT(OUT) :: KTDLEN
      INTEGER, DIMENSION(:), INTENT(OUT) :: KTDLST
      INTEGER,               INTENT(OUT) :: KDLEN
      INTEGER, DIMENSION(:), INTENT(OUT) :: KDATA
      REAL*8,    DIMENSION(:), INTENT(OUT) :: VALUES
      CHARACTER(*), DIMENSION(:), INTENT(OUT) :: CVALS
      INTEGER,               INTENT(OUT) :: IRET
      REAL*8 , PARAMETER ::EPS=10D-8
      INTEGER IV

!     INITIALIZE ARRAYS
!     -----------------


      DO I=1,SIZE(VALUES)
        VALUES(I)=MISSING_VALUE
      END DO

      DO I=1,SIZE(CVALS)
        CVALS(I)=' '
      END DO

      DO I=1,1360
        IF(ABS(REPORT(I)-(-99999.)) < EPS) THEN
           REPORT(I)=MISSING_VALUE
        END IF
      END DO



!     SET LIST OF DATA DESCRIPTORS FOR SECTION 3
!     ------------------------------------------

      KTDLST(1)=301043
      KTDLST(2)=304001
      KTDLST(3)=222000
      KTDLST(4)=101015
      KTDLST(5)=031031
      KTDLST(6)=001031
      KTDLST(7)=001032
      KTDLST(8)=101015
      KTDLST(9)=033007


      KTDLEN=9

!     SET DELAYED REPLICATION FACTORS IF ANY.
!     ---------------------------------------

      KDLEN=1
      KDATA(1)=0

!     SET VALUES FOR SATOB OBSERVATION
!     --------------------------------

      CALL OBSDATE(NINT(REPORT(7)),YEAR,MONTH,DAY)
      CALL OBSTIME(NINT(REPORT(8)),HOUR,MINUTE,SECOND)


      VALUES( 1)=999
      VALUES( 3)=YEAR
      VALUES( 4)=MONTH
      VALUES( 5)=DAY
      VALUES( 6)=HOUR
      VALUES( 7)=MINUTE
      VALUES( 8)=SECOND
      VALUES( 9)=REPORT(4)
      VALUES(10)=REPORT(5)
      VALUES(12)=REPORT(11)
      VALUES(13)=REPORT(16)
      VALUES(14)=REPORT(13)
      VALUES(15)=REPORT(14)

      VALUES(16)=222000.

      IV=16
      DO I=1,15
        IV=IV+1
        VALUES(IV)=0.
      END DO

      VALUES(32)=98.
      VALUES(33)=1.

      IV=33
      DO I=1,15
        IV=IV+1
        VALUES(IV)=70.
      END DO

      END SUBROUTINE CONVERT_82




      SUBROUTINE CONVERT_91(REPORT,KTDLEN,KTDLST,KDLEN,KDATA, &
                             VALUES,CVALS,IRET)
!**** *CONVERT_91*
!
!
!     PURPOSE.
!     --------
!
! 
!
!
!**   INTERFACE.
!     ----------
!
!
!     METHOD.
!     -------
!
!
!
!
!
!     EXTERNALS.
!     ----------
!
!
!
!     REFERENCE.
!     ----------
!
!
!
!     AUTHOR.
!     -------
!
!          M. DRAGOSAVAC    *ECMWF*       
!
!
!     MODIFICATIONS.
!     --------------
!
!          NONE.
!---------------------------------------------------------------------------

      IMPLICIT NONE

      INTEGER YEAR,MONTH,DAY,HOUR,MINUTE,SECOND,I
      REAL*8, PARAMETER :: MISSING_VALUE=1.7D38

      REAL,    DIMENSION(:), INTENT(INOUT)  :: REPORT
      INTEGER,               INTENT(OUT) :: KTDLEN
      INTEGER, DIMENSION(:), INTENT(OUT) :: KTDLST
      INTEGER,               INTENT(OUT) :: KDLEN
      INTEGER, DIMENSION(:), INTENT(OUT) :: KDATA
      REAL*8,    DIMENSION(:), INTENT(OUT) :: VALUES
      CHARACTER(*), DIMENSION(:), INTENT(OUT) :: CVALS
      INTEGER,               INTENT(OUT) :: IRET
      REAL*8 , PARAMETER ::EPS=10D-8
      INTEGER IV
      INTEGER IR

!     INITIALIZE ARRAYS
!     -----------------


      DO I=1,SIZE(VALUES)
        VALUES(I)=MISSING_VALUE
      END DO

      DO I=1,SIZE(CVALS)
        CVALS(I)=' '
      END DO

      DO I=1,1360
        IF(ABS(REPORT(I)-(-99999.)) < EPS) THEN
           REPORT(I)=MISSING_VALUE
        END IF
      END DO



!     SET LIST OF DATA DESCRIPTORS FOR SECTION 3
!     ------------------------------------------
      KTDLST( 1)=301001
      KTDLST( 2)=002011
      KTDLST( 3)=002012
      KTDLST( 4)=301011
      KTDLST( 5)=301012
      KTDLST( 6)=301022
      KTDLST( 7)=105000
      KTDLST( 8)=031001
      KTDLST( 9)=007004
      KTDLST(10)=008001
      KTDLST(11)=010003
      KTDLST(12)=011001
      KTDLST(13)=011002
      KTDLST(14)=222000
      KTDLST(15)=101000
      KTDLST(16)=031002
      KTDLST(17)=031031
      KTDLST(18)=001031
      KTDLST(19)=001032
      KTDLST(20)=101000
      KTDLST(21)=031002
      KTDLST(22)=033007

      KTDLEN=22

!     SET DELAYED REPLICATION FACTORS IF ANY.
!     ---------------------------------------

      KDLEN=3
      KDATA(1)=NINT(REPORT(9))
      KDATA(2)=NINT(REPORT(9))*5+13
      KDATA(3)=KDATA(2)

!     SET VALUES FOR PILOT OBSERVATION
!     --------------------------------

      CALL OBSDATE(NINT(REPORT(7)),YEAR,MONTH,DAY)
      CALL OBSTIME(NINT(REPORT(8)),HOUR,MINUTE,SECOND)


      VALUES( 1)=99
      VALUES( 2)=254
      VALUES(  5)=YEAR                                    ! YEAR
      VALUES(  6)=MONTH                                   ! MONTH
      VALUES(  7)=DAY                                     ! DAY
      VALUES(  8)=FLOAT(HOUR)                             ! HOUR
      VALUES(  9)=FLOAT(MINUTE)                           ! MINUTE
      VALUES( 10)=REPORT(4)                               ! LATITUDE
      VALUES( 11)=REPORT(5)                               ! LONGITUDE
      VALUES( 12)=REPORT(6)                               ! HEIGHT OF STATION
      VALUES( 13)=REPORT(9)                               ! REPLICATION


      IV=14
      IR=11
      DO I=1,NINT(REPORT(9))
        VALUES(IV)=REPORT(IR)       ! PRESSURE
        VALUES(IV+1)=32.
        IF(ABS(REPORT(IR+4)-MISSING_VALUE) > EPS) THEN
           VALUES(IV+2)=REPORT(IR+4)*9.80665 ! GEOPOTENTIAL
        END IF
        VALUES(IV+3)=REPORT(IR+2)         ! DD
        VALUES(IV+4)=REPORT(IR+3)         ! FF
        IV=IV+5
        IR=IR+10
      END DO

      IV=KDATA(2)+1
      IR=KDATA(2)


      VALUES(IV)=222000.

      VALUES(IV+1)=FLOAT(IR)
      IV=IV+1

      DO I=1,IR
        IV=IV+1
        VALUES(IV)=0.
      END DO

      IV=IV+1
      VALUES(IV)=98.
      IV=IV+1
      VALUES(IV)=1.
      IV=IV+1
      VALUES(IV)=FLOAT(IR)
     
      DO I=1,IR
        IV=IV+1
        VALUES(IV)=70.
      END DO

      END SUBROUTINE CONVERT_91




      SUBROUTINE CONVERT_101(REPORT,KTDLEN,KTDLST,KDLEN,KDATA, &
                             VALUES,CVALS,IRET)
!**** *CONVERT_101*
!
!
!     PURPOSE.
!     --------
!
! 
!
!
!**   INTERFACE.
!     ----------
!
!
!     METHOD.
!     -------
!
!
!
!
!
!     EXTERNALS.
!     ----------
!
!
!
!     REFERENCE.
!     ----------
!
!
!
!     AUTHOR.
!     -------
!
!          M. DRAGOSAVAC    *ECMWF*       
!
!
!     MODIFICATIONS.
!     --------------
!
!          NONE.
!---------------------------------------------------------------------------

      IMPLICIT NONE

      INTEGER YEAR,MONTH,DAY,HOUR,MINUTE,SECOND,I
      REAL*8, PARAMETER :: MISSING_VALUE=1.7D38

      REAL,    DIMENSION(:), INTENT(INOUT)  :: REPORT
      INTEGER,               INTENT(OUT) :: KTDLEN
      INTEGER, DIMENSION(:), INTENT(OUT) :: KTDLST
      INTEGER,               INTENT(OUT) :: KDLEN
      INTEGER, DIMENSION(:), INTENT(OUT) :: KDATA
      REAL*8,    DIMENSION(:), INTENT(OUT) :: VALUES
      CHARACTER(*), DIMENSION(:), INTENT(OUT) :: CVALS
      INTEGER,               INTENT(OUT) :: IRET
      REAL*8 , PARAMETER ::EPS=10D-8
      INTEGER IR
      INTEGER IV

!     INITIALIZE ARRAYS
!     -----------------


      DO I=1,SIZE(VALUES)
        VALUES(I)=MISSING_VALUE
      END DO

      DO I=1,SIZE(CVALS)
        CVALS(I)=' '
      END DO


      DO I=1,1360
        IF(ABS(REPORT(I)-(-99999.)) < EPS) THEN
           REPORT(I)=MISSING_VALUE
        END IF
      END DO


!     SET LIST OF DATA DESCRIPTORS FOR SECTION 3
!     ------------------------------------------
      KTDLST(1)=309007
      KTDLST(2)=222000
      KTDLST(3)=101000
      KTDLST(4)=031002
      KTDLST(5)=031031
      KTDLST(6)=001031
      KTDLST(7)=001032
      KTDLST(8)=101000
      KTDLST(9)=031002
      KTDLST(10)=033007
 

      KTDLEN=10

!     SET DELAYED REPLICATION FACTORS IF ANY.
!     ---------------------------------------

      KDATA(1)=NINT(REPORT(9))
      KDATA(2)=NINT(REPORT(9))*7+20
      KDATA(3)=KDATA(2)

      KDLEN=3

!     SET VALUES FOR TEMP  OBSERVATION
!     --------------------------------

      CALL OBSDATE(NINT(REPORT(7)),YEAR,MONTH,DAY)
      CALL OBSTIME(NINT(REPORT(8)),HOUR,MINUTE,SECOND)

      VALUES(  1)=99.
      VALUES(  2)=254.
      VALUES(  5)=YEAR                                    ! YEAR
      VALUES(  6)=MONTH                                   ! MONTH
      VALUES(  7)=FLOAT(DAY)                                     ! DAY
      VALUES(  8)=FLOAT(HOUR)                             ! HOUR
      VALUES(  9)=FLOAT(MINUTE)                           ! MINUTE
      VALUES( 10)=REPORT(4)                               ! LATITUDE
      VALUES( 11)=REPORT(5)                               ! LONGITUDE
      VALUES( 12)=REPORT(6)                               ! HEIGHT OF STATION
      VALUES( 20)=REPORT(9)                               ! REPLICATION


      IV=21
      IR=11
      DO I=1,NINT(REPORT(9))
        VALUES(IV)=REPORT(IR)       ! PRESSURE
        VALUES(IV+1)=32.
        IF(ABS(REPORT(IR+4)-MISSING_VALUE) > EPS) THEN
           VALUES(IV+2)=REPORT(IR+4)*9.80665 ! GEOPOTENTIAL
        END IF
        VALUES(IV+3)=REPORT(IR+5)         ! T
        VALUES(IV+4)=REPORT(IR+6)         ! TD
        VALUES(IV+5)=REPORT(IR+2)         ! DD
        VALUES(IV+6)=REPORT(IR+3)         ! FF
        IV=IV+7
        IR=IR+10
      END DO

      IV=KDATA(2)+1
      IR=KDATA(2)


      VALUES(IV)=222000.

      VALUES(IV+1)=FLOAT(IR)
      IV=IV+1

      DO I=1,IR
        IV=IV+1
        VALUES(IV)=0.
      END DO

      IV=IV+1
      VALUES(IV)=98.
      IV=IV+1
      VALUES(IV)=1.
      IV=IV+1
      VALUES(IV)=FLOAT(IR)

      DO I=1,IR
        IV=IV+1
        VALUES(IV)=70.
      END DO



      END SUBROUTINE CONVERT_101




      SUBROUTINE CONVERT_142(REPORT,KTDLEN,KTDLST,KDLEN,KDATA, &
                             VALUES,CVALS,IRET)
!**** *CONVERT_142*
!
!
!     PURPOSE.
!     --------
!
! 
!
!
!**   INTERFACE.
!     ----------
!
!
!     METHOD.
!     -------
!
!
!
!
!
!     EXTERNALS.
!     ----------
!
!
!
!     REFERENCE.
!     ----------
!
!
!
!     AUTHOR.
!     -------
!
!          M. DRAGOSAVAC    *ECMWF*       
!
!
!     MODIFICATIONS.
!     --------------
!
!          NONE.
!---------------------------------------------------------------------------

      IMPLICIT NONE

      INTEGER YEAR,MONTH,DAY,HOUR,MINUTE,SECOND,I
      REAL*8, PARAMETER :: MISSING_VALUE=1.7D38

      REAL,    DIMENSION(:), INTENT(INOUT)  :: REPORT
      INTEGER,               INTENT(OUT) :: KTDLEN
      INTEGER, DIMENSION(:), INTENT(OUT) :: KTDLST
      INTEGER,               INTENT(OUT) :: KDLEN
      INTEGER, DIMENSION(:), INTENT(OUT) :: KDATA
      REAL*8,    DIMENSION(:), INTENT(OUT) :: VALUES
      CHARACTER(*), DIMENSION(:), INTENT(OUT) :: CVALS
      INTEGER,               INTENT(OUT) :: IRET
      REAL*8 , PARAMETER ::EPS=10D-8
      INTEGER IV

!     INITIALIZE ARRAYS
!     -----------------


      DO I=1,SIZE(VALUES)
        VALUES(I)=MISSING_VALUE
      END DO

      DO I=1,SIZE(CVALS)
        CVALS(I)=' '
      END DO

      DO I=1,1360
        IF(ABS(REPORT(I)-(-99999.)) < EPS) THEN
           REPORT(I)=MISSING_VALUE
        END IF
      END DO


!     SET LIST OF DATA DESCRIPTORS FOR SECTION 3
!     ------------------------------------------
      KTDLST(1)=311001
      KTDLST(2)=222000
      KTDLST(3)=101018
      KTDLST(4)=031031
      KTDLST(5)=001031
      KTDLST(6)=001032
      KTDLST(7)=101018
      KTDLST(8)=033007


      KTDLEN=8

!     SET DELAYED REPLICATION FACTORS IF ANY.
!     ---------------------------------------

      KDLEN=1
      KDATA(1)=0

!     SET VALUES FOR AIREP OBSERVATION
!     --------------------------------

      CALL OBSDATE(NINT(REPORT(7)),YEAR,MONTH,DAY)
      CALL OBSTIME(NINT(REPORT(8)),HOUR,MINUTE,SECOND)


      VALUES( 1)=1008.
      CVALS( 1)='SIMULATE' 
      VALUES(3)=YEAR
      VALUES(4)=MONTH
      VALUES(5)=DAY
      VALUES(6)=HOUR
      VALUES(7)=MINUTE
      VALUES(8)=REPORT(4)
      VALUES(9)=REPORT(5)
      VALUES(11)=REPORT(6)
      VALUES(12)=REPORT(16)
      VALUES(13)=REPORT(13)
      VALUES(14)=REPORT(14)

      VALUES(19)=222000.

      IV=19
      DO I=1,18
        IV=IV+1
        VALUES(IV)=0.
      END DO

      VALUES(38)=98.
      VALUES(39)=1.

      IV=39
      DO I=1,18
        IV=IV+1
        VALUES(IV)=70.
      END DO

      END SUBROUTINE CONVERT_142





      SUBROUTINE CONVERT_145(REPORT,KTDLEN,KTDLST,KDLEN,KDATA, &
                             VALUES,CVALS,IRET)
!**** *CONVERT_145
!
!
!     PURPOSE.
!     --------
!
! 
!
!
!**   INTERFACE.
!     ----------
!
!
!     METHOD.
!     -------
!
!
!
!
!
!     EXTERNALS.
!     ----------
!
!
!
!     REFERENCE.
!     ----------
!
!
!
!     AUTHOR.
!     -------
!
!          M. DRAGOSAVAC    *ECMWF*       
!
!
!     MODIFICATIONS.
!     --------------
!
!          NONE.
!---------------------------------------------------------------------------

      IMPLICIT NONE

      INTEGER YEAR,MONTH,DAY,HOUR,MINUTE,SECOND,I
      REAL*8, PARAMETER :: MISSING_VALUE=1.7D38

      REAL,    DIMENSION(:), INTENT(INOUT)  :: REPORT
      INTEGER,               INTENT(OUT) :: KTDLEN
      INTEGER, DIMENSION(:), INTENT(OUT) :: KTDLST
      INTEGER,               INTENT(OUT) :: KDLEN
      INTEGER, DIMENSION(:), INTENT(OUT) :: KDATA
      REAL*8,    DIMENSION(:), INTENT(OUT) :: VALUES
      CHARACTER(*), DIMENSION(:), INTENT(OUT) :: CVALS
      INTEGER,               INTENT(OUT) :: IRET
      REAL*8 , PARAMETER ::EPS=10D-8

!     INITIALIZE ARRAYS
!     -----------------


      DO I=1,SIZE(VALUES)
        VALUES(I)=MISSING_VALUE
      END DO

      DO I=1,SIZE(CVALS)
        CVALS(I)=' '
      END DO

      DO I=1,1360
        IF(ABS(REPORT(I)-(-99999.)) < EPS) THEN
           REPORT(I)=MISSING_VALUE
        END IF
      END DO


!     SET LIST OF DATA DESCRIPTORS FOR SECTION 3
!     ------------------------------------------
      KTDLST( 1)=001006
      KTDLST( 2)=001008
      KTDLST( 3)=002061
      KTDLST( 4)=002062
      KTDLST( 5)=002002
      KTDLST( 6)=002005
      KTDLST( 7)=002070
      KTDLST( 8)=002063
      KTDLST( 9)=002001
      KTDLST(10)=004001
      KTDLST(11)=004002
      KTDLST(12)=004003
      KTDLST(13)=004004
      KTDLST(14)=004005
      KTDLST(15)=005002
      KTDLST(16)=006002
      KTDLST(17)=008004
      KTDLST(18)=007004
      KTDLST(19)=008021
      KTDLST(20)=011001
      KTDLST(21)=011002
      KTDLST(22)=011031
      KTDLST(23)=011034
      KTDLST(24)=011035
      KTDLST(25)=012001
      KTDLST(26)=012003
      KTDLST(27)=013003
      KTDLST(28)=020041
      

      KTDLEN=28

!     SET DELAYED REPLICATION FACTORS IF ANY.
!     ---------------------------------------

      KDLEN=1
      KDATA(1)=0

!     SET VALUES FOR  ACAR OBSERVATION
!     --------------------------------

      CALL OBSDATE(NINT(REPORT(7)),YEAR,MONTH,DAY)
      CALL OBSTIME(NINT(REPORT(8)),HOUR,MINUTE,SECOND)


      VALUES( 1)=1008.
      CVALS(1)='SIMULATE'
      VALUES(2)=2008.
      CVALS(2)='SIMULATE'
      VALUES(10)=YEAR
      VALUES(11)=MONTH
      VALUES(12)=DAY
      VALUES(13)=HOUR
      VALUES(14)=MINUTE
      VALUES(15)=REPORT(4)
      VALUES(16)=REPORT(5)
      VALUES(18)=REPORT(11)
      VALUES(20)=REPORT(13)
      VALUES(21)=REPORT(14)
      VALUES(25)=REPORT(16)
      VALUES(26)=REPORT(17)


      END SUBROUTINE CONVERT_145




      SUBROUTINE CONVERT_164(REPORT,KTDLEN,KTDLST,KDLEN,KDATA, &
                             VALUES,CVALS,IRET)
!**** *CONVERT_164*
!
!
!     PURPOSE.
!     --------
!
! 
!
!
!**   INTERFACE.
!     ----------
!
!
!     METHOD.
!     -------
!
!
!
!
!
!     EXTERNALS.
!     ----------
!
!
!
!     REFERENCE.
!     ----------
!
!
!
!     AUTHOR.
!     -------
!
!          M. DRAGOSAVAC    *ECMWF*       
!
!
!     MODIFICATIONS.
!     --------------
!
!          NONE.
!---------------------------------------------------------------------------

      IMPLICIT NONE

      INTEGER YEAR,MONTH,DAY,HOUR,MINUTE,SECOND,I
      REAL*8, PARAMETER :: MISSING_VALUE=1.7D38

      REAL,    DIMENSION(:), INTENT(INOUT)  :: REPORT
      INTEGER,               INTENT(OUT) :: KTDLEN
      INTEGER, DIMENSION(:), INTENT(OUT) :: KTDLST
      INTEGER,               INTENT(OUT) :: KDLEN
      INTEGER, DIMENSION(:), INTENT(OUT) :: KDATA
      REAL*8,    DIMENSION(:), INTENT(OUT) :: VALUES
      CHARACTER(*), DIMENSION(:), INTENT(OUT) :: CVALS
      INTEGER,               INTENT(OUT) :: IRET
      REAL*8 , PARAMETER ::EPS=10D-8
      INTEGER IV

!     INITIALIZE ARRAYS
!     -----------------

      DO I=1,SIZE(VALUES)
        VALUES(I)=MISSING_VALUE
      END DO

      DO I=1,SIZE(CVALS)
        CVALS(I)=' '
      END DO

      DO I=1,1360
        IF(ABS(REPORT(I)-(-99999.)) < EPS) THEN
           REPORT(I)=MISSING_VALUE
        END IF
      END DO


!     SET LIST OF DATA DESCRIPTORS FOR SECTION 3
!     ------------------------------------------
      KTDLST(1)=301011
      KTDLST(2)=301012
      KTDLST(3)=301021
      KTDLST(4)=010051
      KTDLST(5)=007004
      KTDLST(6)=007004
      KTDLST(7)=012007
      KTDLST(8)=222000
      KTDLST(9)=101011
      KTDLST(10)=031031
      KTDLST(11)=001031
      KTDLST(12)=001032
      KTDLST(13)=101011
      KTDLST(14)=033007


      KTDLEN=14

!     SET DELAYED REPLICATION FACTORS IF ANY.
!     ---------------------------------------

      KDLEN=1
      KDATA(1)=0

!     SET VALUES FOR PAOB OBSERVATION
!     -------------------------------

      CALL OBSDATE(NINT(REPORT(7)),YEAR,MONTH,DAY)
      CALL OBSTIME(NINT(REPORT(8)),HOUR,MINUTE,SECOND)


      VALUES(  1)=YEAR
      VALUES(  2)=MONTH
      VALUES(  3)=DAY
      VALUES(  4)=HOUR
      VALUES(  5)=MINUTE
      VALUES(  6)=REPORT(4)
      VALUES(  7)=REPORT(5)
      VALUES(  8)=REPORT(11)
      
      VALUES(12)=222000.

      IV=12
      DO I=1,12
        IV=IV+1
        VALUES(IV)=0.
      END DO

      VALUES(24)=98.
      VALUES(25)=1.

      IV=25
      DO I=1,12
        IV=IV+1
        VALUES(IV)=70.
      END DO
      END SUBROUTINE CONVERT_164


      SUBROUTINE OBSDATE(DATE,YEAR,MONTH,DAY)

      INTEGER DATE,OFFSET

      INTEGER YEAR,MONTH,DAY

      YEAR=DATE/10000
      OFFSET=DATE-YEAR*10000
      MONTH=OFFSET/100
      DAY=OFFSET-MONTH*100

      END SUBROUTINE OBSDATE

      SUBROUTINE OBSTIME(TIME,HOUR,MINUTE,SECOND)
      INTEGER TIME,HOUR,MINUTE,SECOND,OFFSET

      HOUR=TIME/10000
      OFFSET=TIME-HOUR*10000
      MINUTE=OFFSET/100
      SECOND=OFFSET-MINUTE*100
      END SUBROUTINE OBSTIME


   END PROGRAM BUFR_SIMULATE

C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      INTEGER FUNCTION JNUMGGQ( KNUM, KPTS)
C
C---->
C**** JNUMGGQ
C
C     PURPOSE
C     -------
C
C     This routine returns the number of points in each latitude of 
C     a gaussian grid.
C
C
C     INTERFACE
C     ---------
C
C     CALL JNUMGGQ( KNUM, KPTS)
C
C
C     Input parameters
C     ----------------
C
C     KNUM - Gaussian grid number
C
C
C     Output parameters
C     -----------------
C
C     KPTS - Array giving number of points at each gaussian latitude 
C            (both hemispheres)
C
C     Returns 0 if OK, otherwise passes the return status from JNUMGG
C
C
C     Common block usage
C     ------------------
C
C     None.
C
C
C     Method
C     ------
C
C     Simplified interface to JNUMGG. 
C
C
C     Externals
C     ---------
C
C     JGETGG - Get the gaussian grid definition. 
C
C
C     Reference
C     ---------
C
C     None
C
C
C     Comments
C     --------
C
C     None
C
C
C     Author
C     ------
C
C     J.D.Chambers      *ECMWF*      January 2002
C
C
C     Modifications
C     -------------
C
C     None.
C
C----<
C
      IMPLICIT NONE
#include "jparams.h"
#include "parim.h"
C
C     Subroutine arguments
C
      INTEGER KNUM, KPTS
      DIMENSION KPTS(KNUM*2)
C
C     Local variables
C
      CHARACTER*1 HTYPE
      INTEGER KRET
C
C     -----------------------------------------------------------------|
C*    Section 1.    Get the information.
C     -----------------------------------------------------------------|
C
  100 CONTINUE
C
      HTYPE = 'R'
      CALL JNUMGG( KNUM, HTYPE, KPTS, KRET)
C
C     -----------------------------------------------------------------|
C*    Section 9. Return to calling routine. Format statements
C     -----------------------------------------------------------------|
C
 900  CONTINUE
C
      JNUMGGQ = KRET
C
      RETURN
      END

C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C


      SUBROUTINE MODVAL   (LENIN,LENOUT,MULT)
C
C---->
C*                                                                    *
C*    NAME      : MODVAL                                              *
C*                                                                    *
C*    FUNCTION  : MAKES ONE VALUE A MULTIPLE OF ANOTHER.              *
C*                                                                    *
C*    INPUT     : LENIN = INPUT  VALUE                                *
C*                MULT  = MODULO VALUE                                *
C*                                                                    *
C*    OUTPUT    : LENOUT= OUTPUT VALUE                                *
C*                                                                    *
C*    GENERAL   : MODVAL CALLS  MOD                                   *
C*                              ABS                                   *
C*                                                                    *
C*    AUTHOR    : B.V. GURETZKY    V.E. DAY                           *
C*                                                                    *
C*    MODIFIED  : J. HENNESSY      25.11.85                           *
C*                                                                    *
C*                                                                    *
C     ---------------------------------------------------------------
C----<
C
      LENG  = ABS (MULT)
      INTER = MOD (ABS(LENIN),LENG)
C
      IF (INTER.NE.0)
     C   THEN
             LENG = LENG - INTER
             IF (LENIN.LT.0)
     C           THEN
                     LENOUT = LENIN - LENG
                 ELSE
                     LENOUT = LENIN + LENG
                 ENDIF
         ELSE
             LENOUT = LENIN
         ENDIF
C
C
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C


      SUBROUTINE MODVAL   (LENIN,LENOUT,MULT)
C
C---->
C*                                                                    *
C*    NAME      : MODVAL                                              *
C*                                                                    *
C*    FUNCTION  : MAKES ONE VALUE A MULTIPLE OF ANOTHER.              *
C*                                                                    *
C*    INPUT     : LENIN = INPUT  VALUE                                *
C*                MULT  = MODULO VALUE                                *
C*                                                                    *
C*    OUTPUT    : LENOUT= OUTPUT VALUE                                *
C*                                                                    *
C*    GENERAL   : MODVAL CALLS  MOD                                   *
C*                              ABS                                   *
C*                                                                    *
C*    AUTHOR    : B.V. GURETZKY    V.E. DAY                           *
C*                                                                    *
C*    MODIFIED  : J. HENNESSY      25.11.85                           *
C*                                                                    *
C*                                                                    *
C     ---------------------------------------------------------------
C----<
C
      LENG  = ABS (MULT)
      INTER = MOD (ABS(LENIN),LENG)
C
      IF (INTER.NE.0)
     C   THEN
             LENG = LENG - INTER
             IF (LENIN.LT.0)
     C           THEN
                     LENOUT = LENIN - LENG
                 ELSE
                     LENOUT = LENIN + LENG
                 ENDIF
         ELSE
             LENOUT = LENIN
         ENDIF
C
C
      RETURN
      END

! Copyright 1981-2016 ECMWF.
!
! This software is licensed under the terms of the Apache Licence
! Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
!
! In applying this licence, ECMWF does not waive the privileges and immunities
! granted to it by virtue of its status as an intergovernmental organisation
! nor does it submit to any jurisdiction.
!

      INTEGER FUNCTION DPATH_TABLES_INTERPOL(DPATH)
!
!---->
!**** DPATH_TABLES_INTERPOL
!
!     Purpose
!     -------
!
!     This routine returns the directory path for interpolation tables.
!     Returned path (as argument) has path separator suffixed (/).
!
!
!     Interface
!     ---------
!
!     IRET = DPATH_TABLES_INTERPOL(DPATH)
!
!
!     Input parameters
!     ----------------
!
!     DPATH - argument in which tables directory path is returned
!
!
!     Output parameters
!     -----------------
!
!     DPATH_TABLES_INTERPOL - length of path string, 0 if not successful
!
!
!     Method
!     ------
!
!     It respects this order (each overriding the previous, if set):
!     - suitable default value
!     - compile-time definition of INTERPOL_TABLES_PATH
!     - run-time env. variable EMOSLIB_FILES
!     - ...                    HIRLAM_LSM_PATH
!     - ...                    MARS_LSM_PATH
!
!
!     Externals
!     ---------
!
!     GETENV  - Read environment variable
!
!
!     Author
!     ------
!
!     P. Maciel      ECMWF      February 2015
!
!----<


!*    Section 0. Definition of variables
      IMPLICIT NONE

      CHARACTER*256 DPATH
      CHARACTER*256 TMPDPATH
      INTEGER IDX

      CHARACTER*13  ENVPATH1
      CHARACTER*15  ENVPATH2
      CHARACTER*13  ENVPATH3
      CHARACTER*39  DEFPATH1
      CHARACTER*256 DEFPATH2

      PARAMETER (ENVPATH1 = 'EMOSLIB_FILES')
      PARAMETER (ENVPATH2 = 'HIRLAM_LSM_PATH')
      PARAMETER (ENVPATH3 = 'MARS_LSM_PATH')
      PARAMETER (DEFPATH1 = '/usr/local/apps/libemos/tables/interpol')
#ifdef INTERPOL_TABLES_PATH
      DATA DEFPATH2 / &
       INTERPOL_TABLES_PATH &
      /
#else
      DATA DEFPATH2 / ' ' /
#endif


!*    Section 1. initialize: reset paths and return value
  100 CONTINUE
      DPATH = ' '
      TMPDPATH = ' '
      DPATH_TABLES_INTERPOL = 0;


!*    Section 2. Attempt reading env. variables, in order of priority
  200 CONTINUE
      CALL GETENV(ENVPATH3,TMPDPATH)
      IF (INDEX(TMPDPATH,' ').EQ.1) CALL GETENV(ENVPATH2,TMPDPATH)
      IF (INDEX(TMPDPATH,' ').EQ.1) CALL GETENV(ENVPATH1,TMPDPATH)

      IDX = INDEX(TMPDPATH,' ') - 1
      IF (IDX.GT.0) THEN
        DPATH = TMPDPATH(1:IDX)
        GOTO 900
      END IF


!*    Section 3. set default, possibly overriden by compile definition
!     (definition is for base directory, so interpol/ need appending)
  300 CONTINUE
      DPATH = DEFPATH1
      IDX = INDEX(DEFPATH2,' ') - 1
      IF (IDX.GT.0) DPATH = DEFPATH2(1:IDX) // '/interpol'


!*    Section 9. Append /, return path string length (otherwise zero)
  900 CONTINUE
      IDX = INDEX(DPATH,' ')
      IF (IDX.GT.1) THEN
        DPATH(IDX:IDX) = '/'
        DPATH_TABLES_INTERPOL = IDX
      END IF
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

       SUBROUTINE BUGETBM(KBUFL,KBUFF,KSEC3,KBMP,KBMPL,KBV,KERR)
C
C**** *BUGETBM*
C
C
C     PURPOSE.
C     --------
C
C          CREATE BIT MAP TO RESOLVE MARKER OPERATORS.
C
C
C
C**   INTERFACE.
C     ----------
C
C          *CALL* *BUGETBM(KBUFL,KBUFF,KSEC3,KBMP,KBMPL,KBV,KERR)*
C
C        INPUT :
C               *KBUFL*   -  LENGTH OF BUFR MESSAGE (WORDS)
C               *KBUFF*   -  ARRAY CONTAINING BUFR MESSAGE
C               *KSEC3*   -  ARRAY CONTAINING SECTION 3 INFORMATION
C                            KSEC3( 1)-- LENGTH OF SECTION 3 (BYTES)
C                            KSEC3( 2)-- RESERVED
C                            KSEC3( 3)-- NUMBER OF SUBSETS
C                            KSEC3( 4)-- FLAG (DATA TYPE,DATA COMPRESSION)
C               *KBMP     -  BIT MAP POINTER TO THE FIRST DATA PRESENT
C                            INDICATOR
C               *KBMPL    -  NUMBER OF  DATA PRESENT INDICATORS
C
C        OUTPUT:
C               *KBV*     -  BIT MAP ARRAY
C               *KERR*    -  RETURNED ERROR CODE
C
C     METHOD.
C     -------
C
C          NONE.
C
C     EXTERNALS.
C     ----------
C
C          BUNPCK          - UNPACKS BIT PATTERN
C          BUNPKS         - UNPACKS BIT PATTERN IN REPEATED WAY
C
C     REFERENCE.
C     ----------
C
C          NONE.
C
C     AUTHOR.
C     -------
C
C          M. DRAGOSAVAC    *ECMWF*       01/02/91.
C
C
C     MODIFICATIONS.
C     --------------
C
C          NONE.
C
C
      IMPLICIT LOGICAL(L,O,G), CHARACTER*8(C,H,Y)
C
C
#     include "parameter.F"
#     include "bcomunit.F"
#     include "bcomwork.F"
#     include "bcombef.F"
#     include "bcomwt.F"
#     include "bcomwtc.F"
#     include "bcomrq.F"
C
      CHARACTER CWTEN*64,CWTU*24
      DIMENSION KBUFF(KBUFL),KBV(*)
      DIMENSION KSEC3(JSEC3)
C
#ifndef R_4
      REAL*8 RVIND
      REAL*8 EPS
#else
      REAL   RVIND
      REAL   EPS
#endif
      DIMENSION IMASK(8),ILIST(JELEM)
C
      DATA IMASK /1,2,4,8,16,32,64,128/
C
C
C     ------------------------------------------------------------------
C*          1.  CALCULATE WORD AND BIT POINTER TO FIRST
C               ---------------------------------------
C               DATA PRESENT INDICATOR.
C               -----------------------
 100  CONTINUE
C
C
      IF(KERR.GT.0) RETURN
C
      IB=0
      IF(IAND(KSEC3(4),IMASK(7)).NE.0) IB=1
C
      IF(IB.EQ.0) THEN
C
C        FOR UNCOMPRESSED DATA
C
         IBIT=NWPTB*NBPW+32+NBPTB
         DO 101 I=1,KBMP-1
         IBIT=IBIT+NWTDW(I)
 101     CONTINUE
C
         IWPT=IBIT/NBPW
         IBPT=IBIT-IWPT*NBPW
      ELSE
C
C        FOR COMPRESSED DATA
C
         IBIT=32+NBPTB
         IWORD=IBIT/NBPW
C
         NWORDP(1)=NWPTB+IWORD
         NBITP (1)=IBIT-IWORD*NBPW
C
         DO 102 I=2,KBMP
C
         IF(NWTDW(I-1).EQ.0) THEN
            NBITP(I)=NBITP(I-1)
            NWORDP(I)=NWORDP(I-1)
            GO TO 102
         END IF
C
         IWRD=NWORDP(I-1)
         IBTP=NBITP (I-1)
C
         IBTP=IBTP+NWTDW(I-1)
         IF(IBTP.GE.NBPW) THEN
            IW=IBTP/NBPW
            IBTP=IBTP-IW*NBPW
            IWRD=IWRD+IW
         END IF
         CALL BUNPCK(NBPW,KBUFF,IDWINC,IWRD,IBTP,6,KERR)
         IF(KERR.GT.0) RETURN
         IF(IDWINC.GT.JBPW) THEN
            KERR=15
            WRITE(KNTN,*)  'BUPMRK :'
            CALL BUERR(KERR)
            RETURN
         END IF
C
         IF(CWTU(I-1).EQ.'CCITTIA5') THEN
            NWTIWS(I-1)=NWTDW(I-1)+6+N*IDWINC*8
         ELSEIF(NWTEN(I-1).EQ.-999) THEN
            NWTIWS(I-1)=NWTDW(I-1)+6+N*IDWINC*8
         ELSE
            NWTIWS(I-1)=NWTDW(I-1)+6+N*IDWINC
         END IF
C
         IBIT = NBITP(I-1) + NWTIWS(I-1)
         IWORD= IBIT/NBPW
C
         NBITP (I)= IBIT - IWORD*NBPW
         NWORDP(I)= NWORDP(I-1) + IWORD
 102     CONTINUE
C
         IBPT=NBITP (KBMP)
         IWPT=NWORDP(KBMP)
      END IF
C
C*          2.  GET BIT MAP FROM DATA SECTION.
C               ------------------------------
 200  CONTINUE
C
      IF(IB.EQ.0) THEN
         CALL GBYTES(KBUFF(IWPT),KBV,IBPT,1,0,KBMPL)
      ELSE
         DO 201 I=1,KBMPL
         CALL BUNPCK(NBPW,KBUFF,IR0,IWPT,IBPT,1,KERR)
         IF(KERR.GT.0) RETURN
         CALL BUNPCK(NBPW,KBUFF,IDWINC,IWPT,IBPT,6,KERR)
         IF(KERR.GT.0) RETURN
         IF(IDWINC.GT.JBPW) THEN
            KERR=15
            WRITE(KNTN,*)  'BUPMRK:'
            CALL BUERR(KERR)
            RETURN
         END IF
C
         DO 202 K=1,KSEC3(3)
         ILIST(K)=0
 202     CONTINUE
C
         IF(IDWINC.NE.0) THEN
C
C           UNPACK INCREMENTS
C
            CALL BUNPKS(NBPW,KBUFF,ILIST,IWPT,IBPT,
     1                  IDWINC,0,KSEC3(3),KERR)
            IF(KERR.GT.0) RETURN
         END IF
C
         KBV(I)=IR0
         IF(IDWINC.NE.0) KBV(I)=IR0+ILIST(1)
 201     CONTINUE
C
      END IF
C
      RETURN
      END

C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      LOGICAL FUNCTION JACOBIF(DATA,NM,W,ROTANG)
C
C---->
C**** JACOBIF
C
C     Purpose
C     -------
C
C     Rotates spectral field by latitude (Fujitsu only).
C
C
C     Interface
C     ---------
C
C     IRET = JACOBIF(DATA,NM,W,ROTANG)
C
C     Input
C     -----
C
C     NM      - Triangular truncation number of the field.
C     DATA    - Linear array of REAL*8s of size (NM+1)*(NM+2)
C               holding the field.
C     W       - Work array of REAL*8s of size (NM+1)*(NM+2).
C     ROTANG  - Rotation angle (degrees, REAL*8)
C              (degrees, negative => rotate counter-clockwise about the
C                                    new Z-axis).
C     
C
C     Output
C     ------
C
C     DATA    - The transformed field.
C
C     Function returns .FALSE. if data cannot be transformed.
C
C
C     Method
C     ------
C
C     See reference paper below.
C
C     Coefficients are read into or are created in memory. A large
C     amount of memory may be required; eg, for truncation NM:
C       8*(NM*(2*NM*NM + 9*NM +13)/3) bytes.
C
C     Optionally, if the environment variable PP_SAVE_ROT is set, a
C     file of coefficients can be created in the directory given by
C     environment variable PP_ROT_DIR.
C
C     The name of the file of rotation coefficients indicates the
C     triangular truncation NM and the rotation angle ROTANG:
C
C           $PP_ROT_DIR/rot_coefs_Tttt_nnnnnnnnn
C     or    $TMPDIR/rot_coefs_Tttt_nnnnnnnnn
C
C     where:
C            ttt =  triangular truncation
C      nnnnnnnnn =  ROTANG*100000,
C     or
C           $PP_ROT_DIR/rot_coefs_Tttt_Mnnnnnnnn
C     or    $TMPDIR/rot_coefs_Tttt_Mnnnnnnnn
C
C     where:
C            ttt =  triangular truncation
C       nnnnnnnn =  -ROTANG*100000 if ROTANG is negative.
C        
C
C     Externals
C     ---------
C
C     INTLOG  - Logs messages.
C     INTLOGR - Logs messages.
C     GETENV  - To get environment variable data.
C     UNLINK  - To remove a file.
C     PPALLOW - Checks if the rotation coefficients can go into mrfs.
C
C
C     Author
C     ------
C
C     J.D.Chambers     ECMWF       April 1999
C
C
C     Reference.
C     ----------
C
C     "Spectral synthesis on rotated and regular grids"
C     by P.Lynch and R.McGrath (Irish Meteorological Service).
C
C
C----<
C     -----------------------------------------------------------------|
C
      IMPLICIT NONE
C
#include "jparams.h"
#include "parim.h"
C
C     Function arguments.
C
      REAL*8 DATA, W
      DIMENSION DATA(*), W(*)
      INTEGER NM
      REAL*8 ROTANG
C
C     Parameters.
C
      REAL*8 EPS
      PARAMETER(EPS = 1.0E-10)
      INTEGER JPNM_MAX, JPMAXMM, JPMEM20
      PARAMETER( JPNM_MAX = 640 )
      PARAMETER( JPMAXMM = 3 )
C                          `--> maximum number of memory slots
C                               used for rotation coefficients
      PARAMETER( JPMEM20 = 20 )
C                           `--> offset in memory allocation table of
C                                first memory slot for rotation
C                                coefficients
C
C     Local variables.
C
      LOGICAL LFOR, LALLOW
      INTEGER I, ISKIP, J, N, MM, K, IEND
      INTEGER NN, M, NDEX, IMEMORY
C
      REAL*4 SROTANG
      REAL*8 SIMAG, S, TEMP, DROTANG
      REAL*8 RAD, TANB, SINB, COSB, Q, RNKN, BNKN, SQNN
      REAL*8 SQNN1, SQ2N, PKN, PK1N, RNKN1, SREAL ,RNK0, RNK1
      REAL*8 INDEXR(JPNM_MAX), INDEXI(JPNM_MAX)
      REAL*8 MINUS1(JPNM_MAX)
      REAL*8 FACTOR(JPNM_MAX)
      REAL*8 WISQR(JPNM_MAX)
      REAL*8 WIB(JPNM_MAX)
      REAL*8 WIR(JPNM_MAX)
      REAL*8 WIDAT(2*JPNM_MAX)
C
      CHARACTER*256 FILENAME
      CHARACTER*40 COEFILE
      DATA COEFILE/'rot_coefs_Tnnn_nnnnnnnnn'/
C
      INTEGER IUNIT, IRET, ILAT, OLDLAT(3), OLDTRUN(3), IOFFSET
      INTEGER IFSIZE, ICNDEX
      INTEGER LOOP, NMP1TM, MAXMEM
      LOGICAL LINMEM, LEXIST
C
      INTEGER CURRENT, OLDEST
      DATA OLDEST/1/, MAXMEM/JPMAXMM/
      SAVE OLDEST, MAXMEM
C
      DATA OLDLAT/3*9999999/, OLDTRUN/3*0/
      DATA LINMEM/.FALSE./, LEXIST/.FALSE./
      SAVE IUNIT, ILAT, OLDLAT, OLDTRUN, COEFILE, LINMEM, LEXIST
C
#ifdef POINTER_64
Cjdc  INTEGER*8 ICOEFF
#endif
      REAL*8 ACOEFF
      DIMENSION ACOEFF(1)
      POINTER ( ICOEFF, ACOEFF )
C
C     Externals
C
      INTEGER JCHMOD, UNLINK
      LOGICAL PPALLOW
      EXTERNAL JCHMOD, UNLINK, PPALLOW
C
C     Statement function
C
      REAL*8 A, B
      LOGICAL ABSCHK
      ABSCHK(A,B) = (ABS(A-B) .LT. EPS*(ABS(A) + ABS(B)))
C
C     W array: 1 -> (NM+1)*(NM+2) for PMN/SQRT(2*N+1) values.
C
C     RNKM values in WIR (for M>0),
C                 in WIB (M<0).
C     Array of temporary SQRT values in WISQR, and
C     temporary transformed data in WIDAT
C
C     -----------------------------------------------------------------|
C*    Section 1.   Initialise
C     -----------------------------------------------------------------|
C
  100 CONTINUE
C
      JACOBIF = .FALSE.
C
      LALLOW = PPALLOW(NM,ROTANG)
C
      CALL INTLOG(JP_DEBUG,'JACOBIF: truncation = ', NM)
      SROTANG = SNGL(ROTANG)
      CALL INTLOGR(JP_DEBUG,'JACOBIF: rotation angle = ', SROTANG)
C
C     Exit immediately if rotation angle is zero.
C
      IF (ABS(ROTANG).LT.EPS) THEN
        CALL INTLOG(JP_DEBUG,'JACOBIF: No rotation necessary',JPQUIET)
        JACOBIF = .TRUE.
        GOTO 999
      ENDIF
C
C     Change to radians.
C
      RAD   = 180.0/PPI
      DROTANG = ROTANG/RAD
      TANB  = TAN(DROTANG/(2.0))
      SINB  = SIN(DROTANG)
      COSB  = COS(DROTANG)
      Q     = SQRT(2.0)/2.0
C
      ICNDEX = 0
C
C     -----------------------------------------------------------------|
C*    Section 2.   Generate PMN/SQRT(2*N+1) values in W.
C     -----------------------------------------------------------------|
C
  200 CONTINUE
C
      W(1)  = 1.0
      W(2)  = COSB
C
      ISKIP = NM + 1
!OCL SCALAR
      DO I = 1,ISKIP
        W(1+ISKIP*I)   = W(1+ISKIP*I-ISKIP)*SINB*
     X                   SQRT(DBLE(2*I-1)/DBLE(2*I))
        W(1+ISKIP*I+1) = COSB*DSQRT(DBLE(2*I+1))*W(1+ISKIP*I)
      ENDDO
C
!OCL SCALAR
      DO I = 2,ISKIP-1
C
!OCL VECTOR
        DO J = 0,ISKIP-I+1
          FACTOR(J) = 1.0/DSQRT(DBLE((I+2*J)*I))
        ENDDO
C
        DO J = 0,ISKIP-I+1
          W(I+J*ISKIP+1) = COSB*DBLE(2*I+2*J-1)
     X                     *FACTOR(J)*W(I+J*ISKIP)
     X                     - DSQRT(DBLE((I-1)*(I+2*J-1)))
     X                     *FACTOR(J)*W(I+J*ISKIP-1)
        ENDDO
C
      ENDDO
C
      MINUS1(1) = -1
!OCL SCALAR
      DO I = 2, JPNM_MAX
        MINUS1(I) = -MINUS1(I-1)
      ENDDO
C
C     -----------------------------------------------------------------|
C*    Section 3.   Pick up the rotation coefficients RNKM.
C     -----------------------------------------------------------------|
C
  300 CONTINUE
C
C     Change the interpolation coefficents if the input latitude is
C     not the same as the one used the last time through.
C
      ILAT = NINT(ROTANG*100000)
C
      DO LOOP = 1, MAXMEM
        IF( ILAT.EQ.OLDLAT(LOOP).AND.(OLDTRUN(LOOP).EQ.NM) ) THEN
C
C         Set flags to show the rotation coefficients are in memory
C
          LINMEM = .TRUE.
          LEXIST = .TRUE.
          CURRENT = LOOP + JPMEM20 - 1
          CALL INTLOG(JP_DEBUG,
     X      'JACOBIF: Existing memory slot re-used = ', CURRENT)
          CALL JMEMHAN( CURRENT, ICOEFF, IMEMORY, 1, IRET)
          IF( IRET.NE.0 ) THEN
            CALL INTLOG(JP_FATAL,
     X        'JACOBIF: Failed to pick up existing memory pool',CURRENT)
            JACOBIF = .FALSE.
            GOTO 999
          ENDIF
          GOTO 310
        ENDIF
      ENDDO
C
      LINMEM = .FALSE.
      LEXIST = .FALSE.
      CURRENT = OLDEST + JPMEM20 - 1
      OLDLAT(OLDEST)  = ILAT
      OLDTRUN(OLDEST) = NM
      OLDEST  = OLDEST + 1
      IF( OLDEST.GT.MAXMEM ) OLDEST = 1
      CALL INTLOG(JP_DEBUG,
     X  'JACOBIF: Different memory slot selected = ', CURRENT)
C
  310 CONTINUE
C
      IF( .NOT. LINMEM ) THEN
C
C       Calculate the coefficients file size (coefficients are REAL*8)
C
        IFSIZE = 8*(NM*(2*NM*NM + 9*NM +13)/3)
C
C       Allocate memory for the REAL*8 coefficients
C
#ifdef REAL_8
        IMEMORY = (NM*(2*NM*NM + 9*NM +13)/3)
#else
        IMEMORY = 2*(NM*(2*NM*NM + 9*NM +13)/3)
#endif
C
  320   CONTINUE
C
        CALL JMEMHAN( CURRENT, ICOEFF, IMEMORY, 1, IRET)
        IF( IRET.NE.0 ) THEN
C
C         If memory allocation fails, reduce the number of slots in the
C         memory pool. Exit if the pool is already down to one slot.
C
          IF( MAXMEM.LT.2 ) THEN
            CALL INTLOG(JP_FATAL,
     X        'JACOBIF: memory allocation error',ICOEFF)
            JACOBIF = .FALSE.
            GOTO 999
          ENDIF
          MAXMEM = MAXMEM - 1
          CALL INTLOG(JP_DEBUG,
     X      'JACOBIF: Reduce number of memory slots to ', MAXMEM)
          LINMEM = .FALSE.
          LEXIST = .FALSE.
          OLDEST = 1
          OLDLAT(OLDEST)  = ILAT
          OLDTRUN(OLDEST) = NM
          CURRENT = OLDEST + JPMEM20 - 1
          OLDEST = OLDEST + 1
          IF( OLDEST.GT.MAXMEM ) OLDEST = 1
          CALL INTLOG(JP_DEBUG,
     X      'JACOBIF: Different memory slot selected = ', CURRENT)
          GOTO 320
        ENDIF
        ICNDEX = 0
C
C       If the file already exists, read it into memory.
C       For 'standard' rotations try PP_ROT_DIR, otherwise TMPDIR.
C
        IF( LALLOW ) THEN
          CALL GETENV('PP_ROT_DIR',FILENAME)
        ELSE
          CALL GETENV('TMPDIR',FILENAME)
        ENDIF
        IOFFSET = INDEX(FILENAME,' ')
        IF( IOFFSET.EQ.1) THEN
          CALL INTLOG(JP_WARN,
     X      'JACOBIF: Unable to open rotation coefficents.',JPQUIET)
C
        ELSE
C
          CALL INTLOG(JP_DEBUG,
     X      'JACOBIF: Existing coefficients sought in:',JPQUIET)
          CALL INTLOG(JP_DEBUG,
     X      'JACOBIF: '// FILENAME(1:IOFFSET-1),JPQUIET)
C
          WRITE(COEFILE(12:14),'(I3.3)') NM
          IF( ILAT.GE.0) THEN
            WRITE(COEFILE(16:),'(I9.9)') ILAT
          ELSE
            COEFILE(16:) = 'M'
            WRITE(COEFILE(17:),'(I8.8)') -ILAT
          ENDIF
          FILENAME = FILENAME(1:IOFFSET-1) // '/' // COEFILE
          IOFFSET = INDEX(FILENAME,' ') - 1
C
          CALL PBOPEN(IUNIT,FILENAME(1:IOFFSET),'r',IRET)
          IF( IRET.EQ.0 ) THEN
C
C           Let user know that a existing file has been opened
C
            CALL INTLOG(JP_DEBUG,
     X        'JACOBIF: Existing coefficients found in file:',JPQUIET)
            CALL INTLOG(JP_DEBUG,'JACOBIF: '// COEFILE, JPQUIET)
C
C           Read coefficients into memory
C
            CALL PBREAD(IUNIT,ACOEFF,IFSIZE,IRET)
            IF( IRET.NE.IFSIZE ) THEN
              CALL INTLOG(JP_WARN,'JACOBIF: PBREAD failed.',JPQUIET)
            ELSE
C
C           Set flags to show the rotation coefficients are in memory
C           and exist.
C
              LINMEM = .TRUE.
              LEXIST = .TRUE.
            ENDIF
C
            CALL PBCLOSE(IUNIT,IRET)
          ENDIF
C
        ENDIF
C
      ENDIF
C
C     -----------------------------------------------------------------|
C*    Section 4.   Generate the rotation coefficients RNKM.
C     -----------------------------------------------------------------|
C
  400 CONTINUE
C
C
C     Generate the rotation coefficients RNKM (K = M dashed in note)
C     and store in W.  For K = 0 special case.
C
C     PMN = W(M*(NM+1) + (N-M+1))
C
!OCL VECTOR
      DO 630 N = 1,NM
        RNKN  = (0.5*(1.0 + COSB))**N
        BNKN  = (0.5*(1.0 - COSB))**N
        SQNN  = DSQRT(DBLE((N+1)*N))
        SQNN1 = SQNN*SINB
        SQ2N  = DSQRT(2.0/DBLE(N))/SINB
C
C       Save SQRTS.
C
!OCL VECTOR
        DO MM = 0,N
          WISQR(MM+1) = DSQRT(DBLE((N+MM)*(N-MM+1)))*SINB
        ENDDO
C
        NN = 1
C
C       Generate RNKM, M = 0 to N.
C
!OCL SCALAR
        DO 590 K = N,0,-1
C
C         If the coefficients are not (yet) in memory, they have to
C         be calculated.
C
          IF( .NOT. LINMEM ) THEN
C
            PKN = W(K*(NM+1) + (N-K+1))
            IF (K.EQ.0) GOTO 500
C
C           For K > 0, go forward from zero.
C
            PK1N = W((K-1)*(NM+1) + (N-(K-1)+1))
C
C           Flip sign if necessary.
C
            IF (MOD(K,2).NE.0)THEN
              PKN = -PKN
            ELSE
              PK1N = -PK1N
            ENDIF
C
C           Work using forward recurrence as long as coefficient
C           calculated passes checks.
C
            LFOR = .TRUE.
C
            RNK0 = PKN
            RNK1 = (-DBLE(K)*TANB*PKN + (WISQR(K+1)/SINB)*PK1N)/SQNN
C
C           Recurrence starts at 2 for M = 0
C
            WIR(1) = RNK0
            WIR(2) = RNK1
C
!OCL SCALAR
            DO MM = 1,N-1
              WIR(MM+2) = (2.0*WIR(MM+1)*(DBLE(MM)*COSB-DBLE(K))
     X                    - WISQR(MM+1)*WIR(MM)) /WISQR(MM+2)
C
C             Apply check to generated coefficient to see if its
C             absolute value is greater than 1.  If so, have to
C             switch to using backwards recurrences.
C
              IF (ABS(WIR(MM+2)).GT.1.0)THEN
                LFOR = .FALSE.
                IEND = MM + 3
                GOTO 435
              ENDIF
            ENDDO
C
C           If forward recurrence appears OK so far,
C           test last element RNKN by comparing with WIR(N+1).
C
            IEND = N + 2
            IF (ABSCHK(RNKN,WIR(N+1))) GOTO 445
C
C           If test failed, try generating coefficients using
C           backwards recurrences.
C
  435       CONTINUE
C
C           Work backwards from the top.
C           Specify N; K is already set from the loop above.
C           Stop at M = 1 (NOT 0).
C
            RNKN1 = RNKN*SQ2N*(DBLE(N)*COSB-DBLE(K))
            WIR(N+1) = RNKN
C
C           Check whether difference is within prescribed tolerance.
C
            IF (LFOR .AND. ABSCHK(RNKN1,WIR(N))) GO  TO 445
            WIR(N) = RNKN1
C
C           For M = 0:
C
!OCL SCALAR
            DO MM = N-1,1,-1
              S = (2.0*WIR(MM+1)*(DBLE(MM)*COSB-DBLE(K))
     X              - (WISQR(MM+2)*WIR(MM+2))) / WISQR(MM+1)
C
C             Accept these if forward recursion failed before
C             reaching this point.
C
              IF (MM+1.LT.IEND)THEN
                IF (ABSCHK(S,WIR(MM))) GOTO 445
              ENDIF
              WIR(MM) = S
C
C             If absolute value is greater than 1, give up gracefully
C
              IF (ABS(S).GT.1.0) GOTO 920
C
            ENDDO
C
            GOTO 920
C
  445       CONTINUE
C
C           Now RNKM for M = 0,-N
C
C           RNKM M = -1,-N
C
C           Forward recurrence starts at 1 for M = 0, 2 for -1 etc.
C
            LFOR = .TRUE.
C
            WIB(1) = RNK0
            WIB(2) = -RNK1-RNK0*DBLE(2*K)/(SQNN1)
C
!OCL SCALAR
            DO MM = 1,(N-1)
              WIB(MM+2) = (2.0*WIB(MM+1)*(DBLE(-MM)*COSB-DBLE(K))
     X              - WISQR(MM+1)*SINB*WIB(MM)) /WISQR(MM+2)
C
C             Apply check to generated coefficient to see if its
C             absolute value is greater than 1.  If so, have to
C             switch to using backwards recurrences.
C
              IF (ABS(WIB(MM+2)).GT.1.0)THEN
                LFOR = .FALSE.
                IEND = MM + 3
                GOTO 455
              ENDIF
            ENDDO
C
C           If forward recurrence appears OK so far,
C           test last element BNKN by comparing with WIB(N+1).
C
            IEND = N + 1
            IF (ABSCHK(BNKN,WIB(N+1))) GOTO 500
C
C           If test failed, try generating coefficients using backwards
C           recurrences.
C
  455       CONTINUE
C
C           Get R values.
C           First RNKN, then next highest RNKN1.
C
            RNKN1 = -BNKN*SQ2N*(DBLE(N)*COSB + DBLE(K))
C
C           Work backwards from the top.
C           Specify N; K is already set from the loop above.
C
C           Stop at M = 1 (NOT 0).
C
            WIB(N+1) = BNKN
            IF (LFOR .AND. ABSCHK(RNKN1,WIB(N))) GOTO 500
            WIB(N) = RNKN1
C
!OCL SCALAR
            DO MM = N-1,1,-1
              S = (2.0*WIB(MM+1)*(DBLE(-MM)*COSB-DBLE(K))
     X            - (WISQR(MM+2)*WIB(MM+2))) / WISQR(MM+1)
C
C             Accept backwards generated coefficients if forward
C             recursion failed before reaching this point.
C
              IF ( (MM.LT.IEND ) .AND. ABSCHK(S,WIB(MM)) ) GOTO 500
              WIB(MM) = S
C
C             If absolute value is greater than 1, give up.
C
              IF (ABS(S).GT.1.0) GOTO 910
C
            ENDDO
C
C           End of backwards recurrences reached with no agreed
C           coefficients, give up.
C
            GOTO 910
C
C     -----------------------------------------------------------------|
C*    Section 5.   Got RNKM. Now transform spectral data.
C     -----------------------------------------------------------------|
C
  500       CONTINUE
C
C           Put coefficients in allocated memory
C
!OCL VECTOR
            DO LOOP = 1, N+1
              ACOEFF(ICNDEX    +LOOP) = WIR(LOOP)
              ACOEFF(ICNDEX+N+1+LOOP) = WIB(LOOP)
            ENDDO
C
          ENDIF
C
C         Coefficients are in memory
C
          PKN  = W(K*(NM+1) + (N-K+1))
          PK1N = W((K-1)*(NM+1) + (N-(K-1)+1))
C
C         Flip sign if necessary.
C
          IF (MOD(K,2).NE.0)THEN
            PKN  = -PKN
          ELSE
            PK1N = -PK1N
          ENDIF
C
!OCL VECTOR
          DO LOOP = 1, N+1
            WIR(LOOP) = ACOEFF(ICNDEX    +LOOP)
            WIB(LOOP) = ACOEFF(ICNDEX+N+1+LOOP)
          ENDDO
          ICNDEX = ICNDEX + 2*(N+1)
C
C
C         Special case when K=0.
C
          IF( K.EQ.0) THEN
C
            SREAL = DATA(2*(N+1)-1)*PKN
            SIMAG = 0.0
!OCL VECTOR
            DO M = 1,N
              SREAL = SREAL
     X        + 2.0*DATA(2*((NM+1)*M-((M-1)*M)/2+1+N-M)-1)
     X        * W((NM+1)*M+(N-M+1))
            ENDDO
C
            NDEX       = 1+N
            WIDAT(NN)   = SREAL
            WIDAT(NN+1) = SIMAG
            NN          = NN + 2
C
          ELSE
C
            SREAL  = DATA(2*(N+1)-1)*PKN
            SIMAG  = 0.0
!OCL VECTOR
            DO M = 1,N
              INDEXR(M) = 2*((NM+1)*M-((M-1)*M)/2+1+N-M)-1
            ENDDO
!OCL VECTOR
            DO M = 1,N
              INDEXI(M) = INDEXR(M) + 1
            ENDDO
C
!OCL VECTOR
            DO M = 1,N
              SREAL = SREAL +
     X              DATA(INDEXR(M))
     X              * (WIR(M+1)+WIB(M+1)*MINUS1(M))
              SIMAG = SIMAG -
     X              DATA(INDEXI(M))
     X              * (-WIR(M+1)+WIB(M+1)*MINUS1(M))
            ENDDO
C
            NDEX       = (NM+1)*K - ((K-1)*K)/2+1+N-K
            WIDAT(NN)   = SREAL
            WIDAT(NN+1) = SIMAG
            NN          = NN + 2
          ENDIF
C
C         Update RNKN at both ends of the forward and backward
C         recurrences.
C
          TEMP = DSQRT(DBLE(N+K)/DBLE(N-K+1))
          RNKN = RNKN*TEMP*SINB/(1+COSB)
          BNKN = -BNKN*TEMP*(1+COSB)/SINB
C
C       End of inner loop.
C
  590   CONTINUE
C
C     -----------------------------------------------------------------|
C*    Section 6.   Now place the values of the rotated spectral
C                  coefficients in DATA.
C     -----------------------------------------------------------------|
C
  600 CONTINUE
C
        NN = 1
!OCL VECTOR
        DO K = N,0,-1
          NDEX = (NM+1)*K - ((K-1)*K)/2+1+N-K
          DATA(2*NDEX-1) = WIDAT(NN)
          DATA(2*NDEX)   = WIDAT(NN+1)
          NN = NN + 2
C
        ENDDO
C
C     End of outer loop.
C
  630 CONTINUE
C
C     -----------------------------------------------------------------|
C*    Section 9.   Return.
C     -----------------------------------------------------------------|
C
  900 CONTINUE
C
      LINMEM = .TRUE.
C
      IF( .NOT. LEXIST ) THEN
C
C       If the environment variable PP_SAVE_ROT is set, save the
C       rotation coefficients in a file.
C       'Standard' rotations go into PP_ROT_DIR, others into TMPDIR.
C
        LEXIST = .TRUE.
        CALL GETENV('PP_SAVE_ROT',FILENAME)
        IOFFSET = INDEX(FILENAME,' ')
        IF( IOFFSET.GT.1 ) THEN
          IF( LALLOW ) THEN
            CALL GETENV('PP_ROT_DIR',FILENAME)
          ELSE
            CALL GETENV('TMPDIR',FILENAME)
          ENDIF
          IOFFSET = INDEX(FILENAME,' ')
          IF( IOFFSET.EQ.1) THEN
            CALL INTLOG(JP_WARN,
     X        'JACOBIF: Unable to save rotation coefficents.',JPQUIET)
C
          ELSE
C
C         Let user know that a new file is being created.
C
          CALL INTLOG(JP_DEBUG,
     X      'JACOBIF: Creating new coefficients in directory',JPQUIET)
          CALL INTLOG(JP_DEBUG,
     X      'JACOBIF: '// FILENAME(1:IOFFSET-1),JPQUIET)
C
            WRITE(COEFILE(12:14),'(I3.3)') NM
            IF( ILAT.GE.0) THEN
              WRITE(COEFILE(16:),'(I9.9)') ILAT
            ELSE
              COEFILE(16:) = 'M'
              WRITE(COEFILE(17:),'(I8.8)') -ILAT
            ENDIF
            FILENAME = FILENAME(1:IOFFSET-1) // '/' // COEFILE
            IOFFSET = INDEX(FILENAME,' ')
C
            CALL PBOPEN(IUNIT,FILENAME(1:IOFFSET-1),'w',IRET)
            IF( IRET.NE.0 ) THEN
              CALL INTLOG(JP_WARN,
     X          'JACOBIF: PBOPEN for write failed',JPQUIET)
              GOTO 995
            ENDIF
C
            CALL INTLOG(JP_DEBUG,
     X        'JACOBIF: New coefficients filename:',JPQUIET)
            CALL INTLOG(JP_DEBUG,'JACOBIF: '// COEFILE, JPQUIET)
C
C           Change access mode to 'read only' for all users.
C
            IRET = JCHMOD(FILENAME(1:IOFFSET-1),'0444')
            IF( IRET.NE.0 )
     X        CALL INTLOG(JP_WARN,'JACOBIF: JCHMOD error.',IRET)
C
C           Write coefficients to file
C
            CALL PBWRITE(IUNIT,ACOEFF,IFSIZE,IRET)
            IF( IRET.NE.IFSIZE ) THEN
              CALL INTLOG(JP_FATAL,'JACOBIF: PBWRITE failed.',JPQUIET)
              IRET = UNLINK(FILENAME(1:IOFFSET-1))
              IF( IRET.NE.0 )
     X          CALL INTLOG(JP_FATAL,'JACOBIF: UNLINK failed',JPQUIET)
              CALL PBCLOSE(IUNIT,IRET)
              JACOBIF = .FALSE.
              GOTO 999
            ENDIF
            CALL PBCLOSE(IUNIT,IRET)
            LINMEM = .TRUE.
          ENDIF
        ENDIF
      ENDIF
C
  995 CONTINUE
C
      JACOBIF = .TRUE.
C
  999 CONTINUE
      RETURN
C
C     Failure to converge with M < 0.
C
  910 CONTINUE
      CALL INTLOG(JP_FATAL,'JACOBIF: Fail to converge M < 0', JPQUIET)
      JACOBIF = .FALSE.
      GOTO 999
C
C     Failure to converge with M > 0.
C
  920 CONTINUE
      CALL INTLOG(JP_FATAL,'JACOBIF: Fail to converge M > 0', JPQUIET)
      JACOBIF = .FALSE.
      GOTO 999
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities
C granted to it by virtue of its status as an intergovernmental organisation
C nor does it submit to any jurisdiction.
C

       PROGRAM GRDEMO
C
      IMPLICIT NONE
C
C**** GRDEMO - Program to demonstrate use of GRIBEX routine.
C
C     Purpose.
C     --------
C
C     Demonstrates use of GRIBEX routine to unpack
C     GRIB coded data.
C
C**   Interface.
C     ----------
C
C     Method.
C     -------
C
C     Prints sections 0, 1, 2, 3 and 4 of GRIB message.
C
C     Externals.
C     ----------
C
C     GRIBEX
C     GRPRS0
C     GRPRS1
C     GRPRS2
C     GRPRS3
C     GRPRS4
C     PBOPEN
C     PBGRIB
C     PBCLOSE
C
C     Reference.
C     ----------
C
C     WMO Manual on Codes for GRIB definition.
C     WMO Publication No. 9, Volume B, for grid catalogue numbers.
C
C     Modifications
C     -------------
C
C     K. Fielding     ECMWF     Dec 2000
C     Set missing value for bit controlled fields.
C
C     Comments.
C     ---------
C
C     GRIBEX provides a number of packing/unpacking options.
C     See documentation for details.
C
C
C     -----------------------------------------------------------------
C
C     Arrays are dimensioned to accommodate T213/N160 data volumes.
C     JPBYTE is number of bytes per REAL
C
      INTEGER JPACK, JPBYTE
C
      PARAMETER (JPACK = 280000)
      PARAMETER (JPBYTE = 4)
C
C     Array for integer parameters from section 0 of GRIB message.
C
      INTEGER ISEC0 (2)
C
C     Array for integer parameters from section 1 of GRIB message.
C
      INTEGER ISEC1 (1024)
C
C     Array for integer parameters from section 2 of GRIB message.
C
      INTEGER ISEC2 (1024)
C
C     Array for integer parameters from section 3 of GRIB message.
C
      INTEGER ISEC3 (2)
C
C     Array for integer parameters from section 4 of GRIB message.
C
      INTEGER ISEC4 (512)
C
C     Array for real parameters from section 2 of GRIB message.
C
      REAL ZSEC2 (512)
C
C     Array for real parameters from section 3 of GRIB message.
C
      REAL ZSEC3 (2)
C
C     Array for real parameters from section 4 of GRIB message.
C     This is the binary data section and the array to hold
C     the unpacked data may need to be 4 times as long as that
C     for the packed data.
C
      REAL ZSEC4 (JPACK * 4)
C
C     Array to read in packed data.
C
      INTEGER INBUFF (JPACK)
C
C     GRIBEX routine has a number of encoding/decoding options.
C
      CHARACTER*256 YDATAFILE
      CHARACTER*2 INPUT
      CHARACTER*1 YOPER
      INTEGER IFILE, NUMERR, IPBLEN, IWORD, IFILEN, IRET, IARGC, NARGS
      INTEGER JCOUNT, LENOUT
CC    INTEGER JLAT, JLONG, JSTART, JEND
CC    REAL ZFIRST, ZLAST, ZSTEP, ZLAT
CC    REAL ZMAX
C
C     Pick up file names from command line.
C
      NARGS = IARGC()
      IF( NARGS.LT.2 ) THEN
         print*,'Usage: agrdemo -i inputfile'
         CALL EXIT(2)
      END IF

      CALL GETARG(1,INPUT)

      IF(INPUT.EQ.'-i') THEN
         CALL GETARG(2,YDATAFILE)
      ELSE
         print*,'Usage: agrdemo -i inputfile'
         CALL EXIT(2)
      END IF

C     Clear error counter.
C
      NUMERR = 0
C
C     Lengths of INBUFF and PSEC4
C
      IPBLEN = JPACK * JPBYTE
C
      IFILEN = INDEX(YDATAFILE,' ') - 1
C
      CALL PBOPEN (IFILE, YDATAFILE (1: IFILEN), 'R', IRET)
C
      IF ( IRET .NE. 0 ) THEN
        WRITE (*, *) ' Return code from PBOPEN = ', IRET
C       CALL PBCLOSE(IFILE, IRET)  ! (problem if PBOPEN failed)
        WRITE (*, *) 'Fault in PBOPEN'
        CALL EXIT(2)
      ENDIF
C
C     Loop through GRIB products in file.
      JCOUNT = 0
C
   50 CONTINUE
      JCOUNT = JCOUNT + 1
C
C     Read packed field into INBUFF.
      CALL PBGRIB (IFILE, INBUFF, IPBLEN, LENOUT, IRET )
C
      IF ( IRET .LT. 0 ) THEN
        WRITE (*, *) ' Return code from pbgrib = ', IRET
        IF ( IRET .EQ. -1) THEN
          WRITE  (*, *) ' End of file. Number of products =', (JCOUNT-1)
          CALL PBCLOSE (IFILE, IRET)
          WRITE (*,*) ' GRDEMO : Number of decoding errors = ', NUMERR
          STOP 'EOF'
        ELSE
          WRITE (*, *) ' kret = ',IRET,' after ', JCOUNT,' products.'
          CALL PBCLOSE (IFILE, IRET)
          WRITE (*, *) 'Fault in PBGRIB'
          CALL EXIT(2)
        ENDIF
      ENDIF
C
C     'D' function to unpack entire GRIB message.
C
      YOPER = 'D'
      WRITE (*,*) ' GRDEMO : Function code = ', YOPER
C
      IRET = 1
      LENOUT = LENOUT / JPBYTE
C
C     Set missing data values
C
      ISEC3 (2) = -99999
      ZSEC3 (2) = -99999.0
C
      CALL GRIBEX (ISEC0, ISEC1, ISEC2, ZSEC2, ISEC3, ZSEC3, ISEC4,
     X             ZSEC4, IPBLEN, INBUFF, LENOUT, IWORD, YOPER, IRET)
C
C     Check return code.
C
      WRITE (*,*) ' GRDEMO : GRIBEX return code = ', IRET
      IF (IRET .EQ. - 6) WRITE (*,*) ' GRDEMO : Pseudo-grib data found.'
      IF (IRET .GT. 0) THEN
        NUMERR = NUMERR + 1
        GO TO 50
      ENDIF
C
C     Print section 0 , 1 , 2 and 3 (if present) and 4.
C     Section 1 is the product definition section.
C     Section 2 is the grid definition section.
C     Section 3 is the bit-map section.
C     Section 4 is the data section.
C
      CALL GRPRS0 (ISEC0)
      CALL GRPRS1 (ISEC0, ISEC1)
C
      IF (ISEC1 (5) .EQ. 0 .OR. ISEC1 (5) .EQ. 64) THEN
        WRITE (*,*) ' GRDEMO : No section 2 in GRIB message.'
      ELSE
        CALL GRPRS2 (ISEC0, ISEC2, ZSEC2)
      ENDIF
C
      IF (ISEC1 (5) .EQ. 0 .OR. ISEC1 (5) .EQ. 128) THEN
        WRITE (*,*) ' GRDEMO : No section 3 in GRIB message.'
      ELSE
        CALL GRPRS3 (ISEC0, ISEC3, ZSEC3)
      ENDIF
C
      CALL GRPRS4 (ISEC0, ISEC4, ZSEC4)
C
C     Sample code to print maximum and minimum value in data.
C
C     ZMAX = ZSEC4 (1)
C     ZMIN = ZSEC4 (1)
C
C     DO JLAT = 2, ISEC4 (1)
C       ZMAX = MAX (ZMAX, ZSEC4 (JLAT) )
C       ZMIN = MIN (ZMIN, ZSEC4 (JLAT) )
C     ENDDO
C     WRITE (*, *)
C     WRITE (*, *) 'Maximum value in field is ', ZMAX
C     WRITE (*, *) 'Minimum value in field is ', ZMIN
C     WRITE (*, *)
C
C     Sample code to print all values along lines of
C     latitude for a lat/long grid only.
C
C     ZFIRST = REAL (ISEC2 (5) ) / 1000.0
C     ZLAST = REAL (ISEC2 (8) ) / 1000.0
C     ZSTEP = REAL (ISEC2 (9) ) / 1000.0
C     WRITE (*, *) 'Longitudes from ', ZFIRST, ' to ', ZLAST,
C    1  ' with stride ', ZSTEP
C
C     DO JLAT = 1, ISEC2 (3)
C       ZLAT = REAL (ISEC2 (4) - (JLAT - 1) * ISEC2 (10) ) / 1000.0
C       JSTART = (JLAT - 1) * ISEC2 (2) + 1
C       JEND = JLAT * ISEC2 (2)
C       WRITE (*, *)
C       WRITE (*, *) 'Values at latitude ', ZLAT
C       WRITE (*, *)
C       WRITE(*, '(1H , 5E16.5)' )
C    1    (ZSEC4 (JLONG), JLONG = JSTART, JEND)
C     ENDDO
C
      GO TO 50
C
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      INTEGER FUNCTION CHKOUT()
C
C---->
C*****CHKOUT*
C
C     PURPOSE
C     -------
C     check if intout  has been called
C     LINTOUT      - Flag to say whether or not intout  has been called
C
C     Function argument
C

#include "parim.h"
#include "nofld.common"

      CHKOUT = 0
      IF(LINTOUT) THEN
         CHKOUT = 1
         CALL INTLOG(JP_DEBUG,'CHKOUT: INTOUT has been called'
     X   ,JPQUIET)
      ENDIF
C
      RETURN
      END

C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      INTEGER FUNCTION CHKOUT()
C
C---->
C*****CHKOUT*
C
C     PURPOSE
C     -------
C     check if intout  has been called
C     LINTOUT      - Flag to say whether or not intout  has been called
C
C     Function argument
C

#include "parim.h"
#include "nofld.common"

      CHKOUT = 0
      IF(LINTOUT) THEN
         CHKOUT = 1
         CALL INTLOG(JP_DEBUG,'CHKOUT: INTOUT has been called'
     X   ,JPQUIET)
      ENDIF
C
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE ECDEF16(HFUNC,KSEC1,KGRIB,KLENG,KNSPT,KBITS,KPR,KRET)
C
C---->
C**** ECDEF16
C
C     Purpose.
C     --------
C
C     GRIB coding/decoding of ECMWF local use definition 16.
C
C**   Interface.
C     ----------
C
C     CALL ECDEF16(HFUNC,KSEC1,KGRIB,KLENG,KNSPT,KBITS,KPR,KRET)
C
C
C     Input Parameters.
C     -----------------
C
C     HFUNC - Requested function.
C             'C' to code data.
C             'D' to decode data.
C
C     KSEC1 - Array containing Grib Section 1 data.
C
C     KGRIB - Array containing Grib coded data.
C
C     KLENG - Length (words) of KGRIB.
C
C     KNSPT - Bit number after which insertion/extraction starts.
C
C     KBITS - Number of bits in computer word.
C
C     KPR   - Debug print switch.
C             0  , No printout.
C             >0 , Debug printout.
C
C     KRET  - Response to error indicator.
C             0        , Abort if error encountered.
C             Non-zero , Return to calling routine
C                             even if error encountered.
C
C     Output Parameters.
C     ------------------
C
C     KSEC1 - Array containing Grib Section 1 data.(Updated)
C
C     KGRIB - Array containing Grib coded data.(Updated)
C
C     KNSPT - Number of bit after last one inserted/extracted.(Updated)
C
C     KRET  - Return code.
C             0   , No error encountered.
C             2   , Error reported by routine INXBIT.
C
C
C     Method.
C     -------
C
C     Input data packed/unpacked in accordance with ECMWF usage of
C     local part of section 1 of Grib code, definition 16.
C
C
C     Externals.
C     ----------
C
C     INXBIT
C     ABORTX
C     CSGNBT
C     DSGNBT
C
C
C     Reference.
C     ----------
C
C     WMO Manual On Codes for Grib Code.
C
C
C     Comments.
C     ---------
C
C     None.
C
#include "ecdef16.h"
C
C     Author.
C     -------
C
C     J.D.Chambers     ECMWF      February 2000
C
C
C     Modifications.
C     --------------
C
C     None.
C
C
C----<
C     -----------------------------------------------------------------|
C*    Section 0 . Definition of variables. Data statements.
C     -----------------------------------------------------------------|
C
      IMPLICIT NONE
C
#include "common/grprs.h"
C
C     Parameters
C
      CHARACTER*1   HFUNC
      INTEGER KSEC1, KGRIB, KLENG, KNSPT, KBITS, KPR, KRET
      DIMENSION KGRIB(*)
      DIMENSION KSEC1(*)
C
C     Local variables
C
      INTEGER IRET, IZERO, LOOP
      LOGICAL LENCODE
C
C     -----------------------------------------------------------------|
C*    Section 1 . Set initial values.
C     -----------------------------------------------------------------|
C
  100 CONTINUE
C
      IRET = KRET
      LENCODE = ( HFUNC.EQ.'C' )
C
C     -----------------------------------------------------------------|
C*    Section 2 . Handle definition 16.
C     -----------------------------------------------------------------|
C
  200 CONTINUE
C
C     Octet 50-51 : Ensemble member number.
C     One 16-bit field.
C
      CALL INXBIT(KGRIB,KLENG,KNSPT,KSEC1(42),1,KBITS,16,HFUNC,KRET)
      IF( KRET.NE.0 ) THEN
        KRET = 2
        GOTO 990
      ENDIF
C
      IF( .NOT. LENCODE ) KSEC1(43) = 0
C
C     Octet 52-53 : System number.
C     One 16-bit field.
C
      CALL INXBIT(KGRIB,KLENG,KNSPT,KSEC1(44),1,KBITS,16,HFUNC,KRET)
      IF( KRET.NE.0 ) THEN
        KRET = 2
        GOTO 990
      ENDIF
C
C     Octet 54-55 : Method number.
C     One 16-bit field.
C
      CALL INXBIT(KGRIB,KLENG,KNSPT,KSEC1(45),1,KBITS,16,HFUNC,KRET)
      IF( KRET.NE.0 ) THEN
        KRET = 2
        GOTO 990
      ENDIF
C
C     Octet 56-59 : Verifying month (in format YYYYMM).
C     One 32-bit field.
C
      CALL INXBIT(KGRIB,KLENG,KNSPT,KSEC1(46),1,KBITS,32,HFUNC,KRET)
      IF( KRET.NE.0 ) THEN
        KRET = 2
        GOTO 990
      ENDIF
C
C     Octet 60 : Averaging period (eg 6-hour, 24-hour).
C     One 8-bit field.
C
      CALL INXBIT(KGRIB,KLENG,KNSPT,KSEC1(47),1,KBITS,8,HFUNC,KRET)
      IF( KRET.NE.0 ) THEN
        KRET = 2
        GOTO 990
      ENDIF
C
C     Octet 61-80 : Spare
C     Twenty 8-bit fields.
C
      IZERO = 0
      IF( LENCODE ) THEN
        DO LOOP = 1, 20
          CALL INXBIT(KGRIB,KLENG,KNSPT,IZERO,1,KBITS,8,HFUNC,KRET)
          IF( KRET.NE.0 ) THEN
            KRET = 2
            GOTO 990
          ENDIF
        ENDDO
      ELSE
        KNSPT = KNSPT + 20*8
      ENDIF
C
C     -----------------------------------------------------------------|
C*    Section 9 . Abort/return to calling routine. Format statements.
C     -----------------------------------------------------------------|
C
  900 CONTINUE
C
      IF( KPR.GE.1 ) WRITE(GRPRSM,*) 'ECDEF16: Output: KNSPT = ', KNSPT 
C
C     Abort if requested to do so when an error has been encountered.
C
      IF( (IRET.EQ.0).AND.(KRET.NE.0) ) CALL ABORTX ('ECDEF16')
C
      RETURN
C
  990 CONTINUE
      WRITE(GRPRSM,*) 'ECDEF16: Error reported by routine INXBIT.'
      RETURN
C
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      logical function big_endian()

      implicit none

      integer*4            icharacter
      character*4 testcharacter
      integer*4             newint


      testcharacter="ABCD"

      newint=0
      read(testcharacter,'(a4)') icharacter
c     icharacter=transfer(testcharacter,0)

      call mvbits(icharacter, 0, 8, newint, 0)

      if(char(newint) .eq. 'A') then
c         little endian
          big_endian=.false.
      else
c         big endian
          big_endian=.true.
      end if
      end

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE CSGNBT( KOUT, KIN, KPOS, KRET)
C---->
C
C     Set the sign bit in position KPOS of word KOUT, and
C     set the rest of bits (KPOS-1) -> using +ve value of 
C     KIN.
C
C     On return, KRET = 0 if all OK.
C
C----<
      IMPLICIT NONE
      INTEGER KOUT, KIN, KPOS, KRET

      INTEGER JPBITS
#ifdef INTEGER_8
      PARAMETER ( JPBITS = 64 )
#else
      PARAMETER ( JPBITS = 32 )
#endif
      INTEGER ISBIT, IVALUE, INSPT, IRETA, IRETB

      IF ( KIN .LT. 0 ) THEN
        IVALUE = -KIN
        ISBIT = 1
      ELSE
        IVALUE = KIN
        ISBIT = 0
      ENDIF

#if defined (VAX) || defined (__alpha)
C
C     VAX bit handling with VAX specific intrinsics
      KOUT = JISHFT( ISBIT, KPOS-1)
      KOUT = KOUT + IVALUE
#else
C
C     Bit handling using INXBIT
      INSPT = 0
      CALL INXBIT( KOUT, 1, INSPT, ISBIT, 1, JPBITS,
     X             (JPBITS-KPOS+1), 'C', IRETA)
      CALL INXBIT( KOUT, 1, INSPT, IVALUE, 1, JPBITS,
     X             (KPOS-1), 'C', IRETB)
      KRET = IRETA+IRETB
      IF ( KRET .NE. 0 ) THEN
        WRITE(*,*) ' CSGNBT - Problem packing bits in value'
        GOTO 900
      ENDIF
#endif

  900 CONTINUE

      RETURN
      END

C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      logical function big_endian()

      implicit none

      integer*4            icharacter
      character*4 testcharacter
      integer*4             newint


      testcharacter="ABCD"

      newint=0
      read(testcharacter,'(a4)') icharacter
c     icharacter=transfer(testcharacter,0)

      call mvbits(icharacter, 0, 8, newint, 0)

      if(char(newint) .eq. 'A') then
c         little endian
          big_endian=.false.
      else
c         big endian
          big_endian=.true.
      end if
      end

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE BUFREN(KSEC0,KSEC1,KSEC2,KSEC3,KSEC4,
     1                  KTDLEN,KTDLST,KDLEN,KDATA,KELEM,KVALS,
     2                  VALUES,CVALS,KBUFL,KBUFF,KERR)
C
C**** *BUFREN*
C
C
C     PURPOSE.
C     --------
C          ENCODE BUFR MESSAGE.
C
C
C**   INTERFACE.
C     ----------
C
C               *CALL BUFREN(KSEC0,KSEC1,KSEC2,KSEC3,KSEC4,
C                            KTDLEN,KTDLST,KDLEN,KDATA,KELEM,KVALS,
C                            VALUES,CVALS,KBUFL,KBUFF,KERR)
C
C        INPUT :
C               *KSEC0*   -  INTEGER ARRAY OF 3 WORDS CONTAINING
C                            BUFR SECTION 0 INFORMATION
C                            KSEC0( 1)-- LENGTH OF SECTION 0 (BYTES)
C                            KSEC0( 2)-- TOTAL LENGTH OF BUFR MESSAGE (BYTES)
C                            KSEC0( 3)-- BUFR EDITION NUMBER
C
C               *KSEC1*   -  INTEGER ARRAY OF AT LEAST 40 WORDS
C                            CONTAINING BUFR SECTION 1 INFORMATION
C                            KSEC1( 1)-- LENGTH OF SECTION 1 (BYTES)
C                            KSEC1( 2)-- BUFR EDITION NUMBER
C                            KSEC1( 3)-- ORIGINATING CENTRE
C                            KSEC1( 4)-- UPDATE SEQUENCE NUMBER
C                            KSEC1( 5)-- FLAG (PRESENCE OF SECTION 2)
C                            KSEC1( 6)-- BUFR MESSAGE TYPE
C                            KSEC1( 7)-- BUFR MESSAGE SUBTYPE
C                            KSEC1( 8)-- VERSION NUMBER OF LOCAL TABLE USED
C                            KSEC1( 9)-- YEAR
C                            KSEC1(10)-- MONTH
C                            KSEC1(11)-- DAY
C                            KSEC1(12)-- HOUR
C                            KSEC1(13)-- MINUTE
C                            KSEC1(14)-- BUFR MASTER TABLE
C                            KSEC1(15)-- VERSION NUMBER OF MASTER TABLE USED
C                            KSEC1(16) TO KSEC1(40) - LOCAL ADP CENTRE
C                                        INFORMATION(PACKED FORM)
C
C
C                            FOR BUFR EDITION 3 ONWARD
C
C                            KSEC1(16)-- ORIGINATING SUB-CENTRE
C                            KSEC1(17)-- NOT USED
C                            KSEC1(18) TO KSEC1(JSEC1) - LOCAL ADP CENTRE
C                                        INFORMATION(PACKED FORM)
C
C                            FOR BUFR EDITION 4 ONWARD
C
C                            KSEC1(16)-- ORIGINATING SUB-CENTRE
C                            KSEC1(17)-- INTERNATIONAL SUB-CATEGORY (SEE COMMON TABLE C-13
C                            KSEC1(18)-- SECOND
C                            KSEC1(19)-- YEAR
C                            KSEC1(20)-- MONTH
C                            KSEC1(21)-- DAY
C                            KSEC1(22)-- HOUR
C                            KSEC1(23)-- MINUTE
C                            KSEC1(24)-- SECOND
C                            KSEC1(25)-- YEAR
C                            KSEC1(26)-- MONTH
C                            KSEC1(27)-- DAY
C                            KSEC1(28)-- HOUR
C                            KSEC1(29)-- MINUTE
C                            KSEC1(30)-- SECOND
C                            KSEC1(31)-- MOST SOUTHERN LATITUDE  (-90 to 90)
C                            KSEC1(32)-- MOST WESTERN LONGITUDE  ( 0-360)
C                            KSEC1(33)-- MOST NORTHEN LATITUDE   (-90 to 90)
C                            KSEC1(34)-- MOST EASTERN LONGITUDE  ( 0-360)
C                            KSEC1(35) TO KSEC1(JSEC1) - LOCAL ADP CENTRE INFORMATION(PACKED FORM)
C
C               *KSEC2*   -  INTEGER ARRAY OF AT LEAST 64 WORDS
C                            CONTAINING BUFR SECTION 2 INFORMATION
C                            KSEC2( 1)-- LENGTH OF SECTION 2 (BYTES)
C                            KSEC2( 2) TO KSEC2(64) LOCAL ADP CENTRE
C                                        INFORMATION(PACKED FORM)
C
C               *KSEC3*   -  INTEGER ARRAY OF 4 WORDS CONTAINING
C                            BUFR SECTION 3 INFORMATION
C                            KSEC3( 1)-- LENGTH OF SECTION 3 (BYTES)
C                            KSEC3( 2)-- RESERVED
C                            KSEC3( 3)-- NUMBER OF SUBSETS
C                            KSEC3( 4)-- FLAG (DATA TYPE,DATA COMPRESSION)
C
C               *KSEC4*   -  INTEGER ARRAY OF 2 WORDS CONTAINING
C                            BUFR SECTION 4 INFORMATION
C                            KSEC4( 1)-- LENGTH OF SECTION 4 (BYTES)
C                            KSEC4( 2)-- RESERVED
C
C               *KTDLEN*  -  INTEGER NUMBER OF DATA DESCRIPTORS IN SECTION 3
C               *KTDLST*  -  INTEGER ARRAY OF AT LEAST KTDLEN WORDS
C                            CONTAINING DATA DESCRIPTORS FOR BUFR SECTION 3
C               *KDLEN*   -  INTEGER (DIMENSION OF KDATA ARRAY)
C               *KDATA*   -  INTEGER ARRAY CONTAINING DATA NEEDED FOR DATA
C                            DESCRIPTOR EXPANSION (DELAYED REPLICATION FACTORS)
C                            WHICH APPEAR IN THE VALUES ARRAY
C
C               *KELEM*   -  INTEGER NUMBER OF ELEMENTS IN BUFR TEMPLATE.
C               *KVALS*   -  INTEGER (DIMENSION OF VALUES ARRAY)
C               *VALUES*  -  REAL ARRAY OF KVALS WORDS (EXPANDED DATA )
C               *CVALS*   -  CHARACTER*80  ARRAY OF KVALS
C
C        OUTPUT:
C               *KBUFL*   -  LENGTH OF BUFR MESSAGE (WORDS)
C               *KBUFF*   -  INTEGER ARRAY CONTAINING BUFR MESSAGE
C               *KERR*    -  RETURN ERROR CODE
C
C
C     METHOD.
C     -------
C
C          BUFR MESSAGE SECTIONS CONTENET, AND DATA ARE PASSED FOR
C     FOR PACKING INTO FM-94 BUFR DATA.DURING UNPACKING A BIT PATHERN
C     GBYTE AND GBYTES ROUTINES (VMS VERSION) ARE USED.
C
C
C     EXTERNALS.
C     ----------
C
C          BUENS0   -  PACK SECTION 0 OF BUFR MESSAGE
C          BUENS1   -  PACK SECTION 1 OF BUFR MESSAGE
C          BUENS2   -  PACK SECTION 2 OF BUFR MESSAGE
C          BUENS3   -  PACK SECTION 3 OF BUFR MESSAGE
C          BUETAB    -  LOAD REQUIRED BUFR TABLES
C          BUENS4   -  PACK SECTION 4 OF BUFR MESSAGE
C          BUENS5   -  PACK SECTION 5 OF BUFR MESSAGE
C
C     REFERENCE.
C     ----------
C
C          NONE.
C
C     AUTHOR.
C     -------
C
C          M. DRAGOSAVAC    *ECMWF*       15/01/91.
C
C
C     MODIFICATIONS.
C     --------------
C
C          NONE.
C
C
      IMPLICIT LOGICAL(L,O,G), CHARACTER*8(C,H,Y)
C
C
#     include "parameter.F"
#     include "bcomunit.F"
#     include "bcmwork.F"
#     include "bcmdefc.F"
#     include "bcmoff.F"
C
      DIMENSION KBUFF(KBUFL)
      DIMENSION KSEC0(JSEC0),KSEC1(JSEC1),KSEC2(JSEC2)
     1,         KSEC3(JSEC3),KSEC4(JSEC4)
C
#ifndef R_4
      REAL*8 VALUES(KVALS)
      REAL*8 RVIND
      REAL*8 EPS
#else
      REAL   VALUES(KVALS)
      REAL   RVIND
      REAL   EPS
#endif
      DIMENSION  KTDLST(KTDLEN)
      DIMENSION  KDATA(KDLEN)
C
      CHARACTER*4   CECMWF,CUSER
      CHARACTER*80  CVALS(KVALS)
C
      SAVE NWPTB1,NBPTB1
C
C     ------------------------------------------------------------------
C
C*          1.   SET CONSTANTS.
C                --------------
 100  CONTINUE
C
      KERR=0
      IF(CECMWF.NE.'ECMF') THEN
         CALL BUIVAR(KERR)
         KPT   = 0
         CECMWF='ECMF'
      END IF
C
      NEDN=KSEC0(3)
C
C     -----------------------------------------------------------------
C*          2.  PACK SECTION 0.
C               ---------------
 200  CONTINUE
C
      CALL BUENS0( KSEC0,KBUFL,KBUFF,KERR )
      IF(KERR.GT.0) RETURN
C
C     ------------------------------------------------------------------
C
C*          3.   PACK SECTION 1.
C                ---------------
 300  CONTINUE
C
      CALL BUENS1( KSEC0,KSEC1,KBUFL,KBUFF,KERR )
      IF(KERR.GT.0) RETURN
C
C     ------------------------------------------------------------------
C
C*          4.  PACK SECTION 2.
C               ---------------
 400  CONTINUE
C
      CALL BUENS2( KSEC1,KSEC2,KBUFL,KBUFF,KERR )
      IF(KERR.GT.0) RETURN
C
C     ------------------------------------------------------------------
C
C*          5.   LOAD BUFR TABLES.
C                -----------------
 500  CONTINUE
C
      CALL BUETAB(KSEC1,KERR)
      IF(KERR.GT.0) RETURN
C
C     ------------------------------------------------------------------
C          6.  PACK SECTION 3.
C              ---------------
 600  CONTINUE
C
      CALL BUENS3( KSEC3,KTDLEN,KTDLST,KBUFL,KBUFF,KERR)
      IF(KERR.GT.0) RETURN
C
C     -----------------------------------------------------------------
C
      OMULTI=.FALSE.
      NSUBSET=1
      IF(IAND(KSEC3(4),64).EQ.0.AND.KSEC3(3).GT.1) THEN
C
C        Multi-subset uncompressed data
C
         NSUBSET=0
         OMULTI=.TRUE.
         DO I=1,KSEC3(3)
         NWT=0
         M=0
         NSUBSET=I
         KERR=0
         CALL BUETD(KPT,KTDLEN,KTDLST,KDLEN,KDATA,KSEC3,
     1              KVALS,VALUES,KELEM,KERR)
         IF(KERR.GT.0) RETURN
C
          CALL BUENS4(KSEC3,KSEC4,KELEM,KVALS,VALUES,CVALS,
     1                KBUFL,KBUFF,KERR)
         IF(KERR.GT.0) RETURN
         END DO

         GO TO 800
      END IF
C     ------------------------------------------------------------------
C          6.1  EXPAND DATA DESCRIPTORS.
C               ------------------------
 610  CONTINUE
      CALL BUETD(KPT,KTDLEN,KTDLST,KDLEN,KDATA,KSEC3,
     1           KVALS,VALUES,KELEM,KERR)
      IF(KERR.GT.0) RETURN
C
C
C     ------------------------------------------------------------------
C
C*          7.   PACK SECTION 4.
C                ---------------
 700  CONTINUE
C
      CALL BUENS4(KSEC3,KSEC4,KELEM,KVALS,VALUES,CVALS,
     1            KBUFL,KBUFF,KERR)
      IF(KERR.GT.0) RETURN
C
C
C     ------------------------------------------------------------------
C
C*          8.   PACK SECTION 5.
C                ---------------
 800  CONTINUE
C
      CALL BUENS5(KSEC0,KSEC1,KBUFL,KBUFF,KERR)
      IF(KERR.GT.0) RETURN
C
C     -----------------------------------------------------------------
C
C*          9.   SET TOTAL BUFR MESSAGE LENGTH.
C                ------------------------------
 900  CONTINUE
C
C
C     -----------------------------------------------------------------
      RETURN
C
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE BUGTLL(KELEM,KTDEXL,KTDEXP,KSEC1,KSEC3 ,
     1                    KVALS, VALUES,  KERR)
C
C**** *BUGTLL*
C
C
C     PURPOSE.
C     --------
C           Set section 1 info for Bufr Edition 4
C
C
C**   INTERFACE.
C     ----------
C
C          NONE.
C
C     METHOD.
C     -------
C
C          
C
C     EXTERNALS.
C     ----------
C
C         NONE.
C
C     REFERENCE.
C     ----------
C
C          NONE.
C
C     AUTHOR.
C     -------
C
C          M. DRAGOSAVAC    *ECMWF*       06/11/2004.
C
C
C     MODIFICATIONS.
C     --------------
C
C          NONE.
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
C
      DIMENSION KSEC1(*),KSEC3(*)
      DIMENSION KTDEXP(*)
#ifndef R_4
      REAL*8 VALUES(*)
      REAL*8 RYEAR(10000)
      REAL*8 RMONTH(10000)
      REAL*8 RDAY(10000)
      REAL*8 RHOUR(10000)
      REAL*8 RMINUTE(10000)
      REAL*8 RSECOND(10000)
      REAL*8 RMINLAT, RMINLON, RMAXLAT, RMAXLON
#else
      REAL   VALUES(*)
      REAL   RYEAR(10000)
      REAL   RMONTH(10000)
      REAL   RDAY(10000)
      REAL   RHOUR(10000)
      REAL   RMINUTE(10000)
      REAL   RSECOND(10000)
      REAL   RMINLAT, RMINLON, RMAXLAT, RMAXLON
#endif
      DIMENSION IDATE(10000)
      DIMENSION ITIME(10000)
C
C     -----------------------------------------------------------------
C
C                1. FIND TIME,LAT,LONG
C
      IPYEAR=0
      IPMONTH=0
      IPDAY=0
      IPHOUR=0
      IPMINUTE=0
      IPSECOND=0
      IPLAT=0
      IPLON=0
C
      DO I=1,KTDEXL
        IF(KTDEXP(I).EQ.004001) THEN
           IF(IPYEAR.EQ.0) IPYEAR=I
        END IF
        IF(KTDEXP(I).EQ.004002) THEN
           IF(IPMONTH.EQ.0) IPMONTH=I
        END IF
        IF(KTDEXP(I).EQ.004003) THEN
           IF(IPDAY.EQ.0) IPDAY=I
        END IF
        IF(KTDEXP(I).EQ.004004) THEN
           IF(IPHOUR.EQ.0) IPHOUR=I
        END IF
        IF(KTDEXP(I).EQ.004005) THEN
           IF(IPMINUTE.EQ.0) IPMINUTE=I
        END IF
        IF(KTDEXP(I).EQ.004006) THEN
           IF(IPSECOND.EQ.0) IPSECOND=I
        END IF
        IF(KTDEXP(I).EQ.005001) THEN
           IF(IPLAT.EQ.0) IPLAT=I
        END IF
        IF(KTDEXP(I).EQ.006001) THEN
           IF(IPLON.EQ.0) IPLON=I
        END IF
        IF(KTDEXP(I).EQ.005002) THEN
           IF(IPLAT.EQ.0) IPLAT=I
        END IF
        IF(KTDEXP(I).EQ.006002) THEN
           IF(IPLON.EQ.0) IPLON=I
        END IF
      END DO
C
       CALL FMMH(IPLAT,IPLON,KELEM,VALUES,KSEC3,RMINLAT,RMINLON,
     1           RMAXLAT,RMAXLON)
C
C      IF(RMINLON.LT.0) RMINLON=360.0-ABS(RMINLON)
C      IF(RMAXLON.lt.0) RMAXLON=360.0-ABS(RMAXLON)
C
       KSEC1(31)=NINT(RMINLAT*100000)
       KSEC1(32)=NINT(RMINLON*100000)
       KSEC1(33)=NINT(RMAXLAT*100000)
       KSEC1(34)=NINT(RMAXLON*100000)
C
       J=0
       IF(IPYEAR.NE.0) THEN
          DO I=1,KSEC3(3)
             IYE=IPYEAR+(I-1)*KELEM
             J=J+1
             RYEAR(J)=VALUES(IYE)
          END DO 
       ELSE
          DO I=1,KSEC3(3)
          RYEAR(I)=0.
          END DO
       END IF
       J=0
       IF(IPMONTH.NE.0) THEN
          DO I=1,KSEC3(3)
             IMO=IPMONTH+(I-1)*KELEM
             J=J+1
             RMONTH(J)=VALUES(IMO)
          END DO
       ELSE
          DO I=1,KSEC3(3)
          RMONTH(I)=0.
          END DO
       END IF
       J=0
       IF(IPDAY.NE.0) THEN
          DO I=1,KSEC3(3)
             IDA=IPDAY+(I-1)*KELEM
             J=J+1
             RDAY(J)=VALUES(IDA)
          END DO
       ELSE
          DO I=1,KSEC3(3)
          RDAY(I)=0.
          END DO
       END IF
       J=0
       IF(IPHOUR.NE.0) THEN
          DO I=1,KSEC3(3)
             IHO=IPHOUR+(I-1)*KELEM
             J=J+1
             RHOUR(J)=VALUES(IHO)
          END DO
       ELSE
          DO I=1,KSEC3(3)
          RHOUR(I)=0.
          END DO
       END IF
       J=0
       IF(IPMINUTE.NE.0) THEN
          DO I=1,KSEC3(3)
             IMI=IPMINUTE+(I-1)*KELEM
             J=J+1
             RMINUTE(J)=VALUES(IMI)
          END DO
       ELSE
          DO I=1,KSEC3(3)
          RMINUTE(I)=0.
          END DO
       END IF
       J=0
       IF(IPSECOND.NE.0) THEN
          DO I=1,KSEC3(3)
             ISE=IPSECOND+(I-1)*KELEM
             J=J+1
             RSECOND(J)=VALUES(ISE)
          END DO
       ELSE
          DO I=1,KSEC3(3)
          RSECOND(I)=0.
          END DO
       END IF
C
       
       DO I=1,KSEC3(3)
       IDATE(I)=NINT(RYEAR(I))*10000+NINT(RMONTH(I))*100+NINT(RDAY(I))
       ITIME(I)=NINT(RDAY(I))*1000000+NINT(RHOUR(I))*10000
     1          +NINT(RMINUTE(I))*100 +NINT(RSECOND(I))
       END DO
C
       IDMAX=IDATE(1)
       ITMAX=ITIME(1)
       IDMIN=IDATE(1)
       ITMIN=ITIME(1)
       IMAX=1
       IMIN=1
C
       DO I=1,KSEC3(3)
          IF(IDATE(I).GT.IDMAX) THEN
             IDMAX=IDATE(I)
             ITMAX=ITIME(I)
             IMAX=I
          ELSEIF(IDATE(I).EQ.IDMAX) THEN
             IF(ITIME(I).GT.ITMAX) THEN
                ITMAX=ITIME(I)
                IMAX=I
             END IF
          END IF
       END DO
C
       DO I=1,KSEC3(3)
          IF(IDATE(I).LT.IDMIN) THEN
             IDMIN=IDATE(I)
             ITMIN=ITIME(I)
             IMIN=I
          ELSEIF(IDATE(I).EQ.IDMIN) THEN
             IF(ITIME(I).LT.ITMIN) THEN
                ITMIN=ITIME(I)
                IMIN=I
             END IF
          END IF
       END DO
C
       KSEC1(19)=NINT(RYEAR(IMIN))
       KSEC1(20)=NINT(RMONTH(IMIN))
       KSEC1(21)=NINT(RDAY(IMIN))
       KSEC1(22)=NINT(RHOUR(IMIN))
       KSEC1(23)=NINT(RMINUTE(IMIN))
       KSEC1(24)=NINT(RSECOND(IMIN))
C
       KSEC1(25)=NINT(RYEAR(IMAX))
       KSEC1(26)=NINT(RMONTH(IMAX))
       KSEC1(27)=NINT(RDAY(IMAX))
       KSEC1(28)=NINT(RHOUR(IMAX))
       KSEC1(29)=NINT(RMINUTE(IMAX))
       KSEC1(30)=NINT(RSECOND(IMAX))
C

      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      INTEGER FUNCTION D2ROSD ( KDATA,  KLEN,   KORDER, KPOWER, KMXPWR,
     X                          KBIAS,  OVECTA, ODEBUG )
C
C---->
C**** D2ROSD
C
C     Purpose.
C     --------
C
C     Rebuild Original field from Spatial Differences, when using
C     non-local features of GRIB second-order extended packing.
C
C**   Interface.
C     ----------
C
C     IRET = D2ROSD ( KDATA,  KLEN,  KPOWER, KMXPWR, OVECTA, ODEBUG )
C
C     Function result value is zero, except for non-valid order.
C
C     Input Parameters.
C     -----------------
C
C     KDATA      - Array of normalized values.
C     KLEN       - Exact number of grid-points to handle.
C     KPOWER     - Auxilary array, containing precomputed powers of 2-1.
C     KMXPWR     - Maximum number of bits allowed.
C     KBIAS      - BIAS of spatial differences.
C     OVECTA     - True if vectorizing algorithm has to be used.
C     ODEBUG     - True for some debug printout.
C
C
C     Output Parameters (effective only if function value is non zero).
C     ------------------
C
C     KDATA      - Array of normalized values (transformed).
C
C
C     Method.
C     -------
C
C     For vector systems, an external loop on order of spatial
C     differencing is made, and inner recursive sum is made by a
C     or by a vectorizing algorithm (that implies an overhead of
C     LOG2(KLEN) in operations and memory accesses).
C
C     For scalar systems, a single scan is performed, with contents
C     specific for each order.
C
C
C     Externals.
C     ----------
C
C     C2BITW    - Computes bit width of a positive integer value.
C
C
C     Reference.
C     ----------
C
C     None.
C
C
C     Comments.
C     --------
C
C     None.
C
C
C     Author.
C     -------
C
C     J. Clochard, Meteo France, for ECMWF - April 1998.
C
C
C     Modifications.
C     _____________
C
C     J. Clochard, September 1998.
C     Optimisation for scalar systems (memory access reduced).
C
C
C----<
C     -----------------------------------------------------------------
C*    Section 0. Definition of variables.
C     -----------------------------------------------------------------
C
      IMPLICIT NONE
C
#include "common/grprs.h"
C
C     Parameters
C
      INTEGER JPORDR
C
C       Maximum order of spatial differencing allowed.
C
      PARAMETER ( JPORDR=3 )
C
C     Subroutine arguments
C
      INTEGER KLEN, KMXPWR, KBIAS, KORDER
      INTEGER KDATA (KLEN), KPOWER (0:KMXPWR)
C
      LOGICAL OVECTA, ODEBUG
C
C     Local variables.
C
      INTEGER IOFF, J, J2, JORDER, ILOG2N, IORIGI, ILEN, IRETFN, I1DIFF
      INTEGER I2DIFF
C
      INTEGER C2BITW
      EXTERNAL C2BITW
C
C     -----------------------------------------------------------------
C*    Section 1 . Performs initial checks.
C     -----------------------------------------------------------------
C
  100 CONTINUE
C
#ifndef ebug2o
      IF (ODEBUG) THEN
#endif
        WRITE(GRPRSM,FMT=9100) KLEN, KORDER, KBIAS
#ifndef ebug2o
      ENDIF
#endif
C
      IF (KORDER.LE.0.OR.KORDER.GT.JPORDR) THEN
        IRETFN = 23110
        WRITE(GRPRSM,FMT=9110) KORDER, JPORDR
        GOTO 900
      ENDIF
C
C     -----------------------------------------------------------------
C*    Section 2 . Preprocessing of first values of field.
C     -----------------------------------------------------------------
C
  200 CONTINUE
C
      IF (OVECTA) THEN
C
C       For higher orders, and due to iterative outer loop on order,
C       it is necessary that the 2nd value contains the first 1st-order
C       difference (between the 2 first values), and so on.
C
        DO 202 JORDER = 2, KORDER
C
#ifdef CRAY
CDIR$ NOVECTOR
#endif
#ifdef FUJITSU
!OCL SCALAR
#endif
          DO 201 J = KORDER, JORDER, -1
C
            KDATA(J)=KDATA(J)-KDATA(J-1)
C
  201     CONTINUE
#ifdef CRAY
CDIR$ VECTOR
#endif
#ifdef FUJITSU
!OCL VECTOR
#endif
C
  202   CONTINUE
C
      ENDIF
C
C     -----------------------------------------------------------------
C*    Section 3 . Rebuild original field integer values.
C     -----------------------------------------------------------------
C
  300 CONTINUE
C
      IF (OVECTA) THEN
C
C                       Vectorizable algorithm.
C                       ----------------------
C
        DO 315 JORDER = KORDER, 1, -1
C
          ILEN=KLEN-JORDER
          ILOG2N=C2BITW ( ILEN-1, KMXPWR, KPOWER, KMXPWR )
C
          IF (JORDER.EQ.KORDER) THEN
C
C              Bias is added at first scan.
C
            DO 312 J2 = 1, ILOG2N
C
              IOFF=KPOWER(J2-1)+1
C
#ifdef CRAY
CDIR$ IVDEP
#endif
#ifdef FUJITSU
!OCL NOVREC
#endif
              DO 311 J = KLEN, IOFF+JORDER, -1
C
                KDATA(J)=KDATA(J)+(KDATA(J-IOFF)+KBIAS)
C
  311         CONTINUE
C
  312       CONTINUE
C
          ELSE
C
            DO 314 J2 = 1, ILOG2N
C
              IOFF=KPOWER(J2-1)+1
C
#ifdef CRAY
CDIR$ IVDEP
#endif
#ifdef FUJITSU
!OCL NOVREC
#endif
              DO 313 J = KLEN, IOFF+JORDER, -1
C
                KDATA(J)=KDATA(J)+KDATA(J-IOFF)
C
  313         CONTINUE
C
  314       CONTINUE
C
          ENDIF
C
  315   CONTINUE
C
      ELSE
C
C                       Recurrent (scalar) algorithm.
C                       ----------------------------
C
C             Only one scan, with specific code for each order.
C
C         Initialize recursion.
C
        IORIGI=KDATA(KORDER)
C
        IF (KORDER.EQ.1) THEN
C
          DO 321 J = 2, KLEN
C
            IORIGI=IORIGI+(KDATA(J)+KBIAS)
            KDATA(J)=IORIGI
C
  321     CONTINUE
C
        ELSEIF (KORDER.EQ.2) THEN
C
          I1DIFF=KDATA(2)-KDATA(1)
C
          DO 322 J = 3, KLEN
C
            I1DIFF=I1DIFF+(KDATA(J)+KBIAS)
            IORIGI=IORIGI+I1DIFF
            KDATA(J)=IORIGI
C
  322     CONTINUE
C
        ELSE
C
          I1DIFF=KDATA(3)-KDATA(2)
          I2DIFF=I1DIFF-(KDATA(2)-KDATA(1))
C
          DO 323 J = 4, KLEN
C
            I2DIFF=I2DIFF+(KDATA(J)+KBIAS)
            I1DIFF=I1DIFF+I2DIFF
            IORIGI=IORIGI+I1DIFF
            KDATA(J)=IORIGI
C
  323     CONTINUE
C
        ENDIF
C
#ifdef ebug2o
        ILEN=MIN (KLEN,10)
        PRINT *,'d2rosd - JORDER=',JORDER,',KDATA(1:',ILEN,')=',
     S           (KDATA(J),J=1,ILEN)
C
#endif
      ENDIF
C
      IRETFN=0
C
C     -----------------------------------------------------------------
C*    Section 9 . Return to calling routine.
C     -----------------------------------------------------------------
C
  900 CONTINUE
C
      D2ROSD = IRETFN
C
#ifndef ebug2o
C
      IF (ODEBUG) THEN
#endif
        WRITE(GRPRSM,FMT=9900) IRETFN
#ifndef ebug2o
      ENDIF
#endif
C
      RETURN
C
 9100 FORMAT (' D2ROSD: Function start, KLEN =',I8,', KORDER =',I2,
     X        ', KBIAS=',I9,'.')
C
 9110 FORMAT (' D2ROSD: Order requested:',I5,', out of [1,',I1,'].')
C
 9312 FORMAT (' D2ROSD: Range diagnostic is ',A,
     X        ' of spatial differences, order',I2,'.')
 9331 FORMAT (' D2ROSD: Selected order:',I2,', range diagnostics:',
     X        4I8,'.')
C
 9900 FORMAT (' D2ROSD: Function return code =',I6,'.')
C
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C


      Subroutine BLOKEX (Ksec0,Ksec1,Ksec2,Klen2,
     &                   Kblok,Kbdim,Kword,Kmaxw,Hoper,Hform,Kret)
C---->
c**
c****  Name  *BLOKEX*
c****  ----
c**
c**   Purpose
c**   -------
c**       1) Block data in BLOK code, Edition 0.
c**       2) Unblock data from BLOK code.
c**       3) Decode only identification section of BLOK
c**          coded data ie Sections 0 and 1.
c**
c**          A number of options exist when coding or decoding data.
c**          See values allowed for requested function, Hoper, Below.
c**
c**   Interface
c**   ---------
c**
c**       Call BLOKEX (Ksec0,Ksec1,Ksec2,Klen2,
c**  &                 Kblok,Kbdim,Kword,Kmaxw,Hoper,Hform,Kret)
c**
c**
c**       Integer   K*
c**       Character H*
c**       
c**       Input parameters for all functions:
c**       -----------------------------------
c**
c**             Hoper - Requested function:
c**
c**                     'B' To code data in BLOK code. The input, 
c**                         when using this function, is the full
c**                         data array (original parent form) Ksec2.
c**                         The output array, Kblok, in this case
c**                         contains all related BLOK messages. The
c**                         length of each BLOK message is Kmaxw,
c**                         except the last one which length is 
c**                         (Kword-(Ksec0(5)-1)*Kmaxw).
c**
c**                     'C' To code data in BLOK code. The input,
c**                         when using this function, is the part of the
c**                         data array (origianl parent form) Ksec2 
c**                         which will be coded in BLOK code.
c**
c**                     'F' To unblock data from BLOK code. By 
c**                         successive calling Blokex with this
c**                         function, it will collect related BLOK
c**                         messages until the original parent form is
c**                         achieved (when the return code is 0).
c**
c**                     'I' To decode only identification
c**                         sections 0 and 1 of BLOK code.
c**
c**                     'L' Return length of BLOK message, in
c**                         bytes, and BLOK edition number only.
c**
c**                     'U' To unblock single BLOK message.
c**
c**             Kbdim - Dimension of array Kblok
c**
c**             Kret  - Response to error indicator
c**
c**                     0         , Abort if error encountered.
c**                     Non-zero  , Return to calling routine
c**                                 even if error encountered.
c**
c**       Input parameters for coding functions.
c**       --------------------------------------
c**             Section   Word   Contents:
c**             -------   ----   ---------
c**             Ksec0       4    Flag;
c**
c**                        decimal
c**                        value     meaning
c**                        -----     -------
c**                           0      Section 1 to be omitted
c**                         128      Section 1 to be present
c**
c**       Input parameters for coding functions.
c**       Output parameters for decoding functions.
c**       -----------------------------------------
c**             Ksec2 - Integer parameters of section 2 (Data
c**                     section) of BLOK code.
c**
c**             Klen2 - Length of array Ksec2
c**
c**             Kmaxw - Maximun length of single BLOK message
c**
c**       Output parameters for coding functions.
c**       Input parameters for decoding functions.
c**       ----------------------------------------
c**             Kblok - Integer parameters of BLOK coded data array.
c**
c**       Output parameters for decoding functions.
c**       -----------------------------------------
c**             Ksec0      - Integer parameters of section 0 of 
c**                          BLOK code.
c**                          Integer array of 7 words.
c**
c**                 Word   Contents:
c**                 ----   ---------
c**                   1    Total length of this BLOK
c**                   2    BLOK code edition number
c**                        (currently edition 0)
c**                   3    Total length of parent form
c**                   4    Flag;
c**
c**                        decimal
c**                        value     meaning
c**                        -----     -------
c**                           0      Section 1 omitted
c**                         128      Section 1 present
c**
c**                   5    Total number of related BLOKs
c**                   6    Sequence number of this BLOK
c**                   7    Reserved
c**
c**
c**             Ksec1      - Integer parameters of section 1 
c**                          of BLOK code (contains integer parameters
c**                          of section 0 and identification section
c**                          of the parent form).
c**                          When coding data, if Section 1 requested to be
c**                          present (Ksec0(4)=128) then:
c**                          Function 'B' requested - Ksec1 is extracted
c**                          from the parent form and inserted in each related
c**                          BLOK.
c**                          Function 'C' requested - Ksec1 is extracted from
c**                          the parent form when the Ksec0(6)=1 and saved to
c**                          be inserted in each related BLOK (untill the
c**                          Ksec0(6)=1 again).
c**
c**       Output parameters for all functions.
c**       ------------------------------------
c**             Kword      - Number of words of Kblok occupied by
c**                          coded data. Output parameter for coding
c**                          function only. Not required as input
c**                          for decoding.
c**
c**             Hform      - Parent data format description ('GRIB',
c**                          'BUFR','    ').
c**
c**             Kret       - return code.
c**
c**                           0  , no errors encountered (when 'F'
c**                                function requested, also means
c**                                that the all related blocks unblocked
c**                                and original parent form achieved).
c**
c**                          Kret leter then 0 - Informative codes for
c**                                              decoding functions.
c**
c**                          -1  , input array (Kblok) does not contain
c**                                BLOK coded data.
c**                          -2  , 'F' function requested, all 
c**                                related blocks not yet unblocked and
c**                                and the original parent form not yet
c**                                achieved.
c**                                
c**                          Kret greater then 0 - Error codes.
c**
c**                               Error codes are described by the
c**                               appropriate output error messages when
c**                               encountered.
c**
c**    Method
c**    ------
c**       Input data packed in BLOK code in accordance with
c**       parameters given or set by user or fully or partially
c**       unpacked, depending on function used.
c**
c**    Externals
c**    ---------
c**       *Abortx* - Terminate execution of the job.
c**       *Inxbit* - Contains calls to the routines gbyte(s)
c**                  and sbyte(s) or their equivalents.
c**       *Setpar* - Set number of bits in the computer word
c**                  (and largest negative number).
c**
c**   Reference.
c**   ----------
c**       WMO manual on codes for BLOK definition.
c**
c**   Comments.
c**   ---------
c**       Versions of source code exist for the vax, cyber, ibm
c**       and sun workstation, as well as the cray.
c**
c**             The following defaults are used. They have been selected
c**             to facilitate the most frequent usage at ECMWF.
c**
c**             1) by default debug printout is switched off.
c**                Call grsdbg (i) where
c**                            i=non-zero, to switch on debug printout.
c**                                     0, to switch off debug printout.
c**
c**             2) by default the rounding of 120 octets is switched on.
c**                Call grsrnd (i) where
c**                            i=non-zero, to switch on rounding
c**                                     0, to switch off rounding
c**
c**    Author
c**    ------
c**       D.Jokic,  ECMWF,  Feb-1992. 
c**
C----<
c*
c*    Prefix conventions for variable names.
c
c     Character    H, dummy arguments,
c                  Y, local variables.
c     Integer      N, global.
c                  K, dummy arguments.
c                  I, local variables.
c
      Implicit none
c
      Character*1 Hoper
      Character*4 Hform
c
      Character*1 Ycoper
      Character*1 Ydoper
      Character*1 Yoper
c
      Integer i
      Integer Ibits
      Integer Ibufr
      Integer Icoun
      Integer Idata
      Integer Ie
      Integer Ieblk
      Integer Iedit
      Integer Iendm
      Integer Igrib
      Integer Iilen
      Integer Ilen1
      Integer Ilen
      Integer Iname
      Integer Inblok
      Integer Initial
      Integer Inspt
      Integer Insptl
      Integer Imisng
      Integer Ioff
      Integer Iorder
      Integer Iret
      Integer Is
      Integer Isec1
      Integer Itblen
      Integer Itplen
      Integer Itemp
      Integer Iword2
      Integer Iword
c
      Integer Jbedno
      Integer Jplen1
c
      Integer Kblok
      Integer Kbdim
      Integer Klen2
      Integer Kret
      Integer Ksec0
      Integer Ksec1
      Integer Ksec2
      Integer Kword
      Integer Kmaxw
c
      Integer Nblok
      Integer Nbcoun
      Integer Nbseqn
      Integer Ndbg
      Integer Nfcoun
      Integer Nflag
      Integer Nrnd
      Integer N7777
      Integer Nuser
c
c     Blok code version number used when coding data.
c
      Parameter (Jbedno=0)
c
c     Length (in octets) used for section 1, when coding data.
c
      Parameter (Jplen1=36)
c
      Dimension Kblok(*)
      Dimension Ksec0(*)
      Dimension Ksec1(*)
      Dimension Ksec2(*)
c
      Dimension Nblok(4)
      Dimension Ibufr(4)
#ifdef CRAY
      Dimension Idata(Kbdim)
#else
      Dimension Idata(34000)
#endif
      Dimension Ieblk(4)
      Dimension Iendm(4)
      Dimension Igrib(4)
      Dimension Iname(4)
      Dimension N7777(4)
      Dimension Isec1(Jplen1)
c
c
c     Characters BLOK and 7777 in ascii for use in sections 0 and 3
c     of BLOK code.
c
      Data Nblok /66,76,79,75/
      Data N7777 /55,55,55,55/
c
c     Characters GRIB and BUFR in ascii.
c
      Data Igrib /71,82,73,66/
      Data Ibufr /66,85,70,82/
c
c     Ycoper - Default operator value for all coding functions	
c     Ydoper - Default operator value for all decoding functions	
c
      Data Ycoper /'C'/
      Data Ydoper /'D'/
c
c     First Call flag
c
      Data Initial /0/
c
      Real Fref
      Integer Nfref,Nvck
      Common /GRBCOM/ Fref,Nfref,Nrnd,Ndbg,Nvck,Nuser
c
      Save Nblok,N7777
      Save Nbseqn,Nbcoun,Nfcoun
      Save Nflag
      Save Initial,Ibits,Itplen
      Save Ilen1,Isec1
c
c     ------------------------------------------------------------------
c
c*        1.   Initialise
c              ----------
  100 Continue
c
c     Set number of bits per computer word and debug indicator,
c     if first time through (Imisng is not using).
c
      If (Initial.eq.0) Then
          Call Setpar (Ibits,Imisng,Ndbg)
          Initial=1
c
c         Internal length of the parent form
c
          Itplen=0
c
c         Nflag - Flag ; 0 - 'F' function not requested
c                        1 - 'F' function requested and full
c                             parent form uncompleted
c                        2 - 'F' function requested, full
c                             parent form uncompleted and fields are
c                             not in right order
c                        3 - 'F' function requested, full
c                             parent form completed and fields are
c                             not in right order
c
          Nflag=0
c
c         Field counters
c
          Nbcoun=1
          Nfcoun=0
c
c         Sequence number
c
          Nbseqn=0
c
          Inblok=0
          Iword2=0
c
      End if
c
c*        1.1  Initialise variables
c
  110 Continue
c
c     Internal return code
c
      Iret=0
c
c     Bit-pointer
c
      Inspt=0
c
c     Number of words in the single BLOK message
c
      Iword=0
      Kword=0
c
c*        1.2  Set parameters
c
  120 Continue
c
c     Set default values for parameters, if values not already set,
c     either on previous call or by user via calls to the grs--- 
c     routines.
c
      If (Nuser.ne.11041967) Then
c
c         Set rounding to 120 bytes on
c
          Nrnd=1
c
c         Set debug print off
c
c         Ndbg=0
c
c         Mark common values set
c
          Nuser=11041967
c
      End if
c
c     When coding, print input parameters, if required.
c
      If (Ndbg.eq.1) Then
          Write (*,*) '/Blokex/ Paragraph 1.'
          If (Hoper.eq.'C') Then
              Call Blprs0 (Ksec0)
          End if
      End if
c
c
c     ------------------------------------------------------------------
c
c*        2.   Check input parameters and reset appropriate variables
c              -----------------------------------------------------
  200 Continue
c
      If (Ndbg.eq.1) Write (*,*) '/Blokex/ Paragraph 2.'
c
c*        2.1  Check that valid function has been requested
c
  210 Continue
      If (Hoper.ne.'B'.and.Hoper.ne.'C'.and.
     &    Hoper.ne.'I'.and.Hoper.ne.'L'.and.
     &    Hoper.ne.'U'.and.Hoper.ne.'F'     ) Then
          Iret=210
          Write (*,9210) Hoper,Iret
          Go to 910
      End if
c
c     Set internal function parameter
c
      If (Hoper.eq.'B'.or.Hoper.eq.'C') Then
          Yoper='B'
      Else
          Yoper='U'
      End if
c
c*        2.2  Rounding of 120 bytes
c
  220 Continue
      If (Yoper.eq.'B') Then
c
          If (Nrnd.eq.1) Then
              If (Mod(Kmaxw*Ibits,120).ne.0) Then
                  Iret=220
                  Write(*,9220) Kmaxw,Nrnd,Iret
                  Go to 910
              End if
          End if
c
c*        2.3  Check BLOK identification section flag - Ksec0(4)
c
  230 Continue
          If (Ksec0(4).ne.0.and.Ksec0(4).ne.128) Then
              Iret=230
              Write(*,9230) Ksec0(4),Iret
              Go to 900
          End if
c
c         Reset length of BLOK identification section
c
          If (Ksec0(4).eq.0) Ilen1=0
c
c*        2.4  Check dimensions and preset output array to 0
c
  240 Continue
c
c         Check dimension Kbdim of the output array Kblok against the
c         the length of the parent form Klen2
c
          If (Kbdim.le.Klen2) Then
              Iret=240
              Write(*,9240) Kbdim,Klen2,Iret
              Go to 900
          End if
c
c         Array to receive coded BLOK data
c
          Do 242 i=1,Kbdim
          Idata(i)=0
  242     Continue
c
c         First and last position for the extraction from the Ksec2
c
          Is=0
          Ie=0
c
      End if
c
c*        2.5  Extract section 0 and section 1 of the parent code and
c*             make identification section of BLOK code (if BLOK
c*             identification section requested Ksec0(4)=128)
c
  250 Continue
c
c     Do the extraction if function 'B' requested or
c     function 'C' requested and BLOK sequence number is 1
c
      If (Hoper.eq.'B'.or.(Hoper.eq.'C'.and.Ksec0(6).eq.1)) Then
c
          If (Ksec0(4).ne.0) Then
c
c             Parent code edition number; Extract field
c
              Itemp=56
              Call Inxbit (Ksec2,Klen2,Itemp,Iedit,1,Ibits,8,
     &                     Ydoper,Iret)
              If (Iret.ne.0) Then
                  Iret=251
                  Write (*,9101) 'parent code edition number.',Iret
                  Go to 900
              End if
c
              If (Iedit.eq.0) Itemp=32
c
c             Length of the parent identification section;
c             Extract field
c
              Call Inxbit (Ksec2,Klen2,Itemp,Ilen1,1,Ibits,24,
     &                     Ydoper,Iret)
              If (Iret.ne.0) Then
                  Iret=252
                  Write (*,9101)
     &            'length of the pareant identification section.',Iret
                  Go to 900
              End if
              If (Ilen1.gt.Jplen1) Then
                  Iret=2521
                  Write (*,9251) Iret
                  Go to 900
              End if
c
c             Length of the BLOK identification section
c
              Itemp=Itemp-24
              Ilen1=Ilen1+Itemp/8
c
c             Parent section 0 and section 1;
c             Extract field
c
              Itemp=0
              Call Inxbit (Ksec2,Klen2,Itemp,Isec1(1),Ilen1,Ibits,8,
     &                     Ydoper,Iret)
              If (Iret.ne.0) Then
                  Iret=253
                  Write (*,9101) 'Parent section 0 and section 1.',Iret
                  Go to 900
              End if
c
          End if
c
      End if
c
c*        2.6  Reset internal parameters
c
  260 Continue
      If (Hoper.eq.'B') Then
c
c         Total number of related bloks
c
          If (Kmaxw.le.0) Then
              Iret=260
              Write (*,9260) Kmaxw,Iret
              Go to 900
          End if
          Inblok=Klen2/Kmaxw+1
c
c         Total length of all BLOK messages
c
          Itblen=Inblok*Kmaxw
          Itemp=Klen2+(Inblok*(120*8/Ibits))
          If (Itblen.lt.Itemp) Inblok=Inblok+1
c
          Ksec0(5)=Inblok
c
c         Total length of the parent form
c
          Ksec0(3)=Klen2*Ibits/8
c
c         Blok sequence number
c
          Nbseqn=0
c
      End if
c
c     Number of Ksec2 words which will be inserted 
c     into one BLOK message
c
      If (Hoper.eq.'C') Then
c
          If (Kmaxw.le.Klen2) Then
              Iret=263
              Write (*,9263) Kmaxw,Klen2,Iret
              Go to 900
          End if
c
          Iword2=Klen2
c
      Else if (Hoper.eq.'B') Then
c
          Iword2=Kmaxw-(((16+4+Ilen1)*8/Ibits)+1)
          Iret=Iword2*Ibits
          If (Mod(Iret,960).ne.0) Then
              Iret=Iret/960
              Iret=Iret*960
              Iword2=Iret/Ibits
          End if
c
      End if
c
c     ------------------------------------------------------------------
c
c*        3.   BLOK Section 0
c              --------------
  300 Continue
c
c     Section 0 shall always be 16 octets long
c
      If (Ndbg.eq.1) Write(*,*) '/Blokex/ Paragraph 3.'
c
c*        3.1  Octets 1-4; The letters B L O K
c
  310 Continue
c
c     Four 8 bit fields
c
      If (Yoper.eq.'B') Then
c
c         Insert fields
c
          Call Inxbit (Idata,Kbdim,Inspt,Nblok(1),4,Ibits,8,
     &                 Ycoper,Iret)
          If (Iret.ne.0) Then
              Iret=310
              Write (*,9100) 'Octets 1-4; The letters B L O K',Iret
              Go to 900
          End if
c
      Else
c
c         Extract fields
c
          Call Inxbit (Kblok,Kbdim,Inspt,Ieblk(1),4,Ibits,8,
     &                 Ydoper,Iret)
          If (Iret.ne.0) Then
              Iret=311
              Write (*,9101) 'Octets 1-4; The letters B L O K',Iret
              Go to 900
          End if
          Do 312 i=1,4
          If (Ieblk(i).ne.Nblok(i)) Then
              Iret=-1
              Go to 910
          End if
  312     Continue
c
      End if
c
c*        3.2  Octets 5-7; Length of message
c
  320 Continue
c
c     One 24 bit field
c
      If (Yoper.eq.'B') Then
c
c         When coding data, skip field. Length is inserted
c         later, when known.
c
          Insptl=Inspt
c
c         Update bit-pointer.
c
          Inspt=Inspt+24
c
       Else
c
c         Extract field
c
          Call Inxbit (Kblok,Kbdim,Inspt,Ksec0(1),1,Ibits,24,
     &                 Ydoper,Iret)
          If (Iret.ne.0) Then
              Iret=320
              Write (*,9101) 'Octets 5-7; Length of message.',Iret
              Go to 900
          End if
c
c
c         If only length is required, go to paragraph 9.
c
          If (Hoper.eq.'L') Then
              Write(*,9321) Ksec0(1)
              Go to 900
          End if
c
          Kword=(Ksec0(1)+Ibits/8-1)*8/Ibits
c
      End if
c
c*        3.3  Octet 8; Blok edition number
c
  330 Continue
c
c     One 8 bit field
c
      If (Yoper.eq.'B') Then
c
c         Set value
c
          Ksec0(2)=Jbedno
c
c         Insert field
c
          Call Inxbit (Idata,Kbdim,Inspt,Ksec0(2),1,Ibits,8,
     &                 Ycoper,Iret)
          If (Iret.ne.0) Then
              Iret=330
              Write (*,9100) 'Octet 8; Blok edition number.',Iret
              Go to 900
          End if
c
      Else
c
c         Extract field
c
          Call Inxbit (Kblok,Kbdim,Inspt,Ksec0(2),1,Ibits,8,
     &                 Ydoper,Iret)
          If (Iret.ne.0) Then
              Iret=330
              Write (*,9101) 'Octet 8; Blok edition number.',Iret
              Go to 900
          End if
c
      End if
c
c*        3.4  Octets 9-11; Total length of parent form
c
  340 Continue
c
c     One 24 bit field
c
      If (Yoper.eq.'B') Then
c
c         Insert field
c
          Call Inxbit (Idata,Kbdim,Inspt,Ksec0(3),1,Ibits,24,
     &                 Ycoper,Iret)
          If (Iret.ne.0) Then
              Iret=340
              Write (*,9100) 'Octets 9-11; Length of parent form.',Iret
              Go to 900
          End if
c
       Else
c
c         Extract field
c
          Call Inxbit (Kblok,Kbdim,Inspt,Ksec0(3),1,Ibits,24,
     &                 Ydoper,Iret)
          If (Iret.ne.0) Then
              Iret=341
              Write (*,9101) 'Octets 9-11; Length of parent form.',Iret
              Go to 900
          End if
      End if
c
c*        3.5  Octet 12; Flag (Code table 1)
c
  350 Continue
c
c     One 8 bit field
c
      If (Yoper.eq.'B') Then
c
c         Insert field
c
          Call Inxbit (Idata,Kbdim,Inspt,Ksec0(4),1,Ibits,8,
     &                 Ycoper,Iret)
          If (Iret.ne.0) Then
              Iret=350
              Write (*,9100) 'Octet 12; Flag.',Iret
              Go to 900
          End if
c
      Else
c
c         Extract field
c
          Call Inxbit (Kblok,Kbdim,Inspt,Ksec0(4),1,Ibits,8,
     &                 Ydoper,Iret)
          If (Iret.ne.0) Then
              Iret=352
              Write (*,9101) 'Octet 12; Flag.',Iret
              Go to 900
          End if
c
      End if
c
c
c*        3.6  Octet 13; Total number of related BLOKS
c
  360 Continue
c
c     One 8 bit field
c
      If (Yoper.eq.'B') Then
c
c         Insert field
c
          Call Inxbit (Idata,Kbdim,Inspt,Ksec0(5),1,Ibits,8,
     &                 Ycoper,Iret)
          If (Iret.ne.0) Then
              Iret=360
              Write (*,9100) 'Octet 13; Total number of related bloks.',
     &                        Iret
              Go to 900
          End if
c
      Else
c
c         Extract field
c
          Call Inxbit (Kblok,Kbdim,Inspt,Ksec0(5),1,Ibits,8,
     &                 Ydoper,Iret)
          If (Iret.ne.0) Then
              Iret=361
              Write (*,9101) 'Octet 13; Total number of related bloks.',
     &                        Iret
              Go to 900
          End if
c
c         Check order of fields if function 'F' requested
c
          If (Nflag.ne.0) Then
              If (Nbseqn/1000.ne.Ksec0(5)) Then
                  Iret=-362
                  Write (*,9425) Iret
                  Call Blprs0 (Ksec0)
                  Go to 739
              End if
          End if
c
      End if
c
c*        3.7  Octet 14; Sequence number of this BLOK
c
  370 Continue
c
c     One 8 bit field
c
      If (Hoper.eq.'B') Then
c
c         Reset value
c
          Nbseqn=Nbseqn+1
          Ksec0(6)=Nbseqn
c
      End if
c
      If (Yoper.eq.'B') Then
c
c         Insert field
c
          Call Inxbit (Idata,Kbdim,Inspt,Ksec0(6),1,Ibits,8,
     &                 Ycoper,Iret)
          If (Iret.ne.0) Then
              Iret=370
              Write (*,9100) 'Octet 14; Sequence number of this BLOK.',
     &                        Iret
              Go to 900
          End if
c
      Else
c
c         Extract field
c
          Call Inxbit (Kblok,Kbdim,Inspt,Ksec0(6),1,Ibits,8,
     &                 Ydoper,Iret)
          If (Iret.ne.0) Then
              Iret=371
              Write (*,9101) 'Octet 14; Sequence number of this BLOK.',
     &                        Iret
              Go to 900
          End if
c
      End if
c
c*        3.8  Octets 15-16; Reserved
c
  380 Continue
c
c     One 16 bit field
c
      If (Yoper.eq.'B') Then
c
c         When coding data, skip field.
c
          Ksec0(7)=0
c
c         Update bit-pointer.
c
          Inspt=Inspt+16
c
      Else
c
c         Extract field
c
          Call Inxbit (Kblok,Kbdim,Inspt,Ksec0(7),1,Ibits,16,
     &                 Ydoper,Iret)
          If (Iret.ne.0) Then
              Iret=381
              Write (*,9101) 'Octets 15-16;',Iret
              Go to 900
          End if
c
      End if
c
c     ------------------------------------------------------------------
c
c*        4.   BLOK Section 1 - Identification section
c              ---------------------------------------
  400 Continue
      If (Ndbg.eq.1) Write (*,*) '/Blokex/ Paragraph 4.'
      If (Ksec0(4).ne.128) Go to 499
c
c*        4.1  Coding data
c
  410 Continue
c
c     Copy section 0 and identification section of the parent code
c     into the section 1 of BLOK code
c
      If (Yoper.eq.'B') Then
c
c         Insert field
c
          Call Inxbit (Idata,Kbdim,Inspt,Isec1(1),Ilen1,Ibits,8,
     &                 Ycoper,Iret)
          If (Iret.ne.0) Then
              Iret=415
              Write (*,9100) 'bit fields into BLOK section 1.',Iret
              Go to 900
          End if
c
c*        4.2  Decoding data
c
  420 Continue
      Else
          Itemp=Inspt
c
c         Name of the parent form
c
          Call Inxbit (Kblok,Kbdim,Itemp,Iname(1),4,Ibits,8,
     &                 Ydoper,Iret)
          If (Iret.ne.0) Then
              Iret=421
              Write (*,9101) 'Name of the parent form.',Iret
              Go to 900
          End if
          Icoun=0
          Hform='GRIB'
          Do 422 i=1,4
          If (Iname(i).eq.Igrib(i)) Icoun=Icoun+1
  422     Continue
          If (Icoun.ne.4) Then
              Icoun=0
              Do 423 i=1,4
              If (Iname(i).eq.Ibufr(i)) Icoun=Icoun+1
  423         Continue
              If (Icoun.eq.4) Then
                  Hform='BUFR'
              Else
                  Iret=423
                  Write (*,9423) Iret
                  Go to 900
              End if
          End if
c
c         Parent code edition number; Extract field
c
          Itemp=Inspt+56
          Call Inxbit (Kblok,Kbdim,Itemp,Iedit,1,Ibits,8,
     &                 Ydoper,Iret)
          If (Iret.ne.0) Then
              Iret=424
              Write (*,9101) 'Parent code edition number.',Iret
              Go to 900
          End if
c
c         Set first word in the output array Ksec1 and check order
c         of fields if 'F' function requested
c
          If (Nflag.ne.0) Then
              If (Iedit.ne.Ksec1(1)) Then
                  Iret=-425
                  Write (*,9425) Iret
                  Call Blprs0 (Ksec0)
                  Call Blprs1 (Ksec1,Hform)
                  Go to 739
              End if
          End if
          Ksec1(1)=Iedit
c
c         Reset position of the length of the parent section 1 for
c         the different parent code versions
c
          If (Hform.eq.'GRIB'.and.Iedit.lt.1) Then
              Itemp=Inspt+32
          Else if (Hform.eq.'BUFR'.and.Iedit.lt.2) Then
              Itemp=Inspt+32
          End if
c
c         Length of the identification section; Extract field
c
          Call Inxbit (Kblok,Kbdim,Itemp,Ilen1,1,Ibits,24,
     &                 Ydoper,Iret)
          If (Iret.ne.0) Then
              Iret=426
              Write (*,9101) 'Length of the section 1.',Iret
              Go to 900
          End if
          Inspt=Itemp
c
c*        4.2.1 GRIB code identification section
c
 4210 Continue
          If (Hform.eq.'GRIB') Then
c
c             Octet 4  : Version Number of Table 2.
c             Octet 5  : Identification of centre.
c             Octet 6  : Generating process identification.
c             Octet 7  : Grid definition.
c             Octet 8  : Flag.
c             Octet 9  : Indicator of parameter.
c             Octet 10 : Indicator of type of level.
c
c             Seven 8 bit fields.
c
              Call Inxbit (Kblok,Kbdim,Inspt,Isec1(1),7,Ibits,8,
     &                     Ydoper,Iret)
              If (Iret.ne.0) Then
                  Iret=4210
                  Write (*,9101) 'Octets 4-10; Section 1.',Iret
                  Go to 900
              End if
c
c             Octets 11 - 12 : Height, pressure etc of levels
c
              Call Inxbit (Kblok,Kbdim,Inspt,Isec1(8),2,Ibits,8,
     &                     Ydoper,Iret)
              If (Iret.ne.0) Then
                  Iret=4211
                  Write (*,9101) 'Octets 11-12; Section 1.',Iret
                  Go to 900
              End if
c
c             Octet 13 : Year of century.
c             Octet 14 : Month.
c             Octet 15 : Day.
c             Octet 16 : Hour.
c             Octet 17 : Minute.
c             Octet 18 : Indicator of unit of time range..
c
c             Six 8 bit fields.
c
              Call Inxbit (Kblok,Kbdim,Inspt,Isec1(10),6,Ibits,8,
     &                     Ydoper,Iret)
              If (Iret.ne.0) Then
                  Iret=4212
                  Write (*,9101) 'Octets 13-18; Section 1.',Iret
                  Go to 900
              End if
c
c             Octets 19 - 20 : Period of time.
c             One 16 bit field or two 8 bit fields.
c
              Call Inxbit (Kblok,Kbdim,Inspt,Isec1(16),2,Ibits,8,
     &                     Ydoper,Iret)
              If (Iret.ne.0) Then
                  Iret=4213
                  Write (*,9101) 'Octets 19-20; Section 1.',Iret
                  Go to 900
              End if
c
c             Octet 21 : Time range indicator.
c             One 8 bit field.
c
              Call Inxbit (Kblok,Kbdim,Inspt,Isec1(18),1,Ibits,8,
     &                     Ydoper,Iret)
              If (Iret.ne.0) Then
                  Iret=4214
                  Write (*,9101) 'Octet 21; Section 1.',Iret
                  Go to 900
              End if
c
c             Octet 22 - 23 : Number averaged.
c             One 16 bit field.
c
              Call Inxbit (Kblok,Kbdim,Inspt,Isec1(19),1,Ibits,16,
     &                     Ydoper,Iret)
              If (Iret.ne.0) Then
                  Iret=4215
                  Write (*,9101) 'Octets 22-23; Section 1.',Iret
                  Go to 900
              End if
c
c             Octet 24 : Number missing from averages etc.
c             Octet 25 : Century of data.
c             Octet 26 : Reserved field. (set to 0)
c             Three 8 bit field.
c
              Itemp=3
              Ilen=20
              If (Iedit.le.0) Itemp=1
c
              Call Inxbit (Kblok,Kbdim,Inspt,Isec1(20),Itemp,Ibits,8,
     &                     Ydoper,Iret)
              If (Iret.ne.0) Then
                  Iret=4216
                  Write (*,9101) 'Octets 24-26; Section 1.',Iret
                  Go to 900
              End if
c
c             Octets 27 - 28 : Units decimal scale factor.
c             One 16 bit field.
c
              If (Iedit.gt.0) Then
c
c                 Extract field
c
                  Call Inxbit (Kblok,Kbdim,Inspt,Isec1(23),1,Ibits,16,
     &                     Ydoper,Iret)
                  If (Iret.ne.0) Then
                      Iret=4217
                      Write (*,9101) 'Octets 27-28; Section 1.',Iret
                      Go to 900
                  End if
                  Ilen=24
c
              End if
c
c             Set output array Ksec1 and check order of fields if
c             'F' function requested
c
              Do 4218 i=1,Ilen
              If (Nflag.ne.0) Then
                  If (Ksec1(i+1).ne.Isec1(i)) Then
                      Iret=-4218
                      Write (*,9425) Iret
                      Call Blprs0 (Ksec0)
                      Call Blprs1 (Ksec1,Hform)
                      Go to 739
                  End if
              Else
                  Ksec1(i+1)=Isec1(i)
              End if
4218          Continue
c
c*        4.2.2 BUFR code identification section
c
 4220 Continue
          Else if (Hform.eq.'BUFR') Then
c
c             Octet 4  : BUFR master table
c             One 8 bit field.
c
              Call Inxbit (Kblok,Kbdim,Inspt,Isec1(1),1,Ibits,8,
     &                     Ydoper,Iret)
              If (Iret.ne.0) Then
                  Iret=4220
                  Write (*,9101) 'Octet 4; Section 1.',Iret
                  Go to 900
              End if
c
c             Octet 5-6  : Originating centre
c             One 16 bit field.
c
              Call Inxbit (Kblok,Kbdim,Inspt,Isec1(2),1,Ibits,16,
     &                     Ydoper,Iret)
              If (Iret.ne.0) Then
                  Iret=4221
                  Write (*,9101) 'Octets 5-6; Section 1.',Iret
                  Go to 900
              End if
c
c             Octet 7  : Update sequence number
c             Octet 8  : Flag.
c             Octet 9  : BUFR message type
c             Octet 10 : BUFR message sub-type
c             Octet 11 : Version number of master table used
c             Octet 12 : Version number of local tables used to augment
c                        the master table in use
c             Octet 13 : Year of century.
c             Octet 14 : Month.
c             Octet 15 : Day.
c             Octet 16 : Hour.
c             Octet 17 : Minute.
c             Octet 18 : Indicator of unit of time range..
c
c             Twelve 8 bit fields.
c
              Call Inxbit (Kblok,Kbdim,Inspt,Isec1(3),12,Ibits,8,
     &                     Ydoper,Iret)
              If (Iret.ne.0) Then
                  Iret=4212
                  Write (*,9101) 'Octets 7-18; Section 1.',Iret
                  Go to 900
              End if
c
          End if
c
      End if
  499 Continue
c
c     Print content of Section 0 and Section 1 if function 'I' requested
c
      If (Hoper.eq.'I') Go to 900
c
c     ------------------------------------------------------------------
c
c*        5.   BLOK Section 2 - Binary Data Section
c              ------------------------------------
  500 Continue
      If (Ndbg.eq.1) Write(*,*) '/Blokex/ Paragraph 5.'
c
c*        5.1  Coding data
c
  510 Continue
      If (Yoper.eq.'B') Then
c
c         First and last position of the Ksec2 array for the
c         data which will be inserted in the current BLOK message
c
          Is=Ie+1
          If (Ksec0(5).ne.Ksec0(6)) Then
              Ie=Is+Iword2-1
          Else
              Ie=Klen2
          End if
c
c         Data to be inserted in the current blok
c
          Iilen=0
          Do 511 i=Is,Ie
          Iilen=Iilen+1
          Kblok(Iilen)=Ksec2(i)
  511     Continue
c
c         Insert field
c
          Call Inxbit (Idata,Kbdim,Inspt,Kblok,Iilen,Ibits,Ibits,
     &                 Ycoper,Iret)
          If (Iret.ne.0) Then
              Iret=512
              Write (*,9100) 'binary data section (Section 2).',Iret
              Go to 900
          End if
c
c*        5.2  Decoding data
c
  520 Continue
      Else
c
c         Length of the data section
c
          Iilen=(Ksec0(1)*8-Inspt)/Ibits
c
c         Data section; Extract field
c
          Call Inxbit (Kblok,Kbdim,Inspt,Idata,Iilen,Ibits,Ibits,
     &                 Ydoper,Iret)
          If (Iret.ne.0) Then
              Iret=522
              Write (*,9101) 'binary data section (Section 2).',Iret
              Go to 900
          End if
      End if          
c
c     ------------------------------------------------------------------
c
c*        6.   BLOK Section 3 - Ascii 7777
c              ---------------------------
  600 Continue
      If (Ndbg.eq.1) Write (*,*) '/Blokex/ Paragraph 6.'
c
c     Four 8 bit fields
c
c*        6.1  Coding data
c
  610 Continue
      If (Yoper.eq.'B') Then
c
c         Insert field
c
          Call Inxbit (Idata,Kbdim,Inspt,N7777(1),4,Ibits,8,
     &                 Ycoper,Iret)
          If (Iret.ne.0) Then
              Iret=611
              Write (*,9100) 'BLOK Section 3 (7777).',Iret
              Go to 900
          End if
c
c         Length of BLOK message
c
          Ksec0(1)=(Inspt-Iword*Ibits)/8
c
c         Insert field
c
          Call Inxbit (Idata,Kbdim,Insptl,Ksec0(1),1,Ibits,24,
     &                 Ycoper,Iret)
          If (Iret.ne.0) Then
              Iret=802
              Write (*,9100) 'Total length of this message',Iret
              Go to 900
          End if
c
c*        6.2  Decoding data
c
  620 Continue
      Else
c
c         Reset counter
c
          Itemp=0
  621     Continue
c
c         Extract field
c
          Call Inxbit (Kblok,Kbdim,Inspt,Iendm(1),4,Ibits,8,
     &                 Ydoper,Iret)
          If (Iret.ne.0) Then
              Iret=621
              Write (*,9101) 'BLOK Section 3 (7777).',Iret
              Go to 900
          End if
c
c         Check that 7777 group is found where expected
c
          Icoun=0
          Do 622 i=1,4
          If (Iendm(i).ne.N7777(i)) Icoun=Icoun+1
  622     Continue
          If (Icoun.ne.0) Then
c
c             Search backward
c
              Inspt=Inspt-8-4*8
              Itemp=Itemp+1
              If (Itemp.gt.8) Then
                  Iret=623
                  Write (*,9623) Iret
                  Go to 900
              End if
              Go to 621
          Else
c
c             Update length of the data section
c
              If (Itemp.eq.0) Then
                  Iword=Iilen
              Else
                  Iword=Iilen-(Itemp*8/Ibits)
              End if
          End if
c
      End if
c
c     ------------------------------------------------------------------
c
c*        7.   Complete single message
c              -----------------------
  700 Continue
      If (Ndbg.eq.1) Write(*,*) '/Blokex/ Paragraph 7.'
c
c*        7.1  Coding data
c
  710 Continue
      If (Yoper.eq.'B') Then
c
c         Any unused part of last word is already set to binary zeroes
c         Increment pointers as necessary
c
          Iword=Inspt/Ibits
          Itemp=Iword*Ibits
          Ioff =Inspt-Itemp
          If (Ioff.ne.0) Then
              Inspt=Inspt+Ibits-Ioff
              Iword=Iword+1
          End if
c
c         Round length to a multiple of 120 octets, if required,
c         any additional words are already set to 0.
c
          If (Nrnd.eq.1) Then
              i=Inspt/960
              i=i*960
              i=Inspt-i
              If (i.ne.0) i=(960-i)/Ibits
              Iword=Iword+i
              Inspt=Iword*Ibits
          End if
c
c         Output BLOK coded data array
c
          If (Nbseqn.eq.Inblok.or.Hoper.eq.'C') Then
              Do 711 i=1,Iword
              Kblok(i)=Idata(i)
  711         Continue
          End if
          Kword=Iword
c
c*        7.2  Decoding data; Function 'U'
c
  720 Continue
      Else if (Hoper.eq.'U') Then
c
          Do 721 i=1,Iword
          Ksec2(i)=Idata(i)
  721     Continue
          Klen2=Iword
c
c*        7.3  Decoding data; Function 'F'
c
  730 Continue
      Else if (Hoper.eq.'F') Then
c
c         Collect fields
c
          If (Nflag.eq.0) Then
c
c         Nflag=0; Function 'F' requested, first time through
c
c             Check the order of the first field
c
              Nflag=1
              If (Ksec0(6).ne.Nbcoun) Then
c
c                 Field is not in right order
c
                  Nflag=2
c
c                 Suppress current unblocking stage
c
                  Nfcoun=1
                  Ksec2(Itplen+Iword+1)=Ksec0(6)*1000000+Iword
c
              End if
c
          Else if (Nflag.eq.1) Then
c
c         Nflag=1; Function 'F' requested, fields in order
c
c             Check the order of the current field
c
              If (Ksec0(6).ne.Nbcoun) Then
c
c                 Fields are not in right order
c
                  Nflag=2
c
c                 Suppress previous and current unblocking stage
c
                  If (Nfcoun.eq.0) Then
                      Itemp=Nbseqn/1000
                      Itemp=Nbseqn-Itemp*1000
                      Ksec2(Itplen+Iword+1)=Itemp*1000000+Itplen
                  End if
                  Nfcoun=2
                  Ksec2(Itplen+Iword+2)=Ksec0(6)*1000000+Iword
c
              End if
c
          Else if (Nflag.eq.2) Then
c
c         Nflag=2; Unblocked fields are not in right order
c
c             Increase counter of the fields which are not in order
c
              Nfcoun=Nfcoun+1
c
c             Suppress current unblocking stage
c
              Ksec2(Itplen+Nfcoun)=Ksec0(6)*1000000+Iword
c
c             Update internally used part of Ksec2
c
              Do 733 i=Nfcoun,1,-1
              Ksec2(Itplen+Iword+i)=Ksec2(Itplen+i)
  733         Continue
c
c             Reset flag if total number of related bloks achieved
c
              If (Nbcoun.eq.Ksec0(5)) Nflag=3
c
          End if
c
          Do 734 i=1,Iword
          Itplen=Itplen+1
          Ksec2(Itplen)=Idata(i)
  734     Continue
          Klen2=Itplen
          Nbseqn=Ksec0(5)*1000+Ksec0(6)
c
c         Repack parent form if fields are not in right order
c
          If (Nflag.eq.3) Then
c
c             Find first field in right order, if any
c
              If (Nfcoun.eq.Nbcoun) Then
c
c                 No fields in order
c
                  Iilen=0
                  Icoun=0
                  Inblok=1
                  Itblen=0
c
              Else
c
c                 Number of the fields in right order
c
                  Icoun=Ksec2(Itplen+1)/1000000
                  Inblok=2
                  Itblen=Icoun-1
c
c                 Length of the fields in right order
c
                  Iilen=Ksec2(Itplen+1)-Icoun*1000000
c
              End if
c
              Do 7350 Ie=Inblok,Nfcoun
              Icoun=Icoun+1
              Is=Iilen
c
              Do 7351 i=Ie,Nfcoun
c
c             Sequence number of the field
c
              Iorder=Ksec2(Itplen+i)/1000000
c
c             Length of the field
c
              Ilen=Ksec2(Itplen+i)-Iorder*1000000
c
c             Field starting index in the array Ksec2
c
              If (Iorder.eq.Icoun) Then
                  Itemp=i
                  Go to 7352
              Else
                  Is=Is+Ilen
              End if
c
 7351         Continue
              Iret=-7351
              Write(*,97351) Icoun,Iret
              Call Blprs1(Ksec1,Hform)
              Go to 739
c
c             Repack parent form so that 'Icoun' field is 
c             in right order
c
 7352         Continue
c
              Do 7353 i=1,Ilen
              Idata(i)=Ksec2(Is+i)
 7353         Continue
              Do 7354 i=Is+Ilen+1,Itplen
              Ksec2(i-Ilen)=Ksec2(i)
 7354         Continue
              Do 7355 i=Itplen-Ilen,Iilen+1,-1
              Ksec2(i+Ilen)=Ksec2(i)
 7355         Continue
              Do 7356 i=1,Ilen
              Iilen=Iilen+1
              Ksec2(Iilen)=Idata(i)
 7356         Continue
c
c             Repack internaly used part of Ksec2
c
              Idata(1)=Ksec2(Itplen+Itemp)
              Do 7357 i=Itplen+Itemp+1,Itplen+Nfcoun
              Ksec2(i-1)=Ksec2(i)
 7357         Continue
              Do 7358 i=Itplen+Nfcoun,Itplen+Iorder-Itblen,-1
              Ksec2(i)=Ksec2(i-1)
 7358         Continue
              Ksec2(Itplen+Iorder-Itblen)=Idata(1)
c
 7350         Continue
c
          End if
c
c         Reset internal total parent length if it is achieved
c
          Itemp=Ksec0(3)*8/Ibits
          If (Nbcoun.eq.Ksec0(5)) Then
              Iret=0
              If (Itplen.ne.Itemp) Then
                  Iret=-739
                  Write(*,9739) Itemp,Itplen,Iret
              End if
          Else
              Iret=-2
              Nbcoun=Nbcoun+1
              Go to 800
          End if
c
      End if
c
c     Reset flags to default values
c
  739 Continue
      If (Hoper.eq.'F') Then
          Nflag=0
          Itplen=0
          Nbseqn=0
          Nbcoun=1
          Nfcoun=0
      End if
c
c     ------------------------------------------------------------------
c
c*        8.   Continue loop over all single BLOK messages
c              -------------------------------------------
  800 Continue
      If (Ndbg.eq.1) Write(*,*) '/Blokex/ Paragraph 8.'
c
      If (Nbseqn.ne.Inblok.and.Hoper.eq.'B') Then
          Go to 300
      End if
c
c     ------------------------------------------------------------------
c
c*        9.   Return code handling
c              --------------------
  900 Continue
c
      If (Ndbg.eq.1) Write(*,*) '/Blokex/ Paragraph 9.'
      If (Ndbg.eq.1.or.Hoper.eq.'I') Then
          Call Blprs0 (Ksec0)
          If (Ksec0(4).eq.128.and.Yoper.ne.'B') Then
              Call Blprs1 (Ksec1,Hform)
          End if
      End if
c
c     If no error has been encountered, set return code to informative
c     value, if required.
c
c     Abort if any error has been encountered and user has requested
c     an abort. Informative values are negative and do not cause an
c     abort.
c
  910 Continue
      If (Iret.gt.0.and.Kret.eq.0) Then
          Call abortx ('BLOKEX')
      Else
          Kret=Iret
          Return
      End if
c
 9100 Format (' Blokex: Error inserting ',a,' Return code=',i4)
 9101 Format (' Blokex: Error extracting ',a,' Return code=',i4)
 9210 Format (' Blokex: Error, Unrecognised function requested: ',a/
     &        ' ','         Return code=',i3)
 9220 Format (' Blokex: Error, Requested length of single',
     &        ' BLOK message ',i10,' words'/
     &        '                 is not multiple of 120 bytes.'/
     &        ' ','         Rounding of 120 bytes included; Nrnd=',i3/
     &        ' ','         Return code=',i3) 
 9230 Format (' Blokex: Error, Unrecognised entry Ksec0(4)=',i6/
     &        ' ','         Valid entry: 0 /or/ 128.'/
     &        ' ','         Return code=',i3) 
 9240 Format (' Blokex: Error, Output array too small to receive',
     &            ' BLOK coded field.'/
     &        ' ','         Kbdim=',i9,' Klen2=',i9/
     &        ' ','         Return code=',i3) 
 9251 Format (' Blokex: Error, Unrecognised parent data format.'/
     &        ' ','         BLOK Section 1 requested to be',
     &            ' included (Ksec0(4)=128) for the'/
     &        ' ','         unrecognised parent data format.'/
     &        ' ','         Return code=',i4) 
 9260 Format (' Blokex: Error, Maximum length of single BLOK ',
     &            ' message Kmaxw=',i9/
     &        ' ','                not valid.'/
     &        ' ','         Return code=',i3)
 9263 Format (' Blokex: Error, Required single BLOK length Kmaxw=',
     &            i9,' too small'/
     &        ' ','         to receive input field Klen2=',i9,
     &            '; Fuction C requested.'/
     &        ' ','         Return code=',i3) 
 9321 Format (' Blokex: Total length of this BLOK is ',i8,
     &            ' octets.')
 9423 Format (' Blokex: Error, Unrecognised parent code name.'/
     &        ' ','         Return code=',i3) 
 9425 Format (' Blokex: Error, Input fields are not in right order.'
     &       /' ','         Unblocking uncompleted.'/
     &        ' ','         Function requested F.'/
     &        ' ','         Return code=',i5) 
 9623 Format (' Blokex: Error, End of message 7777 group not',
     &            ' found.'/
     &        ' ','         Return code=',i3) 
 9739 Format (' Blokex: Error, Original parent length: ',i12,/
     &        ' ','         differ from the length achieved after full',
     &            ' decoding: ',i12/
     &        ' ','         Return code=',i4) 
97351 Format (' Blokex: Error, BLOK sequence ',i3,' missing.'/
     &        ' ','         Unblocking uncompleted.'/
     &        ' ','         Return code=',i5) 

c
      End
      Subroutine Blprs0(Ksec0)
c**
c****  Name  *Blprs0*
c****  ----
c**
c**   Purpose
c**   -------
c**         Print the information in the Indicator
c**         Section (Section 0) of BLOK data.
c**
c**   Interface
c**   ---------
c**       Input: Ksec0 - Array of decoded parameters from Section 0.
c**
c**       Output: Printed data on the standard output.
c**
c**    Method
c**    ------
c**       Fields are printed as integers.
c**
c**    Externals
c**    ---------
c**       None.
c**
c**    Author
c**    ------
c**       D.Jokic,  ECMWF,  February-1992. 
c**
      Integer Ksec0(*)
c
c     ------------------------------------------------------------------
c
c*        1.   Write Ksec0
c              -----------
  100 Continue
      Write (*,9000)
      Write (*,9001)
      Write (*,9002)
      Write (*,9003) Ksec0(1)
      Write (*,9004) Ksec0(2)
      Write (*,9005) Ksec0(3)
      Write (*,9006) Ksec0(4)
      Write (*,9007) Ksec0(5)
      Write (*,9008) Ksec0(6)
c
 9000 Format (' ')
 9001 Format (' ','BLOK Section 0 - Indicator Section.     ')
 9002 Format (' ','----------------------------------------')
 9003 Format (' ','Total length of this BLOK.           ',I9)
 9004 Format (' ','BLOK Edition Number.                 ',I9)
 9005 Format (' ','Total length of parent form.         ',I9)
 9006 Format (' ','Flag (Code Table 1).                 ',I9)
 9007 Format (' ','Total number of related BLOKs.       ',I9)
 9008 Format (' ','Sequence number of this BLOK.        ',I9)
c
      Return
      End
      Subroutine Blprs1(Ksec1,Yform)
c**
c****  Name  *Blprs1*
c****  ----
c**
c**   Purpose
c**   -------
c**         Print the information in the Identification
c**         Section (Section 1) of BLOK data.
c**
c**   Interface
c**   ---------
c**       Input: Ksec1 - Array of decoded parameters from Section 1.
c**              Yform - Format of data
c**
c**       Output: Printed data on the standard output.
c**
c**    Method
c**    ------
c**       Fields are printed as integers.
c**
c**    Externals
c**    ---------
c**       None.
c**
c**    Author
c**    ------
c**       D.Jokic,  ECMWF,  February-1992. 
c**
      Character*4 Yform
c
      Integer Ksec1(*)
c
c     ------------------------------------------------------------------
c
c*        1.   Initialise
c              ----------
  100 Continue
      Write (*,9000)
      Write (*,9001)
      Write (*,9002)
      Write (*,9003) Yform
      Write (*,9004) Ksec1(1)
c
c     ------------------------------------------------------------------
c
c*        2.   GRIB data
c              ---------
  200 Continue
      If (Yform.eq.'GRIB') Then
c
          Write (*,9202) Ksec1(2)
          Write (*,9203) Ksec1(3)
          Write (*,9204) Ksec1(4)
          Write (*,9205) Ksec1(5)
          Write (*,9206) Ksec1(6)
          Write (*,9207) Ksec1(7)
          Write (*,9208) Ksec1(8)
          Write (*,9209) Ksec1(9)
          Write (*,9210) Ksec1(10)
          Write (*,9211) Ksec1(11)
          Write (*,9212) Ksec1(12)
          Write (*,9213) Ksec1(13)
          Write (*,9214) Ksec1(14)
          Write (*,9215) Ksec1(15)
          Write (*,9216) Ksec1(16)
          Write (*,9217) Ksec1(17)
          Write (*,9218) Ksec1(18)
          Write (*,9219) Ksec1(19)
          Write (*,9220) Ksec1(20)
          Write (*,9221) Ksec1(21)
          Write (*,9222) Ksec1(22)
          Write (*,9223) Ksec1(23)
c
c     ------------------------------------------------------------------
c
c*        3.   BUFR data
c              ---------
  300 Continue
      Else if (Yform.eq.'BUFR') Then
c
          Write (*,9302) Ksec1(2)
          Write (*,9303) Ksec1(3)
          Write (*,9304) Ksec1(4)
          Write (*,9305) Ksec1(5)
          Write (*,9306) Ksec1(6)
          Write (*,9307) Ksec1(7)
          Write (*,9308) Ksec1(8)
          Write (*,9309) Ksec1(9)
          Write (*,9310) Ksec1(10)
          Write (*,9311) Ksec1(11)
          Write (*,9312) Ksec1(12)
          Write (*,9313) Ksec1(13)
          Write (*,9314) Ksec1(14)
          Write (*,9315) Ksec1(15)
c
      Else
c
          Write (*,9400) Yform
c
      End if
c
 9000 Format (' ')
 9001 Format (' ','BLOK Section 1 - Identification Section.')
 9002 Format (' ','----------------------------------------')
 9003 Format (' ','Binary data format.                       ',A4)
 9004 Format (' ','Parent edition number.               ',I9)
c
 9202 Format (' ','Code Table 2 Version Number.         ',I9)
 9203 Format (' ','Originating centre identifier.       ',I9)
 9204 Format (' ','Model identification.                ',I9)
 9205 Format (' ','Grid definition.                     ',I9)
 9206 Format (' ','Flag (Code Table 1)                  ',I9)
 9207 Format (' ','Parameter identifier (Code Table 2). ',I9)
 9208 Format (' ','Type of level (Code Table 3).        ',I9)
 9209 Format (' ','Value 1 of level (Code Table 3).     ',I9)
 9210 Format (' ','Value 2 of level (Code Table 3).     ',I9)
 9211 Format (' ','Year of data.                        ',I9)
 9212 Format (' ','Month of data.                       ',I9)
 9213 Format (' ','Day of data.                         ',I9)
 9214 Format (' ','Hour of data.                        ',I9)
 9215 Format (' ','Minute of data.                      ',I9)
 9216 Format (' ','Time unit (Code Table 4).            ',I9)
 9217 Format (' ','Time range one.                      ',I9)
 9218 Format (' ','Time range two.                      ',I9)
 9219 Format (' ','Time range indicator (Code Table 5)  ',I9)
 9220 Format (' ','Number averaged.                     ',I9)
 9221 Format (' ','Number missing from average.         ',I9)
 9222 Format (' ','Century of data.                     ',I9)
 9223 Format (' ','Units decimal scaling factor.        ',I9)
c
 9302 Format (' ','BUFR master table.                   ',I9)
 9303 Format (' ','Originating centre identifier.       ',I9)
 9304 Format (' ','Update sequence number.              ',I9)
 9305 Format (' ','Flag.                                ',I9)
 9306 Format (' ','BUFR message type.                   ',I9)
 9307 Format (' ','BUFR message subtype.                ',I9)
 9308 Format (' ','Version number of master table used. ',I9)
 9309 Format (' ','Version number of local table used.  ',I9)
 9310 Format (' ','Year of data.                        ',I9)
 9311 Format (' ','Month of data.                       ',I9)
 9312 Format (' ','Day of data.                         ',I9)
 9313 Format (' ','Hour of data.                        ',I9)
 9314 Format (' ','Minute of data.                      ',I9)
 9315 Format (' ','Indicator of unit of time range.     ',I9)
c
 9400 Format (' Blprs1: Error, Unknown data format: ',a)
c
      Return
      End

 program tc_track_10t5
!
!
!**** tc_track_10t5*
!
!
!     Purpose.
!     --------
!
!         Create tropical cyclone tracks up to 5 day forecast
!
!
!**   Interface.
!     ----------
!
!
!     Method.
!     -------
!
!
!
!
!
!     Externals.
!     ----------
!
!
!
!     Reference.
!     ----------
!
!
!
!     Author.
!     -------
!
!          M. Dragosavac    *ECMWF*      22/12/2001 
!
!
!     Modifications.
!     --------------
!
!          NONE.
!---------------------------------------------------------------------------
 USE bufr_module

 implicit none

! Local variables

  integer              :: narg, iargc, n, nn
  integer              :: iii,j,ios,ij,ii, i, ikbufl
  integer              :: iunit, iret, ilen, iunitin
  integer              :: kdlen, kel, idis
  integer              :: i_001091, i_031001, i_004024
  integer              :: ivo,k,iv,maxrep

  character(len=256)   :: input_file
  character(len=256)   :: output_file
  character(len=256)   :: displacement
  character(len=256), dimension(10) :: carg


! ----------------------------------


!   Get program arguments


    input_file=' '
    output_file=' '
    displacement=' '
    values=rvind
    vals=rvind
    narg=iargc()

    if(narg < 2) then
       print*,'Usage -- tc_tracks_10t5 -i input_file -o output_file -d displacement'
       print*,'      input_file   -- input file name'
       print*,'      output_file  -- output file name'
       print*,'      displacement -- step displacement in hours'
       stop
    end if

    do  j=1,narg
       call getarg(j,carg(j))
    end do


    do j=1,narg
     if(carg(j) == '-i') then
       input_file=carg(j+1)
     elseif(carg(j) == '-o') then
       output_file=carg(j+1)
     elseif(carg(j) == '-d') then
       displacement=carg(j+1) 
     else
       cycle
     end if
    end do

    read(displacement,fmt='(i3.3)') idis
    write(0,*) 'Input  file name='//trim(input_file)
    write(0,*) 'Output file name='//trim(output_file)
    write(0,*) 'step            =',idis


!-- Open input and output files
!   ---------------------------

    call buivar(1)

!   Open input file

    iret=0
    call pbopen(iunitin,trim(input_file),'r',iret)
    if(iret == -1) then
       print*,'Open failed'
       stop
    elseif(iret == -2) then
       print*,'Invalid input file name'
       stop
    elseif(iret == -3) then
       print*,'Invalid open mode specified'
       stop
    end if


!   Open output file

    iret=0
    call pbopen(iunit,trim(output_file),'w',iret)
    if(iret == -1) then
       print*,'Open failed'
       stop
    elseif(iret == -2) then
       print*,'Invalid input file name'
       stop
    elseif(iret == -3) then
       print*,'Invalid open mode specified'
       stop
    end if



 300  continue   

      iret=0
      call pbbufr(iunitin,kbuff,jbufl,kbufl,iret)
      if(iret.eq.-1) then
           call pbclose(iunitin,iret)
           call pbclose(iunit,iret)
           stop 'EOF'
      end if
      if(iret.eq.-2) stop 'file handling problem'
      if(iret.eq.-3) stop 'array too small for product'
 
      ikbufl=kbufl
      kbufl=kbufl/4+1


      call bus012(kbufl,kbuff,ksup,ksec0,ksec1,ksec2,iret)
      if(iret /=0) then
         print*,'error in bus012: ',iret
         print*,' bufr message number ',n,' corrupted.'
         iret=0
         go to 300
      end if
 
      if(ksup(6) > 1) then
         kel=jwork/ksup(6)
      else
         kel=kelem
      end if
 
      call bufrex(kbufl,kbuff,ksup,ksec0 ,ksec1,ksec2 ,ksec3 ,ksec4, &
                  kel,cnames,cunits,kvals,values,cvals,iret)
 
      if(iret /=0) then
         call exit(2)
      end if
 
      call busel(ktdlen,ktdlst,ktdexl,ktdexp,iret)
      if(iret /=0) call exit(2)
!
      i_001091=0
      i_031001=0
      i_004024=0

      do i=1,30
        if(ktdexp(i) == 1091) i_001091=i
        if(ktdexp(i) == 31001) i_031001=i
        if(ktdexp(i) == 4024 .and. i_004024 == 0) i_004024=i
      end do

      ksec1(5)=0
      



      do i=1,ksec3(3)
        ii=(i-1)*kel
      do j=1,24
      vals(j+ii)=values(j+ii)
      end do
      end do

!     The following loop will get rid of unwanted steps


      do i=1,ksec3(3)
        ii=(i-1)*kel
        ivo=i_004024-1+ii
        iv=i_004024-1+ii
        k=0
      do j=i_004024,ktdexl,10
        ivo=j+ii-1
        if(abs(values(ivo+1)-rvind)/rvind > eps ) then
           if(mod(nint(values(ivo+1)),idis) == 0 .and. ktdexp(j) == 004024) then
              vals(iv:iv+9)=values(ivo:ivo+9)
              iv=iv+10
              k=k+1
           end if 
        else
           if(ksec3(4) == 64) then
           vals(iv:iv+9)=values(ivo:ivo+9)
           iv=iv+10
           k=k+1
           end if
        end if
      end do
      kdata(i)=k
      vals(i_031001+ii)=k
      end do
      kdlen=ksec3(3)

      if(ksec3(4) == 64) then
         maxrep=kdata(1)
         do i=2,kdlen
          if(kdata(i) > maxrep) maxrep=kdata(i)
         end do
            
         do i=1,ksec3(3)
            ii=(i-1)*kel
            vals(i_031001+ii)=maxrep
            kdata(i)=maxrep
         end do
      end if

! encode


      iret=0
      
      call bufren(ksec0,ksec1,ksec2,ksec3,ksec4, &
                  ktdlen,ktdlst,kdlen,kdata,kel, &
                  kvals,vals,cvals,kbufl,kbufr,iret)
      if(iret > 0) then
         print*,'bufren error ', iret
         call exit(2)
      elseif(iret < 0) then
         print*,'Encoding return_code=',iret
      end if


!     Write bufr message into output file

      ilen=kbufl*4

      call pbwrite(iunit,kbufr,ilen,iret)
      print*,'length=',ilen,' iret=',iret
      print*,'Bufr message written into output file'

      go to 300


 end program tc_track_10t5

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE BUPRCO(KBUFL,KBUFF,KJ,KDD,KSTACK,KELEM,KERR)
C
C**** *BUPRCO*
C
C
C     PURPOSE.
C     --------
C
C          PROCESS BUFR OPERATOR.
C
C**   INTERFACE.
C     ----------
C
C          *CALL* *BUPRCO(KBUFL,KBUFF,KJ,KDD,KSTACK,KELEM,KERR)*
C
C        INPUT :
C               *KBUFL*   -  LENGTH OF BUFR MESSAGE (WORDS)
C               *KBUFF*   -  ARRAY CONTAINING BUFR MESSAGE
C               *KJ*      -  POINTER TO ARRAY KSTACK
C               *KDD*     -  DATA DESCRIPTOR
C               *KELEM*   -  DIMENSION OF CNAMES, CUNITS ARRAY
C        OUTPUT:
C               *KSTACK*  - LIST OF DESCRIPTORS
C               *KERR*    - RETURN ERROR CODE
C
C     *METHOD.
C      -------
C
C          NONE.
C
C
C     EXTERNALS.
C     ----------
C
C          BUUATB         - UPDATE AUGMENTED TABLE B
C
C     REFERENCE.
C     ----------
C
C          NONE.
C
C     AUTHOR.
C     -------
C
C          M. DRAGOSAVAC    *ECMWF*       01/02/91.
C
C
C     MODIFICATIONS.
C     --------------
C
C          NONE.
C
C
      IMPLICIT LOGICAL(L,O,G), CHARACTER*8(C,H,Y)
C
C
#     include "parameter.F"
#     include "bcomunit.F"
#     include "bcomwork.F"
#     include "bcomwt.F"
#     include "bcomwtc.F"
#     include "bcombef.F"
C
#ifndef R_4
      REAL*8 RVIND
      REAL*8 EPS
#else
      REAL   RVIND
      REAL   EPS
#endif
      CHARACTER CWTEN*64,CWTU*24
      DIMENSION KBUFF(KBUFL)
      DIMENSION KSTACK(*)
C
C     ------------------------------------------------------------------
C
C*          1.   DETERMINE *F *X AND *Y.
C                -----------------------
 100  CONTINUE
C
      IF( KERR.NE.0 ) RETURN
C
      IF  = KDD / 100000
      IDIF= KDD - IF * 100000
      IX  = IDIF / 1000
      IY  = IDIF - IX * 1000
C
      IF( IF.NE.2 ) THEN
         KERR=21
         CALL BUERR(KERR)
         WRITE(KNTN,*) KDD,' IS TO BE OPERATOR'
         GO TO 400
      END IF
C
C*          1.1   CHANGE DATA WIDTH ?
C                 -------------------
 110  CONTINUE
C
      IF(IX.EQ.1) THEN
         IF(IY.EQ.0) THEN
            NDWINC=0
         ELSE
           NDWINC= NDWINC + (IY-128)
         END IF
         GO TO 400
      END IF
C
C*          1.2   CHANGE SCALE ?
C                 --------------
 120  CONTINUE
C
      IF(IX.EQ.2) THEN
C
C*          1.2.1  UPDATE SCALE MULTIPLIER.
C                  ------------------------
C
         IF(IY.EQ.0) THEN
            NSCAM=0
         ELSE
            NSCAM=NSCAM + (IY-128)
         END IF
         GO TO 400
      END IF
C
C*          1.3  CHANGE REFERENCE VALUE ?
C                ------------------------
 130  CONTINUE
C
      IF(IX.EQ.3) THEN
C
C*          1.3.1  UPDATE AUGMENTED TABLE B.
C                  -------------------------
         CALL BUUATB(KBUFL,KBUFF,KJ,IY,KSTACK,KELEM,KERR)
         GO TO 400
      END IF
C
C*          1.4   ADD ASSOCIATED FIELD ?
C                 ----------------------
 140  CONTINUE
C
      IF(IX.EQ.4) THEN
C
C*          1.4.1   UPDATE ASSOCIATED FIELD WIDTH.
C                   ------------------------------
         IF(IY.EQ.0) THEN
            NFD=NFD-1
            IF(NFD.LT.0) THEN
               KERR=51
               CALL BUERR(KERR)
               RETURN
            ELSEIF(NFD.EQ.0) THEN
               NAFDW=0
            END IF
         ELSE
            NFD=NFD+1
            NAFDWA(NFD)=IY
         END IF
         GO TO 400
      END IF

C
C*          1.5   SIGNIFY CHARACTER ?
C                 -------------------
 150  CONTINUE
C
      IF(IX.EQ.5) THEN
C
C*          1.5.1  ADD SPECIAL ENTRY TO WORKING TABLE.
C                  -----------------------------------
         NWT = NWT + 1
         CWTEN(NWT)='CHARACTERS'
         CWTU (NWT)=' '
         NWTR (NWT)= KDD      ! 0
         NWTDW(NWT)= IY * 8
         NWTEN(NWT)=658367
         NWTS (NWT)=0
         NWTRV(NWT)=0
         M=M+1
         GO TO 400
      END IF
C
C*          1.5.2 SIGNIFY DATA WIDTH FOR IMMEDISTELY
C                 FOLLOWED LOCAL DESCRIPTOR
C
 152  CONTINUE
C
      IF(IX.EQ.6) THEN
         NWT = NWT + 1
         KJ=KJ+1
         CWTEN(NWT)='UNKNOWN'
         CWTU (NWT)='UNKNOWN'
         NWTR (NWT)= KSTACK(KJ)
         NWTDW(NWT)= IY
         NWTS (NWT)= 0
         NWTRV(NWT)= 0
         NWTEN(NWT)= NVIND
         M=NWT
C
C        CHECK IF LOCAL TABLE ENTRY KNOWN
C        --------------------------------
C
C         DO 153 I=1,JTAB
C         IF(NWTR(NWT).EQ.NTABBTR(I)) THEN
C            CWTEN(NWT)=CTABBEN(I)
C            CWTU (NWT)=CTABBU (I)
C            IF(CWTU(NWT)(1:3).EQ.'CCI') NWTEN(NWT)=65367
C            NWTS (NWT)=NTABBS (I)
C            NWTRV(NWT)=NTABBRV(I)
C            NWTDW(NWT)=NTABBDW(I)
C            NWTEN(NWT)=NTABBTR(I)
C            GO TO 400
C         END IF
C  153    CONTINUE
C
         GO TO 400
      END IF
C
      IF(IX.EQ.7) THEN
C
C*          1.5.4  UPDATE SCALE MULTIPLIER.
C                  ------------------------
C
         IF(IY.EQ.0) THEN
            N07     =0
            NSCAM07 =0
            NDWINC07=0
         ELSE
            N07     =IY                               ! exponent
            NSCAM07 =IY
            NDWINC07=((10*IY)+2)/3                    ! data width

         END IF
         GO TO 400
      END IF

      IF(IX.EQ.8) THEN
C
C*          1.5.5  SET DATA WIDTH FOR CCITTIA5
C                  ---------------------------
C
         IF(IY.EQ.0) THEN
           N08=0
         ELSE
           N08=IY          ! number of chatacters
         END IF
         GO TO 400
      END IF
C
C
C*          1.6   QUALITY INFORMATION FOLLOWS.
C                 ----------------------------
 160  CONTINUE
C
      IF(IX.EQ.62) THEN
C
      IF(IY.EQ.0) GO TO 400
C
C*          1.7.1  ADD SPECIAL ENTRY TO WORKING TABLE.
C                  -----------------------------------
         NWT = NWT + 1
         CWTEN(NWT)='QUALITY INFORMATION FOLLOW'
         CWTU (NWT)=' '
         NWTDW(NWT)= 0
         NWTR (NWT)= 222000
         NWTRV(NWT)= 0
         NWTEN(NWT)= 0
         NWTS (NWT)= 0
         M=M+1
         IF(M.GT.KELEM) THEN
            KERR=25
            WRITE(KNTN,*)  'BUPRCO:'
            CALL BUERR(KERR)
            RETURN
         END IF
         GO TO 400
      END IF
C
C
C*          2.  PROCESSING NEW OPERATORS.
C               -------------------------
 200  CONTINUE
C
C
C*          2.1   DATA NOT PRESENT.
C                 -----------------
 210  CONTINUE
C
      IF(IX.EQ.21) THEN
         N221=IY
         GO TO 400
      END IF
C
C
C*          2.2   QUALITY INFORMATION FOLLOWS.
C                 ----------------------------
 220  CONTINUE
C
      IF(IX.EQ.22) THEN
C
C*          1.7.2  ADD SPECIAL ENTRY TO WORKING TABLE.
C                  -----------------------------------
         NWT = NWT + 1
         CWTEN(NWT)='QUALITY INFORMATION FOLLOW'
         CWTU (NWT)=' '
         NWTDW(NWT)= 0
         NWTR (NWT)= 222000
         NWTRV(NWT)= 0
         NWTEN(NWT)= 0
         NWTS (NWT)= 0
         M=M+1
         IF(M.GT.KELEM) THEN
            KERR=25
            WRITE(KNTN,*)  'BUPRCO:'
            CALL BUERR(KERR)
            RETURN
         END IF
         GO TO 400
      END IF
C
C
C*          2.3   SUBSTITUTED VALUES FOLLOWS.
C                 ---------------------------
 230  CONTINUE
C
      IF(IX.EQ.23) THEN
         IF(IY.EQ.0) THEN
            NWT=NWT+1
            CWTEN(NWT)='SUBSTITUTED VALUES FOLLOW'
            CWTU (NWT)=' '
            NWTDW(NWT)= 0
            NWTR (NWT)=223000
            NWTRV(NWT)= 0
            NWTEN(NWT)= 0
            NWTS (NWT)= 0
            M=M+1
            IF(M.GT.KELEM) THEN
               KERR=25
               WRITE(KNTN,*)  'BUPRCO:'
               CALL BUERR(KERR)
               RETURN
            END IF
            GO TO 400
         ELSE
            IF(NFD.NE.0) THEN
               DO I=1,NFD
               NWT=NWT+1
               CWTEN(NWT)='ASSOCIATED FIELD'
               CWTU (NWT)=' '
               NWTDW(NWT)= 0
               NWTR (NWT)= 0
               NWTRV(NWT)= 0
               NWTEN(NWT)= 0
               NWTS (NWT)= 0
               M=M+1
               END DO
               IF(M.GT.KELEM) THEN
                  KERR=25
                  WRITE(KNTN,*)  'BUPRCO:'
                  CALL BUERR(KERR)
                  RETURN
               END IF
            END IF
            OMARKER=.TRUE.
            NWT=NWT+1
             CWTEN(NWT)='SUBSTITUTED VALUE MARKER'
             CWTU (NWT)=' '
            NWTDW(NWT)= 0
            NWTR (NWT)=KDD
             NWTRV(NWT)= 0
             NWTEN(NWT)= 0
             NWTS (NWT)= 0
            M=M+1
            IF(M.GT.KELEM) THEN
               KERR=25
               WRITE(KNTN,*)  'BUPRCO:'
               CALL BUERR(KERR)
               RETURN
            END IF
            GO TO 400
         END IF
      END IF
C
C
C*          2.4   FIRST ORDER STATISTICS FOLLOWS.
C                 -------------------------------
 240  CONTINUE
C
      IF(IX.EQ.24) THEN
         IF(IY.EQ.0) THEN
            NWT=NWT+1
            CWTEN(NWT)='FIRST ORDER STATISTICS FOLLOW'
            CWTU (NWT)=' '
            NWTDW(NWT)= 0
            NWTR (NWT)=224000
            NWTRV(NWT)= 0
            NWTEN(NWT)= 0
            NWTS (NWT)= 0
            M=M+1
            IF(M.GT.KELEM) THEN
               KERR=25
               WRITE(KNTN,*)  'BUPRCO:'
               CALL BUERR(KERR)
               RETURN
            END IF
            GO TO 400
         ELSE
            IF(NFD.NE.0) THEN
               DO I=1,NFD
               NWT=NWT+1
               CWTEN(NWT)='ASSOCIATED FIELD'
               CWTU (NWT)=' '
               NWTDW(NWT)= 0
               NWTR (NWT)= 0
               NWTRV(NWT)= 0
               NWTEN(NWT)= 0
               NWTS (NWT)= 0
               M=M+1
               END DO
               IF(M.GT.KELEM) THEN
                  KERR=25
                  WRITE(KNTN,*)  'BUPRCO:'
                  CALL BUERR(KERR)
                  RETURN
               END IF
            END IF
            OMARKER=.TRUE.
            NWT=NWT+1
             CWTEN(NWT)='FIRST ORDER STATISTICS VALUE MARKER'
             CWTU (NWT)=' '
            NWTDW(NWT)= 0
            NWTR (NWT)=KDD
             NWTRV(NWT)= 0
             NWTEN(NWT)= 0
             NWTS (NWT)= 0
            M=M+1
            IF(M.GT.KELEM) THEN
               KERR=25
               WRITE(KNTN,*)  'BUPRCO:'
               CALL BUERR(KERR)
               RETURN
            END IF
            GO TO 400
         END IF
      END IF
C
C*          2.5   DIFFERENCE STATISTICAL VALUES FOLLOW.
C                 -------------------------------------
 250  CONTINUE
C
      IF(IX.EQ.25) THEN
         IF(IY.EQ.0) THEN
            NWT=NWT+1
            CWTEN(NWT)='DIFFERENCE STATISTICAL VALUES FOLLOW'
            CWTU (NWT)=' '
            NWTDW(NWT)= 0
            NWTR (NWT)=225000
            NWTRV(NWT)= 0
            NWTEN(NWT)= 0
            NWTS (NWT)= 0
            M=M+1
            IF(M.GT.KELEM) THEN
               KERR=25
               WRITE(KNTN,*)  'BUPRCO:'
               CALL BUERR(KERR)
               RETURN
            END IF
            GO TO 400
         ELSE
            IF(NFD.NE.0) THEN
               DO I=1,NFD
               NWT=NWT+1
               CWTEN(NWT)='ASSOCIATED FIELD'
               CWTU (NWT)=' '
               NWTDW(NWT)= 0
               NWTR (NWT)= 0
               NWTRV(NWT)= 0
               NWTEN(NWT)= 0
               NWTS (NWT)= 0
               M=M+1
               END DO
               IF(M.GT.KELEM) THEN
                  KERR=25
                  WRITE(KNTN,*)  'BUPRCO:'
                  CALL BUERR(KERR)
                  RETURN
               END IF
            END IF
            OMARKER=.TRUE.
            NWT=NWT+1
             CWTEN(NWT)='DIFFERENCE STATISTICS VALUE MARKER'
             CWTU (NWT)=' '
            NWTDW(NWT)= 0
            NWTR (NWT)=KDD
             NWTRV(NWT)= 0
             NWTEN(NWT)= 0
             NWTS (NWT)= 0
            M=M+1
            IF(M.GT.KELEM) THEN
               KERR=25
               WRITE(KNTN,*)  'BUPRCO:'
               CALL BUERR(KERR)
               RETURN
            END IF
            GO TO 400
         END IF
      END IF
C
C
C*          2.6   REPLACED/RETAINED VALUES FOLLOWS.
C                 ---------------------------------
 260  CONTINUE
C
      IF(IX.EQ.32) THEN
         IF(IY.EQ.0) THEN
            NWT=NWT+1
            CWTEN(NWT)='REPLACE/RETAINED VALUES FOLLOW'
            CWTU (NWT)=' '
            NWTDW(NWT)= 0
            NWTR (NWT)=232000
            NWTRV(NWT)= 0
            NWTEN(NWT)= 0
            NWTS (NWT)= 0
            M=M+1
            IF(M.GT.KELEM) THEN
               KERR=25
               WRITE(KNTN,*)  'BUPRCO:'
               CALL BUERR(KERR)
               RETURN
            END IF
            GO TO 400
         ELSE
            IF(NFD.NE.0) THEN
               DO I=1,NFD
               NWT=NWT+1
               CWTEN(NWT)='ASSOCIATED FIELD'
               CWTU (NWT)=' '
               NWTDW(NWT)= 0
               NWTR (NWT)= 0
               NWTRV(NWT)= 0
               NWTEN(NWT)= 0
               NWTS (NWT)= 0
               M=M+1
               END DO
               IF(M.GT.KELEM) THEN
                  KERR=25
                  WRITE(KNTN,*)  'BUPRCO:'
                  CALL BUERR(KERR)
                  RETURN
               END IF
            END IF
            OMARKER=.TRUE.
            NWT=NWT+1
             CWTEN(NWT)='REPLACE/RETAINED VALUE MARKER'
             CWTU (NWT)=' '
            NWTDW(NWT)= 0
            NWTR (NWT)=KDD
             NWTRV(NWT)= 0
             NWTEN(NWT)= 0
             NWTS (NWT)= 0
            M=M+1
            IF(M.GT.KELEM) THEN
               KERR=25
               WRITE(KNTN,*)  'BUPRCO:'
               CALL BUERR(KERR)
               RETURN
            END IF
            GO TO 400
         END IF
      END IF
C
C*          2.7   CANCEL BACKWARD REFERENCE.
C                 --------------------------
 270  CONTINUE
C
      IF(IX.EQ.35) THEN
C
C*          1.7.2  ADD SPECIAL ENTRY TO WORKING TABLE.
C                  -----------------------------------
         NWT = NWT + 1
         CWTEN(NWT)='CANCEL BACKWARD DATA REFERENCE'
         CWTU (NWT)=' '
         NWTDW(NWT)= 0
         NWTR (NWT)= 235000
         NWTRV(NWT)= 0
         NWTEN(NWT)= 0
         NWTS (NWT)= 0
C
C         MREL=0
         M=M+1
         IF(M.GT.KELEM) THEN
            KERR=25
            WRITE(KNTN,*)  'BUPRCO:'
            CALL BUERR(KERR)
            RETURN
         END IF
         GO TO 400
      END IF
C
C*          2.8   DEFINE BACKWARD REFERENCE BIT MAP.
C                 ----------------------------------
 280  CONTINUE
C
      IF(IX.EQ.36) THEN
C
C*          2.8.1  ADD SPECIAL ENTRY TO WORKING TABLE.
C                  -----------------------------------
         NWT = NWT + 1
         CWTEN(NWT)='BACKWARD REFERENCE BIT MAP'
         CWTU (NWT)=' '
         NWTDW(NWT)= 0
         NWTR (NWT)= 236000
         NWTRV(NWT)= 0
         NWTEN(NWT)= 0
         NWTS (NWT)= 0
C
         M=M+1
         IF(M.GT.JELEM) THEN
            KERR=30
            WRITE(KNTN,*)  'BUOPER:'
            CALL BUERR(KERR)
            RETURN
         END IF
         GO TO 400
      END IF
C
C*          2.9   DEFINE BACKWARD REFERENCE BIT MAP.
C                 ----------------------------------
 290  CONTINUE
C
      IF(IX.EQ.37) THEN
         IF(IY.EQ.0) THEN
C
C*          2.9.1  ADD SPECIAL ENTRY TO WORKING TABLE.
C                  -----------------------------------
            NWT = NWT + 1
            CWTEN(NWT)='USE PREVIOUSLY DEFINED BIT MAP'
            CWTU (NWT)=' '
            NWTDW(NWT)= 0
            NWTR (NWT)= 237000
            NWTRV(NWT)= 0
            NWTEN(NWT)= 0
            NWTS (NWT)= 0
C
            M=M+1
            IF(M.GT.JELEM) THEN
               KERR=30
               WRITE(KNTN,*)  'BUOPER:'
               CALL BUERR(KERR)
               RETURN
            END IF
            GO TO 400
         ELSE
C
C*          2.9.1  ADD SPECIAL ENTRY TO WORKING TABLE.
C                  -----------------------------------
            NWT = NWT + 1
            CWTEN(NWT)='CANCEL REFERENCE TO PREDEFINED BIT MAP'
            CWTU (NWT)=' '
            NWTDW(NWT)= 0
            NWTR (NWT)= KDD
            NWTRV(NWT)= 0
            NWTEN(NWT)= 0
            NWTS (NWT)= 0
C
            M=M+1
            IF(M.GT.JELEM) THEN
               KERR=30
               WRITE(KNTN,*)  'BUOPER:'
               CALL BUERR(KERR)
               RETURN
            END IF
            GO TO 400
         END IF
      END IF
C
      IF(IX.EQ.9) THEN
         IF(IY.EQ.0) THEN
            N40=0
         ELSE
            N40=IY
         END IF
C
         GO TO 400
      END IF
C

C
C*    5. DEFINE EVENT
C        ------------
 500  CONTINUE
C
      IF(IX.EQ.41) THEN
         IF(IY.EQ.0) THEN
C
C         5.1.1 ADD SPECIAL ENTRY TO WORKING TABLE.
C               -----------------------------------
            NWT = NWT + 1
            CWTEN(NWT)='DEFINE EVENT'
            CWTU (NWT)=' '
            NWTDW(NWT)= 0
            NWTR (NWT)= 241000
            NWTRV(NWT)= 0
            NWTEN(NWT)= 0
            NWTS (NWT)= 0
C
            M=M+1
            IF(M.GT.JELEM) THEN
               KERR=30
               WRITE(KNTN,*)  'BUOPER:'
               CALL BUERR(KERR)
               RETURN
            END IF
            GO TO 400
         ELSE
C
C*          5.1.1  ADD SPECIAL ENTRY TO WORKING TABLE.
C                  -----------------------------------
            NWT = NWT + 1
            CWTEN(NWT)='CANCEL DEFINE EVENT'
            CWTU (NWT)=' '
            NWTDW(NWT)= 0
            NWTR (NWT)= KDD
            NWTRV(NWT)= 0
            NWTEN(NWT)= 0
            NWTS (NWT)= 0
C
            M=M+1
            IF(M.GT.JELEM) THEN
               KERR=30
               WRITE(KNTN,*)  'BUOPER:'
               CALL BUERR(KERR)
               RETURN
            END IF
            GO TO 400
         END IF
      END IF
C
C*        5.1  DEFINE CONDITIONING EVENT
C              -------------------------
 510  CONTINUE
C
      IF(IX.EQ.42) THEN
         IF(IY.EQ.0) THEN
C
C         5.1.1 ADD SPECIAL ENTRY TO WORKING TABLE.
C               -----------------------------------
            NWT = NWT + 1
            CWTEN(NWT)='DEFINE CONDITIONING EVENT'
            CWTU (NWT)=' '
            NWTDW(NWT)= 0
            NWTR (NWT)= 242000
            NWTRV(NWT)= 0
            NWTEN(NWT)= 0
            NWTS (NWT)= 0
C
            M=M+1
            IF(M.GT.JELEM) THEN
               KERR=30
               WRITE(KNTN,*)  'BUOPER:'
               CALL BUERR(KERR)
               RETURN
            END IF
            GO TO 400
         ELSE
C
C*          5.1.2  ADD SPECIAL ENTRY TO WORKING TABLE.
C                  -----------------------------------
            NWT = NWT + 1
            CWTEN(NWT)='CANCEL DEFINE CONDITIONING EVENT'
            CWTU (NWT)=' '
            NWTDW(NWT)= 0
            NWTR (NWT)= KDD
            NWTRV(NWT)= 0
            NWTEN(NWT)= 0
            NWTS (NWT)= 0
C
            M=M+1
            IF(M.GT.JELEM) THEN
               KERR=30
               WRITE(KNTN,*)  'BUOPER:'
               CALL BUERR(KERR)
               RETURN
            END IF
            GO TO 400
         END IF
      END IF
C
C*        5.2  DEFINE CONDITIONING EVENT
C              -------------------------
 520  CONTINUE
C
      IF(IX.EQ.43) THEN
         IF(IY.EQ.0) THEN
C
C         5.2.1 ADD SPECIAL ENTRY TO WORKING TABLE.
C               -----------------------------------
            NWT = NWT + 1
            CWTEN(NWT)='CATEGORICAL FORECAST VALUES FOLLOW'
            CWTU (NWT)=' '
            NWTDW(NWT)= 0
            NWTR (NWT)= 243000
            NWTRV(NWT)= 0
            NWTEN(NWT)= 0
            NWTS (NWT)= 0
C
            M=M+1
            IF(M.GT.JELEM) THEN
               KERR=30
               WRITE(KNTN,*)  'BUOPER:'
               CALL BUERR(KERR)
               RETURN
            END IF
            GO TO 400
         ELSE
C
C*          5.2.2  ADD SPECIAL ENTRY TO WORKING TABLE.
C                  -----------------------------------
            NWT = NWT + 1
            CWTEN(NWT)='CANCEL CATEGORICAL FORECAST VALUES FOLLOW'
            CWTU (NWT)=' '
            NWTDW(NWT)= 0
            NWTR (NWT)= KDD
            NWTRV(NWT)= 0
            NWTEN(NWT)= 0
            NWTS (NWT)= 0
C
            M=M+1
            IF(M.GT.JELEM) THEN
               KERR=30
               WRITE(KNTN,*)  'BUOPER:'
               CALL BUERR(KERR)
               RETURN
            END IF
            GO TO 400
         END IF
      END IF
C
C     ------------------------------------------------------------------
C
 300  CONTINUE
C
      KERR=22
      WRITE(KNTN,*)  'BUPRCO:'
      CALL BUERR(KERR)
C
C     ------------------------------------------------------------------
C
 400  CONTINUE
C
      RETURN
      END

C
C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities
C granted to it by virtue of its status as an intergovernmental organisation
C nor does it submit to any jurisdiction.
C

      INTEGER FUNCTION WV2DXX2(KNSPEC, NUMLATS, NPTS,
     X                         NLATS, STEPNS, STEPWE,
     X                         OLDWAVE, NEWWAVE, NORTH, WEST, PMISS)
C
C---->
C*****WV2DXX2*
C
C     PURPOSE
C     -------
C
C     Interpolates 2D wave spectra fields.
C
C
C     INTERFACE
C     ---------
C
C     IRET = WV2DXX2(KNSPEC, NUMLATS, NPTS,
C    X               NLATS, STEPNS, STEPWE,
C    X               OLDWAVE, NEWWAVE, NORTH, WEST, PMISS)
C
C     Input arguments
C     ---------------
C
C     KNSPEC  - Number of 2D spectra values at each wave point
C     NUMLATS - Input lat number north-south
C     NPTS    - Array giving number of points along each latitude
C               for input field (empty latitudes have entry 0)
C     NLATS   - Number of points N-S in new grid
C     STEPNS  - Output grid north-south resolution (degrees)
C     STEPWE  - Output grid west-east resolution (degrees)
C     OLDWAVE - Original wave field
C     NORTH   - Output grid northernmost latitude (degrees)
C     WEST    - Output grid westernmost longitude (degrees)
C     PMISS   - Missing data value
C
C     Output arguments
C     ----------------
C
C     NEWWAVE - New wave field
C
C     Function returns 0 if the interpolation was OK.
C
C
C     METHOD
C     ------
C
C     Builds the index of neighbouring points for the output grid.
C     Then works through the output grid points, checking for subarea
C     boundaries and looking up neighbouring point 2D spectra values
C     (which may be missing data).
C
C
C     EXTERNALS
C     ---------
C
C     WV2DIDX - builds the index of nearest neighbour points
C     NUMPTWE - Calculates number of grid points between west/east
C               area boundaries
C     NUMVALS - Counts the values in the secondary bitmap.
C     INTLOG  - Log error message
C     JMALLOC - Dynamically allocate memory (deallocation -JFREE- not used)
C
C
C     REFERENCE
C     ---------
C
C     None.
C
C
C     Author.
C     -------
C
C     S. Curic      ECMWF    Jun 2009
C
C     Handle parameter 251 as a simple form of wave 2D spectra.
C     (A field containing one direction and one frequency).
C
C
C----<
C
      IMPLICIT NONE
C
C     Parameters
C
#include "parim.h"
C
      INTEGER JPROUTINE, JPMXLAT, JPNSPEC
      PARAMETER( JPROUTINE = 40000 )
      PARAMETER( JPMXLAT   =  1801 ) ! allow up to 0.1 degree resolution
      PARAMETER( JPNSPEC   =   600 )
C
#include "nifld.common"
#include "nofld.common"
#include "grspace.h"
C
C     Arguments
C
      INTEGER KNSPEC
      INTEGER NUMLATS, NPTS(*), NLATS
      REAL STEPNS, STEPWE, OLDWAVE(*), NEWWAVE(*), NORTH, WEST, PMISS
C
C     Local variables
C
      INTEGER IEOFSET, INDEX, ISTART, IWEST, IWOFSET, KNEWNUM,
     X        KOLDNUM, LOOP, MISSLAT, NCOL, NEXT,
     X        NEXTWV, NROW, NUMNEW(JPMXLAT)
      REAL    AWEST, EAST, NEWLATS(JPMXLAT), OLDLATS(JPMXLAT),
     X        ONORTH, OSOUTH, PTLAT, PTLONG, RLATINC, ROWINC,
     X        SOUTH, OLDEAST, OLDWEST
      INTEGER IRET
C
C     Large, resolution-dependent arrays
C
      LOGICAL IS_ALLOCATED_LARGEARRAY
      DATA    IS_ALLOCATED_LARGEARRAY /.FALSE./
      SAVE    IS_ALLOCATED_LARGEARRAY
C
      INTEGER NEWIDX(JPARRAYDIM_WAVE)
#ifndef _CRAYFTN
#ifdef POINTER_64
      INTEGER*8 P_NEWIDX
#endif
#endif
      POINTER(P_NEWIDX,NEWIDX)
      SAVE P_NEWIDX
C
C     Externals
C
      INTEGER  WV2DIDX, NUMVALS, NUMPTWE
#ifdef POINTER_64
      INTEGER*8 JMALLOC
#else
      INTEGER JMALLOC
#endif
      EXTERNAL WV2DIDX, NUMVALS, NUMPTWE, JMALLOC
C
C     -----------------------------------------------------------------|
C*    Section 1. Initalisation.
C     -----------------------------------------------------------------|
C
  100 CONTINUE
C
      WV2DXX2 = 0
C
C     Initialise the bitmap value lookup function and function
C     which counts the values in the secondary bitmap.
C
      IRET = NUMVALS(0,0,0)
C
C     Check only new-style 2D wave spectra (parameter 251)
C
      IF( KNSPEC.GT.0 ) THEN
        CALL INTLOG(JP_ERROR,
     X    'WV2DXX2: Only single-value 2D spectra field allowed',JPQUIET)
        CALL INTLOG(JP_ERROR,
     X    'WV2XX2: Value given = ',KNSPEC)
        WV2DXX2 = JPROUTINE + 1
        GOTO 900
      ENDIF
C
C     Calculate number of latitudes if grid had been full from
C     North pole to South pole
C
      IF( NUMLATS.GT.JPMXLAT ) THEN
        CALL INTLOG(JP_ERROR,
     X    'WV2DXX2: Number of latitudes in input grid = ',NUMLATS)
        CALL INTLOG(JP_ERROR,
     X    'WV2DXX2: And is greater than allowed maximum = ',JPMXLAT)
        WV2DXX2 = JPROUTINE + 2
        GOTO 900
      ENDIF

      ONORTH = FLOAT(NIAREA(1))/PPMULT
      OSOUTH = FLOAT(NIAREA(3))/PPMULT

      RLATINC = FLOAT(NIGRID(2))/PPMULT

      DO LOOP = 1, NUMLATS
        OLDLATS(LOOP) = 90.0 - (LOOP-1)*RLATINC
      ENDDO
C
C     Fill an array with the number of points at each latitude for the
C     input field (this is a reduced latitude/longitude grid)
C
      MISSLAT = (90.0 - ONORTH)/RLATINC
      KOLDNUM = 1 + (90.0 - OSOUTH)/RLATINC
C
      IF( NIREPR.NE.JPREDLL ) THEN
        DO LOOP = 1, MISSLAT
          NPTS(LOOP)    = 0
        ENDDO
        DO LOOP = 1, (KOLDNUM-MISSLAT)
          NPTS(LOOP+MISSLAT) = NIWE
        ENDDO
        DO LOOP = (KOLDNUM+1), NUMLATS
          NPTS(LOOP)    = 0
        ENDDO
      ENDIF
C
C     Allocate large, resolution-dependent arrays
      IF (.NOT. IS_ALLOCATED_LARGEARRAY) THEN
        P_NEWIDX = JMALLOC(JPARRAYDIM_WAVE*JPBYTES)  ! len*bytes
        IF( P_NEWIDX.EQ.0 ) THEN
          CALL INTLOG(JP_ERROR,'WV2DXX2: JMALLOC fail',JPQUIET)
          WV2DXX2 = JPROUTINE + 1
          GOTO 900
        ENDIF
        IS_ALLOCATED_LARGEARRAY = .TRUE.
      END IF
C
C     -----------------------------------------------------------------|
C*    Section 2. Setup number of points at each latitude for the
C                output latitude/longitude field.
C     -----------------------------------------------------------------|
C
  200 CONTINUE
C
      IF( (NOREPR.EQ.JPQUASI) .OR. (NOREPR.EQ.JPGAUSSIAN) ) THEN
C
C       Reduced (quasi-regular) gaussian output
C
        KNEWNUM = NOGAUSS*2
        DO LOOP = 1, KNEWNUM
          NUMNEW(LOOP)  = NOLPTS(LOOP)
          NEWLATS(LOOP) = ROGAUSS(LOOP)
        ENDDO
C
      ELSE IF( NOREPR.EQ.JPREDLL ) THEN
C
C       Reduced (quasi-regular) lat/long output
C
        KNEWNUM = NOREDLL
        DO LOOP = 1, KNEWNUM
          NUMNEW(LOOP)  = NOLPTS(LOOP)
          NEWLATS(LOOP) = ROREDLL(LOOP)
        ENDDO
C
      ELSE
C
C       Regular output
C
        MISSLAT = NINT((90.0 - NORTH)/STEPNS)
        DO LOOP = 1, MISSLAT
          NUMNEW(LOOP)    = 0
        ENDDO
        DO LOOP = 1, NLATS
          NUMNEW(LOOP+MISSLAT) = NINT(360.0/STEPWE)
        ENDDO
C
        KNEWNUM = MISSLAT + NLATS
        DO LOOP = 1, KNEWNUM
          NEWLATS(LOOP) = 90.0 - (LOOP-1)*STEPNS
        ENDDO
C
      ENDIF
C
C     -----------------------------------------------------------------|
C*    Section 3. Get the input GRIB field characteristics.
C     -----------------------------------------------------------------|
C
  300 CONTINUE
C
C     Calculate the indices of the input grid points to be used for
C     the output points
C
      OLDWEST = FLOAT(NIAREA(2))/PPMULT
      OLDEAST = FLOAT(NIAREA(4))/PPMULT

      WV2DXX2 = WV2DIDX(NUMLATS,NPTS,OLDLATS,OLDWEST,OLDEAST,
     X                  KNEWNUM, NUMNEW, NEWLATS, NEWIDX)
      IF( WV2DXX2.NE.0 ) THEN
        CALL INTLOG(JP_ERROR,
     X    'WV2DXX2: Unable to calculate output grid indices',JPQUIET)
        WV2DXX2 = JPROUTINE + 3
        GOTO 900
      ENDIF
C
C     -----------------------------------------------------------------|
C*    Section 4. Work through the output subarea.
C     -----------------------------------------------------------------|
C
  400 CONTINUE
C
C     Fill in the wave spectra values
C
      NEXT = 0
      NEXTWV = 0
C
      SOUTH = NOAREA(3)/PPMULT
      EAST  = NOAREA(4)/PPMULT
      ISTART = 0
C
C     Work down through latitudes from north to south.
C
      DO NROW = 1, KNEWNUM
C
C       If inside north-south (subarea) boundaries ..
C
        IF( (NOREPR.EQ.JPGAUSSIAN).OR.(NOREPR.EQ.JPQUASI) ) THEN
          PTLAT = ROGAUSS(NROW)
        ELSE
          PTLAT = 90.0 - (NROW-1)*STEPNS
        ENDIF
C
        IF( (PTLAT.LE.NORTH).AND.(ABS(PTLAT-SOUTH).GT.-0.0005) ) THEN
C
C         Calculate number of points between west boundary of area and
C         Greenwich
C
          ROWINC = 360.0/NUMNEW(NROW)
C
          IWEST = INT(WEST/ROWINC)
          IF( (WEST.GT.0.0).AND.(WEST.NE.(IWEST*ROWINC)) ) THEN
            IWEST = IWEST + 1
          ELSEIF( (WEST.LT.0.0).AND.(WEST.NE.(IWEST*ROWINC)) ) THEN
            IWEST = IWEST - 1
          ENDIF
          AWEST = IWEST * ROWINC
          IWOFSET = NUMPTWE(AWEST,0.0,ROWINC)
          IEOFSET = NUMPTWE(AWEST,EAST,ROWINC)
C
C         Work through subarea longitudes from west to east.
C
          DO NCOL = 1, NUMNEW(NROW)
            PTLONG = AWEST + (NCOL-1)*ROWINC
            NEXT = NUMPTWE(AWEST,PTLONG,ROWINC)
            IF( (NEXT.LE.IEOFSET).AND.(NEXT.GE.0) ) THEN
C
C             .. and inside west-east (subarea) boundaries
C
              NEXT = 1 + NEXT - IWOFSET
              IF( NEXT.LE.0) NEXT = NEXT + NUMNEW(NROW)
              NEXT = NEXT + ISTART
              NEXTWV = NEXTWV + 1
C
              INDEX = NEWIDX(NEXT)
              IF( OLDWAVE(INDEX).EQ.PMISS.OR.INDEX.EQ.0) THEN
C
C                 Nearest point is missing
C
                  NEWWAVE(NEXTWV) = PMISS
C
              ELSE
                  NEWWAVE(NEXTWV) = OLDWAVE(INDEX)
              ENDIF
C
            ENDIF
          ENDDO
C
        ENDIF
        ISTART = ISTART + NUMNEW(NROW)
      ENDDO
C
C     -----------------------------------------------------------------|
C*    Section 9. Closedown.
C     -----------------------------------------------------------------|
C
  900 CONTINUE
      RETURN
      END

C
C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      INTEGER FUNCTION WV2DXX2(KNSPEC, NUMLATS, NPTS,
     X                         NLATS, STEPNS, STEPWE,
     X                         OLDWAVE, NEWWAVE,
     X                         NORTH,WEST,PMISS)
C
C---->
C*****WV2DXX2*
C
C     PURPOSE
C     -------
C
C     Interpolates 2D wave spectra fields.
C
C
C     INTERFACE
C     ---------
C
C     IRET = WV2DXX2(KNSPEC, NUMLATS, NPTS,
C    X               NLATS,STEPNS,STEPWE,
C    X               OLDWAVE,NEWWAVE,
C    X               NORTH,WEST,PMISS)
C
C     Input arguments
C     ---------------
C
C     KNSPEC  - Number of 2D spectra values at each wave point
C     NUMLATS - Input lat number north-south
C     NPTS   - Array giving number of points along each latitude
C              for Input field (empty latitudes have entry 0)
C     NLATS   - Number of points N-S in new grid
C     STEPNS  - Output grid north-south resolution (degrees)
C     STEPWE  - Output grid west-east resolution (degrees)
C     OLDWAVE - Original wave field
C     NORTH   - Output grid northernmost latitude (degrees)
C     WEST    - Output grid westernmost longitude (degrees)
C     PMISS   - Missing data value 
C
C     Output arguments
C     ----------------
C
C     NEWWAVE - New wave field
C
C     Function returns 0 if the interpolation was OK.
C
C
C     METHOD
C     ------
C
C     Builds the index of nearest neighbour points for the output grid.
C     Then works through the output grid points, checking for subarea
C     boundaries and looking up nearset neighbour 2D spectra values
C     (which may be missing data).
C
C
C     EXTERNALS
C     ---------
C
C     WV2DIDX - builds the index of nearest neighbour points
C     NUMPTWE - Calculates number of grid points between west/east
C               area boundaries
C     NUMVALS - Counts the values in the secondary bitmap.
C     INTLOG  - Log error message
C     JMALLOC - Dynamically allocate memory (deallocation -JFREE- not used)
C
C
C     REFERENCE
C     ---------
C
C     None.
C
C
C     Author.
C     -------
C
C     S. Curic         ECMWF    Jun 2009 
C
C     Handle parameter 251 as a simple form of wave 2D spectra.
C     (A field containing one direction and one frequency).
C
C
C----<
C
      IMPLICIT NONE
C
C     Parameters
C
#include "parim.h"
#include "nifld.common"
#include "nofld.common"
#include "grspace.h"
C
C     Subroutine arguments
C
      INTEGER NPTS,NLATS
      DIMENSION NPTS(*)
      REAL STEPNS, STEPWE, OLDWAVE, NEWWAVE, NORTH, WEST, PMISS
      DIMENSION OLDWAVE(*), NEWWAVE(*)
      INTEGER NUMLATS, KNSPEC
C
C     Parameters
C
      INTEGER JPROUTINE, JPMXLAT, JPNSPEC
      PARAMETER (JPROUTINE = 40000)
      PARAMETER (JPMXLAT = 1801)
      PARAMETER (JPNSPEC = 600)
C
C     Local arguments
C
      INTEGER IEOFSET, IWOFSET, ISTART, IWEST
      REAL SOUTH, EAST, PTLAT, PTLONG, AWEST, OLDWEST, OLDEAST
      REAL REFVAL, SCALE
      INTEGER NPDATA, INSPT, NEXP, NMANT, NRETA, NRETB, NLENG, NBIT
      INTEGER NVALS
      INTEGER ISCALE, NSCALE, IBITS, ITEMP, NPBTMP2, IBITMAP, NUNUSED
      DIMENSION IBITMAP(JPNSPEC)
      INTEGER IRET, IEDITN
      INTEGER NEXT, NEXTWV, NROW, NCOL, INDEX, ILOCATE
      INTEGER MISSLAT, LOOP, NUMNEW
      INTEGER KOLDNUM, KNEWNUM
      DIMENSION  NUMNEW(JPMXLAT)
      REAL RLATINC, OLDLATS, NEWLATS, ROWINC
      REAL ONORTH, OSOUTH
      DIMENSION OLDLATS(JPMXLAT), NEWLATS(JPMXLAT)
C
C     Large, resolution-dependent arrays
C
      LOGICAL IS_ALLOCATED_LARGEARRAY
      DATA    IS_ALLOCATED_LARGEARRAY /.FALSE./
      SAVE    IS_ALLOCATED_LARGEARRAY
C
      INTEGER NEWIDX
      DIMENSION NEWIDX(JPARRAYDIM_WAVE)
#ifndef _CRAYFTN
#ifdef POINTER_64
      INTEGER*8 P_NEWIDX
#endif
#endif
      POINTER(P_NEWIDX,NEWIDX)
      SAVE P_NEWIDX
C
C     Externals
C
      INTEGER  WV2DIDX, NUMVALS, NUMPTWE
#ifdef POINTER_64
      INTEGER*8 JMALLOC
#else
      INTEGER JMALLOC
#endif
      EXTERNAL WV2DIDX, NUMVALS, NUMPTWE, JMALLOC
C
C ---------------------------------------------------------------------
C*    Section 1. Initalisation.
C ---------------------------------------------------------------------
C
  100 CONTINUE
C
      WV2DXX2 = 0
C
C     Initialise the bitmap value lookup function and function
C     which counts the values in the secondary bitmap.
C
      IRET = NUMVALS(0,0,0)
C
C     Check only new-style 2D wave spectra (parameter 251)
C
      IF( KNSPEC.GT.0 ) THEN
        CALL INTLOG(JP_ERROR,
     X    'WV2DXX2: Only single-value 2D spectra field allowed',JPQUIET)
        CALL INTLOG(JP_ERROR,
     X    'WV2XX2: Value given = ',KNSPEC)
        WV2DXX2 = JPROUTINE + 1
        GOTO 900
      ENDIF
C
C     Calculate number of latitudes if grid had been full from
C     North pole to South pole
C
      IF( NUMLATS.GT.JPMXLAT ) THEN
        CALL INTLOG(JP_ERROR,
     X    'WV2DXX2: Number of latitudes in input grid = ',NUMLATS)
        CALL INTLOG(JP_ERROR,
     X    'WV2DXX2: And is greater than allowed maximum = ',JPMXLAT)
        WV2DXX2 = JPROUTINE + 2
        GOTO 900
      ENDIF

      ONORTH = FLOAT(NIAREA(1))/PPMULT
      OSOUTH = FLOAT(NIAREA(3))/PPMULT

      RLATINC = FLOAT(NIGRID(2))/PPMULT

      DO LOOP = 1, NUMLATS
        OLDLATS(LOOP) = 90.0 - (LOOP-1)*RLATINC
      ENDDO
C
C     Fill an array with the number of points at each latitude for the
C     input field (this is a reduced latitude/longitude grid)
C
      MISSLAT = (90.0 - ONORTH)/RLATINC
      KOLDNUM = 1 + (90.0 - OSOUTH)/RLATINC

      IF( NIREPR.NE.JPREDLL ) THEN
        DO LOOP = 1, MISSLAT
          NPTS(LOOP)    = 0
        ENDDO
        DO LOOP = 1, (KOLDNUM-MISSLAT)
            NPTS(LOOP+MISSLAT) = NIWE
        ENDDO
        DO LOOP = (KOLDNUM+1), NUMLATS
          NPTS(LOOP)    = 0
        ENDDO
      ENDIF
C
C     Allocate large, resolution-dependent arrays
      IF (.NOT. IS_ALLOCATED_LARGEARRAY) THEN
        P_NEWIDX = JMALLOC(JPARRAYDIM_WAVE*JPBYTES)  ! len*bytes
        IS_ALLOCATED_LARGEARRAY = .TRUE.
      END IF
C
C ---------------------------------------------------------------------
C*    Section 2. Setup number of points at each latitude for the
C                output latitude/longitude field.
C ---------------------------------------------------------------------
C
  200 CONTINUE
C
      IF( (NOREPR.EQ.JPQUASI) .OR. (NOREPR.EQ.JPGAUSSIAN) ) THEN
C
C       Reduced (quasi-regular) gaussian output
C
        KNEWNUM = NOGAUSS*2
        DO LOOP = 1, KNEWNUM
          NUMNEW(LOOP)  = NOLPTS(LOOP)
          NEWLATS(LOOP) = ROGAUSS(LOOP)
        ENDDO
C
      ELSE IF( NOREPR.EQ.JPREDLL ) THEN
C
C       Reduced (quasi-regular) lat/long output
C
        KNEWNUM = NOREDLL
        DO LOOP = 1, KNEWNUM
          NUMNEW(LOOP)  = NOLPTS(LOOP)
          NEWLATS(LOOP) = ROREDLL(LOOP)
        ENDDO
C
      ELSE
C
C       Regular output
C
        MISSLAT = NINT((90.0 - NORTH)/STEPNS)
        DO LOOP = 1, MISSLAT
          NUMNEW(LOOP)    = 0
        ENDDO
        DO LOOP = 1, NLATS
          NUMNEW(LOOP+MISSLAT) = NINT(360.0/STEPWE)
        ENDDO
C
        KNEWNUM = MISSLAT + NLATS
        DO LOOP = 1, KNEWNUM
          NEWLATS(LOOP) = 90.0 - (LOOP-1)*STEPNS
        ENDDO
C
      ENDIF
C
C ---------------------------------------------------------------------
C*    Section 3. Get the input GRIB field characteristics.
C ---------------------------------------------------------------------
C
  300 CONTINUE
C
C     Calculate the indices of the input grid points to be used for
C     the output points
C
      OLDWEST = FLOAT(NIAREA(2))/PPMULT
      OLDEAST = FLOAT(NIAREA(4))/PPMULT

      WV2DXX2 = WV2DIDX(NUMLATS,NPTS,OLDLATS,OLDWEST,OLDEAST,
     X                  KNEWNUM, NUMNEW, NEWLATS, NEWIDX)
      IF( WV2DXX2.NE.0 ) THEN
        CALL INTLOG(JP_ERROR,
     X    'WV2DXX2: Unable to calculate output grid indices',JPQUIET)
        WV2DXX2 = JPROUTINE + 3
        GOTO 900
      ENDIF
C
C
C ---------------------------------------------------------------------
C*    Section 4. Work through the output subarea.
C ---------------------------------------------------------------------
C
  400 CONTINUE
C
C     Fill in the wave spectra values
C
      NEXT = 0
      NEXTWV = 0
C
      SOUTH = NOAREA(3)/PPMULT
      EAST  = NOAREA(4)/PPMULT
      ISTART = 0
C
C     Work down through latitudes from north to south.
C
      DO NROW = 1, KNEWNUM
C
C       If inside north-south (subarea) boundaries ..
C
        IF( (NOREPR.EQ.JPGAUSSIAN).OR.(NOREPR.EQ.JPQUASI) ) THEN
          PTLAT = ROGAUSS(NROW)
        ELSE
          PTLAT = 90.0 - (NROW-1)*STEPNS
        ENDIF
C
        IF( (PTLAT.LE.NORTH).AND.(ABS(PTLAT-SOUTH).GT.-0.0005) ) THEN
C
C         Calculate number of points between west boundary of area and
C         Greenwich
C
          ROWINC = 360.0/NUMNEW(NROW)
C
          IWEST = INT(WEST/ROWINC)
          IF( (WEST.GT.0.0).AND.(WEST.NE.(IWEST*ROWINC)) )
     X      IWEST = IWEST + 1
          AWEST = IWEST * ROWINC
          IWOFSET = NUMPTWE(AWEST,0.0,ROWINC)
          IEOFSET = NUMPTWE(AWEST,EAST,ROWINC)
C
C         Work through subarea longitudes from west to east.
C
          DO NCOL = 1, NUMNEW(NROW)
            PTLONG = AWEST + (NCOL-1)*ROWINC
            NEXT = NUMPTWE(AWEST,PTLONG,ROWINC)
            IF( (NEXT.LE.IEOFSET).AND.(NEXT.GE.0) ) THEN
C
C             .. and inside west-east (subarea) boundaries
C
              NEXT = 1 + NEXT - IWOFSET
              IF( NEXT.LE.0) NEXT = NEXT + NUMNEW(NROW)
              NEXT = NEXT + ISTART
              INDEX = NEWIDX(NEXT)

              NEXTWV = NEXTWV + 1

              IF( OLDWAVE(INDEX).EQ.PMISS.OR.INDEX.EQ.0) THEN
C
C               Nearest neighbour is a 'missing' point
C
                  NEWWAVE(NEXTWV) = PMISS
              ELSE
                  NEWWAVE(NEXTWV) = OLDWAVE(INDEX)
              ENDIF
             ENDIF
          ENDDO
C
        ENDIF
        ISTART = ISTART + NUMNEW(NROW)
      ENDDO
C
C ---------------------------------------------------------------------
C*    Section 9. Closedown.
C ---------------------------------------------------------------------
C
  900 CONTINUE
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities
C granted to it by virtue of its status as an intergovernmental organisation
C nor does it submit to any jurisdiction.
C

      INTEGER FUNCTION INTVECY(PUFIELD,PVFIELD,KASIZE,
     X                         PUOUT,PVOUT,OUTLEN)
C
C---->
C**** INTVECY
C
C     Purpose
C     -------
C     Interpolate U or V component fields to grid point.
C
C
C     Interface
C     ---------
C     IRET = INTVECY(PUFIELD,PVFIELD,KASIZE,
C    X               KUGRIB,KVGRIB,OUTLEN)
C
C     Input
C     -----
C     PUFIELD - U values.
C     PVFIELD - V values.
C     KASIZE  - Size of input arrays
C
C
C     Output
C     ------
C     PUOUT - Output wind U component field
C     PVOUT - Output wind V component field
C     OUTLEN - Output U field length (words).
C
C
C     Method
C     ------
C     None.
C
C
C     Externals
C     ---------
C     RESET_C - Reset interpolation handling options using GRIB product.
C     IBASINI - Ensure basic interpolation setup is done.
C     INTFAU  - Prepare to interpolate unpacked input field.
C     INTFBU  - Interpolate unpacked input field.
C     INTLOG  - Log error message.
C     MKFRAME - Create a 'frame' from a rectangular field.
C     INTUVGH - Interpolate GRIB U and V reduced gaussian to rotated GRIB
C               U and V.
C
C
C     Author
C     ------
C     S.Curic     ECMWF     December 2006
C
C
C----<
C     -----------------------------------------------------------------|
C
      IMPLICIT NONE
C
#include "parim.h"
#include "nifld.common"
#include "nofld.common"
#include "intf.h"
#include "current.h"
#include "grfixed.h"
C
C     Parameters
C
      INTEGER JPROUTINE
      PARAMETER (JPROUTINE = 40170)
C
C     Function arguments
C
      INTEGER KASIZE, OUTLEN
      REAL PUFIELD(KASIZE), PVFIELD(KASIZE), PUOUT(*), PVOUT(*)
C
C     Local variables
C
      CHARACTER*1 HOLDTYP
      CHARACTER*1 HTYPE
      CHARACTER*3 EXTRA
      INTEGER IRET
      INTEGER ISAME
      INTEGER ISIZE
      INTEGER KPTS(JPGTRUNC*2)
      INTEGER LOOP
      INTEGER NCOUNT
      INTEGER NGAUSS
      INTEGER NLAT
      INTEGER NLON
      INTEGER NSIZE
      INTEGER NTRUNC
      INTEGER NUMPTS
      INTEGER NUVFLAG
      LOGICAL LFIRST
      LOGICAL LFRAME
      LOGICAL LNEWUV
      LOGICAL LOLDWIND
      LOGICAL LOMISSV
      LOGICAL LSPECUV
      REAL AREA(4)
      REAL EAST
      REAL EW
      REAL GLATS(JPGTRUNC*2)
      REAL GRID(2)
      REAL NS
      REAL OLDGRID(2)
      REAL POLE(2)
      REAL RGGRID
      REAL SWORK
      REAL TWORK
      REAL WEST
cc    INTEGER IN_U
cc    INTEGER IN_V
      POINTER (IRGGRID,RGGRID(1))
      POINTER (ISWORK,SWORK(1))
      POINTER (ITWORK,TWORK(1))
C
C     Externals
C
      CHARACTER*1 GGHTYPE
      INTEGER FIXAREA, INTFAU, INTFBU, HSH2GG, IBASINI
      INTEGER HIRLAMW, INSANE !, RESET_C
      INTEGER HRG2GGW, HLL2LLW
      EXTERNAL GGHTYPE
      EXTERNAL FIXAREA, INTFAU, INTFBU, HSH2GG, IBASINI
      EXTERNAL HIRLAMW, INSANE !, RESET_C
      EXTERNAL HRG2GGW, HLL2LLW
C
      DATA IRGGRID/0/, ISWORK/0/, ITWORK/0/
      SAVE IRGGRID, ISWORK, ITWORK
      DATA LFIRST/.TRUE./, LNEWUV/.TRUE./, EXTRA/'NO '/
      SAVE LFIRST, LNEWUV
C
C     -----------------------------------------------------------------|
C*    Section 1.   Initialise.
C     -----------------------------------------------------------------|
C
  100 CONTINUE
C
      INTVECY = 0
      IF( LFIRST ) THEN
        CALL GETENV('IGNORE_UV_EXTRA_MODE', EXTRA)
        IF((EXTRA(1:1).EQ.'Y').OR.(EXTRA(1:1).EQ.'y')) LNEWUV = .FALSE.
        IF( LNEWUV ) THEN
          CALL INTLOG(JP_DEBUG,
     X      'INTVECY: IGNORE_UV_EXTRA_MODE not turned on',JPQUIET)
        ELSE
          CALL INTLOG(JP_DEBUG,
     X      'INTVECY: IGNORE_UV_EXTRA_MODE turned on',JPQUIET)
        ENDIF
        LFIRST = .FALSE.
      ENDIF
C
      LOLDWIND = LWINDSET
C
C     Ensure that basic initialisation has been done
C
      IRET = IBASINI(0)
      IF( IRET.NE.0 ) THEN
        CALL INTLOG(JP_ERROR,'INTVECY: basic initialise failed',JPQUIET)
        INTVECY = IRET
        GOTO 900
      ENDIF
C
C
cs      NSIZE = ISEC4(1)
      NSIZE = KASIZE
cs      NIREPR = ISEC2(1)
      LSPECUV = (NIREPR.EQ.JPSPHERE).OR.(NIREPR.EQ.JPSPHROT)
cs      IF( LSPECUV ) NIRESO = ISEC2(2)
C
C     Setup interpolation options from input GRIB characteristics.
C
cs      IRET = RESET_C(ISEC1, ISEC2, ZSEC2, ISEC4)
cs      IF( IRET.NE.0 ) THEN
cs        CALL INTLOG(JP_ERROR,
cs     X    'INTVECY: Setup interp. options from GRIB failed.',JPQUIET)
cs        INTVECY = IRET
cs        GOTO 900
cs      ENDIF
C
C       Only allowed rotations are:
C        - spectral to regular lat/long
C        - reduced gaussian to regular lat/long
C
      IF( LNOROTA ) THEN
        IF( ((NOREPR.NE.JPREGROT).AND.(NOREPR.NE.JPREGULAR)).OR.
     X      ((NIREPR.NE.JPSPHERE).AND.(NIREPR.NE.JPQUASI)) ) THEN
          CALL INTLOG(JP_ERROR,
     X      'INTVECY: For vector fields, only allowed rotations are:',
     X      JPQUIET)
          CALL INTLOG(JP_ERROR,
     X      'INTVECY: spectral to regular lat/long, or',JPQUIET)
          CALL INTLOG(JP_ERROR,
     X      'INTVECY: reduced gaussian to regular lat/long',JPQUIET)
          INTVECY = JPROUTINE + 1
          GOTO 900
        ENDIF
      ENDIF
C
C     Check that no outrageous values given for interpolation
C
      ISAME = INSANE()
      IF( (ISAME.GT.0).AND.(ISAME.NE.27261) ) THEN
        CALL INTLOG(JP_ERROR,
     X    'INTVECY: Interpolation cannot use given values.',JPQUIET)
        INTVECY = ISAME
        GOTO 900
      ENDIF
C
      LFRAME = LNOFRAME.AND.
     X         ((NOREPR.EQ.JPREGULAR).OR.(NOREPR.EQ.JPGAUSSIAN).OR.
     X          (NOREPR.EQ.JPREGROT ).OR.(NOREPR.EQ.JPFGGROT  ) )
C
C     Fill area limits (handles case when default 0/0/0/0 given)
C
      IRET = FIXAREA()
      IF( IRET.NE.0 ) THEN
        CALL INTLOG(JP_ERROR,'INTVECY: area fixup failed',JPQUIET)
        INTVECY = JPROUTINE + 3
        GOTO 900
      ENDIF
C
      IF( .NOT. LNOROTA ) THEN
        NOROTA(1) = -9000000
        NOROTA(2) = 0
      ENDIF
C
      CALL INTLOG(JP_DEBUG,'INTVECY: Rotate the U & V fields',JPQUIET)
      CALL INTLOG(JP_DEBUG,'INTVECY: South pole lat  ',NOROTA(1))
      CALL INTLOG(JP_DEBUG,'INTVECY: South pole long ',NOROTA(2))
C
      AREA(1) = REAL(NOAREA(1))/PPMULT
      AREA(2) = REAL(NOAREA(2))/PPMULT
      AREA(3) = REAL(NOAREA(3))/PPMULT
      AREA(4) = REAL(NOAREA(4))/PPMULT
C
      GRID(1) = REAL(NOGRID(1))/PPMULT
      GRID(2) = REAL(NOGRID(2))/PPMULT
C
      POLE(1) = REAL(NOROTA(1))/PPMULT
      POLE(2) = REAL(NOROTA(2))/PPMULT
C
      IF( .NOT. LSPECUV ) GOTO 500
C
C     Get some scratch memory for the U and V fields
C
C     Unpack U field
C
      NIFORM = 0
cs      NIPARAM = IN_U
      LWIND = .TRUE.
      LOLDWIND = LWINDSET
      LWINDSET = .TRUE.
C
cs      IN_U = ISEC1(6)
C
C     Unpack V field
C
cs      NIPARAM = IN_V
cs      IN_V = ISEC1(6)
C
      IF( LNOROTA ) GOTO 300
C
C     -----------------------------------------------------------------|
C*    Section 2.   Spectral to grid-point with no rotation
C     -----------------------------------------------------------------|
C
  200 CONTINUE
C
      CALL INTLOG(JP_DEBUG,
     X  'INTVECY: Interpolate U & V fields with no rotation',JPQUIET)
C
C
C     Interpolate U field
C
      IRET = INTFAU(PUFIELD, KASIZE)
      IF( IRET.NE.0 ) THEN
        CALL INTLOG(JP_ERROR,
     X    'INTVECY: Prepare to interpolate failed.',JPQUIET)
        INTVECY = JPROUTINE + 2
        GOTO 900
      ENDIF
C
      IRET = INTFBU(PUFIELD, KASIZE, PUOUT, OUTLEN)
      IF( IRET.NE.0 ) THEN
        CALL INTLOG(JP_ERROR,'INTVECY: Interpolation failed.',JPQUIET)
        INTVECY = JPROUTINE + 2
        GOTO 900
      ENDIF
C
C     Interpolate V field
C
      IRET = INTFAU(PVFIELD, KASIZE)
      IF( IRET.NE.0 ) THEN
        CALL INTLOG(JP_ERROR,
     X    'INTVECY: Prepare to interpolate failed.',JPQUIET)
        INTVECY = JPROUTINE + 2
        GOTO 900
      ENDIF
C
      IRET = INTFBU(PVFIELD, KASIZE, PVOUT, OUTLEN)
      IF( IRET.NE.0 ) THEN
        CALL INTLOG(JP_ERROR,'INTVECY: Interpolation failed.',JPQUIET)
        INTVECY = JPROUTINE + 2
        GOTO 900
      ENDIF
C
      GOTO 700
C
C     -----------------------------------------------------------------|
C*    Section 3.   Spectral to grid-point with rotation
C     -----------------------------------------------------------------|
C
  300 CONTINUE
C
      IF( .NOT.LUSEHIR ) THEN
        CALL INTLOG(JP_ERROR,
     X    'INTVECY: Unable to rotate spectral U or V:',JPQUIET)
        INTVECY  = JPROUTINE + 3
        GOTO 900
      ENDIF
C
C     Convert spectral to suitable global reduced gaussian
C
      NTRUNC = NIRESO
      NGAUSS = 0
      HTYPE  = ''
      NS = 0.
      EW = 0.
      IRET = HSH2GG(NS,EW,NTRUNC,NGAUSS,HTYPE,KPTS,GLATS,ISIZE)
      IF( IRET.NE.0 ) THEN
        CALL INTLOG(JP_ERROR,
     X    'INTVECY: problem getting data for reduced grid',NTRUNC)
        INTVECY = JPROUTINE + 4
        GOTO 900
      ENDIF
C
      NCOUNT = ISIZE
C
C     Dynamically allocate memory for global reduced gaussian grid
C
      CALL JMEMHAN( 18, IRGGRID, (NCOUNT*2), 1, IRET)
      IF( IRET.NE.0 ) THEN
        CALL INTLOG(JP_ERROR,
     X    'INTVECY: memory alloc for reduced grid fail',JPQUIET)
        INTVECY = JPROUTINE + 4
        GOTO 900
      ENDIF
C
C     Set flag to show field is a wind component
C
      NUVFLAG = 1
C
C     Create the reduced gaussian grid
C
      HOLDTYP = HOGAUST
      WEST = 0.0
      EAST = 360.0 - (360.0/FLOAT(KPTS(NGAUSS)))
C
C     U component spectral -> reduced gaussian
C
      CALL JAGGGP(PUFIELD,NTRUNC,GLATS(1),GLATS(NGAUSS*2),WEST,
     X            EAST,NGAUSS,HTYPE,KPTS,RGGRID,NUVFLAG,IRET)
      IF( IRET.NE.0 ) THEN
        CALL INTLOG(JP_ERROR,
     X    'INTVECY: spectral to reduced gaussian failed',JPQUIET)
        INTVECY = JPROUTINE + 4
        GOTO 900
      ENDIF
C
      HOGAUST = HOLDTYP
C
C     V component spectral -> reduced gaussian
C
      CALL JAGGGP(PVFIELD,NTRUNC,GLATS(1),GLATS(NGAUSS*2),WEST,
     X            EAST,NGAUSS,HTYPE,KPTS,RGGRID(1+NCOUNT),NUVFLAG,IRET)
      IF( IRET.NE.0 ) THEN
        CALL INTLOG(JP_ERROR,
     X    'INTVECY: spectral to reduced gaussian failed',JPQUIET)
        INTVECY = JPROUTINE + 4
        GOTO 900
      ENDIF
C
      HOGAUST = HOLDTYP
C
C     Rotate using 12-point horizontal interpolation
C
C     Dynamically allocate memory for rotated lat/long grid
C
      NLON = 1 + NINT((AREA(JPEAST)  - AREA(JPWEST)) /
     X       GRID(JPWESTEP))                  ! SC
      NLAT = 1 + NINT((AREA(JPNORTH) - AREA(JPSOUTH)) /
     X       GRID(JPNSSTEP))                  ! SC
C
      OUTLEN = NLON * NLAT
C
      IRET = HIRLAMW(LO12PT,RGGRID,RGGRID(1+NCOUNT),NCOUNT,NGAUSS,HTYPE,
     X  AREA,POLE,GRID,PUOUT,PVOUT,OUTLEN,NLON,NLAT)
C
      IF( IRET.NE.0 ) THEN
        CALL INTLOG(JP_ERROR,
     X    'INTVECY: HIRLAMW rotation failed',JPQUIET)
        INTVECY = JPROUTINE + 6
        GOTO 900
      ENDIF
C
C     Set the components flag for rotated U and V coefficients
C
cs      ISEC2(19) = 8
      NOWE = NLON
      NONS = NLAT
      OUTLEN = NLAT*NLON

C
      GOTO 700
C
C     -----------------------------------------------------------------|
C*    Section 5.   Grid to grid  point
C     -----------------------------------------------------------------|
C
  500 CONTINUE
C*    5a.   Generate interpolated lat/long U and V fields.
C     -----------------------------------------------------------------|
C
C
      IF( (NOREPR.EQ.JPREGULAR).OR.(NOREPR.EQ.JPREGROT) ) THEN
C
C       Dynamically allocate scrath space for rotated lat/long grid
C
        NLON = 1 + NINT(FLOAT(NOAREA(JPEAST)  - NOAREA(JPWEST)) /
     X         NOGRID(JPWESTEP))
        NLAT = 1 + NINT(FLOAT(NOAREA(JPNORTH) - NOAREA(JPSOUTH)) /
     X         NOGRID(JPNSSTEP))
C
        NOWE = NLON
        NONS = NLAT
        OUTLEN = NLON * NLAT
C
C       Rotate reduced gaussian to lat/long
C
        IF( (NIREPR.EQ.JPGAUSSIAN).OR.(NIREPR.EQ.JPQUASI) ) THEN
        CALL INTLOG(JP_DEBUG,
     X    'INTVECY: Rotate reduced gaussian to lat/long',JPQUIET)
          HTYPE = GGHTYPE(NIREPR,NIGAUSS,MILLEN)
          IRET = HIRLAMW(LO12PT,
     X                   PUFIELD,PVFIELD,KASIZE,
     X                   NIGAUSS,HTYPE,AREA,POLE,GRID,
     X                   PUOUT,PVOUT,OUTLEN,NLON,NLAT)
          IF( IRET.NE.0 ) THEN
            CALL INTLOG(JP_ERROR,
     X        'INTVECY: HIRLAMW rotation failed',JPQUIET)
            INTVECY = JPROUTINE + 3
            GOTO 900
          ENDIF
C
C       Rotate lat/long to lat/long
C
        ELSE
        CALL INTLOG(JP_DEBUG,
     X    'INTVECY: Rotate lat/long to lat/long',JPQUIET)
          OLDGRID(1) = REAL(NIGRID(1)) / PPMULT
          OLDGRID(2) = REAL(NIGRID(2)) / PPMULT
          IRET = HLL2LLW(LO12PT,PUFIELD,PVFIELD,
     X                   OLDGRID,AREA,POLE,GRID,
     X                   PUOUT,PVOUT,OUTLEN,NLON,NLAT)
          IF( IRET.NE.0 ) THEN
            CALL INTLOG(JP_ERROR,
     X        'INTVECY: HLL2LLW rotation failed',JPQUIET)
            INTVECY = JPROUTINE + 3
            GOTO 900
          ENDIF
        ENDIF
C
      ELSE
C
C*    Section 5b.   Generate interpolated gaussian U and V fields.
C     -----------------------------------------------------------------|
C
  400   CONTINUE
C
        CALL INTLOG(JP_DEBUG,
     X    'INTVECY: Rotate gaussian to gaussian',JPQUIET)
C
C       Dynamically allocate memory for rotated gaussian grids
C
        NUMPTS = NOGAUSS * NOGAUSS
        OUTLEN = 2 * NUMPTS * 8
C
cs        NGAUSS = ISEC2(10)
        IRET = HRG2GGW(LO12PT,
     X                 PUFIELD,PVFIELD,KASIZE,
     X                 NIGAUSS,AREA,POLE,NOGAUSS,HOGAUST,
     X                 PUOUT,PVOUT,OUTLEN,NUMPTS)
        IF( IRET.NE.0 ) THEN
          CALL INTLOG(JP_ERROR,
     X        'INTVECY: HRG2GGW rotation failed',JPQUIET)
            INTVECY = JPROUTINE + 4
            GOTO 900
          ENDIF
C
      ENDIF
C
C
  700 CONTINUE
C
C     Reset the input format flag
C
cs      NIFORM = 1
C
C     If a 'frame' has been specified, build the frame
C
      IF( LFRAME ) THEN
        LOMISSV = LIMISSV
        LIMISSV = .TRUE.
        ISEC1(5) = 192
        ISEC3(2) = NINT(RMISSGV)
        ZSEC3(2) = RMISSGV
        CALL MKFRAME(NLON,NLAT,PUOUT,RMISSGV,NOFRAME)
        CALL MKFRAME(NLON,NLAT,PVOUT,RMISSGV,NOFRAME)
        LIMISSV = LOMISSV
      ENDIF

      DO 910 LOOP = 1, 4
        NOAAPI(LOOP) = NOAREA(LOOP)
  910 CONTINUE
C
C     -----------------------------------------------------------------|
C*    Section 9.   Return
C     -----------------------------------------------------------------|
C
  900 CONTINUE
C
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities
C granted to it by virtue of its status as an intergovernmental organisation
C nor does it submit to any jurisdiction.
C

      INTEGER FUNCTION INTVECY(PUFIELD,PVFIELD,KASIZE,
     X                         PUOUT,PVOUT,OUTLEN)
C
C---->
C**** INTVECY
C
C     Purpose
C     -------
C     Interpolate U or V component fields to grid point.
C
C
C     Interface
C     ---------
C     IRET = INTVECY(PUFIELD,PVFIELD,KASIZE,
C    X               KUGRIB,KVGRIB,OUTLEN)
C
C     Input
C     -----
C     PUFIELD - U values.
C     PVFIELD - V values.
C     KASIZE  - Size of input arrays
C
C
C     Output
C     ------
C     PUOUT - Output wind U component field
C     PVOUT - Output wind V component field
C     OUTLEN - Output U field length (words).
C
C
C     Method
C     ------
C     None.
C
C
C     Externals
C     ---------
C     RESET_C - Reset interpolation handling options using GRIB product.
C     IBASINI - Ensure basic interpolation setup is done.
C     INTFAU  - Prepare to interpolate unpacked input field.
C     INTFBU  - Interpolate unpacked input field.
C     INTLOG  - Log error message.
C     MKFRAME - Create a 'frame' from a rectangular field.
C     INTUVGH - Interpolate GRIB U and V reduced gaussian to rotated GRIB
C               U and V.
C
C
C     Author
C     ------
C     S.Curic     ECMWF     December 2006
C
C
C----<
C     -----------------------------------------------------------------|
C
      IMPLICIT NONE
C
#include "parim.h"
#include "nifld.common"
#include "nofld.common"
#include "intf.h"
#include "current.h"
#include "grfixed.h"
C
C     Parameters
C
      INTEGER JPROUTINE
      PARAMETER (JPROUTINE = 40170)
C
C     Function arguments
C
      INTEGER KASIZE, OUTLEN
      REAL PUFIELD(KASIZE), PVFIELD(KASIZE), PUOUT(*), PVOUT(*)
C
C     Local variables
C
      CHARACTER*1 HOLDTYP
      CHARACTER*1 HTYPE
      CHARACTER*3 EXTRA
      INTEGER IRET
      INTEGER ISAME
      INTEGER ISIZE
      INTEGER KPTS(JPGTRUNC*2)
      INTEGER LOOP
      INTEGER NCOUNT
      INTEGER NGAUSS
      INTEGER NLAT
      INTEGER NLON
      INTEGER NSIZE
      INTEGER NTRUNC
      INTEGER NUMPTS
      INTEGER NUVFLAG
      LOGICAL LFIRST
      LOGICAL LFRAME
      LOGICAL LNEWUV
      LOGICAL LOLDWIND
      LOGICAL LOMISSV
      LOGICAL LSPECUV
      REAL AREA(4)
      REAL EAST
      REAL EW
      REAL GLATS(JPGTRUNC*2)
      REAL GRID(2)
      REAL NS
      REAL OLDGRID(2)
      REAL POLE(2)
      REAL RGGRID
      REAL SWORK
      REAL TWORK
      REAL WEST
cc    INTEGER IN_U
cc    INTEGER IN_V
      POINTER (IRGGRID,RGGRID(1))
      POINTER (ISWORK,SWORK(1))
      POINTER (ITWORK,TWORK(1))
C
C     Externals
C
      CHARACTER*1 GGHTYPE
      INTEGER FIXAREA, INTFAU, INTFBU, HSH2GG, IBASINI
      INTEGER HIRLAMW, INSANE !, RESET_C
      INTEGER HRG2GGW, HLL2LLW
      EXTERNAL GGHTYPE
      EXTERNAL FIXAREA, INTFAU, INTFBU, HSH2GG, IBASINI
      EXTERNAL HIRLAMW, INSANE !, RESET_C
      EXTERNAL HRG2GGW, HLL2LLW
C
      DATA IRGGRID/0/, ISWORK/0/, ITWORK/0/
      SAVE IRGGRID, ISWORK, ITWORK
      DATA LFIRST/.TRUE./, LNEWUV/.TRUE./, EXTRA/'NO '/
      SAVE LFIRST, LNEWUV
C
C     -----------------------------------------------------------------|
C*    Section 1.   Initialise.
C     -----------------------------------------------------------------|
C
  100 CONTINUE
C
      INTVECY = 0
      IF( LFIRST ) THEN
        CALL GETENV('IGNORE_UV_EXTRA_MODE', EXTRA)
        IF((EXTRA(1:1).EQ.'Y').OR.(EXTRA(1:1).EQ.'y')) LNEWUV = .FALSE.
        IF( LNEWUV ) THEN
          CALL INTLOG(JP_DEBUG,
     X      'INTVECY: IGNORE_UV_EXTRA_MODE not turned on',JPQUIET)
        ELSE
          CALL INTLOG(JP_DEBUG,
     X      'INTVECY: IGNORE_UV_EXTRA_MODE turned on',JPQUIET)
        ENDIF
        LFIRST = .FALSE.
      ENDIF
C
      LOLDWIND = LWINDSET
C
C     Ensure that basic initialisation has been done
C
      IRET = IBASINI(0)
      IF( IRET.NE.0 ) THEN
        CALL INTLOG(JP_ERROR,'INTVECY: basic initialise failed',JPQUIET)
        INTVECY = IRET
        GOTO 900
      ENDIF
C
C
cs      NSIZE = ISEC4(1)
      NSIZE = KASIZE
cs      NIREPR = ISEC2(1)
      LSPECUV = (NIREPR.EQ.JPSPHERE).OR.(NIREPR.EQ.JPSPHROT)
cs      IF( LSPECUV ) NIRESO = ISEC2(2)
C
C     Setup interpolation options from input GRIB characteristics.
C
cs      IRET = RESET_C(ISEC1, ISEC2, ZSEC2, ISEC4)
cs      IF( IRET.NE.0 ) THEN
cs        CALL INTLOG(JP_ERROR,
cs     X    'INTVECY: Setup interp. options from GRIB failed.',JPQUIET)
cs        INTVECY = IRET
cs        GOTO 900
cs      ENDIF
C
C       Only allowed rotations are:
C        - spectral to regular lat/long
C        - reduced gaussian to regular lat/long
C
      IF( LNOROTA ) THEN
        IF( ((NOREPR.NE.JPREGROT).AND.(NOREPR.NE.JPREGULAR)).OR.
     X      ((NIREPR.NE.JPSPHERE).AND.(NIREPR.NE.JPQUASI)) ) THEN
          CALL INTLOG(JP_ERROR,
     X      'INTVECY: For vector fields, only allowed rotations are:',
     X      JPQUIET)
          CALL INTLOG(JP_ERROR,
     X      'INTVECY: spectral to regular lat/long, or',JPQUIET)
          CALL INTLOG(JP_ERROR,
     X      'INTVECY: reduced gaussian to regular lat/long',JPQUIET)
          INTVECY = JPROUTINE + 1
          GOTO 900
        ENDIF
      ENDIF
C
C     Check that no outrageous values given for interpolation
C
      ISAME = INSANE()
      IF( (ISAME.GT.0).AND.(ISAME.NE.27261) ) THEN
        CALL INTLOG(JP_ERROR,
     X    'INTVECY: Interpolation cannot use given values.',JPQUIET)
        INTVECY = ISAME
        GOTO 900
      ENDIF
C
      LFRAME = LNOFRAME.AND.
     X         ((NOREPR.EQ.JPREGULAR).OR.(NOREPR.EQ.JPGAUSSIAN).OR.
     X          (NOREPR.EQ.JPREGROT ).OR.(NOREPR.EQ.JPFGGROT  ) )
C
C     Fill area limits (handles case when default 0/0/0/0 given)
C
      IRET = FIXAREA()
      IF( IRET.NE.0 ) THEN
        CALL INTLOG(JP_ERROR,'INTVECY: area fixup failed',JPQUIET)
        INTVECY = JPROUTINE + 3
        GOTO 900
      ENDIF
C
      AREA(1) = REAL(NOAREA(1))/PPMULT
      AREA(2) = REAL(NOAREA(2))/PPMULT
      AREA(3) = REAL(NOAREA(3))/PPMULT
      AREA(4) = REAL(NOAREA(4))/PPMULT
C
      GRID(1) = REAL(NOGRID(1))/PPMULT
      GRID(2) = REAL(NOGRID(2))/PPMULT
C
      IF( LNOROTA ) THEN
        POLE(1) = REAL(NOROTA(1))/PPMULT
        POLE(2) = REAL(NOROTA(2))/PPMULT
        CALL INTLOG(JP_DEBUG,'INTVECY: Rotate the U & V fields',JPQUIET)
        CALL INTLOG(JP_DEBUG,'INTVECY: South pole lat  ',NOROTA(1))
        CALL INTLOG(JP_DEBUG,'INTVECY: South pole long ',NOROTA(2))
      ELSE
        NOROTA(1) = -9000000
        NOROTA(2) = 0
      ENDIF
C

      IF( .NOT. LSPECUV ) GOTO 500
C
C     Get some scratch memory for the U and V fields
C
C     Unpack U field
C
      NIFORM = 0
cs      NIPARAM = IN_U
      LWIND = .TRUE.
      LOLDWIND = LWINDSET
      LWINDSET = .TRUE.
C
cs      IN_U = ISEC1(6)
C
C     Unpack V field
C
cs      NIPARAM = IN_V
cs      IN_V = ISEC1(6)
C
      IF( LNOROTA ) GOTO 300
C
C     -----------------------------------------------------------------|
C*    Section 2.   Spectral to grid-point with no rotation
C     -----------------------------------------------------------------|
C
  200 CONTINUE
C
      CALL INTLOG(JP_DEBUG,
     X  'INTVECY: Interpolate U & V fields with no rotation',JPQUIET)
C
C
C     Interpolate U field
C
      IRET = INTFAU(PUFIELD, KASIZE)
      IF( IRET.NE.0 ) THEN
        CALL INTLOG(JP_ERROR,
     X    'INTVECY: Prepare to interpolate failed.',JPQUIET)
        INTVECY = JPROUTINE + 2
        GOTO 900
      ENDIF
C
      IRET = INTFBU(PUFIELD, KASIZE, PUOUT, OUTLEN)
      IF( IRET.NE.0 ) THEN
        CALL INTLOG(JP_ERROR,'INTVECY: Interpolation failed.',JPQUIET)
        INTVECY = JPROUTINE + 2
        GOTO 900
      ENDIF
C
C     Interpolate V field
C
      IRET = INTFAU(PVFIELD, KASIZE)
      IF( IRET.NE.0 ) THEN
        CALL INTLOG(JP_ERROR,
     X    'INTVECY: Prepare to interpolate failed.',JPQUIET)
        INTVECY = JPROUTINE + 2
        GOTO 900
      ENDIF
C
      IRET = INTFBU(PVFIELD, KASIZE, PVOUT, OUTLEN)
      IF( IRET.NE.0 ) THEN
        CALL INTLOG(JP_ERROR,'INTVECY: Interpolation failed.',JPQUIET)
        INTVECY = JPROUTINE + 2
        GOTO 900
      ENDIF
C
      GOTO 700
C
C     -----------------------------------------------------------------|
C*    Section 3.   Spectral to grid-point with rotation
C     -----------------------------------------------------------------|
C
  300 CONTINUE
C
      IF( .NOT.LUSEHIR ) THEN
        CALL INTLOG(JP_ERROR,
     X    'INTVECY: Unable to rotate spectral U or V:',JPQUIET)
        INTVECY  = JPROUTINE + 3
        GOTO 900
      ENDIF
C
C     Convert spectral to suitable global reduced gaussian
C
      NTRUNC = NIRESO
      NGAUSS = 0
      HTYPE  = ''
      NS = 0.
      EW = 0.
      IRET = HSH2GG(NS,EW,NTRUNC,NGAUSS,HTYPE,KPTS,GLATS,ISIZE)
      IF( IRET.NE.0 ) THEN
        CALL INTLOG(JP_ERROR,
     X    'INTVECY: problem getting data for reduced grid',NTRUNC)
        INTVECY = JPROUTINE + 4
        GOTO 900
      ENDIF
C
      NCOUNT = ISIZE
C
C     Dynamically allocate memory for global reduced gaussian grid
C
      CALL JMEMHAN( 18, IRGGRID, (NCOUNT*2), 1, IRET)
      IF( IRET.NE.0 ) THEN
        CALL INTLOG(JP_ERROR,
     X    'INTVECY: memory alloc for reduced grid fail',JPQUIET)
        INTVECY = JPROUTINE + 4
        GOTO 900
      ENDIF
C
C     Set flag to show field is a wind component
C
      NUVFLAG = 1
C
C     Create the reduced gaussian grid
C
      HOLDTYP = HOGAUST
      WEST = 0.0
      EAST = 360.0 - (360.0/FLOAT(KPTS(NGAUSS)))
C
C     U component spectral -> reduced gaussian
C
      CALL JAGGGP(PUFIELD,NTRUNC,GLATS(1),GLATS(NGAUSS*2),WEST,
     X            EAST,NGAUSS,HTYPE,KPTS,RGGRID,NUVFLAG,IRET)
      IF( IRET.NE.0 ) THEN
        CALL INTLOG(JP_ERROR,
     X    'INTVECY: spectral to reduced gaussian failed',JPQUIET)
        INTVECY = JPROUTINE + 4
        GOTO 900
      ENDIF
C
      HOGAUST = HOLDTYP
C
C     V component spectral -> reduced gaussian
C
      CALL JAGGGP(PVFIELD,NTRUNC,GLATS(1),GLATS(NGAUSS*2),WEST,
     X            EAST,NGAUSS,HTYPE,KPTS,RGGRID(1+NCOUNT),NUVFLAG,IRET)
      IF( IRET.NE.0 ) THEN
        CALL INTLOG(JP_ERROR,
     X    'INTVECY: spectral to reduced gaussian failed',JPQUIET)
        INTVECY = JPROUTINE + 4
        GOTO 900
      ENDIF
C
      HOGAUST = HOLDTYP
C
C     Rotate using 12-point horizontal interpolation
C
C     Dynamically allocate memory for rotated lat/long grid
C
      NLON = 1 + NINT((AREA(JPEAST)  - AREA(JPWEST)) /
     X       GRID(JPWESTEP))                  ! SC
      NLAT = 1 + NINT((AREA(JPNORTH) - AREA(JPSOUTH)) /
     X       GRID(JPNSSTEP))                  ! SC
C
      OUTLEN = NLON * NLAT
C
      IRET = HIRLAMW(LO12PT,RGGRID,RGGRID(1+NCOUNT),NCOUNT,NGAUSS,HTYPE,
     X  AREA,POLE,GRID,PUOUT,PVOUT,OUTLEN,NLON,NLAT)
C
      IF( IRET.NE.0 ) THEN
        CALL INTLOG(JP_ERROR,
     X    'INTVECY: HIRLAMW rotation failed',JPQUIET)
        INTVECY = JPROUTINE + 6
        GOTO 900
      ENDIF
C
C     Set the components flag for rotated U and V coefficients
C
cs      ISEC2(19) = 8
      NOWE = NLON
      NONS = NLAT
      OUTLEN = NLAT*NLON

C
      GOTO 700
C
C     -----------------------------------------------------------------|
C*    Section 5.   Grid to grid  point
C     -----------------------------------------------------------------|
C
  500 CONTINUE
C*    5a.   Generate interpolated lat/long U and V fields.
C     -----------------------------------------------------------------|
C
C
      IF( (NOREPR.EQ.JPREGULAR).OR.(NOREPR.EQ.JPREGROT) ) THEN
C
C       Dynamically allocate scrath space for rotated lat/long grid
C
        NLON = 1 + NINT(FLOAT(NOAREA(JPEAST)  - NOAREA(JPWEST)) /
     X         NOGRID(JPWESTEP))
        NLAT = 1 + NINT(FLOAT(NOAREA(JPNORTH) - NOAREA(JPSOUTH)) /
     X         NOGRID(JPNSSTEP))
C
        NOWE = NLON
        NONS = NLAT
        OUTLEN = NLON * NLAT
C
C       Rotate reduced gaussian to lat/long
C
        IF( (NIREPR.EQ.JPGAUSSIAN).OR.(NIREPR.EQ.JPQUASI) ) THEN
        CALL INTLOG(JP_DEBUG,
     X    'INTVECY: Rotate reduced gaussian to lat/long',JPQUIET)
          HTYPE = GGHTYPE(NIREPR,NIGAUSS,MILLEN)
          IRET = HIRLAMW(LO12PT,
     X                   PUFIELD,PVFIELD,KASIZE,
     X                   NIGAUSS,HTYPE,AREA,POLE,GRID,
     X                   PUOUT,PVOUT,OUTLEN,NLON,NLAT)
          IF( IRET.NE.0 ) THEN
            CALL INTLOG(JP_ERROR,
     X        'INTVECY: HIRLAMW rotation failed',JPQUIET)
            INTVECY = JPROUTINE + 3
            GOTO 900
          ENDIF
C
C       Rotate lat/long to lat/long
C
        ELSE
        CALL INTLOG(JP_DEBUG,
     X    'INTVECY: Rotate lat/long to lat/long',JPQUIET)
          OLDGRID(1) = REAL(NIGRID(1)) / PPMULT
          OLDGRID(2) = REAL(NIGRID(2)) / PPMULT
          IRET = HLL2LLW(LO12PT,PUFIELD,PVFIELD,
     X                   OLDGRID,AREA,POLE,GRID,
     X                   PUOUT,PVOUT,OUTLEN,NLON,NLAT)
          IF( IRET.NE.0 ) THEN
            CALL INTLOG(JP_ERROR,
     X        'INTVECY: HLL2LLW rotation failed',JPQUIET)
            INTVECY = JPROUTINE + 3
            GOTO 900
          ENDIF
        ENDIF
C
      ELSE
C
C*    Section 5b.   Generate interpolated gaussian U and V fields.
C     -----------------------------------------------------------------|
C
  400   CONTINUE
C
        CALL INTLOG(JP_DEBUG,
     X    'INTVECY: Rotate gaussian to gaussian',JPQUIET)
C
C       Dynamically allocate memory for rotated gaussian grids
C
        NUMPTS = NOGAUSS * NOGAUSS
        OUTLEN = 2 * NUMPTS * 8
C
cs        NGAUSS = ISEC2(10)
        IRET = HRG2GGW(LO12PT,
     X                 PUFIELD,PVFIELD,KASIZE,
     X                 NIGAUSS,AREA,POLE,NOGAUSS,HOGAUST,
     X                 PUOUT,PVOUT,OUTLEN,NUMPTS)
        IF( IRET.NE.0 ) THEN
          CALL INTLOG(JP_ERROR,
     X        'INTVECY: HRG2GGW rotation failed',JPQUIET)
            INTVECY = JPROUTINE + 4
            GOTO 900
          ENDIF
C
      ENDIF
C
C
  700 CONTINUE
C
C     Reset the input format flag
C
cs      NIFORM = 1
C
C     If a 'frame' has been specified, build the frame
C
      IF( LFRAME ) THEN
        LOMISSV = LIMISSV
        LIMISSV = .TRUE.
        ISEC1(5) = 192
        ISEC3(2) = NINT(RMISSGV)
        ZSEC3(2) = RMISSGV
        CALL MKFRAME(NLON,NLAT,PUOUT,RMISSGV,NOFRAME)
        CALL MKFRAME(NLON,NLAT,PVOUT,RMISSGV,NOFRAME)
        LIMISSV = LOMISSV
      ENDIF

      DO 910 LOOP = 1, 4
        NOAAPI(LOOP) = NOAREA(LOOP)
  910 CONTINUE
C
C     -----------------------------------------------------------------|
C*    Section 9.   Return
C     -----------------------------------------------------------------|
C
  900 CONTINUE
C
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE BUUKEY( KSEC1,KSEC2,KEY,KSUP,KERR )
C
C**** *BUUKEY*
C
C
C     PURPOSE.
C     --------
C          EXPANDS LOCAL ECMWF INFORMATION FROM SECTION 2.
C
C
C**   INTERFACE.
C     ----------
C
C          *CALL* *BUUKEY(KSEC1,KSEC2,KEY,KSUP,KERR)*
C
C        INPUT :
C               *KSEC1*   -  ARRAY CONTAINING SECTION 1 INFORMATION
C                            KSEC1( 1)-- LENGTH OF SECTION 1 (BYTES)
C                            KSEC1( 2)-- BUFR EDITION NUMBER
C                            KSEC1( 3)-- ORIGINATING CENTRE
C                            KSEC1( 4)-- UPDATE SEQUENCE NUMBER
C                            KSEC1( 5)-- FLAG (PRESENCE OF SECTION 2)
C                            KSEC1( 6)-- BUFR MESSAGE TYPE
C                            KSEC1( 7)-- BUFR MESSAGE SUBTYPE
C                            KSEC1( 8)-- VERSION NUMBER OF LOCAL TABLE USED
C                            KSEC1( 9)-- YEAR
C                            KSEC1(10)-- MONTH
C                            KSEC1(11)-- DAY
C                            KSEC1(12)-- HOUR
C                            KSEC1(13)-- MINUTE
C                            KSEC1(14)-- BUFR MASTER TABLE
C                            KSEC1(15)-- VERSION NUMBER OF MASTER TABLE USED
C                            KSEC1(16) - KSEC1(JSEC1) -- LOCAL ADP CENTRE
C                                        INFORMATION(PACKED FORM)
C
C                            FOR BUFR EDITION 3 ONWARD
C
C                            KSEC1(16)-- ORIGINATING SUB-CENTRE
C                            KSEC1(17)-- NOT USED
C                            KSEC1(18) TO KSEC1(JSEC1) - LOCAL ADP CENTRE
C                                        INFORMATION(PACKED FORM)
C
C                            FOR BUFR EDITION 4 ONWARD
C
C                            KSEC1(16)-- ORIGINATING SUB-CENTRE
C                            KSEC1(17)-- INTERNATIONAL SUB-CATEGORY (SEE COMMON TABLE C-13
C                            KSEC1(18)-- SECOND
C                            KSEC1(19)-- YEAR
C                            KSEC1(20)-- MONTH
C                            KSEC1(21)-- DAY
C                            KSEC1(22)-- HOUR
C                            KSEC1(23)-- MINUTE
C                            KSEC1(24)-- SECOND
C                            KSEC1(25)-- YEAR
C                            KSEC1(26)-- MONTH
C                            KSEC1(27)-- DAY
C                            KSEC1(28)-- HOUR
C                            KSEC1(29)-- MINUTE
C                            KSEC1(30)-- SECOND
C                            KSEC1(31)-- MOST SOUTHERN LATITUDE  (-90 to 90)
C                            KSEC1(32)-- MOST WESTERN LONGITUDE  ( 0-360)
C                            KSEC1(33)-- MOST NORTHEN LATITUDE   (-90 to 90)
C                            KSEC1(34)-- MOST EASTERN LONGITUDE  ( 0-360)
C                            KSEC1(35) TO KSEC1(JSEC1) - LOCAL ADP CENTRE INFORMATION(PACKED FORM)
C
C               *KSEC2*   -  ARRAY CONTAINING SECTION 2 INFORMATION
C                            KSEC2( 1)-- LENGTH OF SECTION 2 (BYTES)
C                            KSEC2( 2) TO KSEC2(JSEC2) LOCAL ADP CENTRE
C                                        INFORMATION(PACKED FORM)
C        OUTPUT:
C               *KEY*     -  ARRAY CONTAINING RDB INFORMATION
C                            KEY( 1)-- LENGTH OF SECTION 2 (BYTES)
C                            KEY( 2)-- RDB TYPE
C                            KEY( 3)-- RDB SUBTYPE
C                            KEY( 4)-- YEAR
C                            KEY( 5)-- MONTH
C                            KEY( 6)-- DAY
C                            KEY( 7)-- HOUR
C                            KEY( 8)-- MINUTE
C                            KEY( 9)-- SECOND
C                            KEY(10)-- LONGITUDE1
C                            KEY(11)-- LATITUDE1
C                            KEY(12)-- LONGITUDE2
C                            KEY(13)-- LATITUDE2
C                            KEY(14)-- NUMBER OF SUBSETS
C                            KEY(15)-- IDENT (NUMERIC)
C                            KEY(16)-- IDENT ( CCITTIA5) ONE CHARACTER
C                            KEY(17)-- IDENT ( CCITTIA5) ONE CHARACTER
C                            KEY(18)-- IDENT ( CCITTIA5) ONE CHARACTER
C                            KEY(19)-- IDENT ( CCITTIA5) ONE CHARACTER
C                            KEY(20)-- IDENT ( CCITTIA5) ONE CHARACTER
C                            KEY(21)-- IDENT ( CCITTIA5) ONE CHARACTER
C                            KEY(22)-- IDENT ( CCITTIA5) ONE CHARACTER
C                            KEY(23)-- IDENT ( CCITTIA5) ONE CHARACTER
C                            KEY(24)-- IDENT ( CCITTIA5) ONE CHARACTER
C                            KEY(25)-- TOTAL BUFR MESSAGE LENGTH
C                            KEY(26)-- DAY    (RDB INSERTION)
C                            KEY(27)-- HOUR   (RDB INSERTION)
C                            KEY(28)-- MINUTE (RDB INSERTION)
C                            KEY(29)-- SECOND (RDB INSERTION)
C                            KEY(30)-- DAY    (MDB INSERTION)
C                            KEY(31)-- HOUR   (MDB INSERTION)
C                            KEY(32)-- MINUTE (MDB INSERTION)
C                            KEY(33)-- SECOND (MDB INSERTION)
C                            KEY(34)-- CORRECTION NUMBER
C                            KEY(35)-- PART
C                            KEY(36)-- 0
C                            KEY(37)-- CORRECTION NUMBER
C                            KEY(38)-- PART
C                            KEY(39)-- 0
C                            KEY(40)-- CORRECTION NUMBER
C                            KEY(41)-- PART
C                            KEY(42)-- 0
C                            KEY(43)-- CORRECTION NUMBER
C                            KEY(44)-- PART
C                            KEY(45)-- 0
C                            KEY(46)-- THE LOWEST Q/C % CONFIDENCE
C               *KSUP*    -  ARRAY CONTAINING SUPLEMENTARY INFORMATION
C                         -  KSUP( 1) -- IDIM1, DIMENSION OF KSEC1
C                         -  KSUP( 2) -- IDIM2, DIMENSION OF KSEC2
C                         -  KSUP( 3) -- IDIM3, DIMENSION OF KSEC3
C                         -  KSUP( 4) -- IDIM4, DIMENSION OF KSEC4
C                         -  KSUP( 5) -- M (NUMBER OF ELEMENTS IN VALUES ARRAY,
C                                           FIRST INDEX)
C                         -  KSUP( 6) -- N (NUMBER OF SUBSETS,SECOND INDEX OF
C                                           VALUES ARRAY)
C                         -  KSUP( 7) -- JVC (NUMBER OF ELEMENTS IN CVAL ARRAY)
C                         -  KSUP( 8) -- TOTAL BUFR MESSAGE LENGTH IN BYTES
C                         -  KSUP( 9) -- IDIM0, DIMENSION OF KSEC0
C               *KERR*    -  RETURNED ERROR CODE
C
C     METHOD.
C     -------
C
C          NONE.
C
C
C     EXTERNALS.
C     ----------
C
C          BUNPCK          - UNPACK BIT PATTERN
C
C     REFERENCE.
C     ----------
C
C          NONE.
C
C     AUTHOR.
C     -------
C
C          M. DRAGOSAVAC    *ECMWF*       17/01/91.
C
C
C     MODIFICATIONS.
C     --------------
C
C          NONE.
C
C
      IMPLICIT LOGICAL(L,O,G), CHARACTER*8(C,H,Y)
C
C
#     include "parameter.F"
#     include "bcomunit.F"
#     include "bcomwork.F"
#     include "bcomdefc.F"
C
      CHARACTER*4 CECMWF,CUSER
C
#ifndef R_4
      REAL*8 RVIND
      REAL*8 EPS
#else
      REAL   RVIND
      REAL   EPS
#endif
      DIMENSION KSEC1(JSEC1),KSEC2(JSEC2),KEY(JKEY)
      DIMENSION IDUM(8)     ,KSUP (JSUP ),KSEC3(JSEC3)
C
C
C*          1. UNPACK LOCAL ADP CENTRE INFORMATION.
C              ------------------------------------
 100  CONTINUE
C
      KERR=0
C
      IF(CECMWF.NE.'ECMF') THEN
         CALL BUEVAR(KERR)
         CECMWF='ECMF'
      END IF
C
      DO 101 I=1,JKEY
      KEY(I)=0
 101  CONTINUE
C
      KEY(1)=KSEC2(1)
      IW=2
      IB=0
      IF(KSEC2(1).EQ.52) THEN
         CALL BUNPCK(NBPW,KSEC2,KEY(2),IW,IB, 8,KERR)
         IF(KERR.GT.0) RETURN
         CALL BUNPCK(NBPW,KSEC2,KEY(3),IW,IB, 8,KERR)
         IF(KERR.GT.0) RETURN
         CALL BUNPCK(NBPW,KSEC2,KEY(4),IW,IB,12,KERR)
         IF(KERR.GT.0) RETURN
         CALL BUNPCK(NBPW,KSEC2,KEY(5),IW,IB, 4,KERR)
         IF(KERR.GT.0) RETURN
         CALL BUNPCK(NBPW,KSEC2,KEY(6),IW,IB, 6,KERR)
         IF(KERR.GT.0) RETURN
         CALL BUNPCK(NBPW,KSEC2,KEY(7),IW,IB, 5,KERR)
         IF(KERR.GT.0) RETURN
         CALL BUNPCK(NBPW,KSEC2,KEY(8),IW,IB, 6,KERR)
         IF(KERR.GT.0) RETURN
         CALL BUNPCK(NBPW,KSEC2,KEY(9),IW,IB, 6,KERR)
         IF(KERR.GT.0) RETURN
         CALL BUNPCK(NBPW,KSEC2,IDUMMY  ,IW,IB, 1,KERR)
         IF(KERR.GT.0) RETURN
         CALL BUNPCK(NBPW,KSEC2,KEY(10),IW,IB,26,KERR)
         IF(KERR.GT.0) RETURN
         CALL BUNPCK(NBPW,KSEC2,IDUMMY  ,IW,IB, 6,KERR)
         IF(KERR.GT.0) RETURN
         CALL BUNPCK(NBPW,KSEC2,KEY(11),IW,IB,25,KERR)
         IF(KERR.GT.0) RETURN
         CALL BUNPCK(NBPW,KSEC2,IDUMMY   ,IW,IB, 7,KERR)
         IF(KERR.GT.0) RETURN
C
         IF(KSUP(6).GT.1.OR.KEY(2).EQ.2.OR.KEY(2).EQ.3.OR.
     1      KEY(2).EQ.12.OR.KEY(2).EQ.8) THEN
C
            CALL BUNPCK(NBPW,KSEC2,KEY(12),IW,IB,26,KERR)
            IF(KERR.GT.0) RETURN
            CALL BUNPCK(NBPW,KSEC2,IDUMMY   ,IW,IB, 6,KERR)
            IF(KERR.GT.0) RETURN
            CALL BUNPCK(NBPW,KSEC2,KEY(13),IW,IB,25,KERR)
            IF(KERR.GT.0) RETURN
            CALL BUNPCK(NBPW,KSEC2,IDUMMY   ,IW,IB, 7,KERR)
            IF(KERR.GT.0) RETURN
            IF(KSUP(6).GT.255.OR.KEY(3).GE.121.AND.
     1         KEY(3).LE.130.OR.KEY(3).EQ.31) THEN
               CALL BUNPCK(NBPW,KSEC2,KEY(14),IW,IB,16,KERR)
               IF(KERR.GT.0) RETURN
               CALL BUNPCK(NBPW,KSEC2,KEY(15),IW,IB,16,KERR)
               IF(KERR.GT.0) RETURN
               CALL BUNPKS(NBPW,KSEC2,IDUM(1),IW,IB,8,0,4,KERR)
               IF(KERR.GT.0) RETURN
               CALL BUNPCK(NBPW,KSEC2,IDUMMY   ,IW,IB, 8,KERR)
               IF(KERR.GT.0) RETURN
            ELSE
               CALL BUNPCK(NBPW,KSEC2,KEY(14),IW,IB, 8,KERR)
               IF(KERR.GT.0) RETURN
               CALL BUNPCK(NBPW,KSEC2,KEY(15),IW,IB,16,KERR)
               IF(KERR.GT.0) RETURN
               CALL BUNPKS(NBPW,KSEC2,IDUM(1),IW,IB,8,0,4,KERR)
               IF(KERR.GT.0) RETURN
               CALL BUNPCK(NBPW,KSEC2,IDUMMY   ,IW,IB,16,KERR)
               IF(KERR.GT.0) RETURN
            END IF
            GO TO 140
         ELSE
            CALL BUNPKS(NBPW,KSEC2,KEY(16),IW,IB,8,0,9,KERR)
            IF(KERR.GT.0) RETURN
            CALL BUNPKS(NBPW,KSEC2,IDUM(1)  ,IW,IB,8,0,8,KERR)
            IF(KERR.GT.0) RETURN
         END IF
C
C
C*          1.4 SUB KEY INFORMATION.
C               --------------------
 140  CONTINUE
C
         CALL BUNPCK(NBPW,KSEC2,KEY(25),IW,IB,16,KERR)
         IF(KERR.GT.0) RETURN
         CALL BUNPCK(NBPW,KSEC2,KEY(26),IW,IB, 6,KERR)
         IF(KERR.GT.0) RETURN
         CALL BUNPCK(NBPW,KSEC2,KEY(27),IW,IB, 5,KERR)
         IF(KERR.GT.0) RETURN
         CALL BUNPCK(NBPW,KSEC2,KEY(28),IW,IB, 6,KERR)
         IF(KERR.GT.0) RETURN
         CALL BUNPCK(NBPW,KSEC2,KEY(29),IW,IB, 6,KERR)
         IF(KERR.GT.0) RETURN
         CALL BUNPCK(NBPW,KSEC2,IDUMMY   ,IW,IB, 1,KERR)
         IF(KERR.GT.0) RETURN
C
         CALL BUNPCK(NBPW,KSEC2,KEY(30),IW,IB, 6,KERR)
         IF(KERR.GT.0) RETURN
         CALL BUNPCK(NBPW,KSEC2,KEY(31),IW,IB, 5,KERR)
         IF(KERR.GT.0) RETURN
         CALL BUNPCK(NBPW,KSEC2,KEY(32),IW,IB, 6,KERR)
         IF(KERR.GT.0) RETURN
         CALL BUNPCK(NBPW,KSEC2,KEY(33),IW,IB, 6,KERR)
         IF(KERR.GT.0) RETURN
         CALL BUNPCK(NBPW,KSEC2,IDUMMY   ,IW,IB, 1,KERR)
         IF(KERR.GT.0) RETURN
C
         CALL BUNPCK(NBPW,KSEC2,KEY(34),IW,IB,6,KERR)
         IF(KERR.GT.0) RETURN
         CALL BUNPCK(NBPW,KSEC2,KEY(35),IW,IB,1,KERR)
         IF(KERR.GT.0) RETURN
         CALL BUNPCK(NBPW,KSEC2,KEY(36),IW,IB,1,KERR)
         IF(KERR.GT.0) RETURN
         CALL BUNPCK(NBPW,KSEC2,KEY(37),IW,IB,6,KERR)
         IF(KERR.GT.0) RETURN
         CALL BUNPCK(NBPW,KSEC2,KEY(38),IW,IB,1,KERR)
         IF(KERR.GT.0) RETURN
         CALL BUNPCK(NBPW,KSEC2,KEY(39),IW,IB,1,KERR)
         IF(KERR.GT.0) RETURN
         CALL BUNPCK(NBPW,KSEC2,KEY(40),IW,IB,6,KERR)
         IF(KERR.GT.0) RETURN
         CALL BUNPCK(NBPW,KSEC2,KEY(41),IW,IB,1,KERR)
         IF(KERR.GT.0) RETURN
         CALL BUNPCK(NBPW,KSEC2,KEY(42),IW,IB,1,KERR)
         IF(KERR.GT.0) RETURN
         CALL BUNPCK(NBPW,KSEC2,KEY(43),IW,IB,6,KERR)
         IF(KERR.GT.0) RETURN
         CALL BUNPCK(NBPW,KSEC2,KEY(44),IW,IB,1,KERR)
         IF(KERR.GT.0) RETURN
         CALL BUNPCK(NBPW,KSEC2,KEY(45),IW,IB,1,KERR)
         IF(KERR.GT.0) RETURN
         CALL BUNPCK(NBPW,KSEC2,KEY(46),IW,IB,8,KERR)
         IF(KERR.GT.0) RETURN
         KSUP( 2)=46
      ELSE
         IF(KSEC2(1).EQ.28) THEN
            CALL BUNPCK(NBPW,KSEC2,KEY(2),IW,IB, 8,KERR)
            IF(KERR.GT.0) RETURN
            CALL BUNPCK(NBPW,KSEC2,KEY(3),IW,IB, 8,KERR)
            IF(KERR.GT.0) RETURN
            CALL BUNPCK(NBPW,KSEC2,KEY(4),IW,IB,12,KERR)
            IF(KERR.GT.0) RETURN
            CALL BUNPCK(NBPW,KSEC2,KEY(5),IW,IB, 4,KERR)
            IF(KERR.GT.0) RETURN
            CALL BUNPCK(NBPW,KSEC2,KEY(6),IW,IB, 6,KERR)
            IF(KERR.GT.0) RETURN
            CALL BUNPCK(NBPW,KSEC2,KEY(7),IW,IB, 5,KERR)
            IF(KERR.GT.0) RETURN
            CALL BUNPCK(NBPW,KSEC2,KEY(8),IW,IB, 6,KERR)
            IF(KERR.GT.0) RETURN
            CALL BUNPCK(NBPW,KSEC2,KEY(9),IW,IB, 6,KERR)
            IF(KERR.GT.0) RETURN
            CALL BUNPCK(NBPW,KSEC2,IDUMMY  ,IW,IB, 1,KERR)
            IF(KERR.GT.0) RETURN
            CALL BUNPCK(NBPW,KSEC2,KEY(10),IW,IB,26,KERR)
            IF(KERR.GT.0) RETURN
            CALL BUNPCK(NBPW,KSEC2,KEY(11),IW,IB,25,KERR)
            IF(KERR.GT.0) RETURN
            CALL BUNPCK(NBPW,KSEC2,IDUMMY  ,IW,IB, 5,KERR)
            IF(KERR.GT.0) RETURN
            IF(KSUP(6).GT.1.OR.KEY(2).EQ.2.OR.KEY(2).EQ.3) THEN
               CALL BUNPCK(NBPW,KSEC2(IW),KEY(12),IW,IB,26,KERR)
               IF(KERR.GT.0) RETURN
               CALL BUNPCK(NBPW,KSEC2,KEY(13),IW,IB,25,KERR)
               IF(KERR.GT.0) RETURN
               CALL BUNPCK(NBPW,KSEC2,IDUMMY  ,IW,IB, 5,KERR)
               IF(KERR.GT.0) RETURN
               CALL BUNPCK(NBPW,KSEC2,KEY(14),IW,IB, 8,KERR)
               IF(KERR.GT.0) RETURN
               CALL BUNPCK(NBPW,KSEC2,KEY(15),IW,IB,16,KERR)
               IF(KERR.GT.0) RETURN
            ELSE
               CALL BUNPKS(NBPW,KSEC2,KEY(16),IW,IB,8,0,9,KERR)
               IF(KERR.GT.0) RETURN
               CALL BUNPKS(NBPW,KSEC2,IDUM(1)  ,IW,IB,8,0,8,KERR)
               IF(KERR.GT.0) RETURN
            END IF
         ELSE
            WRITE(KNTN,'(1H )')
            WRITE(KNTN,'(1H ,A)') 'BUUKEY : KEY DEFINITION NOT KNOWN'
            WRITE(KNTN,'(1H )')
         END IF
      END IF
C
C     CHECK IF IDENT IS RIGHT JUSTIFIED.
C
      IF(KEY(16).EQ.32) THEN
         J=15
         DO 102 I=16,24
         IF(KEY(I).EQ.32) GO TO 102
         J=J+1
         KEY(J)=KEY(I)
         KEY(I)=32
 102     CONTINUE
      END IF
C
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE DTABLE(YNAME,KERR)
C
C**** *DTABLE*
C
C
C     PURPOSE.
C     --------
C          THE MAIN PURPOSE OF THIS PROGRAMME IS TO CREATE WORKING
C          TABLE OF SEQUENCE DESCRIPTORS FOR *BUFR* DECODING.
C
C**   INTERFACE.
C     ----------
C          NONE.
C
C
C
C
C     *METHOD.
C      -------
C          NONE.
C
C
C
C     EXTERNALS.
C     ----------
C          NONE.
C
C
C
C
C     REFERENCE.
C     ----------
C
C          BINARY UNIVERSAL FORM FOR DATA REPRESENTATION, *FM 94 BUFR*.
C
C          J.K.GIBSON AND *M.DRAGOSAVAC,1987:* DECODING *DATA *REPRESENTATION
C                          *FM 94 BUFR*,*TECHNICAL *MEMORANDUM *NO.
C
C          J.K.GIBSON,1986:*EMOS 2 - *STANDARDS FOR SOFTWARE DEVELOPMENT
C                           AND MAINTANANCE *,*TECHICAL MEMORANDUM *NO.
C                           *ECMWF*.
C
C
C     AUTHOR.
C     -------
C
C          M. DRAGOSAVAC       *ECMWF*       JANUARY 1991.
C
C
C     MODIFICATIONS.
C     --------------
C
C          NONE.
C
C
      IMPLICIT LOGICAL(L,O,G), CHARACTER*8(C,H,Y)
C
#     include "parameter.F"
#     include "bcomwork.F"
#     include "bcomtab.F"
#     include "bcomtabc.F"
#     include "bcomct.F"
#     include "bcomctc.F"
#     include "bcomroot.F"
#     include "bcomtabload.F"
#     include "bcomtabloadc.F"

C
      CHARACTER*64 CTABBEN,CCTABBEN
      CHARACTER*24 CTABBU,CCTABBU,CTABLE_LIST
      CHARACTER*120 YENTRY
      CHARACTER*256 YFNAME
      CHARACTER*(*) YNAME
      REAL*8 RVIND,EPS
C
C     ------------------------------------------------------------------
C*          1.   SET INITIAL CONSTANTS.
C                ----------------------
 100  CONTINUE
C
      KERR=0
      J  =0
      IST=1
      YFNAME=' '
C
      DO 101 I=1,JTAB
      NTABDTR(I)=999999
      NTABDL (I)=0
      NTABDST(I)=0
 101  CONTINUE
C
      DO 102 I=1,JTAB*20
      NTABDSQ(I)=0
 102  CONTINUE
C
      II=INDEX(YNAME,' ')
      II=II-1
      YFNAME=YNAME(1:II)
      II=INDEX(YFNAME,' ')
      II=II-1
      CALL GET_FREE_UNIT(IUNIT)
      OPEN(UNIT=IUNIT,iostat=ios,FILE=YFNAME(1:II),STATUS='OLD')
      IF(IOS.NE.0) THEN
         print*,'Open error on ',YFNAME(1:II)
         kerr=63
         return
      END IF
C
C     ------------------------------------------------------------------
C*          2.   READ IN TABLE D
C                ---------------
C
 200  CONTINUE
C
      READ(IUNIT,'(A)',IOSTAT=IOS,END=300) YENTRY
      IF(IOS.NE.0) THEN
         print*,'Read error ',ios
         kerr=8
         return
      END IF
C
      J=J+1
C
      IF(J.GT.JTAB) THEN
         PRINT*,' DIMENSION TOO SMALL J=',J
         KERR=64
         RETURN
      END IF 
C
C     ------------------------------------------------------------------
C*          2.1  SET ARRAYS FOR TABLE REFERENCE, DATA LENGTH,
C*               STARTING POINTER AND SEQUENCE DESCRIPTORS.
C
 210  CONTINUE
C
C
      READ(YENTRY,'(1X,I6,I3)') NTABDTR(J),NTABDL (J)
C
      IF(J.EQ.1) THEN
         IST=1
         NTABDST(J)=IST
      ELSE
         IST=IST + NTABDL(J-1)
         NTABDST(J)=IST
      END IF
C
      IF(NTABDL(J).GT.1) THEN
         READ(YENTRY,'(11X,I6)') NTABDSQ(IST)
         IIST=IST
C
         DO 220 JA=1,NTABDL(J)-1
         IIST=IIST+1
         READ(IUNIT,'(A)',END=300) YENTRY
         READ(YENTRY,'(11X,I6)') NTABDSQ(IIST)
 220     CONTINUE
C
      ELSE
         READ(YENTRY,'(11X,I6)') NTABDSQ(IST)
      END IF
C
C
C     WRITE(*,1000) NTABDTR(J),NTABDL(J),NTABDST(J),
C    1              (NTABDSQ(I),I=NTABDST(J),NTABDL(J)+NTABDST(J)-1)
C
C1000 FORMAT(1H ,I6,I3,1X,I6,1X,I6/ (18X,I6))
C
      GO TO 200
C
C     ------------------------------------------------------------------
 300  CONTINUE
C
      IF(NTT.EQ.JTMAX.AND.NTC.NE.0) THEN
         DO J=1,JTAB
            MTABDTR(J,NTC)=NTABDTR(J)
            MTABDL (J,NTC)=NTABDL(J)
            MTABDST(J,NTC)=NTABDST(J)
         END DO
         DO J=1,JTAB*20
            MTABDSQ(J,NTC)=NTABDSQ(J)
         END DO
      ELSE
         DO J=1,JTAB
            MTABDTR(J,NTT)=NTABDTR(J)
            MTABDL (J,NTT)=NTABDL(J)
            MTABDST(J,NTT)=NTABDST(J)
         END DO
         DO J=1,JTAB*20
            MTABDSQ(J,NTT)=NTABDSQ(J)
         END DO
      END IF
C
      CLOSE(IUNIT)
C
c     WRITE(*,'(1h )')
c     WRITE(*,'(1h ,a,i4)')'Total number of entries in Table D is ',j
C
      RETURN
C     -----------------------------------------------------------------
 400  CONTINUE
C
      RETURN
C
      END

C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      INTEGER FUNCTION INTVECY(PUFIELD,PVFIELD,KASIZE,
     X                         PUOUT,PVOUT,OUTLEN)
C
C---->
C**** INTVECY
C
C     Purpose
C     -------
C     Interpolate U or V component fields to grid point.
C
C
C     Interface
C     ---------
C     IRET = INTVECY(PUFIELD,PVFIELD,KASIZE,
C    X               KUGRIB,KVGRIB,OUTLEN)
C
C     Input
C     -----
C     PUFIELD - U values.
C     PVFIELD - V values.
C     KASIZE  - Size of input arrays
C
C
C     Output
C     ------
C     PUOUT - Output wind U component field
C     PVOUT - Output wind V component field
C     OUTLEN - Output U field length (words).
C
C
C     Method
C     ------
C     None.
C
C
C     Externals
C     ---------
C     RESET_C - Reset interpolation handling options using GRIB product.
C     IBASINI - Ensure basic interpolation setup is done.
C     ISCRSZ  - Calculate number of values in generated field.
C     INTFAU  - Prepare to interpolate unpacked input field.
C     INTFBU  - Interpolate unpacked input field.
C     INTLOG  - Log error message.
C     MKFRAME - Create a 'frame' from a rectangular field.
C     INTUVGH - Interpolate GRIB U and V reduced gaussian to rotated GRIB
C               U and V.
C
C
C     Author
C     ------
C     S.Curic     ECMWF     December 2006
C
C
C----<
C     -----------------------------------------------------------------|
C
      IMPLICIT NONE
C
#include "parim.h"
#include "nifld.common"
#include "nofld.common"
#include "intf.h"
#include "current.h"
#include "intlog.h"
C
C     Parameters
C
      INTEGER JPROUTINE
      PARAMETER (JPROUTINE = 40170 )
C
C     Function arguments
C
      INTEGER KPARAM, KASIZE, OUTLEN
      REAL PUFIELD(KASIZE), PVFIELD(KASIZE), PUOUT(*), PVOUT(*)
C
C     Local variables
C
      LOGICAL LFRAME, LOLDWIND, LOMISSV
      INTEGER NPARAM, IRET, ILENF, NTRUNC, NGAUSS, ISIZE, NCOUNT
      INTEGER NUVFLAG, NLON, NLAT, NBYTES, NSIZE
      INTEGER IHOLD, ISAME
      INTEGER IN_U, IN_V
      INTEGER NUMPTS
      REAL DUMMY
      REAL AREA(4), GRID(2), POLE(2), EAST, WEST
      REAL OLDGRID(2)
      CHARACTER*1 HOLDTYP
      INTEGER LOOP
C
      REAL RGGRID, SWORK, TWORK
      POINTER (IRGGRID, RGGRID(1) )
      POINTER (ISWORK, SWORK(1) )
      POINTER (ITWORK, TWORK(1) )
C
      INTEGER KPTS(JPGTRUNC*2)
      REAL GLATS(JPGTRUNC*2)

      LOGICAL LFIRST, LNEWUV, LSPECUV
      CHARACTER*3 EXTRA
C
C     Externals
C
      INTEGER FIXAREA, INTFAU, INTFBU, INTUVDH, HSP2GG, IBASINI
      INTEGER HIRLAMW, ISCRSZ, RESET_C, INSANE, INTUVGH
      INTEGER HRG2GGW, HLL2LLW
C
      DATA IRGGRID/0/, ISWORK/0/, ITWORK/0/
      SAVE IRGGRID, ISWORK, ITWORK
      DATA LFIRST/.TRUE./, LNEWUV/.TRUE./, EXTRA/'NO '/
      SAVE LFIRST, LNEWUV
C
C     -----------------------------------------------------------------|
C*    Section 1.   Initialise.
C     -----------------------------------------------------------------|
C
  100 CONTINUE
C
      INTVECY = 0
      IF( LFIRST ) THEN
        CALL GETENV('IGNORE_UV_EXTRA_MODE', EXTRA)
        IF((EXTRA(1:1).EQ.'Y').OR.(EXTRA(1:1).EQ.'y')) LNEWUV = .FALSE.
        IF( LNEWUV ) THEN
          CALL INTLOG(JP_DEBUG,
     X      'INTVECY: IGNORE_UV_EXTRA_MODE not turned on',JPQUIET)
        ELSE
          CALL INTLOG(JP_DEBUG,
     X      'INTVECY: IGNORE_UV_EXTRA_MODE turned on',JPQUIET)
        ENDIF
        LFIRST = .FALSE.
      ENDIF
C
      LOLDWIND = LWINDSET
C
C     Ensure that basic initialisation has been done
C
      IRET = IBASINI(0)
      IF( IRET.NE.0 ) THEN
        CALL INTLOG(JP_ERROR,'INTVECY: basic initialise failed',JPQUIET)
        INTVECY = IRET
        GOTO 900
      ENDIF
C
C
cs      NSIZE = ISEC4(1)
      NSIZE = KASIZE
cs      NIREPR = ISEC2(1)
      LSPECUV = (NIREPR.EQ.JPSPHERE).OR.(NIREPR.EQ.JPSPHROT)
cs      IF( LSPECUV ) NIRESO = ISEC2(2)
C
C     Setup interpolation options from input GRIB characteristics.
C
cs      IRET = RESET_C(ISEC1, ISEC2, ZSEC2, ISEC4)
cs      IF( IRET.NE.0 ) THEN
cs        CALL INTLOG(JP_ERROR,
cs     X    'INTVECY: Setup interp. options from GRIB failed.',JPQUIET)
cs        INTVECY = IRET
cs        GOTO 900
cs      ENDIF
C
C       Only allowed rotations are:
C        - spectral to regular lat/long
C        - reduced gaussian to regular lat/long
C
      IF( LNOROTA ) THEN
        IF( ((NOREPR.NE.JPREGROT).AND.(NOREPR.NE.JPREGULAR)).OR.
     X      ((NIREPR.NE.JPSPHERE).AND.(NIREPR.NE.JPQUASI)) ) THEN
          CALL INTLOG(JP_ERROR,
     X      'INTVECY: For vector fields, only allowed rotations are:',
     X      JPQUIET)
          CALL INTLOG(JP_ERROR,
     X      'INTVECY: spectral to regular lat/long, or',JPQUIET)
          CALL INTLOG(JP_ERROR,
     X      'INTVECY: reduced gaussian to regular lat/long',JPQUIET)
          INTVECY = JPROUTINE + 1
          GOTO 900
        ENDIF
      ENDIF
C
C     Check that no outrageous values given for interpolation
C
      ISAME = INSANE()
      IF( (ISAME.GT.0).AND.(ISAME.NE.27261) ) THEN
        CALL INTLOG(JP_ERROR,
     X    'INTVECY: Interpolation cannot use given values.',JPQUIET)
        INTVECY = ISAME
        GOTO 900
      ENDIF
C
      LFRAME = LNOFRAME.AND.
     X         ((NOREPR.EQ.JPREGULAR).OR.(NOREPR.EQ.JPGAUSSIAN).OR.
     X          (NOREPR.EQ.JPREGROT ).OR.(NOREPR.EQ.JPFGGROT  ) )
C
C     Fill area limits (handles case when default 0/0/0/0 given)
C
      IRET = FIXAREA()
      IF( IRET.NE.0 ) THEN
        CALL INTLOG(JP_ERROR,'INTVECY: area fixup failed',JPQUIET)
        INTVECY = JPROUTINE + 3
        GOTO 900
      ENDIF
C
      AREA(1) = REAL(NOAREA(1))/PPMULT
      AREA(2) = REAL(NOAREA(2))/PPMULT
      AREA(3) = REAL(NOAREA(3))/PPMULT
      AREA(4) = REAL(NOAREA(4))/PPMULT
C
      GRID(1) = REAL(NOGRID(1))/PPMULT
      GRID(2) = REAL(NOGRID(2))/PPMULT
C
      IF( LNOROTA ) THEN
        POLE(1) = REAL(NOROTA(1))/PPMULT
        POLE(2) = REAL(NOROTA(2))/PPMULT
        CALL INTLOG(JP_DEBUG,'INTVECY: Rotate the U & V fields',JPQUIET)
        CALL INTLOG(JP_DEBUG,'INTVECY: South pole lat  ',NOROTA(1))
        CALL INTLOG(JP_DEBUG,'INTVECY: South pole long ',NOROTA(2))
      ELSE
        NOROTA(1) = -9000000
        NOROTA(2) = 0
      ENDIF
C

      IF( .NOT. LSPECUV ) GOTO 500
C
C     Get some scratch memory for the U and V fields
C
C     Unpack U field
C
      NIFORM = 0
cs      NIPARAM = IN_U
      LWIND = .TRUE.
      LOLDWIND = LWINDSET
      LWINDSET = .TRUE.
C
cs      IN_U = ISEC1(6)
C
C     Unpack V field
C
cs      NIPARAM = IN_V
cs      IN_V = ISEC1(6)
C
      IF( LNOROTA ) GOTO 300
C
C     -----------------------------------------------------------------|
C*    Section 2.   Spectral to grid-point with no rotation
C     -----------------------------------------------------------------|
C
  200 CONTINUE
C
      CALL INTLOG(JP_DEBUG,
     X  'INTVECY: Interpolate U & V fields with no rotation',JPQUIET)
C
C
C     Interpolate U field
C
      IRET = INTFAU(PUFIELD, KASIZE)
      IF( IRET.NE.0 ) THEN
        CALL INTLOG(JP_ERROR,
     X    'INTVECY: Prepare to interpolate failed.',JPQUIET)
        INTVECY = JPROUTINE + 2
        GOTO 900
      ENDIF
C
      IRET = INTFBU(PUFIELD, KASIZE, PUOUT, OUTLEN)
      IF( IRET.NE.0 ) THEN
        CALL INTLOG(JP_ERROR,'INTVECY: Interpolation failed.',JPQUIET)
        INTVECY = JPROUTINE + 2
        GOTO 900
      ENDIF
C
C     Interpolate V field
C
      IRET = INTFAU(PVFIELD, KASIZE)
      IF( IRET.NE.0 ) THEN
        CALL INTLOG(JP_ERROR,
     X    'INTVECY: Prepare to interpolate failed.',JPQUIET)
        INTVECY = JPROUTINE + 2
        GOTO 900
      ENDIF
C
      IRET = INTFBU(PVFIELD, KASIZE, PVOUT, OUTLEN)
      IF( IRET.NE.0 ) THEN
        CALL INTLOG(JP_ERROR,'INTVECY: Interpolation failed.',JPQUIET)
        INTVECY = JPROUTINE + 2
        GOTO 900
      ENDIF
C
      GOTO 700
C
C     -----------------------------------------------------------------|
C*    Section 3.   Spectral to grid-point with rotation
C     -----------------------------------------------------------------|
C
  300 CONTINUE
C
      IF( .NOT.LUSEHIR ) THEN
        CALL INTLOG(JP_ERROR,
     X    'INTVECY : Unable to rotate spectral U or V:',JPQUIET)
        INTVECY  = JPROUTINE + 3
        GOTO 900
      ENDIF
C
C     Convert spectral to suitable global reduced gaussian
C
      NTRUNC = NIRESO
      IRET = HSP2GG(NTRUNC,NGAUSS,KPTS,GLATS,ISIZE)
      IF( IRET.NE.0 ) THEN
        CALL INTLOG(JP_ERROR,
     X    'INTVECY: problem getting data for reduced grid',NTRUNC)
        INTVECY = JPROUTINE + 4
        GOTO 900
      ENDIF
C
      NCOUNT = ISIZE
C
C     Dynamically allocate memory for global reduced gaussian grid
C
      CALL JMEMHAN( 18, IRGGRID, (NCOUNT*2), 1, IRET)
      IF( IRET.NE.0 ) THEN
        CALL INTLOG(JP_ERROR,
     X    'INTVECY: memory alloc for reduced grid fail',JPQUIET)
        INTVECY = JPROUTINE + 4
        GOTO 900
      ENDIF
C
C     Set flag to show field is a wind component
C
      NUVFLAG = 1
C
C     Create the reduced gaussian grid
C
      HOLDTYP = HOGAUST
      WEST = 0.0
      EAST = 360.0 - (360.0/(NGAUSS*4))
C
C     U component spectral -> reduced gaussian
C
      CALL JAGGGP(PUFIELD,NTRUNC,GLATS(1),GLATS(NGAUSS*2),WEST,
     X            EAST,NGAUSS,'R',KPTS,RGGRID,NUVFLAG,IRET)
      IF( IRET.NE.0 ) THEN
        CALL INTLOG(JP_ERROR,
     X    'INTVECY: spectral to reduced gaussian failed',JPQUIET)
        INTVECY = JPROUTINE + 4
        GOTO 900
      ENDIF
C
      HOGAUST = HOLDTYP
C
C     V component spectral -> reduced gaussian
C
      CALL JAGGGP(PVFIELD,NTRUNC,GLATS(1),GLATS(NGAUSS*2),WEST,
     X            EAST,NGAUSS,'R',KPTS,RGGRID(1+NCOUNT),NUVFLAG,IRET)
      IF( IRET.NE.0 ) THEN
        CALL INTLOG(JP_ERROR,
     X    'INTVECY: spectral to reduced gaussian failed',JPQUIET)
        INTVECY = JPROUTINE + 4
        GOTO 900
      ENDIF
C
      HOGAUST = HOLDTYP
C
C     Rotate using 12-point horizontal interpolation
C
C     Dynamically allocate memory for rotated lat/long grid
C
      NLON = 1 + NINT((AREA(JPEAST)  - AREA(JPWEST)) /
     X       GRID(JPWESTEP))                  ! SC
      NLAT = 1 + NINT((AREA(JPNORTH) - AREA(JPSOUTH)) /
     X       GRID(JPNSSTEP))                  ! SC
C
      OUTLEN = NLON * NLAT
C
      IRET = HIRLAMW(LO12PT,RGGRID,RGGRID(1+NCOUNT),NCOUNT,NGAUSS,AREA,
     X               POLE,GRID,PUOUT,PVOUT,OUTLEN,NLON,NLAT)
C
      IF( IRET.NE.0 ) THEN
        CALL INTLOG(JP_ERROR,
     X    'INTVECY: HIRLAMW rotation failed',JPQUIET)
        INTVECY = JPROUTINE + 6
        GOTO 900
      ENDIF
C
C     Set the components flag for rotated U and V coefficients
C
cs      ISEC2(19) = 8
      NOWE = NLON
      NONS = NLAT
      OUTLEN = NLAT*NLON

C
      GOTO 700
C
C     -----------------------------------------------------------------|
C*    Section 5.   Grid to grid  point
C     -----------------------------------------------------------------|
C
  500 CONTINUE
C*    5a.   Generate interpolated lat/long U and V fields.
C     -----------------------------------------------------------------|
C
C
      IF( (NOREPR.EQ.JPREGULAR).OR.(NOREPR.EQ.JPREGROT) ) THEN
C
C       Dynamically allocate scrath space for rotated lat/long grid
C
        NLON = 1 + NINT(FLOAT(NOAREA(JPEAST)  - NOAREA(JPWEST)) /
     X         NOGRID(JPWESTEP))
        NLAT = 1 + NINT(FLOAT(NOAREA(JPNORTH) - NOAREA(JPSOUTH)) /
     X         NOGRID(JPNSSTEP))
C
        NOWE = NLON
        NONS = NLAT
        OUTLEN = NLON * NLAT
C
C       Rotate reduced gaussian to lat/long
C
        IF( (NIREPR.EQ.JPGAUSSIAN).OR.(NIREPR.EQ.JPQUASI) ) THEN
        IF( LDEBUG ) CALL INTLOG(JP_DEBUG,
     X    'INTVECY: Rotate reduced gaussian to lat/long',JPQUIET)
          IRET = HIRLAMW(LO12PT,
     X                   PUFIELD,PVFIELD,KASIZE,
     X                   NIGAUSS,AREA,POLE,GRID,
     X                   PUOUT,PVOUT,OUTLEN,NLON,NLAT)
          IF( IRET.NE.0 ) THEN
            CALL INTLOG(JP_ERROR,
     X        'INTUVGH: HIRLAMW rotation failed',JPQUIET)
            INTUVGH = JPROUTINE + 3
            GOTO 900
          ENDIF
C
C       Rotate lat/long to lat/long
C
        ELSE
        IF( LDEBUG ) CALL INTLOG(JP_DEBUG,
     X    'INTVECY: Rotate lat/long to lat/long',JPQUIET)
          OLDGRID(1) = REAL(NIGRID(1)) / PPMULT
          OLDGRID(2) = REAL(NIGRID(2)) / PPMULT
          IRET = HLL2LLW(LO12PT,PUFIELD,PVFIELD,
     X                   OLDGRID,AREA,POLE,GRID,
     X                   PUOUT,PVOUT,OUTLEN,NLON,NLAT)
          IF( IRET.NE.0 ) THEN
            CALL INTLOG(JP_ERROR,
     X        'INTVECY: HLL2LLW rotation failed',JPQUIET)
            INTVECY = JPROUTINE + 3
            GOTO 900
          ENDIF
        ENDIF
C
      ELSE
C
C*    Section 5b.   Generate interpolated gaussian U and V fields.
C     -----------------------------------------------------------------|
C
  400   CONTINUE
C
        IF( LDEBUG ) CALL INTLOG(JP_DEBUG,
     X    'INTVECY: Rotate gaussian to gaussian',JPQUIET)
C
C       Dynamically allocate memory for rotated gaussian grids
C
        NUMPTS = NOGAUSS * NOGAUSS
        OUTLEN = 2 * NUMPTS * 8 
C
cs        NGAUSS = ISEC2(10)
        IRET = HRG2GGW(LO12PT,
     X                 PUFIELD,PVFIELD,KASIZE,
     X                 NIGAUSS,AREA,POLE,NOGAUSS,HOGAUST,
     X                 PUOUT,PVOUT,OUTLEN,NUMPTS)
        IF( IRET.NE.0 ) THEN
          IF( LDEBUG ) CALL INTLOG(JP_ERROR,
     X        'INTVECY: HRG2GGW rotation failed',JPQUIET)
            INTUVGH = JPROUTINE + 4
            GOTO 900
          ENDIF
C
      ENDIF
C
C
  700 CONTINUE
C
C     Reset the input format flag
C
cs      NIFORM = 1
C
C     If a 'frame' has been specified, build the frame
C
      IF( LFRAME ) THEN
        LOMISSV = LIMISSV
        LIMISSV = .TRUE.
        ISEC1(5) = 192
        ISEC3(2) = NINT(RMISSGV)
        ZSEC3(2) = RMISSGV
        CALL MKFRAME(NLON,NLAT,PUOUT,RMISSGV,NOFRAME)
        CALL MKFRAME(NLON,NLAT,PVOUT,RMISSGV,NOFRAME)
        LIMISSV = LOMISSV
      ENDIF

      DO 910 LOOP = 1, 4
        NOAAPI(LOOP) = NOAREA(LOOP)
  910 CONTINUE
C
C     -----------------------------------------------------------------|
C*    Section 9.   Return
C     -----------------------------------------------------------------|
C
  900 CONTINUE
C
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities
C granted to it by virtue of its status as an intergovernmental organisation
C nor does it submit to any jurisdiction.
C
      program fft
      parameter (n=2*2*3*5,m=20)
      dimension a((n+2)*m),trigs(n),work(m*(n+1))
      integer ifax(10)
      call set99(trigs,ifax,n)
      do 11 i=1,(n+2)*m
      a(i)=0
11    continue
      do 1 j=1,m
      do 1 i=1,n
      a((j-1)*(n+2)+i)=j
1     continue
c     write (2,*)(a(i),i=1,n)
c      t1=secnds(real(0.))
c     write(*,*)t1
      call fft99(a,work,trigs,ifax,1,n+2,n,m,-1)
c      t2=secnds(real(t1))
c      write(*,*)t2
      write (*,2)(a(i),i=1,n)
 2     format(4(f20.12,2x))
      end

C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      INTEGER FUNCTION GB2GB(
     X  INGRIB,INSIZE,OUTGRIB,OUTSIZE,OUT_EW,OUT_NS,OUTAREA)
C
C---->
C**** GB2GB
C
C     Purpose
C     -------
C
C     Create a subset of an input regular latitude/longitude
C     gridpoint field.
C
C
C     Interface
C     ---------
C
C     IRET = GB2GB(INGRIB,INSIZE,OUTGRIB,OUTSIZE,OUT_EW,OUT_NS,OUTAREA)
C
C     Input
C     -----
C
C     INGRIB  - Input regular latitude/longitude gridpoint field in GRIB
C               format. 
C     INSIZE  - Size in words (integers) of input GRIB product.
C     OUT_EW  - East-west increment of output field (millidegrees).
C     OUT_NS  - North-south increment of output field (millidegrees).
C     OUTAREA - Area boundaries for output field (N/W/S/E millidegrees).
C
C
C     Output
C     ------
C
C     OUTGRIB - Output regular latitude/longitude gridpoint field in GRIB
C               format.
C     OUTSIZE - Size in words (integers) of output GRIB product.
C
C     Returns - length in words (integers) of output GRIB product if OK,
C               negative if error.
C
C
C     Method
C     ------
C
C     Area boundaries for output field are adjusted if necessary to fit
C     the grid (N/W/S/E millidegrees).
C
C
C     Externals
C     ---------
C
C     GRIBEX  - Unpack and pack GRIB products.
C     AREACHK - Fixup input/output field area according to grid
C     INTLOG  - Logs output messages
C     JDEBUG  - Checks whether the debug flag is to be turned on.
C
C
C     Author
C     ------
C
C     J.D.Chambers     ECMWF     March 1999
C
C----<
C
      IMPLICIT NONE
C
#include "jparams.h"
#include "parim.h"
#include "nofld.common"
C
C     Function arguments
C
      INTEGER INGRIB,INSIZE,OUTGRIB,OUTSIZE,OUT_EW,OUT_NS,OUTAREA
      DIMENSION INGRIB(*),OUTGRIB(OUTSIZE),OUTAREA(4)
C
C     Local variables
C
      INTEGER ISEC0,ISEC1,ISEC2,ISEC3,ISEC4
      DIMENSION ISEC0(2),ISEC1(1024),ISEC2(1024),ISEC3(2),ISEC4(512)
      INTEGER ILENP,ILENG,IWORD,IRET,IPOINT
C
      REAL PSEC2,PSEC3,PSEC4
      DIMENSION PSEC2(512),PSEC3(2),PSEC4(1)
C
      INTEGER NVALSI,NVALSO
      REAL ZSEC4I,ZSEC4O
      DIMENSION ZSEC4I(1),ZSEC4O(1)
      POINTER ( NPOINTI, ZSEC4I )
      POINTER ( NPOINTO, ZSEC4O )
C
      INTEGER AREA(4)
      INTEGER INC_EW,INC_NS,N_EW,N_NS,I_EW,I_NS,LOOPO,LOOPI,NEXT
      INTEGER NWEST,NEAST,OWEST,OEAST
      REAL EW,NS,NORTH,WEST,SOUTH,EAST
      LOGICAL LDEBUG, LDUDEW
      CHARACTER*1 HFUNC
C
C     Externals
C
      INTEGER  AREACHK
      EXTERNAL AREACHK
C
C ------------------------------------------------------------------
C     Section 1. Initialise
C ------------------------------------------------------------------
C
  100 CONTINUE
C
      GB2GB = -1
C
      CALL JDEBUG( )
      LDEBUG = ( NDBG.GT.0 )
C
      DO LOOPO = 1, 4
        AREA(LOOPO) = OUTAREA(LOOPO)
      ENDDO
C
C     Unpack input GRIB header.
C
      IRET = 1
      ISEC3(2) = 1E-21
      PSEC3(2) = 1.0E-21
      CALL GRIBEX(ISEC0,ISEC1,ISEC2,PSEC2,ISEC3,PSEC3,ISEC4,
     X            PSEC4,ILENP,INGRIB,INSIZE,IWORD,'J',IRET)
      IF( IRET.GT.0 ) THEN
        IF( LDEBUG )
     X    CALL INTLOG(JP_ERROR,'GB2GB: GRIBEX "J" option error',IRET)
        GOTO 900
      ENDIF
C
C     Ensure that it is a regular latitude/longitude grid.
C
      IF( ISEC2(1).NE.0 ) THEN
        IF( LDEBUG )
     X    CALL INTLOG(JP_ERROR,
     X      'GB2GB: Input not regular lat/long. Type =',ISEC2(1))
        GOTO 900
      ENDIF
C
C ------------------------------------------------------------------
C     Section 2. Check that output grid is a subset of the input grid.
C ------------------------------------------------------------------
C
  200 CONTINUE
C
C     Fixup input/output field area definitions according to grid
C     specification.
C
      EW    = REAL(OUT_EW) / 1000.0
      NS    = REAL(OUT_NS) / 1000.0
      NORTH = REAL(AREA(1)) / 1000.0
      WEST  = REAL(AREA(2)) / 1000.0
      SOUTH = REAL(AREA(3)) / 1000.0
      EAST  = REAL(AREA(4)) / 1000.0
      IRET = AREACHK( EW, NS, NORTH, WEST, SOUTH, EAST )
      IF( IRET.NE.0 ) THEN
        IF( LDEBUG )
     X    CALL INTLOG(JP_ERROR,'GB2GB: AREACHK failed:',IRET)
        GOTO 900
      ENDIF
C
      OUT_EW = NINT(EW * 1000.0)
      OUT_NS = NINT(NS * 1000.0)
      AREA(1) = NINT(NORTH * 1000.0)
      AREA(2) = NINT(WEST  * 1000.0)
      AREA(3) = NINT(SOUTH * 1000.0)
      AREA(4) = NINT(EAST  * 1000.0)
C
C     Check (sub)area limits
C
C     North and south ..
C
      IF( (AREA(1).GT.ISEC2(4)) .OR.
     X    (AREA(3).LT.ISEC2(7)) ) THEN
        IF( LDEBUG ) THEN
          CALL INTLOG(JP_ERROR,
     X      'GB2GB: North/south outside input GRIB area',JPQUIET)
          CALL INTLOG(JP_ERROR,'GB2GB: Requested north  = ',OUTAREA(1))
          CALL INTLOG(JP_ERROR,'GB2GB: Requested south  = ',OUTAREA(3))
          CALL INTLOG(JP_ERROR,'GB2GB: Input GRIB north = ',ISEC2(4))
          CALL INTLOG(JP_ERROR,'GB2GB: Input GRIB south = ',ISEC2(7))
          GOTO 900
        ENDIF
      ENDIF
C
C     East and west ..
C
      NWEST = AREA(2)
      NEAST = AREA(4)
      OWEST = ISEC2(5)
      OEAST = ISEC2(8)
C
      LDUDEW = 
     X  ((NWEST.LT.0).AND.(OWEST.LT.0).AND.(NWEST.LT.OWEST)).OR.
     X  ((NWEST.GT.0).AND.(OWEST.GT.0).AND.(NWEST.LT.OWEST)).OR.
     X  ((NWEST.LT.0).AND.(OWEST.GT.0).AND.(NWEST.LT.(OWEST-36000))).OR.
     X  ((NWEST.GT.0).AND.(OWEST.LT.0).AND.(NWEST.LT.(OWEST+36000))).OR.
     X  ((NEAST.LT.0).AND.(OEAST.LT.0).AND.(NEAST.GT.OEAST)).OR.
     X  ((NEAST.GT.0).AND.(OEAST.GT.0).AND.(NEAST.GT.OEAST)).OR.
     X  ((NEAST.LT.0).AND.(OEAST.GT.0).AND.(NEAST.GT.(OEAST-36000))).OR.
     X  ((NEAST.GT.0).AND.(OEAST.LT.0).AND.(NEAST.GT.(OEAST+36000)))
C
      IF( LDUDEW ) THEN
        IF( LDEBUG ) THEN
          CALL INTLOG(JP_ERROR,
     X      'GB2GB: East/west outside input GRIB area',JPQUIET)
          CALL INTLOG(JP_ERROR,'GB2GB: Requested west  = ',OUTAREA(2))
          CALL INTLOG(JP_ERROR,'GB2GB: Requested east  = ',OUTAREA(4))
          CALL INTLOG(JP_ERROR,'GB2GB: Input GRIB west = ',ISEC2(5))
          CALL INTLOG(JP_ERROR,'GB2GB: Input GRIB east = ',ISEC2(8))
        ENDIF
        GOTO 900
      ENDIF
C
      IF( NWEST.LT.0 ) NWEST = NWEST + 360000
      IF( NEAST.LT.0 ) NEAST = NEAST + 360000
      IF( NEAST.LT.NWEST ) NEAST = NEAST + 360000
      IF( OWEST.LT.0 ) OWEST = OWEST + 360000
      IF( OEAST.LT.0 ) OEAST = OEAST + 360000
      IF( OEAST.LT.OWEST ) OEAST = OEAST + 360000
C
C     Check increments
C
      INC_EW = OUT_EW / ISEC2(9)
      IF( (INC_EW*ISEC2(9)).NE.OUT_EW ) THEN
        IF( LDEBUG ) THEN
          CALL INTLOG(JP_ERROR,
     X      'GB2GB: East-west step not multiple of input grid',JPQUIET)
          CALL INTLOG(JP_ERROR,'GB2GB: Requested step  = ',OUT_EW)
          CALL INTLOG(JP_ERROR,'GB2GB: Input GRIB step = ',ISEC2(9))
        ENDIF
        GOTO 900
      ENDIF
C
      INC_NS = OUT_NS / ISEC2(10)
      IF( (INC_NS*ISEC2(10)).NE.OUT_NS ) THEN
        IF( LDEBUG ) THEN
          CALL INTLOG(JP_ERROR,
     X     'GB2GB: North-south step not multiple of input grid',JPQUIET)
          CALL INTLOG(JP_ERROR,'GB2GB: Requested step  = ',OUT_NS)
          CALL INTLOG(JP_ERROR,'GB2GB: Input GRIB step = ',ISEC2(10))
        ENDIF
        GOTO 900
      ENDIF
C
C ------------------------------------------------------------------
C     Section 3. Generate new grid.
C ------------------------------------------------------------------
C
  300 CONTINUE
C
C     Get memory for input GRIB values.
C
      NVALSI = ISEC2(2)*ISEC2(3)
      CALL JMEMHAN(3,NPOINTI,NVALSI,1,IRET)
      IF( IRET.NE.0 ) THEN
        IF( LDEBUG )
     X    CALL INTLOG(JP_ERROR,'GB2GB: JMEMHAN failed for input',IRET)
        GOTO 900
      ENDIF
C
C     Get memory for output GRIB values.
C
      N_EW = ( (NEAST - NWEST) / OUT_EW ) + 1
      N_NS = ( (AREA(1) - AREA(3)) / OUT_NS ) + 1
      NVALSO = N_EW * N_NS
      CALL JMEMHAN(4,NPOINTO,NVALSO,1,IRET)
      IF( IRET.NE.0 ) THEN
        IF( LDEBUG )
     X    CALL INTLOG(JP_ERROR,'GB2GB: JMEMHAN failed for output',IRET)
        GOTO 900
      ENDIF
C
C     Unpack input GRIB values.
C
      IRET = 1
      CALL GRIBEX(ISEC0,ISEC1,ISEC2,PSEC2,ISEC3,PSEC3,ISEC4,
     X            ZSEC4I,NVALSI,INGRIB,INSIZE,IWORD,'D',IRET)
      IF( IRET.GT.0 ) THEN
        IF( LDEBUG )
     X    CALL INTLOG(JP_ERROR,'GB2GB: GRIBEX "D" option error',IRET)
        GOTO 900
      ENDIF
C
C     Select points for new grid.
C
      I_EW = (NWEST / ISEC2(9) ) + 1
      I_NS = ((90000-AREA(1)) / ISEC2(10) ) + 1
C
      NEXT = 1
      DO LOOPO = I_NS, (I_NS-1+N_NS*INC_NS),INC_NS
        DO LOOPI = I_EW, (I_EW-1+N_EW*INC_EW),INC_EW
          IPOINT = MOD(ISEC2(2)+LOOPI-1,ISEC2(2))+1
          ZSEC4O(NEXT) = ZSEC4I((LOOPO-1)*ISEC2(2)+IPOINT)
          NEXT = NEXT + 1
        ENDDO
      ENDDO
C
C ------------------------------------------------------------------
C     Section 4. Pack new grid into GRIB.
C ------------------------------------------------------------------
C
  400 CONTINUE
C
      ISEC2(2)  = N_EW
      ISEC2(3)  = N_NS
      ISEC2(4)  = OUTAREA(1)
      ISEC2(5)  = OUTAREA(2)
      ISEC2(7)  = OUTAREA(3)
      ISEC2(8)  = OUTAREA(4)
      ISEC2(9)  = OUT_EW
      ISEC2(10) = OUT_NS
C
      ISEC4(1)  = N_NS * N_EW
      IF( (NOACC.GT.0).AND.(NOACC.LT.30) ) ISEC4(2) = NOACC
C
C     PACKING specified can be second-order, simple or archive value
C
      IF( NOHFUNC.EQ.'K' ) THEN
        HFUNC = 'K'
        ISEC4(4)  = 64
        ISEC4(6)  = 16
        ISEC4(9)  = 32
        ISEC4(10) = 16
        ISEC4(12) = 8
        ISEC4(13) = 4
        ISEC4(14) = 0
        ISEC4(15) = -1
      ELSE IF( NOHFUNC.EQ.'S' ) THEN
        HFUNC = 'C'
        ISEC4(4)  = 0
        ISEC4(6)  = 0
      ELSE IF( NOHFUNC.EQ.'A' ) THEN
        IF( ISEC4(4).EQ.64 ) THEN
          HFUNC = 'K'
        ELSE
          HFUNC = 'C'
        ENDIF
      ENDIF
C
      IRET = 1
      CALL GRIBEX(ISEC0,ISEC1,ISEC2,PSEC2,ISEC3,PSEC3,ISEC4,
     X            ZSEC4O,NVALSO,OUTGRIB,OUTSIZE,IWORD,HFUNC,IRET)
      IF( IRET.GT.0 ) THEN
        IF( LDEBUG )
     X    CALL INTLOG(JP_ERROR,'GB2GB: GRIBEX "C" option error',IRET)
        GOTO 900
      ENDIF
      GB2GB = IWORD
C
C ------------------------------------------------------------------
C     Section 9. Return.
C ------------------------------------------------------------------
C
  900 CONTINUE
C
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      LOGICAL FUNCTION PRECIP()
C
C---->
C**** PRECIP
C
C     Purpose
C     -------
C
C     Determines whether or not the current field is to be
C     considered for 'precipitation' treatment.
C
C
C     Interface
C     ---------
C
C     LPRECIP = PRECIP()
C
C     Input
C     -----
C
C     None
C
C
C     Output
C     ------
C
C     Function returns .TRUE. if the field is to be treated as
C     precipitation.
C
C
C     Method
C     ------
C
C     Uses a set of hardcoded rules.
C
C
C     Externals
C     ---------
C
C     INTLOG  - Logs messages
C
C     Uses common blocks nifld.common and nofld.common.
C
C
C     Author
C     ------
C
C     J.D.Chambers     ECMWF     April 2001
C
C----<
C
      IMPLICIT NONE
C
#include "parim.h"
#include "nifld.common"
#include "nofld.common"
C
C     Local variables
C
      LOGICAL LIKELY
C
C     -----------------------------------------------------------------|
C*    Section 1. Initialise
C     -----------------------------------------------------------------|
C
  100 CONTINUE
C
C     If 'useprecip' has been forced to 'yes' ...
C
      IF( LPRECSET ) THEN
        PRECIP = LPREC
        GOTO 900
      ENDIF
C
C     WMO International table 001 for meteorological parameters
C
      IF ( NITABLE.EQ.1 ) THEN
        LIKELY = ( NIPARAM.EQ.61 ).OR.
     X           ( NIPARAM.EQ.62 ).OR.
     X           ( NIPARAM.EQ.63 ).OR.
     X           ( NIPARAM.EQ.64 ).OR.
     X           ( NIPARAM.EQ.65)
C
C     ECMWF local code table 128 for meteorological parameters
C
      ELSEIF ( (NITABLE.EQ.128).OR.(NITABLE.EQ.129) ) THEN
        LIKELY = ( NIPARAM.EQ.142 ).OR.
     X           ( NIPARAM.EQ.143 ).OR.
     X           ( NIPARAM.EQ.144 ).OR.
     X           ( NIPARAM.EQ.228 ).OR.
     X           ( NIPARAM.EQ.239 ).OR.
     X           ( NIPARAM.EQ.240 )
      ELSE
        LIKELY = .FALSE.
      ENDIF
C
      IF( .NOT.LIKELY ) THEN
        PRECIP = .FALSE.
        GOTO 900
      ENDIF
C
C     -----------------------------------------------------------------|
C*    Section 2. Work through the special cases
C     -----------------------------------------------------------------|
C
  200 CONTINUE
C
C     Monthly forecast means using ECMWF local definition 16
C
      IF( NILOCAL.EQ.16 ) THEN
        PRECIP = .FALSE.
        GOTO 900
      ENDIF
C
C     Extreme forecast index using ECMWF local definition 19
C
      IF( NILOCAL.EQ.19 ) THEN
        PRECIP = .FALSE.
        GOTO 900
      ENDIF
C
C     Coupled Atmospheric, Wave and Ocean models (with hindcast support)
C     using ECMWF local definition 23
C
      IF( NILOCAL.EQ.23 ) THEN
        PRECIP = .FALSE.
        GOTO 900
      ENDIF
C
C     ERA fields using code table 160
C
      IF( NITABLE.EQ.160 ) THEN
        PRECIP = .FALSE.
        GOTO 900
      ENDIF
C
      PRECIP = .TRUE.
C
C     -----------------------------------------------------------------|
C*    Section 9.   Return
C     -----------------------------------------------------------------|
C
  900 CONTINUE
C
      IF( .NOT.PRECIP ) THEN
        CALL INTLOG(JP_DEBUG,
     X    'PRECIP: Do not handle field as precipitation', JPQUIET)
      ELSE
        CALL INTLOG(JP_DEBUG,
     X    'PRECIP: Handle field as precipitation', JPQUIET)
      ENDIF
C
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C


      SUBROUTINE UNBKIN (KUNIT,KARRAY,KINLEN,KOUTLEN,KEOF,KRET)
C
C---->
C**** UNBKIN - Read a record from a pure binary file.
C
C     Purpose.
C     --------
C
C           Provides standard interface to read unblocked COS
C           files or UNICOS pure binary files.
C
C           Read next record from a pure binary file
C           and return in given array to calling routine.
C
C**   Interface.
C     ----------
C
C           CALL UNBKIN (KUNIT,KARRAY,KINLEN,KOUTLEN,KEOF,KRET)
C
C           INTEGER    K.
C           REAL       P.
C           LOGICAL    O.
C           CHARACTER  H.
C
C               Input parameters.
C               -----------------
C
C               KUNIT      - Fortran unit number of file to be read.
C                            1 to 99.
C
C               KARRAY     - Array to receive record.
C
C               KINLEN     - Length of this array, in words.
C
C               KOUTLEN    - Length of record to be read (in words)
C                            If this is 0 the length of the record is
C                            assumed to be in the first word of the
C                            record. This is the case for MARS data
C                            in unpacked format.
C
C               KEOF       - 0, If not last read from this file.
C                            1, Last read to be made from this file.
C
C                            Normally this will be 0, but if the
C                            same unit number is used later for
C                            another file, and end-of-file was not
C                            reached on the first one, a misread
C                            will occur, unless KEOF is set to 1 on
C                            the last read from the first file.
C
C               KRET       - 0, Routine to abort if error encountered.
C                            1, Return to calling routine even if error.
C
C                            Adding 100 to KRET will add debug printout
C                            eg values of input and output parameters.
C
C                            Valid values for KRET are thus 0, 1, 100
C                            or 101.
C
C               Output parameters.
C               ------------------
C
C               KOUTLEN    - Length of record read, in words.
C
C               KEOF       - 0, If no end of file detected.
C                            1, End of file detected.
C
C               KRET       - Return code.
C                            0, No error encountered.
C                            1, Read error.
C                            2, Not used.
C                            3, Not used.
C                            4, Not used.
C                            5, No data transferred because user's array
C                               is smaller than the record length.
C                            6, Maximum number of files opened for read
C                               by user program exceeded.
C                            7, Error detected in parameters.
C                            8, Not used.
C                            9, Not used.
C                           10, End of file encountered before end of
C                               record.
C
C     Method.
C     -------
C
C           Data is read in 512 word blocks. The length of each
C           record is given in the first word (or as input parameter)
C           and enough blocks then read to complete the record, which
C           is returned to the user. Any remaining words are kept to
C           use as the start of the next record on the next read.
C
C           An array of Fortran numbers in use is kept, with a
C           corresponding array of pointers to the last part of
C           data read from each one. A similar array keeps end of file
C           status for each file. When the last read has been
C           made from a file, these entries are reset to 0.
C
C           If an error is encountered, an error message is printed.
C
C     Externals.
C     ----------
C
C           None.
C
C     Reference.
C     ----------
C
C           None.
C
C     Comments.
C     ---------
C
C           Maximum number of files which can be handled in one
C           program is 20.
C
C           Routine contains Sections 0 to 3 and Section 9.
C
C     Author.
C     -------
C
C           J. Hennessy      ECMWF      25:06:90.
C
C     Modifications
C     --------------
C
C           None.
C
C     ----------------------------------------------------------------
C----<
C
C
C
C
C
C
C
C
C
C
C*    Section 0 . Definition of variables.
C     ----------------------------------------------------------------
C
      IMPLICIT LOGICAL     ( L, O, G )
      IMPLICIT CHARACTER*8 ( C, H, Y )
      IMPLICIT INTEGER     ( I, J, K, M, N )
C
      PARAMETER (JPBLOK=512)
      PARAMETER (JPFILS= 20)
C
      DIMENSION KARRAY(KINLEN)
      DIMENSION INBUFF(JPFILS*JPBLOK)
      DIMENSION ISTART(JPFILS)
      DIMENSION IFTNOS(JPFILS)
      DIMENSION IATEOF(JPFILS)
C
      DATA ISTART /JPFILS*0/
      DATA IFTNOS /JPFILS*0/
      DATA IATEOF /JPFILS*0/
C
      SAVE INBUFF
      SAVE ISTART
      SAVE IFTNOS
      SAVE IATEOF
C
C     ----------------------------------------------------------------
C
C
C
C
C
C
C
C
C
C*    Section 1 . Check parameters. Set initial values.
C     ----------------------------------------------------------------
C
 1000 CONTINUE
C
C     Set print switch, if required.
C
      IF (KRET.GE.100)
     C   THEN
             KPR = 1
         ELSE
             KPR = 0
         ENDIF
C
C     Print input parameters, if required.
C
      IF (KPR.EQ.1)
     C   THEN
             WRITE (*,*) 'UNBKIN : Section 1.'
             WRITE (*,*) '         Input values used -'
             WRITE (*,9904) KUNIT
             WRITE (*,9905) KINLEN
             WRITE (*,9906) KRET
             WRITE (*,9908) KEOF
         ENDIF
C
C     Check input parameters.
C
      IRET = 0
      IF (KRET.GE.100) KRET = KRET - 100
C
C     Invalid value given for return code.
C
      IF (KRET.LT.0.OR.KRET.GT.1)
     C   THEN
             IRET = 7
             WRITE (*,9910) KRET
             GO TO 9000
         ENDIF
C
C     Fortran unit numbers must be between 1 and 99 inclusive.
C
      IF (KUNIT.LT.1.OR.KUNIT.GT.99)
     C   THEN
             IRET = 7
             WRITE (*,9911) KUNIT
             GO TO 9000
         ENDIF
C
C     Keep last read indicator.
C
      IEOF = KEOF
      KEOF = 0
C
C     Locate Fortran unit number in list of active numbers.
C
      DO 1010 J1010=1,JPFILS
         IF (IFTNOS(J1010).EQ.KUNIT)
     C      THEN
                IB = ISTART(J1010)
                IZ = IATEOF(J1010)
                IP = J1010
                GO TO 1030
            ENDIF
 1010 CONTINUE
C
C     None found, so first time in. Set table entries.
C
      DO 1020 J1020=1,JPFILS
         IF (IFTNOS(J1020).EQ.0)
     C      THEN
                IB = 0
                IZ = 0
                IP = J1020
                IFTNOS(J1020) = KUNIT
                GO TO 1030
            ENDIF
 1020 CONTINUE
C
C     No table entry free. Maximum number of files exceeded.
C
      IRET = 6
      WRITE (*,9912) JPFILS
      GO TO 9000
C
C     Set pointer to array holding last part of data read.
C
 1030 CONTINUE
C
      IPR = IP
      IP  =  (IP-1) * JPBLOK + 1
C
C     INBUFF(IP) to INBUFF(IP+IB) are the remaining words of the
C     last block read.
C
C     ----------------------------------------------------------------
C
C
C
C
C
C
C
C
C
C*    Section 2 . Ensure enough data is read to include a full record.
C     ----------------------------------------------------------------
C
 2000 CONTINUE
C
      IF (KPR.EQ.1)
     C   THEN
             WRITE (*,*) 'UNBKIN : Section 2.'
             WRITE (*,9909) IPR , IP , IB
         ENDIF
C
C     Copy remainder of last block read to user array.
C
C     KARRAY   1      IB
C              !       !
C              =========
C
      DO 2025 J2025 = 1,IB
         KARRAY(J2025) = INBUFF(IP+J2025-1)
 2025 CONTINUE
C
C     Fill remainder of array with zeroes.
C
      DO 2050 J2050 = IB+1,KINLEN
         KARRAY(J2050) = 0
 2050 CONTINUE
C
C
C*    Get length of record to be read.   .
C
      IF (KOUTLEN.NE.0)
     C   THEN
             ILENW = KOUTLEN
         ELSE
             ILENW = KARRAY(1)
         ENDIF
C
C     Force a block to be read if no data remains from previous
C     read.
C
      IF (IB.EQ.0)            ILENW = JPBLOK + 1
C
C     Force a block to be read if data length is 0 to check for
C     end-of-file.
C
      IF (ILENW.EQ.0)         ILENW = JPBLOK + 1
C
C     Force a block to be read if the record Length is
C     greater than the length of data already read.
C
      IF (ILENW.GT.IB)        ILENW = JPBLOK + 1
C
C     No data is read if full record has already been read.
C
C     No data is read if an end-of-file has been
C     encountered on previous read. Even if end-of-file has been
C     reached there may be short record(s) remaining in the
C     last block read.
C
C     KARRAY   1      IB            IE
C              !       !             !
C              =======================
C
C     Read next block if necessary to get full record.
C
      IF (IZ.EQ.0.AND.ILENW.GT.JPBLOK)
     C   THEN
             IE = IB + JPBLOK
             BUFFER IN (KUNIT,0) (KARRAY(IB+1),KARRAY(IE))
             IF (UNIT(KUNIT)) 2300,2200,2100
         ELSE
             IE = IB
             GO TO 2300
         ENDIF
C
 2100 CONTINUE
C
C     Read error, go to section 9.
C
      IRET = 1
      WRITE (*,9913) KUNIT
      GO TO 9000
C
 2200 CONTINUE
C
C     End of file read, so set flag. Last block read may still
C     contain short records.
C
      IZ          = 1
      IATEOF(IPR) = IZ
C
 2300 CONTINUE
C
C*    Get length of record.
C
      IF (KOUTLEN.NE.0)
     C   THEN
             ILENW = KOUTLEN
C
C            If the record length has been set by user, and
C            end-of-file has been encountered, force end-of-file
C            processing if record length is greater than remaining
C            contents of the buffer.
C
             IF(IZ.EQ.1.AND.ILENW.GT.IB) ILENW = 0
C
         ELSE
             ILENW = KARRAY(1)
         ENDIF
C
C        If end-of-file has been encountered and record
C        length is 0 no further record remains in the buffer.
C
         IF (IZ.EQ.1.AND.ILENW.EQ.0)
     C      THEN
                KEOF = 1
                IFTNOS(IPR) = 0
                ISTART(IPR) = 0
                IATEOF(IPR) = 0
                GO TO 9000
            ENDIF
C
      IF (KPR.EQ.1) WRITE (*,9902) ILENW
C
C     Ensure that user's array is large enough.
C
      IF (KINLEN.LT.ILENW)
     C   THEN
             WRITE (*,9917) KINLEN , ILENW
             IRET = 5
             GO TO 9000
         ENDIF
C
C     ----------------------------------------------------------------
C
C
C
C
C
C
C
C
C
C*    Section 3 . Read enough blocks to complete current record.
C     ----------------------------------------------------------------
C
 3000 CONTINUE
C
      IF (KPR.EQ.1) WRITE (*,*) 'UNBKIN : Section 3.'
C
C
C     If data already read does not contain a full record,
C     read enough blocks to include the next full record.
C     Read last block into INBUFF, preceding ones into user's array.
C
      IF (IE.LT.ILENW)
     C   THEN
C
C            KARRAY   1      IB            IE                ILENW
C                     !       !             !                    !
C                     ==============================================
C                                                                  !
C                                                                ILENR
             IB    = IE
             ILENR = ILENW - IE
C
C            If second block is last block, do not read into user array.
C
             IF (ILENR.LE.JPBLOK) GO TO 3010
C
             IDIFF = MOD (ILENR,JPBLOK)
             IF (IDIFF.NE.0)
     C          THEN
                    ILENR = ILENR - IDIFF
                ELSE
                    ILENR = ILENR - JPBLOK
                ENDIF
             IE    = IE + ILENR
             BUFFER IN (KUNIT,0) (KARRAY(IB+1),KARRAY(IE))
             IF (UNIT(KUNIT)) 3010,3700,2100
C
 3010 CONTINUE
C
             BUFFER IN (KUNIT,0) (INBUFF(IP),INBUFF(IP+JPBLOK-1))
             IF (UNIT(KUNIT)) 3100,3700,2100
C
C            Put end of field in user's array.
C
 3100        CONTINUE
C
             IEND = ILENW - IE
             DO 3200 J3200=1,IEND
                KARRAY(IE+J3200) = INBUFF(IP+J3200-1)
 3200        CONTINUE
C
C            Move remainder of block to front of buffer.
C
             INTER = JPBLOK - IEND
             DO 3300 J3300=1,INTER
                INBUFF(IP+J3300-1) = INBUFF(IP+J3300-1+IEND)
 3300        CONTINUE
C
C
         ELSE
C
C            Check for premature end-of-file ie record
C            longer than data already read.
C
C            KARRAY   1        IB          ILENW
C                     !         !    EOF    !
C                     ===========
C
C===         IF (IZ.EQ.1.AND.ILENW.GT.IB) GO TO 3700
C            RE-implement above line and remove next IF clause
C            when ECFILE clears its buffers before use.
C
             IF (IZ.EQ.1.AND.ILENW.GT.IB)
     C          THEN
                    KEOF = 1
                    IFTNOS(IPR) = 0
                    ISTART(IPR) = 0
                    IATEOF(IPR) = 0
                    KOUTLEN     = 0
                    GO TO 9000
                 ENDIF
C
C            KARRAY   1           ILENW    IE
C                     !              !      !
C                     =======================
C
             INTER = IE - ILENW
             DO 3400 J3400=1,INTER
                INBUFF(IP+J3400-1) = KARRAY(ILENW+J3400)
 3400        CONTINUE
         ENDIF
C
      KOUTLEN = ILENW
      IB      = INTER
C
 3600 CONTINUE
C
C     Save pointer to start of next read area, unless last read.
C
      IF (IEOF.EQ.1)
     C   THEN
             IFTNOS(IPR) = 0
             ISTART(IPR) = 0
             IATEOF(IPR) = 0
         ELSE
             ISTART(IPR) = IB
             IATEOF(IPR) = IZ
         ENDIF
C
      GO TO 9000
C
C     End-of-file before end of record.
C
 3700 CONTINUE
C
      IRET = 10
      WRITE (*,9918)
C
C    ----------------------------------------------------------------
C
C
C
C
C
C
C
C
C
C*    Section 9 . Return to calling routine. Format statements.
C     ------------------------------------------------------------------
C
 9000 CONTINUE
C
      IF (KPR.EQ.1)
     C THEN
           WRITE (*,*) 'UNBKIN : Section 9.'
           WRITE (*,*) '         Output values set -'
           WRITE (*,9907) KOUTLEN
           WRITE (*,9908) KEOF
           WRITE (*,9906) IRET
       ENDIF
C
C     Error encountered. Clear table entries, if any exist.
C     Abort if requested.
C
      IF (IRET.NE.0.AND.IRET.NE.2)
     C   THEN
             IF (IRET.NE.6)
     C          THEN
                    IFTNOS(IPR) = 0
                    IATEOF(IPR) = 0
                    ISTART(IPR) = 0
                ENDIF
             WRITE (*,9903) IRET
             IF (KRET.EQ.0) CALL ABORT
         ENDIF
C
      KRET = IRET
C
      RETURN
C
C
 9902 FORMAT (1H ,'UNBKIN : Record length (words) = ',I8)
C
 9903 FORMAT (1H ,'UNBKIN : Return code = ',I6)
C
 9904 FORMAT (1H ,9X,'KUNIT   = ',I6)
C
 9905 FORMAT (1H ,9X,'KINLEN  = ',I6)
C
 9906 FORMAT (1H ,9X,'KRET    = ',I6)
C
 9907 FORMAT (1H ,9X,'KOUTLEN = ',I6)
C
 9908 FORMAT (1H ,9X,'KEOF    = ',I6)
C
 9909 FORMAT (1H ,'IPR = ',I4,'  IP = ',I8,'  IB = ',I8)
C
 9910 FORMAT (1H ,'UNBKIN : KRET on input is ',I4,
     C        '. Valid values are 0,1,10,11,100,110,101 or 111.')
 9911 FORMAT (1H ,'UNBKIN : KUNIT on input is ',I4,
     C        '. Valid values are 1 to 99.')
 9912 FORMAT (1H ,'UNBKIN : Maximum number of files (',I2,') exceeded.')
C
 9913 FORMAT (1H ,'UNBKIN : Error in reading file number ',I3)
C
 9917 FORMAT (1H ,'UNBKIN : Array length is ',I6, 'words, but record ',
     C        'length is ',I6,' words.')
 9918 FORMAT (1H ,'UNBKIN : End-of-file reached before end of record.')
C
C
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities
C granted to it by virtue of its status as an intergovernmental organisation
C nor does it submit to any jurisdiction.
C


      SUBROUTINE LNGBCR (KARRAY,KLENB)
C
C---->
C**** LNGBCR - Calculate or extract length of GRIB field on Cray.
C
C     Purpose.
C     --------
C
C           Calculate or extract length of GRIB field.
C
C**   Interface.
C     ----------
C
C           CALL LNGBCR (KARRAY,KLENB)
C
C           INTEGER    K.
C           REAL       P.
C           LOGICAL    O.
C           CHARACTER  H.
C
C               Input parameters.
C               -----------------
C
C               KARRAY     - Array containing GRIB field.
C
C               Output parameters.
C               ------------------
C
C               KLENB      - Length of GRIB field in bytes.
C
C     Method.
C     -------
C
C           The length of each GRIB encoded field is calculated
C           from the GRIB header Sections for Experimental Edition
C           or Edition 0 of GRIB code. For GRIB Edition 1 the length
C           is extracted from bytes 5-7 of section 0.
C
C     Externals.
C     ----------
C
C           UNPACK
C
C     Reference.
C     ----------
C
C           WMO GRIB Code Documentation.
C
C           Research Department Documentation for description of
C           BUDG and TIDE Pseudo-Grib messages.
C
C     Comments.
C     ---------
C
C           ECMWF Pseudo-Grib fields (BUDG and TIDE)are handled by this
C           routine.
C
C           Routine contains Sections 0 to 1 and Section 9.
C
C     Author.
C     -------
C
C           J. Hennessy      ECMWF      30:04:90.
C
C     Modifications.
C     --------------
C
C           J. Hennessy      ECMWF      31:05:90.
C           Increase array size to accommodate vertical level
C           co-ordinates of model level data. Add array size check.
C
C           J. Hennessy      ECMWF      13:11:90.
C           Increase array size to accommodate bit maps.
C
C           J. Hennessy      ECMWF      16:05:91.
C           Modified to handle GRIB Edition 1.
C
C           J. Hennessy      ECMWF      23:09:92.
C           Washington SST made fixed length for GRIB Edition 1.
C
C     ----------------------------------------------------------------
C----<
C
C
C
C
C
C
C
C*    Section 0 . Definition of variables.
C     ----------------------------------------------------------------
C
      IMPLICIT LOGICAL     ( L, O, G )
      IMPLICIT CHARACTER*8 ( C, H, Y )
      IMPLICIT INTEGER     ( I, J, K, M, N )
C
      PARAMETER (JPBYT=5440)
C
      DIMENSION KARRAY(*)
      DIMENSION ISCATR(JPBYT)
C
C     ----------------------------------------------------------------
C
C
C
C
C
C
C
C
C
C
C*    Section 1 . Unpack the data.
C     ----------------------------------------------------------------
C
  100 CONTINUE
C
C     Unpack first JPBYT octets of data, 1 octet per word.
C
      CALL UNPACK (KARRAY,8,ISCATR,JPBYT)
C
C     ----------------------------------------------------------------
C
C
C
C
C
C
C
C
C
C
C*    Section 2 . Identify GRIB Edition of data.
C     ----------------------------------------------------------------
C
  200 CONTINUE
C
C     In the Experimental GRIB Edition, octet 8 is a flag field
C     and can have a valid value of 0, 1, 2 or 3.
C     In GRIB Edition 0, octet 8 is reserved and set to 0.
C     In GRIB Edition 1, the edition number is in octet 8.
C
C     However, Edition 0 of the code has a fixed length of 24 octets,
C     included in the message, for section 1, so if the value
C     contained in octets 5-7 is 24, and that in octet 8 is 0, it
C     is safe to assume Edition 0 of the GRIB code.
C
      IF (ISCATR(5).EQ.0.AND.ISCATR(6).EQ.0.AND.ISCATR(7).EQ.24.
     C              AND.ISCATR(8).EQ.0)
     C   THEN
             ISNEW = 1
             GO TO 400
         ENDIF
C
C     In the Experimental GRIB Edition, octets 23 and 24 are reserved
C     and set to 0. These octets in Edition 1 are the month and the day,
C     and must be non-zero.
C
      IF (ISCATR(22).EQ.0.AND.ISCATR(23).EQ.0)
     C   THEN
             ISNEW = 0
             GO TO 400
         ENDIF
C
C     ----------------------------------------------------------------
C
C
C
C
C
C
C
C
C
C
C*    Section 3 . Extract GRIB length from Edition 1 data.
C     ----------------------------------------------------------------
C
  300 CONTINUE
C
C     Edition number is 1, so extract length from octets 5-7.
C
      KLENB = SHIFTL(ISCATR(5),16) + SHIFTL(ISCATR(6),8) + ISCATR(7)
      IF (ISCATR(13).EQ.7.AND.ISCATR(17).EQ.139) KLENB = 34920
      GO TO 900
C
C     ----------------------------------------------------------------
C
C
C
C
C
C
C
C
C
C
C*    Section 4 . Calculate GRIB length.
C     ----------------------------------------------------------------
C
  400 CONTINUE
C
C     NMC Washington Sea Surface Temperature analysis is a global
C     field made in ECMWF from 8 component fields received on the GTS
C     and coded in GRIB using ECMWF field code 139. This field
C     contains a bit map and varies in length. For archiving purposes
C     a fixed length was used (34920) bytes. NMC has code figure 7
C     as centre of origin. Experimental Edition of GRIB was never
C     used for this product.
C
      IF (ISNEW.EQ.1.AND.ISCATR(9).EQ.7.AND.ISCATR(13).EQ.139)
     C   THEN
             KLENB = 34920
             GO TO 900
         ENDIF
C
C     Count of octets in Section 0.
C
      KLENB = 4
C
C     Count of octets in Section 1 - code edition dependent.
C
      KLENB = KLENB + 20 + (ISNEW*4)
C
C     Check if optional Section 2 is present.
C
      IFLAG = ISCATR(8+4*ISNEW)
      INC   = 0
      IF (ISNEW.EQ.0)
     C   THEN
             IF (IFLAG.EQ.1.OR.IFLAG.EQ.3) INC = 1
         ELSE
             IF (IFLAG.EQ.128.OR.IFLAG.EQ.192) INC = 1
         ENDIF
C
      IF (INC.EQ.1)
     C        KLENB = KLENB + SHIFTL(ISCATR(KLENB+1),16) +
     C                SHIFTL(ISCATR(KLENB+2),8) + ISCATR(KLENB+3)
C
C     Check on array length.
C
      IF (KLENB.GT.JPBYT)
     C   THEN
             WRITE (*,9001)
             CALL ABORT
         ENDIF
C
C     Check if optional Section 3 is present.
C
      INC   = 0
      IF (ISNEW.EQ.0)
     C   THEN
             IF (IFLAG.EQ.2.OR.IFLAG.EQ.3) INC = 1
         ELSE
             IF (IFLAG.EQ.64.OR.IFLAG.EQ.192) INC = 1
         ENDIF
C
      IF (INC.EQ.1)
     C        KLENB = KLENB + SHIFTL(ISCATR(KLENB+1),16) +
     C                SHIFTL(ISCATR(KLENB+2),8) + ISCATR(KLENB+3)
C
C     Check on array length.
C
      IF ((KLENB+3).GT.JPBYT)
     C   THEN
             WRITE (*,9001)
             CALL ABORT
         ENDIF
C
C     Length of binary data Section 4.
C
      KLENB = KLENB + SHIFTL(ISCATR(KLENB+1),16) +
     C                SHIFTL(ISCATR(KLENB+2),8) + ISCATR(KLENB+3)
C
C     Length of Section 5.
C
      KLENB = KLENB + 4
C
C    ----------------------------------------------------------------
C
C
C
C
C
C
C
C
C
C*    Section 9 . Return to calling routine.
C     ------------------------------------------------------------------
C
  900 CONTINUE
C
 9001 FORMAT (1H ,'LNGBCR : Array ISCATR limits exceeded.')
C
      RETURN
C
      END

C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE DTABLE(YNAME,KERR)
C
C**** *DTABLE*
C
C
C     PURPOSE.
C     --------
C          THE MAIN PURPOSE OF THIS PROGRAMME IS TO CREATE WORKING
C          TABLE OF SEQUENCE DESCRIPTORS FOR *BUFR* DECODING.
C
C**   INTERFACE.
C     ----------
C          NONE.
C
C
C
C
C     *METHOD.
C      -------
C          NONE.
C
C
C
C     EXTERNALS.
C     ----------
C          NONE.
C
C
C
C
C     REFERENCE.
C     ----------
C
C          BINARY UNIVERSAL FORM FOR DATA REPRESENTATION, *FM 94 BUFR*.
C
C          J.K.GIBSON AND *M.DRAGOSAVAC,1987:* DECODING *DATA *REPRESENTATION
C                          *FM 94 BUFR*,*TECHNICAL *MEMORANDUM *NO.
C
C          J.K.GIBSON,1986:*EMOS 2 - *STANDARDS FOR SOFTWARE DEVELOPMENT
C                           AND MAINTANANCE *,*TECHICAL MEMORANDUM *NO.
C                           *ECMWF*.
C
C
C     AUTHOR.
C     -------
C
C          M. DRAGOSAVAC       *ECMWF*       JANUARY 1991.
C
C
C     MODIFICATIONS.
C     --------------
C
C          NONE.
C
C
      IMPLICIT LOGICAL(L,O,G), CHARACTER*8(C,H,Y)
C
#     include "parameter.F"
#     include "bcomwork.F"
#     include "bcomtab.F"
#     include "bcomtabc.F"
#     include "bcomct.F"
#     include "bcomctc.F"
#     include "bcomroot.F"
#     include "bcomtabload.F"
#     include "bcomtabloadc.F"

C
      CHARACTER*64 CTABBEN,CCTABBEN
      CHARACTER*24 CTABBU,CCTABBU,CTABLE_LIST
      CHARACTER*120 YENTRY
      CHARACTER*256 YFNAME
      CHARACTER*(*) YNAME
      REAL*8 RVIND,EPS
C
C     ------------------------------------------------------------------
C*          1.   SET INITIAL CONSTANTS.
C                ----------------------
 100  CONTINUE
C
      KERR=0
      J  =0
      IST=1
      YFNAME=' '
C
      DO 101 I=1,JTAB
      NTABDTR(I)=999999
      NTABDL (I)=0
      NTABDST(I)=0
 101  CONTINUE
C
      DO 102 I=1,JTAB*20
      NTABDSQ(I)=0
 102  CONTINUE
C
      II=INDEX(YNAME,' ')
      II=II-1
      YFNAME=YNAME(1:II)
      II=INDEX(YFNAME,' ')
      II=II-1
      CALL GET_FREE_UNIT(IUNIT)
      OPEN(UNIT=IUNIT,iostat=ios,FILE=YFNAME(1:II),STATUS='OLD')
      IF(IOS.NE.0) THEN
         print*,'Open error on ',YFNAME(1:II)
         kerr=63
         return
      END IF
C
C     ------------------------------------------------------------------
C*          2.   READ IN TABLE D
C                ---------------
C
 200  CONTINUE
C
      READ(IUNIT,'(A)',IOSTAT=IOS,END=300) YENTRY
      IF(IOS.NE.0) THEN
         print*,'Read error ',ios
         kerr=8
         return
      END IF
C
      J=J+1
C
      IF(J.GT.JTAB) THEN
         PRINT*,' DIMENSION TOO SMALL J=',J
         KERR=64
         RETURN
      END IF 
C
C     ------------------------------------------------------------------
C*          2.1  SET ARRAYS FOR TABLE REFERENCE, DATA LENGTH,
C*               STARTING POINTER AND SEQUENCE DESCRIPTORS.
C
 210  CONTINUE
C
C
      READ(YENTRY,'(1X,I6,I3)') NTABDTR(J),NTABDL (J)
C
      IF(J.EQ.1) THEN
         IST=1
         NTABDST(J)=IST
      ELSE
         IST=IST + NTABDL(J-1)
         NTABDST(J)=IST
      END IF
C
      IF(NTABDL(J).GT.1) THEN
         READ(YENTRY,'(11X,I6)') NTABDSQ(IST)
         IIST=IST
C
         DO 220 JA=1,NTABDL(J)-1
         IIST=IIST+1
         READ(IUNIT,'(A)',END=300) YENTRY
         READ(YENTRY,'(11X,I6)') NTABDSQ(IIST)
 220     CONTINUE
C
      ELSE
         READ(YENTRY,'(11X,I6)') NTABDSQ(IST)
      END IF
C
C
C     WRITE(*,1000) NTABDTR(J),NTABDL(J),NTABDST(J),
C    1              (NTABDSQ(I),I=NTABDST(J),NTABDL(J)+NTABDST(J)-1)
C
C1000 FORMAT(1H ,I6,I3,1X,I6,1X,I6/ (18X,I6))
C
      GO TO 200
C
C     ------------------------------------------------------------------
 300  CONTINUE
C
      IF(NTT.EQ.JTMAX.AND.NTC.NE.0) THEN
         DO J=1,JTAB
            MTABDTR(J,NTC)=NTABDTR(J)
            MTABDL (J,NTC)=NTABDL(J)
            MTABDST(J,NTC)=NTABDST(J)
         END DO
         DO J=1,JTAB*20
            MTABDSQ(J,NTC)=NTABDSQ(J)
         END DO
      ELSE
         DO J=1,JTAB
            MTABDTR(J,NTT)=NTABDTR(J)
            MTABDL (J,NTT)=NTABDL(J)
            MTABDST(J,NTT)=NTABDST(J)
         END DO
         DO J=1,JTAB*20
            MTABDSQ(J,NTT)=NTABDSQ(J)
         END DO
      END IF
C
      CLOSE(IUNIT)
C
c     WRITE(*,'(1h )')
c     WRITE(*,'(1h ,a,i4)')'Total number of entries in Table D is ',j
C
      RETURN
C     -----------------------------------------------------------------
 400  CONTINUE
C
      RETURN
C
      END

C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      LOGICAL FUNCTION PRECIP()
C
C---->
C**** PRECIP
C
C     Purpose
C     -------
C
C     Determines whether or not the current field is to be
C     considered for 'precipitation' treatment.
C
C
C     Interface
C     ---------
C
C     LPRECIP = PRECIP()
C
C     Input
C     -----
C
C     None
C
C
C     Output
C     ------
C
C     Function returns .TRUE. if the field is to be treated as
C     precipitation.
C
C
C     Method
C     ------
C
C     Uses a set of hardcoded rules.
C
C
C     Externals
C     ---------
C
C     INTLOG  - Logs messages
C
C     Uses common blocks nifld.common and nofld.common.
C
C
C     Author
C     ------
C
C     J.D.Chambers     ECMWF     April 2001
C
C----<
C
      IMPLICIT NONE
C
#include "parim.h"
#include "nifld.common"
#include "nofld.common"
C
C     Local variables
C
      LOGICAL LIKELY
C
C     -----------------------------------------------------------------|
C*    Section 1. Initialise
C     -----------------------------------------------------------------|
C
  100 CONTINUE
C
C     If 'useprecip' has been forced to 'yes' ...
C
      IF( LPRECSET ) THEN
        PRECIP = LPREC
        GOTO 900
      ENDIF
C
C     WMO International table 001 for meteorological parameters
C
      IF ( NITABLE.EQ.1 ) THEN
        LIKELY = ( NIPARAM.EQ.61 ).OR.
     X           ( NIPARAM.EQ.62 ).OR.
     X           ( NIPARAM.EQ.63 ).OR.
     X           ( NIPARAM.EQ.64 ).OR.
     X           ( NIPARAM.EQ.65)
C
C     ECMWF local code table 128 for meteorological parameters
C
      ELSEIF ( (NITABLE.EQ.128).OR.(NITABLE.EQ.129) ) THEN
        LIKELY = ( NIPARAM.EQ.142 ).OR.
     X           ( NIPARAM.EQ.143 ).OR.
     X           ( NIPARAM.EQ.144 ).OR.
     X           ( NIPARAM.EQ.228 ).OR.
     X           ( NIPARAM.EQ.239 ).OR.
     X           ( NIPARAM.EQ.240 )
      ELSE
        LIKELY = .FALSE.
      ENDIF
C
      IF( .NOT.LIKELY ) THEN
        PRECIP = .FALSE.
        GOTO 900
      ENDIF
C
C     -----------------------------------------------------------------|
C*    Section 2. Work through the special cases
C     -----------------------------------------------------------------|
C
  200 CONTINUE
C
C     Monthly forecast means using ECMWF local definition 16
C
      IF( NILOCAL.EQ.16 ) THEN
        PRECIP = .FALSE.
        GOTO 900
      ENDIF
C
C     Extreme forecast index using ECMWF local definition 19
C
      IF( NILOCAL.EQ.19 ) THEN
        PRECIP = .FALSE.
        GOTO 900
      ENDIF
C
C     Coupled Atmospheric, Wave and Ocean models (with hindcast support)
C     using ECMWF local definition 23
C
      IF( NILOCAL.EQ.23 ) THEN
        PRECIP = .FALSE.
        GOTO 900
      ENDIF
C
C     ERA fields using code table 160
C
      IF( NITABLE.EQ.160 ) THEN
        PRECIP = .FALSE.
        GOTO 900
      ENDIF
C
      PRECIP = .TRUE.
C
C     -----------------------------------------------------------------|
C*    Section 9.   Return
C     -----------------------------------------------------------------|
C
  900 CONTINUE
C
      IF( .NOT.PRECIP ) THEN
        CALL INTLOG(JP_DEBUG,
     X    'PRECIP: Do not handle field as precipitation', JPQUIET)
      ELSE
        CALL INTLOG(JP_DEBUG,
     X    'PRECIP: Handle field as precipitation', JPQUIET)
      ENDIF
C
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE HWTS12
     X  (KLEN,KSCHEME,KLA,PDLAT,PLATIN,PDLO0,PDLO1,PDLO2,PDLO3,NEIGH,
     X   PWTS)
C
C---->
C**** HWTS12
C
C     Purpose
C     -------
C
C     This routine accepts a vector of points and calculates the
C     interpolation weightings for each point suitable for the
C     horizontal interpolation.
C
C
C     Interface
C     ---------
C
C     CALL HWTS12
C    X  (KLEN,KSCHEME,KLA,PDLAT,PLATIN,PDLO0,PDLO1,PDLO2,PDLO3,NEIGH,
C    X   PWTS)
C
C
C     Input parameters
C     ----------------
C
C     KLEN    - Number of points along the vector.
C     KSCHEME - Flag showing interpolation scheme to use for point
C               0 = 12-point
C               1 = 4-point bilinear
C               2 = nearest neighbour
C     KLA     - Latitude number in original field of latitude north of
C               point in the vector.
C     PDLAT   - Meridian linear weight.
C     PLATIN  - Gaussian latitudes.
C     PDLO0   - Zonal linear weight for the latitude of point 5.
C     PDLO1   - Zonal linear weight for the latitude of point 1.
C     PDLO2   - Zonal linear weight for the latitude of point 3.
C     PDLO3   - Zonal linear weight for the latitude of point 11.
C     NEIGH   - List of indices in the original field of neighbouring
C               point values.
C
C
C     Output parameters
C     -----------------
C
C     PWTS   - Weights for interpolation.
C
C     Common block usage
C     ------------------
C
C     None.
C
C
C     Method
C     ------
C
C     Numbering of the points (I is the interpolation point):
C
C                   13       5       6      14
C
C                    7       1       2       8
C                               (I)
C                    9       3       4      10
C
C                   15      11      12      16
C
C
C     Externals
C     ---------
C
C     None.
C
C
C     Reference
C     ---------
C
C     ECMWF Meteorological Bulletin M1.6/7
C     IFS Documentation
C     Part VI: Technical and Computational Procedures (CY21R4)
C     March 2000
C     Section 2.3
C
C
C     Comments
C     --------
C
C     None.
C
C
C     Author
C     ------
C
C     J.D.Chambers      ECMWF      January 2001
C
C
C     Modifications
C     -------------
C
C     None.
C
C----<
C     -----------------------------------------------------------------|
C*    Definition of variables.
C     -----------------------------------------------------------------|
C
      IMPLICIT NONE
C
C     Parameters
C
      INTEGER JP12PT, JP4PT, JPNEARN
      PARAMETER (JP12PT  = 0)
      PARAMETER (JP4PT   = 1)
      PARAMETER (JPNEARN = 2)
C
C     Function arguments
C
      INTEGER KLEN, KSCHEME(KLEN), KLA(KLEN)
      REAL PDLAT(KLEN), PLATIN(*)
      REAL PDLO0(KLEN), PDLO1(KLEN), PDLO2(KLEN), PDLO3(KLEN)
      INTEGER NEIGH(12,*)
      REAL PWTS(12,*)
C
C     Local variables
C
      INTEGER NEXT, LOOP
      INTEGER ILA0G, ILA1G, ILA2G, ILA3G
      REAL ZDLAT, ZDY, ZDY10, ZDY21, ZDY32
      REAL ZDLO1, ZDLO2, ZWXN0, ZWXN1, ZWXN2, ZWXN3
      REAL ZWY0, ZWY1, ZWY2, ZWY3
      REAL ZWXNN, ZCXNN, ZWXSS, ZCXSS
      REAL ZWXS0, ZWXS1, ZWXS2, ZWXS3
C
C     Inline functions
C
      REAL ALPHA, F2, F3, F4
C
      F2(ALPHA) = ((ALPHA+1.0) * (ALPHA-2.0) * (ALPHA-1.0))/2.0
C
      F3(ALPHA) = - ((ALPHA+1.0) * (ALPHA-2.0) * ALPHA)/2.0
C
      F4(ALPHA) = (ALPHA * (ALPHA-1.0) * (ALPHA+1.0))/6.0
C
C     -----------------------------------------------------------------|
C     Process each point in the vector.
C     -----------------------------------------------------------------|
C
      DO NEXT = 1,KLEN
C
C       Clear the weights for the current point
C
        DO LOOP = 1, 12
          PWTS(LOOP,NEXT) = 0.0
        ENDDO
C
C       Use appropriate interpolation scheme for the current point
C
C     -----------------------------------------------------------------|
C       Nearest point selection
C     -----------------------------------------------------------------|
C
        IF( KSCHEME(NEXT).EQ.JPNEARN ) THEN
C
          DO LOOP = 1, 4
            IF( NEIGH(LOOP,NEXT).NE.0 ) PWTS(LOOP,NEXT) = 1.0
          ENDDO
C
          GOTO 900
C
C     -----------------------------------------------------------------|
C       4-point interpolation
C     -----------------------------------------------------------------|
C
        ELSE IF( KSCHEME(NEXT).EQ.JP4PT ) THEN
C
          PWTS(1,NEXT) = (1.0 - PDLO2(NEXT)) * (1.0 - PDLAT(NEXT))
          PWTS(2,NEXT) = PDLO2(NEXT) * (1.0 - PDLAT(NEXT))
          PWTS(3,NEXT) = (1.0 - PDLO1(NEXT)) * PDLAT(NEXT)
          PWTS(4,NEXT) = PDLO1(NEXT) * PDLAT(NEXT)
C
          GOTO 900
C
C     -----------------------------------------------------------------|
C       12-point interpolation
C     -----------------------------------------------------------------|
C
        ELSE
C
C         Setup latitude numbers for the 4 rows.
C
          ILA1G = KLA(NEXT)
          ILA0G = ILA1G - 1
          ILA2G = ILA1G + 1
          ILA3G = ILA1G + 2
C
C         Setup the weights between rows.
C
          ZDLAT = PDLAT(NEXT)
          ZDY   = ZDLAT * (PLATIN(ILA2G) - PLATIN(ILA1G))
          ZDY10 =          PLATIN(ILA1G) - PLATIN(ILA0G)
          ZDY21 =          PLATIN(ILA2G) - PLATIN(ILA1G)
          ZDY32 =          PLATIN(ILA3G) - PLATIN(ILA2G)
C
C     -----------------------------------------------------------------|
C         Polynomial in x-direction.
C     -----------------------------------------------------------------|
C
C         Northern parallel
C
          ZDLO1 = PDLO1(NEXT)
          ZWXN1 = F2(ZDLO1)
          ZWXN2 = F3(ZDLO1)
          ZWXN3 = F4(ZDLO1)
          ZWXN0 = 1.0 - ZWXN1 - ZWXN2 - ZWXN3
C
C         Southern parallel
C
          ZDLO2 = PDLO2(NEXT)
          ZWXS1 = F2(ZDLO2)
          ZWXS2 = F3(ZDLO2)
          ZWXS3 = F4(ZDLO2)
          ZWXS0 = 1.0 - ZWXS1 - ZWXS2 - ZWXS3
C
C     -----------------------------------------------------------------|
C         Polynomial in y-direction.
C     -----------------------------------------------------------------|
C
          ZWY3 = ((ZDY+ZDY10) * (ZDY) * (ZDY-ZDY21)) /
     X           ((ZDY10+ZDY21+ZDY32) * (ZDY21+ZDY32) * (ZDY32))
          ZWY2 = ((ZDY+ZDY10) * (ZDY) * (ZDY-ZDY21-ZDY32)) /
     X           ((ZDY10+ZDY21) * (ZDY21) * (-ZDY32))
          ZWY1 = ((ZDY+ZDY10) * (ZDY-ZDY21) * (ZDY-ZDY21-ZDY32)) /
     X           ((ZDY10) * (-ZDY21) * (-ZDY21-ZDY32))
          ZWY0 = 1.0 - ZWY1 - ZWY2 - ZWY3
C
C     -----------------------------------------------------------------|
C         Linear parts for extreme rows.
C     -----------------------------------------------------------------|
C
C         Northernmost
C
          ZWXNN = PDLO0(NEXT)
          ZCXNN = 1.0 - PDLO0(NEXT)
C
C         Southernmost
C
          ZWXSS = PDLO3(NEXT)
          ZCXSS = 1.0 - PDLO3(NEXT)
C
C     -----------------------------------------------------------------|
C         Weights for 12 points interpolation.
C     -----------------------------------------------------------------|
C
          PWTS( 1,NEXT) = ZWXN1 * ZWY1
          PWTS( 2,NEXT) = ZWXN2 * ZWY1
          PWTS( 3,NEXT) = ZWXS1 * ZWY2
          PWTS( 4,NEXT) = ZWXS2 * ZWY2
          PWTS( 5,NEXT) = ZCXNN * ZWY0
          PWTS( 6,NEXT) = ZWXNN * ZWY0
          PWTS( 7,NEXT) = ZWXN0 * ZWY1
          PWTS( 8,NEXT) = ZWXN3 * ZWY1
          PWTS( 9,NEXT) = ZWXS0 * ZWY2
          PWTS(10,NEXT) = ZWXS3 * ZWY2
          PWTS(11,NEXT) = ZCXSS * ZWY3
          PWTS(12,NEXT) = ZWXSS * ZWY3
C
          GOTO 900
C
        ENDIF
C
C     -----------------------------------------------------------------|
C       End of processing for current point in vector.
C     -----------------------------------------------------------------|
C
  900   CONTINUE
C
      ENDDO
C
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE JSPLEG1( PLEG, PLAT, KTRUNC)
      IMPLICIT NONE
C
C---->
C**** JSPLEG1 - Routine to calculate legendre functions
C
C     Purpose
C     --------
C
C     This routine calculates the legendre functions for one latitude.
C     (but not their derivatives)
C
C
C     Interface
C     ----------
C
C     CALL JSPLEG1( PLEG, PLAT, KTRUNC)
C
C
C     Input parameters
C     ----------------
C
C     PLAT      - Latitude in radians
C     KTRUNC    - Spectral truncation
C
C
C     Output parameters
C     -----------------
C
C     PLEG      - Array of legendre functions for one latitude.
C                 The array must be at least (KTRUNC+1)*(KTRUNC+4)/2 
C                 words long.
C
C
C     Common block usage
C     ------------------
C
C     None
C
C
C     Method
C     ------
C
C     Recurrence relation with explicit relations for P(m,m) and 
C     P(m,m+1)
C
C
C     Externals
C     ---------
C
C     None
C
C
C     Reference
C     ---------
C
C     None
C
C
C     Comments
C     --------
C
C     Rewritten from SPLEG1 to avoid using common blocks.
C     Work arrays ZHLPx currently dimensioned for T213 using 
C     parameter JPTRP1.
C
C
C     AUTHOR
C     ------
C
C     J.D.Chambers         ECMWF        9 November 1993
C
C
C     Modifications
C     -------------
C
C     None
C
C----<
C     _______________________________________________________
C
C*    Section 0. Definition of variables.
C     _______________________________________________________
C
C*    Prefix conventions for variable names
C
C     Logical      L (but not LP), global or common.
C                  O, dummy argument
C                  G, local variable
C                  LP, parameter.
C     Character    C, global or common.
C                  H, dummy argument
C                  Y (but not YP), local variable
C                  YP, parameter.
C     Integer      M and N, global or common.
C                  K, dummy argument
C                  I, local variable
C                  J (but not JP), loop control
C                  JP, parameter.
C     Real         A to F and Q to X, global or common.
C                  P (but not PP), dummy argument
C                  Z, local variable
C                  PP, parameter.
#include "jparams.h"
C
C     Subroutine arguments
C
      REAL PLEG, PLAT
      DIMENSION PLEG(*)
      INTEGER KTRUNC
C
C     Local variables
C
      REAL ZHLP1, ZHLP2, ZHLP3
      DIMENSION ZHLP1(JPTRP1), ZHLP2(JPTRP1), ZHLP3(JPTRP1)
      INTEGER ITOUT1, I1M, ILM, JM, JCN, IM2
      REAL ZSIN, ZCOS, ZF1M, ZRE1, ZF2M, ZM, ZN, ZE1, ZE2
C
C     _______________________________________________________
C
C
C*    Section 1. Initialization.
C     _______________________________________________________
C
  100 CONTINUE
C
      ITOUT1 = KTRUNC+1
      ZSIN   = SIN(PLAT)
      ZCOS   = SQRT(1.-ZSIN*ZSIN)
C
C     Step 1.        M = 0, N = 0 and N = 1
C
      ILM     = 2
      PLEG(1) = 1.0
      ZF1M    = SQRT(3.0)
      PLEG(2) = ZF1M*ZSIN
C     _______________________________________________________
C
C
C     Step 2.       Sum for M = 0 to T (T = truncation)
C     _______________________________________________________
C
 200  CONTINUE
C
      DO 205 JM = 2,ITOUT1
        ZM        = JM-1
        ZHLP1(JM) = SQRT(2.*ZM+3.)
        ZHLP2(JM) = 1./SQRT(2.*ZM)
 205  CONTINUE
      ZHLP1(1) = SQRT(3.)
C
      DO 570 JM = 1,ITOUT1
C
        I1M  = JM-1
        ZM   = I1M
        ZRE1 = ZHLP1(JM)
        ZE1  = 1./ZRE1
C     _______________________________________________________
C
C
C     Step 3.       M > 0 only
C     _______________________________________________________
C
 300    CONTINUE
C
        IF (I1M.NE.0) THEN
          ZF2M = ZF1M*ZCOS*ZHLP2(JM)
          ZF1M = ZF2M*ZRE1
C     _______________________________________________________
C
C
C     Step 4.       N = M and N = M+1
C     _______________________________________________________
C
 400    CONTINUE
C
          ILM       = ILM+1
          PLEG(ILM) = ZF2M
          ILM       = ILM+1
          PLEG(ILM) = ZF1M*ZSIN
C
C         When output truncation is reached, return to calling program
          IF ( JM .EQ. ITOUT1 ) GOTO 570
C
        ENDIF
C     _______________________________________________________
C
C
C     Step 5.       Sum for N = M+2 to T+1
C     _______________________________________________________
C
 500    CONTINUE
C
        IM2 = I1M+2
C
        DO 520 JCN = IM2,ITOUT1
          ZN         = JCN
          ZHLP3(JCN) = SQRT((4.*ZN*ZN-1.)/(ZN*ZN-ZM*ZM))
 520    CONTINUE
C
        DO 560 JCN = IM2,ITOUT1
C
          ZE2       = ZHLP3(JCN)
          ILM       = ILM+1
          PLEG(ILM) = ZE2*(ZSIN*PLEG(ILM-1)-ZE1*PLEG(ILM-2))
          ZE2       = 1./ZE2
          ZE1       = ZE2
C
 560    CONTINUE
C
 570  CONTINUE
C
C     _______________________________________________________
C
C
C*    Section 9. Return to calling routine.
C     _______________________________________________________
C
  900 CONTINUE
C
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE  BUCRKEY(KELEM,KTDEXP,KSUP,KSEC1,KSEC3,KEY,
     1                     VALUES,CVALS,KERR)
C**** *BUCRKEY*
C
C
C     PURPOSE.
C     --------
C
C          EXTRACT ELEMENTS NEEDED FOR RDB KEY DEFINITION
C          FROM VALUES AND CVALS ARRAYS.
C
C
C**   INTERFACE.
C     ----------
C
C          NONE.
C
C     METHOD.
C     -------
C
C          NONE.
C
C
C     EXTERNALS.
C     ----------
C
C          NONE.
C
C     REFERENCE.
C     ----------
C
C          NONE.
C
C     AUTHOR.
C     -------
C
C
C          M. DRAGOSAVAC    *ECMWF*       06/06/99.
C
C
C     MODIFICATIONS.
C     --------------
C
C          NONE.
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
C     -------------------------------------------------------------
      DIMENSION KEY(*),KSUP(*),KSEC1(*),KTDEXP(*)
#ifndef R_4
      REAL*8 EPS, RVIND
      REAL*8 VALUES(*)
      REAL*8 RMINLAT, RMINLON, RMAXLAT, RMAXLON
#else
      REAL   EPS, RVIND
      REAL   VALUES(*)
      REAL   RMINLAT, RMINLON, RMAXLAT, RMAXLON
#endif
      DIMENSION KSEC3(*)
      CHARACTER*(*)CVALS(*)
      CHARACTER*5 CBLOCK
C
 100  CONTINUE
C
C     IPAID - AIRCRAFT FLIGHT NUMBER INDEX
C     IPSID - SATELLITE IDENTIFIER INDEX
C     IPBUOY - BUOY/PLATFORM IDENTIFIER INDEX
C     IPARN - AIRCRAFT REGISTRATION NUMBER INDEX
C     IPMET - METAR ICAO ID
C     IPSHIP - SHIPS' CALL SIGN INDEX
C     IPBLOK - WMO BLOCK NUMBER INDEX
C     IPSTAT - WMO STATION NUMBER INDEX
C     IPYEAR - YEAR INDEX
C     IPMONTH - MONTH INDEX
C     IPDAY - DAY INDEX
C     IPHOUR - HOUR INDEX
C     IPMINUTE - MINUTE INDEX
C     IPSECOND - SECOND INDEX
C     IPLAT - LATITUDE INDEX
C     IPLON - LONGITUDE INDEX
C     IPLAT - LATITUDE INDEX
C     IPLON - LONGITUDE INDEX
C
      KERR=0
      EPS=10.D-7
      RVIND=1.7D38
      IPAID=0
      IPSID=0
      IPBUOY=0
      IPARN=0
      IPMET=0
      IPSHIP=0
      IPBLOK=0
      IPSTAT=0
      IPYEAR=0
      IPMONTH=0
      IPDAY=0
      IPHOUR=0
      IPMINUTE=0
      IPSECOND=0
      IPLAT=0
      IPLON=0
      DO 107 I=16,24
      KEY(I)=32
 107  CONTINUE
C
      IEND = 26
      IF( KSEC1(7).EQ.57 ) IEND = 36
      DO 101 I=1,IEND
      IF(KTDEXP(I).EQ.001006) IPAID=I
      IF(KTDEXP(I).EQ.001007) IPSID=I
      IF(KTDEXP(I).EQ.001005) IPBUOY=I
C     IF(KTDEXP(I).EQ.001008) IPARN=I
      IF(KTDEXP(I).EQ.001194) IPAID=I
      IF(KTDEXP(I).EQ.001063) IPMET=I
      IF(KTDEXP(I).EQ.001011) IPSHIP=I
      IF(KTDEXP(I).EQ.001001) IPBLOK=I
      IF(KTDEXP(I).EQ.001002) IPSTAT=I
      IF(KTDEXP(I).EQ.004001) IPYEAR=I
      IF(KTDEXP(I).EQ.004002) IPMONTH=I
      IF(KTDEXP(I).EQ.004003) IPDAY=I
      IF(KTDEXP(I).EQ.004004) IPHOUR=I
      IF(KTDEXP(I).EQ.004005) IPMINUTE=I
      IF(KTDEXP(I).EQ.004006) IPSECOND=I
      IF(KTDEXP(I).EQ.005001) IPLAT=I
      IF(KTDEXP(I).EQ.006001) IPLON=I
      IF(KTDEXP(I).EQ.005002) IPLAT=I
      IF(KTDEXP(I).EQ.006002) IPLON=I
 101  CONTINUE
C
      KEY(4)=VALUES(IPYEAR)
      KEY(5)=VALUES(IPMONTH)
      KEY(6)=VALUES(IPDAY)
      KEY(7)=VALUES(IPHOUR)
      KEY(8)=VALUES(IPMINUTE)
      IF(IPSECOND.NE.0) KEY(9)=VALUES(IPSECOND)
C
      IF((ABS(VALUES(IPLON)-RVIND))/RVIND.LT.EPS.OR.
     1   (ABS(VALUES(IPLAT)-RVIND))/RVIND.LT.EPS) THEN
          KERR=1
          PRINT*,'FOUND VALUES(IPLON)=',VALUES(IPLON)
          PRINT*,'FOUND VALUES(IPLAT)=',VALUES(IPLAT)
          RETURN
      ELSE
         CALL FMMH( IPLAT,IPLON,KELEM,VALUES,KSEC3,RMINLAT,RMINLON,
     1           RMAXLAT,RMAXLON)

         KEY(10)=NINT(RMINLON*100000.+18000000)
         KEY(11)=NINT(RMINLAT*100000.+9000000)
         KEY(12)=NINT(RMAXLON*100000.+18000000)
         KEY(13)=NINT(RMAXLAT*100000.+9000000)
      END IF
C
      KEY(14)=KSEC3(3)
C
C        SATELITTE ID
C
      KEY(15)=0
      DO IS=16,24
        KEY(IS)=32
      END DO
      IF(IPSID.NE.0) THEN
         KEY(15)=VALUES(IPSID)
      END IF
C
C        WMO BLOCK AND STATION NUMBER
C
      IF(IPBLOK.NE.0) THEN
         IF(ABS(VALUES(IPBLOK)-RVIND)/RVIND.LT.EPS) THEN
            KERR=1
            PRINT*,'FOUND VALUES(IPBLOK)=',VALUES(IPBLOK)
            RETURN
         END IF
         IF(ABS(VALUES(IPSTAT)-RVIND)/RVIND.LT.EPS) THEN
            KERR=1
            PRINT*,'FOUND VALUES(IPSTAT)=',VALUES(IPSTAT)
            RETURN
         END IF
         KEY(16)=NINT(VALUES(IPBLOK))*1000+NINT(VALUES(IPSTAT))
         WRITE(CBLOCK,'(I5.5)') KEY(16)
         J=15
         DO 105 I=1,5
         KEY(J+I)=ICHAR(CBLOCK(I:I))
 105     CONTINUE
      END IF
C
C        BUOY/PALTFORM ID
C
      IF(IPBUOY.NE.0) THEN
         IF(ABS(VALUES(IPBUOY)-RVIND)/RVIND.LT.EPS) THEN
            KERR=1
            PRINT*,'FOUND VALUES(IPBUOY)=',VALUES(IPBUOY)
            RETURN
         END IF
         KEY(16)=NINT(VALUES(IPBUOY))
         WRITE(CBLOCK,'(I5.5)') KEY(16)
         J=15
         DO 106 I=1,5
         KEY(J+I)=ICHAR(CBLOCK(I:I))
 106     CONTINUE
      END IF
C
C        AIRCRAFT IDENTIFIER
C
      IF(IPAID.NE.0) THEN
         IF(ABS(VALUES(IPAID)-RVIND)/RVIND.LT.EPS) THEN
            KERR=1
            PRINT*,'FOUND VALUES(IPAID)=',VALUES(IPAID)
            RETURN
         END IF
        IP=(VALUES(IPAID)/1000)
        INCH=NINT(VALUES(IPAID)-IP*1000)
        J=15
        DO 102 I=1,INCH
        KEY(J+I)=ICHAR(CVALS(IP)(I:I))
 102    CONTINUE
      END IF
C
C        AIRCRAFT REGISTRATION NUMBER
C
      IF(IPARN.NE.0) THEN
         IF(ABS(VALUES(IPARN)-RVIND)/RVIND.LT.EPS) THEN
            KERR=1
            PRINT*,'FOUND VALUES(IPARN)=',VALUES(IPARN)
            RETURN
         END IF
        IP=(VALUES(IPARN)/1000)
        INCH=NINT(VALUES(IPARN)-IP*1000)
        J=15
        DO 103 I=1,INCH
        KEY(J+I)=ICHAR(CVALS(IP)(I:I))
 103    CONTINUE
      END IF
C
C       SHIP'S CALL SIGN
C
      IF(IPSHIP.NE.0) THEN
         IF(ABS(VALUES(IPSHIP)-RVIND)/RVIND.LT.EPS) THEN
            KERR=1
            PRINT*,'FOUND VALUES(IPSHIP)=',VALUES(IPSHIP)
            RETURN
         END IF
        IP=(VALUES(IPSHIP)/1000)
        INCH=NINT(VALUES(IPSHIP)-IP*1000)
        J=15
        DO 104 I=1,INCH
        KEY(J+I)=ICHAR(CVALS(IP)(I:I))
 104    CONTINUE
      END IF
C
C       METAR ID
C
      IF(IPMET.NE.0) THEN
         IF(ABS(VALUES(IPMET)-RVIND)/RVIND.LT.EPS) THEN
            KERR=1
            PRINT*,'FOUND VALUES(IPMET)=',VALUES(IPMET)
            RETURN
         END IF
        IP=(VALUES(IPMET)/1000)
        INCH=NINT(VALUES(IPMET)-IP*1000)
        J=15
        DO 194 I=1,INCH
        KEY(J+I)=ICHAR(CVALS(IP)(I:I))
 194    CONTINUE
      END IF
C
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE SEARCH (KEYS,MAXKEY,STRING,LEN,POS,IS,IF,
     C                    ISUP,IP,OP,IA,MIN)
C
C---->
C**** SEARCH - Search for given character string.
C 
C     Purpose.
C     --------
C
C           Search for a match, in an array of character
C           variables, for a given character string.
C 
C**   Interface.
C     ----------
C
C           CALL SEARCH (KEYS,MAXKEY,STRING,LEN,POS,IS,IF,
C    C                    ISUP,IP,OP,IA,MIN)
C
C               Input Parameters.
C               -----------------
C
C                KEYS   = Array of character variables
C 
C                MAXKEY = Size of array
C 
C                STRING = Character string for which match is
C                         sought
C 
C                LEN    = Length of this string
C 
C                ISUP   = 0 , Print turned on, when no match found.
C                         1 , Print suppressed
C 
C                IS     = Search start position in array "KEYS"
C 
C                IF     = Search end position in array KEYS.
C 
C                OP     = Unit number of file output
C 
C                IP     = Unit number of file input
C 
C                IA     = 1 , Interactive use
C                         0 , Batch use.
C 
C                MIN    = Minimum number of characters needed for match.
C 
C               Output Parameters.
C               ------------------
C
C                POS    = 0 , Match not found
C                         -1 , Multiple matches found
C                         Positive value, indicates array element
C                             which matches
C 
C     Author.
C     -------
C
C           J. Hennessy      ECMWF      16.04.85
C
C     Modifications.
C     --------------
C
C           J. Hennessy      ECMWF      07.12.93
C           Code added to remove ambiguous entries when possible.
C
C           J.D.Chambers  ECMWF  13.12.93
C           Increase parameter value table size 1200 -> 1500
C 
C     ----------------------------------------------------------------
C----<
C
      IMPLICIT INTEGER (A-Z)
C
      PARAMETER (ASIZE=1500)
C
      DIMENSION KEYS(MAXKEY)
      CHARACTER*(*) KEYS, STRING
      CHARACTER*1   PAGE
C
      DIMENSION ATAB(ASIZE)
C
      IF (MAXKEY.GT.ASIZE)
     C   THEN
             WRITE (*,*) ' SEARCH : Array limits exceeded.'
             WRITE (*,*) ' SEARCH : MAXKEY = ', MAXKEY
             WRITE (*,*) '          Notify MARS group.'
             CALL ABORT
         ENDIF
C
      SIZE = MAX (LEN,MIN)
C
C
C
C
C
C****************************************************************
C*
C*    Flag and count matching entries
C*
C****************************************************************
C
C
      N = MIN
  100 K = 0
      DO 200 I=IS,IF
         ATAB(I) = 0
         IF (STRING(1:N).EQ.KEYS(I)(1:N))
     C      THEN
                ATAB(I) = 1
                K = K + 1
                J = I
            ENDIF
  200 CONTINUE
C
      N = N + 1
      IF (N.LE.SIZE.AND.K.GT.1) GO TO 100
C
C
C****************************************************************
C*
C*    No match found. print message (if required) and return.
C*
C****************************************************************
C
      IF (K.EQ.0)
     C THEN
           POS = 0
           IF (ISUP.EQ.1) RETURN
C
           IF (STRING(1:1).NE.'?')
     C      THEN
              WRITE (OP,9000) STRING(1:SIZE)
 9000         FORMAT (' Unrecognised entry - ',A)
            ENDIF
           WRITE (OP,*) 'Valid entries are :-'
           N = 0
           DO 300 I=IS,IF
                  N = N + 1
                  WRITE (OP,'(1H ,20X,A)') KEYS(I)
                  IF (IA.EQ.1.AND.N.EQ.19)
     C              THEN
  250                   WRITE(OP,*)'Type page to continue -->'
                        N = 0
                        READ (IP,'(A1)') PAGE
                        CALL L2U1CR (PAGE)
                        IF (PAGE.NE.'P') GO TO 250
                        GO TO 300
                    ENDIF
  300      CONTINUE
           POS = 0
           RETURN
       END IF
C
C****************************************************************
C*
C*    Return if only 1 match found.
C*
C****************************************************************
C
      IF (K.EQ.1) THEN
                      POS = J
                      RETURN
                  ENDIF
C
C****************************************************************
C*
C*    Number of entries found. Try to resolve ambiguity.
C*
C****************************************************************
C
      DO 350 I=IS,IF
           IF (ATAB(I).EQ.1) 
     C        THEN
                  IJ = RTB(KEYS(I))
                  IF (STRING(1:LEN).EQ.KEYS(I)(1:IJ))
     C               THEN
                         POS = I
                         RETURN
                     ENDIF
              ENDIF
  350 CONTINUE
C
C****************************************************************
C*
C*    Ambiguous entry found. Print/display message
C*
C****************************************************************
C
      WRITE (OP,9001) STRING(1:SIZE)
 9001 FORMAT (' Ambiguous entry  - ',A)
      DO 400 I=IS,IF
           IF (ATAB(I).EQ.1) WRITE (OP,9002) KEYS(I)
 9002      FORMAT ('     ',A)
  400 CONTINUE
C
      POS = - 1
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE BUSTOP(KSTOP)
C
C**** *BUSTOP*
C
C
C     PURPOSE.
C     --------
C            SETS VARIABLE KPMISS,KPRUS,KOKEY,KOFL INTO COMMON BLOCK.
C
C**   INTERFACE.
C     ----------
C
C          *CALL* *BUSTOP(KSTOP)*
C
C        INPUT :
C               *KSTOP*   -  INTEGER CONSTANT
C
C
C     METHOD.
C     -------
C
C
C     EXTERNALS.
C     ----------
C
C          NONE
C
C
C     REFERENCE.
C     ----------
C
C          NONE.
C
C     AUTHOR.
C     -------
C
C          M. DRAGOSAVAC    *ECMWF*       15/09/2007
C
C
C     MODIFICATIONS.
C     --------------
C
C          NONE.
C
C
      IMPLICIT LOGICAL(L,O,G), CHARACTER*8(C,H,Y)
C
#     include "parameter.F"
#     include "bcomwt.F"
#     include "bcomdefc.F"
C
      CHARACTER*4 CECMWF      
C
C     ------------------------------------------------------------------
C
C*          1.   SET CONSTANTS.
C                --------------
 100  CONTINUE
C
      IF(CECMWF.NE.'ECMF') THEN
         IERR=0
         CALL BUEVAR(IERR)
         CECMWF='ECMF'
      END IF
C
      NSTOP=KSTOP
C
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE BUUATB(KBUFL,KBUFF,KJ,KY,KSTACK,KELEM,KERR)
C
C**** *BUUATB*
C
C
C     PURPOSE.
C     --------
C          UPDATE AUGMENTED BUFR TABLE B.
C
C
C**   INTERFACE.
C     ----------
C
C          *CALL* *BUUATB(KBUFL,KBUFF,KJ,KY,KSTACK,KELEM,KERR)*
C
C        INPUT :
C               *KBUFL*   -  LENGTH OF BUFR MESSAGE (WORDS)
C               *KBUFF*   -  ARRAY CONTAINING BUFR MESSAGE
C               *KJ*      -  POINTER TO KSTACK ARRAY
C               *KY*      -  OPERAND OF THE DATA DESCRIPTOR OPERATOR
C               *KELEM*   -
C        OUTPUT:
C               *KSTACK* - LIST OF ELEMENTS
C               *KERR*   - RETURN ERROR CODE
C
C     METHOD.
C     -------
C
C          NONE.
C
C
C     EXTERNALS.
C     ----------
C
C          GBYTE        - PACK BIT PATTERN
C
C
C     REFERENCE.
C     ----------
C
C          NONE.
C
C     AUTHOR.
C     -------
C
C          M. DRAGOSAVAC    *ECMWF*       04/02/91.
C
C
C     MODIFICATIONS.
C     --------------
C
C          NONE.
C
C
      IMPLICIT LOGICAL(L,O,G), CHARACTER*8(C,H,Y)
C
C
C
#     include "parameter.F"
#     include "bcomunit.F"
#     include "bcomwork.F"
#     include "bcomatb.F"
#     include "bcomatbc.F"
#     include "bcomtab.F"
#     include "bcomtabc.F"
#     include "bcomwt.F"
#     include "bcomwtc.F"
#     include "bcombef.F"
#     include "bcomcom.F"
#     include "bcomoff.F"
C
      CHARACTER CATBEN*64,CWTEN*64,CTABBEN*64
      CHARACTER CATBU*24,CWTU*24,CTABBU*24
C
#ifndef R_4
      REAL*8 RVIND
      REAL*8 EPS
#else
      REAL   RVIND
      REAL   EPS
#endif
      DIMENSION KBUFF(KBUFL)
      DIMENSION KSTACK(*)
      DIMENSION IMASK(8)
      DATA IMASK/1,2,4,8,16,32,64,128/
C     ------------------------------------------------------------------
C
C*          1.   UPDATE AUGMENTED TABLE B .
C                --------------------------
 100  CONTINUE
C
      IF( KERR.NE.0 ) RETURN
C
C*          1.1 Y = 0 ?
C               -------
 110  CONTINUE
C
      IF( KY.EQ.0) THEN
C
C*          1.1.1 CLEAR AUGMENTED TABLE B.
C                 ------------------------
         NJA= 0
C
         DO 111 J=1,JTAB
C
         NATBTR(J)= 0
         NATBS (J)= 0
         NATBRV(J)= 0
         NATBDW(J)= 0
         CATBEN(J)=' '
         CATBU (J)=' '
C
 111     CONTINUE
C
         GO TO 300
      END IF
C
C*          1.2  GET NEXT DESCRIPTOR FROM STACK.
C                -------------------------------
 120  CONTINUE
C
      KJ=KJ + 1
      KDD = KSTACK(KJ)
C
C*          1.3  ELEMENT DESCRIPTOR  ?
C                ---------------------
 130  CONTINUE
C
      IF  = KDD /100000
      IDIF= KDD -IF*100000
      IX  = IDIF/1000
      IY  = IDIF-IX*1000
C
      IF(IF.EQ.0) THEN
C
C*          1.3.1 ADD SPECIAL ENTRY TO WORKING TABLE.
C                 -----------------------------------
         NWT = NWT + 1
         NWTEN(NWT)=836970
         CWTEN(NWT)='REFERENCE VALUE'
         CWTU (NWT)=' '
         NWTDW(NWT)= KY
         NWTS (NWT)=0
         NWTRV(NWT)=0
         M=M+1
C
C*          1.3.2 ADD ENTRY TO AUGMENTED TABLE B .
C                 --------------------------------
         DO 131 J=1,JTAB
C
         IF(NTABBTR(J).EQ.KDD) THEN
            I=J
            GO TO 133
         END IF
C
 131     CONTINUE
C
         KERR=23
         WRITE(KNTN,*)'BUUATB :'
         CALL BUERR(KERR)
C
         GO TO 300
C
 133  CONTINUE
C
         NJA=NJA + 1
C
         NATBTR(NJA)=NTABBTR(I)
         NATBS (NJA)=NTABBS (I)
         NATBRV(NJA)=NTABBRV(I)
         NATBDW(NJA)=NTABBDW(I)
         CATBEN(NJA)=CTABBEN(I)
         CATBU (NJA)=CTABBU (I)
C
C*          1.3.3 COMPLITE ENTRY WITH NEW REFERENCE VALUE
C                 ----------------------------------------
C                 FROM DATA SECTION.
C                 ------------------
C
         IB=0
         IF(IAND(ICOMP,IMASK(7)).NE.0) IB=1

         IF(IB.EQ.0) THEN
C
            IBIT=0
C
            DO 134 J=1,NWT-1
C
            IBIT =IBIT + NWTDW(J)
C
 134        CONTINUE
C
            IF(NSUBSET.EQ.1) THEN
               IBIT = IBIT +32 + NBPTB
            ELSE
               IBIT = IBIT + NBP
            END IF
            IWORD= IBIT/NBPW
            ISKIP= IBIT - IWORD*NBPW
            IF(NSUBSET.EQ.1) THEN
               IWORD= IWORD + NWPTB
            ELSE
               IWORD= IWORD + NWP
            END IF
C
C
C           1.3.4 CHECK IF REFERENCE VALUE NEGATIVE
C
            CALL GBYTE(KBUFF(IWORD),ISGN,ISKIP,1)
            IF(ISGN.EQ.1) THEN
               IBIT=IBIT+1
               IWORD= IBIT/NBPW
               ISKIP= IBIT - IWORD*NBPW
               IWORD= IWORD + NWPTB
C
               CALL GBYTE(KBUFF(IWORD),NATBRV(NJA),ISKIP,KY-1)
               NATBRV(NJA)=-NATBRV(NJA)
            ELSE
               CALL GBYTE(KBUFF(IWORD),NATBRV(NJA),ISKIP,KY)
            END IF
C
         ELSE
C            COMPRESSED DATA
C
            IBIT=32+NBPTB
            IWORD=IBIT/NBPW
C
            IWORDP=NWPTB+IWORD
            IBITP =IBIT-IWORD*NBPW
C
            DO 402 I=2,NWT
            IWRD=IWORDP
            IBTP=IBITP
C
            IF(NWTDW(I-1).EQ.0) THEN
               IBITP =IBITP
               IWORDP=IWORDP
               GO TO 402
            END IF
C
            IBTP=IBTP+NWTDW(I-1)
            IF(IBTP.GE.NBPW) THEN
               IW=IBTP/NBPW
               IBTP=IBTP-IW*NBPW
               IWRD=IWRD+IW
            END IF
C
            CALL BUNPCK(NBPW,KBUFF,IDWINC,IWRD,IBTP,6,KERR)
            IF(KERR.GT.0) RETURN
            IF(IDWINC.GT.JBPW) THEN
               KERR=15
               WRITE(KNTN,*) 'BUUATB:'
               CALL BUERR(KERR)
               RETURN
            END IF
            IF(IWRD.GT.KBUFL) THEN
               KERR=26
               WRITE(KNTN,*) 'BUUATB:'
               CALL BUERR(KERR)
               RETURN
            END IF
C
            IF(CWTU(I-1)(1:3).EQ.'CCI') THEN
               IWTIWS=NWTDW(I-1)+6+N*IDWINC*8
            ELSE
               IWTIWS=NWTDW(I-1)+6+N*IDWINC
            END IF
C
            IBIT = IBITP + IWTIWS
            IWORD= IBIT/NBPW
C
            IBITP = IBIT - IWORD*NBPW
            IWORDP= IWORDP + IWORD
C
            IF(IWORDP.GT.KBUFL) THEN
               KERR=26
               WRITE(KNTN,*) 'BUUATB :'
               CALL BUERR(KERR)
               RETURN
            END IF
 402        CONTINUE
C
C
            IW=IWORDP
            IBT=IBITP
            CALL BUNPCK(NBPW,KBUFF,ISG_REF,IW,IBT,1,KERR)
            CALL BUNPCK(NBPW,KBUFF,IR0,IW,IBT,NWTDW(NWT)-1,KERR)
            IF(KERR.GT.0) RETURN
            CALL BUNPCK(NBPW,KBUFF,IDWINC,IW,IBT,6,KERR)
            IF(KERR.GT.0) RETURN
            IF(IDWINC.GT.JBPW) THEN
               KERR=15
               WRITE(KNTN,*) ' BUUATB :'
               CALL BUERR(KERR)
               RETURN
            END IF
C
            IF(IDWINC.NE.0) THEN
               CALL BUNPCK(NBPW,KBUFF,INCR,IW,IBT,IDWINC,KERR)
               IF(KERR.GT.0) RETURN
            END IF
C
            IF(IR0.EQ.NMASK(NWTDW(NWT))) THEN
               JR=NMASK(NWTDW(NWT))
               KERR=19
               WRITE(KNTN,*) 'BUUATB :'
               CALL BUERR(KERR)
               RETURN
            ELSE
               IWTPR0=NWTRV(NWT)+IR0
C
               IF(IDWINC.EQ.0) THEN
                  JREF=IWTPR0
               ELSE
                  IF(INCR.EQ.NMASK(IDWINC)) THEN
                     JREF=NMASK(NWTDW(NWT))
                     KERR=19
                     WRITE(KNTN,*) 'BUUATB :'
                     CALL BUERR(KERR)
                     RETURN
                  ELSE
                     JREF= IWTPR0 + INCR
                  END IF
               END IF
            END IF
C
            NATBRV(NJA)=JREF
            IF(ISG_REF.EQ.1) NATBRV(NJA)=- NATBRV(NJA)
         END IF
C
C           1.3.5 UPDATA WORKING TABLE ENTRIES.
C                 -----------------------------
 135     CONTINUE
C
c        IF(KDD.EQ.31031.OR.KDD.EQ.31192) THEN
c           NWT=NWT+1
c           NWTR(NWT)=KDD
c           NWTS(NWT)=0
c           NWTRV(NWT)=0
c           NWTDW(NWT)=1
c           CWTEN(NWT)='DATA PRESENT INDICATOR'
c           CWTU (NWT)='NUMERIC'
c           M=M+1
c        ELSEIF(KDD.EQ.33007.OR.KDD.EQ.63192) THEN
c           NWT=NWT+1
c           NWTR(NWT)=KDD
c           NWTS(NWT)=0
c           NWTRV(NWT)=0
c           NWTDW(NWT)=7
c           CWTEN(NWT)='% CONFIDENCE'
c           CWTU (NWT)='NUMERIC'
c           M=M+1
c        ELSE
c           CALL BUUPWT(KDD,KELEM,KERR)
c           IF(KERR.GT.0) RETURN
c        END IF
C
         GO TO 120
C
      END IF
C
C     ------------------------------------------------------------------
C
C*           1.4   CHANGE REFERENCE VALUE ?
C                  ------------------------
 140  CONTINUE
C
      IF( IF.EQ.2.AND.IX.EQ.3) THEN
         IF(IY.EQ.255) GO TO 300
         KY=IY
         GO TO 120
      END IF
C     ------------------------------------------------------------------
 200  CONTINUE
C
      KERR=23
      WRITE(KNTN,*)'BUUATB :'
      CALL BUERR(KERR)
C
C     ------------------------------------------------------------------
 300  CONTINUE
C
      RETURN
      END

C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE SEARCH (KEYS,MAXKEY,STRING,LEN,POS,IS,IF,
     C                    ISUP,IP,OP,IA,MIN)
C
C---->
C**** SEARCH - Search for given character string.
C 
C     Purpose.
C     --------
C
C           Search for a match, in an array of character
C           variables, for a given character string.
C 
C**   Interface.
C     ----------
C
C           CALL SEARCH (KEYS,MAXKEY,STRING,LEN,POS,IS,IF,
C    C                    ISUP,IP,OP,IA,MIN)
C
C               Input Parameters.
C               -----------------
C
C                KEYS   = Array of character variables
C 
C                MAXKEY = Size of array
C 
C                STRING = Character string for which match is
C                         sought
C 
C                LEN    = Length of this string
C 
C                ISUP   = 0 , Print turned on, when no match found.
C                         1 , Print suppressed
C 
C                IS     = Search start position in array "KEYS"
C 
C                IF     = Search end position in array KEYS.
C 
C                OP     = Unit number of file output
C 
C                IP     = Unit number of file input
C 
C                IA     = 1 , Interactive use
C                         0 , Batch use.
C 
C                MIN    = Minimum number of characters needed for match.
C 
C               Output Parameters.
C               ------------------
C
C                POS    = 0 , Match not found
C                         -1 , Multiple matches found
C                         Positive value, indicates array element
C                             which matches
C 
C     Author.
C     -------
C
C           J. Hennessy      ECMWF      16.04.85
C
C     Modifications.
C     --------------
C
C           J. Hennessy      ECMWF      07.12.93
C           Code added to remove ambiguous entries when possible.
C
C           J.D.Chambers  ECMWF  13.12.93
C           Increase parameter value table size 1200 -> 1500
C 
C     ----------------------------------------------------------------
C----<
C
      IMPLICIT INTEGER (A-Z)
C
      PARAMETER (ASIZE=1500)
C
      DIMENSION KEYS(MAXKEY)
      CHARACTER*(*) KEYS, STRING
      CHARACTER*1   PAGE
C
      DIMENSION ATAB(ASIZE)
C
      IF (MAXKEY.GT.ASIZE)
     C   THEN
             WRITE (*,*) ' SEARCH : Array limits exceeded.'
             WRITE (*,*) ' SEARCH : MAXKEY = ', MAXKEY
             WRITE (*,*) '          Notify MARS group.'
             CALL ABORT
         ENDIF
C
      SIZE = MAX (LEN,MIN)
C
C
C
C
C
C****************************************************************
C*
C*    Flag and count matching entries
C*
C****************************************************************
C
C
      N = MIN
  100 K = 0
      DO 200 I=IS,IF
         ATAB(I) = 0
         IF (STRING(1:N).EQ.KEYS(I)(1:N))
     C      THEN
                ATAB(I) = 1
                K = K + 1
                J = I
            ENDIF
  200 CONTINUE
C
      N = N + 1
      IF (N.LE.SIZE.AND.K.GT.1) GO TO 100
C
C
C****************************************************************
C*
C*    No match found. print message (if required) and return.
C*
C****************************************************************
C
      IF (K.EQ.0)
     C THEN
           POS = 0
           IF (ISUP.EQ.1) RETURN
C
           IF (STRING(1:1).NE.'?')
     C      THEN
              WRITE (OP,9000) STRING(1:SIZE)
 9000         FORMAT (' Unrecognised entry - ',A)
            ENDIF
           WRITE (OP,*) 'Valid entries are :-'
           N = 0
           DO 300 I=IS,IF
                  N = N + 1
                  WRITE (OP,'(1H ,20X,A)') KEYS(I)
                  IF (IA.EQ.1.AND.N.EQ.19)
     C              THEN
  250                   WRITE(OP,*)'Type page to continue -->'
                        N = 0
                        READ (IP,'(A1)') PAGE
                        CALL L2U1CR (PAGE)
                        IF (PAGE.NE.'P') GO TO 250
                        GO TO 300
                    ENDIF
  300      CONTINUE
           POS = 0
           RETURN
       END IF
C
C****************************************************************
C*
C*    Return if only 1 match found.
C*
C****************************************************************
C
      IF (K.EQ.1) THEN
                      POS = J
                      RETURN
                  ENDIF
C
C****************************************************************
C*
C*    Number of entries found. Try to resolve ambiguity.
C*
C****************************************************************
C
      DO 350 I=IS,IF
           IF (ATAB(I).EQ.1) 
     C        THEN
                  IJ = RTB(KEYS(I))
                  IF (STRING(1:LEN).EQ.KEYS(I)(1:IJ))
     C               THEN
                         POS = I
                         RETURN
                     ENDIF
              ENDIF
  350 CONTINUE
C
C****************************************************************
C*
C*    Ambiguous entry found. Print/display message
C*
C****************************************************************
C
      WRITE (OP,9001) STRING(1:SIZE)
 9001 FORMAT (' Ambiguous entry  - ',A)
      DO 400 I=IS,IF
           IF (ATAB(I).EQ.1) WRITE (OP,9002) KEYS(I)
 9002      FORMAT ('     ',A)
  400 CONTINUE
C
      POS = - 1
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      LOGICAL FUNCTION JFINDIR( ENVNAME, DIRNAME)
C
C---->
C**** JFINDIR
C
C     Purpose
C     _______
C
C     This routine finds the directory specified by an environment
C     variable.
C
C     Interface
C     _________
C
C     LFOUND = JFINDIR( ENVNAME, DIRNAME)
C
C     Input parameters
C     ________________
C
C     ENVNAME - The environment variable.
C
C     Output parameters
C     _________________
C
C     DIRNAME - The directory name (if found).
C
C     The function returns .TRUE. if the environment variable gives
C     a directory name; otherwise it returns .FALSE.
C
C     Common block usage
C     __________________
C
C     None.
C
C     Externals
C     _________
C
C     Reference
C     _________
C
C     GETENV  - to read the envirment variable.
C
C     Comments
C     ________
C
C     None.
C 
C     Author
C     ______
C
C     J.D.Chambers      *ECMWF*      Mar 1996
C
C----<
C     _______________________________________________________
C
      IMPLICIT NONE
C
C     Parameters
Cjdc  INTEGER JPROUTINE
Cjdc  PARAMETER ( JPROUTINE = 30800 )
C
C     Subroutine arguments
      CHARACTER*(*) ENVNAME, DIRNAME
C
C     Local variables
      INTEGER IBLANK
C
C     _______________________________________________________
C
C*    Section 1. Try the environment variable.
C     _______________________________________________________
C
  100 CONTINUE
C
      JFINDIR = .TRUE.
C
      CALL GETENV(ENVNAME, DIRNAME)
C
C     See if a name was returned.
      IBLANK = INDEX(DIRNAME, ' ')
      IF ( IBLANK.LE.1 ) JFINDIR = .FALSE.
C
C     _______________________________________________________
C
C*    Section 9. Return.
C     _______________________________________________________
C
  900 CONTINUE
C
      RETURN
      END

C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      LOGICAL FUNCTION JFINDIR( ENVNAME, DIRNAME)
C
C---->
C**** JFINDIR
C
C     Purpose
C     _______
C
C     This routine finds the directory specified by an environment
C     variable.
C
C     Interface
C     _________
C
C     LFOUND = JFINDIR( ENVNAME, DIRNAME)
C
C     Input parameters
C     ________________
C
C     ENVNAME - The environment variable.
C
C     Output parameters
C     _________________
C
C     DIRNAME - The directory name (if found).
C
C     The function returns .TRUE. if the environment variable gives
C     a directory name; otherwise it returns .FALSE.
C
C     Common block usage
C     __________________
C
C     None.
C
C     Externals
C     _________
C
C     Reference
C     _________
C
C     GETENV  - to read the envirment variable.
C
C     Comments
C     ________
C
C     None.
C 
C     Author
C     ______
C
C     J.D.Chambers      *ECMWF*      Mar 1996
C
C----<
C     _______________________________________________________
C
      IMPLICIT NONE
C
C     Parameters
Cjdc  INTEGER JPROUTINE
Cjdc  PARAMETER ( JPROUTINE = 30800 )
C
C     Subroutine arguments
      CHARACTER*(*) ENVNAME, DIRNAME
C
C     Local variables
      INTEGER IBLANK
C
C     _______________________________________________________
C
C*    Section 1. Try the environment variable.
C     _______________________________________________________
C
  100 CONTINUE
C
      JFINDIR = .TRUE.
C
      CALL GETENV(ENVNAME, DIRNAME)
C
C     See if a name was returned.
      IBLANK = INDEX(DIRNAME, ' ')
      IF ( IBLANK.LE.1 ) JFINDIR = .FALSE.
C
C     _______________________________________________________
C
C*    Section 9. Return.
C     _______________________________________________________
C
  900 CONTINUE
C
      RETURN
      END

c Copyright 1981-2016 ECMWF.
c
c This software is licensed under the terms of the Apache Licence 
c Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
c
c In applying this licence, ECMWF does not waive the privileges and immunities 
c granted to it by virtue of its status as an intergovernmental organisation 
c nor does it submit to any jurisdiction.
c

      SUBROUTINE SETGPFA(TRIGS,N)
*
      DIMENSION TRIGS(*)
      DIMENSION NJ(3)
*
*     DECOMPOSE N INTO FACTORS 2,3,5
*     ------------------------------
      NN = N
      IFAC = 2
*
      DO 30 LL = 1 , 3
      KK = 0
   10 CONTINUE
      IF (MOD(NN,IFAC).NE.0) GO TO 20
      KK = KK + 1
      NN = NN / IFAC
      GO TO 10
   20 CONTINUE
      NJ(LL) = KK
      IFAC = IFAC + LL
   30 CONTINUE
*
      IF (NN.NE.1) THEN
         WRITE(6,40) N
   40    FORMAT(' *** WARNING!!!',I10,' IS NOT A LEGAL VALUE OF N ***')
         RETURN
      ENDIF
*
      IP = NJ(1)
      IQ = NJ(2)
      IR = NJ(3)
*
*     COMPUTE LIST OF ROTATED TWIDDLE FACTORS
*     ---------------------------------------
      NJ(1) = 2**IP
      NJ(2) = 3**IQ
      NJ(3) = 5**IR
*
      TWOPI = 4.0 * ASIN(1.0)
      I = 1
*
      DO 60 LL = 1 , 3
      NI = NJ(LL)
      IF (NI.EQ.1) GO TO 60
*
      DEL = TWOPI / FLOAT(NI)
      IROT = N / NI
      KINK = MOD(IROT,NI)
      KK = 0
*
      DO 50 K = 1 , NI
      ANGLE = FLOAT(KK) * DEL
      TRIGS(I) = COS(ANGLE)
      TRIGS(I+1) = SIN(ANGLE)
      I = I + 2
      KK = KK + KINK
      IF (KK.GT.NI) KK = KK - NI
   50 CONTINUE
   60 CONTINUE
*
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE BUEXS4(KBUFL,KBUFF,KSUP,KSEC3,KSEC4,KELEM,CNAMES,
     1                  CUNITS,KVALS,VALUES,CVALS,KERR)
C
C**** *BUEXS4*
C
C
C     PURPOSE.
C     --------
C          EXPAND PRELIMINARY ITEMS AND DATA OF SECTION 4 OF BUFR MESSAGE.
C
C
C**   INTERFACE.
C     ----------
C
C          *CALL* *BUEXS4(KBUFL,KBUFF,KSUP,KSEC3,KSEC4,KELEM,CNAMES,
C                         CUNITS,KVALS,VALUES,CVALS,KERR)*
C
C        INPUT :
C               *KBUFL*   -  LENGTH OF BUFR MESSAGE (WORDS)
C               *KBUFF*   -  ARRAY CONTAINING BUFR MESSAGE
C               *KELEM*   -  DIMENSION OF CNAMES, CUNITS ARRAY
C               *KVALS*   -  DIMENSION OF VALUES ARRAY
C        OUTPUT:
C               *KSUP*    -  ARRAY CONTAINING SUPLEMENTARY INFORMATION
C                         -  KSUP( 1) -- IDIM1, DIMENSION OF KSEC1
C                         -  KSUP( 2) -- IDIM2, DIMENSION OF KSEC2
C                         -  KSUP( 3) -- IDIM3, DIMENSION OF KSEC3
C                         -  KSUP( 4) -- IDIM4, DIMENSION OF KSEC4
C                         -  KSUP( 5) -- M (NUMBER OF ELEMENTS IN VALUES ARRAY,
C                                           FIRST INDEX)
C                         -  KSUP( 6) -- N (NUMBER OF SUBSETS,SECOND INDEX OF
C                                           VALUES ARRAY)
C                         -  KSUP( 7) -- JVC (NUMBER OF ELEMENTS IN CVAL ARRAY)
C                         -  KSUP( 8) -- TOTAL BUFR MESSAGE LENGTH IN BYTES
C                         -  KSUP( 9) -- IDIM0, DIMENSION OF KSEC0
C               *KSEC3*   -  ARRAY CONTAINING SECTION 3 INFORMATION
C                            KSEC3( 1)-- LENGTH OF SECTION 3 (BYTES)
C                            KSEC3( 2)-- RESERVED
C                            KSEC3( 3)-- NUMBER OF SUBSETS
C                            KSEC3( 4)-- FLAG (DATA TYPE,DATA COMPRESSION)
C               *KSEC4*   -  ARRAY CONTAINING SECTION 4 INFORMATION
C                            KSEC4( 1)-- LENGTH OF SECTION 4 (BYTES)
C                            KSEC4( 2)-- RESERVED
C               *CNAMES*  -  CHARACTER ARRAY CONTAINING ELEMENT NAMES
C               *CUNITS*  -  CHARACTER ARRAY CONTAINIG UNITS
C               *VALUES*  -  REAL ARRAY (EXPANDED DATA VALUES)
C               *CVALS*   -  CHARACTER ARRAY CONTAINING TEXT
C               *KERR*    -  RETURNED ERROR CODE
C
C     METHOD.
C     -------
C
C           NONE.
C
C
C     EXTERNALS.
C     ----------
C
C          BUNPCK          -  UNPACK BIT PATTERN
C          BUNPKS          -  UNPACK BIT PATTERN IN REPEATED WAY,
C                             POINTER ADJUSTMENT
C          BUUNPS          -  UNPACK BIT PATTERN IN REPEATED WAY,
C                             NO POINTER ADJUSTMENT
C          BUUNP           -  UNPACK BIT PATTERN, NO POINTER ADJUSTMENT
C          BUNEXS          -  SET WORD AND BIT POINTERS AT THE BEGINING OF
C                             NEXT SECTION
C
C
C     REFERENCE.
C     ----------
C
C          NONE.
C
C     AUTHOR.
C     -------
C
C          M. DRAGOSAVAC    *ECMWF*       17/01/91.
C
C
C     MODIFICATIONS.
C     --------------
C
C          NONE.
C
C
      IMPLICIT LOGICAL(L,O,G), CHARACTER*8(C,H,Y)
C
C
#     include "parameter.F"
#     include "bcomreq.F"
#     include "bcomunit.F"
#     include "bcomwork.F"
#     include "bcomwt.F"
#     include "bcomp.F"
#     include "bcombef.F"
#     include "bcomrq.F"
#     include "bcomoff.F"
C
      CHARACTER CTEXT*64
      CHARACTER CNAMR*64,CUNIR*24
C
      DIMENSION KBUFF(KBUFL)
      DIMENSION ICH(255),ILIST(JWORK),IVALUES(JWORK) 
      DIMENSION IILIST(8),IR0LIST(8)
C
      CHARACTER*64 CNAMES(KELEM)
      CHARACTER*24 CUNITS(KELEM)
      CHARACTER*80 CVALS(KVALS)
      REAL*4 VVV4,VVV4S
      REAL*8 VVV8S,VVV8,VAL8S
      REAL*4 R4, RHUGE4
      REAL*8 R8, RHUGE8
      LOGICAL OBIG, BIG_ENDIAN
C
#ifndef R_4
      REAL*8 VALUES(KVALS),RQVAL
      REAL*8 RVIND
      REAL*8 EPS
      REAL*8 VVV
#else
      REAL   VALUES(KVALS),RQVAL
      REAL   RVIND
      REAL   EPS
      REAL   VVV
#endif
      LOGICAL CHECK_S4,OS4
      DIMENSION KSUP(JSUP),KSEC3(JSEC3),KSEC4(JSEC4)
      DIMENSION IMASK(8),IRO(80)
      DATA IMASK/1,2,4,8,16,32,64,128/

C
C     ------------------------------------------------------------------
C*          1.  EXPAND PRELIMINARY ITEMS FROM SECTION4.
C               ---------------------------------------
 100  CONTINUE
C
C                JCV - POINTER TO CVALS ARRAY
C                JWT - POINTER TO WORKING TABLE ARRAY
C                JNS - POINTER TO VALUES ARRAY FOR SUB-SETS.
C
      IF(KERR.GT.0) RETURN
C
#if defined(gfortran)
      R4=HUGE(R4)
      R8=HUGE(R8)
#else
      R4=3.4028235e+38
      R8=1.7976931348623157D+308
#endif
C
      IF(OMULTI) THEN
         IF(NSUBSET.EQ.1) JCV = 0
      ELSE
        JCV = 0
      END IF
      OREPF =.FALSE.
C
      IF(KELEM*N.GT.KVALS) THEN
         KERR=14
         CALL BUERR(KERR)
         WRITE(KNTN,*)  ' BUEXS4: NUMBER OF ELEMENTS ',M
         WRITE(KNTN,*)  ' BUEXS4: NUMBER OF SUBSETS  ',N
         MN=M*N
         WRITE(KNTN,*)  ' BUEXS4: SUGGESTED VALUE FOR KVALS ',MN
         WRITE(KNTN,*)  ' BUEXS4: SUGGESTED VALUE FOR KELEM ',M
         RETURN
      END IF
C
C*          1.1  SET THE POINTERS NWPT AND NBPT
C                ------------------------------
C                TO THE BEGINING OF THE SECTION.
C                -------------------------------
 110  CONTINUE
C
      NWPT = NWPTB
      NBPT = NBPTB
      NWPTB4 = NWPTB
      NBPTB4 = NBPTB
C
C*          1.2  UNPACK LENGTH OF SECTION 4.
C                ---------------------------
 120  CONTINUE
C
      CALL BUNPCK(NBPW,KBUFF,KSEC4(1),NWPT,NBPT,24,KERR)
      IF(KERR.GT.0) THEN
         WRITE(KNTN,*)  'ERROR UNPACKING KSEC4(1).'
         RETURN
      END IF
C
      IF(OS4.AND.NREQ(1).EQ.0) THEN
        CALL CHECK_S4S(KELEM,KSEC3,KSEC4,KERR)
        IF(KERR.NE.0) THEN
           return
        END IF
      END IF
C
C
C*          1.3  SET THE POINTERS NWPTB AND NBPTB.
C                ---------------------------------
C                TO BEGINING OF THE NEXT SECTION.
C                --------------------------------
 130  CONTINUE
C
      CALL BUNEXS(KSEC4(1))
C
C
C*          1.4  EXPAND RESERVED BYTE.
C                ---------------------
 140  CONTINUE
C
      CALL BUNPCK(NBPW,KBUFF,KSEC4(2),NWPT,NBPT, 8,KERR)
      IF(KERR.GT.0) THEN
         WRITE(KNTN,*)  'ERROR UNPACKING KSEC4(2).'
         RETURN
      END IF
C
C     -----------------------------------------------------------------
C*          2. EXPAND DATA.
C              ------------
 200  CONTINUE
C
C
C*          2.1  CHECK IF DATA ARE COMRESSED.
C                ----------------------------
 210  CONTINUE
C
      IB=0
      IF(IAND(KSEC3(4),IMASK(7)).NE.0) IB=1
C
      IF(IB.EQ.0) THEN
C
C     ------------------------------------------------------------------
C
C*          3.  UNCOMPRESSED DATA.
C               ------------------
 300  CONTINUE
C
         IF(OMULTI) N=1
C
         DO 301 JNS=1,N
C
         ITEMPREP=0

         IF(OMULTI) THEN
            JNSK=(NSUBSET-1)*KELEM
            JNSK1=(JNS-1)*KELEM
         ELSE
            JNSK=(JNS-1)*KELEM
         END IF
C
         DO 302 JWT=1,M
C
         IF(OMULTI) THEN
            JWTJNS1=JWT+JNSK1
            JWTJNS=JWT+JNSK
         ELSE
            JWTJNS=JWT+JNSK
         END IF
C
c        IF(ITEMPREP.GT.0) THEN
c           IF(NWTR(JWT-1).NE.031011.AND.NWTR(JWT-1)
c    1         .NE.031012) THEN
c              VALUES(JWTJNS)=VALUES(JWTJNS-1)
c              ITEMPREP=ITEMPREP-1
c              GO TO 302
c           ELSE
c              ITEMPREP=ITEMPREP-1
c           END IF
c        END IF

         IF(INWTDW(JWT).EQ.0) THEN
            VALUES(JWTJNS)=0.0
            GO TO 302
         END IF
C
         IF(OMULTI) THEN
            NWPT=INWORDP(JWTJNS1)
            NBPT=INBITP (JWTJNS1)
         ELSE
            NWPT=INWORDP(JWTJNS)
            NBPT=INBITP (JWTJNS)
         END IF
C
c        IF(INWTR(JWT).EQ.31011.OR.INWTR(JWT).EQ.31012) OREPF=.TRUE.
C
C
C     ------------------------------------------------------------------
C*          3.1 CHARACTER DATA / IEEE ?
C               -----------------------
 310  CONTINUE
C
         IF(INWTEN(JWT).EQ.-999) THEN
            IBYTES=INWTDW(JWT)/8
            CALL BUNPKS(NBPW,KBUFF,ILIST,NWPT,NBPT,
     1                  8,0,IBYTES,KERR)
            IF(IBYTES.EQ.4) THEN
               OBIG=BIG_ENDIAN()
               CALL BUSBYTESR4(VVV4,ILIST,0,8,0,IBYTES)
               IF(.NOT.OBIG) THEN
                  CALL SWAP_BYTES4(VVV4,VVV4S)
                  VVV4=VVV4S
               END IF
               IF(ABS(VVV4-R4)/R4.LT.EPS) THEN
                  VALUES(JWTJNS)=RVIND
               ELSE
                  VALUES(JWTJNS)=VVV4
               END IF
            ELSE
               OBIG=BIG_ENDIAN()
               CALL BUSBYTESR8(VVV8,ILIST,0,8,0,IBYTES)
               IF(.NOT.OBIG) THEN
                  CALL SWAP_BYTES8(VVV8,VVV8S)
                  VVV8=VVV8S
               END IF
               IF(ABS(VVV8-R8)/R8.LT.EPS) THEN
                  VALUES(JWTJNS)=RVIND
               ELSE
                  VALUES(JWTJNS)=VVV8
               END IF
            END IF
            GO TO 302
         END IF
C
         IF(INWTEN(JWT).EQ.658367) THEN
C
C*          3.2  OBTAIN CHARACTER DATA FROM DATA SECTION.
C                ----------------------------------------
 320  CONTINUE
C
            IY=INWTDW(JWT)/8
C
            CALL  BUUNPS(NBPW,KBUFF,ICH,NWPT,NBPT,8,0,IY,KERR)
            IF(KERR.GT.0) THEN
               WRITE(KNTN,*)  'ERROR UNPACKING CHARACTER DATA.'
               RETURN
            END IF
C
C*          3.3  MOVE CHARACTER DATA TO "CVALS".
C                -------------------------------
 330  CONTINUE
C
            IYLINE=IY/80
            IYOFF =IY-IYLINE*80
            JCVINC=IYLINE
C
            JCV = JCV + 1
            JCVW= JCV
C
            IF(IYLINE.EQ.0) THEN
               CVALS(JCVW)=' '
               DO 331 J=1,IY
               CVALS(JCVW)(J:J)=CHAR(ICH(J))
 331           CONTINUE
            ELSE
               CVALS(JCVW)=' '
               DO 332 J=1,IYLINE
               DO 333 JJ=1,80
               CVALS(JCVW)(JJ:JJ)= CHAR(ICH(JJ))
 333           CONTINUE
C
               JCVW=JCVW+1
C
 332           CONTINUE
C
               CVALS(JCVW)=' '
               DO 334 J=1,IYOFF
               CVALS(JCVW)(J:J)= CHAR(ICH(J))
 334           CONTINUE
C
            END IF
C
C*          3.4  COMPUTE POINTER VALUES TO BE STORED IN "VALUES".
C                ------------------------------------------------
 340  CONTINUE
C
            VALUES(JWTJNS) = JCV*1000 + IY
            JCV            = JCV + JCVINC
C
            GO TO 302
C
         END IF
C
C*          3.5  OBTAIN VALUE FROM DATA SECTION.
C                -------------------------------
 350  CONTINUE
C
         IF(NWTEN(JWT).EQ.836970) THEN
            ISGN=0
            IWPT=NWPT
            IBPT=NBPT
C
            CALL GBYTE(KBUFF(IWPT),ISGN,IBPT,1)
C
            IBPT=IBPT+1
            IWORD= IBPT/NBPW
            IBPT= IBPT - IWORD*NBPW
            IWPT= IWPT + IWORD
C
            CALL GBYTE(KBUFF(IWPT),IVAL,IBPT,INWTDW(JWT)-1)
            VALUES(JWTJNS)= DFLOAT(IVAL)
            IF(ISGN.EQ.1) VALUES(JWTJNS)=-VALUES(JWTJNS)
            GO TO 302
         ELSE
            CALL GBYTE(KBUFF(NWPT),IVAL,NBPT,INWTDW(JWT))
         END IF
C
C
C     -----------------------------------------------------------------
C*          3.6  UPDATE THE ARRAY "VALUES".
C                --------------------------
 360  CONTINUE
C
C
C        CHECK IF DATA IS MISSING
C
         IF(IVAL.EQ.NMASK(INWTDW(JWT))) THEN
            IF(INWTDW(JWT).NE.1) THEN
               IF(INWTR(JWT).NE.999999.AND.
     1            INWTR(JWT).NE.030001.AND.INWTR(JWT).NE.030002.AND.
     2            INWTR(JWT).NE.030004) THEN
                  VALUES(JWTJNS)=RVIND
               ELSE
                  VALUES(JWTJNS)=ival
               END IF
            ELSE
               VALUES(JWTJNS)=1.0
            END IF
         ELSE
            IVAL=IVAL+INWTRV(JWT)
            IF(INWTS(JWT).GT.0) THEN
               VALUES(JWTJNS)= DFLOAT(IVAL)/10.**INWTS(JWT)
            ELSE
               IIWTS=IABS(INWTS(JWT))
               VALUES(JWTJNS)= DFLOAT(IVAL)*10.**IIWTS
            END IF
         END IF
C
c        IF(INWTR(JWT).EQ.31011.OR.INWTR(JWT).EQ.31012) THEN
c           ITEMPREP=VALUES(JWTJNS)
c        END IF

 302     CONTINUE
C
         KSUP(7)=JCV
C
 301     CONTINUE
C
         IF(OMULTI) THEN
            IBIT=NBITP(NSIZEG(NSUBSET)) + NWTDW(NSIZEG(NSUBSET))
            IWORD=IBIT/NBPW
            NBP=IBIT-IWORD*NBPW
            NWP=NWORDP(NSIZEG(NSUBSET))+IWORD
         END IF
      ELSE 
C     ------------------------------------------------------------------
C
C*          4.  COMPRESSED DATA.
C               ----------------
 400  CONTINUE
C
C*          4.1 OBTAIN N VALUES BY EXPANSION.
C               -----------------------------
 410  CONTINUE
C
         DO 411 JWT=1,M
C
         NWPT=INWORDP(JWT)
         NBPT=INBITP (JWT)
C
         IF(INWTDW(JWT).EQ.0) THEN
            DO 412 J=1,N
            JWTJ=JWT+(J-1)*KELEM
            VALUES(JWTJ)=0.0
 412        CONTINUE
C
            GO TO 411
         END IF
C
C        CHECK IF CHARACTER DATA
C
         IF(INWTEN(JWT).EQ.658367) THEN
            IICH=INWTDW(JWT)/8
            CALL BUNPKS(NBPW,KBUFF,IRO,NWPT,NBPT,8,0,IICH,KERR)
            IF(KERR.GT.0) THEN
               WRITE(KNTN,*)  'ERROR UNPACKING REFERENCE VALUES FOR'
               WRITE(KNTN,*)  JWT,' ELEMENT, OF ',J,' SUBSET.'
               RETURN
            END IF
            CALL BUNPCK(NBPW,KBUFF,IDWINC,NWPT,NBPT,6,KERR)
            IF(KERR.GT.0) THEN
               WRITE(KNTN,*)  'ERROR UNPACKING NUMBER OF BITS FOR ',
     1                        'INCREMENTS'
               WRITE(KNTN,*)  'FOR ',JWT,' ELEMENT, OF ',J,' SUBSET'
               RETURN
            END IF
C
            ITOTAL=IDWINC*KSEC3(3)
            IF(ITOTAL.GT.JWORK) THEN
               KERR=17
               CALL BUERR(KERR)
               RETURN
            END IF 
C
            DO 413 J=1,ITOTAL
            ILIST(J)=0
 413        CONTINUE
C
            CALL BUNPKS(NBPW,KBUFF,ILIST,NWPT,NBPT,
     1                  8,0,ITOTAL,KERR)
            IF(KERR.GT.0) RETURN
C
C           MOVE CHARACTER DATA TO "CVALS" ARRAY.
C
            IY=IDWINC
            IF(IY.EQ.0) THEN
               IY=IICH
               IZ=0
               IF(IICH*KSEC3(3).GT.JWORK) THEN
                  KERR=17
                  CALL BUERR(KERR)
                  RETURN
               END IF
               DO IXX=1,KSEC3(3)
               DO IZZ=1,IICH
               IZ=IZ+1
               ILIST(IZ)=IRO(IZZ)
               END DO
               END DO
            END IF
C
            IYLINE=IY/80
            IYOFF=IY-IYLINE*80
C
            JCVINC=IYLINE
            JJC=0
C
            DO 414 I=1,KSEC3(3)
C
            JCV=JCV+1
            JCVW=JCV
C
            IF(IYLINE.EQ.0) THEN
               CVALS(JCVW)=' '
               DO 415 J=1,IY
               JJC=JJC+1
               CVALS(JCVW)(J:J)=CHAR(ILIST(JJC))
 415           CONTINUE
C
            ELSE
C
               CVALS(JCVW)=' '
               DO 416 J=1,IYLINE
               DO 417 JJJ=1,80
               JJC=JJC+1
               CVALS(JCVW)(JJJ:JJJ)=CHAR(ILIST(JJC))
 417           CONTINUE
C
               JCVW=JCVW+1
 416           CONTINUE
C
               CVALS(JCVW)=' '
               DO 418 J=1,IYOFF
               JJC=JJC+1
               CVALS(JCVW)(J:J)=CHAR(ILIST(JJC))
 418           CONTINUE
C
            END IF
C
C           COMPUTE POINTERS TO VALUES ARRAY
C
            JWTI=JWT+(I-1)*KELEM
C           VALUES(JWTI)=JCV*1000+IY
            VALUES(JWTI)=JCV*1000+INWTDW(JWT)/8
            JCV         =JCV+JCVINC
C
 414        CONTINUE
C
            GO TO 411
C
         ELSEIF(INWTEN(JWT).EQ.-999) THEN
            IICH=INWTDW(JWT)/8
            CALL BUNPKS(NBPW,KBUFF,IR0LIST,NWPT,NBPT,8,0,IICH,KERR)
            IF(KERR.GT.0) THEN
               WRITE(KNTN,*)  'ERROR UNPACKING REFERENCE VALUES FOR',
     1                         JWT,' ELEMENT, OF ',J,' SUBSET.'
               RETURN
            END IF
            CALL BUNPCK(NBPW,KBUFF,IDWINC,NWPT,NBPT,6,KERR)
            IF(KERR.GT.0) THEN
               WRITE(KNTN,*)  'ERROR UNPACKING NUMBER OF BITS FOR ',
     1                        'INCREMENTS'
               WRITE(KNTN,*)  'FOR ',JWT,' ELEMENT, OF ',J,' SUBSET'
               RETURN
            END IF
C
            IF(IDWINC.NE.0) THEN
               ITOTAL=IDWINC*KSEC3(3)
               DO J=1,ITOTAL
                 ILIST(J)=0
               END DO
C
               CALL BUNPKS(NBPW,KBUFF,ILIST,NWPT,NBPT,
     1                     8,0,ITOTAL,KERR)
               IF(KERR.GT.0) RETURN
C
C
C              COMPUTE POINTERS TO VALUES ARRAY
C
               JJC=0
               DO I=1,KSEC3(3)
                JWTI=JWT+(I-1)*KELEM
C
                DO J=1,IICH
                 JJC=JJC+1
                 IILIST(J)=ILIST(JJC)
                END DO

                IF(IICH.EQ.4) THEN
                  CALL BUSBYTESR4(RHUGE4,IILIST,0,8,0,IICH)
                   OBIG=BIG_ENDIAN()
                   IF(.NOT.OBIG) THEN
                      CALL SWAP_BYTES4(RHUGE4,VAL4S)
                      RHUGE4=VAL4S
                   END IF
                  VALUES(JWTI)=RHUGE4
                  IF(ABS(VALUES(JWTI)-R4)/R4.LT.EPS) THEN
                     VALUES(JWTI)=RVIND               
                  END IF
                ELSE
                  CALL BUSBYTESR8(RHUGE8,IILIST,0,8,0,IICH)
                  OBIG=BIG_ENDIAN()
                   IF(.NOT.OBIG) THEN
                      CALL SWAP_BYTES8(RHUGE8,VAL8S)
                      RHUGE8=VAL8S
                   END IF
                  VALUES(JWTI)=RHUGE8
                  IF(ABS(VALUES(JWTI)-R8)/R8.LT.EPS) THEN
                     VALUES(JWTI)=RVIND               
                  END IF
                END IF
C
               END DO
            ELSE
                IF(IICH.EQ.4) THEN
                   CALL BUSBYTESR4(RHUGE4,IR0LIST,0,8,0,IICH)
                   OBIG=BIG_ENDIAN()
                   IF(.NOT.OBIG) THEN
                      CALL SWAP_BYTES4(RHUGE4,VAL4S)
                      RHUGE4=VAL4S
                   END IF
                   DO I=1,KSEC3(3)
                    JWTI=JWT+(I-1)*KELEM
                    IF(ABS(RHUGE4-R4)/R4.LT.EPS) THEN
                       VALUES(JWTI)=RVIND
                    ELSE 
                       VALUES(JWTI)=RHUGE4
                    END IF
                   END DO
                ELSE          
                   CALL BUSBYTESR8(RHUGE8,IR0LIST,0,8,0,IICH)
                   OBIG=BIG_ENDIAN()
                   IF(.NOT.OBIG) THEN
                      CALL SWAP_BYTES8(RHUGE8,VAL8S)
                      RHUGE8=VAL8S
                   END IF
                   DO I=1,KSEC3(3)
                    JWTI=JWT+(I-1)*KELEM
                    IF(ABS(RHUGE8-R8)/R8.LT.EPS) THEN
                       VALUES(JWTI)=RVIND
                    ELSE
                       VALUES(JWTI)=RHUGE8
                    END IF
                   END DO
                END IF 
            END IF
C
            GO TO 411
         ELSE
            IF(INWTEN(JWT).EQ.836970) THEN
               CALL BUNPCK(NBPW,KBUFF,ISG_REF,NWPT,NBPT,1,KERR)
               CALL BUNPCK(NBPW,KBUFF,IR0,NWPT,NBPT,INWTDW(JWT)-1,KERR)
               IF(KERR.GT.0) THEN
                  WRITE(KNTN,*)  'ERROR UNPACKING REFERENCE VALUES FOR'
                  WRITE(KNTN,*)  JWT,' ELEMENT.'
                  RETURN
               END IF
            ELSE
               CALL BUNPCK(NBPW,KBUFF,IR0,NWPT,NBPT,INWTDW(JWT),KERR)
               IF(KERR.GT.0) THEN
                  WRITE(KNTN,*)  'ERROR UNPACKING REFERENCE VALUES FOR'
                  WRITE(KNTN,*)  JWT,' ELEMENT.'
                  RETURN
               END IF
            END IF
            CALL BUNPCK(NBPW,KBUFF,IDWINC,NWPT,NBPT,6,KERR)
            IF(KERR.GT.0) THEN
               WRITE(KNTN,*)  'ERROR UNPACKING NUMBER OF BITS FOR'
               WRITE(KNTN,*)  'INCREMENTS, FOR ',JWT,' ELEMENT.'
               RETURN
            END IF
            IF(IDWINC.GT.JBPW) THEN
               KERR=15
               WRITE(KNTN,*)  ' BUEXS4 :'
               CALL BUERR(KERR)
               PRINT*,'JWT=',JWT,'REF=',INWTR(JWT)
               RETURN
            END IF
         END IF
C
         DO 423 J=1,N
         ILIST(J)=0
 423     CONTINUE
C
         IF(IDWINC.NE.0) THEN
            CALL BUNPKS(NBPW,KBUFF,ILIST,NWPT,NBPT,
     1                  IDWINC,0,N,KERR)
            IF(KERR.GT.0) THEN
               WRITE(KNTN,*)  'ERROR UNPACKING INCREMENTS ',
     1                        'FOR ',JWT,' ELEMENT.'
               RETURN
            END IF
         END IF
C
         IF(INWTEN(JWT).NE.658367) THEN
            IF(IR0.EQ.NMASK(INWTDW(JWT))) THEN
               DO 425 J=1,N
               IVALUES(J)=NMASK(INWTDW(JWT))
 425           CONTINUE
            ELSE
               IWTPR0=INWTRV(JWT)+IR0
C
               IF(IDWINC.EQ.0) THEN
                  DO 426 J=1,N
                  IVALUES(J)=IWTPR0
 426              CONTINUE
C
               ELSE
                  DO 424 J=1,N
                  IF(ILIST(J).EQ.NMASK(IDWINC)) THEN
                     IVALUES(J)=NMASK(INWTDW(JWT))
                  ELSE
                     IVALUES(J)= IWTPR0 + ILIST(J)
                  END IF
 424              CONTINUE
C
               END IF
            END IF
         END IF
C
         DO 427 J=1,N
C
         JWTJ=JWT+(J-1)*KELEM
C
         IF(INWTDW(JWT).NE.1) THEN 
            VALUES(JWTJ)=RVIND
         ELSE
            VALUES(JWTJ)=1.0
         END IF
            
         IF(IVALUES(J).NE.NMASK(INWTDW(JWT))) THEN
            IF(INWTS(JWT).GT.0) THEN
               VALUES(JWTJ)= DFLOAT(IVALUES(J))/10.**INWTS(JWT)
            ELSE
               IIWTS=IABS(INWTS(JWT))
               VALUES(JWTJ)= DFLOAT(IVALUES(J))*10.**IIWTS
            END IF
         END IF
C
         IF(INWTEN(JWT).EQ.836970.AND.ISG_REF.EQ.1) THEN
            VALUES(JWTJ)= - VALUES(JWTJ)
         END IF
 427     CONTINUE
C
 411     CONTINUE
C
         KSUP(7)=JCV
C
      END IF
C
C     ------------------------------------------------------------------
C*             5.  REPEAT ENTRIES IN CNAMES,CUNITS AND VALUES IF NEEDED.
C                  -----------------------------------------------------
 500  CONTINUE
C
      IF(.NOT.OREPF) GO TO 600
      IST=1
C
C*             5.1 SEARCH CNAMES FOR DELAYED REPETITION FACTOR.
C                  --------------------------------------------
 510  CONTINUE
C
C      DO 511 J=IST,M
C      IF(INWTR(J).EQ.31001.OR.INWTR(J).EQ.31002
C     1   .OR.INWTR(J).EQ.31000) GO TO 520
C 511  CONTINUE
C
C      GO TO 600
C
C*             5.2 GET REPETITION FACTOR FROM ARRAY "VALUES".
C                  -------------------------------------------
 520  CONTINUE
C
C      IREPF=VALUES(J)
C      CNAMR=CNAMES(J+1)
C      CUNIR=CUNITS(J+1)
C      VALUR=VALUES(J+1)
C
C*             5.3 PUSH DOWN ENTRIES IN CNAMES,CUNITS,VALUES.
C                  ------------------------------------------
 530  CONTINUE
C
C      IREPM2=IREPF-2
C
C      DO 531 JA=M,J+2,-1
C
C      CNAMES(JA+IREPM2)=CNAMES(JA)
C      CUNITS(JA+IREPM2)=CUNITS(JA)
C
C      DO 932 JB=1,N
C
C      JAJB=JA+(JB-1)*KELEM
C
C      VALUES(JAJB+IREPM2)=VALUES(JAJB)
C 932  CONTINUE
C
C 531  CONTINUE
C
C*             5.4 REPETITION.
C                  -----------
 540  CONTINUE
C
C      DO 541 JA=1,IREPF
C      CNAMES(J+JA)=CNAMR
C      CUNITS(J+JA)=CUNIR
C
C      DO 542 JB=1,N
C
C      JAJB=JA+(JB-1)*KELEM
C
C      VALUES(J+JAJB)=VALUR
C 542  CONTINUE
C
C 541  CONTINUE
C
C*             5.5 UPDATE M AND POINTER TO CONTINUE SEARCH.
C                  ----------------------------------------
C 550  CONTINUE
C
C      M=M+IREPF-2
C      IST=J+IREPF
C
C      GO TO 510
C
C     -----------------------------------------------------------------
C*            6.  SET SUPPLEMENTARY INFORMATION.
C                 ------------------------------
C
 600  CONTINUE
C
      KSUP(4)= 2
C
C     ------------------------------------------------------------------
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE ECDEF10( HFUNC, KSEC1, KGRIB, KLENG, KNSPT, KBITS,
     X                    KPLEN, KPR, KRET)
C
C---->
C**** ECDEF10
C
C     Purpose.
C     --------
C
C     GRIB coding/decoding of ECMWF local use definition 10.
C
C**   Interface.
C     ----------
C
C     CALL ECDEF10( HFUNC, KSEC1, KGRIB, KLENG, KNSPT, KBITS, KPR, KRET)
C
C
C     Input Parameters.
C     -----------------
C
C     HFUNC      - Requested function.
C                  'C' to code data.
C                  'D' to decode data.
C
C     KSEC1      - Array containing Grib Section 1 data.
C
C     KGRIB      - Array containing Grib coded data.
C
C     KLENG      - Length (words) of KGRIB.
C
C     KNSPT      - Bit number after which insertion/extraction starts.
C
C     KBITS      - Number of bits in computer word.
C
C     KPLEN      - Pointer to field containing length of Section 1
C
C     KPR        - Debug print switch.
C                  0  , No printout.
C                  >0 , Debug printout.
C
C     KRET       - Response to error indicator.
C                  0        , Abort if error encountered.
C                  Non-zero , Return to calling routine
C                             even if error encountered.
C
C     Output Parameters.
C     ------------------
C
C     KSEC1      - Array containing Grib Section 1 data.(Updated)
C
C     KGRIB      - Array containing Grib coded data.(Updated)
C
C     KNSPT      - Number of bit after last one inserted/extracted.
C                  (Updated)
C
C     KRET       - Return code.
C                  0   , No error encountered.
C                  2   , Error reported by routine INXBIT.
C
C
C     Method.
C     -------
C
C     Input data packed/unpacked in accordance with ECMWF usage of
C     local part of section 1 of Grib code, definition 10.
C
C
C     Externals.
C     ----------
C
C     INXBIT  - insert/extract bits
C     ABORTX  - abort the program
C     CSGNBT  - code a signed value
C     DSGNBT  - decode a signed value
C
C
C     Reference.
C     ----------
C
C     WMO Manual On Codes for Grib Code.
C
C
C     Comments.
C     ---------
C
#include "ecdef10.h"
C
C
C     Author.
C     -------
C
C     J.D.Chambers     ECMWF      February 1998
C
C
C     Modifications.
C     --------------
C
C     None
C
C
C----<
C     ------------------------------------------------------------------
C*    Section 0 . Definition of variables. Data statements.
C     ------------------------------------------------------------------
C
      IMPLICIT NONE
C
#include "common/grprs.h"
C
C     Parameters
C
      CHARACTER*1   HFUNC
      INTEGER KSEC1, KGRIB, KLENG, KNSPT, KBITS, KPLEN, KPR, KRET
      DIMENSION KGRIB(*)
      DIMENSION KSEC1(*)
C
C     Local variables
C
      INTEGER IRET, LENS1, N, INSPT
      INTEGER ILALO
      DIMENSION ILALO(4)
C
      LOGICAL LENCODE, LDECODE
C
C     ------------------------------------------------------------------
C*    Section 1 . Set initial values.
C     ------------------------------------------------------------------
C
  100 CONTINUE
C
      IRET = KRET
      LENCODE = ( HFUNC .EQ. 'C' )
      LDECODE = .NOT. LENCODE
C
C     ------------------------------------------------------------------
C*    Section 2 . Handle tube.
C     ------------------------------------------------------------------
C
  200 CONTINUE
C
C     Octet 50: Tube number
C     Octet 51: Total number of tubes
C     Octet 52: Central cluster definition
C     Octet 53: Indicator of parameter considered
C     Octet 54: Indicator of type of level
C     Five 8-bit fields.
C
      CALL INXBIT(KGRIB,KLENG,KNSPT,KSEC1(42),5,KBITS,8,HFUNC,KRET)
      IF (KRET.NE.0) THEN
        KRET = 2
        WRITE(GRPRSM,*) 'ECDEF10: Error reported by routine INXBIT:'
        IF( LENCODE ) THEN
          WRITE(GRPRSM,*) '      encoding section 1, elements 42 - 46.'
        ELSE
          WRITE(GRPRSM,*) '      decoding section 1, octets 50 - 54.'
        ENDIF
      ENDIF
C
C     Octets 55-57: Northern latitude of the domain of tubing
C     Octets 58-60: Western longitude of the domain of tubing
C     Octets 61-63: Southern latitude of the domain of tubing
C     Octets 64-66: Eastern longitude of the domain of tubing
C     Four 24-bit fields.
C
C     When coding values, set sign bit to 1, if value is negative.
C
      IF ( LENCODE ) THEN
        CALL CSGNBT( ILALO(1), KSEC1(47), 24, KRET)
        CALL CSGNBT( ILALO(2), KSEC1(48), 24, KRET)
        CALL CSGNBT( ILALO(3), KSEC1(49), 24, KRET)
        CALL CSGNBT( ILALO(4), KSEC1(50), 24, KRET)
      ENDIF
C
      CALL INXBIT(KGRIB,KLENG,KNSPT,ILALO(1),4,KBITS,24,HFUNC,KRET)
      IF (KRET.NE.0) THEN
        KRET = 2
        WRITE(GRPRSM,*) 'ECDEF10: Error reported by routine INXBIT:'
        IF( LENCODE ) THEN
          WRITE(GRPRSM,*) '      encoding section 1, elements 47 - 50.'
        ELSE
          WRITE(GRPRSM,*) '      decoding section 1, octets 55 - 66.'
        ENDIF
      ENDIF
C
C     When decoding values, if sign bit is 1, value is
C     negative.
C
      IF ( LDECODE ) THEN
        CALL DSGNBT( KSEC1(47), ILALO(1), 24, KRET)
        CALL DSGNBT( KSEC1(48), ILALO(2), 24, KRET)
        CALL DSGNBT( KSEC1(49), ILALO(3), 24, KRET)
        CALL DSGNBT( KSEC1(50), ILALO(4), 24, KRET)
      ENDIF
C
C     Octet 67: Number of tube to which operational forecast belongs
C     Octet 68: Number of tube to which control forecast belongs
C     Two 8-bit fields.
C
      CALL INXBIT(KGRIB,KLENG,KNSPT,KSEC1(51),2,KBITS,8,HFUNC,KRET)
      IF (KRET.NE.0) THEN
        KRET = 2
        WRITE(GRPRSM,*) 'ECDEF10: Error reported by routine INXBIT:'
        IF( LENCODE ) THEN
          WRITE(GRPRSM,*) '      encoding section 1, elements 51 - 52.'
        ELSE
          WRITE(GRPRSM,*) '      decoding section 1, octets 67 - 68.'
        ENDIF
      ENDIF
C
C     Octets 69-70: Height/pressure of level considered
C     Octets 71-72: Reference step considered
C     Octets 73-74: Radius of central cluster
C     Octets 75-76: Ensemble standard deviation
C     Octets 77-78: Distance of the tube extreme to the ensemble mean
C     Five 16-bit fields.
C
      CALL INXBIT(KGRIB,KLENG,KNSPT,KSEC1(53),5,KBITS,16,HFUNC,KRET)
      IF (KRET.NE.0) THEN
        KRET = 2
        WRITE(GRPRSM,*) 'ECDEF10: Error reported by routine INXBIT:'
        IF( LENCODE ) THEN
          WRITE(GRPRSM,*) '      encoding section 1, elements 53 - 57.'
        ELSE
          WRITE(GRPRSM,*) '      decoding section 1, octets 69 - 78.'
        ENDIF
      ENDIF
C
C     Octet 79: Number of forecasts belonging to the tube
C     One 8-bit field.
C
      CALL INXBIT(KGRIB,KLENG,KNSPT,KSEC1(58),1,KBITS,8,HFUNC,KRET)
      IF (KRET.NE.0) THEN
        KRET = 2
        WRITE(GRPRSM,*) 'ECDEF10: Error reported by routine INXBIT:'
        IF( LENCODE ) THEN
          WRITE(GRPRSM,*) '      encoding section 1, element 58.'
        ELSE
          WRITE(GRPRSM,*) '      decoding section 1, octet 79.'
        ENDIF
      ENDIF
C
C*    The number of forecasts belonging to a cluster may vary,
C     but section 1 is kept a fixed length.
C
      INSPT = KNSPT + 255*8
C
C     Octets 80-(79+N): List of N ensemble forecast numbers
C     N 8-bit fields.
C
      N = KSEC1(58)
      CALL INXBIT(KGRIB,KLENG,KNSPT,KSEC1(59),N,KBITS,8,HFUNC,KRET)
      IF (KRET.NE.0) THEN
        KRET = 2
        WRITE(GRPRSM,*) 'ECDEF10: Error reported by routine INXBIT:'
        IF( LENCODE ) THEN
          WRITE(GRPRSM,*)
     X  '      encoding section 1, element 59 onwards.'
        ELSE
          WRITE(GRPRSM,*)
     X '      decoding section 1, octet 80 onwards.'
        ENDIF
      ENDIF
C
      KNSPT = INSPT
C
C     On encoding, record the length of section 1.
C
      IF( LENCODE ) THEN
        LENS1 = 79 + 255
        CALL INXBIT(KGRIB,KLENG,KPLEN,LENS1, 1,KBITS,24,HFUNC,KRET)
        IF (KRET.NE.0) THEN
          KRET = 2
          WRITE(GRPRSM,*) 'ECDEF10: Error reported by routine INXBIT:'
          WRITE(GRPRSM,*) '         encoding length of section 1.'
        ENDIF
      ENDIF
C
C     ------------------------------------------------------------------
C*    Section 9 . Abort/return to calling routine. Format statements.
C     ------------------------------------------------------------------
C
  900 CONTINUE
C
      IF( KPR.GE.1 ) THEN
        WRITE(GRPRSM,*) 'ECDEF10: Section 9.'
        WRITE(GRPRSM,*) '        Output values set, KNSPT = ', KNSPT
      ENDIF
C
C     Abort if requested to do so when an error has been encountered.
C
      IF (IRET.EQ.0.AND.KRET.NE.0) THEN
        CALL ABORTX ('ECDEF10')
      ELSE
        RETURN
      ENDIF
C
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

#if (defined CRAY) || (defined __uxp__ ) || (defined IBM_POWER4) || (defined rs6000) || (defined NECSX) || (defined POWERPC)
      SUBROUTINE GSBITE (KS,KD,KSKST,KSIZE,KSKBTW,K,KBPW,KMASK,HADIR)
C
C---->
C**** GSBITE - Extraction/insertion of bits from/to bitstream on Cray.
C
C     Purpose.
C     --------
C
C     Vectorising extraction/insertion of bits from/to bitstream.
C
C**   Interface.
C     ----------
C
C     CALL GSBITE (KS,KD,KSKST,KSIZE,KSKBTW,K,KBPW,KMASK,HADIR)
C
C
C     Input Parameters.
C     -----------------
C
C     KS      - If HADIR='D', input bit stream, else output bit stream.
C     KD      - If HADIR='D', output words, else input words.
C     KSKST   - Number of bits skipped at beginning of KS.
C     KSIZE   - Number of bits to be extracted to one word of KD.
C     KSKBTW  - Number of bits skipped between 2 words to be extracted.
C     K       - Number of words to be extracted into KD. If less than
C               or equal to 0 only calculate KBPW and KMASK.
C     KBPW    - Number of bits per word in KS,calculated if 0.
C     KMASK   - Masks for bit patterns, calculated if KMASK(2) is 0.
C               (KMASK must have dimension KBPW+1)
C     HADIR   - Direction of conversion: 'D' for decoding, ie
C               extract words KD(1...K) from bits KS(KSKST+1....)
C               If not 'D', encode, i.e. pack words KD(1....K) into
C               bits KS(KSKST+1.....KSKST+K*(KSIZE+KSKBTW))
C
C
C     Output Parameters.
C     ------------------
C
C     KS,KD   - See above.
C     KSKST   - Updated to number of bits used, i.e. to
C               KSKST+K*(KSIZE+KSKBTW)
C     KBPW    - If 0 on input, number of bits in each word of KS.
C     KMASK   - If KMASK(2) was 0 on input, bit pattern masks.
C               (KMASK must have dimension KBPW+1)
C
C
C     Method.
C     -------
C
C     Vector loop is over repeatedly occurring bit patterns.
C
C     Externals.
C     ----------
C
C     None.
C
C
C     Reference.
C     ----------
C
C     None.
C
C
C     Comments.
C     ---------
C
C     This routine is for vector processors only.
C
C
C     Author.
C     -------
C
C     G.J.Cats 08 Dec 87
C
C
C     Modifications.
C     --------------
C
C     J. Hennessy     ECMWF     09.09.91
C     Introductory comments changed to conform to standard.
C
C     J.D.Chambers    ECMWF     05.01.95
C     Put in fixes suggested by G.Cats (Dec. 95) for:
C     i)    "Number of words to be extracted = 0"
C     ii)   Optimise test for encode/decode in loop by using logical.
C     iii)  Intialise ISTS before use.
C
C     J.D.Chambers    ECMWF     22.05.96
C     Defines to remove inline functions except on CRAY
C     (The Fujitsu doesn't need them).
C
C     J. Clochard, Meteo France, for ECMWF - January 1998.
C     Use intrinsic functions on CRAY.
C
C
C     ------------------------------------------------------------------
C----<
C
      DIMENSION KS(*),KD(*),KMASK(*)
      CHARACTER*1 HADIR
      LOGICAL     LODECD
C
C     1.  COMPLETE KBPW AND KMASK, RETURN IF 0 WORDS ARE TO BE EXTRACTED
C
      IF(KBPW.EQ.0) THEN
         IS    = KS(1)
         KS(1) = 1
 1101    CONTINUE
         IF(KS(1).NE.0) THEN
            KBPW  = KBPW + 1
            KS(1) = ISHFT(KS(1),1)
            GOTO 1101
         ENDIF
         KS(1) = IS
      ENDIF
      IF(KMASK(2).EQ.0) THEN
         KMASK(KBPW+1) = 0
         DO 1110 J = KBPW,1,-1
           KMASK(J) = IBSET(KMASK(J+1),KBPW-J)
 1110    CONTINUE
      ENDIF
      IF(K.LE.0)RETURN
C
C     2.  PRESET KD TO 0 IF KD IS OUTPUT I.E. WHEN DECODING
C
      LODECD = HADIR .EQ. 'D'
      IF (LODECD) THEN
         DO 2101 J = 1,K
           KD(J) = 0
 2101    CONTINUE
      ENDIF
      IF(KSIZE.LE.0) RETURN
C
C     3.  CALCULATE SEVERAL PARAMETERS FOR LOOPING (FOR EFFICIENCY, THE
C         CODE OF SECTIONS 3.3 AND 3.4 FOR K=1 IS SEPARATED INTO 3.2)
C
C     3.1 NUMBER OF BITS USED PER WORD, INITIAL NR OF SKIPPED BITS
C
      ISTEP = KSIZE + KSKBTW
      ISKWS = KSKST
C
C     3.2 VECTOR LOOP LENGTH AND STEP SIZE IN KD IF K=1;KS STEP IRRELVNT
C
      IF(K.EQ.1) THEN
         ILL  = 1
         IBDL = 2
         ISTD = 1
         ISTS = 1
      ELSE
C
C     3.3 STEP SIZES IN KS,KD: INVERSE OF LARGEST FACTOR OF ISTEP,KBPW
C
         ILCF = KBPW
         ISHF = ISTEP
 331     CONTINUE
         IF(ILCF.EQ.ISHF) GOTO 332
         IF(ILCF.EQ.1) GOTO 332
         IF(ILCF.GT.ISHF) THEN
            ILCF = ILCF - ISHF
         ELSE
            ISHF = ISHF - ILCF
         ENDIF
         GOTO 331
 332     CONTINUE
         ISTD = KBPW/ILCF
         ISTS = ISTEP/ILCF
C
C     3.4 VECTOR LOOP LENGTH AND SWITCH-OVER POINT FOR SMALLER LOOP
C
         ILL  = (K-1)/ISTD + 1
         IBDL = K - (ILL-1)*ISTD
      ENDIF
C
C     4.  LOOP OVER FIRST ISTD WORDS OF KD (TRAILS THE VECTOR LOOP)
C
      DO 790 JBD = 1,ISTD
C
C       4.1 LAST BIT IN KS TO BE TREATED
C
        IENBS = ISKWS + KSIZE
C
C       4.2 NR OF WORDS OF KS TO BE SKIPPED, NR OF BITS IN THOSE AND
C           THIS
C
        ISKW = ISKWS/KBPW
        ISTA = ISKW*KBPW
        ISKB = ISKWS - ISTA
C
C       4.3 MASK AND LEFT SHIFT FOR THE REMAINING BITS
C
        IMASK = KMASK(ISKB+1)
        ISH   = KSIZE + ISKB
C
C       4.4 POSITION OF CURRENT WORD OF KS
C
        IBS = ISKW + 1
C
C       5.  LOOP OVER WORDS OF KS CONTRIBUTING TO ONE WORD OF KD
C
 500    CONTINUE
C
C       5.1 UPDATE SHIFT AND LAST BIT IN CURRENT WORD
C
        ISH  = ISH - KBPW
        IEND = ISTA + KBPW
C
C       5.2 IS LAST BIT OF CURRENT WORD OUTSIDE RANGE TO BE EXTRACTED
C
        IF(IEND.GT.IENBS) THEN
          ISH   = IENBS - IEND
          IMASK = IAND(IMASK,NOT(KMASK(KBPW+ISH+1)))
        ENDIF
C
C       5.3 INITIAL OFFSETS FOR VECTOR ELEMENTS IN VECTOR LOOP
C
        IOS = 0
        IOD = 0
C
C     6.  VECTOR LOOP IS OVER REPEATEDLY OCCURRING BITPATTERNS/MASKS
C
        IF (LODECD) THEN
Cjdc#ifdef CRAY
CDIR$ IVDEP
!cdir nodep
          DO 611 JI = 1,ILL
            KD(JBD+IOD) =
     X        IOR(KD(JBD+IOD),ISHFT(IAND(IMASK,KS(IBS+IOS)),ISH))
            IOD = IOD + ISTD
            IOS = IOS + ISTS
 611      CONTINUE
Cjdc#else
!OCL NOVREC
Cjdc       CALL GSDECODE( KS(IBS), KD(JBD), ISTS, ISTD, ILL, IMASK, ISH )
Cjdc#endif
        ELSE
Cjdc#ifdef CRAY
CDIR$ IVDEP
!OCL NOVREC
!cdir nodep
          DO 612 JI = 1,ILL
            KS(IBS+IOS) = IOR(
     X      IAND(      KS(IBS+IOS),           NOT(IMASK)),
     X      IAND(ISHFT(KD(JBD+IOD),-ISH),    IMASK ))
            IOD = IOD + ISTD
            IOS = IOS + ISTS
 612      CONTINUE
Cjdc#else
Cjdc        CALL GSENCODE( KD(JBD), KS(IBS), ISTD, ISTS, ILL, IMASK, ISH )
Cjdc#endif
        ENDIF
C
C       7.  END LOOPS
C
C       7.1 PREPARE FOR END OF LOOP OVER WORDS OF KS WITIHN ONE KD WORD
C
        ISTA = ISTA + KBPW
C
C       7.2 NEXT WORD OF KD IF EXTRACTION NOT COMPLETED
C
        IF(ISTA.LT.IENBS) THEN
          IMASK = KMASK(1)
          IBS   = IBS + 1
          GOTO 500
        ENDIF
C
C       7.8 PREPARE FOR END OF LOOP OVER FIRST WORDS OF KD
C
        IF(JBD.EQ.IBDL)ILL = ILL - 1
        ISKWS = ISKWS + ISTEP
C
C       7.9 END LOOP OVER FIRST WORDS OF KD
C
 790  CONTINUE
C
C     8.  FINISHED: UPDATE KSKST AND RETURN
C
      KSKST = KSKST + K*ISTEP
C
      RETURN
      END
#endif

C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

C
      COMMON /BCMCT/ NREF(JCTAB)   ,NSTART(JCTAB) ,NLEN(JCTAB),
     1               NCODNUM(JCTST),NSTARTC(JCTST),
     2               NLENC(JCTST)
C
C             NREF      - TABLE C REFERENCE
C             NSTART    - STARTING POINTERS TO ARRAY NCODNUM
C             NLEN      - LENGTHS
C             NCODNUM   - CODE/FLAG TABLE NUMBER
C             NSTARTC   - STARTING POINTERS TO ARRAY CTEXT
C             NLENC     - LENGTHS
C

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

C
      COMMON /BCOMATB/ NJA,NATBTR(JTAB),NATBS (JTAB),
     1                NATBRV(JTAB),NATBDW(JTAB)
C
C
C             NATBTR      - AUGMENTED TABLE B TABLE REFERENCE
C             NATBS       - AUGMENTED TABLE B SCALE
C             NATBRV      - AUGMENTED TABLE B REFERENCE VALUE
C             NATBDW      - AUGMENTED TABLE B DATA WIDTH
C

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities
C granted to it by virtue of its status as an intergovernmental organisation
C nor does it submit to any jurisdiction.
C

      INTEGER FUNCTION HGENGG(AREA,POLE,KGNNEW,HTYPE,KNPTS,GNLATS,
     X                        IGSIZE,RLAT,RLON,NUMPTS)
C
C---->
C**** HGENGG
C
C     Purpose
C     -------
C
C     This routine calculates the original latitude and longitude
C     values (before rotation) for a rotated gaussian grid.
C
C
C     Interface
C     ---------
C
C     IRET = HGENGG(AREA,POLE,KGNNEW,HTYPE,KNPTS,IGSIZE,
C    X              RLAT,RLON,NUMPTS)
C
C
C     Input parameters
C     ----------------
C
C     AREA     - Limits of area (N/W/S/E)
C     POLE     - Pole of rotation (lat/long)
C     KGNNEW   - Gaussian grid number
C     HTYPE    - Gaussian grid type
C                = 'R' for reduced ("quasi-regular"),
C                = 'O' for reduced/octahedral,
C                = 'F' for full,
C                = 'U' for a user-defined gaussian grid
C     KNPTS    - Array containing number of points at each latitude
C     GNLATS   - Array containing list of gaussian latitudes
C     IGSIZE   - The size of the array to fill with the gaussian field
C     NUMPTWE  - Calculate number of grid pts in range from west to east
C
C
C     Output parameters
C     -----------------
C
C     RLAT  - Vector of orginal latitude values for the points in
C             the rotated grid.
C     RLON  - Vector of orginal longitude values for the points in
C             the rotated grid.
C     NUMPTS - Number of points in new field
C
C     Returns 0 if function successful, non-zero otherwise.
C
C
C     Common block usage
C     ------------------
C
C     None.
C
C
C     Method
C     ------
C
C     The vector of points runs from West to East in rows, the rows
C     run from North to South.
C
C
C     Externals
C     ---------
C
C     INTLOG  - Log error message.
C     JDEBUG  - Tests if debug output required.
C     HLL2XYZ - Converts a latitude/longitude position to (x,y,z)
C               wrt axes through the centre of the globe. The z-axis
C               runs from the south to north pole. The x- and y-axes
C               are in the plane of the equator with the x-axis
C               pointing out through lat/long (0,0).
C     YROTATE - Rotates the globe about the new y-axis.
C     XYZ2LL  - Converts an (x,y,z) position to a latitude/longitude.
C     JMALLOC - Dynamically allocate memory
C     JFREE   - Free dynamically allocated memory
C
C
C     Reference
C     ---------
C
C     None.
C
C
C     Comments
C     --------
C
C     None.
C
C
C     Author
C     ------
C
C     J.D.Chambers      ECMWF      February 2001
C
C
C     Modifications
C     -------------
C
C     None.
C
C----<
C     -----------------------------------------------------------------|
C*    Section 0. Definition of variables.
C     -----------------------------------------------------------------|
C
      IMPLICIT NONE
C
#include "parim.h"
#include "nofld.common"
C
C     Parameters
C
      INTEGER JNORTH, JSOUTH, JWEST, JEAST, JW_E, JN_S, JLAT, JLON
      REAL JSCALE
      PARAMETER (JNORTH = 1 )
      PARAMETER (JWEST  = 2 )
      PARAMETER (JSOUTH = 3 )
      PARAMETER (JEAST  = 4 )
      PARAMETER (JW_E  = 1 )
      PARAMETER (JN_S  = 2 )
      PARAMETER (JLAT  = 1 )
      PARAMETER (JLON  = 2 )
      PARAMETER (JSCALE  = 1000.0 )
C
C     Function arguments
C
      CHARACTER*1 HTYPE
      INTEGER KGNNEW,KNPTS(KGNNEW*2),IGSIZE,NUMPTS
      REAL AREA(4),POLE(2),RLAT(*),RLON(*), GNLATS(KGNNEW*2)
C
C     Local variables
C
      INTEGER LOOP, LOOPI, LOOPO, IGRIDNI, NLON
      INTEGER ISIZE, ISIZOLD, NBYTES
      REAL GRID, X(1), Y(1), Z(1)
      REAL RX(1), RY(1), RZ(1)
      POINTER( IPX, X )
      POINTER( IPY, Y )
      POINTER( IPZ, Z )
      POINTER( IPRX, RX )
      POINTER( IPRY, RY )
      POINTER( IPRZ, RZ )
C
      DATA ISIZOLD/-1/
      SAVE ISIZOLD,IPX,IPY,IPZ,IPRX,IPRY,IPRZ
C
C     Externals
C
      INTEGER NUMPTWE
#ifdef POINTER_64
      INTEGER*8 JMALLOC
#else
      INTEGER JMALLOC
#endif
C
C     Statement functions
C
      REAL A, B
      LOGICAL SOUTHOF
      SOUTHOF(A,B) = ((A) - (B)).GT.-1E-4
C
C     -----------------------------------------------------------------|
C     Section 1.  Initialise.
C     -----------------------------------------------------------------|
C
  100 CONTINUE
C
      HGENGG = 0
C
      CALL JDEBUG()
C
C     -----------------------------------------------------------------|
C     Section 2.  Calculate current grid latitudes and longitudes
C     -----------------------------------------------------------------|
C
  200 CONTINUE
C
c     EMOS-199: adjusted for reduced_gg/octahedral
c     GRID = 360.0 / REAL(KGNNEW*4)
      GRID = 360.0 / REAL(KNPTS(KGNNEW))
      IGRIDNI = NINT(GRID*JSCALE)
C
      NUMPTS = 0
      NOPCNT = 0
      NONS   = 0
      NOWE   = 0
      NO1NS  = 0
C
      DO LOOPO = 1, KGNNEW*2
C
C       Generate points inside the area only.
C
        IF( SOUTHOF(AREA(JNORTH),GNLATS(LOOPO)).AND.
     X      SOUTHOF(GNLATS(LOOPO),AREA(JSOUTH)) ) THEN
C
          IF( NO1NS.EQ.0 ) NO1NS = LOOPO
          NONS = NONS + 1
C
C         Grid step varies for "quasi-regular"/octahedral reduced Gaussian grids
C
          IF( HTYPE.EQ.'R' .OR. HTYPE.EQ.'r' .OR.
     X        HTYPE.EQ.'O' .OR. HTYPE.EQ.'o' .OR.
     X        HTYPE.EQ.'U' .OR. HTYPE.EQ.'u' ) THEN
            GRID = 360.0 / REAL(KNPTS(LOOPO))
            IGRIDNI = NINT(GRID*JSCALE)
          ENDIF
C
          NLON = NUMPTWE(AREA(JWEST),AREA(JEAST),GRID)
          NOWE = NLON
          DO LOOPI = 1, NLON
            NUMPTS = NUMPTS + 1
            RLAT(NUMPTS) = GNLATS(LOOPO)
            RLON(NUMPTS) = AREA(JWEST)+REAL((LOOPI-1)*IGRIDNI)/JSCALE
          ENDDO
        ENDIF
      ENDDO
C
C     -----------------------------------------------------------------|
C     Section 3.  Get some space for rotating the lat/longs
C     -----------------------------------------------------------------|
C
  300 CONTINUE
C
      NOPCNT = NUMPTS
      ISIZE  = NUMPTS
      IF( ISIZE.GT.ISIZOLD ) THEN
C
        IF( ISIZOLD.GT.0 ) CALL JFREE(IPX)
C
        NBYTES = 6*ISIZE*JPRLEN
C
        IPX = JMALLOC(NBYTES)
#ifdef hpR64
        IPX = IPX/(1024*1024*1024*4)
#endif
        IF( IPX.EQ.0 ) THEN
          CALL INTLOG(JP_WARN,'HGENGG: Memory allocate fail',JPQUIET)
          HGENGG = 1
          GOTO 900
        ENDIF
C
        IPY  = IPX  + (ISIZE*JPRLEN)
        IPZ  = IPY  + (ISIZE*JPRLEN)
        IPRX = IPZ  + (ISIZE*JPRLEN)
        IPRY = IPRX + (ISIZE*JPRLEN)
        IPRZ = IPRY + (ISIZE*JPRLEN)
C
        ISIZOLD = ISIZE
C
      ENDIF
C
C     -----------------------------------------------------------------|
C     Section 4.  Calculate the lat/longs before rotation
C     -----------------------------------------------------------------|
C
  400 CONTINUE
C
C     Convert the rotated row points lat/longs to (x,y,z) coordinates
C
      CALL HLL2XYZ(RLAT,RLON,X,Y,Z,ISIZE)
C
C     Rotate the rotated row points back through the original latitude
C     rotation
C
      CALL YROTATE(-(90.0+POLE(JLAT)),X,Y,Z,RX,RY,RZ,ISIZE)
C
C     Convert the rotated row points adjusted (x,y,z) coordinates to
C     lat/long in the original grid (but still containing the
C     longitude rotation)
C
      CALL XYZ2LL(RX,RY,RZ,RLAT,RLON,ISIZE)
C
C     Adjust the rotated line longitudes to remove the longitude
C     rotation
C
      DO LOOP = 1, ISIZE
        RLON(LOOP) = RLON(LOOP) + POLE(JLON)
        IF( RLON(LOOP).LT.0.0 )   RLON(LOOP) = RLON(LOOP) + 360.0
        IF( RLON(LOOP).GE.360.0 ) RLON(LOOP) = RLON(LOOP) - 360.0
      ENDDO
C
C     -----------------------------------------------------------------|
C     Section 9.  Return
C     -----------------------------------------------------------------|
C
  900 CONTINUE
C
      RETURN
      END

C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      INTEGER FUNCTION IGTRAN (PMAT, KINCOL, KINROW, KMOVE, KLEN,
     1   KPR, KERR)
C
C---->
C**** *IGTRAN*
C
C     PURPOSE
C     _______
C
C     This routine transposes a rectangular matrix.
C
C     INTERFACE
C     _________
C
C     IERR = IGTRAN (PMAT, KINCOL, KINROW, KMOVE, KLEN, KPR, KERR)
C
C     Input parameters
C     ________________
C
C     PMAT       - The input matrix of length KINCOL * KINROW.
C
C     KINCOL     - The length of the first dimension on entry and
C                  second dimension on exit.
C
C     KINROW     - The length of the second dimension on entry and
C                  first dimension on exit.
C
C     KMOVE      - Work array used to store information to speed up
C                  the process.
C
C     KLEN       - Length of array KMOVE. The recommended length is
C                  (KINCOL + KINROW) / 2.
C
C     KPR        - The debug print switch.
C                  0  , No debugging output.
C                  1  , Produce debugging output.
C
C     KERR       - The error control flag.
C                  (No longer used, kept for backward compatibility.
C                   Used to be used as follows:
C                  -ve, No error message. Return error code.
C                  0  , Hard failure with error message.
C                  +ve, Print error message. Return error code.)
C
C     Output parameters
C     ________________
C
C     PMAT       - The transposed matrix.
C
C     Return value
C     ____________
C
C     The error indicator (INTEGER).
C
C     7401  KLEN was less than 1.
C     7402  A failure during transposition (should never happen).
C
C
C     Common block usage
C     __________________
C
C     None
C
C     EXTERNALS
C     _________
C
C     INTLOG     - Generate log messages.
C
C
C     METHOD
C     ______
C
C     This algorithm uses the cyclic structure of transposition to
C     perform a transposition in place with a minimum amount of work
C     storage.
C
C     REFERENCE
C     _________
C
C     Esko G. Cate and David W. Twigg      Analysis of In-Situ
C                                          Transposition
C     CACM Algorithm 513
C
C
C     COMMENTS
C     ________
C
C     None.
C
C
C     AUTHOR
C     ______
C
C     K. Fielding      *ECMWF*      Jan 1994
C
C
C     MODIFICATIONS
C     _____________
C
C     J.D.Chambers      ECMWF       Sept 1995
C
C----<
C     _______________________________________________________
C
      IMPLICIT NONE
C
#include "parim.h"
C
C     Function arguments
C
      INTEGER KINCOL, KINROW, KLEN, KPR, KERR
      INTEGER KMOVE(KLEN)
      REAL PMAT (KINCOL * KINROW)
C
C     Local variables
      INTEGER ICOUNT, IRMULC, IR0, IR1, IR2, IPOINT, IKMI, IP1, IP2,
     X   IRMCM1, IP1C, IP2C, IROWP1, ICOLM1, ISTART
      INTEGER JST, JINROW, JINCOL
      REAL ZMIP1, ZMIP1C, ZTEMP
C
C     Parameters
      INTEGER JPROUTINE
      PARAMETER (JPROUTINE = 7400)
C
C     _______________________________________________________
C
C*    Section 1. Initialisation
C     _______________________________________________________
C
  100 CONTINUE
C
      IF (KPR .GE. 1) CALL INTLOG(JP_DEBUG,'IGTRAN: Section 1.',JPQUIET)
C
      IGTRAN = 0
C
      IF (KPR .GE. 1) THEN
        CALL INTLOG(JP_DEBUG,'IGTRAN: Input parameters.',JPQUIET)
        CALL INTLOG(JP_DEBUG,'IGTRAN: 1st matrix dimension = ',KINCOL)
        CALL INTLOG(JP_DEBUG,'IGTRAN: 2nd matrix dimension = ',KINROW)
        CALL INTLOG(JP_DEBUG,'IGTRAN: Work array length = ',KLEN)
        CALL INTLOG(JP_DEBUG,
     X    'IGTRAN: Recommended length = ',(KINCOL + KINROW) / 2)
      ENDIF
C
      IF (KINCOL .LE. 1 .OR. KINROW .LE. 1) GO TO 900
C
C     _______________________________________________________
C
C*    Section 2. Rectangular transposition setup
C     _______________________________________________________
C
  200 CONTINUE
C
      IF (KPR .GE. 1) CALL INTLOG(JP_DEBUG,'IGTRAN: Section 2.',JPQUIET)
C
      IF (KINCOL .NE. KINROW) THEN
C
        IF (KLEN .LT. 1) THEN
          IGTRAN = JPROUTINE + 1
          CALL INTLOG(JP_ERROR,'IGTRAN: Work array size = ',KLEN)
          CALL INTLOG(JP_ERROR,'IGTRAN: Must be at least 1.',JPQUIET)
          GO TO 900
        ENDIF
C
        ICOUNT = 2
        IRMULC = KINCOL * KINROW
        IRMCM1 = IRMULC - 1
C
        DO 210 JST = 1, KLEN
          KMOVE (JST) = 0
  210   CONTINUE
C
        IF (KINCOL .GT. 2 .AND. KINROW .GT. 2) THEN
C
C         Calculate the number of fixed points, Euclids algorithm
C         for GCD (m - 1, n - 1)
C
          IR2 = KINCOL - 1
          IR1 = KINROW - 1
C
  220     CONTINUE
          IR0 = MOD (IR2, IR1)
          IR2 = IR1
          IR1 = IR0
          IF (IR0 .NE. 0) GO TO 220
C
          ICOUNT = ICOUNT + IR2 - 1
C
        ENDIF
C
C       Set initial values for search
C
        ISTART = 1
        IPOINT = KINCOL
C
C       At least one loop must be rearranged so branch into loop
C
        GO TO 330
C
C     _______________________________________________________
C
C*    Section 3. Rectangular transposition main loop
C     _______________________________________________________
C
  310   CONTINUE
C
C       Search for loops to rearrange
C
        IKMI = IRMCM1 - ISTART
        ISTART = ISTART + 1
C
        IF (ISTART .GT. IKMI) THEN
          IGTRAN = JPROUTINE + 2
          CALL INTLOG(JP_ERROR,
     X        'IGTRAN: Fail during transposition.',JPQUIET)
          GO TO 900
        ENDIF
C
        IPOINT = IPOINT + KINCOL
C
        IF (IPOINT .GT. IRMCM1) IPOINT = IPOINT - IRMCM1
C
        IP2 = IPOINT
C
        IF (ISTART .EQ. IP2) GO TO 310
C
        IF (ISTART .GT. KLEN) THEN
C
  320     CONTINUE
C
C         Loop exit condition
C
          IF (IP2 .LE. ISTART .OR. IP2 .GE. IKMI)  THEN
            IF (IP2 .NE. ISTART) THEN
              GO TO 310
            ELSE
              GO TO 330
            ENDIF
          ENDIF
          IP1 = IP2
          IP2 = KINCOL * IP1 - IRMCM1 * (IP1 / KINROW)
          GO TO 320
        ENDIF
C
        IF (KMOVE (ISTART) .NE. 0) GO TO 310
C
C       Rearrange the elements of a loop and its companion loop
C
C       Entry into loop on first pass
C
  330   CONTINUE
C
        IP1 = ISTART
        IKMI = IRMCM1 - ISTART
        ZMIP1 = PMAT (IP1 + 1)
        IP1C = IKMI
        ZMIP1C = PMAT (IP1C + 1)
C
  340   CONTINUE
        IP2 = KINCOL * IP1 - IRMCM1 * (IP1 / KINROW)
        IP2C = IRMCM1 - IP2
C
        IF (IP1 .LE. KLEN) KMOVE (IP1) = 2
        IF (IP1C .LE. KLEN) KMOVE (IP1C) = 2
C
        ICOUNT = ICOUNT + 2
C
C       Loop exit conditions
C
        IF (IP2 .EQ. ISTART) GO TO 360
        IF (IP2 .EQ. IKMI) GO TO 350
C
        PMAT (IP1 + 1) = PMAT(IP2 + 1)
        PMAT (IP1C + 1) = PMAT(IP2C + 1)
        IP1 = IP2
        IP1C = IP2C
C
        GO TO 340
C
  350   CONTINUE
C
        ZTEMP = ZMIP1
        ZMIP1 = ZMIP1C
        ZMIP1C = ZTEMP
C
  360   CONTINUE
C
        PMAT (IP1 + 1) = ZMIP1
        PMAT (IP1C + 1) = ZMIP1C
C
        IF (ICOUNT .LT. IRMULC) GO TO 310
C
      ELSE
C
C     _______________________________________________________
C
C*    Section 4. Square transposition
C     _______________________________________________________
C
  400 CONTINUE
C
        IF (KPR.GE.1) CALL INTLOG(JP_DEBUG,'IGTRAN: Section 4.',JPQUIET)
C
C       Square matrix so exchange elements a(i,j) and a(j,i)
C
        ICOLM1 = KINCOL - 1
C
        DO 420 JINCOL = 1, ICOLM1
C
          IROWP1 = JINCOL + 1
C
          DO 410 JINROW = IROWP1, KINROW
C
            IP1 = JINCOL + (JINROW - 1) * KINCOL
            IP2 = JINROW + (JINCOL - 1) * KINROW
C
            ZTEMP = PMAT (IP1)
            PMAT (IP1) = PMAT (IP2)
            PMAT (IP2) = ZTEMP
C
  410     CONTINUE
  420   CONTINUE
      ENDIF
C
C     _______________________________________________________
C
C*    Section 9. Return to calling routine. Format statements
C     _______________________________________________________
C
  900 CONTINUE
C
      IF (KPR .GE. 1) CALL INTLOG(JP_DEBUG,'IGTRAN: Section 9.',JPQUIET)
C
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities
C granted to it by virtue of its status as an intergovernmental organisation
C nor does it submit to any jurisdiction.
C

      INTEGER FUNCTION HNTFAUH(FLDIN,INLEN)
C
C---->
C**** HNTFAUH
C
C     Purpose
C     -------
C
C     Prepare to interpolate to grid point field.
C
C
C     Interface
C     ---------
C
C     IRET = HNTFAUH( FLDIN,INLEN)
C
C     Input
C     -----
C
C     FLDIN  - Input field (unpacked).
C     INLEN  - Input field length (words).
C
C
C     Output
C     ------
C
C     Field unpacked values are in ZNFELDI, rotated if necessary.
C
C     Returns: 0, if OK. Otherwise, an error occured in interpolation.
C
C
C     Method
C     ------
C
C     If the input is a spectral field and the output is a rotated
C     grid-point field, create a global reduced gaussian field and
C     then create the rotated grid-point field from it.
C
C
C     Externals
C     ---------
C
C     INTLOG  - Log error message.
C     INTLOGR - Log error message.
C     JDEBUG  - Checks environment to switch on/off debug
C     FIXAREA - Fixup input/output field area definitions.
C     HSH2GG  - Find suitable gaussian grid/spectral truncation
C     HIRLAM  - Creates rotated lat/long field from reduced gaussian
C     HIRLSM  - Creates rotated lat/long field from reduced gaussian
C               using land-sea mask
C     HRG2GG  - Creates rotated gaussian field from reduced gaussian
C     LSMFLD  - Determines whether a field is to be interpolated using
C               a land-sea mask
C
C
C     Author
C     ------
C
C     J.D.Chambers     ECMWF     February 2001
C
C----<
C
C     -----------------------------------------------------------------|
C*    Section 0.   Variables
C     -----------------------------------------------------------------|
C
      IMPLICIT NONE
C
C     Function arguments
C
      INTEGER INLEN
      REAL FLDIN(*)
C
#include "parim.h"
#include "nifld.common"
#include "nofld.common"
#include "intf.h"
#include "current.h"
#include "grfixed.h"
C
C     Parameters
C
      INTEGER JPROUTINE
      PARAMETER (JPROUTINE = 40150)
C
C     Local variables
C
      CHARACTER*1 HOLDTYP
      CHARACTER*1 HTYPE
      INTEGER     IERR
      INTEGER     IRET
      INTEGER     ISHIZE
      INTEGER     ISIZE
      INTEGER     ITEMP,K,I,J,IM,JM
      INTEGER     KPTS(JPGTRUNC*2)
      INTEGER     LOOP
      INTEGER     NCOUNT
      INTEGER     NGAUSS
      INTEGER     NLAT
      INTEGER     NLON
      INTEGER     NTRUNC
      INTEGER     NUMPTS
      INTEGER     NUVFLAG
      LOGICAL     LLATOUT
      LOGICAL     LSP2RGG
      LOGICAL     LUSELSM
      REAL        AREA(4)
      REAL        EAST
      REAL        EW
      REAL        GRID(2)
      REAL        NS
      REAL        PLATS(JPGTRUNC*2)
      REAL        POLE(2)
      REAL        RGGRID(1)
      REAL        SWORK(1)
C     REAL        TEMP(1440,1440): EMOS-113: changed to dynamic memory allocation
      REAL        TEMP(1536,1536)
      REAL        WEST
      REAL        ZNFLDO(1)
#ifndef _CRAYFTN
#ifdef POINTER_64
      INTEGER*8 IRGGRID
      INTEGER*8 ISWORK
      INTEGER*8 IZNFLDO
#endif
#endif
      POINTER (IRGGRID, RGGRID)
      POINTER (ISWORK,  SWORK)
      POINTER (IZNFLDO, ZNFLDO)
C
      SAVE IRGGRID
      SAVE ISWORK
      SAVE IZNFLDO
C
      DATA ISIZE/0/
C
C     Externals
C
      CHARACTER*1 GGHTYPE
      INTEGER HSH2GG, HIRLAM, HIRLSM, HRG2GG, FIXAREA, PDDEFS
      LOGICAL LSMFLD
      EXTERNAL GGHTYPE
      EXTERNAL HSH2GG, HIRLAM, HIRLSM, HRG2GG, FIXAREA, PDDEFS
      EXTERNAL LSMFLD

C
C     -----------------------------------------------------------------|
C*    Section 1.   Initialise
C     -----------------------------------------------------------------|
C
  100 CONTINUE
C
      HNTFAUH = 0
      IRET    = 0
C
      NCOUNT = INLEN
      IF( LIMISSA ) THEN
        CALL INTLOG(JP_DEBUG,'HNTFAUH: Use missing value',JPQUIET)
        LIMISSV = .TRUE.
      ENDIF
C
C     -----------------------------------------------------------------|
C*    Section 2.   Store input data.
C     -----------------------------------------------------------------|
C
  200 CONTINUE
C
C     Allocate work array ZNFELDI if not already done.
C
      IF( IZNJDCI.NE.1952999238 ) THEN
        CALL JMEMHAN( 19, IZNFLDI, JPEXPAND, 1, IRET)
        IF( IRET.NE.0 ) THEN
          CALL INTLOG(JP_WARN,'HNTFAUH: ZNFELDI allocate fail',JPQUIET)
          HNTFAUH = IRET
          GOTO 900
        ENDIF
        IZNJDCI = 1952999238
      ENDIF

C     Move unpacked values in from user array
      ZNFELDI(1:INLEN) = FLDIN(1:INLEN)
      IF (NISCNM.EQ.64) THEN
        CALL INTLOG(JP_DEBUG,
     X    'HNTFAUH: Scanning flag west-east/south-north',NISCNM)
        ITEMP = NIAREA(1)
        NIAREA(1) = NIAREA(3)
        NIAREA(3) = ITEMP

        IM = NIWE
        JM = NINS
        K=0
        DO J=JM,1,-1
          DO I=1,IM
            K=K+1
            TEMP(I,J) = ZNFELDI(K)
          END DO
        END DO
        K=0
        DO J=1,JM
          DO I=1,IM
            K=K+1
            ZNFELDI(K) = TEMP(I,J)
          END DO
        END DO

      ENDIF
C
      LLATOUT = (NOREPR.EQ.JPREGROT).OR.(NOREPR.EQ.JPREGULAR)

      IF( .NOT.LNOROTA ) GOTO 900
C
C     -----------------------------------------------------------------|
C*    Section 3.   Handle rotation, if necessary.
C     -----------------------------------------------------------------|
C
  300 CONTINUE
C
      CALL INTLOG(JP_DEBUG,'HNTFAUH: Rotate field.',JPQUIET)
      CALL INTLOG(JP_DEBUG,'HNTFAUH: South pole lat  ',NOROTA(1))
      CALL INTLOG(JP_DEBUG,'HNTFAUH: South pole long ',NOROTA(2))
C
C     Fill area limits (handles case when default 0/0/0/0 given)
C
      IRET = FIXAREA()
      IF( IRET.NE.0 ) THEN
        CALL INTLOG(JP_ERROR,'HNTFAUH: area fixup failed',JPQUIET)
        HNTFAUH = JPROUTINE + 3
        GOTO 900
      ENDIF
C
      AREA(1) = REAL(NOAREA(1))/PPMULT
      AREA(2) = REAL(NOAREA(2))/PPMULT
      AREA(3) = REAL(NOAREA(3))/PPMULT
      AREA(4) = REAL(NOAREA(4))/PPMULT
C
      GRID(1) = REAL(NOGRID(1))/PPMULT
      GRID(2) = REAL(NOGRID(2))/PPMULT
C
      POLE(1) = REAL(NOROTA(1))/PPMULT
      POLE(2) = REAL(NOROTA(2))/PPMULT
C
C     -----------------------------------------------------------------|
C*    Section 4.   Spectral to rotated grid-point
C     -----------------------------------------------------------------|
C
  400 CONTINUE
C
      LSP2RGG = .FALSE.
      IF( (NIREPR.EQ.JPSPHERE).OR.(NIREPR.EQ.JPSPHROT) ) THEN
C
C       Convert spectral to suitable global reduced gaussian grid
C
        CALL INTLOG(JP_DEBUG,
     X    'HNTFAUH: Spectral to suitable reduced gaussian',JPQUIET)
C
        NTRUNC = NIRESO

        IF( LNORESO ) THEN
          NTRUNC = NORESO
          NGAUSS = 0
          HTYPE  = ''
          NS = 0.
          EW = 0.
          IRET = HSH2GG(NS,EW,NTRUNC,NGAUSS,HTYPE,KPTS,PLATS,ISIZE)
          IF( IRET.NE.0 ) THEN
            CALL INTLOG(JP_ERROR,
     X        'HNTFAUH: problem getting data for reduced grid',NTRUNC)
            HNTFAUH = JPROUTINE + 4
            GOTO 900
          ENDIF
          GOTO 401
        ENDIF

        IF( LARESOL ) THEN
          NS = 0.
          EW = 0.
          IF( LLATOUT ) THEN
            NS = GRID(1)
            EW = GRID(2)
            NTRUNC = 0
            NGAUSS = 0
            HTYPE = ''
          ELSE
            HTYPE = 'R'
          ENDIF
          IRET = HSH2GG(NS,EW,NTRUNC,NGAUSS,HTYPE,KPTS,PLATS,ISIZE)
          IF( IRET.NE.0 ) THEN
            CALL INTLOG(JP_ERROR,
     X        'HNTFAUH: problem getting data for reduced grid',NTRUNC)
            HNTFAUH = JPROUTINE + 4
            GOTO 900
          ENDIF
        ENDIF

C       Truncate if a smaller resolution has been requested
C
  401 CONTINUE
      IF( NTRUNC.LT.NIRESO ) THEN
       CALL INTLOG(JP_DEBUG,'HNTFAUH: Truncation changed from:',NIRESO)
       CALL INTLOG(JP_DEBUG,'HNTFAUH: to: ',NTRUNC)
       CALL INTLOG(JP_DEBUG,'HNTFAUH: Gaussian number is:',NGAUSS)
C
        ISHIZE =  (NTRUNC+1)*(NTRUNC+4)
        CALL JMEMHAN( 3, IZNFLDO, ISHIZE, 1, IERR)
        IF( IERR.NE.0 ) THEN
          CALL INTLOG(JP_FATAL,
     X      'HNTFAUH: Get scratch space failed',JPQUIET)
          HNTFAUH = JPROUTINE + 4
          GOTO 900
        ENDIF

C       Generate spherical harmonics with output truncation
        CALL SH2SH( ZNFELDI, NIRESO, ZNFLDO, NTRUNC )

C       Move new spherical harmonics to 'input' array
        ZNFELDI(1:ISHIZE) = ZNFLDO(1:ISHIZE)

      ELSE
          CALL INTLOG(JP_DEBUG,
     X      'HNTFAUH: Spectral to suitable reduced gaussian',JPQUIET)
C
          NTRUNC = NIRESO
          NGAUSS = 0
          HTYPE  = ''
          NS = 0.
          EW = 0.
          IRET = HSH2GG(NS,EW,NTRUNC,NGAUSS,HTYPE,KPTS,PLATS,ISIZE)
          IF( IRET.NE.0 ) THEN
            CALL INTLOG(JP_ERROR,
     X        'HNTFAUH: problem getting data for reduced grid',NTRUNC)
            HNTFAUH = JPROUTINE + 4
            GOTO 900
          ENDIF

        ENDIF

C
C       Dynamically allocate memory for global reduced gaussian grid
C
        CALL JMEMHAN( 18, IRGGRID, ISIZE, 1, IRET)
        IF( IRET.NE.0 ) THEN
          CALL INTLOG(JP_ERROR,
     X      'HNTFAUH: memory alloc for reduced grid fail',JPQUIET)
          HNTFAUH = JPROUTINE + 4
          GOTO 900
        ENDIF

C       Set flag to show field is not a wind component
        NUVFLAG = 0

C       Create the reduced gaussian grid
        HOLDTYP = HOGAUST
        WEST = 0.0
        EAST = 360.0 - (360.0/(NGAUSS*4))
c       EMOS-199: adjusted for reduced_gg/octahedral
        IF (HTYPE.EQ.'O')  EAST = 360.0 - (360.0/FLOAT(KPTS(NGAUSS)))
        IF (HTYPE.NE.'R' .AND. HTYPE.NE.'O' .AND.
     X      HTYPE.NE.'F' .AND. HTYPE.NE.'U') THEN
          HTYPE = 'R'
        ENDIF
        CALL JAGGGP(ZNFELDI,NTRUNC,PLATS(1),PLATS(NGAUSS*2),WEST,
     X              EAST,NGAUSS,HTYPE,KPTS,RGGRID,NUVFLAG,IRET)
        IF( IRET.NE.0 ) THEN
          CALL INTLOG(JP_ERROR,
     X      'HNTFAUH: spectral to reduced gaussian failed',JPQUIET)
          HNTFAUH = JPROUTINE + 4
          GOTO 900
        ENDIF
        HOGAUST = HOLDTYP

        NCOUNT = 0
        DO LOOP = 1, (NGAUSS*2)
          NCOUNT= NCOUNT + KPTS(LOOP)
        ENDDO

        LSP2RGG = .TRUE.

        IF( NOREPR.EQ.JPFGGROT ) THEN
          CALL INTLOG(JP_DEBUG,
     X      'HNTFAUH: Convert gaussian to rotated gaussian',JPQUIET)
          GOTO 600
        ENDIF

      ENDIF
C
C     -----------------------------------------------------------------|
C*    Section 5.   Gaussian to rotated lat/long
C     -----------------------------------------------------------------|
C
  500 CONTINUE
C
      IF( (NOREPR.EQ.JPREGROT) .AND. (
     X        (NIREPR.EQ.JPQUASI) .OR.
     X        (NIREPR.EQ.JPGAUSSIAN) .OR.
     X        (LSP2RGG) )) THEN
C
        CALL INTLOG(JP_DEBUG,'HNTFAUH: Gauss to lat/lon',JPQUIET)
C
C       Dynamically allocate memory for rotated lat/long grid
C
        NLON = 1 + NINT(FLOAT((NOAREA(JPEAST)  - NOAREA(JPWEST))) /
     X         NOGRID(JPWESTEP))
        NLAT = 1 + NINT(FLOAT((NOAREA(JPNORTH) - NOAREA(JPSOUTH))) /
     X         NOGRID(JPNSSTEP))
C
        NUMPTS = NLON * NLAT
        ISIZE  = NUMPTS
        CALL JMEMHAN( 11, ISWORK, ISIZE, 1, IRET)
        IF( IRET.NE.0 ) THEN
          CALL INTLOG(JP_ERROR,
     X      'HNTFAUH: memory alloc for lat/long grid fail',JPQUIET)
          HNTFAUH = JPROUTINE + 5
          GOTO 900
        ENDIF
C
        LUSELSM = LSMFLD()
C
C       If original field was spectral, ...
C
        IF( LSP2RGG ) THEN
          IF( LUSELSM ) THEN
            IRET = HIRLSM(LO12PT,RGGRID,NCOUNT,NGAUSS,HTYPE,AREA,POLE,
     X                    GRID,SWORK,ISIZE,NLON,NLAT)
          ELSE
            IRET = HIRLAM(LO12PT,RGGRID,NCOUNT,NGAUSS,HTYPE,AREA,POLE,
     X                    GRID,SWORK,ISIZE,NLON,NLAT)
          ENDIF
C
        ELSE
C
C       If original field was gaussian, ...
C
          IRET = PDDEFS()
          NGAUSS = NIGAUSS
          HTYPE  = GGHTYPE(NIREPR,NIGAUSS,MILLEN)
cs        IF( LUSELSM ) THEN
          IF( LSM ) THEN
            IRET = HIRLSM(LO12PT,ZNFELDI,NCOUNT,NGAUSS,HTYPE,AREA,POLE,
     X                    GRID,SWORK,ISIZE,NLON,NLAT)
          ELSE
            IRET = HIRLAM(LO12PT,ZNFELDI,NCOUNT,NGAUSS,HTYPE,AREA,POLE,
     X                    GRID,SWORK,ISIZE,NLON,NLAT)
          ENDIF
C
        ENDIF
C
        IF( IRET.NE.0 ) THEN
          CALL INTLOG(JP_ERROR,
     X      'HNTFAUH: HIRLAM rotation failed',JPQUIET)
          HNTFAUH = JPROUTINE + 5
          GOTO 900
        ENDIF
C
cs      setting size of output field
        OUTLROT = NLON * NLAT
C
      ENDIF
C
C     -----------------------------------------------------------------|
C*    Section 6.   Gaussian to rotated gaussian
C     -----------------------------------------------------------------|
C
  600 CONTINUE
C
      IF( (LSP2RGG.AND.(NOREPR.EQ.JPFGGROT)) .OR.
     X      (((NIREPR.EQ.JPQUASI).OR.(NIREPR.EQ.JPGAUSSIAN)) .AND.
     X     (NOREPR.EQ.JPFGGROT)) ) THEN
        CALL INTLOG(JP_DEBUG,
     X    'HNTFAUH: Gaussian to reduced gaussian',JPQUIET)
C
C       Dynamically allocate memory for rotated lat/long grid
C
C       ISIZE = NOGAUSS * NOGAUSS * 8
        ISIZE = (2*NOGAUSS) * (4*NOGAUSS + 20)  ! account for RGG/octahedral
        CALL JMEMHAN( 11, ISWORK, ISIZE, 1, IRET)
        IF( IRET.NE.0 ) THEN
          CALL INTLOG(JP_ERROR,
     X      'HNTFAUH: memory alloc for gaussian grid fail',JPQUIET)
          HNTFAUH = JPROUTINE + 6
          GOTO 900
        ENDIF
C
C       If original field was spectral, ...
C
        IF( LSP2RGG ) THEN
          IRET = HRG2GG(LO12PT,RGGRID,NGAUSS,AREA,POLE,
     X                  NOGAUSS,HOGAUST,SWORK,ISIZE,NUMPTS)
C
        ELSE
C
C       If original field was gaussian, ...
C
          NGAUSS = NIGAUSS
          IRET = HRG2GG(LO12PT,ZNFELDI,NGAUSS,AREA,POLE,
     X                  NOGAUSS,HOGAUST,SWORK,ISIZE,NUMPTS)
        ENDIF
cs      setting size of output field
        OUTLROT = NUMPTS
        IF( IRET.NE.0 ) THEN
          CALL INTLOG(JP_ERROR,
     X      'HNTFAUH: HRG2GG rotation failed',JPQUIET)
          HNTFAUH = JPROUTINE + 6
          GOTO 900
        ENDIF
C
      ENDIF

C     move rotated field back into field original array
      ZNFELDI(1:NUMPTS) = SWORK(1:NUMPTS)

C     -----------------------------------------------------------------|
C*    Section 9.   Closedown.
C     -----------------------------------------------------------------|
C
  900 CONTINUE
C
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE CREXIVAR(KERR)
C
C**** *CREXIVAR*
C
C
C     PURPOSE.
C     --------
C         PRINT ERROR CODE.
C
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *CREXIVAR(KERR)*
C
C     METHOD.
C     -------
C
C          NONE.
C
C
C     EXTERNALS.
C     ----------
C
C          NONE.
C
C     REFERENCE.
C     ----------
C
C          NONE.
C
C     AUTHOR.
C     -------
C
C          MILAN DRAGOSAVAC    *ECMWF*       15/02/2003.
C
C
C     MODIFICATIONS.
C     --------------
C
C          NONE.
C
C
      IMPLICIT LOGICAL(L,O,G), CHARACTER*8(C,H,Y)
C

C
      PARAMETER(JSUP =   9,JSEC0=   3,JSEC1= 40,JSEC2= 64 ,JSEC3=    4,
     1          JSEC4=   2,JELEM=40000,JSUBS=400,JCVAL=150 ,JBUFL=40000,
     2          JBPW =  32,JTAB =3000,JCTAB=120,JCTST=1800,JCTEXT= 200,
     3          JWORK=360000,JKEY=46)
C
      COMMON /CRWORK/ NBPT,NGS,NVIND,NBPTSEC2,RVIND,EPS,NE,IEOLD,
     1                  NC07YYY
C
      COMMON /CRBEF / M,MM,N,JCV
C
C             M       -  Number of elements
C             MM      -  Number of elements
C             N       -  Number of data sub_sets
C             JCV     -  Number of character values
C
      COMMON /CRWT/ NCREXDWINC,NCREXSCAM,NCREXAFDW,NCREXWT ,ODREPF,
     2             NCREXSTACK(JELEM),NCREXWTEN(JELEM),
     3             NCREXWTR (JELEM),NCREXWTS (JELEM),
     4             NCREXWTDW(JELEM)
C
C             NCREXDWINC   -  data width increment
C             NCREXSCAM    -  scale multiplier
C             NCREXAFDW    -  augmented field data width
C             NCREXWT      -  pointer to working table
C             NCREXSTACK   -  list of data descriptors
C             ODREPF   -  replication (logical)
C             NCREXWTR     -  working table reference
C             NCREXWTS     -  working scale
C             NCREXWTDW    -  working data width
c

c
      DIMENSION NCODE(JCTEXT)
      CHARACTER*30 CUNITNAME(JCTEXT)
      CHARACTER*24 CIA5(JCTEXT)
      CHARACTER*24 CIA2(JCTEXT)
      CHARACTER*24 YUNIT
c
      LOGICAL OFIRST
      LOGICAL ODREPF
      REAL*8  RVIND
      REAL*8  EPS

      NGS=KBUFL
      NE=0
      NVIND=2147483647
      RVIND=1.7D38
      EPS=1.0D-8
      M=0
      N=0
      NCREXWT=0
      ODREPF=.false.
      NCREXSCAM=0
      NCREXAFDW=0
      NCREXDWINC=0
      NC07YYY=0
      YUNIT=' '
C
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      INTEGER FUNCTION DSECT4( PDATA, KTRUNC, KSEC1, KSEC4,
     X                         KGRIB, KLENG, KNSPT, KBITS, KPACK)
C
C---->
C**** DSECT4
C
C     Purpose.
C     --------
C
C     Decode GRIB section 4 for complex packing of spherical harmonics.
C
C
C**   Interface.
C     ----------
C
C     KRET = DSECT4( PDATA, KTRUNC, KSEC1, KSEC4,
C    X               KGRIB, KLENG, KNSPT, KBITS, KPACK)
C
C
C     Input Parameters.
C     -----------------
C
C     PDATA      - Array of floating point values.
C     KTRUNC     - Truncation of the spherical harmonic coefficients.
C     KLENG      - Length of GRIB product array
C     KNSPT      - Bit pointer for next value in GRIB product
C     KBITS      - Number of bits per computer word.
C     KPACK      - Number of bits per packed value.
C
C
C     Output Parameters.
C     -----------------
C
C     KSEC1      - Array of GRIB section 1 values
C     KSEC4      - Array of GRIB section 4 values
C     KGRIB      - Array containing GRIB product.
C     KNSPT      - Bit pointer for next value in GRIB product(updated)
C
C
C     Method.
C     -------
C
C                            <subset>|
C
C     Given numbers:         cccccccc|cccccc
C                              cccccc|cccccc
C                                cccc|cccccc
C                                  cc|cccccc
C                                    |cccccc
C                                       cccc
C                                         cc
C
C
C     Externals.
C     ----------
C
C     GSCALE    - Apply power scaling to values to be packed.
C     UNPKCF    - Unpack unscaled coefficients from GRIB product.
C     UNCMPCK   - Re-scatter the values being unpacked into array.
C     INXBIT    - Extract bits from GRIB product.
C     DECFP2    - Decode from IBM floating point format.
C     JMALLOC   - Routine to acquire memory
C     JFREE     - Routine to release memory
C
C
C     Reference.
C     ----------
C
C     None.
C
C
C     Comments.
C     --------
C
C     On entry, KNSPT points to the first bit of section 4 in the GRIB
C               product.
C     On exit,  KNSPT points to the first bit of section 5 in the GRIB
C               product.
C
C
C     Author.
C     -------
C
C     J.D.Chambers     ECMWF      06:05:94
C
C
C     Modifications.
C     _____________
C
C     J.D.Chambers     ECMWF      13.09.95
C     Put in check for 32-bit packing.
C     (Removed May 1996)
C
C     J.Clochard, Meteo France, for ECMWF - January 1998.
C     FLOAT function replaced by REAL.
C     Fix comments.
C     Use of external JFREE instead of FREE.
C
C----<
C     -----------------------------------------------------------------
C*    Section 0. Definition of variables.
C     -----------------------------------------------------------------
C
      IMPLICIT NONE
C
C     Parameters
      INTEGER JP15BIT, JP87SET, JPBYTES
#ifdef REAL_8
      PARAMETER (JPBYTES = 8)
#else
      PARAMETER (JPBYTES = 4)
#endif
      PARAMETER ( JP15BIT= 2**15 )
C                            `---> 32768    =   8000(hex)
      PARAMETER ( JP87SET= 192 )
C                            `--->          =     C0(hex)
C
C     Subroutine arguments
C
      INTEGER KTRUNC, KSEC1, KSEC4, KGRIB, KLENG, KNSPT, KBITS, KPACK
      REAL PDATA
      DIMENSION PDATA(*), KGRIB(*), KSEC1(*), KSEC4(*)
C
C     Local variables.
C
      INTEGER J110, J310, IPOWER, ISUBSET
      INTEGER IVAL, IRET, IRETA, IRETB, IEXP, IMANT
      INTEGER INSPTA, ILEN, ISCALE
      INTEGER ILEN4, IFLAG, ISIZE
C
#ifndef _CRAYFTN
#ifdef POINTER_64
      INTEGER*8 IPIVAL
#endif
#endif
      POINTER (IPIVAL, IVAL)
      DIMENSION IVAL(1)
      SAVE IPIVAL, ISIZE
C
      REAL ZREF, ZSCALE
C
C     Externals
C
#ifdef POINTER_64
      INTEGER*8 JMALLOC
#else
      INTEGER JMALLOC
#endif
      INTEGER UNPKCF, GSCALE
      EXTERNAL UNPKCF, GSCALE, JMALLOC
C
      DATA ISIZE/0/
C
C     -----------------------------------------------------------------
C*    Section 1 . Decode octets 1 to 11.
C     -----------------------------------------------------------------
C
  100 CONTINUE
C
      DSECT4 = 0
C
C     Allocate memory (first time only)
      IF( ISIZE.LT.((KTRUNC+1)*(KTRUNC+2)*JPBYTES) ) THEN
        IF( ISIZE.NE.0 ) CALL JFREE(IPIVAL)
        ISIZE = (KTRUNC+1)*(KTRUNC+2)*JPBYTES
        IPIVAL = JMALLOC(ISIZE)
#ifdef hpR64
        IPIVAL = IPIVAL/(1024*1024*1024*4)
#endif
        IF( IPIVAL.EQ.0 ) THEN
          WRITE(*,*) 'DSECT4: Memory allocation failed.'
          WRITE(*,*) 'DSECT4: Number of bytes required = ', ISIZE
          DSECT4 = 16123
          GOTO 900
        ENDIF
      ENDIF
C
C     Preserve bit position of start of section 4.
      INSPTA = KNSPT
C
C     Fill in the number of values unpacked
      KSEC4(1) = (KTRUNC+1)*(KTRUNC+2)
C
C     Octets 1 - 3: Length of section.
C     One 24-bit field.
C
      CALL INXBIT(KGRIB,KLENG,KNSPT,ILEN4,1,KBITS,24,'D',IRET)
      IF (IRET.NE.0) THEN
        DSECT4 = 16110
        WRITE(*,*) 'DSECT4: Problem unpacking length of section.'
        GO TO 900
      ENDIF
C
C     Octet 4:
C     One 4-bit field -> flag, spherical harmonics/complex/float point
C     One 4-bit field -> number of unused bits at end of section 4.
C
      CALL INXBIT(KGRIB,KLENG,KNSPT,IFLAG,1,KBITS,8,'D',IRET)
      IF (IRET.NE.0) THEN
        DSECT4 = 16111
        WRITE(*,*) 'DSECT4: Problem unpacking flag byte.'
        GO TO 900
      ENDIF
C
C     Check the flag
      IF ( (IFLAG/16) .NE. 12 ) THEN
        DSECT4 = 16112
        WRITE(*,*) 'DSECT4: Flag wrong = ', IFLAG
        GO TO 900
      ELSE
        KSEC4(3) = 128
        KSEC4(4) = 64
        DO 110 J110 = 5, 33
          KSEC4(J110) = 0
  110   CONTINUE
      ENDIF
C
C*    Octets 5 - 6 : Scale factor.
C     One 16 bit field.
C
C     Adjust bit pointer over first 4 octets and insert scale factor.
      CALL INXBIT(KGRIB,KLENG,KNSPT,ISCALE,1,KBITS, 16,'D',IRET)
      IF (IRET.NE.0) THEN
        DSECT4 = 16113
        WRITE(*,*) 'DSECT4: Problem unpacking scale factor.'
        GO TO 900
      ENDIF
C
C     Make negative if sign bit set
      IF ( ISCALE .GT. JP15BIT ) THEN
        ISCALE = ISCALE - JP15BIT
        ISCALE = -ISCALE
      ENDIF
      ZSCALE = 2.0**ISCALE
C
C*    Octets 7 - 10 : Reference value.
C     One 8 bit and one 24 bit field.
C
C     Extract reference value exponent and mantissa.
      CALL INXBIT(KGRIB,KLENG,KNSPT,IEXP,1,KBITS, 8,'D',IRETA)
      CALL INXBIT(KGRIB,KLENG,KNSPT,IMANT,1,KBITS, 24,'D',IRETB)
      IRET = IRETA + IRETB
      IF (IRET.NE.0) THEN
        DSECT4 = 16114
        WRITE(*,*) 'DSECT4: Problem unpacking reference value.'
        GO TO 900
      ENDIF
C
C     Decode the reference value
      CALL DECFP2 (ZREF,IEXP,IMANT)
C
C*    Octet 11 : Number of bits containing each packed value.
C     One 8 bit field.
C
C     Extract number of bits for each packed value.
      CALL INXBIT(KGRIB,KLENG,KNSPT,KSEC4(2),1,KBITS, 8,'D',IRET)
      IF (IRET.NE.0) THEN
        DSECT4 = 16115
        WRITE(*,*) 'DSECT4: Problem unpacking number of bits/value.'
        GO TO 900
      ENDIF
C
C     -----------------------------------------------------------------
C*    Section 2 . Decode octets 12 to 18.
C     -----------------------------------------------------------------
C
  200 CONTINUE
C
C     Octets 12 - 13: Octet number of the start of packed data
C     One 16-bit field.
C
C     Extract octet number of the start of packed data.
      CALL INXBIT(KGRIB,KLENG,KNSPT,KSEC4(16),1,KBITS,16,'D',IRET)
      IF (IRET.NE.0) THEN
        DSECT4 = 16116
        WRITE(*,*) 'DSECT4: Problem unpacking start of packed data.'
        GO TO 900
      ENDIF
C
C     Octets 14 - 15: Scaling factor; power of Laplacian operator
C                     applied to field before packing.
C     One 16-bit field.
C
C     Extract scaling power.
      CALL INXBIT(KGRIB,KLENG,KNSPT,IPOWER,1,KBITS,16,'D',IRET)
      IF (IRET.NE.0) THEN
        DSECT4 = 16117
        WRITE(*,*) 'DSECT4: Problem unpacking scaling power.'
        GO TO 900
      ENDIF
C
C     Set value negative if sign bit set.
      IF (IPOWER.GT.JP15BIT) THEN
        IPOWER = IPOWER - JP15BIT
        IPOWER = -IPOWER
      ENDIF
      KSEC4(17) = IPOWER
C
C     Octets 16 - 18: Pentagonal resolution parameters J,K,M
C                     specifying truncation of subset of data
C                     represented unpacked.
C     Three 8-bit fields.
C
C     Extract pentagonal resolution parameters.
      CALL INXBIT(KGRIB,KLENG,KNSPT,KSEC4(18),3,KBITS, 8,'D',IRET)
      IF (IRET.NE.0) THEN
        DSECT4 = 16118
        WRITE(*,*)
     X    'DSECT4: Problem unpacking pentagonal resolution params.'
        GO TO 900
      ENDIF
      ISUBSET = KSEC4(18)
      IF ( ISUBSET .GT. KTRUNC ) THEN
        WRITE(*,*) 'DSECT4: Invalid subset truncation given'
        WRITE(*,*) 'DSECT4: ISUBSET, KTRUNC =', ISUBSET, KTRUNC
        DSECT4 = 16122
        GOTO 900
      ENDIF
C
C     -----------------------------------------------------------------
C*    Section 3.  Extract and scale binary values from GRIB product.
C     -----------------------------------------------------------------
C
  300 CONTINUE
C
C     Adjust bit pointer to end of stored subset of coefficients and
C     extract binary values from GRIB product -> updates bit pointer.
      KNSPT = 8*KSEC4(16)
      ILEN = (KTRUNC+1)*(KTRUNC+2) - (ISUBSET+1)*(ISUBSET+2)
      CALL INXBIT (KGRIB,KLENG,KNSPT,IVAL,ILEN, KBITS,KPACK, 'D',IRET)
      IF ( IRET .NE. 0 ) THEN
        WRITE(*,*) 'DSECT4: Problem unpacking bits'
        DSECT4 = 16119
        GOTO 900
      ENDIF
C
      DO 310 J310 = 1 , ILEN
         PDATA(J310)   = ( REAL(IVAL(J310)) *  ZSCALE ) + ZREF
  310 CONTINUE
C
C     Move the coefficients to their correct (scattered) in the array.
      CALL UNCMPCK( PDATA, KTRUNC, ISUBSET)
C
C
C     -----------------------------------------------------------------
C*    Section 4 . Unpack the subset of coefficients (stored IBM style).
C     -----------------------------------------------------------------
C
  400 CONTINUE
C
C     Adjust pointer to avoid first 18 octets.
      KNSPT = INSPTA + 18*8
C
C     Move back into original locations in the array and convert from
C     IBM format.
      IRET = UNPKCF( PDATA,KTRUNC,ISUBSET,KGRIB,KLENG,KNSPT,KBITS)
      IF ( IRET .NE. 0 ) THEN
        WRITE(*,*) 'DSECT4: Problem unpacking subset of coeffs.'
        DSECT4 = 16120
        GOTO 900
      ENDIF
C
C     -----------------------------------------------------------------
C*    Section 5 . Apply power scaling to field.
C     -----------------------------------------------------------------
C
  500 CONTINUE
C
      IRET = GSCALE( PDATA, KTRUNC, ISUBSET, IPOWER, 'O')
      IF ( IRET .NE. 0 ) THEN
        WRITE(*,*) 'DSECT4: Problem applying power scaling'
        DSECT4 = 16121
        GOTO 900
      ENDIF
C
C     Set bit pointer on 7777 group - section 5
      KNSPT = INSPTA + 8*ILEN4
C
C     -----------------------------------------------------------------
C*    Section 9. Return to calling routine.
C     -----------------------------------------------------------------
C
  900 CONTINUE
C
      RETURN
      END

C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

#if (defined CRAY) || (defined __uxp__ ) || (defined IBM_POWER4) || (defined rs6000) || (defined NECSX) || (defined POWERPC)
      SUBROUTINE GSBITE (KS,KD,KSKST,KSIZE,KSKBTW,K,KBPW,KMASK,HADIR)
C
C---->
C**** GSBITE - Extraction/insertion of bits from/to bitstream on Cray.
C
C     Purpose.
C     --------
C
C     Vectorising extraction/insertion of bits from/to bitstream.
C
C**   Interface.
C     ----------
C
C     CALL GSBITE (KS,KD,KSKST,KSIZE,KSKBTW,K,KBPW,KMASK,HADIR)
C
C
C     Input Parameters.
C     -----------------
C
C     KS      - If HADIR='D', input bit stream, else output bit stream.
C     KD      - If HADIR='D', output words, else input words.
C     KSKST   - Number of bits skipped at beginning of KS.
C     KSIZE   - Number of bits to be extracted to one word of KD.
C     KSKBTW  - Number of bits skipped between 2 words to be extracted.
C     K       - Number of words to be extracted into KD. If less than
C               or equal to 0 only calculate KBPW and KMASK.
C     KBPW    - Number of bits per word in KS,calculated if 0.
C     KMASK   - Masks for bit patterns, calculated if KMASK(2) is 0.
C               (KMASK must have dimension KBPW+1)
C     HADIR   - Direction of conversion: 'D' for decoding, ie
C               extract words KD(1...K) from bits KS(KSKST+1....)
C               If not 'D', encode, i.e. pack words KD(1....K) into
C               bits KS(KSKST+1.....KSKST+K*(KSIZE+KSKBTW))
C
C
C     Output Parameters.
C     ------------------
C
C     KS,KD   - See above.
C     KSKST   - Updated to number of bits used, i.e. to
C               KSKST+K*(KSIZE+KSKBTW)
C     KBPW    - If 0 on input, number of bits in each word of KS.
C     KMASK   - If KMASK(2) was 0 on input, bit pattern masks.
C               (KMASK must have dimension KBPW+1)
C
C
C     Method.
C     -------
C
C     Vector loop is over repeatedly occurring bit patterns.
C
C     Externals.
C     ----------
C
C     None.
C
C
C     Reference.
C     ----------
C
C     None.
C
C
C     Comments.
C     ---------
C
C     This routine is for vector processors only.
C
C
C     Author.
C     -------
C
C     G.J.Cats 08 Dec 87
C
C
C     Modifications.
C     --------------
C
C     J. Hennessy     ECMWF     09.09.91
C     Introductory comments changed to conform to standard.
C
C     J.D.Chambers    ECMWF     05.01.95
C     Put in fixes suggested by G.Cats (Dec. 95) for:
C     i)    "Number of words to be extracted = 0"
C     ii)   Optimise test for encode/decode in loop by using logical.
C     iii)  Intialise ISTS before use.
C
C     J.D.Chambers    ECMWF     22.05.96
C     Defines to remove inline functions except on CRAY
C     (The Fujitsu doesn't need them).
C
C     J. Clochard, Meteo France, for ECMWF - January 1998.
C     Use intrinsic functions on CRAY.
C
C
C     ------------------------------------------------------------------
C----<
C
      DIMENSION KS(*),KD(*),KMASK(*)
      CHARACTER*1 HADIR
      LOGICAL     LODECD
C
C     1.  COMPLETE KBPW AND KMASK, RETURN IF 0 WORDS ARE TO BE EXTRACTED
C
      IF(KBPW.EQ.0) THEN
         IS    = KS(1)
         KS(1) = 1
 1101    CONTINUE
         IF(KS(1).NE.0) THEN
            KBPW  = KBPW + 1
            KS(1) = ISHFT(KS(1),1)
            GOTO 1101
         ENDIF
         KS(1) = IS
      ENDIF
      IF(KMASK(2).EQ.0) THEN
         KMASK(KBPW+1) = 0
         DO 1110 J = KBPW,1,-1
           KMASK(J) = IBSET(KMASK(J+1),KBPW-J)
 1110    CONTINUE
      ENDIF
      IF(K.LE.0)RETURN
C
C     2.  PRESET KD TO 0 IF KD IS OUTPUT I.E. WHEN DECODING
C
      LODECD = HADIR .EQ. 'D'
      IF (LODECD) THEN
         DO 2101 J = 1,K
           KD(J) = 0
 2101    CONTINUE
      ENDIF
      IF(KSIZE.LE.0) RETURN
C
C     3.  CALCULATE SEVERAL PARAMETERS FOR LOOPING (FOR EFFICIENCY, THE
C         CODE OF SECTIONS 3.3 AND 3.4 FOR K=1 IS SEPARATED INTO 3.2)
C
C     3.1 NUMBER OF BITS USED PER WORD, INITIAL NR OF SKIPPED BITS
C
      ISTEP = KSIZE + KSKBTW
      ISKWS = KSKST
C
C     3.2 VECTOR LOOP LENGTH AND STEP SIZE IN KD IF K=1;KS STEP IRRELVNT
C
      IF(K.EQ.1) THEN
         ILL  = 1
         IBDL = 2
         ISTD = 1
         ISTS = 1
      ELSE
C
C     3.3 STEP SIZES IN KS,KD: INVERSE OF LARGEST FACTOR OF ISTEP,KBPW
C
         ILCF = KBPW
         ISHF = ISTEP
 331     CONTINUE
         IF(ILCF.EQ.ISHF) GOTO 332
         IF(ILCF.EQ.1) GOTO 332
         IF(ILCF.GT.ISHF) THEN
            ILCF = ILCF - ISHF
         ELSE
            ISHF = ISHF - ILCF
         ENDIF
         GOTO 331
 332     CONTINUE
         ISTD = KBPW/ILCF
         ISTS = ISTEP/ILCF
C
C     3.4 VECTOR LOOP LENGTH AND SWITCH-OVER POINT FOR SMALLER LOOP
C
         ILL  = (K-1)/ISTD + 1
         IBDL = K - (ILL-1)*ISTD
      ENDIF
C
C     4.  LOOP OVER FIRST ISTD WORDS OF KD (TRAILS THE VECTOR LOOP)
C
      DO 790 JBD = 1,ISTD
C
C       4.1 LAST BIT IN KS TO BE TREATED
C
        IENBS = ISKWS + KSIZE
C
C       4.2 NR OF WORDS OF KS TO BE SKIPPED, NR OF BITS IN THOSE AND
C           THIS
C
        ISKW = ISKWS/KBPW
        ISTA = ISKW*KBPW
        ISKB = ISKWS - ISTA
C
C       4.3 MASK AND LEFT SHIFT FOR THE REMAINING BITS
C
        IMASK = KMASK(ISKB+1)
        ISH   = KSIZE + ISKB
C
C       4.4 POSITION OF CURRENT WORD OF KS
C
        IBS = ISKW + 1
C
C       5.  LOOP OVER WORDS OF KS CONTRIBUTING TO ONE WORD OF KD
C
 500    CONTINUE
C
C       5.1 UPDATE SHIFT AND LAST BIT IN CURRENT WORD
C
        ISH  = ISH - KBPW
        IEND = ISTA + KBPW
C
C       5.2 IS LAST BIT OF CURRENT WORD OUTSIDE RANGE TO BE EXTRACTED
C
        IF(IEND.GT.IENBS) THEN
          ISH   = IENBS - IEND
          IMASK = IAND(IMASK,NOT(KMASK(KBPW+ISH+1)))
        ENDIF
C
C       5.3 INITIAL OFFSETS FOR VECTOR ELEMENTS IN VECTOR LOOP
C
        IOS = 0
        IOD = 0
C
C     6.  VECTOR LOOP IS OVER REPEATEDLY OCCURRING BITPATTERNS/MASKS
C
        IF (LODECD) THEN
Cjdc#ifdef CRAY
CDIR$ IVDEP
!cdir nodep
          DO 611 JI = 1,ILL
            KD(JBD+IOD) =
     X        IOR(KD(JBD+IOD),ISHFT(IAND(IMASK,KS(IBS+IOS)),ISH))
            IOD = IOD + ISTD
            IOS = IOS + ISTS
 611      CONTINUE
Cjdc#else
!OCL NOVREC
Cjdc       CALL GSDECODE( KS(IBS), KD(JBD), ISTS, ISTD, ILL, IMASK, ISH )
Cjdc#endif
        ELSE
Cjdc#ifdef CRAY
CDIR$ IVDEP
!OCL NOVREC
!cdir nodep
          DO 612 JI = 1,ILL
            KS(IBS+IOS) = IOR(
     X      IAND(      KS(IBS+IOS),           NOT(IMASK)),
     X      IAND(ISHFT(KD(JBD+IOD),-ISH),    IMASK ))
            IOD = IOD + ISTD
            IOS = IOS + ISTS
 612      CONTINUE
Cjdc#else
Cjdc        CALL GSENCODE( KD(JBD), KS(IBS), ISTD, ISTS, ILL, IMASK, ISH )
Cjdc#endif
        ENDIF
C
C       7.  END LOOPS
C
C       7.1 PREPARE FOR END OF LOOP OVER WORDS OF KS WITIHN ONE KD WORD
C
        ISTA = ISTA + KBPW
C
C       7.2 NEXT WORD OF KD IF EXTRACTION NOT COMPLETED
C
        IF(ISTA.LT.IENBS) THEN
          IMASK = KMASK(1)
          IBS   = IBS + 1
          GOTO 500
        ENDIF
C
C       7.8 PREPARE FOR END OF LOOP OVER FIRST WORDS OF KD
C
        IF(JBD.EQ.IBDL)ILL = ILL - 1
        ISKWS = ISKWS + ISTEP
C
C       7.9 END LOOP OVER FIRST WORDS OF KD
C
 790  CONTINUE
C
C     8.  FINISHED: UPDATE KSKST AND RETURN
C
      KSKST = KSKST + K*ISTEP
C
      RETURN
      END
#endif

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE BUEXS0( KBUFL,KBUFF,KSUP,KSEC0,KERR)
C
C**** *BUEXS0*
C
C
C     PURPOSE.
C     --------
C          EXPANDS SECTION 0 OF BUFR MESSAGE. SAVES BUFR EDITION NUMBER
C     AND TOTAL LENGTH OF BUFR MESSAGE (BYTES).
C
C
C**   INTERFACE.
C     ----------
C
C          *CALL* *BUEXS0( KBUFL,KBUFF,KSUP,KSEC0,KERR)*
C
C        INPUT :
C               *KBUFL*   -  LENGTH OF BUFR MESSAGE (WORDS)
C               *KBUFF*   -  ARRAY CONTAINING BUFR MESSAGE
C        OUTPUT:
C               *KSUP*    -  ARRAY CONTAINING SUPLEMENTARY INFORMATION
C                         -  KSUP( 1) -- IDIM1, DIMENSION OF KSEC1
C                         -  KSUP( 2) -- IDIM2, DIMENSION OF KSEC2
C                         -  KSUP( 3) -- IDIM3, DIMENSION OF KSEC3
C                         -  KSUP( 4) -- IDIM4, DIMENSION OF KSEC4
C                         -  KSUP( 5) -- M (NUMBER OF ELEMENTS IN VALUES ARRAY,
C                                           FIRST INDEX)
C                         -  KSUP( 6) -- N (NUMBER OF SUBSETS,SECOND INDEX OF
C                                           VALUES ARRAY)
C                         -  KSUP( 7) -- JVC (NUMBER OF ELEMENTS IN CVAL ARRAY)
C                         -  KSUP( 8) -- TOTAL BUFR MESSAGE LENGTH IN BYTES
C                         -  KSUP( 9) -- IDIM0, DIMENSION OF KSEC0
C               *KSEC0*   -  ARRAY CONTAINING SECTION 0 INFORMATION
C                            KSEC0( 1)-- LENGTH OF SECTION 0 (BYTES)
C                            KSEC0( 2)-- TOTAL LENGTH OF BUFR MESSAGE (BYTES)
C                            KSEC0( 3)-- BUFR EDITION NUMBER
C               *KERR*    -  RETURNED ERROR CODE
C
C     METHOD.
C     --------
C
C          NONE.
C
C     EXTERNALS.
C     ----------
C
C          BUNPKS          - UNPACK BIT PATTERN IN REPEATED WAY
C          BUNPCK          - UNPACK BIT PATTERN
C
C     REFERENCE.
C     ----------
C
C          NONE.
C
C     AUTHOR.
C     -------
C
C          M. DRAGOSAVAC    *ECMWF*       15/09/91.
C
C
C     MODIFICATIONS.
C     --------------
C
C          NONE.
C
C
      IMPLICIT LOGICAL(L,O,G), CHARACTER*8(C,H,Y)
C
C
C
#     include "parameter.F"
#     include "bcomunit.F"
#     include "bcomwork.F"
C
      DIMENSION KBUFF(KBUFL),KSUP(*),KSEC0(*)
      DIMENSION IBUFR(4)
#ifndef R_4
      REAL*8 RVIND
      REAL*8 EPS
#else
      REAL   RVIND
      REAL   EPS
#endif
C
      CHARACTER*4 YBUFR
C
C     ------------------------------------------------------------------
C*          1.   EXPAND SECTION 0.
C                -----------------
 100  CONTINUE
C
      IF( KERR.NE.0 ) RETURN
C
C
C*          1.1  INITIALIZE WORKING POINTERS NWPT AND NBPT.
C                ------------------------------------------
      IWPT = 0
      IBPT = 0
      NWPT = 1
      NBPT = 0
C
C*          1.2  UNPACK FIRST FOUR OCTETS CONTAINING *BUFR*.
C                -------------------------------------------
C
      CALL BUNPKS(NBPW,KBUFF,IBUFR,NWPT,NBPT,8,0,4,KERR)
      IF(KERR.GT.0) THEN
         WRITE(KNTN,*)  'ERROR UNPACKING FIRST FOUR OCTETS OF BUFR
     1 MESSAGE.'
         RETURN
      END IF
C
C*          1.3  CHECK IF FIRST FOUR OCTETS ARE 'BUFR'.
C                --------------------------------------
      YBUFR=CHAR(IBUFR(1))//CHAR(IBUFR(2))//
     1      CHAR(IBUFR(3))//CHAR(IBUFR(4))
      IF(YBUFR.NE.'BUFR') THEN
         KERR = 1
         CALL BUERR(KERR)
         RETURN
      END IF
C
C*          1.4 UNPACK BUFR EDITION NUMBER (IT IS 8TH BYTE ).
C               ---------------------------------------------
 140  CONTINUE
C
      IWPT=56/NBPW+1
      IBPT=56-(IWPT-1)*NBPW
C
      CALL BUNPCK(NBPW,KBUFF,KSEC0(3),IWPT,IBPT,8,KERR)
      IF(KERR.GT.0) THEN
      	     WRITE(KNTN,*)  'ERROR UNPACKING KSEC0(3).'
         RETURN
      END IF
C
      IF(KSEC0(3).LE.1) GO TO 170
C
C*          1.5 UNPACK TOTAL LENGTH OF BUFR MESSAGE.
C               ------------------------------------
 150  CONTINUE
C
      CALL BUNPCK(NBPW,KBUFF,KSEC0(2),NWPT,NBPT,24,KERR)
      IF(KERR.GT.0) THEN
         WRITE(KNTN,*)  'ERROR UNPACKING KSEC0(2).'
         RETURN
      END IF
C
C*          1.6 UNPACK BUFR EDITION NUMBER.
C               ---------------------------
 160  CONTINUE
C
      CALL BUNPCK(NBPW,KBUFF,KSEC0(3),NWPT,NBPT,8,KERR)
      IF(KERR.GT.0) THEN
         WRITE(KNTN,*)  'ERROR UNPACKING KSEC0(3).'
         RETURN
      END IF
C
C
C*          1.7 SET LENGTH OF SECTION 0.
C               ------------------------
 170  CONTINUE
C
      KSEC0(1)= 4
      IF(KSEC0(3).GT.1) KSEC0(1)= 8
C
C*          1.8 SET SUPPLEMENTARY INFORMATION.
C               ------------------------------
 180  CONTINUE
C
      KSUP (9)= 3
C
      RETURN
C     -----------------------------------------------------------------
C
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      LOGICAL FUNCTION CHEQUAL( HIN, KFIRST, KLAST, HCOMP)
C
C---->
C**** CHEQUAL
C
C     Purpose
C     -------
C
C     Compare two ASCII character strings without regard to case.
C
C
C     Interface
C     ---------
C
C     Input
C     -----
C
C     HIN   - First string
C     KFIRST- position of first character in string for comparison
C     KLAST - position of last character in string for comparison
C     HCOMP - Second string
C
C
C     Method
C     ------
C
C     Compare values as uppercase letters.
C
C
C     Externals
C     ---------
C
C     None.
C
C
C     Author
C     ------
C
C     J.D.Chambers       ECMWF        January 1995.
C
C----<
C
      IMPLICIT NONE
C
C     Function arguments
C
      CHARACTER*(*) HIN, HCOMP
      INTEGER  KFIRST, KLAST, LOOP, ITEMP1, ITEMP2, ITEMPA
#ifdef rs6000
      ITEMPA = ICHAR( 'a' )
#else
      DATA ITEMPA/97/  !ITEMPA = ICHAR( 'a' )
#endif

      CHEQUAL = .FALSE.
      IF( (KFIRST.GT.KLAST)
     .    .OR. (LEN(HIN)  .LT.KLAST)
     .    .OR. (LEN(HCOMP).LT.KLAST) ) RETURN

      DO LOOP =  KFIRST, KLAST
        ITEMP1 = ICHAR( HIN  (LOOP:LOOP) )
        ITEMP2 = ICHAR( HCOMP(LOOP:LOOP) )
        IF ( ITEMP1 .LT. ITEMPA ) ITEMP1 = ITEMP1 + 32
        IF ( ITEMP2 .LT. ITEMPA ) ITEMP2 = ITEMP2 + 32
        IF ( ITEMP1 .NE. ITEMP2 ) RETURN
      ENDDO

      CHEQUAL = .TRUE.

      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE BUGET_OPERA_IMAGE(KSEC1,KTDEXL,KTDEXP,
     1      CNAMES,CUNITS, KELEM,KVALS,VALUES,CVALS,KTDEXL_IMG,
     2      KTDEXP_IMG,CNAMES_IMG,CUNITS_IMG,KVALS_IMG,VALUES_IMG,
     3      CVALS_IMG,KSIZE_IMG_BYTES,IMAGE,KPIXEL_SIZE,KERR)
C
C**** *BUGET_OPERA_IMAGE*
C
C
C     PURPOSE.
C     --------
C          APPLY DELAYED REPETITIONS TO GET FULL IMAGE
C
C
C**   INTERFACE.
C     ----------
C
C          *CALL* *BUGET_OPERA_IMAGE(KSEC1,KTDEXL,KTDEXP,CNAMES,CUNITS,
C                  KELEM,,KVALS,VALUES,CVALS,
C                  KTDEXL_IMG,KTDEXP_IMG,CNAMES_IMG,CUNITS_IMG,
C                  KVALS_IMG,VALUES_IMG,CVALS_IMG,IMAGE,KPIXEL_SIZE,KERR)
C
C        INPUT :
C               *KSEC1*      -  An integer array of at least 40 words containing Bufr Section 1
C               *KTDEXL*     -  An integer variable containing number of expanded data descriptors
C               *KTDEXP*     -  An integer array containing the list of KTDEXL data descriptors
C               *CNAMES*     -  A CHARACTER*64  array of kelem containing element names
C               *CUNITS*     -  A CHARACTER*24 array of kelem containig bufr table B units
C               *KELEM*      -  An integer containing expected number of expanded elements
C               *KVALS*      -  An integer containing expected number of data elelemnts
C               *VALUES*     -  A REAL*8 array containing expanded values
C               *CVALS*      -  A CHARACTER*80 array containing character values
C        OUTPUT:
C               *KTDEXL_IMG* - An integer variable containing number of expanded data descriptors
C               *KTDEXP_IMG* - An integer array containing the list of KTDEXL_IMG data descriptors
C               *CNAMES_IMG* - A CHARACTER*64  array of kelem containing element names
C               *CUNITS_IMG* - A CHARACTER*24 array of kelem containig bufr table B units
C               *KVALS_IMG*  - An integer containing  number pixels in IMAGE
C               *VALUES_IMG* - A REAL*8 array containing expanded values
C               *CVALS_IMG*  - A CHARACTER*80 array containing character values
C               *IMAGE*      - Integer array containing image ( pixel values)
C               *KPIXEL_SIZE*- Integer containing pixel size in bytes
C               *KERR*    -  RETURNED ERROR CODE
C
C     METHOD.
C     -------
C
C           NONE.
C
C
C     EXTERNALS.
C     ----------
C
C
C     REFERENCE.
C     ----------
C
C          NONE.
C
C     AUTHOR.
C     -------
C
C          M. DRAGOSAVAC    *ECMWF*       02/04/2008
C
C
C     MODIFICATIONS.
C     --------------
C
C          NONE.
C
C
      IMPLICIT LOGICAL(L,O,G), CHARACTER*8(C,H,Y)
C
C
#     include "parameter.F"
C
      PARAMETER (JPIXEL=10000000)
C
      DIMENSION KSEC1(JSEC1)
      INTEGER*4 IMAGE(*)
      INTEGER*4 IPIXELS(JPIXEL)
C     
      DIMENSION KTDEXP(*)
      DIMENSION KTDEXP_IMG(*)
      REAL*8    VALUES_IMG(*)
C
      CHARACTER*64 CNAMES(*),CNAMES_IMG(*)
      CHARACTER*24 CUNITS(*),CUNITS_IMG(*)
      CHARACTER*80 CVALS(*) ,CVALS_IMG(*)
C
      CHARACTER*256 COUT1,COUT2,COUT3
C
#ifndef R_4
      REAL*8 VALUES(KVALS)
      REAL*8 RVIND
      REAL*8 EPS
#else
      REAL   VALUES(KVALS)
      REAL   RVIND
      REAL   EPS
#endif
C
C     ------------------------------------------------------------------
C
      RVIND=1.7D38
      EPS=10.D-8
C     Create image
c
      IROW=0
      DO I=1,KTDEXL
      IF(KTDEXP(i).eq.005031) THEN
         IROW=IROW+1
      END IF
      END DO

C
      I_N_BYTE=0
      DO I=1,KTDEXL
      IF(KTDEXP(i).eq.030001) THEN
         I_N_BYTE=1
      ELSEIF(KTDEXP(i).eq.030002) THEN
         I_N_BYTE=1
      ELSEIF(KTDEXP(i).eq.030004) THEN
         I_N_BYTE=2 
      END IF
      END DO


C     print*,'Size of pixel in bytes=',I_N_BYTE
C     print*,'total number of rows=',irow

      DO I=1,KTDEXL
       IF(KTDEXP(I).EQ.005031.AND.KTDEXP(i-1).EQ.031002) THEN
         IMAGE_START=I-1
         GO TO 100
       END IF
      END DO
c
 100  CONTINUE
c
      DO I=1,IMAGE_START-1
      KTDEXP_IMG(I)=KTDEXP(I)
      END DO

      KTDEXL_IMG=IMAGE_START-1
c
C     print*,'KTDEXL_IMG=',KTDEXL_IMG
C     print*,'image_start=',image_start
C
      DO I=1,IMAGE_START-1
      VALUES_IMG(I)=VALUES(I)
      CNAMES_IMG(I)=CNAMES(I)
      CUNITS_IMG(I)=CUNITS(I)
      END DO
C
C     DO I=1,IMAGE_START-1
C     WRITE(IUNIT2,'(I6,1X,A64,E23.14E3,1x,a24)') I,CNAMES(I),
C    c                                VALUES(I),CUNITS(I)
C     END DO
C
      NBPW=JBPW
      NWPT=1
      NBPT=0
      IMX=0
      MAX=0
      i0=0
      DO I=IMAGE_START,KTDEXL
      IF(KTDEXP(I).EQ.005031) THEN
      END IF
      IF(KTDEXP(I).EQ.030001.AND.KTDEXP(I-1).EQ.031012) THEN
            I_REPEAT=NINT(VALUES(I-1))
            DO J=1,I_REPEAT
            IMX=IMX+1
            if(abs(VALUES(I)-rvind)/rvind.lt.eps) then
               ipixels(IMX)=255
            else
               IF(NINT(VALUES(I)).GT.MAX) MAX=NINT(VALUES(I))
               IVAL=NINT(VALUES(I))
               ipixels(IMX)=ival
            end if
            END DO
      ELSEIF(KTDEXP(I).EQ.030002.AND.KTDEXP(I-1).EQ.031012) THEN
            I_REPEAT=NINT(VALUES(I-1))
            DO J=1,I_REPEAT
            IMX=IMX+1
            if(abs(VALUES(I)-rvind)/rvind.lt.eps) then
               ipixels(IMX)=255
               CALL BUPCK(NBPW,IMAGE(NWPT),255,NWPT,NBPT,8,IERR)
            else
               IF(NINT(VALUES(I)).GT.MAX) MAX=NINT(VALUES(I))
               IVAL=NINT(VALUES(I))
               ipixels(IMX)=ival
            end if
            END DO
      ELSEIF(KTDEXP(i).EQ.030004.AND.KTDEXP(I-1).EQ.031012) THEN
            I_REPEAT=NINT(VALUES(I-1))
            DO J=1,I_REPEAT
            IMX=IMX+1
            if(abs(VALUES(I)-rvind)/rvind.lt.eps) then
               ipixels(IMX)=65535
            else
               IF(NINT(VALUES(I)).GT.MAX) MAX=NINT(VALUES(I))
               IVAL=NINT(VALUES(I))
               ipixels(IMX)=ival
            end if
            END DO
      ELSEIF(KTDEXP(I).EQ.030001.AND.KTDEXP(I-1).EQ.031011) THEN
            I_REPEAT=NINT(VALUES(I-1))
            DO J=1,I_REPEAT
            IMX=IMX+1
            if(abs(VALUES(I)-rvind)/rvind.lt.eps) then
               ipixels(IMX)=255
            else
               IF(NINT(VALUES(I)).GT.MAX) MAX=NINT(VALUES(I))
               IVAL=NINT(VALUES(I))
               ipixels(IMX)=ival
            end if
            END DO
      ELSEIF(KTDEXP(I).EQ.030002.AND.KTDEXP(I-1).EQ.031011) THEN
            I_REPEAT=NINT(VALUES(I-1))
            DO J=1,I_REPEAT
            IMX=IMX+1
            if(abs(VALUES(I)-rvind)/rvind.lt.eps) then
               ipixels(IMX)=255
            else
               IF(NINT(VALUES(I)).GT.MAX) MAX=NINT(VALUES(I))
               IVAL=NINT(VALUES(I))
               ipixels(IMX)=ival
            end if
            END DO
      ELSEIF(KTDEXP(I).EQ.030004.and.KTDEXP(I-1).EQ.031011) THEN
            I_REPEAT=NINT(VALUES(I-1))
            DO J=1,I_REPEAT
            IMX=IMX+1
            if(abs(VALUES(I)-rvind)/rvind.lt.eps) then
               ipixels(IMX)=65535
            else
               IF(NINT(VALUES(I)).GT.MAX) MAX=NINT(VALUES(I))
               IVAL=NINT(VALUES(I))
               ipixels(IMX)=ival
            end if
            END DO
      ELSEIF(KTDEXP(I).EQ.030001) THEN
            IMX=IMX+1
            if(abs(VALUES(I)-rvind)/rvind.lt.eps) then
               ipixels(IMX)=255
            else 
               IF(NINT(VALUES(I)).GT.MAX) MAX=NINT(VALUES(I))
               IVAL=NINT(VALUES(I))
               ipixels(IMX)=ival
            end if
      ELSEIF(KTDEXP(I).EQ.030002) THEN
            IMX=IMX+1
            if(abs(VALUES(I)-rvind)/rvind.lt.eps) then
               ipixels(IMX)=255
            else
               IF(NINT(VALUES(I)).GT.MAX) MAX=NINT(VALUES(I))
               IVAL=NINT(VALUES(I))
               ipixels(IMX)=ival
            end if
      ELSEIF(KTDEXP(I).EQ.030004) THEN
            IMX=IMX+1
            if(abs(VALUES(I)-rvind)/rvind.lt.eps) then
               ipixels(IMX)=65355
            else
               IF(NINT(VALUES(I)).GT.MAX) MAX=NINT(VALUES(I))
               IVAL=NINT(VALUES(I))
               ipixels(IMX)=ival
            end if
      END IF
      END DO
C
      KSIZE_IMG_BYTES=IMX*I_N_BYTE
      KPIXEL_SIZE=I_N_BYTE
      KVALS_IMG=IMX
C
      CALL SBYTES(IMAGE,IPIXELS,0,8,0,IMX)
      
C     print*,'max pixel value=',max
C     print*,'number of pixels=',KVALS_IMG
C     print*,'image size bytes=',KSIZE_IMG_BYTES
C
      GO TO 900
C     -----------------------------------------------------------------
C
 810  CONTINUE
C
      WRITE(*,'(1H ,A)') 'OPEN ERROR ON INPUT FILE'
      GO TO 900
C
 800  CONTINUE
C
      IF(IRET.EQ.-1) THEN
         PRINT*,'NUMBER OF RECORDS PROCESSED ',N
         PRINT*,'NUMBER OF OBSERVATIONS      ',IOBS
      ELSE
         PRINT*,' BUFR : ERROR= ',IERR
      END IF
C
 900  CONTINUE
C
C
C     ------------------------------------------------------------------
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      INTEGER FUNCTION IAFREE (KPR, KERR)
C
C---->
C**** *IAFREE*
C
C     PURPOSE
C     _______
C
C     Deallocate heap space used by grid-pt to grid-pt interpolation.
C
C     INTERFACE
C     _________
C
C     IERR = IAFREE (KPR, KERR)
C
C     Input parameters
C     ________________
C
C     KPR        - The debug print switch.
C                  0  , No debugging output.
C                  1  , Produce debugging output.
C
C     KERR       - The error control flag.
C                  -ve, No error message. Return error code.
C                  0  , Hard failure with error message.
C                  +ve, Print error message. Return error code.
C
C     Output parameters
C     ________________
C
C     None
C
C     Return value
C     ____________
C
C     The error indicator (INTEGER).
C
C     Error and Warning Return Values
C     _______________________________
C
C     Cray error codes
C
C     -1     HPDEALLC block is already free (Warning only).
C
C     21201  HPDEALLC attempt to free block at address outside the
C            bounds of the heap.
C     21202  HPDEALLC attempt to free block at address which was not
C            the beginning of a block.
C     21203  HPDEALLC returning any other non zero code.
C
C     Errors 21201 and 21202 should not occur and any occurrence
C     of one of these errors should be reported to Meteorological
C     Applications.
C
C     Common block usage
C     __________________
C
C     memreq.h     - This file contains the memory request
C                    definition variables.
C
C     MADDR        - The base addresses of the currently allocated
C                    memory segments used and reset.
C     MREQUEST     - The sizes of the current memory requests used
C                    and reset.
C
C
C     EXTERNALS
C     _________
C
C     INTLOG    - Logs messages.
C
C     Cray
C
C     ABORTX    - Standard routine to kill task.
C     HPDEALLC  - Cray library routine to deallocate heap space.
C
C     Sun and SGI
C
C     JFREE     - "Unix" routine to deallocate heap space.
C
C     METHOD
C     ______
C
C     The required heap space is allocated.
C
C     REFERENCE
C     _________
C
C     None
C
C     COMMENTS
C     ________
C
C     None.
C
C     AUTHOR
C     ______
C
C     K. Fielding      *ECMWF*      May 1994
C
C     MODIFICATIONS
C     _____________
C
C     J.D.Chambers      ECMWF       Aug 1994
C
C----<
C     _______________________________________________________
C
C
C*    Section 0. Definition of variables.
C     _______________________________________________________
C
C*    Prefix conventions for variable names
C
C     Logical      L (but not LP), global or common.
C                  O, dummy argument
C                  G, local variable
C                  LP, parameter.
C     Character    C, global or common.
C                  H, dummy argument
C                  Y (but not YP), local variable
C                  YP, parameter.
C     Integer      M and N, global or common.
C                  K, dummy argument
C                  I, local variable
C                  J (but not JP), loop control
C                  JP, parameter.
C     REAL         A to F and Q to X, global or common.
C                  P (but not PP), dummy argument
C                  Z, local variable
C                  PP, parameter.
C
C     Implicit statement to force declarations
C
      IMPLICIT NONE
C
#include "parim.h"
#include "memreq.h"
#include "nifld.common"
#include "nofld.common"
C
C     Dummy arguments
C
      INTEGER KPR, KERR
C
C     Local variables
C
      INTEGER IABORT, IERROR
C
      INTEGER JLEVEL
C
      INTEGER JPROUTINE
C
      PARAMETER (JPROUTINE = 21200)
C
C     External functions
C
C     _______________________________________________________
C
C
C*    Section 1. Initialisation
C     _______________________________________________________
C
  100 CONTINUE
C
      IF (KPR .GE. 1) CALL INTLOG(JP_DEBUG,'IAFREE: Section 1.',JPQUIET)
C
      IAFREE = 0
C
      IF (KPR .GE. 1) CALL INTLOG(JP_DEBUG,
     X 'IAFREE: Free all heap space.',JPQUIET)
C
C     _______________________________________________________
C
C
C*    Section 2. Free acquired space.
C     _______________________________________________________
C
  200 CONTINUE
C
      IF (KPR .GE. 1) CALL INTLOG(JP_DEBUG,'IAFREE: Section 2.',JPQUIET)
C
      IABORT = 0
      IERROR = 0
C
      DO 210 JLEVEL = JPLEVEL, 1, -1
C
         IF (MREQUEST (JLEVEL) .GT. 0) THEN
C
#ifdef CRAY
            CALL HPDEALLC (MADDR (JLEVEL), IERROR, IABORT)
C
            IF (IERROR .EQ. -4) THEN
              IAFREE = - 1
              IF (KERR .GE. 0) CALL INTLOG(JP_ERROR,
     X          'IAFREE: Already free, the block at ', MADDR (JLEVEL))
C
            ELSE IF (IERROR .NE. 0) THEN
C
              IF (IERROR .EQ. -3) THEN
C
                IAFREE = JPROUTINE + 1
C
                IF (KERR .GE. 0) THEN
                  CALL INTLOG(JP_ERROR,
     X              'IAFREE: Heap deallocation failed.',IERROR)
                  CALL INTLOG(JP_ERROR,
     X              'IAFREE: Block outside heap.',MADDR(JLEVEL))
                ENDIF
              ELSE IF (IERROR .EQ. -5) THEN
C
                IAFREE = JPROUTINE + 2
C
                IF (KERR .GE. 0) THEN
                  CALL INTLOG(JP_ERROR,
     X              'IAFREE: Heap deallocation failed.',IERROR)
                  CALL INTLOG(JP_ERROR,
     X              'IAFREE: Not at start of block.',MADDR(JLEVEL))
                ENDIF
              ELSE
C
                IAFREE = JPROUTINE + 3
C
                IF (KERR .GE. 0) THEN
                  CALL INTLOG(JP_ERROR,
     X              'IAFREE: Heap deallocation failed.',IERROR)
                  CALL INTLOG(JP_ERROR,
     X              'IAFREE: Attempt to free block at: ',MADDR(JLEVEL))
                ENDIF
              ENDIF
C
              IF (KERR .EQ. 0) CALL ABORTX ('IAFREE')
              GO TO 900
            ENDIF
#else
            CALL JFREE (MADDR (JLEVEL) )
#endif
C
            MREQUEST (JLEVEL) = 0
            MADDR (JLEVEL) = 0
C
         ENDIF
C
  210 CONTINUE
C
C     _______________________________________________________
C
C
C*    Section 9. Return to calling routine. Format statements
C     _______________________________________________________
C
  900 CONTINUE
C
      IF (KPR .GE. 1) CALL INTLOG(JP_DEBUG,'IAFREE: Section 9.',JPQUIET)
C
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities
C granted to it by virtue of its status as an intergovernmental organisation
C nor does it submit to any jurisdiction.
C

      SUBROUTINE BUPRT(K,KSUB1,KSUB2,KELEM,CNAMES,CUNITS,
     1                 CVALS,KVALS,VALUES,KSUP,KSEC1,KERR)
C
C**** *BUPRT*
C
C
C     PURPOSE.
C     --------
C           PRINT EXPANDED BUFR MESSAG.
C
C
C**   INTERFACE.
C     ----------
C
C           *CALL* *BUPRT(K,KSUB1,KSUB2,KELEM,CNAMES,CUNITS,
C                         CVALS,KVALS,VALUES,KSUP,KSEC1,KERR)*
C
C        INPUT :
C               *K*       -  SWITCH TO PRINT WITH/WITOUT CONTENT OF CODE TABLES
C                            0  - NO  CODE TABLE CONTENT
C                            1  - YES CODE TABLE CONTENT
C               *KSUB1*   -  STARTING SUBSET
C               *KSUB2*   -  ENDING SUBSET
C               *KELEM*   -  DIMENSION OF CNAMES, CUNITS ARRAY
C               *CNAMES*  -  CHARACTER ARRAY CONTAINING ELEMENT NAMES
C               *CUNITS*  -  CHARACTER ARRAY CONTAINIG UNITS
C               *CVALS*   -  CHARACTER ARRAY CONTAINING BUFR CODE TABLE
C                            ENTRIES
C               *KVALS*   -  DIMENSION OF VALUES ARRAY
C               *VALUES*  -  REAL ARRAY (EXPANDED DATA VALUES)
C               *KSUP*    -  ARRAY CONTAINING SUPLEMENTARY INFORMATION
C                         -  KSUP( 1) -- IDIM1, DIMENSION OF KSEC1
C                         -  KSUP( 2) -- IDIM2, DIMENSION OF KSEC2
C                         -  KSUP( 3) -- IDIM3, DIMENSION OF KSEC3
C                         -  KSUP( 4) -- IDIM4, DIMENSION OF KSEC4
C                         -  KSUP( 5) -- M (NUMBER OF ELEMENTS IN VALUES ARRAY,
C                                           FIRST INDEX)
C                         -  KSUP( 6) -- N (NUMBER OF SUBSETS,SECOND INDEX OF
C                                           VALUES ARRAY)
C                         -  KSUP( 7) -- JVC (NUMBER OF ELEMENTS IN CVAL ARRAY)
C                         -  KSUP( 8) -- TOTAL BUFR MESSAGE LENGTH IN BYTES
C                         -  KSUP( 9) -- IDIM0, DIMENSION OF KSEC0
C               *KSEC1*   -  ARRAY CONTAINING SECTION 1 INFORMATION
C                            KSEC1( 1)-- LENGTH OF SECTION 1 (BYTES)
C                            KSEC1( 2)-- BUFR EDITION NUMBER
C                            KSEC1( 3)-- ORIGINATING CENTRE
C                            KSEC1( 4)-- UPDATE SEQUENCE NUMBER
C                            KSEC1( 5)-- FLAG (PRESENCE OF SECTION 2)
C                            KSEC1( 6)-- BUFR MESSAGE TYPE
C                            KSEC1( 7)-- BUFR MESSAGE SUBTYPE
C                            KSEC1( 8)-- VERSION NUMBER OF LOCAL TABLE USED
C                            KSEC1( 9)-- YEAR
C                            KSEC1(10)-- MONTH
C                            KSEC1(11)-- DAY
C                            KSEC1(12)-- HOUR
C                            KSEC1(13)-- MINUTE
C                            KSEC1(14)-- BUFR MASTER TABLE
C                            KSEC1(15)-- VERSION NUMBER OF MASTER TABLE USED
C                            KSEC1(16) - KSEC1(JSEC1) -- LOCAL ADP CENTRE
C                                        INFORMATION(BYTE BY BYTE)
C
C                            FOR BUFR EDITION 3 ONWARD
C
C                            KSEC1(16)-- ORIGINATING SUB-CENTRE
C                            KSEC1(17)-- NOT USED
C                            KSEC1(18) TO KSEC1(JSEC1) - LOCAL ADP CENTRE
C                                        INFORMATION(PACKED FORM)
C
C                            FOR BUFR EDITION 4 ONWARD
C
C                            KSEC1(16)-- ORIGINATING SUB-CENTRE
C                            KSEC1(17)-- INTERNATIONAL SUB-CATEGORY (SEE COMMON TABLE C-13
C                            KSEC1(18)-- SECOND
C                            KSEC1(19)-- YEAR
C                            KSEC1(20)-- MONTH
C                            KSEC1(21)-- DAY
C                            KSEC1(22)-- HOUR
C                            KSEC1(23)-- MINUTE
C                            KSEC1(24)-- SECOND
C                            KSEC1(25)-- YEAR
C                            KSEC1(26)-- MONTH
C                            KSEC1(27)-- DAY
C                            KSEC1(28)-- HOUR
C                            KSEC1(29)-- MINUTE
C                            KSEC1(30)-- SECOND
C                            KSEC1(31)-- MOST SOUTHERN LATITUDE  (-90 to 90)
C                            KSEC1(32)-- MOST WESTERN LONGITUDE  ( 0-360)
C                            KSEC1(33)-- MOST NORTHEN LATITUDE   (-90 to 90)
C                            KSEC1(34)-- MOST EASTERN LONGITUDE  ( 0-360)
C                            KSEC1(35) TO KSEC1(JSEC1) - LOCAL ADP CENTRE INFORMATION(PACKED FORM)
C
C        OUTPUT:
C               *KERR*    -  RETURNED ERROR CODE
C
C
C
C
C     METHOD.
C     -------
C
C            NONE
C
C     EXTERNALS.
C     ----------
C
C            NONE.
C
C     REFERENCE.
C     ----------
C
C          NONE.
C
C     AUTHOR.
C     -------
C
C          M. DRAGOSAVAC    *ECMWF*       04/02/91.
C
C     MODIFICATIONS.
C     --------------
C
C          NONE.
C
      IMPLICIT LOGICAL(L,O,G), CHARACTER*8(C,H,Y)
C
C
#     include "parameter.F"
#     include "bcomunit.F"
#     include "bcomwork.F"
#     include "bcomroot.F"
C
      DIMENSION KTDLST(JELEM)
      DIMENSION KTDEXP(JELEM)
C
      CHARACTER*256 YCODE
      CHARACTER*64 YFLAG(32)
      CHARACTER*64 CNAMES(KELEM)
      CHARACTER*24 CUNITS(KELEM)
      CHARACTER*80 CVALS(KVALS)
      CHARACTER YCHAR*30,YLONG*320
#ifndef R_4
      REAL*8 RVIND
      REAL*8 EPS
      REAL*8 VALUES(KVALS)
#else
      REAL   RVIND
      REAL   EPS
      REAL   VALUES(KVALS)
#endif
C
      DIMENSION KSUP(JSUP),KSEC1(JSEC1)
C
C
C     ------------------------------------------------------------------
C
C*          1.   PRINT BUFR MESSAGE.
C                -------------------
 100  CONTINUE
C
      KERR=0
      YCODE=' '
C
      ISUB1=KSUB1
      ISUB2=KSUB2
      IF(ISUB1.LE.0.OR.ISUB2.LE.0) THEN
         WRITE(KNTN,'(A)')    ' WARNING - NEGATIVE KSUB1 OR KSUB2.'
         WRITE(KNTN,'(A,I5)') ' WARNING - NUMBER OF SUBSETS IS ',KSUP(6)
         RETURN
      END IF
      IF(ISUB1.GT.KSUP(6)) THEN
         WRITE(KNTN,'(A,I5)') ' WARNING - NUMBER OF SUBSETS IS ',KSUP(6)
         RETURN
      END IF
      IF(ISUB2.GT.KSUP(6)) THEN
         ISUB2=KSUP(6)
         WRITE(KNTN,'(A,I5)') ' WARNING - KSUB2 REPLACED BY ',KSUP(6)
      END IF
C
      IF(.NOT. OCTABLE) K=0
C
      IF(K.EQ.0) THEN
C
            DO 103 JB=ISUB1,ISUB2
            CALL BUSEL2(JB,KELEM,KTDLEN,KTDLST,KTDEXL,KTDEXP,CNAMES,
     1                  CUNITS,KERR)
C
            ILN=0
            WRITE(KNTN,'(1H )')
C
            DO 104 JA=1,KTDEXL
C
            ILN=ILN+1
            JAJB=JA+(JB-1)*KELEM
C
            IF(ABS(VALUES(JAJB)-RVIND)/RVIND.LT.EPS) THEN
               WRITE(KNTN,9918) ILN,CNAMES(JA),CUNITS(JA)
            ELSE
               IF(CUNITS(JA)(1:4).EQ.'CCIT') THEN
                  I=NINT(VALUES(JAJB)/1000)
                  NCHAR=VALUES(JAJB)-I*1000
                  NW=NCHAR/80
                  NWOFF=NCHAR-NW*80
                  IF(NWOFF.NE.0) NW=NW+1
C
                  YLONG=' '
                  YLONG(1:80)=CVALS(I)
C
                  II=I
                  DO 125 JC=1,NW-1
                  II=II+1
                  KF=JC*80+1
                  KL=(JC+1)*80
                  YLONG(KF:KL)=CVALS(II)
 125              CONTINUE
C
                  NLINE=NCHAR/30
                  IDIF =NCHAR-NLINE*30
                  IF(IDIF.NE.0) NLINE=NLINE+1
                  YCHAR=' '
                  YCHAR=YLONG(1:30)
C
                  WRITE(KNTN,9919)ILN,CNAMES(JA),VALUES(JAJB),
     1                         CUNITS(JA),YCHAR
C
                  IF(NLINE.GT.1) THEN
                     DO 130 JJ=1,NLINE-1
C
                     K2=JJ*30+1
                     K1=(JJ+1)*30
                     YCHAR=' '
                     YCHAR=YLONG(K2:K1)
C
                     WRITE(KNTN,9920) YCHAR
 130                 CONTINUE
C
                   END IF
               ELSE
                  WRITE(KNTN,9917) ILN,CNAMES(JA),VALUES(JAJB),
     1            CUNITS(JA)
               END IF
            END IF
C
 104        CONTINUE
 103        CONTINUE
C
      END IF
C
      IF(K.EQ.1) THEN
C
C---------------------------------------------------------------------
          WRITE(KNTN,'(1H1)')
C
C---------------------------------------------------------------------
C
          DO 150 JB=ISUB1,ISUB2
          CALL BUSEL2(JB,KELEM,KTDLEN,KTDLST,KTDEXL,KTDEXP,CNAMES,
     1                  CUNITS,KERR)
C
          ILN=0
          WRITE(KNTN,'(1H )')

C
          DO 160 JA=1,KTDEXL
C
          ILN=ILN+1
C
          JAJB=JA+(JB-1)*KELEM
C
          IF(ABS(VALUES(JAJB)-RVIND)/RVIND.LT.EPS) THEN
             WRITE(KNTN,9918) ILN,CNAMES(JA),CUNITS(JA)
          ELSE
             IF(CUNITS(JA)(1:4).EQ.'CCIT') THEN
                  I=NINT(VALUES(JAJB)/1000)
                  NCHAR=VALUES(JAJB)-I*1000
                  NW=NCHAR/80
                  NWOFF=NCHAR-NW*80
                  IF(NWOFF.NE.0) NW=NW+1
C
                  YLONG=' '
                  YLONG(1:80)=CVALS(I)
C
                  II=I
                  DO 1125 JC=1,NW-1
                  II=II+1
                  KF=JC*80+1
                  KL=(JC+1)*80
                  YLONG(KF:KL)=CVALS(II)
1125              CONTINUE
C
                  NLINE=NCHAR/30
                  IDIF =NCHAR-NLINE*30
                  IF(IDIF.NE.0) NLINE=NLINE+1
                  YCHAR=' '
                  YCHAR=YLONG(1:30)
C
                  WRITE(KNTN,9919)ILN,CNAMES(JA),VALUES(JAJB),
     1                         CUNITS(JA),YCHAR
C
                  IF(NLINE.GT.1) THEN
                     DO 1130 JJ=1,NLINE-1
C
                     K2=JJ*30+1
                     K1=(JJ+1)*30
                     YCHAR=' '
                     YCHAR=YLONG(K2:K1)
C
                     WRITE(KNTN,9920) YCHAR
1130                 CONTINUE
C
                  END IF

             ELSEIF(CUNITS(JA)(1:4).EQ.'CODE') THEN
                 KCODE=NINT(VALUES(JAJB))
                 CALL GETCODE(KTDEXP(JA),KCODE,YCODE,IERR)
                 DO IZ=256,1,-1
                 IF(YCODE(IZ:IZ).NE.' ') THEN
                    IZZ=IZ
                    GO TO 161
                 END IF
                 END DO
 161             CONTINUE
                 IKK=IZZ/64+1
                 WRITE(KNTN,9919) ILN,CNAMES(JA),VALUES(JAJB),
     1           CUNITS(JA), YCODE(1:64)

                 IF(IKK.GT.1) THEN
                 IIII=65
                 DO IK=2,IKK
                 WRITE(KNTN,9920) YCODE(iiii:iiii+64-1)
                 IIII=IIII+64
                 END DO
                 END IF
             ELSEIF(CUNITS(JA)(1:4).EQ.'FLAG') THEN
                 KCODE=NINT(VALUES(JAJB))
                 CALL GETFLAG(KTDEXP(JA),KCODE,KFLAG,YFLAG,IERR)
                 IF (IERR.NE.0) THEN
         WRITE(KNTN,'(A,I5)') ' WARNING - BUPRT: GETFLAG IERR = ', IERR
         WRITE(KNTN,'(A)')    ' WARNING - BUPRT: CANNOT CONTINUE'
                   KERR = IERR
                   RETURN
                 END IF
                 WRITE(KNTN,9919) ILN,CNAMES(JA),VALUES(JAJB),
     1           CUNITS(JA), YFLAG(1)
                 IF(KFLAG.GT.1) THEN
                 DO IZ=2,KFLAG
                 WRITE(KNTN,9920) YFLAG(IZ)
                 END DO
                 END IF
             ELSE
                 WRITE(KNTN,9917) ILN,CNAMES(JA),VALUES(JAJB),
     1           CUNITS(JA)
             END IF
          END IF

  160     CONTINUE
  150     CONTINUE
C
        END IF
C
C
C       RETURN
C
C     ------------------------------------------------------------------
C
 200  CONTINUE
C
C     ------------------------------------------------------------------
 9917 FORMAT(1H ,I6,1X,A32,1X,E23.14E3,1X,A24)
 9918 FORMAT(1H ,I6,1X,A32,1X,'                MISSING',1X,A24)
 9919 FORMAT(1H ,I6,1X,A32,1X,E23.14E3,1X,A24,1X,A)
 9920 FORMAT(1H ,89X,A)
      END

C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      INTEGER FUNCTION HNTFAUH(FLDIN,INLEN)
C
C---->
C**** HNTFAUH
C
C     Purpose
C     -------
C
C     Prepare to interpolate input field...
C
C
C     Interface
C     ---------
C
C     IRET = HNTFAUH( FLDIN,INLEN)
C
C     Input
C     -----
C
C     FLDIN  - Input field (unpacked).
C     INLEN  - Input field length (words).
C
C
C     Output
C     ------
C
C     Field unpacked values are in ZNFELDI, rotated if necessary.
C
C     Returns: 0, if OK. Otherwise, an error occured in interpolation.
C
C
C     Method
C     ------
C
C     If the input is a spectral field and the output is a rotated
C     grid-point field, create a global reduced gaussian field and
C     then create the rotated grid-point field from it.
C
C
C     Externals
C     ---------
C
C     INTLOG  - Log error message.
C     INTLOGR - Log error message.
C     JDEBUG  - Checks environment to switch on/off debug
C     FIXAREA - Fixup input/output field area definitions.
C     HSP2GG  - Find suitable gaussian grid for spectral truncation
C     HIRLAM  - Creates rotated lat/long field from reduced gaussian
C     HIRLSM  - Creates rotated lat/long field from reduced gaussian
C               using land-sea mask
C     HRG2GG  - Creates rotated gaussian field from reduced gaussian
C     LSMFLD  - Determines whether a field is to be interpolated using
C               a land-sea mask
C
C
C     Author
C     ------
C
C     J.D.Chambers     ECMWF     February 2001
C
C----<
C
C     -----------------------------------------------------------------|
C*    Section 0.   Variables
C     -----------------------------------------------------------------|
C
      IMPLICIT NONE
C
C     Function arguments
C
      INTEGER INLEN
      REAL FLDIN(*)
C
#include "parim.h"
#include "nifld.common"
#include "nofld.common"
#include "grfixed.h"
#include "intf.h"
#include "jparams.h"
#include "current.h"
#include "intlog.h"
C
C     Parameters
C
      INTEGER JPROUTINE
      PARAMETER (JPROUTINE = 40150 )
      INTEGER JPLEN, JPNM
      PARAMETER ( JPNM = JPSTRUNC )
      PARAMETER ( JPLEN = (JPNM+1)*(JPNM+2) )
C
C     Local variables
C
      LOGICAL LUSELSM, LSP2RGG, LLATOUT
      INTEGER NUMPTS, NGAUSS, NLON, NLAT, NUVFLAG, NTRUNC, NCOUNT
      INTEGER IWORD, IERR, LOOP, IRET, ISIZE, KPTS(JPGTRUNC*2)
      INTEGER ISHIZE
      INTEGER ITEMP,K,I,J,IM,JM
      REAL PLATS(JPGTRUNC*2),AREA(4),GRID(2),POLE(2),WEST,EAST

C     REAL TEMP(1440,1440): EMOS-113: changed to dynamic memory allocation
      REAL TEMP(1536,1536)

      CHARACTER*1 HOLDTYP
C
      REAL SWORK(1), RGGRID(1), ZNFLDO(1)
#ifndef _CRAYFTN
#ifdef POINTER_64
      INTEGER*8 ISWORK, IRGGRID, IZNFLDO
#endif
#endif
      POINTER ( ISWORK, SWORK)
      POINTER ( IRGGRID, RGGRID)
      POINTER ( IZNFLDO, ZNFLDO )
C
      SAVE IZNFLDO, ISWORK, IRGGRID
C
C     Externals
C
      INTEGER HSP2GG, HIRLAM, HIRLSM, HRG2GG, FIXAREA, PDDEFS
      INTEGER HSP2GG2,HSP2GG3
      LOGICAL LSMFLD
C
      REAL POLELAT, POLELON
      CHARACTER*1 TYPE
      INTEGER NBYTES, ITRUNC
      DATA ISIZE/0/
C
C     -----------------------------------------------------------------|
C*    Section 1.   Initialise
C     -----------------------------------------------------------------|
C
  100 CONTINUE
C
      HNTFAUH = 0
      IRET    = 0
C
      NCOUNT = INLEN
C
C     -----------------------------------------------------------------|
C*    Section 2.   Store input data.
C     -----------------------------------------------------------------|
C
  200 CONTINUE
C
C     Allocate work array ZNFELDI if not already done.
C
      IF( IZNJDCI.NE.1952999238 ) THEN
        CALL JMEMHAN( 19, IZNFLDI, JPEXPAND, 1, IRET)
        IF( IRET.NE.0 ) THEN
          CALL INTLOG(JP_WARN,'HNTFAUH: ZNFELDI allocate fail',JPQUIET)
          HNTFAUH = IRET
          GOTO 900
        ENDIF
        IZNJDCI = 1952999238
      ENDIF
C
C     Move unpacked values in from user array
C
      DO LOOP = 1, INLEN
        ZNFELDI( LOOP ) = FLDIN( LOOP )
      ENDDO
      IF (NISCNM.EQ.64) THEN
        CALL INTLOG(JP_DEBUG,
     X    'HNTFAUH: Scanning flag west-east/south-north',NISCNM)
        ITEMP = NIAREA(1)
        NIAREA(1) = NIAREA(3)
        NIAREA(3) = ITEMP


        IM = NIWE
        JM = NINS
        K=0
        DO J=JM,1,-1
          DO I=1,IM
            K=K+1
              TEMP(I,J) = ZNFELDI(K)
          END DO
        END DO
        K=0
        DO J=1,JM
          DO I=1,IM
            K=K+1
              ZNFELDI(K) = TEMP(I,J)
          END DO
        END DO


      ENDIF
C
      LLATOUT = (NOREPR.EQ.JPREGROT).OR.(NOREPR.EQ.JPREGULAR)
C     -----------------------------------------------------------------|
C*    Section 3.   Handle rotation, if necessary.
C     -----------------------------------------------------------------|
C
  300 CONTINUE
C
C     Is rotation required?
C
      IF( LNOROTA ) THEN
C
        IF( LDEBUG ) THEN
          CALL INTLOG(JP_DEBUG,'HNTFAUH: Rotate field.',JPQUIET)
          CALL INTLOG(JP_DEBUG,'HNTFAUH: South pole lat  ',NOROTA(1))
          CALL INTLOG(JP_DEBUG,'HNTFAUH: South pole long ',NOROTA(2))
        ENDIF
C
C       Fill area limits (handles case when default 0/0/0/0 given)
C
        IRET = FIXAREA()
        IF( IRET.NE.0 ) THEN
          IF( LDEBUG ) CALL INTLOG(JP_ERROR,
     X      'HNTFAUH: area fixup failed',JPQUIET)
          HNTFAUH = JPROUTINE + 3
          GOTO 900
        ENDIF
C
        AREA(1) = REAL(NOAREA(1))/PPMULT
        AREA(2) = REAL(NOAREA(2))/PPMULT
        AREA(3) = REAL(NOAREA(3))/PPMULT
        AREA(4) = REAL(NOAREA(4))/PPMULT
C
        GRID(1) = REAL(NOGRID(1))/PPMULT
        GRID(2) = REAL(NOGRID(2))/PPMULT
C
        POLE(1) = REAL(NOROTA(1))/PPMULT
        POLE(2) = REAL(NOROTA(2))/PPMULT
C
C     -----------------------------------------------------------------|
C*    Section 4.   Spectral to rotated grid-point
C     -----------------------------------------------------------------|
C
  400   CONTINUE
C
        LSP2RGG = .FALSE.
      IF( (NIREPR.EQ.JPSPHERE).OR.(NIREPR.EQ.JPSPHROT) ) THEN
C
C         Convert spectral to suitable global reduced gaussian grid
C
          IF( LDEBUG ) CALL INTLOG(JP_DEBUG,
     X      'HNTFAUH: Spectral to suitable reduced gaussian',JPQUIET)
C
          NTRUNC = NIRESO
c---------------------------------------------------------------------
      IF(LNORESO) THEN
         NTRUNC = NORESO
         IRET = HSP2GG(NTRUNC,NGAUSS,KPTS,PLATS,ISIZE)
          IF( IRET.NE.0 ) THEN
            IF( LDEBUG ) CALL INTLOG(JP_ERROR,
     X        'HNTFAUH: problem getting data for reduced grid',NTRUNC)
            HNTFAUH = JPROUTINE + 4
            GOTO 900
          ENDIF
         IF( LDEBUG ) THEN
          CALL INTLOG(JP_DEBUG,'HNTFAUH: Spectral truncation:', NTRUNC)
          CALL INTLOG(JP_DEBUG,'HNTFAUH: Gaussian number : ',NGAUSS)
         ENDIF
        GOTO 401
       ENDIF

       IF(LARESOL ) THEN
        IF(LLATOUT) THEN
         IRET = HSP2GG2(NTRUNC,GRID(1),GRID(2),NGAUSS,KPTS,PLATS,ISIZE)
        ELSE
         IRET = HSP2GG3(NTRUNC,NGAUSS,KPTS,PLATS,ISIZE)
        ENDIF
         IF( IRET.NE.0 ) THEN
           IF( LDEBUG ) CALL INTLOG(JP_ERROR,
     X       'HNTFAUH: problem getting data for reduced grid',NTRUNC)
           HNTFAUH = JPROUTINE + 4
           GOTO 900
         ENDIF
       ENDIF
c---------------------------------------------------------------------
cs            IRET = HSP2GG(NTRUNC,NGAUSS,KPTS,PLATS,ISIZE)
cs            IF( IRET.NE.0 ) THEN
cs              IF( LDEBUG ) CALL INTLOG(JP_ERROR,
cs     X         'HNTFAUH: problem getting data for reduced gridl',NTRUNC)
cs              HNTFAUH = JPROUTINE + 4
cs              GOTO 900
cs            ENDIF

cs         NCOUNT = ISIZE
c---------------------------------------------------------------------
C       Truncate if a smaller resolution has been requested
C
  401 CONTINUE
      IF( NTRUNC.LT.NIRESO ) THEN
       IF( LDEBUG ) THEN
       CALL INTLOG(JP_DEBUG,'HNTFAUH: Truncation changed from: ',NIRESO)
       CALL INTLOG(JP_DEBUG,'HNTFAUH: to: ',NTRUNC)
       CALL INTLOG(JP_DEBUG,'HNTFAUH: Gaussian number is : ',NGAUSS)
       ENDIF
C
            ISHIZE =  (NTRUNC+1)*(NTRUNC+4)
              CALL JMEMHAN( 3, IZNFLDO, ISHIZE, 1, IERR)
              IF( IERR.NE.0 ) THEN
                CALL INTLOG(JP_FATAL,
     X            'HNTFAUH: Get scratch space failed',JPQUIET)
                HNTFAUH = JPROUTINE + 4
                GOTO 900
              ENDIF
C
C         Generate spherical harmonics with output truncation
C
          CALL SH2SH( ZNFELDI, NIRESO, ZNFLDO, NTRUNC )
C
C         Move new spherical harmonics to 'input' array
C
          DO LOOP = 1, ISHIZE
            ZNFELDI(LOOP) = ZNFLDO(LOOP)
          ENDDO

      ELSE
C
          IF( LDEBUG ) CALL INTLOG(JP_DEBUG,
     X      'HNTFAUH: Spectral to suitable reduced gaussian',JPQUIET)
C
          NTRUNC = NIRESO
          IRET = HSP2GG(NTRUNC,NGAUSS,KPTS,PLATS,ISIZE)
          IF( IRET.NE.0 ) THEN
            IF( LDEBUG ) CALL INTLOG(JP_ERROR,
     X        'HNTFAUH: problem getting data for reduced grid',NTRUNC)
            HNTFAUH = JPROUTINE + 4
            GOTO 900
          ENDIF
         IF( LDEBUG ) THEN
          CALL INTLOG(JP_DEBUG,'HNTFAUH: Spectral truncation:', NTRUNC)
          CALL INTLOG(JP_DEBUG,'HNTFAUH: Gaussian number : ',NGAUSS)
         ENDIF
       ENDIF
c---------------------------------------------------------------------
C
C         Dynamically allocate memory for global reduced gaussian grid
C
          CALL JMEMHAN( 18, IRGGRID, ISIZE, 1, IRET)
          IF( IRET.NE.0 ) THEN
            IF( LDEBUG ) CALL INTLOG(JP_ERROR,
     X        'HNTFAUH: memory alloc for reduced grid fail',JPQUIET)
            HNTFAUH = JPROUTINE + 4
            GOTO 900
          ENDIF
C
C         Set flag to show field is not a wind component
C
          NUVFLAG = 0
C
C         Create the reduced gaussian grid
C
          HOLDTYP = HOGAUST
          WEST = 0.0
          EAST = 360.0 - (360.0/(NGAUSS*4))
          CALL JAGGGP(ZNFELDI,NTRUNC,PLATS(1),PLATS(NGAUSS*2),WEST,
     X                EAST,NGAUSS,'R',KPTS,RGGRID,NUVFLAG,IRET)
          IF( IRET.NE.0 ) THEN
            IF( LDEBUG ) CALL INTLOG(JP_ERROR,
     X        'HNTFAUH: spectral to reduced gaussian failed',JPQUIET)
            HNTFAUH = JPROUTINE + 4
            GOTO 900
          ENDIF
          HOGAUST = HOLDTYP

        NCOUNT = 0
        DO LOOP = 1, (NGAUSS*2)
          NCOUNT= NCOUNT + KPTS(LOOP)
        ENDDO
C
          LSP2RGG = .TRUE.
C
C     -----------------------------------------------------------------|
C*    Section 5.   Complete the spectral to rotated lat/long
C     -----------------------------------------------------------------|
C
  500     CONTINUE
C
          IF( NOREPR.EQ.JPREGROT ) THEN
            IF( LDEBUG ) CALL INTLOG(JP_DEBUG,
     X        'HNTFAUH: Convert gaussian to rotated lat/long',JPQUIET)
C
            GOTO 700
C
          ENDIF
C
C     -----------------------------------------------------------------|
C*    Section 6.   Complete the spectral to rotated gaussian
C     -----------------------------------------------------------------|
C
  600   CONTINUE
C
          IF( NOREPR.EQ.JPFGGROT ) THEN
            IF( LDEBUG ) CALL INTLOG(JP_DEBUG,
     X        'HNTFAUH: Convert gaussian to rotated gaussian',JPQUIET)
C
            GOTO 800
          ENDIF

        ENDIF
C
C     -----------------------------------------------------------------|
C*    Section 7.   Gaussian to rotated lat/long
C     -----------------------------------------------------------------|
C
  700   CONTINUE
C
        IF( (LSP2RGG.AND.(NOREPR.EQ.JPREGROT)) .OR.
     X      ( ((NIREPR.EQ.JPQUASI).OR.(NIREPR.EQ.JPGAUSSIAN)) .AND.
     X      (NOREPR.EQ.JPREGROT) ) ) THEN
          IF( LDEBUG )
     X      CALL INTLOG(JP_DEBUG,'HNTFAUH: Gauss to lat/lon',JPQUIET)
C
C         Dynamically allocate memory for rotated lat/long grid
C
          NLON = 1 + NINT(FLOAT((NOAREA(JPEAST)  - NOAREA(JPWEST))) /
     X           NOGRID(JPWESTEP))
          NLAT = 1 + NINT(FLOAT((NOAREA(JPNORTH) - NOAREA(JPSOUTH))) /
     X           NOGRID(JPNSSTEP))
C
          NUMPTS = NLON * NLAT
          ISIZE  = NUMPTS
          CALL JMEMHAN( 11, ISWORK, ISIZE, 1, IRET)
          IF( IRET.NE.0 ) THEN
            IF( LDEBUG ) CALL INTLOG(JP_ERROR,
     X        'HNTFAUH: memory alloc for lat/long grid fail',JPQUIET)
            HNTFAUH = JPROUTINE + 7
            GOTO 900
          ENDIF
C
          LUSELSM = LSMFLD()
C
C         If original field was spectral, ...
C
          IF( LSP2RGG ) THEN
            IF( LUSELSM ) THEN
              IRET = HIRLSM(LO12PT,RGGRID,NCOUNT,NGAUSS,AREA,POLE,GRID,
     X                      SWORK,ISIZE,NLON,NLAT)
            ELSE
              IRET = HIRLAM(LO12PT,RGGRID,NCOUNT,NGAUSS,AREA,POLE,GRID,
     X                      SWORK,ISIZE,NLON,NLAT)
            ENDIF
C
          ELSE
C
C         If original field was gaussian, ...
C
          IRET = PDDEFS()
            NGAUSS = NIGAUSS
cs            IF( LUSELSM ) THEN
            IF( LSM ) THEN
              IRET = HIRLSM(LO12PT,ZNFELDI,NCOUNT,NGAUSS,AREA,POLE,GRID,
     X                      SWORK,ISIZE,NLON,NLAT)
            ELSE
              IRET = HIRLAM(LO12PT,ZNFELDI,NCOUNT,NGAUSS,AREA,POLE,GRID,
     X                      SWORK,ISIZE,NLON,NLAT)
            ENDIF
C
          ENDIF
C
cs   setting size of output field
          OUTLROT = NLON * NLAT
          IF( IRET.NE.0 ) THEN
            IF( LDEBUG ) CALL INTLOG(JP_ERROR,
     X        'HNTFAUH: HIRLAM rotation failed',JPQUIET)
            HNTFAUH = JPROUTINE + 7
            GOTO 900
          ENDIF
C
        ENDIF
C
C     -----------------------------------------------------------------|
C*    Section 8.   Gaussian to rotated gaussian
C     -----------------------------------------------------------------|
C
  800   CONTINUE
C
        IF( (LSP2RGG.AND.(NOREPR.EQ.JPFGGROT)) .OR.
     X      (((NIREPR.EQ.JPQUASI).OR.(NIREPR.EQ.JPGAUSSIAN)) .AND.
     X      (NOREPR.EQ.JPFGGROT)) ) THEN
          IF( LDEBUG ) CALL INTLOG(JP_DEBUG,
     X      'HNTFAUH: Gaussian to reduced gaussian',JPQUIET)
C
C         Dynamically allocate memory for rotated lat/long grid
C
          ISIZE = NOGAUSS * NOGAUSS * 8 
          CALL JMEMHAN( 11, ISWORK, ISIZE, 1, IRET)
          IF( IRET.NE.0 ) THEN
            IF( LDEBUG ) CALL INTLOG(JP_ERROR,
     X        'HNTFAUH: memory alloc for gaussian grid fail',JPQUIET)
            HNTFAUH = JPROUTINE + 8
            GOTO 900
          ENDIF
C
C         If original field was spectral, ...
C
          IF( LSP2RGG ) THEN
            IRET = HRG2GG(LO12PT,RGGRID,NGAUSS,AREA,POLE,
     X                    NOGAUSS,HOGAUST,SWORK,ISIZE,NUMPTS)
C
          ELSE
C
C         If original field was gaussian, ...
C
            NGAUSS = NIGAUSS
            IRET = HRG2GG(LO12PT,ZNFELDI,NGAUSS,AREA,POLE,
     X                    NOGAUSS,HOGAUST,SWORK,ISIZE,NUMPTS)
          ENDIF
cs   setting size of output field
          OUTLROT = NUMPTS
          IF( IRET.NE.0 ) THEN
            IF( LDEBUG ) CALL INTLOG(JP_ERROR,
     X        'HNTFAUH: HRG2GG rotation failed',JPQUIET)
            HNTFAUH = JPROUTINE + 8
            GOTO 900
          ENDIF
C
        ENDIF
C
C     -----------------------------------------------------------------|
C*    Section 9.   Closedown.
C     -----------------------------------------------------------------|
C
C       Move rotated field back into field original array.
C
        DO LOOP = 1, NUMPTS
          ZNFELDI(LOOP) = SWORK(LOOP)
        ENDDO
C
      ENDIF
C
  900 CONTINUE
C
      RETURN
      END

      PROGRAM BUFRREPACK
C
C**** *BUFRREPACK*
C
C
C     PURPOSE.
C     --------
C         REPACKS BUFR  DATA.
C
C
C**   INTERFACE.
C     ----------
C
C          NONE.
C
C     METHOD.
C     -------
C
C          NONE.
C
C
C     EXTERNALS.
C     ----------
C
C         CALL BUSEL
C         CALL BUFREX
C         CALL BUFREN
C         CALL BUPRS0
C         CALL BUPRS1
C         CALL BUPRS2
C         CALL BUPRS3
C         CALL BUPRT
C         CALL BUUKEY
C
C     REFERENCE.
C     ----------
C
C          NONE.
C
C     AUTHOR.
C     -------
C
C          M. DRAGOSAVAC    *ECMWF*       15/02/95.
C
C
C     MODIFICATIONS.
C     --------------
C
C          NONE.
C
C
      IMPLICIT LOGICAL(L,O,G), CHARACTER*8(C,H,Y)
C
      PARAMETER(JSUP =   9,JSEC0=   3,JSEC1= 40,JSEC2=4096,JSEC3= 4,
     1      JSEC4=   2,JELEM=160000,JSUBS=400,JCVAL=150 ,JBUFL=512000,
#ifdef JBPW_64
     2          JBPW =  64,JTAB =3000,JCTAB=120,JCTST=1800,JCTEXT=1200,
#else
     2          JBPW =  32,JTAB =3000,JCTAB=120,JCTST=1800,JCTEXT=1200,
#endif
     3          JWORK=4096000,JKEY=46,JBYTE=512000)
C
      PARAMETER (KELEM=80000)
      PARAMETER (KVALS=360000)
C 
      DIMENSION KBUFF(JBUFL)
      DIMENSION KBUFR(JBUFL)
      DIMENSION KSUP(JSUP)  ,KSEC0(JSEC0),KSEC1(JSEC1)
      DIMENSION KSEC2(JSEC2),KSEC3(JSEC3),KSEC4(JSEC4)
      DIMENSION KEY  (JKEY),KREQ(2)
C
      REAL*8 VALUES(KVALS),VALUE(KVALS),RQV(KELEM)
      REAL*8 RVIND,EPS
      DIMENSION KTDLST(KELEM),KTDEXP(KELEM),KRQ(KELEM)
      DIMENSION KDATA(200)
      DIMENSION IOUT(12800)
C
      CHARACTER*256 CF(100),COUT,CFIN
      CHARACTER*64 CNAMES(KELEM)
      CHARACTER*24 CUNITS(KELEM)
      CHARACTER*80 CVALS(KVALS)
      CHARACTER*80 YENC
      CHARACTER*256 CARG(10)
C
cs      EXTERNAL GETARG
C                                                                       
C     ------------------------------------------------------------------
C*          1. INITIALIZE CONSTANTS AND VARIABLES.
C              -----------------------------------
 100  CONTINUE
C
C     MISSING VALUE INDICATOR
C 
      ITLEN=6400
      ITL=0
      JZ=0
      NW=0
      NBYTES=JBPW/8
      RVIND=1.7D38
      NVIND=2147483647
      IOBS=0
      KRQL=0
      NR=2555
      KREQ(1)=0
      KREQ(2)=0
      DO 102 I=1,KELEM
      RQV(I)=RVIND
      KRQ(I)=NVIND
 102  CONTINUE
C
C     INPUT FILE NAMES
C
      NARG=IARGC()
      IF(NARG.LT.4) THEN
         PRINT*,'USAGE -- bufr_repack -i infile -o outfile'
         STOP
      END IF
      NFILE=NARG
C
      DO 104 J=1,NARG
      CALL GETARG(J,CARG(J))
 104  CONTINUE

      II=0
      IO=0
      DO 105 J=1,NARG
      IF(CARG(J).EQ.'-i') THEN
         IN=J
      ELSEIF(CARG(J).EQ.'-o') THEN
         IO=J
      END IF
 105  CONTINUE
      IF(IO.EQ.0.OR.IN.EQ.0) THEN
         PRINT*,'USAGE -- bufr_repack -i infile -o outfile'
         STOP
      END IF
C
      COUT=CARG(IO+1)
C
      IF(IO.LT.IN) THEN
         IST=IN+1
         IEND=NARG
      ELSE
         IST=IN+1
         IEND=IO-1
      END IF
C
      JJ=INDEX(COUT,' ')
C
      CALL PBOPEN(IUNIT1,COUT(1:JJ),'W',IRET)
      IF(IRET.EQ.-1) STOP 'OPEN FAILED ON BUFR.DAT'
      IF(IRET.EQ.-2) STOP 'INVALID FILE NAME'
      IF(IRET.EQ.-3) STOP 'INVALID OPEN MODE SPECIFIED'
C
      DO 101 II=IST,IEND
      CFIN=CARG(II) 
      ILN=INDEX(CFIN,' ')
C
C*          1.2 OPEN FILE CONTAINING BUFR DATA.
C               -------------------------------
 120  CONTINUE
C
      IRET=0 
      CALL PBOPEN(IUNIT,CFIN(1:ILN),'R',IRET)
      IF(IRET.EQ.-1) STOP 'OPEN FAILED'
      IF(IRET.EQ.-2) STOP 'INVALID FILE NAME'
      IF(IRET.EQ.-3) STOP 'INVALID OPEN MODE SPECIFIED'
C
C     ----------------------------------------------------------------- 
C*          2. SET REQUEST FOR EXPANSION.
C              --------------------------
 200  CONTINUE
C
      OPRT=.FALSE.
      OENC=.TRUE.
      NCOM=1
      OCOMP=.FALSE.
      NR=0
      OSEC3=.FALSE.
C
C*          2.1 SET REQUEST FOR PARTIAL EXPANSION.
C               ----------------------------------
 210  CONTINUE
C
C     SET VARIABLE TO PACK BIG VALUES AS MISSING VALUE INDICATOR
C
      KPMISS=1
      KPRUS=0
      NOKEY=0
      CALL BUPRQ(KPMISS,KPRUS,NOKEY)
C
C     -----------------------------------------------------------------
C*          3.  READ BUFR MESSAGE.
C               ------------------
 300  CONTINUE
C
      IERR=0
      KBUFL=0
C
      IRET=0
      CALL PBBUFR(IUNIT,KBUFF,JBYTE,KBUFL,IRET) 
      IF(IRET.EQ.-1) THEN
          GO TO 900
      END IF
      IF(IRET.EQ.-2) STOP 'FILE HANDLING PROBLEM' 
      IF(IRET.EQ.-3) STOP 'ARRAY TOO SMALL FOR PRODUCT'
C
      N=N+1
      IKBUFL=KBUFL
      KBUFL=KBUFL/NBYTES+1
      IF(N.LT.NR) GO TO 300
C
C     -----------------------------------------------------------------
C*          4. EXPAND BUFR MESSAGE.
C              --------------------
 400  CONTINUE
C
      CALL BUS012(KBUFL,KBUFF,KSUP,KSEC0,KSEC1,KSEC2,KERR)
      IF(KERR.NE.0) THEN
         PRINT*,'ERROR IN BUS012: ',KERR
         PRINT*,' BUFR MESSAGE NUMBER ',N,' CORRUPTED.'
         KERR=0
         GO TO 300
      END IF
C
      IF(KSUP(6).GT.1) THEN
         KEL=KVALS/KSUP(6)
         if(KEL .gt.kelem) kel=kelem
      ELSE
         KEL=KELEM
      END IF
C
      CALL BUFREX(KBUFL,KBUFF,KSUP,KSEC0 ,KSEC1,KSEC2 ,KSEC3 ,KSEC4,
     1            KEL,CNAMES,CUNITS,KVALS,VALUES,CVALS,IERR)
C
      IF(IERR.NE.0) THEN
         IF(IERR.EQ.45) GO TO 300
         CALL EXIT(2)
      END IF
      IOBS=IOBS+KSEC3(3)
C
      CALL BUSEL(KTDLEN,KTDLST,KTDEXL,KTDEXP,KERR)
      IF(KERR.NE.0) CALL EXIT(2)
C
C*          4.1 PRINT CONTENT OF EXPANDED DATA.
C               -------------------------------
 410  CONTINUE
C
      IF(.NOT.OPRT) GO TO 500
      IF(.NOT.OSEC3) GO TO 450
C
C*          4.2 PRINT SECTION ZERO OF BUFR MESSAGE.
C               -----------------------------------
 420  CONTINUE
C

      CALL BUPRS0(KSEC0)
C
C*          4.3 PRINT SECTION ONE OF BUFR MESSAGE.
C               -----------------------------------
 430  CONTINUE
C
      CALL BUPRS1(KSEC1)
C
C
C*          4.4 PRINT SECTION TWO OF BUFR MESSAGE.
C               -----------------------------------
 440  CONTINUE
C
C              AT ECMWF SECTION 2 CONTAINS RDB KEY.
C              SO UNPACK KEY
C
      CALL BUUKEY(KSEC1,KSEC2,KEY,KSUP,KERR)
C
C              PRINT KEY
C
      CALL BUPRS2(KSUP ,KEY)
C
C*          4.5 PRINT SECTION 3 OF BUFR MESSAGE.
C               -----------------------------------
 450  CONTINUE
C
C               FIRST GET DATA DESCRIPTORS
C
      CALL BUSEL(KTDLEN,KTDLST,KTDEXL,KTDEXP,KERR)
      IF(KERR.NE.0) CALL EXIT(2)
C
C               PRINT  CONTENT
C
      IF(OSEC3) THEN
         CALL BUPRS3(KSEC3,KTDLEN,KTDLST,KTDEXL,KTDEXP,KEL,CNAMES)
      END IF
C
C*         4.6 PRINT SECTION 4 (DATA).
C              -----------------------
 460  CONTINUE
C
C          IN THE CASE OF MANY SUBSETS DEFINE RANGE OF SUBSETS
C
      IF(.NOT.OO) THEN
      WRITE(*,'(A,$)') ' STARTING SUBSET TO BE PRINTED : '
      READ(*,'(BN,I4)')   IST
      WRITE(*,'(A,$)') ' ENDING SUBSET TO BE PRINTED : '
      READ(*,'(BN,I4)')   IEND
      OO=.FALSE.
      END IF
C
C              PRINT DATA
C
      ICODE=0
      CALL BUPRT(ICODE,IST,IEND,KEL,CNAMES,CUNITS,CVALS,
     1           KVALS,VALUES,KSUP,KSEC1,IERR)
C
C              RESOLVE BIT MAPS 
C
      IF(IEND.GT.KSEC3(3)) IEND=KSEC3(3)
C
      DO 461 IK=IST,IEND
C 
      CALL BUBOX(IK,KSUP,KEL,KTDEXP,CNAMES,CUNITS,KVALS,VALUES,
     1           KBOX,KAPP,KLEN,KBOXR,VALS,CBOXN,CBOXU,IERR)
C
      CALL BUPRTBOX(KBOX,KAPP,KLEN,KBOXR,VALS,CBOXN,CBOXU)
C
 461  CONTINUE
C
C     -----------------------------------------------------------------
C*          5. COLLECT DATA FOR REPACKING.
C              ---------------------------
 500  CONTINUE
C      
      IF(.NOT.OENC) GO TO 300
C
C               FIRST GET DATA DESCRIPTORS
C
      CALL BUSEL(KTDLEN,KTDLST,KTDEXL,KTDEXP,KERR)
      IF(KERR.NE.0) CALL EXIT(2)
C
C     -----------------------------------------------------------------
C*          6. PACK BUFR MESSAGE BACK INTO BUFR.
C              ---------------------------------
 600  CONTINUE
C
    
      KKK=0
      KBUFL=JBUFL
C
C     GET REPLICATION FACTORS
C
      KK=0
      DO 601 K=1,KSUP(5)
      IF(KTDEXP(K).EQ.31001.OR.KTDEXP(K).EQ.31002.OR.
     1   KTDEXP(K).EQ.31000) THEN
         KK=KK+1
         KDATA(KK)=NINT(VALUES(K))
      END IF
 601  CONTINUE
C
      KDLEN=2
      IF(KK.NE.0) KDLEN=KK
C
C     --------------------------------
C     |Modification to sections error|
C     --------------------------------
      if(ksec1(7).eq.54.or.ksec1(7).eq.55.or.ksec1(7).eq.155) then
         do i=1,ksec3(3)
         ij=7+(i-1)*kel
         if(nint(values(ij)).eq.205) then
            values(ij)=206.
         elseif(nint(values(ij)).eq.206) then
            values(ij)=205.
         elseif(nint(values(ij)).eq.201) then
            values(ij)=203.
         end if
         end do
C

      else
         CALL PBWRITE(IUNIT1,KBUFF,IKBUFL,IERR)
         IF(IERR.LT.0) THEN
         PRINT*,'ERROR WRITING INTO TARGET FILE.'
         CALL EXIT(2)
         end if
C
          NW=NW+1
C
          GO TO 300
      end if
C
C
C*          6.2 ENCODE DATA INTO BUFR MESSAGE.
C               ------------------------------
 620  CONTINUE
C
      IF(KSEC1(5).NE.0) THEN
         CALL BUUKEY(KSEC1,KSEC2,KEY,KSUP,KERR)
         IF(KERR.NE.0) THEN
            PRINT*,'BUUKEY: ERROR ',KERR
            CALL EXIT(2)
         END IF
      END IF
C
      IF(KSUP(6).EQ.0) THEN
         PRINT*,'ZERO SUBSETS'
         CALL EXIT(2)
      END IF
C
C     GET INFORMATION FOR RDB KEY
C
      ksec2(1)=52
      key(1)=52
      KEY(15)=nint(values(7))
C 
C     CALL BUCREKEY(KEL,KTDEXP,KSUP,KSEC1,KSEC3,KEY,
C    1              VALUES,CVALS,KERR)
C     IF(KERR.NE.0) THEN
C        PRINT*,'ERROR IN BUCREKEY.'
C        CALL EXIT(2)
C     END IF
C
C     PACK NEW RDB KEY
C
C
      CALL BUPKEY(KEY,KSEC1,KSEC2,KERR)
      IF(KERR.NE.0) CALL EXIT(2)
C
      KSEC3(4)=128
      IF(KSEC3(3).GT.1) KSEC3(4)=192
C
      CALL BUFREN( KSEC0,KSEC1,KSEC2,KSEC3,KSEC4,
     1             KTDLEN,KTDLST,KDLEN,KDATA,KEL,        !KSUP(5),
     2             KVALS,VALUES,CVALS,KBUFL,KBUFR,KERR)
C
      IF(KERR.GT.0) THEN
         PRINT*,'ERROR DURING ENCODING.'
         CALL EXIT(2)
      END IF
C
C           6.3 WRITE PACKED BUFR MESSAGE INTO FILE.
C               ------------------------------------
 630  CONTINUE
C
      IKBUFL=KBUFL*4
      CALL PBWRITE(IUNIT1,KBUFR,IKBUFL,IERR)
      IF(IERR.LT.0) THEN
         PRINT*,'ERROR WRITING INTO TARGET FILE.'
         CALL EXIT(2)
      END IF
C
      NW=NW+1
C
      GO TO 300
C     -----------------------------------------------------------------
C
 810  CONTINUE
C
      WRITE(*,'(1H ,A)') 'OPEN ERROR ON INPUT FILE'
      GO TO 900
C      
 800  CONTINUE
C
      IF(IRET.EQ.-1) THEN
         PRINT*,'NUMBER OF RECORDS PROCESSED ',N
         PRINT*,'NUMBER OF RECORDS CONVERTED ',NW
c
      ELSE
         PRINT*,' BUFR : ERROR= ',IERR
      END IF
C
 900  CONTINUE
C
      PRINT*,'NUMBER OF RECORDS PROCESSED ',N
      PRINT*,'NUMBER OF RECORDS CONVERTED ',NW
C
      CALL PBCLOSE(IUNIT,IRET)
 101  CONTINUE
C
      CALL PBCLOSE(IUNIT1,IRET)
C
      END
      SUBROUTINE CUTZERO(CHARPAR,KMIN)
C
C**** CUTZERO - SUBROUTINE TO REMOVE ZERO CHARACTERS.
C
C**   PURPOSE
C     -------
C
C     TO REMOVE ZERO-FILL CHARACTERS FROM THE END OF A CHARACTER
C     VARIABLE.
C
C     INTERFACE
C     ---------
C
C     CALL CUTZERO(CHARPAR,KMIN)
C
C          CHARPAR  - CHARACTER VARIABLE WHICH MAY HAVE ZEROS AT THE
C                     END OF THE VALID CHARACTERS, WHICH NEED TO BE
C                     REMOVED;
C                     RETURNED WITH THE ZERO CHARACTERS CONVERTED TO
C                     BLANK.
C
C          KMIN     - INTEGER VARIABLE INDICATING A MINIMUM NUMBER OF
C                     CHARACTERS AT THE BEGINNING OF THE STRING WHICH
C                     MUST NOT BE CHANGED
C
C     THUS:
C
C     CHARPAR='ABC0000'
C     CALL CUTZERO(CHARPAR,4)
C
C     WOULD RETURN THE VALUE 'ABC0   ' IN CHAR, AND WOULD NOT
C     ALTER THE FIRST 4 CHARACTERS.
C
C     METHOD
C     ------
C
C     THE STRIG IS TESTED FOR THE EXISTANCE OF A ZERO CHARACTER.
C     IF NONE IS FOUND, NO CHANGE TAKES PLACE.
C     IF ONE OR MORE ZERO CHARACTERS ARE PRESENT, THE END OF THE
C     STRING IS LOCATED. WORKING BACKWARDS FROM THE END TO THE
C     KMIN-1 POSITION, CHARACTERS ARE TESTED FOR ZERO. IF A ZERO
C     IS FOUND, IT IS REPLACED BY BLANK. IF A NON-ZERO IS FOUND,
C     THE REPLACEMENT LOOP TERMINATES.
C
C     MODIFICATIONS
C     -------------
C
C     ORIGINAL VERSION - 25.01.95 - REX GIBSON - ECMWF.
C
      CHARACTER*(*) CHARPAR
      CHARACTER*1   YZERO
      INTEGER LEN
C
C     -----------------------------------------------------------
C
C*     1.     FIND AND REPLACE THE ZERO CHARACTERS.
C
  100 CONTINUE
      YZERO=CHAR(0)
      I1=INDEX(CHARPAR,'0')
      IF (I1.GT.0) THEN
         I2=MAX(I1,KMIN+1)
         I3=INDEX(CHARPAR,' ')-1
         IF (I3.LE.0) THEN
            I3=LEN(CHARPAR)
         ENDIF
         DO 112 J=I3,I2,-1
         IF (CHARPAR(J:J).EQ.'0') THEN
             CHARPAR(J:J)=' '
         ELSEIF (CHARPAR(J:J).EQ.YZERO) THEN
             GO TO 112
         ELSE
             GO TO 114
         ENDIF
  112    CONTINUE
C
  114    CONTINUE
      ENDIF
C
C     -----------------------------------------------------------
C
C*     2.     RETURN.
C
  200 CONTINUE
C
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE BUUPWT(KDD,KELEM,KERR)
C
C**** *BUUPWT*
C
C
C     PURPOSE.
C     --------
C          UPDATES WORKING TABLES SETTING ELEMENT NAME,UNIT,SCALE,
C     REFERENCE VALUE AND DATA WIDTH.
C
C
C**   INTERFACE.
C     ----------
C
C          *CALL* *BUUPWT(KDD,KELEM,KERR)*
C
C        INPUT :
C               *KDD*     -  DATA DESCRIPTOR
C               *KELEM*   -  DIMENSION OF CNAMES, CUNITS ARRAY
C        OUTPUT:
C               *KERR*    -  RETURN ERROR CODE
C
C     METHOD.
C     -------
C
C          NONE.
C
C
C     EXTERNALS.
C     ----------
C
C          NONE.
C
C     REFERENCE.
C     ----------
C
C          NONE.
C
C     AUTHOR.
C     -------
C
C          M. DRAGOSAVAC    *ECMWF*       01/02/91.
C
C
C     MODIFICATIONS.
C     --------------
C
C          NONE.
C
C
      IMPLICIT LOGICAL(L,O,G), CHARACTER*8(C,H,Y)
C
C
#     include "parameter.F"
#     include "bcomunit.F"
#     include "bcomwt.F"
#     include "bcomwtc.F"
#     include "bcomtab.F"
#     include "bcomtabc.F"
#     include "bcomatb.F"
#     include "bcomatbc.F"
#     include "bcombef.F"
C
      CHARACTER CATBEN*64,CWTEN*64,CTABBEN*64
      CHARACTER CATBU*24,CWTU*24,CTABBU*24
      CHARACTER YCH6*6
C
C
C     ------------------------------------------------------------------
C*          1.   UPDATE WORKING TABLE.
C                ---------------------
 100  CONTINUE
C
      IF( KERR.NE.0 ) RETURN
C
      ICLASS=KDD/1000
      IYYY  =KDD-ICLASS*1000+1
      ICLASS=ICLASS+1
C
C*          1.1  ASSOCIATED FIELD ?
C                ------------------
 110  CONTINUE
C
      IF(NFD.EQ.0) GO TO 140
C
C*          1.2  UNITS ELEMENT DESCRIPTOR ?
C                --------------------------
 120  CONTINUE
C
      I=NTABP(ICLASS,IYYY)
      IF(I.EQ.0) THEN
         KERR=23
         WRITE(KNTN,*)'BUUPWT : ',KDD
         CALL BUERR(KERR)
         DO 1 IQ=1,JELEM
         NSTACK(IQ)=0.
 1       CONTINUE
         RETURN
      END IF
C
      IF(NTABBTR(I)/1000.EQ.31)  GO TO 140
c     IF(CTABBU(I)(1:4).EQ.'CODE') GO TO 140
c     IF(CTABBU(I)(1:4).EQ.'FLAG') GO TO 140
c     IF(CTABBU(I)(1:3).EQ.'NUM' ) GO TO 140
C
C*          1.3   ADD SPECIAL ENTRY TO WORKING TABLE.
C                 -----------------------------------
 130  CONTINUE
C
      IF(N40.NE.0) THEN
         NWT=NWT+1
         CWTEN(NWT)='ASSOCIATED FIELD'
         CWTU (NWT)=' '
         NWTDW(NWT)=N40
         NWTR (NWT)= 999999
         NWTEN(NWT)= 0
         NWTS (NWT)= 0
         NWTRV(NWT)= 0
      ELSE
         DO I=1,NFD
         NWT=NWT+1
         CWTEN(NWT)='ASSOCIATED FIELD'
         CWTU (NWT)=' '
         NWTDW(NWT)=NAFDWA(I)
         NWTR (NWT)= 999999
         NWTEN(NWT)= 0
         NWTS (NWT)= 0
         NWTRV(NWT)= 0
         END DO
      END IF
C
C*                UPDATE CNAMES AND CUNITS
C
      M=M+1
      IF(M.GT.KELEM) THEN
         KERR=25
         WRITE(KNTN,*)'BUUPWT:'
         CALL BUERR(KERR)
         RETURN
      END IF
C
C     ------------------------------------------------------------------
C*          1.4   SEARCH AUGMENTED TABLE *B ENTRIES .
C                 -----------------------------------
 140  CONTINUE
C
      DO 141 J=1,NJA
C
      IF(NATBTR(J).EQ.KDD) THEN
         II=J
C
C*             MODIFY ENTRY FOR OPERATOR IN FORCE.
C              -----------------------------------
C
C*             ADD ENTRY TO WORKING TABLE.
C              ---------------------------
C
         IX=KDD/1000
         IF(N40.NE.0.AND.IX.NE.31) THEN
            NWT=NWT+1
            NWTR (NWT) = KDD
            NWTS (NWT) = 0
            NWTRV(NWT) = 0
            NWTDW(NWT) = N40
         ELSE
            NWT=NWT+1
            NWTR (NWT) = KDD
            NWTS (NWT) = NATBS (II) + NSCAM + NSCAM07
            NWTRV(NWT) = NINT(NATBRV(II)*10.**N07)
            NWTDW(NWT) = NATBDW(II) + NDWINC + NDWINC07
            NWTEN(NWT) = 0

         END IF
C
C        CHECK IF DATA ARE PRESENT IN DATA SECTION.
C
         IF(N221.NE.0) THEN
            IX=KDD/1000
            IF(IX.GT.9.AND.IX.NE.31) NWTDW(NWT)=0
            N221=N221-1
         END IF
C
c        IF(NWTR(NWT).EQ.31011.OR.NWTR(NWT).EQ.31012) THEN
c           OREP=.true.
c        END IF
c        if(OREP) then
c           if(NREP.GT.1.and.NWTR(NWT-1).ne.31011.and.
c    1         NWTR(NWT-1).ne.31012) then
c              NWTDW(NWT)=0
c              NREP=NREP-1
c              IF(NREP.le.1) then
c                 NREP=0
c                 OREP=.false.
c              END IF
c           END IF
c        END IF

C
C*            UPDATE M, CNAMES, CUNITS.
C             -------------------------
C
         CWTEN(NWT) = CATBEN(II)
         CWTU (NWT) = CATBU (II)
         NWTEN(NWT) = 0
         IF(CATBU(II)(1:3).EQ.'CCI') THEN
            NWTEN(NWT)=658367
         ELSEIF(N40.NE.0.AND.IX.NE.31.AND.
     1      CATBU(II)(1:3).NE.'COD'.AND.
     2      CATBU(II)(1:3).NE.'FLA') THEN
            NWTEN(NWT) = -999
         ENDIF
C
         M = M + 1
         IF(M.GT.KELEM) THEN
            KERR=25
            WRITE(KNTN,*)'BUUPWT:'
            CALL BUERR(KERR)
            RETURN
         END IF
C
         RETURN
      END IF
C
 141  CONTINUE
C
C*          1.5  GET TABLE *B ENTRY .
C                ---------------------
 150  CONTINUE
C
      I=NTABP(ICLASS,IYYY)
      IF(I.EQ.0) THEN
         KERR=23
         WRITE(KNTN,*)'BUUPWT : ',KDD
         CALL BUERR(KERR)
         DO 2 IQ=1,JELEM
         NSTACK(IQ)=0.
 2       CONTINUE
         RETURN
      END IF
C
 155  CONTINUE
C
C     -----------------------------------------------------------------
C*          1.6   MODIFY ENTRY FOR OPERATOR IN FORCE.
C                 -----------------------------------
 160  CONTINUE
C
C*                ADD ENTRY TO WORKING TABLE.
C                 ---------------------------
C
      IF(CTABBU(I)(1:4).EQ.'CODE'.OR.
     1   CTABBU(I)(1:4).EQ.'FLAG') THEN
         NWT=NWT+1
         NWTR (NWT) = KDD
         NWTS (NWT) = NTABBS (I) 
         NWTRV(NWT) = NTABBRV(I)
         NWTDW(NWT) = NTABBDW(I)
      ELSEIF(N40.NE.0.AND.IX.NE.31) THEN
         NWT=NWT+1
         NWTR (NWT) = KDD
         NWTS (NWT) = 0
         NWTRV(NWT) = 0
         NWTDW(NWT) = N40
      ELSE 
         NWT=NWT+1
         NWTR (NWT) = KDD
         NWTS (NWT) = NTABBS (I) + NSCAM + NSCAM07
         NWTRV(NWT) = NINT(NTABBRV(I)*10.**N07)
         NWTDW(NWT) = NTABBDW(I) + NDWINC + NDWINC07

      END IF
C
C     CHECK IF DATA ARE PRESENT IN DATA SECTION.
C
      IF(N221.NE.0) THEN
         IX=KDD/1000
         IF(IX.GT.9.AND.IX.NE.31) NWTDW(NWT)=0
         N221=N221-1
      END IF
C
c     IF(NWTR(NWT).EQ.31011.OR.NWTR(NWT).EQ.31012) THEN
c        OREP=.true.
c     END IF
c     IF(OREP) THEN
c        if(NREP.GT.1.and.NWTR(NWT-1).ne.31011.and.
c    1      NWTR(NWT-1).ne.31012) THEN
c           NWTDW(NWT)=0
c           NREP=NREP-1
c           IF(NREP.le.1) THEN
c              NREP=0
c              OREP=.false.
c           END IF
c        END IF
c      END IF

C
 175  CONTINUE
C
C     ------------------------------------------------------------------
C*          1.8  UPDATE M, CNAMES, CUNITS.
C                -------------------------
 180  CONTINUE
C
      CWTEN(NWT) = CTABBEN(I)
      CWTU (NWT) = CTABBU(I)
      NWTEN(NWT) = 0
      IF(CTABBU(I)(1:3).EQ.'CCI') THEN
         NWTEN(NWT)=658367
         IF(N08.NE.0) THEN
            NWTDW(NWT) = N08*8
         END IF
      ELSEIF(N40.NE.0.AND.IX.NE.31.AND.
     1       CTABBU(I)(1:3).NE.'COD'.AND.
     2       CTABBU(I)(1:3).NE.'FLA') THEN
         NWTEN(NWT) = -999
      ENDIF
C
       M = M + 1
       IF(M.GT.KELEM) THEN
          KERR=25
          WRITE(KNTN,*) 'BUUPWT:'
          CALL BUERR(KERR)
          RETURN
       END IF
C
C     -----------------------------------------------------------------
C
 200  CONTINUE
C
      RETURN
      END

C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE CREXIVAR(KERR)
C
C**** *CREXIVAR*
C
C
C     PURPOSE.
C     --------
C         PRINT ERROR CODE.
C
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *CREXIVAR(KERR)*
C
C     METHOD.
C     -------
C
C          NONE.
C
C
C     EXTERNALS.
C     ----------
C
C          NONE.
C
C     REFERENCE.
C     ----------
C
C          NONE.
C
C     AUTHOR.
C     -------
C
C          MILAN DRAGOSAVAC    *ECMWF*       15/02/2003.
C
C
C     MODIFICATIONS.
C     --------------
C
C          NONE.
C
C
      IMPLICIT LOGICAL(L,O,G), CHARACTER*8(C,H,Y)
C

C
      PARAMETER(JSUP =   9,JSEC0=   3,JSEC1= 40,JSEC2= 64 ,JSEC3=    4,
     1          JSEC4=   2,JELEM=40000,JSUBS=400,JCVAL=150 ,JBUFL=40000,
     2          JBPW =  32,JTAB =3000,JCTAB=120,JCTST=1800,JCTEXT= 200,
     3          JWORK=360000,JKEY=46)
C
      COMMON /CRWORK/ NBPT,NGS,NVIND,NBPTSEC2,RVIND,EPS,NE,IEOLD,
     1                  NC07YYY
C
      COMMON /CRBEF / M,MM,N,JCV
C
C             M       -  Number of elements
C             MM      -  Number of elements
C             N       -  Number of data sub_sets
C             JCV     -  Number of character values
C
      COMMON /CRWT/ NCREXDWINC,NCREXSCAM,NCREXAFDW,NCREXWT ,ODREPF,
     2             NCREXSTACK(JELEM),NCREXWTEN(JELEM),
     3             NCREXWTR (JELEM),NCREXWTS (JELEM),
     4             NCREXWTDW(JELEM)
C
C             NCREXDWINC   -  data width increment
C             NCREXSCAM    -  scale multiplier
C             NCREXAFDW    -  augmented field data width
C             NCREXWT      -  pointer to working table
C             NCREXSTACK   -  list of data descriptors
C             ODREPF   -  replication (logical)
C             NCREXWTR     -  working table reference
C             NCREXWTS     -  working scale
C             NCREXWTDW    -  working data width
c

c
      DIMENSION NCODE(JCTEXT)
      CHARACTER*30 CUNITNAME(JCTEXT)
      CHARACTER*24 CIA5(JCTEXT)
      CHARACTER*24 CIA2(JCTEXT)
      CHARACTER*24 YUNIT
c
      LOGICAL OFIRST
      LOGICAL ODREPF
      REAL*8  RVIND
      REAL*8  EPS

      NGS=KBUFL
      NE=0
      NVIND=2147483647
      RVIND=1.7D38
      EPS=1.0D-8
      M=0
      N=0
      NCREXWT=0
      ODREPF=.false.
      NCREXSCAM=0
      NCREXAFDW=0
      NCREXDWINC=0
      NC07YYY=0
      YUNIT=' '
C
      RETURN
      END

C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      INTEGER FUNCTION DSECT4( PDATA, KTRUNC, KSEC1, KSEC4,
     X                         KGRIB, KLENG, KNSPT, KBITS, KPACK)
C
C---->
C**** DSECT4
C
C     Purpose.
C     --------
C
C     Decode GRIB section 4 for complex packing of spherical harmonics.
C
C
C**   Interface.
C     ----------
C
C     KRET = DSECT4( PDATA, KTRUNC, KSEC1, KSEC4,
C    X               KGRIB, KLENG, KNSPT, KBITS, KPACK)
C
C
C     Input Parameters.
C     -----------------
C
C     PDATA      - Array of floating point values.
C     KTRUNC     - Truncation of the spherical harmonic coefficients.
C     KLENG      - Length of GRIB product array
C     KNSPT      - Bit pointer for next value in GRIB product
C     KBITS      - Number of bits per computer word.
C     KPACK      - Number of bits per packed value.
C
C
C     Output Parameters.
C     -----------------
C
C     KSEC1      - Array of GRIB section 1 values
C     KSEC4      - Array of GRIB section 4 values
C     KGRIB      - Array containing GRIB product.
C     KNSPT      - Bit pointer for next value in GRIB product(updated)
C
C
C     Method.
C     -------
C
C                            <subset>|
C
C     Given numbers:         cccccccc|cccccc
C                              cccccc|cccccc
C                                cccc|cccccc
C                                  cc|cccccc
C                                    |cccccc
C                                       cccc
C                                         cc
C
C
C     Externals.
C     ----------
C
C     GSCALE    - Apply power scaling to values to be packed.
C     UNPKCF    - Unpack unscaled coefficients from GRIB product.
C     UNCMPCK   - Re-scatter the values being unpacked into array.
C     INXBIT    - Extract bits from GRIB product.
C     DECFP2    - Decode from IBM floating point format.
C     JMALLOC   - Routine to acquire memory
C     JFREE     - Routine to release memory
C
C
C     Reference.
C     ----------
C
C     None.
C
C
C     Comments.
C     --------
C
C     On entry, KNSPT points to the first bit of section 4 in the GRIB
C               product.
C     On exit,  KNSPT points to the first bit of section 5 in the GRIB
C               product.
C
C
C     Author.
C     -------
C
C     J.D.Chambers     ECMWF      06:05:94
C
C
C     Modifications.
C     _____________
C
C     J.D.Chambers     ECMWF      13.09.95
C     Put in check for 32-bit packing.
C     (Removed May 1996)
C
C     J.Clochard, Meteo France, for ECMWF - January 1998.
C     FLOAT function replaced by REAL.
C     Fix comments.
C     Use of external JFREE instead of FREE.
C
C----<
C     -----------------------------------------------------------------
C*    Section 0. Definition of variables.
C     -----------------------------------------------------------------
C
      IMPLICIT NONE
C
C     Parameters
      INTEGER JP15BIT, JP87SET, JPBYTES
#ifdef REAL_8
      PARAMETER (JPBYTES = 8)
#else
      PARAMETER (JPBYTES = 4)
#endif
      PARAMETER ( JP15BIT= 2**15 )
C                            `---> 32768    =   8000(hex)
      PARAMETER ( JP87SET= 192 )
C                            `--->          =     C0(hex)
C
C     Subroutine arguments
C
      INTEGER KTRUNC, KSEC1, KSEC4, KGRIB, KLENG, KNSPT, KBITS, KPACK
      REAL PDATA
      DIMENSION PDATA(*), KGRIB(*), KSEC1(*), KSEC4(*)
C
C     Local variables.
C
      INTEGER J110, J310, IPOWER, ISUBSET
      INTEGER IVAL, IRET, IRETA, IRETB, IEXP, IMANT
      INTEGER INSPTA, ILEN, ISCALE
      INTEGER ILEN4, IFLAG, ISIZE
C
#ifndef _CRAYFTN
#ifdef POINTER_64
      INTEGER*8 IPIVAL
#endif
#endif
      POINTER (IPIVAL, IVAL)
      DIMENSION IVAL(1)
      SAVE IPIVAL, ISIZE
C
      REAL ZREF, ZSCALE
C
C     Externals
C
#ifdef POINTER_64
      INTEGER*8 JMALLOC
#else
      INTEGER JMALLOC
#endif
      INTEGER UNPKCF, GSCALE
      EXTERNAL UNPKCF, GSCALE, JMALLOC
C
      DATA ISIZE/0/
C
C     -----------------------------------------------------------------
C*    Section 1 . Decode octets 1 to 11.
C     -----------------------------------------------------------------
C
  100 CONTINUE
C
      DSECT4 = 0
C
C     Allocate memory (first time only)
      IF( ISIZE.LT.((KTRUNC+1)*(KTRUNC+2)*JPBYTES) ) THEN
        IF( ISIZE.NE.0 ) CALL JFREE(IPIVAL)
        ISIZE = (KTRUNC+1)*(KTRUNC+2)*JPBYTES
        IPIVAL = JMALLOC(ISIZE)
#ifdef hpR64
        IPIVAL = IPIVAL/(1024*1024*1024*4)
#endif
        IF( IPIVAL.EQ.0 ) THEN
          WRITE(*,*) 'DSECT4: Memory allocation failed.'
          WRITE(*,*) 'DSECT4: Number of bytes required = ', ISIZE
          DSECT4 = 16123
          GOTO 900
        ENDIF
      ENDIF
C
C     Preserve bit position of start of section 4.
      INSPTA = KNSPT
C
C     Fill in the number of values unpacked
      KSEC4(1) = (KTRUNC+1)*(KTRUNC+2)
C
C     Octets 1 - 3: Length of section.
C     One 24-bit field.
C
      CALL INXBIT(KGRIB,KLENG,KNSPT,ILEN4,1,KBITS,24,'D',IRET)
      IF (IRET.NE.0) THEN
        DSECT4 = 16110
        WRITE(*,*) 'DSECT4: Problem unpacking length of section.'
        GO TO 900
      ENDIF
C
C     Octet 4:
C     One 4-bit field -> flag, spherical harmonics/complex/float point
C     One 4-bit field -> number of unused bits at end of section 4.
C
      CALL INXBIT(KGRIB,KLENG,KNSPT,IFLAG,1,KBITS,8,'D',IRET)
      IF (IRET.NE.0) THEN
        DSECT4 = 16111
        WRITE(*,*) 'DSECT4: Problem unpacking flag byte.'
        GO TO 900
      ENDIF
C
C     Check the flag
      IF ( (IFLAG/16) .NE. 12 ) THEN
        DSECT4 = 16112
        WRITE(*,*) 'DSECT4: Flag wrong = ', IFLAG
        GO TO 900
      ELSE
        KSEC4(3) = 128
        KSEC4(4) = 64
        DO 110 J110 = 5, 33
          KSEC4(J110) = 0
  110   CONTINUE
      ENDIF
C
C*    Octets 5 - 6 : Scale factor.
C     One 16 bit field.
C
C     Adjust bit pointer over first 4 octets and insert scale factor.
      CALL INXBIT(KGRIB,KLENG,KNSPT,ISCALE,1,KBITS, 16,'D',IRET)
      IF (IRET.NE.0) THEN
        DSECT4 = 16113
        WRITE(*,*) 'DSECT4: Problem unpacking scale factor.'
        GO TO 900
      ENDIF
C
C     Make negative if sign bit set
      IF ( ISCALE .GT. JP15BIT ) THEN
        ISCALE = ISCALE - JP15BIT
        ISCALE = -ISCALE
      ENDIF
      ZSCALE = 2.0**ISCALE
C
C*    Octets 7 - 10 : Reference value.
C     One 8 bit and one 24 bit field.
C
C     Extract reference value exponent and mantissa.
      CALL INXBIT(KGRIB,KLENG,KNSPT,IEXP,1,KBITS, 8,'D',IRETA)
      CALL INXBIT(KGRIB,KLENG,KNSPT,IMANT,1,KBITS, 24,'D',IRETB)
      IRET = IRETA + IRETB
      IF (IRET.NE.0) THEN
        DSECT4 = 16114
        WRITE(*,*) 'DSECT4: Problem unpacking reference value.'
        GO TO 900
      ENDIF
C
C     Decode the reference value
      CALL DECFP2 (ZREF,IEXP,IMANT)
C
C*    Octet 11 : Number of bits containing each packed value.
C     One 8 bit field.
C
C     Extract number of bits for each packed value.
      CALL INXBIT(KGRIB,KLENG,KNSPT,KSEC4(2),1,KBITS, 8,'D',IRET)
      IF (IRET.NE.0) THEN
        DSECT4 = 16115
        WRITE(*,*) 'DSECT4: Problem unpacking number of bits/value.'
        GO TO 900
      ENDIF
C
C     -----------------------------------------------------------------
C*    Section 2 . Decode octets 12 to 18.
C     -----------------------------------------------------------------
C
  200 CONTINUE
C
C     Octets 12 - 13: Octet number of the start of packed data
C     One 16-bit field.
C
C     Extract octet number of the start of packed data.
      CALL INXBIT(KGRIB,KLENG,KNSPT,KSEC4(16),1,KBITS,16,'D',IRET)
      IF (IRET.NE.0) THEN
        DSECT4 = 16116
        WRITE(*,*) 'DSECT4: Problem unpacking start of packed data.'
        GO TO 900
      ENDIF
C
C     Octets 14 - 15: Scaling factor; power of Laplacian operator
C                     applied to field before packing.
C     One 16-bit field.
C
C     Extract scaling power.
      CALL INXBIT(KGRIB,KLENG,KNSPT,IPOWER,1,KBITS,16,'D',IRET)
      IF (IRET.NE.0) THEN
        DSECT4 = 16117
        WRITE(*,*) 'DSECT4: Problem unpacking scaling power.'
        GO TO 900
      ENDIF
C
C     Set value negative if sign bit set.
      IF (IPOWER.GT.JP15BIT) THEN
        IPOWER = IPOWER - JP15BIT
        IPOWER = -IPOWER
      ENDIF
      KSEC4(17) = IPOWER
C
C     Octets 16 - 18: Pentagonal resolution parameters J,K,M
C                     specifying truncation of subset of data
C                     represented unpacked.
C     Three 8-bit fields.
C
C     Extract pentagonal resolution parameters.
      CALL INXBIT(KGRIB,KLENG,KNSPT,KSEC4(18),3,KBITS, 8,'D',IRET)
      IF (IRET.NE.0) THEN
        DSECT4 = 16118
        WRITE(*,*)
     X    'DSECT4: Problem unpacking pentagonal resolution params.'
        GO TO 900
      ENDIF
      ISUBSET = KSEC4(18)
      IF ( ISUBSET .GT. KTRUNC ) THEN
        WRITE(*,*) 'DSECT4: Invalid subset truncation given'
        WRITE(*,*) 'DSECT4: ISUBSET, KTRUNC =', ISUBSET, KTRUNC
        DSECT4 = 16122
        GOTO 900
      ENDIF
C
C     -----------------------------------------------------------------
C*    Section 3.  Extract and scale binary values from GRIB product.
C     -----------------------------------------------------------------
C
  300 CONTINUE
C
C     Adjust bit pointer to end of stored subset of coefficients and
C     extract binary values from GRIB product -> updates bit pointer.
      KNSPT = 8*KSEC4(16)
      ILEN = (KTRUNC+1)*(KTRUNC+2) - (ISUBSET+1)*(ISUBSET+2)
      CALL INXBIT (KGRIB,KLENG,KNSPT,IVAL,ILEN, KBITS,KPACK, 'D',IRET)
      IF ( IRET .NE. 0 ) THEN
        WRITE(*,*) 'DSECT4: Problem unpacking bits'
        DSECT4 = 16119
        GOTO 900
      ENDIF
C
      DO 310 J310 = 1 , ILEN
         PDATA(J310)   = ( REAL(IVAL(J310)) *  ZSCALE ) + ZREF
  310 CONTINUE
C
C     Move the coefficients to their correct (scattered) in the array.
      CALL UNCMPCK( PDATA, KTRUNC, ISUBSET)
C
C
C     -----------------------------------------------------------------
C*    Section 4 . Unpack the subset of coefficients (stored IBM style).
C     -----------------------------------------------------------------
C
  400 CONTINUE
C
C     Adjust pointer to avoid first 18 octets.
      KNSPT = INSPTA + 18*8
C
C     Move back into original locations in the array and convert from
C     IBM format.
      IRET = UNPKCF( PDATA,KTRUNC,ISUBSET,KGRIB,KLENG,KNSPT,KBITS)
      IF ( IRET .NE. 0 ) THEN
        WRITE(*,*) 'DSECT4: Problem unpacking subset of coeffs.'
        DSECT4 = 16120
        GOTO 900
      ENDIF
C
C     -----------------------------------------------------------------
C*    Section 5 . Apply power scaling to field.
C     -----------------------------------------------------------------
C
  500 CONTINUE
C
      IRET = GSCALE( PDATA, KTRUNC, ISUBSET, IPOWER, 'O')
      IF ( IRET .NE. 0 ) THEN
        WRITE(*,*) 'DSECT4: Problem applying power scaling'
        DSECT4 = 16121
        GOTO 900
      ENDIF
C
C     Set bit pointer on 7777 group - section 5
      KNSPT = INSPTA + 8*ILEN4
C
C     -----------------------------------------------------------------
C*    Section 9. Return to calling routine.
C     -----------------------------------------------------------------
C
  900 CONTINUE
C
      RETURN
      END

      PROGRAM GETBUFR
C
C**** *GETBUFR*
C
C
C     PURPOSE.
C     --------
C         FILTER BUFR MESSAGES FROM INPUT FILE
C         ACCORDING TO REQUEST.
C
C
C**   INTERFACE.
C     ----------
C
C          NONE.
C
C     METHOD.
C     -------
C
C          THE INPUT FILE IS READ ONE MESSAGE AT A TIME.
C          BUFR MESSAGE IS EXPANDED AND CHECKED AGAINST
C          REQUEST. IF BUFR MESSAGE IS NEEDED IT IS WRITTEN
C          INTO THE OUTPUT FILE. IF THERE IS MORE THAN ONE
C          SUBSET IN THE BUFR MESSAGE, ONLY REQUESTED ARE REPACKED
C          AND WRITTEN INTO THE OUTPUT FILE.
C
C
C     EXTERNALS.
C     ----------
C
C         CALL BUSEL
C         CALL BUFREX
C         CALL BUFREN
C         CALL BUPRS0
C         CALL BUPRS1
C         CALL BUPRS2
C         CALL BUPRS3
C         CALL BUPRT
C         CALL BUUKEY
C
C     REFERENCE.
C     ----------
C
C          NONE.
C
C     AUTHOR.
C     -------
C
C          M. DRAGOSAVAC    *ECMWF*       06/12/93.
C
C
C     MODIFICATIONS.
C     --------------
C
C          NONE.
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
      PARAMETER(JSUP =   9,JSEC0=   3,JSEC1= 40,JSEC2= 4096,JSEC3=  4,
#ifdef JBPW_64
     1      JSEC4=   2,JBUFL=512000,JBPW =  64,JKEY=46, JELEM=160000,
#else
     1      JSEC4=   2,JBUFL=512000,JBPW =  32,JKEY=46, JELEM=160000,
#endif
     2      JWORK=4096000)
C
      PARAMETER (KELEM=160000)
      PARAMETER (KVALS=4096000)
C
C
      COMMON /COMRQB/ CTIME,CAREA,CBLOCK,CIDN,CTYPE,CSBTYPE,CRDBT,
     1                CMDBT,CQC,CIDENTS(99),CMETHOD,CSENSOR,CPRODUCT,
     2                CINSTR
C
      COMMON /COMIRQC/ ITR,IDATES(2),ITIMES(2),IAR,FLATS(4),
     1                 IBL,IBLOCK(9999),ITP,ITYPES(9999),
     2                 ISBT,ISBTYPES(9999),IRDBT,IRDBTS(9999),
     3                 IMDBT,IMDBTS(9999),IQC,IQCS(9999),IDN,
     4                 IMT,IMETHOD(9999),ISE,ISENSOR(9999),
     5                 IPR,IPRODUCT(9999),INS,INSTR(9999)
C
      DIMENSION KBUFF(JBUFL)
      DIMENSION KBUFR(JBUFL)
      DIMENSION KSUP(JSUP)  ,KSEC0(JSEC0),KSEC1(JSEC1)
      DIMENSION KSEC2(JSEC2),KSEC3(JSEC3),KSEC4(JSEC4)
      DIMENSION KEY(JKEY),KEY1(JKEY),KEY2(JKEY)
      DIMENSION KSEC11(JSEC1), KSEC12(JSEC1),KSEC31(JSEC3),KSEC32(JSEC3)
C
      REAL*8  VALUES(KVALS),VALUES1(KVALS),VALUES2(KVALS)
      REAL*8 RVIND
C
      DIMENSION KTDLST(KELEM),KTDEXP(KELEM)
      DIMENSION KDATA(4000)
C
      CHARACTER*64 CNAMES(KELEM)
      CHARACTER*24 CUNITS(KELEM)
      CHARACTER*80 CVALS(KVALS)
      CHARACTER*9  CIDENTS
      CHARACTER*16000 CRECORD
      CHARACTER*256 CARG(8)
C
      CHARACTER*255 CRQFILE,CINFILE,COUTFILE,CREMFILE
      CHARACTER*4   CTIME,CAREA,CBLOCK,CIDN,CTYPE,CSBTYPE
      CHARACTER*4   CRDBT,CMDBT,CQC,CKIND,CMETHOD,CSENSOR,CPRODUCT
      CHARACTER*4   CINSTR
C
cs      EXTERNAL GETARG
C
C
C     ------------------------------------------------------------------
C*          1. GET FILE NAMES.
C              ---------------
 100  CONTINUE
C
      IREAD=0
      ISING=0
      IMULTI=0
      IFILTER=0
      ITOTAL=0
      irem=0
C
      NBYTES=JBPW/8
      RVIND=1.7E38
      JBYTE=JBUFL*NBYTES
      ITR=0
      IAR=0
      IBL=0
      ITP=0
      ISBT=0
      IRDBT=0
      IMDBT=0
      IQC=0
      IDN=0
      IPR=0
C
      CRQFILE=' '
      CINFILE=' '
      COUTFILE=' '
      CREMFILE=' '
      ocremfile=.false.
C
C              GET ARGUMENTS
C
C              1)  REQUEST FILE NAME
C              2)  INPUT FILE NAME
C              3)  OUTPUT FILE NAME
C
      NARG=IARGC()
      IF(NARG.lt.6) THEN
         PRINT*,
     X'USAGE -- emoslib_bufr_filter -r request -i infile -o outfile'
         PRINT*,
     X'                             -t remfile'
         STOP
      END IF
      DO 101 J=1,NARG
      CARG(J)=' '
      CALL GETARG(J,CARG(J))
 101  CONTINUE
C
      DO 102 J=1,NARG,2
      IF(CARG(J).EQ.'-i') THEN
         CINFILE=CARG(J+1)
         icin=index(CINFILE,' ')
         icin=icin-1
      ELSEIF(CARG(J).EQ.'-o') THEN
         COUTFILE=CARG(J+1)
         iout=index(COUTFILE,' ')
         iout=iout-1
      ELSEIF(CARG(J).EQ.'-r') THEN
         CRQFILE=CARG(J+1)
         icrq=index(CRQFILE,' ')
         icrq=icrq-1
      ELSEIF(CARG(J).EQ.'-t') THEN
         CREMFILE=CARG(J+1)
         icrem=index(CREMFILE,' ')
         icrem=icrem-1
         ocremfile=.true.
      ELSE
         PRINT*,
     X'USAGE -- emoslib_bufr_filter -r request -i infile -o outfile'
         PRINT*,
     X'                             -t remfile'
         STOP
      END IF
 102  CONTINUE
C
C
C*          1.1 OPEN IN REQUEST
C               ---------------
 110  CONTINUE
C
      OPEN(47,FILE=CRQFILE(1:icrq),IOSTAT=IOS,ERR=111,
     1        STATUS='OLD')
C
      CALL PBOPEN(IUN,COUTFILE(1:iout),'W',IRET)
      IF(IRET.NE.0) THEN
         PRINT*,'OPEN ERROR ',IOS,' ON FILE ',COUTFILE
         CALL EXIT(2)
      END IF
C
      GO TO 120
C
 111  CONTINUE
C
      PRINT*,'OPEN ERROR ',IOS,' ON FILE ',CRQFILE
      CALL EXIT(2)
C
C
C*          1.2 READ IN REQUEST
C               ---------------
 120  CONTINUE
C
C               TIME RANGE
C
      READ(47,'(A)',IOSTAT=IOS,ERR=121,END=130) CRECORD
      CKIND=CRECORD(1:4)
C
      IF(CKIND.EQ.'TIME') THEN
         READ(CRECORD,'(A4,1X,I4,2(1X,I8,I6))',
     1         IOSTAT=IOS,ERR=121)
     1   CTIME,ITR,(IDATES(I),ITIMES(I),I=1,ITR)
         PRINT*,CTIME,ITR,(IDATES(I),ITIMES(I),I=1,ITR)
         GO TO 120
      END IF
C
C               AREA
C
      IF(CKIND.EQ.'AREA') THEN
        READ(CRECORD,'(A4,1X,I4,4(3X,F12.5))',
     1         IOSTAT=IOS,ERR=121)
     1  CAREA,IAR,(FLATS(I),I=1,IAR)
        PRINT*,CAREA,IAR,(FLATS(I),I=1,IAR)
        GO TO 120
      END IF
C
C               BLOCK
C
      IF(CKIND.EQ.'BLOK') THEN
        READ(CRECORD,'(A4,1X,I4,30(13X,I2))',
     1         IOSTAT=IOS,ERR=121)
     1  CBLOCK,IBL,(IBLOCK(I),I=1,IBL)
        PRINT*,CBLOCK,IBL,(IBLOCK(I),I=1,IBL)
        GO TO 120
      END IF
C
C
C               METHOD
C
      IF(CKIND.EQ.'METH') THEN
        READ(CRECORD,'(A4,1X,I4,30(13X,I2))',
     1         IOSTAT=IOS,ERR=121)
     1  CMETHOD,IMT,(IMETHOD(I),I=1,IMT)
        PRINT*,CMETHOD,IMT,(IMETHOD(I),I=1,IMT)
        GO TO 120
      END IF
C
C               SENSOR

      IF(CKIND.EQ.'SENS') THEN
        READ(CRECORD,'(A4,1X,I4,30(12X,I3))',
     1         IOSTAT=IOS,ERR=121)
     1  CSENSOR,ISE,(ISENSOR(I),I=1,ISE)
c        READ(CRECORD,*) (ISENSOR(I),I=1,ISE)
        PRINT*,CSENSOR,ISE,(ISENSOR(I),I=1,ISE)
        GO TO 120
      END IF

C               INSTRUMENT

      IF(CKIND.EQ.'INST') THEN
        READ(CRECORD,'(A4,1X,I4,30(12X,I3))',
     1         IOSTAT=IOS,ERR=121)
     1  CINSTR,INS,(INSTR(I),I=1,INS)
c        READ(CRECORD,*) (INSTR(I),I=1,INS)
        PRINT*,CINSTR,INS,(INSTR(I),I=1,INS)
        GO TO 120
      END IF

C
C               PRODUCT TYPE
C
      IF(CKIND.EQ.'PRTP') THEN
        READ(CRECORD,'(A4,1X,I4,30(13X,I2))',
     1         IOSTAT=IOS,ERR=121)
     1  CPRODUCT,IPR,(IPRODUCT(I),I=1,IPR)
c        READ(CRECORD,*) (IPRODUCT(I),I=1,IPR)
        PRINT*,CPRODUCT,IPR,(IPRODUCT(I),I=1,IPR)
        GO TO 120
      END IF

C
C               IDENT
C
      IF(CKIND.EQ.'IDEN') THEN
        READ(CRECORD,'(A4,1X,I4,30(1X,A9,5X))',
     1         IOSTAT=IOS,ERR=121)
     1  CIDN,IDN,(CIDENTS(I),I=1,IDN)
        PRINT*,CIDN,IDN,(CIDENTS(I),I=1,IDN)
        GO TO 120
      END IF
C
C               TYPES
C
      IF(CKIND.EQ.'TYPE') THEN
        READ(CRECORD,'(A4,1X,I4,30(12X,I3))',
     1         IOSTAT=IOS,ERR=121)
     1  CTYPE,ITP,(ITYPES(I),I=1,ITP)
        PRINT*,CTYPE,ITP,(ITYPES(I),I=1,ITP)
        GO TO 120
      END IF
C
C               SUBTYPES
C
      IF(CKIND.EQ.'STYP') THEN
        READ(CRECORD,'(A4,1X,I4,30(12X,I3))',
     1         IOSTAT=IOS,ERR=121)
     1  CSBTYPE,ISBT,(ISBTYPES(I),I=1,ISBT)
        write(*,'(A4,1X,I4,30(12X,I3))') CSBTYPE,ISBT,
     1                          (ISBTYPES(I),I=1,ISBT)
        GO TO 120
      END IF
C
C               RDB TIME
C
      IF(CKIND.EQ.'RDBT') THEN
        READ(CRECORD,'(A4,1X,I4,30(7X,I8))',
     1         IOSTAT=IOS,ERR=121)
     1  CRDBT,IRDBT,(IRDBTS(I),I=1,IRDBT)
        PRINT*,CRDBT,IRDBT,(IRDBTS(I),I=1,IRDBT)
        GO TO 120
      END IF
C
C               MDB TIME
C
      IF(CKIND.EQ.'MDBT') THEN
        READ(CRECORD,'(A4,1X,I4,30(7X,I8))',
     1         IOSTAT=IOS,ERR=121)
     1  CMDBT,IMDBT,(IMDBTS(I),I=1,IMDBT)
        PRINT*,CMDBT,IMDBT,(IMDBTS(I),I=1,IMDBT)
        GO TO 120
      END IF
C
C               LOWEST QUALITY CONTROL
C
      IF(CKIND.EQ.'LQCT') THEN
        READ(CRECORD,'(A4,1X,I4,2(12X,I3))',
     1         IOSTAT=IOS,ERR=121)
     1  CQC,IQC,(IQCS(I),I=1,IQC)
        PRINT*,CQC,IQC,(IQCS(I),I=1,IQC)
        GO TO 120
      END IF
C
C      GO TO 130
C
 121  CONTINUE
C
      PRINT*,'READ ERROR ',IOS,' ON ',CRQFILE(1:I),' FILE.'
      CALL EXIT(2)
C---------------------------------------------------------------------
C*          1.3 OPEN FILE CONTAINING BUFR DATA.
C               -------------------------------
 130  CONTINUE
C
      IRET=0
C
      CALL PBOPEN(IUNIT,CINFILE(1:icin),'R',IRET)
      IF (IRET.EQ.-1 .OR. IRET .EQ. -2 .OR. IRET.EQ.-3) THEN
        IF (IRET.EQ.-1) PRINT*,'OPEN FAILED'
        IF (IRET.EQ.-2) PRINT*,'INVALID FILE NAME'
        IF (IRET.EQ.-3) PRINT*,'INVALID OPEN MODE SPECIFIED'
        CALL EXIT(2)
      END IF
c
      IF (CREMFILE.NE.' ') THEN
        CALL PBOPEN(IUNIT2,CREMFILE(1:icrem),'W',IRET)
        IF (IRET.EQ.-1 .OR. IRET .EQ. -2 .OR. IRET.EQ.-3) THEN
          IF (IRET.EQ.-1) PRINT*,'OPEN FAILED'
          IF (IRET.EQ.-2) PRINT*,'INVALID FILE NAME'
          IF (IRET.EQ.-3) PRINT*,'INVALID OPEN MODE SPECIFIED'
          CALL EXIT(2)
        END IF
      END IF

C
C     -----------------------------------------------------------------
C*          2.  READ BUFR MESSAGE.
C               ------------------
 200  CONTINUE
C
      IERR=0
      KBUFL=0
c     DO 201 I=1,JBUFL
c     KBUFF(I)=0
c201  CONTINUE
C
      IRET=0
      CALL PBBUFR(IUNIT,KBUFF,JBYTE,KBUFL,IRET)
      IF(IRET.EQ.-1) THEN
         PRINT*,'NUMBER OF MESSAGES READ          ',IREAD
         PRINT*,'NUMBER OF OBSERVATIONS READ      ',ITOTAL
         PRINT*,'NUMBER OF SINGLE SUBSET MESSAGES ',ISING
         PRINT*,'NUMBER OF MULTISUBSET MESSAGES   ',IMULTI
         PRINT*,'NUMBER OF FILTERED OBSERVATIONS  ',IFILTER
         PRINT*,'EOF'
         STOP
      ELSEIF (IRET.EQ.-2) THEN
        PRINT*,'FILE HANDLING PROBLEM'
        CALL EXIT(2)
      ELSEIF (IRET.EQ.-3) THEN
        PRINT*,'ARRAY TOO SMALL FOR PRODUCT'
        CALL EXIT(2)
      END IF
C
      IREAD=IREAD+1
      JLEN=KBUFL
      KBUFL=KBUFL/NBYTES
C
C
C     -----------------------------------------------------------------
C*          2.1 EXPAND BUFR MESSAGE SECTION 0,1,2
C               ---------------------------------
 210  CONTINUE
C
      IERR=0
      CALL BUS012(KBUFL,KBUFF,KSUP,KSEC0,KSEC1,KSEC2,IERR)
      IF(IERR.NE.0) GO TO 200
C
      ITOTAL=ITOTAL+KSUP(6)
C
C            2.1.1  UNPACK KEY
C
      CALL BUUKEY(KSEC1,KSEC2,KEY,KSUP,KERR)
C
C              PRINT KEY
C
C      CALL BUPRS2(KSUP ,KEY)
C
C*           2.2 CHECK IF MESSAGE CONTAIN SUBSETS
C                --------------------------------
 220  CONTINUE
C
c     IF(KSUP(6).EQ.1.AND.KSEC1(7).NE.87.and.
c    1   KSEC1(7).NE.82.and.KSEC1(7).NE.83.and.
c    2   KSEC1(7).NE.206.AND.KSEC1(7).NE.55.and.
c    3   KSEC1(7).NE.54.AND.KSEC1(7).NE.250) THEN
C
C        CHECK IF MESSAGE IS REQUESTED
C
c        OREQ=.FALSE.
c        CALL KEYCHK(KSEC1,KEY,OREQ)
C
C        WRITE MESSAGE ON OUTPUT
C
c        IF(OREQ)  THEN
c          CALL PBWRITE(IUN,KBUFF,JLEN,IRET)
c          IF(IRET.EQ.-1) THEN
c             WRITE(*,'(A,A)') 'WRITE ERROR ON ',COUTFILE(1:K)
c             CALL EXIT(2)
c          END IF
c          IFILTER=IFILTER+1
c          ISING=ISING+1
C
c        ELSE
c          IF(OCREMFILE) THEN
c          CALL PBWRITE(IUNIT2,KBUFF,JLEN,IRET)
c          IF(IRET.EQ.-1) THEN
c             WRITE(*,'(A,A)') 'WRITE ERROR ON ',CREMFILE(1:K)
c             CALL EXIT(2)
c          END IF
c          IREM=IREM+1
c          END IF
c        END IF
C
c        GO TO 200
C
c     END IF
C----------------------------------------------------------------
C
C            2.3 MULTI-SUBSET MESSAGE
C
 230  CONTINUE
C
      IF(KSUP(6).GT.1)  THEN
         KEL=KVALS/KSUP(6)
         IF(KEL.GT.JELEM) KEL=JELEM
      ELSE
         KEL=KELEM
      END IF
C
      CALL BUFREX(KBUFL,KBUFF,KSUP,KSEC0 ,KSEC1,KSEC2 ,KSEC3 ,KSEC4,
     1            KEL,CNAMES,CUNITS,KVALS,VALUES,CVALS,IERR)
      IF(IERR.NE.0) THEN
         PRINT*,'ERROR AFTER READING NUMBER OF MESSAGES ',IREAD
         CALL EXIT(2)
      END IF
C
C*          2.4 PRINT EXPANDED BUFR MESSAGE.
C               ----------------------------
 240  CONTINUE
C
C      CALL BUPRS0(KSEC0)
C      CALL BUPRS1(KSEC1)
C      CALL BUUKEY(KSEC1,KSEC2,KEY,KSUP,KERR)
C      CALL BUPRS2(KSUP ,KEY)
      CALL BUSEL(KTDLEN,KTDLST,KTDEXL,KTDEXP,KERR)
      IF(KERR.NE.0) THEN
        PRINT*,'ERROR AFTER READING NUMBER OF MESSAGES ',IREAD
        CALL EXIT(2)
      ENDIF
C      CALL BUPRS3(KSEC3,KTDLEN,KTDLST,KTDEXL,KTDEXP,KEL,CNAMES)
C      IST=1
C      IEND=KSUP(6)
C      CALL BUPRT(ICODE,IST,IEND,KEL,CNAMES,CUNITS,CVALS,
C     1           KVALS,VALUES,KSUP,KSEC1,IERR)
C
C
C            2.5 COLLECT REQUESTED MESSAGES.
C
 250  CONTINUE
C
      IERR=0
C
      OREQ=.FALSE.
      CALL MESSCHCK(OREQ,KEY,KTDEXL,KTDEXP,
     1              KSUP,KSEC0 ,KSEC1,KSEC2 ,KSEC3 ,KSEC4,
     1              KEL,CNAMES,CUNITS,KVALS,VALUES,CVALS,
     3                    ksec11,ksec12,ksec31,ksec32,
     4                    key1,key2,values1,values2)
C
C     IF(.NOT.OREQ.AND.OCREMFILE) THEN
      IF(ksec31(3).eq.0.AND.OCREMFILE) THEN
C
           CALL PBWRITE(IUNIT2,KBUFF,JLEN,IRET)
           IF(IRET.EQ.-1) THEN
              WRITE(*,'(A,A)') 'WRITE ERROR ON ',CREMFILE(1:K)
              CALL EXIT(2)
           END IF
           IREM=IREM+1
         GO TO 200
C
      END IF
C     -----------------------------------------------------------------
C*          3. PACK BUFR MESSAGE BACK INTO BUFR.
C              ---------------------------------
 300  CONTINUE
C
      KBUFL=JBUFL
C
C     GET REPLICATION FACTORS
C
      if(ksec31(3).ne.0) then
         KK=0
         DO 301 K=1,KSUP(5)
         IF(KTDEXP(K).EQ.31001.OR.KTDEXP(K).EQ.31002.OR.
     2      KTDEXP(K).EQ.31000.OR.
     1      KTDEXP(K).EQ.31011.OR.KTDEXP(K).EQ.31012) THEN
            KK=KK+1
            KDATA(KK)=NINT(VALUES1(K))
         END IF
 301     CONTINUE
C
         KDLEN=2
         IF(KK.NE.0) KDLEN=KK
C
C*          3.2 ENCODE DATA INTO BUFR MESSAGE.
C               ------------------------------
 320  CONTINUE
C
C        Create key if multi subset data
C
         CALL BUPKEY(KEY1,KSEC11,KSEC2,IERR)
         IERR=0
         CALL BUFREN( KSEC0,KSEC11,KSEC2,KSEC31,KSEC4,
     1                KTDLEN,KTDLST,KDLEN,KDATA,KEL,
     2                KVALS,VALUES1,CVALS,KBUFL,KBUFR,IERR)
C
         IF(IERR.NE.0) then
            CALL EXIT(2)
         end if
C
         ILNGTH=KBUFL*NBYTES
C
C        IF(OREQ) THEN
            CALL PBWRITE(IUN,KBUFR,ILNGTH,IRET)
            IF(IRET.EQ.-1) THEN
               PRINT*,'WRITE ERROR ON FILE ',COUTFILE(1:K)
               CALL EXIT(2)
            END IF
            IFILTER=IFILTER+KSEC3(3)
c        END IF
C
         IMULTI=IMULTI+1
c
      END IF
C
      IF(KSEC32(3).NE.0.AND. OCREMFILE) THEN

         KK=0
         DO  K=1,KSUP(5)
         IF(KTDEXP(K).EQ.31001.OR.KTDEXP(K).EQ.31002.OR.
     2      KTDEXP(K).EQ.31000.OR.
     1      KTDEXP(K).EQ.31011.OR.KTDEXP(K).EQ.31012) THEN
            KK=KK+1
            KDATA(KK)=NINT(VALUES2(K))
         END IF
         END DO
C
         KDLEN=2
         IF(KK.NE.0) KDLEN=KK
C
C*          3.2 ENCODE DATA INTO BUFR MESSAGE.
C               ------------------------------
C
C        Create key if multi subset data
C
         CALL BUPKEY(KEY2,KSEC12,KSEC2,IERR)
         IERR=0
         CALL BUFREN( KSEC0,KSEC12,KSEC2,KSEC32,KSEC4,
     1                KTDLEN,KTDLST,KDLEN,KDATA,KEL,
     2                KVALS,VALUES2,CVALS,KBUFL,KBUFR,IERR)
C
         IF(IERR.NE.0) then
            CALL EXIT(2)
         end if
C
         ILNGTH=KBUFL*NBYTES
C
c        IF(OREQ) THEN
            CALL PBWRITE(IUNIT2,KBUFR,ILNGTH,IRET)
            IF(IRET.EQ.-1) THEN
               PRINT*,'WRITE ERROR ON FILE ',COUTFILE(1:K)
               CALL EXIT(2)
            END IF
c        END IF
C
      END IF
C
      GO TO 200
C
 321  CONTINUE
C
      WRITE(*,'(A)') 'ERROR WRITING INTO ',COUTFILE
      CALL EXIT(2)
C     -----------------------------------------------------------------
C
 400  CONTINUE
C
      END
      SUBROUTINE KEYCHK(KSEC1,KEY,OREQ)
C
C**** *KEYCHK*
C
C
C     PURPOSE.
C     --------
C         FILTER BUFR MESSAGES FROM INPUT FILE
C         ACCORDING TO REQUEST.
C
C
C**   INTERFACE.
C     ----------
C
C          NONE.
C
C     METHOD.
C     -------
C
C         RDB KEY IN UNPACKED FORM IS USED TO CHECK AGAINST
C         USER REQUEST. IF REQUST IS MEETED LOGICAL VARIABLE
C         IS SET TO TRUE.
C
C
C     EXTERNALS.
C     ----------
C
C         NONE.
C
C     REFERENCE.
C     ----------
C
C          NONE.
C
C     AUTHOR.
C     -------
C
C          M. DRAGOSAVAC    *ECMWF*       06/12/93.
C
C
C     MODIFICATIONS.
C     --------------
C
C          NONE.
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
      COMMON /COMRQB/ CTIME,CAREA,CBLOCK,CIDN,CTYPE,CSBTYPE,CRDBT,
     1                CMDBT,CQC,CIDENTS(99),CMETHOD,CSENSOR,CPRODUCT,
     2                CINSTR
C
      COMMON /COMIRQC/ ITR,IDATES(2),ITIMES(2),IAR,FLATS(4),
     1                 IBL,IBLOCK(9999),ITP,ITYPES(9999),
     2                 ISBT,ISBTYPES(9999),IRDBT,IRDBTS(9999),
     3                 IMDBT,IMDBTS(9999),IQC,IQCS(9999),IDN,
     4                 IMT,IMETHOD(9999),ISE,ISENSOR(9999),
     5                 IPR,IPRODUCT(9999),INS,INSTR(9999)
C
      CHARACTER*4 CTIME,CAREA,CBLOCK,CTYPE,CSBTYPE,CRDBT,CMDBT,CQC
      CHARACTER*4 CIDN,CMETHOD,CSENSOR,CPRODUCT,CINSTR
      CHARACTER*9 CIDENTS,CIDENT
      DIMENSION KSEC1(*),KEY(*)
      CHARACTER*14 CDATE_FIRST,CDATE_LAST,CDATE_CURRENT
C
C     -----------------------------------------------------------------
C*                  1. RDB KEY DEFINITION
C
 100  CONTINUE
C
C
C            KEY( 1)-- LENGTH OF SECTION 2 (BYTES)
C            KEY( 2)-- RDB TYPE
C            KEY( 3)-- RDB SUBTYPE
C            KEY( 4)-- YEAR
C            KEY( 5)-- MONTH
C            KEY( 6)-- DAY
C            KEY( 7)-- HOUR
C            KEY( 8)-- MINUTE
C            KEY( 9)-- SECOND
C            KEY(10)-- LONGITUDE1
C            KEY(11)-- LATITUDE1
C            KEY(12)-- LONGITUDE2
C            KEY(13)-- LATITUDE2
C            KEY(14)-- NUMBER OF SUBSETS
C            KEY(15)-- IDENT (NUMERIC)
C            KEY(16)-- IDENT ( CCITTIA5) ONE CHARACTER
C            KEY(17)-- IDENT ( CCITTIA5) ONE CHARACTER
C            KEY(18)-- IDENT ( CCITTIA5) ONE CHARACTER
C            KEY(19)-- IDENT ( CCITTIA5) ONE CHARACTER
C            KEY(20)-- IDENT ( CCITTIA5) ONE CHARACTER
C            KEY(21)-- IDENT ( CCITTIA5) ONE CHARACTER
C            KEY(22)-- IDENT ( CCITTIA5) ONE CHARACTER
C            KEY(23)-- IDENT ( CCITTIA5) ONE CHARACTER
C            KEY(24)-- IDENT ( CCITTIA5) ONE CHARACTER
C            KEY(25)-- TOTAL BUFR MESSAGE LENGTH
C            KEY(26)-- DAY    (RDB INSERTION)
C            KEY(27)-- HOUR   (RDB INSERTION)
C            KEY(28)-- MINUTE (RDB INSERTION)
C            KEY(29)-- SECOND (RDB INSERTION)
C            KEY(30)-- DAY    (MDB INSERTION)
C            KEY(31)-- HOUR   (MDB INSERTION)
C            KEY(32)-- MINUTE (MDB INSERTION)
C            KEY(33)-- SECOND (MDB INSERTION)
C            KEY(34)-- CORRECTION NUMBER
C            KEY(35)-- PART
C            KEY(36)-- 0
C            KEY(37)-- CORRECTION NUMBER
C            KEY(38)-- PART
C            KEY(39)-- 0
C            KEY(40)-- CORRECTION NUMBER
C            KEY(41)-- PART
C            KEY(42)-- 0
C            KEY(43)-- CORRECTION NUMBER
C            KEY(44)-- PART
C            KEY(45)-- 0
C            KEY(46)-- THE LOWEST Q/C % CONFIDENCE
C
C     -----------------------------------------------------------------
C
C*               1.1 GET TIME,LATITUDE,LONGITUDE,IDENT,TYPE,SUBTYPE
C                    AND RECEPTION TIMES
C
 110  CONTINUE
C
C                    TIME
C
          write(cdate_current(1:4),'(i4.4)') KEY(4)
          write(cdate_current(5:6),'(i2.2)') KEY(5)
          write(cdate_current(7:8),'(i2.2)') KEY(6)
          write(cdate_current(9:10),'(i2.2)') KEY(7)
          write(cdate_current(11:12),'(i2.2)') KEY(8)
          cdate_current(13:14)='00'
c         write(cdate_current(13:14),'(i2.2)') KEY(9)
c
          write(cdate_first(1:8),'(i8.8)') IDATES(1)
          write(cdate_first(9:14),'(i6.6)') ITIMES(1)
c
          write(cdate_last(1:8),'(i8.8)') IDATES(2)
          write(cdate_last(9:14),'(i6.6)') ITIMES(2)
c
C
C                    LAT AND LONG
C
      RKLAT=(KEY(11)-9000000)/100000.
      RKLON=(KEY(10)-18000000)/100000.
      if(KEY(11).eq.0) RKLAT=-90.0
      if(KEY(10).eq.0) RKLON=-180.0
C
C                    IDENT
C
 105  CONTINUE
C
      CIDENT=' '
      IF(KEY(3).EQ.51.OR.KEY(3).EQ.61.OR.
     1   KEY(3).EQ.62.OR.KEY(3).EQ.63.OR.
     1   KEY(3).EQ.71.OR.KEY(3).EQ.72.OR.
     1   KEY(3).EQ.73.OR.KEY(3).EQ.82.OR.
     1   KEY(3).EQ.83.OR.KEY(3).EQ.84.OR.
     1   KEY(3).EQ.85.OR.KEY(3).EQ.121.OR.
     1   KEY(3).EQ.86.OR.KEY(3).EQ.87.OR.
     1   KEY(3).EQ.88.OR.KEY(3).EQ.89.OR.
     1   KEY(3).EQ.122.OR.KEY(3).EQ.123.OR.
     1   KEY(3).EQ.124.OR.KEY(3).EQ.125.OR.
     1   KEY(3).EQ.65.OR.KEY(3).EQ.75) THEN
         WRITE(CIDENT(1:3),'(I3)',IOSTAT=IOS) KEY(15)
         IF(IOS.NE.0) THEN
            PRINT*,'INTERNAL WRITE ERROR.'
            CALL EXIT(2)
         END IF
C     print*,'cident=',CIDENT(1:3)
         IF(CIDENT(1:1).EQ.' ') THEN
            CIDENT(1:1)=CIDENT(2:2)
            CIDENT(2:2)=CIDENT(3:3)
            CIDENT(3:3)=' '
         END IF
         IDL=INDEX(CIDENT,' ')
         IDL=IDL-1
      ELSE
         J=0
         DO 101 I=16,24
         J=J+1
         CIDENT(J:J)=CHAR(KEY(I))
 101     CONTINUE
         IDL=INDEX(CIDENT,' ')
         IDL=IDL-1
C         IF(IDL.EQ.0) THEN
C            J=15
C            DO 102 I=16,24
C            IF(KEY(I).EQ.32) THEN
C               GO TO 102
C            ELSE
C               J=J+1
C               KEY(J)=KEY(I)
C               KEY(I)=32
C            END IF
C 102      CONTINUE
C          GO TO 105
C          END IF
      END IF
C
C                    TYPE AND SUBTYPE
C
      IKTYPE=KEY(2)
      IKSBTYPE=KEY(3)
C
C                    LOWEST QUALITY CONTROL
      IKQC=KEY(46)
C
C                    RECEPTION TIME
C
      IKRDB=KEY(26)*10**6+KEY(27)*10**4+KEY(28)*10**2+KEY(29)
      IKMDB=KEY(30)*10**6+KEY(31)*10**4+KEY(32)*10**2+KEY(33)
C     ------------------------------------------------------------------
C*                   2. CHECK MATCHING
C
 200  CONTINUE
C
C     CHECK TIME
C
      IF(ITR.NE.0) THEN
          IF(ITR.EQ.1) THEN
             if(cdate_current.ne.cdate_first) then
                OREQ=.FALSE.
                RETURN
             END IF
          ELSE
             if(cdate_current.lt.cdate_first.or.
     1          cdate_current.gt.cdate_last) then
                OREQ=.FALSE.
                RETURN
             END IF
          END IF
      END IF
C
C     CHECK AREA
C
      IF(IAR.NE.0) THEN
         IF(RKLAT.GT.FLATS(1).OR.RKLAT.LT.FLATS(3)) THEN
            OREQ=.FALSE.
            RETURN
         ELSE
            IF(FLATS(4).LT.FLATS(2)) THEN
               RLO3=180.00000
               RLO4=-180.00000
               IF(RKLON.LT.FLATS(2).OR.RKLON.GT.RLO3) THEN
                  IF(RKLON.LT.RLO4.OR.RKLON.GT.FLATS(4)) THEN
                     OREQ=.FALSE.
                     RETURN
                  END IF
               END IF
            ELSE
               IF(RKLON.LT.FLATS(2).OR.RKLON.GT.FLATS(4)) THEN
                  OREQ=.FALSE.
                  RETURN
               END IF
            END IF
         END IF
      END IF
C
C     CHECK BLOCK
C
      IF(IBL.NE.0) THEN
         IKBLOCK=(KEY(16)-48)*10+KEY(17)-48
         OBLOCK=.FALSE.
         DO 202 I=1,IBL
         IF(IKBLOCK.EQ.IBLOCK(I)) OBLOCK=.TRUE.
 202     CONTINUE
         IF(.NOT.OBLOCK) THEN
            OREQ=.FALSE.
            RETURN
         END IF
      END IF
C
C     IDENT
C
      IF(IDN.NE.0) THEN
         OCIDENT=.FALSE.
         DO 203 I=1,IDN
         IF(CIDENT(1:IDL).EQ.CIDENTS(I)(1:IDL)) OCIDENT=.TRUE.
 203     CONTINUE
         IF(.NOT.OCIDENT) THEN
            OREQ=.FALSE.
            RETURN
         END IF
      END IF
C
C     TYPE
C
      IF(ITP.NE.0) THEN
         OTYPE=.FALSE.
         DO 204 I=1,ITP
         IF(KSEC1(6).EQ.ITYPES(I)) OTYPE=.TRUE.
 204     CONTINUE
         IF(.NOT.OTYPE) THEN
           OREQ=.FALSE.
           RETURN
         END IF
      END IF
C
C     SUBTYPE
C
      IF(ISBT.NE.0) THEN
         OSBT=.FALSE.
         DO 205 I=1,ISBT
         IF(ISBTYPES(I).EQ.KSEC1(7)) OSBT=.TRUE.
 205     CONTINUE
         IF(.NOT.OSBT) THEN
           OREQ=.FALSE.
           RETURN
         END IF
      END IF
C
C     LOWEST QUALITY
C
      IF(IQC.NE.0) THEN
         IF(IQC.EQ.1) THEN
            IF(IKQC.NE.IQCS(1)) THEN
               OREQ=.FALSE.
               RETURN
            END IF
         ELSE
            IF(IKQC.LT.IQCS(1).OR.IKQC.GT.IQCS(2)) THEN
               OREQ=.FALSE.
               RETURN
            END IF
         END IF
      END IF
C
C     RDB TIME
C
      IF(IRDBT.NE.0) THEN
         IF(IRDBT.EQ.1) THEN
            IF(IKRDB.NE.IRDBTS(1)) THEN
               OREQ=.FALSE.
               RETURN
            END IF
         ELSE
            IF(IKRDB.LT.IRDBTS(1).OR.IKRDB.GT.IRDBTS(2)) THEN
               OREQ=.FALSE.
               RETURN
            END IF
         END IF
      END IF
C
C     MDB TIME
C
      IF(IMDBT.NE.0) THEN
         IF(IMDBT.EQ.1) THEN
            IF(IKMDB.NE.IMDBTS(1)) THEN
               OREQ=.FALSE.
               RETURN
            END IF
         ELSE
            IF(IKMDB.LT.IMDBTS(1).OR.IKMDB.GT.IMDBTS(2)) THEN
               OREQ=.FALSE.
               RETURN
            END IF
         END IF
      END IF

C
C     COMPUTATIONAL METHOD
C
      IF(IMT.NE.0) THEN
         OREQ=.FALSE.
         RETURN
      END IF
C
C     PRODUCT TYPE
C
      IF(IPR.NE.0) THEN
         OREQ=.FALSE.
         RETURN
      END IF
C     -----------------------------------------------------------------
      OREQ=.TRUE.
C
      RETURN
C
 401  CONTINUE
C
      PRINT*,'INTERNAL READ ERROR.'
      CALL EXIT(2)
      END
      SUBROUTINE MESSCHCK(OREQ,KEY,KTDEXL,KTDEXP,
     1                    KSUP,KSEC0 ,KSEC1,KSEC2 ,KSEC3 ,
     1                    KSEC4,KEL,CNAMES,CUNITS,KVALS,VALUES,CVALS,
     3                    ksec11,ksec12,ksec31,ksec32,
     4                    key1,key2,values1,values2)
C
C**** *MESSCHK*
C
C
C     PURPOSE.
C     --------
C         FILTER BUFR MESSAGES FROM INPUT FILE
C         ACCORDING TO REQUEST.
C
C
C**   INTERFACE.
C     ----------
C
C          NONE.
C
C     METHOD.
C     -------
C
C          IN THE CASE OF MULTI-SUBSET BUFR MESSAGES TO FIND REQUESTED
C          OBSERVATION IT IS NEEDED TO USE FULLY EXPANDED MESSAGE.
C          EVERY SUBSET IS CHECKED AGAINST REQUEST. NEEDED MESSAGES ARE
C          COLLECTED AND RETURNED, AND LOGICAL VARIABLE OREQ SET TO
C          TRUE.
C
C
C     EXTERNALS.
C     ----------
C
C         NONE.
C
C     REFERENCE.
C     ----------
C
C          NONE.
C
C     AUTHOR.
C     -------
C
C          M. DRAGOSAVAC    *ECMWF*       06/12/93.
C
C
C     MODIFICATIONS.
C     --------------
C
C          NONE.
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
      COMMON /COMRQB/ CTIME,CAREA,CBLOCK,CIDN,CTYPE,CSBTYPE,CRDBT,
     1                CMDBT,CQC,CIDENTS(99),CMETHOD,CSENSOR,CPRODUCT,
     2                CINSTR
C
      COMMON /COMIRQC/ ITR,IDATES(2),ITIMES(2),IAR,FLATS(4),
     1                 IBL,IBLOCK(9999),ITP,ITYPES(9999),
     2                 ISBT,ISBTYPES(9999),IRDBT,IRDBTS(9999),
     3                 IMDBT,IMDBTS(9999),IQC,IQCS(9999),IDN,
     3                 IMT,IMETHOD(9999),ISE,ISENSOR(9999),
     5                 IPR,IPRODUCT(9999),INS,INSTR(9999)
C
      CHARACTER*4 CTIME,CAREA,CBLOCK,CTYPE,CSBTYPE,CRDBT,CMDBT,CQC
      CHARACTER*4 CIDN,CMETHOD , CSENSOR, CPRODUCT,CINSTR
      CHARACTER*9 CIDENTS,CIDENT
      DIMENSION KSEC0(*),KSEC1(*),KSUP(*),KSEC2(*),KSEC3(*),KSEC4(*)
      REAL*8 VALUES(*),VALUES1(*),VALUES2(*)
      DIMENSION KTDEXP(*),KEY(*)
      CHARACTER*(*) CVALS(*),CNAMES(*),CUNITS(*)
      DIMENSION KSEC11(*),KSEC12(*),KSEC31(*),KSEC32(*)
      DIMENSION KEY1(*),KEY2(*)
      CHARACTER*14 CDATE_FIRST,CDATE_LAST,CDATE_CURRENT
C
C     -----------------------------------------------------------------
C
C                1. FIND TIME,LAT,LONG,IDENT,TYPE,SUBTYPE E.T.C.
C
 100  CONTINUE
C
      NN1=0                   ! NUMBER OF SUBSETS
      NN2=0
      ksec31(3)=0
      ksec32(3)=0
C
      IPAID=0                ! AICRAFT ID
      IPSID=0                ! SATELLITE ID
      IPBUOY=0               ! BUOY/PLATFORM ID
      IPARN=0                ! AIRCRAFT REGISTRATION NUMBER
      IPSHIP=0               ! SHIP CALL SIGN
      IPBLOK=0               ! BLOCK NUMBER
      IPSTAT=0               ! STATION NUMBER
      IPYEAR=0
      IPMONTH=0
      IPDAY=0
      IPHOUR=0
      IPMINUTE=0
      IPSECOND=0
      IPSECMIC=0             ! 004007 seconds with micro second precission
      IPLAT=0
      IPLON=0
      IMETH=0                ! Wind computational method
      ISENS=0                ! Satellite sensor indicator
      IPROD=0
      INSTRUM=0              ! Satellite instrument 002019
C
      OREQ1=.FALSE.
C
      do i=1,36
        IF(KTDEXP(I).EQ.001006) then
           if(IPAID.eq.0) IPAID=I
        end if
        IF(KTDEXP(I).EQ.001007) then
           if(IPSID.eq.0) IPSID=I
        end if
        IF(KTDEXP(I).EQ.001005) then
           if(IPBUOY.eq.0) IPBUOY=I
        end if
        IF(KTDEXP(I).EQ.001008) then
           if(IPARN.eq.0) IPARN=I
        end if
        IF(KTDEXP(I).EQ.001011) then
           if(IPSHIP.eq.0) IPSHIP=I
        end if
        IF(KTDEXP(I).EQ.001001) then
           if(IPBLOK.eq.0)  IPBLOK=I
        end if
        IF(KTDEXP(I).EQ.001002) then
           if(IPSTAT.eq.0) IPSTAT=I
        end if
        IF(KTDEXP(I).EQ.004001) then
           if(IPYEAR.eq.0) IPYEAR=I
        end if
        IF(KTDEXP(I).EQ.004002) then
           if(IPMONTH.eq.0) IPMONTH=I
        end if
        IF(KTDEXP(I).EQ.004003) then
            if(IPDAY.eq.0) IPDAY=I
        end if
        IF(KTDEXP(I).EQ.004004) then
           if(IPHOUR.eq.0) IPHOUR=I
        end if
        IF(KTDEXP(I).EQ.004005) then
           if(IPMINUTE.eq.0) IPMINUTE=I
        end if
        IF(KTDEXP(I).EQ.004006) then
           if(IPSECOND.eq.0) IPSECOND=I
        end if
        IF(KTDEXP(I).EQ.004007) then
           if(IPSECMIC.eq.0) IPSECMIC=I
        end if
        IF(KTDEXP(I).EQ.005001) THEN
           IF(IPLAT.EQ.0) IPLAT=I
        END IF
        IF(KTDEXP(I).EQ.006001) THEN
           IF(IPLON.EQ.0) IPLON=I
        END IF
        IF(KTDEXP(I).EQ.005002) THEN
           IF(IPLAT.EQ.0) IPLAT=I
        END IF
        IF(KTDEXP(I).EQ.006002) THEN
           IF(IPLON.EQ.0) IPLON=I
        END IF
        IF(KTDEXP(I).EQ.002023) then
           if(IMETH.eq.0) IMETH=I
        end if
        IF(KTDEXP(I).EQ.002048) then
           if(ISENS.eq.0)ISENS=I
        end if
        IF(KTDEXP(I).EQ.002019) then
           IF(INSTRUM.EQ.0) INSTRUM=I
        END IF
        IF(KTDEXP(I).EQ.002172) then
           if(IPROD.eq.0) IPROD=I
        END IF
      end do
C
C
C
C                    IDENT
C
      CIDENT=' '
C
C                    TYPE AND SUBTYPE
C
      IKTYPE=KEY(2)
      IKSBTYPE=KEY(3)
C
C
C                    LOWEST QUALITY CONTROL
      IKQC=KEY(46)
C
C                    RECEPTION TIME
C
      IKRDB=KEY(26)*10**6+KEY(27)*10**4+KEY(28)*10**2+KEY(29)
      IKMDB=KEY(30)*10**6+KEY(31)*10**4+KEY(32)*10**2+KEY(33)
C     ------------------------------------------------------------------
C*                   2. CHECK MATCHING
C
 200  CONTINUE
C
C
C     TYPE
C
      IF(ITP.NE.0) THEN
         OTYPE=.FALSE.
         DO 204 IX=1,ITP
         IF(KSEC1(6).EQ.ITYPES(IX)) OTYPE=.TRUE.
 204     CONTINUE
         IF(.NOT.OTYPE) THEN
           OREQ=.FALSE.
           RETURN
         ELSE
           OREQ=.TRUE.
         END IF
      END IF
C
C     SUBTYPE
C
      IF(ISBT.NE.0) THEN
         OSBT=.FALSE.
         DO 205 IX=1,ISBT
         IF(ISBTYPES(IX).EQ.KSEC1(7)) OSBT=.TRUE.
 205     CONTINUE
         IF(.NOT.OSBT) THEN
           OREQ=.FALSE.
           RETURN
         ELSE
           OREQ=.TRUE.
         END IF
      END IF
C
C     LOWEST QUALITY
C
      IF(IQC.NE.0) THEN
         IF(IQC.EQ.1) THEN
            IF(IKQC.NE.IQCS(1)) THEN
               OREQ=.FALSE.
               RETURN
            ELSE
               OREQ=.TRUE.
            END IF
         ELSE
            IF(IKQC.LT.IQCS(1).AND.IKQC.GT.IQCS(2)) THEN
               OREQ=.FALSE.
               RETURN
            ELSE
               OREQ=.TRUE.
            END IF
         END IF
      END IF
C
C     RDB TIME
C
      IF(IRDBT.NE.0) THEN
         IF(IRDBT.EQ.1) THEN
            IF(IKRDB.NE.IRDBTS(1)) THEN
               OREQ=.FALSE.
               RETURN
            ELSE
               OREQ=.TRUE.
            END IF
         ELSE
            IF(IKRDB.LT.IRDBTS(1).OR.IKRDB.GT.IRDBTS(2)) THEN
               OREQ=.FALSE.
               RETURN
            ELSE
               OREQ=.TRUE.
            END IF
         END IF
      END IF
C
C     MDB TIME
C
      IF(IMDBT.NE.0) THEN
         IF(IMDBT.EQ.1) THEN
            IF(IKMDB.NE.IMDBTS(1)) THEN
               OREQ=.FALSE.
               RETURN
            ELSE
               OREQ=.TRUE.
            END IF
         ELSE
            IF(IKMDB.LT.IMDBTS(1).OR.IKMDB.GT.IMDBTS(2)) THEN
               OREQ=.FALSE.
               RETURN
            ELSE
               OREQ=.TRUE.
            END IF
         END IF
      END IF
C
C
      DO 201 I=1,KSEC3(3)
C
C     CHECK TIME
C

      OREQ=.true.
      OREQ1=.false.
c
      IKEL=(I-1)*KEL
      IF(ITR.NE.0) THEN
          IY=IPYEAR+IKEL
          IM=IPMONTH+IKEL
          ID=IPDAY+IKEL
          IH=IPHOUR+IKEL
          IMM=IPMINUTE+IKEL
          IF(IPSECOND.EQ.0) THEN
             IS=0
             IF(IPSECMIC.NE.0) THEN
                IS=IPSECMIC+IKEL
             END IF
          ELSE
          IS=IPSECOND+IKEL
          END IF
          write(cdate_current(1:4),'(i4.4)') NINT(VALUES(IY))
          write(cdate_current(5:6),'(i2.2)') NINT(VALUES(IM))
          write(cdate_current(7:8),'(i2.2)') NINT(VALUES(ID))
          write(cdate_current(9:10),'(i2.2)') NINT(VALUES(IH))
          write(cdate_current(11:12),'(i2.2)') NINT(VALUES(IMM))
          if(IS.eq.0) then
             cdate_current(13:14)='00'
          else
          write(cdate_current(13:14),'(i2.2)') NINT(VALUES(IS))
          end if
c
          write(cdate_first(1:8),'(i8.8)') IDATES(1)
          write(cdate_first(9:14),'(i6.6)') ITIMES(1)
c
          write(cdate_last(1:8),'(i8.8)') IDATES(2)
          write(cdate_last(9:14),'(i6.6)') ITIMES(2)
c
          IF(ITR.EQ.1) THEN
             if(cdate_current.ne.cdate_first) then
                OREQ=.FALSE.
                GO TO 2011
             else
                OREQ1=.TRUE.
             END IF
          ELSE
             if(cdate_current.lt.cdate_first.or.
     1          cdate_current.gt.cdate_last) then
                   OREQ=.FALSE.
                   GO TO 2011
             else
                OREQ1=.TRUE.
             END IF
          END IF
      END IF
C
C     CHECK AREA
C
      IF(IAR.NE.0.and.IPLAT.ne.0.and.IPLON.ne.0) THEN
         ILA=IPLAT+IKEL
         ILO=IPLON+IKEL
         RKLAT=VALUES(ILA)
         RKLON=VALUES(ILO)
C
         IF(RKLAT.GT.FLATS(1).OR.RKLAT.LT.FLATS(3).OR.
     1      RKLON.LT.FLATS(2).OR.RKLON.GT.FLATS(4)) THEN
            OREQ=.FALSE.
            GO TO 2011
         ELSE
             OREQ1=.TRUE.
         END IF
      END IF
C
C     CHECK BLOCK
C
      IF(IBL.NE.0.and.IPBLOK.ne.0) THEN
         IB=IPBLOK+IKEL
         IKBLOCK=NINT(VALUES(IB))
         OBLOCK=.FALSE.
         DO 202 IX=1,IBL
         IF(IKBLOCK.EQ.IBLOCK(IX)) OBLOCK=.TRUE.
 202     CONTINUE
         IF(.NOT.OBLOCK) THEN
            OREQ=.FALSE.
            GO TO 2011
         ELSE
            OREQ1=.TRUE.
         END IF
      END IF
C
C     CHECK COMPUTATIONAL METHOD
C
      IF(IMT.NE.0.AND.IMETH.NE.0) THEN
         IM=IMETH+IKEL
         IKMETHOD=NINT(VALUES(IM))
         OMETHOD=.false.
         do  ix=1,IMT
         IF(IKMETHOD.eq.IMETHOD(ix)) OMETHOD=.true.
         end do
         IF(.NOT.OMETHOD) THEN
            OREQ=.FALSE.
            GO TO 2011
         ELSE
            OREQ1=.TRUE.
         END IF
       END IF
C
C     CHECK SATELLITE SENSOR INDICATOR
C
      IF(ISE.NE.0.AND.ISENS.NE.0) THEN
         IM=ISENS+IKEL
         IKSENSOR=NINT(VALUES(IM))
         OSENSOR=.false.
         do  ix=1,ISE
         IF(IKSENSOR.eq.ISENSOR(ix)) OSENSOR=.true.
         end do
         IF(.NOT.OSENSOR) THEN
            OREQ=.FALSE.
            GO TO 2011
         ELSE
            OREQ1=.TRUE.
         END IF
       END IF
C
C
C     CHECK SATELLITE INSTRUMENT INDICATOR
C
      IF(INS.NE.0.AND.INSTRUM.NE.0) THEN
         IM=INSTRUM+IKEL
         IKINSTRUM=NINT(VALUES(IM))
         OINSTR=.false.
         do  ix=1,INS
         IF(IKINSTRUM.eq.INSTR(ix)) OINSTR=.true.
         end do
         IF(.NOT.OINSTR) THEN
            OREQ=.FALSE.
            GO TO 2011
         ELSE
            OREQ1=.TRUE.
         END IF
       END IF

C
C     CHECK SATELLITE PRODUCT TYPE
C
      IF(IPR.NE.0.AND.IPROD.NE.0) THEN
         IM=IPROD+IKEL
         IKPRODUCT=NINT(VALUES(IM))
         OPRODUCT=.false.
         do  ix=1,IPR
         IF(IKPRODUCT.eq.IPRODUCT(ix)) OPRODUCT=.true.
         end do
         IF(.NOT.OPRODUCT) THEN
            OREQ=.FALSE.
            GO TO 2011
         ELSE
            OREQ1=.TRUE.
         END IF
       END IF


C
C     IDENT
C
      IF(IDN.NE.0) THEN
         IF(IPAID.NE.0) THEN
            II=IPAID+IKEL
            K=NINT(VALUES(II)/1000)
            IDL=NINT(VALUES(II)-K*1000)
            CIDENT(1:IDL)=CVALS(K)(1:IDL)
         END IF
         IF(IPSID.NE.0) THEN
            II=IPSID+IKEL
            WRITE(CIDENT(1:3),'(I3)',iostat=ios)
     1                          NINT(VALUES(II))
            IF(IOS.NE.0) THEN
               PRINT*,'INTERNAL WRITE ERROR.'
               CALL EXIT(2)
            END IF
cs          print*,'cident1=',CIDENT(1:3)
            IF(CIDENT(1:1).EQ.' '.AND.CIDENT(2:2).EQ.' ') THEN
              CIDENT(1:1)=CIDENT(3:3)
              CIDENT(2:2)=' '
              CIDENT(3:3)=' '
            ELSEIF(CIDENT(1:1).EQ.' ') THEN
              CIDENT(1:1)=CIDENT(2:2)
              CIDENT(2:2)=CIDENT(3:3)
              CIDENT(3:3)=' '
            END IF
cs          print*,'cident2=',CIDENT(1:3)
            IDL=3
         END IF
         IF(IPBUOY.NE.0) THEN
            II=IPBUOY+IKEL
            WRITE(CIDENT(1:9),'(I9)',IOSTAT=IOS)
     1                          NINT(VALUES(II))
            IF(IOS.NE.0) THEN
               PRINT*,'INTERNAL WRITE ERROR.'
               CALL EXIT(2)
            END IF
            IDL=9
         END IF
         IF(IPARN.NE.0) THEN
            II=IPARN+IKEL
            K=NINT(VALUES(II)/1000)
            IDL=NINT(VALUES(II)-K*1000)
            CIDENT(1:IDL)=CVALS(K)(1:IDL)
         END IF
         IF(IPSHIP.NE.0) THEN
            II=IPSHIP+IKEL
            K=NINT(VALUES(II)/1000)
            IDL=NINT(VALUES(II)-K*1000)
            CIDENT(1:IDL)=CVALS(K)(1:IDL)
         END IF
         IF(IPBLOK.NE.0.AND.IPSTAT.NE.0) THEN
            IBB=IPBLOK+IKEL
            IBS=IPSTAT+IKEL
            IBLST=NINT(VALUES(IBB)*1000+VALUES(IBS))
            WRITE(CIDENT(1:5),'(I5.5)',IOSTAT=IOS) IBLST
            IF(IOS.NE.0) THEN
               PRINT*,'INTERNAL WRITE ERROR.'
               CALL EXIT(2)
            END IF
            IDL=5
         END IF
C
         OCIDENT=.FALSE.
         IF(IDL.NE.0) THEN
            DO 203 IX=1,IDN
            IF(CIDENT(1:IDL).EQ.CIDENTS(IX)(1:IDL)) OCIDENT=.TRUE.
 203        CONTINUE
         END IF
         IF(.NOT.OCIDENT) THEN
            OREQ=.FALSE.
            GO TO 2011
         ELSE
            OREQ1=.TRUE.
         END IF
      END IF
C
C     -----------------------------------------------------------------
 2011 continue

      if(OREQ) then
         if(itr.eq.0.and.
     1      iar.eq.0.and.
     2      ibl.eq.0.and.
     3      imt.eq.0.and.
     4      ise.eq.0.and.
     4      ipr.eq.0.and.
     5      idn.eq.0) OREQ1=.true.
      end if
c
      IF(OREQ1.AND.OREQ) then
C
         NN1=NN1+1
c        PRINT*,'SUBSET MATCHED ',NN1
         DO  K=1,KSUP(5)
           IKK=K+(NN1-1)*KEL
           IKC=K+(I-1)*KEL
           VALUES1(IKK)=VALUES(IKC)
         END DO
      ELSE
         NN2=NN2+1
c        PRINT*,'SUBSET not MATCHED ',NN2
         DO  K=1,ksup(5)
           IKK=K+(NN2-1)*KEL
           IKC=K+(I-1)*KEL
           VALUES2(IKK)=VALUES(IKC)
         END DO
      END IF
C
 201  CONTINUE
C
         KSEC31(3)=NN1
         KSEC31(4)=128
         IF(NN1.GT.1) KSEC31(4)=192

         KSEC32(3)=NN2
         KSEC32(4)=128
         IF(NN2.GT.1) KSEC32(4)=192
C
C              3. CREATE NEW SECTION 1 AND THE RDB KEY.
C                 -------------------------------------
 300  CONTINUE
C
      do k=1,40
        ksec11(k)=ksec1(k)
        ksec12(k)=ksec1(k)
      end do
      do k=1,46
        key1(k)=key(k)
        key2(k)=key(k)
      end do
c
      if(nn1.ne.0) then
      KSEC11(5)=128
      RYYY=1900.
      IF(NINT(VALUES1(IPYEAR)).GE.2001) RYYY=2000.
      KSEC11( 9)=NINT(VALUES1(IPYEAR)-RYYY)
      KSEC11(10)=NINT(VALUES1(IPMONTH))
      KSEC11(11)=NINT(VALUES1(IPDAY))
      KSEC11(12)=NINT(VALUES1(IPHOUR))
      KSEC11(13)=NINT(VALUES1(IPMINUTE))
c
      CALL BUCRKEY(KEL,KTDEXP,KSUP,KSEC11,KSEC31,KEY1,
     1                     VALUES1,CVALS,KERR)
      end if
c
      if(nn2.ne.0) then
      KSEC12(5)=128
      RYYY=1900.
      IF(NINT(VALUES2(IPYEAR)).GE.2001) RYYY=2000.
      KSEC12( 9)=NINT(VALUES2(IPYEAR)-RYYY)
      KSEC12(10)=NINT(VALUES2(IPMONTH))
      KSEC12(11)=NINT(VALUES2(IPDAY))
      KSEC12(12)=NINT(VALUES2(IPHOUR))
      KSEC12(13)=NINT(VALUES2(IPMINUTE))
c
      CALL BUCRKEY(KEL,KTDEXP,KSUP,KSEC12,KSEC32,KEY2,
     1                     VALUES2,CVALS,KERR)
      end if


      KEY1(46)=70
      KEY2(46)=70
C
c     OREQ=.false.
c     IF(OREQ1) OREQ=.true.
      RETURN

C
 401  CONTINUE
C
      PRINT*,'INTERNAL READ ERROR.'
      CALL EXIT(2)
      END

      PROGRAM SPLITBUFR
C
C**** *SPLITBUFR*
C
C
C     PURPOSE.
C     --------
C           SPLITS FILE CONTAINING BUFR DATA INTO FILES
C           ACCORDING TO BUFR SUBTYPES. THE CREATED FILE 
C           NAMES ARE "ST" FOLLOWED BY BUFR SUBTYPE NUMBER.
C           (st001 FOR SYNOP LAND)
C
C
C**   INTERFACE.
C     ----------
C
C
C     METHOD.
C     -------
C
C          NONE.
C
C
C     EXTERNALS.
C     ----------
C
C         CALL BUFREX
C
C     REFERENCE.
C     ----------
C
C          NONE.
C
C     AUTHOR.
C     -------
C
C          M. DRAGOSAVAC    *ECMWF*       15/03/2009
C
C
C     MODIFICATIONS.
C     --------------
C
C          NONE.
C
C
      IMPLICIT LOGICAL(L,O,G), CHARACTER*8(C,H,Y)
C
      PARAMETER(JSUP =   9,JSEC0=   3,JSEC1= 40,JSEC2=4096 ,JSEC3=  4,
     1      JSEC4=  2,JELEM=160000,JSUBS=400,JCVAL=150,JBUFL=512000,
#ifdef JBPW_64
     2          JBPW =  64,JTAB =3000,JCTAB=120,JCTST=1800,JCTEXT=1200,
#else
     2          JBPW =  32,JTAB =3000,JCTAB=120,JCTST=1800,JCTEXT=1200,
#endif
     3          JWORK=4096000,JKEY=46,JBYTE=1000000)
C
      PARAMETER (JTYPE=255)
C
      PARAMETER (KELEM=160000)
      PARAMETER (KVALS=4096000)
C 
      DIMENSION KBUFF(JBUFL),KTDLST(JELEM),KTDEXP(JELEM)
      DIMENSION KSUP(JSUP)  ,KSEC0(JSEC0),KSEC1(JSEC1)
      DIMENSION KSEC2(JSEC2),KSEC3(JSEC3),KSEC4(JSEC4)
      DIMENSION KEY  (JKEY)
C
      REAL*8 VALUES(KVALS)
      REAL*8 RVIND,EPS
      DIMENSION IUNIT1(JTYPE)
C
      CHARACTER*64 CNAMES(KELEM)
      CHARACTER*24 CUNITS(KELEM)
      CHARACTER*80 CVALS(KVALS)
C 
      CHARACTER*80 YENC
      CHARACTER*256 CINFILE,CARG(5)
      CHARACTER*5 CFNAME
C
C
cs      EXTERNAL GETARG
C                                                                       
C     ------------------------------------------------------------------
C*          1. INITIALIZE CONSTANTS AND VARIABLES.
C              -----------------------------------
 100  CONTINUE
C
C     MISSING VALUE INDICATOR
C 
      RVIND=1.7E38
      NBYTES=JBPW/8
C
C     INPUT FILE NAME
C
C
C              GET ARGUMENTS
C
C              1)  INPUT FILE NAME
C
      NARG=IARGC()
      IF(NARG.LT.2) THEN
         PRINT*,'USAGE -- bufr_split -i infiles '
         STOP
      END IF
      NFILE=NARG
C
      DO 104 J=1,NARG
      CALL GETARG(J,CARG(J))
 104  CONTINUE

      II=0
      IO=0
      DO 105 J=1,NARG
      IF(CARG(J).EQ.'-i') THEN
         IN=J
      END IF
 105  CONTINUE
      IF(IN.EQ.0) THEN
          PRINT*,'USAGE -- bufr_split -i infiles '
          STOP
      END IF
C
      IST=IN+1
      IEND=NARG
C
      CFNAME(1:2)='st'
      DO 102 I=1,JTYPE
      WRITE(CFNAME(3:5),'(I3.3)') I
      CALL PBOPEN(IUNITC,CFNAME,'W',IRET)
      IUNIT1(I)=IUNITC
 102  CONTINUE

C
      NR=0
C
C*          1.2 OPEN FILE CONTAINING BUFR DATA.
C               -------------------------------
 120  CONTINUE
C
      DO 121 IZ=IST,IEND
C
      CINFILE=' '
      CINFILE=CARG(IZ)
      IZZ=INDEX(CINFILE,' ')
      IZZ=IZZ-1
C
      IRET=0 
      CALL PBOPEN(IUNIT,CINFILE(1:IZZ),'R',IRET)
      IF(IRET.EQ.-1) STOP 'OPEN FAILED'
      IF(IRET.EQ.-2) STOP 'INVALID FILE NAME'
      IF(IRET.EQ.-3) STOP 'INVALID OPEN MODE SPECIFIED'
C
C     ----------------------------------------------------------------- 
C*          3.  READ BUFR MESSAGE.
C               ------------------
 300  CONTINUE
C
      IERR=0
      KBUFL=0
C
      IRET=0
      CALL PBBUFR(IUNIT,KBUFF,JBYTE,KBUF,IRET) 
      IF(IRET.EQ.-1) THEN
         CALL PBCLOSE(IUNIT,IERR)
         GO TO 121
      END IF
      IF(IRET.EQ.-2) STOP 'FILE HANDLING PROBLEM' 
      IF(IRET.EQ.-3) STOP 'ARRAY TOO SMALL FOR PRODUCT'
C
      N=N+1
      KBUFL=KBUF/NBYTES+1
      IF(N.LT.NR) GO TO 300
C
C     -----------------------------------------------------------------
C*          4. EXPAND BUFR MESSAGE.
C              --------------------
 400  CONTINUE
C
      CALL BUS012(KBUFL,KBUFF,KSUP,KSEC0,KSEC1,KSEC2,KERR)
      IF(KERR.NE.0) THEN
         PRINT*,'ERROR IN BUS012: ',KERR
         PRINT*,' BUFR MESSAGE NUMBER ',N,' CORRUPTED.'
         KERR=0
         CALL EXIT(2)
      END IF
C
      KSEC17=KSEC1(7)
C
      IF(KSEC1(7).GE.1.AND.KSEC1(7).LE.4) THEN
         KEL=KELEM
         IF(KSUP(6).GT.1) KEL=JWORK/KSUP(6)
C
         CALL BUFREX(KBUFL,KBUFF,KSUP,KSEC0 ,KSEC1,KSEC2 ,
     1              KSEC3 ,KSEC4,
     2              KEL,CNAMES,CUNITS,KVALS,VALUES,CVALS,IERR)
C
         IF(IERR.NE.0) THEN
            IF(IERR.EQ.45) GO TO 300
C            CALL EXIT(2)
         END IF
C
         CALL BUSEL(KTDLEN,KTDLST,KTDEXL,KTDEXP,KERR)
         IF(KERR.NE.0) CALL EXIT(2)
C
         KSEC17=KSEC1(7)
         IF(KTDLST(1).EQ.307007) THEN
            KSEC17=5
            DO  I=1,KTDLEN
            IF(KTDLST(I).EQ.013022) KSEC17=6
            IF(KTDLST(I).EQ.013021) KSEC17=7
            IF(KTDLST(I).EQ.013020) KSEC17=8
            END DO

         ELSE
            DO  I=1,KTDLEN
            IF(KTDLST(I).EQ.013022) KSEC17=16
            IF(KTDLST(I).EQ.013021) KSEC17=17
            IF(KTDLST(I).EQ.013020) KSEC17=18
            END DO
         END IF
      END IF
C
      IUN=-99
      DO I=1,255
        IF(KSEC17.EQ.I) THEN
           IUN=IUNIT1(I) 
           GO TO 500
        END IF
      END DO
C
 500  CONTINUE
      IF(IUN.lt.0) THEN
         PRINT*,'SUBTYPE ',KSEC17,'FOUND.'
         print*,'unit number of iunit1(1)=',iunit1(1)
         GO TO 300
      END IF
C
C           6.3 WRITE PACKED BUFR MESSAGE INTO FILE.
C               ------------------------------------
 630  CONTINUE
C
      IERR=0
      CALL PBWRITE(IUN,KBUFF,KBUF,IERR)
      IF(IRET.EQ.-1) THEN
         PRINT*,'ERROR DURING WRITE ON OUTPUT FILE'
         CALL EXIT(2)
      END IF
C
      GO TO 300
C
 121  CONTINUE
C     -----------------------------------------------------------------
C
 900  CONTINUE
C
      PRINT*,'NUMBER OF MESSAGES PROCESSED ',N
C
      END

C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      INTEGER FUNCTION IAFREE (KPR, KERR)
C
C---->
C**** *IAFREE*
C
C     PURPOSE
C     _______
C
C     Deallocate heap space used by grid-pt to grid-pt interpolation.
C
C     INTERFACE
C     _________
C
C     IERR = IAFREE (KPR, KERR)
C
C     Input parameters
C     ________________
C
C     KPR        - The debug print switch.
C                  0  , No debugging output.
C                  1  , Produce debugging output.
C
C     KERR       - The error control flag.
C                  -ve, No error message. Return error code.
C                  0  , Hard failure with error message.
C                  +ve, Print error message. Return error code.
C
C     Output parameters
C     ________________
C
C     None
C
C     Return value
C     ____________
C
C     The error indicator (INTEGER).
C
C     Error and Warning Return Values
C     _______________________________
C
C     Cray error codes
C
C     -1     HPDEALLC block is already free (Warning only).
C
C     21201  HPDEALLC attempt to free block at address outside the
C            bounds of the heap.
C     21202  HPDEALLC attempt to free block at address which was not
C            the beginning of a block.
C     21203  HPDEALLC returning any other non zero code.
C
C     Errors 21201 and 21202 should not occur and any occurrence
C     of one of these errors should be reported to Meteorological
C     Applications.
C
C     Common block usage
C     __________________
C
C     memreq.h     - This file contains the memory request
C                    definition variables.
C
C     MADDR        - The base addresses of the currently allocated
C                    memory segments used and reset.
C     MREQUEST     - The sizes of the current memory requests used
C                    and reset.
C
C
C     EXTERNALS
C     _________
C
C     INTLOG    - Logs messages.
C
C     Cray
C
C     ABORTX    - Standard routine to kill task.
C     HPDEALLC  - Cray library routine to deallocate heap space.
C
C     Sun and SGI
C
C     JFREE     - "Unix" routine to deallocate heap space.
C
C     METHOD
C     ______
C
C     The required heap space is allocated.
C
C     REFERENCE
C     _________
C
C     None
C
C     COMMENTS
C     ________
C
C     None.
C
C     AUTHOR
C     ______
C
C     K. Fielding      *ECMWF*      May 1994
C
C     MODIFICATIONS
C     _____________
C
C     J.D.Chambers      ECMWF       Aug 1994
C
C----<
C     _______________________________________________________
C
C
C*    Section 0. Definition of variables.
C     _______________________________________________________
C
C*    Prefix conventions for variable names
C
C     Logical      L (but not LP), global or common.
C                  O, dummy argument
C                  G, local variable
C                  LP, parameter.
C     Character    C, global or common.
C                  H, dummy argument
C                  Y (but not YP), local variable
C                  YP, parameter.
C     Integer      M and N, global or common.
C                  K, dummy argument
C                  I, local variable
C                  J (but not JP), loop control
C                  JP, parameter.
C     REAL         A to F and Q to X, global or common.
C                  P (but not PP), dummy argument
C                  Z, local variable
C                  PP, parameter.
C
C     Implicit statement to force declarations
C
      IMPLICIT NONE
C
#include "parim.h"
#include "memreq.h"
#include "nifld.common"
#include "nofld.common"
C
C     Dummy arguments
C
      INTEGER KPR, KERR
C
C     Local variables
C
      INTEGER IABORT, IERROR
C
      INTEGER JLEVEL
C
      INTEGER JPROUTINE
C
      PARAMETER (JPROUTINE = 21200)
C
C     External functions
C
C     _______________________________________________________
C
C
C*    Section 1. Initialisation
C     _______________________________________________________
C
  100 CONTINUE
C
      IF (KPR .GE. 1) CALL INTLOG(JP_DEBUG,'IAFREE: Section 1.',JPQUIET)
C
      IAFREE = 0
C
      IF (KPR .GE. 1) CALL INTLOG(JP_DEBUG,
     X 'IAFREE: Free all heap space.',JPQUIET)
C
C     _______________________________________________________
C
C
C*    Section 2. Free acquired space.
C     _______________________________________________________
C
  200 CONTINUE
C
      IF (KPR .GE. 1) CALL INTLOG(JP_DEBUG,'IAFREE: Section 2.',JPQUIET)
C
      IABORT = 0
      IERROR = 0
C
      DO 210 JLEVEL = JPLEVEL, 1, -1
C
         IF (MREQUEST (JLEVEL) .GT. 0) THEN
C
#ifdef CRAY
            CALL HPDEALLC (MADDR (JLEVEL), IERROR, IABORT)
C
            IF (IERROR .EQ. -4) THEN
              IAFREE = - 1
              IF (KERR .GE. 0) CALL INTLOG(JP_ERROR,
     X          'IAFREE: Already free, the block at ', MADDR (JLEVEL))
C
            ELSE IF (IERROR .NE. 0) THEN
C
              IF (IERROR .EQ. -3) THEN
C
                IAFREE = JPROUTINE + 1
C
                IF (KERR .GE. 0) THEN
                  CALL INTLOG(JP_ERROR,
     X              'IAFREE: Heap deallocation failed.',IERROR)
                  CALL INTLOG(JP_ERROR,
     X              'IAFREE: Block outside heap.',MADDR(JLEVEL))
                ENDIF
              ELSE IF (IERROR .EQ. -5) THEN
C
                IAFREE = JPROUTINE + 2
C
                IF (KERR .GE. 0) THEN
                  CALL INTLOG(JP_ERROR,
     X              'IAFREE: Heap deallocation failed.',IERROR)
                  CALL INTLOG(JP_ERROR,
     X              'IAFREE: Not at start of block.',MADDR(JLEVEL))
                ENDIF
              ELSE
C
                IAFREE = JPROUTINE + 3
C
                IF (KERR .GE. 0) THEN
                  CALL INTLOG(JP_ERROR,
     X              'IAFREE: Heap deallocation failed.',IERROR)
                  CALL INTLOG(JP_ERROR,
     X              'IAFREE: Attempt to free block at: ',MADDR(JLEVEL))
                ENDIF
              ENDIF
C
              IF (KERR .EQ. 0) CALL ABORTX ('IAFREE')
              GO TO 900
            ENDIF
#else
            CALL JFREE (MADDR (JLEVEL) )
#endif
C
            MREQUEST (JLEVEL) = 0
            MADDR (JLEVEL) = 0
C
         ENDIF
C
  210 CONTINUE
C
C     _______________________________________________________
C
C
C*    Section 9. Return to calling routine. Format statements
C     _______________________________________________________
C
  900 CONTINUE
C
      IF (KPR .GE. 1) CALL INTLOG(JP_DEBUG,'IAFREE: Section 9.',JPQUIET)
C
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      INTEGER FUNCTION IGLSMST (KUNIT, KOFF, KNWE, KFIRST, KSTRIDE,
     1   KLEN, KLSM, NEWFILE)
C
C---->
C**** *IGLSMST*
C
C     PURPOSE
C     _______
C
C     Read and process one line of latitude from a standard land sea
C     mask file.
C
C     INTERFACE
C     _________
C
C     IERR = IGLSMST (KUNIT, KOFF, KNWE, KFIRST, KSTRIDE,
C    1   KLEN, KLSM)
C
C     Input parameters
C     ________________
C
C     KUNIT      - The unit number of the land sea mask file.
C     KOFF       - The word offset within the file of the required
C                  line. This is used to position the file.
C     KNWE       - The number of points in the West-East direction
C                  for this line of latitude.
C     KFIRST     - The position of the first land sea mask point
C                  required within the array.
C     KSTRIDE    - The distance between the longitude points required.
C     KLEN       - The length of a full latitude row of the land sea
C                  mask file.
C     NEWFILE    - 'YI' if the input land-sea mask file is to be
C                       accessed and it has changed
C                  'NI' if the input land-sea mask file is to be
C                       accessed and it has not changed
C                  'YO' if the output land-sea mask file is to be
C                       accessed and it has not changed
C                  'NO' if the output land-sea mask file is to be
C                       accessed and it has not changed
C
C     Output parameters
C     ________________
C
C     KLSM       - The array of land sea mask values for this
C                  latitude value and set of longitude points.
C
C     Return value
C     ____________
C
C     The error indicator (INTEGER).
C
C     Error and Warning Return Values
C     _______________________________
C
C     25401 Unexpected end of file found when positioning or reading
C           land sea mask file.
C     25402 Error return code when positioning or reading land sea
C           mask file.
C
C     Any error in this routine should be reported to Meteorological
C     Applications.
C
C     Common block usage
C     __________________
C
C     None
C
C     EXTERNALS
C     _________
C
C     PBREAD     - Standard library routine to read unstructured
C                  files.
C     PBSEEK     - Standard library routine to position an
C                  unstructured file.
C     INTLOG(R)  - Logs messages.
C
C     METHOD
C     ______
C
C     A full standard latitude line is transferred to the work array
C     and then the required points copied into the output array.
C
C     The land sea mask file is assumed to use one integer word for
C     each value even though these values can only be 0 or 1. This
C     gives a gain in efficiency at a cost in file size.
C
C     To reduce system overheads involved in multiple PBSEEKS and
C     PBREADS, the whole file is read into an array on the first call.
C
C     REFERENCE
C     _________
C
C     None
C
C     COMMENTS
C     ________
C
C     Program contains sections 0 to 3 and 9
C
C     AUTHOR
C     ______
C
C     K. Fielding      *ECMWF*      Nov 1993
C
C     MODIFICATIONS
C     _____________
C
C     J.D.Chambers      ECMWF       Oct 1996
C     The whole file is read into an array on the first call.
C     Number of function arguments reduced.
C
C     J.D.Chambers     ECMWF        Feb 1997
C     Allow for 64-bit pointers
C
C     J.D.Chambers     ECMWF        June 1999
C     Use bitmaps for landsea masks
C
C----<
C     _______________________________________________________
C
C*    Section 0. Definition of variables.
C     _______________________________________________________
C
      IMPLICIT NONE
C
#include "parim.h"
#include "jparams.h"
C
C     Parameters
C
      INTEGER JPROUTINE
      PARAMETER (JPROUTINE = 25400)
      INTEGER JPRAWSZ
      PARAMETER (JPRAWSZ = (JPLONG*JPLAT+(JPBITS-1))/JPBITS )
C
C     Function arguments
C
      INTEGER KUNIT, KOFF, KFIRST, KSTRIDE, KLEN, KNWE
      INTEGER KLSM (KNWE)
      CHARACTER*2 NEWFILE
C
C     Local variables
C
      INTEGER JDCSIZE, JDCINDX, JDCPNT, JDCRET, JLSM
      DIMENSION JLSM(1440)  ! good upto 0.25 degree latitude step
C
      INTEGER IPOINT, IERR, ISIZE
      DATA ISIZE/0/
      INTEGER JLON
      INTEGER LENRAW, IFIRST, IFILE, INDEX
      DIMENSION LENRAW(2)
      DIMENSION IFILE(2)
      INTEGER NRAWMSK
      DIMENSION NRAWMSK(1)
#ifndef _CRAYFTN
#ifdef POINTER_64
      INTEGER*8 IRAWMSK
#endif
#endif
      POINTER (IRAWMSK, NRAWMSK )
      DATA IFILE/0,0/
      SAVE IFILE, LENRAW, IRAWMSK, ISIZE
C     _______________________________________________________
C
C*    Section 1. Initialisation
C     _______________________________________________________
C
  100 CONTINUE
C
      IGLSMST = 0
C
      IF( NDBG.GT.2) THEN
        CALL INTLOG(JP_DEBUG,'IGLSMST: Section 1.',JPQUIET)
        CALL INTLOG(JP_DEBUG,'IGLSMST: Input parameters.',JPQUIET)
        CALL INTLOG(JP_DEBUG,'IGLSMST: Word offset in file = ',KOFF)
        CALL INTLOG(JP_DEBUG,'IGLSMST: Input rec len(words)= ',KLEN)
        CALL INTLOG(JP_DEBUG,'IGLSMST: No. of longitude pts = ',KNWE)
        CALL INTLOG(JP_DEBUG,'IGLSMST: First point in line = ',KFIRST)
        CALL INTLOG(JP_DEBUG,'IGLSMST: Stride along line = ',KSTRIDE)
      ENDIF
C
C     If the input or output land-sea mask file has changed, reset
C     the stored unit
C
      IF( NEWFILE(2:2).EQ.'I' ) THEN
        IF( NEWFILE(1:1).EQ.'Y' ) THEN
          INDEX = 1
          IFILE(INDEX) = KUNIT
          IFIRST = 0
          CALL INTLOG(JP_DEBUG,'IGLSMST: New input LSM file.',JPQUIET)
        ELSE
          INDEX = 1
          IFIRST = 1
        ENDIF
      ENDIF
C
      IF( NEWFILE(2:2).EQ.'O' ) THEN
        IF( NEWFILE(1:1).EQ.'Y' ) THEN
          INDEX = 2
          IFILE(INDEX) = KUNIT
          IFIRST = 0
          CALL INTLOG(JP_DEBUG,'IGLSMST: New output LSM file.',JPQUIET)
        ELSE
          INDEX = 2
          IFIRST = 2
        ENDIF
      ENDIF
C
C     If it is the first time through, read in the whole land-sea
C     mask file
C
      IF( IFIRST.EQ.0 ) THEN
C
C       Find the file length
C
        CALL PBSEEK (KUNIT, 0, 2, LENRAW(INDEX))
        IF ( LENRAW(INDEX).LT.0 ) THEN
          IGLSMST = JPROUTINE + 1
          CALL INTLOG(JP_FATAL,
     X      'IGLSMST: Error finding length of LSM file',JPQUIET)
          GO TO 900
        ENDIF
C
C       Rewind the file
C
        CALL INTLOG(JP_DEBUG,'IGLSMST: Rewind the LSM file.',JPQUIET)
        CALL PBSEEK (KUNIT, 0, 0, IERR)
        IF ( IERR.NE.0 ) THEN
          IGLSMST = JPROUTINE + 2
          CALL INTLOG(JP_FATAL,
     X      'IGLSMST: Error rewinding LSM file',JPQUIET)
          GO TO 900
        ENDIF
C
C     Allocate memory for the array (first time only)
C
        IF( ISIZE.EQ.0 ) THEN
          ISIZE = JPRAWSZ*2
          CALL JMEMHAN( 12, IRAWMSK, ISIZE, 1, IERR)
          IF( IERR.NE.0 ) THEN
            CALL INTLOG(JP_ERROR,
     X        'IGLSMST: Memory allocation error.',IRAWMSK)
            IGLSMST = JPROUTINE + 3
            GOTO 900
          ENDIF
        ENDIF
C
C       Read the file (ignore end-of-file).
C
        CALL INTLOG(JP_DEBUG,'IGLSMST: Read the LSM file',LENRAW(INDEX))
        CALL PBREAD(KUNIT, NRAWMSK((INDEX-1)*JPRAWSZ+1),
     X              LENRAW(INDEX), IERR)
C
        IF( IERR.NE.LENRAW(INDEX) ) THEN
          CALL INTLOG(JP_ERROR,
     X      'IGLSMST: Land-sea mask file read error.',JPQUIET)
          IGLSMST = JPROUTINE + 4
          GOTO 900
        ENDIF
C
      ENDIF
C
C     _______________________________________________________
C
C     Section 2. Transfer file to land sea mask array
C     _______________________________________________________
C
  200 CONTINUE
C
      IF( NDBG.GT.2) CALL INTLOG(JP_DEBUG,'IGLSMST: Section 2.',JPQUIET)
C
C     Needs whole line of land sea mask with no adjustment
C
      IF( (KLEN.EQ.KNWE).AND.(KFIRST.EQ.1) ) THEN
        JDCSIZE = (LENRAW(INDEX)*8+(JPBITS-1))/JPBITS
        JDCINDX = (INDEX-1)*JPRAWSZ+(KOFF/JPBITS) + 1
        JDCPNT = MOD(KOFF,JPBITS)
        CALL INXBIT(NRAWMSK(JDCINDX), JDCSIZE, JDCPNT,
     X              KLSM, KNWE, JPBITS, 1, 'D', JDCRET)
        IF( JDCRET.NE.0 ) THEN
          IGLSMST = JPROUTINE + 4
          GOTO 900
        ENDIF
C
      ELSE
C
C     Needs part of land sea mask array or different starting
C     point
C
C       Unpack whole latitude
C
        JDCSIZE = (LENRAW(INDEX)*8+(JPBITS-1))/JPBITS
        JDCINDX = (INDEX-1)*JPRAWSZ+(KOFF/JPBITS) + 1
        JDCPNT = MOD(KOFF,JPBITS)
        CALL INXBIT(NRAWMSK(JDCINDX), JDCSIZE, JDCPNT,
     X              JLSM, KLEN, JPBITS, 1, 'D', JDCRET)
        IF( JDCRET.NE.0 ) THEN
          IGLSMST = JPROUTINE + 4
          GOTO 900
        ENDIF
C
C       Select required points
C
        DO 220 JLON = 1, KNWE
          IPOINT = MOD(KLEN + KFIRST + KSTRIDE*(JLON-1) - 1, KLEN) + 1
          KLSM(JLON) = JLSM(IPOINT)
  220   CONTINUE


      ENDIF
C
C     _______________________________________________________
C
C*    Section 9. Return to calling routine. Format statements
C     _______________________________________________________
C
  900 CONTINUE
C
      IF( NDBG.GT.2) CALL INTLOG(JP_DEBUG,'IGLSMST: Section 9.',JPQUIET)
C
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

C
      COMMON /BCOMTAB/ NTABBTR(JTAB),NTABBS (JTAB),NTABBRV(JTAB),
     1                NTABBDW(JTAB),NTABDTR(JTAB),NTABDST(JTAB),
     2                NTABDL (JTAB),NTABDSQ(JTAB*20),NTABP(64,256)
C     
C             NTABBTR    - TABLE B,  TABLE REFERENCE              ARRAY
C             NTABBS     - TABLE B,  SCALE                        ARRAY
C             NTABBRF    - TABLE B,  REFERENCE VALUE              ARRAY
C             NTABBDW    - TABLE B,  DATA WIDTH                   ARRAY
C             NTABDTR    - TABLE D,  TABLE REFERENCE              ARRAY
C             NTABDST    - TABLE D,  STARTING POINTERS            ARRAY
C             NTABDL     - TABLE D,  LENGTHS                      ARRAY
C             NTABDSQ    - TABLE D,  LIST OF SEQUENCE DESCRIPTORS ARRAY
C
C

c Copyright 1981-2016 ECMWF.
c
c This software is licensed under the terms of the Apache Licence 
c Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
c
c In applying this licence, ECMWF does not waive the privileges and immunities 
c granted to it by virtue of its status as an intergovernmental organisation 
c nor does it submit to any jurisdiction.
c

C     SUBROUTINE 'RPASSF' - PERFORMS ONE PASS THROUGH DATA AS PART      
C     OF MULTIPLE REAL FFT (FOURIER SYNTHESIS) ROUTINE                  
C                                                                       
C     A IS FIRST REAL INPUT VECTOR                                      
C         EQUIVALENCE B(1) WITH A (LA*INC1+1)                           
C     C IS FIRST REAL OUTPUT VECTOR                                     
C         EQUIVALENCE D(1) WITH C(IFAC*LA*INC2+1)                       
C     TRIGS IS A PRECALCULATED LIST OF SINES & COSINES                  
C     INC1 IS THE ADDRESSING INCREMENT FOR A                            
C     INC2 IS THE ADDRESSING INCREMENT FOR C                            
C     INC3 IS THE INCREMENT BETWEEN INPUT VECTORS A                     
C     INC4 IS THE INCREMENT BETWEEN OUTPUT VECTORS C                    
C     LOT IS THE NUMBER OF VECTORS                                      
C     N IS THE LENGTH OF THE VECTORS                                    
C     IFAC IS THE CURRENT FACTOR OF N                                   
C     LA IS THE PRODUCT OF PREVIOUS FACTORS                             
C     IERR IS AN ERROR INDICATOR:                                       
C              0 - PASS COMPLETED WITHOUT ERROR                         
C              2 - IFAC NOT CATERED FOR                                 
C              3 - IFAC ONLY CATERED FOR IF LA=N/IFAC                   
C     LIPL=.T. => RESULTS ARE RETURNED TO INPUT ARRAY
C              (ONLY VALID IF LA=N/IFAC, I.E. ON LAST PASS)
C                                                                       
C-----------------------------------------------------------------------
C                                                                       
      SUBROUTINE RPASSF(A,B,C,D,TRIGS,INC1,INC2,INC3,INC4,LOT,N,IFAC,   
     *    LA,IERR,LIPL)                                                      
      DIMENSION A(N),B(N),C(N),D(N),TRIGS(N)                            
      LOGICAL LIPL
C                                                                       
      DATA SIN36/0.587785252292473/,SIN72/0.951056516295154/,           
     *    QRT5/0.559016994374947/,SIN60/0.866025403784437/              
C                                                                       
      M=N/IFAC                                                          
      IINK=LA*INC1                                                      
      JINK=LA*INC2                                                      
      JUMP=(IFAC-1)*JINK                                                
      KSTOP=(N-IFAC)/(2*IFAC)                                           
C                                                                       
      IBASE=0                                                           
      JBASE=0                                                           
      IBAD=0                                                            
C
!     Increase the vector length by fusing the loops if the
!     data layout is appropriate:
      IF (INC1.EQ.LOT.AND.INC2.EQ.LOT.AND.INC3.EQ.1.AND.INC4.EQ.1) THEN
        ILA=1
        ILOT=LA*LOT
        INC21=LA*LOT
      ELSE
        ILA=LA
        ILOT=LOT
        INC21=INC2
      ENDIF
C
      IF (IFAC.EQ.2) THEN
C                                                                       
C     CODING FOR FACTOR 2                                               
C     -------------------                                               
  200 CONTINUE                                                          
      IA=1                                                              
      IB=IA+(2*M-LA)*INC1                                               
      JA=1                                                              
      JB=JA+JINK                                                        
C                                                                       
      IF (LA.NE.M) THEN                                            
C                                                                       
      DO 220 L=1,ILA                                                     
      I=IBASE                                                           
      J=JBASE                                                           
!OCL NOVREC                                                   
      DO 210 IJK=1,ILOT                                                  
      C(JA+J)=A(IA+I)+A(IB+I)                                           
      C(JB+J)=A(IA+I)-A(IB+I)                                           
      I=I+INC3                                                          
      J=J+INC4                                                          
  210 CONTINUE                                                          
      IBASE=IBASE+INC1                                                  
      JBASE=JBASE+INC21                                                  
  220 CONTINUE                                                          
      IA=IA+IINK                                                        
      IINK=2*IINK                                                       
      IB=IB-IINK                                                        
      IBASE=0                                                           
      JBASE=JBASE+JUMP                                                  
      JUMP=2*JUMP+JINK                                                  
C
      IF (IA.LT.IB) THEN                                           
      DO 250 K=LA,KSTOP,LA                                              
      KB=K+K                                                            
      C1=TRIGS(KB+1)                                                    
      S1=TRIGS(KB+2)                                                    
      IBASE=0                                                           
      DO 240 L=1,ILA                                                     
      I=IBASE                                                           
      J=JBASE                                                           
!OCL NOVREC                                                   
      DO 230 IJK=1,ILOT                                                  
      C(JA+J)=A(IA+I)+A(IB+I)                                           
      D(JA+J)=B(IA+I)-B(IB+I)                                           
      C(JB+J)=C1*(A(IA+I)-A(IB+I))-S1*(B(IA+I)+B(IB+I))                 
      D(JB+J)=S1*(A(IA+I)-A(IB+I))+C1*(B(IA+I)+B(IB+I))                 
      I=I+INC3                                                          
      J=J+INC4                                                          
  230 CONTINUE                                                          
      IBASE=IBASE+INC1                                                  
      JBASE=JBASE+INC21                                                  
  240 CONTINUE                                                          
      IA=IA+IINK                                                        
      IB=IB-IINK                                                        
      JBASE=JBASE+JUMP                                                  
  250 CONTINUE                                                          
      ENDIF
C
      IF (IA.EQ.IB) THEN                                           
      IBASE=0                                                           
      DO 280 L=1,ILA                                                     
      I=IBASE                                                           
      J=JBASE                                                           
!OCL NOVREC                                                   
      DO 270 IJK=1,ILOT                                                  
      C(JA+J)=A(IA+I)                                                   
      C(JB+J)=-B(IA+I)                                                  
      I=I+INC3                                                          
      J=J+INC4                                                          
  270 CONTINUE                                                          
      IBASE=IBASE+INC1                                                  
      JBASE=JBASE+INC21                                                  
  280 CONTINUE                                                          
      ENDIF                                                         
C                                                                       
      ELSE                !!! Case LA=M                                 
      IF (LIPL) THEN
        DO 294 L=1,ILA                                                     
        I=IBASE                                                           
!OCL NOVREC
        DO 292 IJK=1,ILOT                                                  
        T1=2.0*(A(IA+I)-A(IB+I))                                     
        A(IA+I)=2.0*(A(IA+I)+A(IB+I))                                     
        A(IB+I)=T1
        I=I+INC3                                                          
  292   CONTINUE                                                          
        IBASE=IBASE+INC1                                                  
  294   CONTINUE                                                          
      ELSE
        DO 298 L=1,ILA                                                     
        I=IBASE                                                           
        J=JBASE                                                           
!OCL NOVREC
        DO 296 IJK=1,ILOT                                                  
        C(JA+J)=2.0*(A(IA+I)+A(IB+I))                                     
        C(JB+J)=2.0*(A(IA+I)-A(IB+I))                                     
        I=I+INC3                                                          
        J=J+INC4                                                          
  296   CONTINUE                                                          
        IBASE=IBASE+INC1                                                  
        JBASE=JBASE+INC21                                                  
  298   CONTINUE                                                          
      ENDIF
      ENDIF
C
      ELSEIF (IFAC.EQ.3) THEN
C                                                                       
C     CODING FOR FACTOR 3                                               
C     -------------------                                               
  300 CONTINUE                                                          
      IA=1                                                              
      IB=IA+(2*M-LA)*INC1                                               
      IC=IB                                                             
      JA=1                                                              
      JB=JA+JINK                                                        
      JC=JB+JINK                                                        
C                                                                       
      IF (LA.NE.M) THEN                                            
C                                                                       
      DO 320 L=1,ILA                                                     
      I=IBASE                                                           
      J=JBASE                                                           
!OCL NOVREC                                                   
      DO 310 IJK=1,ILOT                                                  
      C(JA+J)=A(IA+I)+A(IB+I)                                           
      C(JB+J)=(A(IA+I)-0.5*A(IB+I))-(SIN60*(B(IB+I)))                   
      C(JC+J)=(A(IA+I)-0.5*A(IB+I))+(SIN60*(B(IB+I)))                   
      I=I+INC3                                                          
      J=J+INC4                                                          
  310 CONTINUE                                                          
      IBASE=IBASE+INC1                                                  
      JBASE=JBASE+INC21                                                  
  320 CONTINUE                                                          
      IA=IA+IINK                                                        
      IINK=2*IINK                                                       
      IB=IB+IINK                                                        
      IC=IC-IINK                                                        
      JBASE=JBASE+JUMP                                                  
      JUMP=2*JUMP+JINK                                                  
C
      IF (IA.LT.IC) THEN                                           
      DO 350 K=LA,KSTOP,LA                                              
      KB=K+K                                                            
      KC=KB+KB                                                          
      C1=TRIGS(KB+1)                                                    
      S1=TRIGS(KB+2)                                                    
      C2=TRIGS(KC+1)                                                    
      S2=TRIGS(KC+2)                                                    
      IBASE=0                                                           
      DO 340 L=1,ILA                                                     
      I=IBASE                                                           
      J=JBASE                                                           
!OCL NOVREC                                                   
      DO 330 IJK=1,ILOT                                                  
      C(JA+J)=A(IA+I)+(A(IB+I)+A(IC+I))                                 
      D(JA+J)=B(IA+I)+(B(IB+I)-B(IC+I))                                 
      C(JB+J)=                                                          
     *    C1*((A(IA+I)-0.5*(A(IB+I)+A(IC+I)))-(SIN60*(B(IB+I)+B(IC+I))))
     *   -S1*((B(IA+I)-0.5*(B(IB+I)-B(IC+I)))+(SIN60*(A(IB+I)-A(IC+I))))
      D(JB+J)=                                                          
     *    S1*((A(IA+I)-0.5*(A(IB+I)+A(IC+I)))-(SIN60*(B(IB+I)+B(IC+I))))
     *   +C1*((B(IA+I)-0.5*(B(IB+I)-B(IC+I)))+(SIN60*(A(IB+I)-A(IC+I))))
      C(JC+J)=                                                          
     *    C2*((A(IA+I)-0.5*(A(IB+I)+A(IC+I)))+(SIN60*(B(IB+I)+B(IC+I))))
     *   -S2*((B(IA+I)-0.5*(B(IB+I)-B(IC+I)))-(SIN60*(A(IB+I)-A(IC+I))))
      D(JC+J)=                                                          
     *    S2*((A(IA+I)-0.5*(A(IB+I)+A(IC+I)))+(SIN60*(B(IB+I)+B(IC+I))))
     *   +C2*((B(IA+I)-0.5*(B(IB+I)-B(IC+I)))-(SIN60*(A(IB+I)-A(IC+I))))
      I=I+INC3                                                          
      J=J+INC4                                                          
  330 CONTINUE                                                          
      IBASE=IBASE+INC1                                                  
      JBASE=JBASE+INC21                                                  
  340 CONTINUE                                                          
      IA=IA+IINK                                                        
      IB=IB+IINK                                                        
      IC=IC-IINK                                                        
      JBASE=JBASE+JUMP                                                  
  350 CONTINUE                                                          
      ENDIF
C
      IF (IA.EQ.IC) THEN                                           
      IBASE=0                                                           
      DO 380 L=1,ILA                                                     
      I=IBASE                                                           
      J=JBASE                                                           
!OCL NOVREC                                                   
      DO 370 IJK=1,ILOT                                                  
      C(JA+J)=A(IA+I)+A(IB+I)                                           
      C(JB+J)=(0.5*A(IA+I)-A(IB+I))-(SIN60*B(IA+I))                     
      C(JC+J)=-(0.5*A(IA+I)-A(IB+I))-(SIN60*B(IA+I))                    
      I=I+INC3                                                          
      J=J+INC4                                                          
  370 CONTINUE                                                          
      IBASE=IBASE+INC1                                                  
      JBASE=JBASE+INC21                                                  
  380 CONTINUE                                                          
      ENDIF                                                         
C                                                                       
      ELSE                !!! Case LA=M                                 
      SSIN60=2.0*SIN60                                                  
      IF (LIPL) THEN
        DO 394 L=1,ILA                                                     
        I=IBASE                                                           
!OCL NOVREC
        DO 392 IJK=1,ILOT                                                  
        T1=(2.0*A(IA+I)-A(IB+I))-(SSIN60*B(IB+I))                    
        T2=(2.0*A(IA+I)-A(IB+I))+(SSIN60*B(IB+I))                    
        A(IA+I)=2.0*(A(IA+I)+A(IB+I))                                     
        A(IB+I)=T1
        B(IB+I)=T2
        I=I+INC3                                                          
  392   CONTINUE                                                          
        IBASE=IBASE+INC1                                                  
  394   CONTINUE                                                          
      ELSE
        DO 398 L=1,ILA                                                     
        I=IBASE                                                           
        J=JBASE                                                           
!OCL NOVREC
        DO 396 IJK=1,ILOT                                                  
        C(JA+J)=2.0*(A(IA+I)+A(IB+I))                                     
        C(JB+J)=(2.0*A(IA+I)-A(IB+I))-(SSIN60*B(IB+I))                    
        C(JC+J)=(2.0*A(IA+I)-A(IB+I))+(SSIN60*B(IB+I))                    
        I=I+INC3                                                          
        J=J+INC4                                                          
  396   CONTINUE                                                          
        IBASE=IBASE+INC1                                                  
        JBASE=JBASE+INC21                                                  
  398   CONTINUE                                                          
      ENDIF
      ENDIF
C
      ELSEIF (IFAC.EQ.4) THEN
C                                                                       
C     CODING FOR FACTOR 4                                               
C     -------------------                                               
  400 CONTINUE                                                          
      IA=1                                                              
      IB=IA+(2*M-LA)*INC1                                               
      IC=IB+2*M*INC1                                                    
      ID=IB                                                             
      JA=1                                                              
      JB=JA+JINK                                                        
      JC=JB+JINK                                                        
      JD=JC+JINK                                                        
C                                                                       
      IF (LA.NE.M) THEN                                            
C                                                                       
      DO 420 L=1,ILA                                                     
      I=IBASE                                                           
      J=JBASE                                                           
!OCL NOVREC                                                   
      DO 410 IJK=1,ILOT                                                  
      C(JA+J)=(A(IA+I)+A(IC+I))+A(IB+I)                                 
      C(JB+J)=(A(IA+I)-A(IC+I))-B(IB+I)                                 
      C(JC+J)=(A(IA+I)+A(IC+I))-A(IB+I)                                 
      C(JD+J)=(A(IA+I)-A(IC+I))+B(IB+I)                                 
      I=I+INC3                                                          
      J=J+INC4                                                          
  410 CONTINUE                                                          
      IBASE=IBASE+INC1                                                  
      JBASE=JBASE+INC21                                                  
  420 CONTINUE                                                          
      IA=IA+IINK                                                        
      IINK=2*IINK                                                       
      IB=IB+IINK                                                        
      IC=IC-IINK                                                        
      ID=ID-IINK                                                        
      JBASE=JBASE+JUMP                                                  
      JUMP=2*JUMP+JINK                                                  
C
      IF (IB.LT.IC) THEN                                           
      DO 450 K=LA,KSTOP,LA                                              
      KB=K+K                                                            
      KC=KB+KB                                                          
      KD=KC+KB                                                          
      C1=TRIGS(KB+1)                                                    
      S1=TRIGS(KB+2)                                                    
      C2=TRIGS(KC+1)                                                    
      S2=TRIGS(KC+2)                                                    
      C3=TRIGS(KD+1)                                                    
      S3=TRIGS(KD+2)                                                    
      IBASE=0                                                           
      DO 440 L=1,ILA                                                     
      I=IBASE                                                           
      J=JBASE                                                           
!OCL NOVREC                                                   
      DO 430 IJK=1,ILOT                                                  
      C(JA+J)=(A(IA+I)+A(IC+I))+(A(IB+I)+A(ID+I))                       
      D(JA+J)=(B(IA+I)-B(IC+I))+(B(IB+I)-B(ID+I))                       
      C(JC+J)=                                                          
     *    C2*((A(IA+I)+A(IC+I))-(A(IB+I)+A(ID+I)))                      
     *   -S2*((B(IA+I)-B(IC+I))-(B(IB+I)-B(ID+I)))                      
      D(JC+J)=                                                          
     *    S2*((A(IA+I)+A(IC+I))-(A(IB+I)+A(ID+I)))                      
     *   +C2*((B(IA+I)-B(IC+I))-(B(IB+I)-B(ID+I)))                      
      C(JB+J)=                                                          
     *    C1*((A(IA+I)-A(IC+I))-(B(IB+I)+B(ID+I)))                      
     *   -S1*((B(IA+I)+B(IC+I))+(A(IB+I)-A(ID+I)))                      
      D(JB+J)=                                                          
     *    S1*((A(IA+I)-A(IC+I))-(B(IB+I)+B(ID+I)))                      
     *   +C1*((B(IA+I)+B(IC+I))+(A(IB+I)-A(ID+I)))                      
      C(JD+J)=                                                          
     *    C3*((A(IA+I)-A(IC+I))+(B(IB+I)+B(ID+I)))                      
     *   -S3*((B(IA+I)+B(IC+I))-(A(IB+I)-A(ID+I)))                      
      D(JD+J)=                                                          
     *    S3*((A(IA+I)-A(IC+I))+(B(IB+I)+B(ID+I)))                      
     *   +C3*((B(IA+I)+B(IC+I))-(A(IB+I)-A(ID+I)))                      
      I=I+INC3                                                          
      J=J+INC4                                                          
  430 CONTINUE                                                          
      IBASE=IBASE+INC1                                                  
      JBASE=JBASE+INC21                                                  
  440 CONTINUE                                                          
      IA=IA+IINK                                                        
      IB=IB+IINK                                                        
      IC=IC-IINK                                                        
      ID=ID-IINK                                                        
      JBASE=JBASE+JUMP                                                  
  450 CONTINUE                                                          
      ENDIF
C
      IF (IB.EQ.IC) THEN                                           
      IBASE=0                                                           
      SIN45=SQRT(0.5)                                                   
      DO 480 L=1,ILA                                                     
      I=IBASE                                                           
      J=JBASE                                                           
!OCL NOVREC                                                   
      DO 470 IJK=1,ILOT                                                  
      C(JA+J)=A(IA+I)+A(IB+I)                                           
      C(JB+J)=SIN45*((A(IA+I)-A(IB+I))-(B(IA+I)+B(IB+I)))               
      C(JC+J)=B(IB+I)-B(IA+I)                                           
      C(JD+J)=-SIN45*((A(IA+I)-A(IB+I))+(B(IA+I)+B(IB+I)))              
      I=I+INC3                                                          
      J=J+INC4                                                          
  470 CONTINUE                                                          
      IBASE=IBASE+INC1                                                  
      JBASE=JBASE+INC21                                                  
  480 CONTINUE                                                          
      ENDIF                                                             
C                                                                       
      ELSE                !!! Case LA=M                                 
      IF (LIPL) THEN
        DO 494 L=1,ILA                                                     
        I=IBASE                                                           
!OCL NOVREC
        DO 492 IJK=1,ILOT                                                  
        T1=2.0*((A(IA+I)-A(IC+I))-B(IB+I))                           
        T2=2.0*((A(IA+I)+A(IC+I))-A(IB+I))                           
        T3=2.0*((A(IA+I)-A(IC+I))+B(IB+I))                           
        A(IA+I)=2.0*((A(IA+I)+A(IC+I))+A(IB+I))                           
        A(IB+I)=T1
        B(IB+I)=T2
        A(IC+I)=T3
        I=I+INC3                                                          
  492   CONTINUE                                                          
        IBASE=IBASE+INC1                                                  
  494   CONTINUE                                                          
      ELSE
        DO 498 L=1,ILA                                                     
        I=IBASE                                                           
        J=JBASE                                                           
!OCL NOVREC
        DO 496 IJK=1,ILOT                                                  
        C(JA+J)=2.0*((A(IA+I)+A(IC+I))+A(IB+I))                           
        C(JB+J)=2.0*((A(IA+I)-A(IC+I))-B(IB+I))                           
        C(JC+J)=2.0*((A(IA+I)+A(IC+I))-A(IB+I))                           
        C(JD+J)=2.0*((A(IA+I)-A(IC+I))+B(IB+I))                           
        I=I+INC3                                                          
        J=J+INC4                                                          
  496   CONTINUE                                                          
        IBASE=IBASE+INC1                                                  
        JBASE=JBASE+INC21                                                  
  498   CONTINUE                                                          
      ENDIF
      ENDIF
C
      ELSEIF (IFAC.EQ.5) THEN
C                                                                       
C     CODING FOR FACTOR 5                                               
C     -------------------                                               
  500 CONTINUE                                                          
      IA=1                                                              
      IB=IA+(2*M-LA)*INC1                                               
      IC=IB+2*M*INC1                                                    
      ID=IC                                                             
      IE=IB                                                             
      JA=1                                                              
      JB=JA+JINK                                                        
      JC=JB+JINK                                                        
      JD=JC+JINK                                                        
      JE=JD+JINK                                                        
C                                                                       
      IF (LA.NE.M) THEN                                                 
C                                                                       
      DO 520 L=1,ILA                                                     
      I=IBASE                                                           
      J=JBASE                                                           
!OCL NOVREC                                                   
      DO 510 IJK=1,ILOT                                                  
      C(JA+J)=A(IA+I)+(A(IB+I)+A(IC+I))                                 
      C(JB+J)=((A(IA+I)-0.25*(A(IB+I)+A(IC+I)))+QRT5*(A(IB+I)-A(IC+I))) 
     *    -(SIN72*B(IB+I)+SIN36*B(IC+I))                                
      C(JC+J)=((A(IA+I)-0.25*(A(IB+I)+A(IC+I)))-QRT5*(A(IB+I)-A(IC+I))) 
     *    -(SIN36*B(IB+I)-SIN72*B(IC+I))                                
      C(JD+J)=((A(IA+I)-0.25*(A(IB+I)+A(IC+I)))-QRT5*(A(IB+I)-A(IC+I))) 
     *    +(SIN36*B(IB+I)-SIN72*B(IC+I))                                
      C(JE+J)=((A(IA+I)-0.25*(A(IB+I)+A(IC+I)))+QRT5*(A(IB+I)-A(IC+I))) 
     *    +(SIN72*B(IB+I)+SIN36*B(IC+I))                                
      I=I+INC3                                                          
      J=J+INC4                                                          
  510 CONTINUE                                                          
      IBASE=IBASE+INC1                                                  
      JBASE=JBASE+INC21                                                  
  520 CONTINUE                                                          
      IA=IA+IINK                                                        
      IINK=2*IINK                                                       
      IB=IB+IINK                                                        
      IC=IC+IINK                                                        
      ID=ID-IINK                                                        
      IE=IE-IINK                                                        
      JBASE=JBASE+JUMP                                                  
      JUMP=2*JUMP+JINK                                                  
C
      IF (IB.LT.ID) THEN                                                
      DO 550 K=LA,KSTOP,LA                                              
      KB=K+K                                                            
      KC=KB+KB                                                          
      KD=KC+KB                                                          
      KE=KD+KB                                                          
      C1=TRIGS(KB+1)                                                    
      S1=TRIGS(KB+2)                                                    
      C2=TRIGS(KC+1)                                                    
      S2=TRIGS(KC+2)                                                    
      C3=TRIGS(KD+1)                                                    
      S3=TRIGS(KD+2)                                                    
      C4=TRIGS(KE+1)                                                    
      S4=TRIGS(KE+2)                                                    
      IBASE=0                                                           
      DO 540 L=1,ILA                                                     
      I=IBASE                                                           
      J=JBASE                                                           
!OCL NOVREC                                                   
      DO 530 IJK=1,ILOT                                                  
C                                                                       
      A10=(A(IA+I)-0.25*((A(IB+I)+A(IE+I))+(A(IC+I)+A(ID+I))))          
     *    +QRT5*((A(IB+I)+A(IE+I))-(A(IC+I)+A(ID+I)))                   
      A20=(A(IA+I)-0.25*((A(IB+I)+A(IE+I))+(A(IC+I)+A(ID+I))))          
     *    -QRT5*((A(IB+I)+A(IE+I))-(A(IC+I)+A(ID+I)))                   
      B10=(B(IA+I)-0.25*((B(IB+I)-B(IE+I))+(B(IC+I)-B(ID+I))))          
     *    +QRT5*((B(IB+I)-B(IE+I))-(B(IC+I)-B(ID+I)))                   
      B20=(B(IA+I)-0.25*((B(IB+I)-B(IE+I))+(B(IC+I)-B(ID+I))))          
     *    -QRT5*((B(IB+I)-B(IE+I))-(B(IC+I)-B(ID+I)))                   
      A11=SIN72*(B(IB+I)+B(IE+I))+SIN36*(B(IC+I)+B(ID+I))               
      A21=SIN36*(B(IB+I)+B(IE+I))-SIN72*(B(IC+I)+B(ID+I))               
      B11=SIN72*(A(IB+I)-A(IE+I))+SIN36*(A(IC+I)-A(ID+I))               
      B21=SIN36*(A(IB+I)-A(IE+I))-SIN72*(A(IC+I)-A(ID+I))               
C                                                                       
      C(JA+J)=A(IA+I)+((A(IB+I)+A(IE+I))+(A(IC+I)+A(ID+I)))             
      D(JA+J)=B(IA+I)+((B(IB+I)-B(IE+I))+(B(IC+I)-B(ID+I)))             
      C(JB+J)=C1*(A10-A11)-S1*(B10+B11)                                 
      D(JB+J)=S1*(A10-A11)+C1*(B10+B11)                                 
      C(JE+J)=C4*(A10+A11)-S4*(B10-B11)                                 
      D(JE+J)=S4*(A10+A11)+C4*(B10-B11)                                 
      C(JC+J)=C2*(A20-A21)-S2*(B20+B21)                                 
      D(JC+J)=S2*(A20-A21)+C2*(B20+B21)                                 
      C(JD+J)=C3*(A20+A21)-S3*(B20-B21)                                 
      D(JD+J)=S3*(A20+A21)+C3*(B20-B21)                                 
C                                                                       
      I=I+INC3                                                          
      J=J+INC4                                                          
  530 CONTINUE                                                          
      IBASE=IBASE+INC1                                                  
      JBASE=JBASE+INC21                                                  
  540 CONTINUE                                                          
      IA=IA+IINK                                                        
      IB=IB+IINK                                                        
      IC=IC+IINK                                                        
      ID=ID-IINK                                                        
      IE=IE-IINK                                                        
      JBASE=JBASE+JUMP                                                  
  550 CONTINUE                                                          
      ENDIF
C
      IF (IB.EQ.ID) THEN                                                
      IBASE=0                                                           
      DO 580 L=1,ILA                                                     
      I=IBASE                                                           
      J=JBASE                                                           
!OCL NOVREC                                                   
      DO 570 IJK=1,ILOT                                                  
      C(JA+J)=(A(IA+I)+A(IB+I))+A(IC+I)                                 
      C(JB+J)=(QRT5*(A(IA+I)-A(IB+I))+(0.25*(A(IA+I)+A(IB+I))-A(IC+I))) 
     *    -(SIN36*B(IA+I)+SIN72*B(IB+I))                                
      C(JE+J)=-(QRT5*(A(IA+I)-A(IB+I))+(0.25*(A(IA+I)+A(IB+I))-A(IC+I)))
     *    -(SIN36*B(IA+I)+SIN72*B(IB+I))                                
      C(JC+J)=(QRT5*(A(IA+I)-A(IB+I))-(0.25*(A(IA+I)+A(IB+I))-A(IC+I))) 
     *    -(SIN72*B(IA+I)-SIN36*B(IB+I))                                
      C(JD+J)=-(QRT5*(A(IA+I)-A(IB+I))-(0.25*(A(IA+I)+A(IB+I))-A(IC+I)))
     *    -(SIN72*B(IA+I)-SIN36*B(IB+I))                                
      I=I+INC3                                                          
      J=J+INC4                                                          
  570 CONTINUE                                                          
      IBASE=IBASE+INC1                                                  
      JBASE=JBASE+INC21                                                  
  580 CONTINUE                                                          
      ENDIF                                                             
C                                                                       
      ELSE               !!! Case LA=M                                  
      QQRT5=2.0*QRT5                                                    
      SSIN36=2.0*SIN36                                                  
      SSIN72=2.0*SIN72                                                  
      IF (LIPL) THEN
        DO 594 L=1,ILA                                                     
        I=IBASE                                                           
!OCL NOVREC
        DO 592 IJK=1,ILOT                                                  
        T1=(2.0*(A(IA+I)-0.25*(A(IB+I)+A(IC+I)))                     
     *    +QQRT5*(A(IB+I)-A(IC+I)))-(SSIN72*B(IB+I)+SSIN36*B(IC+I))     
        T2=(2.0*(A(IA+I)-0.25*(A(IB+I)+A(IC+I)))                     
     *    -QQRT5*(A(IB+I)-A(IC+I)))-(SSIN36*B(IB+I)-SSIN72*B(IC+I))     
        T3=(2.0*(A(IA+I)-0.25*(A(IB+I)+A(IC+I)))                     
     *    -QQRT5*(A(IB+I)-A(IC+I)))+(SSIN36*B(IB+I)-SSIN72*B(IC+I))     
        T4=(2.0*(A(IA+I)-0.25*(A(IB+I)+A(IC+I)))                     
     *    +QQRT5*(A(IB+I)-A(IC+I)))+(SSIN72*B(IB+I)+SSIN36*B(IC+I))     
        A(IA+I)=2.0*(A(IA+I)+(A(IB+I)+A(IC+I)))                           
        A(IB+I)=T1
        B(IB+I)=T2
        A(IC+I)=T3
        B(IC+I)=T4
        I=I+INC3                                                          
  592   CONTINUE                                                          
        IBASE=IBASE+INC1                                                  
  594   CONTINUE                                                          
      ELSE
        DO 598 L=1,ILA                                                     
        I=IBASE                                                           
        J=JBASE                                                           
!OCL NOVREC
        DO 596 IJK=1,ILOT                                                  
        C(JA+J)=2.0*(A(IA+I)+(A(IB+I)+A(IC+I)))                           
        C(JB+J)=(2.0*(A(IA+I)-0.25*(A(IB+I)+A(IC+I)))                     
     *    +QQRT5*(A(IB+I)-A(IC+I)))-(SSIN72*B(IB+I)+SSIN36*B(IC+I))     
        C(JC+J)=(2.0*(A(IA+I)-0.25*(A(IB+I)+A(IC+I)))                     
     *    -QQRT5*(A(IB+I)-A(IC+I)))-(SSIN36*B(IB+I)-SSIN72*B(IC+I))     
        C(JD+J)=(2.0*(A(IA+I)-0.25*(A(IB+I)+A(IC+I)))                     
     *    -QQRT5*(A(IB+I)-A(IC+I)))+(SSIN36*B(IB+I)-SSIN72*B(IC+I))     
        C(JE+J)=(2.0*(A(IA+I)-0.25*(A(IB+I)+A(IC+I)))                     
     *    +QQRT5*(A(IB+I)-A(IC+I)))+(SSIN72*B(IB+I)+SSIN36*B(IC+I))     
        I=I+INC3                                                          
        J=J+INC4                                                          
  596   CONTINUE                                                          
        IBASE=IBASE+INC1                                                  
        JBASE=JBASE+INC21                                                  
  598   CONTINUE                                                          
      ENDIF
      ENDIF
C
      ELSEIF (IFAC.EQ.6) THEN
C                                                                       
C     CODING FOR FACTOR 6                                               
C     -------------------                                               
  600 CONTINUE                                                          
      IA=1                                                              
      IB=IA+(2*M-LA)*INC1                                               
      IC=IB+2*M*INC1                                                    
      ID=IC+2*M*INC1                                                    
      IE=IC                                                             
      IF=IB                                                             
      JA=1                                                              
      JB=JA+JINK                                                        
      JC=JB+JINK                                                        
      JD=JC+JINK                                                        
      JE=JD+JINK                                                        
      JF=JE+JINK                                                        
C                                                                       
      IF (LA.NE.M) THEN                                                 
C                                                                       
      DO 620 L=1,ILA                                                     
      I=IBASE                                                           
      J=JBASE                                                           
!OCL NOVREC                                                   
      DO 610 IJK=1,ILOT                                                  
      C(JA+J)=(A(IA+I)+A(ID+I))+(A(IB+I)+A(IC+I))                       
      C(JD+J)=(A(IA+I)-A(ID+I))-(A(IB+I)-A(IC+I))                       
      C(JB+J)=((A(IA+I)-A(ID+I))+0.5*(A(IB+I)-A(IC+I)))                 
     *    -(SIN60*(B(IB+I)+B(IC+I)))                                    
      C(JF+J)=((A(IA+I)-A(ID+I))+0.5*(A(IB+I)-A(IC+I)))                 
     *    +(SIN60*(B(IB+I)+B(IC+I)))                                    
      C(JC+J)=((A(IA+I)+A(ID+I))-0.5*(A(IB+I)+A(IC+I)))                 
     *    -(SIN60*(B(IB+I)-B(IC+I)))                                    
      C(JE+J)=((A(IA+I)+A(ID+I))-0.5*(A(IB+I)+A(IC+I)))                 
     *    +(SIN60*(B(IB+I)-B(IC+I)))                                    
      I=I+INC3                                                          
      J=J+INC4                                                          
  610 CONTINUE                                                          
      IBASE=IBASE+INC1                                                  
      JBASE=JBASE+INC21                                                  
  620 CONTINUE                                                          
      IA=IA+IINK                                                        
      IINK=2*IINK                                                       
      IB=IB+IINK                                                        
      IC=IC+IINK                                                        
      ID=ID-IINK                                                        
      IE=IE-IINK                                                        
      IF=IF-IINK                                                        
      JBASE=JBASE+JUMP                                                  
      JUMP=2*JUMP+JINK                                                  
C
      IF (IC.LT.ID) THEN                                                
      DO 650 K=LA,KSTOP,LA                                              
      KB=K+K                                                            
      KC=KB+KB                                                          
      KD=KC+KB                                                          
      KE=KD+KB                                                          
      KF=KE+KB                                                          
      C1=TRIGS(KB+1)                                                    
      S1=TRIGS(KB+2)                                                    
      C2=TRIGS(KC+1)                                                    
      S2=TRIGS(KC+2)                                                    
      C3=TRIGS(KD+1)                                                    
      S3=TRIGS(KD+2)                                                    
      C4=TRIGS(KE+1)                                                    
      S4=TRIGS(KE+2)                                                    
      C5=TRIGS(KF+1)                                                    
      S5=TRIGS(KF+2)                                                    
      IBASE=0                                                           
      DO 640 L=1,ILA                                                     
      I=IBASE                                                           
      J=JBASE                                                           
!OCL NOVREC                                                   
      DO 630 IJK=1,ILOT                                                  
C                                                                       
      A11= (A(IE+I)+A(IB+I))+(A(IC+I)+A(IF+I))                          
      A20=(A(IA+I)+A(ID+I))-0.5*A11                                     
      A21=SIN60*((A(IE+I)+A(IB+I))-(A(IC+I)+A(IF+I)))                   
      B11= (B(IB+I)-B(IE+I))+(B(IC+I)-B(IF+I))                          
      B20=(B(IA+I)-B(ID+I))-0.5*B11                                     
      B21=SIN60*((B(IB+I)-B(IE+I))-(B(IC+I)-B(IF+I)))                   
C                                                                       
      C(JA+J)=(A(IA+I)+A(ID+I))+A11                                     
      D(JA+J)=(B(IA+I)-B(ID+I))+B11                                     
      C(JC+J)=C2*(A20-B21)-S2*(B20+A21)                                 
      D(JC+J)=S2*(A20-B21)+C2*(B20+A21)                                 
      C(JE+J)=C4*(A20+B21)-S4*(B20-A21)                                 
      D(JE+J)=S4*(A20+B21)+C4*(B20-A21)                                 
C                                                                       
      A11=(A(IE+I)-A(IB+I))+(A(IC+I)-A(IF+I))                           
      B11=(B(IE+I)+B(IB+I))-(B(IC+I)+B(IF+I))                           
      A20=(A(IA+I)-A(ID+I))-0.5*A11                                     
      A21=SIN60*((A(IE+I)-A(IB+I))-(A(IC+I)-A(IF+I)))                   
      B20=(B(IA+I)+B(ID+I))+0.5*B11                                     
      B21=SIN60*((B(IE+I)+B(IB+I))+(B(IC+I)+B(IF+I)))                   
C                                                                       
      C(JD+J)=                                                          
     *  C3*((A(IA+I)-A(ID+I))+A11)-S3*((B(IA+I)+B(ID+I))-B11)           
      D(JD+J)=                                                          
     *  S3*((A(IA+I)-A(ID+I))+A11)+C3*((B(IA+I)+B(ID+I))-B11)           
      C(JB+J)=C1*(A20-B21)-S1*(B20-A21)                                 
      D(JB+J)=S1*(A20-B21)+C1*(B20-A21)                                 
      C(JF+J)=C5*(A20+B21)-S5*(B20+A21)                                 
      D(JF+J)=S5*(A20+B21)+C5*(B20+A21)                                 
C                                                                       
      I=I+INC3                                                          
      J=J+INC4                                                          
  630 CONTINUE                                                          
      IBASE=IBASE+INC1                                                  
      JBASE=JBASE+INC21                                                  
  640 CONTINUE                                                          
      IA=IA+IINK                                                        
      IB=IB+IINK                                                        
      IC=IC+IINK                                                        
      ID=ID-IINK                                                        
      IE=IE-IINK                                                        
      IF=IF-IINK                                                        
      JBASE=JBASE+JUMP                                                  
  650 CONTINUE                                                          
      ENDIF
C
      IF (IC.EQ.ID) THEN                                                
      IBASE=0                                                           
      DO 680 L=1,ILA                                                     
      I=IBASE                                                           
      J=JBASE                                                           
!OCL NOVREC                                                   
      DO 670 IJK=1,ILOT                                                  
      C(JA+J)=A(IB+I)+(A(IA+I)+A(IC+I))                                 
      C(JD+J)=B(IB+I)-(B(IA+I)+B(IC+I))                                 
      C(JB+J)=(SIN60*(A(IA+I)-A(IC+I)))-(0.5*(B(IA+I)+B(IC+I))+B(IB+I)) 
      C(JF+J)=-(SIN60*(A(IA+I)-A(IC+I)))-(0.5*(B(IA+I)+B(IC+I))+B(IB+I))
      C(JC+J)=SIN60*(B(IC+I)-B(IA+I))+(0.5*(A(IA+I)+A(IC+I))-A(IB+I))   
      C(JE+J)=SIN60*(B(IC+I)-B(IA+I))-(0.5*(A(IA+I)+A(IC+I))-A(IB+I))   
      I=I+INC3                                                          
      J=J+INC4                                                          
  670 CONTINUE                                                          
      IBASE=IBASE+INC1                                                  
      JBASE=JBASE+INC21                                                  
  680 CONTINUE                                                          
      ENDIF                                                             
C                                                                       
      ELSE                 !!! Case LA=M                                
      SSIN60=2.0*SIN60                                                  
      IF (LIPL) THEN
        DO 694 L=1,ILA                                                     
        I=IBASE                                                           
!OCL NOVREC
        DO 692 IJK=1,ILOT                                                  
        T1=(2.0*(A(IA+I)-A(ID+I))+(A(IB+I)-A(IC+I)))                 
     *    -(SSIN60*(B(IB+I)+B(IC+I)))                                   
        T5=(2.0*(A(IA+I)-A(ID+I))+(A(IB+I)-A(IC+I)))                 
     *    +(SSIN60*(B(IB+I)+B(IC+I)))                                   
        T2=(2.0*(A(IA+I)+A(ID+I))-(A(IB+I)+A(IC+I)))                 
     *    -(SSIN60*(B(IB+I)-B(IC+I)))                                   
        T4=(2.0*(A(IA+I)+A(ID+I))-(A(IB+I)+A(IC+I)))                 
     *    +(SSIN60*(B(IB+I)-B(IC+I)))                                   
        T3=(2.0*(A(IA+I)-A(ID+I)))-(2.0*(A(IB+I)-A(IC+I)))           
        A(IA+I)=(2.0*(A(IA+I)+A(ID+I)))+(2.0*(A(IB+I)+A(IC+I)))           
        A(IB+I)=T1
        B(IB+I)=T2
        A(IC+I)=T3
        B(IC+I)=T4
        A(ID+I)=T5
        I=I+INC3                                                          
  692   CONTINUE                                                          
        IBASE=IBASE+INC1                                                  
  694   CONTINUE                                                          
      ELSE
        DO 698 L=1,ILA                                                     
        I=IBASE                                                           
        J=JBASE                                                           
!OCL NOVREC
        DO 696 IJK=1,ILOT                                                  
        C(JA+J)=(2.0*(A(IA+I)+A(ID+I)))+(2.0*(A(IB+I)+A(IC+I)))           
        C(JD+J)=(2.0*(A(IA+I)-A(ID+I)))-(2.0*(A(IB+I)-A(IC+I)))           
        C(JB+J)=(2.0*(A(IA+I)-A(ID+I))+(A(IB+I)-A(IC+I)))                 
     *    -(SSIN60*(B(IB+I)+B(IC+I)))                                   
        C(JF+J)=(2.0*(A(IA+I)-A(ID+I))+(A(IB+I)-A(IC+I)))                 
     *    +(SSIN60*(B(IB+I)+B(IC+I)))                                   
        C(JC+J)=(2.0*(A(IA+I)+A(ID+I))-(A(IB+I)+A(IC+I)))                 
     *    -(SSIN60*(B(IB+I)-B(IC+I)))                                   
        C(JE+J)=(2.0*(A(IA+I)+A(ID+I))-(A(IB+I)+A(IC+I)))                 
     *    +(SSIN60*(B(IB+I)-B(IC+I)))                                   
        I=I+INC3                                                          
        J=J+INC4                                                          
  696   CONTINUE                                                          
        IBASE=IBASE+INC1                                                  
        JBASE=JBASE+INC21                                                  
  698   CONTINUE                                                          
      ENDIF
      ENDIF
C
      ELSEIF (IFAC.EQ.8) THEN
C                                                                       
C     CODING FOR FACTOR 8                                               
C     -------------------                                               
  800 CONTINUE                                                          
      IF (LA.NE.M) THEN                                            
        IBAD=3
      ELSE
      IA=1                                                              
      IB=IA+LA*INC1                                                     
      IC=IB+2*LA*INC1                                                   
      ID=IC+2*LA*INC1                                                   
      IE=ID+2*LA*INC1                                                   
      JA=1                                                              
      JB=JA+JINK                                                        
      JC=JB+JINK                                                        
      JD=JC+JINK                                                        
      JE=JD+JINK                                                        
      JF=JE+JINK                                                        
      JG=JF+JINK                                                        
      JH=JG+JINK                                                        
      SSIN45=SQRT(2.0)                                                  
C                                                                       
      IF (LIPL) THEN
        DO 820 L=1,ILA                                                     
        I=IBASE                                                           
!OCL NOVREC
        DO 810 IJK=1,ILOT                                                  
        T2=2.0*(((A(IA+I)+A(IE+I))-A(IC+I))-(B(IB+I)-B(ID+I)))       
        T6=2.0*(((A(IA+I)+A(IE+I))-A(IC+I))+(B(IB+I)-B(ID+I)))       
        T1=2.0*((A(IA+I)-A(IE+I))-B(IC+I))                           
     *    +SSIN45*((A(IB+I)-A(ID+I))-(B(IB+I)+B(ID+I)))                 
        T5=2.0*((A(IA+I)-A(IE+I))-B(IC+I))                           
     *    -SSIN45*((A(IB+I)-A(ID+I))-(B(IB+I)+B(ID+I)))                 
        T3=2.0*((A(IA+I)-A(IE+I))+B(IC+I))                           
     *    -SSIN45*((A(IB+I)-A(ID+I))+(B(IB+I)+B(ID+I)))                 
        T7=2.0*((A(IA+I)-A(IE+I))+B(IC+I))                           
     *    +SSIN45*((A(IB+I)-A(ID+I))+(B(IB+I)+B(ID+I)))                 
        T4=2.0*(((A(IA+I)+A(IE+I))+A(IC+I))-(A(IB+I)+A(ID+I)))       
        A(IA+I)=2.0*(((A(IA+I)+A(IE+I))+A(IC+I))+(A(IB+I)+A(ID+I)))       
        A(IB+I)=T1
        B(IB+I)=T2
        A(IC+I)=T3
        B(IC+I)=T4
        A(ID+I)=T5
        B(ID+I)=T6
        A(IE+I)=T7  
        I=I+INC3                                                          
  810   CONTINUE                                                          
        IBASE=IBASE+INC1                                                  
  820   CONTINUE                                                          
      ELSE
        DO 840 L=1,ILA                                                     
        I=IBASE                                                           
        J=JBASE                                                           
!OCL NOVREC
        DO 830 IJK=1,ILOT                                                  
        C(JA+J)=2.0*(((A(IA+I)+A(IE+I))+A(IC+I))+(A(IB+I)+A(ID+I)))       
        C(JE+J)=2.0*(((A(IA+I)+A(IE+I))+A(IC+I))-(A(IB+I)+A(ID+I)))       
        C(JC+J)=2.0*(((A(IA+I)+A(IE+I))-A(IC+I))-(B(IB+I)-B(ID+I)))       
        C(JG+J)=2.0*(((A(IA+I)+A(IE+I))-A(IC+I))+(B(IB+I)-B(ID+I)))       
        C(JB+J)=2.0*((A(IA+I)-A(IE+I))-B(IC+I))                           
     *    +SSIN45*((A(IB+I)-A(ID+I))-(B(IB+I)+B(ID+I)))                 
        C(JF+J)=2.0*((A(IA+I)-A(IE+I))-B(IC+I))                           
     *    -SSIN45*((A(IB+I)-A(ID+I))-(B(IB+I)+B(ID+I)))                 
        C(JD+J)=2.0*((A(IA+I)-A(IE+I))+B(IC+I))                           
     *    -SSIN45*((A(IB+I)-A(ID+I))+(B(IB+I)+B(ID+I)))                 
        C(JH+J)=2.0*((A(IA+I)-A(IE+I))+B(IC+I))                           
     *    +SSIN45*((A(IB+I)-A(ID+I))+(B(IB+I)+B(ID+I)))                 
        I=I+INC3                                                          
        J=J+INC4                                                          
  830   CONTINUE                                                          
        IBASE=IBASE+INC1                                                  
        JBASE=JBASE+INC21                                                  
  840   CONTINUE                                                          
      ENDIF
C
      ENDIF
C
      ELSE
C
      IBAD=2       !!! Illegal factor
C
      ENDIF
C                                                                       
C     RETURN                                                            
C     ------                                                            
  900 CONTINUE                                                          
      IERR=IBAD                                                         
      RETURN                                                            
      END                                                               

C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      INTEGER FUNCTION IGINT (KWEDIST, KOWE, KNSDIST, KONS, PWFACT,
     1   KPR, KERR)
C
C---->
C**** *IGINT*
C
C     PURPOSE
C     _______
C
C     Calculate the basic unnormalised interpolation weights when
C     interpolating between regular grids.
C
C     INTERFACE
C     _________
C
C     IERR = IGINT (KWEDIST, KOWE, KNSDIST, KONS, PWFACT, KPR, KERR)
C
C     Input parameters
C     ________________
C
C     KWEDIST    - This array holds the distances to longitude values
C                  in the input field from the associated longitude
C                  values in the output field. This distance is the
C                  same for every line of latitude for a regular
C                  input field.
C
C     KOWE       - The number of points in the West-East direction in
C                  the output field.
C
C     KNSDIST    - This array holds the distances to lines in input
C                  field from the associated lines of latitude in the
C                  output field. The array is dimensioned (2, KONS).
C
C     KONS       - The number of points in the North-South direction
C                  in the output field.
C
C     KPR        - The debug print switch.
C                  0  , No debugging output.
C                  1  , Produce debugging output.
C
C     KERR       - The error control flag.
C                  -ve, No error message. Return error code.
C                  0  , Hard failure with error message.
C                  +ve, Print error message. Return error code.
C
C     Output parameters
C     ________________
C
C     PWFACT     - The unnormalised array of interpolating weights to
C                  the four neighbouring points for every output point.
C
C     Return value
C     ____________
C
C     The error indicator (INTEGER).
C
C     Error and Warning Return Values
C     _______________________________
C
C     None
C
C     Common block usage
C     __________________
C
C     None
C
C     EXTERNALS
C     _________
C
C     IGINTR     - Calculate the basic unnormalised interpolation
C                  weights for one line of latitude when
C                  interpolating between regular grids.
C     INTLOG     - Logs messages.
C
C     METHOD
C     ______
C
C     The weights are evaluated as the size of the opposing rectangle.
C     It is trivial to show that this is equivalent to weighting by
C     the inverse size of the rectangle of which the input point forms
C     part.
C
C     REFERENCE
C     _________
C
C     None
C
C     COMMENTS
C     ________
C
C     Program contains sections 0 to 2 and 9
C
C     AUTHOR
C     ______
C
C     K. Fielding      *ECMWF*      Oct 1993
C
C     MODIFICATIONS
C     _____________
C
C     None
C
C----<
C     _______________________________________________________
C
C
C*    Section 0. Definition of variables.
C     _______________________________________________________
C
C*    Prefix conventions for variable names
C
C     Logical      L (but not LP), global or common.
C                  O, dummy argument
C                  G, local variable
C                  LP, parameter.
C     Character    C, global or common.
C                  H, dummy argument
C                  Y (but not YP), local variable
C                  YP, parameter.
C     Integer      M and N, global or common.
C                  K, dummy argument
C                  I, local variable
C                  J (but not JP), loop control
C                  JP, parameter.
C     REAL         A to F and Q to X, global or common.
C                  P (but not PP), dummy argument
C                  Z, local variable
C                  PP, parameter.
C
C     Implicit statement to force declarations
C
      IMPLICIT NONE
C
#include "parim.h"
C
C     Dummy arguments
      INTEGER KOWE, KONS, KPR, KERR
      INTEGER KWEDIST (2, KOWE), KNSDIST (2, KONS)
      REAL PWFACT (4, KOWE, KONS)
C
C     Local variables
      INTEGER IPR, IERR
      INTEGER JOLAT
      INTEGER JPROUTINE
      PARAMETER (JPROUTINE = 22200)
C
C     External functions
      INTEGER IGINTR
C
C     _______________________________________________________
C
C
C*    Section 1. Initialisation
C     _______________________________________________________
C
  100 CONTINUE
C
      IF (KPR.GE.1) CALL INTLOG(JP_DEBUG,'IGINT: Section 1.',JPQUIET)
C
      IGINT = 0
C
      IF (KPR .GE. 1) THEN
        CALL INTLOG(JP_DEBUG,'IGINT: Input parameters.',JPQUIET)
        CALL INTLOG(JP_DEBUG,'IGINT: No.output longitudes = ',KOWE)
        CALL INTLOG(JP_DEBUG,'IGINT: No.output latitudes = ',KONS)
      ENDIF
C
C     _______________________________________________________
C
C
C*    Section 2. Calculate arrays of weights
C     _______________________________________________________
C
  200 CONTINUE
C
      IF (KPR.GE.1) CALL INTLOG(JP_DEBUG,'IGINT: Section 2.',JPQUIET)
C
C     Main loop over latitudes
C
      IPR = KPR
C
      DO 220 JOLAT = 1, KONS
C
         IERR = IGINTR (KWEDIST, KOWE, KNSDIST (1, JOLAT),
     1      PWFACT (1, 1, JOLAT), IPR, KERR)
C
         IF (IERR .GT. 0) THEN
            IGINT = IERR
            GO TO 900
         ENDIF
C
         IPR = KPR - 1
C
  220 CONTINUE
C
C     _______________________________________________________
C
C
C*    Section 9. Return to calling routine. Format statements
C     _______________________________________________________
C
  900 CONTINUE
C
      IF (KPR.GE.1) CALL INTLOG(JP_DEBUG,'IGINT: Section 9.',JPQUIET)
C
      RETURN
      END

C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE INXBIT (KGRIB,KLENG,KNSPT,KPARM,KNUM,KBIT,
     C                   KBLEN,HFUNC,KRET)
C
C---->
C**** INXBIT - Insert/extract bits consecutively in/from a given array
C
C     Purpose.
C     --------
C
C           Take rightmost KBLEN bits from KNUM words of KPARM
C           and insert them consecutively in KGRIB, starting at
C           bit after KNSPT or vice versa.
C
C**   Interface.
C     ----------
C
C           CALL INXBIT (KGRIB,KLENG,KNSPT,KPARM,KNUM,KBIT,
C    C                   KBLEN,KRET)
C
C           Integer    K.
C           Real       P.
C           Logical    O.
C           Character  H.
C
C               Input Parameters.
C               -----------------
C
C               KGRIB      - Array containing bitstream.
C               KLENG      - Length (words) of this array.
C               KNSPT      - Bit number after which insertion or
C                            extraction starts.
C               KPARM      - Array from which bits are taken for
C                            insertion in the bitstream or to which
C                            bits are extracted from the bitstream.
C               KBIT       - Number of bits in computer word.
C               KNUM       - Number of bit fields inserted/extracted.
C               KBLEN      - Number of bits per bit field.
C               HFUNC      - Requested function.
C                            'C' to insert bits in bitstream,
C                            'D' to extract bits from bitstream.
C
C               Output Parameters.
C               ------------------
C
C               KNSPT      - Bit number of last bit inserted/extracted.
C
C               KRET       - Return code.
C                            0 , No error encountered.
C                            1 , Insertion/extraction exceeded
C                                array boundary.
C
C     Method.
C     -------
C
C           Word and offset pointer calculated before calling
C           insertion/extraction routines.
C
C     Externals.
C     ----------
C
C           SBYTES
C           GBYTES
C           GSBITE
C
C     Reference.
C     ----------
C
C           ECLIB documentation on SBYTES and GBYTES.
C
C     Comments.
C     ---------
C
C           Cray version of routine.
C           This routine should only be used on the Cray as it
C           contains a call to GSBITE, a vectorising version of
C           GBYTE(S) and SBYTE(S).
C           Routine contains Sections 0 to 3 and Section 9.
C
C     Author.
C     -------
C
C           J. Hennessy      ECMWF      18.06.91
C
C     Modifications.
C     --------------
C
C           J. Hennessy      ECMWF      08.11.91
C           Parameter KMACH removed from list of input parameters.
C
C           J. Hennessy      ECMWF      12.10.92
C           Dimension of IMASK changed from 64 to 65.
C
C     ----------------------------------------------------------------
C----<
C
C
C
C
C
C
C
C
C
C
C*    Section 0 . Definition of variables. Data statements.
C     ----------------------------------------------------------------
C
C*    Prefix conventions for variable names.
C
C     Logical      L (but not LP), global or common.
C                  O, dummy arguments.
C                  G, local variable.
C                  LP, parameter.
C     Character    C, Global or common.
C                  H, dummy arguments.
C                  Y (but not YP), local variables.
C                  YP, parameter.
C     Integer      M and N, global or common.
C                  K, dummy arguments.
C                  I, local variables.
C                  J (but not JP), loop control.
C                  JP, parameter.
C     Real         A to F and Q to X, global or common.
C                  P (but not PP), dummy arguments.
C                  Z, local variables.
C                  PP, parameter.
C
      IMPLICIT NONE
C
      INTEGER IMASK
      INTEGER IND
      INTEGER INUM
      INTEGER IOFF
      INTEGER IPR
      INTEGER IWORD
C
      INTEGER KBIT
      INTEGER KBLEN
      INTEGER KGRIB
      INTEGER KLENG
      INTEGER KNSPT
      INTEGER KNUM
      INTEGER KPARM
      INTEGER KRET
C
      INTEGER J901
C
      DIMENSION KGRIB(KLENG)
      DIMENSION KPARM(*)
      DIMENSION IMASK(65)
C
      CHARACTER*1 HFUNC
C
C     Values in IMASK are set in the first call to routine GSBITE, and
C     are used in subsequent calls.
C
      SAVE IMASK
C
C     Force routine GSBITE to calculate bit-masks first time through.
C
      DATA IMASK(2) /0/
C
C     Debug print switch.
C
      DATA IPR /0/
C
C     ----------------------------------------------------------------
C
C
C
C
C
C
C
C
C
C
C*    Section 1 . Set initial values.
C     ----------------------------------------------------------------
C
  100 CONTINUE
C
      IF (IPR.EQ.1)
     C   THEN
             WRITE (*,*) 'INXBIT : Section 1.'
             WRITE (*,*) '         Input values used -'
             WRITE (*,9009) KLENG
             WRITE (*,9002) KNSPT
             WRITE (*,9004) KBIT
             WRITE (*,9005) HFUNC
         ENDIF
C
      KRET = 0
C
C     ----------------------------------------------------------------
C
C
C
C
C
C
C
C
C
C
C*    Section 2 . Bit insertion/extraction.
C     ----------------------------------------------------------------
C
  200 CONTINUE
C
      IF (IPR.EQ.1) WRITE (*,*) 'INXBIT : Section 2.'
C
C*    Calculate word pointer and offset.
C
      IWORD = KNSPT / KBIT
      IOFF  = KNSPT - IWORD * KBIT
      IWORD = IWORD + 1
      IF (IPR.EQ.1) WRITE (*,9003) IWORD , IOFF
C
C     Insert/extract bits.
C
      IF (KNUM.GE.8)
     C   THEN
C
C            Cray vectorising routine GSBITE performs the same
C            functions as SBYTE(S) and GBYTE(S).
C
             CALL GSBITE (KGRIB(IWORD),KPARM,IOFF,KBLEN,0,KNUM,
     C                    KBIT,IMASK,HFUNC)
         ELSE
C
C            Cray scalar faster.
C
             IF (HFUNC.EQ.'C')
     C          THEN
                    CALL SBYTES (KGRIB(IWORD),KPARM,IOFF,KBLEN,0,KNUM)
                ELSE
                    CALL GBYTES (KGRIB(IWORD),KPARM,IOFF,KBLEN,0,KNUM)
                ENDIF
         ENDIF
C
C     Update pointer.
C
      KNSPT = KNSPT + KBLEN * KNUM
C
C     ----------------------------------------------------------------
C
C
C
C
C
C
C
C
C
C
C*    Section 3 . Check out of range.
C    -----------------------------------------------------------------
C
  300 CONTINUE
C
      IF (IPR.EQ.1) WRITE (*,*) 'INXBIT : Section 3.'
C
      IND = KNSPT / KBIT
      IF (IND.GT.KLENG)
     C   THEN
             KRET = 1
             WRITE (*,9001) IND , KLENG
         ENDIF
C
C     ----------------------------------------------------------------
C
C
C
C
C
C
C
C
C
C
C*    Section 9 . Return to calling routine. Format statements.
C     ----------------------------------------------------------------
C
  900 CONTINUE
C
      IF (IPR.EQ.1)
     C   THEN
             INUM = KNUM
             IF (INUM.GT.360)
     C          THEN
                    INUM = 360
                    WRITE (*,9007) INUM
                ENDIF
             DO 901 J901=1,INUM
               IF (HFUNC.EQ.'C')
     C             THEN
                       WRITE (*,9006) KPARM(J901)
                   ELSE
                       WRITE (*,9008) KPARM(J901)
                   ENDIF
  901        CONTINUE
             WRITE (*,*) 'INXBIT : Section 9.'
             WRITE (*,*) '         Output values set -'
             WRITE (*,9002) KNSPT
         ENDIF
C
C
 9001 FORMAT (1H ,'INXBIT : Word ',I8,' is outside array bounds ',I8)
C
 9002 FORMAT (1H ,'         KNSPT  = ',I8)
C
 9003 FORMAT (1H ,'INXBIT : Word is',I8,', bit offset is ',I2)
C
 9004 FORMAT (1H ,'         KBIT   = ',I8)
C
 9005 FORMAT (1H ,'         HFUNC  = ',A)
C
 9006 FORMAT (1H ,'         Inserted value = ',I20)
C
 9007 FORMAT (1H ,'         First ',I9,' values.')
C
 9008 FORMAT (1H ,'         Extracted value = ',I20)
C
 9009 FORMAT (1H ,'         KLENG  = ',I20)
C
      RETURN
C
      END
      SUBROUTINE ABORTX (HNAME)
C
C**** ABORTX - Terminates execution of program.
C
C     Purpose.
C     --------
C
C           Terminates execution of program.
C
C**   Interface.
C     ----------
C
C           CALL ABORTX (HNAME)
C
C           Integer    K.
C           Real       P.
C           Logical    O.
C           Character  H.
C
C               Input Parameters.
C               -----------------
C
C               HNAME      - Name of calling routine.
C
C               Output Parameters.
C               ------------------
C
C               None.
C
C     Method.
C     -------
C
C           Prints message and terminates.
C
C     Externals.
C     ----------
C
C           ABORT
C
C     Reference.
C     ----------
C
C           None.
C
C     Comments.
C     ---------
C
C           Cray version of routine.
C           Routine contains Sections 0 to 1 and Section 9.
C
C     Author.
C     -------
C
C           J. Hennessy      ECMWF      13.11.91
C
C     Modifications.
C     --------------
C
C           None.
C
C     ------------------------------------------------------------------
C
C
C
C
C
C
C
C
C
C
C*    Section 0 . Definition of variables.
C     ------------------------------------------------------------------
C
C*    Prefix conventions for variable names.
C
C     Logical      L (but not LP), global or common.
C                  O, dummy arguments.
C                  G, local variable.
C                  LP, parameter.
C     Character    C, Global or common.
C                  H, dummy arguments.
C                  Y (but not YP), local variables.
C                  YP, parameter.
C     Integer      M and N, global or common.
C                  K, dummy arguments.
C                  I, local variables.
C                  J (but not JP), loop control.
C                  JP, parameter.
C     Real         A to F and Q to X, global or common.
C                  P (but not PP), dummy arguments.
C                  Z, local variables.
C                  PP, parameter.
C
      IMPLICIT NONE
C
      CHARACTER*(*) HNAME
C
C     ------------------------------------------------------------------
C
C
C
C
C
C
C
C
C
C
C*    Section 1 . Print message and terminate.
C     ------------------------------------------------------------------
C
  100 CONTINUE
C
      WRITE (*,9001) HNAME
C
      CALL ABORT
C
C     ------------------------------------------------------------------
C
C
C
C
C
C
C
C
C
C*    Section 9 . Format statements.
C     ------------------------------------------------------------------
C
  900 CONTINUE
C
 9001 FORMAT (1H ,'ABORTX : Routine ',A,' has requested program',
     C               ' termination.')
C
      RETURN
C
      END
      SUBROUTINE SETPAR (KBIT,KNEG,KPR)
C
C**** SETPAR - Set number of bits in word. Set maximum negative integer.
C
C     Purpose.
C     --------
C
C           Set number of bits in word. Set maximum negative integer.
C
C**   Interface.
C     ----------
C
C           CALL SETPAR (KBIT,KNEG,KPR)
C
C           Integer    K.
C           Real       P.
C           Logical    O.
C           Character  H.
C
C               Input Parameters.
C               -----------------
C
C               KPR        - Debug print switch.
C                            1 , print out.
C                            0 , No print out.
C
C               Output Parameters.
C               ------------------
C
C               KBIT       - Number of bits in computer word.
C
C               KNEG       - Maximum negative integer.
C
C     Method.
C     -------
C
C           Values are assigned.
C
C     Externals.
C     ----------
C
C           None.
C
C     Reference.
C     ----------
C
C           None.
C
C     Comments.
C     ---------
C
C           Cray version of routine.
C           Routine contains Sections 0 to 3 and Section 9.
C
C     Author.
C     -------
C
C           J. Hennessy      ECMWF      28.10.91
C
C     Modifications.
C     --------------
C
C           None.
C
C     ------------------------------------------------------------------
C
C
C
C
C
C
C
C
C
C
C*    Section 0 . Definition of variables. Data statements.
C     ------------------------------------------------------------------
C
C*    Prefix conventions for variable names.
C
C     Logical      L (but not LP), global or common.
C                  O, dummy arguments.
C                  G, local variable.
C                  LP, parameter.
C     Character    C, Global or common.
C                  H, dummy arguments.
C                  Y (but not YP), local variables.
C                  YP, parameter.
C     Integer      M and N, global or common.
C                  K, dummy arguments.
C                  I, local variables.
C                  J (but not JP), loop control.
C                  JP, parameter.
C     Real         A to F and Q to X, global or common.
C                  P (but not PP), dummy arguments.
C                  Z, local variables.
C                  PP, parameter.
C
      IMPLICIT NONE
C
      INTEGER KBIT
      INTEGER KNEG
      INTEGER KPR
C
C     ------------------------------------------------------------------
C
C
C
C
C
C
C
C
C
C
C*    Section 1 . Assign values.
C     ------------------------------------------------------------------
C
  100 CONTINUE
C
      IF (KPR.EQ.1)  WRITE (*,*) ' SETPAR : Section 1.'
C
      KBIT = 64
      KNEG = -9223372036854775807
C
C     ------------------------------------------------------------------
C
C
C
C
C
C
C
C
C
C*    Section 9 . Return to calling routine. Format statements.
C     ------------------------------------------------------------------
C
  900 CONTINUE
C
      IF (KPR.EQ.1)
     C   THEN
             WRITE (*,*) ' SETPAR : Section 9.'
             WRITE (*,*) '          Output values set -'
             WRITE (*,9001) KBIT
             WRITE (*,9002) KNEG
         ENDIF
C
 9001 FORMAT (1H ,'          KBIT = ',I3)
C
 9002 FORMAT (1H ,'          KNEG = ',I22)
C
      RETURN
C
      END
      SUBROUTINE GSBITE (KS,KD,KSKST,KSIZE,KSKBTW,K,KBPW,KMASK,HADIR)
C
C**** GSBITE - Extraction/insertion of bits from/to bitstream on Cray.
C
C     Purpose.
C     --------
C
C           Vectorising extraction/insertion of bits from/to bitstream.
C
C**   Interface.
C     ----------
C
C           CALL GSBITE (KS,KD,KSKST,KSIZE,KSKBTW,K,KBPW,KMASK,HADIR)
C
C           Integer    K.
C           Real       P.
C           Logical    O.
C           Character  H.
C
C               Input Parameters.
C               -----------------
C
C               KS      - If HADIR='D', input bit stream, else output
C                         bit stream.
C               KD      - If HADIR='D', output words, else input words.
C               KSKST   - Number of bits skipped at beginning of KS.
C               KSIZE   - Number of bits to be extracted to one word
C                         of KD.
C               KSKBTW  - Number of bits skipped between two words to
C                         be extracted.
C               K       - Number of words to be extracted into KD. If
C                         less than or equal to 0 only calculate KBPW
C                         and KMASK.
C               KBPW    - Number of bits per word in KS,calculated if 0.
C               KMASK   - Masks for bit patterns, calculated if
C                         KMASK(2) is 0.
C               HADIR   - Direction of conversion: 'D' for decoding, ie
C                         extract words KD(1...K) from bits
C                         KS(KSKST+1....)
C                         If not 'D', encode, i.e. pack words
C                         KD(1....K) into bits
C                         KS(KSKST+1.....KSKST+K*(KSIZE+KSKBTW))
C
C               Output Parameters.
C               ------------------
C
C               KS,KD   - See above.
C               KSKST   - Updated to number of bits used, i.e. to
C                         KSKST+K*(KSIZE+KSKBTW)
C               KBPW    - If 0 on input, number of bits in each word
C                         of KS.
C               KMASK   - If KMASK(2) was 0 on input, bit pattern masks.
C
C     Method.
C     -------
C
C           Vector loop is over repeatedly occurring bit patterns.
C
C     Externals.
C     ----------
C
C           None.
C
C     Reference.
C     ----------
C
C           None.
C
C     Comments.
C     ---------
C
C           This routine is for the Cray only.
C           Variable names do not conform to the standard.
C
C     Author.
C     -------
C
C           G.J.Cats 08 Dec 87
C
C     Modifications.
C     --------------
C
C           J. Hennessy     ECMWF     09.09.91
C           Introductory comments changed to conform to standard.
C
C     ------------------------------------------------------------------
C
      DIMENSION KS(*),KD(*),KMASK(*)
      CHARACTER*1 HADIR
C
C     STATEMENT FUNCTIONS TO MANIPULATE BITS IN WORDS OF 64 BITS
C
C     DATA ONES/7777777777777777B/
C     DATA OOOS/0B/
C
C     1.  SINGLE BIT MANIPULATIONS
C
C     1.1 SET BIT KBIT IN WORD PW
C
      IBSET(KW,KBIT)=OR(KW,SHIFT(1B,KBIT))
C
C     2.  WORD MANIPULATIONS, BIT BY BIT
C
C     2.1 ARE WORDS PW1 AND PW2 EQUAL?
C
C      LOGICAL NLEQAL
C     NLEQAL(PW1,PW2)=(PW1.XOR.PW2).EQ.0B
C
C     2.2 BITWISE AND AND OR
C
      IAND(K1,K2)=AND(K1,K2)
      IOR (K1,K2)= OR(K1,K2)
C
C     2.3 BITWISE NEGATION
C
      NOT(K)=COMPL(K)
C
C     2.4 SHIFT (LEFT FOR KSH POSITIVE, RIGHT FOR KSH NEGATIVE
C
      ISHFT(K,KSH)=CVMGP(SHIFTL(K,KSH),SHIFTR(K,-KSH),KSH)
C
C     3.  SPECIAL PURPOSE
C
C     3.1 TAKE 4 LAST BITS OF KW, PUT THEM IN PW AT POS K*4-1
C
C     SETLEV(PW,KW,K)=OR(AND(PW,SHIFT(0B.EQV.17B,K*4-4)),
C    +SHIFT(AND(17B,KW),K*4-4))
C
C     3.2 EXTRACT FIELD [K*4-1:4] FROM PW
C
C     MGTLEV(PW,K)=AND(17B,SHIFT(PW,68-K*4))
C
C     1.  COMPLETE KBPW AND KMASK, RETURN IF 0 WORDS ARE TO BE EXTRACTED
C
      IF(KBPW.EQ.0)THEN
         IS=KS(1)
         KS(1)=1
 1101    CONTINUE
         IF(KS(1).NE.0)THEN
            KBPW=KBPW+1
            KS(1)=ISHFT(KS(1),1)
            GOTO 1101
         ENDIF
         KS(1)=IS
      ENDIF
      IF(KMASK(2).EQ.0)THEN
         KMASK(KBPW+1)=0
         DO 1110 J=KBPW,1,-1
         KMASK(J)=IBSET(KMASK(J+1),KBPW-J)
 1110    CONTINUE
      ENDIF
      IF(K.LE.0)RETURN
C
C     2.  PRESET KD TO 0 IF KD IS OUTPUT I.E. WHEN DECODING
C
      IF(HADIR.EQ.'D')THEN
         DO 2101 J=1,K
         KD(J)=0
 2101    CONTINUE
      ENDIF
C
C     3.  CALCULATE SEVERAL PARAMETERS FOR LOOPING (FOR EFFICIENCY, THE
C         CODE OF SECTIONS 3.3 AND 3.4 FOR K=1 IS SEPARATED INTO 3.2)
C
C     3.1 NUMBER OF BITS USED PER WORD, INITIAL NR OF SKIPPED BITS
C
      ISTEP=KSIZE+KSKBTW
      ISKWS=KSKST
C
C     3.2 VECTOR LOOP LENGTH AND STEP SIZE IN KD IF K=1;KS STEP IRRELVNT
C
      IF(K.EQ.1)THEN
         ILL=1
         IBDL=2
         ISTD=1
      ELSE
C
C     3.3 STEP SIZES IN KS,KD: INVERSE OF LARGEST FACTOR OF ISTEP,KBPW
C
         ILCF=KBPW
         ISHF=ISTEP
 331     CONTINUE
         IF(ILCF.EQ.ISHF)GOTO 332
         IF(ILCF.EQ.1)GOTO 332
         IF(ILCF.GT.ISHF)THEN
            ILCF=ILCF-ISHF
         ELSE
            ISHF=ISHF-ILCF
         ENDIF
         GOTO 331
 332     CONTINUE
         ISTD=KBPW/ILCF
         ISTS=ISTEP/ILCF
C
C     3.4 VECTOR LOOP LENGTH AND SWITCH-OVER POINT FOR SMALLER LOOP
C
         ILL=(K-1)/ISTD+1
         IBDL=K-(ILL-1)*ISTD
      ENDIF
C
C     4.  LOOP OVER FIRST ISTD WORDS OF KD (TRAILS THE VECTOR LOOP)
C
      DO 790 JBD=1,ISTD
C
C     4.1 LAST BIT IN KS TO BE TREATED
C
      IENBS=ISKWS+KSIZE
C
C     4.2 NR OF WORDS OF KS TO BE SKIPPED, NR OF BITS IN THOSE AND THIS
C
      ISKW=ISKWS/KBPW
      ISTA=ISKW*KBPW
      ISKB=ISKWS-ISTA
C
C     4.3 MASK AND LEFT SHIFT FOR THE REMAINING BITS
C
      IMASK=KMASK(ISKB+1)
      ISH=KSIZE+ISKB
C
C     4.4 POSITION OF CURRENT WORD OF KS
C
      IBS=ISKW+1
C
C     5.  LOOP OVER WORDS OF KS CONTRIBUTING TO ONE WORD OF KD
C
 500  CONTINUE
C
C     5.1 UPDATE SHIFT AND LAST BIT IN CURRENT WORD
C
      ISH=ISH-KBPW
      IEND=ISTA+KBPW
C
C     5.2 IS LAST BIT OF CURRENT WORD OUTSIDE RANGE TO BE EXTRACTED
C
      IF(IEND.GT.IENBS)THEN
         ISH=IENBS-IEND
         IMASK=IAND(IMASK,NOT(KMASK(KBPW+ISH+1)))
      ENDIF
C
C     5.3 INITIAL OFFSETS FOR VECTOR ELEMENTS IN VECTOR LOOP
C
      IOS=0
      IOD=0
C
C     6.  VECTOR LOOP IS OVER REPEATEDLY OCCURRING BITPATTERNS/MASKS
C
      IF(HADIR.EQ.'D')THEN
CDIR$ IVDEP
         DO 611 JI=1,ILL
         KD(JBD+IOD)=IOR(KD(JBD+IOD),ISHFT(IAND(IMASK,KS(IBS+IOS)),ISH))
         IOD=IOD+ISTD
         IOS=IOS+ISTS
 611     CONTINUE
      ELSE
CDIR$ IVDEP
         DO 612 JI=1,ILL
         KS(IBS+IOS)=IOR(
     +   IAND(      KS(IBS+IOS),      NOT(IMASK)),
     +   IAND(ISHFT(KD(JBD+IOD),-ISH),    IMASK ))
         IOD=IOD+ISTD
         IOS=IOS+ISTS
 612     CONTINUE
      ENDIF
C
C     7.  END LOOPS
C
C     7.1 PREPARE FOR END OF LOOP OVER WORDS OF KS WITIHN ONE KD WORD
C
      ISTA=ISTA+KBPW
C
C     7.2 NEXT WORD OF KD IF EXTRACTION NOT COMPLETED
C
      IF(ISTA.LT.IENBS)THEN
         IMASK=KMASK(1)
         IBS=IBS+1
         GOTO 500
      ENDIF
C
C     7.8 PREPARE FOR END OF LOOP OVER FIRST WORDS OF KD
C
      IF(JBD.EQ.IBDL)ILL=ILL-1
      ISKWS=ISKWS+ISTEP
C
C     7.9 END LOOP OVER FIRST WORDS OF KD
C
 790  CONTINUE
C
C     8.  FINISHED: UPDATE KSKST AND RETURN
C
      KSKST=KSKST+K*ISTEP
C
      RETURN
      END
      SUBROUTINE GBYTE  (SOURCE,DEST,IOFSET,IBYTSZ)
C
C**** GBYTE  - Extract a single bit field. Cray routine.
C
C*    FUNCTION: GET A SINGLE BIT FIELD FROM SOURCE INTO DEST
C*
C*    INPUT   : SOURCE(1)= WORD CONTAINING START OF BIT FIELD
C*              DEST     = TARGET WORD
C*              IOFSET   = OFFSET IN BITS FOR START OF THE FIELD
C*              IBYTSZ   = LENGTH OF FIELD IN BITS
C*
C*    OUTPUT  : SOURCE,IOFSET,IBYTSZ UNCHANGED
C*              DEST CONTAINS FIELD RIGHT JUSTIFIED
C*
C*    AUTHOR  : M.MIQUEU   08/1981 (REWRITTEN FROM J.MARTELLET'S)
C*
      PARAMETER(NBPW=64)
      INTEGER SOURCE(1),DEST
      INTEGER SH1
      SH1=IOFSET+IBYTSZ-NBPW

      IF(SH1.GT.0) GO TO 2


C     BYTES DO NOT SPAN WORDS


      SH1=NBPW+SH1


      DEST=AND(
     1          SHIFT(SOURCE(1),SH1),
     2          SHIFT(MASK(IBYTSZ),IBYTSZ)
     3        )

      RETURN

C     BYTE SPANS WORDS

2     CONTINUE


      DEST=OR(
     1        SHIFT(
     2              AND(SOURCE(1),COMPL(MASK(IOFSET)))
     3              ,SH1),
     4        SHIFT(
     5              AND(SOURCE(2),MASK(SH1))
     6              ,SH1)
     7       )



      RETURN
      END
      SUBROUTINE GBYTES (S,D,ISKIP1,IBSIZ,ISKIP2,NBYTES,KWOFF)
C
C**** GBYTES - Extract a number of bit fields. Cray routine.
C
C S CONTAINS A BIT STRING OF INDEFINITE LENGTH. GBYTES WILL
C EXTRACT NBYTES BITSTRINGS, IBSIZ BITS LONG, AND STORE THEM
C RIGHT JUSTIFIED 0 FILL, INTO SUCCESSIVE WORDS OF D. THE
C SUCCESSIVE BITSTRINGS START AT BIT POSITIONS
C     ISKIP1+1+(IBYTE-1)*(IBSIZ+ISKIP2)
C IN THE BIT STRING S. I.E. SKIP ISKIP1 BITS AT THE START,
C AND ISKIP2 BITS BETWEEN THE EXTRACTED STRINGS.
C BIT ISKP+1 IN A STRING IS FOUND IN WORD IS=1+ISKIP/NBPW IN S,
C WHERE NBPW IS THE NUMBER OF BITS PER WORD. THE STARTING BIT
C IS FOUND BY SKIPPING MOD(ISKP,NBPW) BITS IN THAT WORD.
C KWOFF IS AN OPTIONAL 7TH PARAMETER, WHICH DEFAULTS TO 0
C IF PRESENT KWOFF BITS ARE TOTALLY IGNORED AT THE START OF A WORD
C THUS IF A PACKED CYBER BIT STRING IS TRANSFERRED TO THE
C CRAY, WITH EACH 60 BIT CYBER WORD PLACED AT THE RIGHT END OF
C A 64 BIT CRAY WORD, A BYTE SEQUENCE WHICH WAS ORIGINALLY
C LOCATED WITH START POINTS IN ARITHMETIC PROGRESSION ON THE
C CYBER, WILL NO LONGER HAVE THIS PROPERTY ON THE CRAY. BY
C USING THE ROUTINE WITH KWOFF=4, THE ELEMENTS OF THE BYTE
C SEQUENCE CAN BE EXTRACTED ON THE CRAY, USING THE SAME SKIPS
C AS WERE USED ON THE CYBER.
C
      PARAMETER(NBPW=64)
      DIMENSION S(2) , D(NBYTES)
      INTEGER SH1
      IGNORE = 0
      IF(NUMARG().GT.6) IGNORE = KWOFF
      IS=1+ISKIP1/(NBPW-IGNORE)
      ISKIP = MOD(ISKIP1,NBPW-IGNORE) + IGNORE
      ISTEP = ISKIP2+IBSIZ
      DO 75 IBYTE = 1 , NBYTES
C WITH THE STARTING WORD AND BIT POSITION DETERMINED, THE
C DESIRED EXTRACTION CAN BE DONE BY
C***     CALL GBYTE(S(IS),D(IBYTE),ISKIP,IBSIZ)
C BUT SINCE THE CODE IS SHORT IT IS INSERTED IN-LINE.
         SH1 = ISKIP+IBSIZ
         IF(SH1.GT.NBPW) GO TO 50
C BYTE COMES FROM 1 WORD OF S
         D(IBYTE) = AND( SHIFT(S(IS),SH1),SHIFT(MASK(IBSIZ),IBSIZ))
         GO TO 65
   50    CONTINUE
         SH1 =SH1-NBPW
C BYTE COMES FROM 2 WORDS OF S.
         D(IBYTE) = OR(SHIFT(AND(S(IS),COMPL(MASK(ISKIP))),SH1)
     1                           ,
     2                SHIFT(AND(SHIFT(S(IS+1),IGNORE),MASK(SH1)),SH1)
     3                 )
   65    CONTINUE
C UPDATE STARTING WORD AND BIT POSITION
         ISKIP = ISKIP+ISTEP
         IF(ISKIP.LT.NBPW) GO TO 75
         ISKIP =ISKIP-NBPW
         IS = IS+1+ISKIP/(NBPW-IGNORE)
         ISKIP = MOD(ISKIP,NBPW-IGNORE) + IGNORE
   75 CONTINUE
      RETURN
      END
      SUBROUTINE SBYTE  (DEST,SOURCE,IOFSET,IBYTSZ)
C
C**** SBYTE  - Insert a single bit field. Cray routine.
C
C*    FUNCTION: STORE A SINGLE BIT FIELD FROM SOURCE INTO DEST
C*
C*    INPUT   : SOURCE   = WORD CONTAINING  BIT FIELD RIGHT JUSTIFIED
C*              DEST(1)  = 1ST TARGET WORD
C*              IOFSET   = OFFSET IN BITS FOR START OF THE FIELD
C*              IBYTSZ   = LENGTH OF FIELD IN BITS ; .LE.WORD SIZE .....
C*
C*    OUTPUT  : SOURCE,IOFSET,IBYTSZ UNCHANGED
C*              DEST(1) AND EVENTUALLY DEST(2) CONTAIN FIELD
C*
C*    AUTHOR  : M.MIQUEU   08/1981 (REWRITTEN FROM J.MARTELLET'S)
C*
      PARAMETER(NBPW=64)
      INTEGER SOURCE,DEST(1)
      INTEGER SH1,SH2,SH3
      SH1=IOFSET+IBYTSZ
      IF(SH1.GT.NBPW) GO TO 2

      SH2=NBPW-SH1
      IF(SH2.LT.0) SH2=NBPW-SH2

C     BYTE  DOES NOT SPAN WORDS


      DEST(1)=SHIFT(
     1              OR(
     2                 AND(SHIFT(DEST(1),SH1),
     3                     SHIFT(COMPL(MASK(IBYTSZ)),IBYTSZ) )
     4                 ,
     5                 AND(SOURCE,
     6                     COMPL(SHIFT(COMPL(MASK(IBYTSZ)),IBYTSZ)) )
     7                 )
     8              ,SH2)



      RETURN

2     CONTINUE

C     BYTE SPANS 2 WORDS

      SH3=2*NBPW-SH1


      DEST(1)=OR(
     1           AND(DEST(1),MASK(IOFSET))
     2           ,
     3           AND(SHIFT(SOURCE,SH3) , COMPL(MASK(IOFSET)) )
     4           )

      DEST(2)=OR(
     1           AND(DEST(2) , COMPL(MASK(SH1-NBPW)) )
     2           ,
     3           SHIFT( AND(SOURCE , COMPL(MASK(SH3)) ) ,SH3)
     4           )



      RETURN
      END
      SUBROUTINE SBYTES (D,S,ISKIP1,IBSIZ,ISKIP2,NBYTES,KWOFF)
C
C**** SBYTES - Insert a number of bit fields. Cray routine.
C
C REVERSES THE ACTION OF GBYTES, TAKING FIELDS FROM S AND
C INSERTING THEM INTO A BIT STRING IN D. SEE GBYTES.
C AUTHOR D. ROBERTSON  AUG,1981
C
      PARAMETER(NBPW=64)
      DIMENSION D(2) , S(NBYTES)
      INTEGER SH1,SH2,SH3
      IGNORE = 0
      IF(NUMARG().GT.6) IGNORE = KWOFF
      ID=1+ISKIP1/(NBPW-IGNORE)
      ISKIP = MOD(ISKIP1,NBPW-IGNORE) + IGNORE
      ISTEP = ISKIP2+IBSIZ
      DO 75 IBYTE = 1 , NBYTES
C WITH THE STARTING WORD AND BIT POSITION KNOWN, THE
C DESIRED INSERTION CAN BE DONE BY
C**      CALL SBYTE(D(ID),S(IBYTE),ISKIP,IBSIZ)
C BUT THE CODE IS SHORT ENOUGH TO GO IN-LINE.
         SH1 = ISKIP+IBSIZ
         IF(SH1.GT.NBPW) GO TO 50
         SH2 = NBPW-SH1
         IF(SH2.LT.0) SH2 = NBPW-SH2
C BYTE GOES INTO 1 WORD OF D.
         D(ID) = SHIFT(OR(AND(SHIFT(D(ID),SH1),MASK(NBPW-IBSIZ)),
     1                   AND(S(IBYTE),SHIFT(MASK(IBSIZ),IBSIZ))),SH2)
         GO TO 65
   50    CONTINUE
C BYTE GOES INTO 2 WORDS OF D.
         SH3 = 2*NBPW-SH1
         D(ID)=OR(AND(D(ID),MASK(ISKIP)),
     1               AND(SHIFT(S(IBYTE),SH3),COMPL(MASK(ISKIP))))
         D(ID+1)=OR(AND(D(ID+1),SHIFT(COMPL(MASK(SH1-NBPW)),NBPW-IGNORE)
     1                 ),
     2              SHIFT(AND(S(IBYTE),COMPL(MASK(SH3))),SH3-IGNORE))
   65    CONTINUE
C UPDATE STARTING WORD AND BIT POSITION
         ISKIP = ISKIP+ISTEP
         IF(ISKIP.LT.NBPW) GO TO 75
         ISKIP = ISKIP - NBPW
         ID = ID+1+ISKIP/(NBPW-IGNORE)
         ISKIP = MOD(ISKIP,NBPW-IGNORE) + IGNORE
   75    CONTINUE
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE CREXOPER(KPT,KDLEN,KDATA,KJ,KDD,KSTACK,KERR)
C
C
C**** *CREXOPER*
C
C
C     PURPOSE.
C     --------
C
C          PROCESS BUFR OPERATOR.
C
C**   INTERFACE.
C     ----------
C
C          *CALL* *CREXOPER(KPT,KDLEN,KDATA,KJ,KDD,KSTACK,KERR)*
C
C        INPUT :
C               *KPT*    - POINTER TO KDATA ARRAY
C               *KDLEN*  - DIMENSION OF KDATA ARRAY
C               *KDATA*  - ARRAY CONTAINING DATA NEEDED FOR DESCRIPTOR
C                          EXPANSION
C               *KJ*     - POINTER T ARRAY KSTACK
C               *KDD*    - DATA DESCRIPTOR
C        OUTPUT:
C               *KSTACK* - LIST OF DESCRIPTORS
C               *KERR*   - RETURN ERROR CODE
C
C     *METHOD.
C      -------
C
C          NONE.
C
C
C     EXTERNALS.
C     ----------
C
C
C     REFERENCE.
C     ----------
C
C          NONE.
C
C     AUTHOR.
C     -------
C
C          M. DRAGOSAVAC    *ECMWF*       01/02/91.
C
C
C     MODIFICATIONS.
C     --------------
C
C          NONE.
C
C
      IMPLICIT LOGICAL(L,O,G), CHARACTER*8(C,H,Y)
C
C
      PARAMETER(JSUP =   9,JSEC0=   3,JSEC1= 40,JSEC2= 64 ,JSEC3=    4,
     1          JSEC4=2,JELEM=40000,JSUBS=400,JCVAL=150 ,JBUFL=40000,
     2          JBPW =  32,JTAB =3000,JCTAB=120,JCTST=1800,JCTEXT= 200,
     3          JWORK=360000,JKEY=46)
C
C
      COMMON /CRWORK/ NBPT,NGS,NVIND,NBPTSEC2,RVIND,EPS,NE,IEOLD,
     1                  NC07YYY

C
      COMMON /CRWT/ NCREXDWINC,NCREXSCAM,NCREXAFDW,NCREXWT ,ODREPF,
     2             NCREXSTACK(JELEM),NCREXWTEN(JELEM),
     3             NCREXWTR (JELEM),NCREXWTS (JELEM),
     4             NCREXWTDW(JELEM)
C
C             NCREXDWINC   -  data width increment
C             NCREXSCAM    -  scale multiplier
C             NCREXAFDW    -  augmented field data width
C             NCREXWT      -  pointer to working table
C             NCREXSTACK   -  list of data descriptors
C             ODREPF   -  replication (logical)
C             NCREXWTR     -  working table reference
C             NCREXWTS     -  working scale
C             NCREXWTDW    -  working data width
C
      CHARACTER CREXWTEN*64,CREXWTU*24
C
      COMMON /CRWTC/ CREXWTEN(JELEM),CREXWTU(JELEM)
C
C             CREXWTEN    -  working table element naame
C             CREXWTU     -  working table units
C
C
C
      COMMON /CRBEF / M,MM,N,JCV
C
C             M       -  Number of elements
C             MM      -  Number of elements
C             N       -  Number of data sub_sets
C             JCV     -  Number of character values

C
C
      REAL*8 RVIND
      REAL*8 EPS
C
      DIMENSION KSTACK(*)
      DIMENSION KDATA(KDLEN)
C
C     ------------------------------------------------------------------
C
C*          1.   DETERMINE *F *X AND *Y.
C                -----------------------
 100  CONTINUE
C
      IF( KERR.NE.0 ) RETURN
C
      IF  = KDD / 100000
      IDIF= KDD - IF * 100000
      IX  = IDIF / 1000
      IY  = IDIF - IX * 1000
C
      IF( IF.NE.2 ) THEN
         KERR=21
         WRITE(*,*)  ' CREXOPER :'
         CALL CREXERR(KERR)
         GO TO 400
      END IF
C
C*          1.1   CHANGE DATA WIDTH ?
C                 -------------------
 110  CONTINUE
C
      IF(IX.EQ.1) THEN
         NCREXDWINC= IY
         GO TO 400
      END IF
C
C*          1.2   CHANGE SCALE ?
C                 --------------
 120  CONTINUE
C
      IF(IX.EQ.2) THEN
C
C
C*          1.2.1  UPDATE SCALE MULTIPLIER.
C                  ------------------------
C
         IF(IY.GT.900) IY=-(IY-900)
         NCREXSCAM=IY
         GO TO 400
      END IF
C
C
C*          1.4   ADD ASSOCIATED FIELD ?
C                 ----------------------
 140  CONTINUE
C
      IF(IX.EQ.4) THEN
C
C*          1.4.1   UPDATE ASSOCIATED FIELD WIDTH.
C                   ------------------------------
         NCREXAFDW= IY
         GO TO 400
      END IF
C
C*          1.5   SIGNIFY CHARACTER ?
C                 -------------------
 150  CONTINUE
C
      IF(IX.EQ.5) THEN
C
C*          1.5.1  ADD SPECIAL ENTRY TO WORKING TABLE.
C                  -----------------------------------
         NCREXWT = NCREXWT + 1
         CREXWTEN(NCREXWT)='CHARACTERS'
         CREXWTU(NCREXWT)=' '
         NCREXWTR (NCREXWT)= kdd
         NCREXWTDW(NCREXWT)= IY
         NCREXWTEN(NCREXWT)=658367
         NCREXWTS (NCREXWT)=0
         GO TO 400
      END IF
C
C
C*          1.6    CHANGE UNIT
C                 ------------
 160  CONTINUE
C
      IF(IX.EQ.7) THEN
C
         IERR=0
         CALL GET_UNITS(IY,IERR)
         IF(IERR.EQ.0) THEN
            NC07YYY=IY
         END IF
C
         GO TO 400
C
      END IF
C
C     ------------------------------------------------------------------
C
 300  CONTINUE
C
      KERR=22
      WRITE(*,*)  'CREXOPER:'
      CALL CREXERR(KERR)
C
C     ------------------------------------------------------------------
C
 400  CONTINUE
C
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities
C granted to it by virtue of its status as an intergovernmental organisation
C nor does it submit to any jurisdiction.
C

      INTEGER FUNCTION HLL2LLW(L12PNT,OLDFLDU,OLDFLDV,
     X                         OLDGRID,AREA,POLE,GRID,
     X                         NEWFLDU,NEWFLDV,KSIZE,NLON,NLAT)
C
C---->
C**** HLL2LLW
C
C     Purpose
C     -------
C
C     This routine creates rotated U and V regular lat/long fields from
C     U and V global regular lat/long field using 12-point horizontal
C     interpolation.
C
C
C     Interface
C     ---------
C
C     IRET = HLL2LLW(L12PNT,OLDFLDU,OLDFLDV,
C    X               OLDGRID,AREA,POLE,GRID,
C    X               NEWFLDU,NEWFLDV,KSIZE,
C    X               NLON,NLAT)
C
C
C     Input parameters
C     ----------------
C
C     L12PNT  - Chooses between 12-point and 4-point interpolation
C     OLDFLDU - Array of values from the old global lat/long U field
C     OLDFLDV - Array of values from the old global lat/long V field
C     OLDGRID - Grid increments (i/j) for the old global lat/long field
C     AREA    - Limits of area (N/W/S/E) for the new lat/long fields
C     POLE    - Pole of rotation (lat/long) for the new lat/long fields
C     GRID    - Grid increments (i/j) for the new lat/long fields
C     KSIZE   - The size of the array to fill with the new
C               lat/long fields
C
C
C     Output parameters
C     -----------------
C
C     NEWFLDU - The array of values for the new U lat/long field
C     NEWFLDV - The array of values for the new V lat/long field
C     NLON    - Number of longitudes in the regular lat/long fields
C     NLAT    - Number of latitudes in the regular lat/long fields
C
C     Returns 0 if function successful, non-zero otherwise.
C
C     Common block usage
C     ------------------
C
C     None
C
C
C     Method
C     ------
C
C     Numbering of the points (I is the interpolation point):
C
C                   13       5       6      14
C
C                    7       1       2       8
C                               (I)
C                    9       3       4      10
C
C                   15      11      12      16
C
C     The 12-point interpolation is not possible if either of the top
C     two rows is above the original field northern latitude. The
C     nearest neighbour is used if both rows are above, and a 4-pt
C     bilinear interpolation is used if the top row is above.
C     Similarily, if either of the bottom two rows is below the original
C     field southern latitude.
C
C
C     Externals
C     ---------
C
C     INTLOG  - Log error message.
C     JMALLOC - Dynamically allocate memory
C     JFREE   - Free dynamically allocated memory
C     HGENLL  - Calculates original lat/long (before rotation) for
C               a rotated grid
C     HNEILL  - Finds neighbours for points for interpolation
C     HWTSLL  - Calculates weightings for points for interpolation
C
C
C     Reference
C     ---------
C
C     None.
C
C
C     Comments
C     --------
C
C     None.
C
C
C     Author
C     ------
C
C     J.D.Chambers      ECMWF      December 2001
C
C
C     Modifications
C     -------------
C
C     None.
C
C----<
C     -----------------------------------------------------------------|
C*    Section 0. Definition of variables.
C     -----------------------------------------------------------------|
C
      IMPLICIT NONE
C
#include "parim.h"
#include "nofld.common"
C
C     Parameters
C
      INTEGER JNORTH, JSOUTH, JWEST, JEAST, JW_E, JN_S, JLAT, JLON
      INTEGER JP12PT, JP4PT, JPNEARN
      PARAMETER (JP12PT  = 0)
      PARAMETER (JP4PT   = 1)
      PARAMETER (JPNEARN = 2)
      PARAMETER (JNORTH = 1 )
      PARAMETER (JWEST  = 2 )
      PARAMETER (JSOUTH = 3 )
      PARAMETER (JEAST  = 4 )
      PARAMETER (JW_E  = 1 )
      PARAMETER (JN_S  = 2 )
      PARAMETER (JLAT  = 1 )
      PARAMETER (JLON  = 2 )
C
C     Function arguments
C
      LOGICAL L12PNT
      INTEGER KSIZE, NLON, NLAT
      REAL OLDGRID(2),AREA(4),POLE(2),GRID(2)
      REAL OLDFLDU(*),OLDFLDV(*),NEWFLDU(KSIZE),NEWFLDV(KSIZE)
C
C     Local variables
C
      INTEGER NEXT, LOOP, IRET, NLEN, NPREV, NBYTES, NUMBER
      INTEGER NOLDLAT, NOLDLON
C
      LOGICAL LNEW, LFIRST
      INTEGER KSCHEME(1),NEIGH(12,1), KLA(1)
      REAL PWTS(12,1)
      POINTER (IPKSCHE, KSCHEME)
      POINTER (IPNEIGH, NEIGH)
      POINTER (IPKLA,   KLA)
      POINTER (IPPWTS,  PWTS)
C
      REAL PDLO0(1),PDLO1(1),PDLO2(1),PDLO3(1),PDLAT(1)
      POINTER (IPPDLO0, PDLO0)
      POINTER (IPPDLO1, PDLO1)
      POINTER (IPPDLO2, PDLO2)
      POINTER (IPPDLO3, PDLO3)
      POINTER (IPPDLAT, PDLAT)
C
      REAL PREGRID(2)
      INTEGER KPTS(1)
      REAL GLATS(1)
      INTEGER IOFFS(1)
      POINTER (IPKPTS,  KPTS)
      POINTER (IPIOFFS, IOFFS)
      POINTER (IPGLATS, GLATS)
C
      INTEGER ILL, ILLOLD
      REAL RCLAT(1),RCLON(1),RLAT(1),RLON(1),RDIR(1),C(1),S(1),U(1),V(1)
      POINTER (IPRCLAT, RCLAT)
      POINTER (IPRCLON, RCLON)
      POINTER (IPRLAT, RLAT)
      POINTER (IPRLON, RLON)
      POINTER (IPRDIR, RDIR)
      POINTER (IPC, C)
      POINTER (IPS, S)
      POINTER (IPU, U)
      POINTER (IPV, V)
C
      REAL OLDU(1)
      POINTER (IOLDU, OLDU)
      REAL OLDV(1)
      POINTER (IOLDV, OLDV)
C
      DATA NPREV/-1/
      DATA LNEW/.FALSE./, LFIRST/.TRUE./
      DATA ILLOLD/-1/, IOLDU/-1/, IOLDV/-1/
      DATA PREGRID/2*0.0/
C
      SAVE LNEW, LFIRST
      SAVE IPKSCHE, IPNEIGH, IPKLA, IPPWTS
      SAVE IPPDLO0, IPPDLO1, IPPDLO2, IPPDLO3, IPPDLAT
      SAVE NPREV, IPKPTS, IPIOFFS, IPGLATS
      SAVE ILLOLD, IPRLAT, IPRLON, IOLDU, IOLDV
      SAVE IPC, IPS, IPU, IPV
      SAVE PREGRID
C
C     Externals
C
      INTEGER HNEILL, HGENLL
#ifdef POINTER_64
      INTEGER*8 JMALLOC
#else
      INTEGER JMALLOC
#endif
C
C     Statement function
C
      REAL A, RADIAN
C
C     Convert degrees to radians
C
      RADIAN(A) = (A) * 0.0174532925
C
C     -----------------------------------------------------------------|
C     Section 1.  Initialise.
C     -----------------------------------------------------------------|
C
  100 CONTINUE
C
      IPRDIR  = 0
      IPRCLON = 0
      IPRCLAT = 0
      HLL2LLW = 0
C
      CALL JDEBUG()
      NOLDLAT = 1 + NINT(180.0/OLDGRID(1))
      NOLDLON = NINT(360.0/OLDGRID(2))
      NUMBER  = NOLDLAT * NOLDLON
C
      IF( (OLDGRID(1).NE.PREGRID(1)).OR.
     X    (OLDGRID(2).NE.PREGRID(2)) ) THEN
C
C       Allocate memory to hold the input fields
C       (in case OLDFLDU/OLDFLDV and NEWFLDU/NEWFLDV are the same arrays)
C
        IF( IOLDU.GT.0 ) THEN
          CALL JFREE(IOLDU)
          CALL JFREE(IOLDV)
        ENDIF
C
        NBYTES = NUMBER * JPRLEN
C
        IOLDU = JMALLOC(NBYTES)
        IOLDV = JMALLOC(NBYTES)
#ifdef hpR64
        IOLDU = IOLDU/(1024*1024*1024*4)
        IOLDV = IOLDV/(1024*1024*1024*4)
#endif
        IF( (IOLDU.EQ.0).OR.(IOLDV.EQ.0) ) THEN
          CALL INTLOG(JP_ERROR,'HLL2LLW: Memory allocate fail',JPQUIET)
          HLL2LLW = 3
          GOTO 900
        ENDIF
C
        PREGRID(1) = OLDGRID(1)
        PREGRID(2) = OLDGRID(2)
C
      ENDIF
C
C     Preserve the input fields
C
      DO LOOP = 1, NUMBER
        OLDU(LOOP) = OLDFLDU(LOOP)
        OLDV(LOOP) = OLDFLDV(LOOP)
      ENDDO
C
C     -----------------------------------------------------------------|
C     Section 2.  Generate the lat/long points for the output grid
C     -----------------------------------------------------------------|
C
  200 CONTINUE
C
      NLON = 1 + INT((AREA(JEAST) - AREA(JWEST)) / GRID(JW_E))
      NLAT = 1 + INT((AREA(JNORTH) - AREA(JSOUTH)) / GRID(JN_S))
C
      NLEN = NLON * NLAT

      NOWE = NLON
      NONS = NLAT
C
C     Check that given array is big enough for the new field.
C
      IF( NLEN.GT.KSIZE ) THEN
        CALL INTLOG(JP_ERROR,'HLL2LLW: Given array size = ',KSIZE)
        CALL INTLOG(JP_ERROR,'HLL2LLW: Required size = ',NLEN)
        HLL2LLW = 4
        GOTO 900
      ENDIF
C
C     Dynamically allocate memory for lat/long arrays.
C
      ILL = NLEN
      IF( ILL.GT.ILLOLD ) THEN
C
        LNEW = .TRUE.
C
        IF( ILLOLD.GT.0 ) CALL JFREE(IPRLON)
C
        NBYTES = 9*ILL*JPRLEN
C
        IPRLON = JMALLOC(NBYTES)
#ifdef hpR64
        IPRLON = IPRLON/(1024*1024*1024*4)
#endif
        IF( IPRLON.EQ.0 ) THEN
          CALL INTLOG(JP_ERROR,'HLL2LLW: Memory allocate fail',JPQUIET)
          HLL2LLW = 5
          GOTO 900
        ENDIF
C
        IPRLAT  = IPRLON  + (ILL*JPRLEN)
        IPRCLON = IPRLAT  + (ILL*JPRLEN)
        IPRCLAT = IPRCLON + (ILL*JPRLEN)
        IPRDIR  = IPRCLAT + (ILL*JPRLEN)
        IPC     = IPRDIR  + (ILL*JPRLEN)
        IPS     = IPC     + (ILL*JPRLEN)
        IPU     = IPS     + (ILL*JPRLEN)
        IPV     = IPU     + (ILL*JPRLEN)
C
        ILLOLD = ILL
C
      ENDIF
C
      IRET = HGENLL(AREA,POLE,GRID,NLON,NLAT,RLAT,RLON)
      IF( IRET.NE.0 ) THEN
        CALL INTLOG(JP_ERROR,
     X    'HLL2LLW: HGENLL failed to get lat/lon grid data',JPQUIET)
        HLL2LLW = 6
        GOTO 900
      ENDIF
C
C     -----------------------------------------------------------------|
C     Section 3.  Find neighbours for each point for interpolation.
C     -----------------------------------------------------------------|
C
  300 CONTINUE
C
C     Dynamically allocate memory for interpolation arrays.
C
      IF( LNEW ) THEN
C
        IF( .NOT.LFIRST ) CALL JFREE(IPPDLO0)
C
        NBYTES = (17*JPRLEN + 14*JPBYTES) * ILL
C
        IPPDLO0 = JMALLOC(NBYTES)
#ifdef hpR64
        IPPDLO0 = IPPDLO0/(1024*1024*1024*4)
#endif
        IF( IPPDLO0.EQ.0 ) THEN
          CALL INTLOG(JP_ERROR,'HLL2LLW: Memory allocate fail',JPQUIET)
          HLL2LLW = 7
          GOTO 900
        ENDIF
C
        IPPDLO1 = IPPDLO0 + (ILL*JPRLEN)
        IPPDLO2 = IPPDLO1 + (ILL*JPRLEN)
        IPPDLO3 = IPPDLO2 + (ILL*JPRLEN)
        IPPDLAT = IPPDLO3 + (ILL*JPRLEN)
        IPPWTS  = IPPDLAT + (ILL*JPRLEN)
        IPKSCHE = IPPWTS  + (12*ILL*JPRLEN)
        IPKLA   = IPKSCHE + (ILL*JPBYTES)
        IPNEIGH = IPKLA   + (ILL*JPBYTES)
C
        LFIRST = .FALSE.
        LNEW   = .FALSE.
C
      ENDIF
C
C     Find neighbours.
C
      IRET = HNEILL(L12PNT,NLEN,RLAT,RLON,OLDGRID,
     X              KSCHEME,PDLAT,PDLO0,PDLO1,PDLO2,PDLO3,KLA,NEIGH)
      IF( IRET.NE.0 ) THEN
        CALL INTLOG(JP_ERROR,
     X    'HLL2LLW: HNEILL failed to find neighbours',JPQUIET)
        HLL2LLW = 8
        GOTO 900
      ENDIF
C
C     -----------------------------------------------------------------|
C     Section 4.  Perform the 12-point horizontal interpolation.
C     -----------------------------------------------------------------|
C
  400 CONTINUE
C
C     Setup the 12-point horizontal interpolation weights
C
      CALL HWTSLL
     X  (NLEN,KSCHEME,KLA,PDLAT,OLDGRID(2),PDLO0,PDLO1,PDLO2,PDLO3,
     X   NEIGH,PWTS)
C
C     Calculate the interpolated grid point values
C
      DO LOOP = 1, NLEN
        IF( KSCHEME(LOOP).EQ.JP12PT ) THEN
          U(LOOP) =
     X      OLDU(NEIGH( 1,LOOP)) * PWTS( 1,LOOP) +
     X      OLDU(NEIGH( 2,LOOP)) * PWTS( 2,LOOP) +
     X      OLDU(NEIGH( 3,LOOP)) * PWTS( 3,LOOP) +
     X      OLDU(NEIGH( 4,LOOP)) * PWTS( 4,LOOP) +
     X      OLDU(NEIGH( 5,LOOP)) * PWTS( 5,LOOP) +
     X      OLDU(NEIGH( 6,LOOP)) * PWTS( 6,LOOP) +
     X      OLDU(NEIGH( 7,LOOP)) * PWTS( 7,LOOP) +
     X      OLDU(NEIGH( 8,LOOP)) * PWTS( 8,LOOP) +
     X      OLDU(NEIGH( 9,LOOP)) * PWTS( 9,LOOP) +
     X      OLDU(NEIGH(10,LOOP)) * PWTS(10,LOOP) +
     X      OLDU(NEIGH(11,LOOP)) * PWTS(11,LOOP) +
     X      OLDU(NEIGH(12,LOOP)) * PWTS(12,LOOP)
          V(LOOP) =
     X      OLDV(NEIGH( 1,LOOP)) * PWTS( 1,LOOP) +
     X      OLDV(NEIGH( 2,LOOP)) * PWTS( 2,LOOP) +
     X      OLDV(NEIGH( 3,LOOP)) * PWTS( 3,LOOP) +
     X      OLDV(NEIGH( 4,LOOP)) * PWTS( 4,LOOP) +
     X      OLDV(NEIGH( 5,LOOP)) * PWTS( 5,LOOP) +
     X      OLDV(NEIGH( 6,LOOP)) * PWTS( 6,LOOP) +
     X      OLDV(NEIGH( 7,LOOP)) * PWTS( 7,LOOP) +
     X      OLDV(NEIGH( 8,LOOP)) * PWTS( 8,LOOP) +
     X      OLDV(NEIGH( 9,LOOP)) * PWTS( 9,LOOP) +
     X      OLDV(NEIGH(10,LOOP)) * PWTS(10,LOOP) +
     X      OLDV(NEIGH(11,LOOP)) * PWTS(11,LOOP) +
     X      OLDV(NEIGH(12,LOOP)) * PWTS(12,LOOP)
C
        ELSE IF( KSCHEME(LOOP).EQ.JP4PT ) THEN
          U(LOOP) =
     X      OLDU(NEIGH( 1,LOOP)) * PWTS( 1,LOOP) +
     X      OLDU(NEIGH( 2,LOOP)) * PWTS( 2,LOOP) +
     X      OLDU(NEIGH( 3,LOOP)) * PWTS( 3,LOOP) +
     X      OLDU(NEIGH( 4,LOOP)) * PWTS( 4,LOOP)
          V(LOOP) =
     X      OLDV(NEIGH( 1,LOOP)) * PWTS( 1,LOOP) +
     X      OLDV(NEIGH( 2,LOOP)) * PWTS( 2,LOOP) +
     X      OLDV(NEIGH( 3,LOOP)) * PWTS( 3,LOOP) +
     X      OLDV(NEIGH( 4,LOOP)) * PWTS( 4,LOOP)
C
        ELSE
          DO NEXT = 1, 4
            IF( NEIGH(NEXT,LOOP).NE.0 ) THEN
              U(LOOP) = OLDU(NEIGH(NEXT,LOOP))
              V(LOOP) = OLDV(NEIGH(NEXT,LOOP))
            ENDIF
          ENDDO
C
        ENDIF
      ENDDO
C
C     -----------------------------------------------------------------|
C     Section 5.  Adjust the U and V components to new (rotated) axes
C     -----------------------------------------------------------------|
C
  500 CONTINUE
C
      DO LOOP = 1, NLEN
        RDIR(LOOP) = 0.0
      ENDDO
C
      CALL HPSHGPW(RLON,RLAT,RCLON,RCLAT,RDIR,NLEN,POLE)
C
      DO LOOP = 1, NLEN
        RDIR(LOOP) = -RADIAN(RDIR(LOOP))
      ENDDO
C
      DO LOOP = 1, NLEN
        C(LOOP) = COS(RDIR(LOOP))
        S(LOOP) = SIN(RDIR(LOOP))
      ENDDO
C
      DO LOOP = 1, NLEN
        NEWFLDU(LOOP) = U(LOOP)*C(LOOP) - V(LOOP)*S(LOOP)
        NEWFLDV(LOOP) = U(LOOP)*S(LOOP) + V(LOOP)*C(LOOP)
      ENDDO
C
C     -----------------------------------------------------------------|
C     Section 9.  Return.
C     -----------------------------------------------------------------|
C
  900 CONTINUE
C
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE BUENS1( KSEC0,KSEC1,KBUFL,KBUFF,KERR)
C
C**** *BUENS1*
C
C
C     PURPOSE.
C     --------
C          PACK SECTION 1 OF BUFR MESSAGE.
C
C**   INTERFACE.
C     ----------
C
C          *CALL* *BUENS1( KSEC0,KSEC1,KBUFL,KBUFF,KERR)*
C
C
C        INPUT :
C               *KSEC0*   -  ARRAY CONTAINING SECTION 0 INFORMATION
C                            KSEC0( 1)-- LENGTH OF SECTION 0 (BYTES)
C                            KSEC0( 2)-- TOTAL LENGTH OF BUFR MESSAGE (BYTES)
C                            KSEC0( 3)-- BUFR EDITION NUMBER
C               *KSEC1*   -  ARRAY CONTAINING SECTION 1 INFORMATION
C                            KSEC1( 1)-- LENGTH OF SECTION 1 (BYTES)
C                            KSEC1( 2)-- BUFR EDITION NUMBER
C                            KSEC1( 3)-- ORIGINATING CENTRE
C                            KSEC1( 4)-- UPDATE SEQUENCE NUMBER
C                            KSEC1( 5)-- FLAG (PRESENCE OF SECTION 2)
C                            KSEC1( 6)-- BUFR MESSAGE TYPE
C                            KSEC1( 7)-- BUFR MESSAGE SUBTYPE
C                            KSEC1( 8)-- VERSION NUMBER OF LOCAL TABLE USED
C                            KSEC1( 9)-- YEAR
C                            KSEC1(10)-- MONTH
C                            KSEC1(11)-- DAY
C                            KSEC1(12)-- HOUR
C                            KSEC1(13)-- MINUTE
C                            KSEC1(14)-- BUFR MASTER TABLE
C                            KSEC1(15)-- VERSION NUMBER OF MASTER TABLE USED
C                            KSEC1(16) TO KSEC1(JSEC1) - LOCAL ADP CENTRE
C                                        INFORMATION(PACKED FORM)
C
C                            FOR BUFR EDITION 3 ONWARD
C                            
C                            KSEC1(16)-- ORIGINATING SUB-CENTRE
C                            KSEC1(17)-- NOT USED
C                            KSEC1(18) TO KSEC1(JSEC1) - LOCAL ADP CENTRE
C                                        INFORMATION(PACKED FORM)
C
C                            FOR BUFR EDITION 4 ONWARD
C
C                            KSEC1(16)-- ORIGINATING SUB-CENTRE
C                            KSEC1(17)-- INTERNATIONAL SUB-CATEGORY (SEE COMMON TABLE C-13
C                            KSEC1(18)-- SECOND
C                            KSEC1(19)-- YEAR
C                            KSEC1(20)-- MONTH
C                            KSEC1(21)-- DAY
C                            KSEC1(22)-- HOUR
C                            KSEC1(23)-- MINUTE
C                            KSEC1(24)-- SECOND
C                            KSEC1(25)-- YEAR
C                            KSEC1(26)-- MONTH
C                            KSEC1(27)-- DAY
C                            KSEC1(28)-- HOUR
C                            KSEC1(29)-- MINUTE
C                            KSEC1(30)-- SECOND
C                            KSEC1(31)-- MOST SOUTHERN LATITUDE  (-90 to 90)
C                            KSEC1(32)-- MOST WESTERN LONGITUDE  ( 0-360)
C                            KSEC1(33)-- MOST NORTHEN LATITUDE   (-90 to 90)
C                            KSEC1(34)-- MOST EASTERN LONGITUDE  ( 0-360)
C                            KSEC1(35) TO KSEC1(JSEC1) - LOCAL ADP CENTRE INFORMATION(PACKED FORM)
C
C        OUTPUT :
C               *KBUFL*   -  LENGTH OF BUFR MESSAGE (WORDS)
C               *KBUFF*   -  ARRAY CONTAINING BUFR MESSAGE
C               *KERR*    -  RETURNED ERROR CODE
C
C*     METHOD.
C      -------
C
C           NONE.
C
C
C     EXTERNALS.
C     ----------
C
C          BUPCK         -  PACK BIT PATHERN
C          BUOCTN        - SET LENGTH OF SECTION
C
C
C     REFERENCE.
C     ----------
C
C          NONE.
C
C     AUTHOR.
C     -------
C
C          M. DRAGOSAVAC    *ECMWF*       16/01/91.
C
C
C     MODIFICATIONS.
C     --------------
C
C          NONE.
C
C
      IMPLICIT LOGICAL(L,O,G), CHARACTER*8(C,H,Y)
C
C
#     include "parameter.F"
#     include "bcomunit.F"
#     include "bcmwork.F"
C
      DIMENSION KBUFF(KBUFL),KSEC0(JSEC0),KSEC1(JSEC1)
      DIMENSION ISEC1(JSEC1)
#ifndef R_4
      REAL*8 RVIND
      REAL*8 EPS
#else
      REAL   RVIND
      REAL   EPS
#endif
C
C     ------------------------------------------------------------------
C*          1.  PACK SECTION 1.
C               ---------------
 100  CONTINUE
C
      IF( KERR.NE.0 ) RETURN
C
      DO 101 I=1,JSEC1
      ISEC1(I)=0
 101  CONTINUE
C
C*          1.1  KEEP POINTERS TO THE BEGINING OF THE SECTION.
C                ---------------------------------------------
 110  CONTINUE
C
      IWPTB = NWPT
      IBPTB = NBPT
C
C
C*          1.2 PACK LENGTH OF SECTION 1.
C               -------------------------
 120  CONTINUE
C
      CALL BUPCK(NBPW,KBUFF(NWPT),0,NWPT,NBPT,24,KERR)
      IF(KERR.GT.0) THEN
         WRITE(KNTN,*) 'ERROR PACKING LENGTH OF SECTION 1.'
         RETURN
      END IF
C
C
C*          1.3  PACK BUFR EDITION NUMBER/MASTER TABLE USED.
C                -------------------------------------------
 130  CONTINUE
C
      IF(KSEC0(3).LE.1) THEN
         CALL BUPCK(NBPW,KBUFF(NWPT),KSEC1(2),NWPT,NBPT, 8,KERR)
         IF(KERR.GT.0) THEN
            WRITE(KNTN,*) 'ERROR PACKING BUFR EDITION NUMBER' 
            WRITE(KNTN,*) 'IN SECTION 1.'
            RETURN
         END IF
      ELSE
         CALL BUPCK(NBPW,KBUFF(NWPT),KSEC1(14),NWPT,NBPT, 8,KERR)
         IF(KERR.GT.0) THEN
            WRITE(KNTN,*) 'ERROR PACKING BUFR MASTER TABLE NUMBER'
            WRITE(KNTN,*) 'IN SECTION 1.'
            RETURN
         END IF
      END IF
C
C*          1.4  PACK ORIGINATING CENTRE.
C                ------------------------
 140  CONTINUE
C
      IF(KSEC0(3).LT.3) THEN
         CALL BUPCK(NBPW,KBUFF(NWPT),KSEC1(3),NWPT,NBPT,16,KERR)
         IF(KERR.GT.0) THEN
         WRITE(KNTN,*) 'ERROR PACKING ORIGINATING CENTRE IN SECTION 1.'
            RETURN
         END IF
      ELSEIF(KSEC0(3).EQ.3) THEN
         CALL BUPCK(NBPW,KBUFF(NWPT),KSEC1(16),NWPT,NBPT,8,KERR)
         IF(KERR.GT.0) THEN
            WRITE(KNTN,*) 'ERROR PACKING ORIGINATING ',
     1                    'SUB-CENTRE IN SECTION 1.'
            RETURN
         END IF
         CALL BUPCK(NBPW,KBUFF(NWPT),KSEC1(3),NWPT,NBPT,8,KERR)
         IF(KERR.GT.0) THEN
         WRITE(KNTN,*) 'ERROR PACKING ORIGINATING CENTRE IN SECTION 1.'
            RETURN
         END IF
      ELSEIF(KSEC0(3).EQ.4) THEN
         CALL BUPCK(NBPW,KBUFF(NWPT),KSEC1(3),NWPT,NBPT,16,KERR)
         IF(KERR.GT.0) THEN
         WRITE(KNTN,*) 'ERROR PACKING ORIGINATING CENTRE IN SECTION 1.'
            RETURN
         END IF
         CALL BUPCK(NBPW,KBUFF(NWPT),KSEC1(16),NWPT,NBPT,16,KERR)
         IF(KERR.GT.0) THEN
            WRITE(KNTN,*) 'ERROR PACKING ORIGINATING ',
     1                    'SUB-CENTRE IN SECTION 1.'
            RETURN
         END IF
      END IF
C
C*          1.5  PACK UPDATE SEQUENCE NUMBER.
C                ----------------------------
 150  CONTINUE
C
      CALL BUPCK(NBPW,KBUFF(NWPT),KSEC1(4),NWPT,NBPT, 8,KERR)
      IF(KERR.GT.0) THEN
         WRITE(KNTN,*) 'ERROR PACKING UPDATE SEQUENCE NUMBER ',
     1                 'IN SECTION 1.'
         RETURN
      END IF
C
C*          1.6  PACK INTEGER VALUE OF THE OCTET CONTAINING
C                ------------------------------------------
C                FLAG BITS(ZERO IF SECTION TWO IS NOT PRESENT).
C                ----------------------------------------------
 160  CONTINUE
C
      CALL BUPCK(NBPW,KBUFF(NWPT),KSEC1(5),NWPT,NBPT, 8,KERR)
      IF(KERR.GT.0) THEN
         WRITE(KNTN,*) 'ERROR PACKING FLAG IN SECTION 1.'
         RETURN
      END IF
C
C*          1.7  PACK *BUFR* MESSAGE TYPE.
C                -------------------------
 170  CONTINUE
C
      CALL BUPCK(NBPW,KBUFF(NWPT),KSEC1(6),NWPT,NBPT, 8,KERR)
      IF(KERR.GT.0) THEN
      WRITE(KNTN,*) 'ERROR PACKING BUFR MESSAGE TYPE IN SECTION 1.'
         RETURN
      END IF
C
C           1.7.1 PACK BUFR INTERNATIONAL SUB-CATEGORY
C                 -------------------------------------
      IF(KSEC0(3).EQ.4) THEN
         CALL BUPCK(NBPW,KBUFF(NWPT),KSEC1(17),NWPT,NBPT, 8,KERR)
         IF(KERR.GT.0) THEN
         WRITE(KNTN,*) 'ERROR PACKING KSEC1(17) IN SECTION 1.'
            RETURN
         END IF
      END IF
C
C*          1.8  PACK *BUFR* MESSAGE SUB-TYPE.
C                -----------------------------
 180  CONTINUE
C
      CALL BUPCK(NBPW,KBUFF(NWPT),KSEC1(7),NWPT,NBPT, 8,KERR)
      IF(KERR.GT.0) THEN
         WRITE(KNTN,*) 'ERROR PACKING BUFR MESSAGE SUBTYPE.'
         RETURN
      END IF
C
C*          1.9  PACK LOCAL TABLE VERSION NUMBER OR
C                ----------------------------------
C                VERSION NUMBER OF MASTER TABLE USED.
C                ------------------------------------
 190  CONTINUE
C
      IF(KSEC0(3).LE.1) THEN
         CALL BUPCK(NBPW,KBUFF(NWPT),KSEC1(8),NWPT,NBPT,16,KERR)
         IF(KERR.GT.0) THEN
            WRITE(KNTN,*) 'ERROR PACKING VERSION NUMBER OF ',
     1                    'LOCAL TABLE USED.'
            RETURN
         END IF
      ELSE
         CALL BUPCK(NBPW,KBUFF(NWPT),KSEC1(15),NWPT,NBPT, 8,KERR)
         IF(KERR.GT.0) THEN
            WRITE(KNTN,*) 'ERROR PACKING VERSION NUMBER OF ',
     1                    'MASTER TABLE USED.'
            RETURN
         END IF
         CALL BUPCK(NBPW,KBUFF(NWPT),KSEC1( 8),NWPT,NBPT, 8,KERR)
         IF(KERR.GT.0) THEN
            WRITE(KNTN,*) 'ERROR PACKING VERSION NUMBER OF ',
     1                    'LOCAL TABLE USED.'
            RETURN
         END IF
      END IF
C
C*          2.0  PACK YEAR.
C                ----------
 200  CONTINUE
C
      IF(KSEC0(3).LE.3) THEN
         CALL BUPCK(NBPW,KBUFF(NWPT),KSEC1(9),NWPT,NBPT, 8,KERR)
         IF(KERR.GT.0) THEN
            WRITE(KNTN,*) 'ERROR PACKING KSEC1(9) IN SECTION 1.'
            RETURN
         END IF
      ELSE
         CALL BUPCK(NBPW,KBUFF(NWPT),KSEC1(9),NWPT,NBPT,16,KERR)
         IF(KERR.GT.0) THEN
            WRITE(KNTN,*) 'ERROR PACKING KSEC1(9) IN SECTION 1.'
            RETURN
         END IF
      END IF
C
C*          2.1  PACK MONTH.
C                -----------
 210  CONTINUE
C
      CALL BUPCK(NBPW,KBUFF(NWPT),KSEC1(10),NWPT,NBPT, 8,KERR)
      IF(KERR.GT.0) THEN
         WRITE(KNTN,*) 'ERROR PACKING KSEC1(10) IN SECTION 1.'
         RETURN
      END IF
C
C*          2.2 PACK DAY.
C               -----------
 220  CONTINUE
C
      CALL BUPCK(NBPW,KBUFF(NWPT),KSEC1(11),NWPT,NBPT, 8,KERR)
      IF(KERR.GT.0) THEN
         WRITE(KNTN,*) 'ERROR PACKING KSEC1(11) IN SECTION 1.'
         RETURN
      END IF
C
C*          2.3 PACK HOUR.
C               ------------
 230  CONTINUE
C
      CALL BUPCK(NBPW,KBUFF(NWPT),KSEC1(12),NWPT,NBPT, 8,KERR)
      IF(KERR.GT.0) THEN
         WRITE(KNTN,*) 'ERROR PACKING KSEC1(12) IN SECTION 1.'
         RETURN
      END IF
C
C*          2.4 PACK MINUTE.
C               --------------
 240  CONTINUE
C
      CALL BUPCK(NBPW,KBUFF(NWPT),KSEC1(13),NWPT,NBPT, 8,KERR)
      IF(KERR.GT.0) THEN
         WRITE(KNTN,*) 'ERROR PACKING KSEC1(13) IN SECTION 1.'
         RETURN
      END IF
C
C          2.4.1 PACK SECOND
C                -----------
      IF(KSEC0(3).EQ.4) THEN
         CALL BUPCK(NBPW,KBUFF(NWPT),KSEC1(18),NWPT,NBPT, 8,KERR)
         IF(KERR.GT.0) THEN
            WRITE(KNTN,*) 'ERROR PACKING KSEC1(18) IN SECTION 1.'
            RETURN
         END IF
      END IF

C
C          2.5 PACK LOCAL ADP CENTRE INFORMATION.
C              ----------------------------------
 250  CONTINUE
C
      IF(KSEC0(3).LT.3) THEN
         IOFF=KSEC1(1)-17
         IW=16
         IB=0
      ELSEIF(KSEC0(3).EQ.3) THEN
         IOFF=KSEC1(1)-17
         IF(IOFF.LT.1) THEN
           WRITE(KNTN,*) 'ERROR IN KSEC1(1)'
           WRITE(KNTN,*) 'THE SIZE SHALL BE AT LEAST 18 BYTES'
           KERR=55
           RETURN
         END IF
         IW=18
         IB=0
      ELSEIF(KSEC0(3).EQ.4) THEN
C        IOFF=KSEC1(1)-52
         IOFF=KSEC1(1)-22
         IF(IOFF.LT.0) THEN
           WRITE(KNTN,*) 'ERROR IN KSEC1(1)'
           WRITE(KNTN,*) 'THE SIZE SHALL BE AT LEAST 22 BYTES'
           KERR=55
           RETURN
         END IF
C        IW=35      ! index for local info
         IW=19      ! index for local info
         IB=0
      END IF
      IF(IOFF.GT.0) THEN
         CALL BUNPKS(NBPW,KSEC1,ISEC1,IW,IB,8,0,IOFF,KERR)
         IF(KERR.GT.0) THEN
            WRITE(KNTN,*) 'ERROR PACKING LOCAL ADP CENTRE INFORMATION'
            WRITE(KNTN,*) 'IN SECTION 1.'
            RETURN
         END IF
C
         CALL BUPKS(NBPW,KBUFF(NWPT),ISEC1,NWPT,NBPT,8,0,IOFF,KERR)
         IF(KERR.GT.0) THEN
            WRITE(KNTN,*) 'ERROR PACKING LOCAL ADP CENTRE INFORMATION'
            WRITE(KNTN,*) 'IN SECTION 1.'
            RETURN
         END IF
      END IF
C     ------------------------------------------------------------------
C*          2.6  SET UP LENGTH OF THE SECTION 1.
C                --------------------------------
 260  CONTINUE
C
      CALL BUOCTN(IWPTB,IBPTB,KBUFL,KBUFF,KERR)
      IF(KERR.GT.0) RETURN
C
C
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

       INTEGER FUNCTION D2ORDR ( KDATA, KLENP, KSEC1, KSEC2, KSEC3, 
     X                          KSEC4, KGRIB, KLENG, KNSPT, KBITS,
     X                          HOPER, KLEN4, KNIL,  PREF , PSCALE,
     X                          KBMAP, KVALS, KDEBUG )
C
C---->
C**** D2ORDR
C
C     Purpose.
C     --------
C
C     Decode GRIB section 4 for complex packing of grid-point
C     values ("second-order packing").
C
C
C**   Interface.
C     ----------
C
C     KRET = D2ORDR ( KDATA, KLENP, KSEC1, KSEC2, KSEC3, KSEC4,
C    X                KGRIB, KLENG, KNSPT, KBITS, HOPER, KLEN4,
C    X                KNIL,  PREF, PSCALE, KBMAP, KVALS, KDEBUG )
C
C
C     Input Parameters.
C     -----------------
C
C     KLENP      - Length of array KDATA.
C     KSEC1      - Array of GRIB section 1 integer descriptors.
C     KSEC2      - Array of GRIB section 2 integer descriptors.
C     KSEC3      - Array of GRIB section 3 integer descriptors.
C     KSEC4      - Array of GRIB section 4 integer descriptors.
C                  (preset to zero, and already decoded for (3:6)
C     KGRIB      - GRIB product array.
C     KLENG      - Length of GRIB product array.
C     KNSPT      - Bit pointer for next value in GRIB product.
C     KBITS      - Number of bits per computer word.
C     HOPER      - Requested function:
C                  'D' or 'R' to decode the whole field,
C                  'X' to decode only a few gridpoints (as described
C                   in KSEC4(34:42),
C                  'J' to decode only section 4 descriptors.
C     KLEN4      - Length (octets) of section 4.
C     KNIL       - Unused bit count at end of section 4.
C     KBMAP      - Bit pointer for start of explicit primary bit-map
C                  (if any).
C     KVALS      - Number of bits in primary bit-map.
C     KDEBUG     - >0 for some debug printout.
C
C
C     Output Parameters.
C     -----------------
C
C     KDATA      - Array of normalized values.
C     KSEC4      - Array of GRIB section 4 values (completed).
C     KGRIB      - Array containing GRIB product.
C     KNSPT      - Bit pointer for next value in GRIB product (updated).
C     PREF       - Reference value of field.
C     PSCALE     - Scale factor (ready to use) of field.
C
C
C     Method.
C     -------
C
C     Follows WMO Manual of Codes, and also DSECT4 structure.
C
C
C     Externals.
C     ----------
C
C     INXBIT    - Extract bits from GRIB product.
C     DECFP2    - Decode from IBM floating point format.
C     PRTBIN    - Print binary value in character format.
C     C2BITW    - Computes bit width of a positive integer value.
C     DSGNBT    - Decodes an integer value and its sign bit.
C     MAXMNI    - Computes extrema of integer array.
C     D2ROSD    - Rebuild original values from spatial differencing.
C     REVERO    - Reverse order of values in even rank rows.
C
C
C     Reference.
C     ----------
C
C     None.
C
C
C     Comments.
C     --------
C
C     On entry, KNSPT points to the first bit of section 4
C               in the GRIB product.
C     On exit,  KNSPT points to the first unused bit of section 4,
C               (or to the first bit of section 5, if unused bit count
C                is zero) in the GRIB product.
C
C
C     Author.
C     -------
C
C     J. Clochard, Meteo France, for ECMWF - January 1998.
C
C
C     Modifications.
C     _____________
C
C     J. Clochard, April 1998.
C     Update comments, and add more consistency with C2ORDR source code.
C     Inhibit REVERO call for function 'X'.
C     Introduce spatial differencing.
C
C     J. Clochard, September 1998.
C     Optimize management of primary bit-map in row by row packing case.
C     Fixes behaviour for HOPER='J' (KDATA must not be used)
C     and HOPER='X' (KDATA minimum length is KSEC4(34), not full-length.
C
C
C----<
C     -----------------------------------------------------------------
C*    Section 0. Definition of variables.
C     -----------------------------------------------------------------
C
      IMPLICIT NONE
C
#include "common/grprs.h"
C
C     Parameters
C
      INTEGER JP15BIT, JP16SET, JPWS1O, JPXMAX, JPXPWR, JPWS2O
C
      PARAMETER ( JP15BIT= 2**15 )
C                            `---> 32768    =   8000(hex)
      PARAMETER ( JP16SET= 2**16-1 )
C                            `---> 65535    =   FFFF(hex)
C     JPWS1O ===> Size of group work arrays.
C     JPXMAX ===> Maximum number of points for 'X' function.
C     JPXPWR ===>    "      "    "  bits number per value/descriptor.
C     JPWS2O ===> Size of work array IWORK2
C                 (must be strictly bigger than JPWS1O).
C
C     IWORK2 array is used to unpack:
C     -group sizes, in case of general extended packing
C                   (JPWS1O last values);
C     -secondary bit-map, if any;
C     -primary bit-map, in case of row by row packing.
C
C     These cases are exclusive.
C
#ifdef JBPW_64
      PARAMETER ( JPWS1O= 5000, JPWS2O= 20000, JPXMAX= 4, JPXPWR= 47 )
#else
      PARAMETER ( JPWS1O= 5000, JPWS2O= 20000, JPXMAX= 4, JPXPWR= 31 )
#endif
C
C     Subroutine arguments
C
      INTEGER KLENP, KLENG, KNSPT, KBITS, KLEN4, KNIL, KBMAP, KVALS
      INTEGER KDEBUG
      INTEGER KDATA (KLENP), KSEC1 (*), KSEC2 (*), KSEC4 (*), KGRIB (*)
      INTEGER KSEC3 (*)
C
      CHARACTER HOPER * (*)
C
      REAL PREF, PSCALE
C
C     Local variables.
C
      INTEGER IRET, IRETA, IRETB, IEXP, IMANT, IFLAGX, IAUXIL, INDKS4
      INTEGER IFIROV, ISECOV, ISCALE, IPTRSO, ILEN, INROWS, J, IRETFN
      INTEGER IPTRFO, IWIDTH, IPTRBM, ILAUXS, IPTRB0, ILNGTH, IRANG
      INTEGER IBITGW, IAUXIS, INBSEQ, JSEQ, IGROFF, IGRNBR, JGROUP
      INTEGER IREFLN, ICOUNT, IMAXVN, INPEXT, INCR, IEXTOR, IVALS
      INTEGER ISKIP, JEXT, IEXT, ICNEXT, INSPTA, IPTRGW, INVALS, ICOUNG
      INTEGER INDROW, INDCOL, IVALSC, IPTRFN, IPTRSN, IVALK4, IREFER
      INTEGER IPRWID, ICOUNS, ILNGTS, INDEXX, INDEXY, JROW, ISEQ
#ifdef ebug2o
      INTEGER IMAXVC
#endif
      INTEGER IBITGS, IPTRGS, IORDER, IWIDSD, IBIAS
#ifndef wmogrp2o
      INTEGER IEXTRA
#endif
C
      INTEGER IWIDGR (JPWS1O), IWORK2 (JPWS2O), IFIRST (JPWS1O)
      INTEGER IRGEXT (JPXMAX+1), INDXOR (JPXMAX), ILENGR (JPWS1O)
      INTEGER IPOWER (0:JPXPWR)
      INTEGER IWORK (3)
C
      CHARACTER YOPER*1
C
      LOGICAL LROW, LQUASI, LCTWID, LSECBI, LPRIBI, LDEBUG, L1CALL
      LOGICAL LGENXT, LBOUST, LPRCLN, LVECTD
C
      INTEGER REVERO, D2ROSD
      EXTERNAL REVERO, D2ROSD
      INTEGER C2BITW
      EXTERNAL C2BITW
C
      SAVE L1CALL, IPOWER
C
      DATA L1CALL / .TRUE. /
C
C     -----------------------------------------------------------------
C*    Section 1 . Decode octets 5 to 13.
C     -----------------------------------------------------------------
C
  100 CONTINUE
C
      IPTRB0 = 0
      IAUXIS = 0
      ILEN = 0
      IRETFN = 0
      YOPER='D'
      INSPTA=KNSPT
      LDEBUG=KDEBUG.GE.1
C
      IF (L1CALL) THEN
C
        DO 111 J=0,JPXPWR-1
        IPOWER(J)=2**J-1
  111   CONTINUE
#ifdef JBPW_64
        IPOWER(JPXPWR)=140737488355327
#else
        IPOWER(JPXPWR)=2147483647
#endif
C
        L1CALL=.FALSE.
C
      ENDIF
C
#ifndef ebug2o
      IF (LDEBUG) THEN
#endif
        WRITE(GRPRSM,FMT=9100) HOPER(:1),KNSPT
#ifndef ebug2o
      ENDIF
#endif
C
      KNSPT=KNSPT+4*8
C
C*    Octets 5 - 6 : Scale factor.
C     One 16 bit field.
C
      CALL INXBIT (KGRIB,KLENG,KNSPT,ISCALE,1,KBITS, 16,YOPER,IRET)
C
      IF (IRET.NE.0) THEN
        IRETFN = 17110
        WRITE(GRPRSM,FMT=9001) 'scale factor'
        GO TO 900
      ENDIF
C
C     Make negative if sign bit set
      IF ( ISCALE .GT. JP15BIT ) THEN
        ISCALE = ISCALE - JP15BIT
        ISCALE = -ISCALE
      ENDIF
      PSCALE = 2.0**ISCALE
#ifdef ebug2o
      WRITE(GRPRSM,FMT='('' D2ORDR - Binary scale factor ='',
     X       I20,TR1,F30.20,''.'')') ISCALE,PSCALE
#endif
C
C*    Octets 7 - 10 : Reference value.
C     One 8 bit and one 24 bit field.
C
C     Extract reference value exponent and mantissa.
      CALL INXBIT(KGRIB,KLENG,KNSPT,IEXP,1,KBITS, 8,YOPER,IRETA)
      CALL INXBIT(KGRIB,KLENG,KNSPT,IMANT,1,KBITS, 24,YOPER,IRETB)
      IRET = IRETA + IRETB
C
      IF (IRET.NE.0) THEN
        IRETFN = 17120
        WRITE(GRPRSM,FMT=9001) 'reference value'
        GO TO 900
      ENDIF
C
C     Decode the reference value
      CALL DECFP2 (PREF,IEXP,IMANT)
C
C*    Octet 11 : Number of bits containing each first-order value.
C     One 8 bit field.
C
      CALL INXBIT(KGRIB,KLENG,KNSPT,KSEC4(2),1,KBITS, 8,YOPER,IRET)
C
      IF (IRET.NE.0) THEN
        IRETFN = 17130
        WRITE(GRPRSM,FMT=9001) 'bit number of first-order values'
        GO TO 900
      ELSEIF (KSEC4(2).GT.JPXPWR) THEN
        IRETFN = 17131
        WRITE(GRPRSM,FMT=9002) 'Bit number (of first-order values)',
     X                          JPXPWR
        GO TO 900
#ifdef ebug2o
      ELSE
#else
      ELSEIF (LDEBUG) THEN
#endif
        WRITE(GRPRSM,FMT=9135) KSEC4(2)
      ENDIF
C
C     Octets 12 - 13: Octet number of the start of first-order packed 
C                     data.
C     One 16-bit field.
C
      CALL INXBIT(KGRIB,KLENG,KNSPT,IPTRFO,1,KBITS,16,YOPER,IRET)
C
      IF (IRET.NE.0) THEN
        IRETFN = 17140
        WRITE(GRPRSM,FMT=9001) 'pointer to first-order packed data'
        GO TO 900
#ifdef ebug2o
      ELSE
#else
      ELSEIF (LDEBUG) THEN
#endif
        WRITE(GRPRSM,FMT=9150) PREF, IPTRFO, KNSPT
      ENDIF
C
C     -----------------------------------------------------------------
C*    Section 2 . Decode octets 14 to 21.
C     -----------------------------------------------------------------
C
  200 CONTINUE
C
C     Octet 14: Extended flags.
C     One 8-bit field.
C
      CALL INXBIT(KGRIB,KLENG,KNSPT,IFLAGX,1,KBITS, 8,YOPER,IRET)
C
      IF (IRET.NE.0) THEN
        IRETFN = 17210
        WRITE(GRPRSM,FMT=9001) 'extended flags'
        GO TO 900
#ifdef ebug2o
      ELSE
#else
      ELSEIF (LDEBUG) THEN
#endif
        CALL PRTBIN (IFLAGX,8,IAUXIL,IRET)
C
        IF (IRET.NE.0) THEN
          IAUXIL=IFLAGX
        ENDIF
C
        WRITE(GRPRSM,FMT=9210) IAUXIL, KNSPT
      ENDIF
C
C         R------- only bit 1 is reserved.
C         -0------ single datum at each grid point.
C         -1------ matrix of values at each grid point.
C         --0----- no secondary bit map.
C         --1----- secondary bit map present.
C         ---0---- second order values have constant width.
C         ---1---- second order values have different widths.
C         ----0--- no general extended second order packing.
C         ----1--- general extended second order packing used.
C         -----0-- standard field ordering in section 4.
C         -----1-- boustrophedonic ordering in section 4.
C         ------00 no spatial differencing used.
C         ------01 1st-order spatial differencing used.
C         ------10 2nd-order    "         "         " .
C         ------11 3rd-order    "         "         " .
C
      IF (IFLAGX.GE.128) THEN
        IRETFN = 17220
        WRITE(GRPRSM,FMT=9220)
        GO TO 900
      ENDIF
C
      IAUXIL = 64
      INDKS4 = 6
C
      IVALK4 = 8
C
      DO 201 J = 2, IVALK4
C
      IF (J.EQ.5) THEN
        INDKS4 = INDKS4 + 1
      ENDIF
C      
      IF (IFLAGX.GE.IAUXIL) THEN
        KSEC4(INDKS4+J) = IAUXIL
        IFLAGX = IFLAGX - IAUXIL
      ENDIF
C
      IAUXIL=IAUXIL/2
  201 CONTINUE
C
#ifndef ebug2o
      IF (LDEBUG) THEN
#endif
        WRITE(GRPRSM,FMT=9225) (KSEC4(J),J=3,10)
#ifndef ebug2o
      ENDIF
#endif
C
      IF (IFLAGX.NE.0) THEN
        IRETFN = 17230
        WRITE(GRPRSM,FMT=9230)
        GO TO 900
      ELSEIF (KSEC4(8).NE.0) THEN
        IRETFN = 17240
        WRITE(GRPRSM,FMT=9240)
        GO TO 900
      ENDIF
C
      LPRIBI=MOD (KSEC1(5),128).GE.64
      LSECBI=KSEC4(9).NE.0
      LROW=.NOT.LSECBI.AND.KSEC4(12).EQ.0
      LGENXT=.NOT.LSECBI.AND.KSEC4(12).NE.0
      LBOUST=KSEC4(13).NE.0
      IORDER=KSEC4(14)+KSEC4(15)
C
      IF (IORDER.NE.0) THEN
C
        IF (HOPER.EQ.'X') THEN
          IRETFN = 17244
          WRITE(GRPRSM,FMT=9244) HOPER(:1)
          GO TO 900
        ELSEIF (.NOT.LGENXT) THEN
          IRETFN = 17245
          WRITE(GRPRSM,FMT=9245)
          GO TO 900
        ENDIF
C
      ENDIF
C
      LQUASI=KSEC2(17).EQ.1
      LCTWID=KSEC4(10).EQ.0
C
C     Octets 15 - 20: Octet number of the start of second-order packed 
C                     data, Number of first-order packed data,
C                     Number of second-order packed data.
C     Three 16-bit fields.
C
      CALL INXBIT(KGRIB,KLENG,KNSPT,KSEC4(17),3,KBITS,16,YOPER,IRET)
C
      IF (IRET.NE.0) THEN
        IRETFN = 17250
        WRITE(GRPRSM,FMT=9001) 'standard second-order descriptors'
        GO TO 900
      ENDIF
C
      IPTRSO=KSEC4(17)
      IFIROV=KSEC4(18)
      ISECOV=KSEC4(19)
C
#ifndef wmogrp2o
C     Octet 21: Reserved by WMO, so should be zero in standard case.
C               Could be used for extra bits of group number.
C     One 8-bit field.
C
      CALL INXBIT(KGRIB,KLENG,KNSPT,IEXTRA,1,KBITS, 8,YOPER,IRET)
C
      IF (IRET.NE.0) THEN
        IRETFN = 17255
        WRITE(GRPRSM,FMT=9001) '21st octet of section 4'
        GO TO 900
      ELSEIF (IEXTRA.NE.0) THEN
        IFIROV=IFIROV+(JP16SET+1)*IEXTRA
        CALL PRTBIN (IEXTRA,8,IAUXIL,IRET)
C
        IF (IRET.NE.0) THEN
          IAUXIL=IEXTRA
        ENDIF
C
        WRITE(GRPRSM,FMT=9255) IAUXIL, IEXTRA, IFIROV
      ENDIF
C
      KSEC4(18)=IFIROV
C
#else
C     Octet 21: Reserved by WMO.
C     One 8-bit field. Skipped.
C
      KNSPT = KNSPT + 8
C
#endif
      IF (KSEC1(5).GE.128) THEN
C
C     Cross checks between descriptors decoded above,
C     and section 2 descriptors previously decoded.
C
        IF (MOD (KSEC2(11),64).LT.32) THEN
          INROWS=KSEC2(3)
        ELSE
          INROWS=KSEC2(2)
        ENDIF
C
        IF (LROW.AND.((LPRIBI.AND.INROWS.LT.IFIROV).OR.
     X                (.NOT.LPRIBI.AND.INROWS.NE.IFIROV))) THEN
          IRETFN = 17260
          WRITE(GRPRSM,FMT=9260)
          GO TO 900
        ELSEIF (LQUASI) THEN
          IREFLN=22
          ILEN=0
C
          DO 211 J=1,INROWS
          ILEN=ILEN+KSEC2(IREFLN+J)
  211     CONTINUE
C
        ELSE
          ILEN=KSEC2(2)*KSEC2(3)
          ILNGTH=ILEN/INROWS
        ENDIF
C
        IF (LPRIBI.AND.ISECOV.GT.ILEN.AND.HOPER.NE.'J') THEN
          IRETFN = 17265
          WRITE(GRPRSM,FMT=9270) 'too big'
          GO TO 900
        ELSEIF (.NOT.LPRIBI) THEN
C
          IF (ILEN.LE.JP16SET.AND.(IORDER+ISECOV).NE.ILEN) THEN
            IRETFN = 17270
            WRITE(GRPRSM,FMT=9270) 'from section 2'
            GO TO 900
          ELSEIF (ILEN.GT.JP16SET) THEN
C
C           Two octets not wide enough for ISECOV - adjust.
C
            ISECOV=ILEN-IORDER
            KSEC4(19)=ISECOV
          ENDIF
C
        ELSEIF (KVALS.NE.ILEN) THEN
          IRETFN = 17275
          WRITE(GRPRSM,FMT=9275)
          GO TO 900
        ENDIF
C
      ELSE
C
C     No section 2 in the present message.
C
        IF (LROW) THEN
          IRETFN = 17277
          WRITE(GRPRSM,FMT=9277) 'Row by row packing'
          GO TO 900
        ELSEIF (HOPER.EQ.'X') THEN
          IRETFN = 17278
          WRITE(GRPRSM,FMT=9277) 'HOPER=''X'' function'
          GO TO 900
        ELSEIF (LBOUST) THEN
          IRETFN = 17279
          WRITE(GRPRSM,FMT=9277) 'Boustrophedonic ordering'
          GO TO 900
        ENDIF
C
      ENDIF
C
      IF (LPRIBI) THEN
C
        IF (KSEC3(1).EQ.0) THEN
C
C         Explicit primary bit-map included.
C         Computation of effective number of points.
C
          INBSEQ=1+(KVALS-1)/JPWS2O
          INVALS=0
          ISEQ=0
C
          IF (LROW.AND.HOPER.NE.'J') THEN
C
C           In row by row case, it is also necessary for decoding field
C           values to compute real length of rows. Do it now, as far as
C           permitted through ILENGR work array size.
C
            IAUXIS=0
            ILAUXS=MIN (JPWS2O,KVALS)
            IPTRBM=KBMAP
            ISEQ=1
            CALL INXBIT(KGRIB,KLENG,IPTRBM,IWORK2,ILAUXS,KBITS,1,YOPER,
     X                  IRET)
C
            IF (IRET.NE.0) THEN
              IRETFN = 17280
              WRITE(GRPRSM,FMT=9001) 'primary bit-map, row by row case'
              GO TO 900
            ENDIF
C
            DO 223 JROW=1,MIN (INROWS,JPWS1O)
C
C             Full length of row (unmasked).
C
            IF (LQUASI) THEN
              ILNGTH=KSEC2(IREFLN+JROW)
            ELSE
              ILNGTH=ILEN/INROWS
            ENDIF
C
            IVALS=ILNGTH
            ILNGTH=0
            IVALSC=IVALS
C
  221       CONTINUE
C
            DO 222 J=1,MIN (IVALSC,ILAUXS-IAUXIS)
            ILNGTH=ILNGTH+IWORK2(IAUXIS+J)
  222       CONTINUE
C
            IF (IVALSC.LE.ILAUXS-IAUXIS) THEN
C
              IAUXIS=IAUXIS+IVALSC
C
            ELSEIF (IPTRBM.LT.KBMAP+KVALS) THEN
C
              IVALSC=IVALSC-(ILAUXS-IAUXIS)
              ILAUXS=MIN(KBMAP+KVALS-IPTRBM,JPWS2O)
              IAUXIS=0
              ISEQ=ISEQ+1
              CALL INXBIT(KGRIB,KLENG,IPTRBM,IWORK2,ILAUXS,KBITS,1,
     X                    YOPER,IRET)
C
              IF (IRET.NE.0) THEN
                IRETFN = 17280
                WRITE(GRPRSM,FMT=9001)
     X                   'primary bit-map, row by row case'
                GO TO 900
              ENDIF
C
              GOTO 221
C
            ELSE
C
              IRETFN = 17560
              WRITE(GRPRSM,FMT=9560)
              GO TO 900
C
            ENDIF
C
            ILENGR(JROW)=ILNGTH
            INVALS=INVALS+ILNGTH
C
  223       CONTINUE
C
C             End-up current sequence (active only if bit-map has not
C             been fully processed)...
C
            DO 224 J=IAUXIS+1,ILAUXS
            INVALS=INVALS+IWORK2(J)
  224       CONTINUE
C
            IAUXIL=(ISEQ-1)*JPWS2O+IAUXIS
C
          ENDIF
C
C             Staightforward computing.
C
          DO 228 JSEQ=ISEQ+1,INBSEQ
          IAUXIS=(JSEQ-1)*JPWS2O
          ILAUXS=MIN (JPWS2O,KVALS-IAUXIS)
          IPTRBM=KBMAP+IAUXIS
          CALL INXBIT(KGRIB,KLENG,IPTRBM,IWORK2,ILAUXS,KBITS,1,YOPER,
     X                IRET)
C
          IF (IRET.NE.0) THEN
            IRETFN = 17280
            WRITE(GRPRSM,FMT=9001) 'primary bit-map'
            GO TO 900
          ENDIF
C
          DO 227 J=1,ILAUXS
          INVALS=INVALS+IWORK2(J)
  227     CONTINUE
C
  228     CONTINUE
C
          IF (LROW.AND.HOPER.NE.'J') THEN
C
            IF (INROWS.GT.JPWS1O) THEN
C
C           ... it is necessary to (re)read primary bit-map, adjusting
C           pointer to start of (JPWS1O+1)th row.
C
              IAUXIS=0
              ILAUXS=MIN (JPWS2O,KVALS-IAUXIL)
              IPTRBM=KBMAP+IAUXIL
              CALL INXBIT(KGRIB,KLENG,IPTRBM,IWORK2,ILAUXS,KBITS,1,
     X                    YOPER,IRET)
C
              IF (IRET.NE.0) THEN
                IRETFN = 17280
                WRITE(GRPRSM,FMT=9001)
     X               'primary bit-map, row by row case'
                GO TO 900
              ENDIF
C
            ENDIF
C
          ENDIF
C
          IF (INVALS.GT.JP16SET) THEN
C
C       Two octets might be not wide enough for ISECOV. Adjust.
C
            ISECOV=INVALS-IORDER
          ENDIF
C
        ELSEIF (LROW) THEN
C
          IRETFN = 17281
          WRITE(GRPRSM,FMT=9281) 'Row by row'
          GO TO 900
C
        ELSEIF (LBOUST) THEN
C
          IRETFN = 17282
          WRITE(GRPRSM,FMT=9281) 'Boustrophedonic ordering'
          GO TO 900
C
        ENDIF
C
C         WARNING:
C         -------
C       Whenever an implicit primary bit-map is included, it is then
C       assumed that ISECOV contains the right number of grid-points
C       really included in section 4. This is valid only if this
C       effective number of points is lower than (or equal to) JP16SET.

      ENDIF
C
      IF (IORDER+ISECOV.GT.KLENP.AND.HOPER.NE.'J'.AND.HOPER.NE.'X') THEN
        IRETFN = 17290
        WRITE(GRPRSM,FMT=9290) IORDER+ISECOV,KLENP
        GO TO 900
      ELSEIF (HOPER.EQ.'X'.AND.KLENP.LE.IORDER) THEN
        IRETFN = 17291
        WRITE(GRPRSM,FMT=9291) IORDER+1
        GO TO 900
      ENDIF
C
C     -----------------------------------------------------------------
C*    Section 3 . Decode last octet(s) (22...) before loop on groups.
C     -----------------------------------------------------------------
C
  300 CONTINUE
C
      IF (KSEC4(12).NE.0) THEN
C
C               General extended second-order packing used.
C
        IF (LSECBI) THEN
          IRETFN = 17310
          WRITE(GRPRSM,FMT=9310) 'no secondary bit-map'
          GO TO 900
        ELSEIF (LCTWID) THEN
          IRETFN = 17320
          WRITE(GRPRSM,FMT=9310) 'variable group widths'
          GO TO 900
        ENDIF
C
C     Octets 22 - 23: Width of widths, Width of lengths.
C     Two 8-bit fields.
C
        CALL INXBIT(KGRIB,KLENG,KNSPT,IWORK,2,KBITS,8,YOPER,IRET)
C
        IF (IRET.NE.0) THEN
          IRETFN = 17330
          WRITE(GRPRSM,FMT=9001) 'general extended descriptors, widths'
          GO TO 900
        ENDIF
C
        IBITGW=IWORK(1)
        IBITGS=IWORK(2)
C
        IF (MAX (IBITGW,IBITGS).GT.JPXPWR) THEN
          IRETFN = 17340
          WRITE(GRPRSM,FMT=9002)
     X         'general extended width of (group and/or size)',
     X                            JPXPWR
          GO TO 900
        ENDIF
C
        KSEC4(11)=IBITGS
C
C     Octets 24-25: Octet number of the start of group sizes (lengths).
C     One 16-bit field.
C
        CALL INXBIT(KGRIB,KLENG,KNSPT,IPTRGS,1,KBITS,16,YOPER,IRET)
C
        IF (IRET.NE.0) THEN
          IRETFN = 17345
          WRITE(GRPRSM,FMT=9001) 'general extended group size pointer'
          GO TO 900
        ENDIF
C
        IPTRSN=1+(8+(KNSPT-INSPTA)+IFIROV*IBITGW-1)/8
C
        IF (IPTRSN.GT.JP16SET) THEN
C
C           Two octets not wide enough for IPTRGS - adjust.
C
          IPTRGS=IPTRSN
        ENDIF
C
        IF (IORDER.NE.0.AND.HOPER.NE.'J') THEN
C
C     Octet 26: Width of spatial differencing specific descriptors.
C     One 8-bit field.
C
          CALL INXBIT(KGRIB,KLENG,KNSPT,IWIDSD,1,KBITS,8,YOPER,IRET)
C
          IF (IRET.NE.0) THEN
            IRETFN = 17346
            WRITE(GRPRSM,FMT=9001)
     X           'Width of spatial differencing descriptors'
            GO TO 900
          ELSEIF (IWIDSD.NE.0) THEN
C
C     Octet 27-onwards: first IORDER original values and diff. bias.
C     (IORDER+1) fields of IWIDSD bits.
C
            IAUXIL=IORDER+1
            CALL INXBIT(KGRIB,KLENG,KNSPT,KDATA,IAUXIL,KBITS,IWIDSD,
     X                  YOPER,IRET)
C
            IF (IRET.NE.0) THEN
              IRETFN = 17347
              WRITE(GRPRSM,FMT=9001)
     X           'First field value(s) (spatial differencing case)'
              GO TO 900
            ENDIF
C
C              Decode bias and its sign.
C
            CALL DSGNBT(IBIAS,KDATA(IAUXIL),IWIDSD,IRET)
C
            IF (IRET.NE.0) THEN
              IRETFN = 17348
              WRITE(GRPRSM,FMT=9348) IRET
              GO TO 900
            ENDIF
C
C                 Adjust pointer to next octet boundary.
C
            KNSPT=8*((8+KNSPT-1)/8)
C
          ELSE
C
C                 Spatial differencing descriptors are all zero.
C
            DO 311 J=1,IORDER
            KDATA(J)=0
  311       CONTINUE
C
            IBIAS=0
C
          ENDIF
C
        ENDIF
C
      ELSE
C
        IBITGW=8
C
        IF (LCTWID) THEN
C
C     Octet 22: Single value for width of second-order values.
C     One 8-bit field.
C
          CALL INXBIT(KGRIB,KLENG,KNSPT,IWIDTH,1,KBITS,8,YOPER,IRET)
C
          IF (IRET.NE.0) THEN
            IRETFN = 17350
            WRITE(GRPRSM,FMT=9001) 'constant width of 2nd-order values'
            GO TO 900
          ELSEIF (IWIDTH.GT.JPXPWR) THEN
            IRETFN = 17351
            WRITE(GRPRSM,FMT=9002) 'Constant width', JPXPWR
            GO TO 900
          ENDIF
C
          KSEC4(11)=IWIDTH
C
        ENDIF
C
        IF (LSECBI) THEN
C
C     Secondary bit-map present. Initialize pointer, and decode
C     start of secondary bit-map (if field decoding is requested).
C
          IF (LCTWID) THEN
            IPTRBM=23
          ELSE
            IPTRBM=22+IFIROV
          ENDIF
C
          IPTRBM=(IPTRBM-1)*8+INSPTA
          IPTRB0=IPTRBM
C
          IF (HOPER.NE.'J') THEN
C
            ILAUXS=MIN(ISECOV,JPWS2O)
            IAUXIS=1
            CALL INXBIT(KGRIB,KLENG,IPTRBM,IWORK2,ILAUXS,KBITS,1,YOPER,
     X                  IRET)
C
            IF (IRET.NE.0) THEN
              IRETFN = 17360
              WRITE(GRPRSM,FMT=9001) 'start of secondary bit-map'
              GO TO 900
            ELSEIF (IWORK2(1).NE.1) THEN
              IRETFN = 17365
              WRITE(GRPRSM,FMT=9365)
              GO TO 900
            ENDIF
C
          ENDIF
C
        ENDIF
C
      ENDIF
C
C     Compute minimum values for pointers. If it leads to value(s)
C     not fitting in 2 octets, then assume these are the right
C     value(s) to use.
C
      IPTRGW=KNSPT
      IPTRFN=1+(8+IPTRGW-INSPTA-1)/8
C
      IF (LCTWID) THEN
        IPTRFN=IPTRFN+(8+ISECOV-1)/8
      ELSEIF (LROW) THEN
        IPTRFN=IPTRFN+(8+IFIROV*IBITGW-1)/8
      ELSEIF (LGENXT) THEN
        IPTRFN=IPTRFN+(8+IFIROV*IBITGW-1)/8+(8+IFIROV*IBITGS-1)/8
      ELSE
        IPTRFN=IPTRFN+(8+IFIROV*IBITGW-1)/8+(8+ISECOV-1)/8
      ENDIF
C
      IF (IPTRFN.GT.JP16SET) THEN
        IPTRFO=IPTRFN
      ENDIF
C
      KSEC4(16)=IPTRFO
      IPTRSN=IPTRFO+(8+IFIROV*KSEC4(2)-1)/8
C
      IF (IPTRSN.GT.JP16SET) THEN
        IPTRSO=IPTRSN
        KSEC4(17)=IPTRSO
      ENDIF
C
#ifndef ebug2o
      IF (LDEBUG) THEN
#endif
C
        IF (LROW) THEN
          WRITE(GRPRSM,FMT=9381) 'row by row'
        ELSEIF (LCTWID) THEN
          WRITE(GRPRSM,FMT=9382) KSEC4(11)
        ELSEIF (LGENXT) THEN
          WRITE(GRPRSM,FMT=9381) 'general extended'
        ELSE
          WRITE(GRPRSM,FMT=9381) 'WMO general 2nd-order'
        ENDIF
C
        IF (LBOUST) THEN
          WRITE(GRPRSM,FMT=9383)
        ENDIF
C
        IF (IORDER.NE.0) THEN
          WRITE(GRPRSM,FMT=9384) IORDER, IBIAS
        ENDIF
C
        WRITE(GRPRSM,FMT=9385) IFIROV, ISECOV, IPTRFO, IPTRSO
#ifndef ebug2o
      ENDIF
C
#endif
      KSEC4(20)=IBITGW
      IPTRFO=(IPTRFO-1)*8+INSPTA
      IPTRSO=(IPTRSO-1)*8+INSPTA
C
C     Cross checks betweens pointers.
C
      IF (LGENXT) THEN
C
        IPTRGS=(IPTRGS-1)*8+INSPTA
C
        IF (IPTRGW+IFIROV*IBITGW.GT.IPTRGS) THEN
          IRETFN = 17391
          WRITE(GRPRSM,FMT=9391)
          GO TO 900
        ELSEIF (IPTRGS+IFIROV*IBITGS.GT.IPTRFO) THEN
          IRETFN = 17392
          WRITE(GRPRSM,FMT=9393)
     X           'general extended group size/1st-order values'
          GO TO 900
        ENDIF
C
      ELSEIF (LSECBI) THEN
C
        IF (IPTRB0+ISECOV.GT.IPTRFO) THEN
          IRETFN = 17393
          WRITE(GRPRSM,FMT=9393) '2ndary bit-map/1st-order values'
          GO TO 900
        ENDIF
C
      ENDIF
C
      IF (IPTRFO+IFIROV*KSEC4(2).GT.IPTRSO) THEN
        IRETFN = 17394
        WRITE(GRPRSM,FMT=9393) 'First-order/Second-order'
        GO TO 900
      ENDIF
C
C     -----------------------------------------------------------------
C*    Section 4 . Additional preprocessing for function 'X'.
C     -----------------------------------------------------------------
C
  400 CONTINUE
C
      IF (HOPER.EQ.'X') THEN
C
C     First, perform some checks.
C
        INDEXX=34
        INDEXY=42
C
#ifndef ebug2o
        IF (LDEBUG) THEN
#endif
          WRITE(GRPRSM,FMT=9401) INDEXX, INDEXY,
     X                            (KSEC4(J),J=INDEXX,INDEXY)
#ifndef ebug2o
        ENDIF
#endif
C
        INPEXT=KSEC4(INDEXX)
C
        IF (LPRIBI) THEN
          IRETFN = 17410
          WRITE(GRPRSM,FMT=9410) 'not valid with a (primary) bit-map'
          GO TO 900
        ELSEIF (KSEC2(1).GE.40.OR.
     X          (MOD(KSEC2(1),10).NE.0.AND.MOD(KSEC2(1),10).NE.4)) THEN
          IRETFN = 17411
          WRITE(GRPRSM,FMT=9410)
     X              'valid only with lat/long or gaussian field'
          GO TO 900
        ELSEIF (INPEXT.LT.1.OR.INPEXT.GT.JPXMAX) THEN
          IRETFN = 17412
          WRITE(GRPRSM,FMT=9412) JPXMAX,' points.'
          GO TO 900
        ELSEIF (INPEXT.GT.KLENP) THEN
          IRETFN = 17413
          WRITE(GRPRSM,FMT=9413) INPEXT
          GO TO 900
        ENDIF
C
C       Take into account third bit of scanning modes to know 
C       which dimension is latitude.
C
C       INCR=0 means that longitude is the most rapidly varying.
C
        INCR=MOD (KSEC2(11),64)/32
C
C       Now compute 1-dimensional "addresses" in whole field.
C
        DO 422 JEXT=1,INPEXT
        INDROW=KSEC4(INDEXX+2*JEXT-1+INCR)
        INDCOL=KSEC4(INDEXX+2*JEXT  -INCR)
C
        IF (INDROW.LT.1.OR.INDROW.GT.INROWS) THEN
          IRETFN = 17421
          WRITE(GRPRSM,FMT=9421) JEXT, INCR+1, INROWS
          GO TO 900
        ELSEIF(LQUASI) THEN
          ISKIP=0
C
          DO 421 J=1,INDROW-1
          ISKIP=ISKIP+KSEC2(IREFLN+J)
  421     CONTINUE
C
          ILNGTH=KSEC2(IREFLN+INDROW)
C
        ELSE
          ISKIP=(INDROW-1)*ILNGTH
        ENDIF
C
        IF (INDCOL.LT.1.OR.INDCOL.GT.ILNGTH) THEN
          IRETFN = 17422
          WRITE(GRPRSM,FMT=9421) JEXT, 2-INCR, ILNGTH
          GO TO 900
        ENDIF
C
#ifndef ebug2o
        IF (LDEBUG) THEN
#endif
          WRITE(GRPRSM,FMT=9422) JEXT, INDROW, INDCOL, ISKIP, ILNGTH
#ifndef ebug2o
        ENDIF
C
#endif
        IF (LBOUST.AND.MOD(INDROW,2).EQ.0) THEN
          INDCOL=ILNGTH+1-INDCOL
        ENDIF
C
        IRGEXT(JEXT)=ISKIP+INDCOL
        INDXOR(JEXT)=JEXT
  422   CONTINUE
C
C     Finally, sort "addresses" in ascending order.
C
        DO 432 JEXT=1,INPEXT-1
C
        DO 431 J=JEXT+1,INPEXT
C
        IF (IRGEXT(J).LT.IRGEXT(JEXT)) THEN
          IAUXIL=IRGEXT(J)
          IRGEXT(J)=IRGEXT(JEXT)
          IRGEXT(JEXT)=IAUXIL
          IAUXIL=INDXOR(J)
          INDXOR(J)=INDXOR(JEXT)
          INDXOR(JEXT)=IAUXIL
        ENDIF
C
  431   CONTINUE
C
  432   CONTINUE
C
        IRGEXT(INPEXT+1)=0
#ifndef ebug2o
C
        IF (LDEBUG) THEN
#endif
          PRINT *,' D2ORDR: IRGEXT = ',IRGEXT,', INDXOR = ',INDXOR,'.'
#ifndef ebug2o
        ENDIF
C
#endif
      ELSE
        INPEXT=0
      ENDIF
C
C     -----------------------------------------------------------------
C*    Section 5 . Decode values, group by group.
C     -----------------------------------------------------------------
C
  500 CONTINUE
C
C     Finished if function 'J' is requested.
C
      IF (HOPER.EQ.'J') THEN
        KSEC4(1)=IORDER+ISECOV
        GO TO 900
      ENDIF
C
      ICOUNT=IORDER
      ICOUNS=IORDER
      ICOUNG=IORDER
      IEXT=1
      INBSEQ=1+(IFIROV-1)/JPWS1O
C
      IF (KSEC4(2).EQ.0) THEN
C
C       In this case, no first-order values are provided: they are
C       all equal to 0 (group references equal to field reference).
C
        DO 501 J=1,MIN (IFIROV,JPWS1O)
        IFIRST(J)=0
  501   CONTINUE
C
      ENDIF
C
      IF (LCTWID.AND.HOPER.NE.'X') THEN
C
C       Constant width packing. Second-order values will be
C       decoded once per sequence.
C
        IPRWID=KSEC4(11)
C
        DO 502 J=1,MIN (IFIROV,JPWS1O)
        IWIDGR(J)=IPRWID
  502   CONTINUE
C
      ENDIF
C
C                 Groups treated as sequences, as large as possible
C                 with respect to group work arrays size (JPWS1O). 
C
      DO 591 JSEQ=1,INBSEQ
C
      IGROFF=(JSEQ-1)*JPWS1O
      IGRNBR=MIN (JPWS1O,IFIROV-IGROFF)
C
      IF (LGENXT) THEN
        CALL INXBIT(KGRIB,KLENG,IPTRGS,IWORK2,IGRNBR,KBITS,IBITGS,YOPER,
     X              IRET)
C
        IF (IRET.NE.0) THEN
          IRETFN = 17510
          WRITE(GRPRSM,FMT=9510) 'sizes', IGROFF+1, IGROFF+IGRNBR
          GO TO 900
        ENDIF
C
      ENDIF
C
      IF (.NOT.LCTWID) THEN
        CALL INXBIT(KGRIB,KLENG,IPTRGW,IWIDGR,IGRNBR,KBITS,IBITGW,YOPER,
     X              IRET)
C
        IF (IRET.NE.0) THEN
          IRETFN = 17520
          WRITE(GRPRSM,FMT=9510) 'widths', IGROFF+1, IGROFF+IGRNBR
          GO TO 900
        ENDIF
C
        IPRWID=IWIDGR(1)
C
      ENDIF
C
      IF (KSEC4(2).NE.0) THEN
C
        CALL INXBIT(KGRIB,KLENG,IPTRFO,IFIRST,IGRNBR,KBITS,KSEC4(2),
     X              YOPER,IRET)
C
        IF (IRET.NE.0) THEN
          IRETFN = 17530
          WRITE(GRPRSM,FMT=9510) '1st-order values', IGROFF+1,
     X         IGROFF+IGRNBR
          GO TO 900
        ENDIF
C
      ENDIF
C
      ILNGTS=0
C
C     Loop over groups in a given sequence.
C
      DO 551 JGROUP=1,IGRNBR
C
C     Define length of current group: ILNGTH.
C
      IF (LGENXT) THEN
        ILNGTH=IWORK2(JGROUP)
      ELSEIF (LSECBI) THEN
C
        ILNGTH=0
C
  520   CONTINUE
C
        DO 521 J=IAUXIS+1,ILAUXS
C
        IF (IWORK2(J).EQ.1) THEN
          IRANG=J
          GOTO 522
        ENDIF
C
  521   CONTINUE
C
        ILNGTH=ILNGTH+ILAUXS-IAUXIS
C
        IF (IPTRBM.LT.IPTRB0+ISECOV) THEN
          ILAUXS=MIN(IPTRB0+ISECOV-IPTRBM,JPWS2O)
          IAUXIS=0
          CALL INXBIT(KGRIB,KLENG,IPTRBM,IWORK2,ILAUXS,KBITS,1,YOPER,
     X                IRET)
C
          IF (IRET.NE.0) THEN
            IRETFN = 17540
            WRITE(GRPRSM,FMT=9001) 'secondary bit-map'
            GO TO 900
          ENDIF
C
          GOTO 520
        ELSE
C
C           It was the last group.
C
          ILNGTH=ILNGTH+1
          GOTO 523
        ENDIF
C
  522   CONTINUE
C
        ILNGTH=ILNGTH+IRANG-IAUXIS
        IAUXIS=IRANG
C
  523   CONTINUE
C
      ELSE
C
C        ... that's row by row packing...
C
C            (re)definition of row length.
C
        IF (LQUASI) THEN
          IREFLN=IREFLN+1
          ILNGTH=KSEC2(IREFLN)
        ELSE
          ILNGTH=ILEN/INROWS
        ENDIF
C       
        IF (LPRIBI) THEN
C
C         Row by row packing, but an explicit bit-map is included.
C         The number of values in current row has to be known.
C
          IVALS=ILNGTH
C
          IF (JSEQ.EQ.1) THEN
C
C            Rows of first sequence has been pre-computed in Section 2.
C
            ILNGTH=ILENGR(JGROUP)
C
          ELSE
C
            ILNGTH=0
            IVALSC=IVALS
C
  530       CONTINUE
C
            DO 531 J=1,MIN (IVALSC,ILAUXS-IAUXIS)
            ILNGTH=ILNGTH+IWORK2(IAUXIS+J)
  531       CONTINUE
C
            IF (IVALSC.LE.ILAUXS-IAUXIS) THEN
C
              IAUXIS=IAUXIS+IVALSC
C
            ELSEIF (IPTRBM.LT.KBMAP+KVALS) THEN
C
              IVALSC=IVALSC-(ILAUXS-IAUXIS)
              ILAUXS=MIN(KBMAP+KVALS-IPTRBM,JPWS2O)
              IAUXIS=0
#ifndef ebug2o
C
              IF (LDEBUG) THEN
#endif
                WRITE(GRPRSM,FMT=9540) IGROFF+JGROUP, IPTRBM, ILAUXS
#ifndef ebug2o
              ENDIF
C
#endif
              CALL INXBIT(KGRIB,KLENG,IPTRBM,IWORK2,ILAUXS,KBITS,1,
     X                    YOPER,IRET)
C
              IF (IRET.NE.0) THEN
                IRETFN = 17550
                WRITE(GRPRSM,FMT=9001)
     X                    'primary bit-map in row by row case'
                GO TO 900
              ENDIF
C
              GOTO 530
C
            ELSE
C
              IRETFN = 17560
              WRITE(GRPRSM,FMT=9560)
              GO TO 900
C
            ENDIF
C
          ENDIF
C
#ifndef ebug2o
          IF (LDEBUG) THEN
#endif
            WRITE(GRPRSM,FMT=9565) IGROFF+JGROUP, ILNGTH, IVALS
#ifndef ebug2o
          ENDIF
C
#endif
        ENDIF
C
      ENDIF
C
      ICNEXT=ICOUNT+ILNGTH
C
      IF (ICNEXT.GT.(IORDER+ISECOV)) THEN
        IRETFN = 17570
        WRITE(GRPRSM,FMT=9570) ICNEXT, ISECOV
        GO TO 900
      ENDIF
C
      ILENGR(JGROUP)=ILNGTH
C
C         Go to next group if no point is included in current group.
C         (may only occur for masked field in row by row case)
C
      IF (ILNGTH.EQ.0) THEN
        IWIDGR(JGROUP)=0
        IFIRST(JGROUP)=0
        GOTO 551
      ENDIF
C
C     If necessary, (re)define width of current group: IWIDTH.
C
      IWIDTH=IWIDGR(JGROUP)
C
  540 CONTINUE
C
C     All characteristics of current group are known, so proceed
C     with second-order data.
C
C     Except for 'X' function, neighbour groups of same width are
C     "unpacked" together, at least once per sequence.
C
      IF (HOPER.NE.'X') THEN
C
C         All values of current group will have to be processed.
C
        IF (IWIDTH.NE.IPRWID) THEN
C
C     Current group may not be unpacked together with previous one(s).
C
#ifdef ebug2o
          PRINT *,'d2ordr - groups..',IGROFF+JGROUP-1,
     X          ' IPTRSO/IPRWID/ICOUNS/ILNGTS= ',
     X            IPTRSO, IPRWID, ICOUNS, ILNGTS
#endif
C
          IF (IPRWID.NE.0.AND.ILNGTS.NE.0) THEN
C
C     Effective decoding of second-order values, for previous group(s).
C
            CALL INXBIT(KGRIB,KLENG,IPTRSO,KDATA(ICOUNS+1),
     X                  ILNGTS,KBITS,IPRWID,YOPER,IRET)
C
            IF (IRET.NE.0) THEN
              IRETFN = 17580
              WRITE(GRPRSM,FMT=9580) 'groups..', IGROFF+JGROUP-1
              GO TO 900
            ENDIF
C
          ENDIF
C
          ICOUNS=ICOUNT
          ILNGTS=0
          IPRWID=IWIDTH
C
        ENDIF
C
        ILNGTS=ILNGTS+ILNGTH
C
      ELSEIF (IRGEXT(IEXT).GT.ICOUNT.AND.IRGEXT(IEXT).LE.ICNEXT) THEN
C
C     Function 'X' - Compute only a single "full" normalized value.
C
        IEXTOR=INDXOR(IEXT)
C
        IF (IWIDTH.NE.0) THEN
          IAUXIL=IPTRSO+(IRGEXT(IEXT)-ICOUNT-1)*IWIDTH
          CALL INXBIT(KGRIB,KLENG,IAUXIL,KDATA(IEXTOR),1,KBITS,
     X                IWIDTH,YOPER,IRET)
C
          IF (IRET.NE.0) THEN
            IRETFN = 17580
            WRITE(GRPRSM,FMT=9580) 'group', IGROFF+JGROUP
            GO TO 900
          ENDIF
C
          KDATA(IEXTOR)=IFIRST(JGROUP)+KDATA(IEXTOR)
        ELSE
          KDATA(IEXTOR)=IFIRST(JGROUP)
        ENDIF
C
        IEXT=IEXT+1
#ifndef ebug2o
C
        IF (LDEBUG) THEN
#endif
          WRITE(GRPRSM,FMT=9585) IEXT, INPEXT
#ifndef ebug2o
        ENDIF
#endif
C
C       Loop back, to allow for extraction of other point(s)
C       within the current group.
C
        GOTO 540
C
      ELSE
C
C       Function 'X', but group contains no requested grid-point.
C       Pointer adjusted for next group.
C
        IPTRSO=IPTRSO+ILNGTH*IWIDTH
C
      ENDIF
C
      ICOUNT=ICNEXT
C
  551 CONTINUE
C
      IF (HOPER.NE.'X') THEN
C
#ifdef ebug2o
        PRINT *,'d2ordr - groups..',IGROFF+IGRNBR,
     X          ' IPTRSO/IPRWID/ICOUNS/ILNGTS= ',
     X            IPTRSO, IPRWID, ICOUNS, ILNGTS
C
#endif
        IF (IPRWID.NE.0.AND.ILNGTS.NE.0) THEN
C
C         Effective decoding of second-order values, for last group(s)
C         of the current sequence.
C
C         In case of constant width packing it means all groups
C         of the current sequence.
C
          CALL INXBIT(KGRIB,KLENG,IPTRSO,KDATA(ICOUNS+1),
     X                ILNGTS,KBITS,IPRWID,YOPER,IRET)
C  
          IF (IRET.NE.0) THEN
            IRETFN = 17580
            WRITE(GRPRSM,FMT=9580) 'groups..', IGROFF+IGRNBR
            GO TO 900
          ENDIF
C
        ENDIF
C
        ICOUNS=ICOUNT
C
C       Add first-order values to rebuild original normalized values.
C
        DO 563 JGROUP=1,IGRNBR
C
#ifdef ebug2o
        IMAXVC=0
#endif
        IREFER=IFIRST(JGROUP)
        ILNGTH=ILENGR(JGROUP)
        IWIDTH=IWIDGR(JGROUP)
C
        IF (IWIDTH.NE.0) THEN
C
          DO 561 J=1,ILNGTH
#ifdef ebug2o
          IMAXVC=MAX(IMAXVC,KDATA(ICOUNG+J))
#endif
          KDATA(ICOUNG+J)=IREFER+KDATA(ICOUNG+J)
  561     CONTINUE
C
        ELSE
C
C     Group with a constant value: no second order value included.
C
          DO 562 J=1,ILNGTH
          KDATA(ICOUNG+J)=IREFER
  562     CONTINUE
C
        ENDIF
C
        ICOUNG=ICOUNG+ILNGTH
#ifdef ebug2o
        PRINT *,'d2ordr - group ',IGROFF+JGROUP,ICOUNG,ILNGTH,IWIDTH,
     X           IREFER,IMAXVC
#endif
C
  563   CONTINUE
C
      ENDIF
C
  591 CONTINUE
C
C     -----------------------------------------------------------------
C*    Section 6 . Last computations.
C     -----------------------------------------------------------------
C
  600 CONTINUE
C
C          From this point and for the remaining part of the routine,
C          ISECOV is the total number of grid-points.
C
      ISECOV=IORDER+ISECOV
C
      IF (IORDER.NE.0) THEN
C
C         Rebuild original field values from spatial differences.
C
#if (defined CRAY) || (defined FUJITSU)
        LVECTD=.TRUE.
#else
        LVECTD=.FALSE.
#endif
C
        IRETFN = D2ROSD ( KDATA,  ISECOV, IORDER, IPOWER, JPXPWR,
     X                    IBIAS,  LVECTD, LDEBUG )
C
        IF (IRETFN.NE.0) THEN
          GOTO 900
        ENDIF
C
      ENDIF
C
      IF (HOPER.NE.'X') THEN
C
C       Recompute original bit number for the whole field.
C
        CALL MAXMNI (KDATA,ISECOV,IMAXVN,IAUXIL)
C
        KSEC4(2) = C2BITW ( IMAXVN, JPXPWR, IPOWER, JPXPWR )
C
#ifndef ebug2o
        IF (LDEBUG) THEN
#endif
          WRITE(GRPRSM,FMT=9601) KSEC4(2)
#ifndef ebug2o
        ENDIF
C
#endif
        IF (ICOUNT.NE.ISECOV) THEN
          IRETFN = 17610
          WRITE(GRPRSM,FMT=9610) ICOUNT, ISECOV
          GO TO 900
        ELSE
          KSEC4(1)=ISECOV
        ENDIF        
C
      ELSE
        KSEC4(1)=MIN(IEXT,JPXMAX)
      ENDIF
C
#ifndef ebug2o
      IF (LDEBUG) THEN
#endif
        WRITE(GRPRSM,FMT=9602) KSEC4(1)
#ifndef ebug2o
      ENDIF
C
#endif
      KNSPT=INSPTA+KLEN4*8-KNIL
C
      IF (IPTRSO.NE.KNSPT) THEN
        IRETFN = 17620
        WRITE(GRPRSM,FMT=9620) IPTRSO, KNSPT
        GO TO 900
      ENDIF        
C
      IF (LBOUST.AND.HOPER.NE.'X') THEN
C
C           Reverse ordering within even rank rows.
C
        LPRCLN=.FALSE.
C
        IRETFN = REVERO ( KDATA,  KLENP,  KSEC2,  KGRIB,  KLENG,
     X                    KBITS,  KBMAP,  KVALS,  LPRIBI, LQUASI,
     X                    INROWS, ISECOV, IFIRST, JPWS2O, LDEBUG,
     X                    LPRCLN, IWORK2 )
      ENDIF
C
C     -----------------------------------------------------------------
C*    Section 9. Return to calling routine.
C     -----------------------------------------------------------------
C
  900 CONTINUE
C
      D2ORDR = IRETFN
#ifndef ebug2o
C
      IF (LDEBUG) THEN
#endif
        WRITE(GRPRSM,FMT=9900) IRETFN, HOPER(:1), KNSPT
#ifndef ebug2o
      ENDIF
#endif
C
      RETURN
C
 9001 FORMAT (' D2ORDR: Problem extracting ',A,'.')
C
 9002 FORMAT (' D2ORDR: ',A,' above',I3,'.')
C
 9100 FORMAT (' D2ORDR: Function start, HOPER = ',A,', KNSPT =',I10,
     X        '.')
 9135 FORMAT (' D2ORDR: Decoded number of bits (for 1st-order values)',
     X        ' =',I3,'.')
 9150 FORMAT (' D2ORDR: PREF =',F30.20,', decoded IPTRFO =',I6,'.',/,
     X        ' D2ORDR: KNSPT at end of "Section 1" =',I10,'.')
 9210 FORMAT (' D2ORDR: Extended flags =',I9.8,', KNSPT =',I10,'.')
 9220 FORMAT (' D2ORDR: First extended flag (reserved) set.')
 9225 FORMAT (' D2ORDR: KSEC4(3:10) =',I4,3I3,I2,3I3,'.')
 9230 FORMAT (' D2ORDR: Last extended flag(s) (reserved) set.')
 9240 FORMAT (' D2ORDR: Matrix of values invalid here.')
 9244 FORMAT (' D2ORDR: Function HOPER = "',A1,
     X        '" not supported for spatial differencing.')
 9245 FORMAT (' D2ORDR: Spatial differencing implies general',
     X                   ' extended 2nd-order packing.')
#ifndef wmogrp2o
 9255 FORMAT (' D2ORDR: 21st octet of section 4 not zero:',I9.8,
     X        '=>',I3,'.',/,TR10,
     X        'interpreted as extra bits for group number:',I8,'.')
#endif
 9260 FORMAT (' D2ORDR: Row by row packing: row/group numbers',
     X        ' not consistent.')
 9270 FORMAT (' D2ORDR: Number of second-order values ',A,'.')
 9275 FORMAT (' D2ORDR: (Primary bit-map size/section 2 contents)',
     X        ' mismatch.')
 9277 FORMAT (' D2ORDR: ',A,' only supported with a section 2.')
 9281 FORMAT (' D2ORDR: ',A,
     S        '/Implicit primary bit-map: not supported.')
 9290 FORMAT (' D2ORDR: Grid-point number exceeds KDATA size:',I9,
     X        ' >',I9,'.')
 9291 FORMAT (' D2ORDR: Function ''X'' - KDATA size must be at least',
     X        I2,' for actual spatial differencing).')
C
 9310 FORMAT (' D2ORDR: General extended packing implies ',A,'.')
 9348 FORMAT (
     X' D2ORDR: Bias sign management problem, DSGNBT return is',I5,'.')
 9365 FORMAT (' D2ORDR: First bit of secondary bit-map is not set.')
 9381 FORMAT (' D2ORDR: Packing method is ',A,'.')
 9382 FORMAT (' D2ORDR: Packing method is constant width, on',I3,
     X        ' bits.')
 9383 FORMAT (' D2ORDR: Boustrophedonic ordering used.')
 9384 FORMAT (' D2ORDR: Spatial differencing used, order is',I2,
     X        ', bias =',I9,'.')
 9385 FORMAT (' D2ORDR: IFIROV, ISECOV, IPTRFO, IPTRSO =',2I8,2I10,
     X        '.')
 9391 FORMAT (
     X ' D2ORDR: Bad pointer to general extended group size info.')
 9393 FORMAT (' D2ORDR: (',A,')',' pointers mismatch.')
C
 9401 FORMAT (' D2ORDR: ''X'' Function - KSEC4(',I2,':',I2,') = ',I3,
     X        8I6,'.')
 9410 FORMAT (' D2ORDR: Function ''X'' ',A,'.')
 9412 FORMAT (' D2ORDR: Function ''X'' valid only for 1 to',I3,
     X        ' points.')
 9413 FORMAT (' D2ORDR: Function ''X'' - KDATA size insufficient for',
     X        I2,' points requested.')
 9421 FORMAT (' D2ORDR: Function ''X'', Point',I6,',',I2,
     X        '-index not in range [1-',I6,'].')
 9422 FORMAT (' D2ORDR: JEXT, INDROW, INDCOL, ISKIP, ILNGTH =',
     X        I3,2I6,I8,I6,'.')
C
 9510 FORMAT (' D2ORDR: ',A,', groups',I6,'..',I6.6,'.')
 9540 FORMAT (' D2ORDR: mask, row',I6,', bit-map pointer =',I10,
     X        ', size requested=',I8,'.')
 9560 FORMAT (' D2ORDR: Pointers problem for primary bit-map,',
     X        ' row by row case.')
 9565 FORMAT (' D2ORDR: mask, row',I6,', length =',I6,' out of',I6,'.')
 9570 FORMAT (' D2ORDR: Grid-point number overflow:',I8,' >',I8,'.')
 9580 FORMAT (' D2ORDR: second-order values, ',A,I8,'.')
 9585 FORMAT (' D2ORDR: IEXT =',I3,', INPEXT =',I3,'.')
C
 9601 FORMAT (
     X  ' D2ORDR: Original number of bits -returned in KSEC4(2)-) =',
     X  I3,'.')
 9602 FORMAT (' D2ORDR: Values decoded -returned in KSEC4(1)- =',
     X        I8,'.')
 9610 FORMAT (' D2ORDR: Mismatch: sum of group lengths =',I8,
     X        ', expected =',I8,'.')
 9620 FORMAT (' D2ORDR: Final bit pointer is',I10,', expected =',I10,
     X        '.')
C
 9900 FORMAT (' D2ORDR: Function return code =',I6,', HOPER = ',A,
     X        ', KNSPT =',I10,'.')
C      
      END

c Copyright 1981-2012 ECMWF.
c
c This software is licensed under the terms of the Apache Licence 
c Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
c
c In applying this licence, ECMWF does not waive the privileges and immunities 
c granted to it by virtue of its status as an intergovernmental organisation 
c nor does it submit to any jurisdiction.
c

C     SUBROUTINE 'RPASSF' - PERFORMS ONE PASS THROUGH DATA AS PART      
C     OF MULTIPLE REAL FFT (FOURIER SYNTHESIS) ROUTINE                  
C                                                                       
C     A IS FIRST REAL INPUT VECTOR                                      
C         EQUIVALENCE B(1) WITH A (LA*INC1+1)                           
C     C IS FIRST REAL OUTPUT VECTOR                                     
C         EQUIVALENCE D(1) WITH C(IFAC*LA*INC2+1)                       
C     TRIGS IS A PRECALCULATED LIST OF SINES & COSINES                  
C     INC1 IS THE ADDRESSING INCREMENT FOR A                            
C     INC2 IS THE ADDRESSING INCREMENT FOR C                            
C     INC3 IS THE INCREMENT BETWEEN INPUT VECTORS A                     
C     INC4 IS THE INCREMENT BETWEEN OUTPUT VECTORS C                    
C     LOT IS THE NUMBER OF VECTORS                                      
C     N IS THE LENGTH OF THE VECTORS                                    
C     IFAC IS THE CURRENT FACTOR OF N                                   
C     LA IS THE PRODUCT OF PREVIOUS FACTORS                             
C     IERR IS AN ERROR INDICATOR:                                       
C              0 - PASS COMPLETED WITHOUT ERROR                         
C              2 - IFAC NOT CATERED FOR                                 
C              3 - IFAC ONLY CATERED FOR IF LA=N/IFAC                   
C     LIPL=.T. => RESULTS ARE RETURNED TO INPUT ARRAY
C              (ONLY VALID IF LA=N/IFAC, I.E. ON LAST PASS)
C                                                                       
C-----------------------------------------------------------------------
C                                                                       
      SUBROUTINE RPASSF(A,B,C,D,TRIGS,INC1,INC2,INC3,INC4,LOT,N,IFAC,   
     *    LA,IERR,LIPL)                                                      
      DIMENSION A(N),B(N),C(N),D(N),TRIGS(N)                            
      LOGICAL LIPL
C                                                                       
      DATA SIN36/0.587785252292473/,SIN72/0.951056516295154/,           
     *    QRT5/0.559016994374947/,SIN60/0.866025403784437/              
C                                                                       
      M=N/IFAC                                                          
      IINK=LA*INC1                                                      
      JINK=LA*INC2                                                      
      JUMP=(IFAC-1)*JINK                                                
      KSTOP=(N-IFAC)/(2*IFAC)                                           
C                                                                       
      IBASE=0                                                           
      JBASE=0                                                           
      IBAD=0                                                            
C
!     Increase the vector length by fusing the loops if the
!     data layout is appropriate:
      IF (INC1.EQ.LOT.AND.INC2.EQ.LOT.AND.INC3.EQ.1.AND.INC4.EQ.1) THEN
        ILA=1
        ILOT=LA*LOT
        INC21=LA*LOT
      ELSE
        ILA=LA
        ILOT=LOT
        INC21=INC2
      ENDIF
C
      IF (IFAC.EQ.2) THEN
C                                                                       
C     CODING FOR FACTOR 2                                               
C     -------------------                                               
  200 CONTINUE                                                          
      IA=1                                                              
      IB=IA+(2*M-LA)*INC1                                               
      JA=1                                                              
      JB=JA+JINK                                                        
C                                                                       
      IF (LA.NE.M) THEN                                            
C                                                                       
      DO 220 L=1,ILA                                                     
      I=IBASE                                                           
      J=JBASE                                                           
!OCL NOVREC                                                   
      DO 210 IJK=1,ILOT                                                  
      C(JA+J)=A(IA+I)+A(IB+I)                                           
      C(JB+J)=A(IA+I)-A(IB+I)                                           
      I=I+INC3                                                          
      J=J+INC4                                                          
  210 CONTINUE                                                          
      IBASE=IBASE+INC1                                                  
      JBASE=JBASE+INC21                                                  
  220 CONTINUE                                                          
      IA=IA+IINK                                                        
      IINK=2*IINK                                                       
      IB=IB-IINK                                                        
      IBASE=0                                                           
      JBASE=JBASE+JUMP                                                  
      JUMP=2*JUMP+JINK                                                  
C
      IF (IA.LT.IB) THEN                                           
      DO 250 K=LA,KSTOP,LA                                              
      KB=K+K                                                            
      C1=TRIGS(KB+1)                                                    
      S1=TRIGS(KB+2)                                                    
      IBASE=0                                                           
      DO 240 L=1,ILA                                                     
      I=IBASE                                                           
      J=JBASE                                                           
!OCL NOVREC                                                   
      DO 230 IJK=1,ILOT                                                  
      C(JA+J)=A(IA+I)+A(IB+I)                                           
      D(JA+J)=B(IA+I)-B(IB+I)                                           
      C(JB+J)=C1*(A(IA+I)-A(IB+I))-S1*(B(IA+I)+B(IB+I))                 
      D(JB+J)=S1*(A(IA+I)-A(IB+I))+C1*(B(IA+I)+B(IB+I))                 
      I=I+INC3                                                          
      J=J+INC4                                                          
  230 CONTINUE                                                          
      IBASE=IBASE+INC1                                                  
      JBASE=JBASE+INC21                                                  
  240 CONTINUE                                                          
      IA=IA+IINK                                                        
      IB=IB-IINK                                                        
      JBASE=JBASE+JUMP                                                  
  250 CONTINUE                                                          
      ENDIF
C
      IF (IA.EQ.IB) THEN                                           
      IBASE=0                                                           
      DO 280 L=1,ILA                                                     
      I=IBASE                                                           
      J=JBASE                                                           
!OCL NOVREC                                                   
      DO 270 IJK=1,ILOT                                                  
      C(JA+J)=A(IA+I)                                                   
      C(JB+J)=-B(IA+I)                                                  
      I=I+INC3                                                          
      J=J+INC4                                                          
  270 CONTINUE                                                          
      IBASE=IBASE+INC1                                                  
      JBASE=JBASE+INC21                                                  
  280 CONTINUE                                                          
      ENDIF                                                         
C                                                                       
      ELSE                !!! Case LA=M                                 
      IF (LIPL) THEN
        DO 294 L=1,ILA                                                     
        I=IBASE                                                           
!OCL NOVREC
        DO 292 IJK=1,ILOT                                                  
        T1=2.0*(A(IA+I)-A(IB+I))                                     
        A(IA+I)=2.0*(A(IA+I)+A(IB+I))                                     
        A(IB+I)=T1
        I=I+INC3                                                          
  292   CONTINUE                                                          
        IBASE=IBASE+INC1                                                  
  294   CONTINUE                                                          
      ELSE
        DO 298 L=1,ILA                                                     
        I=IBASE                                                           
        J=JBASE                                                           
!OCL NOVREC
        DO 296 IJK=1,ILOT                                                  
        C(JA+J)=2.0*(A(IA+I)+A(IB+I))                                     
        C(JB+J)=2.0*(A(IA+I)-A(IB+I))                                     
        I=I+INC3                                                          
        J=J+INC4                                                          
  296   CONTINUE                                                          
        IBASE=IBASE+INC1                                                  
        JBASE=JBASE+INC21                                                  
  298   CONTINUE                                                          
      ENDIF
      ENDIF
C
      ELSEIF (IFAC.EQ.3) THEN
C                                                                       
C     CODING FOR FACTOR 3                                               
C     -------------------                                               
  300 CONTINUE                                                          
      IA=1                                                              
      IB=IA+(2*M-LA)*INC1                                               
      IC=IB                                                             
      JA=1                                                              
      JB=JA+JINK                                                        
      JC=JB+JINK                                                        
C                                                                       
      IF (LA.NE.M) THEN                                            
C                                                                       
      DO 320 L=1,ILA                                                     
      I=IBASE                                                           
      J=JBASE                                                           
!OCL NOVREC                                                   
      DO 310 IJK=1,ILOT                                                  
      C(JA+J)=A(IA+I)+A(IB+I)                                           
      C(JB+J)=(A(IA+I)-0.5*A(IB+I))-(SIN60*(B(IB+I)))                   
      C(JC+J)=(A(IA+I)-0.5*A(IB+I))+(SIN60*(B(IB+I)))                   
      I=I+INC3                                                          
      J=J+INC4                                                          
  310 CONTINUE                                                          
      IBASE=IBASE+INC1                                                  
      JBASE=JBASE+INC21                                                  
  320 CONTINUE                                                          
      IA=IA+IINK                                                        
      IINK=2*IINK                                                       
      IB=IB+IINK                                                        
      IC=IC-IINK                                                        
      JBASE=JBASE+JUMP                                                  
      JUMP=2*JUMP+JINK                                                  
C
      IF (IA.LT.IC) THEN                                           
      DO 350 K=LA,KSTOP,LA                                              
      KB=K+K                                                            
      KC=KB+KB                                                          
      C1=TRIGS(KB+1)                                                    
      S1=TRIGS(KB+2)                                                    
      C2=TRIGS(KC+1)                                                    
      S2=TRIGS(KC+2)                                                    
      IBASE=0                                                           
      DO 340 L=1,ILA                                                     
      I=IBASE                                                           
      J=JBASE                                                           
!OCL NOVREC                                                   
      DO 330 IJK=1,ILOT                                                  
      C(JA+J)=A(IA+I)+(A(IB+I)+A(IC+I))                                 
      D(JA+J)=B(IA+I)+(B(IB+I)-B(IC+I))                                 
      C(JB+J)=                                                          
     *    C1*((A(IA+I)-0.5*(A(IB+I)+A(IC+I)))-(SIN60*(B(IB+I)+B(IC+I))))
     *   -S1*((B(IA+I)-0.5*(B(IB+I)-B(IC+I)))+(SIN60*(A(IB+I)-A(IC+I))))
      D(JB+J)=                                                          
     *    S1*((A(IA+I)-0.5*(A(IB+I)+A(IC+I)))-(SIN60*(B(IB+I)+B(IC+I))))
     *   +C1*((B(IA+I)-0.5*(B(IB+I)-B(IC+I)))+(SIN60*(A(IB+I)-A(IC+I))))
      C(JC+J)=                                                          
     *    C2*((A(IA+I)-0.5*(A(IB+I)+A(IC+I)))+(SIN60*(B(IB+I)+B(IC+I))))
     *   -S2*((B(IA+I)-0.5*(B(IB+I)-B(IC+I)))-(SIN60*(A(IB+I)-A(IC+I))))
      D(JC+J)=                                                          
     *    S2*((A(IA+I)-0.5*(A(IB+I)+A(IC+I)))+(SIN60*(B(IB+I)+B(IC+I))))
     *   +C2*((B(IA+I)-0.5*(B(IB+I)-B(IC+I)))-(SIN60*(A(IB+I)-A(IC+I))))
      I=I+INC3                                                          
      J=J+INC4                                                          
  330 CONTINUE                                                          
      IBASE=IBASE+INC1                                                  
      JBASE=JBASE+INC21                                                  
  340 CONTINUE                                                          
      IA=IA+IINK                                                        
      IB=IB+IINK                                                        
      IC=IC-IINK                                                        
      JBASE=JBASE+JUMP                                                  
  350 CONTINUE                                                          
      ENDIF
C
      IF (IA.EQ.IC) THEN                                           
      IBASE=0                                                           
      DO 380 L=1,ILA                                                     
      I=IBASE                                                           
      J=JBASE                                                           
!OCL NOVREC                                                   
      DO 370 IJK=1,ILOT                                                  
      C(JA+J)=A(IA+I)+A(IB+I)                                           
      C(JB+J)=(0.5*A(IA+I)-A(IB+I))-(SIN60*B(IA+I))                     
      C(JC+J)=-(0.5*A(IA+I)-A(IB+I))-(SIN60*B(IA+I))                    
      I=I+INC3                                                          
      J=J+INC4                                                          
  370 CONTINUE                                                          
      IBASE=IBASE+INC1                                                  
      JBASE=JBASE+INC21                                                  
  380 CONTINUE                                                          
      ENDIF                                                         
C                                                                       
      ELSE                !!! Case LA=M                                 
      SSIN60=2.0*SIN60                                                  
      IF (LIPL) THEN
        DO 394 L=1,ILA                                                     
        I=IBASE                                                           
!OCL NOVREC
        DO 392 IJK=1,ILOT                                                  
        T1=(2.0*A(IA+I)-A(IB+I))-(SSIN60*B(IB+I))                    
        T2=(2.0*A(IA+I)-A(IB+I))+(SSIN60*B(IB+I))                    
        A(IA+I)=2.0*(A(IA+I)+A(IB+I))                                     
        A(IB+I)=T1
        B(IB+I)=T2
        I=I+INC3                                                          
  392   CONTINUE                                                          
        IBASE=IBASE+INC1                                                  
  394   CONTINUE                                                          
      ELSE
        DO 398 L=1,ILA                                                     
        I=IBASE                                                           
        J=JBASE                                                           
!OCL NOVREC
        DO 396 IJK=1,ILOT                                                  
        C(JA+J)=2.0*(A(IA+I)+A(IB+I))                                     
        C(JB+J)=(2.0*A(IA+I)-A(IB+I))-(SSIN60*B(IB+I))                    
        C(JC+J)=(2.0*A(IA+I)-A(IB+I))+(SSIN60*B(IB+I))                    
        I=I+INC3                                                          
        J=J+INC4                                                          
  396   CONTINUE                                                          
        IBASE=IBASE+INC1                                                  
        JBASE=JBASE+INC21                                                  
  398   CONTINUE                                                          
      ENDIF
      ENDIF
C
      ELSEIF (IFAC.EQ.4) THEN
C                                                                       
C     CODING FOR FACTOR 4                                               
C     -------------------                                               
  400 CONTINUE                                                          
      IA=1                                                              
      IB=IA+(2*M-LA)*INC1                                               
      IC=IB+2*M*INC1                                                    
      ID=IB                                                             
      JA=1                                                              
      JB=JA+JINK                                                        
      JC=JB+JINK                                                        
      JD=JC+JINK                                                        
C                                                                       
      IF (LA.NE.M) THEN                                            
C                                                                       
      DO 420 L=1,ILA                                                     
      I=IBASE                                                           
      J=JBASE                                                           
!OCL NOVREC                                                   
      DO 410 IJK=1,ILOT                                                  
      C(JA+J)=(A(IA+I)+A(IC+I))+A(IB+I)                                 
      C(JB+J)=(A(IA+I)-A(IC+I))-B(IB+I)                                 
      C(JC+J)=(A(IA+I)+A(IC+I))-A(IB+I)                                 
      C(JD+J)=(A(IA+I)-A(IC+I))+B(IB+I)                                 
      I=I+INC3                                                          
      J=J+INC4                                                          
  410 CONTINUE                                                          
      IBASE=IBASE+INC1                                                  
      JBASE=JBASE+INC21                                                  
  420 CONTINUE                                                          
      IA=IA+IINK                                                        
      IINK=2*IINK                                                       
      IB=IB+IINK                                                        
      IC=IC-IINK                                                        
      ID=ID-IINK                                                        
      JBASE=JBASE+JUMP                                                  
      JUMP=2*JUMP+JINK                                                  
C
      IF (IB.LT.IC) THEN                                           
      DO 450 K=LA,KSTOP,LA                                              
      KB=K+K                                                            
      KC=KB+KB                                                          
      KD=KC+KB                                                          
      C1=TRIGS(KB+1)                                                    
      S1=TRIGS(KB+2)                                                    
      C2=TRIGS(KC+1)                                                    
      S2=TRIGS(KC+2)                                                    
      C3=TRIGS(KD+1)                                                    
      S3=TRIGS(KD+2)                                                    
      IBASE=0                                                           
      DO 440 L=1,ILA                                                     
      I=IBASE                                                           
      J=JBASE                                                           
!OCL NOVREC                                                   
      DO 430 IJK=1,ILOT                                                  
      C(JA+J)=(A(IA+I)+A(IC+I))+(A(IB+I)+A(ID+I))                       
      D(JA+J)=(B(IA+I)-B(IC+I))+(B(IB+I)-B(ID+I))                       
      C(JC+J)=                                                          
     *    C2*((A(IA+I)+A(IC+I))-(A(IB+I)+A(ID+I)))                      
     *   -S2*((B(IA+I)-B(IC+I))-(B(IB+I)-B(ID+I)))                      
      D(JC+J)=                                                          
     *    S2*((A(IA+I)+A(IC+I))-(A(IB+I)+A(ID+I)))                      
     *   +C2*((B(IA+I)-B(IC+I))-(B(IB+I)-B(ID+I)))                      
      C(JB+J)=                                                          
     *    C1*((A(IA+I)-A(IC+I))-(B(IB+I)+B(ID+I)))                      
     *   -S1*((B(IA+I)+B(IC+I))+(A(IB+I)-A(ID+I)))                      
      D(JB+J)=                                                          
     *    S1*((A(IA+I)-A(IC+I))-(B(IB+I)+B(ID+I)))                      
     *   +C1*((B(IA+I)+B(IC+I))+(A(IB+I)-A(ID+I)))                      
      C(JD+J)=                                                          
     *    C3*((A(IA+I)-A(IC+I))+(B(IB+I)+B(ID+I)))                      
     *   -S3*((B(IA+I)+B(IC+I))-(A(IB+I)-A(ID+I)))                      
      D(JD+J)=                                                          
     *    S3*((A(IA+I)-A(IC+I))+(B(IB+I)+B(ID+I)))                      
     *   +C3*((B(IA+I)+B(IC+I))-(A(IB+I)-A(ID+I)))                      
      I=I+INC3                                                          
      J=J+INC4                                                          
  430 CONTINUE                                                          
      IBASE=IBASE+INC1                                                  
      JBASE=JBASE+INC21                                                  
  440 CONTINUE                                                          
      IA=IA+IINK                                                        
      IB=IB+IINK                                                        
      IC=IC-IINK                                                        
      ID=ID-IINK                                                        
      JBASE=JBASE+JUMP                                                  
  450 CONTINUE                                                          
      ENDIF
C
      IF (IB.EQ.IC) THEN                                           
      IBASE=0                                                           
      SIN45=SQRT(0.5)                                                   
      DO 480 L=1,ILA                                                     
      I=IBASE                                                           
      J=JBASE                                                           
!OCL NOVREC                                                   
      DO 470 IJK=1,ILOT                                                  
      C(JA+J)=A(IA+I)+A(IB+I)                                           
      C(JB+J)=SIN45*((A(IA+I)-A(IB+I))-(B(IA+I)+B(IB+I)))               
      C(JC+J)=B(IB+I)-B(IA+I)                                           
      C(JD+J)=-SIN45*((A(IA+I)-A(IB+I))+(B(IA+I)+B(IB+I)))              
      I=I+INC3                                                          
      J=J+INC4                                                          
  470 CONTINUE                                                          
      IBASE=IBASE+INC1                                                  
      JBASE=JBASE+INC21                                                  
  480 CONTINUE                                                          
      ENDIF                                                             
C                                                                       
      ELSE                !!! Case LA=M                                 
      IF (LIPL) THEN
        DO 494 L=1,ILA                                                     
        I=IBASE                                                           
!OCL NOVREC
        DO 492 IJK=1,ILOT                                                  
        T1=2.0*((A(IA+I)-A(IC+I))-B(IB+I))                           
        T2=2.0*((A(IA+I)+A(IC+I))-A(IB+I))                           
        T3=2.0*((A(IA+I)-A(IC+I))+B(IB+I))                           
        A(IA+I)=2.0*((A(IA+I)+A(IC+I))+A(IB+I))                           
        A(IB+I)=T1
        B(IB+I)=T2
        A(IC+I)=T3
        I=I+INC3                                                          
  492   CONTINUE                                                          
        IBASE=IBASE+INC1                                                  
  494   CONTINUE                                                          
      ELSE
        DO 498 L=1,ILA                                                     
        I=IBASE                                                           
        J=JBASE                                                           
!OCL NOVREC
        DO 496 IJK=1,ILOT                                                  
        C(JA+J)=2.0*((A(IA+I)+A(IC+I))+A(IB+I))                           
        C(JB+J)=2.0*((A(IA+I)-A(IC+I))-B(IB+I))                           
        C(JC+J)=2.0*((A(IA+I)+A(IC+I))-A(IB+I))                           
        C(JD+J)=2.0*((A(IA+I)-A(IC+I))+B(IB+I))                           
        I=I+INC3                                                          
        J=J+INC4                                                          
  496   CONTINUE                                                          
        IBASE=IBASE+INC1                                                  
        JBASE=JBASE+INC21                                                  
  498   CONTINUE                                                          
      ENDIF
      ENDIF
C
      ELSEIF (IFAC.EQ.5) THEN
C                                                                       
C     CODING FOR FACTOR 5                                               
C     -------------------                                               
  500 CONTINUE                                                          
      IA=1                                                              
      IB=IA+(2*M-LA)*INC1                                               
      IC=IB+2*M*INC1                                                    
      ID=IC                                                             
      IE=IB                                                             
      JA=1                                                              
      JB=JA+JINK                                                        
      JC=JB+JINK                                                        
      JD=JC+JINK                                                        
      JE=JD+JINK                                                        
C                                                                       
      IF (LA.NE.M) THEN                                                 
C                                                                       
      DO 520 L=1,ILA                                                     
      I=IBASE                                                           
      J=JBASE                                                           
!OCL NOVREC                                                   
      DO 510 IJK=1,ILOT                                                  
      C(JA+J)=A(IA+I)+(A(IB+I)+A(IC+I))                                 
      C(JB+J)=((A(IA+I)-0.25*(A(IB+I)+A(IC+I)))+QRT5*(A(IB+I)-A(IC+I))) 
     *    -(SIN72*B(IB+I)+SIN36*B(IC+I))                                
      C(JC+J)=((A(IA+I)-0.25*(A(IB+I)+A(IC+I)))-QRT5*(A(IB+I)-A(IC+I))) 
     *    -(SIN36*B(IB+I)-SIN72*B(IC+I))                                
      C(JD+J)=((A(IA+I)-0.25*(A(IB+I)+A(IC+I)))-QRT5*(A(IB+I)-A(IC+I))) 
     *    +(SIN36*B(IB+I)-SIN72*B(IC+I))                                
      C(JE+J)=((A(IA+I)-0.25*(A(IB+I)+A(IC+I)))+QRT5*(A(IB+I)-A(IC+I))) 
     *    +(SIN72*B(IB+I)+SIN36*B(IC+I))                                
      I=I+INC3                                                          
      J=J+INC4                                                          
  510 CONTINUE                                                          
      IBASE=IBASE+INC1                                                  
      JBASE=JBASE+INC21                                                  
  520 CONTINUE                                                          
      IA=IA+IINK                                                        
      IINK=2*IINK                                                       
      IB=IB+IINK                                                        
      IC=IC+IINK                                                        
      ID=ID-IINK                                                        
      IE=IE-IINK                                                        
      JBASE=JBASE+JUMP                                                  
      JUMP=2*JUMP+JINK                                                  
C
      IF (IB.LT.ID) THEN                                                
      DO 550 K=LA,KSTOP,LA                                              
      KB=K+K                                                            
      KC=KB+KB                                                          
      KD=KC+KB                                                          
      KE=KD+KB                                                          
      C1=TRIGS(KB+1)                                                    
      S1=TRIGS(KB+2)                                                    
      C2=TRIGS(KC+1)                                                    
      S2=TRIGS(KC+2)                                                    
      C3=TRIGS(KD+1)                                                    
      S3=TRIGS(KD+2)                                                    
      C4=TRIGS(KE+1)                                                    
      S4=TRIGS(KE+2)                                                    
      IBASE=0                                                           
      DO 540 L=1,ILA                                                     
      I=IBASE                                                           
      J=JBASE                                                           
!OCL NOVREC                                                   
      DO 530 IJK=1,ILOT                                                  
C                                                                       
      A10=(A(IA+I)-0.25*((A(IB+I)+A(IE+I))+(A(IC+I)+A(ID+I))))          
     *    +QRT5*((A(IB+I)+A(IE+I))-(A(IC+I)+A(ID+I)))                   
      A20=(A(IA+I)-0.25*((A(IB+I)+A(IE+I))+(A(IC+I)+A(ID+I))))          
     *    -QRT5*((A(IB+I)+A(IE+I))-(A(IC+I)+A(ID+I)))                   
      B10=(B(IA+I)-0.25*((B(IB+I)-B(IE+I))+(B(IC+I)-B(ID+I))))          
     *    +QRT5*((B(IB+I)-B(IE+I))-(B(IC+I)-B(ID+I)))                   
      B20=(B(IA+I)-0.25*((B(IB+I)-B(IE+I))+(B(IC+I)-B(ID+I))))          
     *    -QRT5*((B(IB+I)-B(IE+I))-(B(IC+I)-B(ID+I)))                   
      A11=SIN72*(B(IB+I)+B(IE+I))+SIN36*(B(IC+I)+B(ID+I))               
      A21=SIN36*(B(IB+I)+B(IE+I))-SIN72*(B(IC+I)+B(ID+I))               
      B11=SIN72*(A(IB+I)-A(IE+I))+SIN36*(A(IC+I)-A(ID+I))               
      B21=SIN36*(A(IB+I)-A(IE+I))-SIN72*(A(IC+I)-A(ID+I))               
C                                                                       
      C(JA+J)=A(IA+I)+((A(IB+I)+A(IE+I))+(A(IC+I)+A(ID+I)))             
      D(JA+J)=B(IA+I)+((B(IB+I)-B(IE+I))+(B(IC+I)-B(ID+I)))             
      C(JB+J)=C1*(A10-A11)-S1*(B10+B11)                                 
      D(JB+J)=S1*(A10-A11)+C1*(B10+B11)                                 
      C(JE+J)=C4*(A10+A11)-S4*(B10-B11)                                 
      D(JE+J)=S4*(A10+A11)+C4*(B10-B11)                                 
      C(JC+J)=C2*(A20-A21)-S2*(B20+B21)                                 
      D(JC+J)=S2*(A20-A21)+C2*(B20+B21)                                 
      C(JD+J)=C3*(A20+A21)-S3*(B20-B21)                                 
      D(JD+J)=S3*(A20+A21)+C3*(B20-B21)                                 
C                                                                       
      I=I+INC3                                                          
      J=J+INC4                                                          
  530 CONTINUE                                                          
      IBASE=IBASE+INC1                                                  
      JBASE=JBASE+INC21                                                  
  540 CONTINUE                                                          
      IA=IA+IINK                                                        
      IB=IB+IINK                                                        
      IC=IC+IINK                                                        
      ID=ID-IINK                                                        
      IE=IE-IINK                                                        
      JBASE=JBASE+JUMP                                                  
  550 CONTINUE                                                          
      ENDIF
C
      IF (IB.EQ.ID) THEN                                                
      IBASE=0                                                           
      DO 580 L=1,ILA                                                     
      I=IBASE                                                           
      J=JBASE                                                           
!OCL NOVREC                                                   
      DO 570 IJK=1,ILOT                                                  
      C(JA+J)=(A(IA+I)+A(IB+I))+A(IC+I)                                 
      C(JB+J)=(QRT5*(A(IA+I)-A(IB+I))+(0.25*(A(IA+I)+A(IB+I))-A(IC+I))) 
     *    -(SIN36*B(IA+I)+SIN72*B(IB+I))                                
      C(JE+J)=-(QRT5*(A(IA+I)-A(IB+I))+(0.25*(A(IA+I)+A(IB+I))-A(IC+I)))
     *    -(SIN36*B(IA+I)+SIN72*B(IB+I))                                
      C(JC+J)=(QRT5*(A(IA+I)-A(IB+I))-(0.25*(A(IA+I)+A(IB+I))-A(IC+I))) 
     *    -(SIN72*B(IA+I)-SIN36*B(IB+I))                                
      C(JD+J)=-(QRT5*(A(IA+I)-A(IB+I))-(0.25*(A(IA+I)+A(IB+I))-A(IC+I)))
     *    -(SIN72*B(IA+I)-SIN36*B(IB+I))                                
      I=I+INC3                                                          
      J=J+INC4                                                          
  570 CONTINUE                                                          
      IBASE=IBASE+INC1                                                  
      JBASE=JBASE+INC21                                                  
  580 CONTINUE                                                          
      ENDIF                                                             
C                                                                       
      ELSE               !!! Case LA=M                                  
      QQRT5=2.0*QRT5                                                    
      SSIN36=2.0*SIN36                                                  
      SSIN72=2.0*SIN72                                                  
      IF (LIPL) THEN
        DO 594 L=1,ILA                                                     
        I=IBASE                                                           
!OCL NOVREC
        DO 592 IJK=1,ILOT                                                  
        T1=(2.0*(A(IA+I)-0.25*(A(IB+I)+A(IC+I)))                     
     *    +QQRT5*(A(IB+I)-A(IC+I)))-(SSIN72*B(IB+I)+SSIN36*B(IC+I))     
        T2=(2.0*(A(IA+I)-0.25*(A(IB+I)+A(IC+I)))                     
     *    -QQRT5*(A(IB+I)-A(IC+I)))-(SSIN36*B(IB+I)-SSIN72*B(IC+I))     
        T3=(2.0*(A(IA+I)-0.25*(A(IB+I)+A(IC+I)))                     
     *    -QQRT5*(A(IB+I)-A(IC+I)))+(SSIN36*B(IB+I)-SSIN72*B(IC+I))     
        T4=(2.0*(A(IA+I)-0.25*(A(IB+I)+A(IC+I)))                     
     *    +QQRT5*(A(IB+I)-A(IC+I)))+(SSIN72*B(IB+I)+SSIN36*B(IC+I))     
        A(IA+I)=2.0*(A(IA+I)+(A(IB+I)+A(IC+I)))                           
        A(IB+I)=T1
        B(IB+I)=T2
        A(IC+I)=T3
        B(IC+I)=T4
        I=I+INC3                                                          
  592   CONTINUE                                                          
        IBASE=IBASE+INC1                                                  
  594   CONTINUE                                                          
      ELSE
        DO 598 L=1,ILA                                                     
        I=IBASE                                                           
        J=JBASE                                                           
!OCL NOVREC
        DO 596 IJK=1,ILOT                                                  
        C(JA+J)=2.0*(A(IA+I)+(A(IB+I)+A(IC+I)))                           
        C(JB+J)=(2.0*(A(IA+I)-0.25*(A(IB+I)+A(IC+I)))                     
     *    +QQRT5*(A(IB+I)-A(IC+I)))-(SSIN72*B(IB+I)+SSIN36*B(IC+I))     
        C(JC+J)=(2.0*(A(IA+I)-0.25*(A(IB+I)+A(IC+I)))                     
     *    -QQRT5*(A(IB+I)-A(IC+I)))-(SSIN36*B(IB+I)-SSIN72*B(IC+I))     
        C(JD+J)=(2.0*(A(IA+I)-0.25*(A(IB+I)+A(IC+I)))                     
     *    -QQRT5*(A(IB+I)-A(IC+I)))+(SSIN36*B(IB+I)-SSIN72*B(IC+I))     
        C(JE+J)=(2.0*(A(IA+I)-0.25*(A(IB+I)+A(IC+I)))                     
     *    +QQRT5*(A(IB+I)-A(IC+I)))+(SSIN72*B(IB+I)+SSIN36*B(IC+I))     
        I=I+INC3                                                          
        J=J+INC4                                                          
  596   CONTINUE                                                          
        IBASE=IBASE+INC1                                                  
        JBASE=JBASE+INC21                                                  
  598   CONTINUE                                                          
      ENDIF
      ENDIF
C
      ELSEIF (IFAC.EQ.6) THEN
C                                                                       
C     CODING FOR FACTOR 6                                               
C     -------------------                                               
  600 CONTINUE                                                          
      IA=1                                                              
      IB=IA+(2*M-LA)*INC1                                               
      IC=IB+2*M*INC1                                                    
      ID=IC+2*M*INC1                                                    
      IE=IC                                                             
      IF=IB                                                             
      JA=1                                                              
      JB=JA+JINK                                                        
      JC=JB+JINK                                                        
      JD=JC+JINK                                                        
      JE=JD+JINK                                                        
      JF=JE+JINK                                                        
C                                                                       
      IF (LA.NE.M) THEN                                                 
C                                                                       
      DO 620 L=1,ILA                                                     
      I=IBASE                                                           
      J=JBASE                                                           
!OCL NOVREC                                                   
      DO 610 IJK=1,ILOT                                                  
      C(JA+J)=(A(IA+I)+A(ID+I))+(A(IB+I)+A(IC+I))                       
      C(JD+J)=(A(IA+I)-A(ID+I))-(A(IB+I)-A(IC+I))                       
      C(JB+J)=((A(IA+I)-A(ID+I))+0.5*(A(IB+I)-A(IC+I)))                 
     *    -(SIN60*(B(IB+I)+B(IC+I)))                                    
      C(JF+J)=((A(IA+I)-A(ID+I))+0.5*(A(IB+I)-A(IC+I)))                 
     *    +(SIN60*(B(IB+I)+B(IC+I)))                                    
      C(JC+J)=((A(IA+I)+A(ID+I))-0.5*(A(IB+I)+A(IC+I)))                 
     *    -(SIN60*(B(IB+I)-B(IC+I)))                                    
      C(JE+J)=((A(IA+I)+A(ID+I))-0.5*(A(IB+I)+A(IC+I)))                 
     *    +(SIN60*(B(IB+I)-B(IC+I)))                                    
      I=I+INC3                                                          
      J=J+INC4                                                          
  610 CONTINUE                                                          
      IBASE=IBASE+INC1                                                  
      JBASE=JBASE+INC21                                                  
  620 CONTINUE                                                          
      IA=IA+IINK                                                        
      IINK=2*IINK                                                       
      IB=IB+IINK                                                        
      IC=IC+IINK                                                        
      ID=ID-IINK                                                        
      IE=IE-IINK                                                        
      IF=IF-IINK                                                        
      JBASE=JBASE+JUMP                                                  
      JUMP=2*JUMP+JINK                                                  
C
      IF (IC.LT.ID) THEN                                                
      DO 650 K=LA,KSTOP,LA                                              
      KB=K+K                                                            
      KC=KB+KB                                                          
      KD=KC+KB                                                          
      KE=KD+KB                                                          
      KF=KE+KB                                                          
      C1=TRIGS(KB+1)                                                    
      S1=TRIGS(KB+2)                                                    
      C2=TRIGS(KC+1)                                                    
      S2=TRIGS(KC+2)                                                    
      C3=TRIGS(KD+1)                                                    
      S3=TRIGS(KD+2)                                                    
      C4=TRIGS(KE+1)                                                    
      S4=TRIGS(KE+2)                                                    
      C5=TRIGS(KF+1)                                                    
      S5=TRIGS(KF+2)                                                    
      IBASE=0                                                           
      DO 640 L=1,ILA                                                     
      I=IBASE                                                           
      J=JBASE                                                           
!OCL NOVREC                                                   
      DO 630 IJK=1,ILOT                                                  
C                                                                       
      A11= (A(IE+I)+A(IB+I))+(A(IC+I)+A(IF+I))                          
      A20=(A(IA+I)+A(ID+I))-0.5*A11                                     
      A21=SIN60*((A(IE+I)+A(IB+I))-(A(IC+I)+A(IF+I)))                   
      B11= (B(IB+I)-B(IE+I))+(B(IC+I)-B(IF+I))                          
      B20=(B(IA+I)-B(ID+I))-0.5*B11                                     
      B21=SIN60*((B(IB+I)-B(IE+I))-(B(IC+I)-B(IF+I)))                   
C                                                                       
      C(JA+J)=(A(IA+I)+A(ID+I))+A11                                     
      D(JA+J)=(B(IA+I)-B(ID+I))+B11                                     
      C(JC+J)=C2*(A20-B21)-S2*(B20+A21)                                 
      D(JC+J)=S2*(A20-B21)+C2*(B20+A21)                                 
      C(JE+J)=C4*(A20+B21)-S4*(B20-A21)                                 
      D(JE+J)=S4*(A20+B21)+C4*(B20-A21)                                 
C                                                                       
      A11=(A(IE+I)-A(IB+I))+(A(IC+I)-A(IF+I))                           
      B11=(B(IE+I)+B(IB+I))-(B(IC+I)+B(IF+I))                           
      A20=(A(IA+I)-A(ID+I))-0.5*A11                                     
      A21=SIN60*((A(IE+I)-A(IB+I))-(A(IC+I)-A(IF+I)))                   
      B20=(B(IA+I)+B(ID+I))+0.5*B11                                     
      B21=SIN60*((B(IE+I)+B(IB+I))+(B(IC+I)+B(IF+I)))                   
C                                                                       
      C(JD+J)=                                                          
     *  C3*((A(IA+I)-A(ID+I))+A11)-S3*((B(IA+I)+B(ID+I))-B11)           
      D(JD+J)=                                                          
     *  S3*((A(IA+I)-A(ID+I))+A11)+C3*((B(IA+I)+B(ID+I))-B11)           
      C(JB+J)=C1*(A20-B21)-S1*(B20-A21)                                 
      D(JB+J)=S1*(A20-B21)+C1*(B20-A21)                                 
      C(JF+J)=C5*(A20+B21)-S5*(B20+A21)                                 
      D(JF+J)=S5*(A20+B21)+C5*(B20+A21)                                 
C                                                                       
      I=I+INC3                                                          
      J=J+INC4                                                          
  630 CONTINUE                                                          
      IBASE=IBASE+INC1                                                  
      JBASE=JBASE+INC21                                                  
  640 CONTINUE                                                          
      IA=IA+IINK                                                        
      IB=IB+IINK                                                        
      IC=IC+IINK                                                        
      ID=ID-IINK                                                        
      IE=IE-IINK                                                        
      IF=IF-IINK                                                        
      JBASE=JBASE+JUMP                                                  
  650 CONTINUE                                                          
      ENDIF
C
      IF (IC.EQ.ID) THEN                                                
      IBASE=0                                                           
      DO 680 L=1,ILA                                                     
      I=IBASE                                                           
      J=JBASE                                                           
!OCL NOVREC                                                   
      DO 670 IJK=1,ILOT                                                  
      C(JA+J)=A(IB+I)+(A(IA+I)+A(IC+I))                                 
      C(JD+J)=B(IB+I)-(B(IA+I)+B(IC+I))                                 
      C(JB+J)=(SIN60*(A(IA+I)-A(IC+I)))-(0.5*(B(IA+I)+B(IC+I))+B(IB+I)) 
      C(JF+J)=-(SIN60*(A(IA+I)-A(IC+I)))-(0.5*(B(IA+I)+B(IC+I))+B(IB+I))
      C(JC+J)=SIN60*(B(IC+I)-B(IA+I))+(0.5*(A(IA+I)+A(IC+I))-A(IB+I))   
      C(JE+J)=SIN60*(B(IC+I)-B(IA+I))-(0.5*(A(IA+I)+A(IC+I))-A(IB+I))   
      I=I+INC3                                                          
      J=J+INC4                                                          
  670 CONTINUE                                                          
      IBASE=IBASE+INC1                                                  
      JBASE=JBASE+INC21                                                  
  680 CONTINUE                                                          
      ENDIF                                                             
C                                                                       
      ELSE                 !!! Case LA=M                                
      SSIN60=2.0*SIN60                                                  
      IF (LIPL) THEN
        DO 694 L=1,ILA                                                     
        I=IBASE                                                           
!OCL NOVREC
        DO 692 IJK=1,ILOT                                                  
        T1=(2.0*(A(IA+I)-A(ID+I))+(A(IB+I)-A(IC+I)))                 
     *    -(SSIN60*(B(IB+I)+B(IC+I)))                                   
        T5=(2.0*(A(IA+I)-A(ID+I))+(A(IB+I)-A(IC+I)))                 
     *    +(SSIN60*(B(IB+I)+B(IC+I)))                                   
        T2=(2.0*(A(IA+I)+A(ID+I))-(A(IB+I)+A(IC+I)))                 
     *    -(SSIN60*(B(IB+I)-B(IC+I)))                                   
        T4=(2.0*(A(IA+I)+A(ID+I))-(A(IB+I)+A(IC+I)))                 
     *    +(SSIN60*(B(IB+I)-B(IC+I)))                                   
        T3=(2.0*(A(IA+I)-A(ID+I)))-(2.0*(A(IB+I)-A(IC+I)))           
        A(IA+I)=(2.0*(A(IA+I)+A(ID+I)))+(2.0*(A(IB+I)+A(IC+I)))           
        A(IB+I)=T1
        B(IB+I)=T2
        A(IC+I)=T3
        B(IC+I)=T4
        A(ID+I)=T5
        I=I+INC3                                                          
  692   CONTINUE                                                          
        IBASE=IBASE+INC1                                                  
  694   CONTINUE                                                          
      ELSE
        DO 698 L=1,ILA                                                     
        I=IBASE                                                           
        J=JBASE                                                           
!OCL NOVREC
        DO 696 IJK=1,ILOT                                                  
        C(JA+J)=(2.0*(A(IA+I)+A(ID+I)))+(2.0*(A(IB+I)+A(IC+I)))           
        C(JD+J)=(2.0*(A(IA+I)-A(ID+I)))-(2.0*(A(IB+I)-A(IC+I)))           
        C(JB+J)=(2.0*(A(IA+I)-A(ID+I))+(A(IB+I)-A(IC+I)))                 
     *    -(SSIN60*(B(IB+I)+B(IC+I)))                                   
        C(JF+J)=(2.0*(A(IA+I)-A(ID+I))+(A(IB+I)-A(IC+I)))                 
     *    +(SSIN60*(B(IB+I)+B(IC+I)))                                   
        C(JC+J)=(2.0*(A(IA+I)+A(ID+I))-(A(IB+I)+A(IC+I)))                 
     *    -(SSIN60*(B(IB+I)-B(IC+I)))                                   
        C(JE+J)=(2.0*(A(IA+I)+A(ID+I))-(A(IB+I)+A(IC+I)))                 
     *    +(SSIN60*(B(IB+I)-B(IC+I)))                                   
        I=I+INC3                                                          
        J=J+INC4                                                          
  696   CONTINUE                                                          
        IBASE=IBASE+INC1                                                  
        JBASE=JBASE+INC21                                                  
  698   CONTINUE                                                          
      ENDIF
      ENDIF
C
      ELSEIF (IFAC.EQ.8) THEN
C                                                                       
C     CODING FOR FACTOR 8                                               
C     -------------------                                               
  800 CONTINUE                                                          
      IF (LA.NE.M) THEN                                            
        IBAD=3
      ELSE
      IA=1                                                              
      IB=IA+LA*INC1                                                     
      IC=IB+2*LA*INC1                                                   
      ID=IC+2*LA*INC1                                                   
      IE=ID+2*LA*INC1                                                   
      JA=1                                                              
      JB=JA+JINK                                                        
      JC=JB+JINK                                                        
      JD=JC+JINK                                                        
      JE=JD+JINK                                                        
      JF=JE+JINK                                                        
      JG=JF+JINK                                                        
      JH=JG+JINK                                                        
      SSIN45=SQRT(2.0)                                                  
C                                                                       
      IF (LIPL) THEN
        DO 820 L=1,ILA                                                     
        I=IBASE                                                           
!OCL NOVREC
        DO 810 IJK=1,ILOT                                                  
        T2=2.0*(((A(IA+I)+A(IE+I))-A(IC+I))-(B(IB+I)-B(ID+I)))       
        T6=2.0*(((A(IA+I)+A(IE+I))-A(IC+I))+(B(IB+I)-B(ID+I)))       
        T1=2.0*((A(IA+I)-A(IE+I))-B(IC+I))                           
     *    +SSIN45*((A(IB+I)-A(ID+I))-(B(IB+I)+B(ID+I)))                 
        T5=2.0*((A(IA+I)-A(IE+I))-B(IC+I))                           
     *    -SSIN45*((A(IB+I)-A(ID+I))-(B(IB+I)+B(ID+I)))                 
        T3=2.0*((A(IA+I)-A(IE+I))+B(IC+I))                           
     *    -SSIN45*((A(IB+I)-A(ID+I))+(B(IB+I)+B(ID+I)))                 
        T7=2.0*((A(IA+I)-A(IE+I))+B(IC+I))                           
     *    +SSIN45*((A(IB+I)-A(ID+I))+(B(IB+I)+B(ID+I)))                 
        T4=2.0*(((A(IA+I)+A(IE+I))+A(IC+I))-(A(IB+I)+A(ID+I)))       
        A(IA+I)=2.0*(((A(IA+I)+A(IE+I))+A(IC+I))+(A(IB+I)+A(ID+I)))       
        A(IB+I)=T1
        B(IB+I)=T2
        A(IC+I)=T3
        B(IC+I)=T4
        A(ID+I)=T5
        B(ID+I)=T6
        A(IE+I)=T7  
        I=I+INC3                                                          
  810   CONTINUE                                                          
        IBASE=IBASE+INC1                                                  
  820   CONTINUE                                                          
      ELSE
        DO 840 L=1,ILA                                                     
        I=IBASE                                                           
        J=JBASE                                                           
!OCL NOVREC
        DO 830 IJK=1,ILOT                                                  
        C(JA+J)=2.0*(((A(IA+I)+A(IE+I))+A(IC+I))+(A(IB+I)+A(ID+I)))       
        C(JE+J)=2.0*(((A(IA+I)+A(IE+I))+A(IC+I))-(A(IB+I)+A(ID+I)))       
        C(JC+J)=2.0*(((A(IA+I)+A(IE+I))-A(IC+I))-(B(IB+I)-B(ID+I)))       
        C(JG+J)=2.0*(((A(IA+I)+A(IE+I))-A(IC+I))+(B(IB+I)-B(ID+I)))       
        C(JB+J)=2.0*((A(IA+I)-A(IE+I))-B(IC+I))                           
     *    +SSIN45*((A(IB+I)-A(ID+I))-(B(IB+I)+B(ID+I)))                 
        C(JF+J)=2.0*((A(IA+I)-A(IE+I))-B(IC+I))                           
     *    -SSIN45*((A(IB+I)-A(ID+I))-(B(IB+I)+B(ID+I)))                 
        C(JD+J)=2.0*((A(IA+I)-A(IE+I))+B(IC+I))                           
     *    -SSIN45*((A(IB+I)-A(ID+I))+(B(IB+I)+B(ID+I)))                 
        C(JH+J)=2.0*((A(IA+I)-A(IE+I))+B(IC+I))                           
     *    +SSIN45*((A(IB+I)-A(ID+I))+(B(IB+I)+B(ID+I)))                 
        I=I+INC3                                                          
        J=J+INC4                                                          
  830   CONTINUE                                                          
        IBASE=IBASE+INC1                                                  
        JBASE=JBASE+INC21                                                  
  840   CONTINUE                                                          
      ENDIF
C
      ENDIF
C
      ELSE
C
      IBAD=2       !!! Illegal factor
C
      ENDIF
C                                                                       
C     RETURN                                                            
C     ------                                                            
  900 CONTINUE                                                          
      IERR=IBAD                                                         
      RETURN                                                            
      END                                                               

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C


      SUBROUTINE REPCHR (HCHAR,HOLD,HNEW)
C
C---->
C**** REPCHR - Replace one character by another.
C
C     Purpose.
C     --------
C
C           Replace all occurrences of a given character in a
C           character string by another.
C
C**   Interface.
C     ----------
C
C           CALL REPCHR (HCHAR,HOLD,HNEW)
C
C           Integer    K.
C           Real       P.
C           Logical    O.
C           Character  H.
C
C               Input parameters.
C               -----------------
C
C               HCHAR      - Character string to be modified.
C               HOLD       - Character to be replaced.
C               HNEW       - Replacement character.
C
C               Output parameters.
C               ------------------
C
C               HCHAR      - Modified character string.
C
C     Method.
C     -------
C
C           Characters examined in sequence and changed if necessary.
C           Only the first character of the strings HOLD and HNEW is
C           used, if these are longer than 1 character.
C
C     Externals.
C     ----------
C
C           None.
C
C     Reference.
C     ----------
C
C           None.
C
C     Comments.
C     ---------
C
C           Program contains sections 0 to 1 and section 9.
C
C     Author.
C     -------
C
C           J. Hennessy      ECMWF      16.01:92.
C
C     Modifications
C     --------------
C
C           None.
C
C     ----------------------------------------------------------------
C----<
C
C
C
C
C
C
C
C
C
C
C*    Section 0 . Definition of variables.
C     ----------------------------------------------------------------
C
      IMPLICIT NONE
C
C*    Prefix conventions for variable names.
C
C     Logical      L (but not LP), global or common.
C                  O, dummy arguments.
C                  G, local variable.
C                  LP, parameter.
C     Character    C, Global or common.
C                  H, dummy arguments.
C                  Y (but not YP), local variables.
C                  YP, parameter.
C     Integer      M and N, global or common.
C                  K, dummy arguments.
C                  I, local variables.
C                  J (but not JP), loop control.
C                  JP, parameter.
C     Real         A to F and Q to X, global or common.
C                  P (but not PP), dummy arguments.
C                  Z, local variables.
C                  PP, parameter.
C
      INTEGER      ILEN
C
      INTEGER      J150
C
      CHARACTER*(*) HCHAR
      CHARACTER*(*) HOLD
      CHARACTER*(*) HNEW
C
C     ----------------------------------------------------------------
C
C
C
C
C
C
C
C
C
C
C*    Section 1 . Replace required characters.
C     ----------------------------------------------------------------
C
  100 CONTINUE
C
      ILEN = LEN (HCHAR)
C
      DO 150 J150=1,ILEN
         IF (HCHAR(J150:J150).EQ.HOLD(1:1)) HCHAR(J150:J150) = HNEW(1:1)
  150 CONTINUE
C
C     ----------------------------------------------------------------
C
C
C
C
C
C
C
C
C
C
C*    Section 9 . Return to calling routine.
C     ------------------------------------------------------------------
C
  900 CONTINUE
C
      RETURN
C
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE BUAUG(KPT,KDLEN,KDATA,KJ,KY,KSTACK,KERR)
C
C**** *BUAUG*
C
C
C     PURPOSE.
C     --------
C          UPDATE AUGMENTED BUFR TABLE B.
C
C
C**   INTERFACE.
C     ----------
C
C          *CALL* *BUAUG(KPT,KDLEN,KDATA,KJ,KY,KSTACK,KER)
C
C        INPUT :
C               *KPT*      - POINTER TOO KDATA ARRAY
C               *KDLEN*    -  DIMENSION OF KDATA ARRAY
C               *KDATA*    -  ARRAY CONTAINING DATA NEEDED FOR DATA DESCRIPTOR
C                            EXPANSION
C               *KJ*       - POINTER TO KSTACK ARRAY
C               *KY*       - OPERAND OF THE DATA DESCRIPTOR OPERATOR
C
C        OUTPUT:
C               *KSTACK* - LIST OF ELEMENTS
C               *KERR*   - RETURN ERROR CODE
C
C     METHOD.
C     -------
C
C          NONE.
C
C
C     EXTERNALS.
C     ----------
C
C          GBYTE        - PACK BIT PATHERN
C
C
C     REFERENCE.
C     ----------
C
C          NONE.
C
C     AUTHOR.
C     -------
C
C          M. DRAGOSAVAC    *ECMWF*       04/02/91.
C
C
C     MODIFICATIONS.
C     --------------
C
C          NONE.
C
C
      IMPLICIT LOGICAL(L,O,G), CHARACTER*8(C,H,Y)
C
C
#     include "parameter.F"
#     include "bcomunit.F"
#     include "bcmwork.F"
#     include "bcmatb.F"
#     include "bcmatbc.F"
#     include "bcmtab.F"
#     include "bcmtabc.F"
#     include "bcmwt.F"
#     include "bcmwtc.F"
#     include "bcmbef.F"
C
      CHARACTER CATBEN*64,CWTEN*64,CTABBEN*64
      CHARACTER CATBU*24,CWTU*24,CTABBU*24
C
#ifndef R_4
      REAL*8 RVIND
      REAL*8 EPS
#else
      REAL   RVIND
      REAL   EPS
#endif
      DIMENSION KSTACK(*)
      DIMENSION KDATA(KDLEN)
C     ------------------------------------------------------------------
C
C*          1.   UPDATE AUGMENTED TABLE B .
C                --------------------------
 100  CONTINUE
C
      IF( KERR.NE.0 ) RETURN
C
C
C*          1.1 Y = 0 ?
C               -------
 110  CONTINUE
C
      IF( KY.EQ.0) THEN
C
C*          1.1.1 CLEAR AUGMENTED TABLE B.
C                 ------------------------
         NJA= 0
C
         DO 111 J=1,JTAB
C
         NATBTR(J)= 0
         NATBS (J)= 0
         NATBRV(J)= 0
         NATBDW(J)= 0
         CATBEN(J)=' '
         CATBU (J)=' '
C
 111     CONTINUE
C
         GO TO 300
      END IF
C
C*          1.2  GET NEXT DESCRIPTOR FROM STACK.
C                -------------------------------
 120  CONTINUE
C
      KJ=KJ + 1
      KDD = KSTACK(KJ)
C
C*          1.3  ELEMENT DESCRIPTOR  ?
C                ---------------------
 130  CONTINUE
C
      IF  = KDD /100000
      IDIF= KDD -IF*100000
      IX  = IDIF/1000
      IY  = IDIF-IX*1000
C
      IF(IF.EQ.0) THEN
C
C*          1.3.1 ADD SPECIAL ENTRY TO WORKING TABLE.
C                 -----------------------------------
         NWT = NWT + 1
         M   = M   + 1
         NWTEN(NWT)=836970
         CWTEN(NWT)='REFERENCE VALUE'
         CWTU (NWT)='  '
         NWTDW(NWT)= KY
         NWTS (NWT)=0
         NWTRV(NWT)=0
         NWTR (NWT)=0
C
C*          1.3.2 ADD ENTRY TO AUGMENTED TABLE B .
C                 --------------------------------
         DO 131 J=1,JTAB
C
         IF(NTABBTR(J).EQ.KDD) THEN
            I=J
            GO TO 133
         END IF
C
 131     CONTINUE
C
         KERR= 23
         WRITE(KNTN,*) ' BUAUG :'
         CALL BUERR(KERR)
         GO TO 300
C
 133  CONTINUE
C
         NJA=NJA + 1
C
         NATBTR(NJA)=NTABBTR(I)
         NATBS (NJA)=NTABBS (I)
         NATBRV(NJA)=NTABBRV(I)
         NATBDW(NJA)=NTABBDW(I)
         CATBEN(NJA)=CTABBEN(I)
         CATBU (NJA)=CTABBU (I)
C
C*          1.3.3 COMPLITE ENTRY WITH NEW REFERENCE VALUE
C                 ----------------------------------------
C                 FROM DATA SECTION.
C                 ------------------
C
         KPT=KPT+1
         NATBRV(NJA)=KDATA(KPT)
C
C           1.3.4 UPDATE WORKING TABLES
C                 ---------------------
 135     CONTINUE
C
C        CALL BUEPWT(KDD,KERR)
C        IF(KERR.GT.0) RETURN
C
         GO TO 120
C
      END IF
C
C     ------------------------------------------------------------------
C
C*           1.4   CHANGE REFERENCE VALUE ?
C                  ------------------------
 140  CONTINUE
C
      IF( IF.EQ.2.AND.IX.EQ.3) THEN
         IF(IY.EQ.255) GO TO 300
         KY=IY
         GO TO 120
      END IF
C     ------------------------------------------------------------------
 200  CONTINUE
C
      KERR=23
      WRITE(KNTN,*) ' BUAUG :'
      CALL BUERR(KERR)
C
C     ------------------------------------------------------------------
 300  CONTINUE
C
      RETURN
C
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities
C granted to it by virtue of its status as an intergovernmental organisation
C nor does it submit to any jurisdiction.
C

      SUBROUTINE JMAKLL3( KUNIT, KTRUNC, PINTVL, PLAT, PLEG, KRET)
C
C---->
C**** JMAKLL
C
C     PURPOSE
C     _______
C
C     This routine creates legendre functions for latitude rows upto
C     the given latitude in a 'non-standard truncation/interval' file.
C
C     INTERFACE
C     _________
C
C     CALL JMAKLL( KUNIT, KTRUNC, PINTVL, PLAT, PLEG, KRET)
C
C     Input parameters
C     ________________
C
C     KUNIT   - Unit number for open file of legendre functions.
C     KTRUNC  - Truncation.
C     PINTVL  - Grid interval (degrees)
C     PLAT    - Latitude in degrees.
C
C     Output parameters
C     ________________
C
C     PLEG     - Array of legendre functions for the latitude.
C     KRET     - Return status code
C                0 = OK
C
C     Common block usage
C     __________________
C
C     JDCNDBG
C
C     Method
C     ______
C
C     Determine which functions already exist for the latitude rows
C     in the file, skip to the end and create necessary extra functions
C     and add to the file.
C
C     Externals
C     _________
C
C     PBSEEK    - Position the coefficients file
C     PBWRITE   - Write the coefficients file
C     INTLOG   - Output log message
C     INTLOGR  - Output log message (with real value)
C
C     Reference
C     _________
C
C     None.
C
C     Comments
C     ________
C
C     Only positive latitude values are allowed.
C
C     AUTHOR
C     ______
C
C     J.D.Chambers      *ECMWF*      Dec 1993
C
C     MODIFICATIONS
C     _____________
C
C     None.
C
C----<
C     _______________________________________________________
C
C
C*    Section 0. Definition of variables.
C     _______________________________________________________
C
C*    Prefix conventions for variable names
C
C     Logical      L (but not LP), global or common.
C                  O, dummy argument
C                  G, local variable
C                  LP, parameter.
C     Character    C, global or common.
C                  H, dummy argument
C                  Y (but not YP), local variable
C                  YP, parameter.
C     Integer      M and N, global or common.
C                  K, dummy argument
C                  I, local variable
C                  J (but not JP), loop control
C                  JP, parameter.
C     REAL         A to F and Q to X, global or common.
C                  P (but not PP), dummy argument
C                  Z, local variable
C                  PP, parameter.
C
      IMPLICIT NONE
C
#include "jparams.h"
#include "parim.h"
C
C     Parameters
C
      INTEGER JPROUTINE
      PARAMETER ( JPROUTINE = 30500 )
C
C     Subroutine arguments
C
      INTEGER KUNIT, KTRUNC, KRET
      REAL PLEG, PINTVL, PLAT
      DIMENSION PLEG(*)
C
C     Local variables
C
      INTEGER NEWPOS, NSIZE, NRET, NROWCT, NBYTES
      REAL ZLATEST, ZLAT, ALAT, PIBY2, DEG2RAD
      INTEGER NEXT, FIRST, LAST
C
C     _______________________________________________________
C
C*    Section 1.    Initialization.
C     _______________________________________________________
C
 100  CONTINUE
C
      IF( NDBG.GT.1 ) THEN
        CALL INTLOG(JP_DEBUG,'JMAKLL3: Input parameters:',JPQUIET)
        CALL INTLOG(JP_DEBUG,
     X    'JMAKLL3: Unit number for leg.funcs file =', KUNIT)
        CALL INTLOG(JP_DEBUG,'JMAKLL3: Truncation = ', KTRUNC)
        CALL INTLOGR(JP_DEBUG,
     X    'JMAKLL3: Grid interval (degrees) = ', PINTVL)
        CALL INTLOGR(JP_DEBUG,
     X    'JMAKLL3: Latitude in degrees = ', PLAT)
      ENDIF
C
      IF( PLAT.LT.0.0 ) THEN
        ZLAT = 0.0
      ELSE
        ZLAT = PLAT
      ENDIF
C
C     Calculate the byte offset into the file where the legendre
C     functions for the latitude should be.
C
#ifdef REAL_8
      NSIZE   = 8 * (KTRUNC+1)*(KTRUNC+4)/2
#else
      NSIZE   = 4 * (KTRUNC+1)*(KTRUNC+4)/2
#endif
      NEWPOS = NINT( (90.0 - ZLAT)/PINTVL ) * NSIZE
C
C     Find the current file length
C
      CALL PBSEEK3( KUNIT, 0, 2, NRET)
      IF( NRET.LT.0 ) THEN
        CALL INTLOG(JP_ERROR,'JMAKLL3: PBSEEK error',NRET)
        KRET = JPROUTINE + 2
        GOTO 990
      ENDIF
C
C     Use the length to determine how many rows have already been
C     put into the file
C
      NROWCT = NRET/NSIZE
      ZLATEST  = 90.0 - REAL(NROWCT) * PINTVL
C
      IF( NDBG.GT.1 ) THen
        CALL INTLOG(JP_DEBUG,'JMAKLL3: File length on open = ', NRET)
        CALL INTLOG(JP_DEBUG,
     X    'JMAKLL3: Number of rows already in file = ', NROWCT)
        CALL INTLOGR(JP_DEBUG,
     X    'JMAKLL3: Next latitude to go in file = ', ZLATEST)
      ENDIF
C
C     _______________________________________________________
C
C*    Section 2.    Processing.
C     _______________________________________________________
C
C     Loop through latitudes not in the file yet
C
#ifdef REAL_8
      NBYTES = (KTRUNC+1)*(KTRUNC+4)/2  * 8
#else
      NBYTES = (KTRUNC+1)*(KTRUNC+4)/2  * 4
#endif
C
      IF( NDBG.GT.1 )
     X  CALL INTLOG(JP_DEBUG,'JMAKLL3: No. of bytes per row = ', NBYTES)
C
      PIBY2   = PPI / 2.0
      DEG2RAD = PPI / 180.0
C
      FIRST = NINT(ZLATEST/PINTVL)
      LAST  = NINT(ZLAT/PINTVL)
      DO NEXT = FIRST, LAST, -1
        ALAT = (NEXT*PINTVL) * DEG2RAD
C
        IF( NDBG.GT.1 ) CALL INTLOGR(JP_DEBUG,
     X    'JMAKLL3: Next latitude constructed = ', (NEXT*PINTVL))
C
        CALL JSPLEG1( PLEG, ALAT, KTRUNC)
        CALL PBWRITE3( KUNIT, PLEG, NBYTES, NRET)
        IF( NRET.LT.NSIZE ) THEN
          CALL INTLOG(JP_ERROR,'JMAKLL3: PBWRITE error.', NRET)
          CALL INTLOG(JP_ERROR,'JMAKLL3: bytes required = ', NSIZE)
          KRET = JPROUTINE + 3
          GOTO 990
        ENDIF
      ENDDO
C     _______________________________________________________
C
C*    Section 9. Return to calling routine. Format statements
C     _______________________________________________________
C
 900  CONTINUE
      KRET = 0
C
 990  CONTINUE
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE L2U1CR (HSTRNG)
C
C---->
C**** L2U1CR - Convert character string to upper case.
C
C     Purpose.
C     --------
C
C           Convert character string to all upper case.
C
C**   Interface.
C     ----------
C
C           CALL L2U1CR (HSTRNG)
C
C           Integer    K.
C           Real       P.
C           Logical    O.
C           Character  H.
C
C               Input parameters.
C               -----------------
C
C               HSTRNG     - String in upper and/or lower case.
C
C               Output parameters.
C               ------------------
C
C               HSTRNG     - Character string in all upper case.
C
C     Method.
C     -------
C
C           Numeric values of each byte examined and altered if in the
C           range of lower case letters.
C
C     Externals.
C     ----------
C
C           ICHAR
C           CHAR
C
C     Reference.
C     ----------
C
C           Cray Programmer's Library Reference Manual.
C
C     Comments.
C     ---------
C
C           Routine contains sections 0 to 1 and section 9.
C
C     Author.
C     -------
C
C           J. Hennessy      ECMWF      07:04:89.
C
C     Modifications
C     --------------
C
C           J. Hennessy      ECMWF      29.01.90
C           Replace null characters by blanks.
C
C     ----------------------------------------------------------------
C----<
C
C
C
C
C
C
C
C
C
C
C*    Section 0 . Definition of variables.
C     ----------------------------------------------------------------
C
      IMPLICIT LOGICAL     ( L, O, G )
      IMPLICIT CHARACTER*8 ( C, H, Y )
      IMPLICIT INTEGER     ( I, J, K, M, N )
C
      CHARACTER*(*) HSTRNG
C
C     ASCII representation of lower case characters a and z.
C
      DATA IA  /97/
      DATA IZ  /122/
C
C     ASCII representation of null and blank characters.
C
      DATA INULL /0/
C
C     ----------------------------------------------------------------
C
C
C
C
C
C
C
C
C
C*    Section 1 . Change any necessary letters.
C     ----------------------------------------------------------------
C
 1000 CONTINUE
C
C
      ILEN = LEN (HSTRNG)
C
      DO 1100 J=1,ILEN
         ICH = ICHAR (HSTRNG(J:J))
         IF ( (ICH.GE.IA).AND.(ICH.LE.IZ) ) HSTRNG (J:J) = CHAR (ICH-32)
         IF (ICH.EQ.INULL) HSTRNG (J:J) = CHAR (32)
 1100 CONTINUE
C
C     ---------------------------------------------------------------
C
C
C
C
C
C
C*    Section 9 . Return to calling routine.
C     ----------------------------------------------------------------
C
 9000 CONTINUE
C
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities
C granted to it by virtue of its status as an intergovernmental organisation
C nor does it submit to any jurisdiction.
C
      PROGRAM LINK_PRODGEN
      IMPLICIT NONE
C
C     Checks symbols when linking.
C
      INTEGER I
      REAL R
      CHARACTER C
      LOGICAL L
      COMPLEX J
      INTEGER IARGC
C
      INTEGER HIRLAM
      INTEGER HIRLAMW
      INTEGER HIRLSM
      INTEGER INTF
      INTEGER INTIN
      INTEGER INTOUT
      INTEGER JGETGG
      INTEGER JGGLAT
      INTEGER WV2DINT
      INTEGER WVQLINT
      IF (IARGC().LT.0) THEN
          CALL FREECF  (I)
          CALL JNUMGG  (I,C,I,I)
          CALL JVOD2UV (J,J,I,J,J,I)
          I = HIRLAM  (L,R,I,I,R,R,R,R,I,I,I)
          I = HIRLAMW (L,R,R,I,I,R,R,R,R,R,I,I,I)
          I = HIRLSM  (L,R,I,I,R,R,R,R,I,I,I)
          I = INTF    (I,I,R,I,I,R)
          I = INTIN   (C,I,R,C)
          I = INTOUT  (C,I,R,C)
          I = JGETGG  (I,C,R,I,I)
          I = JGGLAT  (I,R)
          I = WV2DINT (I,I,I,I,R,R,R,R,R,I,R,R)
          I = WVQLINT (I,I,I,I,R,R,R,R,R,I,R,R)
      END IF
      END

C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE CREXOPER(KPT,KDLEN,KDATA,KJ,KDD,KSTACK,KERR)
C
C
C**** *CREXOPER*
C
C
C     PURPOSE.
C     --------
C
C          PROCESS BUFR OPERATOR.
C
C**   INTERFACE.
C     ----------
C
C          *CALL* *CREXOPER(KPT,KDLEN,KDATA,KJ,KDD,KSTACK,KERR)*
C
C        INPUT :
C               *KPT*    - POINTER TO KDATA ARRAY
C               *KDLEN*  - DIMENSION OF KDATA ARRAY
C               *KDATA*  - ARRAY CONTAINING DATA NEEDED FOR DESCRIPTOR
C                          EXPANSION
C               *KJ*     - POINTER T ARRAY KSTACK
C               *KDD*    - DATA DESCRIPTOR
C        OUTPUT:
C               *KSTACK* - LIST OF DESCRIPTORS
C               *KERR*   - RETURN ERROR CODE
C
C     *METHOD.
C      -------
C
C          NONE.
C
C
C     EXTERNALS.
C     ----------
C
C
C     REFERENCE.
C     ----------
C
C          NONE.
C
C     AUTHOR.
C     -------
C
C          M. DRAGOSAVAC    *ECMWF*       01/02/91.
C
C
C     MODIFICATIONS.
C     --------------
C
C          NONE.
C
C
      IMPLICIT LOGICAL(L,O,G), CHARACTER*8(C,H,Y)
C
C
      PARAMETER(JSUP =   9,JSEC0=   3,JSEC1= 40,JSEC2= 64 ,JSEC3=    4,
     1          JSEC4=2,JELEM=40000,JSUBS=400,JCVAL=150 ,JBUFL=40000,
     2          JBPW =  32,JTAB =3000,JCTAB=120,JCTST=1800,JCTEXT= 200,
     3          JWORK=360000,JKEY=46)
C
C
      COMMON /CRWORK/ NBPT,NGS,NVIND,NBPTSEC2,RVIND,EPS,NE,IEOLD,
     1                  NC07YYY

C
      COMMON /CRWT/ NCREXDWINC,NCREXSCAM,NCREXAFDW,NCREXWT ,ODREPF,
     2             NCREXSTACK(JELEM),NCREXWTEN(JELEM),
     3             NCREXWTR (JELEM),NCREXWTS (JELEM),
     4             NCREXWTDW(JELEM)
C
C             NCREXDWINC   -  data width increment
C             NCREXSCAM    -  scale multiplier
C             NCREXAFDW    -  augmented field data width
C             NCREXWT      -  pointer to working table
C             NCREXSTACK   -  list of data descriptors
C             ODREPF   -  replication (logical)
C             NCREXWTR     -  working table reference
C             NCREXWTS     -  working scale
C             NCREXWTDW    -  working data width
C
      CHARACTER CREXWTEN*64,CREXWTU*24
C
      COMMON /CRWTC/ CREXWTEN(JELEM),CREXWTU(JELEM)
C
C             CREXWTEN    -  working table element naame
C             CREXWTU     -  working table units
C
C
C
      COMMON /CRBEF / M,MM,N,JCV
C
C             M       -  Number of elements
C             MM      -  Number of elements
C             N       -  Number of data sub_sets
C             JCV     -  Number of character values

C
C
      REAL*8 RVIND
      REAL*8 EPS
C
      DIMENSION KSTACK(*)
      DIMENSION KDATA(KDLEN)
C
C     ------------------------------------------------------------------
C
C*          1.   DETERMINE *F *X AND *Y.
C                -----------------------
 100  CONTINUE
C
      IF( KERR.NE.0 ) RETURN
C
      IF  = KDD / 100000
      IDIF= KDD - IF * 100000
      IX  = IDIF / 1000
      IY  = IDIF - IX * 1000
C
      IF( IF.NE.2 ) THEN
         KERR=21
         WRITE(*,*)  ' CREXOPER :'
         CALL CREXERR(KERR)
         GO TO 400
      END IF
C
C*          1.1   CHANGE DATA WIDTH ?
C                 -------------------
 110  CONTINUE
C
      IF(IX.EQ.1) THEN
         NCREXDWINC= IY
         GO TO 400
      END IF
C
C*          1.2   CHANGE SCALE ?
C                 --------------
 120  CONTINUE
C
      IF(IX.EQ.2) THEN
C
C
C*          1.2.1  UPDATE SCALE MULTIPLIER.
C                  ------------------------
C
         IF(IY.GT.900) IY=-(IY-900)
         NCREXSCAM=IY
         GO TO 400
      END IF
C
C
C*          1.4   ADD ASSOCIATED FIELD ?
C                 ----------------------
 140  CONTINUE
C
      IF(IX.EQ.4) THEN
C
C*          1.4.1   UPDATE ASSOCIATED FIELD WIDTH.
C                   ------------------------------
         NCREXAFDW= IY
         GO TO 400
      END IF
C
C*          1.5   SIGNIFY CHARACTER ?
C                 -------------------
 150  CONTINUE
C
      IF(IX.EQ.5) THEN
C
C*          1.5.1  ADD SPECIAL ENTRY TO WORKING TABLE.
C                  -----------------------------------
         NCREXWT = NCREXWT + 1
         CREXWTEN(NCREXWT)='CHARACTERS'
         CREXWTU(NCREXWT)=' '
         NCREXWTR (NCREXWT)= kdd
         NCREXWTDW(NCREXWT)= IY
         NCREXWTEN(NCREXWT)=658367
         NCREXWTS (NCREXWT)=0
         GO TO 400
      END IF
C
C
C*          1.6    CHANGE UNIT
C                 ------------
 160  CONTINUE
C
      IF(IX.EQ.7) THEN
C
         IERR=0
         CALL GET_UNITS(IY,IERR)
         IF(IERR.EQ.0) THEN
            NC07YYY=IY
         END IF
C
         GO TO 400
C
      END IF
C
C     ------------------------------------------------------------------
C
 300  CONTINUE
C
      KERR=22
      WRITE(*,*)  'CREXOPER:'
      CALL CREXERR(KERR)
C
C     ------------------------------------------------------------------
C
 400  CONTINUE
C
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities
C granted to it by virtue of its status as an intergovernmental organisation
C nor does it submit to any jurisdiction.
C
      program fftw
      implicit none
      
      integer n
      integer m
      integer i
      integer j
      parameter (n=2*2*3*5)
      parameter (m=20)

      real    a     ((n+2)*m)
      real    trigs (n)
      real    work  (m*(n+1))
      integer ifax  (10)

#include "fftw3.f"
      integer*8 plan


      integer KLONO
      integer JPLONO
      real del
      real angle
      real PZFA((n+2)*m)
      real FFTWOUT(n)
      REAL PPI
      PARAMETER ( PPI = 3.14159265358979 )


C     Generate sines and cosines for angles 0 to pi in N steps
C     (possibly the only surviving part of set99)
      del = (2.0*ppi) / float(n)
      do i = 0, (n/2)-1
        angle        = float(i)*del
        trigs(2*i+1) = cos(angle)
        trigs(2*i+2) = sin(angle)
      enddo


      call set99(trigs,ifax,n)

      a = 0
      do j = 1, m
        do i = 1, n
          a((j-1)*(n+2)+i) = j
        enddo
      enddo

      call fft99(a,work,trigs,ifax,1,n+2,n,m,-1)

      KLONO  = n
      JPLONO = n
      PZFA   = a

      FFTWOUT(1:KLONO) = 0.
      CALL DFFTW_PLAN_DFT_C2R_1D( PLAN, KLONO, PZFA, FFTWOUT,
     .  FFTW_ESTIMATE
     .+ FFTW_UNALIGNED
     .+ FFTW_NO_SIMD )
      CALL DFFTW_EXECUTE( PLAN )
      PZFA( 1:KLONO              ) = FFTWOUT(1:KLONO) 
      PZFA( KLONO+1:(JPLONO+2)*m ) = 0.
      a = PZFA
      CALL DFFTW_DESTROY_PLAN( PLAN )

      write (*,'(4(f20.12,2x))') (a(i),i=1,n)
      end

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE EXTMAP (KGRIB,KLENG,KMAP1,KMAP2,KVALS,PSEC4,KSIZE,
     X                   KBITS,KSBMAP,PMISS,KNUM,KPR,KRET,KNOMIS)
C
C---->
C**** EXTMAP - Extraction of bit maps for routine GRIBEX.
C
C     Purpose.
C     --------
C
C     Extracts bit-maps (primary and secondary,if present)
C     from an array of GRIB coded data and inserts the
C     missing data value indicator in appropriate places in
C     the array of already unpacked data values.
C
C**   Interface.
C     ----------
C
C     CALL EXTMAP (KGRIB,KLENG,KMAP1,KMAP2,KVALS,PSEC4,KSIZE,KBITS,
C    X             KSBMAP,PMISS,KNUM,KPR,KRET,KNOMIS)
C
C
C     Input Parameters.
C     -----------------
C
C     KGRIB      - Array from which data is being unpacked
C                  from GRIB code.
C
C     KLENG      - Length of this array.
C
C     KMAP1      - Bit-pointer to start of primary bit-map
C                  (Section 3 bitmap) in array KGRIB.
C
C     KMAP2      - Bit-pointer to start of secondary bitmap
C                  (Section 4 bitmap) in array KGRIB.
C                  Negative value if no secondary bit maps.
C
C     KVALS      - Number of unpacked values in PSEC4 on entry
C
C     PSEC4      - Array of data values unpacked from GRIB code.
C
C     KSIZE      - Number of bits in the primary bit map.
C
C     KBITS      - Number of bits in computer word.
C
C     PMISS      - Value to be used to indicate missing data
C                  in array PSEC4.
C
C     KNUM       - Number of values at each grid point. This
C                  is normally 1 except when a matrix of value
C                  is represented.
C
C     KPR        - Debug print switch.
C                  0  , No printout.
C                  >0 , Debug printout.
C
C     Output Parameters.
C     ------------------
C
C     KSBMAP     - Bit-map flag.
C                  -2 , All bits in the bit-map set to 1.
C                       There is no missing data.
C                  -4 , Some points have no data. User
C                       supplied value for missing data
C                       indicator in appropriate places in
C                       the array PSEC4.
C
C     KRET       - Return code.
C                  0 , No error encountered.
C                  1 , Error in routine INXBIT.
C                  4 , Number of values at each grid point (KNUM)
C                      is greater than allowed (JPWORK).
C
C     KNOMIS     - Number of non-missing values in PSEC4 entry.
C
C
C     Method.
C     -------
C
C     The bit-map contains 1 where valid data exists and 0
C     where data is missing. The corresponding data array
C     contains valid data and the missing data indicator value.
C
C     Externals.
C     ----------
C
C     INXBIT   - Extract values from bit-stream
C
C     Reference.
C     ----------
C
C     See routine GRIBEX.
C
C     Comments.
C     ---------
C
C     Routine contains Sections 0 to 3 and Section 9.
C
C     Author.
C     -------
C
C     J. Hennessy      ECMWF      10:07:92
C
C     Modifications.
C     --------------
C
C     J. Hennessy      ECMWF      29:10:92
C     Maximum sizes increased to allow for packing of
C     2D spectra.
C     Number of data values 120*61*12*25
C
C     J.D.Chambers     ECMWF      09:03:94
C     Maximum size for bitmap array increased to 132000
C     to allow for products 0.5 * 0.5 degrees, whole
C     hemisphere (N or S).
C
C     J.D.Chambers     ECMWF      18:04:94
C     Fix setting of missing values according to bitmap 
C
C     J.D.Chambers     ECMWF      19:07:94
C     Maximum size for bitmap array increased to 140000
C     for reduced gaussian n160.
C
C     J.D.Chambers     ECMWF      23.05.95
C     Use dynamic allocation for secondary bitmap
C     Process primary bitmap in small pieces.  Use PSEC4
C     for expanding data using bitmaps.
C
C     J.D.Chambers     ECMWF      24.10.96
C     Use fixed allocation for secondary bitmap
C     Process primary bitmap in small pieces.  Use PSEC4
C
C     J. Clochard, METEO FRANCE, for ECMWF - January 1998.
C     Dummy-argument KNOMIS added.
C     Strips size (JPWORK) enlarged to 10000.
C
C----<
C     ------------------------------------------------------------------
C*    Section 0 . Definition of variables. Data statements.
C     ------------------------------------------------------------------
C
      IMPLICIT NONE
C
#include "common/grprs.h"
C
C     Parameters
C
      INTEGER JPWORK
      PARAMETER (JPWORK=10000)
C
C     Subroutine arguments
C
      INTEGER KBITS, KGRIB, KLENG, KMAP1, KMAP2, KNUM, KVALS, KNOMIS
      DIMENSION KGRIB(*)
      INTEGER KPR, KRET, KSBMAP, KSIZE
      REAL PMISS, PSEC4
      DIMENSION PSEC4(*)
C
C     Local variables
C
      INTEGER ICURR, IPT, LENGTH
      INTEGER JLOOP, JLOOPI, NEXT, IMANY, NABITS, NBITS, NVALS, MYMAP1
      LOGICAL LMOPT
C
      INTEGER IMAP1
      DIMENSION IMAP1(JPWORK)
C
C     Work array.
C
      INTEGER IMAP2
      DIMENSION IMAP2(JPWORK)
C
C
C     ------------------------------------------------------------------
C*    Section 1 . Set initial values.
C     ------------------------------------------------------------------
C
  100 CONTINUE
C
      IF( KPR.GE.1 ) THEN
        WRITE(GRPRSM,*) 'EXTMAP: Section 1.'
        WRITE(GRPRSM,*) 'EXTMAP:   Input values used -'
        WRITE(GRPRSM,*) 'EXTMAP: KSIZE,KNUM = ', KSIZE,KNUM
        WRITE(GRPRSM,*) 'EXTMAP: KLENG,KMAP1,KMAP2,KBITS, PMISS = '
        WRITE(GRPRSM,*) KLENG,KMAP1,KMAP2,KBITS, PMISS
        WRITE(GRPRSM,*) 'EXTMAP: KVALS = ', KVALS
      ENDIF
C
C     Reset return code to 0.
C
      KRET  = 0
      KNOMIS = 0
      NBITS = 0
      NABITS = 0
      LENGTH = KNUM
C
C     Check there is enough space for unpacking secondary bitmap
C
      IF( LENGTH.GT.JPWORK ) THEN
        WRITE(GRPRSM,*) 'EXTMAP: Number of values at each grid point'
        WRITE(GRPRSM,*)
     X    'EXTMAP: (KNUM) is greater than allowed (JPWORK).'
        KRET = 4
        GOTO 900
      ENDIF
C
C     ------------------------------------------------------------------
C*    Section 2 .  Handle 'M' option case
C     ------------------------------------------------------------------
C
  200 CONTINUE
C
C     If the original field has been packed with the 'M' option,
C     have to find out how many true values there are in the field.
C
      LENGTH = KSIZE * KNUM
      LMOPT = (KVALS.EQ.LENGTH)
C
      IF( LMOPT ) THEN
C
C       Count the number of bits in the primary bitmap
C
        NEXT = 0
        NVALS = 0
        MYMAP1 = KMAP1
C
  210   CONTINUE
C
C       Unpack the primary bitmap in strips of JPWORK values
C
        NEXT = NEXT + JPWORK
        IMANY = JPWORK
C
C       Check whether end of primary bitmap reached.
C       Adjust if less than JPWORK values left to process
C
        IF( NEXT.GT.KSIZE ) IMANY = KSIZE + JPWORK - NEXT
C
C       Unpack next strip of primary bitmap values.
C
        CALL INXBIT(KGRIB,KLENG,MYMAP1,IMAP1,IMANY,KBITS,1,'D',KRET)
        IF( KRET.NE.0 ) THEN
          WRITE(GRPRSM,*) 'EXTMAP: Error reported by routine INXBIT.'
          KRET = 1
          GO TO 900
        ENDIF
C
C       Work through the strip of primary bitmap values counting points
C       which are not missing.
C
        DO 220 JLOOP = 1,IMANY
          IF( IMAP1(JLOOP).EQ.1 ) NVALS = NVALS + 1
  220   CONTINUE
C
C       Loop back if more strips of primary bitmap to process
C
        IF( NEXT.LT.KSIZE ) GOTO 210
C
      ELSE
C
        NVALS = KVALS
C
      ENDIF
C
      IF( KPR.GE.1 ) THEN
        WRITE(GRPRSM,*) 'EXTMAP: NVALS = ', NVALS
        WRITE(GRPRSM,*) 'EXTMAP: KVALS = ', KVALS
        WRITE(GRPRSM,*) 'EXTMAP: LENGTH = ', LENGTH
      ENDIF
C
C     Move input field to far end of input array
C
      IF( NVALS.LT.LENGTH ) THEN
        ICURR = NVALS+1
!OCL NOVREC
        DO 230 JLOOP = LENGTH, LENGTH - NVALS + 1, -1
          ICURR = ICURR - 1
          PSEC4(JLOOP) = PSEC4(ICURR)
  230   CONTINUE
      ENDIF
C
C     ------------------------------------------------------------------
C*    Section 3 . Decoding of bit-map and data.
C     ------------------------------------------------------------------
C
  300 CONTINUE
C
      IF( KPR.GE.1 ) WRITE(GRPRSM,*) 'EXTMAP: Section 3.'
C
C*    Set unoccupied values in array to missing data indicator.
C
      ICURR = LENGTH - NVALS
      DO 310 JLOOP = 1, ICURR
        PSEC4(JLOOP) = PMISS
  310 CONTINUE
C
C*    Copy data to output array or insert missing data value
C     in accordance with the bit map values.
C
      ICURR = LENGTH - NVALS
      IPT = 1
      NEXT = 0
C
  320 CONTINUE
C
C     The primary bitmap is unpacked and used in strips of JPWORK values
C
      NEXT = NEXT + JPWORK
      IMANY = JPWORK
C
C     Check whether end of primary bitmap reached.
C     Adjust if less than JPWORK values left to process
C
      IF( NEXT.GT.KSIZE ) IMANY = KSIZE + JPWORK - NEXT
C
C     Unpack next strip of primary bitmap values.
C
      CALL INXBIT(KGRIB,KLENG,KMAP1,IMAP1,IMANY,KBITS,1,'D',KRET)
      IF( KRET.NE.0 ) THEN
        WRITE(GRPRSM,*) 'EXTMAP: Error reported by routine INXBIT.'
        KRET = 1
        GO TO 900
      ENDIF
C
C     Work through the strip of primary bitmap values.
C
      IF(KMAP2.LE.0.AND.KNUM.EQ.1) THEN
        IMAP2(1) = 1
!OCL NOVREC
        DO 325 JLOOP = 1,IMANY
          IF( IMAP1(JLOOP).EQ.1 ) THEN
            ICURR      = ICURR + 1
            PSEC4(IPT) = PSEC4(ICURR)
            NABITS     = NABITS + 1
          ELSE
            PSEC4(IPT) = PMISS
            NBITS      = NBITS + 1
          ENDIF
          IPT = IPT + 1
 325    CONTINUE
C
      ELSE
C
        DO 380 JLOOP = 1,IMANY
C
C         If primary bitmap indicates there are values at the point ..
C
          IF( IMAP1(JLOOP).EQ.1 ) THEN
C
C           .. read secondary bitmap, if any.
C
            IF( KMAP2.GT.0 ) THEN
              CALL INXBIT(KGRIB,KLENG,KMAP2,IMAP2,KNUM,KBITS,1,'D',KRET)
              IF( KRET.NE.0 ) THEN
                WRITE(GRPRSM,*)
     X            'EXTMAP: Error reported by routine INXBIT.'
                KRET = 1
                GO TO 900
              ENDIF
C
            ELSE
C
C*            If no secondary bitmaps present, set up dummy secondary
C             bitmap to indicate no missing data values.
C
              IF( KNUM.EQ.1 ) THEN
                IMAP2(1)   = 1
                ICURR      = ICURR + 1
                PSEC4(IPT) = PSEC4(ICURR)
                IPT        = IPT + 1
                NABITS     = NABITS + 1
              ELSE
                DO 330 JLOOPI = 1,KNUM
                  IMAP2(JLOOPI) = 1
  330           CONTINUE
              ENDIF
C
            ENDIF
C
C           Use the bitmap to put in data value or missing data indicator.
C
            IF( KNUM.GT.1 ) THEN
              DO 340 JLOOPI = 1,KNUM
                IF( IMAP2(JLOOPI).EQ.1 ) NABITS = NABITS + 1
  340         CONTINUE
C
              DO 350 JLOOPI = 1,KNUM
                IF( IMAP2(JLOOPI).NE.1 ) NBITS = NBITS + 1
  350         CONTINUE
C
              DO 360 JLOOPI = 1,KNUM
                IF( IMAP2(JLOOPI).EQ.1 ) THEN
                  ICURR              = ICURR + 1
                  PSEC4(IPT+JLOOPI-1) = PSEC4(ICURR)
                ELSE
                  PSEC4(IPT+JLOOPI-1) = PMISS
                ENDIF
  360         CONTINUE
              IPT = IPT + KNUM
C
            ENDIF
C
C         If primary bitmap indicates there are no values at the point ..
C
          ELSE
            IF( KNUM.EQ.1 ) THEN
              PSEC4(IPT) = PMISS
            ELSE
              DO 370 JLOOPI = 1,KNUM
                PSEC4(IPT+JLOOPI-1) = PMISS
  370         CONTINUE
            ENDIF
            IPT   = IPT + KNUM
            NBITS = NBITS + KNUM
          ENDIF
C
  380   CONTINUE
C
      ENDIF
C
C     Loop back if more strips of primary bitmap to process
C
      IF( NEXT.LT.KSIZE ) GOTO 320
C
C*    Set bit-map flag.
C
      IF( NBITS.GT.0 ) THEN
        KSBMAP = -4
      ELSE
        KSBMAP = -2
      ENDIF
C
C*    Return effective number of non-missing values.
C
      KNOMIS=NVALS
C
C     ------------------------------------------------------------------
C*    Section 9 . Return to calling routine. Format statements.
C     ------------------------------------------------------------------
C
  900 CONTINUE
C
      IF( KPR.GE.1 ) THEN
        WRITE(GRPRSM,*) 'EXTMAP: Section 9.'
        WRITE(GRPRSM,*) 'EXTMAP: NBITS = ', NBITS
        WRITE(GRPRSM,*) 'EXTMAP: NABITS = ', NABITS
        WRITE(GRPRSM,*) 'EXTMAP: NVALS = ', NVALS
        WRITE(GRPRSM,*) 'EXTMAP: Output values set -'
        WRITE(GRPRSM,*) 'EXTMAP: KNOMIS = ', KNOMIS
        WRITE(GRPRSM,*) 'EXTMAP: KSIZE = ', KSIZE
        WRITE(GRPRSM,*) 'EXTMAP: KSBMAP = ', KSBMAP
      ENDIF
C
      RETURN
      END

C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

       INTEGER FUNCTION D2ORDR ( KDATA, KLENP, KSEC1, KSEC2, KSEC3, 
     X                          KSEC4, KGRIB, KLENG, KNSPT, KBITS,
     X                          HOPER, KLEN4, KNIL,  PREF , PSCALE,
     X                          KBMAP, KVALS, KDEBUG )
C
C---->
C**** D2ORDR
C
C     Purpose.
C     --------
C
C     Decode GRIB section 4 for complex packing of grid-point
C     values ("second-order packing").
C
C
C**   Interface.
C     ----------
C
C     KRET = D2ORDR ( KDATA, KLENP, KSEC1, KSEC2, KSEC3, KSEC4,
C    X                KGRIB, KLENG, KNSPT, KBITS, HOPER, KLEN4,
C    X                KNIL,  PREF, PSCALE, KBMAP, KVALS, KDEBUG )
C
C
C     Input Parameters.
C     -----------------
C
C     KLENP      - Length of array KDATA.
C     KSEC1      - Array of GRIB section 1 integer descriptors.
C     KSEC2      - Array of GRIB section 2 integer descriptors.
C     KSEC3      - Array of GRIB section 3 integer descriptors.
C     KSEC4      - Array of GRIB section 4 integer descriptors.
C                  (preset to zero, and already decoded for (3:6)
C     KGRIB      - GRIB product array.
C     KLENG      - Length of GRIB product array.
C     KNSPT      - Bit pointer for next value in GRIB product.
C     KBITS      - Number of bits per computer word.
C     HOPER      - Requested function:
C                  'D' or 'R' to decode the whole field,
C                  'X' to decode only a few gridpoints (as described
C                   in KSEC4(34:42),
C                  'J' to decode only section 4 descriptors.
C     KLEN4      - Length (octets) of section 4.
C     KNIL       - Unused bit count at end of section 4.
C     KBMAP      - Bit pointer for start of explicit primary bit-map
C                  (if any).
C     KVALS      - Number of bits in primary bit-map.
C     KDEBUG     - >0 for some debug printout.
C
C
C     Output Parameters.
C     -----------------
C
C     KDATA      - Array of normalized values.
C     KSEC4      - Array of GRIB section 4 values (completed).
C     KGRIB      - Array containing GRIB product.
C     KNSPT      - Bit pointer for next value in GRIB product (updated).
C     PREF       - Reference value of field.
C     PSCALE     - Scale factor (ready to use) of field.
C
C
C     Method.
C     -------
C
C     Follows WMO Manual of Codes, and also DSECT4 structure.
C
C
C     Externals.
C     ----------
C
C     INXBIT    - Extract bits from GRIB product.
C     DECFP2    - Decode from IBM floating point format.
C     PRTBIN    - Print binary value in character format.
C     C2BITW    - Computes bit width of a positive integer value.
C     DSGNBT    - Decodes an integer value and its sign bit.
C     MAXMNI    - Computes extrema of integer array.
C     D2ROSD    - Rebuild original values from spatial differencing.
C     REVERO    - Reverse order of values in even rank rows.
C
C
C     Reference.
C     ----------
C
C     None.
C
C
C     Comments.
C     --------
C
C     On entry, KNSPT points to the first bit of section 4
C               in the GRIB product.
C     On exit,  KNSPT points to the first unused bit of section 4,
C               (or to the first bit of section 5, if unused bit count
C                is zero) in the GRIB product.
C
C
C     Author.
C     -------
C
C     J. Clochard, Meteo France, for ECMWF - January 1998.
C
C
C     Modifications.
C     _____________
C
C     J. Clochard, April 1998.
C     Update comments, and add more consistency with C2ORDR source code.
C     Inhibit REVERO call for function 'X'.
C     Introduce spatial differencing.
C
C     J. Clochard, September 1998.
C     Optimize management of primary bit-map in row by row packing case.
C     Fixes behaviour for HOPER='J' (KDATA must not be used)
C     and HOPER='X' (KDATA minimum length is KSEC4(34), not full-length.
C
C
C----<
C     -----------------------------------------------------------------
C*    Section 0. Definition of variables.
C     -----------------------------------------------------------------
C
      IMPLICIT NONE
C
#include "grprs.h"
C
C     Parameters
C
      INTEGER JP15BIT, JP16SET, JPWS1O, JPXMAX, JPXPWR, JPWS2O
C
      PARAMETER ( JP15BIT= 2**15 )
C                            `---> 32768    =   8000(hex)
      PARAMETER ( JP16SET= 2**16-1 )
C                            `---> 65535    =   FFFF(hex)
C     JPWS1O ===> Size of group work arrays.
C     JPXMAX ===> Maximum number of points for 'X' function.
C     JPXPWR ===>    "      "    "  bits number per value/descriptor.
C     JPWS2O ===> Size of work array IWORK2
C                 (must be strictly bigger than JPWS1O).
C
C     IWORK2 array is used to unpack:
C     -group sizes, in case of general extended packing
C                   (JPWS1O last values);
C     -secondary bit-map, if any;
C     -primary bit-map, in case of row by row packing.
C
C     These cases are exclusive.
C
#ifdef JBPW_64
      PARAMETER ( JPWS1O= 5000, JPWS2O= 20000, JPXMAX= 4, JPXPWR= 47 )
#else
      PARAMETER ( JPWS1O= 5000, JPWS2O= 20000, JPXMAX= 4, JPXPWR= 31 )
#endif
C
C     Subroutine arguments
C
      INTEGER KLENP, KLENG, KNSPT, KBITS, KLEN4, KNIL, KBMAP, KVALS
      INTEGER KDEBUG
      INTEGER KDATA (KLENP), KSEC1 (*), KSEC2 (*), KSEC4 (*), KGRIB (*)
      INTEGER KSEC3 (*)
C
      CHARACTER HOPER * (*)
C
      REAL PREF, PSCALE
C
C     Local variables.
C
      INTEGER IRET, IRETA, IRETB, IEXP, IMANT, IFLAGX, IAUXIL, INDKS4
      INTEGER IFIROV, ISECOV, ISCALE, IPTRSO, ILEN, INROWS, J, IRETFN
      INTEGER IPTRFO, IWIDTH, IPTRBM, ILAUXS, IPTRB0, ILNGTH, IRANG
      INTEGER IBITGW, IAUXIS, INBSEQ, JSEQ, IGROFF, IGRNBR, JGROUP
      INTEGER IREFLN, ICOUNT, IMAXVN, INPEXT, INCR, IEXTOR, IVALS
      INTEGER ISKIP, JEXT, IEXT, ICNEXT, INSPTA, IPTRGW, INVALS, ICOUNG
      INTEGER INDROW, INDCOL, IVALSC, IPTRFN, IPTRSN, IVALK4, IREFER
      INTEGER IPRWID, ICOUNS, ILNGTS, INDEXX, INDEXY, JROW, ISEQ
#ifdef ebug2o
      INTEGER IMAXVC
#endif
      INTEGER IBITGS, IPTRGS, IORDER, IWIDSD, IBIAS
#ifndef wmogrp2o
      INTEGER IEXTRA
#endif
C
      INTEGER IWIDGR (JPWS1O), IWORK2 (JPWS2O), IFIRST (JPWS1O)
      INTEGER IRGEXT (JPXMAX+1), INDXOR (JPXMAX), ILENGR (JPWS1O)
      INTEGER IPOWER (0:JPXPWR)
      INTEGER IWORK (3)
C
      CHARACTER YOPER*1
C
      LOGICAL LROW, LQUASI, LCTWID, LSECBI, LPRIBI, LDEBUG, L1CALL
      LOGICAL LGENXT, LBOUST, LPRCLN, LVECTD
C
      INTEGER REVERO, D2ROSD
      EXTERNAL REVERO, D2ROSD
      INTEGER C2BITW
      EXTERNAL C2BITW
C
      SAVE L1CALL, IPOWER
C
      DATA L1CALL / .TRUE. /
C
C     -----------------------------------------------------------------
C*    Section 1 . Decode octets 5 to 13.
C     -----------------------------------------------------------------
C
  100 CONTINUE
C
      IRETFN = 0
      YOPER='D'
      INSPTA=KNSPT
      LDEBUG=KDEBUG.GE.1
C
      IF (L1CALL) THEN
C
        DO 111 J=0,JPXPWR-1
        IPOWER(J)=2**J-1
  111   CONTINUE
#ifdef JBPW_64
        IPOWER(JPXPWR)=140737488355327
#else
        IPOWER(JPXPWR)=2147483647
#endif
C
        L1CALL=.FALSE.
C
      ENDIF
C
#ifndef ebug2o
      IF (LDEBUG) THEN
#endif
        WRITE(GRPRSM,FMT=9100) HOPER(:1),KNSPT
#ifndef ebug2o
      ENDIF
#endif
C
      KNSPT=KNSPT+4*8
C
C*    Octets 5 - 6 : Scale factor.
C     One 16 bit field.
C
      CALL INXBIT (KGRIB,KLENG,KNSPT,ISCALE,1,KBITS, 16,YOPER,IRET)
C
      IF (IRET.NE.0) THEN
        IRETFN = 17110
        WRITE(GRPRSM,FMT=9001) 'scale factor'
        GO TO 900
      ENDIF
C
C     Make negative if sign bit set
      IF ( ISCALE .GT. JP15BIT ) THEN
        ISCALE = ISCALE - JP15BIT
        ISCALE = -ISCALE
      ENDIF
      PSCALE = 2.0**ISCALE
#ifdef ebug2o
      WRITE(GRPRSM,FMT='('' D2ORDR - Binary scale factor ='',
     X       I20,TR1,F30.20,''.'')') ISCALE,PSCALE
#endif
C
C*    Octets 7 - 10 : Reference value.
C     One 8 bit and one 24 bit field.
C
C     Extract reference value exponent and mantissa.
      CALL INXBIT(KGRIB,KLENG,KNSPT,IEXP,1,KBITS, 8,YOPER,IRETA)
      CALL INXBIT(KGRIB,KLENG,KNSPT,IMANT,1,KBITS, 24,YOPER,IRETB)
      IRET = IRETA + IRETB
C
      IF (IRET.NE.0) THEN
        IRETFN = 17120
        WRITE(GRPRSM,FMT=9001) 'reference value'
        GO TO 900
      ENDIF
C
C     Decode the reference value
      CALL DECFP2 (PREF,IEXP,IMANT)
C
C*    Octet 11 : Number of bits containing each first-order value.
C     One 8 bit field.
C
      CALL INXBIT(KGRIB,KLENG,KNSPT,KSEC4(2),1,KBITS, 8,YOPER,IRET)
C
      IF (IRET.NE.0) THEN
        IRETFN = 17130
        WRITE(GRPRSM,FMT=9001) 'bit number of first-order values'
        GO TO 900
      ELSEIF (KSEC4(2).GT.JPXPWR) THEN
        IRETFN = 17131
        WRITE(GRPRSM,FMT=9002) 'Bit number (of first-order values)',
     X                          JPXPWR
        GO TO 900
#ifdef ebug2o
      ELSE
#else
      ELSEIF (LDEBUG) THEN
#endif
        WRITE(GRPRSM,FMT=9135) KSEC4(2)
      ENDIF
C
C     Octets 12 - 13: Octet number of the start of first-order packed 
C                     data.
C     One 16-bit field.
C
      CALL INXBIT(KGRIB,KLENG,KNSPT,IPTRFO,1,KBITS,16,YOPER,IRET)
C
      IF (IRET.NE.0) THEN
        IRETFN = 17140
        WRITE(GRPRSM,FMT=9001) 'pointer to first-order packed data'
        GO TO 900
#ifdef ebug2o
      ELSE
#else
      ELSEIF (LDEBUG) THEN
#endif
        WRITE(GRPRSM,FMT=9150) PREF, IPTRFO, KNSPT
      ENDIF
C
C     -----------------------------------------------------------------
C*    Section 2 . Decode octets 14 to 21.
C     -----------------------------------------------------------------
C
  200 CONTINUE
C
C     Octet 14: Extended flags.
C     One 8-bit field.
C
      CALL INXBIT(KGRIB,KLENG,KNSPT,IFLAGX,1,KBITS, 8,YOPER,IRET)
C
      IF (IRET.NE.0) THEN
        IRETFN = 17210
        WRITE(GRPRSM,FMT=9001) 'extended flags'
        GO TO 900
#ifdef ebug2o
      ELSE
#else
      ELSEIF (LDEBUG) THEN
#endif
        CALL PRTBIN (IFLAGX,8,IAUXIL,IRET)
C
        IF (IRET.NE.0) THEN
          IAUXIL=IFLAGX
        ENDIF
C
        WRITE(GRPRSM,FMT=9210) IAUXIL, KNSPT
      ENDIF
C
C         R------- only bit 1 is reserved.
C         -0------ single datum at each grid point.
C         -1------ matrix of values at each grid point.
C         --0----- no secondary bit map.
C         --1----- secondary bit map present.
C         ---0---- second order values have constant width.
C         ---1---- second order values have different widths.
C         ----0--- no general extended second order packing.
C         ----1--- general extended second order packing used.
C         -----0-- standard field ordering in section 4.
C         -----1-- boustrophedonic ordering in section 4.
C         ------00 no spatial differencing used.
C         ------01 1st-order spatial differencing used.
C         ------10 2nd-order    "         "         " .
C         ------11 3rd-order    "         "         " .
C
      IF (IFLAGX.GE.128) THEN
        IRETFN = 17220
        WRITE(GRPRSM,FMT=9220)
        GO TO 900
      ENDIF
C
      IAUXIL = 64
      INDKS4 = 6
C
      IVALK4 = 8
C
      DO 201 J = 2, IVALK4
C
      IF (J.EQ.5) THEN
        INDKS4 = INDKS4 + 1
      ENDIF
C      
      IF (IFLAGX.GE.IAUXIL) THEN
        KSEC4(INDKS4+J) = IAUXIL
        IFLAGX = IFLAGX - IAUXIL
      ENDIF
C
      IAUXIL=IAUXIL/2
  201 CONTINUE
C
#ifndef ebug2o
      IF (LDEBUG) THEN
#endif
        WRITE(GRPRSM,FMT=9225) (KSEC4(J),J=3,10)
#ifndef ebug2o
      ENDIF
#endif
C
      IF (IFLAGX.NE.0) THEN
        IRETFN = 17230
        WRITE(GRPRSM,FMT=9230)
        GO TO 900
      ELSEIF (KSEC4(8).NE.0) THEN
        IRETFN = 17240
        WRITE(GRPRSM,FMT=9240)
        GO TO 900
      ENDIF
C
      LPRIBI=MOD (KSEC1(5),128).GE.64
      LSECBI=KSEC4(9).NE.0
      LROW=.NOT.LSECBI.AND.KSEC4(12).EQ.0
      LGENXT=.NOT.LSECBI.AND.KSEC4(12).NE.0
      LBOUST=KSEC4(13).NE.0
      IORDER=KSEC4(14)+KSEC4(15)
C
      IF (IORDER.NE.0) THEN
C
        IF (HOPER.EQ.'X') THEN
          IRETFN = 17244
          WRITE(GRPRSM,FMT=9244) HOPER(:1)
          GO TO 900
        ELSEIF (.NOT.LGENXT) THEN
          IRETFN = 17245
          WRITE(GRPRSM,FMT=9245)
          GO TO 900
        ENDIF
C
      ENDIF
C
      LQUASI=KSEC2(17).EQ.1
      LCTWID=KSEC4(10).EQ.0
C
C     Octets 15 - 20: Octet number of the start of second-order packed 
C                     data, Number of first-order packed data,
C                     Number of second-order packed data.
C     Three 16-bit fields.
C
      CALL INXBIT(KGRIB,KLENG,KNSPT,KSEC4(17),3,KBITS,16,YOPER,IRET)
C
      IF (IRET.NE.0) THEN
        IRETFN = 17250
        WRITE(GRPRSM,FMT=9001) 'standard second-order descriptors'
        GO TO 900
      ENDIF
C
      IPTRSO=KSEC4(17)
      IFIROV=KSEC4(18)
      ISECOV=KSEC4(19)
C
#ifndef wmogrp2o
C     Octet 21: Reserved by WMO, so should be zero in standard case.
C               Could be used for extra bits of group number.
C     One 8-bit field.
C
      CALL INXBIT(KGRIB,KLENG,KNSPT,IEXTRA,1,KBITS, 8,YOPER,IRET)
C
      IF (IRET.NE.0) THEN
        IRETFN = 17255
        WRITE(GRPRSM,FMT=9001) '21st octet of section 4'
        GO TO 900
      ELSEIF (IEXTRA.NE.0) THEN
        IFIROV=IFIROV+(JP16SET+1)*IEXTRA
        CALL PRTBIN (IEXTRA,8,IAUXIL,IRET)
C
        IF (IRET.NE.0) THEN
          IAUXIL=IEXTRA
        ENDIF
C
        WRITE(GRPRSM,FMT=9255) IAUXIL, IEXTRA, IFIROV
      ENDIF
C
      KSEC4(18)=IFIROV
C
#else
C     Octet 21: Reserved by WMO.
C     One 8-bit field. Skipped.
C
      KNSPT = KNSPT + 8
C
#endif
      IF (KSEC1(5).GE.128) THEN
C
C     Cross checks between descriptors decoded above,
C     and section 2 descriptors previously decoded.
C
        IF (MOD (KSEC2(11),64).LT.32) THEN
          INROWS=KSEC2(3)
        ELSE
          INROWS=KSEC2(2)
        ENDIF
C
        IF (LROW.AND.((LPRIBI.AND.INROWS.LT.IFIROV).OR.
     X                (.NOT.LPRIBI.AND.INROWS.NE.IFIROV))) THEN
          IRETFN = 17260
          WRITE(GRPRSM,FMT=9260)
          GO TO 900
        ELSEIF (LQUASI) THEN
          IREFLN=22
          ILEN=0
C
          DO 211 J=1,INROWS
          ILEN=ILEN+KSEC2(IREFLN+J)
  211     CONTINUE
C
        ELSE
          ILEN=KSEC2(2)*KSEC2(3)
          ILNGTH=ILEN/INROWS
        ENDIF
C
        IF (LPRIBI.AND.ISECOV.GT.ILEN.AND.HOPER.NE.'J') THEN
          IRETFN = 17265
          WRITE(GRPRSM,FMT=9270) 'too big'
          GO TO 900
        ELSEIF (.NOT.LPRIBI) THEN
C
          IF (ILEN.LE.JP16SET.AND.(IORDER+ISECOV).NE.ILEN) THEN
            IRETFN = 17270
            WRITE(GRPRSM,FMT=9270) 'from section 2'
            GO TO 900
          ELSEIF (ILEN.GT.JP16SET) THEN
C
C           Two octets not wide enough for ISECOV - adjust.
C
            ISECOV=ILEN-IORDER
            KSEC4(19)=ISECOV
          ENDIF
C
        ELSEIF (KVALS.NE.ILEN) THEN
          IRETFN = 17275
          WRITE(GRPRSM,FMT=9275)
          GO TO 900
        ENDIF
C
      ELSE
C
C     No section 2 in the present message.
C
        IF (LROW) THEN
          IRETFN = 17277
          WRITE(GRPRSM,FMT=9277) 'Row by row packing'
          GO TO 900
        ELSEIF (HOPER.EQ.'X') THEN
          IRETFN = 17278
          WRITE(GRPRSM,FMT=9277) 'HOPER=''X'' function'
          GO TO 900
        ELSEIF (LBOUST) THEN
          IRETFN = 17279
          WRITE(GRPRSM,FMT=9277) 'Boustrophedonic ordering'
          GO TO 900
        ENDIF
C
      ENDIF
C
      IF (LPRIBI) THEN
C
        IF (KSEC3(1).EQ.0) THEN
C
C         Explicit primary bit-map included.
C         Computation of effective number of points.
C
          INBSEQ=1+(KVALS-1)/JPWS2O
          INVALS=0
          ISEQ=0
C
          IF (LROW.AND.HOPER.NE.'J') THEN
C
C           In row by row case, it is also necessary for decoding field
C           values to compute real length of rows. Do it now, as far as
C           permitted through ILENGR work array size.
C
            IAUXIS=0
            ILAUXS=MIN (JPWS2O,KVALS)
            IPTRBM=KBMAP
            ISEQ=1
            CALL INXBIT(KGRIB,KLENG,IPTRBM,IWORK2,ILAUXS,KBITS,1,YOPER,
     X                  IRET)
C
            IF (IRET.NE.0) THEN
              IRETFN = 17280
              WRITE(GRPRSM,FMT=9001) 'primary bit-map, row by row case'
              GO TO 900
            ENDIF
C
            DO 223 JROW=1,MIN (INROWS,JPWS1O)
C
C             Full length of row (unmasked).
C
            IF (LQUASI) THEN
              ILNGTH=KSEC2(IREFLN+JROW)
            ELSE
              ILNGTH=ILEN/INROWS
            ENDIF
C
            IVALS=ILNGTH
            ILNGTH=0
            IVALSC=IVALS
C
  221       CONTINUE
C
            DO 222 J=1,MIN (IVALSC,ILAUXS-IAUXIS)
            ILNGTH=ILNGTH+IWORK2(IAUXIS+J)
  222       CONTINUE
C
            IF (IVALSC.LE.ILAUXS-IAUXIS) THEN
C
              IAUXIS=IAUXIS+IVALSC
C
            ELSEIF (IPTRBM.LT.KBMAP+KVALS) THEN
C
              IVALSC=IVALSC-(ILAUXS-IAUXIS)
              ILAUXS=MIN(KBMAP+KVALS-IPTRBM,JPWS2O)
              IAUXIS=0
              ISEQ=ISEQ+1
              CALL INXBIT(KGRIB,KLENG,IPTRBM,IWORK2,ILAUXS,KBITS,1,
     X                    YOPER,IRET)
C
              IF (IRET.NE.0) THEN
                IRETFN = 17280
                WRITE(GRPRSM,FMT=9001)
     X                   'primary bit-map, row by row case'
                GO TO 900
              ENDIF
C
              GOTO 221
C
            ELSE
C
              IRETFN = 17560
              WRITE(GRPRSM,FMT=9560)
              GO TO 900
C
            ENDIF
C
            ILENGR(JROW)=ILNGTH
            INVALS=INVALS+ILNGTH
C
  223       CONTINUE
C
C             End-up current sequence (active only if bit-map has not
C             been fully processed)...
C
            DO 224 J=IAUXIS+1,ILAUXS
            INVALS=INVALS+IWORK2(J)
  224       CONTINUE
C
            IAUXIL=(ISEQ-1)*JPWS2O+IAUXIS
C
          ENDIF
C
C             Staightforward computing.
C
          DO 228 JSEQ=ISEQ+1,INBSEQ
          IAUXIS=(JSEQ-1)*JPWS2O
          ILAUXS=MIN (JPWS2O,KVALS-IAUXIS)
          IPTRBM=KBMAP+IAUXIS
          CALL INXBIT(KGRIB,KLENG,IPTRBM,IWORK2,ILAUXS,KBITS,1,YOPER,
     X                IRET)
C
          IF (IRET.NE.0) THEN
            IRETFN = 17280
            WRITE(GRPRSM,FMT=9001) 'primary bit-map'
            GO TO 900
          ENDIF
C
          DO 227 J=1,ILAUXS
          INVALS=INVALS+IWORK2(J)
  227     CONTINUE
C
  228     CONTINUE
C
          IF (LROW.AND.HOPER.NE.'J') THEN
C
            IF (INROWS.GT.JPWS1O) THEN
C
C           ... it is necessary to (re)read primary bit-map, adjusting
C           pointer to start of (JPWS1O+1)th row.
C
              IAUXIS=0
              ILAUXS=MIN (JPWS2O,KVALS-IAUXIL)
              IPTRBM=KBMAP+IAUXIL
              CALL INXBIT(KGRIB,KLENG,IPTRBM,IWORK2,ILAUXS,KBITS,1,
     X                    YOPER,IRET)
C
              IF (IRET.NE.0) THEN
                IRETFN = 17280
                WRITE(GRPRSM,FMT=9001)
     X               'primary bit-map, row by row case'
                GO TO 900
              ENDIF
C
            ENDIF
C
          ENDIF
C
          IF (INVALS.GT.JP16SET) THEN
C
C       Two octets might be not wide enough for ISECOV. Adjust.
C
            ISECOV=INVALS-IORDER
          ENDIF
C
        ELSEIF (LROW) THEN
C
          IRETFN = 17281
          WRITE(GRPRSM,FMT=9281) 'Row by row'
          GO TO 900
C
        ELSEIF (LBOUST) THEN
C
          IRETFN = 17282
          WRITE(GRPRSM,FMT=9281) 'Boustrophedonic ordering'
          GO TO 900
C
        ENDIF
C
C         WARNING:
C         -------
C       Whenever an implicit primary bit-map is included, it is then
C       assumed that ISECOV contains the right number of grid-points
C       really included in section 4. This is valid only if this
C       effective number of points is lower than (or equal to) JP16SET.

      ENDIF
C
      IF (IORDER+ISECOV.GT.KLENP.AND.HOPER.NE.'J'.AND.HOPER.NE.'X') THEN
        IRETFN = 17290
        WRITE(GRPRSM,FMT=9290) IORDER+ISECOV,KLENP
        GO TO 900
      ELSEIF (HOPER.EQ.'X'.AND.KLENP.LE.IORDER) THEN
        IRETFN = 17291
        WRITE(GRPRSM,FMT=9291) IORDER+1
        GO TO 900
      ENDIF
C
C     -----------------------------------------------------------------
C*    Section 3 . Decode last octet(s) (22...) before loop on groups.
C     -----------------------------------------------------------------
C
  300 CONTINUE
C
      IF (KSEC4(12).NE.0) THEN
C
C               General extended second-order packing used.
C
        IF (LSECBI) THEN
          IRETFN = 17310
          WRITE(GRPRSM,FMT=9310) 'no secondary bit-map'
          GO TO 900
        ELSEIF (LCTWID) THEN
          IRETFN = 17320
          WRITE(GRPRSM,FMT=9310) 'variable group widths'
          GO TO 900
        ENDIF
C
C     Octets 22 - 23: Width of widths, Width of lengths.
C     Two 8-bit fields.
C
        CALL INXBIT(KGRIB,KLENG,KNSPT,IWORK,2,KBITS,8,YOPER,IRET)
C
        IF (IRET.NE.0) THEN
          IRETFN = 17330
          WRITE(GRPRSM,FMT=9001) 'general extended descriptors, widths'
          GO TO 900
        ENDIF
C
        IBITGW=IWORK(1)
        IBITGS=IWORK(2)
C
        IF (MAX (IBITGW,IBITGS).GT.JPXPWR) THEN
          IRETFN = 17340
          WRITE(GRPRSM,FMT=9002)
     X         'general extended width of (group and/or size)',
     X                            JPXPWR
          GO TO 900
        ENDIF
C
        KSEC4(11)=IBITGS
C
C     Octets 24-25: Octet number of the start of group sizes (lengths).
C     One 16-bit field.
C
        CALL INXBIT(KGRIB,KLENG,KNSPT,IPTRGS,1,KBITS,16,YOPER,IRET)
C
        IF (IRET.NE.0) THEN
          IRETFN = 17345
          WRITE(GRPRSM,FMT=9001) 'general extended group size pointer'
          GO TO 900
        ENDIF
C
        IPTRSN=1+(8+(KNSPT-INSPTA)+IFIROV*IBITGW-1)/8
C
        IF (IPTRSN.GT.JP16SET) THEN
C
C           Two octets not wide enough for IPTRGS - adjust.
C
          IPTRGS=IPTRSN
        ENDIF
C
        IF (IORDER.NE.0.AND.HOPER.NE.'J') THEN
C
C     Octet 26: Width of spatial differencing specific descriptors.
C     One 8-bit field.
C
          CALL INXBIT(KGRIB,KLENG,KNSPT,IWIDSD,1,KBITS,8,YOPER,IRET)
C
          IF (IRET.NE.0) THEN
            IRETFN = 17346
            WRITE(GRPRSM,FMT=9001)
     X           'Width of spatial differencing descriptors'
            GO TO 900
          ELSEIF (IWIDSD.NE.0) THEN
C
C     Octet 27-onwards: first IORDER original values and diff. bias.
C     (IORDER+1) fields of IWIDSD bits.
C
            IAUXIL=IORDER+1
            CALL INXBIT(KGRIB,KLENG,KNSPT,KDATA,IAUXIL,KBITS,IWIDSD,
     X                  YOPER,IRET)
C
            IF (IRET.NE.0) THEN
              IRETFN = 17347
              WRITE(GRPRSM,FMT=9001)
     X           'First field value(s) (spatial differencing case)'
              GO TO 900
            ENDIF
C
C              Decode bias and its sign.
C
            CALL DSGNBT(IBIAS,KDATA(IAUXIL),IWIDSD,IRET)
C
            IF (IRET.NE.0) THEN
              IRETFN = 17348
              WRITE(GRPRSM,FMT=9348) IRET
              GO TO 900
            ENDIF
C
C                 Adjust pointer to next octet boundary.
C
            KNSPT=8*((8+KNSPT-1)/8)
C
          ELSE
C
C                 Spatial differencing descriptors are all zero.
C
            DO 311 J=1,IORDER
            KDATA(J)=0
  311       CONTINUE
C
            IBIAS=0
C
          ENDIF
C
        ENDIF
C
      ELSE
C
        IBITGW=8
C
        IF (LCTWID) THEN
C
C     Octet 22: Single value for width of second-order values.
C     One 8-bit field.
C
          CALL INXBIT(KGRIB,KLENG,KNSPT,IWIDTH,1,KBITS,8,YOPER,IRET)
C
          IF (IRET.NE.0) THEN
            IRETFN = 17350
            WRITE(GRPRSM,FMT=9001) 'constant width of 2nd-order values'
            GO TO 900
          ELSEIF (IWIDTH.GT.JPXPWR) THEN
            IRETFN = 17351
            WRITE(GRPRSM,FMT=9002) 'Constant width', JPXPWR
            GO TO 900
          ENDIF
C
          KSEC4(11)=IWIDTH
C
        ENDIF
C
        IF (LSECBI) THEN
C
C     Secondary bit-map present. Initialize pointer, and decode
C     start of secondary bit-map (if field decoding is requested).
C
          IF (LCTWID) THEN
            IPTRBM=23
          ELSE
            IPTRBM=22+IFIROV
          ENDIF
C
          IPTRBM=(IPTRBM-1)*8+INSPTA
          IPTRB0=IPTRBM
C
          IF (HOPER.NE.'J') THEN
C
            ILAUXS=MIN(ISECOV,JPWS2O)
            IAUXIS=1
            CALL INXBIT(KGRIB,KLENG,IPTRBM,IWORK2,ILAUXS,KBITS,1,YOPER,
     X                  IRET)
C
            IF (IRET.NE.0) THEN
              IRETFN = 17360
              WRITE(GRPRSM,FMT=9001) 'start of secondary bit-map'
              GO TO 900
            ELSEIF (IWORK2(1).NE.1) THEN
              IRETFN = 17365
              WRITE(GRPRSM,FMT=9365)
              GO TO 900
            ENDIF
C
          ENDIF
C
        ENDIF
C
      ENDIF
C
C     Compute minimum values for pointers. If it leads to value(s)
C     not fitting in 2 octets, then assume these are the right
C     value(s) to use.
C
      IPTRGW=KNSPT
      IPTRFN=1+(8+IPTRGW-INSPTA-1)/8
C
      IF (LCTWID) THEN
        IPTRFN=IPTRFN+(8+ISECOV-1)/8
      ELSEIF (LROW) THEN
        IPTRFN=IPTRFN+(8+IFIROV*IBITGW-1)/8
      ELSEIF (LGENXT) THEN
        IPTRFN=IPTRFN+(8+IFIROV*IBITGW-1)/8+(8+IFIROV*IBITGS-1)/8
      ELSE
        IPTRFN=IPTRFN+(8+IFIROV*IBITGW-1)/8+(8+ISECOV-1)/8
      ENDIF
C
      IF (IPTRFN.GT.JP16SET) THEN
        IPTRFO=IPTRFN
      ENDIF
C
      KSEC4(16)=IPTRFO
      IPTRSN=IPTRFO+(8+IFIROV*KSEC4(2)-1)/8
C
      IF (IPTRSN.GT.JP16SET) THEN
        IPTRSO=IPTRSN
        KSEC4(17)=IPTRSO
      ENDIF
C
#ifndef ebug2o
      IF (LDEBUG) THEN
#endif
C
        IF (LROW) THEN
          WRITE(GRPRSM,FMT=9381) 'row by row'
        ELSEIF (LCTWID) THEN
          WRITE(GRPRSM,FMT=9382) KSEC4(11)
        ELSEIF (LGENXT) THEN
          WRITE(GRPRSM,FMT=9381) 'general extended'
        ELSE
          WRITE(GRPRSM,FMT=9381) 'WMO general 2nd-order'
        ENDIF
C
        IF (LBOUST) THEN
          WRITE(GRPRSM,FMT=9383)
        ENDIF
C
        IF (IORDER.NE.0) THEN
          WRITE(GRPRSM,FMT=9384) IORDER, IBIAS
        ENDIF
C
        WRITE(GRPRSM,FMT=9385) IFIROV, ISECOV, IPTRFO, IPTRSO
#ifndef ebug2o
      ENDIF
C
#endif
      KSEC4(20)=IBITGW
      IPTRFO=(IPTRFO-1)*8+INSPTA
      IPTRSO=(IPTRSO-1)*8+INSPTA
C
C     Cross checks betweens pointers.
C
      IF (LGENXT) THEN
C
        IPTRGS=(IPTRGS-1)*8+INSPTA
C
        IF (IPTRGW+IFIROV*IBITGW.GT.IPTRGS) THEN
          IRETFN = 17391
          WRITE(GRPRSM,FMT=9391)
          GO TO 900
        ELSEIF (IPTRGS+IFIROV*IBITGS.GT.IPTRFO) THEN
          IRETFN = 17392
          WRITE(GRPRSM,FMT=9393)
     X           'general extended group size/1st-order values'
          GO TO 900
        ENDIF
C
      ELSEIF (LSECBI) THEN
C
        IF (IPTRB0+ISECOV.GT.IPTRFO) THEN
          IRETFN = 17393
          WRITE(GRPRSM,FMT=9393) '2ndary bit-map/1st-order values'
          GO TO 900
        ENDIF
C
      ENDIF
C
      IF (IPTRFO+IFIROV*KSEC4(2).GT.IPTRSO) THEN
        IRETFN = 17394
        WRITE(GRPRSM,FMT=9393) 'First-order/Second-order'
        GO TO 900
      ENDIF
C
C     -----------------------------------------------------------------
C*    Section 4 . Additional preprocessing for function 'X'.
C     -----------------------------------------------------------------
C
  400 CONTINUE
C
      IF (HOPER.EQ.'X') THEN
C
C     First, perform some checks.
C
        INDEXX=34
        INDEXY=42
C
#ifndef ebug2o
        IF (LDEBUG) THEN
#endif
          WRITE(GRPRSM,FMT=9401) INDEXX, INDEXY,
     X                            (KSEC4(J),J=INDEXX,INDEXY)
#ifndef ebug2o
        ENDIF
#endif
C
        INPEXT=KSEC4(INDEXX)
C
        IF (LPRIBI) THEN
          IRETFN = 17410
          WRITE(GRPRSM,FMT=9410) 'not valid with a (primary) bit-map'
          GO TO 900
        ELSEIF (KSEC2(1).GE.40.OR.
     X          (MOD(KSEC2(1),10).NE.0.AND.MOD(KSEC2(1),10).NE.4)) THEN
          IRETFN = 17411
          WRITE(GRPRSM,FMT=9410)
     X              'valid only with lat/long or gaussian field'
          GO TO 900
        ELSEIF (INPEXT.LT.1.OR.INPEXT.GT.JPXMAX) THEN
          IRETFN = 17412
          WRITE(GRPRSM,FMT=9412) JPXMAX,' points.'
          GO TO 900
        ELSEIF (INPEXT.GT.KLENP) THEN
          IRETFN = 17413
          WRITE(GRPRSM,FMT=9413) INPEXT
          GO TO 900
        ENDIF
C
C       Take into account third bit of scanning modes to know 
C       which dimension is latitude.
C
C       INCR=0 means that longitude is the most rapidly varying.
C
        INCR=MOD (KSEC2(11),64)/32
C
C       Now compute 1-dimensional "addresses" in whole field.
C
        DO 422 JEXT=1,INPEXT
        INDROW=KSEC4(INDEXX+2*JEXT-1+INCR)
        INDCOL=KSEC4(INDEXX+2*JEXT  -INCR)
C
        IF (INDROW.LT.1.OR.INDROW.GT.INROWS) THEN
          IRETFN = 17421
          WRITE(GRPRSM,FMT=9421) JEXT, INCR+1, INROWS
          GO TO 900
        ELSEIF(LQUASI) THEN
          ISKIP=0
C
          DO 421 J=1,INDROW-1
          ISKIP=ISKIP+KSEC2(IREFLN+J)
  421     CONTINUE
C
          ILNGTH=KSEC2(IREFLN+INDROW)
C
        ELSE
          ISKIP=(INDROW-1)*ILNGTH
        ENDIF
C
        IF (INDCOL.LT.1.OR.INDCOL.GT.ILNGTH) THEN
          IRETFN = 17422
          WRITE(GRPRSM,FMT=9421) JEXT, 2-INCR, ILNGTH
          GO TO 900
        ENDIF
C
#ifndef ebug2o
        IF (LDEBUG) THEN
#endif
          WRITE(GRPRSM,FMT=9422) JEXT, INDROW, INDCOL, ISKIP, ILNGTH
#ifndef ebug2o
        ENDIF
C
#endif
        IF (LBOUST.AND.MOD(INDROW,2).EQ.0) THEN
          INDCOL=ILNGTH+1-INDCOL
        ENDIF
C
        IRGEXT(JEXT)=ISKIP+INDCOL
        INDXOR(JEXT)=JEXT
  422   CONTINUE
C
C     Finally, sort "addresses" in ascending order.
C
        DO 432 JEXT=1,INPEXT-1
C
        DO 431 J=JEXT+1,INPEXT
C
        IF (IRGEXT(J).LT.IRGEXT(JEXT)) THEN
          IAUXIL=IRGEXT(J)
          IRGEXT(J)=IRGEXT(JEXT)
          IRGEXT(JEXT)=IAUXIL
          IAUXIL=INDXOR(J)
          INDXOR(J)=INDXOR(JEXT)
          INDXOR(JEXT)=IAUXIL
        ENDIF
C
  431   CONTINUE
C
  432   CONTINUE
C
        IRGEXT(INPEXT+1)=0
#ifndef ebug2o
C
        IF (LDEBUG) THEN
#endif
          PRINT *,' D2ORDR: IRGEXT = ',IRGEXT,', INDXOR = ',INDXOR,'.'
#ifndef ebug2o
        ENDIF
C
#endif
      ELSE
        INPEXT=0
      ENDIF
C
C     -----------------------------------------------------------------
C*    Section 5 . Decode values, group by group.
C     -----------------------------------------------------------------
C
  500 CONTINUE
C
C     Finished if function 'J' is requested.
C
      IF (HOPER.EQ.'J') THEN
        KSEC4(1)=IORDER+ISECOV
        GO TO 900
      ENDIF
C
      ICOUNT=IORDER
      ICOUNS=IORDER
      ICOUNG=IORDER
      IEXT=1
      INBSEQ=1+(IFIROV-1)/JPWS1O
C
      IF (KSEC4(2).EQ.0) THEN
C
C       In this case, no first-order values are provided: they are
C       all equal to 0 (group references equal to field reference).
C
        DO 501 J=1,MIN (IFIROV,JPWS1O)
        IFIRST(J)=0
  501   CONTINUE
C
      ENDIF
C
      IF (LCTWID.AND.HOPER.NE.'X') THEN
C
C       Constant width packing. Second-order values will be
C       decoded once per sequence.
C
        IPRWID=KSEC4(11)
C
        DO 502 J=1,MIN (IFIROV,JPWS1O)
        IWIDGR(J)=IPRWID
  502   CONTINUE
C
      ENDIF
C
C                 Groups treated as sequences, as large as possible
C                 with respect to group work arrays size (JPWS1O). 
C
      DO 591 JSEQ=1,INBSEQ
C
      IGROFF=(JSEQ-1)*JPWS1O
      IGRNBR=MIN (JPWS1O,IFIROV-IGROFF)
C
      IF (LGENXT) THEN
        CALL INXBIT(KGRIB,KLENG,IPTRGS,IWORK2,IGRNBR,KBITS,IBITGS,YOPER,
     X              IRET)
C
        IF (IRET.NE.0) THEN
          IRETFN = 17510
          WRITE(GRPRSM,FMT=9510) 'sizes', IGROFF+1, IGROFF+IGRNBR
          GO TO 900
        ENDIF
C
      ENDIF
C
      IF (.NOT.LCTWID) THEN
        CALL INXBIT(KGRIB,KLENG,IPTRGW,IWIDGR,IGRNBR,KBITS,IBITGW,YOPER,
     X              IRET)
C
        IF (IRET.NE.0) THEN
          IRETFN = 17520
          WRITE(GRPRSM,FMT=9510) 'widths', IGROFF+1, IGROFF+IGRNBR
          GO TO 900
        ENDIF
C
        IPRWID=IWIDGR(1)
C
      ENDIF
C
      IF (KSEC4(2).NE.0) THEN
C
        CALL INXBIT(KGRIB,KLENG,IPTRFO,IFIRST,IGRNBR,KBITS,KSEC4(2),
     X              YOPER,IRET)
C
        IF (IRET.NE.0) THEN
          IRETFN = 17530
          WRITE(GRPRSM,FMT=9510) '1st-order values', IGROFF+1,
     X         IGROFF+IGRNBR
          GO TO 900
        ENDIF
C
      ENDIF
C
      ILNGTS=0
C
C     Loop over groups in a given sequence.
C
      DO 551 JGROUP=1,IGRNBR
C
C     Define length of current group: ILNGTH.
C
      IF (LGENXT) THEN
        ILNGTH=IWORK2(JGROUP)
      ELSEIF (LSECBI) THEN
C
        ILNGTH=0
C
  520   CONTINUE
C
        DO 521 J=IAUXIS+1,ILAUXS
C
        IF (IWORK2(J).EQ.1) THEN
          IRANG=J
          GOTO 522
        ENDIF
C
  521   CONTINUE
C
        ILNGTH=ILNGTH+ILAUXS-IAUXIS
C
        IF (IPTRBM.LT.IPTRB0+ISECOV) THEN
          ILAUXS=MIN(IPTRB0+ISECOV-IPTRBM,JPWS2O)
          IAUXIS=0
          CALL INXBIT(KGRIB,KLENG,IPTRBM,IWORK2,ILAUXS,KBITS,1,YOPER,
     X                IRET)
C
          IF (IRET.NE.0) THEN
            IRETFN = 17540
            WRITE(GRPRSM,FMT=9001) 'secondary bit-map'
            GO TO 900
          ENDIF
C
          GOTO 520
        ELSE
C
C           It was the last group.
C
          ILNGTH=ILNGTH+1
          GOTO 523
        ENDIF
C
  522   CONTINUE
C
        ILNGTH=ILNGTH+IRANG-IAUXIS
        IAUXIS=IRANG
C
  523   CONTINUE
C
      ELSE
C
C        ... that's row by row packing...
C
C            (re)definition of row length.
C
        IF (LQUASI) THEN
          IREFLN=IREFLN+1
          ILNGTH=KSEC2(IREFLN)
        ELSE
          ILNGTH=ILEN/INROWS
        ENDIF
C       
        IF (LPRIBI) THEN
C
C         Row by row packing, but an explicit bit-map is included.
C         The number of values in current row has to be known.
C
          IVALS=ILNGTH
C
          IF (JSEQ.EQ.1) THEN
C
C            Rows of first sequence has been pre-computed in Section 2.
C
            ILNGTH=ILENGR(JGROUP)
C
          ELSE
C
            ILNGTH=0
            IVALSC=IVALS
C
  530       CONTINUE
C
            DO 531 J=1,MIN (IVALSC,ILAUXS-IAUXIS)
            ILNGTH=ILNGTH+IWORK2(IAUXIS+J)
  531       CONTINUE
C
            IF (IVALSC.LE.ILAUXS-IAUXIS) THEN
C
              IAUXIS=IAUXIS+IVALSC
C
            ELSEIF (IPTRBM.LT.KBMAP+KVALS) THEN
C
              IVALSC=IVALSC-(ILAUXS-IAUXIS)
              ILAUXS=MIN(KBMAP+KVALS-IPTRBM,JPWS2O)
              IAUXIS=0
#ifndef ebug2o
C
              IF (LDEBUG) THEN
#endif
                WRITE(GRPRSM,FMT=9540) IGROFF+JGROUP, IPTRBM, ILAUXS
#ifndef ebug2o
              ENDIF
C
#endif
              CALL INXBIT(KGRIB,KLENG,IPTRBM,IWORK2,ILAUXS,KBITS,1,
     X                    YOPER,IRET)
C
              IF (IRET.NE.0) THEN
                IRETFN = 17550
                WRITE(GRPRSM,FMT=9001)
     X                    'primary bit-map in row by row case'
                GO TO 900
              ENDIF
C
              GOTO 530
C
            ELSE
C
              IRETFN = 17560
              WRITE(GRPRSM,FMT=9560)
              GO TO 900
C
            ENDIF
C
          ENDIF
C
#ifndef ebug2o
          IF (LDEBUG) THEN
#endif
            WRITE(GRPRSM,FMT=9565) IGROFF+JGROUP, ILNGTH, IVALS
#ifndef ebug2o
          ENDIF
C
#endif
        ENDIF
C
      ENDIF
C
      ICNEXT=ICOUNT+ILNGTH
C
      IF (ICNEXT.GT.(IORDER+ISECOV)) THEN
        IRETFN = 17570
        WRITE(GRPRSM,FMT=9570) ICNEXT, ISECOV
        GO TO 900
      ENDIF
C
      ILENGR(JGROUP)=ILNGTH
C
C         Go to next group if no point is included in current group.
C         (may only occur for masked field in row by row case)
C
      IF (ILNGTH.EQ.0) THEN
        IWIDGR(JGROUP)=0
        IFIRST(JGROUP)=0
        GOTO 551
      ENDIF
C
C     If necessary, (re)define width of current group: IWIDTH.
C
      IWIDTH=IWIDGR(JGROUP)
C
  540 CONTINUE
C
C     All characteristics of current group are known, so proceed
C     with second-order data.
C
C     Except for 'X' function, neighbour groups of same width are
C     "unpacked" together, at least once per sequence.
C
      IF (HOPER.NE.'X') THEN
C
C         All values of current group will have to be processed.
C
        IF (IWIDTH.NE.IPRWID) THEN
C
C     Current group may not be unpacked together with previous one(s).
C
#ifdef ebug2o
          PRINT *,'d2ordr - groups..',IGROFF+JGROUP-1,
     X          ' IPTRSO/IPRWID/ICOUNS/ILNGTS= ',
     X            IPTRSO, IPRWID, ICOUNS, ILNGTS
#endif
C
          IF (IPRWID.NE.0.AND.ILNGTS.NE.0) THEN
C
C     Effective decoding of second-order values, for previous group(s).
C
            CALL INXBIT(KGRIB,KLENG,IPTRSO,KDATA(ICOUNS+1),
     X                  ILNGTS,KBITS,IPRWID,YOPER,IRET)
C
            IF (IRET.NE.0) THEN
              IRETFN = 17580
              WRITE(GRPRSM,FMT=9580) 'groups..', IGROFF+JGROUP-1
              GO TO 900
            ENDIF
C
          ENDIF
C
          ICOUNS=ICOUNT
          ILNGTS=0
          IPRWID=IWIDTH
C
        ENDIF
C
        ILNGTS=ILNGTS+ILNGTH
C
      ELSEIF (IRGEXT(IEXT).GT.ICOUNT.AND.IRGEXT(IEXT).LE.ICNEXT) THEN
C
C     Function 'X' - Compute only a single "full" normalized value.
C
        IEXTOR=INDXOR(IEXT)
C
        IF (IWIDTH.NE.0) THEN
          IAUXIL=IPTRSO+(IRGEXT(IEXT)-ICOUNT-1)*IWIDTH
          CALL INXBIT(KGRIB,KLENG,IAUXIL,KDATA(IEXTOR),1,KBITS,
     X                IWIDTH,YOPER,IRET)
C
          IF (IRET.NE.0) THEN
            IRETFN = 17580
            WRITE(GRPRSM,FMT=9580) 'group', IGROFF+JGROUP
            GO TO 900
          ENDIF
C
          KDATA(IEXTOR)=IFIRST(JGROUP)+KDATA(IEXTOR)
        ELSE
          KDATA(IEXTOR)=IFIRST(JGROUP)
        ENDIF
C
        IEXT=IEXT+1
#ifndef ebug2o
C
        IF (LDEBUG) THEN
#endif
          WRITE(GRPRSM,FMT=9585) IEXT, INPEXT
#ifndef ebug2o
        ENDIF
#endif
C
C       Loop back, to allow for extraction of other point(s)
C       within the current group.
C
        GOTO 540
C
      ELSE
C
C       Function 'X', but group contains no requested grid-point.
C       Pointer adjusted for next group.
C
        IPTRSO=IPTRSO+ILNGTH*IWIDTH
C
      ENDIF
C
      ICOUNT=ICNEXT
C
  551 CONTINUE
C
      IF (HOPER.NE.'X') THEN
C
#ifdef ebug2o
        PRINT *,'d2ordr - groups..',IGROFF+IGRNBR,
     X          ' IPTRSO/IPRWID/ICOUNS/ILNGTS= ',
     X            IPTRSO, IPRWID, ICOUNS, ILNGTS
C
#endif
        IF (IPRWID.NE.0.AND.ILNGTS.NE.0) THEN
C
C         Effective decoding of second-order values, for last group(s)
C         of the current sequence.
C
C         In case of constant width packing it means all groups
C         of the current sequence.
C
          CALL INXBIT(KGRIB,KLENG,IPTRSO,KDATA(ICOUNS+1),
     X                ILNGTS,KBITS,IPRWID,YOPER,IRET)
C  
          IF (IRET.NE.0) THEN
            IRETFN = 17580
            WRITE(GRPRSM,FMT=9580) 'groups..', IGROFF+IGRNBR
            GO TO 900
          ENDIF
C
        ENDIF
C
        ICOUNS=ICOUNT
C
C       Add first-order values to rebuild original normalized values.
C
        DO 563 JGROUP=1,IGRNBR
C
#ifdef ebug2o
        IMAXVC=0
#endif
        IREFER=IFIRST(JGROUP)
        ILNGTH=ILENGR(JGROUP)
        IWIDTH=IWIDGR(JGROUP)
C
        IF (IWIDTH.NE.0) THEN
C
          DO 561 J=1,ILNGTH
#ifdef ebug2o
          IMAXVC=MAX(IMAXVC,KDATA(ICOUNG+J))
#endif
          KDATA(ICOUNG+J)=IREFER+KDATA(ICOUNG+J)
  561     CONTINUE
C
        ELSE
C
C     Group with a constant value: no second order value included.
C
          DO 562 J=1,ILNGTH
          KDATA(ICOUNG+J)=IREFER
  562     CONTINUE
C
        ENDIF
C
        ICOUNG=ICOUNG+ILNGTH
#ifdef ebug2o
        PRINT *,'d2ordr - group ',IGROFF+JGROUP,ICOUNG,ILNGTH,IWIDTH,
     X           IREFER,IMAXVC
#endif
C
  563   CONTINUE
C
      ENDIF
C
  591 CONTINUE
C
C     -----------------------------------------------------------------
C*    Section 6 . Last computations.
C     -----------------------------------------------------------------
C
  600 CONTINUE
C
C          From this point and for the remaining part of the routine,
C          ISECOV is the total number of grid-points.
C
      ISECOV=IORDER+ISECOV
C
      IF (IORDER.NE.0) THEN
C
C         Rebuild original field values from spatial differences.
C
#if (defined CRAY) || (defined FUJITSU)
        LVECTD=.TRUE.
#else
        LVECTD=.FALSE.
#endif
C
        IRETFN = D2ROSD ( KDATA,  ISECOV, IORDER, IPOWER, JPXPWR,
     X                    IBIAS,  LVECTD, LDEBUG )
C
        IF (IRETFN.NE.0) THEN
          GOTO 900
        ENDIF
C
      ENDIF
C
      IF (HOPER.NE.'X') THEN
C
C       Recompute original bit number for the whole field.
C
        CALL MAXMNI (KDATA,ISECOV,IMAXVN,IAUXIL)
C
        KSEC4(2) = C2BITW ( IMAXVN, JPXPWR, IPOWER, JPXPWR )
C
#ifndef ebug2o
        IF (LDEBUG) THEN
#endif
          WRITE(GRPRSM,FMT=9601) KSEC4(2)
#ifndef ebug2o
        ENDIF
C
#endif
        IF (ICOUNT.NE.ISECOV) THEN
          IRETFN = 17610
          WRITE(GRPRSM,FMT=9610) ICOUNT, ISECOV
          GO TO 900
        ELSE
          KSEC4(1)=ISECOV
        ENDIF        
C
      ELSE
        KSEC4(1)=MIN(IEXT,JPXMAX)
      ENDIF
C
#ifndef ebug2o
      IF (LDEBUG) THEN
#endif
        WRITE(GRPRSM,FMT=9602) KSEC4(1)
#ifndef ebug2o
      ENDIF
C
#endif
      KNSPT=INSPTA+KLEN4*8-KNIL
C
      IF (IPTRSO.NE.KNSPT) THEN
        IRETFN = 17620
        WRITE(GRPRSM,FMT=9620) IPTRSO, KNSPT
        GO TO 900
      ENDIF        
C
      IF (LBOUST.AND.HOPER.NE.'X') THEN
C
C           Reverse ordering within even rank rows.
C
        LPRCLN=.FALSE.
C
        IRETFN = REVERO ( KDATA,  KLENP,  KSEC2,  KGRIB,  KLENG,
     X                    KBITS,  KBMAP,  KVALS,  LPRIBI, LQUASI,
     X                    INROWS, ISECOV, IFIRST, JPWS2O, LDEBUG,
     X                    LPRCLN, IWORK2 )
      ENDIF
C
C     -----------------------------------------------------------------
C*    Section 9. Return to calling routine.
C     -----------------------------------------------------------------
C
  900 CONTINUE
C
      D2ORDR = IRETFN
#ifndef ebug2o
C
      IF (LDEBUG) THEN
#endif
        WRITE(GRPRSM,FMT=9900) IRETFN, HOPER(:1), KNSPT
#ifndef ebug2o
      ENDIF
#endif
C
      RETURN
C
 9001 FORMAT (' D2ORDR: Problem extracting ',A,'.')
C
 9002 FORMAT (' D2ORDR: ',A,' above',I3,'.')
C
 9100 FORMAT (' D2ORDR: Function start, HOPER = ',A,', KNSPT =',I10,
     X        '.')
 9135 FORMAT (' D2ORDR: Decoded number of bits (for 1st-order values)',
     X        ' =',I3,'.')
 9150 FORMAT (' D2ORDR: PREF =',F30.20,', decoded IPTRFO =',I6,'.',/,
     X        ' D2ORDR: KNSPT at end of "Section 1" =',I10,'.')
 9210 FORMAT (' D2ORDR: Extended flags =',I9.8,', KNSPT =',I10,'.')
 9220 FORMAT (' D2ORDR: First extended flag (reserved) set.')
 9225 FORMAT (' D2ORDR: KSEC4(3:10) =',I4,3I3,I2,3I3,'.')
 9230 FORMAT (' D2ORDR: Last extended flag(s) (reserved) set.')
 9240 FORMAT (' D2ORDR: Matrix of values invalid here.')
 9244 FORMAT (' D2ORDR: Function HOPER = "',A1,
     X        '" not supported for spatial differencing.')
 9245 FORMAT (' D2ORDR: Spatial differencing implies general',
     X                   ' extended 2nd-order packing.')
#ifndef wmogrp2o
 9255 FORMAT (' D2ORDR: 21st octet of section 4 not zero:',I9.8,
     X        '=>',I3,'.',/,TR10,
     X        'interpreted as extra bits for group number:',I8,'.')
#endif
 9260 FORMAT (' D2ORDR: Row by row packing: row/group numbers',
     X        ' not consistent.')
 9270 FORMAT (' D2ORDR: Number of second-order values ',A,'.')
 9275 FORMAT (' D2ORDR: (Primary bit-map size/section 2 contents)',
     X        ' mismatch.')
 9277 FORMAT (' D2ORDR: ',A,' only supported with a section 2.')
 9281 FORMAT (' D2ORDR: ',A,
     S        '/Implicit primary bit-map: not supported.')
 9290 FORMAT (' D2ORDR: Grid-point number exceeds KDATA size:',I9,
     X        ' >',I9,'.')
 9291 FORMAT (' D2ORDR: Function ''X'' - KDATA size must be at least',
     X        I2,' for actual spatial differencing).')
C
 9310 FORMAT (' D2ORDR: General extended packing implies ',A,'.')
 9348 FORMAT (
     X' D2ORDR: Bias sign management problem, DSGNBT return is',I5,'.')
 9365 FORMAT (' D2ORDR: First bit of secondary bit-map is not set.')
 9381 FORMAT (' D2ORDR: Packing method is ',A,'.')
 9382 FORMAT (' D2ORDR: Packing method is constant width, on',I3,
     X        ' bits.')
 9383 FORMAT (' D2ORDR: Boustrophedonic ordering used.')
 9384 FORMAT (' D2ORDR: Spatial differencing used, order is',I2,
     X        ', bias =',I9,'.')
 9385 FORMAT (' D2ORDR: IFIROV, ISECOV, IPTRFO, IPTRSO =',2I8,2I10,
     X        '.')
 9391 FORMAT (
     X ' D2ORDR: Bad pointer to general extended group size info.')
 9393 FORMAT (' D2ORDR: (',A,')',' pointers mismatch.')
C
 9401 FORMAT (' D2ORDR: ''X'' Function - KSEC4(',I2,':',I2,') = ',I3,
     X        8I6,'.')
 9410 FORMAT (' D2ORDR: Function ''X'' ',A,'.')
 9412 FORMAT (' D2ORDR: Function ''X'' valid only for 1 to',I3,
     X        ' points.')
 9413 FORMAT (' D2ORDR: Function ''X'' - KDATA size insufficient for',
     X        I2,' points requested.')
 9421 FORMAT (' D2ORDR: Function ''X'', Point',I6,',',I2,
     X        '-index not in range [1-',I6,'].')
 9422 FORMAT (' D2ORDR: JEXT, INDROW, INDCOL, ISKIP, ILNGTH =',
     X        I3,2I6,I8,I6,'.')
C
 9510 FORMAT (' D2ORDR: ',A,', groups',I6,'..',I6.6,'.')
 9540 FORMAT (' D2ORDR: mask, row',I6,', bit-map pointer =',I10,
     X        ', size requested=',I8,'.')
 9560 FORMAT (' D2ORDR: Pointers problem for primary bit-map,',
     X        ' row by row case.')
 9565 FORMAT (' D2ORDR: mask, row',I6,', length =',I6,' out of',I6,'.')
 9570 FORMAT (' D2ORDR: Grid-point number overflow:',I8,' >',I8,'.')
 9580 FORMAT (' D2ORDR: second-order values, ',A,I8,'.')
 9585 FORMAT (' D2ORDR: IEXT =',I3,', INPEXT =',I3,'.')
C
 9601 FORMAT (
     X  ' D2ORDR: Original number of bits -returned in KSEC4(2)-) =',
     X  I3,'.')
 9602 FORMAT (' D2ORDR: Values decoded -returned in KSEC4(1)- =',
     X        I8,'.')
 9610 FORMAT (' D2ORDR: Mismatch: sum of group lengths =',I8,
     X        ', expected =',I8,'.')
 9620 FORMAT (' D2ORDR: Final bit pointer is',I10,', expected =',I10,
     X        '.')
C
 9900 FORMAT (' D2ORDR: Function return code =',I6,', HOPER = ',A,
     X        ', KNSPT =',I10,'.')
C      
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C


      SUBROUTINE DELSP (HCHAR)
C
C---->
C**** DELSP - Delete spaces around valid MARS directive separators.
C
C     Purpose.
C     --------
C
C           Removes any spaces before and after any characters
C           encountered in input string, which are valid separators
C           in a MARS command line. These are / , = " .
C           Any spaces between minus sign and number are also removed.
C
C**   Interface.
C     ----------
C
C           CALL DELSP (HCHAR)
C
C           Integer    K.
C           Real       P.
C           Logical    O.
C           Character  H.
C
C               Input parameters.
C               -----------------
C
C               HCHAR      - Character string to be modified.
C
C               Output parameters.
C               ------------------
C
C               HCHAR      - Modified character string.
C
C     Method.
C     -------
C
C           Uses index function to locate any spaces to be
C           removed.
C
C     Externals.
C     ----------
C
C           RTB
C
C     Reference.
C     ----------
C
C           None.
C
C     Comments.
C     ---------
C
C           Program contains sections 0 to 2 and section 9.
C
C     Author.
C     -------
C
C           J. Hennessy      ECMWF      01.09:86.
C
C     Modifications
C     --------------
C
C           J. Hennessy      ECMWF      30.03.87
C           Prevent looping when string ends with a separator.
C
C           J. Hennessy      ECMWF      18.07.91
C           Other separators added.
C
C     ----------------------------------------------------------------
C----<
C
C
C
C
C
C
C
C
C
C
C*    Section 0 . Definition of variables.
C     ----------------------------------------------------------------
C
      IMPLICIT  NONE
C
      CHARACTER*(*)      HCHAR
C
      INTEGER            I
      INTEGER            IEND
      INTEGER            RTB
C
C     ----------------------------------------------------------------
C
C
C
C
C
C
C
C
C
C*    Section 1 . Remove any spaces before separators.
C     ----------------------------------------------------------------
C
c--      WRITE (*,9000)
c--      WRITE (*,9002) HCHAR
C
  100 CONTINUE
C
      I = INDEX (HCHAR(1:),' /')
C
      IF (I.NE.0)
     C   THEN
             HCHAR(I:) = HCHAR(I+1:)
             GO TO 100
         ENDIF
C
  110 CONTINUE
C
      I = INDEX (HCHAR(1:),' ,')
C
      IF (I.NE.0)
     C   THEN
             HCHAR(I:) = HCHAR(I+1:)
             GO TO 110
         ENDIF
C
  120 CONTINUE
C
      I = INDEX (HCHAR(1:),' =')
C
      IF (I.NE.0)
     C   THEN
             HCHAR(I:) = HCHAR(I+1:)
             GO TO 120
         ENDIF
C
  130 CONTINUE
C
      I = INDEX (HCHAR(1:),' "')
C
      IF (I.NE.0)
     C   THEN
             HCHAR(I:) = HCHAR(I+1:)
             GO TO 130
         ENDIF
C
  140 CONTINUE
C
      I = INDEX (HCHAR(1:),' .')
C
      IF (I.NE.0)
     C   THEN
             HCHAR(I:) = HCHAR(I+1:)
             GO TO 140
         ENDIF
C
C     ----------------------------------------------------------------
C
C
C
C
C
C
C
C
C
C*    Section 2 . Remove any spaces after separators.
C     ----------------------------------------------------------------
C
      iend = rtb (hchar)
  200 CONTINUE
C
      I = INDEX (HCHAR(1:),'/ ')
C
C*    Go to section 9 if string ends '/ '.
C
c++      IEND = RTB (HCHAR)
      IF (IEND.EQ.I) GO TO 210
C
      IF (I.NE.0)
     C   THEN
             HCHAR(I+1:) = HCHAR(I+2:)
             iend = iend - 1
             GO TO 200
         ENDIF
C
  210 CONTINUE
C
      I = INDEX (HCHAR(1:),', ')
C
C*    Go to section 9 if string ends ', '.
C
      IEND = RTB (HCHAR)
      IF (IEND.EQ.I) GO TO 220
C
      IF (I.NE.0)
     C   THEN
             HCHAR(I+1:) = HCHAR(I+2:)
             GO TO 210
         ENDIF
C
  220 CONTINUE
C
      I = INDEX (HCHAR(1:),'= ')
C
C*    Go to section 9 if string ends '= '.
C
      IEND = RTB (HCHAR)
      IF (IEND.EQ.I) GO TO 230
C
      IF (I.NE.0)
     C   THEN
             HCHAR(I+1:) = HCHAR(I+2:)
             GO TO 220
         ENDIF
C
  230 CONTINUE
C
      I = INDEX (HCHAR(1:),'" ')
C
C*    Go to section 9 if string ends '" '.
C
      IEND = RTB (HCHAR)
      IF (IEND.EQ.I) GO TO 240
C
      IF (I.NE.0)
     C   THEN
             HCHAR(I+1:) = HCHAR(I+2:)
             GO TO 230
         ENDIF
C
  240 CONTINUE
C
      I = INDEX (HCHAR(1:),'. ')
C
C*    Go to section 9 if string ends '. '.
C
      IEND = RTB (HCHAR)
      IF (IEND.EQ.I) GO TO 250
C
      IF (I.NE.0)
     C   THEN
             HCHAR(I+1:) = HCHAR(I+2:)
             GO TO 240
         ENDIF
C
  250 CONTINUE
C
      I = INDEX (HCHAR(1:),'- ')
C
C*    Go to section 9 if string ends '- '.
C
      IEND = RTB (HCHAR)
      IF (IEND.EQ.I) GO TO 260
C
      IF (I.NE.0)
     C   THEN
             HCHAR(I+1:) = HCHAR(I+2:)
             GO TO 250
         ENDIF
C
  260 CONTINUE
C
c--      WRITE (*,9001)
c--      WRITE (*,9002) HCHAR
C
C     ----------------------------------------------------------------
C
C
C
C
C
C
C
C
C
C
C
C
C
C*    Section 9 . Return to calling routine.
C     ------------------------------------------------------------------
C
  900 CONTINUE
C
      RETURN
C
 9000 FORMAT (1H ,'DELSP : Input string :-')
C
 9001 FORMAT (1H ,'DELSP : Output string :-')
C
 9002 FORMAT (1H ,A)
C
      END

C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C


      SUBROUTINE REPCHR (HCHAR,HOLD,HNEW)
C
C---->
C**** REPCHR - Replace one character by another.
C
C     Purpose.
C     --------
C
C           Replace all occurrences of a given character in a
C           character string by another.
C
C**   Interface.
C     ----------
C
C           CALL REPCHR (HCHAR,HOLD,HNEW)
C
C           Integer    K.
C           Real       P.
C           Logical    O.
C           Character  H.
C
C               Input parameters.
C               -----------------
C
C               HCHAR      - Character string to be modified.
C               HOLD       - Character to be replaced.
C               HNEW       - Replacement character.
C
C               Output parameters.
C               ------------------
C
C               HCHAR      - Modified character string.
C
C     Method.
C     -------
C
C           Characters examined in sequence and changed if necessary.
C           Only the first character of the strings HOLD and HNEW is
C           used, if these are longer than 1 character.
C
C     Externals.
C     ----------
C
C           None.
C
C     Reference.
C     ----------
C
C           None.
C
C     Comments.
C     ---------
C
C           Program contains sections 0 to 1 and section 9.
C
C     Author.
C     -------
C
C           J. Hennessy      ECMWF      16.01:92.
C
C     Modifications
C     --------------
C
C           None.
C
C     ----------------------------------------------------------------
C----<
C
C
C
C
C
C
C
C
C
C
C*    Section 0 . Definition of variables.
C     ----------------------------------------------------------------
C
      IMPLICIT NONE
C
C*    Prefix conventions for variable names.
C
C     Logical      L (but not LP), global or common.
C                  O, dummy arguments.
C                  G, local variable.
C                  LP, parameter.
C     Character    C, Global or common.
C                  H, dummy arguments.
C                  Y (but not YP), local variables.
C                  YP, parameter.
C     Integer      M and N, global or common.
C                  K, dummy arguments.
C                  I, local variables.
C                  J (but not JP), loop control.
C                  JP, parameter.
C     Real         A to F and Q to X, global or common.
C                  P (but not PP), dummy arguments.
C                  Z, local variables.
C                  PP, parameter.
C
      INTEGER      ILEN
C
      INTEGER      J150
C
      CHARACTER*(*) HCHAR
      CHARACTER*(*) HOLD
      CHARACTER*(*) HNEW
C
C     ----------------------------------------------------------------
C
C
C
C
C
C
C
C
C
C
C*    Section 1 . Replace required characters.
C     ----------------------------------------------------------------
C
  100 CONTINUE
C
      ILEN = LEN (HCHAR)
C
      DO 150 J150=1,ILEN
         IF (HCHAR(J150:J150).EQ.HOLD(1:1)) HCHAR(J150:J150) = HNEW(1:1)
  150 CONTINUE
C
C     ----------------------------------------------------------------
C
C
C
C
C
C
C
C
C
C
C*    Section 9 . Return to calling routine.
C     ------------------------------------------------------------------
C
  900 CONTINUE
C
      RETURN
C
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE ECDEF12( HFUNC, KSEC1, KGRIB, KLENG, KNSPT, KBITS,
     X                   KPR, KRET)
C
C---->
C**** ECDEF12
C
C     Purpose.
C     --------
C
C     GRIB coding/decoding of ECMWF local use definition 12.
C
C**   Interface.
C     ----------
C
C     CALL ECDEF12( HFUNC, KSEC1, KGRIB, KLENG, KNSPT, KBITS, KPR, KRET)
C
C
C     Input Parameters.
C     -----------------
C
C     HFUNC      - Requested function.
C                  'C' to code data.
C                  'D' to decode data.
C
C     KSEC1      - Array containing Grib Section 1 data.
C
C     KGRIB      - Array containing Grib coded data.
C
C     KLENG      - Length (words) of KGRIB.
C
C     KNSPT      - Bit number after which insertion/extraction starts.
C
C     KBITS      - Number of bits in computer word.
C
C     KPR        - Debug print switch.
C                  0  , No printout.
C                  >0 , Debug printout.
C
C     KRET       - Response to error indicator.
C                  0        , Abort if error encountered.
C                  Non-zero , Return to calling routine
C                             even if error encountered.
C
C     Output Parameters.
C     ------------------
C
C     KSEC1      - Array containing Grib Section 1 data.(Updated)
C
C     KGRIB      - Array containing Grib coded data.(Updated)
C
C     KNSPT      - Number of bit after last one inserted/extracted.
C                  (Updated)
C
C     KRET       - Return code.
C                  0   , No error encountered.
C                  2   , Error reported by routine INXBIT.
C
C
C     Method.
C     -------
C
C     Input data packed/unpacked in accordance with ECMWF usage of
C     local part of section 1 of Grib code, definition 10.
C
C
C     Externals.
C     ----------
C
C     INXBIT  - insert/extract bits
C     ABORTX  - abort the program
C     CSGNBT  - code a signed value
C     DSGNBT  - decode a signed value
C
C
C     Reference.
C     ----------
C
C     WMO Manual On Codes for Grib Code.
C
C
C     Comments.
C     ---------
C
#include "ecdef12.h"
C
C
C     Author.
C     -------
C
C     J.D.Chambers     ECMWF      November 1998
C
C
C     Modifications.
C     --------------
C
C     None
C
C
C----<
C     ------------------------------------------------------------------
C*    Section 0 . Definition of variables. Data statements.
C     ------------------------------------------------------------------
C
      IMPLICIT NONE
C
#include "common/grprs.h"
C
C     Parameters
C
      CHARACTER*1   HFUNC
      INTEGER KSEC1, KGRIB, KLENG, KNSPT, KBITS, KPR, KRET
      DIMENSION KGRIB(*)
      DIMENSION KSEC1(*)
C
C     Local variables
C
      INTEGER IRET, LOOP
C
      LOGICAL LENCODE, LDECODE
C
C     ------------------------------------------------------------------
C*    Section 1 . Set initial values.
C     ------------------------------------------------------------------
C
  100 CONTINUE
C
      IRET = KRET
      LENCODE = ( HFUNC.EQ.'C' )
      LDECODE = .NOT.LENCODE
C
C     ------------------------------------------------------------------
C*    Section 2 . Handle data for analysis which used the SST
C     ------------------------------------------------------------------
C
  200 CONTINUE
C
C     Octet 50-53: Start date of the period (YYYYMMDD)
C     One 32-bit field.
C
      CALL INXBIT(KGRIB,KLENG,KNSPT,KSEC1(42),1,KBITS,32,HFUNC,KRET)
      IF( KRET.NE.0 ) THEN
        KRET = 2
        WRITE(GRPRSM,*) 'ECDEF12: Error reported by routine INXBIT:'
        IF( LENCODE ) THEN
          WRITE(GRPRSM,*) '      encoding section 1, element 42.'
        ELSE
          WRITE(GRPRSM,*) '      decoding section 1, octets 50 - 53.'
        ENDIF
      ENDIF
C
C     Octets 54-55: Start time of the period (HHMM)
C     One 16-bit field.
C
      CALL INXBIT(KGRIB,KLENG,KNSPT,KSEC1(43),1,KBITS,16,HFUNC,KRET)
      IF( KRET.NE.0 ) THEN
        KRET = 2
        WRITE(GRPRSM,*) 'ECDEF12: Error reported by routine INXBIT:'
        IF( LENCODE ) THEN
          WRITE(GRPRSM,*) '      encoding section 1, element 43.'
        ELSE
          WRITE(GRPRSM,*) '      decoding section 1, octets 54 - 55.'
        ENDIF
      ENDIF
C
C     Octet 56-59: Finish date of the period (YYYYMMDD)
C     One 32-bit field.
C
      CALL INXBIT(KGRIB,KLENG,KNSPT,KSEC1(44),1,KBITS,32,HFUNC,KRET)
      IF( KRET.NE.0 ) THEN
        KRET = 2
        WRITE(GRPRSM,*) 'ECDEF12: Error reported by routine INXBIT:'
        IF( LENCODE ) THEN
          WRITE(GRPRSM,*) '      encoding section 1, element 44.'
        ELSE
          WRITE(GRPRSM,*) '      decoding section 1, octets 56 - 59.'
        ENDIF
      ENDIF
C
C     Octets 60-61: Finish time of the period (HHMM)
C     One 16-bit field.
C
      CALL INXBIT(KGRIB,KLENG,KNSPT,KSEC1(45),1,KBITS,16,HFUNC,KRET)
      IF( KRET.NE.0 ) THEN
        KRET = 2
        WRITE(GRPRSM,*) 'ECDEF12: Error reported by routine INXBIT:'
        IF( LENCODE ) THEN
          WRITE(GRPRSM,*) '      encoding section 1, element 45.'
        ELSE
          WRITE(GRPRSM,*) '      decoding section 1, octets 60 - 61.'
        ENDIF
      ENDIF
C
C     Octet 62-65: Verifying date of the period (YYYYMMDD)
C     One 32-bit field.
C
      CALL INXBIT(KGRIB,KLENG,KNSPT,KSEC1(46),1,KBITS,32,HFUNC,KRET)
      IF( KRET.NE.0 ) THEN
        KRET = 2
        WRITE(GRPRSM,*) 'ECDEF12: Error reported by routine INXBIT:'
        IF( LENCODE ) THEN
          WRITE(GRPRSM,*) '      encoding section 1, element 46.'
        ELSE
          WRITE(GRPRSM,*) '      decoding section 1, octets 62 - 65.'
        ENDIF
      ENDIF
C
C     Octets 66-67: Verifying time of the period (HHMM)
C     One 16-bit field.
C
      CALL INXBIT(KGRIB,KLENG,KNSPT,KSEC1(47),1,KBITS,16,HFUNC,KRET)
      IF( KRET.NE.0 ) THEN
        KRET = 2
        WRITE(GRPRSM,*) 'ECDEF12: Error reported by routine INXBIT:'
        IF( LENCODE ) THEN
          WRITE(GRPRSM,*) '      encoding section 1, element 47.'
        ELSE
          WRITE(GRPRSM,*) '      decoding section 1, octets 66 - 67.'
        ENDIF
      ENDIF
C
C     Octet 68: Code showing method of meaning, averaging, etc
C     One 8-bit field.
C
      CALL INXBIT(KGRIB,KLENG,KNSPT,KSEC1(48),1,KBITS,8,HFUNC,KRET)
      IF( KRET.NE.0 ) THEN
        KRET = 2
        WRITE(GRPRSM,*) 'ECDEF12: Error reported by routine INXBIT:'
        IF( LENCODE ) THEN
          WRITE(GRPRSM,*) '      encoding section 1, element 48.'
        ELSE
          WRITE(GRPRSM,*) '      decoding section 1, octet 68.'
        ENDIF
      ENDIF
C
C     Octet 69-70: No (N) of different time intervals used to build data
C     One 16-bit field.
C
      CALL INXBIT(KGRIB,KLENG,KNSPT,KSEC1(49),1,KBITS,16,HFUNC,KRET)
      IF( KRET.NE.0 ) THEN
        KRET = 2
        WRITE(GRPRSM,*) 'ECDEF12: Error reported by routine INXBIT:'
        IF( LENCODE ) THEN
          WRITE(GRPRSM,*) '      encoding section 1, element 49.'
        ELSE
          WRITE(GRPRSM,*) '      decoding section 1, octets 69 - 70.'
        ENDIF
      ENDIF
C
C     Octets 71-70+(N*4): List of time intervals used
C     N 32-bit fields.
C
      DO LOOP = 1, KSEC1(49)
        CALL INXBIT(KGRIB,KLENG,KNSPT,KSEC1(49+LOOP),1,KBITS,32,
     X              HFUNC,KRET)
        IF( KRET.NE.0 ) THEN
          KRET = 2
          WRITE(GRPRSM,*) 'ECDEF12: Error reported by routine INXBIT:'
          IF( LENCODE ) THEN
            WRITE(GRPRSM,*)
     X   '      encoding section 1, elements 50 onwards.'
          ELSE
            WRITE(GRPRSM,*)
     X   '      decoding section 1, octets 71 onwards.'
          ENDIF
        ENDIF
      ENDDO
C
C     ------------------------------------------------------------------
C*    Section 9 . Abort/return to calling routine.
C     ------------------------------------------------------------------
C
  900 CONTINUE
C
      IF( KPR.GE.1 ) THEN
        WRITE(GRPRSM,*) 'ECDEF12: Section 9.'
        WRITE(GRPRSM,*) '        Output values set, KNSPT = ', KNSPT
      ENDIF
C
C     Abort if requested to do so when an error has been encountered.
C
      IF( (IRET.EQ.0).AND.(KRET.NE.0) ) THEN
        CALL ABORTX('ECDEF12')
      ELSE
        RETURN
      ENDIF
C
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities
C granted to it by virtue of its status as an intergovernmental organisation
C nor does it submit to any jurisdiction.
C

        SUBROUTINE PBBUFR(KUNIT,KARRAY,KINLEN,KOUTLEN,KRET)
C
C---->
C**** PBBUFR
C
C     PURPOSE
C     _______
C
C     Reads next BUFR product from a file.
C
C     INTERFACE
C     _________
C
C     CALL PBBUFR(KUNIT,KARRAY,KINLEN,KOUTLEN,KRET)
C
C
C     Input parameters
C     ________________
C
C     KUNIT  - Unit number for the file returned from PBOPEN.
C     KARRAY - FORTRAN array big enough to hold the BUFR product.
C     KINLEN - Size in BYTES of the FORTRAN array.
C
C
C     Output parameters
C     ________________
C
C     KOUTLEN - size in BYTES of the BUFR product read
C     KRET    -  0  if a BUFR product has been successfully read
C
C               -1  if end-of-file is hit before a BUFR product is read
C
C               -3  if the size of KARRAY is not sufficient for the
C                   BUFR product
C
C
C     Common block usage
C     __________________
C
C     None.
C
C
C     Method
C     ______
C
C     Calls BUFRREAD.
C
C
C     Externals
C     _________
C
C     BUFRREAD - Read next BUFR product.
C
C
C     AUTHOR
C     ______
C
C     J.D.Chambers       ECMWF
C
C
C     MODIFICATIONS
C     _____________
C
C     None.
C
C******************************************************************************
C----<
C
C     Subroutine arguments
C
      INTEGER KARRAY(1)
      INTEGER KUNIT,KINLEN,KOUTLEN,KRET
C
C     Local argument(s)
C
      INTEGER NREAD, IRET
C
C     Get the BUFR product
C
      CALL BUFRREAD( KARRAY, KINLEN, NREAD, IRET, KUNIT )
C
C     Escape if the user buffer is too small to hold even the early sections of
C     the product or EOF encountered
C
      IF( IRET.EQ.-4 ) THEN
        KOUTLEN = NREAD
        KRET = -1
        RETURN
      ENDIF
C
C     Escape if no BUFR product is found in the file
C
      IF( IRET.EQ.-1 ) THEN
        KOUTLEN = 0
        KRET = -1
        RETURN
      ENDIF
C
C     Check if the array is big enough for the BUFR product
C
      IF( IRET.EQ.-3 ) THEN
        KOUTLEN = NREAD
        KRET = -3
        RETURN
      ENDIF
C
C     Set success code if product retrieved
C
      IF( NREAD.GE.0 )  THEN
        KOUTLEN = NREAD
        KRET = 0
      ENDIF
C
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE BUENS0( KSEC0,KBUFL,KBUFF,KERR)
C
C**** *BUENS0*
C
C
C     PURPOSE.
C     --------
C          PACK SECTION 0 OF BUFR MESSAGE.
C     PACKING BUFR EDITION 2.
C
C**   INTERFACE.
C     ----------
C
C          *CALL* *BUENS0( KSEC0,KBUFL,KBUFF,KERR)*
C
C
C        INPUT:
C               *KSEC0*   -  ARRAY CONTAINING SECTION 0 INFORMATION
C                            KSEC0( 1)-- LENGTH OF SECTION 0 (BYTES)
C                            KSEC0( 2)-- TOTAL LENGTH OF BUFR MESSAGE (BYTES)
C                            KSEC0( 3)-- BUFR EDITION NUMBER
C        OUTPUT:
C               *KBUFL*   -  LENGTH OF BUFR MESSAGE (WORDS)
C               *KBUFF*   -  ARRAY CONTAINING BUFR MESSAGE
C               *KERR*    -  RETURNED ERROR CODE
C
C     METHOD.
C     --------
C
C          NONE.
C
C     EXTERNALS.
C     ----------
C
C          BUPKS         - PACK BIT PATHERN IN REPEATED WAY
C          BUPCK         - PACK BIT PATHERN
C          BUOCTN        - SET LENGTH OF SECTION
C
C     REFERENCE.
C     ----------
C
C          NONE.
C
C     AUTHOR.
C     -------
C
C          M. DRAGOSAVAC    *ECMWF*       15/09/91.
C
C
C     MODIFICATIONS.
C     --------------
C
C          NONE.
C
C
      IMPLICIT LOGICAL(L,O,G), CHARACTER*8(C,H,Y)
C
C
C
#     include "parameter.F"
#     include "bcomunit.F"
#     include "bcmwork.F"
C
      DIMENSION KBUFF(KBUFL)
      DIMENSION KSEC0(JSEC0)
      DIMENSION IBUFR(4)
#ifndef R_4
      REAL*8 RVIND
      REAL*8 EPS
#else
      REAL   RVIND
      REAL   EPS
#endif
C
      DATA IBUFR/66,85,70,82/
C
C     B IS CCITT.5 DECIMAL 66
C     U IS CCITT.5 DECIMAL 85
C     F IS CCITT.5 DECIMAL 70
C     R IS CCITT.5 DECIMAL 82
C
C
C     ------------------------------------------------------------------
C*          1. PACK SECTION 0.
C              ---------------
 100  CONTINUE
C
      IF( KERR.NE.0 ) RETURN
C
C
C*          1.1  INITIALIZE WORKING POINTERS NWPT AND NBPT.
C                ------------------------------------------
      NWPT = 1
      NBPT = 0
C
C*          1.2  PACK FIRST FOUR OCTETS CONTAINING *BUFR*.
C                -------------------------------------------
C
      CALL BUPKS(NBPW,KBUFF(NWPT),IBUFR,NWPT,NBPT,8,0,4,KERR)
      IF(KERR.GT.0) THEN
         WRITE(KNTN,*)'ERROR PACKING FIRST FOUR OCTETS',
     1' OF BUFR MESSAGE.'
         RETURN
      END IF
C
      IF(KSEC0(3).LE.1) GO TO 200
C
C*          1.2 PACK TOTAL LENGTH OF BUFR MESSAGE.
C               ------------------------------------
 120  CONTINUE
C
      CALL BUPCK(NBPW,KBUFF(NWPT),0,NWPT,NBPT,24,KERR)
      IF(KERR.GT.0) THEN
         WRITE(KNTN,*) 'ERROR PACKING TOTAL LENGTH OF BUFR MESSAGE'
         WRITE(KNTN,*) 'IN SECTION 0.'
         RETURN
      END IF
C
C*          1.3 PACK BUFR EDITION NUMBER (IT IS 8TH BYTE ).
C               ---------------------------------------------
 130  CONTINUE
C
      CALL BUPCK(NBPW,KBUFF(NWPT),KSEC0(3),NWPT,NBPT,8,KERR)
      IF(KERR.GT.0) THEN
         WRITE(KNTN,*) 'ERROR PACKING BUFR EDITION NUMBER IN SECTION 0.'
         RETURN
      END IF
C
C     ------------------------------------------------------------------
C
 200  CONTINUE
C
      RETURN
      END

C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      INTEGER FUNCTION HSP2GG3(KTRUNC,KGAUSS,KPTS,PLATS,KSIZE)
C
C---->
C**** HSP2GG3
C
C     Purpose
C     -------
C
C     This routine finds a suitable gaussian grid for a given
C     spectral truncation.
C
C
C     Interface
C     ---------
C
C     IRET = HSP2GG3(KTRUNC,KGAUSS,KPTS,KSIZE)
C
C
C     Input parameters
C     ----------------
C
C     KTRUNC - The spectral truncation
C
C
C     Output parameters
C     -----------------
C
C     KGAUSS - The gaussian number
C     KPTS   - Array giving number of points along each line of latitude
C              in the reduced gaussian grid (both hemispheres)
C     PLATS  - Array giving gaussian latitudes (both hemispheres)
C     KSIZE  - The number of points in the reduced gaussian grid
C
C     Returns 0 if all OK, otherwise there is an error.
C
C
C     Common block usage
C     ------------------
C
C     None
C
C
C     Method
C     ------
C
C     None
C
C
C     Externals
C     ---------
C
C     JGETGG - Reads the definition of a gaussian grid
C
C
C     Reference
C     ---------
C
C     None.
C
C
C     Comments
C     --------
C
C     None.
C
C
C     Author
C     ------
C
C     J.D.Chambers      ECMWF      February 2001
C
C
C     Modifications
C     -------------
C
C     S.Curic     ECMWF      March 2005
C     Added checking for a automatic trancation T255, T399, T799, T2047 
C     and corresponding gaussian grid.
C
C     S.Curic     ECMWF      April 2008
C     Added checking for a automatic trancation T1279
C     and corresponding gaussian grid.
C
C
C     S.Curic     ECMWF      Semptember 2009
C     Match T255 and T213 against N128 instead of N160
C     upon Alan Geer request
C
C----<
C     -----------------------------------------------------------------|
C*    Section 0. Definition of variables.
C     -----------------------------------------------------------------|
C
      IMPLICIT NONE
C
#include "parim.h"
C
C     Function arguments
C
      INTEGER KTRUNC, KGAUSS, KPTS(*), KSIZE
      REAL PLATS(*)
#include "jparams.h"
C
C     Local variables
C
      INTEGER LOOP, IRET
      LOGICAL LDEBUG
C
C
C     -----------------------------------------------------------------|
C     Section 1.  Initialise.
C     -----------------------------------------------------------------|
C
  100 CONTINUE
C
      HSP2GG3 = 0

      CALL JDEBUG()
      LDEBUG = ( NDBG.NE.0 )
C
      IF(KGAUSS.EQ.1024) THEN      ! Mariano
        KTRUNC = 2047
      ELSEIF(KTRUNC.EQ.640) THEN ! Jan Haseler
        KTRUNC = 1279
      ELSEIF(KGAUSS.EQ.400) THEN   ! Oper 2005
        KTRUNC = 799
      ELSEIF(KGAUSS.EQ.320) THEN
        KTRUNC = 639
      ELSEIF(KGAUSS.EQ.256) THEN   ! Oper 2004
        KTRUNC = 511
      ELSEIF(KGAUSS.EQ.200) THEN   ! Enfo 2005
        KTRUNC = 399
      ELSEIF(KGAUSS.EQ.160) THEN
        KTRUNC = 319
      ELSEIF(KGAUSS.EQ.128) THEN   ! Enfo 2004
        KTRUNC = 255
      ELSEIF(KGAUSS.EQ.128) THEN
        KTRUNC = 213
      ELSEIF(KGAUSS.EQ.96) THEN   ! Elias 2014
        KTRUNC = 191
      ELSEIF(KGAUSS.EQ.80) THEN
        KTRUNC = 159
      ELSEIF(KGAUSS.EQ.48) THEN
        KTRUNC = 95
      ELSEIF(KGAUSS.EQ.48) THEN
        KTRUNC = 63
      ELSE
        CALL INTLOG(JP_ERROR,'HSP2GG3: Unmatched truncation',KTRUNC)
        HSP2GG3 = 1
        GOTO 900
      ENDIF
C
C     Get the reduced gaussian grid information and count the
C     number of points.
C
      CALL JGETGG(KGAUSS,'R',PLATS,KPTS,IRET)
      IF( IRET.NE.0 ) THEN
        CALL INTLOG(JP_ERROR,
     X    'HSP2GG3: JGETGG failed to get gaussian data',JPQUIET)
        HSP2GG3 = 2
        GOTO 900
      ENDIF
C
      KSIZE = 0
      DO LOOP = 1, KGAUSS*2
        KSIZE = KSIZE + KPTS(LOOP)
      ENDDO

      IF( LDEBUG ) THEN
          CALL INTLOG(JP_DEBUG,
     X    'HSP2GG3: Output Gaussian number :',KGAUSS)
          CALL INTLOG(JP_DEBUG,
     X    'HSP2GG3: Corresponding Spectral Truncation:',KTRUNC)
      ENDIF
C
C     -----------------------------------------------------------------|
C     Section 9.  Return.
C     -----------------------------------------------------------------|
C
  900 CONTINUE
C
      RETURN
      END

C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE EXTMAP (KGRIB,KLENG,KMAP1,KMAP2,KVALS,PSEC4,KSIZE,
     X                   KBITS,KSBMAP,PMISS,KNUM,KPR,KRET,KNOMIS)
C
C---->
C**** EXTMAP - Extraction of bit maps for routine GRIBEX.
C
C     Purpose.
C     --------
C
C     Extracts bit-maps (primary and secondary,if present)
C     from an array of GRIB coded data and inserts the
C     missing data value indicator in appropriate places in
C     the array of already unpacked data values.
C
C**   Interface.
C     ----------
C
C     CALL EXTMAP (KGRIB,KLENG,KMAP1,KMAP2,KVALS,PSEC4,KSIZE,KBITS,
C    X             KSBMAP,PMISS,KNUM,KPR,KRET,KNOMIS)
C
C
C     Input Parameters.
C     -----------------
C
C     KGRIB      - Array from which data is being unpacked
C                  from GRIB code.
C
C     KLENG      - Length of this array.
C
C     KMAP1      - Bit-pointer to start of primary bit-map
C                  (Section 3 bitmap) in array KGRIB.
C
C     KMAP2      - Bit-pointer to start of secondary bitmap
C                  (Section 4 bitmap) in array KGRIB.
C                  Negative value if no secondary bit maps.
C
C     KVALS      - Number of unpacked values in PSEC4 on entry
C
C     PSEC4      - Array of data values unpacked from GRIB code.
C
C     KSIZE      - Number of bits in the primary bit map.
C
C     KBITS      - Number of bits in computer word.
C
C     PMISS      - Value to be used to indicate missing data
C                  in array PSEC4.
C
C     KNUM       - Number of values at each grid point. This
C                  is normally 1 except when a matrix of value
C                  is represented.
C
C     KPR        - Debug print switch.
C                  0  , No printout.
C                  >0 , Debug printout.
C
C     Output Parameters.
C     ------------------
C
C     KSBMAP     - Bit-map flag.
C                  -2 , All bits in the bit-map set to 1.
C                       There is no missing data.
C                  -4 , Some points have no data. User
C                       supplied value for missing data
C                       indicator in appropriate places in
C                       the array PSEC4.
C
C     KRET       - Return code.
C                  0 , No error encountered.
C                  1 , Error in routine INXBIT.
C                  4 , Number of values at each grid point (KNUM)
C                      is greater than allowed (JPWORK).
C
C     KNOMIS     - Number of non-missing values in PSEC4 entry.
C
C
C     Method.
C     -------
C
C     The bit-map contains 1 where valid data exists and 0
C     where data is missing. The corresponding data array
C     contains valid data and the missing data indicator value.
C
C     Externals.
C     ----------
C
C     INXBIT   - Extract values from bit-stream
C
C     Reference.
C     ----------
C
C     See routine GRIBEX.
C
C     Comments.
C     ---------
C
C     Routine contains Sections 0 to 3 and Section 9.
C
C     Author.
C     -------
C
C     J. Hennessy      ECMWF      10:07:92
C
C     Modifications.
C     --------------
C
C     J. Hennessy      ECMWF      29:10:92
C     Maximum sizes increased to allow for packing of
C     2D spectra.
C     Number of data values 120*61*12*25
C
C     J.D.Chambers     ECMWF      09:03:94
C     Maximum size for bitmap array increased to 132000
C     to allow for products 0.5 * 0.5 degrees, whole
C     hemisphere (N or S).
C
C     J.D.Chambers     ECMWF      18:04:94
C     Fix setting of missing values according to bitmap 
C
C     J.D.Chambers     ECMWF      19:07:94
C     Maximum size for bitmap array increased to 140000
C     for reduced gaussian n160.
C
C     J.D.Chambers     ECMWF      23.05.95
C     Use dynamic allocation for secondary bitmap
C     Process primary bitmap in small pieces.  Use PSEC4
C     for expanding data using bitmaps.
C
C     J.D.Chambers     ECMWF      24.10.96
C     Use fixed allocation for secondary bitmap
C     Process primary bitmap in small pieces.  Use PSEC4
C
C     J. Clochard, METEO FRANCE, for ECMWF - January 1998.
C     Dummy-argument KNOMIS added.
C     Strips size (JPWORK) enlarged to 10000.
C
C----<
C     ------------------------------------------------------------------
C*    Section 0 . Definition of variables. Data statements.
C     ------------------------------------------------------------------
C
      IMPLICIT NONE
C
#include "grprs.h"
C
C     Parameters
C
      INTEGER JPWORK
      PARAMETER (JPWORK=10000)
C
C     Subroutine arguments
C
      INTEGER KBITS, KGRIB, KLENG, KMAP1, KMAP2, KNUM, KVALS, KNOMIS
      DIMENSION KGRIB(*)
      INTEGER KPR, KRET, KSBMAP, KSIZE
      REAL PMISS, PSEC4
      DIMENSION PSEC4(*)
C
C     Local variables
C
      INTEGER ICURR, IPT, LENGTH
      INTEGER JLOOP, JLOOPI, NEXT, IMANY, NABITS, NBITS, NVALS, MYMAP1
      LOGICAL LMOPT
C
      INTEGER IMAP1
      DIMENSION IMAP1(JPWORK)
C
C     Work array.
C
      INTEGER IMAP2
      DIMENSION IMAP2(JPWORK)
C
C
C     ------------------------------------------------------------------
C*    Section 1 . Set initial values.
C     ------------------------------------------------------------------
C
  100 CONTINUE
C
      IF( KPR.GE.1 ) THEN
        WRITE(GRPRSM,*) 'EXTMAP: Section 1.'
        WRITE(GRPRSM,*) 'EXTMAP:   Input values used -'
        WRITE(GRPRSM,*) 'EXTMAP: KSIZE,KNUM = ', KSIZE,KNUM
        WRITE(GRPRSM,*) 'EXTMAP: KLENG,KMAP1,KMAP2,KBITS, PMISS = '
        WRITE(GRPRSM,*) KLENG,KMAP1,KMAP2,KBITS, PMISS
        WRITE(GRPRSM,*) 'EXTMAP: KVALS = ', KVALS
      ENDIF
C
C     Reset return code to 0.
C
      KRET  = 0
      KNOMIS = 0
      NBITS = 0
      NABITS = 0
      LENGTH = KNUM
C
C     Check there is enough space for unpacking secondary bitmap
C
      IF( LENGTH.GT.JPWORK ) THEN
        WRITE(GRPRSM,*) 'EXTMAP: Number of values at each grid point'
        WRITE(GRPRSM,*)
     X    'EXTMAP: (KNUM) is greater than allowed (JPWORK).'
        KRET = 4
        GOTO 900
      ENDIF
C
C     ------------------------------------------------------------------
C*    Section 2 .  Handle 'M' option case
C     ------------------------------------------------------------------
C
  200 CONTINUE
C
C     If the original field has been packed with the 'M' option,
C     have to find out how many true values there are in the field.
C
      LENGTH = KSIZE * KNUM
      LMOPT = (KVALS.EQ.LENGTH)
C
      IF( LMOPT ) THEN
C
C       Count the number of bits in the primary bitmap
C
        NEXT = 0
        NVALS = 0
        MYMAP1 = KMAP1
C
  210   CONTINUE
C
C       Unpack the primary bitmap in strips of JPWORK values
C
        NEXT = NEXT + JPWORK
        IMANY = JPWORK
C
C       Check whether end of primary bitmap reached.
C       Adjust if less than JPWORK values left to process
C
        IF( NEXT.GT.KSIZE ) IMANY = KSIZE + JPWORK - NEXT
C
C       Unpack next strip of primary bitmap values.
C
        CALL INXBIT(KGRIB,KLENG,MYMAP1,IMAP1,IMANY,KBITS,1,'D',KRET)
        IF( KRET.NE.0 ) THEN
          WRITE(GRPRSM,*) 'EXTMAP: Error reported by routine INXBIT.'
          KRET = 1
          GO TO 900
        ENDIF
C
C       Work through the strip of primary bitmap values counting points
C       which are not missing.
C
        DO 220 JLOOP = 1,IMANY
          IF( IMAP1(JLOOP).EQ.1 ) NVALS = NVALS + 1
  220   CONTINUE
C
C       Loop back if more strips of primary bitmap to process
C
        IF( NEXT.LT.KSIZE ) GOTO 210
C
      ELSE
C
        NVALS = KVALS
C
      ENDIF
C
      IF( KPR.GE.1 ) THEN
        WRITE(GRPRSM,*) 'EXTMAP: NVALS = ', NVALS
        WRITE(GRPRSM,*) 'EXTMAP: KVALS = ', KVALS
        WRITE(GRPRSM,*) 'EXTMAP: LENGTH = ', LENGTH
      ENDIF
C
C     Move input field to far end of input array
C
      IF( NVALS.LT.LENGTH ) THEN
        ICURR = NVALS+1
!OCL NOVREC
        DO 230 JLOOP = LENGTH, LENGTH - NVALS + 1, -1
          ICURR = ICURR - 1
          PSEC4(JLOOP) = PSEC4(ICURR)
  230   CONTINUE
      ENDIF
C
C     ------------------------------------------------------------------
C*    Section 3 . Decoding of bit-map and data.
C     ------------------------------------------------------------------
C
  300 CONTINUE
C
      IF( KPR.GE.1 ) WRITE(GRPRSM,*) 'EXTMAP: Section 3.'
C
C*    Set unoccupied values in array to missing data indicator.
C
      ICURR = LENGTH - NVALS
      DO 310 JLOOP = 1, ICURR
        PSEC4(JLOOP) = PMISS
  310 CONTINUE
C
C*    Copy data to output array or insert missing data value
C     in accordance with the bit map values.
C
      ICURR = LENGTH - NVALS
      IPT = 1
      NEXT = 0
C
  320 CONTINUE
C
C     The primary bitmap is unpacked and used in strips of JPWORK values
C
      NEXT = NEXT + JPWORK
      IMANY = JPWORK
C
C     Check whether end of primary bitmap reached.
C     Adjust if less than JPWORK values left to process
C
      IF( NEXT.GT.KSIZE ) IMANY = KSIZE + JPWORK - NEXT
C
C     Unpack next strip of primary bitmap values.
C
      CALL INXBIT(KGRIB,KLENG,KMAP1,IMAP1,IMANY,KBITS,1,'D',KRET)
      IF( KRET.NE.0 ) THEN
        WRITE(GRPRSM,*) 'EXTMAP: Error reported by routine INXBIT.'
        KRET = 1
        GO TO 900
      ENDIF
C
C     Work through the strip of primary bitmap values.
C
      IF(KMAP2.LE.0.AND.KNUM.EQ.1) THEN
        IMAP2(1) = 1
!OCL NOVREC
        DO 325 JLOOP = 1,IMANY
          IF( IMAP1(JLOOP).EQ.1 ) THEN
            ICURR      = ICURR + 1
            PSEC4(IPT) = PSEC4(ICURR)
            NABITS     = NABITS + 1
          ELSE
            PSEC4(IPT) = PMISS
            NBITS      = NBITS + 1
          ENDIF
          IPT = IPT + 1
 325    CONTINUE
C
      ELSE
C
        DO 380 JLOOP = 1,IMANY
C
C         If primary bitmap indicates there are values at the point ..
C
          IF( IMAP1(JLOOP).EQ.1 ) THEN
C
C           .. read secondary bitmap, if any.
C
            IF( KMAP2.GT.0 ) THEN
              CALL INXBIT(KGRIB,KLENG,KMAP2,IMAP2,KNUM,KBITS,1,'D',KRET)
              IF( KRET.NE.0 ) THEN
                WRITE(GRPRSM,*)
     X            'EXTMAP: Error reported by routine INXBIT.'
                KRET = 1
                GO TO 900
              ENDIF
C
            ELSE
C
C*            If no secondary bitmaps present, set up dummy secondary
C             bitmap to indicate no missing data values.
C
              IF( KNUM.EQ.1 ) THEN
                IMAP2(1)   = 1
                ICURR      = ICURR + 1
                PSEC4(IPT) = PSEC4(ICURR)
                IPT        = IPT + 1
                NABITS     = NABITS + 1
              ELSE
                DO 330 JLOOPI = 1,KNUM
                  IMAP2(JLOOPI) = 1
  330           CONTINUE
              ENDIF
C
            ENDIF
C
C           Use the bitmap to put in data value or missing data indicator.
C
            IF( KNUM.GT.1 ) THEN
              DO 340 JLOOPI = 1,KNUM
                IF( IMAP2(JLOOPI).EQ.1 ) NABITS = NABITS + 1
  340         CONTINUE
C
              DO 350 JLOOPI = 1,KNUM
                IF( IMAP2(JLOOPI).NE.1 ) NBITS = NBITS + 1
  350         CONTINUE
C
              DO 360 JLOOPI = 1,KNUM
                IF( IMAP2(JLOOPI).EQ.1 ) THEN
                  ICURR              = ICURR + 1
                  PSEC4(IPT+JLOOPI-1) = PSEC4(ICURR)
                ELSE
                  PSEC4(IPT+JLOOPI-1) = PMISS
                ENDIF
  360         CONTINUE
              IPT = IPT + KNUM
C
            ENDIF
C
C         If primary bitmap indicates there are no values at the point ..
C
          ELSE
            IF( KNUM.EQ.1 ) THEN
              PSEC4(IPT) = PMISS
            ELSE
              DO 370 JLOOPI = 1,KNUM
                PSEC4(IPT+JLOOPI-1) = PMISS
  370         CONTINUE
            ENDIF
            IPT   = IPT + KNUM
            NBITS = NBITS + KNUM
          ENDIF
C
  380   CONTINUE
C
      ENDIF
C
C     Loop back if more strips of primary bitmap to process
C
      IF( NEXT.LT.KSIZE ) GOTO 320
C
C*    Set bit-map flag.
C
      IF( NBITS.GT.0 ) THEN
        KSBMAP = -4
      ELSE
        KSBMAP = -2
      ENDIF
C
C*    Return effective number of non-missing values.
C
      KNOMIS=NVALS
C
C     ------------------------------------------------------------------
C*    Section 9 . Return to calling routine. Format statements.
C     ------------------------------------------------------------------
C
  900 CONTINUE
C
      IF( KPR.GE.1 ) THEN
        WRITE(GRPRSM,*) 'EXTMAP: Section 9.'
        WRITE(GRPRSM,*) 'EXTMAP: NBITS = ', NBITS
        WRITE(GRPRSM,*) 'EXTMAP: NABITS = ', NABITS
        WRITE(GRPRSM,*) 'EXTMAP: NVALS = ', NVALS
        WRITE(GRPRSM,*) 'EXTMAP: Output values set -'
        WRITE(GRPRSM,*) 'EXTMAP: KNOMIS = ', KNOMIS
        WRITE(GRPRSM,*) 'EXTMAP: KSIZE = ', KSIZE
        WRITE(GRPRSM,*) 'EXTMAP: KSBMAP = ', KSBMAP
      ENDIF
C
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE BURQUC(KBUFL,KBUFF,KELEM,CNAMES,CUNITS,KSUP,KSEC3,KERR)
C
C**** *BURQUC*
C
C
C     PURPOSE.
C     --------
C
C          CREATE PARAMETERS NEEDED FOR PARTIAL EXPANSION OF
C     BUFR MESSAGE ACCORDING TO REQUESTED INPUT LISTS.
C
C
C**   INTERFACE.
C     ----------
C
C          *CALL* *BURQUC(KBUFL,KBUFF,KELEM,CNAMES,CUNITS,KSUP,KSEC3,KERR)*
C
C        INPUT :
C               *KBUFL*   -  LENGTH OF BUFR MESSAGE (WORDS)
C               *KBUFF*   -  ARRAY CONTAINING BUFR MESSAGE
C               *KELEM*   -  DIMENSION OF CNAMES, CUNITS ARRAY
C               *CNAMES*  -  CHARACTER ARRAY CONTAINING ELEMENT NAMES
C               *CUNITS*  -  CHARACTER ARRAY CONTAINIG UNITS
C               *KSUP*    -  ARRAY CONTAINING SUPLEMENTARY INFORMATION
C                         -  KSUP( 1) -- IDIM1, DIMENSION OF KSEC1
C                         -  KSUP( 2) -- IDIM2, DIMENSION OF KSEC2
C                         -  KSUP( 3) -- IDIM3, DIMENSION OF KSEC3
C                         -  KSUP( 4) -- IDIM4, DIMENSION OF KSEC4
C                         -  KSUP( 5) -- M (NUMBER OF ELEMENTS IN VALUES ARRAY,
C                                           FIRST INDEX)
C                         -  KSUP( 6) -- N (NUMBER OF SUBSETS,SECOND INDEX OF
C                                           VALUES ARRAY)
C                         -  KSUP( 7) -- JVC (NUMBER OF ELEMENTS IN CVAL ARRAY)
C                         -  KSUP( 8) -- TOTAL BUFR MESSAGE LENGTH IN BYTES
C                         -  KSUP( 9) -- IDIM0, DIMENSION OF KSEC0
C               *KSEC3*   -  ARRAY CONTAINING SECTION 3 INFORMATION
C                            KSEC3( 1)-- LENGTH OF SECTION 3 (BYTES)
C                            KSEC3( 2)-- RESERVED
C                            KSEC3( 3)-- NUMBER OF SUBSETS
C                            KSEC3( 4)-- FLAG (DATA TYPE,DATA COMPRESSION)
C               *KERR*    -  RETURNED ERROR CODE
C
C     METHOD.
C     -------
C          WORD AND BIT POINTERS ARE CALCULATED FOR EVERY ELEMENT
C     IN THE EXPANDED LIST OF ELEMENTS. IF PARTIAL EXPANSION REQUESTED,
C     INDECES TO REQUIRED ELEMENTS ARE DETERMINED, AS WELL AS CORRESPONDING
C     QUALITY CONTROL, STATISTICS ETC. INFORMATION.
C
C
C
C     EXTERNALS.
C     ----------
C
C          BUNPCK          - UNPACKS BIT PATTERN
C          BUNPKS         - UNPACKS BIT PATTERN IN REPEATED WAY
C          BUPMRK          - PROCES MARKER OPERATOR
C
C     REFERENCE.
C     ----------
C
C          NONE.
C
C     AUTHOR.
C     -------
C
C          M. DRAGOSAVAC    *ECMWF*       01/02/91.
C
C
C     MODIFICATIONS.
C     --------------
C
C          NONE.
C
C
      IMPLICIT LOGICAL(L,O,G), CHARACTER*8(C,H,Y)
C
C
#     include "parameter.F"
#     include "bcomunit.F"
#     include "bcomwork.F"
#     include "bcombef.F"
#     include "bcomwt.F"
#     include "bcomp.F"
#     include "bcomwtc.F"
#     include "bcomrq.F"
#     include "bcomreq.F"
#     include "bcomoff.F"
C
      CHARACTER CWTEN*64,CWTU*24
      CHARACTER*64 CNAMES(KELEM)
      CHARACTER*24 CUNITS(KELEM)
C
      DIMENSION KBUFF(KBUFL)
      DIMENSION KSUP(JSUP),KSEC3(JSEC3)
C
      DIMENSION IRQEI(JELEM),IQCI(JELEM),IQCDPI(JELEM)
      DIMENSION IBVAL(JELEM),IBV(JELEM)
      DIMENSION IC7(JELEM),IC8(JELEM),IC7R(JELEM),IC8R(JELEM)
      DIMENSION NQP(JELEM),ITYPE(100)
C
      DIMENSION IMASK(8)
#ifndef R_4
      REAL*8 RVIND
      REAL*8 EPS
      REAL*8 RQVAL
      REAL*8 VAL
#else
      REAL   RVIND
      REAL   EPS
      REAL   RQVAL
      REAL   VAL
#endif
C
      SAVE IBV,IBVAL
C
      DATA IMASK /1,2,4,8,16,32,64,128/
C
C
C     ------------------------------------------------------------------
C
C*          1.  DEFINE WORD/BIT POINTERS TO EVERY ELEMENT.
C               ------------------------------------------
 100  CONTINUE
C
      NFUCM=1
      NFCM=0
C
      IF(KERR.GT.0) RETURN
C
C     CHECK REQUEST VALIDITY
C
      IF(NREQ(1).EQ.0.AND.NREQ(2).NE.0) THEN
         KERR=38
         CALL BUERR(KERR)
         RETURN
      END IF
C
      MREL=0
C
      IBP32= 32 + NBPTB
C
      IB1=0
      IF(IAND(NREQ(2),IMASK(1)).NE.0) IB1=1
      IB2=0
      IF(IAND(NREQ(2),IMASK(2)).NE.0) IB2=1
      IB3=0
      IF(IAND(NREQ(2),IMASK(3)).NE.0) IB3=1
      IB4=0
      IF(IAND(NREQ(2),IMASK(4)).NE.0) IB4=1
      IB5=0
      IF(IAND(NREQ(2),IMASK(5)).NE.0) IB5=1
      IB6=0
      IF(IAND(NREQ(2),IMASK(6)).NE.0) IB6=1
C
C
C*          1.2 NON-COMPRESSED DATA.
C               --------------------
 120  CONTINUE
C
      IF(OMULTI) THEN
C
         N=1
         DO 1221 I=1,N
         IBIT=0
         IF(NSUBSET.EQ.1) THEN
            IBIT = IBIT + IBP32   ! beginning of first element
            IWORD= IBIT/NBPW
         ELSE
            IBIT=NBP
         END IF
C
         I1MK=(I-1)*KELEM
         I1= 1+I1MK
C
         IF(NSUBSET.EQ.1) THEN
            NBITP (I1)= IBIT - IWORD*NBPW  
            NWORDP(I1)= NWPTB + IWORD
         ELSE
            NWORDP(I1)= NWP
            NBITP (I1)= NBP
            IBIT= IBIT + NWP*NBPW
         END IF
C
         DO 1231 J=2,M
         IBIT = IBIT + NWTDW(J-1)
         IWORD= IBIT/NBPW
C
         JI= J+I1MK
C
         NBITP (JI)= IBIT - IWORD*NBPW
         IF(NSUBSET.EQ.1) THEN
            NWORDP(JI)= NWPTB + IWORD
         ELSE
            NWORDP(JI)=IWORD
         END IF
 1231    CONTINUE
 1221    CONTINUE

         NSIZEG(NSUBSET)=M
      ELSE
         IBIT0= 0
C
         IF(N.GT.1) THEN
            DO 121 J=1,M
            IBIT0 = IBIT0 + NWTDW(J)
 121        CONTINUE
         END IF
C
         DO 122 I=1,N
         IBIT=0
         IBIT=IBIT0*(I-1)
         IBIT = IBIT + IBP32
         IWORD= IBIT/NBPW
C
         I1MK=(I-1)*KELEM
         I1= 1+I1MK
C
         NBITP (I1)= IBIT - IWORD*NBPW
         NWORDP(I1)= NWPTB + IWORD
C
         DO 123 J=2,M
         IBIT = IBIT + NWTDW(J-1)
         IWORD= IBIT/NBPW
C
         JI= J+I1MK
C
         NBITP (JI)= IBIT - IWORD*NBPW
         NWORDP(JI)= NWPTB + IWORD
 123     CONTINUE
 122     CONTINUE
C
      END IF
C     -----------------------------------------------------------------
C*          2. CREATE POINTERS FOR REQUESTED ELEMENTS.
C              ---------------------------------------
 200  CONTINUE
C
C
C*          2.1 CHECK IF SUBSET OF ELEMENTS REQUESTED.
C
 210  CONTINUE
C
      IF(NREQ(1).EQ.0) THEN
         DO 212 I=1,M
         INWTEN(I)=NWTEN(I)
         INWTR (I)=NWTR (I)
         INWTS (I)=NWTS (I)
         INWTDW(I)=NWTDW(I)
         INWTRV(I)=NWTRV(I)
         CNAMES(I)=CWTEN(I)
         CUNITS(I)=CWTU(I)
         DO 2128 J=1,N
         JM1K=(J-1)*KELEM
         JI=I+JM1K
         INWORDP(JI)=NWORDP(JI)
         INBITP(JI)=NBITP(JI)
 2128    CONTINUE
 212     CONTINUE
         RETURN
      END IF
C
      IF(NREQ(1).EQ.1) THEN
         DO 213 I=1,M
         IF(NWTR(I).GT.200000.AND.
     1      NWTR(I).NE.999999) THEN
            MREL=I-1
            GO TO 2133
         END IF
 213     CONTINUE
         MREL=M
C
 2133    CONTINUE
         J=0
         IF(NREQ(2).EQ.0) THEN
            DO 2131 I=1,MREL
            J=J+1
            DO 2132 K=1,N
C
            K1K=(K-1)*KELEM
            JK=J+K1K
            IK=I+K1K
C
            INBITP(JK)=NBITP(IK)
            INWORDP(JK)=NWORDP(IK)
 2132       CONTINUE
            INWTEN(J)=NWTEN(I)
            INWTR(J)=NWTR(I)
            INWTS(J)=NWTS(I)
            INWTDW(J)=NWTDW(I)
            INWTRV(J)=NWTRV(I)
            CNAMES(J)=CWTEN(I)
            CUNITS(J)=CWTU(I)
 2131       CONTINUE
            M=J
            RETURN
         ELSE
            M=MREL
            GO TO 220
         END IF
C
      END IF
C
      IF(NREQ(1).EQ.2) THEN
         DO 214 I=1,M
         IF(NWTR(I).EQ.235000) THEN
            M=I-1
            GO TO 2141
         END IF
 214     CONTINUE
C
 2141    CONTINUE
C
         J=0
         IF(NREQ(2).EQ.0) THEN
            DO 2142 I=1,M    
            J=J+1
            DO 2143 K=1,N
C
            K1K=(K-1)*KELEM
            JK=J+K1K
            IK=I+K1K
C
            INBITP(JK)=NBITP(IK)
            INWORDP(JK)=NWORDP(IK)
 2143       CONTINUE
            INWTEN(J)=NWTEN(I)
            INWTR(J)=NWTR(I)
            INWTS(J)=NWTS(I)
            INWTDW(J)=NWTDW(I)
            INWTRV(J)=NWTRV(I)
            CNAMES(J)=CWTEN(I)
            CUNITS(J)=CWTU(I)
 2142       CONTINUE
C
            RETURN
         ELSE
            GO TO 220
         END IF
      END IF
C
      IF(NREQ(1).EQ.3) THEN
         DO 215 I=1,M
         IF(NWTR(I).EQ.235000) THEN
C
C           COPY CLASS 1 - 8
C
            DO 2151 III=1,M
            IF(NWTR(III).GT.8000) THEN
               J=0
               IF(NREQ(2).EQ.0) THEN
                  DO 2161 II=1,III-1
                  J=J+1
                  DO 2171 K=1,N
                  K1K=(K-1)*KELEM
                  JK=J+K1K
                  IIK=II+K1K
                  INBITP(JK)=NBITP(IIK)
                  INWORDP(JK)=NWORDP(IIK)
 2171             CONTINUE
                  INWTR(J)  =NWTR(II)
                  INWTS(J)  =NWTS(II)
                  INWTRV(J) =NWTRV(II)
                  INWTDW(J) =NWTDW(II)
                  INWTEN(J) =NWTEN(II)
                  CNAMES(J)=CWTEN(II)
                  CUNITS(J)=CWTU(II)
 2161             CONTINUE
                  GO TO 2160
               ELSE
                  DO 21611 II=1,III-1
                  J=J+1
                  DO 21711 K=1,N
                  K1K=(K-1)*KELEM
                  JK=J+K1K
                  IIK=II+K1K
                  NBITP(JK)=NBITP(IIK)
                  NWORDP(JK)=NWORDP(IIK)
21711             CONTINUE
                  NWTR(J)  =NWTR(II)
                  NWTS(J)  =NWTS(II)
                  NWTRV(J) =NWTRV(II)
                  NWTDW(J) =NWTDW(II)
                  NWTEN(J) =NWTEN(II)
                  CWTEN(J)=CWTEN(II)
                  CWTU(J)=CWTU(II)
21611             CONTINUE
                  GO TO 2160
               END IF
            END IF
 2151       CONTINUE
C----------------------------------------------------------------------
 2160       CONTINUE
            IF(NREQ(2).EQ.0) THEN
            DO 216 II=I+1,M
               J=J+1
               DO 217 K=1,N
               K1K=(K-1)*KELEM
               JK=J+K1K
               IIK=II+K1K
               INBITP(JK)=NBITP(IIK)
               INWORDP(JK)=NWORDP(IIK)
 217           CONTINUE
               INWTR(J)  =NWTR(II)
               INWTS(J)  =NWTS(II)
               INWTRV(J) =NWTRV(II)
               INWTDW(J) =NWTDW(II)
               INWTEN(J) =NWTEN(II)
               CNAMES(J)=CWTEN(II)
               CUNITS(J)=CWTU(II)
 216           CONTINUE
               M=J
               RETURN
            ELSE
               DO 2169 II=I+1,M
               J=J+1
               DO 2179 K=1,N
               K1K=(K-1)*KELEM
               JK=J+K1K
               IIK=II+K1K
               NBITP(JK)=NBITP(IIK)
               NWORDP(JK)=NWORDP(IIK)
 2179          CONTINUE
               NWTR(J)  =NWTR(II)
               NWTS(J)  =NWTS(II)
               NWTRV(J) =NWTRV(II)
               NWTDW(J) =NWTDW(II)
               NWTEN(J) =NWTEN(II)
               CWTEN(J)=CWTEN(II)
               CWTU(J)=CWTU(II)
 2169          CONTINUE
               M=J
               GO TO 220
            END IF
         END IF
 215     CONTINUE
         KERR=39
         CALL BUERR(KERR)
         M=0
         RETURN
      ELSE 
         KERR=40
         CALL BUERR(KERR)
         RETURN
      END IF
C
C
C*          2.2 CREATE INDICES TO CLASS 7/8
C               ---------------------------
 220  CONTINUE
C
      DO 225 I=1,M
      IF(NWTR(I).GT.200000.AND.
     1   NWTR(I).NE.999999) THEN
         MREL=I-1
         GO TO 226
      END IF
 225  CONTINUE
C
      MREL=M
C
 226  CONTINUE
C
      J=0
      JJ=0
      DO 221 I=1,MREL
      ICLASS=NWTR(I)/1000
      IF(ICLASS.EQ.7) THEN
         J=J+1
         IC7(J)=I
      END IF
C
      IF(ICLASS.EQ.8) THEN
         JJ=JJ+1
         IC8(JJ)=I
      END IF
 221  CONTINUE
C
      IC7L=J
      IC8L=JJ
      J=0
      JJ=0
      DO 223 I=1,NRQL
      ICLASS=NRQ(I)/1000
      IF(ICLASS.EQ.7.AND.(ABS(RQVAL(I)-RVIND)/RVIND.GT.EPS)) THEN
         J=J+1
         IC7R(J)=I
      END IF
C
      IF(ICLASS.EQ.8.AND.(ABS(RQVAL(I)-RVIND)/RVIND.GT.EPS)) THEN
         JJ=JJ+1
         IC8R(JJ)=I
      END IF
 223  CONTINUE
C
      IC7RL=J
      IC8RL=JJ
C
C*          2.3 CREATE INDECES TO THE REQUESTED ELEMENTS.
C               -----------------------------------------
 230  CONTINUE
C
      IF(IC7RL.EQ.0.AND.IC8RL.EQ.0) THEN
         IL=MREL
         IRL=NRQL
      END IF
      IF(IC7RL.NE.0.AND.IC8RL.EQ.0) THEN
         IL=IC7(1)
         IRL=IC7R(1)-1
      END IF
      IF(IC8RL.NE.0.AND.IC7RL.EQ.0) THEN
         IL=IC8(1)
         IRL=IC8R(1)-1
      END IF
      IF(IC7RL.NE.0.AND.IC8RL.NE.0) THEN
         IL=IC7(1)
         IF(IC7(1).GT.IC8(1)) IL=IC8(1)
         IRL=IC7R(1)
         IF(IC7R(1).GT.IC8R(1)) IRL=IC8R(1)
         IRL=IRL-1
      END IF
C
      DO 299 I=1,MREL
      IRQEI(I)=0
 299  CONTINUE
C
      ORQEI=.FALSE.
      DO 231 I=1,IL
      IF(IB2.EQ.0.OR.NRQL.EQ.0) THEN
         ORQEI=.TRUE.
         IRQEI(I)=I
      ELSE
         DO 232 K=1,IRL
         IF(NWTR(I).EQ.NRQ(K)) THEN
            ORQEI=.TRUE.
            IRQEI(I)=I
         END IF
 232     CONTINUE
      END IF
 231  CONTINUE
C
C
      IF(IC7RL.NE.0) THEN
C
C        CLASS 7 SIGNIFYING
C
         IST=1
         DO 233 IJ=1,IC7RL
         III=IC7R(IJ)
         DO 234 I=IST,IC7L
         II=IC7(I)
         IF(IC7R(IJ).EQ.IC7R(IJ+1)) THEN
         IF(NWTR(II).NE.NWTR(II+1)) GO TO 234
         END IF
         IBITP=NBITP(II)
         IWORD=NWORDP(II)
         CALL GBYTE(KBUFF(IWORD),IVAL,IBITP,NWTDW(II))
         ISCALE=NWTS(II)
         IREF  =NWTRV(II)
         IVAL  =IVAL+IREF
         VAL   =RVIND
         IF(IVAL.NE.NMASK(NWTDW(II))) THEN
            IF(ISCALE.GT.0) THEN
               VAL=IVAL/10.**ISCALE
            ELSE
               IISCALE=IABS(ISCALE)
               VAL=IVAL*10.**IISCALE
            END IF
         END IF
C
         INEXT=IC7(I+1)-1
         IF(I.EQ.IC7L) INEXT=MREL
C         IF(IC7(I+1).EQ.0) INEXT=MREL
         IF(ABS(RQVAL(III)-VAL).LT.EPS.OR.
     1      ABS(RQVAL(III)-RVIND)/RVIND.LT.EPS) THEN
            DO 236 KI=II,INEXT
            IF(IB2.EQ.0) THEN
               ORQEI=.TRUE.
               IRQEI(KI)=KI
            ELSE
               IE=IC7R(IJ+1)-1
               IF(IJ.EQ.IC7RL) IE=NRQL
               IF(IC8RL.NE.0) THEN
                  DO 238 JA=1,IC8RL
                  IF(IC8R(JA).GT.III.AND.IC8R(JA).LT.IE) THEN
                     IE=IC8R(JA)-2
                     GO TO 298
                  END IF
 238              CONTINUE
               END IF
 298           CONTINUE
               DO 237 IK=III,IE
               IF(NWTR(KI).EQ.NRQ(IK)) THEN
                  ORQEI=.TRUE.
                  IRQEI(KI)=KI
               END IF
 237           CONTINUE
            END IF
 236        CONTINUE
C
            GO TO 233
         END IF
 234     CONTINUE
 233     CONTINUE
C
      END IF
C
      IF(IC8RL.NE.0) THEN
C
C        CLASS 8 SIGNIFYING
C
         IST=1
         DO 241 IJ=1,IC8RL
         III=IC8R(IJ)
         DO 242 I=IST,IC8L
         II=IC8(I)
         IBITP=NBITP(II)
         IWORD=NWORDP(II)
         CALL GBYTE(KBUFF(IWORD),IVAL,IBITP,NWTDW(II))
         ISCALE=NWTS(II)
         IREF  =NWTRV(II)
         IVAL  =IVAL+IREF
         VAL   =RVIND
         IF(IVAL.NE.NMASK(NWTDW(II))) THEN
            IF(ISCALE.GT.0) THEN
               VAL=IVAL/10.**ISCALE
            ELSE
               IISCALE=IABS(ISCALE)
               VAL=IVAL*10.**IISCALE
            END IF
         END IF
C
         INEXT=IC8(I+1)-2
         IF(IC8(I+1).EQ.0) INEXT=MREL
C
         OT=.FALSE.
         IF(ABS(VAL-RVIND)/RVIND.LT.EPS) THEN
            IVAL=NINT(VAL)
            IRQV=NINT(RQVAL(III))
C
            IF(NWTR(II).EQ.008001) THEN
               OT=.TRUE.
               IF(IAND(IVAL,IRQV).NE.IRQV) OT=.FALSE.
            ELSE
               OT=.TRUE.
               IF(ABS(VAL-RQVAL(III)).GT.EPS) OT=.FALSE.
            END IF
         END IF
C
         IF(OT) THEN
            ICL=NWTR(II-1)/1000
            IF(ICL.EQ.7) IRQEI(II-1)=II-1
            DO 244 KI=II,INEXT
            IF(IB2.EQ.0) THEN
               ORQEI=.TRUE.
               IRQEI(KI)=KI
            ELSE
               IE=IC8R(IJ+1)-1
               IF(IJ.EQ.IC8RL) IE=NRQL
               IF(IC7RL.NE.0) THEN
                  DO 248 JA=1,IC7RL
                  IF(IC7R(JA).GT.III.AND.IC7R(JA).LT.IE) THEN
                     IE=IC7R(JA)-1
                     GO TO 297
                  END IF
 248              CONTINUE
               END IF
 297           CONTINUE
               DO 245 IK=III,IE
               IF(NWTR(KI).EQ.NRQ(IK)) THEN
                  ORQEI=.TRUE.
                  IRQEI(KI)=KI
               END IF
 245           CONTINUE
            END IF
 244        CONTINUE
C
         END IF
 242     CONTINUE
 241     CONTINUE
C
      END IF
C
      IF(.NOT.ORQEI) THEN
         KERR=45
         CALL BUERR(KERR)
         M=0
         RETURN
      END IF

C
C
C*          3. FIND POINTERS TO QUALITY CONTROL,START OF DATA
C               ----------------------------------------------
C               PRESENT INDICATORS AND %CONFIDENCE.
C               -----------------------------------
C
 300  CONTINUE
C
      I=0
      IF(IB3.NE.0) THEN
         I=I+1
         ITYPE(I)=222000
      END IF
C
      IF(IB4.NE.0) THEN
         I=I+1
         ITYPE(I)=224000
      END IF
C
      IF(IB5.NE.0) THEN
         I=I+1
         ITYPE(I)=225000
      END IF
C
      IF(IB6.NE.0) THEN
         I=I+1
         ITYPE(I)=223000
      END IF
C
      KEND=I
      IF(KEND.EQ.0) THEN
        J=0
        DO 4011 I=1,MREL
        IF(IRQEI(I).NE.0) THEN
          II=IRQEI(I)
          J=J+1
          DO 4021 K=1,N
          K1K=(K-1)*KELEM
          JK=J+K1K
          IIK=II+K1K
          INWORDP(JK)=NWORDP(IIK)
          INBITP (JK)=NBITP (IIK)
 4021     CONTINUE
          INWTR(J)  =NWTR(II)
          INWTS(J)  =NWTS(II)
          INWTRV(J) =NWTRV(II)
          INWTDW(J) =NWTDW(II)
          INWTEN(J) =NWTEN(II)
          CNAMES(J)=CWTEN(II)
          CUNITS(J)=CWTU(II)
        END IF
4011    CONTINUE
        GO TO 900
      END IF
C
      OLIST=.FALSE.
      O236=.FALSE.
      O237=.FALSE.
C
      DO 500 KT=1,KEND
C
         JQPR=0
         JQUA=0
         JQCA=0
         JQC =0
         JQCC=0
         JQCS=0
         KM=MREL
C
C        FIND POINTERS TO OPERATORS
C
         KZ=0
         DO 3031 I=KM,M
         IF(NWTR(I).EQ.ITYPE(KT)) THEN
            KZ=KZ+1
            NQP(KZ)=I
         END IF
 3031    CONTINUE
C
         IF(KZ.EQ.0) THEN
            WRITE(KNTN,*) ITYPE(KT),' NOT PRESENT IN THIS MESSAGE.'
            GO TO 500
         ELSE
            KZ=KZ+1
            NQP(KZ)=M
         END IF
C
         DO 3033 KQ=1,KZ-1
C
         JQUA=NQP(KQ)
C
         IF(NWTR(JQUA+1).EQ.236000) THEN
            JQ236=JQUA+1
            O236=.TRUE.
         END IF
C
         IF(NWTR(JQUA+1).EQ.237000) THEN
            JQ237=JQUA+1
            O237=.TRUE.
         ELSE
            O237=.FALSE.
         END IF
C
C
C        DATA PRESENT INDICATOR
C
         IF(.NOT.O236.AND.O237) THEN
C
C           FIND LAST DEFINED BIT MAP
C
            DO 420 I=JQUA,MREL,-1
            IF(NWTR(I).EQ.236000) GO TO 421
 420        CONTINUE
C
            KERR=41
            CALL BUERR(KERR)
            RETURN
C
 421        CONTINUE
C
            O236=.TRUE.
            O237=.FALSE.
            JQ236=I
            JQ237=0
            IK=I
            IDPRF=0
            DO 3015 I=IK,M
            IF(NWTR(I).EQ.31031.OR.NWTR(I).EQ.31192) THEN
               IDPRF=IDPRF+1
               IF(IDPRF.EQ.1) JQPR=I
            ELSE
               IF(IDPRF.NE.0) GO TO 30111
            END IF
 3015       CONTINUE
C
 3016       CONTINUE
         END IF
C
C        DATA PRESENT INDICATOR
C
         IF(.NOT.O237) THEN
            IDPRF=0
            DO 301 I=JQUA,NQP(KQ+1)
            IF(NWTR(I).EQ.31031.OR.NWTR(I).EQ.31192) THEN
               IDPRF=IDPRF+1
               IF(IDPRF.EQ.1) JQPR=I
            ELSE
               IF(IDPRF.NE.0) GO TO 30111
            END IF
 301        CONTINUE
         END IF
C
30111   CONTINUE
C
C        GENERATING CENTRE
C
         DO 309 I=JQUA,NQP(KQ+1)
         IF(NWTR(I).EQ.1031) THEN
            JQCC=I
            GO TO 302
         END IF
 309     CONTINUE
C
 302     CONTINUE
C
C        GENERATING APPLICATION
C
         DO 307 I=JQUA,NQP(KQ+1)
         IF(NWTR(I).EQ.1032.OR.NWTR(I).EQ.1201.OR.
     1      NWTR(I).EQ.63191) THEN
            JQCA=I
            GO TO 3071
         END IF
 307     CONTINUE
C
 3071    CONTINUE
C
C        PERCENTAGE CONFIDENCE
C
         IF(ITYPE(KT).EQ.222000) THEN
            DO 305 I=JQUA,NQP(KQ+1)
            IF(NWTR(I)/1000.EQ.33.OR.NWTR(I).EQ.63192) THEN
               JQC=I
               GO TO 306
            END IF
 305        CONTINUE
         ELSE
C           SIGNIFICANCE
C
            DO 308 I=JQUA,NQP(KQ+1)
            IF(NWTR(I)/1000.EQ.8) THEN
               JQCS=I
               GO TO 3088
            END IF
 308        CONTINUE
C
 3088       CONTINUE

            DO 3051 I=JQUA,NQP(KQ+1)
            IF(NWTR(I).EQ.223255.OR.NWTR(I).EQ.224255.OR.
     1         NWTR(I).EQ.225255) THEN
               JQC=I
               GO TO 306
            END IF
 3051       CONTINUE
         END IF
C
C
 306     CONTINUE
C
C
C*          3.1  SET INDICES TO GET Q/C.
C                GET BIT MAP FROM DATA SECTION.
C
 310  CONTINUE
C
         IF(JQUA.EQ.0) THEN
            WRITE(KNTN,'(1H )')
        WRITE(KNTN,'(1H ,A)') 'Q/C NOT PRESENT IN THIS BUFR MESSAGE.'
            WRITE(KNTN,'(1H )')
         ELSE
C
            IF(.NOT.O237) THEN
               DO 311 K=1,N
C
               K1K=(K-1)*KELEM
               JQPRK=JQPR+K1K
C
               IWPT=NWORDP(JQPRK)
               IBPT=NBITP (JQPRK)
               CALL GBYTES(KBUFF(IWPT),IBV,IBPT,1,0,IDPRF)
               DO 312 KA=1,IDPRF
               KAK=KA+K1K
               IBVAL(KAK)=IBV(KA)
 312           CONTINUE
 311           CONTINUE
            END IF
C
            IDIF=MREL-IDPRF
C
            JS=0
            IF(IDIF.NE.0) THEN
               DO 313 I=1,IDIF
               JS=JS+1
               IQCDPI(JS)=0
 313           CONTINUE
            END IF
C
            JQPRM1=JQPR-1
            DO 314 I=1,IDPRF
            JS=JS+1
            IQCDPI(JS)=I+JQPRM1
 314        CONTINUE
C
            JS=0
            IF(IDIF.NE.0) THEN
               DO 315 I=1,IDIF
               JS=JS+1
               DO 316 JJ=1,N
               JJJ=JS+(JJ-1)*KELEM
               IQCI(JJJ)=0
 316           CONTINUE
 315           CONTINUE
            END IF
C
            K=JQC-1
            DO 317 I=1,IDPRF
            OK=.TRUE.
            JS=JS+1
            DO 318 JJ=1,N
            JJ1K=(JJ-1)*KELEM
            JJJ=JS+JJ1K
            IJJ=I+JJ1K
            IQCI(JJJ)=0
            IF(IBVAL(IJJ).EQ.0) THEN
               IF(OK) K=K+1
               IQCI(JJJ)=K
               OK=.FALSE.
            END IF
 318        CONTINUE
 317        CONTINUE
C
         END IF
C
C
C           4.  CREATE REQUESTED ELEMENT LIST
C               -----------------------------
 400  CONTINUE
C
      IF(.NOT.OLIST) THEN
         IF(NREQ(2).EQ.0) NRQL=0
         J=0
         DO 401 I=1,MREL
         IF(IRQEI(I).NE.0) THEN
            II=IRQEI(I)
            J=J+1
            DO 402 K=1,N
            K1K=(K-1)*KELEM
            JK=J+K1K
            IIK=II+K1K
            INWORDP(JK)=NWORDP(IIK)
            INBITP (JK)=NBITP (IIK)
 402        CONTINUE
            INWTR(J)  =NWTR(II)
            INWTS(J)  =NWTS(II)
            INWTRV(J) =NWTRV(II)
            INWTDW(J) =NWTDW(II)
            INWTEN(J) =NWTEN(II)
            CNAMES(J)=CWTEN(II)
            CUNITS(J)=CWTU(II)
            OLIST=.TRUE.
         END IF
 401     CONTINUE
      END IF
C
      IF(JQUA.NE.0) THEN
C
C*          4.1 ADD DATA PRESENT INDICATOR AND Q/C.
C               -----------------------------------
 410     CONTINUE
C
C               ADD OPERATOR 222000
C
         J=J+1
         DO 411 K=1,N
C
         K1K=(K-1)*KELEM
         JK=J+K1K
         JQUAK=JQUA+K1K
C
         INWORDP(JK)=NWORDP(JQUAK)
         INBITP (JK)=NBITP (JQUAK)
 411     CONTINUE
         INWTR(J)  =NWTR(JQUA)
         INWTS(J)  =NWTS(JQUA)
         INWTRV(J) =NWTRV(JQUA)
         INWTDW(J) =NWTDW(JQUA)
         INWTEN(J) =NWTEN(JQUA)
         CNAMES(J)=CWTEN(JQUA)
         CUNITS(J)=CWTU(JQUA)
C
         IF(O236.AND..NOT.O237) THEN
            J=J+1
            DO 4111 K=1,N
            K1K=(K-1)*KELEM
            JK=J+K1K
            JQUAK=JQ236+K1K
C
            INWORDP(JK)=NWORDP(JQUAK)
            INBITP (JK)=NBITP (JQUAK)
 4111       CONTINUE
            INWTR(J)  =NWTR(JQ236)
            INWTS(J)  =NWTS(JQ236)
            INWTRV(J) =NWTRV(JQ236)
            INWTDW(J) =NWTDW(JQ236)
            INWTEN(J) =NWTEN(JQ236)
            CNAMES(J)=CWTEN(JQ236)
            CUNITS(J)=CWTU (JQ236)
         END IF
C
         IF(O237) THEN
            J=J+1
            DO 4112 K=1,N
            K1K=(K-1)*KELEM
            JK=J+K1K
            JQUAK=JQ237+K1K
C
            INWORDP(JK)=NWORDP(JQUAK)
            INBITP (JK)=NBITP (JQUAK)
 4112       CONTINUE
            INWTR (J) =NWTR (JQ237)
            INWTS (J) =NWTS (JQ237)
            INWTRV(J) =NWTRV(JQ237)
            INWTDW(J) =NWTDW(JQ237)
            INWTEN(J) =NWTEN(JQ237)
            CNAMES(J)=CWTEN(JQ237)
            CUNITS(J)=CWTU (JQ237)
         END IF
C
         IF(.NOT.O237) THEN
            DO 412 I=1,MREL
            IF(IRQEI(I).NE.0) THEN
               IF(IQCDPI(I).NE.0) THEN
                  J=J+1
                  DO 413 K=1,N
C
                  K1K=(K-1)*KELEM
                  JK=J+K1K
                  IQCDK=IQCDPI(I)+K1K
C
                  INWORDP(JK)=NWORDP(IQCDK)
                  INBITP (JK)=NBITP (IQCDK)
 413              CONTINUE
                  INWTR(J)  =NWTR(IQCDPI(I))
                  INWTS(J)  =NWTS(IQCDPI(I))
                  INWTRV(J) =NWTRV(IQCDPI(I))
                  INWTDW(J) =NWTDW(IQCDPI(I))
                  INWTEN(J) =NWTEN(IQCDPI(I))
                  CNAMES(J)=CWTEN(IQCDPI(I))
                  CUNITS(J)=CWTU(IQCDPI(I))
               END IF
            END IF
 412        CONTINUE
         END IF
C
C        GENERATING CENTRE
C
         IF(JQCC.NE.0) THEN
            J=J+1
            DO 417 K=1,N

            K1K=(K-1)*KELEM
            JK=J+K1K
            JQCCK=JQCC+K1K
C
            INWORDP(JK)=NWORDP(JQCCK)
            INBITP (JK)=NBITP (JQCCK)
 417        CONTINUE
            INWTR(J)  =NWTR(JQCC)
            INWTS(J)  =NWTS(JQCC)
            INWTRV(J) =NWTRV(JQCC)
            INWTDW(J) =NWTDW(JQCC)
            INWTEN(J) =NWTEN(JQCC)
            CNAMES(J)=CWTEN(JQCC)
            CUNITS(J)=CWTU(JQCC)
         END IF
C
C        GENERATING APPLICATION
C
         IF(JQCA.NE.0) THEN
            J=J+1
            DO 414 K=1,N

            K1K=(K-1)*KELEM
            JK=J+K1K
            JQCAK=JQCA+K1K
C
            INWORDP(JK)=NWORDP(JQCAK)
            INBITP (JK)=NBITP (JQCAK)
 414        CONTINUE
            INWTR(J)  =NWTR(JQCA)
            INWTS(J)  =NWTS(JQCA)
            INWTRV(J) =NWTRV(JQCA)
            INWTDW(J) =NWTDW(JQCA)
            INWTEN(J) =NWTEN(JQCA)
            CNAMES(J)=CWTEN(JQCA)
            CUNITS(J)=CWTU(JQCA)
         END IF
C
C        SIGNIFICANCE
C
         IF(JQCS.NE.0) THEN
            J=J+1
            DO 4147 K=1,N

            K1K=(K-1)*KELEM
            JK=J+K1K
            JQCAK=JQCS+K1K
C
            INWORDP(JK)=NWORDP(JQCAK)
            INBITP (JK)=NBITP (JQCAK)
 4147       CONTINUE
            INWTR(J)  =NWTR(JQCS)
            INWTS(J)  =NWTS(JQCS)
            INWTRV(J) =NWTRV(JQCS)
            INWTDW(J) =NWTDW(JQCS)
            INWTEN(J) =NWTEN(JQCS)
            CNAMES(J)=CWTEN(JQCS)
            CUNITS(J)=CWTU(JQCS)
         END IF
C
C        CALSS 33 ELEMENTS
C
         DO 415 I=1,MREL
         IF(IRQEI(I).NE.0) THEN
            OK=.TRUE.
            DO 416 JJ=1,N
            JJ1K=(JJ-1)*KELEM
            IJJ=I+JJ1K
            IF(IQCI(IJJ).NE.0) THEN
               IF(OK) J=J+1
               OK=.FALSE.
               INWTR(J)  =NWTR  (IQCI(IJJ))
               INWTS(J)  =NWTS  (IQCI(IJJ))
               INWTRV(J) =NWTRV (IQCI(IJJ))
               INWTDW(J) =NWTDW (IQCI(IJJ))
               INWTEN(J) =NWTEN (IQCI(IJJ))
               CNAMES(J)=CWTEN (IQCI(IJJ))
               CUNITS(J)=CWTU  (IQCI(IJJ))
C
               JJJ=J+JJ1K
               JQCIJJ=IQCI(IJJ)+JJ1K
C
               INWORDP(JJJ)=NWORDP(JQCIJJ)
               INBITP (JJJ)=NBITP (JQCIJJ)
            END IF
 416        CONTINUE
C
         END IF
 415     CONTINUE
      END IF
C
 3033 CONTINUE
C
 500  CONTINUE
C
C*          5. MAKE ONE TO ONE CORRESPONDENCE BETWEEN ELEMENTS AND
C              Q/C,STATISTICS,DIFFERENCE STATISTICS OR SUBSTITUTED VALUES
C              LEAVING BEHIND DATA PRESENT INDICATORS.
C
      IF(IB3.NE.0) THEN
      END IF
C
      IF(IB4.NE.0) THEN
      END IF
C
      IF(IB5.NE.0) THEN
      END IF
C
      IF(IB6.NE.0) THEN
      END IF
C
C*          9.  UPDATE TOTAL NUMBER OF ELEMENTS.
C               --------------------------------
 900  CONTINUE
C
      M=J
      NFCM=0
      NFUCM=1
C
      RETURN
C
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

#ifndef USE_NO_POINTERS
      INTEGER FUNCTION GBITMAP(KNUM, KVALS, KNONMIS, KBTPTR, KBYTE)
C
C---->
C**** GBITMAP - Read bitmap from a file
C
C     Purpose.
C     --------
C
C     Reads a bitmap from a file.
C
C**   Interface.
C     ----------
C
C     IRET = GBITMAP(KNUM, KVALS, KNONMIS, KBTPTR, KBYTE)
C
C
C     Input Parameters.
C     -----------------
C
C     KNUM    - The predetermined bitmap number (in range 0 to 999)
C     KBYTE   - Number of bits in an INTEGER.
C
C     Output Parameters.
C     ------------------
C
C     KVALS   - The number of bits in the bitmap
C     KNONMIS - The number of non-missing points in the bitmap
C     KBTPTR  - Pointer to the start of the bitmap
C
C     Returns zero if all OK (otherwise an error).
C
C
C     Method.
C     -------
C
C     Opens a file containing the bitmap, allocates memory for the
C     bitmap, reads the bitmap into memory, and closes the file.
C
C     If the bitmap number is the same as in the previous call,
C     the open/allocate/read sequence is skipped.
C
C     The file pathname may be given by the environment variable
C     LOCAL_BITMAP_PATH, otherwise a hardcoded default pathname is used.
C
C
C     Externals.
C     ----------
C
C     PBOPEN   - Opens the binary bitmap file
C     PBREAD   - Reads the binary bitmap file
C     PBCLOSE  - Closes the binary bitmap file
C     INXBIT   - Extract values from bit-stream
C     JMALLOC  - Routine to acquire memory
C
C
C     Reference.
C     ----------
C
C     None.
C
C
C     Comments.
C     ---------
C
C     None.
C
C
C     Author.
C     -------
C
C     J.D.Chambers       ECMWF      Oct 1996
C
C
C     Modifications.
C     --------------
C
C     J.D.Chambers     ECMWF        Feb 1997
C     Allow for 64-bit pointers
C
C     J.Clochard, Meteo France, for ECMWF - January 1998.
C     Use JMALLOC for all systems.
C
C
C----<
C     ----------------------------------------------------------------
C*    Section 0 . Definition of variables. Data statements.
C     ----------------------------------------------------------------
C
      IMPLICIT NONE
C
#include "common/grprs.h"
#include "grbcom.h"
C
C     Function arguments
C
      INTEGER KNUM, KVALS, KNONMIS, KBYTE
#ifndef _CRAYFTN
#ifdef POINTER_64
      INTEGER*8 KBTPTR
#else
      INTEGER*4 KBTPTR
#endif
#else
      INTEGER*8 KBTPTR
#endif
C
C     Local variables
C
      INTEGER IRET
C
C     Predetermined bitmask variables
C
      CHARACTER*256 HBTMASK
      INTEGER IBTMAP,IBTMASK,IBTSIZE,IBTSIZP,IBTOPEN,IBTVALS,NONMISS
      INTEGER IOFFSET
#ifndef _CRAYFTN
#ifdef POINTER_64
      INTEGER*8 IBTPTR
#endif
#endif
      POINTER (IBTPTR,IBTMAP)
      DIMENSION IBTMAP(1)
      SAVE IBTPTR, IBTSIZP, IBTOPEN, IBTVALS, NONMISS
C
C     External functions
C
#ifdef POINTER_64
      INTEGER*8 JMALLOC
#else
      INTEGER JMALLOC
#endif
      EXTERNAL JMALLOC
C
      DATA IBTSIZP/0/
      DATA IBTOPEN/0/
C
C     ----------------------------------------------------------------
C     Section 1 . Initialise.
C     ----------------------------------------------------------------
C
  100 CONTINUE
C
C     Clear return values
      KVALS   = 0
      KNONMIS = 0
      KBTPTR  = 0
C
C     Check the bitmap number is valid
      IF( (KNUM.LT.0) .OR. (KNUM.GT.999) ) THEN
        WRITE(GRPRSM,*) 'GBITMAP: Invalid bitmap number given = ', KNUM
        GBITMAP = 727
        GOTO 900
      ENDIF
C
C     ----------------------------------------------------------------
C     Section 2 . Open the bitmask file if first time.
C     ----------------------------------------------------------------
C
  200 CONTINUE
C
      IF( IBTOPEN.NE.KNUM ) THEN
C 
C       Build filename
        HBTMASK = ELBPATH
        IOFFSET = INDEX( HBTMASK, ' ')
        WRITE(HBTMASK(IOFFSET:IOFFSET+10),'(A8,I3.3)')
     X    'bitmask_', KNUM
        IOFFSET = INDEX( HBTMASK, ' ')
C 
C       Open the file
        CALL PBOPEN(IBTMASK,HBTMASK(1:IOFFSET-1),'r',IRET)
        IF( IRET.NE.0 ) THEN
          WRITE(GRPRSM,*) 'GBITMAP: Open predetermined bitmap failed'
          GBITMAP = 728
          GOTO 900
        ENDIF
C 
C       Read file size (number of bits)
        CALL PBREAD(IBTMASK,IBTSIZE,KBYTE,IRET)
        IF( IRET.NE.KBYTE ) THEN
          WRITE(GRPRSM,*) 'GBITMAP: Problem getting bitmap size'
          GBITMAP = 729
          GOTO 900
        ENDIF
C 
C       Get memory to read bitmask unless sufficient previously
C       allocated
        IBTVALS = IBTSIZE
        IBTSIZE = (IBTSIZE+8-1)/8
C 
C       Check whether this bitmap is bigger than the previous
C       bitmap (if any)
        IF( IBTSIZE.GT.IBTSIZP ) THEN
C 
C         Return previously allocated memory (if any)
          IF( IBTSIZP.NE.0 ) CALL JFREE(IBTPTR)
C 
C         Get memory
          IBTPTR  = JMALLOC(IBTSIZE)
#ifdef hpR64
          IBTPTR = IBTPTR/(1024*1024*1024*4)
#endif
          IF( IBTPTR.EQ.0 ) THEN
            WRITE(GRPRSM,*) 'GBITMAP: Problem getting memory for bitmap'
            GBITMAP = 730
            GOTO 900
          ENDIF
        ENDIF
C 
C       Read number of non-missing points
        CALL PBREAD(IBTMASK,NONMISS,KBYTE,IRET)
        IF( IRET.NE.KBYTE ) THEN
          WRITE(GRPRSM,*)
     X      'GBITMAP: Problem getting no. non-missing points'
          GBITMAP = 731
          GOTO 900
        ENDIF
C 
C       Read the bitmap
        CALL PBREAD(IBTMASK,IBTMAP,IBTSIZE,IRET)
        IF( IRET.NE.IBTSIZE ) THEN
          WRITE(GRPRSM,*) 'GBITMAP: Problem reading bitmap'
          GBITMAP = 732
          GOTO 900
        ENDIF
C 
C       Close the bitmap file
        CALL PBCLOSE(IBTMASK,IRET)
        IF( IRET.NE.0 ) THEN
          WRITE(GRPRSM,*) 'GBITMAP: Problem closing bitmap file'
          GBITMAP = 733
          GOTO 900
        ENDIF
C
        IBTOPEN = KNUM
C
      ENDIF
C
C     Setup return values
      KVALS   = IBTVALS
      KNONMIS = NONMISS
      KBTPTR  = IBTPTR
      GBITMAP = 0
C 
C     ----------------------------------------------------------------
C     Section 9 . Closedown.
C     ----------------------------------------------------------------
C
  900 CONTINUE
C
      RETURN
      END
#endif

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities
C granted to it by virtue of its status as an intergovernmental organisation
C nor does it submit to any jurisdiction.
C

      INTEGER FUNCTION INTFAU(FLDIN,INLEN)
C
C---->
C**** INTFAU
C
C     Purpose
C     -------
C
C     Prepare to interpolate input field...
C
C
C     Interface
C     ---------
C
C     IRET = INTFAU( FLDIN,INLEN)
C
C     Input
C     -----
C
C     FLDIN  - Input field (unpacked).
C     INLEN  - Input field length (words).
C
C
C     Output
C     ------
C
C    Field unpacked values are in ZNFELDI.
C
C
C     Method
C     ------
C
C     Unpack field if GRIB.
C
C
C     Externals
C     ---------
C
C     None.
C
C
C     Author
C     ------
C
C     J.D.Chambers     ECMWF     Jan 1995
C
C----<
C
      IMPLICIT NONE
C
C     Function arguments
C
      INTEGER INLEN
      REAL FLDIN(*)
C
#include "parim.h"
#include "nifld.common"
#include "nofld.common"
#include "grfixed.h"
#include "intf.h"
C
C     Parameters
C
      INTEGER JPROUTINE
      PARAMETER (JPROUTINE = 26300 )
      INTEGER JPLEN, JPNM
      PARAMETER ( JPNM = JPSTRUNC )
      PARAMETER ( JPLEN = (JPNM+1)*(JPNM+2) )
C
C     Local variables
C
      REAL POLELAT, POLELON
      CHARACTER*1 HTYPE
      INTEGER NUMPTS, NGAUSS
      INTEGER ISIZE, NBYTES, ITRUNC
      DATA ISIZE/0/
C
      REAL SWORK
      DIMENSION SWORK(1)
#ifndef _CRAYFTN
#ifdef POINTER_64
      INTEGER*8 ISWORK
#endif
#endif
      POINTER ( ISWORK, SWORK)
C
      REAL*8 DWORK
      DIMENSION DWORK(1)
#ifndef _CRAYFTN
#ifdef POINTER_64
      INTEGER*8 IDWORK
#endif
#endif
      POINTER ( IDWORK, DWORK )
C
      REAL*8 DATA
      DIMENSION DATA(1)
#ifndef _CRAYFTN
#ifdef POINTER_64
      INTEGER*8 IDATA
#endif
#endif
      POINTER ( IDATA, DATA)
C
      SAVE ISIZE, ISWORK, IDWORK, IDATA
C
      REAL*8 DLON, DLAT
      LOGICAL LOK
      DATA NBYTES/4/
C
C     Externals
      INTEGER GGROTAT
      LOGICAL JACOBI
      EXTERNAL JACOBI
      INTEGER IRET
      INTEGER LOOP
C
C ------------------------------------------------------------------
C*    Section 1.   Initialise
C ------------------------------------------------------------------
C
  100 CONTINUE
      INTFAU = 0
      IRET = 0
C
C ------------------------------------------------------------------
C*    Section 2.   Decode data from the GRIB code
C ------------------------------------------------------------------
C
  200 CONTINUE
C
C     Allocate work array ZNFELDI if not already done.
C
      IF( IZNJDCI.NE.1952999238 ) THEN
        CALL JMEMHAN( 19, IZNFLDI, JPEXPAND, 1, IRET)
        IF( IRET.NE.0 ) THEN
          CALL INTLOG(JP_WARN,'INTFAU: ZNFELDI allocate fail',JPQUIET)
          INTFAU = IRET
          GOTO 900
        ENDIF
        IZNJDCI = 1952999238
      ENDIF
C
C     Move unpacked values in from user array
      DO 210 LOOP = 1, INLEN
        ZNFELDI( LOOP ) = FLDIN( LOOP )
 210  CONTINUE
C
C ------------------------------------------------------------------
C*    Section 3.   Handle spectral rotation, if necessary.
C ------------------------------------------------------------------
C
  300 CONTINUE
C
C     Is the interpolation from SH with a rotation of the SH first?
C
      IF( ((NIREPR.EQ.JPSPHERE).OR.(NIREPR.EQ.JPSPHROT)) .AND.
     X    LNOROTA ) THEN
C
C       Avoid rotating U or V spectral coefficients
C
        IF( (NIPARAM.EQ.131).OR.(NIPARAM.EQ.132) ) THEN
          CALL INTLOG(JP_ERROR,
     X      'INTFAU: Unable to rotate spectral U or V:',NIPARAM)
          INTFAU = JPROUTINE + 6
          GOTO 900
        ENDIF
C
C       Dynamically allocate memory for workspace.
C
C       (Note the multiplication by 2 for REAL*8).
C
        NUMPTS = INLEN
        ISIZE = NUMPTS*2
        CALL JMEMHAN( 11, IDWORK, ISIZE, 1, IRET)
        IF( IRET.NE.0 ) THEN
          CALL INTLOG(JP_ERROR,'INTFAU: memory allocation fail',IDWORK)
          INTFAU = JPROUTINE + 1
          GOTO 900
        ENDIF
C
C       (Note the multiplication by 2 for REAL*8).
C
        ISIZE = JPLEN*2
        CALL JMEMHAN( 15, IDATA, ISIZE, 1, IRET)
        IF( IRET.NE.0 ) THEN
          CALL INTLOG(JP_ERROR,'INTFAU: memory allocation fail',IDATA)
          INTFAU = JPROUTINE + 2
          GOTO 900
        ENDIF
C
        CALL INTLOG(JP_DEBUG,'INTFAU: Rotate SH field.',JPQUIET)
        CALL INTLOG(JP_DEBUG,'INTFAU: South pole latitude  ',NOROTA(1))
        CALL INTLOG(JP_DEBUG,'INTFAU: South pole longitude ',NOROTA(2))
        IF ( NOREPR.EQ.JPSPHERE )  NOREPR = JPSPHROT
        IF ( NOREPR.EQ.JPREGULAR )  NOREPR = JPREGROT
        ITRUNC = NIRESO
#if (defined REAL_8)
        DLAT = -90.0 - REAL(NOROTA(1))/JPMULT
        DLON = - REAL(NOROTA(2))/JPMULT
C
C       Rotate the spectral field by longitude.
        CALL RPHI( ZNFELDI, ITRUNC, DWORK, DLON)
C
C       Rotate the spectral field by latitude.
        LOK = JACOBI( ZNFELDI, ITRUNC, DWORK, DLAT)
#else
        DLAT = -90.0 - DBLE(NOROTA(1))/JPMULT
        DLON = - DBLE(NOROTA(2))/JPMULT
C
C       Expand spectral coefficients to REAL*8
C
        DO LOOP = 1, NUMPTS
          DATA(LOOP) = DBLE(ZNFELDI(LOOP))
        ENDDO
C
C       Rotate the spectral field by longitude.
        CALL RPHI( DATA, ITRUNC, DWORK, DLON)
C
C       Rotate the spectral field by latitude.
C
        LOK = JACOBI( DATA, ITRUNC, DWORK, DLAT)
#endif
        IF(.NOT.LOK) THEN
          CALL INTLOG(JP_ERROR,'INTFAU: Spectral rotation fail',JPQUIET)
          INTFAU = JPROUTINE + 3
          GOTO 900
        ENDIF
#if (!defined REAL_8)
C
C       Repack spectral coefficients to REAL*4.
C
        DO LOOP = 1, NUMPTS
          ZNFELDI(LOOP) = SNGL(DATA(LOOP))
        ENDDO
#endif
C
      ENDIF
C
C ------------------------------------------------------------------
C*    Section 4.   Handle gaussian rotation, if necessary.
C ------------------------------------------------------------------
C
  400 CONTINUE
C
C     Is the interpolation from gaussian with a rotation of the
C     gaussian first?
C
      IF( ((NIREPR.EQ.JPGAUSSIAN).OR.(NIREPR.EQ.JPQUASI)) .AND.
     X    LNOROTA ) THEN
C
        CALL INTLOG(JP_DEBUG,'INTFAU: Rotate gaussian field.',JPQUIET)
        CALL INTLOG(JP_DEBUG,'INTFAU: South pole latitude  ',NOROTA(1))
        CALL INTLOG(JP_DEBUG,'INTFAU: South pole longitude ',NOROTA(2))
        IF ( NOREPR.EQ.JPGAUSSIAN )  NOREPR = JPFGGROT
        IF ( NOREPR.EQ.JPQUASI )     NOREPR = JPQGGROT
C
C       Dynamically allocate memory for workspace.
C
        NUMPTS = INLEN
        ISIZE  = NUMPTS
        CALL JMEMHAN( 11, ISWORK, ISIZE, 1, IRET)
        IF( IRET.NE.0 ) THEN
          CALL INTLOG(JP_ERROR,'INTFAU: memory allocation fail',ISWORK)
          INTFAU = JPROUTINE + 4
          GOTO 900
        ENDIF
C
C       Rotate the gaussian field.
C
        POLELAT = REAL(NOROTA(1))/JPMULT
        POLELON = REAL(NOROTA(2))/JPMULT
        NGAUSS = NIGAUSS
        IF( NIREPR.EQ.JPGAUSSIAN ) THEN
          HTYPE = 'F'
        ELSE
          HTYPE = 'R'
        ENDIF
        IRET=GGROTAT(ZNFELDI,SWORK,NUMPTS,POLELAT,POLELON,HTYPE,NGAUSS)
        IF( IRET.NE.0 ) THEN
          CALL INTLOG(JP_ERROR,'INTFAU: Gaussian rotation fail',JPQUIET)
          INTFAU = JPROUTINE + 5
          GOTO 900
        ENDIF
C
C       Move rotated field back into field original array.
C
        DO LOOP = 1, NUMPTS
          ZNFELDI(LOOP) = SWORK(LOOP)
        ENDDO
        OUTLROT = NUMPTS
C
      ENDIF
C
C
C ------------------------------------------------------------------
C*    Section 9.   Closedown.
C ------------------------------------------------------------------
C
  900 CONTINUE
C
C     Clear change flags for next product processing
C
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE GET_FREE_UNIT(KUNIT)
C
C**** *CTABLE*
C
C
C     PURPOSE.
C     --------
C        Get free unit number  
C         
C
C**   INTERFACE.
C     ----------
C          NONE.
C
C
C
C
C     *METHOD.
C      -------
C          NONE.
C
C
C
C     EXTERNALS.
C     ----------
C          NONE.
C
C
C
C
C     REFERENCE.
C     ----------
C
C
C     AUTHOR.

C          M. DRAGOSAVAC       *ECMWF*       JANUARY 2008.
C
C
C     MODIFICATIONS.
C     --------------
C
C          NONE.
C
C
      IMPLICIT LOGICAL(L,O,G), CHARACTER*8(C,H,Y)

C
      DO I=10,300
         INQUIRE(UNIT=i,IOSTAT=IOS,OPENED=OPENED)
         IF(.NOT.OPENED) THEN
            KUNIT=I
            GO TO 100
         END IF
      END DO
100   CONTINUE
      END 

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE YROTATE(RANGLE,X,Y,Z,RX,RY,RZ,INROW)
C---->
C**** YROTATE
C
C     Purpose
C     -------
C
C     Rotate an array of (x,y,z) values about the y-axis.
C
C
C     Interface
C     ---------
C
C     CALL YROTATE(RANGLE,X,Y,Z,RX,RY,RZ,INROW)
C
C     Input
C     -----
C
C     RANGLE  - The angle of rotation (degrees)
C     (X,Y,Z) - Arrays of input (x,y,z) values.
C     INROW   - Number of coordinate values.
C
C
C     Output
C     ------
C
C     (RX,RY,RZ) - Arrays of rotated (x,y,z) values.
C
C
C     Method
C     ------
C
C     Y remains unchanged.
C
C
C     Externals
C     ---------
C
C     None.
C
C
C     Author
C     ------
C
C     J.D.Chambers     ECMWF
C
C----<
C
      IMPLICIT NONE
C
C     Subroutine arguments
C
      REAL RANGLE,X,Y,Z,RX,RY,RZ
      DIMENSION X(*),Y(*),Z(*),RX(*),RY(*),RZ(*)
      INTEGER INROW
C
C     Local variables
C
      REAL FACTOR, ANGLE, SINA, COSA
      DATA FACTOR/0.017453293/
      INTEGER LOOP
C
      ANGLE = RANGLE * FACTOR
      SINA  = SIN(ANGLE)
      COSA  = COS(ANGLE)
C
      DO LOOP = 1, INROW
        RY(LOOP) = Y(LOOP)
        RX(LOOP) =  X(LOOP)*COSA + Z(LOOP)*SINA
        RZ(LOOP) = -X(LOOP)*SINA + Z(LOOP)*COSA
      ENDDO
C
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C


      SUBROUTINE GETFPD (KFPD,PFPD,KLEN,KARAY,KPR,KRET)
C
C---->
C**** GETFPD - Extract data from unpacked GRIB record.
C
C     Purpose.
C     --------
C
C           Get floating point data from record of unpacked GRIB
C           or Pseudo-grib data.
C
C**   Interface.
C     ----------
C
C           CALL GETFPD (KFPD,PFPD,KLEN,KARAY,KPR,KRET)
C
C           INTEGER    K.
C           REAL       P.
C           LOGICAL    O.
C           CHARACTER  H.
C
C               Input parameters.
C               -----------------
C
C               PFPD       - Array to receive floating point data.
C               KLEN       - Length of this array.
C               KARAY      - Array containing unpacked record.
C
C
C               KPR        - Debug print switch.
C                            0 , No printout.
C                            1 , Debug printout.
C
C               KRET       - Abort/no abort when error found.
C                            0   , Abort if error found.
C                            Non-zero , no abort on error.
C
C               Output parameters.
C               ------------------
C
C               KRET       - Error return code.
C                            0   , No error encountered.
C                            1   , Target array too small.
C
C               PFPD       - Floating point data.
C               KFPD       - Number of values in this array.
C
C     Method.
C     -------
C
C           Unpacked data is in self-defining records. The required
C           values are located and extracted.
C
C     Externals.
C     ----------
C
C           None.
C
C     Reference.
C     ----------
C
C           See MARS format documentation re GRIB, Pseudo-grib and
C           unpacked record formats.
C
C     Comments.
C     ---------
C
C           Routine contains sections 0 to 2 and section 9.
C
C     Author.
C     -------
C
C           J. Hennessy      ECMWF      18:06:86.
C
C     Modifications
C     --------------
C
C           None.
C
C     ----------------------------------------------------------------
C---->
C
C
C
C
C
C
C
C
C
C
C*    SECTION 0 . DEFINITION OF VARIABLES.
C     ----------------------------------------------------------------
C
      IMPLICIT LOGICAL     ( L, O, G )
      IMPLICIT CHARACTER*8 ( C, H, Y )
      IMPLICIT INTEGER     ( I, J, K, M, N )
C
      DIMENSION KARAY(*)
      DIMENSION PFPD(KLEN)
C
      EQUIVALENCE (IVAL,ZVAL)
C
C     ----------------------------------------------------------------
C
C
C
C
C
C
C
C
C
C*    SECTION 1 . SET INITIAL VALUES. CHECK INPUT PARAMETERS.
C     ----------------------------------------------------------------
C
 1000 CONTINUE
C
      IF (KPR.EQ.1) WRITE (*,*) 'GETFPD : SECTION 1.'
C
      IRET = KRET
      KRET = 0
C
C
C*    GO TO SECTION 9 , IF ERROR IN PARAMETERS.
C
      IF (KRET.NE.0) GO TO 9000
C
C     ----------------------------------------------------------------
C
C
C
C
C
C
C
C
C
C*    SECTION 2 . LOCATE AND EXTRACT VALUES.
C     ----------------------------------------------------------------
C
 2000 CONTINUE
C
      IF (KPR.EQ.1) WRITE (*,*) 'GETFPD : SECTION 2.'
C
      ILB1 = KARAY(2)
      ILB2 = KARAY(2+ILB1+1)
      ILF2 = KARAY(2+ILB1+1+ILB2+1)
      ILB3 = KARAY(2+ILB1+1+ILB2+1+ILF2+1)
      ILCD = KARAY(2+ILB1+1+ILB2+1+ILF2+1+ILB3+1)
      KFPD = KARAY(2+ILB1+1+ILB2+1+ILF2+1+ILB3+1+ILCD+1)
C
      IF (KLEN.LT.KFPD)
     C   THEN
             KRET = 1
             WRITE (*,9001) KRET , KFPD
             GO TO 9000
         ENDIF
C
      DO 2010 J=1,KFPD
         IVAL    = KARAY(J+2+ILB1+1+ILB2+1+ILF2+1+ILB3+1+ILCD+1)
         PFPD(J) = ZVAL
 2010 CONTINUE
C
C
C     ----------------------------------------------------------------
C
C
C
C
C
C
C
C*    SECTION 9 . RETURN TO CALLING ROUTINE OR ABORT. FORMAT STATEMENTS.
C     ------------------------------------------------------------------
C
 9000 CONTINUE
C
      IF (KPR.EQ.1) WRITE (*,*) 'GETFPD : SECTION 9.'
C
      IF (KRET.NE.0.AND.IRET.EQ.0) CALL ABORT
C
      RETURN
C
C
 9001 FORMAT (1H ,'GETFPD : ERROR CODE = ',I3,'. TARGET ARRAY MUST ',
     C            'BE AT LEAST ',I5,' WORDS LONG.')
C
C
C     ---------------------------------------------------------------
C
C
      END
C

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities
C granted to it by virtue of its status as an intergovernmental organisation
C nor does it submit to any jurisdiction.
C

      SUBROUTINE INXBIT (KGRIB,KLENG,KNSPT,KPARM,KNUM,KBIT,
     C                   KBLEN,HFUNC,KRET)
C
C---->
C**** INXBIT - Insert/extract bits consecutively in/from a given array
C
C     Purpose.
C     --------
C
C     Take rightmost KBLEN bits from KNUM words of KPARM
C     and insert them consecutively in KGRIB, starting at
C     bit after KNSPT or vice versa.
C
C**   Interface.
C     ----------
C
C     CALL INXBIT (KGRIB,KLENG,KNSPT,KPARM,KNUM,KBIT, KBLEN,KRET)
C
C
C     Input Parameters.
C     -----------------
C
C     KGRIB      - Array containing bitstream.
C     KLENG      - Length (words) of this array.
C     KNSPT      - Bit number after which insertion/extraction starts.
C     KPARM      - Array from which bits are taken for
C                  insertion in the bitstream or to which
C                  bits are extracted from the bitstream.
C     KBIT       - Number of bits in computer word.
C     KNUM       - Number of bit fields inserted/extracted.
C     KBLEN      - Number of bits per bit field.
C     HFUNC      - Requested function.
C                  'C' to insert bits in bitstream,
C                  'D' to extract bits from bitstream.
C
C     Output Parameters.
C     ------------------
C
C     KNSPT      - Bit number of last bit inserted/extracted.
C
C     KRET       - Return code.
C                  0 , No error encountered.
C                  1 , Insertion/extraction exceeded array boundary.
C
C     Method.
C     -------
C
C     Word and offset pointer calculated before calling
C     insertion/extraction routines.
C
C     Externals.
C     ----------
C
C
C     Reference.
C     ----------
C
C     ECLIB documentation on SBYTES and GBYTES.
C
C     Comments.
C     ---------
C
#if (defined CRAY) || (defined __uxp__ ) || (defined IBM_POWER4)
C     Vectorized Fortran version of routine.
C     This routine contains a call to GSBITE, a vectorising
C     version of GBYTE(S) and SBYTE(S).
#else
C     Generic version of routine.
#endif
C     Author.
C     -------
C
C     J. Hennessy      ECMWF      18.06.91
C
C     Modifications.
C     --------------
C
C     J. Hennessy      ECMWF      08.11.91
C     Parameter KMACH removed from list of input parameters.
C
C     J. Hennessy      ECMWF      12.10.92
C     Dimension of IMASK changed from 64 to 65.
C
C     J.D.Chambers     ECMWF      21.05.96
C     Defines put in for Fujtsu.
C
C----<
C     ----------------------------------------------------------------
C*    Section 0 . Definition of variables. Data statements.
C     ----------------------------------------------------------------
C
      IMPLICIT NONE
C
#include "common/grprs.h"
C
      CHARACTER*1 HFUNC
      INTEGER IND, IOFF, IWORD
      INTEGER KBIT, KBLEN, KGRIB, KLENG, KNSPT, KNUM, KPARM, KRET
#ifdef DEBUG
      INTEGER INUM, J901
#endif
C
      DIMENSION KGRIB(KLENG)
      DIMENSION KPARM(*)
#if (defined CRAY) || (defined __uxp__ ) || (defined IBM_POWER4)
      INTEGER IMASK
      DIMENSION IMASK(65)
C
C     Values in IMASK are set in the first call to routine GSBITE, and
C     are used in subsequent calls.
C
      SAVE IMASK
C
C     Force routine GSBITE to calculate bit-masks first time through.
C
      DATA IMASK(2) /0/
#endif
C
C     ----------------------------------------------------------------
C*    Section 1 . Set initial values.
C     ----------------------------------------------------------------
C
  100 CONTINUE
C
#ifdef DEBUG
      WRITE(GRPRSM,*) 'INXBIT: Input values used -'
      WRITE(GRPRSM,*) 'KLENG = ', KLENG
      WRITE(GRPRSM,*) 'KNSPT = ', KNSPT
      WRITE(GRPRSM,*) 'KBIT = ', KBIT
      WRITE(GRPRSM,*) 'HFUNC = ', HFUNC
#endif
C
      KRET = 0
C
C     ----------------------------------------------------------------
C*    Section 2 . Bit insertion/extraction.
C     ----------------------------------------------------------------
C
  200 CONTINUE
C
C*    Calculate word pointer and offset.
C
      IWORD = KNSPT / KBIT
      IOFF  = KNSPT - IWORD * KBIT
      IWORD = IWORD + 1
#ifdef DEBUG
      WRITE(GRPRSM,*) 'INXBIT: Word is ',IWORD,', bit offset is ',IOFF
#endif
C
C     Insert/extract bits.
C
#if (defined CRAY) || (defined __uxp__ ) || (defined IBM_POWER4)
      IF (KNUM.GE.8) THEN
C
C       Vectorising routine GSBITE performs the same
C       functions as SBYTE(S) and GBYTE(S).
C
        CALL GSBITE (KGRIB(IWORD),KPARM,IOFF,KBLEN,0,KNUM,
     X                    KBIT,IMASK,HFUNC)
      ELSE
C
C       Scalar faster.
C
        IF (HFUNC.EQ.'C') THEN
          CALL SBYTES (KGRIB(IWORD),KPARM,IOFF,KBLEN,0,KNUM)
        ELSE
          CALL GBYTES (KGRIB(IWORD),KPARM,IOFF,KBLEN,0,KNUM)
        ENDIF
      ENDIF
#elif (defined CYBER)
      IF (HFUNC.EQ.'C') THEN
        CALL SBYTES6 (KGRIB(IWORD),KPARM,IOFF,KBLEN,0,KNUM)
      ELSE
        CALL GBYTES6 (KGRIB(IWORD),KPARM,IOFF,KBLEN,0,KNUM)
      ENDIF
#elif (defined IBM) || (defined VAX)
      IF (HFUNC.EQ.'C') THEN
        CALL SBYTES (KGRIB(IWORD),KPARM,IOFF,KBLEN,0,KNUM)
      ELSE
        CALL GBYTES (KGRIB(IWORD),KPARM,IOFF,KBLEN,0,KNUM)
      ENDIF
#else
      IF (HFUNC.EQ.'C') THEN
        CALL SBYTES (KGRIB(IWORD),KPARM,IOFF,KBLEN,0,KNUM)
      ELSE
        CALL GBYTES (KGRIB(IWORD),KPARM,IOFF,KBLEN,0,KNUM)
      ENDIF
#endif
C
C     Update pointer.
C
      KNSPT = KNSPT + KBLEN * KNUM
C
C     ----------------------------------------------------------------
C*    Section 3 . Check out of range.
C    -----------------------------------------------------------------
C
  300 CONTINUE
C
      IND = KNSPT / KBIT
      IF (IND.GT.KLENG) THEN
        KRET = 1
        WRITE(GRPRSM,*) 'INXBIT : Word ', IND ,
     X              ' is outside array bounds ', KLENG
      ENDIF
C
C     ----------------------------------------------------------------
C*    Section 9 . Return to calling routine.
C     ----------------------------------------------------------------
C
  900 CONTINUE
C
#ifdef DEBUG
      INUM = KNUM
      IF( INUM.GT.360 ) THEN
        INUM = 360
        WRITE(GRPRSM,*) 'First ', INUM,' values.'
      ENDIF
      DO 901 J901=1,INUM
        IF( HFUNC.EQ.'C' ) THEN
          WRITE(GRPRSM,*) 'Inserted value = ', KPARM(J901)
        ELSE
          WRITE(GRPRSM,'(1H ,Z)') KGRIB(IWORD)
          WRITE(GRPRSM,*) 'Extracted value = ', KPARM(J901)
          WRITE(GRPRSM,'(1H ,Z)') KPARM(J901)
        ENDIF
  901 CONTINUE
      WRITE(GRPRSM,*) '         Output values set -'
      WRITE(GRPRSM,*) 'KNSPT = ', KNSPT
#endif
C
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      INTEGER FUNCTION DSVSEC2(KGRIB,KLENG,INSPT,KSEC2,IBITS,ILEN2)
C
C---->
C**** DSVSEC2P
C
C     PURPOSE
C     _______
C
C     Decodes GRIB section 2 values for space view fields.
C
C     INTERFACE
C     _________
C
C     IRET = DSVSEC2(KGRIB,KLENG,INSPT,KSEC2,IBITS)
C
C     Input parameters
C     ________________
C
C     KGRIB   - GRIB product unpacked so far (upto octet 6). 
C     KLENG   - Length of KGRIB.
C     INSPT   - Bit position of GRIB product unpacked so far.
C     KSEC2   - GRIB section 2 description.
C     IBITS   - Number of bits per element in KGRIB.
C     ILEN2   - Length in bytes of section 2
C     
C
C     Output parameters
C     ________________
C
C     KSEC2   - Updated GRIB section 2 description.
C     INSPT   - Updated bit position of GRIB product built so far.
C     IRET    - Function return status code, 0 = OK
C
C     Common block usage
C     __________________
C
C     None.
C
C     Method
C     ______
C
C     Unpacks values given in KGRIB into KSEC2 and updates bit
C     pointer INSPT.
C
C     Externals
C     _________
C
C     DSGNBT  - Get the sign bit and adjust value to +/-.
C     INXBIT  - Insert bit data.
C
C
C     AUTHOR
C     ______
C
C     J.D.Chambers       ECMWF     February 1999
C
C     MODIFICATIONS
C     _____________
C
C     None.
C
C----<
C     _______________________________________________________
C
C     Section 0. Definition of variables.
C     _______________________________________________________
C
      IMPLICIT NONE
C
#include "common/grprs.h"
C
C     Parameters
C
      INTEGER JP16SET
      PARAMETER ( JP16SET = 2**16 - 1 ) 
C                            ^---> 65535    =   FFFF(hex)
C
C     Function arguments
C
      INTEGER KGRIB,KLENG,INSPT,KSEC2,IBITS,ILEN2
      DIMENSION KGRIB(*),KSEC2(*)
C
C     Local variables
C
      INTEGER ILALO(2), IRET, IRESOL
C
C     _______________________________________________________
C
C     Section 1.    Initialization.
C     _______________________________________________________
C
  100 CONTINUE
C
      DSVSEC2 = 0
C
C     _______________________________________________________
C
C     Section 2.    Unpack section 2 octets.
C     _______________________________________________________
C
  200 CONTINUE
C
C      Octets 7 - 8  : Nx - number of points along X-axis.
C      Octets 9 - 10 : Ny - number of points along Y-axis.
C      Two 16 bit fields.
C 
       CALL INXBIT(KGRIB,KLENG,INSPT,KSEC2(2),2,IBITS, 16,'D',IRET)
       IF( IRET.NE.0 ) THEN
         DSVSEC2 = 1
         WRITE(GRPRSM,*) 'DSVSEC2: Error extracting'
         WRITE(GRPRSM,*) 'DSVSEC2: number of points along X or Y axis.'
         WRITE(GRPRSM,*) 'DSVSEC2: Return code = ', IRET
         GO TO 900
       ENDIF
C 
C      Octets 11 - 13 : Lap - latitude of sub-satellite point.
C      Octets 14 - 16 : Lop - longitude of sub-satellite point.
C      Two 24 bit fields.
C 
       CALL INXBIT(KGRIB,KLENG,INSPT,ILALO(1),2,IBITS, 24,'D',IRET)
       IF( IRET.NE.0 ) THEN
         DSVSEC2 = 1
         WRITE(GRPRSM,*) 'DSVSEC2: Error extracting'
         WRITE(GRPRSM,*)
     X     'DSVSEC2: latitude/longitude of sub-satellite pt.'
         WRITE(GRPRSM,*) 'DSVSEC2: Return code = ', IRET
         GO TO 900
       ENDIF
C 
C      If sign bit is 1, value is negative.
C 
       CALL DSGNBT( KSEC2(4), ILALO(1), 24, IRET)
       CALL DSGNBT( KSEC2(5), ILALO(2), 24, IRET)
C 
C      Octet 17 : Resolution and components flag.
C      One 8 bit field.
C 
       CALL INXBIT(KGRIB,KLENG,INSPT,IRESOL,1,IBITS, 8,'D',IRET)
       IF( IRET.NE.0 ) THEN
         DSVSEC2 = 1
         WRITE(GRPRSM,*) 'DSVSEC2: Error extracting'
         WRITE(GRPRSM,*) 'DSVSEC2: components flag.'
         WRITE(GRPRSM,*) 'DSVSEC2: Return code = ', IRET
         GO TO 900
       ENDIF
C 
C      All flag fields are already set to 0, so
C
       IF( IRESOL.EQ.0 ) GO TO 214
C
C      Resolution flag is not applicable.
C
       IF( IRESOL.GE.128) IRESOL = IRESOL - 128
C
C      Set earth flag.
C
       IF( IRESOL.GE.64) THEN
         KSEC2(18) = 64
         IRESOL    = IRESOL - 64
       ENDIF
C 
C      Set components flag.
C 
       KSEC2(19) = IRESOL
C 
  214  CONTINUE
C 
C      Octets 18 - 20 : dx Apparent diameter of earth in grid
C                       lengths in x direction.
C      Octets 21 - 23 : dy Apparent diameter of earth in grid
C                       lengths in y direction.
C      Two 24 bit fields.
C 
       CALL INXBIT(KGRIB,KLENG,INSPT,KSEC2(7),2,IBITS, 24,'D',IRET)
       IF( IRET.NE.0 ) THEN
         DSVSEC2 = 1
         WRITE(GRPRSM,*) 'DSVSEC2: Error extracting'
         WRITE(GRPRSM,*) 'DSVSEC2: number of points along X or Y axis.'
         WRITE(GRPRSM,*) 'DSVSEC2: Return code = ', IRET
         GO TO 900
       ENDIF
C 
C      Octets 24 - 25 : Xp X-coordinate of sub-satellite point.
C      Octets 26 - 27 : Yp Y-coordinate of sub-satellite point.
C      Two 16 bit fields.
C 
       CALL INXBIT(KGRIB,KLENG,INSPT,KSEC2(9),2,IBITS, 16,'D',IRET)
       IF( IRET.NE.0 ) THEN
         DSVSEC2 = 1
         WRITE(GRPRSM,*) 'DSVSEC2: Error extracting'
         WRITE(GRPRSM,*)
     X     'DSVSEC2: X or Y coordinate of sub-satellite point.'
         WRITE(GRPRSM,*) 'DSVSEC2: Return code = ', IRET
         GO TO 900
       ENDIF
C 
C      Octet 28 : Scanning mode flags.
C      One 8 bit field.
C 
       CALL INXBIT(KGRIB,KLENG,INSPT,KSEC2(11),1,IBITS, 8,'D',IRET)
       IF( IRET.NE.0 ) THEN
         DSVSEC2 = 1
         WRITE(GRPRSM,*) 'DSVSEC2: Error extracting'
         WRITE(GRPRSM,*) 'DSVSEC2: scanning mode flags.'
         WRITE(GRPRSM,*) 'DSVSEC2: Return code = ', IRET
         GO TO 900
       ENDIF
C 
C     Octets 29 - 31 : The orientation of the grid.
C     Octets 32 - 34 : nr the altitude of the camera.
C     Two 24 bit fields.
C 
      CALL INXBIT(KGRIB,KLENG,INSPT,KSEC2(13),2,IBITS, 24,'D',IRET)
      IF( IRET.NE.0 ) THEN
        DSVSEC2 = 1
        WRITE(GRPRSM,*) 'DSVSEC2: Error extracting'
        WRITE(GRPRSM,*)
     X     'DSVSEC2: orientation of the grid or camera angle.'
        WRITE(GRPRSM,*) 'DSVSEC2: Return code = ', IRET
        GO TO 900
      ENDIF
C 
C     Octets 35 - 36 : Xo - X coordinate of origin of sector
C                             image.
C     Octets 37 - 38 : Yo - Y coordinate of origin of sector
C                             image.
C     Two 16 bit fields.
C 
      CALL INXBIT(KGRIB,KLENG,INSPT,KSEC2(15),2,IBITS, 16,'D',IRET)
      IF( IRET.NE.0 ) THEN
        DSVSEC2 = 1
        WRITE(GRPRSM,*) 'DSVSEC2: Error extracting'
        WRITE(GRPRSM,*)
     X     'DSVSEC2: X or Y coordinates of origin of sector.'
        WRITE(GRPRSM,*) 'DSVSEC2: Return code = ', IRET
        GO TO 900
      ENDIF
C
C     Octets 39 - 40 : Reserved (ECMWF).
C     Octets 39 - 44 : Reserved (GRIB specification).
C 
C     Update bit pointer.
C
      INSPT = INSPT + (ILEN2 - 38) * 8
C 
C     _______________________________________________________
C 
C     Section 9. Return to calling routine.
C     _______________________________________________________
C 
  900 CONTINUE
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      LOGICAL FUNCTION ISOCTAHEDRAL(KNUM,KPTS)
C
C---->
C**** *ISOCTAHEDRAL*
C
C     PURPOSE
C     _______
C
C     Check if KPTS (pl array) represents a octahedral progression series
C
C
C     Input parameters
C     ________________
C
C     KNUM - Gaussian grid number
C
C     KPTS - Array giving number of points at each gaussian 
C            latitude, both hemispheres (pl array)
C
C----<
      IMPLICIT NONE


C     Arguments
      INTEGER KNUM, KPTS(*)


C     Local variables
      INTEGER LOOP, IMAGE, NLAT
      CHARACTER*1 HTYPEO
      INTEGER QGOCT
      EXTERNAL QGOCT
      LOGICAL ISGGVALID
      EXTERNAL ISGGVALID


C     Check octahedral progression series
C     (symmetry is checked as well, return on first failure)
      HTYPEO = 'O'
      ISOCTAHEDRAL = ISGGVALID(HTYPEO,KNUM)
      IF( ISOCTAHEDRAL ) THEN
        DO LOOP = 1, KNUM
          IMAGE = 2 * KNUM - LOOP + 1
          NLAT  = QGOCT(LOOP)
          ISOCTAHEDRAL = ( NLAT.EQ.KPTS(LOOP)  )
     X             .AND. ( NLAT.EQ.KPTS(IMAGE) )
          IF( .NOT.ISOCTAHEDRAL ) GOTO 900
        ENDDO
      ENDIF

 900  CONTINUE
      ENDFUNCTION

C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      INTEGER FUNCTION SPROTAT(INGRIB,INLEN,SLON,SLAT,OUTGRIB,OUTLEN)
C
C---->
C**** SPROTAT
C
C     Purpose
C     -------
C
C     Rotates a spherical harmonic field.
C
C
C     Interface
C     ---------
C
C     IRET = SPROTAT(INGRIB,INLEN,SLON,SLAT,OUTGRIB,OUTLEN)
C
C     Input
C     -----
C
C     INGRIB  - Input GRIB field of spherical harmonics.
C     INLEN   - Length in bytes of the input GRIB.
C     SLON    - Longitude rotation required (degrees)
C     SLAT    - Latitude rotation required (degrees)
C
C
C     Output
C     ------
C
C     OUTGRIB  - Output GRIB field of rotated spherical harmonics.
C     OUTLEN   - Length in bytes of the output GRIB.
C
C     Function returns 0 if all OK, otherwise the rotation failed.
C
C
C     Method
C     ------
C
C     Externals
C     ---------
C
C     GRIBEX  - Decode/encode a GRIB product.
C     RPHI    - Rotates spectral coefficients by longitude.
C     JACOBI  - Rotates spectral coefficients by latitude.
C     INTLOG  - Logs messages.
C
C     Author
C     ------
C
C     J.D.Chambers         ECMWF     October, 1995.
C
C
C---------------------------------------------------------------------
C----<
C
      IMPLICIT NONE
#include "parim.h"
C
C     Parameters
      INTEGER JPROUTINE
      PARAMETER (JPROUTINE = 28300)
      INTEGER JPLEN, JPNM
      PARAMETER ( JPNM = JPSTRUNC )
      PARAMETER ( JPLEN = (JPNM+1)*(JPNM+2) )
C
C     Function arguments.
      INTEGER INGRIB, INLEN, OUTGRIB, OUTLEN
      DIMENSION INGRIB(*), OUTGRIB(*)
      REAL SLON, SLAT
C
C     Local variables
      INTEGER KSEC0, KSEC1, KSEC2, KSEC3, KSEC4, KWORD, KLENP, KLENG
      DIMENSION KSEC0(2),KSEC1(512),KSEC2(512),KSEC3(2),KSEC4(512)
      REAL PSEC4, PSEC2, PSEC3
      DIMENSION PSEC2(512),PSEC3(2),PSEC4(JPLEN)
      REAL*8 DLON, DLAT
      REAL*8 WORK
      DIMENSION WORK(2*(JPNM+1)*(JPNM+6))
      INTEGER ITRUNC, IRET, NBYTES, LOOP
      LOGICAL LOK
      REAL*8 DATA
      DIMENSION DATA(JPLEN)
C
      DATA NBYTES/4/
C
C     Externals
      LOGICAL JACOBI
      EXTERNAL JACOBI
C
C     _______________________________________________________
C
C*    Section 1. Initialise.
C     _______________________________________________________
C
  100 CONTINUE
C
      SPROTAT = 0
      IRET    = 0
#if (defined REAL_8)
      DLON = SLON
      DLAT = -90.0 - SLAT
#else
      DLON = DBLE(SLON)
      DLAT = -90.0 - DBLE(SLAT)
#endif
C
C     Decode the field.
      KLENP = JPLEN
      KLENG = (INLEN+NBYTES-1)/NBYTES
      IRET  = 1
      CALL GRIBEX(KSEC0, KSEC1, KSEC2, PSEC2, KSEC3, PSEC3, KSEC4, 
     X            PSEC4, KLENP, INGRIB, KLENG, KWORD, 'D' , IRET )
      IF(IRET.NE.0)THEN
        CALL INTLOG(JP_FATAL,'SPROTAT: Error decoding GRIB,IRET=', IRET)
        SPROTAT = JPROUTINE + 1
        GOTO 900
      ENDIF
C
C     Check that it really is a spherical harmonic field.
      IF( (KSEC2(1).NE.50) .AND. (KSEC2(1).NE.60) ) THEN
        CALL INTLOG(JP_FATAL,'SPROTAT: GRIB field not spectral',JPQUIET)
        CALL INTLOG(JP_FATAL,'SPROTAT: GRIB KSEC2(1) = ', KSEC2(1))
        SPROTAT = JPROUTINE + 2
        GOTO 900
      ENDIF
C
      ITRUNC = KSEC2(2)
C
C     _______________________________________________________
C
C*    Section 2. Rotate the spectral coefficients.
C     _______________________________________________________
C
  200 CONTINUE
C
#if (defined REAL_8)
C*********************************************************************
C
C     (REALs are already double precision)
C
C     Rotate the spectral field by longitude.
C     Positive DLON => frame rotated from west to east.
C
      CALL RPHI( PSEC4, ITRUNC, WORK, DLON)
C
C     Rotate the spectral field by latitude.
C     Negative DLAT => rotate counter-clockwise about new polar axis.
C
      LOK = JACOBI ( PSEC4, ITRUNC, WORK, DLAT)
#else
C*********************************************************************
C
C     (REALs are single precision)
C
C     Expand spectral coefficients to REAL*8
      DO 210 LOOP = 1, KSEC4(1)
        DATA(LOOP) = DBLE(PSEC4(LOOP))
  210 CONTINUE
C
C     Rotate the spectral field by longitude.
C     Positive DLON => frame rotated from west to east.
C
      CALL RPHI( DATA, ITRUNC, WORK, DLON)
C
C     Rotate the spectral field by latitude.
C     Negative DLAT => rotate counter-clockwise about new polar axis.
C
      LOK = JACOBI ( DATA, ITRUNC, WORK, DLAT)
      IF(.NOT.LOK) THEN
        CALL INTLOG(JP_FATAL,'SPROTAT: JACOBI failed.', JPQUIET)
        SPROTAT = JPROUTINE + 3
        GOTO 900
      ENDIF
C
C     Repack spectral coefficients to REAL*4.
      DO 220 LOOP = 1, KSEC4(1)
        PSEC4(LOOP) = SNGL(DATA(LOOP))
  220 CONTINUE
C*********************************************************************
#endif
C
C     _______________________________________________________
C
C*    Section 3. Repack the spectral coefficients.
C     _______________________________________________________
C
  300 CONTINUE
C
C     Put in details of southern pole of rotation
      KSEC2(13) = NINT(SLAT*1000.0)
      KSEC2(14) = NINT(SLON*1000.0)
C
C     Put in indicator to show field has been rotated ..
      KSEC2(1) = 60
C
C     .. unless south pole of rotation is (0,-90).
      IF( (KSEC2(14).EQ.0) .AND. (KSEC2(13).EQ.-90000) ) KSEC2(1) = 50
C
C     Encode the field.
      KLENP = KSEC4(1)
      KLENG = (OUTLEN+NBYTES-1)/NBYTES
      IRET  = 1
      CALL GRIBEX(KSEC0, KSEC1, KSEC2, PSEC2, KSEC3, PSEC3, KSEC4, 
     X            PSEC4, KLENP, OUTGRIB, KLENG, KWORD, 'C' , IRET )
      IF(IRET.NE.0)THEN
        CALL INTLOG(JP_FATAL,'SPROTAT: Error encoding GRIB,IRET=', IRET)
        SPROTAT = JPROUTINE + 4
        GOTO 900
      ENDIF
      OUTLEN = KSEC0(1)
C
C     _______________________________________________________
C
C*    Section 9. Return.
C     _______________________________________________________
C
  900 CONTINUE
C
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      PROGRAM GRDEMO
C
      IMPLICIT NONE
C
C---->
C**** GRDEMO - Program to demonstrate use of GRIBEX routine.
C
C     Purpose.
C     --------
C
C     Demonstrates use of GRIBEX routine to unpack
C     GRIB coded data.
C
C**   Interface.
C     ----------
C
C     File of GRIB coded data in "datafile".
C
C     Method.
C     -------
C
C     Prints sections 0, 1, 2, 3 and 4 of GRIB message.
C
C     Externals.
C     ----------
C
C     GRIBEX
C     GRPRS0
C     GRPRS1
C     GRPRS2
C     GRPRS3
C     GRPRS4
C     PBOPEN
C     PBGRIB
C     PBCLOSE
C
C     Reference.
C     ----------
C
C     WMO Manual on Codes for GRIB definition.
C     WMO Publication No. 9, Volume B, for grid catalogue numbers.
C
C     Comments.
C     ---------
C
C     GRIBEX provides a number of packing/unpacking options.
C     See documentation for details.
C
C
C     -----------------------------------------------------------------
C----<
C
C     Arrays are dimensioned to accommodate T213/N160 data volumes.
C
      INTEGER JPACK
      PARAMETER (JPACK=70000)
      INTEGER ISEC0, ISEC1, ISEC2, ISEC3, ISEC4
C
C     Array for integer parameters from section 0 of GRIB message.
C
      DIMENSION ISEC0(2)
C
C     Array for integer parameters from section 1 of GRIB message.
C
      DIMENSION ISEC1(1024)
C
C     Array for integer parameters from section 2 of GRIB message.
C
      DIMENSION ISEC2(1024)
C
C     Array for integer parameters from section 3 of GRIB message.
C
      DIMENSION ISEC3(2)
C
C     Array for integer parameters from section 4 of GRIB message.
C
      DIMENSION ISEC4(512)
C
      REAL ZSEC2, ZSEC3, ZSEC4
C
C     Array for real parameters from section 2 of GRIB message.
C
      DIMENSION ZSEC2(512)
C
C     Array for real parameters from section 3 of GRIB message.
C
      DIMENSION ZSEC3(2)
C
C     Array for real parameters from section 4 of GRIB message.
C     This is the binary data section and the array to hold the unpacked
C     data may need to be a number of times as long as that for the
C     packed data. Here it is set arbitrarily to four time longer.
C
      DIMENSION ZSEC4(JPACK*2)
C
C     Array to read in packed data.
C
      INTEGER INBUFF
      DIMENSION INBUFF(JPACK)
C
      INTEGER FILE, JCOUNT, NUMERR, IRET, IPUNP, IWORD
      INTEGER LOOP, LENOUT, ILENB
C
C     Clear counters.
C
      NUMERR = 0
      JCOUNT = 0
C
C     Open the data file
C
      CALL PBOPEN( FILE, "datafile", "R", IRET)
      IF( IRET.NE.0 ) THEN
        WRITE(*, *) 'Return code from PBOPEN = ',IRET
        CALL PBCLOSE(FILE, IRET)
        STOP 'Fault in PBOPEN'
      ENDIF
      ILENB = ILENB*4
C
C
C     Loop through GRIB products in file.
C
   50 CONTINUE
C
        JCOUNT = JCOUNT + 1
C
C       Read packed field into INBUFF.
C
        CALL PBSIZE(FILE, LENOUT)
        WRITE(*,*) 'Next GRIB field size = ', lenout
C
        ILENB = JPACK * 4
        CALL PBGRIB( FILE, INBUFF, ILENB, LENOUT, IRET )
        IF( IRET.LT.0 ) THEN
          WRITE(*, *) 'Return code from PBGRIB = ',IRET
          IF( IRET.EQ.-1 ) THEN
            WRITE(*, *) 'End of file. Number of products = ',(JCOUNT-1)
            CALL PBCLOSE(FILE, IRET)
            WRITE(*,*) 'Number of decoding errors = ',NUMERR
            STOP 'EOF'
          ELSE
            WRITE(*, *)
     X        'Return code = ',IRET,' after ',JCOUNT,' products.'
            CALL PBCLOSE(FILE, IRET)
            STOP 'Fault in PBGRIB'
          ENDIF
        ENDIF
        WRITE(*, *) 'Return length from PBGRIB = ',lenout
C
C       Decode the GRIB product.
C
        IRET = 1
        ILENB = JPACK
        IPUNP = JPACK * 4
        CALL GRIBEX(ISEC0,ISEC1,ISEC2,ZSEC2,ISEC3,ZSEC3,ISEC4,
     X              ZSEC4,IPUNP,INBUFF,ILENB,IWORD,'D',IRET)
C
C       Check the return code.
c
        WRITE(*,*) 'GRIBEX return code = ',IRET
        IF( IRET.EQ.-6 ) WRITE(*,*) 'Pseudo-grib data found.'
C
C       Update error count if necessary.
C
        IF( IRET.GT.0 ) THEN
          NUMERR = NUMERR + 1
          GOTO 50
        ENDIF
C
C       Print section 0, 1, 2 and 3 (if present) and 4.
C       Section 1 is the product definition section.
C       Section 2 is the grid definition section.
C       Section 3 is the bit-map section.
C       Section 4 is the data section.
C
        CALL GRPRS0(ISEC0)
        CALL GRPRS1(ISEC0,ISEC1)
C
        IF( (ISEC1(5).EQ.0).OR.(ISEC1(5).EQ.64) ) THEN
          WRITE(*,*) 'No section 2 in GRIB message.'
        ELSE
          CALL GRPRS2(ISEC0,ISEC2,ZSEC2)
        ENDIF
C
        IF( (ISEC1(5).EQ.0).OR.(ISEC1(5).EQ.128) ) THEN
          WRITE(*,*) 'No section 3 in GRIB message.'
        ELSE
          CALL GRPRS3(ISEC0,ISEC3,ZSEC3)
        ENDIF
C
        CALL GRPRS4(ISEC0,ISEC4,ZSEC4)
C
C       Print some vales
        DO LOOP = 1,ISEC4(1)
          WRITE(*,*) 'zsec4(', loop, ') = ', zsec4(loop)
        ENDDO
C
      GOTO 50
C
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      INTEGER FUNCTION C2ROWS ( KDATA,  KLENP,  KSEC2,  KSEC4,  KGRIB,
     X                          KLENG,  KNSPT,  KBITS,  OCOMGR, OLONLY,
     X                          KLEN4,  KBMAP,  KVALS,  OPRIBI, OQUASI,
     X                          KNROWS, KLEN,   KREFGR, KLENGR, KBITGR,
     X                          KWORK,  KLWORK, KPOWER, KMXPWR, KPCWID,
     X                          KXCWID, KNBIFO, ODEBUG )
C
C---->
C**** C2ROWS
C
C     Purpose.
C     --------
C
C     Performs "row by row packing" method for section 4 of GRIB,
C     and/or computes only length of section 4, with/without coding,
C     with this method.
C
C
C**   Interface.
C     ----------
C
C     KRET = C2ROWS ( KDATA,  KLENP,  KSEC2,  KSEC4,  KGRIB,  KLENG,
C    X                KNSPT,  KBITS,  OCOMGR, OLONLY, KLEN4,  KBMAP,
C    X                KVALS,  OPRIBI, OQUASI, KNROWS, KLEN,   KREFGR,
C    X                KLENGR, KBITGR, KWORK,  KLWORK, KPOWER, KMXPWR,
C    X                KPCWID, KXCWID, KNBIFO, ODEBUG )
C
C
C     Input Parameters for all options.
C     --------------------------------
C
C     KDATA      - Array of normalized values.
C     KLENP      - Length of array KDATA.
C     KSEC2      - Array of GRIB section 2 integer descriptors.
C     KSEC4      - Array of GRIB section 4 integer descriptors.
C     KGRIB      - Array containing GRIB product (for bit-map).
C     KLENG      - Length of GRIB product array.
C     KNSPT      - Bit pointer for next value in GRIB product.
C     KBITS      - Number of bits per computer word.
C     OCOMGR     - True if COMputing of GRoup arrays is requested.
C     OLONLY     - True if Length ONLY is requested (no coding).
C     KBMAP      - Bit pointer for start of explicit primary Bit-MAP
C                  (if any).
C     KVALS      - Number of bits in primary bit-map.
C     OPRIBI     - True if a PRImary BIt-map is present.
C     OQUASI     - True if the grid is QUASI-regular.
C     KNROWS     - Number of ROWS (or lines) in the grid.
C     KLEN       - Exact number of grid-points to handle.
C     KLWORK     - Length of work array KWORK.
C     KPOWER     - Auxilary array, containing precomputed powers of 2-1.
C     KMXPWR     - Maximum number of bits per original scaled value.
C     KPCWID     - Auxilary array, precomputed widths.
C     KXCWID     - Maximum width associated to KPCWID.
C     ODEBUG     - True for some debug printout.
C
C
C     Output Parameters for all options.
C     ---------------------------------
C
C     KLEN4      - Length of section 4.
C
C     Output Parameters when OLONLY is false.
C     --------------------------------------
C
C     KSEC4      - Array of GRIB section 4 integer descriptors.
C                  (for second-order descriptors)
C     KGRIB      - Array containing GRIB product.
C     KNSPT      - Bit pointer for next value in GRIB product (updated).
C     KWORK      - Used as work array by C2PACK.
C
C     Output Parameters when OCOMGR is true.
C     -------------------------------------
C
C     KWORK      - Work array, used to unpack a primary bit-map, if any.
C
C     Output Parameters when OCOMGR is true,
C      Input Parameters when OCOMGR is false.
C     --------------------------------------
C
C     KREFGR     - Work array, first-order values for each row.
C     KLENGR     - Work array, effective length of each row.
C     KBITGR     - Work array, bit number ("width") of each row.
C     KNBIFO     - Number of BIts for coding First-Order values.
C
C     Output Parameters when OCOMGR is true,
C      Input parameter in all cases.
C     --------------------------------------
C
C     KDATA      - Used as work array by C2PACK.
C
C     Method.
C     -------
C
C     Follows WMO Manual of Codes.
C
C     If requested through OCOMGR, a first scan computes work arrays,
C     bit number for coding first-order values and length of section 4.
C
C     If requested, coding is applied in a second scan, using
C     descriptors computed in the first scan, possibly in a previous
C     call.
C
C     Externals.
C     ----------
C
C     INXBIT    - Extract bits from GRIB product.
C     MAXMNI    - Computes extrema of integer array.
C     C2BITW    - Computes bit width of a positive integer value.
C     C2PACK    - Encodes descriptors and data.
C
C
C     Reference.
C     ----------
C
C     None.
C
C
C     Comments.
C     --------
C
C     On entry, KNSPT points to the first bit of section 4 
C               in the GRIB product.
C     On exit,  KNSPT points to the first unused bit of section 4,
C               (or to the first bit of section 5, if unused bit count
C                is zero) in the GRIB product.
C
C     KDATA is overwritten when coding is requested.
C     This is coherent with GRIBEX.
C
C
C     Author.
C     -------
C
C     J. Clochard, Meteo France, for ECMWF - January 1998.
C
C
C     Modifications.
C     _____________
C
C     J. Clochard, February 1998.
C     Use C2BITW function for bit width computations.
C
C     J. Clochard, September 1998.
C     Suppress KSEC1/KSEC3 dummy-arguments.
C         "    KSEC1, add KWORK/KPOWER/KMXPWR argument in C2PACK call.
C
C     J. Clochard, June 1999.
C     Use precomputed array to determine widths . Dummy-arguments
C     KPCWID and KXCWID added . Assumption is made that KXCWID
C     is at least (KMXPWR+1)/2 .
C
C
C----<
C     -----------------------------------------------------------------
C*    Section 0. Definition of variables.
C     -----------------------------------------------------------------
C
      IMPLICIT NONE
C
#include "common/grprs.h"
C
C     Subroutine arguments
C
      INTEGER KLENP, KLENG, KNSPT, KBITS, KBMAP, KVALS, KLEN4, KNROWS
      INTEGER KLEN, KLWORK, KMXPWR, KNBIFO, KXCWID
      INTEGER KDATA (KLENP), KSEC2 (*), KSEC4 (*), KPCWID (0:*)
      INTEGER KGRIB (KLENG), KREFGR (KNROWS), KLENGR (KNROWS)
      INTEGER KBITGR (KNROWS), KWORK (KLWORK), KPOWER (0:KMXPWR)
C
      LOGICAL OPRIBI, OQUASI, OLONLY, OCOMGR, ODEBUG
C
C     Local variables.
C
      INTEGER IREFLN, ICOUNT, INBITI, INBIFO, ILENSO, ILDSTA, IZERO
      INTEGER ILNGTX, ILNGTH, IPTRBM, INBSEQ, JROW, JSEQ, IPTOFF
      INTEGER IPTNBR, IRET, J, IDMAX, IDMIN, ISOMAX, ILCWID
      INTEGER IRETFN, IBITGW, IFOMAX
C
      INTEGER C2PACK, C2BITW
      EXTERNAL C2PACK, C2BITW
C
      CHARACTER YOPER*1
C
C     -----------------------------------------------------------------
C*    Section 1 . Performs initial checks.
C     -----------------------------------------------------------------
C
  100 CONTINUE
C
#ifndef ebug2o
      IF (ODEBUG) THEN
#endif
        WRITE(GRPRSM,FMT=9100) OCOMGR, OLONLY, KNSPT
#ifndef ebug2o
      ENDIF
#endif
C
      IRETFN = 0
      ILCWID = KPOWER(KXCWID)+1
      IREFLN=22
      ICOUNT=0
      INBITI=KSEC4(2)
      IFOMAX=0
      ILENSO=0
      ILDSTA=21
      IZERO=0
      IBITGW=8
      ILNGTX=KSEC4(1)/KNROWS
C
      IF (OPRIBI) THEN
        IPTRBM=KBMAP
      ENDIF
C
      IF (.NOT.OCOMGR) THEN
C
        IF (OLONLY) THEN
          IRETFN = 19110
          WRITE(GRPRSM,FMT=9110)
          GOTO 900
        ELSE
          INBIFO=KNBIFO
          GOTO 300
        ENDIF
C
      ENDIF
C
C     -----------------------------------------------------------------
C*    Section 2 . Compute effective length, reference, width of rows.
C     -----------------------------------------------------------------
C
  200 CONTINUE
#ifndef ebug2o
      IF (ODEBUG) THEN
#endif
        WRITE(GRPRSM,FMT=9200)
#ifndef ebug2o
      ENDIF
C
#endif
C
      YOPER='D'
C
      DO 230 JROW=1,KNROWS
C
      IF (OQUASI) THEN
        ILNGTX=KSEC2(IREFLN+JROW)
      ENDIF
C
      IF (OPRIBI.AND.ILNGTX.NE.0) THEN
C
C         Row by row packing, but an (explicit) bit-map is included.
C         The number of values in current row has to be computed.
C
        ILNGTH=0
        INBSEQ=1+(ILNGTX-1)/KLWORK
C
        DO 212 JSEQ=1,INBSEQ
        IPTOFF=(JSEQ-1)*KLWORK
        IPTNBR=MIN (KLWORK,ILNGTX-IPTOFF)
        CALL INXBIT (KGRIB,KLENG,IPTRBM,KWORK,IPTNBR,KBITS,1,
     X               YOPER,IRET)
C
        IF (IRET.NE.0) THEN
          IRETFN = 19210
          WRITE(GRPRSM,FMT=9210) JROW, IPTOFF+1, IPTOFF+IPTNBR
          GOTO 900
        ENDIF
C
        DO 211 J=1,IPTNBR
        ILNGTH=ILNGTH+KWORK(J)
  211   CONTINUE
C
  212   CONTINUE
C
      ELSE
C
        ILNGTH=ILNGTX
C
      ENDIF
C
      KLENGR(JROW)=ILNGTH
C
      IF (ILNGTH.NE.0) THEN
C
C     Width of row (number of bits necessary to code second-order
C                   values).
C
        CALL MAXMNI (KDATA(ICOUNT+1),ILNGTH,IDMAX,IDMIN)
C
        ISOMAX=IDMAX-IDMIN
C
        IF (ISOMAX.LT.ILCWID) THEN
          KBITGR(JROW)=KPCWID(ISOMAX)
        ELSE
          KBITGR(JROW)=KXCWID+KPCWID(ISOMAX/ILCWID)
        ENDIF
#ifdef row1sc2o
C
C     Take the minimum value of row as reference value.
C     Consistant with Bracknell's encoder approach.
C
        KREFGR(JROW)=IDMIN
#else
C
C     Maximum use of width for second-order values: the maximum value
C     of row will be encoded with the biggest value fitting in
C     KBITGR(JROW) bits, and keeping reference value positive or zero.
C
C     The goal is to get the lowest reference value, thus trying to
C     save bit(s) to encode the first-order values.
C
        IF (KBITGR(JROW).NE.0) THEN
          KREFGR(JROW)=MAX (0,IDMIN-(KPOWER(KBITGR(JROW))-ISOMAX))
        ELSE
          KREFGR(JROW)=IDMIN
        ENDIF
#endif
C
        IFOMAX=MAX (IFOMAX,KREFGR(JROW))
        ICOUNT=ICOUNT+ILNGTH
        ILENSO=ILENSO+ILNGTH*KBITGR(JROW)
C
      ELSE
C
        KREFGR(JROW)=0
        KBITGR(JROW)=0
C
      ENDIF
C
#ifdef ebug2o
      PRINT *,'c2rows - group', JROW, ILNGTH, KBITGR(JROW), ' (',
     X KNSPT+8*(ILDSTA+(8+KNROWS*(IBITGW+KSEC4(2))-1)/8)+ILENSO, ')',
     X IDMIN, ISOMAX, KREFGR(JROW), ICOUNT
#endif
C
  230 CONTINUE
C
      IF (ICOUNT.NE.KLEN) THEN
        IRETFN = 19220
        WRITE(GRPRSM,FMT=9220) ICOUNT, KLEN
        GOTO 900
      ENDIF      
C
C     Number of bits necessary to code first-order values.
C
      INBIFO = C2BITW ( IFOMAX, INBITI, KPOWER, KMXPWR )
C
#ifdef row1sc2o
C     To obtain an equivalent to a 1-scan coding, as Bracknell
C     coder seems to do. Such a method is more direct, does not
C     require work arrays, but is less efficient: row references are
C     coded with the same number of bits as specified for packing.
C
      INBIFO=KSEC4(2)
#endif
C
C     Compute length of descriptors, and of full section 4 of GRIB.
C
#ifndef ebug2o
      IF (ODEBUG) THEN
#endif
        WRITE(GRPRSM,FMT=9250) (KSEC4(J),J=1,10), INBIFO
#ifndef ebug2o
      ENDIF
C
#endif
      KLEN4 = ILDSTA + (8+KNROWS*IBITGW-1)/8 + (8+KNROWS*INBIFO-1)/8
     X               + (8+ILENSO-1)/8
      KLEN4=2*((2+KLEN4-1)/2)
      KNBIFO=INBIFO
C
      IF (OLONLY) THEN
C
C       Length has been computed, go back without any coding.
C
        GOTO 900
C
      ENDIF
C
C     -----------------------------------------------------------------
C*    Section 3. Definition of fixed-length descriptors and coding.
C     -----------------------------------------------------------------
C
  300 CONTINUE
C
C     The first 10 octets have already been coded in GRIBEX, or will
C     be in a further step of GRIBEX:
C     Length of section, flags+unused bit count, binary scale factor,
C     reference value.
C
#ifndef ebug2o
      IF (ODEBUG) THEN
#endif
        WRITE(GRPRSM,FMT=9300) 
#ifndef ebug2o
      ENDIF
C
#endif
C     Enforce right values for extended flags.
C
      KSEC4( 9)=0
      KSEC4(10)=16
      KSEC4(12)=0
      KSEC4(13)=0
C
C     Extra descriptors.
C
      KSEC4(18)=KNROWS
      KSEC4(20)=IBITGW
C
      IRETFN = C2PACK ( KDATA,  KLENP,  KSEC4,  KGRIB,  KLENG,  KNSPT,
     X                  KBITS,  KLEN,   KREFGR, KLENGR, KBITGR, KWORK,
     X                  KLWORK, KPOWER, KMXPWR, KNBIFO, ODEBUG )
C
C     -----------------------------------------------------------------
C*    Section 9. Return to calling routine.
C     -----------------------------------------------------------------
C
  900 CONTINUE
C
      C2ROWS = IRETFN
#ifndef ebug2o
C
      IF (ODEBUG) THEN
#endif
        WRITE(GRPRSM,FMT=9900) IRETFN, OCOMGR, OLONLY, KNSPT
#ifndef ebug2o
      ENDIF
#endif
C
      RETURN
C
 9100 FORMAT (' C2ROWS: Function start, OCOMGR = ',L1,
     X        ', OLONLY = ',L1,', KNSPT =',I10,'.')
C
 9110 FORMAT (' C2ROWS: Routine called, but has nothing to do.')
C
 9200 FORMAT (' C2ROWS: Computing work arrays.')
C
 9210 FORMAT (' C2ROWS: Problem unpacking primary bit-map,row',I6,
     X        ' points ',I8,'..',I8,'.')
C
 9220 FORMAT (' C2ROWS: Inconsistency: computed g.p. number =',I8,
     X        ', expected =',I8,'.')
C
 9250 FORMAT (' C2ROWS: KSEC4(1:10) =',I9,I3,I4,3I3,I2,3I3,
     X        ', INBIFO =',I3,'.')
C
 9300 FORMAT (' C2ROWS: Coding phase - calling C2PACK.')
C
 9900 FORMAT (' C2ROWS: Function return code =',I6,', OCOMGR= ',L1,
     X        ', OLONLY= ',L1,', KNSPT =',I10,'.')
C
      END

C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      INTEGER FUNCTION INTFAU(FLDIN,INLEN)
C
C---->
C**** INTFAU
C
C     Purpose
C     -------
C
C     Prepare to interpolate input field...
C
C
C     Interface
C     ---------
C
C     IRET = INTFAU( FLDIN,INLEN)
C
C     Input
C     -----
C
C     FLDIN  - Input field (unpacked).
C     INLEN  - Input field length (words).
C
C
C     Output
C     ------
C
C    Field unpacked values are in ZNFELDI.
C
C
C     Method
C     ------
C
C     Unpack field if GRIB.
C
C
C     Externals
C     ---------
C
C     None.
C
C
C     Author
C     ------
C
C     J.D.Chambers     ECMWF     Jan 1995
C
C----<
C
      IMPLICIT NONE
C
C     Function arguments
C
      INTEGER INLEN
      REAL FLDIN(*)
C
#include "parim.h"
#include "nifld.common"
#include "nofld.common"
#include "grfixed.h"
#include "intf.h"
C
C     Parameters
C
      INTEGER JPROUTINE
      PARAMETER (JPROUTINE = 26300 )
      INTEGER JPLEN, JPNM
      PARAMETER ( JPNM = JPSTRUNC )
      PARAMETER ( JPLEN = (JPNM+1)*(JPNM+2) )
C
C     Local variables
C
      REAL POLELAT, POLELON
      CHARACTER*1 TYPE
      INTEGER NUMPTS, NGAUSS
      INTEGER ISIZE, NBYTES, ITRUNC
      DATA ISIZE/0/
C
      REAL SWORK
      DIMENSION SWORK(1)
#ifndef _CRAYFTN
#ifdef POINTER_64
      INTEGER*8 ISWORK
#endif
#endif
      POINTER ( ISWORK, SWORK)
C
      REAL*8 DWORK
      DIMENSION DWORK(1)
#ifndef _CRAYFTN
#ifdef POINTER_64
      INTEGER*8 IDWORK
#endif
#endif
      POINTER ( IDWORK, DWORK )
C
      REAL*8 DATA
      DIMENSION DATA(1)
#ifndef _CRAYFTN
#ifdef POINTER_64
      INTEGER*8 IDATA
#endif
#endif
      POINTER ( IDATA, DATA)
C
      SAVE ISIZE, ISWORK, IDWORK, IDATA
C
      REAL*8 DLON, DLAT
      LOGICAL LOK
      DATA NBYTES/4/
C
C     Externals
      INTEGER GGROTAT
      LOGICAL JACOBI
      EXTERNAL JACOBI
      INTEGER IRET
      INTEGER LOOP
C
C ------------------------------------------------------------------
C*    Section 1.   Initialise
C ------------------------------------------------------------------
C
  100 CONTINUE
      INTFAU = 0
      IRET = 0
C
C ------------------------------------------------------------------
C*    Section 2.   Decode data from the GRIB code
C ------------------------------------------------------------------
C
  200 CONTINUE
C
C     Allocate work array ZNFELDI if not already done.
C
      IF( IZNJDCI.NE.1952999238 ) THEN
        CALL JMEMHAN( 19, IZNFLDI, JPEXPAND, 1, IRET)
        IF( IRET.NE.0 ) THEN
          CALL INTLOG(JP_WARN,'INTFAU: ZNFELDI allocate fail',JPQUIET)
          INTFAU = IRET
          GOTO 900
        ENDIF
        IZNJDCI = 1952999238
      ENDIF
C
C     Move unpacked values in from user array
      DO 210 LOOP = 1, INLEN
        ZNFELDI( LOOP ) = FLDIN( LOOP )
 210  CONTINUE
C
C ------------------------------------------------------------------
C*    Section 3.   Handle spectral rotation, if necessary.
C ------------------------------------------------------------------
C
  300 CONTINUE
C
C     Is the interpolation from SH with a rotation of the SH first?
C
      IF( ((NIREPR.EQ.JPSPHERE).OR.(NIREPR.EQ.JPSPHROT)) .AND.
     X    LNOROTA ) THEN
C
C       Avoid rotating U or V spectral coefficients
C
        IF( (NIPARAM.EQ.131).OR.(NIPARAM.EQ.132) ) THEN
          CALL INTLOG(JP_ERROR,
     X      'INTFAU: Unable to rotate spectral U or V:',NIPARAM)
          INTFAU = JPROUTINE + 6
          GOTO 900
        ENDIF
C
C       Dynamically allocate memory for workspace.
C
C       (Note the multiplication by 2 for REAL*8).
C
        NUMPTS = INLEN
        ISIZE = NUMPTS*2
        CALL JMEMHAN( 11, IDWORK, ISIZE, 1, IRET)
        IF( IRET.NE.0 ) THEN
          CALL INTLOG(JP_ERROR,'INTFAU: memory allocation fail',IDWORK)
          INTFAU = JPROUTINE + 1
          GOTO 900
        ENDIF
C
C       (Note the multiplication by 2 for REAL*8).
C
        ISIZE = JPLEN*2
        CALL JMEMHAN( 15, IDATA, ISIZE, 1, IRET)
        IF( IRET.NE.0 ) THEN
          CALL INTLOG(JP_ERROR,'INTFAU: memory allocation fail',IDATA)
          INTFAU = JPROUTINE + 2
          GOTO 900
        ENDIF
C
        CALL INTLOG(JP_DEBUG,'INTFAU: Rotate SH field.',JPQUIET)
        CALL INTLOG(JP_DEBUG,'INTFAU: South pole latitude  ',NOROTA(1))
        CALL INTLOG(JP_DEBUG,'INTFAU: South pole longitude ',NOROTA(2))
        IF ( NOREPR.EQ.JPSPHERE )  NOREPR = JPSPHROT
        IF ( NOREPR.EQ.JPREGULAR )  NOREPR = JPREGROT
        ITRUNC = NIRESO
#if (defined REAL_8)
        DLAT = -90.0 - REAL(NOROTA(1))/JPMULT
        DLON = - REAL(NOROTA(2))/JPMULT
C
C       Rotate the spectral field by longitude.
        CALL RPHI( ZNFELDI, ITRUNC, DWORK, DLON)
C
C       Rotate the spectral field by latitude.
        LOK = JACOBI( ZNFELDI, ITRUNC, DWORK, DLAT)
#else
        DLAT = -90.0 - DBLE(NOROTA(1))/JPMULT
        DLON = - DBLE(NOROTA(2))/JPMULT
C
C       Expand spectral coefficients to REAL*8
C
        DO LOOP = 1, NUMPTS
          DATA(LOOP) = DBLE(ZNFELDI(LOOP))
        ENDDO
C
C       Rotate the spectral field by longitude.
        CALL RPHI( DATA, ITRUNC, DWORK, DLON)
C
C       Rotate the spectral field by latitude.
C
        LOK = JACOBI( DATA, ITRUNC, DWORK, DLAT)
#endif
        IF(.NOT.LOK) THEN
          CALL INTLOG(JP_ERROR,'INTFAU: Spectral rotation fail',JPQUIET)
          INTFAU = JPROUTINE + 3
          GOTO 900
        ENDIF
#if (!defined REAL_8)
C
C       Repack spectral coefficients to REAL*4.
C
        DO LOOP = 1, NUMPTS
          ZNFELDI(LOOP) = SNGL(DATA(LOOP))
        ENDDO
#endif
C
      ENDIF
C
C ------------------------------------------------------------------
C*    Section 4.   Handle gaussian rotation, if necessary.
C ------------------------------------------------------------------
C
  400 CONTINUE
C
C     Is the interpolation from gaussian with a rotation of the
C     gaussian first?
C
      IF( ((NIREPR.EQ.JPGAUSSIAN).OR.(NIREPR.EQ.JPQUASI)) .AND.
     X    LNOROTA ) THEN
C
        CALL INTLOG(JP_DEBUG,'INTFAU: Rotate gaussian field.',JPQUIET)
        CALL INTLOG(JP_DEBUG,'INTFAU: South pole latitude  ',NOROTA(1))
        CALL INTLOG(JP_DEBUG,'INTFAU: South pole longitude ',NOROTA(2))
        IF ( NOREPR.EQ.JPGAUSSIAN )  NOREPR = JPFGGROT
        IF ( NOREPR.EQ.JPQUASI )     NOREPR = JPQGGROT
C
C       Dynamically allocate memory for workspace.
C
        NUMPTS = INLEN
        ISIZE  = NUMPTS
        CALL JMEMHAN( 11, ISWORK, ISIZE, 1, IRET)
        IF( IRET.NE.0 ) THEN
          CALL INTLOG(JP_ERROR,'INTFAU: memory allocation fail',ISWORK)
          INTFAU = JPROUTINE + 4
          GOTO 900
        ENDIF
C
C       Rotate the gaussian field.
C
        POLELAT = REAL(NOROTA(1))/JPMULT
        POLELON = REAL(NOROTA(2))/JPMULT
        NGAUSS = NIGAUSS
        IF( NIREPR.EQ.JPGAUSSIAN ) THEN
          TYPE = 'F'
        ELSE
          TYPE = 'R'
        ENDIF
        IRET = GGROTAT(ZNFELDI,SWORK,NUMPTS,POLELAT,POLELON,TYPE,NGAUSS)
        IF( IRET.NE.0 ) THEN
          CALL INTLOG(JP_ERROR,'INTFAU: Gaussian rotation fail',JPQUIET)
          INTFAU = JPROUTINE + 5
          GOTO 900
        ENDIF
C
C       Move rotated field back into field original array.
C
        DO LOOP = 1, NUMPTS
          ZNFELDI(LOOP) = SWORK(LOOP)
        ENDDO
        OUTLROT = NUMPTS
C
      ENDIF
C
C
C ------------------------------------------------------------------
C*    Section 9.   Closedown.
C ------------------------------------------------------------------
C
  900 CONTINUE
C
C     Clear change flags for next product processing
C
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE PBCREX(KUNIT,KARRAY,KINLEN,KOUTLEN,KRET)
C
C---->
C**** PBCREX
C
C     PURPOSE
C     _______
C
C     Reads next CREX product from a file.
C
C     INTERFACE
C     _________
C
C     CALL PBCREX(KUNIT,KARRAY,KINLEN,KOUTLEN,KRET)
C
C
C     Input parameters
C     ________________
C
C     KUNIT   - unit number for the file returned from PBOPEN
C     KARRAY  - FORTRAN array big enough to hold the CREX product
C     KINLEN  - size in BYTES of the FORTRAN array
C
C
C     Output parameters
C     ________________
C
C     KOUTLEN - size in BYTES of the CREX product read	
C     KRET    - 0  if a CREX product has been successfully read
C              -1  if end-of-file is hit before a CREX product is read
C              -2  if file read error is generated
C              -3  if the size of KARRAY is not sufficient for the
C                  CREX product
C
C
C     Common block usage
C     __________________
C
C     None.
C
C
C     Method
C     ______
C
C     Calls CREXRD.
C
C
C     Externals
C     _________
C
C     CREXRD - Read next CREX product.
C
C
C     AUTHOR
C     ______
C
C     J.D.Chambers       ECMWF
C
C
C     MODIFICATIONS
C     _____________
C
C     None.
C
C******************************************************************************
C----<
C
      IMPLICIT NONE
C
C     Subroutine arguments
C
      INTEGER KARRAY(1)
      INTEGER KUNIT,KINLEN,KOUTLEN,KRET
C
C     Local arguments
C
      INTEGER NREAD, IRET
C
C Get the CREX product
C
      CALL CREXRD( KARRAY, KINLEN, NREAD, IRET, KUNIT )
C
C Escape if the user buffer is too small to hold even the early sections of
C the product or EOF encountered
C
      IF( IRET.EQ.-4 ) THEN
        KOUTLEN = NREAD
        KRET    = -1
        RETURN
      ENDIF
C
C Escape if no CREX product is found in the file
C
      IF( IRET.EQ.-1 ) THEN
        KOUTLEN = 0
        KRET    = -1
        RETURN
      ENDIF
C
C Escape if file read error
C
      IF( (IRET.EQ.-2) .OR. (IRET.EQ.-5) ) THEN
        KOUTLEN = 0
        KRET    = -2
        RETURN
      ENDIF
C
C Check if the array is big enough for the CREX product
C
      IF( IRET.EQ.-3 ) THEN
        KOUTLEN = NREAD
        KRET    = -3
        RETURN
      ENDIF
C
C Set success code if product retrieved
C
      IF( NREAD.GE.0 )  THEN
        KOUTLEN = NREAD
        KRET    = 0
      ENDIF
C
      RETURN 
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE HWTSLSM
     X  (KLEN,KSCHEME,KLA,PDLAT,PLATIN,PDLO0,PDLO1,PDLO2,PDLO3,NEIGH,
     X   LSMOLD,LSMNEW,PWTS)
C
C---->
C**** HWTSLSM
C
C     Purpose
C     -------
C
C     This routine accepts a vector of points and calculates the
C     interpolation weightings for each point suitable for the
C     horizontal interpolation.
C
C
C     Interface
C     ---------
C
C     CALL HWTSLSM
C    X  (KLEN,KSCHEME,KLA,PDLAT,PLATIN,PDLO0,PDLO1,PDLO2,PDLO3,NEIGH,
C    X   LSMOLD,LSMNEW,PWTS)
C
C
C     Input parameters
C     ----------------
C
C     KLEN    - Number of points along the vector.
C     KSCHEME - Flag showing interpolation scheme to use for point
C               0 = 12-point
C               1 = 4-point bilinear
C               2 = nearest neighbour
C     KLA     - Latitude number in original field of latitude north of
C               point in the vector.
C     PDLAT   - Meridian linear weight.
C     PLATIN  - Gaussian latitudes.
C     PDLO0   - Zonal linear weight for the latitude of point 5.
C     PDLO1   - Zonal linear weight for the latitude of point 1.
C     PDLO2   - Zonal linear weight for the latitude of point 3.
C     PDLO3   - Zonal linear weight for the latitude of point 11.
C     NEIGH   - List of indices in the original field of neighbouring
C               point values.
C     LSMOLD  - Array of land-sea mask values ( a reduced gaussian
C               field which matches the reduced gaussian field to be
C               used for interpolation)
C     LSMNEW  - Vector of land-sea mask values for the input points
C
C
C     Output parameters
C     -----------------
C
C     PWTS   - Weights for interpolation.
C
C     Common block usage
C     ------------------
C
C     None.
C
C
C     Method
C     ------
C
C     Numbering of the points (I is the interpolation point):
C
C                   13       5       6      14
C
C                    7       1       2       8
C                               (I)
C                    9       3       4      10
C
C                   15      11      12      16
C
C
C     Externals
C     ---------
C
C     None.
C
C
C     Reference
C     ---------
C
C     ECMWF Meteorological Bulletin M1.6/7
C     IFS Documentation
C     Part VI: Technical and Computational Procedures (CY21R4)
C     March 2000
C     Section 2.3
C
C
C     Comments
C     --------
C
C     None.
C
C
C     Author
C     ------
C
C     J.D.Chambers      ECMWF      March 2001
C
C
C     Modifications
C     -------------
C
C     None.
C
C----<
C     -----------------------------------------------------------------|
C*    Definition of variables.
C     -----------------------------------------------------------------|
C
      IMPLICIT NONE
C
C     Parameters
C
      INTEGER JP12PT, JP4PT, JPNEARN
      PARAMETER (JP12PT  = 0)
      PARAMETER (JP4PT   = 1)
      PARAMETER (JPNEARN = 2)
C
C     Function arguments
C
      INTEGER KLEN, KSCHEME(KLEN), KLA(KLEN)
      REAL PDLAT(KLEN), PLATIN(*)
      REAL PDLO0(KLEN), PDLO1(KLEN), PDLO2(KLEN), PDLO3(KLEN)
      REAL LSMNEW(KLEN)
      INTEGER NEIGH(12,*)
      REAL LSMOLD(*),PWTS(12,*)
C
C     Local variables
C
      INTEGER NEXT, LOOP
      INTEGER ILA0G, ILA1G, ILA2G, ILA3G
      INTEGER IMKOUT, IMKIN1, IMKIN2, IMKIN3, IMKIN4, IMKIN5, IMKIN6
      INTEGER IMKIN7, IMKIN8, IMKIN9, IMKIN10, IMKIN11, IMKIN12
      REAL ZDLAT, ZDY, ZDY10, ZDY21, ZDY32
      REAL ZDLO, ZDLO1, ZDLO2, ZDLO3, ZWXN0, ZWXN1, ZWXN2, ZWXN3
      REAL ZWY0, ZWY1, ZWY2, ZWY3
      REAL ZWXNN, ZCXNN, ZWXSS, ZCXSS
      REAL ZWXS0, ZWXS1, ZWXS2, ZWXS3
      REAL ZWY, ZCY, ZWXN, ZCXN, ZWXS, ZCXS
      REAL ZWLSI1, ZWLSI2, ZWLSI3, ZWLSI4, ZWLSI5, ZWLSI6
      REAL ZWLSI7, ZWLSI8, ZWLSI9, ZWLSI10, ZWLSI11, ZWLSI12
      REAL ZWLSI13, ZWLSI14, ZWLSI15, ZWLSI16, ZWLSI17
      REAL ZEPSIL
      DATA ZEPSIL/1.E-5/
C
C     Inline functions
C
      REAL A, B, ADJUST
      REAL ALPHA, BETA, GAMMA, DELTA, EPSILON, F2, F3, F4
C
      ADJUST(A,B) = 1.0 - INT(B + ZEPSIL)*(1.0 - A)
C
      F2(ALPHA,BETA,GAMMA,DELTA,EPSILON) =
     X  ALPHA * ((1.0 + BETA*GAMMA) *
     X  (1.0 + DELTA*(GAMMA-2.0)) *
     X  (1.0 + EPSILON*(GAMMA-3.0))) /
     X  ((1.0 - 2.0*DELTA) * (1.0 - 3.0*EPSILON))
C
      F3(ALPHA,BETA,GAMMA,DELTA,EPSILON) =
     X  ALPHA * ((1.0 + BETA*GAMMA) *
     X  (1.0 + DELTA*(GAMMA - 1.0)) *
     X  (1.0 + EPSILON*(GAMMA - 3.0))) /
     X  ((1.0 + BETA) * (1.0 - 2.0*EPSILON))
C
      F4(ALPHA,BETA,GAMMA,DELTA,EPSILON) =
     X  ALPHA * ((1.0 + BETA*GAMMA) *
     X  (1.0 + DELTA*(GAMMA - 1.0)) *
     X  (1.0 + EPSILON*(GAMMA - 2.0))) /
     X  ((1.0 + 2.0*BETA) * (1.0 + DELTA))
C
C     -----------------------------------------------------------------|
C     Process each point in the vector.
C     -----------------------------------------------------------------|
C
      DO NEXT = 1,KLEN
C
C       Clear the weights for the current point
C
        DO LOOP = 1, 12
          PWTS(LOOP,NEXT) = 0.0
        ENDDO
C
C       Use appropriate interpolation scheme for the current point
C
C     -----------------------------------------------------------------|
C
C       Nearest point selection
C
C     -----------------------------------------------------------------|
C
        IF( KSCHEME(NEXT).EQ.JPNEARN ) THEN
C
          DO LOOP = 1, 4
            IF( NEIGH(LOOP,NEXT).NE.0 ) PWTS(LOOP,NEXT) = 1.0
          ENDDO
C
          GOTO 900
C
C     -----------------------------------------------------------------|
C
C       4-point interpolation
C
C     -----------------------------------------------------------------|
C
        ELSE IF( KSCHEME(NEXT).EQ.JP4PT ) THEN
C
C     -----------------------------------------------------------------|
C         Initialise the lsm weights
C     -----------------------------------------------------------------|
C
          ZWLSI1  = 1.0
          ZWLSI2  = 1.0
          ZWLSI3  = 1.0
          ZWLSI4  = 1.0
C
          ZWLSI14 = 0.0
          ZWLSI15 = 0.0
          ZWLSI17 = 0.0
C
C         Modify the weights according to whether or not the target
C         point matches its neighbours
C
          IMKOUT = NINT(LSMNEW(NEXT))
C
          IMKIN1 = NINT(LSMOLD(NEIGH(1,NEXT)))
          IF( IMKIN1.NE.IMKOUT ) ZWLSI1 = 0.0
C
          IMKIN2 = NINT(LSMOLD(NEIGH(2,NEXT)))
          IF( IMKIN2.NE.IMKOUT ) ZWLSI2 = 0.0
C
          IMKIN3 = NINT(LSMOLD(NEIGH(3,NEXT)))
          IF( IMKIN3.NE.IMKOUT ) ZWLSI3 = 0.0
C
          IMKIN4 = NINT(LSMOLD(NEIGH(4,NEXT)))
          IF( IMKIN4.NE.IMKOUT ) ZWLSI4 = 0.0
C
          IF( IMKIN1.NE.IMKOUT) ZWLSI1 = 0.0
          IF( IMKIN2.NE.IMKOUT) ZWLSI2 = 0.0
          IF( IMKIN3.NE.IMKOUT) ZWLSI3 = 0.0
          IF( IMKIN4.NE.IMKOUT) ZWLSI4 = 0.0
C
          ZWLSI14 = MIN(ZWLSI1 + ZWLSI2, 1.0)
          ZWLSI15 = MIN(ZWLSI3 + ZWLSI4, 1.0)
          ZWLSI17 = MIN(ZWLSI14 + ZWLSI15, 1.0)
C
          ZWLSI1 = ADJUST(ZWLSI1,ZWLSI14)
          ZWLSI2 = ADJUST(ZWLSI2,ZWLSI14)
          ZWLSI3 = ADJUST(ZWLSI3,ZWLSI15)
          ZWLSI4 = ADJUST(ZWLSI4,ZWLSI15)
C
          ZWLSI14 = ADJUST(ZWLSI17,ZWLSI14)
          ZWLSI15 = ADJUST(ZWLSI17,ZWLSI15)
C
C     -----------------------------------------------------------------|
C         Weights for bilinear interpolation.
C     -----------------------------------------------------------------|
C
      
          ZWY = ZWLSI15 * (1.0 + ZWLSI14 * (PDLAT(NEXT) - 1.0))
          ZCY = 1.0 - ZWY
C
          ZWXN = ZWLSI2 * (1.0 + ZWLSI1 * (PDLO1(NEXT) - 1.0))
          ZCXN = 1.0 - ZWXN
C
          ZWXS = ZWLSI4 * (1.0 + ZWLSI3 * (PDLO2(NEXT) - 1.0))
          ZCXS = 1.0 - ZWXS
C
          PWTS(1,NEXT) = ZCXN * ZCY
          PWTS(2,NEXT) = ZWXN * ZCY
          PWTS(3,NEXT) = ZCXS * ZWY
          PWTS(4,NEXT) = ZWXS * ZWY
C
          GOTO 900
C
C     -----------------------------------------------------------------|
C
C       12-point interpolation
C
C     -----------------------------------------------------------------|
C
        ELSE
C
C     -----------------------------------------------------------------|
C         Initialise the lsm weights
C     -----------------------------------------------------------------|
C
          ZWLSI1  = 1.0
          ZWLSI2  = 1.0
          ZWLSI3  = 1.0
          ZWLSI4  = 1.0
          ZWLSI5  = 1.0
          ZWLSI6  = 1.0
          ZWLSI7  = 1.0
          ZWLSI8  = 1.0
          ZWLSI9  = 1.0
          ZWLSI10 = 1.0
          ZWLSI11 = 1.0
          ZWLSI12 = 1.0
C
          ZWLSI13 = 0.0
          ZWLSI14 = 0.0
          ZWLSI15 = 0.0
          ZWLSI16 = 0.0
          ZWLSI17 = 0.0
C
C         Modify the weights according to whether or not the target
C         point matches its neighbours
C
          IMKOUT = NINT(LSMNEW(NEXT))
C
          IMKIN1 = NINT(LSMOLD(NEIGH(1,NEXT)))
          IF( IMKIN1.NE.IMKOUT ) ZWLSI1 = 0.0
C
          IMKIN2 = NINT(LSMOLD(NEIGH(2,NEXT)))
          IF( IMKIN2.NE.IMKOUT ) ZWLSI2 = 0.0
C
          IMKIN3 = NINT(LSMOLD(NEIGH(3,NEXT)))
          IF( IMKIN3.NE.IMKOUT ) ZWLSI3 = 0.0
C
          IMKIN4 = NINT(LSMOLD(NEIGH(4,NEXT)))
          IF( IMKIN4.NE.IMKOUT ) ZWLSI4 = 0.0
C
          IMKIN5 = NINT(LSMOLD(NEIGH(5,NEXT)))
          IF( IMKIN5.NE.IMKOUT ) ZWLSI5 = 0.0
C
          IMKIN6 = NINT(LSMOLD(NEIGH(6,NEXT)))
          IF( IMKIN6.NE.IMKOUT ) ZWLSI6 = 0.0
C
          IMKIN7 = NINT(LSMOLD(NEIGH(7,NEXT)))
          IF( IMKIN7.NE.IMKOUT ) ZWLSI7 = 0.0
C
          IMKIN8 = NINT(LSMOLD(NEIGH(8,NEXT)))
          IF( IMKIN8.NE.IMKOUT ) ZWLSI8 = 0.0
C
          IMKIN9 = NINT(LSMOLD(NEIGH(9,NEXT)))
          IF( IMKIN9.NE.IMKOUT ) ZWLSI9 = 0.0
C
          IMKIN10 = NINT(LSMOLD(NEIGH(10,NEXT)))
          IF( IMKIN10.NE.IMKOUT ) ZWLSI10 = 0.0
C
          IMKIN11 = NINT(LSMOLD(NEIGH(11,NEXT)))
          IF( IMKIN11.NE.IMKOUT ) ZWLSI11 = 0.0
C
          IMKIN12 = NINT(LSMOLD(NEIGH(12,NEXT)))
          IF( IMKIN12.NE.IMKOUT ) ZWLSI12 = 0.0
C
          ZWLSI13 = MIN(ZWLSI5+ZWLSI6                  ,1.0)
          ZWLSI14 = MIN(ZWLSI7+ZWLSI1+ZWLSI2+ZWLSI8    ,1.0)
          ZWLSI15 = MIN(ZWLSI9+ZWLSI3+ZWLSI4+ZWLSI10   ,1.0)
          ZWLSI16 = MIN(ZWLSI11+ZWLSI12                ,1.0)
          ZWLSI17 = MIN(ZWLSI13+ZWLSI14+ZWLSI15+ZWLSI16,1.0)
C
          ZWLSI1  = ADJUST(ZWLSI1,ZWLSI14)
          ZWLSI2  = ADJUST(ZWLSI2,ZWLSI14)
          ZWLSI3  = ADJUST(ZWLSI3,ZWLSI15)
          ZWLSI4  = ADJUST(ZWLSI4,ZWLSI15)
          ZWLSI5  = ADJUST(ZWLSI5,ZWLSI13)
          ZWLSI6  = ADJUST(ZWLSI6,ZWLSI13)
          ZWLSI7  = ADJUST(ZWLSI7,ZWLSI14)
          ZWLSI8  = ADJUST(ZWLSI8,ZWLSI14)
          ZWLSI9  = ADJUST(ZWLSI9,ZWLSI15)
          ZWLSI10 = ADJUST(ZWLSI10,ZWLSI15)
          ZWLSI11 = ADJUST(ZWLSI11,ZWLSI16)
          ZWLSI12 = ADJUST(ZWLSI12,ZWLSI16)
C
          ZWLSI13 = ADJUST(ZWLSI13,ZWLSI17)
          ZWLSI14 = ADJUST(ZWLSI14,ZWLSI17)
          ZWLSI15 = ADJUST(ZWLSI15,ZWLSI17)
          ZWLSI16 = ADJUST(ZWLSI16,ZWLSI17)
C
C         Setup latitude numbers for the 4 rows.
C
          ILA1G = KLA(NEXT)
          ILA0G = ILA1G - 1
          ILA2G = ILA1G + 1
          ILA3G = ILA1G + 2
C
C         Setup the weights between rows.
C
          ZDLAT = PDLAT(NEXT)
          ZDY   = ZDLAT * (PLATIN(ILA2G) - PLATIN(ILA1G))
          ZDY10 =          PLATIN(ILA1G) - PLATIN(ILA0G)
          ZDY21 =          PLATIN(ILA2G) - PLATIN(ILA1G)
          ZDY32 =          PLATIN(ILA3G) - PLATIN(ILA2G)
C
C     -----------------------------------------------------------------|
C         Polynomial in x-direction.
C     -----------------------------------------------------------------|
C
C         Northern parallel
C
          ZDLO1 = PDLO1(NEXT)
          ZWXN1 = F2(ZWLSI1,ZWLSI7,ZDLO1,ZWLSI2,ZWLSI8)
          ZWXN2 = F3(ZWLSI2,ZWLSI7,ZDLO1,ZWLSI1,ZWLSI8)
          ZWXN3 = F4(ZWLSI8,ZWLSI7,ZDLO1,ZWLSI1,ZWLSI2)
          ZWXN0 = 1.0 - ZWXN1 - ZWXN2 - ZWXN3
C
C         Southern parallel
C
          ZDLO2 = PDLO2(NEXT)
          ZWXS1 = F2(ZWLSI3,ZWLSI9,ZDLO2,ZWLSI4,ZWLSI10)
          ZWXS2 = F3(ZWLSI4,ZWLSI9,ZDLO2,ZWLSI3,ZWLSI10)
          ZWXS3 = F4(ZWLSI10,ZWLSI9,ZDLO2,ZWLSI3,ZWLSI4)
          ZWXS0 = 1.0 - ZWXS1 - ZWXS2 - ZWXS3
C
C     -----------------------------------------------------------------|
C         Polynomial in y-direction.
C     -----------------------------------------------------------------|
C
          ZWY1 = ZWLSI14*((1.0 + ZWLSI13*(ZDY + ZDY10 - 1.0)) *
     X           (1.0 + ZWLSI15*(ZDY - ZDY21 - 1.0)) *
     X           (1.0 + ZWLSI16*(ZDY - ZDY21 - ZDY32 - 1.0))) /
     X           ((1.0 + ZWLSI13*(ZDY10 - 1.0)) *
     X           (1.0 + ZWLSI15*( -ZDY21 - 1.0)) *
     X           (1.0 + ZWLSI16*( -ZDY21 - ZDY32 - 1.0)))
          ZWY2 = ZWLSI15*((1.0 + ZWLSI13*(ZDY + ZDY10 - 1.0)) *
     X           (1.0 + ZWLSI14*(ZDY - 1.0)) *
     X           (1.0 + ZWLSI16*(ZDY - ZDY21 - ZDY32 - 1.0))) /
     X           ((1.0 + ZWLSI13*(ZDY10 + ZDY21 - 1.0)) *
     X           (1.0 + ZWLSI14*(ZDY21 - 1.0)) *
     X           (1.0 + ZWLSI16*( -ZDY32 - 1.0)))
          ZWY3 = ZWLSI16*((1.0 + ZWLSI13*(ZDY + ZDY10 - 1.0)) *
     X           (1.0 + ZWLSI14*(ZDY - 1.0)) *
     X           (1.0 + ZWLSI15*(ZDY - ZDY21 - 1.0))) /
     X           ((1.0 + ZWLSI13*(ZDY10 + ZDY21 + ZDY32 - 1.0)) *
     X           (1.0 + ZWLSI14*(ZDY21 + ZDY32 - 1.0)) *
     X           (1.0 + ZWLSI15*(ZDY32 - 1.0)))
          ZWY0 = 1.0 - ZWY1 - ZWY2 - ZWY3
C
C     -----------------------------------------------------------------|
C         Linear parts for extreme rows.
C     -----------------------------------------------------------------|
C
C         Northernmost
C
          ZDLO  = PDLO0(NEXT)
          ZWXNN = ZWLSI6 * (1.0 + ZWLSI5 * (ZDLO - 1.0))
          ZCXNN = 1.0 - ZWXNN
C
C         Southernmost
C
          ZDLO3 = PDLO3(NEXT)
          ZWXSS = ZWLSI12 * (1.0 + ZWLSI11 * (ZDLO3 - 1.0))
          ZCXSS = 1.0 - ZWXSS
C
C     -----------------------------------------------------------------|
C         Weights for 12 points interpolation.
C     -----------------------------------------------------------------|
C
          PWTS( 1,NEXT) = ZWXN1 * ZWY1
          PWTS( 2,NEXT) = ZWXN2 * ZWY1
          PWTS( 3,NEXT) = ZWXS1 * ZWY2
          PWTS( 4,NEXT) = ZWXS2 * ZWY2
          PWTS( 5,NEXT) = ZCXNN * ZWY0
          PWTS( 6,NEXT) = ZWXNN * ZWY0
          PWTS( 7,NEXT) = ZWXN0 * ZWY1
          PWTS( 8,NEXT) = ZWXN3 * ZWY1
          PWTS( 9,NEXT) = ZWXS0 * ZWY2
          PWTS(10,NEXT) = ZWXS3 * ZWY2
          PWTS(11,NEXT) = ZCXSS * ZWY3
          PWTS(12,NEXT) = ZWXSS * ZWY3
C
          GOTO 900
C
        ENDIF
C
C     -----------------------------------------------------------------|
C       End of processing for current point in vector.
C     -----------------------------------------------------------------|
C
  900   CONTINUE
C
      ENDDO
C
      RETURN
      END

C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE BBUPRS2(KNT,KSUP,KEY)
C
C**** *BUPRS2*
C
C
C     PURPOSE.
C     --------
C           PRINT SECTION 2 OF BUFR MESSAGE (EXPANDED RDB KEY).
C
C
C**   INTERFACE.
C     ----------
C
C           *CALL* *BUPRS2(KNT,KSUP,KEY)*
C
C        INPUT :
C               *KNT*   -  UNIT NUMBER FOR IO
C               *KSUP*    -  ARRAY CONTAINING SUPLEMENTARY INFORMATION
C                         -  KSUP( 1) -- IDIM1, DIMENSION OF KSEC1
C                         -  KSUP( 2) -- IDIM2, DIMENSION OF KSEC2
C                         -  KSUP( 3) -- IDIM3, DIMENSION OF KSEC3
C                         -  KSUP( 4) -- IDIM4, DIMENSION OF KSEC4
C                         -  KSUP( 5) -- M (NUMBER OF ELEMENTS IN VALUES ARRAY,
C                                           FIRST INDEX)
C                         -  KSUP( 6) -- N (NUMBER OF SUBSETS,SECOND INDEX OF
C                                           VALUES ARRAY)
C                         -  KSUP( 7) -- JVC (NUMBER OF ELEMENTS IN CVAL ARRAY)
C                         -  KSUP( 8) -- TOTAL BUFR MESSAGE LENGTH IN BYTES
C                         -  KSUP( 9) -- IDIM0, DIMENSION OF KSEC0
C               *KEY*     -  ARRAY CONTAINING SECTION 2 INFORMATION
C                            KEY( 1)-- LENGTH OF SECTION 2 (BYTES)
C                            KEY( 2)-- RDB TYPE
C                            KEY( 3)-- RDB SUBTYPE
C                            KEY( 4)-- YEAR
C                            KEY( 5)-- MONTH
C                            KEY( 6)-- DAY
C                            KEY( 7)-- HOUR
C                            KEY( 8)-- MINUTE
C                            KEY( 9)-- SECOND
C                            KEY(10)-- LONGITUDE1
C                            KEY(11)-- LATITUDE1
C                            KEY(12)-- LONGITUDE2
C                            KEY(13)-- LATITUDE2
C                            KEY(14)-- NUMBER OF SUBSETS
C                            KEY(15)-- IDENT (NUMERIC)
C                            KEY(16)-- IDENT ( CCITTIA5) ONE CHARACTER
C                            KEY(17)-- IDENT ( CCITTIA5) ONE CHARACTER
C                            KEY(18)-- IDENT ( CCITTIA5) ONE CHARACTER
C                            KEY(19)-- IDENT ( CCITTIA5) ONE CHARACTER
C                            KEY(20)-- IDENT ( CCITTIA5) ONE CHARACTER
C                            KEY(21)-- IDENT ( CCITTIA5) ONE CHARACTER
C                            KEY(22)-- IDENT ( CCITTIA5) ONE CHARACTER
C                            KEY(23)-- IDENT ( CCITTIA5) ONE CHARACTER
C                            KEY(24)-- IDENT ( CCITTIA5) ONE CHARACTER
C                            KEY(25)-- TOTAL BUFR MESSAGE LENGTH
C                            KEY(26)-- DAY    (RDB INSERTION)
C                            KEY(27)-- HOUR   (RDB INSERTION)
C                            KEY(28)-- MINUTE (RDB INSERTION)
C                            KEY(29)-- SECOND (RDB INSERTION)
C                            KEY(30)-- DAY    (MDB INSERTION)
C                            KEY(31)-- HOUR   (MDB INSERTION)
C                            KEY(32)-- MINUTE (MDB INSERTION)
C                            KEY(33)-- SECOND (MDB INSERTION)
C                            KEY(34)-- CORRECTION NUMBER
C                            KEY(35)-- PART
C                            KEY(36)-- 0
C                            KEY(37)-- CORRECTION NUMBER
C                            KEY(38)-- PART
C                            KEY(39)-- 0
C                            KEY(40)-- CORRECTION NUMBER
C                            KEY(41)-- PART
C                            KEY(42)-- 0
C                            KEY(43)-- CORRECTION NUMBER
C                            KEY(44)-- PART
C                            KEY(45)-- 0
C                            KEY(46)-- THE LOWEST Q/C % CONFIDENCE
C
C
C
C
C     METHOD.
C     -------
C
C            NONE
C
C     EXTERNALS.
C     ----------
C
C            NONE.
C
C     REFERENCE.
C     ----------
C
C          NONE.
C
C     AUTHOR.
C     -------
C
C          M. DRAGOSAVAC    *ECMWF*       04/02/91.
C
C     MODIFICATIONS.
C     --------------
C
C          NONE.
C
      IMPLICIT LOGICAL(L,O,G), CHARACTER*8(C,H,Y)
C
C
#     include "parameter.F"
C
      DIMENSION KSUP(JSUP),KEY(JKEY)
C
#ifndef R_4
      REAL*8 RLAT1
      REAL*8 RLON1
      REAL*8 RLAT2
      REAL*8 RLON2
#else
      REAL   RLAT1
      REAL   RLON1
      REAL   RLAT2
      REAL   RLON2
#endif
C
      CHARACTER*9 CIDENT
      CHARACTER*13 YFM
C
C     ------------------------------------------------------------------
C
C*          1.   PRINT SECTION 2.
C                ----------------
 100  CONTINUE
C
      YFM='(1H ,A,TR0,A)'
C
      IF(KSUP(2).LE.1) THEN
         WRITE(KNT) 'PRTKEY : RDB KEY NOT DEFINED IN SECTION 2.'
         RETURN
      END IF
C
      WRITE(KNT,'(1H1)')
C
      WRITE(KNT,'(1H ,A)')       '        BUFR SECTION 2    '
      WRITE(KNT,'(1H )')
      WRITE(KNT,'(1H ,A,I9)')    'LENGTH OF SECTION 2       ', KEY(1)
      WRITE(KNT,'(1H )')
      WRITE(KNT,'(1H ,A)')       '      REPORT DATA BASE KEY  '
      WRITE(KNT,'(1H )')
C
      IKTYPE=0
      IF(KEY(2).EQ.2) IKTYPE=2
      IF(KEY(2).EQ.3) IKTYPE=2
      IF(KEY(2).EQ.12)IKTYPE=2
      IF(KEY(2).EQ.08)IKTYPE=2
      IF(IKTYPE.EQ.0.AND.KSUP(6).GT.1) IKTYPE=2
C
      IF(IKTYPE.EQ.2) THEN
C      IF(KEY(2).EQ.2.OR.KEY(2).EQ.3.OR.KEY(2).EQ.12) THEN
C
         WRITE(KNT,'(1H ,A,I9)') 'RDB DATA TYPE             ', KEY(2)
         WRITE(KNT,'(1H ,A,I9)') 'RDB DATA SUBTYPE          ', KEY(3)
         WRITE(KNT,'(1H ,A,I9)') 'YEAR                      ', KEY(4)
         WRITE(KNT,'(1H ,A,I9)') 'MONTH                     ', KEY(5)
         WRITE(KNT,'(1H ,A,I9)') 'DAY                       ', KEY(6)
         WRITE(KNT,'(1H ,A,I9)') 'HOUR                      ', KEY(7)
         WRITE(KNT,'(1H ,A,I9)') 'MINUTE                    ', KEY(8)
         WRITE(KNT,'(1H ,A,I9)') 'SECOND                    ', KEY(9)
         RLAT1=(KEY(11)-9000000)/100000.
         RLON1=(KEY(10)-18000000)/100000.
         WRITE(KNT,'(1H ,A,F9.2)')'LATITUDE  1               ', RLAT1
         WRITE(KNT,'(1H ,A,F9.2)')'LONGITUDE 1               ', RLON1
         RLAT2=(KEY(13)-9000000)/100000.
         RLON2=(KEY(12)-18000000)/100000.
         WRITE(KNT,'(1H ,A,F9.2)')'LATITUDE  2               ', RLAT2
         WRITE(KNT,'(1H ,A,F9.2)')'LONGITUDE 2               ', RLON2
         WRITE(KNT,'(1H ,A,I9)') 'NUMBER OF OBSERVATIONS    ', KEY(14)
         WRITE(KNT,'(1H ,A,I9)') 'IDENTIFIER                ', KEY(15)
         WRITE(KNT,'(1H ,A,I9)') 'TOTAL BUFR MESSAGE LENGTH ', KEY(25)
         WRITE(KNT,'(1H ,A,I9)') 'DAY    (RDB INSERTION)    ', KEY(26)
         WRITE(KNT,'(1H ,A,I9)') 'HOUR   (RDB INSERTION)    ', KEY(27)
         WRITE(KNT,'(1H ,A,I9)') 'MINUTE( (RDB INSERTION)   ', KEY(28)
         WRITE(KNT,'(1H ,A,I9)') 'SECOND (RDB INSERTION)    ', KEY(29)
         WRITE(KNT,'(1H ,A,I9)') 'DAY    (MDB ARRIVAL)      ', KEY(30)
         WRITE(KNT,'(1H ,A,I9)') 'HOUR   (MDB ARRIVAL)      ', KEY(31)
         WRITE(KNT,'(1H ,A,I9)') 'MINUTE (MDB ARRIVAL)      ', KEY(32)
         WRITE(KNT,'(1H ,A,I9)') 'SECOND (MDB ARRIVAL       ', KEY(33)
         WRITE(KNT,'(1H ,A,I9)') 'CORRECTION NUMBER         ', KEY(34)
         WRITE(KNT,'(1H ,A,I9)') 'PART OF MESSAGE           ', KEY(35)
         WRITE(KNT,'(1H ,A,I9)') 'CORRECTION NUMBER         ', KEY(37)
         WRITE(KNT,'(1H ,A,I9)') 'PART OF MESSAGE           ', KEY(38)
         WRITE(KNT,'(1H ,A,I9)') 'CORRECTION NUMBER         ', KEY(40)
         WRITE(KNT,'(1H ,A,I9)') 'PART OF MESSAGE           ', KEY(41)
         WRITE(KNT,'(1H ,A,I9)') 'CORRECTION NUMBER         ', KEY(43)
         WRITE(KNT,'(1H ,A,I9)') 'PART OF MESSAGE           ', KEY(44)
         WRITE(KNT,'(1H ,A,I9)') 'QUALITY CONTROL % CONF    ', KEY(46)
      ELSE
         WRITE(KNT,'(1H ,A,I9)') 'RDB DATA TYPE             ', KEY(2)
         WRITE(KNT,'(1H ,A,I9)') 'RDB DATA SUBTYPE          ', KEY(3)
         WRITE(KNT,'(1H ,A,I9)') 'YEAR                      ', KEY(4)
         WRITE(KNT,'(1H ,A,I9)') 'MONTH                     ', KEY(5)
         WRITE(KNT,'(1H ,A,I9)') 'DAY                       ', KEY(6)
         WRITE(KNT,'(1H ,A,I9)') 'HOUR                      ', KEY(7)
         WRITE(KNT,'(1H ,A,I9)') 'MINUTE                    ', KEY(8)
         WRITE(KNT,'(1H ,A,I9)') 'SECOND                    ', KEY(9)
         RLAT1=(KEY(11)-9000000)/100000.
         RLON1=(KEY(10)-18000000)/100000.
         WRITE(KNT,'(1H ,A,F9.2)')'LATITUDE  1               ', RLAT1
         WRITE(KNT,'(1H ,A,F9.2)')'LONGITUDE 1               ', RLON1
         IDD=0
         CIDENT=' '
         DO 201 ID=16,24
         IDD=IDD+1
         CIDENT(IDD:IDD)=CHAR(KEY(ID))
 201     CONTINUE
         IDD=INDEX(CIDENT,' ')
         IF(IDD.EQ.0) IDD=10
         IDD=10-IDD
         WRITE(YFM(10:10),'(I1)',ERR=202) IDD
         GO TO 203
 202     YFM(10:10)='9'
 203     WRITE(KNT,FMT=YFM)      'IDENTIFER                 ', CIDENT
         WRITE(KNT,'(1H ,A,I9)') 'TOTAL BUFR MESSAGE LENGTH ', KEY(25)
         WRITE(KNT,'(1H ,A,I9)') 'DAY    (RDB INSERTION)    ', KEY(26)
         WRITE(KNT,'(1H ,A,I9)') 'HOUR   (RDB INSERTION)    ', KEY(27)
         WRITE(KNT,'(1H ,A,I9)') 'MINUTE (RDB INSERTION)    ', KEY(28)
         WRITE(KNT,'(1H ,A,I9)') 'SECOND (RDB INSERTION)    ', KEY(29)
         WRITE(KNT,'(1H ,A,I9)') 'DAY    (MDB ARRIVAL)      ', KEY(30)
         WRITE(KNT,'(1H ,A,I9)') 'HOUR   (MDB ARRIVAL)      ', KEY(31)
         WRITE(KNT,'(1H ,A,I9)') 'MINUTE (MDB ARRIVAL)      ', KEY(32)
         WRITE(KNT,'(1H ,A,I9)') 'SECOND (MDB ARRIVAL       ', KEY(33)
         WRITE(KNT,'(1H ,A,I9)') 'CORRECTION NUMBER         ', KEY(34)
         WRITE(KNT,'(1H ,A,I9)') 'PART OF MESSAGE           ', KEY(35)
         WRITE(KNT,'(1H ,A,I9)') 'CORRECTION NUMBER         ', KEY(37)
         WRITE(KNT,'(1H ,A,I9)') 'PART OF MESSAGE           ', KEY(38)
         WRITE(KNT,'(1H ,A,I9)') 'CORRECTION NUMBER         ', KEY(40)
         WRITE(KNT,'(1H ,A,I9)') 'PART OF MESSAGE           ', KEY(41)
         WRITE(KNT,'(1H ,A,I9)') 'CORRECTION NUMBER         ', KEY(43)
         WRITE(KNT,'(1H ,A,I9)') 'PART OF MESSAGE           ', KEY(44)
         WRITE(KNT,'(1H ,A,I9)') 'QUALITY CONTROL % CONF    ', KEY(46)
      END IF
C
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE SETLALO(K,KLA,KLO,KERR)
C
C     RETURN INDICES FOR LATITUDE AND LONGITUDE
C
      KERR=0
C
      IF(K.EQ.1) THEN
         KLA=9
         KLO=10
         RETURN
      ELSEIF(K.EQ.2) THEN
         KLA=9
         KLO=10
         RETURN
      ELSEIF(K.EQ.3) THEN
         KLA=9
         KLO=10
         RETURN
      ELSEIF(K.EQ.4) THEN
         KLA=9
         KLO=10
         RETURN
      ELSEIF(K.EQ.7) THEN
         KLA=9
         KLO=10
         RETURN
      ELSEIF(K.EQ.9) THEN
         KLA=10
         KLO=11
         RETURN
      ELSEIF(K.EQ.11) THEN
         KLA=10
         KLO=11
         RETURN
      ELSEIF(K.EQ.13) THEN
         KLA=10
         KLO=11
         RETURN
      ELSEIF(K.EQ.19) THEN
         KLA=10
         KLO=11
         RETURN
      ELSEIF(K.EQ.21) THEN
         KLA=10
         KLO=11
         RETURN
      ELSEIF(K.EQ.22) THEN
         KLA=10
         KLO=11
         RETURN
      ELSEIF(K.EQ.23) THEN
         KLA=10
         KLO=11
         RETURN
      ELSEIF(K.EQ.51) THEN
         KLA=8
         KLO=9
         RETURN
      ELSEIF(K.EQ.53) THEN
         KLA=8
         KLO=9
         RETURN
      ELSEIF(K.EQ.54) THEN
         KLA=22
         KLO=23
         RETURN
      ELSEIF(K.EQ.55) THEN
         KLA=22
         KLO=23
         RETURN
       ELSEIF(K.EQ.61) THEN
         KLA=9
         KLO=10
         RETURN
       ELSEIF(K.EQ.62) THEN
         KLA=9
         KLO=10
         RETURN
       ELSEIF(K.EQ.63) THEN
         KLA=9
         KLO=10
         RETURN
       ELSEIF(K.EQ.71) THEN
         KLA=9
         KLO=10
         RETURN
       ELSEIF(K.EQ.72) THEN
         KLA=9
         KLO=10
         RETURN
       ELSEIF(K.EQ.73) THEN
         KLA=9
         KLO=10
         RETURN
       ELSEIF(K.EQ.82) THEN
         KLA=9
         KLO=10
         RETURN
       ELSEIF(K.EQ.83) THEN
         KLA=9
         KLO=10
         RETURN
       ELSEIF(K.EQ.84) THEN
         KLA=9
         KLO=10
         RETURN
       ELSEIF(K.EQ.85) THEN
         KLA=9
         KLO=10
         RETURN
       ELSEIF(K.EQ.86) THEN
         KLA=9
         KLO=10
         RETURN
       ELSEIF(K.EQ.87) THEN
         KLA=12
         KLO=13
         RETURN
       ELSEIF(K.EQ.88) THEN
         KLA=9
         KLO=10
         RETURN
      ELSEIF(K.EQ.89) THEN
         KLA=12
         KLO=13
         RETURN
      ELSEIF(K.EQ.91) THEN
         KLA=10
         KLO=11
         RETURN
      ELSEIF(K.EQ.92) THEN
         KLA=10
         KLO=11
         RETURN
      ELSEIF(K.EQ.95) THEN
         KLA=3 
         KLO=4
         RETURN
      ELSEIF(K.EQ.96) THEN
         KLA=9
         KLO=10
         RETURN
      ELSEIF(K.EQ.97) THEN
         KLA=9
         KLO=10
         RETURN
      ELSEIF(K.EQ.101) THEN
         KLA=10
         KLO=11
         RETURN
      ELSEIF(K.EQ.102) THEN
         KLA=11
         KLO=12
         RETURN
      ELSEIF(K.EQ.103) THEN
         KLA=11
         KLO=12
         RETURN
      ELSEIF(K.EQ.104) THEN
         KLA=15
         KLO=16
         RETURN
      ELSEIF(K.EQ.106) THEN
         KLA=11
         KLO=12
         RETURN
      ELSEIF(K.EQ.121) THEN
         KLA=10
         KLO=11
         RETURN
      ELSEIF(K.EQ.122) THEN
         KLA=10
         KLO=11
         RETURN
      ELSEIF(K.EQ.123) THEN
         KLA=10
         KLO=11
         RETURN
      ELSEIF(K.EQ.126) THEN
         KLA=9
         KLO=10
         RETURN
      ELSEIF(K.EQ.127) THEN
         KLA=11
         KLO=12
         RETURN
      ELSEIF(K.EQ.129) THEN
         KLA=11
         KLO=12
         RETURN
      ELSEIF(K.EQ.130) THEN
         KLA=11
         KLO=12
         RETURN
      ELSEIF(K.EQ.131) THEN
         KLA=10
         KLO=11
         RETURN
      ELSEIF(K.EQ.132) THEN
         KLA=7
         KLO=8
         RETURN
      ELSEIF(K.EQ.133) THEN
         KLA=7
         KLO=8
         RETURN
      ELSEIF(K.EQ.136) THEN
         KLA=14
         KLO=15
         RETURN
      ELSEIF(K.EQ.137) THEN
         KLA=16
         KLO=17
         RETURN
      ELSEIF(K.EQ.142) THEN
         KLA=8
         KLO=9
         RETURN
      ELSEIF(K.EQ.144) THEN
         KLA=8
         KLO=9
         RETURN
      ELSEIF(K.EQ.145) THEN
         KLA=15
         KLO=16
         RETURN
      ELSEIF(K.EQ.164) THEN
         KLA=6
         KLO=7
         RETURN
      ELSEIF(K.EQ.255) THEN
         KLA=8
         KLO=9
         RETURN
      ELSE
         PRINT*,'POINTERS FOR ',K,' SYBTYPE NOT DEFINED.'
         KERR=1
         KLA=0
         KLO=0
         RETURN
      END IF
C
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE BUEDD(KPT,KTDLEN,KTDLST,KDLEN,KDATA,KSEC3,
     1                 KVALS,VALUES,KELEM,CNAMES,CUNITS,KERR)
C
C**** *BUEDD*
C
C
C     PURPOSE.
C     --------
C
C          EXPAND SECTION 3 OF BUFR MESSAGE.
C
C
C**   INTERFACE.
C     ----------
C
C          *CALL* *BUEDD(KPT,KTDLEN,KTDLST,KDLEN,KDATA,KSEC3,
C                        KVALS,VALUES,KELEM,CNAMES,CUNITS,KERR)
C
C        INPUT :
C               *KPT*     -  POINTER TO KDATA ARRAY
C               *KTDLEN*  -  NUMBER OF DATA DESCRIPTORS IN SECTION 3
C               *KTDLST*  -  ARRAY CONTAINING DATA DESCRIPTORS IN SECTION 3
C               *KDLEN*   -  DIMENSION OF KDATA ARRAY
C               *KDATA*   -  ARRAY CONTAINING DATA NEEDED FOR DATA DESCRIPTOR
C                            EXPANSION
C               *KSEC3*   -  ARRAY CONTAINING SECTION 3 INFORMATION
C                            KSEC3( 1)-- LENGTH OF SECTION 3 (BYTES)
C                            KSEC3( 2)-- RESERVED
C                            KSEC3( 3)-- NUMBER OF SUBSETS
C                            KSEC3( 4)-- FLAG (DATA TYPE,DATA COMPRESSION)
C        OUTPUT :
C               *KERR*    -  RETURNED ERROR CODE
C
C     METHOD.
C     -------
C           DATA DESCRIPTOR TAKEN FROM KTDLST ARRAY ARE FULLY
C        EXPANDED USING DATA FROM KDATA ARRAY IF NEEDED.
C        ( DELAYED REPLICATION FACTORS ETC.)
C
C
C     EXTERNALS.
C     ----------
C
C          BUNEXS        - SET WORD AND BIT POINTERS AT THE BEGINING OF
C                          NEXT SECTION
C          BUNPCK        - UNPACKS BIT PATHERN
C          BUREP         - SOLVES REPLICATION PROBLEM
C          BUETDR        - SOLVES TABLE D REFERENCE
C          BUOPER        - PROCESS OPERATOR
C          BUEPWT        - UPDATES WORKING TABLE
C
C     REFERENCE.
C     ----------
C
C          NONE.
C
C     AUTHOR.
C     -------
C
C          M. DRAGOSAVAC    *ECMWF*       01/02/91.
C
C
C     MODIFICATIONS.
C     --------------
C
C          NONE.
C
C
      IMPLICIT LOGICAL(L,O,G), CHARACTER*8(C,H,Y)
C
C
#     include "parameter.F"
#     include "bcomunit.F"
#     include "bcmwork.F"
#     include "bcmbef.F"
#     include "bcmwt.F"
#     include "bcmwtc.F"
#     include "bcmel.F"
C
      CHARACTER CWTEN*64,CWTU*24
      CHARACTER*64 CNAMES(KELEM)
      CHARACTER*24 CUNITS(KELEM)
C
#ifndef R_4
      REAL*8 VALUES(KVALS)
      REAL*8 RVIND
      REAL*8 EPS
#else
      REAL   VALUES(KVALS)
      REAL   RVIND
      REAL   EPS
#endif
C
      DIMENSION ISTACK(JELEM),IISTACK(JELEM)
      DIMENSION IMASK(8)
C
      DIMENSION KSEC3(JSEC3)
      DIMENSION KDATA(KDLEN),KTDLST(KTDLEN)
C
      DATA IMASK/1,2,4,8,16,32,64,128/
C     ------------------------------------------------------------------
C
C*          1.
C                --------------------------------------
 100  CONTINUE
C
      IF( KERR.NE.0 ) RETURN
C
      N = KSEC3(3)
      NOLD = 0
C
C
C*          2.   EXPAND DATA DESCRIPTORS.
C                ------------------------
 200  CONTINUE
C
C
C*          2.1  SET EXPECTED NUMBER OF DATA DESCRIPTORS.
C                ----------------------------------------
C                AND INITIALIZE NUMBER OF DATA VALUES PER SUB-SET.
C                -------------------------------------------------
 210  CONTINUE
C
      J      = 0
      KPT    = 0
      NWT    = 0
      JMAX   = KTDLEN
      JMAXNEW=JMAX
C
      IF(KTDLEN.GT.JELEM) THEN
         WRITE(KNTN,*) ' BUETD :'
         KERR=29
         CALL BUERR(KERR)
         RETURN
      END IF
C
C*          2.2  PUT DATA DESCRIPTORS IN STACK.
C                ------------------------------
 220  CONTINUE
C
      DO 221 JJ=1,JMAX
C
      ISTACK(JJ)=KTDLST(JJ)
      IISTACK(JJ)=ISTACK(JJ)
C
 221  CONTINUE
C
C*          2.2.1 CHECK IF IT IS SAME DATA DESCRIPTOR DESCRIOPTION.
C                 -------------------------------------------------
C                 TO MAKE MORE EFFICIENT DATA DESCRIPTOR DESCRIPTION
C                 EXPANSION, IN CASE THAT DELAYED REPLICATION FACTOR
C                 IS NOT PRESENT AND DATA DESCRIPTORS ARE THE SAME,
C                 PREVIOUS WORKING TABLE SHOULD BE USED. IT IS POSIBLE
C                 AT THIS PLACE IN THE FUTURE TO MAKE MORE SOPHISTICATED
C                 CONTROL.
C
C
      DO 222 JC=1,JMAX
C
      IF(ISTACK(JC).NE.NSTACK(JC)) THEN
C
C
         ODREPF=.FALSE.
C
C        SWAP CONTENT OF THE STACKS.
C
         DO 223 JJC=1,JMAX
         NSTACK(JJC)=ISTACK(JJC)
 223     CONTINUE
C
         NTDLEN = JMAX
         M=0
         NOLD=N
         NFCM=0
         MREL=0
         OMARKER=.FALSE.
         MBMP=0
         MBMPL=0
C
         GO TO 230
C
      END IF
C
 222  CONTINUE
C
C
C*    IF MARKER OPERATOR PRESENT EXPAND DESCRIPTORS AGAIN
C
      IF(OMARKER) THEN
         M=0
         NOLD=N
         NFCM=0
         MREL=0
         OMARKER=.FALSE.
         NTDLEN=JMAX
         MBMP=0
         MBMPL=0
         GO TO 230
      END IF
C
C*    RETURN IF DELAYED REPLICATION FACTOR IS NOT PRESENT.
C
      IF(JMAX.NE.NTDLEN) THEN
         M=0
         NOLD=N
         NFCM=0
         MREL=0
         OMARKER=.FALSE.
         NTDLEN=JMAX
         MBMP=0
         MBMPL=0
         GO TO 230
      END IF
C
      OB=.FALSE.
      IF(IAND(KSEC3(4),IMASK(7)).NE.0)  OB=.TRUE.
C
      IF(ODREPF) GO TO 229
C
      IF(.NOT.ODREPF) THEN
         IF(N.GT.NOLD) NOLD=N
         IF(OB.AND.NFCM.EQ.1)      GO TO 300
         IF(.NOT.OB.AND.NFCM.EQ.0) GO TO 300
      END IF
C
 229  CONTINUE
C
      M=0
      NOLD=N
      NFCM=0
      MREL=0
      OMARKER=.FALSE.
      NTDLEN=JMAX
      MBMP=0
      MBMPL=0
C
C     ------------------------------------------------------------------
C*          2.3  GET NEXT DESCRIPTOR FROM THE STACK.
C                -----------------------------------
 230  CONTINUE
C
      J   = J + 1
      IF(J.GT.JMAX) GO TO 270
C
      IDD = ISTACK(J)
      IF(IDD.EQ.0)  GO TO 230
C
      IF = IDD/100000
C
C     ------------------------------------------------------------------
C*          2.4  CHECK IF IT IS REPLICATION DESCRIPTOR.
C                --------------------------------------
 240  CONTINUE
C
      IF(IF.EQ.0) THEN
C
C*          2.6  ELEMENT DESCRIPTOR, SO UPDATE WORKING TABLE.
C                --------------------------------------------
 260     CONTINUE
C
c        IF(IDD.EQ.31031.OR.IDD.EQ.31192) THEN
c           NWT=NWT+1
c           NWTR(NWT)=IDD
c           NWTS(NWT)=0
c           NWTRV(NWT)=0
c           NWTDW(NWT)=1
c           NWTEN(NWT)=0
c           CWTEN(NWT)='DATA PRESENT INDICATOR'
c           CWTU (NWT)='FLAG TABLE 031031'
c           M=M+1
c        ELSEIF(IDD.EQ.33007.OR.IDD.EQ.63192) THEN
c           NWT=NWT+1
c           NWTR(NWT)=IDD
c           NWTS(NWT)=0
c           NWTRV(NWT)=0
c           NWTDW(NWT)=7
c           NWTEN(NWT)=0
c           CWTEN(NWT)='% CONFIDENCE'
c           CWTU (NWT)='%'
c           M=M+1
c        ELSE
            CALL BUEPWTC(IDD,KERR)
            IF(KERR.GT.0) RETURN
c        END IF
      ELSEIF(IF.EQ.1) THEN
C
C*          2.4.1     SOLVE REPLICATION PROBLEM.
C                     --------------------------
C
         CALL BUREPC(KPT,KDLEN,KDATA,J,JMAX,IDD,ISTACK,KERR)
         IF(KERR.GT.0) RETURN
C
      ELSEIF(IF.EQ.2) THEN
C
C
C*          2.5.3 PROCESS OPERATOR.
C                 -----------------
         CALL BUOPERC(KPT,KDLEN,KDATA,J,IDD,ISTACK,KERR)
         IF(KERR.GT.0) RETURN
C
      ELSEIF(IF.EQ.3) THEN
C
C
C*          2.5.2 REPLACE BY LIST OF DESCRIPTORS FROM TABLE *D.
C                 ---------------------------------------------
         CALL BUETDR(J,JMAX,IDD,ISTACK,KERR)
         IF(KERR.GT.0) THEN
            DO 252 IQ=1,JELEM
            NSTACK(IQ)=0.
 252        CONTINUE
            RETURN
         END IF
      ELSE
         KERR=37
         CALL BUERR(KERR)
         RETURN
      END IF
C
      GO TO 230
C
C     ------------------------------------------------------------------
C*          2.7 RESOLVE MARKER OPERATOR.
C               ------------------------
 270  CONTINUE
C
C      IF(OMARKER) THEN
C         CALL BUEPMRKC(KSEC3,KVALS,VALUES,KELEM,CNAMES,CUNITS,KERR)
C         IF(KERR.GT.0) RETURN
C      END IF
C
C     ------------------------------------------------------------------
C
C*          3. COLLECT  SUPPLEMENTARY ITEMS.
C              -----------------------------
 300  CONTINUE
C
      NTDEXL =M
      DO 301 I=1,NTDEXL
      NTDEXP(I)=NWTR(I)
 301  CONTINUE
C
      NTDLEN=JMAXNEW
      DO 302 I=1,NTDLEN
      NTDLST(I)=IISTACK(I)
 302  CONTINUE
C
      DO 303 I=1,M
      CNAMES(I)=CWTEN(I)
      CUNITS(I)=CWTU (I)
 303  CONTINUE
C
      RETURN
      END

 MODULE bufr_module

       implicit none

!-- BUFR variable

    real*8   , parameter      :: rvind=1.7D38
    real*8   , parameter      :: eps=1.0D-8
    integer, parameter      :: nvind=2147483647

    integer, parameter :: jsup =   9
    integer, parameter :: jsec0=   3
    integer, parameter :: jsec1=  40
    integer, parameter :: jsec2=  4096
    integer, parameter :: jsec3=   4
    integer, parameter :: jsec4=   2
    integer, parameter :: jelem=160000
    integer, parameter :: jbufl=512000
#ifdef JBPW_64
    integer, parameter :: jbpw =  64
#else
    integer, parameter :: jbpw =  32
#endif
    integer, parameter :: jwork=4096000
    integer, parameter :: jkey=46
    integer, parameter :: jbyte=512000
    integer, parameter :: kelem=160000
    integer, parameter :: kvals=4096000

    integer, dimension(jbufl) :: kbuff, kbufr
    integer, dimension(jsup)  :: ksup
    integer, dimension(jsec0) :: ksec0
    integer, dimension(jsec1) :: ksec1
    integer, dimension(jsec2) :: ksec2
    integer, dimension(jsec3) :: ksec3
    integer, dimension(jsec4) :: ksec4
    integer, dimension(jkey)  :: key
    real*8,    dimension(kvals) :: values, vals
    integer, dimension(kelem) :: ktdlst
    integer, dimension(kelem) :: ktdexp
    integer, dimension(kelem) :: kdata
    integer                   :: kbox

    integer                   :: kbufl
    integer                   :: ktdlen
    integer                   :: ktdexl
    integer                   :: kapp
    integer                   :: klen
    integer, dimension(kvals) :: kboxr


    character(len= 64), dimension(kelem) :: cnames
    character(len= 24), dimension(kelem) :: cunits
    character(len= 80), dimension(kvals) :: cvals
    character(len= 24), dimension(kelem) :: cboxu
    character(len= 64), dimension(kelem) :: cboxn


 END MODULE bufr_module

C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      INTEGER FUNCTION DSVSEC2(KGRIB,KLENG,INSPT,KSEC2,IBITS,ILEN2)
C
C---->
C**** DSVSEC2P
C
C     PURPOSE
C     _______
C
C     Decodes GRIB section 2 values for space view fields.
C
C     INTERFACE
C     _________
C
C     IRET = DSVSEC2(KGRIB,KLENG,INSPT,KSEC2,IBITS)
C
C     Input parameters
C     ________________
C
C     KGRIB   - GRIB product unpacked so far (upto octet 6). 
C     KLENG   - Length of KGRIB.
C     INSPT   - Bit position of GRIB product unpacked so far.
C     KSEC2   - GRIB section 2 description.
C     IBITS   - Number of bits per element in KGRIB.
C     ILEN2   - Length in bytes of section 2
C     
C
C     Output parameters
C     ________________
C
C     KSEC2   - Updated GRIB section 2 description.
C     INSPT   - Updated bit position of GRIB product built so far.
C     IRET    - Function return status code, 0 = OK
C
C     Common block usage
C     __________________
C
C     None.
C
C     Method
C     ______
C
C     Unpacks values given in KGRIB into KSEC2 and updates bit
C     pointer INSPT.
C
C     Externals
C     _________
C
C     DSGNBT  - Get the sign bit and adjust value to +/-.
C     INXBIT  - Insert bit data.
C
C
C     AUTHOR
C     ______
C
C     J.D.Chambers       ECMWF     February 1999
C
C     MODIFICATIONS
C     _____________
C
C     None.
C
C----<
C     _______________________________________________________
C
C     Section 0. Definition of variables.
C     _______________________________________________________
C
      IMPLICIT NONE
C
#include "grprs.h"
C
C     Parameters
C
      INTEGER JP16SET
      PARAMETER ( JP16SET = 2**16 - 1 ) 
C                            ^---> 65535    =   FFFF(hex)
C
C     Function arguments
C
      INTEGER KGRIB,KLENG,INSPT,KSEC2,IBITS,ILEN2
      DIMENSION KGRIB(*),KSEC2(*)
C
C     Local variables
C
      INTEGER ILALO(2), IRET, IRESOL
C
C     _______________________________________________________
C
C     Section 1.    Initialization.
C     _______________________________________________________
C
  100 CONTINUE
C
      DSVSEC2 = 0
C
C     _______________________________________________________
C
C     Section 2.    Unpack section 2 octets.
C     _______________________________________________________
C
  200 CONTINUE
C
C      Octets 7 - 8  : Nx - number of points along X-axis.
C      Octets 9 - 10 : Ny - number of points along Y-axis.
C      Two 16 bit fields.
C 
       CALL INXBIT(KGRIB,KLENG,INSPT,KSEC2(2),2,IBITS, 16,'D',IRET)
       IF( IRET.NE.0 ) THEN
         DSVSEC2 = 1
         WRITE(GRPRSM,*) 'DSVSEC2: Error extracting'
         WRITE(GRPRSM,*) 'DSVSEC2: number of points along X or Y axis.'
         WRITE(GRPRSM,*) 'DSVSEC2: Return code = ', IRET
         GO TO 900
       ENDIF
C 
C      Octets 11 - 13 : Lap - latitude of sub-satellite point.
C      Octets 14 - 16 : Lop - longitude of sub-satellite point.
C      Two 24 bit fields.
C 
       CALL INXBIT(KGRIB,KLENG,INSPT,ILALO(1),2,IBITS, 24,'D',IRET)
       IF( IRET.NE.0 ) THEN
         DSVSEC2 = 1
         WRITE(GRPRSM,*) 'DSVSEC2: Error extracting'
         WRITE(GRPRSM,*)
     X     'DSVSEC2: latitude/longitude of sub-satellite pt.'
         WRITE(GRPRSM,*) 'DSVSEC2: Return code = ', IRET
         GO TO 900
       ENDIF
C 
C      If sign bit is 1, value is negative.
C 
       CALL DSGNBT( KSEC2(4), ILALO(1), 24, IRET)
       CALL DSGNBT( KSEC2(5), ILALO(2), 24, IRET)
C 
C      Octet 17 : Resolution and components flag.
C      One 8 bit field.
C 
       CALL INXBIT(KGRIB,KLENG,INSPT,IRESOL,1,IBITS, 8,'D',IRET)
       IF( IRET.NE.0 ) THEN
         DSVSEC2 = 1
         WRITE(GRPRSM,*) 'DSVSEC2: Error extracting'
         WRITE(GRPRSM,*) 'DSVSEC2: components flag.'
         WRITE(GRPRSM,*) 'DSVSEC2: Return code = ', IRET
         GO TO 900
       ENDIF
C 
C      All flag fields are already set to 0, so
C
       IF( IRESOL.EQ.0 ) GO TO 214
C
C      Resolution flag is not applicable.
C
       IF( IRESOL.GE.128) IRESOL = IRESOL - 128
C
C      Set earth flag.
C
       IF( IRESOL.GE.64) THEN
         KSEC2(18) = 64
         IRESOL    = IRESOL - 64
       ENDIF
C 
C      Set components flag.
C 
       KSEC2(19) = IRESOL
C 
  214  CONTINUE
C 
C      Octets 18 - 20 : dx Apparent diameter of earth in grid
C                       lengths in x direction.
C      Octets 21 - 23 : dy Apparent diameter of earth in grid
C                       lengths in y direction.
C      Two 24 bit fields.
C 
       CALL INXBIT(KGRIB,KLENG,INSPT,KSEC2(7),2,IBITS, 24,'D',IRET)
       IF( IRET.NE.0 ) THEN
         DSVSEC2 = 1
         WRITE(GRPRSM,*) 'DSVSEC2: Error extracting'
         WRITE(GRPRSM,*) 'DSVSEC2: number of points along X or Y axis.'
         WRITE(GRPRSM,*) 'DSVSEC2: Return code = ', IRET
         GO TO 900
       ENDIF
C 
C      Octets 24 - 25 : Xp X-coordinate of sub-satellite point.
C      Octets 26 - 27 : Yp Y-coordinate of sub-satellite point.
C      Two 16 bit fields.
C 
       CALL INXBIT(KGRIB,KLENG,INSPT,KSEC2(9),2,IBITS, 16,'D',IRET)
       IF( IRET.NE.0 ) THEN
         DSVSEC2 = 1
         WRITE(GRPRSM,*) 'DSVSEC2: Error extracting'
         WRITE(GRPRSM,*)
     X     'DSVSEC2: X or Y coordinate of sub-satellite point.'
         WRITE(GRPRSM,*) 'DSVSEC2: Return code = ', IRET
         GO TO 900
       ENDIF
C 
C      Octet 28 : Scanning mode flags.
C      One 8 bit field.
C 
       CALL INXBIT(KGRIB,KLENG,INSPT,KSEC2(11),1,IBITS, 8,'D',IRET)
       IF( IRET.NE.0 ) THEN
         DSVSEC2 = 1
         WRITE(GRPRSM,*) 'DSVSEC2: Error extracting'
         WRITE(GRPRSM,*) 'DSVSEC2: scanning mode flags.'
         WRITE(GRPRSM,*) 'DSVSEC2: Return code = ', IRET
         GO TO 900
       ENDIF
C 
C     Octets 29 - 31 : The orientation of the grid.
C     Octets 32 - 34 : nr the altitude of the camera.
C     Two 24 bit fields.
C 
      CALL INXBIT(KGRIB,KLENG,INSPT,KSEC2(13),2,IBITS, 24,'D',IRET)
      IF( IRET.NE.0 ) THEN
        DSVSEC2 = 1
        WRITE(GRPRSM,*) 'DSVSEC2: Error extracting'
        WRITE(GRPRSM,*)
     X     'DSVSEC2: orientation of the grid or camera angle.'
        WRITE(GRPRSM,*) 'DSVSEC2: Return code = ', IRET
        GO TO 900
      ENDIF
C 
C     Octets 35 - 36 : Xo - X coordinate of origin of sector
C                             image.
C     Octets 37 - 38 : Yo - Y coordinate of origin of sector
C                             image.
C     Two 16 bit fields.
C 
      CALL INXBIT(KGRIB,KLENG,INSPT,KSEC2(15),2,IBITS, 16,'D',IRET)
      IF( IRET.NE.0 ) THEN
        DSVSEC2 = 1
        WRITE(GRPRSM,*) 'DSVSEC2: Error extracting'
        WRITE(GRPRSM,*)
     X     'DSVSEC2: X or Y coordinates of origin of sector.'
        WRITE(GRPRSM,*) 'DSVSEC2: Return code = ', IRET
        GO TO 900
      ENDIF
C
C     Octets 39 - 40 : Reserved (ECMWF).
C     Octets 39 - 44 : Reserved (GRIB specification).
C 
C     Update bit pointer.
C
      INSPT = INSPT + (ILEN2 - 38) * 8
C 
C     _______________________________________________________
C 
C     Section 9. Return to calling routine.
C     _______________________________________________________
C 
  900 CONTINUE
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities
C granted to it by virtue of its status as an intergovernmental organisation
C nor does it submit to any jurisdiction.
C

      INTEGER FUNCTION IRDIWE(KLLEN,KINS,KNSIND,KONS,KILONG,KIWEMAX,
     1  KOLONG,KOWE,KWEIND,KWEDIST,IAREA,OAREA,KPR,KERR)
C
C---->
C**** *IRDIWE*
C
C     PURPOSE
C     _______
C
C     Calculate the distances between points in an output longitude
C     array and its West and East neighbours in the input longitude
C     array for a quasi regular input field and regular output field.
C
C     INTERFACE
C     _________
C
C     IERR = IRDIWE(KLLEN,KINS,KNSIND,KONS,KILONG,KIWEMAX,
C    1  KOLONG,KOWE,KWEIND,KWEDIST,IAREA,OAREA,KPR,KERR)
C
C     Input parameters
C     ________________
C
C     KLLEN      - This array contains the quasi regular Gaussian
C                  line length definition.
C
C     KINS       - The number of points in the North-South direction
C                  in the input field.
C
C     KNSIND     - This array will contain the array offsets of the
C                  North and South points in the input array required
C                  for interpolation.
C
C     KONS       - The number of points in the North-South direction
C                  in the output field.
C
C     KILONG     - The array of input longitudes.
C
C     KIWEMAX    - The maximum number of points in the West-East
C                  direction for this quasi regular Gaussian grid.
C
C     KOLONG     - The array of output longitudes.
C
C     KOWE       - The number of points in the West-East direction in
C                  the output field.
C
C     IAREA      - Input field area definition (N/W/S/E).
C
C     OAREA      - output field area definition (N/W/S/E).
C
C     KPR        - The debug print switch.
C                  0  , No debugging output.
C                  1  , Produce debugging output.
C
C     KERR       - The error control flag.
C                  -ve, No error message. Return error code.
C                  0  , Hard failure with error message.
C                  +ve, Print error message. Return error code.
C
C     Output parameters
C     ________________
C
C     KWEIND     - This array will contain the array offsets of
C                  the West and East points in the input array
C                  required for interpolation for all lines of
C                  latitude.
C
C     KWEDIST    - This array holds the distances to longitude values
C                  in the input field from the associated longitude
C                  values in the output field. This array is
C                  dimensioned (2, KOWE, 2, KONS).
C
C     Return value
C     ____________
C
C     The error indicator (INTEGER).
C
C     Error and Warning Return Values
C     _______________________________
C
C     None
C
C     Common block usage
C     __________________
C
C     None
C
C     EXTERNALS
C     _________
C
C     IGDIWE     - Calculate the distances between points in an
C                  output longitude array and its West and East
C                  neighbours in the input longitude array for one
C                  line of latitude.
C     INTLOG(R)  - Logs messages.
C
C     METHOD
C     ______
C
C     This routine will create the arrays of offsets and distance as
C     two arrays of length (2, Number of output longitudes, 2,
C     Number of output latitudes).
C
C     The array of offsets is copied from line to line provided the
C     number of points in the quasi regular lines of latitude does
C     not change. When the definition changes IGDIWE is used to
C     generate the offsets and distances for the new line definition.
C
C----<

C     ------------------------------------------------------------------
C*    Section 0. Definition of variables
C     ------------------------------------------------------------------
      IMPLICIT NONE

#include "parim.h"

C     Arguments
      INTEGER IAREA(4)
      INTEGER OAREA(4)
      INTEGER KINS
      INTEGER KONS
      INTEGER KIWEMAX
      INTEGER KOWE
      INTEGER KPR
      INTEGER KERR
      INTEGER KLLEN (KINS)
      INTEGER KNSIND (2,KONS)
      INTEGER KILONG (KIWEMAX+1)
      INTEGER KOLONG (KOWE)
      INTEGER KWEIND (2,KOWE,2,KONS)
      INTEGER KWEDIST(2,KOWE,2,KONS)

C     Local variables
      LOGICAL GWEGLOBE
      INTEGER KIWE
      INTEGER ISTRIDE
      INTEGER IERR
      INTEGER IBLON
      INTEGER IBNS
      INTEGER IBLAT
      INTEGER JLAT
      INTEGER JLON
      INTEGER JNS
      INTEGER JPROUTINE
      PARAMETER (JPROUTINE = 23900)

C     External functions
      INTEGER IGDIWE
      EXTERNAL IGDIWE

C     ------------------------------------------------------------------
C*    Section 1. Initialisation
C     ------------------------------------------------------------------
  100 CONTINUE

      IF (KPR.GE.1) CALL INTLOG(JP_DEBUG,'IRDIWE: Section 1.',JPQUIET)

      IRDIWE = 0

      IF (KPR .GE. 1) THEN
        CALL INTLOG(JP_DEBUG,'IRDIWE: Input parameters.',JPQUIET)
        CALL INTLOG(JP_DEBUG,'IRDIWE: Max no.input longs  = ',KIWEMAX)
        CALL INTLOG(JP_DEBUG,'IRDIWE: No.input lats       = ',KINS)
        CALL INTLOG(JP_DEBUG,'IRDIWE: No.output longs     = ',KOWE)
        CALL INTLOG(JP_DEBUG,'IRDIWE: No.output lats      = ',KONS)
        CALL INTLOG(JP_DEBUG,'IRDIWE: Output field spread = ',KOLONG(1))
        CALL INTLOG(JP_DEBUG,'IRDIWE: to ',KOLONG(KOWE))
      ENDIF

      GWEGLOBE = .TRUE.
      IBLON = 0
      IERR = 0

C     ------------------------------------------------------------------
C*    Section 2. Generate distances and points for all lines of latitude
C     ------------------------------------------------------------------
  200 CONTINUE

      IF (KPR.GE.1) CALL INTLOG(JP_DEBUG,'IRDIWE: Section 2.',JPQUIET)

      IBLAT = 1
      IBNS  = 1

      DO JLAT = 1, KONS
        DO JNS = 1, 2

          KIWE = KLLEN(KNSIND(JNS,JLAT))

          IF (KIWE .EQ. IBLON) THEN

C          Same line definition as last one calculated
           KWEIND (1:2,1:KOWE,JNS,JLAT) = KWEIND (1:2,1:KOWE,IBNS,IBLAT)
           KWEDIST(1:2,1:KOWE,JNS,JLAT) = KWEDIST(1:2,1:KOWE,IBNS,IBLAT)

          ELSE

            IBLON = KIWE
            IBNS  = JNS
            IBLAT = JLAT

C           Generate longitude values for this line            ! FIXME: remove
C           (wrap around input grid to simplify IGDIWE)        ! ...
            ISTRIDE = JP360 / KIWE                             ! ...
            DO JLON = 1, KIWE                                  ! ...
              KILONG (JLON) = (JLON - 1) * ISTRIDE             ! ...
            ENDDO                                              ! ...
            KILONG(KIWE + 1) = KILONG (1)                      ! ...

            IRDIWE = IGDIWE( KIWE, KOWE,
     1        KWEIND  (1,1,JNS,JLAT),
     2        KWEDIST (1,1,JNS,JLAT),
     3        IAREA, OAREA,
     4        KILONG, KOLONG, GWEGLOBE )   ! FIXME: remove
            IF (IRDIWE.NE.0) GO TO 900

          ENDIF

        ENDDO
      ENDDO

C     ------------------------------------------------------------------
C*    Section 9. Return to calling routine. Format statements
C     ------------------------------------------------------------------
  900 CONTINUE

      IF (KPR.GE.1) CALL INTLOG(JP_DEBUG,'IRDIWE: Section 9.',JPQUIET)
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE BUENS5( KSEC0,KSEC1,KBUFL,KBUFF,KERR)
C
C
C
C
C     PURPOSE.
C     --------
C          PACK SECTION 5 OF BUFR MESSAGE.
C
C
C**   INTERFACE.
C     ----------
C
C          *CALL* *BUENS5( KSEC0,KSEC1,KBUFL,KBUFF,KERR)*
C
C        INPUT :
C               *KSEC0*   -  ARRAY CONTAINING SECTION 0 INFORMATION
C                            KSEC0( 1)-- LENGTH OF SECTION 0 (BYTES)
C                            KSEC0( 2)-- TOTAL LENGTH OF BUFR MESSAGE (BYTES)
C                            KSEC0( 3)-- BUFR EDITION NUMBER
C               *KSEC1*   -  INTEGER ARRAY OF AT LEAST 40 WORDS
C                            CONTAINING BUFR SECTION 1 INFORMATION
C                            KSEC1( 1)-- LENGTH OF SECTION 1 (BYTES)
C                            KSEC1( 2)-- BUFR EDITION NUMBER
C                            KSEC1( 3)-- ORIGINATING CENTRE
C                            KSEC1( 4)-- UPDATE SEQUENCE NUMBER
C                            KSEC1( 5)-- FLAG (PRESENCE OF SECTION 2)
C                            KSEC1( 6)-- BUFR MESSAGE TYPE
C                            KSEC1( 7)-- BUFR MESSAGE SUBTYPE
C                            KSEC1( 8)-- VERSION NUMBER OF LOCAL TABLE USED
C                            KSEC1( 9)-- YEAR
C                            KSEC1(10)-- MONTH
C                            KSEC1(11)-- DAY
C                            KSEC1(12)-- HOUR
C                            KSEC1(13)-- MINUTE
C                            KSEC1(14)-- BUFR MASTER TABLE
C                            KSEC1(15)-- VERSION NUMBER OF MASTER TABLE USED
C                            KSEC1(16) - KSEC1(40) -- LOCAL ADP CENTRE
C                                        INFORMATION(BYTE BY BYTE)
C
C                            FOR BUFR EDITION 3 ONWARD
C
C                            KSEC1(16)-- ORIGINATING SUB-CENTRE
C                            KSEC1(17)-- NOT USED
C                            KSEC1(18) TO KSEC1(JSEC1) - LOCAL ADP CENTRE
C                                        INFORMATION(PACKED FORM)
C
C                            FOR BUFR EDITION 4 ONWARD
C
C                            KSEC1(16)-- ORIGINATING SUB-CENTRE
C                            KSEC1(17)-- INTERNATIONAL SUB-CATEGORY (SEE COMMON TABLE C-13
C                            KSEC1(18)-- SECOND
C                            KSEC1(19)-- YEAR
C                            KSEC1(20)-- MONTH
C                            KSEC1(21)-- DAY
C                            KSEC1(22)-- HOUR
C                            KSEC1(23)-- MINUTE
C                            KSEC1(24)-- SECOND
C                            KSEC1(25)-- YEAR
C                            KSEC1(26)-- MONTH
C                            KSEC1(27)-- DAY
C                            KSEC1(28)-- HOUR
C                            KSEC1(29)-- MINUTE
C                            KSEC1(30)-- SECOND
C                            KSEC1(31)-- MOST SOUTHERN LATITUDE  (-90 to 90)
C                            KSEC1(32)-- MOST WESTERN LONGITUDE  ( 0-360)
C                            KSEC1(33)-- MOST NORTHEN LATITUDE   (-90 to 90)
C                            KSEC1(34)-- MOST EASTERN LONGITUDE  ( 0-360)
C                            KSEC1(35) TO KSEC1(JSEC1) - LOCAL ADP CENTRE INFORMATION(PACKED FORM)
C
C
C        OUTPUT :
C               *KBUFL*   -  LENGTH OF BUFR MESSAGE (WORDS)
C               *KBUFF*   -  ARRAY CONTAINING BUFR MESSAGE
C               *KERR*    -  RETURNED ERROR CODE
C
C     METHOD.
C     --------
C
C          NONE.
C
C     EXTERNALS.
C     ----------
C
C          BUPKS         - PACK BIT PATHERN IN REPEATED WAY
C
C     REFERENCE.
C     ----------
C
C          NONE.
C
C     AUTHOR.
C     -------
C
C          M. DRAGOSAVAC    *ECMWF*       15/09/91.
C
C
C     MODIFICATIONS.
C     --------------
C
C          NONE.
C
C
      IMPLICIT LOGICAL(L,O,G), CHARACTER*8(C,H,Y)
C
C
C
#     include "parameter.F"
#     include "bcomunit.F"
#     include "bcmwork.F"
#     include "bcprq.F"
C
      DIMENSION KBUFF(KBUFL)
      DIMENSION IBUFR(4)
      DIMENSION KSEC0(JSEC0),KSEC1(JSEC1)
#ifndef R_4
      REAL*8 RVIND
      REAL*8 EPS
#else
      REAL   RVIND
      REAL   EPS
#endif
C
      DATA IBUFR/55,55,55,55/
C
C     ------------------------------------------------------------------
C*          1.   EXPAND SECTION 5.
C                -----------------
 100  CONTINUE
C
      IF( KERR.GT.0 ) RETURN
C
C*          1.2  PACK LAST FOUR OCTETS CONTAINING '7777'.
C                ----------------------------------------
C
      CALL BUPKS(NBPW,KBUFF(NWPT),IBUFR,NWPT,NBPT,8,0,4,KERR)
      IF(KERR.GT.0) RETURN
C
C*          1.3  SET TOTAL LENGTH OF BUFR MESSAGE.
C                ---------------------------------
 130  CONTINUE
C
      IBYTES=(NWPT-1)*NBPW/8+NBPT/8
      IWORDS=IBYTES*8/NBPW
      IF(IWORDS*NBPW.LT.IBYTES*8) IWORDS=IWORDS+1
      KBUFL =IWORDS
C
C*          1.4  SET TOTAL LENGTH OF BUFR MESSAGE IN SECTION 0.
C                ----------------------------------------------
 140  CONTINUE
C
      KSEC0(2)=IBYTES
C
      IF(KSEC0(3).GT.1) THEN
C
C        FOR BUFR EDITION 2 LENGTH OF MESSAGE STARTS AT 5 TH BYTE.
C
         IWPT= 32/NBPW + 1
         IBPT= 32 - (IWPT-1)* NBPW
C
         CALL BUPCK(NBPW,KBUFF(IWPT),IBYTES,IWPT,IBPT,24,KERR)
         IF(KERR.GT.0) THEN
          WRITE(KNTN,*)  'ERROR PACKING TOTAL LENGTH OF BUFR MESSAGE
     1 IN SECTION 0.'
         END IF
      END IF
C
C*          1.5 SET TOTAL BUFR LENGTH IN SECTION 2
C
 150  CONTINUE
C
C     RDB KEY PACKED ONLY FOR ECMWF DATA AND SECTION 2 PRESENT.
C
      IF(NOKEY.EQ.0.AND.KSEC1(5).NE.0) THEN
         IBTS=4
         IF(KSEC0(3).GT.1) IBTS=8
C
C        SIZE OF SECTION 0 AND 1 PLUS 36 BYTES FROM BEGINING
C        OF SECTION 2.
C
         IBTS=IBTS+KSEC1(1)+36
         IBIT=IBTS*8
C
         IWPT= IBIT/NBPW + 1
         IBPT= IBIT - (IWPT-1)* NBPW
C
         IF(IBYTES .GT. 65535 ) IBYTES=65535
C
         CALL BUPCK(NBPW,KBUFF(IWPT),IBYTES,IWPT,IBPT,16,KERR)
         IF(KERR.GT.0) THEN
          WRITE(KNTN,*)  'ERROR PACKING TOTAL LENGTH OF BUFR MESSAGE
     1 IN SECTION 2.'
         END IF
      END IF
C
      RETURN
      END

C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      PROGRAM GRDEMO
C
      IMPLICIT NONE
C
C---->
C**** GRDEMO - Program to demonstrate use of GRIBEX routine.
C
C     Purpose.
C     --------
C
C     Demonstrates use of GRIBEX routine to unpack
C     GRIB coded data.
C
C**   Interface.
C     ----------
C
C     File of GRIB coded data in "datafile".
C
C     Method.
C     -------
C
C     Prints sections 0, 1, 2, 3 and 4 of GRIB message.
C
C     Externals.
C     ----------
C
C     GRIBEX
C     GRPRS0
C     GRPRS1
C     GRPRS2
C     GRPRS3
C     GRPRS4
C     PBOPEN
C     PBGRIB
C     PBCLOSE
C
C     Reference.
C     ----------
C
C     WMO Manual on Codes for GRIB definition.
C     WMO Publication No. 9, Volume B, for grid catalogue numbers.
C
C     Comments.
C     ---------
C
C     GRIBEX provides a number of packing/unpacking options.
C     See documentation for details.
C
C
C     -----------------------------------------------------------------
C----<
C
C     Arrays are dimensioned to accommodate T213/N160 data volumes.
C
      INTEGER JPACK
      PARAMETER (JPACK=70000)
      INTEGER ISEC0, ISEC1, ISEC2, ISEC3, ISEC4
C
C     Array for integer parameters from section 0 of GRIB message.
C
      DIMENSION ISEC0(2)
C
C     Array for integer parameters from section 1 of GRIB message.
C
      DIMENSION ISEC1(1024)
C
C     Array for integer parameters from section 2 of GRIB message.
C
      DIMENSION ISEC2(1024)
C
C     Array for integer parameters from section 3 of GRIB message.
C
      DIMENSION ISEC3(2)
C
C     Array for integer parameters from section 4 of GRIB message.
C
      DIMENSION ISEC4(512)
C
      REAL ZSEC2, ZSEC3, ZSEC4
C
C     Array for real parameters from section 2 of GRIB message.
C
      DIMENSION ZSEC2(512)
C
C     Array for real parameters from section 3 of GRIB message.
C
      DIMENSION ZSEC3(2)
C
C     Array for real parameters from section 4 of GRIB message.
C     This is the binary data section and the array to hold the unpacked
C     data may need to be a number of times as long as that for the
C     packed data. Here it is set arbitrarily to four time longer.
C
      DIMENSION ZSEC4(JPACK*2)
C
C     Array to read in packed data.
C
      INTEGER INBUFF
      DIMENSION INBUFF(JPACK)
C
      INTEGER FILE, JCOUNT, NUMERR, IRET, IPUNP, IWORD
      INTEGER LOOP, LENOUT, ILENB
C
C     Clear counters.
C
      NUMERR = 0
      JCOUNT = 0
C
C     Open the data file
C
      CALL PBOPEN( FILE, "datafile", "R", IRET)
      IF( IRET.NE.0 ) THEN
        WRITE(*, *) 'Return code from PBOPEN = ',IRET
        CALL PBCLOSE(FILE, IRET)
        STOP 'Fault in PBOPEN'
      ENDIF
      ILENB = ILENB*4
C
C
C     Loop through GRIB products in file.
C
   50 CONTINUE
C
        JCOUNT = JCOUNT + 1
C
C       Read packed field into INBUFF.
C
        CALL PBSIZE(FILE, LENOUT)
        WRITE(*,*) 'Next GRIB field size = ', lenout
C
        ILENB = JPACK * 4
        CALL PBGRIB( FILE, INBUFF, ILENB, LENOUT, IRET )
        IF( IRET.LT.0 ) THEN
          WRITE(*, *) 'Return code from PBGRIB = ',IRET
          IF( IRET.EQ.-1 ) THEN
            WRITE(*, *) 'End of file. Number of products = ',(JCOUNT-1)
            CALL PBCLOSE(FILE, IRET)
            WRITE(*,*) 'Number of decoding errors = ',NUMERR
            STOP 'EOF'
          ELSE
            WRITE(*, *)
     X        'Return code = ',IRET,' after ',JCOUNT,' products.'
            CALL PBCLOSE(FILE, IRET)
            STOP 'Fault in PBGRIB'
          ENDIF
        ENDIF
        WRITE(*, *) 'Return length from PBGRIB = ',lenout
C
C       Decode the GRIB product.
C
        IRET = 1
        ILENB = JPACK
        IPUNP = JPACK * 4
        CALL GRIBEX(ISEC0,ISEC1,ISEC2,ZSEC2,ISEC3,ZSEC3,ISEC4,
     X              ZSEC4,IPUNP,INBUFF,ILENB,IWORD,'D',IRET)
C
C       Check the return code.
c
        WRITE(*,*) 'GRIBEX return code = ',IRET
        IF( IRET.EQ.-6 ) WRITE(*,*) 'Pseudo-grib data found.'
C
C       Update error count if necessary.
C
        IF( IRET.GT.0 ) THEN
          NUMERR = NUMERR + 1
          GOTO 50
        ENDIF
C
C       Print section 0, 1, 2 and 3 (if present) and 4.
C       Section 1 is the product definition section.
C       Section 2 is the grid definition section.
C       Section 3 is the bit-map section.
C       Section 4 is the data section.
C
        CALL GRPRS0(ISEC0)
        CALL GRPRS1(ISEC0,ISEC1)
C
        IF( (ISEC1(5).EQ.0).OR.(ISEC1(5).EQ.64) ) THEN
          WRITE(*,*) 'No section 2 in GRIB message.'
        ELSE
          CALL GRPRS2(ISEC0,ISEC2,ZSEC2)
        ENDIF
C
        IF( (ISEC1(5).EQ.0).OR.(ISEC1(5).EQ.128) ) THEN
          WRITE(*,*) 'No section 3 in GRIB message.'
        ELSE
          CALL GRPRS3(ISEC0,ISEC3,ZSEC3)
        ENDIF
C
        CALL GRPRS4(ISEC0,ISEC4,ZSEC4)
C
C       Print some vales
        DO LOOP = 1,ISEC4(1)
          WRITE(*,*) 'zsec4(', loop, ') = ', zsec4(loop)
        ENDDO
C
      GOTO 50
C
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE BUEXS2( KBUFL,KBUFF,KSUP,KSEC1,KSEC2,KERR )
C
C**** *BUEXS2*
C
C
C     PURPOSE.
C     --------
C          EXPANDS SECTION 2 OF BUFR MESSAGE. EXPANDED DATA ARE
C     STORED IN THE ARRAY KSEC2.
C
C
C**   INTERFACE.
C     ----------
C
C          *CALL* *BUEXS2(KBUFL,KBUFF,KSUP,KSEC1,KSEC2,KERR)*
C
C        INPUT :
C               *KBUFL*   -  LENGTH OF BUFR MESSAGE (WORDS)
C               *KBUFF*   -  ARRAY CONTAINING BUFR MESSAGE
C        OUTPUT:
C               *KSUP*    -  ARRAY CONTAINING SUPLEMENTARY INFORMATION
C                         -  KSUP( 1) -- IDIM1, DIMENSION OF KSEC1
C                         -  KSUP( 2) -- IDIM2, DIMENSION OF KSEC2
C                         -  KSUP( 3) -- IDIM3, DIMENSION OF KSEC3
C                         -  KSUP( 4) -- IDIM4, DIMENSION OF KSEC4
C                         -  KSUP( 5) -- M (NUMBER OF ELEMENTS IN VALUES ARRAY,
C                                           FIRST INDEX)
C                         -  KSUP( 6) -- N (NUMBER OF SUBSETS,SECOND INDEX OF
C                                           VALUES ARRAY)
C                         -  KSUP( 7) -- JVC (NUMBER OF ELEMENTS IN CVAL ARRAY)
C                         -  KSUP( 8) -- TOTAL BUFR MESSAGE LENGTH IN BYTES
C                         -  KSUP( 9) -- IDIM0, DIMENSION OF KSEC0
C               *KSEC1*   -  ARRAY CONTAINING SECTION 1 INFORMATION
C                            KSEC1( 1)-- LENGTH OF SECTION 1 (BYTES)
C                            KSEC1( 2)-- BUFR EDITION NUMBER
C                            KSEC1( 3)-- ORIGINATING CENTRE
C                            KSEC1( 4)-- UPDATE SEQUENCE NUMBER
C                            KSEC1( 5)-- FLAG (PRESENCE OF SECTION 2)
C                            KSEC1( 6)-- BUFR MESSAGE TYPE
C                            KSEC1( 7)-- BUFR MESSAGE SUBTYPE
C                            KSEC1( 8)-- VERSION NUMBER OF LOCAL TABLE USED
C                            KSEC1( 9)-- YEAR
C                            KSEC1(10)-- MONTH
C                            KSEC1(11)-- DAY
C                            KSEC1(12)-- HOUR
C                            KSEC1(13)-- MINUTE
C                            KSEC1(14)-- BUFR MASTER TABLE
C                            KSEC1(15)-- VERSION NUMBER OF MASTER TABLE USED
C                            KSEC1(16) - KSEC1(JSEC1) -- LOCAL ADP CENTRE
C                                        INFORMATION(PACKED FORM)
C
C                            FOR BUFR EDITION 3 ONWARD
C
C                            KSEC1(16)-- ORIGINATING SUB-CENTRE
C                            KSEC1(17)-- NOT USED
C                            KSEC1(18) TO KSEC1(JSEC1) - LOCAL ADP CENTRE
C                                        INFORMATION(PACKED FORM)
C
C                            FOR BUFR EDITION 4 ONWARD
C
C                            KSEC1(16)-- ORIGINATING SUB-CENTRE
C                            KSEC1(17)-- INTERNATIONAL SUB-CATEGORY (SEE COMMON TABLE C-13
C                            KSEC1(18)-- SECOND
C                            KSEC1(19)-- YEAR
C                            KSEC1(20)-- MONTH
C                            KSEC1(21)-- DAY
C                            KSEC1(22)-- HOUR
C                            KSEC1(23)-- MINUTE
C                            KSEC1(24)-- SECOND
C                            KSEC1(25)-- YEAR
C                            KSEC1(26)-- MONTH
C                            KSEC1(27)-- DAY
C                            KSEC1(28)-- HOUR
C                            KSEC1(29)-- MINUTE
C                            KSEC1(30)-- SECOND
C                            KSEC1(31)-- MOST SOUTHERN LATITUDE  (-90 to 90)
C                            KSEC1(32)-- MOST WESTERN LONGITUDE  ( 0-360)
C                            KSEC1(33)-- MOST NORTHEN LATITUDE   (-90 to 90)
C                            KSEC1(34)-- MOST EASTERN LONGITUDE  ( 0-360)
C                            KSEC1(35) TO KSEC1(JSEC1) - LOCAL ADP CENTRE INFORMATION(PACKED FORM)
C
C               *KSEC2*   -  ARRAY CONTAINING SECTION 2 INFORMATION
C                            KSEC2( 1)-- LENGTH OF SECTION 2 (BYTES)
C                            KSEC2( 2) TO KSEC2(JSEC2) LOCAL ADP CENTRE
C                                         INFORMATION(PACKED FORM)
C               *KERR*    -  RETURNED ERROR CODE
C
C     METHOD.
C     -------
C
C          THE LENGTH OF SECTION 2 AND POINTERS TO THE BEGINING
C     OF SECTION 3 ARE SET. RDB KEY IS THEN UNPACKED AND ALL INFORMATION
C     STORED INTO ARRAY KSEC2.
C
C
C     EXTERNALS.
C     ----------
C
C          BUNPCK          - UNPACK BIT PATTERN
C          BUNEXS         - SET WORD AND BIT POINTERS AT THE BEGINING
C                           OF NEXT BUFR SECTION.
C
C     REFERENCE.
C     ----------
C
C          NONE.
C
C     AUTHOR.
C     -------
C
C          M. DRAGOSAVAC    *ECMWF*       17/01/91.
C
C
C     MODIFICATIONS.
C     --------------
C
C          NONE.
C
C
      IMPLICIT LOGICAL(L,O,G), CHARACTER*8(C,H,Y)
C
C
#     include "parameter.F"
#     include "bcomunit.F"
#     include "bcomwork.F"
#     include "bcprq.F"
C
      DIMENSION KBUFF(KBUFL)
      DIMENSION KSUP(JSUP),KSEC1(JSEC1),KSEC2(JSEC2)
      DIMENSION ISEC2(JSEC2),IISEC2(JSEC2)
#ifndef R_4
      REAL*8 RVIND
      REAL*8 EPS
#else
      REAL   RVIND
      REAL   EPS
#endif
C
C     ------------------------------------------------------------------
C*          1.  EXPAND SECTION 2.
C               -----------------
 100  CONTINUE
C
      IF( KERR.NE.0 ) RETURN
C
      DO 101 I=1,JSEC2
      KSEC2(I)=0
 101  CONTINUE
C
      IF( KSEC1(5) .NE. 0 .AND. KSEC1(5) .NE. 128) THEN
          KERR=50
          CALL BUERR(KERR)
          RETURN
      END IF
C
      IF( KSEC1(5).EQ.0) THEN
          KSUP(2) = 1
          KSEC2(1)= 0
          RETURN
      END IF
C
C*          1.1 SET THE POINTERS NWPT AND NBPT AT THE BEGINING OF SECTION.
C              -----------------------------------------------------------
 110  CONTINUE
C
      NWPT = NWPTB
      NBPT = NBPTB
C
C*          1.2  UNPACK LENGTH OF SECTION 2.
C                ---------------------------
      CALL BUNPCK(NBPW,KBUFF,KSEC2(1),NWPT,NBPT,24,KERR)
      IF(KERR.GT.0) THEN
         WRITE(KNTN,*)  'ERROR UNPACKING KSEC2(1).'
         RETURN
      END IF
C
C*          1.2.1  SET POINTERS NWPTB AND NBPTB TO THE
C                  -----------------------------------
C                  BEGINING OF THE NEXT SECTION.
C                  -----------------------------
      CALL BUNEXS(KSEC2(1))
C
      CALL BUNPCK(NBPW,KBUFF,IDUMMY,NWPT,NBPT, 8,KERR)
      IF(KERR.GT.0) THEN
         WRITE(KNTN,*)  'ERROR UNPACKING DUMMY OCTET IN SECTION 2.'
         RETURN
      END IF
C
C*          1.3  UNPACK LOCAL ADP CENTRE INFORMATION.
C                ------------------------------------
C
      IOFF=KSEC2(1)-4
C
      IF(IOFF.GT.JSEC2) THEN
         KERR=5
         CALL BUERR(KERR)
         RETURN
      END IF
C
      CALL BUNPKS(NBPW,KBUFF,ISEC2(1),NWPT,NBPT,
     1            8,0,IOFF,KERR)
      IF(KERR.GT.0) THEN
      WRITE(KNTN,*)  'ERROR UNPACKING LOCAL ADP CENTRE INFORMATION'
         WRITE(KNTN,*)  'IN SECTION2.'
         RETURN
      END IF
C
      IF(KSEC1(3).EQ.98) THEN
         IF(NOKEY.EQ.0) THEN
            IF(ISEC2(2).NE.KSEC1(7)) THEN
C
C              BYTES IN THE KEY IN REVERSED ORDER.
C
               J=0
               DO 131 I=1,JSEC2,4
               IISEC2(I)=ISEC2(I+3)
               IISEC2(I+1)=ISEC2(I+2)
               IISEC2(I+2)=ISEC2(I+1)
               IISEC2(I+3)=ISEC2(I)
 131           CONTINUE
               DO 132 I=1,JSEC2
               ISEC2(I)=IISEC2(I)
 132           CONTINUE
            END IF
         END IF
      END IF
C
C                PACK LOCAL ADP CENTRE INFORMATION INTO KSE2(2) ONWARD.
C
      IW=2
      IBT=0
      CALL BUPKS(NBPW,KSEC2(IW),ISEC2,IW,IBT,8,0,IOFF,KERR)
      IF(KERR.GT.0) THEN
         WRITE(KNTN,*) 'ERROR PACKING LOCAL ADP CENTRE',
     1                 ' INFORMATION INTO'
         WRITE(KNTN,*)  'KSEC2(2) ONWARD.'
         RETURN
      END IF
C
C                SET LENGHT OF KSEC2
C
      KSUP(2)=IW
C     ------------------------------------------------------------------
 200  CONTINUE
C
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE BBUPRS1(KNT,KSEC1)
C
C**** *BUPRS1*
C
C
C     PURPOSE.
C     --------
C           PRINT SECTION 1 OF BUFR MESSAGE.
C
C
C**   INTERFACE.
C     ----------
C
C           *CALL* *BUPRS1(KNT,KSEC1)*
C
C        INPUT :
C               *KNT*   -  UNIT NUMBER FOR IO
C               *KSEC1*   -  ARRAY CONTAINING SECTION 1 INFORMATION
C                            KSEC1( 1)-- LENGTH OF SECTION 1 (BYTES)
C                            KSEC1( 2)-- BUFR EDITION NUMBER
C                            KSEC1( 3)-- ORIGINATING CENTRE
C                            KSEC1( 4)-- UPDATE SEQUENCE NUMBER
C                            KSEC1( 5)-- FLAG (PRESENCE OF SECTION 2)
C                            KSEC1( 6)-- BUFR MESSAGE TYPE
C                            KSEC1( 7)-- BUFR MESSAGE SUBTYPE
C                            KSEC1( 8)-- VERSION NUMBER OF LOCAL TABLE USED
C                            KSEC1( 9)-- YEAR
C                            KSEC1(10)-- MONTH
C                            KSEC1(11)-- DAY
C                            KSEC1(12)-- HOUR
C                            KSEC1(13)-- MINUTE
C                            KSEC1(14)-- BUFR MASTER TABLE
C                            KSEC1(15)-- VERSION NUMBER OF MASTER TABLE USED
C                            KSEC1(16) - KSEC1(JSEC1) -- LOCAL ADP CENTRE
C                                        INFORMATION(BYTE BY BYTE)
C
C                            FOR BUFR EDITION >= 3
C
C                            KSEC1(16) - ORIGINATING SUB-CENTRE
C                            KSEC1(18) - KSEC1(JSEC1) -- LOCAL ADP CENTRE
C                                        INFORMATION(BYTE BY BYTE)
C
C                            FOR BUFR EDITION 4 ONWARD
C
C                            KSEC1(16)-- ORIGINATING SUB-CENTRE
C                            KSEC1(17)-- INTERNATIONAL SUB-CATEGORY (SEE COMMON TABLE C-13
C                            KSEC1(18)-- SECOND
C                            KSEC1(19)-- YEAR
C                            KSEC1(20)-- MONTH
C                            KSEC1(21)-- DAY
C                            KSEC1(22)-- HOUR
C                            KSEC1(23)-- MINUTE
C                            KSEC1(24)-- SECOND
C                            KSEC1(25)-- YEAR
C                            KSEC1(26)-- MONTH
C                            KSEC1(27)-- DAY
C                            KSEC1(28)-- HOUR
C                            KSEC1(29)-- MINUTE
C                            KSEC1(30)-- SECOND
C                            KSEC1(31)-- MOST SOUTHERN LATITUDE  (-90 to 90)
C                            KSEC1(32)-- MOST WESTERN LONGITUDE  ( 0-360)
C                            KSEC1(33)-- MOST NORTHEN LATITUDE   (-90 to 90)
C                            KSEC1(34)-- MOST EASTERN LONGITUDE  ( 0-360)
C                            KSEC1(35) TO KSEC1(JSEC1) - LOCAL ADP CENTRE INFORMATION(PACKED FORM)
C                            
C
C     METHOD.
C     -------
C
C            NONE
C
C     EXTERNALS.
C     ----------
C
C            NONE.
C
C     REFERENCE.
C     ----------
C
C          NONE.
C
C     AUTHOR.
C     -------
C
C          M. DRAGOSAVAC    *ECMWF*       04/02/91.
C
C     MODIFICATIONS.
C     --------------
C
C          NONE.
C
      IMPLICIT LOGICAL(L,O,G), CHARACTER*8(C,H,Y)
C
C
#     include "parameter.F"
C
      DIMENSION KSEC1(JSEC1)
C
C     ------------------------------------------------------------------
C
C*          1.   PRINT SECTION 1.
C                ----------------
 100  CONTINUE
C
      WRITE(KNT,'(1H1)')
C
      IF(KSEC1( 2).LE.3) THEN
      WRITE(KNT,'(1H ,A)')    '        BUFR SECTION 1    '
      WRITE(KNT,'(1H )')
      WRITE(KNT,'(1H ,A,I5)')'LENGTH OF SECTION 1 (BYTES)   ',KSEC1( 1)
      WRITE(KNT,'(1H ,A,I5)')'BUFR EDITION NUMBER           ',KSEC1( 2)
      IF(KSEC1(2).GE.3) THEN
      WRITE(KNT,'(1H ,A,I5)')'ORIGINATING SUB-CENTRE        ',KSEC1(16)
      END IF
      WRITE(KNT,'(1H ,A,I5)')'ORIGINATING CENTRE            ',KSEC1( 3)
      WRITE(KNT,'(1H ,A,I5)')'UPDATE SEQUENCE NUMBER        ',KSEC1( 4)
      WRITE(KNT,'(1H ,A,I5)')'FLAG (PRESENCE OF SECTION 2)  ',KSEC1( 5)
      WRITE(KNT,'(1H ,A,I5)')'BUFR MESSAGE TYPE             ',KSEC1( 6)
      WRITE(KNT,'(1H ,A,I5)')'BUFR MESSAGE SUBTYPE          ',KSEC1( 7)
      WRITE(KNT,'(1H ,A,I5)')'VERSION NUMBER OF LOCAL TABLE ',KSEC1( 8)
      WRITE(KNT,'(1H ,A,I5)')'YEAR                          ',KSEC1( 9)
      WRITE(KNT,'(1H ,A,I5)')'MONTH                         ',KSEC1(10)
      WRITE(KNT,'(1H ,A,I5)')'DAY                           ',KSEC1(11)
      WRITE(KNT,'(1H ,A,I5)')'HOUR                          ',KSEC1(12)
      WRITE(KNT,'(1H ,A,I5)')'MINUTE                        ',KSEC1(13)
      WRITE(KNT,'(1H ,A,I5)')'VERSION NUMBER OF MASTER TABLE',KSEC1(15)
      WRITE(KNT,'(1H ,A,I5)')'BUFR MASTER TABLE             ',KSEC1(14)

      ELSEIF(KSEC1( 2).EQ.4) THEN

      WRITE(KNT,'(1H ,A)')    '        BUFR SECTION 1    '
      WRITE(KNT,'(1H )')
      WRITE(KNT,'(1H ,A,I9)')'LENGTH OF SECTION 1 (BYTES)   ',KSEC1( 1)
      WRITE(KNT,'(1H ,A,I9)')'BUFR MASTER TABLE             ',KSEC1(14)
      WRITE(KNT,'(1H ,A,I9)')'ORIGINATING CENTRE            ',KSEC1( 3)
      WRITE(KNT,'(1H ,A,I9)')'ORIGINATING SUB-CENTRE        ',KSEC1(16)
      WRITE(KNT,'(1H ,A,I9)')'UPDATE SEQUENCE NUMBER        ',KSEC1( 4)
      WRITE(KNT,'(1H ,A,I9)')'FLAG (PRESENCE OF SECTION 2)  ',KSEC1( 5)
      WRITE(KNT,'(1H ,A,I9)')'DATA CATEGORY                 ',KSEC1( 6)
      WRITE(KNT,'(1H ,A,I9)')'DATA SUB-CATEGORY             ',KSEC1(17)
      WRITE(KNT,'(1H ,A,I9)')'LOCAL DATA SUB-CATEGORU       ',KSEC1( 7)
      WRITE(KNT,'(1H ,A,I9)')'VERSION NUMBER OF MASTER TABLE',KSEC1(15)
      WRITE(KNT,'(1H ,A,I9)')'VERSION NUMBER OF LOCAL TABLE ',KSEC1( 8)
      WRITE(KNT,'(1H ,A,I9)')'YEAR                          ',KSEC1( 9)
      WRITE(KNT,'(1H ,A,I9)')'MONTH                         ',KSEC1(10)
      WRITE(KNT,'(1H ,A,I9)')'DAY                           ',KSEC1(11)
      WRITE(KNT,'(1H ,A,I9)')'HOUR                          ',KSEC1(12)
      WRITE(KNT,'(1H ,A,I9)')'MINUTE                        ',KSEC1(13)
      WRITE(KNT,'(1H ,A,I9)')'SECOND                        ',KSEC1(18)
c     WRITE(KNT,'(1H ,A,I9)')'YEAR    (EARLIEST TIME)       ',KSEC1(19)
c     WRITE(KNT,'(1H ,A,I9)')'MONTH   (EARLIEST TIME)       ',KSEC1(20)
c     WRITE(KNT,'(1H ,A,I9)')'DAY     (EARLIEST TIME)       ',KSEC1(21)
c     WRITE(KNT,'(1H ,A,I9)')'HOUR    (EARLIEST TIME)       ',KSEC1(22)
c     WRITE(KNT,'(1H ,A,I9)')'MINUTE  (EARLIEST TIME)       ',KSEC1(23)
c     WRITE(KNT,'(1H ,A,I9)')'SECOND  (EARLIEST TIME)       ',KSEC1(28)
c     WRITE(KNT,'(1H ,A,I9)')'YEAR    (LATEST TIME)         ',KSEC1(25)
c     WRITE(KNT,'(1H ,A,I9)')'MONTH   (LATEST TIME)         ',KSEC1(26)
c     WRITE(KNT,'(1H ,A,I9)')'DAY     (LATEST TIME)         ',KSEC1(27)
c     WRITE(KNT,'(1H ,A,I9)')'HOUR    (LATEST TIME)         ',KSEC1(28)
c     WRITE(KNT,'(1H ,A,I9)')'MINUTE  (LATEST TIME)         ',KSEC1(29)
c     WRITE(KNT,'(1H ,A,I9)')'SECOND  (LATEST TIME)         ',KSEC1(30)
c     WRITE(KNT,'(1H ,A,I9)')'MOST SOUTHERN LATITUDE        ',KSEC1(31)
c     WRITE(KNT,'(1H ,A,I9)')'MOST WESTERN LONGITUDE        ',KSEC1(32)
c     WRITE(KNT,'(1H ,A,I9)')'MOST NORTHERN LATITUDE        ',KSEC1(33)
c     WRITE(KNT,'(1H ,A,I9)')'MOST EASTERN LONGITUDE        ',KSEC1(34)
C
      END IF
C
      RETURN
      END

C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE CTABLE1(YNAME,KERR)
C
C**** *CTABLE1*
C
C
C     PURPOSE.
C     --------
C          THE MAIN PURPOSE OF THIS PROGRAMME IS TO CREATE WORKING
C          CODE TABLES FOR *BUFR* DECODING.
C
C**   INTERFACE.
C     ----------
C          NONE.
C
C
C
C
C     *METHOD.
C      -------
C          NONE.
C
C
C
C     EXTERNALS.
C     ----------
C          NONE.
C
C
C
C
C     REFERENCE.
C     ----------
C
C          BINARY UNIVERSAL FORM FOR DATA REPRESENTATION, *FM 94 BUFR*.
C
C          J.K.GIBSON AND *M.DRAGOSAVAC,1987:* DECODING *DATA *REPRESENTATION
C                          *FM 94 BUFR*,*TECHNICAL *MEMORANDUM *NO. 134
C
C          J.K.GIBSON,1986:*EMOS 2 - *STANDARDS FOR SOFTWARE DEVELOPMENT
C                           AND MAINTANANCE *,*TECHICAL MEMORANDUM *NO.
C                           *ECMWF*.
C
C
C     AUTHOR.
C     -------
C
C          M. DRAGOSAVAC       *ECMWF*       JANUARY 1991.
C
C
C     MODIFICATIONS.
C     --------------
C
C          NONE.
C
C
      IMPLICIT LOGICAL(L,O,G), CHARACTER*8(C,H,Y)
C
#     include "parameter.F"
#     include "bcmwork.F"
#     include "bcmtab.F"
#     include "bcmtabc.F"
#     include "bcmct.F"
#     include "bcmctc.F"
#     include "bcmroot.F"

C
      CHARACTER*64 CTEXT
      CHARACTER*64 CTABBEN
      CHARACTER*24 CTABBU
      CHARACTER*256 YFNAME
      CHARACTER*(*) YNAME
      CHARACTER*120 YENTRY
C
      REAL*8 RVIND,EPS
C
C     ------------------------------------------------------------------
C*          1.   SET INITIAL CONSTANTS AND POINTERS
C                ----------------------------------
 100  CONTINUE
C
      J=0
      YFNAME=' '
C
      DO 101 I=1,JCTEXT
      CTEXT(I)=' '
 101  CONTINUE
C
      DO 102 I=1,JCTAB
      NREF(I)=0
      NSTART(I)=0
      NLEN(I)=0
 102  CONTINUE
C
      DO 103 I=1,JCTST
      NCODNUM(I)=0
      NSTARTC(I)=0
      NLENC  (I)=0
 103  CONTINUE
C
      II=INDEX(YNAME,' ')
      II=II-1
      YFNAME=YNAME(1:II)
      II=INDEX(YFNAME,' ')
      II=II-1
      CALL GET_FREE_UNIT(IUNIT)
      OPEN(UNIT=IUNIT,FILE=YFNAME(1:II),ERR=401,STATUS='OLD')
C
C     ------------------------------------------------------------------
C*          2.   READ IN CODE TABLE ENTRY
C                ------------------------
 200  CONTINUE
C
C
      READ(IUNIT,'(A)',ERR=402,END=300) YENTRY
C
      J = J+1
C
      IF(J.GT.JCTAB) THEN
         PRINT*,' DIMENSION TOO SMALL J=',J
         kerr=66
         return
      END IF 
C
C     ------------------------------------------------------------------
C*          2.1  SET ARRAYS FOR CODE TABLE TABLE REFERENCE, STARTING POINTERS
C                FOR LIST OF CODE NUMBERS, LENGTH , LIST OF CODE NUMBERS,
C                STARTING POINTERS AND LENGTH OF TEXT INFORMATION.
 210  CONTINUE
C
      READ(YENTRY,'(I6,1X,I4,1X,I4,1X,I2)') NREF(J),NLEN(J),NCODE,NLINE
    
C
      IF(J.EQ.1) THEN
         NSTART (J)  = 1
         NSTARTC(J)  = 1
         IPT = 1
         IIPT= 1
      ELSE
         NSTART(J)   = NSTART(J-1) + NLEN(J-1)
         IPT         = NSTART(J)
         IIPT        = IIPT + 1
         NSTARTC(IPT)= IIPT
      END IF
C
C
      NCODNUM(IPT)=NCODE
      NLENC ( IPT)=NLINE
C
      CTEXT (IIPT)=YENTRY(21:80)
C     -------------------------------------------------------------------
      IF(NLENC(IPT).GT.1) THEN
         DO 220 JA=1,NLENC(IPT)-1
         READ(IUNIT,'(A)',END=300) YENTRY
         IIPT=IIPT+1
         CTEXT(IIPT)=YENTRY(21:80)
 220     CONTINUE
      END IF
C
      IF(NLEN(J).GT.1) THEN
         DO 230 JA=1,NLEN(J)-1
         READ(IUNIT,'(A)',END=300) YENTRY
         READ(YENTRY,'(12X,I4,1X,I2)') NCODE,NLINE
         IPT   = IPT + 1
         IIPT  =IIPT + 1
         NCODNUM(IPT)= NCODE
         NSTARTC(IPT)=  IIPT
         NLENC  (IPT)=NLINE
         CTEXT(IIPT) = YENTRY(21:80)
         IF(NLENC(IPT).GT.1) THEN
            DO 240 JB=1,NLENC(IPT)-1
            READ(IUNIT,'(A)',END=300) YENTRY
            IIPT=IIPT+1
            CTEXT(IIPT)=YENTRY(21:80)
 240        CONTINUE
         END IF
 230     CONTINUE
      END IF
C
      GO TO 200
C
C     ------------------------------------------------------------------
 300  CONTINUE
C
      CLOSE(IUNIT)
C
C     write(*,'(1h )')
C     write(*,'(1H ,a,i4)') 'Total number of entries in Table C is ',j
C
      RETURN
C     -----------------------------------------------------------------
 400  CONTINUE
C
 401  CONTINUE
C
      KERR=62
      WRITE(*,4401) IOS,YFNAME
 4401 FORMAT(1H ,'Open error ',i4,' on ',a)
      RETURN
C
 402  CONTINUE
      KERR=7
      WRITE(*,4402) IOS,YFNAME
 4402 FORMAT(1H ,'Read error ',i4,' on ',a)
      RETURN
C
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE GETCODE(KREF,KCODE,YCODE,KERR)
C
C**** *GETCODE*
C
C
C     PURPOSE.
C     --------
C
C          The main purpose of the subroutine is to get text 
C          associated with code number 
C
C**   INTERFACE.
C     ----------
C          NONE.
C
C
C
C
C     *METHOD.
C      -------
C          NONE.
C
C
C
C     EXTERNALS.
C     ----------
C          NONE.
C
C
C
C
C     REFERENCE.
C     ----------
C
C
C     AUTHOR.
C     -------
C
C          M. DRAGOSAVAC       *ECMWF*       JANUARY 2008.
C
C
C     MODIFICATIONS.
C     --------------
C
C          NONE.
C
C
      IMPLICIT LOGICAL(L,O,G), CHARACTER*8(C,H,Y)
C
#     include "parameter.F"
#     include "bcomwork.F"
#     include "bcomtab.F"
#     include "bcomtabc.F"
#     include "bcomct.F"
#     include "bcomctc.F"
#     include "bcomroot.F"
C#     include "bcomtabload.F"
C#     include "bcomtabloadc.F"


C
      CHARACTER*64 CTEXT
      CHARACTER*64 CTABBEN
      CHARACTER*24 CTABBU
      CHARACTER*256 YCODE
C
C
C     ------------------------------------------------------------------
C*          1.   SET INITIAL CONSTANTS AND POINTERS
C                ----------------------------------
 100  CONTINUE
C
      kerr=0
C
      ycode=' '
      do i=1,JCTAB
      if(nref(i).eq.kref) go to 200
      end do
      ycode(1:)='CODE ENTRY NOT KNOWN'
      return      
c
 200  continue
      ipt=nstart(i)
      do i=ipt,ipt+nlen(i)-1
       if(ncodnum(i).eq.KCODE) then
         iptc=nstartc(i)
         ii=1
         iptc1=nlenc(i)+iptc-1
         do j=iptc,iptc1
          do k=64,1,-1
          if(ctext(j)(k:k).ne.' ') then
           iz=k
           go to 201
          end if
          end do
 201      ycode(ii:ii+iz-1)=ctext(j)(1:iz)
          ii=ii+iz
         end do
         go to 300
       end if
      end do
      ycode(1:)='CODE ENTRY NOT KNOWN'
C
 300  continue
      return
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities
C granted to it by virtue of its status as an intergovernmental organisation
C nor does it submit to any jurisdiction.
C
      PROGRAM GRIBEX_ABORT
      IMPLICIT NONE
C
C     This test expects to fail (internal stop). It should not arrive
C     to the END statement, which would return 0.
C
      INTEGER I
      REAL R
      CHARACTER C
      CALL GRIBEX(I,I,I,R,I,R,I,R,I,I,I,I,C,I)
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE BUSEL(KTDLEN,KTDLST,KTDEXL,KTDEXP,KERR)
C
C**** *BUSEL*
C
C
C     PURPOSE.
C     --------
C          RETURNS LIST OF DATA DESCRIPTORS AS IN SECTION 3  OF BUFR
C          MESSAGE AND TOTAL/REQUESTED LIST OF ELEMENTS.
C
C
C**   INTERFACE.
C     ----------
C
C          *CALL* *BUSEL(KTDLEN,KTDLST,KTDEXL,KTDEXP,KERR)*
C
C
C        OUTPUT:
C               *KTDLEN*  -  NUMBER OF DATA DESCRIPTORS IN SECTION 3
C               *KTDLST*  -  ARRAY CONTAINING DATA DESCRIPTORS IN SECTION 3
C               *KTDEXL*  -  NUMBER OF ENTRIES IN LIST OF EXPANDED DATA
C                            DESCRIPTORS
C               *KTDEXP*  -  ARRAY CONTAINIG EXPANDED DATA DESCRIPTORS
C               *KERR*    -  RETURNED ERROR CODE
C
C
C     METHOD.
C     -------
C
C          NONE.
C
C     EXTERNALS.
C     ----------
C
C          NONE.
C
C     REFERENCE.
C     ----------
C
C          NONE.
C
C     AUTHOR.
C     -------
C
C          M. DRAGOSAVAC    *ECMWF*       15/01/91.
C
C
C     MODIFICATIONS.
C     --------------
C
C          NONE.
C
C
      IMPLICIT LOGICAL(L,O,G), CHARACTER*8(C,H,Y)
C
C
#     include "parameter.F"
#     include "bcomunit.F"
#     include "bcomel.F"
C
      DIMENSION  KTDLST(*),KTDEXP(*)
C
C
C     -----------------------------------------------------------------

C*          1.  PUT LIST OF ELEMENTS FROM COMMON BLOCK
C               --------------------------------------
C               TO REQUESTED ARRAYS.
C               --------------------
 100  CONTINUE
C
      KERR=0
C
      KTDLEN=NTDLEN
      KTDEXL=NTDEXL
C
      DO 101 I=1,NTDLEN
      KTDLST(I)=NTDLST(I)
 101  CONTINUE
C
      DO 102 I=1,NTDEXL
      KTDEXP(I)=NTDEXP(I)
 102  CONTINUE
C
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      COMMON /BCMWORK/ RVIND,EPS,NBPW,NWPT,NBPT,NWPTB,NBPTB,NMASK(JBPW)
     1,                NVIND,NBENP,NLTVNP,NWWP,NXXP,NYYP
     2,                NZZP,NSSP,NEDN
C
C             NBPW          -  NUMBER OF BITS PER COMPUTER WORD
C             NWPT          -  WORD POINTER
C             NBPT          -  BIT POINTER
C             NWPTB         -  POINTER TO WORD AT THE BEGINING OF NEXT SECTION
C             NBPTB         -  POINTER TO BIT AT THE BEGINING OF NEXT SECTION
C             NMASK         -  BIT MASK ARRAY
C             NVIND         -  MISSING VALUE INDICATOR (INTEGER)
C             RVIND         -  MISSING VALUE INDICATOR (REAL)
C             NBENP         -  PREVIOUS BUFR EDITION NUMBER
C             NLTVNP        -  PREVIOUS LOCAL TABLE VERSION NUMBER
C             NXXP          -  BUFR MASTER TABLE USED
C             NYYP          -  VERSION NUMBER OF MASTER TABLE USED
C             NZZP          -  VERSION NUMBER OF LOCAL TABLE USED
C             NEDN          -  BUFR EDITION

c Copyright 1981-2016 ECMWF.
c
c This software is licensed under the terms of the Apache Licence 
c Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
c
c In applying this licence, ECMWF does not waive the privileges and immunities 
c granted to it by virtue of its status as an intergovernmental organisation 
c nor does it submit to any jurisdiction.
c

      SUBROUTINE FFT991(A,WORK,TRIGS,IFAX,INC,JUMP,N,ILOT,ISIGN)
      REAL A(*),WORK(*),
     *  TRIGS(*)
      INTEGER IFAX(*)
C
C     SUBROUTINE 'FFT991' - MULTIPLE FAST REAL PERIODIC TRANSFORM
C     SUPERSEDES PREVIOUS ROUTINE 'FFT991'
C
C     REAL TRANSFORM OF LENGTH N PERFORMED BY REMOVING REDUNDANT
C     OPERATIONS FROM COMPLEX TRANSFORM OF LENGTH N
C
C     A IS THE ARRAY CONTAINING INPUT & OUTPUT DATA
C     WORK IS AN AREA OF SIZE (N+1)*MIN(ILOT,JP_LOT)
C     TRIGS IS A PREVIOUSLY PREPARED LIST OF TRIG FUNCTION VALUES
C     IFAX IS A PREVIOUSLY PREPARED LIST OF FACTORS OF N
C     INC IS THE INCREMENT WITHIN EACH DATA 'VECTOR'
C         (E.G. INC=1 FOR CONSECUTIVELY STORED DATA)
C     JUMP IS THE INCREMENT BETWEEN THE START OF EACH DATA VECTOR
C     N IS THE LENGTH OF THE DATA VECTORS
C     ILOT IS THE NUMBER OF DATA VECTORS
C     ISIGN = +1 FOR TRANSFORM FROM SPECTRAL TO GRIDPOINT
C           = -1 FOR TRANSFORM FROM GRIDPOINT TO SPECTRAL
C
C     ORDERING OF COEFFICIENTS:
C         A(0),B(0),A(1),B(1),A(2),B(2),...,A(N/2),B(N/2)
C         WHERE B(0)=B(N/2)=0; (N+2) LOCATIONS REQUIRED
C
C     ORDERING OF DATA:
C         X(0),X(1),X(2),...,X(N-1), 0 , 0 ; (N+2) LOCATIONS REQUIRED
C
C     VECTORIZATION IS ACHIEVED ON CRAY BY DOING THE TRANSFORMS
C     IN PARALLEL
C
C     N MUST BE COMPOSED OF FACTORS 2,3 & 5 BUT DOES NOT HAVE TO BE EVEN
C
C     DEFINITION OF TRANSFORMS:
C     -------------------------
C
C     ISIGN=+1: X(J)=SUM(K=0,...,N-1)(C(K)*EXP(2*I*J*K*PI/N))
C         WHERE C(K)=A(K)+I*B(K) AND C(N-K)=A(K)-I*B(K)
C
C     ISIGN=-1: A(K)=(1/N)*SUM(J=0,...,N-1)(X(J)*COS(2*J*K*PI/N))
C               B(K)=-(1/N)*SUM(J=0,...,N-1)(X(J)*SIN(2*J*K*PI/N))
C
      IF(IFAX(10).NE.N) CALL SET99(TRIGS,IFAX,N)
      NFAX=IFAX(1)
      NX=N+1
      IF (MOD(N,2).EQ.1) NX=N
cfse  NBLOX=1+(ILOT-1)/64
cfse  NVEX=ILOT-(NBLOX-1)*64
      NBLOX=1+(ILOT-1)/512
      NVEX=ILOT-(NBLOX-1)*512
      IF (ISIGN.EQ.-1) GO TO 300
C
C     ISIGN=+1, SPECTRAL TO GRIDPOINT TRANSFORM
C     -----------------------------------------
  100 CONTINUE
      ISTART=1
      DO 220 NB=1,NBLOX
      IA=ISTART
      I=ISTART
*vocl loop,novrec
      DO 110 J=1,NVEX
      A(I+INC)=0.5*A(I)
      I=I+JUMP
  110 CONTINUE
      IF (MOD(N,2).EQ.1) GO TO 130
      I=ISTART+N*INC
*vocl loop,novrec
      DO 120 J=1,NVEX
      A(I)=0.5*A(I)
      I=I+JUMP
  120 CONTINUE
  130 CONTINUE
      IA=ISTART+INC
      ILA=1
      IGO=+1
C
      DO 160 K=1,NFAX
      IFAC=IFAX(K+1)
      IERR=-1
      IF (IGO.EQ.-1) GO TO 140
      CALL RPASSM(A(IA),A(IA+ILA*INC),WORK(1),WORK(IFAC*ILA+1),TRIGS,
     *    INC,1,JUMP,NX,NVEX,N,IFAC,ILA,IERR)
      GO TO 150
  140 CONTINUE
      CALL RPASSM(WORK(1),WORK(ILA+1),A(IA),A(IA+IFAC*ILA*INC),TRIGS,
     *    1,INC,NX,JUMP,NVEX,N,IFAC,ILA,IERR)
  150 CONTINUE
      IF (IERR.NE.0) GO TO 500
      ILA=IFAC*ILA
      IGO=-IGO
      IA=ISTART
  160 CONTINUE
C
C     IF NECESSARY, COPY RESULTS BACK TO A
C     ------------------------------------
      IF (MOD(NFAX,2).EQ.0) GO TO 190
      IBASE=1
      JBASE=IA
      DO 180 JJ=1,NVEX
      I=IBASE
      J=JBASE
      DO 170 II=1,N
      A(J)=WORK(I)
      I=I+1
      J=J+INC
  170 CONTINUE
      IBASE=IBASE+NX
      JBASE=JBASE+JUMP
  180 CONTINUE
  190 CONTINUE
C
C     FILL IN ZEROS AT END
C     --------------------
      IX=ISTART+N*INC
*vocl loop,novrec
      DO 210 J=1,NVEX
      A(IX)=0.0
      A(IX+INC)=0.0
      IX=IX+JUMP
  210 CONTINUE
C
      ISTART=ISTART+NVEX*JUMP
cfse  NVEX=64
      NVEX=512
  220 CONTINUE
      RETURN
C
C     ISIGN=-1, GRIDPOINT TO SPECTRAL TRANSFORM
C     -----------------------------------------
  300 CONTINUE
      ISTART=1
      DO 410 NB=1,NBLOX
      IA=ISTART
      ILA=N
      IGO=+1
C
      DO 340 K=1,NFAX
      IFAC=IFAX(NFAX+2-K)
      ILA=ILA/IFAC
      IERR=-1
      IF (IGO.EQ.-1) GO TO 320
      CALL QPASSM(A(IA),A(IA+IFAC*ILA*INC),WORK(1),WORK(ILA+1),TRIGS,
     *    INC,1,JUMP,NX,NVEX,N,IFAC,ILA,IERR)
      GO TO 330
  320 CONTINUE
      CALL QPASSM(WORK(1),WORK(IFAC*ILA+1),A(IA),A(IA+ILA*INC),TRIGS,
     *    1,INC,NX,JUMP,NVEX,N,IFAC,ILA,IERR)
  330 CONTINUE
      IF (IERR.NE.0) GO TO 500
      IGO=-IGO
      IA=ISTART+INC
  340 CONTINUE
C
C     IF NECESSARY, COPY RESULTS BACK TO A
C     ------------------------------------
      IF (MOD(NFAX,2).EQ.0) GO TO 370
      IBASE=1
      JBASE=IA
      DO 360 JJ=1,NVEX
      I=IBASE
      J=JBASE
      DO 350 II=1,N
      A(J)=WORK(I)
      I=I+1
      J=J+INC
  350 CONTINUE
      IBASE=IBASE+NX
      JBASE=JBASE+JUMP
  360 CONTINUE
  370 CONTINUE
C
C     SHIFT A(0) & FILL IN ZERO IMAG PARTS
C     ------------------------------------
      IX=ISTART
      DO 380 J=1,NVEX
      A(IX)=A(IX+INC)
      A(IX+INC)=0.0
      IX=IX+JUMP
  380 CONTINUE
      IF (MOD(N,2).EQ.1) GO TO 400
      IZ=ISTART+(N+1)*INC
      DO 390 J=1,NVEX
      A(IZ)=0.0
      IZ=IZ+JUMP
  390 CONTINUE
  400 CONTINUE
C
      ISTART=ISTART+NVEX*JUMP
cfse  NVEX=64
      NVEX=512
  410 CONTINUE
      RETURN
C
C     ERROR MESSAGES
C     --------------
  500 CONTINUE
      IF(IERR.EQ.1) THEN
  520 FORMAT('VECTOR LENGTH =',I4,', GREATER THAN 64')
      ELSEIF(IERR.EQ.2) THEN
      WRITE(6,540) IFAC
  540 FORMAT( 'FACTOR =',I3,', NOT CATERED FOR')
      ELSE
      WRITE(6,560) IFAC
  560 FORMAT('FACTOR =',I3,', ONLY CATERED FOR IF ILA*IFAC=N')
      ENDIF
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE NMAKLL( KTRUNC, PINTVL, PLAT, KNUM, PLEG, KRET)
C
C---->
C**** NMAKLL
C
C     PURPOSE
C     _______
C
C     This routine creates legendre functions for latitude rows from
C     the given latitude.
C
C     INTERFACE
C     _________
C
C     CALL NMAKLL( KTRUNC, PINTVL, PLAT, KNUM, PLEG, KRET)
C
C     Input parameters
C     ________________
C
C     KTRUNC  - Truncation.
C     PINTVL  - Grid interval (degrees)
C     PLAT    - Start latitude in degrees.
C     KNUM    - Number of latitudes
C
C     Output parameters
C     ________________
C
C     PLEG     - Array of legendre functions for the latitude.
C     KRET     - Return status code
C                0 = OK
C
C     Common block usage
C     __________________
C
C     JDCNDBG
C
C     Method
C     ______
C
C     See below.
C
C     Externals
C     _________
C
C     INTLOG   - Output log message
C     INTLOGR  - Output log message (with real value)
C
C     Reference
C     _________
C
C     None.
C
C     Comments
C     ________
C
C     None at present.
C
C     AUTHOR
C     ______
C
C     J.D.Chambers      *ECMWF*      June 1999
C
C     MODIFICATIONS
C     _____________
C
C     None.
C
C----<
C
      IMPLICIT NONE
C
#include "jparams.h"
#include "parim.h"
C
C     Parameters
C
      INTEGER JPROUTINE
      PARAMETER ( JPROUTINE = 30500 )
C
C     Subroutine arguments
C
      INTEGER KTRUNC, KRET, KNUM
      REAL PLEG, PINTVL, PLAT
      DIMENSION PLEG(*)
C
C     Local variables
C
      REAL ZLAST, ZLAT, ALAT, DEG2RAD
      INTEGER NEXTRW, NEXT, FIRST, LAST
C
C     _______________________________________________________
C
C*    Section 1.    Initialization.
C     _______________________________________________________
C
 100  CONTINUE
C
      IF( NDBG.GT.1 ) THEN
        CALL INTLOG(JP_DEBUG,'NMAKLL: Input parameters:',JPQUIET)
        CALL INTLOG(JP_DEBUG,'NMAKLL: Truncation = ', KTRUNC)
        CALL INTLOG(JP_DEBUG,'NMAKLL: Number of latitudes = ', KNUM)
        CALL INTLOGR(JP_DEBUG,
     X    'NMAKLL: Grid interval (degrees) = ', PINTVL)
        CALL INTLOGR(JP_DEBUG,
     X    'NMAKLL: Latitude in degrees = ', PLAT)
      ENDIF
C
      IF( PLAT.LT.0.0 ) THEN
        ZLAT = 0.0
      ELSE
        ZLAT = PLAT
      ENDIF
C
C     _______________________________________________________
C
C*    Section 2.    Processing.
C     _______________________________________________________
C
      DEG2RAD = PPI / 180.0
C
      ZLAST = ZLAT - (KNUM-1)*PINTVL
      NEXTRW = 1
      FIRST = NINT(ZLAT/PINTVL)
      LAST  = NINT(ZLAST/PINTVL)
      DO NEXT = FIRST, LAST, -1
        ALAT = (NEXT*PINTVL) * DEG2RAD
C
        IF( NDBG.GT.1 ) CALL INTLOGR(JP_DEBUG,
     X    'NMAKLL: Next latitude constructed = ', (NEXT*PINTVL))
C
        CALL JSPLEG1( PLEG(NEXTRW), ALAT, KTRUNC)
        NEXTRW = NEXTRW + (KTRUNC+1)*(KTRUNC+4)/2
      ENDDO
C     _______________________________________________________
C
C*    Section 9. Return to calling routine. Format statements
C     _______________________________________________________
C
 900  CONTINUE
      KRET = 0
C
 990  CONTINUE
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE BUPRS1(KSEC1)
C
C**** *BUPRS1*
C
C
C     PURPOSE.
C     --------
C           PRINT SECTION 1 OF BUFR MESSAGE.
C
C
C**   INTERFACE.
C     ----------
C
C           *CALL* *BUPRS1(KSEC1)*
C
C        INPUT :
C               *KSEC1*   -  ARRAY CONTAINING SECTION 1 INFORMATION
C                            KSEC1( 1)-- LENGTH OF SECTION 1 (BYTES)
C                            KSEC1( 2)-- BUFR EDITION NUMBER
C                            KSEC1( 3)-- ORIGINATING CENTRE
C                            KSEC1( 4)-- UPDATE SEQUENCE NUMBER
C                            KSEC1( 5)-- FLAG (PRESENCE OF SECTION 2)
C                            KSEC1( 6)-- BUFR MESSAGE TYPE
C                            KSEC1( 7)-- BUFR MESSAGE SUBTYPE
C                            KSEC1( 8)-- VERSION NUMBER OF LOCAL TABLE USED
C                            KSEC1( 9)-- YEAR
C                            KSEC1(10)-- MONTH
C                            KSEC1(11)-- DAY
C                            KSEC1(12)-- HOUR
C                            KSEC1(13)-- MINUTE
C                            KSEC1(14)-- BUFR MASTER TABLE
C                            KSEC1(15)-- VERSION NUMBER OF MASTER TABLE USED
C                            KSEC1(16) - KSEC1(JSEC1) -- LOCAL ADP CENTRE
C                                        INFORMATION(BYTE BY BYTE)
C
C                            FOR BUFR EDITION >= 3
C
C                            KSEC1(16) - ORIGINATING SUB-CENTRE
C                            KSEC1(18) - KSEC1(JSEC1) -- LOCAL ADP CENTRE
C                                        INFORMATION(BYTE BY BYTE)
C                            
C
C                            FOR BUFR EDITION 4 ONWARD
C
C                            KSEC1(16)-- ORIGINATING SUB-CENTRE
C                            KSEC1(17)-- INTERNATIONAL SUB-CATEGORY (SEE COMMON TABLE C-13
C                            KSEC1(18)-- SECOND
C                            KSEC1(19)-- YEAR
C                            KSEC1(20)-- MONTH
C                            KSEC1(21)-- DAY
C                            KSEC1(22)-- HOUR
C                            KSEC1(23)-- MINUTE
C                            KSEC1(24)-- SECOND
C                            KSEC1(25)-- YEAR
C                            KSEC1(26)-- MONTH
C                            KSEC1(27)-- DAY
C                            KSEC1(28)-- HOUR
C                            KSEC1(29)-- MINUTE
C                            KSEC1(30)-- SECOND
C                            KSEC1(31)-- MOST SOUTHERN LATITUDE  (-90 to 90)
C                            KSEC1(32)-- MOST WESTERN LONGITUDE  ( 0-360)
C                            KSEC1(33)-- MOST NORTHEN LATITUDE   (-90 to 90)
C                            KSEC1(34)-- MOST EASTERN LONGITUDE  ( 0-360)
C                            KSEC1(35) TO KSEC1(JSEC1) - LOCAL ADP CENTRE INFORMATION(PACKED FORM)

C
C     METHOD.
C     -------
C
C            NONE
C
C     EXTERNALS.
C     ----------
C
C            NONE.
C
C     REFERENCE.
C     ----------
C
C          NONE.
C
C     AUTHOR.
C     -------
C
C          M. DRAGOSAVAC    *ECMWF*       04/02/91.
C
C     MODIFICATIONS.
C     --------------
C
C          NONE.
C
      IMPLICIT LOGICAL(L,O,G), CHARACTER*8(C,H,Y)
C
C
#     include "parameter.F"
#     include "bcomunit.F"
C
      DIMENSION KSEC1(JSEC1)
C
C     ------------------------------------------------------------------
C
C*          1.   PRINT SECTION 1.
C                ----------------
 100  CONTINUE
C
      WRITE(KNTN,'(1H1)')
C
      IF(KSEC1( 2).LE.3) THEN
      WRITE(KNTN,'(1H ,A)')    '        BUFR SECTION 1    '
      WRITE(KNTN,'(1H )')
      WRITE(KNTN,'(1H ,A,I5)')'LENGTH OF SECTION 1 (BYTES)   ',KSEC1( 1)
      WRITE(KNTN,'(1H ,A,I5)')'BUFR EDITION NUMBER           ',KSEC1( 2)
      IF(KSEC1(2).GE.3) THEN
      WRITE(KNTN,'(1H ,A,I5)')'ORIGINATING SUB-CENTRE        ',KSEC1(16)
      END IF
      WRITE(KNTN,'(1H ,A,I5)')'ORIGINATING CENTRE            ',KSEC1( 3)
      WRITE(KNTN,'(1H ,A,I5)')'UPDATE SEQUENCE NUMBER        ',KSEC1( 4)
      WRITE(KNTN,'(1H ,A,I5)')'FLAG (PRESENCE OF SECTION 2)  ',KSEC1( 5)
      WRITE(KNTN,'(1H ,A,I5)')'BUFR MESSAGE TYPE             ',KSEC1( 6)
      WRITE(KNTN,'(1H ,A,I5)')'BUFR MESSAGE SUBTYPE          ',KSEC1( 7)
      WRITE(KNTN,'(1H ,A,I5)')'VERSION NUMBER OF LOCAL TABLE ',KSEC1( 8)
      WRITE(KNTN,'(1H ,A,I5)')'YEAR                          ',KSEC1( 9)
      WRITE(KNTN,'(1H ,A,I5)')'MONTH                         ',KSEC1(10)
      WRITE(KNTN,'(1H ,A,I5)')'DAY                           ',KSEC1(11)
      WRITE(KNTN,'(1H ,A,I5)')'HOUR                          ',KSEC1(12)
      WRITE(KNTN,'(1H ,A,I5)')'MINUTE                        ',KSEC1(13)
      WRITE(KNTN,'(1H ,A,I5)')'VERSION NUMBER OF MASTER TABLE',KSEC1(15)
      WRITE(KNTN,'(1H ,A,I5)')'BUFR MASTER TABLE             ',KSEC1(14)

      ELSEIF(KSEC1( 2).EQ.4) THEN

      WRITE(KNTN,'(1H ,A)')    '        BUFR SECTION 1    '
      WRITE(KNTN,'(1H )')
      WRITE(KNTN,'(1H ,A,I9)')'LENGTH OF SECTION 1 (BYTES)   ',KSEC1( 1)
      WRITE(KNTN,'(1H ,A,I9)')'BUFR MASTER TABLE             ',KSEC1(14)
      WRITE(KNTN,'(1H ,A,I9)')'ORIGINATING CENTRE            ',KSEC1( 3)
      WRITE(KNTN,'(1H ,A,I9)')'ORIGINATING SUB-CENTRE        ',KSEC1(16)
      WRITE(KNTN,'(1H ,A,I9)')'UPDATE SEQUENCE NUMBER        ',KSEC1( 4)
      WRITE(KNTN,'(1H ,A,I9)')'FLAG (PRESENCE OF SECTION 2)  ',KSEC1( 5)
      WRITE(KNTN,'(1H ,A,I9)')'DATA CATEGORY                 ',KSEC1( 6)
      WRITE(KNTN,'(1H ,A,I9)')'DATA SUB-CATEGORY             ',KSEC1(17)
      WRITE(KNTN,'(1H ,A,I9)')'LOCAL DATA SUB-CATEGORY       ',KSEC1( 7)
      WRITE(KNTN,'(1H ,A,I9)')'VERSION NUMBER OF MASTER TABLE',KSEC1(15)
      WRITE(KNTN,'(1H ,A,I9)')'VERSION NUMBER OF LOCAL TABLE ',KSEC1( 8)
      WRITE(KNTN,'(1H ,A,I9)')'YEAR                          ',KSEC1( 9)
      WRITE(KNTN,'(1H ,A,I9)')'MONTH                         ',KSEC1(10)
      WRITE(KNTN,'(1H ,A,I9)')'DAY                           ',KSEC1(11)
      WRITE(KNTN,'(1H ,A,I9)')'HOUR                          ',KSEC1(12)
      WRITE(KNTN,'(1H ,A,I9)')'MINUTE                        ',KSEC1(13)
      WRITE(KNTN,'(1H ,A,I9)')'SECOND                        ',KSEC1(18)
c     WRITE(KNTN,'(1H ,A,I9)')'YEAR    (EARLIEST TIME)       ',KSEC1(19)
c     WRITE(KNTN,'(1H ,A,I9)')'MONTH   (EARLIEST TIME)       ',KSEC1(20)
c     WRITE(KNTN,'(1H ,A,I9)')'DAY     (EARLIEST TIME)       ',KSEC1(21)
c     WRITE(KNTN,'(1H ,A,I9)')'HOUR    (EARLIEST TIME)       ',KSEC1(22)
c     WRITE(KNTN,'(1H ,A,I9)')'MINUTE  (EARLIEST TIME)       ',KSEC1(23)
c     WRITE(KNTN,'(1H ,A,I9)')'SECOND  (EARLIEST TIME)       ',KSEC1(28)
c     WRITE(KNTN,'(1H ,A,I9)')'YEAR    (LATEST TIME)         ',KSEC1(25)
c     WRITE(KNTN,'(1H ,A,I9)')'MONTH   (LATEST TIME)         ',KSEC1(26)
c     WRITE(KNTN,'(1H ,A,I9)')'DAY     (LATEST TIME)         ',KSEC1(27)
c     WRITE(KNTN,'(1H ,A,I9)')'HOUR    (LATEST TIME)         ',KSEC1(28)
c     WRITE(KNTN,'(1H ,A,I9)')'MINUTE  (LATEST TIME)         ',KSEC1(29)
c     WRITE(KNTN,'(1H ,A,I9)')'SECOND  (LATEST TIME)         ',KSEC1(30)
c     WRITE(KNTN,'(1H ,A,I9)')'MOST SOUTHERN LATITUDE        ',KSEC1(31)
c     WRITE(KNTN,'(1H ,A,I9)')'MOST WESTERN LONGITUDE        ',KSEC1(32)
c     WRITE(KNTN,'(1H ,A,I9)')'MOST NORTHERN LATITUDE        ',KSEC1(33)
c     WRITE(KNTN,'(1H ,A,I9)')'MOST EASTERN LONGITUDE        ',KSEC1(34)

      END IF

C
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      INTEGER FUNCTION IGALLOC (KLEVEL, KREQUEST, KADDR, KPR, KERR)
C
C---->
C**** *IGALLOC*
C
C     PURPOSE
C     _______
C
C     This routine allocates heap space.
C
C     INTERFACE
C     _________
C
C     IERR = IGALLOC (KLEVEL, KREQUEST, KADDR, KPR, KERR)
C
C     Input parameters
C     ________________
C
C     KLEVEL     - The heap block number.
C
C     KREQUEST   - The amount of heap space required.
C
C     KPR        - The debug print switch.
C                  0  , No debugging output.
C                  1  , Produce debugging output.
C
C     KERR       - The error control flag.
C                  -ve, No error message. Return error code.
C                  0  , Hard failure with error message.
C                  +ve, Print error message. Return error code.
C
C     Output parameters
C     ________________
C
C     KADDR      - The base address of the heap space allocated.
C
C     Return value
C     ____________
C
C     The error indicator (INTEGER).
C
C     Error and Warning Return Values
C     _______________________________
C
C     Cray error codes
C
Cray  -1    HPDEALLC block is already free (Warning only).
Cray
Cray  24301 HPDEALLC attempt to free block at address outside the
Cray        bounds of the heap.
Cray  24302 HPDEALLC attempt to free block at address which was not
Cray        the beginning of a block.
Cray  24303 HPDEALLC returning any other non zero code.
Cray  24304 HPALLOC request was not greater than 0 words.
Cray  24305 HPALLOC called and not enough memory was available.
Cray  24306 HPALLOC The memory arena has been truncated by a user
Cray        ssbreak(2) call.
Cray  24307 HPALLOC returning any other non zero code.
Cray
Cray  Errors 24301, 24302 and 24304 should not occur and any occurrence
Cray  of one of these errors should be reported to Meteorological
Cray  Applications.
C
C     Sun and SGI error codes
C
C     24301 MALLOC memory allocation failed.
C
C     Common block usage
C     __________________
C
C     memreq.h  - This file contains the memory request definition
C                 variables.
C
C     MADDR     - The base addresses of the currently allocated
C                 memory segments are modified.
C     MREQUEST  - The sizes of the current memory requests are modified.
C
C     EXTERNALS
C     _________
C
C     INTLOG(R)    - Logs messages.
C
C     Cray externals
C
Cray  HPALLOC   - Cray library routine to allocate heap space.
Cray  HPDEALLC  - Cray library routine to de-allocate heap space.
C
C     Sun and SGI externals
C
C     JFREE     - Unix routine to free heap space.
C     JMALLOC   - Unix routine to acquire heap space.
C
C     METHOD
C     ______
C
C     The heap block number is used to indicate which heap is being
C     modified. Currently heap 1 is used to acquire space for
C     expanding GRIB arrays into real arrays and heap 2 is used for
C     internal space during the interpolation process.
C
C     REFERENCE
C     _________
C
C     None
C
C     COMMENTS
C     ________
C
C     Program contains sections 0 to 2 and 9
C
C     AUTHOR
C     ______
C
C     K. Fielding      *ECMWF*      Jan 1994
C
C     MODIFICATIONS
C     _____________
C
C     J.D.Chambers     ECMWF        Feb 1997
C     Allow for 64-bit pointers
C
C----<
C     -----------------------------------------------------------------|
C*    Section 0. Definition of variables.
C     -----------------------------------------------------------------|
C
      IMPLICIT NONE
C
#include "parim.h"
#include "memreq.h"
C
C     Function arguments
C
      INTEGER KLEVEL, KREQUEST, KPR, KERR
#if (defined POINTER_64)
      INTEGER*8 KADDR
#else
      INTEGER KADDR
#endif
C
C     Local variables
C
      INTEGER IABORT, IERROR
#ifdef POINTER_64
      INTEGER*8 IDUMMY
#else
      INTEGER IDUMMY
#endif
      DATA IDUMMY/0/
      INTEGER JPROUTINE
      PARAMETER (JPROUTINE = 24300)
C
C     External functions
C
#ifdef POINTER_64
      INTEGER*8 JMALLOC
#else
      INTEGER JMALLOC
#endif
      EXTERNAL JMALLOC
C
C     -----------------------------------------------------------------|
C*    Section 1. Initialisation
C     -----------------------------------------------------------------|
C
  100 CONTINUE
C
      IGALLOC = 0
C
      IF( KPR.GE.1 ) THEN
        CALL INTLOG(JP_DEBUG,'IGALLOC: Input parameters.',JPQUIET)
        CALL INTLOG(JP_DEBUG,'IGALLOC: Heap number = ',KLEVEL)
        CALL INTLOG(JP_DEBUG,'IGALLOC: Heap request = ',KREQUEST)
        CALL INTLOG(JP_DEBUG,'IGALLOC: Current heap =',MREQUEST(KLEVEL))
      ENDIF
C
C     -----------------------------------------------------------------|
C*    Section 2. Calculate arrays of weights
C     -----------------------------------------------------------------|
C
  200 CONTINUE
C
      IABORT = 0
      IERROR = 0
C
      IF( MREQUEST(KLEVEL).LT.KREQUEST.AND.MREQUEST(KLEVEL).GT.0) THEN
C
C       Memory required is greater than that currently allocated
C
C       Return any heap in use for spectral -> grid point operations
C
        CALL JMEMHAN(1,IDUMMY,IDUMMY,0,IERROR)
        CALL JMEMHAN(2,IDUMMY,IDUMMY,0,IERROR)
C
        CALL JFREE (MADDR (KLEVEL) )
      ENDIF
C
C     First request for memory.
C
      IF( MREQUEST(KLEVEL).LT.KREQUEST ) THEN
C
C       Return any heap in use for spectral -> grid point operations
C
        CALL JMEMHAN(1,IDUMMY,IDUMMY,0,IERROR)
        CALL JMEMHAN(2,IDUMMY,IDUMMY,0,IERROR)
C
        MADDR(KLEVEL) = JMALLOC(KREQUEST)
#ifdef hpR64
        MADDR(KLEVEL) = MADDR(KLEVEL)/(1024*1024*1024*4)
#endif
        IF( MADDR(KLEVEL).EQ.0 ) THEN
C
          IGALLOC = JPROUTINE + 8
          CALL INTLOG(JP_ERROR,'IGALLOC: Memory requested = ',KREQUEST)
          CALL INTLOG(JP_ERROR,
     X      'IGALLOC: No more memory available from system.',JPQUIET)
          IF( KERR.EQ.0 ) CALL INTLOG(JP_FATAL,
     X      'IGALLOC: Interpolation failed.',IGALLOC)
          GOTO 900
        ENDIF
C
        KADDR = MADDR(KLEVEL)
        MREQUEST(KLEVEL) = KREQUEST
C
      ELSE
C
C       Memory required is <= to that already allocated
C
        KADDR = MADDR(KLEVEL)
C
      ENDIF
C
      IF( KPR.GE.1 ) THEN
        CALL INTLOG(JP_DEBUG,'IGALLOC: Return heap address = ',KADDR)
      ENDIF
C
C     -----------------------------------------------------------------|
C*    Section 9. Return to calling routine. Format statements
C     -----------------------------------------------------------------|
C
  900 CONTINUE
C
      IF( KPR.GE.1 ) CALL INTLOG(JP_DEBUG,'IGALLOC: Section 9.',JPQUIET)

      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      INTEGER FUNCTION IBASINI(KFORCE)
C
C---->
C**** IBASINI
C  
C     Purpose
C     -------
C
C     Ensures basic initialisation of common blocks is done
C  
C     Interface
C     ---------
C
C     IRET = IBASINI(KFORCE)
C
C
C     Input parameters
C     ----------------
C
C     KFORCE  = 1, to force initialisation of common blocks.
C             = 0, to check if initialisation of common blocks is done
C                  already (and do it if not already done).
C  
C  
C     Method
C     ------
C
C     NJDCDOT in nifld.common is checked/set.
C
C     Looks for environment variable INTERP_GEN_COEFFS which gives
C     the name of a file containing the cutoff spectral truncation
C     above which interpolation coefficients are generated 'on the
C     fly'. Variable NICOMP is set with this value in nifld.common.
C     The file contains entries for each computer architecture in
C     format:
C
C       col 1
C         |
C         v
C         FUJITSU 319
C         sgimips 213
C         hppa 213
C         DEFAULT 106
C
C     If no matching $ARCH value, the DEFAULT value is used.
C     If no matching $ARCH and no DEFAULT value, a hard-code value is used.
C
C     Looks for environment variable USE_HIRLAM_12POINT to determine
C     whether or not the Hiralm 12-point horizontal interpolation is
C     to be used for rotations.
C
C
C     Externals
C     ---------
C
C     CLEAR_C - Clear common block variables
C     GETENV  - Get value of an environment variable
C     JINDEX  - Returns length of character string
C  
C  
C     Author
C     ------
C
C     J.D.Chambers       ECMWF        August 1994.
C
C----<
C
C     -----------------------------------------------------------------|
C
      IMPLICIT NONE
C
#include "parim.h"
#include "nifld.common"
#include "nofld.common"
#include "intf.h"
C
C     Function arguments
C
      INTEGER KFORCE
C
C     Local variables
C
      CHARACTER*120 LINE
      CHARACTER*20 ARCH, USEHIR
      CHARACTER*256 CONFIG
      INTEGER IMAGIC, IRET, ICONFIG, IBLANK, LOOP
      DATA ICONFIG/69/
      DATA IMAGIC/1952999238/
C
C     Externals
C
      INTEGER JINDEX
C
C     -----------------------------------------------------------------|
C     Section 1. Force initialisation if requested.
C     -----------------------------------------------------------------|
C
  100 CONTINUE
C
      IF ( KFORCE .EQ. 1 ) NJDCDOT = 0
C
C     See if basic initialisation has already been done or not
C
      IF ( NJDCDOT .NE. IMAGIC ) THEN
C
C       Clear common block variables
C
        CALL CLEAR_C()
C
        IRET = 1
        CALL IAINIT(0,IRET)
C
C       Set interpolation handling default values
C       (Replaces old call to rddefs)
C
        NILOCAL = 0
        NISTREM = 0
        NIFORM = 1
        NOFORM = 1
        NITABLE = 128
        NOTABLE = 128
        NIPARAM = 0
        DO LOOP = 1,4
          NIAREA(LOOP) = 0
          NOAREA(LOOP) = 0
        ENDDO
        NISCNM = 0
        NOSCNM = 0
C
C       Set default value for truncation above which interpolation
C       coefficients are to be computed dynamically
C
        NICOMP = 319
C
C       Now see if this default value has been modified in a
C       configuration file
C
        CALL GETENV('INTERP_GEN_COEFFS', CONFIG)
        IBLANK = JINDEX(CONFIG)
        IF( IBLANK.GE.1 ) THEN
C
C         Open the configuration file
C
          OPEN( ICONFIG, FILE=CONFIG, STATUS='OLD', ERR=200)
          CALL GETENV('ARCH', ARCH)
          IBLANK = JINDEX(ARCH)
          IF( IBLANK.LT.1 ) ARCH = 'DEFAULT'
          IBLANK = JINDEX(ARCH)
C
C         Look for matching 'arch'
C
  110     CONTINUE
          READ( ICONFIG, '(A)', END= 200) LINE
          IF( ARCH(1:IBLANK).EQ.LINE(1:IBLANK) ) THEN
            READ(LINE(IBLANK+1:),'(1X,I3)') NICOMP
            GOTO 200
          ENDIF
C
C         Pickup default (will be used if no matching 'arch')
C
          IF( (LINE(1:7).EQ.'DEFAULT').OR.
     X        (LINE(1:7).EQ.'default') )
     X      READ(LINE(IBLANK+1:),'(1X,I3)') NICOMP
C
          GOTO 110
        ENDIF
C
C     -----------------------------------------------------------------|
C     Section 2. See if Hirlam 12-point horizontal interpolation to be
C                use for rotations (default = 'yes').
C     -----------------------------------------------------------------|
C
  200   CONTINUE
C
        LUSEHIR = .TRUE.
        CALL GETENV('USE_HIRLAM_12POINT', USEHIR)
        IF( (USEHIR(1:3).EQ.'OFF').OR.(USEHIR(1:2).EQ.'NO') )
     X    LUSEHIR = .FALSE.
C
C     -----------------------------------------------------------------|
C     Section 9. Return
C     -----------------------------------------------------------------|
C
  900   CONTINUE
C
C       Set 'magic number' to show basic initialisation has been done
C
        NJDCDOT = IMAGIC
C
      ENDIF
C
      IBASINI = 0
C
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities
C granted to it by virtue of its status as an intergovernmental organisation
C nor does it submit to any jurisdiction.
C

      SUBROUTINE JMEMHAN( KFLAG, KZOUTBF, KSIZE, KOPT, KRET)
C
C---->
C**** JMEMHAN
C
C     PURPOSE
C     _______
C
C     This routine handles memory allocation for jintll.F and jintgg.F
C
C     INTERFACE
C     _________
C
C     CALL JMEMHAN( KFLAG, KZOUTBF, KSIZE, KOPT, KRET)
C
C     Input parameters
C     ________________
C
C     KFLAG   - Flag to select lat/long or gaussian allocation
C               = 1  for grid to grid interpolation (igalloc)
C               = 2  for grid to grid interpolation (igalloc)
C               = 3  for scratch space
C               = 4  for vorticity and divergence scratch space
C               = 5  for even more scratch space (!?)
C               = 6  for latitude/longitude interpolation coefficients
C                    on Fujitsu
C               = 7  for gaussian interpolation coefficients on Fujitsu
C               = 8  unused
C               = 9  for FFT work space
C               = 10 for output (partial) grid point field workspace
C               = 11 for work space for rotating fields (see intfap.F)
C               = 12 for raw land-sea mask (see iglsmst.F)
C               = 13 for 10 minute land-sea mask (see iglsm01.F)
C               = 14 for reading legendre coefficents line by line
C               = 15 more work space for rotating fields (see intfap.F)
C               = 16 more work space intfbu.F
C               = 17 more work space ??
C               = 18 for rotation of gaussian grids (ggrotat and tatorgg)
C               = 19 for dynamic allocation of znfeldi (intf)
C               = 20 to 22, coefficients for rotating spectral fields (jacobif)
C
C     KSIZE   - Size of memory required in words
C     KOPT    - Memory option
C               = 0 to deallocate
C               = 1 to allocate
C
C
C     Output parameters
C     ________________
C
C     KZOUTBF - Pointer to memory (if allocating)
C     KRET    - Return status code
C               0 = OK
C
C
C     Common block usage
C     __________________
C
C     JDCNDGB
C     JMEMCOM
C
C
C     Method
C     ______
C
C     None.
C
C
C     Externals
C     _________
C
C     JDEBUG    - Checks environment variable to switch on/off debug
C     JMALLOC   - Allocate heap space
C     JFREE     - Deallocate heap space
C     INTLOG    - Output log message
C     IAFREE    - Deallocate heap space used by grid-pt to grid-pt
C                 interpolation
C
C
C     Reference
C     _________
C
C     None.
C
C
C     Comments
C     ________
C
C     None.
C
C
C     AUTHOR
C     ______
C
C     J.D.Chambers      *ECMWF*      May 1994
C
C     MODIFICATIONS
C     _____________
C
C     J.D.Chambers      *ECMWF*      Jan 1995
C     Add scratch for vorticity and divergence (flag = 4)
C
C     J.D.Chambers      *ECMWF*      Jan 1995
C     Add space for interpolation coefficents (flag = 6)
C
C     J.D.Chambers      *ECMWF*      Sep 1996
C     Split space for interpolation coefficents (flag = 6 and 7)
C
C     J.D.Chambers     ECMWF        Feb 1997
C     Allow for 64-bit pointers
C
C     J.D.Chambers     ECMWF        Mar 1998
C     Allow memory flushing
C
C----<
C     -------------------------------------------------------
C*    Section 0. Definition of variables.
C     -------------------------------------------------------
C
      IMPLICIT NONE
#include "jparams.h"
#include "jparam2.h"
#include "parim.h"
C
C     Parameters
C
      INTEGER JPROUTINE, JPOPTMX
      PARAMETER ( JPROUTINE = 30600 )
      PARAMETER ( JPOPTMX = 22 )
C
C     Subroutine arguments
C
#ifdef POINTER_64
      INTEGER*8 KZOUTBF
#else
      INTEGER KZOUTBF
#endif
      INTEGER KSIZE, KOPT, KRET, KFLAG
C
C     Local variables
C
      LOGICAL LDEBUG, LDEBUG1
      INTEGER ITOTAL, LOOP
#ifdef POINTER_64
      INTEGER*8 IZOUTBF
#else
      INTEGER IZOUTBF
#endif
      INTEGER IEXIST
      DIMENSION IEXIST(JPOPTMX)
      DIMENSION IZOUTBF(JPOPTMX)
      DATA IEXIST/ JPOPTMX * -1/
      DATA IZOUTBF/ JPOPTMX * 0/
C
      SAVE IEXIST, IZOUTBF
C
C     Externals
C
#ifdef POINTER_64
      INTEGER*8 JMALLOC
#else
      INTEGER JMALLOC
#endif
      INTEGER IAFREE
      EXTERNAL JMALLOC, IAFREE
C
C     -------------------------------------------------------
C*    Section 1.    Initialisation.
C     -------------------------------------------------------
C
  100 CONTINUE
C
      KRET = 0
      CALL JDEBUG( )
      LDEBUG  = ( NDBG.GT.0 )
      LDEBUG1 = ( NDBG.EQ.1 )
C
C     Check that a  valid option has been chosen
C
      IF( ( KFLAG.LT.1 ).OR.( KFLAG.GT.JPOPTMX ) ) THEN
        CALL INTLOG(JP_ERROR,'JMEMHAN: Invalid flag = ', KFLAG)
        KRET = JPROUTINE + 1
        GOTO 900
      ENDIF
C
C     Display diagnostics if required
C
      IF( LDEBUG ) THEN
C
        CALL INTLOG(JP_DEBUG,'JMEMHAN: Input parameters:',JPQUIET)
        CALL INTLOG(JP_DEBUG, 'JMEMHAN: Memory type flag = ', KFLAG)
C
        IF( ( KFLAG.EQ.1 ).OR.( KFLAG.EQ.2 ) ) CALL INTLOG(JP_DEBUG,
     X    'JMEMHAN: 1 = grid to grid interpolation', JPQUIET)
C
        IF( ( KFLAG.EQ.3 ).OR.( KFLAG.EQ.4 ).OR.( KFLAG.EQ.5 ) )
     X    CALL INTLOG(JP_DEBUG,
     X    'JMEMHAN: 3->5 = scratch,',JPQUIET)
C
        IF( KFLAG.EQ.6 ) CALL INTLOG(JP_DEBUG,
     X    'JMEMHAN: 6 = coeffs for spectral to lat/long interp',JPQUIET)
C
        IF( KFLAG.EQ.7 ) CALL INTLOG(JP_DEBUG,
     X    'JMEMHAN: 7 = coefs for spectral to gaussian interp,',JPQUIET)
C
        IF( KFLAG.EQ.8 ) CALL INTLOG(JP_DEBUG,
     X    'JMEMHAN: 8 = coefficients for rotating SH fields',JPQUIET)
C
        IF( KFLAG.EQ.9 ) CALL INTLOG(JP_DEBUG,
     X    'JMEMHAN: 9 = FFT workspace,',JPQUIET)
C
        IF( KFLAG.EQ.10 ) CALL INTLOG(JP_DEBUG,
     X    'JMEMHAN: 10 = output (partial) grid pt field,',JPQUIET)
C
        IF( KFLAG.EQ.11 ) CALL INTLOG(JP_DEBUG,
     X    'JMEMHAN: 11 = work space for rotating fields,',JPQUIET)
C
        IF( KFLAG.EQ.12 ) CALL INTLOG(JP_DEBUG,
     X    'JMEMHAN: 12 = raw land-sea mask,',JPQUIET)
C
        IF( KFLAG.EQ.13 ) CALL INTLOG(JP_DEBUG,
     X    'JMEMHAN: 13 = 10 minute land-sea mask.',JPQUIET)
C
        IF( KFLAG.EQ.14 ) CALL INTLOG(JP_DEBUG,
     X    'JMEMHAN: 14 = legendre coefficents line by line.',JPQUIET)
C
        IF( KFLAG.EQ.15 ) CALL INTLOG(JP_DEBUG,
     X    'JMEMHAN: 15 = more work space for rotating fields.',JPQUIET)
C
        IF( KFLAG.EQ.16 ) CALL INTLOG(JP_DEBUG,
     X    'JMEMHAN: 16 = more work space for intfbu.F.',JPQUIET)
C
        IF( KFLAG.EQ.17 ) CALL INTLOG(JP_DEBUG,
     X    'JMEMHAN: 17 = more work space for ??.',JPQUIET)
C
        IF( KFLAG.EQ.18 ) CALL INTLOG(JP_DEBUG,
     X    'JMEMHAN: 18 = space for rotating gaussian fields.',JPQUIET)
C
        IF( KFLAG.EQ.19 ) CALL INTLOG(JP_DEBUG,
     X    'JMEMHAN: 19 = for dynamic allocation of znfeldi.',JPQUIET)
C
        IF( KFLAG.EQ.20 ) CALL INTLOG(JP_DEBUG,
     X    'JMEMHAN: 20 = coefficients for rotating SH fields',JPQUIET)
C
        IF( KFLAG.EQ.21 ) CALL INTLOG(JP_DEBUG,
     X    'JMEMHAN: 21 = coefficients for rotating SH fields',JPQUIET)
C
        IF( KFLAG.EQ.22 ) CALL INTLOG(JP_DEBUG,
     X    'JMEMHAN: 22 = coefficients for rotating SH fields',JPQUIET)
C
        CALL INTLOG(JP_DEBUG,'JMEMHAN: Memory reqd in words = ', KSIZE)
        CALL INTLOG(JP_DEBUG,'JMEMHAN: Option (1 = allocate) = ', KOPT)
      ENDIF
C
C     -------------------------------------------------------
C*    Section 2.    Allocate memory
C     -------------------------------------------------------
C
  200 CONTINUE
C
      IF( KOPT.EQ.1 ) THEN
C
        IF( LDEBUG ) THEN
          CALL INTLOG(JP_DEBUG,
     X      'JMEMHAN: Requested allocation = ', KSIZE)
          CALL INTLOG(JP_DEBUG,
     X      'JMEMHAN: Previous allocation  = ', IEXIST(KFLAG))
        ENDIF
C
C       See if more memory required than already allocated
C
        IF( KSIZE.GT.IEXIST(KFLAG) ) THEN
C
C         Special cases (sigh)
C
C         If allocating memory for spectral to lat/long or gaussian
C         interpolation, first deallocate heap space used by grid-pt
C         to grid-pt interpolation.
C
          IF( ( KFLAG.EQ.1 ).OR.( KFLAG.EQ.2 ) ) THEN
            IF( LDEBUG ) THEN
              KRET = IAFREE(1,1)
            ELSE
              KRET = IAFREE(0,-1)
            ENDIF
          ENDIF
C
C         If allocating memory on VPP for spectral to grid interpolation
C         coefficients, first deallocate memory used by other type of
C         spectral to gaussian interpolation if this option has been
C         requested.
C
          IF( LFREECF ) THEN
            IF( LDEBUG ) CALL INTLOG(JP_DEBUG,
     X        'JMEMHAN: Free coefficients option exercised', JPQUIET)
C
C           Spectral -> lat/long
C
            IF( KFLAG.EQ.6 ) THEN
              IF( IEXIST(7).NE.-1 ) THEN
                IF( LDEBUG ) CALL INTLOG(JP_DEBUG,
     X            'JMEMHAN: Free spect->gaussn coeff memory',IZOUTBF(7))
                CALL JFREE( IZOUTBF(7) )
                IZOUTBF(7) = 0
                IEXIST(7) = -1
                NISIZE7 = 0
                YOLDGG = 'xxxxxxxxxxxxxxxxxxxx'
              ENDIF
            ENDIF
C
C           Spectral -> gaussian
C
            IF( KFLAG.EQ.7 ) THEN
              IF( IEXIST(6).NE.-1 ) THEN
                IF( LDEBUG ) CALL INTLOG(JP_DEBUG,
     X            'JMEMHAN: Free spec->lat/lon coeff memory',IZOUTBF(6))
                CALL JFREE( IZOUTBF(6) )
                IZOUTBF(6) = 0
                IEXIST(6) = -1
                NISIZE6 = 0
                YOLDLL = 'xxxxxxxxxxxxxxxxxxxx'
              ENDIF
            ENDIF
          ENDIF
C
          IF( LDEBUG ) CALL INTLOG(JP_DEBUG,
     X      'JMEMHAN: Request greater than previous allocation', KSIZE)
C
C         If memory already allocated, deallocate existing memory
C
          IF( IEXIST(KFLAG).GE.0 ) THEN
C
            IF( LDEBUG ) CALL INTLOG(JP_DEBUG,
     X          'JMEMHAN: Deallocate existing memory',IEXIST(KFLAG))
            CALL JFREE( IZOUTBF(KFLAG) )
          ENDIF
C
C         Allocate heap memory
C
          IF( LDEBUG ) CALL INTLOG(JP_DEBUG,
     X      'JMEMHAN: Allocate new memory ',KSIZE)
C
          IEXIST(KFLAG) = KSIZE
#if (defined REAL_8)
          IZOUTBF(KFLAG) = JMALLOC( IEXIST(KFLAG) * 8 )
#else
          IZOUTBF(KFLAG) = JMALLOC( IEXIST(KFLAG) * 4 )
#endif
#ifdef hpR64
          IZOUTBF(KFLAG) = IZOUTBF(KFLAG)/(1024*1024*1024*4)
#endif
          IF( IZOUTBF(KFLAG).EQ.0 ) THEN
            CALL INTLOG(JP_ERROR,
     X        'JMEMHAN: Memory allocation failed',IZOUTBF(KFLAG))
            IEXIST(KFLAG) = -1
            KRET = JPROUTINE + 5
            GOTO 900
          ENDIF
        ENDIF
C
        IF( LFREECF ) THEN
C
C         Spectral -> lat/long
C
          IF( KFLAG.EQ.6 ) NISIZE6 = IEXIST(6)
C
C         Spectral -> gaussian
C
          IF( KFLAG.EQ.7 ) NISIZE7 = IEXIST(7)
C
        ENDIF
C
C     -------------------------------------------------------
C*    Section 3.    Deallocate memory
C     -------------------------------------------------------
C
  300 CONTINUE
C
      ELSE
C
        IF( LDEBUG ) CALL INTLOG(JP_DEBUG,
     X    'JMEMHAN: Deallocate memory address = ',IZOUTBF(KFLAG))
C
        IF( IZOUTBF(KFLAG).GT.0 ) THEN
C
          CALL JFREE( IZOUTBF(KFLAG) )
          IZOUTBF(KFLAG) = 0
          IEXIST(KFLAG) = -1
C
        ELSE
          CALL INTLOG(JP_DEBUG,'JMEMHAN: Deallocation ignored',JPQUIET)
        ENDIF
      ENDIF
C
C     _______________________________________________________
C
C*    Section 9. Return to calling routine.
C     _______________________________________________________
C
 900  CONTINUE
      IF( KRET.EQ.0 ) KZOUTBF = IZOUTBF(KFLAG)
C
      IF( LDEBUG.AND.(.NOT.LDEBUG1) ) THEN
        ITOTAL = 0
        DO LOOP = 1, JPOPTMX
          IF( IEXIST(LOOP).GT.0 ) THEN
            CALL INTLOG(JP_DEBUG, 'JMEMHAN: For type ', LOOP)
#if (defined REAL_8)
            CALL INTLOG(JP_DEBUG,
     X        'JMEMHAN: bytes allocated = ', IEXIST(LOOP)*8 )
            ITOTAL = ITOTAL + (IEXIST(LOOP) * 8)
#else
            CALL INTLOG(JP_DEBUG,
     X        'JMEMHAN: bytes allocated = ', IEXIST(LOOP)*4 )
            ITOTAL = ITOTAL + (IEXIST(LOOP) * 4)
#endif
          ENDIF
        ENDDO
        CALL INTLOG(JP_DEBUG,'JMEMHAN: Total bytes allocated=', ITOTAL)
        CALL INTLOG(JP_DEBUG,'JMEMHAN: Return status code = ', KRET)
      ENDIF
C
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE BTABLE(YNAME,YTABB,KERR)
C
C**** *BTABLE*
C
C
C     PURPOSE.
C     --------
C          CREATE BUFR TABLE B IN BINARY FORM.
C
C**   INTERFACE.
C     ----------
C          NONE.
C
C
C     *METHOD.
C      -------
C          NONE.
C
C
C     EXTERNALS.
C     ----------
C          NONE.
C
C
C
C
C     REFERENCE.
C     ----------
C
C          BINARY UNIVERSAL FORM FOR DATA REPRESENTATION, FM 94 BUFR.
C
C          J.K.GIBSON AND M.DRAGOSAVAC,1987: DECODING DATA 
C          REPRESENTATION FM 94 BUFR,TECHNICAL MEMORANDUM NO.
C
C          J.K.GIBSON,1986:EMOS 2 - STANDARDS FOR SOFTWARE DEVELOPMENT
C          AND MAINTANANCE ,TECHICAL MEMORANDUM NO.       ECMWF.
C
C
C     AUTHOR.
C     -------
C
C          M. DRAGOSAVAC       *ECMWF*       JANUARY 1991.
C
C
C     MODIFICATIONS.
C     --------------
C
C          NONE.
C
C
      IMPLICIT LOGICAL(L,O,G), CHARACTER*8(C,H,Y)
C
#     include "parameter.F"
#     include "bcomwork.F"
#     include "bcomtab.F"
#     include "bcomtabc.F"
#     include "bcomct.F"
#     include "bcomctc.F"
#     include "bcomroot.F"
#     include "bcomtabload.F"
#     include "bcomtabloadc.F"

C
      CHARACTER*64 CTABBEN,CCTABBEN
      CHARACTER*24 CTABBU,CCTABBU,CTABLE_LIST,YTABB
      CHARACTER*120 YENTRY
      CHARACTER*(*) YNAME
      CHARACTER*256  YFNAME
      REAL*8 RVIND,EPS
C
C     DATA CTABBEN/JTAB*' '/,CTABBU/JTAB*' '/
C
C     ------------------------------------------------------------------
C*          1.   INITIALIZE CONSTANTS AND VARIABLES.
C                -----------------------------------
 100  CONTINUE
C
      J=0
      ICLASS0=0
      IVIND=2147483647
      YFNAME=' '
C
      DO 101 I=1,64
      do 101 ii=1,255
      NTABP(I,ii)=0
 101  CONTINUE
C
      DO 102 i=1,JTAB
      NTABBTR(I)=IVIND
      NTABBS (I)=IVIND
      NTABBRV(I)=IVIND
      NTABBDW(I)=IVIND
      CTABBEN(I)=' '
      CTABBU (I)=' '
 102  CONTINUE
C
      II=INDEX(YNAME,' ')
      II=II-1
      YFNAME=YNAME(1:II)
      II=INDEX(YFNAME,' ')
      II=II-1
      CALL GET_FREE_UNIT(IUNIT)
      OPEN(UNIT=IUNIT,FILE=YFNAME(1:II),
     2            IOSTAT=IOS,      
     1            STATUS='OLD')
      IF(IOS.NE.0) THEN
         print*,'open error on ',YFNAME(1:II)
         kerr=61
         return
      END IF
C     ------------------------------------------------------------------
C*          2.   READ IN TABLE B ELEMENT.
C                ------------------------
C
 200  CONTINUE
C
      YENTRY=' '
      READ(IUNIT,'(A)',ERR=402,END=300) YENTRY
C
      J=J+1
      IF(J.GT.JTAB) THEN
         PRINT*,' DIMENSION TOO SMALL J=',J
         kerr=6
         return
      END IF 
C
C     ------------------------------------------------------------------
C*          2.1  SET ARRAYS FOR TABLE REFERENCE, ELEMENT NAME, UNITS,
C*               REFERENCE VALUE AND DATA WIDTH.
C
 210  CONTINUE
C
C
      READ(YENTRY,'(1X,I6,1x,64x,1x,24x,1x,I3,1x,I12,1x,I3)')
     1                                         NTABBTR(J),NTABBS (J),
     1                                         NTABBRV(J),NTABBDW(J)
C
      CTABBEN(J)=YENTRY( 9:72)
      CTABBU (J)=YENTRY(74:97)
C
      ICLASS=NTABBTR(J)/1000
      IYYY  =NTABBTR(J)-ICLASS*1000+1
C
      ICLASS=ICLASS+1
      NTABP(ICLASS,IYYY)=J
C
c      WRITE(*,1000) NTABBTR(J),CTABBEN(J),CTABBU(J),NTABBS(J),
c     1              NTABBRV(J),NTABBDW(J)
c 1000 FORMAT(1H ,1X,I6,1x,64x,1x,24x,1x,,I3,1x,I12,1x,I3)
C
      GO TO 200
C
C     ------------------------------------------------------------------
 300  CONTINUE
C
      NTT=NTT+1
      IF(NTT.GT.JTMAX) THEN
         NTT=NTT-1
         NTC=NTC+1
         IF(NTC.GT.10) NTC=1
         DO J=1,JTAB
         MTABBTR(J,NTC)=NTABBTR(J)
         MTABBS (J,NTC)=NTABBS (J)
         MTABBRV(J,NTC)=NTABBRV(J)
         MTABBDW(J,NTC)=NTABBDW(J)
         CCTABBEN(J,NTC)=CTABBEN(J)
         CCTABBU (J,NTC)=CTABBU (J)
         END DO
         DO I=1,64
         DO K=1,255
         MTABP(I,K,NTC)=NTABP(I,K)
         END DO
         END DO
         CTABLE_LIST(NTC)=YTABB
      ELSE
         DO J=1,JTAB
         MTABBTR(J,NTT)=NTABBTR(J)
         MTABBS (J,NTT)=NTABBS (J)
         MTABBRV(J,NTT)=NTABBRV(J)
         MTABBDW(J,NTT)=NTABBDW(J)
         CCTABBEN(J,NTT)=CTABBEN(J)
         CCTABBU (J,NTT)=CTABBU (J)
         END DO
         DO I=1,64
         DO K=1,255
         MTABP(I,K,NTT)=NTABP(I,K)
         END DO
         END DO
         CTABLE_LIST(NTT)=YTABB
      END IF
C
      CLOSE(IUNIT)
C
C     WRITE(*,'(1h )')
C     WRITE(*,'(1h ,a,i4)') 'Total number of entries in Table B is ',j
C
      RETURN
C
402   CONTINUE
      KERR=6
      WRITE(*,4402) IOS,YFNAME
 4402 FORMAT(1H ,'Read error',i4,' on ',a)
      RETURN
C
 401  CONTINUE
C
      KERR=61
      WRITE(*,4401) IOS,YFNAME
 4401 FORMAT(1H ,'Open error',i4,' on ',a)
C     
      RETURN
      END

C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      INTEGER FUNCTION IRDIWE (KLLEN, KINS, KNSIND, KONS, KILONG,
     1   KIWE, KOLONG, KOWE, KWEIND, KWEDIST, KPR, KERR)
C
C---->
C**** *IRDIWE*
C
C     PURPOSE
C     _______
C
C     Calculate the distances between points in an output longitude
C     array and its West and East neighbours in the input longitude
C     array for a quasi regular input field and regular output field.
C
C     INTERFACE
C     _________
C
C     IERR = IRDIWE (KLLEN, KINS, KNSIND, KONS, KILONG, KIWE, KOLONG,
C    1   KOWE, KWEIND, KWEDIST, KPR, KERR)
C
C     Input parameters
C     ________________
C
C     KLLEN      - This array contains the quasi regular Gaussian
C                  line length definition.
C
C     KINS       - The number of points in the North-South direction
C                  in the input field.
C
C     KNSIND     - This array will contain the array offsets of the
C                  North and South points in the input array required
C                  for interpolation.
C
C     KONS       - The number of points in the North-South direction
C                  in the output field.
C
C     KILONG     - The array of input longitudes.
C
C     KIWE       - The maximum number of points in the West-East
C                  direction for this quasi regular Gaussian grid.
C
C     KOLONG     - The array of output longitudes.
C
C     KOWE       - The number of points in the West-East direction in
C                  the output field.
C
C     KPR        - The debug print switch.
C                  0  , No debugging output.
C                  1  , Produce debugging output.
C
C     KERR       - The error control flag.
C                  -ve, No error message. Return error code.
C                  0  , Hard failure with error message.
C                  +ve, Print error message. Return error code.
C
C     Output parameters
C     ________________
C
C     KWEIND     - This array will contain the array offsets of
C                  the West and East points in the input array
C                  required for interpolation for all lines of
C                  latitude.
C
C     KWEDIST    - This array holds the distances to longitude values
C                  in the input field from the associated longitude
C                  values in the output field. This array is
C                  dimensioned (2, KOWE, 2, KONS).
C
C     Return value
C     ____________
C
C     The error indicator (INTEGER).
C
C     Error and Warning Return Values
C     _______________________________
C
C     None
C
C     Common block usage
C     __________________
C
C     None
C
C     EXTERNALS
C     _________
C
C     IGDIWE     - Calculate the distances between points in an
C                  output longitude array and its West and East
C                  neighbours in the input longitude array for one
C                  line of latitude.
C     INTLOG(R)    - Logs messages.
C
C     METHOD
C     ______
C
C     This routine will create the arrays of offsets and distance as
C     two arrays of length (2, Number of output longitudes, 2,
C     Number of output latitudes).
C
C     The array of offsets is copied from line to line provided the
C     number of points in the quasi regular lines of latitude does
C     not change. When the definition changes IGDIWE is used to
C     generate the offsets and distances for the new line definition.
C
C     REFERENCE
C     _________
C
C     None
C
C     COMMENTS
C     ________
C
C     Program contains sections 0 to 2 and 9
C
C     AUTHOR
C     ______
C
C     K. Fielding      *ECMWF*      Nov 1993
C
C     MODIFICATIONS
C     _____________
C
C     None
C
C----<
C     _______________________________________________________
C
C*    Section 0. Definition of variables.
C     _______________________________________________________
C
C*    Prefix conventions for variable names
C
C     Logical      L (but not LP), global or common.
C                  O, dummy argument
C                  G, local variable
C                  LP, parameter.
C     Character    C, global or common.
C                  H, dummy argument
C                  Y (but not YP), local variable
C                  YP, parameter.
C     Integer      M and N, global or common.
C                  K, dummy argument
C                  I, local variable
C                  J (but not JP), loop control
C                  JP, parameter.
C     REAL         A to F and Q to X, global or common.
C                  P (but not PP), dummy argument
C                  Z, local variable
C                  PP, parameter.
C
C     Implicit statement to force declarations
C
      IMPLICIT NONE
C
#include "parim.h"
C
C     Dummy arguments
      INTEGER KINS, KONS, KIWE, KOWE, KPR, KERR
      INTEGER KLLEN (KINS)
      INTEGER KNSIND (2, KONS)
      INTEGER KILONG (KIWE + 1), KOLONG (KOWE)
      INTEGER KWEIND (2, KOWE, 2, KONS),
     1   KWEDIST (2, KOWE, 2, KONS)
C
C     Local variables
      LOGICAL GWEGLOBE
      INTEGER IIPLAT, IILON, ISTRIDE, IPR, IERR
      INTEGER IBLON, IBNS, IBLAT
      INTEGER JLAT, JLON, JNS, JWE
      INTEGER JPROUTINE
      PARAMETER (JPROUTINE = 23900)
C
C     External functions
      INTEGER IGDIWE
C
C     _______________________________________________________
C
C*    Section 1. Initialisation
C     _______________________________________________________
C
  100 CONTINUE
C
      IF (KPR.GE.1) CALL INTLOG(JP_DEBUG,'IRDIWE: Section 1.',JPQUIET)
C
      IRDIWE = 0
C
      IF (KPR .GE. 1) THEN
        CALL INTLOG(JP_DEBUG,'IRDIWE: Input parameters.',JPQUIET)
        CALL INTLOG(JP_DEBUG,'IRDIWE: Max no.input longs = ',KIWE)
        CALL INTLOG(JP_DEBUG,'IRDIWE: No.input lats = ',KINS)
        CALL INTLOG(JP_DEBUG,'IRDIWE: No.output longs = ',KOWE)
        CALL INTLOG(JP_DEBUG,'IRDIWE: No.output lats = ',KONS)
        CALL INTLOG(JP_DEBUG,'IRDIWE: Output field spread = ',KOLONG(1))
        CALL INTLOG(JP_DEBUG,'IRDIWE: to ',KOLONG(KOWE))
      ENDIF
C
      GWEGLOBE = .TRUE.
C
      IBLON = 0
C
      IERR = 0
C
C     _______________________________________________________
C
C*    Section 2. Generate distances and points for all lines
C                of latitude
C     _______________________________________________________
C
  200 CONTINUE
C
      IF (KPR.GE.1) CALL INTLOG(JP_DEBUG,'IRDIWE: Section 2.',JPQUIET)
C
      IPR = KPR
      IBLAT = 1
      IBNS  = 1
C
      DO 250 JLAT = 1, KONS
C
         DO 240 JNS = 1, 2
C
            IIPLAT = KNSIND (JNS, JLAT)
            IILON = KLLEN (IIPLAT)
C
            IF (IILON .EQ. IBLON) THEN
C
C     Same line definition as last one calculated
C
               DO 220 JWE = 1, 2
                  DO 210 JLON = 1, KOWE
C
                     KWEIND (JWE, JLON, JNS, JLAT) =
     1                  KWEIND (JWE, JLON, IBNS, IBLAT)
                     KWEDIST (JWE, JLON, JNS, JLAT) =
     1                  KWEDIST (JWE, JLON, IBNS, IBLAT)
C
  210             CONTINUE
  220          CONTINUE
C
            ELSE
C
               IBLON = IILON
               IBNS = JNS
               IBLAT = JLAT
C
               ISTRIDE = JP360 / IILON
C
C     Generate longitude values for this line
C
               DO 230 JLON = 1, IILON
C
                  KILONG (JLON) = (JLON - 1) * ISTRIDE
C
  230          CONTINUE
C
C     Wrap around input grid to simplify routine IGDIWE
C
               KILONG (IILON + 1) = KILONG (1)
C
               IERR = IGDIWE (KILONG, IILON, KOLONG, KOWE, GWEGLOBE,
     1            KWEIND (1, 1, JNS, JLAT), KWEDIST (1, 1, JNS, JLAT),
     2            IPR, KERR)
C
               IF (IERR .GT. 0) THEN
                  IRDIWE = IERR
                  GO TO 900
               ENDIF
C
               IPR = KPR - 1
C
            ENDIF
C
  240    CONTINUE
C
  250 CONTINUE
C
C
C     _______________________________________________________
C
C*    Section 9. Return to calling routine. Format statements
C     _______________________________________________________
C
  900 CONTINUE
C
      IF (KPR.GE.1) CALL INTLOG(JP_DEBUG,'IRDIWE: Section 9.',JPQUIET)
C
C
      RETURN
      END

      PROGRAM SAMPLE4
C
      IMPLICIT NONE
      INTEGER INTV
      REAL REALV
      CHARACTER*20 CHARV
      DIMENSION INTV(4), REALV(4), CHARV(4)
C
      INTEGER JPGRIB, JPBYTES
C
      PARAMETER (JPGRIB = 7000000)
C
C     Set JPBYTES = 8 on a 64-bit machine.
      PARAMETER (JPBYTES = 4)
C
      INTEGER IVOGRIB (JPGRIB), IDVGRIB (JPGRIB)
      INTEGER IUGRIB (JPGRIB), IVGRIB (JPGRIB)
C
      INTEGER IUNIT1, IUNIT2, IREC, INLENG, IERR, IRET,J,NARGS
C
C     Externals
      INTEGER INTOUT, INTUVP2, IARGC
      LOGICAL ISSAME
C
      CHARACTER*128 INFILE, OUTFILE, CARG(4)
 
C **********************************************************************
C
C     Pick up file names from command line.
C
      NARGS = IARGC()
      IF( NARGS.LT.4 ) THEN
        print*,'Usage: interpolation_example2 -i infile -o outfile'
        STOP
      END IF
 
      DO 101 J=1,NARGS
      CALL GETARG(J,CARG(J))
 101  CONTINUE
 
      DO 102 J=1,NARGS,2
        IF(CARG(J).EQ.'-i') THEN
           INFILE=CARG(J+1)
        ELSEIF(CARG(J).EQ.'-o') THEN
           OUTFILE=CARG(J+1)
        ELSE
        print*,'Usage: interpolation_example2 -i infile -o outfile'
        STOP
        END IF
 102  CONTINUE
 
C **********************************************************************
 
C     Set output grid interval
      REALV(1) = 3.0
      REALV(2) = 3.0
      IRET = INTOUT('grid',INTV,REALV,CHARV)
      IF ( IRET .NE. 0 ) THEN
        STOP 'grid setting INTOUT failed.'
      ENDIF
C
C     Open input and output files.
      CALL PBOPEN(IUNIT1, INFILE, 'r', IERR)
      IF ( IERR .NE. 0 ) STOP ' PBOPEN failed'
      CALL PBOPEN(IUNIT2, OUTFILE, 'w', IERR)
      IF ( IERR .NE. 0 ) STOP ' PBOPEN failed'
C
C     Read vorticity.
      CALL PBGRIB(IUNIT1, IVOGRIB, JPGRIB * JPBYTES, IREC, IERR)
      IF ( IERR .EQ. -1 ) GOTO 900
      IF ( IERR .NE. 0 ) STOP ' PBGRIB failed for vorticity'
C
C     Read divergence.
      CALL PBGRIB(IUNIT1, IDVGRIB, JPGRIB * JPBYTES, IREC, IERR)
      IF ( IERR .EQ. -1 ) GOTO 900
      IF ( IERR .NE. 0 ) STOP ' PBGRIB failed for divergence'
C
C     Create U and V
      WRITE(*,*) ' Create U and V.'
      INLENG = JPGRIB
      IRET = INTUVP2(IVOGRIB, IDVGRIB, JPGRIB, IUGRIB, IVGRIB, INLENG)
      IF ( IRET .NE. 0 ) THEN
        WRITE(*,*) ' INTUVP failed.'
        STOP
      ENDIF
C
C     Write the new U and V products to file
      IF ( INLENG .GT. 0 ) THEN
        CALL PBWRITE(IUNIT2, IUGRIB, INLENG*JPBYTES, IERR)
        IF ( IERR .LT. (INLENG*JPBYTES) ) STOP ' PBWRITE failed'
        CALL PBWRITE(IUNIT2, IVGRIB, INLENG*JPBYTES, IERR)
        IF ( IERR .LT. (INLENG*JPBYTES) ) STOP ' PBWRITE failed'
      ENDIF
C
C     Closedown
 900  CONTINUE
C
C     Close input and output files.
      CALL PBCLOSE(IUNIT1, IERR)
      CALL PBCLOSE(IUNIT2, IERR)
C
      STOP
      END
      

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C


      SUBROUTINE MXMN(PARR,KLEN,PMAX,PMIN)
C
C---->
C**   *SUBROUTINE* *MXMN* - *FIND THE MAXIMUM AND MINIMUM ELEMENTS OF
C                       AN ARRAY
C
C          *JAN *HASELER     *ECMWF*     6/10/82
C
C     PURPOSE
C     -------
C
C          *FIND THE MAXIMUM AND MINIMUM ELEMENTS OF THE ARRAY *PARR*
C
C     INTERFACE
C     ---------
C
C           *CALL* *MXMN(PARR,KLEN,PMAX,PMIN)*
C
C     WHERE *PARR(KLEN)* = INPUT ARRAY
C           *PMAX*       = OUTPUT MAXIMUM ELEMENT OF *PARR*
C           *PMIN*       = OUTPUT MINIMUM ELEMENT OF *PARR*
C
C     *MXMN* IS CALLED FROM SUBROUTINES *OUTSHC,* *OUTSHG,* *OUT2D* AND
C     *OUTDIA*
C
C     RESULTS
C     -------
C
C          *THE VALUES *PMAX* AND *PMIN* ARE RETURNED
C
C     EXTERNALS
C     ---------
C
C          *ISMAX* - *CAL* FUNCTION TO FIND MAX ARRAY ELEMENT
C          *ISMIN* - *CAL* FUNCTION TO FIND MIN ARRAY ELEMENT
C
C     ------------------------------------------------------------------
C----<
C
      DIMENSION PARR(KLEN)
C
C-----------------------------------------------------------------------
C*
C          1.           FIND MAX AND MIN
C                       ----------------
C
  100 CONTINUE
C
C*            1.1       SEARCH THROUGH 4096 ELEMENTS AT A TIME
  110 CONTINUE
      ZMIN=PARR(1)
      ZMAX=PARR(1)
      ID=1
      I1=KLEN/4096
      I2=KLEN-I1*4096
C
      DO 115 J=1,I1
      IX=ISMAX(4096,PARR(ID),1)+ID-1
      IN=ISMIN(4096,PARR(ID),1)+ID-1
      ZMAX=AMAX1(ZMAX,PARR(IX))
      ZMIN=AMIN1(ZMIN,PARR(IN))
      ID=ID+4096
  115 CONTINUE
C
C
C*            1.2       REMAINING ELEMENTS
  120 CONTINUE
      IF (I2.GT.0) THEN
           IX=ISMAX(I2,PARR(ID),1)+ID-1
           IN=ISMIN(I2,PARR(ID),1)+ID-1
           ZMAX=AMAX1(ZMAX,PARR(IX))
           ZMIN=AMIN1(ZMIN,PARR(IN))
      ENDIF
C
      PMIN=ZMIN
      PMAX=ZMAX
C
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

C
      COMMON /BCOMWT/ NDWINC,NSCAM,NAFDW,NWT ,ODREPF,N40,N07,N08,
     1               NDWINC07,NSCAM07,NAFDWA(100),NFD,NREP,OREP,
     1               N221,MREL,NFCM,NFUCM,MBMP,OMARKER,M0,NSTOP,
     2               MBMPL,NSTACK(JELEM),NWTEN(JELEM),
     3               NWTR (JELEM),NWTS (JELEM),NWTRV (JELEM),
     4               NWTDW(JELEM),NWTIW(JELEM),NWTIWS(JELEM)
C
C             NDWINC   -  DATA WIDTH INCREMENT
C             NSCAM    -  SCALE MULTIPLIER
C             NAFDW    -  AUGMENTED FIELD DATA WIDTH
C             NWT      -  POINTER TO WORKING TABLE
C             NSTACK   -  LIST OF DATA DESCRIPTORS
C             ODREPF   -  REPLICATION (LOGICAL)
C             N221     -  DATA NOT PRESENT FOR N221 ELEMENTS
C             MREL     -  POINTER TO THE LAST DATA ELEMENT
C             NFCM     -  FIRST COMPRESSED MESSAGE
C             MBMP     -  POINTER TO THE BEGINING OF BIT MAP
C             NWTR     -  WORKING TABLE REFERENCE
C             NWTS     -  WORKING SCALE
C             NWTRV    -  WORKING REFERENCE VALUE
C             NWTDW    -  WORKING DATA WIDTH
C             NWTIW    -  WORKING DATA WIDTH OF INCREMENTS
C             NWTIWS   -  WORKING TOTAL DATA WIDTH OF ELEMENT SET
C             NSTOP    -  STOP EXPANSION AFTER NSTOP ELEMENTS
C

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities
C granted to it by virtue of its status as an intergovernmental organisation
C nor does it submit to any jurisdiction.
C
      PROGRAM LINK_MARS
      IMPLICIT NONE
C
C     Checks symbols when linking.
C
      INTEGER I
      REAL R
      CHARACTER C
      INTEGER IARGC
C
      INTEGER AREACHK
      INTEGER IBASINI
      INTEGER INTF
      INTEGER INTIN
      INTEGER INTOUT
      INTEGER intf2
      INTEGER intuvp2
      INTEGER intuvs2
      INTEGER intvect2
      IF (IARGC().LT.0) THEN
          CALL INTLOG (I,C,I)
          I = AREACHK  (R,R,R,R,R,R)
          I = IBASINI  (I)
          I = INTF     (I,I,R,I,I,R)
          I = INTIN    (C,I,R,C)
          I = INTOUT   (C,I,R,C)
          I = intf2    (C,I,C,I)
          I = intuvp2  (C,C,I,C,C,I)
          I = intuvs2  (C,C,I,C,C,I)
          I = intvect2 (C,C,I,C,C,I)
      END IF
      END

C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE BUSEL(KTDLEN,KTDLST,KTDEXL,KTDEXP,KERR)
C
C**** *BUSEL*
C
C
C     PURPOSE.
C     --------
C          RETURNS LIST OF DATA DESCRIPTORS AS IN SECTION 3  OF BUFR
C          MESSAGE AND TOTAL/REQUESTED LIST OF ELEMENTS.
C
C
C**   INTERFACE.
C     ----------
C
C          *CALL* *BUSEL(KTDLEN,KTDLST,KTDEXL,KTDEXP,KERR)*
C
C
C        OUTPUT:
C               *KTDLEN*  -  NUMBER OF DATA DESCRIPTORS IN SECTION 3
C               *KTDLST*  -  ARRAY CONTAINING DATA DESCRIPTORS IN SECTION 3
C               *KTDEXL*  -  NUMBER OF ENTRIES IN LIST OF EXPANDED DATA
C                            DESCRIPTORS
C               *KTDEXP*  -  ARRAY CONTAINIG EXPANDED DATA DESCRIPTORS
C               *KERR*    -  RETURNED ERROR CODE
C
C
C     METHOD.
C     -------
C
C          NONE.
C
C     EXTERNALS.
C     ----------
C
C          NONE.
C
C     REFERENCE.
C     ----------
C
C          NONE.
C
C     AUTHOR.
C     -------
C
C          M. DRAGOSAVAC    *ECMWF*       15/01/91.
C
C
C     MODIFICATIONS.
C     --------------
C
C          NONE.
C
C
      IMPLICIT LOGICAL(L,O,G), CHARACTER*8(C,H,Y)
C
C
#     include "parameter.F"
#     include "bcomunit.F"
#     include "bcomel.F"
C
      DIMENSION  KTDLST(*),KTDEXP(*)
C
C
C     -----------------------------------------------------------------

C*          1.  PUT LIST OF ELEMENTS FROM COMMON BLOCK
C               --------------------------------------
C               TO REQUESTED ARRAYS.
C               --------------------
 100  CONTINUE
C
      KERR=0
C
      KTDLEN=NTDLEN
      KTDEXL=NTDEXL
C
      DO 101 I=1,NTDLEN
      KTDLST(I)=NTDLST(I)
 101  CONTINUE
C
      DO 102 I=1,NTDEXL
      KTDEXP(I)=NTDEXP(I)
 102  CONTINUE
C
      RETURN
      END

C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      COMMON /BCMWORK/ RVIND,EPS,NBPW,NWPT,NBPT,NWPTB,NBPTB,NMASK(JBPW)
     1,                NVIND,NBENP,NLTVNP,NWWP,NXXP,NYYP
     2,                NZZP,NSSP,NEDN
C
C             NBPW          -  NUMBER OF BITS PER COMPUTER WORD
C             NWPT          -  WORD POINTER
C             NBPT          -  BIT POINTER
C             NWPTB         -  POINTER TO WORD AT THE BEGINING OF NEXT SECTION
C             NBPTB         -  POINTER TO BIT AT THE BEGINING OF NEXT SECTION
C             NMASK         -  BIT MASK ARRAY
C             NVIND         -  MISSING VALUE INDICATOR (INTEGER)
C             RVIND         -  MISSING VALUE INDICATOR (REAL)
C             NBENP         -  PREVIOUS BUFR EDITION NUMBER
C             NLTVNP        -  PREVIOUS LOCAL TABLE VERSION NUMBER
C             NXXP          -  BUFR MASTER TABLE USED
C             NYYP          -  VERSION NUMBER OF MASTER TABLE USED
C             NZZP          -  VERSION NUMBER OF LOCAL TABLE USED
C             NEDN          -  BUFR EDITION

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE CREXEDD(KPT,KTDLEN,CREXLST,KDLEN,KDATA,KSEC3,
     1             KELEM,CNAMES,CUNITS,KERR)
C
C**** *CREXEDD*
C
C
C     PURPOSE.
C     --------
C
C          Expand Crex data descriptors
C
C
C**   INTERFACE.
C     ----------
C
C          *CALL* *CREXETD( KPT,KTDLEN,CREXLST,KDLEN,KDATA,KSEC3,
C                           KVALS,VALUES,KELEM,KERR)*
C
C        INPUT :
C               *KPT*     -  POINTER TO KDATA ARRAY
C               *KTDLEN*  -  number of data descriptors in section 1
C               *KTDLST*  -  array containing data descriptors in section 1
C               *KDLEN*   -  DIMENSION OF KDATA ARRAY
C               *KDATA*   -  ARRAY CONTAINING DATA NEEDED FOR DESCRIPTOR
C                            EXPANSION ( delayed replications)
C               *KSEC3*   -  Integer array of 4 words containing
C
C                            KSEC3( 1)-- Reserved
C                            KSEC3( 2)-- Reserved
C                            KSEC3( 3)-- number of subsets
C                            KSEC3( 4)-- Reserved
C                            data values
C               *KELEM*   -  dimension of CNAMES, CUNITS array
C        OUTPUT:
C               *KERR*    -  returned error code
C
C     METHOD.
C      -------
C
C          Expands list of data descriptors in section 1
C     of Crex message. Working tables for further data decoding are set,
C     list of Crex data descriptors and a list of expanded Crex data descriptors
C     according to table D reference are returned respectively.
C
C
C

C
C     EXTERNALS.
C     ----------
C
C
C     REFERENCE.
C     ----------
C
C          NONE.
C
C     AUTHOR.
C     -------
C
C          MILAN DRAGOSAVAC    *ECMWF*       07/01/2004.
C
C
C     MODIFICATIONS.
C     --------------
C
C          NONE.
C
C------------------------------------------------------------------------------------
C
      IMPLICIT LOGICAL(L,O,G), CHARACTER*8(C,H,Y)
C
C
      PARAMETER(JSUP =   9,JSEC0=   3,JSEC1= 40,JSEC2= 64 ,JSEC3=    4,
     1          JSEC4=   2,JELEM=40000,JSUBS=400,JCVAL=150 ,JBUFL=40000,
     2          JBPW =  32,JTAB =3000,JCTAB=120,JCTST=1800,JCTEXT= 200,
     3          JWORK=360000,JKEY=46)
C
C
C
      COMMON /CRWORK/ NBPT,NGS,NVIND,NBPTSEC2,RVIND,EPS,NE,IEOLD,
     1                  NC07YYY
C
      COMMON/CRTAB/ NCREXBR(JTAB),NCREXBS(JTAB)    , NCREXBDW(JTAB),
     1              NCREXDR(JTAB),NCREXDST(JTAB)   ,
     2              NCREXDL(JTAB),NCREXDSQ(JTAB*20),NCREXP(64,255)

C
C             NCREXBR     - table B,  table reference              array
C             NCREXBS     - table B,  scale                        array
C             NCREXBDW    - table B,  data width                   array
C             NCREXDR     - table D,  table reference              array
C             NCREXDST    - table D,  starting pointers            array
C             NCREXDL     - table D,  lengths                      array
C             NCREXDSQ    - table D,  list of sequence descriptors array
C
      COMMON /CRTABC/ CREXNAME(JTAB),CREXUNIT(JTAB)
C
C             CREXNAME      -  table B, ELEMENT NAME           array
C             CREXUNIT      -  table B, unit                   array
c
C
      COMMON /CRBEF / M,MM,N,JCV
C
C             M       -  Number of elements
C             MM      -  Number of elements
C             N       -  Number of data sub_sets
C             JCV     -  Number of character values
C
C
      COMMON /CRWT/ NCREXDWINC,NCREXSCAM,NCREXAFDW,NCREXWT ,ODREPF,
     2              NCREXSTACK(JELEM),NCREXWTEN(JELEM),
     3              NCREXWTR (JELEM),NCREXWTS (JELEM),
     4              NCREXWTDW(JELEM)
C
C             NCREXDWINC   -  data width increment
C             NCREXSCAM    -  scale multiplier
C             NCREXAFDW    -  augmented field data width
C             NCREXWT      -  pointer to working table
C             NCREXSTACK   -  list of data descriptors
C             ODREPF   -  replication (logical)
C             NCREXWTR     -  working table reference
C             NCREXWTS     -  working scale
C             NCREXWTDW    -  working data width
C
C
C
      COMMON /CRWTC/ CREXWTEN(JELEM),CREXWTU(JELEM)
C
C             CREXWTEN    -  working table element naame
C             CREXWTU     -  working table units
C
C
      COMMON /CREL/ NCREXTDLEN,NCREXTDLST(JELEM),NCREXTDEXL,
     1              NCREXTDEXP(JELEM)
C
C             NCREXTDLEN - number of Data descriptors in section 3
C             NCREXTDLST - list of Data descriptors
C             NCREXTDEXL - number of expanded Data Descriptors
C             NCREXTDEXP - list of expanded Data descriptors
C
      CHARACTER*64 CREXWTEN
      CHARACTER*24 CREXWTU
C
      CHARACTER*64 CREXNAME
      CHARACTER*24 CREXUNIT
C
      CHARACTER*(*) CREXLST(*)
      CHARACTER*64 CNAMES(KELEM)
      CHARACTER*24 CUNITS(KELEM)
C
      DIMENSION ISTACK(JELEM),IISTACK(JELEM)
C
      DIMENSION KSUP(JSUP),KSEC3(JSEC3)
C
      REAL*8 RVIND,EPS
c
C     ------------------------------------------------------------------
C
C*          1.   EXPAND PRELIMINARY ITEMS OF SECTION 3.
C                --------------------------------------
 100  CONTINUE
C
      IF( KERR.NE.0 ) RETURN
C
CC     -----------------------------------------------------------------
C
C*          2.   EXPAND DATA DESCRIPTORS.
C                ------------------------
 200  CONTINUE
C
C
C*          2.1  CALCULATE EXPECTED NUMBER OF DATA DESCRIPTORS.
C                ----------------------------------------------
C                AND INITIALIZE NUMBER OF DATA VALUES PER SUB-SET.
C                -------------------------------------------------
 210  CONTINUE
C
      J = 0
      M = 0
      KPT=0
      NCREXWT=0
      NCREXTDLEN=ktdlen
C
C
C*          2.2  PUT DATA DESCRIPTORS IN STACK.
C                -----------------------------------------
 220  CONTINUE
C
      DO 221 JJ=1,KTDLEN
C
      if(CREXLST(JJ)(1:1).eq.'D') CREXLST(JJ)(1:1)='3'
      if(CREXLST(JJ)(1:1).eq.'B') CREXLST(JJ)(1:1)='0'
      if(CREXLST(JJ)(1:1).eq.'C') CREXLST(JJ)(1:1)='2'
      if(CREXLST(JJ)(1:1).eq.'R') CREXLST(JJ)(1:1)='1'
c
      IOS=0
      READ( CREXLST(JJ),'(i6.6)',IOSTAT=IOS) ISTACK(JJ)
      IF(IOS.NE.0) THEN
         print*,'Internal read error in CREXLST.'
         print*,'NCREXTDLEN=ktdlen=',NCREXTDLEN
         print*,jj,' CREXLST(JJ)=',CREXLST(JJ)
         kerr=35
         RETURN
      END IF
C
      IISTACK(JJ)=ISTACK(JJ)
C
 221  CONTINUE
C
      JMAX=NCREXTDLEN
C     ------------------------------------------------------------------
C*          2.3  GET NEXT DESCRIPTOR FROM THE STACK.
C                -----------------------------------
 230  CONTINUE
C
C
      J   = J + 1
      IF(J.GT.JMAX) GO TO 300
C
      IDD = ISTACK(J)
      IF(IDD.EQ.0)  GO TO 230
C
      IF = IDD/100000
C
C     ------------------------------------------------------------------
C*          2.4  CHECK IF IT IS REPLICATION DESCRIPTOR.
C                --------------------------------------
 240  CONTINUE
C
      IF( IF.EQ.0) THEN
C
C*          2.6  ELEMENT DESCRIPTOR, SO UPDATE WORKING TABLE.
C                --------------------------------------------
 260     CONTINUE
C
         CALL CREXEPWT(IDD,KERR)
         IF(KERR.GT.0) RETURN
C
      ELSEIF( IF.EQ.1) THEN
C
C*          2.4.1     SOLVE REPLICATION PROBLEM.
C                     --------------------------
C
C
         CALL CREXREP(KPT,KDLEN,KDATA,J,JMAX,IDD,ISTACK,KERR)
         IF(KERR.GT.0) RETURN
C
      ELSEIF( IF.EQ.2) THEN
C
C*          2.5.3 PROCESS OPERATOR.
C                 -----------------
            CALL CREXOPER(KPT,KDLEN,KDATA,J,IDD,ISTACK,KERR)
            IF(KERR.GT.0) RETURN
C
      ELSEIF( IF.EQ.3) THEN
C
C*          2.5.2 REPLACE BY LIST OF DESCRIPTORS FROM TABLE *D.
C                 ---------------------------------------------
            CALL CREXETDR(J,JMAX,IDD,ISTACK,KERR)
            IF(KERR.GT.0) THEN
               DO 252 IQ=1,JELEM
               NCREXSTACK(IQ)=0.
 252           CONTINUE
               RETURN
            END IF
      ELSE
         KERR=37
         CALL CREXERR(KERR)
         RETURN
      END IF
C
      GO TO 230
C
C     ------------------------------------------------------------------
C
C*          3. COLLECT  SUPPLEMENTARY ITEMS.
C              -----------------------------
 300  CONTINUE
C
      NCREXTDEXL =M
      DO 301 I=1,NCREXTDEXL
      NCREXTDEXP(I)=NCREXWTR(I)
      CNAMES(I)=CREXWTEN(I)
      CUNITS(I)=CREXWTU(I)
 301  CONTINUE
C
      DO 302 I=1,NCREXTDLEN
      NCREXTDLST (I)=IISTACK(I)
 302  CONTINUE
C
      KSUP(3)= 4
      KSUP(5)= M
      KSEC3(3)=NSUBSET
      KSUP(6)= KSEC3(3)
C
      RETURN
C
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C
      SUBROUTINE CHECK_S4S(KELEM,KSEC3,KSEC4,KERR)
C
C**** *CHECK_S4S*
C
C
C     PURPOSE.
C     --------
C          CHECK SECTION 4 SIZE
C
C
C**   INTERFACE.
C     ----------
C
C
C     METHOD.
C     -------
C
C           NONE.
C
C
C     EXTERNALS.
C     ----------
C
C
C     REFERENCE.
C     ----------
C
C          NONE.
C
C     AUTHOR.
C     -------
C
C          M. DRAGOSAVAC    *ECMWF*       JUNE 2009
C
C
C     MODIFICATIONS.
C     --------------

      IMPLICIT LOGICAL(L,O,G), CHARACTER*8(C,H,Y)

#     include "parameter.F"
#     include "bcomoff.F"
#     include "bcomwt.F"

      DIMENSION KSEC3(*),KSEC4(*)
      DIMENSION IMASK(8)

    
      DATA IMASK/1,2,4,8,16,32,64,128/

c        Check if data are compressed
         IB=0
         IF(IAND(KSEC3(4),IMASK(7)).NE.0) IB=1
         IF(IB.EQ.0) THEN
C         Uncompressed
            IF(OMULTI) then
              isum=0
              IF(NSUBSET.EQ.KSEC3(3)) THEN
              DO J=1,KSEC3(3)
              DO I=1,NSIZEG(J)
              IJ=I+(J-1)*KELEM 
              isum=isum+NWTDWG(IJ)
              END DO
              END DO
              ibytes=isum/8
              ibit=isum-ibytes*8
              if(ibit.ne.0) then
C                padding to byte
                 ibytes=ibytes+1
                 if(mod(ibytes,2).ne.0) then
                    ibytes=ibytes+1
                 end if
                 ibytes=ibytes+4
              else
                if(mod(ibytes,2).ne.0) then
                    ibytes=ibytes+1
                 end if
                 ibytes=ibytes+4
              end if
              if((ksec4(1)-ibytes).gt.1) then
                  print*,'Error in section 4 size'
                  print*,'ksec4(1)=',ksec4(1)
                  print*,'Actual size=',ibytes
                  KERR=56
                  return
              end if
              END IF
            ELSE
              isum=0
              do I=1,NSIZE(1)
              isum=isum+NWTDW(I)
              END DO
              isum=isum*ksec3(3)
              ibytes=isum/8
              ibit=isum-ibytes*8
              if(ibit.ne.0) then
C                padding to byte
                 ibytes=ibytes+1
                 if(mod(ibytes,2).ne.0) then
                    ibytes=ibytes+1
                 end if
                 ibytes=ibytes+4
              else
                if(mod(ibytes,2).ne.0) then
                    ibytes=ibytes+1
                 end if
                 ibytes=ibytes+4
              end if
              if((ksec4(1)-ibytes).gt.1) then
               KERR=56
               WRITE(KNTN,*)  'ERROR IN BU_CHECK_S4S: '
               CALL BUERR(KERR)
              WRITE(KNTN,*)  'KSEC4(1)=',ksec4(1),' ACTUAL SIZE=',ibytes
               return
              end if
            END IF
         ELSE
C           Compressed
            isum=0
            do I=1,NSIZE(1)
            isum=isum+NWTIWS(I)
            END DO
            ibytes=isum/8
            ibit=isum-ibytes*8
            if(ibit.ne.0) then
C              padding to byte
                ibytes=ibytes+1
                if(mod(ibytes,2).ne.0) then
                    ibytes=ibytes+1
                 end if
               ibytes=ibytes+4
            else
               if(mod(ibytes,2).ne.0) then
                  ibytes=ibytes+1
                end if
               ibytes=ibytes+4
            end if
            if((ksec4(1)-ibytes).gt.1) then
               KERR=56
               WRITE(KNTN,*)  'ERROR IN BU_CHECK_S4S: '
               CALL BUERR(KERR)
              WRITE(KNTN,*)  'KSEC4(1)=',KSEC4(1),' ACTUAL SIZE=',ibytes
               return
            end if
         END IF
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C
C
      PARAMETER(JSUP =   9,JSEC0=   3,JSEC1= 40,JSEC2=4096,JSEC3=   4,
     1          JSEC4=2,JELEM=320000,JSUBS=400,JCVAL=150 ,JBUFL=512000,
#ifdef JBPW_64
     2          JBPW =  64,JTAB =3000,JCTAB=3000,JCTST=9000,JCTEXT=9000,
#else
     2          JBPW =  32,JTAB =3000,JCTAB=3000,JCTST=9000,JCTEXT=9000,
#endif
     3          JWORK=4096000,JKEY=46, JTMAX=10,JTCLAS=64,JTEL=255)

C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE NMAKLL( KTRUNC, PINTVL, PLAT, KNUM, PLEG, KRET)
C
C---->
C**** NMAKLL
C
C     PURPOSE
C     _______
C
C     This routine creates legendre functions for latitude rows from
C     the given latitude.
C
C     INTERFACE
C     _________
C
C     CALL NMAKLL( KTRUNC, PINTVL, PLAT, KNUM, PLEG, KRET)
C
C     Input parameters
C     ________________
C
C     KTRUNC  - Truncation.
C     PINTVL  - Grid interval (degrees)
C     PLAT    - Start latitude in degrees.
C     KNUM    - Number of latitudes
C
C     Output parameters
C     ________________
C
C     PLEG     - Array of legendre functions for the latitude.
C     KRET     - Return status code
C                0 = OK
C
C     Common block usage
C     __________________
C
C     JDCNDBG
C
C     Method
C     ______
C
C     See below.
C
C     Externals
C     _________
C
C     INTLOG   - Output log message
C     INTLOGR  - Output log message (with real value)
C
C     Reference
C     _________
C
C     None.
C
C     Comments
C     ________
C
C     None at present.
C
C     AUTHOR
C     ______
C
C     J.D.Chambers      *ECMWF*      June 1999
C
C     MODIFICATIONS
C     _____________
C
C     None.
C
C----<
C
      IMPLICIT NONE
C
#include "jparams.h"
#include "parim.h"
C
C     Parameters
C
      INTEGER JPROUTINE
      PARAMETER ( JPROUTINE = 30500 )
C
C     Subroutine arguments
C
      INTEGER KTRUNC, KRET, KNUM
      REAL PLEG, PINTVL, PLAT
      DIMENSION PLEG(*)
C
C     Local variables
C
      REAL ZLAST, ZLAT, ALAT, DEG2RAD
      INTEGER NEXTRW, NEXT, FIRST, LAST
C
C     _______________________________________________________
C
C*    Section 1.    Initialization.
C     _______________________________________________________
C
 100  CONTINUE
C
      IF( NDBG.GT.1 ) THEN
        CALL INTLOG(JP_DEBUG,'NMAKLL: Input parameters:',JPQUIET)
        CALL INTLOG(JP_DEBUG,'NMAKLL: Truncation = ', KTRUNC)
        CALL INTLOG(JP_DEBUG,'NMAKLL: Number of latitudes = ', KNUM)
        CALL INTLOGR(JP_DEBUG,
     X    'NMAKLL: Grid interval (degrees) = ', PINTVL)
        CALL INTLOGR(JP_DEBUG,
     X    'NMAKLL: Latitude in degrees = ', PLAT)
      ENDIF
C
      IF( PLAT.LT.0.0 ) THEN
        ZLAT = 0.0
      ELSE
        ZLAT = PLAT
      ENDIF
C
C     _______________________________________________________
C
C*    Section 2.    Processing.
C     _______________________________________________________
C
      DEG2RAD = PPI / 180.0
C
      ZLAST = ZLAT - (KNUM-1)*PINTVL
      NEXTRW = 1
      FIRST = NINT(ZLAT/PINTVL)
      LAST  = NINT(ZLAST/PINTVL)
      DO NEXT = FIRST, LAST, -1
        ALAT = (NEXT*PINTVL) * DEG2RAD
C
        IF( NDBG.GT.1 ) CALL INTLOGR(JP_DEBUG,
     X    'NMAKLL: Next latitude constructed = ', (NEXT*PINTVL))
C
        CALL JSPLEG1( PLEG(NEXTRW), ALAT, KTRUNC)
        NEXTRW = NEXTRW + (KTRUNC+1)*(KTRUNC+4)/2
      ENDDO
C     _______________________________________________________
C
C*    Section 9. Return to calling routine. Format statements
C     _______________________________________________________
C
 900  CONTINUE
      KRET = 0
C
 990  CONTINUE
      RETURN
      END

C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      INTEGER FUNCTION IBASINI(KFORCE)
C
C---->
C**** IBASINI
C  
C     Purpose
C     -------
C
C     Ensures basic initialisation of common blocks is done
C  
C     Interface
C     ---------
C
C     IRET = IBASINI(KFORCE)
C
C
C     Input parameters
C     ----------------
C
C     KFORCE  = 1, to force initialisation of common blocks.
C             = 0, to check if initialisation of common blocks is done
C                  already (and do it if not already done).
C  
C  
C     Method
C     ------
C
C     NJDCDOT in nifld.common is checked/set.
C
C     Looks for environment variable INTERP_GEN_COEFFS which gives
C     the name of a file containing the cutoff spectral truncation
C     above which interpolation coefficients are generated 'on the
C     fly'. Variable NICOMP is set with this value in nifld.common.
C     The file contains entries for each computer architecture in
C     format:
C
C       col 1
C         |
C         v
C         FUJITSU 319
C         sgimips 213
C         hppa 213
C         DEFAULT 106
C
C     If no matching $ARCH value, the DEFAULT value is used.
C     If no matching $ARCH and no DEFAULT value, a hard-code value is used.
C
C     Looks for environment variable USE_HIRLAM_12POINT to determine
C     whether or not the Hiralm 12-point horizontal interpolation is
C     to be used for rotations.
C
C
C     Externals
C     ---------
C
C     CLEAR_C - Clear common block variables
C     RDDEFS  - Read interpolation handling default values
C     GETENV  - Get value of an environment variable
C     JINDEX  - Returns length of character string
C  
C  
C     Author
C     ------
C
C     J.D.Chambers       ECMWF        August 1994.
C
C----<
C
C     -----------------------------------------------------------------|
C
      IMPLICIT NONE
C
#include "parim.h"
#include "nifld.common"
#include "nofld.common"
#include "intf.h"
C
C     Function arguments
C
      INTEGER KFORCE
C
C     Local variables
C
      CHARACTER*120 LINE
      CHARACTER*20 ARCH, USEHIR
      CHARACTER*256 CONFIG
      INTEGER IMAGIC, IRET, ICONFIG, IBLANK, LOOP
      DATA ICONFIG/69/
      DATA IMAGIC/1952999238/
C
C     Externals
C
      INTEGER RDDEFS, JINDEX
C
C     -----------------------------------------------------------------|
C     Section 1. Force initialisation if requested.
C     -----------------------------------------------------------------|
C
  100 CONTINUE
C
      IF ( KFORCE .EQ. 1 ) NJDCDOT = 0
C
C     See if basic initialisation has already been done or not
C
      IF ( NJDCDOT .NE. IMAGIC ) THEN
C
C       Clear common block variables
C
        CALL CLEAR_C()
C
        IRET = 1
        CALL IAINIT(0,IRET)
C
C       Set interpolation handling default values
C       (Replaces old call to rddefs)
C
        NILOCAL = 0
        NISTREM = 0
        NIFORM = 1
        NOFORM = 1
        NITABLE = 128
        NOTABLE = 128
        NIPARAM = 0
        DO LOOP = 1,4
          NIAREA(LOOP) = 0
          NOAREA(LOOP) = 0
        ENDDO
        NISCNM = 0
        NOSCNM = 0
C
C       Set default value for truncation above which interpolation
C       coefficients are to be computed dynamically
C
        NICOMP = 319
C
C       Now see if this default value has been modified in a
C       configuration file
C
        CALL GETENV('INTERP_GEN_COEFFS', CONFIG)
        IBLANK = JINDEX(CONFIG)
        IF( IBLANK.GE.1 ) THEN
C
C         Open the configuration file
C
          OPEN( ICONFIG, FILE=CONFIG, STATUS='OLD', ERR=200)
          CALL GETENV('ARCH', ARCH)
          IBLANK = JINDEX(ARCH)
          IF( IBLANK.LT.1 ) ARCH = 'DEFAULT'
          IBLANK = JINDEX(ARCH)
C
C         Look for matching 'arch'
C
  110     CONTINUE
          READ( ICONFIG, '(A)', END= 200) LINE
          IF( ARCH(1:IBLANK).EQ.LINE(1:IBLANK) ) THEN
            READ(LINE(IBLANK+1:),'(1X,I3)') NICOMP
            GOTO 200
          ENDIF
C
C         Pickup default (will be used if no matching 'arch')
C
          IF( (LINE(1:7).EQ.'DEFAULT').OR.
     X        (LINE(1:7).EQ.'default') )
     X      READ(LINE(IBLANK+1:),'(1X,I3)') NICOMP
C
          GOTO 110
        ENDIF
C
C     -----------------------------------------------------------------|
C     Section 2. See if Hirlam 12-point horizontal interpolation to be
C                use for rotations (default = 'yes').
C     -----------------------------------------------------------------|
C
  200   CONTINUE
C
        LUSEHIR = .TRUE.
        CALL GETENV('USE_HIRLAM_12POINT', USEHIR)
        IF( (USEHIR(1:3).EQ.'OFF').OR.(USEHIR(1:2).EQ.'NO') )
     X    LUSEHIR = .FALSE.
C
C     -----------------------------------------------------------------|
C     Section 9. Return
C     -----------------------------------------------------------------|
C
  900   CONTINUE
C
C       Set 'magic number' to show basic initialisation has been done
C
        NJDCDOT = IMAGIC
C
      ENDIF
C
      IBASINI = 0
C
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities
C granted to it by virtue of its status as an intergovernmental organisation
C nor does it submit to any jurisdiction.
C

      INTEGER FUNCTION IGSETUP(KSEC1,KSEC2,KSEC3,KSEC4)
C
C---->
C**** IGSETUP
C
C     Purpose
C     -------
C
C     Setup GRIB sections 1, 2, 3 & 4 for the new interpolation product.
C     For GRIBex.
C
C     Interface
C     ---------
C
C     IRET IGSETUP(KSEC1,KSEC2,KSEC3,KSEC4)
C
C     Input
C     -----
C
C     KSEC1   - Section 1 values
C     KSEC2   - Section 2 values
C     KSEC3   - Section 3 values
C     KSEC4   - Section 4 values
C
C     Output
C     ------
C
C     KSEC1   - Section 1 values (modified)
C     KSEC2   - Section 2 values (modified)
C     KSEC3   - Section 3 values (modified)
C     KSEC4   - Section 4 values (modified)
C
C     Method
C     ------
C
C     Use common block values and existing values from the original GRIB
C     product used for interpolation.
C
C
C     Externals
C     ---------
C
C     INTLOG   - Logs messages.
C
C
C     Author
C     ------
C
C     J.D.Chambers     ECMWF     Aug 1994
C
C----<
C
      IMPLICIT NONE
C
#include "parim.h"
#include "nifld.common"
#include "nofld.common"
C
C     Parameter(s)
C
      INTEGER JPROUTINE
      PARAMETER ( JPROUTINE = 19100 )
C
C     Function arguments
C
      INTEGER KSEC1(*), KSEC2(*), KSEC3(*), KSEC4(*)
C
C     Local variables
C
      LOGICAL LIROTAT, LOROTAT
      INTEGER ITEMP
      REAL RTEMP
      REAL RSEC2(JPGRIB_ISEC2)  ! (not an argument, not necessary outside)
C
C***********************************************************************
C     Section 1.   Startup.
C***********************************************************************
C
 100  CONTINUE
C
      IGSETUP = 0
C
C     Check a recognized data representation type is being processed
C
      IF ( (NOREPR .NE.JPREGULAR  ) .AND.
     X     (NOREPR .NE.JPREGROT   ) .AND.
     X     (NOREPR .NE.JPGAUSSIAN ) .AND.
     X     (NOREPR .NE.JPFGGROT   ) .AND.
     X     (NOREPR .NE.JPQUASI    ) .AND.
     X     (NOREPR .NE.JPQGGROT   ) .AND.
     X     (NOREPR .NE.JPSPHROT   ) .AND.
     X     (NOREPR .NE.JPSPHERE   ) ) GOTO 910
C
C     Set flags if input is rotated or if a rotation angle has been given
C
      LIROTAT = (NIREPR.EQ.JPSPHROT).OR.
     X          (NIREPR.EQ.JPREGROT).OR.
     X          (NIREPR.EQ.JPFGGROT).OR.
     X          (NIREPR.EQ.JPQGGROT)
C
      LOROTAT = ((NOROTA(1).NE.-9000000).AND.(NOROTA(1).NE.0)).OR.
     X          (NOROTA(2).NE.0)
     X          .OR. (NOREPR.EQ.JPSPHROT .OR.
     X                NOREPR.EQ.JPREGROT .OR.
     X                NOREPR.EQ.JPFGGROT .OR.
     X                NOREPR.EQ.JPQGGROT)
C
C***********************************************************************
C     Section 2.   Setup output product section 1.
C***********************************************************************
C
 200  CONTINUE
C
C     Setup output if not given by input GRIB message
C     (ie input is 'unpacked').
C
      IF ( NIFORM .NE. 1 ) THEN
C
C       Code table ( same as input )
C
        KSEC1(1) = NOTABLE
C
C       Originating centre = ECMWF
C
        KSEC1(2) = 98
C
C       Generating process ID = 255
C       Grid definition       = 255
C
        KSEC1(3) = 255
        KSEC1(4) = 255
C
C       Parameter
C
        KSEC1(6) = NOPARAM
C
C       Level
C
        KSEC1(7) = NOLEVT
        KSEC1(8) = NOLEVEL
        KSEC1(9) = 0
C
C       Dummy date and time ( 1 Jan 1990, 1200 )
C
        KSEC1(10) = 90
        KSEC1(11) = 1
        KSEC1(12) = 1
        KSEC1(13) = 12
        KSEC1(14) = 0
C
C       Dummy verifying time (initialised analysis)
C
        KSEC1(15) = 1
        KSEC1(16) = 0
        KSEC1(17) = 0
        KSEC1(18) = 1
        KSEC1(19) = 0
        KSEC1(20) = 0
C
C       Century ( = 20 )
C
        KSEC1(21) = 20
C
C       Lots of zeroes
C
        KSEC1(22:36) = 0
C
C     Allow for user specified output field values when input is packed
C
      ELSE
C
C       Code table
C
        KSEC1(1) = NOTABLE
C
C       Parameter
C
        IF( LNOPARA ) KSEC1(6) = NOPARAM
C
C       Level
C
        IF( LNOLEVT ) KSEC1(7) = NOLEVT
        IF( LNOLEVL ) THEN
          KSEC1(8) = NOLEVEL
          KSEC1(9) = 0
        ENDIF
      ENDIF
C
C     Section 2 included, section 3 omitted
C
      KSEC1(5) = 128
C
C     Rest of section 1 kept unchanged from input product
C
C***********************************************************************
C     Section 3.   Setup output product section 2.
C***********************************************************************
C
 300  CONTINUE
C
C     Data representation type
C
C     Adjust output representation type if field is rotated
C
      IF( LIROTAT.OR.LOROTAT ) THEN
        KSEC2(1) = NOREPR
        IF(NOREPR.EQ.JPREGULAR )  KSEC2(1) = JPREGROT
        IF(NOREPR.EQ.JPSPHERE )   KSEC2(1) = JPSPHROT
        IF(NOREPR.EQ.JPQUASI )    KSEC2(1) = JPFGGROT
        IF(NOREPR.EQ.JPQGGROT )   KSEC2(1) = JPFGGROT
        IF(NOREPR.EQ.JPGAUSSIAN ) KSEC2(1) = JPFGGROT
C
      ELSE
C
        IF( (NOREPR.EQ.JPQUASI).OR.(NOREPR.EQ.JPQGGROT) ) THEN
          KSEC2(1) = JPGAUSSIAN
        ELSE
          KSEC2(1) = NOREPR
        ENDIF
      ENDIF
C
C***********************************************************************
C     Section 3.1. Setup section 2 for lat/long, equidistant
C                  cylindrical or plate carre grids.
C***********************************************************************
C
 310  CONTINUE
C
      IF ( (NOREPR.EQ.JPREGULAR).OR.(NOREPR.EQ.JPREGROT) ) THEN
C
C       For south to north grids, only global area allowed (eg KWBC SST)
C
cs        IF( KSEC2(4).LT.KSEC2(7) ) THEN
cs          IF((NOAREA(1).NE.(-NOAREA(3))).AND.(NOAREA(3).NE.JP90)) THEN
cs            CALL INTLOG(JP_ERROR,
cs     X        'IGSETUP: Subareas not allowed interpolating',JPQUIET)
cs            CALL INTLOG(JP_ERROR,
cs     X        'IGSETUP: grids running from south to north',JPQUIET)
cs            IGSETUP = JPROUTINE + 2
cs            GOTO 900
cs          ENDIF
cs        ENDIF
C
C       Number of points along a parallel
C
        KSEC2(2) = NOWE
C
C       Number of points along a meridian
C
        KSEC2(3) = NONS
C
C       Resolution flag, increments are given
C
        KSEC2(6) = 128
C
C       Latitude and longitude of first/last grid point
C       La1/Lo1 - NOAREA(1): north, NOAREA(2): west
C       La2/Lo2 - NOAREA(3): south, NOAREA(4): east
C       EMOS-214: store REAL values in parallel data structure (real precision), for values that requiring sub-millidegree precision
C
        IF( NOAREA(1).GE.0 ) THEN
          KSEC2(4) = (NOAREA(1)+(JPMICRO/2)) / JPMICRO
        ELSE
          KSEC2(4) = (NOAREA(1)-(JPMICRO/2)) / JPMICRO
        ENDIF
        IF( NOAREA(2).GE.0 ) THEN
          KSEC2(5) = (NOAREA(2)+(JPMICRO/2)) / JPMICRO
        ELSE
          KSEC2(5) = (NOAREA(2)-(JPMICRO/2)) / JPMICRO
        ENDIF
        IF( NOAREA(3).GE.0 ) THEN
          KSEC2(7) = (NOAREA(3)+(JPMICRO/2)) / JPMICRO
        ELSE
          KSEC2(7) = (NOAREA(3)-(JPMICRO/2)) / JPMICRO
        ENDIF
        IF( NOAREA(4).GE.0 ) THEN
          KSEC2(8) = (NOAREA(4)+(JPMICRO/2)) / JPMICRO
        ELSE
          KSEC2(8) = (NOAREA(4)-(JPMICRO/2)) / JPMICRO
        ENDIF
        RSEC2(4:5) = FLOAT(NOAREA(1:2))/JPMULT
        RSEC2(7:8) = FLOAT(NOAREA(3:4))/JPMULT
C
C       Flip latitudes if they run from south to north
C       Set scanning mode flags
C
        IF( KSEC2(4).LT.KSEC2(7) ) THEN
          IF( LNOGRID ) THEN
            ITEMP = KSEC2(7)
            KSEC2(7) = KSEC2(4)
            KSEC2(4) = ITEMP
            RTEMP = RSEC2(7)
            RSEC2(7) = RSEC2(4)
            RSEC2(4) = RTEMP
            KSEC2(11) = 0
          ELSE
            KSEC2(11) = 64
          ENDIF
        ELSE
          KSEC2(11) = NOSCNM
        ENDIF
C
C       i and j  direction increments
C       EMOS-214: store REAL values in parallel data structure (real precision), for values that requiring sub-millidegree precision
C
        KSEC2( 9) = (NOGRID(1) + (JPMICRO/2)) / JPMICRO
        KSEC2(10) = (NOGRID(2) + (JPMICRO/2)) / JPMICRO
        RSEC2( 9) = FLOAT(NOGRID(1))/JPMULT
        RSEC2(10) = FLOAT(NOGRID(2))/JPMULT
C
C       Following left same as for input product
C       - no.of vertical coordinate parameters,
C       - lat/long of southern pole of rotation
C       - lat/long of pole of stretching
C
C       If rotated, put in new lat/long of southern pole of rotation
C       EMOS-214: store REAL values in parallel data structure (real precision), for values that requiring sub-millidegree precision
C
        IF( LIROTAT.OR.LOROTAT ) THEN
          IF( NOROTA(1).GE.0 ) THEN
            KSEC2(13) = (NOROTA(1) + (JPMICRO/2)) / JPMICRO
          ELSE
            KSEC2(13) = (NOROTA(1) - (JPMICRO/2)) / JPMICRO
          ENDIF
          IF( NOROTA(2).GE.0 ) THEN
            KSEC2(14) = (NOROTA(2) + (JPMICRO/2)) / JPMICRO
          ELSE
            KSEC2(14) = (NOROTA(2) - (JPMICRO/2)) / JPMICRO
          ENDIF
          RSEC2(13:14) = FLOAT(NOROTA(1:2))/JPMULT
        ENDIF
C
C       Regular grid flag
C
        KSEC2(17) = 0
C
C       Following left same as for input product
C       - earth flag
C       - components flag
C       - reserved fields
C
      ENDIF
C
C***********************************************************************
C     Section 3.2. Setup section 2 for gaussian grids.
C***********************************************************************
C
 320  CONTINUE
C
      IF ( NOREPR.EQ.JPQUASI    .OR. NOREPR.EQ.JPQGGROT .OR.
     X     NOREPR.EQ.JPGAUSSIAN .OR. NOREPR.EQ.JPFGGROT ) THEN
C
C       Number of points along a parallel
C
C       For a regular gaussian grid only
        IF( (NOREPR.EQ.JPGAUSSIAN).OR.(NOREPR.EQ.JPFGGROT) ) THEN
          KSEC2(2) = NOWE
        ELSE
          KSEC2(2) = 0
        ENDIF
C
C       Number of points along a meridian
C
        KSEC2(3) = NONS
C
C       Resolution flag
C       For a regular gaussian grid only, increments are given
C
        IF( (NOREPR.EQ.JPGAUSSIAN).OR.(NOREPR.EQ.JPFGGROT) ) THEN
          KSEC2(6) = 128
        ELSE
          KSEC2(6) = 0
        ENDIF
C
C       Latitude and longitude of first/last grid point
C       La1/Lo1 - NOAREA(1): north, NOAREA(2): west
C       La2/Lo2 - NOAREA(3): south, NOAREA(4): east
C       EMOS-214: store REAL values in parallel data structure (real precision), for values that requiring sub-millidegree precision
C
        IF( NOAREA(1).GE.0 ) THEN
          KSEC2(4) = (NOAREA(1)+(JPMICRO/2)) / JPMICRO
        ELSE
          KSEC2(4) = (NOAREA(1)-(JPMICRO/2)) / JPMICRO
        ENDIF
        IF( NOAREA(2).GE.0 ) THEN
          KSEC2(5) = (NOAREA(2)+(JPMICRO/2)) / JPMICRO
        ELSE
          KSEC2(5) = (NOAREA(2)-(JPMICRO/2)) / JPMICRO
        ENDIF
        IF( NOAREA(3).GE.0 ) THEN
          KSEC2(7) = (NOAREA(3)+(JPMICRO/2)) / JPMICRO
        ELSE
          KSEC2(7) = (NOAREA(3)-(JPMICRO/2)) / JPMICRO
        ENDIF
        IF( NOAREA(4).GE.0 ) THEN
          KSEC2(8) = (NOAREA(4)+(JPMICRO/2)) / JPMICRO
        ELSE
          KSEC2(8) = (NOAREA(4)-(JPMICRO/2)) / JPMICRO
        ENDIF
        RSEC2(4:5) = FLOAT(NOAREA(1:2))/JPMULT
        RSEC2(7:8) = FLOAT(NOAREA(3:4))/JPMULT
C
C       i direction increment
C
C       For a regular gaussian grid, only
C
        KSEC2(9) = 0
        RSEC2(9) = 0.
        IF( (NOREPR.EQ.JPGAUSSIAN).OR.(NOREPR.EQ.JPFGGROT) ) THEN
          KSEC2(9) = (((JP90)/NOGAUSS)+(JPMICRO/2)) / JPMICRO
          RSEC2(9) = (FLOAT(JP90)/FLOAT(NOGAUSS))/JPMULT
        ENDIF
C
C       Number of parallels between a pole and the Equator
C
        KSEC2(10) = NOGAUSS
C
C       Scanning mode flags
C
        KSEC2(11) = NOSCNM
C
C       Following left same as for input product
C       - no.of vertical coordinate parameters,
C       - lat/long of southern pole of rotation
C       - lat/long of pole of stretching
C
C       If rotated, put in new lat/long of southern pole of rotation
C       EMOS-214: store REAL values in parallel data structure (real precision), for values that requiring sub-millidegree precision
C
        IF( LIROTAT.OR.LOROTAT ) THEN
          IF( NOROTA(1).GE.0 ) THEN
            KSEC2(13) = (NOROTA(1) + (JPMICRO/2)) / JPMICRO
          ELSE
            KSEC2(13) = (NOROTA(1) - (JPMICRO/2)) / JPMICRO
          ENDIF
          IF( NOROTA(2).GE.0 ) THEN
            KSEC2(14) = (NOROTA(2) + (JPMICRO/2)) / JPMICRO
          ELSE
            KSEC2(14) = (NOROTA(2) - (JPMICRO/2)) / JPMICRO
          ENDIF
          RSEC2(13:14) = FLOAT(NOROTA(1:2))/JPMULT
        ENDIF
C
C       Regular grid flag
C
        IF( (NOREPR.EQ.JPGAUSSIAN).OR.(NOREPR.EQ.JPFGGROT) ) THEN
          KSEC2(17) = 0
        ELSE
          KSEC2(17) = 1
        ENDIF
C
C       Following left same as for input product
C       - earth flag
C       - components flag
C       - reserved fields
C
C       For reduced grid, move in number of points along each parallel
C
          IF( (NOREPR.EQ.JPQUASI) .OR.
     X        (NOREPR.EQ.JPQGGROT) ) THEN
          DO ITEMP = 1, KSEC2(3)
            KSEC2(22+ITEMP) = NOLPTS(ITEMP+NO1NS-1)
          ENDDO
        ENDIF
C
      ENDIF
C
C***********************************************************************
C     Section 3.3. Setup section 2 for spherical harmonic coefficients.
C***********************************************************************
C
 330  CONTINUE
C
      IF ( (NOREPR.EQ.JPSPHERE).OR.(NOREPR.EQ.JPSPHROT) ) THEN
C
C       I, K, M pentagonal resolution parameters
C
        KSEC2(2) = NORESO
        KSEC2(3) = NORESO
        KSEC2(4) = NORESO
C
C       Representation type, associated legendre functions of the
C                            first kind
        KSEC2(5) = 1
C
C       Representation mode, complex packing
C
        KSEC2(6) = 2
C
C       Following left same as for input product
C       - reserved words 7-11
C       - no.of vertical coordinate parameters,
C       - lat/long of southern pole of rotation
C       - lat/long of pole of stretching
C       - reserved words 17-22
C
C       If rotated, put in new lat/long of southern pole of rotation
C       EMOS-214: store REAL values in parallel data structure (real precision), for values that requiring sub-millidegree precision
C
        IF( LIROTAT.OR.LOROTAT ) THEN
          IF( NOROTA(1).GE.0 ) THEN
            KSEC2(13) = (NOROTA(1) + (JPMICRO/2)) / JPMICRO
          ELSE
            KSEC2(13) = (NOROTA(1) - (JPMICRO/2)) / JPMICRO
          ENDIF
          IF( NOROTA(2).GE.0 ) THEN
            KSEC2(14) = (NOROTA(2) + (JPMICRO/2)) / JPMICRO
          ELSE
            KSEC2(14) = (NOROTA(2) - (JPMICRO/2)) / JPMICRO
          ENDIF
          RSEC2(13:14) = FLOAT(NOROTA(1:2))/JPMULT
        ENDIF
      ENDIF
C
C***********************************************************************
C     Section 4.   Setup output product section 4.
C***********************************************************************
C
 400  CONTINUE
C
C     Number of values to be packed
C
      IF ( (NOREPR.EQ.JPSPHERE).OR.(NOREPR.EQ.JPSPHROT) ) THEN
        KSEC4(1) = (NORESO + 1) * (NORESO + 2)
      ELSE IF( (NOREPR.EQ.JPQUASI).OR.(NOREPR.EQ.JPQGGROT) ) THEN
        KSEC4(1) = NOPCNT
      ELSE
        KSEC4(1) = NOWE * NONS
      ENDIF
C
C     If all the values are missing, set the count of values negative
C
      IF(NOMISS.NE.0) THEN
        KSEC4(1) = -KSEC4(1)
      ENDIF
C
C     Number of bits used for each packed value
C
      KSEC4(2) = NOACC
C
C     Type of data, spherical harmonic = 128, grid point = 0
C
      IF ( (NOREPR.EQ.JPSPHERE).OR.(NOREPR.EQ.JPSPHROT) ) THEN
        KSEC4(3) = 128
      ELSE
        KSEC4(3) = 0
      ENDIF
C
C     Type of packing, spherical harmonic = complex
C
      IF ( (NOREPR.EQ.JPSPHERE).OR.(NOREPR.EQ.JPSPHROT) ) THEN
        KSEC4(4) = 64
      ELSE
        KSEC4(4) = 0
      ENDIF
C
C     Type of data = floating point
C
      KSEC4(5) = 0
C
C     Additional flags indicator = none
C
      KSEC4(6) = 0
C
C     Reserved word, set to 0
C
      KSEC4(7) = 0
C
C     Following set to simplest case
C     - no.of values indicator
C     - secondary bitmaps indicator
C     - values width indicator
C     - no.of bits for 2nd order values
C
      KSEC4(8)  = 0
      KSEC4(9)  = 0
      KSEC4(10) = 0
      KSEC4(11) = 0
C
C     Reserved words, set to 0
C
      KSEC4(12) = 0
      KSEC4(13) = 0
      KSEC4(14) = 0
      KSEC4(15) = 0
C
C     If spherical harmonics, set following for complex packing
C
      IF ( (NOREPR.EQ.JPSPHERE).OR.(NOREPR.EQ.JPSPHROT) ) THEN
C
C       KSEC4(16), pointer to start of packed data, setup by packing
C       KSEC4(17), scaling factor P, unchanged from input
C       KSEC4(18), pentagonal resolution parameter J for packing of subset,
C                  unchanged from input
C       KSEC4(19), pentagonal resolution parameter K for packing of subset,
C                  unchanged from input
C       KSEC4(20), pentagonal resolution parameter M for packing of subset,
C                  unchanged from input
C
      ELSE
        KSEC4(16:20) = 0
      ENDIF
C
C     Words 21-33 reserved, set to zero.
C
      KSEC4(21:33) = 0
C
C***********************************************************************
C     Section 9.   Closedown
C***********************************************************************
C
 900  CONTINUE
C
      RETURN
C
C     Invalid data represntation type
C
 910  CONTINUE
      CALL INTLOG(JP_ERROR,
     X  'IGSETUP: Data representation type not recognized: ',NOREPR)
      CALL INTLOG(JP_ERROR,
     X  'IGSETUP: Only the following types are recognized:',JPQUIET)
      CALL INTLOG(JP_ERROR,'IGSETUP: Lat/long grid = ', JPREGULAR)
      CALL INTLOG(JP_ERROR,'IGSETUP: Lat/long (rotated) = ', JPREGROT)
      CALL INTLOG(JP_ERROR,'IGSETUP: regular gaussian = ', JPGAUSSIAN)
      CALL INTLOG(JP_ERROR,'IGSETUP: reg gauss rotated = ', JPFGGROT)
      CALL INTLOG(JP_ERROR,'IGSETUP: reduced gaussian = ', JPQUASI)
      CALL INTLOG(JP_ERROR,'IGSETUP: red gauss rotated = ', JPQUASI)
      CALL INTLOG(JP_ERROR,'IGSETUP: spherical harmonic = ', JPSPHERE)
      CALL INTLOG(JP_ERROR,'IGSETUP: spectral (rotated) = ', JPSPHROT)
C
      IGSETUP = JPROUTINE + 1
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities
C granted to it by virtue of its status as an intergovernmental organisation
C nor does it submit to any jurisdiction.
C

      INTEGER FUNCTION HGETLSM(KGAUSS,HTYPE,OLDLSM,KSIZE)
C
C---->
C**** HGETLSM
C
C     Purpose
C     -------
C
C     This routine reads a file of reduced gaussian field land-sea
C     mask values.
C
C
C     Interface
C     ---------
C
C     IRET = HGETLSM(KGAUSS,OLDLSM,KSIZE)
C
C
C     Input parameters
C     ----------------
C
C     KGAUSS - Gaussian number of the reduced gaussian field
C     HTYPE  - Gaussian type of the reduced gaussian field ('R','O')
C     KSIZE  - Number of bytes to read into OLDLSM
C
C
C     Output parameters
C     -----------------
C
C     OLDLSM - The array of values for the reduced gaussian field
C
C     Returns 0 if function successful, non-zero otherwise.
C
C     Common block usage
C     ------------------
C
C     None
C
C
C     Method
C     ------
C
C     Gets pathname from HIRLAM_LSM_PATH and reads land-sea mask
C     from a file.
C
C
C     Externals
C     ---------
C
C     INTLOG  - Log error message.
C     PBOPEN  - Open land-sea mask file
C     PBREAD  - Read land-sea mask file
C     PBCLOSE - Close land-sea mask file
C
C
C     Reference
C     ---------
C
C     None.
C
C
C     Comments
C     --------
C
C     None.
C
C
C     Author
C     ------
C
C     J.D.Chambers      ECMWF      March 2001
C
C
C     Modifications
C     -------------
C
C     Replace PBOPEN, etc by PBOPEN3, etc on VPP.
C     J.D.Chambers      ECMWF      December 2001
C
C----<
C     -----------------------------------------------------------------|
C*    Section 0. Definition of variables.
C     -----------------------------------------------------------------|
C
      IMPLICIT NONE
C
#include "parim.h"
#include "nifld.common"
#include "nofld.common"
C
C     Function arguments
C
      INTEGER KGAUSS
      CHARACTER*1 HTYPE
      REAL OLDLSM(*)
      INTEGER KSIZE
C
C     Local variables
C
      CHARACTER*256 FILENAME
      CHARACTER*4 YGAUSS
      INTEGER IOFFS, IUNIT, IRET
C
C     Externals
C
      INTEGER DPATH_TABLES_INTERPOL
      EXTERNAL DPATH_TABLES_INTERPOL
C
C     -----------------------------------------------------------------|
C     Section 1.  Initialise.
C     -----------------------------------------------------------------|
C
  100 CONTINUE
C
      HGETLSM = 0
C
      CALL JDEBUG()
C
C     -----------------------------------------------------------------|
C     Section 2.  Build the land-sea mask file pathname
C     -----------------------------------------------------------------|
C
  200 CONTINUE
C
C     Build LSM directory path
C
      FILENAME = ' '
      IOFFS = DPATH_TABLES_INTERPOL(FILENAME)
      IF (IOFFS.EQ.0) THEN
        CALL INTLOG(JP_DEBUG,
     X    'HGETLSM: unable to build LSM directory path.',JPQUIET)
        HGETLSM = 2
        GOTO 900
      ENDIF
C
C     Complete the filename
C
      IF( HTYPE.EQ.'R' ) THEN
        WRITE(YGAUSS,'(I4.4)') KGAUSS
        FILENAME = FILENAME(1:IOFFS) // 'LSM_GG_' // YGAUSS
      ELSE
        WRITE(YGAUSS,'(I0)') KGAUSS
        FILENAME = FILENAME(1:IOFFS) // 'LSM_' // HTYPE // YGAUSS
      ENDIF
      IOFFS = INDEX(FILENAME,' ')
C
      IF (LNNLSM_CY41R1) FILENAME(IOFFS:) = '_CY41R1'
      IOFFS = INDEX(FILENAME,' ')
C
      CALL INTLOG(JP_DEBUG,'HGETLSM: land-sea mask filename',JPQUIET)
      CALL INTLOG(JP_DEBUG,'HGETLSM: ' // FILENAME(1:(IOFFS-1)),JPQUIET)
C
C     -----------------------------------------------------------------|
C     Section 3.  Read the land-sea mask values
C     -----------------------------------------------------------------|
C
  300 CONTINUE
C
      CALL PBOPEN(IUNIT,FILENAME(1:(IOFFS-1)),'r',IRET)
      IF( IRET.NE.0 ) THEN
        CALL INTLOG(JP_DEBUG,'HGETLSM: PBOPEN Iret',IRET)
        CALL INTLOG(JP_DEBUG,'HGETLSM: PBOPEN failed',JPQUIET)
        HGETLSM = 3
        GOTO 900
      ENDIF
C
      CALL PBREAD(IUNIT,OLDLSM,KSIZE,IRET)
      IF( IRET.NE.KSIZE ) THEN
        CALL INTLOG(JP_DEBUG,'HGETLSM: PBREAD failed',JPQUIET)
        HGETLSM = 3
        GOTO 900
      ENDIF
C
      CALL PBCLOSE(IUNIT,IRET)
      IF( IRET.NE.0 ) THEN
        CALL INTLOG(JP_DEBUG,'HGETLSM: PBCLOSE failed',JPQUIET)
        HGETLSM = 3
        GOTO 900
      ENDIF
C
C     -----------------------------------------------------------------|
C     Section 9.  Return.
C     -----------------------------------------------------------------|
C
  900 CONTINUE
C
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities
C granted to it by virtue of its status as an intergovernmental organisation
C nor does it submit to any jurisdiction.
C
      INTEGER FUNCTION JGGLAT(KLAT, PGAUSS)
C
C---->
C**** *JGGLAT* - Routine to compute Gaussian abscissae
C
C     PURPOSE
C     _______
C
C     This routine computes Gaussian lines of latitude for a given
C     truncation.
C
C     INTERFACE
C     _________
C
C     IERR = JGGLAT(KLAT, PGAUSS)
C
C     Input parameters
C     ________________
C
C     KLAT       - This is the number of lines of latitude from pole to
C                  pole.
C
C     Output parameters
C     ________________
C
C     PGAUSS     - The Gaussian lines of latitude for truncation
C                  KLAT / 2.
C
C     Return value
C     ____________
C
C     The error indicator (INTEGER).
C
C     Error and Warning Return Values
C     _______________________________
C
C     1  The Newton iteration failed to converge when generating
C        Gaussian lines of latitude.
C
C     MARSINT problem - Please report this to Meteorological
C     Applications.
C
C     Common block usage
C     __________________
C
C     None
C
C     EXTERNALS
C     _________
C
C     JBESS    - This routine is used to generate initial
C                  approximations to the Gaussian latitudes.
C
C     METHOD
C     ______
C
C     JBESS is used to provide zeros of the Bessel function J0,
C     which are used as starting approximations to the Gaussian
C     latitudes. Newton iteration is used to generate the latitudes
C     from these approximations.
C
C     REFERENCE
C     _________
C
C     None
C
C     COMMENTS
C     ________
C
C
C     This routine is adapted from that in the old Marsint library.
C     The interface and the variable names have been modified.
C
C     Program contains sections 0 to 2 and 9
C
C     AUTHOR
C     ______
C
C     K. Fielding      *ECMWF*      Oct 1993
C
C     MODIFICATIONS
C     _____________
C
C     None
C
C----<
C     _______________________________________________________
C
C*    Section 0. Definition of variables.
C     _______________________________________________________
C
         IMPLICIT NONE
C
#include "jparams.h"
#include "parim.h"
C
C     Dummy arguments
      INTEGER KLAT
C
      REAL PGAUSS (*)
C
C     Local variables
C
      INTEGER ITRUNC, IERR
C
C     Loop control variables
C
      INTEGER JLAT, JITER, JLN
C
      REAL ZRADDEG, ZCON, ZLAT, ZROOT
      REAL ZKM1, ZKM2, ZLN, ZFUNC, ZDERIV, ZMOVE
C
C     Function externals
C
      INTEGER JBESS
C
C     _______________________________________________________
C
C*    Section 1. Set constants and get initial approximation.
C     _______________________________________________________
C
  100 CONTINUE
C
      ZFUNC  = 0.
      JGGLAT = 0
C
      ZRADDEG = 180.0 / PPI
C
      ZCON = (PPONE - (PPTWO / PPI) ** 2) * PPQUART
C
      ZLAT = KLAT
      ITRUNC = KLAT / 2
C
      IERR = JBESS (ITRUNC, PGAUSS)
C
C     _______________________________________________________
C
C*    Section 2. Compute abscissae
C     _______________________________________________________
C
  200 CONTINUE
C
      DO 240 JLAT = 1, ITRUNC
C
C     First approximation for ZROOT
C
         ZROOT = COS (PGAUSS (JLAT) /
     1      SQRT ( (ZLAT + PPHALF) ** 2 + ZCON) )
C
C     Perfrom loop of Newton iterations
C
         DO 220 JITER =1, JPMAXITER
C
            ZKM2 = PPONE
            ZKM1 = ZROOT
C
C     Compute Legendre polynomial
C
            DO 210 JLN = 2, KLAT
C
               ZLN = JLN
C
               ZFUNC = ( (PPTWO * ZLN - PPONE) * ZROOT * ZKM1 -
     1            (ZLN - PPONE) * ZKM2) / ZLN
C
               ZKM2 = ZKM1
               ZKM1 = ZFUNC
C
  210       CONTINUE
C
C     Perform Newton iteration
C
C
            ZDERIV = (ZLAT * (ZKM2 - ZROOT * ZFUNC) ) /
     1         (PPONE - ZROOT ** 2)
C
            ZMOVE = ZFUNC / ZDERIV
C
            ZROOT = ZROOT - ZMOVE
C
C     If ABS (ZMOVE) < PPEPSA leave iteration loop because sufficient
C     accuracy has been achieved.
C
            IF (ABS (ZMOVE) .LE. PPEPSA) GOTO 230
C
  220    CONTINUE
C
C     Routine fails if no convergence after JPMAXITER iterations.
C
         JGGLAT = 1
         GO TO 900
C
  230    CONTINUE
C
C*    Set North and South values using symmetry.
C
         PGAUSS (JLAT) = ASIN (ZROOT) * ZRADDEG
         PGAUSS (KLAT + 1 - JLAT) = - PGAUSS (JLAT)
C
  240 CONTINUE
C
C
      IF (KLAT .NE. ITRUNC * 2) PGAUSS (ITRUNC + 1) = PPZERO
C
C     _______________________________________________________
C
C*    Section 9. Return to calling routine.
C     _______________________________________________________
C
  900 CONTINUE
C
C
      RETURN
      END

C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE JMEMHAN( KFLAG, KZOUTBF, KSIZE, KOPT, KRET)
C
C---->
C**** JMEMHAN
C
C     PURPOSE
C     _______
C
C     This routine handles memory allocation for jintll.F and jintgg.F
C
C     INTERFACE
C     _________
C
C     CALL JMEMHAN( KFLAG, KZOUTBF, KSIZE, KOPT, KRET)
C
C     Input parameters
C     ________________
C
C     KFLAG   - Flag to select lat/long or gaussian allocation
C               = 1  for grid to grid interpolation (igalloc)
C               = 2  for grid to grid interpolation (igalloc)
C               = 3  for scratch space
C               = 4  for vorticity and divergence scratch space
C               = 5  for even more scratch space (!?)
C               = 6  for latitude/longitude interpolation coefficients
C                    on Fujitsu
C               = 7  for gaussian interpolation coefficients on Fujitsu
C               = 8  unused
C               = 9  for FFT work space
C               = 10 for output (partial) grid point field workspace
C               = 11 for work space for rotating fields (see intfap.F)
C               = 12 for raw land-sea mask (see iglsmst.F)
C               = 13 for 10 minute land-sea mask (see iglsm01.F)
C               = 14 for reading legendre coefficents line by line
C               = 15 more work space for rotating fields (see intfap.F)
C               = 16 more work space intfbu.F
C               = 17 more work space ??
C               = 18 for rotation of gaussian grids (ggrotat and tatorgg)
C               = 19 for dynamic allocation of znfeldi (intf)
C               = 20 to 22, coefficients for rotating spectral fields (jacobif)
C
C     KSIZE   - Size of memory required in words
C     KOPT    - Memory option
C               = 0 to deallocate
C               = 1 to allocate
C
C
C     Output parameters
C     ________________
C
C     KZOUTBF - Pointer to memory (if allocating)
C     KRET    - Return status code
C               0 = OK
C
C
C     Common block usage
C     __________________
C
C     JDCNDGB
C     JMEMCOM
C
C
C     Method
C     ______
C
C     None.
C
C
C     Externals
C     _________
C
C     JDEBUG    - Checks environment variable to switch on/off debug
C     JMALLOC   - Allocate heap space
C     JFREE     - Deallocate heap space
C     INTLOG    - Output log message
C     IAFREE    - Deallocate heap space used by grid-pt to grid-pt
C                 interpolation
C
C
C     Reference
C     _________
C
C     None.
C
C
C     Comments
C     ________
C
C     None.
C
C
C     AUTHOR
C     ______
C
C     J.D.Chambers      *ECMWF*      May 1994
C
C     MODIFICATIONS
C     _____________
C
C     J.D.Chambers      *ECMWF*      Jan 1995
C     Add scratch for vorticity and divergence (flag = 4)
C
C     J.D.Chambers      *ECMWF*      Jan 1995
C     Add space for interpolation coefficents (flag = 6)
C
C     J.D.Chambers      *ECMWF*      Sep 1996
C     Split space for interpolation coefficents (flag = 6 and 7)
C
C     J.D.Chambers     ECMWF        Feb 1997
C     Allow for 64-bit pointers
C
C     J.D.Chambers     ECMWF        Mar 1998
C     Allow memory flushing
C
C----<
C     -------------------------------------------------------
C*    Section 0. Definition of variables.
C     -------------------------------------------------------
C
      IMPLICIT NONE
#include "jparams.h"
#include "jparam2.h"
#include "parim.h"
C
C     Parameters
C
      INTEGER JPROUTINE, JPOPTMX
      PARAMETER ( JPROUTINE = 30600 )
      PARAMETER ( JPOPTMX = 22 )
C
C     Subroutine arguments
C
#ifdef POINTER_64
      INTEGER*8 KZOUTBF
#else
      INTEGER KZOUTBF
#endif
      INTEGER KSIZE, KOPT, KRET, KFLAG
C
C     Local variables
C
      LOGICAL LDEBUG, LDEBUG1
      INTEGER ITOTAL, LOOP
#ifdef POINTER_64
      INTEGER*8 IZOUTBF
#else
      INTEGER IZOUTBF
#endif
      INTEGER IEXIST
      DIMENSION IEXIST(JPOPTMX)
      DIMENSION IZOUTBF(JPOPTMX)
      DATA IEXIST/ JPOPTMX * -1/
      DATA IZOUTBF/ JPOPTMX * 0/
C
      SAVE IEXIST, IZOUTBF
C
C     Externals
C
#ifdef POINTER_64
      INTEGER*8 JMALLOC
#else
      INTEGER JMALLOC
#endif
      INTEGER IAFREE
      EXTERNAL JMALLOC, IAFREE
C
C     -------------------------------------------------------
C*    Section 1.    Initialisation.
C     -------------------------------------------------------
C
  100 CONTINUE
C
      KRET = 0
      CALL JDEBUG( )
      LDEBUG  = ( NDBG.GT.0 )
      LDEBUG1 = ( NDBG.EQ.1 )
C
C     Check that a  valid option has been chosen
C
      IF( ( KFLAG.LT.1 ).OR.( KFLAG.GT.JPOPTMX ) ) THEN
        CALL INTLOG(JP_ERROR,'JMEMHAN: Invalid flag = ', KFLAG)
        KRET = JPROUTINE + 1
        GOTO 900
      ENDIF
C
C     Display diagnostics if required
C
      IF( LDEBUG ) THEN
C
        CALL INTLOG(JP_DEBUG,'JMEMHAN: Input parameters:',JPQUIET)
        CALL INTLOG(JP_DEBUG, 'JMEMHAN: Memory type flag = ', KFLAG)
C
        IF( ( KFLAG.EQ.1 ).OR.( KFLAG.EQ.2 ) ) CALL INTLOG(JP_DEBUG,
     X    'JMEMHAN: 1 = grid to grid interpolation', JPQUIET)
C
        IF( ( KFLAG.EQ.3 ).OR.( KFLAG.EQ.4 ).OR.( KFLAG.EQ.5 ) )
     X    CALL INTLOG(JP_DEBUG,
     X    'JMEMHAN: 3->5 = scratch,',JPQUIET)
C
        IF( KFLAG.EQ.6 ) CALL INTLOG(JP_DEBUG,
     X    'JMEMHAN: 6 = coeffs for spectral to lat/long interp',JPQUIET)
C
        IF( KFLAG.EQ.7 ) CALL INTLOG(JP_DEBUG,
     X    'JMEMHAN: 7 = coefs for spectral to gaussian interp,',JPQUIET)
C
        IF( KFLAG.EQ.8 ) CALL INTLOG(JP_DEBUG,
     X    'JMEMHAN: 8 = coefficients for rotating SH fields',JPQUIET)
C
        IF( KFLAG.EQ.9 ) CALL INTLOG(JP_DEBUG,
     X    'JMEMHAN: 9 = FFT workspace,',JPQUIET)
C
        IF( KFLAG.EQ.10 ) CALL INTLOG(JP_DEBUG,
     X    'JMEMHAN: 10 = output (partial) grid pt field,',JPQUIET)
C
        IF( KFLAG.EQ.11 ) CALL INTLOG(JP_DEBUG,
     X    'JMEMHAN: 11 = work space for rotating fields,',JPQUIET)
C
        IF( KFLAG.EQ.12 ) CALL INTLOG(JP_DEBUG,
     X    'JMEMHAN: 12 = raw land-sea mask,',JPQUIET)
C
        IF( KFLAG.EQ.13 ) CALL INTLOG(JP_DEBUG,
     X    'JMEMHAN: 13 = 10 minute land-sea mask.',JPQUIET)
C
        IF( KFLAG.EQ.14 ) CALL INTLOG(JP_DEBUG,
     X    'JMEMHAN: 14 = legendre coefficents line by line.',JPQUIET)
C
        IF( KFLAG.EQ.15 ) CALL INTLOG(JP_DEBUG,
     X    'JMEMHAN: 15 = more work space for rotating fields.',JPQUIET)
C
        IF( KFLAG.EQ.16 ) CALL INTLOG(JP_DEBUG,
     X    'JMEMHAN: 16 = more work space for intfbu.F.',JPQUIET)
C
        IF( KFLAG.EQ.17 ) CALL INTLOG(JP_DEBUG,
     X    'JMEMHAN: 17 = more work space for ??.',JPQUIET)
C
        IF( KFLAG.EQ.18 ) CALL INTLOG(JP_DEBUG,
     X    'JMEMHAN: 18 = space for rotating gaussian fields.',JPQUIET)
C
        IF( KFLAG.EQ.19 ) CALL INTLOG(JP_DEBUG,
     X    'JMEMHAN: 19 = for dynamic allocation of znfeldi.',JPQUIET)
C
        IF( KFLAG.EQ.20 ) CALL INTLOG(JP_DEBUG,
     X    'JMEMHAN: 20 = coefficients for rotating SH fields',JPQUIET)
C
        IF( KFLAG.EQ.21 ) CALL INTLOG(JP_DEBUG,
     X    'JMEMHAN: 21 = coefficients for rotating SH fields',JPQUIET)
C
        IF( KFLAG.EQ.22 ) CALL INTLOG(JP_DEBUG,
     X    'JMEMHAN: 22 = coefficients for rotating SH fields',JPQUIET)
C
        CALL INTLOG(JP_DEBUG,'JMEMHAN: Memory reqd in words = ', KSIZE)
        CALL INTLOG(JP_DEBUG,'JMEMHAN: Option (1 = allocate) = ', KOPT)
      ENDIF
C
C     -------------------------------------------------------
C*    Section 2.    Allocate memory
C     -------------------------------------------------------
C
  200 CONTINUE
C
      IF( KOPT.EQ.1 ) THEN
C
        IF( LDEBUG ) THEN
          CALL INTLOG(JP_DEBUG,
     X      'JMEMHAN: Requested allocation = ', KSIZE)
          CALL INTLOG(JP_DEBUG,
     X      'JMEMHAN: Previous allocation  = ', IEXIST(KFLAG))
        ENDIF
C
C       See if more memory required than already allocated
C
        IF( KSIZE.GT.IEXIST(KFLAG) ) THEN
C
C         Special cases (sigh)
C
C         If allocating memory for spectral to lat/long or gaussian
C         interpolation, first deallocate heap space used by grid-pt
C         to grid-pt interpolation.
C
          IF( ( KFLAG.EQ.1 ).OR.( KFLAG.EQ.2 ) ) THEN
            IF( LDEBUG ) THEN
              KRET = IAFREE(1,1)
            ELSE
              KRET = IAFREE(0,-1)
            ENDIF
          ENDIF
C
C         If allocating memory on VPP for spectral to grid interpolation
C         coefficients, first deallocate memory used by other type of
C         spectral to gaussian interpolation if this option has been
C         requested.
C
          IF( LFREECF ) THEN
            IF( LDEBUG ) CALL INTLOG(JP_DEBUG,
     X        'JMEMHAN: Free coefficients option exercised', JPQUIET)
C
C           Spectral -> lat/long
C
            IF( KFLAG.EQ.6 ) THEN
              IF( IEXIST(7).NE.-1 ) THEN
                IF( LDEBUG ) CALL INTLOG(JP_DEBUG,
     X            'JMEMHAN: Free spect->gaussn coeff memory',IZOUTBF(7))
                CALL JFREE( IZOUTBF(7) )
                IZOUTBF(7) = 0
                IEXIST(7) = -1
                NISIZE7 = 0
                YOLDGG = 'xxxxxxxxxxxxxxx'
              ENDIF
            ENDIF
C
C           Spectral -> gaussian
C
            IF( KFLAG.EQ.7 ) THEN
              IF( IEXIST(6).NE.-1 ) THEN
                IF( LDEBUG ) CALL INTLOG(JP_DEBUG,
     X            'JMEMHAN: Free spec->lat/lon coeff memory',IZOUTBF(6))
                CALL JFREE( IZOUTBF(6) )
                IZOUTBF(6) = 0
                IEXIST(6) = -1
                NISIZE6 = 0
                YOLDLL = 'xxxxxxxxxxxxxxxxxxx'
              ENDIF
            ENDIF
          ENDIF
C
          IF( LDEBUG ) CALL INTLOG(JP_DEBUG,
     X      'JMEMHAN: Request greater than previous allocation', KSIZE)
C
C         If memory already allocated, deallocate existing memory
C
          IF( IEXIST(KFLAG).GE.0 ) THEN
C
            IF( LDEBUG ) CALL INTLOG(JP_DEBUG,
     X          'JMEMHAN: Deallocate existing memory',IEXIST(KFLAG))
            CALL JFREE( IZOUTBF(KFLAG) )
          ENDIF
C
C         Allocate heap memory
C
          IF( LDEBUG ) CALL INTLOG(JP_DEBUG,
     X      'JMEMHAN: Allocate new memory ',KSIZE)
C
          IEXIST(KFLAG) = KSIZE
#if (defined REAL_8)
          IZOUTBF(KFLAG) = JMALLOC( IEXIST(KFLAG) * 8 )
#else
          IZOUTBF(KFLAG) = JMALLOC( IEXIST(KFLAG) * 4 )
#endif
#ifdef hpR64
          IZOUTBF(KFLAG) = IZOUTBF(KFLAG)/(1024*1024*1024*4)
#endif
          IF( IZOUTBF(KFLAG).EQ.0 ) THEN
            CALL INTLOG(JP_ERROR,
     X        'JMEMHAN: Memory allocation failed',IZOUTBF(KFLAG))
            IEXIST(KFLAG) = -1
            KRET = JPROUTINE + 5
            GOTO 900
          ENDIF
        ENDIF
C
        IF( LFREECF ) THEN
C
C         Spectral -> lat/long
C
          IF( KFLAG.EQ.6 ) NISIZE6 = IEXIST(6)
C
C         Spectral -> gaussian
C
          IF( KFLAG.EQ.7 ) NISIZE7 = IEXIST(7)
C
        ENDIF
C
C     -------------------------------------------------------
C*    Section 3.    Deallocate memory
C     -------------------------------------------------------
C
  300 CONTINUE
C
      ELSE
C
        IF( LDEBUG ) CALL INTLOG(JP_DEBUG,
     X    'JMEMHAN: Deallocate memory address = ',IZOUTBF(KFLAG))
C
        IF( IZOUTBF(KFLAG).GT.0 ) THEN
C
          CALL JFREE( IZOUTBF(KFLAG) )
          IZOUTBF(KFLAG) = 0
          IEXIST(KFLAG) = -1
C
        ELSE
          CALL INTLOG(JP_DEBUG,'JMEMHAN: Deallocation ignored',JPQUIET)
        ENDIF
      ENDIF
C
C     _______________________________________________________
C
C*    Section 9. Return to calling routine.
C     _______________________________________________________
C
 900  CONTINUE
      IF( KRET.EQ.0 ) KZOUTBF = IZOUTBF(KFLAG)
C
      IF( LDEBUG.AND.(.NOT.LDEBUG1) ) THEN
        ITOTAL = 0
        DO LOOP = 1, JPOPTMX
          IF( IEXIST(LOOP).GT.0 ) THEN
            CALL INTLOG(JP_DEBUG, 'JMEMHAN: For type ', LOOP)
#if (defined REAL_8)
            CALL INTLOG(JP_DEBUG,
     X        'JMEMHAN: bytes allocated = ', IEXIST(LOOP)*8 )
            ITOTAL = ITOTAL + (IEXIST(LOOP) * 8)
#else
            CALL INTLOG(JP_DEBUG,
     X        'JMEMHAN: bytes allocated = ', IEXIST(LOOP)*4 )
            ITOTAL = ITOTAL + (IEXIST(LOOP) * 4)
#endif
          ENDIF
        ENDDO
        CALL INTLOG(JP_DEBUG,'JMEMHAN: Total bytes allocated=', ITOTAL)
        CALL INTLOG(JP_DEBUG,'JMEMHAN: Return status code = ', KRET)
      ENDIF
C
      RETURN
      END

C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE BTABLE(YNAME,YTABB,KERR)
C
C**** *BTABLE*
C
C
C     PURPOSE.
C     --------
C          CREATE BUFR TABLE B IN BINARY FORM.
C
C**   INTERFACE.
C     ----------
C          NONE.
C
C
C     *METHOD.
C      -------
C          NONE.
C
C
C     EXTERNALS.
C     ----------
C          NONE.
C
C
C
C
C     REFERENCE.
C     ----------
C
C          BINARY UNIVERSAL FORM FOR DATA REPRESENTATION, FM 94 BUFR.
C
C          J.K.GIBSON AND M.DRAGOSAVAC,1987: DECODING DATA 
C          REPRESENTATION FM 94 BUFR,TECHNICAL MEMORANDUM NO.
C
C          J.K.GIBSON,1986:EMOS 2 - STANDARDS FOR SOFTWARE DEVELOPMENT
C          AND MAINTANANCE ,TECHICAL MEMORANDUM NO.       ECMWF.
C
C
C     AUTHOR.
C     -------
C
C          M. DRAGOSAVAC       *ECMWF*       JANUARY 1991.
C
C
C     MODIFICATIONS.
C     --------------
C
C          NONE.
C
C
      IMPLICIT LOGICAL(L,O,G), CHARACTER*8(C,H,Y)
C
#     include "parameter.F"
#     include "bcomwork.F"
#     include "bcomtab.F"
#     include "bcomtabc.F"
#     include "bcomct.F"
#     include "bcomctc.F"
#     include "bcomroot.F"
#     include "bcomtabload.F"
#     include "bcomtabloadc.F"

C
      CHARACTER*64 CTABBEN,CCTABBEN
      CHARACTER*24 CTABBU,CCTABBU,CTABLE_LIST,YTABB
      CHARACTER*120 YENTRY
      CHARACTER*(*) YNAME
      CHARACTER*256  YFNAME
      REAL*8 RVIND,EPS
C
C     DATA CTABBEN/JTAB*' '/,CTABBU/JTAB*' '/
C
C     ------------------------------------------------------------------
C*          1.   INITIALIZE CONSTANTS AND VARIABLES.
C                -----------------------------------
 100  CONTINUE
C
      J=0
      ICLASS0=0
      IVIND=2147483647
      YFNAME=' '
C
      DO 101 I=1,64
      do 101 ii=1,255
      NTABP(I,ii)=0
 101  CONTINUE
C
      DO 102 i=1,JTAB
      NTABBTR(I)=IVIND
      NTABBS (I)=IVIND
      NTABBRV(I)=IVIND
      NTABBDW(I)=IVIND
      CTABBEN(I)=' '
      CTABBU (I)=' '
 102  CONTINUE
C
      II=INDEX(YNAME,' ')
      II=II-1
      YFNAME=YNAME(1:II)
      II=INDEX(YFNAME,' ')
      II=II-1
      CALL GET_FREE_UNIT(IUNIT)
      OPEN(UNIT=IUNIT,FILE=YFNAME(1:II),
     2            IOSTAT=IOS,      
     1            STATUS='OLD')
      IF(IOS.NE.0) THEN
         print*,'open error on ',YFNAME(1:II)
         kerr=61
         return
      END IF
C     ------------------------------------------------------------------
C*          2.   READ IN TABLE B ELEMENT.
C                ------------------------
C
 200  CONTINUE
C
      YENTRY=' '
      READ(IUNIT,'(A)',ERR=402,END=300) YENTRY
C
      J=J+1
      IF(J.GT.JTAB) THEN
         PRINT*,' DIMENSION TOO SMALL J=',J
         kerr=6
         return
      END IF 
C
C     ------------------------------------------------------------------
C*          2.1  SET ARRAYS FOR TABLE REFERENCE, ELEMENT NAME, UNITS,
C*               REFERENCE VALUE AND DATA WIDTH.
C
 210  CONTINUE
C
C
      READ(YENTRY,'(1X,I6,1x,64x,1x,24x,1x,I3,1x,I12,1x,I3)')
     1                                         NTABBTR(J),NTABBS (J),
     1                                         NTABBRV(J),NTABBDW(J)
C
      CTABBEN(J)=YENTRY( 9:72)
      CTABBU (J)=YENTRY(74:97)
C
      ICLASS=NTABBTR(J)/1000
      IYYY  =NTABBTR(J)-ICLASS*1000+1
C
      ICLASS=ICLASS+1
      NTABP(ICLASS,IYYY)=J
C
c      WRITE(*,1000) NTABBTR(J),CTABBEN(J),CTABBU(J),NTABBS(J),
c     1              NTABBRV(J),NTABBDW(J)
c 1000 FORMAT(1H ,1X,I6,1x,64x,1x,24x,1x,,I3,1x,I12,1x,I3)
C
      GO TO 200
C
C     ------------------------------------------------------------------
 300  CONTINUE
C
      NTT=NTT+1
      IF(NTT.GT.JTMAX) THEN
         NTT=NTT-1
         NTC=NTC+1
         IF(NTC.GT.10) NTC=1
         DO J=1,JTAB
         MTABBTR(J,NTC)=NTABBTR(J)
         MTABBS (J,NTC)=NTABBS (J)
         MTABBRV(J,NTC)=NTABBRV(J)
         MTABBDW(J,NTC)=NTABBDW(J)
         CCTABBEN(J,NTC)=CTABBEN(J)
         CCTABBU (J,NTC)=CTABBU (J)
         END DO
         DO I=1,64
         DO K=1,255
         MTABP(I,K,NTC)=NTABP(I,K)
         END DO
         END DO
         CTABLE_LIST(NTC)=YTABB
      ELSE
         DO J=1,JTAB
         MTABBTR(J,NTT)=NTABBTR(J)
         MTABBS (J,NTT)=NTABBS (J)
         MTABBRV(J,NTT)=NTABBRV(J)
         MTABBDW(J,NTT)=NTABBDW(J)
         CCTABBEN(J,NTT)=CTABBEN(J)
         CCTABBU (J,NTT)=CTABBU (J)
         END DO
         DO I=1,64
         DO K=1,255
         MTABP(I,K,NTT)=NTABP(I,K)
         END DO
         END DO
         CTABLE_LIST(NTT)=YTABB
      END IF
C
      CLOSE(IUNIT)
C
C     WRITE(*,'(1h )')
C     WRITE(*,'(1h ,a,i4)') 'Total number of entries in Table B is ',j
C
      RETURN
C
402   CONTINUE
      KERR=6
      WRITE(*,4402) IOS,YFNAME
 4402 FORMAT(1H ,'Read error',i4,' on ',a)
      RETURN
C
 401  CONTINUE
C
      KERR=61
      WRITE(*,4401) IOS,YFNAME
 4401 FORMAT(1H ,'Open error',i4,' on ',a)
C     
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities
C granted to it by virtue of its status as an intergovernmental organisation
C nor does it submit to any jurisdiction.
C

      INTEGER FUNCTION HIRLAMW(L12PNT,OLDFLDU,OLDFLDV,KOUNT,KGAUSS,
     X  HTYPE,AREA,POLE,GRID,NEWFLDU,NEWFLDV,KSIZE,NLON,NLAT)
C
C---->
C**** HIRLAMW
C
C     Purpose
C     -------
C
C     This routine creates a rotated regular lat/long field from a
C     gaussian field using 12-point horizontal interpolation.
C
C
C     Interface
C     ---------
C
C     IRET = HIRLAMW(L12PNT,OLDFLDU,OLDFLDV,KOUNT,KGAUSS,HTYPE,AREA,
C    X               POLE,GRID,NEWFLDU,NEWFLDV,KSIZE,NLON,NLAT)
C
C
C     Input parameters
C     ----------------
C
C     L12PNT  - Chooses between 12-point and 4-point interpolation
C               = .TRUE. for 12-point horizontal
C               = .FALSE. for 4-point
C     OLDFLDU - The array of values from the gaussian U field
C     OLDFLDV - The array of values from the gaussian V field
C     KOUNT   - Number of values in OLDFLDU/V
C     KGAUSS  - Gaussian number for the gaussian field
C     HTYPE   - Gaussian grid type
C               = 'R' for reduced ("quasi-regular"),
C               = 'O' for reduced/octahedral,
C               = 'F' for full,
C               = 'U' for a user-defined gaussian grid
C     AREA    - Limits of output area (N/W/S/E)
C     POLE    - Pole of rotation (lat/long)
C     GRID    - Output lat/long grid increments (we/ns)
C     KSIZE   - The size of the output array to fill with the regular
C               lat/long field
C
C
C     Output parameters
C     -----------------
C
C     NEWFLDU - The array of values for the regular lat/long U field
C     NEWFLDV - The array of values for the regular lat/long V field
C     NLON    - Number of longitudes in the regular lat/long field
C     NLAT    - Number of latitudes in the regular lat/long field
C
C     Returns 0 if function successful, non-zero otherwise.
C
C     Common block usage
C     ------------------
C
C     nifld.common
C     nofld.common
C
C
C     Method
C     ------
C
C     Numbering of the points (I is the interpolation point):
C
C                   13       5       6      14
C
C                    7       1       2       8
C                               (I)
C                    9       3       4      10
C
C                   15      11      12      16
C
C     The 12-point interpolation is not possible if either of the top
C     two rows is above the original field northern latitude. The
C     nearest neighbour is used if both rows are above, and a 4-pt
C     bilinear interpolation is used if the top row is above.
C     Similarily, if either of the bottom two rows is below the original
C     field southern latitude.
C
C
C     Externals
C     ---------
C
C     JGETGG  - Reads the definition of a gaussian grid
C     HGENGRW - Calculates original lat/long (before rotation) for
C               a rotated grid for wind fields.
C     HNEI12  - Finds neighbours for points for interpolation
C     HWTS12  - Calculates weightings for points for interpolation
C     HIRLAMW_USERSPACE_1_GET - HIRLAMW userspace memory #1
C     HIRLAMW_USERSPACE_2_GET - HIRLAMW userspace memory #2
C     HIRLAMW_USERSPACE_3_GET - HIRLAMW userspace memory #3
C
C
C     Reference
C     ---------
C
C     None.
C
C
C     Comments
C     --------
C
C     None.
C
C
C     Author
C     ------
C
C     J.D.Chambers      ECMWF      January 2001
C
C
C     Modifications
C     -------------
C
C     None.
C
C----<
C     -----------------------------------------------------------------|
C*    Section 0. Definition of variables.
C     -----------------------------------------------------------------|
C
      IMPLICIT NONE
C
#include "parim.h"
#include "nifld.common"
#include "nofld.common"
#include "grfixed.h"
C
C     Parameters
C
      INTEGER JNORTH, JSOUTH, JWEST, JEAST, JW_E, JN_S
      INTEGER JP12PT, JP4PT
      PARAMETER (JP12PT = 0)
      PARAMETER (JP4PT  = 1)
      PARAMETER (JNORTH = 1)
      PARAMETER (JWEST  = 2)
      PARAMETER (JSOUTH = 3)
      PARAMETER (JEAST  = 4)
      PARAMETER (JW_E   = 1)
      PARAMETER (JN_S   = 2)
C
C     Function arguments
C
      LOGICAL L12PNT
      INTEGER KOUNT, KGAUSS, KSIZE, NLON, NLAT
      REAL AREA(4), POLE(2), GRID(2)
      REAL OLDFLDU(*), NEWFLDU(KSIZE)
      REAL OLDFLDV(*), NEWFLDV(KSIZE)
      CHARACTER*1 HTYPE
C
C     Local variables
C
      INTEGER NEXT, LOOP, IRET, NLEN, NBYTES, NUMBER
      INTEGER NPREV, COUNTU, COUNTV, NEAREST
      CHARACTER*1 HPREV
C
      INTEGER KSCHEME(1),NEIGH(12,1), KLA(1)
      REAL PWTS(12,1)
      POINTER (IPKSCHE, KSCHEME)
      POINTER (IPNEIGH, NEIGH)
      POINTER (IPKLA,   KLA)
      POINTER (IPPWTS,  PWTS)
C
      REAL PDLO0(1),PDLO1(1),PDLO2(1),PDLO3(1),PDLAT(1)
      POINTER (IPPDLO0, PDLO0)
      POINTER (IPPDLO1, PDLO1)
      POINTER (IPPDLO2, PDLO2)
      POINTER (IPPDLO3, PDLO3)
      POINTER (IPPDLAT, PDLAT)
C
      INTEGER IGG, IGGOLD
      INTEGER KPTS(1)
      REAL GLATS(1)
      INTEGER IOFFS(1)
      POINTER (IPKPTS,  KPTS)
      POINTER (IPIOFFS, IOFFS)
      POINTER (IPGLATS, GLATS)
C
      INTEGER ILL
      REAL RLAT(1),RLON(1)
      POINTER (IPRLAT, RLAT)
      POINTER (IPRLON, RLON)
      REAL RCLAT(1),RCLON(1),RDIR(1),C(1),S(1),U(1),V(1)
      POINTER (IPRCLAT, RCLAT)
      POINTER (IPRCLON, RCLON)
      POINTER (IPRDIR, RDIR)
      POINTER (IPC, C)
      POINTER (IPS, S)
      POINTER (IPU, U)
      POINTER (IPV, V)
C
      REAL OLDU(KOUNT), OLDV(KOUNT)
C
      CHARACTER*7 FNAME
      PARAMETER  (FNAME = 'HIRLAMW')
C
      DATA IGGOLD/-1/
      DATA NUMBER/-1/
      DATA NPREV/-1/
      DATA HPREV/' '/
C
      SAVE IPKSCHE, IPNEIGH, IPKLA, IPPWTS
      SAVE IPPDLO0, IPPDLO1, IPPDLO2, IPPDLO3, IPPDLAT
      SAVE IGGOLD, IPKPTS, IPIOFFS, IPGLATS
      SAVE IPRLAT, IPRLON
      SAVE NUMBER
      SAVE NPREV
      SAVE HPREV
      SAVE IPRCLAT, IPRCLON, IPRDIR
      SAVE IPC, IPS, IPU, IPV
C
C     Externals
C
      INTEGER HNEI12
      INTEGER HGENGRW
#ifdef POINTER_64
      INTEGER*8
#else
      INTEGER
#endif
     X  HIRLAMW_USERSPACE_1_GET,
     X  HIRLAMW_USERSPACE_2_GET,
     X  HIRLAMW_USERSPACE_3_GET
C
C     Statement functions
C
      REAL A, B
      LOGICAL NOTEQ
C
C     Convert degrees to radians
C
      REAL X, RADIAN
      RADIAN(X) = (X) * 0.0174532925
C
C     Tests that A is not (almost) equal to B
C
      NOTEQ(A,B) = (ABS((A)-(B)).GT.(ABS(A)*1E-3))
C
C     -----------------------------------------------------------------|
C     Section 1.  Initialise.
C     -----------------------------------------------------------------|
C
  100 CONTINUE
C
      HIRLAMW = 0
C
      CALL JDEBUG()
C
      IF( L12PNT ) THEN
        CALL INTLOG(JP_DEBUG,FNAME//': 12-pt interpolation',JPQUIET)
      ELSE
        CALL INTLOG(JP_DEBUG,FNAME//': 4-pt interpolation',JPQUIET)
      ENDIF

      IF( HTYPE.NE.'O' .AND. HTYPE.NE.'R' .AND. HTYPE.NE.'U'
     X .AND. HTYPE.NE.'F' ) THEN
        CALL INTLOG(JP_ERROR,
     X    FNAME//': Gaussian type unsupported ('//HTYPE//')',JPQUIET)
        HIRLAMW = 1
        GOTO 900
      ENDIF

C     Dynamically allocate memory for gaussian grid information.
C
      IGG = KGAUSS*2
      IF( IGG.GT.IGGOLD ) THEN
C
        NBYTES = (IGG*JPRLEN) + (2*IGG+1)*JPBYTES
C
        IPKPTS = HIRLAMW_USERSPACE_1_GET(NBYTES)
#ifdef hpR64
        IPKPTS = IPKPTS/(1024*1024*1024*4)
#endif
        IF( IPKPTS.EQ.0 ) THEN
          CALL INTLOG(JP_ERROR,
     X      FNAME//': Memory allocate fail',JPQUIET)
          HIRLAMW = 1
          GOTO 900
        ENDIF
C
        IPGLATS = IPKPTS  + (IGG*JPBYTES)
        IPIOFFS = IPGLATS + (IGG*JPRLEN)
C
        IGGOLD = IGG
        NPREV = -1
        HPREV = ' '
C
      ENDIF
C
C     Build up offsets to start of each latitude in original field(s)
C
      IF( KGAUSS.NE.NPREV .AND. HPREV.NE.HTYPE) THEN
        CALL INTLOG(JP_DEBUG,FNAME//': trying Gaussian '//HTYPE,KGAUSS)
        CALL JGETGG(KGAUSS,HTYPE,GLATS,KPTS,IRET)
        IF( IRET.NE.0 ) THEN
          CALL INTLOG(JP_ERROR,
     X      FNAME//': JGETGG failed to get gaussian data',JPQUIET)
          HIRLAMW = 2
          GOTO 900
        ENDIF
C
        IOFFS(1) = 1
        DO LOOP = 2, (KGAUSS*2+1)
          IOFFS(LOOP) = IOFFS(LOOP-1) + KPTS(LOOP-1)
        ENDDO
C
        NUMBER = (IOFFS(KGAUSS*2+1) - 1)
        IF( NUMBER.NE.KOUNT ) THEN
          CALL INTLOG(JP_ERROR,FNAME//': Given no. of points =',KOUNT)
          CALL INTLOG(JP_ERROR,FNAME//': Expected no. of pts =',NUMBER)
          HIRLAMW = 3
          GOTO 900
        ENDIF
C
        NPREV = KGAUSS
        HPREV = HTYPE
      ENDIF
C
C     Preserve the input fields
C     (in case OLDFLDx and NEWFLDx are the same arrays)
C
      OLDU(1:NUMBER) = OLDFLDU(1:NUMBER)
      OLDV(1:NUMBER) = OLDFLDV(1:NUMBER)
C
C     -----------------------------------------------------------------|
C     Section 2.  Generate the lat/long points for the output grid
C     -----------------------------------------------------------------|
C
  200 CONTINUE
C
      NLON = 1 + NINT((AREA(JEAST) - AREA(JWEST)) / GRID(JW_E))
      NLAT = 1 + NINT((AREA(JNORTH) - AREA(JSOUTH)) / GRID(JN_S))
C
      NLEN = NLON * NLAT

      NOWE = NLON
      NONS = NLAT
C
C     Check that given array is big enough for the new field.
C
      IF( NLEN.GT.KSIZE ) THEN
        CALL INTLOG(JP_ERROR,FNAME//': Given array size = ',KSIZE)
        CALL INTLOG(JP_ERROR,FNAME//': Required size = = ',NLEN)
        HIRLAMW = 5
        GOTO 900
      ENDIF
C
C     Dynamically allocate memory for lat/long arrays.
C
      ILL = NLEN
      NBYTES = 9*ILL*JPRLEN
C
      IPRLON = HIRLAMW_USERSPACE_2_GET(NBYTES)
#ifdef hpR64
      IPRLON = IPRLON/(1024*1024*1024*4)
#endif
      IF( IPRLON.EQ.0 ) THEN
        CALL INTLOG(JP_ERROR,FNAME//': Memory allocate fail',JPQUIET)
        HIRLAMW = 6
        GOTO 900
      ENDIF
C
      IPRLAT  = IPRLON  + (ILL*JPRLEN)
      IPRCLON = IPRLAT  + (ILL*JPRLEN)
      IPRCLAT = IPRCLON + (ILL*JPRLEN)
      IPRDIR  = IPRCLAT + (ILL*JPRLEN)
      IPC     = IPRDIR  + (ILL*JPRLEN)
      IPS     = IPC     + (ILL*JPRLEN)
      IPU     = IPS     + (ILL*JPRLEN)
      IPV     = IPU     + (ILL*JPRLEN)
C
      IRET = HGENGRW(AREA,POLE,GRID,NLON,NLAT,RCLAT,RCLON,RLAT,RLON)
      IF( IRET.NE.0 ) THEN
        CALL INTLOG(JP_ERROR,
     X      FNAME//': HGENGRW failed to get lat/lon grid',JPQUIET)
        HIRLAMW = 7
        GOTO 900
      ENDIF
C
C     -----------------------------------------------------------------|
C     Section 3.  Find neighbours for each point for interpolation.
C     -----------------------------------------------------------------|
C
  300 CONTINUE
C
C     Dynamically allocate memory for interpolation arrays.
C
      NBYTES = (17*JPRLEN + 14*JPBYTES) * ILL
C
      IPPDLO0 = HIRLAMW_USERSPACE_3_GET(NBYTES)
#ifdef hpR64
      IPPDLO0 = IPPDLO0/(1024*1024*1024*4)
#endif
      IF( IPPDLO0.EQ.0 ) THEN
        CALL INTLOG(JP_ERROR,FNAME//': Memory allocate fail',JPQUIET)
        HIRLAMW = 8
        GOTO 900
      ENDIF
C
      IPPDLO1 = IPPDLO0 + (ILL*JPRLEN)
      IPPDLO2 = IPPDLO1 + (ILL*JPRLEN)
      IPPDLO3 = IPPDLO2 + (ILL*JPRLEN)
      IPPDLAT = IPPDLO3 + (ILL*JPRLEN)
      IPPWTS  = IPPDLAT + (ILL*JPRLEN)
      IPKSCHE = IPPWTS  + (12*ILL*JPRLEN)
      IPKLA   = IPKSCHE + (ILL*JPBYTES)
      IPNEIGH = IPKLA   + (ILL*JPBYTES)
C
C     Find neighbours.
C
      IRET = HNEI12(L12PNT,NLEN,RLAT,RLON,KGAUSS,KPTS,GLATS,
     X              KSCHEME,PDLAT,PDLO0,PDLO1,PDLO2,PDLO3,KLA,NEIGH)
      IF( IRET.NE.0 ) THEN
        CALL INTLOG(JP_ERROR,
     X      FNAME//': HNEI12 failed to find neighbours',JPQUIET)
        HIRLAMW = 9
        GOTO 900
      ENDIF
C
C     -----------------------------------------------------------------|
C     Section 4.  Perform the 12-point horizontal interpolation.
C     -----------------------------------------------------------------|
C
  400 CONTINUE
C
C     Setup the 12-point horizontal interpolation weights
C
      CALL HWTS12
     X  (NLEN,KSCHEME,KLA,PDLAT,GLATS,PDLO0,PDLO1,PDLO2,PDLO3,NEIGH,
     X   PWTS)
C
C     Calculate the interpolated grid point values
C
      DO LOOP = 1, NLEN
        IF( KSCHEME(LOOP).EQ.JP12PT ) THEN
C
C     See if any of the neighbours are missing
C
          COUNTU = 0
          IF( NOTEQ(OLDU(NEIGH( 1,LOOP)),RMISSGV) ) COUNTU = COUNTU + 1
          IF( NOTEQ(OLDU(NEIGH( 2,LOOP)),RMISSGV) ) COUNTU = COUNTU + 1
          IF( NOTEQ(OLDU(NEIGH( 3,LOOP)),RMISSGV) ) COUNTU = COUNTU + 1
          IF( NOTEQ(OLDU(NEIGH( 4,LOOP)),RMISSGV) ) COUNTU = COUNTU + 1
          IF( NOTEQ(OLDU(NEIGH( 5,LOOP)),RMISSGV) ) COUNTU = COUNTU + 1
          IF( NOTEQ(OLDU(NEIGH( 6,LOOP)),RMISSGV) ) COUNTU = COUNTU + 1
          IF( NOTEQ(OLDU(NEIGH( 7,LOOP)),RMISSGV) ) COUNTU = COUNTU + 1
          IF( NOTEQ(OLDU(NEIGH( 8,LOOP)),RMISSGV) ) COUNTU = COUNTU + 1
          IF( NOTEQ(OLDU(NEIGH( 9,LOOP)),RMISSGV) ) COUNTU = COUNTU + 1
          IF( NOTEQ(OLDU(NEIGH(10,LOOP)),RMISSGV) ) COUNTU = COUNTU + 1
          IF( NOTEQ(OLDU(NEIGH(11,LOOP)),RMISSGV) ) COUNTU = COUNTU + 1
          IF( NOTEQ(OLDU(NEIGH(12,LOOP)),RMISSGV) ) COUNTU = COUNTU + 1
          COUNTV = 0
          IF( NOTEQ(OLDV(NEIGH( 1,LOOP)),RMISSGV) ) COUNTV = COUNTV + 1
          IF( NOTEQ(OLDV(NEIGH( 2,LOOP)),RMISSGV) ) COUNTV = COUNTV + 1
          IF( NOTEQ(OLDV(NEIGH( 3,LOOP)),RMISSGV) ) COUNTV = COUNTV + 1
          IF( NOTEQ(OLDV(NEIGH( 4,LOOP)),RMISSGV) ) COUNTV = COUNTV + 1
          IF( NOTEQ(OLDV(NEIGH( 5,LOOP)),RMISSGV) ) COUNTV = COUNTV + 1
          IF( NOTEQ(OLDV(NEIGH( 6,LOOP)),RMISSGV) ) COUNTV = COUNTV + 1
          IF( NOTEQ(OLDV(NEIGH( 7,LOOP)),RMISSGV) ) COUNTV = COUNTV + 1
          IF( NOTEQ(OLDV(NEIGH( 8,LOOP)),RMISSGV) ) COUNTV = COUNTV + 1
          IF( NOTEQ(OLDV(NEIGH( 9,LOOP)),RMISSGV) ) COUNTV = COUNTV + 1
          IF( NOTEQ(OLDV(NEIGH(10,LOOP)),RMISSGV) ) COUNTV = COUNTV + 1
          IF( NOTEQ(OLDV(NEIGH(11,LOOP)),RMISSGV) ) COUNTV = COUNTV + 1
          IF( NOTEQ(OLDV(NEIGH(12,LOOP)),RMISSGV) ) COUNTV = COUNTV + 1
C
C         Interpolate using twelve neighbours if none are missing
C
          IF( (COUNTU.EQ.12).AND.(COUNTV.EQ.12) ) THEN
C
            U(LOOP) =
     X        OLDU(NEIGH( 1,LOOP)) * PWTS( 1,LOOP) +
     X        OLDU(NEIGH( 2,LOOP)) * PWTS( 2,LOOP) +
     X        OLDU(NEIGH( 3,LOOP)) * PWTS( 3,LOOP) +
     X        OLDU(NEIGH( 4,LOOP)) * PWTS( 4,LOOP) +
     X        OLDU(NEIGH( 5,LOOP)) * PWTS( 5,LOOP) +
     X        OLDU(NEIGH( 6,LOOP)) * PWTS( 6,LOOP) +
     X        OLDU(NEIGH( 7,LOOP)) * PWTS( 7,LOOP) +
     X        OLDU(NEIGH( 8,LOOP)) * PWTS( 8,LOOP) +
     X        OLDU(NEIGH( 9,LOOP)) * PWTS( 9,LOOP) +
     X        OLDU(NEIGH(10,LOOP)) * PWTS(10,LOOP) +
     X        OLDU(NEIGH(11,LOOP)) * PWTS(11,LOOP) +
     X        OLDU(NEIGH(12,LOOP)) * PWTS(12,LOOP)
            V(LOOP) =
     X        OLDV(NEIGH( 1,LOOP)) * PWTS( 1,LOOP) +
     X        OLDV(NEIGH( 2,LOOP)) * PWTS( 2,LOOP) +
     X        OLDV(NEIGH( 3,LOOP)) * PWTS( 3,LOOP) +
     X        OLDV(NEIGH( 4,LOOP)) * PWTS( 4,LOOP) +
     X        OLDV(NEIGH( 5,LOOP)) * PWTS( 5,LOOP) +
     X        OLDV(NEIGH( 6,LOOP)) * PWTS( 6,LOOP) +
     X        OLDV(NEIGH( 7,LOOP)) * PWTS( 7,LOOP) +
     X        OLDV(NEIGH( 8,LOOP)) * PWTS( 8,LOOP) +
     X        OLDV(NEIGH( 9,LOOP)) * PWTS( 9,LOOP) +
     X        OLDV(NEIGH(10,LOOP)) * PWTS(10,LOOP) +
     X        OLDV(NEIGH(11,LOOP)) * PWTS(11,LOOP) +
     X        OLDV(NEIGH(12,LOOP)) * PWTS(12,LOOP)
C
C         Set missing if all neighbours are missing
C
          ELSE IF( (COUNTU.EQ.0).OR.(COUNTV.EQ.0) ) THEN
            U(LOOP) = RMISSGV
            V(LOOP) = RMISSGV
C
C         Otherwise, use the nearest neighbour
C
          ELSE
            NEAREST = 1
            IF( PWTS( 2,LOOP).GT.PWTS(NEAREST,LOOP) ) NEAREST = 2
            IF( PWTS( 3,LOOP).GT.PWTS(NEAREST,LOOP) ) NEAREST = 3
            IF( PWTS( 4,LOOP).GT.PWTS(NEAREST,LOOP) ) NEAREST = 4
            IF( PWTS( 5,LOOP).GT.PWTS(NEAREST,LOOP) ) NEAREST = 5
            IF( PWTS( 6,LOOP).GT.PWTS(NEAREST,LOOP) ) NEAREST = 6
            IF( PWTS( 7,LOOP).GT.PWTS(NEAREST,LOOP) ) NEAREST = 7
            IF( PWTS( 8,LOOP).GT.PWTS(NEAREST,LOOP) ) NEAREST = 8
            IF( PWTS( 9,LOOP).GT.PWTS(NEAREST,LOOP) ) NEAREST = 9
            IF( PWTS(10,LOOP).GT.PWTS(NEAREST,LOOP) ) NEAREST =10
            IF( PWTS(11,LOOP).GT.PWTS(NEAREST,LOOP) ) NEAREST =11
            IF( PWTS(12,LOOP).GT.PWTS(NEAREST,LOOP) ) NEAREST =12
            U(LOOP) = OLDU(NEIGH( NEAREST,LOOP))
            V(LOOP) = OLDV(NEIGH( NEAREST,LOOP))
          ENDIF
C
        ELSE IF( KSCHEME(LOOP).EQ.JP4PT ) THEN
C
C     See if any of the neighbours are missing
C
          COUNTU = 0
          IF( NOTEQ(OLDU(NEIGH( 1,LOOP)),RMISSGV) ) COUNTU = COUNTU + 1
          IF( NOTEQ(OLDU(NEIGH( 2,LOOP)),RMISSGV) ) COUNTU = COUNTU + 1
          IF( NOTEQ(OLDU(NEIGH( 3,LOOP)),RMISSGV) ) COUNTU = COUNTU + 1
          IF( NOTEQ(OLDU(NEIGH( 4,LOOP)),RMISSGV) ) COUNTU = COUNTU + 1
          COUNTV = 0
          IF( NOTEQ(OLDV(NEIGH( 1,LOOP)),RMISSGV) ) COUNTV = COUNTV + 1
          IF( NOTEQ(OLDV(NEIGH( 2,LOOP)),RMISSGV) ) COUNTV = COUNTV + 1
          IF( NOTEQ(OLDV(NEIGH( 3,LOOP)),RMISSGV) ) COUNTV = COUNTV + 1
          IF( NOTEQ(OLDV(NEIGH( 4,LOOP)),RMISSGV) ) COUNTV = COUNTV + 1
C
C         Interpolate using four neighbours if none are missing
C
          IF( (COUNTU.EQ.4).AND.(COUNTV.EQ.4) ) THEN
C
            U(LOOP) =
     X        OLDU(NEIGH( 1,LOOP)) * PWTS( 1,LOOP) +
     X        OLDU(NEIGH( 2,LOOP)) * PWTS( 2,LOOP) +
     X        OLDU(NEIGH( 3,LOOP)) * PWTS( 3,LOOP) +
     X        OLDU(NEIGH( 4,LOOP)) * PWTS( 4,LOOP)
            V(LOOP) =
     X        OLDV(NEIGH( 1,LOOP)) * PWTS( 1,LOOP) +
     X        OLDV(NEIGH( 2,LOOP)) * PWTS( 2,LOOP) +
     X        OLDV(NEIGH( 3,LOOP)) * PWTS( 3,LOOP) +
     X        OLDV(NEIGH( 4,LOOP)) * PWTS( 4,LOOP)
C
C         Set missing if all neighbours are missing
C
          ELSE IF( (COUNTU.EQ.0).OR.(COUNTV.EQ.0) ) THEN
            U(LOOP) = RMISSGV
            V(LOOP) = RMISSGV
C
C         Otherwise, use the nearest neighbour
C
          ELSE
            NEAREST = 1
            IF( PWTS( 2,LOOP).GT.PWTS(NEAREST,LOOP) ) NEAREST = 2
            IF( PWTS( 3,LOOP).GT.PWTS(NEAREST,LOOP) ) NEAREST = 3
            IF( PWTS( 4,LOOP).GT.PWTS(NEAREST,LOOP) ) NEAREST = 4
            U(LOOP) = OLDU(NEIGH( NEAREST,LOOP))
            V(LOOP) = OLDV(NEIGH( NEAREST,LOOP))
          ENDIF
C
        ELSE
          DO NEXT = 1, 4
            IF( NEIGH(NEXT,LOOP).NE.0 ) THEN
              U(LOOP) = OLDU(NEIGH(NEXT,LOOP))
              V(LOOP) = OLDV(NEIGH(NEXT,LOOP))
            ENDIF
          ENDDO
C
        ENDIF
      ENDDO
C
C     -----------------------------------------------------------------|
C     Section 5.  Adjust the U and V components to new (rotated) axes
C     -----------------------------------------------------------------|
C
  500 CONTINUE
C
      DO LOOP = 1, NLEN
        RDIR(LOOP) = 0.0
      ENDDO
C
      CALL HPSHGPW(RLON,RLAT,RCLON,RCLAT,RDIR,NLEN,POLE)
C
      DO LOOP = 1, NLEN
        RDIR(LOOP) = -RADIAN(RDIR(LOOP))
      ENDDO
C
      DO LOOP = 1, NLEN
        C(LOOP) = COS(RDIR(LOOP))
        S(LOOP) = SIN(RDIR(LOOP))
      ENDDO
C
      DO LOOP = 1, NLEN
        IF( NOTEQ(U(LOOP),RMISSGV).AND.NOTEQ(V(LOOP),RMISSGV) ) THEN
          NEWFLDU(LOOP) = U(LOOP)*C(LOOP) - V(LOOP)*S(LOOP)
          NEWFLDV(LOOP) = U(LOOP)*S(LOOP) + V(LOOP)*C(LOOP)
        ELSE
          NEWFLDU(LOOP) = RMISSGV
          NEWFLDV(LOOP) = RMISSGV
        ENDIF
      ENDDO
C
C     -----------------------------------------------------------------|
C     Section 9.  Return.
C     -----------------------------------------------------------------|
C
  900 CONTINUE
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      INTEGER FUNCTION IAINIT (KPR, KERR)
C
C---->
C**** *IAINIT*
C
C     PURPOSE
C     _______
C
C     Initialise common decks for grid-pt to grid-pt interpolation.
C
C     INTERFACE
C     _________
C
C     IERR = IAINIT (KPR, KERR)
C
C     Input parameters
C     ________________
C
C     KPR        - The debug print switch.
C                  0  , No debugging output.
C                  1  , Produce debugging output.
C
C     KERR       - The error control flag.
C                  -ve, No error message. Return error code.
C                  0  , Hard failure with error message.
C                  +ve, Print error message. Return error code.
C
C     Output parameters
C     ________________
C
C     None
C
C     Return value
C     ____________
C
C     The error indicator (INTEGER).
C
C     Error and Warning Return Values
C     _______________________________
C
C     None
C
C     Common block usage
C     __________________
C
C     grfixed.h    - The include file contains all the array space
C                    for grid to grid interpolation.
C
C     MILLEN       - The array of latitude line lengths for a quasi
C                    regular Gaussian grid is set.
C
C     memreq.h     - This file contains the memory request
C                    definition variables.
C
C     MADDR        - The base addresses of the currently allocated
C                    memory segments are set.
C     MREQUEST     - The sizes of the current memory requests are set.
C
C
C     EXTERNALS
C     _________
C
C     INTLOG   - Logs messages.
C
C     METHOD
C     ______
C
C     Initialise common decks for grid-pt to grid-pt interpolation:
C                - memory access arrays,
C                - quasi regular definition.
C
C     REFERENCE
C     _________
C
C     None
C
C     COMMENTS
C     ________
C
C     None.
C
C     AUTHOR
C     ______
C
C     K. Fielding      *ECMWF*      Apr 1994
C
C     MODIFICATIONS
C     _____________
C
C     J.D.Chambers      ECMWF       Aug 1994
C
C----<
C     _______________________________________________________
C
C
C*    Section 0. Definition of variables.
C     _______________________________________________________
C
C*    Prefix conventions for variable names
C
C     Logical      L (but not LP), global or common.
C                  O, dummy argument
C                  G, local variable
C                  LP, parameter.
C     Character    C, global or common.
C                  H, dummy argument
C                  Y (but not YP), local variable
C                  YP, parameter.
C     Integer      M and N, global or common.
C                  K, dummy argument
C                  I, local variable
C                  J (but not JP), loop control
C                  JP, parameter.
C     REAL         A to F and Q to X, global or common.
C                  P (but not PP), dummy argument
C                  Z, local variable
C                  PP, parameter.
C
C     Implicit statement to force declarations
C
      IMPLICIT NONE
C
#include "parim.h"
#include "memreq.h"
#include "nifld.common"
#include "nofld.common"
#include "grfixed.h"
C
C     Dummy arguments
C
      INTEGER KPR, KERR
C
C     Local variables
C
      INTEGER JSET
C
      INTEGER JPROUTINE
C
      PARAMETER (JPROUTINE = 21100)
C
C     External functions
C
C     Transform definition variables that must be preserved
C
C
C     _______________________________________________________
C
C
C*    Section 1. Initialisation
C     _______________________________________________________
C
  100 CONTINUE
C
      IF (KPR .GE. 1) CALL INTLOG(JP_DEBUG,'IAINIT: Section 1.',JPQUIET)
C
      IAINIT = 0
C
      IF (KPR .GE. 1) CALL INTLOG(JP_DEBUG,
     X  'IAINIT : Grid-pt to grid-pt common decks initialised',JPQUIET)
C
C     _______________________________________________________
C
C
C*    Section 2. Initialise memory access arrays.
C     _______________________________________________________
C
  200 CONTINUE
C
      IF (KPR .GE. 1) CALL INTLOG(JP_DEBUG,'IAINIT: Section 2.',JPQUIET)
C
      DO 210 JSET = 1, JPLEVEL
         MREQUEST (JSET) = 0
         MADDR (JSET) = 0
  210 CONTINUE
C
C     _______________________________________________________
C
C
C*    Section 3. Initialise quasi regular definition
C     _______________________________________________________
C
  300 CONTINUE
C
      IF (KPR .GE. 1) CALL INTLOG(JP_DEBUG,'IAINIT: Section 3.',JPQUIET)
C
      DO 310 JSET = 1, JPLAT
         MILLEN (JSET) = 0
  310 CONTINUE
C
C     _______________________________________________________
C
C
C*    Section 9. Return to calling routine. Format statements
C     _______________________________________________________
C
  900 CONTINUE
C
      IF (KPR .GE. 1) CALL INTLOG(JP_DEBUG,'IAINIT: Section 9.',JPQUIET)
C
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities
C granted to it by virtue of its status as an intergovernmental organisation
C nor does it submit to any jurisdiction.
C
      PROGRAM HSP2GG_TESTS
      IMPLICIT NONE

C     Externals
      INTEGER HSP2GG, HSP2GG2, HSP2GG3

C     Local variables
      INTEGER IRET(3)
      INTEGER KTRUNC, KGAUSS, KSIZE
      INTEGER KPTS(96)
      REAL LL(2), PLATS(96)

      IRET = 0

      KTRUNC = 63  ! input
      KGAUSS = 0   ! output
      KPTS  = 0
      PLATS = 0.
      IRET(1) = HSP2GG(KTRUNC,KGAUSS,KPTS,PLATS,KSIZE)
      IF (IRET(1).EQ.0) THEN
          PRINT *, 'HSP2GG in:  KTRUNC = ', KTRUNC
          PRINT *, 'HSP2GG out: KGAUSS = ', KGAUSS
          IF (KGAUSS.NE.48)   IRET(1) = -1
          IF (KSIZE.NE.13280) IRET(1) = -2
      ENDIF

      LL(:)  = 2.5  ! input
      KGAUSS = 0    ! output
      KTRUNC = 0    ! output
      KPTS  = 0
      PLATS = 0.
      IRET(2) = HSP2GG2(KTRUNC,LL(1),LL(2),KGAUSS,KPTS,PLATS,KSIZE)
      IF (IRET(2).EQ.0) THEN
          PRINT *, 'HSP2GG2 in:  NS/EW  = ', LL(1:2)
          PRINT *, 'HSP2GG2 out: KGAUSS = ', KGAUSS
          PRINT *, 'HSP2GG2 out: KTRUNC = ', KTRUNC
          IF (KTRUNC.NE.63)   IRET(2) = -3
          IF (KGAUSS.NE.48)   IRET(2) = -4
          IF (KSIZE.NE.13280) IRET(1) = -2
      ENDIF

      KGAUSS = 48  ! input
      KTRUNC = 0   ! output
      KPTS  = 0
      PLATS = 0.
      IRET(3) = HSP2GG3(KTRUNC,KGAUSS,KPTS,PLATS,KSIZE)
      IF (IRET(3).EQ.0) THEN
          PRINT *, 'HSP2GG3 in:  KGAUSS = ', KGAUSS
          PRINT *, 'HSP2GG3 out: KTRUNC = ', KTRUNC
          IF (KTRUNC.NE.95)   IRET(3) = -6
          IF (KSIZE.NE.13280) IRET(1) = -2
      ENDIF

      IF ( IRET(1).NE.0 .OR.
     .     IRET(2).NE.0 .OR.
     .     IRET(3).NE.0 ) CALL EXIT(-1)
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C


      SUBROUTINE SORT (BLOCK,NOF,UN,IRETR,NBIT)
C
C---->
C**********************************************************************
C*                                                                    *
C*    NAME      : SORT                                                *
C*                                                                    *
C*    FUNCTION  : SORTS AN ARRAY IN ASCENDING FIELD CODE-NUMBER       *
C*                AND WRITES THE FIELD TO GIVEN UNIT NUMBER.          *
C*                                                                    *
C*    INPUT     : BLOCK = INPUT ARRAY CONTAINING FIELDS.              *
C*                NOF   = NO OF FIELDS                                *
C*                UN    = OUTPUT FILE FOR SORTED FIELDS.              *
C*                NBIT  = NO OF BITS PER WORD                         *
C*                                                                    *
C*    OUTPUT    : IRETR  >  0     NO. OF RECORDS WRITTEN              *
C*                       <  0     ERRORS REPORTED BY SUBROUTINES      *
C*                       = -200   BUFFER OUT ERROR                    *
C*                BLOCK - RECORDS ARE ALTERED . FIELD-CODE OCTETS     *
C*                        ARE SET TO 0 !!!!!                          *
C*                                                                    *
C*    GENERAL   : SORT    CALLS RECLEN                                *
C*                              SBYTE                                 *
C*                                                                    *
C*    AUTHOR    : B.V. GURETZKY  V.E. DAY                             *
C*                                                                    *
C*    MODIFIED  : J. HENNESSY    26.11.85                             *
C*                                                                    *
C**********************************************************************
C----<
C
      IMPLICIT INTEGER (B,U)
      DIMENSION BLOCK(*)
C
      DATA IPR /1/
C
C     RETURN IF NUMBER OF FIELDS NOT MORE THAN 0.
C
      IF (NOF.LE.0) RETURN
C
C     ONLY 1 FIELD SUPPLIED
C
      IF (NOF.EQ.1)
     C  THEN
            CALL RECLEN (BLOCK(1),LEN,NBIT,ICODE,INDIC,LEVEL,JERR)
            IF (JERR.NE.0)
     C         THEN
                   IRETR = JERR
                   RETURN
               ENDIF
            LEN = LEN / 8
            BUFFER OUT (UN,0) (BLOCK(1),BLOCK(LEN))
            IUNIT = UNIT(UN)
            IF (IUNIT.GT.0) GO TO 10000
            IRETR = IRETR + 1
            RETURN
        ENDIF
C
C
C     LOOP THROUGH FIELDS SUPPLIED TO FIND THE ONE WITH
C     THE NEXT HIGHEST FIELD CODE.
C
      DO 2000 I = 1,NOF
C
         IB              = 0
         LENEXTR         = 0
         IOFFEXT         = 0
         ICODEXT         = 999
C
         DO 1000 J = 1,NOF
C
C           GET LENGTH OF FIELD RECORD.
C
            CALL RECLEN  (BLOCK(IB+1),LEN,NBIT,ICODE,INDIC,LEVEL,JERR)
            IF (JERR.NE.0)
     C         THEN
                   IRETR = JERR
                   RETURN
               ENDIF
            LEN = LEN / 8
C
            IF ((ICODE.LT.ICODEXT).AND.(ICODE.NE.0))
     C         THEN
                   LENEXTR   = LEN
                   IOFFEXT   = IB
                   ICODEXT   = ICODE
               ENDIF
            IB = IB + LEN
C
 1000    CONTINUE
C
C        WRITE FIELD
C
         LEN = IOFFEXT + LENEXTR
         BUFFER OUT(UN,0) (BLOCK(IOFFEXT+1),BLOCK(LEN))
         CALL RECLEN (BLOCK(IOFFEXT+1),LEN,NBIT,ICODE,INDIC,LEVEL,JERR)
            IF (JERR.NE.0)
     C         THEN
                   IRETR = JERR
                   RETURN
               ENDIF
         IUNIT = UNIT(UN)
         IF (IPR.EQ.1) WRITE (*,9101) LEVEL,ICODE
 9101    FORMAT (1H ,'LEVEL ',I5,' FIELD ',I5)
         IF (ICODE.LT.127.OR.ICODE.GT.255)
     C      THEN
                WRITE (*,*) 'SORT : INVALID FIELD CODE.'
                CALL ABORT
            ENDIF
C
         IF (IUNIT.GT.0) GO TO 10000
C
C        SET  CODE-TYPE TO ZERO TO INDICATE
C        THAT FIELD HAS ALREADY BEEN WRITTEN
C
         IZERO = 0
         CALL SBYTE (BLOCK(IOFFEXT+2),IZERO,32,8)
         IRETR = IRETR + 1

 2000 CONTINUE

      RETURN
10000 CONTINUE

      IRETR = -200
      WRITE (*,*) ' SORT : BUFFER OUT ERROR.'
C
      RETURN
C
      END

C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C


      SUBROUTINE MXMN(PARR,KLEN,PMAX,PMIN)
C
C---->
C**   *SUBROUTINE* *MXMN* - *FIND THE MAXIMUM AND MINIMUM ELEMENTS OF
C                       AN ARRAY
C
C          *JAN *HASELER     *ECMWF*     6/10/82
C
C     PURPOSE
C     -------
C
C          *FIND THE MAXIMUM AND MINIMUM ELEMENTS OF THE ARRAY *PARR*
C
C     INTERFACE
C     ---------
C
C           *CALL* *MXMN(PARR,KLEN,PMAX,PMIN)*
C
C     WHERE *PARR(KLEN)* = INPUT ARRAY
C           *PMAX*       = OUTPUT MAXIMUM ELEMENT OF *PARR*
C           *PMIN*       = OUTPUT MINIMUM ELEMENT OF *PARR*
C
C     *MXMN* IS CALLED FROM SUBROUTINES *OUTSHC,* *OUTSHG,* *OUT2D* AND
C     *OUTDIA*
C
C     RESULTS
C     -------
C
C          *THE VALUES *PMAX* AND *PMIN* ARE RETURNED
C
C     EXTERNALS
C     ---------
C
C          *ISMAX* - *CAL* FUNCTION TO FIND MAX ARRAY ELEMENT
C          *ISMIN* - *CAL* FUNCTION TO FIND MIN ARRAY ELEMENT
C
C     ------------------------------------------------------------------
C----<
C
      DIMENSION PARR(KLEN)
C
C-----------------------------------------------------------------------
C*
C          1.           FIND MAX AND MIN
C                       ----------------
C
  100 CONTINUE
C
C*            1.1       SEARCH THROUGH 4096 ELEMENTS AT A TIME
  110 CONTINUE
      ZMIN=PARR(1)
      ZMAX=PARR(1)
      ID=1
      I1=KLEN/4096
      I2=KLEN-I1*4096
C
      DO 115 J=1,I1
      IX=ISMAX(4096,PARR(ID),1)+ID-1
      IN=ISMIN(4096,PARR(ID),1)+ID-1
      ZMAX=AMAX1(ZMAX,PARR(IX))
      ZMIN=AMIN1(ZMIN,PARR(IN))
      ID=ID+4096
  115 CONTINUE
C
C
C*            1.2       REMAINING ELEMENTS
  120 CONTINUE
      IF (I2.GT.0) THEN
           IX=ISMAX(I2,PARR(ID),1)+ID-1
           IN=ISMIN(I2,PARR(ID),1)+ID-1
           ZMAX=AMAX1(ZMAX,PARR(IX))
           ZMIN=AMIN1(ZMIN,PARR(IN))
      ENDIF
C
      PMIN=ZMIN
      PMAX=ZMAX
C
      RETURN
      END

!
! Copyright 1981-2016 ECMWF.
!
! This software is licensed under the terms of the Apache Licence
! Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
!
! Unless required by applicable law or agreed to in writing, software
! distributed under the License is distributed on an "AS IS" BASIS,
! WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
!
! In applying this licence, ECMWF does not waive the privileges and immunities
! granted to it by virtue of its status as an intergovernmental organisation
! nor does it submit to any jurisdiction.
!
PROGRAM EXAMPLE_INTF

  USE grib_api
  IMPLICIT NONE
  INTEGER, DIMENSION(4)                       :: INTV
  REAL, DIMENSION(4)                          :: REALV
  CHARACTER(Len=20), DIMENSION(4)             :: CHARV

  INTEGER (KIND=4), DIMENSION(1)              :: INGRIB(1), NEWFLD(1)

  INTEGER                                     :: IUNIT1, IUNIT2
  INTEGER                                     :: IGRIB
  INTEGER                                     :: IRET, NARGS
  INTEGER (KIND=KINDOFINT)                    :: INLEN, NEWLEN
  INTEGER                                     :: J
  INTEGER                                     :: NRESOL
  INTEGER                                     :: Ni, Nj
  INTEGER                                     :: IBPV
  INTEGER                                     :: len_in, len_out
  INTEGER                                     :: IPARAM, ITABLE
  REAL, DIMENSION(:), ALLOCATABLE             :: VALUES_IN, VALUES_OUT
  REAL                                        :: DLAT, DLON
  REAL                                        :: VALMISS

!     Externals
  INTEGER                                     :: INTIN, INTOUT, INTF, IARGC

  CHARACTER(Len=128)                          :: INFILE, OUTFILE
  CHARACTER(Len=128), DIMENSION(20)           :: CARG
  CHARACTER(Len=128)                          :: MESSAGE = ' '
  CHARACTER(Len=32)                           :: CINGRIDT = ' ', CINGRIDN = ' '

! **********************************************************************
! Default values

  IBPV = 16          ! bitsPerValue / accuracy
  NRESOL = 0         ! Gaussian resolution
  DLAT = 0.5         ! Latitude increment (in degrees)
  DLON = 0.5         ! Longitude increment (in degrees)
  VALMISS = -99999.9 ! Missing value indicator

!     Pick up file names from command line.

  NARGS = 0
  NARGS = IARGC()
  IF ( NARGS .NE. 4) THEN
     PRINT *, 'NARGS is incorrect'
     CALL USAGE
     STOP
  END IF

  DO J = 1, NARGS
     CALL GETARG(J,CARG(J))
  END DO

  DO J = 1, NARGS,2
    IF (CARG(J) == '-i') THEN
      INFILE=TRIM(CARG(J+1))
    ELSEIF (CARG(J) == '-o') THEN
      OUTFILE=TRIM(CARG(J+1))
    ELSE
      CALL USAGE
      STOP
    END IF
  END DO

  PRINT *, '*** Open input and output files'

  CALL GRIB_OPEN_FILE (IUNIT1, INFILE, 'r', IRET)
  IF ( IRET /= GRIB_SUCCESS) STOP ' GRIB_OPEN of INFILE failed'

  CALL GRIB_OPEN_FILE (IUNIT2, OUTFILE, 'w', IRET)
  IF ( IRET /= GRIB_SUCCESS) STOP ' GRIB_OPEN of OUTFILE failed'

  PRINT *, '*** Start of loop through input GRIB-coded fields'

  CALL GRIB_NEW_FROM_FILE(IUNIT1, IGRIB, IRET)

  LOOP: DO WHILE (IRET /= GRIB_END_OF_FILE)

    IF (IRET /= GRIB_SUCCESS) THEN
      PRINT *, ' GRIB_NEW_FROM_FILE failed with error code = ', IRET
      CALL GRIB_GET_ERROR_STRING(IRET,MESSAGE)
      PRINT *, TRIM(MESSAGE)
      PRINT *, 'Skipping to next message ...'
      CALL GRIB_NEW_FROM_FILE(IUNIT1, IGRIB, IRET)
      CYCLE
    ENDIF

    PRINT *, '*** Unpack the values in the input GRIB'

    CALL GRIB_GET_SIZE(IGRIB,'values',len_in)
    PRINT *,  '     Allocating array for input field of size=',len_in
    ALLOCATE(VALUES_IN(len_in))
    CALL GRIB_SET(IGRIB,'missingValue',VALMISS)
    CALL GRIB_GET(IGRIB,'values',VALUES_IN)

! Define the input field via calls to INTIN
    CHARV(1) = 'unpacked'
    IRET = INTIN('form',INTV, REALV, CHARV)
    IF ( IRET /= 0 ) THEN
      PRINT *,  ' INTIN failed to set format'
      STOP
    ENDIF

! Get parameter information (assumes unportable ParamId structure)
    CALL GRIB_GET(IGRIB,'paramId',IPARAM)
    ITABLE = 128
    IF (IPARAM.GT.1000) THEN
      ITABLE = IPARAM / 1000
      IPARAM = MOD(IPARAM,1000)
    ENDIF

    INTV(1) = ITABLE
    IRET = INTIN('table',INTV, REALV, CHARV)
    IF ( IRET /= 0 ) THEN
      PRINT *, ' INTIN failed to set table'
      STOP
    ENDIF

    INTV(1) = IPARAM
    IRET = INTIN('parameter',INTV, REALV, CHARV)
    IF ( IRET /= 0 ) THEN
      PRINT *, ' INTIN failed to set parameter'
      STOP
    ENDIF

! Check it's a Gaussian grid and set resolution
    CALL GRIB_GET(IGRIB,'gridType',CINGRIDT)
    IF ((TRIM(CINGRIDT) ==  'regular_gg') .OR. &
        (TRIM(CINGRIDT) ==  'reduced_gg')) THEN
      CALL GRIB_GET(IGRIB,'gridName',CINGRIDN)
      CHARV(1) = CINGRIDN(1:20)
      PRINT *, '     gridName = ', CHARV(1)
      IRET = INTIN('gridname',INTV, REALV, CHARV)
      IF ( IRET /= 0 ) THEN
        PRINT *, ' INTIN failed to set gridname'
        STOP
      ENDIF
    ELSE
      PRINT *, 'Input grid type ', TRIM(CINGRIDT), ' not regular_gg/reduced_gg'
      CYCLE
    ENDIF

! Set the missing value
    CHARV(1) = 'yes'
    REALV(1) = VALMISS
    IRET = INTIN('missingvalue',INTV, REALV, CHARV)
    IF ( IRET /= 0 ) THEN
      PRINT *, ' INTIN failed to set missingValue'
      STOP
    ENDIF

! Define the output field with calls to INTOUT
    CHARV(1) = 'unpacked'
    IRET = INTOUT('form',INTV, REALV, CHARV)
    IF ( IRET /= 0 ) THEN
      PRINT *, ' INTOUT failed to set format'
      STOP
    ENDIF

    PRINT *, '*** Define the grid interval for the new field(s)'
    REALV(1) = DLAT
    REALV(2) = DLON
    IRET = INTOUT('grid', INTV, REALV, CHARV)
    IF ( IRET /= 0 ) THEN
      PRINT *, ' INTOUT failed to set grid resolution'
      STOP
    ENDIF
    PRINT *, '    GRID TYPE = lat-lon'
    PRINT *, '    RESOL = ', REALV(1), 'x', REALV(2)

! Calculate the number of points (assumes global grid)
    Ni = INT(360.0/REALV(2))
    Nj = INT(180.0/REALV(1)) + 1
    len_out = Ni*Nj
    PRINT *, '    Allocating output array of size = ', len_out
    ALLOCATE(VALUES_OUT(LEN_OUT))

! Define the packing accuracy for the new field(s).
    INTV(1) = IBPV
    IRET = INTOUT('accuracy', INTV, REALV, CHARV)
    IF ( IRET /= 0 ) THEN
      PRINT *, ' INTOUT failed to set accuracy'
      STOP
    ENDIF
    PRINT *, '    ACCURACY = ', IBPV

    PRINT *, '*** Interpolate'
    INLEN =1
    NEWLEN = 1
    IRET = INTF(INGRIB,len_in,VALUES_IN,NEWFLD,len_out,VALUES_OUT)
    IF ( IRET /= 0 ) THEN
      WRITE(*,*) ' INTF failed for product '
      WRITE(*,*) ' Skipping to next message ...'
      CALL GRIB_RELEASE(IGRIB)
      DEALLOCATE(VALUES_IN,VALUES_OUT)
      CYCLE
    ENDIF

    PRINT *, '*** Set-up and write output GRIB'

    CALL GRIB_SET(IGRIB,'gridType','regular_ll')
    CALL GRIB_SET(IGRIB,'latitudeOfFirstGridPointInDegrees',90.0)
    CALL GRIB_SET(IGRIB,'latitudeOfLastGridPointInDegrees',-90.0)
    CALL GRIB_SET(IGRIB,'longitudeOfFirstGridPointInDegrees',0.0)
    CALL GRIB_SET(IGRIB,'longitudeOfLastGridPointInDegrees',360.0 - DLON)
    CALL GRIB_SET(IGRIB,'iDirectionIncrementInDegrees',DLON)
    CALL GRIB_SET(IGRIB,'jDirectionIncrementInDegrees',DLON)
    CALL GRIB_SET(IGRIB,'bitsPerValue',IBPV)
    CALL GRIB_SET(IGRIB,'Ni',Ni)
    CALL GRIB_SET(IGRIB,'Nj',Nj)
    CALL GRIB_SET(IGRIB,'values',VALUES_OUT)
    CALL GRIB_WRITE(IGRIB,IUNIT2)

!   Free the memory.
    CALL GRIB_RELEASE(IGRIB)
    DEALLOCATE(VALUES_IN, VALUES_OUT)

!   Loop back for next product.
    CALL GRIB_NEW_FROM_FILE(IUNIT1, IGRIB, IRET)

  END DO LOOP

! Close input and output files.
  CALL GRIB_CLOSE_FILE(IUNIT1, IRET)
  CALL GRIB_CLOSE_FILE(IUNIT2, IRET)

  STOP

CONTAINS

  SUBROUTINE USAGE

   PRINT *, 'Usage: example_intf -i inputfile -o outputfile'
   PRINT *,  '   -i inputfile      input file name (required)'
   PRINT *,  '   -o outputfile     output file name (required)'

   RETURN

  END SUBROUTINE USAGE

END PROGRAM EXAMPLE_INTF

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE CREXETD(KPT,KTDLEN,CREXLST,KDLEN,KDATA,KSEC3,
     1             KVALS,VALUES,KELEM,KERR)
C
C**** *CREXETD*
C
C
C     PURPOSE.
C     --------
C
C          Expand Crex data descriptors
C
C
C**   INTERFACE.
C     ----------
C
C          *CALL* *CREXETD( KPT,KTDLEN,CREXLST,KDLEN,KDATA,KSEC3,
C                           KVALS,VALUES,KELEM,KERR)*
C
C        INPUT :
C               *KPT*     -  POINTER TO KDATA ARRAY
C               *KTDLEN*  -  number of data descriptors in section 1
C               *KTDLST*  -  array containing data descriptors in section 1
C               *KDLEN*   -  DIMENSION OF KDATA ARRAY
C               *KDATA*   -  ARRAY CONTAINING DATA NEEDED FOR DESCRIPTOR
C                            EXPANSION ( delayed replications)
C               *KSEC3*   -  Integer array of 4 words containing
C
C                            KSEC3( 1)-- Reserved
C                            KSEC3( 2)-- Reserved
C                            KSEC3( 3)-- number of subsets
C                            KSEC3( 4)-- Reserved
C               *KVALS    -  Integer (expected number of data values)
C               *VALUES*  -  Real*8 array of KVALS containing expanded
C                            data values
C               *KELEM*   -  dimension of CNAMES, CUNITS array
C        OUTPUT:
C               *KERR*    -  returned error code
C
C     METHOD.
C      -------
C
C          Expands list of data descriptors in section 1
C     of Crex message. Working tables for further data decoding are set,
C     list of Crex data descriptors and a list of expanded Crex data descriptors
C     according to table D reference are returned respectively.
C
C
C
C
C     EXTERNALS.
C     ----------
C
C
C     REFERENCE.
C     ----------
C
C          NONE.
C
C     AUTHOR.
C     -------
C
C          MILAN DRAGOSAVAC    *ECMWF*       07/01/2004.
C
C
C     MODIFICATIONS.
C     --------------
C
C          NONE.
C
C------------------------------------------------------------------------------------
C
      IMPLICIT LOGICAL(L,O,G), CHARACTER*8(C,H,Y)
C
C
      PARAMETER(JSUP =   9,JSEC0=   3,JSEC1= 40,JSEC2= 64 ,JSEC3=    4,
     1          JSEC4=   2,JELEM=40000,JSUBS=400,JCVAL=150 ,JBUFL=40000,
     2          JBPW =  32,JTAB =3000,JCTAB=120,JCTST=1800,JCTEXT= 200,
     3          JWORK=360000,JKEY=46)
C
C
C
      COMMON /CRWORK/ NBPT,NGS,NVIND,NBPTSEC2,RVIND,EPS,NE,IEOLD,
     1                  NC07YYY
C
      COMMON /CRTAB/ NCREXBR(JTAB),NCREXBS(JTAB)    , NCREXBDW(JTAB),
     1              NCREXDR(JTAB),NCREXDST(JTAB)   ,
     2              NCREXDL(JTAB),NCREXDSQ(JTAB*20),NCREXP(64,255)

C
C             NCREXBR     - table B,  table reference              array
C             NCREXBS     - table B,  scale                        array
C             NCREXBDW    - table B,  data width                   array
C             NCREXDR    - table D,  table reference              array
C             NCREXDST    - table D,  starting pointers            array
C             NCREXDL     - table D,  lengths                      array
C             NCREXDSQ    - table D,  list of sequence descriptors array
C
       COMMON /CRTABC/ CREXNAME(JTAB),CREXUNIT(JTAB)
C
C             CREXNAME      -  table B, ELEMENT NAME           array
C             CREXUNIT      -  table B, unit                   array
c
C
      COMMON /CRBEF / M,MM,N,JCV
C
C             M       -  Number of elements
C             MM      -  Number of elements
C             N       -  Number of data sub_sets
C             JCV     -  Number of character values
C
C
      COMMON /CRWT/ NCREXDWINC,NCREXSCAM,NCREXAFDW,NCREXWT ,ODREPF,
     2             NCREXSTACK(JELEM),NCREXWTEN(JELEM),
     3             NCREXWTR (JELEM),NCREXWTS (JELEM),
     4             NCREXWTDW(JELEM)
C
C             NCREXDWINC   -  data width increment
C             NCREXSCAM    -  scale multiplier
C             NCREXAFDW    -  augmented field data width
C             NCREXWT      -  pointer to working table
C             NCREXSTACK   -  list of data descriptors
C             ODREPF   -  replication (logical)
C             NCREXWTR     -  working table reference
C             NCREXWTS     -  working scale
C             NCREXWTDW    -  working data width
C
C
C
      COMMON /CRWTC/ CREXWTEN(JELEM),CREXWTU(JELEM)
C
C             CREXWTEN    -  working table element naame
C             CREXWTU     -  working table units
C
      CHARACTER CREXWTEN*64,CREXWTU*24
C
      COMMON /CREL/ NCREXTDLEN,NCREXTDLST(JELEM),NCREXTDEXL,
     1              NCREXTDEXP(JELEM)
C
C             NCREXTDLEN - number of Data descriptors in section 3
C             NCREXTDLST - list of Data descriptors
C             NCREXTDEXL - number of expanded Data Descriptors
C             NCREXTDEXP - list of expanded Data descriptors
C
      COMMON /CRCOFF/ NSUBSET
C
      CHARACTER*64 CREXNAME
      CHARACTER*24 CREXUNIT
      CHARACTER*(*) CREXLST(*)
C
      DIMENSION ISTACK(JELEM),IISTACK(JELEM)
C
      DIMENSION KSUP(JSUP),KSEC3(JSEC3)
C
      REAL*8 RVIND,EPS
      REAL*8 VALUES(KVALS)
c
C     ------------------------------------------------------------------
C
C*          1.   EXPAND PRELIMINARY ITEMS OF SECTION 3.
C                --------------------------------------
 100  CONTINUE
C
      IF( KERR.NE.0 ) RETURN
C
C     -----------------------------------------------------------------
C
C*          2.   EXPAND DATA DESCRIPTORS.
C                ------------------------
 200  CONTINUE
C
C
C*          2.1  CALCULATE EXPECTED NUMBER OF DATA DESCRIPTORS.
C                ----------------------------------------------
C                AND INITIALIZE NUMBER OF DATA VALUES PER SUB-SET.
C                -------------------------------------------------
 210  CONTINUE
C
      J = 0
      M = 0
      IF(NSUBSET.EQ.1) KPT=0
      NCREXWT=0 
      NCREXTDLEN=KTDLEN
C
C
C*          2.2  PUT DATA DESCRIPTORS IN STACK.
C                -----------------------------------------
 220  CONTINUE
C
      DO 221 JJ=1,KTDLEN
C
      if(CREXLST(JJ)(1:1).eq.'D') CREXLST(JJ)(1:1)='3'
      if(CREXLST(JJ)(1:1).eq.'B') CREXLST(JJ)(1:1)='0'
      if(CREXLST(JJ)(1:1).eq.'C') CREXLST(JJ)(1:1)='2'
      if(CREXLST(JJ)(1:1).eq.'R') CREXLST(JJ)(1:1)='1'
c
      IOS=0
      READ( CREXLST(JJ),'(i6.6)',IOSTAT=IOS) ISTACK(JJ)
      IF(IOS.NE.0) THEN
         PRINT*,'NCREXTDLEN=KTDLEN=',NCREXTDLEN
         PRINT*,JJ,' CREXLST(JJ)=',CREXLST(JJ)
         kerr=35
         CALL CREXERR(KERR)
         RETURN
      END IF
C
      IISTACK(JJ)=ISTACK(JJ)
C
 221  CONTINUE
C
      JMAX=NCREXTDLEN
C     ------------------------------------------------------------------
C*          2.3  GET NEXT DESCRIPTOR FROM THE STACK.
C                -----------------------------------
 230  CONTINUE
C
C
      J   = J + 1
      IF(J.GT.JMAX) GO TO 300
C
      IDD = ISTACK(J)
      IF(IDD.EQ.0)  GO TO 230
C
      IF = IDD/100000
C
C     ------------------------------------------------------------------
C*          2.4  CHECK IF IT IS REPLICATION DESCRIPTOR.
C                --------------------------------------
 240  CONTINUE
C
      IF( IF.EQ.0) THEN
C
C*          2.6  ELEMENT DESCRIPTOR, SO UPDATE WORKING TABLE.
C                --------------------------------------------
 260     CONTINUE
C
         CALL CREXEPWT(IDD,KERR)
         IF(KERR.GT.0) RETURN
C
      ELSEIF( IF.EQ.1) THEN
C
C*          2.4.1     SOLVE REPLICATION PROBLEM.
C                     --------------------------
C
C
         CALL CREXREP(KPT,KDLEN,KDATA,J,JMAX,IDD,ISTACK,KERR)
         IF(KERR.GT.0) RETURN
C
      ELSEIF( IF.EQ.2) THEN
C
C*          2.5.3 PROCESS OPERATOR.
C                 -----------------
            CALL CREXOPER(KPT,KDLEN,KDATA,J,IDD,ISTACK,KERR)
            IF(KERR.GT.0) RETURN
C
      ELSEIF( IF.EQ.3) THEN
C
C*          2.5.2 REPLACE BY LIST OF DESCRIPTORS FROM TABLE *D.
C                 ---------------------------------------------
            CALL CREXETDR(J,JMAX,IDD,ISTACK,KERR)
            IF(KERR.GT.0) THEN
               DO 252 IQ=1,JELEM
               NCREXSTACK(IQ)=0.
 252           CONTINUE
               RETURN
            END IF
      ELSE
         KERR=37
         CALL CREXERR(KERR)
         RETURN
      END IF
c
      GO TO 230
C
C     ------------------------------------------------------------------
C
C*          3. COLLECT  SUPPLEMENTARY ITEMS.
C              -----------------------------
 300  CONTINUE
C
      NCREXTDEXL =M
      DO 301 I=1,NCREXTDEXL
      NCREXTDEXP(I)=NCREXWTR(I)
 301  CONTINUE
C
      DO 302 I=1,NCREXTDLEN
      NCREXTDLST (I)=IISTACK(I)
 302  CONTINUE
C
      KSUP(3)= 4
      KSUP(5)= M
      KSUP(6)= KSEC3(3)
C
      RETURN
C
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE CREXPRS0(KSEC0)
C
C**** *CREXPRS0*
C
C
C     PURPOSE.
C     --------
C           PRINT SECTION 0 OF CREX MESSAGE.
C
C
C**   INTERFACE.
C     ----------
C
C           *CALL* *CREXPRS0(KSEC0)*
C
C        INPUT :
C               *KSEC0*   -  ARRAY CONTAINING SECTION 0 INFORMATION
C                            KSEC0( 1)-- LENGTH OF SECTION 0 (BYTES)
C                            KSEC0( 2)-- TOTAL LENGTH OF CREX MESSAGE (BYTES)
C                            KSEC0( 3)-- Crex Edition number
C
C     METHOD.
C     -------
C
C            NONE
C
C     EXTERNALS.
C     ----------
C
C            NONE.
C
C     REFERENCE.
C     ----------
C
C          NONE.
C
C     AUTHOR.
C     -------
C
C          MILAN DRAGOSAVAC    *ECMWF*       07/01/2004.
C
C     MODIFICATIONS.
C     --------------
C
C          NONE.
C
      IMPLICIT LOGICAL(L,O,G), CHARACTER*8(C,H,Y)
C
      DIMENSION KSEC0(*)
C
C     ------------------------------------------------------------------
C
C*          1.   PRINT SECTION 0.
C                ----------------
 100  CONTINUE
C
      WRITE(*,'(1H1)')
C
      WRITE(*,'(1H ,A)')    '         CREX SECTION 0    '
      WRITE(*,'(1H )')
      WRITE(*,'(1H ,A,I5)') 'LENGTH OF SECTION 0 (BYTES)         ',
     1                       KSEC0(1)
      WRITE(*,'(1H ,A,I5)') 'TOTAL LENGTH OF CREX MESSAGE (BYTES)',
     1                       KSEC0(2)
C
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

       SUBROUTINE INSCAL (PDATA,KDATA,KLEN,PREF,PSCALE,NBPV)
C
C---->
C**** INSCAL - Vectorise calculation of increments.
C
C     Purpose.
C     --------
C
C     Vectorise calculation of increments.
C
C**   Interface.
C     ----------
C
C     CALL INSCAL (PDATA,KDATA,KLEN,PREF,PSCALE,NBPV)
C
C
C     Input Parameters.
C     -----------------
C
C     PDATA      - Array of floating point values.
C     KLEN       - Number of values to be converted.
C     PREF       - Reference value.
C     PSCALE     - Scale factor.
C     NBPV       - Number of bits per packed value
C
C     Output Parameters.
C     -----------------
C
C     KDATA      - Array of integer increments
C
C     Method.
C     -------
C
C     The reference value is subtracted from each value,
C     and the result is then divided by the scale factor.
C
C     Externals.
C     ----------
C
C     None.
C
C     Reference.
C     ----------
C
C     WMO Manual on Codes re GRIB representation.
C
C     Comments.
C     --------
C
C     PDATA and KDATA are really the same array. This routine
C     is just a device to force vectorisation on the Cray,
C     without the necessity of using another array.
C
C
C     Author.
C     -------
C
C     J. Hennessy     ECMWF     25.06.91
C
C     Modifications.
C     _____________
C
C     J.D.Chambers          ECMWF     21.11.94
C     Use JNINT on VAX
C
C     J.D.Chambers          ECMWF     21.11.94
C     Check number of bits per value is not exceeded
C
C     P.J.Towers            ECMWF     18.07.02
C     Optimised for IBM Power4.
C         -Merged loops
C         -Replaced Nint(x) by Int(x+0.5)
C         -Replaced division by scale by multiplication by reciprocal
C
C     R. El Khatib / D. Paradis METEO-FRANCE 06.02.08
C         - (No conversion if the value exceeds the number of bits for
C         integers 
C
C----<
C     -----------------------------------------------------------------
C*    Section 0. Definition of variables.
C     -----------------------------------------------------------------
C
#ifdef CRAY
      IMPLICIT NONE
#endif
#include "grbcom.h"
#include "common/grprs.h"
C
      INTEGER KDATA(KLEN), NBPV, LOOP, MAXNBPV
      INTEGER INTEMAX
C
      REAL PDATA(KLEN), PREF, PSCALE
      REAL ZRECIP
      REAL ZI
      LOGICAL LPDEBUG
C
C     -----------------------------------------------------------------
C*    Section 1 . Calculation of increments.
C     -----------------------------------------------------------------
C
  100 CONTINUE
C
      LPDEBUG = ( NDBG.GE.1 )
      MAXNBPV = 2**NBPV
      ZRECIP = 1.0 / PSCALE
      IF( LPDEBUG ) THEN
        WRITE(GRPRSM,*) 'INSCAL: MAXNBPV = ', MAXNBPV
        WRITE(GRPRSM,*) 'INSCAL: PSCALE = ', PSCALE
        WRITE(GRPRSM,*) 'INSCAL: ZRECIP = ', ZRECIP
        WRITE(GRPRSM,*) 'INSCAL: PREF = ', PREF
        WRITE(GRPRSM,*) 'INSCAL: KLEN = ', KLEN
      ENDIF

#ifdef JBPW_64
      INTEMAX = 140737488355327
#else
      INTEMAX = 2147483647
#endif

      DO LOOP = 1,KLEN
#ifdef VAX
         KDATA(LOOP) = JNINT ( (PDATA(LOOP) - PREF) / PSCALE )
#else
         ZI =  (PDATA(LOOP) - PREF) * ZRECIP + 0.5
         IF (ABS(ZI) .GE. INTEMAX) THEN
            KDATA(LOOP) = MAXNBPV - 1
         ELSE
            KDATA(LOOP) =  INT ( ZI )
         ENDIF
#endif
         IF( KDATA(LOOP).GE.MAXNBPV ) KDATA(LOOP) = MAXNBPV - 1
         IF( KDATA(LOOP).LT.0 ) KDATA(LOOP) = 0
      ENDDO
C
C     -----------------------------------------------------------------
C*    Section 9. Return to calling routine.
C     -----------------------------------------------------------------
C
  900 CONTINUE
C
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE HLL2XYZ(RLAT,RLONG,X,Y,Z,INROW)
C---->
C**** HLL2XYZ
C
C     Purpose
C     -------
C
C     Converts an array of latitude/longitude values to an
C     array of (x,y,z) coordinates.
C
C
C     Interface
C     ---------
C
C     CALL HLL2XYZ(RLAT,RLONG,X,Y,Z,INROW)
C
C     Input
C     -----
C
C     RLAT  - Array of latitudes.
C     RLONG - Array of corresponding longitudes.
C     INROW - Count of latitudes/longitudes.
C
C
C     Output
C     ------
C
C     (X,Y,Z) - Array of coordinates.
C
C
C     Method
C     ------
C
C     Z axis is the polar axis directed from south to north.
C     X and Y axes are in the equatorial plane and have origin at the
C     centre of the Earth. The X axis passes through (O north, 0 east).
C
C
C     Externals
C     ---------
C
C     None.
C
C
C     Author
C     ------
C
C     J.D.Chambers     ECMWF
C
C----<
C
      IMPLICIT NONE
C
C     Subroutine arguments
C
      REAL RLAT,RLONG,X,Y,Z
      DIMENSION RLAT(*),RLONG(*),X(*),Y(*),Z(*)
      INTEGER INROW
C
C     Local variables
C
      REAL FACTOR
      DATA FACTOR/0.017453293/
      INTEGER LOOP
C
      DO LOOP = 1, INROW
        X(LOOP) = COS(RLAT(LOOP)*FACTOR) * COS(RLONG(LOOP)*FACTOR)
        Y(LOOP) = COS(RLAT(LOOP)*FACTOR) * SIN(RLONG(LOOP)*FACTOR)
        Z(LOOP) = SIN(RLAT(LOOP)*FACTOR)
      ENDDO
C
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities
C granted to it by virtue of its status as an intergovernmental organisation
C nor does it submit to any jurisdiction.
C

C     Determine if parameter is a wave direction parameter and
C     therefore requiring special interpolation treatment, given its ID
C     (warning: parameter table is not checked.)

      LOGICAL FUNCTION IS_WAVE_DIRECTION(PARAM)

      IMPLICIT NONE
      INTEGER PARAM

      IS_WAVE_DIRECTION =
     X  ((PARAM.EQ.113) .OR. !wefxd (140113, Wave energy flux mean direction)
     X   (PARAM.EQ.122) .OR. !mwd1
     X   (PARAM.EQ.125) .OR. !mwd2
     X   (PARAM.EQ.128) .OR. !mwd3
     X   (PARAM.EQ.230) .OR. !mwd
     X   (PARAM.EQ.235) .OR. !mdww
     X   (PARAM.EQ.238) .OR. !mdts
     X   (PARAM.EQ.242) .OR. !mdwi
     X   (PARAM.EQ.249))     !dwi

      END

C
C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities
C granted to it by virtue of its status as an intergovernmental organisation
C nor does it submit to any jurisdiction.
C

      INTEGER FUNCTION WAVEXX2(NPARAM, NUMLATS, NPTS,
     X                         NLATS, STEPNS, STEPWE,
     X                         OLDWAVE, NEWWAVE, NORTH, WEST, PMISS)
C
C---->
C*****WAVEXX2*
C
C     PURPOSE
C     -------
C
C     Interpolates wave fields (except 2D spectra).
C
C
C     INTERFACE
C     ---------
C
C     IRET = WAVEXX2(NPARAM, NUMLATS, NPTS,
C    X               NLATS, STEPNS, STEPWE,
C    X               OLDWAVE, NEWWAVE, NORTH, WEST, PMISS)
C
C     Input arguments
C     ---------------
C
C     NPARAM  - Parameter ID
C     NUMLATS - Input lat number north-south
C     NPTS    - Array giving number of points along each latitude
C               for input field (empty latitudes have entry 0)
C     NLATS   - Number of points N-S in new grid
C     STEPNS  - Output grid north-south resolution (degrees)
C     STEPWE  - Output grid west-east resolution (degrees)
C     OLDWAVE - Original wave field
C     NORTH   - Output grid northernmost latitude (degrees)
C     WEST    - Output grid westernmost longitude (degrees)
C     PMISS   - Missing data value
C
C     Output arguments
C     ----------------
C
C     NEWWAVE - New wave field
C
C     Function returns 0 if the interpolation was OK.
C
C
C     METHOD
C     ------
C
C     Builds the index of neighbouring points for the output grid.
C     Then works through the output grid points, checking for subarea
C     boundaries and looking up neighbouring point values and weights
C     (which may be missing data).
C
C
C     EXTERNALS
C     ---------
C
C     WAVEIDX - Determines which nearest neighbour points to use for
C               interpolating to new output grid point
C     NUMPTWE - Calculates number of grid points between west/east
C               area boundaries
C     INTLOG  - Log error message
C     JMALLOC - Dynamically allocate memory (deallocation -JFREE- not used)
C
C
C     REFERENCE
C     ---------
C
C     None.
C
C
C     Author.
C     -------
C
C     S. Curic      ECMWF    Jun 2009
C
C
C
C----<
C
      IMPLICIT NONE
C
C     Parameters
C
#include "parim.h"
C
      INTEGER JPROUTINE, JPMXLAT,
     X        JPNW, JPNE, JPSW, JPSE, JPN, JPS,
     X        JPDISNW, JPDISNE, JPDISSW, JPDISSE
      PARAMETER( JPROUTINE = 40100 )
      PARAMETER( JPMXLAT   =  1801 ) ! allow up to 0.1 degree resolution
      PARAMETER( JPNW=1, JPNE=2, JPSW=3, JPSE=4, JPN=5, JPS=6,
     X           JPDISNW=7, JPDISNE=8, JPDISSW=9, JPDISSE=10 )
C
#include "nifld.common"
#include "nofld.common"
#include "grspace.h"
C
C     Arguments
C
      INTEGER NPARAM
      INTEGER NUMLATS, NPTS(*), NLATS
      REAL STEPNS, STEPWE, OLDWAVE(*), NEWWAVE(*), NORTH, WEST, PMISS
C
C     Local variables
C
      INTEGER IEOFSET, INDEX, ISTART, IWEST, IWOFSET, KNEWNUM,
     X        KOLDNUM, LOOP, MISSLAT, NCOL, NEXT,
     X        NEXTWV, NROW, NUMNEW(JPMXLAT)
      REAL    AWEST, EAST, NEWLATS(JPMXLAT), OLDLATS(JPMXLAT),
     X        ONORTH, OSOUTH, PTLAT, PTLONG, RLATINC, ROWINC,
     X        SOUTH, OEAST, OWEST
      INTEGER INE, INW, ISE, ISW
      LOGICAL LDIREC
      REAL    C1, C2, CC, CNE_PT, CNW_PT, CSE_PT, CSW_PT, DI1N, DI1S,
     X        DI2N, DI2S, DISNE, DISNW, DISSE, DISSW, DK1, DK2, NE_PT,
     X        NW_PT, RAD, S1, S2, SE_PT, SNE_PT, SNW_PT, SS, SSE_PT,
     X        SSW_PT, SW_PT, U1, U2
C
      DATA RAD/0.01745329251/
C
C     Large, resolution-dependent arrays
C
      LOGICAL IS_ALLOCATED_LARGEARRAY
      DATA    IS_ALLOCATED_LARGEARRAY /.FALSE./
      SAVE    IS_ALLOCATED_LARGEARRAY
C
      INTEGER NEWIDX(4,JPARRAYDIM_WAVE)
#ifndef _CRAYFTN
#ifdef POINTER_64
      INTEGER*8 P_NEWIDX
#endif
#endif
      POINTER(P_NEWIDX,NEWIDX)
      SAVE P_NEWIDX
C
      REAL*4 DISTNEW(10,JPARRAYDIM_WAVE)
#ifndef _CRAYFTN
#ifdef POINTER_64
      INTEGER*8 P_DISTNEW
#endif
#endif
      POINTER(P_DISTNEW,DISTNEW)
      SAVE P_DISTNEW
C
C     Externals
C
      INTEGER  WAVEIDX, NUMPTWE
#ifdef POINTER_64
      INTEGER*8 JMALLOC
#else
      INTEGER JMALLOC
#endif
      LOGICAL IS_WAVE_DIRECTION
      EXTERNAL WAVEIDX, NUMPTWE, JMALLOC, IS_WAVE_DIRECTION
C
C     -----------------------------------------------------------------|
C*    Section 1. Initalisation.
C     -----------------------------------------------------------------|
C
  100 CONTINUE
C
      WAVEXX2 = 0
C
C     Initialise the bitmap value lookup function
C
      MISSLAT = 0

      ONORTH = FLOAT(NIAREA(1))/PPMULT
      OSOUTH = FLOAT(NIAREA(3))/PPMULT
      RLATINC = FLOAT(NIGRID(2))/PPMULT
C
C     Calculate number of latitudes if grid had been full from
C     North pole to South pole
C
      IF( NUMLATS.GT.JPMXLAT ) THEN
        CALL INTLOG(JP_ERROR,
     X    'WAVEXX2: Number of latitudes in input grid = ',NUMLATS)
        CALL INTLOG(JP_ERROR,
     X    'WAVEXX2: And is greater than allowed maximum = ',JPMXLAT)
        WAVEXX2 = JPROUTINE + 1
        GOTO 900
      ENDIF
C
C
C     Fill an array with the number of points at each latitude for the
C     input field.
C
      IF(NIREPR.EQ.JPREDLL) THEN
C
C       Input field is a reduced latitude/longitude grid
C
C       .. but it may be 'pseudo-gaussian' in layout
C       (ie global, symmetric about the equator but no latitude
C        at the equator)
C
        IF( (ONORTH.NE.90.0).AND.(MOD(NUMLATS,2).EQ.0) ) THEN
C
          ONORTH = FLOAT(NIAREA(1))
          OSOUTH = FLOAT(NIAREA(3))
          RLATINC = FLOAT(NIGRID(2))

          DO LOOP = 1, NUMLATS
cs            OLDLATS(LOOP) = ONORTH - (LOOP-1)*RLATINC
            OLDLATS(LOOP) = (ONORTH - (LOOP-1)*RLATINC)/PPMULT
          ENDDO

          DO LOOP = 1, NUMLATS
            OLDLATS(LOOP) = 90.0 - (LOOP-1)*RLATINC
          ENDDO
C
        ELSE
C
          DO LOOP = 1, NUMLATS
            OLDLATS(LOOP) = 90.0 - (LOOP-1)*RLATINC
          ENDDO
cs-----------------------------------------------------
cs          MISSLAT = (9000000 - NIAREA(1) )/NIGRID(2)
cs          DO LOOP = 1, MISSLAT
cs            NPTS(LOOP)    = 0
cs          ENDDO
cs          KOLDNUM = 1 + (9000000 - NIAREA(3))/NIGRID(2)
cs          DO LOOP = 1, (KOLDNUM-MISSLAT)
cs            print*,LOOP+MISSLAT, NPTS(LOOP+MISSLAT)
cs            NPTS(LOOP+MISSLAT) = ISEC2(22+LOOP)
cs          ENDDO
cs          DO LOOP = (KOLDNUM+1), NUMLATS
cs            print*,'to set 0 ', loop, NPTS(LOOP)
cs            NPTS(LOOP)    = 0
cs          ENDDO
cs-----------------------------------------------------

C
        ENDIF
C
      ELSE
C
C       Input field is a regular latitude/longitude grid
C
C
        DO LOOP = 1, NUMLATS
          OLDLATS(LOOP) = 90.0 - (LOOP-1)*RLATINC
        ENDDO
C
        MISSLAT = (90.0 - ONORTH)/RLATINC
        KOLDNUM = 1 + NINT((90.0 - OSOUTH)/RLATINC)
C
        DO LOOP = 1, MISSLAT
          NPTS(LOOP)    = 0
        ENDDO
        DO LOOP = 1, (KOLDNUM-MISSLAT)
          NPTS(LOOP+MISSLAT) = NIWE
        ENDDO
        DO LOOP = (KOLDNUM+1), NUMLATS
          NPTS(LOOP)    = 0
        ENDDO
      ENDIF
C
C     Allocate large, resolution-dependent arrays
      IF (.NOT. IS_ALLOCATED_LARGEARRAY) THEN
        P_NEWIDX  = JMALLOC( 4*JPARRAYDIM_WAVE*JPBYTES)  !  4*len*bytes
        P_DISTNEW = JMALLOC(10*JPARRAYDIM_WAVE*4)        ! 10*len*bytes
        IF( (P_NEWIDX.EQ.0) .OR. (P_DISTNEW.EQ.0) ) THEN
          CALL INTLOG(JP_ERROR,'WAVEXX2: JMALLOC fail',JPQUIET)
          WAVEXX2 = JPROUTINE + 1
          GOTO 900
        ENDIF
        IS_ALLOCATED_LARGEARRAY = .TRUE.
      END IF
C
C     -----------------------------------------------------------------|
C*    Section 2. Setup number of points at each latitude for the
C                output latitude/longitude field.
C     -----------------------------------------------------------------|
C
  200 CONTINUE
C
      IF( (NOREPR.EQ.JPQUASI) .OR. (NOREPR.EQ.JPGAUSSIAN) ) THEN
C
C       Reduced (quasi-regular) gaussian output
C
        KNEWNUM = NOGAUSS*2
        DO LOOP = 1, KNEWNUM
          NUMNEW(LOOP)  = NOLPTS(LOOP)
          NEWLATS(LOOP) = ROGAUSS(LOOP)
        ENDDO
C
      ELSE IF( NOREPR.EQ.JPREDLL ) THEN
C
C       Reduced (quasi-regular) lat/long output
C
        KNEWNUM = NOREDLL
        DO LOOP = 1, KNEWNUM
          NUMNEW(LOOP)  = NOLPTS(LOOP)
          NEWLATS(LOOP) = ROREDLL(LOOP)
        ENDDO
C
      ELSE
C
C       Regular output
C
        MISSLAT = NINT((90.0 - NORTH)/STEPNS)
        DO LOOP = 1, MISSLAT
          NUMNEW(LOOP)    = 0
        ENDDO
        DO LOOP = 1, NLATS
          NUMNEW(LOOP+MISSLAT) = NINT(360.0/STEPWE)
        ENDDO
C
        KNEWNUM = MISSLAT + NLATS
        DO LOOP = 1, KNEWNUM
          NEWLATS(LOOP) = 90.0 - (LOOP-1)*STEPNS
        ENDDO
C
      ENDIF
C
C     -----------------------------------------------------------------|
C*    Section 3. Get the input GRIB field characteristics.
C     -----------------------------------------------------------------|
C
  300 CONTINUE
C
C     Calculate the indices of the input grid points to be used for
C     the output points
C
      OWEST = FLOAT(NIAREA(2))/PPMULT
      OEAST = FLOAT(NIAREA(4))/PPMULT

      WAVEXX2 = WAVEIDX(NUMLATS,NPTS,OLDLATS,OWEST,OEAST,
     X                  KNEWNUM, NUMNEW, NEWLATS, NEWIDX, DISTNEW)
      IF( WAVEXX2.NE.0 ) THEN
        CALL INTLOG(JP_ERROR,
     X    'WAVEXX2: Unable to calculate output grid indices',JPQUIET)
        WAVEXX2 = JPROUTINE + 3
        GOTO 900
      ENDIF
C
C     Wave direction parameters need special handling
      LDIREC = IS_WAVE_DIRECTION(NPARAM)
C
C     -----------------------------------------------------------------|
C*    Section 4. Work through the output subarea.
C     -----------------------------------------------------------------|
C
  400 CONTINUE
C
C     Fill in the wave spectra values
C
      NEXT = 0
      NEXTWV = 0
C
      SOUTH = NOAREA(3)/PPMULT
      EAST  = NOAREA(4)/PPMULT
      ISTART = 0
C
C     Work down through latitudes from north to south.
C
      DO NROW = 1, KNEWNUM
C
C       If inside north-south (subarea) boundaries ..
C
        IF( (NOREPR.EQ.JPGAUSSIAN).OR.(NOREPR.EQ.JPQUASI) ) THEN
          PTLAT = ROGAUSS(NROW)
        ELSE
          PTLAT = 90.0 - (NROW-1)*STEPNS
        ENDIF
C
        IF( (PTLAT.LE.NORTH).AND.(ABS(PTLAT-SOUTH).GT.-0.0005) ) THEN
C
C         Calculate number of points between west boundary of area and
C         Greenwich
C
          ROWINC = 360.0/NUMNEW(NROW)
C
          IWEST = INT(WEST/ROWINC)
          IF (ABS(WEST - IWEST*ROWINC).GT.0.000001) THEN
            IF (WEST.GT.0.0) IWEST = IWEST + 1
            IF (WEST.LT.0.0) IWEST = IWEST - 1
          ENDIF
          AWEST = IWEST * ROWINC
          IWOFSET = NUMPTWE(AWEST,0.0,ROWINC)
          IEOFSET = NUMPTWE(AWEST,EAST,ROWINC)
C
C         Work through subarea longitudes from west to east.
C
          DO NCOL = 1, NUMNEW(NROW)
            PTLONG = AWEST + (NCOL-1)*ROWINC
            NEXT = NUMPTWE(AWEST,PTLONG,ROWINC)
            IF( (NEXT.LE.IEOFSET).AND.(NEXT.GE.0) ) THEN
C
C             .. and inside west-east (subarea) boundaries
C
              NEXT = 1 + NEXT - IWOFSET
              IF( NEXT.LE.0) NEXT = NEXT + NUMNEW(NROW)
              NEXT = NEXT + ISTART
              NEXTWV = NEXTWV + 1
C
              INW = NEWIDX(JPNW,NEXT)
              INE = NEWIDX(JPNE,NEXT)
              ISW = NEWIDX(JPSW,NEXT)
              ISE = NEWIDX(JPSE,NEXT)
C
C             Test if any of the four neighbouring points is missing.
C
                IF( (OLDWAVE(INW).EQ.PMISS) .OR.
     X              (OLDWAVE(ISW).EQ.PMISS) .OR.
     X              (OLDWAVE(INE).EQ.PMISS) .OR.
     X              (OLDWAVE(ISE).EQ.PMISS) ) THEN
                ENDIF

              IF( (INW.EQ.0) .OR. (OLDWAVE(INW).EQ.PMISS) .OR.
     X            (ISW.EQ.0) .OR. (OLDWAVE(ISW).EQ.PMISS) .OR.
     X            (INE.EQ.0) .OR. (OLDWAVE(INE).EQ.PMISS) .OR.
     X            (ISE.EQ.0) .OR. (OLDWAVE(ISE).EQ.PMISS) ) THEN
                IF( (OLDWAVE(INW).EQ.PMISS) .AND.
     X              (OLDWAVE(ISW).EQ.PMISS) .AND.
     X              (OLDWAVE(INE).EQ.PMISS) .AND.
     X              (OLDWAVE(ISE).EQ.PMISS) ) THEN
                ENDIF
C
C               If so, take nearest grid point value.
C
                DISNW = DISTNEW(JPDISNW,NEXT)
                DISNE = DISTNEW(JPDISNE,NEXT)
                DISSW = DISTNEW(JPDISSW,NEXT)
                DISSE = DISTNEW(JPDISSE,NEXT)
C
                IF( (DISNW.LE.DISNE).AND.
     X              (DISNW.LE.DISSW).AND.
     X              (DISNW.LE.DISSE)) THEN
                  INDEX = INW
C
                ELSE IF( (DISNE.LE.DISSW).AND.
     X                   (DISNE.LE.DISSE) ) THEN
                  INDEX = INE
C
                ELSE IF( (DISSW.LE.DISSE) ) THEN
                  INDEX = ISW
C
                ELSE
                  INDEX = ISE
                ENDIF
C
                IF(INDEX.EQ.0.OR.(OLDWAVE(INDEX).EQ.PMISS)) THEN
C
C                 Nearest point is missing
C
                  NEWWAVE(NEXTWV) = PMISS
C
                ELSE
                  NEWWAVE(NEXTWV) =  OLDWAVE(INDEX)
                ENDIF
C
              ELSE
C
C               Use bi-linear interpolation from four
C               neighbouring sea points (possible conv REAL*4 to REAL*8)
C
                DI1N = DISTNEW(JPNW,NEXT)
                DI2N = DISTNEW(JPNE,NEXT)
                DI1S = DISTNEW(JPSW,NEXT)
                DI2S = DISTNEW(JPSE,NEXT)
                DK1  = DISTNEW(JPN,NEXT)
                DK2  = DISTNEW(JPS,NEXT)
C
                NW_PT = OLDWAVE(INW)
                NE_PT = OLDWAVE(INE)
                SW_PT = OLDWAVE(ISW)
                SE_PT = OLDWAVE(ISE)
                IF( .NOT. LDIREC ) THEN
                  U1 = NW_PT*DI2N + NE_PT*DI1N
                  U2 = SW_PT*DI2S + SE_PT*DI1S
                  NEWWAVE(NEXTWV) = U1*DK2 + U2*DK1
                ELSE
C
C                 Fields representing a 'direction': resolve into
C                 components and interpolate each separately.
C
#if (defined REAL_8)
#define __ATAN2 DATAN2
#define __COS   DCOS
#define __SIN   DSIN
#else
#define __ATAN2 ATAN2
#define __COS   COS
#define __SIN   SIN
#endif
                  CNW_PT = __COS(NW_PT*RAD)
                  CNE_PT = __COS(NE_PT*RAD)
                  CSW_PT = __COS(SW_PT*RAD)
                  CSE_PT = __COS(SE_PT*RAD)
                  SNW_PT = __SIN(NW_PT*RAD)
                  SNE_PT = __SIN(NE_PT*RAD)
                  SSW_PT = __SIN(SW_PT*RAD)
                  SSE_PT = __SIN(SE_PT*RAD)
                  C1 = CNW_PT*DI2N + CNE_PT*DI1N
                  C2 = CSW_PT*DI2S + CSE_PT*DI1S
                  CC = C1*DK2 + C2*DK1
                  S1 = SNW_PT*DI2N + SNE_PT*DI1N
                  S2 = SSW_PT*DI2S + SSE_PT*DI1S
                  SS = S1*DK2 + S2*DK1
                  IF( SS.LT.0.0 ) THEN
                    NEWWAVE(NEXTWV) = __ATAN2(SS,CC)/RAD + 360.0
                  ELSE
                    NEWWAVE(NEXTWV) = __ATAN2(SS,CC)/RAD
                  ENDIF
#undef __SIN
#undef __COS
#undef __ATAN2
                ENDIF
              ENDIF
            ENDIF
          ENDDO
C
        ENDIF
        ISTART = ISTART + NUMNEW(NROW)
      ENDDO
C
C     -----------------------------------------------------------------|
C*    Section 9. Closedown.
C     -----------------------------------------------------------------|
C
  900 CONTINUE
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE BUPKS(KBPW,KDEST,KSOURC,KWPT,KBPT,KSIZE,KSKIPB,K,KERR)
C
C**** *BUPKS*
C
C
C     PURPOSE.
C     --------
C          PURPOSE OF THIS ROUTINE IS TO PACK BIT STRING OF
C     KSIZE BITS, STARTED AT WORD KWPT OF ARRAY KSOURC AFTER
C     SKIPPINH KBPT BITS. RESULT IS PUT INTO KDEST. AT THE END
C     POINTERS KWPT AND KBPT ARE ADJUSTED.
C
C**   INTERFACE.
C     ----------
C
C          *CALL* *BUPKS(KBPW,KDEST,KSOURC,KWPT,KBPT,KSIZE,KSKIPB,K,KERR)*
C
C
C        INPUT :
C            KBPW      - NUMBER OF BITS PER COMPUTER WORD
C            KSOURC    - SOURCE (CONTINUOUS BIT STRING OF
C                          ARBITRARY LENGTH)
C            KWPT      - WORD POINTER
C            KBPT      - BIT POINTER
C            KSIZE     - NUMBER OF BITS USED FOR PACKING
C            KSKIPB    - NUMBER OF BITS TO SKIP BETWEEN ELEMENTS
C            K         - ITERATION
C
C        OUTPUT :
C            KDEST     - DESTINATION
C            KERR      - RETURN ERROR CODE
C
C     METHOD.
C     -------
C
C            NONE.
C
C
C     EXTERNALS.
C     ----------
C
C
C          SBYTES     - PACK BIT PATHERN
C
C
C     REFERENCE.
C     ----------
C
C          NONE.
C
C     AUTHOR.
C     -------
C
C          M. DRAGOSAVAC    *ECMWF*       15/01/91.
C
C
C     MODIFICATIONS.
C     --------------
C
C          NONE.
C
C
      IMPLICIT LOGICAL(L,O,G), CHARACTER*8(C,H,Y)
C
      DIMENSION KDEST(*),KSOURC(*)
C
C     ------------------------------------------------------------------
C*          1.   EXTRACT BIT PATTERN.
C                --------------------
 100  CONTINUE
C
      IF(KERR.GT.0) RETURN
C
      IF(KSIZE.GT.KBPW) THEN
         KERR= 34
         WRITE(KNTN,*)  'BUPKS :'
         CALL BUERR(KERR)
         RETURN
      END IF
C
      CALL SBYTES(KDEST,KSOURC,KBPT,KSIZE,KSKIPB,K)
C
C     ------------------------------------------------------------------
C*          1.1  UPDATE WORD AND BIT POINTERS.
C                -----------------------------
 110  CONTINUE
C
      KBPT = KBPT + K*(KSIZE+KSKIPB)
C
      IF(KBPT.GE.KBPW) THEN
         IW  = KBPT/ KBPW
         KBPT= KBPT - IW * KBPW
         KWPT= KWPT +IW
      END IF
C
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE BUPCK(KBPW,KD,KS,KWPT,KBPT,KSI,KERR)
C
C**** *BUPCK*
C
C
C     PURPOSE.
C     --------
C         PURPOSE OF THIS ROUTINE IS TO PACK VALUE *KS* IN
C         *KSI* BITS, STARTED AT WORD KWPT OF ARRAY *KD* AFTER
C         SKIPPING NBPT BITS.  AT THE END
C         POINTERS *KWPT* AND *KBPT* ARE ADJUSTED.
C
C**   INTERFACE.
C     ----------
C
C     *CALL* *BUPCK(KBPW,KD,KS,KWPT,KBPT,KSI,KERR)*
C
C        INPUT :
C            *KS*    - SOURCE
C            *KWPT*  - WORD POINTER
C            *KWPT*  - BIT POINTER
C            *KSI*   - NUMBER OF BITS ACCUPIED BY KS.
C
C        OUTPUT :
C            *KD*    - DESTINATION ARRAY.
C            *KERR*  - RETURN ERROR CODE
C
C     *METHOD.
C      -------
C
C            NONE.
C
C
C     EXTERNALS.
C     ----------
C
C
C            *CALL SBYTE(KD,KS,KBPT,KSI)*
C
C            *KD*    - DESTINATION ARRAY.
C            *KS*    - SOURCE
C            *KBPT*  - POINTER TO BIT IN THE KD(KWPT)
C            *KSI*   - NUMBER OF BITS ACCUPIED BY KS.
C
C
C
C
C     REFERENCE.
C     ----------
C
C          NONE.
C
C     AUTHOR.
C     -------
C
C          M. DRAGOSAVAC    *ECMWF*       09/06/86.
C
C
C     MODIFICATIONS.
C     --------------
C
C          NONE.
C
C
      IMPLICIT LOGICAL(L,O,G), CHARACTER*8(C,H,Y)
C
C
#     include "parameter.F"
#     include "bcomunit.F"
#     include "bcmwork.F"
C
#ifndef R_4
      REAL*8 RVIND
      REAL*8 EPS
#else
      REAL   RVIND
      REAL   EPS
#endif
      DIMENSION KD(*)
      DIMENSION IMAXV(32)
C
      DATA IMAXV/1,3,7,15,31,63,127,255,511,1023,2047,4095,8191,
     1  16383,32767,65535,131071,262143,524287,1048575,2097151,
     2  4194305,8388607,16777215,33554431,671108863,134217727,
     3  268435455,536870911,1073741823,2147483647,2147483647/
C
C     ------------------------------------------------------------------
C*          1.   SET UP BIT PATTERN.
C                -------------------
C
 100  CONTINUE
C
      IF(KERR.GT.0) RETURN
C
      IF(KS.EQ.NVIND) KS=IMAXV(KSI)
C
      IF(KS.GT.IMAXV(KSI)) THEN
         KERR=28
         RETURN
      END IF
C
      CALL SBYTE(KD,KS,KBPT,KSI)
C
C     ------------------------------------------------------------------
C*          1.1  UPDATE WORD AND BIT POINTERS.
C                -----------------------------
 110  CONTINUE
C
      KBPT = KBPT + KSI
C
      IF(KBPT.GE.KBPW) THEN
         KBPT= KBPT - KBPW
         KWPT= KWPT + 1
      END IF
C
      RETURN
      END

C
C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C Unless required by applicable law or agreed to in writing, software
C distributed under the License is distributed on an "AS IS" BASIS,
C WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
C
C In applying this licence, ECMWF does not waive the privileges and immunities
C granted to it by virtue of its status as an intergovernmental organisation
C nor does it submit to any jurisdiction.
C

      PROGRAM EXAMPLE_INTF2
      IMPLICIT NONE


C     Parameters
      INTEGER JPGRIB   ! GRIB size (up to 1/16 deg)
      INTEGER JPBYTES  ! bytes/integer
      PARAMETER (JPGRIB = 33190420)
#ifdef INTEGER_8
      PARAMETER (JPBYTES = 8)
#else
      PARAMETER (JPBYTES = 4)
#endif


C     Local variables
      INTEGER      INTV(4)
      REAL         REALV(4)
      CHARACTER*20 CHARV

      CHARACTER*128 INFILE, OUTFILE, ARG
      INTEGER INLEN, OUTLEN, U1, U2, IRET, N
      INTEGER INGRIB(JPGRIB), OUTGRIB(JPGRIB)


C     Externals
      INTEGER INTOUT, INTF2, IARGC


C     ------------------------------------------------------------------


C     Pick up file names from command line
      INFILE  = ' '
      OUTFILE = ' '
      IF( IARGC().EQ.4 ) THEN
        DO N = 1, 4, 2
          CALL GETARG(N,ARG)
          IF (ARG.EQ.'-i') THEN
            CALL GETARG(N+1,INFILE)
          ELSEIF (ARG.EQ.'-o') THEN
            CALL GETARG(N+1,OUTFILE)
          ENDIF
        ENDDO
      ENDIF
      CALL CHECK(
     _  INDEX(INFILE,' ').EQ.1 .OR. INDEX(OUTFILE,' ').EQ.1,
     _  'Usage: example_intf2 -i infile -o outfile' )

      INTV  = 0
      REALV = 0.
      CHARV = ''


C     Define the packing accuracy for the new field(s)
      INTV(1) = 24
      IRET = INTOUT('accuracy', INTV, REALV, CHARV)
      CALL CHECK(IRET.NE.0, 'INTOUT (accuracy) failed')
      INTV(1) = 0


C     Define the geographical area for the new field(s)
      REALV(1) =  60.
      REALV(2) = -10.
      REALV(3) =  40.
      REALV(4) =  15.
      IRET = INTOUT('area', INTV, REALV, CHARV)
      CALL CHECK(IRET.NE.0, 'INTOUT (area) failed')
      REALV = 0.


C     Define the grid interval for the new field(s)
      REALV(1) = 1.5
      REALV(2) = 1.5
      IRET = INTOUT('grid', INTV, REALV, CHARV)
      CALL CHECK(IRET.NE.0, 'INTOUT (grid) failed')
      REALV = 0.


C     Open input and output files
      CALL PBOPEN(U1, INFILE, 'r', IRET)
      CALL CHECK(IRET.NE.0, 'PBOPEN failed (r)')
      CALL PBOPEN(U2, OUTFILE, 'w', IRET)
      CALL CHECK(IRET.NE.0, 'PBOPEN failed (w)')


C     Start of loop on input fields
      PRINT *, 'Start interpolation...'
      N = 0
 220  CONTINUE
      N = N + 1

C     Read next field
      CALL PBGRIB(U1, INGRIB, JPGRIB*JPBYTES, INLEN, IRET)
      IF (IRET.EQ.-1) THEN
        IRET = 0
        GOTO 290
      ENDIF
      CALL CHECK(IRET.NE.0, 'PBGRIB failed')

C     Interpolate
      PRINT *, 'Interpolate field #', N
      OUTLEN = JPGRIB
      IRET = INTF2(INGRIB,INLEN,OUTGRIB,OUTLEN)
      CALL CHECK(IRET.NE.0, 'INTF failed')

C     Write the new field to file
      IF (OUTLEN.GT.0) THEN
        CALL PBWRITE(U2, OUTGRIB, OUTLEN, IRET)
      ELSE
        PRINT *, 'Output same as input'
        CALL PBWRITE(U2, INGRIB, INLEN, IRET)
      ENDIF
      CALL CHECK(IRET.LT.0, 'PBWRITE failed')


C     Loop back for next field
      GOTO 220


C     Close
 290  CONTINUE
      CALL PBCLOSE(U1, IRET)
      CALL PBCLOSE(U2, IRET)

      PRINT *, 'Interpolated ', (N-1), ' field(s).'
      END


C     ------------------------------------------------------------------


      SUBROUTINE CHECK(OOPS,MSG)
      IMPLICIT NONE
      LOGICAL OOPS
      CHARACTER MSG*(*)
      IF (OOPS) THEN
        PRINT *, MSG
        CALL EXIT(3)
      ENDIF
      END

C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      INTEGER FUNCTION JGGLAT(KLAT, PGAUSS)
C
C---->
C**** *JGGLAT* - Routine to compute Gaussian abscissae
C
C     PURPOSE
C     _______
C
C     This routine computes Gaussian lines of latitude for a given
C     truncation.
C
C     INTERFACE
C     _________
C
C     IERR = JGGLAT(KLAT, PGAUSS)
C
C     Input parameters
C     ________________
C
C     KLAT       - This is the number of lines of latitude from pole to
C                  pole.
C
C     Output parameters
C     ________________
C
C     PGAUSS     - The Gaussian lines of latitude for truncation
C                  KLAT / 2.
C
C     Return value
C     ____________
C
C     The error indicator (INTEGER).
C
C     Error and Warning Return Values
C     _______________________________
C
C     1  The Newton iteration failed to converge when generating
C        Gaussian lines of latitude.
C
C     MARSINT problem - Please report this to Meteorological
C     Applications.
C
C     Common block usage
C     __________________
C
C     None
C
C     EXTERNALS
C     _________
C
C     JBESS    - This routine is used to generate initial
C                  approximations to the Gaussian latitudes.
C
C     METHOD
C     ______
C
C     JBESS is used to provide zeros of the Bessel function J0,
C     which are used as starting approximations to the Gaussian
C     latitudes. Newton iteration is used to generate the latitudes
C     from these approximations.
C
C     REFERENCE
C     _________
C
C     None
C
C     COMMENTS
C     ________
C
C
C     This routine is adapted from that in the old Marsint library.
C     The interface and the variable names have been modified.
C
C     Program contains sections 0 to 2 and 9
C
C     AUTHOR
C     ______
C
C     K. Fielding      *ECMWF*      Oct 1993
C
C     MODIFICATIONS
C     _____________
C
C     None
C
C----<
C     _______________________________________________________
C
C*    Section 0. Definition of variables.
C     _______________________________________________________
C
         IMPLICIT NONE
C
#include "jparams.h"
#include "parim.h"
C
C     Dummy arguments
      INTEGER KLAT
C
      REAL PGAUSS (*)
C
C     Local variables
C
      INTEGER ITRUNC, IERR
C
C     Loop control variables
C
      INTEGER JLAT, JITER, JLN
C
      REAL ZRADDEG, ZCON, ZLAT, ZROOT
      REAL ZKM1, ZKM2, ZLN, ZFUNC, ZDERIV, ZMOVE
C
C     Function externals
C
      INTEGER JBESS
C
C     _______________________________________________________
C
C*    Section 1. Set constants and get initial approximation.
C     _______________________________________________________
C
  100 CONTINUE
C
      JGGLAT = 0
C
      ZRADDEG = 180.0 / PPI
C
      ZCON = (PPONE - (PPTWO / PPI) ** 2) * PPQUART
C
      ZLAT = KLAT
      ITRUNC = KLAT / 2
C
      IERR = JBESS (ITRUNC, PGAUSS)
C
C     _______________________________________________________
C
C*    Section 2. Compute abscissae
C     _______________________________________________________
C
  200 CONTINUE
C
      DO 240 JLAT = 1, ITRUNC
C
C     First approximation for ZROOT
C
         ZROOT = COS (PGAUSS (JLAT) /
     1      SQRT ( (ZLAT + PPHALF) ** 2 + ZCON) )
C
C     Perfrom loop of Newton iterations
C
         DO 220 JITER =1, JPMAXITER
C
            ZKM2 = PPONE
            ZKM1 = ZROOT
C
C     Compute Legendre polynomial
C
            DO 210 JLN = 2, KLAT
C
               ZLN = JLN
C
               ZFUNC = ( (PPTWO * ZLN - PPONE) * ZROOT * ZKM1 -
     1            (ZLN - PPONE) * ZKM2) / ZLN
C
               ZKM2 = ZKM1
               ZKM1 = ZFUNC
C
  210       CONTINUE
C
C     Perform Newton iteration
C
C
            ZDERIV = (ZLAT * (ZKM2 - ZROOT * ZFUNC) ) /
     1         (PPONE - ZROOT ** 2)
C
            ZMOVE = ZFUNC / ZDERIV
C
            ZROOT = ZROOT - ZMOVE
C
C     If ABS (ZMOVE) < PPEPSA leave iteration loop because sufficient
C     accuracy has been achieved.
C
            IF (ABS (ZMOVE) .LE. PPEPSA) GOTO 230
C
  220    CONTINUE
C
C     Routine fails if no convergence after JPMAXITER iterations.
C
         JGGLAT = 1
         GO TO 900
C
  230    CONTINUE
C
C*    Set North and South values using symmetry.
C
         PGAUSS (JLAT) = ASIN (ZROOT) * ZRADDEG
         PGAUSS (KLAT + 1 - JLAT) = - PGAUSS (JLAT)
C
  240 CONTINUE
C
C
      IF (KLAT .NE. ITRUNC * 2) PGAUSS (ITRUNC + 1) = PPZERO
C
C     _______________________________________________________
C
C*    Section 9. Return to calling routine.
C     _______________________________________________________
C
  900 CONTINUE
C
C
      RETURN
      END
      INTEGER FUNCTION JBESS (KTRUNC, PBESJ0)
C
C**** *JBESS* - Routine to return zeros of the J0 Bessel function.
C
C     PURPOSE
C     _______
C
C     This routine returns up to JPLOOK zeros of the J0 Bessel function.
C     If more than JPLOOK zeros are required then approximate zeros are
C     returned after the JPLOOK-th.
C
C     INTERFACE
C     _________
C
C     IERR = JBESS (KTRUNC, PBESJ0)
C
C     Input parameters
C     ________________
C
C     KTRUNC     - This is the number of zeros of the J0 Bessel
C                  function required.
C
C     Output parameters
C     ________________
C
C     PBESJ0     - The output array of zeros of the J0 Bessel function.
C
C     Return Value
C     ____________
C
C     The error indicator (INTEGER).
C
C     Error and Warning Return Values
C     _______________________________
C
C     None
C
C     Common block usage
C     __________________
C
C     None
C
C     EXTERNALS
C     _________
C
C     None
C
C     METHOD
C     ______
C
C     The first JPLOOK values are obtained from a look-up table (ZPBES).
C     Any additional values requested are approximated by adding
C     PI (3.14159...) to the previous value.
C
C     REFERENCE
C     _________
C
C     None
C
C     COMMENTS
C     ________
C
C     This routine is adapted from that in the old Marsint library.
C     The interface and the variable names have been modified.
C
C     Program contains sections 0 to 2 and 9
C
C     AUTHOR
C     ______
C
C     K. Fielding      *ECMWF*      Oct 1993
C
C     MODIFICATIONS
C     _____________
C
C     None
C
C     _______________________________________________________
C
C
C*    Section 0. Definition of variables.
C     _______________________________________________________
C
C*    Prefix conventions for variable names
C
C     Logical      L (but not LP), global or common.
C                  O, dummy argument
C                  G, local variable
C                  LP, parameter.
C     Character    C, global or common.
C                  H, dummy argument
C                  Y (but not YP), local variable
C                  YP, parameter.
C     Integer      M and N, global or common.
C                  K, dummy argument
C                  I, local variable
C                  J (but not JP), loop control
C                  JP, parameter.
C     REAL         A to F and Q to X, global or common.
C                  P (but not PP), dummy argument
C                  Z, local variable
C                  PP, parameter.
C
C     Implicit statement to force declarations
C
      IMPLICIT NONE
C
#include "jparams.h"
C
C     Dummy arguments
C
      INTEGER KTRUNC
C
      REAL PBESJ0 (*)
C
C     Local variables
C
C
      INTEGER ILOOK
      INTEGER JAPPRX, JLOOK
C
      REAL ZPBES (JPLOOK)
C
      DATA ZPBES        /   2.4048255577E0,   5.5200781103E0,
     1    8.6537279129E0,  11.7915344391E0,  14.9309177086E0,
     2   18.0710639679E0,  21.2116366299E0,  24.3524715308E0,
     3   27.4934791320E0,  30.6346064684E0,  33.7758202136E0,
     4   36.9170983537E0,  40.0584257646E0,  43.1997917132E0,
     5   46.3411883717E0,  49.4826098974E0,  52.6240518411E0,
     6   55.7655107550E0,  58.9069839261E0,  62.0484691902E0,
     7   65.1899648002E0,  68.3314693299E0,  71.4729816036E0,
     8   74.6145006437E0,  77.7560256304E0,  80.8975558711E0,
     9   84.0390907769E0,  87.1806298436E0,  90.3221726372E0,
     A   93.4637187819E0,  96.6052679510E0,  99.7468198587E0,
     1  102.8883742542E0, 106.0299309165E0, 109.1714896498E0,
     2  112.3130502805E0, 115.4546126537E0, 118.5961766309E0,
     3  121.7377420880E0, 124.8793089132E0, 128.0208770059E0,
     4  131.1624462752E0, 134.3040166383E0, 137.4455880203E0,
     5  140.5871603528E0, 143.7287335737E0, 146.8703076258E0,
     6  150.0118824570E0, 153.1534580192E0, 156.2950342685E0 /
C
C     _______________________________________________________
C
C
C*    Section 1. Extract initial values from look up table
C
C     _______________________________________________________
C
  100 CONTINUE
C
      JBESS = 0
C
      ILOOK = MIN(KTRUNC, JPLOOK)
C
      DO 110 JLOOK = 1, ILOOK
         PBESJ0(JLOOK) = ZPBES(JLOOK)
  110 CONTINUE
C
C     _______________________________________________________
C
C*    Section 2. Approximate any extra values required
C     _______________________________________________________
C
  200 CONTINUE
C
      DO 210 JAPPRX = ILOOK + 1, KTRUNC
         PBESJ0(JAPPRX) = PBESJ0(JPLOOK) + PPI * (JAPPRX - ILOOK)
  210 CONTINUE
C
C     _______________________________________________________
C
C*    Section 9. Return to calling routine.
C     _______________________________________________________
C
  900 CONTINUE
C
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE CREX_GET_NAME_UNIT(KREFERENCE,YNAME,YUNIT)
C
C**** *CREX_GET_NAME_UNIT*

C
C
C     PURPOSE.
C     --------
C          FIND NAME AND THE UNIT FOR THE PARTICULAR REFERENCE NUMBER.
C
C
C**   INTERFACE.
C     ----------
C
C          *CALL* *CREX_GET_NAME_UNIT(KREFERENCE,YNAME,YUNIT)*
C
C
C        INPUT : *KREFERENCE* - TABLE B REFERENCE NUMBER
C        OUTPUT:
C                *CNAMES*     -  ARRAY CONTAINING ELEMENT NAMES
C                *CUNITS*     -  ARRAY CONTAINING ELEMENT UNITS
C
C
C     METHOD.
C     -------
C
C          NONE.
C
C     EXTERNALS.
C     ----------
C          NONE.
C
C     REFERENCE.
C     ----------
C
C          NONE.
C
C     AUTHOR.
C     -------
C
C          M. DRAGOSAVAC    *ECMWF*       15/01/2006.
C
C
C     MODIFICATIONS.
C     --------------
C
C          NONE.
C
C
      IMPLICIT LOGICAL(L,O,G), CHARACTER*8(C,H,Y)

C
      PARAMETER(JSUP =   9,JSEC0=   3,JSEC1= 40,JSEC2= 64 ,JSEC3=    4,
     1          JSEC4=   2,JELEM=40000,JSUBS=400,JCVAL=150 ,JBUFL=40000,
     2          JBPW =  32,JTAB =3000,JCTAB=120,JCTST=1800,JCTEXT= 200,
     3          JWORK=360000,JKEY=46)

C
      CHARACTER*64 YNAME
      CHARACTER*24 YUNIT
C
C
      COMMON/CREXTAB/ NCREXBR(JTAB),NCREXBS(JTAB)    , NCREXBDW(JTAB),
     1                NCREXDR(JTAB),NCREXDST(JTAB)   ,
     2                NCREXDL(JTAB),NCREXDSQ(JTAB*20),NCREXP(64,255)

C
C             NCREXBR     - table B,  table reference              array
C             NCREXBS     - table B,  scale                        array 
C             NCREXBDW    - table B,  data width                   array
C             NCREXDR     - table D,  table reference              array
C             NCREXDST    - table D,  starting pointers            array
C             NCREXDL     - table D,  lengths                      array
C             NCREXDSQ    - table D,  list of sequence descriptors array
C     
       COMMON/CREXTABC/ CREXNAME(JTAB),CREXUNIT(JTAB),CREXLST(JELEM)
C
C             CREXNAME      -  table B, ELEMENT NAME           array
C             CREXUNIT      -  table B, unit                   array
C
      CHARACTER CREXNAME*64,CREXUNIT*24
      CHARACTER*6  CREXLST
C
      ICLASS=KREFERENCE/1000
      IYYY  =KREFERENCE-ICLASS*1000+1
      ICLASS=ICLASS+1
C
      I=NCREXP(ICLASS,IYYY)
      YNAME=CREXNAME(I)
      YUNIT=CREXUNIT(I)
C
      RETURN
      END

C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      INTEGER FUNCTION IAINIT (KPR, KERR)
C
C---->
C**** *IAINIT*
C
C     PURPOSE
C     _______
C
C     Initialise common decks for grid-pt to grid-pt interpolation.
C
C     INTERFACE
C     _________
C
C     IERR = IAINIT (KPR, KERR)
C
C     Input parameters
C     ________________
C
C     KPR        - The debug print switch.
C                  0  , No debugging output.
C                  1  , Produce debugging output.
C
C     KERR       - The error control flag.
C                  -ve, No error message. Return error code.
C                  0  , Hard failure with error message.
C                  +ve, Print error message. Return error code.
C
C     Output parameters
C     ________________
C
C     None
C
C     Return value
C     ____________
C
C     The error indicator (INTEGER).
C
C     Error and Warning Return Values
C     _______________________________
C
C     None
C
C     Common block usage
C     __________________
C
C     grfixed.h    - The include file contains all the array space
C                    for grid to grid interpolation.
C
C     MILLEN       - The array of latitude line lengths for a quasi
C                    regular Gaussian grid is set.
C
C     memreq.h     - This file contains the memory request
C                    definition variables.
C
C     MADDR        - The base addresses of the currently allocated
C                    memory segments are set.
C     MREQUEST     - The sizes of the current memory requests are set.
C
C
C     EXTERNALS
C     _________
C
C     INTLOG   - Logs messages.
C
C     METHOD
C     ______
C
C     Initialise common decks for grid-pt to grid-pt interpolation:
C                - memory access arrays,
C                - quasi regular definition.
C
C     REFERENCE
C     _________
C
C     None
C
C     COMMENTS
C     ________
C
C     None.
C
C     AUTHOR
C     ______
C
C     K. Fielding      *ECMWF*      Apr 1994
C
C     MODIFICATIONS
C     _____________
C
C     J.D.Chambers      ECMWF       Aug 1994
C
C----<
C     _______________________________________________________
C
C
C*    Section 0. Definition of variables.
C     _______________________________________________________
C
C*    Prefix conventions for variable names
C
C     Logical      L (but not LP), global or common.
C                  O, dummy argument
C                  G, local variable
C                  LP, parameter.
C     Character    C, global or common.
C                  H, dummy argument
C                  Y (but not YP), local variable
C                  YP, parameter.
C     Integer      M and N, global or common.
C                  K, dummy argument
C                  I, local variable
C                  J (but not JP), loop control
C                  JP, parameter.
C     REAL         A to F and Q to X, global or common.
C                  P (but not PP), dummy argument
C                  Z, local variable
C                  PP, parameter.
C
C     Implicit statement to force declarations
C
      IMPLICIT NONE
C
#include "parim.h"
#include "memreq.h"
#include "nifld.common"
#include "nofld.common"
#include "grfixed.h"
C
C     Dummy arguments
C
      INTEGER KPR, KERR
C
C     Local variables
C
      INTEGER JSET
C
      INTEGER JPROUTINE
C
      PARAMETER (JPROUTINE = 21100)
C
C     External functions
C
C     Transform definition variables that must be preserved
C
C
C     _______________________________________________________
C
C
C*    Section 1. Initialisation
C     _______________________________________________________
C
  100 CONTINUE
C
      IF (KPR .GE. 1) CALL INTLOG(JP_DEBUG,'IAINIT: Section 1.',JPQUIET)
C
      IAINIT = 0
C
      IF (KPR .GE. 1) CALL INTLOG(JP_DEBUG,
     X  'IAINIT : Grid-pt to grid-pt common decks initialised',JPQUIET)
C
C     _______________________________________________________
C
C
C*    Section 2. Initialise memory access arrays.
C     _______________________________________________________
C
  200 CONTINUE
C
      IF (KPR .GE. 1) CALL INTLOG(JP_DEBUG,'IAINIT: Section 2.',JPQUIET)
C
      DO 210 JSET = 1, JPLEVEL
         MREQUEST (JSET) = 0
         MADDR (JSET) = 0
  210 CONTINUE
C
C     _______________________________________________________
C
C
C*    Section 3. Initialise quasi regular definition
C     _______________________________________________________
C
  300 CONTINUE
C
      IF (KPR .GE. 1) CALL INTLOG(JP_DEBUG,'IAINIT: Section 3.',JPQUIET)
C
      DO 310 JSET = 1, JPLAT
         MILLEN (JSET) = 0
  310 CONTINUE
C
C     _______________________________________________________
C
C
C*    Section 9. Return to calling routine. Format statements
C     _______________________________________________________
C
  900 CONTINUE
C
      IF (KPR .GE. 1) CALL INTLOG(JP_DEBUG,'IAINIT: Section 9.',JPQUIET)
C
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE KWLOC1(KSEC1,KGRIB,KLENG,KNSPT,KBITS,KPLEN,KPR,KRET)
C
C---->
C**** KWLOC1
C
C     Purpose.
C     --------
C
C     GRIB coding/decoding of Washington ensemble product local use of
C     Section 1.
C
C     Interface.
C     ----------
C
C     CALL KWLOC1 (KSEC1,KGRIB,KLENG,KNSPT,KBITS, KPLEN,KPR,KRET)
C
C
C     Input Parameters.
C     -----------------
C
C     KSEC1      - Array containing Grib Section 1 data.
C
C     KGRIB      - Array containing Grib coded data.
C
C     KLENG      - Length (words) of KGRIB.
C
C     KNSPT      - Bit number after which insertion or
C                  extraction starts.
C
C     KBITS      - Number of bits in computer word.
C
C     KPLEN      - Pointer to field containing length of Section 1.
C
C     KPR        - Debug print switch.
C                  0  , No printout.
C                  >0 , Debug printout.
C
C     KRET       - Response to error indicator.
C                  0        , Abort if error encountered.
C                  Non-zero , Return to calling routine
C                             even if error encountered.
C
C     Output Parameters.
C     ------------------
C
C     KSEC1      - Array containing Grib Section 1 data.
C
C     KGRIB      - Array containing Grib coded data.
C
C     KNSPT      - Number of bit after last one inserted or
C                              extracted.
C
C     KRET       - Return code.
C                  0   , No error encountered.
C                  1   , Error reported by routine INXBIT.
C
C     Method.
C     -------
C
C     Input data packed/unpacked in accordance with Washington ensemble
C     product usage of local part of section 1 of Grib code.
C
C
C     Externals.
C     ----------
C
C     INXBIT - insert/extract bit data
C     ABORTX - abort program
C
C
C     Reference.
C     ----------
C
C     WMO Manual On Codes for Grib Code.
C
C
C     Comments.
C     ---------
C
C     Washington ensemble product usage of local part of section 1 of
C     GRIB:
C
C     Octet 41 : Identifies the application:
C                1   Ensemble.
C
C     Octet 42 : Type:
C                1   Unperturbed control forecast,
C                2   Individual negatively perturbed forecast,
C                3   Individual positively perturbed forecast,
C                4   Cluster,
C                5   Whole ensemble.
C
C     Octet 43 : Identification number:
C                1   If byte 42=1, identifies high resolution.
C                2   If byte 42=1, identifies low resolution.
C                3   Etc.(!?).
C                    (1 to 5 for perturbed 00Z forecast.)
C                    (1 to 2 for perturbed 12Z forecast.)
C
C     Octet 44 : Products:
C                1   Full field (individual forecast)/unweighted mean.
C                2   Weighted mean.
C                11  Standard deviation wrt ensemble mean.
C                12  Standard deviation wrt ensemble mean, normalized.
C
C     Octet 45 : Spatial smoothing of product (number of highest total
C                wavenumber included):
C                255 Original resolution retained.
C
Cjdc  Octet 46 : Dummy.    (Not being used!)
C
C
C     Author.
C     -------
C
C     J.D.Chambers     ECMWF      09.10.95
C
C
C     Modifications.
C     --------------
C
C     None.
C
C----<
C     ------------------------------------------------------------------
C     Section 0 . Definition of variables. Data statements.
C     ------------------------------------------------------------------
C
      IMPLICIT NONE
C
#include "common/grprs.h"
C
C     Parameters
      INTEGER KSEC1, KGRIB, KLENG, KNSPT, KBITS, KPLEN, KPR, KRET
      DIMENSION KGRIB(*)
      DIMENSION KSEC1(*)
C
C     Local variables
      INTEGER IRET
      CHARACTER*1   YFUNC
C
C     ------------------------------------------------------------------
C     Section 1 . Set initial values.
C     ------------------------------------------------------------------
C
  100 CONTINUE
C
      IF (KPR.GE.1) THEN
        WRITE(GRPRSM,*) 'KWLOC1 : Section 1.'
        WRITE(GRPRSM,*) 'KWLOC1 : On input, KNSPT = ',KNSPT
      ENDIF
C
C     Reset return code to 0, retaining input value to decide
C     on abort / no abort, if error encountered later.
C
      IRET = KRET
      KRET = 0
      YFUNC = 'D'
C
C     ------------------------------------------------------------------
C     Section 2 . Washington ensemble product local use of Grib
C                 Section 1.
C     ------------------------------------------------------------------
C
  200 CONTINUE
C
      IF (KPR.GE.1) WRITE(GRPRSM,*) 'ECLOC1 : Section 2.'
C
C     Extract fields.
C
C
C     Octet 41 : Identifies the application:
C                1   Ensemble.
C     One 8 bit field.
C
      CALL INXBIT (KGRIB,KLENG,KNSPT,KSEC1(37),1,KBITS, 8,YFUNC,KRET)
      IF (KRET.NE.0) THEN
        WRITE(GRPRSM,*) 'KWLOC1: INXBIT error reported = ',KRET
        KRET = 1
        GO TO 900
      ENDIF
C
C     Octet 42 : Type:
C                1   Unperturbed control forecast,
C                2   Individual negatively perturbed forecast,
C                3   Individual positively perturbed forecast,
C                4   Cluster,
C                5   Whole ensemble.
C     One 8 bit field.
C
      CALL INXBIT (KGRIB,KLENG,KNSPT,KSEC1(38),1,KBITS, 8,YFUNC,KRET)
      IF (KRET.NE.0) THEN
        WRITE(GRPRSM,*) 'KWLOC1: INXBIT error reported = ',KRET
        KRET = 1
        GO TO 900
      ENDIF
C
C     Octet 43 : Identification number:
C                1   If byte 42=1, identifies high resolution.
C                2   If byte 42=1, identifies low resolution.
C                3   Etc.(!?)
C     One 8 bit field.
C
      CALL INXBIT (KGRIB,KLENG,KNSPT,KSEC1(39),1,KBITS, 8,YFUNC,KRET)
      IF (KRET.NE.0) THEN
        WRITE(GRPRSM,*) 'KWLOC1: INXBIT error reported = ',KRET
        KRET = 1
        GO TO 900
      ENDIF
C
C     Octet 44 : Products:
C                1   Full field (individual forecast)/unweighted mean.
C                2   Weighted mean.
C                11  Standard deviation wrt ensemble mean.
C                11  Standard deviation wrt ensemble mean, normalized.
C     One 8 bit field.
C
      CALL INXBIT (KGRIB,KLENG,KNSPT,KSEC1(40),1,KBITS, 8,YFUNC,KRET)
      IF (KRET.NE.0) THEN
        WRITE(GRPRSM,*) 'KWLOC1: INXBIT error reported = ',KRET
        KRET = 1
        GO TO 900
      ENDIF
C
C     Octet 45 : Spatial smoothing of product (number of highest total
C                wavenumber included):
C                255 Original resolution retained.
C     One 8 bit field.
C
      CALL INXBIT (KGRIB,KLENG,KNSPT,KSEC1(41),1,KBITS, 8,YFUNC,KRET)
      IF (KRET.NE.0) THEN
        WRITE(GRPRSM,*) 'KWLOC1: INXBIT error reported = ',KRET
        KRET = 1
        GO TO 900
      ENDIF
C
C     Octet 46 : Dummy.
C     One 8 bit field.
C
Cjdc  KNSPT = KNSPT + 8
C
C     ------------------------------------------------------------------
C     Section 9 . Abort/return to calling routine. Format statements.
C     ------------------------------------------------------------------
C
  900 CONTINUE
C
      IF (KPR.GE.1) THEN
        WRITE(GRPRSM,*) 'KWLOC1 : Section 9.'
        WRITE(GRPRSM,*) 'KWLOC1 : On output, KNSPT = ',KNSPT
      ENDIF
C
C     Abort if requested to do so when an error has been encountered.
C
      IF ( (IRET.EQ.0) .AND. (KRET.NE.0) ) THEN
        CALL ABORTX ('KWLOC1')
      ELSE
        RETURN
      ENDIF
C
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE BBUPRTBOX(KNT,KBOX,KAPP,KLEN,KBOXR,VALS,CBOXN,CBOXU)
C
C**** *BUPRTBOX*
C
C
C     PURPOSE.
C     --------
C
C
C
C**   INTERFACE.
C     ----------
C
C               *CALL* *BUPRTBOX(KNT,KBOX,KAPP,KLEN,KBOXR,VALS,CBOXN,CBOXU)*
C
C        INPUT :
C               *KNT*     -  UNIT NUMBER FOR IO
C               *KBOX*    -  NUMBER OF ROWS      
C               *KAPP*    -  NUMBER OF COLUMNS
C               *KLEN*    -  OFFSET FOR START OF NEXT COLUMN
C               *KBOXR*   -  ARRAY CONTAINING BUFR TABLE B REFERENCE NUMBERS
C               *VALS*    -  ARRAY CONTAINING UNPACKED VALUES
C               *CBOXN*   -  ARRAY CONTAINING ELEMENT NAMES
C               *CBOXU*   -  ARRAY CONTAINING ELEMENT UNITS
C
C     METHOD.
C     -------
C
C
C
C     EXTERNALS.
C     ----------
C
C
C     REFERENCE.
C     ----------
C
C          NONE.
C
C     AUTHOR.
C     -------
C
C          M. DRAGOSAVAC    *ECMWF*       01/02/94.
C
C
C     MODIFICATIONS.
C     --------------
C
C          NONE.
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
      PARAMETER(JELEM=160000)
      DIMENSION IOPER(100)
      DIMENSION KBOXR(360000),IBVAL(JELEM),IBPRINT(60)
#ifndef R_4
      REAL*8 RPRINT(60)
      REAL*8 VALS(360000)
#else
      REAL  RPRINT(60)
      REAL  VALS(360000)
#endif
      CHARACTER*64 CBOXN(40000)
      CHARACTER*24 CBOXU(40000)
C
C
C     ------------------------------------------------------------------
C*                 1. PRINT BOXED EXPANDED BUFR MESSAGE
C                     ---------------------------------
 100  CONTINUE
C
      IF(KBOX.LE.6) THEN
         WRITE(KNT,'(A)') 'THERE IS NO USEFULL DATA TO BE PRINTED.'
         KBOX=0
        RETURN
      END IF
C
      IF(KAPP.GT.60) THEN
         WRITE(KNT,'(A)') 'THERE IS MORE THAN 60 APPLICATIONS IN ',
     1                    'THE DATA'
         WRITE(KNT,'(A)') 'ONLY FIRST 60 WILL BE PROCESSED'
         KAPP=60
      END IF
C
      IF(KAPP.GT.1) THEN
         IREP=(KAPP-1)/10
         IOFF=(KAPP-1)-IREP*10
         IF(IOFF.NE.0) IREP=IREP+1
      ELSE
         IREP=1
         IOFF=0
      END IF
C
      IST=2
      IEND=11
C      IF(IREP.EQ.1.AND.KAPP.EQ.1) IEND=IOFF+1
      IF(IREP.EQ.1 .AND. IOFF .EQ.0) IEND=11
C
      DO 2005 J=1,IREP
C
      WRITE(KNT,'(A)')' '
      DO 2002 I=1,KBOX
      IIII=1
      RPRINT(IIII)=VALS(I)
C
      DO 2003 II=IST,IEND
      IIII=IIII+1
      III=I+(II-1)*KLEN      
      RPRINT(IIII)=VALS(III)
      IBPRINT(IIII)=KBOXR(III)
 2003 CONTINUE
C     WRITE(KNT,'(1H ,I4,1X,A32,1X,15(1X,I6,1X,F8.1))') 
C    1        I,CBOXN(I),(IBPRINT(NN),RPRINT(NN),NN=1,KAPP)
      WRITE(KNT,'(1H ,I4,1X,A32,1X,F14.1,30(1X,F8.1))')
     1        I,CBOXN(I),(RPRINT(NN),NN=1,IIII)
 2002 CONTINUE
C
      IF(IOFF.NE.0.AND.J.EQ.(IREP-1)) THEN
         IST=IEND+1
         IEND=IEND+IOFF
      ELSE
         IST=IEND+1
         IEND=IEND+10
      END IF
C
 2005 CONTINUE
C
C
      RETURN
      END

C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      INTEGER FUNCTION INTWAVE(INGRIB,INLEN,OUTGRIB,OUTLEN)
C
C---->
C**** INTWAVE
C
C     Purpose
C     -------
C
C     Interpolate an ECMWF wave field wave field or a reduced
C     latitude-longitude field
C
C
C     Interface
C     ---------
C
C     IRET = INTWAVE(INGRIB,INLEN,OUTGRIB,OUTLEN)
C
C     Input
C     -----
C
C     INGRIB - Input field (packed).
C     INLEN  - Input field length (words).
C
C
C     Output
C     ------
C
C     OUTGRIB - Output field (packed).
C     OUTLEN  - Output field length (words).
C
C
C     Method
C     ------
C
C     Call interpolation routine; then repack into GRIB format.
C
C
C     Externals
C     ---------
C
C     FIXAREA - Fixup area definition to correspond to grid definitions
C     GRIBEX  - Decode/encode GRIB product.
C     JMEMHAN - Handles memory allocation.
C     JDEBUG  - Checks environment to switch on/off debug
C     INTLOG  - Log error message.
C     WAVEXXX - Interpolate wave fields (except 2D spectra)
C     WV2DXXX - Interpolate wave 2D spectra fields
C     MKFRAME - Create a 'frame' from a rectangular field
C     MKBITMP - Apply a bitmap to a rectangular field
C
C
C     Author
C     ------
C
C     J.D.Chambers     ECMWF     Sep 1996
C
C
C     Modifications
C     -------------
C
C     J.D.Chambers     ECMWF     Nov 1966
C     Add interpolation of 2D spectra.
C
C     J.D.Chambers     ECMWF        Feb 1997
C     Allow for 64-bit pointers
C
C     J.D.Chambers     ECMWF        April 2004
C     Handle reduced lat-long fields
C
C     S.Curic     ECMWF        April 2005
C     Add support for frame and bitmap
C
C----<
C
      IMPLICIT NONE
C
C     Function arguments
      INTEGER INGRIB(*),OUTGRIB(*),INLEN,OUTLEN
C
#include "parim.h"
#include "nifld.common"
#include "nofld.common"
#include "intf.h"
#include "grfixed.h"
#include "jparams.h"
C
C     Parameters
      INTEGER JPROUTINE, JP2DSP, JP2DSPQ, JPMAXLT

      PARAMETER (JPROUTINE = 40200 )
      PARAMETER (JP2DSP  = 250 )
C                           ^---- parameter number for 2D wave spectra (whole)
      PARAMETER (JP2DSPQ = 251 )
C                           ^---- parameter number for 2D wave spectra (single)
      PARAMETER (JPMAXLT = 361 )
C
C     Local variables
C
      CHARACTER*1 HFUNC

      REAL ZMISS
      DATA ZMISS/-9999999.0/
      INTEGER IWORD, IRET, ISIZE, NSPEC, LAT1, LOOP, IERR
      INTEGER KNUM, NUM_E_W, NUM_N_S, NFULLNS, NFULLEW
      REAL GRIDWE, GRIDNS, NORTH, SOUTH, WEST, EAST
      INTEGER NUMPTS
      DIMENSION NUMPTS(JPMAXLT)
#ifndef _CRAYFTN
#ifdef POINTER_64
      INTEGER*8 INEWAVE, IDISTNW, IZ2DSP, INEWIDX
#endif
#endif
      REAL NEWAVE
      POINTER ( INEWAVE, NEWAVE )
      DIMENSION NEWAVE( 1 )
      REAL*4 DISTNEW
      POINTER ( IDISTNW, DISTNEW )
      DIMENSION DISTNEW( 1 )
      REAL Z2DSP
      POINTER ( IZ2DSP, Z2DSP )
      DIMENSION Z2DSP( 1 )
      INTEGER NEWIDX
      POINTER ( INEWIDX, NEWIDX )
      DIMENSION NEWIDX( 1 )
      REAL RNLAT, RSLAT, STEP
      INTEGER NUMTABL, NUMPROD
      LOGICAL LCOEFFS, L98WAVE, LFRAME, LBITMP
      LOGICAL LDEBUG
C
C     Externals
      INTEGER WAVEXXX, WV2DXXX, AREACHK, FIXAREA
      INTEGER NUMPTNS, NUMPTWE, JNORSGG, MKBITMP
C
C ------------------------------------------------------------------
C     Section 1.   Initialise
C ------------------------------------------------------------------
C
  100 CONTINUE
C
      INTWAVE = 0
C
      LCOEFFS = .FALSE.
C
C     Check if debug option turned on
      CALL JDEBUG()
      LDEBUG = NDBG.GT.0
C
C     Allocate work array ZNFELDI if not already done.
C
      IF( IZNJDCI.NE.1952999238 ) THEN
        CALL JMEMHAN( 19, IZNFLDI, JPEXPAND, 1, IRET)
        IF( IRET.NE.0 ) THEN
          CALL INTLOG(JP_WARN,'INTWAVE: ZNFELDI allocate fail',JPQUIET)
          INTWAVE= IRET
          GOTO 900
        ENDIF
        IZNJDCI = 1952999238
      ENDIF
C
C     Unpack GRIB message headers (using ZMISS as missing data value).
C
      IRET = 1
      ISEC3(2) = NINT(ZMISS)
      ZSEC3(2) = ZMISS
      CALL GRIBEX (ISEC0,ISEC1,ISEC2,ZSEC2,ISEC3,ZSEC3,ISEC4,
     X             ZNFELDI,JPEXPAND,INGRIB,INLEN,IWORD,'J',IRET)
      IF( (IRET.NE.0).AND.(IRET.NE.811) ) THEN
        CALL INTLOG(JP_ERROR,'INTWAVE: GRIBEX decoding failed.',JPQUIET)
        INTWAVE = JPROUTINE + 1
        GOTO 900
      ENDIF
C
C     Check that the field can be handled
C
      NUMTABL = ISEC1(2)*1000 + ISEC1(1)
      NUMPROD = NUMTABL*1000 + ISEC1(6)
      L98WAVE = (NUMTABL.EQ.98140).OR.
     X          (NUMPROD.EQ.98131229).OR.
     X          (NUMPROD.EQ.98131232).OR.
     X          (NIREPR.EQ.26)
      IF( .NOT.L98WAVE ) THEN
        CALL INTLOG(JP_WARN,'INTWAVE: Not an ECMWF wave field',JPQUIET)
        INTWAVE = JPROUTINE + 2
        GOTO 900
      ENDIF
      IF( ISEC2(1).NE.0 ) THEN
        CALL INTLOG(JP_WARN,
     X    'INTWAVE: Not a lat/long field',JPQUIET)
        INTWAVE = JPROUTINE + 3
        GOTO 900
      ENDIF
      IF( (ISEC2(6).NE.128) .OR. (ISEC2(10).LT.10) ) THEN
        CALL INTLOG(JP_ERROR,
     X    'INTWAVE: Cannot handle longitude increment',ISEC2(10))
        INTWAVE = JPROUTINE + 4
        GOTO 900
      ENDIF
C
C ------------------------------------------------------------------
C     Section 2.   Sort out interpolation area.
C ------------------------------------------------------------------
C
  200 CONTINUE
C
      NSPEC = 1
      KNUM  = ISEC2(3)
C
C     Adjust (sub-)area limits to suit the grid
C
      IRET = FIXAREA()
      IF ( IRET .NE. 0 ) THEN
        CALL INTLOG(JP_ERROR, 'INTWAVE: FIXAREA failed.',JPQUIET)
        INTWAVE = JPROUTINE + 5
        GOTO 900
      ENDIF
      NORTH = FLOAT(NOAREA(1))/PPMULT
      WEST  = FLOAT(NOAREA(2))/PPMULT
      SOUTH = FLOAT(NOAREA(3))/PPMULT
      EAST  = FLOAT(NOAREA(4))/PPMULT
C
C     Calculate the number of points E-W and N-S in new grid area
C
      IF( (NOREPR.EQ.JPQUASI) .OR. (NOREPR.EQ.JPGAUSSIAN)) THEN
        GRIDWE  = NOGAUSS
        GRIDNS  = 0
      ELSE IF( NOREPR.EQ.JPREDLL ) THEN
        GRIDWE  = 360.0/NOLPTS((NOREDLL/2)+1)
        GRIDNS  = FLOAT(NOGRID(2))/PPMULT
      ELSE
        GRIDWE  = FLOAT(NOGRID(1))/PPMULT
        GRIDNS  = FLOAT(NOGRID(2))/PPMULT
      ENDIF
C
      IRET = AREACHK(GRIDWE,GRIDNS,NORTH,WEST,SOUTH,EAST)
      IF( IRET.NE.0 ) THEN
        INTWAVE = JPROUTINE + 6
        GOTO 900
      ENDIF
      NOAREA(1) = NINT(NORTH*PPMULT)
      NOAREA(2) = NINT(WEST*PPMULT)
      NOAREA(3) = NINT(SOUTH*PPMULT)
      NOAREA(4) = NINT(EAST*PPMULT)
C
      IF( (NOREPR.EQ.JPQUASI) .OR. (NOREPR.EQ.JPGAUSSIAN)) THEN
        GRIDWE  = 360.0/NOLPTS(NOGAUSS)
        NUM_E_W = NUMPTWE(WEST,EAST,GRIDWE)
        NFULLEW = NUMPTWE(0.0,360.0,GRIDWE) - 1
        NUM_N_S = JNORSGG(SOUTH,ROGAUSS,NOGAUSS,1) - 
     X            JNORSGG(NORTH,ROGAUSS,NOGAUSS,0) + 1
        NFULLNS = NOGAUSS*2
      ELSE IF( NOREPR.EQ.JPREDLL ) THEN
        NUM_E_W = NUMPTWE(WEST,EAST,GRIDWE)
        NFULLEW = NUMPTWE(0.0,360.0,GRIDWE) - 1
        NUM_N_S = NUMPTNS(NORTH,SOUTH,GRIDNS)
        NFULLNS = NOREDLL
      ELSE
        NUM_E_W = NUMPTWE(WEST,EAST,GRIDWE)
        NFULLEW = NUMPTWE(0.0,360.0,GRIDWE) - 1
        NUM_N_S = NUMPTNS(NORTH,SOUTH,GRIDNS)
        NFULLNS = NUM_N_S
      ENDIF
C
C
C ------------------------------------------------------------------
C     Section 3.   Interpolate wave fields other than 2D spectra.
C ------------------------------------------------------------------
C
  300 CONTINUE
C
C     Handle if not 2D spectra ..
C
      IF( (ISEC1(6).NE.JP2DSP).AND.(ISEC1(6).NE.JP2DSPQ) ) THEN
       IF( LDEBUG ) THEN
       CALL INTLOG(JP_DEBUG,
     X 'INTWAVE: Interpolate wave fields other than 2D spectra',JPQUIET)
       ENDIF
C
C       Get some scratch space for the interpolated field.
C
        ISIZE = NFULLEW * NUM_N_S
        CALL JMEMHAN( 3, INEWAVE, ISIZE, 1, IRET)
        IF ( IRET.NE.0 ) THEN
          CALL INTLOG(JP_ERROR,'INTWAVE: Get work space fail.',JPQUIET)
          INTWAVE = JPROUTINE + 7
          GOTO 900
        ENDIF
C
        ISIZE = NFULLEW * NFULLNS * 4
        CALL JMEMHAN( 4, INEWIDX, ISIZE, 1, IRET)
        IF ( IRET.NE.0 ) THEN
          CALL INTLOG(JP_ERROR,'INTWAVE: Get work space fail.',JPQUIET)
          INTWAVE = JPROUTINE + 8
          GOTO 900
        ENDIF
C
        ISIZE = NFULLEW * NFULLNS * 10
        CALL JMEMHAN( 5, IDISTNW, ISIZE, 1, IRET)
        IF ( IRET.NE.0 ) THEN
          CALL INTLOG(JP_ERROR,'INTWAVE: Get work space fail.',JPQUIET)
          INTWAVE = JPROUTINE + 9
          GOTO 900
        ENDIF

C       Interpolate the field
C
        IRET = WAVEXXX(ISEC2,ISEC4,NUM_N_S,GRIDNS,GRIDWE,INGRIB,NEWIDX,
     X                 DISTNEW,NEWAVE,NORTH,WEST,ZMISS)
        IF( IRET.NE.0 ) THEN
          CALL INTLOG(JP_ERROR,'INTWAVE: Interpolation failed.',JPQUIET)
          INTWAVE = JPROUTINE + 10
          GOTO 900
        ENDIF
C
C ------------------------------------------------------------------
C     Section 4.   Interpolate wave 2D spectra field.
C ------------------------------------------------------------------
C
      ELSE
C
  400   CONTINUE

      IF( LDEBUG ) THEN
      CALL INTLOG(JP_DEBUG,
     X 'INTWAVE: Interpolate wave 2D spectra field',JPQUIET)
      ENDIF
C
C       Find number of 2D spectra values at each point
C
        IF( ISEC4(8).NE.0 ) LCOEFFS = .TRUE.
        IF( (ISEC4(8).NE.0).AND.(ISEC1(6).NE.JP2DSPQ) ) THEN
          NSPEC = ISEC4(50) * ISEC4(51)
        ELSE
          NSPEC = 1
        ENDIF
C
C       Get some scratch space for the interpolated field.
C
        ISIZE = NSPEC * NFULLEW * NUM_N_S
        CALL JMEMHAN( 3, INEWAVE, ISIZE, 1, IRET)
        IF ( IRET.NE.0 ) THEN
          CALL INTLOG(JP_ERROR,'INTWAVE: Get work space fail.',JPQUIET)
          INTWAVE = JPROUTINE + 11
          GOTO 900
        ENDIF
C
        ISIZE = NFULLEW * NFULLNS
        CALL JMEMHAN( 4, INEWIDX, ISIZE, 1, IRET)
        IF ( IRET.NE.0 ) THEN
          CALL INTLOG(JP_ERROR,'INTWAVE: Get work space fail.',JPQUIET)
          INTWAVE = JPROUTINE + 12
          GOTO 900
        ENDIF
C
C       Interpolate the field
C
        IRET = WV2DXXX(ISEC2,ISEC4,NUM_N_S,GRIDNS,GRIDWE,
     X                 INGRIB,NEWIDX,NEWAVE,NORTH,WEST,ZMISS)
        IF( IRET.NE.0 ) THEN
          CALL INTLOG(JP_ERROR,'INTWAVE: Interpolation failed.',JPQUIET)
          INTWAVE = JPROUTINE + 13
          GOTO 900
        ENDIF
C
      ENDIF
C
C ------------------------------------------------------------------
C     Section 5.   Pack the interpolated field into GRIB.
C ------------------------------------------------------------------
C
  500   CONTINUE

C     If a 'bitmap' has been specified, build the bitmap
C
      LBITMP = LNOBITMP.AND.
     X         ((NOREPR.EQ.JPREGROT).OR.(NOREPR.EQ.JPREGULAR).OR.
     X          (NOREPR.EQ.JPGAUSSIAN))

      IF( LBITMP ) THEN
        CALL INTLOG(JP_DEBUG,'INTWAVE: MKBITMP is enabled',JPQUIET)
        IERR = MKBITMP(NUM_E_W,NUM_N_S,NEWAVE,ZMISS)
        IF( IERR.NE.0 ) THEN
          CALL INTLOG(JP_ERROR,'INTFB: Problem applying bitmap',JPQUIET)
          GOTO 900
        ENDIF
      ENDIF
C     If a 'frame' has been specified, build the frame
C
       LFRAME = LNOFRAME.AND.
     X         ((NOREPR.EQ.JPREGULAR).OR.(NOREPR.EQ.JPGAUSSIAN).OR.
     X          (NOREPR.EQ.JPREGROT ).OR.(NOREPR.EQ.JPFGGROT  ) )

         CALL INTLOG(JP_DEBUG,'INTWAVE: NUM_E_W ',NUM_E_W)
         CALL INTLOG(JP_DEBUG,'INTWAVE: NUM_N_S ',NUM_N_S)
      IF( LFRAME ) THEN
           CALL INTLOG(JP_DEBUG,'INTWAVE: MKFRAME is enabled',JPQUIET)
           CALL INTLOG(JP_DEBUG,'INTWAVE: NOFRAME ',NOFRAME)
         CALL MKFRAME(NUM_E_W,NUM_N_S,NEWAVE,ZMISS,NOFRAME) 
      ENDIF
C
C     GRIB sections 2 and 3 (bitmap) included
C
      ISEC1(5) = 192
C
      IF( (NOREPR.EQ.JPQUASI) .OR. (NOREPR.EQ.JPREDLL) ) THEN
C
C       Reduced gaussian or reduced lat/long with (possible) subarea
C
        IF( NOREPR.EQ.JPQUASI ) THEN
          ISEC2(1) = JPGAUSSIAN
          ISEC2(10)= NOGAUSS
        ELSE
          ISEC2(1) = JPREGULAR
          ISEC2(10)= NINT(GRIDNS*1000.0)
        ENDIF
        ISEC2(2) = 255
        ISEC2(3) = NUM_N_S
        ISEC2(5) = NINT(WEST*1000.0)
        ISEC2(6) = 0
        ISEC2(8) = NINT(EAST*1000.0)
        ISEC2(17)= 1
        ISEC4(1) = 0
C
        LAT1 = 0
 510    CONTINUE
        LAT1 = LAT1 + 1
        IF( NOREPR.EQ.JPQUASI ) THEN
          RNLAT = ROGAUSS(LAT1)
          RSLAT = ROGAUSS(LAT1+NUM_N_S-1)
        ELSE
          RNLAT = 90.0 - (LAT1-1)*GRIDNS
          RSLAT = 90.0 - (LAT1+NUM_N_S-2)*GRIDNS
        ENDIF
        IF( RNLAT.GT.NORTH ) GOTO 510
C
        ISEC2(4) = NINT(RNLAT*1000.0)
        ISEC2(7) = NINT(RSLAT*1000.0)
C
        DO LOOP = LAT1, (NUM_N_S+LAT1-1)
          ISEC2(23+LOOP-LAT1) = NOLPTS(LOOP)
          ISEC4(1) = ISEC4(1) + ISEC2(23+LOOP-LAT1)
        ENDDO
C
      ELSE
C
C       Regular gaussian or lat/long with (possible) subarea
C
        IF( NOREPR.EQ.JPGAUSSIAN ) THEN
          ISEC2(1) = JPGAUSSIAN
        ELSE
          ISEC2(1) = JPREGULAR
        ENDIF
        ISEC2(2) = NUM_E_W
        ISEC2(3) = NUM_N_S
        ISEC2(4) = NINT(NORTH*1000.0)
        ISEC2(5) = NINT(WEST*1000.0)
        ISEC2(6) = 128
        ISEC2(7) = NINT(SOUTH*1000.0)
        ISEC2(8) = NINT(EAST*1000.0)
        ISEC2(9) = NINT(GRIDWE*1000.0)
        IF( NOREPR.EQ.JPGAUSSIAN ) THEN
          ISEC2(10) = NOGAUSS
        ELSE
          ISEC2(10) = NINT(GRIDNS*1000.0)
        ENDIF
        ISEC2(17)= 0
        ISEC4(1) = NUM_E_W * NUM_N_S
      ENDIF
C
C     Use -9999999 as missing data value.
C
      ISEC3(2) = NINT(ZMISS)
      ZSEC3(2) = ZMISS
C
      ISEC4(1) = ISEC4(1) * NSPEC
      ISEC4(2) = NOACC
      IF( LCOEFFS ) ISEC4(6)  = 16
C            `-----> wave fields have additional flags for
C                    NC1 and NC2 coefficients (floats stored
C                    in integer array isec4)
      IRET = 1
C
C     If grid-point output, setup for 2nd order packing if requested.
C
      IF( (NOREPR.NE.JPSPHERE) .AND. (NOREPR.NE.JPSPHROT) ) THEN
        HFUNC = 'C'
        IF( NOHFUNC.EQ.'K' ) THEN
          HFUNC = 'K'
          ISEC4(4)  = 64
          ISEC4(6)  = 16
          ISEC4(9)  = 32
          ISEC4(10) = 16
          ISEC4(12) = 8
          ISEC4(13) = 4
          ISEC4(14) = 0
          ISEC4(15) = -1
        ELSE
          ISEC4(4)  = 0
        ENDIF
      ELSE
        HFUNC = 'C'
        IF( NOHFUNC.EQ.'C' ) THEN
          ISEC2(6) = 2
          ISEC4(4) = 64
        ELSE IF( NOHFUNC.EQ.'S' ) THEN
          ISEC2(6) = 1
          ISEC4(4) = 0
        ENDIF

      ENDIF

C
      CALL GRIBEX (ISEC0,ISEC1,ISEC2,ZSEC2,ISEC3,ZSEC3,ISEC4,
     X             NEWAVE,ISEC4(1),OUTGRIB,OUTLEN,IWORD,HFUNC,IRET)
C
      IF ( IRET.NE.0 ) THEN
        CALL INTLOG(JP_ERROR,'INTWAVE: GRIBEX encoding failed.',IRET)
        INTWAVE = JPROUTINE + 14
        GOTO 900
      ENDIF
      OUTLEN = IWORD
C
C ------------------------------------------------------------------
C*    Section 9.   Closedown.
C ------------------------------------------------------------------
C
  900 CONTINUE
C
C     Clear change flags for next product processing
C
      LCHANGE = .FALSE.
      LSMCHNG = .FALSE.
C
      RETURN
      END

C
C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities
C granted to it by virtue of its status as an intergovernmental organisation
C nor does it submit to any jurisdiction.
C

      INTEGER FUNCTION WAVEXX2(NPARAM, NUMLATS, NPTS,
     X                         NLATS, STEPNS, STEPWE,
     X                         OLDWAVE, NEWWAVE, NORTH, WEST, PMISS)
C
C---->
C*****WAVEXX2*
C
C     PURPOSE
C     -------
C
C     Interpolates wave fields (except 2D spectra).
C
C
C     INTERFACE
C     ---------
C
C     IRET = WAVEXX2(NPARAM, NUMLATS, NPTS,
C    X               NLATS, STEPNS, STEPWE,
C    X               OLDWAVE, NEWWAVE, NORTH, WEST, PMISS)
C
C     Input arguments
C     ---------------
C
C     NPARAM  - Parameter ID
C     NUMLATS - Input lat number north-south
C     NPTS    - Array giving number of points along each latitude
C               for input field (empty latitudes have entry 0)
C     NLATS   - Number of points N-S in new grid
C     STEPNS  - Output grid north-south resolution (degrees)
C     STEPWE  - Output grid west-east resolution (degrees)
C     OLDWAVE - Original wave field
C     NORTH   - Output grid northernmost latitude (degrees)
C     WEST    - Output grid westernmost longitude (degrees)
C     PMISS   - Missing data value
C
C     Output arguments
C     ----------------
C
C     NEWWAVE - New wave field
C
C     Function returns 0 if the interpolation was OK.
C
C
C     METHOD
C     ------
C
C     Builds the index of neighbouring points for the output grid.
C     Then works through the output grid points, checking for subarea
C     boundaries and looking up neighbouring point values and weights
C     (which may be missing data).
C
C
C     EXTERNALS
C     ---------
C
C     WAVEIDX - Determines which nearest neighbour points to use for
C               interpolating to new output grid point
C     NUMPTWE - Calculates number of grid points between west/east
C               area boundaries
C     INTLOG  - Log error message
C     JMALLOC - Dynamically allocate memory (deallocation -JFREE- not used)
C
C
C     REFERENCE
C     ---------
C
C     None.
C
C
C     Author.
C     -------
C
C     S. Curic      ECMWF    Jun 2009
C
C
C
C----<
C
      IMPLICIT NONE
C
C     Parameters
C
#include "parim.h"
C
      INTEGER JPROUTINE, JPMXLAT,
     X        JPNW, JPNE, JPSW, JPSE, JPN, JPS,
     X        JPDISNW, JPDISNE, JPDISSW, JPDISSE
      PARAMETER( JPROUTINE = 40100 )
      PARAMETER( JPMXLAT   =  1801 ) ! allow up to 0.1 degree resolution
      PARAMETER( JPNW=1, JPNE=2, JPSW=3, JPSE=4, JPN=5, JPS=6,
     X           JPDISNW=7, JPDISNE=8, JPDISSW=9, JPDISSE=10 )
C
#include "nifld.common"
#include "nofld.common"
#include "grspace.h"
C
C     Arguments
C
      INTEGER NPARAM
      INTEGER NUMLATS, NPTS(*), NLATS
      REAL STEPNS, STEPWE, OLDWAVE(*), NEWWAVE(*), NORTH, WEST, PMISS
C
C     Local variables
C
      INTEGER IEOFSET, INDEX, ISTART, IWEST, IWOFSET, KNEWNUM,
     X        KOLDNUM, LOOP, MISSLAT, NCOL, NEXT,
     X        NEXTWV, NROW, NUMNEW(JPMXLAT)
      REAL    AWEST, EAST, NEWLATS(JPMXLAT), OLDLATS(JPMXLAT),
     X        ONORTH, OSOUTH, PTLAT, PTLONG, RLATINC, ROWINC,
     X        SOUTH, OEAST, OWEST
      INTEGER INE, INW, ISE, ISW
      LOGICAL LDIREC
      REAL    C1, C2, CC, CNE_PT, CNW_PT, CSE_PT, CSW_PT, DI1N, DI1S,
     X        DI2N, DI2S, DISNE, DISNW, DISSE, DISSW, DK1, DK2, NE_PT,
     X        NW_PT, RAD, S1, S2, SE_PT, SNE_PT, SNW_PT, SS, SSE_PT,
     X        SSW_PT, SW_PT, U1, U2
C
      DATA RAD/0.01745329251/
C
C     Large, resolution-dependent arrays
C
      LOGICAL IS_ALLOCATED_LARGEARRAY
      DATA    IS_ALLOCATED_LARGEARRAY /.FALSE./
      SAVE    IS_ALLOCATED_LARGEARRAY
C
      INTEGER NEWIDX(4,JPARRAYDIM_WAVE)
#ifndef _CRAYFTN
#ifdef POINTER_64
      INTEGER*8 P_NEWIDX
#endif
#endif
      POINTER(P_NEWIDX,NEWIDX)
      SAVE P_NEWIDX
C
      REAL*4 DISTNEW(10,JPARRAYDIM_WAVE)
#ifndef _CRAYFTN
#ifdef POINTER_64
      INTEGER*8 P_DISTNEW
#endif
#endif
      POINTER(P_DISTNEW,DISTNEW)
      SAVE P_DISTNEW
C
C     Externals
C
      INTEGER  WAVEIDX, NUMPTWE
#ifdef POINTER_64
      INTEGER*8 JMALLOC
#else
      INTEGER JMALLOC
#endif
      LOGICAL IS_WAVE_DIRECTION
      EXTERNAL WAVEIDX, NUMPTWE, JMALLOC, IS_WAVE_DIRECTION
C
C     -----------------------------------------------------------------|
C*    Section 1. Initalisation.
C     -----------------------------------------------------------------|
C
  100 CONTINUE
C
      WAVEXX2 = 0
C
C     Initialise the bitmap value lookup function
C
      MISSLAT = 0

      ONORTH = FLOAT(NIAREA(1))/PPMULT
      OSOUTH = FLOAT(NIAREA(3))/PPMULT
      RLATINC = FLOAT(NIGRID(2))/PPMULT
C
C     Calculate number of latitudes if grid had been full from
C     North pole to South pole
C
      IF( NUMLATS.GT.JPMXLAT ) THEN
        CALL INTLOG(JP_ERROR,
     X    'WAVEXX2: Number of latitudes in input grid = ',NUMLATS)
        CALL INTLOG(JP_ERROR,
     X    'WAVEXX2: And is greater than allowed maximum = ',JPMXLAT)
        WAVEXX2 = JPROUTINE + 1
        GOTO 900
      ENDIF
C
C
C     Fill an array with the number of points at each latitude for the
C     input field.
C
      IF(NIREPR.EQ.JPREDLL) THEN
C
C       Input field is a reduced latitude/longitude grid
C
C       .. but it may be 'pseudo-gaussian' in layout
C       (ie global, symmetric about the equator but no latitude
C        at the equator)
C
        IF( (ONORTH.NE.90.0).AND.(MOD(NUMLATS,2).EQ.0) ) THEN
C
          ONORTH = FLOAT(NIAREA(1))
          OSOUTH = FLOAT(NIAREA(3))
          RLATINC = FLOAT(NIGRID(2))

        ENDIF
C
        DO LOOP = 1, NUMLATS
          OLDLATS(LOOP) = 90.0 - (LOOP-1)*RLATINC
        ENDDO
C
      ELSE
C
C       Input field is a regular latitude/longitude grid
C
        DO LOOP = 1, NUMLATS
          OLDLATS(LOOP) = ONORTH - (LOOP-1)*RLATINC
        ENDDO
C
        NPTS(1:NUMLATS) = NIWE
C
      ENDIF
C
C     Allocate large, resolution-dependent arrays
      IF (.NOT. IS_ALLOCATED_LARGEARRAY) THEN
        P_NEWIDX  = JMALLOC( 4*JPARRAYDIM_WAVE*JPBYTES)  !  4*len*bytes
        P_DISTNEW = JMALLOC(10*JPARRAYDIM_WAVE*4)        ! 10*len*bytes
        IF( (P_NEWIDX.EQ.0) .OR. (P_DISTNEW.EQ.0) ) THEN
          CALL INTLOG(JP_ERROR,'WAVEXX2: JMALLOC fail',JPQUIET)
          WAVEXX2 = JPROUTINE + 1
          GOTO 900
        ENDIF
        IS_ALLOCATED_LARGEARRAY = .TRUE.
      END IF
C
C     -----------------------------------------------------------------|
C*    Section 2. Setup number of points at each latitude for the
C                output latitude/longitude field.
C     -----------------------------------------------------------------|
C
  200 CONTINUE
C
      IF( (NOREPR.EQ.JPQUASI) .OR. (NOREPR.EQ.JPGAUSSIAN) ) THEN
C
C       Reduced (quasi-regular) gaussian output
C
        KNEWNUM = NOGAUSS*2
        DO LOOP = 1, KNEWNUM
          NUMNEW(LOOP)  = NOLPTS(LOOP)
          NEWLATS(LOOP) = ROGAUSS(LOOP)
        ENDDO
C
      ELSE IF( NOREPR.EQ.JPREDLL ) THEN
C
C       Reduced (quasi-regular) lat/long output
C
        KNEWNUM = NOREDLL
        DO LOOP = 1, KNEWNUM
          NUMNEW(LOOP)  = NOLPTS(LOOP)
          NEWLATS(LOOP) = ROREDLL(LOOP)
        ENDDO
C
      ELSE
C
C       Regular output
C
        MISSLAT = NINT((90.0 - NORTH)/STEPNS)
        DO LOOP = 1, MISSLAT
          NUMNEW(LOOP)    = 0
        ENDDO
        DO LOOP = 1, NLATS
          NUMNEW(LOOP+MISSLAT) = NINT(360.0/STEPWE)
        ENDDO
C
        KNEWNUM = MISSLAT + NLATS
        DO LOOP = 1, KNEWNUM
          NEWLATS(LOOP) = 90.0 - (LOOP-1)*STEPNS
        ENDDO
C
      ENDIF
C
C     -----------------------------------------------------------------|
C*    Section 3. Get the input GRIB field characteristics.
C     -----------------------------------------------------------------|
C
  300 CONTINUE
C
C     Calculate the indices of the input grid points to be used for
C     the output points
C
      OWEST = FLOAT(NIAREA(2))/PPMULT
      OEAST = FLOAT(NIAREA(4))/PPMULT

      WAVEXX2 = WAVEIDX(NUMLATS,NPTS,OLDLATS,OWEST,OEAST,
     X                  KNEWNUM, NUMNEW, NEWLATS, NEWIDX, DISTNEW)
      IF( WAVEXX2.NE.0 ) THEN
        CALL INTLOG(JP_ERROR,
     X    'WAVEXX2: Unable to calculate output grid indices',JPQUIET)
        WAVEXX2 = JPROUTINE + 3
        GOTO 900
      ENDIF
C
C     Wave direction parameters need special handling
      LDIREC = IS_WAVE_DIRECTION(NPARAM)
C
C     -----------------------------------------------------------------|
C*    Section 4. Work through the output subarea.
C     -----------------------------------------------------------------|
C
  400 CONTINUE
C
C     Fill in the wave spectra values
C
      NEXT = 0
      NEXTWV = 0
C
      SOUTH = NOAREA(3)/PPMULT
      EAST  = NOAREA(4)/PPMULT
      ISTART = 0
C
C     Work down through latitudes from north to south.
C
      DO NROW = 1, KNEWNUM
C
C       If inside north-south (subarea) boundaries ..
C
        IF( (NOREPR.EQ.JPGAUSSIAN).OR.(NOREPR.EQ.JPQUASI) ) THEN
          PTLAT = ROGAUSS(NROW)
        ELSE
          PTLAT = 90.0 - (NROW-1)*STEPNS
        ENDIF
C
        IF( (PTLAT.LE.NORTH).AND.(ABS(PTLAT-SOUTH).GT.-0.0005) ) THEN
C
C         Calculate number of points between west boundary of area and
C         Greenwich
C
          ROWINC = 360.0/NUMNEW(NROW)
C
          IWEST = INT(WEST/ROWINC)
          IF (ABS(WEST - IWEST*ROWINC).GT.0.000001) THEN
            IF (WEST.GT.0.0) IWEST = IWEST + 1
            IF (WEST.LT.0.0) IWEST = IWEST - 1
          ENDIF
          AWEST = IWEST * ROWINC
          IWOFSET = NUMPTWE(AWEST,0.0,ROWINC)
          IEOFSET = NUMPTWE(AWEST,EAST,ROWINC)
C
C         Work through subarea longitudes from west to east.
C
          DO NCOL = 1, NUMNEW(NROW)
            PTLONG = AWEST + (NCOL-1)*ROWINC
            NEXT = NUMPTWE(AWEST,PTLONG,ROWINC)
            IF( (NEXT.LE.IEOFSET).AND.(NEXT.GE.0) ) THEN
C
C             .. and inside west-east (subarea) boundaries
C
              NEXT = 1 + NEXT - IWOFSET
              IF( NEXT.LE.0) NEXT = NEXT + NUMNEW(NROW)
              NEXT = NEXT + ISTART
              NEXTWV = NEXTWV + 1
C
              INW = NEWIDX(JPNW,NEXT)
              INE = NEWIDX(JPNE,NEXT)
              ISW = NEWIDX(JPSW,NEXT)
              ISE = NEWIDX(JPSE,NEXT)
C
C             Test if any of the four neighbouring points is missing.
C
                IF( (OLDWAVE(INW).EQ.PMISS) .OR.
     X              (OLDWAVE(ISW).EQ.PMISS) .OR.
     X              (OLDWAVE(INE).EQ.PMISS) .OR.
     X              (OLDWAVE(ISE).EQ.PMISS) ) THEN
                ENDIF

              IF( (INW.EQ.0) .OR. (OLDWAVE(INW).EQ.PMISS) .OR.
     X            (ISW.EQ.0) .OR. (OLDWAVE(ISW).EQ.PMISS) .OR.
     X            (INE.EQ.0) .OR. (OLDWAVE(INE).EQ.PMISS) .OR.
     X            (ISE.EQ.0) .OR. (OLDWAVE(ISE).EQ.PMISS) ) THEN
                IF( (OLDWAVE(INW).EQ.PMISS) .AND.
     X              (OLDWAVE(ISW).EQ.PMISS) .AND.
     X              (OLDWAVE(INE).EQ.PMISS) .AND.
     X              (OLDWAVE(ISE).EQ.PMISS) ) THEN
                ENDIF
C
C               If so, take nearest grid point value.
C
                DISNW = DISTNEW(JPDISNW,NEXT)
                DISNE = DISTNEW(JPDISNE,NEXT)
                DISSW = DISTNEW(JPDISSW,NEXT)
                DISSE = DISTNEW(JPDISSE,NEXT)
C
                IF( (DISNW.LE.DISNE).AND.
     X              (DISNW.LE.DISSW).AND.
     X              (DISNW.LE.DISSE)) THEN
                  INDEX = INW
C
                ELSE IF( (DISNE.LE.DISSW).AND.
     X                   (DISNE.LE.DISSE) ) THEN
                  INDEX = INE
C
                ELSE IF( (DISSW.LE.DISSE) ) THEN
                  INDEX = ISW
C
                ELSE
                  INDEX = ISE
                ENDIF
C
                IF(INDEX.EQ.0.OR.(OLDWAVE(INDEX).EQ.PMISS)) THEN
C
C                 Nearest point is missing
C
                  NEWWAVE(NEXTWV) = PMISS
C
                ELSE
                  NEWWAVE(NEXTWV) =  OLDWAVE(INDEX)
                ENDIF
C
              ELSE
C
C               Use bi-linear interpolation from four
C               neighbouring sea points (possible conv REAL*4 to REAL*8)
C
                DI1N = DISTNEW(JPNW,NEXT)
                DI2N = DISTNEW(JPNE,NEXT)
                DI1S = DISTNEW(JPSW,NEXT)
                DI2S = DISTNEW(JPSE,NEXT)
                DK1  = DISTNEW(JPN,NEXT)
                DK2  = DISTNEW(JPS,NEXT)
C
                NW_PT = OLDWAVE(INW)
                NE_PT = OLDWAVE(INE)
                SW_PT = OLDWAVE(ISW)
                SE_PT = OLDWAVE(ISE)
                IF( .NOT. LDIREC ) THEN
                  U1 = NW_PT*DI2N + NE_PT*DI1N
                  U2 = SW_PT*DI2S + SE_PT*DI1S
                  NEWWAVE(NEXTWV) = U1*DK2 + U2*DK1
                ELSE
C
C                 Fields representing a 'direction': resolve into
C                 components and interpolate each separately.
C
#if (defined REAL_8)
#define __ATAN2 DATAN2
#define __COS   DCOS
#define __SIN   DSIN
#else
#define __ATAN2 ATAN2
#define __COS   COS
#define __SIN   SIN
#endif
                  CNW_PT = __COS(NW_PT*RAD)
                  CNE_PT = __COS(NE_PT*RAD)
                  CSW_PT = __COS(SW_PT*RAD)
                  CSE_PT = __COS(SE_PT*RAD)
                  SNW_PT = __SIN(NW_PT*RAD)
                  SNE_PT = __SIN(NE_PT*RAD)
                  SSW_PT = __SIN(SW_PT*RAD)
                  SSE_PT = __SIN(SE_PT*RAD)
                  C1 = CNW_PT*DI2N + CNE_PT*DI1N
                  C2 = CSW_PT*DI2S + CSE_PT*DI1S
                  CC = C1*DK2 + C2*DK1
                  S1 = SNW_PT*DI2N + SNE_PT*DI1N
                  S2 = SSW_PT*DI2S + SSE_PT*DI1S
                  SS = S1*DK2 + S2*DK1
                  IF( SS.LT.0.0 ) THEN
                    NEWWAVE(NEXTWV) = __ATAN2(SS,CC)/RAD + 360.0
                  ELSE
                    NEWWAVE(NEXTWV) = __ATAN2(SS,CC)/RAD
                  ENDIF
#undef __SIN
#undef __COS
#undef __ATAN2
                ENDIF
              ENDIF
            ENDIF
          ENDDO
C
        ENDIF
        ISTART = ISTART + NUMNEW(NROW)
      ENDDO
C
C     -----------------------------------------------------------------|
C*    Section 9. Closedown.
C     -----------------------------------------------------------------|
C
  900 CONTINUE
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities
C granted to it by virtue of its status as an intergovernmental organisation
C nor does it submit to any jurisdiction.
C

      SUBROUTINE JSGGGP( PSHUP, KTRUNC, PNORTH, PSOUTH, PWEST, PEAST,
     X                    KNUM, HTYPE, KPTS, POUTF, LUV, KRET)
C
C---->
C**** JSGGGP
C
C     PURPOSE
C     _______
C
C     This routine converts streched spectral fields to a gaussian
C     grid field.
C
C     INTERFACE
C     _________
C
C     CALL JSGGGP( PSHUP, KTRUNC, PNORTH, PSOUTH, PWEST, PEAST,
C    X                    KNUM, HTYPE, KPTS, POUTF, LUV, KRET)
C
C     Input parameters
C     ________________
C
C     PSHUP    - Spherical harmonics field, unpacked
C     KTRUNC   - Truncation number of spherical harmonics field
C     PNORTH   - Northernmost latitude for output field (degrees)
C     PSOUTH   - Southernmost latitude for output field (degrees)
C     PWEST    - Westernmost longitude for output field (degrees)
C     PEAST    - Easternmost longitude for output field (degrees)
C     KNUM     - Gaussian grid number
C     HTYPE    - Gaussian grid type
C                = 'R' for reduced ("quasi-regular"),
C                = 'O' for reduced/octahedral,
C                = 'F' for full,
C                = 'U' for user-defined reduced gaussian grid
C     KPTS     - Array specifying number of points at each line of
C                latitude if HTYPE = 'U'.
C                (Must be big enough for both hemispheres, but only
C                 needs to give Northern hemisphere values from pole
C                 to latitude nearest the Equator.)
C     LUV      - Code indicating whether or not the field is a wind
C                component field;
C                = 1 if U or V field.
C
C     Output parameters
C     ________________
C
C     KPTS     - Array specifying number of points at each line of
C                latitude; user defined values if HTYPE = 'U'.
C                (Must be big enough for both hemispheres)
C     POUTF    - Output grid point field
C     KRET     - Return status code
C                0 = OK
C
C     Common block usage
C     __________________
C
C     JDCNDBG
C
C     Method
C     ______
C
C     Converts stretched 'latitude' to real latitude and then
C     interpolates along the real latitude line.
C
C
C     Externals
C     _________
C
C     JGETGG   - Pick up the definition of the gaussian grid.
C     JJSET99  - Sets up FFT
C     JNORSGG  - Determines which latitude row in a gaussian grid is
C                north or south of a given latitude
C     JSYMGG   - Generate symmetric grid from spherical harmonics
C     JMKOFGG  - Builds offsets into storage array
C     JDEBUG   - Checks environment variable to switch on/off debug
C     INTLOG   - Logs output messages
C     INTLOGR  - Logs output messages
C
C
C     Reference
C     _________
C
C     None
C
C
C     Comments
C     ________
C
C     None
C
C
C     AUTHOR
C     ______
C
C     J.D.Chambers      ECMWF      July 1999
C
C     MODIFICATIONS
C     _____________
C
C
C     None
C
C----<
C     _______________________________________________________
C
C
      IMPLICIT NONE
#include "jparams.h"
#include "parim.h"
#include "current.h"
#include "nifld.common"
#include "nofld.common"
#include "grfixed.h"
C
C     Subroutine arguments
C
      COMPLEX   PSHUP
      DIMENSION PSHUP(*)
      INTEGER   KTRUNC, KNUM, KPTS, KRET
      DIMENSION KPTS(*)
      CHARACTER*1 HTYPE
      REAL      PNORTH, PSOUTH, PWEST, PEAST
      REAL      POUTF
      DIMENSION POUTF(*)
      INTEGER   LUV
C
C     Parameters
C
      INTEGER JPROUTINE
      PARAMETER ( JPROUTINE = 31600 )
      REAL DEG2RAD
      PARAMETER ( DEG2RAD = PPI/180.0 )
C
C     Local variables
C
      INTEGER ILON, ILONOLD, ITOUP1, IJPWR, NUMPTS
      DIMENSION IJPWR(JPMAX)
      INTEGER ILUNIT
      INTEGER NXTROW
      REAL RINTVL, ZCOSI, ZLAT
      REAL ZFACTOR(JPMAX)
C
      INTEGER IMFAX
      REAL ATRIGS
      DIMENSION IMFAX(10),ATRIGS(JPLONO*2)
#ifndef _CRAYFTN
#ifdef POINTER_64
      INTEGER*8 IALEG, IZFA
#endif
#endif
      REAL ALEG
      DIMENSION ALEG(1)
      POINTER ( IALEG, ALEG )
      REAL ZFA
      DIMENSION ZFA(2)
      POINTER ( IZFA, ZFA )
      INTEGER ISIZE
      DATA ISIZE/0/
      SAVE ISIZE, IZFA
C
      INTEGER J108, NNORTH, NSOUTH, NFLAG
      INTEGER NOFSET, LOOP
      DIMENSION NOFSET(JPMAX)
      INTEGER INORTH, ISOUTH, IMAGE
      REAL ALAT
      DIMENSION ALAT(JPMAX)
C
      SAVE ILUNIT
C
      LOGICAL LDEBUG, LFIRST
      DATA LFIRST/.TRUE./
      SAVE LDEBUG, LFIRST
C
      INTEGER  JNORSGG
      EXTERNAL JNORSGG
C     _______________________________________________________
C
C*    Section 1.    Initialization.
C     _______________________________________________________
C
  100 CONTINUE
C
      CALL JDEBUG( )
      LDEBUG = NDBG.GT.0
C
C
C     First time through, dynamically allocate memory for workspace
C
      IF( LFIRST ) THEN
        LFIRST = .FALSE.
        ISIZE =  (JPLONO+2)*64
        CALL JMEMHAN( 10, IZFA, ISIZE, 1, KRET)
        IF( KRET.NE.0 ) THEN
          CALL INTLOG(JP_ERROR,'JSGGGP: memory allocation error.',IZFA)
          KRET = JPROUTINE + 1
          GOTO 990
        ENDIF
      ENDIF
C
      IF( LDEBUG ) THEN
        CALL INTLOG(JP_DEBUG,'JSGGGP: Input parameters:',JPQUIET)
        CALL INTLOG(JP_DEBUG,
     X    'JSGGGP: Spherical harmonic truncation = ', KTRUNC)
        CALL INTLOGR(JP_DEBUG,
     X    'JSGGGP: Northern latitude for output = ', PNORTH)
        CALL INTLOGR(JP_DEBUG,
     X    'JSGGGP: Southern latitude for output = ', PSOUTH)
        CALL INTLOGR(JP_DEBUG,
     X    'JSGGGP: Western longitude for output = ', PWEST)
        CALL INTLOGR(JP_DEBUG,
     X    'JSGGGP: Eastern longitude for output = ', PEAST)
        CALL INTLOG(JP_DEBUG,
     X    'JSGGGP: Gaussian grid number = ', KNUM)
C
        IF( HTYPE.EQ.'R' .OR. HTYPE.EQ.'r' ) CALL INTLOG(JP_DEBUG,
     X    'JSGGGP: Grid type is Reduced.',JPQUIET)
        IF( HTYPE.EQ.'O' .OR. HTYPE.EQ.'o' ) CALL INTLOG(JP_DEBUG,
     X    'JSGGGP: Grid type is Reduced/octahedral.',JPQUIET)
        IF( HTYPE.EQ.'F' .OR. HTYPE.EQ.'f' ) CALL INTLOG(JP_DEBUG,
     X    'JSGGGP: Grid type is Full.',JPQUIET)
        IF( HTYPE.EQ.'U' .OR. HTYPE.EQ.'u' ) CALL INTLOG(JP_DEBUG,
     X    'JSGGGP: Grid type is User.',JPQUIET)
        CALL INTLOG(JP_DEBUG,
     X    'JSGGGP: Field code( = 1 for U or V) = ', LUV)
C
        IF( HTYPE.EQ.'u' .OR. HTYPE.EQ.'U' ) THEN
          CALL INTLOG(JP_DEBUG,'JSGGGP: User-supplied values.',JPQUIET)
          CALL INTLOG(JP_DEBUG,'JSGGGP: No. pts at each line:',JPQUIET)
          DO NDBGLP = 1, 20
            CALL INTLOG(JP_DEBUG,' ',KPTS( NDBGLP ))
          ENDDO
        ENDIF
      ENDIF
C
C     Pick up the file containing the definition of the gaussian grid.
C
      IF( (NOGAUSO.NE.KNUM).OR.(HOGAUST.NE.HTYPE) ) THEN
        CALL JGETGG( KNUM, HTYPE, ALAT, KPTS, KRET)
        IF( KRET.NE.0 ) GOTO 990
        NOGAUSO = KNUM
        HOGAUST = HTYPE
      ELSE
        DO LOOP = 1, KNUM*2
          ALAT(LOOP) = ROGAUSS(LOOP)
          KPTS(LOOP) = NOLPTS(LOOP)
        ENDDO
      ENDIF
C
C     Calculate the true latitudes and the map factor.
C
      DO LOOP = 1, KNUM*2
        CALL STRLAT(ALAT(LOOP), RISTRET, 0, ALAT(LOOP), ZFACTOR(LOOP))
      ENDDO
C
C     Coefficients are to generated 'on the fly'
C
      LON_FLY = .TRUE.
      LFILEIO = .FALSE.
      LMEMORY = .FALSE.
      LSHARED = .FALSE.
      LMAPPED = .FALSE.
      ISIZE =  (KTRUNC+1)*(KTRUNC+2)
      CALL JMEMHAN( 14, IALEG, ISIZE, 1, KRET)
      IF( KRET.NE.0 ) THEN
        CALL INTLOG(JP_ERROR,'JSGGGP: memory allocate error.',IALEG)
        KRET = JPROUTINE + 2
        GOTO 990
      ENDIF
C
      IF( KRET.NE.0 ) THEN
        CALL INTLOG(JP_ERROR,
     X    'JSGGGP: Failed to open legendre function file',JPQUIET)
        KRET = JPROUTINE + 3
        GOTO 990
      ENDIF
C
      NNORTH = JNORSGG( PNORTH, ALAT, KNUM, 1)
      NSOUTH = JNORSGG( PSOUTH, ALAT, KNUM, 0)
      IF( LDEBUG ) THEN
        CALL INTLOG(JP_DEBUG,
     X    'JSGGGP: Gaussian latitudes in requested area:',JPQUIET)
        CALL INTLOG(JP_DEBUG,'JSGGGP: NORTH = ',NNORTH)
        CALL INTLOG(JP_DEBUG,'JSGGGP: SOUTH = ',NSOUTH)
      ENDIF
C
C
C     For calculation purposes, the number of longitude points for each
C     latitude row has to be greater than 2*(output truncation) to
C     ensure the fourier transform is exact (see Reference, page 10).
C
C     The following loop calculates the power of 2 to be used as a
C     multipier for each row to ensure there are enough points.
C     Later, when filling the output array POUTF, the longitude points
C     have to be taken selectively to avoid the intermediate generated
C     points, picking up values only at the required longitudes.
C
      ITOUP1 = KTRUNC
      DO 108 J108 = 1, KNUM
        IMAGE = 2*KNUM - J108 + 1
        ILON        = KPTS(J108)
        IJPWR(J108) = 1
 104    CONTINUE
          IF(ILON .GT. 2*ITOUP1) GOTO 106
          IJPWR(J108) = IJPWR(J108)*2
          ILON        = ILON*2
          GOTO 104
 106    CONTINUE
        IJPWR(IMAGE) = IJPWR(J108)
 108  CONTINUE
C
C     _______________________________________________________
C
C*    Section 2.    Work out geometry of the request
C     _______________________________________________________
C
 200  CONTINUE
C
C     Latitude rows are generated from row INORTH to ISOUTH.
C     Selection is carried out for actual requested rows when the
C     calculated values are moved to the output array.
C
      INORTH = NNORTH
      ISOUTH = NSOUTH
C
C     Setup the storage offset for the given latitude range
C
 220  CONTINUE
C
      IF( LDEBUG ) THEN
        CALL INTLOG(JP_DEBUG,'JSGGGP: INORTH = ', INORTH)
        CALL INTLOG(JP_DEBUG,'JSGGGP: ISOUTH = ', ISOUTH)
      ENDIF
      CALL JMKOFGG(HTYPE,NNORTH,NSOUTH,PWEST,PEAST,KNUM,KPTS,NOFSET)
C
C     _______________________________________________________
C
C*    Section 3.    Process one row at a time.
C     _______________________________________________________
C
 300  CONTINUE
C
      IF( LDEBUG )
     X  CALL INTLOG(JP_DEBUG,'JSGGGP: Process latitude rows.',JPQUIET)
C
      ILONOLD = 0
C
      DO NXTROW = INORTH, ISOUTH
C
C       Initialise FFT constants for the latitude
C
        ILON = KPTS(NXTROW) * IJPWR(NXTROW)
C
        IF( LDEBUG ) THEN
          CALL INTLOG(JP_DEBUG,
     X      'JSGGGP: Initialise FFT consts for the group.',JPQUIET)
          CALL INTLOG(JP_DEBUG,
     X      'JSGGGP: Latitude number = ', NXTROW)
          CALL INTLOG(JP_DEBUG,
     X      'JSGGGP: No. of calculated long.pts = ', ILON)
        ENDIF
C
        IF( ILON.NE.ILONOLD ) THEN
          ILONOLD = ILON
          CALL JJSET99( ATRIGS, IMFAX, ILON, KRET)
          IF( KRET.NE.0 ) GOTO 990
        ENDIF
C
C       Calculate the points along the line of latitude
C
        CALL JSYMGG( PSHUP, KTRUNC, NXTROW, ILUNIT, 1, ILON,
     X               ALAT, ALEG, ATRIGS, IMFAX, .FALSE., ZFA, KRET)
        IF( KRET.NE.0 ) GOTO 990
C
C       If it is a wind component field, apply latitude correction
C
        IF( LUV.EQ.1 ) THEN
          ZLAT   = ALAT(NXTROW)
          ZCOSI  = ZFACTOR(NXTROW) / ABS( COS(ZLAT*DEG2RAD) )
          CALL EMOSLIB_SSCAL( ILON, ZCOSI, ZFA(2), 1)
        ENDIF
C
C       Store away the generated latitudes
C
        IF( HTYPE.EQ.'R' .OR. HTYPE.EQ.'r' .OR.
     X      HTYPE.EQ.'O' .OR. HTYPE.EQ.'o' .OR.
     X      HTYPE.EQ.'U' .OR. HTYPE.EQ.'u' ) THEN
          NUMPTS = KPTS(NXTROW)
        ELSE
          RINTVL = (PEAST - PWEST)*FLOAT( KPTS(NXTROW) ) / 360.0
          NUMPTS = NINT( RINTVL ) + 1
        ENDIF
C
C       Move latitude line to output array
C
        NFLAG = 1
        CALL JMOVGG( ZFA, PWEST, KNUM, NXTROW, 1, NUMPTS,
     X    ILON, IJPWR(NXTROW), NOFSET, POUTF, NFLAG)
C
      ENDDO
C
C     _______________________________________________________
C
C*    Section 9. Return to calling routine. Format statements
C     _______________________________________________________
C
 930  CONTINUE
      KRET = 0
C
 990  CONTINUE
C
      IF( LDEBUG ) CALL INTLOG(JP_DEBUG,'JSGGGP: Return code = ',KRET)
C
      RETURN
      END

C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

       SUBROUTINE INSCAL (PDATA,KDATA,KLEN,PREF,PSCALE,NBPV)
C
C---->
C**** INSCAL - Vectorise calculation of increments.
C
C     Purpose.
C     --------
C
C     Vectorise calculation of increments.
C
C**   Interface.
C     ----------
C
C     CALL INSCAL (PDATA,KDATA,KLEN,PREF,PSCALE,NBPV)
C
C
C     Input Parameters.
C     -----------------
C
C     PDATA      - Array of floating point values.
C     KLEN       - Number of values to be converted.
C     PREF       - Reference value.
C     PSCALE     - Scale factor.
C     NBPV       - Number of bits per packed value
C
C     Output Parameters.
C     -----------------
C
C     KDATA      - Array of integer increments
C
C     Method.
C     -------
C
C     The reference value is subtracted from each value,
C     and the result is then divided by the scale factor.
C
C     Externals.
C     ----------
C
C     None.
C
C     Reference.
C     ----------
C
C     WMO Manual on Codes re GRIB representation.
C
C     Comments.
C     --------
C
C     PDATA and KDATA are really the same array. This routine
C     is just a device to force vectorisation on the Cray,
C     without the necessity of using another array.
C
C
C     Author.
C     -------
C
C     J. Hennessy     ECMWF     25.06.91
C
C     Modifications.
C     _____________
C
C     J.D.Chambers          ECMWF     21.11.94
C     Use JNINT on VAX
C
C     J.D.Chambers          ECMWF     21.11.94
C     Check number of bits per value is not exceeded
C
C     P.J.Towers            ECMWF     18.07.02
C     Optimised for IBM Power4.
C         -Merged loops
C         -Replaced Nint(x) by Int(x+0.5)
C         -Replaced division by scale by multiplication by reciprocal
C
C     R. El Khatib / D. Paradis METEO-FRANCE 06.02.08
C         - (No conversion if the value exceeds the number of bits for
C         integers 
C
C----<
C     -----------------------------------------------------------------
C*    Section 0. Definition of variables.
C     -----------------------------------------------------------------
C
#ifdef CRAY
      IMPLICIT NONE
#endif
#include "grbcom.h"
#include "grprs.h"
C
      INTEGER KDATA(KLEN), NBPV, LOOP, MAXNBPV
      INTEGER INTEMAX
C
      REAL PDATA(KLEN), PREF, PSCALE
      REAL ZRECIP
      REAL ZI
      LOGICAL LPDEBUG
C
C     -----------------------------------------------------------------
C*    Section 1 . Calculation of increments.
C     -----------------------------------------------------------------
C
  100 CONTINUE
C
      LPDEBUG = ( NDBG.GE.1 )
      MAXNBPV = 2**NBPV
      ZRECIP = 1.0 / PSCALE
      IF( LPDEBUG ) THEN
        WRITE(GRPRSM,*) 'INSCAL: MAXNBPV = ', MAXNBPV
        WRITE(GRPRSM,*) 'INSCAL: PSCALE = ', PSCALE
        WRITE(GRPRSM,*) 'INSCAL: ZRECIP = ', ZRECIP
        WRITE(GRPRSM,*) 'INSCAL: PREF = ', PREF
        WRITE(GRPRSM,*) 'INSCAL: KLEN = ', KLEN
      ENDIF

#ifdef JBPW_64
      INTEMAX = 140737488355327
#else
      INTEMAX = 2147483647
#endif

      DO LOOP = 1,KLEN
#ifdef VAX
         KDATA(LOOP) = JNINT ( (PDATA(LOOP) - PREF) / PSCALE )
#else
         ZI =  (PDATA(LOOP) - PREF) * ZRECIP + 0.5
         IF (ABS(ZI) .GE. INTEMAX) THEN
            KDATA(LOOP) = MAXNBPV - 1
         ELSE
            KDATA(LOOP) =  INT ( ZI )
         ENDIF
#endif
         IF( KDATA(LOOP).GE.MAXNBPV ) KDATA(LOOP) = MAXNBPV - 1
         IF( KDATA(LOOP).LT.0 ) KDATA(LOOP) = 0
      ENDDO
C
C     -----------------------------------------------------------------
C*    Section 9. Return to calling routine.
C     -----------------------------------------------------------------
C
  900 CONTINUE
C
      RETURN
      END

C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE HLL2XYZ(RLAT,RLONG,X,Y,Z,INROW)
C---->
C**** HLL2XYZ
C
C     Purpose
C     -------
C
C     Converts an array of latitude/longitude values to an
C     array of (x,y,z) coordinates.
C
C
C     Interface
C     ---------
C
C     CALL HLL2XYZ(RLAT,RLONG,X,Y,Z,INROW)
C
C     Input
C     -----
C
C     RLAT  - Array of latitudes.
C     RLONG - Array of corresponding longitudes.
C     INROW - Count of latitudes/longitudes.
C
C
C     Output
C     ------
C
C     (X,Y,Z) - Array of coordinates.
C
C
C     Method
C     ------
C
C     Z axis is the polar axis directed from south to north.
C     X and Y axes are in the equatorial plane and have origin at the
C     centre of the Earth. The X axis passes through (O north, 0 east).
C
C
C     Externals
C     ---------
C
C     None.
C
C
C     Author
C     ------
C
C     J.D.Chambers     ECMWF
C
C----<
C
      IMPLICIT NONE
C
C     Subroutine arguments
C
      REAL RLAT,RLONG,X,Y,Z
      DIMENSION RLAT(*),RLONG(*),X(*),Y(*),Z(*)
      INTEGER INROW
C
C     Local variables
C
      REAL FACTOR
      DATA FACTOR/0.017453293/
      INTEGER LOOP
C
      DO LOOP = 1, INROW
        X(LOOP) = COS(RLAT(LOOP)*FACTOR) * COS(RLONG(LOOP)*FACTOR)
        Y(LOOP) = COS(RLAT(LOOP)*FACTOR) * SIN(RLONG(LOOP)*FACTOR)
        Z(LOOP) = SIN(RLAT(LOOP)*FACTOR)
      ENDDO
C
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE BUFREX(KBUFL,KBUFF,KSUP,KSEC0,KSEC1,KSEC2,KSEC3,KSEC4,
     2                  KELEM,CNAMES,CUNITS,KVALS,VALUES,CVALS,KERR)
C
C**** *BUFREX*
C
C
C     PURPOSE.
C     --------
C          DECODE BUFR MESSAGE INTO FULLY EXPANDED FORM; RETURNING
C     INFORMATION RELEVANT FOR ALL BUFR SECTIONS, EXPANDED VALUES,
C     THEIR NAMES AND UNITS.
C
C
C**   INTERFACE.
C     ----------
C
C          *CALL* *BUFREX(KBUFL,KBUFF,KSUP,KSEC0,KSEC1,KSEC2,KSEC3,KSEC4,
C     1                   KELEM,CNAMES,CUNITS,KVALS,VALUES,CVALS,KERR)*
C
C        INPUT :
C               *KBUFL*   -  LENGTH OF BUFR MESSAGE (WORDS)
C               *KBUFF*   -  INTEGER ARRAY CONTAINING BUFR MESSAGE
C               *KELEM*   -  INTEGER (EXPECTED NUMBER OF EXPANDED ELEMENTS)
C               *KVALS*   -  INTEGER (EXPECTED NUMBER OF DATA VALUES)
C        OUTPUT:
C               *KSUP*    -  INTEGER ARRAY OF 9 WORDS CONTAINING
C                            SUPLEMENTARY INFORMATION
C                         -  KSUP( 1) -- IDIM1, DIMENSION OF KSEC1
C                         -  KSUP( 2) -- IDIM2, DIMENSION OF KSEC2
C                         -  KSUP( 3) -- IDIM3, DIMENSION OF KSEC3
C                         -  KSUP( 4) -- IDIM4, DIMENSION OF KSEC4
C                         -  KSUP( 5) -- M (NUMBER OF ELEMENTS IN VALUES
C                                           ARRAY, FIRST INDEX)
C                         -  KSUP( 6) -- N (NUMBER OF SUBSETS,SECOND INDEX
C                                           OF VALUES ARRAY)
C                         -  KSUP( 7) -- JVC (NUMBER OF ELEMENTS IN CVAL ARRAY)
C                         -  KSUP( 8) -- TOTAL BUFR MESSAGE LENGTH IN BYTES
C                         -  KSUP( 9) -- IDIM0, DIMENSION OF KSEC0
C
C               *KSEC0*   -  INTEGER ARRAY OF 3 WORDS CONTAINING
C                            BUFR SECTION 0 INFORMATION
C                            KSEC0( 1)-- LENGTH OF SECTION 0 (BYTES)
C                            KSEC0( 2)-- TOTAL LENGTH OF BUFR MESSAGE (BYTES)
C                            KSEC0( 3)-- BUFR EDITION NUMBER
C
C               *KSEC1*   -  INTEGER ARRAY OF AT LEAST 40 WORDS
C                            CONTAINING BUFR SECTION 1 INFORMATION
C                            KSEC1( 1)-- LENGTH OF SECTION 1 (BYTES)
C                            KSEC1( 2)-- BUFR EDITION NUMBER
C                            KSEC1( 3)-- ORIGINATING CENTRE
C                            KSEC1( 4)-- UPDATE SEQUENCE NUMBER
C                            KSEC1( 5)-- FLAG (PRESENCE OF SECTION 2)
C                            KSEC1( 6)-- BUFR MESSAGE TYPE
C                            KSEC1( 7)-- BUFR MESSAGE SUBTYPE
C                            KSEC1( 8)-- VERSION NUMBER OF LOCAL TABLE USED
C                            KSEC1( 9)-- YEAR
C                            KSEC1(10)-- MONTH
C                            KSEC1(11)-- DAY
C                            KSEC1(12)-- HOUR
C                            KSEC1(13)-- MINUTE
C                            KSEC1(14)-- BUFR MASTER TABLE
C                            KSEC1(15)-- VERSION NUMBER OF MASTER TABLE USED
C                            KSEC1(16) - KSEC1(40) -- LOCAL ADP CENTRE
C                                        INFORMATION(BYTE BY BYTE)
C
C
C                            FOR BUFR EDITION 3 ONWARD
C
C                            KSEC1(16)-- ORIGINATING SUB-CENTRE
C                            KSEC1(17)-- NOT USED
C                            KSEC1(18) TO KSEC1(JSEC1) - LOCAL ADP CENTRE
C                                        INFORMATION(PACKED FORM)
C
C                            FOR BUFR EDITION 4 ONWARD
C
C                            KSEC1(16)-- ORIGINATING SUB-CENTRE
C                            KSEC1(17)-- INTERNATIONAL SUB-CATEGORY (SEE COMMON TABLE C-13
C                            KSEC1(18)-- SECOND
C                            KSEC1(19)-- YEAR
C                            KSEC1(20)-- MONTH
C                            KSEC1(21)-- DAY
C                            KSEC1(22)-- HOUR
C                            KSEC1(23)-- MINUTE
C                            KSEC1(24)-- SECOND
C                            KSEC1(25)-- YEAR
C                            KSEC1(26)-- MONTH
C                            KSEC1(27)-- DAY
C                            KSEC1(28)-- HOUR
C                            KSEC1(29)-- MINUTE
C                            KSEC1(30)-- SECOND
C                            KSEC1(31)-- MOST SOUTHERN LATITUDE  (-90 to 90)
C                            KSEC1(32)-- MOST WESTERN LONGITUDE  ( 0-360)
C                            KSEC1(33)-- MOST NORTHEN LATITUDE   (-90 to 90)
C                            KSEC1(34)-- MOST EASTERN LONGITUDE  ( 0-360)
C                            KSEC1(35) TO KSEC1(JSEC1) - LOCAL ADP CENTRE INFORMATION(PACKED FORM)
C
C               *KSEC2*   -  INTEGER ARRAY OF AT LEAST 64 WORDS
C                            CONTAINING BUFR SECTION 2 INFORMATION
C                            KSEC2( 1)-- LENGTH OF SECTION 2 (BYTES)
C                            KSEC2( 2) TO KSEC2(47) RDB KEY
C
C               *KSEC3*   -  INTEGER ARRAY OF 4 WORDS CONTAINING
C                            BUFR SECTION 3 INFORMATION
C                            KSEC3( 1)-- LENGTH OF SECTION 3 (BYTES)
C                            KSEC3( 2)-- RESERVED
C                            KSEC3( 3)-- NUMBER OF SUBSETS
C                            KSEC3( 4)-- FLAG (DATA TYPE,DATA COMPRESSION)
C
C               *KSEC4*   -  INTEGER ARRAY OF 2 WORDS CONTAINING
C                            BUFR SECTION 4 INFORMATION
C                            KSEC4( 1)-- LENGTH OF SECTION 4 (BYTES)
C                            KSEC4( 2)-- RESERVED
C
C               *CNAMES*  -  CHARACTER*64  ARRAY OF KELEM CONTAINING
C                            BUFR TABLE B ELEMENT NAMES
C               *CUNITS*  -  CHARACTER*24 ARRAY OF KELEM CONTAINIG
C                            BUFR TABLE B UNITS
C               *VALUES*  -  REAL ARRAY OF KVALS CONTAINING EXPANDED
C                            DATA VALUES
C               *CVALS*   -  CHARACTER*80 ARRAY OF KVALS CONTAINING
C                            BUFR CODE TABLE OR CCITTIA5 BUFR ELEMENTS
C                            ENTRIES
C               *KERR*    -  RETURNED ERROR CODE
C
C
C     METHOD.
C     -------
C
C          BUFR MESSAGE PASSED AS ARGUMENT TO THIS ROUTINE IS DECODED
C     SECTION BY SECTION. SUPLEMENTARY INFORMATION AND EXPANDED DATA
C     ARE RETURNED AS WELL AS ERROR CODE. DURING BIT PATTERN UNPACKING
C     GBYTE AND GBYTES ROUTINES (VMS VERSION) ARE USED.
C
C
C     EXTERNALS.
C     ----------
C
C          BUEXS0   -  EXPANDS SECTION 0 OF BUFR MESSAGE
C          BUEXS1   -  EXPANDS SECTION 1 OF BUFR MESSAGE
C          BUEXS2   -  EXPANDS SECTION 2 OF BUFR MESSAGE
C          BUEXS3   -  EXPANDS SECTION 3 OF BUFR MESSAGE
C          BUGBTS   -  LOAD REQUIRED BUFR TABLES
C          BUEXS4   -  EXPANDS SECTION 4 OF BUFR MESSAGE
C          BUEXS5   -  EXPANDS SECTION 5 OF BUFR MESSAGE
C
C     REFERENCE.
C     ----------
C
C          NONE.
C
C     AUTHOR.
C     -------
C
C          M. DRAGOSAVAC    *ECMWF*       15/01/91.
C
C
C     MODIFICATIONS.
C     --------------
C
C          NONE.
C
C
      IMPLICIT LOGICAL(L,O,G), CHARACTER*8(C,H,Y)
C
C
#     include "parameter.F"
#     include "bcomunit.F"
#     include "bcomwork.F"
#     include "bcomwt.F"
#     include "bcomdefc.F"
#     include "bcomreq.F"
#     include "bcomoff.F"
C
      DIMENSION KBUFF(KBUFL)
      DIMENSION KSUP(JSUP),KSEC0(JSEC0),KSEC1(JSEC1)
      DIMENSION KSEC2(JSEC2),KSEC3(JSEC3),KSEC4(JSEC4)
C
#ifndef R_4
      REAL*8 VALUES(KVALS)
      REAL*8 RVIND
      REAL*8 EPS
      REAL*8 RQVAL
      REAL*8 VAL
#else
      REAL   VALUES(KVALS)
      REAL   RVIND
      REAL   EPS
      REAL   RQVAL
      REAL   VAL
#endif
C
      CHARACTER*64 CNAMES(KELEM)
      CHARACTER*24 CUNITS(KELEM)
      CHARACTER*80 CVALS(KVALS)
      CHARACTER*4  CECMWF,CUSER
C
      SAVE NWPTB1,NBPTB1
C     ------------------------------------------------------------------
C
C*          1.   SET CONSTANTS.
C                --------------
 100  CONTINUE
C
      KERR=0
C
      M0=1
C
      DO 101 I=1,JSEC0
      KSEC0(I)=0
 101  CONTINUE
C
      DO 102 I=1,JSEC1
      KSEC1(I)=0
 102  CONTINUE
C
      DO 103 I=1,JSEC3
      KSEC3(I)=0
 103  CONTINUE
C
      DO 104 I=1,JSUP
      KSUP(I)=0
 104  CONTINUE
C
      DO 105 I=1,JSEC4
      KSEC4(I)=0
 105  CONTINUE
C
      DO 106 I=1,JSEC2
      KSEC2(I)=0
 106  CONTINUE
C
      IF(CECMWF.NE.'ECMF') THEN
         CALL BUEVAR(KERR)
         CECMWF='ECMF'
      END IF
C
      IF(CUSER.NE.'USER') THEN
         NREQ(1)=0
         NREQ(2)=0
         NRQL=0
      END IF
C     -----------------------------------------------------------------
C*          2.  EXPAND SECTION 0.
C               -----------------
 200  CONTINUE
C
      CALL BUEXS0( KBUFL,KBUFF,KSUP,KSEC0,KERR )
      IF(KERR.GT.0) RETURN
C
C     ------------------------------------------------------------------
C*          3.   EXPAND SECTION 1.
C                ------------------
 300  CONTINUE
C
      CALL BUEXS1( KBUFL,KBUFF,KSUP,KSEC0,KSEC1,KERR )
      IF(KERR.GT.0) RETURN
C
C     ------------------------------------------------------------------
C*          4.  EXPAND SECTION 2.
C               -----------------
 400  CONTINUE
C
      CALL BUEXS2( KBUFL,KBUFF,KSUP,KSEC1,KSEC2,KERR )
      IF(KERR.GT.0) RETURN
C
      CALL BUEXS33(KBUFL,KBUFF,KSEC3,KERR)
      IF(KERR.GT.0) RETURN
      
      NWPTB1=NWPTB
      NBPTB1=NBPTB
C     ------------------------------------------------------------------
C*          5.   LOAD BUFR TABLES.
C                -----------------
 500  CONTINUE
C
      CALL BUGBTS(KSEC1,KERR)
      IF(KERR.GT.0) RETURN
C
      OMULTI=.FALSE.
      NSUBSET=1
      IF(IAND(KSEC3(4),64).EQ.0.AND.KSEC3(3).GT.1) THEN
C
         OMULTI=.TRUE.
         DO I=1,KSEC3(3)
         NWT=0
         M=0
         NWPTB=NWPTB1
         NBPTB=NBPTB1
         NSUBSET=I
         CALL BUEXS3(KBUFL,KBUFF,KSUP,KSEC3,KELEM,CNAMES,CUNITS,
     1               KERR)
         IF(KERR.GT.0) RETURN
C
         CALL BUEXS4(KBUFL ,KBUFF ,KSUP  ,KSEC3,KSEC4,
     1               KELEM ,CNAMES,CUNITS,KVALS,VALUES,CVALS,KERR)
         IF(KERR.GT.0) RETURN
         END DO

         GO TO 800
      END IF
    
C     ------------------------------------------------------------------
C*          6.  EXPAND SECTION 3.
C               -----------------
 600  CONTINUE
C
      CALL BUEXS3(KBUFL,KBUFF,KSUP,KSEC3,KELEM,CNAMES,CUNITS,KERR)
      IF(KERR.GT.0) RETURN
C
C     ------------------------------------------------------------------
C*          7.   EXPAND SECTION 4.
C                -----------------
 700  CONTINUE
C
      CALL BUEXS4(KBUFL ,KBUFF ,KSUP  ,KSEC3,KSEC4,
     1            KELEM ,CNAMES,CUNITS,KVALS,VALUES,CVALS,KERR)
      IF(KERR.GT.0) RETURN
C
C     ------------------------------------------------------------------
C*          8.   EXPAND SECTION 5.
C                -----------------
 800  CONTINUE
C
      CALL BUEXS5(KBUFL,KBUFF,KERR)
      IF(KERR.GT.0) RETURN
C
C     -----------------------------------------------------------------
C*          9.   SET TOTAL BUFR MESSAGE LENGTH.
C                ------------------------------
 900  CONTINUE
C
      KSUP(8)=KSEC0(1)+KSEC1(1)+KSEC2(1)+KSEC3(1)+KSEC4(1)+4
C
C     -----------------------------------------------------------------
      RETURN
C
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

       SUBROUTINE BUSBYTESR8(DESTINATION,KSOURCE,KSKIP,KWIDTH,
     1                       KSKIPBETWEEN,KNUMBER)
C
C**** *BUSBYTESR8*
C
C
C     PURPOSE.
C     --------
C          
C
C**   INTERFACE.
C     ----------
C          NONE.
C
C
C
C
C     *METHOD.
C      -------
C          NONE.
C
C
C
C     EXTERNALS.
C     ----------
C          NONE.
C
C
C
C
C     REFERENCE.
C     ----------
C
C
C     AUTHOR.
C     -------
C
C          M. DRAGOSAVAC       *ECMWF*       JULY 2008
C
C
C     MODIFICATIONS.
C     --------------
C
C          NONE.
C
C
      IMPLICIT LOGICAL(L,O,G), CHARACTER*8(C,H,Y)

      REAL*8 DESTINATION

      CALL SBYTES(DESTINATION,KSOURCE,KSKIP,KWIDTH,KSKIPBETWEEN,KNUMBER)
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE BUERR(KERR)
C**** *BUERR*
C
C
C     PURPOSE.
C     --------
C         PRINT ERROR CODE.
C
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *BUERR(KERR)*
C
C     METHOD.
C     -------
C
C          NONE.
C
C
C     EXTERNALS.
C     ----------
C
C          NONE.
C
C     REFERENCE.
C     ----------
C
C          NONE.
C
C     AUTHOR.
C     -------
C
C          M. DRAGOSAVAC    *ECMWF*       15/02/92.
C
C
C     MODIFICATIONS.
C     --------------
C
C          NONE.
C
C
      IMPLICIT LOGICAL(L,O,G), CHARACTER*8(C,H,Y)
C
#     include "bcomunit.F"
C
      CHARACTER*80 CERROR(100)
C
      DATA CERROR/100*' '/
C
C     ------------------------------------------------------------------
C
C*          1.   INITIALIZE MESSAGES.
C                --------------------
 100  CONTINUE
C
      CERROR( 1)=' START OF BUFR MESSAGE NOT FOUND.'
      CERROR( 2)=' END OF BUFR MESSAGE NOT FOUND.'
      CERROR( 3)=' ARRAY TO RECEIVE BUFR MESSAGE TOO SMALL.'
      CERROR( 4)=' JSEC1 PARAMETER TOO SMAL. LOCAL ADP CENTER'//
     1           ' INFORMATION SKIPPED.'
      CERROR( 5)=' JSEC2 PARAMETER TOO SMALL. LOCAL ADP CENTRE'//
     2           ' INFORMATION SKIPPED.'
      CERROR( 6)=' ERROR DURING READ BUFR TABLE B.'
      CERROR( 7)=' ERROR DURING READ BUFR TABLE C.'
      CERROR( 8)=' ERROR DURING READ BUFR TABLE D.'
      CERROR( 9)=' OPEN ERROR.'
      CERROR(10)=' ERROR DURING CLOSE BUFR TABLE B.'
      CERROR(11)=' ERROR DURING CLOSE BUFR TABLE C.'
      CERROR(12)=' ERROR DURING CLOSE BUFR TABLE D.'
      CERROR(13)=' NUMBER OF BITS TO BE EXTRACTED GREATER THAN'//
     1           ' NUMBER OF BITS PER COMPUTER WORD.'
      CERROR(14)=' ARGUMENT KVALS TOO SMALL.'
      CERROR(15)=' INCREMENT VALUE FOR COMPRESSED DATA TOO BIG.'
      CERROR(16)=' JSUBS PARAMETER TOO SMALL.'
      CERROR(17)=' JWORK PARAMETER TOO SMALL.'
      CERROR(18)=' REPLICATION FACTOR EQUAL TO ZERO.'
      CERROR(19)=' DELAYED REPLICATION FACTOR TOO BIG.'
      CERROR(20)=' TABLE D REFERENCE NOT FOUND.'
      CERROR(21)=' DATA DESCRIPTOR OPERATOR NOT FOUND.'
      CERROR(22)=' BUFR OPEARTOR NAME NOT FOUND.'
      CERROR(23)=' TABLE B REFERENCE NOT FOUND.'
      CERROR(24)=' AUGMENTED TABLE B REFERENCE NOT FOUND.'
      CERROR(25)=' KELEM ARGUMENT TOO SMALL.'
      CERROR(26)=' WORD POINTER OUT OF RANGE.'
      CERROR(27)=' TOO MANY SUBSETS TO BE PACKED.'
      CERROR(28)=' NUMBER TO BE PACKED TOO BIG.'
      CERROR(29)=' NUMBER OF DESCRIPTORS KTDLEN TOO BIG.'
      CERROR(30)=' NUMBER OF ELEMENTS GREATER THAN JELEM.'
      CERROR(31)=' TOO FEW ELEMENTS IN KDATA ARRAY.'
      CERROR(32)=' NUMBER OF SUBSETS EQUAL TO ZERO.'
      CERROR(33)=' NEGATIVE VALUE TO BE PACKED.'
      CERROR(34)=' NUMBER OF BITS TO BE PACKED GREATER THAN'//
     1           ' NUMBER OF BITS PER COMPUTER WORD.'
      CERROR(35)=' '
      CERROR(36)=' BAD ORDER OF DATA DESCRIPTORS.'
      CERROR(37)=' WRONG DATA DESCRIPTOR.'
      CERROR(38)=' PARTIAL EXPANSION ON TOTAL MESSAGE NOT SUPPORTED.'
      CERROR(39)=' CAN NOT RECOGNIZE FEEDBACK DATA IN THIS MESSAGE.'
      CERROR(40)=' REQUEST FLAG ILLEGAL.'
      CERROR(41)=' BIT MAP NOT SET.'
      CERROR(42)=' THIS ELEMENT MUST BE DATA PRESENT INDICATOR.'
      CERROR(43)=' TABLE B ELEMENT MUST FOLLOW BIT MAP.'
      CERROR(44)=' REQUESTED SUBSET DOES NOT EXIST.'
      CERROR(45)=' THERE IS NO ONE REQUESTED ELEMENT IN THE DATA.'
      CERROR(46)=' INPUT ARRAY IS TOO SMALL TO RECEIVE INFORMATION.'
      CERROR(47)=' KELEM ARGUMENT IS TOO BIG. MAXIMUM ALLOWED IS 160000'
      CERROR(48)=' '
      CERROR(49)=' TOO MANY DATA FOR BOXING '
      CERROR(50)=' ERROR IN KSEC1(5) FLAG. '//
     1           ' ALLOWED VALUES: ZERO OR 128'
      CERROR(51)=' WRONG USAGE OF 204Y OPERATOR'
      CERROR(56)=' WRONG SECTION 4 SIZE'
C
      IF(KERR.GE.0.AND.KERR.LE.100) THEN
        WRITE(KNTN,'(1H ,A)') CERROR(KERR)
      ELSE
        WRITE(KNTN,'(1H ,A)') ' ERROR NUMBER OUT OF RANGE !'
      END IF
C
      RETURN
      END

C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE BUPCK(KBPW,KD,KS,KWPT,KBPT,KSI,KERR)
C
C**** *BUPCK*
C
C
C     PURPOSE.
C     --------
C         PURPOSE OF THIS ROUTINE IS TO PACK VALUE *KS* IN
C         *KSI* BITS, STARTED AT WORD KWPT OF ARRAY *KD* AFTER
C         SKIPPING NBPT BITS.  AT THE END
C         POINTERS *KWPT* AND *KBPT* ARE ADJUSTED.
C
C**   INTERFACE.
C     ----------
C
C     *CALL* *BUPCK(KBPW,KD,KS,KWPT,KBPT,KSI,KERR)*
C
C        INPUT :
C            *KS*    - SOURCE
C            *KWPT*  - WORD POINTER
C            *KWPT*  - BIT POINTER
C            *KSI*   - NUMBER OF BITS ACCUPIED BY KS.
C
C        OUTPUT :
C            *KD*    - DESTINATION ARRAY.
C            *KERR*  - RETURN ERROR CODE
C
C     *METHOD.
C      -------
C
C            NONE.
C
C
C     EXTERNALS.
C     ----------
C
C
C            *CALL SBYTE(KD,KS,KBPT,KSI)*
C
C            *KD*    - DESTINATION ARRAY.
C            *KS*    - SOURCE
C            *KBPT*  - POINTER TO BIT IN THE KD(KWPT)
C            *KSI*   - NUMBER OF BITS ACCUPIED BY KS.
C
C
C
C
C     REFERENCE.
C     ----------
C
C          NONE.
C
C     AUTHOR.
C     -------
C
C          M. DRAGOSAVAC    *ECMWF*       09/06/86.
C
C
C     MODIFICATIONS.
C     --------------
C
C          NONE.
C
C
      IMPLICIT LOGICAL(L,O,G), CHARACTER*8(C,H,Y)
C
C
#     include "parameter.F"
#     include "bcomunit.F"
#     include "bcmwork.F"
C
#ifndef R_4
      REAL*8 RVIND
      REAL*8 EPS
#else
      REAL   RVIND
      REAL   EPS
#endif
      DIMENSION KD(*)
      DIMENSION IMAXV(32)
C
      DATA IMAXV/1,3,7,15,31,63,127,255,511,1023,2047,4095,8191,
     1  16383,32767,65535,131071,262143,524287,1048575,2097151,
     2  4194305,8388607,16777215,33554431,671108863,134217727,
     3  268435455,536870911,1073741823,2147483647,2147483647/
C
C     ------------------------------------------------------------------
C*          1.   SET UP BIT PATTERN.
C                -------------------
C
 100  CONTINUE
C
      IF(KERR.GT.0) RETURN
C
      IF(KS.EQ.NVIND) KS=IMAXV(KSI)
C
      IF(KS.GT.IMAXV(KSI)) THEN
         KERR=28
         RETURN
      END IF
C
      CALL SBYTE(KD,KS,KBPT,KSI)
C
C     ------------------------------------------------------------------
C*          1.1  UPDATE WORD AND BIT POINTERS.
C                -----------------------------
 110  CONTINUE
C
      KBPT = KBPT + KSI
C
      IF(KBPT.GE.KBPW) THEN
         KBPT= KBPT - KBPW
         KWPT= KWPT + 1
      END IF
C
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities
C granted to it by virtue of its status as an intergovernmental organisation
C nor does it submit to any jurisdiction.
C


      SUBROUTINE SETPAR (KBIT,KNEG,KPR)
C
C---->
C**** SETPAR - Set number of bits in word. Set maximum negative integer.
C
C     Purpose.
C     --------
C
C     Set number of bits in word. Set maximum negative integer.
C
C**   Interface.
C     ----------
C
C     CALL SETPAR (KBIT,KNEG,KPR)
C
C
C     Input Parameters.
C     -----------------
C
C     KPR - Debug print switch.
C           > 0 , print out.
C           0   , No print out.
C
C     Output Parameters.
C     ------------------
C
C     KBIT       - Number of bits in computer word.
C
C     KNEG       - Maximum negative integer.
C
C     Method.
C     -------
C
C     Values are assigned according to hardware platform.
C
C     Externals.
C     ----------
C
C     None.
C
C     Reference.
C     ----------
C
C     None.
C
C     Comments.
C     ---------
C
C     None
C
C     Author.
C     -------
C
C     J. Hennessy      ECMWF      28.10.91
C
C     Modifications.
C     --------------
C
C     None.
C
C     ------------------------------------------------------------------
C----<
C
C*    Section 0 . Definition of variables. Data statements.
C     ------------------------------------------------------------------
C
      IMPLICIT NONE
C
#include "common/grprs.h"
C
      INTEGER KBIT
      INTEGER KNEG
      INTEGER KPR
C
C     ------------------------------------------------------------------
C*    Section 1 . Assign values.
C     ------------------------------------------------------------------
C
  100 CONTINUE
C
      IF( KPR.GE.1 )  WRITE(GRPRSM,*) ' SETPAR : Section 1.'
C
#ifdef INTEGER_8
      KBIT = 64
      KNEG = -9223372036854775807
#elif (defined VAX)
      KBIT = 32
      KNEG = -2147483648
#else
      KBIT = 32
      KNEG = -2147483647
#endif
C     ------------------------------------------------------------------
C*    Section 9 . Return to calling routine.
C     ------------------------------------------------------------------
C
  900 CONTINUE
C
      IF( KPR.GE.1 ) THEN
        WRITE(GRPRSM,*) ' SETPAR : Section 9.'
        WRITE(GRPRSM,*) '          Output values set -'
        WRITE(GRPRSM,*) 'SETPAR: KBIT = ', KBIT
        WRITE(GRPRSM,*) 'SETPAR: KNEG = ', KNEG
      ENDIF
C
      RETURN
      END

C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities
C granted to it by virtue of its status as an intergovernmental organisation
C nor does it submit to any jurisdiction.
C

      INTEGER FUNCTION HIRLAMW(L12PNT,OLDFLDU,OLDFLDV,KOUNT,KGAUSS,AREA,
     X                        POLE,GRID,NEWFLDU,NEWFLDV,KSIZE,NLON,NLAT)
C
C---->
C**** HIRLAMW
C
C     Purpose
C     -------
C
C     This routine creates a rotated regular lat/long field from a
C     gaussian field using 12-point horizontal interpolation.
C
C
C     Interface
C     ---------
C
C     IRET = HIRLAMW(L12PNT,OLDFLDU,OLDFLDV,KOUNT,KGAUSS,AREA,
C    X               POLE,GRID,NEWFLDU,NEWFLDV,KSIZE,NLON,NLAT)
C
C
C     Input parameters
C     ----------------
C
C     L12PNT - Chooses between 12-point and 4-point interpolation
C              = .TRUE. for 12-point horizontal
C              = .FALSE. for 4-point
C     OLDFLDU - The array of values from the gaussian U field
C     OLDFLDV - The array of values from the gaussian V field
C     KOUNT   - Number of values in OLDFLDU/V
C     KGAUSS  - Gaussian number for the gaussian field
C     AREA    - Limits of output area (N/W/S/E)
C     POLE    - Pole of rotation (lat/long)
C     GRID    - Output lat/long grid increments (we/ns)
C     KSIZE   - The size of the output array to fill with the regular
C               lat/long field
C
C
C     Output parameters
C     -----------------
C
C     NEWFLDU - The array of values for the regular lat/long U field
C     NEWFLDV - The array of values for the regular lat/long V field
C     NLON    - Number of longitudes in the regular lat/long field
C     NLAT    - Number of latitudes in the regular lat/long field
C
C     Returns 0 if function successful, non-zero otherwise.
C
C     Common block usage
C     ------------------
C
C     nifld.common
C     nofld.common
C
C
C     Method
C     ------
C
C     Numbering of the points (I is the interpolation point):
C
C                   13       5       6      14
C
C                    7       1       2       8
C                               (I)
C                    9       3       4      10
C
C                   15      11      12      16
C
C     The 12-point interpolation is not possible if either of the top
C     two rows is above the original field northern latitude. The
C     nearest neighbour is used if both rows are above, and a 4-pt
C     bilinear interpolation is used if the top row is above.
C     Similarily, if either of the bottom two rows is below the original
C     field southern latitude.
C
C
C     Externals
C     ---------
C
C     INTLOG  - Log error message.
C     JMALLOC - Dynamically allocate memory
C     JFREE   - Free dynamically allocated memory
C     JGETGG  - Reads the definition of a gaussian grid
C     HGENGRW - Calculates original lat/long (before rotation) for
C               a rotated grid for wind fields.
C     HNEI12  - Finds neighbours for points for interpolation
C     HWTS12  - Calculates weightings for points for interpolation
C
C
C     Reference
C     ---------
C
C     None.
C
C
C     Comments
C     --------
C
C     None.
C
C
C     Author
C     ------
C
C     J.D.Chambers      ECMWF      January 2001
C
C
C     Modifications
C     -------------
C
C     None.
C
C----<
C     -----------------------------------------------------------------|
C*    Section 0. Definition of variables.
C     -----------------------------------------------------------------|
C
      IMPLICIT NONE
C
#include "parim.h"
#include "nifld.common"
#include "nofld.common"
C
C     Parameters
C
      INTEGER JNORTH, JSOUTH, JWEST, JEAST, JW_E, JN_S, JLAT, JLON
      INTEGER JP12PT, JP4PT, JPNEARN
      PARAMETER (JP12PT  = 0)
      PARAMETER (JP4PT   = 1)
      PARAMETER (JPNEARN = 2)
      PARAMETER (JNORTH = 1 )
      PARAMETER (JWEST  = 2 )
      PARAMETER (JSOUTH = 3 )
      PARAMETER (JEAST  = 4 )
      PARAMETER (JW_E  = 1 )
      PARAMETER (JN_S  = 2 )
      PARAMETER (JLAT  = 1 )
      PARAMETER (JLON  = 2 )
C
C     Function arguments
C
      LOGICAL L12PNT
      INTEGER KOUNT, KGAUSS, KSIZE, NLON, NLAT
      REAL AREA(4), POLE(2), GRID(2)
      REAL OLDFLDU(*), NEWFLDU(KSIZE)
      REAL OLDFLDV(*), NEWFLDV(KSIZE)
C
C     Local variables
C
      INTEGER NEXT, LOOP, IRET, NLEN, NBYTES, NUMBER
      INTEGER NPREV, COUNTU, COUNTV, NEAREST
C
      LOGICAL LNEW, LFIRST
      INTEGER KSCHEME(1),NEIGH(12,1), KLA(1)
      REAL PWTS(12,1)
      POINTER (IPKSCHE, KSCHEME)
      POINTER (IPNEIGH, NEIGH)
      POINTER (IPKLA,   KLA)
      POINTER (IPPWTS,  PWTS)
C
      REAL PDLO0(1),PDLO1(1),PDLO2(1),PDLO3(1),PDLAT(1)
      POINTER (IPPDLO0, PDLO0)
      POINTER (IPPDLO1, PDLO1)
      POINTER (IPPDLO2, PDLO2)
      POINTER (IPPDLO3, PDLO3)
      POINTER (IPPDLAT, PDLAT)
C
      INTEGER IGG, IGGOLD
      INTEGER KPTS(1)
      REAL GLATS(1)
      INTEGER IOFFS(1)
      POINTER (IPKPTS,  KPTS)
      POINTER (IPIOFFS, IOFFS)
      POINTER (IPGLATS, GLATS)
C
      INTEGER ILL, ILLOLD
      REAL RLAT(1),RLON(1)
      POINTER (IPRLAT, RLAT)
      POINTER (IPRLON, RLON)
      REAL RCLAT(1),RCLON(1),RDIR(1),C(1),S(1),U(1),V(1)
      POINTER (IPRCLAT, RCLAT)
      POINTER (IPRCLON, RCLON)
      POINTER (IPRDIR, RDIR)
      POINTER (IPC, C)
      POINTER (IPS, S)
      POINTER (IPU, U)
      POINTER (IPV, V)
C
      REAL OLDU(KOUNT), OLDV(KOUNT)
C
      CHARACTER*7 FUNCNAME
      PARAMETER  (FUNCNAME = 'HIRLAMW')
C
      DATA IGGOLD/-1/, ILLOLD/-1/
      DATA NUMBER/-1/
      DATA LNEW/.FALSE./, LFIRST/.TRUE./
      DATA NPREV/-1/
C
      SAVE LNEW, LFIRST
      SAVE IPKSCHE, IPNEIGH, IPKLA, IPPWTS
      SAVE IPPDLO0, IPPDLO1, IPPDLO2, IPPDLO3, IPPDLAT
      SAVE IGGOLD, IPKPTS, IPIOFFS, IPGLATS
      SAVE ILLOLD, IPRLAT, IPRLON
      SAVE NUMBER
      SAVE NPREV
      SAVE IPRCLAT, IPRCLON, IPRDIR
      SAVE IPC, IPS, IPU, IPV
C
C     Externals
C
      INTEGER HNEI12
      INTEGER HGENGRW
#ifdef POINTER_64
      INTEGER*8 JMALLOC
#else
      INTEGER JMALLOC
#endif
C
C     Statement functions
C
      REAL A, B
      LOGICAL NOTEQ
C
C     Convert degrees to radians
C
      REAL X, RADIAN
      RADIAN(X) = (X) * 0.0174532925
C
C     Tests that A is not (almost) equal to B
C
      NOTEQ(A,B) = (ABS((A)-(B)).GT.(ABS(A)*1E-3))
C
C     -----------------------------------------------------------------|
C     Section 1.  Initialise.
C     -----------------------------------------------------------------|
C
  100 CONTINUE
C
      HIRLAMW = 0
C
      CALL JDEBUG()
C
      IF( L12PNT ) THEN
        CALL INTLOG(JP_DEBUG,FUNCNAME//': 12-pt interpolation',JPQUIET)
      ELSE
        CALL INTLOG(JP_DEBUG,FUNCNAME//': 4-pt interpolation',JPQUIET)
      ENDIF
C
C     Dynamically allocate memory for gaussian grid information.
C
      IGG = KGAUSS*2
      IF( IGG.GT.IGGOLD ) THEN
C
        IF( IGGOLD.GT.0 ) CALL JFREE(IPKPTS)
C
        NBYTES = (IGG*JPRLEN) + (2*IGG+1)*JPBYTES
C
        IPKPTS = JMALLOC(NBYTES)
#ifdef hpR64
        IPKPTS = IPKPTS/(1024*1024*1024*4)
#endif
        IF( IPKPTS.EQ.0 ) THEN
          CALL INTLOG(JP_ERROR,
     X      FUNCNAME//': Memory allocate fail',JPQUIET)
          HIRLAMW = 1
          GOTO 900
        ENDIF
C
        IPGLATS = IPKPTS  + (IGG*JPBYTES)
        IPIOFFS = IPGLATS + (IGG*JPRLEN)
C
        IGGOLD = IGG
        NPREV = -1
C
      ENDIF
C
C     Build up offsets to start of each latitude in original field(s)
C
      IF( KGAUSS.NE.NPREV ) THEN
        IF( NIREPR.EQ.JPGAUSSIAN ) THEN
          CALL JGETGG(KGAUSS,'F',GLATS,KPTS,IRET)
        ELSE
          CALL JGETGG(KGAUSS,'R',GLATS,KPTS,IRET)
        ENDIF
C
        IF( IRET.NE.0 ) THEN
          CALL INTLOG(JP_ERROR,
     X      FUNCNAME//': JGETGG failed to get gaussian data',JPQUIET)
          HIRLAMW = 2
          GOTO 900
        ENDIF
C
        IOFFS(1) = 1
        DO LOOP = 2, (KGAUSS*2+1)
          IOFFS(LOOP) = IOFFS(LOOP-1) + KPTS(LOOP-1)
        ENDDO
C
        NUMBER = (IOFFS(KGAUSS*2+1) - 1)
        IF( NUMBER.NE.KOUNT ) THEN
          CALL INTLOG(JP_ERROR,
     X      FUNCNAME//': Given no. of points =',KOUNT)
          CALL INTLOG(JP_ERROR,
     X      FUNCNAME//': Expected no. of pts =',NUMBER)
          HIRLAMW = 3
          GOTO 900
        ENDIF
C
        NPREV = KGAUSS
      ENDIF
C
C     Preserve the input fields
C     (in case OLDFLDx and NEWFLDx are the same arrays)
C
      DO LOOP = 1, NUMBER
        OLDU(LOOP) = OLDFLDU(LOOP)
        OLDV(LOOP) = OLDFLDV(LOOP)
      ENDDO
C
C     -----------------------------------------------------------------|
C     Section 2.  Generate the lat/long points for the output grid
C     -----------------------------------------------------------------|
C
  200 CONTINUE
C
      NLON = 1 + NINT((AREA(JEAST) - AREA(JWEST)) / GRID(JW_E))
      NLAT = 1 + NINT((AREA(JNORTH) - AREA(JSOUTH)) / GRID(JN_S))
C
      NLEN = NLON * NLAT

      NOWE = NLON
      NONS = NLAT
C
C     Check that given array is big enough for the new field.
C
      IF( NLEN.GT.KSIZE ) THEN
        CALL INTLOG(JP_ERROR,FUNCNAME//': Given array size = ',KSIZE)
        CALL INTLOG(JP_ERROR,FUNCNAME//': Required size = = ',NLEN)
        HIRLAMW = 5
        GOTO 900
      ENDIF
C
C     Dynamically allocate memory for lat/long arrays.
C
      ILL = NLEN
      IF( ILL.GT.ILLOLD ) THEN
C
        LNEW = .TRUE.
C
        IF( ILLOLD.GT.0 ) CALL JFREE(IPRLON)
C
        NBYTES = 9*ILL*JPRLEN
C
        IPRLON = JMALLOC(NBYTES)
#ifdef hpR64
        IPRLON = IPRLON/(1024*1024*1024*4)
#endif
        IF( IPRLON.EQ.0 ) THEN
          CALL INTLOG(JP_ERROR,
     X      FUNCNAME//': Memory allocate fail',JPQUIET)
          HIRLAMW = 6
          GOTO 900
        ENDIF
C
        IPRLAT  = IPRLON + (ILL*JPRLEN)
        IPRCLON = IPRLAT + (ILL*JPRLEN)
        IPRCLAT = IPRCLON + (ILL*JPRLEN)
        IPRDIR  = IPRCLAT + (ILL*JPRLEN)
        IPC     = IPRDIR + (ILL*JPRLEN)
        IPS     = IPC    + (ILL*JPRLEN)
        IPU     = IPS    + (ILL*JPRLEN)
        IPV     = IPU    + (ILL*JPRLEN)
C
        ILLOLD = ILL
C
      ENDIF
C
      IRET = HGENGRW(AREA,POLE,GRID,NLON,NLAT,RCLAT,RCLON,RLAT,RLON)
      IF( IRET.NE.0 ) THEN
        CALL INTLOG(JP_ERROR,
     X      FUNCNAME//': HGENGRW failed to get lat/lon grid',JPQUIET)
        HIRLAMW = 7
        GOTO 900
      ENDIF
C
C     -----------------------------------------------------------------|
C     Section 3.  Find neighbours for each point for interpolation.
C     -----------------------------------------------------------------|
C
  300 CONTINUE
C
C     Dynamically allocate memory for interpolation arrays.
C
      IF( LNEW ) THEN
C
        IF( .NOT.LFIRST ) CALL JFREE(IPPDLO0)
C
        NBYTES = (17*JPRLEN + 14*JPBYTES) * ILL
C
        IPPDLO0 = JMALLOC(NBYTES)
#ifdef hpR64
        IPPDLO0 = IPPDLO0/(1024*1024*1024*4)
#endif
        IF( IPPDLO0.EQ.0 ) THEN
          CALL INTLOG(JP_ERROR,
     X      FUNCNAME//': Memory allocate fail',JPQUIET)
          HIRLAMW = 8
          GOTO 900
        ENDIF
C
        IPPDLO1 = IPPDLO0 + (ILL*JPRLEN)
        IPPDLO2 = IPPDLO1 + (ILL*JPRLEN)
        IPPDLO3 = IPPDLO2 + (ILL*JPRLEN)
        IPPDLAT = IPPDLO3 + (ILL*JPRLEN)
        IPPWTS  = IPPDLAT + (ILL*JPRLEN)
        IPKSCHE = IPPWTS  + (12*ILL*JPRLEN)
        IPKLA   = IPKSCHE + (ILL*JPBYTES)
        IPNEIGH = IPKLA   + (ILL*JPBYTES)
C
        LFIRST = .FALSE.
C
      ENDIF
C
C     Find neighbours.
C
      IRET = HNEI12(L12PNT,NLEN,RLAT,RLON,KGAUSS,KPTS,GLATS,
     X              KSCHEME,PDLAT,PDLO0,PDLO1,PDLO2,PDLO3,KLA,NEIGH)
      IF( IRET.NE.0 ) THEN
        CALL INTLOG(JP_ERROR,
     X      FUNCNAME//': HNEI12 failed to find neighbours',JPQUIET)
        HIRLAMW = 9
        GOTO 900
      ENDIF
C
C     -----------------------------------------------------------------|
C     Section 4.  Perform the 12-point horizontal interpolation.
C     -----------------------------------------------------------------|
C
  400 CONTINUE
C
C     Setup the 12-point horizontal interpolation weights
C
      CALL HWTS12
     X  (NLEN,KSCHEME,KLA,PDLAT,GLATS,PDLO0,PDLO1,PDLO2,PDLO3,NEIGH,
     X   PWTS)
C
C     Calculate the interpolated grid point values
C
      DO LOOP = 1, NLEN
        IF( KSCHEME(LOOP).EQ.JP12PT ) THEN
C
C     See if any of the neighbours are missing
C
          COUNTU = 0
          IF( NOTEQ(OLDU(NEIGH( 1,LOOP)),RMISSGV) ) COUNTU = COUNTU + 1
          IF( NOTEQ(OLDU(NEIGH( 2,LOOP)),RMISSGV) ) COUNTU = COUNTU + 1
          IF( NOTEQ(OLDU(NEIGH( 3,LOOP)),RMISSGV) ) COUNTU = COUNTU + 1
          IF( NOTEQ(OLDU(NEIGH( 4,LOOP)),RMISSGV) ) COUNTU = COUNTU + 1
          IF( NOTEQ(OLDU(NEIGH( 5,LOOP)),RMISSGV) ) COUNTU = COUNTU + 1
          IF( NOTEQ(OLDU(NEIGH( 6,LOOP)),RMISSGV) ) COUNTU = COUNTU + 1
          IF( NOTEQ(OLDU(NEIGH( 7,LOOP)),RMISSGV) ) COUNTU = COUNTU + 1
          IF( NOTEQ(OLDU(NEIGH( 8,LOOP)),RMISSGV) ) COUNTU = COUNTU + 1
          IF( NOTEQ(OLDU(NEIGH( 9,LOOP)),RMISSGV) ) COUNTU = COUNTU + 1
          IF( NOTEQ(OLDU(NEIGH(10,LOOP)),RMISSGV) ) COUNTU = COUNTU + 1
          IF( NOTEQ(OLDU(NEIGH(11,LOOP)),RMISSGV) ) COUNTU = COUNTU + 1
          IF( NOTEQ(OLDU(NEIGH(12,LOOP)),RMISSGV) ) COUNTU = COUNTU + 1
          COUNTV = 0
          IF( NOTEQ(OLDV(NEIGH( 1,LOOP)),RMISSGV) ) COUNTV = COUNTV + 1
          IF( NOTEQ(OLDV(NEIGH( 2,LOOP)),RMISSGV) ) COUNTV = COUNTV + 1
          IF( NOTEQ(OLDV(NEIGH( 3,LOOP)),RMISSGV) ) COUNTV = COUNTV + 1
          IF( NOTEQ(OLDV(NEIGH( 4,LOOP)),RMISSGV) ) COUNTV = COUNTV + 1
          IF( NOTEQ(OLDV(NEIGH( 5,LOOP)),RMISSGV) ) COUNTV = COUNTV + 1
          IF( NOTEQ(OLDV(NEIGH( 6,LOOP)),RMISSGV) ) COUNTV = COUNTV + 1
          IF( NOTEQ(OLDV(NEIGH( 7,LOOP)),RMISSGV) ) COUNTV = COUNTV + 1
          IF( NOTEQ(OLDV(NEIGH( 8,LOOP)),RMISSGV) ) COUNTV = COUNTV + 1
          IF( NOTEQ(OLDV(NEIGH( 9,LOOP)),RMISSGV) ) COUNTV = COUNTV + 1
          IF( NOTEQ(OLDV(NEIGH(10,LOOP)),RMISSGV) ) COUNTV = COUNTV + 1
          IF( NOTEQ(OLDV(NEIGH(11,LOOP)),RMISSGV) ) COUNTV = COUNTV + 1
          IF( NOTEQ(OLDV(NEIGH(12,LOOP)),RMISSGV) ) COUNTV = COUNTV + 1
C
C         Interpolate using twelve neighbours if none are missing
C
          IF( (COUNTU.EQ.12).AND.(COUNTV.EQ.12) ) THEN
C
            U(LOOP) =
     X        OLDU(NEIGH( 1,LOOP)) * PWTS( 1,LOOP) +
     X        OLDU(NEIGH( 2,LOOP)) * PWTS( 2,LOOP) +
     X        OLDU(NEIGH( 3,LOOP)) * PWTS( 3,LOOP) +
     X        OLDU(NEIGH( 4,LOOP)) * PWTS( 4,LOOP) +
     X        OLDU(NEIGH( 5,LOOP)) * PWTS( 5,LOOP) +
     X        OLDU(NEIGH( 6,LOOP)) * PWTS( 6,LOOP) +
     X        OLDU(NEIGH( 7,LOOP)) * PWTS( 7,LOOP) +
     X        OLDU(NEIGH( 8,LOOP)) * PWTS( 8,LOOP) +
     X        OLDU(NEIGH( 9,LOOP)) * PWTS( 9,LOOP) +
     X        OLDU(NEIGH(10,LOOP)) * PWTS(10,LOOP) +
     X        OLDU(NEIGH(11,LOOP)) * PWTS(11,LOOP) +
     X        OLDU(NEIGH(12,LOOP)) * PWTS(12,LOOP)
            V(LOOP) =
     X        OLDV(NEIGH( 1,LOOP)) * PWTS( 1,LOOP) +
     X        OLDV(NEIGH( 2,LOOP)) * PWTS( 2,LOOP) +
     X        OLDV(NEIGH( 3,LOOP)) * PWTS( 3,LOOP) +
     X        OLDV(NEIGH( 4,LOOP)) * PWTS( 4,LOOP) +
     X        OLDV(NEIGH( 5,LOOP)) * PWTS( 5,LOOP) +
     X        OLDV(NEIGH( 6,LOOP)) * PWTS( 6,LOOP) +
     X        OLDV(NEIGH( 7,LOOP)) * PWTS( 7,LOOP) +
     X        OLDV(NEIGH( 8,LOOP)) * PWTS( 8,LOOP) +
     X        OLDV(NEIGH( 9,LOOP)) * PWTS( 9,LOOP) +
     X        OLDV(NEIGH(10,LOOP)) * PWTS(10,LOOP) +
     X        OLDV(NEIGH(11,LOOP)) * PWTS(11,LOOP) +
     X        OLDV(NEIGH(12,LOOP)) * PWTS(12,LOOP)
C
C         Set missing if all neighbours are missing
C
          ELSE IF( (COUNTU.EQ.0).OR.(COUNTV.EQ.0) ) THEN
            U(LOOP) = RMISSGV
            V(LOOP) = RMISSGV
C
C         Otherwise, use the nearest neighbour
C
          ELSE
            NEAREST = 1
            IF( PWTS( 2,LOOP).GT.PWTS(NEAREST,LOOP) ) NEAREST = 2
            IF( PWTS( 3,LOOP).GT.PWTS(NEAREST,LOOP) ) NEAREST = 3
            IF( PWTS( 4,LOOP).GT.PWTS(NEAREST,LOOP) ) NEAREST = 4
            IF( PWTS( 5,LOOP).GT.PWTS(NEAREST,LOOP) ) NEAREST = 5
            IF( PWTS( 6,LOOP).GT.PWTS(NEAREST,LOOP) ) NEAREST = 6
            IF( PWTS( 7,LOOP).GT.PWTS(NEAREST,LOOP) ) NEAREST = 7
            IF( PWTS( 8,LOOP).GT.PWTS(NEAREST,LOOP) ) NEAREST = 8
            IF( PWTS( 9,LOOP).GT.PWTS(NEAREST,LOOP) ) NEAREST = 9
            IF( PWTS(10,LOOP).GT.PWTS(NEAREST,LOOP) ) NEAREST =10
            IF( PWTS(11,LOOP).GT.PWTS(NEAREST,LOOP) ) NEAREST =11
            IF( PWTS(12,LOOP).GT.PWTS(NEAREST,LOOP) ) NEAREST =12
            U(LOOP) = OLDU(NEIGH( NEAREST,LOOP))
            V(LOOP) = OLDV(NEIGH( NEAREST,LOOP))
          ENDIF
C
        ELSE IF( KSCHEME(LOOP).EQ.JP4PT ) THEN
C
C     See if any of the neighbours are missing
C
          COUNTU = 0
          IF( NOTEQ(OLDU(NEIGH( 1,LOOP)),RMISSGV) ) COUNTU = COUNTU + 1
          IF( NOTEQ(OLDU(NEIGH( 2,LOOP)),RMISSGV) ) COUNTU = COUNTU + 1
          IF( NOTEQ(OLDU(NEIGH( 3,LOOP)),RMISSGV) ) COUNTU = COUNTU + 1
          IF( NOTEQ(OLDU(NEIGH( 4,LOOP)),RMISSGV) ) COUNTU = COUNTU + 1
          COUNTV = 0
          IF( NOTEQ(OLDV(NEIGH( 1,LOOP)),RMISSGV) ) COUNTV = COUNTV + 1
          IF( NOTEQ(OLDV(NEIGH( 2,LOOP)),RMISSGV) ) COUNTV = COUNTV + 1
          IF( NOTEQ(OLDV(NEIGH( 3,LOOP)),RMISSGV) ) COUNTV = COUNTV + 1
          IF( NOTEQ(OLDV(NEIGH( 4,LOOP)),RMISSGV) ) COUNTV = COUNTV + 1
C
C         Interpolate using four neighbours if none are missing
C
          IF( (COUNTU.EQ.4).AND.(COUNTV.EQ.4) ) THEN
C
            U(LOOP) =
     X        OLDU(NEIGH( 1,LOOP)) * PWTS( 1,LOOP) +
     X        OLDU(NEIGH( 2,LOOP)) * PWTS( 2,LOOP) +
     X        OLDU(NEIGH( 3,LOOP)) * PWTS( 3,LOOP) +
     X        OLDU(NEIGH( 4,LOOP)) * PWTS( 4,LOOP)
            V(LOOP) =
     X        OLDV(NEIGH( 1,LOOP)) * PWTS( 1,LOOP) +
     X        OLDV(NEIGH( 2,LOOP)) * PWTS( 2,LOOP) +
     X        OLDV(NEIGH( 3,LOOP)) * PWTS( 3,LOOP) +
     X        OLDV(NEIGH( 4,LOOP)) * PWTS( 4,LOOP)
C
C         Set missing if all neighbours are missing
C
          ELSE IF( (COUNTU.EQ.0).OR.(COUNTV.EQ.0) ) THEN
            U(LOOP) = RMISSGV
            V(LOOP) = RMISSGV
C
C         Otherwise, use the nearest neighbour
C
          ELSE
            NEAREST = 1
            IF( PWTS( 2,LOOP).GT.PWTS(NEAREST,LOOP) ) NEAREST = 2
            IF( PWTS( 3,LOOP).GT.PWTS(NEAREST,LOOP) ) NEAREST = 3
            IF( PWTS( 4,LOOP).GT.PWTS(NEAREST,LOOP) ) NEAREST = 4
            U(LOOP) = OLDU(NEIGH( NEAREST,LOOP))
            V(LOOP) = OLDV(NEIGH( NEAREST,LOOP))
          ENDIF
C
        ELSE
          DO NEXT = 1, 4
            IF( NEIGH(NEXT,LOOP).NE.0 ) THEN
              U(LOOP) = OLDU(NEIGH(NEXT,LOOP))
              V(LOOP) = OLDV(NEIGH(NEXT,LOOP))
            ENDIF
          ENDDO
C
        ENDIF
      ENDDO
C
C     -----------------------------------------------------------------|
C     Section 5.  Adjust the U and V components to new (rotated) axes
C     -----------------------------------------------------------------|
C
  500 CONTINUE
C
      DO LOOP = 1, NLEN
        RDIR(LOOP) = 0.0
      ENDDO
C
      CALL HPSHGPW(RLON,RLAT,RCLON,RCLAT,RDIR,NLEN,POLE)
C
      DO LOOP = 1, NLEN
        RDIR(LOOP) = -RADIAN(RDIR(LOOP))
      ENDDO
C
      DO LOOP = 1, NLEN
        C(LOOP) = COS(RDIR(LOOP))
        S(LOOP) = SIN(RDIR(LOOP))
      ENDDO
C
      DO LOOP = 1, NLEN
        IF( NOTEQ(U(LOOP),RMISSGV).AND.NOTEQ(V(LOOP),RMISSGV) ) THEN
          NEWFLDU(LOOP) = U(LOOP)*C(LOOP) - V(LOOP)*S(LOOP)
          NEWFLDV(LOOP) = U(LOOP)*S(LOOP) + V(LOOP)*C(LOOP)
        ELSE
          NEWFLDU(LOOP) = RMISSGV
          NEWFLDV(LOOP) = RMISSGV
        ENDIF
      ENDDO
C
C     -----------------------------------------------------------------|
C     Section 9.  Return.
C     -----------------------------------------------------------------|
C
  900 CONTINUE
      RETURN
      END

C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE CREX_GET_NAME_UNIT(KREFERENCE,YNAME,YUNIT)
C
C**** *CREX_GET_NAME_UNIT*

C
C
C     PURPOSE.
C     --------
C          FIND NAME AND THE UNIT FOR THE PARTICULAR REFERENCE NUMBER.
C
C
C**   INTERFACE.
C     ----------
C
C          *CALL* *CREX_GET_NAME_UNIT(KREFERENCE,YNAME,YUNIT)*
C
C
C        INPUT : *KREFERENCE* - TABLE B REFERENCE NUMBER
C        OUTPUT:
C                *CNAMES*     -  ARRAY CONTAINING ELEMENT NAMES
C                *CUNITS*     -  ARRAY CONTAINING ELEMENT UNITS
C
C
C     METHOD.
C     -------
C
C          NONE.
C
C     EXTERNALS.
C     ----------
C          NONE.
C
C     REFERENCE.
C     ----------
C
C          NONE.
C
C     AUTHOR.
C     -------
C
C          M. DRAGOSAVAC    *ECMWF*       15/01/2006.
C
C
C     MODIFICATIONS.
C     --------------
C
C          NONE.
C
C
      IMPLICIT LOGICAL(L,O,G), CHARACTER*8(C,H,Y)

C
      PARAMETER(JSUP =   9,JSEC0=   3,JSEC1= 40,JSEC2= 64 ,JSEC3=    4,
     1          JSEC4=   2,JELEM=40000,JSUBS=400,JCVAL=150 ,JBUFL=40000,
     2          JBPW =  32,JTAB =3000,JCTAB=120,JCTST=1800,JCTEXT= 200,
     3          JWORK=360000,JKEY=46)

C
      CHARACTER*64 YNAME
      CHARACTER*24 YUNIT
C
C
      COMMON/CREXTAB/ NCREXBR(JTAB),NCREXBS(JTAB)    , NCREXBDW(JTAB),
     1                NCREXDR(JTAB),NCREXDST(JTAB)   ,
     2                NCREXDL(JTAB),NCREXDSQ(JTAB*20),NCREXP(64,255)

C
C             NCREXBR     - table B,  table reference              array
C             NCREXBS     - table B,  scale                        array 
C             NCREXBDW    - table B,  data width                   array
C             NCREXDR     - table D,  table reference              array
C             NCREXDST    - table D,  starting pointers            array
C             NCREXDL     - table D,  lengths                      array
C             NCREXDSQ    - table D,  list of sequence descriptors array
C     
       COMMON/CREXTABC/ CREXNAME(JTAB),CREXUNIT(JTAB),CREXLST(JELEM)
C
C             CREXNAME      -  table B, ELEMENT NAME           array
C             CREXUNIT      -  table B, unit                   array
C
      CHARACTER CREXNAME*64,CREXUNIT*24
      CHARACTER*6  CREXLST
C
      ICLASS=KREFERENCE/1000
      IYYY  =KREFERENCE-ICLASS*1000+1
      ICLASS=ICLASS+1
C
      I=NCREXP(ICLASS,IYYY)
      YNAME=CREXNAME(I)
      YUNIT=CREXUNIT(I)
C
      RETURN
      END

      subroutine mygribex( isec0, isec1, isec2, zsec2, isec3, zsec3,
     x                     isec4, zsec4, ipunp, inbuff, ilenb, iword,
     x                     ierr)
C
C     An inteface to Fortran subroutine GRIBEX to get round any
C     problem passing the 'I' character parameter from C to Fortran.
C
      integer isec0, isec1, isec2, isec3,  isec4
      integer ipunp, inbuff, ilenb, iword, ierr
      dimension isec0(*), isec1(*), isec2(*), isec3(*),  isec4(*)
      dimension inbuff(*)

      real zsec2, zsec3, zsec4
      dimension zsec2(*), zsec3(*), zsec4(*)

      call gribex( isec0, isec1, isec2, zsec2, isec3, zsec3, isec4,
     x             zsec4, ipunp, inbuff, ilenb, iword, 'I', ierr)

      return
      end

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE CREXEN(KSEC0,KSEC1,KSEC3,
     1                  KTDLEN,CREXKTDLST,KDLEN,KDATA,KELEM,KVALS,
     2                  VALUES,CVALS,KBUFL,KBUFF,KERR)
C
C**** *CREXEN*
C
C
C     PURPOSE.
C     --------
C           Creates CREX message
C
C
C**   INTERFACE.
C     ----------
C
C           *CALL* *CREXEN(KSEC0,KSEC1,KSEC3,
C                          KTDLEN,CREXKTDLST,KDLEN,KDATA,KELEM,KVALS,
C                          VALUES,CVALS,KBUFL,KBUFF,KERR)*
C
C
C
C        INPUT :
C               *KBUFL*   -  Length of CREX message (words)
C               *KELEM*   -  Integer (expected number of expanded elements)
C               *KVALS*   -  Integer (expected number of data values)
C        OUTPUT:
C
C               *KSUP*    -  Integer array of 9 words containing
C                            suplementary information
C                         -  KSUP( 1) -- IDIM1, dimension of KSEC1
C                         -  KSUP( 2) -- Reserved
C                         -  KSUP( 3) -- IDIM3, dimension of KSEC3
C                         -  KSUP( 4) -- Reserved
C                         -  KSUP( 5) -- M (number of elements in values
C                                           array, first index)
C                         -  KSUP( 6) -- N (number of subsets,second index
C                                           of values array)
C                         -  KSUP( 7) -- JVC (number of elements in CVAL array)
C                         -  KSUP( 8) -- total CREX message length in bytes
C                         -  KSUP( 9) -- IDIM0, dimension of KSEC0
C
C               *KSEC0*   -  Integer array of 3 words containing
C                            CREX section 0 information
C                            KSEC0( 1)-- length of section 0 (bytes)
C                            KSEC0( 2)-- total length of CREX message (bytes)
C                            KSEC0( 3)-- CREX Edition number
C
C               *KSEC1*   -  Integer array of at least 40 words
C                            containing CREX section 1 information
C                            KSEC1( 1)-- Reserved
C                            KSEC1( 2)-- CREX Edition number
C                            KSEC1( 3)-- Reserved
C                            KSEC1( 4)-- Reserved
C                            KSEC1( 5)-- Reserved
C                            KSEC1( 6)-- CREX message type
C                            KSEC1( 7)-- Reserved
C                            KSEC1( 8)-- version number of local table used
C                            KSEC1( 9)-- Reserved
C                            KSEC1(10)-- Reserved
C                            KSEC1(11)-- Reserved
C                            KSEC1(12)-- Reserved
C                            KSEC1(13)-- Reserved
C                            KSEC1(14)-- CREX Master table
C                            KSEC1(15)-- version number of Master table used
C                            KSEC1(16) - KSEC1(40) -- Reserved
C
C
C                            Crex Edition 2
C
C               *KSEC1*   -  Integer array of at least 40 words
C                            containing CREX section 1 information
C                            KSEC1( 1)-- Reserved
C                            KSEC1( 2)-- CREX Edition number
C                            KSEC1( 3)-- Originating Centre ( oooo)
C                            KSEC1( 4)-- Update sequence number (uu)
C                            KSEC1( 5)-- Number of subsets (sss)
C                            KSEC1( 6)-- CREX data category (nnn)
C                            KSEC1( 7)-- International data sub-category (mmm)
C                            KSEC1( 8)-- version number of local table used
C                            KSEC1( 9)-- Year (yyyy)
C                            KSEC1(10)-- Month (mm)
C                            KSEC1(11)-- Day (dd)
C                            KSEC1(12)-- Hour (hh)
C                            KSEC1(13)-- Minute (mm)
C                            KSEC1(14)-- CREX Master table (tt)
C                            KSEC1(15)-- version number of Master table used (vv)
C                            KSEC1(16)-- Originating sub-centre (ppp)
C                            KSEC1(17)-- Bufr master table version number
C                            KSEC1(18)-- Bufr version number of local table used
C                            KSEC1(19) - KSEC1(40) -- Reserved
C
C
C               *KSEC3*   -  Integer array of 4 words containing
C                            CREX section 3 information
C                            KSEC3( 1)-- length of section 3 (bytes)
C                            KSEC3( 2)-- reserved
C                            KSEC3( 3)-- number of subsets
C                            KSEC3( 4)-- flag (data type,data compression)
C
C               *CNAMES*  -  Character*64  array of KELEM containing
C                            CREX Table B element names
C               *CUNITS*  -  Character*24 array of KELEM containig
C                            CREX Table B units
C               *VALUES*  -  Real*8 array of KVALS containing expanded
C                            data values
C               *CVALS*   -  Character*80 array of KVALS containing
C                            CREX code table or CCITTIA5 CREX elements
C                            entries
C               *KERR*    -  returned error code
C
C
C
C
C     METHOD.
C     -------
C
C            NONE
C
C     EXTERNALS.
C     ----------
C
C            NONE.
C
C     REFERENCE.
C     ----------
C
C          NONE.
C
C     AUTHOR.
C     -------
C
C          M. DRAGOSAVAC    *ECMWF*       04/02/2003.
C
C     MODIFICATIONS.
C     --------------
C
C          NONE.
C
      IMPLICIT LOGICAL(L,O,G), CHARACTER*8(C,H,Y)


      PARAMETER(JSUP =   9,JSEC0=   3,JSEC1= 40,JSEC2= 64 ,JSEC3=    4,
     1          JSEC4=   2,JELEM=40000,JSUBS=400,JCVAL=150 ,JBUFL=40000,
     2          JBPW =  32,JTAB =3000,JCTAB=120,JCTST=1800,JCTEXT= 200,
     3          JWORK=360000,JKEY=46)
C
C
      COMMON /CRWORK/ NBPT,NGS,NVIND,NBPTSEC2,RVIND,EPS,NE,IEOLD,
     1                  NC07YYY
C
      COMMON /CRWT/ NCREXDWINC,NCREXSCAM,NCREXAFDW,NCREXWT ,ODREPF,
     2             NCREXSTACK(JELEM),NCREXWTEN(JELEM),
     3             NCREXWTR (JELEM),NCREXWTS (JELEM),
     4             NCREXWTDW(JELEM)
C
C             NCREXDWINC   -  data width increment
C             NCREXSCAM    -  scale multiplier
C             NCREXAFDW    -  augmented field data width
C             NCREXWT      -  pointer to working table
C             NCREXSTACK   -  list of data descriptors
C             ODREPF   -  replication (logical)
C             NCREXWTR     -  working table reference
C             NCREXWTS     -  working scale
C             NCREXWTDW    -  working data width
C
C
C
      COMMON /CRWTC/ CREXWTEN(JELEM),CREXWTU(JELEM)
C
C             CREXWTEN    -  working table element naame
C             CREXWTU     -  working table units
C
      CHARACTER CREXWTEN*64,CREXWTU*24
C
      COMMON /CREL/ NCREXTDLEN,NCREXTDLST(JELEM),NCREXTDEXL,
     1              NCREXTDEXP(JELEM)
C
C             NCREXTDLEN - number of Data descriptors in section 3
C             NCREXTDLST - list of Data descriptors
C             NCREXTDEXL - number of expanded Data Descriptors
C             NCREXTDEXP - list of expanded Data descriptors
C
      COMMON /CRCMOFF/ NSUBSET
C

      CHARACTER*120 YENTRY
      CHARACTER*15  FMT
      CHARACTER*6  CREXKTDLST(KELEM),CREXKTDLST0
C
      INTEGER IVALUE(KELEM)
C
      CHARACTER*4 YUSE_E
C
      INTEGER IVAL,IIVAL
c
      REAL*8 EPS
      REAL*8 RVIND
      REAL*8 VAL
C

      DIMENSION KSUP(JSUP),KSEC0(JSEC0),KSEC1(JSEC1)
      DIMENSION KSEC3(JSEC3)
      DIMENSION KBUFF(KBUFL)
      DIMENSION KBUFR(JBUFL)
C
      REAL*8 VALUES(KVALS)
C
      CHARACTER*80 CVALS(KVALS),CV
C
      CHARACTER*(JBUFL*4) YOUT
C
      CHARACTER*3 crcrlf
C
      CHARACTER*4 CECMWF
C
      EQUIVALENCE(KBUFR(1),YOUT)

C     ------------------------------------------------------------------
C
      CALL GETENV('USE_E',YUSE_E)
C 
      YOUT=' '
      IPT=1
      IPT0=1
      crcrlf=char(13)//char(13)//char(10)
c
c*         1. Set Constants
c             ----------------
 100  continue
c
      KERR=0
      IF(CECMWF.NE.'ECMF') THEN
         CALL CREXIVAR(KERR)
         IPT   = 1
         IPT0  = 1
         CECMWF='ECMF'
      END IF
c
C*          1. Create Section 0 - Indicator Section
C              ------------------------------------
 110  CONTINUE
c
      YOUT(1:9)='CREX++'//crcrlf
c
c*          2. Create Section 1 - Data Description Section
c              -------------------------------------------
 200  CONTINUE
c
      IF(KSEC1(2).LT.2) THEN
      YOUT(10:10)='T'
      WRITE(YOUT(10:16),'(A1,3(i2.2))') 'T',KSEC1(14),KSEC1(2),KSEC1(15)
      YOUT(17:18)=' A'
      WRITE(YOUT(19:21),'(I3.3)',IOSTAT=IOS) KSEC1(6)
      IF(IOS.NE.0) THEN
         print*,'Internal write error.'
         KERR=33
         RETURN
      END IF
      IPT=22
      ELSE
         YOUT(10:10)='T'
         WRITE(YOUT(10:20),'(A1,5(i2.2))') 'T',KSEC1(14),KSEC1(2),
     1         KSEC1(15),KSEC1(17),KSEC1(18)
         YOUT(22:22)='A'
         WRITE(YOUT(23:28),'(2(i3.3))') KSEC1(6), KSEC1(7)
         YOUT(30:30)='P'
         WRITE(YOUT(31:38),'(i5.5,i3.3)') KSEC1(3), KSEC1(16)
         YOUT(40:40)='U'
         WRITE(YOUT(41:42),'(i2.2)') ksec1(4)
         YOUT(44:44)='S'
         WRITE(YOUT(45:47),'(i3.3)') KSEC1(5)
         YOUT(49:49)='Y'
         WRITE(YOUT(50:57),'(I4.4,2(i2.2))') KSEC1(9),KSEC1(10),
     1         KSEC1(11)
         YOUT(59:59)='H'
         WRITE(YOUT(60:63),'(2(i2.2))') KSEC1(12),KSEC1(13)

         IPT=64
      END IF
C
      DO 201 I=1,KTDLEN
      YOUT(IPT:IPT+6)=' '//CREXKTDLST(I)
      IPT=IPT+7
c
      IF((IPT-IPT0).GT.60) THEN
         YOUT(IPT:IPT+2)=crcrlf
         IPT=IPT+3
         IPT0=IPT
      END IF
c
 201  CONTINUE
c
      IF(YUSE_E.EQ.'true') THEN
         iE=1
         YOUT(IPT:IPT+6)=' E++'//crcrlf
         IPT=IPT+7
      ELSE
         YOUT(IPT:IPT+4)='++'//crcrlf
         IPT=IPT+5
      END IF
c
c*         3. Load Crex Tables
c             ----------------
 300  CONTINUE
c
      CALL CREXETAB(KSEC1,KERR)
      IF(KERR.GT.0) RETURN

c
c*         3.1 Expand Data Descriptors
c              -----------------------
c
 310  CONTINUE
c
      KPT=0
      IPT0=IPT
      NSUBSET=0
      DO 401 IX=1,KSEC3(3)
C
      NSUBSET=NSUBSET+1
C
      CALL CREXETD(KPT,KTDLEN,CREXKTDLST,KDLEN,KDATA,KSEC3,
     1             KVALS,VALUES,KELEM,KERR)
      IF(KERR.GT.0) RETURN
c
c*         4. Create Section 2 - Data Section
c             -------------------------------
 400  CONTINUE
c
C
C
      DO 402 iy=1,NCREXTDEXL
      IZ=IY+(NSUBSET-1)*KELEM
c
      IF(ABS(VALUES(IZ)-RVIND)/RVIND.gt.EPS) THEN
         if(CREXWTU(IY)(1:4).EQ.'CHAR') THEN
            ICP=NINT(VALUES(IZ)/1000)
            ICH=NINT(VALUES(IZ))-ICP*1000
            IF(YUSE_E.EQ.'true') THEN
               YOUT(IPT:IPT)=CHAR(iE+48)
               iE=iE+1
               IF(iE.GT.9) iE=0
               IPT=IPT+1
            END IF
            YOUT(IPT:IPT)=' '
            IPT=IPT+1
            IF(ICHAR(CVALS(ICP)(1:1)).EQ.255) then
               cv=' '
               do ii=1,NCREXWTDW(IY)
               cv(ii:ii)='/'
               end do 
               YOUT(IPT:IPT+NCREXWTDW(IY)-1)=cv
            else
               YOUT(IPT:IPT+NCREXWTDW(IY)-1)=CVALS(ICP)
            end if
            IPT=IPT+NCREXWTDW(IY)
            YOUT(IPT:IPT)=' '
            IPT=IPT+1
         ELSE
            IF(CREXWTU(IY)(1:4).EQ.'FLAG') THEN
               IVAL=INT(VALUES(IZ))
               CALL DEC2OCTAL(IIVAL,IVAL,IERR)
               IF(IERR.NE.0) THEN
                  print*,'Error during flag conversion'
                  print*,'iz=',iz,' ','values(iz)=',values(iz)
                  print*,'iz=',iz,' ','ival      =',ival
                  print*,'iz=',iz,' ','iival      =',iival
                  KERR=34
                  RETURN 
               END IF
               VALUES(IZ)=FLOAT(IIVAL)
c           ELSEIF(CREXWTU(IY)(1:4).eq.'C   ') THEN
c              convert Kelvin into Celsius
c              VALUES(IZ)=VALUES(IZ)-273.16
            END IF

            IF(NCREXWTS(IY).GE.0) THEN
               IVALUE(IY)=NINT(VALUES(IZ)*10.**NCREXWTS(IY))
            ELSE
               IVALUE(IY)=NINT(VALUES(IZ)/10.**IABS(NCREXWTS(IY)))
            END IF
C
c-----------------------------------------------------------------
            JZ=0
            IRES=IABS(IVALUE(IY))
            DO WHILE(IRES.GT.0)
            JZ=JZ+1
            IRES=IRES/10
            END DO
c
            IF(JZ.GT.NCREXWTDW(IY)) THEN
      print*,'Element=',iy,' NCREXWTR=',NCREXWTR(iy),'value=',ivalue(iy)
               print*,'number of figures calculated ',jz
               print*,'number of figures in tables ',NCREXWTDW(iy)
c
c              Replace this value with missing value '/'
c
               YOUT(IPT:IPT)=' '
               IPT=IPT+1
               if(YUSE_E.EQ.'true') THEN
                  YOUT(IPT:IPT)=CHAR(iE+48)
                  iE=iE+1
                  if(iE.gt.9) iE=0
                  IPT=IPT+1
               END IF
               DO III=1,NCREXWTDW(IY)
               YOUT(IPT:IPT)='/'
               IPT=IPT+1
               END DO
            ELSE
c-----------------------------------------------------------------
               IF(IVALUE(IY).LT.0) THEN
                  YOUT(IPT:IPT)=' '
                  IF(YUSE_E.eq.'true') THEN
                     IPT=IPT+1
                     YOUT(IPT:IPT)=CHAR(iE+48)
                     iE=iE+1
                     IF(iE.gt.9) iE=0
                  END IF
                  IPT=IPT+1
                  YOUT(IPT:IPT)='-'
               ELSE
                  YOUT(IPT:IPT)=' '
                  IF(YUSE_E.EQ.'true') THEN
                     IPT=IPT+1
                     YOUT(IPT:IPT)=CHAR(iE+48)
                     iE=iE+1
                     IF(iE.gt.9) iE=0
                  END IF
               END IF
c
               IPT=IPT+1
c
               FMT='(i02.02)'
               IF(NCREXWTR(iy).eq.031001.or.NCREXWTR(iy).eq.031002) then
                  NCREXWTDW(iy)=4
               END IF
               WRITE(FMT(3:4),'(I2.2)',IOSTAT=IOS) NCREXWTDW(iy)
               IF(IOS.NE.0) THEN
                  print*,'Internal write error.'
                  KERR=33
                  RETURN
               END IF
               FMT(6:7)=FMT(3:4)
               WRITE(YOUT(IPT:IPT+NCREXWTDW(iy)-1),FMT,IOSTAT=IOS)
     1               IABS(IVALUE(IY))
               IF(IOS.NE.0) THEN
                  print*,'Internal write error ',ios
                  KERR=33
                  RETURN
               END IF
               IPT=IPT+NCREXWTDW(iy)
            END IF
         END IF
      ELSE
         YOUT(IPT:IPT)=' '
         IF(YUSE_E.eq.'true') THEN
            IPT=IPT+1
            YOUT(IPT:IPT)=CHAR(iE+48)
            iE=iE+1
            IF(iE.gt.9) iE=0
         END IF
c
         IPT=IPT+1
c
         DO III=1,NCREXWTDW(iy)
          YOUT(IPT:IPT)='/'
          IPT=IPT+1
         END DO
      END IF
c
      IF((IPT-IPT0).GT.60) THEN
         YOUT(IPT:IPT+2)=crcrlf
         IPT=IPT+3
         IPT0=IPT
      END IF
C
 402  CONTINUE
c
      YOUT(IPT:IPT+3)='+'//crcrlf
      IPT=IPT+4
      IPT0=IPT
c
 401  CONTINUE
C
      IPT=IPT-4
      YOUT(IPT:IPT+4)='++'//crcrlf
      IPT=IPT+5
c
c*          5. Create Section 4 - End Section
c              -------------------------------
 500  continue
c
      YOUT(IPT:IPT+6)='7777'//crcrlf
      IPT=IPT+6
      IPT0=IPT
C
C           6. Return the size of crex in bytes
C              --------------------------------
 600  CONTINUE

      NBYTPW=JBPW/8
      K=IPT/NBYTPW+1
      DO 601 I=1,K
      KBUFF(i)=KBUFR(i)
 601  END DO
C
      KBUFL=IPT
C
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE SSCAL (KN, SA, XVEC, KNCX)                             
C                                                                       
C---->
C**** *SSCAL* - ROUTINE WHICH IMPLEMENTS THE BLAS ROUTINE OF THE        
C               SAME NAME                                               
C                                                                       
C     PURPOSE.                                                          
C     --------                                                          
C                                                                       
C     SIMPLE REPLACEMENT FOR IBM                                        
C                                                                       
C**   INTERFACE.                                                        
C     ----------                                                        
C                                                                       
C     * CALL SSCAL (KN, SA, XVEC, KNCX) *                               
C                                                                       
C                                                                       
C     METHOD.                                                           
C     -------                                                           
C                                                                       
C     XVEC (1 + IP * KNCX) = XVEC (1 + IP * KNCX) * SA                  
C     FOR IP = 0 TO KN - 1                                              
C                                                                       
C     EXTERNALS.                                                        
C     ----------                                                        
C                                                                       
C     NONE                                                              
C                                                                       
C     REFERENCE.                                                        
C     ----------                                                        
C                                                                       
C     NONE                                                              
C                                                                       
C     AUTHOR.                                                           
C     -------                                                           
C                                                                       
C     K. FIELDING         * ECMWF *     FEB 1992.                       
C                                                                       
C     MODIFICATIONS.                                                    
C     --------------                                                    
C                                                                       
C     NONE                                                              
C                                                                       
C     COMMON BLOCKS USED                                                
C     -------------------                                               
C                                                                       
C     NONE                                                              
C----<
C                                                                       
      INTEGER KN, KNCX                                                  
Cjdc  DOUBLE PRECISION SA                                               
Cjdc  DOUBLE PRECISION XVEC (*)                                         
      REAL SA                                               
      REAL XVEC (*)                                         
C                                                                       
      INTEGER IP                                                        
C                                                                       
C     1.    MAIN LOOP OF CODE                                           
C           ----------------------------------------------              
C                                                                       
  100 CONTINUE                                                          
      DO 110 IP = 0, KN - 1                                             
         XVEC (1 + IP * KNCX) = XVEC (1 + IP * KNCX) * SA               
  110 CONTINUE                                                          
C                                                                       
C     END OF ROUTINE                                                    
C                                                                       
      RETURN                                                            
      END                                                               

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities
C granted to it by virtue of its status as an intergovernmental organisation
C nor does it submit to any jurisdiction.
C

      SUBROUTINE JAGGGP( PSHUP, KTRUNC, PNORTH, PSOUTH, PWEST, PEAST,
     X                    KNUM, HTYPE, KPTS, POUTF, LUV, KRET)
C
C---->
C**** JAGGGP
C
C     PURPOSE
C     _______
C
C     This routine converts spectral input fields to a gaussian
C     grid field.
C
C     INTERFACE
C     _________
C
C     CALL JAGGGP( PSHUP, KTRUNC, PNORTH, PSOUTH, PWEST, PEAST,
C    X                    KNUM, HTYPE, KPTS, POUTF, LUV, KRET)
C
C     Input parameters
C     ________________
C
C     PSHUP    - Spherical harmonics field, unpacked
C     KTRUNC   - Truncation number of spherical harmonics field
C     PNORTH   - Northernmost latitude for output field (degrees)
C     PSOUTH   - Southernmost latitude for output field (degrees)
C     PWEST    - Westernmost longitude for output field (degrees)
C     PEAST    - Easternmost longitude for output field (degrees)
C     KNUM     - Gaussian grid number
C     HTYPE    - Gaussian grid type
C                = 'R' for reduced ("quasi-regular"),
C                = 'O' for reduced/octahedral,
C                = 'F' for full,
C                = 'U' for user-defined reduced gaussian grid
C     KPTS     - Array specifying number of points at each line of
C                latitude if HTYPE = 'U'.
C                (Must be big enough for both hemispheres, but only
C                 needs to give Northern hemisphere values from pole
C                 to latitude nearest the Equator.)
C     LUV      - Code indicating whether or not the field is a wind
C                component field;
C                = 1 if U or V field.
C
C     Output parameters
C     ________________
C
C     KPTS     - Array specifying number of points at each line of
C                latitude; user defined values if HTYPE = 'U'.
C                (Must be big enough for both hemispheres)
C     POUTF    - Output grid point field
C     KRET     - Return status code
C                0 = OK
C
C     Common block usage
C     __________________
C
C     JDCNDBG, JDCFLAGS
C
C     Method
C     ______
C
C     None.
C
C
C     Externals
C     _________
C
C     JGETGG   - Pick up the definition of the gaussian grid.
C     JOPNGG   - Opens the legendre functions file for reading line
C                by line.
C     JOPNGGF  - Opens the legendre functions file and reads the whole
C                of it into dynamically allocated memory.
C     JOPNGGSM - Opens the legendre functions file and memory maps it.
C     JJSET99  - Sets up FFT
C     JNORSGG  - Determines which latitude row in a gaussian grid is
C                north or south of a given latitude
C     JSYMGG   - Generate symmetric grid from spherical harmonics
C     JWSCAL   - Apply latitude correction to wind component field
C     JMVUGG   - Moves grid point data to output array
C     JMKOFGG  - Builds offsets into storage array
C     JDEBUG   - Checks environment variable to switch on/off debug
C     INTLOG   - Logs output messages
C     INTLOGR  - Logs output messages
C     GETCONF  - Decides how to handle legendre coefficients
C     GETENV   - Get value of an environment variable
c     FORCED_FFTW - determine if FFTW should be used, instead of the
C                usual FFT99 (as per the environment)
#ifdef SHAREDMEMORY
C     SMREAD   - Gets interpolation coefficients in a shared memory array
#endif
C
C
C     Reference
C     _________
C
C     None
C
C
C     Comments
C     ________
C
C     It handles transformations to a gaussian grid.
C
C
C     AUTHOR
C     ______
C
C     J.D.Chambers      *ECMWF*      Jan 1994
C
C     MODIFICATIONS
C     _____________
C
C
C     J.D.Chambers     ECMWF        Feb 1997
C     Allow for 64-bit pointers
C
C----<
C     _______________________________________________________
C
C
      IMPLICIT NONE
#include "jparams.h"
#include "parim.h"
#include "current.h"
#include "nifld.common"
#include "nofld.common"
#include "grfixed.h"
C
C     Subroutine arguments
C
      COMPLEX   PSHUP
      DIMENSION PSHUP(*)
      INTEGER   KTRUNC, KNUM, KPTS, KRET, KRET2
      DIMENSION KPTS(*)
      CHARACTER*1 HTYPE
      REAL      PNORTH, PSOUTH, PWEST, PEAST
      REAL      POUTF
      DIMENSION POUTF(*)
      INTEGER   LUV
C
C     Parameters
C
      INTEGER JPROUTINE
      PARAMETER ( JPROUTINE = 31600 )
C
C     Local variables
C
      INTEGER ILON, ITOUP1, IJPWR, NUMPTS
      DIMENSION IJPWR(JPMAX)
      INTEGER ILUNIT
      INTEGER NXTROW
      REAL RINTVL, GNUM
      LOGICAL LUSEFFTW
C
      INTEGER IMFAX
      REAL ATRIGS
      DIMENSION IMFAX(10),ATRIGS(JPLONO*2)
#ifndef _CRAYFTN
#ifdef POINTER_64
      INTEGER*8 IALEG, IZFA
#endif
#endif
      REAL ALEG
      DIMENSION ALEG(1)
      POINTER ( IALEG, ALEG )
      REAL ZFA
      DIMENSION ZFA(1)
      POINTER ( IZFA, ZFA )
      INTEGER ISIZE
      DATA ISIZE/0/
      SAVE ISIZE, IZFA
C
      CHARACTER*10 PLAINUV
      CHARACTER*6  HUSEFFT
C
      INTEGER NGROUP
      INTEGER FILENM, J, NNORTH, NSOUTH, NCASE, NFLAG
      INTEGER NOFSET, LOOP
      DIMENSION NOFSET(JPMAX)
      INTEGER INORTH, ISOUTH, IMAGE, NFIRST, NDIFF
      DATA FILENM/67/
      REAL ALAT
      DIMENSION ALAT(JPMAX)
C
      SAVE ILUNIT, IALEG
C
      LOGICAL LDEBUG, LFIRST, LPLAINU
      DATA LFIRST/.TRUE./, LPLAINU/.FALSE./
      SAVE LDEBUG, LFIRST, LPLAINU
      INTEGER IBLANK
C
C     External
C
      INTEGER  JNORSGG
      EXTERNAL JNORSGG
#ifdef SHAREDMEMORY
      INTEGER  SHAREDGG, SHAREDDT
      EXTERNAL SHAREDGG, SHAREDDT
#endif
      LOGICAL FORCED_FFTW
      EXTERNAL FORCED_FFTW
C     _______________________________________________________
C
C*    Section 1.    Initialization.
C     _______________________________________________________
C
  100 CONTINUE
C
      CALL JDEBUG( )
      LDEBUG = NDBG.GT.0
C
C     Decide how to handle legendre coefficients
C
      CALL GETCONF()
C
      IF( LFIRST ) THEN
C
        LFIRST = .FALSE.
C
C       Check environment variable to see if wind components are plain
C       U and V, or U*cos(theta) and V*cos(theta) (the default).
C
        CALL GETENV('INTERP_PLAIN_UV', PLAINUV)
        IBLANK = INDEX(PLAINUV, ' ')
C
        IF( (IBLANK.EQ.3).AND.(PLAINUV(1:2).EQ.'ON') )  LPLAINU =.TRUE.
        IF( (IBLANK.EQ.3).AND.(PLAINUV(1:2).EQ.'on') )  LPLAINU =.TRUE.
        IF( (IBLANK.EQ.4).AND.(PLAINUV(1:3).EQ.'YES') ) LPLAINU =.TRUE.
        IF( (IBLANK.EQ.4).AND.(PLAINUV(1:3).EQ.'yes') ) LPLAINU =.TRUE.
C
        IF( (IBLANK.EQ.3).AND.(PLAINUV(1:2).EQ.'NO') )  LPLAINU =.FALSE.
        IF( (IBLANK.EQ.3).AND.(PLAINUV(1:2).EQ.'no') )  LPLAINU =.FALSE.
        IF( (IBLANK.EQ.4).AND.(PLAINUV(1:3).EQ.'OFF') ) LPLAINU =.FALSE.
        IF( (IBLANK.EQ.4).AND.(PLAINUV(1:3).EQ.'off') ) LPLAINU =.FALSE.
C
C
C       First time through, dynamically allocate memory for workspace
C
        ISIZE =  (JPLONO+2)*64
        CALL JMEMHAN( 10, IZFA, ISIZE, 1, KRET)
        IF( KRET.NE.0 ) THEN
          CALL INTLOG(JP_ERROR,'JAGGGP: memory allocation error.',IZFA)
          KRET = JPROUTINE + 1
          GOTO 990
        ENDIF
      ENDIF
C
      IF( LDEBUG ) THEN
        CALL INTLOG(JP_DEBUG,'JAGGGP: Input parameters:',JPQUIET)
        CALL INTLOG(JP_DEBUG,
     X    'JAGGGP: Spherical harmonic truncation = ', KTRUNC)
        CALL INTLOGR(JP_DEBUG,
     X    'JAGGGP: Northern latitude for output = ', PNORTH)
        CALL INTLOGR(JP_DEBUG,
     X    'JAGGGP: Southern latitude for output = ', PSOUTH)
        CALL INTLOGR(JP_DEBUG,
     X    'JAGGGP: Western longitude for output = ', PWEST)
        CALL INTLOGR(JP_DEBUG,
     X    'JAGGGP: Eastern longitude for output = ', PEAST)
        CALL INTLOG(JP_DEBUG,
     X    'JAGGGP: Gaussian grid number = ', KNUM)
C
        IF( HTYPE.EQ.'R' .OR. HTYPE.EQ.'r' ) CALL INTLOG(JP_DEBUG,
     X    'JAGGGP: Grid type is Reduced.',JPQUIET)
        IF( HTYPE.EQ.'O' .OR. HTYPE.EQ.'o' ) CALL INTLOG(JP_DEBUG,
     X    'JAGGGP: Grid type is Reduced/octahedral.',JPQUIET)
        IF( HTYPE.EQ.'F' .OR. HTYPE.EQ.'f' ) CALL INTLOG(JP_DEBUG,
     X    'JAGGGP: Grid type is Full.',JPQUIET)
        IF( HTYPE.EQ.'U' .OR. HTYPE.EQ.'u' ) CALL INTLOG(JP_DEBUG,
     X    'JAGGGP: Grid type is User.',JPQUIET)
        CALL INTLOG(JP_DEBUG,
     X    'JAGGGP: Field code( = 1 for U or V) = ', LUV)
C
        IF( HTYPE.EQ.'u' .OR. HTYPE.EQ.'U' ) THEN
          CALL INTLOG(JP_DEBUG,'JAGGGP: User-supplied values.',JPQUIET)
          CALL INTLOG(JP_DEBUG,'JAGGGP: No. pts at each line:',JPQUIET)
          DO NDBGLP = 1, 20
            CALL INTLOG(JP_DEBUG,' ',KPTS( NDBGLP ))
          ENDDO
        ENDIF
      ENDIF
C
C     Pick up the file containing the definition of the gaussian grid.
C
      IF( (NOGAUSO.NE.KNUM).OR.(HOGAUST.NE.HTYPE) ) THEN
        CALL JGETGG( KNUM, HTYPE, ALAT, KPTS, KRET)
        IF( KRET.NE.0 ) GOTO 990
        NOGAUSO = KNUM
        HOGAUST = HTYPE
      ELSE
        DO LOOP = 1, KNUM*2
          ALAT(LOOP) = ROGAUSS(LOOP)
          KPTS(LOOP) = NOLPTS(LOOP)
        ENDDO
      ENDIF
C
C     If coefficients are not to generated 'on the fly',
C     open the appropriate legendre function file.
C
      IF( LFILEIO ) THEN
        ISIZE = JPK
        CALL JMEMHAN( 14, IALEG, ISIZE, 1, KRET)
        IF( KRET.NE.0 ) THEN
          CALL INTLOG(JP_ERROR,'JAGGGP: memory allocate error',IALEG)
          KRET = JPROUTINE + 2
          GOTO 990
        ENDIF
        CALL JOPNGG(ALEG,KNUM,KTRUNC,ILUNIT,ALAT,KRET)
      ELSE IF( LMEMORY ) THEN
        CALL JOPNGGF(IALEG,KNUM,KTRUNC,ILUNIT,ALAT,KRET)
      ELSE IF( LMAPPED ) THEN
        CALL JOPNGGSM(IALEG,KNUM,KTRUNC,ILUNIT,ALAT,KRET)
#ifdef SHAREDMEMORY
      ELSE IF( LSHARED ) THEN
        GNUM = REAL(KNUM)
        CALL INTLOG(JP_DEBUG,'JAGGGP: call SHAREDGG', JPQUIET)
        KRET = SHAREDGG(IALEG,KTRUNC,KNUM)
        IF( KRET.NE.0 ) THEN
          CALL INTLOG(JP_ERROR,
     X      'JAGGGP: SHARED MEMORY Failed to get legendre coeff.',KRET)
          KRET = JPROUTINE + 3
          GOTO 990
        ENDIF
        GOTO 102
#endif
      ELSE
        ISIZE =  (KTRUNC+1)*(KTRUNC+2)
        CALL JMEMHAN( 14, IALEG, ISIZE, 1, KRET)
        IF( KRET.NE.0 ) THEN
          CALL INTLOG(JP_ERROR,'JAGGGP: memory allocate error.',IALEG)
          KRET = JPROUTINE + 2
          GOTO 990
        ENDIF
      ENDIF
C
      IF( KRET.NE.0 ) THEN
        CALL INTLOG(JP_ERROR,
     X    'JAGGGP: Failed to get legendre coefficients',KRET)
        KRET = JPROUTINE + 3
        GOTO 990
      ENDIF
C
  102 CONTINUE
C
C     Determine which latitude rows in the gaussian grid are in the
C     requested area
C
      NNORTH = JNORSGG( PNORTH, ALAT, KNUM, 1)
      NSOUTH = JNORSGG( PSOUTH, ALAT, KNUM, 0)
      IF( LDEBUG ) THEN
        CALL INTLOG(JP_DEBUG,
     X    'JAGGGP: Gaussian latitudes in requested area:',JPQUIET)
        CALL INTLOG(JP_DEBUG,'JAGGGP: NORTH = ',NNORTH)
        CALL INTLOG(JP_DEBUG,'JAGGGP: SOUTH = ',NSOUTH)
      ENDIF
C
C
C     For calculation purposes, the number of longitude points for each
C     latitude row has to be greater than 2*(output truncation) to
C     ensure the fourier transform is exact (see Reference, page 10).
C
C     The following loop calculates the power of 2 to be used as a
C     multipier for each row to ensure there are enough points.
C     Later, when filling the output array POUTF, the longitude points
C     have to be taken selectively to avoid the intermediate generated
C     points, picking up values only at the required longitudes.
C
      ITOUP1 = KTRUNC
      DO J = 1, KNUM
        IMAGE = 2*KNUM - J + 1
        ILON     = KPTS(J)
        IJPWR(J) = 1
 104    CONTINUE
          IF(ILON .GT. 2*ITOUP1) GOTO 106
          IJPWR(J) = IJPWR(J)*2
          ILON        = ILON*2
          GOTO 104
 106    CONTINUE
        IJPWR(IMAGE) = IJPWR(J)
      ENDDO
C
C     _______________________________________________________
C
C*    Section 2.    Work out geometry of the request
C     _______________________________________________________
C
 200  CONTINUE
C
C     Latitude rows are generated from row INORTH to ISOUTH.
C     Selection is carried out for actual requested rows when the
C     calculated values are moved to the output array.
C
C     Start with assumption that the area is symmetrical about equator.
C
      NCASE  = 1
      NFLAG  = 3
      INORTH = NNORTH
      ISOUTH = KNUM
      NDIFF  = 0
C
C     Northern hemisphere only ?
C
      IF ( PSOUTH .GE. 0.0 ) THEN
        NCASE  = 2
        NFLAG  = 1
        INORTH = NNORTH
        ISOUTH = NSOUTH
        IF( LDEBUG ) CALL INTLOG(JP_DEBUG,
     X    'JAGGGP: North hemisphere only.',JPQUIET)
        GOTO 220
      ENDIF
C
C     Southern hemisphere only ?
C
      IF ( PNORTH .LE. 0.0 ) THEN
        NCASE  = 3
        NFLAG  = 2
        INORTH = 2*KNUM - NSOUTH + 1
        ISOUTH = 2*KNUM - NNORTH + 1
        IF( LDEBUG ) CALL INTLOG(JP_DEBUG,
     X    'JAGGGP: South hemisphere only.',JPQUIET)
        GOTO 220
      ENDIF
C
C     Straddles equator ...
C     ... more north than south?
C
      IF ( PNORTH .GT. -PSOUTH ) THEN
        NCASE  = 4
        INORTH = NNORTH
        ISOUTH = KNUM
        IF( LDEBUG ) THEN
          CALL INTLOG(JP_DEBUG,'JAGGGP: Straddles equator.',JPQUIET)
          CALL INTLOG(JP_DEBUG,'JAGGGP: More north than south',JPQUIET)
        ENDIF
        GOTO 220
      ENDIF
C
C     ... more south than north?
C
      IF ( PNORTH .LT. -PSOUTH ) THEN
        NCASE  = 5
        INORTH = 2*KNUM - NSOUTH + 1
        ISOUTH = KNUM
        NDIFF  = NNORTH - INORTH
        IF( LDEBUG ) THEN
          CALL INTLOG(JP_DEBUG,'JAGGGP: Straddles equator.',JPQUIET)
          CALL INTLOG(JP_DEBUG,'JAGGGP: More south than north',JPQUIET)
        ENDIF
      ENDIF
C
C     Setup the storage offset for the given latitude range
C
 220  CONTINUE
C
      IF( LDEBUG ) THEN
        CALL INTLOG(JP_DEBUG,'JAGGGP: INORTH = ', INORTH)
        CALL INTLOG(JP_DEBUG,'JAGGGP: ISOUTH = ', ISOUTH)
      ENDIF
      CALL JMKOFGG(HTYPE,NNORTH,NSOUTH,PWEST,PEAST,KNUM,KPTS,NOFSET)
C
C     _______________________________________________________
C
C*    Section 3.    Check which version of FFT to use
C     _______________________________________________________
C
 300  CONTINUE
C
      LUSEFFTW = FORCED_FFTW(LOCTAHEDRAL)
      HUSEFFT = 'FFT99'
#ifdef HAVE_FFTW
      IF( LDEBUG .AND. .NOT. LUSEFFTW ) CALL INTLOG(JP_DEBUG,
     X  'JAGGGP: Check which version of FFT to use.',JPQUIET)
      DO LOOP = 1, KNUM !*2 (only half of KPTS/IJPWR needs to be checked)
        IF( LUSEFFTW ) EXIT
        ILON = KPTS(LOOP) * IJPWR(LOOP)
        CALL JJSET99( ATRIGS, IMFAX, ILON, KRET )
        LUSEFFTW = ( KRET .NE. 0 )
      ENDDO
#ifdef REAL_8
      IF( LUSEFFTW ) HUSEFFT = 'DFFTW'
#else
      IF( LUSEFFTW ) HUSEFFT = 'SFFTW'
#endif
#endif
      IF( LDEBUG ) CALL INTLOG(JP_DEBUG,
     X  'JAGGGP: Will use '//HUSEFFT,JPQUIET)
C
C     _______________________________________________________
C
C*    Section 4.    Process all latitude rows
C     _______________________________________________________
C
 400  CONTINUE
C
      IF( LDEBUG ) CALL INTLOG(JP_DEBUG,
     X  'JAGGGP: Process latitude rows.',JPQUIET)
C
      NGROUP = 0
C
      DO NXTROW = INORTH, ISOUTH
C
C       Build up a group of lines of the same length which can all
C       be transformed at the same time.
        NGROUP = NGROUP + 1
C
C       Initialise FFT constants for the group
C
        IF ( NGROUP .EQ. 1 ) THEN
          NFIRST = NXTROW
          ILON = KPTS(NFIRST) * IJPWR(NFIRST)
C
          IF( LDEBUG ) THEN
            CALL INTLOG(JP_DEBUG,
     X        'JAGGGP: Initialise FFT consts for the group.',JPQUIET)
            CALL INTLOG(JP_DEBUG,
     X        'JAGGGP: Latitude number = ', NFIRST)
            CALL INTLOG(JP_DEBUG,
     X        'JAGGGP: No. of calculated long.pts = ', ILON)
          ENDIF
C
          IF( .NOT. LUSEFFTW ) THEN
            CALL JJSET99( ATRIGS, IMFAX, ILON, KRET)
            IF( KRET .NE. 0 ) GOTO 990
          ENDIF
        ENDIF
C
C       If the current line is the last to be processed,
C       or the next line is not suitable for the current group,
C       or 32 lines are in the group already ...
C
        IF (     ( NXTROW .EQ. ISOUTH)
     X      .OR. ( KPTS(NFIRST) .NE. KPTS(NXTROW+1) )
     X      .OR. ( NGROUP .EQ. JP32 ) ) THEN
C
C         Calculate the points along the line of latitude
C
          IF( LDEBUG ) CALL INTLOG(JP_DEBUG,
     X      'JAGGGP: Number in group = ', NGROUP)
C
          CALL JSYMGG( PSHUP, KTRUNC, NFIRST, ILUNIT, NGROUP, ILON,
     X                 ALAT, ALEG, ATRIGS, IMFAX, LUSEFFTW, ZFA, KRET )
          IF( KRET .NE. 0 ) GOTO 990
C
C         If it is a wind component field formed from spectral Ucos(theta)
C         and Vcos(theta) (ie not just spectral U and V), apply a
C         latitude correction
C
          IF( (LUV.EQ.1).AND.(.NOT.LPLAINU) )
     X      CALL JWSCAL(ZFA, NGROUP, ILON, NFIRST, ALAT)
C
C         Store away the generated latitudes
C
          IF( HTYPE.EQ.'R' .OR. HTYPE.EQ.'r' .OR.
     X        HTYPE.EQ.'O' .OR. HTYPE.EQ.'o' .OR.
     X        HTYPE.EQ.'U' .OR. HTYPE.EQ.'u' ) THEN
            NUMPTS = KPTS(NFIRST)
          ELSE
            RINTVL = (PEAST - PWEST)*FLOAT( KPTS(NFIRST) ) / 360.0
            NUMPTS = NINT( RINTVL ) + 1
          ENDIF
C
C         Is the area unequally distributed about the equator?
C
          IF ( NCASE .EQ. 4 .OR. NCASE .EQ. 5 ) THEN
            CALL JMVUGG( ZFA, NNORTH, NSOUTH, PWEST, KNUM, NFIRST,
     X                   NDIFF, NGROUP, NUMPTS, ILON,
     X                   IJPWR(NFIRST), NOFSET, POUTF)
            NDIFF  = MAX( 0, (NDIFF - NGROUP) )
C
C         No, it is all in one hemisphere or is symmetrical
C         about the equator
C
          ELSE
            CALL JMOVGG( ZFA, PWEST, KNUM, NFIRST, NGROUP, NUMPTS,
     X                   ILON, IJPWR(NFIRST), NOFSET, POUTF, NFLAG)
          ENDIF
C
C         Startup next group of latitudes
C
          NGROUP = 0
        ENDIF
C
      ENDDO
C
C     _______________________________________________________
C
C*    Section 9. Return to calling routine. Format statements
C     _______________________________________________________
C
 990  CONTINUE
#ifdef SHAREDMEMORY
C     note: shareddt return value ignored
      KRET2 = SHAREDDT(IALEG)
      IF( LDEBUG )
     X  CALL INTLOG(JP_DEBUG,'JAGGGP: release_shared_file  = ', KRET2)
#endif

C
      IF( LDEBUG ) CALL INTLOG(JP_DEBUG,'JAGGGP: Return code = ',KRET)
C
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE GENGRIB( VALUES, LAT, LONG, NBITS, GRIB, GRIBSIZE)
C
C---->
C**** GENGRIB
C
C     Purpose.
C     --------
C
C     Creates a generic GRIB field product.
C
C
C**   Interface.
C     ----------
C
C     CALL GENGRIB( VALUES, LAT, LONG, NBITS, GRIB, GRIBSIZE)
C
C
C     Input
C     -----
C
C     VALUES   -  array of real numbers
C     LAT      -  first dimension of the array
C                 (e.g. number of points along a meridian )
C     LONG     -  second dimension of the array
C                 (e.g. number of points along a parallel )
C     NBITS    -  number of bits to use for each packed value
C                 If NBITS = 0, a value is calculated for the given
C                 field.
C     GRIBSIZE -  size in bytes of output array GRIB
C
C
C     Output
C     ------
C
C     GRIB     -  packed GRIB record
C
C
C     Method.
C     -------
C
C     Packs the matrix of real values as a 500 hPa geopotential first
C     guess field for 94/1/1 1200.
C
C
C     Externals.
C     ----------
C
C     GRIBEX
C     CNBITS
C
C
C     Reference.
C     ----------
C
C     Binary data representation - FM 92 GRIB, ECMWF, May 1992
C
C
C     Comments.
C     ---------
C
C     If number of bits for packing is not supplied by caller, calculate
C     the number of bits needed to code the range of field values.
C     Apply (arbitrary) lower limit unless the number of bits is 1 (for
C     bit fields for example) when the value is left as 1.
C
C
C     Author.
C     -------
C
C     J.D.Chambers           ECMWF      28.07.94
C
C
C     Modifications.
C     --------------
C
C     None.
C
C   
C----<
C     ----------------------------------------------------------------
C*    Section 0 . Definition of variables.
C     ----------------------------------------------------------------
C                                                                
      IMPLICIT NONE 
C
C     Parameters
      INTEGER JPLOW
      PARAMETER ( JPLOW = 16 )
C
C     Arguments
      INTEGER LAT,LONG
      REAL VALUES( LAT, LONG)
      INTEGER GRIB(*), GRIBSIZE
      INTEGER NBITS
C
C     Local variables
      INTEGER KSEC0(2), KSEC1(43), KSEC2(23), KSEC3(2), KSEC4(33)
      REAL PSEC2(10), PSEC3(2)
      INTEGER LOOP, KLENG, KLENP, KWORD, KRET
C
      INTEGER CNBITS
C                                             
C     ----------------------------------------------------------------
C*    Section 1 . Setup section 1.
C     ----------------------------------------------------------------
C                                                                    
  100 CONTINUE                                                    
C                                                               
      KSEC1( 1) = 128
      KSEC1( 2) = 98
      KSEC1( 3) = 255
      KSEC1( 4) = 255
      KSEC1( 5) = 128
      KSEC1( 6) = 129
      KSEC1( 7) = 100
      KSEC1( 8) = 500
      KSEC1( 9) = 0
      KSEC1(10) = 94
      KSEC1(11) = 1
      KSEC1(12) = 1
      KSEC1(13) = 12
      KSEC1(14) = 0
      KSEC1(15) = 1
      KSEC1(16) = 0
      KSEC1(17) = 0
      KSEC1(18) = 0
      KSEC1(19) = 0
      KSEC1(20) = 0
      KSEC1(21) = 20
      DO 110 LOOP = 22, 36
        KSEC1(LOOP) = 0
  110 CONTINUE
      KSEC1(24) = 1
      KSEC1(37) = 1
      KSEC1(38) = 1
      KSEC1(39) = 1
      KSEC1(40) = 1060
      KSEC1(41) = 1413829460
      KSEC1(42) = 0
      KSEC1(43) = 0
C                                             
C     ----------------------------------------------------------------
C*    Section 2 . Setup section 2.
C     ----------------------------------------------------------------
C                                                                    
  200 CONTINUE                                                    
C                                                               
      KSEC2( 1) = 0
      KSEC2( 2) = LONG
      KSEC2( 3) = LAT
      KSEC2( 4) = 90000
      KSEC2( 5) = 0
      KSEC2( 6) = 128
      KSEC2( 7) = -90000
      KSEC2( 8) = 360000 - (360000/LONG)
      KSEC2( 9) = (360000/LONG)
      KSEC2(10) = (180000/(LAT-1))
      KSEC2(11) = 0
      KSEC2(12) = 0
      KSEC2(13) = 0
      KSEC2(14) = 0
      KSEC2(15) = 0
      KSEC2(16) = 0
      KSEC2(17) = 0
      KSEC2(18) = 0
      KSEC2(19) = 0
      KSEC2(20) = 0
      KSEC2(21) = 0
      KSEC2(22) = 0
      KSEC2(23) = LONG
      DO 210 LOOP =1, 10
        PSEC2(LOOP) = 0.0
  210 CONTINUE
C                                             
C     ----------------------------------------------------------------
C*    Section 3 . Setup section 3.
C     ----------------------------------------------------------------
C                                                                    
  300 CONTINUE                                                    
C                                                               
      KSEC3( 1) = 0
      KSEC3( 2) = -1000000
      PSEC3( 1) = 0
      PSEC3( 2) = -1000000.0
C                                             
C     ----------------------------------------------------------------
C*    Section 4 . Setup section 4.
C     ----------------------------------------------------------------
C                                                                    
  400 CONTINUE                                                    
C                                                               
      KSEC4( 1) = LAT*LONG
C
      IF ( NBITS .LE. 0 ) THEN
C
C       If number of bits for packing not supplied by caller, calculate
C       the number of bits needed to code the range of field values.
        KSEC4( 2) = CNBITS( VALUES, LAT, LONG )
C
C       Apply (arbitrary) lower limit.
        IF ( (KSEC4( 2) .LT. JPLOW) .AND.
     X       (KSEC4( 2) .NE. 1) ) KSEC4( 2) = JPLOW
      ELSE
        KSEC4( 2) = NBITS
      ENDIF
      DO 410 LOOP = 3, 33
        KSEC4(LOOP) = 0
  410 CONTINUE
C                                             
C     ----------------------------------------------------------------
C*    Section 5 . Pack the field.
C     ----------------------------------------------------------------
C                                                                    
  500 CONTINUE                                                    
C                                                               
#ifdef CRAY
      KLENG = GRIBSIZE/8
#else
      KLENG = GRIBSIZE/4
#endif
      KLENP = LAT*LONG
C
Cjdc  CALL GRSVCK(0)
Cjdc  CALL GRSDBG(1)
C
      CALL GRIBEX( KSEC0, KSEC1, KSEC2, PSEC2, KSEC3, PSEC3, KSEC4,
     X             VALUES, KLENP, GRIB, KLENG, KWORD, 'C', KRET)
C                                           
C     ----------------------------------------------------------------
C*    Section 9 . End.
C     ----------------------------------------------------------------
C                                                                
  900 CONTINUE                                           
C                                                    
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE GET_NAME_UNIT(KREFERENCE,YNAME,YUNIT)
C
C**** *GET_NAME_UNIT*
C
C
C     PURPOSE.
C     --------
C          FIND NAME AND THE UNIT FOR THE PARTICULAR REFERENCE NUMBER.
C
C
C**   INTERFACE.
C     ----------
C
C          *CALL* *GET_NAME_UNIT(KREFERENCE,YNAME,YUNIT)*
C
C
C        INPUT : *KREFERENCE* - TABLE B REFERENCE NUMBER
C        OUTPUT:
C                *CNAMES*     -  ARRAY CONTAINING ELEMENT NAMES
C                *CUNITS*     -  ARRAY CONTAINING ELEMENT UNITS
C                *KERR*       -  RETURN CODE
C
C
C     METHOD.
C     -------
C
C          NONE.
C
C     EXTERNALS.
C     ----------
C
C          NONE.
C
C     REFERENCE.
C     ----------
C
C          NONE.
C
C     AUTHOR.
C     -------
C
C          M. DRAGOSAVAC    *ECMWF*       15/01/2006.
C
C
C     MODIFICATIONS.
C     --------------
C
C          NONE.
C
C
      IMPLICIT LOGICAL(L,O,G), CHARACTER*8(C,H,Y)

C
#     include "parameter.F"

      CHARACTER*64 YNAME
      CHARACTER*24 YUNIT
C
#     include "bcomtab.F"
#     include "bcomtabc.F"
C
      CHARACTER*64 CTABBEN
      CHARACTER*24 CTABBU
      DIMENSION KREF(11)
      CHARACTER*64  CN(11)

C
      DATA KREF/222000,235000,236000,237000,224000,225000,223000,
     1          232000,235000,999999,0/ 
      DATA CN/'QUALITY INFORMATION FOLLOW',
     1        'CANCEL BACKWARD DATA REFERENCE',
     2        'BACKWARD REFERENCE BIT MAP',
     3        'USE PREVIOUSLY DEFINED BIT MAP',
     4        'FIRST ORDER STATISTICS FOLLOW',
     5        'DIFFERENCE STATISTICAL VALUES FOLLOW',
     6        'SUBSTITUTED VALUES FOLLOW',
     7        'REPLACE/RETAINED VALUES FOLLOW',
     8        'CANCEL BACKWARD DATA REFERENCE',
     9        'ASSOCIATED FIELD',
     1        'REFERENCE VALUE'/ 
C
      KERR=0
      DO I=1,11
      IF(KREFERENCE.EQ.KREF(I)) THEN
         YNAME=CN(I)
         YUNIT=' '
         RETURN 
      END IF
      END DO
      IF(KREFERENCE/1000.EQ.205) THEN
        YNAME='CHARACTERS'
        YUNIT='CCITT IA5 '
        RETURN
      END IF
C
      ICLASS=KREFERENCE/1000
      IYYY  =KREFERENCE-ICLASS*1000+1
      ICLASS=ICLASS+1
C
      if(ICLASS.GT.64.or.IYYY.gt.256) then
         print*,'KREFERENCE=',KREFERENCE
         print*,'ICLASS=',ICLASS
         print*,'IYYY=',IYYY
         KERR=57
         RETURN
      end if
      I=NTABP(ICLASS,IYYY)
      YNAME=CTABBEN(I)
      YUNIT=CTABBU(I)
C
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities
C granted to it by virtue of its status as an intergovernmental organisation
C nor does it submit to any jurisdiction.
C


      SUBROUTINE PRTBIN (KIN,KNBIT,KOUT,KERR)
C
C---->
C**** PRTBIN - Binary to decimal conversion.
C
C     Purpose.
C     --------
C
C           Produces a decimal number with ones and zeroes
C           corresponding to the ones and zeroes of the input
C           binary number.
C           eg input number 1011 binary, output number 1011 decimal.
C
C**   Interface.
C     ----------
C
C           CALL PRTBIN (KIN,KNBIT,KOUT,KERR)
C
C           Integer    K.
C           Real       P.
C           Logical    O.
C           Character  H.
C
C               Input Parameters.
C               -----------------
C
C               KIN   - Integer variable containing binary number.
C
C               KNBIT - Number of bits in binary number.
C
C               Output Parameters.
C               -----------------
C
C               KOUT  - Integer variable containing decimal value
C                       with ones and zeroes corresponding to those of
C                       the input binary number.
C
C               KERR  - 0, If no error.
C                       1, Number of bits in binary number exceeds
C                          maximum allowed or is less than 1.
C
C     Method.
C     -------
C
C           Odd numbers have a binary representation ending in 1, even
C           numbers end in 0.
C
C     Externals.
C     ----------
C
C           None.
C
C     Reference.
C     ----------
C
C           None.
C
C     Comments.
C     ---------
C
C           Replaces earlier routine of the same name, which
C           contained non-ANSI code.
C           Routine contains sections 0, 1 and section 9.
C
C     Author.
C     -------
C
C           John Hennessy     ECMWF    01.10.91
C
C     Modifications.
C     --------------
C
C           None.
C
C     ---------------------------------------------------------------
C----<
C
C
C
C
C
C
C
C
C
C
C*    Section 0. Definition of variables. Check on parameters.
C     -----------------------------------------------------------------
C
C*    Prefix conventions for variable names.
C
C     Logical      L (but not LP), global or common.
C                  O, dummy arguments.
C                  G, local variable.
C                  LP, parameter.
C     Character    C, Global or common.
C                  H, dummy arguments.
C                  Y (but not YP), local variables.
C                  YP, parameter.
C     Integer      M and N, global or common.
C                  K, dummy arguments.
C                  I, local variables.
C                  J (but not JP), loop control.
C                  JP, parameter.
C     Real         A to F and Q to X, global or common.
C                  P (but not PP), dummy arguments.
C                  Z, local variables.
C                  PP, parameter.
C
      IMPLICIT NONE
C
#include "common/grprs.h"
C
      INTEGER IDEC
      INTEGER IK
      INTEGER ITEMP
C
      INTEGER J102
C
      INTEGER KERR
      INTEGER KIN
      INTEGER KNBIT
      INTEGER KOUT
C
C     Check length of binary number to ensure decimal number
C     generated will fit in the computer word - in this case will
C     it fit in a Cray 48 bit integer?
C
      IF (KNBIT.LT.1.OR.KNBIT.GT.14)
     C   THEN
             KERR = 1
             WRITE(GRPRSM,9000) KNBIT
             GO TO 900
         ELSE
             KERR = 0
         ENDIF
C
C     -----------------------------------------------------------------
C
C
C
C
C
C
C
C
C
C
C*    Section 1. Generate required number.
C     -----------------------------------------------------------------
C
  100 CONTINUE
C
      KOUT = 0
      IK   = KIN
      IDEC = 1
C
      DO 102 J102=1,KNBIT
         ITEMP = IK - ( (IK/2)*2 )
         KOUT  = KOUT + ITEMP * IDEC
         IK    = IK / 2
         IDEC  = IDEC * 10
  102 CONTINUE
C
C     -----------------------------------------------------------------
C
C
C
C
C
C
C
C
C
C
C*    Section 9. Format statements. Return to calling routine.
C     -----------------------------------------------------------------
C
  900 CONTINUE
C
 9000 FORMAT (1H ,'PRTBIN : Error in binary number length - ',I3,
     C            ' bits.')
C
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE GRSREF (PREF)
C
C---->
C**** GRSREF - Set user defined reference value for routine GRIBEX.
C
C     Purpose.
C     --------
C
C           Set user defined reference value for GRIB code for
C           routine GRIBEX.
C
C**   Interface.
C     ----------
C
C           CALL GRSREF (PREF)
C
C           Integer    K.
C           Real       P.
C           Logical    O.
C           Character  H.
C
C               Input Parameters.
C               -----------------
C
C               PREF        - Reference value required.
C
C               Output Parameters.
C               ------------------
C
C               None.
C
C     Method.
C     -------
C
C           The flag variable NFREF is set to indicate that the
C           user has supplied a reference value and the variable
C           FREF is set to the required reference value. These
C           variables are in the common area. All other parameters
C           are also set to default values, if they have not already
C           been set by the user.
C
C     Externals.
C     ----------
C
C           GRSDEF - Default setting of global variables.
C
C     Reference.
C     ----------
C
C           See subroutine GRIBEX.
C
C     Comments.
C     ---------
C
C           Routine contains Sections 0 to 1 and Section 9.
C
C     Author.
C     -------
C
C           J. Hennessy      ECMWF      25.06.91
C
C     Modifications.
C     --------------
C
C           J. Hennessy      ECMWF      28.08.91
C           Changes to some comments only.
C
C           J. Hennessy      ECMWF      14.11.91
C           Changes to common area.
C
C           J.D.Chambers     ECMWF      13.09.94
C           Add NONOFF and NOABORT, use grbcom.h
C
C           J. Clochard, Meteo France, for ECMWF - January 1998.
C           Use GRSDEF routine for default setting.
C
C           J. Clochard, Meteo France, for ECMWF - June 1999.
C           Use a static variable to determine if initialisation of
C           default values has already been done for common area
C           variables.
C
C----<
C     ----------------------------------------------------------------
C*    Section 0 . Definition of variables.
C     ----------------------------------------------------------------
C
      IMPLICIT NONE
C
#include "grbcom.h"
C
      REAL    PREF
C
      LOGICAL LFIRST
      SAVE LFIRST
C
      DATA LFIRST / .TRUE. /
C
C     ----------------------------------------------------------------
C*    Section 1 . Set values.
C     ----------------------------------------------------------------
C
  100 CONTINUE
C
C     If common area variables have not been set, start by
C     setting default values.
C
      IF (LFIRST) THEN
C
C       Common area variables may have not been set, so start by
C       trying to set default values.
C
        CALL GRSDEF
        LFIRST=.FALSE.
C
      ENDIF
C
C
C     Set reference value to required value.
C
      FREF   = PREF
C
C     Reference value supplied by user flag. Set to on.
C
      NFREF  = 1
C
C     ----------------------------------------------------------------
C*    Section 9 . Return to calling routine.
C     ----------------------------------------------------------------
C
  900 CONTINUE
C
      RETURN
C
      END

C
C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      INTEGER FUNCTION WAVEXX2(NPARAM, NUMLATS, NPTS,
     X                         NLATS, STEPNS, STEPWE,
     X                         OLDWAVE,
     X                         NEWWAVE, NORTH, WEST, PMISS)
C
C---->
C*****WAVEXX2*
C
C     PURPOSE
C     -------
C
C     Interpolates wave fields (except 2D spectra).
C
C
C     INTERFACE
C     ---------
C
C     IRET = WAVEXX2(NPARAM, NUMLATS, NLATS, STEPNS, STEPWE,
C    X               OLDWAVE, NEWIDX, DISTNEW,
C    X               NEWWAVE, NORTH, WEST, PMISS)
C
C     Input arguments
C     ---------------
C
C     NUMLATS - Input lat number north-south
C     NPTS   - Array giving number of points along each latitude
C               (empty latitudes have entry 0)
C     NLATS   - Number of points N-S in new grid
C     STEPNS  - Output grid north-south resolution (degrees)
C     STEPWE  - Output grid west-east resolution (degrees)
C     OLDWAVE - Original wave field
C     NORTH   - Output grid northernmost latitude (degrees)
C     WEST    - Output grid westernmost longitude (degrees)
C     PMISS   - Missing data value 
C
C     Output arguments
C     ----------------
C
C     NEWWAVE - New wave field
C
C     Function returns 0 if the interpolation was OK.
C
C
C     METHOD
C     ------
C
C     Builds the index of neighbouring points for the output grid.
C     Then works through the output grid points, checking for subarea
C     boundaries and looking up neighbouring point values and weights.
C     (Neighbours may have missing data).
C
C
C     EXTERNALS
C     ---------
C
C     WAVEIDX - Determines which nearest-neighbour values to use for
C               interpolating to new output grid point
C     NUMPTWE - Calculates number of grid points between west/east
C               area boundaries
C     INTLOG  - Log error message
C     JMALLOC - Dynamically allocate memory (deallocation -JFREE- not used)
C
C
C     REFERENCE
C     ---------
C
C     None.
C
C
C     Author.
C     -------
C
C     S. Curic      ECMWF    Jun 2009
C
C
C
C----<
C
      IMPLICIT NONE
C
C     Parameters
C
#include "parim.h"
#include "nifld.common"
#include "nofld.common"
#include "grspace.h"
      INTEGER JPROUTINE, JPMXLAT
      PARAMETER (JPROUTINE = 40100)
      PARAMETER (JPMXLAT = 1801)
      INTEGER JPNW, JPNE, JPSW, JPSE, JPN, JPS
      INTEGER JPDISNW, JPDISNE, JPDISSW, JPDISSE
      PARAMETER (JPNW = 1)
      PARAMETER (JPNE = 2)
      PARAMETER (JPSW = 3)
      PARAMETER (JPSE = 4)
      PARAMETER (JPN  = 5)
      PARAMETER (JPS  = 6)
      PARAMETER (JPDISNW = 7)
      PARAMETER (JPDISNE = 8)
      PARAMETER (JPDISSW = 9)
      PARAMETER (JPDISSE = 10)
C
C     Subroutine arguments
C
      INTEGER NPTS,NLATS
      DIMENSION NPTS(*)
      REAL STEPNS, STEPWE, OLDWAVE, NEWWAVE, NORTH, WEST, PMISS
      DIMENSION OLDWAVE(*), NEWWAVE(*)
      INTEGER NUMLATS
C
C     Local arguments
C
      REAL RLATINC, RLATINC2
      REAL ONORTH,OSOUTH,OWEST, OEAST
      INTEGER IEOFSET, IWOFSET, ISTART, IWEST
      REAL SOUTH, PTLAT, AWEST, EAST, PTLONG
      REAL REFVAL, SCALE
      INTEGER NSPT1, INSPT, NEXP, NMANT, NRETA, NRETB, NLENG, NBIT
      INTEGER NPARAM, ISCALE, NSCALE, IBITS, ITEMP
      INTEGER IRET, IEDITN
      INTEGER NEXT, NEXTWV, NROW, NCOL, INDEX
      INTEGER MISSLAT, LOOP, NUMNEW, KOLDNUM, KNEWNUM
      DIMENSION NUMNEW(JPMXLAT)
      REAL OLDLATS, NEWLATS, ROWINC
      DIMENSION OLDLATS(JPMXLAT), NEWLATS(JPMXLAT)
      LOGICAL LDIREC
      REAL*4 DISNW, DISNE, DISSW, DISSE
      REAL*4 NW_PT, NE_PT, SW_PT, SE_PT
      REAL*4 RAD
      DATA RAD/0.017453293/
      REAL*4 DI1N, DI1S, DI2N, DI2S, DK1, DK2
      REAL*4 CNW_PT, CNE_PT, CSW_PT, CSE_PT
      REAL*4 SNW_PT, SNE_PT, SSW_PT, SSE_PT
      REAL*4 U1, U2, C1, C2, S1, S2, CC, SS
      INTEGER INW, INE, ISW, ISE, JNW, JNE, JSW, JSE
C
C     Large, resolution-dependent arrays
C
      LOGICAL IS_ALLOCATED_LARGEARRAY
      DATA    IS_ALLOCATED_LARGEARRAY /.FALSE./
      SAVE    IS_ALLOCATED_LARGEARRAY
C
      INTEGER NEWIDX
      DIMENSION NEWIDX(4,JPARRAYDIM_WAVE)
#ifndef _CRAYFTN
#ifdef POINTER_64
      INTEGER*8 P_NEWIDX
#endif
#endif
      POINTER(P_NEWIDX,NEWIDX)
      SAVE P_NEWIDX
C
      REAL*4 DISTNEW
      DIMENSION DISTNEW(10,JPARRAYDIM_WAVE)
#ifndef _CRAYFTN
#ifdef POINTER_64
      INTEGER*8 P_DISTNEW
#endif
#endif
      POINTER(P_DISTNEW,DISTNEW)
      SAVE P_DISTNEW
C
C     Externals
C
      INTEGER  WAVEIDX, NUMPTWE
#ifdef POINTER_64
      INTEGER*8 JMALLOC
#else
      INTEGER JMALLOC
#endif
      EXTERNAL WAVEIDX, NUMPTWE, JMALLOC
C
C ---------------------------------------------------------------------
C*    Section 1. Initalisation.
C ---------------------------------------------------------------------
C
  100 CONTINUE
C
      WAVEXX2 = 0
C
C     Initialise the bitmap value lookup function
C
      MISSLAT = 0

      ONORTH = FLOAT(NIAREA(1))/PPMULT
      OSOUTH = FLOAT(NIAREA(3))/PPMULT
      RLATINC = FLOAT(NIGRID(2))/PPMULT
C
C     Calculate number of latitudes if grid had been full from
C     North pole to South pole
C
      IF( NUMLATS.GT.JPMXLAT ) THEN
        CALL INTLOG(JP_ERROR,
     X    'WAVEXX2: Number of latitudes in input grid = ',NUMLATS)
        CALL INTLOG(JP_ERROR,
     X    'WAVEXX2: And is greater than allowed maximum = ',JPMXLAT)
        WAVEXX2 = JPROUTINE + 1
        GOTO 900
      ENDIF
C
C
C     Fill an array with the number of points at each latitude for the
C     input field.
C
      IF(NIREPR.EQ.JPREDLL) THEN
C
C       Input field is a reduced latitude/longitude grid
C
C       .. but it may be 'pseudo-gaussian' in layout
C       (ie global, symmetric about the equator but no latitude
C        at the equator)
C
        IF( (ONORTH.NE.90.0).AND.(MOD(NUMLATS,2).EQ.0) ) THEN
C
          ONORTH = FLOAT(NIAREA(1))
          OSOUTH = FLOAT(NIAREA(3))
          RLATINC = FLOAT(NIGRID(2))

          DO LOOP = 1, NUMLATS
cs            OLDLATS(LOOP) = ONORTH - (LOOP-1)*RLATINC
            OLDLATS(LOOP) = (ONORTH - (LOOP-1)*RLATINC)/PPMULT
          ENDDO

          DO LOOP = 1, NUMLATS
            OLDLATS(LOOP) = 90.0 - (LOOP-1)*RLATINC
          ENDDO
C
        ELSE
C
          DO LOOP = 1, NUMLATS
            OLDLATS(LOOP) = 90.0 - (LOOP-1)*RLATINC
          ENDDO
cs-----------------------------------------------------
cs          MISSLAT = (9000000 - NIAREA(1) )/NIGRID(2)
cs          DO LOOP = 1, MISSLAT
cs            NPTS(LOOP)    = 0
cs          ENDDO
cs          KOLDNUM = 1 + (9000000 - NIAREA(3))/NIGRID(2)
cs          DO LOOP = 1, (KOLDNUM-MISSLAT)
cs            print*,LOOP+MISSLAT, NPTS(LOOP+MISSLAT)
cs            NPTS(LOOP+MISSLAT) = ISEC2(22+LOOP)
cs          ENDDO
cs          DO LOOP = (KOLDNUM+1), NUMLATS
cs            print*,'to set 0 ', loop, NPTS(LOOP)
cs            NPTS(LOOP)    = 0
cs          ENDDO
cs-----------------------------------------------------

C
        ENDIF
C
      ELSE
C
C       Input field is a regular latitude/longitude grid
C
C
        DO LOOP = 1, NUMLATS
          OLDLATS(LOOP) = 90.0 - (LOOP-1)*RLATINC
        ENDDO
C
        MISSLAT = (90.0 - ONORTH)/RLATINC
        DO LOOP = 1, MISSLAT
          NPTS(LOOP)    = 0
        ENDDO
        KOLDNUM = 1 + NINT((90.0 - OSOUTH)/RLATINC)
        DO LOOP = 1, (KOLDNUM-MISSLAT)
          NPTS(LOOP+MISSLAT) = NIWE
        ENDDO
        DO LOOP = (KOLDNUM+1), NUMLATS
          NPTS(LOOP)    = 0
        ENDDO
      ENDIF
C
C     Allocate large, resolution-dependent arrays
      IF (.NOT. IS_ALLOCATED_LARGEARRAY) THEN
        P_NEWIDX  = JMALLOC( 4*JPARRAYDIM_WAVE*JPBYTES)  !  4*len*bytes
        P_DISTNEW = JMALLOC(10*JPARRAYDIM_WAVE*4)        ! 10*len*bytes
        IS_ALLOCATED_LARGEARRAY = .TRUE.
      END IF
C
C ---------------------------------------------------------------------
C*    Section 2. Setup number of points at each latitude for the
C                output latitude/longitude field.
C ---------------------------------------------------------------------
C
  200 CONTINUE
C
      IF( (NOREPR.EQ.JPQUASI) .OR. (NOREPR.EQ.JPGAUSSIAN) ) THEN
C
C       Reduced (quasi-regular) gaussian output
C
        KNEWNUM = NOGAUSS*2
        DO LOOP = 1, KNEWNUM
          NUMNEW(LOOP)  = NOLPTS(LOOP)
          NEWLATS(LOOP) = ROGAUSS(LOOP)
        ENDDO
C
      ELSE IF( NOREPR.EQ.JPREDLL ) THEN
C
C       Reduced (quasi-regular) lat/long output
C
        KNEWNUM = NOREDLL
        DO LOOP = 1, KNEWNUM
          NUMNEW(LOOP)  = NOLPTS(LOOP)
          NEWLATS(LOOP) = ROREDLL(LOOP)
        ENDDO
C
      ELSE
C
C       Regular output
C
        MISSLAT = NINT((90.0 - NORTH)/STEPNS)
        DO LOOP = 1, MISSLAT
          NUMNEW(LOOP)    = 0
        ENDDO
        DO LOOP = 1, NLATS
          NUMNEW(LOOP+MISSLAT) = NINT(360.0/STEPWE)
        ENDDO
C
        KNEWNUM = MISSLAT + NLATS
        DO LOOP = 1, KNEWNUM
          NEWLATS(LOOP) = 90.0 - (LOOP-1)*STEPNS
        ENDDO
C
      ENDIF
C
C ---------------------------------------------------------------------
C*    Section 3. Get the input GRIB field characteristics.
C ---------------------------------------------------------------------
C
  300 CONTINUE
C
C     Calculate the indices of the input grid points to be used for
C     the output points
C

      OWEST = FLOAT(NIAREA(2))/PPMULT
      OEAST = FLOAT(NIAREA(4))/PPMULT

      WAVEXX2 = WAVEIDX(NUMLATS,NPTS,OLDLATS,OWEST,OEAST,
     X                  KNEWNUM, NUMNEW, NEWLATS,
     X                  NEWIDX, DISTNEW)
      IF( WAVEXX2.NE.0 ) THEN
        CALL INTLOG(JP_ERROR,
     X    'WAVEXX2: Unable to calculate output grid indices',JPQUIET)
        WAVEXX2 = JPROUTINE + 2
        GOTO 900
      ENDIF
C
C     Wave direction parameters need special handling
C     (MWD1, MWD2, MWD3, MWD, MDWW, MDPS, MDWI, DWI)
C
      LDIREC = ( (NPARAM.EQ.122) .OR.
     X           (NPARAM.EQ.125) .OR.
     X           (NPARAM.EQ.128) .OR.
     X           (NPARAM.EQ.230) .OR.
     X           (NPARAM.EQ.235) .OR.
     X           (NPARAM.EQ.238) .OR.
     X           (NPARAM.EQ.242) .OR.
     X           (NPARAM.EQ.249) )
C
C ---------------------------------------------------------------------
C*    Section 4. Work through the output subarea.
C ---------------------------------------------------------------------
C
  400 CONTINUE
C
C     Fill in the wave spectra values
C
      NEXT = 0
      NEXTWV = 0
C
      SOUTH = NOAREA(3)/PPMULT
      EAST  = NOAREA(4)/PPMULT
      ISTART = 0
C
C     Work down through latitudes from north to south.
C
      DO NROW = 1, KNEWNUM
C
C       If inside north-south (subarea) boundaries ..
C
        IF( (NOREPR.EQ.JPGAUSSIAN).OR.(NOREPR.EQ.JPQUASI) ) THEN
          PTLAT = ROGAUSS(NROW)
        ELSE
          PTLAT = 90.0 - (NROW-1)*STEPNS
        ENDIF
        IF( (PTLAT.LE.NORTH).AND.(ABS(PTLAT-SOUTH).GT.-0.0005) ) THEN
C
C         Calculate number of points between west boundary of area and
C         Greenwich
C
          ROWINC = 360.0/NUMNEW(NROW)
C
          IWEST = INT(WEST/ROWINC)
          IF( (WEST.GT.0.0).AND.(WEST.NE.(IWEST*ROWINC)) )
     X      IWEST = IWEST + 1
          AWEST = IWEST * ROWINC
          IWOFSET = NUMPTWE(AWEST,0.0,ROWINC)
          IEOFSET = NUMPTWE(AWEST,EAST,ROWINC)
C
C         Work through subarea longitudes from west to east.
C
          DO NCOL = 1, NUMNEW(NROW)
            PTLONG = AWEST + (NCOL-1)*ROWINC
            NEXT = NUMPTWE(AWEST,PTLONG,ROWINC)
            IF( (NEXT.LE.IEOFSET).AND.(NEXT.GE.0) ) THEN
C
C             .. and inside west-east (subarea) boundaries
C
              NEXT = 1 + NEXT - IWOFSET
              IF( NEXT.LE.0) NEXT = NEXT + NUMNEW(NROW)
              NEXT = NEXT + ISTART
              NEXTWV = NEXTWV + 1
C
              INW = NEWIDX(JPNW,NEXT)
              INE = NEWIDX(JPNE,NEXT)
              ISW = NEWIDX(JPSW,NEXT)
              ISE = NEWIDX(JPSE,NEXT)
C
C             Test if any of the four neighbouring points is missing.
C
                IF( (OLDWAVE(INW).EQ.PMISS) .OR.
     X              (OLDWAVE(ISW).EQ.PMISS) .OR.
     X              (OLDWAVE(INE).EQ.PMISS) .OR.
     X              (OLDWAVE(ISE).EQ.PMISS) ) THEN
                ENDIF

              IF( (INW.EQ.0) .OR. (OLDWAVE(INW).EQ.PMISS) .OR.
     X            (ISW.EQ.0) .OR. (OLDWAVE(ISW).EQ.PMISS) .OR.
     X            (INE.EQ.0) .OR. (OLDWAVE(INE).EQ.PMISS) .OR.
     X            (ISE.EQ.0) .OR. (OLDWAVE(ISE).EQ.PMISS) ) THEN
                IF( (OLDWAVE(INW).EQ.PMISS) .AND.
     X              (OLDWAVE(ISW).EQ.PMISS) .AND.
     X              (OLDWAVE(INE).EQ.PMISS) .AND.
     X              (OLDWAVE(ISE).EQ.PMISS) ) THEN
                ENDIF
C
C               If so, take nearest grid point value.
C
                DISNW = DISTNEW(JPDISNW,NEXT)
                DISNE = DISTNEW(JPDISNE,NEXT)
                DISSW = DISTNEW(JPDISSW,NEXT)
                DISSE = DISTNEW(JPDISSE,NEXT)
C
                IF( (DISNW.LE.DISNE).AND.
     X              (DISNW.LE.DISSW).AND.
     X              (DISNW.LE.DISSE)) THEN
                  INDEX = INW
C
                ELSE IF( (DISNE.LE.DISSW).AND.
     X                   (DISNE.LE.DISSE) ) THEN
                  INDEX = INE
C
                ELSE IF( (DISSW.LE.DISSE) ) THEN
                  INDEX = ISW
C
                ELSE
                  INDEX = ISE
                ENDIF
C
                IF(INDEX.EQ.0.OR.(OLDWAVE(INDEX).EQ.PMISS)) THEN
C
C                 Nearest point is missing
C
                  NEWWAVE(NEXTWV) = PMISS
C
                ELSE

                  NEWWAVE(NEXTWV) =  OLDWAVE(INDEX)
                ENDIF
C
              ELSE
C
C               Use bi-linear interpolation from four
C               neighbouring sea points.
C
C
                DI1N = DISTNEW(JPNW,NEXT)
                DI2N = DISTNEW(JPNE,NEXT)
                DI1S = DISTNEW(JPSW,NEXT)
                DI2S = DISTNEW(JPSE,NEXT)
                DK1  = DISTNEW(JPN,NEXT)
                DK2  = DISTNEW(JPS,NEXT)
C
                 NW_PT =  OLDWAVE(INW)
                 NE_PT =  OLDWAVE(INE)
                 SW_PT =  OLDWAVE(ISW)
                 SE_PT =  OLDWAVE(ISE)
                IF( .NOT. LDIREC ) THEN
                  U1 = NW_PT*DI2N + NE_PT*DI1N
                  U2 = SW_PT*DI2S + SE_PT*DI1S
                  NEWWAVE(NEXTWV) = U1*DK2 + U2*DK1
                ELSE
C
C                 Fields representing a 'direction': resolve into
C                 components and interpolate each separately.
C
                  CNW_PT = COS(NW_PT*RAD)
                  CNE_PT = COS(NE_PT*RAD)
                  CSW_PT = COS(SW_PT*RAD)
                  CSE_PT = COS(SE_PT*RAD)
                  SNW_PT = SIN(NW_PT*RAD)
                  SNE_PT = SIN(NE_PT*RAD)
                  SSW_PT = SIN(SW_PT*RAD)
                  SSE_PT = SIN(SE_PT*RAD)
                  C1 = CNW_PT*DI2N + CNE_PT*DI1N
                  C2 = CSW_PT*DI2S + CSE_PT*DI1S
                  CC = C1*DK2 + C2*DK1
                  S1 = SNW_PT*DI2N + SNE_PT*DI1N
                  S2 = SSW_PT*DI2S + SSE_PT*DI1S
                  SS = S1*DK2 + S2*DK1
                  IF( SS.LT.0.0 ) THEN
                    NEWWAVE(NEXTWV) = ATAN2(SS,CC)/RAD + 360.0
                  ELSE
                    NEWWAVE(NEXTWV) = ATAN2(SS,CC)/RAD
                  ENDIF
                ENDIF
              ENDIF
            ENDIF
          ENDDO
C
        ENDIF
        ISTART = ISTART + NUMNEW(NROW)
      ENDDO
C
C ---------------------------------------------------------------------
C*    Section 9. Closedown.
C ---------------------------------------------------------------------
C
  900 CONTINUE
      RETURN
      END

!
! Copyright 1981-2016 ECMWF.
!
! This software is licensed under the terms of the Apache Licence Version 2.0
! which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
!
! In applying this licence, ECMWF does not waive the privileges and immunities
! granted to it by virtue of its status as an intergovernmental organisation
! nor does it submit to any jurisdiction.
!
! ******************************
! Modified by: Cristian Simarro, ported from GRIBEX to GRIB_API
! DATE: 17-02-2016
! ******************************
!

PROGRAM singlePointInterpolation
!
  USE grib_api

  IMPLICIT NONE
  INTEGER                                     :: IPROD
  INTEGER, DIMENSION(4)                       :: INTV
  REAL, DIMENSION(4)                          :: REALV
  CHARACTER(Len=20), DIMENSION(4)             :: CHARV
  LOGICAL                                     :: ASCII
  LOGICAL                                     :: WRITE_INTERIM_GG
  CHARACTER(Len=20)                           :: TMPGNAME
  CHARACTER(Len=20)                           :: GNAME

  INTEGER, PARAMETER                          :: JPGRIB=10000000
  INTEGER, PARAMETER                          :: JPBYTES=4
  INTEGER, PARAMETER                          :: MISSING_VALUE=-9999999
!
!     JPBYTES is the size in bytes on an 'INTEGER'
!     Set JPBYTES = 8 on a 64-bit machine.
!
  CHARACTER (LEN=1),DIMENSION(:), ALLOCATABLE :: WORK, OUTGRIB
  CHARACTER                                   :: HTYPE
  CHARACTER                                   :: GAUSSIAN
  REAL , DIMENSION(1000)                      :: LATS, LONS
  REAL                                        :: LLVALUES(1)
!
  INTEGER                                     :: isOctahedral
  CHARACTER(Len=20)                           :: gridType
  INTEGER                                     :: bitsPerValue
  INTEGER                                     :: KPTS(10024),PLATS(10024)
  INTEGER                                     :: IUNIT1, IUNIT2,IUNIT3,IUNITASCII
  INTEGER                                     :: IGRIB, IGRIB2
  INTEGER                                     :: IRET, NARGS
  INTEGER (KIND=KINDOFINT)                    :: INLEN, NEWLEN, NSIZE
  INTEGER                                     :: J
  INTEGER                                     :: NLATLON, LOOP, LOOPO
  INTEGER                                     :: EOF
  INTEGER                                     :: IFILEN
  INTEGER                                     :: NGAUSS, NPTS, NLON, NLAT
  REAL                                        :: AREA(4), GRID(2), POLE(2)
  REAL,DIMENSION(:), ALLOCATABLE              :: GLATS,GLONS,GVALUES

!
!     Externals
  INTEGER                                     :: INTOUT, INTF2, IARGC, HIRLSM
  INTEGER                                     :: HSP2GG
  EXTERNAL                                    :: HIRLSM, HSP2GG

  CHARACTER(Len=128)                          :: LLFILE, INFILE, OUTFILE
  CHARACTER(Len=128)                          :: MESSAGE = ' '
!
! **********************************************************************
!
!  Definitions and parameters
!
  DATA GRID/1.0,1.0/
  DATA POLE/-90.0,0.0/
!
!  GAUSSIAN: Set the intermediate type of the reduced grid in case of converting from SH
!  [O,N]
!
  GAUSSIAN = 'O'
!
!  Write the intermediate gaussian file?
!
  WRITE_INTERIM_GG = .FALSE.
  TMPGNAME = GAUSSIAN//'TMP'//'.grib'
!
!  Unit to use to write the ascii file if needed
!
  IUNITASCII = 16
  ASCII = .FALSE.
!
!  Accuracy in the intermediate gaussian if source is SH
!
  bitsPerValue = 16

! **********************************************************************
!
!  Pick up file names from command line.
!
  NARGS = IARGC()
  IF ( NARGS < 3 .OR. NARGS > 4) THEN
     print*,'Usage: singlePointInterpolation llfile, inputfile outputfile [a]'
     STOP
  END IF

  CALL GETARG(1,LLFILE)
  CALL GETARG(2,INFILE)
  CALL GETARG(3,OUTFILE)
  IF (NARGS == 4) THEN
    ASCII = .TRUE.
  ENDIF
!
!  Open input and output GRIB files.
!
  CALL GRIB_OPEN_FILE (IUNIT1, TRIM(INFILE), 'r', IRET)
  IF ( IRET /= GRIB_SUCCESS) STOP ' GRIB_OPEN failed'

  CALL GRIB_OPEN_FILE (IUNIT2, TRIM(OUTFILE), 'w', IRET)
  IF ( IRET /= GRIB_SUCCESS ) STOP ' GRIB_OPEN failed'
  IPROD = 0
  IF ( ASCII ) THEN
    OPEN(UNIT=IUNITASCII,FILE=TRIM(OUTFILE)//'.txt',IOSTAT=IRET)
    IF (IRET == 0) THEN
      WRITE(*,*)'File:',TRIM(OUTFILE),' opened'
    ELSE
      WRITE(*,*)'File:',TRIM(OUTFILE),' not opened'
      WRITE(*,*)'Input/output status = ',IRET
      WRITE(*,*)'Program will stop'
      STOP
    END IF
  END IF
  IF (WRITE_INTERIM_GG) THEN
    CALL GRIB_OPEN_FILE (IUNIT3, TMPGNAME, 'w', IRET)
    IF ( IRET /= GRIB_SUCCESS ) STOP ' GRIB_OPEN failed'
  ENDIF
!
! Open file containing lat-lon coordinates
!
  IFILEN = INDEX(LLFILE,' ') - 1
  OPEN(UNIT=1,FILE=LLFILE,IOSTAT=IRET)
  IF (IRET /= 0) STOP 'ERROR on open of lat-lon file'
!
! Read the latitude-longitude points
!
  EOF = 0
  LOOP = 1
  NLATLON = 0
  DO WHILE (EOF == 0) 
    READ(1,*,IOSTAT=IRET) LATS(LOOP), LONS(LOOP)
    IF (IRET > 0) THEN
      STOP 'Error reading lat-lon file'
    ELSEIF (IRET < 0) THEN
      EOF=0
      EXIT
    ENDIF
    IF (LATS(LOOP) > 90.0 .OR. LATS(LOOP) < -90.0) THEN
      WRITE(*,*) 'Latitude ', LOOP, ' is faulty: (',LATS(LOOP),')'
      STOP ' Fail'
    ENDIF
    IF (LONS(LOOP) < -360.0 .OR. LONS(LOOP) > 360.0) THEN
      WRITE(*,*) 'Longitude ', LOOP, ' is faulty: (',LONS(LOOP),')'
      STOP ' Fail'
    ENDIF
    NLATLON = NLATLON + 1
    LOOP = LOOP + 1
  END DO
  CLOSE(UNIT=1)
  IF (NLATLON < 1) STOP 'No latitude/longitude pairs given'
!
  WRITE(*,*) 'Number of latitude/longitude pairs = ', NLATLON
!
! Start of loop through input GRIB-coded fields creating a HANDLER
!
  CALL GRIB_NEW_FROM_FILE(IUNIT1,IGRIB,IRET)
  WRITE (*,*) 'Iterating over the messages...'
  
  DO WHILE (IRET /= GRIB_END_OF_FILE)
    IF (IRET /= GRIB_SUCCESS) THEN
      PRINT *, ' GRIB_READ_FROM_FILE failed with error code = ', IRET
      CALL GRIB_GET_ERROR_STRING(IRET,MESSAGE)
      PRINT *, TRIM(MESSAGE)
      PRINT *, 'Skipping to next message ...'
      CYCLE
    ENDIF
!    IPROD = IPROD + 1
!    WRITE(*,*) 'Message number' , IPROD

!
!  Get the gridType
!
    CALL GRIB_GET(IGRIB,'gridType',gridType,IRET)
    IF ( IRET /= GRIB_SUCCESS ) STOP ' GRIB_GET failed for gridType'
!
!  Check if the input is SH, if it is, interpolate to GG
!
    IF ( gridType == 'sh' ) THEN
!
!  Transform to a reduced Gaussian grid
!  First copy message from HANDLER ( IGRIB ) into MEMORY ( WORK ).
!
!  WRITE (*,*) 'Found spherical harmonics input, interpolating to ',GAUSSIAN, &
!  ' GG'
      CALL GRIB_GET_MESSAGE_SIZE(IGRIB,INLEN,IRET)
      IF ( IRET /= GRIB_SUCCESS ) STOP ' GRIB_MESSAGE_SIZE failed'
      ALLOCATE(WORK(INLEN))
      CALL GRIB_COPY_MESSAGE(IGRIB,WORK,IRET)
      IF ( IRET /= GRIB_SUCCESS ) STOP ' GRIB_COPY_MESSAGE failed'
!      
!  Get the proper values for the new reduced grib
!
      CALL GRIB_GET(IGRIB,'pentagonalResolutionParameterJ',J,IRET)
      IF ( IRET /= GRIB_SUCCESS ) STOP ' GRIB_GET pentagonalResolutionParameterJ failed'
      CALL GRIB_GET_SIZE(IGRIB,'values',NPTS)
      IRET = HSP2GG(J,NGAUSS,KPTS,PLATS,NSIZE)
      IF( IRET.NE.0 ) THEN
          WRITE(*,*) 'Failed to find suitable gaussian grid for the'
          WRITE(*,*) 'spectral input GRIB'
          STOP 'FAIL'
      ENDIF
!      WRITE (*,*) J,NGAUSS,NSIZE,NPTS,INLEN
!
!  Create GNAME string with [N,O]NGAUSS to send to INTOUT gridname
!
      WRITE (GNAME,*) NGAUSS
      GNAME=GAUSSIAN//adjustl(GNAME)
!
!  Set the INTOUT parameters to be reduced, octahedral?
!
      IRET = INTOUT('gridname',INTV,REALV,GNAME)
      IF( IRET.NE.0 ) THEN
          WRITE(*,*) 'Failed to setup gaussian grid interpolation'
          STOP 'FAIL'
      ENDIF
      IRET = INTOUT('accuracy',bitsPerValue,REALV,CHARV)
      IF( IRET.NE.0 ) THEN
          WRITE(*,*) 'Failed to setup gaussian grid interpolation'
          STOP 'FAIL'
      ENDIF
!
!  From sh message in WORK we will interpolate to reduced OUTGRIB
!  We need to figure out NEWLEN to avoid memory waste
!
      NEWLEN = JPGRIB
      ALLOCATE(OUTGRIB(NEWLEN))
      IRET = INTF2(WORK,INLEN,OUTGRIB,NEWLEN)
      IF ( IRET /= 0 ) THEN
        WRITE(*,*) ' INTF failed, use environment JDCNDBG=1'
        STOP
      ENDIF
!
!  Create new GRIB handle from the new message OUTGRIB
!
      CALL GRIB_NEW_FROM_MESSAGE(IGRIB,OUTGRIB,IRET)
      IF ( IRET /= GRIB_SUCCESS ) STOP ' GRIB_NEW_FROM_MESSAGE failed'
      IF (WRITE_INTERIM_GG) THEN
        CALL GRIB_WRITE(IGRIB,IUNIT3,IRET)
        IF ( IRET /= GRIB_SUCCESS ) STOP ' GRIB_WRITE failed'
      ENDIF
      DEALLOCATE(OUTGRIB,WORK)
!
!  Finish section SH -> GG
!
    ENDIF
    
!
!  Interpolate the gaussian field to lat/long
!  At this point IGRIB is either the handler to the source or the generated interim GG
!  First let's find out the type of grid to use in the HIRLSM
!
    CALL GRIB_GET(IGRIB,'gridType',gridType,IRET)
    IF ( IRET /= GRIB_SUCCESS ) STOP ' GRIB_GET failed for gridType'
    CALL GRIB_GET(IGRIB,'isOctahedral',isOctahedral)
    IF ( gridType == 'regular_gg' ) THEN
        HTYPE = 'F'
    ELSEIF ( isOctahedral == 1 ) THEN
        HTYPE = 'O'
    ELSE
        HTYPE = 'R'
    ENDIF
!   WRITE (*,*) HTYPE
!
!  NGAUSS: Get the grib key N (old GRIBEX ISEC2(10))
!  NPTS:   Get the size of values (old GRIBEX ISEC4(1))
!  GLATS,GLONS,GVALUES: Get the data (old GRIBEX ZSEC(4))
!
    CALL GRIB_GET(IGRIB,'N',NGAUSS,IRET)
    IF ( IRET /= GRIB_SUCCESS ) STOP ' GRIB_GET failed'
    CALL GRIB_GET_SIZE(IGRIB,'values',NPTS)
    IF ( IRET /= GRIB_SUCCESS ) STOP ' GRIB_GET_SIZE failed'
    ALLOCATE(GLATS(NPTS))
    ALLOCATE(GLONS(NPTS))
    ALLOCATE(GVALUES(NPTS))
    CALL GRIB_GET_DATA(IGRIB,GLATS,GLONS,GVALUES)
    IF ( IRET /= GRIB_SUCCESS ) STOP ' GRIB_GET_DATA failed'
    
!
!  Interpolate to a single-point regular_ll as many times as lat/lon in the input file
!
    DO LOOPO = 1, NLATLON
        AREA(1) = LATS(LOOPO)
        AREA(2) = LONS(LOOPO)
        AREA(3) = LATS(LOOPO)
        AREA(4) = LONS(LOOPO)
        
        IRET = HIRLSM(.TRUE.,GVALUES,NPTS,NGAUSS,HTYPE,AREA,POLE,GRID,LLVALUES,1, &
          NLON,NLAT)
        IF( IRET.NE.0 ) THEN
          WRITE (*,*) IRET
          STOP 'Interpolation from gaussian grid to lat/lon grid failed be sure that you are using emoslib double precission r64'
        ENDIF
        IF (ASCII) THEN
          WRITE(IUNITASCII,"(1x,i5,2x,2(F8.2,1X),f8.2)") LOOPO, LATS(LOOPO), LONS(LOOPO), LLVALUES(1)
        ENDIF
    
!    
!  Set the keys and write the new values to OUT file.
!       ISEC2( 1) = 0
!       ISEC2( 2) = 1
!       ISEC2( 3) = 1
!       ISEC2( 4) = NINT(LATS(LOOPO)*1000)
!       ISEC2( 5) = NINT(LONS(LOOPO)*1000)
!       ISEC2( 6) = 128
!       ISEC2( 7) = NINT(LATS(LOOPO)*1000)
!       ISEC2( 8) = NINT(LONS(LOOPO)*1000)
!       ISEC2( 9) = 1000
!       ISEC2(10) = 1000
!       ISEC2(11) = 0
!       ISEC2(12) = 0
!       ISEC2(13) = 0
!       ISEC2(14) = 0
!       ISEC2(15) = 0
!       ISEC2(16) = 0
!       ISEC2(17) = 0
!       ISEC2(18) = 0
!       ISEC2(19) = 0
!
        CALL GRIB_CLONE(IGRIB,IGRIB2)
        IF ( IRET /= GRIB_SUCCESS)  STOP ' GRIB_CLONE failed'
        CALL GRIB_SET(IGRIB2,'gridType','regular_ll')
        CALL GRIB_SET(IGRIB2,'Ni',1)
        CALL GRIB_SET(IGRIB2,'Nj',1)
        CALL GRIB_SET(IGRIB2,'latitudeOfFirstGridPointInDegrees',LATS(LOOPO))
        CALL GRIB_SET(IGRIB2,'longitudeOfFirstGridPointInDegrees',LONS(LOOPO))
        CALL GRIB_SET(IGRIB2,'latitudeOfLastGridPointInDegrees',LATS(LOOPO))
        CALL GRIB_SET(IGRIB2,'longitudeOfLastGridPointInDegrees',LONS(LOOPO))
        CALL GRIB_SET(IGRIB2,'iDirectionIncrementInDegrees',GRID(1))
        CALL GRIB_SET(IGRIB2,'jDirectionIncrementInDegrees',GRID(2))
        CALL GRIB_SET(IGRIB2,'missingValue',MISSING_VALUE)
        CALL GRIB_SET(IGRIB2,'bitsPerValue',bitsPerValue)
        CALL GRIB_SET(IGRIB2,'values',LLVALUES)
!
!  Finally write the data into the OUTFILE
!
        CALL GRIB_WRITE(IGRIB2,IUNIT2,IRET)
        IF ( IRET /= GRIB_SUCCESS)  STOP ' GRIB_WRITE failed'
    END DO
!
!  Free the memory.
! 
    CALL GRIB_RELEASE(IGRIB)
    CALL GRIB_RELEASE(IGRIB2)
    DEALLOCATE(GLATS,GLONS,GVALUES)
!
!  Loop back for next product.
!
    CALL GRIB_NEW_FROM_FILE(IUNIT1,IGRIB,IRET)    
  END DO
!
!  Close input and output files.
! 
  CALL GRIB_CLOSE_FILE(IUNIT1, IRET)
  CALL GRIB_CLOSE_FILE(IUNIT2, IRET)
  IF (WRITE_INTERIM_GG) THEN
    CALL GRIB_CLOSE_FILE(IUNIT3,IRET)
  ENDIF
  CLOSE(UNIT=IUNITASCII)
!
  WRITE (*,*) 'Finished, check the output file ' , OUTFILE
  STOP
END PROGRAM singlePointInterpolation

C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE JSGGGP( PSHUP, KTRUNC, PNORTH, PSOUTH, PWEST, PEAST,
     X                    KNUM, HTYPE, KPTS, POUTF, LUV, KRET)
C
C---->
C**** JSGGGP
C
C     PURPOSE
C     _______
C
C     This routine converts strecthed spectral fields to a gaussian
C     grid field.
C
C     INTERFACE
C     _________
C
C     CALL JSGGGP( PSHUP, KTRUNC, PNORTH, PSOUTH, PWEST, PEAST,
C    X                    KNUM, HTYPE, KPTS, POUTF, LUV, KRET)
C
C     Input parameters
C     ________________
C
C     PSHUP    - Spherical harmonics field, unpacked
C     KTRUNC   - Truncation number of spherical harmonics field
C     PNORTH   - Northernmost latitude for output field (degrees)
C     PSOUTH   - Southernmost latitude for output field (degrees)
C     PWEST    - Westernmost longitude for output field (degrees)
C     PEAST    - Easternmost longitude for output field (degrees)
C     KNUM     - Gaussian grid number
C     HTYPE    - Gaussian grid type
C                = 'R' for reduced, 
C                = 'F' for full
C                = 'U' for user-defined reduced gaussian grid
C     KPTS     - Array specifying number of points at each line of
C                latitude if HTYPE = 'U'.
C                (Must be big enough for both hemispheres, but only
C                 needs to give Northern hemisphere values from pole
C                 to latitude nearest the Equator.)
C     LUV      - Code indicating whether or not the field is a wind
C                component field;
C                = 1 if U or V field.
C
C     Output parameters
C     ________________
C
C     KPTS     - Array specifying number of points at each line of
C                latitude; user defined values if HTYPE = 'U'.
C                (Must be big enough for both hemispheres)
C     POUTF    - Output grid point field
C     KRET     - Return status code
C                0 = OK
C
C     Common block usage
C     __________________
C
C     JDCNDBG
C
C     Method
C     ______
C
C     Converts stretched 'latitude' to real latitude and then
C     interpolates along the real latitude line.
C
C
C     Externals
C     _________
C
C     JGETGG   - Pick up the definition of the gaussian grid.
C     JJSET99  - Sets up FFT
C     JNORSGG  - Determines which latitude row in a gaussian grid is
C                north or south of a given latitude
C     JSYMGG   - Generate symmetric grid from spherical harmonics 
C     JWSCAL   - Apply latitude correction to wind component field
C     JMVUGG   - Moves grid point data to output array
C     JMKOFGG  - Builds offsets into storage array
C     JDEBUG   - Checks environment variable to switch on/off debug
C     INTLOG   - Logs output messages
C     INTLOGR  - Logs output messages
C
C
C     Reference
C     _________
C
C     None
C
C
C     Comments
C     ________
C
C     None
C
C
C     AUTHOR
C     ______
C
C     J.D.Chambers      ECMWF      July 1999
C
C     MODIFICATIONS
C     _____________
C
C
C     None
C
C----<
C     _______________________________________________________
C
C
      IMPLICIT NONE
#include "jparams.h"
#include "parim.h"
#include "current.h"
#include "nifld.common"
#include "nofld.common"
#include "grfixed.h"
C
C     Subroutine arguments
C
      COMPLEX   PSHUP
      DIMENSION PSHUP(*)
      INTEGER   KTRUNC, KNUM, KPTS, KRET
      DIMENSION KPTS(*)
      CHARACTER*1 HTYPE
      REAL      PNORTH, PSOUTH, PWEST, PEAST
      REAL      POUTF
      DIMENSION POUTF(*)
      INTEGER   LUV
C
C     Parameters
C
      INTEGER JPROUTINE
      PARAMETER ( JPROUTINE = 31600 )
      REAL DEG2RAD
      PARAMETER ( DEG2RAD = PPI/180.0 )
C
C     Local variables
C
      INTEGER ILON, ILONOLD, ITOUP1, IJPWR, NUMPTS
      DIMENSION IJPWR(JPMAX)
      INTEGER ILUNIT
      INTEGER NXTROW
      REAL RINTVL, ZCOSI, ZLAT
      REAL ZFACTOR(JPMAX)
C
      INTEGER IMFAX
      REAL ATRIGS
      DIMENSION IMFAX(10),ATRIGS(JPLONO*2)
#ifndef _CRAYFTN
#ifdef POINTER_64
      INTEGER*8 IALEG, IZFA
#endif
#endif
      REAL ALEG
      DIMENSION ALEG(1)
      POINTER ( IALEG, ALEG )
      REAL ZFA
      DIMENSION ZFA(2)
      POINTER ( IZFA, ZFA )
      INTEGER ISIZE
      DATA ISIZE/0/
      SAVE ISIZE, IZFA
C
      INTEGER J108, NNORTH, NSOUTH, NFLAG
      INTEGER NOFSET, LOOP
      DIMENSION NOFSET(JPMAX)
      INTEGER INORTH, ISOUTH, IMAGE
      REAL ALAT
      DIMENSION ALAT(JPMAX)
C
      SAVE ILUNIT
C
      LOGICAL LDEBUG, LFIRST
      DATA LFIRST/.TRUE./
      SAVE LDEBUG, LFIRST
C
      INTEGER  JNORSGG
      EXTERNAL JNORSGG
C     _______________________________________________________
C
C*    Section 1.    Initialization.
C     _______________________________________________________
C
  100 CONTINUE
C
      CALL JDEBUG( )
      LDEBUG = NDBG.GT.0
C
C
C     First time through, dynamically allocate memory for workspace
C
      IF( LFIRST ) THEN
        LFIRST = .FALSE.
        ISIZE =  (JPLONO+2)*64
        CALL JMEMHAN( 10, IZFA, ISIZE, 1, KRET)
        IF( KRET.NE.0 ) THEN
          CALL INTLOG(JP_ERROR,'JSGGGP: memory allocation error.',IZFA)
          KRET = JPROUTINE + 1
          GOTO 990
        ENDIF
      ENDIF
C
      IF( LDEBUG ) THEN
        CALL INTLOG(JP_DEBUG,'JSGGGP: Input parameters:',JPQUIET)
        CALL INTLOG(JP_DEBUG,
     X    'JSGGGP: Spherical harmonic truncation = ', KTRUNC)
        CALL INTLOGR(JP_DEBUG,
     X    'JSGGGP: Northern latitude for output = ', PNORTH)
        CALL INTLOGR(JP_DEBUG,
     X    'JSGGGP: Southern latitude for output = ', PSOUTH)
        CALL INTLOGR(JP_DEBUG,
     X    'JSGGGP: Western longitude for output = ', PWEST)
        CALL INTLOGR(JP_DEBUG,
     X    'JSGGGP: Eastern longitude for output = ', PEAST)
        CALL INTLOG(JP_DEBUG,
     X    'JSGGGP: Gaussian grid number = ', KNUM)
C
        IF( HTYPE.EQ.'R' .OR. HTYPE.EQ.'r' ) CALL INTLOG(JP_DEBUG,
     X    'JSGGGP: Grid type is Reduced.',JPQUIET)
        IF( HTYPE.EQ.'F' .OR. HTYPE.EQ.'f' ) CALL INTLOG(JP_DEBUG,
     X    'JSGGGP: Grid type is Full.',JPQUIET)
        IF( HTYPE.EQ.'U' .OR. HTYPE.EQ.'u' ) CALL INTLOG(JP_DEBUG,
     X    'JSGGGP: Grid type is User.',JPQUIET)
        CALL INTLOG(JP_DEBUG,
     X    'JSGGGP: Field code( = 1 for U or V) = ', LUV)
C
        IF( (HTYPE.EQ.'u').OR.(HTYPE.EQ.'U') ) THEN
          CALL INTLOG(JP_DEBUG,'JSGGGP: User-supplied values.',JPQUIET)
          CALL INTLOG(JP_DEBUG,'JSGGGP: No. pts at each line:',JPQUIET)
          DO NDBGLP = 1, 20
            CALL INTLOG(JP_DEBUG,' ',KPTS( NDBGLP ))
          ENDDO
        ENDIF
      ENDIF
C
C     Pick up the file containing the definition of the gaussian grid.
C
      IF( (NOGAUSO.NE.KNUM).OR.(HOGAUST.NE.HTYPE) ) THEN
        CALL JGETGG( KNUM, HTYPE, ALAT, KPTS, KRET)
        IF( KRET.NE.0 ) GOTO 990
        NOGAUSO = KNUM
        HOGAUST = HTYPE
      ELSE
        DO LOOP = 1, KNUM*2
          ALAT(LOOP) = ROGAUSS(LOOP)
          KPTS(LOOP) = NOLPTS(LOOP)
        ENDDO
      ENDIF
C
C     Calculate the true latitudes and the map factor.
C
      DO LOOP = 1, KNUM*2
        CALL STRLAT(ALAT(LOOP), RISTRET, 0, ALAT(LOOP), ZFACTOR(LOOP))
      ENDDO
C
C     Coefficients are to generated 'on the fly'
C
      LON_FLY = .TRUE.
      LFILEIO = .FALSE.
      LMEMORY = .FALSE.
      LSHARED = .FALSE.
      LMAPPED = .FALSE.
      ISIZE =  (KTRUNC+1)*(KTRUNC+2)
      CALL JMEMHAN( 14, IALEG, ISIZE, 1, KRET)
      IF( KRET.NE.0 ) THEN
        CALL INTLOG(JP_ERROR,'JSGGGP: memory allocate error.',IALEG)
        KRET = JPROUTINE + 2
        GOTO 990
      ENDIF
C
      IF( KRET.NE.0 ) THEN
        CALL INTLOG(JP_ERROR,
     X    'JSGGGP: Failed to open legendre function file',JPQUIET)
        KRET = JPROUTINE + 3
        GOTO 990
      ENDIF
C
      NNORTH = JNORSGG( PNORTH, ALAT, KNUM, 1)
      NSOUTH = JNORSGG( PSOUTH, ALAT, KNUM, 0)
      IF( LDEBUG ) THEN
        CALL INTLOG(JP_DEBUG,
     X    'JSGGGP: Gaussian latitudes in requested area:',JPQUIET)
        CALL INTLOG(JP_DEBUG,'JSGGGP: NORTH = ',NNORTH)
        CALL INTLOG(JP_DEBUG,'JSGGGP: SOUTH = ',NSOUTH)
      ENDIF
C
C
C     For calculation purposes, the number of longitude points for each
C     latitude row has to be greater than 2*(output truncation) to 
C     ensure the fourier transform is exact (see Reference, page 10). 
C
C     The following loop calculates the power of 2 to be used as a 
C     multipier for each row to ensure there are enough points.
C     Later, when filling the output array POUTF, the longitude points
C     have to be taken selectively to avoid the intermediate generated
C     points, picking up values only at the required longitudes.
C
      ITOUP1 = KTRUNC
      DO 108 J108 = 1, KNUM
	IMAGE = 2*KNUM - J108 + 1
	ILON        = KPTS(J108)
        IJPWR(J108) = 1
 104    CONTINUE
          IF(ILON .GT. 2*ITOUP1) GOTO 106
          IJPWR(J108) = IJPWR(J108)*2
          ILON        = ILON*2
          GOTO 104
 106    CONTINUE
	IJPWR(IMAGE) = IJPWR(J108)
 108  CONTINUE
C
C     _______________________________________________________
C
C*    Section 2.    Work out geometry of the request
C     _______________________________________________________
C
 200  CONTINUE
C
C     Latitude rows are generated from row INORTH to ISOUTH.
C     Selection is carried out for actual requested rows when the 
C     calculated values are moved to the output array.
C
      INORTH = NNORTH
      ISOUTH = NSOUTH
C
C     Setup the storage offset for the given latitude range
C
 220  CONTINUE
C
      IF( LDEBUG ) THEN
        CALL INTLOG(JP_DEBUG,'JSGGGP: INORTH = ', INORTH)
        CALL INTLOG(JP_DEBUG,'JSGGGP: ISOUTH = ', ISOUTH)
      ENDIF
      CALL JMKOFGG(HTYPE,NNORTH,NSOUTH,PWEST,PEAST,KNUM,KPTS,NOFSET)
C
C     _______________________________________________________
C
C*    Section 3.    Process one row at a time.
C     _______________________________________________________
C
 300  CONTINUE
C
      IF( LDEBUG )
     X  CALL INTLOG(JP_DEBUG,'JSGGGP: Process latitude rows.',JPQUIET)
C
      ILONOLD = 0
C
      DO NXTROW = INORTH, ISOUTH
C
C       Initialise FFT constants for the latitude
C
        ILON = KPTS(NXTROW) * IJPWR(NXTROW)
C
        IF( LDEBUG ) THEN
          CALL INTLOG(JP_DEBUG,
     X      'JSGGGP: Initialise FFT consts for the group.',JPQUIET)
          CALL INTLOG(JP_DEBUG,
     X      'JSGGGP: Latitude number = ', NXTROW)
          CALL INTLOG(JP_DEBUG,
     X      'JSGGGP: No. of calculated long.pts = ', ILON)
        ENDIF
C
        IF( ILON.NE.ILONOLD ) THEN
          ILONOLD = ILON
          CALL JJSET99( ATRIGS, IMFAX, ILON, KRET)
          IF( KRET.NE.0 ) GOTO 990
        ENDIF
C
C       Calculate the points along the line of latitude
C
        CALL JSYMGG( PSHUP, KTRUNC, NXTROW, ILUNIT, 1, ILON,
     X               ALAT, ALEG, ATRIGS, IMFAX, ZFA, KRET)
	IF( KRET.NE.0 ) GOTO 990
C
C       If it is a wind component field, apply latitude correction
C
	IF( LUV.EQ.1 ) THEN
          ZLAT   = ALAT(NXTROW)
          ZCOSI  = ZFACTOR(NXTROW) / ABS( COS(ZLAT*DEG2RAD) )
          CALL SSCAL( ILON, ZCOSI, ZFA(2), 1)
        ENDIF
C
C       Store away the generated latitudes
C
        IF( (HTYPE.EQ.'U').OR.(HTYPE.EQ.'R') ) THEN
          NUMPTS = KPTS(NXTROW)
        ELSE
          RINTVL = (PEAST - PWEST)*FLOAT( KPTS(NXTROW) ) / 360.0
          NUMPTS = NINT( RINTVL ) + 1
        ENDIF
C
C       Move latitude line to output array
C
        NFLAG = 1
	CALL JMOVGG( ZFA, PWEST, KNUM, NXTROW, 1, NUMPTS,
     X    ILON, IJPWR(NXTROW), NOFSET, POUTF, NFLAG)
C
      ENDDO
C
C     _______________________________________________________
C
C*    Section 9. Return to calling routine. Format statements
C     _______________________________________________________
C
      KRET = 0
C
 990  CONTINUE
C
      IF( LDEBUG ) CALL INTLOG(JP_DEBUG,'JSGGGP: Return code = ',KRET)
C
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      INTEGER FUNCTION GSCALE( PDATA, KTRUNC, KSTART, IPOWER, HOPT)
C
C---->
C**** GSCALE
C
C     Purpose.
C     --------
C
C     Pre- or post-scales spherical harmonic coefficents in GRIB scaling
C     and packing.
C
C
C**   Interface.
C     ----------
C
C     IRET = GSCALE(PDATA, KTRUNC, KSTART, IPOWER, HOPT)
C
C
C     Input Parameters.
C     -----------------
C
C     PDATA      - Array of floating point values.
C     KTRUNC     - Truncation of the spherical harmonic coefficients.
C     KSTART     - Number indicating truncation after which to start.
C     IPOWER     - Power to use when scaling coefficients(*1000).
C     HOPT       - Selects pre- or post scaling
C                  = 'I' for pre-scaling
C                  = 'O' for post-scaling
C
C
C     Output Parameters.
C     -----------------
C
C     PDATA      - Array with values changed.
C
C
C     Method.
C     -------
C
C                            <--    n    -->             (n = 0 to m)
C
C                            <KSTART>|
C
C     Given numbers:         cccccccc|cccccc    ^
C                              cccccc|cccccc    |
C                                cccc|cccccc    |
C                                  cc|cccccc    m        (m = 0 to KTRUNC)
C                                    |cccccc    |
C                                       cccc    |
C                                         cc    v
C
C
C      Operates on values :          |cccccc
C                                    |cccccc
C                                    |cccccc
C                                    |cccccc
C                                    |cccccc
C                                       cccc
C                                         cc
C
C
C
C     A scale factor is applied to the values.  The factor is
C     
C     n(n+1)^^p            for pre-scaling
C     1 / n(n+1)^^p        for post-scaling
C
C     where p = IPOWER/1000.
C
C
C     Externals.
C     ----------
C
C     None
C
C
C     Reference.
C     ----------
C
C     None.
C
C
C     Comments.
C     --------
C
C     None.
C
C
C     Author.
C     -------
C
C     J.D.Chambers     ECMWF      20:04:94
C
C
C     Modifications.
C     _____________
C
C     J.D.Chambers     ECMWF        Feb 1997
C     Allow for 64-bit pointers
C
C     J. Clochard, Meteo France, for ECMWF - January 1998.
C     Call to FLOAT replaced by REAL.
C
C     J.D.Chambers     ECMWF        July 2000
C     Run loops calculating power factors in SCALAR on VPPs to
C     eliminate differences due to vetorisation.
C
C     S.Curic     ECMWF        April 2005
C     Change value of JPMXTRC in order to handle truncation T2047
C
C----<
C     -----------------------------------------------------------------|
C*    Section 0. Definition of variables.
C     -----------------------------------------------------------------|
C
C
      IMPLICIT NONE
C
#include "common/grprs.h"
C
C     Parameters
C
      INTEGER JPBYTES, JPMXTRC
#ifdef REAL_8
      PARAMETER (JPBYTES = 8)
#else
      PARAMETER (JPBYTES = 4)
#endif
      PARAMETER (JPMXTRC = 2048)
C
C     Subroutine arguments
C
      INTEGER KTRUNC, KSTART, IPOWER
      REAL PDATA
      DIMENSION PDATA(*)
      CHARACTER*1 HOPT
C
C     Local variables.
C
      INTEGER N, M, INDEX
      REAL FACTOR, POWER
      DIMENSION FACTOR(JPMXTRC)
C
C     Externals
C
C     -----------------------------------------------------------------|
C*    Section 1 . Check for valid truncation and start values.
C     -----------------------------------------------------------------|
C
  100 CONTINUE
C
      GSCALE = 0
      IF( (IPOWER.LT.-10000).OR.(IPOWER.GT.10000) ) THEN
        WRITE(GRPRSM,*) ' GSCALE - Invalid power given = ', IPOWER
        GSCALE = 16600
        GOTO 900
      ENDIF
C
      IF( (KTRUNC.LT.0).OR.(KTRUNC.GT.JPMXTRC) ) THEN
        WRITE(GRPRSM,*) ' GSCALE - cannot handle truncation = ', KTRUNC
        GSCALE = 16601
        GOTO 900
      ENDIF
C
      IF( (HOPT.NE.'I').AND.(HOPT.NE.'O') ) THEN
        WRITE(GRPRSM,*) ' GSCALE - Invalid option given = ', HOPT
        GSCALE = 16602
        GOTO 900
      ENDIF
C
      IF( KSTART.GT.KTRUNC ) THEN
        WRITE(GRPRSM,*) ' GSCALE - Invalid start/truncation given'
        WRITE(GRPRSM,*) ' GSCALE - KSTART, KTRUNC =', KSTART, KTRUNC
        GSCALE = 16603
        GOTO 900
      ENDIF
C
C     Setup scaling factors = n(n+1)^^p, for n = 1 to KTRUNC
C
      IF( IPOWER.EQ.0 ) GOTO 900
      POWER = REAL(IPOWER) / 1000.0
      FACTOR(1) = 1.0
C
C     'I' option -> multiply by the factors
C     'O' option -> divide by the factors
C
      IF( HOPT.EQ.'I' ) THEN
#ifdef FUJITSU
!OCL SCALAR
#endif
        DO N = 1 , KTRUNC
          IF( IPOWER.NE.1000 ) THEN
            FACTOR(N+1) = REAL(N * (N+1) )**POWER
          ELSE
            FACTOR(N+1) = REAL(N * (N + 1))
          ENDIF
        ENDDO
      ELSE
#ifdef FUJITSU
!OCL SCALAR
#endif
        DO N = 1 , KTRUNC
          IF( IPOWER.NE.1000 ) THEN
            FACTOR(N+1) = 1.0 / REAL(N * (N+1) )**POWER
          ELSE
            FACTOR(N+1) = 1.0 / REAL(N * (N + 1))
          ENDIF
        ENDDO
      ENDIF
C
C     -----------------------------------------------------------------|
C*    Section 2 . Scale the values.
C     -----------------------------------------------------------------|
C
  200 CONTINUE
C
C     Handle values 2 at a time (real and imaginary parts)
C
      INDEX = -1
      DO M = 0 , KSTART-1
        DO N = M , KTRUNC
          INDEX = INDEX + 2
          IF( N.GE.KSTART ) THEN
            PDATA(INDEX)   = PDATA(INDEX)   * FACTOR(N+1)
            PDATA(INDEX+1) = PDATA(INDEX+1) * FACTOR(N+1)
          ENDIF   
        ENDDO
      ENDDO
C
      DO M = KSTART , KTRUNC
        DO N = M , KTRUNC
          INDEX = INDEX + 2
          PDATA(INDEX)   = PDATA(INDEX)   * FACTOR(N+1)
          PDATA(INDEX+1) = PDATA(INDEX+1) * FACTOR(N+1)
        ENDDO
      ENDDO
C
C     -----------------------------------------------------------------|
C*    Section 9. Return to calling routine.
C     -----------------------------------------------------------------|
C
  900 CONTINUE
C
      RETURN
      END

C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE SSCAL (KN, SA, XVEC, KNCX)                             
C                                                                       
C---->
C**** *SSCAL* - ROUTINE WHICH IMPLEMENTS THE BLAS ROUTINE OF THE        
C               SAME NAME                                               
C                                                                       
C     PURPOSE.                                                          
C     --------                                                          
C                                                                       
C     SIMPLE REPLACEMENT FOR IBM                                        
C                                                                       
C**   INTERFACE.                                                        
C     ----------                                                        
C                                                                       
C     * CALL SSCAL (KN, SA, XVEC, KNCX) *                               
C                                                                       
C                                                                       
C     METHOD.                                                           
C     -------                                                           
C                                                                       
C     XVEC (1 + IP * KNCX) = XVEC (1 + IP * KNCX) * SA                  
C     FOR IP = 0 TO KN - 1                                              
C                                                                       
C     EXTERNALS.                                                        
C     ----------                                                        
C                                                                       
C     NONE                                                              
C                                                                       
C     REFERENCE.                                                        
C     ----------                                                        
C                                                                       
C     NONE                                                              
C                                                                       
C     AUTHOR.                                                           
C     -------                                                           
C                                                                       
C     K. FIELDING         * ECMWF *     FEB 1992.                       
C                                                                       
C     MODIFICATIONS.                                                    
C     --------------                                                    
C                                                                       
C     NONE                                                              
C                                                                       
C     COMMON BLOCKS USED                                                
C     -------------------                                               
C                                                                       
C     NONE                                                              
C----<
C                                                                       
      INTEGER KN, KNCX                                                  
Cjdc  DOUBLE PRECISION SA                                               
Cjdc  DOUBLE PRECISION XVEC (*)                                         
      REAL SA                                               
      REAL XVEC (*)                                         
C                                                                       
      INTEGER IP                                                        
C                                                                       
C     1.    MAIN LOOP OF CODE                                           
C           ----------------------------------------------              
C                                                                       
  100 CONTINUE                                                          
      DO 110 IP = 0, KN - 1                                             
         XVEC (1 + IP * KNCX) = XVEC (1 + IP * KNCX) * SA               
  110 CONTINUE                                                          
C                                                                       
C     END OF ROUTINE                                                    
C                                                                       
      RETURN                                                            
      END                                                               

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      INTEGER FUNCTION DLASEC2(KGRIB,KLENG,INSPT,KSEC0,KSEC2,IBITS)
C
C---->
C**** DLASEC2P
C
C     PURPOSE
C     _______
C
C     Decodes GRIB section 2 values for lambert conformal fields.
C
C     INTERFACE
C     _________
C
C     IRET = DLASEC2(KGRIB,KLENG,INSPT,KSEC0,KSEC2,IBITS)
C
C     Input parameters
C     ________________
C
C     KGRIB   - GRIB product unpacked so far (upto octet 6). 
C     KLENG   - Length of KGRIB.
C     INSPT   - Bit position of GRIB product unpacked so far.
C     KSEC0   - GRIB section 0 description.
C     KSEC2   - GRIB section 2 description.
C     IBITS   - Number of bits per element in KGRIB.
C     
C
C     Output parameters
C     ________________
C
C     KSEC2   - Updated GRIB section 2 description.
C     INSPT   - Updated bit position of GRIB product built so far.
C     IRET    - Function return status code, 0 = OK
C
C     Common block usage
C     __________________
C
C     None.
C
C     Method
C     ______
C
C     Unpacks values given in KGRIB into KSEC2 and updates bit
C     pointer INSPT.
C
C     Externals
C     _________
C
C     DSGNBT  - Get the sign bit and adjust value to +/-.
C     INXBIT  - Insert bit data.
C
C
C     AUTHOR
C     ______
C
C     J.D.Chambers       ECMWF     February 1999
C
C     MODIFICATIONS
C     _____________
C
C     None.
C
C----<
C     _______________________________________________________
C
C     Section 0. Definition of variables.
C     _______________________________________________________
C
      IMPLICIT NONE
C
#include "common/grprs.h"
C
C     Function arguments
C
      INTEGER KGRIB,KLENG,INSPT,KSEC0,KSEC2,IBITS
      DIMENSION KGRIB(*),KSEC0(*),KSEC2(*)
C
C     Local variables
C
      INTEGER ILALO(2), IRET, IRESOL
C
C     _______________________________________________________
C
C     Section 1.    Initialization.
C     _______________________________________________________
C
  100 CONTINUE
C
      DLASEC2 = 0
C
C     _______________________________________________________
C
C     Section 2.    Unpack section 2 octets.
C     _______________________________________________________
C
  200 CONTINUE
C
C     Octets 7 - 8  : Ni - number of points along X-axis.
C     Octets 9 - 10 : Nj - number of points along Y-axis.
C     Two 16 bit fields.
C
      CALL INXBIT(KGRIB,KLENG,INSPT,KSEC2(2),2,IBITS, 16,'D',IRET)
      IF( IRET.NE.0 ) THEN
        DLASEC2 = 1
        WRITE(GRPRSM,*) 'GRIBEX: Error extracting'
        WRITE(GRPRSM,*) 'GRIBEX: number of points along X or Y axis.'
        WRITE(GRPRSM,*) 'GRIBEX: Return code = ', IRET
        GOTO 900
      ENDIF
C
C     Octets 11 - 13 : La1 - latitude of first grid point.
C     Octets 14 - 16 : Lo1 - longitude of first grid point.
C     Two 24 bit fields.
C
      CALL INXBIT(KGRIB,KLENG,INSPT,ILALO(1),2,IBITS, 24,'D',IRET)
      IF( IRET.NE.0 ) THEN
        DLASEC2 = 1
        WRITE(GRPRSM,*) 'GRIBEX: Error extracting'
        WRITE(GRPRSM,*)
     X    'GRIBEX: latitude or longitude of first grid pt.'
        WRITE(GRPRSM,*) 'GRIBEX: Return code = ', IRET
        GOTO 900
      ENDIF
C
C     If sign bit is 1, value is negative.
C 
      CALL DSGNBT( KSEC2(4), ILALO(1), 24, IRET)
      CALL DSGNBT( KSEC2(5), ILALO(2), 24, IRET)
C
C     Octet 17 : Resolution and components flag.
C     One 8 bit field.
C
      CALL INXBIT(KGRIB,KLENG,INSPT,IRESOL,1,IBITS, 8,'D',IRET)
      IF( IRET.NE.0 ) THEN
        DLASEC2 = 1
        WRITE(GRPRSM,*) 'GRIBEX: Error extracting'
        WRITE(GRPRSM,*) 'GRIBEX: components flag.'
        WRITE(GRPRSM,*) 'GRIBEX: Return code = ', IRET
        GOTO 900
      ENDIF
C
C     If all flag fields are already set to 0, bypass.
C 
      IF( IRESOL.EQ.0 ) GOTO 515
C 
C     Resolution flag is not applicable.
C 
      IF( IRESOL.GE.128) THEN
        KSEC2(6) = 128
        IRESOL   = IRESOL - 128
      ENDIF
C 
C     Set earth flag.
C 
      IF( IRESOL.GE.64) THEN
        KSEC2(18) = 64
        IRESOL    = IRESOL - 64
      ENDIF
C 
C     Set components flag.
C
      KSEC2(19) = IRESOL
C 
  515 CONTINUE
C
C     Octets 18 - 20 : LoV - orientation of the grid.
C     One 24 bit field.
C
      CALL INXBIT(KGRIB,KLENG,INSPT,ILALO(1),1,IBITS, 24,'D',IRET)
      IF( IRET.NE.0 ) THEN
        DLASEC2 = 1
        WRITE(GRPRSM,*) 'GRIBEX: Error extracting'
        WRITE(GRPRSM,*)
     X    'GRIBEX: latitude or longitude of last grid point.'
        WRITE(GRPRSM,*) 'GRIBEX: Return code = ', IRET
        GOTO 900
      ENDIF
C
C     If sign bit is 1, value is negative.
C 
      CALL DSGNBT( KSEC2(7), ILALO(1), 24, IRET)
C
C     Octets 21 - 23 : Dx - X direction grid length.
C     Octets 24 - 26 : Dy - Y direction grid length.
C     Two 24 bit fields.
C
      CALL INXBIT(KGRIB,KLENG,INSPT,KSEC2(9),2,IBITS, 24,'D',IRET)
      IF( IRET.NE.0 ) THEN
        DLASEC2 = 1
        WRITE(GRPRSM,*) 'GRIBEX: Error extracting'
        WRITE(GRPRSM,*) 'GRIBEX: X or Y axis grid length.'
        WRITE(GRPRSM,*) 'GRIBEX: Return code = ', IRET
        GOTO 900
      ENDIF
C
C     Octet 27 : Projection centre flag.
C     One 8-bit field.
C
      CALL INXBIT(KGRIB,KLENG,INSPT,KSEC2(13),1,IBITS, 8,'D',IRET)
      IF( IRET.NE.0 ) THEN
        DLASEC2 = 1
        WRITE(GRPRSM,*) 'GRIBEX: Error extracting'
        WRITE(GRPRSM,*) 'GRIBEX: Projection centre flag.'
        WRITE(GRPRSM,*) 'GRIBEX: Return code = ', IRET
        GOTO 900
      ENDIF
C
C     Octet 28 : Scanning mode flags.
C     One 8 bit field.
C
      CALL INXBIT(KGRIB,KLENG,INSPT,KSEC2(11),1,IBITS, 8,'D',IRET)
      IF( IRET.NE.0 ) THEN
        DLASEC2 = 1
        WRITE(GRPRSM,*) 'GRIBEX: Error extracting'
        WRITE(GRPRSM,*) 'GRIBEX: scanning mode flags.'
        WRITE(GRPRSM,*) 'GRIBEX: Return code = ', IRET
        GOTO 900
      ENDIF
C
C     Fix-up for flag which was different in Experimental
C            Edition.
C
      IF( KSEC0(2).EQ.-1.AND.KSEC2(11).EQ.1) KSEC2(11) = 0
C
C     Octets 29 - 31 : Latin 1.
C     Octets 32 - 34 : Latin 2.
C     Two 24 bit fields.
C
      CALL INXBIT(KGRIB,KLENG,INSPT,ILALO(1),2,IBITS, 24,'D',IRET)
      IF( IRET.NE.0 ) THEN
        DLASEC2 = 1
        WRITE(GRPRSM,*) 'GRIBEX: Error extracting'
        WRITE(GRPRSM,*) 'GRIBEX: Latin1 or Latin2 of secants points.'
        WRITE(GRPRSM,*) 'GRIBEX: Return code = ', IRET
        GOTO 900
      ENDIF
C
C     If sign bit is 1, value is negative.
C
      CALL DSGNBT( KSEC2(14), ILALO(1), 24, IRET)
      CALL DSGNBT( KSEC2(15), ILALO(2), 24, IRET)
C
C     Octets 35 - 37 : Latitude of the southern pole.
C     Octets 38 - 40 : Longitude of the southern pole.
C     Two 24 bit fields.
C
      CALL INXBIT(KGRIB,KLENG,INSPT,ILALO(1),2,IBITS, 24,'D',IRET)
      IF( IRET.NE.0 ) THEN
        DLASEC2 = 1
        WRITE(GRPRSM,*) 'GRIBEX: Error extracting'
        WRITE(GRPRSM,*) 'GRIBEX: latitude/longitude of southern pole.'
        WRITE(GRPRSM,*) 'GRIBEX: Return code = ', IRET
        GOTO 900
      ENDIF
C
C     If sign bit is 1, value is negative.
C 
      CALL DSGNBT( KSEC2(20), ILALO(1), 24, IRET)
      CALL DSGNBT( KSEC2(21), ILALO(2), 24, IRET)
C
C     Octets 41 - 42 : Reserved.
C     One 16 bit fields.
C
C     Update bit pointer.
C 
      INSPT = INSPT + 16
C
C     _______________________________________________________
C
C     Section 9. Return to calling routine.
C     _______________________________________________________
C
  900 CONTINUE
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      INTEGER FUNCTION C2BITW ( KVALUE, KXBITS, KPOWER, KMXPWR )
C
C---->
C**** C2BITW
C
C     Purpose.
C     --------
C
C     Compute BIT Width necessary to encode a positive integer value.
C
C**   Interface.
C     ----------
C
C     IWIDTH = C2BITW ( KVALUE, KXBITS, KPOWER, KMXPWR )
C
C     Function return value is the requested bit width.
C
C     Input Parameters.
C     -----------------
C
C     KVALUE     - Positive integer value.
C     KXBITS     - MaXimum number of BITS estimated.
C     KPOWER     - Auxilary array, containing precomputed powers of 2-1.
C     KMXPWR     - Maximum number of bits allowed.
C
C
C     Output Parameters.
C     ------------------
C
C     None.
C
C
C     Method.
C     -------
C
C     Loop down on possible bit width values.
C
C
C
C     Externals.
C     ----------
C
C     None.
C
C
C     Reference.
C     ----------
C
C     None.
C
C
C     Comments.
C     --------
C
C     None.
C
C
C     Author.
C     -------
C
C     J. Clochard, Meteo France, for ECMWF - February 1998.
C
C
C     Modifications.
C     _____________
C
C     None.
C
C----<
C
C     -----------------------------------------------------------------
C*    Section 0. Definition of variables.
C     -----------------------------------------------------------------
C
      IMPLICIT NONE
C
C     Subroutine arguments
C
      INTEGER KVALUE, KXBITS, KMXPWR
      INTEGER KPOWER (0:KMXPWR)
C
C     Local variables.
C
      INTEGER IRETFN, J
C
C     -----------------------------------------------------------------
C*    Section 1 . Direct computing.
C     -----------------------------------------------------------------
C
  100 CONTINUE
C
      DO 101 J=MIN (KXBITS,KMXPWR)-1,0,-1
C
      IF (KVALUE.GT.KPOWER(J)) THEN
        IRETFN=J+1
        GOTO 102
      ENDIF
C
  101 CONTINUE
C
      IRETFN=0
C
  102 CONTINUE
C
C     -----------------------------------------------------------------
C*    Section 9 . Return to calling routine.
C     -----------------------------------------------------------------
C
  900 CONTINUE
C
      C2BITW = IRETFN
C
C
      RETURN
C
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE JOPNLL( PLEG, PINTVL, KTRUNC, KUNIT, PBUILD, KRET)
C
C---->
C**** JOPNLL
C
C     Purpose
C     _______
C
C     This routine finds a file of legendre polynomials corresponding
C     to a given grid interval and truncation and returns a unit number.
C
C     Interface
C     _________
C
C     CALL JOPNLL( PLEG, PINTVL, KTRUNC, KUNIT, PBUILD, KRET)
C
C     Input parameters
C     ________________
C
C     PLEG    - Array for legendre function
C     PINTVL  - Grid interval in degrees
C     KTRUNC  - Spherical truncation
C
C     Output parameters
C     _________________
C
C     KUNIT   - Unit number from PBOPEN
C               0 , open failed
C     PBUILD  - Grid interval used to build the legendre 
C               coefficients file (degrees)
C     KRET    - Return status code
C               0 = OK
C
C     Common block usage
C     __________________
C
C     None
C
C     Method
C     ______
C
C     Builds a file name from the truncation and grid interval and
C     tries to open a file of that name.
C
C     If the file is already open (from a previous call), the
C     previous unit number is returned.
C     If a different file is already open (from a previous call), the
C     existing file is closed first.
C
C     If no file can be located, a file is created.
C
C     Externals
C     _________
C
C     PBOPEN   - Open binary file and return unit number
C     PBCLOSE  - Close binary file
C     JFINDIR  - Find the file of legendre coefficients
C     JMAKLL   - Makes a file of legendre coefficients
C     INTLOG   - Output log message
C     JCHMOD   - Change file permissions
C     RENAME   - Rename file
C
C     Reference
C     _________
C
C     NONE
C
C     Comments
C     ________
C
C     The Legendre polynomials for the transforms may be held in
C     a ready-made file whose name is held in an environment variable:
C         cf_txxxx_raabbbbb       Txxx   aa.bbbbb degrees
C     For example,
C         cf_t0213_r0050000       T213    0.5 degrees
C         cf_t0106_r0250000       T106    2.5 degrees
C
C     On the C90, the file of polynomials may be cached in /owrk/marsint
C
C     Otherwise the file is located in (or will be created in) the first
C     directory given by one of the following (in the order listed, if
C     they exist):
C         environment variable PPDIR
C     or
C         the current working directory.
C
C     Author
C     ______
C
C     J.D.Chambers      *ECMWF*      Nov 1993
C
C     Modifications
C     _____________
C
C     J.D.Chambers      *ECMWF*      Mar 1996
C     Standardise the search order for the environment variables.
C
C----<
C     _______________________________________________________
C
      IMPLICIT NONE
C
#include "parim.h"
C
C     Parameters
C
      INTEGER JPROUTINE
      PARAMETER( JPROUTINE = 30900 )
C
C     Subroutine arguments
C
      REAL      PLEG, PINTVL, PBUILD
      DIMENSION PLEG(*)
      INTEGER   KTRUNC, KUNIT, KRET
C
C     Local variables
C
      INTEGER IRET, IOFFSET
      LOGICAL LFOUND
      CHARACTER*256 DIRNAME
      CHARACTER*256 FILENAME, FILEDUM
      CHARACTER*512 FULLPATH
      CHARACTER*20 YPFN
      CHARACTER*20 YOLD
#ifdef REAL_8
      DATA YPFN/'CF_Txxxx_Raabbbbb'/
#else
      DATA YPFN/'cf_txxxx_raabbbbb'/
#endif
      DATA YOLD/'xxxxxxxxxxxxxxxxxxxx'/
      INTEGER NUNIT
      DATA NUNIT/0/
C
      SAVE NUNIT, YOLD
C
C     Externals
C
      LOGICAL JFINDIR
      LOGICAL JFINDFN
      INTEGER JCHMOD, RENAME
C
C     _______________________________________________________
C
C*    Section 1. See if required file already in use.
C     _______________________________________________________
C
  100 CONTINUE
C
C     Setup the file name
C
      WRITE(YPFN(5:8),'(I4.4)') KTRUNC
      WRITE(YPFN(11:17),'(I7.7)') NINT(PINTVL*JPMULT)
      CALL INTLOG(JP_DEBUG,
     X  'JOPNLL: Coefficients file to open is:', JPQUIET)
      CALL INTLOG(JP_DEBUG, YPFN, JPQUIET)
      PBUILD = PINTVL
C
C     If file already open, return the existing unit number
C
      IF( YPFN.EQ.YOLD ) THEN
        CALL INTLOG(JP_DEBUG,'JOPNLL: File already open.',JPQUIET)
        KUNIT = NUNIT
        GOTO 900
      ENDIF
C
C     Otherwise, close the existing file
C
      IF( NUNIT.NE.0 ) THEN
        CALL PBCLOSE(NUNIT, IRET)
        IF( IRET.NE.0 ) THEN
          CALL INTLOG(JP_ERROR,'JOPNLL: PBCLOSE error',IRET)
          KRET = JPROUTINE + 1
          GOTO 990
        ENDIF
        NUNIT = 0
      ENDIF
C     _______________________________________________________
C
C*    Section 2. See if the file has already been created.
C     _______________________________________________________
C
  200 CONTINUE
C
C     Set appropriate build inteval 
C
      WRITE(YPFN(11:17),'(I7.7)') NINT(PBUILD*JPMULT)
C
      IOFFSET = INDEX(YPFN,' ') - 1
      FILENAME = YPFN(1:IOFFSET)
C
      LFOUND = JFINDIR('PPDIR', DIRNAME)
      IF( LFOUND ) THEN
        LFOUND = JFINDFN(DIRNAME,FILENAME,IOFFSET,NUNIT)
        IF( LFOUND ) GOTO 500
      ENDIF
C
C     Try present working directory
C
      IOFFSET = INDEX(YPFN, ' ') - 1
      FILENAME = YPFN(1:IOFFSET)
      CALL PBOPEN( NUNIT, FILENAME(1:IOFFSET), 'r', IRET)
      IF( IRET.EQ.0 ) GOTO 500
C     _______________________________________________________
C
C*    Section 3. File doesn't exist, find a suitable directory for it.
C     _______________________________________________________
C
  300 CONTINUE
C
      LFOUND = JFINDIR('PPDIR', DIRNAME)
      IF ( LFOUND ) THEN
        IOFFSET = INDEX(DIRNAME, ' ') - 1
        FULLPATH = DIRNAME(1:IOFFSET) // '/' // FILENAME
        IOFFSET = INDEX(FULLPATH, ' ') - 1
        FILENAME(1:IOFFSET) = FULLPATH(1:IOFFSET)
        FILEDUM(1:IOFFSET) = FILENAME(1:IOFFSET)
#ifdef REAL_8
        FILEDUM(IOFFSET-16:IOFFSET-15) = 'XX'
#else
        FILEDUM(IOFFSET-16:IOFFSET-15) = 'xx'
#endif
        CALL PBOPEN(NUNIT, FILEDUM(1:IOFFSET), 'w', IRET)
        IF( IRET.EQ.0 ) GOTO 400
      ENDIF
C
C     Try present working directory
C
      IOFFSET = INDEX(YPFN,' ') - 1
      FILENAME = YPFN(1:IOFFSET)
      FILEDUM(1:IOFFSET) = FILENAME(1:IOFFSET)
#ifdef REAL_8
      FILEDUM(IOFFSET-16:IOFFSET-15) = 'XX'
#else
      FILEDUM(IOFFSET-16:IOFFSET-15) = 'xx'
#endif
      CALL PBOPEN(NUNIT, FILEDUM(1:IOFFSET), 'w', IRET)
      IF( IRET.NE.0 ) THEN
        CALL INTLOG(JP_FATAL,'JOPNLL: PBOPEN error.',IRET)
        KRET = JPROUTINE + 2
        GOTO 990
      ENDIF
C     _______________________________________________________
C
C*    Section 4. Create the coefficients file.
C     _______________________________________________________
C
  400 CONTINUE
C
C     Let user know that a new file is being created.
C
      IOFFSET = INDEX(FILENAME, ' ') - 1
      CALL INTLOG(JP_DEBUG,'JOPNLL: Creating new coefficients file:',
     X            JPQUIET)
      CALL INTLOG(JP_DEBUG,FILENAME(1:IOFFSET), JPQUIET)
C
C     Change access mode to 'read only' for all users.
C
      IRET = JCHMOD(FILEDUM(1:IOFFSET),'0444')
      IF( IRET.NE.0 ) THEN
        CALL INTLOG(JP_FATAL,'JOPNLL: JCHMOD error.',IRET)
        KRET = JPROUTINE + 3
        GOTO 990
      ENDIF
C
C     Make coefficients file
C
      CALL JMAKLL( NUNIT, KTRUNC, PBUILD, 0.0, PLEG, KRET)
      IF( KRET.NE.0 ) GOTO 990
C
C     Close it, rename it, re-open for reading, leave it open.
C
      CALL PBCLOSE(NUNIT, IRET)
      IF( IRET.NE.0 ) THEN
        CALL INTLOG(JP_ERROR,'JOPNLL: PBCLOSE error.',IRET)
        KRET = JPROUTINE + 4
        GOTO 990
      ENDIF
C
      FILEDUM(IOFFSET+1:IOFFSET+1) = CHAR(0)
      FILENAME(IOFFSET+1:IOFFSET+1) = CHAR(0)
      IRET = RENAME(FILEDUM(1:IOFFSET),FILENAME(1:IOFFSET))
#ifndef hpR64
      IF( IRET.NE.0 ) THEN
        CALL INTLOG(JP_FATAL,'JOPNLL: RENAME of file failed',JPQUIET)
        KRET = JPROUTINE + 5
        GOTO 990
      ENDIF
#endif
C
      CALL PBOPEN(NUNIT, FILENAME(1:IOFFSET), 'r', IRET)
      IF( IRET.NE.0 ) THEN
        CALL INTLOG(JP_FATAL,'JOPNLL: PBOPEN error.',IRET)
        KRET = JPROUTINE + 6
        GOTO 990
      ENDIF
C     _______________________________________________________
C
C*    Section 5. File now open with read access.
C     _______________________________________________________
C
  500 CONTINUE
C
      KUNIT = NUNIT
      YOLD  = YPFN
C
C     _______________________________________________________
C
C*    Section 9. Return to calling routine. Format statements
C     _______________________________________________________
C
  900 CONTINUE
C
      KRET = 0
C
 990  CONTINUE
C
      RETURN
      END

C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE BUERR(KERR)
C**** *BUERR*
C
C
C     PURPOSE.
C     --------
C         PRINT ERROR CODE.
C
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *BUERR(KERR)*
C
C     METHOD.
C     -------
C
C          NONE.
C
C
C     EXTERNALS.
C     ----------
C
C          NONE.
C
C     REFERENCE.
C     ----------
C
C          NONE.
C
C     AUTHOR.
C     -------
C
C          M. DRAGOSAVAC    *ECMWF*       15/02/92.
C
C
C     MODIFICATIONS.
C     --------------
C
C          NONE.
C
C
      IMPLICIT LOGICAL(L,O,G), CHARACTER*8(C,H,Y)
C
#     include "bcomunit.F"
C
      CHARACTER*80 CERROR(100)
C
      DATA CERROR/100*' '/
C
C     ------------------------------------------------------------------
C
C*          1.   INITIALIZE MESSAGES.
C                --------------------
 100  CONTINUE
C
      CERROR( 1)=' START OF BUFR MESSAGE NOT FOUND.'
      CERROR( 2)=' END OF BUFR MESSAGE NOT FOUND.'
      CERROR( 3)=' ARRAY TO RECEIVE BUFR MESSAGE TOO SMALL.'
      CERROR( 4)=' JSEC1 PARAMETER TOO SMAL. LOCAL ADP CENTER'//
     1           ' INFORMATION SKIPPED.'
      CERROR( 5)=' JSEC2 PARAMETER TOO SMALL. LOCAL ADP CENTRE'//
     2           ' INFORMATION SKIPPED.'
      CERROR( 6)=' ERROR DURING READ BUFR TABLE B.'
      CERROR( 7)=' ERROR DURING READ BUFR TABLE C.'
      CERROR( 8)=' ERROR DURING READ BUFR TABLE D.'
      CERROR( 9)=' OPEN ERROR.'
      CERROR(10)=' ERROR DURING CLOSE BUFR TABLE B.'
      CERROR(11)=' ERROR DURING CLOSE BUFR TABLE C.'
      CERROR(12)=' ERROR DURING CLOSE BUFR TABLE D.'
      CERROR(13)=' NUMBER OF BITS TO BE EXTRACTED GREATER THAN'//
     1           ' NUMBER OF BITS PER COMPUTER WORD.'
      CERROR(14)=' ARGUMENT KVALS TOO SMALL.'
      CERROR(15)=' INCREMENT VALUE FOR COMPRESSED DATA TOO BIG.'
      CERROR(16)=' JSUBS PARAMETER TOO SMALL.'
      CERROR(17)=' JWORK PARAMETER TOO SMALL.'
      CERROR(18)=' REPLICATION FACTOR EQUAL TO ZERO.'
      CERROR(19)=' DELAYED REPLICATION FACTOR TOO BIG.'
      CERROR(20)=' TABLE D REFERENCE NOT FOUND.'
      CERROR(21)=' DATA DESCRIPTOR OPERATOR NOT FOUND.'
      CERROR(22)=' BUFR OPEARTOR NAME NOT FOUND.'
      CERROR(23)=' TABLE B REFERENCE NOT FOUND.'
      CERROR(24)=' AUGMENTED TABLE B REFERENCE NOT FOUND.'
      CERROR(25)=' KELEM ARGUMENT TOO SMALL.'
      CERROR(26)=' WORD POINTER OUT OF RANGE.'
      CERROR(27)=' TOO MANY SUBSETS TO BE PACKED.'
      CERROR(28)=' NUMBER TO BE PACKED TOO BIG.'
      CERROR(29)=' NUMBER OF DESCRIPTORS KTDLEN TOO BIG.'
      CERROR(30)=' NUMBER OF ELEMENTS GREATER THAN JELEM.'
      CERROR(31)=' TOO FEW ELEMENTS IN KDATA ARRAY.'
      CERROR(32)=' NUMBER OF SUBSETS EQUAL TO ZERO.'
      CERROR(33)=' NEGATIVE VALUE TO BE PACKED.'
      CERROR(34)=' NUMBER OF BITS TO BE PACKED GREATER THAN'//
     1           ' NUMBER OF BITS PER COMPUTER WORD.'
      CERROR(35)=' '
      CERROR(36)=' BAD ORDER OF DATA DESCRIPTORS.'
      CERROR(37)=' WRONG DATA DESCRIPTOR.'
      CERROR(38)=' PARTIAL EXPANSION ON TOTAL MESSAGE NOT SUPPORTED.'
      CERROR(39)=' CAN NOT RECOGNIZE FEEDBACK DATA IN THIS MESSAGE.'
      CERROR(40)=' REQUEST FLAG ILLEGAL.'
      CERROR(41)=' BIT MAP NOT SET.'
      CERROR(42)=' THIS ELEMENT MUST BE DATA PRESENT INDICATOR.'
      CERROR(43)=' TABLE B ELEMENT MUST FOLLOW BIT MAP.'
      CERROR(44)=' REQUESTED SUBSET DOES NOT EXIST.'
      CERROR(45)=' THERE IS NO ONE REQUESTED ELEMENT IN THE DATA.'
      CERROR(46)=' INPUT ARRAY IS TOO SMALL TO RECEIVE INFORMATION.'
      CERROR(47)=' KELEM ARGUMENT IS TOO BIG. MAXIMUM ALLOWED IS 160000'
      CERROR(48)=' '
      CERROR(49)=' TOO MANY DATA FOR BOXING '
      CERROR(50)=' ERROR IN KSEC1(5) FLAG. '//
     1           ' ALLOWED VALUES: ZERO OR 128'
      CERROR(51)=' WRONG USAGE OF 204Y OPERATOR'
      CERROR(56)=' WRONG SECTION 4 SIZE'
C
      IF(KERR.GE.0.AND.KERR.LE.100) THEN
        WRITE(KNTN,'(1H ,A)') CERROR(KERR)
      ELSE
        WRITE(KNTN,'(1H ,A)') ' ERROR NUMBER OUT OF RANGE !'
      END IF
C
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      INTEGER FUNCTION REF2GRB(PREF, KEXP, KMANT, KBITS)
C
C---->
C**** REF2GRB
C
C     Purpose.
C     --------
C
C     Code and check reference value in IBM format
C
C
C**   Interface.
C     ----------
C
C     CALL REF2GRB(PREF, KEXP, KMANT, KBITS)
C
C
C     Input Parameters.
C     -----------------
C
C     PREF       - Reference value
C     KBITS      - Number of bits per computer word.
C
C
C     Output Parameters.
C     -----------------
C
C     KEXP       - 8-bit exponent
C     KMANT      - 24-bit mantissa
C
C     Function returns 0 if no problems encountered, otherwise -1.
C
C
C     Method.
C     -------
C
C     Codes in IBM format, then decides to ensure that reference 
C     value used for packing is not different from that stored
C     because of packing differences.
C
C
C     Externals.
C     ----------
C
C     CONFP3    - Encode into IBM floating point format.
C     DECFP     - Decode from IBM floating point format.
C
C
C     Reference.
C     ----------
C
C     None.
C
C
C     Comments.
C     --------
C
C     None.
C
C
C     Author.
C     -------
C
C     J.D.Chambers     ECMWF      17:05:94
C
C
C     Modifications.
C     _____________
C
C     Change to function return status code.
C     J.D.Chambers     ECMWF      August, 2000
C
C
C----<
C     -----------------------------------------------------------------|
C*    Section 0. Definition of variables.
C     -----------------------------------------------------------------|
C
      IMPLICIT NONE
C
#include "common/grprs.h"
C
#include "grbcom.h"
C
C     Subroutine arguments
C
      REAL PREF
      INTEGER KEXP, KMANT, KBITS
C
C     Local variables
C
      INTEGER ITRND
      REAL ZTEMP
      LOGICAL LDEBUG
C
C     -----------------------------------------------------------------|
C*    Section 1. Convert to and from IBM format.
C     -----------------------------------------------------------------|
C
  100 CONTINUE
C
      REF2GRB = 0
C
      LDEBUG = (NDBG.EQ.1)
C 
C     Convert floating point reference value to IBM representation.
C
      ITRND = 1
      ZTEMP = PREF
      CALL CONFP3 (PREF,KEXP,KMANT,KBITS,ITRND)
C 
C     Set reference value to that actually stored in the GRIB code.
C
      CALL DECFP2 (PREF,KEXP,KMANT)
C 
C     If the nearest number which can be represented in
C     GRIB format is greater than the reference value,
C     find the nearest number in GRIB format lower
C     than the reference value.
C 
      IF (ZTEMP.LT.PREF) THEN
C 
C       Convert floating point to GRIB representation
C       using truncation to ensure that the converted
C       number is smaller than the original one.
C
        ITRND = 0
        PREF  = ZTEMP
        CALL CONFP3 (PREF,KEXP,KMANT,KBITS,ITRND)
C 
C       Set reference value to that stored in the GRIB code.
C
        CALL DECFP2 (PREF,KEXP,KMANT)
C 
        IF (ZTEMP.LT.PREF) THEN
          IF( LDEBUG ) THEN
            WRITE(GRPRSM,*) 'REF2GRB: Reference value error.'
            WRITE(GRPRSM,*) 'REF2GRB: Notify Met.Applications Section.'
            WRITE(GRPRSM,*) 'REF2GRB: ZTEMP = ', ZTEMP
#ifdef REAL_8
            WRITE(GRPRSM,'(1X,Z16)') ZTEMP
#else
            WRITE(GRPRSM,'(1X,Z8)') ZTEMP
#endif
            WRITE(GRPRSM,*) 'REF2GRB: PREF = ', PREF
#ifdef REAL_8
            WRITE(GRPRSM,'(1X,Z16)') PREF
#else
            WRITE(GRPRSM,'(1X,Z8)') PREF
#endif
            REF2GRB = -1
          ENDIF
C
          PREF = ZTEMP
        ENDIF
      ENDIF
C
C     -----------------------------------------------------------------|
C*    Section 9. Return.
C     -----------------------------------------------------------------|
C
  900 CONTINUE
C
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

C
      COMMON /BCMDEFC/ CECMWF,CUSER
C
C             CECMWF        -  CHARACTER STRING TO CONTROL DEFAULT SET UP
C             CUSER  

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities
C granted to it by virtue of its status as an intergovernmental organisation
C nor does it submit to any jurisdiction.
C

      SUBROUTINE EMOSLIB_SSCAL (KN, SA, XVEC, KNCX)
C
C---->
C**** *EMOSLIB_SSCAL*
C
C     PURPOSE.
C     --------
C
C     SIMPLE REPLACEMENT FOR IBM (for both BLAS SSCAL and DSCAL)
C
C**   INTERFACE.
C     ----------
C
C     * CALL EMSOLIB_SSCAL (KN, SA, XVEC, KNCX) *
C
C
C     METHOD.
C     -------
C
C     XVEC (1 + IP * KNCX) = XVEC (1 + IP * KNCX) * SA
C     FOR IP = 0 TO KN - 1
C
C     EXTERNALS.
C     ----------
C
C     NONE
C
C     REFERENCE.
C     ----------
C
C     NONE
C
C     AUTHOR.
C     -------
C
C     K. FIELDING         * ECMWF *     FEB 1992.
C
C     MODIFICATIONS.
C     --------------
C
C     NONE
C
C     COMMON BLOCKS USED
C     -------------------
C
C     NONE
C----<
C
      INTEGER KN, KNCX
Cjdc  DOUBLE PRECISION SA
Cjdc  DOUBLE PRECISION XVEC (*)
      REAL SA
      REAL XVEC (*)
C
      INTEGER IP
C
C     1.    MAIN LOOP OF CODE
C           ----------------------------------------------
C
  100 CONTINUE
      DO 110 IP = 0, KN - 1
         XVEC (1 + IP * KNCX) = XVEC (1 + IP * KNCX) * SA
  110 CONTINUE
C
C     END OF ROUTINE
C
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities
C granted to it by virtue of its status as an intergovernmental organisation
C nor does it submit to any jurisdiction.
C

      SUBROUTINE JMVULL( PZFA, PNORTH, PSOUTH, PWEST, PLATINC, PLONINC,
     X                   PSTART,PDIFF, KROWS, KCOLS, KLON, KJPWR, POUTF)
C
C---->
C**** JMVULL
C
C     Purpose
C     _______
C
C     This routine moves grid point data from array PZFA to array POUTF.
C     It handles the case when the number of latitudes is different in
C     the two hemispheres.
C
C
C     Interface
C     _________
C
C     CALL JMVULL( PZFA, PNORTH, PSOUTH, PWEST, PLATINC, PLONINC,
C    X                   PSTART,PDIFF, KROWS, KCOLS, KLON, KJPWR, POUTF)
C
C
C     Input parameters
C     ________________
C
C     PZFA      -  Input array of grid points arranged in pairs of
C                  north and south latitude bands
C     PNORTH    -  Northernmost latitude for field in POUTF (degrees)
C     PSOUTH    -  Southernmost latitude for field in POUTF (degrees)
C     PWEST     -  Westernmost longitude for field in POUTF (degrees)
C     PLATINC   -  Grid interval between latitudes in degrees in POUTF
C     PLONINC   -  Grid interval between longitudes in degrees in POUTF
C     PSTART    -  Current first latitude in PZFA (degrees)
C     PDIFF     -  Offset to first latitude in PZFA for moving (degrees)
C     KROWS     -  Number of latitude rows to store
C     KCOLS     -  Number of longitude points to store from latitude
C     KLON      -  Number of longitude points in generated latitude row
C     KJPWR     -  Multiplication factor applied to ensure that number
C                  of longitude points > twice*spherical truncation
C
C
C     Output parameters
C     ________________
C
C     POUTF      - output array of grid points
C
C
C     Common block usage
C     __________________
C
C     JDCNDBG
C
C
C     Method
C     ______
C
C     Moves latitude rows of points from PZFA into the correct
C     geographical positions in POUTF.  POUTF may already be
C     partially full.  The distribution is not symmetrical north-south.
C
C
C     Externals
C     _________
C
C     JMOVLL    - Move points of symmetric grid to array
C     INTLOG   - Logs messages
C     INTLOGR  - Logs messages with real value.
C
C
C     Reference
C     _________
C
C     E.C.M.W.F. Research Department technical memorandum no. 56
C                "The forecast and analysis post-processing package"
C                May 1982. J.Haseler.
C
C
C     Comments
C     ________
C
C     POUTF is a 2-dimensional array, with first dimension = KCOLS.
C
C     For calculation purposes, the number of longitude points
C     has to be greater than 2*(output truncation) to ensure that the
C     fourier transform is exact (see Reference, page 10).
C     Parameter JPLONO is set to 860 to ensure that PZFA will have
C     enough slots for the KLON points for all values of regular
C     grid intervals from N1 to N720.
C
C     When filling the output array POUTF, the longitude points have
C     have to be taken selectively to avoid the intermediate generated
C     points, picking up values only at the required longitudes.  The
C     magnification factor is KJPWR (a power of 2).
C
C     PZFA has values stored:
C       North lat1:  x, 1, x, 2, x, 3, x, ... , KLON, ...
C       South lat1:  x, 1, x, 2, x, 3, x, ... , KLON, ...
C       North lat2:  x, 1, x, 2, x, 3, x, ... , KLON, ...
C       South lat2:  x, 1, x, 2, x, 3, x, ... , KLON, ...
C       ... for KROWS latitudes.
C
C     The 'x' represents the extra values generated because of the
C     need for the number of points along a latitude line to be more
C     than twice the truncation of the spherical harmonics.
C
C
C     Author
C     ______
C
C     J.D.Chambers      ECMWF      Nov 1993
C
C
C     Modifications
C     _____________
C
C     None
C
C----<
C
      IMPLICIT NONE
C
C     _______________________________________________________
C
#include "jparams.h"
#include "parim.h"
C
C     Subroutine arguments
      INTEGER KROWS, KCOLS, KLON, KJPWR
      REAL PZFA, PNORTH, PWEST, PSOUTH, PLATINC, PLONINC, PSTART
      REAL PDIFF, POUTF
      DIMENSION PZFA( JPLONO+2, 64), POUTF( KCOLS, *)
C
C     Parameters
      INTEGER JPROUTINE
      PARAMETER( JPROUTINE = 32100 )
C
C     Local variables
      INTEGER INROWS, NROWS, NFLAG
      INTEGER LATEST
      REAL ZTOP, ZBASE
C
C     _______________________________________________________
C
C*    Section 1. Initialization.
C     _______________________________________________________
C
  100 CONTINUE
C
      IF ( NDBG .GT. 1) THEN
        CALL INTLOG(JP_DEBUG,'JMVULL - Input parameters:',JPQUIET)
        CALL INTLOGR(JP_DEBUG,
     X    'JMVULL - Northern latitude for output = ', PNORTH)
        CALL INTLOGR(JP_DEBUG,
     X    'JMVULL - Southern latitude for output = ', PSOUTH)
        CALL INTLOGR(JP_DEBUG,
     X    'JMVULL - Western longitude for output = ', PWEST)
        CALL INTLOGR(JP_DEBUG,
     X    'JMVULL - Latitude grid interval (deg) = ', PLATINC)
        CALL INTLOGR(JP_DEBUG,
     X    'JMVULL - Longitude grid interval (deg) = ', PLONINC)
        CALL INTLOGR(JP_DEBUG,
     X    'JMVULL - First latitude for moving = ', PSTART)
        CALL INTLOGR(JP_DEBUG,
     X    'JMVULL - Offset to first lat. for moving = ', PDIFF)
        CALL INTLOG(JP_DEBUG,
     X    'JMVULL - Number of latitudes to store = ', KROWS)
        CALL INTLOG(JP_DEBUG,
     X    'JMVULL - Number of longitude pts per row = ', KCOLS)
        CALL INTLOG(JP_DEBUG,
     X    'JMVULL - No. long.pts per generated row = ', KLON)
        CALL INTLOG(JP_DEBUG,
     X    'JMVULL - Multiplication factor applied = ', KJPWR)
      ENDIF
C
      LATEST = 1
      ZTOP   = PSTART
      ZBASE  = PSTART - (KROWS - 1)*PLATINC
      INROWS = KROWS
      NROWS = INROWS
C
      IF ( NDBG .GT. 1) THEN
        CALL INTLOGR(JP_DEBUG,
     X    'JMVULL - Current northernmost lat = ', ZTOP)
        CALL INTLOGR(JP_DEBUG,
     X    'JMVULL - Current southernmost lat = ', ZBASE)
      ENDIF
C     _______________________________________________________
C
C*    Section 2. Processing more North than South, or more South
C                than North.
C     _______________________________________________________
C
  200 CONTINUE
Cjdc  IF ( ZTOP .GE. (-PSOUTH) ) THEN
      IF( (PNORTH.GT.(-PSOUTH)) .AND. (ZTOP .GE. (-PSOUTH)) ) THEN
C
C     Move excess northern latitudes ...
        NROWS = NINT( ( ZTOP + PSOUTH )/PLATINC )
        NROWS = MIN( NROWS, KROWS )
        NFLAG = 1
C
        IF ( NDBG .GT. 1) CALL INTLOG(JP_DEBUG,
     X    'JMVULL - Move excess north latitudes = ', NROWS)
C
        CALL JMOVLL( PZFA, PNORTH, PWEST, PLATINC, PLONINC, ZTOP, NROWS,
     X               KCOLS, KLON, KJPWR, POUTF, NFLAG)
C
      ELSE
C
C     Move excess southern latitudes ...
        NROWS = NINT( ( ZTOP - PNORTH )/PLATINC )
        NROWS = MIN( NROWS, KROWS )
        NFLAG = 2
C
        IF ( NDBG .GT. 1) CALL INTLOG(JP_DEBUG,
     X    'JMVULL - Move excess south latitudes = ', NROWS)
C
          CALL JMOVLL(PZFA, PNORTH, PWEST, PLATINC, PLONINC, PSTART,
     X              NROWS, KCOLS, KLON, KJPWR, POUTF, NFLAG)
      ENDIF
C
      ZTOP   = ZTOP - (NROWS * PLATINC)
      LATEST = LATEST + (2 * NROWS)
      NROWS  = INROWS - NROWS
C     _______________________________________________________
C
C*    Section 3. Processing latitudes common to both North and South.
C     _______________________________________________________
C
  300 CONTINUE
C
C     Move rows common to both if any left ...
      IF ( NROWS .GT. 0 ) THEN
C
        IF ( NDBG .GT. 1) CALL INTLOG(JP_DEBUG,
     X    'JMVULL - Move common latitudes(N & S) = ', NROWS)
C
        NFLAG = 3
        CALL JMOVLL( PZFA( 1, LATEST), PNORTH, PWEST, PLATINC, PLONINC,
     X               ZTOP, NROWS, KCOLS, KLON, KJPWR, POUTF, NFLAG)
      ENDIF
C     _______________________________________________________
C
C
C*    Section 9. Return to calling routine. Format statements
C     _______________________________________________________
C
  900 CONTINUE
C
C
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities
C granted to it by virtue of its status as an intergovernmental organisation
C nor does it submit to any jurisdiction.
C

      SUBROUTINE GRPRS1B(KSEC1)
C
C---->
C**** GRPRS1B
C
C     Purpose.
C     --------
C
C     Print the information in the Product Definition
C     Section (Section 1) of decoded GRIB data.
C
C**   Interface.
C     ----------
C
C     CALL GRPRS1B(KSEC1)
C
C
C     Input Parameters.
C     -----------------
C
C     KSEC1 - Array of decoded parameters from Section 1.
C
C
C     Output Parameters.
C     ------------------
C
C     None.
C
C
C     Method.
C     -------
C
C     Flag fields are printed in binary representation.
C     Other fields as integers.
C     Fields printed depend on GRIB Edition.
C
C     This is a simplified version of grprs1.F called by grprs1.c
C     to display local definitions stored internally in ECMWF local
C     defienition 190.
C
C
C     Externals.
C     ----------
C
C     PRTBIN  - Print binary value in character format.
C     CHKTAB2 - Looks up a parameter in a given ECMWF local table 2.
C
C     Common block GRPRSCM.
C
C
C     Reference.
C     ----------
C
C     WMO Manual on Codes re GRIB Code.
C     See also routine GRIBEX.
C
C
C     Comments.
C     ---------
C
C     When decoding data from Experimental Edition or Edition 0,
C     routine GRIBEX adds the additional fields available in
C     Edition 1.
C
C     Checks environment variable GRPRS_STREAM for output stream number
C     for printing (default is 6)
C
C
C     Author.
C     -------
C     J.D.Chambers     ECMWF      November 2004
C
C
C----<
C     -----------------------------------------------------------------|
C*    Section 0. Definition of variables.
C     -----------------------------------------------------------------|
C
      IMPLICIT NONE
C
#include "common/grprs.h"
#include "grbcom.h"
C
C     Parameter(s)
C
      INTEGER JPBYTES
#ifdef INTEGER_8
      PARAMETER (JPBYTES = 8)
#else
      PARAMETER (JPBYTES = 4)
#endif
C
C     Subroutine arguments
C
      INTEGER KSEC1(*)
C
C     Local variables
C
      INTEGER IPREV, ICURR, ICOUNT, IOFFSET, IYEAR
CC    INTEGER IBIT, IERR, IOUT, NBYTES, LEN, IOFF2, IOFF3
      INTEGER JLOOP, JILOOP
      REAL VALUE
C
      CHARACTER*8 HVERSION
CC    CHARACTER*121 HFIRST, HSECOND, HTHIRD, HFOURTH
C
C     Externals
C
      INTEGER CHKTAB2
      EXTERNAL CHKTAB2
C
C     -----------------------------------------------------------------|
C*    Section 1 . Print required information.
C     -----------------------------------------------------------------|
C
  100 CONTINUE
C
        IF(KSEC1(37).EQ.1)
     X    WRITE(GRPRSM,*) '(Mars labelling or ensemble forecast)'
        IF(KSEC1(37).EQ.2)
     X    WRITE(GRPRSM,*) '(Cluster means and standard deviations)'
        IF(KSEC1(37).EQ.3)
     X    WRITE(GRPRSM,*) '(Satellite image data)'
        IF(KSEC1(37).EQ.4)
     X    WRITE(GRPRSM,*) '(Ocean model data)'
        IF(KSEC1(37).EQ.5)
     X    WRITE(GRPRSM,*) '(Forecast probability data)'
        IF(KSEC1(37).EQ.6)
     X    WRITE(GRPRSM,*) '(Surface temperature data)'
        IF(KSEC1(37).EQ.7)
     X    WRITE(GRPRSM,*) '(Sensitivity data)'
        IF(KSEC1(37).EQ.8)
     X    WRITE(GRPRSM,*) '(ECMWF re-analysis data)'
        IF(KSEC1(37).EQ.9)
     X    WRITE(GRPRSM,*) '(Singular vectors / ensemble perturbations)'
        IF(KSEC1(37).EQ.10)
     X    WRITE(GRPRSM,*) '(EPS tubes)'
        IF(KSEC1(37).EQ.11)
     X    WRITE(GRPRSM,*) '(Supplementary data used by analysis)'
        IF(KSEC1(37).EQ.13)
     X    WRITE(GRPRSM,*) '(Wave 2D spectra direction and frequency)'
        IF(KSEC1(37).EQ.14)
     X    WRITE(GRPRSM,*) '(Brightness temperature)'
        IF(KSEC1(37).EQ.15)
     X    WRITE(GRPRSM,*) '(Ocean ensemble seasonal forecast)'
        IF(KSEC1(37).EQ.16)
     X    WRITE(GRPRSM,*) '(Seasonal fc monthly mean atmosphere data)'
        IF(KSEC1(37).EQ.17)
     X    WRITE(GRPRSM,*) '(Sst or sea-ice used by analysis)'
        IF(KSEC1(37).EQ.18)
     X    WRITE(GRPRSM,*) '(Multi-analysis ensemble data)'
        IF(KSEC1(37).EQ.19)
     X    WRITE(GRPRSM,*) '(Extreme forecast index data)'
        IF(KSEC1(37).EQ.20)
     X    WRITE(GRPRSM,*) '(4D variational increments)'
        IF(KSEC1(37).EQ.21)
     X    WRITE(GRPRSM,*) '(Sensitive area predictions)'
        IF(KSEC1(37).EQ.23)
     X    WRITE(GRPRSM,*)
     X '(Coupled atmospheric, wave & ocean means (+ hindcast support))'
        IF(KSEC1(37).EQ.24)
     X    WRITE(GRPRSM,*) '(Satellite image simulation)'
        IF(KSEC1(37).EQ.25)
     X    WRITE(GRPRSM,*) '(4DVar model errors)'
        IF(KSEC1(37).EQ.50)
     X    WRITE(GRPRSM,*) '(Member State data)'
        IF(KSEC1(37).EQ.190)
     X    WRITE(GRPRSM,*) '(Multiple ECMWF local definitions)'
        IF(KSEC1(37).EQ.191)
     X    WRITE(GRPRSM,*) '(Free format data descriptor)'
C
        WRITE(GRPRSM,9302) KSEC1(38)
        WRITE(GRPRSM,9303) KSEC1(39)
        WRITE(GRPRSM,9304) KSEC1(40)
        WRITE(HVERSION, '(A8)' ) KSEC1(41)
        WRITE(GRPRSM,9305)
     X    HVERSION(5:5),
     X    HVERSION(6:6),
     X    HVERSION(7:7),
     X    HVERSION(8:8)
C
C       ECMWF Local definition 1.
C       (MARS labelling or ensemble forecast data)
C
        IF (KSEC1(37).EQ.1) THEN
          WRITE(GRPRSM,9310) KSEC1(42)
          IF( KSEC1(40).NE.1090 ) WRITE(GRPRSM,9311) KSEC1(43)
          GOTO 900
        ENDIF
C
C       ECMWF Local definition 2.
C       (Cluster means and standard deviations)
C
        IF (KSEC1(37).EQ.2) THEN
          WRITE(GRPRSM,9312) KSEC1(42)
          WRITE(GRPRSM,9313) KSEC1(43)
          WRITE(GRPRSM,9314) KSEC1(44)
          WRITE(GRPRSM,9315) KSEC1(45)
          WRITE(GRPRSM,9316) KSEC1(46)
          WRITE(GRPRSM,9317) KSEC1(47)
          WRITE(GRPRSM,9318) KSEC1(48)
          WRITE(GRPRSM,9319) KSEC1(49)
          WRITE(GRPRSM,9320) KSEC1(50)
          WRITE(GRPRSM,9321) KSEC1(51)
          WRITE(GRPRSM,9324) KSEC1(52)
          WRITE(GRPRSM,9322) KSEC1(53)
          DO 210 JLOOP = 1,KSEC1(53)
            WRITE(GRPRSM,9323) KSEC1(JLOOP+53)
  210     CONTINUE
          GOTO 900
        ENDIF
C
C       ECMWF Local definition 3.
C       (Satellite image data)
C
        IF (KSEC1(37).EQ.3) THEN
          WRITE(GRPRSM,9306) KSEC1(42)
          WRITE(GRPRSM,9307) KSEC1(43)
          GOTO 900
        ENDIF
C
C       ECMWF Local definition 4.
C       (Ocean model data)
C
        IF (KSEC1(37).EQ.4) THEN
          WRITE(GRPRSM,9310) KSEC1(42)
          IF( KSEC1(40).NE.1090 ) WRITE(GRPRSM,9311) KSEC1(43)
          WRITE(GRPRSM,9401) KSEC1(44)
          WRITE(GRPRSM,9402) KSEC1(45)
C
          WRITE(GRPRSM,*) ' '
          WRITE(GRPRSM,*) 'Coordinate structure definition.'
          WRITE(GRPRSM,*) '--------------------------------'
          WRITE(GRPRSM,9403) KSEC1(46)
          WRITE(GRPRSM,9404) KSEC1(47)
          WRITE(GRPRSM,9405) KSEC1(48)
          WRITE(GRPRSM,9406) KSEC1(49)
          WRITE(GRPRSM,9407) KSEC1(50)
C
          WRITE(GRPRSM,*) ' '
          WRITE(GRPRSM,*) 'Position definition.'
          WRITE(GRPRSM,*) '--------------------'
          WRITE(GRPRSM,9411) KSEC1(51)
          WRITE(GRPRSM,9412) KSEC1(52)
          WRITE(GRPRSM,9413) KSEC1(53)
          WRITE(GRPRSM,9414) KSEC1(54)
          WRITE(GRPRSM,9415) KSEC1(55)
          WRITE(GRPRSM,9416) KSEC1(56)
          WRITE(GRPRSM,9413) KSEC1(57)
          WRITE(GRPRSM,9414) KSEC1(58)
          WRITE(GRPRSM,9415) KSEC1(59)
C
          WRITE(GRPRSM,*) ' '
          WRITE(GRPRSM,*) 'Grid Definition.'
          WRITE(GRPRSM,*) '----------------'
          WRITE(GRPRSM,9421) KSEC1(60)
          WRITE(GRPRSM,9422) KSEC1(61)
          WRITE(GRPRSM,9423) KSEC1(62)
          WRITE(GRPRSM,9424) KSEC1(63)
          WRITE(GRPRSM,9425) KSEC1(64)
          WRITE(GRPRSM,9426) KSEC1(65)
          WRITE(GRPRSM,9427) KSEC1(66)
          WRITE(GRPRSM,9428) KSEC1(67)
          WRITE(GRPRSM,9429) KSEC1(68)
          WRITE(GRPRSM,9430) KSEC1(69)
C
          WRITE(GRPRSM,*) ' '
          WRITE(GRPRSM,*) 'Further information.'
          WRITE(GRPRSM,*) '--------------------'
          WRITE(GRPRSM,9441) KSEC1(70)
C
          WRITE(GRPRSM,*) ' '
          WRITE(GRPRSM,*) 'Auxiliary information.'
          WRITE(GRPRSM,*) '----------------------'
          WRITE(GRPRSM,9451) KSEC1(71)
          WRITE(GRPRSM,9452) KSEC1(72)
          WRITE(GRPRSM,9453) KSEC1(73)
          WRITE(GRPRSM,9454) KSEC1(74)
C
          WRITE(GRPRSM,*) ' '
          WRITE(GRPRSM,*) 'Horizontal coordinate supplement.'
          WRITE(GRPRSM,*) '---------------------------------'
          IF( KSEC1(71).EQ.0 ) THEN
            WRITE(GRPRSM,*) '(None).'
          ELSE
            WRITE(GRPRSM,*) 'Number of items = ', KSEC1(71)
            DO JLOOP = 1,KSEC1(71)
              WRITE(GRPRSM,9461) KSEC1(74+JLOOP)
            ENDDO
          ENDIF
C
          WRITE(GRPRSM,*) ' '
          WRITE(GRPRSM,*) 'Mixed coordinate definition.'
          WRITE(GRPRSM,*) '----------------------------'
          IF( KSEC1(72).EQ.0 ) THEN
            WRITE(GRPRSM,*) '(None).'
          ELSE
            WRITE(GRPRSM,*) 'Number of items = ', KSEC1(72)
            IOFFSET = 74 + KSEC1(71)
            DO JLOOP = 1,KSEC1(72)
              WRITE(GRPRSM,9461) KSEC1(IOFFSET+JLOOP)
            ENDDO
          ENDIF
C
          WRITE(GRPRSM,*) ' '
          WRITE(GRPRSM,*) 'Grid coordinate list.'
          WRITE(GRPRSM,*) '---------------------'
          IF( KSEC1(73).EQ.0 ) THEN
            WRITE(GRPRSM,*) '(None).'
          ELSE
            WRITE(GRPRSM,*) 'Number of items = ', KSEC1(73)
            IOFFSET = 74 + KSEC1(71) + KSEC1(72)
            DO JLOOP = 1,KSEC1(73)
              WRITE(GRPRSM,9461) KSEC1(IOFFSET+JLOOP)
            ENDDO
          ENDIF
C
          WRITE(GRPRSM,*) ' '
          WRITE(GRPRSM,*) 'Auxiliary array.'
          WRITE(GRPRSM,*) '----------------'
          IF( KSEC1(74).EQ.0 ) THEN
            WRITE(GRPRSM,*) '(None).'
          ELSE
            WRITE(GRPRSM,*) 'Number of items = ', KSEC1(74)
            IOFFSET = 74 + KSEC1(71) + KSEC1(72) + KSEC1(73)
            DO JLOOP = 1,KSEC1(74)
              WRITE(GRPRSM,9461) KSEC1(IOFFSET+JLOOP)
            ENDDO
          ENDIF
C
          WRITE(GRPRSM,*) ' '
          WRITE(GRPRSM,*) 'Post-auxiliary array.'
          WRITE(GRPRSM,*) '---------------------'
          IOFFSET = 74 + KSEC1(71) + KSEC1(72) + KSEC1(73) + KSEC1(74)
          IF( KSEC1(IOFFSET+1).EQ.0 ) THEN
            WRITE(GRPRSM,*) '(None).'
          ELSE
            WRITE(GRPRSM,*) 'Number of items = ', KSEC1(IOFFSET+1)
            DO JLOOP = 2, 4
              WRITE(GRPRSM,9461) KSEC1(IOFFSET+JLOOP)
            ENDDO
            IF( KSEC1(IOFFSET+1).GT.4 ) THEN
              WRITE(GRPRSM,9462) KSEC1(IOFFSET+5)
              IF( KSEC1(IOFFSET+6).NE.0 ) THEN
                WRITE(GRPRSM,9463) KSEC1(IOFFSET+6)
                WRITE(GRPRSM,9464) KSEC1(IOFFSET+7)
              ENDIF
            ENDIF
          ENDIF
C
          GOTO 900
        ENDIF
C
C       ECMWF Local definition 5.
C       (Forecast probability data)
C
        IF (KSEC1(37).EQ.5) THEN
          WRITE(GRPRSM,9500) KSEC1(42)
          WRITE(GRPRSM,9501) KSEC1(43)
          WRITE(GRPRSM,9502) KSEC1(44)
          WRITE(GRPRSM,9503) KSEC1(45)
          IF ( KSEC1(45) .NE. 2 ) WRITE(GRPRSM,9504) KSEC1(46)
          IF ( KSEC1(45) .NE. 1 ) WRITE(GRPRSM,9505) KSEC1(47)
          GOTO 900
        ENDIF
C
C       ECMWF Local definition 6.
C       (Surface temperature data)
C
        IF (KSEC1(37).EQ.6) THEN
C
          IYEAR = KSEC1(44)
          IF( IYEAR.GT.100 ) THEN
            IF( IYEAR.LT.19000000 ) IYEAR = IYEAR + 19000000
            WRITE(GRPRSM,9601) IYEAR
          ELSE
            WRITE(GRPRSM,*)
     X        'Date of SST field used               Not given'
          ENDIF
          IF(KSEC1(45).EQ.0) WRITE(GRPRSM,9602) KSEC1(45)
          IF(KSEC1(45).EQ.1) WRITE(GRPRSM,9603) KSEC1(45)
          IF(KSEC1(45).EQ.2) WRITE(GRPRSM,9604) KSEC1(45)
C
          WRITE(GRPRSM,9605) KSEC1(46)
C
          DO 260 JLOOP = 1, KSEC1(46)
            IYEAR = KSEC1(45+(JLOOP*2))
            IF( IYEAR.GT.100 ) THEN
              IF( IYEAR.LT.19000000 ) IYEAR = IYEAR + 19000000
              WRITE(GRPRSM,9606) JLOOP, IYEAR
              WRITE(GRPRSM,9607) JLOOP, KSEC1(46+(JLOOP*2))
            ELSE
              WRITE(GRPRSM,*)
     X          'Date of SST field used               Not given'
            ENDIF
C
  260     CONTINUE
C
          GOTO 900
        ENDIF
C
C       ECMWF Local definition 7.
C       (Sensitivity data)
C
        IF (KSEC1(37).EQ.7) THEN
          IF ( KSEC1(39) .EQ. 51 ) WRITE(GRPRSM,9700) KSEC1(42)
          IF ( KSEC1(39) .NE. 51 ) WRITE(GRPRSM,9701) KSEC1(42)
          IF ( KSEC1(39) .NE. 52 ) WRITE(GRPRSM,9702) KSEC1(43)
          IF ( KSEC1(39) .EQ. 52 ) WRITE(GRPRSM,9703) KSEC1(43)
          WRITE(GRPRSM,9704) KSEC1(44)
          WRITE(GRPRSM,9705) KSEC1(45)
          GOTO 900
        ENDIF
C
C
C       ECMWF Local definition 8.
C       (ECMWF re-analysis data)
C
        IF (KSEC1(37).EQ.8) THEN
          IF( (KSEC1(40).EQ.1043).OR.
     X        (KSEC1(40).EQ.1070).OR.
     X        (KSEC1(40).EQ.1071) ) THEN
            WRITE(GRPRSM,9801) KSEC1(42)
            DO JLOOP = 43, 54
              JILOOP = JLOOP + 8
              WRITE(GRPRSM,9800) JILOOP, KSEC1(JLOOP)
            ENDDO
          ELSE
            DO JLOOP = 42, 54
              JILOOP = JLOOP + 8
              WRITE(GRPRSM,9800) JILOOP, KSEC1(JLOOP)
            ENDDO
          ENDIF
          GOTO 900
        ENDIF
C
        IF (KSEC1(39).GT.4.AND.KSEC1(39).LT.9) THEN
          WRITE(GRPRSM,9308) KSEC1(42)
          WRITE(GRPRSM,9309) KSEC1(43)
        ENDIF
C
C
C       ECMWF Local definition 9.
C       (Singular vectors and ensemble perturbations)
C
        IF (KSEC1(37).EQ.9) THEN
          IF(KSEC1(39).EQ.60)
     X      WRITE(GRPRSM,9960) KSEC1(42)
          IF(KSEC1(39).EQ.61)
     X      WRITE(GRPRSM,9961) KSEC1(42)
          IF(KSEC1(39).EQ.62)
     X      WRITE(GRPRSM,9962) KSEC1(42)
          IF(KSEC1(39).EQ.62) THEN
            WRITE(GRPRSM,9943) KSEC1(43)
            WRITE(GRPRSM,9944) KSEC1(44)
            WRITE(GRPRSM,9945) KSEC1(45)
            WRITE(GRPRSM,9946) KSEC1(46)
            WRITE(GRPRSM,9947) KSEC1(47)
            WRITE(GRPRSM,9948) KSEC1(48)
            WRITE(GRPRSM,9949) KSEC1(49)
            WRITE(GRPRSM,9950) KSEC1(50)
            WRITE(GRPRSM,9951) KSEC1(51)
            WRITE(GRPRSM,9952) KSEC1(52)
            WRITE(GRPRSM,9953) KSEC1(53)
            WRITE(GRPRSM,9954) KSEC1(54)
            WRITE(GRPRSM,9955) KSEC1(55)
          ENDIF
          GOTO 900
        ENDIF
C
C
C       ECMWF Local definition 10.
C       (EPS tubes)
C
        IF (KSEC1(37).EQ.10) THEN
          WRITE(GRPRSM,1001) KSEC1(42)
          WRITE(GRPRSM,1002) KSEC1(43)
          WRITE(GRPRSM,1003) KSEC1(44)
          WRITE(GRPRSM,1004) KSEC1(45)
          WRITE(GRPRSM,1005) KSEC1(46)
          WRITE(GRPRSM,1006) KSEC1(47)
          WRITE(GRPRSM,1007) KSEC1(48)
          WRITE(GRPRSM,1008) KSEC1(49)
          WRITE(GRPRSM,1009) KSEC1(50)
          WRITE(GRPRSM,1010) KSEC1(51)
          WRITE(GRPRSM,1011) KSEC1(52)
          WRITE(GRPRSM,1012) KSEC1(53)
          WRITE(GRPRSM,1013) KSEC1(54)
          WRITE(GRPRSM,1014) KSEC1(55)
          WRITE(GRPRSM,1015) KSEC1(56)
          WRITE(GRPRSM,1016) KSEC1(57)
          WRITE(GRPRSM,1017) KSEC1(58)
C
          WRITE(GRPRSM,1018)
          DO 280 JLOOP = 1, KSEC1(58)
            WRITE(GRPRSM,1019) KSEC1(58+JLOOP)
  280     CONTINUE
          GOTO 900
        ENDIF
C
C
C       ECMWF Local definition 11.
C       (Supplementary data used by the analysis)
C
        IF (KSEC1(37).EQ.11) THEN
          WRITE(GRPRSM,1101)
          WRITE(GRPRSM,1103) KSEC1(42)
          WRITE(GRPRSM,1104) KSEC1(43)
          WRITE(GRPRSM,1105) KSEC1(44)
          WRITE(HVERSION, '(A8)' ) KSEC1(45)
          WRITE(GRPRSM,1106)
#ifdef LITTLE_ENDIAN
     X      HVERSION(8:8),
     X      HVERSION(7:7),
     X      HVERSION(6:6),
     X      HVERSION(5:5)
#else
     X      HVERSION(5:5),
     X      HVERSION(6:6),
     X      HVERSION(7:7),
     X      HVERSION(8:8)
#endif
          IYEAR = KSEC1(46)
          IF( IYEAR.GT.40 ) THEN
            IYEAR = IYEAR + 1900
          ELSE
            IYEAR = IYEAR + 2000
          ENDIF
          WRITE(GRPRSM,1107) KSEC1(46), IYEAR
          WRITE(GRPRSM,1108) KSEC1(47)
          WRITE(GRPRSM,1109) KSEC1(48)
          WRITE(GRPRSM,1110) KSEC1(49)
          WRITE(GRPRSM,1111) KSEC1(50)
          WRITE(GRPRSM,1112) KSEC1(51)
          WRITE(GRPRSM,1113) KSEC1(52)
          WRITE(GRPRSM,1114) KSEC1(53)
          GOTO 900
        ENDIF
C
C
C       ECMWF Local definition 12.
C
        IF (KSEC1(37).EQ.12) THEN
          WRITE(GRPRSM,1201)
          WRITE(GRPRSM,1203) KSEC1(42)
          WRITE(GRPRSM,1204) KSEC1(43)
          WRITE(GRPRSM,1205) KSEC1(44)
          WRITE(GRPRSM,1206) KSEC1(45)
          WRITE(GRPRSM,1207) KSEC1(46)
          WRITE(GRPRSM,1208) KSEC1(47)
          WRITE(GRPRSM,1209) KSEC1(48)
          WRITE(GRPRSM,1210) KSEC1(49)
          WRITE(GRPRSM,1211)
          IPREV  = KSEC1(50)
          ICURR  = 0
          ICOUNT = 0
          DO JLOOP = 1, KSEC1(49)
            ICURR = KSEC1(49+JLOOP)
            IF( ICURR.NE.IPREV ) THEN
              IF( ICOUNT.EQ.1 ) WRITE(GRPRSM,1212) IPREV
              IF( ICOUNT.EQ.2 ) WRITE(GRPRSM,1213) IPREV
              IF( ICOUNT.GT.2 ) WRITE(GRPRSM,1214) IPREV, ICOUNT
              IPREV  = ICURR
              ICOUNT = 1
            ELSE
              ICOUNT = ICOUNT + 1
            ENDIF
          ENDDO
          IF( ICOUNT.EQ.1 ) WRITE(GRPRSM,1212) IPREV
          IF( ICOUNT.EQ.2 ) WRITE(GRPRSM,1213) IPREV
          IF( ICOUNT.GT.2 ) WRITE(GRPRSM,1214) IPREV, ICOUNT
          GOTO 900
        ENDIF
C
C
C       ECMWF Local definition 13.
C       (Wave 2D spectra direction and frequency)
C
        IF (KSEC1(37).EQ.13) THEN
          WRITE(GRPRSM,1301) KSEC1(44)
          WRITE(GRPRSM,1302) KSEC1(45)
          WRITE(GRPRSM,1303) KSEC1(46)
          WRITE(GRPRSM,1304) KSEC1(47)
          WRITE(GRPRSM,1305) KSEC1(48)
          WRITE(GRPRSM,1306) KSEC1(49)
          WRITE(GRPRSM,1307)
          DO 290 JLOOP = 1, KSEC1(46)
            VALUE = REAL(KSEC1(49+JLOOP))/REAL(KSEC1(48))
            IF( KSEC1(44).EQ.JLOOP ) THEN
              WRITE(GRPRSM,1308) JLOOP, VALUE
            ELSE
              WRITE(GRPRSM,1309) JLOOP, VALUE
            ENDIF
  290     CONTINUE
          WRITE(GRPRSM,1310)
          DO 295 JLOOP = 1, KSEC1(47)
            VALUE = REAL(KSEC1(49+KSEC1(46)+JLOOP))/REAL(KSEC1(49))
            IF( KSEC1(45).EQ.JLOOP ) THEN
              WRITE(GRPRSM,1308) JLOOP, VALUE
            ELSE
              WRITE(GRPRSM,1309) JLOOP, VALUE
            ENDIF
  295     CONTINUE
C
          IF( N13FLAG.GT.0 ) THEN
            WRITE(GRPRSM,1311) KSEC1(50+KSEC1(46)+KSEC1(47))
            WRITE(GRPRSM,1312) KSEC1(51+KSEC1(46)+KSEC1(47))
            IF( N13FLAG.GT.1 ) THEN
              WRITE(GRPRSM,1313) KSEC1(52+KSEC1(46)+KSEC1(47))
              WRITE(GRPRSM,1314) KSEC1(53+KSEC1(46)+KSEC1(47))
              WRITE(GRPRSM,1315) KSEC1(54+KSEC1(46)+KSEC1(47))
            ENDIF
          ENDIF
          GOTO 900
        ENDIF
C
C       ECMWF Local definition 14.
C       (Brightness temperature)
C
        IF (KSEC1(37).EQ.14) THEN
          WRITE(GRPRSM,1401) KSEC1(44)
          WRITE(GRPRSM,1402) KSEC1(45)
          WRITE(GRPRSM,1403) KSEC1(46)
          WRITE(GRPRSM,1404)
          DO 296 JLOOP = 1, KSEC1(46)
            VALUE = REAL(KSEC1(46+JLOOP))/REAL(KSEC1(45))
            IF( KSEC1(44).EQ.JLOOP ) THEN
              WRITE(GRPRSM,1405) JLOOP, VALUE
            ELSE
              WRITE(GRPRSM,1406) JLOOP, VALUE
            ENDIF
  296     CONTINUE
          GOTO 900
        ENDIF
C
C       ECMWF Local definition 15.
C       (Ocean ensemble seasonal forecast)
C
        IF (KSEC1(37).EQ.15) THEN
          WRITE(GRPRSM,1501) KSEC1(42)
          WRITE(GRPRSM,1504) KSEC1(43)
          WRITE(GRPRSM,1502) KSEC1(44)
          WRITE(GRPRSM,1503) KSEC1(45)
          GOTO 900
        ENDIF
C
C       ECMWF Local definition 16.
C       (Seasonal forecast monthly mean atmosphere data)
C
        IF (KSEC1(37).EQ.16) THEN
          WRITE(GRPRSM,1501) KSEC1(42)
          WRITE(GRPRSM,1502) KSEC1(44)
          WRITE(GRPRSM,1503) KSEC1(45)
          WRITE(GRPRSM,1601) KSEC1(46)
          WRITE(GRPRSM,1602) KSEC1(47)
          WRITE(GRPRSM,1603) KSEC1(48)
          GOTO 900
        ENDIF
C
C       ECMWF Local definition 17.
C       (Sst or sea-ice used by analysis)
C
        IF (KSEC1(37).EQ.17) THEN
C
          IYEAR = KSEC1(44)
          IF( IYEAR.GT.100 ) THEN
            IF( IYEAR.LT.19000000 ) IYEAR = IYEAR + 19000000
            WRITE(GRPRSM,1701) IYEAR
          ELSE
            WRITE(GRPRSM,*)
     X        'Date of sst/ice field used           Not given'
          ENDIF
          IF(KSEC1(45).EQ.0) WRITE(GRPRSM,1702) KSEC1(45)
          IF(KSEC1(45).EQ.1) WRITE(GRPRSM,1703) KSEC1(45)
          IF(KSEC1(45).EQ.2) WRITE(GRPRSM,1704) KSEC1(45)
C
          WRITE(GRPRSM,1705) KSEC1(46)
C
          DO JLOOP = 1, KSEC1(46)
            IYEAR = KSEC1(45+(JLOOP*2))
            IF( IYEAR.GT.100 ) THEN
              IF( IYEAR.LT.19000000 ) IYEAR = IYEAR + 19000000
              WRITE(GRPRSM,1706) JLOOP, IYEAR
              WRITE(GRPRSM,1707) JLOOP, KSEC1(46+(JLOOP*2))
            ELSE
              WRITE(GRPRSM,*)
     X          'Date of sst/ice field used           Not given'
            ENDIF
C
          ENDDO
          GOTO 900
C
        ENDIF
C
C       ECMWF Local definition 18.
C       (Multi-analysis ensemble data)
C
        IF (KSEC1(37).EQ.18) THEN
          WRITE(GRPRSM,1801) KSEC1(42)
          WRITE(GRPRSM,1802) KSEC1(43)
          WRITE(GRPRSM,1803) KSEC1(44)
          WRITE(HVERSION, '(A8)' ) KSEC1(45)
          WRITE(GRPRSM,1804)
#ifdef LITTLE_ENDIAN
     X      HVERSION(8:8),
     X      HVERSION(7:7),
     X      HVERSION(6:6),
     X      HVERSION(5:5)
#else
     X      HVERSION(5:5),
     X      HVERSION(6:6),
     X      HVERSION(7:7),
     X      HVERSION(8:8)
#endif
          WRITE(GRPRSM,1805) KSEC1(46)
          WRITE(GRPRSM,*) '  WMO centre analyses used:'
          WRITE(GRPRSM,*) '  ------------------------'
          DO JLOOP = 1, KSEC1(46)
            WRITE(HVERSION, '(A8)' ) KSEC1(46+JLOOP)
            WRITE(GRPRSM,1806)
#ifdef LITTLE_ENDIAN
     X      HVERSION(8:8),
     X      HVERSION(7:7),
     X      HVERSION(6:6),
     X      HVERSION(5:5)
#else
     X      HVERSION(5:5),
     X      HVERSION(6:6),
     X      HVERSION(7:7),
     X      HVERSION(8:8)
#endif
          ENDDO
          GOTO 900
        ENDIF
C
C       ECMWF Local definition 19.
C       (Extreme forecast index)
C
        IF (KSEC1(37).EQ.19) THEN
          WRITE(GRPRSM,1901) KSEC1(42)
          WRITE(GRPRSM,1902) KSEC1(43)
          WRITE(GRPRSM,1903) KSEC1(44)
          WRITE(GRPRSM,1904) KSEC1(45)
          WRITE(GRPRSM,1905) KSEC1(46)
          WRITE(GRPRSM,1906) KSEC1(47)
          WRITE(GRPRSM,1907) KSEC1(48)
          WRITE(GRPRSM,1908) KSEC1(49)
          WRITE(GRPRSM,1909) KSEC1(50)
          GOTO 900
        ENDIF
C
C       ECMWF Local definition 20.
C       (4D variational increments)
C
        IF (KSEC1(37).EQ.20) THEN
          WRITE(GRPRSM,2001) KSEC1(42)
          WRITE(GRPRSM,2002) KSEC1(43)
          GOTO 900
        ENDIF
C
C       ECMWF Local definition 21.
C       (Sensitive area predictions)
C
        IF (KSEC1(37).EQ.21) THEN
          WRITE(GRPRSM,2101) KSEC1(42)
          WRITE(GRPRSM,2102) KSEC1(43)
          WRITE(GRPRSM,2103) KSEC1(44)
          WRITE(GRPRSM,2104) KSEC1(45)
          WRITE(GRPRSM,2105) KSEC1(46)
          WRITE(GRPRSM,2106) KSEC1(47)
          WRITE(GRPRSM,2107) KSEC1(48)
          WRITE(GRPRSM,2108) KSEC1(49)
          WRITE(GRPRSM,2109) KSEC1(50)
          WRITE(GRPRSM,2110) KSEC1(51)
          WRITE(GRPRSM,2111) KSEC1(52)
          WRITE(GRPRSM,2112) KSEC1(53)
          WRITE(GRPRSM,2113) KSEC1(54)
          WRITE(GRPRSM,2114) KSEC1(55)
          WRITE(GRPRSM,2115) KSEC1(56)
          WRITE(GRPRSM,2116) KSEC1(57)
          WRITE(HVERSION, '(A8)' ) KSEC1(58)
#ifdef LITTLE_ENDIAN
          WRITE(GRPRSM,2117) HVERSION(5:5)
#else
          WRITE(GRPRSM,2117) HVERSION(8:8)
#endif
          WRITE(GRPRSM,2118) KSEC1(59)
          WRITE(GRPRSM,2119) KSEC1(60)
          WRITE(GRPRSM,2120) KSEC1(61)
          GOTO 900
        ENDIF
C
C       ECMWF Local definition 22.
C       (Couple atmospheric, wave and ocean models)
C
        IF (KSEC1(37).EQ.22) THEN
          WRITE(GRPRSM,1501) KSEC1(42)
          WRITE(GRPRSM,1504) KSEC1(43)
          WRITE(GRPRSM,1502) KSEC1(44)
          WRITE(GRPRSM,1503) KSEC1(45)
          WRITE(GRPRSM,2201) KSEC1(46)
          WRITE(GRPRSM,2202) KSEC1(47)
          WRITE(GRPRSM,2203) KSEC1(48)
          GOTO 900
        ENDIF
C
C       ECMWF Local definition 23.
C       (Couple atmospheric, wave and ocean means)
C
        IF (KSEC1(37).EQ.23) THEN
          WRITE(GRPRSM,1501) KSEC1(42)
          WRITE(GRPRSM,1504) KSEC1(43)
          WRITE(GRPRSM,1502) KSEC1(44)
          WRITE(GRPRSM,1503) KSEC1(45)
          WRITE(GRPRSM,1601) KSEC1(46)
          WRITE(GRPRSM,1602) KSEC1(47)
          WRITE(GRPRSM,1603) KSEC1(48)
          WRITE(GRPRSM,2201) KSEC1(49)
          WRITE(GRPRSM,2202) KSEC1(50)
          WRITE(GRPRSM,2203) KSEC1(51)
          WRITE(GRPRSM,9502) KSEC1(52)
          WRITE(GRPRSM,9503) KSEC1(53)
          IF ( KSEC1(53) .NE. 2 ) WRITE(GRPRSM,9504) KSEC1(54)
          IF ( KSEC1(53) .NE. 1 ) WRITE(GRPRSM,9505) KSEC1(55)
C
          GOTO 900
        ENDIF
C
C       ECMWF Local definition 24.
C       (Couple atmospheric, wave and ocean means)
C
        IF (KSEC1(37).EQ.24) THEN
          WRITE(GRPRSM,2401) KSEC1(42)
          WRITE(GRPRSM,2402) KSEC1(43)
          WRITE(GRPRSM,2403) KSEC1(44)
          WRITE(GRPRSM,2404) KSEC1(45)
          GOTO 900
C
C       ECMWF Local definition 25.
C       (Couple atmospheric, wave and ocean means)
C
        IF (KSEC1(37).EQ.25) THEN
          WRITE(GRPRSM,2501) KSEC1(42)
          WRITE(GRPRSM,2502) KSEC1(43)
          WRITE(GRPRSM,2503) KSEC1(44)
        ENDIF
C
        ENDIF
C
C       ECMWF Local definition 50.
C       (Member State data)
C
        IF (KSEC1(37).EQ.50) THEN
          WRITE(GRPRSM,5001) KSEC1(42)
          WRITE(GRPRSM,5002) KSEC1(43)
          WRITE(GRPRSM,5003) KSEC1(44)
          WRITE(GRPRSM,5004) KSEC1(45)
          WRITE(GRPRSM,5005) KSEC1(46)
          WRITE(GRPRSM,5006) KSEC1(47)
          WRITE(GRPRSM,5007) KSEC1(48)
          WRITE(GRPRSM,*) '  ECMWF additions'
          WRITE(GRPRSM,*) '  ---------------'
          WRITE(GRPRSM,5008) KSEC1(49)
          WRITE(GRPRSM,5009) KSEC1(50)
          WRITE(GRPRSM,5010) (KSEC1(JLOOP),JLOOP=51,60)
          WRITE(GRPRSM,*) '  Optional data'
          WRITE(GRPRSM,*) '  -------------'
          WRITE(GRPRSM,5010) (KSEC1(JLOOP),JLOOP=61,106)
          GOTO 900
        ENDIF
C
C       ECMWF Local definition 191.
C       (Free format data descriptor)
C
        IF (KSEC1(37).EQ.191) THEN
          WRITE(GRPRSM,19101) KSEC1(44)
          WRITE(GRPRSM,19102) KSEC1(45)
          WRITE(GRPRSM,19103) KSEC1(46)
          WRITE(GRPRSM,19108) KSEC1(51)
          WRITE(GRPRSM,*) '  Data descriptor bytes'
          WRITE(GRPRSM,*) '  ---------------------'
          DO JLOOP = 52, (51+(KSEC1(51)+JPBYTES-1)/JPBYTES)
            WRITE(GRPRSM,19109) KSEC1(JLOOP)
          ENDDO
          GOTO 900
        ENDIF
C
C       ECMWF Local definition not in above selection
C       (eg defined using templates)
C
Cjdc    CALL LDEFPRT(GRPRSM,KSEC1)
C
C     -----------------------------------------------------------------|
C*    Section 9 . Format statements. Return to calling routine.
C     -----------------------------------------------------------------|
C
  900 CONTINUE
C
      RETURN
C
 9000 FORMAT(' ')
 9001 FORMAT(' Section 1 - Product Definition Section.')
 9002 FORMAT(' ---------------------------------------')
 9100 FORMAT(' Code Table 2 Version Number.         ',I9)
 9101 FORMAT(' Originating centre identifier.       ',I9)
 9102 FORMAT(' Model identification.                ',I9)
 9103 FORMAT(' Grid definition.                     ',I9)
 9104 FORMAT(' Flag (Code Table 1)                   ',I8.8)
 9105 FORMAT(' Parameter identifier (Code Table 2). ',I9)
 9106 FORMAT(' Type of level (Code Table 3).        ',I9)
 9107 FORMAT(' Value 1 of level (Code Table 3).     ',I9)
 9108 FORMAT(' Value 2 of level (Code Table 3).     ',I9)
 9109 FORMAT(' Year of reference time of data.      ',I9,'  (',I4,')' )
 9110 FORMAT(' Month of reference time of data.     ',I9)
 9111 FORMAT(' Day of reference time of data.       ',I9)
 9112 FORMAT(' Hour of reference time of data.      ',I9)
 9113 FORMAT(' Minute of reference time of data.    ',I9)
 9114 FORMAT(' Time unit (Code Table 4).            ',I9)
 9115 FORMAT(' Time range one.                      ',I9)
 9116 FORMAT(' Time range two.                      ',I9)
 9117 FORMAT(' Time range indicator (Code Table 5)  ',I9)
 9118 FORMAT(' Number averaged.                     ',I9)
 9119 FORMAT(' Number missing from average.         ',I9)
 9120 FORMAT(' Century of reference time of data.   ',I9)
 9121 FORMAT(' Units decimal scaling factor.        ',I9)
 9122 FORMAT(' Century of reference time of data.   Not given')
 9123 FORMAT(' Sub-centre identifier.               ',I9)
 9206 FORMAT(' Satellite identifier.                ',I9)
 9207 FORMAT(' Spectral band.                       ',I9)
C
 9301 FORMAT(' ECMWF local usage identifier.        ',I9)
 9302 FORMAT(' Class.                               ',I9)
 9303 FORMAT(' Type.                                ',I9)
 9304 FORMAT(' Stream.                              ',I9)
 9305 FORMAT(' Version number or Experiment identifier.  ',A1,A1,A1,A1)
 9306 FORMAT(' Satellite spectral band.             ',I9)
 9307 FORMAT(' Function code.                       ',I9)
 9308 FORMAT(' Simulation number.                   ',I9)
 9309 FORMAT(' Total number of simulations.         ',I9)
 9310 FORMAT(' Forecast number.                     ',I9)
 9311 FORMAT(' Total number of forecasts.           ',I9)
 9312 FORMAT(' Cluster number.                      ',I9)
 9313 FORMAT(' Total number of clusters.            ',I9)
 9314 FORMAT(' Clustering method.                   ',I9)
 9315 FORMAT(' Start time step when clustering.     ',I9)
 9316 FORMAT(' End time step when clustering.       ',I9)
 9317 FORMAT(' Northern latitude of domain.         ',I9)
 9318 FORMAT(' Western longitude of domain.         ',I9)
 9319 FORMAT(' Southern latitude of domain.         ',I9)
 9320 FORMAT(' Eastern longitude of domain.         ',I9)
 9321 FORMAT(' Operational forecast in cluster      ',I9)
 9322 FORMAT(' Number of forecasts in cluster.      ',I9)
 9323 FORMAT(' Forecast number                      ',I9)
 9324 FORMAT(' Control forecast in cluster          ',I9)
C
C       ECMWF Local definition 4.
C
 9401 FORMAT(' System number.                       ',I9)
 9402 FORMAT(' Method number.                       ',I9)
 9403 FORMAT(' Space unit flag.                     ',I9)
 9404 FORMAT(' Vertical coordinate definition.      ',I9)
 9405 FORMAT(' Horizontal coordinate definition.    ',I9)
 9406 FORMAT(' Time unit flag.                      ',I9)
 9407 FORMAT(' Time coordinate definition.          ',I9)
 9408 FORMAT(' Method used for analysis or forecast.',I9)
C
 9411 FORMAT(' Mixed coordinate field flag.         ',I9)
 9412 FORMAT(' Coordinate 1 flag.                   ',I9)
 9413 FORMAT(' Averaging flag.                      ',I9)
 9414 FORMAT(' Position of level 1.                 ',I9)
 9415 FORMAT(' Position of level 2.                 ',I9)
 9416 FORMAT(' Coordinate 2 flag.                   ',I9)
C
 9421 FORMAT(' Coordinate 3 flag (x-axis)           ',I9)
 9422 FORMAT(' Coordinate 4 flag (y-axis)           ',I9)
 9423 FORMAT(' Coordinate 4 of first grid point.   ',I10)
 9424 FORMAT(' Coordinate 3 of first grid point.   ',I10)
 9425 FORMAT(' Coordinate 4 of last grid point.    ',I10)
 9426 FORMAT(' Coordinate 3 of last grid point.    ',I10)
 9427 FORMAT(' i - increment.                       ',I9)
 9428 FORMAT(' j - increment.                       ',I9)
 9429 FORMAT(' Flag for irregular grid coordinates. ',I9)
 9430 FORMAT(' Flag for normal or staggered grids.  ',I9)
C
 9441 FORMAT(' Further information flag.            ',I9)
C
 9451 FORMAT(' No. entries in horizontal coordinate ',I9)
 9452 FORMAT(' No. entries in mixed coordinate defn.',I9)
 9453 FORMAT(' No. entries in grid coordinate list. ',I9)
 9454 FORMAT(' No. entries in auxiliary array.      ',I9)
C
 9461 FORMAT('  ',I12)
 9462 FORMAT(' Reference date                       ',I9)
 9463 FORMAT(' Climate date - from                  ',I9)
 9464 FORMAT(' Climate date - to                    ',I9)
C
C       ECMWF Local definition 5.
C
 9500 FORMAT(' Forecast probability number          ',I9)
 9501 FORMAT(' Total number of forecast probabilities ',I7)
 9502 FORMAT(' Threshold units decimal scale factor ',I9)
 9503 FORMAT(' Threshold indicator(1=lower,2=upper,3=both) ',I2)
 9504 FORMAT(' Lower threshold value                ',I9)
 9505 FORMAT(' Upper threshold value                ',I9)
C
C       ECMWF Local definition 6.
C
 9601 FORMAT(' Date of SST field used               ',I9)
 9602 FORMAT(' Type of SST field (= climatology)    ',I9)
 9603 FORMAT(' Type of SST field (= 1/1 degree)     ',I9)
 9604 FORMAT(' Type of SST field (= 2/2 degree)     ',I9)
 9605 FORMAT(' Number of ICE fields used:           ',I9)
 9606 FORMAT(' Date of ICE field',I3,'                 ',I9)
 9607 FORMAT(' Satellite number (ICE field',I3,')      ',I9)
C
C       ECMWF Local definition 7.
C
 9700 FORMAT(' Forecast number                      ',I9)
 9701 FORMAT(' Iteration number                     ',I9)
 9702 FORMAT(' Total number of diagnostics          ',I9)
 9703 FORMAT(' No.interations in diag. minimisation ',I9)
 9704 FORMAT(' Domain(0=Global,1=Europe,2=N.Hem.,3=S.Hem.) ',I2)
 9705 FORMAT(' Diagnostic number                    ',I9)
C
C       ECMWF Local definition 8.
C
 9800 FORMAT(' ERA section 1 octet ',I2,'.              ',I9)
 9801 FORMAT(' Interval between reference times     ',I9)
C
C       ECMWF Local definition 9.
C
 9943 FORMAT(' Number of iterations                 ',I9)
 9944 FORMAT(' Number of singular vectors computed  ',I9)
 9945 FORMAT(' Norm used at initial time            ',I9)
 9946 FORMAT(' Norm used at final time              ',I9)
 9947 FORMAT(' Multiplication factor                ',I9)
 9948 FORMAT(' Latitude of north-west corner        ',I9)
 9949 FORMAT(' Longitude of north-west corner       ',I9)
 9950 FORMAT(' Latitude of south-east corner        ',I9)
 9951 FORMAT(' Longitude of south-east corner       ',I9)
 9952 FORMAT(' Accuracy                             ',I9)
 9953 FORMAT(' Number of singular vectors evolved   ',I9)
 9954 FORMAT(' Ritz number one                      ',I9)
 9955 FORMAT(' Ritz number two                      ',I9)
 9960 FORMAT(' Perturbed ensemble forecast number   ',I9)
 9961 FORMAT(' Initial state perturbation number    ',I9)
 9962 FORMAT(' Singular vector number               ',I9)
C
C       ECMWF Local definition 10.
C
 1001 FORMAT(' Tube number                          ',I9)
 1002 FORMAT(' Total number of tubes                ',I9)
 1003 FORMAT(' Central cluster definition           ',I9)
 1004 FORMAT(' Parameter                            ',I9)
 1005 FORMAT(' Type of level                        ',I9)
 1006 FORMAT(' Northern latitude of domain of tubing',I9)
 1007 FORMAT(' Western longitude of domain of tubing',I9)
 1008 FORMAT(' Southern latitude of domain of tubing',I9)
 1009 FORMAT(' Eastern longitude of domain of tubing',I9)
 1010 FORMAT(' Tube number of operational forecast  ',I9)
 1011 FORMAT(' Tube number of control forecast      ',I9)
 1012 FORMAT(' Height/pressure of level             ',I9)
 1013 FORMAT(' Reference step                       ',I9)
 1014 FORMAT(' Radius of central cluster            ',I9)
 1015 FORMAT(' Ensemble standard deviation          ',I9)
 1016 FORMAT(' Dist.of tube extreme to ensemble mean',I9)
 1017 FORMAT(' Number of forecasts in the tube      ',I9)
 1018 FORMAT(' List of ensemble forecast numbers:')
 1019 FORMAT('    ',I9)
C
C       ECMWF Local definition 11.
C
 1101 FORMAT(' Details of analysis which used the supplementary data:')
 1103 FORMAT('   Class                              ',I9)
 1104 FORMAT('   Type                               ',I9)
 1105 FORMAT('   Stream                             ',I9)
 1106 FORMAT('   Version number/experiment identifier:   ',A1,A1,A1,A1)
 1107 FORMAT('   Year                               ',I9,'  (',I4,')')
 1108 FORMAT('   Month                              ',I9)
 1109 FORMAT('   Day                                ',I9)
 1110 FORMAT('   Hour                               ',I9)
 1111 FORMAT('   Minute                             ',I9)
 1112 FORMAT('   Century                            ',I9)
 1113 FORMAT('   Originating centre                 ',I9)
 1114 FORMAT('   Sub-centre                         ',I9)
C
C       ECMWF Local definition 12.
C
 1201 FORMAT(' (Mean, average, etc)')
 1203 FORMAT(' Start date of the period              ', I8)
 1204 FORMAT(' Start time of the period                  ', I4.4)
 1205 FORMAT(' Finish date of the period             ', I8)
 1206 FORMAT(' Finish time of the period                 ', I4.4)
 1207 FORMAT(' Verifying date of the period          ', I8)
 1208 FORMAT(' Verifying time of the period              ', I4.4)
 1209 FORMAT(' Code showing method                   ', I8)
 1210 FORMAT(' Number of different time intervals used  ', I5)
 1211 FORMAT(' List of different time intervals used:')
 1212 FORMAT('  - interval ',I5.4, ' used       once')
 1213 FORMAT('  - interval ',I5.4, ' used       twice')
 1214 FORMAT('  - interval ',I5.4, ' used ', I5, ' times')

C
C       ECMWF Local definition 13.
C
 1301 FORMAT(' Direction number                     ',I9)
 1302 FORMAT(' Frequency number                     ',I9)
 1303 FORMAT(' Total number of directions           ',I9)
 1304 FORMAT(' Total number of frequencies          ',I9)
 1305 FORMAT(' Scale factor applied to directions   ',I9)
 1306 FORMAT(' Scale factor applied to frequencies  ',I9)
 1307 FORMAT(' List of directions:')
 1308 FORMAT(' ', I2.2,':', F15.7, '   <-- this field value')
 1309 FORMAT(' ', I2.2,':', F15.7)
 1310 FORMAT(' List of frequencies:')
 1311 FORMAT(' System number (65535 = missing)      ',I9)
 1312 FORMAT(' Method number (65535 = missing)      ',I9)
 1313 FORMAT(' Reference date                       ',I9)
 1314 FORMAT(' Climate date (from)                  ',I9)
 1315 FORMAT(' Climate date (to)                    ',I9)
C
C       ECMWF Local definition 14.
C
 1401 FORMAT(' Channel number                       ',I9)
 1402 FORMAT(' Scale factor applied to frequencies  ',I9)
 1403 FORMAT(' Total number of frequencies          ',I9)
 1404 FORMAT(' List of frequencies:')
 1405 FORMAT(' ', I3,':', F15.9, '   <-- this channel')
 1406 FORMAT(' ', I3,':', F15.9)
C
C       ECMWF Local definition 15.
C
 1501 FORMAT(' Ensemble member number               ',I9)
 1502 FORMAT(' System number                        ',I9)
 1503 FORMAT(' Method number                        ',I9)
 1504 FORMAT(' Total number of ensembles            ',I9)
C
C       ECMWF Local definition 16.
C
 1601 FORMAT(' Verifying month                      ',I9)
 1602 FORMAT(' Averaging period                     ',I9)
 1603 FORMAT(' Forecast month (0 = not present)     ',I9)
C
C       ECMWF Local definition 17.
C
 1701 FORMAT(' Date of sst/ice field used           ',I9)
 1702 FORMAT(' Type of sst/ice field (= climatology)',I9)
 1703 FORMAT(' Type of sst/ice field (= 1/1 degree) ',I9)
 1704 FORMAT(' Type of sst/ice field (= 2/2 degree) ',I9)
 1705 FORMAT(' Number of ICE fields used:           ',I9)
 1706 FORMAT(' Date of ICE field',I3,'                 ',I9)
 1707 FORMAT(' Satellite number (ICE field',I3,')      ',I9)
C
C       ECMWF Local definition 18.
C
 1801 FORMAT(' Ensemble forecast number             ',I9)
 1802 FORMAT(' Number of forecasts in ensemble      ',I9)
 1803 FORMAT(' Data origin                          ',I9)
 1804 FORMAT(' Model identifier of forecast used         ',A1,A1,A1,A1)
 1805 FORMAT(' Number of analyses in start analysis ',I9)
 1806 FORMAT('   ',A1,A1,A1,A1)
C
C       ECMWF Local definition 19.
C
 1901 FORMAT(' Zero, for Mars compatibility         ',I9)
 1902 FORMAT(' Ensemble size                        ',I9)
 1903 FORMAT(' Power of 10 used to scale weight (F) ',I9)
 1904 FORMAT(' Weight*10**F applied to climate month 1',I7)
 1905 FORMAT(' First month used for climate month 1 ',I9)
 1906 FORMAT(' Last month used for climate month 1  ',I9)
 1907 FORMAT(' First month used for climate month 2 ',I9)
 1908 FORMAT(' Last month used for climate month 2  ',I9)
 1909 FORMAT(' EFI order                            ',I9)
C
C       ECMWF Local definition 20.
C
 2001 FORMAT(' Iteration                            ',I9)
 2002 FORMAT(' Total number of iterations           ',I9)
C
C       ECMWF Local definition 21.
C
 2101 FORMAT(' Forecast/sing.vector/flight number   ',I9)
 2102 FORMAT(' Number of iterations                 ',I9)
 2103 FORMAT(' Number of singular vectors computed  ',I9)
 2104 FORMAT(' Norm used at initial time            ',I9)
 2105 FORMAT(' Norm used at final time              ',I9)
 2106 FORMAT(' Lat-lon multiplication factor        ',I9)
 2107 FORMAT(' Area north-west latitude             ',I9)
 2108 FORMAT(' Area north-west longitude            ',I9)
 2109 FORMAT(' Area south-east latitude             ',I9)
 2110 FORMAT(' Area south-east longitude            ',I9)
 2111 FORMAT(' Accuracy                             ',I9)
 2112 FORMAT(' Number of singular vectors evolved   ',I9)
 2113 FORMAT(' Ritz number 1                        ',I9)
 2114 FORMAT(' Ritz number 2                        ',I9)
 2115 FORMAT(' Observation offset period            ',I9)
 2116 FORMAT(' Forecast lead time                   ',I9)
 2117 FORMAT(' Domain                                       ',A1)
 2118 FORMAT(' Method number                        ',I9)
 2119 FORMAT(' Total forecasts in ensemble          ',I9)
 2120 FORMAT(' Shape of verification region (flag)  ',I9)
C
C       ECMWF Local definition 22 and 23.
C
 2201 FORMAT(' Reference date                       ',I9)
 2202 FORMAT(' Climate date (from)                  ',I9)
 2203 FORMAT(' Climate date (to)                    ',I9)
C
C       ECMWF Local definition 24
C
 2401 FORMAT(' Satellite identifier  (WMO table C-5)',I9)
 2402 FORMAT(' Instrument identifier (WMO table C-8)',I9)
 2403 FORMAT(' Channel number                       ',I9)
 2404 FORMAT(' Function code                        ',I9)
C
C       ECMWF Local definition 25
C
 2501 FORMAT(' Component index                      ',I9)
 2502 FORMAT(' Number of components                 ',I9)
 2503 FORMAT(' Model error type                     ',I9)
C
C       ECMWF Local definition 50.
C
 5001 FORMAT(' Number                               ',I9)
 5002 FORMAT(' Total                                ',I9)
 5003 FORMAT(' Model identifier                     ',I9)
 5004 FORMAT(' Latitude of NW corner (degrees*10^6) ',I9)
 5005 FORMAT(' Longitude of NW corner(degrees*10^6) ',I9)
 5006 FORMAT(' Latitude of SE corner (degrees*10^6) ',I9)
 5007 FORMAT(' Longitude of SE corner(degrees*10^6) ',I9)
 5008 FORMAT(' Original parameter number            ',I9)
 5009 FORMAT(' Original parameter table number      ',I9)
 5010 FORMAT(10(1X,Z8.8))
C
C       ECMWF Local definition 190.
C
19001 FORMAT(' Number of ECMWF local definitions    ',I9)
19002 FORMAT(' ECMWF local definition number        ',I9)
19003 FORMAT(' Number of bytes in local definition  ',I9)
#ifdef INTEGER_8
19004 FORMAT(3X,Z16.16)
#else
19004 FORMAT(3X,Z8.8)
#endif
C
C       ECMWF Local definition 191.
C
19101 FORMAT(' Format version major number          ',I9)
19102 FORMAT(' Format version minor number          ',I9)
19103 FORMAT(' Original sub-centre identifier       ',I9)
19108 FORMAT(' Number of bytes of data descriptor   ',I9)
#ifdef INTEGER_8
19109 FORMAT(3X,Z16.16)
#else
19109 FORMAT(3X,Z8.8)
#endif
C
      END

C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE CREXSEL(KTDLEN,KTDLST,KTDEXL,KTDEXP,KERR)
C
C**** *CREXSEL*
C
C
C
C     PURPOSE.
C     --------
C          Returns list of Data Descriptors as in Section 1  of Crex
C          message and total/requested list of elements.
C
C
C**   INTERFACE.
C     ----------
C
C          *CALL* *CREXSEL(KTDLEN,KTDLST,KTDEXL,KTDEXP,KERR)*
C
C
C        OUTPUT:
C               *KTDLEN*  -  number of data descriptors in section 1
C               *KTDLST*  -  array containing data descriptors in section 1
C               *KTDEXL*  -  number of entries in list of expanded data
C                            descriptors
C               *KTDEXP*  -  array containig expanded data descriptors
C               *KERR*    -  returned error code
C
C
C     METHOD.
C     -------
C
C          NONE.
C
C     EXTERNALS.
C     ----------
C
C          NONE.
C
C     REFERENCE.
C     ----------
C
C          NONE.
C
C     AUTHOR.
C     -------
C
C          MILAN DRAGOSAVAC    *ECMWF*       07/01/2004.
C
C
C     MODIFICATIONS.
C     --------------
C
C          NONE.
C
C
      IMPLICIT LOGICAL(L,O,G), CHARACTER*8(C,H,Y)
C
C
      PARAMETER(JSUP =   9,JSEC0=   3,JSEC1= 40,JSEC2= 64 ,JSEC3=    4,
     1          JSEC4=   2,JELEM=40000,JSUBS=400,JCVAL=150 ,JBUFL=40000,
     2          JBPW =  32,JTAB =3000,JCTAB=120,JCTST=1800,JCTEXT= 200,
     3          JWORK=360000,JKEY=46)
C
C
      COMMON /CREXEL/ NCREXTDLEN,NCREXTDLST(JELEM),NCREXTDEXL,
     1                NCREXTDEXP(JELEM)
C
C             NCREXTDLEN - number of Data descriptors in section 1
C             NCREXTDLST - list of Data descriptors
C             NCREXTDEXL - number of expanded Data Descriptors
C             NCREXTDEXP - list of expanded Data descriptors
C
C
      DIMENSION  KTDLST(*),KTDEXP(*)
C
C
C     -----------------------------------------------------------------

C*          1.  PUT LIST OF ELEMENTS FROM COMMON BLOCK
C               --------------------------------------
C               TO REQUESTED ARRAYS.
C               --------------------
 100  CONTINUE
C
      KERR=0
C
      KTDLEN=NCREXTDLEN
      KTDEXL=NCREXTDEXL
C
      DO 101 I=1,NCREXTDLEN
      KTDLST(I)=NCREXTDLST(I)
 101  CONTINUE
C
      DO 102 I=1,NCREXTDEXL
      KTDEXP(I)=NCREXTDEXP(I)
 102  CONTINUE
C
      RETURN
      END

C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE JAGGGP( PSHUP, KTRUNC, PNORTH, PSOUTH, PWEST, PEAST,
     X                    KNUM, HTYPE, KPTS, POUTF, LUV, KRET)
C
C---->
C**** JAGGGP
C
C     PURPOSE
C     _______
C
C     This routine converts spectral input fields to a gaussian
C     grid field.
C
C     INTERFACE
C     _________
C
C     CALL JAGGGP( PSHUP, KTRUNC, PNORTH, PSOUTH, PWEST, PEAST,
C    X                    KNUM, HTYPE, KPTS, POUTF, LUV, KRET)
C
C     Input parameters
C     ________________
C
C     PSHUP    - Spherical harmonics field, unpacked
C     KTRUNC   - Truncation number of spherical harmonics field
C     PNORTH   - Northernmost latitude for output field (degrees)
C     PSOUTH   - Southernmost latitude for output field (degrees)
C     PWEST    - Westernmost longitude for output field (degrees)
C     PEAST    - Easternmost longitude for output field (degrees)
C     KNUM     - Gaussian grid number
C     HTYPE    - Gaussian grid type
C                = 'R' for reduced, 
C                = 'F' for full
C                = 'U' for user-defined reduced gaussian grid
C     KPTS     - Array specifying number of points at each line of
C                latitude if HTYPE = 'U'.
C                (Must be big enough for both hemispheres, but only
C                 needs to give Northern hemisphere values from pole
C                 to latitude nearest the Equator.)
C     LUV      - Code indicating whether or not the field is a wind
C                component field;
C                = 1 if U or V field.
C
C     Output parameters
C     ________________
C
C     KPTS     - Array specifying number of points at each line of
C                latitude; user defined values if HTYPE = 'U'.
C                (Must be big enough for both hemispheres)
C     POUTF    - Output grid point field
C     KRET     - Return status code
C                0 = OK
C
C     Common block usage
C     __________________
C
C     JDCNDBG, JDCFLAGS
C
C     Method
C     ______
C
C     None.
C
C
C     Externals
C     _________
C
C     JGETGG   - Pick up the definition of the gaussian grid.
C     JOPNGG   - Opens the legendre functions file for reading line
C                by line.
C     JOPNGGF  - Opens the legendre functions file and reads the whole
C                of it into dynamically allocated memory.
C     JOPNGGSM - Opens the legendre functions file and memory maps it.
C     JJSET99  - Sets up FFT
C     JNORSGG  - Determines which latitude row in a gaussian grid is
C                north or south of a given latitude
C     JSYMGG   - Generate symmetric grid from spherical harmonics 
C     JWSCAL   - Apply latitude correction to wind component field
C     JMVUGG   - Moves grid point data to output array
C     JMKOFGG  - Builds offsets into storage array
C     JDEBUG   - Checks environment variable to switch on/off debug
C     INTLOG   - Logs output messages
C     INTLOGR  - Logs output messages
C     GETCONF  - Decides how to handle legendre coefficients
C     GETENV   - Get value of an environment variable
#ifdef SHAREDMEMORY
C     SMREAD   - Gets interpolation coefficients in a shared memory array
#endif
C
C
C     Reference
C     _________
C
C     None
C
C
C     Comments
C     ________
C
C     It handles transformations to a gaussian grid.
C
C
C     AUTHOR
C     ______
C
C     J.D.Chambers      *ECMWF*      Jan 1994
C
C     MODIFICATIONS
C     _____________
C
C
C     J.D.Chambers     ECMWF        Feb 1997
C     Allow for 64-bit pointers
C
C----<
C     _______________________________________________________
C
C
      IMPLICIT NONE
#include "jparams.h"
#include "parim.h"
#include "current.h"
#include "nifld.common"
#include "nofld.common"
#include "grfixed.h"
C
C     Subroutine arguments
C
      COMPLEX   PSHUP
      DIMENSION PSHUP(*)
      INTEGER   KTRUNC, KNUM, KPTS, KRET
      DIMENSION KPTS(*)
      CHARACTER*1 HTYPE
      REAL      PNORTH, PSOUTH, PWEST, PEAST
      REAL      POUTF
      DIMENSION POUTF(*)
      INTEGER   LUV
C
C     Parameters
C
      INTEGER JPROUTINE
      PARAMETER ( JPROUTINE = 31600 )
C
C     Local variables
C
      INTEGER ILON, ITOUP1, IJPWR, NUMPTS, ITYPE
      DIMENSION IJPWR(JPMAX)
      INTEGER ILUNIT
      INTEGER NXTROW
      REAL RINTVL, GNUM
C
      INTEGER IMFAX
      REAL ATRIGS
      DIMENSION IMFAX(10),ATRIGS(JPLONO*2)
#ifndef _CRAYFTN
#ifdef POINTER_64
      INTEGER*8 IALEG, IZFA
#endif
#endif
      REAL ALEG
      DIMENSION ALEG(1)
      POINTER ( IALEG, ALEG )
      REAL ZFA
      DIMENSION ZFA(1)
      POINTER ( IZFA, ZFA )
      INTEGER ISIZE
      DATA ISIZE/0/
      SAVE ISIZE, IZFA
C
      CHARACTER*10 PLAINUV
C
      CHARACTER*8 FILENAME
      DATA FILENAME/'Nxxx_DEF'/
      INTEGER NGROUP
      INTEGER FILENM, J108, NNORTH, NSOUTH, NCASE, NFLAG
      INTEGER NOFSET, LOOP
      DIMENSION NOFSET(JPMAX)
      INTEGER INORTH, ISOUTH, IMAGE, NFIRST, NDIFF
      DATA FILENM/67/
      REAL ALAT
      DIMENSION ALAT(JPMAX)
C
      SAVE ILUNIT, IALEG
C
      LOGICAL LDEBUG, LFIRST, LPLAINU
      DATA LFIRST/.TRUE./, LPLAINU/.FALSE./
      SAVE LDEBUG, LFIRST, LPLAINU
      CHARACTER*20 CONFIG
      INTEGER IBLANK
C
      INTEGER  JNORSGG
      EXTERNAL JNORSGG
#ifdef SHAREDMEMORY
      INTEGER  SHAREDGG, SHAREDDT
      EXTERNAL SHAREDGG, SHAREDDT
#endif
C     _______________________________________________________
C
C*    Section 1.    Initialization.
C     _______________________________________________________
C
  100 CONTINUE
C
      CALL JDEBUG( )
      LDEBUG = NDBG.GT.0
C
C     Decide how to handle legendre coefficients
C
      CALL GETCONF()
C
      IF( LFIRST ) THEN
C
        LFIRST = .FALSE.
C
C       Check environment variable to see if wind components are plain
C       U and V, or U*cos(theta) and V*cos(theta) (the default).
C
        CALL GETENV('INTERP_PLAIN_UV', PLAINUV)
        IBLANK = INDEX(PLAINUV, ' ')
C
        IF( (IBLANK.EQ.3).AND.(PLAINUV(1:2).EQ.'ON') )  LPLAINU =.TRUE.
        IF( (IBLANK.EQ.3).AND.(PLAINUV(1:2).EQ.'on') )  LPLAINU =.TRUE.
        IF( (IBLANK.EQ.4).AND.(PLAINUV(1:3).EQ.'YES') ) LPLAINU =.TRUE.
        IF( (IBLANK.EQ.4).AND.(PLAINUV(1:3).EQ.'yes') ) LPLAINU =.TRUE.
C
        IF( (IBLANK.EQ.3).AND.(PLAINUV(1:2).EQ.'NO') )  LPLAINU =.FALSE.
        IF( (IBLANK.EQ.3).AND.(PLAINUV(1:2).EQ.'no') )  LPLAINU =.FALSE.
        IF( (IBLANK.EQ.4).AND.(PLAINUV(1:3).EQ.'OFF') ) LPLAINU =.FALSE.
        IF( (IBLANK.EQ.4).AND.(PLAINUV(1:3).EQ.'off') ) LPLAINU =.FALSE.
C
C
C       First time through, dynamically allocate memory for workspace
C
        ISIZE =  (JPLONO+2)*64
        CALL JMEMHAN( 10, IZFA, ISIZE, 1, KRET)
        IF( KRET.NE.0 ) THEN
          CALL INTLOG(JP_ERROR,'JAGGGP: memory allocation error.',IZFA)
          KRET = JPROUTINE + 1
          GOTO 990
        ENDIF
      ENDIF
C
      IF( LDEBUG ) THEN
        CALL INTLOG(JP_DEBUG,'JAGGGP: Input parameters:',JPQUIET)
        CALL INTLOG(JP_DEBUG,
     X    'JAGGGP: Spherical harmonic truncation = ', KTRUNC)
        CALL INTLOGR(JP_DEBUG,
     X    'JAGGGP: Northern latitude for output = ', PNORTH)
        CALL INTLOGR(JP_DEBUG,
     X    'JAGGGP: Southern latitude for output = ', PSOUTH)
        CALL INTLOGR(JP_DEBUG,
     X    'JAGGGP: Western longitude for output = ', PWEST)
        CALL INTLOGR(JP_DEBUG,
     X    'JAGGGP: Eastern longitude for output = ', PEAST)
        CALL INTLOG(JP_DEBUG,
     X    'JAGGGP: Gaussian grid number = ', KNUM)
C
        IF( HTYPE.EQ.'R' .OR. HTYPE.EQ.'r' ) CALL INTLOG(JP_DEBUG,
     X    'JAGGGP: Grid type is Reduced.',JPQUIET)
        IF( HTYPE.EQ.'F' .OR. HTYPE.EQ.'f' ) CALL INTLOG(JP_DEBUG,
     X    'JAGGGP: Grid type is Full.',JPQUIET)
        IF( HTYPE.EQ.'U' .OR. HTYPE.EQ.'u' ) CALL INTLOG(JP_DEBUG,
     X    'JAGGGP: Grid type is User.',JPQUIET)
        CALL INTLOG(JP_DEBUG,
     X    'JAGGGP: Field code( = 1 for U or V) = ', LUV)
C
        IF ( HTYPE .EQ. 'u' .OR. HTYPE .EQ. 'U' ) THEN
          CALL INTLOG(JP_DEBUG,'JAGGGP: User-supplied values.',JPQUIET)
          CALL INTLOG(JP_DEBUG,'JAGGGP: No. pts at each line:',JPQUIET)
          DO NDBGLP = 1, 20
            CALL INTLOG(JP_DEBUG,' ',KPTS( NDBGLP ))
          ENDDO
        ENDIF
      ENDIF
C
C     Pick up the file containing the definition of the gaussian grid.
C
      IF( (NOGAUSO.NE.KNUM).OR.(HOGAUST.NE.HTYPE) ) THEN
        CALL JGETGG( KNUM, HTYPE, ALAT, KPTS, KRET)
        IF ( KRET .NE. 0 ) GOTO 990
        NOGAUSO = KNUM
        HOGAUST = HTYPE
      ELSE
        DO LOOP = 1, KNUM*2
          ALAT(LOOP) = ROGAUSS(LOOP)
          KPTS(LOOP) = NOLPTS(LOOP)
        ENDDO
      ENDIF
C
C     If coefficients are not to generated 'on the fly',
C     open the appropriate legendre function file.
C
      IF( LFILEIO ) THEN
        ISIZE = JPK
        CALL JMEMHAN( 14, IALEG, ISIZE, 1, KRET)
        IF( KRET.NE.0 ) THEN
          CALL INTLOG(JP_ERROR,'JAGGGP: memory allocate error',IALEG)
          KRET = JPROUTINE + 2
          GOTO 990
        ENDIF
        CALL JOPNGG( ALEG, KNUM, KTRUNC, ILUNIT, ALAT, KRET)
      ELSE IF( LMEMORY ) THEN
        CALL JOPNGGF( IALEG, KNUM, KTRUNC, ILUNIT, ALAT, KRET)
      ELSE IF( LMAPPED ) THEN
        CALL JOPNGGSM( IALEG, KNUM, KTRUNC, ILUNIT, ALAT, KRET)
#ifdef SHAREDMEMORY
      ELSE IF( LSHARED ) THEN
        GNUM = REAL(KNUM)
        IF( LDEBUG ) THEN
           CALL INTLOG(JP_DEBUG,'JAGGGP: call SHAREDGG', JPQUIET)
        ENDIF
C
        KRET =  SHAREDGG(IALEG,KTRUNC,KNUM)
C
        IF( KRET.NE.0 ) THEN
          CALL INTLOG(JP_ERROR,
     X      'JAGGGP: SHARED MEMORY Failed to get legendre coeff.',KRET)
	      KRET = JPROUTINE + 3
	      GOTO 990
        ENDIF
        GOTO 102
#endif
      ELSE
        ISIZE =  (KTRUNC+1)*(KTRUNC+2)
        CALL JMEMHAN( 14, IALEG, ISIZE, 1, KRET)
        IF( KRET.NE.0 ) THEN
          CALL INTLOG(JP_ERROR,'JAGGGP: memory allocate error.',IALEG)
          KRET = JPROUTINE + 2
          GOTO 990
        ENDIF
      ENDIF
C
      IF( KRET.NE.0 ) THEN
        CALL INTLOG(JP_ERROR,
     X    'JAGGGP: Failed to get legendre coefficients',KRET)
	KRET = JPROUTINE + 3
	GOTO 990
      ENDIF
C
  102 CONTINUE
C
C     Determine which latitude rows in the gaussian grid are in the 
C     requested area
C
      NNORTH = JNORSGG( PNORTH, ALAT, KNUM, 1)
      NSOUTH = JNORSGG( PSOUTH, ALAT, KNUM, 0)
      IF( LDEBUG ) THEN
        CALL INTLOG(JP_DEBUG,
     X    'JAGGGP: Gaussian latitudes in requested area:',JPQUIET)
        CALL INTLOG(JP_DEBUG,'JAGGGP: NORTH = ',NNORTH)
        CALL INTLOG(JP_DEBUG,'JAGGGP: SOUTH = ',NSOUTH)
      ENDIF
C
C
C     For calculation purposes, the number of longitude points for each
C     latitude row has to be greater than 2*(output truncation) to 
C     ensure the fourier transform is exact (see Reference, page 10). 
C
C     The following loop calculates the power of 2 to be used as a 
C     multipier for each row to ensure there are enough points.
C     Later, when filling the output array POUTF, the longitude points
C     have to be taken selectively to avoid the intermediate generated
C     points, picking up values only at the required longitudes.
C
      ITOUP1 = KTRUNC
      DO 108 J108 = 1, KNUM
	IMAGE = 2*KNUM - J108 + 1
	ILON        = KPTS(J108)
        IJPWR(J108) = 1
 104    CONTINUE
          IF(ILON .GT. 2*ITOUP1) GOTO 106
	  IJPWR(J108) = IJPWR(J108)*2
          ILON        = ILON*2
          GOTO 104
 106    CONTINUE
	IJPWR(IMAGE) = IJPWR(J108)
 108  CONTINUE
C
C     _______________________________________________________
C
C*    Section 2.    Work out geometry of the request
C     _______________________________________________________
C
 200  CONTINUE
C
C     Latitude rows are generated from row INORTH to ISOUTH.
C     Selection is carried out for actual requested rows when the 
C     calculated values are moved to the output array.
C
C     Start with assumption that the area is symmetrical about equator.
C
      NCASE  = 1
      NFLAG  = 3
      INORTH = NNORTH
      ISOUTH = KNUM
      NDIFF  = 0
C
C     Northern hemisphere only ?
C
      IF ( PSOUTH .GE. 0.0 ) THEN
        NCASE  = 2
	NFLAG  = 1
	INORTH = NNORTH
	ISOUTH = NSOUTH
        IF( LDEBUG ) CALL INTLOG(JP_DEBUG,
     X    'JAGGGP: North hemisphere only.',JPQUIET)
	GOTO 220
      ENDIF
C
C     Southern hemisphere only ?
C
      IF ( PNORTH .LE. 0.0 ) THEN
        NCASE  = 3
	NFLAG  = 2
        INORTH = 2*KNUM - NSOUTH + 1
        ISOUTH = 2*KNUM - NNORTH + 1
        IF( LDEBUG ) CALL INTLOG(JP_DEBUG,
     X    'JAGGGP: South hemisphere only.',JPQUIET)
	GOTO 220
      ENDIF
C
C     Straddles equator ...
C     ... more north than south?
C
      IF ( PNORTH .GT. -PSOUTH ) THEN
	NCASE  = 4
	INORTH = NNORTH
	ISOUTH = KNUM
        IF( LDEBUG ) THEN
          CALL INTLOG(JP_DEBUG,'JAGGGP: Straddles equator.',JPQUIET)
          CALL INTLOG(JP_DEBUG,'JAGGGP: More north than south',JPQUIET)
        ENDIF
	GOTO 220
      ENDIF
C
C     ... more south than north?
C
      IF ( PNORTH .LT. -PSOUTH ) THEN
	NCASE  = 5
	INORTH = 2*KNUM - NSOUTH + 1
	ISOUTH = KNUM
	NDIFF  = NNORTH - INORTH
        IF( LDEBUG ) THEN
          CALL INTLOG(JP_DEBUG,'JAGGGP: Straddles equator.',JPQUIET)
          CALL INTLOG(JP_DEBUG,'JAGGGP: More south than north',JPQUIET)
        ENDIF
      ENDIF
C
C     Setup the storage offset for the given latitude range
C
 220  CONTINUE
C
      IF( LDEBUG ) THEN
        CALL INTLOG(JP_DEBUG,'JAGGGP: INORTH = ', INORTH)
        CALL INTLOG(JP_DEBUG,'JAGGGP: ISOUTH = ', ISOUTH)
      ENDIF
      CALL JMKOFGG(HTYPE,NNORTH,NSOUTH,PWEST,PEAST,KNUM,KPTS,NOFSET)
C
C     _______________________________________________________
C
C*    Section 3.    Process all latitude rows
C     _______________________________________________________
C
 300  CONTINUE
C
      IF( LDEBUG ) CALL INTLOG(JP_DEBUG,
     X  'JAGGGP: Process latitude rows.',JPQUIET)
C
      NGROUP = 0
C
      DO 320 NXTROW = INORTH, ISOUTH
C
C       Build up a group of lines of the same length which can all
C       be transformed at the same time.
        NGROUP = NGROUP + 1
C
C       Initialise FFT constants for the group
C
        IF ( NGROUP .EQ. 1 ) THEN
	  NFIRST = NXTROW
	  ILON = KPTS(NFIRST) * IJPWR(NFIRST)
C
          IF( LDEBUG ) THEN
            CALL INTLOG(JP_DEBUG,
     X        'JAGGGP: Initialise FFT consts for the group.',JPQUIET)
            CALL INTLOG(JP_DEBUG,
     X        'JAGGGP: Latitude number = ', NFIRST)
            CALL INTLOG(JP_DEBUG,
     X        'JAGGGP: No. of calculated long.pts = ', ILON)
          ENDIF
C
          CALL JJSET99( ATRIGS, IMFAX, ILON, KRET)
          IF( KRET .NE. 0 ) GOTO 990
	ENDIF
C
C       If the current line is the last to be processed,
C       or the next line is not suitable for the current group,
C       or 32 lines are in the group already ...
C
        IF (     ( NXTROW .EQ. ISOUTH)
     X      .OR. ( KPTS(NFIRST) .NE. KPTS(NXTROW+1) )
     X      .OR. ( NGROUP .EQ. JP32 ) ) THEN
C
C         Calculate the points along the line of latitude
C
          IF( LDEBUG ) CALL INTLOG(JP_DEBUG,
     X      'JAGGGP: Number in group = ', NGROUP)
C
          CALL JSYMGG( PSHUP, KTRUNC, NFIRST, ILUNIT, NGROUP, ILON,
     X                 ALAT, ALEG, ATRIGS, IMFAX, ZFA, KRET)
	  IF( KRET .NE. 0 ) GOTO 990
C
C         If it is a wind component field formed from spectral Ucos(theta)
C         and Vcos(theta) (ie not just spectral U and V), apply a
C         latitude correction
C
	  IF( (LUV.EQ.1).AND.(.NOT.LPLAINU) )
     X      CALL JWSCAL(ZFA, NGROUP, ILON, NFIRST, ALAT)
C
C         Store away the generated latitudes
C
          IF( (HTYPE .EQ. 'U') .OR. (HTYPE .EQ. 'R') ) THEN
            NUMPTS = KPTS(NFIRST)
          ELSE
            RINTVL = (PEAST - PWEST)*FLOAT( KPTS(NFIRST) ) / 360.0
            NUMPTS = NINT( RINTVL ) + 1
          ENDIF
C
C         Is the area unequally distributed about the equator?
C
          IF ( NCASE .EQ. 4 .OR. NCASE .EQ. 5 ) THEN
	    CALL JMVUGG( ZFA, NNORTH, NSOUTH, PWEST, KNUM, NFIRST,
     X                   NDIFF, NGROUP, NUMPTS, ILON,
     X                   IJPWR(NFIRST), NOFSET, POUTF)
            NDIFF  = MAX( 0, (NDIFF - NGROUP) )
C
C         No, it is all in one hemisphere or is symmetrical
C         about the equator
C
	  ELSE
	    CALL JMOVGG( ZFA, PWEST, KNUM, NFIRST, NGROUP, NUMPTS,
     X  		 ILON, IJPWR(NFIRST), NOFSET, POUTF, NFLAG)
          ENDIF
C
C         Startup next group of latitudes
C
	  NGROUP = 0
        ENDIF
C
 320  CONTINUE
C
C     _______________________________________________________
C
C*    Section 9. Return to calling routine. Format statements
C     _______________________________________________________
C
 930  CONTINUE
      KRET = 0
C
 990  CONTINUE
#ifdef SHAREDMEMORY
      KRET = SHAREDDT(IALEG) 
      IF( LDEBUG ) 
     X  CALL INTLOG(JP_DEBUG,'JAGGGP: release_shared_file  = ', KRET)
      KRET = 0
#endif

C
      IF( LDEBUG ) CALL INTLOG(JP_DEBUG,'JAGGGP: Return code = ', KRET)
C
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities
C granted to it by virtue of its status as an intergovernmental organisation
C nor does it submit to any jurisdiction.
C
      SUBROUTINE BUEVAR(KERR)
C
C**** *BUEVAR*
C
C
C     PURPOSE.
C     --------
C         INITIALIZE CONSTANTS AND VARIABLES.
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *BUEVAR(KERR)*
C
C     METHOD.
C     -------
C
C          NONE.
C
C
C     EXTERNALS.
C     ----------
C
C     GETENV  - GETS VALUE OF AN ENVIRONMENT VARIABLE.
C     EMOSNUM - GIVES CURRENT EMOSLIB VERSION NUMBER.
C
C     REFERENCE.
C     ----------
C
C          NONE.
C
C     AUTHOR.
C     -------
C
C          M. DRAGOSAVAC    *ECMWF*       15/03/92.
C
C
C     MODIFICATIONS.
C     --------------
C
C          NONE.
C
C
      IMPLICIT LOGICAL(L,O,G), CHARACTER*8(C,H,Y)
C
C
#     include "parameter.F"
#     include "bcomunit.F"
#     include "bcomatb.F"
#     include "bcombef.F"
#     include "bcomwork.F"
#     include "bcomwt.F"
#     include "bcomroot.F"
#     include "bcprq.F"
#     include "bcomtabload.F"
#     include "bcomtabloadc.F"
#     include "bcomoff.F"
C
      CHARACTER*256 CROOT, HDEFAULT,CPRINT
      CHARACTER*9   STD_OUT,YKNTN, CTU
      CHARACTER*24 CTABLE_LIST,CCTABBU
      CHARACTER*64 CCTABBEN
      LOGICAL OPRINT,OS4
C
      INTEGER IEMOSNM
#ifndef R_4
      REAL*8 RVIND
      REAL*8 EPS
#else
      REAL   RVIND
      REAL   EPS
#endif
C
C     EXTERNAL FUNCTIONS
C
      INTEGER EMOSNUM
      EXTERNAL EMOSNUM

#ifdef TABLE_PATH
      DATA HDEFAULT
     & / TABLE_PATH /
#else
      DATA HDEFAULT / '' /
#endif

C
C     ------------------------------------------------------------------
C*          1.   INITIALIZE VARIABLES AND CONSTANTS.
C                -----------------------------------
 100  CONTINUE
C
      IF(KERR.GT.0) RETURN
C
      NJA= 0
      M  =0
      MM =0
      N  =0
      JCV=0
      NBPW=JBPW
      NWPT=0
      NBPT=0
      NWPTB=0
      NBPTB=0
      NSTOP=2147483647
      NVIND=2147483647
      RVIND=1.7D38
      EPS=10.D-7
      NBENP=0
      NLTVNP=0
      NWWP=0
      NXXP=0
      NYYP=0
      NZZP=0
      NTC=0
      NTT=0
      NDWINC=0
      NSCAM=0
      NSCAM07=0
      NDWINC07=0
      N07=0
      NAFDW=0
      NFD=0
      NWT=0
      ODREPF=.FALSE.
      OS4=.FALSE.
      N221=0
      N40=0
      MREL=0
      NFCM=0
      MBMP=0
      MBMPL=0
      OMARKER=.FALSE.
      CROOT=' '
      NREP=0
      OREP=.false.
      N08=0
      NSSP=0
C
C     STANDARD OUTPUT UNIT NUMBER
C
      STD_OUT=' '
      YKNTN=' '
      CALL GETENV('STD_OUT',YKNTN)
      INKNTN=INDEX(YKNTN,' ')
      IF(INKNTN.EQ.1) THEN
        KNTN=6
      ELSE
        READ(YKNTN,'(I3.3)') KNTN
      END IF
C
C     CHECK SECTION 4 SIZE
      CS4=' '
      CALL GETENV('CHECK_S4',CS4)
      ILNG=INDEX(CS4,' ')
      IF(ILNG.LE.1) THEN
         OS4=.false.
      ELSEIF(CS4(1:4).EQ.'TRUE'.or.CS4(1:4).EQ.'true') then
         OS4=.true.
      END IF
C
      CALL GETENV('USE_TABLE_C',CTU)
      ILNG=INDEX(CTU,' ')
      IF(ILNG.LE.1) THEN
         OCTABLE=.false.
      ELSEIF(CTU(1:4).eq.'true'.or.CTU.eq.'TRUE') then
         OCTABLE=.true.
      END IF
      CALL GETENV('BUFR_TABLES',CROOT)
      ILNG=INDEX(CROOT,' ')
      IF(ILNG.LE.1) THEN
        ILNG=INDEX(HDEFAULT,' ') - 1
        IF(ILNG.GT.0) THEN
          CROOT = HDEFAULT(1:ILNG)//'/bufrtables/'
        ELSE
#ifdef BUFR_TABLES_PATH
           CROOT=BUFR_TABLES_PATH
           ILNG=INDEX(CROOT,' ')
#else
           CROOT='/usr/local/apps/libemos/tables/bufr/text/'
C
C         SGI/HP/SUN BUFR TABLES PATH
C
C
C         ADD VERSION NUMBER
C
          ILNG=INDEX(CROOT,' ')
          IEMOSNM = EMOSNUM(1)
          WRITE(CROOT(ILNG:ILNG+5),'(I6.6)') IEMOSNM
          CROOT(ILNG+6:) = '/'
#endif
        ENDIF
      ENDIF
      ILNG=INDEX(CROOT,' ')
      IF (ILNG.GT.1) THEN
        IF (CROOT(ILNG-1:ILNG-1).NE.'/') CROOT(ILNG:ILNG)='/'
      ENDIF
C
      CPRINT=' '
      OPRINT=.TRUE.
      CALL GETENV('PRINT_TABLE_NAMES',CPRINT)
      ILN=INDEX(CPRINT,' ')
      IF(ILN.LE.1) THEN
         OPRINT=.TRUE.
      ELSE
         IF(CPRINT(1:ILN-1).EQ.'FALSE'.OR.
     1      CPRINT(1:ILN-1).EQ.'false') OPRINT=.FALSE.
      END IF

      IF(OPRINT) THEN
C
      WRITE(KNTN,'(1H ,A)') '                  ECMWF '
      WRITE(KNTN,'(1H )')
      WRITE(KNTN,'(1H ,A,A)') '     BUFR DECODING SOFTWARE',
     1' VERSION -  7.2 '
      WRITE(KNTN,'(1H ,A)') '           1 APRIL  2007. '
      WRITE(KNTN,'(1H )')
      WRITE(KNTN,'(1H )')
      WRITE(KNTN,'(1H )')
      WRITE(KNTN,'(1H ,A)') 'Your path for bufr tables is :'
      WRITE(KNTN,'(1H ,A)')  CROOT(1:ILNG+6)
      END IF
C
      DO 101 I=1,JBPW-2
      NMASK(I)=2**I-1
 101  CONTINUE
      IF(JBPW.EQ.32) THEN
          NMASK(31)=2147483647
      END IF
C
      IF(NPMISS.LT.0.OR.NPMISS.GT.1) NPMISS=0
      IF(NPRUS.LT.0.OR.NPRUS.GT.1)   NPRUS=0
      IF(NOKEY.LT.0.OR.NOKEY.GT.1)   NOKEY=0
      IF(NOFL.LT.0.OR.NOFL.GT.1)     NOFL=0
C
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE OCTAL2DEC(KOCTAL,KDECIMAL,KERR)
C**** *DEC2OCTAL*
C
C
C     PURPOSE.
C     --------
C         Convert decomal integer into octal value
C
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *DEC2OCTAL(KOCTAL,KDECIMAL,KERR)
C
C     METHOD.
C     -------
C
C          NONE.
C
C
C     EXTERNALS.
C     ----------
C
C          NONE.
C
C     REFERENCE.
C     ----------
C
C          NONE.
C
C     AUTHOR.
C     -------
C
C          MILAN DRAGOSAVAC    *ECMWF*       07/01/2004.
C
C
C     MODIFICATIONS.
C     --------------
C
C          NONE.
C
C
      IMPLICIT LOGICAL(L,O,G), CHARACTER*8(C,H,Y)

      INTEGER KOCTAL
      INTEGER KDECIMAL
      CHARACTER*10 C
c
      KERR=0
      WRITE(C,'(I10)',IOSTAT=IOS) KOCTAL
      IF(IOS.NE.0) then
        Print*,'OCTAL2DEC: internal write error ',ios
        KERR=33
        RETURN
      ENDIF

      READ(C, '(O10)',IOSTAT=IOS) KDECIMAL
      IF(IOS.NE.0) then
        Print*,'OCTAL2DEC: internal write error ',ios
        KERR=33
        RETURN
      ENDIF
c     
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE BUEXS5( KBUFL,KBUFF,KERR)
C
C**** *BUEXS5*
C
C
C     PURPOSE.
C     --------
C          EXPANDS SECTION 5 OF BUFR MESSAGE.
C
C
C**   INTERFACE.
C     ----------
C
C          *CALL* *BUEXS5( KBUFL,KBUFF,KERR)*
C
C        INPUT :
C               *KBUFL*   -  LENGTH OF BUFR MESSAGE (WORDS)
C               *KBUFF*   -  ARRAY CONTAINING BUFR MESSAGE
C        OUTPUT:
C               *KERR*    -  RETURNED ERROR CODE
C
C     METHOD.
C     --------
C
C          NONE.
C
C     EXTERNALS.
C     ----------
C
C          BUNPKS         - UNPACK BIT PATTERN IN REPEATED WAY
C
C     REFERENCE.
C     ----------
C
C          NONE.
C
C     AUTHOR.
C     -------
C
C          M. DRAGOSAVAC    *ECMWF*       15/09/91.
C
C
C     MODIFICATIONS.
C     --------------
C
C          NONE.
C
C
      IMPLICIT LOGICAL(L,O,G), CHARACTER*8(C,H,Y)
C
C
C
#     include "parameter.F"
#     include "bcomunit.F"
#     include "bcomwork.F"
C
      DIMENSION KBUFF(KBUFL)
      DIMENSION IBUFR(4)
#ifndef R_4
      REAL*8 RVIND
      REAL*8 EPS
#else
      REAL   RVIND
      REAL   EPS
#endif
C
      CHARACTER*4 YBUFR
C
C     ------------------------------------------------------------------
C*          1.   EXPAND SECTION 5.
C                -----------------
 100  CONTINUE
C
      IF( KERR.NE.0 ) RETURN
C
      NWPT = NWPTB
      NBPT = NBPTB
C
C
C*          1.2  UNPACK LAST FOUR OCTETS CONTAINING '7777'.
C                ------------------------------------------
C
      CALL BUNPKS(NBPW,KBUFF,IBUFR,NWPT,NBPT,8,0,4,KERR)
C
C*          1.3  CHECK IF THE LAST FOUR OCTETS ARE '7777'.
C                --------------------------------------
      YBUFR=CHAR(IBUFR(1))//CHAR(IBUFR(2))//
     1      CHAR(IBUFR(3))//CHAR(IBUFR(4))
      IF(YBUFR.NE.'7777') THEN
         KERR = 2
         WRITE(KNTN,'(1H ,A)') 'BUEXS5 :'
         CALL BUERR(KERR)
         RETURN
      END IF
C
C     -----------------------------------------------------------------
      RETURN
      END

C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      INTEGER FUNCTION EMESEC2(KGRIB,KLENG,KNSPT,KSEC0,KSEC2,KBITS,
     X                         OQUASI)
C
C---->
C**** EMESEC2
C
C     PURPOSE
C     _______
C
C     Encodes GRIB section 2 values for lat/long grid fields.
C
C     INTERFACE
C     _________
C
C     IRET = EMESEC2(KGRIB,KLENG,KNSPT,KSEC0,KSEC2,KBITS,OQUASI)
C
C     Input parameters
C     ________________
C
C     KGRIB   - GRIB product built so far (upto octet 6). 
C     KLENG   - Length of KGRIB.
C     KNSPT   - Bit position of GRIB product built so far.
C     KSEC0   - GRIB section 0 description.
C     KSEC2   - GRIB section 2 description.
C     KBITS   - Number of bits per element in KGRIB.
C     OQUASI  - .TRUE. if gaussian grid is quasi-regular (reduced).
C     
C
C     Output parameters
C     ________________
C
C     KGRIB   - Updated GRIB product to end of section 2.
C     KNSPT   - Updated bit position of GRIB product built so far.
C     IRET    - Function return status code, 0 = OK
C
C     Common block usage
C     __________________
C
C     /GRPRSCM/ for GRPRSM variable.
C
C     Method
C     ______
C
C     Packs values given in KSEC2 into KGRIB and updates bit
C     pointer KNSPT.
C
C     Externals
C     _________
C
C     CSGNBT  - Set the sign bit.
C     INXBIT  - Insert bit data.
C
C
C     AUTHOR
C     ______
C
C     J. Clochard, Meteo France, for ECMWF - October 2000.
C     (derived from ELLSEC2)
C
C     MODIFICATIONS
C     _____________
C
C     J. Clochard, June 2008.
C     Use of GRPRSM instead of standard output in error/debug printouts.
C     Doctorize all dummy-arguments (K for integers, O for logicals).
C     Return-code set to 810 for errors on final padding.
C     Do not enforce Di/j increments to missing values when resolution
C     flag is off.
C----<
C     _______________________________________________________
C
C     Section 0. Definition of variables.
C     _______________________________________________________
C
      IMPLICIT NONE
C
C     Parameters
C
      INTEGER JP16SET, JP24SET
      PARAMETER ( JP16SET = 2**16 - 1 ) 
C                            ^---> 65535    =   FFFF(hex)
      PARAMETER ( JP24SET = 2**24 - 1 ) 
C                           ^---> 16777215 = FFFFFF(hex)
C     Function arguments
C
      INTEGER KGRIB,KLENG,KNSPT,KSEC0,KSEC2,KBITS, JLOOP
      DIMENSION KGRIB(*),KSEC0(*),KSEC2(*)
      LOGICAL OQUASI
C
C     Global variables
C
#include "grprs.h"
C
C     Local variables
C
      INTEGER ILALO(2), IRET, IRESOL, IZERO
      SAVE IZERO
      DATA IZERO /0/
C
C     _______________________________________________________
C
C     Section 1.    Initialization.
C     _______________________________________________________
C
  100 CONTINUE
C
      EMESEC2 = 0
C
C     _______________________________________________________
C
C     Section 2.    Pack section 2 octets.
C     _______________________________________________________
C
  200 CONTINUE
C
C     Octets 7 - 8  : Ni - number of points along a parallel.
C     Octets 9 - 10 : Nj - number of points along a meridian.
C     Two 16 bit fields.
C
C     WARNING!!
C     For quasi-regular grids, it is here assumed that Ni is variable,
C     i.e. that the number of points along a parallel is variable but
C     that the number of points along a meridian is fixed.
C
C     For quasi-regular grids Ni is set to all 1 bits, as
C     the number of points is different on different parallels.
C
C     Set to all 1 bits.
C
      IF( OQUASI ) KSEC2(2) = JP16SET
C
      CALL INXBIT(KGRIB,KLENG,KNSPT,KSEC2(2),2,KBITS, 16,'C',IRET)
      IF( IRET.NE.0) THEN
        EMESEC2 = 1
        WRITE(GRPRSM,*) 'EMESEC2: Error inserting number of pts'
        WRITE(GRPRSM,*) 'EMESEC2: along parallel or meridian.'
        WRITE(GRPRSM,*) 'EMESEC2: Return code = ', IRET
        GO TO 900
      ENDIF
C
C     Octets 11 - 13 : La1 - latitude of first grid point.
C     Octets 14 - 16 : Lo1 - longitude of first grid point.
C     Two 24 bit fields.
C
C     Set sign bit to 1, if value is negative.
C
      CALL CSGNBT( ILALO(1), KSEC2(4), 24, IRET)
      CALL CSGNBT( ILALO(2), KSEC2(5), 24, IRET)
C
      CALL INXBIT(KGRIB,KLENG,KNSPT,ILALO,2,KBITS, 24,'C',IRET)
      IF( IRET.NE.0) THEN
        EMESEC2 = 1
        WRITE(GRPRSM,*) 'EMESEC2: Error inserting'
        WRITE(GRPRSM,*)
     X    'EMESEC2: latitude or longitude of first grid pt.'
        WRITE(GRPRSM,*) 'EMESEC2: Return code = ', IRET
        GO TO 900
      ENDIF
C
C     Octet 17 : Resolution and components flag.
C     One 8 bit field.
C
      IRESOL = KSEC2(6)+KSEC2(18)+KSEC2(19)
C
      CALL INXBIT(KGRIB,KLENG,KNSPT,IRESOL,1,KBITS, 8,'C',IRET)
      IF( IRET.NE.0) THEN
        EMESEC2 = 1
        WRITE(GRPRSM,*) 'EMESEC2: Error inserting'
        WRITE(GRPRSM,*) 'EMESEC2: components flag.'
        WRITE(GRPRSM,*) 'EMESEC2: Return code = ', IRET
        GO TO 900
      ENDIF
C
C     Octets 18 - 20 : La2 - latitude of last grid point.
C     Octets 21 - 23 : Lo2 - longitude of last grid point.
C     Two 24 bit fields.
C
C     Set sign bit to 1, if value is negative.
C
      CALL CSGNBT( ILALO(1), KSEC2(7), 24, IRET)
      CALL CSGNBT( ILALO(2), KSEC2(8), 24, IRET)
C
C     Insert / extract fields.
C
      CALL INXBIT(KGRIB,KLENG,KNSPT,ILALO,2,KBITS, 24,'C',IRET)
      IF( IRET.NE.0) THEN
        EMESEC2 = 1
        WRITE(GRPRSM,*) 'EMESEC2: Error inserting'
        WRITE(GRPRSM,*) 'EMESEC2: latitude/longitude of last grid point'
        WRITE(GRPRSM,*) 'EMESEC2: Return code = ', IRET
        GO TO 900
      ENDIF
C
C     Octets 24 - 26 : Latin - latitude(s) at which the Mercator
C                      projection cylinder intersects the Earth.
C     One 24 bit field.
C
C     Set sign bit to 1, if value is negative.
C
      CALL CSGNBT( ILALO(1), KSEC2(9), 24, IRET)
C
      CALL INXBIT(KGRIB,KLENG,KNSPT,ILALO,1,KBITS, 24,'C',IRET)
      IF( IRET.NE.0) THEN
        EMESEC2 = 1
        WRITE(GRPRSM,*) 'EMESEC2: Error inserting'
        WRITE(GRPRSM,*) 'EMESEC2: latitude of intersection.'
        WRITE(GRPRSM,*) 'EMESEC2: Return code = ', IRET
        GO TO 900
      ENDIF
C
C     Octet 27 : Reserved. Set to zero.
C     One 8 bit field.
C
Ce    Set bits to 0.
C
      CALL INXBIT(KGRIB,KLENG,KNSPT, IZERO, 1,KBITS, 8,'C',IRET)
      IF( IRET.NE.0) THEN
        EMESEC2 = 1
        WRITE(GRPRSM,*) 'EMESEC2: Error inserting dummy zero.'
        WRITE(GRPRSM,*) 'EMESEC2: Return code = ', IRET
        GO TO 900
      ENDIF
C
C     Octet 28 : Scanning mode flags.
C     One 8 bit field.
C
      CALL INXBIT(KGRIB,KLENG,KNSPT,KSEC2(11),1,KBITS, 8,'C',IRET)
      IF( IRET.NE.0) THEN
        EMESEC2 = 1
        WRITE(GRPRSM,*) 'EMESEC2: Error inserting'
        WRITE(GRPRSM,*) 'EMESEC2: scanning mode flags.'
        WRITE(GRPRSM,*) 'EMESEC2: Return code = ', IRET
        GO TO 900
      ENDIF
C
C     Fix-up for flag which was different in Experimental Edition.
C
      IF( KSEC0(2).EQ.-1.AND.KSEC2(11).EQ.1) KSEC2(11) = 0
C
C     Octets 29 - 31 : Di - i direction increment.
C     One 24 bit field.
C
C     For quasi-regular grids all Di bits are set to 1, as
C     the increment is different on different parallels.
C
C     If field not given, set to all bits to 1.
C
Ce    Set to all 1 bits.
      IF( OQUASI) KSEC2(13) = JP24SET
Ce
Ce    If increments not given, set all bits to 1.
Ce    IF( KSEC2(6).EQ.0) KSEC2(13) = JP24SET
C
      CALL INXBIT(KGRIB,KLENG,KNSPT,KSEC2(13),1,KBITS, 24,'C',IRET)
      IF( IRET.NE.0) THEN
        EMESEC2 = 1
        WRITE(GRPRSM,*) 'EMESEC2: Error inserting'
        WRITE(GRPRSM,*) 'EMESEC2: i direction increment.'
        WRITE(GRPRSM,*) 'EMESEC2: Return code = ', IRET
        GO TO 900
      ENDIF
C
C     Octets 32 - 34 : Dj - j direction increment.
C     One 24 bit field.
C
C     If field not given, set to all bits to 1.
C
C     IF( KSEC2(6).EQ.0) KSEC2(14) = JP24SET
C
      CALL INXBIT(KGRIB,KLENG,KNSPT,KSEC2(14),1,KBITS, 24,'C',IRET)
      IF( IRET.NE.0) THEN
        EMESEC2 = 1
        WRITE(GRPRSM,*) 'EMESEC2: Error inserting'
        WRITE(GRPRSM,*) 'EMESEC2: j direction increment.'
        WRITE(GRPRSM,*) 'EMESEC2: Return code = ', IRET
        GO TO 900
      ENDIF
C
C     Octets 35 - 42 : Reserved.
C     Eight 8 bit fields.
C
Ce    Set bits to 0.
C
      DO 221 JLOOP = 1, 8
C
        CALL INXBIT(KGRIB,KLENG,KNSPT, IZERO, 1,KBITS, 8,'C',IRET)
        IF( IRET.NE.0) THEN
	  IRET = 810
          EMESEC2 = IRET
          WRITE(GRPRSM,*) 'EMESEC2: Error inserting dummy zero.'
          WRITE(GRPRSM,*) 'EMESEC2: Return code = ', IRET
          GO TO 900
        ENDIF
C
  221 CONTINUE
C
C     _______________________________________________________
C
C     Section 9. Return to calling routine.
C     _______________________________________________________
C
  900 CONTINUE
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE BUSRP(KBUFL,KBUFF,KSEC3,KJ,KJ1,KDD,KSTACK,KELEM,KERR)
C
C**** *BUSRP*
C
C
C     PURPOSE.
C     --------
C          RESOLVE DATA DESCRIPTOR REPLICATION PROBLEM.
C
C
C**   INTERFACE.
C     ----------
C
C          *CALL* *BUSRP(KBUFL,KBUFF,KSEC3,KJ,KJ1,KDD,KSTACK,KELEM,KERR)*
C
C        INPUT :
C               *KBUFL*   -  LENGTH OF BUFR MESSAGE (WORDS)
C               *KBUFF*   -  ARRAY CONTAINING BUFR MESSAGE
C               *KSEC3*   -  ARRAY CONTAINIG SECTION 3 INFORMATION
C               *KELEM*   -  DIMENSION OF CNAMES, CUNITS ARRAY
C               *KDD*      - DATA DESCRIPTOR
C        OUTPUT:
C               *KJ*       - POINTER TO KSTACK ARRAY
C               *KJ1*      - POINTER TO LAST ELEMENT IN KSTACK
C               *KSTACK*   - LIST OF DATA DESCRIPTORS
C               *KERR*     - RETURN CODE
C
C     METHOD.
C     -------
C          NONE.
C
C     EXTERNALS.
C     ----------
C
C          BUSTDR            - RESOLVE TABLE D REFERENCE
C          BUUPWT              - UPDATE WORKING TABLES
C          GBYTE             - UNPACK BIT PATTERN
C
C
C     REFERENCE.
C     ----------
C
C          NONE.
C
C     AUTHOR.
C     -------
C
C          M. DRAGOSAVAC    *ECMWF*       01/02/91.
C
C
C     MODIFICATIONS.
C     --------------
C
C          NONE.
C
C
      IMPLICIT LOGICAL(L,O,G), CHARACTER*8(C,H,Y)
C
      CHARACTER CWTEN*64,CWTU*24
C
C
#     include "parameter.F"
#     include "bcomunit.F"
#     include "bcomwork.F"
#     include "bcomwt.F"
#     include "bcomwtc.F"
#     include "bcombef.F"
#     include "bcomoff.F"
C
#ifndef R_4
      REAL*8 RVIND
      REAL*8 EPS
#else
      REAL   RVIND
      REAL   EPS
#endif
      DIMENSION KBUFF(KBUFL),ILIST(JELEM)
      DIMENSION KSTACK(*),KSEC3(JSEC3),IMASK(8)
C
      DATA IMASK/1,2,4,8,16,32,64,128/
C
C     ------------------------------------------------------------------
C
C*          1.   STORE K, NUMBER OF DESCRIPTORS TO BE REPLICATED.
C                ------------------------------------------------
 100  CONTINUE
C
      IF( KERR.NE.0 ) RETURN
C
      IF  = KDD / 100000
      IDIF= KDD - IF * 100000
      IX  = IDIF / 1000
      IY  = IDIF - IX * 1000
      K   = IX
C
      IF(IY.EQ.0) ODREPF=.TRUE.
C
C*          1.1   DELAYED REPLICATION ?
C                 ---------------------
 110  CONTINUE
C
      IF( IY .NE. 0 ) THEN
C
C*          1.2   STORE NUMBER OF DESCRIPTORS, K, AND REPLICATION
C                 -----------------------------------------------
C                 FACTOR JR.
C                 ----------
 120     CONTINUE
C
C         K  = IX
         JR = IY
         GO TO 500
      END IF
C
C     ------------------------------------------------------------------
C
C*          2.   GET NEXT DESCRIPTOR.
C                --------------------
 200  CONTINUE
C
      KJ =KJ + 1
      KDD= KSTACK(KJ)
C
C     ------------------------------------------------------------------
C
C*          2.1  REPLICATION FACTOR ?
C                --------------------
 210  CONTINUE
C
      IF(KDD.NE.31001.AND.KDD.NE.31002.AND.
     1   KDD.NE.31000.AND.
     1   KDD.NE.31011.AND.KDD.NE.31012 )THEN

C
C*          2.1.1  SEQUENCE DESCRIPTOR ?
C                  ---------------------
C
         IF=KDD/100000
C
         IF( IF.EQ.3) THEN
C
C*          2.1.1.1  SOLVE TABLE D REFERENCE.
C                    ------------------------
            CALL BUSTDR(KJ,KJ1,KDD,KSTACK,KERR)
            IF(KERR.GT.0) THEN
               DO 252 IQ=1,JELEM
               NSTACK(IQ)=0.
 252           CONTINUE
               RETURN
            END IF
            GO TO 200
         END IF
C
         IF( IF.EQ.2) THEN
            CALL BUPRCO(KBUFL,KBUFF,KJ,KDD,KSTACK,KELEM,KERR)
            IF(KERR.GT.0) THEN
               CALL BUERR(KERR)
               RETURN
            END IF
            GO TO 200
         END IF
C
         KERR=36
         CALL BUERR(KERR)
         RETURN
      END IF
C
C     ------------------------------------------------------------------
C
C*          3.  UPDATE WORKING TABLE.
C               ---------------------
 300  CONTINUE
C
c     IF(KDD.EQ.31031.OR.KDD.EQ.31192) THEN
c        NWT=NWT+1
c        NWTR(NWT)=KDD
c        NWTS(NWT)=0
c        NWTRV(NWT)=0
c        NWTDW(NWT)=1
c        CWTEN(NWT)='DATA PRESENT INDICATOR'
c        CWTU (NWT)='NUMERIC'
c        M=M+1
c     ELSEIF(KDD.EQ.33007.OR.KDD.EQ.63192) THEN
c        NWT=NWT+1
c        NWTR(NWT)=KDD
c        NWTS(NWT)=0
c        NWTRV(NWT)=0
c        NWTDW(NWT)=7
c        CWTEN(NWT)='% CONFIDENCE'
c        CWTU (NWT)='NUMERIC'
c        M=M+1
c     ELSE
         CALL BUUPWT(KDD,KELEM,KERR)
         IF(KERR.GT.0) RETURN
         IF(KDD.EQ.031011.or.kdd.eq.031012) return
c     END IF
C
C     CHECK IF NEXT DESCRIPTOR CANCEL OPERATOR FOR DELAYED
C     REPLICATION
C
      IIIF=KSTACK(KJ+1)/100000
      IIII=KSTACK(KJ+1)-IIIF*100000
      IIIX=IIII/1000
      IIIY=IIII-IIIX*1000
C
      IF(IIIF.EQ.2.AND.IIIY.EQ.0) THEN
         KJ=KJ+1
         KDD=KSTACK(KJ)
         CALL BUPRCO(KBUFL,KBUFF,KJ,KDD,KSTACK,KELEM,KERR)
         IF(KERR.GT.0) THEN
            CALL BUERR(KERR)
            RETURN
         END IF
      END IF
C
C     ------------------------------------------------------------------
C
C*          4.  LOCATE AND STORE JR, THE REPLICATION FACTOR FROM DATA.
C               ------------------------------------------------------
 400  CONTINUE
C
      IB=0
      IF(IAND(KSEC3(4),IMASK(7)).NE.0) IB=1
C
C     RESOLVE MARKERS
C
      IF(OMARKER) THEN
         CALL BUPMRK(KBUFL,KBUFF,KSEC3,KELEM,KERR)
         IF(KERR.GT.0) RETURN
      END IF
C
      IF(IB.EQ.0) THEN
C
C        UNCOMPRESSED DATA
C
         IBIT=0
C
         DO 401 J=1,NWT-1
C
         IBIT=IBIT+NWTDW(J)
C
 401     CONTINUE
C
         IF(NSUBSET.EQ.1) THEN
            IBIT = IBIT + 32 + NBPTB
         ELSE
            IBIT=IBIT+NBP
         END IF
C
         IWORD= IBIT/NBPW
         ISKIP= IBIT - IWORD*NBPW
         IF(NSUBSET.EQ.1) THEN
            IWORD= IWORD + NWPTB
         ELSE
            IWORD= IWORD + NWP
         END IF
C
         CALL GBYTE(KBUFF(IWORD),JR,ISKIP,NWTDW(NWT))

         IF(JR.EQ.0) THEN
            KJ=KJ+K
            GO TO 640
         END IF

c        IF(NWTR(NWT).eq.31011.or.NWTR(NWT).eq.31012) then
c           NREP=JR
c        END IF
      ELSE
C
C        COMPRESSED DATA
C
         IBIT=32+NBPTB
         IWORD=IBIT/NBPW
C
         IWORDP=NWPTB+IWORD
         IBITP =IBIT-IWORD*NBPW
C
         DO 402 I=2,NWT
         IWRD=IWORDP
         IBTP=IBITP
C
         IF(NWTDW(I-1).EQ.0) THEN
            IBITP =IBITP
            IWORDP=IWORDP
            GO TO 402
         END IF
C
         IBTP=IBTP+NWTDW(I-1)
         IF(IBTP.GE.NBPW) THEN
            IW=IBTP/NBPW
            IBTP=IBTP-IW*NBPW
            IWRD=IWRD+IW
         END IF
C
         CALL BUNPCK(NBPW,KBUFF,IDWINC,IWRD,IBTP,6,KERR)
         IF(KERR.GT.0) RETURN
         IF(IDWINC.GT.JBPW) THEN
            KERR=15
            WRITE(KNTN,*) 'BUSRP:'
            CALL BUERR(KERR)
            RETURN
         END IF
         IF(IWRD.GT.KBUFL) THEN
            KERR=26
            WRITE(KNTN,*) 'BUSRP:'
            CALL BUERR(KERR)
            RETURN
         END IF
C
         IF(CWTU(I-1)(1:3).EQ.'CCI') THEN
            IWTIWS=NWTDW(I-1)+6+N*IDWINC*8
         ELSE
            IWTIWS=NWTDW(I-1)+6+N*IDWINC
         END IF
C
         IBIT = IBITP + IWTIWS
         IWORD= IBIT/NBPW
C
         IBITP = IBIT - IWORD*NBPW
         IWORDP= IWORDP + IWORD
C
         IF(IWORDP.GT.KBUFL) THEN
            KERR=26
            WRITE(KNTN,*) 'BUSRP :'
            CALL BUERR(KERR)
            RETURN
         END IF
 402     CONTINUE
C
C        UNPACK JR DELAYED REPLICATION FACTOR
C
         IW=IWORDP
         IBT=IBITP
         CALL BUNPCK(NBPW,KBUFF,IR0,IW,IBT,NWTDW(NWT),KERR)
         IF(KERR.GT.0) RETURN
         CALL BUNPCK(NBPW,KBUFF,IDWINC,IW,IBT,6,KERR)
         IF(KERR.GT.0) RETURN
         IF(IDWINC.GT.JBPW) THEN
            KERR=15
            WRITE(KNTN,*) ' BUSRP :'
            CALL BUERR(KERR)
            RETURN
         END IF
C
         IF(IDWINC.NE.0) THEN
            CALL BUNPCK(NBPW,KBUFF,INCR,IW,IBT,IDWINC,KERR)
            IF(KERR.GT.0) RETURN
         END IF
C
         IF(IR0.EQ.NMASK(NWTDW(NWT))) THEN
            JR=NMASK(NWTDW(NWT))
            KERR=19
            WRITE(KNTN,*) 'BUSRP :'
            CALL BUERR(KERR)
            RETURN
         ELSE
            IWTPR0=NWTRV(NWT)+IR0
C
            IF(IDWINC.EQ.0) THEN
               JR=IWTPR0
            ELSE
               IF(INCR.EQ.NMASK(IDWINC)) THEN
                  JR=NMASK(NWTDW(NWT))
                  KERR=19
                  WRITE(KNTN,*) 'BUSRP :'
                  CALL BUERR(KERR)
                  RETURN
               ELSE
                  JR= IWTPR0 + INCR
               END IF
            END IF
         END IF
      END IF
C
      IF(JR.EQ.0) THEN
         KJ=KJ+K
         GO TO 640
      END IF
C
      JRTK=JR*K+KJ1-K
      IF(JRTK.GT.JELEM) THEN
         KERR=19
         WRITE(KNTN,*) 'BUSRP :'
         CALL BUERR(KERR)
         WRITE(KNTN,*)'REPLICATION FACTOR =',JR
         RETURN
      END IF
C
C     ------------------------------------------------------------------
C*          5.  GET NEXT K DESCRIPTORS.
C               -----------------------
 500  CONTINUE
C
      DO 501 J=1,K
C
      ILIST(J)=KSTACK(KJ+J)
C
 501  CONTINUE
C
C     ------------------------------------------------------------------
C*          6.  ADD JR TIMES K DESCRIPTORS IN PLACE OF K
C               ----------------------------------------
C               DESCRIPTORS OBTAINED.
C               ---------------------
 600  CONTINUE
C
C     ------------------------------------------------------------------
C*          6.1  PUSH DOWN DESCRIPTORS IN KSTACK FOR (JR-1)*K PLACES
C                ---------------------------------------------------
C                STARTING AT KJ1 AND ENDING AT KJ+K.
C                -----------------------------------
 610  CONTINUE
C
      JRKM1=(JR-1)*K
C
      DO 611 J=KJ1,KJ+K,-1
C
      KSTACK(J+JRKM1)=KSTACK(J)
C
 611  CONTINUE
C
C*          6.2  INSERT LIST IN THE STACK.
C                -------------------------
 620  CONTINUE
C
      DO 622 J=1,JR
C
      KJJM1K=KJ+(J-1)*K
C
      DO 623 J1=1,K
C
      KSTACK(KJJM1K+J1)=ILIST(J1)
C
 623  CONTINUE
 622  CONTINUE
C
C     ------------------------------------------------------------------
C*          6.3  ADJUST DESCRIPTOR COUNT FOR LIST LENGTH.
C                ----------------------------------------
 630  CONTINUE
C
      KJ1 = KJ1  + (JR-1)*K
C
C     ------------------------------------------------------------------
C*          6.4  ADJUST NUMBER OF DATA DESCRIPTORS NOT PRESENT.
C                ----------------------------------------------
 640  CONTINUE
C
      IF(N221.NE.0)  N221= KJ1  - KJ + 1
C
C     ------------------------------------------------------------------
 700  CONTINUE
C
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE BUEXS3P(KBUFL,KBUFF,KSUP,KSEC3,KERR)
C
C**** *BUEXS3P*
C
C
C     PURPOSE.
C     --------
C
C          EXPAND SECTION 3 OF BUFR MESSAGE.
C               (PRELIMINARY ITEMS)
C
C
C**   INTERFACE.
C     ----------
C
C          *CALL* *BUEXS3P( KBUFL,KBUFF,KSUP,KSEC3,KERR)*
C
C        INPUT :
C               *KBUFL*   -  LENGTH OF BUFR MESSAGE (WORDS)
C               *KBUFF*   -  ARRAY CONTAINING BUFR MESSAGE
C        OUTPUT:
C               *KSUP*    -  ARRAY CONTAINING SUPLEMENTARY INFORMATION
C                         -  KSUP( 1) -- IDIM1, DIMENSION OF KSEC1
C                         -  KSUP( 2) -- IDIM2, DIMENSION OF KSEC2
C                         -  KSUP( 3) -- IDIM3, DIMENSION OF KSEC3
C                         -  KSUP( 4) -- IDIM4, DIMENSION OF KSEC4
C                         -  KSUP( 5) -- M (NUMBER OF ELEMENTS IN VALUES ARRAY,
C                                           FIRST INDEX)
C                         -  KSUP( 6) -- N (NUMBER OF SUBSETS,SECOND INDEX OF
C                                           VALUES ARRAY)
C                         -  KSUP( 7) -- JVC (NUMBER OF ELEMENTS IN CVAL ARRAY)
C                         -  KSUP( 8) -- TOTAL BUFR MESSAGE LENGTH IN BYTES
C                         -  KSUP( 9) -- IDIM0, DIMENSION OF KSEC0
C               *KSEC3*   -  ARRAY KSEC3 
C               *KERR*    -  RETURNED ERROR CODE
C
C     METHOD.
C      -------
C
C
C          NONE.
C
C     EXTERNALS.
C     ----------
C
C          BUNEXS        - SET WORD AND BIT POINTERS AT THE BEGINING OF
C                          NEXT SECTION
C          BUNPCK        - UNPACKS BIT PATTERN
C
C     REFERENCE.
C     ----------
C
C          NONE.
C
C     AUTHOR.
C     -------
C
C          M. DRAGOSAVAC    *ECMWF*       01/02/91.
C
C
C     MODIFICATIONS.
C     --------------
C
C          NONE.
C
C
      IMPLICIT LOGICAL(L,O,G), CHARACTER*8(C,H,Y)
C
C
#     include "parameter.F"
#     include "bcomunit.F"
#     include "bcomwork.F"
C
      DIMENSION KBUFF(KBUFL),KSEC3(JSEC3)
      DIMENSION KSUP(JSUP)
#ifndef R_4
      REAL*8 RVIND
      REAL*8 EPS
#else
      REAL   RVIND
      REAL   EPS
#endif
C
C     ------------------------------------------------------------------
C
C*          1.   EXPAND PRELIMINARY ITEMS OF SECTION 3.
C                --------------------------------------
 100  CONTINUE
C
      IF( KERR.NE.0 ) RETURN
C
C*          1.1   SET THE POINTERS NWPT AND NBPT TO THE
C                 -------------------------------------
C                 BEGINING OF THE SECTION 3.
C                 --------------------------
 110  CONTINUE
C
      NWPT = NWPTB
      NBPT = NBPTB
C
C*          1.2   UNPACK LENGTH OF SECTION 3.
C                 ---------------------------
 120  CONTINUE
C
      CALL BUNPCK(NBPW,KBUFF,KSEC3(1),NWPT,NBPT,24,KERR)
      IF(KERR.GT.0) RETURN
C
C*          1.2.1  SET THE POINTERS NWPTB AND NBPTB TO
C                  -----------------------------------
C                  THE BEGINNING OF THE NEXT SECTION.
C                  ----------------------------------
      CALL BUNEXS(KSEC3(1))
C
C*          1.3    UNPACK ZERO BYTE AND PUT IT IN KSEC3(2).
C                  ----------------------------------------
 130  CONTINUE
C
      CALL BUNPCK(NBPW,KBUFF,KSEC3(2),NWPT,NBPT,8,KERR)
      IF(KERR.GT.0) RETURN
C
C*          1.4    UNPACK NUMBER OF DATA SUB-SETS.
C                  -------------------------------
 140  CONTINUE
C
      CALL BUNPCK(NBPW,KBUFF,KSEC3(3),NWPT,NBPT,16,KERR)
      IF(KERR.GT.0) RETURN
      IF(KSEC3(3).LE.0) THEN
         KERR=32
         WRITE(KNTN,*)  ' BUEXS3 :'
         CALL BUERR(KERR)
         RETURN
      END IF
C
C
C*          1.5    UNPACK INTEGER VALUE OF THE OCTET
C                  ---------------------------------
C                  CONTAINING FLAG BITS.
C                  --------------------
 150  CONTINUE
C
      CALL BUNPCK(NBPW,KBUFF,KSEC3(4),NWPT,NBPT,8,KERR)
      IF(KERR.GT.0) THEN
         WRITE(KNTN,*)  'ERROR UNPACKING KSEC3(4).'
         RETURN
      END IF

C
C     -----------------------------------------------------------------
C
      KSUP(3)= 4
      KSUP(5)= 0
      KSUP(6)= KSEC3(3)
C
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      INTEGER FUNCTION C2PKVW ( KDATA,  KLENP,  KGRIB,  KLENG,  KNSPT,
     X                          KBITS,  KLEN,   KREFGR, KLENGR, KBITGR,
     X                          KWORK,  KLWORK, KFIROV, KCOUNT, KPOWER,
     X                          KMXPWR, OROW,   OVECTA, ODEBUG )
C
C---->
C**** C2PKVW
C
C     Purpose.
C     --------
C
C     Computes and packs second-order values for variable width methods
C     of second-order packing.
C
C
C**   Interface.
C     ----------
C
C     KRET = C2PKVW ( KDATA,  KLENP,  KGRIB,  KLENG,  KNSPT,  KBITS,
C    X                KLEN,   KREFGR, KLENGR, KBITGR, KWORK,  KLWORK,
C    X                KGRIB,  KCOUNT, KPOWER, KMXPWR, OROW,   OVECTA,
C    X                ODEBUG )
C
C
C     Input Parameters.
C     ----------------
C
C     KDATA      - Array of normalized values.
C     KLENP      - Length of array KDATA.
C     KLENG      - Length of GRIB product array.
C     KNSPT      - Bit pointer for next value in GRIB product.
C     KBITS      - Number of bits per computer word.
C     KLEN       - Exact number of grid-points to handle.
C     KREFGR     - Work array, first-order values for each group.
C     KLENGR     - Work array, effective length of each group.
C     KBITGR     - Work array, bit number ("width") of each group.
C     KLWORK     - Length of work arrays.
C     KFIROV     - Number of FIRst-Order Values.
C     KCOUNT     - Initial index into KDATA.
C     KPOWER     - Auxilary array, containing precomputed powers of 2-1.
C     KMXPWR     - Maximum number of bits per original scaled value.
C     OROW       - True if row by row packing is active packing method.
C     OVECTA     - True if vector-oriented algorithm has to be used.
C     ODEBUG     - True for some debug printout.
C
C
C     Output Parameters.
C     -----------------
C
C     KDATA      - Used as work array for second-order values.
C     KGRIB      - Array containing GRIB product.
C     KNSPT      - Bit pointer for next value in GRIB product (updated).
C     KREFGR     - Work array, re-used internally.
C     KBITGR     - Work array, re-used internally.
C     KWORK      - Work array.
C     KCOUNT     - Final index into KDATA.
C
C
C     Method.
C     -------
C
C     Follows WMO Manual of Codes.
C
C     Externals.
C     ----------
C
C     INXBIT    - Insert bits into GRIB product.
C
C
C     Reference.
C     ----------
C
C     None.
C
C
C     Comments.
C     --------
C
C
C     KDATA is overwritten. This is coherent with GRIBEX coding.
C
C
C     Author.
C     -------
C
C     J. Clochard, Meteo France, for ECMWF - September 1998.
C
C
C     Modifications.
C     _____________
C
C     None.
C
C
C----<
C     -----------------------------------------------------------------
C*    Section 0. Definition of variables.
C     -----------------------------------------------------------------
C
      IMPLICIT NONE
C
#include "common/grprs.h"
C
C     Subroutine arguments
C
      INTEGER KLENP, KLENG, KNSPT, KBITS, KLEN, KLWORK, KFIROV, KCOUNT
      INTEGER KMXPWR
      INTEGER KDATA (KLENP), KGRIB (KLENG), KPOWER (0:KMXPWR)
      INTEGER KREFGR (KLWORK), KLENGR (KLWORK), KBITGR (KLWORK)
      INTEGER KWORK (KLWORK)
C
      LOGICAL OROW, OVECTA, ODEBUG
C
C     Local variables.
C
      INTEGER ICOUNT, JGROUP, ILNGTH, IRET, J, IWIDTH, IREFER, IOFF
      INTEGER IRETFN, IPRWID, JTIMES, ILNGTS, IDATA,  ICOUNB, IBLOCK
      INTEGER JBLOCK, IFIRST, ILBITS, IBIT,   IWIDPR, INTERM, IPOWER
C
      CHARACTER YOPER*1
C
C     -----------------------------------------------------------------
C*    Section 1 . Initialisations.
C     -----------------------------------------------------------------
C
  100 CONTINUE
C
#ifndef ebug2o
      IF (ODEBUG) THEN
#endif
        WRITE(GRPRSM,FMT=9100) KNSPT
#ifndef ebug2o
      ENDIF
#endif
C
      IRETFN=0
      YOPER='C'
      ICOUNT=KCOUNT
C
C     -----------------------------------------------------------------
C*    Section 2. Blocks groups of same width, compute 2nd-order values.
C     -----------------------------------------------------------------
C
  200 CONTINUE
C
C         Determin blocks of neighbour groups of same width to be
C         "packed" together for coding, and compute 2nd-order values.
C
C         In both cases any constant groups are not taken into account.
C
      ILNGTS=0
      ICOUNB=0
      IBLOCK=0
C
C         Find first non-constant group.
C
      DO 201 J=1,KFIROV
C
        IF (KBITGR(J).NE.0) THEN
          IFIRST=J
          GOTO 202
        ENDIF
C
        ICOUNT=ICOUNT+KLENGR(J)
C
  201 CONTINUE
C
C         All groups are constant (constant field, at least piecewise).
C         In such a case there are no second-order values to code.
C
      IFIRST=KFIROV+1
      ICOUNT=KLEN
C
  202 CONTINUE
C
      IPRWID=KBITGR(MIN (IFIRST,KFIROV))
C
      DO 204 JGROUP=IFIRST,KFIROV
C
        IWIDTH=KBITGR(JGROUP)
        ILNGTH=KLENGR(JGROUP)
        IREFER=KREFGR(JGROUP)
C
        IF (IWIDTH.NE.0) THEN
C
C              Compute second-order values for current group.
C
#ifdef CRAY
CDIR$ IVDEP
#endif
#ifdef FUJITSU
!OCL NOVREC
#endif
          DO 203 J=1,ILNGTH
C
            KDATA(ICOUNB+J)=KDATA(ICOUNT+J)-IREFER
C
  203     CONTINUE
C
          IF (IWIDTH.NE.IPRWID) THEN
C
C             Current group may not be blocked with previous one(s).
C
            IF (ILNGTS.NE.0) THEN
C
C               Closes current block.
C
              IBLOCK=IBLOCK+1
              KBITGR(IBLOCK)=IPRWID
              KWORK(IBLOCK)=ILNGTS
              ILNGTS=0
C
            ENDIF
C
            IPRWID=IWIDTH
C
          ENDIF
C
          ICOUNB=ICOUNB+ILNGTH
          ILNGTS=ILNGTS+ILNGTH
C
        ENDIF
C
        ICOUNT=ICOUNT+ILNGTH
C
  204 CONTINUE
C
      IF (IPRWID.NE.0.AND.ILNGTS.NE.0) THEN
C
C           Closing last block of group(s).
C
        IBLOCK=IBLOCK+1
        KBITGR(IBLOCK)=IPRWID
        KWORK(IBLOCK)=ILNGTS
C
      ENDIF
C
C     -----------------------------------------------------------------
C*    Section 3. Packs second-order values.
C     -----------------------------------------------------------------
C
  300 CONTINUE
C
      ILBITS=0
      ICOUNB=0
      ILNGTS=0
C
      IF (OROW.OR..NOT.OVECTA) THEN
C
C           For such a case, granularity is large enough to make one
C           INXBIT call per block of group(s).
C
        DO 311 JBLOCK=1,IBLOCK
C
          ILNGTH=KWORK(JBLOCK)
          IWIDTH=KBITGR(JBLOCK)
#ifdef ebug2o
          PRINT *,'c2pkvw - block',JBLOCK,
     X              ' KNSPT/IWIDTH/ICOUNB/ILNGTH = ',
     X                KNSPT, IWIDTH, ICOUNB, ILNGTH
#endif
          CALL INXBIT(KGRIB,KLENG,KNSPT,KDATA(ICOUNB+1),ILNGTH,KBITS,
     X                IWIDTH,YOPER,IRET)
C
          IF (IRET.NE.0) THEN
            IRETFN = 24310
            WRITE(GRPRSM,FMT=9310) 'block', JBLOCK, ILNGTH, IWIDTH
            GO TO 900
          ENDIF
C
          ICOUNB=ICOUNB+ILNGTH
C
  311   CONTINUE
C
      ELSE
C
C       Granularity is generally small. Except for very big groups,
C       split 2nd-order values into individual bits, blocked into
C       KREFGR work array, that is flushed when full.
C
C
        DO 399 JBLOCK=1,IBLOCK
C
          ILNGTH=KWORK(JBLOCK)
          IWIDTH=KBITGR(JBLOCK)
C
          IF ((ILBITS+ILNGTH*IWIDTH).GT.KLWORK.AND.ILBITS.NE.0) THEN
C
C             Work array of split bits has to be flushed. Pack it.
C
#ifdef ebug2o
            PRINT *,'c2pkvw - blocks..',JBLOCK-1,
     X              ' KNSPT/ILBITS = ',
     X                KNSPT, ILBITS
#endif
            CALL INXBIT(KGRIB,KLENG,KNSPT,KREFGR,ILBITS,KBITS,
     X                  1,YOPER,IRET)
C
            IF (IRET.NE.0) THEN
              IRETFN = 24320
              WRITE(GRPRSM,FMT=9320) JBLOCK-1, ILBITS
              GO TO 900
            ENDIF
C
            ILBITS=0
C
          ENDIF
C
          IF ((ILNGTH*IWIDTH).GT.KLWORK) THEN
C
C             Current block is too large to fit into KREFGR.
C             Pack it straightforward, without intermediate splitting.
C
#ifdef ebug2o
            PRINT *,'c2pkvw - BLOCK',JBLOCK,
     X              ' KNSPT/IWIDTH/ICOUNB/ILNGTH = ',
     X                KNSPT, IWIDTH, ICOUNB, ILNGTH
#endif
            CALL INXBIT(KGRIB,KLENG,KNSPT,KDATA(ICOUNB+1),ILNGTH,KBITS,
     X                  IWIDTH,YOPER,IRET)
C
            IF (IRET.NE.0) THEN
              IRETFN = 24320
              WRITE(GRPRSM,FMT=9310) 'BLOCK', JBLOCK, ILNGTH, IWIDTH
              GO TO 900
            ENDIF          
C
          ELSE
C
C             Split current block into individual bits, stored into
C             array KREFGR (one bit per index value).
C
C             Start processing by "full" packets of 7-bit wide.
C             (even if 7-bit wide, last packet is processed separately).
C
            INTERM=(IWIDTH-1)/7
            IWIDPR=0
C
            DO 322 JTIMES=1,INTERM
C
              IOFF=ILBITS+IWIDPR
              IWIDPR=IWIDPR+7
              IPOWER=KPOWER(IWIDTH-IWIDPR)+1
C
#ifdef CRAY
CDIR$ IVDEP
#endif
#ifdef FUJITSU
!OCL NOVREC
#endif
              DO 321 J=1,ILNGTH
C
                IDATA=KDATA(ICOUNB+J)/IPOWER
                KDATA(ICOUNB+J)=KDATA(ICOUNB+J)-IPOWER*IDATA
                IBIT=IDATA/64
                KREFGR(IOFF+1)=IBIT
                IDATA=IDATA-64*IBIT
                IBIT=IDATA/32
                KREFGR(IOFF+2)=IBIT
                IDATA=IDATA-32*IBIT
                IBIT=IDATA/16
                KREFGR(IOFF+3)=IBIT
                IDATA=IDATA-16*IBIT
                IBIT=IDATA/8
                KREFGR(IOFF+4)=IBIT
                IDATA=IDATA-8*IBIT
                IBIT=IDATA/4
                KREFGR(IOFF+5)=IBIT
                IDATA=IDATA-4*IBIT
                IBIT=IDATA/2
                KREFGR(IOFF+6)=IBIT
                KREFGR(IOFF+7)=IDATA-2*IBIT
                IOFF=IOFF+IWIDTH
C
  321         CONTINUE
C
  322       CONTINUE
C
C             Now process last packet of bits (least significant ones).
C             No more use to restore KDATA.
C
            IOFF=ILBITS+IWIDPR
            IPRWID=IWIDTH-IWIDPR
C
            IF (IPRWID.EQ.7) THEN
C
#ifdef CRAY
CDIR$ IVDEP
#endif
#ifdef FUJITSU
!OCL NOVREC
#endif
              DO 323 J=1,ILNGTH
C
                IBIT=KDATA(ICOUNB+J)/64
                KREFGR(IOFF+1)=IBIT
                IDATA=KDATA(ICOUNB+J)-64*IBIT
                IBIT=IDATA/32
                KREFGR(IOFF+2)=IBIT
                IDATA=IDATA-32*IBIT
                IBIT=IDATA/16
                KREFGR(IOFF+3)=IBIT
                IDATA=IDATA-16*IBIT
                IBIT=IDATA/8
                KREFGR(IOFF+4)=IBIT
                IDATA=IDATA-8*IBIT
                IBIT=IDATA/4
                KREFGR(IOFF+5)=IBIT
                IDATA=IDATA-4*IBIT
                IBIT=IDATA/2
                KREFGR(IOFF+6)=IBIT
                KREFGR(IOFF+7)=IDATA-2*IBIT
                IOFF=IOFF+IWIDTH
C
  323         CONTINUE
C
            ELSEIF (IPRWID.EQ.6) THEN
C
#ifdef CRAY
CDIR$ IVDEP
#endif
#ifdef FUJITSU
!OCL NOVREC
#endif
              DO 324 J=1,ILNGTH
C
                IBIT=KDATA(ICOUNB+J)/32
                KREFGR(IOFF+1)=IBIT
                IDATA=KDATA(ICOUNB+J)-32*IBIT
                IBIT=IDATA/16
                KREFGR(IOFF+2)=IBIT
                IDATA=IDATA-16*IBIT
                IBIT=IDATA/8
                KREFGR(IOFF+3)=IBIT
                IDATA=IDATA-8*IBIT
                IBIT=IDATA/4
                KREFGR(IOFF+4)=IBIT
                IDATA=IDATA-4*IBIT
                IBIT=IDATA/2
                KREFGR(IOFF+5)=IBIT
                KREFGR(IOFF+6)=IDATA-2*IBIT
                IOFF=IOFF+IWIDTH
C
  324         CONTINUE
C
            ELSEIF (IPRWID.EQ.5) THEN
C
#ifdef CRAY
CDIR$ IVDEP
#endif
#ifdef FUJITSU
!OCL NOVREC
#endif
              DO 325 J=1,ILNGTH
C
                IBIT=KDATA(ICOUNB+J)/16
                KREFGR(IOFF+1)=IBIT
                IDATA=KDATA(ICOUNB+J)-16*IBIT
                IBIT=IDATA/8
                KREFGR(IOFF+2)=IBIT
                IDATA=IDATA-8*IBIT
                IBIT=IDATA/4
                KREFGR(IOFF+3)=IBIT
                IDATA=IDATA-4*IBIT
                IBIT=IDATA/2
                KREFGR(IOFF+4)=IBIT
                KREFGR(IOFF+5)=IDATA-2*IBIT
                IOFF=IOFF+IWIDTH
C
  325         CONTINUE
C
            ELSEIF (IPRWID.EQ.4) THEN
C
#ifdef CRAY
CDIR$ IVDEP
#endif
#ifdef FUJITSU
!OCL NOVREC
#endif
              DO 326 J=1,ILNGTH
C
                IBIT=KDATA(ICOUNB+J)/8
                KREFGR(IOFF+1)=IBIT
                IDATA=KDATA(ICOUNB+J)-8*IBIT
                IBIT=IDATA/4
                KREFGR(IOFF+2)=IBIT
                IDATA=IDATA-4*IBIT
                IBIT=IDATA/2
                KREFGR(IOFF+3)=IBIT
                KREFGR(IOFF+4)=IDATA-2*IBIT
                IOFF=IOFF+IWIDTH
C
  326         CONTINUE
C
            ELSEIF (IPRWID.EQ.3) THEN
C
#ifdef CRAY
CDIR$ IVDEP
#endif
#ifdef FUJITSU
!OCL NOVREC
#endif
              DO 327 J=1,ILNGTH
C
                IBIT=KDATA(ICOUNB+J)/4
                KREFGR(IOFF+1)=IBIT
                IDATA=KDATA(ICOUNB+J)-4*IBIT
                IBIT=IDATA/2
                KREFGR(IOFF+2)=IBIT
                KREFGR(IOFF+3)=IDATA-2*IBIT
                IOFF=IOFF+IWIDTH
C
  327         CONTINUE
C
            ELSEIF (IPRWID.EQ.2) THEN
C
#ifdef CRAY
CDIR$ IVDEP
#endif
#ifdef FUJITSU
!OCL NOVREC
#endif
              DO 328 J=1,ILNGTH
C
                IBIT=KDATA(ICOUNB+J)/2
                KREFGR(IOFF+1)=IBIT
                KREFGR(IOFF+2)=KDATA(ICOUNB+J)-2*IBIT
                IOFF=IOFF+IWIDTH
C
  328         CONTINUE
C
            ELSE
C
              DO 329 J=1,ILNGTH
C
                KREFGR(IOFF+1)=KDATA(ICOUNB+J)
                IOFF=IOFF+IWIDTH
C
  329         CONTINUE
C
            ENDIF
C
            ILBITS=ILBITS+ILNGTH*IWIDTH
C
          ENDIF
C
          ICOUNB=ICOUNB+ILNGTH
C
  399   CONTINUE
C
        IF (ILBITS.NE.0) THEN
C
C             Last flush for work array of split bits. Pack it.
C
#ifdef ebug2o
          PRINT *,'c2pkvw - blocks..',IBLOCK,
     X            ' KNSPT/ILBITS = ',
     X              KNSPT, ILBITS
#endif
          CALL INXBIT(KGRIB,KLENG,KNSPT,KREFGR,ILBITS,KBITS,
     X                1,YOPER,IRET)
C
          IF (IRET.NE.0) THEN
            IRETFN = 24320
            WRITE(GRPRSM,FMT=9320) IBLOCK, ILBITS
            GO TO 900
          ENDIF
C
        ENDIF
C
      ENDIF
C
C
C     -----------------------------------------------------------------
C*    Section 9. Return to calling routine.
C     -----------------------------------------------------------------
C
  900 CONTINUE
C
      KCOUNT=ICOUNT
      C2PKVW = IRETFN
#ifndef ebug2o
C
      IF (ODEBUG) THEN
#endif
        WRITE(GRPRSM,FMT=9900) IRETFN, KNSPT
#ifndef ebug2o
      ENDIF
#endif
C
      RETURN
C
 9100 FORMAT (' C2PKVW: Function start, KNSPT =',I10,'.')
C
 9310 FORMAT (' C2PKVW: Problem inserting 2nd-order values, ',A,I7,
     S        ',',I6,'*',I2,' bits.')
C
 9320 FORMAT (' C2PKVW: Problem inserting 2nd-order values, blocks..',
     S        I7,',',I9,' bits.')
C
 9900 FORMAT (' C2PKVW: Function return code =',I6,', KNSPT =',I10,'.')
C
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities
C granted to it by virtue of its status as an intergovernmental organisation
C nor does it submit to any jurisdiction.
C

      SUBROUTINE JWINDLL( PSHUP, KTRUNC, PSTART, PBUILD, PINTVL, KLUNIT,
     X                    KLATO,KLONO,PLEG,PTRIGS,KMFAX,PZFA,KRET)
C
C---->
C**** JWINDLL
C
C     Purpose
C     -------
C     This routine converts spectral input fields to standard
C     lat/long grid fields for wind components U and V.
C
C
C     Interface
C     ---------
C     CALL JWINDLL( PSHUP, KTRUNC, PSTART, PBUILD, PINTVL, KLUNIT,
C    X              KLATO,KLONO,PLEG,PTRIGS,KMFAX,PZFA,KRET)
C
C
C     Input parameters
C     ----------------
C     PSHUP  - Spherical harmonics field, unpacked
C     KTRUNC - Truncation number of spherical harmonics field
C     PSTART - Start latitude (northernmost) for output field
C              (must be positive - see comments below)
C     PBUILD - Grid interval used to build the legendre coefficients file
C     PINTVL - Grid latitude interval in degrees
C     KLUNIT - stream number of the legendre function file
C     KLATO  - Number of latitude points in output field
C     KLONO  - Number of longitude points in output field
C     PLEG   - Array used to hold legendre functions
C     PTRIGS - Initialized array of trig.functions (setup by JJSET99)
C     KMFAX  - Initialized array of prime factors (setup by JJSET99)
C
C
C     Output parameters
C     -----------------
C     PZFA - Output grid point field; contains upto 32 each of
C            North and South latitude rows symmetrically.
C     KRET - Return status code
C            0 = OK
C
C
C     Common block usage
C     ------------------
C     JDCNDBG
C
C
C     Method
C     ------
C     None.
C
C
C     Externals
C     ---------
C     JREADLL - Reads the legendre functions for a latitude
C     JSPPOLE - Applies correction at North or South pole
C     FFT99   - Carries out FFT
C     INTLOG  - Output log message
C     INTLOGR - Output log message (with real value)
C     GETENV  - Pick up contents of an environment variable
C     JUVPOLE - Use gaussian grid to calculate U and V at the poles
C
C
C     Reference
C     ---------
C     E.C.M.W.F. Research Department technical memorandum no. 56
C                "The forecast and analysis post-processing package"
C                May 1982. J.Haseler.
C
C
C     Comments
C     --------
C     This is a redesign, based on SPECGP.F
C
C     It handles transformation to a regular lat/long grid.
C     The generated grid is symmetrical about the equator, so
C     PSTART must be positive.
C
C     It is only for U and V fields (correction is applied at the
C     poles and a scale factor is applied according to latitude).
C
C
C     Author
C     ------
C     J.D.Chambers      *ECMWF*      Nov 1993
C
C
C     Modifications
C     -------------
C     J.D.Chambers     ECMWF        Feb 1997
C     Allow for 64-bit pointers
C
C     J.D.Chambers     ECMWF        October 2002
C     Add handling for U/V spectral (as opposed to Ucos(theta)/Vcos(theta))
C
C
C----<
C     -----------------------------------------------------------------|
C
C
      IMPLICIT NONE
#include "jparams.h"
#include "parim.h"
#include "nifld.common"
C
C     Subroutine arguments
C
      COMPLEX   PSHUP
      DIMENSION PSHUP(*)
      INTEGER   KTRUNC
      REAL      PSTART, PBUILD, PINTVL
      INTEGER   KLUNIT, KLATO, KLONO, KMFAX, KRET
      REAL PLEG, PTRIGS, PZFA
      DIMENSION PZFA(JPLONO + 2, 64)
      DIMENSION KMFAX(*), PLEG(*), PTRIGS(*)
C
C     Parameters
C
      INTEGER JPROUTINE
      PARAMETER ( JPROUTINE = 31400 )
C
C     Local variables
C
      REAL ZPIBY2, ZDEGR, ZLAT
      INTEGER ILIM, IMLIM, ILN
      INTEGER ITAL, ITALA, ITALS, IMN, IMP
      INTEGER INORTH, ISOUTH
      INTEGER JM, J245, JNEXTLAT
      INTEGER NERR
      INTEGER*8 IOFF
      INTEGER*8 JDCLOOP
      REAL ZF
      REAL ZCOSI
C
      DIMENSION ZF(2*JPFFT)
C
#ifndef _CRAYFTN
#ifdef POINTER_64
      INTEGER*8 IWORK
#endif
#endif
      REAL WORK
      DIMENSION WORK(1)
      POINTER ( IWORK, WORK )
      COMPLEX   ZDUM(JPTRNC + 1)
      COMPLEX   ZSUMS(JPTRNC + 1), ZSUMA(JPTRNC + 1)
      COMPLEX*16 CHOLD
      INTEGER LOOP
C
      LOGICAL LXFIRST, LPLAINU
      INTEGER ISIZE, IBLANK
      CHARACTER*10 PLAINUV
C
      DATA LXFIRST/.TRUE./, LPLAINU/.FALSE./
      DATA ISIZE/0/
      SAVE ISIZE, IWORK, LXFIRST, LPLAINU
C
C     Statement function
C
      LOGICAL GPOLE
      REAL ANGLE
      GPOLE(ANGLE) = ( ABS(90.0 - ABS(ANGLE) ) .LT. 1.0E-3 )
C                  = .TRUE. if LAT is 90.0 or -90.0
C
C     -----------------------------------------------------------------|
C*    Section 1.    Initialization.
C     -----------------------------------------------------------------|
C
  100 CONTINUE
      IOFF = 0
C
C     Check environment variable to see if wind components are plain
C     U and V, or U*cos(theta) and V*cos(theta) (the default).
C
      IF( LXFIRST ) THEN
C
        LXFIRST = .FALSE.
        CALL GETENV('INTERP_PLAIN_UV', PLAINUV)
        IBLANK = INDEX(PLAINUV, ' ')
C
        IF( (IBLANK.EQ.3).AND.(PLAINUV(1:2).EQ.'ON') )  LPLAINU =.TRUE.
        IF( (IBLANK.EQ.3).AND.(PLAINUV(1:2).EQ.'on') )  LPLAINU =.TRUE.
        IF( (IBLANK.EQ.4).AND.(PLAINUV(1:3).EQ.'YES') ) LPLAINU =.TRUE.
        IF( (IBLANK.EQ.4).AND.(PLAINUV(1:3).EQ.'yes') ) LPLAINU =.TRUE.
C
        IF( (IBLANK.EQ.3).AND.(PLAINUV(1:2).EQ.'NO') )  LPLAINU =.FALSE.
        IF( (IBLANK.EQ.3).AND.(PLAINUV(1:2).EQ.'no') )  LPLAINU =.FALSE.
        IF( (IBLANK.EQ.4).AND.(PLAINUV(1:3).EQ.'OFF') ) LPLAINU =.FALSE.
        IF( (IBLANK.EQ.4).AND.(PLAINUV(1:3).EQ.'off') ) LPLAINU =.FALSE.
C
C       First time through, dynamically allocate memory for workspace
C
        ISIZE =  2*JPFFT*64
        CALL JMEMHAN( 9, IWORK, ISIZE, 1, KRET)
        IF( KRET.NE.0 ) THEN
          CALL INTLOG(JP_ERROR,'JWINDLL: memory allocation error',IWORK)
          KRET = JPROUTINE + 1
          GOTO 990
        ENDIF
      ENDIF
C
      IF( NDBG.GT.1 ) THEN
        CALL INTLOG(JP_DEBUG,
     X    'JWINDLL: Spherical harmonic coeffs(first 20):',JPQUIET)
        DO NDBGLP = 1, 20
          CALL INTLOGR(JP_DEBUG,' ',PSHUP( NDBGLP ))
        ENDDO
        CALL INTLOG(JP_DEBUG,
     X    'JWINDLL: Input parameters:',JPQUIET)
        CALL INTLOG(JP_DEBUG,
     X    'JWINDLL: Spherical harmonic truncation = ', KTRUNC)
        CALL INTLOGR(JP_DEBUG,
     X    'JWINDLL: Start latitude(northernmost) = ', PSTART)
        CALL INTLOGR(JP_DEBUG,
     X    'JWINDLL: Grid lat. interval(leg. file) = ', PBUILD)
        CALL INTLOGR(JP_DEBUG,
     X    'JWINDLL: Grid lat. interval(degrees) = ', PINTVL)
        CALL INTLOG(JP_DEBUG,
     X    'JWINDLL: Stream number of leg. file = ', KLUNIT)
        CALL INTLOG(JP_DEBUG,
     X    'JWINDLL: Number of lat. rows in output = ', KLATO)
        CALL INTLOG(JP_DEBUG,
     X    'JWINDLL: Number of long. pts per row = ', KLONO)
        CALL INTLOG(JP_DEBUG,
     X    'JWINDLL: Trig.functions (setup by JJSET99):',JPQUIET)
        DO NDBGLP = 1, 10
          CALL INTLOGR(JP_DEBUG,' ',PTRIGS( NDBGLP ))
        ENDDO
        CALL INTLOG(JP_DEBUG,
     X    'JWINDLL: Prime factors (setup by JJSET99):',JPQUIET)
        DO NDBGLP = 1, 10
          CALL INTLOG(JP_DEBUG,' ',KMFAX( NDBGLP ))
        ENDDO
      ENDIF
C
      ZPIBY2 = PPI / 2.0
      ZDEGR  = PPI / 180.0
      ILIM   = KTRUNC + 1
      IMLIM  = KTRUNC + 1
      INORTH = -1
      ILN    = KLONO + 2
C
C     -----------------------------------------------------------------|
C*    Section 2.    Main loop through latitude rows to
C*                  calculate fourier coefficients
C     -----------------------------------------------------------------|
C
 200  CONTINUE
C
C     For each latitude, the north and corresponding south latitude row
C     are calculated at the same time from the same legendre functions.
C
      DO 280 JNEXTLAT = 1, KLATO
        ZLAT  = ( PSTART - (PINTVL * REAL(JNEXTLAT - 1)) )
C
        IF( NDBG.GT.1 )
     X    CALL INTLOGR(JP_DEBUG, 'JWINDLL: Next latitude = ', ZLAT)
C
C       If required, generate the coefficients 'on the fly'
C
        IF( LON_FLY ) THEN
          CALL NMAKLL( KTRUNC, PBUILD, ZLAT, 1, PLEG, NERR)
          IOFF = 0
        ELSE IF( LFILEIO ) THEN
          CALL JREADLL( KLUNIT, KTRUNC, PBUILD, ZLAT, PLEG, NERR)
          IF ( NERR .NE. 0 ) THEN
            CALL INTLOG(JP_ERROR,'JWINDLL: JREADLL error',NERR)
            KRET = JPROUTINE + 2
            GOTO 990
          ENDIF
        ELSE
            IOFF = NINT( (90.0 - ZLAT)/PBUILD )
            IOFF = IOFF *(KTRUNC+1)
            IOFF = IOFF *(KTRUNC+4)
            IOFF = IOFF/2
        ENDIF
C
C     Clear unused slots in array.
C     Note there are two slots in the array - one for north latitude
C     and one for the corresponding south latitude.
        INORTH = INORTH + 2
        ISOUTH = INORTH + 1
        DO LOOP = 1, ILN
          ZF( LOOP) = 0.0
          PZFA( LOOP, INORTH) = 0.0
          PZFA( LOOP, ISOUTH) = 0.0
        ENDDO
C
C       For spectral Ucos(theta), Vcos(theta), treat the poles as a
C       special case.
C
        IF( GPOLE(ZLAT).AND.(.NOT.LPLAINU) ) THEN
C
          IF( NDBG.GT.1 ) CALL INTLOG(JP_DEBUG,
     X      'JWINDLL: Pole special for spectral Ucos(t), Vcos(t)',
     X      JPQUIET)
C
          CALL JSPPOLE( PSHUP, 1, KTRUNC, .TRUE., ZF)
          DO LOOP = 1, ILN
            PZFA( LOOP, INORTH) = ZF( LOOP)
          ENDDO
C
          CALL JSPPOLE( PSHUP, 0, KTRUNC, .TRUE., ZF)
          DO LOOP = 1, ILN
            PZFA( LOOP, ISOUTH) = ZF( LOOP)
          ENDDO
C
        ELSE
C
C       Otherwise not at pole, or spectral U and V
C
C         Fill slots which are used
          IMN = 0
          IMP = 0
C
          DO 247 JM = 1, IMLIM
            ITAL = ILIM - JM + 1
            DO 245 J245 = 1, ITAL
              IF( LFILEIO ) THEN
                ZDUM(J245) = PLEG(IMP + J245)*PSHUP(IMN + J245)
              ELSE
                JDCLOOP = IMP + J245 + IOFF
                ZDUM(J245) = PLEG(JDCLOOP)*PSHUP(IMN + J245)
              ENDIF
 245        CONTINUE
            IMP = IMP + ITAL + 1
            IMN = IMN + ITAL
            ITALS = (ITAL + 1)/2
            ITALA = ITAL/2
            CHOLD = (0.0D0, 0.0D0)
            DO LOOP = 1, 2*ITALS, 2
              CHOLD = CHOLD + ZDUM(LOOP)
            ENDDO
            ZSUMS(JM) = CHOLD
            CHOLD = (0.0D0, 0.0D0)
            DO LOOP = 2, 2*ITALA, 2
              CHOLD = CHOLD + ZDUM(LOOP)
            ENDDO
            ZSUMA(JM) = CHOLD
 247      CONTINUE
C
C       For the southern hemisphere row, the legendre functions are
C       the complex conjugates of the corresponding northern row -
C       hence the juggling with the signs in the next loop.
C
C       Note that PZFA is REAL, but the coefficients being calculated
C       are COMPLEX.  There are pairs of values for each coefficient
C       (real and imaginary parts) and pairs of values for each
C       latitude (north and south).
C
          DO JM = 1, IMLIM
            PZFA(2*JM -1, INORTH) = REAL(ZSUMS(JM))  + REAL(ZSUMA(JM))
            PZFA(2*JM   , INORTH) = AIMAG(ZSUMS(JM)) + AIMAG(ZSUMA(JM))
            PZFA(2*JM -1, ISOUTH) = REAL(ZSUMS(JM))  - REAL(ZSUMA(JM))
            PZFA(2*JM   , ISOUTH) = AIMAG(ZSUMS(JM)) - AIMAG(ZSUMA(JM))
          ENDDO
        ENDIF
C
C*    End of main loop through latitude rows.
C
 280  CONTINUE
C
C     -----------------------------------------------------------------|
C*    Section 3.    Fast fourier transform
C     -----------------------------------------------------------------|
C
 300  CONTINUE
C
      IF( NDBG.GT.1 ) CALL INTLOG(JP_DEBUG,
     X  'JWINDLL: FFT, no.of rows (N and S) = ', ISOUTH)
C
      CALL FFT99(PZFA,WORK,PTRIGS,KMFAX,1,JPLONO+2,KLONO,ISOUTH,1)
C
      IF( NDBG.GT.1 ) THEN
        CALL INTLOG(JP_DEBUG,
     X    'JWINDLL: Values calculated by FFT:',JPQUIET)
        DO NDBGLP = 1, 20
          CALL INTLOGR(JP_DEBUG,' ',PZFA( 1, NDBGLP ))
          CALL INTLOGR(JP_DEBUG,' ',PZFA( 2, NDBGLP ))
        ENDDO
      ENDIF
C
C     For spectral U, V generate the poles from a reduced gaussian line
C     of latitude.
C
      IF( GPOLE(PSTART).AND.(LPLAINU) ) THEN
C
        IF( NDBG.GT.1 ) CALL INTLOG(JP_DEBUG,
     X    'JWINDLL: Poles generated from gaussian for spectral U, V',
     X    JPQUIET)
C
        CALL JUVPOLE(PSHUP, KTRUNC, PZFA, KLONO, KRET)
        IF( KRET.NE.0 ) THEN
          CALL INTLOG(JP_ERROR,'JWINDLL: pole wind create error',IWORK)
          KRET = JPROUTINE + 1
          GOTO 990
        ENDIF
C
      ENDIF
C
C     -----------------------------------------------------------------|
C*    Section 4.    For spectral Ucos(theta), Vcos(theta), apply scale
C                   factor to all latitudes except poles.
C     -----------------------------------------------------------------|
C
 400  CONTINUE
C
      IF( NDBG.GT.0 ) THEN
        IF( LPLAINU ) THEN
          CALL INTLOG(JP_DEBUG,
     X      'JWINDLL: Do not apply scale to latitudes',JPQUIET)
        ELSE
          CALL INTLOG(JP_DEBUG,
     X      'JWINDLL: Apply scale to latitudes',JPQUIET)
        ENDIF
      ENDIF
C
      IF( .NOT.LPLAINU ) THEN
        INORTH = -1
        DO JNEXTLAT = 1, KLATO
          ZLAT  = ( PSTART - (PINTVL * REAL(JNEXTLAT - 1)) )
          INORTH = INORTH + 2
          ISOUTH = INORTH + 1
          IF( .NOT.GPOLE(ZLAT) ) THEN
            ZCOSI = 1.0 / COS( ZLAT * ZDEGR )
            CALL EMOSLIB_SSCAL( KLONO, ZCOSI, PZFA( 2, INORTH), 1)
            CALL EMOSLIB_SSCAL( KLONO, ZCOSI, PZFA( 2, ISOUTH), 1)
          ENDIF
        ENDDO
C
      ENDIF
C     -----------------------------------------------------------------|
C*    Section 9. Return to calling routine. Format statements
C     -----------------------------------------------------------------|
C
 900  CONTINUE
C
      KRET = 0
C
 990  CONTINUE
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE BUPRQ(KPMISS,KPRUS,KOKEY)
C
C**** *BUPRQ*
C
C
C     PURPOSE.
C     --------
C            SETS VARIABLE KPMISS,KPRUS INTO COMMON BLOCK.
C
C**   INTERFACE.
C     ----------
C
C          *CALL* *BUPRQ(KPMISS,KPRUS,KOKEY)*
C
C        INPUT :
C               *KPMISS*   -  INTEGER VARIABLE
C                            0 - DEFAULT, PAKS MAX VALUE FOR DATA WIDTH -1 BITS.
C
C                            1 - PAKS VALUE AS MISSING VALUE
C               *KPRUS*   -   AN INTEGER 
C                            0 - IF DATA DESCRIPTORS THE SAME REUSE POINTERS
C                            1 - ALWAYS RECALCULATE POINTERS 
C               *KOKEY*    - 0 - DEFAULT, PACKS ECMWF RDB KEY
C                            1 - PACKS SECTION 2 IF NEEDED BUT NOT LENGTH
C                                OF BUFR MESSAGE IN KEY
C
C
C     METHOD.
C     -------
C
C           DURING PACKING THE VALUE TO BE PACKED CAN HAPPEN TO BE TOO BIG
C           TO FIT INTO CORRESPONDING DATA WIDTH. THIS SUBROUTINE  ALLOWS USER
C           TO CHOSE BETWEEN:
C    
C            1)  PACK BIG VALUE AS MAX VALUE REPRESENTED WITH DATA WIDTH -1
C                BITS (DEFAULT)
C            2)  PACK BIG VALUE AS MISSING VALUE
C
C     EXTERNALS.
C     ----------
C
C          NONE
C
C     REFERENCE.
C     ----------
C
C          NONE.
C
C     AUTHOR.
C     -------
C
C          M. DRAGOSAVAC    *ECMWF*       15/01/95.
C
C
C     MODIFICATIONS.
C     --------------
C
C          NONE.
C
C
      IMPLICIT LOGICAL(L,O,G), CHARACTER*8(C,H,Y)
C
#     include "bcprq.F"
C
C     ------------------------------------------------------------------
C
C*          1.   SET CONSTANTS.
C                --------------
 100  CONTINUE
C
      IF(KPMISS.LT.0.OR.KPMISS.GT.1) KPMISS=0
      IF(KPRUS .LT.0.OR.KPRUS.GT.1 ) KPRUS=0
      IF(KOKEY .LT.0.OR.KOKEY.GT.1 ) NOKEY=0
      NPMISS=KPMISS
      NPRUS=KPRUS
      NOKEY=KOKEY
C
      RETURN
      END

C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

       PROGRAM TDEXP
C
C**** *TDEXP*
C
C
C     PURPOSE.
C     --------
C         Expands list of Bufr data descriptors.
C
C
C**   INTERFACE.
C     ----------
C
C          NONE.
C
C     METHOD.
C     -------
C
C          NONE.
C
C
C     EXTERNALS.
C     ----------
C
C         CALL BUSEL
C         CALL BUFREX
C         CALL BUFREN
C         CALL BUPRS0
C         CALL BUPRS1
C         CALL BUPRS2
C         CALL BUPRS3
C         CALL BUPRT
C         CALL BUUKEY
C
C     REFERENCE.
C     ----------
C
C          NONE.
C
C     AUTHOR.
C     -------
C
C          M. DRAGOSAVAC    *ECMWF*       June 2005.
C
C
C     MODIFICATIONS.
C     --------------
C
C          NONE.
C
C
      IMPLICIT LOGICAL(L,O,G), CHARACTER*8(C,H,Y)
C
      PARAMETER(JSEC1=40,JSEC3=4)
      PARAMETER (KDLEN=200,KELEM=40000,KVALS=360000)
C 
      DIMENSION KSEC1(JSEC1)     ! ,KSEC3(JSEC3)
C
      DIMENSION KTDLST(KELEM),KTDEXP(KELEM)
      DIMENSION KDATA(KDLEN)
C
      CHARACTER*64 CNAMES(KELEM)
      CHARACTER*24 CUNITS(KELEM)
C                                                                       
C
C     ------------------------------------------------------------------
C*          1. INITIALIZE CONSTANTS AND VARIABLES.
C              -----------------------------------
 100  CONTINUE
C
C
      RVIND=1.7E38
C
C     INITIALIZE DELAYED REPLICATION FACTORS OR REFERENCE VALUES ETD.
C
C
      KDATA(1)=127
      KDATA(2)=5
      KDATA(3)=5
      KDATA(4)=5
      KDATA(5)=5
C
C     SET DATA DECSRIPTORS
C
      KTDLST(  1)=301090
      KTDLST(  2)=301091
      KTDLST(  3)=302001
      KTDLST(  4)=007004
      KTDLST(  5)=010009
      KTDLST(  6)=302072
      KTDLST(  7)=101005
      KTDLST(  8)=307063
      KTDLST(  9)=302069
      KTDLST( 10)=007032
      KTDLST( 11)=007033
      KTDLST( 12)=020031
      KTDLST( 13)=020032
      KTDLST( 14)=002038
      KTDLST( 15)=022043
      KTDLST( 16)=302021
      KTDLST( 17)=302078
      KTDLST( 18)=302073
      KTDLST( 19)=302074
      KTDLST( 20)=302075
      KTDLST( 21)=004025
      KTDLST( 22)=302076
      KTDLST( 23)=302071
      KTDLST( 24)=004025
      KTDLST( 25)=013059
      KTDLST( 26)=302083
      KTDLST( 27)=033005
      KTDLST( 28)=033006

      KTDLST( 29)=223000
      KTDLST( 30)=236000
      KTDLST( 31)=101000
      KTDLST( 32)=031001
      KTDLST( 33)=031031
      KTDLST( 34)=001031
      KTDLST( 35)=001032
      KTDLST( 36)=008083
      KTDLST( 37)=101000
      KTDLST( 38)=031001
      KTDLST( 39)=223255

      KTDLST( 40)=223000
      KTDLST( 41)=237000
      KTDLST( 42)=001031
      KTDLST( 43)=001032
      KTDLST( 44)=008083
      KTDLST( 45)=101000
      KTDLST( 46)=031001
      KTDLST( 47)=223255

      KTDLST( 48)=223000
      KTDLST( 49)=237000
      KTDLST( 50)=001031
      KTDLST( 51)=001032
      KTDLST( 52)=008083
      KTDLST( 53)=101000
      KTDLST( 54)=031001
      KTDLST( 55)=223255

      KTDLST( 56)=223000
      KTDLST( 57)=237000
      KTDLST( 58)=001031
      KTDLST( 59)=001032
      KTDLST( 60)=008083
      KTDLST( 61)=101000
      KTDLST( 62)=031001
      KTDLST( 63)=223255



      ktdlen=63

C
C     SET DATA DECSRIPTORS
C
C     SECTION 1 CONTENT
C
      KSEC1(2)=4     ! BUFR EDITION NUMBER
      KSEC1(14)=0    ! BUFR MASTER TABLE USED
      ksec1(16)=0    ! ORIGINATING SUB-CENTRE
      KSEC1(3)=98    ! ORIGINATING CENTRE
      KSEC1(8)=1     ! VERSION NUMBER OF LOCAL TABLE USED
      KSEC1(15)=12    ! VERSION NUMBER OF MASTER TABLE USED
C
C     SECTION 3 CONTENT
C
C
c
      K=1
      CALL BUXDES(K,KSEC1,KTDLEN,KTDLST,KDLEN,KDATA,KELEM,
     1            KTDEXL,KTDEXP,CNAMES,CUNITS,KERR)
C
      END

c Copyright 1981-2016 ECMWF.
c
c This software is licensed under the terms of the Apache Licence 
c Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
c
c In applying this licence, ECMWF does not waive the privileges and immunities 
c granted to it by virtue of its status as an intergovernmental organisation 
c nor does it submit to any jurisdiction.
c

C     SUBROUTINE 'QPASSF' - PERFORMS ONE PASS THROUGH DATA AS PART      
C     OF MULTIPLE REAL FFT (FOURIER ANALYSIS) ROUTINE                   
C                                                                       
C     A IS FIRST REAL INPUT VECTOR                                      
C         EQUIVALENCE B(1) WITH A(IFAC*LA*INC1+1)                       
C     C IS FIRST REAL OUTPUT VECTOR                                     
C         EQUIVALENCE D(1) WITH C(LA*INC2+1)                            
C     TRIGS IS A PRECALCULATED LIST OF SINES & COSINES                  
C     INC1 IS THE ADDRESSING INCREMENT FOR A                            
C     INC2 IS THE ADDRESSING INCREMENT FOR C                            
C     INC3 IS THE INCREMENT BETWEEN INPUT VECTORS A                     
C     INC4 IS THE INCREMENT BETWEEN OUTPUT VECTORS C                    
C     LOT IS THE NUMBER OF VECTORS                                      
C     N IS THE LENGTH OF THE VECTORS                                    
C     IFAC IS THE CURRENT FACTOR OF N                                   
C     LA = N/(PRODUCT OF FACTORS USED SO FAR)                           
C     IERR IS AN ERROR INDICATOR:                                       
C              0 - PASS COMPLETED WITHOUT ERROR                         
C              2 - IFAC NOT CATERED FOR                                 
C              3 - IFAC ONLY CATERED FOR IF LA=N/IFAC                   
C     LIPL=.T. => RESULTS ARE RETURNED TO INPUT ARRAY
C              (ONLY VALID IF LA=N/IFAC, I.E. ON FIRST PASS)
C                                                                       
C-----------------------------------------------------------------------
C                                                                       
      SUBROUTINE QPASSF(A,B,C,D,TRIGS,INC1,INC2,INC3,INC4,LOT,N,IFAC,   
     *    LA,IERR,LIPL)                                                      
      DIMENSION A(N),B(N),C(N),D(N),TRIGS(N)                            
      LOGICAL LIPL
C                                                                       
      DATA SIN36/0.587785252292473/,SIN72/0.951056516295154/,           
     *    QRT5/0.559016994374947/,SIN60/0.866025403784437/              
C                                                                       
      M=N/IFAC                                                          
      IINK=LA*INC1                                                      
      JINK=LA*INC2                                                      
      IJUMP=(IFAC-1)*IINK                                               
      KSTOP=(N-IFAC)/(2*IFAC)                                           
C                                                                       
      IBASE=0                                                           
      JBASE=0                                                           
      IBAD=0
C
!     Increase the vector length by fusing the loops if the
!     data layout is appropriate:
      IF (INC1.EQ.LOT.AND.INC2.EQ.LOT.AND.INC3.EQ.1.AND.INC4.EQ.1) THEN
        ILA=1
        ILOT=LA*LOT
        INC11=LA*LOT
      ELSE
        ILA=LA
        ILOT=LOT
        INC11=INC1
      ENDIF

C
      IF (IFAC.EQ.2) THEN
C                                                                       
C     CODING FOR FACTOR 2                                               
C     -------------------                                               
  200 CONTINUE                                                          
      IA=1                                                              
      IB=IA+IINK                                                        
      JA=1                                                              
      JB=JA+(2*M-LA)*INC2                                               
C                                                                       
      IF (LA.NE.M) THEN                                                
C                                                                       
      DO 220 L=1,ILA                                                     
      I=IBASE                                                           
      J=JBASE                                                           
!OCL NOVREC                                                   
      DO 210 IJK=1,ILOT                                                  
      C(JA+J)=A(IA+I)+A(IB+I)                                           
      C(JB+J)=A(IA+I)-A(IB+I)                                           
      I=I+INC3                                                          
      J=J+INC4                                                          
  210 CONTINUE                                                          
      IBASE=IBASE+INC11                                                  
      JBASE=JBASE+INC2                                                  
  220 CONTINUE                                                          
      JA=JA+JINK                                                        
      JINK=2*JINK                                                       
      JB=JB-JINK                                                        
      IBASE=IBASE+IJUMP                                                 
      IJUMP=2*IJUMP+IINK                                                
C
      IF (JA.LT.JB) THEN                                                
      DO 250 K=LA,KSTOP,LA                                              
      KB=K+K                                                            
      C1=TRIGS(KB+1)                                                    
      S1=TRIGS(KB+2)                                                    
      JBASE=0                                                           
      DO 240 L=1,ILA                                                     
      I=IBASE                                                           
      J=JBASE                                                           
!OCL NOVREC                                                   
      DO 230 IJK=1,ILOT                                                  
      C(JA+J)=A(IA+I)+(C1*A(IB+I)+S1*B(IB+I))                           
      C(JB+J)=A(IA+I)-(C1*A(IB+I)+S1*B(IB+I))                           
      D(JA+J)=(C1*B(IB+I)-S1*A(IB+I))+B(IA+I)                           
      D(JB+J)=(C1*B(IB+I)-S1*A(IB+I))-B(IA+I)                           
      I=I+INC3                                                          
      J=J+INC4                                                          
  230 CONTINUE                                                          
      IBASE=IBASE+INC11                                                  
      JBASE=JBASE+INC2                                                  
  240 CONTINUE                                                          
      IBASE=IBASE+IJUMP                                                 
      JA=JA+JINK                                                        
      JB=JB-JINK                                                        
  250 CONTINUE                                                          
      ENDIF
C
      IF (JA.EQ.JB) THEN                                                
      JBASE=0                                                           
      DO 280 L=1,ILA                                                     
      I=IBASE                                                           
      J=JBASE                                                           
!OCL NOVREC                                                   
      DO 270 IJK=1,ILOT                                                  
      C(JA+J)=A(IA+I)                                                   
      D(JA+J)=-A(IB+I)                                                  
      I=I+INC3                                                          
      J=J+INC4                                                          
  270 CONTINUE                                                          
      IBASE=IBASE+INC11                                                  
      JBASE=JBASE+INC2                                                  
  280 CONTINUE                                                          
      ENDIF                                                             
C                                                                       
      ELSE                !!! Case LA=M                                 
      Z=1.0/FLOAT(N)                                                    
      IF (LIPL) THEN
        DO 294 L=1,ILA                                                     
        I=IBASE                                                           
!OCL NOVREC                                                   
        DO 292 IJK=1,ILOT                                                  
        T1=Z*(A(IA+I)-A(IB+I))                                       
        A(IA+I)=Z*(A(IA+I)+A(IB+I))                                       
        A(IB+I)=T1
        I=I+INC3                                                          
  292   CONTINUE                                                          
        IBASE=IBASE+INC11                                                  
  294   CONTINUE                                                          
      ELSE
        DO 298 L=1,ILA                                                     
        I=IBASE                                                           
        J=JBASE                                                           
!OCL NOVREC                                                   
        DO 296 IJK=1,ILOT                                                  
        C(JA+J)=Z*(A(IA+I)+A(IB+I))                                       
        C(JB+J)=Z*(A(IA+I)-A(IB+I))                                       
        I=I+INC3                                                          
        J=J+INC4                                                          
  296   CONTINUE                                                          
        IBASE=IBASE+INC11                                                  
        JBASE=JBASE+INC2                                                  
  298   CONTINUE                                                          
      ENDIF
      ENDIF
C
      ELSEIF (IFAC.EQ.3) THEN
C                                                                       
C     CODING FOR FACTOR 3                                               
C     -------------------                                               
  300 CONTINUE                                                          
      IA=1                                                              
      IB=IA+IINK                                                        
      IC=IB+IINK                                                        
      JA=1                                                              
      JB=JA+(2*M-LA)*INC2                                               
      JC=JB                                                             
C                                                                       
      IF (LA.NE.M) THEN                                                 
C                                                                       
      DO 320 L=1,ILA                                                     
      I=IBASE                                                           
      J=JBASE                                                           
!OCL NOVREC                                                   
      DO 310 IJK=1,ILOT                                                  
      C(JA+J)=A(IA+I)+(A(IB+I)+A(IC+I))                                 
      C(JB+J)=A(IA+I)-0.5*(A(IB+I)+A(IC+I))                             
      D(JB+J)=SIN60*(A(IC+I)-A(IB+I))                                   
      I=I+INC3                                                          
      J=J+INC4                                                          
  310 CONTINUE                                                          
      IBASE=IBASE+INC11                                                  
      JBASE=JBASE+INC2                                                  
  320 CONTINUE                                                          
      JA=JA+JINK                                                        
      JINK=2*JINK                                                       
      JB=JB+JINK                                                        
      JC=JC-JINK                                                        
      IBASE=IBASE+IJUMP                                                 
      IJUMP=2*IJUMP+IINK                                                
C
      IF (JA.LT.JC) THEN                                                
      DO 350 K=LA,KSTOP,LA                                              
      KB=K+K                                                            
      KC=KB+KB                                                          
      C1=TRIGS(KB+1)                                                    
      S1=TRIGS(KB+2)                                                    
      C2=TRIGS(KC+1)                                                    
      S2=TRIGS(KC+2)                                                    
      JBASE=0                                                           
      DO 340 L=1,ILA                                                     
      I=IBASE                                                           
      J=JBASE                                                           
!OCL NOVREC                                                   
      DO 330 IJK=1,ILOT                                                  
      A1=(C1*A(IB+I)+S1*B(IB+I))+(C2*A(IC+I)+S2*B(IC+I))                
      B1=(C1*B(IB+I)-S1*A(IB+I))+(C2*B(IC+I)-S2*A(IC+I))                
      A2=A(IA+I)-0.5*A1                                                 
      B2=B(IA+I)-0.5*B1                                                 
      A3=SIN60*((C1*A(IB+I)+S1*B(IB+I))-(C2*A(IC+I)+S2*B(IC+I)))        
      B3=SIN60*((C1*B(IB+I)-S1*A(IB+I))-(C2*B(IC+I)-S2*A(IC+I)))        
      C(JA+J)=A(IA+I)+A1                                                
      D(JA+J)=B(IA+I)+B1                                                
      C(JB+J)=A2+B3                                                     
      D(JB+J)=B2-A3                                                     
      C(JC+J)=A2-B3                                                     
      D(JC+J)=-(B2+A3)                                                  
      I=I+INC3                                                          
      J=J+INC4                                                          
  330 CONTINUE                                                          
      IBASE=IBASE+INC11                                                  
      JBASE=JBASE+INC2                                                  
  340 CONTINUE                                                          
      IBASE=IBASE+IJUMP                                                 
      JA=JA+JINK                                                        
      JB=JB+JINK                                                        
      JC=JC-JINK                                                        
  350 CONTINUE                                                          
      ENDIF
C
      IF (JA.EQ.JC) THEN                                                
      JBASE=0                                                           
      DO 380 L=1,ILA                                                     
      I=IBASE                                                           
      J=JBASE                                                           
!OCL NOVREC                                                   
      DO 370 IJK=1,ILOT                                                  
      C(JA+J)=A(IA+I)+0.5*(A(IB+I)-A(IC+I))                             
      D(JA+J)=-SIN60*(A(IB+I)+A(IC+I))                                  
      C(JB+J)=A(IA+I)-(A(IB+I)-A(IC+I))                                 
      I=I+INC3                                                          
      J=J+INC4                                                          
  370 CONTINUE                                                          
      IBASE=IBASE+INC11                                                  
      JBASE=JBASE+INC2                                                  
  380 CONTINUE                                                          
      ENDIF                                                             
C                                                                       
      ELSE                 !!! Case LA=M                                
      Z=1.0/FLOAT(N)                                                    
      ZSIN60=Z*SIN60                                                    
      IF (LIPL) THEN
        DO 394 L=1,ILA                                                     
        I=IBASE                                                           
!OCL NOVREC                                                   
        DO 392 IJK=1,ILOT                                                  
        T1=Z*(A(IA+I)-0.5*(A(IB+I)+A(IC+I)))                         
        T2=ZSIN60*(A(IC+I)-A(IB+I))                                  
        A(IA+I)=Z*(A(IA+I)+(A(IB+I)+A(IC+I)))                             
        A(IB+I)=T1
        A(IC+I)=T2
        I=I+INC3                                                          
  392   CONTINUE                                                          
        IBASE=IBASE+INC11                                                  
  394   CONTINUE                                                          
      ELSE
        DO 398 L=1,ILA                                                     
        I=IBASE                                                           
        J=JBASE                                                           
!OCL NOVREC                                                   
        DO 396 IJK=1,ILOT                                                  
        C(JA+J)=Z*(A(IA+I)+(A(IB+I)+A(IC+I)))                             
        C(JB+J)=Z*(A(IA+I)-0.5*(A(IB+I)+A(IC+I)))                         
        D(JB+J)=ZSIN60*(A(IC+I)-A(IB+I))                                  
        I=I+INC3                                                          
        J=J+INC4                                                          
  396   CONTINUE                                                          
        IBASE=IBASE+INC11                                                  
        JBASE=JBASE+INC2                                                  
  398   CONTINUE                                                          
      ENDIF
      ENDIF
C
      ELSEIF (IFAC.EQ.4) THEN
C                                                                       
C     CODING FOR FACTOR 4                                               
C     -------------------                                               
  400 CONTINUE                                                          
      IA=1                                                              
      IB=IA+IINK                                                        
      IC=IB+IINK                                                        
      ID=IC+IINK                                                        
      JA=1                                                              
      JB=JA+(2*M-LA)*INC2                                               
      JC=JB+2*M*INC2                                                    
      JD=JB                                                             
C                                                                       
      IF (LA.NE.M) THEN                                                 
C                                                                       
      DO 420 L=1,ILA                                                     
      I=IBASE                                                           
      J=JBASE                                                           
!OCL NOVREC                                                   
      DO 410 IJK=1,ILOT                                                  
      C(JA+J)=(A(IA+I)+A(IC+I))+(A(IB+I)+A(ID+I))                       
      C(JC+J)=(A(IA+I)+A(IC+I))-(A(IB+I)+A(ID+I))                       
      C(JB+J)=A(IA+I)-A(IC+I)                                           
      D(JB+J)=A(ID+I)-A(IB+I)                                           
      I=I+INC3                                                          
      J=J+INC4                                                          
  410 CONTINUE                                                          
      IBASE=IBASE+INC11                                                  
      JBASE=JBASE+INC2                                                  
  420 CONTINUE                                                          
      JA=JA+JINK                                                        
      JINK=2*JINK                                                       
      JB=JB+JINK                                                        
      JC=JC-JINK                                                        
      JD=JD-JINK                                                        
      IBASE=IBASE+IJUMP                                                 
      IJUMP=2*IJUMP+IINK                                                
C
      IF (JB.LT.JC) THEN                                                
      DO 450 K=LA,KSTOP,LA                                              
      KB=K+K                                                            
      KC=KB+KB                                                          
      KD=KC+KB                                                          
      C1=TRIGS(KB+1)                                                    
      S1=TRIGS(KB+2)                                                    
      C2=TRIGS(KC+1)                                                    
      S2=TRIGS(KC+2)                                                    
      C3=TRIGS(KD+1)                                                    
      S3=TRIGS(KD+2)                                                    
      JBASE=0                                                           
      DO 440 L=1,ILA                                                     
      I=IBASE                                                           
      J=JBASE                                                           
!OCL NOVREC                                                   
      DO 430 IJK=1,ILOT                                                  
      A0=A(IA+I)+(C2*A(IC+I)+S2*B(IC+I))                                
      A2=A(IA+I)-(C2*A(IC+I)+S2*B(IC+I))                                
      A1=(C1*A(IB+I)+S1*B(IB+I))+(C3*A(ID+I)+S3*B(ID+I))                
      A3=(C1*A(IB+I)+S1*B(IB+I))-(C3*A(ID+I)+S3*B(ID+I))                
      B0=B(IA+I)+(C2*B(IC+I)-S2*A(IC+I))                                
      B2=B(IA+I)-(C2*B(IC+I)-S2*A(IC+I))                                
      B1=(C1*B(IB+I)-S1*A(IB+I))+(C3*B(ID+I)-S3*A(ID+I))                
      B3=(C1*B(IB+I)-S1*A(IB+I))-(C3*B(ID+I)-S3*A(ID+I))                
      C(JA+J)=A0+A1                                                     
      C(JC+J)=A0-A1                                                     
      D(JA+J)=B0+B1                                                     
      D(JC+J)=B1-B0                                                     
      C(JB+J)=A2+B3                                                     
      C(JD+J)=A2-B3                                                     
      D(JB+J)=B2-A3                                                     
      D(JD+J)=-(B2+A3)                                                  
      I=I+INC3                                                          
      J=J+INC4                                                          
  430 CONTINUE                                                          
      IBASE=IBASE+INC11                                                  
      JBASE=JBASE+INC2                                                  
  440 CONTINUE                                                          
      IBASE=IBASE+IJUMP                                                 
      JA=JA+JINK                                                        
      JB=JB+JINK                                                        
      JC=JC-JINK                                                        
      JD=JD-JINK                                                        
  450 CONTINUE                                                          
      ENDIF
C
      IF (JB.EQ.JC) THEN                                                
      SIN45=SQRT(0.5)                                                   
      JBASE=0                                                           
      DO 480 L=1,ILA                                                     
      I=IBASE                                                           
      J=JBASE                                                           
!OCL NOVREC                                                   
      DO 470 IJK=1,ILOT                                                  
      C(JA+J)=A(IA+I)+SIN45*(A(IB+I)-A(ID+I))                           
      C(JB+J)=A(IA+I)-SIN45*(A(IB+I)-A(ID+I))                           
      D(JA+J)=-A(IC+I)-SIN45*(A(IB+I)+A(ID+I))                          
      D(JB+J)=A(IC+I)-SIN45*(A(IB+I)+A(ID+I))                           
      I=I+INC3                                                          
      J=J+INC4                                                          
  470 CONTINUE                                                          
      IBASE=IBASE+INC11                                                  
      JBASE=JBASE+INC2                                                  
  480 CONTINUE                                                          
      ENDIF                                                             
C                                                                       
      ELSE              !!! Case LA=M                                   
      Z=1.0/FLOAT(N)                                                    
      IF (LIPL) THEN
        DO 494 L=1,ILA                                                     
        I=IBASE                                                           
!OCL NOVREC                                                   
        DO 492 IJK=1,ILOT                                                  
        T1=Z*(A(IA+I)-A(IC+I))                                       
        T3=Z*(A(ID+I)-A(IB+I))                                       
        T2=Z*((A(IA+I)+A(IC+I))-(A(IB+I)+A(ID+I)))                   
        A(IA+I)=Z*((A(IA+I)+A(IC+I))+(A(IB+I)+A(ID+I)))                   
        A(IB+I)=T1
        A(IC+I)=T2
        A(ID+I)=T3
        I=I+INC3                                                          
  492   CONTINUE                                                          
        IBASE=IBASE+INC11                                                  
  494   CONTINUE                                                          
      ELSE
        DO 498 L=1,ILA                                                     
        I=IBASE                                                           
        J=JBASE                                                           
!OCL NOVREC                                                   
        DO 496 IJK=1,ILOT                                                  
        C(JA+J)=Z*((A(IA+I)+A(IC+I))+(A(IB+I)+A(ID+I)))                   
        C(JC+J)=Z*((A(IA+I)+A(IC+I))-(A(IB+I)+A(ID+I)))                   
        C(JB+J)=Z*(A(IA+I)-A(IC+I))                                       
        D(JB+J)=Z*(A(ID+I)-A(IB+I))                                       
        I=I+INC3                                                          
        J=J+INC4                                                          
  496   CONTINUE                                                          
        IBASE=IBASE+INC11                                                  
        JBASE=JBASE+INC2                                                  
  498   CONTINUE                                                          
      ENDIF
      ENDIF
C
      ELSEIF (IFAC.EQ.5) THEN
C                                                                       
C     CODING FOR FACTOR 5                                               
C     -------------------                                               
  500 CONTINUE                                                          
      IA=1                                                              
      IB=IA+IINK                                                        
      IC=IB+IINK                                                        
      ID=IC+IINK                                                        
      IE=ID+IINK                                                        
      JA=1                                                              
      JB=JA+(2*M-LA)*INC2                                               
      JC=JB+2*M*INC2                                                    
      JD=JC                                                             
      JE=JB                                                             
C                                                                       
      IF (LA.NE.M) THEN                                                 
C                                                                       
      DO 520 L=1,ILA                                                     
      I=IBASE                                                           
      J=JBASE                                                           
!OCL NOVREC                                                   
      DO 510 IJK=1,ILOT                                                  
      A1=A(IB+I)+A(IE+I)                                                
      A3=A(IB+I)-A(IE+I)                                                
      A2=A(IC+I)+A(ID+I)                                                
      A4=A(IC+I)-A(ID+I)                                                
      A5=A(IA+I)-0.25*(A1+A2)                                           
      A6=QRT5*(A1-A2)                                                   
      C(JA+J)=A(IA+I)+(A1+A2)                                           
      C(JB+J)=A5+A6                                                     
      C(JC+J)=A5-A6                                                     
      D(JB+J)=-SIN72*A3-SIN36*A4                                        
      D(JC+J)=-SIN36*A3+SIN72*A4                                        
      I=I+INC3                                                          
      J=J+INC4                                                          
  510 CONTINUE                                                          
      IBASE=IBASE+INC11                                                  
      JBASE=JBASE+INC2                                                  
  520 CONTINUE                                                          
      JA=JA+JINK                                                        
      JINK=2*JINK                                                       
      JB=JB+JINK                                                        
      JC=JC+JINK                                                        
      JD=JD-JINK                                                        
      JE=JE-JINK                                                        
      IBASE=IBASE+IJUMP                                                 
      IJUMP=2*IJUMP+IINK                                                
C
      IF (JB.LT.JD) THEN                                                
      DO 550 K=LA,KSTOP,LA                                              
      KB=K+K                                                            
      KC=KB+KB                                                          
      KD=KC+KB                                                          
      KE=KD+KB                                                          
      C1=TRIGS(KB+1)                                                    
      S1=TRIGS(KB+2)                                                    
      C2=TRIGS(KC+1)                                                    
      S2=TRIGS(KC+2)                                                    
      C3=TRIGS(KD+1)                                                    
      S3=TRIGS(KD+2)                                                    
      C4=TRIGS(KE+1)                                                    
      S4=TRIGS(KE+2)                                                    
      JBASE=0                                                           
      DO 540 L=1,ILA                                                     
      I=IBASE                                                           
      J=JBASE                                                           
!OCL NOVREC                                                   
      DO 530 IJK=1,ILOT                                                  
      A1=(C1*A(IB+I)+S1*B(IB+I))+(C4*A(IE+I)+S4*B(IE+I))                
      A3=(C1*A(IB+I)+S1*B(IB+I))-(C4*A(IE+I)+S4*B(IE+I))                
      A2=(C2*A(IC+I)+S2*B(IC+I))+(C3*A(ID+I)+S3*B(ID+I))                
      A4=(C2*A(IC+I)+S2*B(IC+I))-(C3*A(ID+I)+S3*B(ID+I))                
      B1=(C1*B(IB+I)-S1*A(IB+I))+(C4*B(IE+I)-S4*A(IE+I))                
      B3=(C1*B(IB+I)-S1*A(IB+I))-(C4*B(IE+I)-S4*A(IE+I))                
      B2=(C2*B(IC+I)-S2*A(IC+I))+(C3*B(ID+I)-S3*A(ID+I))                
      B4=(C2*B(IC+I)-S2*A(IC+I))-(C3*B(ID+I)-S3*A(ID+I))                
      A5=A(IA+I)-0.25*(A1+A2)                                           
      A6=QRT5*(A1-A2)                                                   
      B5=B(IA+I)-0.25*(B1+B2)                                           
      B6=QRT5*(B1-B2)                                                   
      A10=A5+A6                                                         
      A20=A5-A6                                                         
      B10=B5+B6                                                         
      B20=B5-B6                                                         
      A11=SIN72*B3+SIN36*B4                                             
      A21=SIN36*B3-SIN72*B4                                             
      B11=SIN72*A3+SIN36*A4                                             
      B21=SIN36*A3-SIN72*A4                                             
      C(JA+J)=A(IA+I)+(A1+A2)                                           
      C(JB+J)=A10+A11                                                   
      C(JE+J)=A10-A11                                                   
      C(JC+J)=A20+A21                                                   
      C(JD+J)=A20-A21                                                   
      D(JA+J)=B(IA+I)+(B1+B2)                                           
      D(JB+J)=B10-B11                                                   
      D(JE+J)=-(B10+B11)                                                
      D(JC+J)=B20-B21                                                   
      D(JD+J)=-(B20+B21)                                                
      I=I+INC3                                                          
      J=J+INC4                                                          
  530 CONTINUE                                                          
      IBASE=IBASE+INC11                                                  
      JBASE=JBASE+INC2                                                  
  540 CONTINUE                                                          
      IBASE=IBASE+IJUMP                                                 
      JA=JA+JINK                                                        
      JB=JB+JINK                                                        
      JC=JC+JINK                                                        
      JD=JD-JINK                                                        
      JE=JE-JINK                                                        
  550 CONTINUE                                                          
      ENDIF
C
      IF (JB.EQ.JD) THEN                                                
      JBASE=0                                                           
      DO 580 L=1,ILA                                                     
      I=IBASE                                                           
      J=JBASE                                                           
!OCL NOVREC                                                   
      DO 570 IJK=1,ILOT                                                  
      A1=A(IB+I)+A(IE+I)                                                
      A3=A(IB+I)-A(IE+I)                                                
      A2=A(IC+I)+A(ID+I)                                                
      A4=A(IC+I)-A(ID+I)                                                
      A5=A(IA+I)+0.25*(A3-A4)                                           
      A6=QRT5*(A3+A4)                                                   
      C(JA+J)=A5+A6                                                     
      C(JB+J)=A5-A6                                                     
      C(JC+J)=A(IA+I)-(A3-A4)                                           
      D(JA+J)=-SIN36*A1-SIN72*A2                                        
      D(JB+J)=-SIN72*A1+SIN36*A2                                        
      I=I+INC3                                                          
      J=J+INC4                                                          
  570 CONTINUE                                                          
      IBASE=IBASE+INC11                                                  
      JBASE=JBASE+INC2                                                  
  580 CONTINUE                                                          
      ENDIF                                                             
C                                                                       
      ELSE                !!! Case LA=M                                 
      Z=1.0/FLOAT(N)                                                    
      ZQRT5=Z*QRT5                                                      
      ZSIN36=Z*SIN36                                                    
      ZSIN72=Z*SIN72                                                    
      IF (LIPL) THEN
        DO 594 L=1,ILA                                                     
        I=IBASE                                                           
!OCL NOVREC                                                   
        DO 592 IJK=1,ILOT                                                  
        A1=A(IB+I)+A(IE+I)                                                
        A3=A(IB+I)-A(IE+I)                                                
        A2=A(IC+I)+A(ID+I)                                                
        A4=A(IC+I)-A(ID+I)                                                
        A5=Z*(A(IA+I)-0.25*(A1+A2))                                       
        A6=ZQRT5*(A1-A2)                                                  
        A(IA+I)=Z*(A(IA+I)+(A1+A2))                                       
        A(IB+I)=A5+A6                                                     
        A(ID+I)=A5-A6                                                     
        A(IC+I)=-ZSIN72*A3-ZSIN36*A4                                      
        A(IE+I)=-ZSIN36*A3+ZSIN72*A4                                      
        I=I+INC3                                                          
  592   CONTINUE                                                          
        IBASE=IBASE+INC11                                                  
  594   CONTINUE                                                          
      ELSE
        DO 598 L=1,ILA                                                     
        I=IBASE                                                           
        J=JBASE                                                           
!OCL NOVREC                                                   
        DO 596 IJK=1,ILOT                                                  
        A1=A(IB+I)+A(IE+I)                                                
        A3=A(IB+I)-A(IE+I)                                                
        A2=A(IC+I)+A(ID+I)                                                
        A4=A(IC+I)-A(ID+I)                                                
        A5=Z*(A(IA+I)-0.25*(A1+A2))                                       
        A6=ZQRT5*(A1-A2)                                                  
        C(JA+J)=Z*(A(IA+I)+(A1+A2))                                       
        C(JB+J)=A5+A6                                                     
        C(JC+J)=A5-A6                                                     
        D(JB+J)=-ZSIN72*A3-ZSIN36*A4                                      
        D(JC+J)=-ZSIN36*A3+ZSIN72*A4                                      
        I=I+INC3                                                          
        J=J+INC4                                                          
  596   CONTINUE                                                          
        IBASE=IBASE+INC11                                                  
        JBASE=JBASE+INC2                                                  
  598   CONTINUE                                                          
      ENDIF
      ENDIF
C
      ELSEIF (IFAC.EQ.6) THEN
C                                                                       
C     CODING FOR FACTOR 6                                               
C     -------------------                                               
  600 CONTINUE                                                          
      IA=1                                                              
      IB=IA+IINK                                                        
      IC=IB+IINK                                                        
      ID=IC+IINK                                                        
      IE=ID+IINK                                                        
      IF=IE+IINK                                                        
      JA=1                                                              
      JB=JA+(2*M-LA)*INC2                                               
      JC=JB+2*M*INC2                                                    
      JD=JC+2*M*INC2                                                    
      JE=JC                                                             
      JF=JB                                                             
C                                                                       
      IF (LA.NE.M) THEN                                                 
C                                                                       
      DO 620 L=1,ILA                                                     
      I=IBASE                                                           
      J=JBASE                                                           
!OCL NOVREC                                                   
      DO 610 IJK=1,ILOT                                                  
      A11=(A(IC+I)+A(IF+I))+(A(IB+I)+A(IE+I))                           
      C(JA+J)=(A(IA+I)+A(ID+I))+A11                                     
      C(JC+J)=(A(IA+I)+A(ID+I)-0.5*A11)                                 
      D(JC+J)=SIN60*((A(IC+I)+A(IF+I))-(A(IB+I)+A(IE+I)))               
      A11=(A(IC+I)-A(IF+I))+(A(IE+I)-A(IB+I))                           
      C(JB+J)=(A(IA+I)-A(ID+I))-0.5*A11                                 
      D(JB+J)=SIN60*((A(IE+I)-A(IB+I))-(A(IC+I)-A(IF+I)))               
      C(JD+J)=(A(IA+I)-A(ID+I))+A11                                     
      I=I+INC3                                                          
      J=J+INC4                                                          
  610 CONTINUE                                                          
      IBASE=IBASE+INC11                                                  
      JBASE=JBASE+INC2                                                  
  620 CONTINUE                                                          
      JA=JA+JINK                                                        
      JINK=2*JINK                                                       
      JB=JB+JINK                                                        
      JC=JC+JINK                                                        
      JD=JD-JINK                                                        
      JE=JE-JINK                                                        
      JF=JF-JINK                                                        
      IBASE=IBASE+IJUMP                                                 
      IJUMP=2*IJUMP+IINK                                                
C
      IF (JC.LT.JD) THEN                                                
      DO 650 K=LA,KSTOP,LA                                              
      KB=K+K                                                            
      KC=KB+KB                                                          
      KD=KC+KB                                                          
      KE=KD+KB                                                          
      KF=KE+KB                                                          
      C1=TRIGS(KB+1)                                                    
      S1=TRIGS(KB+2)                                                    
      C2=TRIGS(KC+1)                                                    
      S2=TRIGS(KC+2)                                                    
      C3=TRIGS(KD+1)                                                    
      S3=TRIGS(KD+2)                                                    
      C4=TRIGS(KE+1)                                                    
      S4=TRIGS(KE+2)                                                    
      C5=TRIGS(KF+1)                                                    
      S5=TRIGS(KF+2)                                                    
      JBASE=0                                                           
      DO 640 L=1,ILA                                                     
      I=IBASE                                                           
      J=JBASE                                                           
!OCL NOVREC                                                   
      DO 630 IJK=1,ILOT                                                  
      A1=C1*A(IB+I)+S1*B(IB+I)                                          
      B1=C1*B(IB+I)-S1*A(IB+I)                                          
      A2=C2*A(IC+I)+S2*B(IC+I)                                          
      B2=C2*B(IC+I)-S2*A(IC+I)                                          
      A3=C3*A(ID+I)+S3*B(ID+I)                                          
      B3=C3*B(ID+I)-S3*A(ID+I)                                          
      A4=C4*A(IE+I)+S4*B(IE+I)                                          
      B4=C4*B(IE+I)-S4*A(IE+I)                                          
      A5=C5*A(IF+I)+S5*B(IF+I)                                          
      B5=C5*B(IF+I)-S5*A(IF+I)                                          
      A11=(A2+A5)+(A1+A4)                                               
      A20=(A(IA+I)+A3)-0.5*A11                                          
      A21=SIN60*((A2+A5)-(A1+A4))                                       
      B11=(B2+B5)+(B1+B4)                                               
      B20=(B(IA+I)+B3)-0.5*B11                                          
      B21=SIN60*((B2+B5)-(B1+B4))                                       
      C(JA+J)=(A(IA+I)+A3)+A11                                          
      D(JA+J)=(B(IA+I)+B3)+B11                                          
      C(JC+J)=A20-B21                                                   
      D(JC+J)=A21+B20                                                   
      C(JE+J)=A20+B21                                                   
      D(JE+J)=A21-B20                                                   
      A11=(A2-A5)+(A4-A1)                                               
      A20=(A(IA+I)-A3)-0.5*A11                                          
      A21=SIN60*((A4-A1)-(A2-A5))                                       
      B11=(B5-B2)-(B4-B1)                                               
      B20=(B3-B(IA+I))-0.5*B11                                          
      B21=SIN60*((B5-B2)+(B4-B1))                                       
      C(JB+J)=A20-B21                                                   
      D(JB+J)=A21-B20                                                   
      C(JD+J)=A11+(A(IA+I)-A3)                                          
      D(JD+J)=B11+(B3-B(IA+I))                                          
      C(JF+J)=A20+B21                                                   
      D(JF+J)=A21+B20                                                   
      I=I+INC3                                                          
      J=J+INC4                                                          
  630 CONTINUE                                                          
      IBASE=IBASE+INC11                                                  
      JBASE=JBASE+INC2                                                  
  640 CONTINUE                                                          
      IBASE=IBASE+IJUMP                                                 
      JA=JA+JINK                                                        
      JB=JB+JINK                                                        
      JC=JC+JINK                                                        
      JD=JD-JINK                                                        
      JE=JE-JINK                                                        
      JF=JF-JINK                                                        
  650 CONTINUE                                                          
      ENDIF
C
      IF (JC.EQ.JD) THEN                                                
      JBASE=0                                                           
      DO 680 L=1,ILA                                                     
      I=IBASE                                                           
      J=JBASE                                                           
!OCL NOVREC                                                   
      DO 670 IJK=1,ILOT                                                  
      C(JA+J)=(A(IA+I)+0.5*(A(IC+I)-A(IE+I)))+ SIN60*(A(IB+I)-A(IF+I))  
      D(JA+J)=-(A(ID+I)+0.5*(A(IB+I)+A(IF+I)))-SIN60*(A(IC+I)+A(IE+I))  
      C(JB+J)=A(IA+I)-(A(IC+I)-A(IE+I))                                 
      D(JB+J)=A(ID+I)-(A(IB+I)+A(IF+I))                                 
      C(JC+J)=(A(IA+I)+0.5*(A(IC+I)-A(IE+I)))-SIN60*(A(IB+I)-A(IF+I))   
      D(JC+J)=-(A(ID+I)+0.5*(A(IB+I)+A(IF+I)))+SIN60*(A(IC+I)+A(IE+I))  
      I=I+INC3                                                          
      J=J+INC4                                                          
  670 CONTINUE                                                          
      IBASE=IBASE+INC11                                                  
      JBASE=JBASE+INC2                                                  
  680 CONTINUE                                                          
      ENDIF                                                             
C                                                                       
      ELSE                !!! Case LA=M                                 
      Z=1.0/FLOAT(N)                                                    
      ZSIN60=Z*SIN60                                                    
      IF (LIPL) THEN
        DO 694 L=1,ILA                                                     
        I=IBASE                                                           
!OCL NOVREC                                                   
        DO 692 IJK=1,ILOT                                                  
        A11=(A(IC+I)-A(IF+I))+(A(IE+I)-A(IB+I))                           
        T1=Z*((A(IA+I)-A(ID+I))-0.5*A11)                             
        T5=Z*((A(IA+I)-A(ID+I))+A11)                                 
        T2=ZSIN60*((A(IE+I)-A(IB+I))-(A(IC+I)-A(IF+I)))              
        T4=ZSIN60*((A(IC+I)+A(IF+I))-(A(IB+I)+A(IE+I)))              
        A11=(A(IC+I)+A(IF+I))+(A(IB+I)+A(IE+I))                           
        T3=Z*((A(IA+I)+A(ID+I))-0.5*A11)                             
        A(IA+I)=Z*((A(IA+I)+A(ID+I))+A11)                                 
        A(IB+I)=T1
        A(IC+I)=T2
        A(ID+I)=T3
        A(IE+I)=T4
        A(IF+I)=T5
        I=I+INC3                                                          
  692   CONTINUE                                                          
        IBASE=IBASE+INC11                                                  
  694   CONTINUE                                                          
      ELSE
        DO 698 L=1,ILA                                                     
        I=IBASE                                                           
        J=JBASE                                                           
!OCL NOVREC                                                   
        DO 696 IJK=1,ILOT                                                  
        A11=(A(IC+I)+A(IF+I))+(A(IB+I)+A(IE+I))                           
        C(JA+J)=Z*((A(IA+I)+A(ID+I))+A11)                                 
        C(JC+J)=Z*((A(IA+I)+A(ID+I))-0.5*A11)                             
        D(JC+J)=ZSIN60*((A(IC+I)+A(IF+I))-(A(IB+I)+A(IE+I)))              
        A11=(A(IC+I)-A(IF+I))+(A(IE+I)-A(IB+I))                           
        C(JB+J)=Z*((A(IA+I)-A(ID+I))-0.5*A11)                             
        D(JB+J)=ZSIN60*((A(IE+I)-A(IB+I))-(A(IC+I)-A(IF+I)))              
        C(JD+J)=Z*((A(IA+I)-A(ID+I))+A11)                                 
        I=I+INC3                                                          
        J=J+INC4                                                          
  696   CONTINUE                                                          
        IBASE=IBASE+INC11                                                  
        JBASE=JBASE+INC2                                                  
  698   CONTINUE                                                          
      ENDIF
      ENDIF
C
      ELSEIF (IFAC.EQ.8) THEN
C                                                                       
C     CODING FOR FACTOR 8                                               
C     -------------------                                               
  800 CONTINUE                                                          
      IF (LA.NE.M) THEN                                            
        IBAD=3                                                            
      ELSE
      IA=1                                                              
      IB=IA+IINK                                                        
      IC=IB+IINK                                                        
      ID=IC+IINK                                                        
      IE=ID+IINK                                                        
      IF=IE+IINK                                                        
      IG=IF+IINK                                                        
      IH=IG+IINK                                                        
      JA=1                                                              
      JB=JA+LA*INC2                                                     
      JC=JB+2*M*INC2                                                    
      JD=JC+2*M*INC2                                                    
      JE=JD+2*M*INC2                                                    
      Z=1.0/FLOAT(N)                                                    
      ZSIN45=Z*SQRT(0.5)                                                
C                                                                       
      IF (LIPL) THEN
        DO 820 L=1,ILA                                                     
        I=IBASE                                                           
!OCL NOVREC                                                   
        DO 810 IJK=1,ILOT                                                  
        T3=Z*((A(IA+I)+A(IE+I))-(A(IC+I)+A(IG+I)))                   
        T4=Z*((A(ID+I)+A(IH+I))-(A(IB+I)+A(IF+I)))                   
        T1=Z*(A(IA+I)-A(IE+I))                                       
     *    +ZSIN45*((A(IH+I)-A(ID+I))-(A(IF+I)-A(IB+I)))                 
        T5=Z*(A(IA+I)-A(IE+I))                                       
     *    -ZSIN45*((A(IH+I)-A(ID+I))-(A(IF+I)-A(IB+I)))                 
        T2=ZSIN45*((A(IH+I)-A(ID+I))+(A(IF+I)-A(IB+I)))              
     *    +Z*(A(IG+I)-A(IC+I))                                          
        T6=ZSIN45*((A(IH+I)-A(ID+I))+(A(IF+I)-A(IB+I)))              
     *    -Z*(A(IG+I)-A(IC+I))                                          
        T7=Z*(((A(IA+I)+A(IE+I))+(A(IC+I)+A(IG+I)))-                 
     *    ((A(ID+I)+A(IH+I))+(A(IB+I)+A(IF+I))))                        
        A(IA+I)=Z*(((A(IA+I)+A(IE+I))+(A(IC+I)+A(IG+I)))+                 
     *    ((A(ID+I)+A(IH+I))+(A(IB+I)+A(IF+I))))                        
        A(IB+I)=T1
        A(IC+I)=T2
        A(ID+I)=T3
        A(IE+I)=T4
        A(IF+I)=T5
        A(IG+I)=T6
        A(IH+I)=T7
        I=I+INC3                                                          
  810   CONTINUE                                                          
        IBASE=IBASE+INC11                                                  
  820   CONTINUE                                                          
      ELSE
        DO 840 L=1,ILA                                                     
        I=IBASE                                                           
        J=JBASE                                                           
!OCL NOVREC                                                   
        DO 830 IJK=1,ILOT                                                  
        C(JA+J)=Z*(((A(IA+I)+A(IE+I))+(A(IC+I)+A(IG+I)))+                 
     *    ((A(ID+I)+A(IH+I))+(A(IB+I)+A(IF+I))))                        
        C(JE+J)=Z*(((A(IA+I)+A(IE+I))+(A(IC+I)+A(IG+I)))-                 
     *    ((A(ID+I)+A(IH+I))+(A(IB+I)+A(IF+I))))                        
        C(JC+J)=Z*((A(IA+I)+A(IE+I))-(A(IC+I)+A(IG+I)))                   
        D(JC+J)=Z*((A(ID+I)+A(IH+I))-(A(IB+I)+A(IF+I)))                   
        C(JB+J)=Z*(A(IA+I)-A(IE+I))                                       
     *    +ZSIN45*((A(IH+I)-A(ID+I))-(A(IF+I)-A(IB+I)))                 
        C(JD+J)=Z*(A(IA+I)-A(IE+I))                                       
     *    -ZSIN45*((A(IH+I)-A(ID+I))-(A(IF+I)-A(IB+I)))                 
        D(JB+J)=ZSIN45*((A(IH+I)-A(ID+I))+(A(IF+I)-A(IB+I)))              
     *    +Z*(A(IG+I)-A(IC+I))                                          
        D(JD+J)=ZSIN45*((A(IH+I)-A(ID+I))+(A(IF+I)-A(IB+I)))              
     *    -Z*(A(IG+I)-A(IC+I))                                          
        I=I+INC3                                                          
        J=J+INC4                                                          
  830   CONTINUE                                                          
        IBASE=IBASE+INC11                                                  
        JBASE=JBASE+INC2                                                  
  840   CONTINUE                                                          
      ENDIF
C
      ENDIF
C
      ELSE
C
        IBAD=2        !!! Illegal factor
C
      ENDIF
C                                                                       
C     RETURN                                                            
C     ------                                                            
  900 CONTINUE                                                          
      IERR=IBAD                                                         
      RETURN                                                            
      END                                                               

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE GRSDBG (KDBG)
C
C---->
C**** GRSDBG - Debug print switch setting for routine GRIBEX.
C
C     Purpose.
C     --------
C
C           Switch debug printout on or off for routine GRIBEX.
C
C**   Interface.
C     ----------
C
C     CALL GRSDBG (KDBG)
C
C     Input Parameters.
C     -----------------
C
C     KDGB        - Debug print switch.
C                   0 , No printout.
C                   Non-zero , Debug printout.
C
C     Output Parameters.
C     ------------------
C
C     None.
C
C     Method.
C     -------
C
C     The variable NDBG is set in the common area. All other
C     parameters are also set to default values, if they have
C     not already been set by the user.
C
C     Externals.
C     ----------
C
C     GRSDEF - Default setting of global variables.
C
C     Reference.
C     ----------
C
C     See subroutine GRIBEX.
C
C     Comments.
C     ---------
C
C     None
C
C     Author.
C     -------
C
C     J. Hennessy      ECMWF      25.06.91
C
C     Modifications.
C     --------------
C
C     J. Hennessy      ECMWF      25.06.91
C     Changes to some comments only.
C
C     J. Hennessy      ECMWF      14.11.91
C     Common areas changed.
C
C     J. Hennessy      ECMWF      07.01.92
C     Input parameter returned unchanged.
C
C     J.D.Chambers     ECMWF      13.09.94
C     Add NONOFF and NOABORT, use grbcom.h
C
C     J. Clochard, Meteo France, for ECMWF - January 1998.
C     Use GRSDEF routine for default setting.
C
C     J. Clochard, Meteo France, for ECMWF - June 1999.
C     Use a static variable to determine if initialisation of
C     default values has already been done for common area
C     variables.
C
C----<
C     ----------------------------------------------------------------
C*    Section 0 . Definition of variables.
C     ----------------------------------------------------------------
C
      IMPLICIT NONE
C
#include "grbcom.h"
C
      INTEGER KDBG
C
      LOGICAL LFIRST
      SAVE LFIRST
C
      DATA LFIRST / .TRUE. /
C
C     ----------------------------------------------------------------
C*    Section 1 . Set values.
C     ----------------------------------------------------------------
C
  100 CONTINUE
C
      IF (LFIRST) THEN
C
C       Common area variables may have not been set, so start by
C       trying to set default values.
C
        CALL GRSDEF
        LFIRST=.FALSE.
C
      ENDIF
C
C     Set debug print to required value.
C
      NDBG   = KDBG
C
C     ----------------------------------------------------------------
C*    Section 9 . Return to calling routine.
C     ----------------------------------------------------------------
C
  900 CONTINUE
C
      RETURN
C
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      INTEGER FUNCTION EOCSEC2(KGRIB,KLENG,INSPT,KSEC2,IBITS)
C
C---->
C**** EOCSEC2P
C
C     PURPOSE
C     _______
C
C     Encodes GRIB section 2 values for ECMWF ocean fields.
C
C     INTERFACE
C     _________
C
C     IRET = EOCSEC2(KGRIB,KLENG,INSPT,KSEC2,IBITS)
C
C     Input parameters
C     ________________
C
C     KGRIB   - GRIB product built so far (upto octet 6). 
C     KLENG   - Length of KGRIB.
C     INSPT   - Bit position of GRIB product built so far.
C     KSEC2   - GRIB section 2 description.
C     IBITS   - Number of bits per element in KGRIB.
C     
C
C     Output parameters
C     ________________
C
C     KGRIB   - Updated GRIB product to end of section 2.
C     INSPT   - Updated bit position of GRIB product built so far.
C     IRET    - Function return status code, 0 = OK
C
C     Common block usage
C     __________________
C
C     None.
C
C     Method
C     ______
C
C     Packs values given in KSEC2 into KGRIB and updates bit
C     pointer INSPT.
C
#include "eocsec2.h"
C
C     Externals
C     _________
C
C     CSGNBT  - Set the sign bit.
C     INXBIT  - Insert bit data.
C
C
C     AUTHOR
C     ______
C
C     J.D.Chambers       ECMWF     February 1999
C
C     MODIFICATIONS
C     _____________
C
C     None.
C
C----<
C     _______________________________________________________
C
C     Section 0. Definition of variables.
C     _______________________________________________________
C
      IMPLICIT NONE
C
#include "common/grprs.h"
C
C     Parameters
C
      INTEGER JP16SET
      PARAMETER ( JP16SET = 2**16 - 1 ) 
C                            ^---> 65535    =   FFFF(hex)
C
C     Function arguments
C
      INTEGER KGRIB,KLENG,INSPT,KSEC2,IBITS
      DIMENSION KGRIB(*),KSEC2(*)
C
C     Local variables
C
      INTEGER IRET, ILOOP
C
C     _______________________________________________________
C
C     Section 1.    Initialization.
C     _______________________________________________________
C
  100 CONTINUE
C
      EOCSEC2 = 0
C
C     _______________________________________________________
C
C     Section 2.    Pack section 2 octets.
C     _______________________________________________________
C
  200 CONTINUE
C
C
C     Octets 7 - 8  : Ni - number of points along a parallel.
C     Octets 9 - 10 : Nj - number of points along a meridian.
C     Two 16 bit fields.
C
      CALL INXBIT(KGRIB,KLENG,INSPT,KSEC2(2),2,IBITS, 16,'C',IRET)
      IF( IRET.NE.0 ) THEN
        EOCSEC2 = 1
        WRITE(GRPRSM,*) 'GRIBEX: Error inserting/extracting'
        WRITE(GRPRSM,*)
     X    'GRIBEX: number of pts along first or second axis.'
        WRITE(GRPRSM,*) 'GRIBEX: Return code = ', IRET
        GO TO 900
      ENDIF
C
C     Octets 11 - 27 : Reserved.
C
C     Fill reserved octets with 0.
C
      DO ILOOP = 1,17
        CALL INXBIT(KGRIB,KLENG,INSPT, 0, 1,IBITS, 8,'C',IRET)
        IF( IRET.NE.0 ) THEN
          EOCSEC2 = 1
          WRITE(GRPRSM,*) 'GRIBEX: Error inserting dummy zero.'
          WRITE(GRPRSM,*) 'GRIBEX: Return code = ', IRET
          GO TO 900
        ENDIF
      ENDDO
C
C     Octet 28 : Scanning mode flags.
C     One 8 bit field.
C
      CALL INXBIT(KGRIB,KLENG,INSPT,KSEC2(11),1,IBITS, 8,'C',IRET)
      IF( IRET.NE.0 ) THEN
        EOCSEC2 = 1
        WRITE(GRPRSM,*) 'GRIBEX: Error inserting/extracting'
        WRITE(GRPRSM,*) 'GRIBEX: scanning mode flags.'
        WRITE(GRPRSM,*) 'GRIBEX: Return code = ', IRET
        GO TO 900
      ENDIF
C
C     Octets 29 - 32 : Reserved.
C
C     Fill reserved octets with 0.
C
      DO ILOOP = 1,4
        CALL INXBIT(KGRIB,KLENG,INSPT, 0, 1,IBITS, 8,'C',IRET)
        IF( IRET.NE.0 ) THEN
          EOCSEC2 = 1
          WRITE(GRPRSM,*) 'GRIBEX: Error inserting dummy zero.'
          WRITE(GRPRSM,*) 'GRIBEX: Return code = ', IRET
          GO TO 900
        ENDIF
      ENDDO
C
C     _______________________________________________________
C
C     Section 9. Return to calling routine.
C     _______________________________________________________
C
  900 CONTINUE
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      INTEGER FUNCTION ELASEC2(KGRIB,KLENG,INSPT,KSEC0,KSEC2,IBITS)
C
C---->
C**** ELASEC2P
C
C     PURPOSE
C     _______
C
C     Encodes GRIB section 2 values for lambert conformal fields.
C
C     INTERFACE
C     _________
C
C     IRET = ELASEC2(KGRIB,KLENG,INSPT,KSEC0,KSEC2,IBITS)
C
C     Input parameters
C     ________________
C
C     KGRIB   - GRIB product built so far (upto octet 6). 
C     KLENG   - Length of KGRIB.
C     INSPT   - Bit position of GRIB product built so far.
C     KSEC0   - GRIB section 0 description.
C     KSEC2   - GRIB section 2 description.
C     IBITS   - Number of bits per element in KGRIB.
C     
C
C     Output parameters
C     ________________
C
C     KGRIB   - Updated GRIB product to end of section 2.
C     INSPT   - Updated bit position of GRIB product built so far.
C     IRET    - Function return status code, 0 = OK
C
C     Common block usage
C     __________________
C
C     None.
C
C     Method
C     ______
C
C     Packs values given in KSEC2 into KGRIB and updates bit
C     pointer INSPT.
C
C     Externals
C     _________
C
C     CSGNBT  - Set the sign bit.
C     INXBIT  - Insert bit data.
C
C
C     AUTHOR
C     ______
C
C     J.D.Chambers       ECMWF     February 1999
C
C     MODIFICATIONS
C     _____________
C
C     None.
C
C----<
C     _______________________________________________________
C
C     Section 0. Definition of variables.
C     _______________________________________________________
C
      IMPLICIT NONE
C
#include "common/grprs.h"
C
C     Function arguments
C
      INTEGER KGRIB,KLENG,INSPT,KSEC0,KSEC2,IBITS
      DIMENSION KGRIB(*),KSEC0(*),KSEC2(*)
C
C     Local variables
C
      INTEGER ILALO(2), IRET, IRESOL
C
C     _______________________________________________________
C
C     Section 1.    Initialization.
C     _______________________________________________________
C
  100 CONTINUE
C
      ELASEC2 = 0
C
C     _______________________________________________________
C
C     Section 2.    Pack section 2 octets.
C     _______________________________________________________
C
  200 CONTINUE
C
C     Octets 7 - 8  : Ni - number of points along X-axis.
C     Octets 9 - 10 : Nj - number of points along Y-axis.
C     Two 16 bit fields.
C
      CALL INXBIT(KGRIB,KLENG,INSPT,KSEC2(2),2,IBITS, 16,'C',IRET)
      IF( IRET.NE.0 ) THEN
        ELASEC2 = 1
        WRITE(GRPRSM,*) 'ELASEC2 Error inserting'
        WRITE(GRPRSM,*) 'ELASEC2 number of points along X or Y axis.'
        WRITE(GRPRSM,*) 'ELASEC2 Return code = ', IRET
        GOTO 900
      ENDIF
C
C     Octets 11 - 13 : La1 - latitude of first grid point.
C     Octets 14 - 16 : Lo1 - longitude of first grid point.
C     Two 24 bit fields.
C
C     Set sign bit to 1, if value is negative.
C 
      CALL CSGNBT( ILALO(1), KSEC2(4), 24, IRET)
      CALL CSGNBT( ILALO(2), KSEC2(5), 24, IRET)
C
      CALL INXBIT(KGRIB,KLENG,INSPT,ILALO(1),2,IBITS, 24,'C',IRET)
      IF( IRET.NE.0 ) THEN
        ELASEC2 = 1
        WRITE(GRPRSM,*) 'ELASEC2 Error inserting'
        WRITE(GRPRSM,*)
     X    'ELASEC2 latitude or longitude of first grid pt.'
        WRITE(GRPRSM,*) 'ELASEC2 Return code = ', IRET
        GOTO 900
      ENDIF
C
C     Octet 17 : Resolution and components flag.
C     One 8 bit field.
C
C     Resolution flag ( KSEC2(6) ) is not applicable.
C
      IRESOL = KSEC2(18)+KSEC2(19)+KSEC2(6)
C
      CALL INXBIT(KGRIB,KLENG,INSPT,IRESOL,1,IBITS, 8,'C',IRET)
      IF( IRET.NE.0 ) THEN
        ELASEC2 = 1
        WRITE(GRPRSM,*) 'ELASEC2 Error inserting'
        WRITE(GRPRSM,*) 'ELASEC2 components flag.'
        WRITE(GRPRSM,*) 'ELASEC2 Return code = ', IRET
        GOTO 900
      ENDIF
C
C     Octets 18 - 20 : LoV - orientation of the grid.
C     One 24 bit field.
C
C     Set sign bit to 1, if value is negative.
C 
      CALL CSGNBT( ILALO(1), KSEC2(7), 24, IRET)
C
      CALL INXBIT(KGRIB,KLENG,INSPT,ILALO(1),1,IBITS, 24,'C',IRET)
      IF( IRET.NE.0 ) THEN
        ELASEC2 = 1
        WRITE(GRPRSM,*) 'ELASEC2 Error inserting'
        WRITE(GRPRSM,*)
     X    'ELASEC2 latitude or longitude of last grid point.'
        WRITE(GRPRSM,*) 'ELASEC2 Return code = ', IRET
        GOTO 900
      ENDIF
C
C     Octets 21 - 23 : Dx - X direction grid length.
C     Octets 24 - 26 : Dy - Y direction grid length.
C     Two 24 bit fields.
C
      CALL INXBIT(KGRIB,KLENG,INSPT,KSEC2(9),2,IBITS, 24,'C',IRET)
      IF( IRET.NE.0 ) THEN
        ELASEC2 = 1
        WRITE(GRPRSM,*) 'ELASEC2 Error inserting'
        WRITE(GRPRSM,*) 'ELASEC2 X or Y axis grid length.'
        WRITE(GRPRSM,*) 'ELASEC2 Return code = ', IRET
        GOTO 900
      ENDIF
C
C     Octet 27 : Projection centre flag.
C     One 8-bit field.
C
      CALL INXBIT(KGRIB,KLENG,INSPT,KSEC2(13),1,IBITS, 8,'C',IRET)
      IF( IRET.NE.0 ) THEN
        ELASEC2 = 1
        WRITE(GRPRSM,*) 'ELASEC2 Error inserting'
        WRITE(GRPRSM,*) 'ELASEC2 Projection centre flag.'
        WRITE(GRPRSM,*) 'ELASEC2 Return code = ', IRET
        GOTO 900
      ENDIF
C
C     Octet 28 : Scanning mode flags.
C     One 8 bit field.
C
      CALL INXBIT(KGRIB,KLENG,INSPT,KSEC2(11),1,IBITS, 8,'C',IRET)
      IF( IRET.NE.0 ) THEN
        ELASEC2 = 1
        WRITE(GRPRSM,*) 'ELASEC2 Error inserting'
        WRITE(GRPRSM,*) 'ELASEC2 scanning mode flags.'
        WRITE(GRPRSM,*) 'ELASEC2 Return code = ', IRET
        GOTO 900
      ENDIF
C
C     Fix-up for flag which was different in Experimental Edition.
C
      IF( KSEC0(2).EQ.-1.AND.KSEC2(11).EQ.1) KSEC2(11) = 0
C
C     Octets 29 - 31 : Latin 1.
C     Octets 32 - 34 : Latin 2.
C     Two 24 bit fields.
C
C     Set sign bit to 1, if value is negative.
C 
      CALL CSGNBT( ILALO(1), KSEC2(14), 24, IRET)
      CALL CSGNBT( ILALO(2), KSEC2(15), 24, IRET)
C
      CALL INXBIT(KGRIB,KLENG,INSPT,ILALO(1),2,IBITS, 24,'C',IRET)
      IF( IRET.NE.0 ) THEN
        ELASEC2 = 1
        WRITE(GRPRSM,*) 'ELASEC2 Error inserting'
        WRITE(GRPRSM,*) 'ELASEC2 Latin1 or Latin2 of secants points.'
        WRITE(GRPRSM,*) 'ELASEC2 Return code = ', IRET
        GOTO 900
      ENDIF
C
C     Octets 35 - 37 : Latitude of the southern pole.
C     Octets 38 - 40 : Longitude of the southern pole.
C     Two 24 bit fields.
C
C     Set sign bit to 1, if value is negative.
C 
      CALL CSGNBT( ILALO(1), KSEC2(20), 24, IRET)
      CALL CSGNBT( ILALO(2), KSEC2(21), 24, IRET)
C
      CALL INXBIT(KGRIB,KLENG,INSPT,ILALO(1),2,IBITS, 24,'C',IRET)
      IF( IRET.NE.0 ) THEN
        ELASEC2 = 1
        WRITE(GRPRSM,*) 'ELASEC2 Error inserting'
        WRITE(GRPRSM,*) 'ELASEC2 latitude/longitude of southern pole.'
        WRITE(GRPRSM,*) 'ELASEC2 Return code = ', IRET
        GOTO 900
      ENDIF
C
C     Octets 41 - 42 : Reserved.
C     One 16 bit fields.
C
C     All bits already set to 0.
C     Update bit pointer.
C 
      INSPT = INSPT + 16
C 
C     _______________________________________________________
C
C     Section 9. Return to calling routine.
C     _______________________________________________________
C
  900 CONTINUE
      RETURN
      END

C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE BUEXS5( KBUFL,KBUFF,KERR)
C
C**** *BUEXS5*
C
C
C     PURPOSE.
C     --------
C          EXPANDS SECTION 5 OF BUFR MESSAGE.
C
C
C**   INTERFACE.
C     ----------
C
C          *CALL* *BUEXS5( KBUFL,KBUFF,KERR)*
C
C        INPUT :
C               *KBUFL*   -  LENGTH OF BUFR MESSAGE (WORDS)
C               *KBUFF*   -  ARRAY CONTAINING BUFR MESSAGE
C        OUTPUT:
C               *KERR*    -  RETURNED ERROR CODE
C
C     METHOD.
C     --------
C
C          NONE.
C
C     EXTERNALS.
C     ----------
C
C          BUNPKS         - UNPACK BIT PATTERN IN REPEATED WAY
C
C     REFERENCE.
C     ----------
C
C          NONE.
C
C     AUTHOR.
C     -------
C
C          M. DRAGOSAVAC    *ECMWF*       15/09/91.
C
C
C     MODIFICATIONS.
C     --------------
C
C          NONE.
C
C
      IMPLICIT LOGICAL(L,O,G), CHARACTER*8(C,H,Y)
C
C
C
#     include "parameter.F"
#     include "bcomunit.F"
#     include "bcomwork.F"
C
      DIMENSION KBUFF(KBUFL)
      DIMENSION IBUFR(4)
#ifndef R_4
      REAL*8 RVIND
      REAL*8 EPS
#else
      REAL   RVIND
      REAL   EPS
#endif
C
      CHARACTER*4 YBUFR
C
C     ------------------------------------------------------------------
C*          1.   EXPAND SECTION 5.
C                -----------------
 100  CONTINUE
C
      IF( KERR.NE.0 ) RETURN
C
      NWPT = NWPTB
      NBPT = NBPTB
C
C
C*          1.2  UNPACK LAST FOUR OCTETS CONTAINING '7777'.
C                ------------------------------------------
C
      CALL BUNPKS(NBPW,KBUFF,IBUFR,NWPT,NBPT,8,0,4,KERR)
C
C*          1.3  CHECK IF THE LAST FOUR OCTETS ARE '7777'.
C                --------------------------------------
      YBUFR=CHAR(IBUFR(1))//CHAR(IBUFR(2))//
     1      CHAR(IBUFR(3))//CHAR(IBUFR(4))
      IF(YBUFR.NE.'7777') THEN
         KERR = 2
         WRITE(KNTN,'(1H ,A)') 'BUEXS5 :'
         CALL BUERR(KERR)
         RETURN
      END IF
C
C     -----------------------------------------------------------------
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE RORINT(PDATA,KDATA,KLEN,HDIR)
C
C---->
C**** RORINT - Conversion of arrays between data types.
C
C     Purpose.
C     --------
C
C     Converts real arrays to integer and vice versa.
C
C**   Interface.
C     ----------
C
C     CALL RORINT(PDATA,KDATA,KLEN,HDIR)
C
C     Input Parameters.
C     -----------------
C
C     KDATA      - Array of integer increments
C                  Input for 'R' function.
C     PDATA      - Array of floating point values.
C                  Input for 'I' function.
C     KLEN       - Number of values to be converted.
C     HDIR       - 'R', convert integer to real.
C                  'I', convert real to integer.
C
C     Output Parameters.
C     -----------------
C
C     KDATA      - Array of integer increments
C                  Output for 'I' function.
C     PDATA      - Array of floating point values.
C                  Output for 'R' function.
C
C     Method.
C     -------
C
C     Data types converted.
C
C     Externals.
C     ----------
C
C     None.
C
C     Reference.
C     ----------
C
C     None.
C
C     Comments.
C     --------
C
C     PDATA and KDATA are really the same array. This routine
C     is just a device to force vectorisation on the Cray,
C     without the necessity of using another array.
C
C
C     Author.
C     -------
C
C     J. Hennessy     ECMWF     27.09.91
C
C     Modifications.
C     _____________
C
C     J.D.Chambers          ECMWF     21.11.94
C     Use JNINT on VAX
C
C     J.D.Chambers    ECMWF     23.10.97
C     Use input and output arrays with same REAL and INTEGER size.
C
C----<
C     -----------------------------------------------------------------
C*    Section 0. Definition of variables.
C     -----------------------------------------------------------------
C
      IMPLICIT NONE
C
#if (defined REAL_BIGGER_THAN_INTEGER)
      INTEGER*8 KDATA
      REAL*8 PDATA
#else
      INTEGER KDATA
      REAL PDATA
#endif
      INTEGER KLEN
      DIMENSION PDATA(KLEN)
      DIMENSION KDATA(KLEN)
      CHARACTER*(1) HDIR
C
      INTEGER JLOOP
C
C     -----------------------------------------------------------------
C*    Section 1 . Conversion of data types.
C     -----------------------------------------------------------------
C
  100 CONTINUE
C
C     Real to integer
C
      IF (HDIR.EQ.'I') THEN
        DO 110 JLOOP = 1, KLEN
#ifdef VAX
          KDATA(JLOOP) = JNINT(PDATA(JLOOP))
#else
          KDATA(JLOOP) = NINT(PDATA(JLOOP))
#endif
  110   CONTINUE
C
C     Integer to real
C
      ELSE
        DO 120 JLOOP = KLEN, 1, -1
#if (defined REAL_BIGGER_THAN_INTEGER)
          PDATA(JLOOP) = DBLE(KDATA(JLOOP))
#else
          PDATA(JLOOP) = REAL(KDATA(JLOOP))
#endif
  120   CONTINUE
      ENDIF
C
C     -----------------------------------------------------------------
C*    Section 9. Return to calling routine.
C     -----------------------------------------------------------------
C
  900 CONTINUE
C
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities
C granted to it by virtue of its status as an intergovernmental organisation
C nor does it submit to any jurisdiction.
C

      INTEGER FUNCTION WV2DIDX(KOLDNUM,NUMOLD,OLDLATS,OLDWEST,OLDEAST,
     X                         KNEWNUM,NUMNEW,NEWLATS,NEWWAVE)
C
C---->
C*****WV2DIDX*
C
C     PURPOSE
C     -------
C
C     Determines which nearest-neighbour values of an input global wave
C     2D-spectra grid field to use for an output global wave 2D-spectra
C     grid field.
C
C
C     INTERFACE
C     ---------
C
C     IRET = WV2DIDX(KOLDNUM,NUMOLD,OLDLATS,OLDWEST,OLDEAST,
C    X               KNEWNUM,NUMNEW,NEWLATS,NEWWAVE)
C
C     Input arguments
C     ---------------
C
C     KOLDNUM - No. of meridians from North to South pole (input field)
C     NUMOLD  - Array giving number of points along each latitude
C               (empty latitudes have entry 0)
C     OLDLATS - input field latitudes
C     OLDWEST - western longitude of the input field (degrees)
C     OLDEAST - eastern longitude of the input field (degrees)
C
C     KNEWNUM - No. of meridians from North to South pole (output field)
C     NUMNEW  - Array giving number of points along each latitude
C               (empty latitudes have entry 0)
C     NEWLATS - output field latitudes
C
C     Output arguments
C     ----------------
C
C     NEWWAVE - Indices of points to use
C
C     Function returns 0 if the interpolation was OK.
C
C
C     METHOD
C     ------
C
C     The index of the nearest neighbouring grid point value of
C     the input field is assigned to each point of the output
C     grid.
C     The index is zero if the output grid point is 'missing'.
C
C     The input field can be regular or quasi-regular, and can be
C     global or a subarea.
C     The output field can be regular or quasi-regular.
C
C
C     EXTERNALS
C     ---------
C
C     INTLOG  - Log error message.
C
C
C     REFERENCE
C     ---------
C
C     None
C
C
C     Author.
C     -------
C
C     J.D.Chambers      ECMWF    October  1997
C
C
C----<
C
      IMPLICIT NONE
C
#include "parim.h"
C
C     Parameters
C
      INTEGER JPROUTINE
      PARAMETER ( JPROUTINE = 19410 )
      INTEGER JPLLMAX
      PARAMETER ( JPLLMAX = 1801 )
C                             `--> allow upto 0.1 degree resolution
      INTEGER JPNMOUT
      PARAMETER ( JPNMOUT = 1800 )
C                             `--> allow upto 0.1 degree resolution
C
C     Function arguments
C
      INTEGER KOLDNUM, NUMOLD, KNEWNUM, NUMNEW
      DIMENSION NUMOLD(*), NUMNEW(*)
      REAL OLDWEST, OLDEAST, OLDLATS, NEWLATS
      DIMENSION OLDLATS(*), NEWLATS(*)
      INTEGER NEWWAVE
      DIMENSION NEWWAVE(*)
C
C     Local arguments
C
      INTEGER NEWCOL, NEWROW, INCOL, LOOP, NEXT, NUMMAX
      INTEGER I_NW, I_SW, I_N, I_S, I_NE, I_SE
      REAL*8 DELONGN, DELONGS, DIFF, RESOL, DINC, DEPS
      REAL*8 DIST_NW, DIST_SW, DIST_NE, DIST_SE, DIST_N, DIST_S
      REAL*4 DISNW, DISNE, DISSW, DISSE
      REAL*8 ZXIN, ZXIS, LON, OWEST, OEAST
      DIMENSION LON(JPNMOUT*2)
      LOGICAL LINGNS, LINGWE
      INTEGER INDEXI
      DIMENSION INDEXI(JPLLMAX)
      LOGICAL LGLOBAL, LFULLG, LGWRAP
      DATA DEPS/0.00005/
C
C ---------------------------------------------------------------------
C*    Section 1. Initalisation.
C ---------------------------------------------------------------------
C
  100 CONTINUE
C
      WV2DIDX = 0
      CALL INTLOG(JP_DEBUG,
     X   'WV2DIDX: Wave interpolation requested.',JPQUIET)
C
C     Check latitude/longitude grid specification
      IF( KOLDNUM.GT.JPLLMAX ) THEN
        CALL INTLOG(JP_ERROR,
     X    'WV2DIDX: Number of latitudes in input grid = ',KOLDNUM)
        CALL INTLOG(JP_ERROR,
     X    'WV2DIDX: And is greater than allowed maximum = ',JPLLMAX)
        WV2DIDX = JPROUTINE + 1
        GOTO 900
      ENDIF
C
C     Set up INDEXI for latitude lines in input lat/lon array
C

      INDEXI(1) = 0
      DO LOOP = 2, KOLDNUM
        INDEXI(LOOP) = INDEXI(LOOP-1) + NUMOLD(LOOP-1)
      ENDDO
C
      OEAST = OLDEAST
      OWEST = OLDWEST

C     Check whether the input field is global or a subarea
C
      NUMMAX = NUMOLD(1)
      DO LOOP = 2, KOLDNUM
        IF( NUMOLD(LOOP).GT.NUMMAX ) NUMMAX = NUMOLD(LOOP)
      ENDDO
      IF( NUMMAX.LE.0 ) THEN
        CALL INTLOG(JP_ERROR,
     X    'WV2DIDX: Input wave field has no points',JPQUIET)
        WV2DIDX = JPROUTINE + 2
        GOTO 900
      ENDIF
C
      LGWRAP = ABS((OEAST-OWEST) - DBLE(360.0)).LT.DEPS
      DINC = 360.0/DBLE(NUMMAX)
      LFULLG = ABS((DMOD((OEAST-OWEST+DBLE(360.0)),DBLE(360.0))
     X              +DINC)-DBLE(360.0)).LT.DEPS
C
      LGLOBAL = LFULLG.OR.LGWRAP
C
C ---------------------------------------------------------------------
C*    Section 2. Interpolation.
C ---------------------------------------------------------------------
C
  200 CONTINUE
C
      NEXT = 1
C
      DO 220 NEWROW = 1, KNEWNUM
C
C       Find old latitude rows to north and south of new latitude and
C       set up the distance between new row and the old rows to N and S.
C
        DO LOOP = 1, KOLDNUM -1
          IF( (NEWLATS(NEWROW).LE.OLDLATS(LOOP)) .AND.
     X        (NEWLATS(NEWROW).GT.OLDLATS(LOOP+1)) ) THEN
            I_N = LOOP
            I_S = MIN(LOOP+1,KOLDNUM)
            GOTO 205
          ENDIF
        ENDDO
C
        IF( NEWLATS(NEWROW).EQ.OLDLATS(KOLDNUM) ) THEN
          I_N = KOLDNUM
          I_S = KOLDNUM
        ELSE
          I_N = -1
          I_S = -1
        ENDIF
C
  205   CONTINUE
        IF( I_N.NE.I_S) THEN
          DIFF   = OLDLATS(I_N) - OLDLATS(I_S)
          DIST_N = (OLDLATS(I_N) - NEWLATS(NEWROW)) / DIFF
        ELSE
          DIST_N = 1.0
        ENDIF
        DIST_S = 1.0 - DIST_N
C
C       Check if the new interpolated row lies between 2 old rows which
C       have data points
C
        LINGNS = .FALSE.
        IF( I_N.GT.0 ) THEN
          IF( (NUMOLD(I_N).GT.0).AND.(NUMOLD(I_S).GT.0) ) THEN
C
C           Yes, so set up the grid increments.
C
C
C           Note that the grid increments are different depending on
C           whether or not the grid is global; global grids have an
C           extra interval at the end (eg between 358.5 and 0.0), while
C           subareas have outer limits defined by 'west' and 'east' and
C           a given number of points in between.
C
            IF( LGLOBAL ) THEN
              DELONGN = 360.0/DBLE(NUMOLD(I_N))
              DELONGS = 360.0/DBLE(NUMOLD(I_S))
            ELSE
              DINC = DMOD((OEAST-OWEST+DBLE(360.0)), DBLE(360.0))/
     X                 DBLE(NUMOLD(I_N))

              DELONGN = (DMOD((OEAST-OWEST+DBLE(360.0)), DBLE(360.0))
     X                 +DINC) / DBLE(NUMOLD(I_N))
              DINC = DMOD((OEAST-OWEST+DBLE(360.0)), DBLE(360.0))/
     X                 DBLE(NUMOLD(I_S))
              DELONGS = (DMOD((OEAST-OWEST+DBLE(360.0)), DBLE(360.0))
     X                 +DINC) / DBLE(NUMOLD(I_S))
            ENDIF
c

            LINGNS  = .TRUE.
          ENDIF
C
C         The equator is given special treatment so that the northern
C         and southern hemispheres for the parameter 250 can (later)
C         be stitched together.
C
C         If the input field finishs at the equator and the output
C         field has a line at the equator, use the input equator for
C         interpolation.
C
          IF( NEWLATS(NEWROW).EQ.0.0 .AND.
     x        ((NUMOLD(I_N).GT.0).AND.(NUMOLD(I_S).EQ.0)) ) THEN
C
C           Yes, so set up the grid increments.
C
            IF( LGLOBAL ) THEN
              DELONGN = 360.0/DBLE(NUMOLD(I_N))
            ELSE
              DINC = DMOD((OEAST-OWEST+DBLE(360.0)), DBLE(360.0))/
     X                 DBLE(NUMOLD(I_N))
              DELONGN = (DMOD((OEAST-OWEST+DBLE(360.0)), DBLE(360.0))
     X                 +DINC) / DBLE(NUMOLD(I_N))
            ENDIF
            DELONGS = DELONGN
            DIST_N = 0.0
            DIST_S = 1.0
            I_S = I_N
            LINGNS  = .TRUE.
          ENDIF
        ENDIF
C
C       Setup longitudes for the current row
C
        INCOL = NUMNEW(NEWROW)
        IF( INCOL.NE.0 ) THEN
             RESOL = 360.0/DBLE(INCOL)
             DO LOOP = 1, INCOL
               LON(LOOP) = DBLE(LOOP-1)*RESOL
             ENDDO
C
          DO 210 NEWCOL = 1, INCOL
C
            LINGWE = (LON(NEWCOL).GT.OWEST).OR.(LON(NEWCOL).LT.OEAST)
C
            IF( LINGNS .AND. LINGWE ) THEN
C
C             If point to be interpolated is inside the input field ,
C             work out distances from new point to four neighbours.
C
              ZXIN = DMOD( (LON(NEWCOL) + (360.0-OWEST) + DBLE(720.0)),
     X                     DBLE(360.0))
cs            ZXIN = LON(NEWCOL)
              ZXIS = ZXIN
              ZXIN = ZXIN/DELONGN + 1.0
              ZXIS = ZXIS/DELONGS + 1.0
              I_NW = INT(ZXIN)
              I_NE = I_NW + 1
              I_SW = INT(ZXIS)
              I_SE = I_SW + 1
C
C             Allow wrap-around
C
C
              I_NW = MOD(I_NW,NUMOLD(I_N))
              I_NE = MOD(I_NE,NUMOLD(I_N))
              I_SW = MOD(I_SW,NUMOLD(I_S))
              I_SE = MOD(I_SE,NUMOLD(I_S))
              IF( I_NW.EQ.0 ) I_NW = NUMOLD(I_N)
              IF( I_SW.EQ.0 ) I_SW = NUMOLD(I_S)
              IF( I_NE.EQ.0 ) I_NE = NUMOLD(I_N)
              IF( I_SE.EQ.0 ) I_SE = NUMOLD(I_S)
C
C             Calculate distance from interpolated point to its neighbours
C
              DIST_NW = ZXIN - REAL(I_NW)
              DIST_NE = 1.0 - DIST_NW
              DIST_SW = ZXIS - REAL(I_SW)
              DIST_SE = 1.0 - DIST_SW
C
C             Take nearest grid point value.
C
              DISNW = DIST_NW*DIST_NW + DIST_N*DIST_N
              DISNE = DIST_NE*DIST_NE + DIST_N*DIST_N
              DISSW = DIST_SW*DIST_SW + DIST_S*DIST_S
              DISSE = DIST_SE*DIST_SE + DIST_S*DIST_S
C
              IF( (DISNW.LE.DISNE).AND.(DISNW.LE.DISSW).AND.
     X            (DISNW.LE.DISSE) ) THEN
C
C               Use north-west neighbour
C
                NEWWAVE(NEXT) = INDEXI(I_N)+I_NW
C
              ELSE IF( (DISNE.LE.DISSW).AND.(DISNE.LE.DISSE) ) THEN
C
C               Use north-east neighbour
C
                NEWWAVE(NEXT) = INDEXI(I_N)+I_NE
C
              ELSE IF( DISSW.LE.DISSE ) THEN
C
C               Use south-west neighbour
C
                NEWWAVE(NEXT) = INDEXI(I_S)+I_SW
              ELSE
C
C               Use south-east neighbour
C
                NEWWAVE(NEXT) = INDEXI(I_S)+I_SE
              ENDIF
C
C           If the point to be interpolated is outside the input field,
C           set it to 'land'.
C
            ELSE
              NEWWAVE(NEXT) = 0
            ENDIF
C
            NEXT = NEXT + 1
C
  210     CONTINUE
C
        ENDIF
C
  220 CONTINUE
C
C ---------------------------------------------------------------------
C*    Section 9. Closedown.
C ---------------------------------------------------------------------
C
  900 CONTINUE
C
      IF( WV2DIDX.EQ.0 ) THEN
        CALL INTLOG(JP_DEBUG, 'WV2DIDX: successful.',JPQUIET)
      ELSE
        CALL INTLOG(JP_ERROR, 'WV2DIDX: failed.',JPQUIET)
      ENDIF
C
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities
C granted to it by virtue of its status as an intergovernmental organisation
C nor does it submit to any jurisdiction.
C

      SUBROUTINE GETFLAG(KREF,KCODE,KFLAG,YFLAG,IERR)
C
C**** *GETFLAG*
C
C
C     PURPOSE.
C     --------
C
C          The main purpose of the subroutine is to get text
C          associated with code number
C
C**   INTERFACE.
C     ----------
C          NONE.
C
C
C
C
C     *METHOD.
C      -------
C          NONE.
C
C
C
C     EXTERNALS.
C     ----------
C          NONE.
C
C
C
C
C     REFERENCE.
C     ----------
C
C
C     AUTHOR.
C     -------
C
C          M. DRAGOSAVAC       *ECMWF*       JANUARY 2008.
C
C
C     MODIFICATIONS.
C     --------------
C
C          NONE.
C
C
      IMPLICIT LOGICAL(L,O,G), CHARACTER*8(C,H,Y)
C
#     include "parameter.F"
#     include "bcomwork.F"
#     include "bcomtab.F"
#     include "bcomtabc.F"
#     include "bcomct.F"
#     include "bcomctc.F"
#     include "bcomroot.F"
C#     include "bcomtabload.F"
C#     include "bcomtabloadc.F"


C
      CHARACTER*64  CTEXT
      CHARACTER*64  CTABBEN
      CHARACTER*24  CTABBU
      CHARACTER*64  YFLAG(32)
C
C
C     ------------------------------------------------------------------
C*          1.   SET INITIAL CONSTANTS AND POINTERS
C                ----------------------------------
 100  CONTINUE
C
      J=0
      do i=1,32
      YFLAG(i)=' '
      end do
C
      do i=1,JCTAB
      if(nref(i).eq.kref) go to 200
      end do
      print*,'Could not find ',kref
      ierr=2
      return
c
 200  continue
C
      ictab=i
C
C     Find data width for kref
C
      do i=1,JTAB
      if(NTABBTR(I).eq.kref) go to 201
      end do

      print*,'Could not find ',kref
      ierr=2
      return
 201  continue
c
      ibtab=i
c
      iwidth=NTABBDW(ibtab)
c
      if(KCODE.eq.NMASK(iwidth)) then
         KFLAG=1
         YFLAG(1)='MISSING VALUE'
         return
      else
         ipt=nstart(ictab)
         iptc=nstartc(ipt)
         KFLAG=0
         do i=ipt,ipt+nlen(ictab)-1
            ibitnumber=ncodnum(i)
c           test bit
            ipos=iwidth-ibitnumber
            if(btest(KCODE,ipos)) then
               ic=iptc+ibitnumber-1
               KFLAG=KFLAG+1
               YFLAG(KFLAG)=ctext(ic)
            end if
         end do
      end if

      return
      END

C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE BUEXS3P(KBUFL,KBUFF,KSUP,KSEC3,KERR)
C
C**** *BUEXS3P*
C
C
C     PURPOSE.
C     --------
C
C          EXPAND SECTION 3 OF BUFR MESSAGE.
C               (PRELIMINARY ITEMS)
C
C
C**   INTERFACE.
C     ----------
C
C          *CALL* *BUEXS3P( KBUFL,KBUFF,KSUP,KSEC3,KERR)*
C
C        INPUT :
C               *KBUFL*   -  LENGTH OF BUFR MESSAGE (WORDS)
C               *KBUFF*   -  ARRAY CONTAINING BUFR MESSAGE
C        OUTPUT:
C               *KSUP*    -  ARRAY CONTAINING SUPLEMENTARY INFORMATION
C                         -  KSUP( 1) -- IDIM1, DIMENSION OF KSEC1
C                         -  KSUP( 2) -- IDIM2, DIMENSION OF KSEC2
C                         -  KSUP( 3) -- IDIM3, DIMENSION OF KSEC3
C                         -  KSUP( 4) -- IDIM4, DIMENSION OF KSEC4
C                         -  KSUP( 5) -- M (NUMBER OF ELEMENTS IN VALUES ARRAY,
C                                           FIRST INDEX)
C                         -  KSUP( 6) -- N (NUMBER OF SUBSETS,SECOND INDEX OF
C                                           VALUES ARRAY)
C                         -  KSUP( 7) -- JVC (NUMBER OF ELEMENTS IN CVAL ARRAY)
C                         -  KSUP( 8) -- TOTAL BUFR MESSAGE LENGTH IN BYTES
C                         -  KSUP( 9) -- IDIM0, DIMENSION OF KSEC0
C               *KSEC3*   -  ARRAY KSEC3 
C               *KERR*    -  RETURNED ERROR CODE
C
C     METHOD.
C      -------
C
C
C          NONE.
C
C     EXTERNALS.
C     ----------
C
C          BUNEXS        - SET WORD AND BIT POINTERS AT THE BEGINING OF
C                          NEXT SECTION
C          BUNPCK        - UNPACKS BIT PATTERN
C
C     REFERENCE.
C     ----------
C
C          NONE.
C
C     AUTHOR.
C     -------
C
C          M. DRAGOSAVAC    *ECMWF*       01/02/91.
C
C
C     MODIFICATIONS.
C     --------------
C
C          NONE.
C
C
      IMPLICIT LOGICAL(L,O,G), CHARACTER*8(C,H,Y)
C
C
#     include "parameter.F"
#     include "bcomunit.F"
#     include "bcomwork.F"
C
      DIMENSION KBUFF(KBUFL),KSEC3(JSEC3)
      DIMENSION KSUP(JSUP)
#ifndef R_4
      REAL*8 RVIND
      REAL*8 EPS
#else
      REAL   RVIND
      REAL   EPS
#endif
C
C     ------------------------------------------------------------------
C
C*          1.   EXPAND PRELIMINARY ITEMS OF SECTION 3.
C                --------------------------------------
 100  CONTINUE
C
      IF( KERR.NE.0 ) RETURN
C
C*          1.1   SET THE POINTERS NWPT AND NBPT TO THE
C                 -------------------------------------
C                 BEGINING OF THE SECTION 3.
C                 --------------------------
 110  CONTINUE
C
      NWPT = NWPTB
      NBPT = NBPTB
C
C*          1.2   UNPACK LENGTH OF SECTION 3.
C                 ---------------------------
 120  CONTINUE
C
      CALL BUNPCK(NBPW,KBUFF,KSEC3(1),NWPT,NBPT,24,KERR)
      IF(KERR.GT.0) RETURN
C
C*          1.2.1  SET THE POINTERS NWPTB AND NBPTB TO
C                  -----------------------------------
C                  THE BEGINNING OF THE NEXT SECTION.
C                  ----------------------------------
      CALL BUNEXS(KSEC3(1))
C
C*          1.3    UNPACK ZERO BYTE AND PUT IT IN KSEC3(2).
C                  ----------------------------------------
 130  CONTINUE
C
      CALL BUNPCK(NBPW,KBUFF,KSEC3(2),NWPT,NBPT,8,KERR)
      IF(KERR.GT.0) RETURN
C
C*          1.4    UNPACK NUMBER OF DATA SUB-SETS.
C                  -------------------------------
 140  CONTINUE
C
      CALL BUNPCK(NBPW,KBUFF,KSEC3(3),NWPT,NBPT,16,KERR)
      IF(KERR.GT.0) RETURN
      IF(KSEC3(3).LE.0) THEN
         KERR=32
         WRITE(KNTN,*)  ' BUEXS3 :'
         CALL BUERR(KERR)
         RETURN
      END IF
C
C
C*          1.5    UNPACK INTEGER VALUE OF THE OCTET
C                  ---------------------------------
C                  CONTAINING FLAG BITS.
C                  --------------------
 150  CONTINUE
C
      CALL BUNPCK(NBPW,KBUFF,KSEC3(4),NWPT,NBPT,8,KERR)
      IF(KERR.GT.0) THEN
         WRITE(KNTN,*)  'ERROR UNPACKING KSEC3(4).'
         RETURN
      END IF

C
C     -----------------------------------------------------------------
C
      KSUP(3)= 4
      KSUP(5)= 0
      KSUP(6)= KSEC3(3)
C
      RETURN
      END

c Copyright 1981-2016 ECMWF.
c
c This software is licensed under the terms of the Apache Licence 
c Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
c
c In applying this licence, ECMWF does not waive the privileges and immunities 
c granted to it by virtue of its status as an intergovernmental organisation 
c nor does it submit to any jurisdiction.
c

      SUBROUTINE FAX(IFAX,N,MODE)
      DIMENSION IFAX(10)
      COMMON /QQQQFFT/ IXXX
C
C     MARK INITIALISATION AS 'OLD' TYPE
C
      IXXX=0
C
      NN=N
      IF (IABS(MODE).EQ.1) GO TO 10
      IF (IABS(MODE).EQ.8) GO TO 10
      NN=N/2
      IF ((NN+NN).EQ.N) GO TO 10
      IFAX(1)=-99
      RETURN
   10 K=1
C     TEST FOR FACTORS OF 4
   20 IF (MOD(NN,4).NE.0) GO TO 30
      K=K+1
      IFAX(K)=4
      NN=NN/4
      IF (NN.EQ.1) GO TO 80
      GO TO 20
C     TEST FOR EXTRA FACTOR OF 2
   30 IF (MOD(NN,2).NE.0) GO TO 40
      K=K+1
      IFAX(K)=2
      NN=NN/2
      IF (NN.EQ.1) GO TO 80
C     TEST FOR FACTORS OF 3
   40 IF (MOD(NN,3).NE.0) GO TO 50
      K=K+1
      IFAX(K)=3
      NN=NN/3
      IF (NN.EQ.1) GO TO 80
      GO TO 40
C     NOW FIND REMAINING FACTORS
   50 L=5
      INC=2
C     INC ALTERNATELY TAKES ON VALUES 2 AND 4
   60 IF (MOD(NN,L).NE.0) GO TO 70
      K=K+1
      IFAX(K)=L
      NN=NN/L
      IF (NN.EQ.1) GO TO 80
      GO TO 60
   70 L=L+INC
      INC=6-INC
      GO TO 60
   80 IFAX(1)=K-1
C     IFAX(1) CONTAINS NUMBER OF FACTORS
C     IFAX(1) CONTAINS NUMBER OF FACTORS
      NFAX=IFAX(1)
C     SORT FACTORS INTO ASCENDING ORDER
      IF (NFAX.EQ.1) GO TO 110
      DO 100 II=2,NFAX
      ISTOP=NFAX+2-II
      DO 90 I=2,ISTOP
      IF (IFAX(I+1).GE.IFAX(I)) GO TO 90
      ITEM=IFAX(I)
      IFAX(I)=IFAX(I+1)
      IFAX(I+1)=ITEM
   90 CONTINUE
  100 CONTINUE
  110 CONTINUE
      IFAX(10)=0
      RETURN
      END

C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      INTEGER FUNCTION INTFC( INGRIB,INLEN,FLDIN,OUTGRIB,OUTLEN,FLDOUT)
C
C---->
C**** INTFC
C
C     Purpose
C     -------
C
C     Move input field to output field.
C
C
C     Interface
C     ---------
C
C     IRET = INTFC( INGRIB,INLEN,FLDIN,OUTGRIB,OUTLEN,FLDOUT)
C
C     Input
C     -----
C
C     INGRIB - Input field (packed).
C     INLEN  - Input field length (words).
C     FLDIN  - Input field (unpacked).
C
C
C     Output
C     ------
C
C     OUTGRIB - Output field (packed).
C     OUTLEN  - Output field length (words).
C     FLDOUT  - Output field (unpacked).
C
C
C     Method
C     ------
C
C     Move data (packed or unpacked) without special processing.
C
C
C     Externals
C     ---------
C
C     None.
C
C
C     Author
C     ------
C
C     J.D.Chambers     ECMWF     Jan 1995
C
C----<
C
      IMPLICIT NONE
C
C     Function arguments
      INTEGER INGRIB(*),OUTGRIB(*),INLEN,OUTLEN
      REAL FLDIN(*),FLDOUT(*)
C
#include "parim.h"
#include "nifld.common"
#include "nofld.common"
#include "grfixed.h"
C
C     Parameters
      INTEGER JPROUTINE
      PARAMETER (JPROUTINE = 26700 )
C
C     Local variables
C
      INTEGER LOOP
C
C ------------------------------------------------------------------
C*    Section 1.   Initialise
C ------------------------------------------------------------------
C
  100 CONTINUE
      INTFC = 0
C
C ------------------------------------------------------------------
C*    Section 2.   Move data from input to output.
C ------------------------------------------------------------------
C
  200 CONTINUE
C
C     If input is a GRIB product
      If (NIFORM .EQ. 1) THEN
C
C       Move packed values to user array
        DO 210 LOOP = 1, INLEN
          OUTGRIB( LOOP ) = INGRIB( LOOP )
 210    CONTINUE
C
      ELSE
C
C       Otherwise, move unpacked values to user array
        DO 220 LOOP = 1, INLEN
          FLDOUT( LOOP ) = FLDIN( LOOP )
 220    CONTINUE
C
      ENDIF
C
C     Return the number of values, the unpacked array length
      OUTLEN = INLEN
C
C ------------------------------------------------------------------
C*    Section 9.   Closedown.
C ------------------------------------------------------------------
C
  900 CONTINUE
C
C     Clear change flags for next product processing
      LCHANGE = .FALSE.
      LSMCHNG = .FALSE.
C
      RETURN
      END

c Copyright 1981-2016 ECMWF.
c
c This software is licensed under the terms of the Apache Licence 
c Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
c
c In applying this licence, ECMWF does not waive the privileges and immunities 
c granted to it by virtue of its status as an intergovernmental organisation 
c nor does it submit to any jurisdiction.
c

      SUBROUTINE FFTRIG(TRIGS,N,MODE)
      DIMENSION TRIGS(N)
      COMMON /QQQQFFT/ IXXX
C
C     MARK INITIALISATION AS 'OLD' TYPE
C
      IXXX=0
C
      PI=2.0*ASIN(1.0)
      IMODE=IABS(MODE)
      NN=N
      IF (IMODE.GT.1.AND.IMODE.LT.6) NN=N/2
      DEL=(PI+PI)/FLOAT(NN)
      L=NN+NN
      DO 10 I=1,L,2
      ANGLE=0.5*FLOAT(I-1)*DEL
      TRIGS(I)=COS(ANGLE)
      TRIGS(I+1)=SIN(ANGLE)
   10 CONTINUE
      IF (IMODE.EQ.1) RETURN
      IF (IMODE.EQ.8) RETURN
      DEL=0.5*DEL
      NH=(NN+1)/2
      L=NH+NH
      LA=NN+NN
      DO 20 I=1,L,2
      ANGLE=0.5*FLOAT(I-1)*DEL
      TRIGS(LA+I)=COS(ANGLE)
      TRIGS(LA+I+1)=SIN(ANGLE)
   20 CONTINUE
      IF (IMODE.LE.3) RETURN
      DEL=0.5*DEL
      LA=LA+NN
      IF (MODE.EQ.5) GO TO 40
      DO 30 I=2,NN
      ANGLE=FLOAT(I-1)*DEL
      TRIGS(LA+I)=2.0*SIN(ANGLE)
   30 CONTINUE
      RETURN
   40 CONTINUE
      DEL=0.5*DEL
      DO 50 I=2,N
      ANGLE=FLOAT(I-1)*DEL
      TRIGS(LA+I)=SIN(ANGLE)
   50 CONTINUE
      RETURN
      END

C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      INTEGER FUNCTION C2PKVW ( KDATA,  KLENP,  KGRIB,  KLENG,  KNSPT,
     X                          KBITS,  KLEN,   KREFGR, KLENGR, KBITGR,
     X                          KWORK,  KLWORK, KFIROV, KCOUNT, KPOWER,
     X                          KMXPWR, OROW,   OVECTA, ODEBUG )
C
C---->
C**** C2PKVW
C
C     Purpose.
C     --------
C
C     Computes and packs second-order values for variable width methods
C     of second-order packing.
C
C
C**   Interface.
C     ----------
C
C     KRET = C2PKVW ( KDATA,  KLENP,  KGRIB,  KLENG,  KNSPT,  KBITS,
C    X                KLEN,   KREFGR, KLENGR, KBITGR, KWORK,  KLWORK,
C    X                KGRIB,  KCOUNT, KPOWER, KMXPWR, OROW,   OVECTA,
C    X                ODEBUG )
C
C
C     Input Parameters.
C     ----------------
C
C     KDATA      - Array of normalized values.
C     KLENP      - Length of array KDATA.
C     KLENG      - Length of GRIB product array.
C     KNSPT      - Bit pointer for next value in GRIB product.
C     KBITS      - Number of bits per computer word.
C     KLEN       - Exact number of grid-points to handle.
C     KREFGR     - Work array, first-order values for each group.
C     KLENGR     - Work array, effective length of each group.
C     KBITGR     - Work array, bit number ("width") of each group.
C     KLWORK     - Length of work arrays.
C     KFIROV     - Number of FIRst-Order Values.
C     KCOUNT     - Initial index into KDATA.
C     KPOWER     - Auxilary array, containing precomputed powers of 2-1.
C     KMXPWR     - Maximum number of bits per original scaled value.
C     OROW       - True if row by row packing is active packing method.
C     OVECTA     - True if vector-oriented algorithm has to be used.
C     ODEBUG     - True for some debug printout.
C
C
C     Output Parameters.
C     -----------------
C
C     KDATA      - Used as work array for second-order values.
C     KGRIB      - Array containing GRIB product.
C     KNSPT      - Bit pointer for next value in GRIB product (updated).
C     KREFGR     - Work array, re-used internally.
C     KBITGR     - Work array, re-used internally.
C     KWORK      - Work array.
C     KCOUNT     - Final index into KDATA.
C
C
C     Method.
C     -------
C
C     Follows WMO Manual of Codes.
C
C     Externals.
C     ----------
C
C     INXBIT    - Insert bits into GRIB product.
C
C
C     Reference.
C     ----------
C
C     None.
C
C
C     Comments.
C     --------
C
C
C     KDATA is overwritten. This is coherent with GRIBEX coding.
C
C
C     Author.
C     -------
C
C     J. Clochard, Meteo France, for ECMWF - September 1998.
C
C
C     Modifications.
C     _____________
C
C     None.
C
C
C----<
C     -----------------------------------------------------------------
C*    Section 0. Definition of variables.
C     -----------------------------------------------------------------
C
      IMPLICIT NONE
C
#include "grprs.h"
C
C     Subroutine arguments
C
      INTEGER KLENP, KLENG, KNSPT, KBITS, KLEN, KLWORK, KFIROV, KCOUNT
      INTEGER KMXPWR
      INTEGER KDATA (KLENP), KGRIB (KLENG), KPOWER (0:KMXPWR)
      INTEGER KREFGR (KLWORK), KLENGR (KLWORK), KBITGR (KLWORK)
      INTEGER KWORK (KLWORK)
C
      LOGICAL OROW, OVECTA, ODEBUG
C
C     Local variables.
C
      INTEGER ICOUNT, JGROUP, ILNGTH, IRET, J, IWIDTH, IREFER, IOFF
      INTEGER IRETFN, IPRWID, JTIMES, ILNGTS, IDATA,  ICOUNB, IBLOCK
      INTEGER JBLOCK, IFIRST, ILBITS, IBIT,   IWIDPR, INTERM, IPOWER
C
      CHARACTER YOPER*1
C
C     -----------------------------------------------------------------
C*    Section 1 . Initialisations.
C     -----------------------------------------------------------------
C
  100 CONTINUE
C
#ifndef ebug2o
      IF (ODEBUG) THEN
#endif
        WRITE(GRPRSM,FMT=9100) KNSPT
#ifndef ebug2o
      ENDIF
#endif
C
      IRETFN=0
      YOPER='C'
      ICOUNT=KCOUNT
C
C     -----------------------------------------------------------------
C*    Section 2. Blocks groups of same width, compute 2nd-order values.
C     -----------------------------------------------------------------
C
  200 CONTINUE
C
C         Determin blocks of neighbour groups of same width to be
C         "packed" together for coding, and compute 2nd-order values.
C
C         In both cases any constant groups are not taken into account.
C
      ILNGTS=0
      ICOUNB=0
      IBLOCK=0
C
C         Find first non-constant group.
C
      DO 201 J=1,KFIROV
C
        IF (KBITGR(J).NE.0) THEN
          IFIRST=J
          GOTO 202
        ENDIF
C
        ICOUNT=ICOUNT+KLENGR(J)
C
  201 CONTINUE
C
C         All groups are constant (constant field, at least piecewise).
C         In such a case there are no second-order values to code.
C
      IFIRST=KFIROV+1
      ICOUNT=KLEN
C
  202 CONTINUE
C
      IPRWID=KBITGR(MIN (IFIRST,KFIROV))
C
      DO 204 JGROUP=IFIRST,KFIROV
C
        IWIDTH=KBITGR(JGROUP)
        ILNGTH=KLENGR(JGROUP)
        IREFER=KREFGR(JGROUP)
C
        IF (IWIDTH.NE.0) THEN
C
C              Compute second-order values for current group.
C
#ifdef CRAY
CDIR$ IVDEP
#endif
#ifdef FUJITSU
!OCL NOVREC
#endif
          DO 203 J=1,ILNGTH
C
            KDATA(ICOUNB+J)=KDATA(ICOUNT+J)-IREFER
C
  203     CONTINUE
C
          IF (IWIDTH.NE.IPRWID) THEN
C
C             Current group may not be blocked with previous one(s).
C
            IF (ILNGTS.NE.0) THEN
C
C               Closes current block.
C
              IBLOCK=IBLOCK+1
              KBITGR(IBLOCK)=IPRWID
              KWORK(IBLOCK)=ILNGTS
              ILNGTS=0
C
            ENDIF
C
            IPRWID=IWIDTH
C
          ENDIF
C
          ICOUNB=ICOUNB+ILNGTH
          ILNGTS=ILNGTS+ILNGTH
C
        ENDIF
C
        ICOUNT=ICOUNT+ILNGTH
C
  204 CONTINUE
C
      IF (IPRWID.NE.0.AND.ILNGTS.NE.0) THEN
C
C           Closing last block of group(s).
C
        IBLOCK=IBLOCK+1
        KBITGR(IBLOCK)=IPRWID
        KWORK(IBLOCK)=ILNGTS
C
      ENDIF
C
C     -----------------------------------------------------------------
C*    Section 3. Packs second-order values.
C     -----------------------------------------------------------------
C
  300 CONTINUE
C
      ILBITS=0
      ICOUNB=0
      ILNGTS=0
C
      IF (OROW.OR..NOT.OVECTA) THEN
C
C           For such a case, granularity is large enough to make one
C           INXBIT call per block of group(s).
C
        DO 311 JBLOCK=1,IBLOCK
C
          ILNGTH=KWORK(JBLOCK)
          IWIDTH=KBITGR(JBLOCK)
#ifdef ebug2o
          PRINT *,'c2pkvw - block',JBLOCK,
     X              ' KNSPT/IWIDTH/ICOUNB/ILNGTH = ',
     X                KNSPT, IWIDTH, ICOUNB, ILNGTH
#endif
          CALL INXBIT(KGRIB,KLENG,KNSPT,KDATA(ICOUNB+1),ILNGTH,KBITS,
     X                IWIDTH,YOPER,IRET)
C
          IF (IRET.NE.0) THEN
            IRETFN = 24310
            WRITE(GRPRSM,FMT=9310) 'block', JBLOCK, ILNGTH, IWIDTH
            GO TO 900
          ENDIF
C
          ICOUNB=ICOUNB+ILNGTH
C
  311   CONTINUE
C
      ELSE
C
C       Granularity is generally small. Except for very big groups,
C       split 2nd-order values into individual bits, blocked into
C       KREFGR work array, that is flushed when full.
C
C
        DO 399 JBLOCK=1,IBLOCK
C
          ILNGTH=KWORK(JBLOCK)
          IWIDTH=KBITGR(JBLOCK)
C
          IF ((ILBITS+ILNGTH*IWIDTH).GT.KLWORK.AND.ILBITS.NE.0) THEN
C
C             Work array of split bits has to be flushed. Pack it.
C
#ifdef ebug2o
            PRINT *,'c2pkvw - blocks..',JBLOCK-1,
     X              ' KNSPT/ILBITS = ',
     X                KNSPT, ILBITS
#endif
            CALL INXBIT(KGRIB,KLENG,KNSPT,KREFGR,ILBITS,KBITS,
     X                  1,YOPER,IRET)
C
            IF (IRET.NE.0) THEN
              IRETFN = 24320
              WRITE(GRPRSM,FMT=9320) JBLOCK-1, ILBITS
              GO TO 900
            ENDIF
C
            ILBITS=0
C
          ENDIF
C
          IF ((ILNGTH*IWIDTH).GT.KLWORK) THEN
C
C             Current block is too large to fit into KREFGR.
C             Pack it straightforward, without intermediate splitting.
C
#ifdef ebug2o
            PRINT *,'c2pkvw - BLOCK',JBLOCK,
     X              ' KNSPT/IWIDTH/ICOUNB/ILNGTH = ',
     X                KNSPT, IWIDTH, ICOUNB, ILNGTH
#endif
            CALL INXBIT(KGRIB,KLENG,KNSPT,KDATA(ICOUNB+1),ILNGTH,KBITS,
     X                  IWIDTH,YOPER,IRET)
C
            IF (IRET.NE.0) THEN
              IRETFN = 24320
              WRITE(GRPRSM,FMT=9310) 'BLOCK', JBLOCK, ILNGTH, IWIDTH
              GO TO 900
            ENDIF          
C
          ELSE
C
C             Split current block into individual bits, stored into
C             array KREFGR (one bit per index value).
C
C             Start processing by "full" packets of 7-bit wide.
C             (even if 7-bit wide, last packet is processed separately).
C
            INTERM=(IWIDTH-1)/7
            IWIDPR=0
C
            DO 322 JTIMES=1,INTERM
C
              IOFF=ILBITS+IWIDPR
              IWIDPR=IWIDPR+7
              IPOWER=KPOWER(IWIDTH-IWIDPR)+1
C
#ifdef CRAY
CDIR$ IVDEP
#endif
#ifdef FUJITSU
!OCL NOVREC
#endif
              DO 321 J=1,ILNGTH
C
                IDATA=KDATA(ICOUNB+J)/IPOWER
                KDATA(ICOUNB+J)=KDATA(ICOUNB+J)-IPOWER*IDATA
                IBIT=IDATA/64
                KREFGR(IOFF+1)=IBIT
                IDATA=IDATA-64*IBIT
                IBIT=IDATA/32
                KREFGR(IOFF+2)=IBIT
                IDATA=IDATA-32*IBIT
                IBIT=IDATA/16
                KREFGR(IOFF+3)=IBIT
                IDATA=IDATA-16*IBIT
                IBIT=IDATA/8
                KREFGR(IOFF+4)=IBIT
                IDATA=IDATA-8*IBIT
                IBIT=IDATA/4
                KREFGR(IOFF+5)=IBIT
                IDATA=IDATA-4*IBIT
                IBIT=IDATA/2
                KREFGR(IOFF+6)=IBIT
                KREFGR(IOFF+7)=IDATA-2*IBIT
                IOFF=IOFF+IWIDTH
C
  321         CONTINUE
C
  322       CONTINUE
C
C             Now process last packet of bits (least significant ones).
C             No more use to restore KDATA.
C
            IOFF=ILBITS+IWIDPR
            IPRWID=IWIDTH-IWIDPR
C
            IF (IPRWID.EQ.7) THEN
C
#ifdef CRAY
CDIR$ IVDEP
#endif
#ifdef FUJITSU
!OCL NOVREC
#endif
              DO 323 J=1,ILNGTH
C
                IBIT=KDATA(ICOUNB+J)/64
                KREFGR(IOFF+1)=IBIT
                IDATA=KDATA(ICOUNB+J)-64*IBIT
                IBIT=IDATA/32
                KREFGR(IOFF+2)=IBIT
                IDATA=IDATA-32*IBIT
                IBIT=IDATA/16
                KREFGR(IOFF+3)=IBIT
                IDATA=IDATA-16*IBIT
                IBIT=IDATA/8
                KREFGR(IOFF+4)=IBIT
                IDATA=IDATA-8*IBIT
                IBIT=IDATA/4
                KREFGR(IOFF+5)=IBIT
                IDATA=IDATA-4*IBIT
                IBIT=IDATA/2
                KREFGR(IOFF+6)=IBIT
                KREFGR(IOFF+7)=IDATA-2*IBIT
                IOFF=IOFF+IWIDTH
C
  323         CONTINUE
C
            ELSEIF (IPRWID.EQ.6) THEN
C
#ifdef CRAY
CDIR$ IVDEP
#endif
#ifdef FUJITSU
!OCL NOVREC
#endif
              DO 324 J=1,ILNGTH
C
                IBIT=KDATA(ICOUNB+J)/32
                KREFGR(IOFF+1)=IBIT
                IDATA=KDATA(ICOUNB+J)-32*IBIT
                IBIT=IDATA/16
                KREFGR(IOFF+2)=IBIT
                IDATA=IDATA-16*IBIT
                IBIT=IDATA/8
                KREFGR(IOFF+3)=IBIT
                IDATA=IDATA-8*IBIT
                IBIT=IDATA/4
                KREFGR(IOFF+4)=IBIT
                IDATA=IDATA-4*IBIT
                IBIT=IDATA/2
                KREFGR(IOFF+5)=IBIT
                KREFGR(IOFF+6)=IDATA-2*IBIT
                IOFF=IOFF+IWIDTH
C
  324         CONTINUE
C
            ELSEIF (IPRWID.EQ.5) THEN
C
#ifdef CRAY
CDIR$ IVDEP
#endif
#ifdef FUJITSU
!OCL NOVREC
#endif
              DO 325 J=1,ILNGTH
C
                IBIT=KDATA(ICOUNB+J)/16
                KREFGR(IOFF+1)=IBIT
                IDATA=KDATA(ICOUNB+J)-16*IBIT
                IBIT=IDATA/8
                KREFGR(IOFF+2)=IBIT
                IDATA=IDATA-8*IBIT
                IBIT=IDATA/4
                KREFGR(IOFF+3)=IBIT
                IDATA=IDATA-4*IBIT
                IBIT=IDATA/2
                KREFGR(IOFF+4)=IBIT
                KREFGR(IOFF+5)=IDATA-2*IBIT
                IOFF=IOFF+IWIDTH
C
  325         CONTINUE
C
            ELSEIF (IPRWID.EQ.4) THEN
C
#ifdef CRAY
CDIR$ IVDEP
#endif
#ifdef FUJITSU
!OCL NOVREC
#endif
              DO 326 J=1,ILNGTH
C
                IBIT=KDATA(ICOUNB+J)/8
                KREFGR(IOFF+1)=IBIT
                IDATA=KDATA(ICOUNB+J)-8*IBIT
                IBIT=IDATA/4
                KREFGR(IOFF+2)=IBIT
                IDATA=IDATA-4*IBIT
                IBIT=IDATA/2
                KREFGR(IOFF+3)=IBIT
                KREFGR(IOFF+4)=IDATA-2*IBIT
                IOFF=IOFF+IWIDTH
C
  326         CONTINUE
C
            ELSEIF (IPRWID.EQ.3) THEN
C
#ifdef CRAY
CDIR$ IVDEP
#endif
#ifdef FUJITSU
!OCL NOVREC
#endif
              DO 327 J=1,ILNGTH
C
                IBIT=KDATA(ICOUNB+J)/4
                KREFGR(IOFF+1)=IBIT
                IDATA=KDATA(ICOUNB+J)-4*IBIT
                IBIT=IDATA/2
                KREFGR(IOFF+2)=IBIT
                KREFGR(IOFF+3)=IDATA-2*IBIT
                IOFF=IOFF+IWIDTH
C
  327         CONTINUE
C
            ELSEIF (IPRWID.EQ.2) THEN
C
#ifdef CRAY
CDIR$ IVDEP
#endif
#ifdef FUJITSU
!OCL NOVREC
#endif
              DO 328 J=1,ILNGTH
C
                IBIT=KDATA(ICOUNB+J)/2
                KREFGR(IOFF+1)=IBIT
                KREFGR(IOFF+2)=KDATA(ICOUNB+J)-2*IBIT
                IOFF=IOFF+IWIDTH
C
  328         CONTINUE
C
            ELSE
C
              DO 329 J=1,ILNGTH
C
                KREFGR(IOFF+1)=KDATA(ICOUNB+J)
                IOFF=IOFF+IWIDTH
C
  329         CONTINUE
C
            ENDIF
C
            ILBITS=ILBITS+ILNGTH*IWIDTH
C
          ENDIF
C
          ICOUNB=ICOUNB+ILNGTH
C
  399   CONTINUE
C
        IF (ILBITS.NE.0) THEN
C
C             Last flush for work array of split bits. Pack it.
C
#ifdef ebug2o
          PRINT *,'c2pkvw - blocks..',IBLOCK,
     X            ' KNSPT/ILBITS = ',
     X              KNSPT, ILBITS
#endif
          CALL INXBIT(KGRIB,KLENG,KNSPT,KREFGR,ILBITS,KBITS,
     X                1,YOPER,IRET)
C
          IF (IRET.NE.0) THEN
            IRETFN = 24320
            WRITE(GRPRSM,FMT=9320) IBLOCK, ILBITS
            GO TO 900
          ENDIF
C
        ENDIF
C
      ENDIF
C
C
C     -----------------------------------------------------------------
C*    Section 9. Return to calling routine.
C     -----------------------------------------------------------------
C
  900 CONTINUE
C
      KCOUNT=ICOUNT
      C2PKVW = IRETFN
#ifndef ebug2o
C
      IF (ODEBUG) THEN
#endif
        WRITE(GRPRSM,FMT=9900) IRETFN, KNSPT
#ifndef ebug2o
      ENDIF
#endif
C
      RETURN
C
 9100 FORMAT (' C2PKVW: Function start, KNSPT =',I10,'.')
C
 9310 FORMAT (' C2PKVW: Problem inserting 2nd-order values, ',A,I7,
     S        ',',I6,'*',I2,' bits.')
C
 9320 FORMAT (' C2PKVW: Problem inserting 2nd-order values, blocks..',
     S        I7,',',I9,' bits.')
C
 9900 FORMAT (' C2PKVW: Function return code =',I6,', KNSPT =',I10,'.')
C
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities
C granted to it by virtue of its status as an intergovernmental organisation
C nor does it submit to any jurisdiction.
C

      INTEGER FUNCTION HSP2GG(KTRUNC,KGAUSS,KPTS,PLATS,KSIZE)
C
C---->
C**** HSP2GG
C
C     Purpose
C     -------
C     This routine finds a suitable Gaussian grid for a given
C     spectral truncation.
C
C
C     Interface
C     ---------
C     IRET = HSP2GG(KTRUNC,KGAUSS,KPTS,PLATS,KSIZE)
C
C
C     Input parameters
C     ----------------
C     KTRUNC - spectral truncation
C
C
C     Output parameters
C     -----------------
C     KGAUSS - Gaussian grid number
C     HTYPE  - Gaussian grid type
C              = 'R' for reduced ("quasi-regular"),
C              = 'O' for reduced/octahedral,
C              = 'F' for full,
C              = 'U' for a user-defined Gaussian grid
C     KPTS   - array giving number of points along each line of latitude
C              in the reduced Gaussian grid (both hemispheres)
C     PLATS  - array giving Gaussian latitudes (both hemispheres)
C     KSIZE  - number of points in the reduced Gaussian grid
C
C     Returns 0 if all OK, otherwise there is an error.
C
C
C     Externals
C     ---------
C     HSH2GG - Finds a suitable Gaussian grid and/or spectral truncation
C     for a given spectral truncation and/or lat/long increments.
C
C----<
      IMPLICIT NONE

!#include "parim.h"

C     Arguments
      INTEGER KTRUNC, KGAUSS, KPTS(*), KSIZE
      REAL PLATS(*)

C     Externals
      INTEGER HSH2GG

C     Local variables
      REAL NS, EW
      CHARACTER*1 HTYPE

      NS = 0.
      EW = 0.

      KGAUSS = 0   ! output
      HTYPE  = ''  ! output
      HSP2GG = HSH2GG(NS,EW,KTRUNC,KGAUSS,HTYPE,KPTS,PLATS,KSIZE)
      END

C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      COMPLEX FUNCTION CSUM (KN, UVEC, KNCX)                         
C                                                                       
C---->
C**** *CSUM* - ROUTINE WHICH IMPLEMENTS THE BLAS ROUTINE OF THE         
C              SAME NAME                                                
C                                                                       
C     PURPOSE.                                                          
C     --------                                                          
C                                                                       
C     SIMPLE REPLACEMENT FOR IBM                                        
C                                                                       
C**   INTERFACE.                                                        
C     ----------                                                        
C                                                                       
C     * CV = CSUM (KN, UVEC, KNCX) *                                    
C                                                                       
C                                                                       
C     METHOD.                                                           
C     -------                                                           
C                                                                       
C     CREATE COMPLEX SUM OF COMPLEX VECTOR                              
C                                                                       
C     EXTERNALS.                                                        
C     ----------                                                        
C                                                                       
C     NONE                                                              
C                                                                       
C     REFERENCE.                                                        
C     ----------                                                        
C                                                                       
C     NONE                                                              
C                                                                       
C     AUTHOR.                                                           
C     -------                                                           
C                                                                       
C     K. FIELDING         * ECMWF *     FEB 1992.                       
C                                                                       
C     MODIFICATIONS.                                                    
C     --------------                                                    
C                                                                       
C     NONE                                                              
C                                                                       
C     COMMON BLOCKS USED                                                
C     -------------------                                               
C                                                                       
C     NONE                                                              
C                                                                       
C----<
      INTEGER KN, KNCX                                                  
      COMPLEX UVEC (*)                                               
C                                                                       
      INTEGER IP                                                        
      COMPLEX CHOLD                                                  
C                                                                       
C     1.    MAIN LOOP OF CODE                                           
C           ----------------------------------------------              
C                                                                       
  100 CONTINUE                                                          
      CHOLD = (0.0D0, 0.0D0)                                            
C                                                                       
      DO 110 IP = 0, KN - 1                                             
         CHOLD = CHOLD + UVEC (1 + IP * KNCX)                           
  110 CONTINUE                                                          
C                                                                       
      CSUM = CHOLD                                                      
C                                                                       
C     END OF ROUTINE                                                    
C                                                                       
      RETURN                                                            
      END                                                               

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities
C granted to it by virtue of its status as an intergovernmental organisation
C nor does it submit to any jurisdiction.
C

      INTEGER FUNCTION ISCRSZ()
C---->
C**** ISCRSZ
C
C     Purpose
C     -------
C
C     Calculate size of scratch space required for output field of
C     interpolation.
C
C
C     Interface
C     ---------
C
C     ISIZE = ISCRSZ()
C
C
C     Input
C     -----
C
C     Values in common blocks "nofld.common".
C
C
C     Output
C     ------
C
C     Size as number of values (words).
C     Returns 0 if output type not recognised.
C
C
C     Method
C     ------
C
C     Depends on output grid type.
C
C
C     Externals
C     ---------
C
C     INTLOG  - Log error message
C     JNORSGG - Calculate gaussian latitude
C     NUMPTWE - Calculate number of grid pts in range from west to east
C
C
C     Author
C     ------
C
C     J.D.Chambers     ECMWF     Feb 1995
C
C----<
C
      IMPLICIT NONE
C
#include "parim.h"
#include "nofld.common"
#include "grfixed.h"
C
C     Local variables
C
      INTEGER LOOP
      REAL PNORTH, PWEST, PSOUTH, PEAST, TEMP !, GRID
C
C     Externals
C
      EXTERNAL JNORSGG, NUMPTWE
      INTEGER JNORSGG, NUMPTWE
C
C     Statement functions
C
      REAL X, Y
      LOGICAL SOUTHOF
      SOUTHOF(X,Y) = ((X) - (Y)).GT.-1E-4
C
C     -----------------------------------------------------------------|
C     Section 1.  Initialise.
C     -----------------------------------------------------------------|
C
  100 CONTINUE
C
      ISCRSZ = 0
C
C     -----------------------------------------------------------------|
C*    Section 2.   Spherical harmonic field
C     -----------------------------------------------------------------|
C
  200 CONTINUE
C
      IF( (NOREPR.EQ.JPSPHERE).OR.
     X    (NOREPR.EQ.JPSTRSH).OR.
     X    (NOREPR.EQ.JPSPHROT) ) THEN
cs        ISCRSZ = (NORESO+1) * (NORESO+4)
        ISCRSZ = (NORESO+1) * (NORESO+2)
        CALL INTLOG(JP_DEBUG,'ISCRSZ: spherical harmonic',JPQUIET)
        GOTO 900
      ENDIF
C
C     -----------------------------------------------------------------|
C*    Section 3.   Regular lat/long field
C     -----------------------------------------------------------------|
C
  300 CONTINUE
C
      IF( (NOREPR.EQ.JPREGULAR).OR.(NOREPR.EQ.JPREGROT) ) THEN
C
        TEMP = ABS(FLOAT(NOAREA(1)) - FLOAT(NOAREA(3)))
        NONS  = NINT( TEMP / FLOAT(NOGRID(2)) ) + 1
        TEMP = FLOAT(NOAREA(4)) - FLOAT(NOAREA(2))
        NOWE  =  NINT( TEMP / FLOAT(NOGRID(1)) ) + 1
C
        ISCRSZ = NONS * NOWE
        CALL INTLOG(JP_DEBUG,'ISCRSZ: number of latitudes = ', NONS)
        CALL INTLOG(JP_DEBUG,'ISCRSZ: number of longitudes = ', NOWE)
        CALL INTLOG(JP_DEBUG,'ISCRSZ: Regular lat/long',JPQUIET)
        GOTO 900
      ENDIF
C
C     -----------------------------------------------------------------|
C*    Section 4.   Regular gaussian field
C     -----------------------------------------------------------------|
C
  400 CONTINUE
C
      IF( (NOREPR.EQ.JPGAUSSIAN).OR.(NOREPR.EQ.JPFGGROT) ) THEN
C
        PNORTH = FLOAT( NOAREA(1) ) / PPMULT
        PSOUTH = FLOAT( NOAREA(3) ) / PPMULT
        NO1NS = JNORSGG( PNORTH, ROGAUSS, NOGAUSS, 1)
        NONS  = JNORSGG( PSOUTH, ROGAUSS, NOGAUSS, 1) - NO1NS + 1
        TEMP = FLOAT(NOAREA(4)) - FLOAT(NOAREA(2))
        TEMP = (TEMP * FLOAT(NOGAUSS) ) / FLOAT(JP90)
CS added for grib2
        LGLOBL = (NONS.EQ.NOGAUSS*2.AND.NOAREA(2).EQ.0)
        NOWE = NINT(TEMP) + 1
        IF( LGLOBL ) NOWE = 4*NOGAUSS
C
        ISCRSZ = NONS * NOWE
        CALL INTLOG(JP_DEBUG,'ISCRSZ: number of latitudes = ', NONS)
        CALL INTLOG(JP_DEBUG,'ISCRSZ: number of longitudes = ', NOWE)
        CALL INTLOG(JP_DEBUG,'ISCRSZ: regular gaussian',JPQUIET)
        GOTO 900
      ENDIF
C
C     -----------------------------------------------------------------|
C*    Section 5.   Reduced (quasi-regular) gaussian field
C     -----------------------------------------------------------------|
C
  500 CONTINUE
C
      IF( (NOREPR.EQ.JPQUASI).OR.(NOREPR.EQ.JPQGGROT) ) THEN
C
        PNORTH = FLOAT( NOAREA(1) ) / PPMULT
        PWEST  = FLOAT( NOAREA(2) ) / PPMULT
        PSOUTH = FLOAT( NOAREA(3) ) / PPMULT
        PEAST  = FLOAT( NOAREA(4) ) / PPMULT
        NO1NS = JNORSGG( PNORTH, ROGAUSS, NOGAUSS, 1)
        NONS  = JNORSGG( PSOUTH, ROGAUSS, NOGAUSS, 1) - NO1NS + 1
CS added for grib2
        LGLOBL = (NONS.EQ.NOGAUSS*2.AND.NOAREA(2).EQ.0)
        NOWE = 0
C
        NOPCNT = 0
        DO LOOP = 1, NOGAUSS*2
          IF( SOUTHOF(PNORTH,ROGAUSS(LOOP)).AND.
     X        SOUTHOF(ROGAUSS(LOOP),PSOUTH) ) THEN
C
C           EMOS-186: disregard area cropping east/west-wise, it seems
C           NUMPTWE assumptions don't hold for RGG/octahedral
C           GRID = 360.0 / REAL(NOLPTS(LOOP))
C           NOPCNT = NOPCNT + NUMPTWE(PWEST,PEAST,GRID)
            NOPCNT = NOPCNT + NOLPTS(LOOP)
C
          ENDIF
        ENDDO
C
        ISCRSZ = NOPCNT
        CALL INTLOG(JP_DEBUG,'ISCRSZ: number of latitudes = ', NONS)
        CALL INTLOG(JP_DEBUG,'ISCRSZ: quasi-regular gaussian',JPQUIET)
        GOTO 900
      ENDIF
C
C     -----------------------------------------------------------------|
C*    Section 9.   Return
C     -----------------------------------------------------------------|
C
  900 CONTINUE
C
      CALL INTLOG(JP_DEBUG,
     X  'ISCRSZ: number of points in output field = ',ISCRSZ)
C
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      INTEGER FUNCTION C2CWID ( KDATA,  KLENP,  KSEC4,  KGRIB,  KLENG,
     X                          KNSPT,  KBITS,  OCOMGR, OLONLY, KLEN4,
     X                          KFIROV, KLEN,   KREFGR, KLENGR, KLWORK,
     X                          KSTART, KPOWER, KMXPWR, KNBIFO, KNCMIN,
     X                          KLWORX, KIWORK, ODEBUG, OPTLEN )
C
C---->
C**** C2CWID
C
C     Purpose.
C     --------
C
C     Performs "constant width packing" method for section 4 of GRIB,
C     and/or computes only length of section 4, with/without coding,
C     with this method.
C
C
C**   Interface.
C     ----------
C
C     KRET = C2CWID ( KDATA,  KLENP,  KSEC4,  KGRIB,  KLENG,  KNSPT,
C    X                KBITS,  OCOMGR, OLONLY, KLEN4,  KFIROV, KLEN,
C    X                KREFGR, KLENGR, KLWORK, KSTART, KPOWER, KMXPWR,
C    X                KNBIFO, KNCMIN, KLWORX, KIWORK, ODEBUG, OPTLEN )
C
C
C     Input Parameters for all options.
C     --------------------------------
C
C     KDATA      - Array of normalized values.
C     KLENP      - Length of array KDATA.
C     KSEC4      - Array of GRIB section 4 integer descriptors.
C     KLENG      - Length of GRIB product array.
C     KNSPT      - Bit pointer for next value in GRIB product.
C     KBITS      - Number of bits per computer word.
C     OCOMGR     - True if COMputing of GRoup arrays is requested.
C     OLONLY     - True if Length ONLY is requested (no coding).
C     KLEN       - Exact number of grid-points to handle.
C     KLWORK     - First dimension of work arrays.
C     KPOWER     - Auxilary array, containing precomputed powers of 2-1.
C     KMXPWR     - Maximum number of bits per original scaled value.
C     KNCMIN     - Minimum increment to use when determining groups.
C     ODEBUG     - True for some debug printout.
C     OPTLEN     - OPTimise LENgth of section 4 (if OCOMGR is true).
C
C
C     Output Parameters for all options.
C     ---------------------------------
C
C     KSEC4      - Array of GRIB section 4 integer descriptors:
C                  KSEC4(11) when OCOMGR and OPTLEN are true;
C                  other indexes when OLONLY is false.
C     KLEN4      - Length of section 4.
C     KLWORX     - Maximum work space used.
C
C     Output Parameters when OLONLY is false.
C     --------------------------------------
C
C     KGRIB      - Array containing GRIB product.
C     KNSPT      - Bit pointer for next value in GRIB product (updated).
C
C     Output Parameters when OCOMGR is true,
C      Input Parameters when OCOMGR is false.
C     --------------------------------------
C
C     KFIROV     - Number of FIrst-Order Values (and groups) determined.
C     KREFGR     - Work array, first-order values for each group.
C     KLENGR     - Work array, effective length of each group.
C     KNBIFO     - Number of BIts for coding First-Order values.
C     KIWORK     - Second index into work arrays corresponding to
C                  optimal or computed case.
C
C     Output Parameters when OCOMGR is true,
C      Input parameter in all cases.
C     --------------------------------------
C
C     KDATA      - Used as work array by C2PACK.
C
C     Input Parameter when OCOMGR is false.
C     -------------------------------------
C
C     KSTART     - First index value of precomputed work arrays KREFGR
C                  and KLENGR.
C
C     Method.
C     -------
C
C     Follows WMO Manual of Codes.
C
C     If requested through OCOMGR, a first scan computes work arrays,
C     bit number for coding first-order values and length of section 4.
C
C     If requested, coding is applied in a second scan, using
C     descriptors computed in the first scan, possibly in a previous
C     call.
C
C     When OPTLEN is true, an iterative process is performed in the
C     first scan, to choose an optimal width leading to minimum length
C     of message (through its section 4).
C
C     Externals.
C     ----------
C
C     C2BITW    - Computes bit width of a positive integer value.
C     C2PACK    - Encodes descriptors and data.
C
C
C     Reference.
C     ----------
C
C     None.
C
C
C     Comments.
C     --------
C
C     On entry, KNSPT points to the first bit of section 4 
C               in the GRIB product.
C     On exit,  KNSPT points to the first unused bit of section 4,
C               (or to the first bit of section 5, if unused bit count
C                is zero) in the GRIB product.
C
C     KDATA is overwritten when coding is requested.
C     This is coherent with GRIBEX.
C
C
C     Author.
C     -------
C
C     J. Clochard, Meteo France, for ECMWF - January 1998.
C
C
C     Modifications.
C     _____________
C
C     J. Clochard, April 1998.
C     Use C2BITW function for bit width computations, out of
C     the splitting algorithm itself.
C     When optimisation is required, use -KSEC4(11) as initial and
C     maximum width for iterative search of optimal width.
C
C     J. Clochard, September 1998.
C     Suppress KSEC1/KSEC2/KSEC3 dummy-arguments.
C         "    KSEC1, add KWORK/KPOWER/KMXPWR argument in C2PACK call.
C
C
C----<
C     -----------------------------------------------------------------
C*    Section 0. Definition of variables.
C     -----------------------------------------------------------------
C
      IMPLICIT NONE
C
#include "common/grprs.h"
C
C     Subroutine arguments
C
      INTEGER KLENP, KLENG, KNSPT, KBITS, KLEN4, KNCMIN, KLWORX, KIWORK
      INTEGER KLEN, KLWORK, KMXPWR, KNBIFO, KFIROV, KSTART
      INTEGER KDATA (KLENP), KSEC4 (*), KGRIB (KLENG), KREFGR (KLWORK,2)
      INTEGER KPOWER (0:KMXPWR), KLENGR (KLWORK,2)
C
      LOGICAL OLONLY, OCOMGR, ODEBUG, OPTLEN
C
C     Local variables.
C
      INTEGER INBITN, ICOUNT, INBITX, INBIFO, ILDSTA
      INTEGER IGROUP, INCR, ISIZEG, INBIT, INCMIR, IPOWER, ICWORK
      INTEGER J, IDMAX, IDMIN, ISOMAX, ICRITR, ICRITO, INCRBI
      INTEGER IRETFN, IBITGW, IFOMAX, INCMIN, INBITO, IDMAXG, IDMING
      INTEGER INBIFX, INBICW, IOFF, IFIROV, ISTART, ILWORK
C
      INTEGER C2PACK, C2BITW
      EXTERNAL C2PACK, C2BITW
C
      INTRINSIC ABS
C
C     -----------------------------------------------------------------
C*    Section 1 . Performs initial checks.
C     -----------------------------------------------------------------
C
  100 CONTINUE
C
#ifndef ebug2o
      IF (ODEBUG) THEN
#endif
        WRITE(GRPRSM,FMT=9100) OCOMGR, OPTLEN, OLONLY, KNSPT
#ifndef ebug2o
      ENDIF
#endif
C
      IRETFN = 0
      ICOUNT=0
      ILDSTA=21
      IBITGW=8
      INBITO=KSEC4(2)
      KLWORX=0
C
      IF (.NOT.OCOMGR) THEN
C
        IF (OLONLY) THEN
          IRETFN = 21110
          WRITE(GRPRSM,FMT=9110)
          GOTO 900
        ELSE
          INBIFO=KNBIFO
          INBICW=KSEC4(11)
          IFIROV=KFIROV
          KLWORX=KFIROV
          ISTART=KSTART
          GOTO 300
        ENDIF
C
      ENDIF
C
C     -----------------------------------------------------------------
C*    Section 2 . Computing of references and lengths of groups.
C     -----------------------------------------------------------------
C
  200 CONTINUE
C
      IFIROV=(KLWORK+1)
      INBIFO=INBITO
      INBICW=INBITO
      INCMIN=MIN (MAX (KNCMIN,1),1+KLEN/2)
      ISIZEG=1 + INT ( SQRT ( REAL (KLEN-1) ) /5. )
      ISIZEG=MAX (ISIZEG,INCMIN)
      ICWORK=1
      ISTART=1
C
C     Initial value for criterion to minimize in iterative process.
C     Over-estimated (expressed in bits instead of octets).
C
      ICRITO=8+IFIROV*(INBIFO+1)-1+8+(KLEN+1)*(INBICW+1)-1
C
      IF (OPTLEN) THEN
C
C     In this case, no predetermined number of bits is assigned.
C     An iterative process will compute a number of bits leading to
C     a (relative) minimum length of coded message.
C
        INBITX=ABS (KSEC4(11))
        INBITN=0
        INBIT=MAX (INBITX-1,INBITN)
        INCRBI=-MIN ( 3 , MAX (1,(INBIT-INBITN)/3) )
      ELSE
C
C     Width (number of bits for second-order values) is KSEC4(11).
C
        INBITX=KSEC4(11)
        INBITN=KSEC4(11)
        INBIT=KSEC4(11)
        INCRBI=-1
      ENDIF
C
#ifndef ebug2o
      IF (ODEBUG) THEN
#endif
        WRITE(GRPRSM,FMT=9200) INBITO, (KSEC4(J),J=1,13),
     X                          INCMIN, ISIZEG
#ifndef ebug2o
      ENDIF
C
#endif
C     -----------------------------------------------------------------
C                     Start of iterative process.
C     -----------------------------------------------------------------
C
  210 CONTINUE
C
#ifndef ebug2o
      IF (ODEBUG) THEN
#endif
        WRITE(GRPRSM,FMT=9210) INBITX, INBITN, INBIT, INCRBI
#ifndef ebug2o
      ENDIF
C
#endif
      ICOUNT=0
      IGROUP=0
      IFOMAX=0
      IPOWER=KPOWER(INBIT)
C
C     -----------------------------------------------------------------
C                  Determination of an initial group.
C     -----------------------------------------------------------------
C
  220 CONTINUE
C
      ISIZEG=MIN (ISIZEG,KLEN-ICOUNT)
C
C     Extrema computed in-line for better efficiency.
C
      IDMAX=KDATA(ICOUNT+1)
      IDMIN=KDATA(ICOUNT+1)
C
      DO 221 J=2,ISIZEG
      IDMAX=MAX (IDMAX,KDATA(ICOUNT+J))
      IDMIN=MIN (IDMIN,KDATA(ICOUNT+J))
  221 CONTINUE
C
      ISOMAX=IDMAX-IDMIN
C     PRINT *,'c2cwid - ICOUNT=',ICOUNT,', ISIZEG=',ISIZEG,
C    S        ', IDMIN=',IDMIN,', IDMAX=',IDMAX,', ISOMAX=',ISOMAX
C
      IF (ISOMAX.GT.IPOWER) THEN
C
C     Initial segment does not fit within INBIT bits, reduce and retry.
C
        ISIZEG=ISIZEG/2
        GOTO 220
      ELSEIF (ISIZEG.LT.INCMIN.AND.IGROUP.NE.0) THEN
C
C     Initial group size very small. Try to join previous group...
C
        IDMAXG=MAX (IDMAX,IDMAXG)
        IDMING=MIN (IDMIN,IDMING)
        ISOMAX=IDMAXG-IDMING
C
        IF (ISOMAX.LE.IPOWER) THEN
C
C     ... succesfully.
C
          KLENGR(IGROUP,ICWORK)=KLENGR(IGROUP,ICWORK)+ISIZEG
          ICOUNT=ICOUNT+ISIZEG
          GOTO 241
        ENDIF
C
      ENDIF
C
      IDMAXG=IDMAX
      IDMING=IDMIN
      IOFF=ICOUNT+ISIZEG
      INCR=MIN (ISIZEG,KLEN-IOFF)
C
      IF (INCR.EQ.0) THEN
        GOTO 240
      ENDIF
C
C     -----------------------------------------------------------------
C                Try to add increments to initial group.
C     -----------------------------------------------------------------
C
  230 CONTINUE
C
      IDMAX=IDMAXG
      IDMIN=IDMING
C
#ifdef FUJITSU
!OCL SCALAR
#endif
      DO 231 J=1,INCR
      IDMAX=MAX (IDMAX,KDATA(IOFF+J))
      IDMIN=MIN (IDMIN,KDATA(IOFF+J))
  231 CONTINUE
#ifdef FUJITSU
!OCL VECTOR
#endif
C
      ISOMAX=IDMAX-IDMIN
C     PRINT *,'c2cwid - IOFF=',IOFF,', ISIZEG=',ISIZEG,
C    S      ', INCR=',INCR,', ISOMAX=',ISOMAX,', IGROUP+1=',IGROUP+1
C
C     If end of data very near, relax constraint on minimum increment.
C
      INCMIR=MAX ( 1, MIN (KLEN-IOFF,INCMIN) )
C
      IF (ISOMAX.LE.IPOWER) THEN
C
C     Incremental group added to current group.
C
        IDMAXG=IDMAX
        IDMING=IDMIN
        IOFF=IOFF+INCR
        INCR=MIN (ISIZEG,KLEN-IOFF)
C
        IF (INCR.NE.0) THEN
          GOTO 230
        ENDIF
C
      ELSEIF (INCR.GT.INCMIR) THEN
C
C     Incremental group does not fit, try a smaller one.
C
        INCR=MAX (INCR/2,INCMIR)
        GOTO 230
      ENDIF
C
C     -----------------------------------------------------------------
C     No incremental group may be added. Current group is closed.
C     -----------------------------------------------------------------
C
  240 CONTINUE
C
      IGROUP=IGROUP+1
      KLENGR(IGROUP,ICWORK)=IOFF-ICOUNT
      ICOUNT=IOFF
      ISOMAX=IDMAXG-IDMING
C
C     Maximum use of width for second-order values: the maximum value
C     of group will be encoded with the biggest value fitting in
C     INBIT bits, and keeping reference value positive or zero.
C
C     The goal is to get the lowest reference value, thus trying
C     (desperately) to save bit(s) to encode the first-order values.
C
  241 CONTINUE
C
      KREFGR(IGROUP,ICWORK)=MAX (0,IDMING-(IPOWER-ISOMAX))
      IFOMAX=MAX (IFOMAX,KREFGR(IGROUP,ICWORK))
#ifdef ebug2o
C
      IF (.NOT.OLONLY) THEN
        PRINT *,'c2cwid - group',IGROUP,KLENGR(IGROUP,ICWORK),INBIT
     X         ,' (...)',IDMING,ISOMAX,KREFGR(IGROUP,ICWORK),ICOUNT
      ENDIF
#endif
C
      IF (ICOUNT.EQ.KLEN) THEN
        GOTO 250
      ELSEIF (IGROUP.LT.KLWORK) THEN
        ISIZEG=MAX (INCMIN,ISIZEG,KLENGR(IGROUP,ICWORK)/2)
        GOTO 220
      ELSE
C
C     Out of work space. A message is issued, except in iterative
C     process, if the estimated length is already bigger than
C     previously computed.
C
        KLWORX=MAX (KLWORX,IGROUP)
        ICRITR=(8+(IGROUP+1)*INBIFO-1)/8+(8+KLEN*INBIT-1)/8
C
        IF (ICRITR.LT.ICRITO) THEN
          WRITE(GRPRSM,FMT=9240) KLWORK, INBIT
        ENDIF
C
        IF (INBIT.LT.INBITX.AND.INBIT.GT.INBITN) THEN
C
C     Other bit value(s) may still be tried.
C
          ICRITR=ICRITO+1
          GOTO 260
        ELSEIF (INBICW.NE.INBITO) THEN
C
C     A constant width has been successfully computed before.
C     It will be used as the best computable result.
C
          GOTO 270
        ELSE
          IRETFN = 21240
          GOTO 900
        ENDIF
C
      ENDIF
C
  250 CONTINUE
C
      KLWORX=MAX (KLWORX,IGROUP)
C
C     Number of bits necessary to code first-order values.
C
      INBIFX = C2BITW ( IFOMAX, INBITO, KPOWER, KMXPWR )
C
      ICRITR=(8+IGROUP*INBIFX-1)/8+(8+KLEN*INBIT-1)/8
C
  260 CONTINUE      
C
#ifndef ebug2o
      IF (ODEBUG) THEN
#endif
        WRITE(GRPRSM,FMT=9260) INBIT, INBIFX, IGROUP, ICRITR
#ifndef ebug2o
      ENDIF
C
#endif
      IF (ICRITR.LT.ICRITO) THEN
C
C     INBIT may be retained, at least temporarily, for constant width.
C
        INBICW=INBIT
        IFIROV=IGROUP
        INBIFO=INBIFX
        KIWORK=ICWORK
        ICWORK=1+MOD (ICWORK,2)
        ICRITO=ICRITR
C
        IF (INBIT.GT.INBITN) THEN
C
C     Decrease INBIT for next trial.
C
          IF (INCRBI.LT.0) THEN
            INCRBI=MAX ( INCRBI , MIN (-1,(INBITN-INBIT)/3) )
          ELSE
            INCRBI=MAX ( MIN (-1,1-INCRBI) , INBITN-INBIT )
          ENDIF
C
          INBITX=INBIT-1
          INBIT=INBIT+INCRBI
          GOTO 210
        ENDIF
C
      ENDIF
C
      IF (INBIT.LT.INBITX) THEN
C
C             INBIT not suitable, increase it and retry.
C
        INBITN=INBIT+1
        INCRBI=MIN ( MAX (ABS(1-INCRBI),1) , INBITX-INBIT )
        INBIT=INBIT+INCRBI
        GOTO 210
C
      ENDIF
C
C     Work done, and/or no better length than previously.
C
  270 CONTINUE      
C
C     Compute full length of section 4 of GRIB.
C 
      KLEN4=ILDSTA + 1 + (8+KLEN-1)/8 + ICRITO
      KLEN4=2*((2+KLEN4-1)/2)
      KNBIFO=INBIFO
      KFIROV=IFIROV
C
      IF (OPTLEN) THEN
        KSEC4(11)=INBICW
      ENDIF
C
      IF (OLONLY) THEN
C
C       Length has been computed, go back without any coding.
C
        GOTO 900
C
      ENDIF
C
C     -----------------------------------------------------------------
C*    Section 3. Definition of fixed-length descriptors and coding.
C     -----------------------------------------------------------------
C
  300 CONTINUE
C
C     The first 10 octets have already been coded in GRIBEX, or will
C     be in a further step of GRIBEX:
C     Length of section, flags+unused bit count, binary scale factor,
C     reference value.
C
#ifndef ebug2o
      IF (ODEBUG) THEN
#endif
        WRITE(GRPRSM,FMT=9300) 
#ifndef ebug2o
      ENDIF
C
#endif
C     Enforce right values for extended flags.
C
      KSEC4( 9)=32
      KSEC4(10)=0
      KSEC4(12)=0
C
C     Extra descriptors.
C
      KSEC4(18)=KFIROV
      KSEC4(20)=IBITGW
      ILWORK=KLWORK-ISTART+1
C
C     KREFGR alone in call corresponds to a formal argument of function
C     C2PACK, which has to be there but is not used for constant width
C     packing.
C
      IRETFN = C2PACK ( KDATA,  KLENP,  KSEC4,  KGRIB,  KLENG,  KNSPT,
     X                  KBITS,  KLEN,   KREFGR(ISTART,KIWORK),
     X                  KLENGR(ISTART,KIWORK),          KREFGR,
     X                  KREFGR, ILWORK, KPOWER, KMXPWR, KNBIFO, ODEBUG )
C
C     -----------------------------------------------------------------
C*    Section 9. Return to calling routine.
C     -----------------------------------------------------------------
C
  900 CONTINUE
C
      C2CWID = IRETFN
#ifndef ebug2o
C
      IF (ODEBUG) THEN
#endif
        WRITE(GRPRSM,FMT=9900) IRETFN, OCOMGR, OPTLEN, OLONLY, KNSPT
#ifndef ebug2o
      ENDIF
#endif
C
      RETURN
C
 9100 FORMAT (' C2CWID: Function start, OCOMGR = ',L1,
     X        ', OPTLEN = ',L1,', OLONLY = ',L1,', KNSPT =',I10,'.')
C
 9110 FORMAT (' C2CWID: Routine called, but has nothing to do.')
C
 9200 FORMAT (' C2CWID: Computing work arrays, INBITO =',I3,'.',/,
     X        ' C2CWID: KSEC4(1:13)=',I9,I3,I4,3I3,I2,4I3,2I2,'.',/,
     X        ' C2CWID: INCMIN =',I3,', ISIZEG =',I6,'.')
C
 9210 FORMAT (' C2CWID: INBITX =',I3,', INBITN =',I3,', INBIT =',I3,
     X        ', INCRBI =',I3,'.')
C
 9240 FORMAT (' C2CWID: Groups number exceeds work space (',I8,
     X        '), giving up for INBIT =',I3,'.')
C
 9260 FORMAT (' C2CWID: INBIT =',I3,', INBIFX =',I3,', IGROUP =',I8,
     X        ', ICRITR =',I9,'.')
C
 9300 FORMAT (' C2CWID: Coding phase - calling C2PACK.')
C
 9900 FORMAT (' C2CWID: Function return code=',I6,
     X        ', OCOMGR/OPTLEN/OLONLY/KNSPT=',3L1,I10,'.')
C
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C


      INTEGER FUNCTION CNBITS( VALUES, LAT, LONG )
C
C---->
C**** CNBITS
C
C     Purpose.
C     --------
C
C     Calculate the number of bits needed to code a range of
C     field values.
C
C
C**   Interface.
C     ----------
C
C     CALL CNBITS( VALUES, LAT, LONG )
C
C
C     Input
C     -----
C
C     VALUES   -  array of real numbers
C     LAT      -  first dimension of the array
C                 (e.g. number of points along a meridian )
C     LONG     -  second dimension of the array
C                 (e.g. number of points along a parallel )
C
C
C     Output
C     ------
C
C     CNBITS return value is required number of bits.
C
C
C     Method.
C     -------
C
C     Finds power of 2 required to scan the range of values.
C
C
C     Externals.
C     ----------
C
C     None.
C
C
C     Reference.
C     ----------
C
C     None.
C
C
C     Comments.
C     ---------
C
C     None.
C
C
C     Author.
C     -------
C
C     J.D.Chambers           ECMWF      8 Nove 1994
C
C
C     Modifications.
C     --------------
C
C     None.
C
C   
C----<
C     ----------------------------------------------------------------
C*    Section 0 . Definition of variables.
C     ----------------------------------------------------------------
C                                                                
      IMPLICIT NONE
C
C     Arguments
      INTEGER LAT,LONG
      REAL VALUES( LAT, LONG)
C
C     Local variables
      INTEGER ILAT,ILON
      REAL RMAXV, RMINV, RANGE
C   
C     ----------------------------------------------------------------
C*    Section 1 . Find maximum and minimum for the given values
C     ----------------------------------------------------------------
C                                                                
 100  CONTINUE
      CNBITS = 0
C
C     Find maximum and minimum for the given values
      RMINV = 0.0
      RMAXV = 0.0
C
      DO 120 ILAT = 1, LAT
        DO 110 ILON = 1, LONG
          IF ( RMINV .GT. (VALUES( ILAT, ILON)) )
     X      RMINV = (VALUES( ILAT, ILON))
          IF ( RMAXV .LT. (VALUES( ILAT, ILON)) )
     X      RMAXV = (VALUES( ILAT, ILON))
  110   CONTINUE
  120 CONTINUE
C
      RANGE = ABS( RMAXV - RMINV )
C
C     Calculate the number of bits needed to span the number range
      IF ( RANGE .EQ. 0.0 ) THEN
        CNBITS = 1
      ELSE
        CNBITS = INT ( (ALOG( RANGE )/ALOG(2.0)) ) + 1
      ENDIF
C
      RETURN
      END

C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE JWINDLL( PSHUP, KTRUNC, PSTART, PBUILD, PINTVL, KLUNIT,
     X                    KLATO,KLONO,PLEG,PTRIGS,KMFAX,PZFA,KRET)
C
C---->
C**** JWINDLL
C
C     Purpose
C     -------
C     This routine converts spectral input fields to standard
C     lat/long grid fields for wind components U and V.
C
C
C     Interface
C     ---------
C     CALL JWINDLL( PSHUP, KTRUNC, PSTART, PBUILD, PINTVL, KLUNIT,
C    X              KLATO,KLONO,PLEG,PTRIGS,KMFAX,PZFA,KRET)
C
C
C     Input parameters
C     ----------------
C     PSHUP  - Spherical harmonics field, unpacked
C     KTRUNC - Truncation number of spherical harmonics field
C     PSTART - Start latitude (northernmost) for output field
C              (must be positive - see comments below)
C     PBUILD - Grid interval used to build the legendre coefficients file
C     PINTVL - Grid latitude interval in degrees
C     KLUNIT - stream number of the legendre function file
C     KLATO  - Number of latitude points in output field
C     KLONO  - Number of longitude points in output field
C     PLEG   - Array used to hold legendre functions
C     PTRIGS - Initialized array of trig.functions (setup by JJSET99)
C     KMFAX  - Initialized array of prime factors (setup by JJSET99)
C
C
C     Output parameters
C     -----------------
C     PZFA - Output grid point field; contains upto 32 each of
C            North and South latitude rows symmetrically.
C     KRET - Return status code
C            0 = OK
C
C
C     Common block usage
C     ------------------
C     JDCNDBG
C
C
C     Method
C     ------
C     None.
C
C
C     Externals
C     ---------
C     JREADLL - Reads the legendre functions for a latitude
C     JSPPOLE - Applies correction at North or South pole
C     FFT99   - Carries out FFT
C     INTLOG  - Output log message
C     INTLOGR - Output log message (with real value)
C     GETENV  - Pick up contents of an environment variable
C     JUVPOLE - Use gaussian grid to calculate U and V at the poles
C
C
C     Reference
C     ---------
C     E.C.M.W.F. Research Department technical memorandum no. 56
C                "The forecast and analysis post-processing package"
C                May 1982. J.Haseler.
C
C
C     Comments
C     --------
C     This is a redesign, based on SPECGP.F
C
C     It handles transformation to a regular lat/long grid.
C     The generated grid is symmetrical about the equator, so
C     PSTART must be positive.
C
C     It is only for U and V fields (correction is applied at the 
C     poles and a scale factor is applied according to latitude).
C
C
C     Author
C     ------
C     J.D.Chambers      *ECMWF*      Nov 1993
C
C
C     Modifications
C     -------------
C     J.D.Chambers     ECMWF        Feb 1997
C     Allow for 64-bit pointers
C
C     J.D.Chambers     ECMWF        October 2002
C     Add handling for U/V spectral (as opposed to Ucos(theta)/Vcos(theta))
C
C
C----<
C     -----------------------------------------------------------------|
C
C
      IMPLICIT NONE
#include "jparams.h"
#include "parim.h"
#include "nifld.common"
C
C     Subroutine arguments
C
      COMPLEX   PSHUP
      DIMENSION PSHUP(*)
      INTEGER   KTRUNC
      REAL      PSTART, PBUILD, PINTVL
      INTEGER   KLUNIT, KLATO, KLONO, KMFAX, KRET
      REAL PLEG, PTRIGS, PZFA
      DIMENSION PZFA(JPLONO + 2, 64)
      DIMENSION KMFAX(*), PLEG(*), PTRIGS(*)
C
C     Parameters
C
      INTEGER JPROUTINE
      PARAMETER ( JPROUTINE = 31400 )
C
C     Local variables
C
      REAL ZPIBY2, ZDEGR, ZLAT
      INTEGER ILIM, IMLIM, ILN
      INTEGER ITAL, ITALA, ITALS, IMN, IMP
      INTEGER INORTH, ISOUTH
      INTEGER JM, J245, JNEXTLAT
      INTEGER NERR
      INTEGER*8 IOFF
      INTEGER*8 JDCLOOP
      REAL ZF
      REAL ZCOSI
C
      DIMENSION ZF(2*JPFFT)
C
#ifndef _CRAYFTN
#ifdef POINTER_64
      INTEGER*8 IWORK
#endif
#endif
      REAL WORK
      DIMENSION WORK(1)
      POINTER ( IWORK, WORK )
      COMPLEX   ZDUM(JPTRNC + 1)
      COMPLEX   ZSUMS(JPTRNC + 1), ZSUMA(JPTRNC + 1)
      COMPLEX*16 CHOLD
      INTEGER LOOP
C
      LOGICAL LXFIRST, LPLAINU
      INTEGER ISIZE, IBLANK
      CHARACTER*10 PLAINUV
C
      DATA LXFIRST/.TRUE./, LPLAINU/.FALSE./
      DATA ISIZE/0/
      SAVE ISIZE, IWORK, LXFIRST, LPLAINU
C
C     Statement function
C
      LOGICAL GPOLE
      REAL ANGLE
      GPOLE(ANGLE) = ( ABS(90.0 - ABS(ANGLE) ) .LT. 1.0E-3 )
C                  = .TRUE. if LAT is 90.0 or -90.0
C
C     -----------------------------------------------------------------|
C*    Section 1.    Initialization.
C     -----------------------------------------------------------------|
C
  100 CONTINUE
C
C     Check environment variable to see if wind components are plain
C     U and V, or U*cos(theta) and V*cos(theta) (the default).
C
      IF( LXFIRST ) THEN
C
        LXFIRST = .FALSE.
        CALL GETENV('INTERP_PLAIN_UV', PLAINUV)
        IBLANK = INDEX(PLAINUV, ' ')
C
        IF( (IBLANK.EQ.3).AND.(PLAINUV(1:2).EQ.'ON') )  LPLAINU =.TRUE.
        IF( (IBLANK.EQ.3).AND.(PLAINUV(1:2).EQ.'on') )  LPLAINU =.TRUE.
        IF( (IBLANK.EQ.4).AND.(PLAINUV(1:3).EQ.'YES') ) LPLAINU =.TRUE.
        IF( (IBLANK.EQ.4).AND.(PLAINUV(1:3).EQ.'yes') ) LPLAINU =.TRUE.
C
        IF( (IBLANK.EQ.3).AND.(PLAINUV(1:2).EQ.'NO') )  LPLAINU =.FALSE.
        IF( (IBLANK.EQ.3).AND.(PLAINUV(1:2).EQ.'no') )  LPLAINU =.FALSE.
        IF( (IBLANK.EQ.4).AND.(PLAINUV(1:3).EQ.'OFF') ) LPLAINU =.FALSE.
        IF( (IBLANK.EQ.4).AND.(PLAINUV(1:3).EQ.'off') ) LPLAINU =.FALSE.
C
C       First time through, dynamically allocate memory for workspace
C
        ISIZE =  2*JPFFT*64
        CALL JMEMHAN( 9, IWORK, ISIZE, 1, KRET)
        IF( KRET.NE.0 ) THEN
          CALL INTLOG(JP_ERROR,'JWINDLL: memory allocation error',IWORK)
          KRET = JPROUTINE + 1
          GOTO 990
        ENDIF
      ENDIF
C
      IF( NDBG.GT.1 ) THEN
        CALL INTLOG(JP_DEBUG,
     X    'JWINDLL: Spherical harmonic coeffs(first 20):',JPQUIET)
        DO NDBGLP = 1, 20
          CALL INTLOGR(JP_DEBUG,' ',PSHUP( NDBGLP ))
        ENDDO
        CALL INTLOG(JP_DEBUG,
     X    'JWINDLL: Input parameters:',JPQUIET)
        CALL INTLOG(JP_DEBUG,
     X    'JWINDLL: Spherical harmonic truncation = ', KTRUNC)
        CALL INTLOGR(JP_DEBUG,
     X    'JWINDLL: Start latitude(northernmost) = ', PSTART)
        CALL INTLOGR(JP_DEBUG,
     X    'JWINDLL: Grid lat. interval(leg. file) = ', PBUILD)
        CALL INTLOGR(JP_DEBUG,
     X    'JWINDLL: Grid lat. interval(degrees) = ', PINTVL)
        CALL INTLOG(JP_DEBUG,
     X    'JWINDLL: Stream number of leg. file = ', KLUNIT)
        CALL INTLOG(JP_DEBUG,
     X    'JWINDLL: Number of lat. rows in output = ', KLATO)
        CALL INTLOG(JP_DEBUG,
     X    'JWINDLL: Number of long. pts per row = ', KLONO)
        CALL INTLOG(JP_DEBUG,
     X    'JWINDLL: Trig.functions (setup by JJSET99):',JPQUIET)
        DO NDBGLP = 1, 10
          CALL INTLOGR(JP_DEBUG,' ',PTRIGS( NDBGLP ))
        ENDDO
        CALL INTLOG(JP_DEBUG,
     X    'JWINDLL: Prime factors (setup by JJSET99):',JPQUIET)
        DO NDBGLP = 1, 10
          CALL INTLOG(JP_DEBUG,' ',KMFAX( NDBGLP ))
        ENDDO
      ENDIF
C
      ZPIBY2 = PPI / 2.0
      ZDEGR  = PPI / 180.0
      ILIM   = KTRUNC + 1
      IMLIM  = KTRUNC + 1
      INORTH = -1
      ILN    = KLONO + 2
C
C     -----------------------------------------------------------------|
C*    Section 2.    Main loop through latitude rows to
C*                  calculate fourier coefficients
C     -----------------------------------------------------------------|
C
 200  CONTINUE
C
C     For each latitude, the north and corresponding south latitude row
C     are calculated at the same time from the same legendre functions.
C
      DO 280 JNEXTLAT = 1, KLATO
        ZLAT  = ( PSTART - (PINTVL * REAL(JNEXTLAT - 1)) )
C
        IF( NDBG.GT.1 )
     X    CALL INTLOGR(JP_DEBUG, 'JWINDLL: Next latitude = ', ZLAT)
C
C       If required, generate the coefficients 'on the fly'
C
        IF( LON_FLY ) THEN
          CALL NMAKLL( KTRUNC, PBUILD, ZLAT, 1, PLEG, NERR)
          IOFF = 0
        ELSE IF( LFILEIO ) THEN
          CALL JREADLL( KLUNIT, KTRUNC, PBUILD, ZLAT, PLEG, NERR)
          IF ( NERR .NE. 0 ) THEN
            CALL INTLOG(JP_ERROR,'JWINDLL: JREADLL error',NERR)
	    KRET = JPROUTINE + 2
	    GOTO 990
	  ENDIF
        ELSE
            IOFF = NINT( (90.0 - ZLAT)/PBUILD )
            IOFF = IOFF *(KTRUNC+1)
            IOFF = IOFF *(KTRUNC+4)
            IOFF = IOFF/2
        ENDIF
C
C     Clear unused slots in array.
C     Note there are two slots in the array - one for north latitude 
C     and one for the corresponding south latitude.
        INORTH = INORTH + 2
        ISOUTH = INORTH + 1
        DO LOOP = 1, ILN
          ZF( LOOP) = 0.0
          PZFA( LOOP, INORTH) = 0.0
          PZFA( LOOP, ISOUTH) = 0.0
        ENDDO
C
C       For spectral Ucos(theta), Vcos(theta), treat the poles as a
C       special case.
C
        IF( GPOLE(ZLAT).AND.(.NOT.LPLAINU) ) THEN
C
          IF( NDBG.GT.1 ) CALL INTLOG(JP_DEBUG,
     X      'JWINDLL: Pole special for spectral Ucos(t), Vcos(t)',
     X      JPQUIET)
C
          CALL JSPPOLE( PSHUP, 1, KTRUNC, .TRUE., ZF)
          DO LOOP = 1, ILN
            PZFA( LOOP, INORTH) = ZF( LOOP)
          ENDDO
C
          CALL JSPPOLE( PSHUP, 0, KTRUNC, .TRUE., ZF)
          DO LOOP = 1, ILN
            PZFA( LOOP, ISOUTH) = ZF( LOOP)
          ENDDO
C
        ELSE
C
C       Otherwise not at pole, or spectral U and V
C
C         Fill slots which are used
          IMN = 0
          IMP = 0
C
          DO 247 JM = 1, IMLIM
            ITAL = ILIM - JM + 1
            DO 245 J245 = 1, ITAL
              IF( LFILEIO ) THEN
                ZDUM(J245) = PLEG(IMP + J245)*PSHUP(IMN + J245)
              ELSE
                JDCLOOP = IMP + J245 + IOFF
                ZDUM(J245) = PLEG(JDCLOOP)*PSHUP(IMN + J245)
              ENDIF
 245        CONTINUE
            IMP = IMP + ITAL + 1
            IMN = IMN + ITAL
            ITALS = (ITAL + 1)/2
            ITALA = ITAL/2
            CHOLD = (0.0D0, 0.0D0)
            DO LOOP = 1, 2*ITALS, 2
              CHOLD = CHOLD + ZDUM(LOOP)
            ENDDO
            ZSUMS(JM) = CHOLD
            CHOLD = (0.0D0, 0.0D0)
            DO LOOP = 2, 2*ITALA, 2
              CHOLD = CHOLD + ZDUM(LOOP)
            ENDDO
            ZSUMA(JM) = CHOLD
 247      CONTINUE
C
C       For the southern hemisphere row, the legendre functions are
C       the complex conjugates of the corresponding northern row -
C       hence the juggling with the signs in the next loop.
C
C       Note that PZFA is REAL, but the coefficients being calculated
C       are COMPLEX.  There are pairs of values for each coefficient
C       (real and imaginary parts) and pairs of values for each
C       latitude (north and south).
C
          DO JM = 1, IMLIM
            PZFA(2*JM -1, INORTH) = REAL(ZSUMS(JM))  + REAL(ZSUMA(JM))
            PZFA(2*JM   , INORTH) = AIMAG(ZSUMS(JM)) + AIMAG(ZSUMA(JM))
            PZFA(2*JM -1, ISOUTH) = REAL(ZSUMS(JM))  - REAL(ZSUMA(JM))
            PZFA(2*JM   , ISOUTH) = AIMAG(ZSUMS(JM)) - AIMAG(ZSUMA(JM))
          ENDDO
        ENDIF
C
C*    End of main loop through latitude rows.
C
 280  CONTINUE
C
C     -----------------------------------------------------------------|
C*    Section 3.    Fast fourier transform
C     -----------------------------------------------------------------|
C
 300  CONTINUE
C
      IF( NDBG.GT.1 ) CALL INTLOG(JP_DEBUG,
     X  'JWINDLL: FFT, no.of rows (N and S) = ', ISOUTH)
C
      CALL FFT99(PZFA,WORK,PTRIGS,KMFAX,1,J2NFFT,KLONO,ISOUTH,1)
C
      IF( NDBG.GT.1 ) THEN
        CALL INTLOG(JP_DEBUG,
     X    'JWINDLL: Values calculated by FFT:',JPQUIET)
        DO NDBGLP = 1, 20
          CALL INTLOGR(JP_DEBUG,' ',PZFA( 1, NDBGLP ))
          CALL INTLOGR(JP_DEBUG,' ',PZFA( 2, NDBGLP ))
        ENDDO
      ENDIF
C
C     For spectral U, V generate the poles from a reduced gaussian line
C     of latitude.
C
      IF( GPOLE(PSTART).AND.(LPLAINU) ) THEN
C
        IF( NDBG.GT.1 ) CALL INTLOG(JP_DEBUG,
     X    'JWINDLL: Poles generated from gaussian for spectral U, V',
     X    JPQUIET)
C
        CALL JUVPOLE(PSHUP, KTRUNC, PZFA, KLONO, KRET)
        IF( KRET.NE.0 ) THEN
          CALL INTLOG(JP_ERROR,'JWINDLL: pole wind create error',IWORK)
          KRET = JPROUTINE + 1
          GOTO 990
        ENDIF
C
      ENDIF
C
C     -----------------------------------------------------------------|
C*    Section 4.    For spectral Ucos(theta), Vcos(theta), apply scale
C                   factor to all latitudes except poles.
C     -----------------------------------------------------------------|
C
 400  CONTINUE
C
      IF( NDBG.GT.0 ) THEN
        IF( LPLAINU ) THEN
          CALL INTLOG(JP_DEBUG,
     X      'JWINDLL: Do not apply scale to latitudes',JPQUIET)
        ELSE
          CALL INTLOG(JP_DEBUG,
     X      'JWINDLL: Apply scale to latitudes',JPQUIET)
        ENDIF
      ENDIF
C
      IF( .NOT.LPLAINU ) THEN
        INORTH = -1
        DO JNEXTLAT = 1, KLATO
          ZLAT  = ( PSTART - (PINTVL * REAL(JNEXTLAT - 1)) )
          INORTH = INORTH + 2
          ISOUTH = INORTH + 1
          IF( .NOT.GPOLE(ZLAT) ) THEN
            ZCOSI = 1.0 / COS( ZLAT * ZDEGR )
            CALL SSCAL( KLONO, ZCOSI, PZFA( 2, INORTH), 1)
            CALL SSCAL( KLONO, ZCOSI, PZFA( 2, ISOUTH), 1)
          ENDIF
        ENDDO
C
      ENDIF
C     -----------------------------------------------------------------|
C*    Section 9. Return to calling routine. Format statements
C     -----------------------------------------------------------------|
C
 900  CONTINUE
C
      KRET = 0
C
 990  CONTINUE
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities
C granted to it by virtue of its status as an intergovernmental organisation
C nor does it submit to any jurisdiction.
C

      SUBROUTINE ECDEF4( HFUNC, KSEC1, KGRIB, KLENG, KNSPT, KBITS,
     X                   KPLEN, KPR, KRET)
C
C---->
C**** ECDEF4
C
C     Purpose.
C     --------
C
C     GRIB coding/decoding of ECMWF local use of definition 4.
C     (Ocean extensions).
C
C**   Interface.
C     ----------
C
C    CALL ECDEF4( HFUNC, KSEC1, KGRIB, KLENG, KNSPT, KBITS, KPLEN, KPR, KRET)
C
C     Input Parameters.
C     -----------------
C
C     HFUNC      - Requested function.
C                  'C' to code data.
C                  'D' to decode data.
C
C     KSEC1      - Array containing Grib Section 1 data.
C
C     KGRIB      - Array containing Grib coded data.
C
C     KLENG      - Length (words) of KGRIB.
C
C     KNSPT      - Bit number after which insertion/extraction starts.
C
C     KBITS      - Number of bits in computer word.
C
C     KPLEN      - Pointer to field containing length of Section 1.
C
C     KPR        - Debug print switch.
C                  0  , No printout.
C                  >0 , Debug printout.
C
C     KRET       - Response to error indicator.
C                  0        , Abort if error encountered.
C                  Non-zero , Return to calling routine
C                             even if error encountered.
C
C     Output Parameters.
C     ------------------
C
C     KSEC1      - Array containing Grib Section 1 data.(Updated)
C
C     KGRIB      - Array containing Grib coded data.(Updated)
C
C     KNSPT      - Number of bit after last one inserted/extracted.(Updated)
C
C     KRET       - Return code.
C                  0   , No error encountered.
C                  2   , Error reported by routine INXBIT.
C
C
C     Method.
C     -------
C
C     Input data packed/unpacked in accordance with ECMWF usage of
C     local part of section 1 of Grib code, definition 4.
C
C
C     Externals.
C     ----------
C
C     INXBIT
C     ABORTX
C     CSGNBT
C     DSGNBT
C
C
C     Reference.
C     ----------
C
C     WMO Manual On Codes for Grib Code.
C
C
C     Comments.
C     ---------
C
C     Adapted from ECLOC1.F - simplified to handle just definition 4.
#include "ecdef4.h"
C
C     Author.
C     -------
C
C     J.D.Chambers     ECMWF      18th January 1995
C
C     Modifications.
C     --------------
C
C     J.D.Chambers     ECMWF       Jan 2000
C     Allow single 2-byte ensemble number for stream 1090 (ECMWF
C     ensemble seasonal forecasts)
C
C
C----<
C     -----------------------------------------------------------------|
C*    Section 0 . Definition of variables. Data statements.
C     -----------------------------------------------------------------|
C
      IMPLICIT NONE
C
#include "common/grprs.h"
C
C     Parameters
C
      CHARACTER*1   HFUNC
      INTEGER KSEC1, KGRIB, KLENG, KNSPT, KBITS, KPLEN, KPR, KRET
      DIMENSION KGRIB(*)
      DIMENSION KSEC1(*)
C
C     Local variables
C
      INTEGER IRET, ILENS1, INUM, LOOP, IP1, N
CC    INTEGER IZERO
      INTEGER ILALO
      DIMENSION ILALO(8)
      LOGICAL LENCODE, LDECODE
C
C     -----------------------------------------------------------------|
C*    Section 1 . Set initial values.
C     -----------------------------------------------------------------|
C
  100 CONTINUE
C
      IRET = KRET
      LENCODE = ( HFUNC.EQ.'C' )
      LDECODE = .NOT. LENCODE
C
C     -----------------------------------------------------------------|
C*    Section 2 .  Ocean extensions, definition 4.
C     -----------------------------------------------------------------|
C
  200 CONTINUE
C
      IF( KSEC1(40).EQ.1090 ) THEN
C
C       If seasonal forecast data ...
C
C       Octet 50-51 : Forecast number.
C       One 16 bit field.
C
        CALL INXBIT(KGRIB,KLENG,KNSPT,KSEC1(42),1,KBITS,16,HFUNC,KRET)
        IF (KRET.NE.0) GOTO 910
C
        IF( LDECODE ) KSEC1(43) = 0
C
      ELSE
C
C       Octet 50 : Ensemble forecast number
C       Octet 51 : Total number of forecasts in ensemble
C       Two 8-bit fields.
C
        CALL INXBIT(KGRIB,KLENG,KNSPT,KSEC1(42),2,KBITS, 8,HFUNC,KRET)
        IF( KRET.NE.0 ) GOTO 910
C
      ENDIF
C
C     Octet 52 : Flag showing existence of a post-auxiliary array
C     One 8-bit field.
C
      IF( LENCODE ) IP1 = 1
      CALL INXBIT(KGRIB,KLENG,KNSPT, IP1,1,KBITS,8,HFUNC,KRET)
      IF( KRET.NE.0 ) GOTO 910
C
C     -----------------------------------------------------------------|
C*    Section 3 .  Coordinate structure definition.
C     -----------------------------------------------------------------|
C
  300 CONTINUE
C
C     Octet 53 : Fundamental spatial reference system (Planet flag)
C     Octet 54 : Fundamental time reference
C     Octet 55 : Space unit flag (applies only if lengths NOT
C                otherwise labelled)
C     Octet 56 : Vertical coordinate definition (z)
C     Octet 57 : Horizontal coordinate definition (x,y)
C     Octet 58 : Time unit flag
C     Octet 59 : Time coordinate definition (t)
C     Seven 8-bit fields.
C
      CALL INXBIT(KGRIB,KLENG,KNSPT,KSEC1(44),7,KBITS, 8,HFUNC,KRET)
      IF( KRET.NE.0 ) GOTO 910
C
C     -----------------------------------------------------------------|
C*    Section 4 .  Mixed coordinates.
C     -----------------------------------------------------------------|
C
  400 CONTINUE
C
C*    Position definition.
C     Octet 60 : Mixed coordinate field flag
C     Octet 61 : Coordinate 1 flag  (usually time)
C     Octet 62 : Averaging flag
C     Three 8-bit fields.
C
      CALL INXBIT(KGRIB,KLENG,KNSPT,KSEC1(51),3,KBITS, 8,HFUNC,KRET)
      IF( KRET.NE.0 ) GOTO 910
C
C     Octets 63 - 66 : Position of level 1
C     Octets 67 - 70 : Position of level 2
C     Two 32-bit fields.
C
C     When coding data, set sign bit to 1, if value is negative.
C
      IF( LENCODE ) THEN
        CALL CSGNBT( ILALO(1), KSEC1(54), 32, KRET)
        CALL CSGNBT( ILALO(2), KSEC1(55), 32, KRET)
      ENDIF
C
      CALL INXBIT(KGRIB,KLENG,KNSPT,ILALO(1),2,KBITS, 32,HFUNC,KRET)
      IF( KRET.NE.0 ) GOTO 910
C
C     When decoding data, if sign bit is 1, value is negative.
C
      IF( LDECODE ) THEN
        CALL DSGNBT( KSEC1(54), ILALO(1), 32, KRET)
        CALL DSGNBT( KSEC1(55), ILALO(2), 32, KRET)
      ENDIF
C
C     Octet 71 : Coordinate 2 flag  (usually z-coordinate)
C     Octet 72 : Averaging flag
C     Two 8-bit fields.
C
      CALL INXBIT(KGRIB,KLENG,KNSPT,KSEC1(56),2,KBITS, 8,HFUNC,KRET)
      IF( KRET.NE.0 ) GOTO 910
C
C     Octets 73 - 76 : Position of level 1
C     Octets 77 - 80 : Position of level 2
C     Two 32-bit fields.
C
C     When coding data, set sign bit to 1, if value is negative.
C
      IF( LENCODE ) THEN
        CALL CSGNBT( ILALO(1), KSEC1(58), 32, KRET)
        CALL CSGNBT( ILALO(2), KSEC1(59), 32, KRET)
      ENDIF
C
      CALL INXBIT(KGRIB,KLENG,KNSPT,ILALO(1),2,KBITS, 32,HFUNC,KRET)
      IF( KRET.NE.0 ) GOTO 910
C
C     When decoding data, if sign bit is 1, value is negative.
C
      IF( LDECODE ) THEN
        CALL DSGNBT( KSEC1(58), ILALO(1), 32, KRET)
        CALL DSGNBT( KSEC1(59), ILALO(2), 32, KRET)
      ENDIF
C
C     -----------------------------------------------------------------|
C*    Section 5 .  Grid definition.
C     -----------------------------------------------------------------|
C
  500 CONTINUE
C
C     Octets 81 : Coordinate 3 flag (x-axis, usually longitude)
C     Octets 82 : Coordinate 4 flag (y-axis, usually latitude)
C     Two 8-bit fields.
C
      CALL INXBIT(KGRIB,KLENG,KNSPT,KSEC1(60),2,KBITS, 8,HFUNC,KRET)
      IF( KRET.NE.0 ) GOTO 910
C
C     Octets  83 - 86  : Coordinate 4 of first grid point
C     Octets  87 - 90  : Coordinate 3 of first grid point
C     Octets  91 - 94  : Coordinate 4 of last grid point
C     Octets  95 - 98  : Coordinate 3 of last grid point
C     Octets  99 - 102 : i-increment
C     Octets 103 - 106 : j-increment
C     Six 32-bit fields.
C
C     When coding data, set sign bit to 1, if value is negative.
C
      IF( LENCODE ) THEN
        CALL CSGNBT( ILALO(1), KSEC1(62), 32, KRET)
        CALL CSGNBT( ILALO(2), KSEC1(63), 32, KRET)
        CALL CSGNBT( ILALO(3), KSEC1(64), 32, KRET)
        CALL CSGNBT( ILALO(4), KSEC1(65), 32, KRET)
        CALL CSGNBT( ILALO(5), KSEC1(66), 32, KRET)
        CALL CSGNBT( ILALO(6), KSEC1(67), 32, KRET)
      ENDIF
C
      CALL INXBIT(KGRIB,KLENG,KNSPT,ILALO(1),6,KBITS, 32,HFUNC,KRET)
      IF( KRET.NE.0 ) GOTO 910
C
C     When decoding data, if sign bit is 1, value is negative.
C
      IF( LDECODE ) THEN
        CALL DSGNBT( KSEC1(62), ILALO(1), 32, KRET)
        CALL DSGNBT( KSEC1(63), ILALO(2), 32, KRET)
        CALL DSGNBT( KSEC1(64), ILALO(3), 32, KRET)
        CALL DSGNBT( KSEC1(65), ILALO(4), 32, KRET)
        CALL DSGNBT( KSEC1(66), ILALO(5), 32, KRET)
        CALL DSGNBT( KSEC1(67), ILALO(6), 32, KRET)
      ENDIF
C
C
C     Octet 107 : Flag for irregular grid coordinate list
C     Octet 108 : Flag for normal or staggered grid
C     Two 8-bit fields.
C
      CALL INXBIT(KGRIB,KLENG,KNSPT,KSEC1(68),2,KBITS, 8,HFUNC,KRET)
      IF( KRET.NE.0 ) GOTO 910
C
C     -----------------------------------------------------------------|
C*    Section 6 .  Auxiliary information.
C     -----------------------------------------------------------------|
C
  600 CONTINUE
C
C     Octet 109 : Flag for any further information
C     One 8-bit fields.
C
      CALL INXBIT(KGRIB,KLENG,KNSPT,KSEC1(70),1,KBITS, 8,HFUNC,KRET)
      IF( KRET.NE.0 ) GOTO 910
C
C*    Auxiliary information.
C
C     Octet 110 : Number of entries in horizontal coordinate
C                 definition supplement.
C     One 8-bit field.
C
      CALL INXBIT(KGRIB,KLENG,KNSPT,KSEC1(71),1,KBITS, 8,HFUNC,KRET)
      IF( KRET.NE.0 ) GOTO 910
C
C     Octets 111 - 112 : Number of entries in mixed coordinate
C                        definition.
C     Octets 113 - 114 : Number of entries in grid coordinate list
C     Octets 115 - 116 : Number of entries in auxiliary array
C     Three 16-bit fields .
C
      CALL INXBIT(KGRIB,KLENG,KNSPT,KSEC1(72),3,KBITS, 16,HFUNC,KRET)
      IF( KRET.NE.0 ) GOTO 910
C
C     At this point length of Section 1 of Grib code is 116 octets.
C
      ILENS1 = 116
      INUM   = 75
C
C     -----------------------------------------------------------------|
C*    Section 7 .  (Optional) Supplements.
C     -----------------------------------------------------------------|
C
  700 CONTINUE
C
C     Horizontal coordinate supplement.
C
      DO LOOP = 1, KSEC1(71)
C
C       KSEC1(71) 32-bit fields.
C
C       When coding values, set sign bit to 1, if value is negative.
C
        IF( LENCODE ) CALL CSGNBT( ILALO(1), KSEC1(INUM), 32, KRET)
C
        CALL INXBIT(KGRIB,KLENG,KNSPT,ILALO(1),1,KBITS,32, HFUNC,KRET)
        IF( KRET.NE.0 ) GOTO 910
C
C       When decoding values, if sign bit is 1, value is negative.
C
        IF( LDECODE ) CALL DSGNBT( KSEC1(INUM), ILALO(1), 32, KRET)
        ILENS1 = ILENS1 + 4
        INUM   = INUM + 1
C
      ENDDO
C
C     Mixed coordinate definition.
C
      DO LOOP = 1, KSEC1(72)
C
C       KSEC1(72) 32-bit fields.
C
C       When coding values, set sign bit to 1, if value is negative.
C
        IF( LENCODE ) CALL CSGNBT( ILALO(1), KSEC1(INUM), 32, KRET)
C
        CALL INXBIT(KGRIB,KLENG,KNSPT,ILALO(1),1,KBITS, 32,HFUNC,KRET)
        IF( KRET.NE.0 ) GOTO 910
C
C       When decoding values, if sign bit is 1, value is negative.
C
        IF( LDECODE ) CALL DSGNBT( KSEC1(INUM), ILALO(1), 32, KRET)
        ILENS1 = ILENS1 + 4
        INUM   = INUM + 1
C
      ENDDO
C
C     Grid coordinate list.
C
      DO LOOP = 1, KSEC1(73)
C
C       KSEC1(73) 32-bit fields.
C
C       When coding values, set sign bit to 1, if value is negative.
C
        IF( LENCODE ) CALL CSGNBT( ILALO(1), KSEC1(INUM), 32, KRET)
C
        CALL INXBIT(KGRIB,KLENG,KNSPT,ILALO(1),1,KBITS, 32,HFUNC,KRET)
        IF( KRET.NE.0 ) GOTO 910
C
C       When decoding values, if sign bit is 1, value is negative.
C
        IF( LDECODE ) CALL DSGNBT( KSEC1(INUM), ILALO(1), 32, KRET)
        ILENS1 = ILENS1 + 4
        INUM   = INUM + 1
C
      ENDDO
C
C     Auxiliary array.
C
      IF( KSEC1(74).NE.0 ) THEN
C
C       KSEC1(74) 32-bit fields.
C
        CALL INXBIT(KGRIB,KLENG,KNSPT,KSEC1(INUM),KSEC1(74),KBITS,
     X             32,HFUNC,KRET)
        IF( KRET.NE.0 ) GOTO 910
        ILENS1 = ILENS1 + 4 * KSEC1(74)
        INUM   = INUM + KSEC1(74)
      ENDIF
C
C     Post-auxiliary array.
C
      IF( IP1.EQ.1 ) THEN
C
C       Integer count, N say, followed by (N-1) 32-bit fields.
C
        CALL INXBIT(KGRIB,KLENG,KNSPT,KSEC1(INUM),1,KBITS,
     X             32,HFUNC,KRET)
        IF( KRET.NE.0 ) GOTO 910
        N = KSEC1(INUM)
        IF( N.GT.1 ) THEN
          INUM   = INUM + 1
C
          CALL INXBIT(KGRIB,KLENG,KNSPT,KSEC1(INUM),(N-1),KBITS,
     X               32,HFUNC,KRET)
          IF( KRET.NE.0 ) GOTO 910
          ILENS1 = ILENS1 + 4 * N
          INUM   = INUM + N - 1
        ELSE
          KSEC1(INUM) = 0
          ILENS1 = ILENS1 + 4
          KNSPT = KNSPT + 32
        ENDIF
      ELSE
        KSEC1(INUM) = 0
      ENDIF
C
C*    Insert length of section 1, if coding data.
C     One 24-bit field.
C
      IF( LENCODE ) THEN
        CALL INXBIT(KGRIB,KLENG,KPLEN,ILENS1,1,KBITS, 24,HFUNC,KRET)
        IF( KRET.NE.0 ) GOTO 910
      ENDIF
C
C     -----------------------------------------------------------------|
C*    Section 9 . Abort/return to calling routine.
C     -----------------------------------------------------------------|
C
  900 CONTINUE
C
      IF( KPR.GE.1 )
     X  WRITE(GRPRSM,*) 'ECDEF4: Section 9. On output, KNSPT  = ',KNSPT
C
      RETURN
C
  910 CONTINUE
      KRET = 2
      WRITE(GRPRSM,*) 'ECDEF4: Error reported by routine INXBIT.'
C
C     Abort if requested to do so when an error has been encountered.
C
      IF( IRET.EQ.0.AND.KRET.NE.0 ) THEN
        CALL ABORTX ('ECDEF4')
      ELSE
        RETURN
      ENDIF
C
      END

c Copyright 1981-2012 ECMWF.
c
c This software is licensed under the terms of the Apache Licence 
c Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
c
c In applying this licence, ECMWF does not waive the privileges and immunities 
c granted to it by virtue of its status as an intergovernmental organisation 
c nor does it submit to any jurisdiction.
c

C     SUBROUTINE 'QPASSF' - PERFORMS ONE PASS THROUGH DATA AS PART      
C     OF MULTIPLE REAL FFT (FOURIER ANALYSIS) ROUTINE                   
C                                                                       
C     A IS FIRST REAL INPUT VECTOR                                      
C         EQUIVALENCE B(1) WITH A(IFAC*LA*INC1+1)                       
C     C IS FIRST REAL OUTPUT VECTOR                                     
C         EQUIVALENCE D(1) WITH C(LA*INC2+1)                            
C     TRIGS IS A PRECALCULATED LIST OF SINES & COSINES                  
C     INC1 IS THE ADDRESSING INCREMENT FOR A                            
C     INC2 IS THE ADDRESSING INCREMENT FOR C                            
C     INC3 IS THE INCREMENT BETWEEN INPUT VECTORS A                     
C     INC4 IS THE INCREMENT BETWEEN OUTPUT VECTORS C                    
C     LOT IS THE NUMBER OF VECTORS                                      
C     N IS THE LENGTH OF THE VECTORS                                    
C     IFAC IS THE CURRENT FACTOR OF N                                   
C     LA = N/(PRODUCT OF FACTORS USED SO FAR)                           
C     IERR IS AN ERROR INDICATOR:                                       
C              0 - PASS COMPLETED WITHOUT ERROR                         
C              2 - IFAC NOT CATERED FOR                                 
C              3 - IFAC ONLY CATERED FOR IF LA=N/IFAC                   
C     LIPL=.T. => RESULTS ARE RETURNED TO INPUT ARRAY
C              (ONLY VALID IF LA=N/IFAC, I.E. ON FIRST PASS)
C                                                                       
C-----------------------------------------------------------------------
C                                                                       
      SUBROUTINE QPASSF(A,B,C,D,TRIGS,INC1,INC2,INC3,INC4,LOT,N,IFAC,   
     *    LA,IERR,LIPL)                                                      
      DIMENSION A(N),B(N),C(N),D(N),TRIGS(N)                            
      LOGICAL LIPL
C                                                                       
      DATA SIN36/0.587785252292473/,SIN72/0.951056516295154/,           
     *    QRT5/0.559016994374947/,SIN60/0.866025403784437/              
C                                                                       
      M=N/IFAC                                                          
      IINK=LA*INC1                                                      
      JINK=LA*INC2                                                      
      IJUMP=(IFAC-1)*IINK                                               
      KSTOP=(N-IFAC)/(2*IFAC)                                           
C                                                                       
      IBASE=0                                                           
      JBASE=0                                                           
      IBAD=0
C
!     Increase the vector length by fusing the loops if the
!     data layout is appropriate:
      IF (INC1.EQ.LOT.AND.INC2.EQ.LOT.AND.INC3.EQ.1.AND.INC4.EQ.1) THEN
        ILA=1
        ILOT=LA*LOT
        INC11=LA*LOT
      ELSE
        ILA=LA
        ILOT=LOT
        INC11=INC1
      ENDIF

C
      IF (IFAC.EQ.2) THEN
C                                                                       
C     CODING FOR FACTOR 2                                               
C     -------------------                                               
  200 CONTINUE                                                          
      IA=1                                                              
      IB=IA+IINK                                                        
      JA=1                                                              
      JB=JA+(2*M-LA)*INC2                                               
C                                                                       
      IF (LA.NE.M) THEN                                                
C                                                                       
      DO 220 L=1,ILA                                                     
      I=IBASE                                                           
      J=JBASE                                                           
!OCL NOVREC                                                   
      DO 210 IJK=1,ILOT                                                  
      C(JA+J)=A(IA+I)+A(IB+I)                                           
      C(JB+J)=A(IA+I)-A(IB+I)                                           
      I=I+INC3                                                          
      J=J+INC4                                                          
  210 CONTINUE                                                          
      IBASE=IBASE+INC11                                                  
      JBASE=JBASE+INC2                                                  
  220 CONTINUE                                                          
      JA=JA+JINK                                                        
      JINK=2*JINK                                                       
      JB=JB-JINK                                                        
      IBASE=IBASE+IJUMP                                                 
      IJUMP=2*IJUMP+IINK                                                
C
      IF (JA.LT.JB) THEN                                                
      DO 250 K=LA,KSTOP,LA                                              
      KB=K+K                                                            
      C1=TRIGS(KB+1)                                                    
      S1=TRIGS(KB+2)                                                    
      JBASE=0                                                           
      DO 240 L=1,ILA                                                     
      I=IBASE                                                           
      J=JBASE                                                           
!OCL NOVREC                                                   
      DO 230 IJK=1,ILOT                                                  
      C(JA+J)=A(IA+I)+(C1*A(IB+I)+S1*B(IB+I))                           
      C(JB+J)=A(IA+I)-(C1*A(IB+I)+S1*B(IB+I))                           
      D(JA+J)=(C1*B(IB+I)-S1*A(IB+I))+B(IA+I)                           
      D(JB+J)=(C1*B(IB+I)-S1*A(IB+I))-B(IA+I)                           
      I=I+INC3                                                          
      J=J+INC4                                                          
  230 CONTINUE                                                          
      IBASE=IBASE+INC11                                                  
      JBASE=JBASE+INC2                                                  
  240 CONTINUE                                                          
      IBASE=IBASE+IJUMP                                                 
      JA=JA+JINK                                                        
      JB=JB-JINK                                                        
  250 CONTINUE                                                          
      ENDIF
C
      IF (JA.EQ.JB) THEN                                                
      JBASE=0                                                           
      DO 280 L=1,ILA                                                     
      I=IBASE                                                           
      J=JBASE                                                           
!OCL NOVREC                                                   
      DO 270 IJK=1,ILOT                                                  
      C(JA+J)=A(IA+I)                                                   
      D(JA+J)=-A(IB+I)                                                  
      I=I+INC3                                                          
      J=J+INC4                                                          
  270 CONTINUE                                                          
      IBASE=IBASE+INC11                                                  
      JBASE=JBASE+INC2                                                  
  280 CONTINUE                                                          
      ENDIF                                                             
C                                                                       
      ELSE                !!! Case LA=M                                 
      Z=1.0/FLOAT(N)                                                    
      IF (LIPL) THEN
        DO 294 L=1,ILA                                                     
        I=IBASE                                                           
!OCL NOVREC                                                   
        DO 292 IJK=1,ILOT                                                  
        T1=Z*(A(IA+I)-A(IB+I))                                       
        A(IA+I)=Z*(A(IA+I)+A(IB+I))                                       
        A(IB+I)=T1
        I=I+INC3                                                          
  292   CONTINUE                                                          
        IBASE=IBASE+INC11                                                  
  294   CONTINUE                                                          
      ELSE
        DO 298 L=1,ILA                                                     
        I=IBASE                                                           
        J=JBASE                                                           
!OCL NOVREC                                                   
        DO 296 IJK=1,ILOT                                                  
        C(JA+J)=Z*(A(IA+I)+A(IB+I))                                       
        C(JB+J)=Z*(A(IA+I)-A(IB+I))                                       
        I=I+INC3                                                          
        J=J+INC4                                                          
  296   CONTINUE                                                          
        IBASE=IBASE+INC11                                                  
        JBASE=JBASE+INC2                                                  
  298   CONTINUE                                                          
      ENDIF
      ENDIF
C
      ELSEIF (IFAC.EQ.3) THEN
C                                                                       
C     CODING FOR FACTOR 3                                               
C     -------------------                                               
  300 CONTINUE                                                          
      IA=1                                                              
      IB=IA+IINK                                                        
      IC=IB+IINK                                                        
      JA=1                                                              
      JB=JA+(2*M-LA)*INC2                                               
      JC=JB                                                             
C                                                                       
      IF (LA.NE.M) THEN                                                 
C                                                                       
      DO 320 L=1,ILA                                                     
      I=IBASE                                                           
      J=JBASE                                                           
!OCL NOVREC                                                   
      DO 310 IJK=1,ILOT                                                  
      C(JA+J)=A(IA+I)+(A(IB+I)+A(IC+I))                                 
      C(JB+J)=A(IA+I)-0.5*(A(IB+I)+A(IC+I))                             
      D(JB+J)=SIN60*(A(IC+I)-A(IB+I))                                   
      I=I+INC3                                                          
      J=J+INC4                                                          
  310 CONTINUE                                                          
      IBASE=IBASE+INC11                                                  
      JBASE=JBASE+INC2                                                  
  320 CONTINUE                                                          
      JA=JA+JINK                                                        
      JINK=2*JINK                                                       
      JB=JB+JINK                                                        
      JC=JC-JINK                                                        
      IBASE=IBASE+IJUMP                                                 
      IJUMP=2*IJUMP+IINK                                                
C
      IF (JA.LT.JC) THEN                                                
      DO 350 K=LA,KSTOP,LA                                              
      KB=K+K                                                            
      KC=KB+KB                                                          
      C1=TRIGS(KB+1)                                                    
      S1=TRIGS(KB+2)                                                    
      C2=TRIGS(KC+1)                                                    
      S2=TRIGS(KC+2)                                                    
      JBASE=0                                                           
      DO 340 L=1,ILA                                                     
      I=IBASE                                                           
      J=JBASE                                                           
!OCL NOVREC                                                   
      DO 330 IJK=1,ILOT                                                  
      A1=(C1*A(IB+I)+S1*B(IB+I))+(C2*A(IC+I)+S2*B(IC+I))                
      B1=(C1*B(IB+I)-S1*A(IB+I))+(C2*B(IC+I)-S2*A(IC+I))                
      A2=A(IA+I)-0.5*A1                                                 
      B2=B(IA+I)-0.5*B1                                                 
      A3=SIN60*((C1*A(IB+I)+S1*B(IB+I))-(C2*A(IC+I)+S2*B(IC+I)))        
      B3=SIN60*((C1*B(IB+I)-S1*A(IB+I))-(C2*B(IC+I)-S2*A(IC+I)))        
      C(JA+J)=A(IA+I)+A1                                                
      D(JA+J)=B(IA+I)+B1                                                
      C(JB+J)=A2+B3                                                     
      D(JB+J)=B2-A3                                                     
      C(JC+J)=A2-B3                                                     
      D(JC+J)=-(B2+A3)                                                  
      I=I+INC3                                                          
      J=J+INC4                                                          
  330 CONTINUE                                                          
      IBASE=IBASE+INC11                                                  
      JBASE=JBASE+INC2                                                  
  340 CONTINUE                                                          
      IBASE=IBASE+IJUMP                                                 
      JA=JA+JINK                                                        
      JB=JB+JINK                                                        
      JC=JC-JINK                                                        
  350 CONTINUE                                                          
      ENDIF
C
      IF (JA.EQ.JC) THEN                                                
      JBASE=0                                                           
      DO 380 L=1,ILA                                                     
      I=IBASE                                                           
      J=JBASE                                                           
!OCL NOVREC                                                   
      DO 370 IJK=1,ILOT                                                  
      C(JA+J)=A(IA+I)+0.5*(A(IB+I)-A(IC+I))                             
      D(JA+J)=-SIN60*(A(IB+I)+A(IC+I))                                  
      C(JB+J)=A(IA+I)-(A(IB+I)-A(IC+I))                                 
      I=I+INC3                                                          
      J=J+INC4                                                          
  370 CONTINUE                                                          
      IBASE=IBASE+INC11                                                  
      JBASE=JBASE+INC2                                                  
  380 CONTINUE                                                          
      ENDIF                                                             
C                                                                       
      ELSE                 !!! Case LA=M                                
      Z=1.0/FLOAT(N)                                                    
      ZSIN60=Z*SIN60                                                    
      IF (LIPL) THEN
        DO 394 L=1,ILA                                                     
        I=IBASE                                                           
!OCL NOVREC                                                   
        DO 392 IJK=1,ILOT                                                  
        T1=Z*(A(IA+I)-0.5*(A(IB+I)+A(IC+I)))                         
        T2=ZSIN60*(A(IC+I)-A(IB+I))                                  
        A(IA+I)=Z*(A(IA+I)+(A(IB+I)+A(IC+I)))                             
        A(IB+I)=T1
        A(IC+I)=T2
        I=I+INC3                                                          
  392   CONTINUE                                                          
        IBASE=IBASE+INC11                                                  
  394   CONTINUE                                                          
      ELSE
        DO 398 L=1,ILA                                                     
        I=IBASE                                                           
        J=JBASE                                                           
!OCL NOVREC                                                   
        DO 396 IJK=1,ILOT                                                  
        C(JA+J)=Z*(A(IA+I)+(A(IB+I)+A(IC+I)))                             
        C(JB+J)=Z*(A(IA+I)-0.5*(A(IB+I)+A(IC+I)))                         
        D(JB+J)=ZSIN60*(A(IC+I)-A(IB+I))                                  
        I=I+INC3                                                          
        J=J+INC4                                                          
  396   CONTINUE                                                          
        IBASE=IBASE+INC11                                                  
        JBASE=JBASE+INC2                                                  
  398   CONTINUE                                                          
      ENDIF
      ENDIF
C
      ELSEIF (IFAC.EQ.4) THEN
C                                                                       
C     CODING FOR FACTOR 4                                               
C     -------------------                                               
  400 CONTINUE                                                          
      IA=1                                                              
      IB=IA+IINK                                                        
      IC=IB+IINK                                                        
      ID=IC+IINK                                                        
      JA=1                                                              
      JB=JA+(2*M-LA)*INC2                                               
      JC=JB+2*M*INC2                                                    
      JD=JB                                                             
C                                                                       
      IF (LA.NE.M) THEN                                                 
C                                                                       
      DO 420 L=1,ILA                                                     
      I=IBASE                                                           
      J=JBASE                                                           
!OCL NOVREC                                                   
      DO 410 IJK=1,ILOT                                                  
      C(JA+J)=(A(IA+I)+A(IC+I))+(A(IB+I)+A(ID+I))                       
      C(JC+J)=(A(IA+I)+A(IC+I))-(A(IB+I)+A(ID+I))                       
      C(JB+J)=A(IA+I)-A(IC+I)                                           
      D(JB+J)=A(ID+I)-A(IB+I)                                           
      I=I+INC3                                                          
      J=J+INC4                                                          
  410 CONTINUE                                                          
      IBASE=IBASE+INC11                                                  
      JBASE=JBASE+INC2                                                  
  420 CONTINUE                                                          
      JA=JA+JINK                                                        
      JINK=2*JINK                                                       
      JB=JB+JINK                                                        
      JC=JC-JINK                                                        
      JD=JD-JINK                                                        
      IBASE=IBASE+IJUMP                                                 
      IJUMP=2*IJUMP+IINK                                                
C
      IF (JB.LT.JC) THEN                                                
      DO 450 K=LA,KSTOP,LA                                              
      KB=K+K                                                            
      KC=KB+KB                                                          
      KD=KC+KB                                                          
      C1=TRIGS(KB+1)                                                    
      S1=TRIGS(KB+2)                                                    
      C2=TRIGS(KC+1)                                                    
      S2=TRIGS(KC+2)                                                    
      C3=TRIGS(KD+1)                                                    
      S3=TRIGS(KD+2)                                                    
      JBASE=0                                                           
      DO 440 L=1,ILA                                                     
      I=IBASE                                                           
      J=JBASE                                                           
!OCL NOVREC                                                   
      DO 430 IJK=1,ILOT                                                  
      A0=A(IA+I)+(C2*A(IC+I)+S2*B(IC+I))                                
      A2=A(IA+I)-(C2*A(IC+I)+S2*B(IC+I))                                
      A1=(C1*A(IB+I)+S1*B(IB+I))+(C3*A(ID+I)+S3*B(ID+I))                
      A3=(C1*A(IB+I)+S1*B(IB+I))-(C3*A(ID+I)+S3*B(ID+I))                
      B0=B(IA+I)+(C2*B(IC+I)-S2*A(IC+I))                                
      B2=B(IA+I)-(C2*B(IC+I)-S2*A(IC+I))                                
      B1=(C1*B(IB+I)-S1*A(IB+I))+(C3*B(ID+I)-S3*A(ID+I))                
      B3=(C1*B(IB+I)-S1*A(IB+I))-(C3*B(ID+I)-S3*A(ID+I))                
      C(JA+J)=A0+A1                                                     
      C(JC+J)=A0-A1                                                     
      D(JA+J)=B0+B1                                                     
      D(JC+J)=B1-B0                                                     
      C(JB+J)=A2+B3                                                     
      C(JD+J)=A2-B3                                                     
      D(JB+J)=B2-A3                                                     
      D(JD+J)=-(B2+A3)                                                  
      I=I+INC3                                                          
      J=J+INC4                                                          
  430 CONTINUE                                                          
      IBASE=IBASE+INC11                                                  
      JBASE=JBASE+INC2                                                  
  440 CONTINUE                                                          
      IBASE=IBASE+IJUMP                                                 
      JA=JA+JINK                                                        
      JB=JB+JINK                                                        
      JC=JC-JINK                                                        
      JD=JD-JINK                                                        
  450 CONTINUE                                                          
      ENDIF
C
      IF (JB.EQ.JC) THEN                                                
      SIN45=SQRT(0.5)                                                   
      JBASE=0                                                           
      DO 480 L=1,ILA                                                     
      I=IBASE                                                           
      J=JBASE                                                           
!OCL NOVREC                                                   
      DO 470 IJK=1,ILOT                                                  
      C(JA+J)=A(IA+I)+SIN45*(A(IB+I)-A(ID+I))                           
      C(JB+J)=A(IA+I)-SIN45*(A(IB+I)-A(ID+I))                           
      D(JA+J)=-A(IC+I)-SIN45*(A(IB+I)+A(ID+I))                          
      D(JB+J)=A(IC+I)-SIN45*(A(IB+I)+A(ID+I))                           
      I=I+INC3                                                          
      J=J+INC4                                                          
  470 CONTINUE                                                          
      IBASE=IBASE+INC11                                                  
      JBASE=JBASE+INC2                                                  
  480 CONTINUE                                                          
      ENDIF                                                             
C                                                                       
      ELSE              !!! Case LA=M                                   
      Z=1.0/FLOAT(N)                                                    
      IF (LIPL) THEN
        DO 494 L=1,ILA                                                     
        I=IBASE                                                           
!OCL NOVREC                                                   
        DO 492 IJK=1,ILOT                                                  
        T1=Z*(A(IA+I)-A(IC+I))                                       
        T3=Z*(A(ID+I)-A(IB+I))                                       
        T2=Z*((A(IA+I)+A(IC+I))-(A(IB+I)+A(ID+I)))                   
        A(IA+I)=Z*((A(IA+I)+A(IC+I))+(A(IB+I)+A(ID+I)))                   
        A(IB+I)=T1
        A(IC+I)=T2
        A(ID+I)=T3
        I=I+INC3                                                          
  492   CONTINUE                                                          
        IBASE=IBASE+INC11                                                  
  494   CONTINUE                                                          
      ELSE
        DO 498 L=1,ILA                                                     
        I=IBASE                                                           
        J=JBASE                                                           
!OCL NOVREC                                                   
        DO 496 IJK=1,ILOT                                                  
        C(JA+J)=Z*((A(IA+I)+A(IC+I))+(A(IB+I)+A(ID+I)))                   
        C(JC+J)=Z*((A(IA+I)+A(IC+I))-(A(IB+I)+A(ID+I)))                   
        C(JB+J)=Z*(A(IA+I)-A(IC+I))                                       
        D(JB+J)=Z*(A(ID+I)-A(IB+I))                                       
        I=I+INC3                                                          
        J=J+INC4                                                          
  496   CONTINUE                                                          
        IBASE=IBASE+INC11                                                  
        JBASE=JBASE+INC2                                                  
  498   CONTINUE                                                          
      ENDIF
      ENDIF
C
      ELSEIF (IFAC.EQ.5) THEN
C                                                                       
C     CODING FOR FACTOR 5                                               
C     -------------------                                               
  500 CONTINUE                                                          
      IA=1                                                              
      IB=IA+IINK                                                        
      IC=IB+IINK                                                        
      ID=IC+IINK                                                        
      IE=ID+IINK                                                        
      JA=1                                                              
      JB=JA+(2*M-LA)*INC2                                               
      JC=JB+2*M*INC2                                                    
      JD=JC                                                             
      JE=JB                                                             
C                                                                       
      IF (LA.NE.M) THEN                                                 
C                                                                       
      DO 520 L=1,ILA                                                     
      I=IBASE                                                           
      J=JBASE                                                           
!OCL NOVREC                                                   
      DO 510 IJK=1,ILOT                                                  
      A1=A(IB+I)+A(IE+I)                                                
      A3=A(IB+I)-A(IE+I)                                                
      A2=A(IC+I)+A(ID+I)                                                
      A4=A(IC+I)-A(ID+I)                                                
      A5=A(IA+I)-0.25*(A1+A2)                                           
      A6=QRT5*(A1-A2)                                                   
      C(JA+J)=A(IA+I)+(A1+A2)                                           
      C(JB+J)=A5+A6                                                     
      C(JC+J)=A5-A6                                                     
      D(JB+J)=-SIN72*A3-SIN36*A4                                        
      D(JC+J)=-SIN36*A3+SIN72*A4                                        
      I=I+INC3                                                          
      J=J+INC4                                                          
  510 CONTINUE                                                          
      IBASE=IBASE+INC11                                                  
      JBASE=JBASE+INC2                                                  
  520 CONTINUE                                                          
      JA=JA+JINK                                                        
      JINK=2*JINK                                                       
      JB=JB+JINK                                                        
      JC=JC+JINK                                                        
      JD=JD-JINK                                                        
      JE=JE-JINK                                                        
      IBASE=IBASE+IJUMP                                                 
      IJUMP=2*IJUMP+IINK                                                
C
      IF (JB.LT.JD) THEN                                                
      DO 550 K=LA,KSTOP,LA                                              
      KB=K+K                                                            
      KC=KB+KB                                                          
      KD=KC+KB                                                          
      KE=KD+KB                                                          
      C1=TRIGS(KB+1)                                                    
      S1=TRIGS(KB+2)                                                    
      C2=TRIGS(KC+1)                                                    
      S2=TRIGS(KC+2)                                                    
      C3=TRIGS(KD+1)                                                    
      S3=TRIGS(KD+2)                                                    
      C4=TRIGS(KE+1)                                                    
      S4=TRIGS(KE+2)                                                    
      JBASE=0                                                           
      DO 540 L=1,ILA                                                     
      I=IBASE                                                           
      J=JBASE                                                           
!OCL NOVREC                                                   
      DO 530 IJK=1,ILOT                                                  
      A1=(C1*A(IB+I)+S1*B(IB+I))+(C4*A(IE+I)+S4*B(IE+I))                
      A3=(C1*A(IB+I)+S1*B(IB+I))-(C4*A(IE+I)+S4*B(IE+I))                
      A2=(C2*A(IC+I)+S2*B(IC+I))+(C3*A(ID+I)+S3*B(ID+I))                
      A4=(C2*A(IC+I)+S2*B(IC+I))-(C3*A(ID+I)+S3*B(ID+I))                
      B1=(C1*B(IB+I)-S1*A(IB+I))+(C4*B(IE+I)-S4*A(IE+I))                
      B3=(C1*B(IB+I)-S1*A(IB+I))-(C4*B(IE+I)-S4*A(IE+I))                
      B2=(C2*B(IC+I)-S2*A(IC+I))+(C3*B(ID+I)-S3*A(ID+I))                
      B4=(C2*B(IC+I)-S2*A(IC+I))-(C3*B(ID+I)-S3*A(ID+I))                
      A5=A(IA+I)-0.25*(A1+A2)                                           
      A6=QRT5*(A1-A2)                                                   
      B5=B(IA+I)-0.25*(B1+B2)                                           
      B6=QRT5*(B1-B2)                                                   
      A10=A5+A6                                                         
      A20=A5-A6                                                         
      B10=B5+B6                                                         
      B20=B5-B6                                                         
      A11=SIN72*B3+SIN36*B4                                             
      A21=SIN36*B3-SIN72*B4                                             
      B11=SIN72*A3+SIN36*A4                                             
      B21=SIN36*A3-SIN72*A4                                             
      C(JA+J)=A(IA+I)+(A1+A2)                                           
      C(JB+J)=A10+A11                                                   
      C(JE+J)=A10-A11                                                   
      C(JC+J)=A20+A21                                                   
      C(JD+J)=A20-A21                                                   
      D(JA+J)=B(IA+I)+(B1+B2)                                           
      D(JB+J)=B10-B11                                                   
      D(JE+J)=-(B10+B11)                                                
      D(JC+J)=B20-B21                                                   
      D(JD+J)=-(B20+B21)                                                
      I=I+INC3                                                          
      J=J+INC4                                                          
  530 CONTINUE                                                          
      IBASE=IBASE+INC11                                                  
      JBASE=JBASE+INC2                                                  
  540 CONTINUE                                                          
      IBASE=IBASE+IJUMP                                                 
      JA=JA+JINK                                                        
      JB=JB+JINK                                                        
      JC=JC+JINK                                                        
      JD=JD-JINK                                                        
      JE=JE-JINK                                                        
  550 CONTINUE                                                          
      ENDIF
C
      IF (JB.EQ.JD) THEN                                                
      JBASE=0                                                           
      DO 580 L=1,ILA                                                     
      I=IBASE                                                           
      J=JBASE                                                           
!OCL NOVREC                                                   
      DO 570 IJK=1,ILOT                                                  
      A1=A(IB+I)+A(IE+I)                                                
      A3=A(IB+I)-A(IE+I)                                                
      A2=A(IC+I)+A(ID+I)                                                
      A4=A(IC+I)-A(ID+I)                                                
      A5=A(IA+I)+0.25*(A3-A4)                                           
      A6=QRT5*(A3+A4)                                                   
      C(JA+J)=A5+A6                                                     
      C(JB+J)=A5-A6                                                     
      C(JC+J)=A(IA+I)-(A3-A4)                                           
      D(JA+J)=-SIN36*A1-SIN72*A2                                        
      D(JB+J)=-SIN72*A1+SIN36*A2                                        
      I=I+INC3                                                          
      J=J+INC4                                                          
  570 CONTINUE                                                          
      IBASE=IBASE+INC11                                                  
      JBASE=JBASE+INC2                                                  
  580 CONTINUE                                                          
      ENDIF                                                             
C                                                                       
      ELSE                !!! Case LA=M                                 
      Z=1.0/FLOAT(N)                                                    
      ZQRT5=Z*QRT5                                                      
      ZSIN36=Z*SIN36                                                    
      ZSIN72=Z*SIN72                                                    
      IF (LIPL) THEN
        DO 594 L=1,ILA                                                     
        I=IBASE                                                           
!OCL NOVREC                                                   
        DO 592 IJK=1,ILOT                                                  
        A1=A(IB+I)+A(IE+I)                                                
        A3=A(IB+I)-A(IE+I)                                                
        A2=A(IC+I)+A(ID+I)                                                
        A4=A(IC+I)-A(ID+I)                                                
        A5=Z*(A(IA+I)-0.25*(A1+A2))                                       
        A6=ZQRT5*(A1-A2)                                                  
        A(IA+I)=Z*(A(IA+I)+(A1+A2))                                       
        A(IB+I)=A5+A6                                                     
        A(ID+I)=A5-A6                                                     
        A(IC+I)=-ZSIN72*A3-ZSIN36*A4                                      
        A(IE+I)=-ZSIN36*A3+ZSIN72*A4                                      
        I=I+INC3                                                          
  592   CONTINUE                                                          
        IBASE=IBASE+INC11                                                  
  594   CONTINUE                                                          
      ELSE
        DO 598 L=1,ILA                                                     
        I=IBASE                                                           
        J=JBASE                                                           
!OCL NOVREC                                                   
        DO 596 IJK=1,ILOT                                                  
        A1=A(IB+I)+A(IE+I)                                                
        A3=A(IB+I)-A(IE+I)                                                
        A2=A(IC+I)+A(ID+I)                                                
        A4=A(IC+I)-A(ID+I)                                                
        A5=Z*(A(IA+I)-0.25*(A1+A2))                                       
        A6=ZQRT5*(A1-A2)                                                  
        C(JA+J)=Z*(A(IA+I)+(A1+A2))                                       
        C(JB+J)=A5+A6                                                     
        C(JC+J)=A5-A6                                                     
        D(JB+J)=-ZSIN72*A3-ZSIN36*A4                                      
        D(JC+J)=-ZSIN36*A3+ZSIN72*A4                                      
        I=I+INC3                                                          
        J=J+INC4                                                          
  596   CONTINUE                                                          
        IBASE=IBASE+INC11                                                  
        JBASE=JBASE+INC2                                                  
  598   CONTINUE                                                          
      ENDIF
      ENDIF
C
      ELSEIF (IFAC.EQ.6) THEN
C                                                                       
C     CODING FOR FACTOR 6                                               
C     -------------------                                               
  600 CONTINUE                                                          
      IA=1                                                              
      IB=IA+IINK                                                        
      IC=IB+IINK                                                        
      ID=IC+IINK                                                        
      IE=ID+IINK                                                        
      IF=IE+IINK                                                        
      JA=1                                                              
      JB=JA+(2*M-LA)*INC2                                               
      JC=JB+2*M*INC2                                                    
      JD=JC+2*M*INC2                                                    
      JE=JC                                                             
      JF=JB                                                             
C                                                                       
      IF (LA.NE.M) THEN                                                 
C                                                                       
      DO 620 L=1,ILA                                                     
      I=IBASE                                                           
      J=JBASE                                                           
!OCL NOVREC                                                   
      DO 610 IJK=1,ILOT                                                  
      A11=(A(IC+I)+A(IF+I))+(A(IB+I)+A(IE+I))                           
      C(JA+J)=(A(IA+I)+A(ID+I))+A11                                     
      C(JC+J)=(A(IA+I)+A(ID+I)-0.5*A11)                                 
      D(JC+J)=SIN60*((A(IC+I)+A(IF+I))-(A(IB+I)+A(IE+I)))               
      A11=(A(IC+I)-A(IF+I))+(A(IE+I)-A(IB+I))                           
      C(JB+J)=(A(IA+I)-A(ID+I))-0.5*A11                                 
      D(JB+J)=SIN60*((A(IE+I)-A(IB+I))-(A(IC+I)-A(IF+I)))               
      C(JD+J)=(A(IA+I)-A(ID+I))+A11                                     
      I=I+INC3                                                          
      J=J+INC4                                                          
  610 CONTINUE                                                          
      IBASE=IBASE+INC11                                                  
      JBASE=JBASE+INC2                                                  
  620 CONTINUE                                                          
      JA=JA+JINK                                                        
      JINK=2*JINK                                                       
      JB=JB+JINK                                                        
      JC=JC+JINK                                                        
      JD=JD-JINK                                                        
      JE=JE-JINK                                                        
      JF=JF-JINK                                                        
      IBASE=IBASE+IJUMP                                                 
      IJUMP=2*IJUMP+IINK                                                
C
      IF (JC.LT.JD) THEN                                                
      DO 650 K=LA,KSTOP,LA                                              
      KB=K+K                                                            
      KC=KB+KB                                                          
      KD=KC+KB                                                          
      KE=KD+KB                                                          
      KF=KE+KB                                                          
      C1=TRIGS(KB+1)                                                    
      S1=TRIGS(KB+2)                                                    
      C2=TRIGS(KC+1)                                                    
      S2=TRIGS(KC+2)                                                    
      C3=TRIGS(KD+1)                                                    
      S3=TRIGS(KD+2)                                                    
      C4=TRIGS(KE+1)                                                    
      S4=TRIGS(KE+2)                                                    
      C5=TRIGS(KF+1)                                                    
      S5=TRIGS(KF+2)                                                    
      JBASE=0                                                           
      DO 640 L=1,ILA                                                     
      I=IBASE                                                           
      J=JBASE                                                           
!OCL NOVREC                                                   
      DO 630 IJK=1,ILOT                                                  
      A1=C1*A(IB+I)+S1*B(IB+I)                                          
      B1=C1*B(IB+I)-S1*A(IB+I)                                          
      A2=C2*A(IC+I)+S2*B(IC+I)                                          
      B2=C2*B(IC+I)-S2*A(IC+I)                                          
      A3=C3*A(ID+I)+S3*B(ID+I)                                          
      B3=C3*B(ID+I)-S3*A(ID+I)                                          
      A4=C4*A(IE+I)+S4*B(IE+I)                                          
      B4=C4*B(IE+I)-S4*A(IE+I)                                          
      A5=C5*A(IF+I)+S5*B(IF+I)                                          
      B5=C5*B(IF+I)-S5*A(IF+I)                                          
      A11=(A2+A5)+(A1+A4)                                               
      A20=(A(IA+I)+A3)-0.5*A11                                          
      A21=SIN60*((A2+A5)-(A1+A4))                                       
      B11=(B2+B5)+(B1+B4)                                               
      B20=(B(IA+I)+B3)-0.5*B11                                          
      B21=SIN60*((B2+B5)-(B1+B4))                                       
      C(JA+J)=(A(IA+I)+A3)+A11                                          
      D(JA+J)=(B(IA+I)+B3)+B11                                          
      C(JC+J)=A20-B21                                                   
      D(JC+J)=A21+B20                                                   
      C(JE+J)=A20+B21                                                   
      D(JE+J)=A21-B20                                                   
      A11=(A2-A5)+(A4-A1)                                               
      A20=(A(IA+I)-A3)-0.5*A11                                          
      A21=SIN60*((A4-A1)-(A2-A5))                                       
      B11=(B5-B2)-(B4-B1)                                               
      B20=(B3-B(IA+I))-0.5*B11                                          
      B21=SIN60*((B5-B2)+(B4-B1))                                       
      C(JB+J)=A20-B21                                                   
      D(JB+J)=A21-B20                                                   
      C(JD+J)=A11+(A(IA+I)-A3)                                          
      D(JD+J)=B11+(B3-B(IA+I))                                          
      C(JF+J)=A20+B21                                                   
      D(JF+J)=A21+B20                                                   
      I=I+INC3                                                          
      J=J+INC4                                                          
  630 CONTINUE                                                          
      IBASE=IBASE+INC11                                                  
      JBASE=JBASE+INC2                                                  
  640 CONTINUE                                                          
      IBASE=IBASE+IJUMP                                                 
      JA=JA+JINK                                                        
      JB=JB+JINK                                                        
      JC=JC+JINK                                                        
      JD=JD-JINK                                                        
      JE=JE-JINK                                                        
      JF=JF-JINK                                                        
  650 CONTINUE                                                          
      ENDIF
C
      IF (JC.EQ.JD) THEN                                                
      JBASE=0                                                           
      DO 680 L=1,ILA                                                     
      I=IBASE                                                           
      J=JBASE                                                           
!OCL NOVREC                                                   
      DO 670 IJK=1,ILOT                                                  
      C(JA+J)=(A(IA+I)+0.5*(A(IC+I)-A(IE+I)))+ SIN60*(A(IB+I)-A(IF+I))  
      D(JA+J)=-(A(ID+I)+0.5*(A(IB+I)+A(IF+I)))-SIN60*(A(IC+I)+A(IE+I))  
      C(JB+J)=A(IA+I)-(A(IC+I)-A(IE+I))                                 
      D(JB+J)=A(ID+I)-(A(IB+I)+A(IF+I))                                 
      C(JC+J)=(A(IA+I)+0.5*(A(IC+I)-A(IE+I)))-SIN60*(A(IB+I)-A(IF+I))   
      D(JC+J)=-(A(ID+I)+0.5*(A(IB+I)+A(IF+I)))+SIN60*(A(IC+I)+A(IE+I))  
      I=I+INC3                                                          
      J=J+INC4                                                          
  670 CONTINUE                                                          
      IBASE=IBASE+INC11                                                  
      JBASE=JBASE+INC2                                                  
  680 CONTINUE                                                          
      ENDIF                                                             
C                                                                       
      ELSE                !!! Case LA=M                                 
      Z=1.0/FLOAT(N)                                                    
      ZSIN60=Z*SIN60                                                    
      IF (LIPL) THEN
        DO 694 L=1,ILA                                                     
        I=IBASE                                                           
!OCL NOVREC                                                   
        DO 692 IJK=1,ILOT                                                  
        A11=(A(IC+I)-A(IF+I))+(A(IE+I)-A(IB+I))                           
        T1=Z*((A(IA+I)-A(ID+I))-0.5*A11)                             
        T5=Z*((A(IA+I)-A(ID+I))+A11)                                 
        T2=ZSIN60*((A(IE+I)-A(IB+I))-(A(IC+I)-A(IF+I)))              
        T4=ZSIN60*((A(IC+I)+A(IF+I))-(A(IB+I)+A(IE+I)))              
        A11=(A(IC+I)+A(IF+I))+(A(IB+I)+A(IE+I))                           
        T3=Z*((A(IA+I)+A(ID+I))-0.5*A11)                             
        A(IA+I)=Z*((A(IA+I)+A(ID+I))+A11)                                 
        A(IB+I)=T1
        A(IC+I)=T2
        A(ID+I)=T3
        A(IE+I)=T4
        A(IF+I)=T5
        I=I+INC3                                                          
  692   CONTINUE                                                          
        IBASE=IBASE+INC11                                                  
  694   CONTINUE                                                          
      ELSE
        DO 698 L=1,ILA                                                     
        I=IBASE                                                           
        J=JBASE                                                           
!OCL NOVREC                                                   
        DO 696 IJK=1,ILOT                                                  
        A11=(A(IC+I)+A(IF+I))+(A(IB+I)+A(IE+I))                           
        C(JA+J)=Z*((A(IA+I)+A(ID+I))+A11)                                 
        C(JC+J)=Z*((A(IA+I)+A(ID+I))-0.5*A11)                             
        D(JC+J)=ZSIN60*((A(IC+I)+A(IF+I))-(A(IB+I)+A(IE+I)))              
        A11=(A(IC+I)-A(IF+I))+(A(IE+I)-A(IB+I))                           
        C(JB+J)=Z*((A(IA+I)-A(ID+I))-0.5*A11)                             
        D(JB+J)=ZSIN60*((A(IE+I)-A(IB+I))-(A(IC+I)-A(IF+I)))              
        C(JD+J)=Z*((A(IA+I)-A(ID+I))+A11)                                 
        I=I+INC3                                                          
        J=J+INC4                                                          
  696   CONTINUE                                                          
        IBASE=IBASE+INC11                                                  
        JBASE=JBASE+INC2                                                  
  698   CONTINUE                                                          
      ENDIF
      ENDIF
C
      ELSEIF (IFAC.EQ.8) THEN
C                                                                       
C     CODING FOR FACTOR 8                                               
C     -------------------                                               
  800 CONTINUE                                                          
      IF (LA.NE.M) THEN                                            
        IBAD=3                                                            
      ELSE
      IA=1                                                              
      IB=IA+IINK                                                        
      IC=IB+IINK                                                        
      ID=IC+IINK                                                        
      IE=ID+IINK                                                        
      IF=IE+IINK                                                        
      IG=IF+IINK                                                        
      IH=IG+IINK                                                        
      JA=1                                                              
      JB=JA+LA*INC2                                                     
      JC=JB+2*M*INC2                                                    
      JD=JC+2*M*INC2                                                    
      JE=JD+2*M*INC2                                                    
      Z=1.0/FLOAT(N)                                                    
      ZSIN45=Z*SQRT(0.5)                                                
C                                                                       
      IF (LIPL) THEN
        DO 820 L=1,ILA                                                     
        I=IBASE                                                           
!OCL NOVREC                                                   
        DO 810 IJK=1,ILOT                                                  
        T3=Z*((A(IA+I)+A(IE+I))-(A(IC+I)+A(IG+I)))                   
        T4=Z*((A(ID+I)+A(IH+I))-(A(IB+I)+A(IF+I)))                   
        T1=Z*(A(IA+I)-A(IE+I))                                       
     *    +ZSIN45*((A(IH+I)-A(ID+I))-(A(IF+I)-A(IB+I)))                 
        T5=Z*(A(IA+I)-A(IE+I))                                       
     *    -ZSIN45*((A(IH+I)-A(ID+I))-(A(IF+I)-A(IB+I)))                 
        T2=ZSIN45*((A(IH+I)-A(ID+I))+(A(IF+I)-A(IB+I)))              
     *    +Z*(A(IG+I)-A(IC+I))                                          
        T6=ZSIN45*((A(IH+I)-A(ID+I))+(A(IF+I)-A(IB+I)))              
     *    -Z*(A(IG+I)-A(IC+I))                                          
        T7=Z*(((A(IA+I)+A(IE+I))+(A(IC+I)+A(IG+I)))-                 
     *    ((A(ID+I)+A(IH+I))+(A(IB+I)+A(IF+I))))                        
        A(IA+I)=Z*(((A(IA+I)+A(IE+I))+(A(IC+I)+A(IG+I)))+                 
     *    ((A(ID+I)+A(IH+I))+(A(IB+I)+A(IF+I))))                        
        A(IB+I)=T1
        A(IC+I)=T2
        A(ID+I)=T3
        A(IE+I)=T4
        A(IF+I)=T5
        A(IG+I)=T6
        A(IH+I)=T7
        I=I+INC3                                                          
  810   CONTINUE                                                          
        IBASE=IBASE+INC11                                                  
  820   CONTINUE                                                          
      ELSE
        DO 840 L=1,ILA                                                     
        I=IBASE                                                           
        J=JBASE                                                           
!OCL NOVREC                                                   
        DO 830 IJK=1,ILOT                                                  
        C(JA+J)=Z*(((A(IA+I)+A(IE+I))+(A(IC+I)+A(IG+I)))+                 
     *    ((A(ID+I)+A(IH+I))+(A(IB+I)+A(IF+I))))                        
        C(JE+J)=Z*(((A(IA+I)+A(IE+I))+(A(IC+I)+A(IG+I)))-                 
     *    ((A(ID+I)+A(IH+I))+(A(IB+I)+A(IF+I))))                        
        C(JC+J)=Z*((A(IA+I)+A(IE+I))-(A(IC+I)+A(IG+I)))                   
        D(JC+J)=Z*((A(ID+I)+A(IH+I))-(A(IB+I)+A(IF+I)))                   
        C(JB+J)=Z*(A(IA+I)-A(IE+I))                                       
     *    +ZSIN45*((A(IH+I)-A(ID+I))-(A(IF+I)-A(IB+I)))                 
        C(JD+J)=Z*(A(IA+I)-A(IE+I))                                       
     *    -ZSIN45*((A(IH+I)-A(ID+I))-(A(IF+I)-A(IB+I)))                 
        D(JB+J)=ZSIN45*((A(IH+I)-A(ID+I))+(A(IF+I)-A(IB+I)))              
     *    +Z*(A(IG+I)-A(IC+I))                                          
        D(JD+J)=ZSIN45*((A(IH+I)-A(ID+I))+(A(IF+I)-A(IB+I)))              
     *    -Z*(A(IG+I)-A(IC+I))                                          
        I=I+INC3                                                          
        J=J+INC4                                                          
  830   CONTINUE                                                          
        IBASE=IBASE+INC11                                                  
        JBASE=JBASE+INC2                                                  
  840   CONTINUE                                                          
      ENDIF
C
      ENDIF
C
      ELSE
C
        IBAD=2        !!! Illegal factor
C
      ENDIF
C                                                                       
C     RETURN                                                            
C     ------                                                            
  900 CONTINUE                                                          
      IERR=IBAD                                                         
      RETURN                                                            
      END                                                               

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities
C granted to it by virtue of its status as an intergovernmental organisation
C nor does it submit to any jurisdiction.
C

      INTEGER FUNCTION FIXAREA( )
C
C---->
C**** FIXAREA
C
C     Purpose
C     -------
C
C     Fixup input/output field area definitions.
C
C
C     Interface
C     ---------
C
C     IRET = FIXAREA( )
C
C     Input
C     -----
C
C     None.
C
C
C     Output
C     ------
C
C     None.
C
C
C     Method
C     ------
C
C     If default (0/0/0/0) selected for input, input area is set
C       - to global for spherical harmonics
C       - to global for lat/long grid
C       - to global for gaussian grid
C
C     If default (0/0/0/0) selected for output, output area is set
C       - to same as input area for lat/long grid
C       - to same as input area for regular gaussian grid
C       - to global for reduced gaussian grid
C
C     (Currently, subareas are not supported for reduced gaussian fields.
C      Should work OK; but need to correct setup of values in GRIB
C      product for number of points in each latitude row)
C
C     Output area is adjusted to fit the given grid step.
C
C
C     Externals
C     ---------
C
C     AREACHK - Match input/output field area definitions according to
C               grid specification.
C     GETENV   - Get value of an environment variable
C     INTLOG   - Logs output messages
C
C
C     Author
C     ------
C
C     J.D.Chambers     ECMWF     Jan 1995
C
C----<
C
      IMPLICIT NONE
C
C     Function arguments
C
#include "parim.h"
#include "nifld.common"
#include "nofld.common"
#include "grfixed.h"
#include "intf.h"
#include "current.h"
C
C     Parameters
C
      INTEGER JPROUTINE
      PARAMETER (JPROUTINE = 19200 )
C
C     Local variables
C
      INTEGER INORTH, ISOUTH, IEAST
      INTEGER ITEMP, IRET
      REAL EW, NS, NORTH, SOUTH, EAST, WEST, FACTOR3, FACTOR4
      LOGICAL LDEFIN, LDEFOUT, LGLOBAL, LOVERDE
      CHARACTER*20 OVERIDE
      INTEGER IBLANK
C
C     Externals
C
      INTEGER AREACHK
C
C ------------------------------------------------------------------
C*    Section 1.   Initialise
C ------------------------------------------------------------------
C
  100 CONTINUE
      FIXAREA = 0
      FACTOR3 = 0.
      FACTOR4 = 0.
      LDEFIN  = .FALSE.
      LGLOBAL = .FALSE.
C
C ------------------------------------------------------------------
C*    Section 2.   Fixup input area if default (0/0/0/0).
C ------------------------------------------------------------------
C
  200 CONTINUE
C
C     Fixup input ocean area definition
C
      IF( NILOCAL.EQ.4 ) THEN
        FACTOR3 = 0.0
        FACTOR4 = 0.0
C
        IF( NIFORM.EQ.1 ) THEN
          IF( ISEC1(60).EQ.1 ) FACTOR3 = 1.0
          IF( ISEC1(60).EQ.2 ) THEN
            IF( ISEC1(47).EQ.160 ) FACTOR3 = 1000.0
          ENDIF
          IF( ISEC1(60).EQ.3 ) FACTOR3 = 1000000.0
          IF( ISEC1(60).EQ.4 ) FACTOR3 = 1000000.0
C
          IF( ISEC1(61).EQ.1 ) FACTOR4 = 1.0
          IF( ISEC1(61).EQ.2 ) THEN
            IF( ISEC1(47).EQ.160 ) FACTOR4 = 1000.0
          ENDIF
          IF( ISEC1(61).EQ.3 ) FACTOR4 = 1000000.0
          IF( ISEC1(61).EQ.4 ) FACTOR4 = 1000000.0
C
          IF( (FACTOR3.EQ.0).OR.(FACTOR4.EQ.0) ) THEN
            FIXAREA = 2
            GOTO 900
          ENDIF
          NORTH = REAL(ISEC1(62))/FACTOR4
          WEST  = REAL(ISEC1(63))/FACTOR3
          SOUTH = REAL(ISEC1(64))/FACTOR4
          EAST  = REAL(ISEC1(65))/FACTOR3
        ELSE
          IF( NIOCO3.EQ.1 ) FACTOR3 = 1.0
          IF( NIOCO3.EQ.2 ) THEN
            IF( NIVCDEF.EQ.160 ) FACTOR3 = 1000.0
          ENDIF
          IF( NIOCO3.EQ.3 ) FACTOR3 = 1000000.0
          IF( NIOCO3.EQ.4 ) FACTOR3 = 1000000.0
C
          IF( NIOCO4.EQ.1 ) FACTOR4 = 1.0
          IF( NIOCO4.EQ.2 ) THEN
            IF( NIVCDEF.EQ.160 ) FACTOR4 = 1000.0
          ENDIF
          IF( NIOCO4.EQ.3 ) FACTOR4 = 1000000.0
          IF( NIOCO4.EQ.4 ) FACTOR4 = 1000000.0
C
          IF( (FACTOR3.EQ.0).OR.(FACTOR4.EQ.0) ) THEN
            FIXAREA = 2
            GOTO 900
          ENDIF
          NORTH = REAL(NIOCO4F)/FACTOR4
          WEST  = REAL(NIOCO3F)/FACTOR3
          SOUTH = REAL(NIOCO4L)/FACTOR4
          EAST  = REAL(NIOCO3L)/FACTOR3
        ENDIF
        NIAREA(1) = NINT( NORTH * PPMULT + 0.1)
        NIAREA(2) = NINT( WEST  * PPMULT + 0.1)
        NIAREA(3) = NINT( SOUTH * PPMULT + 0.1)
        NIAREA(4) = NINT( EAST  * PPMULT + 0.1)
        GOTO 300
      ENDIF
C
C Sinisa bug fix for grid global fields
C       If input is lat/lon, check if it is global to within
C       a tolerance of 0.1 degrees
       IF ( NIREPR .EQ. JPREGULAR ) THEN
          IF ( NIAREA(4).GT.0 ) THEN
            IEAST = NIAREA(4)
          ELSE
            IEAST = JP360 + NIAREA(4)
          ENDIF
         IF(NIAREA(1).EQ.JP90.AND.NIAREA(3).EQ.-JP90.AND.
     X      NIAREA(2).EQ.0.AND.
     X      IABS(JP360 - IEAST - NIGRID(1)).LT.1000) THEN
              NIAREA(1) = 0
              NIAREA(2) = 0
              NIAREA(3) = 0
              NIAREA(4) = 0
csinisa
cs          ELSEIF(IABS(JP360 - IEAST - NIGRID(1)).LT.1000) THEN
cs              NOAREA(1) = NIAREA(1)
cs              NOAREA(2) = 0
cs              NOAREA(3) = NIAREA(3)
cs              NOAREA(4) = 36000000
          ENDIF
        ENDIF

      LDEFIN = ( (NIAREA(1) .EQ. 0) .AND. (NIAREA(2) .EQ. 0) .AND.
     X           (NIAREA(3) .EQ. 0) .AND. (NIAREA(4) .EQ. 0) )

C
      IF( LDEFIN ) THEN
C
        IF ( (NIREPR.EQ.JPSPHERE) .OR. (NIREPR.EQ.JPSPHROT) ) THEN
C
C         Spectral input ..
          EW = 0.0
          NS = 0.0
C
        ELSE IF ( NIREPR .EQ. JPREGULAR ) THEN
C
C         Regular lat/long grid ..
          EW = FLOAT( NIGRID(1) ) / PPMULT
          NS = FLOAT( NIGRID(2) ) / PPMULT
C
        ELSE
C
C         Gaussian grid ..
          EW = FLOAT( NIGAUSS )
          NS = 0.0
        ENDIF
C
        NORTH = 0.0
        WEST  = 0.0
        SOUTH = 0.0
        EAST  = 0.0
        IRET = AREACHK( EW, NS, NORTH, WEST, SOUTH, EAST )
        IF( IRET.NE.0 ) THEN
          FIXAREA = IRET
          GOTO 900
        ENDIF
        NIAREA(1) = NINT( NORTH * PPMULT + 0.1)
        NIAREA(2) = NINT( WEST  * PPMULT + 0.1)
        NIAREA(3) = NINT( SOUTH * PPMULT + 0.1)
        NIAREA(4) = NINT( EAST  * PPMULT + 0.1)
C
      ENDIF
C
C ------------------------------------------------------------------
C*    Section 3.   Fixup output area if default (0/0/0/0).
C ------------------------------------------------------------------
C
  300 CONTINUE
C
C     See if environment variable has been specified to override
C     output area specification
C
      LOVERDE = .FALSE.
      CALL GETENV('OVERRIDE_OUTPUT_AREA', OVERIDE)
      IBLANK = INDEX(OVERIDE, ' ')
      IF( IBLANK.GT.1 ) THEN
        IF( OVERIDE(1:2).EQ.'ON' ) THEN
          LOVERDE = .TRUE.
          CALL INTLOG(JP_DEBUG,
     X      'FIXAREA: OVERRIDE_OUTPUT_AREA is ON',JPQUIET)
        ENDIF
      ENDIF
C
      LDEFOUT = ( (NOAREA(1) .EQ. 0) .AND. (NOAREA(2) .EQ. 0) .AND.
     X            (NOAREA(3) .EQ. 0) .AND. (NOAREA(4) .EQ. 0) )
     X          .OR. LOVERDE
C
C     Fixup output ocean area definition
C
      IF( NILOCAL.EQ.4 ) THEN
        IF( LDEFOUT ) THEN
          IF( NIFORM.EQ.1 ) THEN
              SOUTH  = REAL(ISEC1(64))/FACTOR4
              NORTH  = REAL(ISEC1(62))/FACTOR4
              WEST   = REAL(ISEC1(63))/FACTOR3
              EAST   = REAL(ISEC1(65))/FACTOR3

              EW = FLOAT( NOGRID(1) ) / PPMULT
              NS = FLOAT( NOGRID(2) ) / PPMULT

            IF( ISEC1(60).EQ.3 ) THEN
              WEST  = 0.0
              EAST  = 360.0
              IRET = AREACHK( EW, NS, NORTH, WEST, SOUTH, EAST )
              IF ( IRET .NE. 0 ) THEN
                 FIXAREA = IRET
                 GOTO 900
              ENDIF
            ELSEIF( ISEC1(60).EQ.4 ) THEN
              WEST  = -90.0
              EAST  =  90.0
            ENDIF

            IF( ISEC1(61).EQ.3 ) THEN
              SOUTH  = 0.0
              NORTH  = 360.0
            ELSEIF( ISEC1(61).EQ.4 ) THEN
              SOUTH  = -90.0
              NORTH  =  90.0
            ENDIF
          ELSE
              NORTH = REAL(NIOCO4F)/FACTOR4
              WEST  = REAL(NIOCO3F)/FACTOR3
              SOUTH = REAL(NIOCO4L)/FACTOR4
              EAST  = REAL(NIOCO3L)/FACTOR3
              EW = FLOAT( NOGRID(1) ) / PPMULT
              NS = FLOAT( NOGRID(2) ) / PPMULT
            IF( NIOCO3.EQ.3 ) THEN
              WEST  = 0.0
              EAST  = 360.0
              IRET = AREACHK( EW, NS, NORTH, WEST, SOUTH, EAST )
              IF ( IRET .NE. 0 ) THEN
                 FIXAREA = IRET
                 GOTO 900
              ENDIF
            ELSEIF( NIOCO3.EQ.4 ) THEN
              WEST  = -90.0
              EAST  =  90.0
            ENDIF

            IF( NIOCO4.EQ.3 ) THEN
              SOUTH  = 0.0
              NORTH  = 360.0
            ELSEIF( NIOCO4.EQ.4 ) THEN
              SOUTH  = -90.0
              NORTH  =  90.0
            ENDIF
          ENDIF

          NOAREA(1) = NINT( NORTH * PPMULT + 0.1)
          NOAREA(2) = NINT( WEST  * PPMULT + 0.1)
          NOAREA(3) = NINT( SOUTH * PPMULT + 0.1)
          NOAREA(4) = NINT( EAST  * PPMULT + 0.1)
        ELSE
          NORTH = REAL(NOAREA(1)) / PPMULT
          WEST  = REAL(NOAREA(2)) / PPMULT
          SOUTH = REAL(NOAREA(3)) / PPMULT
          EAST  = REAL(NOAREA(4)) / PPMULT
        ENDIF
        GOTO 900
      ENDIF
C
      IF( LDEFOUT ) THEN
C
C       If input is gaussian, check if it is global to within
C       a tolerance of 0.1 degrees.
C
        IF ( (NIREPR.EQ.JPGAUSSIAN) .OR. (NIREPR.EQ.JPQUASI) ) THEN
          INORTH = NINT( RIGAUSS(1) * PPMULT )
          ISOUTH = -INORTH
c         EMOS-199: adjusted for reduced_gg/octahedral
c         IEAST  = JP360 - (JP90/NIGAUSS)
          IEAST  = JP360 - (JP360/MILLEN(NIGAUSS))
          LGLOBAL = (NIAREA(2).EQ.0)
     X      .AND. (IABS(NIAREA(1)-INORTH).LE.1000)
     X      .AND. (IABS(NIAREA(3)-ISOUTH).LE.1000)
     X      .AND. (IABS(NIAREA(4)-IEAST ).LE.1000 .OR.
     X        NIREPR.EQ.JPGAUSSIAN .OR. .TRUE. )
C         NOTE: a similar (but useless) test was done here before adding
C         .TRUE. be replicate the same (useless) behaviour
        ENDIF
C
C       Spectral output ..
C
C       .. skip section fitting output area to grid
C
        IF ( (NOREPR.EQ.JPSPHERE).OR.(NOREPR.EQ.JPSPHROT) ) GOTO 900
C
C       Regular lat/long grid ..
C
        IF ( (NOREPR.EQ.JPREGULAR).OR.(NOREPR.EQ.JPREGROT) ) THEN
          IF( LDEFIN .OR. LGLOBAL.OR.(NIREPR.EQ.JPREDLL) ) THEN
            EW = FLOAT( NOGRID(1) ) / PPMULT
            NS = FLOAT( NOGRID(2) ) / PPMULT
            NORTH = 90.0
            WEST  = 0.0
            SOUTH = -NORTH
            EAST  = 360.0
C
C           Use GRIB header values for reduced lat/long grids
C           (maybe 'Mediterranean' sub-area).
C
            IF( NIREPR.EQ.JPREDLL ) THEN
              NORTH = REAL(NIAREA(1))/PPMULT
              WEST  = REAL(NIAREA(2))/PPMULT
              SOUTH = REAL(NIAREA(3))/PPMULT
              EAST  = REAL(NIAREA(4))/PPMULT
            ENDIF
            IRET = AREACHK( EW, NS, NORTH, WEST, SOUTH, EAST )
            IF ( IRET .NE. 0 ) THEN
               FIXAREA = IRET
               GOTO 900
            ENDIF
            NOAREA(1) = NINT( NORTH * PPMULT + 0.1)
            NOAREA(2) = NINT( WEST  * PPMULT + 0.1)
            NOAREA(3) = NINT( SOUTH * PPMULT + 0.1)
            NOAREA(4) = NINT( EAST  * PPMULT + 0.1)
C
          ELSE
            NOAREA(1) = NIAREA(1)
            NOAREA(2) = NIAREA(2)
            NOAREA(3) = NIAREA(3)
            NOAREA(4) = NIAREA(4)
          ENDIF
C
        ENDIF
C
C       Gaussian ..
C
        IF ( (NOREPR.EQ.JPGAUSSIAN) .OR. (NOREPR.EQ.JPQUASI) ) THEN
C
C         Is output grid specification the same as the input?
          IF( NIGAUSS.EQ.NOGAUSS) THEN
            IF( (NOREPR.EQ.JPGAUSSIAN) .AND. LGLOBAL ) THEN
              NOAREA(1) = JP90
              NOAREA(2) = 0
              NOAREA(3) = -JP90
c     EMOS-199: adjusted for reduced_gg/octahedral
c             NOAREA(4) = JP360 - (JP90/NOGAUSS)
              NOAREA(4) = JP360 - (JP360/NOLPTS(NOGAUSS))
            ELSE
              NOAREA(1) = NIAREA(1)
              NOAREA(2) = NIAREA(2)
              NOAREA(3) = NIAREA(3)
              NOAREA(4) = NIAREA(4)
           ENDIF
C
C           Skip section fitting output area to grid
            GOTO 900
C
          ELSE
C
C           Different grid resolutions
            EW = FLOAT( NOGAUSS )
            NS = 0.0
            IF( (NOREPR.EQ.JPGAUSSIAN) .AND. LGLOBAL ) THEN
              NORTH =  90.0
              WEST  =   0.0
              SOUTH = -90.0
c     EMOS-199: adjusted for reduced_gg/octahedral
c             EAST  = 360.0 - (360.0/(EW*4.0))
              EAST  = 360.0 - (360.0/FLOAT(NOLPTS(NOGAUSS)))
            ELSE
              NORTH = FLOAT( NIAREA(1) ) / PPMULT
              WEST  = FLOAT( NIAREA(2) ) / PPMULT
              SOUTH = FLOAT( NIAREA(3) ) / PPMULT
              EAST  = FLOAT( NIAREA(4) ) / PPMULT
            ENDIF
            IRET = AREACHK( EW, NS, NORTH, WEST, SOUTH, EAST )
            IF ( IRET .NE. 0 ) THEN
               FIXAREA = IRET
               GOTO 900
            ENDIF
            NOAREA(1) = NINT( NORTH * PPMULT + 0.1)
            NOAREA(2) = NINT( WEST  * PPMULT + 0.1)
            NOAREA(3) = NINT( SOUTH * PPMULT + 0.1)
            NOAREA(4) = NINT( EAST  * PPMULT + 0.1)
C
C           If regular lat/long input, check if output west longitude
C           reachs to full globe
            ITEMP = NIAREA(4)+NIGRID(1)
            IF( (NIREPR.EQ.JPREGULAR .AND. ITEMP.EQ.JP360) .OR.
     X          (NIREPR.EQ.JPSPHERE) .OR.
     X          (NIREPR.EQ.JPSPHROT) ) THEN
c     EMOS-199: adjusted for reduced_gg/octahedral
c             NOAREA(4) = JP360 - (JP90/NOGAUSS)
              NOAREA(4) = JP360 - (JP360/NOLPTS(NOGAUSS))
            ENDIF
          ENDIF
        ENDIF
C
      ENDIF
C
C ------------------------------------------------------------------
C*    Section 4.   Now fixup output areas to correspond to the grid.
C ------------------------------------------------------------------
C
  400 CONTINUE
C
      IF ( (NOREPR.EQ.JPREGULAR).OR.(NOREPR.EQ.JPREGROT) ) THEN
C
C       Regular lat/long grid ..
        EW = FLOAT( NOGRID(1) ) / PPMULT
        NS = FLOAT( NOGRID(2) ) / PPMULT
C
      ELSE
C
C       Gaussian grid ..
        EW = FLOAT( NOGAUSS )
        NS = 0.0
      ENDIF
C
      NORTH = FLOAT( NOAREA(1) ) / PPMULT
      WEST  = FLOAT( NOAREA(2) ) / PPMULT
      SOUTH = FLOAT( NOAREA(3) ) / PPMULT
      EAST  = FLOAT( NOAREA(4) ) / PPMULT
      IRET = AREACHK( EW, NS, NORTH, WEST, SOUTH, EAST )
      IF ( IRET .NE. 0 ) THEN
         FIXAREA = IRET
         GOTO 900
      ENDIF
      NOAREA(1) = NINT( NORTH * PPMULT + 0.1)
      NOAREA(2) = NINT( WEST  * PPMULT + 0.1)
      NOAREA(3) = NINT( SOUTH * PPMULT + 0.1)
      NOAREA(4) = NINT( EAST  * PPMULT + 0.1)

C EMOS-199: [F|N] grids assume max(pl)=4*N, however O grids have
C max(pl)=4*+16 and AREACHK doesn't know of the difference
C The code below only checks if the adjusted EAST matches what
C would happen on a [F|N] global grid, and corrects it for an O grid.
      IF ( (NOREPR.EQ.JPQUASI)
     X  .AND. (HOGAUST.EQ.'O'
     X  .AND. NOAREA(2).EQ.0
     X  .AND. NOAREA(4).EQ.(JP360-JP90/NOGAUSS) ))
     X  NOAREA(4) = JP360 - (JP360/NOLPTS(NOGAUSS))

C
C ------------------------------------------------------------------
C*    Section 9.   Closedown.
C ------------------------------------------------------------------
C
  900 CONTINUE
C
      RETURN
      END

C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE GRSDBG (KDBG)
C
C---->
C**** GRSDBG - Debug print switch setting for routine GRIBEX.
C
C     Purpose.
C     --------
C
C           Switch debug printout on or off for routine GRIBEX.
C
C**   Interface.
C     ----------
C
C     CALL GRSDBG (KDBG)
C
C     Input Parameters.
C     -----------------
C
C     KDGB        - Debug print switch.
C                   0 , No printout.
C                   Non-zero , Debug printout.
C
C     Output Parameters.
C     ------------------
C
C     None.
C
C     Method.
C     -------
C
C     The variable NDBG is set in the common area. All other
C     parameters are also set to default values, if they have
C     not already been set by the user.
C
C     Externals.
C     ----------
C
C     GRSDEF - Default setting of global variables.
C
C     Reference.
C     ----------
C
C     See subroutine GRIBEX.
C
C     Comments.
C     ---------
C
C     None
C
C     Author.
C     -------
C
C     J. Hennessy      ECMWF      25.06.91
C
C     Modifications.
C     --------------
C
C     J. Hennessy      ECMWF      25.06.91
C     Changes to some comments only.
C
C     J. Hennessy      ECMWF      14.11.91
C     Common areas changed.
C
C     J. Hennessy      ECMWF      07.01.92
C     Input parameter returned unchanged.
C
C     J.D.Chambers     ECMWF      13.09.94
C     Add NONOFF and NOABORT, use grbcom.h
C
C     J. Clochard, Meteo France, for ECMWF - January 1998.
C     Use GRSDEF routine for default setting.
C
C     J. Clochard, Meteo France, for ECMWF - June 1999.
C     Use a static variable to determine if initialisation of
C     default values has already been done for common area
C     variables.
C
C----<
C     ----------------------------------------------------------------
C*    Section 0 . Definition of variables.
C     ----------------------------------------------------------------
C
      IMPLICIT NONE
C
#include "grbcom.h"
C
      INTEGER KDBG
C
      LOGICAL LFIRST
      SAVE LFIRST
C
      DATA LFIRST / .TRUE. /
C
C     ----------------------------------------------------------------
C*    Section 1 . Set values.
C     ----------------------------------------------------------------
C
  100 CONTINUE
C
      IF (LFIRST) THEN
C
C       Common area variables may have not been set, so start by
C       trying to set default values.
C
        CALL GRSDEF
        LFIRST=.FALSE.
C
      ENDIF
C
C     Set debug print to required value.
C
      NDBG   = KDBG
C
C     ----------------------------------------------------------------
C*    Section 9 . Return to calling routine.
C     ----------------------------------------------------------------
C
  900 CONTINUE
C
      RETURN
C
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities
C granted to it by virtue of its status as an intergovernmental organisation
C nor does it submit to any jurisdiction.
C

      PROGRAM TEST_INTERPOLATION
      IMPLICIT NONE


C     Parameters
      INTEGER JPGRIB                 ! GRIB size
C     PARAMETER (JPGRIB =  2000000)
C     PARAMETER (JPGRIB =  4284076)  ! for R640/O640 output
C     PARAMETER (JPGRIB =  7000000)  ! for INTUVP2 (requires 2 fields)
      PARAMETER (JPGRIB = 33190420)  ! for R1280/O1280 = 1/16 deg (INTUVP2 not tested)
      INTEGER JPBYTES                ! bytes/integer (8 on 64-bit architecture)
#ifdef INTEGER_8
      PARAMETER (JPBYTES = 8)
#else
      PARAMETER (JPBYTES = 4)
#endif
      LOGICAL IN, OUT
      PARAMETER (IN=.TRUE., OUT=.FALSE.)


C     Locals
      INTEGER R, I
      INTEGER IO ! 0:?, 1:INTIN, 2: INTOUT
      CHARACTER*256 ARG, KEY, VAL, F1, F2
      CHARACTER*1 N
      PARAMETER (N = CHAR(10))


C     Internals & externals
      LOGICAL SPLITARGS
      INTEGER WRAP_INT, WRAP_INTF2, WRAP_INTUVP2 !, WRAP_INTVECT2
      INTEGER IARGC


C     Initialize
      R = 0
      F1 = ''
      F2 = '/dev/null'


C     Process command line, in order
      DO I = 1, IARGC()
        CALL GETARG(I,ARG)
        R = -1
        IO = 0
        IF (SPLITARGS(ARG,IO,KEY,VAL)) THEN

          IF (IO.EQ.0) THEN
            IF (KEY.EQ.'input')    F1 = VAL
            IF (KEY.EQ.'output')   F2 = VAL
            IF (KEY.EQ.'input' .OR. KEY.EQ.'output') R=0
            IF (KEY.EQ.'intf2')    R=WRAP_INTF2   (F1,F2,JPGRIB,JPBYTES)
            IF (KEY.EQ.'intuvp2')  R=WRAP_INTUVP2 (F1,F2,JPGRIB,JPBYTES)
C           IF (KEY.EQ.'INTVECT2') R=WRAP_INTVECT2(F1,F2,JPGRIB,JPBYTES)
          ELSEIF (IO.EQ.1) THEN
            IF (KEY.EQ.'accuracy')        R=WRAP_INT(IN, KEY,VAL,1,0)
            IF (KEY.EQ.'area')            R=WRAP_INT(IN, KEY,VAL,0,4)
            IF (KEY.EQ.'date')            R=WRAP_INT(IN, KEY,VAL,1,0)
            IF (KEY.EQ.'form')            R=WRAP_INT(IN, KEY,VAL,0,0)
            IF (KEY.EQ.'grid')            R=WRAP_INT(IN, KEY,VAL,0,2)
            IF (KEY.EQ.'gridname')        R=WRAP_INT(IN, KEY,VAL,0,0)
            IF (KEY.EQ.'level')           R=WRAP_INT(IN, KEY,VAL,1,0)
            IF (KEY.EQ.'local')           R=WRAP_INT(IN, KEY,VAL,1,0)
            IF (KEY.EQ.'lsm_param')       R=WRAP_INT(IN, KEY,VAL,0,0)
            IF (KEY.EQ.'lsmset')          R=WRAP_INT(IN, KEY,VAL,0,0)
            IF (KEY.EQ.'matrix')          R=WRAP_INT(IN, KEY,VAL,1,0)
            IF (KEY.EQ.'npts')            R=WRAP_INT(IN, KEY,VAL,2,0)
            IF (KEY.EQ.'parameter')       R=WRAP_INT(IN, KEY,VAL,1,0)
            IF (KEY.EQ.'reduced')         R=WRAP_INT(IN, KEY,VAL,1,0)
            IF (KEY.EQ.'regular')         R=WRAP_INT(IN, KEY,VAL,1,0)
            IF (KEY.EQ.'scan')            R=WRAP_INT(IN, KEY,VAL,1,0)
            IF (KEY.EQ.'table')           R=WRAP_INT(IN, KEY,VAL,1,0)
            IF (KEY.EQ.'truncation')      R=WRAP_INT(IN, KEY,VAL,1,0)
            IF (KEY.EQ.'uselsm')          R=WRAP_INT(IN, KEY,VAL,0,0)
            IF (KEY.EQ.'useprecip')       R=WRAP_INT(IN, KEY,VAL,0,0)
            IF (KEY.EQ.'usewind')         R=WRAP_INT(IN, KEY,VAL,0,0)
            IF (KEY.EQ.'user_reduced_gaussian'.OR.
     .          KEY.EQ.'user_regular_gaussian')
     .        R=WRAP_INT(IN, KEY,VAL,1,0)
          ELSEIF (IO.EQ.2) THEN
            IF (KEY.EQ.'12-point')        R=WRAP_INT(OUT,KEY,VAL,0,0)
            IF (KEY.EQ.'accuracy')        R=WRAP_INT(OUT,KEY,VAL,1,0)
            IF (KEY.EQ.'area')            R=WRAP_INT(OUT,KEY,VAL,0,4)
            IF (KEY.EQ.'autoresol')       R=WRAP_INT(OUT,KEY,VAL,1,0)
            IF (KEY.EQ.'bitmap')          R=WRAP_INT(OUT,KEY,VAL,0,0)
            IF (KEY.EQ.'form')            R=WRAP_INT(OUT,KEY,VAL,0,0)
            IF (KEY.EQ.'frame')           R=WRAP_INT(OUT,KEY,VAL,1,0)
            IF (KEY.EQ.'gauss_from_file') R=WRAP_INT(OUT,KEY,VAL,0,0)
            IF (KEY.EQ.'gaussian')        R=WRAP_INT(OUT,KEY,VAL,1,0)
            IF (KEY.EQ.'grid')            R=WRAP_INT(OUT,KEY,VAL,0,2)
            IF (KEY.EQ.'gridname')        R=WRAP_INT(OUT,KEY,VAL,0,0)
            IF (KEY.EQ.'interpolation')   R=WRAP_INT(OUT,KEY,VAL,0,0)
            IF (KEY.EQ.'level')           R=WRAP_INT(OUT,KEY,VAL,1,0)
            IF (KEY.EQ.'levtype')         R=WRAP_INT(OUT,KEY,VAL,1,0)
            IF (KEY.EQ.'packing')         R=WRAP_INT(OUT,KEY,VAL,0,0)
            IF (KEY.EQ.'parameter')       R=WRAP_INT(OUT,KEY,VAL,1,0)
            IF (KEY.EQ.'red_latlon')      R=WRAP_INT(OUT,KEY,VAL,0,2)
            IF (KEY.EQ.'reduced')         R=WRAP_INT(OUT,KEY,VAL,1,0)
            IF (KEY.EQ.'regular')         R=WRAP_INT(OUT,KEY,VAL,1,0)
            IF (KEY.EQ.'rotation')        R=WRAP_INT(OUT,KEY,VAL,0,2)
            IF (KEY.EQ.'scan')            R=WRAP_INT(OUT,KEY,VAL,1,0)
            IF (KEY.EQ.'specification')   R=WRAP_INT(OUT,KEY,VAL,1,0)
            IF (KEY.EQ.'style')           R=WRAP_INT(OUT,KEY,VAL,0,0)
            IF (KEY.EQ.'table')           R=WRAP_INT(OUT,KEY,VAL,1,0)
            IF (KEY.EQ.'truncation')      R=WRAP_INT(OUT,KEY,VAL,1,0)
            IF (KEY.EQ.'intermediate_gaussian'.OR.
     .          KEY.EQ.'user_reduced_gaussian'.OR.
     .          KEY.EQ.'user_reduced_latlon'  .OR.
     .          KEY.EQ.'user_regular_gaussian')
     .        R=WRAP_INT(OUT,KEY,VAL,1,0)
          ENDIF

        ENDIF
        IF (R.NE.0) THEN
          PRINT *, 'Problem with option "'//ARG(1:INDEX(ARG,' ')-1)//'"'
          PRINT *, '  key:   "'//KEY(1:INDEX(KEY,' ')-1)//'"'
          PRINT *, '  value: "'//VAL(1:INDEX(VAL,' ')-1)//'"'
          CALL EXIT(1)
        ENDIF
      ENDDO

      IF (F1(1:1).EQ.' ' .OR. F2(1:1).EQ.' ') THEN
  666     PRINT *,N
     .//'Usage: int --input=1.grib --output=2.grib [options] ...'//N
     .//'where in/output files and interpolation fn. are mandatory:'//N
     .//'  --input=C    input file'//N
     .//'  --output=C   output file (default: /dev/null)'//N
     .//'  --intf2:     general/MARS interpolation'//N
     .//'               (allows multiple GRIB input)'//N
     .//'  --intuvp2:   u/v fields interpolation'//N
     .//'               (requires vo/d or u/v pair on GRIB input)'//N
C    .//'  --intvect2:  u/v fields interpolation'//N
C    .//'               (requires u/v pair on GRIB input)'//N
     .//N
     .//'and any of the INTIN/OUT options, interpreted in order'//N
     .//'(some combinations are inconsistent):'//N
     .//'  --INTIN:truncation=I:   SH truncation (input)'//N
     .//'  --INTOUT:12-point=C:    12-point bilinear int. ([yes|no])'//N
     .//'  --INTOUT:accuracy=I:    pck. accuracy ([16|24|...)'//N
     .//'  --INTOUT:area=R/R/R/R:  geographical area (N/W/S/E)'//N
     .//'  --INTOUT:autoresol=I:   SH auto truncation on/off ([1|0])'//N
     .//'  --INTOUT:grid=R/R:          regular lat-lon, or'//N
     .//'  --INTOUT:gridname=[F|N|O]I: specific grid, with:'//N
     .//'      F: regular Gaussian'//N
     .//'      N: reduced Gaussian/"quasi-regular"'//N
     .//'      O: reduced Gaussian/"octahedral"'//N
     .//'      I: points between equator and poles (N)'//N
     .//'  --INTOUT:interpolation=C: interpol. method (ref. code)'//N
     .//'  --INTOUT:packing=C:     pck. method ([second|simple|...])'//N
     .//'  --INTOUT:reduced=I:     reduced Gaussian grid (alternate)'//N
     .//'  --INTOUT:regular=I:     regular Gaussian grid (alternate)'//N
     .//'  --INTOUT:rotation=R/R:  South pole new position (lat/lon)'//N
     .//'  --INTOUT:style=C:       style ([dissemination|...])'//N
     .//'  --INTOUT:truncation=I:  SH truncation (output)'//N
     .//N
     .//'with the following abbreviations:'//N
     .//'  I: integer number'//N
     .//'  R: real number'//N
     .//'  C: text string'//N
        STOP
      ENDIF


      STOP
      ENDPROGRAM


C     ------------------------------------------------------------------
      LOGICAL FUNCTION SPLITARGS(ARG,IN,KEY,VAL)
      IMPLICIT NONE
      CHARACTER*256 ARG, KEY, VAL
      INTEGER IN

      IN  = 0
      KEY = ''
      VAL = ''
      IF (ARG(1:2).EQ.'--') THEN 
        KEY = ARG(3:)
        IF (INDEX(ARG,'=').GT.3) VAL = ARG(INDEX(ARG,'=')+1:)
        IF (INDEX(ARG,'=').GT.3) KEY = ARG(3:INDEX(ARG,'=')-1)
      ENDIF
      IF (KEY(1:6).EQ.'INTIN:') THEN
        IN  = 1
        KEY = KEY(7:)
      ELSEIF (KEY(1:7).EQ.'INTOUT:') THEN
        IN  = 2
        KEY = KEY(8:)
      ENDIF
      SPLITARGS = (INDEX(KEY,' ').GT.1)
      ENDFUNCTION


C     ------------------------------------------------------------------
      INTEGER FUNCTION WRAP_INT(IN,K,C,NI,NR)
      IMPLICIT NONE
      LOGICAL IN
      CHARACTER*256 K, C
      INTEGER NI, NR

      CHARACTER*256 M
      INTEGER I(4)
      REAL R(4)

      INTEGER INTIN, INTOUT
      EXTERNAL INTIN, INTOUT

      I = 0
      R = 0.
      IF (IN) THEN
        M = 'intin'
      ELSE
        M = 'intout'
      ENDIF
      M = M(1:INDEX(M,' ')-1)//'("'//K(1:INDEX(K,' ')-1)//'")'
      IF (NI.LT.0 .OR. NI.GT.4) NI = 0
      IF (NR.LT.0 .OR. NR.GT.4) NR = 0
      IF (NI.GE.1) THEN
        DO WHILE (INDEX(C,'/').GT.0)
          C(INDEX(C,'/'):INDEX(C,'/')) = ' '
        ENDDO
        READ (C,*) I(1:NI)
        C = ''
        PRINT *, M(1:INDEX(M,' ')-1), I(1:NI)
      ELSEIF (NR.GE.1) THEN
        DO WHILE (INDEX(C,'/').GT.0)
          C(INDEX(C,'/'):INDEX(C,'/')) = ' '
        ENDDO
        READ (C,*) R(1:NR)
        C = ''
        PRINT *, M(1:INDEX(M,' ')-1), R(1:NR)
      ELSE
        PRINT *, M(1:INDEX(M,' ')-1), ' "'//C(1:INDEX(C,' ')-1)//'"'
      ENDIF
      IF (IN) THEN
        WRAP_INT = INTIN (K,I,R,C)
      ELSE
        WRAP_INT = INTOUT(K,I,R,C)
      ENDIF
      IF (WRAP_INT.NE.0) PRINT *, M(1:INDEX(M,' ')-1)//' failed.'
      ENDFUNCTION


C     ------------------------------------------------------------------
      INTEGER FUNCTION WRAP_INTF2(INFILE,OUTFILE,LENGRIB,LENBYTES)
      IMPLICIT NONE
      CHARACTER*256 INFILE, OUTFILE
      INTEGER LENGRIB, LENBYTES

      INTEGER INGRIB(LENGRIB), NEWFLD(LENGRIB)
      INTEGER U1, U2, N, LENINT, IREC, IRET

      INTEGER INTF2
      EXTERNAL INTF2

C     Initialize
      INGRIB = 0
      NEWFLD = 0
      CALL EXCEPT()

C     Open input and output files
      IRET = 0
      CALL PBOPEN(U1, INFILE, 'r', IRET)
      CALL CHECK(IRET.NE.0, 'PBOPEN failed (r).')
      CALL PBOPEN(U2, OUTFILE, 'w', IRET)
      CALL CHECK(IRET.NE.0, 'PBOPEN failed (w).')

C     Start of loop on input fields
      N = 0
  120 CONTINUE
      N = N + 1

C     Read next field
      CALL PBGRIB(U1, INGRIB, LENGRIB*LENBYTES, IREC, IRET)
      IF (IRET.EQ.-1) THEN
        IRET = 0
        GOTO 190
      ENDIF
      CALL CHECK(IRET.NE.0, 'PBGRIB failed.')

C     Interpolate
      PRINT *, 'Interpolate field #', N
      LENINT = LENGRIB
      IRET = INTF2(INGRIB,IREC,NEWFLD,LENINT)
      CALL CHECK(IRET.NE.0, 'INTF2 failed')

C     Write the new field to file
      IF (LENINT.GT.0) THEN
        CALL PBWRITE(U2, NEWFLD, LENINT, IRET)
      ELSE
        PRINT *, 'Output same as input'
        CALL PBWRITE(U2, INGRIB, IREC, IRET)
      ENDIF
      CALL CHECK(IRET.LT.0, 'PBWRITE failed')
      IRET = 0

C     Loop back for next field
      IF (IRET.EQ.0) GOTO 120

C     Closedown
  190 CONTINUE
      WRAP_INTF2 = IRET
      CALL PBCLOSE(U1, IRET)
      CALL PBCLOSE(U2, IRET)
      PRINT *, 'All done.'
      ENDFUNCTION


C     ------------------------------------------------------------------
      INTEGER FUNCTION WRAP_INTUVP2(INFILE,OUTFILE,LENGRIB,LENBYTES)
      IMPLICIT NONE
      CHARACTER*256 INFILE, OUTFILE
      INTEGER LENGRIB, LENBYTES

      INTEGER IVOGRIB(LENGRIB), IDVGRIB(LENGRIB)
      INTEGER IUGRIB(LENGRIB), IVGRIB(LENGRIB)
      INTEGER U1, U2, N, LENINT, IREC, IRET

      INTEGER INTUVP2
      EXTERNAL INTUVP2

C     Open input and output files
      CALL PBOPEN(U1, INFILE, 'r', IRET)
      CALL CHECK(IRET.NE.0, 'PBOPEN failed (r).')
      CALL PBOPEN(U2, OUTFILE, 'w', IRET)
      CALL CHECK(IRET.NE.0, 'PBOPEN failed (w).')

C     Start of loop on input vo/d fields
      N = 0
  220 CONTINUE
      N = N + 1

C     Read next vo/d
      CALL PBGRIB(U1, IVOGRIB, LENGRIB*LENBYTES, IREC, IRET)
      IF (IRET.EQ.-1) THEN
        IRET = 0
        GOTO 290
      ENDIF
      CALL CHECK(IRET.NE.0, 'PBGRIB failed (vo).')
      CALL PBGRIB(U1, IDVGRIB, LENGRIB*LENBYTES, IREC, IRET)
      IF (IRET.EQ.-1) THEN
        IRET = 0
        GOTO 290
      ENDIF
      CALL CHECK(IRET.NE.0, 'PBGRIB failed (d).')

C     Interpolate
      PRINT *, 'Interpolate vo/d #', N
      LENINT = LENGRIB
      IRET = INTUVP2(IVOGRIB, IDVGRIB, LENGRIB, IUGRIB, IVGRIB, LENINT)
      CALL CHECK(IRET.NE.0, 'INTUVP2 failed.')

C     Write the new u/v fields to file
      IF (LENINT.GT.0) THEN
        CALL PBWRITE(U2, IUGRIB, LENINT, IRET)
        CALL CHECK(IRET.LT.LENINT, 'PBWRITE failed.')
        CALL PBWRITE(U2, IVGRIB, LENINT, IRET)
        CALL CHECK(IRET.LT.LENINT, 'PBWRITE failed.')
        IRET = 0
      ENDIF

C     Loop back for next field
      IF (IRET.EQ.0) GOTO 220

C     Closedown
  290 CONTINUE
      WRAP_INTUVP2 = IRET
      CALL PBCLOSE(U1, IRET)
      CALL PBCLOSE(U2, IRET)
      PRINT *, 'All done.'
      ENDFUNCTION


C     ------------------------------------------------------------------
#if 0
      INTEGER FUNCTION WRAP_INTVECT2(INFILE,OUTFILE,LENGRIB,LENBYTES)
      IMPLICIT NONE
      CHARACTER*256 INFILE, OUTFILE
      INTEGER LENGRIB, LENBYTES

      INTEGER IIAGRIB(LENGRIB), IIBGRIB(LENGRIB)
      INTEGER IOAGRIB(LENGRIB), IOBGRIB(LENGRIB)
      INTEGER U1, U2, N, LENINT, IREC, IRET

      INTEGER INTVECT2
      EXTERNAL INTVECT2

C     Open input and output files
      CALL PBOPEN(U1, INFILE, 'r', IRET)
      CALL CHECK(IRET.NE.0, 'PBOPEN failed (r).')
      CALL PBOPEN(U2, OUTFILE, 'w', IRET)
      CALL CHECK(IRET.NE.0, 'PBOPEN failed (w).')

C     Start of loop on input u/v fields
      N = 0
  220 CONTINUE
      N = N + 1

C     Read next u/v
      CALL PBGRIB(U1, IIAGRIB, LENGRIB*LENBYTES, IREC, IRET)
      IF (IRET.EQ.-1) THEN
        IRET = 0
        GOTO 290
      ENDIF
      CALL CHECK(IRET.NE.0, 'PBGRIB failed (u).')
      CALL PBGRIB(U1, IIBGRIB, LENGRIB*LENBYTES, IREC, IRET)
      IF (IRET.EQ.-1) THEN
        IRET = 0
        GOTO 290
      ENDIF
      CALL CHECK(IRET.NE.0, 'PBGRIB failed (v).')

C     Interpolate
      PRINT *, 'Interpolate u/v #', N
      LENINT = LENGRIB
      IRET = INTVECT2(IIAGRIB,IIBGRIB,LENGRIB,IOAGRIB,IOBGRIB,LENINT)
      CALL CHECK(IRET.NE.0, 'INTVECT2 failed.')

C     Write the new u/v fields to file
      IF (LENINT.GT.0) THEN
        CALL PBWRITE(U2, IOAGRIB, LENINT, IRET)
        CALL CHECK(IRET.LT.LENINT, 'PBWRITE failed.')
        CALL PBWRITE(U2, IOBGRIB, LENINT, IRET)
        CALL CHECK(IRET.LT.LENINT, 'PBWRITE failed.')
        IRET = 0
      ENDIF

C     Loop back for next field
      IF (IRET.EQ.0) GOTO 220

C     Closedown
  290 CONTINUE
      WRAP_INTVECT2 = IRET
      CALL PBCLOSE(U1, IRET)
      CALL PBCLOSE(U2, IRET)
      PRINT *, 'All done.'
      ENDFUNCTION
#endif


C     ------------------------------------------------------------------
      SUBROUTINE CHECK(OOPS,MSG)
      IMPLICIT NONE
      LOGICAL OOPS
      CHARACTER MSG*(*)
      IF (OOPS) THEN
        PRINT *, MSG(1:INDEX(MSG,' ')-1)
        CALL EXIT(3)
      ENDIF
      ENDSUBROUTINE

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities
C granted to it by virtue of its status as an intergovernmental organisation
C nor does it submit to any jurisdiction.
C

      INTEGER FUNCTION KRG2RGD(OLDFLD, NEWFLD, NUMME, NUMGG)
C
C---->
C**** KRG2RG
C
C     Purpose
C     -------
C
C     Interpolate a field based on one reduced gaussian grid to a
C     field based on a different reduced gaussian grid, using
C     intermediate interpolation
C
C
C     Interface
C     ---------
C
C     IRET = KRG2RGD(OLDFLD, NEWFLD, NUMME, NUMGG)
C
C     Input
C     -----
C
C     OLDFLD - Old field in GRIB format
C     NUMME  - Number of the intermediate gaussian field
C     NUMGG  - Number of the new gaussian field
C
C
C     Output
C     ------
C
C     NEWFLD - New field in GRIB format
C
C     Function returns:
C       - the size in bytes of the new GRIB product if all is well
C       - -1, otherwise.
C
C
C     Method
C     ------
C
C     Unpack input GRIBS.
C     Intermediate interpolation
C     Create new field and pack it into GRIB format.
C
C
C     Externals
C     ---------
C
C     GRIBEX  - Decode and encode GRIB products.
C     KINTRG  - Interpolate reduced gaussian field to reduced gaussian
C     JMALLOC - Dynamically allocate memory
C     INTLOG  - Log messages
C
C
C     Author
C     ------
C
C     S.Curic     ECMWF     October 2006
C
C----<
C
      IMPLICIT NONE
C
C     Function arguments
C
      INTEGER NUMME, NUMGG, OLDFLD(*), NEWFLD(*)
C
#include "parim.h"
#include "nifld.common"
#include "nofld.common"
C
C     Parameters
C
      INTEGER JPACK, JUNPACK, JPINTB, JPREALB
      PARAMETER (JPACK   = 4000000)
      PARAMETER (JUNPACK = 6000000)
#ifdef INTEGER_8
      PARAMETER (JPINTB = 8)
#else
      PARAMETER (JPINTB = 4)
#endif
#ifdef REAL_8
      PARAMETER (JPREALB = 8)
#else
      PARAMETER (JPREALB = 8)
#endif
C
C     Local variables
C
      INTEGER IFSEC0(JPGRIB_ISEC0),IFSEC1(JPGRIB_ISEC1),
     X IFSEC2(JPGRIB_ISEC2),IFSEC3(JPGRIB_ISEC3),IFSEC4(JPGRIB_ISEC4)
      INTEGER NFSEC2(JPGRIB_ISEC2),NFSEC3(JPGRIB_ISEC3)
      INTEGER NEWGEO(JPGRIB_ISEC2)
      INTEGER ISIZE
      LOGICAL LFIRST
      CHARACTER*1 HTYPE
#ifndef _CRAYFTN
#if (!defined sgi)
#ifdef POINTER_64
      INTEGER*8 IZFSEC4, IPFSEC4, IMEDFLD
#else
      INTEGER   IZFSEC4, IPFSEC4, IMEDFLD
#endif
#endif
#endif
C
      REAL PLAT(JPMAXNG)
      REAL ZFSEC2(5000), ZFSEC3(2), ZFSEC4(1)
      REAL PFSEC3(2), PFSEC4(1), MEDFLD(1)
C
      POINTER( IZFSEC4, ZFSEC4 )
      POINTER( IPFSEC4, PFSEC4 )
      POINTER( IMEDFLD, MEDFLD )
C
      INTEGER IRET, ILENB, IPUNP, IWORD
C
C     Externals
C
#ifdef POINTER_64
      INTEGER*8 JMALLOC
#else
      INTEGER JMALLOC
#endif
      INTEGER KINTRG
      EXTERNAL KINTRG, JMALLOC
C
      DATA LFIRST/.TRUE./
      SAVE LFIRST, IZFSEC4, IPFSEC4, IMEDFLD
C
C     -----------------------------------------------------------------|
C*    Section 1.   Initialise
C     -----------------------------------------------------------------|
C
  100 CONTINUE
C
      KRG2RGD = 0
C
      IF( (NUMGG*2).GT.JPMAXNG ) THEN
        CALL INTLOG(JP_ERROR,'KRG2RGD: Gaussian N too big = ',NUMGG)
        CALL INTLOG(JP_ERROR,'KRG2RGD: Maximum handled = ',(JPMAXNG/2))
        KRG2RGD = -1
        GOTO 900
      ENDIF

      IF( (NUMME*2).GT.JPMAXNG ) THEN
       CALL INTLOG(JP_ERROR,'KRG2RGD: Intermediate Gaussian N too big= '
     X   ,NUMME)
       CALL INTLOG(JP_ERROR,'KRG2RGD: Maximum handled = ',(JPMAXNG/2))
       KRG2RGD = -1
       GOTO 900
      ENDIF
C
C     First time, dynamically allocate memory for the field values
C
      IF( LFIRST ) THEN
        LFIRST = .FALSE.
        ISIZE = JUNPACK * JPREALB
        CALL INTLOG(JP_DEBUG,'KRG2RGD: Allocate memory = ',ISIZE)
C
        IZFSEC4 = JMALLOC(ISIZE)
#ifdef hpR64
        IZFSEC4 = IZFSEC4/(1024*1024*1024*4)
#endif
        IF( IZFSEC4.EQ.0 ) THEN
          CALL INTLOG(JP_ERROR,'KRG2RGD: JMALLOC fail IZFSEC4',JPQUIET)
          KRG2RGD = -1
          GOTO 900
        ENDIF
C
        IPFSEC4 = JMALLOC(ISIZE)
#ifdef hpR64
        IPFSEC4 = IPFSEC4/(1024*1024*1024*4)
#endif
        IF( IPFSEC4.EQ.0 ) THEN
          CALL INTLOG(JP_ERROR,'KRG2RGD: JMALLOC fail IPFSEC4',JPQUIET)
          KRG2RGD = -1
          GOTO 900
        ENDIF
C
        IMEDFLD = JMALLOC(ISIZE)
#ifdef hpR64
        IMEDFLD = IMEDFLD/(1024*1024*1024*4)
#endif
        IF( IMEDFLD.EQ.0 ) THEN
          CALL INTLOG(JP_ERROR,'KRG2RGD: JMALLOC fail IMEDFLD',JPQUIET)
          KRG2RGD = -1
          GOTO 900
        ENDIF
      ENDIF
C
C     -----------------------------------------------------------------|
C*    Section 2.   Unpack the input GRIB
C     -----------------------------------------------------------------|
C
  200 CONTINUE
C
C     Old field
C
      IRET = 1
      IPUNP = JUNPACK
      ILENB = JPACK
      IFSEC3(1) = 0
      IFSEC3(2) = INT(RMISSGV)
      ZFSEC3(1) = 0.0
      ZFSEC3(2) = RMISSGV
      CALL GRIBEX (IFSEC0,IFSEC1,IFSEC2,ZFSEC2,IFSEC3,ZFSEC3,IFSEC4,
     X             ZFSEC4,IPUNP,OLDFLD,ILENB,IWORD,'D',IRET)
      IF( IRET.GT.0 ) THEN
        WRITE(*,*) 'KRG2RGD: Old field gribex return code = ',IRET
        KRG2RGD = -1
        RETURN
      ENDIF
C
C     -----------------------------------------------------------------|
C*    Section 3.   Create intermediate field
C     -----------------------------------------------------------------|
C
  300 CONTINUE
C
      NFSEC2(1:JPGRIB_ISEC2) = IFSEC2(1:JPGRIB_ISEC2)
      NEWGEO(1:JPGRIB_ISEC2) = 0
      HTYPE = 'R'
      IF( LOCTAHEDRAL ) HTYPE = 'O'
      CALL JGETGG( NUMME, HTYPE, PLAT, NEWGEO(23), IRET)
      IF( IRET.NE.0 ) THEN
        WRITE(*,*) 'KRG2RGD: Problem calling JGETGG, status = ',IRET
        KRG2RGD = -1
        RETURN
      ENDIF
      NEWGEO(3)  = NUMME * 2
      NEWGEO(4)  = NINT(PLAT(1)*1000.0)
      NEWGEO(5)  = 0
      NEWGEO(7)  = NINT(PLAT(NUMME*2)*1000.0)
c     EMOS-199: adjusted for reduced_gg/octahedral
c     NEWGEO(8)  = NINT((360.0-(360.0/REAL(NUMME*4)))*1000.0)
      NEWGEO(8)  = NINT((360.0-(360.0/REAL(NEWGEO(23+NUMME))))*1000.0)
      NEWGEO(10) = NUMME
C
      IRET = KINTRG(IFSEC2, NEWGEO, ZFSEC4, MEDFLD)
      IF( IRET.LE.0 ) THEN
        WRITE(*,*) 'KRG2RGD: New field creation failed'
        KRG2RGD = -1
        RETURN
      ELSE
        CALL INTLOG(JP_DEBUG,
     X   'KRG2RGD: Intermediate gaussian field created - N',NUMME)
      ENDIF

C
C     -----------------------------------------------------------------|
C*    Section 4. Create new field from intermediate and put in GRIB
C     -----------------------------------------------------------------|
C

      HTYPE = 'R'
      IF( LOCTAHEDRAL ) HTYPE = 'O'
      CALL JGETGG( NUMGG, HTYPE, PLAT, NFSEC2(23), IRET)
      IF( IRET.NE.0 ) THEN
        WRITE(*,*) 'KRG2RGD: Problem calling JGETGG, status = ',IRET
        KRG2RGD = -1
        RETURN
      ENDIF
      NFSEC2(3)  = NUMGG * 2
      NFSEC2(4)  = NINT(PLAT(1)*1000.0)
      NFSEC2(7)  = NINT(PLAT(NUMGG*2)*1000.0)
c     EMOS-199: adjusted for reduced_gg/octahedral
c     NFSEC2(8)  = NINT((360.0-(360.0/REAL(NUMGG*4)))*1000.0)
      NFSEC2(8)  = NINT((360.0-(360.0/REAL(NFSEC2(23+NUMGG))))*1000.0)
      NFSEC2(10) = NUMGG
C
      IRET = KINTRG(NEWGEO, NFSEC2, MEDFLD, PFSEC4)
      IF( IRET.LE.0 ) THEN
        WRITE(*,*) 'KRG2RGD: New field creation failed'
        KRG2RGD = -1
        RETURN
      ELSE
        CALL INTLOG(JP_DEBUG,
     X   'KRG2RGD: New gaussian field created - N',NUMGG)
      ENDIF
      IFSEC4(1) = IRET
C
      IRET = 1
      IPUNP = JUNPACK
      ILENB = JPACK
C
C     If output 'accuracy' specified, use it for the new field
C
      IF( LNOACC ) THEN
        IFSEC4(2) = NOACC
      ENDIF
C
C     There may be 'missing' values in the new field if the old field
C     has 'missing' values.
C
      IF( IFSEC1(5).EQ.192 ) THEN
        IFSEC1(5) = 192
        NFSEC3(1) = 0
        NFSEC3(2) = INT(RMISSGV)
        PFSEC3(1) = 0.0
        PFSEC3(2) = RMISSGV
      ENDIF
C
      CALL GRIBEX (IFSEC0,IFSEC1,NFSEC2,ZFSEC2,NFSEC3,PFSEC3,IFSEC4,
     X             PFSEC4,IPUNP,NEWFLD,ILENB,IWORD,'C',IRET)
      IF( IRET.NE.0 ) THEN
        WRITE(*,*) 'KRG2RGD: New field gribex return code = ',IRET
        KRG2RGD = -1
        RETURN
      ENDIF
C
      KRG2RGD = IWORD * JPINTB
C
C     -----------------------------------------------------------------|
C*    Section 5.   Return
C     -----------------------------------------------------------------|
C
  900 CONTINUE
C
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE CONFPA(FVAL,KLENFP,KOFF,KPACKED,KWORD,KLENPS,KBIT)
C
C---->
C********************************************************************
C*
C*    NAME      : CONFPA
C*
C*    FUNCTION  : CONVERT FLOATING POINT NUMBER FROM MACHINE
C*                REPRESENTATION TO GRIB REPRESENTATION.
C*
C*    INPUT     : FVAL  - FLOATING POINT NUMBERS TO BE CONVERTED.
C*                KLENFP  : LENGTH OF FVAL
C*              : KOFF  - OFFSET IN BITS TO FIRST PACKED FIELD IN KPACKED.
C*                KBIT    : NUMBER OF BITS IN OUTPUT WORD
C*                KLENPS  : LENGTH OF KPACKED
C*
C*    OUTPUT    : KPACKED : PACKED OUTPUT FIELD
C*
C*    JOHN HENNESSY , ECMWF , 15TH APRIL 1985
C*    DAVID DENT    , ECMWF , 18TH NOVEMBER 1997
C*
C*    LIMITATION of this VECTOR version:
C*    assumes KOFF=0 and INTEGER word length is 32
C*
C********************************************************************
C----<
C
      REAL FVAL(KLENFP)
      INTEGER KPACKED(KLENPS)
C
      EPS = 1.0E-12
      IOUT=1
C
C        convert array of real numbers
C
      DO 210 JL=1,KLENFP
        IF (FVAL(JL).EQ.0.0) THEN
          JEXP  = 128
          JMANT = 0
        ELSE
C
          REF = FVAL(JL)
C
C     SIGN OF VALUE
C
          ISIGN = 0
          IF (REF.LE.0.) THEN
            ISIGN = 128
            REF = - REF
          ENDIF
C
C     EXPONENT
C
          IF (REF.EQ.0.0) THEN
            JEXP = 0
          ELSE
            JEXP = INT(ALOG(REF)*(1.0/ALOG(16.0))+64.0+1.0+EPS)
          ENDIF
C
          IF (JEXP.LT.0  ) JEXP = 0
          IF (JEXP.GT.127) JEXP = 127
C
C     MANTISSA
C
          JMANT = NINT (REF/16.0**(JEXP-70))
C
C     ADD SIGN BIT TO EXPONENT.
C
          JEXP = JEXP + ISIGN
C
        ENDIF
C
        KPACKED(IOUT)=IOR(ISHFT(JEXP,24),JMANT)

#ifdef LITTLE_ENDIAN
        CALL SWAP4(KPACKED(IOUT))
#endif 
        
        IOUT=IOUT+1
  210 CONTINUE
C
      KWORD=KWORD+(KLENFP*32/KBIT)
C
      RETURN
C
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities
C granted to it by virtue of its status as an intergovernmental organisation
C nor does it submit to any jurisdiction.
C

      SUBROUTINE JGETGG(KNUM,HTYPE,PLAT,KPTS,KRET)
C
C---->
C**** JGETGG
C
C     PURPOSE
C     _______
C
C     This routine reads the definition of a gaussian grid.
C
C
C     INTERFACE
C     _________
C
C     CALL JGETGG(KNUM,HTYPE,PLAT,KPTS,KRET)
C
C
C     Input parameters
C     ________________
C
C     KNUM     - Gaussian grid number
C     HTYPE    - Gaussian grid type
C                = 'R' for reduced ("quasi-regular"),
C                = 'O' for reduced/octahedral,
C                = 'F' for full,
C                = 'U' for a user-defined gaussian grid
C     KPTS     - Array giving users definition of the number of points
C                at each gaussian latitude if HTYPE  = 'U'
C
C
C     Output parameters
C     ________________
C
C     PLAT     - Array of gaussian latitudes (both hemispheres)
C     KPTS     - Array giving number of points at each gaussian
C                latitude, both hemispheres
C                (unchanged from input if HTYPE = 'U')
C     KRET     - Return status code
C                0 = OK
C
C
C     Common block usage
C     __________________
C
C     None.
C
C     Method
C     ______
C
C     If HTYPE = 'U', the users definition of the grid is used.
C     Latitudes values are calculated corresponding to KNUM.
C
C     An array of predefined values is used.
C
C
C     Externals
C     _________
C
C     INTLOG   - Output log message
C     IGGLAT   - Computes Gaussian latitude lines for given truncation
C     QGOCT    - Reduced Gaussian grid, octahedral progression series
C
C
C     Reference
C     _________
C
C     None
C
C
C     Comments
C     ________
C
C     None
C
C
C     AUTHOR
C     ______
C
C     J.D.Chambers      ECMWF      Jan 1994
C
C
C     MODIFICATIONS
C     _____________
C
C     J.D.Chambers      ECMWF      Apr 1995
C     Use predefined definition file for N80 and N160 to cope with
C     changes in the 'standard' definition.
C
C     J.D.Chambers      ECMWF      Apr 1996
C     Call JGGLAT if regular grid but not N80 or N160
C
C     J.D.Chambers      ECMWF      Apr 1996
C     Fixup standard pathnames for VPPs.
C     Read array of values from file if possible (once only).
C
C     S.Siemen         ECMWF       April 2015
C     Ensure user defined numbers of latitudes (PL) are not overwritten
C
C----<
C     -----------------------------------------------------------------|
C*    Section 0. Definition of variables.
C     -----------------------------------------------------------------|
C
      IMPLICIT NONE
C
C     Parameters
C
      INTEGER JPROUTINE
      PARAMETER ( JPROUTINE = 30100 )
C
C     Subroutine arguments
C
      INTEGER KNUM, KPTS(*), KRET
      CHARACTER*1 HTYPE
      REAL PLAT(*)
C
C     Local variables
C
#include "parim.h"
! nifld.common only for NGSPEC
#include "nifld.common"
#include "grfixed.h"
#include "rgauss_032.h"
#include "rgauss_048.h"
#include "rgauss_064.h"
#include "rgauss_080.h"
#include "rgauss_080_19940113.h"
#include "rgauss_096.h"
#include "rgauss_128.h"
#include "rgauss_160.h"
#include "rgauss_160_19931222.h"
#include "rgauss_200.h"
#include "rgauss_256.h"
#include "rgauss_320.h"
#include "rgauss_400.h"
#include "rgauss_512.h"
#include "rgauss_640.h"
#include "rgauss_1024.h"
#include "rgauss_1280.h"
#include "rgauss_2000.h"
C
      INTEGER IERR
      INTEGER IMAGE
      INTEGER INUM
      INTEGER JJERR
      INTEGER JJPR
      INTEGER LOOP
C
C     Externals
C
      LOGICAL ISGGVALID
      EXTERNAL ISGGVALID
      INTEGER IGGLAT, QGOCT
      EXTERNAL IGGLAT, QGOCT
C
C     -----------------------------------------------------------------|
C*    Section 1.    Set up standard latitudes
C     -----------------------------------------------------------------|
C
  100 CONTINUE
C
      IF( KNUM.GT.JPMAXNG .OR. .NOT.ISGGVALID(HTYPE,KNUM) ) THEN
        CALL INTLOG(JP_ERROR,
     X    'JGETGG: Grid not valid: '//HTYPE,KNUM)
        CALL INTLOG(JP_ERROR,
     X    'JGETGG: maybe too big for internal array dimension ',JPMAXNG)
        GOTO 910
      ENDIF
C
      INUM = KNUM*2
C
      IF( (HTYPE.EQ.'U').OR.(HTYPE.EQ.'u') ) GOTO 500
      IF( (HTYPE.EQ.'R').OR.(HTYPE.EQ.'r').OR.
     X    (HTYPE.EQ.'O').OR.(HTYPE.EQ.'o') ) GOTO 200
C
C     If a regular gaussian grid, calculate the gaussian latitudes
C
      CALL INTLOG(JP_DEBUG,
     X  'JGETGG: Calculate the gaussian latitudes for N = ',KNUM)
C
      JJPR  = 1
      JJERR = 1
      IERR  = IGGLAT(INUM, PLAT, JJPR, JJERR)
      IF( IERR.NE.0 ) THEN
        CALL INTLOG(JP_ERROR, 'JGETGG: IGGLAT call failed',IERR)
        KRET = IERR
        GOTO 990
      ENDIF
C
C     Fill in the number of points at each latitude
C
      CALL INTLOG(JP_DEBUG,'JGETGG: Regular gaussian grid N ',KNUM)
C
      KPTS(1:INUM) = KNUM*4
C
      GOTO 930
C
C     -----------------------------------------------------------------|
C*    Section 2.    Read REDUCED gaussian definitions from array
C     -----------------------------------------------------------------|
C
  200 CONTINUE
C
C     Fill in the gaussian latitudes
C
      JJPR  = 1
      JJERR = 1
      IERR  = IGGLAT(INUM, PLAT, JJPR, JJERR)
      IF( IERR.NE.0 ) THEN
        CALL INTLOG(JP_ERROR, 'JGETGG: IGGLAT call failed',IERR)
        KRET = IERR
        GOTO 990
      ENDIF
C
C     Fill the array for each row in both hemispheres.
C
      IF ((HTYPE.EQ.'O').OR.(HTYPE.EQ.'o')) THEN
          DO LOOP = 1, KNUM
              IMAGE       = INUM - LOOP +1
              KPTS(LOOP)  = QGOCT(LOOP)
              KPTS(IMAGE) = KPTS(LOOP)
          ENDDO
          GOTO 930
      ELSEIF( KNUM.EQ. 32 ) THEN
        DO LOOP = 1, KNUM
          IMAGE       = INUM - LOOP +1
          KPTS(LOOP)  = QG032(LOOP)
          KPTS(IMAGE) = KPTS(LOOP)
        ENDDO
        GOTO 930
C
      ELSEIF( KNUM.EQ. 48 ) THEN
        DO LOOP = 1, KNUM
          IMAGE       = INUM - LOOP +1
          KPTS(LOOP)  = QG048(LOOP)
          KPTS(IMAGE) = KPTS(LOOP)
        ENDDO
        GOTO 930

      ELSEIF( KNUM.EQ. 64 ) THEN
        DO LOOP = 1, KNUM
          IMAGE       = INUM - LOOP +1
          KPTS(LOOP)  = QG064(LOOP)
          KPTS(IMAGE) = KPTS(LOOP)
        ENDDO
        GOTO 930
C
      ELSE IF( KNUM.EQ. 80 ) THEN
C
        IF( NGSPEC.EQ.12 ) THEN
          DO LOOP = 1, KNUM
            IMAGE       = INUM - LOOP +1
            KPTS(LOOP)  = QG08012(LOOP)
            KPTS(IMAGE) = KPTS(LOOP)
          ENDDO
          GOTO 930
        ELSE
          DO LOOP = 1, KNUM
            IMAGE       = INUM - LOOP +1
            KPTS(LOOP)  = QG08018(LOOP)
            KPTS(IMAGE) = KPTS(LOOP)
          ENDDO
          GOTO 930
        ENDIF
C
      ELSE IF( KNUM.EQ.96 ) THEN
        DO LOOP = 1, KNUM
          IMAGE       = INUM - LOOP +1
          KPTS(LOOP)  = QG096(LOOP)
          KPTS(IMAGE) = KPTS(LOOP)
        ENDDO
        GOTO 930
C
      ELSE IF( KNUM.EQ.128 ) THEN
        DO LOOP = 1, KNUM
          IMAGE       = INUM - LOOP +1
          KPTS(LOOP)  = QG128(LOOP)
          KPTS(IMAGE) = KPTS(LOOP)
        ENDDO
        GOTO 930
C
      ELSE IF( KNUM.EQ.160 ) THEN
        IF( NGSPEC.EQ.12 ) THEN
          DO LOOP = 1, KNUM
            IMAGE       = INUM - LOOP +1
            KPTS(LOOP)  = QG16012(LOOP)
            KPTS(IMAGE) = KPTS(LOOP)
          ENDDO
          GOTO 930
        ELSE
          DO LOOP = 1, KNUM
            IMAGE       = INUM - LOOP +1
            KPTS(LOOP)  = QG16018(LOOP)
            KPTS(IMAGE) = KPTS(LOOP)
          ENDDO
          GOTO 930
        ENDIF
C
      ELSE IF( KNUM.EQ.200 ) THEN
        DO LOOP = 1, KNUM
          IMAGE       = INUM - LOOP +1
          KPTS(LOOP)  = QG200(LOOP)
          KPTS(IMAGE) = KPTS(LOOP)
        ENDDO
        GOTO 930
C
      ELSE IF( KNUM.EQ.256 ) THEN
        DO LOOP = 1, KNUM
          IMAGE       = INUM - LOOP +1
          KPTS(LOOP)  = QG256(LOOP)
          KPTS(IMAGE) = KPTS(LOOP)
        ENDDO
        GOTO 930
C
      ELSE IF( KNUM.EQ.320 ) THEN
        DO LOOP = 1, KNUM
          IMAGE       = INUM - LOOP +1
          KPTS(LOOP)  = QG320(LOOP)
          KPTS(IMAGE) = KPTS(LOOP)
        ENDDO
        GOTO 930
C
      ELSE IF( KNUM.EQ.400 ) THEN
        DO LOOP = 1, KNUM
          IMAGE       = INUM - LOOP +1
          KPTS(LOOP)  = QG400(LOOP)
          KPTS(IMAGE) = KPTS(LOOP)
        ENDDO
        GOTO 930
C
      ELSE IF( KNUM.EQ.512 ) THEN
        DO LOOP = 1, KNUM
          IMAGE       = INUM - LOOP +1
          KPTS(LOOP)  = QG512(LOOP)
          KPTS(IMAGE) = KPTS(LOOP)
        ENDDO
        GOTO 930
C
      ELSE IF( KNUM.EQ.640 ) THEN
        DO LOOP = 1, KNUM
          IMAGE       = INUM - LOOP +1
          KPTS(LOOP)  = QG640(LOOP)
          KPTS(IMAGE) = KPTS(LOOP)
        ENDDO
        GOTO 930
C
      ELSE IF( KNUM.EQ.1024 ) THEN
        DO LOOP = 1, KNUM
          IMAGE       = INUM - LOOP +1
          KPTS(LOOP)  = QG1024(LOOP)
          KPTS(IMAGE) = KPTS(LOOP)
        ENDDO
        GOTO 930
C
      ELSE IF( KNUM.EQ.1280 ) THEN
        DO LOOP = 1, KNUM
          IMAGE       = INUM - LOOP +1
          KPTS(LOOP)  = QG1280(LOOP)
          KPTS(IMAGE) = KPTS(LOOP)
        ENDDO
        GOTO 930
C
      ELSE
C       This is the default grid to use (N=1024)
        DO LOOP = 1, KNUM
          IMAGE       = INUM - LOOP +1
          KPTS(LOOP)  = QG1024(LOOP)
          KPTS(IMAGE) = KPTS(LOOP)
        ENDDO
        GOTO 930
      ENDIF
C
C     -----------------------------------------------------------------|
C*    Section 5.    Use User's gaussian definitions from array
C     -----------------------------------------------------------------|
C
  500 CONTINUE
C
      CALL INTLOG(JP_DEBUG,
     X  'JGETGG: Read definitions from User array', JPQUIET)
C
C     Fill the array for each row in both hemispheres.
C
      DO LOOP = 1, INUM
        PLAT(LOOP) = ROGAUSS(LOOP)
C        KPTS(LOOP) = NOLPTS(LOOP)
      ENDDO
C
      GOTO 930
C
C     -----------------------------------------------------------------|
C*    Section 9. Return to calling routine. Format statements
C     -----------------------------------------------------------------|
C
 910  CONTINUE
      KRET = JPROUTINE + 2
      CALL INTLOG(JP_ERROR,
     X  'JGETGG: No suitable gaussian grid definition found.',JPQUIET)
      GOTO 990
C
 930  CONTINUE
      KRET = 0
C
 990  CONTINUE
      RETURN
      END

C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE GETFLAG(KREF,KCODE,KFLAG,YFLAG,KERR)
C
C**** *GETFLAG*
C
C
C     PURPOSE.
C     --------
C
C          The main purpose of the subroutine is to get text 
C          associated with code number 
C
C**   INTERFACE.
C     ----------
C          NONE.
C
C
C
C
C     *METHOD.
C      -------
C          NONE.
C
C
C
C     EXTERNALS.
C     ----------
C          NONE.
C
C
C
C
C     REFERENCE.
C     ----------
C
C
C     AUTHOR.
C     -------
C
C          M. DRAGOSAVAC       *ECMWF*       JANUARY 2008.
C
C
C     MODIFICATIONS.
C     --------------
C
C          NONE.
C
C
      IMPLICIT LOGICAL(L,O,G), CHARACTER*8(C,H,Y)
C
#     include "parameter.F"
#     include "bcomwork.F"
#     include "bcomtab.F"
#     include "bcomtabc.F"
#     include "bcomct.F"
#     include "bcomctc.F"
#     include "bcomroot.F"
C#     include "bcomtabload.F"
C#     include "bcomtabloadc.F"


C
      CHARACTER*64  CTEXT
      CHARACTER*64  CTABBEN
      CHARACTER*24  CTABBU
      CHARACTER*64  YFLAG(32)
C
C
C     ------------------------------------------------------------------
C*          1.   SET INITIAL CONSTANTS AND POINTERS
C                ----------------------------------
 100  CONTINUE
C
      J=0
      do i=1,32
      YFLAG(i)=' '
      end do
C
      do i=1,JCTAB
      if(nref(i).eq.kref) go to 200
      end do
      print*,'Could not find ',kref
      ierr=2
      return      
c
 200  continue
C
      ictab=i
C
C     Find data width for kref
C
      do i=1,JTAB
      if(NTABBTR(I).eq.kref) go to 201
      end do

      print*,'Could not find ',kref
      ierr=2
      return
 201  continue
c
      ibtab=i
c
      iwidth=NTABBDW(ibtab)
c
      if(KCODE.eq.NMASK(iwidth)) then
         KFLAG=1
         YFLAG(1)='MISSING VALUE'         
         return
      else
         ipt=nstart(ictab)
         iptc=nstartc(ipt)
         KFLAG=0
         do i=ipt,ipt+nlen(ictab)-1
            ibitnumber=ncodnum(i)
c           test bit 
            ipos=iwidth-ibitnumber
            if(btest(KCODE,ipos)) then
               ic=iptc+ibitnumber-1
               KFLAG=KFLAG+1
               YFLAG(KFLAG)=ctext(ic)
            end if
         end do
      end if

      return
      END

C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      INTEGER FUNCTION IGLREV (PMAT, KCOL, KROW, KDIR, KPR, KERR)
C
C---->
C**** *IGLREV*
C
C     PURPOSE
C     _______
C
C     This routine reverses either the rows or the columns of a
C     rectangular matrix.
C
C     INTERFACE
C     _________
C
C     IERR = IGLREV (PMAT, KCOL, KROW, KDIR, KPR, KERR)
C
C     Input parameters
C     ________________
C
C     PMAT       - The input matrix of dimension (KCOL, KROW).
C
C     KCOL       - The length of the first dimension of PMAT.
C
C     KROW       - The length of the second dimension of PMAT.
C
C     KDIR       - 1    Reverses the order in each column.
C                       West-East reversal for meteorological fields.
C                  2    Reverses the order in each row.
C                       North-South reversal for meteorological fields.
C
C     KPR        - The debug print switch.
C                  0  , No debugging output.
C                  1  , Produce debugging output.
C
C     KERR       - The error control flag.
C                  -ve, No error message. Return error code.
C                  0  , Hard failure with error message.
C                  +ve, Print error message. Return error code.
C
C     Output parameters
C     ________________
C
C     PMAT       - The transformed matrix.
C
C     Return value
C     ____________
C
C     The error indicator (INTEGER).
C
C     Error and Warning Return Values
C     _______________________________
C
C     None
C
C     Common block usage
C     __________________
C
C     None
C
C     EXTERNALS
C     _________
C
C     INTLOG     - Logs messages.
C
C     METHOD
C     ______
C
C     KDIR = 1 is implemented by swapping elements within each column
C              of the matrix.
C
C     KDIR = 2 is implemented by reversing the order of the columns.
C
C     REFERENCE
C     _________
C
C     None
C
C     COMMENTS
C     ________
C
C     Program contains sections 0 to 3 and 9
C
C     AUTHOR
C     ______
C
C     K. Fielding      *ECMWF*      Jan 1994
C
C     MODIFICATIONS
C     _____________
C
C     None
C
C----<
C     _______________________________________________________
C
C
C*    Section 0. Definition of variables.
C     _______________________________________________________
C
C*    Prefix conventions for variable names
C
C     Logical      L (but not LP), global or common.
C                  O, dummy argument
C                  G, local variable
C                  LP, parameter.
C     Character    C, global or common.
C                  H, dummy argument
C                  Y (but not YP), local variable
C                  YP, parameter.
C     Integer      M and N, global or common.
C                  K, dummy argument
C                  I, local variable
C                  J (but not JP), loop control
C                  JP, parameter.
C     REAL         A to F and Q to X, global or common.
C                  P (but not PP), dummy argument
C                  Z, local variable
C                  PP, parameter.
C
C     Implicit statement to force declarations
C
      IMPLICIT NONE
C
#include "parim.h"
C
C     Dummy arguments
C
      INTEGER KCOL, KROW, KDIR, KPR, KERR
C
      REAL PMAT (KCOL, KROW)
C
C     Local variables
C
      INTEGER IHALF
C
      INTEGER JSTEP, JMOVE
C
      REAL ZTEMP
C
      INTEGER JPROUTINE
C
      PARAMETER (JPROUTINE = 7300)
C
C     External functions
C
C
C     _______________________________________________________
C
C
C*    Section 1. Initialisation
C     _______________________________________________________
C
  100 CONTINUE
C
      IF (KPR .GE. 1) CALL INTLOG(JP_DEBUG,'IGLREV: Section 1.',JPQUIET)
C
      IGLREV = 0
C
      IF (KPR .GE. 1) THEN
        CALL INTLOG(JP_DEBUG,'IRSCAN: Input parameters.',JPQUIET)
        CALL INTLOG(JP_DEBUG,'IRSCAN: First matrix dimension is ',KCOL)
        CALL INTLOG(JP_DEBUG,'IRSCAN: Second matrix dimension is ',KROW)
        CALL INTLOG(JP_DEBUG,'IRSCAN: Direction value is ',KDIR)
        CALL INTLOG(JP_DEBUG,'IRSCAN: Input parameters.',JPQUIET)
      ENDIF
C
C     _______________________________________________________
C
C
C*    Section 2. Matrix COLUMN reversal (Field row interchange - WE)
C     _______________________________________________________
C
  200 CONTINUE
C
      IF (KPR .GE. 1) CALL INTLOG(JP_DEBUG,'IGLREV: Section 2.',JPQUIET)
C
      IF (KDIR .EQ. 1) THEN
C
         IHALF = KCOL / 2
C
         DO 220 JMOVE = 1, IHALF
C
            DO 210 JSTEP = 1, KROW
C
               ZTEMP = PMAT (KCOL + 1 - JMOVE, JSTEP)
               PMAT (KCOL + 1 - JMOVE, JSTEP) = PMAT (JMOVE, JSTEP)
               PMAT (JMOVE, JSTEP) = ZTEMP
C
  210       CONTINUE
C
  220    CONTINUE
C
      ELSE
C
C     _______________________________________________________
C
C
C*    Section 3. Matrix ROW reversal (Field column interchange - NS)
C     _______________________________________________________
C
  300 CONTINUE
C
      IF (KPR .GE. 1) CALL INTLOG(JP_DEBUG,'IGLREV: Section 3.',JPQUIET)
C
         IHALF = KROW / 2
C
         DO 320 JMOVE = 1, IHALF
C
            DO 310 JSTEP = 1, KCOL
C
               ZTEMP = PMAT (JSTEP, KROW + 1 - JMOVE)
               PMAT (JSTEP, KROW + 1 - JMOVE) = PMAT (JSTEP, JMOVE)
               PMAT (JSTEP, JMOVE) = ZTEMP
C
  310       CONTINUE
C
  320    CONTINUE
C
      ENDIF
C
C     _______________________________________________________
C
C
C*    Section 9. Return to calling routine. Format statements
C     _______________________________________________________
C
  900 CONTINUE
C
      IF (KPR .GE. 1) CALL INTLOG(JP_DEBUG,'IGLREV: Section 9.',JPQUIET)
C
      RETURN
      END

c Copyright 1981-2012 ECMWF.
c
c This software is licensed under the terms of the Apache Licence 
c Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
c
c In applying this licence, ECMWF does not waive the privileges and immunities 
c granted to it by virtue of its status as an intergovernmental organisation 
c nor does it submit to any jurisdiction.
c

      SUBROUTINE FAX(IFAX,N,MODE)
      DIMENSION IFAX(10)
      COMMON /QQQQFFT/ IXXX
C
C     MARK INITIALISATION AS 'OLD' TYPE
C
      IXXX=0
C
      NN=N
      IF (IABS(MODE).EQ.1) GO TO 10
      IF (IABS(MODE).EQ.8) GO TO 10
      NN=N/2
      IF ((NN+NN).EQ.N) GO TO 10
      IFAX(1)=-99
      RETURN
   10 K=1
C     TEST FOR FACTORS OF 4
   20 IF (MOD(NN,4).NE.0) GO TO 30
      K=K+1
      IFAX(K)=4
      NN=NN/4
      IF (NN.EQ.1) GO TO 80
      GO TO 20
C     TEST FOR EXTRA FACTOR OF 2
   30 IF (MOD(NN,2).NE.0) GO TO 40
      K=K+1
      IFAX(K)=2
      NN=NN/2
      IF (NN.EQ.1) GO TO 80
C     TEST FOR FACTORS OF 3
   40 IF (MOD(NN,3).NE.0) GO TO 50
      K=K+1
      IFAX(K)=3
      NN=NN/3
      IF (NN.EQ.1) GO TO 80
      GO TO 40
C     NOW FIND REMAINING FACTORS
   50 L=5
      INC=2
C     INC ALTERNATELY TAKES ON VALUES 2 AND 4
   60 IF (MOD(NN,L).NE.0) GO TO 70
      K=K+1
      IFAX(K)=L
      NN=NN/L
      IF (NN.EQ.1) GO TO 80
      GO TO 60
   70 L=L+INC
      INC=6-INC
      GO TO 60
   80 IFAX(1)=K-1
C     IFAX(1) CONTAINS NUMBER OF FACTORS
C     IFAX(1) CONTAINS NUMBER OF FACTORS
      NFAX=IFAX(1)
C     SORT FACTORS INTO ASCENDING ORDER
      IF (NFAX.EQ.1) GO TO 110
      DO 100 II=2,NFAX
      ISTOP=NFAX+2-II
      DO 90 I=2,ISTOP
      IF (IFAX(I+1).GE.IFAX(I)) GO TO 90
      ITEM=IFAX(I)
      IFAX(I)=IFAX(I+1)
      IFAX(I+1)=ITEM
   90 CONTINUE
  100 CONTINUE
  110 CONTINUE
      IFAX(10)=0
      RETURN
      END

 program tc_tracks
!
!
!**** tc_tracks*
!
!
!     Purpose.
!     --------
!
!         Create tropical cyclone tracks
!
!
!**   Interface.
!     ----------
!
!
!     Method.
!     -------
!
!
!
!
!
!     Externals.
!     ----------
!
!
!
!     Reference.
!     ----------
!
!
!
!     Author.
!     -------
!
!          M. Dragosavac    *ECMWF*      22/12/2001 
!
!
!     Modifications.
!     --------------
!
!          NONE.
!---------------------------------------------------------------------------
 USE bufr_module

 implicit none

! Local variables

  integer              :: iii,narg, iargc, n, nn
  integer              :: j,ios,ij,ii
  integer              :: iunit, iret,ierr, ilen
  integer              :: kdlen
  integer              :: second, subset

  character(len=256)   :: input_file
  character(len=256)   :: output_file
  character(len=256)   :: det_file
  character(len=256), dimension(10) :: carg
  character(len=1024)   :: line
  character(len=3)     :: tc_identifier
  character(len=10)    :: tc_name


  integer             :: increment
  integer             :: member
  integer             :: originating_centre
  integer             :: number_of_steps
  integer             :: is_missing_step(100)

  real                :: lat_observed
  real                :: lon_observed
  real                :: lat_pressure(100)
  real                :: lon_pressure(100)
  real                :: lat_wind(100)
  real                :: lon_wind(100)
  integer             :: year
  integer             :: month
  integer             :: day
  integer             :: hour
  integer             :: minute
  integer             :: key2(46)
  integer             :: key3(46)
  integer             :: kerr
  integer             :: jj                             ! loop variable
  real                :: wind(100)
  real                :: pressure(100)
  real                :: missing
  integer             :: edition


  integer, parameter :: kel=1000

! Subroutine interface


! ----------------------------------

!  initialization of variables

  missing=rvind
  increment=0
  number_of_steps=0
  is_missing_step=0
  lat_pressure=missing
  lon_pressure=missing
  lat_wind=missing
  lon_wind=missing
  wind=missing
  pressure=missing

!   Get program arguments


    input_file=' '
    output_file=' '

    narg=iargc()

    if(narg < 3) then
       print*,'Usage -- tc_tracks_det -4 -i input_file -o det_file '
       print*,'      -4 option to produce BUFR edition 4'
       print*,'      input_file   -- input file name'
       print*,'      det_file     -- determistic file name'
       stop
    end if

    do  j=1,narg
       call getarg(j,carg(j))
    end do


    edition=3
    do j=1,narg
     if(carg(j) == '-i') then
       input_file=carg(j+1)
     elseif(carg(j) == '-o') then
       output_file=carg(j+1)
     elseif(carg(j) == '-4') then
       edition=4
     else
       cycle
     end if
    end do

    write(0,*) 'Input  file name='//trim(input_file)
    write(0,*) 'Deterministic file name='//trim(output_file)


!-- Open input and output files
!   ---------------------------


!   Open input file

    open(21,file=trim(input_file),iostat=ios)
    if(ios /= 0) then
      print*,'Open error on input file '
      stop
    end if

!   Open output file

    iret=0
    call pbopen(iunit,trim(output_file),'w',iret)
    if(iret == -1) then
       print*,'Open failed'
       stop
    elseif(iret == -2) then
       print*,'Invalid input file name'
       stop
    elseif(iret == -3) then
       print*,'Invalid open mode specified'
       stop
    end if



!   Read input file
  
    subset=0
    number_of_steps=0
    values=rvind
    
    do while( ios == 0 )
    
    line=' '
    read(21,'(a)', iostat=ios) line
!   write(0,*) trim(line)

    if( ios == 0 ) then
      if(index(line,'originating centre') /= 0 ) then
         read(line,'(47x,i3)',iostat=ios) originating_centre
         write(*,'(47x,i3)',iostat=ios) originating_centre
         if(ios /= 0 ) then
            print*,'Internal read error for originating_centre'
            call exit(2)
         end if
      elseif(index(line,'TC identifier') /= 0 ) then
         read(line,'(16x,a3)',iostat=ios) tc_identifier
         write(*,'(16x,a3)',iostat=ios) tc_identifier
         if(ios /= 0 ) then
            print*,'Internal read error for tc_identifier'
            call exit(2)
         end if
      elseif(index(line,'TC name') /= 0 ) then  
         read(line,'(10x,a10)',iostat=ios) tc_name
         write(*,'(10x,a10)',iostat=ios) tc_name
         if(ios /= 0 ) then
            print*,'Internal read error for tc_name'
            call exit(2)
         end if
      elseif(index(line,'YYYYMMDDHHMM') /= 0 ) then
         read(line,'(36x,i4,i2,i2,i2,i2)',iostat=ios) year, month, day, hour, minute
         write(*,'(36x,i4,i2,i2,i2,i2)',iostat=ios) year, month, day, hour, minute
         if(ios /= 0 ) then
            print*,'Internal read error for date/time'
            call exit(2)
         end if
      elseif(index(line,'obs lat') /= 0 ) then
         read(line,'(14x,f6.2)',iostat=ios) lat_observed
         write(*,'(14x,f6.2)',iostat=ios) lat_observed
         if(ios /= 0 ) then
            print*,'Internal read error for obs lat'
            call exit(2)
         end if
      elseif(index(line,'obs lon') /= 0 ) then
         read(line,'(13x,f7.2)',iostat=ios) lon_observed
         write(*,'(13x,f7.2)',iostat=ios) lon_observed
         if(ios /= 0 ) then
            print*,'Internal read error for obs lon'
            call exit(2)
         end if
      elseif(index(line,'member') /= 0 ) then
         if (iii /= 0 ) then
            print *,'Internal read error: too many members, only deterministic expected'
            call exit(2)
         endif
         read(line,'(46x,i2)',iostat=ios) member
         write(*,'(46x,i2)',iostat=ios) member
         if(ios /= 0 ) then
            print*,'Internal read error for member'
            call exit(2)
         end if
      elseif(index(line,'number of steps') /= 0 ) then
         read(line,'(46x,i2)',iostat=ios) number_of_steps
         write(*,'(46x,i2)',iostat=ios) number_of_steps
         if(ios /= 0 ) then
            print*,'Internal read error for number of steps'
            call exit(2)
         end if


      elseif(index(line,'increment') /= 0 ) then
         read(line,'(46x,i2)',iostat=ios) increment
         write(*,'(46x,i2)',iostat=ios) increment
         if(ios /= 0 ) then
            print*,'Internal read error for increment'
            call exit(2)
         end if
      elseif(index(line,'missing') /= 0 ) then
           iii=iii+1
           is_missing_step(iii)=1
      else
         iii=iii+1
         is_missing_step(iii)=0
         read(line,'(4x,f6.2,3x,f7.2,3x,f7.2,4x,f6.2,4x,f6.2,3x,f7.2)',iostat=ios) lat_pressure(iii), &
&             lon_pressure(iii),pressure(iii),wind(iii),lat_wind(iii), &
&             lon_wind(iii)
         write(*,'(4x,f6.2,3x,f7.2,3x,f7.2,4x,f6.2,4x,f6.2,3x,f7.2)',iostat=ios) lat_pressure(iii), &
&             lon_pressure(iii),pressure(iii),wind(iii),lat_wind(iii), &
&             lon_wind(iii)
         pressure(iii)=pressure(iii)*100.
!          print*,' ',iii,'----',lat(iii),lon(iii),pressure(iii),wind(iii)
           if(ios /= 0 ) then
              print*,'Internal read error for increment'
              call exit(2)
           end if
      end if
    else
       print*,'END of data....................'
       exit
    end if
    end do

    if (number_of_steps .eq. 0) then
      print *,'number of steps = 0, no output bufr written'
      stop
    end if

    cvals(1)=tc_identifier
    cvals(2)=tc_name


    subset=subset+1

    ij=(subset-1)*kel

        n=1+ij
        values(  n)=98.      ! Originating centre
        n=2+ij
        values(  n)=rvind    ! Originating subcentre
        n=3+ij
        values(  n)=1.       ! Generation application
        n=4+ij
        values(  n)=1003.    ! Storm identifier
        n=5+ij
        values(  n)=2010.    ! Storm name
        n=6+ij
        values(  n)=2.       ! singular vector
        n=7+ij
        values(  n)=member    ! Only deterministic member
        n=8+ij
        values(  n)=0        ! unperturbed high resol. control forecast
!+++++++++++++++++++++
        n=9+ij
        values(  n)=year
        n=10+ij
        values(  n)=month
        n=11+ij
        values(  n)=day
        n=12+ij
        values(  n)=hour
        n=13+ij
        values(  n)=minute
!+++++++++++++++++++++++++
        n=14+ij
        values(  n)=1.             ! Storm centre
        n=15+ij
        values(  n)=lat_observed
        n=16+ij
        values(  n)=lon_observed
        n=17+ij
        values(  n)=5. ! Location of the storm in the analysis
        n=18+ij
        if (is_missing_step(1) == 0) values(  n)=lat_pressure(1)
        n=19+ij
        if (is_missing_step(1) == 0) values(  n)=lon_pressure(1)
        n=20+ij
        if (is_missing_step(1) == 0) values(  n)=pressure(1)
        n=21+ij
        values(  n)=3.
        n=22+ij
        values(  n)=lat_wind(1)
        n=23+ij
        values(  n)=lon_wind(1)
        n=24+ij
        values(  n)=wind(1)
!+++++++++++++++++++++++++
        n=25+ij
        values(  n)=number_of_steps-1       ! delayed replication up to any forecast steps

        nn=25
        do ii=2,number_of_steps
          if (is_missing_step(ii) == 1) continue
          nn=nn+1
          n=nn+ij
          values(  n)=4.         ! time significance  008021 forecast
          nn=nn+1
          n=nn+ij
          values(  n)=(ii-1)*increment  ! time displacement
          nn=nn+1
          n=nn+ij
          values(  n)=1.           ! 008005 storm centre
          nn=nn+1
          n=nn+ij
          values(  n)=lat_pressure(ii)        !
          nn=nn+1
          n=nn+ij
          values(  n)=lon_pressure(ii)
          nn=nn+1
          n=nn+ij
          values(  n)=pressure(ii)
          nn=nn+1
          n=nn+ij
          values(  n)=3.           ! 008005  location of max wind
          nn=nn+1
          n=nn+ij
          values(  n)=lat_wind(ii)        !
          nn=nn+1
          n=nn+ij
          values(  n)=lon_wind(ii)
          nn=nn+1
          n=nn+ij
          values(  n)=wind(ii)
        end do

        ktdlst( 1)=001033
        ktdlst( 2)=001034
        ktdlst( 3)=001032
        ktdlst( 4)=001025
        ktdlst( 5)=001027
        ktdlst( 6)=001090
        ktdlst( 7)=001091
        ktdlst( 8)=001092
        ktdlst(09)=301011
        ktdlst(10)=301012
        ktdlst(11)=008005
        ktdlst(12)=005002
        ktdlst(13)=006002
        ktdlst(14)=008005
        ktdlst(15)=005002
        ktdlst(16)=006002
        ktdlst(17)=010051
        ktdlst(18)=008005
        ktdlst(19)=301023
        ktdlst(20)=011012
        ktdlst(21)=108000
        ktdlst(22)=031001
        ktdlst(23)=008021
        ktdlst(24)=004024
        ktdlst(25)=008005
        ktdlst(26)=301023
        ktdlst(27)=010051
        ktdlst(28)=008005
        ktdlst(29)=301023
        ktdlst(30)=011012

        ktdlen=30

!          Create bufr message

        if (edition == 3) then
            ksec0( 3)=3
            ksec1( 2)=3
            ksec1( 1)=18 
        else if (edition == 4 ) then
            ksec0( 3)=4
            ksec1( 2)=4
            ksec1( 1)=22
        end if

        ksec1( 3)=98
        ksec1( 4)=1
        ksec1( 5)=128        ! 128 section 2 exists
        ksec1( 6)=7
        ksec1( 7)=32
        ksec1( 8)=0
        if(values(9) > 2000.) then
           ksec1( 9)=nint(values(9))-2000
        else
           ksec1( 9)=nint(values(9))-1900
        end if
        ksec1(10)=nint(values(10))
        ksec1(11)=nint(values(11))
        ksec1(12)=nint(values(12))
        ksec1(13)=nint(values(13))
        ksec1(14)=0 
        ksec1(15)=16
        ksec1(16)=0
        ksec1(17)=0
        ksec1(18)=0

        ksec2(1)=52 ! this is required to encode section 2

! define section 2
! initialise key2 variable
        do jj=1,46
          key2(jj)=0
        enddo

        key2(1)=52                 ! Length of section 2
        key2(2)=8                  ! RDB type
        key2(3)=32                 ! RDB subtype
        key2(4)=nint(values(09))    ! Year
        key2(5)=nint(values(10))   ! Month
        key2(6)=nint(values(11))   ! Day
        key2(7)=nint(values(12))   ! Hour
        key2(8)=nint(values(13))   ! Minute
        key2(9)=0                  ! Second

        key2(10)=NINT(lon_observed*100000.+18000000)    ! Longitude 1 location of first storm centre
        key2(11)=NINT(lat_observed*100000.+9000000)     ! Latitude 1 location of first storm centre
        key2(12)=NINT(lon_observed*100000.+18000000)    ! Longitude 2 location of first storm centre
        key2(13)=NINT(lat_observed*100000.+9000000)     ! Latitude 2 location of first storm centre
        key2(14)=subset    ! no of observations/subsets

! identifier	
        key2(16)=ichar(tc_identifier(1:1))           ! first character of short identifier
        key2(17)=ichar(tc_identifier(2:2))           ! second character of short identifier
        key2(18)=ichar(tc_identifier(3:3))           ! third character of short identifier
        key2(19)=32
        key2(20)=32
        key2(21)=32
        key2(22)=32
        key2(23)=32
        key2(24)=32

        ksec3(1)=0
        ksec3(2)=0
        ksec3(3)=subset
        ksec3(4)=0
        if(ksec3(3).gt.1) ksec3(4)=64

        kdlen=1
        kdata(1)=number_of_steps-1   ! first step is pert. anal.
        kbufl=jbufl

! pack rdb key into ksec2 array

        call bupkey(key2,ksec1,ksec2,kerr)

        if(kerr.ne.0) then
          print*,'BUPKEY: error',kerr
          call exit(2)
        end if

! encode

        ierr=0
        call bufren(ksec0,ksec1,ksec2,ksec3,ksec4, &
                    ktdlen,ktdlst,kdlen,kdata,kel, &
                    kvals,values,cvals,kbufl,kbufr,ierr)
        if(ierr > 0) then
           print*,'bufren error ', ierr
           call exit(2)
        elseif(ierr < 0) then
           print*,'Encoding return_code=',ierr
        end if


!          Write bufr message into output file

        ilen=kbufl*4

        call pbwrite(iunit,kbufr,ilen,ierr)
        print*,'length=',ilen,' ierr=',ierr
        print*,'Bufr message written into output file'

 end program tc_tracks

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE JJSET99(TRIGS, IFAX, N, KRET)
C
C---->
C**** JJSET99
C
C     PURPOSE
C     _______
C
C     Computes factors of N & sines and cosines required by FFT99 
C     and FFT991.
C
C     INTERFACE
C     _________
C
C     CALL JJSET99(TRIGS, IFAX, N, KRET))
C
C     Input parameters
C     ________________
C
C     N      - Number to factorise.
C
C     Output parameters
C     ________________
C
C     TRIGS  - Sines and cosines for angles 0 to pi in N steps
C              (sin,cos,sin,cos,...)
C     IFAX   - Allowed factors of N  from 8,6,5,4,3,2.
C              (Only one 8 allowed).
C              IFAX(1)  = count of factors.
C              IFAX(2-9)= factor (or zero).
C              IFAX(10) = N.
C     KRET   - 0 if factorised OK.
C
C     Method
C     ______
C
C     Look for sixes first, store factors in order: 8,6,5,4,3,2;
C     then reverses the order for output.
C
C
C     Externals
C     _________
C
C     INTLOG - Log error messages.
C
C
C     Reference
C     _________
C
C     None.
C
C
C     Comments
C     ________
C
C     This is a tidy up, based on set99.F
C
C
C     AUTHOR
C     ______
C
C     J.D.Chambers      *ECMWF*      Nov 1996
C
C
C     MODIFICATIONS
C     _____________
C
C     None.
C
C----<
C     _______________________________________________________
C
C*    Section 0. Definition of variables.
C     _______________________________________________________
C
C
      IMPLICIT NONE
#include "jparams.h"
#include "parim.h"
C
C     Parameters
      INTEGER JPROUTINE
      PARAMETER ( JPROUTINE = 31500 )
C
C     Subroutine arguments
      REAL TRIGS
      INTEGER IFAX, N, KRET
      DIMENSION TRIGS(N), IFAX(10)
C
C     Local variables
      INTEGER JFAX, LFAX, LOOP, NIL, NHL, NU, I, K, L, IFAC, NFAX
      DIMENSION LFAX(7), JFAX(10)
      DATA LFAX/6,8,5,4,3,2,1/
      REAL DEL, ANGLE
C
C     _______________________________________________________
C
C     Section 1.    Initialization.
C     _______________________________________________________
C
  100 CONTINUE
C
      DO LOOP = 1, 10
        JFAX(LOOP) = 0
      ENDDO
C
      KRET = 0
C
C     Generate sines and cosines for angles 0 to pi in N steps
C
      DEL = (2.0*PPI) / FLOAT(N)
      NIL = 0
      NHL = (N/2)-1
C
      DO K = NIL,NHL
        ANGLE        = FLOAT(K)*DEL
        TRIGS(2*K+1) = COS(ANGLE)
        TRIGS(2*K+2) = SIN(ANGLE)
      ENDDO
C
C     _______________________________________________________
C
C     Section 2.    Find allowed factors of N
C                   (8,6,5,4,3,2; only one 8 allowed)
C     _______________________________________________________
C
  200 CONTINUE
C
C     Look for sixes first, store factors in order: 8,6,5,4,3,2
C
      NU   = N
      IFAC = 6
      K    = 0
      L    = 1
C
C     Loop through potential factors.
C
  220 CONTINUE
C
      IF (MOD(NU,IFAC).EQ.0) THEN
C
C       Allowed factor found
        K       = K+1
C
        IF( K.GT.8) THEN
          CALL INTLOG(JP_ERROR,'Too many factors found factorising ',N)
          KRET = JPROUTINE + 1
          GOTO 910
        ENDIF
C
        JFAX(K) = IFAC
C
C       If factor is 8 ..
        IF (IFAC.EQ.8) THEN
C
C         Swap 8 into first array slot instead of 6 if 6 already found
          IF (K.NE.1) THEN
            JFAX(1) = 8
            JFAX(K) = 6
          ENDIF
        ENDIF
C
C       Factor found
        NU = NU/IFAC
C
C       Exit if all factors of N have been found
        IF (NU.EQ.1) GOTO 900
C
C       Only one 8 allowed as a factor
        IF (IFAC.NE.8) GOTO 220
      ENDIF
C
C     Pick up next allowed factor.
      L    = L+1
      IFAC = LFAX(L)
      IF (IFAC.GT.1) GOTO 220
C
C     Problem! All allowed factors tried but some factors still left.
C
      CALL INTLOG(JP_ERROR,'Illegal factors found factorising ',N)
      KRET = JPROUTINE + 2
      GOTO 910
C     _______________________________________________________
C
C     Section 9.    All factors found.
C     _______________________________________________________
C
  900 CONTINUE
C
C     Store the factors in the reverse order in the output array.
C
      NFAX    = K
      IFAX(1) = NFAX
      DO I = 1,NFAX
        IFAX(NFAX+2-I) = JFAX(I)
      ENDDO
C
      IFAX(10) = N
C
  910 CONTINUE
C
      RETURN
      END

c Copyright 1981-2012 ECMWF.
c
c This software is licensed under the terms of the Apache Licence 
c Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
c
c In applying this licence, ECMWF does not waive the privileges and immunities 
c granted to it by virtue of its status as an intergovernmental organisation 
c nor does it submit to any jurisdiction.
c

      SUBROUTINE FFTRIG(TRIGS,N,MODE)
      DIMENSION TRIGS(N)
      COMMON /QQQQFFT/ IXXX
C
C     MARK INITIALISATION AS 'OLD' TYPE
C
      IXXX=0
C
      PI=2.0*ASIN(1.0)
      IMODE=IABS(MODE)
      NN=N
      IF (IMODE.GT.1.AND.IMODE.LT.6) NN=N/2
      DEL=(PI+PI)/FLOAT(NN)
      L=NN+NN
      DO 10 I=1,L,2
      ANGLE=0.5*FLOAT(I-1)*DEL
      TRIGS(I)=COS(ANGLE)
      TRIGS(I+1)=SIN(ANGLE)
   10 CONTINUE
      IF (IMODE.EQ.1) RETURN
      IF (IMODE.EQ.8) RETURN
      DEL=0.5*DEL
      NH=(NN+1)/2
      L=NH+NH
      LA=NN+NN
      DO 20 I=1,L,2
      ANGLE=0.5*FLOAT(I-1)*DEL
      TRIGS(LA+I)=COS(ANGLE)
      TRIGS(LA+I+1)=SIN(ANGLE)
   20 CONTINUE
      IF (IMODE.LE.3) RETURN
      DEL=0.5*DEL
      LA=LA+NN
      IF (MODE.EQ.5) GO TO 40
      DO 30 I=2,NN
      ANGLE=FLOAT(I-1)*DEL
      TRIGS(LA+I)=2.0*SIN(ANGLE)
   30 CONTINUE
      RETURN
   40 CONTINUE
      DEL=0.5*DEL
      DO 50 I=2,N
      ANGLE=FLOAT(I-1)*DEL
      TRIGS(LA+I)=SIN(ANGLE)
   50 CONTINUE
      RETURN
      END

C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      INTEGER FUNCTION ISCRSZ()
C---->
C**** ISCRSZ
C
C     Purpose
C     -------
C
C     Calculate size of scratch space required for output field of
C     interpolation.
C     
C
C     Interface
C     ---------
C
C     ISIZE = ISCRSZ()
C
C
C     Input
C     -----
C
C     Values in common blocks "nofld.common".
C
C
C     Output
C     ------
C
C     Size as number of values (words).
C     Returns 0 if output type not recognised.
C
C
C     Method
C     ------
C
C     Depends on output grid type.
C
C
C     Externals
C     ---------
C
C     INTLOG  - Log error message
C     JNORSGG - Calculate gaussian latitude
C     NUMPTWE - Calculate number of grid pts in range from west to east
C
C
C     Author
C     ------
C
C     J.D.Chambers     ECMWF     Feb 1995
C
C----<
C
      IMPLICIT NONE
C
#include "parim.h"
#include "nifld.common"
#include "nofld.common"
#include "grfixed.h"
C
C     Local variables
C
      INTEGER LOOP
      REAL PNORTH, PWEST, PSOUTH, PEAST, GRID, TEMP
C
C     Externals
C
      EXTERNAL JNORSGG, NUMPTWE
      INTEGER JNORSGG, NUMPTWE
C
C     Statement functions
C
      REAL X, Y
      LOGICAL SOUTHOF
      SOUTHOF(X,Y) = ((X) - (Y)).GT.-1E-4
C
C     -----------------------------------------------------------------|
C     Section 1.  Initialise.
C     -----------------------------------------------------------------|
C
  100 CONTINUE
C
      ISCRSZ = 0
C
C     -----------------------------------------------------------------|
C*    Section 2.   Spherical harmonic field
C     -----------------------------------------------------------------|
C
  200 CONTINUE
C
      IF( (NOREPR.EQ.JPSPHERE).OR.
     X    (NOREPR.EQ.JPSTRSH).OR.
     X    (NOREPR.EQ.JPSPHROT) ) THEN
cs        ISCRSZ = (NORESO+1) * (NORESO+4)
        ISCRSZ = (NORESO+1) * (NORESO+2)
        CALL INTLOG(JP_DEBUG,'ISCRSZ: spherical harmonic',JPQUIET)
        GOTO 900
      ENDIF
C
C     -----------------------------------------------------------------|
C*    Section 3.   Regular lat/long field
C     -----------------------------------------------------------------|
C
  300 CONTINUE
C
      IF( (NOREPR.EQ.JPREGULAR).OR.(NOREPR.EQ.JPREGROT) ) THEN
C
        TEMP = ABS(FLOAT(NOAREA(1)) - FLOAT(NOAREA(3)))
        NONS  = NINT( TEMP / FLOAT(NOGRID(2)) ) + 1
        TEMP = FLOAT(NOAREA(4)) - FLOAT(NOAREA(2))
        NOWE  =  NINT( TEMP / FLOAT(NOGRID(1)) ) + 1
C
        ISCRSZ = NONS * NOWE
        CALL INTLOG(JP_DEBUG,'ISCRSZ: number of latitudes = ', NONS)
        CALL INTLOG(JP_DEBUG,'ISCRSZ: number of longitudes = ', NOWE)
        CALL INTLOG(JP_DEBUG,'ISCRSZ: Regular lat/long',JPQUIET)
        GOTO 900
      ENDIF
C
C     -----------------------------------------------------------------|
C*    Section 4.   Regular gaussian field
C     -----------------------------------------------------------------|
C
  400 CONTINUE
C
      IF( (NOREPR.EQ.JPGAUSSIAN).OR.(NOREPR.EQ.JPFGGROT) ) THEN
C
        PNORTH = FLOAT( NOAREA(1) ) / PPMULT
        PSOUTH = FLOAT( NOAREA(3) ) / PPMULT
        NO1NS = JNORSGG( PNORTH, ROGAUSS, NOGAUSS, 1)
        NONS  = JNORSGG( PSOUTH, ROGAUSS, NOGAUSS, 1) - NO1NS + 1
        TEMP = FLOAT(NOAREA(4)) - FLOAT(NOAREA(2))
        TEMP = (TEMP * FLOAT(NOGAUSS) ) / FLOAT(JP90)
        NOWE  = NINT(TEMP) + 1
CS added for grib2
        IF(NONS.EQ.NOGAUSS*2.AND.NOAREA(2).EQ.0) THEN
           LGLOBL = .TRUE.
        ENDIF
C
        ISCRSZ = NONS * NOWE
        CALL INTLOG(JP_DEBUG,'ISCRSZ: number of latitudes = ', NONS)
        CALL INTLOG(JP_DEBUG,'ISCRSZ: number of longitudes = ', NOWE)
        CALL INTLOG(JP_DEBUG,'ISCRSZ: regular gaussian',JPQUIET)
        GOTO 900
      ENDIF
C
C     -----------------------------------------------------------------|
C*    Section 5.   Reduced (quasi-regular) gaussian field
C     -----------------------------------------------------------------|
C
  500 CONTINUE
C
      IF( (NOREPR.EQ.JPQUASI).OR.(NOREPR.EQ.JPQGGROT) ) THEN
C
        PNORTH = FLOAT( NOAREA(1) ) / PPMULT
        PWEST  = FLOAT( NOAREA(2) ) / PPMULT
        PSOUTH = FLOAT( NOAREA(3) ) / PPMULT
        PEAST  = FLOAT( NOAREA(4) ) / PPMULT
        NO1NS = JNORSGG( PNORTH, ROGAUSS, NOGAUSS, 1)
        NONS  = JNORSGG( PSOUTH, ROGAUSS, NOGAUSS, 1) - NO1NS + 1
CS added for grib2
        IF(NONS.EQ.NOGAUSS*2.AND.NOAREA(2).EQ.0) THEN
           LGLOBL = .TRUE.
        ENDIF
        NOWE  = 0
C
        NOPCNT = 0
        DO LOOP = 1, NOGAUSS*2
          IF( SOUTHOF(PNORTH,ROGAUSS(LOOP)).AND.
     X        SOUTHOF(ROGAUSS(LOOP),PSOUTH) ) THEN
            GRID = 360.0 / REAL(NOLPTS(LOOP))
            NOPCNT = NOPCNT + NUMPTWE(PWEST,PEAST,GRID)
          ENDIF
        ENDDO
C
        ISCRSZ = NOPCNT
        CALL INTLOG(JP_DEBUG,'ISCRSZ: number of latitudes = ', NONS)
        CALL INTLOG(JP_DEBUG,'ISCRSZ: quasi-regular gaussian',JPQUIET)
        GOTO 900
      ENDIF
C
C     -----------------------------------------------------------------|
C*    Section 9.   Return
C     -----------------------------------------------------------------|
C
  900 CONTINUE
C
      CALL INTLOG(JP_DEBUG,
     X  'ISCRSZ: number of points in output field = ',ISCRSZ)
C
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C


      SUBROUTINE GETLGD (KLGD,OLND,KLEN,KARAY,KPR,KRET)
C
C---->
C     ----------------------------------------------------------------
C
C****
C
C     PURPOSE.
C     --------
C
C           GET LOGICAL DATA FROM RECORD OF UNPACKED GRIB
C           OR PSEUDO-GRIB DATA.
C
C**   INTERFACE.
C     ----------
C
C           CALL GETLGD (KLGD,OLND,KLEN,KARAY,KPR,KRET)
C
C           INTEGER    K.
C           REAL       P.
C           LOGICAL    O.
C           CHARACTER  H.
C
C               INPUT PARAMETERS.
C               -----------------
C
C               OLND       - ARRAY TO RECEIVE LOGICAL DATA.
C               KLEN       - LENGTH OF THIS ARRAY.
C               KARAY      - ARRAY CONTAINING UNPACKED RECORD.
C               KPR        - DEBUG PRINT SWITCH.
C                            0 , NO PRINTOUT.
C                            1 , DEBUG PRINTOUT.
C
C               KRET       - ABORT/NO ABORT WHEN ERROR FOUND.
C                            0   , ABORT IF ERROR FOUND.
C                            NON-ZERO , NO ABORT ON ERROR.
C
C               OUTPUT PARAMETERS.
C               ------------------
C
C               KRET       - ERROR RETURN CODE.
C                            0   , NO ERROR ENCOUNTERED.
C                            1   , TARGET ARRAY TOO SMALL.
C               OLND       - LOGICAL DATA.
C               KLGD       - NUMBER OF VALUES IN THIS ARRAY.
C
C     METHOD.
C     -------
C
C           UNPACKED DATA IS IN SELF-DEFINING RECORDS. THE REQUIRED
C           VALUES ARE LOCATED AND EXTRACTED.
C
C     EXTERNALS.
C     ----------
C
C           NONE.
C
C     REFERENCE.
C     ----------
C
C           SEE MARS FORMAT DOCUMENTATION RE GRIB, PSEUDO-GRIB AND
C           UNPACKED RECORD FORMATS.
C
C     COMMENTS.
C     ---------
C
C           PROGRAM CONTAINS SECTIONS 0 TO 2 AND SECTION 9.
C
C     AUTHOR.
C     -------
C
C           J. HENNESSY      ECMWF      18:06:86.
C
C     MODIFICATIONS
C     --------------
C           NONE.
C
C     ----------------------------------------------------------------
C----<
C
C
C
C
C
C
C
C
C
C
C*    SECTION 0 . DEFINITION OF VARIABLES.
C     ------------------------------------
C
      IMPLICIT LOGICAL     ( L, O, G )
      IMPLICIT CHARACTER*8 ( C, H, Y )
      IMPLICIT INTEGER     ( I, J, K, M, N )
C
      DIMENSION KARAY(*)
      DIMENSION OLND(KLEN)
C
C     ----------------------------------------------------------------
C
C
C
C
C
C
C
C
C
C*    SECTION 1 . SET INITIAL VALUES. CHECK INPUT PARAMETERS.
C     -------------------------------------------------------
C
 1000 CONTINUE
C
      IF (KPR.EQ.1) WRITE (*,*) 'GETLGD : SECTION 1.'
C
      IRET = KRET
      KRET = 0
C
C
C*    GO TO SECTION 9 , IF ERROR IN PARAMETERS.
C
      IF (KRET.NE.0) GO TO 9000
C
C     ----------------------------------------------------------------
C
C
C
C
C
C
C
C
C
C*    SECTION 2 . LOCATE AND EXTRACT VALUES.
C     --------------------------------------
C
 2000 CONTINUE
C
      IF (KPR.EQ.1) WRITE (*,*) 'GETLGD : SECTION 2.'
C
      ILB1 = KARAY(2)
      ILB2 = KARAY(2+ILB1+1)
      ILF2 = KARAY(2+ILB1+1+ILB2+1)
      ILB3 = KARAY(2+ILB1+1+ILB2+1+ILF2+1)
      ILCD = KARAY(2+ILB1+1+ILB2+1+ILF2+1+ILB3+1)
      ILFD = KARAY(2+ILB1+1+ILB2+1+ILF2+1+ILB3+1+ILCD+1)
      ILID = KARAY(2+ILB1+1+ILB2+1+ILF2+1+ILB3+1+ILCD+1+ILFD+1)
      KLGD = KARAY(2+ILB1+1+ILB2+1+ILF2+1+ILB3+1+ILCD+1+ILFD+1+ILID+1)
C
      IF (KLEN.LT.KLGD)
     C   THEN
             KRET = 1
             WRITE (*,9001) KRET , KLGD
             GO TO 9000
         ENDIF
C
      DO 2010 J=1,KLGD
         IVAL    = KARAY(J+2+ILB1+1+ILB2+1+ILF2+1+ILB3+1+ILCD+1+ILFD+1
     C                    +KLGD+1)
         OLND(J) = .FALSE.
         IF (IVAL.EQ.1) OLND(J) = .TRUE.
 2010 CONTINUE
C
C
C     ----------------------------------------------------------------
C
C
C
C
C
C
C
C*    SECTION 9 . RETURN TO CALLING ROUTINE OR ABORT. FORMAT STATEMENTS.
C     ------------------------------------------------------------------
C
 9000 CONTINUE
C
      IF (KPR.EQ.1) WRITE (*,*) 'GETLGD : SECTION 9.'
C
      IF (KRET.NE.0.AND.IRET.EQ.0) CALL ABORT
C
      RETURN
C
C
 9001 FORMAT (1H ,'GETLGD : ERROR CODE = ',I3,'. TARGET ARRAY MUST ',
     C            'BE AT LEAST ',I5,' WORDS LONG.')
C
C
C     ---------------------------------------------------------------
C
C
      END
C

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE JMOVLL( PZFA, PNORTH, PWEST, PLATINC, PLONINC, PSTART,
     X                   KROWS, KCOLS, KLON, KJPWR, POUTF, KFLAG)
C
C---->
C**** JMOVLL
C
C     Purpose
C     _______
C
C     This routine moves grid point data from array PZFA to array POUTF.
C
C
C     Interface
C     _________
C
C     CALL JMOVLL( PZFA, PNORTH, PWEST,PLATINC, PLONINC, PSTART, 
C    X             KROWS, KCOLS, KLON, KJPWR, POUTF, KFLAG)
C
C
C     Input parameters
C     ________________
C
C     PZFA      -  Input array of grid points arranged in pairs of
C                  north and south latitude bands
C     PNORTH    -  Northernmost latitude for field in POUTF (degrees)
C     PWEST     -  Westernmost longitude for field in POUTF (degrees)
C     PLATINC   -  Grid interval between latitudes in degrees in POUTF
C     PLONINC   -  Grid interval between longitudes in degrees in POUTF
C     PSTART    -  Current first latitude in PZFA for moving (degrees)
C     KROWS     -  Number of latitude rows to store
C     KCOLS     -  Number of longitude points to store from latitude
C     KLON      -  Number of longitude points in generated latitude row
C     KJPWR     -  Multiplication factor applied to ensure that number
C                  of longitude points > twice*spherical truncation
C     KFLAG     -  = 1 if only the North hemisphere lats. to be moved
C                  = 2 if only the South hemisphere lats. to be moved
C                  = 3 if both North/South hemisphere lats. to be moved
C
C
C     Output parameters
C     ________________
C
C     POUTF      - output array of grid points
C
C
C     Common block usage
C     __________________
C
C     JDCNDBG
C
C
C     Method
C     ______
C
C     Moves latitude rows of points from PZFA into the correct 
C     geographical positions in POUTF.  POUTF may already be 
C     partially full.  The distribution is symmetrical north-south.
C
C
C     Externals
C     _________
C
C     INTLOG   - Logs messages
C     INTLOGR  - Logs messages with real value.
C
C
C     Reference
C     _________
C
C
C     E.C.M.W.F. Research Department technical memorandum no. 56
C                "The forecast and analysis post-processing package"
C                May 1982. J.Haseler.
C
C
C     Comments
C     ________
C
C     POUTF is a 2-dimensional array, with first dimension = KCOLS.
C
C     For calculation purposes, the number of longitude points
C     has to be greater than 2*(output truncation) to ensure that the
C     fourier transform is exact (see Reference, page 10). 
C     Parameter JPLONO is set to 860 to ensure that PZFA will have
C     enough slots for the KLON points for all values of regular
C     grid intervals from N1 to N720.
C
C     When filling the output array POUTF, the longitude points have
C     have to be taken selectively to avoid the intermediate generated
C     points, picking up values only at the required longitudes.  The
C     magnification factor is KJPWR (a power of 2).
C
C     PZFA has values stored:
C       North lat1:  x, 1, x, 2, x, 3, x, ... , KLON, ...
C       South lat1:  x, 1, x, 2, x, 3, x, ... , KLON, ...
C       North lat2:  x, 1, x, 2, x, 3, x, ... , KLON, ...
C       South lat2:  x, 1, x, 2, x, 3, x, ... , KLON, ...
C       ... for KROWS latitudes.
C
C     The 'x' represents the extra values generated because of the
C     need for the number of points along a latitude line to be more
C     than twice the truncation of the spherical harmonics.
C
C
C     Author
C     ______
C
C     J.D.Chambers      ECMWF      Nov 1993
C
C
C     Modifications
C     _____________
C
C     None
C
C----<
C
      IMPLICIT NONE
C     _______________________________________________________
C
C*    Section 0. Definition of variables.
C     _______________________________________________________
C
#include "jparams.h"
#include "parim.h"
C
C     Subroutine arguments
C
      INTEGER KROWS, KCOLS, KLON, KJPWR, KFLAG
      REAL PZFA, PNORTH, PWEST, PLATINC, PLONINC, PSTART, POUTF
      DIMENSION PZFA( JPLONO+2, 64), POUTF(KCOLS,*)
C
C     Parameters
      INTEGER JPROUTINE
      PARAMETER( JPROUTINE = 31900 )
C
C     Local variables
C
      INTEGER IOFFN, IOFFS, LOOPRW, LOOPCL, NEXT
      INTEGER LONGIT, N360, NSTART
C
C     _______________________________________________________
C
C
C*    Section 1. Initialization
C     _______________________________________________________
C
  100 CONTINUE

      IF ( NDBG .GT. 1) THEN
        CALL INTLOG(JP_DEBUG,'JMOVLL - Input parameters:',JPQUIET)
        CALL INTLOGR(JP_DEBUG,
     X    'JMOVLL - Northern latitude for output = ', PNORTH)
        CALL INTLOGR(JP_DEBUG,
     X    'JMOVLL - Western longitude for output = ', PWEST)
        CALL INTLOGR(JP_DEBUG,
     X    'JMOVLL -  Latitude grid interval (deg) = ', PLATINC)
        CALL INTLOGR(JP_DEBUG,
     X    'JMOVLL - Longitude grid interval (deg) = ', PLONINC)
        CALL INTLOGR(JP_DEBUG,
     X    'JMOVLL - First latitude for moving = ', PSTART)
        CALL INTLOG(JP_DEBUG,
     X    'JMOVLL - Number of latitudes to store = ', KROWS)
        CALL INTLOG(JP_DEBUG,
     X    'JMOVLL - Number of longitude pts per row = ', KCOLS)
        CALL INTLOG(JP_DEBUG,
     X    'JMOVLL - No. long.pts per generated row = ', KLON)
        CALL INTLOG(JP_DEBUG,
     X    'JMOVLL - Multiplication factor applied = ', KJPWR)
        CALL INTLOG(JP_DEBUG,
     X    'JMOVLL - Move hemisphere(1=N,2=S,3=both) = ', KFLAG)
C
      ENDIF
C
C     Find start offset in storage array
      IOFFN  = NINT( (PNORTH - PSTART)/PLATINC ) + 1
      IOFFS  = NINT( (PNORTH + PSTART)/PLATINC ) + 2
      LONGIT = NINT( (360.0 + PWEST)/PLONINC )
      N360 = NINT( 360.0/PLONINC )
      NSTART = MOD( LONGIT, N360)*KJPWR
      IF ( NDBG .GT. 1) THEN
        CALL INTLOG(JP_DEBUG,
     X    'JMOVLL - Offset in storage array(north) = ', IOFFN)
        CALL INTLOG(JP_DEBUG,
     X    'JMOVLL - Offset in storage array(south) = ', IOFFS)
        CALL INTLOG(JP_DEBUG,
     X    'JMOVLL - Start longitude = ', LONGIT)
        CALL INTLOG(JP_DEBUG,
     X    'JMOVLL - Modulus for longitude 360deg. = ', N360)
        CALL INTLOG(JP_DEBUG,
     X    'JMOVLL - Start point index = ', NSTART)
      ENDIF
C     _______________________________________________________
C
C
C*    Section 2. Store the points for northern latitudes, southern 
C*               latitudes or both.
C     _______________________________________________________
C
 200  CONTINUE
C
C     Store Northern latitudes ..
C     .. skipping intermediate values - see calculation of NEXT below
C
      IF ( KFLAG .NE. 2 ) THEN
C
        IF ( NDBG .GT. 1) CALL INTLOG(JP_DEBUG,
     X    'JMOVLL - Storing North latitudes',JPQUIET)
C
        DO 222 LOOPRW = 1, KROWS*2, 2
          DO 220 LOOPCL = 1, KCOLS
            NEXT = 2 + MOD( NSTART + (LOOPCL-1)*KJPWR , KLON)
            POUTF( LOOPCL, IOFFN + LOOPRW/2 ) = PZFA( NEXT, LOOPRW)
 220      CONTINUE
 222    CONTINUE
      ENDIF
C
C     Store Southern latitudes ..
C     .. skipping intermediate values - see calculation of NEXT below
C
      IF ( KFLAG .NE. 1 ) THEN
C
        IF ( NDBG .GT. 1) CALL INTLOG(JP_DEBUG,
     X    'JMOVLL - Storing South latitudes',JPQUIET)
C
        DO  242 LOOPRW = 2, KROWS*2, 2
          DO 240 LOOPCL = 1, KCOLS
            NEXT = 2 + MOD( NSTART + (LOOPCL-1)*KJPWR , KLON)
            POUTF( LOOPCL, IOFFS - LOOPRW/2 ) = PZFA( NEXT, LOOPRW)
 240      CONTINUE
 242    CONTINUE
C
      ENDIF
C
C     _______________________________________________________
C
C
C*    Section 9. Return to calling routine. Format statements
C     _______________________________________________________
C
  900 CONTINUE
C
C
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities
C granted to it by virtue of its status as an intergovernmental organisation
C nor does it submit to any jurisdiction.
C

      PROGRAM TEST_INTERPOLATION
      IMPLICIT NONE


C     Parameters
      INTEGER JPGRIB                 ! GRIB size
C     PARAMETER (JPGRIB =  2000000)
C     PARAMETER (JPGRIB =  4284076)  ! for R640/O640 output
C     PARAMETER (JPGRIB =  7000000)  ! for INTUVP2 (requires 2 fields)
      PARAMETER (JPGRIB = 33190420)  ! for R1280/O1280 = 1/16 deg (INTUVP2 not tested)
      INTEGER JPBYTES                ! bytes/integer (8 on 64-bit architecture)
#ifdef INTEGER_8
      PARAMETER (JPBYTES = 8)
#else
      PARAMETER (JPBYTES = 4)
#endif
      LOGICAL IN, OUT
      PARAMETER (IN=.TRUE., OUT=.FALSE.)


C     Locals
      INTEGER R, I
      INTEGER IO ! 0:?, 1:INTIN, 2: INTOUT
      CHARACTER*256 ARG, KEY, VAL, F1, F2
      CHARACTER*1 N
      PARAMETER (N = CHAR(10))


C     Internals & externals
      LOGICAL SPLITARGS
      INTEGER WRAP_INT, WRAP_INTF2, WRAP_INTUVP2, WRAP_INTVECT2
      INTEGER IARGC


C     Initialize
      R = 0
      F1 = ''
      F2 = '/dev/null'


C     Process command line, in order
      DO I = 1, IARGC()
        CALL GETARG(I,ARG)
        R = -1
        IO = 0
        IF (SPLITARGS(ARG,IO,KEY,VAL)) THEN

          IF (IO.EQ.0) THEN
            IF (KEY.EQ.'input')    F1 = VAL
            IF (KEY.EQ.'output')   F2 = VAL
            IF (KEY.EQ.'input' .OR. KEY.EQ.'output') R=0
            IF (KEY.EQ.'intf2')    R=WRAP_INTF2   (F1,F2,JPGRIB,JPBYTES)
            IF (KEY.EQ.'intuvp2')  R=WRAP_INTUVP2 (F1,F2,JPGRIB,JPBYTES)
            IF (KEY.EQ.'intvect2') R=WRAP_INTVECT2(F1,F2,JPGRIB,JPBYTES)
          ELSEIF (IO.EQ.1) THEN
            IF (KEY.EQ.'accuracy')        R=WRAP_INT(IN, KEY,VAL,1,0)
            IF (KEY.EQ.'area')            R=WRAP_INT(IN, KEY,VAL,0,4)
            IF (KEY.EQ.'date')            R=WRAP_INT(IN, KEY,VAL,1,0)
            IF (KEY.EQ.'form')            R=WRAP_INT(IN, KEY,VAL,0,0)
            IF (KEY.EQ.'grid')            R=WRAP_INT(IN, KEY,VAL,0,2)
            IF (KEY.EQ.'gridname')        R=WRAP_INT(IN, KEY,VAL,0,0)
            IF (KEY.EQ.'level')           R=WRAP_INT(IN, KEY,VAL,1,0)
            IF (KEY.EQ.'local')           R=WRAP_INT(IN, KEY,VAL,1,0)
            IF (KEY.EQ.'lsm_param')       R=WRAP_INT(IN, KEY,VAL,0,0)
            IF (KEY.EQ.'lsmset')          R=WRAP_INT(IN, KEY,VAL,0,0)
            IF (KEY.EQ.'matrix')          R=WRAP_INT(IN, KEY,VAL,1,0)
            IF (KEY.EQ.'npts')            R=WRAP_INT(IN, KEY,VAL,2,0)
            IF (KEY.EQ.'parameter')       R=WRAP_INT(IN, KEY,VAL,1,0)
            IF (KEY.EQ.'reduced')         R=WRAP_INT(IN, KEY,VAL,1,0)
            IF (KEY.EQ.'regular')         R=WRAP_INT(IN, KEY,VAL,1,0)
            IF (KEY.EQ.'scan')            R=WRAP_INT(IN, KEY,VAL,1,0)
            IF (KEY.EQ.'table')           R=WRAP_INT(IN, KEY,VAL,1,0)
            IF (KEY.EQ.'truncation')      R=WRAP_INT(IN, KEY,VAL,1,0)
            IF (KEY.EQ.'uselsm')          R=WRAP_INT(IN, KEY,VAL,0,0)
            IF (KEY.EQ.'useprecip')       R=WRAP_INT(IN, KEY,VAL,0,0)
            IF (KEY.EQ.'usewind')         R=WRAP_INT(IN, KEY,VAL,0,0)
            IF (KEY.EQ.'user_reduced_gaussian'.OR.
     .          KEY.EQ.'user_regular_gaussian')
     .        R=WRAP_INT(IN, KEY,VAL,1,0)
          ELSEIF (IO.EQ.2) THEN
            IF (KEY.EQ.'12-point')        R=WRAP_INT(OUT,KEY,VAL,0,0)
            IF (KEY.EQ.'accuracy')        R=WRAP_INT(OUT,KEY,VAL,1,0)
            IF (KEY.EQ.'area')            R=WRAP_INT(OUT,KEY,VAL,0,4)
            IF (KEY.EQ.'autoresol')       R=WRAP_INT(OUT,KEY,VAL,1,0)
            IF (KEY.EQ.'bitmap')          R=WRAP_INT(OUT,KEY,VAL,0,0)
            IF (KEY.EQ.'form')            R=WRAP_INT(OUT,KEY,VAL,0,0)
            IF (KEY.EQ.'frame')           R=WRAP_INT(OUT,KEY,VAL,1,0)
            IF (KEY.EQ.'gauss_from_file') R=WRAP_INT(OUT,KEY,VAL,0,0)
            IF (KEY.EQ.'gaussian')        R=WRAP_INT(OUT,KEY,VAL,1,0)
            IF (KEY.EQ.'grid')            R=WRAP_INT(OUT,KEY,VAL,0,2)
            IF (KEY.EQ.'gridname')        R=WRAP_INT(OUT,KEY,VAL,0,0)
            IF (KEY.EQ.'interpolation')   R=WRAP_INT(OUT,KEY,VAL,0,0)
            IF (KEY.EQ.'level')           R=WRAP_INT(OUT,KEY,VAL,1,0)
            IF (KEY.EQ.'levtype')         R=WRAP_INT(OUT,KEY,VAL,1,0)
            IF (KEY.EQ.'packing')         R=WRAP_INT(OUT,KEY,VAL,0,0)
            IF (KEY.EQ.'parameter')       R=WRAP_INT(OUT,KEY,VAL,1,0)
            IF (KEY.EQ.'red_latlon')      R=WRAP_INT(OUT,KEY,VAL,0,2)
            IF (KEY.EQ.'reduced')         R=WRAP_INT(OUT,KEY,VAL,1,0)
            IF (KEY.EQ.'regular')         R=WRAP_INT(OUT,KEY,VAL,1,0)
            IF (KEY.EQ.'rotation')        R=WRAP_INT(OUT,KEY,VAL,0,2)
            IF (KEY.EQ.'scan')            R=WRAP_INT(OUT,KEY,VAL,1,0)
            IF (KEY.EQ.'specification')   R=WRAP_INT(OUT,KEY,VAL,1,0)
            IF (KEY.EQ.'style')           R=WRAP_INT(OUT,KEY,VAL,0,0)
            IF (KEY.EQ.'table')           R=WRAP_INT(OUT,KEY,VAL,1,0)
            IF (KEY.EQ.'truncation')      R=WRAP_INT(OUT,KEY,VAL,1,0)
            IF (KEY.EQ.'intermediate_gaussian'.OR.
     .          KEY.EQ.'user_reduced_gaussian'.OR.
     .          KEY.EQ.'user_reduced_latlon'  .OR.
     .          KEY.EQ.'user_regular_gaussian')
     .        R=WRAP_INT(OUT,KEY,VAL,1,0)
          ENDIF

        ENDIF
        IF (R.NE.0) THEN
          PRINT *, 'Problem with option "'//ARG(1:INDEX(ARG,' ')-1)//'"'
          PRINT *, '  key:   "'//KEY(1:INDEX(KEY,' ')-1)//'"'
          PRINT *, '  value: "'//VAL(1:INDEX(VAL,' ')-1)//'"'
          CALL EXIT(1)
        ENDIF
      ENDDO

      IF (F1(1:1).EQ.' ' .OR. F2(1:1).EQ.' ') THEN
  666     PRINT *,N
     .//'Usage: int --input=1.grib --output=2.grib [options] ...'//N
     .//'where in/output files and interpolation fn. are mandatory:'//N
     .//'  --input=C    input file'//N
     .//'  --output=C   output file (default: /dev/null)'//N
     .//'  --intf2:     general/MARS interpolation'//N
     .//'               (allows multiple GRIB input)'//N
     .//'  --intuvp2:   u/v fields interpolation'//N
     .//'               (requires vo/d or u/v pair on GRIB input)'//N
     .//'  --intvect2:  u/v fields interpolation'//N
     .//'               (requires u/v pair on GRIB input)'//N
     .//N
     .//'and any of the INTIN/OUT options, interpreted in order'//N
     .//'(some combinations are inconsistent):'//N
     .//'  --INTIN:truncation=I:   SH truncation (input)'//N
     .//'  --INTOUT:12-point=C:    12-point bilinear int. ([yes|no])'//N
     .//'  --INTOUT:accuracy=I:    pck. accuracy ([16|24|...)'//N
     .//'  --INTOUT:area=R/R/R/R:  geographical area (N/W/S/E)'//N
     .//'  --INTOUT:autoresol=I:   SH auto truncation on/off ([1|0])'//N
     .//'  --INTOUT:grid=R/R:          regular lat-lon, or'//N
     .//'  --INTOUT:gridname=[F|N|O]I: specific grid, with:'//N
     .//'      F: regular Gaussian'//N
     .//'      N: reduced Gaussian/"quasi-regular"'//N
     .//'      O: reduced Gaussian/"octahedral"'//N
     .//'      I: points between equator and poles (N)'//N
     .//'  --INTOUT:interpolation=C: interpol. method (ref. code)'//N
     .//'  --INTOUT:packing=C:     pck. method ([second|simple|...])'//N
     .//'  --INTOUT:reduced=I:     reduced Gaussian grid (alternate)'//N
     .//'  --INTOUT:regular=I:     regular Gaussian grid (alternate)'//N
     .//'  --INTOUT:rotation=R/R:  South pole new position (lat/lon)'//N
     .//'  --INTOUT:style=C:       style ([dissemination|...])'//N
     .//'  --INTOUT:truncation=I:  SH truncation (output)'//N
     .//N
     .//'with the following abbreviations:'//N
     .//'  I: integer number'//N
     .//'  R: real number'//N
     .//'  C: text string'//N
        STOP
      ENDIF


      STOP
      ENDPROGRAM


C     ------------------------------------------------------------------
      LOGICAL FUNCTION SPLITARGS(ARG,IN,KEY,VAL)
      IMPLICIT NONE
      CHARACTER*256 ARG, KEY, VAL
      INTEGER IN

      IN  = 0
      KEY = ''
      VAL = ''
      IF (ARG(1:2).EQ.'--') THEN 
        KEY = ARG(3:)
        IF (INDEX(ARG,'=').GT.3) VAL = ARG(INDEX(ARG,'=')+1:)
        IF (INDEX(ARG,'=').GT.3) KEY = ARG(3:INDEX(ARG,'=')-1)
      ENDIF
      IF (KEY(1:6).EQ.'INTIN:') THEN
        IN  = 1
        KEY = KEY(7:)
      ELSEIF (KEY(1:7).EQ.'INTOUT:') THEN
        IN  = 2
        KEY = KEY(8:)
      ENDIF
      SPLITARGS = (INDEX(KEY,' ').GT.1)
      ENDFUNCTION


C     ------------------------------------------------------------------
      INTEGER FUNCTION WRAP_INT(IN,K,C,NI,NR)
      IMPLICIT NONE
      LOGICAL IN
      CHARACTER*256 K, C
      INTEGER NI, NR

      CHARACTER*256 M
      INTEGER I(4)
      REAL R(4)

      INTEGER INTIN, INTOUT
      EXTERNAL INTIN, INTOUT

      I = 0
      R = 0.
      IF (IN) THEN
        M = 'intin'
      ELSE
        M = 'intout'
      ENDIF
      M = M(1:INDEX(M,' ')-1)//'("'//K(1:INDEX(K,' ')-1)//'")'
      IF (NI.LT.0 .OR. NI.GT.4) NI = 0
      IF (NR.LT.0 .OR. NR.GT.4) NR = 0
      IF (NI.GE.1) THEN
        DO WHILE (INDEX(C,'/').GT.0)
          C(INDEX(C,'/'):INDEX(C,'/')) = ' '
        ENDDO
        READ (C,*) I(1:NI)
        C = ''
        PRINT *, M(1:INDEX(M,' ')-1), I(1:NI)
      ELSEIF (NR.GE.1) THEN
        DO WHILE (INDEX(C,'/').GT.0)
          C(INDEX(C,'/'):INDEX(C,'/')) = ' '
        ENDDO
        READ (C,*) R(1:NR)
        C = ''
        PRINT *, M(1:INDEX(M,' ')-1), R(1:NR)
      ELSE
        PRINT *, M(1:INDEX(M,' ')-1), ' "'//C(1:INDEX(C,' ')-1)//'"'
      ENDIF
      IF (IN) THEN
        WRAP_INT = INTIN (K,I,R,C)
      ELSE
        WRAP_INT = INTOUT(K,I,R,C)
      ENDIF
      IF (WRAP_INT.NE.0) PRINT *, M(1:INDEX(M,' ')-1)//' failed.'
      ENDFUNCTION


C     ------------------------------------------------------------------
      INTEGER FUNCTION WRAP_INTF2(INFILE,OUTFILE,LENGRIB,LENBYTES)
      IMPLICIT NONE
      CHARACTER*256 INFILE, OUTFILE
      INTEGER LENGRIB, LENBYTES

      INTEGER INGRIB(LENGRIB), NEWFLD(LENGRIB)
      INTEGER U1, U2, N, LENINT, IREC, IRET

      INTEGER INTF2
      EXTERNAL INTF2

C     Initialize
      INGRIB = 0
      NEWFLD = 0
      CALL EXCEPT()

C     Open input and output files
      IRET = 0
      CALL PBOPEN(U1, INFILE, 'r', IRET)
      CALL CHECK(IRET.NE.0, 'PBOPEN failed (r).')
      CALL PBOPEN(U2, OUTFILE, 'w', IRET)
      CALL CHECK(IRET.NE.0, 'PBOPEN failed (w).')

C     Start of loop on input fields
      N = 0
  120 CONTINUE
      N = N + 1

C     Read next field
      CALL PBGRIB(U1, INGRIB, LENGRIB*LENBYTES, IREC, IRET)
      IF (IRET.EQ.-1) THEN
        IRET = 0
        GOTO 190
      ENDIF
      CALL CHECK(IRET.NE.0, 'PBGRIB failed.')

C     Interpolate
      PRINT *, 'Interpolate field #', N
      LENINT = LENGRIB
      IRET = INTF2(INGRIB,IREC,NEWFLD,LENINT)
      CALL CHECK(IRET.NE.0, 'INTF2 failed')

C     Write the new field to file
      IF (LENINT.GT.0) THEN
        CALL PBWRITE(U2, NEWFLD, LENINT, IRET)
      ELSE
        PRINT *, 'Output same as input'
        CALL PBWRITE(U2, INGRIB, IREC, IRET)
      ENDIF
      CALL CHECK(IRET.LT.0, 'PBWRITE failed')
      IRET = 0

C     Loop back for next field
      IF (IRET.EQ.0) GOTO 120

C     Closedown
  190 CONTINUE
      WRAP_INTF2 = IRET
      CALL PBCLOSE(U1, IRET)
      CALL PBCLOSE(U2, IRET)
      PRINT *, 'All done.'
      ENDFUNCTION


C     ------------------------------------------------------------------
      INTEGER FUNCTION WRAP_INTUVP2(INFILE,OUTFILE,LENGRIB,LENBYTES)
      IMPLICIT NONE
      CHARACTER*256 INFILE, OUTFILE
      INTEGER LENGRIB, LENBYTES

      INTEGER IVOGRIB(LENGRIB), IDVGRIB(LENGRIB)
      INTEGER IUGRIB(LENGRIB), IVGRIB(LENGRIB)
      INTEGER U1, U2, N, LENINT, IREC, IRET

      INTEGER INTUVP2
      EXTERNAL INTUVP2

C     Open input and output files
      CALL PBOPEN(U1, INFILE, 'r', IRET)
      CALL CHECK(IRET.NE.0, 'PBOPEN failed (r).')
      CALL PBOPEN(U2, OUTFILE, 'w', IRET)
      CALL CHECK(IRET.NE.0, 'PBOPEN failed (w).')

C     Start of loop on input vo/d fields
      N = 0
  220 CONTINUE
      N = N + 1

C     Read next vo/d
      CALL PBGRIB(U1, IVOGRIB, LENGRIB*LENBYTES, IREC, IRET)
      IF (IRET.EQ.-1) THEN
        IRET = 0
        GOTO 290
      ENDIF
      CALL CHECK(IRET.NE.0, 'PBGRIB failed (vo).')
      CALL PBGRIB(U1, IDVGRIB, LENGRIB*LENBYTES, IREC, IRET)
      IF (IRET.EQ.-1) THEN
        IRET = 0
        GOTO 290
      ENDIF
      CALL CHECK(IRET.NE.0, 'PBGRIB failed (d).')

C     Interpolate
      PRINT *, 'Interpolate vo/d > u/v #', N
      LENINT = LENGRIB
      IRET = INTUVP2(IVOGRIB, IDVGRIB, LENGRIB, IUGRIB, IVGRIB, LENINT)
      CALL CHECK(IRET.NE.0, 'INTUVP2 failed.')

C     Write the new u/v fields to file
      IF (LENINT.GT.0) THEN
        CALL PBWRITE(U2, IUGRIB, LENINT, IRET)
        CALL CHECK(IRET.LT.LENINT, 'PBWRITE failed.')
        CALL PBWRITE(U2, IVGRIB, LENINT, IRET)
        CALL CHECK(IRET.LT.LENINT, 'PBWRITE failed.')
        IRET = 0
      ENDIF

C     Loop back for next field
      IF (IRET.EQ.0) GOTO 220

C     Closedown
  290 CONTINUE
      WRAP_INTUVP2 = IRET
      CALL PBCLOSE(U1, IRET)
      CALL PBCLOSE(U2, IRET)
      PRINT *, 'All done.'
      ENDFUNCTION


C     ------------------------------------------------------------------
      INTEGER FUNCTION WRAP_INTVECT2(INFILE,OUTFILE,LENGRIB,LENBYTES)
      IMPLICIT NONE
      CHARACTER*256 INFILE, OUTFILE
      INTEGER LENGRIB, LENBYTES

      INTEGER IIAGRIB(LENGRIB), IIBGRIB(LENGRIB)
      INTEGER IOAGRIB(LENGRIB), IOBGRIB(LENGRIB)
      INTEGER U1, U2, N, LENINT, IREC, IRET

      INTEGER INTVECT2
      EXTERNAL INTVECT2

C     Open input and output files
      CALL PBOPEN(U1, INFILE, 'r', IRET)
      CALL CHECK(IRET.NE.0, 'PBOPEN failed (r).')
      CALL PBOPEN(U2, OUTFILE, 'w', IRET)
      CALL CHECK(IRET.NE.0, 'PBOPEN failed (w).')

C     Start of loop on input u/v fields
      N = 0
  220 CONTINUE
      N = N + 1

C     Read next u/v
      CALL PBGRIB(U1, IIAGRIB, LENGRIB*LENBYTES, IREC, IRET)
      IF (IRET.EQ.-1) THEN
        IRET = 0
        GOTO 290
      ENDIF
      CALL CHECK(IRET.NE.0, 'PBGRIB failed (u).')
      CALL PBGRIB(U1, IIBGRIB, LENGRIB*LENBYTES, IREC, IRET)
      IF (IRET.EQ.-1) THEN
        IRET = 0
        GOTO 290
      ENDIF
      CALL CHECK(IRET.NE.0, 'PBGRIB failed (v).')

C     Interpolate
      PRINT *, 'Interpolate u/v #', N
      LENINT = LENGRIB
      IRET = INTVECT2(IIAGRIB,IIBGRIB,LENGRIB,IOAGRIB,IOBGRIB,LENINT)
      CALL CHECK(IRET.NE.0, 'INTVECT2 failed.')

C     Write the new u/v fields to file
      IF (LENINT.GT.0) THEN
        CALL PBWRITE(U2, IOAGRIB, LENINT, IRET)
        CALL CHECK(IRET.LT.LENINT, 'PBWRITE failed.')
        CALL PBWRITE(U2, IOBGRIB, LENINT, IRET)
        CALL CHECK(IRET.LT.LENINT, 'PBWRITE failed.')
        IRET = 0
      ENDIF

C     Loop back for next field
      IF (IRET.EQ.0) GOTO 220

C     Closedown
  290 CONTINUE
      WRAP_INTVECT2 = IRET
      CALL PBCLOSE(U1, IRET)
      CALL PBCLOSE(U2, IRET)
      PRINT *, 'All done.'
      ENDFUNCTION


C     ------------------------------------------------------------------
      SUBROUTINE CHECK(OOPS,MSG)
      IMPLICIT NONE
      LOGICAL OOPS
      CHARACTER MSG*(*)
      IF (OOPS) THEN
        PRINT *, MSG(1:INDEX(MSG,' ')-1)
        CALL EXIT(3)
      ENDIF
      ENDSUBROUTINE

C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE ECDEF4( HFUNC, KSEC1, KGRIB, KLENG, KNSPT, KBITS,
     X                   KPLEN, KPR, KRET)
C
C---->
C**** ECDEF4
C
C     Purpose.
C     --------
C
C     GRIB coding/decoding of ECMWF local use of definition 4.
C     (Ocean extensions).
C
C**   Interface.
C     ----------
C
C    CALL ECDEF4( HFUNC, KSEC1, KGRIB, KLENG, KNSPT, KBITS, KPLEN, KPR, KRET)
C
C     Input Parameters.
C     -----------------
C
C     HFUNC      - Requested function.
C                  'C' to code data.
C                  'D' to decode data.
C
C     KSEC1      - Array containing Grib Section 1 data.
C
C     KGRIB      - Array containing Grib coded data.
C
C     KLENG      - Length (words) of KGRIB.
C
C     KNSPT      - Bit number after which insertion/extraction starts.
C
C     KBITS      - Number of bits in computer word.
C
C     KPLEN      - Pointer to field containing length of Section 1.
C
C     KPR        - Debug print switch.
C                  0  , No printout.
C                  >0 , Debug printout.
C
C     KRET       - Response to error indicator.
C                  0        , Abort if error encountered.
C                  Non-zero , Return to calling routine
C                             even if error encountered.
C
C     Output Parameters.
C     ------------------
C
C     KSEC1      - Array containing Grib Section 1 data.(Updated)
C
C     KGRIB      - Array containing Grib coded data.(Updated)
C
C     KNSPT      - Number of bit after last one inserted/extracted.(Updated)
C
C     KRET       - Return code.
C                  0   , No error encountered.
C                  2   , Error reported by routine INXBIT.
C
C
C     Method.
C     -------
C
C     Input data packed/unpacked in accordance with ECMWF usage of
C     local part of section 1 of Grib code, definition 4.
C
C
C     Externals.
C     ----------
C
C     INXBIT
C     ABORTX
C     CSGNBT
C     DSGNBT
C
C
C     Reference.
C     ----------
C
C     WMO Manual On Codes for Grib Code.
C
C
C     Comments.
C     ---------
C
C     Adapted from ECLOC1.F - simplified to handle just definition 4.
#include "ecdef4.h"
C
C     Author.
C     -------
C
C     J.D.Chambers     ECMWF      18th January 1995
C
C     Modifications.
C     --------------
C
C     J.D.Chambers     ECMWF       Jan 2000
C     Allow single 2-byte ensemble number for stream 1090 (ECMWF
C     ensemble seasonal forecasts)
C
C
C----<
C     -----------------------------------------------------------------|
C*    Section 0 . Definition of variables. Data statements.
C     -----------------------------------------------------------------|
C
      IMPLICIT NONE
C
#include "grprs.h"
C
C     Parameters
C
      CHARACTER*1   HFUNC
      INTEGER KSEC1, KGRIB, KLENG, KNSPT, KBITS, KPLEN, KPR, KRET
      DIMENSION KGRIB(*)
      DIMENSION KSEC1(*)
C
C     Local variables
C
      INTEGER IRET, IZERO, ILENS1, INUM, LOOP, IP1, N
      INTEGER ILALO
      DIMENSION ILALO(8)
      LOGICAL LENCODE, LDECODE
C
C     -----------------------------------------------------------------|
C*    Section 1 . Set initial values.
C     -----------------------------------------------------------------|
C
  100 CONTINUE
C
      IRET = KRET
      LENCODE = ( HFUNC.EQ.'C' )
      LDECODE = .NOT. LENCODE
C
C     -----------------------------------------------------------------|
C*    Section 2 .  Ocean extensions, definition 4.
C     -----------------------------------------------------------------|
C
  200 CONTINUE
C
      IF( KSEC1(40).EQ.1090 ) THEN
C
C       If seasonal forecast data ...
C
C       Octet 50-51 : Forecast number.
C       One 16 bit field.
C
        CALL INXBIT(KGRIB,KLENG,KNSPT,KSEC1(42),1,KBITS,16,HFUNC,KRET)
        IF (KRET.NE.0) GOTO 910
C
        IF( LDECODE ) KSEC1(43) = 0
C
      ELSE
C
C       Octet 50 : Ensemble forecast number
C       Octet 51 : Total number of forecasts in ensemble
C       Two 8-bit fields.
C
        CALL INXBIT(KGRIB,KLENG,KNSPT,KSEC1(42),2,KBITS, 8,HFUNC,KRET)
        IF( KRET.NE.0 ) GOTO 910
C
      ENDIF
C
C     Octet 52 : Flag showing existence of a post-auxiliary array
C     One 8-bit field.
C
      IF( LENCODE ) IP1 = 1
      CALL INXBIT(KGRIB,KLENG,KNSPT, IP1,1,KBITS,8,HFUNC,KRET)
      IF( KRET.NE.0 ) GOTO 910
C
C     -----------------------------------------------------------------|
C*    Section 3 .  Coordinate structure definition.
C     -----------------------------------------------------------------|
C
  300 CONTINUE
C
C     Octet 53 : Fundamental spatial reference system (Planet flag)
C     Octet 54 : Fundamental time reference
C     Octet 55 : Space unit flag (applies only if lengths NOT
C                otherwise labelled)
C     Octet 56 : Vertical coordinate definition (z)
C     Octet 57 : Horizontal coordinate definition (x,y)
C     Octet 58 : Time unit flag
C     Octet 59 : Time coordinate definition (t)
C     Seven 8-bit fields.
C
      CALL INXBIT(KGRIB,KLENG,KNSPT,KSEC1(44),7,KBITS, 8,HFUNC,KRET)
      IF( KRET.NE.0 ) GOTO 910
C
C     -----------------------------------------------------------------|
C*    Section 4 .  Mixed coordinates.
C     -----------------------------------------------------------------|
C
  400 CONTINUE
C
C*    Position definition.
C     Octet 60 : Mixed coordinate field flag
C     Octet 61 : Coordinate 1 flag  (usually time)
C     Octet 62 : Averaging flag
C     Three 8-bit fields.
C
      CALL INXBIT(KGRIB,KLENG,KNSPT,KSEC1(51),3,KBITS, 8,HFUNC,KRET)
      IF( KRET.NE.0 ) GOTO 910
C
C     Octets 63 - 66 : Position of level 1
C     Octets 67 - 70 : Position of level 2
C     Two 32-bit fields.
C
C     When coding data, set sign bit to 1, if value is negative.
C
      IF( LENCODE ) THEN
        CALL CSGNBT( ILALO(1), KSEC1(54), 32, KRET)
        CALL CSGNBT( ILALO(2), KSEC1(55), 32, KRET)
      ENDIF
C
      CALL INXBIT(KGRIB,KLENG,KNSPT,ILALO(1),2,KBITS, 32,HFUNC,KRET)
      IF( KRET.NE.0 ) GOTO 910
C
C     When decoding data, if sign bit is 1, value is negative.
C
      IF( LDECODE ) THEN
        CALL DSGNBT( KSEC1(54), ILALO(1), 32, KRET)
        CALL DSGNBT( KSEC1(55), ILALO(2), 32, KRET)
      ENDIF
C
C     Octet 71 : Coordinate 2 flag  (usually z-coordinate)
C     Octet 72 : Averaging flag
C     Two 8-bit fields.
C
      CALL INXBIT(KGRIB,KLENG,KNSPT,KSEC1(56),2,KBITS, 8,HFUNC,KRET)
      IF( KRET.NE.0 ) GOTO 910
C
C     Octets 73 - 76 : Position of level 1
C     Octets 77 - 80 : Position of level 2
C     Two 32-bit fields.
C
C     When coding data, set sign bit to 1, if value is negative.
C
      IF( LENCODE ) THEN
        CALL CSGNBT( ILALO(1), KSEC1(58), 32, KRET)
        CALL CSGNBT( ILALO(2), KSEC1(59), 32, KRET)
      ENDIF
C
      CALL INXBIT(KGRIB,KLENG,KNSPT,ILALO(1),2,KBITS, 32,HFUNC,KRET)
      IF( KRET.NE.0 ) GOTO 910
C
C     When decoding data, if sign bit is 1, value is negative.
C
      IF( LDECODE ) THEN
        CALL DSGNBT( KSEC1(58), ILALO(1), 32, KRET)
        CALL DSGNBT( KSEC1(59), ILALO(2), 32, KRET)
      ENDIF
C
C     -----------------------------------------------------------------|
C*    Section 5 .  Grid definition.
C     -----------------------------------------------------------------|
C
  500 CONTINUE
C
C     Octets 81 : Coordinate 3 flag (x-axis, usually longitude)
C     Octets 82 : Coordinate 4 flag (y-axis, usually latitude)
C     Two 8-bit fields.
C
      CALL INXBIT(KGRIB,KLENG,KNSPT,KSEC1(60),2,KBITS, 8,HFUNC,KRET)
      IF( KRET.NE.0 ) GOTO 910
C
C     Octets  83 - 86  : Coordinate 4 of first grid point
C     Octets  87 - 90  : Coordinate 3 of first grid point
C     Octets  91 - 94  : Coordinate 4 of last grid point
C     Octets  95 - 98  : Coordinate 3 of last grid point
C     Octets  99 - 102 : i-increment
C     Octets 103 - 106 : j-increment
C     Six 32-bit fields.
C
C     When coding data, set sign bit to 1, if value is negative.
C
      IF( LENCODE ) THEN
        CALL CSGNBT( ILALO(1), KSEC1(62), 32, KRET)
        CALL CSGNBT( ILALO(2), KSEC1(63), 32, KRET)
        CALL CSGNBT( ILALO(3), KSEC1(64), 32, KRET)
        CALL CSGNBT( ILALO(4), KSEC1(65), 32, KRET)
        CALL CSGNBT( ILALO(5), KSEC1(66), 32, KRET)
        CALL CSGNBT( ILALO(6), KSEC1(67), 32, KRET)
      ENDIF
C
      CALL INXBIT(KGRIB,KLENG,KNSPT,ILALO(1),6,KBITS, 32,HFUNC,KRET)
      IF( KRET.NE.0 ) GOTO 910
C
C     When decoding data, if sign bit is 1, value is negative.
C
      IF( LDECODE ) THEN
        CALL DSGNBT( KSEC1(62), ILALO(1), 32, KRET)
        CALL DSGNBT( KSEC1(63), ILALO(2), 32, KRET)
        CALL DSGNBT( KSEC1(64), ILALO(3), 32, KRET)
        CALL DSGNBT( KSEC1(65), ILALO(4), 32, KRET)
        CALL DSGNBT( KSEC1(66), ILALO(5), 32, KRET)
        CALL DSGNBT( KSEC1(67), ILALO(6), 32, KRET)
      ENDIF
C
C
C     Octet 107 : Flag for irregular grid coordinate list
C     Octet 108 : Flag for normal or staggered grid
C     Two 8-bit fields.
C
      CALL INXBIT(KGRIB,KLENG,KNSPT,KSEC1(68),2,KBITS, 8,HFUNC,KRET)
      IF( KRET.NE.0 ) GOTO 910
C
C     -----------------------------------------------------------------|
C*    Section 6 .  Auxiliary information.
C     -----------------------------------------------------------------|
C
  600 CONTINUE
C
C     Octet 109 : Flag for any further information
C     One 8-bit fields.
C
      CALL INXBIT(KGRIB,KLENG,KNSPT,KSEC1(70),1,KBITS, 8,HFUNC,KRET)
      IF( KRET.NE.0 ) GOTO 910
C
C*    Auxiliary information.
C
C     Octet 110 : Number of entries in horizontal coordinate
C                 definition supplement.
C     One 8-bit field.
C
      CALL INXBIT(KGRIB,KLENG,KNSPT,KSEC1(71),1,KBITS, 8,HFUNC,KRET)
      IF( KRET.NE.0 ) GOTO 910
C
C     Octets 111 - 112 : Number of entries in mixed coordinate
C                        definition.
C     Octets 113 - 114 : Number of entries in grid coordinate list
C     Octets 115 - 116 : Number of entries in auxiliary array
C     Three 16-bit fields .
C
      CALL INXBIT(KGRIB,KLENG,KNSPT,KSEC1(72),3,KBITS, 16,HFUNC,KRET)
      IF( KRET.NE.0 ) GOTO 910
C
C     At this point length of Section 1 of Grib code is 116 octets.
C
      ILENS1 = 116
      INUM   = 75
C
C     -----------------------------------------------------------------|
C*    Section 7 .  (Optional) Supplements.
C     -----------------------------------------------------------------|
C
  700 CONTINUE
C
C     Horizontal coordinate supplement.
C
      DO LOOP = 1, KSEC1(71)
C
C       KSEC1(71) 32-bit fields.
C
C       When coding values, set sign bit to 1, if value is negative.
C
        IF( LENCODE ) CALL CSGNBT( ILALO(1), KSEC1(INUM), 32, KRET)
C
        CALL INXBIT(KGRIB,KLENG,KNSPT,ILALO(1),1,KBITS,32, HFUNC,KRET)
        IF( KRET.NE.0 ) GOTO 910
C
C       When decoding values, if sign bit is 1, value is negative.
C
        IF( LDECODE ) CALL DSGNBT( KSEC1(INUM), ILALO(1), 32, KRET)
        ILENS1 = ILENS1 + 4
        INUM   = INUM + 1
C
      ENDDO
C
C     Mixed coordinate definition.
C
      DO LOOP = 1, KSEC1(72)
C
C       KSEC1(72) 32-bit fields.
C
C       When coding values, set sign bit to 1, if value is negative.
C
        IF( LENCODE ) CALL CSGNBT( ILALO(1), KSEC1(INUM), 32, KRET)
C
        CALL INXBIT(KGRIB,KLENG,KNSPT,ILALO(1),1,KBITS, 32,HFUNC,KRET)
        IF( KRET.NE.0 ) GOTO 910
C
C       When decoding values, if sign bit is 1, value is negative.
C
        IF( LDECODE ) CALL DSGNBT( KSEC1(INUM), ILALO(1), 32, KRET)
        ILENS1 = ILENS1 + 4
        INUM   = INUM + 1
C
      ENDDO
C
C     Grid coordinate list.
C
      DO LOOP = 1, KSEC1(73)
C
C       KSEC1(73) 32-bit fields.
C
C       When coding values, set sign bit to 1, if value is negative.
C
        IF( LENCODE ) CALL CSGNBT( ILALO(1), KSEC1(INUM), 32, KRET)
C
        CALL INXBIT(KGRIB,KLENG,KNSPT,ILALO(1),1,KBITS, 32,HFUNC,KRET)
        IF( KRET.NE.0 ) GOTO 910
C
C       When decoding values, if sign bit is 1, value is negative.
C
        IF( LDECODE ) CALL DSGNBT( KSEC1(INUM), ILALO(1), 32, KRET)
        ILENS1 = ILENS1 + 4
        INUM   = INUM + 1
C
      ENDDO
C
C     Auxiliary array.
C
      IF( KSEC1(74).NE.0 ) THEN
C
C       KSEC1(74) 32-bit fields.
C
        CALL INXBIT(KGRIB,KLENG,KNSPT,KSEC1(INUM),KSEC1(74),KBITS,
     X             32,HFUNC,KRET)
        IF( KRET.NE.0 ) GOTO 910
        ILENS1 = ILENS1 + 4 * KSEC1(74)
        INUM   = INUM + KSEC1(74)
      ENDIF
C
C     Post-auxiliary array.
C
      IF( IP1.EQ.1 ) THEN
C
C       Integer count, N say, followed by (N-1) 32-bit fields.
C
        CALL INXBIT(KGRIB,KLENG,KNSPT,KSEC1(INUM),1,KBITS,
     X             32,HFUNC,KRET)
        IF( KRET.NE.0 ) GOTO 910
        N = KSEC1(INUM)
        IF( N.GT.1 ) THEN
          INUM   = INUM + 1
C
          CALL INXBIT(KGRIB,KLENG,KNSPT,KSEC1(INUM),(N-1),KBITS,
     X               32,HFUNC,KRET)
          IF( KRET.NE.0 ) GOTO 910
          ILENS1 = ILENS1 + 4 * N
          INUM   = INUM + N - 1
        ELSE
          KSEC1(INUM) = 0
          ILENS1 = ILENS1 + 4
          KNSPT = KNSPT + 32
        ENDIF
      ELSE
        KSEC1(INUM) = 0
      ENDIF
C
C*    Insert length of section 1, if coding data.
C     One 24-bit field.
C
      IF( LENCODE ) THEN
        CALL INXBIT(KGRIB,KLENG,KPLEN,ILENS1,1,KBITS, 24,HFUNC,KRET)
        IF( KRET.NE.0 ) GOTO 910
      ENDIF
C
C     -----------------------------------------------------------------|
C*    Section 9 . Abort/return to calling routine.
C     -----------------------------------------------------------------|
C
  900 CONTINUE
C
      IF( KPR.GE.1 )
     X  WRITE(GRPRSM,*) 'ECDEF4: Section 9. On output, KNSPT  = ',KNSPT
C
      RETURN
C
  910 CONTINUE
      KRET = 2
      WRITE(GRPRSM,*) 'ECDEF4: Error reported by routine INXBIT.'
C
C     Abort if requested to do so when an error has been encountered.
C
      IF( IRET.EQ.0.AND.KRET.NE.0 ) THEN
        CALL ABORTX ('ECDEF4')
      ELSE
        RETURN
      ENDIF
C
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities
C granted to it by virtue of its status as an intergovernmental organisation
C nor does it submit to any jurisdiction.
C

C     Determine if parameter needs to be interpolated with nearest
C     neighbour-type method, given its ID and table.

      LOGICAL FUNCTION FORCED_NEAREST_NEIGHBOUR(FORCED,TABLE,PARAM)

      IMPLICIT NONE

      LOGICAL FORCED
      INTEGER TABLE
      INTEGER PARAM
      CHARACTER*12 YFLAG

C     Use method if FORCED, is a special param ID, or set by env
      FORCED_NEAREST_NEIGHBOUR =
     x
     x FORCED
     x .OR.
     x
     x (TABLE.EQ.128).AND.
     x   ((PARAM.EQ.27).OR.  !cvl
     x    (PARAM.EQ.28).OR.  !cvh
     x    (PARAM.EQ.29).OR.  !tvl
     x    (PARAM.EQ.30).OR.  !tvh
     x    (PARAM.EQ.43) )    !slt
     x .OR.
     x
     x (TABLE.EQ.260).AND.
     x   ((PARAM.EQ.15))     !ptype
     x .OR.
     x
     x (TABLE.EQ.228).AND.
     x   ((PARAM.EQ.217).OR. !ilspf
     x    (PARAM.EQ.218).OR. !crr
     x    (PARAM.EQ.219).OR. !lsrr
     x    (PARAM.EQ.220).OR. !csfr
     x    (PARAM.EQ.221).OR. !lssfr
     x    (PARAM.EQ.222).OR. !mxtpr3
     x    (PARAM.EQ.223).OR. !mntpr3
     x    (PARAM.EQ.224).OR. !mxtpr6
     x    (PARAM.EQ.225).OR. !mntpr6
     x    (PARAM.EQ.226).OR. !mxtpr
     x    (PARAM.EQ.227) )   !mntpr

      IF (.NOT.FORCED_NEAREST_NEIGHBOUR) THEN
        CALL GETENV('NEAREST_NEIGHBOUR', YFLAG)
        FORCED_NEAREST_NEIGHBOUR = (YFLAG(1:1).EQ.'1')
      END IF

      END

C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      INTEGER FUNCTION FIXAREA( )
C
C---->
C**** FIXAREA
C
C     Purpose
C     -------
C
C     Fixup input/output field area definitions.
C
C
C     Interface
C     ---------
C
C     IRET = FIXAREA( )
C
C     Input
C     -----
C
C     None.
C
C
C     Output
C     ------
C
C     None.
C
C
C     Method
C     ------
C
C     If default (0/0/0/0) selected for input, input area is set
C       - to global for spherical harmonics 
C       - to global for lat/long grid 
C       - to global for gaussian grid 
C
C     If default (0/0/0/0) selected for output, output area is set
C       - to same as input area for lat/long grid 
C       - to same as input area for regular gaussian grid 
C       - to global for reduced gaussian grid 
C
C     (Currently, subareas are not supported for reduced gaussian fields.
C      Should work OK; but need to correct setup of values in GRIB
C      product for number of points in each latitude row)
C
C     Output area is adjusted to fit the given grid step.
C
C
C     Externals
C     ---------
C
C     AREACHK - Match input/output field area definitions according to
C               grid specification.
C     GETENV   - Get value of an environment variable
C     INTLOG   - Logs output messages
C
C
C     Author
C     ------
C
C     J.D.Chambers     ECMWF     Jan 1995
C
C----<
C
      IMPLICIT NONE
C
C     Function arguments
C
#include "parim.h"
#include "nifld.common"
#include "nofld.common"
#include "grfixed.h"
#include "intf.h"
C
C     Parameters
C
      INTEGER JPROUTINE
      PARAMETER (JPROUTINE = 19200 )
C
C     Local variables
C
      INTEGER INORTH, ISOUTH, IEAST
      INTEGER ITEMP, IRET
      REAL EW, NS, NORTH, SOUTH, EAST, WEST, FACTOR3, FACTOR4
      LOGICAL LDEFIN, LDEFOUT, LGLOBAL, LOVERDE
      CHARACTER*20 OVERIDE
      INTEGER IBLANK
C
C     Externals
C
      INTEGER AREACHK
C
C ------------------------------------------------------------------
C*    Section 1.   Initialise
C ------------------------------------------------------------------
C
  100 CONTINUE
      FIXAREA = 0
      LGLOBAL = .FALSE.
C
C ------------------------------------------------------------------
C*    Section 2.   Fixup input area if default (0/0/0/0).
C ------------------------------------------------------------------
C
  200 CONTINUE
C
C     Fixup input ocean area definition
C
      IF( NILOCAL.EQ.4 ) THEN
        FACTOR3 = 0.0
        FACTOR4 = 0.0
C
        IF( NIFORM.EQ.1 ) THEN
          IF( ISEC1(60).EQ.1 ) FACTOR3 = 1.0
          IF( ISEC1(60).EQ.2 ) THEN
            IF( ISEC1(47).EQ.160 ) FACTOR3 = 1000.0
          ENDIF
          IF( ISEC1(60).EQ.3 ) FACTOR3 = 1000000.0
          IF( ISEC1(60).EQ.4 ) FACTOR3 = 1000000.0
C
          IF( ISEC1(61).EQ.1 ) FACTOR4 = 1.0
          IF( ISEC1(61).EQ.2 ) THEN
            IF( ISEC1(47).EQ.160 ) FACTOR4 = 1000.0
          ENDIF
          IF( ISEC1(61).EQ.3 ) FACTOR4 = 1000000.0
          IF( ISEC1(61).EQ.4 ) FACTOR4 = 1000000.0
C
          IF( (FACTOR3.EQ.0).OR.(FACTOR4.EQ.0) ) THEN
            FIXAREA = 2
            GOTO 900
          ENDIF
          NORTH = REAL(ISEC1(62))/FACTOR4
          WEST  = REAL(ISEC1(63))/FACTOR3
          SOUTH = REAL(ISEC1(64))/FACTOR4
          EAST  = REAL(ISEC1(65))/FACTOR3
        ELSE
          IF( NIOCO3.EQ.1 ) FACTOR3 = 1.0
          IF( NIOCO3.EQ.2 ) THEN
            IF( NIVCDEF.EQ.160 ) FACTOR3 = 1000.0
          ENDIF
          IF( NIOCO3.EQ.3 ) FACTOR3 = 1000000.0
          IF( NIOCO3.EQ.4 ) FACTOR3 = 1000000.0
C
          IF( NIOCO4.EQ.1 ) FACTOR4 = 1.0
          IF( NIOCO4.EQ.2 ) THEN
            IF( NIVCDEF.EQ.160 ) FACTOR4 = 1000.0
          ENDIF
          IF( NIOCO4.EQ.3 ) FACTOR4 = 1000000.0
          IF( NIOCO4.EQ.4 ) FACTOR4 = 1000000.0
C
          IF( (FACTOR3.EQ.0).OR.(FACTOR4.EQ.0) ) THEN
            FIXAREA = 2
            GOTO 900
          ENDIF
          NORTH = REAL(NIOCO4F)/FACTOR4
          WEST  = REAL(NIOCO3F)/FACTOR3
          SOUTH = REAL(NIOCO4L)/FACTOR4
          EAST  = REAL(NIOCO3L)/FACTOR3
        ENDIF
        NIAREA(1) = NINT( NORTH * PPMULT + 0.1)
        NIAREA(2) = NINT( WEST  * PPMULT + 0.1)
        NIAREA(3) = NINT( SOUTH * PPMULT + 0.1)
        NIAREA(4) = NINT( EAST  * PPMULT + 0.1)
        GOTO 300
      ENDIF
C
C Sinisa bug fix for grid global fields
C       If input is lat/lon, check if it is global to within
C       a tolerance of 0.1 degrees
       IF ( NIREPR .EQ. JPREGULAR ) THEN
          IF ( NIAREA(4).GT.0 ) THEN
            IEAST = NIAREA(4)
          ELSE
            IEAST = JP360 + NIAREA(4)
          ENDIF
         IF(NIAREA(1).EQ.JP90.AND.NIAREA(3).EQ.-JP90.AND.
     X      NIAREA(2).EQ.0.AND.
     X      IABS(JP360 - IEAST - NIGRID(1)).LT.1000) THEN
              NIAREA(1) = 0.
              NIAREA(2) = 0.
              NIAREA(3) = 0.
              NIAREA(4) = 0.
csinisa
cs          ELSEIF(IABS(JP360 - IEAST - NIGRID(1)).LT.1000) THEN
cs              NOAREA(1) = NIAREA(1)
cs              NOAREA(2) = 0
cs              NOAREA(3) = NIAREA(3)
cs              NOAREA(4) = 36000000
          ENDIF
        ENDIF

      LDEFIN = ( (NIAREA(1) .EQ. 0) .AND. (NIAREA(2) .EQ. 0) .AND.
     X           (NIAREA(3) .EQ. 0) .AND. (NIAREA(4) .EQ. 0) ) 

C
      IF( LDEFIN ) THEN
C
        IF ( (NIREPR.EQ.JPSPHERE) .OR. (NIREPR.EQ.JPSPHROT) ) THEN
C
C         Spectral input ..
          EW = 0.0
          NS = 0.0
C
        ELSE IF ( NIREPR .EQ. JPREGULAR ) THEN
C
C         Regular lat/long grid ..
          EW = FLOAT( NIGRID(1) ) / PPMULT
          NS = FLOAT( NIGRID(2) ) / PPMULT
C
        ELSE
C
C         Gaussian grid ..
          EW = FLOAT( NIGAUSS )
          NS = 0.0
        ENDIF
C
        NORTH = 0.0
        WEST  = 0.0
        SOUTH = 0.0
        EAST  = 0.0
        IRET = AREACHK( EW, NS, NORTH, WEST, SOUTH, EAST )
        IF( IRET.NE.0 ) THEN
          FIXAREA = IRET
          GOTO 900
        ENDIF
        NIAREA(1) = NINT( NORTH * PPMULT + 0.1)
        NIAREA(2) = NINT( WEST  * PPMULT + 0.1)
        NIAREA(3) = NINT( SOUTH * PPMULT + 0.1)
        NIAREA(4) = NINT( EAST  * PPMULT + 0.1)
C
      ENDIF
C
C ------------------------------------------------------------------
C*    Section 3.   Fixup output area if default (0/0/0/0).
C ------------------------------------------------------------------
C
  300 CONTINUE
C
C     See if environment variable has been specified to override
C     output area specification
C
      LOVERDE = .FALSE.
      CALL GETENV('OVERRIDE_OUTPUT_AREA', OVERIDE)
      IBLANK = INDEX(OVERIDE, ' ')
      IF( IBLANK.GT.1 ) THEN
        IF( OVERIDE(1:2).EQ.'ON' ) THEN
          LOVERDE = .TRUE.
          CALL INTLOG(JP_DEBUG,
     X      'FIXAREA: OVERRIDE_OUTPUT_AREA is ON',JPQUIET)
        ENDIF
      ENDIF
C
      LDEFOUT = ( (NOAREA(1) .EQ. 0) .AND. (NOAREA(2) .EQ. 0) .AND.
     X            (NOAREA(3) .EQ. 0) .AND. (NOAREA(4) .EQ. 0) )
     X          .OR. LOVERDE
C
C     Fixup output ocean area definition
C
      IF( NILOCAL.EQ.4 ) THEN
        IF( LDEFOUT ) THEN
          IF( NIFORM.EQ.1 ) THEN
              SOUTH  = REAL(ISEC1(64))/FACTOR4
              NORTH  = REAL(ISEC1(62))/FACTOR4
              WEST   = REAL(ISEC1(63))/FACTOR3
              EAST   = REAL(ISEC1(65))/FACTOR3

              EW = FLOAT( NOGRID(1) ) / PPMULT
              NS = FLOAT( NOGRID(2) ) / PPMULT

            IF( ISEC1(60).EQ.3 ) THEN
              WEST  = 0.0
              EAST  = 360.0
              IRET = AREACHK( EW, NS, NORTH, WEST, SOUTH, EAST )
              IF ( IRET .NE. 0 ) THEN
                 FIXAREA = IRET
                 GOTO 900
              ENDIF
            ELSEIF( ISEC1(60).EQ.4 ) THEN
              WEST  = -90.0
              EAST  =  90.0
            ENDIF

            IF( ISEC1(61).EQ.3 ) THEN
              SOUTH  = 0.0
              NORTH  = 360.0
            ELSEIF( ISEC1(61).EQ.4 ) THEN
              SOUTH  = -90.0
              NORTH  =  90.0
            ENDIF
          ELSE
              NORTH = REAL(NIOCO4F)/FACTOR4
              WEST  = REAL(NIOCO3F)/FACTOR3
              SOUTH = REAL(NIOCO4L)/FACTOR4
              EAST  = REAL(NIOCO3L)/FACTOR3
              EW = FLOAT( NOGRID(1) ) / PPMULT
              NS = FLOAT( NOGRID(2) ) / PPMULT
            IF( NIOCO3.EQ.3 ) THEN
              WEST  = 0.0
              EAST  = 360.0
              IRET = AREACHK( EW, NS, NORTH, WEST, SOUTH, EAST )
              IF ( IRET .NE. 0 ) THEN
                 FIXAREA = IRET
                 GOTO 900
              ENDIF
            ELSEIF( NIOCO3.EQ.4 ) THEN
              WEST  = -90.0
              EAST  =  90.0
            ENDIF

            IF( NIOCO4.EQ.3 ) THEN
              SOUTH  = 0.0
              NORTH  = 360.0
            ELSEIF( NIOCO4.EQ.4 ) THEN
              SOUTH  = -90.0
              NORTH  =  90.0
            ENDIF
          ENDIF

          NOAREA(1) = NINT( NORTH * PPMULT + 0.1)
          NOAREA(2) = NINT( WEST  * PPMULT + 0.1)
          NOAREA(3) = NINT( SOUTH * PPMULT + 0.1)
          NOAREA(4) = NINT( EAST  * PPMULT + 0.1)
        ELSE
          NORTH = REAL(NOAREA(1)) / PPMULT
          WEST  = REAL(NOAREA(2)) / PPMULT
          SOUTH = REAL(NOAREA(3)) / PPMULT
          EAST  = REAL(NOAREA(4)) / PPMULT
        ENDIF
        GOTO 900
      ENDIF
C
      IF( LDEFOUT ) THEN
C
C       If input is gaussian, check if it is global to within
C       a tolerance of 0.1 degrees.
C
        IF ( (NIREPR.EQ.JPGAUSSIAN) .OR. (NIREPR.EQ.JPQUASI) ) THEN
          LGLOBAL = .TRUE.
          INORTH    = NINT( RIGAUSS(1) * PPMULT )
          IF( IABS(NIAREA(1)-INORTH).GT.1000) LGLOBAL = .FALSE.
          ISOUTH    = - INORTH
          IF( IABS(NIAREA(3)-ISOUTH).GT.1000) LGLOBAL = .FALSE.
          IF( NIAREA(2).NE.0 ) LGLOBAL = .FALSE.
C Sinisa added case east less than 0
          IF ( NIAREA(4).GT.0 ) THEN
            IEAST = NIAREA(4)
          ELSE
            IEAST = JP360 + NIAREA(4)
          ENDIF
          IEAST = JP360 - (JP90/NIGAUSS)
          IF( NIREPR.EQ.JPGAUSSIAN ) THEN
             IF( IABS(JP360 - IEAST - (JP90/NIGAUSS)).GT.1000)
     X          LGLOBAL = .FALSE.
          ENDIF
        ENDIF
C
C       Spectral output ..
C
C       .. skip section fitting output area to grid
C
        IF ( (NOREPR.EQ.JPSPHERE).OR.(NOREPR.EQ.JPSPHROT) ) GOTO 900
C
C       Regular lat/long grid ..
C
        IF ( (NOREPR.EQ.JPREGULAR).OR.(NOREPR.EQ.JPREGROT) ) THEN
          IF( LDEFIN .OR. LGLOBAL.OR.(NIREPR.EQ.JPREDLL) ) THEN
            EW = FLOAT( NOGRID(1) ) / PPMULT
            NS = FLOAT( NOGRID(2) ) / PPMULT
            NORTH = 90.0
            WEST  = 0.0
            SOUTH = -NORTH
            EAST  = 360.0
C
C           Use GRIB header values for reduced lat/long grids
C           (maybe 'Mediterranean' sub-area).
C
            IF( NIREPR.EQ.JPREDLL ) THEN
              NORTH = REAL(NIAREA(1))/PPMULT
              WEST  = REAL(NIAREA(2))/PPMULT
              SOUTH = REAL(NIAREA(3))/PPMULT
              EAST  = REAL(NIAREA(4))/PPMULT
            ENDIF
            IRET = AREACHK( EW, NS, NORTH, WEST, SOUTH, EAST )
            IF ( IRET .NE. 0 ) THEN
               FIXAREA = IRET
               GOTO 900
            ENDIF
            NOAREA(1) = NINT( NORTH * PPMULT + 0.1)
            NOAREA(2) = NINT( WEST  * PPMULT + 0.1)
            NOAREA(3) = NINT( SOUTH * PPMULT + 0.1)
            NOAREA(4) = NINT( EAST  * PPMULT + 0.1)
C
          ELSE
            NOAREA(1) = NIAREA(1)
            NOAREA(2) = NIAREA(2)
            NOAREA(3) = NIAREA(3)
            NOAREA(4) = NIAREA(4)
          ENDIF
C
        ENDIF
C
C       Gaussian ..
C
        IF ( (NOREPR.EQ.JPGAUSSIAN) .OR. (NOREPR.EQ.JPQUASI) ) THEN
C
C         Is output grid specification the same as the input?
          IF( NIGAUSS.EQ.NOGAUSS) THEN
            IF( (NOREPR.EQ.JPGAUSSIAN) .AND. LGLOBAL ) THEN
              NOAREA(1) = JP90
              NOAREA(2) = 0
              NOAREA(3) = -JP90
              NOAREA(4) = JP360 - (JP90/NOGAUSS)
            ELSE
              NOAREA(1) = NIAREA(1)
              NOAREA(2) = NIAREA(2)
              NOAREA(3) = NIAREA(3)
              NOAREA(4) = NIAREA(4)
           ENDIF
C
C           Skip section fitting output area to grid
            GOTO 900
C
          ELSE
C
C           Different grid resolutions
            EW = FLOAT( NOGAUSS )
            NS = 0.0
            IF( (NOREPR.EQ.JPGAUSSIAN) .AND. LGLOBAL ) THEN
              NORTH = 90.0
              WEST  = 0.0
              SOUTH = -90.0
              EAST  = 360.0 - (360.0/(EW*4.0))
            ELSE
              NORTH = FLOAT( NIAREA(1) ) / PPMULT
              WEST  = FLOAT( NIAREA(2) ) / PPMULT
              SOUTH = FLOAT( NIAREA(3) ) / PPMULT
              EAST  = FLOAT( NIAREA(4) ) / PPMULT
            ENDIF
            IRET = AREACHK( EW, NS, NORTH, WEST, SOUTH, EAST )
            IF ( IRET .NE. 0 ) THEN
               FIXAREA = IRET
               GOTO 900
            ENDIF
            NOAREA(1) = NINT( NORTH * PPMULT + 0.1)
            NOAREA(2) = NINT( WEST  * PPMULT + 0.1)
            NOAREA(3) = NINT( SOUTH * PPMULT + 0.1)
            NOAREA(4) = NINT( EAST  * PPMULT + 0.1)
C
C           If regular lat/long input, check if output west longitude
C           reachs to full globe
            IF (NIREPR .EQ. JPREGULAR) THEN
              ITEMP = NIAREA(4)+NIGRID(1)
              IF ( ITEMP.EQ.JP360 ) NOAREA(4) = JP360 - (JP90/NOGAUSS)
            ENDIF
C
            IF (NIREPR .EQ. JPSPHERE) NOAREA(4) = JP360 - (JP90/NOGAUSS)
            IF (NIREPR .EQ. JPSPHROT) NOAREA(4) = JP360 - (JP90/NOGAUSS)
          ENDIF
        ENDIF
C
      ENDIF
C
C ------------------------------------------------------------------
C*    Section 4.   Now fixup output areas to correspond to the grid.
C ------------------------------------------------------------------
C
  400 CONTINUE
C
      IF ( (NOREPR.EQ.JPREGULAR).OR.(NOREPR.EQ.JPREGROT) ) THEN
C
C       Regular lat/long grid ..
        EW = FLOAT( NOGRID(1) ) / PPMULT
        NS = FLOAT( NOGRID(2) ) / PPMULT
C
      ELSE
C
C       Gaussian grid ..
        EW = FLOAT( NOGAUSS )
        NS = 0.0
      ENDIF
C
      NORTH = FLOAT( NOAREA(1) ) / PPMULT
      WEST  = FLOAT( NOAREA(2) ) / PPMULT
      SOUTH = FLOAT( NOAREA(3) ) / PPMULT
      EAST  = FLOAT( NOAREA(4) ) / PPMULT
      IRET = AREACHK( EW, NS, NORTH, WEST, SOUTH, EAST )
      IF ( IRET .NE. 0 ) THEN
         FIXAREA = IRET
         GOTO 900
      ENDIF
      NOAREA(1) = NINT( NORTH * PPMULT + 0.1)
      NOAREA(2) = NINT( WEST  * PPMULT + 0.1)
      NOAREA(3) = NINT( SOUTH * PPMULT + 0.1)
      NOAREA(4) = NINT( EAST  * PPMULT + 0.1)
C
C ------------------------------------------------------------------
C*    Section 9.   Closedown.
C ------------------------------------------------------------------
C
  900 CONTINUE
C
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities
C granted to it by virtue of its status as an intergovernmental organisation
C nor does it submit to any jurisdiction.
C

      INTEGER FUNCTION INTFBU(FLDIN,INLEN,FLDOUT,OUTLEN)
C
C---->
C**** INTFBU
C
C     Purpose
C     -------
C
C     Interpolate input field...
C
C
C     Interface
C     ---------
C
C     IRET = INTFBU( FLDIN,INLEN,FLDOUT,OUTLEN)
C
C     Input
C     -----
C
C     FLDIN  - Input field (unpacked).
C     INLEN  - Input field length (words).
C
C
C     Output
C     ------
C
C     FLDOUT  - Output field (unpacked).
C     OUTLEN  - Output field length (words).
C
C
C     Method
C     ------
C
C     Call interpolation routines; then repack if GRIB output.
C
C     Currently, subareas are not supported for reduced gaussian fields.
C     (Works OK; but need to setup values in GRIB product for number of
C      points in each latitude row)
C
C
C     Externals
C     ---------
C
C     IARCNTL - Control interp. quasi reg.Gauss -> Gaussian or lat/long
C     IAGCNTL - Control interpolation reg.Gaussian or lat/long fields.
C     JSH2SH  - Changes resolution of a field of spectral coefficients.
C     JALLGP  - Converts spectral input fields to lat/long grid fields.
C     JALLWN  - Converts spectral input wind fields to lat/long grids.
C     JAGGGP  - Converts spectral input fields to a gaussian grid field.
C     IBASINI - Ensure basic interpolation setup is done.
C     RESET_C - Reset interpolation handling options using GRIB product.
C     JMEMHAN - Handles memory allocation.
C     IGLSIZE - Evaluate array sizes for reg. lat/long and area.
C     IGSIZE  - Evaluate array sizes for a regular Gaussian.
C     IRSIZE  - Evaluate array sizes for a quasi reg Gaussian.
C     ISCRSZ  - Calculate number of values in generated field.
C     INTLOG  - Log error message.
C
C
C     Author
C     ------
C
C     J.D.Chambers     ECMWF     Aug 1994
C
C     J.D.Chambers     ECMWF        Feb 1997
C     Allow for 64-bit pointers
C
C----<
C
      IMPLICIT NONE
C
C     Function arguments
      INTEGER INLEN,OUTLEN
      REAL FLDIN(*),FLDOUT(*)
C
#include "parim.h"
#include "nifld.common"
#include "nofld.common"
#include "grfixed.h"
#include "intf.h"
C
C     Parameters
      INTEGER JPROUTINE
      INTEGER JPALLOC, JPSCR16
      PARAMETER (JPROUTINE = 26600 )
      PARAMETER (JPALLOC = 1 )
      PARAMETER (JPSCR16 = 16 )
C
C     Local variables
C
      INTEGER IERR, ISIZE, IUV
      REAL PNORTH, PSOUTH, PWEST, PEAST, PLATINC, PLONINC
      LOGICAL OIWEGLOBE, OINPOLE, OISPOLE
      LOGICAL OOWEGLOBE, OONPOLE, OOSPOLE
      LOGICAL LSTYLE
      INTEGER KILN, KITOTAL, KOLN, KOTOTAL, KPR, KERR
      INTEGER LOOP
      INTEGER HOLDEW, HOLDNS, IDISTEP
      REAL*8 DISSRES
      CHARACTER*1 HTYPE
#ifndef _CRAYFTN
#ifdef POINTER_64
      INTEGER*8 IZNFLDO
#endif
#endif
      REAL ZNFLDO
      POINTER ( IZNFLDO, ZNFLDO )
      DIMENSION ZNFLDO( 1 )
C
C     Externals
      INTEGER IGLSIZE, IGSIZE, IRSIZE, IARCNTL, IAGCNTL
      INTEGER ISCRSZ
C
C ------------------------------------------------------------------
C*    Section 1.   Initialise
C ------------------------------------------------------------------
C
  100 CONTINUE
      HOLDEW = 0
      HOLDNS = 0
      IERR   = 0
      KPR    = 0
      LSTYLE = .FALSE.
      INTFBU = 0
C
C     Allocate work array ZNFELDI if not already done.
C
      IF( IZNJDCI.NE.1952999238 ) THEN
        CALL JMEMHAN( 19, IZNFLDI, JPEXPAND, 1, IERR)
        IF( IERR.NE.0 ) THEN
          CALL INTLOG(JP_WARN,'INTFBU: znfeldi allocate fail',JPQUIET)
          INTFBU = IERR
          GOTO 900
        ENDIF
        IZNJDCI = 1952999238
      ENDIF
C
C ------------------------------------------------------------------
C*    Section 3.   Interpolation spherical harmonics to spherical
C                  harmonics
C ------------------------------------------------------------------
C
  300 CONTINUE
C
      IF ( ((NIREPR.EQ.JPSPHERE).OR.(NIREPR.EQ.JPSPHROT)) .AND.
     X     ((NOREPR.EQ.JPSPHERE).OR.(NOREPR.EQ.JPSPHROT)) ) THEN

C       Get scratch space for interpolation
C
        ISIZE = ISCRSZ()
        IF ( ISIZE .LE. 0 ) THEN
          CALL INTLOG(JP_ERROR,'INTFBU: Get scratch space failed',ISIZE)
          INTFBU = JPROUTINE + 2
          GOTO 900
        ENDIF
        CALL JMEMHAN( JPSCR16, IZNFLDO, ISIZE, JPALLOC, IERR)
        IF ( IERR .NE. 0 ) THEN
          CALL INTLOG(JP_ERROR,'INTFBU: Get scratch space fail',JPQUIET)
          INTFBU = JPROUTINE + 2
          GOTO 900
        ENDIF
C
        CALL SH2SH( ZNFELDI, NIRESO, ZNFLDO, NORESO )
C
        GOTO 700
C
C     If not spectral -> spectral transformation, make sure the input
C     and output area definitions have been setup.
C
      ELSE
       LSTYLE = LNOSTYLE.AND.
     X         (NOSTYLE.EQ.JPSDISM).AND.
     X         (NOREPR.EQ.JPREGULAR)

        IF( LSTYLE ) THEN
c to be consistant with product generation
              IF(NIRESO.EQ.1279) THEN
                 DISSRES = 0.125
              ELSEIF(NIRESO.EQ.799) THEN
                 DISSRES = 0.25
              ELSEIF(NIRESO.EQ.639) THEN
                 DISSRES = 0.25
              ELSEIF(NIRESO.EQ.399) THEN
                 DISSRES = 0.5
              ELSEIF(NIRESO.EQ.319) THEN
                 DISSRES = 0.5
              ELSEIF(NIRESO.EQ.255) THEN
                 DISSRES = 0.5
              ELSEIF(NIRESO.EQ.155) THEN
                 DISSRES = 1.5
              ELSE
                 DISSRES = NOGRID(1) / PPMULT
            CALL INTLOG(JP_WARN,'INTFBU: Diss resol set to: ',NOGRID(1))
              ENDIF
            IDISTEP = NINT(DISSRES*PPMULT)
            HOLDEW = NOGRID(1)
            HOLDNS = NOGRID(2)
            NOGRID(1) = IDISTEP
            NOGRID(2) = IDISTEP
         ENDIF
C
C       Setup geographical limits
C
        PNORTH = FLOAT( NOAREA(1) ) / PPMULT
        PWEST  = FLOAT( NOAREA(2) ) / PPMULT
        PSOUTH = FLOAT( NOAREA(3) ) / PPMULT
        PEAST  = FLOAT( NOAREA(4) ) / PPMULT
C
      ENDIF
C
C ------------------------------------------------------------------
C     Section 4.   Interpolation spherical harmonics to grid point.
C ------------------------------------------------------------------
C
  400 CONTINUE
C
      IF ( (NIREPR.EQ.JPSPHERE).OR.(NIREPR.EQ.JPSPHROT) ) THEN
C
C       Get scratch space for interpolation
C
        ISIZE = ISCRSZ()
        IF ( ISIZE .LE. 0 ) THEN
          CALL INTLOG(JP_ERROR,'INTFBU: Get scratch space failed',ISIZE)
          INTFBU = JPROUTINE + 4
          GOTO 900
        ENDIF
C
        CALL JMEMHAN( JPSCR16, IZNFLDO, ISIZE, JPALLOC, IERR)
        IF ( IERR .NE. 0 ) THEN
          CALL INTLOG(JP_ERROR,'INTFBU: Get scratch space fail',JPQUIET)
          INTFBU = JPROUTINE + 4
          GOTO 900
        ENDIF
C
C       Setup wind flag
C
        IF( .NOT.LWINDSET ) THEN
          LWIND = ( ( NOTABLE.EQ.128 ).AND.
     X            ((NOPARAM.EQ.131).OR.(NOPARAM.EQ.132)) )
        ENDIF
        CALL INTLOG(JP_DEBUG,'INTFBU: Wind flag = ', LWIND)
        IF ( LWIND ) THEN
          IUV = 1
        ELSE
          IUV = 0
        ENDIF
C
C ------------------------------------------------------------------
C*    Section 4.1  Interpolation spherical harmonics to grid point.
C ------------------------------------------------------------------
C
  410 CONTINUE
C
        IF ( (NOREPR.EQ.JPREGULAR).OR.(NOREPR.EQ.JPREGROT) ) THEN
          CALL INTLOG(JP_DEBUG,'INTFBU: SH -> lat/long',JPQUIET)
C
C         -> latitude/longitude grid
C
          PLONINC = FLOAT( NOGRID(1) ) / PPMULT
          PLATINC = FLOAT( NOGRID(2) ) / PPMULT
          IF ( LWIND ) THEN
            CALL JALLWN( ZNFELDI, NIRESO, PNORTH, PSOUTH, PWEST, PEAST,
     X                   PLATINC, PLONINC, ZNFLDO, IERR)
          ELSE
            CALL JALLGP( ZNFELDI, NIRESO, PNORTH, PSOUTH, PWEST, PEAST,
     X                   PLATINC, PLONINC, ZNFLDO, IERR)
          ENDIF
          IF ( IERR .NE. 0 ) THEN
            CALL INTLOG(JP_ERROR,
     X        'INTFBU: Interpolation of gaussian field failed.',JPQUIET)
            INTFBU = JPROUTINE + 4
            GOTO 900
          ENDIF
C
          GOTO 700
C
        ENDIF
C
C
        IF ((NOREPR.EQ.JPGAUSSIAN).OR.(NOREPR.EQ.JPQUASI)) THEN
C
C         -> regular/reduced gaussian grid
C
          HTYPE = ''
          IF (NOREPR.EQ.JPGAUSSIAN) THEN
          CALL INTLOG(JP_DEBUG,'INTFBU: SH -> regular gaussian',JPQUIET)
cs          HTYPE = 'U'
            HTYPE = 'F'
          ELSE
          CALL INTLOG(JP_DEBUG,'INTFBU: SH -> reduced gaussian',JPQUIET)
            HTYPE = 'U'
          ENDIF

          CALL JAGGGP(ZNFELDI, NIRESO, PNORTH, PSOUTH, PWEST, PEAST,
     X                NOGAUSS, HTYPE, NOLPTS, ZNFLDO, IUV, IERR)
          IF ( IERR .NE. 0 ) THEN
            CALL INTLOG(JP_ERROR,
     X        'INTFBU: Interpolation of gaussian field failed.',JPQUIET)
            INTFBU = JPROUTINE + 4
            GOTO 900
          ENDIF
          GOTO 700

        ENDIF
C
C       Dropthrough => unrecognized output field type
C
        IERR   = JPROUTINE + 4
        CALL INTLOG(JP_ERROR,
     X    'INTFBU: Unrecognized output field type.',NOREPR)
        INTFBU = IERR
        GOTO 900
C
      ENDIF
C
C ------------------------------------------------------------------
C     Section 5.   Interpolate Gaussian grid to grid point.
C ------------------------------------------------------------------
C
  500 CONTINUE
C
C     Setup flags for input and output fields
C
      KERR = 1
      IF (NIREPR .EQ. JPQUASI) THEN
        IERR = IRSIZE( NIGAUSS, NIAREA, MILLEN, NIWE, NINS, KILN,
     X                 KITOTAL, RIGAUSS, OIWEGLOBE, OINPOLE, OISPOLE,
     X                 KPR, KERR)
      ELSE IF ( NIREPR .EQ. JPGAUSSIAN ) THEN
          IERR = IGSIZE( NIGAUSS, NIAREA, NIWE, NINS, KILN, RIGAUSS,
     X                    OIWEGLOBE, OINPOLE, OISPOLE, KPR, KERR)
      ELSE
        IERR = IGLSIZE( NIGRID, NIAREA, NIWE, NINS, KILN, OIWEGLOBE,
     X                  OINPOLE, OISPOLE, KPR, KERR)
      ENDIF
C
      NONS = 0
      NOWE = 0
      IF (NOREPR .EQ. JPQUASI) THEN
        IERR = IRSIZE( NOGAUSS, NOAREA, NOLPTS, NOWE, NONS, KOLN,
     X                 KOTOTAL, ROGAUSS, OOWEGLOBE, OONPOLE, OOSPOLE,
     X                 KPR, KERR)
      ELSE IF ( NOREPR .EQ. JPGAUSSIAN ) THEN
          IERR = IGSIZE( NOGAUSS, NOAREA, NOWE, NONS, KOLN, ROGAUSS,
     X                    OOWEGLOBE, OONPOLE, OOSPOLE, KPR, KERR)
      ELSE
        IERR = IGLSIZE( NOGRID, NOAREA, NOWE, NONS, KOLN, OOWEGLOBE,
     X                  OONPOLE, OOSPOLE, KPR, KERR)
      ENDIF
C
      IF ( IERR .NE. 0 ) THEN
        CALL INTLOG(JP_ERROR,
     X    'INTFBU: Interpolation of gaussian field failed.',IERR)
        INTFBU = JPROUTINE + 6
        GOTO 900
      ENDIF
C
C
C ------------------------------------------------------------------
C     Section 5.1  Interpolate reduced Gaussian grid to grid point.
C ------------------------------------------------------------------
C
  510 CONTINUE
C
C
      ISIZE = ISCRSZ()
      IF ( ISIZE .LE. 0 ) THEN
        CALL INTLOG(JP_ERROR,'INTFBU: Get scratch space failed.',ISIZE)
        INTFBU = JPROUTINE + 2
        GOTO 900
      ENDIF
      CALL JMEMHAN( JPSCR16, IZNFLDO, ISIZE, JPALLOC, IERR)
      IF ( IERR .NE. 0 ) THEN
        CALL INTLOG(JP_ERROR,'INTFBU: Get scratch space fail.',JPQUIET)
        INTFBU = JPROUTINE + 2
        GOTO 900
      ENDIF
C
      IF (NIREPR .EQ. JPQUASI) THEN
        IERR = IARCNTL( ZNFELDI, JPEXPAND, ZNFLDO, ISIZE, KILN,
     X                  OIWEGLOBE, OINPOLE, OISPOLE, KOLN, OOWEGLOBE,
     X                  OONPOLE, OOSPOLE, KPR ,KERR)
        IF ( IERR .NE. 0 ) THEN
          CALL INTLOG(JP_ERROR,
     X      'INTFBU: Interpolation of gaussian field failed.',IERR)
          INTFBU = JPROUTINE + 7
          GOTO 900
        ENDIF
C
        GOTO 700
C
      ENDIF
C
C ------------------------------------------------------------------
C*    Section 6.   Interpolate regular grid point to grid point.
C ------------------------------------------------------------------
C
  600 CONTINUE
C
      IERR = IAGCNTL( ZNFELDI, JPEXPAND, ZNFLDO, ISIZE, KILN,
     X                OIWEGLOBE, OINPOLE, OISPOLE, KOLN, OOWEGLOBE,
     X                OONPOLE, OOSPOLE, KPR, KERR)
      IF ( IERR .NE. 0 ) THEN
        CALL INTLOG(JP_ERROR,
     X    'INTFBU: Interpolation of gaussian field failed.',IERR)
        INTFBU = JPROUTINE + 8
        GOTO 900
      ENDIF
C
C ------------------------------------------------------------------
C*    Section 7.   Move unpacked values to user array.
C ------------------------------------------------------------------
C
  700 CONTINUE
C     If dissemination 'style' selection has been chosen, select points.
C
      IF( LSTYLE ) THEN
          NOGRID(1) = HOLDEW
          NOGRID(2) = HOLDNS
        CALL DDSTYLE(ZNFLDO,IDISTEP,IDISTEP,NOGRID(1),NOGRID(2),IERR)
        IF( IERR.NE.0 ) THEN
         CALL INTLOG(JP_ERROR,
     X  'INTFBU: Wrong requested grid increment for dissemination style'
     X   ,JPQUIET)
         INTFBU = JPROUTINE + 3
          GOTO 900
        ENDIF
        PLONINC = FLOAT(NOGRID(1))/PPMULT
        PLATINC = FLOAT(NOGRID(2))/PPMULT
        PNORTH  = FLOAT(NOAREA(1))/PPMULT
        PWEST   = FLOAT(NOAREA(2))/PPMULT
        PSOUTH  = FLOAT(NOAREA(3))/PPMULT
        PEAST   = FLOAT(NOAREA(4))/PPMULT

        NOWE = NINT((PEAST  - PWEST )/PLONINC) + 1
        NONS = NINT((PNORTH - PSOUTH)/PLATINC) + 1
        ISIZE = NOWE*NONS
      ENDIF
c
      DO LOOP = 1, ISIZE
        FLDOUT( LOOP ) = ZNFLDO( LOOP )
      ENDDO
C
C     Return the number of values, the unpacked array length
C
      OUTLEN = ISIZE
C
C ------------------------------------------------------------------
C*    Section 9.   Closedown.
C ------------------------------------------------------------------
C
  900 CONTINUE
C
C     Clear change flags for next product processing
C
      LCHANGE = .FALSE.
      LSMCHNG = .FALSE.
C
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities
C granted to it by virtue of its status as an intergovernmental organisation
C nor does it submit to any jurisdiction.
C

      INTEGER FUNCTION IGNORM (PWFACT, PSUM, KOWE, KONS, KPR, KERR)
C
C---->
C**** *IGNORM*
C
C     PURPOSE
C     _______
C
C     Normalise the array of interpolation weights.
C
C     INTERFACE
C     _________
C
C     IERR = IGNORM (PWFACT, PSUM, KOWE, KONS, KPR, KERR)
C
C     Input parameters
C     ________________
C
C     PWFACT     - The array of unnormalised interpolating weights to
C                  the four neighbouring points for every output point.
C
C     PSUM       - Work array used to aid vectorisation.
C
C     KOWE       - The number of points in the West-East direction in
C                  the output field.
C
C     KONS       - The number of points in the North-South direction
C                  in the output field.
C
C     KPR        - The debug print switch.
C                  0  , No debugging output.
C                  1  , Produce debugging output.
C
C     KERR       - The error control flag.
C                  -ve, No error message. Return error code.
C                  0  , Hard failure with error message.
C                  +ve, Print error message. Return error code.
C
C     Output parameters
C     ________________
C
C     PWFACT     - The normalised array of interpolating weights to
C                  the four neighbouring points for every output point.
C
C     Return value
C     ____________
C
C     The error indicator (INTEGER).
C
C     Error and Warning Return Values
C     _______________________________
C
C     None
C
C     Common block usage
C     __________________
C
C     None
C
C     EXTERNALS
C     _________
C
C     INTLOG(R)    - Logs messages.
C
C     METHOD
C     ______
C
C     The four weights for each output point are normalised to have a
C     sum of one.
C
C     REFERENCE
C     _________
C
C     None
C
C     COMMENTS
C     ________
C
C     Program contains sections 0 to 2 and 9
C
C     AUTHOR
C     ______
C
C     K. Fielding      *ECMWF*      Oct 1993
C
C     MODIFICATIONS
C     _____________
C
C     None
C
C----<
C     _______________________________________________________
C
C
C*    Section 0. Definition of variables.
C     _______________________________________________________
C
C*    Prefix conventions for variable names
C
C     Logical      L (but not LP), global or common.
C                  O, dummy argument
C                  G, local variable
C                  LP, parameter.
C     Character    C, global or common.
C                  H, dummy argument
C                  Y (but not YP), local variable
C                  YP, parameter.
C     Integer      M and N, global or common.
C                  K, dummy argument
C                  I, local variable
C                  J (but not JP), loop control
C                  JP, parameter.
C     REAL         A to F and Q to X, global or common.
C                  P (but not PP), dummy argument
C                  Z, local variable
C                  PP, parameter.
C
C     Implicit statement to force declarations
C
      IMPLICIT NONE
C
#include "parim.h"
C
C     Dummy arguments
      INTEGER KOWE, KONS, KPR, KERR
      REAL PWFACT (4, KOWE, KONS), PSUM (KOWE)
C
C     Local variables
      INTEGER JOLAT, JOLON, JDIR
      INTEGER JPROUTINE
      PARAMETER (JPROUTINE = 25600)
C
C     _______________________________________________________
C
C*    Section 1. Initialisation
C     _______________________________________________________
C
  100 CONTINUE
C
      IF (KPR.GE.1) CALL INTLOG(JP_DEBUG,'IGNORM: Section 1.',JPQUIET)
C
      IGNORM = 0
C
      IF (KPR .GE. 1) THEN
        CALL INTLOG(JP_DEBUG,'IGNORM: No of output longitudes = ',KOWE)
        CALL INTLOG(JP_DEBUG,'IGNORM: No of output latitudes  = ',KONS)
      ENDIF
C
C     _______________________________________________________
C
C*    Section 2. Calculate arrays of weights
C     _______________________________________________________
C
  200 CONTINUE
C
      IF (KPR.GE.1) CALL INTLOG(JP_DEBUG,'IGNORM: Section 2.',JPQUIET)
C
      DO 260 JOLAT = 1, KONS
C
         DO 210 JOLON = 1, KOWE
C
            PSUM (JOLON) = PPZERO
C
  210    CONTINUE
C
         DO 230 JDIR = 1, 4
            DO 220 JOLON = 1, KOWE
C
               PSUM (JOLON) = PSUM (JOLON) +
     1            PWFACT (JDIR, JOLON, JOLAT)
C
  220       CONTINUE
  230    CONTINUE
C
         DO 250 JDIR = 1, 4
            DO 240 JOLON = 1, KOWE
C
               PWFACT (JDIR, JOLON, JOLAT) =
     1            PWFACT (JDIR, JOLON, JOLAT) / PSUM (JOLON)
C
  240       CONTINUE
  250    CONTINUE
C
  260 CONTINUE
C
C     _______________________________________________________
C
C*    Section 9. Return to calling routine. Format statements
C     _______________________________________________________
C
  900 CONTINUE
C
      IF (KPR.GE.1) CALL INTLOG(JP_DEBUG,'IGNORM: Section 9.',JPQUIET)
C
C
      RETURN
      END

C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      INTEGER FUNCTION HSP2GG(KTRUNC,KGAUSS,KPTS,PLATS,KSIZE)
C
C---->
C**** HSP2GG
C
C     Purpose
C     -------
C
C     This routine finds a suitable gaussian grid for a given
C     spectral truncation.
C
C
C     Interface
C     ---------
C
C     IRET = HSP2GG(KTRUNC,KGAUSS,KPTS,KSIZE)
C
C
C     Input parameters
C     ----------------
C
C     KTRUNC - The spectral truncation
C
C
C     Output parameters
C     -----------------
C
C     KGAUSS - The gaussian number
C     KPTS   - Array giving number of points along each line of latitude
C              in the reduced gaussian grid (both hemispheres)
C     PLATS  - Array giving gaussian latitudes (both hemispheres)
C     KSIZE  - The number of points in the reduced gaussian grid
C
C     Returns 0 if all OK, otherwise there is an error.
C
C
C     Common block usage
C     ------------------
C
C     None
C
C
C     Method
C     ------
C
C     None
C
C
C     Externals
C     ---------
C
C     JGETGG - Reads the definition of a gaussian grid
C
C
C     Reference
C     ---------
C
C     None.
C
C
C     Comments
C     --------
C
C     None.
C
C
C     Author
C     ------
C
C     J.D.Chambers      ECMWF      February 2001
C
C
C     Modifications
C     -------------
C
C     S.Curic     ECMWF      March 2005
C     Added checking for a automatic trancation T255, T399, T799, T2047 
C     and corresponding gaussian grid.
C
C     S.Curic     ECMWF      April 2008
C     Added checking for a automatic trancation T1279
C     and corresponding gaussian grid.
C
C
C     S.Curic     ECMWF      Semptember 2009
C     Match T255 and T213 against N128 instead of N160
C     upon Alan Geer request
C
C----<
C     -----------------------------------------------------------------|
C*    Section 0. Definition of variables.
C     -----------------------------------------------------------------|
C
      IMPLICIT NONE
C
#include "parim.h"
C
C     Function arguments
C
      INTEGER KTRUNC, KGAUSS, KPTS(*), KSIZE
      REAL PLATS(*)
C
C     Local variables
C
      INTEGER LOOP, IRET
C
C
C     -----------------------------------------------------------------|
C     Section 1.  Initialise.
C     -----------------------------------------------------------------|
C
  100 CONTINUE
C
      HSP2GG = 0
C
      IF( (KTRUNC.EQ.2047).OR.(KTRUNC.EQ.2048) ) THEN      ! Mariano
        KGAUSS = 1024
      ELSE IF( (KTRUNC.EQ.1279).OR.(KTRUNC.EQ.1280) ) THEN ! Jan Haseler
        KGAUSS = 640
      ELSE IF( (KTRUNC.EQ.799).OR.(KTRUNC.EQ.800) ) THEN   ! Oper 2005
        KGAUSS = 400
      ELSE IF( (KTRUNC.EQ.639).OR.(KTRUNC.EQ.640) ) THEN
        KGAUSS = 320
      ELSE IF( (KTRUNC.EQ.511).OR.(KTRUNC.EQ.512) ) THEN   ! Oper 2004
        KGAUSS = 256
      ELSE IF( (KTRUNC.EQ.399).OR.(KTRUNC.EQ.400) ) THEN   ! Enfo 2005
        KGAUSS = 200
      ELSE IF( (KTRUNC.EQ.319).OR.(KTRUNC.EQ.320) ) THEN
        KGAUSS = 160
      ELSE IF( (KTRUNC.EQ.255).OR.(KTRUNC.EQ.256) ) THEN   ! Enfo 2004
        KGAUSS = 128
      ELSE IF( (KTRUNC.EQ.213).OR.(KTRUNC.EQ.214) ) THEN
        KGAUSS = 128
      ELSE IF( (KTRUNC.EQ.191).OR.(KTRUNC.EQ.192) ) THEN
        KGAUSS = 96
      ELSE IF( (KTRUNC.EQ.159).OR.(KTRUNC.EQ.160) ) THEN
        KGAUSS = 80
      ELSE IF( (KTRUNC.EQ.106).OR.(KTRUNC.EQ.107) ) THEN
        KGAUSS = 80
      ELSE IF( (KTRUNC.EQ.95) .OR.(KTRUNC.EQ.96 ) ) THEN
        KGAUSS = 48
      ELSE IF( (KTRUNC.EQ.63) .OR.(KTRUNC.EQ.64 ) ) THEN
        KGAUSS = 48
      ELSE
        CALL INTLOG(JP_ERROR,'HSP2GG: Unmatched truncation',KTRUNC)
        HSP2GG = 1
        GOTO 900
      ENDIF
C
C     Get the reduced gaussian grid information and count the
C     number of points.
C
      CALL JGETGG(KGAUSS,'R',PLATS,KPTS,IRET)
      IF( IRET.NE.0 ) THEN
        CALL INTLOG(JP_ERROR,
     X    'HSP2GG: JGETGG failed to get gaussian data',JPQUIET)
        HSP2GG = 2
        GOTO 900
      ENDIF
C
      KSIZE = 0
      DO LOOP = 1, KGAUSS*2
        KSIZE = KSIZE + KPTS(LOOP)
      ENDDO
C
C     -----------------------------------------------------------------|
C     Section 9.  Return.
C     -----------------------------------------------------------------|
C
  900 CONTINUE
C
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C


      SUBROUTINE REMSP (STRING)
C
C---->
C**** REMSP - Remove leading spaces from character string.
C     NAME       : REMSP
C
C     FUNCTION   : LEFT JUSTIFY CHARACTER STRING BY REMOVING
C                  ANY LEADING SPACES.
C
C     INPUT      : STRING = CHARACTER STRING, WITH OR WITHOUT
C                           LEADING SPACES.
C
C     OUTPUT     : STRING = CHARACTER STRING LEFT JUSTIFIED.
C
C         JOHN HENNESSY, ECMWF, 16TH APRIL 1985
C
C     ---------------------------------------------------------------
C----<
C
      CHARACTER*(*) STRING
C
      DO 100 I=1,LEN(STRING)
         IF (STRING(I:I).NE.' ') GO TO 200
  100 CONTINUE
C
C     Blank line.
C
      RETURN
C
C     Left justify string.
C
  200 STRING(1:) = STRING(I:)
C
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities
C granted to it by virtue of its status as an intergovernmental organisation
C nor does it submit to any jurisdiction.
C


      SUBROUTINE DECOGD (FPDATA,ILENF,IBITS,NBIT,IB1PAR,IB2PAR,
     C              IB3PAR,FVERT,ILENV,IGRIB,ILENG,IWORD,
     C              JLENV,JLENF,RMISS,IERR)
C
C---->
C*     NAME     : DECOGD
C*
C*     FUNCTION : DECODE WMO GRIB CODED DATA.
C*
C*     INPUT    : NBIT    - NUMBER OF BITS IN COMPUTER WORD
C*
C*                IGRIB   - INTEGER ARRAY CONTAINING DATA IN GRIB CODE.
C*                ILENG   - LENGTH OF ARRAY IGRIB.
C*
C*                FVERT   - REAL ARRAY TO RECEIVE VERTICAL COORDINATE
C*                          PARAMETERS.
C*                ILENV   - LENGTH OF ARRAY FVERT.
C*
C*                FPDATA  - REAL ARRAY TO RECEIVE DECODED DATA VALUES.
C*                ILENF   - LENGTH OF ARRAY FPDATA.
C*
C*                          *****  IF THIS IS 1 ONLY
C*                          THE PRODUCT AND GRID DEFINITION BLOCKS
C*                          ARE DECODED. *****
C*
C*                IB1PAR  - INTEGER ARRAY (DIMENSION 18) TO RECEIVE
C*                          PRODUCT DEFINITION INFORMATION.
C*
C*                IB2PAR  - INTEGER ARRAY (DIMENSION 11) TO RECEIVE GRID
C*                          DEFINITION INFORMATION.
C*
C*     OUTPUT   : PARAMETERS FROM BLOCK 1 , PRODUCT DEFINITION BLOCK.
C*                --------------------------------------------------
C*                IB1PAR  - INTEGER ARRAY (DIMENSION 18) OF PRODUCT
C*                          DEFINITION INFORMATION.
C*
C*                WORD      CONTENTS
C*                ----      --------
C*                  1       ORIGINATING CENTRE IDENTIFIER.
C*                  2       MODEL IDENTIFICATION.
C*                  3       GRID DEFINITION.
C*                  4       FLAG ( CODE TABLE 1)
C*                  5       PARAMETER IDENTIFIER ( CODE TABLE 2 ).
C*                  6       TYPE OF LEVEL (CODE TABLE 3).
C*                 7-8      VALUE(S) OF LEVELS (CODE TABLE 3).
C*                  9       YEAR OF DATA
C*                 10       MONTH OF DATA
C*                 11       DAY OF DATA
C*                 12       HOUR OF DATA
C*                 13       MINUTE OF DATA
C*                 14       TIME UNIT (CODE TABLE 4).
C*                 15       TIME RANGE ONE
C*                 16       TIME RANGE TWO
C*                 17       TIME RANGE FLAG (CODE TABLE 5).
C*                 18       NUMBER AVERAGED.
C*
C*                          VALUE(S) OF LEVEL CAN OCCUPY 2 WORDS..
C*                          FOR A LAYER THE FIRST WORD DEFINES THE TOP
C*                          AND THE SECOND THE BOTTOM OF THE LAYER.
C*                          FOR A SINGLE LEVEL, ONLY THE FIRST WORD IS
C*                          USED.
C*
C*                PARAMETERS FROM BLOCK 2 , GRID DEFINITION BLOCK.
C*                -----------------------------------------------
C*                IB2PAR - INTEGER ARRAY (DIMENSION 11) CONTAINING GRID
C*                         DEFINITION INFORMATION.
C*                         USE VARIES WITH DATA REPRESENTATION TYPE.
C*
C*                WORD      LAT/LONG GRID
C*                ----      -------------
C*                 1        DATA REPRESENTATION TYPE (CODE TABLE 6).
C*                 2        NO. OF POINTS ALONG A LATITUDE
C*                 3        NO. OF POINTS ALONG A MERIDIAN.
C*                 4        LATITUDE OF ORIGIN (SOUTH - IVE).
C*                 5        LONGITUDE OF ORIGIN (WEST - IVE).
C*                 6        RESOLUTION FLAG. (CODE TABLE 7)
C*                 7        LATITUDE OF EXTREME POINT (SOUTH - IVE).
C*                 8        LONGITUDE OF EXTREME POINT (WEST - IVE).
C*                 9        LATITUDE INCREMENT
C*                10        LONGITUDE INCREMENT
C*                11        SCANNING MODE FLAGS (CODE TABLE 8)
C*
C*                WORD      GAUSSIAN GRID
C*                ----      -------------
C*                1-9       AS FOR LAT/LONGITUDE GRID.
C*                10        THE NUMBER OF LATITUDE LINES BETWEEN A POLE
C*                          AND THE EQUATOR.
C*                11        SCANNING MODE FLAGS (CODE TABLE 8)
C*
C*                WORD      SPHERICAL HARMONICS
C*                ----      -------------------
C*                  1       DATA REPRESENTATION TYPE (CODE TABLE 6)
C*                  2       J - PENTAGONAL RESOLUTION PARAMETER
C*                  3       K - PENTAGONAL RESOLUTION PARAMETER
C*                  4       M - PENTAGONAL RESOLUTION PARAMETER
C*                  5       REPRESENTATION TYPE (CODE TABLE 9)
C*                  6       REPRESENTATION MODE (CODE TABLE 10)
C*                7-11      NOT USED
C*
C*
C*                USE FOR OTHER DATA REPRESENTATION TYPES IS
C*
C*                FVERT  - REAL ARRAY OF VERTICAL COORDINATE PARAMETERS
C*                JLENV  - NUMBER OF VALUES IN THIS ARRAY.
C*
C*                USED FOR HYBRID LEVELS ONLY.
C*
C*                PARAMETERS FROM BLOCK 3 , BIT-MAP DEFINITION BLOCK.
C*                --------------------------------------------------
C*
C*                IBMAP     -  ARRAY (DIMENSION IBLEN) CONTAINING BIT MA
C*                IBLEN     -  NUMBER OF WORDS IN ARRAY IBMAP.
C*                IBVAL     -  NUMBER OF VALUES ON THIS ARRAY.
C*                IERR      -  ERROR INDICATOR
C*                             -5, MISSING PREDEFINED BIT MAP.
C*
C*
C*                PARAMETERS FROM BLOCK 4 , BINARY DATA BLOCK.
C*                -------------------------------------------
C*                FPDATA  - ARRAY OF FLOATING POINT VALUES.
C*                JLENF   - NUMBER OF VALUES IN THIS ARRAY.
C*                          JLENF IS NEGATIVE IF MISSING DATA CODED
C*
C*                IBITS   - NUMBER OF BITS FOR CODED DATA VALUES.
C*
C*                IWORD   - NUMBER OF WORDS DECODED.
C*
C*                IERR    - ERROR INDICATOR.
C*
C*                          0, NO ERROR.
C*
C*                         -1, NUMBER OF BITS PER DATA VALUE EXCEEDS
C*                             WORD LENGTH, OR MAXIMUM ALLOWED.
C*                         -2, INPUT ARRAY HOLDS FEWER CODED VALUES
C*                             THAN EXPECTED.
C*                         -3, OUTPUT ARRAY TOO SMALL TO HOLD DECODED
C*                             DATA VALUES.
C*                         -4, CURRENTLY UNDEFINED OPTION SELECTED.
C*
C*                          1, NO BLOCK 5 FOUND.
C*
C*    GENERAL  : DECOGD CALLS GBYTE
C*                            GBYTES
C*                            OFFSET
C*                            DECFP
C*                            SBYTE
C*
C*   Modifications
C*   -------------
C
C940309     J.D.Chambers     ECMWF      09:03:94
C940309     Maximum size for bitmap array increased to 132000
C940309     to allow for products 0.5 * 0.5 degrees, whole
C940309     hemisphere (N or S).
C*
C     ---------------------------------------------------------------
C----<
C
C
C
C
C
C
C
C
C
      DIMENSION FPDATA(ILENF),FVERT(ILENV)
      DIMENSION IBLOCK(24),IGRIB(ILENG)
      DIMENSION IB1PAR(18),IB2PAR(11),IB3PAR(2),ILAT(2)
C
C940309 INTEGER*4 IBMAP(41472)
      INTEGER*4 IBMAP(132000)
C940309 DIMENSION FPDATAG(41472)
      DIMENSION FPDATAG(132000)
      CHARACTER*20 BITMAP
      CHARACTER YCHAR
C
      EQUIVALENCE (ZGRIB,JGRIB)
C
C     SET MAXIMUM NUMBER OF BITS PER DATA FIELD.
C
      DATA IMAX /32/
C
      ZSCALE = 0.
      IERR = 0
C
      RMISS=1.7E38
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C********************************************************************
C*
C*    BLOCK 0 - INDICATOR BLOCK.
C*
C********************************************************************
C
C
C     EXTRACT 4 OCTETS CONTAINING ASCII G R I B .
C
      IWORD = 1
      IOFF  = 0
      IBYTE = 8
      NVAL  = 4
C
      CALL GBYTES (IGRIB(1),IBLOCK(1),0,IBYTE,0,NVAL)
      CALL OFFSET (IOFF,NVAL,IWORD,IBYTE,NBIT,ILENG,IERR)
      IF (IERR.NE.0) RETURN
C
C
C
C
C
C
C
C********************************************************************
C*
C*    BLOCK 1 - PRODUCT DEFINITION BLOCK.
C*
C********************************************************************
C
C
C     EXTRACT FIRST 4 OCTETS OF BLOCK 1.
C
      NVAL  = 4
C
      CALL GBYTES (IGRIB(IWORD),IBLOCK(1),IOFF,IBYTE,0,NVAL)
      CALL OFFSET (IOFF,NVAL,IWORD,IBYTE,NBIT,ILENG,IERR)
      IF (IERR.NE.0) RETURN
C
C     IF THESE OCTETS DO NOT CONTAIN 0, 0, 24 AND 0 RESPECTIVELY
C     THEN THE DATA IS IN THE OLD VERSION OF THE CODE.
C
      IF (IBLOCK(1).EQ.0.AND.IBLOCK(2).EQ.0.AND.IBLOCK(3).EQ.24.
     C    AND.IBLOCK(4).EQ.0)
     C      THEN
                ISNEW = 1
                NVAL = 20
            ELSE
                ISNEW = 0
                NVAL = 16
            ENDIF
C
C     EXTRACT NEXT 16 OR 20 OCTETS OF BLOCK 1 - NUMBER DEPENDS
C     ON VERSION OF CODE.
C
      CALL GBYTES (IGRIB(IWORD),IBLOCK(5),IOFF,IBYTE,0,NVAL)
      CALL OFFSET (IOFF,NVAL,IWORD,IBYTE,NBIT,ILENG,IERR)
      IF (IERR.NE.0) RETURN
C
C     TRANSFER PRODUCT DEFINITION INFORMATION TO OUTPUT ARRAY.
C     EXCEPT FOR NUMBER AVERAGED.
C
      DO 100 I=1,17
         IB1PAR(I) = IBLOCK(I+4*ISNEW)
  100 CONTINUE
C
C
C
C
C     NUMBER AVERAGED OCCUPIES 2 OCTETS.
C
      IB1PAR(18) = IBLOCK(18+4*ISNEW) * 256 + IBLOCK(19+4*ISNEW)
C
C
C
C
C
C***
C*    DESCRIPTION OF LEVEL OR LAYER ( CODE TABLE 3 ).
C***
C
C     CERTAIN LEVEL TYPES REQUIRE THAT THE DESCRIPTION OCCUPY
C     BOTH 8 BIT FIELDS. PUT SINGLE VALUE IN FIRST LEVEL WORD.
C
      KTEMP = 32 + (ISNEW*224)
      IF (IB1PAR(6).EQ.100.OR.IB1PAR(6).EQ.103.OR.IB1PAR(6).EQ.105.
     C    OR.IB1PAR(6).EQ.107.OR.IB1PAR(6).EQ.109)
     C    THEN
              IB1PAR(7) = IB1PAR(7) * KTEMP + IB1PAR(8)
              IB1PAR(8) = 0
          ENDIF
C
C
C
C
C
C
C
C
C
C***
C*    TIME RANGE.
C***
C
C     ONE TIME RANGE CAN OCCUPY TWO OCTETS.
C
      IF (IB1PAR(17).EQ.10)
     C   THEN
             IB1PAR(15) = IB1PAR(15) * KTEMP + IB1PAR(16)
             IB1PAR(16) = 0
         ENDIF
C
C
C
C
C
C
C
C
C
C
C
C********************************************************************
C*
C*    BLOCK 2 - GRID DESCRIPTION BLOCK.
C*
C********************************************************************
C
C***
C*    CHECK FLAG INDICATING IF BLOCK 2 IS INCLUDED IN CODE.
C***
C
C     INC IS SET TO 1 , IF BLOCK 2 IS INCLUDED.
C
      INC = 0
C
C
      IF (ISNEW.EQ.0)
     C   THEN
C            OLD VERSION OF CODE
C
C            BLOCKS INCLUDED    BINARY VALUE      DECIMAL VALUE
C
C                NONE             00000000               0
C                 2               00000001               1
C                 3               00000010               2
C             2 AND 3             00000011               3
C
             IF (IB1PAR(4).EQ.1.OR.IB1PAR(4).EQ.3) INC = 1
         ELSE
C            NEW VERSION
C
C            BLOCKS INCLUDED    BINARY VALUE      DECIMAL VALUE
C
C                NONE             00000000               0
C                 2               10000000             128
C                 3               01000000              64
C             2 AND 3             11000000             192
C
             IF (IB1PAR(4).EQ.128.OR.IB1PAR(4).EQ.192) INC = 1
         ENDIF
C
      IF (INC.EQ.1)
     C   THEN
C
C
C***
C*           LENGTH OF GRID DESCRIPTION BLOCK.
C***
C
             CALL GBYTE (IGRIB(IWORD),LBLK,IOFF,24)
             CALL OFFSET (IOFF,1,IWORD,24,NBIT,ILENG,IERR)
             IF (IERR.NE.0) RETURN
C
C            LENGTH IS 32 OCTETS FOR LAT/LONG, GAUSSIAN AND SPHERICAL
C            HARMONICS . FOR ANY DATA  ON HYBRID LEVELS THE
C            VERTICAL COORDINATES ARE ADDED.
C            GET NUMBER OF VERTICAL COORDINATE PARAMETERS, IF ANY.
C
             JLENV = (LBLK - 32) / 4
             IF(ILENV.LT.JLENV)
     C          THEN
                    IERR = -3
                    WRITE (*,9001) JLENV,ILENV
 9001               FORMAT (1H ,'NUMBER OF VERTICAL COORDINATES - ',I4,
     C                          ', ARRAY SIZE IS - ',I4)
                    RETURN
                ENDIF
C
C
C***
C*           NUMBER OF UNUSED BITS AT END OF BLOCK.
C***
C
             CALL GBYTE (IGRIB(IWORD),LNIL,IOFF,8)
             CALL OFFSET (IOFF,1,IWORD,8,NBIT,ILENG,IERR)
             IF (IERR.NE.0) RETURN
C
C
C
C
C***
C*           NEXT OCTET IS RESERVED.
C***
C
             CALL OFFSET (IOFF,1,IWORD,8,NBIT,ILENG,IERR)
             IF (IERR.NE.0) RETURN
C
C
C
C
C
C
C
C***
C*           DATA REPRESENTATION TYPE.
C***
C
             CALL GBYTE (IGRIB(IWORD),IB2PAR(1),IOFF,8)
             CALL OFFSET (IOFF,1,IWORD,8,NBIT,ILENG,IERR)
             IF (IERR.NE.0) RETURN
C
C            LAT/LONGITUDE GRID, GAUSSIAN GRID AND SPHERICAL HARMONICS
C            ARE THE ONLY DATA REPRESENTATIONS HANDLED.
C
             IF (IB2PAR(1).NE.0.AND.IB2PAR(1).NE.4.AND.IB2PAR(1).NE.50)
     C          THEN
                     WRITE (*,*)'GRID DESCRIPTION BLOCK NOT YET DEFINED'
                     IERR = -4
                     RETURN
                ENDIF
C
C
C
C
C***
C*           LAT/LONG OR GAUSSIAN GRID.
C***
C
             IF (IB2PAR(1).EQ.0.OR.IB2PAR(1).EQ.4)
     C         THEN
C
C                  NUMBER OF LAT/LONG POINTS.
C
                   CALL GBYTES (IGRIB(IWORD),IB2PAR(2),IOFF,16,0,2)
                   CALL OFFSET (IOFF,2,IWORD,16,NBIT,ILENG,IERR)
                   IF (IERR.NE.0) RETURN
C
C                  LAT/LONG OF ORIGIN.
C
                   CALL GBYTES (IGRIB(IWORD),ILAT(1),IOFF,24,0,2)
                   CALL OFFSET (IOFF,2,IWORD,24,NBIT,ILENG,IERR)
                   IF (IERR.NE.0) RETURN
C
C                  IF SIGN BIT SET TO 1 , VALUES ARE NEGATIVE.
C
                   DO 200 I=1,2
                      IB2PAR(I+3) = ILAT(I)
                      IF (ILAT(I).GT.8388608)
     C                   THEN
                             IB2PAR(I+3) = IB2PAR(I+3) - 8388608
                             IB2PAR(I+3) = - IB2PAR(I+3)
                         ENDIF
  200             CONTINUE
C
C
C                  RESOLUTION FLAG.
C
                   CALL GBYTE (IGRIB(IWORD),IB2PAR(6),IOFF,8)
                   CALL OFFSET (IOFF,1,IWORD,8,NBIT,ILENG,IERR)
                   IF (IERR.NE.0) RETURN
C
C
C                  LAT/LONG OF EXTREME POINTS.
C
                   CALL GBYTES (IGRIB(IWORD),ILAT(1),IOFF,24,0,2)
                   CALL OFFSET (IOFF,2,IWORD,24,NBIT,ILENG,IERR)
                   IF (IERR.NE.0) RETURN
C
C                  IF SIGN BIT SET TO 1 , VALUES ARE NEGATIVE.
C
                   DO 300 I=1,2
                      IB2PAR(I+6) = ILAT(I)
                      IF (ILAT(I).GT.8388608)
     C                   THEN
                             IB2PAR(I+6) = IB2PAR(I+6) - 8388608
                             IB2PAR(I+6) = - IB2PAR(I+6)
                         ENDIF
  300             CONTINUE
C
C                 DIRECTION INCREMENTS / NUMBER OF LATITUDE LINES.
C
                  CALL GBYTES (IGRIB(IWORD),IB2PAR(9),IOFF,16,0,2)
                  CALL OFFSET (IOFF,2,IWORD,16,NBIT,ILENG,IERR)
                  IF (IERR.NE.0) RETURN
C
C                 SCANNING MODE FLAGS.
C
                  CALL GBYTE (IGRIB(IWORD),IB2PAR(11),IOFF,8)
                  CALL OFFSET (IOFF,1,IWORD,8,NBIT,ILENG,IERR)
                  IF (IERR.NE.0) RETURN
C
C                 4 RESERVED OCTETS.
C
                  CALL OFFSET (IOFF,4,IWORD,8,NBIT,ILENG,IERR)
                  IF (IERR.NE.0) RETURN
C
              ENDIF
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C***
C*            SPHERICAL HARMONIC DATA.
C***
C
              IF (IB2PAR(1).EQ.50)
     C           THEN
C
C                    PENTAGONAL RESOLUTION PARAMETERS.
C
                     CALL GBYTES (IGRIB(IWORD),IB2PAR(2),IOFF,16,0,3)
                     CALL OFFSET (IOFF,3,IWORD,16,NBIT,ILENG,IERR)
                     IF (IERR.NE.0) RETURN
C
C                    REPRESENTATION TYPE AND MODE.
C
                     CALL GBYTES (IGRIB(IWORD),IB2PAR(5),IOFF,8,0,2)
                     CALL OFFSET (IOFF,2,IWORD,8,NBIT,ILENG,IERR)
                     IF (IERR.NE.0) RETURN
C
C                    18 RESERVED OCTETS.
C
                     CALL OFFSET (IOFF,18,IWORD,8,NBIT,ILENG,IERR)
                     IF (IERR.NE.0) RETURN
C
                 ENDIF
C
C
C
C
C***
C*               VERTICAL COORDINATE PARAMETERS FOR HYBRID LEVELS.
C***
C
                 IF (JLENV.NE.0)
     C              THEN
                        DO 400 I=1,JLENV
                           CALL GBYTE (IGRIB(IWORD),IEXP,IOFF,8)
                           CALL OFFSET (IOFF,1,IWORD,8,NBIT,ILENG,IERR)
                           IF (IERR.NE.0) RETURN
                           CALL GBYTE (IGRIB(IWORD),IMANT,IOFF,24)
                           CALL OFFSET (IOFF,1,IWORD,24,NBIT,ILENG,IERR)
                           IF (IERR.NE.0) RETURN
                           CALL DECFP (FVERT(I),IEXP,IMANT)
  400                   CONTINUE
                    ENDIF
C
         ENDIF
C
C
C     RETURN IF ONLY PRODUCT AND GRID DEFINITION BLOCKS REQUIRED.
C
      IF (ILENF.EQ.1) RETURN
C
C
C
C
C
C
C
C
C********************************************************************
C*
C*    BLOCK 3 - BIT MAP BLOCK.
C*
C********************************************************************
C
C     INC IS SET TO 1 , IF BLOCK 3 IS INCLUDED.
C
      INC = 0
C
C
      IF (ISNEW.EQ.0)
     C   THEN
C            OLD VERSION OF CODE
C
C            BLOCKS INCLUDED    BINARY VALUE      DECIMAL VALUE
C
C                NONE             00000000               0
C                 2               00000001               1
C                 3               00000010               2
C             2 AND 3             00000011               3
C
             IF (IB1PAR(4).EQ.2.OR.IB1PAR(4).EQ.3) INC = 1
         ELSE
C            NEW VERSION
C
C            BLOCKS INCLUDED    BINARY VALUE      DECIMAL VALUE
C
C                NONE             00000000               0
C                 2               10000000             128
C                 3               01000000              64
C             2 AND 3             11000000             192
C
             IF (IB1PAR(4).EQ.64.OR.IB1PAR(4).EQ.192) INC = 1
         ENDIF
C
      IF (INC.EQ.1)
     C     THEN
C
C
C*            GET LENGTH OF THE BIT MAP BLOCK
C
C
      CALL GBYTE (IGRIB(IWORD),IB3LEN,IOFF,24)
      CALL OFFSET(IOFF,1,IWORD,24,NBIT,ILENG,IERR)
      IF( IERR.NE.0 ) RETURN
C
C
C*            GET NUMBER OF UNUSED BITS AT THE END OF THE BLOCK 3.
C
C
      CALL GBYTE(IGRIB(IWORD),INUB,IOFF,8)
      CALL OFFSET(IOFF,1,IWORD,8,NBIT,ILENG,IERR)
      IF( IERR.NE.0 ) RETURN
C
C*            CHECK IF BIT MAP FOLLOWS
C
      CALL GBYTE (IGRIB(IWORD),IBMF,IOFF,16)
      CALL OFFSET(IOFF,1,IWORD,16,NBIT,ILENG,IERR)
      IF( IERR.NE.0 ) RETURN
C
      IB3PAR(1)=IBMF
C
      IF( IBMF.EQ.0 )
     1   THEN
            IBVAL=(IB3LEN-6)*8-INUB
C
C940309     IF(IBVAL.GT.41472) THEN
            IF(IBVAL.GT.132000) THEN
               IERR=-3
               WRITE(*,8888) IBVAL
 8888          FORMAT(1H ,'BIT MAP ARRAY TOO SMALL - IBVAL =',I12)
               RETURN
            END IF

            DO 450 J=1,IBVAL
C
             CALL GBYTE(IGRIB(IWORD),IBMAP(J),IOFF,1)
             CALL OFFSET(IOFF,1,IWORD,1,NBIT,ILENG,IERR)
             IF(IERR.NE.0) RETURN
C
 450         CONTINUE
C
             CALL OFFSET(IOFF,1,IWORD,INUB,NBIT,ILENG,IERR)
C
           ELSE
C
C*            GET PREDEFINED BIT MAP
C
              WRITE(YCHAR,'(I5)') IBMF
C
              BITMAP='BIT_MAP_'//YCHAR//'.DAT'
C
              OPEN(UNIT=10,IOSTAT=IOS,ERR=455,FILE=BITMAP,
     1        FORM='UNFORMATTED',STATUS='OLD')
C
              READ(10) IBVAL,IBLEN,(IBMAP(I),I=1,IBLEN)
C
              CLOSE(10)
C
              GO TO 460
C
 455          CONTINUE
C
              IERR=-5
              WRITE(*,9906) IOS
 9906         FORMAT(1H ,'ERROR ON UNIT 10, ERROR NO. ',I6)
              RETURN
C
 460          CONTINUE
C
           ENDIF
C
C
       END IF
C
C
C
C********************************************************************
C*
C*    BLOCK 4 - BINARY DATA BLOCK.
C*
C********************************************************************
C
C
C
C***
C*    GET LENGTH OF BINARY DATA BLOCK.
C***
C
C
      IPW = IWORD
      IPB = IOFF
C
      CALL GBYTE (IGRIB(IWORD),LBIN,IOFF,24)
      CALL OFFSET (IOFF,1,IWORD,24,NBIT,ILENG,IERR)
      IF (IERR.NE.0) RETURN
C
C
C
C
C***
C*    4 BIT FLAG / 4 BIT COUNT OF UNUSED BITS AT END OF BLOCK OCTET.
C***
C
      CALL GBYTE (IGRIB(IWORD),IFLAG,IOFF,8)
      CALL OFFSET (IOFF,1,IWORD,8,NBIT,ILENG,IERR)
      IF (IERR.NE.0) RETURN
C
      IF (ISNEW.EQ.0)
     C    THEN
C             OLD VERSION OF CODE
C
C             0000---- GRID POINT
C             0001---- SPHERICAL HARMONICS
C
              IREP = IFLAG / 16
              LNIL = IFLAG - IREP * 16
C
          ELSE
C             NEW VERSION OF CODE
C
C             0000---- GRID POINT
C             1000---- SPHERICAL HARMONICS
C
              IREP = IFLAG / 128
              LNIL = IFLAG - IREP * 128
C
          ENDIF
C
C
C
C
C
C
C
C
C***
C*    GET SCALE FACTOR
C***
C
      CALL GBYTE (IGRIB(IWORD),JSCALE,IOFF,16)
      CALL OFFSET (IOFF,1,IWORD,16,NBIT,ILENG,IERR)
      IF (IERR.NE.0) RETURN
C
      ISCALE = JSCALE
      IF (JSCALE.GE.32768)
     C    THEN
              ISCALE = ISCALE - 32768
              ISCALE = - ISCALE
          ENDIF
C
C
C
C
C***
C*    GET REFERENCE VALUE (FMIN) IN GRIB FORMAT (IEXP,IMANT)
C***
C
C
      CALL GBYTE (IGRIB(IWORD),IEXP,IOFF,8)
      CALL OFFSET (IOFF,1,IWORD,8,NBIT,ILENG,IERR)
      IF (IERR.NE.0) RETURN
      CALL GBYTE (IGRIB(IWORD),IMANT,IOFF,24)
      CALL OFFSET (IOFF,1,IWORD,24,NBIT,ILENG,IERR)
      IF (IERR.NE.0) RETURN
C
C
C     CHECK FOR MISSING DATA INDICATORS.
C
      IMISS = 0
      IF (JSCALE.EQ.65535.AND.IEXP.EQ.255.AND.IMANT.EQ.16777215)
     C   IMISS = 1
C
C     CONVERT REFERENCE VALUE AND SCALE FACTOR.
C
      IF (IMISS.EQ.0)
     C   THEN
             CALL DECFP (FMIN,IEXP,IMANT)
             ZSCALE = 2.**ISCALE
         ENDIF
C
C
C
C
C***
C*    GET NUMBER OF BITS IN EACH DATA VALUE.
C***
C
      CALL GBYTE (IGRIB(IWORD),IBITS,IOFF,8)
      CALL OFFSET (IOFF,1,IWORD,8,NBIT,ILENG,IERR)
      IF (IERR.NE.0) RETURN
C
C
C     CHECK NUMBER OF BITS PER DATA FIELD.
C
      IF (IBITS.GT.NBIT.OR.IBITS.GT.IMAX)
     C    THEN
              IERR = -1
              WRITE (*,9002) IBITS,NBIT,IMAX
 9002         FORMAT (1H ,'NUMBER OF BITS PER DATA VALUE, ',I3,
     C                'EXCEEDS WORD LENGTH, ',I3,' OR MAXIMUM ',
     C                ' PERMITTED VALUE, ',I3)
              RETURN
          ENDIF
C
C***
C*    IF DATA IS IN SPHERICAL HARMONIC FORM, NEXT 4 OCTETS
C*    CONTAIN THE REAL (0,0) COEFFICIENT.
C***
C
      IF (IREP.EQ.1)
     C    THEN
C
C            GET REAL (0,0) COEFFICIENT IN GRIB FORMAT AND
C            CONVERT TO FLOATING POINT.
C
             CALL GBYTE (IGRIB(IWORD),IEXP,IOFF,8)
             CALL OFFSET (IOFF,1,IWORD,8,NBIT,ILENG,IERR)
             IF (IERR.NE.0) RETURN
             CALL GBYTE (IGRIB(IWORD),IMANT,IOFF,24)
             CALL OFFSET (IOFF,1,IWORD,24,NBIT,ILENG,IERR)
             IF (IERR.NE.0) RETURN
             IF (IMISS.EQ.1)
     C          THEN
                    FPDATA(1) = 0.0
                ELSE
                    CALL DECFP (FPDATA(1),IEXP,IMANT)
                ENDIF
          ENDIF
C
C
C
C
C*****
C*    DECODE DATA VALUES TO FLOATING POINT AND STORE IN FPDATA.
C*****
C
C     FIRST CALCULATE THE NUMBER OF DATA VALUES.
C
      JLENF = LBIN - 11 - IREP * 4
      JLENF = (JLENF * 8 - LNIL) / IBITS
C
C     CHECK LENGTH OF OUTPUT ARRAY.
C
      IF (JLENF+IREP.GT.ILENF)
     C   THEN
             IERR = -3
             WRITE (*,9003) JLENF,ILENF
 9003        FORMAT (1H ,'NUMBER OF VALUES TO BE DECODED IS - ',I7,
     C                    ', ARRAY SIZE - ',I7)
             RETURN
         ENDIF
C
      CALL GBYTES (IGRIB(IWORD),FPDATA(IREP+1),IOFF,IBITS,0,JLENF)
      CALL OFFSET (IOFF,JLENF,IWORD,IBITS,NBIT,ILENG,IERR)
      IF (IERR.NE.0) RETURN
C
      DO 500 I= IREP+1,IREP+JLENF
            IF (IMISS.EQ.1)
     C         THEN
                   FPDATA(1) = 0.0
               ELSE
                   ZGRIB     = FPDATA (I)
                   FPDATA(I) = FMIN + JGRIB * ZSCALE
               ENDIF
  500 CONTINUE
C
C     INCLUDE (0,0) COEFFICIENT IN COUNT, IF SPHERICAL HARMONIC DATA.
C
      JLENF = IREP + JLENF
C
C
C
C
C***
C*    SKIP ANY ZERO FILL AT END OF DATA BLOCK.
C***
C
      L = (IWORD-IPW) * NBIT + IOFF -IPB
      L = LBIN * 8 - L
      IF (L.NE.0)
     C    THEN
              CALL OFFSET (IOFF,1,IWORD,L,NBIT,ILENG,IERR)
              IF (IERR.NE.0) RETURN
          ENDIF
C
C      !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
C*         IF BIT MAP PRESENT FILL MISSING VALUES BY RMISS.
C
      IF(IB1PAR(4).EQ.64.OR.IB1PAR(4).EQ.192) THEN
C
         JI=0
         DO 647 J=1,IBVAL
         IF(IBMAP(J).EQ.0) THEN
            FPDATAG(J)=RMISS
         ELSE
            JI=JI+1
            FPDATAG(J)=FPDATA(JI)
         END IF
 647     CONTINUE
C
         JLENF = IBVAL
         DO 649 I=1,JLENF
         FPDATA(I)=FPDATAG(I)
 649     CONTINUE
C
      END IF
C
C********************************************************************
C*
C*    BLOCK 5 - END BLOCK.
C*
C********************************************************************
C
C     CHECK 7 7 7 7 AT END OF CODED DATA.
C
C
      CALL GBYTES (IGRIB(IWORD),IBLOCK(1),IOFF,8,0,4)
C
C     55 IS THE VALUE OF ASCII CHARACTER '7'
C
      DO 600 I=1,4
         IF (IBLOCK(I).NE.55) IERR = 1
  600 CONTINUE
C
      IF (IERR.EQ.1) WRITE (*,*) ' NO 7777 GROUP FOUND '
C
C
C
C     SET NUMBER OF VALUES NEGATIVE, IF MISSING DATA VALUES.
C
      IF (IMISS.EQ.1) JLENF = - JLENF
C
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE CREXPRS1(KSEC1,KSEC3,KTDLEN,KTDLST,KTDEXL,KTDEXP,
     1                    KELEM,CNAMES)
C
C**** *CREXPRS1*
C
C
C     PURPOSE.
C     --------
C           PRINT SECTION 1 OF CREX MESSAGE.
C
C
C**   INTERFACE.
C     ----------
C
C           *CALL* *CREXPRS1(KSEC1,KSEC3,KTDLEN,KTDLST,KTDEXL,KTDEXP,
C                            KELEM,CNAMES)*
C
C        INPUT :
C
C               *KSEC1*   -  ARRAY CONTAINING SECTION 1 INFORMATION
C                            KSEC1( 1)-- Not used
C                            KSEC1( 2)-- CREX EDITION NUMBER
C                            KSEC1( 3)-- Not used
C                            KSEC1( 4)-- Not Used
C                            KSEC1( 5)-- Not used
C                            KSEC1( 6)-- CREX MESSAGE TYPE
C                            KSEC1( 7)-- Not used
C                            KSEC1( 8)-- VERSION NUMBER OF LOCAL TABLE USED
C                            KSEC1( 9)-- Not used
C                            KSEC1(10)-- Not used
C                            KSEC1(11)-- Not used
C                            KSEC1(12)-- Not used
C                            KSEC1(13)-- Not used
C                            KSEC1(14)-- CREX MASTER TABLE
C                            KSEC1(15)-- VERSION NUMBER OF MASTER TABLE USED
C                            KSEC1(16) - KSEC1(JSEC1) -- Not used
C
C                            Crex Edition 2
C
C               *KSEC1*   -  Integer array of at least 40 words
C                            containing CREX section 1 information
C                            KSEC1( 1)-- Reserved
C                            KSEC1( 2)-- CREX Edition number
C                            KSEC1( 3)-- Originating Centre ( oooo)
C                            KSEC1( 4)-- Update sequence number (uu)
C                            KSEC1( 5)-- Number of subsets (sss)
C                            KSEC1( 6)-- CREX data category (nnn)
C                            KSEC1( 7)-- International data sub-category (mmm)
C                            KSEC1( 8)-- version number of local table used
C                            KSEC1( 9)-- Year (yyyy)
C                            KSEC1(10)-- Month (mm)
C                            KSEC1(11)-- Day (dd)
C                            KSEC1(12)-- Hour (hh)
C                            KSEC1(13)-- Minute (mm)
C                            KSEC1(14)-- CREX Master table (tt)
C                            KSEC1(15)-- version number of Master table used (vv)
C                            KSEC1(16)-- Originating sub-centre (ppp)
C                            KSEC1(17)-- Bufr master table version number
C                            KSEC1(18)-- Bufr version number of local table used
C                            KSEC1(19) - KSEC1(40) -- Reserved
C

C
C               *KSEC3*   -  Integer array of 4 words containing
C                            KSEC3( 1)-- Reserved
C                            KSEC3( 2)-- Reserved
C                            KSEC3( 3)-- number of subsets
C                            KSEC3( 4)-- Reserved

C               *KTDLEN*  -  number of data descriptors in section 1
C               *KTDLST*  -  array containing data descriptors in section 1
C               *KTDEXL*  -  number of entries in list of expanded data descriptors
C               *KTDEXP*  -  array containig expanded data descriptors
C               *KELEM*   -  Integer (expected number of expanded elements)
C               *CNAMES*  -  Character*64  array of KELEM containing
C                            CREX Table B element names
C
C
C     METHOD.
C     -------
C
C            NONE
C
C     EXTERNALS.
C     ----------
C
C            NONE.
C
C     REFERENCE.
C     ----------
C
C          NONE.
C
C     AUTHOR.
C     -------
C
C          MILAN DRAGOSAVAC    *ECMWF*       07/01/2004.
C
C     MODIFICATIONS.
C     --------------
C
C          NONE.
C
      IMPLICIT LOGICAL(L,O,G), CHARACTER*8(C,H,Y)
C
C
      DIMENSION KSEC1(*)
      DIMENSION KSEC3(*)
      DIMENSION KTDLST(KTDLEN),KTDEXP(KTDEXL)
C
      CHARACTER*64 CNAMES(KELEM)
      CHARACTER*6  YYYYYY

C
C     ------------------------------------------------------------------
C
C*          1.   PRINT SECTION 1.
C                ----------------
 100  CONTINUE
C
      WRITE(*,'(1H1)')
C
      WRITE(*,'(1H ,A)')    '        CREX SECTION 1    '
      WRITE(*,'(1H )')
      IF(KSEC1(2).LT.2) THEN
       WRITE(*,'(1H ,A,I5)')'CREX EDITION NUMBER            ',KSEC1( 2)
       WRITE(*,'(1H ,A,I5)')'CREX MESSAGE TYPE              ',KSEC1( 6)
       WRITE(*,'(1H ,A,I5)')'VERSION NUMBER OF LOCAL TABLE  ',KSEC1( 8)
       WRITE(*,'(1H ,A,I5)')'VERSION NUMBER OF MASTER TABLE ',KSEC1(15)
       WRITE(*,'(1H ,A,I5)')'CREX MASTER TABLE              ',KSEC1(14)
C
       WRITE(*,'(1H1)')
       WRITE(*,'(1H ,A,I5)')'NUMBER OF SUBSETS              ',KSEC3( 3)
      ELSE
       WRITE(*,'(1H ,A,I5)')'CREX EDITION NUMBER            ',KSEC1( 2)
       WRITE(*,'(1H ,A,I5)')'ORIGINATING CENTRE             ',KSEC1( 3)
       WRITE(*,'(1H ,A,I5)')'ORIGINATING SUB-CENTRE         ',KSEC1(16)
       WRITE(*,'(1H ,A,I5)')'UPDATE SEQUENCE NUMBER         ',KSEC1( 4)
       WRITE(*,'(1H ,A,I5)')'CREX DATA CATEGORY             ',KSEC1( 6)
       WRITE(*,'(1H ,A,I5)')'INTERNATIONAL DATA SUB-CATEGORY',KSEC1( 7)
       WRITE(*,'(1H ,A,I5)')'YEAR                           ',KSEC1( 9)
       WRITE(*,'(1H ,A,I5)')'MONTH                          ',KSEC1(10)
       WRITE(*,'(1H ,A,I5)')'DAY                            ',KSEC1(11)
       WRITE(*,'(1H ,A,I5)')'HOUR                           ',KSEC1(12)
       WRITE(*,'(1H ,A,I5)')'MINUTE                         ',KSEC1(13)
       WRITE(*,'(1H ,A,I5)')'VERSION NUMBER OF MASTER TABLE ',KSEC1(15)
       WRITE(*,'(1H ,A,I5)')'VERSION NUMBER OF LOCAL TABLE  ',KSEC1( 8)
       WRITE(*,'(1H ,A,I5)')'CREX MASTER TABLE              ',KSEC1(14)
       WRITE(*,'(1H ,A,I5)')'BUFR MASTER TABLE NUMBER       ',KSEC1(17)
       WRITE(*,'(1H ,A,I5)')'BUFR VERSION OF LOCAL TABLE    ',KSEC1(18)
C
       WRITE(*,'(1H1)')
       WRITE(*,'(1H ,A,I5)')'NUMBER OF SUBSETS              ',KSEC3( 3)
C
      END IF
C
C
      WRITE(*,'(1H ,//)')
      WRITE(*,'(1H ,A)')    '       DATA DESCRIPTORS (UNEXPANDED)'
      WRITE(*,'(1H )')
C
      WRITE(*,'(1H )')
      DO 110 I=1,KTDLEN
       write(yyyyyy,'(i6.6)') KTDLST(I)
       if(yyyyyy(1:1).eq.'0') yyyyyy(1:1)='B'
       if(yyyyyy(1:1).eq.'1') yyyyyy(1:1)='R'
       if(yyyyyy(1:1).eq.'2') yyyyyy(1:1)='C'
       if(yyyyyy(1:1).eq.'3') yyyyyy(1:1)='D'
       WRITE(*,'(1H ,I4,2X,A)') I,yyyyyy
 110  CONTINUE
C
      WRITE(*,'(1H ,/)')
      WRITE(*,'(1H ,A)')    '       DATA DESCRIPTORS (EXPANDED)'
      WRITE(*,'(1H )')
      DO 120 I=1,KTDEXL
       write(yyyyyy,'(i6.6)') KTDEXP(I)
       if(yyyyyy(1:1).eq.'0') yyyyyy(1:1)='B'
       if(yyyyyy(1:1).eq.'1') yyyyyy(1:1)='R'
       if(yyyyyy(1:1).eq.'2') yyyyyy(1:1)='C'
       if(yyyyyy(1:1).eq.'3') yyyyyy(1:1)='D'
       WRITE(*,'(1H ,I5,2X,A,2X,A)') I,yyyyyy,CNAMES(I)
 120  CONTINUE

      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities
C granted to it by virtue of its status as an intergovernmental organisation
C nor does it submit to any jurisdiction.
C

      INTEGER FUNCTION IGLSMD(KDATE,KREPR,KGRID,KGAUSS,KAREA,KLN,
     X   HFILE, OSTAND, KOGRID, KOLINE, KNREC, KPR, KERR)
C
C---->
C**** *IGLSMD*
C
C     PURPOSE
C     _______
C
C     Generate the land sea mask file information.
C
C     INTERFACE
C     _________
C
C     IERR = IGLSMD(KDATE,KREPR,KGRID,KGAUSS,KAREA,KLN,
C    X          HFILE, OSTAND, KOGRID, KOLINE, KNREC, KPR, KERR)
C
C     Input parameters
C     ________________
C
C     KDATE      - The field date in YYMMDD format
C
C     KREPR      - The field representation.
C
C     KGRID      - The latitude/longitude field grid definition
C                  (WE, NS) or Gaussian truncation.
C
C     KAREA      - The field area definition (N, W, S, E).
C
C     KLN        - The Northern line number. This is mainly used for
C                  Gaussian grids.
C
C     KPR        - The debug print switch.
C                  0  , No debugging output.
C                  1  , Produce debugging output.
C
C     KERR       - The error control flag.
C                  -ve, No error message. Return error code.
C                  0  , Hard failure with error message.
C                  +ve, Print error message. Return error code.
C
C     Output parameters
C     ________________
C
C     HFILE      - The filename for the land-sea mask.
C
C     OSTAND     - Flag indicating whether the land-sea mask is
C                  a prestored "standard" field.
C
C     KOGRID     - The grid stride (WE, NS) in a pre-stored
C                  "standard" land sea mask file.
C
C     KOLINE     - The offsets (N, W) of the first points in a
C                  pre-stored "standard" land sea mask file.
C
C     KNREC      - The file line length for the input array. This is
C                  used for positioning and transfer purposes.
C
C     Return value
C     ____________
C
C     The status indicator (INTEGER).
C          = 0 if OK,
C          = 25201 if data representation type is not valid.
C          = 25202 if unable to locate lsm file for reduced gaussian
C
C     EXTERNALS
C     _________
C
C     GETENV     - Standard routine to get environmental variable.
C     INTLOG(R)  - Logs messages.
C
C     METHOD
C     ______
C
C     NOTE This routine is highly machine dependent as the path and
C     file names for all land sea mask files are in the text. GETENV
C     is used to allow the specification of an alternate directory
C     for the storage of land sea masks (variable MARS_LSM_PATH).
C
C     The grid definition is compared with the definitions of the
C     pre-stored land sea mask files. If a match is found then the
C     appropriate filename is returned and the stride and offset
C     arrays are set to appropriate values. If no match is found then
C     the name of the basic 10 minute 0-1 land sea mask file is
C     returned.
C
C     AUTHOR
C     ______
C
C     K. Fielding      *ECMWF*      Nov 1993
C
C     MODIFICATIONS
C     _____________
C
C     J.D.Chambers     ECMWF        7 Feb 96
C     Add lookup for reduced gaussian fields
C
C     J.D.Chambers     ECMWF       Nov 98
C     Change default pathnames.
C
C----<
C     _______________________________________________________
C
C*    Section 0. Definition of variables.
C     _______________________________________________________
C
      IMPLICIT NONE
C
#include "parim.h"
C
C     Arguments
C
      CHARACTER*256 HFILE
      LOGICAL OSTAND
      INTEGER KDATE, KREPR, KGAUSS, KLN, KNREC, KPR, KERR
      INTEGER KGRID(2), KAREA(4), KOGRID(2), KOLINE(2)
C
C     Parameters
C
      INTEGER JPROUTINE
      PARAMETER (JPROUTINE = 25200)
      INTEGER JPFILES
      INTEGER JPN80, JPR160, JP0P5LL, JP0P25LL
      PARAMETER (JPFILES = 4)
      PARAMETER (JPN80 = 1)
      PARAMETER (JPR160 = 2)
      PARAMETER (JP0P5LL = 3)
      PARAMETER (JP0P25LL = 4)
C
C     Local variables
C
      CHARACTER*6 YFLAG
      INTEGER IRET
      LOGICAL LDEBUG, L10MIN, L025
      REAL RLSTRIDE
C
      CHARACTER*256 YBASE
      CHARACTER*256 YENVBACK
C
C     List of standard filenames       - YFILES
C     File for 10 minute land sea mask - YLSM10
C
      CHARACTER*40 YFILES (JPFILES), YLSM10
C
      INTEGER IBASELEN, ILSM10LEN
      INTEGER IFILELEN (JPFILES)
C
C     External functions
C
      INTEGER LSM_RED, DPATH_TABLES_INTERPOL
      EXTERNAL LSM_RED, DPATH_TABLES_INTERPOL
C
      DATA YLSM10 / 'lsm_xx_lsm10m01' /
      DATA ILSM10LEN / 15 /
      DATA YFILES /
     X  'lsm_xx_lsmn080',
     X  'lsm_xx_lsmr160',
     X  'lsm_xx_lsm0p5deg',
     X  'lsm_xx_lsm0p25deg'
     X  /
      DATA IFILELEN/ 14, 14, 16, 17 /
C
C     _______________________________________________________
C
C*    Section 1. Initialisation
C     _______________________________________________________
C
  100 CONTINUE
C
C     Force processing with 10min lsm with env variable
      CALL GETENV('LSM_10MIN', YFLAG)
      L10MIN = (YFLAG(1:1).EQ.'1')
      IF( L10MIN ) CALL INTLOG(JP_DEBUG,
     X  'IGLSMD: Forcing processing with 10 min',JPQUIET)

C     Processing with 0.25 Predefined lsm Enable
      CALL GETENV('LSM_025', YFLAG)
      L025 = (YFLAG(1:1).EQ.'1')
      IF( L025 ) CALL INTLOG(JP_DEBUG,
     X 'IGLSMD: Processing with 0.25 Predefined LSM Enabled',JPQUIET)

      IGLSMD = 0
      LDEBUG = ( KPR.GE.1 )
C
      IF( LDEBUG ) THEN
        CALL INTLOG(JP_DEBUG,'IGLSMD: Input parameters.',JPQUIET)
        CALL INTLOG(JP_DEBUG,'IGLSMD: Date = ',KDATE)
        CALL INTLOG(JP_DEBUG,'IGLSMD: Grid representation = ',KREPR)
        CALL INTLOG(JP_DEBUG,'IGLSMD: N line number = ', KLN)
C
        IF( (KREPR.EQ.JPGAUSSIAN).OR.
     X      (KREPR.EQ.JPQUASI)   .OR.
     X      (KREPR.EQ.JPQGGROT)  .OR.
     X      (KREPR.EQ.JPFGGROT) ) THEN
          CALL INTLOG(JP_DEBUG,'IGLSMD: Gaussian trunc = ',KGAUSS)
        ELSE IF( (KREPR.EQ.JPREGULAR).OR.(KREPR.EQ.JPREGROT) ) THEN
          CALL INTLOG(JP_DEBUG,'IGLSMD: Grid WE = ',KGRID(1))
          CALL INTLOG(JP_DEBUG,'IGLSMD: Grid NS = ',KGRID(2))
        ENDIF
C
        CALL INTLOG(JP_DEBUG,'IGLSMD: Area North = ', KAREA(1))
        CALL INTLOG(JP_DEBUG,'IGLSMD: Area West  = ', KAREA(2))
        CALL INTLOG(JP_DEBUG,'IGLSMD: Area South = ', KAREA(3))
        CALL INTLOG(JP_DEBUG,'IGLSMD: Area East  = ', KAREA(4))
C
      ENDIF
C
C     _______________________________________________________
C
C*    Section 2. Check environment variable for path of land sea masks.
C     _______________________________________________________
C
  200 CONTINUE
C
      IF ( LDEBUG ) CALL INTLOG(JP_DEBUG,'IGLSMD: Section 2.',JPQUIET)
C
      IBASELEN = DPATH_TABLES_INTERPOL(YENVBACK)
      IF( IBASELEN.EQ.0 ) THEN
        IF( LDEBUG ) CALL INTLOG(JP_ERROR,
     X    'IGLSMD: unable to build LSM directory path.',JPQUIET)
        IGLSMD = JPROUTINE + 3
        GOTO 900
      ENDIF
      YBASE = YENVBACK
C
C     _______________________________________________________
C
C*    Section 3. Standard Gaussian grids - F80
C     _______________________________________________________
C
  300 CONTINUE
C
      IF( (KREPR.EQ.JPGAUSSIAN).OR.
     X    (KREPR.EQ.JPFGGROT) ) THEN
        IF( LDEBUG ) CALL INTLOG(JP_DEBUG,'IGLSMD: Section 3.',JPQUIET)
C
c       ILSTRIDE = JP90 / KGAUSS
        RLSTRIDE = 90./REAL(KGAUSS) * PPMULT
        KOGRID (JPWESTEP) = 1
        KOGRID (JPNSSTEP) = 1
c       KOLINE (JPWEST)  = KAREA (JPWEST) / ILSTRIDE + 1
        KOLINE (JPWEST)  = REAL(KAREA(JPWEST))/RLSTRIDE + 1
        KOLINE (JPNORTH) = KLN
C
        IF( KGAUSS.EQ.80 ) THEN
C
          HFILE = YBASE(1:IBASELEN) // YFILES(JPN80)(1:IFILELEN(JPN80))
          OSTAND = .TRUE.
          KNREC = 320
C
        ELSE
C
          HFILE = YBASE(1:IBASELEN) // YLSM10(1:ILSM10LEN)
          OSTAND = .FALSE.
          KNREC = JPPACK
C
        ENDIF
C
C     _______________________________________________________
C
C*    Section 4. Standard reduced Gaussian grids - N160
C     _______________________________________________________
C
  400 CONTINUE
C
      ELSE IF( KREPR.EQ.JPQUASI ) THEN
        IF( LDEBUG ) CALL INTLOG(JP_DEBUG,'IGLSMD: Section 4.',JPQUIET)
C
        KOGRID(JPWESTEP) = 1
        KOGRID(JPNSSTEP) = 1
        KOLINE(JPWEST)   = 1
        KOLINE(JPNORTH)  = KLN
C
        IF( KGAUSS.EQ.160 ) THEN
          IRET = LSM_RED(KGAUSS,KDATE,32,HFILE)
          IF( IRET.EQ.0 ) THEN
            IF( LDEBUG ) CALL INTLOG(JP_ERROR,
     X        'IGLSMD: LSM_RED unable to locate lsm file.',JPQUIET)
            IGLSMD = JPROUTINE + 2
            GOTO 900
          ENDIF
          OSTAND = .TRUE.
          KNREC = 0
        ELSE
C
          HFILE = YBASE(1:IBASELEN) // YLSM10(1:ILSM10LEN)
          OSTAND = .FALSE.
          KNREC = JPPACK
C
        ENDIF
C
C     _______________________________________________________
C
C*    Section 5. Latitude/longitude grids
C
C                The standard 0.5 degree grid is used for any
C                grid which has a stride which is a multiple of
C                0.5 and North and South limits which are a
C                multiple of 0.5
C     _______________________________________________________
C
  500 CONTINUE
C
      ELSE IF( (KREPR.EQ.JPREGULAR).OR.(KREPR.EQ.JPREGROT) ) THEN
        IF( LDEBUG ) CALL INTLOG(JP_DEBUG,'IGLSMD: Section 5.',JPQUIET)
C
        IF( MOD(KGRID(JPNSSTEP),JP0P5).EQ.0 .AND.
     1      MOD(KGRID(JPWESTEP),JP0P5).EQ.0 .AND.
     2      MOD(KAREA(JPNORTH), JP0P5).EQ.0 .AND.
     3      MOD(KAREA(JPWEST),  JP0P5).EQ.0 .AND.
     4      .NOT.L10MIN ) THEN
C
        HFILE=YBASE(1:IBASELEN)//YFILES(JP0P5LL)(1:IFILELEN(JP0P5LL))
          OSTAND = .TRUE.
          KNREC = 720
C
          KOGRID(JPWESTEP) = KGRID(JPWESTEP) / JP0P5
          KOGRID(JPNSSTEP) = KGRID(JPNSSTEP) / JP0P5
          KOLINE(JPWEST)   = KAREA(JPWEST) / JP0P5 + 1
          KOLINE(JPNORTH)  = (JP90 - KAREA(JPNORTH) ) / JP0P5 + 1
C
        ELSE
C
          HFILE = YBASE(1:IBASELEN) // YLSM10(1:ILSM10LEN)
          OSTAND = .FALSE.
          KNREC = JPPACK
C
          KOGRID (JPWESTEP) = 1
          KOGRID (JPNSSTEP) = 1
          KOLINE (JPWEST) = 1
          KOLINE (JPNORTH) = KLN
C
        ENDIF
      ELSE
        IGLSMD = JPROUTINE + 1
        IF( KERR.GE.0 ) CALL INTLOG(JP_ERROR,
     X     'IGLSMD: Invalid data representation = ',KREPR)
C
        IF( KERR.EQ.0 ) CALL INTLOG(JP_FATAL,
     X     'IGLSMD: Interpolation failed.',IGLSMD)
C       GOTO 900
      ENDIF

      IF( L025 ) THEN
        IF( KGRID(JPNSSTEP).EQ.JP0P25.AND.
     1      KGRID(JPWESTEP).EQ.JP0P25.AND.
     2      MOD(KAREA(JPNORTH), JP0P25).EQ.0 .AND.
     3      MOD(KAREA(JPWEST),  JP0P25).EQ.0 .AND.
     4      .NOT.L10MIN ) THEN
C
        HFILE=YBASE(1:IBASELEN)//YFILES(JP0P25LL)(1:IFILELEN(JP0P25LL))
          OSTAND = .TRUE.
          KNREC = 1440
C
            KOGRID(JPWESTEP) = 1
            KOGRID(JPNSSTEP) = 1
            KOLINE(JPWEST)   = KAREA(JPWEST) / JP0P25 + 1
            KOLINE(JPNORTH)  = (JP90 - KAREA(JPNORTH) ) / JP0P25 + 1
        ENDIF
      ENDIF
C
C     _______________________________________________________
C
C*    Section 9. Return to calling routine. Format statements
C     _______________________________________________________
C
  900 CONTINUE
C
      IF( LDEBUG ) CALL INTLOG(JP_DEBUG,'IGLSMD: Section 9.',JPQUIET)
C
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      REAL FUNCTION KNFROM4(LVEGGY,RLAT,RLON,OLAT,OLON,PT,OLDFLD)
C
C---->
C**** KNFROM4
C
C     Purpose
C     -------
C
C     Generates a new field point from its four nearest neighbours.
C
C
C     Interface
C     ---------
C
C     VALUE = KNFROM4(RLAT,RLON,OLAT,OLON,PT,OLDFLD)
C
C     Input
C     -----
C
C     LVEGGY - 'True' if 'nearest neighbour' processing required
C     RLAT   - Latitude of the new point
C     RLON   - Longitude of the new point
C     OLAT   - Latitudes of the upper and lower lines
C     OLON   - Longitudes of the four neighbouring points
C     PT     - Positions in old field array of the four neighbours
C     OLDFLD - Array of old field values
C
C
C     Output
C     ------
C
C     Function returns a value for the new field point.
C
C
C     Method
C     ------
C
C     Uses neighbours to calculate a value by bi-linear interpolation.
C
C
C     Externals
C     ---------
C
C     None.
C
C
C     Author
C     ------
C
C     J.D.Chambers     ECMWF     November 2000
C
C----<
C
      IMPLICIT NONE
C
C     Function arguments
C
      LOGICAL LVEGGY
      REAL RLAT,RLON,OLAT(2),OLON(4),OLDFLD(*)
      INTEGER PT(4)
C
#include "intisl.h"
#include "nifld.common"
C
C     Local variables
C
      INTEGER COUNT, NEAREST
      REAL WEIGHT(4), NWEIGHT, SWEIGHT, NORMAL

C     Additional local variables for calculation
C     of corrected bilinear interpolation
C     that works for non-regular grids
      REAL NWGHT, SWGHT 
      REAL SVALUE, SWEIGHT2, SWEIGHT1 
      REAL NVALUE, NWEIGHT2, NWEIGHT1
C
C     Externals
C
C
C     Statement function
C
      REAL A, B
      LOGICAL NOTEQ
      NOTEQ(A,B) = (ABS((A)-(B)).GT.(ABS(A)*1E-3))
C
C     -----------------------------------------------------------------|
C*    Section 1. Calculate weighting values for each neighbour
C     -----------------------------------------------------------------|
C


  100 CONTINUE
C
C     Calculate the north/south weighting values allowing for
C     southern latitude to be same as northern latitude
C
      NWEIGHT = OLAT(NORTH) - RLAT
      SWEIGHT = RLAT - OLAT(SOUTH)
      IF( SWEIGHT.EQ.0.0 ) NWEIGHT = 1.0

C
C     Calculate the weighting values for each matching neighbour
C
c     new method
      WEIGHT(NWEST) = ABS((OLON(NEAST) - RLON) * SWEIGHT)
      WEIGHT(NEAST) = ABS((RLON - OLON(NWEST)) * SWEIGHT)
      WEIGHT(SWEST) = ABS((OLON(SEAST) - RLON) * NWEIGHT)
      WEIGHT(SEAST) = ABS((RLON - OLON(SWEST)) * NWEIGHT)
      
C
C     Normalise the weights
C
      NORMAL = ( WEIGHT(NWEST) + WEIGHT(NEAST) +
     X           WEIGHT(SWEST) + WEIGHT(SEAST) )
C
      WEIGHT(NWEST) = WEIGHT(NWEST)/NORMAL
      WEIGHT(NEAST) = WEIGHT(NEAST)/NORMAL
      WEIGHT(SWEST) = WEIGHT(SWEST)/NORMAL
      WEIGHT(SEAST) = WEIGHT(SEAST)/NORMAL

C
C     -----------------------------------------------------------------|
C*    Section 3.   Interpolate
C     -----------------------------------------------------------------|
C
  300 CONTINUE
C
C     Use nearest neighbour for vegetation field
C
      IF( LVEGGY ) THEN
        NEAREST = NWEST
        IF( WEIGHT(NEAST).GT.WEIGHT(NEAREST) ) NEAREST = NEAST
        IF( WEIGHT(SWEST).GT.WEIGHT(NEAREST) ) NEAREST = SWEST
        IF( WEIGHT(SEAST).GT.WEIGHT(NEAREST) ) NEAREST = SEAST
        KNFROM4 = OLDFLD(PT(NEAREST))
C
      ELSE

C
C       Count non-missing data values
C
        COUNT = 0
        IF( NOTEQ(OLDFLD(PT(NWEST)),RMISSGV) ) COUNT = COUNT + 1
        IF( NOTEQ(OLDFLD(PT(NEAST)),RMISSGV) ) COUNT = COUNT + 1
        IF( NOTEQ(OLDFLD(PT(SWEST)),RMISSGV) ) COUNT = COUNT + 1
        IF( NOTEQ(OLDFLD(PT(SEAST)),RMISSGV) ) COUNT = COUNT + 1
C
C       Interpolate using four neighbours if none are missing
C
        IF( COUNT.EQ.4 ) THEN

C         An entirely different calculaton (a correct one) using 
C         a bilinear method that works on reduced Gaussian grids

C         work out the interpolated value along the top line of latitude

          NWEIGHT1 = (RLON - OLON(NWEST)) / (OLON(NEAST) - OLON(NWEST))
          NWEIGHT2 = 1.0 - NWEIGHT1
          NVALUE = OLDFLD(PT(NWEST)) * NWEIGHT2 +
     X             OLDFLD(PT(NEAST)) * NWEIGHT1

C         do the same for the southern line of latitude
          SWEIGHT1 = (RLON - OLON(SWEST)) / (OLON(SEAST) - OLON(SWEST))
          SWEIGHT2 = 1.0 - SWEIGHT1
          SVALUE = OLDFLD(PT(SWEST)) * SWEIGHT2 + 
     x             OLDFLD(PT(SEAST)) * SWEIGHT1

          IF (OLAT(NORTH).EQ.OLAT(SOUTH)) THEN
C             we can't work with these numbers in our
c             new calculation so revert to what emoslib
c             used to do as it is at least robust to what
c             appears to be an accidental call to this function
              KNFROM4 = ( (OLDFLD(PT(NWEST)) * WEIGHT(NWEST)) +
     X                      (OLDFLD(PT(NEAST)) * WEIGHT(NEAST)) +
     X                      (OLDFLD(PT(SWEST)) * WEIGHT(SWEST)) +
     X                      (OLDFLD(PT(SEAST)) * WEIGHT(SEAST)) )

          ELSE
C         now interpolate between these values according to the 
C         output latitude value
              NWGHT = (RLAT - OLAT(SOUTH)) / (OLAT(NORTH) - OLAT(SOUTH))
              SWGHT = 1.0 - NWGHT
              KNFROM4 = NWGHT * NVALUE + SWGHT * SVALUE
          END IF
C
C       Set missing if all neighbours are missing
C
        ELSE IF( COUNT.EQ.0 ) THEN
          KNFROM4 = RMISSGV
C
C       Otherwise, use the nearest neighbour
C
        ELSE
          NEAREST = NWEST
          IF( WEIGHT(NEAST).GT.WEIGHT(NEAREST) ) NEAREST = NEAST
          IF( WEIGHT(SWEST).GT.WEIGHT(NEAREST) ) NEAREST = SWEST
          IF( WEIGHT(SEAST).GT.WEIGHT(NEAREST) ) NEAREST = SEAST
          KNFROM4 = OLDFLD(PT(NEAREST))
        ENDIF
      ENDIF
C
C     -----------------------------------------------------------------|
C*    Section 9.   Return
C     -----------------------------------------------------------------|
C
  900 CONTINUE
C
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE ECDEF13( HFUNC, KSEC1, KGRIB, KLENG, KNSPT, KBITS,
     X                    KPLEN, KPR, KRET)
C
C---->
C**** ECDEF13
C
C     Purpose.
C     --------
C
C     GRIB coding/decoding of ECMWF local use definition 13.
C
C**   Interface.
C     ----------
C
C     CALL ECDEF13( HFUNC, KSEC1, KGRIB, KLENG, KNSPT, KBITS, KPR, KRET)
C
C
C     Input Parameters.
C     -----------------
C
C     HFUNC      - Requested function.
C                  'C' to code data.
C                  'D' to decode data.
C
C     KSEC1      - Array containing Grib Section 1 data.
C
C     KGRIB      - Array containing Grib coded data.
C
C     KLENG      - Length (words) of KGRIB.
C
C     KNSPT      - Bit number after which insertion/extraction starts.
C
C     KBITS      - Number of bits in computer word.
C
C     KPLEN      - Pointer to field containing length of Section 1
C
C     KPR        - Debug print switch.
C                  0  , No printout.
C                  >0 , Debug printout.
C
C     KRET       - Response to error indicator.
C                  0        , Abort if error encountered.
C                  Non-zero , Return to calling routine
C                             even if error encountered.
C
C     Output Parameters.
C     ------------------
C
C     KSEC1      - Array containing Grib Section 1 data.(Updated)
C
C     KGRIB      - Array containing Grib coded data.(Updated)
C
C     KNSPT      - Number of bit after last one inserted/extracted.
C                  (Updated)
C
C     KRET       - Return code.
C                  0   , No error encountered.
C                  2   , Error reported by routine INXBIT.
C
C
C     Method.
C     -------
C
C     Input data packed/unpacked in accordance with ECMWF usage of
C     local part of section 1 of Grib code, definition 13.
C
C
C     Externals.
C     ----------
C
C     INXBIT  - insert/extract bits
C     ABORTX  - abort the program
C
C
C     Reference.
C     ----------
C
C     WMO Manual On Codes for Grib Code.
C
C
C     Comments.
C     ---------
C
#include "ecdef13.h"
C
C
C     Author.
C     -------
C
C     J.D.Chambers     ECMWF      April 1998
C
C
C     Modifications.
C     --------------
C
C     Add system and method numbers
C     J.D.Chambers     ECMWF      May 2000
C
C
C----<
C     ------------------------------------------------------------------
C*    Section 0 . Definition of variables. Data statements.
C     ------------------------------------------------------------------
C
      IMPLICIT NONE
C
#include "common/grprs.h"
C
C     Parameters
C
      CHARACTER*1   HFUNC
      INTEGER KSEC1, KGRIB, KLENG, KNSPT, KBITS, KPLEN, KPR, KRET
      DIMENSION KGRIB(*)
      DIMENSION KSEC1(*)
C
C     Local variables
C
      INTEGER IRET, IZERO, JLOP, LENS1, ND, NF, IFLAG
C
      LOGICAL LENCODE, LDECODE
C
C     ------------------------------------------------------------------
C*    Section 1 . Set initial values.
C     ------------------------------------------------------------------
C
  100 CONTINUE
C
      IRET = KRET
      LENCODE = ( HFUNC .EQ. 'C' )
      LDECODE = .NOT. LENCODE
C
C     ------------------------------------------------------------------
C*    Section 2 . Handle tube.
C     ------------------------------------------------------------------
C
  200 CONTINUE
C
C     Octet 50: As for MARS labelling (zero or ensemble forecast number)
C     Octet 51: As for MARS labelling (zero or total no. in ensembles)
C     Octet 52: Direction number
C     Octet 53: Frequency number
C     Octet 54: Total number of directions (Nd)
C     Octet 55: Total number of frequencies (Nf)
C     Six 8-bit fields.
C
      CALL INXBIT(KGRIB,KLENG,KNSPT,KSEC1(42),6,KBITS,8,HFUNC,KRET)
      IF (KRET.NE.0) THEN
        KRET = 2
        WRITE(GRPRSM,*) 'ECDEF13: Error reported by routine INXBIT:'
        IF( LENCODE ) THEN
          WRITE(GRPRSM,*) '      encoding section 1, elements 42 - 47.'
        ELSE
          WRITE(GRPRSM,*) '      decoding section 1, octets 50 - 55.'
        ENDIF
      ENDIF
C
      ND = KSEC1(46)
      NF = KSEC1(47)
C
C     Octets 56-59: Integer scaling factor applied to directions
C     Octets 60-63: Integer scaling factor applied to frequencies
C     Two 32-bit fields.
C
      CALL INXBIT(KGRIB,KLENG,KNSPT,KSEC1(48),2,KBITS,32,HFUNC,KRET)
      IF (KRET.NE.0) THEN
        KRET = 2
        WRITE(GRPRSM,*) 'ECDEF13: Error reported by routine INXBIT:'
        IF( LENCODE ) THEN
          WRITE(GRPRSM,*) '      encoding section 1, elements 48 - 49.'
        ELSE
          WRITE(GRPRSM,*) '      decoding section 1, octets 56 - 63.'
        ENDIF
      ENDIF
C
C     Octet 64: Flag to indicate whether or not system
C               and method number are present.
C                 0 = not present (old style product)
C                 1 = present
C
      IFLAG = 1
      CALL INXBIT(KGRIB,KLENG,KNSPT,IFLAG,1,KBITS,8,HFUNC,KRET)
      IF (KRET.NE.0) THEN
        KRET = 2
        WRITE(GRPRSM,*) 'ECDEF13: Error reported by routine INXBIT:'
        IF( LENCODE ) THEN
          WRITE(GRPRSM,*) '      encoding section 1, system/method flag'
        ELSE
          WRITE(GRPRSM,*) '      decoding section 1, octet 64'
        ENDIF
      ENDIF
C
C     If the flag is set (new style product)
C
      IF( IFLAG.EQ.1 ) THEN
C
C     Octets 65-66: System number
C     One 16-bit field.
C
        CALL INXBIT(KGRIB,KLENG,KNSPT,KSEC1(50+ND+NF),
     X              1,KBITS,16,HFUNC,KRET)
        IF (KRET.NE.0) THEN
          KRET = 2
          WRITE(GRPRSM,*) 'ECDEF13: Error reported by routine INXBIT:'
          IF( LENCODE ) THEN
            WRITE(GRPRSM,*) '      encoding section 1, system number'
          ELSE
            WRITE(GRPRSM,*) '      decoding section 1, octets 65 - 66'
          ENDIF
        ENDIF
C
C     Octets 67-68: Method number
C     One 16-bit field.
C
        CALL INXBIT(KGRIB,KLENG,KNSPT,KSEC1(51+ND+NF),
     X              1,KBITS,16,HFUNC,KRET)
        IF (KRET.NE.0) THEN
          KRET = 2
          WRITE(GRPRSM,*) 'ECDEF13: Error reported by routine INXBIT:'
          IF( LENCODE ) THEN
            WRITE(GRPRSM,*) '      encoding section 1, method number'
          ELSE
            WRITE(GRPRSM,*) '      decoding section 1, octets 67 - 68'
          ENDIF
        ENDIF
C
      ELSE
C
C       (Old style)
C       Octets 65-68: Spare (set to zero)
C       Four 8-bit fields.
C
        IF( LENCODE ) THEN
          DO JLOP = 65, 68
            IZERO = 0
            CALL INXBIT(KGRIB,KLENG,KNSPT,IZERO,1,KBITS,8,HFUNC,KRET)
            IF (KRET.NE.0) THEN
              KRET = 2
              WRITE(GRPRSM,*)
     X  'ECDEF13: Error reported by routine INXBIT:'
              WRITE(GRPRSM,*)
     X  '      encoding section 1, octets 69 - 100.'
            ENDIF
          ENDDO
        ELSE
          KNSPT = KNSPT + 4*8
        ENDIF
      ENDIF
C
C     Octets 69-100: Spare (set to zero)
C     Thirty-32 8-bit fields.
C
      IF( LENCODE ) THEN
        DO 210 JLOP = 69, 100
          IZERO = 0
          CALL INXBIT(KGRIB,KLENG,KNSPT,IZERO,1,KBITS,8,HFUNC,KRET)
          IF (KRET.NE.0) THEN
            KRET = 2
            WRITE(GRPRSM,*) 'ECDEF13: Error reported by routine INXBIT:'
            WRITE(GRPRSM,*) '      encoding section 1, octets 69 - 100.'
          ENDIF
  210   CONTINUE
      ELSE
        KNSPT = KNSPT + 32*8
      ENDIF
C
C     Octet 101 onwards: List of Nd scaled directions
C     Nd 32-bit fields.
C
      DO 220 JLOP = 50, (49+ND)
        CALL INXBIT(KGRIB,KLENG,KNSPT,KSEC1(JLOP),1,KBITS,32,HFUNC,KRET)
        IF (KRET.NE.0) THEN
          KRET = 2
          WRITE(GRPRSM,*) 'ECDEF13: Error reported by routine INXBIT:'
          IF( LENCODE ) THEN
            WRITE(GRPRSM,*)
     X  '      encoding section 1, elements 50 onwards'
          ELSE
            WRITE(GRPRSM,*)
     X  '      decoding section 1, octets 101 onwards.'
          ENDIF
        ENDIF
  220 CONTINUE
C
C     Octets 101+Nd*4 onwards: List of Nf scaled frequencies
C     Nf 32-bit fields.
C
      DO 230 JLOP = (50+ND), (49+ND+NF)
        CALL INXBIT(KGRIB,KLENG,KNSPT,KSEC1(JLOP),1,KBITS,32,HFUNC,KRET)
        IF (KRET.NE.0) THEN
          KRET = 2
          WRITE(GRPRSM,*) 'ECDEF13: Error reported by routine INXBIT:'
          IF( LENCODE ) THEN
            WRITE(GRPRSM,*)
     X  '      encoding section 1, element (50+Nd) etc.'
          ELSE
            WRITE(GRPRSM,*)
     X  '      decoding section 1, octets (101+Nd*4)->'
          ENDIF
        ENDIF
  230 CONTINUE
C
C
C     On encoding, record the length of section 1.
C
      IF( LENCODE ) THEN
        LENS1 = 100 + (ND*4) + (NF*4)
        CALL INXBIT(KGRIB,KLENG,KPLEN,LENS1, 1,KBITS,24,HFUNC,KRET)
        IF (KRET.NE.0) THEN
          KRET = 2
          WRITE(GRPRSM,*) 'ECDEF13: Error reported by routine INXBIT:'
          WRITE(GRPRSM,*) '         encoding length of section 1.'
        ENDIF
      ENDIF
C
C     ------------------------------------------------------------------
C*    Section 9 . Abort/return to calling routine. Format statements.
C     ------------------------------------------------------------------
C
  900 CONTINUE
C
      IF( KPR.GE.1 ) THEN
        WRITE(GRPRSM,*) 'ECDEF13: Section 9.'
        WRITE(GRPRSM,*) '        Output values set, KNSPT = ', KNSPT
      ENDIF
C
C     Abort if requested to do so when an error has been encountered.
C
      IF (IRET.EQ.0.AND.KRET.NE.0) THEN
        CALL ABORTX ('ECDEF13')
      ELSE
        RETURN
      ENDIF
C
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE SBYTE  (DEST,SOURCE,IOFSET,IBYTSZ)
C
C---->
C**** SBYTE  - Insert a single bit field. Cray routine.
C
C*    FUNCTION: STORE A SINGLE BIT FIELD FROM SOURCE INTO DEST
C*
C*    INPUT   : SOURCE   = WORD CONTAINING  BIT FIELD RIGHT JUSTIFIED
C*              DEST(1)  = 1ST TARGET WORD
C*              IOFSET   = OFFSET IN BITS FOR START OF THE FIELD
C*              IBYTSZ   = LENGTH OF FIELD IN BITS ; .LE.WORD SIZE .....
C*
C*    OUTPUT  : SOURCE,IOFSET,IBYTSZ UNCHANGED
C*              DEST(1) AND EVENTUALLY DEST(2) CONTAIN FIELD
C*
C*    AUTHOR  : M.MIQUEU   08/1981 (REWRITTEN FROM J.MARTELLET'S)
C*
C----<
      PARAMETER(NBPW=64)
      INTEGER SOURCE,DEST(1)
      INTEGER SH1,SH2,SH3
      SH1=IOFSET+IBYTSZ
      IF(SH1.GT.NBPW) GO TO 2

      SH2=NBPW-SH1
      IF(SH2.LT.0) SH2=NBPW-SH2

C     BYTE  DOES NOT SPAN WORDS


      DEST(1)=SHIFT(
     1              OR(
     2                 AND(SHIFT(DEST(1),SH1),
     3                     SHIFT(COMPL(MASK(IBYTSZ)),IBYTSZ) )
     4                 ,
     5                 AND(SOURCE,
     6                     COMPL(SHIFT(COMPL(MASK(IBYTSZ)),IBYTSZ)) )
     7                 )
     8              ,SH2)



      RETURN

2     CONTINUE

C     BYTE SPANS 2 WORDS

      SH3=2*NBPW-SH1


      DEST(1)=OR(
     1           AND(DEST(1),MASK(IOFSET))
     2           ,
     3           AND(SHIFT(SOURCE,SH3) , COMPL(MASK(IOFSET)) )
     4           )

      DEST(2)=OR(
     1           AND(DEST(2) , COMPL(MASK(SH1-NBPW)) )
     2           ,
     3           SHIFT( AND(SOURCE , COMPL(MASK(SH3)) ) ,SH3)
     4           )



      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      INTEGER FUNCTION IGGLAT(KLAT, PGAUSS, KPR, KERR)
C
C---->
C**** *IGGLAT*
C
C     PURPOSE
C     _______
C
C     Compute Gaussian lines of latitude for a given truncation.
C
C
C     INTERFACE
C     _________
C
C     IERR = IGGLAT(KLAT, PGAUSS, KPR, KERR)
C
C
C     Input parameters
C     ________________
C
C     KLAT - The number of lines of latitude from pole to pole.
C
C     KPR  - Debug print switch:
C            0, No debugging output.
C            1, Produce debugging output.
C
C     KERR - Error control flag.
C            -ve, No error message. Return error code.
C            0  , Hard failure with error message.
C            +ve, Print error message. Return error code.
C
C
C     Output parameters
C     ________________
C
C     PGAUSS - The Gaussian lines of latitude for truncation KLAT/2
C
C
C     Return value
C     ____________
C
C     0     - OK
C     24701 - The calculation of Gaussian lines of latitude failed.
C
C
C     Common block usage
C     __________________
C
C     None
C
C
C     EXTERNALS
C     _________
C
C     INTLOG(R) - Logs messages.
C     IGBESS    - This routine is used to generate initial
C                 approximations to the Gaussian latitudes.
C
C
C     METHOD
C     ______
C
C     IGBESS is used to provide zeros of the Bessel function J0,
C     which are used as starting approximations to the Gaussian
C     latitudes. Newton iteration is used to generate the latitudes
C     from these approximations.
C
C     Calculated latitudes are stored internally and reused if a
C     later call asks for the same calculation.
C
C
C     REFERENCE
C     _________
C
C     None
C
C
C     COMMENTS
C     ________
C
C     This routine is adapted from that in the old Marsint library.
C     The interface and the variable names have been modified.
C
C
C     AUTHOR
C     ______
C
C     K. Fielding      *ECMWF*      Oct 1993
C
C
C     MODIFICATIONS
C     _____________
C
C     J.Chambers        ECMWF       Aug 1998
C     Add reuse of calculated latitudes.
C
C----<
C     -------------------------------------------------------
C*    Section 0. Definition of variables.
C     -------------------------------------------------------
C
      IMPLICIT NONE
C
#include "jparams.h"
#include "parim.h"
C
C     Function arguments
C
      INTEGER KLAT, KPR, KERR
      REAL PGAUSS (*)
C
C     Parameters
C
      INTEGER JPROUTINE
      PARAMETER (JPROUTINE = 24700)
C     -------------------------------------------------------
C     The convergence criteria is machine dependent
C     -------------------------------------------------------
C
      REAL PACRCY
#ifdef REAL_8
      PARAMETER (PACRCY = 1.0E-14)
#else
      PARAMETER (PACRCY = 1.0E-7)
#endif
C
C     Local variables
C
      LOGICAL LDEBUG
      INTEGER ITRUNC, IERR
      INTEGER JLAT, JITER, JLN, LOOP, JOLDLAT
      REAL ZRADDEG, ZCON, ZLAT, ZROOT
      REAL ZKM1, ZKM2, ZLN, ZFUNC, ZDERIV, ZMOVE
      REAL ROLDGS
      DIMENSION ROLDGS(JPGTRUNC*2)
C
      SAVE JOLDLAT, ROLDGS
C
C     Externals
C
      INTEGER IGBESS
C
C     -------------------------------------------------------
C*    Section 1. Set constants and get initial approximation.
C     -------------------------------------------------------
C
  100 CONTINUE
C
      ZFUNC  = 0.
      IGGLAT = 0
      LDEBUG = ( KPR.GE.1 )
C
      IF( LDEBUG ) THEN
        CALL INTLOG(JP_DEBUG,'IGGLAT: Section 1.',JPQUIET)
        CALL INTLOG(JP_DEBUG,
     X  'IGGLAT: No.lines lat from pole to pole = ',KLAT)
      ENDIF
C
C     Using previously calculated values if truncation is the same.
C
      IF( KLAT.EQ.JOLDLAT ) THEN
        IF( LDEBUG ) CALL INTLOG(JP_DEBUG,
     X    'IGGLAT: Using previously calculated values',JPQUIET)
        DO LOOP = 1, KLAT
          PGAUSS(LOOP) = ROLDGS(LOOP)
        ENDDO
        GOTO 900
      ENDIF
C
      JOLDLAT = KLAT
C
      ZRADDEG = 180.0/PPI
C
      ZCON   = (PPONE - (PPTWO / PPI) ** 2) * PPQUART
C
      ZLAT   = KLAT
      ITRUNC = KLAT/2
C
      IERR = IGBESS(ITRUNC, PGAUSS, KPR, KERR)
C
      IF( IERR.GT.0 ) THEN
         IGGLAT = IERR
         GOTO 900
      ENDIF
C
C     -------------------------------------------------------
C*    Section 2. Compute abscissae
C     -------------------------------------------------------
C
  200 CONTINUE
C
      IF( LDEBUG ) CALL INTLOG(JP_DEBUG,'IGGLAT: Section 2.',JPQUIET)
C
      DO 240 JLAT = 1, ITRUNC
C
C       First approximation for ZROOT
C
        ZROOT = COS(PGAUSS(JLAT) / SQRT( (ZLAT+PPHALF)**2 + ZCON) )
C
C       Perform loop of Newton iterations
C
        DO 220 JITER = 1, JPMAXITER
C
          ZKM2 = PPONE
          ZKM1 = ZROOT
C
C         Compute Legendre polynomial
C
          DO 210 JLN = 2, KLAT
C
            ZLN = JLN
C
            ZFUNC = ( (PPTWO * ZLN - PPONE) * ZROOT * ZKM1 -
     1              (ZLN - PPONE) * ZKM2) / ZLN
C
            ZKM2 = ZKM1
            ZKM1 = ZFUNC
C
  210     CONTINUE
C
C         Perform Newton iteration
C
          ZDERIV = (ZLAT * (ZKM2 - ZROOT * ZFUNC) ) /
     1             (PPONE - ZROOT ** 2)
C
          ZMOVE = ZFUNC / ZDERIV
          ZROOT = ZROOT - ZMOVE
C
C         Leave iteration loop when sufficient accuracy achieved.
C
          IF( ABS(ZMOVE).LE.PACRCY ) GOTO 230
C
  220   CONTINUE
C
C       Routine fails if no convergence after JPMAXITER iterations.
C
        IGGLAT = JPROUTINE + 1
C
        IF( KERR.GE.0 ) CALL INTLOG(JP_ERROR,
     X    'IGGLAT: Calculation of Gaussian lats failed.',JPQUIET)
C
        IF( KERR.EQ.0 ) CALL INTLOG(JP_FATAL,
     X    'IGGLAT: interpolation failed.',IGGLAT)
C
        GOTO 900
C
  230   CONTINUE
C
C*      Set North and South values using symmetry.
C
        PGAUSS(JLAT) = ASIN(ZROOT) * ZRADDEG
        PGAUSS(KLAT + 1 - JLAT) = - PGAUSS(JLAT)
C
  240 CONTINUE
C
      IF( KLAT.NE.(ITRUNC*2) ) PGAUSS(ITRUNC + 1) = PPZERO
C
C     Store calculated values for re-use
C
      DO LOOP = 1, KLAT
        ROLDGS(LOOP) = PGAUSS(LOOP)
      ENDDO
C
C     -------------------------------------------------------
C*    Section 9. Return to calling routine.
C     -------------------------------------------------------
C
  900 CONTINUE
C
      IF( LDEBUG ) CALL INTLOG(JP_DEBUG,'IGGLAT: Section 9.',JPQUIET)
C
      RETURN
      END

C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      INTEGER FUNCTION INTFBU( FLDIN,INLEN,FLDOUT,OUTLEN)
C
C---->
C**** INTFBU
C
C     Purpose
C     -------
C
C     Interpolate input field...
C
C
C     Interface
C     ---------
C
C     IRET = INTFBU( FLDIN,INLEN,FLDOUT,OUTLEN)
C
C     Input
C     -----
C
C     FLDIN  - Input field (unpacked).
C     INLEN  - Input field length (words).
C
C
C     Output
C     ------
C
C     FLDOUT  - Output field (unpacked).
C     OUTLEN  - Output field length (words).
C
C
C     Method
C     ------
C
C     Call interpolation routines; then repack if GRIB output.
C
C     Currently, subareas are not supported for reduced gaussian fields.
C     (Works OK; but need to setup values in GRIB product for number of
C      points in each latitude row)
C
C
C     Externals
C     ---------
C
C     IARCNTL - Control interp. quasi reg.Gauss -> Gaussian or lat/long
C     IAGCNTL - Control interpolation reg.Gaussian or lat/long fields.
C     JSH2SH  - Changes resolution of a field of spectral coefficients.
C     JALLGP  - Converts spectral input fields to lat/long grid fields.
C     JALLWN  - Converts spectral input wind fields to lat/long grids.
C     JAGGGP  - Converts spectral input fields to a gaussian grid field.
C     IBASINI - Ensure basic interpolation setup is done.
C     RESET_C - Reset interpolation handling options using GRIB product.
C     JMEMHAN - Handles memory allocation.
C     IGLSIZE - Evaluate array sizes for reg. lat/long and area.
C     IGSIZE  - Evaluate array sizes for a regular Gaussian.
C     IRSIZE  - Evaluate array sizes for a quasi reg Gaussian.
C     FIXAREA - Fixup area definition to correspond to grid definitions
C     ISCRSZ  - Calculate number of values in generated field.
C     INTLOG  - Log error message.
C
C
C     Author
C     ------
C
C     J.D.Chambers     ECMWF     Aug 1994
C
C     J.D.Chambers     ECMWF        Feb 1997
C     Allow for 64-bit pointers
C
C----<
C
      IMPLICIT NONE
C
C     Function arguments
      INTEGER INLEN,OUTLEN
      REAL FLDIN(*),FLDOUT(*)
C
#include "parim.h"
#include "nifld.common"
#include "nofld.common"
#include "grfixed.h"
#include "intf.h"
C
C     Parameters
      INTEGER JPROUTINE
      INTEGER JPALLOC, JPSCR16
      PARAMETER (JPROUTINE = 26600 )
      PARAMETER (JPALLOC = 1 )
      PARAMETER (JPSCR16 = 16 )
C
C     Local variables
C
      INTEGER IERR, ISIZE, IUV
      REAL PNORTH, PSOUTH, PWEST, PEAST, PLATINC, PLONINC
      REAL EW, NS, NORTH, SOUTH, WEST, EAST
      REAL HNORTH, HSOUTH, HWEST, HEAST
      LOGICAL OIWEGLOBE, OINPOLE, OISPOLE
      LOGICAL OOWEGLOBE, OONPOLE, OOSPOLE
      LOGICAL LSTYLE
      INTEGER KILN, KITOTAL, KOLN, KOTOTAL, KPR, KERR
      INTEGER LOOP
      INTEGER HOLDEW, HOLDNS, N_NOWE, N_NONS, IDISTEP
      REAL*8 DISSRES
#ifndef _CRAYFTN
#ifdef POINTER_64
      INTEGER*8 IZNFLDO
#endif
#endif
      REAL ZNFLDO
      POINTER ( IZNFLDO, ZNFLDO )
      DIMENSION ZNFLDO( 1 )
C
C     Externals
      INTEGER IGLSIZE, IGSIZE, IRSIZE, IARCNTL, IAGCNTL
      INTEGER FIXAREA, ISCRSZ
C
C ------------------------------------------------------------------
C*    Section 1.   Initialise
C ------------------------------------------------------------------
C
  100 CONTINUE
      INTFBU = 0
      IERR = 0
      KPR = 0
C
C     Allocate work array ZNFELDI if not already done.
C
      IF( IZNJDCI.NE.1952999238 ) THEN
        CALL JMEMHAN( 19, IZNFLDI, JPEXPAND, 1, IERR)
        IF( IERR.NE.0 ) THEN
          CALL INTLOG(JP_WARN,'INTFBU: znfeldi allocate fail',JPQUIET)
          INTFBU = IERR
          GOTO 900
        ENDIF
        IZNJDCI = 1952999238
      ENDIF
C
C ------------------------------------------------------------------
C*    Section 3.   Interpolation spherical harmonics to spherical
C                  harmonics
C ------------------------------------------------------------------
C
  300 CONTINUE
C
      IF ( ((NIREPR.EQ.JPSPHERE).OR.(NIREPR.EQ.JPSPHROT)) .AND.
     X     ((NOREPR.EQ.JPSPHERE).OR.(NOREPR.EQ.JPSPHROT)) ) THEN

C       Get scratch space for interpolation
C
        ISIZE = ISCRSZ()
        IF ( ISIZE .LE. 0 ) THEN
          CALL INTLOG(JP_ERROR,'INTFBU: Get scratch space failed',ISIZE)
          INTFBU = JPROUTINE + 2
          GOTO 900
        ENDIF
        CALL JMEMHAN( JPSCR16, IZNFLDO, ISIZE, JPALLOC, IERR)
        IF ( IERR .NE. 0 ) THEN
          CALL INTLOG(JP_ERROR,'INTFBU: Get scratch space fail',JPQUIET)
          INTFBU = JPROUTINE + 2
          GOTO 900
        ENDIF
C
        CALL SH2SH( ZNFELDI, NIRESO, ZNFLDO, NORESO )
C
        GOTO 700
C
C     If not spectral -> spectral transformation, make sure the input
C     and output area definitions have been setup.
C
      ELSE
       LSTYLE = LNOSTYLE.AND.
     X         (NOSTYLE.EQ.JPSDISM).AND.
     X         (NOREPR.EQ.JPREGULAR)

        IF( LSTYLE ) THEN
c to be consistant with product generation
              IF(NIRESO.EQ.1279) THEN
                 DISSRES = 0.125
              ELSEIF(NIRESO.EQ.799) THEN
                 DISSRES = 0.25
              ELSEIF(NIRESO.EQ.639) THEN
                 DISSRES = 0.25
              ELSEIF(NIRESO.EQ.399) THEN
                 DISSRES = 0.5
              ELSEIF(NIRESO.EQ.319) THEN
                 DISSRES = 0.5
              ELSEIF(NIRESO.EQ.255) THEN
                 DISSRES = 0.5
              ELSEIF(NIRESO.EQ.155) THEN
                 DISSRES = 1.5
              ELSE
                 DISSRES = NOGRID(1) / PPMULT
            CALL INTLOG(JP_WARN,'INTFBU: Diss resol set to: ',NOGRID(1))
              ENDIF
            IDISTEP = NINT(DISSRES*PPMULT)
            HOLDEW = NOGRID(1)
            HOLDNS = NOGRID(2)
            NOGRID(1) = IDISTEP
            NOGRID(2) = IDISTEP
         ENDIF
C
C       Setup geographical limits
C
        PNORTH = FLOAT( NOAREA(1) ) / PPMULT
        PWEST  = FLOAT( NOAREA(2) ) / PPMULT
        PSOUTH = FLOAT( NOAREA(3) ) / PPMULT
        PEAST  = FLOAT( NOAREA(4) ) / PPMULT
C
      ENDIF
C
C ------------------------------------------------------------------
C     Section 4.   Interpolation spherical harmonics to grid point.
C ------------------------------------------------------------------
C
  400 CONTINUE
C
      IF ( (NIREPR.EQ.JPSPHERE).OR.(NIREPR.EQ.JPSPHROT) ) THEN
C
C       Get scratch space for interpolation
C
        ISIZE = ISCRSZ()
        IF ( ISIZE .LE. 0 ) THEN
          CALL INTLOG(JP_ERROR,'INTFBU: Get scratch space failed',ISIZE)
          INTFBU = JPROUTINE + 2
          GOTO 900
        ENDIF
C
        CALL JMEMHAN( JPSCR16, IZNFLDO, ISIZE, JPALLOC, IERR)
        IF ( IERR .NE. 0 ) THEN
          CALL INTLOG(JP_ERROR,'INTFBU: Get scratch space fail',JPQUIET)
          INTFBU = JPROUTINE + 2
          GOTO 900
        ENDIF
C
C       Setup wind flag
C
        IF( .NOT.LWINDSET ) THEN
          LWIND = ( ( NOTABLE.EQ.128 ).AND.
     X            ((NOPARAM.EQ.131).OR.(NOPARAM.EQ.132)) )
        ENDIF
        CALL INTLOG(JP_DEBUG,'INTFBU: Wind flag = ', LWIND)
        IF ( LWIND ) THEN
          IUV = 1
        ELSE
          IUV = 0
        ENDIF
C
C ------------------------------------------------------------------
C*    Section 4.1  Interpolation spherical harmonics to grid point.
C ------------------------------------------------------------------
C
  410 CONTINUE
C
        IF ( (NOREPR.EQ.JPREGULAR).OR.(NOREPR.EQ.JPREGROT) ) THEN
C
C         -> latitude/longitude grid
C
          PLONINC = FLOAT( NOGRID(1) ) / PPMULT
          PLATINC = FLOAT( NOGRID(2) ) / PPMULT
          IF ( LWIND ) THEN
            CALL JALLWN( ZNFELDI, NIRESO, PNORTH, PSOUTH, PWEST, PEAST,
     X                   PLATINC, PLONINC, ZNFLDO, IERR)
          ELSE
            CALL JALLGP( ZNFELDI, NIRESO, PNORTH, PSOUTH, PWEST, PEAST,
     X                   PLATINC, PLONINC, ZNFLDO, IERR)
          ENDIF
          IF ( IERR .NE. 0 ) THEN
            CALL INTLOG(JP_ERROR,
     X        'INTFBU: Interpolation of gaussian field failed.',JPQUIET)
            INTFBU = JPROUTINE + 3
            GOTO 900
          ENDIF
C
          GOTO 700
C
        ENDIF
C
C
        IF ( NOREPR .EQ. JPGAUSSIAN) THEN
C
C         -> regular gaussian grid
C
          CALL JAGGGP( ZNFELDI, NIRESO, PNORTH, PSOUTH, PWEST, PEAST,
     X                 NOGAUSS, 'F', NOLPTS, ZNFLDO, IUV, IERR)
cs     X                 NOGAUSS, 'U', NOLPTS, ZNFLDO, IUV, IERR)
          IF ( IERR .NE. 0 ) THEN
            CALL INTLOG(JP_ERROR,
     X        'INTFBU: Interpolation of gaussian field failed.',JPQUIET)
            INTFBU = JPROUTINE + 4
            GOTO 900
          ENDIF
C
          GOTO 700
C
        ENDIF
C
C
        IF ( NOREPR .EQ. JPQUASI) THEN
C
C         -> reduced gaussian grid
C
          CALL JAGGGP( ZNFELDI, NIRESO, PNORTH, PSOUTH, PWEST, PEAST,
     X                 NOGAUSS, 'U', NOLPTS, ZNFLDO, IUV, IERR)
          IF ( IERR .NE. 0 ) THEN
            CALL INTLOG(JP_ERROR,
     X        'INTFBU: Interpolation of gaussian field failed.',JPQUIET)
            INTFBU = JPROUTINE + 4
            GOTO 900
          ENDIF
C
          GOTO 700
C
        ENDIF
C
C       Dropthrough => unrecognized output field type
C
        IERR   = JPROUTINE + 1
        CALL INTLOG(JP_ERROR,
     X    'INTFBU: Unrecognized output field type.',NOREPR)
        INTFBU = IERR
        GOTO 900
C
      ENDIF
C
C ------------------------------------------------------------------
C     Section 5.   Interpolate Gaussian grid to grid point.
C ------------------------------------------------------------------
C
  500 CONTINUE
C
C     Setup flags for input and output fields
C
      KERR = 1
      IF (NIREPR .EQ. JPQUASI) THEN
        IERR = IRSIZE( NIGAUSS, NIAREA, MILLEN, NIWE, NINS, KILN,
     X                 KITOTAL, RIGAUSS, OIWEGLOBE, OINPOLE, OISPOLE,
     X                 KPR, KERR)
      ELSE IF ( NIREPR .EQ. JPGAUSSIAN ) THEN
          IERR = IGSIZE( NIGAUSS, NIAREA, NIWE, NINS, KILN, RIGAUSS,
     X                    OIWEGLOBE, OINPOLE, OISPOLE, KPR, KERR)
      ELSE
        IERR = IGLSIZE( NIGRID, NIAREA, NIWE, NINS, KILN, OIWEGLOBE,
     X                  OINPOLE, OISPOLE, KPR, KERR)
      ENDIF
C
      NONS = 0
      NOWE = 0
      IF (NOREPR .EQ. JPQUASI) THEN
        IERR = IRSIZE( NOGAUSS, NOAREA, NOLPTS, NOWE, NONS, KOLN,
     X                 KOTOTAL, ROGAUSS, OOWEGLOBE, OONPOLE, OOSPOLE,
     X                 KPR, KERR)
      ELSE IF ( NOREPR .EQ. JPGAUSSIAN ) THEN
          IERR = IGSIZE( NOGAUSS, NOAREA, NOWE, NONS, KOLN, ROGAUSS,
     X                    OOWEGLOBE, OONPOLE, OOSPOLE, KPR, KERR)
      ELSE
        IERR = IGLSIZE( NOGRID, NOAREA, NOWE, NONS, KOLN, OOWEGLOBE,
     X                  OONPOLE, OOSPOLE, KPR, KERR)
      ENDIF
C
      IF ( IERR .NE. 0 ) THEN
        CALL INTLOG(JP_ERROR,
     X    'INTFBU: Interpolation of gaussian field failed.',IERR)
        INTFBU = JPROUTINE + 6
        GOTO 900
      ENDIF
C
C
C ------------------------------------------------------------------
C     Section 5.1  Interpolate reduced Gaussian grid to grid point.
C ------------------------------------------------------------------
C
  510 CONTINUE
C
C
      ISIZE = ISCRSZ()
      IF ( ISIZE .LE. 0 ) THEN
        CALL INTLOG(JP_ERROR,'INTFBU: Get scratch space failed.',ISIZE)
        INTFBU = JPROUTINE + 2
        GOTO 900
      ENDIF
      CALL JMEMHAN( JPSCR16, IZNFLDO, ISIZE, JPALLOC, IERR)
      IF ( IERR .NE. 0 ) THEN
        CALL INTLOG(JP_ERROR,'INTFBU: Get scratch space fail.',JPQUIET)
        INTFBU = JPROUTINE + 2
        GOTO 900
      ENDIF
C
      IF (NIREPR .EQ. JPQUASI) THEN
        IERR = IARCNTL( ZNFELDI, JPEXPAND, ZNFLDO, ISIZE, KILN,
     X                  OIWEGLOBE, OINPOLE, OISPOLE, KOLN, OOWEGLOBE,
     X                  OONPOLE, OOSPOLE, KPR ,KERR)
        IF ( IERR .NE. 0 ) THEN
          CALL INTLOG(JP_ERROR,
     X      'INTFBU: Interpolation of gaussian field failed.',IERR)
          INTFBU = JPROUTINE + 7
          GOTO 900
        ENDIF
C
        GOTO 700
C
      ENDIF
C
C ------------------------------------------------------------------
C*    Section 6.   Interpolate regular grid point to grid point.
C ------------------------------------------------------------------
C
  600 CONTINUE
C
      IERR = IAGCNTL( ZNFELDI, JPEXPAND, ZNFLDO, ISIZE, KILN,
     X                OIWEGLOBE, OINPOLE, OISPOLE, KOLN, OOWEGLOBE,
     X                OONPOLE, OOSPOLE, KPR, KERR)
      IF ( IERR .NE. 0 ) THEN
        CALL INTLOG(JP_ERROR,
     X    'INTFBU: Interpolation of gaussian field failed.',IERR)
        INTFBU = JPROUTINE + 8
        GOTO 900
      ENDIF
C
C ------------------------------------------------------------------
C*    Section 7.   Move unpacked values to user array.
C ------------------------------------------------------------------
C
  700 CONTINUE
C     If dissemination 'style' selection has been chosen, select points.
C
      IF( LSTYLE ) THEN
          NOGRID(1) = HOLDEW
          NOGRID(2) = HOLDNS
        CALL DDSTYLE(ZNFLDO,IDISTEP,IDISTEP,NOGRID(1),NOGRID(2),IERR)
        IF( IERR.NE.0 ) THEN
         CALL INTLOG(JP_ERROR,
     X  'INTFBU: Wrong requested grid increment for dissemination style'
     X   ,JPQUIET)
         INTFBU = JPROUTINE + 3
          GOTO 900
        ENDIF
         PLONINC = FLOAT( NOGRID(1) ) / PPMULT
         PLATINC = FLOAT( NOGRID(2) ) / PPMULT
         PNORTH = FLOAT( NOAREA(1) ) / PPMULT
         PWEST  = FLOAT( NOAREA(2) ) / PPMULT
         PSOUTH = FLOAT( NOAREA(3) ) / PPMULT
         PEAST  = FLOAT( NOAREA(4) ) / PPMULT

          N_NOWE = NINT((PEAST-PWEST)/PLONINC) + 1
          N_NONS = NINT((PNORTH-PSOUTH)/PLATINC) + 1
        NOWE = N_NOWE
        NONS = N_NONS
        ISIZE = NOWE*NONS
      ENDIF
c
      DO 710 LOOP = 1, ISIZE
        FLDOUT( LOOP ) = ZNFLDO( LOOP )
 710  CONTINUE
C
C     Return the number of values, the unpacked array length
C
      OUTLEN = ISIZE
C
C ------------------------------------------------------------------
C*    Section 9.   Closedown.
C ------------------------------------------------------------------
C
  900 CONTINUE
C
C     Clear change flags for next product processing
C
      LCHANGE = .FALSE.
      LSMCHNG = .FALSE.
C
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE GBYTES (S,D,ISKIP1,IBSIZ,ISKIP2,NBYTES,KWOFF)
C
C---->
C**** GBYTES - Extract a number of bit fields. Cray routine.
C
C S CONTAINS A BIT STRING OF INDEFINITE LENGTH. GBYTES WILL
C EXTRACT NBYTES BITSTRINGS, IBSIZ BITS LONG, AND STORE THEM
C RIGHT JUSTIFIED 0 FILL, INTO SUCCESSIVE WORDS OF D. THE
C SUCCESSIVE BITSTRINGS START AT BIT POSITIONS
C     ISKIP1+1+(IBYTE-1)*(IBSIZ+ISKIP2)
C IN THE BIT STRING S. I.E. SKIP ISKIP1 BITS AT THE START,
C AND ISKIP2 BITS BETWEEN THE EXTRACTED STRINGS.
C BIT ISKP+1 IN A STRING IS FOUND IN WORD IS=1+ISKIP/NBPW IN S,
C WHERE NBPW IS THE NUMBER OF BITS PER WORD. THE STARTING BIT
C IS FOUND BY SKIPPING MOD(ISKP,NBPW) BITS IN THAT WORD.
C KWOFF IS AN OPTIONAL 7TH PARAMETER, WHICH DEFAULTS TO 0
C IF PRESENT KWOFF BITS ARE TOTALLY IGNORED AT THE START OF A WORD
C THUS IF A PACKED CYBER BIT STRING IS TRANSFERRED TO THE
C CRAY, WITH EACH 60 BIT CYBER WORD PLACED AT THE RIGHT END OF
C A 64 BIT CRAY WORD, A BYTE SEQUENCE WHICH WAS ORIGINALLY
C LOCATED WITH START POINTS IN ARITHMETIC PROGRESSION ON THE
C CYBER, WILL NO LONGER HAVE THIS PROPERTY ON THE CRAY. BY
C USING THE ROUTINE WITH KWOFF=4, THE ELEMENTS OF THE BYTE
C SEQUENCE CAN BE EXTRACTED ON THE CRAY, USING THE SAME SKIPS
C AS WERE USED ON THE CYBER.
C
C----<
      PARAMETER(NBPW=64)
      DIMENSION S(2) , D(NBYTES)
      INTEGER SH1
      IGNORE = 0
#ifdef CRAY
      IF(NUMARG().GT.6) IGNORE = KWOFF
#else
      IF(NUMARG(DUMMY).GT.6) IGNORE = KWOFF
#endif
      IS=1+ISKIP1/(NBPW-IGNORE)
      ISKIP = MOD(ISKIP1,NBPW-IGNORE) + IGNORE
      ISTEP = ISKIP2+IBSIZ
      DO 75 IBYTE = 1 , NBYTES
C WITH THE STARTING WORD AND BIT POSITION DETERMINED, THE
C DESIRED EXTRACTION CAN BE DONE BY
C***     CALL GBYTE(S(IS),D(IBYTE),ISKIP,IBSIZ)
C BUT SINCE THE CODE IS SHORT IT IS INSERTED IN-LINE.
         SH1 = ISKIP+IBSIZ
         IF(SH1.GT.NBPW) GO TO 50
C BYTE COMES FROM 1 WORD OF S
         D(IBYTE) = AND( SHIFT(S(IS),SH1),SHIFT(MASK(IBSIZ),IBSIZ))
         GO TO 65
   50    CONTINUE
         SH1 =SH1-NBPW
C BYTE COMES FROM 2 WORDS OF S.
         D(IBYTE) = OR(SHIFT(AND(S(IS),COMPL(MASK(ISKIP))),SH1)
     1                           ,
     2                SHIFT(AND(SHIFT(S(IS+1),IGNORE),MASK(SH1)),SH1)
     3                 )
   65    CONTINUE
C UPDATE STARTING WORD AND BIT POSITION
         ISKIP = ISKIP+ISTEP
         IF(ISKIP.LT.NBPW) GO TO 75
         ISKIP =ISKIP-NBPW
         IS = IS+1+ISKIP/(NBPW-IGNORE)
         ISKIP = MOD(ISKIP,NBPW-IGNORE) + IGNORE
   75 CONTINUE
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities
C granted to it by virtue of its status as an intergovernmental organisation
C nor does it submit to any jurisdiction.
C

      SUBROUTINE ECDEF18(HFUNC,KSEC1,KGRIB,KLENG,KNSPT,KBITS,KRET)
C
C---->
C**** ECDEF18
C
C     Purpose.
C     --------
C
C     GRIB coding/decoding of ECMWF local use definition 18.
C
C**   Interface.
C     ----------
C
C     CALL ECDEF18(HFUNC,KSEC1,KGRIB,KLENG,KNSPT,KBITS,KRET)
C
C
C     Input Parameters.
C     -----------------
C
C     HFUNC      - Requested function.
C                  'C' to code data.
C                  'D' to decode data.
C
C     KSEC1      - Array containing Grib Section 1 data.
C
C     KGRIB      - Array containing Grib coded data.
C
C     KLENG      - Length (words) of KGRIB.
C
C     KNSPT      - Bit number after which insertion/extraction starts.
C
C     KBITS      - Number of bits in computer word.
C
C     KRET       - Response to error indicator.
C                  0        , Abort if error encountered.
C                  Non-zero , Return to calling routine
C                             even if error encountered.
C
C     Output Parameters.
C     ------------------
C
C     KSEC1      - Array containing Grib Section 1 data.(Updated)
C
C     KGRIB      - Array containing Grib coded data.(Updated)
C
C     KNSPT      - Number of bit after last one inserted/extracted.(Updated)
C
C     KRET       - Return code.
C                  0   , No error encountered.
C                  2   , Error reported by routine INXBIT.
C
C
C     Method.
C     -------
C
C     Input data packed/unpacked in accordance with ECMWF usage of
C     local part of section 1 of Grib code, definition 18.
C
C
C     Externals.
C     ----------
C
C     INXBIT  - Insert/extract bits to/from bit stream.
C     ABORTX  - Abort processing.
C
C
C     Reference.
C     ----------
C
C     WMO Manual On Codes for Grib Code.
C
C
C     Comments.
C     ---------
C
#include "ecdef18.h"
C
C
C     Author.
C     -------
C
C     J.D.Chambers     ECMWF      February 2001
C
C
C     Modifications.
C     --------------
C
C     None.
C
C
C----<
C     -----------------------------------------------------------------|
C*    Section 0 . Definition of variables. Data statements.
C     -----------------------------------------------------------------|
C
      IMPLICIT NONE
C
#include "common/grprs.h"
C
C     Parameters
C
      CHARACTER*1   HFUNC
      INTEGER KSEC1, KGRIB, KLENG, KNSPT, KBITS, KRET
      DIMENSION KGRIB(*)
      DIMENSION KSEC1(*)
C
C     Local variables
C
      INTEGER IRET, IZERO, NUMBER, ILOOP, LOOP
CC    INTEGER INUM
      CHARACTER*4 HBLANK
C
      LOGICAL LENCODE
C
C     -----------------------------------------------------------------|
C*    Section 1 . Set initial values.
C     -----------------------------------------------------------------|
C
  100 CONTINUE
C
      IRET = KRET
      LENCODE = HFUNC.EQ.'C'
C
C     -----------------------------------------------------------------|
C*    Section 2 . Handle definition 1.
C     -----------------------------------------------------------------|
C
  200 CONTINUE
C
C     Octet 50 : Ensemble forecast number
C     Octet 51 : Total number of Forecasts.
C     Octet 52 : Data origin
C     Three 8-bit fields.
C
      CALL INXBIT(KGRIB,KLENG,KNSPT,KSEC1(42),3,KBITS,8,HFUNC,KRET)
      IF (KRET.NE.0) THEN
        KRET = 2
        WRITE(GRPRSM,*) 'ECDEF18: Error reported by routine INXBIT:'
        IF( LENCODE ) THEN
          WRITE(GRPRSM,*) '       encoding section 1, octets 50 to 52.'
        ELSE
          WRITE(GRPRSM,*) '       decoding section 1, octets 50 to 52.'
        ENDIF
      ENDIF
C
C     Octets 53 - 56 : Model identifier of forecast used
C     4 Ascii characters, right justified
C
      CALL INXBIT(KGRIB,KLENG,KNSPT,KSEC1(45),1,KBITS,32,HFUNC,KRET)
      IF (KRET.NE.0) THEN
        KRET = 2
        WRITE(GRPRSM,*) 'ECDEF18: Error reported by routine INXBIT:'
        IF( LENCODE ) THEN
          WRITE(GRPRSM,*) '       encoding section 1, octets 53 to 56.'
        ELSE
          WRITE(GRPRSM,*) '       decoding section 1, octets 53 to 56.'
        ENDIF
      ENDIF
C
C     Octet 57 : Consensus count
C     One 8-bit field.
C
      CALL INXBIT(KGRIB,KLENG,KNSPT,KSEC1(46),1,KBITS,8,HFUNC,KRET)
      IF (KRET.NE.0) THEN
        KRET = 2
        WRITE(GRPRSM,*) 'ECDEF18: Error reported by routine INXBIT:'
        IF( LENCODE ) THEN
          WRITE(GRPRSM,*) '       encoding section 1, octet 57.'
        ELSE
          WRITE(GRPRSM,*) '       decoding section 1, octet 57.'
        ENDIF
      ENDIF
C
C     Octets 58 to 60 : Spare (set to zero)
C
      DO LOOP = 1, 3
        IF ( LENCODE ) THEN
          IZERO = 0
          CALL INXBIT(KGRIB,KLENG,KNSPT,IZERO,1,KBITS,8,HFUNC,KRET)
          IF (KRET.NE.0) THEN
            KRET = 2
            WRITE(GRPRSM,*) 'ECDEF18: Error reported by routine INXBIT:'
            WRITE(GRPRSM,*)
     X   '         encoding section 1, octets 58 to 60.'
          ENDIF
        ELSE
          KNSPT = KNSPT + 8
        ENDIF
      ENDDO
C
C     Octets 61 to 120 : List of WMO centre identifiers for analyses used
C     Upto fifteen fields. ( Each 4 Ascii characters, right justified)
C
      NUMBER = KSEC1(46)
      DO LOOP = 1, NUMBER
        CALL INXBIT(KGRIB,KLENG,KNSPT,KSEC1(46+LOOP),1,
     X              KBITS,32,HFUNC,KRET)
        IF (KRET.NE.0) THEN
          KRET = 2
          WRITE(GRPRSM,*) 'ECDEF18: Error reported by routine INXBIT:'
          IF( LENCODE ) THEN
            WRITE(GRPRSM,*)
     X   '       encoding section 1, list of WMO ids.'
          ELSE
            WRITE(GRPRSM,*)
     X   '       decoding section 1, list of WMO ids.'
          ENDIF
        ENDIF
      ENDDO
C
C     Handle unused entries (set to blanks)
C
      DO LOOP = NUMBER+1, 15
        HBLANK = '    '
        IF ( LENCODE ) THEN
          CALL INXBIT(KGRIB,KLENG,KNSPT,HBLANK,1,KBITS,32,HFUNC,KRET)
          IF (KRET.NE.0) THEN
            KRET = 2
            WRITE(GRPRSM,*) 'ECDEF18: Error reported by routine INXBIT:'
            WRITE(GRPRSM,*) '         encoding section 1, unused list.'
          ENDIF
        ELSE
          KSEC1(46+LOOP) = 0
          DO ILOOP = 1, 4
            KSEC1(46+LOOP) = KSEC1(46+LOOP)*256 +
     X                       ICHAR(HBLANK(ILOOP:ILOOP))
          ENDDO
          KNSPT = KNSPT + 32
        ENDIF
      ENDDO
C
C     -----------------------------------------------------------------|
C*    Section 9 . Abort/return to calling routine. Format statements.
C     -----------------------------------------------------------------|
C
  900 CONTINUE
C
C     Abort if requested to do so when an error has been encountered.
C
      IF (IRET.EQ.0.AND.KRET.NE.0) THEN
        CALL ABORTX ('ECDEF18')
      ELSE
        RETURN
      ENDIF
C
      END

C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C


      SUBROUTINE REMSP (STRING)
C
C---->
C**** REMSP - Remove leading spaces from character string.
C     NAME       : REMSP
C
C     FUNCTION   : LEFT JUSTIFY CHARACTER STRING BY REMOVING
C                  ANY LEADING SPACES.
C
C     INPUT      : STRING = CHARACTER STRING, WITH OR WITHOUT
C                           LEADING SPACES.
C
C     OUTPUT     : STRING = CHARACTER STRING LEFT JUSTIFIED.
C
C         JOHN HENNESSY, ECMWF, 16TH APRIL 1985
C
C     ---------------------------------------------------------------
C----<
C
      CHARACTER*(*) STRING
C
      DO 100 I=1,LEN(STRING)
         IF (STRING(I:I).NE.' ') GO TO 200
  100 CONTINUE
C
C     Blank line.
C
      RETURN
C
C     Left justify string.
C
  200 STRING(1:) = STRING(I:)
C
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities
C granted to it by virtue of its status as an intergovernmental organisation
C nor does it submit to any jurisdiction.
C

      INTEGER FUNCTION ESTIMA()
C---->
C**** ESTIMA
C
C     Purpose
C     -------
C
C     Calculate size of scratch space required for output field of
C     interpolation.
C
C
C     Interface
C     ---------
C
C     ISIZE = ESTIMA()
C
C
C     Input
C     -----
C
C     Values in common blocks "nofld.common".
C
C
C     Output
C     ------
C
C     Size as number of values (words).
C     Returns 0 if output type not recognised.
C
C
C     Method
C     ------
C
C     Depends on output grid type.
C
C
C     Externals
C     ---------
C
C     INTLOG  - Log error message
C
C
C     Author
C     ------
C
C     J.D.Chambers     ECMWF     Feb 1995
C
C----<
C
      IMPLICIT NONE
C
#include "parim.h"
#include "nifld.common"
#include "nofld.common"
C
      INTEGER TMP
C
C     -----------------------------------------------------------------|
C     Section 1.  Initialise.
C     -----------------------------------------------------------------|
C
  100 CONTINUE
C
      ESTIMA = 0
      TMP = 0
C
C     -----------------------------------------------------------------|
C*    Section 2.   Spherical harmonic field
C     -----------------------------------------------------------------|
C
  200 CONTINUE
C
      IF( (NOREPR.EQ.JPSPHERE).OR.
     X    (NOREPR.EQ.JPSTRSH).OR.
     X    (NOREPR.EQ.JPSPHROT) ) THEN
cs        ESTIMA = (NORESO+1) * (NORESO+4)
        ESTIMA = (NORESO+1) * (NORESO+2)
        CALL INTLOG(JP_DEBUG,'ESTIMA: spherical harmonic = ',ESTIMA)
        GOTO 900
      ENDIF
C
C     -----------------------------------------------------------------|
C*    Section 5.  gaussian field
C     -----------------------------------------------------------------|
C
  500 CONTINUE
C
      IF(NOGAUSS.GT.0) THEN
C       ESTIMA = NOGAUSS * NOGAUSS * 8
        ESTIMA = (2*NOGAUSS) * (4*NOGAUSS + 20)  ! account for RGG/octahedral
        CALL INTLOG(JP_DEBUG,'ESTIMA: Gaussian Number = ', NOGAUSS)
        CALL INTLOG(JP_DEBUG,'ESTIMA: any gaussian= ',ESTIMA)
        GOTO 900
      ENDIF
C
C     -----------------------------------------------------------------|
C*    Section 3.   Regular lat/long field
C     -----------------------------------------------------------------|
C
  300 CONTINUE
C
      IF( (NOREPR.EQ.JPREGULAR).OR.(NOREPR.EQ.JPREGROT) ) THEN
        ESTIMA = (JP360/NOGRID(1) + 1) * (JP180 / NOGRID(2) + 1)
        IF( ABS(NOAREA(4)-NOAREA(2)).GT.0 .AND.
     X      ABS(NOAREA(3)-NOAREA(1)).GT.0 ) THEN
C         EMOS-277: extra (+1)*2 for memory allocation (see issue)
C         ! 2* to consider also vector interpolations (such as vo/d > u/v)
          TMP = (ABS(NOAREA(4)-NOAREA(2))/NOGRID(1) + 1 + 1)
     X        * (ABS(NOAREA(3)-NOAREA(1))/NOGRID(2) + 1 + 1)
          TMP = 2*TMP
          IF (ESTIMA>TMP) ESTIMA = TMP
        ENDIF
        CALL INTLOG(JP_DEBUG,'ESTIMA: Regular lat/long = ',ESTIMA)
      ENDIF

      IF(NILOCAL.EQ.4) THEN
        IF(NOGRID(1).GT.0.AND.NOGRID(1).GT.0) THEN
          ESTIMA = (JP360/NOGRID(1) + 1) * (JP180 / NOGRID(2) + 1)*2
        ELSE
          ESTIMA = 36099382
        ENDIF
        CALL INTLOG(JP_DEBUG,'ESTIMA: OCEAN field = ',ESTIMA)
      ENDIF
C
C     -----------------------------------------------------------------|
C*    Section 9.   Return
C     -----------------------------------------------------------------|
C
  900 CONTINUE
C
      CALL INTLOG(JP_DEBUG,
     X  'ESTIMA: number of points in output field = ',ESTIMA)
C
      RETURN
      END

C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE CREXPRS1(KSEC1,KSEC3,KTDLEN,KTDLST,KTDEXL,KTDEXP,
     1                    KELEM,CNAMES)
C
C**** *CREXPRS1*
C
C
C     PURPOSE.
C     --------
C           PRINT SECTION 1 OF CREX MESSAGE.
C
C
C**   INTERFACE.
C     ----------
C
C           *CALL* *CREXPRS1(KSEC1,KSEC3,KTDLEN,KTDLST,KTDEXL,KTDEXP,
C                            KELEM,CNAMES)*
C
C        INPUT :
C
C               *KSEC1*   -  ARRAY CONTAINING SECTION 1 INFORMATION
C                            KSEC1( 1)-- Not used
C                            KSEC1( 2)-- CREX EDITION NUMBER
C                            KSEC1( 3)-- Not used
C                            KSEC1( 4)-- Not Used
C                            KSEC1( 5)-- Not used
C                            KSEC1( 6)-- CREX MESSAGE TYPE
C                            KSEC1( 7)-- Not used
C                            KSEC1( 8)-- VERSION NUMBER OF LOCAL TABLE USED
C                            KSEC1( 9)-- Not used
C                            KSEC1(10)-- Not used
C                            KSEC1(11)-- Not used
C                            KSEC1(12)-- Not used
C                            KSEC1(13)-- Not used
C                            KSEC1(14)-- CREX MASTER TABLE
C                            KSEC1(15)-- VERSION NUMBER OF MASTER TABLE USED
C                            KSEC1(16) - KSEC1(JSEC1) -- Not used
C
C                            Crex Edition 2
C
C               *KSEC1*   -  Integer array of at least 40 words
C                            containing CREX section 1 information
C                            KSEC1( 1)-- Reserved
C                            KSEC1( 2)-- CREX Edition number
C                            KSEC1( 3)-- Originating Centre ( oooo)
C                            KSEC1( 4)-- Update sequence number (uu)
C                            KSEC1( 5)-- Number of subsets (sss)
C                            KSEC1( 6)-- CREX data category (nnn)
C                            KSEC1( 7)-- International data sub-category (mmm)
C                            KSEC1( 8)-- version number of local table used
C                            KSEC1( 9)-- Year (yyyy)
C                            KSEC1(10)-- Month (mm)
C                            KSEC1(11)-- Day (dd)
C                            KSEC1(12)-- Hour (hh)
C                            KSEC1(13)-- Minute (mm)
C                            KSEC1(14)-- CREX Master table (tt)
C                            KSEC1(15)-- version number of Master table used (vv)
C                            KSEC1(16)-- Originating sub-centre (ppp)
C                            KSEC1(17)-- Bufr master table version number
C                            KSEC1(18)-- Bufr version number of local table used
C                            KSEC1(19) - KSEC1(40) -- Reserved
C

C
C               *KSEC3*   -  Integer array of 4 words containing
C                            KSEC3( 1)-- Reserved
C                            KSEC3( 2)-- Reserved
C                            KSEC3( 3)-- number of subsets
C                            KSEC3( 4)-- Reserved

C               *KTDLEN*  -  number of data descriptors in section 1
C               *KTDLST*  -  array containing data descriptors in section 1
C               *KTDEXL*  -  number of entries in list of expanded data descriptors
C               *KTDEXP*  -  array containig expanded data descriptors
C               *KELEM*   -  Integer (expected number of expanded elements)
C               *CNAMES*  -  Character*64  array of KELEM containing
C                            CREX Table B element names
C
C
C     METHOD.
C     -------
C
C            NONE
C
C     EXTERNALS.
C     ----------
C
C            NONE.
C
C     REFERENCE.
C     ----------
C
C          NONE.
C
C     AUTHOR.
C     -------
C
C          MILAN DRAGOSAVAC    *ECMWF*       07/01/2004.
C
C     MODIFICATIONS.
C     --------------
C
C          NONE.
C
      IMPLICIT LOGICAL(L,O,G), CHARACTER*8(C,H,Y)
C
C
      DIMENSION KSEC1(*)
      DIMENSION KSEC3(*)
      DIMENSION KTDLST(KTDLEN),KTDEXP(KTDEXL)
C
      CHARACTER*64 CNAMES(KELEM)
      CHARACTER*6  YYYYYY

C
C     ------------------------------------------------------------------
C
C*          1.   PRINT SECTION 1.
C                ----------------
 100  CONTINUE
C
      WRITE(*,'(1H1)')
C
      WRITE(*,'(1H ,A)')    '        CREX SECTION 1    '
      WRITE(*,'(1H )')
      IF(KSEC1(2).LT.2) THEN
       WRITE(*,'(1H ,A,I5)')'CREX EDITION NUMBER            ',KSEC1( 2)
       WRITE(*,'(1H ,A,I5)')'CREX MESSAGE TYPE              ',KSEC1( 6)
       WRITE(*,'(1H ,A,I5)')'VERSION NUMBER OF LOCAL TABLE  ',KSEC1( 8)
       WRITE(*,'(1H ,A,I5)')'VERSION NUMBER OF MASTER TABLE ',KSEC1(15)
       WRITE(*,'(1H ,A,I5)')'CREX MASTER TABLE              ',KSEC1(14)
C
       WRITE(*,'(1H1)')
       WRITE(*,'(1H ,A,I5)')'NUMBER OF SUBSETS              ',KSEC3( 3)
      ELSE
       WRITE(*,'(1H ,A,I5)')'CREX EDITION NUMBER            ',KSEC1( 2)
       WRITE(*,'(1H ,A,I5)')'ORIGINATING CENTRE             ',KSEC1( 3)
       WRITE(*,'(1H ,A,I5)')'ORIGINATING SUB-CENTRE         ',KSEC1(16)
       WRITE(*,'(1H ,A,I5)')'UPDATE SEQUENCE NUMBER         ',KSEC1( 4)
       WRITE(*,'(1H ,A,I5)')'CREX DATA CATEGORY             ',KSEC1( 6)
       WRITE(*,'(1H ,A,I5)')'INTERNATIONAL DATA SUB-CATEGORY',KSEC1( 7)
       WRITE(*,'(1H ,A,I5)')'YEAR                           ',KSEC1( 9)
       WRITE(*,'(1H ,A,I5)')'MONTH                          ',KSEC1(10)
       WRITE(*,'(1H ,A,I5)')'DAY                            ',KSEC1(11)
       WRITE(*,'(1H ,A,I5)')'HOUR                           ',KSEC1(12)
       WRITE(*,'(1H ,A,I5)')'MINUTE                         ',KSEC1(13)
       WRITE(*,'(1H ,A,I5)')'VERSION NUMBER OF MASTER TABLE ',KSEC1(15)
       WRITE(*,'(1H ,A,I5)')'VERSION NUMBER OF LOCAL TABLE  ',KSEC1( 8)
       WRITE(*,'(1H ,A,I5)')'CREX MASTER TABLE              ',KSEC1(14)
       WRITE(*,'(1H ,A,I5)')'BUFR MASTER TABLE NUMBER       ',KSEC1(17)
       WRITE(*,'(1H ,A,I5)')'BUFR VERSION OF LOCAL TABLE    ',KSEC1(18)
C
       WRITE(*,'(1H1)')
       WRITE(*,'(1H ,A,I5)')'NUMBER OF SUBSETS              ',KSEC3( 3)
C
      END IF
C
C
      WRITE(*,'(1H ,//)')
      WRITE(*,'(1H ,A)')    '       DATA DESCRIPTORS (UNEXPANDED)'
      WRITE(*,'(1H )')
C
      WRITE(*,'(1H )')
      DO 110 I=1,KTDLEN
       write(yyyyyy,'(i6.6)') KTDLST(I)
       if(yyyyyy(1:1).eq.'0') yyyyyy(1:1)='B'
       if(yyyyyy(1:1).eq.'1') yyyyyy(1:1)='R'
       if(yyyyyy(1:1).eq.'2') yyyyyy(1:1)='C'
       if(yyyyyy(1:1).eq.'3') yyyyyy(1:1)='D'
       WRITE(*,'(1H ,I4,2X,A)') I,yyyyyy
 110  CONTINUE
C
      WRITE(*,'(1H ,/)')
      WRITE(*,'(1H ,A)')    '       DATA DESCRIPTORS (EXPANDED)'
      WRITE(*,'(1H )')
      DO 120 I=1,KTDEXL
       write(yyyyyy,'(i6.6)') KTDEXP(I)
       if(yyyyyy(1:1).eq.'0') yyyyyy(1:1)='B'
       if(yyyyyy(1:1).eq.'1') yyyyyy(1:1)='R'
       if(yyyyyy(1:1).eq.'2') yyyyyy(1:1)='C'
       if(yyyyyy(1:1).eq.'3') yyyyyy(1:1)='D'
       WRITE(*,'(1H ,I5,2X,A,2X,A)') I,yyyyyy,CNAMES(I)
 120  CONTINUE

      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C


      SUBROUTINE SCM0   (PDL,PDR,PFL,PFR,KLG)
C
C---->
C**** SCM0   - Apply SCM0 limiter to derivative estimates.
C
C    M. HORTAL    ECMWF February 1991  closely following D. WILLIAMSON
C
C    Apply SCM0 limiter to derivative estimates.
C
C   output:
C     pdl   = the limited derivative at the left edge of the interval
C     pdr   = the limited derivative at the right edge of the interval
C
C   inputs
C     pdl   = the original derivative at the left edge
C     pdr   = the original derivative at the right edge
C     pfl   = function value at the left edge of the interval
C     pfr   = function value at the right edge of the interval
C     klg  = number of intervals where the derivatives are limited
C
C----<
      INTEGER KLG
C
      REAL PDL(KLG), PDR(KLG), PFL(KLG), PFR(KLG)
C
      INTEGER JL
C      
      REAL ZALPHA, ZBETA, ZEPS, ZFAC
C
  100 CONTINUE
C
C    define constants
C
      ZEPS=1.E-12
      ZFAC=3.*(1.-ZEPS)
C
      DO 200 JL=1,KLG
      IF(ABS(PFR(JL)-PFL(JL)).GT.ZEPS) THEN
          ZALPHA=PDL(JL)/(PFR(JL)-PFL(JL))
          ZBETA =PDR(JL)/(PFR(JL)-PFL(JL))
          IF(ZALPHA.LE.0.) PDL(JL)=0.
          IF(ZBETA .LE.0.) PDR(JL)=0.
          IF(ZALPHA.GT.ZFAC) PDL(JL)=ZFAC*(PFR(JL)-PFL(JL))
          IF(ZBETA .GT.ZFAC) PDR(JL)=ZFAC*(PFR(JL)-PFL(JL))
      ELSE
          PDL(JL)=0.
          PDR(JL)=0.
      ENDIF
  200 CONTINUE
      END

C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities
C granted to it by virtue of its status as an intergovernmental organisation
C nor does it submit to any jurisdiction.
C

      INTEGER FUNCTION IGLSMD(KDATE,KREPR,KGRID,KGAUSS,KAREA,KLN,
     X   HFILE, OSTAND, KOGRID, KOLINE, KNREC, KPR, KERR)
C
C---->
C**** *IGLSMD*
C
C     PURPOSE
C     _______
C
C     Generate the land sea mask file information.
C
C     INTERFACE
C     _________
C
C     IERR = IGLSMD(KDATE,KREPR,KGRID,KGAUSS,KAREA,KLN,
C    X          HFILE, OSTAND, KOGRID, KOLINE, KNREC, KPR, KERR)
C
C     Input parameters
C     ________________
C
C     KDATE      - The field date in YYMMDD format
C
C     KREPR      - The field representation.
C
C     KGRID      - The latitude/longitude field grid definition
C                  (WE, NS) or Gaussian truncation.
C
C     KAREA      - The field area definition (N, W, S, E).
C
C     KLN        - The Northern line number. This is mainly used for
C                  Gaussian grids.
C
C     KPR        - The debug print switch.
C                  0  , No debugging output.
C                  1  , Produce debugging output.
C
C     KERR       - The error control flag.
C                  -ve, No error message. Return error code.
C                  0  , Hard failure with error message.
C                  +ve, Print error message. Return error code.
C
C     Output parameters
C     ________________
C
C     HFILE      - The filename for the land-sea mask.
C
C     OSTAND     - Flag indicating whether the land-sea mask is
C                  a prestored "standard" field.
C
C     KOGRID     - The grid stride (WE, NS) in a pre-stored
C                  "standard" land sea mask file.
C
C     KOLINE     - The offsets (N, W) of the first points in a
C                  pre-stored "standard" land sea mask file.
C
C     KNREC      - The file line length for the input array. This is
C                  used for positioning and transfer purposes.
C
C     Return value
C     ____________
C
C     The status indicator (INTEGER).
C          = 0 if OK,
C          = 25201 if data representation type is not valid.
C          = 25202 if unable to locate lsm file for reduced gaussian
C
C     Common block usage
C     __________________
C
C     None
C
C     EXTERNALS
C     _________
C
C     GETENV     - Standard routine to get environmental variable.
C     INDEX      - Intrinsic routine to find position of substring.
C     LEN        - Intrinsic routine to find length of string.
C     INTLOG(R)  - Logs messages.
C     EMOSNUM    - Gives current EMOSLIB version number.
C
C     METHOD
C     ______
C
C     NOTE This routine is highly machine dependent as the path and
C     file names for all land sea mask files are in the text. GETENV
C     is used to allow the specification of an alternate directory
C     for the storage of land sea masks (variable MARS_LSM_PATH).
C
C     The grid definition is compared with the definitions of the
C     pre-stored land sea mask files. If a match is found then the
C     appropriate filename is returned and the stride and offset
C     arrays are set to appropriate values. If no match is found then
C     the name of the basic 10 minute 0-1 land sea mask file is
C     returned.
C
C     REFERENCE
C     _________
C
C     None
C
C     COMMENTS
C     ________
C
C     Program contains sections 0 to 5 and 9
C
C     AUTHOR
C     ______
C
C     K. Fielding      *ECMWF*      Nov 1993
C
C     MODIFICATIONS
C     _____________
C
C     J.D.Chambers     ECMWF        7 Feb 96
C     Add lookup for reduced gaussian fields
C
C     J.D.Chambers     ECMWF       Nov 98
C     Change default pathnames.
C
C----<
C     _______________________________________________________
C
C*    Section 0. Definition of variables.
C     _______________________________________________________
C
      IMPLICIT NONE
C
#include "parim.h"
C
C     Function arguments
C
      CHARACTER *(*) HFILE
      LOGICAL OSTAND
      INTEGER KDATE, KREPR, KGAUSS, KLN, KNREC, KPR, KERR
      INTEGER KGRID(2), KAREA(4), KOGRID(2), KOLINE(2)
C
C     Parameters
C
      INTEGER JPROUTINE
      PARAMETER (JPROUTINE = 25200)
      INTEGER JPFILES
      INTEGER JPN80, JPR160, JP0P5LL, JP0P25LL
      PARAMETER (JPFILES = 4)
      PARAMETER (JPN80 = 1)
      PARAMETER (JPR160 = 2)
      PARAMETER (JP0P5LL = 3)
      PARAMETER (JP0P25LL = 4)
C
C     Local variables
C
      CHARACTER*6 YEMOSNM,YFLAG,YFLAG1
      INTEGER IEMOSNM
      INTEGER ILSTRIDE, IRET, IOFFSET
      LOGICAL LDEBUG, L10MIN, L025
C
      CHARACTER*256 YBASE
      CHARACTER*256 YENVBACK
C
C     List of standard filenames       - YFILES
C     File for 10 minute land sea mask - YLSM10
C
      CHARACTER*40 YFILES (JPFILES), YLSM10
C
      INTEGER IBASELEN, ILSM10LEN
      INTEGER IFILELEN (JPFILES)
C
C     External functions
C
      INTEGER EMOSNUM, LSM_RED, DPATH_TABLES_INTERPOL
      EXTERNAL EMOSNUM, LSM_RED, DPATH_TABLES_INTERPOL
C
      DATA YLSM10 / 'lsm_xx_lsm10m01' /
      DATA ILSM10LEN / 15 /
      DATA YFILES /
     X  'lsm_xx_lsmn080',
     X  'lsm_xx_lsmr160',
     X  'lsm_xx_lsm0p5deg',
     X  'lsm_xx_lsm0p25deg'
     X  /
      DATA IFILELEN/ 14, 14, 16, 17 /
C
C     _______________________________________________________
C
C*    Section 1. Initialisation
C     _______________________________________________________
C
  100 CONTINUE
C
      L10MIN = .FALSE.
C     Force processing with 10min lsm with env variable
        CALL GETENV('LSM_10MIN', YFLAG)
        IF( YFLAG(1:1).EQ.'1' ) L10MIN = .TRUE.

      IF( L10MIN ) CALL INTLOG(JP_DEBUG,
     X  'IGLSMD: Forcing processing with 10 min',JPQUIET)

      L025 = .FALSE.
C     Processing with 0.25 Predefined lsm Enable
        CALL GETENV('LSM_025', YFLAG1)
        IF( YFLAG1(1:1).EQ.'1' ) L025 = .TRUE.

      IF( L025 ) CALL INTLOG(JP_DEBUG,
     X 'IGLSMD: Processing with 0.25 Predefined LSM Enabled',JPQUIET)

      IGLSMD = 0
      LDEBUG = ( KPR.GE.1 )
C
      IF( LDEBUG ) THEN
        CALL INTLOG(JP_DEBUG,'IGLSMD: Input parameters.',JPQUIET)
        CALL INTLOG(JP_DEBUG,'IGLSMD: Date = ',KDATE)
        CALL INTLOG(JP_DEBUG,'IGLSMD: Grid representation = ',KREPR)
        CALL INTLOG(JP_DEBUG,'IGLSMD: N line number = ', KLN)
C
        IF( (KREPR.EQ.JPGAUSSIAN).OR.
     X      (KREPR.EQ.JPQUASI)   .OR.
     X      (KREPR.EQ.JPQGGROT)  .OR.
     X      (KREPR.EQ.JPFGGROT) ) THEN
          CALL INTLOG(JP_DEBUG,'IGLSMD: Gaussian trunc = ',KGAUSS)
        ELSE IF( (KREPR.EQ.JPREGULAR).OR.(KREPR.EQ.JPREGROT) ) THEN
          CALL INTLOG(JP_DEBUG,'IGLSMD: Grid WE = ',KGRID(1))
          CALL INTLOG(JP_DEBUG,'IGLSMD: Grid NS = ',KGRID(2))
        ENDIF
C
        CALL INTLOG(JP_DEBUG,'IGLSMD: Area North = ', KAREA(1))
        CALL INTLOG(JP_DEBUG,'IGLSMD: Area West  = ', KAREA(2))
        CALL INTLOG(JP_DEBUG,'IGLSMD: Area South = ', KAREA(3))
        CALL INTLOG(JP_DEBUG,'IGLSMD: Area East  = ', KAREA(4))
C
      ENDIF
C
C     _______________________________________________________
C
C*    Section 2. Check environment variable for path of land sea masks.
C
C                GETENV returns a blank value if the environmental
C                variable is not set. This is true for C90, Sun and
C                SGI.
C     _______________________________________________________
C
  200 CONTINUE
C
      IF ( LDEBUG ) CALL INTLOG(JP_DEBUG,'IGLSMD: Section 2.',JPQUIET)
C
      IBASELEN = DPATH_TABLES_INTERPOL(YENVBACK)
      IF( IBASELEN.EQ.0 ) THEN
        IF( LDEBUG ) CALL INTLOG(JP_ERROR,
     X    'IGLSMD: unable to build LSM directory path.',JPQUIET)
        IGLSMD = JPROUTINE + 3
        GOTO 900
      ENDIF
      YBASE = YENVBACK
C
C     _______________________________________________________
C
C*    Section 3. Standard Gaussian grids - N80
C     _______________________________________________________
C
  300 CONTINUE
C
      IF( (KREPR.EQ.JPGAUSSIAN).OR.
     X    (KREPR.EQ.JPFGGROT) ) THEN
        IF( LDEBUG ) CALL INTLOG(JP_DEBUG,'IGLSMD: Section 3.',JPQUIET)
C
        ILSTRIDE = JP90 / KGAUSS
        KOGRID (JPWESTEP) = 1
        KOGRID (JPNSSTEP) = 1
        KOLINE (JPWEST) = KAREA (JPWEST) / ILSTRIDE + 1
        KOLINE (JPNORTH) = KLN
C
        IF( KGAUSS.EQ.80 ) THEN
C
          HFILE = YBASE(1:IBASELEN) // YFILES(JPN80)(1:IFILELEN(JPN80))
          OSTAND = .TRUE.
          KNREC = 320
C
        ELSE
C
          HFILE = YBASE(1:IBASELEN) // YLSM10(1:ILSM10LEN)
          OSTAND = .FALSE.
          KNREC = JPPACK
C
        ENDIF
C
C     _______________________________________________________
C
C*    Section 4. Standard reduced Gaussian grids - R160
C     _______________________________________________________
C
  400 CONTINUE
C
      ELSE IF( KREPR.EQ.JPQUASI ) THEN
        IF( LDEBUG ) CALL INTLOG(JP_DEBUG,'IGLSMD: Section 4.',JPQUIET)
C
        KOGRID(JPWESTEP) = 1
        KOGRID(JPNSSTEP) = 1
        KOLINE(JPWEST)   = 1
        KOLINE(JPNORTH)  = KLN
C
        IF( KGAUSS.EQ.160 ) THEN
          IRET = LSM_RED(KGAUSS,KDATE,32,HFILE)
          IF( IRET.EQ.0 ) THEN
            IF( LDEBUG ) CALL INTLOG(JP_ERROR,
     X        'IGLSMD: LSM_RED unable to locate lsm file.',JPQUIET)
            IGLSMD = JPROUTINE + 2
            GOTO 900
          ENDIF
          OSTAND = .TRUE.
          KNREC = 0
        ELSE
C
          HFILE = YBASE(1:IBASELEN) // YLSM10(1:ILSM10LEN)
          OSTAND = .FALSE.
          KNREC = JPPACK
C
        ENDIF
C
C     _______________________________________________________
C
C*    Section 5. Latitude/longitude grids
C
C                The standard 0.5 degree grid is used for any
C                grid which has a stride which is a multiple of
C                0.5 and North and South limits which are a
C                multiple of 0.5
C     _______________________________________________________
C
  500 CONTINUE
C
      ELSE IF( (KREPR.EQ.JPREGULAR).OR.(KREPR.EQ.JPREGROT) ) THEN
        IF( LDEBUG ) CALL INTLOG(JP_DEBUG,'IGLSMD: Section 5.',JPQUIET)
C
        IF( MOD(KGRID(JPNSSTEP),JP0P5).EQ.0 .AND.
     1      MOD(KGRID(JPWESTEP),JP0P5).EQ.0 .AND.
     2      MOD(KAREA(JPNORTH), JP0P5).EQ.0 .AND.
     3      MOD(KAREA(JPWEST),  JP0P5).EQ.0 .AND.
     4      .NOT.L10MIN ) THEN
C
        HFILE=YBASE(1:IBASELEN)//YFILES(JP0P5LL)(1:IFILELEN(JP0P5LL))
          OSTAND = .TRUE.
          KNREC = 720
C
          KOGRID(JPWESTEP) = KGRID(JPWESTEP) / JP0P5
          KOGRID(JPNSSTEP) = KGRID(JPNSSTEP) / JP0P5
          KOLINE(JPWEST)   = KAREA(JPWEST) / JP0P5 + 1
          KOLINE(JPNORTH)  = (JP90 - KAREA(JPNORTH) ) / JP0P5 + 1
C
        ELSE
C
          HFILE = YBASE(1:IBASELEN) // YLSM10(1:ILSM10LEN)
          OSTAND = .FALSE.
          KNREC = JPPACK
C
          KOGRID (JPWESTEP) = 1
          KOGRID (JPNSSTEP) = 1
          KOLINE (JPWEST) = 1
          KOLINE (JPNORTH) = KLN
C
        ENDIF
      ELSE
        IGLSMD = JPROUTINE + 1
        IF( KERR.GE.0 ) CALL INTLOG(JP_ERROR,
     X     'IGLSMD: Invalid data representation = ',KREPR)
C
        IF( KERR.EQ.0 ) CALL INTLOG(JP_FATAL,
     X     'IGLSMD: Interpolation failed.',IGLSMD)
C       GOTO 900
      ENDIF

      IF( L025 ) THEN
        IF( KGRID(JPNSSTEP).EQ.JP0P25.AND.
     1      KGRID(JPWESTEP).EQ.JP0P25.AND.
     2      MOD(KAREA(JPNORTH), JP0P25).EQ.0 .AND.
     3      MOD(KAREA(JPWEST),  JP0P25).EQ.0 .AND.
     4      .NOT.L10MIN ) THEN
C
        HFILE=YBASE(1:IBASELEN)//YFILES(JP0P25LL)(1:IFILELEN(JP0P25LL))
          OSTAND = .TRUE.
          KNREC = 1440
C
            KOGRID(JPWESTEP) = 1
            KOGRID(JPNSSTEP) = 1
            KOLINE(JPWEST)   = KAREA(JPWEST) / JP0P25 + 1
            KOLINE(JPNORTH)  = (JP90 - KAREA(JPNORTH) ) / JP0P25 + 1
        ENDIF
      ENDIF
C
C     _______________________________________________________
C
C
C*    Section 9. Return to calling routine. Format statements
C     _______________________________________________________
C
  900 CONTINUE
C
      IF( LDEBUG ) CALL INTLOG(JP_DEBUG,'IGLSMD: Section 9.',JPQUIET)
C
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities
C granted to it by virtue of its status as an intergovernmental organisation
C nor does it submit to any jurisdiction.
C

      INTEGER FUNCTION HLL2LL(L12PNT,OLDFLD,OLDGRID,AREA,POLE,GRID,
     X                        NEWFLD,KSIZE,NLON,NLAT)
C
C---->
C**** HLL2LL
C
C     Purpose
C     -------
C
C     This routine creates a rotated regular lat/long field from a
C     global regular lat/long field using 12-point horizontal
C     interpolation.
C
C
C     Interface
C     ---------
C
C     IRET = HLL2LL(L12PNT,OLDFLD,OLDGRID,AREA,POLE,GRID,NEWFLD,KSIZE,
C    X              NLON,NLAT)
C
C
C     Input parameters
C     ----------------
C
C     L12PNT  - Chooses between 12-point and 4-point interpolation
C     OLDFLD  - The array of values from the regular lat/long field
C     OLDGRID - Grid increments (i/j) for the global lat/long field
C     AREA    - Limits of area (N/W/S/E) for the new lat/long field
C     POLE    - Pole of rotation (lat/long) for the new lat/long field
C     GRID    - Grid increments (i/j) for the new lat/long field
C     KSIZE   - The size of the array to fill with the new
C               lat/long field
C
C
C     Output parameters
C     -----------------
C
C     NEWFLD - The array of values for the regular lat/long field
C     NLON   - Number of longitudes in the regular lat/long field
C     NLAT   - Number of latitudes in the regular lat/long field
C
C     Returns 0 if function successful, non-zero otherwise.
C
C     Common block usage
C     ------------------
C
C
C
C     Method
C     ------
C
C     Numbering of the points (I is the interpolation point):
C
C                   13       5       6      14
C
C                    7       1       2       8
C                               (I)
C                    9       3       4      10
C
C                   15      11      12      16
C
C     The 12-point interpolation is not possible if either of the top
C     two rows is above the original field northern latitude. The
C     nearest neighbour is used if both rows are above, and a 4-pt
C     bilinear interpolation is used if the top row is above.
C     Similarily, if either of the bottom two rows is below the original
C     field southern latitude.
C
C
C     Externals
C     ---------
C
C     INTLOG  - Logs messages
C     JMALLOC - Dynamically allocate memory
C     JFREE   - Free dynamically allocated memory
C     HGENLL  - Calculates original lat/long (before rotation) for
C               a rotated grid
C     HNEILL  - Finds neighbours for points for interpolation
C     HWTSLL  - Calculates weightings for points for interpolation
C     FORCED_NEAREST_NEIGHBOUR - check forced interpolation method
C
C
C     Reference
C     ---------
C
C     None.
C
C
C     Comments
C     --------
C
C     None.
C
C
C     Author
C     ------
C
C     J.D.Chambers      ECMWF      November 2001
C
C
C     Modifications
C     -------------
C
C     None.
C
C----<
C     -----------------------------------------------------------------|
C*    Section 0. Definition of variables.
C     -----------------------------------------------------------------|
C
      IMPLICIT NONE
C
#include "parim.h"
#include "nifld.common"
#include "nofld.common"
C
C     Parameters
C
      INTEGER JNORTH, JSOUTH, JWEST, JEAST, JW_E, JN_S, JLAT, JLON
      INTEGER JP12PT, JP4PT, JPNEARN
      PARAMETER (JP12PT  = 0)
      PARAMETER (JP4PT   = 1)
      PARAMETER (JPNEARN = 2)
      PARAMETER (JNORTH = 1 )
      PARAMETER (JWEST  = 2 )
      PARAMETER (JSOUTH = 3 )
      PARAMETER (JEAST  = 4 )
      PARAMETER (JW_E  = 1 )
      PARAMETER (JN_S  = 2 )
      PARAMETER (JLAT  = 1 )
      PARAMETER (JLON  = 2 )
C
C     Function arguments
C
      LOGICAL L12PNT
      INTEGER KSIZE, NLON, NLAT
      REAL OLDGRID(2),AREA(4),POLE(2),GRID(2),OLDFLD(*),NEWFLD(KSIZE)
C
C     Local variables
C
      INTEGER NEXT, LOOP, IRET, NLEN, NPREV, NBYTES, NUMBER
      INTEGER NOLDLAT, NOLDLON, NEAREST
C
      LOGICAL LNEW, LFIRST, LVEGGY
      INTEGER KSCHEME(1),NEIGH(12,1), KLA(1)
      REAL PWTS(12,1)
      POINTER (IPKSCHE, KSCHEME)
      POINTER (IPNEIGH, NEIGH)
      POINTER (IPKLA,   KLA)
      POINTER (IPPWTS,  PWTS)
C
      REAL PDLO0(1),PDLO1(1),PDLO2(1),PDLO3(1),PDLAT(1)
      POINTER (IPPDLO0, PDLO0)
      POINTER (IPPDLO1, PDLO1)
      POINTER (IPPDLO2, PDLO2)
      POINTER (IPPDLO3, PDLO3)
      POINTER (IPPDLAT, PDLAT)
C
      REAL PREGRID(2)
      INTEGER KPTS(1)
      REAL GLATS(1)
      INTEGER IOFFS(1)
      POINTER (IPKPTS,  KPTS)
      POINTER (IPIOFFS, IOFFS)
      POINTER (IPGLATS, GLATS)
C
      INTEGER ILL, ILLOLD
      REAL RLAT(1),RLON(1)
      POINTER (IPRLAT, RLAT)
      POINTER (IPRLON, RLON)
C
      REAL OLD(1)
      POINTER (IOLD,   OLD)
C
      DATA NPREV/-1/
      DATA LNEW/.FALSE./, LFIRST/.TRUE./
      DATA ILLOLD/-1/, IOLD/-1/
      DATA PREGRID/2*0.0/
C
      SAVE LNEW, LFIRST
      SAVE IPKSCHE, IPNEIGH, IPKLA, IPPWTS
      SAVE IPPDLO0, IPPDLO1, IPPDLO2, IPPDLO3, IPPDLAT
      SAVE NPREV, IPKPTS, IPIOFFS, IPGLATS
      SAVE ILLOLD, IPRLAT, IPRLON, IOLD
      SAVE PREGRID
C
C     Externals
C
      LOGICAL FORCED_NEAREST_NEIGHBOUR
      INTEGER HNEILL, HGENLL
#ifdef POINTER_64
      INTEGER*8 JMALLOC
#else
      INTEGER JMALLOC
#endif
C
C     -----------------------------------------------------------------|
C     Section 1.  Initialise.
C     -----------------------------------------------------------------|
C
  100 CONTINUE
C
      HLL2LL = 0
C
      CALL JDEBUG()

      IF( L12PNT ) THEN
        CALL INTLOG(JP_DEBUG,'HLL2LL: 12-pt interpolation',JPQUIET)
      ELSE
        CALL INTLOG(JP_DEBUG,'HLL2LL:  4-pt interpolation',JPQUIET)
      ENDIF
C
      CALL CHKPREC()
      IF( LPREC )THEN
        CALL INTLOG(JP_DEBUG,
     X   'HLL2LL: precipitation threshold applied',JPQUIET)
      ELSE
        CALL INTLOG(JP_DEBUG,
     X   'HLL2LL: precipitation threshold not applied',JPQUIET)
      ENDIF

C     Use nearest neighbour if required
      LVEGGY = FORCED_NEAREST_NEIGHBOUR(LMETHOD,NITABLE,NIPARAM)
      IF( LVEGGY ) CALL INTLOG(JP_DEBUG,
     X  'HLL2LL: nearest neighbour processing',JPQUIET)

      NOLDLAT = 1 + NINT(180.0/OLDGRID(1))
      NOLDLON = NINT(360.0/OLDGRID(2))
      NUMBER  = NOLDLAT * NOLDLON
C
      IF( (OLDGRID(1).NE.PREGRID(1)).OR.
     X    (OLDGRID(2).NE.PREGRID(2)) ) THEN
C
C       Allocate memory to hold the input field
C       (in case OLDFLD and NEWFLD are the same arrays)
C
        IF( IOLD.GT.0 ) CALL JFREE(IOLD)
C
        NBYTES = NUMBER * JPRLEN
C
        IOLD = JMALLOC(NBYTES)
#ifdef hpR64
        IOLD = IOLD/(1024*1024*1024*4)
#endif
        IF( IOLD.EQ.0 ) THEN
          CALL INTLOG(JP_ERROR,'HLL2LL: Memory allocation fail',JPQUIET)
          HLL2LL = 3
          GOTO 900
        ENDIF
C
        PREGRID(1) = OLDGRID(1)
        PREGRID(2) = OLDGRID(2)
C
      ENDIF
C
C     Preserve the input field
C
      DO LOOP = 1, NUMBER
        OLD(LOOP) = OLDFLD(LOOP)
      ENDDO
C
C     -----------------------------------------------------------------|
C     Section 2.  Generate the lat/long points for the output grid
C     -----------------------------------------------------------------|
C
  200 CONTINUE
C
      NLON = 1 + NINT((AREA(JEAST) - AREA(JWEST)) / GRID(JW_E)) ! SC
      NLAT = 1 + NINT((AREA(JNORTH) - AREA(JSOUTH)) / GRID(JN_S)) ! SC
C
      NLEN = NLON * NLAT

      NOWE = NLON
      NONS = NLAT
C
C     Check that given array is big enough for the new field.
C
      IF( NLEN.GT.KSIZE ) THEN
        CALL INTLOG(JP_ERROR,'HLL2LL: Given array size = ',KSIZE)
        CALL INTLOG(JP_ERROR,'HLL2LL: Required size = ',NLEN)
        HLL2LL = 4
        GOTO 900
      ENDIF
C
C     Dynamically allocate memory for lat/long arrays.
C
      ILL = NLEN
      IF( ILL.GT.ILLOLD ) THEN
C
        LNEW = .TRUE.
C
        IF( ILLOLD.GT.0 ) CALL JFREE(IPRLON)
C
        NBYTES = 2*ILL*JPRLEN
C
        IPRLON = JMALLOC(NBYTES)
#ifdef hpR64
        IPRLON = IPRLON/(1024*1024*1024*4)
#endif
        IF( IPRLON.EQ.0 ) THEN
          CALL INTLOG(JP_ERROR,'HLL2LL: Memory allocation fail',JPQUIET)
          HLL2LL = 5
          GOTO 900
        ENDIF
C
        IPRLAT = IPRLON + (ILL*JPRLEN)
C
        ILLOLD = ILL
C
      ENDIF
C
      IRET = HGENLL(AREA,POLE,GRID,NLON,NLAT,RLAT,RLON)
      IF( IRET.NE.0 ) THEN
        CALL INTLOG(JP_ERROR,
     X    'HLL2LL: HGENLL failed to get lat/lon grid data',JPQUIET)
        HLL2LL = 6
        GOTO 900
      ENDIF
C
C     -----------------------------------------------------------------|
C     Section 3.  Find neighbours for each point for interpolation.
C     -----------------------------------------------------------------|
C
  300 CONTINUE
C
C     Dynamically allocate memory for interpolation arrays.
C
      IF( LNEW ) THEN
C
        IF( .NOT.LFIRST ) CALL JFREE(IPPDLO0)
C
        NBYTES = (17*JPRLEN + 14*JPBYTES) * ILL
C
        IPPDLO0 = JMALLOC(NBYTES)
#ifdef hpR64
        IPPDLO0 = IPPDLO0/(1024*1024*1024*4)
#endif
        IF( IPPDLO0.EQ.0 ) THEN
          CALL INTLOG(JP_ERROR,'HLL2LL: Memory allocation fail',JPQUIET)
          HLL2LL = 7
          GOTO 900
        ENDIF
C
        IPPDLO1 = IPPDLO0 + (ILL*JPRLEN)
        IPPDLO2 = IPPDLO1 + (ILL*JPRLEN)
        IPPDLO3 = IPPDLO2 + (ILL*JPRLEN)
        IPPDLAT = IPPDLO3 + (ILL*JPRLEN)
        IPPWTS  = IPPDLAT + (ILL*JPRLEN)
        IPKSCHE = IPPWTS  + (12*ILL*JPRLEN)
        IPKLA   = IPKSCHE + (ILL*JPBYTES)
        IPNEIGH = IPKLA   + (ILL*JPBYTES)
C
        LFIRST = .FALSE.
        LNEW   = .FALSE.
C
      ENDIF
C
C     Find neighbours.
C
      IRET = HNEILL(L12PNT,NLEN,RLAT,RLON,OLDGRID,
     X              KSCHEME,PDLAT,PDLO0,PDLO1,PDLO2,PDLO3,KLA,NEIGH)
      IF( IRET.NE.0 ) THEN
        CALL INTLOG(JP_ERROR,
     X    'HLL2LL: HNEILL failed to find neighbours',JPQUIET)
        HLL2LL = 8
        GOTO 900
      ENDIF
C
C     -----------------------------------------------------------------|
C     Section 4.  Perform the 12-point horizontal interpolation.
C     -----------------------------------------------------------------|
C
  400 CONTINUE
C
C     Setup the 12-point horizontal interpolation weights
C
      CALL HWTSLL
     X  (NLEN,KSCHEME,KLA,PDLAT,oldgrid(2),pdlo0,PDLO1,PDLO2,PDLO3,
     X   NEIGH,PWTS)
C
C     Calculate the interpolated grid point values
C
      DO LOOP = 1, NLEN
        IF( LVEGGY) THEN
            NEAREST = 1
            IF( PWTS( 2,LOOP).GT.PWTS(NEAREST,LOOP) ) NEAREST = 2
            IF( PWTS( 3,LOOP).GT.PWTS(NEAREST,LOOP) ) NEAREST = 3
            IF( PWTS( 4,LOOP).GT.PWTS(NEAREST,LOOP) ) NEAREST = 4
            IF( PWTS( 5,LOOP).GT.PWTS(NEAREST,LOOP) ) NEAREST = 5
            IF( PWTS( 6,LOOP).GT.PWTS(NEAREST,LOOP) ) NEAREST = 6
            IF( PWTS( 7,LOOP).GT.PWTS(NEAREST,LOOP) ) NEAREST = 7
            IF( PWTS( 8,LOOP).GT.PWTS(NEAREST,LOOP) ) NEAREST = 8
            IF( PWTS( 9,LOOP).GT.PWTS(NEAREST,LOOP) ) NEAREST = 9
            IF( PWTS(10,LOOP).GT.PWTS(NEAREST,LOOP) ) NEAREST =10
            IF( PWTS(11,LOOP).GT.PWTS(NEAREST,LOOP) ) NEAREST =11
            IF( PWTS(12,LOOP).GT.PWTS(NEAREST,LOOP) ) NEAREST =12
            NEWFLD(LOOP) = OLD(NEIGH( NEAREST,LOOP))
        ELSE
          IF( KSCHEME(LOOP).EQ.JP12PT ) THEN
            NEWFLD(LOOP) =
     X        OLD(NEIGH( 1,LOOP)) * PWTS( 1,LOOP) +
     X        OLD(NEIGH( 2,LOOP)) * PWTS( 2,LOOP) +
     X        OLD(NEIGH( 3,LOOP)) * PWTS( 3,LOOP) +
     X        OLD(NEIGH( 4,LOOP)) * PWTS( 4,LOOP) +
     X        OLD(NEIGH( 5,LOOP)) * PWTS( 5,LOOP) +
     X        OLD(NEIGH( 6,LOOP)) * PWTS( 6,LOOP) +
     X        OLD(NEIGH( 7,LOOP)) * PWTS( 7,LOOP) +
     X        OLD(NEIGH( 8,LOOP)) * PWTS( 8,LOOP) +
     X        OLD(NEIGH( 9,LOOP)) * PWTS( 9,LOOP) +
     X        OLD(NEIGH(10,LOOP)) * PWTS(10,LOOP) +
     X        OLD(NEIGH(11,LOOP)) * PWTS(11,LOOP) +
     X        OLD(NEIGH(12,LOOP)) * PWTS(12,LOOP)
C
          ELSE IF( KSCHEME(LOOP).EQ.JP4PT ) THEN
            NEWFLD(LOOP) =
     X        OLD(NEIGH( 1,LOOP)) * PWTS( 1,LOOP) +
     X        OLD(NEIGH( 2,LOOP)) * PWTS( 2,LOOP) +
     X        OLD(NEIGH( 3,LOOP)) * PWTS( 3,LOOP) +
     X        OLD(NEIGH( 4,LOOP)) * PWTS( 4,LOOP)
C
          ELSE
            DO NEXT = 1, 4
              IF( NEIGH(NEXT,LOOP).NE.0 )
     X          NEWFLD(LOOP) = OLD(NEIGH(NEXT,LOOP))
            ENDDO
C
          ENDIF
        ENDIF
      ENDDO
C
C     -----------------------------------------------------------------|
C     Section 9.  Return.
C     -----------------------------------------------------------------|
C
  900 CONTINUE
C
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE CREXS1( KBUFL,YBUFF,KSUP,KSEC0,KSEC1,KERR)
C
C**** *CREXS1*
C
C
C     PURPOSE.
C     --------
C          Expands section 1 of CREX message. Saves expanded information
C          in the array KSEC1.
C
C**   INTERFACE.
C     ----------
C
C          *CALL* *BUEXS1( KBUFL,YBUFF,KSUP,KSEC0,KSEC1,KERR)*
C
C          INPUT :
C               *KBUFL*   -  length of CREX message (words)
C               *YBUFF*   -  array containing CREX message
C          OUTPUT:
C               *KSUP*    -  Integer array of 9 words containing
C                            suplementary information
C                         -  KSUP( 1) -- IDIM1, dimension of KSEC1
C                         -  KSUP( 2) -- Reserved
C                         -  KSUP( 3) -- IDIM3, dimension of KSEC3
C                         -  KSUP( 4) -- Reserved
C                         -  KSUP( 5) -- M (number of elements in values
C                                           array, first index)
C                         -  KSUP( 6) -- N (number of subsets,second index
C                                           of values array)
C                         -  KSUP( 7) -- JVC (number of elements in CVAL array)
C                         -  KSUP( 8) -- total CREX message length in bytes
C                         -  KSUP( 9) -- IDIM0, dimension of KSEC0
C
C               *KSEC0*   -  array containing section 0 information
C                            KSEC0( 1)-- length of section 0 (bytes)
C                            KSEC0( 2)-- total length of CREX message (bytes)
C                            KSEC0( 3)-- CREX Edition number
C
C               *KSEC1*   -  Integer array of at least 40 words
C                            containing CREX section 1 information
C                            KSEC1( 1)-- Reserved
C                            KSEC1( 2)-- CREX Edition number
C                            KSEC1( 3)-- Reserved
C                            KSEC1( 4)-- Reserved
C                            KSEC1( 5)-- Reserved
C                            KSEC1( 6)-- CREX message type
C                            KSEC1( 7)-- Reserved
C                            KSEC1( 8)-- version number of local table used
C                            KSEC1( 9)-- Reserved
C                            KSEC1(10)-- Reserved
C                            KSEC1(11)-- Reserved
C                            KSEC1(12)-- Reserved
C                            KSEC1(13)-- Reserved
C                            KSEC1(14)-- CREX Master table
C                            KSEC1(15)-- version number of Master table used
C                            KSEC1(16) - KSEC1(40) -- Reserved
C
C
C                            Crex Edition 2
C
C               *KSEC1*   -  Integer array of at least 40 words
C                            containing CREX section 1 information
C                            KSEC1( 1)-- Reserved
C                            KSEC1( 2)-- CREX Edition number
C                            KSEC1( 3)-- Originating Centre ( oooo)
C                            KSEC1( 4)-- Update sequence number (uu)
C                            KSEC1( 5)-- Number of subsets (sss)
C                            KSEC1( 6)-- CREX data category (nnn)
C                            KSEC1( 7)-- International data sub-category (mmm)
C                            KSEC1( 8)-- version number of local table used
C                            KSEC1( 9)-- Year (yyyy)
C                            KSEC1(10)-- Month (mm)
C                            KSEC1(11)-- Day (dd)
C                            KSEC1(12)-- Hour (hh)
C                            KSEC1(13)-- Minute (mm)
C                            KSEC1(14)-- CREX Master table (tt)
C                            KSEC1(15)-- version number of Master table used (vv)
C                            KSEC1(16)-- Originating sub-centre (ppp)
C                            KSEC1(17)-- Bufr master table version number
C                            KSEC1(18)-- Bufr version number of local table used
C                            KSEC1(19) - KSEC1(40) -- Reserved
C
C               *KERR*    -  Return error code
C
C      METHOD.
C      -------
C
C           NONE.
C
C
C     EXTERNALS.
C     ----------
C
C
C     REFERENCE.
C     ----------
C
C          NONE.
C
C     AUTHOR.
C     -------
C
C          MILAN DRAGOSAVAC    *ECMWF*       07/01/2004.
C
C
C     MODIFICATIONS.
C     --------------
C
C          NONE.
C
C
      IMPLICIT LOGICAL(L,O,G), CHARACTER*8(C,H,Y)
C
C
      PARAMETER(JSUP =   9,JSEC0=   3,JSEC1= 40,JSEC2= 64 ,JSEC3=    4,
     1          JSEC4=   2,JELEM=40000,JSUBS=400,JCVAL=150 ,JBUFL=40000,
     2          JBPW =  32,JTAB =3000,JCTAB=120,JCTST=1800,JCTEXT= 200,
     3          JWORK=360000,JKEY=46)
C
C
      DIMENSION KSUP(JSUP),KSEC0(JSEC0),KSEC1(JSEC1)
      DIMENSION ISEC1(JSEC1)
C
      COMMON /CREXWORK/ NBPT,NGS,NVIND,NBPTSEC2,RVIND,EPS,NE,IEOLD,
     1                  NC07YYY
C
      COMMON/CREXTAB/ NCREXBR(JTAB),NCREXBS(JTAB)    , NCREXBDW(JTAB),
     1                NCREXDR(JTAB),NCREXDST(JTAB)   ,
     2                NCREXDL(JTAB),NCREXDSQ(JTAB*20),NCREXP(64,255)

C
C             NCREXBR     - table B,  table reference              array
C             NCREXBS     - table B,  scale                        array
C             NCREXBDW    - table B,  data width                   array
C             NCREXDR     - table D,  table reference              array
C             NCREXDST    - table D,  starting pointers            array
C             NCREXDL     - table D,  lengths                      array
C             NCREXDSQ    - table D,  list of sequence descriptors array
C
       COMMON/CREXTABC/ CREXNAME(JTAB),CREXUNIT(JTAB),CREXLST(JELEM)
C
C             CREXNAME      -  table B, ELEMENT NAME           array
C             CREXUNIT      -  table B, unit                   array
c
C
      COMMON /CREXEL/ NCREXTDLEN,NCREXTDLST(JELEM),NCREXTDEXL,
     1                NCREXTDEXP(JELEM)
c
      CHARACTER*6 CREXLST
      CHARACTER*64 CREXNAME 
      CHARACTER*24 CREXUNIT
      REAL*8 RVIND,EPS
c
      CHARACTER*(*) YBUFF
C
C     ------------------------------------------------------------------
C*          1.  EXPAND SECTION 1.
C               ------------------
 100  CONTINUE
C
      IF( KERR.NE.0 ) RETURN
C
      IF(YBUFF(NBPT:NBPT).NE.'T') THEN
         KERR=42
         CALL CREXERR(KERR)
         RETURN
      END IF
C
      NBPT=NBPT+1
      ITEMP=NBPT
      CALL NEXTSEC(KBUFL,YBUFF, ITEMP,NGS,KERR )
      IF(KERR.NE.0) THEN
         KERR=40 
         CALL CREXERR(KERR)
         RETURN
      END IF
C
      IF(ITEMP.GT.NGS) THEN
         KERR=43
         CALL CREXERR(KERR)
         RETURN
      END IF
C
C
C     Get Master table used tt
C
      CALL EXTGRP(KBUFL,YBUFF, NBPT,2,KSEC1(14),KERR )
      IF(KERR.NE.0) THEN
         KERR=44
         CALL CREXERR(KERR)
         RETURN
      END IF
C
C     Get CREX Edition number  ee
C
      CALL EXTGRP(KBUFL,YBUFF, NBPT,2,KSEC1(2),KERR)
      IF(KERR.NE.0) THEN
         KERR=45
         CALL CREXERR(KERR)
         RETURN
      END IF
      KSEC0(3)=KSEC1(2)
C
C     Get Version number of master table used  vv
C
      CALL EXTGRP(KBUFL,YBUFF, NBPT,2,KSEC1(15),KERR)
      IF(KERR.NE.0) THEN
         KERR=46
         CALL CREXERR(KERR)
         RETURN
      END IF
C
      IF(KSEC1(2).EQ.2 ) THEN
C
C        Bufr master table version number  bb
C
         CALL EXTGRP(KBUFL,YBUFF, NBPT,2,KSEC1(17),KERR)
         IF(KERR.NE.0) THEN
            KERR=46
            CALL CREXERR(KERR)
            RETURN
         END IF
C
C        Bufr version number of local table ww
C
         CALL EXTGRP(KBUFL,YBUFF, NBPT,2,KSEC1(18),KERR)
         IF(KERR.NE.0) THEN
            KERR=46
            CALL CREXERR(KERR)
            RETURN
         END IF

      END IF

      CALL NEXTSEP(KBUFL,YBUFF,NBPT,ITEMP,KERR)
      CALL NEXTPRT(KBUFL,YBUFF,NBPT,ITEMP,KERR )
      IF(KERR.NE.0) THEN
         print*,'nextprt: error ',ierr
         RETURN
      END IF
C
      IF(YBUFF(NBPT:NBPT).NE.'A') THEN
         print*,'CREX table A not found.'
         RETURN
      END IF
C
      NBPT=NBPT+1
C
C     Get CREX table A   nnn
C
      CALL EXTGRP(KBUFL,YBUFF, NBPT,3,KSEC1(6),KERR)
      IF(KERR.NE.0) THEN
         print*,'extgrp : error ',kerr
         RETURN
      END IF
      IF(KSEC1(2).eq.2) THEN
C
C        Get international sub-category mmm
C
         CALL EXTGRP(KBUFL,YBUFF, NBPT,3,KSEC1(7),KERR)
         IF(KERR.NE.0) THEN
            print*,'extgrp : error ',kerr
            RETURN
         END IF

         CALL NEXTSEP(KBUFL,YBUFF,NBPT,ITEMP,KERR)
         CALL NEXTPRT(KBUFL,YBUFF,NBPT,ITEMP,KERR )
         IF(KERR.NE.0) THEN
            print*,'nextprt: error ',ierr
            RETURN
         END IF
C
         IF(YBUFF(NBPT:NBPT).NE.'P') THEN
            print*,'CREX oiginating centre not found.'
            RETURN
         END IF
C
         NBPT=NBPT+1
C
C        Get originating centre  ooooo
C
         CALL EXTGRP(KBUFL,YBUFF, NBPT,5,KSEC1(3),KERR)
         IF(KERR.NE.0) THEN
            print*,'extgrp : error ',kerr
            RETURN
         END IF
C
C        Get originating sub-centre ppp
C
         CALL EXTGRP(KBUFL,YBUFF, NBPT,3,KSEC1(16),KERR)
         IF(KERR.NE.0) THEN
            print*,'extgrp : error ',kerr
            RETURN
         END IF

         CALL NEXTSEP(KBUFL,YBUFF,NBPT,ITEMP,KERR)
         CALL NEXTPRT(KBUFL,YBUFF,NBPT,ITEMP,KERR )
         IF(KERR.NE.0) THEN
            print*,'nextprt: error ',ierr
            RETURN
         END IF
C
         IF(YBUFF(NBPT:NBPT).NE.'U') THEN
            print*,'CREX update sequence number not found.'
            RETURN
         END IF
C
         NBPT=NBPT+1
C
C        Get update sequence number uu
C
         CALL EXTGRP(KBUFL,YBUFF, NBPT,2,KSEC1(4),KERR)
         IF(KERR.NE.0) THEN
            print*,'extgrp : error ',kerr
            RETURN
         END IF
C
         CALL NEXTSEP(KBUFL,YBUFF,NBPT,ITEMP,KERR)
         CALL NEXTPRT(KBUFL,YBUFF,NBPT,ITEMP,KERR )
         IF(KERR.NE.0) THEN
            print*,'nextprt: error ',ierr
            RETURN
         END IF
C
         IF(YBUFF(NBPT:NBPT).NE.'S') THEN
            print*,'CREX number of subsets not found.'
            RETURN
         END IF
C
         NBPT=NBPT+1
C          Get number of subsets
C
         CALL EXTGRP(KBUFL,YBUFF, NBPT,3,KSEC1(5),KERR)
         IF(KERR.NE.0) THEN
            print*,'extgrp : error ',kerr
            RETURN
         END IF
C
         CALL NEXTSEP(KBUFL,YBUFF,NBPT,ITEMP,KERR)
         CALL NEXTPRT(KBUFL,YBUFF,NBPT,ITEMP,KERR )
         IF(KERR.NE.0) THEN
            print*,'nextprt: error ',ierr
            RETURN
         END IF

         IF(YBUFF(NBPT:NBPT).NE.'Y') THEN
            print*,'CREX date not found.'
            RETURN
         END IF

C
         NBPT=NBPT+1
C
C        Get CREX date
C
         CALL EXTGRP(KBUFL,YBUFF, NBPT,4,KSEC1(9),KERR)
         IF(KERR.NE.0) THEN
            print*,'extgrp : error ',kerr
            RETURN
         END IF
         CALL EXTGRP(KBUFL,YBUFF, NBPT,2,KSEC1(10),KERR)
         IF(KERR.NE.0) THEN
            print*,'extgrp : error ',kerr
            RETURN
         END IF
C
         CALL EXTGRP(KBUFL,YBUFF, NBPT,2,KSEC1(11),KERR)
         IF(KERR.NE.0) THEN
            print*,'extgrp : error ',kerr
            RETURN
         END IF

         CALL NEXTSEP(KBUFL,YBUFF,NBPT,ITEMP,KERR)
         CALL NEXTPRT(KBUFL,YBUFF,NBPT,ITEMP,KERR )
         IF(KERR.NE.0) THEN
            print*,'nextprt: error ',ierr
            RETURN
         END IF
C
         IF(YBUFF(NBPT:NBPT).NE.'H') THEN
            print*,'CREX time not found.'
            RETURN
         END IF
C
         NBPT=NBPT+1
C
C        Get CREX time
C
         CALL EXTGRP(KBUFL,YBUFF, NBPT,2,KSEC1(12),KERR)
         IF(KERR.NE.0) THEN
            print*,'extgrp : error ',kerr
            RETURN
         END IF
         CALL EXTGRP(KBUFL,YBUFF, NBPT,2,KSEC1(13),KERR)
         IF(KERR.NE.0) THEN
            print*,'extgrp : error ',kerr
            RETURN
         END IF

C
      END IF
C
      KTDLEN=0
C
 200  CONTINUE
C
      CALL NEXTSEP(KBUFL,YBUFF,NBPT,ITEMP,KERR)
      CALL NEXTPRT(KBUFL,YBUFF,NBPT,ITEMP,KERR )
      IF(KERR.NE.0) THEN
         print*,'nextprt: error ',ierr
         RETURN
      END IF
C
      IF(NBPT.GE.ITEMP) GO TO 300
C
      IF(YBUFF(NBPT:NBPT).EQ.'E') THEN
         NE=1
         GO TO 200 
      END IF
      KTDLEN=KTDLEN+1
      CALL EXTGRPC(KBUFL,YBUFF, NBPT,6,CREXLST(KTDLEN),KERR)
      IF(KERR.NE.0) THEN
         print*,'extgrpc : error ',kerr
         RETURN
      END IF
C
      GO TO 200
C
 300  CONTINUE
C
      NCREXTDLEN=KTDLEN 
C     ------------------------------------------------------------------
C
      RETURN
      END

c Copyright 1981-2016 ECMWF.
c
c This software is licensed under the terms of the Apache Licence 
c Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
c
c In applying this licence, ECMWF does not waive the privileges and immunities 
c granted to it by virtue of its status as an intergovernmental organisation 
c nor does it submit to any jurisdiction.
c

      subroutine gpfa3(a,b,trigs,inc,jump,n,mm,lot,isign)
*     fortran version of *gpfa3* -
*     radix-3 section of self-sorting, in-place
*        generalized PFA
*
*-------------------------------------------------------------------
*
      dimension a(*), b(*), trigs(*)
      data sin60/0.866025403784437/
      data lvr/128/
*
*     ***************************************************************
*     *                                                             *
*     *  N.B. LVR = LENGTH OF VECTOR REGISTERS, SET TO 128 FOR C90. *
*     *  RESET TO 64 FOR OTHER CRAY MACHINES, OR TO ANY LARGE VALUE *
*     *  (GREATER THAN OR EQUAL TO LOT) FOR A SCALAR COMPUTER.      *
*     *                                                             *
*     ***************************************************************
*
      n3 = 3**mm
      inq = n/n3
      jstepx = (n3-n) * inc
      ninc = n * inc
      ink = inc * inq
      mu = mod(inq,3)
      if (isign.eq.-1) mu = 3-mu
      m = mm
      mh = (m+1)/2
      s = float(isign)
      c1 = sin60
      if (mu.eq.2) c1 = -c1
*
      nblox = 1 + (lot-1)/lvr
      left = lot
      s = float(isign)
      istart = 1
*
*  loop on blocks of lvr transforms
*  --------------------------------
      do 500 nb = 1 , nblox
*
      if (left.le.lvr) then
         nvex = left
      else if (left.lt.(2*lvr)) then
         nvex = left/2
         nvex = nvex + mod(nvex,2)
      else
         nvex = lvr
      endif
      left = left - nvex
*
      la = 1
*
*  loop on type I radix-3 passes
*  -----------------------------
      do 160 ipass = 1 , mh
      jstep = (n*inc) / (3*la)
      jstepl = jstep - ninc
*
*  k = 0 loop (no twiddle factors)
*  -------------------------------
      do 120 jjj = 0 , (n-1)*inc , 3*jstep
      ja = istart + jjj
*
*  "transverse" loop
*  -----------------
      do 115 nu = 1 , inq
      jb = ja + jstepl
      if (jb.lt.istart) jb = jb + ninc
      jc = jb + jstepl
      if (jc.lt.istart) jc = jc + ninc
      j = 0
*
*  loop across transforms
*  ----------------------
cdir$ ivdep, shortloop
      do 110 l = 1 , nvex
      t1 = a(jb+j) + a(jc+j)
      t2 = a(ja+j) - 0.5 * t1
      t3 = c1 * ( a(jb+j) - a(jc+j) )
      u1 = b(jb+j) + b(jc+j)
      u2 = b(ja+j) - 0.5 * u1
      u3 = c1 * ( b(jb+j) - b(jc+j) )
      a(ja+j) = a(ja+j) + t1
      b(ja+j) = b(ja+j) + u1
      a(jb+j) = t2 - u3
      b(jb+j) = u2 + t3
      a(jc+j) = t2 + u3
      b(jc+j) = u2 - t3
      j = j + jump
  110 continue
      ja = ja + jstepx
      if (ja.lt.istart) ja = ja + ninc
  115 continue
  120 continue
*
*  finished if n3 = 3
*  ------------------
      if (n3.eq.3) go to 490
      kk = 2 * la
*
*  loop on nonzero k
*  -----------------
      do 150 k = ink , jstep-ink , ink
      co1 = trigs(kk+1)
      si1 = s*trigs(kk+2)
      co2 = trigs(2*kk+1)
      si2 = s*trigs(2*kk+2)
*
*  loop along transform
*  --------------------
      do 140 jjj = k , (n-1)*inc , 3*jstep
      ja = istart + jjj
*
*  "transverse" loop
*  -----------------
      do 135 nu = 1 , inq
      jb = ja + jstepl
      if (jb.lt.istart) jb = jb + ninc
      jc = jb + jstepl
      if (jc.lt.istart) jc = jc + ninc
      j = 0
*
*  loop across transforms
*  ----------------------
cdir$ ivdep,shortloop
      do 130 l = 1 , nvex
      t1 = a(jb+j) + a(jc+j)
      t2 = a(ja+j) - 0.5 * t1
      t3 = c1 * ( a(jb+j) - a(jc+j) )
      u1 = b(jb+j) + b(jc+j)
      u2 = b(ja+j) - 0.5 * u1
      u3 = c1 * ( b(jb+j) - b(jc+j) )
      a(ja+j) = a(ja+j) + t1
      b(ja+j) = b(ja+j) + u1
      a(jb+j) = co1*(t2-u3) - si1*(u2+t3)
      b(jb+j) = si1*(t2-u3) + co1*(u2+t3)
      a(jc+j) = co2*(t2+u3) - si2*(u2-t3)
      b(jc+j) = si2*(t2+u3) + co2*(u2-t3)
      j = j + jump
  130 continue
*-----( end of loop across transforms )
      ja = ja + jstepx
      if (ja.lt.istart) ja = ja + ninc
  135 continue
  140 continue
*-----( end of loop along transforms )
      kk = kk + 2*la
  150 continue
*-----( end of loop on nonzero k )
      la = 3*la
  160 continue
*-----( end of loop on type I radix-3 passes)
*
*  loop on type II radix-3 passes
*  ------------------------------
  400 continue
*
      do 480 ipass = mh+1 , m
      jstep = (n*inc) / (3*la)
      jstepl = jstep - ninc
      laincl = la*ink - ninc
*
*  k=0 loop (no twiddle factors)
*  -----------------------------
      do 430 ll = 0 , (la-1)*ink , 3*jstep
*
      do 420 jjj = ll , (n-1)*inc , 3*la*ink
      ja = istart + jjj
*
*  "transverse" loop
*  -----------------
      do 415 nu = 1 , inq
      jb = ja + jstepl
      if (jb.lt.istart) jb = jb + ninc
      jc = jb + jstepl
      if (jc.lt.istart) jc = jc + ninc
      jd = ja + laincl
      if (jd.lt.istart) jd = jd + ninc
      je = jd + jstepl
      if (je.lt.istart) je = je + ninc
      jf = je + jstepl
      if (jf.lt.istart) jf = jf + ninc
      jg = jd + laincl
      if (jg.lt.istart) jg = jg + ninc
      jh = jg + jstepl
      if (jh.lt.istart) jh = jh + ninc
      ji = jh + jstepl
      if (ji.lt.istart) ji = ji + ninc
      j = 0
*
*  loop across transforms
*  ----------------------
cdir$ ivdep, shortloop
      do 410 l = 1 , nvex
      t1 = a(jb+j) + a(jc+j)
      t2 = a(ja+j) - 0.5 * t1
      t3 = c1 * ( a(jb+j) - a(jc+j) )
      a(jb+j) = a(jd+j)
      u1 = b(jb+j) + b(jc+j)
      u2 = b(ja+j) - 0.5 * u1
      u3 = c1 * ( b(jb+j) - b(jc+j) )
      b(jb+j) = b(jd+j)
      a(ja+j) = a(ja+j) + t1
      b(ja+j) = b(ja+j) + u1
      a(jd+j) = t2 - u3
      b(jd+j) = u2 + t3
      a(jc+j) = t2 + u3
      b(jc+j) = u2 - t3
*----------------------
      t1 = a(je+j) + a(jf+j)
      t2 = a(jb+j) - 0.5 * t1
      t3 = c1 * ( a(je+j) - a(jf+j) )
      a(jf+j) = a(jh+j)
      u1 = b(je+j) + b(jf+j)
      u2 = b(jb+j) - 0.5 * u1
      u3 = c1 * ( b(je+j) - b(jf+j) )
      b(jf+j) = b(jh+j)
      a(jb+j) = a(jb+j) + t1
      b(jb+j) = b(jb+j) + u1
      a(je+j) = t2 - u3
      b(je+j) = u2 + t3
      a(jh+j) = t2 + u3
      b(jh+j) = u2 - t3
*----------------------
      t1 = a(jf+j) + a(ji+j)
      t2 = a(jg+j) - 0.5 * t1
      t3 = c1 * ( a(jf+j) - a(ji+j) )
      t1 = a(jg+j) + t1
      a(jg+j) = a(jc+j)
      u1 = b(jf+j) + b(ji+j)
      u2 = b(jg+j) - 0.5 * u1
      u3 = c1 * ( b(jf+j) - b(ji+j) )
      u1 = b(jg+j) + u1
      b(jg+j) = b(jc+j)
      a(jc+j) = t1
      b(jc+j) = u1
      a(jf+j) = t2 - u3
      b(jf+j) = u2 + t3
      a(ji+j) = t2 + u3
      b(ji+j) = u2 - t3
      j = j + jump
  410 continue
*-----( end of loop across transforms )
      ja = ja + jstepx
      if (ja.lt.istart) ja = ja + ninc
  415 continue
  420 continue
  430 continue
*-----( end of double loop for k=0 )
*
*  finished if last pass
*  ---------------------
      if (ipass.eq.m) go to 490
*
      kk = 2*la
*
*     loop on nonzero k
*     -----------------
      do 470 k = ink , jstep-ink , ink
      co1 = trigs(kk+1)
      si1 = s*trigs(kk+2)
      co2 = trigs(2*kk+1)
      si2 = s*trigs(2*kk+2)
*
*  double loop along first transform in block
*  ------------------------------------------
      do 460 ll = k , (la-1)*ink , 3*jstep
*
      do 450 jjj = ll , (n-1)*inc , 3*la*ink
      ja = istart + jjj
*
*  "transverse" loop
*  -----------------
      do 445 nu = 1 , inq
      jb = ja + jstepl
      if (jb.lt.istart) jb = jb + ninc
      jc = jb + jstepl
      if (jc.lt.istart) jc = jc + ninc
      jd = ja + laincl
      if (jd.lt.istart) jd = jd + ninc
      je = jd + jstepl
      if (je.lt.istart) je = je + ninc
      jf = je + jstepl
      if (jf.lt.istart) jf = jf + ninc
      jg = jd + laincl
      if (jg.lt.istart) jg = jg + ninc
      jh = jg + jstepl
      if (jh.lt.istart) jh = jh + ninc
      ji = jh + jstepl
      if (ji.lt.istart) ji = ji + ninc
      j = 0
*
*  loop across transforms
*  ----------------------
cdir$ ivdep, shortloop
      do 440 l = 1 , nvex
      t1 = a(jb+j) + a(jc+j)
      t2 = a(ja+j) - 0.5 * t1
      t3 = c1 * ( a(jb+j) - a(jc+j) )
      a(jb+j) = a(jd+j)
      u1 = b(jb+j) + b(jc+j)
      u2 = b(ja+j) - 0.5 * u1
      u3 = c1 * ( b(jb+j) - b(jc+j) )
      b(jb+j) = b(jd+j)
      a(ja+j) = a(ja+j) + t1
      b(ja+j) = b(ja+j) + u1
      a(jd+j) = co1*(t2-u3) - si1*(u2+t3)
      b(jd+j) = si1*(t2-u3) + co1*(u2+t3)
      a(jc+j) = co2*(t2+u3) - si2*(u2-t3)
      b(jc+j) = si2*(t2+u3) + co2*(u2-t3)
*----------------------
      t1 = a(je+j) + a(jf+j)
      t2 = a(jb+j) - 0.5 * t1
      t3 = c1 * ( a(je+j) - a(jf+j) )
      a(jf+j) = a(jh+j)
      u1 = b(je+j) + b(jf+j)
      u2 = b(jb+j) - 0.5 * u1
      u3 = c1 * ( b(je+j) - b(jf+j) )
      b(jf+j) = b(jh+j)
      a(jb+j) = a(jb+j) + t1
      b(jb+j) = b(jb+j) + u1
      a(je+j) = co1*(t2-u3) - si1*(u2+t3)
      b(je+j) = si1*(t2-u3) + co1*(u2+t3)
      a(jh+j) = co2*(t2+u3) - si2*(u2-t3)
      b(jh+j) = si2*(t2+u3) + co2*(u2-t3)
*----------------------
      t1 = a(jf+j) + a(ji+j)
      t2 = a(jg+j) - 0.5 * t1
      t3 = c1 * ( a(jf+j) - a(ji+j) )
      t1 = a(jg+j) + t1
      a(jg+j) = a(jc+j)
      u1 = b(jf+j) + b(ji+j)
      u2 = b(jg+j) - 0.5 * u1
      u3 = c1 * ( b(jf+j) - b(ji+j) )
      u1 = b(jg+j) + u1
      b(jg+j) = b(jc+j)
      a(jc+j) = t1
      b(jc+j) = u1
      a(jf+j) = co1*(t2-u3) - si1*(u2+t3)
      b(jf+j) = si1*(t2-u3) + co1*(u2+t3)
      a(ji+j) = co2*(t2+u3) - si2*(u2-t3)
      b(ji+j) = si2*(t2+u3) + co2*(u2-t3)
      j = j + jump
  440 continue
*-----(end of loop across transforms)
      ja = ja + jstepx
      if (ja.lt.istart) ja = ja + ninc
  445 continue
  450 continue
  460 continue
*-----( end of double loop for this k )
      kk = kk + 2*la
  470 continue
*-----( end of loop over values of k )
      la = 3*la
  480 continue
*-----( end of loop on type II radix-3 passes )
*-----( nvex transforms completed)
  490 continue
      istart = istart + nvex * jump
  500 continue
*-----( end of loop on blocks of transforms )
*
      return
      end

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE GETCONF( )
C
C---->
C**** GETCONF
C
C     PURPOSE
C     _______
C
C     This routine looks for environment variable CONFIG_INTERP to
C     decide how to handle legendre coefficients.
C
C     INTERFACE
C     _________
C
C     CALL GETCONF( )
C
C     Input parameters
C     ________________
C
C     None.
C
C     Output parameters
C     ________________
C
C     Sets flags in common block JDCFLAGS (see nifld.common):
C
C       LFILEIO, LMEMORY, LSHARED, LON_FLY, LMAPPED
C
C
C     Common block usage
C     __________________
C
C     JDCNDBG, JDCFLAGS
C
C
C     Method
C     ______
C
C     Looks for environment variable CONFIG_INTERP to decide how to
C     handle legendre coefficients. The variable contains entries in
C     the format:
C
C       col 1
C         |
C         v
C         FILEIO   to read coefficents from a file one latitude at a time
C         MEMORY   to read all coefficents from a file into memory
C         SHARED   to read coefficents from a memory-mapped file
C         ON_FLY   to generate coefficents for each latitude 'on the fly'
C
C     Externals
C     _________
C
C     JDEBUG   - Checks environment variable to switch on/off debug
C     INTLOG   - Logs output messages
C     GETENV   - Get value of an environment variable
C
C
C     Reference
C     _________
C
C     None.
C
C
C     Comments
C     ________
C
C     None.
C
C
C     AUTHOR
C     ______
C
C     J.D.Chambers      ECMWF      Jan 2000
C
C
C     MODIFICATIONS
C     _____________
C
C     None.
C
C----<
C     _______________________________________________________
C
C*    Section 0. Definition of variables.
C     _______________________________________________________
C
      IMPLICIT NONE
#include "nifld.common"
#include "parim.h"
#include "jparams.h"
C
C     Parameters
C
C     Local variables
C
      CHARACTER*20 CONFIG
      INTEGER IBLANK
C
      LOGICAL LDEBUG
      SAVE LDEBUG
C
C     -----------------------------------------------------------------|
C*    Section 1.    Initialization.
C     -----------------------------------------------------------------|
C
  100 CONTINUE
C
      IF( LIFIRST ) THEN
C
        LIFIRST = .FALSE.
C
        CALL JDEBUG( )
        LDEBUG = NDBG.GT.0
C
C       Read the configuration information
C
        CALL GETENV('CONFIG_INTERP', CONFIG)
        IBLANK = INDEX(CONFIG, ' ')
        IF( IBLANK.GT.6 ) THEN
C
          IF( CONFIG(1:6).EQ.'FILEIO' ) LFILEIO = .TRUE.
          IF( CONFIG(1:6).EQ.'MEMORY' ) LMEMORY = .TRUE.
          IF( CONFIG(1:6).EQ.'SHARED' ) LSHARED = .TRUE.
          IF( CONFIG(1:6).EQ.'ON_FLY' ) LON_FLY = .TRUE.
          IF( CONFIG(1:6).EQ.'MAPPED' ) LMAPPED = .TRUE.
          IF( LDEBUG ) THEN
            CALL INTLOG(JP_DEBUG,
     X      'GETCONF: Legendre coefficents via: '//CONFIG(1:6),JPQUIET)
          ENDIF
        ELSE
#if defined IBM_POWER4
           IF( LDEBUG ) CALL INTLOG(JP_DEBUG,
     X      'GETCONF: Default legendre coeff handling: MAPPED',JPQUIET)
          LMAPPED = .TRUE.
#else
           IF( LDEBUG ) CALL INTLOG(JP_DEBUG,
     X      'GETCONF: Default legendre coeff handling: FILEIO',JPQUIET)
          LFILEIO = .TRUE.
#endif
        ENDIF
C
      ENDIF
C
C     -----------------------------------------------------------------|
C*    Section 9. Return to calling routine.
C     -----------------------------------------------------------------|
C
 900  CONTINUE
C
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE SET99(TRIGS,IFAX,N)
      DIMENSION TRIGS(N),IFAX(10),JFAX(10),LFAX(7)
C---->
C
C     SUBROUTINE 'SET99' - COMPUTES FACTORS OF N & TRIGONOMETRIC
C     FUNCTIONS REQUIRED BY FFT99 & FFT991
C
C----<
#include "jparams.h"
C
      DATA LFAX/6,8,5,4,3,2,1/
      IXXX=1
C
      DEL= (2.0*PPI)/FLOAT(N)
      NIL=0
      NHL=(N/2)-1
      DO 10 K=NIL,NHL
      ANGLE=FLOAT(K)*DEL
      TRIGS(2*K+1)=COS(ANGLE)
      TRIGS(2*K+2)=SIN(ANGLE)
   10 CONTINUE
C
C     FIND FACTORS OF N (8,6,5,4,3,2; ONLY ONE 8 ALLOWED)
C     LOOK FOR SIXES FIRST, STORE FACTORS IN DESCENDING ORDER
      NU=N
      IFAC=6
      K=0
      L=1
   20 CONTINUE
      IF (MOD(NU,IFAC).NE.0) GO TO 30
      K=K+1
      JFAX(K)=IFAC
      IF (IFAC.NE.8) GO TO 25
      IF (K.EQ.1) GO TO 25
      JFAX(1)=8
      JFAX(K)=6
   25 CONTINUE
      NU=NU/IFAC
      IF (NU.EQ.1) GO TO 50
      IF (IFAC.NE.8) GO TO 20
   30 CONTINUE
      L=L+1
      IFAC=LFAX(L)
      IF (IFAC.GT.1) GO TO 20
C
      WRITE(6,40) N
   40 FORMAT(4H1N =,I4,27H - CONTAINS ILLEGAL FACTORS)
      RETURN
C
C     NOW REVERSE ORDER OF FACTORS
   50 CONTINUE
      NFAX=K
      IFAX(1)=NFAX
      DO 60 I=1,NFAX
      IFAX(NFAX+2-I)=JFAX(I)
   60 CONTINUE
      IFAX(10)=N
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities
C granted to it by virtue of its status as an intergovernmental organisation
C nor does it submit to any jurisdiction.
C

      INTEGER FUNCTION LSM_RED( KGAUSS, KDATE, KBITS, HPATH )
C
C---->
C**** LSM_RED
C
C     PURPOSE
C     -------
C
C     Generates the land sea mask file pathname.
C
C
C     INTERFACE
C     ---------
C
C     IRET = LSM_RED( KGAUSS, KDATE, KBITS, HPATH )
C
C
C     Input
C     -----
C     KGAUSS - The gaussian number (80 or 160)
C     KDATE  - The data date in YYYYMMDD format.
C     KBITS  - Number of bits per land-sea mask value (eg 32 or 64)
C
C     Output
C     ------
C     HPATH  - The full file pathname (with gaussian number
C              number of bits and date).
C
C
C     Return value
C     ------------
C
C     Function returns the number of characters in the file pathname,
C     or zero if no match found.
C
C
C     Common block usage
C     ------------------
C
C     None
C
C
C     EXTERNALS
C     ---------
C
C     GETENV     - Standard routine to get environmental variable.
C     INDEX      - Intrinsic routine to find position of substring.
C     EMOSNUM    - Gives current EMOSLIB version number.
C
C
C     METHOD
C     ------
C     None
C
C
C     REFERENCE
C     ---------
C
C     None
C
C     COMMENTS
C     --------
C
C     None
C
C
C     AUTHOR
C     ------
C
C     J.D.Chambers      *ECMWF*      ??? 1996
C
C
C     MODIFICATIONS
C     -------------
C
C     J.D.Chambers      *ECMWF*      July 1998
C     Use dates in YYYYMMDD format to handle year 2000 etc.
C
C----<
C     _______________________________________________________
C
C*    Section 0. Definition of variables.
C     _______________________________________________________
C
      IMPLICIT NONE
C
C     Parameters
C
      INTEGER JPD160, JPD80
      PARAMETER (JPD160=6)
      PARAMETER (JPD80=2)
C
C     Function parameters
C
      INTEGER KGAUSS, KDATE, KBITS
      CHARACTER*(*) HPATH
C
C     Local variables
C
      INTEGER LOOP
C
C     External functions
C
      INTEGER DPATH_TABLES_INTERPOL
      EXTERNAL DPATH_TABLES_INTERPOL
C
C     Change dates for N160
C
      INTEGER DATE160(JPD160)
      DATA DATE160/
     X            19790930,
     X            19910917,
     X            19930804,
     X            19940302,
     X            19940823,
     X            19950404
     X           /
C
C     Change dates for N80
C
      INTEGER DATE80(JPD80)
      DATA DATE80/
     X            19790930,
     X            19790930
     X           /
C
      CHARACTER*256 YBASE
      INTEGER IBASELEN

      CHARACTER*50 PATH160(JPD160)
      CHARACTER*50 PATH80(JPD80)
C
C     Pathnames for N160
C
      DATA PATH160/
     X            '_19790930',
     X            '_19910917',
     X            '_19930804',
     X            '_19940302',
     X            '_19940823',
     X            '_19950404'
     X          /
C
C
C     Pathnames for N80
      DATA PATH80/
     X            '_19790930',
     X            '_19790930'
     X          /
C
      INTEGER INDEX
C
C     External functions
C
      INTEGER EMOSNUM
      EXTERNAL EMOSNUM
C
C***************************************************************
C     Section 1. Initialize and check input values.
C***************************************************************
C
  100 CONTINUE
C
      LSM_RED = 0
      HPATH = ' '
C
C     Only reduced N160 gaussian fields handled.
C
      IF( KGAUSS.NE.160 ) GOTO 900
C
C     Only 32 bit and 64 bit land-sea masks handled.
C
      IF( (KBITS.NE.32).AND.(KBITS.NE.64) ) GOTO 900
C
C     Check environment variable for path of land sea masks.
C     (no error is raised, since 0 is a possible resulting value)
C
      IBASELEN = DPATH_TABLES_INTERPOL(YBASE)
C
C***************************************************************
C     Section 2. Build pathnames.
C***************************************************************
C
  200 CONTINUE
C
C     Handle N160
C
      IF( KGAUSS.EQ.160 ) THEN
        DO 210 LOOP = 1, JPD160-1
          IF( (KDATE.GE.DATE160(LOOP) ) .AND.
     X         (KDATE.LT.DATE160(LOOP+1)) ) THEN
            HPATH(1:) = YBASE(1:IBASELEN) //
     X                  'r160_' // 'xx' // PATH160(LOOP)
            LSM_RED = INDEX(HPATH,' ')
            GOTO 900
          ENDIF
  210   CONTINUE
C
C       Dropthrough -> take latest.
C
        HPATH(1:) = YBASE(1:IBASELEN) //
     X              'r160_' // 'xx' // PATH160(JPD160)
        LSM_RED = INDEX(HPATH,' ')
C
C     Handle N80
C
      ELSE
        DO 220 LOOP = 1, JPD80-1
          IF( (KDATE.GE.DATE80(LOOP) ) .AND.
     X         (KDATE.LT.DATE80(LOOP+1)) ) THEN
            HPATH(1:) = YBASE(1:IBASELEN) //
     X                  'r80_' // 'xx' // PATH80(LOOP)
            LSM_RED = INDEX(HPATH,' ')
            GOTO 900
          ENDIF
  220   CONTINUE
C
C       Dropthrough -> take latest.
C
        HPATH(1:) = YBASE(1:IBASELEN) //
     X              'r80_' // 'xx' // PATH80(JPD80)
        LSM_RED = INDEX(HPATH,' ')
      ENDIF
C
C***************************************************************
C     Section 9. Return.
C***************************************************************
C
  900 CONTINUE
C
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE GRCHK4 (KSEC1,KSEC4,PSEC4,KRET)
C
C---->
C**** GRCHK4 - Check parameters for Section 4 of GRIB Code.
C
C     Purpose.
C     --------
C
C           Check parameters for Section 4 of GRIB code against
C           valid values for GRIB Edition 1.
C
C**   Interface.
C     ----------
C
C           CALL GRCHK4 (KSEC1,KSEC4,PSEC4,KRET)
C
C           Integer    K.
C           Real       P.
C           Logical    O.
C           Character  H.
C
C               Input Parameters.
C               -----------------
C
C               KSEC1      - Array containing integer parameters for
C                            section 1 of GRIB code.
C
C               KSEC4      - Array containing integer parameters for
C                            section 4 of GRIB code.
C
C               PSEC4      - Array containing real parameters for
C                            section 4 of GRIB code.
C
C               Output Parameters.
C               ------------------
C
C               KRET       - Return code.
C                            0   , No error encountered.
C                            1   , Error in GRIB Code parameter.
C
C     Method.
C     -------
C
C           Values checked against current code/flag tables
C           and against maximum or minimum permitted values.
C           They are also checked against the current status
C           of the implementation of GRIBEX.
C
C     Externals.
C     ----------
C
C           None.
C
C     Reference.
C     ----------
C
C           WMO Manual on Codes for GRIB Code.
C
C     Comments.
C     ---------
C
C           Routine contains Sections 0 to 2 and Section 9.
C
C     Author.
C     -------
C
C           J. Hennessy      ECMWF      18.06.91
C
C     Modifications.
C     --------------
C
C           J. Hennessy      ECMWF      01.10.91
C           Additional parameters KSEC1 and PSEC4 added.
C
C           J. Hennessy      ECMWF      17.07.92
C           Additional flag and matrix of values checks added.
C
C           J.D.Chambers     ECMWF      27.04.94
C           Allow complex packing for spherical harmonics
C
C           J. Clochard, Meteo France, for ECMWF - January 1998.
C           Take into account second-order packing for grid-point data.
C           Revised printouts.
C
C----<
C     ----------------------------------------------------------------
C*    Section 0 . Definition of variables. Data statements.
C     ----------------------------------------------------------------
C
C
      IMPLICIT NONE
C
#include "common/grprs.h"
C
      INTEGER KRET
      INTEGER KSEC1
      INTEGER KSEC4
C
      REAL    PSEC4
C
      DIMENSION KSEC1(*)
      DIMENSION KSEC4(*)
C
      DIMENSION PSEC4(*)
C
C     ----------------------------------------------------------------
C*    Section 1 . Set initial values.
C     ----------------------------------------------------------------
C
  100 CONTINUE
C
C     Reset return code.
      KRET = 0
C
C     ----------------------------------------------------------------
C*    Section 2 . Check values against code tables and extreme values.
C     ----------------------------------------------------------------
C
  200 CONTINUE
C
C*    Check number of values to be encoded.
      IF (KSEC4(1).EQ.0) THEN
        KRET = 1
        WRITE(GRPRSM,*)
     X    'GRCHK4: Invalid number of data values to be encoded'
     X    , KSEC4(1)
      ENDIF
C
C*    Check number of bits per data value.
      IF (KSEC4(2).LT.1.OR.KSEC4(2).GT.32) THEN
        KRET = 1
        WRITE(GRPRSM,*)
     X     'GRCHK4: Invalid number of bits for packed data values'
     X    , KSEC4(2)
      ENDIF
C
C*    Check on type of data (grid or spherical harmonics).
      IF ( KSEC4(3).NE.0 .AND. KSEC4(3).NE.128 ) THEN
        WRITE(GRPRSM,*) 'GRCHK4: Invalid type of data', KSEC4(3)
      ENDIF
C
C*    Check type of packing.
      IF ( KSEC4(4).NE.0 .AND. KSEC4(4).NE.64 ) THEN
        KRET = 1
        WRITE(GRPRSM,*) 'GRCHK4: Invalid type of packing', KSEC4(4)
      ENDIF
C
C*    Check data representation.
      IF (KSEC4(5).NE.0.AND.KSEC4(5).NE.32) THEN
        KRET = 1
        WRITE(GRPRSM,*) 'GRCHK4: Invalid data representation', KSEC4(5)
      ENDIF
C
C*    Check additional flag field.
      IF (KSEC4(6).NE.0.AND.KSEC4(6).NE.16) THEN
        KRET = 1
        WRITE(GRPRSM,*)
     X    'GRCHK4: Invalid additional flag field', KSEC4(6)
      ENDIF
C
C*    Check reserved field.
      IF (KSEC4(7).NE.0) THEN
        WRITE(GRPRSM,*)
     X    'GRCHK4: Reserved field not 0. May cause trouble'
        WRITE(GRPRSM,*) 'GRCHK4: in future releases of GRIBEX.'
      ENDIF
C
C*    Check number of values indicator.
      IF (KSEC4(8).NE.0.AND.KSEC4(8).NE.64) THEN
        KRET = 1
        WRITE(GRPRSM,*) 'GRCHK4: Invalid number of fields indicator'
     X    , KSEC4(8)
      ENDIF
C
C*    Check secondary bit maps indicator.
      IF (KSEC4(9).NE.0.AND.KSEC4(9).NE.32) THEN
        KRET = 1
        WRITE(GRPRSM,*) 'GRCHK4: Invalid secondary bit map indicator'
     X    , KSEC4(9)
      ENDIF
C
C*    Check value widths indicator.
      IF (KSEC4(6).EQ.16.AND.KSEC4(10).NE.0.AND.KSEC4(10).NE.16) THEN
        KRET = 1
        WRITE(GRPRSM,*) 'GRCHK4: Invalid value widths', KSEC4(10)
      ENDIF
C
C*    Tests specific to second-order packing.
C
      IF (KSEC4(3).EQ.0.AND.KSEC4(4).EQ.64) THEN
C
C*    Check constant width.
        IF (KSEC4(10).EQ.0.AND.(ABS(KSEC4(11)).GE.KSEC4(2))) THEN
          KRET = 1
          WRITE(GRPRSM,9011) KSEC4(11), KSEC4(2)-1
        ENDIF
C
C*    Check general extended 2nd-order packing indicator.
        IF (KSEC4(12).NE.0.AND.KSEC4(12).NE.8) THEN
          KRET = 1
          WRITE(GRPRSM,*)
     X     'GRCHK4: Invalid general extended 2n-order packing indicator'
     X      , KSEC4(12)
        ENDIF
C
C*    Check boustrophedonic ordering indicator.
        IF (KSEC4(13).NE.0.AND.KSEC4(13).NE.4) THEN
          KRET = 1
          WRITE(GRPRSM,*)
     X     'GRCHK4: Invalid boustrophedonic ordering indicator'
     X      , KSEC4(13)
        ENDIF
C
C*    Check spatial differencing indicator.
        IF (KSEC4(14).NE.0.AND.KSEC4(14).NE.2) THEN
          KRET = 1
          WRITE(GRPRSM,*)
     X    'GRCHK4: Invalid spatial differencing indicator'
     X      , KSEC4(14)
        ENDIF
C
      ENDIF
C
C     ----------------------------------------------------------------
C*    Section 9 . Return to calling routine.
C     ----------------------------------------------------------------
C
  900 CONTINUE
C
 9011 FORMAT (TR1,'GRCHK4 : Second-order packing with constant width ',
     C        'option:',/,TR10,'Constant width value',I3,
     C        ' not in range [-/+',I2,'(=KSEC4(2)-1)].')
C
      RETURN
C
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE GROUTPT()
C
C---->
C**** GROUTPT
C
C     Purpose.
C     --------
C     Changes diagnostic output stream if defined by environment variable.
C
C**   Interface.
C     ----------
C     CALL GROUTPT()
C
C
C     Input Parameters.
C     -----------------
C     None.
C
C
C     Output Parameters.
C     ------------------
C     None.
C
C
C     Method.
C     -------
C     Checks environment variable GRPRS_STREAM for output stream number
C     for printing (default is 6)
C
C
C     Externals.
C     ----------
C     Common block GRPRSCM.
C
C
C     Reference.
C     ----------
C     None.
C
C
C     Comments.
C     ---------
C     None.
C
C
C     Author.
C     -------
C
C     J.D.Chambers   ECMWF    June 2002
C
C----<
C     -----------------------------------------------------------------|
C*    Section 0. Definition of variables.
C     -----------------------------------------------------------------|
C
      IMPLICIT NONE
C
#include "common/grprs.h"
C
C
C     Local variables
C
      INTEGER IOFFSET
      CHARACTER*10 YNUMBER
C
C     -----------------------------------------------------------------|
C*    Section 1 .
C     -----------------------------------------------------------------|
C
  100 CONTINUE
C
C     See if output stream needs changing
C
      CALL GETENV('GRPRS_STREAM', YNUMBER)
      IOFFSET = INDEX( YNUMBER, ' ')
      IF( IOFFSET.GT.1 ) THEN
        IF( IOFFSET.EQ.2 ) THEN
          READ(YNUMBER,'(I1.1)') GRPRSM
        ELSE IF( IOFFSET.EQ.3 ) THEN
          READ(YNUMBER,'(I2.2)') GRPRSM
        ELSE
          WRITE(GRPRSM,*)
     X    'GROUTPT: Invalid value for GRPRS_STREAM: ' // YNUMBER
          GRPRSM = 6
        ENDIF
      ELSE
        GRPRSM = 6
      ENDIF
C
      IF( GRPRSM.LT.1 ) THEN
        WRITE(*,*) 'GROUTPT: Invalid number for GRPRS_STREAM: ', GRPRSM
        GRPRSM = 6
      ENDIF
C
C     -----------------------------------------------------------------|
C*    Section 9 . Format statements. Return to calling routine.
C     -----------------------------------------------------------------|
C
  900 CONTINUE
C
      RETURN
      END

C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE ECDEF13( HFUNC, KSEC1, KGRIB, KLENG, KNSPT, KBITS,
     X                    KPLEN, KPR, KRET)
C
C---->
C**** ECDEF13
C
C     Purpose.
C     --------
C
C     GRIB coding/decoding of ECMWF local use definition 13.
C
C**   Interface.
C     ----------
C
C     CALL ECDEF13( HFUNC, KSEC1, KGRIB, KLENG, KNSPT, KBITS, KPR, KRET)
C
C
C     Input Parameters.
C     -----------------
C
C     HFUNC      - Requested function.
C                  'C' to code data.
C                  'D' to decode data.
C
C     KSEC1      - Array containing Grib Section 1 data.
C
C     KGRIB      - Array containing Grib coded data.
C
C     KLENG      - Length (words) of KGRIB.
C
C     KNSPT      - Bit number after which insertion/extraction starts.
C
C     KBITS      - Number of bits in computer word.
C
C     KPLEN      - Pointer to field containing length of Section 1
C
C     KPR        - Debug print switch.
C                  0  , No printout.
C                  >0 , Debug printout.
C
C     KRET       - Response to error indicator.
C                  0        , Abort if error encountered.
C                  Non-zero , Return to calling routine
C                             even if error encountered.
C
C     Output Parameters.
C     ------------------
C
C     KSEC1      - Array containing Grib Section 1 data.(Updated)
C
C     KGRIB      - Array containing Grib coded data.(Updated)
C
C     KNSPT      - Number of bit after last one inserted/extracted.
C                  (Updated)
C
C     KRET       - Return code.
C                  0   , No error encountered.
C                  2   , Error reported by routine INXBIT.
C
C
C     Method.
C     -------
C
C     Input data packed/unpacked in accordance with ECMWF usage of
C     local part of section 1 of Grib code, definition 13.
C
C
C     Externals.
C     ----------
C
C     INXBIT  - insert/extract bits
C     ABORTX  - abort the program
C
C
C     Reference.
C     ----------
C
C     WMO Manual On Codes for Grib Code.
C
C
C     Comments.
C     ---------
C
#include "ecdef13.h"
C
C
C     Author.
C     -------
C
C     J.D.Chambers     ECMWF      April 1998
C
C
C     Modifications.
C     --------------
C
C     Add system and method numbers
C     J.D.Chambers     ECMWF      May 2000
C
C
C----<
C     ------------------------------------------------------------------
C*    Section 0 . Definition of variables. Data statements.
C     ------------------------------------------------------------------
C
      IMPLICIT NONE
C
#include "grprs.h"
C
C     Parameters
C
      CHARACTER*1   HFUNC
      INTEGER KSEC1, KGRIB, KLENG, KNSPT, KBITS, KPLEN, KPR, KRET
      DIMENSION KGRIB(*)
      DIMENSION KSEC1(*)
C
C     Local variables
C
      INTEGER IRET, IZERO, JLOP, LENS1, ND, NF, IFLAG
C
      LOGICAL LENCODE, LDECODE
C
C     ------------------------------------------------------------------
C*    Section 1 . Set initial values.
C     ------------------------------------------------------------------
C
  100 CONTINUE
C
      IRET = KRET
      LENCODE = ( HFUNC .EQ. 'C' )
      LDECODE = .NOT. LENCODE
C
C     ------------------------------------------------------------------
C*    Section 2 . Handle tube.
C     ------------------------------------------------------------------
C
  200 CONTINUE
C
C     Octet 50: As for MARS labelling (zero or ensemble forecast number)
C     Octet 51: As for MARS labelling (zero or total no. in ensembles)
C     Octet 52: Direction number
C     Octet 53: Frequency number
C     Octet 54: Total number of directions (Nd)
C     Octet 55: Total number of frequencies (Nf)
C     Six 8-bit fields.
C
      CALL INXBIT(KGRIB,KLENG,KNSPT,KSEC1(42),6,KBITS,8,HFUNC,KRET)
      IF (KRET.NE.0) THEN
        KRET = 2
        WRITE(GRPRSM,*) 'ECDEF13: Error reported by routine INXBIT:'
        IF( LENCODE ) THEN
          WRITE(GRPRSM,*) '      encoding section 1, elements 42 - 47.'
        ELSE
          WRITE(GRPRSM,*) '      decoding section 1, octets 50 - 55.'
        ENDIF
      ENDIF
C
      ND = KSEC1(46)
      NF = KSEC1(47)
C
C     Octets 56-59: Integer scaling factor applied to directions
C     Octets 60-63: Integer scaling factor applied to frequencies
C     Two 32-bit fields.
C
      CALL INXBIT(KGRIB,KLENG,KNSPT,KSEC1(48),2,KBITS,32,HFUNC,KRET)
      IF (KRET.NE.0) THEN
        KRET = 2
        WRITE(GRPRSM,*) 'ECDEF13: Error reported by routine INXBIT:'
        IF( LENCODE ) THEN
          WRITE(GRPRSM,*) '      encoding section 1, elements 48 - 49.'
        ELSE
          WRITE(GRPRSM,*) '      decoding section 1, octets 56 - 63.'
        ENDIF
      ENDIF
C
C     Octet 64: Flag to indicate whether or not system
C               and method number are present.
C                 0 = not present (old style product)
C                 1 = present
C
      IFLAG = 1
      CALL INXBIT(KGRIB,KLENG,KNSPT,IFLAG,1,KBITS,8,HFUNC,KRET)
      IF (KRET.NE.0) THEN
        KRET = 2
        WRITE(GRPRSM,*) 'ECDEF13: Error reported by routine INXBIT:'
        IF( LENCODE ) THEN
          WRITE(GRPRSM,*) '      encoding section 1, system/method flag'
        ELSE
          WRITE(GRPRSM,*) '      decoding section 1, octet 64'
        ENDIF
      ENDIF
C
C     If the flag is set (new style product)
C
      IF( IFLAG.EQ.1 ) THEN
C
C     Octets 65-66: System number
C     One 16-bit field.
C
        CALL INXBIT(KGRIB,KLENG,KNSPT,KSEC1(50+ND+NF),
     X              1,KBITS,16,HFUNC,KRET)
        IF (KRET.NE.0) THEN
          KRET = 2
          WRITE(GRPRSM,*) 'ECDEF13: Error reported by routine INXBIT:'
          IF( LENCODE ) THEN
            WRITE(GRPRSM,*) '      encoding section 1, system number'
          ELSE
            WRITE(GRPRSM,*) '      decoding section 1, octets 65 - 66'
          ENDIF
        ENDIF
C
C     Octets 67-68: Method number
C     One 16-bit field.
C
        CALL INXBIT(KGRIB,KLENG,KNSPT,KSEC1(51+ND+NF),
     X              1,KBITS,16,HFUNC,KRET)
        IF (KRET.NE.0) THEN
          KRET = 2
          WRITE(GRPRSM,*) 'ECDEF13: Error reported by routine INXBIT:'
          IF( LENCODE ) THEN
            WRITE(GRPRSM,*) '      encoding section 1, method number'
          ELSE
            WRITE(GRPRSM,*) '      decoding section 1, octets 67 - 68'
          ENDIF
        ENDIF
C
      ELSE
C
C       (Old style)
C       Octets 65-68: Spare (set to zero)
C       Four 8-bit fields.
C
        IF( LENCODE ) THEN
          DO JLOP = 65, 68
            IZERO = 0
            CALL INXBIT(KGRIB,KLENG,KNSPT,IZERO,1,KBITS,8,HFUNC,KRET)
            IF (KRET.NE.0) THEN
              KRET = 2
              WRITE(GRPRSM,*)
     X  'ECDEF13: Error reported by routine INXBIT:'
              WRITE(GRPRSM,*)
     X  '      encoding section 1, octets 69 - 100.'
            ENDIF
          ENDDO
        ELSE
          KNSPT = KNSPT + 4*8
        ENDIF
      ENDIF
C
C     Octets 69-100: Spare (set to zero)
C     Thirty-32 8-bit fields.
C
      IF( LENCODE ) THEN
        DO 210 JLOP = 69, 100
          IZERO = 0
          CALL INXBIT(KGRIB,KLENG,KNSPT,IZERO,1,KBITS,8,HFUNC,KRET)
          IF (KRET.NE.0) THEN
            KRET = 2
            WRITE(GRPRSM,*) 'ECDEF13: Error reported by routine INXBIT:'
            WRITE(GRPRSM,*) '      encoding section 1, octets 69 - 100.'
          ENDIF
  210   CONTINUE
      ELSE
        KNSPT = KNSPT + 32*8
      ENDIF
C
C     Octet 101 onwards: List of Nd scaled directions
C     Nd 32-bit fields.
C
      DO 220 JLOP = 50, (49+ND)
        CALL INXBIT(KGRIB,KLENG,KNSPT,KSEC1(JLOP),1,KBITS,32,HFUNC,KRET)
        IF (KRET.NE.0) THEN
          KRET = 2
          WRITE(GRPRSM,*) 'ECDEF13: Error reported by routine INXBIT:'
          IF( LENCODE ) THEN
            WRITE(GRPRSM,*)
     X  '      encoding section 1, elements 50 onwards'
          ELSE
            WRITE(GRPRSM,*)
     X  '      decoding section 1, octets 101 onwards.'
          ENDIF
        ENDIF
  220 CONTINUE
C
C     Octets 101+Nd*4 onwards: List of Nf scaled frequencies
C     Nf 32-bit fields.
C
      DO 230 JLOP = (50+ND), (49+ND+NF)
        CALL INXBIT(KGRIB,KLENG,KNSPT,KSEC1(JLOP),1,KBITS,32,HFUNC,KRET)
        IF (KRET.NE.0) THEN
          KRET = 2
          WRITE(GRPRSM,*) 'ECDEF13: Error reported by routine INXBIT:'
          IF( LENCODE ) THEN
            WRITE(GRPRSM,*)
     X  '      encoding section 1, element (50+Nd) etc.'
          ELSE
            WRITE(GRPRSM,*)
     X  '      decoding section 1, octets (101+Nd*4)->'
          ENDIF
        ENDIF
  230 CONTINUE
C
C
C     On encoding, record the length of section 1.
C
      IF( LENCODE ) THEN
        LENS1 = 100 + (ND*4) + (NF*4)
        CALL INXBIT(KGRIB,KLENG,KPLEN,LENS1, 1,KBITS,24,HFUNC,KRET)
        IF (KRET.NE.0) THEN
          KRET = 2
          WRITE(GRPRSM,*) 'ECDEF13: Error reported by routine INXBIT:'
          WRITE(GRPRSM,*) '         encoding length of section 1.'
        ENDIF
      ENDIF
C
C     ------------------------------------------------------------------
C*    Section 9 . Abort/return to calling routine. Format statements.
C     ------------------------------------------------------------------
C
  900 CONTINUE
C
      IF( KPR.GE.1 ) THEN
        WRITE(GRPRSM,*) 'ECDEF13: Section 9.'
        WRITE(GRPRSM,*) '        Output values set, KNSPT = ', KNSPT
      ENDIF
C
C     Abort if requested to do so when an error has been encountered.
C
      IF (IRET.EQ.0.AND.KRET.NE.0) THEN
        CALL ABORTX ('ECDEF13')
      ELSE
        RETURN
      ENDIF
C
      END

C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE GBYTES (S,D,ISKIP1,IBSIZ,ISKIP2,NBYTES,KWOFF)
C
C---->
C**** GBYTES - Extract a number of bit fields. Cray routine.
C
C S CONTAINS A BIT STRING OF INDEFINITE LENGTH. GBYTES WILL
C EXTRACT NBYTES BITSTRINGS, IBSIZ BITS LONG, AND STORE THEM
C RIGHT JUSTIFIED 0 FILL, INTO SUCCESSIVE WORDS OF D. THE
C SUCCESSIVE BITSTRINGS START AT BIT POSITIONS
C     ISKIP1+1+(IBYTE-1)*(IBSIZ+ISKIP2)
C IN THE BIT STRING S. I.E. SKIP ISKIP1 BITS AT THE START,
C AND ISKIP2 BITS BETWEEN THE EXTRACTED STRINGS.
C BIT ISKP+1 IN A STRING IS FOUND IN WORD IS=1+ISKIP/NBPW IN S,
C WHERE NBPW IS THE NUMBER OF BITS PER WORD. THE STARTING BIT
C IS FOUND BY SKIPPING MOD(ISKP,NBPW) BITS IN THAT WORD.
C KWOFF IS AN OPTIONAL 7TH PARAMETER, WHICH DEFAULTS TO 0
C IF PRESENT KWOFF BITS ARE TOTALLY IGNORED AT THE START OF A WORD
C THUS IF A PACKED CYBER BIT STRING IS TRANSFERRED TO THE
C CRAY, WITH EACH 60 BIT CYBER WORD PLACED AT THE RIGHT END OF
C A 64 BIT CRAY WORD, A BYTE SEQUENCE WHICH WAS ORIGINALLY
C LOCATED WITH START POINTS IN ARITHMETIC PROGRESSION ON THE
C CYBER, WILL NO LONGER HAVE THIS PROPERTY ON THE CRAY. BY
C USING THE ROUTINE WITH KWOFF=4, THE ELEMENTS OF THE BYTE
C SEQUENCE CAN BE EXTRACTED ON THE CRAY, USING THE SAME SKIPS
C AS WERE USED ON THE CYBER.
C
C----<
      PARAMETER(NBPW=64)
      DIMENSION S(2) , D(NBYTES)
      INTEGER SH1
      IGNORE = 0
#ifdef CRAY
      IF(NUMARG().GT.6) IGNORE = KWOFF
#else
      IF(NUMARG(DUMMY).GT.6) IGNORE = KWOFF
#endif
      IS=1+ISKIP1/(NBPW-IGNORE)
      ISKIP = MOD(ISKIP1,NBPW-IGNORE) + IGNORE
      ISTEP = ISKIP2+IBSIZ
      DO 75 IBYTE = 1 , NBYTES
C WITH THE STARTING WORD AND BIT POSITION DETERMINED, THE
C DESIRED EXTRACTION CAN BE DONE BY
C***     CALL GBYTE(S(IS),D(IBYTE),ISKIP,IBSIZ)
C BUT SINCE THE CODE IS SHORT IT IS INSERTED IN-LINE.
         SH1 = ISKIP+IBSIZ
         IF(SH1.GT.NBPW) GO TO 50
C BYTE COMES FROM 1 WORD OF S
         D(IBYTE) = AND( SHIFT(S(IS),SH1),SHIFT(MASK(IBSIZ),IBSIZ))
         GO TO 65
   50    CONTINUE
         SH1 =SH1-NBPW
C BYTE COMES FROM 2 WORDS OF S.
         D(IBYTE) = OR(SHIFT(AND(S(IS),COMPL(MASK(ISKIP))),SH1)
     1                           ,
     2                SHIFT(AND(SHIFT(S(IS+1),IGNORE),MASK(SH1)),SH1)
     3                 )
   65    CONTINUE
C UPDATE STARTING WORD AND BIT POSITION
         ISKIP = ISKIP+ISTEP
         IF(ISKIP.LT.NBPW) GO TO 75
         ISKIP =ISKIP-NBPW
         IS = IS+1+ISKIP/(NBPW-IGNORE)
         ISKIP = MOD(ISKIP,NBPW-IGNORE) + IGNORE
   75 CONTINUE
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      INTEGER FUNCTION IGPLSM (POFELD, KLEN, KPR, KERR)
C
C---->
C**** *IGPLSM*
C
C     PURPOSE
C     _______
C
C     Force an interpolated land sea mask field back to a real 0-1
C     field.
C
C     INTERFACE
C     _________
C
C     IERR = IGPLSM (POFELD, KLEN, KPR, KERR)
C
C     Input parameters
C     ________________
C
C     POFELD     - The output field as previously calculated.
C
C     KLEN       - The length of the output field.
C
C     KPR        - The debug print switch.
C                  0  , No debugging output.
C                  1  , Produce debugging output.
C
C     KERR       - The error control flag.
C                  -ve, No error message. Return error code.
C                  0  , Hard failure with error message.
C                  +ve, Print error message. Return error code.
C
C     Output parameters
C     ________________
C
C     POFELD     - The 0-1 land sea mask output field
C
C     Return value
C     ____________
C
C     The error indicator (INTEGER).
C
C     Error and Warning Return Values
C     _______________________________
C
C     None
C
C     Common block usage
C     __________________
C
C     None
C
C     EXTERNALS
C     _________
C
C     INTLOG(R)    - Logs messages.
C
C     METHOD
C     ______
C
C     The intrinsic routine ANINT is used to create a real array of
C     the nearest integer value to the interpolated field. An
C     additional check is that all values less than zero are forced
C     to zero and all values greater than one are forced to one.
C
C     REFERENCE
C     _________
C
C     None
C
C     COMMENTS
C     ________
C
C     Program contains sections 0 to 2 and 9
C
C     AUTHOR
C     ______
C
C     K. Fielding      *ECMWF*      Feb 1994
C
C     MODIFICATIONS
C     _____________
C
C     None
C
C----<
C     _______________________________________________________
C
C
C*    Section 0. Definition of variables.
C     _______________________________________________________
C
C*    Prefix conventions for variable names
C
C     Logical      L (but not LP), global or common.
C                  O, dummy argument
C                  G, local variable
C                  LP, parameter.
C     Character    C, global or common.
C                  H, dummy argument
C                  Y (but not YP), local variable
C                  YP, parameter.
C     Integer      M and N, global or common.
C                  K, dummy argument
C                  I, local variable
C                  J (but not JP), loop control
C                  JP, parameter.
C     REAL         A to F and Q to X, global or common.
C                  P (but not PP), dummy argument
C                  Z, local variable
C                  PP, parameter.
C
C     Implicit statement to force declarations
C
      IMPLICIT NONE
C
#include "parim.h"
C
C     Dummy arguments
      INTEGER KLEN, KPR, KERR
      REAL POFELD (KLEN)
C
C     Local variables
      INTEGER JLEN
      INTEGER JPROUTINE
      PARAMETER (JPROUTINE = 25700)
C
C     _______________________________________________________
C
C*    Section 1. Initialisation
C     _______________________________________________________
C
  100 CONTINUE
C
      IF (KPR.GE.1) CALL INTLOG(JP_DEBUG,'IGPLSM: Section 1.',JPQUIET)
C
      IGPLSM = 0
C
      IF (KPR .GE. 1)
     X  CALL INTLOG(JP_DEBUG,'IGPLSM: Total fld len = ',KLEN)
C
C
C     _______________________________________________________
C
C*    Section 2. Force land sea mask to nearest integer (0 or 1)
C     _______________________________________________________
C
  200 CONTINUE
C
      IF (KPR.GE.1) CALL INTLOG(JP_DEBUG,'IGPLSM: Section 2.',JPQUIET)
C
      DO 210 JLEN = 1, KLEN
C
         POFELD (JLEN) = ANINT (POFELD (JLEN) )
C
         IF (POFELD (JLEN) .LT. PPZERO) POFELD (JLEN) = PPZERO
         IF (POFELD (JLEN) .GT. PPONE) POFELD (JLEN) = PPONE
C
  210 CONTINUE
C
C     _______________________________________________________
C
C*    Section 9. Return to calling routine. Format statements
C     _______________________________________________________
C
  900 CONTINUE
C
      IF (KPR.GE.1) CALL INTLOG(JP_DEBUG,'IGPLSM: Section 9.',JPQUIET)
C
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE GRSMKP(KONOFF)
C
C---->
C**** GRSMKP - P factor calculation switch setting for routine GRIBEX.
C
C     Purpose.
C     --------
C
C     P factor calculation switch set on or off for routine GRIBEX.
C
C
C**   Interface.
C     ----------
C
C     CALL GRSMKP (KONOFF)
C
C
C     Input Parameter.
C     ----------------
C
C     KONOFF  - P factor calculation switch flag,
C               = 0 ,        user supplies the P factor (default)
C               = Non-zero , GRIBEX calculates the P factor.
C
C
C     Output Parameters.
C     ------------------
C
C     None.
C
C
C     Method.
C     -------
C
C     The variable NONOFF is set in the common area. All other
C     parameters are also set to default values, if they have
C     not already been set by the user.
C
C
C     Externals.
C     ----------
C
C     GRSDEF - Default setting of global variables.
C
C
C     Reference.
C     ----------
C
C     See subroutine GRIBEX.
C
C
C     Comments.
C     ---------
C
C     None.
C
C
C     Author.
C     -------
C
C     J.D.Chambers       ECMWF      6th Sept 1994
C
C
C     Modifications.
C     --------------
C
C     J.D.Chambers     ECMWF      13.09.94
C     Add NONOFF and NOABORT, use grbcom.h
C
C     J. Clochard, Meteo France, for ECMWF - January 1998.
C     Use GRSDEF routine for default setting.
C
C     J. Clochard, Meteo France, for ECMWF - June 1999.
C     Use a static variable to determine if initialisation of
C     default values has already been done for common area variables.
C
C
C----<
C     ----------------------------------------------------------------
C*    Section 0 . Definition of variables.
C     ----------------------------------------------------------------
C
      IMPLICIT NONE
C
#include "grbcom.h"
C
C     Subroutine arguments.
      INTEGER KONOFF
C
C     Local variables.
      INTEGER IONOFF
C
      LOGICAL LFIRST
      SAVE LFIRST
C
      DATA LFIRST / .TRUE. /
C
C     ----------------------------------------------------------------
C*    Section 1 . Set values.
C     ----------------------------------------------------------------
C
  100 CONTINUE
C
      IONOFF = 0
      IF (KONOFF.NE.0) IONOFF = 1
C
      IF (LFIRST) THEN
C
C       Common area variables may have not been set, so start by
C       trying to set default values.
C
        CALL GRSDEF
        LFIRST=.FALSE.
C
      ENDIF
C
C     Set P factor switch to required value
C
      NONOFF   = IONOFF
C
C     ----------------------------------------------------------------
C*    Section 9 . Return to calling routine.
C     ----------------------------------------------------------------
C
  900 CONTINUE
C
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE DSGNBT( KOUT, KIN, KPOS, KRET)
C---->
C
C     Get the sign bit in position KPOS of word KIN, and
C     set value of KOUT from the rest of bits (KPOS-1) ->
C     with the correct sign.
C
C     On return, KRET = 0 if all OK.
C
C----<
      IMPLICIT NONE
      INTEGER KOUT, KIN, KPOS, KRET

      INTEGER JPBITS
#ifdef INTEGER_8
      PARAMETER ( JPBITS = 64 )
#else
      PARAMETER ( JPBITS = 32 )
#endif
      INTEGER ISBIT, INSPT, IRETA, IRETB
#if defined (VAX) || defined (__alpha)
      INTEGER ITEMP, IMASK1,IMASK2
#endif
C
#if defined (VAX) || defined (__alpha)
C
C     VAX bit handling using VAX specific intrinsics
      ITEMP  = 1
      IMASK1 = JISHFT( ITEMP, (KPOS-1))
      ITEMP  = -1
      ITEMP  = JISHFT( ITEMP, (KPOS-1) )
      IMASK2 = JNOT( ITEMP )
      ISBIT  = JIAND( KIN, IMASK1)
      KOUT   = JIAND( KIN, IMASK2)
#else
C
C     Bit handling using INXBIT
      INSPT = 0
      CALL INXBIT( KIN, 1, INSPT, ISBIT, 1, JPBITS,
     X             (JPBITS-KPOS+1), 'D', IRETA)
      CALL INXBIT( KIN, 1, INSPT, KOUT, 1, JPBITS,
     X             (KPOS-1), 'D', IRETB)
      KRET = IRETA+IRETB
      IF ( KRET .NE. 0 ) THEN
        WRITE(*,*) ' DSGNBT - Problem unpacking bits in value'
        GOTO 900
      ENDIF
#endif

      IF ( ISBIT .NE. 0 ) KOUT = -KOUT

  900 CONTINUE

      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE BUSET(KPMISS,KPRUS,KOKEY,KOFL,K1,K2,K3,K4)
C
C**** *BUSET*
C
C
C     PURPOSE.
C     --------
C            SETS VARIABLE KPMISS,KPRUS,KOKEY,KOFL INTO COMMON BLOCK.
C
C**   INTERFACE.
C     ----------
C
C          *CALL* *BUSET(KPMISS,KPRUS,KOKEY,KOFL,K1,K2,K3,K4)*
C
C        INPUT :
C               *KPMISS*   -  INTEGER VARIABLE
C                            0 - DEFAULT, PAKS MAX VALUE FOR DATA WIDTH -1 BITS.
C
C                            1 - PAKS VALUE AS MISSING VALUE
C               *KPRUS*   -   AN INTEGER
C                            1 - ALWAYS RECALCULATE POINTERS
C               *KOKEY*    - 0 - DEFAULT, PACKS ECMWF RDB KEY
C                            1 - PACKS SECTION 2 IF NEEDED BUT NOT LENGTH
C                                OF BUFR MESSAGE IN KEY
C               *KOFL*    -  0 - NO CHECK ON VALUES
C                            1 - CHECK ON VALUES
C
C
C     METHOD.
C     -------
C
C           DURING PACKING THE VALUE TO BE PACKED CAN HAPPEN TO BE TOO BIG
C           TO FIT INTO CORRESPONDING DATA WIDTH. THIS SUBROUTINE  ALLOWS USER
C           TO CHOSE BETWEEN:
C
C            1)  PACK BIG VALUE AS MAX VALUE REPRESENTED WITH DATA WIDTH -1
C                BITS (DEFAULT)
C            2)  PACK BIG VALUE AS MISSING VALUE
C
C     EXTERNALS.
C     ----------
C
C          NONE
C
C
C     REFERENCE.
C     ----------
C
C          NONE.
C
C     AUTHOR.
C     -------
C
C          M. DRAGOSAVAC    *ECMWF*       15/01/95.
C
C
C     MODIFICATIONS.
C     --------------
C
C          NONE.
C
C
      IMPLICIT LOGICAL(L,O,G), CHARACTER*8(C,H,Y)
C
#     include "bcprq.F"
C
C     ------------------------------------------------------------------
C
C*          1.   SET CONSTANTS.
C                --------------
 100  CONTINUE
C
      IF(KPMISS.LT.0.AND.KPMISS.GT.1) KPMISS=0
      IF(KPRUS.LT.0.AND.KPRUS.GT.1)   KPRUS=0
      IF(KOKEY.LT.0.AND.KOKEY.GT.1)   NOKEY=0
      IF(KOFL.LT.0.AND.KOFL.GT.1)   NOFL=0
      NPMISS=KPMISS
      NPRUS=KPRUS
      NOKEY=KOKEY
      NOFL=KOFL
C
      RETURN
      END

SUBROUTINE CONSINT (KLAT_IN, KLON_IN, PLAT_IN, KIN,&
                         & KLAT_OUT,KLON_OUT,PLAT_OUT,KOUT,&
                         & PFLD_IN, PFLD_OUT, &
                         & LDPAR)

!    Purpose.
!    --------
!      Conserving bicubic interpolation of grid field from model 
!      resolution to grid defined by input parameter. Assumes the 
!      whole field is in memory.

!    Explicit arguments:
!    -------------------

!    Input:
!      KLAT_IN  - number of latitude rows of the input grid
!      KLON_IN  - number of longitudes for each row of the input grid
!      PLAT_IN  - latitude (degrees) of each row of the input grid
!      KIN      - size of input array
!      KLAT_OUT - number of latitude rows of the output grid
!      KLON_OUT - number of longitudes for each row of the output grid
!      PLAT_OUT - latitude (degrees) of each row of the output grid
!      KOUT     - size of output array
!      PFLD_IN  - array of grid values at input resolution

!    Output:
!      PFLD_OUT - array of interpolated values

!    Optional:
!      LDPAR    - parity for extra-polar calculations
!                 .TRUE. for scalar fields
!                 .FASE. for vector fields

!    Author.
!    -------
!      E. Holm - modification of GRID_BICUBIC by Y.Tremolet

!    Modifications.
!    --------------
!      Original: 27/05/04
!      20050507 Elias Holm: Introduce order and limiter in call and
!                           generalize code for up to quintic interpolation
!        Y.Tremolet    26-Jan-2005 Added optional arguments
!      20080204 Elias Holm: Surface pressure on input/output and
!                           simplified
!      20081015 Elias Holm: Simplify and reorder calculations for speed
!      20101230 Elias Holm: Simplified version without pressure thickness 
!                           weighting
!      20110125 Elias Holm: Latitude inputs in degrees
!     ------------------------------------------------------------------

IMPLICIT NONE

INTEGER,INTENT(IN)    :: KLAT_IN 
INTEGER,INTENT(IN)    :: KLON_IN(KLAT_IN) 
REAL   ,INTENT(IN)    :: PLAT_IN(KLAT_IN) 
INTEGER,INTENT(IN)    :: KIN 
INTEGER,INTENT(IN)    :: KLAT_OUT 
INTEGER,INTENT(IN)    :: KLON_OUT(KLAT_OUT) 
REAL   ,INTENT(IN)    :: PLAT_OUT(KLAT_OUT) 
INTEGER,INTENT(IN)    :: KOUT 
REAL   ,INTENT(IN)    :: PFLD_IN(KIN)
REAL   ,INTENT(OUT)   :: PFLD_OUT(KOUT) 
LOGICAL, OPTIONAL, INTENT(IN)    :: LDPAR

INTEGER :: IND_IN  (KLAT_IN)
INTEGER :: ILON_IN (-2:KLAT_IN+3)
REAL    :: ZLAT_IN (-2:KLAT_IN+3)
REAL    :: ZLON_IN (-2:KLAT_IN+3)
REAL    :: ZDLAT_IN(-2:KLAT_IN+3), ZDLATI_IN(-2:KLAT_IN+3)
REAL    :: ZDLON_IN(-2:KLAT_IN+3), ZDLONI_IN(-2:KLAT_IN+3)
REAL    :: ZHLAT_IN(-2:KLAT_IN+3)
REAL    :: ZHLON_IN(-2:KLAT_IN+3)
REAL    :: ZDHLAT_IN(-2:KLAT_IN+3), ZDHLATI_IN(-2:KLAT_IN+3)
REAL    :: ZG_IN   (-2:KLAT_IN+3)
INTEGER :: ILAT_IO  (0:KLAT_OUT)
REAL    :: ZLAT_OUT (0:KLAT_OUT), ZLON_OUT (1:KLAT_OUT)
REAL    :: ZDLAT_OUT(1:KLAT_OUT), ZDLON_OUT(1:KLAT_OUT)
REAL    :: ZHLAT_OUT(1:KLAT_OUT), ZHLON_OUT(1:KLAT_OUT)
REAL    :: ZG_OUT   (1:KLAT_OUT)

INTEGER :: J, JLAT, JLON, JNUM, JINX, JINY, JINYD, JOUTY,IRET
INTEGER :: JXMAX_IN, JXMAX_OUT, JYMAX_OUT, IBL
INTEGER :: JBL, IBL_OUT, JINYSTA, JINYEND, IBLATSTA_OUT(1:KLAT_OUT)
INTEGER :: IBLATEND_OUT(1:KLAT_OUT), IBLON_OUT(1:KLAT_OUT)
REAL    :: ZSUM, ZOUT, ZX, ZY, ZY2, ZDHI
REAL    :: ZC(0:3), ZDC, ZDL, ZDLL, ZDR, ZDRR, ZCC2, ZCC3
REAL    :: ZMINMOD, ZFRAC, ZCURVLIM, ZLIML, ZLIMR, ZLIM
REAL    :: ZPARITY, ZPRIMADD
REAL, ALLOCATABLE :: ZPRIMX(:,:), ZPRIMY(:,:), ZPRIM(:,:), ZFLD_IN(:)
REAL, ALLOCATABLE :: ZDIFX(:,:), ZDIFY(:,:), ZOUTPRE(:)

REAL    :: RPI, RD2R

!     ------------------------------------------------------------------
ZMINMOD(ZDC)=(0.5+SIGN(0.5,ZDC))*MIN(1.,ABS(ZDC))
ZFRAC(ZDC,ZDR)=ZDC/SIGN(ABS(ZDR)+1.E-30,ZDR)
ZCURVLIM(ZDL,ZDR)=SIGN(MIN(ABS(ZDL),ABS(ZDR)/3.),ZDL)


!     *    0. CONSTANTS AND FUNCTIONS

RPI=ACOS(-1.)
RD2R=RPI/180.
ZCC2=1.0/1536.
ZCC3=1.0/15360.

ZPARITY=1.0
IF (PRESENT(LDPAR)) THEN
  IF (.NOT.LDPAR) ZPARITY=-1.0
ENDIF

ALLOCATE(ZFLD_IN(KIN))
DO J=1,KIN
  ZFLD_IN(J)=PFLD_IN(J)
ENDDO

!     *    1. INPUT GRID AND FIELD

!*         1.1 Geometry of input grid
!              Assuming lat_(j+.5) = 0.5*(lat_(j) + lat_(j+1))

ZLAT_IN(0)      = SIGN(RPI/2.,RD2R*PLAT_IN(1))
ZLAT_IN(KLAT_IN)= SIGN(RPI/2.,RD2R*PLAT_IN(KLAT_IN))
JNUM=1
JXMAX_IN=0
DO JLAT=1,KLAT_IN
  IF (JLAT<KLAT_IN) ZLAT_IN(JLAT)=RD2R*0.5*(PLAT_IN(JLAT)+PLAT_IN(JLAT+1))
  ZDLAT_IN(JLAT)=ABS(ZLAT_IN(JLAT-1)-ZLAT_IN(JLAT))
  ILON_IN(JLAT)=KLON_IN(JLAT)
  ZDLON_IN(JLAT)=2.*RPI/ILON_IN(JLAT)
  IND_IN(JLAT)=JNUM
  JNUM=JNUM+ILON_IN(JLAT)
  JXMAX_IN=MAX(JXMAX_IN,ILON_IN(JLAT))
!              Starting longitude (must be less or equal to zero)
  ZLON_IN(JLAT)=-ZDLON_IN(JLAT)/2.
!              Scale factors
  ZHLON_IN(JLAT) = (SIN(ZLAT_IN(JLAT-1))-SIN(ZLAT_IN(JLAT)))/ZDLAT_IN(JLAT)
  ZHLAT_IN(JLAT) = 1.
  ZG_IN(JLAT)=ZHLON_IN(JLAT)*ZHLAT_IN(JLAT)*ZDLON_IN(JLAT)*ZDLAT_IN(JLAT)
ENDDO

!          1.1.1 Extension over poles
! Starting longitude for extension over the poles for even ILON_IN is 0.,
! and for odd ILON_IN shift by half a gridcell to -RPI/ILON_IN.

DO JINY = 1, 3
  ILON_IN (1-JINY)       = ILON_IN (JINY)
  ZDLAT_IN(1-JINY)       = ZDLAT_IN(JINY)
  ZDLON_IN(1-JINY)       = ZDLON_IN(JINY)
  ZHLAT_IN(1-JINY)       = ZHLAT_IN(JINY)
  ZHLON_IN(1-JINY)       = ZHLON_IN(JINY)
  ZG_IN   (1-JINY)       = ZG_IN   (JINY)
  ZLAT_IN (1-JINY)       = 2.*ZLAT_IN(0)-ZLAT_IN(JINY-1)
  ZLON_IN(1-JINY)        = ZLON_IN(JINY)&
                          &+MOD(ILON_IN(1-JINY),2)*RPI/ILON_IN(1-JINY)
  ILON_IN (KLAT_IN+JINY) = ILON_IN (KLAT_IN+1-JINY)
  ZDLAT_IN(KLAT_IN+JINY) = ZDLAT_IN(KLAT_IN+1-JINY)
  ZDLON_IN(KLAT_IN+JINY) = ZDLON_IN(KLAT_IN+1-JINY)
  ZHLAT_IN(KLAT_IN+JINY) = ZHLAT_IN(KLAT_IN+1-JINY)
  ZHLON_IN(KLAT_IN+JINY) = ZHLON_IN(KLAT_IN+1-JINY)
  ZG_IN   (KLAT_IN+JINY) = ZG_IN   (KLAT_IN+1-JINY)
  ZLAT_IN (KLAT_IN+JINY) = 2.*ZLAT_IN(KLAT_IN)-ZLAT_IN(KLAT_IN-JINY)
  ZLON_IN (KLAT_IN+JINY) = ZLON_IN (KLAT_IN+1-JINY)&
                          &+MOD(ILON_IN(KLAT_IN+JINY),2)*RPI/ILON_IN(KLAT_IN+JINY)
ENDDO

!              1.1.2 Inverses
ZDLONI_IN(:)=1./ZDLON_IN(:)
ZDLATI_IN(:)=1./ZDLAT_IN(:)
ZDHLAT_IN(:)=ZDLAT_IN(:)*ZHLAT_IN(:)
ZDHLATI_IN(:)=1./ZDHLAT_IN(:)

!*         1.2 Primitive function of input field with respect to longitude
!              Valid at grid-cell longitude boundaries.
!              Make an extension zone of +/-3 grid-cells for interpolation.
!              The extension over the poles shifts fields by RPI.

!          1.2.1 Primitive function
ALLOCATE(ZPRIMX(-2:JXMAX_IN+3,-2:KLAT_IN+3))
ALLOCATE(ZDIFX (-2:JXMAX_IN+2,-2:KLAT_IN+3))

DO JLAT=1,KLAT_IN
  ZSUM=0.
  DO JLON=1,ILON_IN(JLAT)
    ZSUM=ZSUM+ZFLD_IN(IND_IN(JLAT)-1+JLON)*ZG_IN(JLAT)
    ZPRIMX(JLON,JLAT)=ZSUM
  ENDDO
ENDDO

!          1.2.2 The extension over the poles shifts fields by RPI.

DO JINY = 1, 3
  ZSUM=0.
  DO JLON=1,ILON_IN(1-JINY)
    JINX = 1 + MOD( ILON_IN(1-JINY)/2 + JLON - 1, ILON_IN(1-JINY) )
    ZSUM=ZSUM+ZPARITY*ZFLD_IN(IND_IN(JINY)-1+JINX)*ZG_IN(1-JINY)
    ZPRIMX(JLON,1-JINY) = ZSUM
  ENDDO
  ZSUM=0.
  DO JLON=1,ILON_IN(KLAT_IN+JINY)
    JINX = 1+MOD( ILON_IN(KLAT_IN+JINY)/2 + JLON - 1, ILON_IN(KLAT_IN+JINY) )
    ZSUM=ZSUM+ZPARITY*ZFLD_IN(IND_IN(KLAT_IN+1-JINY)-1+JINX)*ZG_IN(KLAT_IN+JINY)
    ZPRIMX(JLON,KLAT_IN+JINY) = ZSUM
  ENDDO
ENDDO

!          1.2.3 Extension in x-direction

DO JINX = 1, 3
  DO JLAT=-2,KLAT_IN+3
    ZPRIMX(1-JINX            ,JLAT) =-ZPRIMX(ILON_IN(JLAT),JLAT)&
                                    &+ZPRIMX(ILON_IN(JLAT)+1-JINX,JLAT)
    ZPRIMX(ILON_IN(JLAT)+JINX,JLAT) = ZPRIMX(ILON_IN(JLAT),JLAT)&
                                    &+ZPRIMX(JINX,JLAT)
  ENDDO
ENDDO

!              1.2.5 Difference of primitive function

DO JLAT=-2,KLAT_IN+3
  DO JLON=-2,ILON_IN(JLAT)+2
    ZDIFX(JLON,JLAT)=ZPRIMX(JLON+1,JLAT)-ZPRIMX(JLON,JLAT)
  ENDDO
ENDDO



!     *    2. OUTPUT GRID AND FIELD

!*         2.1 Geometry of output grid
!              Output grid can be finer or coarser than input grid.
!              Therefore dimensioning [KLAT_IN/KLAT_OUT]+4+1
!              to allow for 4th order interpolation of primitive
!              function wrt latitude at top and bottom of grid-cell
!              boundaries (output latitudes).

!          2.1.1 Grid blocks with constant longitude spacing

IBL_OUT = 1
IBLATSTA_OUT(1) = 1
IBLON_OUT(1) = KLON_OUT(1)
DO JLAT=2,KLAT_OUT
  IF((KLON_OUT(JLAT)/=KLON_OUT(JLAT-1)) .OR. (JLAT == KLAT_OUT/2))THEN
    IBL_OUT = IBL_OUT + 1
    IBLATEND_OUT(IBL_OUT-1) = JLAT-1
    IBLATSTA_OUT(IBL_OUT) = JLAT
    IBLON_OUT(IBL_OUT) = KLON_OUT(JLAT)
  ENDIF
ENDDO
IBLATEND_OUT(IBL_OUT)=KLAT_OUT

!          2.1.2 Latitudes and scale factors

ZLAT_OUT(0)       = SIGN(RPI/2.,RD2R*PLAT_OUT(1))
ZLAT_OUT(KLAT_OUT)= SIGN(RPI/2.,RD2R*PLAT_OUT(KLAT_OUT))
DO JLAT=1,KLAT_OUT
  IF (JLAT<KLAT_OUT) ZLAT_OUT(JLAT)=RD2R*0.5*(PLAT_OUT(JLAT)+PLAT_OUT(JLAT+1))
  ZDLAT_OUT(JLAT)=ABS(ZLAT_OUT(JLAT-1)-ZLAT_OUT(JLAT))
  ZDLON_OUT(JLAT)=2.*RPI/KLON_OUT(JLAT)
!              Starting longitude (must be less or equal to zero)
  ZLON_OUT(JLAT)=-ZDLON_OUT(JLAT)/2.
!              Scale factors
  ZHLON_OUT(JLAT) = ABS(SIN(ZLAT_OUT(JLAT-1))-SIN(ZLAT_OUT(JLAT)))/ZDLAT_OUT(JLAT)
  ZHLAT_OUT(JLAT) = 1.
  ZG_OUT(JLAT) = ZHLON_OUT(JLAT)*ZHLAT_OUT(JLAT)*ZDLON_OUT(JLAT)*ZDLAT_OUT(JLAT)
ENDDO

!          2.1.3 Closest input row above each output row

ILAT_IO(0)=0
DO JLAT=1,KLAT_OUT
  ILAT_IO(JLAT)=ILAT_IO(JLAT-1)
  DO WHILE (ZLAT_IN(ILAT_IO(JLAT)) > ZLAT_OUT(JLAT))
    ILAT_IO(JLAT)=ILAT_IO(JLAT)+1
  ENDDO
  ILAT_IO(JLAT)=ILAT_IO(JLAT)-1
ENDDO
JXMAX_OUT=0
JYMAX_OUT=0
DO JBL=1, IBL_OUT
  JXMAX_OUT = MAX(JXMAX_OUT,IBLON_OUT(JBL))
  JYMAX_OUT = MAX(JYMAX_OUT,IBLATEND_OUT(JBL)-IBLATSTA_OUT(JBL)+1)
ENDDO

  
!*         2.2 Interpolation of primitive function

JNUM=0
ALLOCATE(ZPRIM(0:JXMAX_OUT,-3:3+KLAT_IN))
ALLOCATE(ZDIFY(1:JXMAX_OUT,-3:3+KLAT_IN))
ALLOCATE(ZPRIMY(0:JXMAX_OUT,0:JYMAX_OUT))
ALLOCATE(ZOUTPRE(0:JXMAX_OUT))
DO JBL=1, IBL_OUT

!          2.2.1 Interpolate PF of input field with respect to longitude
!                to output grid-cell longitude boundaries.
!                (output longitude / input latitude)

  JINYSTA=ILAT_IO(IBLATSTA_OUT(JBL)-1)
  JINYEND=ILAT_IO(IBLATEND_OUT(JBL))
  JINYD=JINYEND-JINYSTA
  DO JLON=0,IBLON_OUT(JBL)
    ZPRIM(JLON,-3)=0.
    ZOUTPRE(JLON)=ZLON_OUT(IBLATSTA_OUT(JBL))+JLON*ZDLON_OUT(IBLATSTA_OUT(JBL))
  ENDDO
  DO JINY=JINYSTA-2,JINYEND+3
    DO JLON=0,IBLON_OUT(JBL)
      ZOUT =  ZOUTPRE(JLON)-ZLON_IN(JINY)
      ZPRIMADD=0.
      IF (ZOUT<0.) THEN
        ZOUT    = ZOUT+ILON_IN(JINY)*ZDLON_IN(JINY)
        ZPRIMADD=-ZPRIMX(ILON_IN(JINY),JINY)
      ENDIF
      IF (ZOUT>ILON_IN(JINY)*ZDLON_IN(JINY)) THEN
        ZOUT    = ZOUT-ILON_IN(JINY)*ZDLON_IN(JINY)
        ZPRIMADD= ZPRIMX(ILON_IN(JINY),JINY)
      ENDIF
      JINX=INT(ZOUT*ZDLONI_IN(JINY))
      ZX=-1.+2.*(ZOUT-JINX*ZDLON_IN(JINY))*ZDLONI_IN(JINY)
!          2.2.1.1 Basic coefficients
      ZDLL=ZDIFX(JINX-2,JINY)
      ZDL =ZDIFX(JINX-1,JINY)
      ZDC =ZDIFX(JINX  ,JINY)
      ZDR =ZDIFX(JINX+1,JINY)
      ZDRR=ZDIFX(JINX+2,JINY)
      ZC(0) = (ZPRIMX(JINX+1,JINY)+ZPRIMX(JINX  ,JINY))*.5
      ZC(1) = ZDC*.5
!          2.2.1.2 Economization of the power series (5th to 3rd order)
      ZC(2)=(130.*(ZDR-ZDL)-17.*(ZDRR-ZDLL))*ZCC2
      ZC(3)=(452.*(ZDR-2.*ZDC+ZDL)-33.*(ZDRR-2.*ZDC+ZDLL))*ZCC3
!          2.2.1.3 Limiting
      ZC(3) = ZCURVLIM(ZC(3),ZC(2))
      ZLIMR = ZMINMOD( ZFRAC( (ZDR-ZDC)*.5,       2.*( ZC(2)+ZC(3) ) ) )
      ZLIML = ZMINMOD( ZFRAC( (ZDL-ZDC)*.5, ZLIMR*2.*(-ZC(2)+ZC(3) ) ) )
      ZLIM  = ZLIMR*ZLIML
      ZC(2) = ZLIM*ZC(2)
      ZC(3) = ZLIM*ZC(3)
!          2.2.1.5 Evaluation
      ZPRIM(JLON,JINY-JINYSTA)= ZC(0)+ZC(1)*ZX   &
                 & +(ZX*ZX-1.)*(ZC(2)+ZC(3)*ZX)   &
                 & +ZPRIMADD
    ENDDO
  ENDDO

!          2.2.2  Differentiate wrt longitude

  DO JINY=-2,3+JINYD
    ZDHI = 1./(ZDLON_OUT(IBLATSTA_OUT(JBL))*ZHLON_IN(JINYSTA+JINY))
    DO JLON=IBLON_OUT(JBL),1,-1
      ZPRIM(JLON,JINY) = (ZPRIM(JLON,JINY)-ZPRIM(JLON-1,JINY))*ZDHI
    ENDDO
  ENDDO

!          2.2.3 PF wrt latitude and scalefactor*cellarea (G=h_y, dA=dy ==> G*dA)
!                (output longitude / input latitude)

  DO JINY=-2,3+JINYD
    DO JLON=1, IBLON_OUT(JBL)
      ZPRIM(JLON,JINY)= ZPRIM(JLON,JINY-1)+ZPRIM(JLON,JINY)
    ENDDO
  ENDDO
  DO JINY=-2,2+JINYD
    DO JLON=1, IBLON_OUT(JBL)
      ZDIFY(JLON,JINY) = (ZPRIM(JLON,JINY+1)-ZPRIM(JLON,JINY))*ZDHLATI_IN(JINYSTA+JINY+1)
    ENDDO
  ENDDO

!          2.2.4 Interpolation PF to output latitude cell boundaries

  DO JOUTY = 0, IBLATEND_OUT(JBL)-IBLATSTA_OUT(JBL)+1
    JLAT =         JOUTY+IBLATSTA_OUT(JBL)-1
    JINY = ILAT_IO(JOUTY+IBLATSTA_OUT(JBL)-1)-JINYSTA
    ZY=-1.+2.*(-ZLAT_OUT(JLAT)+ZLAT_IN(JINYSTA+JINY))*ZDLATI_IN(JINYSTA+JINY+1)
    ZY2 = (ZY*ZY-1.)
    DO JLON=1, IBLON_OUT(JBL)
!          2.2.4.1 Basic coefficients
      ZDLL=ZDIFY(JLON,JINY-2)
      ZDL =ZDIFY(JLON,JINY-1)
      ZDC =ZDIFY(JLON,JINY  )
      ZDR =ZDIFY(JLON,JINY+1)
      ZDRR=ZDIFY(JLON,JINY+2)
      ZC(0) = (ZPRIM(JLON,JINY+1)+ZPRIM(JLON,JINY))*.5
      ZC(1) = ZDC*.5
!          2.2.1.2 Economization of the power series (5th to 3rd order)
      ZC(2)=(130.*(ZDR-ZDL)-17.*(ZDRR-ZDLL))*ZCC2
      ZC(3)=(452.*(ZDR-2.*ZDC+ZDL)-33.*(ZDRR-2.*ZDC+ZDLL))*ZCC3
!          2.2.1.3 Limiting
      ZC(3) = ZCURVLIM(ZC(3),ZC(2))
      ZLIMR = ZMINMOD( ZFRAC( (ZDR-ZDC)*.5,       2.*( ZC(2)+ZC(3) ) ) )
      ZLIML = ZMINMOD( ZFRAC( (ZDL-ZDC)*.5, ZLIMR*2.*(-ZC(2)+ZC(3) ) ) )
      ZLIM  = ZLIMR*ZLIML
      ZC(2) = ZLIM*ZC(2)
      ZC(3) = ZLIM*ZC(3)
!          2.2.5.4 Back to real coefficients
      ZC(1:3) = ZDHLAT_IN(JINYSTA+JINY+1)*ZC(1:3)
!          2.2.4.5 Evaluation
      ZPRIMY(JLON,JOUTY)= ZC(0)+ZC(1)*ZY+ZY2*(ZC(2)+ZC(3)*ZY)
    ENDDO
  ENDDO

!          2.2.5 Take difference of primitive function to get output field
!                (output longitude / output latitude)

  DO JOUTY = 1, IBLATEND_OUT(JBL)-IBLATSTA_OUT(JBL)+1
    JLAT = JOUTY+IBLATSTA_OUT(JBL)-1
    ZDHI = 1./(ZDLAT_OUT(JLAT)*ZHLAT_OUT(JLAT))
    DO JLON=1, IBLON_OUT(JBL)
      JNUM=JNUM+1
      PFLD_OUT(JNUM) =  (ZPRIMY(JLON,JOUTY)-ZPRIMY(JLON,JOUTY-1))*ZDHI
    ENDDO
  ENDDO
ENDDO
IF (ALLOCATED(ZPRIM ))  DEALLOCATE(ZPRIM )
IF (ALLOCATED(ZPRIMY))  DEALLOCATE(ZPRIMY)
IF (ALLOCATED(ZDIFY))   DEALLOCATE(ZDIFY)
IF (ALLOCATED(ZOUTPRE)) DEALLOCATE(ZOUTPRE)

IF (ALLOCATED(ZPRIMX)) DEALLOCATE(ZPRIMX)
IF (ALLOCATED(ZFLD_IN)) DEALLOCATE(ZFLD_IN)
IF (ALLOCATED(ZDIFX)) DEALLOCATE(ZDIFX)


END SUBROUTINE CONSINT

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE KWPRS1 (KSEC0,KSEC1)
C
C---->
C**** KWPRS1
C
C     Purpose.
C     --------
C
C     Print the information in the Product Definition
C     Section (Section 1) of decoded Washington ensemble GRIB data.
C
C**   Interface.
C     ----------
C
C     CALL KWPRS1 (KSEC0,KSEC1)
C
C
C     Input Parameters.
C     -----------------
C
C     KSEC0 - Array of decoded parameters from Section 0.
C
C     KSEC1 - Array of decoded parameters from Section 1.
C
C
C     Output Parameters.
C     ------------------
C
C     None.
C
C
C     Method.
C     -------
C
C     None.
C
C
C     Externals.
C     ----------
C
C     PRTBIN
C
C
C     Reference.
C     ----------
C
C     WMO Manual on Codes re GRIB Code.
C     See also routine GRIBEX.
C     http://www.nco.ncep.noaa.gov/pmb/docs/on388/appendixc.html. 
C
C
C     Comments.
C     ---------
C
C
C     Washington ensemble product usage of local part of section 1 of
C     GRIB:
C
C     KSEC1(37) decoded from Octet 41.
C     Identifies the application:
C                1   Ensemble.
C
C     KSEC1(38) decoded from Octet 42.
C     Type:
C                1   Unperturbed control forecast,
C                2   Individual negatively perturbed forecast,
C                3   Individual positively perturbed forecast,
C                4   Cluster,
C                5   Whole ensemble.
C
C     KSEC1(39) decoded from Octet 43.
C     Identification number:
C                1   If byte 42 = 1, identifies high resolution.
C                2   If byte 42 = 1, identifies low resolution.
C                1-5 If byte 42 = 2 or 3, number of a member of a pair
C                    of (negative perturbation, positive perturbation) 
C
C     KSEC1(40) decoded from Octet 44.
C     Product identifier:
C                1   Full field (individual forecast)/unweighted mean.
C                2   Weighted mean.
C                11  Standard deviation wrt ensemble mean.
C                11  Standard deviation wrt ensemble mean, normalized.
C
C     KSEC1(41) decoded from Octet 45.
C     Spatial smoothing of product (number of highest total
C     wavenumber included):
C                255 Original resolution retained.
C
C     Following are used only if needed.
C
C     Probability Section
C     -------------------
C
C     KSEC1(42) decoded from Octet 46.
C     Probability product definition.
C     If octet 9 = 191 or 192, defines variable in terms of octet 9 table
C
C     KSEC1(43) decoded from Octet 47.
C     Probability type 
C                1 = Probability of event below lower limit 
C                2 = Probability of event above upper limit 
C                3 = Probability of event between lower and upper limits 
C
C     KSEC1(44) decoded from Octets 48 - 51
C     Probability lower limit (unit as in octet 9; floating point number)
C
C     KSEC1(45) decoded from Octets 52 - 55
C     Probability upper limit (unit as in octet 9; floating point number)
C
C     Octets 56 - 60 are reserved.
C
C     Following are used only if octet 42 = 4 or 5.
C
C     Clustering Section
C     ------------------
C
C     KSEC1(46) decoded from Octet 61.
C     Ensemble size (number of members, including controls)
C
C     KSEC1(47) decoded from Octet 62.
C     Cluster size (number of members)
C
C     KSEC1(48) decoded from Octet 63.
C     Number of clusters 
C
C     KSEC1(49) decoded from Octet 64.
C     Clustering Method
C                1 = AC 
C                2 = RMS 
C
C     KSEC1(50) decoded from Octets 65 - 67
C     Northern latitude of clustering domain (in thousandths of degree) 
C
C     KSEC1(51) decoded from Octets 68 - 70
C     Southern latitude of clustering domain (in thousandths of degree) 
C
C     KSEC1(52) decoded from Octets 71 - 73
C     Eastern longitude of clustering domain (in thousandths of degree) 
C
C     KSEC1(53) decoded from Octets 74 - 76
C     Western longitude of clustering domain (in thousandths of degree) 
C
C     KSEC1(54 - 63) decoded from Octets 77 - 86
C     Cluster Membership (If octet 42 = 4)
C     Indicates in binary (on/off) format, which members of the ensemble
C     belong to the current cluster. Membership table defined by product
C     generators. 
C
C
C
C     Author.
C     -------
C
C     J.D.Chambers   ECMWF 09.10.95
C
C
C     Modifications.
C     --------------
C
C     None.
C
C
C----<
C     -----------------------------------------------------------------
C*    Section 0. Definition of variables.
C     -----------------------------------------------------------------
C
      IMPLICIT NONE
C
#include "common/grprs.h"
C
C     Parameters
      INTEGER KSEC0
      INTEGER KSEC1
      DIMENSION KSEC0(*)
      DIMENSION KSEC1(*)
C
C     Local variables
C
      INTEGER LOOP
      INTEGER*4 ILIMIT
      REAL*4    RLIMIT
      EQUIVALENCE(ILIMIT,RLIMIT)
C
C     -----------------------------------------------------------------
C*    Section 1 . Print required information.
C     ----------------------------------------------------------------- C
  100 CONTINUE
C
C     -----------------------------------------------------------------
C*    Section 2 . Print Washington ensemble product information.
C     -----------------------------------------------------------------
C
  200 CONTINUE
C
C     Application Identifier.
C
      WRITE(GRPRSM,9000) KSEC1(37)
C
C     Type.
C
      IF(KSEC1(38).GT.5) WRITE(GRPRSM,9100) KSEC1(38)
      IF(KSEC1(38).EQ.1) WRITE(GRPRSM,9101) KSEC1(38)
      IF(KSEC1(38).EQ.2) WRITE(GRPRSM,9102) KSEC1(38)
      IF(KSEC1(38).EQ.3) WRITE(GRPRSM,9103) KSEC1(38)
      IF(KSEC1(38).EQ.4) WRITE(GRPRSM,9104) KSEC1(38)
      IF(KSEC1(38).EQ.5) WRITE(GRPRSM,9105) KSEC1(38)
C
C     Identification number.
C
      IF(KSEC1(38).NE.1) THEN
        WRITE(GRPRSM,9200) KSEC1(39)
      ELSE
        IF(KSEC1(39).EQ.1) THEN
          WRITE(GRPRSM,9201) KSEC1(39)
        ELSE IF(KSEC1(39).EQ.2) THEN
          WRITE(GRPRSM,9202) KSEC1(39)
        ELSE
          WRITE(GRPRSM,9200) KSEC1(39)
        ENDIF
      ENDIF
C
C     Product.
C
      IF(KSEC1(40).EQ.1) THEN
        WRITE(GRPRSM,9301) KSEC1(40)
      ELSE IF(KSEC1(40).EQ.2) THEN
        WRITE(GRPRSM,9302) KSEC1(40)
      ELSE IF(KSEC1(40).EQ.11) THEN
        WRITE(GRPRSM,9311) KSEC1(40)
      ELSE IF(KSEC1(40).EQ.12) THEN
        WRITE(GRPRSM,9312) KSEC1(40)
      ELSE
        WRITE(GRPRSM,9300) KSEC1(40)
      ENDIF
C
C     Spatial smoothing of product.
C
      IF( KSEC1(41).EQ.255) THEN
        WRITE(GRPRSM,9400) KSEC1(41)
      ELSE
        WRITE(GRPRSM,9401) KSEC1(41)
      ENDIF
C
C     Probability Section
C
      IF( KSEC1(42).NE.0) THEN
C
C       Probability type
C
        WRITE(GRPRSM,9500) KSEC1(42)
        IF( KSEC1(43).EQ.1 ) THEN
          WRITE(GRPRSM,9501) KSEC1(43)
        ELSE IF( KSEC1(43).EQ.2 ) THEN
          WRITE(GRPRSM,9502) KSEC1(43)
        ELSE IF( KSEC1(43).EQ.3 ) THEN
          WRITE(GRPRSM,9503) KSEC1(43)
        ELSE
          WRITE(GRPRSM,9504) KSEC1(43)
        ENDIF
C
C       Limits
C
        ILIMIT = KSEC1(44)
        WRITE(GRPRSM,9505) RLIMIT
C
        ILIMIT = KSEC1(45)
        WRITE(GRPRSM,9506) RLIMIT
      ENDIF
C
C     Clustering Section
C
      IF( KSEC1(46).NE.0) THEN
C
C       Ensemble size
C
        WRITE(GRPRSM,9507) KSEC1(46)
C
        IF( KSEC1(47).NE.0 ) THEN 
C
C         Cluster size
C         Number of clusters
C         Clustering Method
C
          WRITE(GRPRSM,9508) KSEC1(47)
          WRITE(GRPRSM,9509) KSEC1(48)
          WRITE(GRPRSM,9510) KSEC1(49)
C
C         North/South/East/West limits of clustering domain
C
          WRITE(GRPRSM,9511) KSEC1(50)
          WRITE(GRPRSM,9511) KSEC1(51)
          WRITE(GRPRSM,9511) KSEC1(52)
          WRITE(GRPRSM,9511) KSEC1(53)
C
C         Cluster Membership
C
          IF( KSEC1(38).EQ.4 ) THEN
            WRITE(GRPRSM,9515)
            WRITE(GRPRSM,9516)
            DO LOOP = 1, KSEC1(46)
              IF( KSEC1(53+LOOP).EQ.1 ) THEN
                WRITE(GRPRSM,9517) LOOP
              ELSE
                WRITE(GRPRSM,9518) LOOP
              ENDIF
            ENDDO
          ENDIF
C
        ENDIF
C
      ENDIF
C
C     -----------------------------------------------------------------
C*    Section 9 . Format statements. Return to calling routine.
C     -----------------------------------------------------------------
C
  900 CONTINUE
C
      RETURN
C
 9000 FORMAT(1H ,'Application Identifier.(1=Ensemble)  ',I9)
C
 9100 FORMAT(1H ,'Type:                                ',I9)
 9101 FORMAT(1H ,'Type: Unperturbed control forecast.  ',I9)
 9102 FORMAT(1H ,'Type: Individual -vely perturbed fc. ',I9)
 9103 FORMAT(1H ,'Type: Individual +vely perturbed fc. ',I9)
 9104 FORMAT(1H ,'Type: Cluster.                       ',I9)
 9105 FORMAT(1H ,'Type: Whole ensemble.                ',I9)
C
 9200 FORMAT(1H ,'Identification number.               ',I9)
 9201 FORMAT(1H ,'Identification number: (1=high res)  ',I9)
 9202 FORMAT(1H ,'Identification number: (2=low res)   ',I9)
C
 9300 FORMAT(1H ,'Product.                             ',I9)
 9301 FORMAT(1H ,'Full field/unweighted mean.          ',I9)
 9302 FORMAT(1H ,'Weighted mean.                       ',I9)
 9311 FORMAT(1H ,'Standard deviation wrt ensemble mean.',I9)
 9312 FORMAT(1H ,'Stand.dev. wrt ens. mean, normalized.',I9)
C
 9400 FORMAT(1H ,'Original spatial smoothing retained. ',I9)
 9401 FORMAT(1H ,'Spatial smoothing of product:        ',I9)
C
 9500 FORMAT(1H ,'Probability product definition       ',I9)
 9501 FORMAT(1H ,'Prob. of event below lower limit     ',I9)
 9502 FORMAT(1H ,'Prob. of event above upper limit     ',I9)
 9503 FORMAT(1H ,'Prob. of event between limits        ',I9)
 9504 FORMAT(1H ,'Unknown probability type             ',I9)
 9505 FORMAT(1H ,'Probability lower limit        ',F15.6)
 9506 FORMAT(1H ,'Probability upper limit        ',F15.6)
 9507 FORMAT(1H ,'Ensemble size (members + controls)   ',I9)
 9508 FORMAT(1H ,'Cluster size (number of members)     ',I9)
 9509 FORMAT(1H ,'Number of clusters                   ',I9)
 9510 FORMAT(1H ,'Clustering Method (1 = AC, 2 = RMS)  ',I9)
 9511 FORMAT(1H ,'Northern latitude of domain (x1000)  ',I9) 
 9512 FORMAT(1H ,'Southern latitude of domain (x1000)  ',I9) 
 9513 FORMAT(1H ,'Eastern longitude of domain (x1000)  ',I9) 
 9514 FORMAT(1H ,'Western longitude of domain (x1000)  ',I9) 
 9515 FORMAT(1H ,'Cluster Membership')
 9516 FORMAT(1H ,'------------------')
 9517 FORMAT(1H ,'Ensemble member',I3,' in cluster')
 9518 FORMAT(1H ,'Ensemble member',I3,' not in cluster')
C
      END

C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      INTEGER FUNCTION IRSCAN (PMAT, KLEN, KLLEN, KNNS, KSCAN, KPR,
     1   KERR)
C
C---->
C**** *IRSCAN*
C
C     PURPOSE
C     _______
C
C     This routine transforms a field between the specified external
C     scanning mode and a standard internal scanning mode where the
C     array represents a quasi regular field.
C
C     INTERFACE
C     _________
C
C     IERR = IRSCAN (PMAT, KLEN, KLLEN, KNNS, KSCAN, KPR, KERR)
C
C     Input parameters
C     ________________
C
C     PMAT       - The input matrix of length (KLEN).
C
C     KLEN       - The number of points in the matrix.
C
C     KLLEN      - This array contains the quasi regular Gaussian
C                  line length definitions.
C
C     KNNS       - The number of points in the North-South direction.
C
C     KSCAN      - A standard GRIB byte variable with bits 1 to 3
C                  separately significant. This means that the final
C                  value is the sum of the bit settings.
C
C                  128 , Set if points scan East to West.
C                   64 , Set if points scan South to North.
C                   32 , Set if points in the North South direction
C                        are consecutive.
C
C     KPR        - The debug print switch.
C                  0  , No debugging output.
C                  1  , Produce debugging output.
C
C     KERR       - The error control flag.
C                  -ve, No error message. Return error code.
C                  0  , Hard failure with error message.
C                  +ve, Print error message. Return error code.
C
C     Output parameters
C     ________________
C
C     PMAT       - The transposed matrix.
C
C     Return value
C     ____________
C
C     The error indicator (INTEGER).
C
C     Error and Warning Return Values
C     _______________________________
C
C     7201  The scanning mode was not in the range 0 to 255.
C     7202  A scanning mode with consecutive values in the North
C           South direction was requested. This is not compatible
C           with a quasi regular Gaussian field.
C     7203  The total number of points given by the array KLLEN was
C           not equal to KLEN.
C
C     Common block usage
C     __________________
C
C     None
C
C     EXTERNALS
C     _________
C
C     IRLREV     - Routine to reverse the elements within each row
C                  or each column of a quasi regular Gaussian field.
C     INTLOG     - Logs messages.
C
C     METHOD
C     ______
C
C     KSCAN = 128 is implemented by swapping elements within each
C                 column of the matrix.
C
C     KSCAN = 64  is implemented by reversing the order of the columns.
C
C     REFERENCE
C     _________
C
C     None
C
C     COMMENTS
C     ________
C
C     Program contains sections 0 to 2 and 9
C
C     AUTHOR
C     ______
C
C     K. Fielding      *ECMWF*      Jan 1994
C
C     MODIFICATIONS
C     _____________
C
C     None
C
C----<
C     _______________________________________________________
C
C
C*    Section 0. Definition of variables.
C     _______________________________________________________
C
C*    Prefix conventions for variable names
C
C     Logical      L (but not LP), global or common.
C                  O, dummy argument
C                  G, local variable
C                  LP, parameter.
C     Character    C, global or common.
C                  H, dummy argument
C                  Y (but not YP), local variable
C                  YP, parameter.
C     Integer      M and N, global or common.
C                  K, dummy argument
C                  I, local variable
C                  J (but not JP), loop control
C                  JP, parameter.
C     REAL         A to F and Q to X, global or common.
C                  P (but not PP), dummy argument
C                  Z, local variable
C                  PP, parameter.
C
C     Implicit statement to force declarations
C
      IMPLICIT NONE
C
#include "parim.h"
C
C     Dummy arguments
C
      INTEGER KLEN, KNNS, KSCAN, KPR, KERR
C
      INTEGER KLLEN (KNNS)
C
      REAL PMAT (KLEN)
C
C     Local variables
C
      LOGICAL GNSMOD, GWEMOD, GTRMOD
C
      INTEGER ISCAN, IDIR, ITOTAL, IERR
C
      INTEGER JSTEP
C
      INTEGER JPROUTINE
C
      PARAMETER (JPROUTINE = 7200)
C
C     External functions
C
      INTEGER IRLREV
C
C     _______________________________________________________
C
C
C*    Section 1. Initialisation - Evaluate scan modes
C     _______________________________________________________
C
  100 CONTINUE
C
      IF (KPR .GE. 1) CALL INTLOG(JP_DEBUG,'IRSCAN: Section 1.',JPQUIET)
C
      IRSCAN = 0
C
      IF (KPR .GE. 1) THEN
         CALL INTLOG(JP_DEBUG,'IRSCAN: Input parameters',JPQUIET)
         CALL INTLOG(JP_DEBUG,'IRSCAN: Total length of matrix is ',KLEN)
         CALL INTLOG(JP_DEBUG,'IRSCAN: Latitude lines are ',KNNS)
         CALL INTLOG(JP_DEBUG,'IRSCAN: Scan mode is ',KSCAN)
      ENDIF
C
      IF (KSCAN .LT. 0 .OR. KSCAN .GE. 256) THEN
         IRSCAN = JPROUTINE + 1
         IF (KERR .GE. 0) CALL INTLOG(JP_ERROR,
     X     'IRSCAN: Scan mode is not in range 0 to 255 = ',KSCAN)
         IF (KERR .EQ. 0) CALL INTLOG(JP_FATAL,
     X    'IRSCAN: Interpolation fails.',IRSCAN)
         GO TO 900
      ENDIF
C
C     Zero KSCAN means no transformation
C
      IF (KSCAN .EQ. 0) GO TO 900
C
      ISCAN = KSCAN
      GWEMOD = .FALSE.
      GNSMOD = .FALSE.
C
      IF (ISCAN .GE. 128) THEN
         ISCAN = ISCAN - 128
         GWEMOD = .TRUE.
      ENDIF
C
      IF (ISCAN .GE. 64) THEN
         ISCAN = ISCAN - 64
         GNSMOD = .TRUE.
      ENDIF
C
      GTRMOD = ISCAN .GE. 32
C
      IF (GTRMOD) THEN
        IRSCAN = JPROUTINE + 2
        IF (KERR .GE. 0) THEN
         CALL INTLOG(JP_ERROR,
     X     'IRSCAN: scan mode wants consecutive N to S points',JPQUIET)
           CALL INTLOG(JP_ERROR,
     X      'IRSCAN: Not feasible for a quasi regular grid',JPQUIET)
          IF (KERR .EQ. 0) CALL INTLOG(JP_FATAL,
     X      'IRSCAN: Interpolation fails.',IRSCAN)
        ENDIF
        GO TO 900
      ENDIF
C
      ITOTAL = 0
C
      DO 110 JSTEP = 1, KNNS
        ITOTAL = ITOTAL + KLLEN (JSTEP)
  110 CONTINUE
C
      IF (ITOTAL .NE. KLEN) THEN
        IRSCAN = JPROUTINE + 3
        IF (KERR .GE. 0) THEN
          CALL INTLOG(JP_ERROR,
     X      'IRSCAN: Array length provided = ',KLEN)
            CALL INTLOG(JP_ERROR,
     X       'IRSCAN: not equal to sum of line lengths = ',ITOTAL)
           IF (KERR .EQ. 0) CALL INTLOG(JP_FATAL,
     X       'IRSCAN: Interpolation fails.',IRSCAN)
         ENDIF
         GO TO 900
      ENDIF
C
C     _______________________________________________________
C
C*    Section 2. Any field as order is unimportant
C
C                Potential operations in order are
C
C                1 Modify West East mode
C                2 Modify North South mode
C     _______________________________________________________
C
  200 CONTINUE
C
      IF (KPR .GE. 1) CALL INTLOG(JP_DEBUG,'IRSCAN: Section 2.',JPQUIET)
C
      IF (GWEMOD) THEN
C
         IDIR = 1
C
         IERR = IRLREV (PMAT, KLEN, KLLEN, KNNS, IDIR, KPR)
C
         IF (IERR .GT. 0) THEN
            IRSCAN = IERR
            GO TO 900
         ENDIF
C
      ENDIF
C
      IF (GNSMOD) THEN
C
         IDIR = 2
C
         IERR = IRLREV (PMAT, KLEN, KLLEN, KNNS, IDIR, KPR)
C
         IF (IERR .GT. 0) THEN
            IRSCAN = IERR
            GO TO 900
         ENDIF
C
      ENDIF
C
C     _______________________________________________________
C
C*    Section 9. Return to calling routine. Format statements
C     _______________________________________________________
C
  900 CONTINUE
C
      IF (KPR .GE. 1) CALL INTLOG(JP_DEBUG,'IRSCAN: Section 9.',JPQUIET)
C
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE INXBIT (KGRIB,KLENG,KNSPT,KPARM,KNUM,KBIT,
     C                   KBLEN,HFUNC,KRET)
C
C---->
C**** INXBIT - Insert/extract bits consecutively in/from a given array
C
C     Purpose.
C     --------
C
C           Take rightmost KBLEN bits from KNUM words of KPARM
C           and insert them consecutively in KGRIB, starting at
C           bit after KNSPT or vice versa.
C
C**   Interface.
C     ----------
C
C           CALL INXBIT (KGRIB,KLENG,KNSPT,KPARM,KNUM,KBIT,
C    C                   KBLEN,KRET)
C
C           Integer    K.
C           Real       P.
C           Logical    O.
C           Character  H.
C
C               Input Parameters.
C               -----------------
C
C               KGRIB      - Array containing bitstream.
C               KLENG      - Length (words) of this array.
C               KNSPT      - Bit number after which insertion or
C                            extraction starts.
C               KPARM      - Array from which bits are taken for
C                            insertion in the bitstream or to which
C                            bits are extracted from the bitstream.
C               KBIT       - Number of bits in computer word.
C               KNUM       - Number of bit fields inserted/extracted.
C               KBLEN      - Number of bits per bit field.
C               HFUNC      - Requested function.
C                            'C' to insert bits in bitstream,
C                            'D' to extract bits from bitstream.
C
C               Output Parameters.
C               ------------------
C
C               KNSPT      - Bit number of last bit inserted/extracted.
C
C               KRET       - Return code.
C                            0 , No error encountered.
C                            1 , Insertion/extraction exceeded
C                                array boundary.
C
C     Method.
C     -------
C
C           Word and offset pointer calculated before calling
C           insertion/extraction routines.
C
C     Externals.
C     ----------
C
C           SBYTES
C           GBYTES
C
C     Reference.
C     ----------
C
C           ECLIB documentation on SBYTES and GBYTES.
C
C     Comments.
C     ---------
C
C           IBM version of routine.
C           Routine contains Sections 0 to 3 and Section 9.
C
C     Author.
C     -------
C
C           J. Hennessy      ECMWF      18.06.91
C
C     Modifications.
C     --------------
C
C           J. Hennessy      ECMWF      08.11.91
C           Parameter KMACH removed from list of input parameters.
C
C           J. Hennessy      ECMWF      12.10.92
C           Dimension of IMASK changed from 64 to 65.
C
C     ----------------------------------------------------------------
C----<
C
C
C
C
C
C
C
C
C
C
C*    Section 0 . Definition of variables. Data statements.
C     ----------------------------------------------------------------
C
C*    Prefix conventions for variable names.
C
C     Logical      L (but not LP), global or common.
C                  O, dummy arguments.
C                  G, local variable.
C                  LP, parameter.
C     Character    C, Global or common.
C                  H, dummy arguments.
C                  Y (but not YP), local variables.
C                  YP, parameter.
C     Integer      M and N, global or common.
C                  K, dummy arguments.
C                  I, local variables.
C                  J (but not JP), loop control.
C                  JP, parameter.
C     Real         A to F and Q to X, global or common.
C                  P (but not PP), dummy arguments.
C                  Z, local variables.
C                  PP, parameter.
C
      INTEGER IND
      INTEGER INUM
      INTEGER IOFF
      INTEGER IPR
      INTEGER IWORD
C
      INTEGER KBIT
      INTEGER KBLEN
      INTEGER KGRIB
      INTEGER KLENG
      INTEGER KNSPT
      INTEGER KNUM
      INTEGER KPARM
      INTEGER KRET
C
      INTEGER J901
C
      DIMENSION KGRIB(KLENG)
      DIMENSION KPARM(*)
C
      CHARACTER*1 HFUNC
C
C
C     Debug print switch.
C
      DATA IPR /0/
C
C     ----------------------------------------------------------------
C
C
C
C
C
C
C
C
C
C
C*    Section 1 . Set initial values.
C     ----------------------------------------------------------------
C
  100 CONTINUE
C
      IF (IPR.EQ.1)
     C   THEN
             WRITE (*,*) 'INXBIT : Section 1.'
             WRITE (*,*) '         Input values used -'
             WRITE (*,9009) KLENG
             WRITE (*,9002) KNSPT
             WRITE (*,9004) KBIT
             WRITE (*,9005) HFUNC
         ENDIF
C
      KRET = 0
C
C     ----------------------------------------------------------------
C
C
C
C
C
C
C
C
C
C
C*    Section 2 . Bit insertion/extraction.
C     ----------------------------------------------------------------
C
  200 CONTINUE
C
      IF (IPR.EQ.1) WRITE (*,*) 'INXBIT : Section 2.'
C
C*    Calculate word pointer and offset.
C
      IWORD = KNSPT / KBIT
      IOFF  = KNSPT - IWORD * KBIT
      IWORD = IWORD + 1
      IF (IPR.EQ.1) WRITE (*,9003) IWORD , IOFF
C
C     Insert/extract bits.
C
      IF (HFUNC.EQ.'C')
     C   THEN
             CALL SBYTES (KGRIB(IWORD),KPARM,IOFF,KBLEN,0,KNUM)
         ELSE
             CALL GBYTES (KGRIB(IWORD),KPARM,IOFF,KBLEN,0,KNUM)
         ENDIF
C
C     Update pointer.
C
      KNSPT = KNSPT + KBLEN * KNUM
C
C     ----------------------------------------------------------------
C
C
C
C
C
C
C
C
C
C
C*    Section 3 . Check out of range.
C    -----------------------------------------------------------------
C
  300 CONTINUE
C
      IF (IPR.EQ.1) WRITE (*,*) 'INXBIT : Section 3.'
C
      IND = KNSPT / KBIT
      IF (IND.GT.KLENG)
     C   THEN
             KRET = 1
             WRITE (*,9001) IND , KLENG
         ENDIF
C
C     ----------------------------------------------------------------
C
C
C
C
C
C
C
C
C
C
C*    Section 9 . Return to calling routine. Format statements.
C     ----------------------------------------------------------------
C
  900 CONTINUE
C
      IF (IPR.EQ.1)
     C   THEN
             INUM = KNUM
             IF (INUM.GT.360)
     C          THEN
                    INUM = 360
                    WRITE (*,9007) INUM
                ENDIF
             DO 901 J901=1,INUM
               IF (HFUNC.EQ.'C')
     C             THEN
                       WRITE (*,9006) KPARM(J901)
                   ELSE
                       WRITE (*,9008) KPARM(J901)
                   ENDIF
  901        CONTINUE
             WRITE (*,*) 'INXBIT : Section 9.'
             WRITE (*,*) '         Output values set -'
             WRITE (*,9002) KNSPT
         ENDIF
C
C
 9001 FORMAT (1H ,'INXBIT : Word ',I8,' is outside array bounds ',I8)
C
 9002 FORMAT (1H ,'         KNSPT  = ',I8)
C
 9003 FORMAT (1H ,'INXBIT : Word is',I8,', bit offset is ',I2)
C
 9004 FORMAT (1H ,'         KBIT   = ',I8)
C
 9005 FORMAT (1H ,'         HFUNC  = ',A)
C
 9006 FORMAT (1H ,'         Inserted value = ',I20)
C
 9007 FORMAT (1H ,'         First ',I9,' values.')
C
 9008 FORMAT (1H ,'         Extracted value = ',I20)
C
 9009 FORMAT (1H ,'         KLENG  = ',I20)
C
      RETURN
C
      END
      SUBROUTINE ABORTX (HNAME)
C
C**** ABORTX - Terminates execution of program.
C
C     Purpose.
C     --------
C
C           Terminates execution of program.
C
C**   Interface.
C     ----------
C
C           CALL ABORTX (HNAME)
C
C           Integer    K.
C           Real       P.
C           Logical    O.
C           Character  H.
C
C               Input Parameters.
C               -----------------
C
C               HNAME      - Name of calling routine.
C
C               Output Parameters.
C               ------------------
C
C               None.
C
C     Method.
C     -------
C
C           Prints message and terminates.
C
C     Externals.
C     ----------
C
C           SYSABN
C
C     Reference.
C     ----------
C
C           None.
C
C     Comments.
C     ---------
C
C           IBM version of routine.
C           Routine contains Sections 0 to 1 and Section 9.
C
C     Author.
C     -------
C
C           J. Hennessy      ECMWF      13.11.91
C
C     Modifications.
C     --------------
C
C           None.
C
C     ------------------------------------------------------------------
C
C
C
C
C
C
C
C
C
C
C*    Section 0 . Definition of variables.
C     ------------------------------------------------------------------
C
C*    Prefix conventions for variable names.
C
C     Logical      L (but not LP), global or common.
C                  O, dummy arguments.
C                  G, local variable.
C                  LP, parameter.
C     Character    C, Global or common.
C                  H, dummy arguments.
C                  Y (but not YP), local variables.
C                  YP, parameter.
C     Integer      M and N, global or common.
C                  K, dummy arguments.
C                  I, local variables.
C                  J (but not JP), loop control.
C                  JP, parameter.
C     Real         A to F and Q to X, global or common.
C                  P (but not PP), dummy arguments.
C                  Z, local variables.
C                  PP, parameter.
C
C
      CHARACTER*(*) HNAME
C
C     ------------------------------------------------------------------
C
C
C
C
C
C
C
C
C
C
C*    Section 1 . Print message and terminate.
C     ------------------------------------------------------------------
C
  100 CONTINUE
C
      WRITE (*,9001) HNAME
C
      CALL SYSABN (1)
C
C     ------------------------------------------------------------------
C
C
C
C
C
C
C
C
C
C*    Section 9 . Format statements.
C     ------------------------------------------------------------------
C
  900 CONTINUE
C
 9001 FORMAT (1H ,'ABORTX : Routine ',A,' has requested program',
     C               ' termination.')
C
      RETURN
C
      END
      SUBROUTINE SETPAR (KBIT,KNEG,KPR)
C
C**** SETPAR - Set number of bits in word. Set maximum negative integer.
C
C     Purpose.
C     --------
C
C           Set number of bits in word. Set maximum negative integer.
C
C**   Interface.
C     ----------
C
C           CALL SETPAR (KBIT,KNEG,KPR)
C
C           Integer    K.
C           Real       P.
C           Logical    O.
C           Character  H.
C
C               Input Parameters.
C               -----------------
C
C               KPR        - Debug print switch.
C                            1 , print out.
C                            0 , No print out.
C
C               Output Parameters.
C               ------------------
C
C               KBIT       - Number of bits in computer word.
C
C               KNEG       - Maximum negative integer.
C
C     Method.
C     -------
C
C           Values are assigned.
C
C     Externals.
C     ----------
C
C           None.
C
C     Reference.
C     ----------
C
C           None.
C
C     Comments.
C     ---------
C
C           IBM version of routine.
C           Routine contains Sections 0 to 3 and Section 9.
C
C     Author.
C     -------
C
C           J. Hennessy      ECMWF      28.10.91
C
C     Modifications.
C     --------------
C
C           None.
C
C     ------------------------------------------------------------------
C
C
C
C
C
C
C
C
C
C
C*    Section 0 . Definition of variables. Data statements.
C     ------------------------------------------------------------------
C
C*    Prefix conventions for variable names.
C
C     Logical      L (but not LP), global or common.
C                  O, dummy arguments.
C                  G, local variable.
C                  LP, parameter.
C     Character    C, Global or common.
C                  H, dummy arguments.
C                  Y (but not YP), local variables.
C                  YP, parameter.
C     Integer      M and N, global or common.
C                  K, dummy arguments.
C                  I, local variables.
C                  J (but not JP), loop control.
C                  JP, parameter.
C     Real         A to F and Q to X, global or common.
C                  P (but not PP), dummy arguments.
C                  Z, local variables.
C                  PP, parameter.
C
C
      INTEGER KBIT
      INTEGER KNEG
      INTEGER KPR
C
C     ------------------------------------------------------------------
C
C
C
C
C
C
C
C
C
C
C*    Section 1 . Assign values.
C     ------------------------------------------------------------------
C
  100 CONTINUE
C
      IF (KPR.EQ.1)  WRITE (*,*) ' SETPAR : Section 1.'
C
      KBIT = 32
      KNEG = -2147483647
C
C     ------------------------------------------------------------------
C
C
C
C
C
C
C
C
C
C*    Section 9 . Return to calling routine. Format statements.
C     ------------------------------------------------------------------
C
  900 CONTINUE
C
      IF (KPR.EQ.1)
     C   THEN
             WRITE (*,*) ' SETPAR : Section 9.'
             WRITE (*,*) '          Output values set -'
             WRITE (*,9001) KBIT
             WRITE (*,9002) KNEG
         ENDIF
C
 9001 FORMAT (1H ,'          KBIT = ',I3)
C
 9002 FORMAT (1H ,'          KNEG = ',I22)
C
      RETURN
C
      END

 program tc_tracks
!
!
!**** tc_tracks*
!
!
!     Purpose.
!     --------
!
!         Create tropical cyclone tracks
!
!
!**   Interface.
!     ----------
!
!
!     Method.
!     -------
!
!
!
!
!
!     Externals.
!     ----------
!
!
!
!     Reference.
!     ----------
!
!
!
!     Author.
!     -------
!
!          M. Dragosavac    *ECMWF*      22/12/2001 
!
!
!     Modifications.
!     --------------
!
!          NONE.
!---------------------------------------------------------------------------
 USE bufr_module

 implicit none

! Local variables

  integer              :: narg, iargc, n, nn
  integer              :: iii,j,ios,ij,ii, iz
  integer              :: iunit, iret,ierr, ilen
  integer              :: kdlen
  integer              :: second, subset, iunit1

  character(len=256)   :: input_file
  character(len=256)   :: output_file
  character(len=256)   :: det_file
  character(len=256), dimension(10) :: carg
  character(len=1024)   :: line
  character(len=3)     :: tc_identifier
  character(len=10)    :: tc_name


  integer             :: increment(100)
  integer             :: member
  integer             :: originating_centre
  integer             :: number_of_members
  integer             :: member_number(100)
  integer             :: number_of_steps(100)
  integer             :: start_member(2)
  integer             :: end_member(2)

  real                :: lat_observed
  real                :: lon_observed
  real                :: lat_pressure(100,100)
  real                :: lon_pressure(100,100)
  real                :: lat_wind(100,100)
  real                :: lon_wind(100,100)
  integer             :: year
  integer             :: month
  integer             :: day
  integer             :: hour
  integer             :: minute
  integer             :: key2(46)
  integer             :: key3(46)
  integer             :: kerr
  integer             :: jj                             ! loop variable
  real                :: wind(100,100)
  real                :: pressure(100,100)


  integer, parameter :: kel=1000

! Subroutine interface


! ----------------------------------


!   Get program arguments


    input_file=' '
    output_file=' '

    narg=iargc()

    if(narg < 4) then
       print*,'Usage -- tc_tracks -i input_file -o eps_file - d det_file '
       print*,'      input_file   -- input file name'
       print*,'      eps_file     -- eps file name'
       print*,'      det_file     -- determistic file name'
       stop
    end if

    do  j=1,narg
       call getarg(j,carg(j))
    end do


    do j=1,narg
     if(carg(j) == '-i') then
       input_file=carg(j+1)
     elseif(carg(j) == '-o') then
       output_file=carg(j+1)
     elseif(carg(j) == '-d') then
       det_file=carg(j+1)
     else
       cycle
     end if
    end do

    write(0,*) 'Input  file name='//trim(input_file)
    write(0,*) 'Output file name='//trim(output_file)
    write(0,*) 'Deterministic file name='//trim(det_file)


!-- Open input and output files
!   ---------------------------


!   Open input file

    open(21,file=trim(input_file),iostat=ios)
    if(ios /= 0) then
      print*,'Open error on input file '
      stop
    end if

!   Open output file

    iret=0
    call pbopen(iunit,trim(output_file),'w',iret)
    if(iret == -1) then
       print*,'Open failed'
       stop
    elseif(iret == -2) then
       print*,'Invalid input file name'
       stop
    elseif(iret == -3) then
       print*,'Invalid open mode specified'
       stop
    end if

    iret=0
    call pbopen(iunit1,trim(det_file),'w',iret)
    if(iret == -1) then
       print*,'Open failed'
       stop
    elseif(iret == -2) then
       print*,'Invalid input file name'
       stop
    elseif(iret == -3) then
       print*,'Invalid open mode specified'
       stop
    end if



!   Read input file
  
    subset=0
    number_of_members=0
    number_of_steps=0
    values=rvind
    
    do while( ios == 0 )
    
    line=' '
    read(21,'(a)', iostat=ios) line
!   write(0,*) trim(line)

    if( ios == 0 ) then
      if(index(line,'originating centre') /= 0 ) then
         read(line,'(47x,i3)',iostat=ios) originating_centre
         write(*,'(47x,i3)',iostat=ios) originating_centre
         if(ios /= 0 ) then
            print*,'Internal read error for originating_centre'
            call exit(2)
         end if
      elseif(index(line,'TC identifier') /= 0 ) then
         read(line,'(16x,a3)',iostat=ios) tc_identifier
         write(*,'(16x,a3)',iostat=ios) tc_identifier
         if(ios /= 0 ) then
            print*,'Internal read error for tc_identifier'
            call exit(2)
         end if
      elseif(index(line,'TC name') /= 0 ) then  
         read(line,'(10x,a10)',iostat=ios) tc_name
         write(*,'(10x,a10)',iostat=ios) tc_name
         if(ios /= 0 ) then
            print*,'Internal read error for tc_name'
            call exit(2)
         end if
      elseif(index(line,'YYYYMMDDHHMM') /= 0 ) then
         read(line,'(36x,i4,i2,i2,i2,i2)',iostat=ios) year, month, day, hour, minute
         write(*,'(36x,i4,i2,i2,i2,i2)',iostat=ios) year, month, day, hour, minute
         if(ios /= 0 ) then
            print*,'Internal read error for date/time'
            call exit(2)
         end if
      elseif(index(line,'obs lat') /= 0 ) then
         read(line,'(14x,f6.2)',iostat=ios) lat_observed
         write(*,'(14x,f6.2)',iostat=ios) lat_observed
         if(ios /= 0 ) then
            print*,'Internal read error for obs lat'
            call exit(2)
         end if
      elseif(index(line,'obs lon') /= 0 ) then
         read(line,'(13x,f7.2)',iostat=ios) lon_observed
         write(*,'(13x,f7.2)',iostat=ios) lon_observed
         if(ios /= 0 ) then
            print*,'Internal read error for obs lon'
            call exit(2)
         end if
      elseif(index(line,'member') /= 0 ) then
         iii=0
         read(line,'(46x,i2)',iostat=ios) member
         write(*,'(46x,i2)',iostat=ios) member
         if(ios /= 0 ) then
            print*,'Internal read error for member'
            call exit(2)
         end if
         number_of_members=number_of_members+1
         member_number(number_of_members)=member
      elseif(index(line,'number of steps') /= 0 ) then
         read(line,'(46x,i2)',iostat=ios) number_of_steps(member)
         write(*,'(46x,i2)',iostat=ios) number_of_steps(member)
         if(ios /= 0 ) then
            print*,'Internal read error for number of steps'
            call exit(2)
         end if


      elseif(index(line,'increment') /= 0 ) then
         read(line,'(46x,i2)',iostat=ios) increment(member)
         write(*,'(46x,i2)',iostat=ios) increment(member)
         if(ios /= 0 ) then
            print*,'Internal read error for increment'
            call exit(2)
         end if
      else
           iii=iii+1
           read(line,'(4x,f6.2,3x,f7.2,3x,f7.2,4x,f6.2,4x,f6.2,3x,f7.2)',iostat=ios) lat_pressure(member,iii), &
&                           lon_pressure(member,iii),pressure(member,iii),wind(member,iii),lat_wind(member,iii), &
&                           lon_wind(member,iii)
           write(*,'(4x,f6.2,3x,f7.2,3x,f7.2,4x,f6.2,4x,f6.2,3x,f7.2)',iostat=ios) lat_pressure(member,iii), &
&                           lon_pressure(member,iii),pressure(member,iii),wind(member,iii),lat_wind(member,iii), &
&                           lon_wind(member,iii)

!          print*,member,' ',iii,'----',lat(member,iii),lon(member,iii),pressure(member,iii),wind(member,iii)
           if(ios /= 0 ) then
              print*,'Internal read error for increment'
              call exit(2)
           end if
      end if
    else
       print*,'END of data....................'
       exit
    end if
    end do


      cvals(1)=tc_identifier
      cvals(2)=tc_name


      start_member(1)=1
      end_member(1)=number_of_members-1
      start_member(2)=number_of_members
      end_member(2)=number_of_members
      do iz=1,2 
        subset=0

      do iii=start_member(iz),end_member(iz)

        subset=subset+1

        ij=(subset-1)*kel

        n=1+ij
        values(  n)=98.      ! Originating centre
        n=2+ij
        values(  n)=rvind    ! Originating subcentre
        n=3+ij
        values(  n)=1.       ! Generation application
        n=4+ij
        values(  n)=1003.    ! Storm identifier
        n=5+ij
        values(  n)=2010.    ! Storm name
        n=6+ij
        values(  n)=2.       ! singular vector
        n=7+ij
        values(  n)=member_number(iii)    ! Ensemble member number
        n=8+ij
	if (member_number(iii)==51) then
          values(  n)=1        ! unperturbed low resol. control forecast
	else if (member_number(iii)==52) then
          values(  n)=0        ! unperturbed high resol. control forecast
	else
	  values(  n)=255      ! missing value because pos/neg perurbations do not make sense
	end if
!+++++++++++++++++++++

        n=9+ij
        values(  n)=year
        n=10+ij
        values(  n)=month
        n=11+ij
        values(  n)=day
        n=12+ij
        values(  n)=hour
        n=13+ij
        values(  n)=minute
!+++++++++++++++++++++++++
        n=14+ij
        values(  n)=1.             ! Storm centre
        n=15+ij
        values(  n)=lat_observed
        n=16+ij
        values(  n)=lon_observed
        n=17+ij
        values(  n)=4.             ! Location of the storm in the perturbed analysis
        if(iz.eq.2) values(  n)=5. ! Location of the storm in the analysis
        n=18+ij
        values(  n)=lat_pressure(iii,1)
        n=19+ij
        values(  n)=lon_pressure(iii,1)
        n=20+ij
        values(  n)=pressure(iii,1)*100.
        n=21+ij
        values(  n)=3.
        n=22+ij
        values(  n)=lat_wind(iii,1)
        n=23+ij
        values(  n)=lon_wind(iii,1)
        n=24+ij
        values(  n)=wind(iii,1)
!+++++++++++++++++++++++++
        n=25+ij
        if(iz == 1) then
           values(  n)=maxval(number_of_steps(1:51))-1       ! delayed replication up to any forecast steps
        else
           values(  n)=number_of_steps(52)-1       ! delayed replication up to any forecast steps
        end if

        nn=25
        do ii=2,number_of_steps(iii)
          nn=nn+1
          n=nn+ij
          values(  n)=4.         ! time significance  008021 forecast
          nn=nn+1
          n=nn+ij
          values(  n)=(ii-1)*increment(iii)  ! time displacement
          nn=nn+1
          n=nn+ij
          values(  n)=1.           ! 008005 storm centre
          nn=nn+1
          n=nn+ij
          values(  n)=lat_pressure(iii,ii)        !
          nn=nn+1
          n=nn+ij
          values(  n)=lon_pressure(iii,ii)
          nn=nn+1
          n=nn+ij
          values(  n)=pressure(iii,ii)*100.
          nn=nn+1
          n=nn+ij
          values(  n)=3.           ! 008005  location of max wind
          nn=nn+1
          n=nn+ij
          values(  n)=lat_wind(iii,ii)        !
          nn=nn+1
          n=nn+ij
          values(  n)=lon_wind(iii,ii)
          nn=nn+1
          n=nn+ij
          values(  n)=wind(iii,ii)
        end do

       end do


        ktdlst( 1)=001033
        ktdlst( 2)=001034
        ktdlst( 3)=001032
        ktdlst( 4)=001025
        ktdlst( 5)=001027
        ktdlst( 6)=001090
        ktdlst( 7)=001091
        ktdlst( 8)=001092
        ktdlst(09)=301011
        ktdlst(10)=301012
        ktdlst(11)=008005
        ktdlst(12)=005002
        ktdlst(13)=006002
        ktdlst(14)=008005
        ktdlst(15)=005002
        ktdlst(16)=006002
        ktdlst(17)=010051
        ktdlst(18)=008005
        ktdlst(19)=301023
        ktdlst(20)=011012
        ktdlst(21)=108000
        ktdlst(22)=031001
        ktdlst(23)=008021
        ktdlst(24)=004024
        ktdlst(25)=008005
        ktdlst(26)=301023
        ktdlst(27)=010051
        ktdlst(28)=008005
        ktdlst(29)=301023
        ktdlst(30)=011012

        ktdlen=30

!          Create bufr message

        ksec0( 3)=3

        ksec1( 1)=18
        ksec1( 2)=3
        ksec1( 3)=98
        ksec1( 4)=1
        ksec1( 5)=128        ! 128 section 2 exists
        ksec1( 6)=7
        ksec1( 7)=32
        ksec1( 8)=0
        if(values(9) > 2000.) then
           ksec1( 9)=nint(values(9))-2000
        else
           ksec1( 9)=nint(values(9))-1900
        end if
        ksec1(10)=nint(values(10))
        ksec1(11)=nint(values(11))
        ksec1(12)=nint(values(12))
        ksec1(13)=nint(values(13))
        ksec1(14)=0
        ksec1(15)=11
        ksec1(16)=0
        ksec1(17)=0
        ksec1(18)=0
	
	ksec2(1)=52 ! this is required to encode section 2

! define section 2
! initialise key2 variable
        do jj=1,46
          key2(jj)=0
        enddo

        key2(1)=52                 ! Length of section 2
        key2(2)=8                  ! RDB type
        key2(3)=32                 ! RDB subtype
	key2(4)=nint(values(09))    ! Year
	key2(5)=nint(values(10))   ! Month
	key2(6)=nint(values(11))   ! Day
	key2(7)=nint(values(12))   ! Hour
	key2(8)=nint(values(13))   ! Minute
	key2(9)=0                  ! Second

        key2(10)=NINT(lon_observed*100000.+18000000)    ! Longitude 1 location of first storm centre
        key2(11)=NINT(lat_observed*100000.+9000000)     ! Latitude 1 location of first storm centre
        key2(12)=NINT(lon_observed*100000.+18000000)    ! Longitude 2 location of first storm centre
        key2(13)=NINT(lat_observed*100000.+9000000)     ! Latitude 2 location of first storm centre
        key2(14)=subset    ! no of observations/subsets

! identifier	
        key2(16)=ichar(tc_identifier(1:1))           ! first character of short identifier
        key2(17)=ichar(tc_identifier(2:2))           ! second character of short identifier
        key2(18)=ichar(tc_identifier(3:3))           ! third character of short identifier
        key2(19)=32
        key2(20)=32
        key2(21)=32
        key2(22)=32
        key2(23)=32
        key2(24)=32
		
        ksec3(1)=0
        ksec3(2)=0
        ksec3(3)=subset
        ksec3(4)=0
        if(ksec3(3).gt.1) ksec3(4)=64

        kdlen=1
        if(iz == 1) then
           kdata(1)=maxval(number_of_steps(1:51))-1  ! first step is pert. anal.
        else
           kdata(1)=number_of_steps(52)-1   ! first step is pert. anal.
        end if
        kbufl=jbufl

! pack rdb key into ksec2 array

        call bupkey(key2,ksec1,ksec2,kerr)

        if(kerr.ne.0) then
          print*,'BUPKEY: error',kerr
          call exit(2)
        end if

! encode

        ierr=0
        call bufren(ksec0,ksec1,ksec2,ksec3,ksec4, &
                    ktdlen,ktdlst,kdlen,kdata,kel, &
                    kvals,values,cvals,kbufl,kbufr,ierr)
        if(ierr > 0) then
           print*,'bufren error ', ierr
           call exit(2)
        elseif(ierr < 0) then
           print*,'Encoding return_code=',ierr
        end if


!          Write bufr message into output file

        ilen=kbufl*4

        if(iz == 1) then
           call pbwrite(iunit,kbufr,ilen,ierr)
           print*,'length=',ilen,' ierr=',ierr
           print*,'Bufr message written into output file'
        else
           call pbwrite(iunit1,kbufr,ilen,ierr)
           print*,'length=',ilen,' ierr=',ierr
           print*,'Bufr message written into output file'
        end if


        end do

 end program tc_tracks

C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

C
      COMMON /BCOMATB/ NJA,NATBTR(JTAB),NATBS (JTAB),
     1                NATBRV(JTAB),NATBDW(JTAB)
C
C
C             NATBTR      - AUGMENTED TABLE B TABLE REFERENCE
C             NATBS       - AUGMENTED TABLE B SCALE
C             NATBRV      - AUGMENTED TABLE B REFERENCE VALUE
C             NATBDW      - AUGMENTED TABLE B DATA WIDTH
C

C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      INTEGER FUNCTION DLLSEC2(KGRIB,KLENG,INSPT,KSEC0,KSEC2,IBITS,
     X                         IMISNG)
C
C---->
C**** DLLSEC2P
C
C     PURPOSE
C     _______
C
C     Decodes GRIB section 2 values for lat/long grid fields.
C
C     INTERFACE
C     _________
C
C     IRET = DLLSEC2(KGRIB,KLENG,INSPT,KSEC0,KSEC2,IBITS,IMISNG)
C
C     Input parameters
C     ________________
C
C     KGRIB   - GRIB product unpacked so far (upto octet 6). 
C     KLENG   - Length of KGRIB.
C     INSPT   - Bit position of GRIB product unpacked so far.
C     KSEC0   - GRIB section 0 description.
C     KSEC2   - GRIB section 2 description.
C     IBITS   - Number of bits per element in KGRIB.
C     IMISNG  - Missing data value to be used.
C     
C
C     Output parameters
C     ________________
C
C     KSEC2   - Updated GRIB section 2 description.
C     INSPT   - Updated bit position of GRIB product built so far.
C     IRET    - Function return status code, 0 = OK
C
C     Common block usage
C     __________________
C
C     None.
C
C     Method
C     ______
C
C     Unpacks values given in KGRIB into KSEC2 and updates bit
C     pointer INSPT.
C
C     Externals
C     _________
C
C     DSGNBT  - Get the sign bit and adjust value to +/-.
C     INXBIT  - Insert bit data.
C
C
C     AUTHOR
C     ______
C
C     J.D.Chambers       ECMWF     February 1999
C
C     MODIFICATIONS
C     _____________
C
C     None.
C
C----<
C     _______________________________________________________
C
C     Section 0. Definition of variables.
C     _______________________________________________________
C
      IMPLICIT NONE
C
#include "grprs.h"
C
C     Parameters
C
      INTEGER JP16SET
      PARAMETER ( JP16SET = 2**16 - 1 ) 
C                            ^---> 65535    =   FFFF(hex)
C
C     Function arguments
C
      INTEGER KGRIB,KLENG,INSPT,KSEC0,KSEC2,IBITS,IMISNG
      DIMENSION KGRIB(*),KSEC0(*),KSEC2(*)
C
C     Local variables
C
      INTEGER ILALO(2), IRET, IRESOL
C
C     _______________________________________________________
C
C     Section 1.    Initialization.
C     _______________________________________________________
C
  100 CONTINUE
C
      DLLSEC2 = 0
C
C     _______________________________________________________
C
C     Section 2.    Unpack section 2 octets.
C     _______________________________________________________
C
  200 CONTINUE
C
C     Octets 7 - 8  : Ni - number of points along a parallel.
C     Octets 9 - 10 : Nj - number of points along a meridian.
C     Two 16 bit fields.
C
C     WARNING!!
C     For quasi-regular grids, it is here assumed that Ni is variable,
C     i.e. that the number of points along a parallel is variable but
C     that the number of points along a meridian is fixed.
C
C     For quasi-regular grids Ni is set to all 1 bits, as
C     the number of points is different on different parallels.
C
      CALL INXBIT(KGRIB,KLENG,INSPT,KSEC2(2),2,IBITS, 16,'D',IRET)
      IF( IRET.NE.0 ) THEN
        DLLSEC2 = 1
        WRITE(GRPRSM,*) 'DLLSEC2: Error inserting/extracting'
        WRITE(GRPRSM,*)
     X    'DLLSEC2: number of pts along parallel or meridian.'
        WRITE(GRPRSM,*) 'DLLSEC2: Return code = ', IRET
        GOTO 900
      ENDIF
C
C     Octets 11 - 13 : La1 - latitude of first grid point.
C     Octets 14 - 16 : Lo1 - longitude of first grid point.
C     Two 24 bit fields.
C
      CALL INXBIT(KGRIB,KLENG,INSPT,ILALO(1),2,IBITS, 24,'D',IRET)
      IF( IRET.NE.0 ) THEN
        DLLSEC2 = 1
        WRITE(GRPRSM,*) 'DLLSEC2: Error inserting/extracting'
        WRITE(GRPRSM,*)
     X    'DLLSEC2: latitude or longitude of first grid pt.'
        WRITE(GRPRSM,*) 'DLLSEC2: Return code = ', IRET
        GOTO 900
      ENDIF
C
      CALL DSGNBT( KSEC2(4), ILALO(1), 24, IRET)
      CALL DSGNBT( KSEC2(5), ILALO(2), 24, IRET)
C
C     Octet 17 : Resolution and components flag.
C     One 8 bit field.
C
      CALL INXBIT(KGRIB,KLENG,INSPT,IRESOL,1,IBITS, 8,'D',IRET)
      IF( IRET.NE.0 ) THEN
        DLLSEC2 = 1
        WRITE(GRPRSM,*) 'DLLSEC2: Error inserting/extracting'
        WRITE(GRPRSM,*) 'DLLSEC2: components flag.'
        WRITE(GRPRSM,*) 'DLLSEC2: Return code = ', IRET
        GOTO 900
      ENDIF
C
C     All flag fields are already set to 0, so
C
      IF( IRESOL.EQ.0 ) GOTO 211
C
C     Fix up for flag which was different in Experimental edition.
C
      IF( KSEC0(2).EQ.-1.AND.(IRESOL.EQ.1.OR.IRESOL.EQ.3)) IRESOL = 128
C
C     Set Resolution flag.
C
      IF( IRESOL.GE.128) THEN
        KSEC2(6) = 128
        IRESOL   = IRESOL - 128
      ENDIF
C
C     Set earth flag.
C
      IF( IRESOL.GE.64) THEN
          KSEC2(18) = 64
          IRESOL    = IRESOL - 64
      ENDIF
C
C     Set components flag.
C
      KSEC2(19) = IRESOL
C
  211 CONTINUE
C
C     Octets 18 - 20 : La2 - latitude of last grid point.
C     Octets 21 - 23 : Lo2 - longitude of last grid point.
C     Two 24 bit fields.
C
      CALL INXBIT(KGRIB,KLENG,INSPT,ILALO(1),2,IBITS, 24,'D',IRET)
      IF( IRET.NE.0 ) THEN
        DLLSEC2 = 1
        WRITE(GRPRSM,*) 'DLLSEC2: Error inserting/extracting'
        WRITE(GRPRSM,*)
     X    'DLLSEC2: latitude or longitude of last grid point.'
        WRITE(GRPRSM,*) 'DLLSEC2: Return code = ', IRET
        GOTO 900
      ENDIF
C
      CALL DSGNBT( KSEC2(7), ILALO(1), 24, IRET)
      CALL DSGNBT( KSEC2(8), ILALO(2), 24, IRET)
C
C     Octets 24 - 25 : Di - i direction increment.
C     One 16 bit field.
C
C     For quasi-regular grids all Di bits are set to 1, as
C     the increment is different on different parallels.
C
      CALL INXBIT(KGRIB,KLENG,INSPT,KSEC2(9),1,IBITS, 16,'D',IRET)
      IF( IRET.NE.0 ) THEN
        DLLSEC2 = 1
        WRITE(GRPRSM,*) 'DLLSEC2: Error inserting/extracting'
        WRITE(GRPRSM,*) 'DLLSEC2: i direction increment.'
        WRITE(GRPRSM,*) 'DLLSEC2: Return code = ', IRET
        GOTO 900
      ENDIF
C
C     Change 1 bits to missing data value.
C
      IF( KSEC2(9).EQ.JP16SET) KSEC2(9) = IMISNG
C
C
C     Octets 26 - 27 : Dj - j direction increment.
C     One 16 bit field.
C
      CALL INXBIT(KGRIB,KLENG,INSPT,KSEC2(10),1,IBITS, 16,'D',IRET)
      IF( IRET.NE.0 ) THEN
        DLLSEC2 = 1
        WRITE(GRPRSM,*) 'DLLSEC2: Error inserting/extracting'
        WRITE(GRPRSM,*) 'DLLSEC2: j direction increment.'
        WRITE(GRPRSM,*) 'DLLSEC2: Return code = ', IRET
        GOTO 900
      ENDIF
C
C     Change 1 bits to missing data value.
C
      IF( KSEC2(10).EQ.JP16SET) KSEC2(10) = IMISNG
C
C     Octet 28 : Scanning mode flags.
C     One 8 bit field.
C
      CALL INXBIT(KGRIB,KLENG,INSPT,KSEC2(11),1,IBITS, 8,'D',IRET)
      IF( IRET.NE.0 ) THEN
        DLLSEC2 = 1
        WRITE(GRPRSM,*) 'DLLSEC2: Error inserting/extracting'
        WRITE(GRPRSM,*) 'DLLSEC2: scanning mode flags.'
        WRITE(GRPRSM,*) 'DLLSEC2: Return code = ', IRET
        GOTO 900
      ENDIF
C
C     Fix-up for flag which was different in Experimental Edition.
      IF( KSEC0(2).EQ.-1.AND.KSEC2(11).EQ.1) KSEC2(11) = 0
C
C     Octets 29 - 32 : Reserved.
C     Two 16 bit fields.
C
C     Update bit pointer.
      INSPT = INSPT + 32
C
C     _______________________________________________________
C
C     Section 9. Return to calling routine.
C     _______________________________________________________
C
  900 CONTINUE
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities
C granted to it by virtue of its status as an intergovernmental organisation
C nor does it submit to any jurisdiction.
C

      SUBROUTINE CONFP3(PVAL,KEXP,KMANT,KBITS,KROUND)
C
C---->
C**** CONFP3 - Convert floating point number to GRIB representation.
C
C     Purpose.
C     --------
C
C     Convert floating point number from machine
C     representation to GRIB representation.
C
C**   Interface.
C     ----------
C
C     CALL CONFP3(PVAL,KEXP,KMANT,KBITS,KROUND)
C
C
C     Input Parameters.
C     -----------------
C
C     PVAL    - Floating point number to be converted.
C     KBITS   - Number of bits in computer word.
C     KROUND  - Conversion type.
C               0 , Closest number in GRIB format less than
C                   original number.
C               1 , Closest number in GRIB format to the
C                   original number (equal to, greater than or
C                   less than original number).
C               10 , as for 0 but with debug printout.
C               11 , as for 1 but with debug printout.
C
C     Output Parameters.
C     -----------------
C
C     KEXP    - 8 Bit signed exponent.
C     KMANT   - 24 Bit mantissa.
C
C     Method.
C     -------
C
C     Floating point number represented as 8 bit signed
C     exponent and 24 bit mantissa in integer values.
C
C     Externals.
C     ----------
C
C     DECFP2
C     ABORTX
C
C     Reference.
C     ----------
C
C     WMO Manual on Codes re GRIB representation.
C
C     Comments.
C     ---------
C
C     Routine aborts if an invalid conversion type parameter
C     is used or if a 24 bit mantissa is not produced.
C
C
C     Author.
C     -------
C
C     John Hennessy   ECMWF   18.06.91
C
C     Modifications.
C     --------------
C
C     John Hennessy   ECMWF   24.09.91
C     Corrections made to descriptions of input parameter KROUND.
C     Changes to comments and format statements.
C
C     J.D.Chambers    ECMWF    13.09.94
C     Inhibit abort if NOABORT = 1, use grbcom.h
C
C
C     J.D.Chambers    ECMWF    21.11.94
C     Use JNINT for VAX
C
C----<
C     -----------------------------------------------------------------
C*    Section 0 . Definition of variables. Set initial values.
C     -----------------------------------------------------------------
C
      IMPLICIT NONE
C
#include "common/grprs.h"
C
#include "grbcom.h"
C
C     Subroutine arguments
C
      REAL PVAL
      INTEGER KEXP,KMANT,KBITS,KROUND
C
C     Local variables
C
      INTEGER IEXP, IPR, IROUND, ISIGN
      REAL ZEPS, ZREF, ZVAL
C
C     -----------------------------------------------------------------
C*    Section 1 . Initialise
C     -----------------------------------------------------------------
C
  100 CONTINUE
C
C     Debug print switch.
C
      IF( KROUND.GE.10) THEN
        IPR    = 1
        IROUND = KROUND - 10
      ELSE
        IPR    = 0
        IROUND = KROUND
      ENDIF
C
C     Check conversion type parameter.
C
      IF( IROUND.NE.0.AND.IROUND.NE.1) THEN
        WRITE(GRPRSM,*) 'CONFP3: Invalid conversion type = ', KROUND
C
        IF( NOABORT.EQ.0 ) CALL ABORTX('CONFP3')
C
C       If not aborting, arbitrarily set rounding to 'up'.
C
        IROUND = 1
      ENDIF
C
C     -----------------------------------------------------------------
C*    Section 2 . Convert value of zero.
C     -----------------------------------------------------------------
C
  200 CONTINUE
C
      IF( PVAL.EQ.0.0 ) THEN
        KEXP  = 0
        KMANT = 0
        IEXP  = 0
        ISIGN = 0
        GOTO 900
      ENDIF
C
C     -----------------------------------------------------------------
C*    Section 3 . Convert other values.
C     -----------------------------------------------------------------
C
  300 CONTINUE
C
      ZEPS = 1.0E-12
      IF( KBITS.EQ.32) ZEPS = 1.0E-8
      ZREF = PVAL
C
C     Sign of value.
C
      ISIGN = 0
      IF( ZREF.LT.0.) THEN
        ISIGN = 128
        ZREF  = - ZREF
      ENDIF
C
C     Exponent.
C
#ifdef CRAY
      IEXP = INT(ALOG(ZREF)*(1.0/ALOG(16.0))+64.0+1.0+ZEPS)
#else
      IEXP = INT(LOG(ZREF)*(1.0/LOG(16.0))+64.0+1.0+ZEPS)
#endif
C
      IF( IEXP.LT.0  ) IEXP = 0
      IF( IEXP.GT.127) IEXP = 127
C
C     Mantissa.
C
      IF( IROUND.EQ.0 ) THEN
C
C       Closest number in GRIB format less than original number.
C       Truncate for positive numbers.
C       Round up for negative numbers.
C
        IF( ISIGN.EQ.0 ) THEN
          KMANT = INT(ZREF/16.0**(IEXP-70))
        ELSE
#ifdef VAX
          KMANT = JNINT(ZREF/16.0**(IEXP-70)+0.5)
#else
          KMANT = NINT(ZREF/16.0**(IEXP-70)+0.5)
#endif
        ENDIF
C
      ELSE
C
C       Closest number in GRIB format to the original number
C       (equal to, greater than or less than original number).
C
#ifdef VAX
        KMANT = JNINT(ZREF/16.0**(IEXP-70))
#else
        KMANT = NINT(ZREF/16.0**(IEXP-70))
#endif
      ENDIF
C
C     Check that mantissa value does not exceed 24 bits.
C     If it does, adjust the exponent upwards and recalculate
C     the mantissa.
C     (Nb. 16777215 = 2**24 - 1)
C
      IF( KMANT.GT.16777215) THEN
C
  350   CONTINUE
C
        IEXP = IEXP + 1
C
C       Check for exponent overflow during adjustment
C
        IF( IEXP.GT.127 ) THEN
          WRITE(GRPRSM,*) 'CONFP3: Exponent overflow'
          WRITE(GRPRSM,9002) PVAL
          WRITE(GRPRSM,9003) ISIGN, IEXP, KMANT
C
          IF( NOABORT.EQ.0 ) CALL ABORTX('CONFP3')
C
C         If not aborting, arbitrarily set value to zero
C
          WRITE(GRPRSM,*) 'CONFP3: Value arbitrarily set to zero.'
          KEXP  = 0
          KMANT = 0
          IEXP  = 0
          ISIGN = 0
          GOTO 900
C
        ENDIF
C
        IF( IROUND.EQ.0) THEN
C
C         Closest number in GRIB format less than original number.
C         Truncate for positive numbers.
C         Round up for negative numbers.
C
          IF( ISIGN.EQ.0 ) THEN
            KMANT = INT(ZREF/16.0**(IEXP-70))
          ELSE
#ifdef VAX
            KMANT = JNINT(ZREF/16.0**(IEXP-70)+0.5)
#else
            KMANT = NINT(ZREF/16.0**(IEXP-70)+0.5)
#endif
          ENDIF
C
        ELSE
C
C         Closest number in GRIB format to the original number
C         (equal to, greater or less than original number).
C
#ifdef VAX
          KMANT = JNINT(ZREF/16.0**(IEXP-70))
#else
          KMANT = NINT(ZREF/16.0**(IEXP-70))
#endif
        ENDIF
C
C       Repeat calculation (with modified exponent) if still have
C       mantissa overflow.
C
        IF( KMANT.GT.16777215) GOTO 350
C
      ENDIF
C
C     Add sign bit to exponent.
C
      KEXP = IEXP + ISIGN
C
C     -----------------------------------------------------------------
C*    Section 9. Return
C     -----------------------------------------------------------------
C
  900 CONTINUE
C
C     Print generated values if required.
C
      IF( IPR.EQ.1 ) THEN
        WRITE(GRPRSM,9006) KROUND
        WRITE(GRPRSM,9002) PVAL
        CALL DECFP2(ZVAL,KEXP,KMANT)
        WRITE(GRPRSM,9007) ZVAL
        WRITE(GRPRSM,9003) ISIGN, IEXP, KMANT
      ENDIF
C
      RETURN
C
C
 9002 FORMAT(1H ,'CONFP3: Original number = ',F30.20)
 9003 FORMAT(1H ,'CONFP3: Sign = ',I3,', Exponent = ',I3,
     X            ', Mantissa = ',I12)
 9006 FORMAT(1H ,'CONFP3: Conversion type parameter = ',I4)
 9007 FORMAT(1H ,'CONFP3: Converted to      ',F30.20)
C
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE MAXMN2(PARRAY,KLEN,PMISS,PMAX,PMIN)
C
C---->
C**** MAXMN2 - Get max/minimum values, ignoring missing data value.
C
C     Purpose.
C     --------
C
C     Get maximum and minimum values from an array of
C     floating point numbers, ignoring missing data value.
C
C**   Interface.
C     ----------
C
C     CALL MAXMN2(PARRAY,KLEN,PMISS,PMAX,PMIN)
C
C     Input Parameters.
C     -----------------
C
C     PARRAY - Array of numbers.
C
C     KLEN   - Last word of this array.
C
C     PMISS  - Value indicating missing data in array element.
C
C     Output Parameters.
C     ------------------
C
C     PMAX   - Maximum value.
C     PMIN   - Minimum value.
C
C     Method.
C     -------
C
C     Intrinsic functions MAX and MIN are used.
C
C     Externals.
C     ----------
C
C     None.
C
C     Reference.
C     ----------
C
C     None.
C
C     Comments.
C     ---------
C
C     None.
C
C     Author.
C     -------
C
C     J. Hennessy      ECMWF      18:06:91
C
C     Modifications.
C     --------------
C
C     J. Clochard, Meteo France, for ECMWF - January 1998.
C     Exclude values from first loop in second search loop.
C
C----<
C     ----------------------------------------------------------------
C*    Section 0 . Definition of variables. Data statements.
C     ----------------------------------------------------------------
C
      IMPLICIT NONE
C
C     Subroutine arguments
C
      INTEGER KLEN
      REAL   PARRAY, PMAX, PMIN, PMISS, VSMALL
      DIMENSION PARRAY(*)
#ifndef __uxp__
C
C     Parameters
C
      REAL JPSMALL
#ifdef __alpha
#ifdef REAL_8
      PARAMETER (JPSMALL = 1E-307)
#else
      PARAMETER (JPSMALL = 1E-37)
#endif
#else
#ifdef REAL_8
      PARAMETER (JPSMALL = 1E-308)
#else
      PARAMETER (JPSMALL = 1E-38)
#endif
#endif
#endif
C
C     Local variables
C
      INTEGER JLOOP, IOFF
C
C     ----------------------------------------------------------------
C*    Section 1 . Get maximum and minimum values.
C     ----------------------------------------------------------------
C
  100 CONTINUE
      IOFF = 0
C
C     Set initial values to first data value which is not
C     a missing data indicator.
C
      DO 110 JLOOP = 1 , KLEN
        IF (PARRAY(JLOOP).NE.PMISS) THEN
          PMAX = PARRAY(JLOOP)
          PMIN = PARRAY(JLOOP)
          IOFF = JLOOP
          GO TO 120
        ENDIF
  110 CONTINUE
C
  120 CONTINUE
C
C     Extract maximum and minimum values.
C
      DO 130 JLOOP = IOFF+1 , KLEN
        IF (PARRAY(JLOOP).NE.PMISS) THEN
          PMAX = MAX(PMAX,PARRAY(JLOOP))
          PMIN = MIN(PMIN,PARRAY(JLOOP))
        ENDIF
  130 CONTINUE
C
C     Adjust to an acceptable 'tiny' minimum
C
#ifdef __uxp__
      VSMALL = TINY(PMIN)
#else
      VSMALL = JPSMALL
#endif
      IF( (PMIN.NE.0.0).AND.(ABS(PMIN).LT.VSMALL) )
     X   PMIN = SIGN(VSMALL,PMIN)
C
C     ----------------------------------------------------------------
C*    Section 9. Return to calling routine.
C     ----------------------------------------------------------------
C
  900 CONTINUE
C
      RETURN
C
      END

C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      INTEGER FUNCTION HLL2LL(L12PNT,OLDFLD,OLDGRID,AREA,POLE,GRID,
     X                        NEWFLD,KSIZE,NLON,NLAT)
C
C---->
C**** HLL2LL
C
C     Purpose
C     -------
C
C     This routine creates a rotated regular lat/long field from a
C     global regular lat/long field using 12-point horizontal
C     interpolation.
C
C
C     Interface
C     ---------
C
C     IRET = HLL2LL(L12PNT,OLDFLD,OLDGRID,AREA,POLE,GRID,NEWFLD,KSIZE,
C    X              NLON,NLAT)
C
C
C     Input parameters
C     ----------------
C
C     L12PNT  - Chooses between 12-point and 4-point interpolation
C     OLDFLD  - The array of values from the regular lat/long field
C     OLDGRID - Grid increments (i/j) for the global lat/long field
C     AREA    - Limits of area (N/W/S/E) for the new lat/long field
C     POLE    - Pole of rotation (lat/long) for the new lat/long field
C     GRID    - Grid increments (i/j) for the new lat/long field
C     KSIZE   - The size of the array to fill with the new
C               lat/long field
C
C
C     Output parameters
C     -----------------
C
C     NEWFLD - The array of values for the regular lat/long field 
C     NLON   - Number of longitudes in the regular lat/long field
C     NLAT   - Number of latitudes in the regular lat/long field
C
C     Returns 0 if function successful, non-zero otherwise.
C
C     Common block usage
C     ------------------
C
C
C
C     Method
C     ------
C
C     Numbering of the points (I is the interpolation point):
C
C                   13       5       6      14
C
C                    7       1       2       8
C                               (I)
C                    9       3       4      10
C
C                   15      11      12      16
C
C     The 12-point interpolation is not possible if either of the top
C     two rows is above the original field northern latitude. The
C     nearest neighbour is used if both rows are above, and a 4-pt
C     bilinear interpolation is used if the top row is above.
C     Similarily, if either of the bottom two rows is below the original
C     field southern latitude.
C
C
C     Externals
C     ---------
C
C     INTLOG  - Log error message.
C     JMALLOC - Dynamically allocate memory
C     JFREE   - Free dynamically allocated memory
C     HGENLL  - Calculates original lat/long (before rotation) for
C               a rotated grid
C     HNEILL  - Finds neighbours for points for interpolation
C     HWTSLL  - Calculates weightings for points for interpolation
C
C
C     Reference
C     ---------
C
C     None.
C
C
C     Comments
C     --------
C
C     None.
C
C
C     Author
C     ------
C
C     J.D.Chambers      ECMWF      November 2001
C
C
C     Modifications
C     -------------
C
C     None.
C
C----<
C     -----------------------------------------------------------------|
C*    Section 0. Definition of variables.
C     -----------------------------------------------------------------|
C
      IMPLICIT NONE
C
#include "parim.h"
#include "nifld.common"
#include "nofld.common"
C
C     Parameters
C
      INTEGER JNORTH, JSOUTH, JWEST, JEAST, JW_E, JN_S, JLAT, JLON
      INTEGER JP12PT, JP4PT, JPNEARN
      PARAMETER (JP12PT  = 0)
      PARAMETER (JP4PT   = 1)
      PARAMETER (JPNEARN = 2)
      PARAMETER (JNORTH = 1 )
      PARAMETER (JWEST  = 2 )
      PARAMETER (JSOUTH = 3 )
      PARAMETER (JEAST  = 4 )
      PARAMETER (JW_E  = 1 )
      PARAMETER (JN_S  = 2 )
      PARAMETER (JLAT  = 1 )
      PARAMETER (JLON  = 2 )
C
C     Function arguments
C
      LOGICAL L12PNT
      INTEGER KSIZE, NLON, NLAT
      REAL OLDGRID(2),AREA(4),POLE(2),GRID(2),OLDFLD(*),NEWFLD(KSIZE)
C
C     Local variables
C
      integer loopx
      INTEGER NEXT, LOOP, IRET, NLEN, NPREV, NBYTES, NUMBER
      INTEGER NOLDLAT, NOLDLON, NEAREST
C
      CHARACTER*12 YFLAG
      LOGICAL LNEW, LFIRST, LVEGGY
      INTEGER KSCHEME(1),NEIGH(12,1), KLA(1)
      REAL PWTS(12,1)
      POINTER (IPKSCHE, KSCHEME)
      POINTER (IPNEIGH, NEIGH)
      POINTER (IPKLA,   KLA)
      POINTER (IPPWTS,  PWTS)
C
      REAL PDLO0(1),PDLO1(1),PDLO2(1),PDLO3(1),PDLAT(1)
      POINTER (IPPDLO0, PDLO0)
      POINTER (IPPDLO1, PDLO1)
      POINTER (IPPDLO2, PDLO2)
      POINTER (IPPDLO3, PDLO3)
      POINTER (IPPDLAT, PDLAT)
C
      REAL PREGRID(2)
      INTEGER KPTS(1)
      REAL GLATS(1)
      INTEGER IOFFS(1)
      POINTER (IPKPTS,  KPTS)
      POINTER (IPIOFFS, IOFFS)
      POINTER (IPGLATS, GLATS)
C
      INTEGER ILL, ILLOLD
      REAL RLAT(1),RLON(1)
      POINTER (IPRLAT, RLAT)
      POINTER (IPRLON, RLON)
C
      REAL OLD(1)
      POINTER (IOLD,   OLD)
C
      DATA NPREV/-1/
      DATA LNEW/.FALSE./, LFIRST/.TRUE./
      DATA ILLOLD/-1/, IOLD/-1/
      DATA PREGRID/2*0.0/
C
      SAVE LNEW, LFIRST
      SAVE IPKSCHE, IPNEIGH, IPKLA, IPPWTS
      SAVE IPPDLO0, IPPDLO1, IPPDLO2, IPPDLO3, IPPDLAT
      SAVE NPREV, IPKPTS, IPIOFFS, IPGLATS
      SAVE ILLOLD, IPRLAT, IPRLON, IOLD
      SAVE PREGRID
C
C     Externals
C
      INTEGER HNEILL, HGENLL
#ifdef POINTER_64
      INTEGER*8 JMALLOC
#else
      INTEGER JMALLOC
#endif
C
C     -----------------------------------------------------------------|
C     Section 1.  Initialise.
C     -----------------------------------------------------------------|
C
  100 CONTINUE
C
      HLL2LL = 0
C
      CALL JDEBUG()

      IF( L12PNT ) THEN
        CALL INTLOG(JP_DEBUG,'HLL2LL: 12-pt interpolation',JPQUIET)
      ELSE
        CALL INTLOG(JP_DEBUG,'HLL2LL:  4-pt interpolation',JPQUIET)
      ENDIF
C
      CALL CHKPREC()
      IF( LPREC )THEN
        CALL INTLOG(JP_DEBUG,
     X   'HLL2LL: precipitation threshold applied',JPQUIET)
      ELSE
        CALL INTLOG(JP_DEBUG,
     X   'HLL2LL: precipitation threshold not applied',JPQUIET)
      ENDIF
C    Are we handling vegetation parameter
      LVEGGY = (NITABLE.EQ.128).AND.
     X         ((NIPARAM.EQ.27).OR.
     X          (NIPARAM.EQ.28).OR.
     X          (NIPARAM.EQ.29).OR.
     X          (NIPARAM.EQ.30).OR.
     X          (NIPARAM.EQ.43) )

C     Force nearest neighbour processing with env variable
        CALL GETENV('NEAREST_NEIGHBOUR', YFLAG)
        IF( YFLAG(1:1).EQ.'1' ) LVEGGY = .TRUE.

C     Force nearest neighbour processing with INTOUT parameter
      IF( LMETHOD ) LVEGGY = .TRUE.

      IF( LVEGGY ) CALL INTLOG(JP_DEBUG,
     X  'HLL2LL: nearest neighbour processing (vegetation)',JPQUIET)

      NOLDLAT = 1 + NINT(180.0/OLDGRID(1))
      NOLDLON = NINT(360.0/OLDGRID(2))
      NUMBER  = NOLDLAT * NOLDLON
C
      IF( (OLDGRID(1).NE.PREGRID(1)).OR.
     X    (OLDGRID(2).NE.PREGRID(2)) ) THEN
C
C       Allocate memory to hold the input field
C       (in case OLDFLD and NEWFLD are the same arrays)
C
        IF( IOLD.GT.0 ) CALL JFREE(IOLD)
C
        NBYTES = NUMBER * JPRLEN
C
        IOLD = JMALLOC(NBYTES)
#ifdef hpR64
        IOLD = IOLD/(1024*1024*1024*4)
#endif
        IF( IOLD.EQ.0 ) THEN
          CALL INTLOG(JP_ERROR,'HLL2LL: Memory allocation fail',JPQUIET)
          HLL2LL = 3
          GOTO 900
        ENDIF
C
        PREGRID(1) = OLDGRID(1)
        PREGRID(2) = OLDGRID(2)
C
      ENDIF
C
C     Preserve the input field
C
      DO LOOP = 1, NUMBER
        OLD(LOOP) = OLDFLD(LOOP)
      ENDDO
C
C     -----------------------------------------------------------------|
C     Section 2.  Generate the lat/long points for the output grid
C     -----------------------------------------------------------------|
C
  200 CONTINUE
C
      NLON = 1 + NINT((AREA(JEAST) - AREA(JWEST)) / GRID(JW_E)) ! SC
      NLAT = 1 + NINT((AREA(JNORTH) - AREA(JSOUTH)) / GRID(JN_S)) ! SC
C
      NLEN = NLON * NLAT

      NOWE = NLON
      NONS = NLAT
C
C     Check that given array is big enough for the new field.
C
      IF( NLEN.GT.KSIZE ) THEN
        CALL INTLOG(JP_ERROR,'HLL2LL: Given array size = ',KSIZE)
        CALL INTLOG(JP_ERROR,'HLL2LL: Required size = ',NLEN)
        HLL2LL = 4
        GOTO 900
      ENDIF
C
C     Dynamically allocate memory for lat/long arrays.
C
      ILL = NLEN
      IF( ILL.GT.ILLOLD ) THEN
C
        LNEW = .TRUE.
C
        IF( ILLOLD.GT.0 ) CALL JFREE(IPRLON)
C
        NBYTES = 2*ILL*JPRLEN
C
        IPRLON = JMALLOC(NBYTES)
#ifdef hpR64
        IPRLON = IPRLON/(1024*1024*1024*4)
#endif
        IF( IPRLON.EQ.0 ) THEN
          CALL INTLOG(JP_ERROR,'HLL2LL: Memory allocation fail',JPQUIET)
          HLL2LL = 5
          GOTO 900
        ENDIF
C
        IPRLAT = IPRLON + (ILL*JPRLEN)
C
        ILLOLD = ILL
C
      ENDIF
C
      IRET = HGENLL(AREA,POLE,GRID,NLON,NLAT,RLAT,RLON)
      IF( IRET.NE.0 ) THEN
        CALL INTLOG(JP_ERROR,
     X    'HLL2LL: HGENLL failed to get lat/lon grid data',JPQUIET)
        HLL2LL = 6
        GOTO 900
      ENDIF
C
C     -----------------------------------------------------------------|
C     Section 3.  Find neighbours for each point for interpolation.
C     -----------------------------------------------------------------|
C
  300 CONTINUE
C
C     Dynamically allocate memory for interpolation arrays.
C
      IF( LNEW ) THEN
C
        IF( .NOT.LFIRST ) CALL JFREE(IPPDLO0)
C
        NBYTES = (17*JPRLEN + 14*JPBYTES) * ILL
C
        IPPDLO0 = JMALLOC(NBYTES)
#ifdef hpR64
        IPPDLO0 = IPPDLO0/(1024*1024*1024*4)
#endif
        IF( IPPDLO0.EQ.0 ) THEN
          CALL INTLOG(JP_ERROR,'HLL2LL: Memory allocation fail',JPQUIET)
          HLL2LL = 7
          GOTO 900
        ENDIF
C
        IPPDLO1 = IPPDLO0 + (ILL*JPRLEN)
        IPPDLO2 = IPPDLO1 + (ILL*JPRLEN)
        IPPDLO3 = IPPDLO2 + (ILL*JPRLEN)
        IPPDLAT = IPPDLO3 + (ILL*JPRLEN)
        IPPWTS  = IPPDLAT + (ILL*JPRLEN)
        IPKSCHE = IPPWTS  + (12*ILL*JPRLEN)
        IPKLA   = IPKSCHE + (ILL*JPBYTES)
        IPNEIGH = IPKLA   + (ILL*JPBYTES)
C
        LFIRST = .FALSE.
        LNEW   = .FALSE.
C
      ENDIF
C
C     Find neighbours.
C
      IRET = HNEILL(L12PNT,NLEN,RLAT,RLON,OLDGRID,
     X              KSCHEME,PDLAT,PDLO0,PDLO1,PDLO2,PDLO3,KLA,NEIGH)
      IF( IRET.NE.0 ) THEN
        CALL INTLOG(JP_ERROR,
     X    'HLL2LL: HNEILL failed to find neighbours',JPQUIET)
        HLL2LL = 8
        GOTO 900
      ENDIF
C
C     -----------------------------------------------------------------|
C     Section 4.  Perform the 12-point horizontal interpolation.
C     -----------------------------------------------------------------|
C
  400 CONTINUE
C
C     Setup the 12-point horizontal interpolation weights
C
      CALL HWTSLL
     X  (NLEN,KSCHEME,KLA,PDLAT,oldgrid(2),pdlo0,PDLO1,PDLO2,PDLO3,
     X   NEIGH,PWTS)
C
C     Calculate the interpolated grid point values
C
      DO LOOP = 1, NLEN
        IF( LVEGGY) THEN
            NEAREST = 1
            IF( PWTS( 2,LOOP).GT.PWTS(NEAREST,LOOP) ) NEAREST = 2
            IF( PWTS( 3,LOOP).GT.PWTS(NEAREST,LOOP) ) NEAREST = 3
            IF( PWTS( 4,LOOP).GT.PWTS(NEAREST,LOOP) ) NEAREST = 4
            IF( PWTS( 5,LOOP).GT.PWTS(NEAREST,LOOP) ) NEAREST = 5
            IF( PWTS( 6,LOOP).GT.PWTS(NEAREST,LOOP) ) NEAREST = 6
            IF( PWTS( 7,LOOP).GT.PWTS(NEAREST,LOOP) ) NEAREST = 7
            IF( PWTS( 8,LOOP).GT.PWTS(NEAREST,LOOP) ) NEAREST = 8
            IF( PWTS( 9,LOOP).GT.PWTS(NEAREST,LOOP) ) NEAREST = 9
            IF( PWTS(10,LOOP).GT.PWTS(NEAREST,LOOP) ) NEAREST =10
            IF( PWTS(11,LOOP).GT.PWTS(NEAREST,LOOP) ) NEAREST =11
            IF( PWTS(12,LOOP).GT.PWTS(NEAREST,LOOP) ) NEAREST =12
            NEWFLD(LOOP) = OLD(NEIGH( NEAREST,LOOP))
        ELSE
          IF( KSCHEME(LOOP).EQ.JP12PT ) THEN
            NEWFLD(LOOP) =
     X        OLD(NEIGH( 1,LOOP)) * PWTS( 1,LOOP) +
     X        OLD(NEIGH( 2,LOOP)) * PWTS( 2,LOOP) +
     X        OLD(NEIGH( 3,LOOP)) * PWTS( 3,LOOP) +
     X        OLD(NEIGH( 4,LOOP)) * PWTS( 4,LOOP) +
     X        OLD(NEIGH( 5,LOOP)) * PWTS( 5,LOOP) +
     X        OLD(NEIGH( 6,LOOP)) * PWTS( 6,LOOP) +
     X        OLD(NEIGH( 7,LOOP)) * PWTS( 7,LOOP) +
     X        OLD(NEIGH( 8,LOOP)) * PWTS( 8,LOOP) +
     X        OLD(NEIGH( 9,LOOP)) * PWTS( 9,LOOP) +
     X        OLD(NEIGH(10,LOOP)) * PWTS(10,LOOP) +
     X        OLD(NEIGH(11,LOOP)) * PWTS(11,LOOP) +
     X        OLD(NEIGH(12,LOOP)) * PWTS(12,LOOP)
C
          ELSE IF( KSCHEME(LOOP).EQ.JP4PT ) THEN
            NEWFLD(LOOP) =
     X        OLD(NEIGH( 1,LOOP)) * PWTS( 1,LOOP) +
     X        OLD(NEIGH( 2,LOOP)) * PWTS( 2,LOOP) +
     X        OLD(NEIGH( 3,LOOP)) * PWTS( 3,LOOP) +
     X        OLD(NEIGH( 4,LOOP)) * PWTS( 4,LOOP)
C
          ELSE
            DO NEXT = 1, 4  
              IF( NEIGH(NEXT,LOOP).NE.0 )
     X          NEWFLD(LOOP) = OLD(NEIGH(NEXT,LOOP))
            ENDDO
C
          ENDIF
        ENDIF
      ENDDO
C
C     -----------------------------------------------------------------|
C     Section 9.  Return.
C     -----------------------------------------------------------------|
C
  900 CONTINUE
C
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE BUBOX(KSUB,KSUP,KELEM,KWTR,CNAMES,CUNITS,KVALS,VALUES,
     1                 KBOX,KAPP,KLEN,KBOXR,VALS,CBOXN,CBOXU,KERR)
C
C**** *BUBOX*
C
C
C     PURPOSE.
C     --------
C
C
C
C**   INTERFACE.
C     ----------
C
C               *CALL BUBOX(KSUB,KSUP,KELEM,KWTR,CNAMES,CUNITS,KVALS,VALUES,
C                           KBOX,KAPP,KLEN,KBOXR,VALS,CBOXN,CBOXU,KERR)*
C
C        INPUT :
C               *KSUB*    -  SUBSET NUMBER
C               *KSUP*    -  ARRAY CONTAINING SUPLEMENTARY INFORMATION
C                         -  KSUP( 1) -- IDIM1, DIMENSION OF KSEC1
C                         -  KSUP( 2) -- IDIM2, DIMENSION OF KSEC2
C                         -  KSUP( 3) -- IDIM3, DIMENSION OF KSEC3
C                         -  KSUP( 4) -- IDIM4, DIMENSION OF KSEC4
C                         -  KSUP( 5) -- M (NUMBER OF ELEMENTS IN VALUES ARRAY,
C                                           FIRST INDEX)
C                         -  KSUP( 6) -- N (NUMBER OF SUBSETS,SECOND INDEX OF
C                                           VALUES ARRAY)
C                         -  KSUP( 7) -- JVC (NUMBER OF ELEMENTS IN CVAL ARRAY)
C                         -  KSUP( 8) -- TOTAL BUFR MESSAGE LENGTH IN BYTES
C                         -  KSUP( 9) -- IDIM0, DIMENSION OF KSEC0
C               *KELEM*   -  EXPECTED NUMBER OF EXPANDED TABLE B ELEMENTS
C               *KWTR*    -  ARRAY CONTAINING BUFR TABLE B REFERENCE NUMBERS
C               *CNAMES*  -  ARRAY CONTAINING ELEMENT NAMES
C               *CUNITS*  -  ARRAY CONTAINING ELEMENT UNITS
C               *KVALS*   -  DIMENSION OF VALUES ARRAY
C               *VALUES*  -  ARRAY CONTAINING UNPACKED VALUES
C               
C        OUTPUT :
C
C               *KBOX*    -  NUMBER OF ROWS      
C               *KAPP*    -  NUMBER OF COLUMNS
C               *KLEN*    -  OFFSET FOR START OF NEXT COLUMN
C               *KBOXR*   -  ARRAY CONTAINING BUFR TABLE B REFERENCE NUMBERS
C               *VALS*    -  ARRAY CONTAINING UNPACKED VALUES
C               *CBOXN*   -  ARRAY CONTAINING ELEMENT NAMES
C               *CBOXU*   -  ARRAY CONTAINING ELEMENT UNITS
C               *KERR*    -  RETURNED ERROR CODE
C
C     METHOD.
C     -------
C
C
C
C     EXTERNALS.
C     ----------
C
C
C     REFERENCE.
C     ----------
C
C          NONE.
C
C     AUTHOR.
C     -------
C
C          M. DRAGOSAVAC    *ECMWF*       01/02/94.
C
C
C     MODIFICATIONS.
C     --------------
C
C          NONE.
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
C
#     include "parameter.F"
C
#     include "bcomunit.F"
C
      CHARACTER*64 CNAMES(*)
      CHARACTER*24 CUNITS(*)
C
C
      DIMENSION KSUP(9),KWTR(*)
C
      DIMENSION IOPER(100),RPRINT(60)
C
      DIMENSION KBOXR(JWORK)
      DIMENSION IBVAL(JELEM),IBPRINT(60)
      CHARACTER*64 CBOXN(JELEM)
      CHARACTER*24 CBOXU(JELEM)
C
#ifndef R_4
      REAL*8 VALUES(*)
      REAL*8 VALS(JWORK)
      REAL*8 RVIND
      REAL*8 EPS
#else
      REAL   VALUES(*)
      REAL   VALS(JWORK)
      REAL   RVIND
      REAL   EPS
#endif
C     ------------------------------------------------------------------
C
C*          1.  GET ALL ELEMENTS UNTIL FIRST OPERATOR APPEAR.
C               ---------------------------------------------
 100  CONTINUE
C

      IF(KERR.GT.0) RETURN
C
      RVIND=1.7D38
      EPS=10.D-7
      NVIND=2147483647
C
      IF(KELEM.GT.JELEM) THEN
         KERR=47
         CALL BUERR(KERR)
         RETURN
      END IF

C
C     JUST TO KEEP PROGRAM FOR FUTURE MULTY SUBSET BOXING
C
      KSUB1=KSUB
      KSUB2=KSUB
C
      IF(KSUB1.LT.1.OR.KSUB1.GT.KSUP(6)) THEN
         KERR=44
         CALL BUERR(KERR)
         RETURN
      END IF
C
      IF(KSUB1.NE.KSUB2) THEN
         WRITE(KNTN,*) 'ONLY ONE SUBSET AT A TIME',
     1' WILL BE BOXED.'
         KSUB2=KSUB1
      END IF
C
      KBOXR(1)=2147483647
      CBOXN(1)='OPERATOR'
      CBOXU(1)=' '
      KBOXR(2)=2147483647
      CBOXN(2)='GENERATING CENTRE( CODE TABLE 001031)'
      CBOXU(2)='CODE TABLE'
      KBOXR(3)=2147483647
      CBOXN(3)='GENERATING APPLICATION (CODE TABLE 001032)'
      CBOXU(3)='CODE TABLE'
      KBOXR(4)=2147483647
      CBOXN(4)='STATISTICS (008024/008023) '
      CBOXU(4)='CODE TABLE'
      KBOXR(5)=2147483647
      CBOXN(5)='INCREMENTAL UPDATE NUMBER'
      CBOXU(5)='NUMERIC'
      KBOXR(6)=2147483647
      CBOXN(6)='MINIMISATION SIMULATION NUMBER'
      CBOXU(6)='NUMERIC'
C
      MREL=0
      J=0
      DO 103 I=1,KSUP(5)
      IF(KWTR(I).EQ.222000.OR.
     1   KWTR(I).EQ.223000.OR.
     1   KWTR(I).EQ.224000.OR.
     1   KWTR(I).EQ.225000.OR.
     1   KWTR(I).EQ.235000.OR.
     1   KWTR(I).EQ.237255.OR.
     1   KWTR(I).EQ.232000) THEN
         J=J+1
         IOPER(J)=I
      END IF
 103  CONTINUE
C
      NOPER=J
C
      IOPER(J+1)=KSUP(5)
C
      NOPP1=NOPER+1
      INI=IOPER(1)*8+20
      IF(INI*NOPP1.GT.JWORK) THEN
         KERR=47
         WRITE(KNTN,*) 'TOO MANY DATA FOR BOXING.'
         RETURN
      END IF
C
      DO 105 I=1,INI*NOPP1
      VALS(I)=RVIND
      KBOXR(I)=NVIND
 105  CONTINUE
C
      IF(NOPER.EQ.0) THEN
         KAPP =1                            ! NUMBER OF APPLICATIONS
         KAPPL=1
         KLEN=KELEM
         J=6
         DO 101 I=1,KSUP(5)
         J=J+1
         KBOXR(J)=KWTR(I)
         CBOXN(J)=CNAMES(I)
         CBOXU(J)=CUNITS(I)
         DO 191 KK=KSUB1,KSUB2
         JJ=I+(KK-1)*KELEM                     ! POINTER TO VALUES ARRAY
         IP=J  !+(KAPP-1)*KLEN  ! +(KK-1)*KAPPL*KLEN ! POINTER TO VALS ARRAY
         VALS (IP)=VALUES(JJ)
 191     CONTINUE
 101     CONTINUE
C
         KBOX=J                             ! TOTAL NUMBER OF ELEMENTS
         MREL=J
         GO TO 2000
      END IF
C
      O236=.FALSE.
C
      LFIRST=1
      J=6
C
C
      LAST=IOPER(1)-1
      IF(MREL.EQ.0) MREL=LAST+6
      KLEN=LAST*8+20
C
 102  CONTINUE
C
C*          1.1 MOVE ELEMENTS FROM LFIRST TO LAST INTO BOX.
C               -------------------------------------------
 110  CONTINUE
C
      KAPP =1                            ! NUMBER OF APPLICATIONS
      KAPPL=60
      DO 111 I=LFIRST,LAST
      J=J+1
      KBOXR(J)=KWTR(I)
      CBOXN(J)=CNAMES(I)
      CBOXU(J)=CUNITS(I)
      DO 192 KK=KSUB1,KSUB2
      JJ=I+(KK-1)*KELEM
      IP=J ! +(KAPP-1)*KLEN   ! +(KK-1)*KAPPL*KLEN
      VALS (IP)=VALUES(JJ)
 192  CONTINUE
 111  CONTINUE
C
      KBOX=J                             ! TOTAL NUMBER OF ELEMENTS
C
      DO 1000 LL=1,NOPER
C
      K=IOPER(LL)
C
      IF(KWTR(K).EQ.235000) THEN
         MREL=0
         K=K+1
C
         KL=IOPER(LL+1)-1
         DO 112 I=K,KL
         J=J+1
         KBOXR(J)=KWTR(I)
         CBOXN(J)=CNAMES(I)
         CBOXU(J)=CUNITS(I)
         DO 190 KK=KSUB1,KSUB2
         JJ=I+(KK-1)*KELEM
         IP=J  !+(KAPP-1)*KLEN              ! +(KK-1)*KAPPL*KLEN
         VALS (IP)=VALUES(JJ)
 190     CONTINUE
 112     CONTINUE
         GO TO 1000
      END IF
      IF(KWTR(K).EQ.222000) THEN
         K=K+1
         IMARK=222000
         IF(MREL.EQ.0) MREL=J
         GO TO 119
      END IF
      IF(KWTR(K).EQ.223000) THEN
         K=K+1
         IMARK=223000
         IF(MREL.EQ.0) MREL=J
         GO TO 119
      END IF
      IF(KWTR(K).EQ.224000) THEN
         K=K+1
         IMARK=224000
         IF(MREL.EQ.0) MREL=J
         GO TO 119
      END IF
      IF(KWTR(K).EQ.225000) THEN
         K=K+1
         IMARK=225000
         IF(MREL.EQ.0) MREL=J
         GO TO 119
      END IF
      IF(KWTR(K).EQ.232000) THEN
         K=K+1
         IMARK=232000
         IF(MREL.EQ.0) MREL=J
      END IF
C
 119  CONTINUE
C
C     CHECK IF NEXT ELEMENT IS OPERATOR
C
      IF(KWTR(K).EQ.236000) THEN
         O236=.TRUE.
         K=K+1
      END IF
C
      IF(KWTR(K).EQ.237000) THEN
         K=K+1
         GO TO 120
      END IF
C
      IF(KWTR(K).EQ.237255) THEN
         O236=.FALSE.
         K=K+1
         GO TO 1000
      END IF
C
C     SKIP IF DELAYED REPLICATION FACTOR FOLLOW
C
      IF(KWTR(K).EQ.31002.OR.KWTR(K).EQ.31001.OR.
     1   KWTR(K).EQ.31000) K=K+1
C
C     NEXT ELEMENT MUST BE DATA PRESENT INDICATOR
C
      IF(KWTR(K).NE.31031.AND.KWTR(K).NE.31192) THEN
         KERR=42
         CALL BUERR(KERR)
         WRITE(KNTN,*) 'ELEMENT ',K,' MUST BE',
     1' DATA PRESENT INDICATOR.'
         RETURN
      END IF
C
C     COUNT NUMBER OF DATA PRESENT INDICATORS
C
C     IBITS - POINTER TO THE FIRST DATA PRESENT INDICATOR
C     IDPI  - NUMBER OF DATA PRESENT INDICATORS
C
      IBITS=K
      IDPI=0
      DO 113 I=K,IOPER(LL+1)
      IF(KWTR(I).EQ.31031) THEN
         IDPI=IDPI+1 
      ELSE
         GO TO 114
      END IF
 113  CONTINUE
C
      KERR=43
      CALL BUERR(KERR)
      RETURN
C
 114  CONTINUE
C
C     RESET CURRENT POINTER
C
      K=I
C
C     GET BIT MAP FROM VALUES
C
      IBP=IBITS-1
      DO 115 I=1,IDPI
      IBP=IBP+1
      IF(ABS(VALUES(IBP)-RVIND)/RVIND.LT.EPS) THEN
         IBVAL(I)=NVIND
      ELSE 
         IBVAL(I)=VALUES(IBP)
      END IF
 115  CONTINUE
C
C
 120  CONTINUE
C
C     NEXT 3 ELEMENTS MUST BE GENERATING CENTRE AND APPLICATION 
C     AND CLASS 8 ELEMENT.
C
      KAPP=KAPP+1
      IF(KAPP.GT.60) THEN
         WRITE(KNTN,*) 'THERE IS MORE THAN 60 APPLICATIONS',
     1' IN THE DATA.'
         RETURN
      END IF
      IF(KWTR(K).EQ.1031.OR.KWTR(K).EQ.1033) THEN
         KP=(KAPP-1)*KLEN
         KP1=KP+1
         KBOXR(KP1)=IMARK
C         CBOXN(KP1)=' '
C         CBOXU(KP1)=' '
         DO 194 KK=KSUB1,KSUB2
         IP=1+(KAPP-1)*KLEN             ! +(KK-1)*KAPPL*KLEN
         VALS(IP)=IMARK
 194     CONTINUE
         KP2=KP+2
         KBOXR(KP2)=KWTR(K)
C         CBOXN(KP2)=CNAMES(K)
C         CBOXU(KP2)=CUNITS(K)
         DO 195 KK=KSUB1,KSUB2
         JJ=K+(KK-1)*KELEM
         IP=2+(KAPP-1)*KLEN             ! +(KK-1)*KAPPL*KLEN
         VALS(IP)=VALUES(JJ)  
 195     CONTINUE
         K=K+1
      END IF
      IF(KWTR(K).EQ.1032.OR.KWTR(K).EQ.1201.OR.KWTR(K).EQ.63191) THEN
         KP=(KAPP-1)*KLEN
         KP3=KP+3
         KBOXR(KP3)=KWTR(K)
C         CBOXN(KP3)=CNAMES(K)
C         CBOXU(KP3)=CUNITS(K)
         DO 196 KK=KSUB1,KSUB2
         JJ=K+(KK-1)*KELEM
         IP=3+(KAPP-1)*KLEN             ! +(KK-1)*KAPPL*KLEN
         VALS(IP)=VALUES(JJ)
 196     CONTINUE
         K=K+1
      END IF
      IF(KWTR(K)/1000.EQ.8) THEN
         KP=(KAPP-1)*KLEN
         KP4=KP+4
         KBOXR(KP4)=KWTR(K)
C         CBOXN(KP4)=CNAMES(K)
C         CBOXU(KP4)=CUNITS(K)
         DO 197 KK=KSUB1,KSUB2
         JJ=K+(KK-1)*KELEM
         IP=4+(KAPP-1)*KLEN             !  +(KK-1)*KAPPL*KLEN
         VALS(IP)=VALUES(JJ)
 197     CONTINUE
         K=K+1
      END IF
      IF(KWTR(K).EQ.33210) THEN
         KP=(KAPP-1)*KLEN
         KP5=KP+5
         KBOXR(KP5)=KWTR(K)
C         CBOXN(KP5)=CNAMES(K)
C         CBOXU(KP5)=CUNITS(K)
         DO 201 KK=KSUB1,KSUB2
         JJ=K+(KK-1)*KELEM
         IP=5+(KAPP-1)*KLEN             !  +(KK-1)*KAPPL*KLEN
         VALS(IP)=VALUES(JJ)
 201     CONTINUE
         K=K+1
      END IF
      IF(KWTR(K).EQ.33211) THEN
         KP=(KAPP-1)*KLEN
         KP6=KP+6
         KBOXR(KP6)=KWTR(K)
C         CBOXN(KP6)=CNAMES(K)
C         CBOXU(KP6)=CUNITS(K)
         DO 202 KK=KSUB1,KSUB2
         JJ=K+(KK-1)*KELEM
         IP=6+(KAPP-1)*KLEN             !  +(KK-1)*KAPPL*KLEN
         VALS(IP)=VALUES(JJ)
 202     CONTINUE
         K=K+1
      END IF
C
C     NEXT ELEMENT CAN BE DELAYED/EXTENDED DELAYED REPLICATION
C     SKIP IT
C
      IF(KWTR(K).EQ.31002.OR.KWTR(K).EQ.31001.OR.
     1   KWTR(K).EQ.31000) K=K+1
C
C
C     MOVE CORESPONDING QUALITY CONTROL INTO BOX
C
      KQ=MREL-IDPI+1
      KAPPK=(KAPP-1)*KLEN  
      DO 121 I=1,IDPI
      IF(IBVAL(I).NE.0) THEN
         KKQ=KQ+KAPPK
         VALS(KKQ)=RVIND 
         KQ=KQ+1
      ELSE
         KKQ=KQ+KAPPK
         KBOXR(KKQ)=KWTR(K)
C         CBOXN(KKQ)=CNAMES(K)
C         CBOXU(KKQ)=CUNITS(K)
         DO 198 KK=KSUB1,KSUB2
         JJ=K+(KK-1)*KELEM                ! +(KK-1)*KAPPL*KLEN
         VALS(KKQ)=VALUES(JJ)
 198     CONTINUE
         K=K+1 
         KQ=KQ+1
      END IF
 121  CONTINUE
C
C     CHECK IF SOME NEW DATA FOLLOW.
C
      IF(K.LT.IOPER(LL+1)-1) THEN
C
C        MOVE THESE ELEMENTS INTO BOX
C
         IF(KWTR(IOPER(LL+1)).GT.200000.AND.
     1      KWTR(IOPER(LL+1)).NE.999999) THEN
            ILL=IOPER(LL+1)-1
         ELSE
            ILL=IOPER(LL+1)
         END IF
         DO 122 I=K,ILL
         J=J+1
         KBOXR(J)=KWTR(I)
         CBOXN(J)=CNAMES(I)
         CBOXU(J)=CUNITS(I)
         DO 199 KK=KSUB1,KSUB2
         JJ=I+(KK-1)*KELEM
         IP=J   !+(KAPP-1)*KLEN              !  +(KK-1)*KAPPL*KLEN
         VALS(IP)=VALUES(JJ)
 199     CONTINUE
 122     CONTINUE
         KBOX=J
      END IF
C
 1000 CONTINUE
C
 2000 CONTINUE
C
      KBOX=J
      IF(KBOX.LE.6) KBOX=0
C
      RETURN
      END

c Copyright 1981-2012 ECMWF.
c
c This software is licensed under the terms of the Apache Licence 
c Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
c
c In applying this licence, ECMWF does not waive the privileges and immunities 
c granted to it by virtue of its status as an intergovernmental organisation 
c nor does it submit to any jurisdiction.
c

      subroutine gpfa3(a,b,trigs,inc,jump,n,mm,lot,isign)
*     fortran version of *gpfa3* -
*     radix-3 section of self-sorting, in-place
*        generalized PFA
*
*-------------------------------------------------------------------
*
      dimension a(*), b(*), trigs(*)
      data sin60/0.866025403784437/
      data lvr/128/
*
*     ***************************************************************
*     *                                                             *
*     *  N.B. LVR = LENGTH OF VECTOR REGISTERS, SET TO 128 FOR C90. *
*     *  RESET TO 64 FOR OTHER CRAY MACHINES, OR TO ANY LARGE VALUE *
*     *  (GREATER THAN OR EQUAL TO LOT) FOR A SCALAR COMPUTER.      *
*     *                                                             *
*     ***************************************************************
*
      n3 = 3**mm
      inq = n/n3
      jstepx = (n3-n) * inc
      ninc = n * inc
      ink = inc * inq
      mu = mod(inq,3)
      if (isign.eq.-1) mu = 3-mu
      m = mm
      mh = (m+1)/2
      s = float(isign)
      c1 = sin60
      if (mu.eq.2) c1 = -c1
*
      nblox = 1 + (lot-1)/lvr
      left = lot
      s = float(isign)
      istart = 1
*
*  loop on blocks of lvr transforms
*  --------------------------------
      do 500 nb = 1 , nblox
*
      if (left.le.lvr) then
         nvex = left
      else if (left.lt.(2*lvr)) then
         nvex = left/2
         nvex = nvex + mod(nvex,2)
      else
         nvex = lvr
      endif
      left = left - nvex
*
      la = 1
*
*  loop on type I radix-3 passes
*  -----------------------------
      do 160 ipass = 1 , mh
      jstep = (n*inc) / (3*la)
      jstepl = jstep - ninc
*
*  k = 0 loop (no twiddle factors)
*  -------------------------------
      do 120 jjj = 0 , (n-1)*inc , 3*jstep
      ja = istart + jjj
*
*  "transverse" loop
*  -----------------
      do 115 nu = 1 , inq
      jb = ja + jstepl
      if (jb.lt.istart) jb = jb + ninc
      jc = jb + jstepl
      if (jc.lt.istart) jc = jc + ninc
      j = 0
*
*  loop across transforms
*  ----------------------
cdir$ ivdep, shortloop
      do 110 l = 1 , nvex
      t1 = a(jb+j) + a(jc+j)
      t2 = a(ja+j) - 0.5 * t1
      t3 = c1 * ( a(jb+j) - a(jc+j) )
      u1 = b(jb+j) + b(jc+j)
      u2 = b(ja+j) - 0.5 * u1
      u3 = c1 * ( b(jb+j) - b(jc+j) )
      a(ja+j) = a(ja+j) + t1
      b(ja+j) = b(ja+j) + u1
      a(jb+j) = t2 - u3
      b(jb+j) = u2 + t3
      a(jc+j) = t2 + u3
      b(jc+j) = u2 - t3
      j = j + jump
  110 continue
      ja = ja + jstepx
      if (ja.lt.istart) ja = ja + ninc
  115 continue
  120 continue
*
*  finished if n3 = 3
*  ------------------
      if (n3.eq.3) go to 490
      kk = 2 * la
*
*  loop on nonzero k
*  -----------------
      do 150 k = ink , jstep-ink , ink
      co1 = trigs(kk+1)
      si1 = s*trigs(kk+2)
      co2 = trigs(2*kk+1)
      si2 = s*trigs(2*kk+2)
*
*  loop along transform
*  --------------------
      do 140 jjj = k , (n-1)*inc , 3*jstep
      ja = istart + jjj
*
*  "transverse" loop
*  -----------------
      do 135 nu = 1 , inq
      jb = ja + jstepl
      if (jb.lt.istart) jb = jb + ninc
      jc = jb + jstepl
      if (jc.lt.istart) jc = jc + ninc
      j = 0
*
*  loop across transforms
*  ----------------------
cdir$ ivdep,shortloop
      do 130 l = 1 , nvex
      t1 = a(jb+j) + a(jc+j)
      t2 = a(ja+j) - 0.5 * t1
      t3 = c1 * ( a(jb+j) - a(jc+j) )
      u1 = b(jb+j) + b(jc+j)
      u2 = b(ja+j) - 0.5 * u1
      u3 = c1 * ( b(jb+j) - b(jc+j) )
      a(ja+j) = a(ja+j) + t1
      b(ja+j) = b(ja+j) + u1
      a(jb+j) = co1*(t2-u3) - si1*(u2+t3)
      b(jb+j) = si1*(t2-u3) + co1*(u2+t3)
      a(jc+j) = co2*(t2+u3) - si2*(u2-t3)
      b(jc+j) = si2*(t2+u3) + co2*(u2-t3)
      j = j + jump
  130 continue
*-----( end of loop across transforms )
      ja = ja + jstepx
      if (ja.lt.istart) ja = ja + ninc
  135 continue
  140 continue
*-----( end of loop along transforms )
      kk = kk + 2*la
  150 continue
*-----( end of loop on nonzero k )
      la = 3*la
  160 continue
*-----( end of loop on type I radix-3 passes)
*
*  loop on type II radix-3 passes
*  ------------------------------
  400 continue
*
      do 480 ipass = mh+1 , m
      jstep = (n*inc) / (3*la)
      jstepl = jstep - ninc
      laincl = la*ink - ninc
*
*  k=0 loop (no twiddle factors)
*  -----------------------------
      do 430 ll = 0 , (la-1)*ink , 3*jstep
*
      do 420 jjj = ll , (n-1)*inc , 3*la*ink
      ja = istart + jjj
*
*  "transverse" loop
*  -----------------
      do 415 nu = 1 , inq
      jb = ja + jstepl
      if (jb.lt.istart) jb = jb + ninc
      jc = jb + jstepl
      if (jc.lt.istart) jc = jc + ninc
      jd = ja + laincl
      if (jd.lt.istart) jd = jd + ninc
      je = jd + jstepl
      if (je.lt.istart) je = je + ninc
      jf = je + jstepl
      if (jf.lt.istart) jf = jf + ninc
      jg = jd + laincl
      if (jg.lt.istart) jg = jg + ninc
      jh = jg + jstepl
      if (jh.lt.istart) jh = jh + ninc
      ji = jh + jstepl
      if (ji.lt.istart) ji = ji + ninc
      j = 0
*
*  loop across transforms
*  ----------------------
cdir$ ivdep, shortloop
      do 410 l = 1 , nvex
      t1 = a(jb+j) + a(jc+j)
      t2 = a(ja+j) - 0.5 * t1
      t3 = c1 * ( a(jb+j) - a(jc+j) )
      a(jb+j) = a(jd+j)
      u1 = b(jb+j) + b(jc+j)
      u2 = b(ja+j) - 0.5 * u1
      u3 = c1 * ( b(jb+j) - b(jc+j) )
      b(jb+j) = b(jd+j)
      a(ja+j) = a(ja+j) + t1
      b(ja+j) = b(ja+j) + u1
      a(jd+j) = t2 - u3
      b(jd+j) = u2 + t3
      a(jc+j) = t2 + u3
      b(jc+j) = u2 - t3
*----------------------
      t1 = a(je+j) + a(jf+j)
      t2 = a(jb+j) - 0.5 * t1
      t3 = c1 * ( a(je+j) - a(jf+j) )
      a(jf+j) = a(jh+j)
      u1 = b(je+j) + b(jf+j)
      u2 = b(jb+j) - 0.5 * u1
      u3 = c1 * ( b(je+j) - b(jf+j) )
      b(jf+j) = b(jh+j)
      a(jb+j) = a(jb+j) + t1
      b(jb+j) = b(jb+j) + u1
      a(je+j) = t2 - u3
      b(je+j) = u2 + t3
      a(jh+j) = t2 + u3
      b(jh+j) = u2 - t3
*----------------------
      t1 = a(jf+j) + a(ji+j)
      t2 = a(jg+j) - 0.5 * t1
      t3 = c1 * ( a(jf+j) - a(ji+j) )
      t1 = a(jg+j) + t1
      a(jg+j) = a(jc+j)
      u1 = b(jf+j) + b(ji+j)
      u2 = b(jg+j) - 0.5 * u1
      u3 = c1 * ( b(jf+j) - b(ji+j) )
      u1 = b(jg+j) + u1
      b(jg+j) = b(jc+j)
      a(jc+j) = t1
      b(jc+j) = u1
      a(jf+j) = t2 - u3
      b(jf+j) = u2 + t3
      a(ji+j) = t2 + u3
      b(ji+j) = u2 - t3
      j = j + jump
  410 continue
*-----( end of loop across transforms )
      ja = ja + jstepx
      if (ja.lt.istart) ja = ja + ninc
  415 continue
  420 continue
  430 continue
*-----( end of double loop for k=0 )
*
*  finished if last pass
*  ---------------------
      if (ipass.eq.m) go to 490
*
      kk = 2*la
*
*     loop on nonzero k
*     -----------------
      do 470 k = ink , jstep-ink , ink
      co1 = trigs(kk+1)
      si1 = s*trigs(kk+2)
      co2 = trigs(2*kk+1)
      si2 = s*trigs(2*kk+2)
*
*  double loop along first transform in block
*  ------------------------------------------
      do 460 ll = k , (la-1)*ink , 3*jstep
*
      do 450 jjj = ll , (n-1)*inc , 3*la*ink
      ja = istart + jjj
*
*  "transverse" loop
*  -----------------
      do 445 nu = 1 , inq
      jb = ja + jstepl
      if (jb.lt.istart) jb = jb + ninc
      jc = jb + jstepl
      if (jc.lt.istart) jc = jc + ninc
      jd = ja + laincl
      if (jd.lt.istart) jd = jd + ninc
      je = jd + jstepl
      if (je.lt.istart) je = je + ninc
      jf = je + jstepl
      if (jf.lt.istart) jf = jf + ninc
      jg = jd + laincl
      if (jg.lt.istart) jg = jg + ninc
      jh = jg + jstepl
      if (jh.lt.istart) jh = jh + ninc
      ji = jh + jstepl
      if (ji.lt.istart) ji = ji + ninc
      j = 0
*
*  loop across transforms
*  ----------------------
cdir$ ivdep, shortloop
      do 440 l = 1 , nvex
      t1 = a(jb+j) + a(jc+j)
      t2 = a(ja+j) - 0.5 * t1
      t3 = c1 * ( a(jb+j) - a(jc+j) )
      a(jb+j) = a(jd+j)
      u1 = b(jb+j) + b(jc+j)
      u2 = b(ja+j) - 0.5 * u1
      u3 = c1 * ( b(jb+j) - b(jc+j) )
      b(jb+j) = b(jd+j)
      a(ja+j) = a(ja+j) + t1
      b(ja+j) = b(ja+j) + u1
      a(jd+j) = co1*(t2-u3) - si1*(u2+t3)
      b(jd+j) = si1*(t2-u3) + co1*(u2+t3)
      a(jc+j) = co2*(t2+u3) - si2*(u2-t3)
      b(jc+j) = si2*(t2+u3) + co2*(u2-t3)
*----------------------
      t1 = a(je+j) + a(jf+j)
      t2 = a(jb+j) - 0.5 * t1
      t3 = c1 * ( a(je+j) - a(jf+j) )
      a(jf+j) = a(jh+j)
      u1 = b(je+j) + b(jf+j)
      u2 = b(jb+j) - 0.5 * u1
      u3 = c1 * ( b(je+j) - b(jf+j) )
      b(jf+j) = b(jh+j)
      a(jb+j) = a(jb+j) + t1
      b(jb+j) = b(jb+j) + u1
      a(je+j) = co1*(t2-u3) - si1*(u2+t3)
      b(je+j) = si1*(t2-u3) + co1*(u2+t3)
      a(jh+j) = co2*(t2+u3) - si2*(u2-t3)
      b(jh+j) = si2*(t2+u3) + co2*(u2-t3)
*----------------------
      t1 = a(jf+j) + a(ji+j)
      t2 = a(jg+j) - 0.5 * t1
      t3 = c1 * ( a(jf+j) - a(ji+j) )
      t1 = a(jg+j) + t1
      a(jg+j) = a(jc+j)
      u1 = b(jf+j) + b(ji+j)
      u2 = b(jg+j) - 0.5 * u1
      u3 = c1 * ( b(jf+j) - b(ji+j) )
      u1 = b(jg+j) + u1
      b(jg+j) = b(jc+j)
      a(jc+j) = t1
      b(jc+j) = u1
      a(jf+j) = co1*(t2-u3) - si1*(u2+t3)
      b(jf+j) = si1*(t2-u3) + co1*(u2+t3)
      a(ji+j) = co2*(t2+u3) - si2*(u2-t3)
      b(ji+j) = si2*(t2+u3) + co2*(u2-t3)
      j = j + jump
  440 continue
*-----(end of loop across transforms)
      ja = ja + jstepx
      if (ja.lt.istart) ja = ja + ninc
  445 continue
  450 continue
  460 continue
*-----( end of double loop for this k )
      kk = kk + 2*la
  470 continue
*-----( end of loop over values of k )
      la = 3*la
  480 continue
*-----( end of loop on type II radix-3 passes )
*-----( nvex transforms completed)
  490 continue
      istart = istart + nvex * jump
  500 continue
*-----( end of loop on blocks of transforms )
*
      return
      end

C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE SET99(TRIGS,IFAX,N)
      DIMENSION TRIGS(N),IFAX(10),JFAX(10),LFAX(7)
C---->
C
C     SUBROUTINE 'SET99' - COMPUTES FACTORS OF N & TRIGONOMETRIC
C     FUNCTIONS REQUIRED BY FFT99 & FFT991
C
C----<
#include "jparams.h"
C
      DATA LFAX/6,8,5,4,3,2,1/
      IXXX=1
C
      DEL= (2.0*PPI)/FLOAT(N)
      NIL=0
      NHL=(N/2)-1
      DO 10 K=NIL,NHL
      ANGLE=FLOAT(K)*DEL
      TRIGS(2*K+1)=COS(ANGLE)
      TRIGS(2*K+2)=SIN(ANGLE)
   10 CONTINUE
C
C     FIND FACTORS OF N (8,6,5,4,3,2; ONLY ONE 8 ALLOWED)
C     LOOK FOR SIXES FIRST, STORE FACTORS IN DESCENDING ORDER
      NU=N
      IFAC=6
      K=0
      L=1
   20 CONTINUE
      IF (MOD(NU,IFAC).NE.0) GO TO 30
      K=K+1
      JFAX(K)=IFAC
      IF (IFAC.NE.8) GO TO 25
      IF (K.EQ.1) GO TO 25
      JFAX(1)=8
      JFAX(K)=6
   25 CONTINUE
      NU=NU/IFAC
      IF (NU.EQ.1) GO TO 50
      IF (IFAC.NE.8) GO TO 20
   30 CONTINUE
      L=L+1
      IFAC=LFAX(L)
      IF (IFAC.GT.1) GO TO 20
C
      WRITE(6,40) N
   40 FORMAT(4H1N =,I4,27H - CONTAINS ILLEGAL FACTORS)
      RETURN
C
C     NOW REVERSE ORDER OF FACTORS
   50 CONTINUE
      NFAX=K
      IFAX(1)=NFAX
      DO 60 I=1,NFAX
      IFAX(NFAX+2-I)=JFAX(I)
   60 CONTINUE
      IFAX(10)=N
      RETURN
      END

C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE GRCHK4 (KSEC1,KSEC4,PSEC4,KRET)
C
C---->
C**** GRCHK4 - Check parameters for Section 4 of GRIB Code.
C
C     Purpose.
C     --------
C
C           Check parameters for Section 4 of GRIB code against
C           valid values for GRIB Edition 1.
C
C**   Interface.
C     ----------
C
C           CALL GRCHK4 (KSEC1,KSEC4,PSEC4,KRET)
C
C           Integer    K.
C           Real       P.
C           Logical    O.
C           Character  H.
C
C               Input Parameters.
C               -----------------
C
C               KSEC1      - Array containing integer parameters for
C                            section 1 of GRIB code.
C
C               KSEC4      - Array containing integer parameters for
C                            section 4 of GRIB code.
C
C               PSEC4      - Array containing real parameters for
C                            section 4 of GRIB code.
C
C               Output Parameters.
C               ------------------
C
C               KRET       - Return code.
C                            0   , No error encountered.
C                            1   , Error in GRIB Code parameter.
C
C     Method.
C     -------
C
C           Values checked against current code/flag tables
C           and against maximum or minimum permitted values.
C           They are also checked against the current status
C           of the implementation of GRIBEX.
C
C     Externals.
C     ----------
C
C           None.
C
C     Reference.
C     ----------
C
C           WMO Manual on Codes for GRIB Code.
C
C     Comments.
C     ---------
C
C           Routine contains Sections 0 to 2 and Section 9.
C
C     Author.
C     -------
C
C           J. Hennessy      ECMWF      18.06.91
C
C     Modifications.
C     --------------
C
C           J. Hennessy      ECMWF      01.10.91
C           Additional parameters KSEC1 and PSEC4 added.
C
C           J. Hennessy      ECMWF      17.07.92
C           Additional flag and matrix of values checks added.
C
C           J.D.Chambers     ECMWF      27.04.94
C           Allow complex packing for spherical harmonics
C
C           J. Clochard, Meteo France, for ECMWF - January 1998.
C           Take into account second-order packing for grid-point data.
C           Revised printouts.
C
C----<
C     ----------------------------------------------------------------
C*    Section 0 . Definition of variables. Data statements.
C     ----------------------------------------------------------------
C
C
      IMPLICIT NONE
C
#include "grprs.h"
C
      INTEGER KRET
      INTEGER KSEC1
      INTEGER KSEC4
C
      REAL    PSEC4
C
      DIMENSION KSEC1(*)
      DIMENSION KSEC4(*)
C
      DIMENSION PSEC4(*)
C
C     ----------------------------------------------------------------
C*    Section 1 . Set initial values.
C     ----------------------------------------------------------------
C
  100 CONTINUE
C
C     Reset return code.
      KRET = 0
C
C     ----------------------------------------------------------------
C*    Section 2 . Check values against code tables and extreme values.
C     ----------------------------------------------------------------
C
  200 CONTINUE
C
C*    Check number of values to be encoded.
      IF (KSEC4(1).EQ.0) THEN
        KRET = 1
        WRITE(GRPRSM,*)
     X    'GRCHK4: Invalid number of data values to be encoded'
     X    , KSEC4(1)
      ENDIF
C
C*    Check number of bits per data value.
      IF (KSEC4(2).LT.1.OR.KSEC4(2).GT.32) THEN
        KRET = 1
        WRITE(GRPRSM,*)
     X     'GRCHK4: Invalid number of bits for packed data values'
     X    , KSEC4(2)
      ENDIF
C
C*    Check on type of data (grid or spherical harmonics).
      IF ( KSEC4(3).NE.0 .AND. KSEC4(3).NE.128 ) THEN
        WRITE(GRPRSM,*) 'GRCHK4: Invalid type of data', KSEC4(3)
      ENDIF
C
C*    Check type of packing.
      IF ( KSEC4(4).NE.0 .AND. KSEC4(4).NE.64 ) THEN
        KRET = 1
        WRITE(GRPRSM,*) 'GRCHK4: Invalid type of packing', KSEC4(4)
      ENDIF
C
C*    Check data representation.
      IF (KSEC4(5).NE.0.AND.KSEC4(5).NE.32) THEN
        KRET = 1
        WRITE(GRPRSM,*) 'GRCHK4: Invalid data representation', KSEC4(5)
      ENDIF
C
C*    Check additional flag field.
      IF (KSEC4(6).NE.0.AND.KSEC4(6).NE.16) THEN
        KRET = 1
        WRITE(GRPRSM,*)
     X    'GRCHK4: Invalid additional flag field', KSEC4(6)
      ENDIF
C
C*    Check reserved field.
      IF (KSEC4(7).NE.0) THEN
        WRITE(GRPRSM,*)
     X    'GRCHK4: Reserved field not 0. May cause trouble'
        WRITE(GRPRSM,*) 'GRCHK4: in future releases of GRIBEX.'
      ENDIF
C
C*    Check number of values indicator.
      IF (KSEC4(8).NE.0.AND.KSEC4(8).NE.64) THEN
        KRET = 1
        WRITE(GRPRSM,*) 'GRCHK4: Invalid number of fields indicator'
     X    , KSEC4(8)
      ENDIF
C
C*    Check secondary bit maps indicator.
      IF (KSEC4(9).NE.0.AND.KSEC4(9).NE.32) THEN
        KRET = 1
        WRITE(GRPRSM,*) 'GRCHK4: Invalid secondary bit map indicator'
     X    , KSEC4(9)
      ENDIF
C
C*    Check value widths indicator.
      IF (KSEC4(6).EQ.16.AND.KSEC4(10).NE.0.AND.KSEC4(10).NE.16) THEN
        KRET = 1
        WRITE(GRPRSM,*) 'GRCHK4: Invalid value widths', KSEC4(10)
      ENDIF
C
C*    Tests specific to second-order packing.
C
      IF (KSEC4(3).EQ.0.AND.KSEC4(4).EQ.64) THEN
C
C*    Check constant width.
        IF (KSEC4(10).EQ.0.AND.(ABS(KSEC4(11)).GE.KSEC4(2))) THEN
          KRET = 1
          WRITE(GRPRSM,9011) KSEC4(11), KSEC4(2)-1
        ENDIF
C
C*    Check general extended 2nd-order packing indicator.
        IF (KSEC4(12).NE.0.AND.KSEC4(12).NE.8) THEN
          KRET = 1
          WRITE(GRPRSM,*)
     X     'GRCHK4: Invalid general extended 2n-order packing indicator'
     X      , KSEC4(12)
        ENDIF
C
C*    Check boustrophedonic ordering indicator.
        IF (KSEC4(13).NE.0.AND.KSEC4(13).NE.4) THEN
          KRET = 1
          WRITE(GRPRSM,*)
     X     'GRCHK4: Invalid boustrophedonic ordering indicator'
     X      , KSEC4(13)
        ENDIF
C
C*    Check spatial differencing indicator.
        IF (KSEC4(14).NE.0.AND.KSEC4(14).NE.2) THEN
          KRET = 1
          WRITE(GRPRSM,*)
     X    'GRCHK4: Invalid spatial differencing indicator'
     X      , KSEC4(14)
        ENDIF
C
      ENDIF
C
C     ----------------------------------------------------------------
C*    Section 9 . Return to calling routine.
C     ----------------------------------------------------------------
C
  900 CONTINUE
C
 9011 FORMAT (TR1,'GRCHK4 : Second-order packing with constant width ',
     C        'option:',/,TR10,'Constant width value',I3,
     C        ' not in range [-/+',I2,'(=KSEC4(2)-1)].')
C
      RETURN
C
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      INTEGER FUNCTION IRPREC (PIFELD, KSTART, KINS, POFELD, KOWE,
     1   KONS, KWEIND, KNSIND, PWFACT, PMAX, PINPNT, KPR, KERR)
C
C---->
C**** *IRPREC*
C
C     PURPOSE
C     _______
C
C     Perform additional interpolation processes for precipitation
C     fields when the input field is quasi regular.
C
C     INTERFACE
C     _________
C
C     IERR = IRPREC (PIFELD, KSTART, KINS, POFELD, KOWE, KONS,
C    1   KWEIND, KNSIND, PWFACT, PMAX, PINPNT, KPR, KERR)
C
C     Input parameters
C     ________________
C
C     PIFELD     - The input field provided by the calling routine.
C
C     KSTART     - The array offset for each line of latitude within
C                  the quasi regular field.
C
C     KINS       - The number of points in the North-South direction
C                  in the input field.
C
C     POFELD     - The output field as previously calculated.
C
C     KOWE       - The number of points in the West-East direction in
C                  the output field.
C
C     KONS       - The number of points in the North-South direction
C                  in the output field.
C
C     KWEIND     - This array contains the array offsets of the West
C                  and East points in the input array required for
C                  interpolation.
C
C     KNSIND     - This array contains the array offsets of the North
C                  and South points in the input array required for
C                  interpolation.
C
C     PWFACT     - The array of interpolating weights to the four
C                  neighbouring points for every output point.
C
C     PMAX       - Work array used to aid vectorisation.
C
C     PINPNT     - Work array used to aid vectorisation.
C
C     KPR        - The debug print switch.
C                  0  , No debugging output.
C                  1  , Produce debugging output.
C
C     KERR       - The error control flag.
C                  -ve, No error message. Return error code.
C                  0  , Hard failure with error message.
C                  +ve, Print error message. Return error code.
C
C     Output parameters
C     ________________
C
C     POFELD     - The output field as modified to allow for
C                  precipitation.
C
C     Return value
C     ____________
C
C     The error indicator (INTEGER).
C
C     Error and Warning Return Values
C     _______________________________
C
C     None
C
C     Common block usage
C     __________________
C
C     None
C
C     EXTERNALS
C     _________
C
C     INTLOG(R)    - Logs messages.
C     CHKPREC - Check if precipitation threshold has been redefined
C
C     METHOD
C     ______
C
C     The precipitation at a point is set to zero in the following
C     circumstances.
C
C     1  The interpolated precipitation is less than a threshold value.
C
C     2  There is no precipitation at the neighbouring point with the
C        highest interpolating weight.
C
C     NOTE that this operation is performed before the special
C     routines for the poles when interpolating from quasi regular
C     Gaussian grids to global latitude/longitude fields. The polar
C     values for precipitation, during such interpolations, will
C     always be the average value of the nearest Gaussian line with
C     no threshold check.
C
C     REFERENCE
C     _________
C
C     None
C
C     COMMENTS
C     ________
C
C     Program contains sections 0 to 3 and 9
C
C     AUTHOR
C     ______
C
C     K. Fielding      *ECMWF*      Nov 1993
C
C     MODIFICATIONS
C     _____________
C
C     None
C
C----<
C     _______________________________________________________
C
C
C*    Section 0. Definition of variables.
C     _______________________________________________________
C
C*    Prefix conventions for variable names
C
C     Logical      L (but not LP), global or common.
C                  O, dummy argument
C                  G, local variable
C                  LP, parameter.
C     Character    C, global or common.
C                  H, dummy argument
C                  Y (but not YP), local variable
C                  YP, parameter.
C     Integer      M and N, global or common.
C                  K, dummy argument
C                  I, local variable
C                  J (but not JP), loop control
C                  JP, parameter.
C     REAL         A to F and Q to X, global or common.
C                  P (but not PP), dummy argument
C                  Z, local variable
C                  PP, parameter.
C
C     Implicit statement to force declarations
C
      IMPLICIT NONE
C
#include "parim.h"
#include "nifld.common"
C
C     Dummy arguments
      INTEGER KOWE, KINS, KONS, KPR, KERR
      INTEGER KSTART (KINS)
      INTEGER KWEIND (2, KOWE, 2, KONS), KNSIND (2, KONS)
      REAL PIFELD (*), POFELD (KOWE, KONS)
      REAL PWFACT (4, KOWE, KONS)
      REAL PMAX (KOWE), PINPNT (KOWE)
C
C     Local variables
      LOGICAL LAT_RAIN
      INTEGER ILAT, IDIR, ISTART
      INTEGER JOLAT, JOLON, JNS, JWE
      INTEGER JPROUTINE
      PARAMETER (JPROUTINE = 23500)
C
C     _______________________________________________________
C
C*    Section 1. Initialisation
C     _______________________________________________________
C
  100 CONTINUE
C
      IF (KPR.GE.1) CALL INTLOG(JP_DEBUG,'IRPREC: Section 1.',JPQUIET)
C
      IRPREC = 0
C
      IF (KPR .GE. 1) THEN
        CALL INTLOG(JP_DEBUG,'IRPREC: No. of input fld lats = ',KINS)
        CALL INTLOG(JP_DEBUG,'IRPREC: No. of output fld lats = ',KONS)
        CALL INTLOG(JP_DEBUG,'IRPREC: No. of output fld longs = ',KOWE)
      ENDIF
C
C     _______________________________________________________
C
C*    Section 2. eliminate output precipitation based on
C                interpolation threshhold
C     _______________________________________________________
C
  200 CONTINUE
C
      IF (KPR.GE.1) CALL INTLOG(JP_DEBUG,'IRPREC: Section 2.',JPQUIET)
C
      CALL CHKPREC()
C
      DO 360 JOLAT = 1, KONS
C
         LAT_RAIN = .FALSE.
C
         DO 210 JOLON = 1, KOWE
C
            IF (POFELD (JOLON, JOLAT) .LT. ZPRECIP) THEN
               POFELD (JOLON, JOLAT) = PPZERO
            ELSE
               LAT_RAIN = .TRUE.
            ENDIF
C
  210    CONTINUE
C
C     _______________________________________________________
C
C*    Section 3. eliminate output precipitation based on
C                "nearest" point.
C
C                Do not bother if there is no precipitation on this
C                line of latitude
C     _______________________________________________________
C
  300 CONTINUE
C
      IF (KPR .GE. 1 .AND. JOLAT .EQ. 1) 
     X  CALL INTLOG(JP_DEBUG,'IRPREC: Section 3.',JPQUIET)
C
C
         IF (LAT_RAIN) THEN
C
            DO 310 JOLON = 1, KOWE
C
               PMAX (JOLON) = PPZERO
C
  310       CONTINUE
C
            DO 340 JNS = 1, 2
C
               ILAT = KNSIND (JNS, JOLAT)
               ISTART = KSTART (ILAT) - 1
C
               DO 330 JWE = 1, 2
C
                  IDIR = (JNS - 1) * 2 + JWE
C
                  DO 320 JOLON = 1, KOWE
C
                     IF (PWFACT (IDIR, JOLON, JOLAT) .GT.
     1                  PMAX (JOLON) ) THEN
C
                        PMAX (JOLON) = PWFACT (IDIR, JOLON, JOLAT)
C
                        PINPNT (JOLON) = PIFELD (ISTART +
     2                     KWEIND (JWE, JOLON, JNS, JOLAT) )
C
                     ENDIF
C
  320             CONTINUE
C
  330          CONTINUE
C
  340       CONTINUE
C
            DO 350 JOLON = 1, KOWE
C
               IF (PINPNT (JOLON) .LT. ZPRECIP)
     1            POFELD (JOLON, JOLAT) = PPZERO
C
  350       CONTINUE
C
         ENDIF
C
  360 CONTINUE
C
C     _______________________________________________________
C
C
C*    Section 9. Return to calling routine. Format statements
C     _______________________________________________________
C
  900 CONTINUE
C
      IF (KPR.GE.1) CALL INTLOG(JP_DEBUG,'IRPREC: Section 9.',JPQUIET)
C
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      INTEGER FUNCTION INTUVY( PVIN, PDIN, INLEN,
     X                         PUOUT, PVOUT, OUTLEN)
C
C---->
C**** INTUVY
C
C     Purpose
C     -------
C
C     Convert GRIB format input vorticity and divergence field to
C     unpacked U and V fields.
C
C
C     Interface
C     ---------
C
C     IRET = INTUVY( PVIN, PDIN, INLEN, PUOUT,PVOUT,OUTLEN)
C
C     Input
C     -----
C
C     KVIN - Input vorticity field  (spectral).
C     KDIN - Input divergence field (spectral).
C     INLEN  - Input field length (words).
C
C
C     Output
C     ------
C
C     KUOUT - Output U field
C     KVOUT - Output V field
C     OUTLEN  - Output field length (words).
C
C
C     Method
C     ------
C
C     Convert spectral vorticity/divergence to spectral U/V without
C     subsequent interpolation.
C
C     Note that a common block is used in intf.h to hold the U/V
C     fields before interpolation.
C
C     Externals
C     ---------
C
C     INTUVU - Now does all the work!
C     INTLOG - Log error message.
C
C
C     Author
C     ------
C
C     S.Curic     ECMWF     Dec 2006
C
C
C----<
C     -----------------------------------------------------------------|
C
      IMPLICIT NONE
C
C     Function arguments
C
      INTEGER  INLEN, OUTLEN
      REAL     PVIN(INLEN), PDIN(INLEN), PUOUT(*), PVOUT(*)
C
#include "parim.h"
#include "nifld.common"
#include "nofld.common"
#include "grfixed.h"
#include "intf.h"
C
C     Parameters
C
      INTEGER JPROUTINE
      PARAMETER (JPROUTINE = 26900 )
C
C     Local variables
C
      INTEGER IHOLD1, IHOLD2, IHOLD3
      LOGICAL LHOLD4
C
C     Externals
C
      INTEGER INTUVU
C
C     -----------------------------------------------------------------|
C*    Section 1.   Initialise
C     -----------------------------------------------------------------|
C
  100 CONTINUE
C
C     -----------------------------------------------------------------|
C*    Section 2.   Unpack the vorticity/divergence fields.
C     -----------------------------------------------------------------|
C
  200 CONTINUE
C
C     Ensure output representation says 'spectral, no rotation'
C
      IHOLD1    = NOREPR
      NOREPR    = JPSPHERE
      IHOLD2    = NOROTA(1)
      IHOLD3    = NOROTA(2)
      NOROTA(1) = -9000000
      NOROTA(2) = 0.0
      LHOLD4    = LNOROTA
      LNOROTA   = .FALSE.
C
      INTUVY =
     X  INTUVU(PVIN,PDIN,INLEN,PUOUT,PVOUT,OUTLEN)
C
C     Restore output representation
C
      NOREPR    = IHOLD1
      NOROTA(1) = IHOLD2
      NOROTA(2) = IHOLD3
      LNOROTA   = LHOLD4
C
C     -----------------------------------------------------------------|
C*    Section 9.   Closedown.
C     -----------------------------------------------------------------|
C
  900 CONTINUE
C
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities
C granted to it by virtue of its status as an intergovernmental organisation
C nor does it submit to any jurisdiction.
C

      INTEGER FUNCTION IRGTOG (PIFELD, KSTART, KINS, KOWE, KONS,
     1   KWEIND, KNSIND, PWFACT, POFELD, KPR, KERR)
C
C---->
C**** *IRGTOG*
C
C     Purpose
C     -------
C
C     Perform basic interpolation between the input and output fields
C     for a quasi regular input field and a regular output field.
C
C     Interface
C     ---------
C
C     IERR = IRGTOG (PIFELD, KSTART, KINS, KOWE, KONS, KWEIND,
C    1   KNSIND, PWFACT, POFELD, KPR, KERR)
C
C     Input parameters
C     ----------------
C
C     PIFELD     - The input field provided by the calling routine.
C
C     KSTART     - The array offset for each line of latitude within
C                  the quasi regular field.
C
C     KINS       - The number of points in the North-South direction
C                  in the input field.
C
C     KOWE       - The number of points in the West-East direction in
C                  the output field.
C
C     KONS       - The number of points in the North-South direction
C                  in the output field.
C
C     KWEIND     - This array contains the array offsets of the West
C                  and East points in the input array required for
C                  interpolation.
C
C     KNSIND     - This array contains the array offsets of the North
C                  and South points in the input array required for
C                  interpolation.
C
C     PWFACT     - The array of interpolating weights to the four
C                  neighbouring points for every output point.
C
C     KPR        - The debug print switch.
C                  0  , No debugging output.
C                  1  , Produce debugging output.
C
C     KERR       - The error control flag.
C                  -ve, No error message. Return error code.
C                  0  , Hard failure with error message.
C                  +ve, Print error message. Return error code.
C
C     Output parameters
C     -----------------
C
C     POFELD     - The output field returned to the calling routine.
C
C     Return value
C     ------------
C
C     The error indicator (INTEGER).
C
C     Error and Warning Return Values
C     -------------------------------
C
C     None
C
C     Common block usage
C     ------------------
C
C     None
C
C     Externals
C     ---------
C
C     INTLOG - Logs messages
C     FORCED_NEAREST_NEIGHBOUR - check forced interpolation method
C
C
C     Method
C     ------
C
C     This routine performs basic linear interpolation using the four
C     neighbouring points in the quasi regular input array to
C     generate the output array.
C
C     Reference
C     ---------
C
C     None
C
C     Comments
C     --------
C
C     None
C
C     Author
C     ------
C
C     K. Fielding      *ECMWF*      Nov 1993
C
C     Modifications
C     -------------
C
C     Allow for missing data values
C     J.D.Chambers      ECMWF       August 2000
C
C     Force nearest neighbour processing with env variable or
C     INTOUT parameter
C     S.Curic           ECMWF       September 2005
C
C----<
C     -----------------------------------------------------------------|
C*    Section 0. Definition of variables.
C     -----------------------------------------------------------------|
C
      IMPLICIT NONE
C
#include "parim.h"
#include "nifld.common"
#include "nofld.common"
C
C     Function arguments
C
      INTEGER KINS, KOWE, KONS, KPR, KERR
      INTEGER KSTART (KINS)
      INTEGER KWEIND (2, KOWE, 2, KONS), KNSIND (2, KONS)
      REAL PIFELD (*), POFELD (KOWE, KONS)
      REAL PWFACT (4, KOWE, KONS)
C
C     Local variables
C
      INTEGER ILATN, ILATS, INORTH, ISOUTH, JOLAT, JOLON, COUNT
      REAL NEAREST
      LOGICAL LVEGGY
C
C     Externals
C
      LOGICAL FORCED_NEAREST_NEIGHBOUR
C
C     Statement function
C
      REAL A, B
      LOGICAL NOTEQ
      NOTEQ(A,B) = (ABS((A)-(B)).GT.(ABS(A)*1E-3))
C
C     -----------------------------------------------------------------|
C*    Section 1. Initialisation
C     -----------------------------------------------------------------|
C
  100 CONTINUE
C
      IRGTOG = 0
C
      IF (KPR .GE. 1) THEN
        CALL INTLOG(JP_DEBUG,'IRGTOG: Section 1.',JPQUIET)
        CALL INTLOG(JP_DEBUG,'IRGTOG: No. input fld lats = ',KINS)
        CALL INTLOG(JP_DEBUG,'IRGTOG: No.output fld lats = ',KONS)
        CALL INTLOG(JP_DEBUG,'IRGTOG: No.output fld longs = ',KOWE)
      ENDIF
C
C     Use nearest neighbour if required
      LVEGGY = FORCED_NEAREST_NEIGHBOUR(LMETHOD,NITABLE,NIPARAM)
      IF( LVEGGY ) CALL INTLOG(JP_DEBUG,
     X  'IRGTOG: nearest neighbour processing',JPQUIET)
C
C     -----------------------------------------------------------------|
C*    Section 2. Basic interpolation
C     -----------------------------------------------------------------|
C
  200 CONTINUE
C
      IF( KPR.GE.1 ) CALL INTLOG(JP_DEBUG,'IRGTOG: Section 2.',JPQUIET)
C
      DO JOLAT = 1, KONS
C
        ILATN = KNSIND(JP_I_N,JOLAT)
        ILATS = KNSIND(JP_I_S,JOLAT)
C
        INORTH = KSTART(ILATN) - 1
        ISOUTH = KSTART(ILATS) - 1
C
        DO JOLON = 1, KOWE
C
C         Count non-missing data values
C
          COUNT = 0
          IF( NOTEQ(PIFELD(KWEIND(JP_I_W,JOLON,JP_I_N,JOLAT)+INORTH),
     X          RMISSGV) ) COUNT = COUNT + 1
          IF( NOTEQ(PIFELD(KWEIND(JP_I_E,JOLON,JP_I_N,JOLAT)+INORTH),
     X          RMISSGV) ) COUNT = COUNT + 1
          IF( NOTEQ(PIFELD(KWEIND(JP_I_W,JOLON,JP_I_S,JOLAT)+ISOUTH),
     X          RMISSGV) ) COUNT = COUNT + 1
          IF( NOTEQ(PIFELD(KWEIND(JP_I_E,JOLON,JP_I_S,JOLAT)+ISOUTH),
     X          RMISSGV) ) COUNT = COUNT + 1
C
C         Interpolate using four neighbours if none are missing
C
          IF( (COUNT.EQ.4).AND.(.NOT.LVEGGY) ) THEN
            POFELD(JOLON,JOLAT) =
     X        PIFELD(KWEIND(JP_I_W,JOLON,JP_I_N,JOLAT)+INORTH) *
     X          PWFACT(JP_I_NW,JOLON,JOLAT) +
     X        PIFELD(KWEIND(JP_I_E,JOLON,JP_I_N,JOLAT)+INORTH) *
     X          PWFACT(JP_I_NE,JOLON,JOLAT) +
     X        PIFELD(KWEIND(JP_I_W,JOLON,JP_I_S,JOLAT)+ISOUTH) *
     X          PWFACT(JP_I_SW,JOLON,JOLAT) +
     X        PIFELD(KWEIND(JP_I_E,JOLON,JP_I_S,JOLAT)+ISOUTH) *
     X          PWFACT(JP_I_SE,JOLON,JOLAT)
C
C         Set missing if all neighbours are missing
C
          ELSE IF( COUNT.EQ.0 ) THEN
            POFELD(JOLON,JOLAT) = RMISSGV
C
C         Otherwise, use the nearest neighbour
C
          ELSE
            NEAREST = PWFACT(JP_I_NW,JOLON,JOLAT)
            POFELD(JOLON,JOLAT) =
     X        PIFELD(KWEIND(JP_I_W,JOLON,JP_I_N,JOLAT)+INORTH)
C
            IF( PWFACT(JP_I_NE,JOLON,JOLAT).GT.NEAREST ) THEN
              NEAREST = PWFACT(JP_I_NE,JOLON,JOLAT)
              POFELD(JOLON,JOLAT) =
     X          PIFELD(KWEIND(JP_I_E,JOLON,JP_I_N,JOLAT)+INORTH)
            ENDIF
C
            IF( PWFACT(JP_I_SW,JOLON,JOLAT).GT.NEAREST ) THEN
              NEAREST = PWFACT(JP_I_SW,JOLON,JOLAT)
              POFELD(JOLON,JOLAT) =
     X          PIFELD(KWEIND(JP_I_W,JOLON,JP_I_S,JOLAT)+ISOUTH)
            ENDIF
C
            IF( PWFACT(JP_I_SE,JOLON,JOLAT).GT.NEAREST ) THEN
              NEAREST = PWFACT(JP_I_SE,JOLON,JOLAT)
              POFELD(JOLON,JOLAT) =
     X          PIFELD(KWEIND(JP_I_E,JOLON,JP_I_S,JOLAT)+ISOUTH)
            ENDIF
C
          ENDIF
C
        ENDDO
C
      ENDDO
C
C     -----------------------------------------------------------------|
C*    Section 9. Return to calling routine. Format statements
C     -----------------------------------------------------------------|
C
  900 CONTINUE
C
      IF( KPR.GE.1 ) CALL INTLOG(JP_DEBUG,'IRGTOG: Section 9.',JPQUIET)
C
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities
C granted to it by virtue of its status as an intergovernmental organisation
C nor does it submit to any jurisdiction.
C

      SUBROUTINE JALLGP( PSHUP, KTRUNC, PNORTH, PSOUTH, PWEST, PEAST,
     X                    PLATINC, PLONINC, POUTF, KRET)
C
C---->
C**** JALLGP
C
C     PURPOSE
C     _______
C
C     This routine converts spectral input fields to standard
C     lat/long grid fields.
C
C     INTERFACE
C     _________
C
C     CALL JALLGP( PSHUP, KTRUNC, PNORTH, PSOUTH, PWEST, PEAST,
C    X                    PLATINC, PLONINC, POUTF, KRET)
C
C     Input parameters
C     ________________
C
C     PSHUP    - Spherical harmonics field, unpacked
C     KTRUNC   - Truncation number of spherical harmonics field
C     PNORTH   - Northernmost latitude for output field (degrees)
C     PSOUTH   - Southernmost latitude for output field (degrees)
C     PWEST    - Westernmost longitude for output field (degrees)
C     PEAST    - Easternmost longitude for output field (degrees)
C     PLATINC  - Grid interval between latitudes in degrees
C     PLONINC  - Grid interval between longitudes in degrees
C
C     Output parameters
C     ________________
C
C     POUTF    - Output grid point field
C     KRET     - Return status code
C                0 = OK
C
C     Common block usage
C     __________________
C
C     JDCNDBG, JDCFLAGS
C
C
C     Method
C     ______
C
C     None.
C
C     Externals
C     _________
C
C     JOPNLL   - Opens the legendre functions file for reading line
C                by line.
C     JOPNLLF  - Opens the legendre functions file and reads the whole
C                of it into dynamically allocated memory.
C     JOPNLLSM - Opens the legendre functions file and memory maps it.
C
C     JJSET99  - Sets up FFT
C     JSYMLL   - Generate symmetric grid from spherical harmonics
C     JWINDLL  - Generate symmetric grid from spherical harmonics(wind)
C     JMOVLL   - Move points of symmetric grid to array
C     JMVULL   - Move points of unsymmetric grid to array
C     JDEBUG   - Checks environment variable to switch on/off debug
C     INTLOG   - Logs output messages
C     INTLOGR  - Logs output messages
C     GETENV   - Get value of an environment variable
C     GETCONF  - Decides how to handle legendre coefficients
#ifdef SHAREDMEMORY
C     SMREAD   - Gets interpolation coefficients in a shared memory array
#endif
C
C
C     Reference
C     _________
C
C     E.C.M.W.F. Research Department technical memorandum no. 56
C                "The forecast and analysis post-processing package"
C                May 1982. J.Haseler.
C
C
C     Comments
C     ________
C
C     This is a redesign, based on SPECGP.F
C
C     It handles transformations to a regular lat/long grid assuming.
C
C     It is not for U and V fields (no correction is applied at the
C     poles).
C
C
C     AUTHOR
C     ______
C
C     J.D.Chambers      *ECMWF*      Nov 1993
C
C     MODIFICATIONS
C     _____________
C
C
C     J.D.Chambers     ECMWF        Feb 1997
C     Allow for 64-bit pointers
C
C----<
C     _______________________________________________________
C
C*    Section 0. Definition of variables.
C     _______________________________________________________
C
      IMPLICIT NONE
#include "jparams.h"
#include "parim.h"
#include "nifld.common"
C
C     Parameters
C
      INTEGER JPROUTINE
      REAL PEPS
      PARAMETER ( JPROUTINE = 30000 )
      PARAMETER ( PEPS = 1E-6 )
C                   |
C                    `-> value used to compare equality of calculated
C                        latitude with area limits
C
C     Subroutine arguments
C
      COMPLEX   PSHUP
      DIMENSION PSHUP(*)
      INTEGER   KTRUNC
      REAL      PNORTH, PSOUTH, PWEST, PEAST, PLATINC, PLONINC
      REAL      POUTF
      DIMENSION POUTF(*)
      INTEGER   KRET
C
C     Local variables
C
      REAL PSTART, PNORMX, PDIFF
      REAL ZDEGR, ZBUILD
      INTEGER ILON, IOLON, ITOUP1, IJPWR
      INTEGER ILUNIT, ISTART
      INTEGER NEXT, NCALLS, NLEFT, NROWS, NFLAG, NCASE, NUMLON
C
      INTEGER IMFAX
      REAL ATRIGS
      DIMENSION IMFAX(10),ATRIGS(JPLONO*2)
#ifndef _CRAYFTN
#ifdef POINTER_64
      INTEGER*8 IALEG, IZFA
#endif
#endif
      REAL ALEG
      DIMENSION ALEG(1)
      POINTER ( IALEG, ALEG )
      REAL ZFA
      DIMENSION ZFA(1)
      POINTER ( IZFA, ZFA )
C
C     Integer Itimer,timer1
      INTEGER ISIZE, ISIZE2
      DATA ISIZE/0/, ISIZE2/0/
      SAVE ISIZE, ISIZE2, IZFA
C
      SAVE ILUNIT, IMFAX, ATRIGS, IALEG
C
      LOGICAL LDEBUG, LFIRST
      DATA LFIRST/.TRUE./
      SAVE LDEBUG, LFIRST
C
C     Externals
C
#ifdef SHAREDMEMORY
      INTEGER SHAREDLL, SHAREDDT
      EXTERNAL SHAREDLL, SHAREDDT
#endif
C
C     _______________________________________________________
C
C*    Section 1.    Initialization.
C     _______________________________________________________
C
  100 CONTINUE
C
      CALL JDEBUG( )
      LDEBUG = NDBG.GT.0
C
C     Decide how to handle legendre coefficients
C
      CALL GETCONF()
C
C
C       First time through, dynamically allocate memory for workspace
C
      IF( LFIRST ) THEN
        LFIRST = .FALSE.
        ISIZE =  (JPLONO+2)*64
        CALL JMEMHAN( 10, IZFA, ISIZE, 1, KRET)
        IF( KRET.NE.0 ) THEN
          CALL INTLOG(JP_ERROR,'JALLGP: memory allocation error.',IZFA)
          KRET = JPROUTINE + 1
          GOTO 900
        ENDIF
      ENDIF
C
      IF( LDEBUG ) THEN
        CALL INTLOG(JP_DEBUG,'JALLGP: Input parameters:', JPQUIET)
        CALL INTLOG(JP_DEBUG,
     X    'JALLGP: Spherical harmonic coeffs(first 20):', JPQUIET)
        DO NDBGLP = 1, 20
          CALL INTLOGR(JP_DEBUG,' ', PSHUP( NDBGLP ))
        ENDDO
        CALL INTLOG(JP_DEBUG,
     X    'JALLGP: Spherical harmonic truncation = ', KTRUNC)
        CALL INTLOGR(JP_DEBUG,
     X    'JALLGP: Northern latitude for output = ', PNORTH)
        CALL INTLOGR(JP_DEBUG,
     X    'JALLGP: Southern latitude for output = ', PSOUTH)
        CALL INTLOGR(JP_DEBUG,
     X    'JALLGP: Western longitude for output = ', PWEST)
        CALL INTLOGR(JP_DEBUG,
     X    'JALLGP: Eastern longitude for output = ', PEAST)
        CALL INTLOGR(JP_DEBUG,
     X    'JALLGP: Latitude grid interval (deg) = ', PLATINC)
        CALL INTLOGR(JP_DEBUG,
     X    'JALLGP: Longitude grid interval (deg) = ', PLONINC)
      ENDIF
C
C     Open the appropriate legendre function file.
C
      IF( LFILEIO ) THEN
        ISIZE2 = JPK
        CALL JMEMHAN( 14, IALEG, ISIZE2, 1, KRET)
        IF( KRET.NE.0 ) THEN
          CALL INTLOG(JP_ERROR,'JALLGP: memory allocate error.',IALEG)
          KRET = JPROUTINE + 2
          GOTO 900
        ENDIF
        CALL JOPNLL( ALEG, PLATINC, KTRUNC, ILUNIT, ZBUILD, KRET)
C
      ELSE IF( LMEMORY ) THEN
        CALL JOPNLLF( IALEG, PLATINC, KTRUNC, ILUNIT, ZBUILD, KRET)
C
      ELSE IF( LMAPPED ) THEN
        CALL JOPNLLSM( IALEG, PLATINC, KTRUNC, ILUNIT, ZBUILD, KRET)
C
#ifdef SHAREDMEMORY
      ELSE IF( LSHARED ) THEN
        IF( LDEBUG ) THEN
           CALL INTLOG(JP_DEBUG,'JALLGP: call SHAREDLL:', JPQUIET)
        ENDIF

        KRET=SHAREDLL(IALEG,KTRUNC,PLATINC)

c        print*,' jallgp.F KRET=',KRET
        IF( KRET.NE.0 ) THEN
          CALL INTLOG(JP_ERROR,
     X     'JALLGP: SHARED Failed to get legendre coeff.',KRET)
          KRET = JPROUTINE + 3
          GOTO 900
        ENDIF
        GOTO 102
#endif
      ELSE
        ISIZE2 =  (KTRUNC+1)*(KTRUNC+2)
        CALL JMEMHAN( 14, IALEG, ISIZE2, 1, KRET)
        IF( KRET.NE.0 ) THEN
          CALL INTLOG(JP_ERROR,'JALLGP: memory allocate error.',IALEG)
          KRET = JPROUTINE + 2
          GOTO 900
        ENDIF
      ENDIF
C
      IF( KRET.NE.0 ) THEN
        CALL INTLOG(JP_ERROR,
     X    'JALLGP: Failed to get legendre coefficients',KRET)
        KRET = JPROUTINE + 3
        GOTO 900
      ENDIF
C
  102 CONTINUE
C
      ZDEGR  = PPI / 180.0
      IOLON  = NINT( 360.0 / PLATINC )
      ILON   = NINT( 360.0 / PLONINC )
      ITOUP1 = KTRUNC
C
C     For calculation purposes, ILON, the number of longitude points,
C     has to be greater than 2*(output truncation) to ensure that the
C     fourier transform is exact (see Reference, page 10).
C     The following loop increases ILON*IJPWR until ILON=>2*ITOUP1.
C     Later, when filling the output array POUTF, the longitude points
C     have to be taken selectively to avoid the intermediate generated
C     points, picking up values only at the required longitudes.
C
      IJPWR = 1
 110  CONTINUE
        IF( ILON.GT.2*ITOUP1 ) GOTO 120
        IJPWR = IJPWR*2
        ILON  = ILON*2
        GOTO 110
 120  CONTINUE
C
C     Initialise FFT constants
C
      IF( LDEBUG ) THEN
        CALL INTLOG(JP_DEBUG,
     X    'JALLGP: Initialise FFT constants with ', ILON)
        CALL INTLOG(JP_DEBUG,
     X    'JALLGP: longitude points.', JPQUIET)
      ENDIF
C
      CALL JJSET99( ATRIGS, IMFAX, ILON, KRET)
      IF( KRET.NE.0 ) GOTO 900
C
C     _______________________________________________________
C
C*    Section 2.    Work out geometry of the request
C     _______________________________________________________
C
 200  CONTINUE
C
C     Symmetrical about equator?
C
      NCASE  = 1
      NFLAG  = 3
      PNORMX = PNORTH
      PDIFF  = 0.0
      NROWS  = NINT( PNORTH/PLATINC )  + 1
      IF( ( ABS((NROWS-1)*PLATINC)-PNORTH).GT.PEPS ) NROWS = NROWS - 1
C
C     Northern hemisphere only ?
C
      IF( PSOUTH.GT.0.0 ) THEN
        NCASE = 2
        NFLAG = 1
        PNORMX = PNORTH
        PDIFF = PNORTH - PSOUTH
        NROWS = NINT( PDIFF/PLATINC )  + 1
        IF( ( ABS((NROWS-1)*PLATINC)-PNORTH).GT.PEPS ) NROWS = NROWS - 1
        IF( LDEBUG )
     X    CALL INTLOG(JP_DEBUG,'JALLGP: North hemisphere only.',JPQUIET)
        GOTO 300
      ENDIF
C
C     Southern hemisphere only ?
C
      IF( PNORTH.LT.0.0 ) THEN
        NCASE = 3
        NFLAG = 2
        PNORMX = ABS(PSOUTH)
        PDIFF  = PNORMX + PNORTH
        NROWS =  NINT( PDIFF/PLATINC )  + 1
        IF( ( ABS((NROWS-1)*PLATINC)-ABS(PSOUTH)).GT.PEPS )
     X    NROWS = NROWS - 1
C
        IF( LDEBUG )
     X    CALL INTLOG(JP_DEBUG,'JALLGP: South hemisphere only.',JPQUIET)
        GOTO 300
      ENDIF
C
C     Straddles equator ...
C     ... more north than south?
C
      IF( PNORTH.GT.-PSOUTH ) THEN
        NCASE = 4
        PNORMX = PNORTH
        PDIFF = PNORTH + PSOUTH
        NROWS =  NINT( PNORMX/PLATINC )  + 1
C
        IF( LDEBUG ) THEN
          CALL INTLOG(JP_DEBUG,
     X      'JALLGP: Straddles equator.', JPQUIET)
          CALL INTLOG(JP_DEBUG,
     X      'JALLGP: More north than south.', JPQUIET)
        ENDIF
      ENDIF
C
C     ... more south than north?
C
      IF( PNORTH.LT.-PSOUTH ) THEN
        NCASE = 5
        PNORMX = ABS(PSOUTH)
        PDIFF  = PNORMX - PNORTH
        NROWS =  NINT( PNORMX/PLATINC )  + 1
        IF( ( ABS((NROWS-1)*PLATINC)-PNORMX).GT.PEPS ) NROWS = NROWS - 1
C
        IF( LDEBUG ) THEN
          CALL INTLOG(JP_DEBUG,
     X      'JALLGP: Straddles equator.', JPQUIET)
          CALL INTLOG(JP_DEBUG,
     X      'JALLGP: More south than north.', JPQUIET)
        ENDIF
      ENDIF
C     _______________________________________________________
C
C*    Section 3.    Calculation.
C     _______________________________________________________
C
 300  CONTINUE
C
      NUMLON = NINT( (PEAST - PWEST)/PLONINC ) + 1
      ZBUILD = PLATINC
C
      IF( LDEBUG ) THEN
        CALL INTLOG(JP_DEBUG,'JALLGP: Number of longitudes = ', NUMLON)
        CALL INTLOGR(JP_DEBUG,
     X    'JALLGP: North latitude used for calc = ', PNORMX)
        CALL INTLOG(JP_DEBUG,'JALLGP: No.lats used in calc = ', NROWS)
      ENDIF
C
      NCALLS = NROWS / JP32
C
      IF( LWIND ) THEN
        IF( LDEBUG ) CALL INTLOG(JP_DEBUG,
     X    'JALLGP: No.of 32 rows (calls to JWINDLL) = ', NCALLS)
      ELSE
        IF( LDEBUG ) CALL INTLOG(JP_DEBUG,
     X    'JALLGP: No.of 32 rows (calls to JSYMLL) = ', NCALLS)
      ENDIF
C     _______________________________________________________
C
C*    Section 4.    Process 32 rows at a time.
C     _______________________________________________________
C
 400  CONTINUE
C
C     timer1=Itimer(0)
      DO 420 NEXT = 1, NCALLS
        PSTART = PNORMX - REAL( (NEXT -1)*JP32 ) *PLATINC
        ISTART = INT((PSTART*1000.0)+0.5)
        PSTART = ISTART/1000.0
C
        IF( LDEBUG )
     X    CALL INTLOGR(JP_DEBUG, 'JALLGP: Next latitude = ', PSTART)
C
C       Generate the next 32 rows (Northern and Southern hemisphere).
C
        IF( LWIND ) THEN
          CALL JWINDLL( PSHUP, KTRUNC, PSTART, ZBUILD, PLATINC, ILUNIT,
     X                 JP32,ILON,ALEG,ATRIGS,IMFAX,ZFA,KRET)
        ELSE
          CALL JSYMLL( PSHUP, KTRUNC, PSTART, ZBUILD, PLATINC, ILUNIT,
     X                 JP32,ILON,ALEG,ATRIGS,IMFAX,ZFA,KRET)
        ENDIF
        IF( KRET.NE.0 ) GOTO 900
C
C       If area straddles the equator and has different number of
C       north/south rows, only move a selection of rows to output array.
C
        IF( (NCASE.EQ.4).OR.(NCASE.EQ.5) ) THEN
          CALL JMVULL( ZFA, PNORTH, PSOUTH, PWEST, PLATINC, PLONINC,
     X                 PSTART, PDIFF, JP32, NUMLON, ILON, IJPWR, POUTF)
          PDIFF = PDIFF - PLATINC*JP32
          IF( PDIFF.LT.0 ) NCASE = NCASE - 2
C
C       Otherwise, move them all
C
        ELSE
          CALL JMOVLL( ZFA, PNORTH, PWEST, PLATINC, PLONINC, PSTART,
     X                 JP32, NUMLON, ILON, IJPWR, POUTF, NFLAG)
        ENDIF
C
 420  CONTINUE
C     timer1=Itimer(timer1)
C     print*,'jallgp.F legendre functions JSYMLL time:',timer1,' sec'

C
C     _______________________________________________________
C
C*    Section 5.    Process leftover rows nearest the equator.
C     _______________________________________________________
C
 500  CONTINUE
C
      NLEFT = MOD( NROWS, JP32 )
C
      IF( LDEBUG ) CALL INTLOG(JP_DEBUG,
     X    'JALLGP: No.of leftover rows nearest equator = ', NLEFT)
C
C
      IF( NLEFT.NE.0 ) THEN
        PSTART = PNORMX - REAL( NCALLS*JP32 ) *PLATINC
C
      IF( LDEBUG )
     X  CALL INTLOGR(JP_DEBUG, 'JALLGP: Next latitude = ',PSTART)
C
        IF( LWIND ) THEN
          CALL JWINDLL( PSHUP, KTRUNC, PSTART, ZBUILD, PLATINC, ILUNIT,
     X                 NLEFT,ILON,ALEG,ATRIGS,IMFAX,ZFA,KRET)
        ELSE
          CALL JSYMLL( PSHUP, KTRUNC, PSTART, ZBUILD, PLATINC, ILUNIT,
     X                 NLEFT,ILON,ALEG,ATRIGS,IMFAX,ZFA,KRET)
        ENDIF
        IF( KRET.NE.0 ) GOTO 900
C
C       If area straddles the equator and has different number of
C       north/south rows, only move a selection of rows to output array.
C
        IF( (NCASE.EQ.4).OR.(NCASE.EQ.5) ) THEN
          CALL JMVULL( ZFA, PNORTH, PSOUTH, PWEST, PLATINC, PLONINC,
     X                 PSTART, 0.0, NLEFT, NUMLON, ILON, IJPWR, POUTF)
C
C       Otherwise, move them all
C
        ELSE
          CALL JMOVLL( ZFA, PNORTH, PWEST, PLATINC, PLONINC, PSTART,
     X                 NLEFT, NUMLON, ILON, IJPWR, POUTF, NFLAG)
        ENDIF
C
      ENDIF
C
      KRET = 0
#ifdef SHAREDMEMORY
      KRET = SHAREDDT(IALEG)
      IF( LDEBUG )
     X  CALL INTLOG(JP_DEBUG,'JALLGP: release_shared_file  = ', KRET)
      KRET = 0
#endif
C
C     _______________________________________________________
C
C*    Section 9. Return to calling routine. Format statements
C     _______________________________________________________
C
 900  CONTINUE
C
      RETURN
      END

C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      INTEGER FUNCTION IGPLSM (POFELD, KLEN, KPR, KERR)
C
C---->
C**** *IGPLSM*
C
C     PURPOSE
C     _______
C
C     Force an interpolated land sea mask field back to a real 0-1
C     field.
C
C     INTERFACE
C     _________
C
C     IERR = IGPLSM (POFELD, KLEN, KPR, KERR)
C
C     Input parameters
C     ________________
C
C     POFELD     - The output field as previously calculated.
C
C     KLEN       - The length of the output field.
C
C     KPR        - The debug print switch.
C                  0  , No debugging output.
C                  1  , Produce debugging output.
C
C     KERR       - The error control flag.
C                  -ve, No error message. Return error code.
C                  0  , Hard failure with error message.
C                  +ve, Print error message. Return error code.
C
C     Output parameters
C     ________________
C
C     POFELD     - The 0-1 land sea mask output field
C
C     Return value
C     ____________
C
C     The error indicator (INTEGER).
C
C     Error and Warning Return Values
C     _______________________________
C
C     None
C
C     Common block usage
C     __________________
C
C     None
C
C     EXTERNALS
C     _________
C
C     INTLOG(R)    - Logs messages.
C
C     METHOD
C     ______
C
C     The intrinsic routine ANINT is used to create a real array of
C     the nearest integer value to the interpolated field. An
C     additional check is that all values less than zero are forced
C     to zero and all values greater than one are forced to one.
C
C     REFERENCE
C     _________
C
C     None
C
C     COMMENTS
C     ________
C
C     Program contains sections 0 to 2 and 9
C
C     AUTHOR
C     ______
C
C     K. Fielding      *ECMWF*      Feb 1994
C
C     MODIFICATIONS
C     _____________
C
C     None
C
C----<
C     _______________________________________________________
C
C
C*    Section 0. Definition of variables.
C     _______________________________________________________
C
C*    Prefix conventions for variable names
C
C     Logical      L (but not LP), global or common.
C                  O, dummy argument
C                  G, local variable
C                  LP, parameter.
C     Character    C, global or common.
C                  H, dummy argument
C                  Y (but not YP), local variable
C                  YP, parameter.
C     Integer      M and N, global or common.
C                  K, dummy argument
C                  I, local variable
C                  J (but not JP), loop control
C                  JP, parameter.
C     REAL         A to F and Q to X, global or common.
C                  P (but not PP), dummy argument
C                  Z, local variable
C                  PP, parameter.
C
C     Implicit statement to force declarations
C
      IMPLICIT NONE
C
#include "parim.h"
C
C     Dummy arguments
      INTEGER KLEN, KPR, KERR
      REAL POFELD (KLEN)
C
C     Local variables
      INTEGER JLEN
      INTEGER JPROUTINE
      PARAMETER (JPROUTINE = 25700)
C
C     _______________________________________________________
C
C*    Section 1. Initialisation
C     _______________________________________________________
C
  100 CONTINUE
C
      IF (KPR.GE.1) CALL INTLOG(JP_DEBUG,'IGPLSM: Section 1.',JPQUIET)
C
      IGPLSM = 0
C
      IF (KPR .GE. 1)
     X  CALL INTLOG(JP_DEBUG,'IGPLSM: Total fld len = ',KLEN)
C
C
C     _______________________________________________________
C
C*    Section 2. Force land sea mask to nearest integer (0 or 1)
C     _______________________________________________________
C
  200 CONTINUE
C
      IF (KPR.GE.1) CALL INTLOG(JP_DEBUG,'IGPLSM: Section 2.',JPQUIET)
C
      DO 210 JLEN = 1, KLEN
C
         POFELD (JLEN) = ANINT (POFELD (JLEN) )
C
         IF (POFELD (JLEN) .LT. PPZERO) POFELD (JLEN) = PPZERO
         IF (POFELD (JLEN) .GT. PPONE) POFELD (JLEN) = PPONE
C
  210 CONTINUE
C
C     _______________________________________________________
C
C*    Section 9. Return to calling routine. Format statements
C     _______________________________________________________
C
  900 CONTINUE
C
      IF (KPR.GE.1) CALL INTLOG(JP_DEBUG,'IGPLSM: Section 9.',JPQUIET)
C
      RETURN
      END

C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE KWPRS1 (KSEC0,KSEC1)
C
C---->
C**** KWPRS1
C
C     Purpose.
C     --------
C
C     Print the information in the Product Definition
C     Section (Section 1) of decoded Washington ensemble GRIB data.
C
C**   Interface.
C     ----------
C
C     CALL KWPRS1 (KSEC0,KSEC1)
C
C
C     Input Parameters.
C     -----------------
C
C     KSEC0 - Array of decoded parameters from Section 0.
C
C     KSEC1 - Array of decoded parameters from Section 1.
C
C
C     Output Parameters.
C     ------------------
C
C     None.
C
C
C     Method.
C     -------
C
C     None.
C
C
C     Externals.
C     ----------
C
C     PRTBIN
C
C
C     Reference.
C     ----------
C
C     WMO Manual on Codes re GRIB Code.
C     See also routine GRIBEX.
C     http://www.nco.ncep.noaa.gov/pmb/docs/on388/appendixc.html. 
C
C
C     Comments.
C     ---------
C
C
C     Washington ensemble product usage of local part of section 1 of
C     GRIB:
C
C     KSEC1(37) decoded from Octet 41.
C     Identifies the application:
C                1   Ensemble.
C
C     KSEC1(38) decoded from Octet 42.
C     Type:
C                1   Unperturbed control forecast,
C                2   Individual negatively perturbed forecast,
C                3   Individual positively perturbed forecast,
C                4   Cluster,
C                5   Whole ensemble.
C
C     KSEC1(39) decoded from Octet 43.
C     Identification number:
C                1   If byte 42 = 1, identifies high resolution.
C                2   If byte 42 = 1, identifies low resolution.
C                1-5 If byte 42 = 2 or 3, number of a member of a pair
C                    of (negative perturbation, positive perturbation) 
C
C     KSEC1(40) decoded from Octet 44.
C     Product identifier:
C                1   Full field (individual forecast)/unweighted mean.
C                2   Weighted mean.
C                11  Standard deviation wrt ensemble mean.
C                11  Standard deviation wrt ensemble mean, normalized.
C
C     KSEC1(41) decoded from Octet 45.
C     Spatial smoothing of product (number of highest total
C     wavenumber included):
C                255 Original resolution retained.
C
C     Following are used only if needed.
C
C     Probability Section
C     -------------------
C
C     KSEC1(42) decoded from Octet 46.
C     Probability product definition.
C     If octet 9 = 191 or 192, defines variable in terms of octet 9 table
C
C     KSEC1(43) decoded from Octet 47.
C     Probability type 
C                1 = Probability of event below lower limit 
C                2 = Probability of event above upper limit 
C                3 = Probability of event between lower and upper limits 
C
C     KSEC1(44) decoded from Octets 48 - 51
C     Probability lower limit (unit as in octet 9; floating point number)
C
C     KSEC1(45) decoded from Octets 52 - 55
C     Probability upper limit (unit as in octet 9; floating point number)
C
C     Octets 56 - 60 are reserved.
C
C     Following are used only if octet 42 = 4 or 5.
C
C     Clustering Section
C     ------------------
C
C     KSEC1(46) decoded from Octet 61.
C     Ensemble size (number of members, including controls)
C
C     KSEC1(47) decoded from Octet 62.
C     Cluster size (number of members)
C
C     KSEC1(48) decoded from Octet 63.
C     Number of clusters 
C
C     KSEC1(49) decoded from Octet 64.
C     Clustering Method
C                1 = AC 
C                2 = RMS 
C
C     KSEC1(50) decoded from Octets 65 - 67
C     Northern latitude of clustering domain (in thousandths of degree) 
C
C     KSEC1(51) decoded from Octets 68 - 70
C     Southern latitude of clustering domain (in thousandths of degree) 
C
C     KSEC1(52) decoded from Octets 71 - 73
C     Eastern longitude of clustering domain (in thousandths of degree) 
C
C     KSEC1(53) decoded from Octets 74 - 76
C     Western longitude of clustering domain (in thousandths of degree) 
C
C     KSEC1(54 - 63) decoded from Octets 77 - 86
C     Cluster Membership (If octet 42 = 4)
C     Indicates in binary (on/off) format, which members of the ensemble
C     belong to the current cluster. Membership table defined by product
C     generators. 
C
C
C
C     Author.
C     -------
C
C     J.D.Chambers   ECMWF 09.10.95
C
C
C     Modifications.
C     --------------
C
C     None.
C
C
C----<
C     -----------------------------------------------------------------
C*    Section 0. Definition of variables.
C     -----------------------------------------------------------------
C
      IMPLICIT NONE
C
#include "grprs.h"
C
C     Parameters
      INTEGER KSEC0
      INTEGER KSEC1
      DIMENSION KSEC0(*)
      DIMENSION KSEC1(*)
C
C     Local variables
C
      INTEGER LOOP
      INTEGER*4 ILIMIT
      REAL*4    RLIMIT
      EQUIVALENCE(ILIMIT,RLIMIT)
C
C     -----------------------------------------------------------------
C*    Section 1 . Print required information.
C     ----------------------------------------------------------------- C
  100 CONTINUE
C
C     -----------------------------------------------------------------
C*    Section 2 . Print Washington ensemble product information.
C     -----------------------------------------------------------------
C
  200 CONTINUE
C
C     Application Identifier.
C
      WRITE(GRPRSM,9000) KSEC1(37)
C
C     Type.
C
      IF(KSEC1(38).GT.5) WRITE(GRPRSM,9100) KSEC1(38)
      IF(KSEC1(38).EQ.1) WRITE(GRPRSM,9101) KSEC1(38)
      IF(KSEC1(38).EQ.2) WRITE(GRPRSM,9102) KSEC1(38)
      IF(KSEC1(38).EQ.3) WRITE(GRPRSM,9103) KSEC1(38)
      IF(KSEC1(38).EQ.4) WRITE(GRPRSM,9104) KSEC1(38)
      IF(KSEC1(38).EQ.5) WRITE(GRPRSM,9105) KSEC1(38)
C
C     Identification number.
C
      IF(KSEC1(38).NE.1) THEN
        WRITE(GRPRSM,9200) KSEC1(39)
      ELSE
        IF(KSEC1(39).EQ.1) THEN
          WRITE(GRPRSM,9201) KSEC1(39)
        ELSE IF(KSEC1(39).EQ.2) THEN
          WRITE(GRPRSM,9202) KSEC1(39)
        ELSE
          WRITE(GRPRSM,9200) KSEC1(39)
        ENDIF
      ENDIF
C
C     Product.
C
      IF(KSEC1(40).EQ.1) THEN
        WRITE(GRPRSM,9301) KSEC1(40)
      ELSE IF(KSEC1(40).EQ.2) THEN
        WRITE(GRPRSM,9302) KSEC1(40)
      ELSE IF(KSEC1(40).EQ.11) THEN
        WRITE(GRPRSM,9311) KSEC1(40)
      ELSE IF(KSEC1(40).EQ.12) THEN
        WRITE(GRPRSM,9312) KSEC1(40)
      ELSE
        WRITE(GRPRSM,9300) KSEC1(40)
      ENDIF
C
C     Spatial smoothing of product.
C
      IF( KSEC1(41).EQ.255) THEN
        WRITE(GRPRSM,9400) KSEC1(41)
      ELSE
        WRITE(GRPRSM,9401) KSEC1(41)
      ENDIF
C
C     Probability Section
C
      IF( KSEC1(42).NE.0) THEN
C
C       Probability type
C
        WRITE(GRPRSM,9500) KSEC1(42)
        IF( KSEC1(43).EQ.1 ) THEN
          WRITE(GRPRSM,9501) KSEC1(43)
        ELSE IF( KSEC1(43).EQ.2 ) THEN
          WRITE(GRPRSM,9502) KSEC1(43)
        ELSE IF( KSEC1(43).EQ.3 ) THEN
          WRITE(GRPRSM,9503) KSEC1(43)
        ELSE
          WRITE(GRPRSM,9504) KSEC1(43)
        ENDIF
C
C       Limits
C
        ILIMIT = KSEC1(44)
        WRITE(GRPRSM,9505) RLIMIT
C
        ILIMIT = KSEC1(45)
        WRITE(GRPRSM,9506) RLIMIT
      ENDIF
C
C     Clustering Section
C
      IF( KSEC1(46).NE.0) THEN
C
C       Ensemble size
C
        WRITE(GRPRSM,9507) KSEC1(46)
C
        IF( KSEC1(47).NE.0 ) THEN 
C
C         Cluster size
C         Number of clusters
C         Clustering Method
C
          WRITE(GRPRSM,9508) KSEC1(47)
          WRITE(GRPRSM,9509) KSEC1(48)
          WRITE(GRPRSM,9510) KSEC1(49)
C
C         North/South/East/West limits of clustering domain
C
          WRITE(GRPRSM,9511) KSEC1(50)
          WRITE(GRPRSM,9511) KSEC1(51)
          WRITE(GRPRSM,9511) KSEC1(52)
          WRITE(GRPRSM,9511) KSEC1(53)
C
C         Cluster Membership
C
          IF( KSEC1(38).EQ.4 ) THEN
            WRITE(GRPRSM,9515)
            WRITE(GRPRSM,9516)
            DO LOOP = 1, KSEC1(46)
              IF( KSEC1(53+LOOP).EQ.1 ) THEN
                WRITE(GRPRSM,9517) LOOP
              ELSE
                WRITE(GRPRSM,9518) LOOP
              ENDIF
            ENDDO
          ENDIF
C
        ENDIF
C
      ENDIF
C
C     -----------------------------------------------------------------
C*    Section 9 . Format statements. Return to calling routine.
C     -----------------------------------------------------------------
C
  900 CONTINUE
C
      RETURN
C
 9000 FORMAT(1H ,'Application Identifier.(1=Ensemble)  ',I9)
C
 9100 FORMAT(1H ,'Type:                                ',I9)
 9101 FORMAT(1H ,'Type: Unperturbed control forecast.  ',I9)
 9102 FORMAT(1H ,'Type: Individual -vely perturbed fc. ',I9)
 9103 FORMAT(1H ,'Type: Individual +vely perturbed fc. ',I9)
 9104 FORMAT(1H ,'Type: Cluster.                       ',I9)
 9105 FORMAT(1H ,'Type: Whole ensemble.                ',I9)
C
 9200 FORMAT(1H ,'Identification number.               ',I9)
 9201 FORMAT(1H ,'Identification number: (1=high res)  ',I9)
 9202 FORMAT(1H ,'Identification number: (2=low res)   ',I9)
C
 9300 FORMAT(1H ,'Product.                             ',I9)
 9301 FORMAT(1H ,'Full field/unweighted mean.          ',I9)
 9302 FORMAT(1H ,'Weighted mean.                       ',I9)
 9311 FORMAT(1H ,'Standard deviation wrt ensemble mean.',I9)
 9312 FORMAT(1H ,'Stand.dev. wrt ens. mean, normalized.',I9)
C
 9400 FORMAT(1H ,'Original spatial smoothing retained. ',I9)
 9401 FORMAT(1H ,'Spatial smoothing of product:        ',I9)
C
 9500 FORMAT(1H ,'Probability product definition       ',I9)
 9501 FORMAT(1H ,'Prob. of event below lower limit     ',I9)
 9502 FORMAT(1H ,'Prob. of event above upper limit     ',I9)
 9503 FORMAT(1H ,'Prob. of event between limits        ',I9)
 9504 FORMAT(1H ,'Unknown probability type             ',I9)
 9505 FORMAT(1H ,'Probability lower limit        ',F15.6)
 9506 FORMAT(1H ,'Probability upper limit        ',F15.6)
 9507 FORMAT(1H ,'Ensemble size (members + controls)   ',I9)
 9508 FORMAT(1H ,'Cluster size (number of members)     ',I9)
 9509 FORMAT(1H ,'Number of clusters                   ',I9)
 9510 FORMAT(1H ,'Clustering Method (1 = AC, 2 = RMS)  ',I9)
 9511 FORMAT(1H ,'Northern latitude of domain (x1000)  ',I9) 
 9512 FORMAT(1H ,'Southern latitude of domain (x1000)  ',I9) 
 9513 FORMAT(1H ,'Eastern longitude of domain (x1000)  ',I9) 
 9514 FORMAT(1H ,'Western longitude of domain (x1000)  ',I9) 
 9515 FORMAT(1H ,'Cluster Membership')
 9516 FORMAT(1H ,'------------------')
 9517 FORMAT(1H ,'Ensemble member',I3,' in cluster')
 9518 FORMAT(1H ,'Ensemble member',I3,' not in cluster')
C
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities
C granted to it by virtue of its status as an intergovernmental organisation
C nor does it submit to any jurisdiction.
C

      INTEGER FUNCTION IGDIWE(KIWE,KOWE,KWEIND,KWEDIST,IAREA,OAREA,
     .  KILONG,KOLONG,OWEGLOBE)  !FIXME: remove
C
C---->
C**** *IGDIWE*
C
C     PURPOSE
C     _______
C
C     Calculate the distances between points in an output longitude
C     array and its West and East neighbours in the input longitude
C     array.
C
C     INTERFACE
C     _________
C
C     IERR = IGDIWE(KIWE,KOWE,KWEIND,KWEDIST,IAREA,OAREA)
C
C     Input parameters
C     ________________
C
C     KIWE       - The number of points in the West-East direction in
C                  the input field.
C
C     KOWE       - The number of points in the West-East direction in
C                  the output field.
C
C     IAREA      - Input field area definition (N/W/S/E).
C
C     OAREA      - Input field area definition (N/W/S/E).
C
CTEMP KILONG     - The array of input longitudes.
CTEMP
CTEMP KOLONG     - The array of output longitudes.
CTEMP
CTEMP OWEGLOBE   - This variable will be true if the input array of
CTEMP              longitudes spans the globe.
C
C     Output parameters
C     ________________
C
C     KWEIND     - This array will contain the array offsets of the
C                  West and East points in the input array required
C                  for interpolation.
C
C     KWEDIST    - This array holds the distances to longitude values
C                  in the input field from the associated longitude
C                  values in the output field.
C
C     Return value
C     ____________
C
C     The error indicator (INTEGER).
C
C----<

      IMPLICIT NONE
#include "parim.h"
#include "nofld.common"

C     Arguments
      INTEGER KIWE
      INTEGER KOWE
      INTEGER IAREA(4)
      INTEGER OAREA(4)
      INTEGER KWEIND (2,KOWE)
      INTEGER KWEDIST(2,KOWE)

C     Local variables
      INTEGER I, J, IA, IB
      LOGICAL LSTAGGL, LSUBAR, LSUBARO  ! (to avoid globals)

C     Arguments & local variables (FIXME: remove)
      INTEGER KILONG(KIWE+1), KOLONG(KOWE)
      LOGICAL OWEGLOBE
      INTEGER IBASE, ILOW, IUP
      REAL LO, LO1, LO2, IDELTA, ODELTA

C     NOTE: subarea/staggered definition copied from areachk.F:218
C     testing shows that:
C       LGLOBL   = .NOT. LSUBARO
C       OWEGLOBE = .NOT. LSUBAR
      LSUBARO = (OAREA(1).NE.0) .AND. (OAREA(2).NE.0) .AND.
     .          (OAREA(3).NE.0) .AND. (OAREA(4).NE.0)
      LSUBAR  = (IAREA(1).NE.0) .AND. (IAREA(2).NE.0) .AND.
     .          (IAREA(3).NE.0) .AND. (IAREA(4).NE.0)
      LSTAGGL = (LSUBAR) .AND.
     .          (IABS(JP360 - IAREA(4) - IAREA(2)).LT.1000)


      IF( LSTAGGL .OR. LSUBAR ) THEN

!       CALL INTLOG(JP_DEBUG,
!    .    'IGDIWE: Staggered grids not supported', JPQUIET )

        CALL INTLOG(JP_DEBUG,'IGDIWE: algorithm: old :-(',JPQUIET)

C       OLD METHOD:
C       This sets the arrays of offsets and distance (of length
C       (2, Number of output longitudes)), used for all latitude rows when
C       both input & and output grids are regular. It is used to provide
C       the values for one line of latitude for quasi regular Gaussian
C       input fields.


        IGDIWE = 0
        IF (OWEGLOBE) THEN

          DO I = 1, KIWE

C           NOTE entry #1 is repeated as point KIWE + 1 to simplify the wrap around
            ILOW = KILONG (I)
            IUP  = KILONG (I + 1)
            IF (IUP .GT. ILOW) THEN

              DO J = 1, KOWE

                IF (KOLONG(J).GE.ILOW .AND.  KOLONG(J).LT.IUP) THEN

C                 Normal case IUP > ILOW: longitude point found
                  KWEIND (JP_I_W, J) = I
                  IF (I .LT. KIWE) THEN
                    KWEIND (JP_I_E, J) = I + 1
                  ELSE
                    KWEIND (JP_I_E, J) = 1
                  ENDIF
                  KWEDIST (JP_I_W, J) = KOLONG (J) - ILOW
                  KWEDIST (JP_I_E, J) = IUP - KOLONG (J)

                ENDIF

              ENDDO

            ELSE

              DO J = 1, KOWE

                IF (KOLONG (J) .GE. ILOW) THEN

C                 Wrap around case: longitude point found between ILOW and 3600000
                  KWEIND (JP_I_W, J) = I
                  IF (I .LT. KIWE) THEN
                    KWEIND (JP_I_E, J) = I + 1
                  ELSE
                    KWEIND (JP_I_E, J) = 1
                  ENDIF
                  KWEDIST (JP_I_W, J) = KOLONG (J) - ILOW
                  KWEDIST (JP_I_E, J) = IUP + JP360 - KOLONG (J)

                ENDIF

                IF (KOLONG (J) .LE. IUP) THEN

C                 Wrap around case: longitude point found between 0 and IUP
                  KWEIND (JP_I_W, J) = I
                  IF (I .LT. KIWE) THEN
                    KWEIND (JP_I_E, J) = I + 1
                  ELSE
                    KWEIND (JP_I_E, J) = 1
                  ENDIF
                  KWEDIST (JP_I_W, J) = KOLONG (J) + JP360 - ILOW
                  KWEDIST (JP_I_E, J) = IUP - KOLONG (J)

                ENDIF

              ENDDO

            ENDIF

          ENDDO

        ELSE

C         last point found for non-global input grids
          IBASE = 1

          DO J = 1, KOWE

            DO I = IBASE, KIWE - 1

              ILOW = KILONG (I)
              IUP = KILONG (I + 1)

              IF (KOLONG(J).GE.ILOW .AND. KOLONG(J).LE.IUP) THEN

C               Normal case IUP > ILOW: longitude point found
                KWEIND (JP_I_W, J) = I
                KWEIND (JP_I_E, J) = I + 1
                IBASE = I
                KWEDIST (JP_I_W, J) = KOLONG (J) - ILOW
                KWEDIST (JP_I_E, J) = IUP - KOLONG (J)
                GOTO 250

              ELSE IF (IUP .LT. ILOW) THEN

                IF (KOLONG (J) .GE. ILOW) THEN

C                 Wrap around case: longitude point found between ILOW and 3600000
                  KWEIND (JP_I_W, J) = I
                  KWEIND (JP_I_E, J) = I + 1
                  IBASE = I
                  KWEDIST (JP_I_W, J) = KOLONG (J) - ILOW
                  KWEDIST (JP_I_E, J) = IUP + JP360 - KOLONG (J)
                  GOTO 250

                ENDIF

                IF (KOLONG (J) .LE. IUP) THEN

C                 Wrap around case: longitude point found between 0 and IUP
                  KWEIND (JP_I_W, J) = I
                  KWEIND (JP_I_E, J) = I + 1
                  IBASE = I
                  KWEDIST (JP_I_W, J) = KOLONG (J) + JP360 - ILOW
                  KWEDIST (JP_I_E, J) = IUP - KOLONG (J)
                  GOTO 250

                ENDIF

              ENDIF

            ENDDO

C           This statement will be reached if the output grid does not
C           fit within the input grid.
            IGDIWE = 6
            LO  = REAL(KOLONG(J))/PPMULT
            LO1 = REAL(KILONG(1))/PPMULT
            LO2 = REAL(KILONG(KIWE))/PPMULT
      CALL INTLOG( JP_ERROR,'IGDIWE: Output long. value number = ',J)
      CALL INTLOGR(JP_ERROR,'IGDIWE: Output long. value ',LO)
      CALL INTLOGR(JP_ERROR,'IGDIWE: outside input range = ',LO1)
      CALL INTLOGR(JP_ERROR,'IGDIWE: to ',LO2)
      CALL INTLOG(JP_FATAL,'IGDIWE: Interpolation failing.',JPQUIET)
            GOTO 900

  250     CONTINUE
          ENDDO

        ENDIF
  900   CONTINUE

      ELSE

        CALL INTLOG(JP_DEBUG,'IGDIWE: algorithm: new :-)',JPQUIET)

        IF( LGLOBL ) THEN

          DO J = 1, KOWE

            I = FLOOR( REAL((J-1)*KIWE)/REAL(KOWE) ) + 1
            KWEIND (JP_I_W,J) = I
            KWEIND (JP_I_E,J) = MOD(I,KIWE)+1

!C           original:
!            IKIWE = JP360 / KIWE
!            IKOWE = JP360 / KOWE
!            IA = (J-1)*IKOWE - (I-1)*IKIWE
!            IB = ( I )*IKIWE - (J-1)*IKOWE  ! (same as: IKIWE - A)

            IA = (J-1)*KIWE - (I-1)*KOWE
            IB = ( I )*KOWE - (J-1)*KIWE

!C           adimensionalize from KIWE*KOWE space (optional):
!            IA = INT( REAL(IA*JP360)*REAL(KIWE*KOWE) )
!            IB = INT( REAL(IB*JP360)*REAL(KIWE*KOWE) )

            KWEDIST(JP_I_W,J) = IA
            KWEDIST(JP_I_E,J) = IB

          ENDDO

        ELSE

C         (this also works globally, but it isn't precision-independent)
C         set grid increments
          IDELTA = REAL(360)/REAL(KIWE)
          ODELTA = REAL(360)/REAL(KOWE)
          IF( .NOT.LGLOBL .AND. KOWE.GT.1 ) THEN
            ODELTA = REAL(OAREA(4)-OAREA(2))/REAL(JPMULT*(KOWE-1))
          ENDIF

          LO1 = REAL(OAREA(2))/REAL(JPMULT)
          DO J = 1, KOWE

            LO = REAL(J-1)*ODELTA + LO1
            DO WHILE (LO.LT.0.)
              LO = LO + 360.
            ENDDO
            DO WHILE (LO.GE.360.)
              LO = LO - 360.
            ENDDO

            I = MOD(FLOOR( LO/IDELTA ),KIWE) + 1
            KWEIND (JP_I_W,J) = I
            KWEIND (JP_I_E,J) = MOD(I,KIWE)+1

            IA = INT(REAL(JPMULT)*(LO-REAL(I-1)*IDELTA   ))
           !IB = INT(REAL(JPMULT)*(   REAL( I )*IDELTA-LO)) (same as below)
            IB = INT(REAL(JPMULT)*IDELTA) - IA
            DO WHILE (IA.LT.0 .OR. IB.LT.0)
              IA = IA + INT(REAL(JPMULT)*IDELTA)
              IB = IB + INT(REAL(JPMULT)*IDELTA)
            ENDDO

            KWEDIST(JP_I_W,J) = IA
            KWEDIST(JP_I_E,J) = IB

          ENDDO

        ENDIF
        IGDIWE = 0

      ENDIF
      END

       PROGRAM CREATE_GTS_HEADER
c
c**** *CREATE_GTS_HEADER*
c
c
c     PURPOSE.
c     --------
c         Create GTS Meteorologibal message
c
c
c**   INTERFACE.
c     ----------
c
c          NONE.
c
c     METHOD.
c     -------
c
c          NONE.
c
c
c     EXTERNALS.
c     ----------
c
c
c     REFERENCE.
c     ----------
c
c          NONE.
c
c     AUTHOR.
c     -------
c
c          MILAN DRAGOSAVAC    *ECMWF*       2008/12/18
c
c
c     MODIFICATIONS.
c     --------------
c
c          NONE.
c
c

      IMPLICIT NONE
c


C  BUFR


      integer    JSUP
      integer    JSEC0
      integer    JSEC1
      integer    JSEC2
      integer    JSEC3
      integer    JSEC4
      integer    JELEM
      integer    JSUBS
      integer    JCVAL
      integer    JBUFL
      integer    JBPW
      integer    JTAB
      integer    JCTAB
      integer    JCTST
      integer    JCTEXT
      integer    JWORK
      integer    JKEY
      integer    JBYTE
      integer    KELEM,KVALS
      real*8     RVIND
      integer    NVIND
C
      PARAMETER(JSUP =   9,JSEC0=   3,JSEC1= 40,JSEC2=4096 ,JSEC3=    4,
     1        JSEC4=   2,JELEM=320000,JSUBS=400,JCVAL=150 ,JBUFL=300000,
     2          JBPW =  32,JTAB =3000,JCTAB=120,JCTST=1800,JCTEXT=1200,
     3          JWORK=4096000,JKEY=46,JBYTE=440000)
C
C
      PARAMETER (KELEM=320000)
      PARAMETER (KVALS=4096000)


      PARAMETER (RVIND=1.7D38)
      PARAMETER (NVIND=2147483647)

      integer   KBUFF(JBUFL)
      integer   KSUP(JSUP)
      integer   KSEC0(JSEC0)
      integer   KSEC1(JSEC1)
      integer   KSEC2(JSEC2)
      integer   KSEC3(JSEC3)
      integer   KSEC4(JSEC4)
      integer   KEY(JKEY)
      integer   KREQ(2)
      integer   KTDLST(JELEM)
      integer   KTDEXP(JELEM)
      integer   KDATA(200)

      integer   KBUFL

      real*8    VALUES(KVALS)

      character*64   CNAMES(KELEM)
      character*24   CUNITS(KELEM)
      character*80   CVALS(KELEM)

      integer                     KTDLEN,KDLENG
      integer                     KPMISS, KPRUS, NOKEY, NOFL, ILEN
      integer                     KERR

c
c 
c
      CHARACTER*256 CARG(10)
c
      CHARACTER*1 ETX
      CHARACTER*2 CII
      CHARACTER*3 CBBB,CRCRLF,SEQUENCE
      CHARACTER*6 CDATE,CDATEOLD
      CHARACTER*4 AHR
      CHARACTER*6 TTAAII
      CHARACTER*4 CCCC, SOHCRCRLF
      CHARACTER*256 CINFILE
      CHARACTER*256 COUTFILE
      CHARACTER*120000 YBUFR,YOUT
      CHARACTER*8 TOTALSIZE

      INTEGER NARG,IARGC,J,IN,IO,IUNIT,IRET,IUNIT1,INNN,IERR,N,II
      INTEGER KBUFR(JBUFL)
      INTEGER KBUFS(JBUFL)

      EQUIVALENCE(YBUFR,KBUFS)
      EQUIVALENCE(YOUT,KBUFR)
c     ------------------------------------------------------------------
c*          1. INITIALIZE CONSTANTS AND VARIABLES.
c              -----------------------------------
 100  CONTINUE
 
c     General abbreviated header is T1T2A1A2ii


      CRCRLF=char(13)//char(13)//char(10)
      SOHCRCRLF=char(1)//char(13)//char(13)//char(10)
      ETX=char(3)
 
c     GET INPUT AND OUTPUT FILE NAME.
 
      NARG=IARGC()
 
      DO J=1,NARG
      CALL GETARG(J,CARG(J))
      END DO

      cinfile=' '
      coutfile=' '
      cbbb=' '
      cccc=' '
      ahr=' '
      cdate=' '

      DO J=1,NARG,2
      IF(CARG(J).EQ.'-i') THEN
         CINFILE=CARG(J+1)
         IN=index(CINFILE,' ')
         IN=IN-1
      ELSEIF(CARG(J).EQ.'-o') THEN
         COUTFILE=CARG(J+1)
         IO=index(COUTFILE,' ')
         IO=IO-1
      ELSEIF(CARG(J).EQ.'-t') THEN
         TTAAII=CARG(J+1)
      ELSEIF(CARG(J).EQ.'-c') THEN
         CCCC=CARG(J+1)
      ELSEIF(CARG(J).EQ.'-b') THEN
         CBBB=CARG(J+1)
      END IF
      END DO
 
      IF(CINFILE .EQ.' '.OR. COUTFILE .EQ.' '.OR. TTAAII .EQ.' '
     1   .OR. CCCC.EQ.' ') THEN
         PRINT*,'USAGE -- create_gts_header -i infile -o outfile',
     1   ' -t T1T2A1A2ii -c CCCC -b BBB'
         STOP
      END IF
 
c*          1.2 OPEN FILE CONTAINING BUFR DATA.
 120  CONTINUE

      CALL PBOPEN(IUNIT,CINFILE(1:IN),'R',IRET)
      IF(IRET.EQ.-1) STOP 'OPEN FAILED ON INPUT FILE'
      IF(IRET.EQ.-2) STOP 'INVALID FILE NAME'
      IF(IRET.EQ.-3) STOP 'INVALID OPEN MODE SPECIFIED'

      CALL PBOPEN(IUNIT1,COUTFILE(1:IO),'W',IRET)
      IF(IRET.EQ.-1) STOP 'OPEN FAILED ON OUTPUT FILE'
      IF(IRET.EQ.-2) STOP 'INVALID FILE NAME'
      IF(IRET.EQ.-3) STOP 'INVALID OPEN MODE SPECIFIED'
 
c     ----------------------------------------------------------------- 
 
      INNN=0
      CDATEOLD=' '
 
c*          3.  READ BUFR MESSAGE.
c               ------------------
 300  CONTINUE
 
      IERR=0
      KBUFL=0
 
      CALL PBBUFR(IUNIT,KBUFS,JBYTE*4,KBUFL,IERR) 
      IF(IERR.EQ.-1) THEN
         PRINT*,'NUMBER OF MESSAGES    ',N
         STOP 'EOF'
      END IF
      IF(IERR.EQ.-2) STOP 'FILE HANDLING PROBLEM' 
      IF(IERR.EQ.-3) STOP 'ARRAY TOO SMALL FOR PRODUCT'
 
      INNN=INNN+1
      if(INNN.GT.999) INNN=1
      write(SEQUENCE(1:3),'(I3.3)') INNN
      N=N+1
c     PRINT*,'----------------------------------',N,' ',KBUFL
c
c     -----------------------------------------------------------------
c*          4. EXPAND BUFR MESSAGE.
c              --------------------
 400  CONTINUE
c
      CALL BUS012( KBUFL,KBUFS,KSUP,KSEC0,KSEC1,KSEC2,IERR)
      IF(IERR.NE.0) THEN
         PRINT*,'ERROR IN BUS012: ',IERR
         PRINT*,' BUFR MESSAGE NUMBER ',N,' CORRUPTED.'
         IERR=0
         GO TO 300
      END IF
c
      write(CDATE(1:2),'(I2.2)') KSEC1(11)
      write(CDATE(3:4),'(I2.2)') KSEC1(12)
      write(CDATE(5:6),'(I2.2)') KSEC1(13)
      if(CDATE.eq.CDATEOLD) THEN
         II=II+1
      else
         CDATEOLD=CDATE
      end if
      write(CII(1:2),'(i2.2)') ii
      yout(9:10)='00'
      yout(11:14)=SOHCRCRLF
      yout(15:17)=SEQUENCE
      yout(18:20)=CRCRLF
      yout(21:26)=TTAAII
C     yout(25:26)=CII
      yout(27:27)=' '
      yout(28:31)=CCCC
      yout(32:32)=' '
      yout(33:38)=CDATE
      if(CBBB.ne.' ') THEN
         yout(39:39)=' '
         yout(40:42)=CBBB
         yout(43:45)=CRCRLF
         yout(46:46+KBUFL-1)=YBUFR(1:KBUFL)
         yout(46+KBUFL:)=CRCRLF//ETX
         ILEN=KSEC0(2)+39
         write(TOTALSIZE,'(i8.8)') ILEN
         yout(1:8)=TOTALSIZE
         ILEN=ILEN+10
      else
         yout(39:41)=CRCRLF
         yout(42:42+KBUFL-1)=YBUFR(1:KBUFL)
         ilen=42+KBUFL-1
         yout(42+KBUFL:)=CRCRLF//ETX
         ILEN=KSEC0(2)+35
         write(TOTALSIZE,'(i8.8)') ILEN
         yout(1:8)=TOTALSIZE
         ILEN=ILEN+10
      end if
c
      CALL PBWRITE(IUNIT1,KBUFR,ILEN,IERR)
      IF(IERR.LT.0) THEN
         PRINT*,'ERROR WRITING INTO TARGET FILE.'
         CALL EXIT(2)
      END IF
      PRINT*,'RECORD WRITTEN INTO FILE '
c
       GO TO 300
      END 

C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE JREADLL( KUNIT, KTRUNC, PBUILD, PLAT, PLEG, KRET)
C
C---->
C**** JREADLL
C
C     PURPOSE
C     _______
C
C     This routine reads legendre functions for one latitude.
C
C     INTERFACE
C     _________
C
C     CALL JREADLL( KUNIT, KTRUNC, PBUILD, PLAT, PLEG, KRET)
C
C     Input parameters
C     ________________
C
C     KUNIT   - Unit number for open file of legendre functions.
C     KTRUNC  - Truncation.
C     PBUILD  - Grid interval used to build legendre coefficients file
C     PLAT    - Latitude in degrees.
C
C     Output parameters
C     ________________
C
C     PLEG     - Array of legendre functions for the latitude.
C     KRET     - Return status code
C                0 = OK
C
C     Common block usage
C     __________________
C
C     None.
C
C     Method
C     ______
C
C     Calculate offset of the legendre functions for the latitude row 
C     in the file, skip to the row and read the functions.
C
C     Retries the read upto 3 times if necessary
C
C     Externals
C     _________
C
C     PBSEEK    - Position the coefficients file
C     PBREAD    - Read the coefficients file
C     INTLOG   - Output log message
C     INTLOGR  - Output log message (with real value)
C
C     Reference
C     _________
C
C     None.
C
C     Comments
C     ________
C
C     Only positive latitude values are allowed.
C
C     AUTHOR
C     ______
C
C     J.D.Chambers      *ECMWF*      Nov 1993
C
C     MODIFICATIONS
C     _____________
C
C     None.
C
C----<
C     _______________________________________________________
C
C
      IMPLICIT NONE
#include "jparams.h"
#include "parim.h"
C
C     Subroutine arguments
C
      INTEGER KUNIT, KTRUNC, KRET
      REAL PBUILD, PLEG, PLAT
      DIMENSION PLEG(*)
C
C     Parameters
      INTEGER JPROUTINE
      PARAMETER ( JPROUTINE = 31100 )
C
C     Local variables
C
      INTEGER NTRIES
      INTEGER NSIZE, NRET
      INTEGER*8 FSIZE, FRET
      INTEGER*8 NEWPOS, OLDPOS

      REAL ZLAT
      DATA OLDPOS/-1/
      SAVE NEWPOS, OLDPOS
C
C     _______________________________________________________
C
C*    Section 1.    Initialization.
C     _______________________________________________________
C
100   CONTINUE
      IF ( PLAT .LT. 0.0 ) THEN
        ZLAT = 0.0
      ELSE
        ZLAT = PLAT
      ENDIF
C
C     Calculate the byte offset into the file where the legendre
C     functions for the latitude should be.
#ifdef REAL_8
      NSIZE   = 8 * (KTRUNC+1)*(KTRUNC+4)/2
      FSIZE   = 8 * (KTRUNC+1)*(KTRUNC+4)/2
#else
      NSIZE   = 4 * (KTRUNC+1)*(KTRUNC+4)/2
      FSIZE   = 4 * (KTRUNC+1)*(KTRUNC+4)/2
#endif
cs      NEWPOS = NINT( (90.0 - ZLAT)/PBUILD ) * NSIZE
      NEWPOS = NINT( (90.0 - ZLAT)/PBUILD ) * FSIZE
C
C     _______________________________________________________
C
C*    Section 2.    Processing.
C     _______________________________________________________
C
C     Position file unless the previous read left it in the correct 
C     position already
C
      NTRIES = 0
 210  CONTINUE
      NTRIES = NTRIES + 1
      IF ( NEWPOS .NE. OLDPOS ) THEN
        CALL PBSEEK64( KUNIT, NEWPOS, 0, FRET)
        IF ( FRET .NE. NEWPOS ) THEN
          CALL INTLOG(JP_ERROR,'JREADLL: PBSEEK64 error.',FRET)
	  KRET = JPROUTINE + 2
	  GOTO 990
	ENDIF
      ENDIF
C
C     Read the legendre coefficients
      CALL PBREAD( KUNIT, PLEG, NSIZE, NRET)
      IF ( NRET .NE. NSIZE ) THEN
	IF ( NTRIES .EQ. JPMXTRY ) THEN
          CALL INTLOG(JP_ERROR,'JREADLL: PBREAD error.',NRET)
	  KRET = JPROUTINE + 3
	  GOTO 990
	ELSE
	  GOTO 210
        ENDIF
      ENDIF
C
C     Record the current file byte position
      OLDPOS = NEWPOS + NSIZE
C     _______________________________________________________
C
C*    Section 9. Return to calling routine. Format statements
C     _______________________________________________________
C
 900  CONTINUE
      KRET = 0
C
 990  CONTINUE
      RETURN
      END

C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities
C granted to it by virtue of its status as an intergovernmental organisation
C nor does it submit to any jurisdiction.
C

      SUBROUTINE BUPRT(K,KSUB1,KSUB2,KELEM,CNAMES,CUNITS,
     1                 CVALS,KVALS,VALUES,KSUP,KSEC1,KERR)
C
C**** *BUPRT*
C
C
C     PURPOSE.
C     --------
C           PRINT EXPANDED BUFR MESSAG.
C
C
C**   INTERFACE.
C     ----------
C
C           *CALL* *BUPRT(K,KSUB1,KSUB2,KELEM,CNAMES,CUNITS,
C                         CVALS,KVALS,VALUES,KSUP,KSEC1,KERR)*
C
C        INPUT :
C               *K*       -  SWITCH TO PRINT WITH/WITOUT CONTENT OF CODE TABLES
C                            0  - NO  CODE TABLE CONTENT
C                            1  - YES CODE TABLE CONTENT
C               *KSUB1*   -  STARTING SUBSET
C               *KSUB2*   -  ENDING SUBSET
C               *KELEM*   -  DIMENSION OF CNAMES, CUNITS ARRAY
C               *CNAMES*  -  CHARACTER ARRAY CONTAINING ELEMENT NAMES
C               *CUNITS*  -  CHARACTER ARRAY CONTAINIG UNITS
C               *CVALS*   -  CHARACTER ARRAY CONTAINING BUFR CODE TABLE
C                            ENTRIES
C               *KVALS*   -  DIMENSION OF VALUES ARRAY
C               *VALUES*  -  REAL ARRAY (EXPANDED DATA VALUES)
C               *KSUP*    -  ARRAY CONTAINING SUPLEMENTARY INFORMATION
C                         -  KSUP( 1) -- IDIM1, DIMENSION OF KSEC1
C                         -  KSUP( 2) -- IDIM2, DIMENSION OF KSEC2
C                         -  KSUP( 3) -- IDIM3, DIMENSION OF KSEC3
C                         -  KSUP( 4) -- IDIM4, DIMENSION OF KSEC4
C                         -  KSUP( 5) -- M (NUMBER OF ELEMENTS IN VALUES ARRAY,
C                                           FIRST INDEX)
C                         -  KSUP( 6) -- N (NUMBER OF SUBSETS,SECOND INDEX OF
C                                           VALUES ARRAY)
C                         -  KSUP( 7) -- JVC (NUMBER OF ELEMENTS IN CVAL ARRAY)
C                         -  KSUP( 8) -- TOTAL BUFR MESSAGE LENGTH IN BYTES
C                         -  KSUP( 9) -- IDIM0, DIMENSION OF KSEC0
C               *KSEC1*   -  ARRAY CONTAINING SECTION 1 INFORMATION
C                            KSEC1( 1)-- LENGTH OF SECTION 1 (BYTES)
C                            KSEC1( 2)-- BUFR EDITION NUMBER
C                            KSEC1( 3)-- ORIGINATING CENTRE
C                            KSEC1( 4)-- UPDATE SEQUENCE NUMBER
C                            KSEC1( 5)-- FLAG (PRESENCE OF SECTION 2)
C                            KSEC1( 6)-- BUFR MESSAGE TYPE
C                            KSEC1( 7)-- BUFR MESSAGE SUBTYPE
C                            KSEC1( 8)-- VERSION NUMBER OF LOCAL TABLE USED
C                            KSEC1( 9)-- YEAR
C                            KSEC1(10)-- MONTH
C                            KSEC1(11)-- DAY
C                            KSEC1(12)-- HOUR
C                            KSEC1(13)-- MINUTE
C                            KSEC1(14)-- BUFR MASTER TABLE
C                            KSEC1(15)-- VERSION NUMBER OF MASTER TABLE USED
C                            KSEC1(16) - KSEC1(JSEC1) -- LOCAL ADP CENTRE
C                                        INFORMATION(BYTE BY BYTE)
C
C                            FOR BUFR EDITION 3 ONWARD
C
C                            KSEC1(16)-- ORIGINATING SUB-CENTRE
C                            KSEC1(17)-- NOT USED
C                            KSEC1(18) TO KSEC1(JSEC1) - LOCAL ADP CENTRE
C                                        INFORMATION(PACKED FORM)
C
C                            FOR BUFR EDITION 4 ONWARD
C
C                            KSEC1(16)-- ORIGINATING SUB-CENTRE
C                            KSEC1(17)-- INTERNATIONAL SUB-CATEGORY (SEE COMMON TABLE C-13
C                            KSEC1(18)-- SECOND
C                            KSEC1(19)-- YEAR
C                            KSEC1(20)-- MONTH
C                            KSEC1(21)-- DAY
C                            KSEC1(22)-- HOUR
C                            KSEC1(23)-- MINUTE
C                            KSEC1(24)-- SECOND
C                            KSEC1(25)-- YEAR
C                            KSEC1(26)-- MONTH
C                            KSEC1(27)-- DAY
C                            KSEC1(28)-- HOUR
C                            KSEC1(29)-- MINUTE
C                            KSEC1(30)-- SECOND
C                            KSEC1(31)-- MOST SOUTHERN LATITUDE  (-90 to 90)
C                            KSEC1(32)-- MOST WESTERN LONGITUDE  ( 0-360)
C                            KSEC1(33)-- MOST NORTHEN LATITUDE   (-90 to 90)
C                            KSEC1(34)-- MOST EASTERN LONGITUDE  ( 0-360)
C                            KSEC1(35) TO KSEC1(JSEC1) - LOCAL ADP CENTRE INFORMATION(PACKED FORM)
C
C        OUTPUT:
C               *KERR*    -  RETURNED ERROR CODE
C
C
C
C
C     METHOD.
C     -------
C
C            NONE
C
C     EXTERNALS.
C     ----------
C
C            NONE.
C
C     REFERENCE.
C     ----------
C
C          NONE.
C
C     AUTHOR.
C     -------
C
C          M. DRAGOSAVAC    *ECMWF*       04/02/91.
C
C     MODIFICATIONS.
C     --------------
C
C          NONE.
C
      IMPLICIT LOGICAL(L,O,G), CHARACTER*8(C,H,Y)
C
C
#     include "parameter.F"
#     include "bcomunit.F"
#     include "bcomwork.F"
#     include "bcomroot.F"
C
      DIMENSION KTDLST(JELEM)
      DIMENSION KTDEXP(JELEM)
C
      CHARACTER*256 YCODE
      CHARACTER*64 YFLAG(32)
      CHARACTER*64 CNAMES(KELEM)
      CHARACTER*24 CUNITS(KELEM)
      CHARACTER*80 CVALS(KVALS)
      CHARACTER YCHAR*30,YLONG*320
#ifndef R_4
      REAL*8 RVIND
      REAL*8 EPS
      REAL*8 VALUES(KVALS)
#else
      REAL   RVIND
      REAL   EPS
      REAL   VALUES(KVALS)
#endif
C
      DIMENSION KSUP(JSUP),KSEC1(JSEC1)
C
C
C     ------------------------------------------------------------------
C
C*          1.   PRINT BUFR MESSAGE.
C                -------------------
 100  CONTINUE
C
      KERR=0
      YCODE=' '
C
      ISUB1=KSUB1
      ISUB2=KSUB2
      IF(ISUB1.LE.0.OR.ISUB2.LE.0) THEN
         WRITE(KNTN,'(A)')    ' WARNING - NEGATIVE KSUB1 OR KSUB2.'
         WRITE(KNTN,'(A,I5)') ' WARNING - NUMBER OF SUBSETS IS ',KSUP(6)
         RETURN
      END IF
      IF(ISUB1.GT.KSUP(6)) THEN
         WRITE(KNTN,'(A,I5)') ' WARNING - NUMBER OF SUBSETS IS ',KSUP(6)
         RETURN
      END IF
      IF(ISUB2.GT.KSUP(6)) THEN
         ISUB2=KSUP(6)
         WRITE(KNTN,'(A,I5)') ' WARNING - KSUB2 REPLACED BY ',KSUP(6)
      END IF
C
      IF(.NOT. OCTABLE) K=0
C
      IF(K.EQ.0) THEN
C
            DO 103 JB=ISUB1,ISUB2
            CALL BUSEL2(JB,KELEM,KTDLEN,KTDLST,KTDEXL,KTDEXP,CNAMES,
     1                  CUNITS,KERR)
C
            ILN=0
            WRITE(KNTN,'(1H )')
C
            DO 104 JA=1,KTDEXL
C
            ILN=ILN+1
            JAJB=JA+(JB-1)*KELEM
C
            IF(ABS(VALUES(JAJB)-RVIND)/RVIND.LT.EPS) THEN
               WRITE(KNTN,9918) ILN,CNAMES(JA),CUNITS(JA)
            ELSE
               IF(CUNITS(JA)(1:4).EQ.'CCIT') THEN
                  I=NINT(VALUES(JAJB)/1000)
                  NCHAR=VALUES(JAJB)-I*1000
                  NW=NCHAR/80
                  NWOFF=NCHAR-NW*80
                  IF(NWOFF.NE.0) NW=NW+1
C
                  YLONG=' '
                  YLONG(1:80)=CVALS(I)
C
                  II=I
                  DO 125 JC=1,NW-1
                  II=II+1
                  KF=JC*80+1
                  KL=(JC+1)*80
                  YLONG(KF:KL)=CVALS(II)
 125              CONTINUE
C
                  NLINE=NCHAR/30
                  IDIF =NCHAR-NLINE*30
                  IF(IDIF.NE.0) NLINE=NLINE+1
                  YCHAR=' '
                  YCHAR=YLONG(1:30)
C
                  WRITE(KNTN,9919)ILN,CNAMES(JA),VALUES(JAJB),
     1                         CUNITS(JA),YCHAR
C
                  IF(NLINE.GT.1) THEN
                     DO 130 JJ=1,NLINE-1
C
                     K2=JJ*30+1
                     K1=(JJ+1)*30
                     YCHAR=' '
                     YCHAR=YLONG(K2:K1)
C
                     WRITE(KNTN,9920) YCHAR
 130                 CONTINUE
C
                   END IF
               ELSE
                  WRITE(KNTN,9917) ILN,CNAMES(JA),VALUES(JAJB),
     1            CUNITS(JA)
               END IF
            END IF
C
 104        CONTINUE
 103        CONTINUE
C
      END IF
C
      IF(K.EQ.1) THEN
C
C---------------------------------------------------------------------
          WRITE(KNTN,'(1H1)')
C
C---------------------------------------------------------------------
C
          DO 150 JB=ISUB1,ISUB2
          CALL BUSEL2(JB,KELEM,KTDLEN,KTDLST,KTDEXL,KTDEXP,CNAMES,
     1                  CUNITS,KERR)
C
          ILN=0
          WRITE(KNTN,'(1H )')

C
          DO 160 JA=1,KTDEXL
C
          ILN=ILN+1
C
          JAJB=JA+(JB-1)*KELEM
C
          IF(ABS(VALUES(JAJB)-RVIND)/RVIND.LT.EPS) THEN
             WRITE(KNTN,9918) ILN,CNAMES(JA),CUNITS(JA)
          ELSE
             IF(CUNITS(JA)(1:4).EQ.'CCIT') THEN
                  I=NINT(VALUES(JAJB)/1000)
                  NCHAR=VALUES(JAJB)-I*1000
                  NW=NCHAR/80
                  NWOFF=NCHAR-NW*80
                  IF(NWOFF.NE.0) NW=NW+1
C
                  YLONG=' '
                  YLONG(1:80)=CVALS(I)
C
                  II=I
                  DO 1125 JC=1,NW-1
                  II=II+1
                  KF=JC*80+1
                  KL=(JC+1)*80
                  YLONG(KF:KL)=CVALS(II)
1125              CONTINUE
C
                  NLINE=NCHAR/30
                  IDIF =NCHAR-NLINE*30
                  IF(IDIF.NE.0) NLINE=NLINE+1
                  YCHAR=' '
                  YCHAR=YLONG(1:30)
C
                  WRITE(KNTN,9919)ILN,CNAMES(JA),VALUES(JAJB),
     1                         CUNITS(JA),YCHAR
C
                  IF(NLINE.GT.1) THEN
                     DO 1130 JJ=1,NLINE-1
C
                     K2=JJ*30+1
                     K1=(JJ+1)*30
                     YCHAR=' '
                     YCHAR=YLONG(K2:K1)
C
                     WRITE(KNTN,9920) YCHAR
1130                 CONTINUE
C
                  END IF

             ELSEIF(CUNITS(JA)(1:4).EQ.'CODE') THEN
                 KCODE=NINT(VALUES(JAJB))
                 CALL GETCODE(KTDEXP(JA),KCODE,YCODE,IERR)
                 DO IZ=256,1,-1
                 IF(YCODE(IZ:IZ).NE.' ') THEN
                    IZZ=IZ
                    GO TO 161
                 END IF
                 END DO
 161             CONTINUE
                 IKK=IZZ/64+1
                 WRITE(KNTN,9919) ILN,CNAMES(JA),VALUES(JAJB),
     1           CUNITS(JA), YCODE(1:64)

                 IF(IKK.GT.1) THEN
                 IIII=65
                 DO IK=2,IKK
                 WRITE(KNTN,9920) YCODE(iiii:iiii+64-1)
                 IIII=IIII+64
                 END DO
                 END IF
             ELSEIF(CUNITS(JA)(1:4).EQ.'FLAG') THEN
                 KCODE=NINT(VALUES(JAJB))
                 CALL GETFLAG(KTDEXP(JA),KCODE,KFLAG,YFLAG,IERR)
                 IF (IERR.NE.0) THEN
         WRITE(KNTN,'(A,I5)') ' WARNING - BUPRT: GETFLAG IERR = ', IERR
         WRITE(KNTN,'(A)')    ' WARNING - BUPRT: CANNOT CONTINUE'
                   KERR = IERR
                   RETURN
                 END IF
                 WRITE(KNTN,9919) ILN,CNAMES(JA),VALUES(JAJB),
     1           CUNITS(JA), YFLAG(1)
                 IF(KFLAG.GT.1) THEN
                 DO IZ=2,KFLAG
                 WRITE(KNTN,9920) YFLAG(IZ)
                 END DO
                 END IF
             ELSE
                 WRITE(KNTN,9917) ILN,CNAMES(JA),VALUES(JAJB),
     1           CUNITS(JA)
             END IF
          END IF

  160     CONTINUE
  150     CONTINUE
C
        END IF
C
C
C       RETURN
C
C     ------------------------------------------------------------------
C
 200  CONTINUE
C
C     ------------------------------------------------------------------
 9917 FORMAT(1H ,I6,1X,A32,1X,E23.14E3,1X,A24)
 9918 FORMAT(1H ,I6,1X,A32,1X,'                MISSING',1X,A24)
 9919 FORMAT(1H ,I6,1X,A32,1X,E23.14E3,1X,A24,1X,A)
 9920 FORMAT(1H ,89X,A)
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities
C granted to it by virtue of its status as an intergovernmental organisation
C nor does it submit to any jurisdiction.
C

#define INT_MISSING -2147483647

      SUBROUTINE CLEAR_C( )
C
C---->
C**** CLEAR_C
C
C     Purpose
C     -------
C
C     Sets start values for parameters in common block.
C
C
C     Interface
C     ---------
C
C     CALL CLEAR_C()
C
C
C     Method
C     ------
C
C     Hard coded defaults.
C
C
C     Externals
C     ---------
C
C     None.
C
C
C     Author
C     ------
C
C     J.D.Chambers       ECMWF        August 1994.
C
C----<
C
C     IMPLICIT NONE
#include "parim.h"
#include "nifld.common"
#include "nifld.extracommon"
#include "nofld.common"
#include "grfixed.h"
#include "current.h"
C
C     ------------------------------------------------------------------
C*    Section 1.   Initialise
C     ------------------------------------------------------------------
C
  100 CONTINUE
C
C     Set default processing flag settings.
C
      LCHANGE     = .TRUE.
      LSMCHNG     = .TRUE.
      LSM         = .TRUE.
      LPREC       = .FALSE.
      LWIND       = .FALSE.
      LOCTAHEDRAL = .FALSE.
C
C     Set default area indexes.
C
      NINS  = 0
      NIWE  = 0
      NO1NS = 0
      NO1WE = 0
      NONS  = 0
      NOWE  = 0
C
C     Defaults for output GRIB record ..
C     .. ECMWF local code table 128
C     .. level 500 hPa
C
      NOPARAM = 0
      NOTABLE = 128
      NOLEVT  = 100
      NOLEVEL = 500
      NOHFUNC = 'A'
C
C     Turn off all flags indicating that user has given a value.
C
      LSMPARSET = .FALSE.
      LSMSET    = .FALSE.
      LPRECSET  = .FALSE.
      LWINDSET  = .FALSE.
      LNIGAUS   = .FALSE.
      LNGSPEC   = .FALSE.
      LIGIVEL   = .FALSE.
      LIGIVEP   = .FALSE.
      LOGIVEL   = .FALSE.
      LOGIVEP   = .FALSE.
      LNOAREA   = .FALSE.
      LNORESO   = .FALSE.
      LNOGAUS   = .FALSE.
      LNOACC    = .FALSE.
      LNOREPR   = .FALSE.
      LNOTABL   = .FALSE.
      LNOPARA   = .FALSE.
      LNOLEVL   = .FALSE.
      LNOLEVT   = .FALSE.
      LNOGRID   = .FALSE.
      LNOFRAME  = .FALSE.
      LNOSTYLE  = .FALSE.
      LARESOL   = .FALSE.
      LINTOUT   = .FALSE.
      LIMISSV   = .FALSE.
      LDOUBLE   = .FALSE.
C
      RMISSGV   = REAL(INT_MISSING)
C
C     Clear input and output gaussian grid definitions
C
      NIGAUSS = 0
      RIGAUSS(1:JPLAT) = 0.0
      MILLEN (1:JPLAT) = 0

      NOGAUSS = 0
      ROGAUSS(1:JPLAT) = 0.0
      NOLPTS (1:JPLAT) = 0
C
C     Clear information about gaussian field definitions
C
      NGSPEC  = 0
      NIGAUSO = 0
      NOGAUSO = 0
      HIGAUST = 'X'
      HOGAUST = 'X'
C
C     Clear rotation angle values.
C
      NOROTA(1) = 0
      NOROTA(2) = 0
      LNOROTA   = .FALSE.
      LO12PT = .TRUE.
      LMETHOD = .FALSE.
      LNNLSM        = .FALSE.
      LNNLSM_CY41R1 = .FALSE.
C
C     Clear style and frame values
C
      NOFRAME = 0
      NOSTYLE = JPSMARS
C
C     Clear flags showing how to deal with legendre coefficients
C
      LFILEIO = .FALSE.
      LMEMORY = .FALSE.
      LSHARED = .FALSE.
      LON_FLY = .FALSE.
      LMAPPED = .FALSE.
      LIFIRST = .TRUE.
C
C     Clear fields for ISLSCP processing
C
      IF( LNIISCL ) THEN
        CALL JFREE(NIPOGRB)
        CALL JFREE(NIPNGRB)
      ENDIF
      LNIISCL = .FALSE.
C
C     ------------------------------------------------------------------
C*    Section 9.   Closedown.
C     ------------------------------------------------------------------
C
  900 CONTINUE
C
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE BURQC(KBUFL,KBUFF,KELEM,CNAMES,CUNITS,KSUP,KSEC3,KERR)
C
C**** *BURQC*
C
C
C     PURPOSE.
C     --------
C
C          CREATE PARAMETERS NEEDED FOR PARTIAL EXPANSION OF
C     BUFR MESSAGE WITH COMPRESSED DATA ACCORDING TO REQUESTED
C     INPUT LISTS.
C
C
C**   INTERFACE.
C     ----------
C
C          *CALL* *BURQC(KBUFL,KBUFF,KELEM,CNAMES,CUNITS,KSUP,KSEC3,KERR)*
C
C        INPUT :
C               *KBUFL*   -  LENGTH OF BUFR MESSAGE (WORDS)
C               *KBUFF*   -  ARRAY CONTAINING BUFR MESSAGE
C               *KELEM*   -  DIMENSION OF CNAMES, CUNITS ARRAY
C               *CNAMES*  -  CHARACTER ARRAY CONTAINING ELEMENT NAMES
C               *CUNITS*  -  CHARACTER ARRAY CONTAINIG UNITS
C               *KSUP*    -  ARRAY CONTAINING SUPLEMENTARY INFORMATION
C                         -  KSUP( 1) -- IDIM1, DIMENSION OF KSEC1
C                         -  KSUP( 2) -- IDIM2, DIMENSION OF KSEC2
C                         -  KSUP( 3) -- IDIM3, DIMENSION OF KSEC3
C                         -  KSUP( 4) -- IDIM4, DIMENSION OF KSEC4
C                         -  KSUP( 5) -- M (NUMBER OF ELEMENTS IN VALUES ARRAY,
C                                           FIRST INDEX)
C                         -  KSUP( 6) -- N (NUMBER OF SUBSETS,SECOND INDEX OF
C                                           VALUES ARRAY)
C                         -  KSUP( 7) -- JVC (NUMBER OF ELEMENTS IN CVAL ARRAY)
C                         -  KSUP( 8) -- TOTAL BUFR MESSAGE LENGTH IN BYTES
C                         -  KSUP( 9) -- IDIM0, DIMENSION OF KSEC0
C               *KSEC3*   -  ARRAY CONTAINING SECTION 3 INFORMATION
C                            KSEC3( 1)-- LENGTH OF SECTION 3 (BYTES)
C                            KSEC3( 2)-- RESERVED
C                            KSEC3( 3)-- NUMBER OF SUBSETS
C                            KSEC3( 4)-- FLAG (DATA TYPE,DATA COMPRESSION)
C               *KERR*    -  RETURNED ERROR CODE
C
C     METHOD.
C      -------
C
C          WORD AND BIT POINTERS ARE CALCULATED FOR EVERY ELEMENT
C     IN THE EXPANDED LIST OF ELEMENTS. IF PARTIAL EXPANSION REQUESTED,
C     INDECES TO REQUIRED ELEMENTS ARE DETERMINED, AS WELL AS CORRESPONDING
C     QUALITY CONTROL, STATISTICS ETC. INFORMATION.
C
C
C     EXTERNALS.
C     ----------
C
C          BUNPCK          - UNPACKS BIT PATTERN
C          BUNPKS         - UNPACKS BIT PATTERN IN REPEATED WAY
C
C     REFERENCE.
C     ----------
C
C          NONE.
C
C     AUTHOR.
C     -------
C
C          M. DRAGOSAVAC    *ECMWF*       01/02/91.
C
C
C     MODIFICATIONS.
C     --------------
C
C          NONE.
C
C
      IMPLICIT LOGICAL(L,O,G), CHARACTER*8(C,H,Y)
C
C
#     include "parameter.F"
#     include "bcomunit.F"
#     include "bcomwork.F"
#     include "bcombef.F"
#     include "bcomwt.F"
#     include "bcomp.F"
#     include "bcomwtc.F"
#     include "bcomrq.F"
#     include "bcomreq.F"
C
      CHARACTER*64 CWTEN
      CHARACTER*24 CWTU
      CHARACTER*64 CNAMES(KELEM)
      CHARACTER*24 CUNITS(KELEM)
C
      DIMENSION KSUP(JSUP),KSEC3(JSEC3)
      DIMENSION KBUFF(KBUFL)
C
      DIMENSION IRQEI(JELEM),IQCI(JELEM),IQCDPI(JELEM)
      DIMENSION IBVAL(JELEM),IBV(JELEM)
      DIMENSION IC7(JELEM),IC8(JELEM),IC7R(JELEM),IC8R(JELEM)
      DIMENSION NQP(JELEM),ITYPE(100)
C
#ifndef R_4
      REAL*8 RVIND
      REAL*8 EPS
      REAL*8 RQVAL
      REAL*8 VAL
#else
      REAL   RVIND
      REAL   EPS
      REAL   RQVAL
      REAL   VAL
#endif
      DIMENSION IMASK(8)
C
      SAVE IBV,IBVAL
C
      DATA IMASK /1,2,4,8,16,32,64,128/
C
C
C     ------------------------------------------------------------------
C
C*          1.  DEFINE WORD/BIT POINTERS TO EVERY ELEMENT.
C               ------------------------------------------
 100  CONTINUE
C
      IF(KERR.GT.0) RETURN
C
      NFCM=1
      NFUCM=0
C
C     CHECK REQUEST VALIDITY
C
      IF(NREQ(1).EQ.0.AND.NREQ(2).NE.0) THEN
         KERR=38
         CALL BUERR(KERR)
         RETURN
      END IF
C
      MREL=0
C
      IBP32= 32 + NBPTB
C
      IB1=0
      IF(IAND(NREQ(2),IMASK(1)).NE.0) IB1=1
      IB2=0
      IF(IAND(NREQ(2),IMASK(2)).NE.0) IB2=1
      IB3=0
      IF(IAND(NREQ(2),IMASK(3)).NE.0) IB3=1
      IB4=0
      IF(IAND(NREQ(2),IMASK(4)).NE.0) IB4=1
      IB5=0
      IF(IAND(NREQ(2),IMASK(5)).NE.0) IB5=1
      IB6=0
      IF(IAND(NREQ(2),IMASK(6)).NE.0) IB6=1
C
C*          1.1 COMPRESSED DATA.
C               ----------------
 110  CONTINUE
C
      IBIT=IBP32
      IWORD=IBIT/NBPW
C
      NWORDP(1)=NWPTB+IWORD
      NBITP (1)=IBIT-IWORD*NBPW
C
      DO 111 I=2,M+1
      IWRD=NWORDP(I-1)
      IBTP=NBITP (I-1)
C
      IF(NWTDW(I-1).EQ.0) THEN
         NBITP(I) =NBITP(I-1)
         NWORDP(I)=NWORDP(I-1)
         GO TO 111
      END IF
C
      IBTP=IBTP+NWTDW(I-1)
      IF(IBTP.GE.NBPW) THEN
         IW=IBTP/NBPW
         IBTP=IBTP-IW*NBPW
         IWRD=IWRD+IW
      END IF
C
      CALL BUNPCK(NBPW,KBUFF,IDWINC,IWRD,IBTP,6,KERR)
      IF(KERR.GT.0) RETURN
      IF(IDWINC.GT.JBPW) THEN
            KERR=15
            WRITE(KNTN,*)  'BURQC :'
            CALL BUERR(KERR)
            RETURN
      END IF
      IF(IWRD.GT.KBUFL) THEN
            KERR=26
            WRITE(KNTN,*)  'BURQC :'
            CALL BUERR(KERR)
            RETURN
      END IF
C
      IF(CWTU(I-1).EQ.'CCITTIA5') THEN
         NWTIWS(I-1)=NWTDW(I-1)+6+N*IDWINC*8
      ELSEIF(NWTEN(I-1).EQ.-999) THEN
         NWTIWS(I-1)=NWTDW(I-1)+6+N*IDWINC*8
      ELSE
         NWTIWS(I-1)=NWTDW(I-1)+6+N*IDWINC
      END IF
C
      IBIT = NBITP(I-1) + NWTIWS(I-1)
      IWORD= IBIT/NBPW
C
      NBITP (I)= IBIT - IWORD*NBPW
      NWORDP(I)= NWORDP(I-1) + IWORD
C
      IF(NWORDP(I).GT.KBUFL) THEN
            KERR=26
            WRITE(KNTN,*)  'BURQC :'
            CALL BUERR(KERR)
            RETURN
      END IF
 111  CONTINUE
C
C     -----------------------------------------------------------------
C*          2. CREATE POINTERS FOR REQUESTED ELEMENTS.
C              ---------------------------------------
 200  CONTINUE
C
C
C*          2.1 CHECK IF SUBSET OF ELEMENTS REQUESTED.
C
 210  CONTINUE
C
      IF(NREQ(1).EQ.0) THEN
         DO 212 I=1,M
         INWTEN(I)=NWTEN(I)
         INWTR (I)=NWTR (I)
         INWTS (I)=NWTS (I)
         INWTDW(I)=NWTDW(I)
         INWTRV(I)=NWTRV(I)
         CNAMES(I)=CWTEN(I)
         CUNITS(I)=CWTU(I)
         INWORDP(I)=NWORDP(I)
         INBITP(I)=NBITP(I)
 212     CONTINUE
         RETURN
      END IF
C
      IF(NREQ(1).EQ.1) THEN
         DO 213 I=1,M
         IF(NWTR(I).GT.200000.AND.
     1      NWTR(I).NE.999999) THEN
            MREL=I-1
            GO TO 2133
         END IF
 213     CONTINUE
         MREL=M
C
 2133    CONTINUE
         J=0
         IF(NRQL.EQ.0) THEN
            DO 2131 I=1,MREL
            J=J+1
            INBITP(J)=NBITP(I)
            INWORDP(J)=NWORDP(I)
            INWTEN(J)=NWTEN(I)
            INWTR(J) =NWTR(I)
            INWTS(J) =NWTS(I)
            INWTDW(J)=NWTDW(I)
            INWTRV(J)=NWTRV(I)
            CNAMES(J)=CWTEN(I)
            CUNITS(J)=CWTU(I)
 2131       CONTINUE
C
            M=J
            RETURN
         ELSE
            M=MREL
            GO TO 220
         END IF
      END IF
C
      IF(NREQ(1).EQ.2) THEN
         DO 214 I=1,M
         IF(NWTR(I).EQ.235000) THEN
            M=I-1
            GO TO 2141
         END IF
 214     CONTINUE
C
 2141    CONTINUE
C
         J=0
         IF(NREQ(2).EQ.0) THEN
            DO 2142 I=1,M
            J=J+1
            INBITP(J)=NBITP(I)
            INWORDP(J)=NWORDP(I)
            INWTEN(J)=NWTEN(I)
            INWTR(J)=NWTR(I)
            INWTS(J)=NWTS(I)
            INWTDW(J)=NWTDW(I)
            INWTRV(J)=NWTRV(I)
            CNAMES(J)=CWTEN(I)
            CUNITS(J)=CWTU(I)
 2142       CONTINUE
            RETURN
         ELSE
            GO TO 220
         END IF
      END IF
C
      IF(NREQ(1).EQ.3) THEN
         DO 215 I=1,M
         IF(NWTR(I).EQ.235000) THEN
C
C           COPY CLASS 1 - 8 ELEMENTS
C
            DO 2151 III=1,M
            IF(NWTR(III).GT.8000) THEN
               J=0
               IF(NREQ(2).EQ.0) THEN
                  DO 2161 II=1,III-1
                  J=J+1
                  INBITP(J)=NBITP(II)
                  INWORDP(J)=NWORDP(II)
                  INWTR(J)=NWTR(II)
                  INWTS(J)=NWTS(II)
                  INWTRV(J)=NWTRV(II)
                  INWTDW(J)=NWTDW(II)
                  INWTEN(J)=NWTEN(II)
                  CNAMES(J)=CWTEN(II)
                  CUNITS(J)=CWTU(II)
 2161             CONTINUE
                  GO TO 2160
              ELSE
                  DO 21611 II=1,III-1
                  J=J+1
                  NBITP(J)=NBITP(II)
                  NWORDP(J)=NWORDP(II)
                  NWTR(J)=NWTR(II)
                  NWTS(J)=NWTS(II)
                  NWTRV(J)=NWTRV(II)
                  NWTDW(J)=NWTDW(II)
                  NWTEN(J)=NWTEN(II)
                  CWTEN(J)=CWTEN(II)
                  CWTU(J)=CWTU(II)
21611             CONTINUE
                  GO TO 2160

              END IF
            END IF
 2151       CONTINUE
C
 2160       CONTINUE
C
            IF(NREQ(2).EQ.0) THEN
               DO 216 II=I+1,M
               J=J+1
               INBITP(J)=NBITP(II)
               INWORDP(J)=NWORDP(II)
               INWTR(J)=NWTR(II)
               INWTS(J)=NWTS(II)
               INWTRV(J)=NWTRV(II)
               INWTDW(J)=NWTDW(II)
               INWTEN(J)=NWTEN(II)
               CNAMES(J)=CWTEN(II)
               CUNITS(J)=CWTU(II)
 216           CONTINUE
               M=J
               RETURN
            ELSE
               DO 2169 II=I+1,M
               J=J+1
               NBITP(J)=NBITP(II)
               NWORDP(J)=NWORDP(II)
               NWTR(J)=NWTR(II)
               NWTS(J)=NWTS(II)
               NWTRV(J)=NWTRV(II)
               NWTDW(J)=NWTDW(II)
               NWTEN(J)=NWTEN(II)
               CWTEN(J)=CWTEN(II)
               CWTU(J)=CWTU(II) 
 2169          CONTINUE
               M=J
               GO TO 220
            END IF
         END IF
C
 215     CONTINUE
C
         KERR=39
         CALL BUERR(KERR)
         RETURN
      ELSE
         KERR=40
         CALL BUERR(KERR)
         RETURN
      END IF
C
C
C*          2.2 CREATE INDECES TO CLASS 7/8
C               ---------------------------
 220  CONTINUE
C
      DO 225 I=1,M
      IF(NWTR(I).GT.200000.AND.
     1   NWTR(I).NE.999999) THEN
         MREL=I-1
         GO TO 226
      END IF
 225  CONTINUE
C
      MREL=M
C
 226  CONTINUE
C
      J=0
      JJ=0
      DO 221 I=1,MREL
      ICLASS=NWTR(I)/1000
      IF(ICLASS.EQ.7) THEN
         J=J+1
         IC7(J)=I
      END IF
C
      IF(ICLASS.EQ.8) THEN
         JJ=JJ+1
         IC8(JJ)=I
      END IF
 221  CONTINUE
C
      IC7L=J
      IC8L=JJ
      J=0
      JJ=0
      DO 223 I=1,NRQL
      ICLASS=NRQ(I)/1000
      IF(ICLASS.EQ.7.AND.(ABS(RQVAL(I)-RVIND)/RVIND.GT.EPS)) THEN
         J=J+1
         IC7R(J)=I
      END IF
C
      IF(ICLASS.EQ.8.AND.(ABS(RQVAL(I)-RVIND)/RVIND.GT.EPS)) THEN
         JJ=JJ+1
         IC8R(JJ)=I
      END IF
 223  CONTINUE
C
      IC7RL=J
      IC8RL=JJ
C
C*          2.3 CREATE INDECES TO THE REQUESTED ELEMENTS.
C               -----------------------------------------
 230  CONTINUE
C
      IF(IC7RL.EQ.0.AND.IC8RL.EQ.0) THEN
         IL=MREL
         IRL=NRQL
      END IF
      IF(IC7RL.NE.0.AND.IC8RL.EQ.0) THEN
         IL=IC7(1)
         IRL=IC7R(1)-1
      END IF
      IF(IC8RL.NE.0.AND.IC7RL.EQ.0) THEN
         IL=IC8(1)
         IRL=IC8R(1)-1
      END IF
      IF(IC7RL.NE.0.AND.IC8RL.NE.0) THEN
         IL=IC7(1)
         IF(IC7(1).GT.IC8(1)) IL=IC8(1)
         IRL=IC7R(1)
         IF(IC7R(1).GT.IC8R(1)) IRL=IC8R(1)
         IRL=IRL-1
      END IF
C
      DO 299 I=1,MREL
      IRQEI(I)=0
 299  CONTINUE
C
      ORQEI=.FALSE.
      DO 231 I=1,IL
      IF(IB2.EQ.0.OR.NRQL.EQ.0) THEN
         ORQEI=.TRUE.
         IRQEI(I)=I
      ELSE
         DO 232 K=1,IRL
         IF(NWTR(I).EQ.NRQ(K)) THEN
            ORQEI=.TRUE.
            IRQEI(I)=I
         END IF
 232     CONTINUE
      END IF
 231  CONTINUE
C
      IF(IC7RL.NE.0) THEN
C
C        CLASS 7 SIGNIFYING
C
         IST=1
         DO 233 IJ=1,IC7RL
         III=IC7R(IJ)
         DO 234 I=IST,IC7L
         II=IC7(I)
         IBITP=NBITP(II)
         IWORD=NWORDP(II)

         CALL BUNPCK(NBPW,KBUFF,IVAL,IWORD,IBITP,NWTDW(II),KERR)
         IF(KERR.NE.0) THEN
            CALL BUERR(KERR)
            RETURN
         END IF
         CALL BUNPCK(NBPW,KBUFF,IDWINC,IWORD,IBITP,6,KERR)
         IF(KERR.NE.0) THEN
            CALL BUERR(KERR)
            RETURN
         END IF
         CALL BUNPCK(NBPW,KBUFF,INC,IWORD,IBITP,IDWINC,KERR)
         IF(INC.EQ.NMASK(IDWINC)) IVAL=NMASK(NWTDW(II))
C
         IF(IVAL.NE.NMASK(NWTDW(II))) THEN
            ISCALE=NWTS(II)
            IREF  =NWTRV(II)
            IVAL  =IVAL+IREF+INC
            VAL   =RVIND
            IF(IVAL.NE.NMASK(NWTDW(II))) THEN
               IF(ISCALE.GT.0) THEN
                  VAL=IVAL/10.**ISCALE
               ELSE
                  IISCALE=IABS(ISCALE)
                  VAL=IVAL*10.**IISCALE
               END IF
            END IF
         ELSE
            VAL=RVIND
         END IF
C
         INEXT=IC7(I+1)-1
         IF(IC7(I+1).LE.0) INEXT=MREL
         IF(ABS(RQVAL(III)-VAL).LT.EPS.OR.
     1      ABS(RQVAL(III)-RVIND)/RVIND.LT.EPS) THEN
            DO 236 KI=II,INEXT
            IF(IB2.EQ.0) THEN
               ORQEI=.TRUE.
               IRQEI(KI)=KI
            ELSE
               IE=IC7R(IJ+1)-1
               IF(IJ.EQ.IC7RL) IE=NRQL
               IF(IC8RL.NE.0) THEN
                  DO 238 JA=1,IC8RL
                  IF(IC8R(JA).GT.III.AND.IC8R(JA).LT.IE) THEN
                     IE=IC8R(JA)-2
                     GO TO 298
                  END IF
 238              CONTINUE
               END IF
 298           CONTINUE
               DO 237 IK=III,IE
               IF(NWTR(KI).EQ.NRQ(IK)) THEN
                  ORQEI=.TRUE.
                  IRQEI(KI)=KI
               END IF
 237           CONTINUE
            END IF
 236        CONTINUE
C
            GO TO 233
         END IF
 234     CONTINUE
 233     CONTINUE
C
      END IF
C
      IF(IC8RL.NE.0) THEN
C
C        CLASS 8 SIGNIFYING
C
         IST=1
         DO 241 IJ=1,IC8RL
         III=IC8R(IJ)
         DO 242 I=IST,IC8L
         II=IC8(I)
         IBITP=NBITP(II)
         IWORD=NWORDP(II)
         CALL GBYTE(KBUFF(IWORD),IVAL,IBITP,NWTDW(II))
         ISCALE=NWTS(II)
         IREF  =NWTRV(II)
         IVAL  =IVAL+IREF
         VAL   =RVIND
         IF(IVAL.NE.NMASK(NWTDW(II))) THEN
            IF(ISCALE.GT.0) THEN
               VAL=IVAL/10.**ISCALE
            ELSE
               IISCALE=IABS(ISCALE)
               VAL=IVAL*10.**IISCALE
            END IF
         END IF
C
         INEXT=IC8(I+1)-2
         IF(IC8(I+1).EQ.0) INEXT=MREL
C
         OT=.FALSE.
         IF(ABS(VAL-RVIND)/RVIND.LT.EPS) THEN
            IVAL=NINT(VAL)
            IRQV=NINT(RQVAL(III))
C
            IF(NWTR(II).EQ.008001) THEN
               OT=.TRUE.
               IF(IAND(IVAL,IRQV).NE.IRQV) OT=.FALSE.
            ELSE
               OT=.TRUE.
               IF(ABS(VAL-RQVAL(III)).GT.EPS) OT=.FALSE.
            END IF
         END IF
C
         IF(OT) THEN
            ICL=NWTR(II-1)/1000
            IF(ICL.EQ.7) IRQEI(II-1)=II-1
            DO 244 KI=II,INEXT
            IF(IB2.EQ.0) THEN
               ORQEI=.TRUE.
               IRQEI(KI)=KI
            ELSE
               IE=IC8R(IJ+1)-1
               IF(IJ.EQ.IC8RL) IE=NRQL
               IF(IC7RL.NE.0) THEN
                  DO 248 JA=1,IC7RL
                  IF(IC7R(JA).GT.III.AND.IC7R(JA).LT.IE) THEN
                     IE=IC7R(JA)-1
                     GO TO 297
                  END IF
 248              CONTINUE
               END IF
 297           CONTINUE
               DO 245 IK=III,IE
               IF(NWTR(KI).EQ.NRQ(IK)) THEN
                 ORQEI=.TRUE.
                 IRQEI(KI)=KI
               END IF
 245           CONTINUE
            END IF
 244        CONTINUE
C
         END IF
 242     CONTINUE
 241     CONTINUE
C
      END IF
C
      IF(.NOT.ORQEI) THEN
         KERR=45
         CALL BUERR(KERR)
         M=0
         RETURN
      END IF
C
C
C
C*          3. FIND POINTERS TO QUALITY CONTROL,START OF DATA
C               ----------------------------------------------
C               PRESENT INDICATORS AND %CONFIDENCE.
C               -----------------------------------
C
 300  CONTINUE
C
      I=0
      IF(IB3.NE.0) THEN
         I=I+1
         ITYPE(I)=222000
      END IF
C
      IF(IB4.NE.0) THEN
         I=I+1
         ITYPE(I)=224000
      END IF
C
      IF(IB5.NE.0) THEN
         I=I+1
         ITYPE(I)=225000
      END IF
C
      IF(IB6.NE.0) THEN
         I=I+1
         ITYPE(I)=223000
      END IF
C
      KEND=I
      IF(KEND.EQ.0) THEN
         J=0
         DO 4011 I=1,MREL
         IF(IRQEI(I).NE.0) THEN
            II=IRQEI(I)
            J=J+1
            INWORDP(J)=NWORDP(II)
            INBITP(J)=NBITP(II)
            INWTR(J)=NWTR(II)
            INWTS(J)=NWTS(II)
            INWTRV(J)=NWTRV(II)
            INWTDW(J)=NWTDW(II)
            INWTEN(J)=NWTEN(II)
            CNAMES(J)=CWTEN(II)
            CUNITS(J)=CWTU(II)
         END IF
 4011    CONTINUE
         GO TO 900
      END IF
C
      OLIST=.FALSE.
      O236=.FALSE.
      O237=.FALSE.
C
      DO 500 KT=1,KEND
         JQPR=0
         JQUA=0
         JQCA=0
         JQC =0
         JQCC=0
         JQCS=0
         KM=MREL
C
C
C        FIND POINTERS TO OPERATORS
C
         KZ=0
         DO 3031 I=KM,M
         IF(NWTR(I).EQ.ITYPE(KT)) THEN
            KZ=KZ+1
            NQP(KZ)=I
         END IF
 3031    CONTINUE
C
         IF(KZ.EQ.0) THEN
            WRITE(KNTN,*) ITYPE(KT),' NOT PRESENT IN THIS MESSAGE.'
            GO TO 500
         ELSE
            KZ=KZ+1
            NQP(KZ)=M
         END IF
C
         DO 3033 KQ=1,KZ-1
C
         JQUA=NQP(KQ)
C
         IF(NWTR(JQUA+1).EQ.236000) THEN
            JQ236=JQUA+1
            O236=.TRUE.
         END IF
C
         IF(NWTR(JQUA+1).EQ.237000) THEN
            JQ237=JQUA+1
            O237=.TRUE.
         ELSE
            O237=.FALSE.
         END IF
C
C
C        DATA PRESENT INDICATOR
C
         IF(.NOT.O236.AND.O237) THEN
C
C           FIND LAST DEFINED BIT MAP
C
            DO 420 I=JQUA,MREL,-1
            IF(NWTR(I).EQ.236000) GO TO 421
 420        CONTINUE
C
            KERR=41
            CALL BUERR(KERR)
            RETURN
C
 421        CONTINUE
C
            O236=.TRUE.
            O237=.FALSE.
            JQ236=I
            JQ237=0
            IK=I
            IDPRF=0
            DO 3015 I=IK,M
            IF(NWTR(I).EQ.31031.OR.NWTR(I).EQ.31192) THEN
               IDPRF=IDPRF+1
               IF(IDPRF.EQ.1) JQPR=I
            ELSE
               IF(IDPRF.NE.0) GO TO 30111
            END IF
 3015       CONTINUE
C
 3016       CONTINUE
         END IF
C
C        DATA PRESENT INDICATOR
C
         IF(.NOT.O237) THEN
            IDPRF=0
            DO 301 I=JQUA,NQP(KQ+1)
            IF(NWTR(I).EQ.31031.OR.NWTR(I).EQ.31192) THEN
               IDPRF=IDPRF+1
               IF(IDPRF.EQ.1) JQPR=I
            ELSE
               IF(IDPRF.NE.0) GO TO 30111
            END IF
 301        CONTINUE
         END IF
C
30111   CONTINUE
C
C        GENERATING CENTRE
C
         DO 309 I=JQUA,NQP(KQ+1)
         IF(NWTR(I).EQ.1031) THEN
            JQCC=I
            GO TO 302
         END IF
 309     CONTINUE
C
 302     CONTINUE
C
C        GENERATING APPLICATION
C
         DO 307 I=JQUA,NQP(KQ+1)
         IF(NWTR(I).EQ.1032.OR.NWTR(I).EQ.1201.OR.
     1      NWTR(I).EQ.63191) THEN
            JQCA=I
            GO TO 3071
         END IF
 307     CONTINUE
C
 3071    CONTINUE
C
C        PERCENTAGE CONFIDENCE
C
         IF(ITYPE(KT).EQ.222000) THEN
            DO 305 I=JQUA,NQP(KQ+1)
            IF(NWTR(I)/1000.EQ.33.OR.NWTR(I).EQ.63192) THEN
               JQC=I
               GO TO 306
            END IF
 305        CONTINUE
         ELSE
C           SIGNIFICANCE
C
            DO 308 I=JQUA,NQP(KQ+1)
            IF(NWTR(I)/1000.EQ.8) THEN
               JQCS=I
               GO TO 3088
            END IF
 308        CONTINUE
C
 3088       CONTINUE
C
            DO 3051 I=JQUA,NQP(KQ+1)
            IF(NWTR(I).EQ.223255.OR.NWTR(I).EQ.224255.OR.
     1         NWTR(I).EQ.225255) THEN
               JQC=I
               GO TO 306
            END IF
 3051       CONTINUE
         END IF
C
C
 306     CONTINUE
C
C*          3.1  SET INDICES TO GET Q/C.
C                GET BIT MAP FROM DATA SECTION.
C
 310  CONTINUE
C
         IF(JQUA.EQ.0) THEN
            WRITE(KNTN,'(1H )')
        WRITE(KNTN,'(1H ,A)') 'Q/C NOT PRESENT IN THIS BUFR MESSAGE.'
            WRITE(KNTN,'(1H )')
         ELSE
C
            IF(.NOT.O237) THEN
C
               KAK=0
               IQPR=JQPR-1
               DO 311 K=1,IDPRF
               IQPR=IQPR+1
               KAK=KAK+1
               IWPT=NWORDP(IQPR)
               IBPT=NBITP (IQPR)
               CALL GBYTE(KBUFF(IWPT),IBVAL(KAK),IBPT,1)
 311           CONTINUE
            END IF
C
            IDIF=MREL-IDPRF
C
            JS=0
            IF(IDIF.NE.0) THEN
               DO 313 I=1,IDIF
               JS=JS+1
               IQCDPI(JS)=0
 313           CONTINUE
            END IF
C
            JQPRM1=JQPR-1
            DO 314 I=1,IDPRF
            JS=JS+1
            IQCDPI(JS)=I+JQPRM1
 314        CONTINUE
C
            JS=0
            IF(IDIF.NE.0) THEN
               DO 315 I=1,IDIF
               JS=JS+1
               IQCI(JS)=0
 315           CONTINUE
            END IF
C
            K=JQC-1
            DO 317 I=1,IDPRF
            OK=.TRUE.
            JS=JS+1
            IQCI(JS)=0
            IF(IBVAL(I).EQ.0) THEN
               IF(OK) K=K+1
               IQCI(JS)=K
               OK=.FALSE.
            END IF
 317        CONTINUE
C
         END IF
C
C
C*          4.  CREATE REQUESTED ELEMENT LIST.
C               ------------------------------
 400  CONTINUE
C
      IF(.NOT.OLIST) THEN
         IF(NREQ(2).EQ.0) NRQL=0
         J=0
         DO 401 I=1,MREL
         IF(IRQEI(I).NE.0) THEN
            II=IRQEI(I)
            J=J+1
            INBITP(J)=NBITP(II)
            INWORDP(J)=NWORDP(II)
            INWTR(J)  =NWTR(II)
            INWTS(J)  =NWTS(II)
            INWTRV(J) =NWTRV(II)
            INWTDW(J) =NWTDW(II)
            INWTEN(J) =NWTEN(II)
            CNAMES(J)=CWTEN(II)
            CUNITS(J)=CWTU(II)
            OLIST=.TRUE.
         END IF
 401     CONTINUE
      END IF
C
      IF(JQUA.NE.0) THEN
C
C*          4.1 ADD DATA PRESENT INDICATOR AND Q/C.
C               -----------------------------------
 410     CONTINUE
C
C                  ADD OPERATOR 222000
         J=J+1
         INWORDP(J)=NWORDP(JQUA)
         INBITP (J)=NBITP (JQUA)
         INWTR(J)  =NWTR(JQUA)
         INWTS(J)  =NWTS(JQUA)
         INWTRV(J) =NWTRV(JQUA)
         INWTDW(J) =NWTDW(JQUA)
         INWTEN(J) =NWTEN(JQUA)
         CNAMES(J)=CWTEN(JQUA)
         CUNITS(J)=CWTU(JQUA)
C
         IF(O236.AND..NOT.O237) THEN
            J=J+1
            INWORDP(J)=NWORDP(JQ236)
            INBITP (J)=NBITP (JQ236)
            INWTR(J)  =NWTR(JQ236)
            INWTS(J)  =NWTS(JQ236)
            INWTRV(J) =NWTRV(JQ236)
            INWTDW(J) =NWTDW(JQ236)
            INWTEN(J) =NWTEN(JQ236)
            CNAMES(J)=CWTEN(JQ236)
         END IF
C
         IF(O237) THEN
            J=J+1
            INWORDP(J)=NWORDP(JQ237)
            INBITP (J)=NBITP (JQ237)
            INWTR (J) =NWTR (JQ237)
            INWTS (J) =NWTS (JQ237)
            INWTRV(J) =NWTRV(JQ237)
            INWTDW(J) =NWTDW(JQ237)
            INWTEN(J) =NWTEN(JQ237)
            CNAMES(J)=CWTEN(JQ237)
            CUNITS(J)=CWTU (JQ237)
         END IF
C
         IF(.NOT.O237) THEN 
            DO 412 I=1,MREL
            IF(IRQEI(I).NE.0) THEN
               IF(IQCDPI(I).NE.0) THEN
                  J=J+1
                  INWORDP(J)=NWORDP(IQCDPI(I))
                  INBITP (J)=NBITP (IQCDPI(I))
                  INWTR(J)  =NWTR(IQCDPI(I))
                  INWTS(J)  =NWTS(IQCDPI(I))
                  INWTRV(J) =NWTRV(IQCDPI(I))
                  INWTDW(J) =NWTDW(IQCDPI(I))
                  INWTEN(J) =NWTEN(IQCDPI(I))
                  CNAMES(J)=CWTEN(IQCDPI(I))
                  CUNITS(J)=CWTU(IQCDPI(I))
               END IF
            END IF
 412        CONTINUE
         END IF
C
C
C        GENERATING CENTRE
C
         IF(JQCC.NE.0) THEN
            J=J+1
            INWORDP(J)=NWORDP(JQCC)
            INBITP (J)=NBITP (JQCC)
            INWTR(J)  =NWTR(JQCC)
            INWTS(J)  =NWTS(JQCC)
            INWTRV(J) =NWTRV(JQCC)
            INWTDW(J) =NWTDW(JQCC)
            INWTEN(J) =NWTEN(JQCC)
            CNAMES(J)=CWTEN(JQCC)
            CUNITS(J)=CWTU(JQCC)
         END IF
C
C        Q/C APPLICATION
C
         IF(JQCA.NE.0) THEN
            J=J+1
            INWORDP(J)=NWORDP(JQCA)
            INBITP (J)=NBITP (JQCA)
            INWTR(J)  =NWTR(JQCA)
            INWTS(J)  =NWTS(JQCA)
            INWTRV(J) =NWTRV(JQCA)
            INWTDW(J) =NWTDW(JQCA)
            INWTEN(J) =NWTEN(JQCA)
            CNAMES(J)=CWTEN(JQCA)
            CUNITS(J)=CWTU(JQCA)
         END IF
C
C        SIGNIFICANCE
C
         IF(JQCS.NE.0) THEN
            J=J+1
            INWORDP(J)=NWORDP(JQCS)
            INBITP (J)=NBITP (JQCS)
            INWTR(J)  =NWTR(JQCS)
            INWTS(J)  =NWTS(JQCS)
            INWTRV(J) =NWTRV(JQCS)
            INWTDW(J) =NWTDW(JQCS)
            INWTEN(J) =NWTEN(JQCS)
            CNAMES(J)=CWTEN(JQCS)
            CUNITS(J)=CWTU(JQCS)
         END IF
C
C
C        CLASS 33 ELEMENTS
C
         DO 415 I=1,MREL
         IF(IRQEI(I).NE.0) THEN
            OK=.TRUE.
            IF(IQCI(I).NE.0) THEN
               IF(OK) J=J+1
               OK=.FALSE.
               INWORDP(J)=NWORDP(IQCI(I))
               INBITP (J)=NBITP (IQCI(I))
               INWTR(J)  =NWTR  (IQCI(I))
               INWTS(J)  =NWTS  (IQCI(I))
               INWTRV(J) =NWTRV (IQCI(I))
               INWTDW(J) =NWTDW (IQCI(I))
               INWTEN(J) =NWTEN (IQCI(I))
               CNAMES(J)=CWTEN (IQCI(I))
               CUNITS(J)=CWTU  (IQCI(I))
            END IF
         END IF
 415     CONTINUE
      END IF
 3033 CONTINUE
C
C
C*          5. MAKE ONE TO ONE CORRESPONDENCE BETWEEN ELEMENTS AND
C              Q/C,STATISTICS,DIFFERENCE STATISTICS OR SUBSTITUTED VALUES
C              LEAVING BEHIND DATA PRESENT INDICATORS.
 500  CONTINUE
C
C
C*          9.  UPDATE TOTAL NUMBER OF ELEMENTS.
C               --------------------------------
 900  CONTINUE
C
      M=J
      NFCM=1
      NFUCM=0
C
      RETURN
C
      END

C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE CONFP3(PVAL,KEXP,KMANT,KBITS,KROUND)
C
C---->
C**** CONFP3 - Convert floating point number to GRIB representation.
C
C     Purpose.
C     --------
C
C     Convert floating point number from machine
C     representation to GRIB representation.
C
C**   Interface.
C     ----------
C
C     CALL CONFP3(PVAL,KEXP,KMANT,KBITS,KROUND)
C
C
C     Input Parameters.
C     -----------------
C
C     PVAL    - Floating point number to be converted.
C     KBITS   - Number of bits in computer word.
C     KROUND  - Conversion type.
C               0 , Closest number in GRIB format less than
C                   original number.
C               1 , Closest number in GRIB format to the
C                   original number (equal to, greater than or
C                   less than original number).
C               10 , as for 0 but with debug printout.
C               11 , as for 1 but with debug printout.
C
C     Output Parameters.
C     -----------------
C
C     KEXP    - 8 Bit signed exponent.
C     KMANT   - 24 Bit mantissa.
C
C     Method.
C     -------
C
C     Floating point number represented as 8 bit signed
C     exponent and 24 bit mantissa in integer values.
C
C     Externals.
C     ----------
C
C     DECFP2
C     ABORTX
C
C     Reference.
C     ----------
C
C     WMO Manual on Codes re GRIB representation.
C
C     Comments.
C     ---------
C
C     Routine aborts if an invalid conversion type parameter
C     is used or if a 24 bit mantissa is not produced.
C
C
C     Author.
C     -------
C
C     John Hennessy   ECMWF   18.06.91
C
C     Modifications.
C     --------------
C
C     John Hennessy   ECMWF   24.09.91
C     Corrections made to descriptions of input parameter KROUND.
C     Changes to comments and format statements.
C
C     J.D.Chambers    ECMWF    13.09.94
C     Inhibit abort if NOABORT = 1, use grbcom.h
C
C
C     J.D.Chambers    ECMWF    21.11.94
C     Use JNINT for VAX
C
C----<
C     -----------------------------------------------------------------
C*    Section 0 . Definition of variables. Set initial values.
C     -----------------------------------------------------------------
C
      IMPLICIT NONE
C
#include "grprs.h"
C
#include "grbcom.h"
C
C     Subroutine arguments
C
      REAL PVAL
      INTEGER KEXP,KMANT,KBITS,KROUND
C
C     Local variables
C
      INTEGER IEXP, IPR, IROUND, ISIGN
      REAL ZEPS, ZREF, ZVAL
C
C     -----------------------------------------------------------------
C*    Section 1 . Initialise
C     -----------------------------------------------------------------
C
  100 CONTINUE
C
C     Debug print switch.
C
      IF( KROUND.GE.10) THEN
	IPR    = 1
	IROUND = KROUND - 10
      ELSE
	IPR    = 0
	IROUND = KROUND
      ENDIF
C
C     Check conversion type parameter.
C
      IF( IROUND.NE.0.AND.IROUND.NE.1) THEN
	WRITE(GRPRSM,*) 'CONFP3: Invalid conversion type = ', KROUND
C
	IF( NOABORT.EQ.0 ) CALL ABORTX('CONFP3')
C
C       If not aborting, arbitrarily set rounding to 'up'.
C
        IROUND = 1
      ENDIF
C
C     -----------------------------------------------------------------
C*    Section 2 . Convert value of zero.
C     -----------------------------------------------------------------
C
  200 CONTINUE
C
      IF( PVAL.EQ.0.0 ) THEN
        KEXP  = 0
        KMANT = 0
	IEXP  = 0
	ISIGN = 0
        GOTO 900
      ENDIF
C
C     -----------------------------------------------------------------
C*    Section 3 . Convert other values.
C     -----------------------------------------------------------------
C
  300 CONTINUE
C
      ZEPS = 1.0E-12
      IF( KBITS.EQ.32) ZEPS = 1.0E-8
      ZREF = PVAL
C
C     Sign of value.
C
      ISIGN = 0
      IF( ZREF.LT.0.) THEN
        ISIGN = 128
        ZREF  = - ZREF
      ENDIF
C
C     Exponent.
C
#ifdef CRAY
      IEXP = INT(ALOG(ZREF)*(1.0/ALOG(16.0))+64.0+1.0+ZEPS)
#else
      IEXP = INT(LOG(ZREF)*(1.0/LOG(16.0))+64.0+1.0+ZEPS)
#endif
C
      IF( IEXP.LT.0  ) IEXP = 0
      IF( IEXP.GT.127) IEXP = 127
C
C     Mantissa.
C
      IF( IROUND.EQ.0 ) THEN
C
C       Closest number in GRIB format less than original number.
C       Truncate for positive numbers.
C       Round up for negative numbers.
C
	IF( ISIGN.EQ.0 ) THEN
          KMANT = INT(ZREF/16.0**(IEXP-70))
        ELSE
#ifdef VAX
          KMANT = JNINT(ZREF/16.0**(IEXP-70)+0.5)
#else
          KMANT = NINT(ZREF/16.0**(IEXP-70)+0.5)
#endif
	ENDIF
C
      ELSE
C
C       Closest number in GRIB format to the original number
C       (equal to, greater than or less than original number).
C
#ifdef VAX
        KMANT = JNINT(ZREF/16.0**(IEXP-70))
#else
        KMANT = NINT(ZREF/16.0**(IEXP-70))
#endif
      ENDIF
C
C     Check that mantissa value does not exceed 24 bits.
C     If it does, adjust the exponent upwards and recalculate
C     the mantissa.
C     (Nb. 16777215 = 2**24 - 1)
C
      IF( KMANT.GT.16777215) THEN
C
  350   CONTINUE
C
	IEXP = IEXP + 1
C
C       Check for exponent overflow during adjustment
C
        IF( IEXP.GT.127 ) THEN
          WRITE(GRPRSM,*) 'CONFP3: Exponent overflow'
	  WRITE(GRPRSM,9002) PVAL
	  WRITE(GRPRSM,9003) ISIGN, IEXP, KMANT
C
          IF( NOABORT.EQ.0 ) CALL ABORTX('CONFP3')
C
C         If not aborting, arbitrarily set value to zero
C
          WRITE(GRPRSM,*) 'CONFP3: Value arbitrarily set to zero.'
          KEXP  = 0
          KMANT = 0
          IEXP  = 0
          ISIGN = 0
          GOTO 900
C
        ENDIF
C
        IF( IROUND.EQ.0) THEN
C
C         Closest number in GRIB format less than original number.
C         Truncate for positive numbers.
C         Round up for negative numbers.
C
          IF( ISIGN.EQ.0 ) THEN
            KMANT = INT(ZREF/16.0**(IEXP-70))
          ELSE
#ifdef VAX
            KMANT = JNINT(ZREF/16.0**(IEXP-70)+0.5)
#else
            KMANT = NINT(ZREF/16.0**(IEXP-70)+0.5)
#endif
          ENDIF
C
        ELSE
C
C         Closest number in GRIB format to the original number
C         (equal to, greater or less than original number).
C
#ifdef VAX
          KMANT = JNINT(ZREF/16.0**(IEXP-70))
#else
          KMANT = NINT(ZREF/16.0**(IEXP-70))
#endif
	ENDIF
C
C       Repeat calculation (with modified exponent) if still have
C       mantissa overflow.
C
        IF( KMANT.GT.16777215) GOTO 350
C
      ENDIF
C
C     Add sign bit to exponent.
C
      KEXP = IEXP + ISIGN
C
C     -----------------------------------------------------------------
C*    Section 9. Return
C     -----------------------------------------------------------------
C
  900 CONTINUE
C
C     Print generated values if required.
C
      IF( IPR.EQ.1 ) THEN
	WRITE(GRPRSM,9006) KROUND
	WRITE(GRPRSM,9002) PVAL
	CALL DECFP2(ZVAL,KEXP,KMANT)
	WRITE(GRPRSM,9007) ZVAL
	WRITE(GRPRSM,9003) ISIGN, IEXP, KMANT
      ENDIF
C
      RETURN
C
C
 9002 FORMAT(1H ,'CONFP3: Original number = ',F30.20)
 9003 FORMAT(1H ,'CONFP3: Sign = ',I3,', Exponent = ',I3,
     X            ', Mantissa = ',I12)
 9006 FORMAT(1H ,'CONFP3: Conversion type parameter = ',I4)
 9007 FORMAT(1H ,'CONFP3: Converted to      ',F30.20)
C
      END

C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE BUBOX(KSUB,KSUP,KELEM,KWTR,CNAMES,CUNITS,KVALS,VALUES,
     1                 KBOX,KAPP,KLEN,KBOXR,VALS,CBOXN,CBOXU,KERR)
C
C**** *BUBOX*
C
C
C     PURPOSE.
C     --------
C
C
C
C**   INTERFACE.
C     ----------
C
C               *CALL BUBOX(KSUB,KSUP,KELEM,KWTR,CNAMES,CUNITS,KVALS,VALUES,
C                           KBOX,KAPP,KLEN,KBOXR,VALS,CBOXN,CBOXU,KERR)*
C
C        INPUT :
C               *KSUB*    -  SUBSET NUMBER
C               *KSUP*    -  ARRAY CONTAINING SUPLEMENTARY INFORMATION
C                         -  KSUP( 1) -- IDIM1, DIMENSION OF KSEC1
C                         -  KSUP( 2) -- IDIM2, DIMENSION OF KSEC2
C                         -  KSUP( 3) -- IDIM3, DIMENSION OF KSEC3
C                         -  KSUP( 4) -- IDIM4, DIMENSION OF KSEC4
C                         -  KSUP( 5) -- M (NUMBER OF ELEMENTS IN VALUES ARRAY,
C                                           FIRST INDEX)
C                         -  KSUP( 6) -- N (NUMBER OF SUBSETS,SECOND INDEX OF
C                                           VALUES ARRAY)
C                         -  KSUP( 7) -- JVC (NUMBER OF ELEMENTS IN CVAL ARRAY)
C                         -  KSUP( 8) -- TOTAL BUFR MESSAGE LENGTH IN BYTES
C                         -  KSUP( 9) -- IDIM0, DIMENSION OF KSEC0
C               *KELEM*   -  EXPECTED NUMBER OF EXPANDED TABLE B ELEMENTS
C               *KWTR*    -  ARRAY CONTAINING BUFR TABLE B REFERENCE NUMBERS
C               *CNAMES*  -  ARRAY CONTAINING ELEMENT NAMES
C               *CUNITS*  -  ARRAY CONTAINING ELEMENT UNITS
C               *KVALS*   -  DIMENSION OF VALUES ARRAY
C               *VALUES*  -  ARRAY CONTAINING UNPACKED VALUES
C               
C        OUTPUT :
C
C               *KBOX*    -  NUMBER OF ROWS      
C               *KAPP*    -  NUMBER OF COLUMNS
C               *KLEN*    -  OFFSET FOR START OF NEXT COLUMN
C               *KBOXR*   -  ARRAY CONTAINING BUFR TABLE B REFERENCE NUMBERS
C               *VALS*    -  ARRAY CONTAINING UNPACKED VALUES
C               *CBOXN*   -  ARRAY CONTAINING ELEMENT NAMES
C               *CBOXU*   -  ARRAY CONTAINING ELEMENT UNITS
C               *KERR*    -  RETURNED ERROR CODE
C
C     METHOD.
C     -------
C
C
C
C     EXTERNALS.
C     ----------
C
C
C     REFERENCE.
C     ----------
C
C          NONE.
C
C     AUTHOR.
C     -------
C
C          M. DRAGOSAVAC    *ECMWF*       01/02/94.
C
C
C     MODIFICATIONS.
C     --------------
C
C          NONE.
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
C
#     include "parameter.F"
C
#     include "bcomunit.F"
C
      CHARACTER*64 CNAMES(*)
      CHARACTER*24 CUNITS(*)
C
C
      DIMENSION KSUP(9),KWTR(*)
C
      DIMENSION IOPER(100),RPRINT(60)
C
      DIMENSION KBOXR(JWORK)
      DIMENSION IBVAL(JELEM),IBPRINT(60)
      CHARACTER*64 CBOXN(JELEM)
      CHARACTER*24 CBOXU(JELEM)
C
#ifndef R_4
      REAL*8 VALUES(*)
      REAL*8 VALS(JWORK)
      REAL*8 RVIND
      REAL*8 EPS
#else
      REAL   VALUES(*)
      REAL   VALS(JWORK)
      REAL   RVIND
      REAL   EPS
#endif
C     ------------------------------------------------------------------
C
C*          1.  GET ALL ELEMENTS UNTIL FIRST OPERATOR APPEAR.
C               ---------------------------------------------
 100  CONTINUE
C

      IF(KERR.GT.0) RETURN
C
      RVIND=1.7D38
      EPS=10.D-7
      NVIND=2147483647
C
      IF(KELEM.GT.JELEM) THEN
         KERR=47
         CALL BUERR(KERR)
         RETURN
      END IF

C
C     JUST TO KEEP PROGRAM FOR FUTURE MULTY SUBSET BOXING
C
      KSUB1=KSUB
      KSUB2=KSUB
C
      IF(KSUB1.LT.1.OR.KSUB1.GT.KSUP(6)) THEN
         KERR=44
         CALL BUERR(KERR)
         RETURN
      END IF
C
      IF(KSUB1.NE.KSUB2) THEN
         WRITE(KNTN,*) 'ONLY ONE SUBSET AT A TIME',
     1' WILL BE BOXED.'
         KSUB2=KSUB1
      END IF
C
      KBOXR(1)=2147483647
      CBOXN(1)='OPERATOR'
      CBOXU(1)=' '
      KBOXR(2)=2147483647
      CBOXN(2)='GENERATING CENTRE( CODE TABLE 001031)'
      CBOXU(2)='CODE TABLE'
      KBOXR(3)=2147483647
      CBOXN(3)='GENERATING APPLICATION (CODE TABLE 001032)'
      CBOXU(3)='CODE TABLE'
      KBOXR(4)=2147483647
      CBOXN(4)='STATISTICS (008024/008023) '
      CBOXU(4)='CODE TABLE'
      KBOXR(5)=2147483647
      CBOXN(5)='INCREMENTAL UPDATE NUMBER'
      CBOXU(5)='NUMERIC'
      KBOXR(6)=2147483647
      CBOXN(6)='MINIMISATION SIMULATION NUMBER'
      CBOXU(6)='NUMERIC'
C
      MREL=0
      J=0
      DO 103 I=1,KSUP(5)
      IF(KWTR(I).EQ.222000.OR.
     1   KWTR(I).EQ.223000.OR.
     1   KWTR(I).EQ.224000.OR.
     1   KWTR(I).EQ.225000.OR.
     1   KWTR(I).EQ.235000.OR.
     1   KWTR(I).EQ.237255.OR.
     1   KWTR(I).EQ.232000) THEN
         J=J+1
         IOPER(J)=I
      END IF
 103  CONTINUE
C
      NOPER=J
C
      IOPER(J+1)=KSUP(5)
C
      NOPP1=NOPER+1
      INI=IOPER(1)*8+20
      IF(INI*NOPP1.GT.JWORK) THEN
         KERR=47
         WRITE(KNTN,*) 'TOO MANY DATA FOR BOXING.'
         RETURN
      END IF
C
      DO 105 I=1,INI*NOPP1
      VALS(I)=RVIND
      KBOXR(I)=NVIND
 105  CONTINUE
C
      IF(NOPER.EQ.0) THEN
         KAPP =1                            ! NUMBER OF APPLICATIONS
         KAPPL=1
         KLEN=KELEM
         J=6
         DO 101 I=1,KSUP(5)
         J=J+1
         KBOXR(J)=KWTR(I)
         CBOXN(J)=CNAMES(I)
         CBOXU(J)=CUNITS(I)
         DO 191 KK=KSUB1,KSUB2
         JJ=I+(KK-1)*KELEM                     ! POINTER TO VALUES ARRAY
         IP=J  !+(KAPP-1)*KLEN  ! +(KK-1)*KAPPL*KLEN ! POINTER TO VALS ARRAY
         VALS (IP)=VALUES(JJ)
 191     CONTINUE
 101     CONTINUE
C
         KBOX=J                             ! TOTAL NUMBER OF ELEMENTS
         MREL=J
         GO TO 2000
      END IF
C
      O236=.FALSE.
C
      LFIRST=1
      J=6
C
C
      LAST=IOPER(1)-1
      IF(MREL.EQ.0) MREL=LAST+6
      KLEN=LAST*8+20
C
 102  CONTINUE
C
C*          1.1 MOVE ELEMENTS FROM LFIRST TO LAST INTO BOX.
C               -------------------------------------------
 110  CONTINUE
C
      KAPP =1                            ! NUMBER OF APPLICATIONS
      KAPPL=60
      DO 111 I=LFIRST,LAST
      J=J+1
      KBOXR(J)=KWTR(I)
      CBOXN(J)=CNAMES(I)
      CBOXU(J)=CUNITS(I)
      DO 192 KK=KSUB1,KSUB2
      JJ=I+(KK-1)*KELEM
      IP=J ! +(KAPP-1)*KLEN   ! +(KK-1)*KAPPL*KLEN
      VALS (IP)=VALUES(JJ)
 192  CONTINUE
 111  CONTINUE
C
      KBOX=J                             ! TOTAL NUMBER OF ELEMENTS
C
      DO 1000 LL=1,NOPER
C
      K=IOPER(LL)
C
      IF(KWTR(K).EQ.235000) THEN
         MREL=0
         K=K+1
C
         KL=IOPER(LL+1)-1
         DO 112 I=K,KL
         J=J+1
         KBOXR(J)=KWTR(I)
         CBOXN(J)=CNAMES(I)
         CBOXU(J)=CUNITS(I)
         DO 190 KK=KSUB1,KSUB2
         JJ=I+(KK-1)*KELEM
         IP=J  !+(KAPP-1)*KLEN              ! +(KK-1)*KAPPL*KLEN
         VALS (IP)=VALUES(JJ)
 190     CONTINUE
 112     CONTINUE
         GO TO 1000
      END IF
      IF(KWTR(K).EQ.222000) THEN
         K=K+1
         IMARK=222000
         IF(MREL.EQ.0) MREL=J
         GO TO 119
      END IF
      IF(KWTR(K).EQ.223000) THEN
         K=K+1
         IMARK=223000
         IF(MREL.EQ.0) MREL=J
         GO TO 119
      END IF
      IF(KWTR(K).EQ.224000) THEN
         K=K+1
         IMARK=224000
         IF(MREL.EQ.0) MREL=J
         GO TO 119
      END IF
      IF(KWTR(K).EQ.225000) THEN
         K=K+1
         IMARK=225000
         IF(MREL.EQ.0) MREL=J
         GO TO 119
      END IF
      IF(KWTR(K).EQ.232000) THEN
         K=K+1
         IMARK=232000
         IF(MREL.EQ.0) MREL=J
      END IF
C
 119  CONTINUE
C
C     CHECK IF NEXT ELEMENT IS OPERATOR
C
      IF(KWTR(K).EQ.236000) THEN
         O236=.TRUE.
         K=K+1
      END IF
C
      IF(KWTR(K).EQ.237000) THEN
         K=K+1
         GO TO 120
      END IF
C
      IF(KWTR(K).EQ.237255) THEN
         O236=.FALSE.
         K=K+1
         GO TO 1000
      END IF
C
C     SKIP IF DELAYED REPLICATION FACTOR FOLLOW
C
      IF(KWTR(K).EQ.31002.OR.KWTR(K).EQ.31001.OR.
     1   KWTR(K).EQ.31000) K=K+1
C
C     NEXT ELEMENT MUST BE DATA PRESENT INDICATOR
C
      IF(KWTR(K).NE.31031.AND.KWTR(K).NE.31192) THEN
         KERR=42
         CALL BUERR(KERR)
         WRITE(KNTN,*) 'ELEMENT ',K,' MUST BE',
     1' DATA PRESENT INDICATOR.'
         RETURN
      END IF
C
C     COUNT NUMBER OF DATA PRESENT INDICATORS
C
C     IBITS - POINTER TO THE FIRST DATA PRESENT INDICATOR
C     IDPI  - NUMBER OF DATA PRESENT INDICATORS
C
      IBITS=K
      IDPI=0
      DO 113 I=K,IOPER(LL+1)
      IF(KWTR(I).EQ.31031) THEN
         IDPI=IDPI+1 
      ELSE
         GO TO 114
      END IF
 113  CONTINUE
C
      KERR=43
      CALL BUERR(KERR)
      RETURN
C
 114  CONTINUE
C
C     RESET CURRENT POINTER
C
      K=I
C
C     GET BIT MAP FROM VALUES
C
      IBP=IBITS-1
      DO 115 I=1,IDPI
      IBP=IBP+1
      IF(ABS(VALUES(IBP)-RVIND)/RVIND.LT.EPS) THEN
         IBVAL(I)=NVIND
      ELSE 
         IBVAL(I)=VALUES(IBP)
      END IF
 115  CONTINUE
C
C
 120  CONTINUE
C
C     NEXT 3 ELEMENTS MUST BE GENERATING CENTRE AND APPLICATION 
C     AND CLASS 8 ELEMENT.
C
      KAPP=KAPP+1
      IF(KAPP.GT.60) THEN
         WRITE(KNTN,*) 'THERE IS MORE THAN 60 APPLICATIONS',
     1' IN THE DATA.'
         RETURN
      END IF
      IF(KWTR(K).EQ.1031.OR.KWTR(K).EQ.1033) THEN
         KP=(KAPP-1)*KLEN
         KP1=KP+1
         KBOXR(KP1)=IMARK
C         CBOXN(KP1)=' '
C         CBOXU(KP1)=' '
         DO 194 KK=KSUB1,KSUB2
         IP=1+(KAPP-1)*KLEN             ! +(KK-1)*KAPPL*KLEN
         VALS(IP)=IMARK
 194     CONTINUE
         KP2=KP+2
         KBOXR(KP2)=KWTR(K)
C         CBOXN(KP2)=CNAMES(K)
C         CBOXU(KP2)=CUNITS(K)
         DO 195 KK=KSUB1,KSUB2
         JJ=K+(KK-1)*KELEM
         IP=2+(KAPP-1)*KLEN             ! +(KK-1)*KAPPL*KLEN
         VALS(IP)=VALUES(JJ)  
 195     CONTINUE
         K=K+1
      END IF
      IF(KWTR(K).EQ.1032.OR.KWTR(K).EQ.1201.OR.KWTR(K).EQ.63191) THEN
         KP=(KAPP-1)*KLEN
         KP3=KP+3
         KBOXR(KP3)=KWTR(K)
C         CBOXN(KP3)=CNAMES(K)
C         CBOXU(KP3)=CUNITS(K)
         DO 196 KK=KSUB1,KSUB2
         JJ=K+(KK-1)*KELEM
         IP=3+(KAPP-1)*KLEN             ! +(KK-1)*KAPPL*KLEN
         VALS(IP)=VALUES(JJ)
 196     CONTINUE
         K=K+1
      END IF
      IF(KWTR(K)/1000.EQ.8) THEN
         KP=(KAPP-1)*KLEN
         KP4=KP+4
         KBOXR(KP4)=KWTR(K)
C         CBOXN(KP4)=CNAMES(K)
C         CBOXU(KP4)=CUNITS(K)
         DO 197 KK=KSUB1,KSUB2
         JJ=K+(KK-1)*KELEM
         IP=4+(KAPP-1)*KLEN             !  +(KK-1)*KAPPL*KLEN
         VALS(IP)=VALUES(JJ)
 197     CONTINUE
         K=K+1
      END IF
      IF(KWTR(K).EQ.33210) THEN
         KP=(KAPP-1)*KLEN
         KP5=KP+5
         KBOXR(KP5)=KWTR(K)
C         CBOXN(KP5)=CNAMES(K)
C         CBOXU(KP5)=CUNITS(K)
         DO 201 KK=KSUB1,KSUB2
         JJ=K+(KK-1)*KELEM
         IP=5+(KAPP-1)*KLEN             !  +(KK-1)*KAPPL*KLEN
         VALS(IP)=VALUES(JJ)
 201     CONTINUE
         K=K+1
      END IF
      IF(KWTR(K).EQ.33211) THEN
         KP=(KAPP-1)*KLEN
         KP6=KP+6
         KBOXR(KP6)=KWTR(K)
C         CBOXN(KP6)=CNAMES(K)
C         CBOXU(KP6)=CUNITS(K)
         DO 202 KK=KSUB1,KSUB2
         JJ=K+(KK-1)*KELEM
         IP=6+(KAPP-1)*KLEN             !  +(KK-1)*KAPPL*KLEN
         VALS(IP)=VALUES(JJ)
 202     CONTINUE
         K=K+1
      END IF
C
C     NEXT ELEMENT CAN BE DELAYED/EXTENDED DELAYED REPLICATION
C     SKIP IT
C
      IF(KWTR(K).EQ.31002.OR.KWTR(K).EQ.31001.OR.
     1   KWTR(K).EQ.31000) K=K+1
C
C
C     MOVE CORESPONDING QUALITY CONTROL INTO BOX
C
      KQ=MREL-IDPI+1
      KAPPK=(KAPP-1)*KLEN  
      DO 121 I=1,IDPI
      IF(IBVAL(I).NE.0) THEN
         KKQ=KQ+KAPPK
         VALS(KKQ)=RVIND 
         KQ=KQ+1
      ELSE
         KKQ=KQ+KAPPK
         KBOXR(KKQ)=KWTR(K)
C         CBOXN(KKQ)=CNAMES(K)
C         CBOXU(KKQ)=CUNITS(K)
         DO 198 KK=KSUB1,KSUB2
         JJ=K+(KK-1)*KELEM                ! +(KK-1)*KAPPL*KLEN
         VALS(KKQ)=VALUES(JJ)
 198     CONTINUE
         K=K+1 
         KQ=KQ+1
      END IF
 121  CONTINUE
C
C     CHECK IF SOME NEW DATA FOLLOW.
C
      IF(K.LT.IOPER(LL+1)-1) THEN
C
C        MOVE THESE ELEMENTS INTO BOX
C
         IF(KWTR(IOPER(LL+1)).GT.200000.AND.
     1      KWTR(IOPER(LL+1)).NE.999999) THEN
            ILL=IOPER(LL+1)-1
         ELSE
            ILL=IOPER(LL+1)
         END IF
         DO 122 I=K,ILL
         J=J+1
         KBOXR(J)=KWTR(I)
         CBOXN(J)=CNAMES(I)
         CBOXU(J)=CUNITS(I)
         DO 199 KK=KSUB1,KSUB2
         JJ=I+(KK-1)*KELEM
         IP=J   !+(KAPP-1)*KLEN              !  +(KK-1)*KAPPL*KLEN
         VALS(IP)=VALUES(JJ)
 199     CONTINUE
 122     CONTINUE
         KBOX=J
      END IF
C
 1000 CONTINUE
C
 2000 CONTINUE
C
      KBOX=J
      IF(KBOX.LE.6) KBOX=0
C
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities
C granted to it by virtue of its status as an intergovernmental organisation
C nor does it submit to any jurisdiction.
C

      LOGICAL FUNCTION LSMFLD()
C
C---->
C**** LSMFLD
C
C     Purpose
C     -------
C
C     Determines whether or not the current field is to be
C     considered for 'land-sea mask' treatment.
C
C
C     Interface
C     ---------
C
C     LLSMFLD = LSMFLD()
C
C     Input
C     -----
C
C     None
C
C
C     Output
C     ------
C
C     Function returns .TRUE. if the field is to be treated with
C     land-sea mask.
C
C
C     Method
C     ------
C
C     Uses a set of hardcoded rules.
C
C
C     Externals
C     ---------
C
C     INTLOG  - Logs messages
C
C     Uses common blocks nifld.common and nofld.common.
C
C
C     Author
C     ------
C
C     J.D.Chambers     ECMWF     April 2001
C
C----<
C
      IMPLICIT NONE
C
#include "parim.h"
#include "nifld.common"
#include "nofld.common"
C
C     Local variables
C
      LOGICAL LIKELY
C
C     -----------------------------------------------------------------|
C*    Section 1. Initialise
C     -----------------------------------------------------------------|
C
  100 CONTINUE
C
C     If 'uselsm' has been forced to 'yes' ...
C
      LSMFLD = .FALSE.
      IF( LSMSET ) THEN
        LSMFLD = LSM
        GOTO 900
      ENDIF
C
C     WMO International table 001 for meteorological parameters
C
      IF ( NITABLE.EQ.1 ) THEN
        LIKELY = ( NIPARAM.NE.2 )
C
C     ECMWF local code table 128 for meteorological parameters
C
      ELSEIF ( (NITABLE.EQ.128).OR.(NITABLE.EQ.129) ) THEN
        LIKELY = ( NIPARAM.NE.151 ).AND.  !msl
     X           ( NIPARAM.NE.172 )       !lsm
      ELSE
        LIKELY = .FALSE.
      ENDIF
C
      IF( .NOT.LIKELY ) THEN
        LSMFLD = .FALSE.
        GOTO 900
      ENDIF
C
C     -----------------------------------------------------------------|
C*    Section 2. Work through the special cases
C     -----------------------------------------------------------------|
C
  200 CONTINUE
C
C     -----------------------------------------------------------------|
C*    Section 9.   Return
C     -----------------------------------------------------------------|
C
  900 CONTINUE
C
      IF( .NOT.LSMFLD ) THEN
        CALL INTLOG(JP_DEBUG,
     X    'LSMFLD: Do not handle field with land-sea mask', JPQUIET)
      ELSE
        CALL INTLOG(JP_DEBUG,
     X    'LSMFLD: Handle field with land-sea mask', JPQUIET)
      ENDIF
C
      RETURN
      END

      PROGRAM BUFRREPACK
C
C**** *BUFRREPACK*
C
C
C     PURPOSE.
C     --------
C         REPACKS BUFR  DATA.
C
C
C**   INTERFACE.
C     ----------
C
C          NONE.
C
C     METHOD.
C     -------
C
C          NONE.
C
C
C     EXTERNALS.
C     ----------
C
C         CALL BUSEL
C         CALL BUFREX
C         CALL BUFREN
C         CALL BUPRS0
C         CALL BUPRS1
C         CALL BUPRS2
C         CALL BUPRS3
C         CALL BUPRT
C         CALL BUUKEY
C
C     REFERENCE.
C     ----------
C
C          NONE.
C
C     AUTHOR.
C     -------
C
C          M. DRAGOSAVAC    *ECMWF*       15/02/95.
C
C
C     MODIFICATIONS.
C     --------------
C
C          NONE.
C
C
      IMPLICIT LOGICAL(L,O,G), CHARACTER*8(C,H,Y)
C
      PARAMETER(JSUP =   9,JSEC0=   3,JSEC1= 40,JSEC2=4096 ,JSEC3= 4,
     1       JSEC4=   2,JELEM=160000,JSUBS=400,JCVAL=150 ,JBUFL=512000,
#ifdef JBPW_64
     2          JBPW =  64,JTAB =3000,JCTAB=120,JCTST=1800,JCTEXT=1200,
#else
     2          JBPW =  32,JTAB =3000,JCTAB=120,JCTST=1800,JCTEXT=1200,
#endif
     3          JWORK=4096000,JKEY=46,JBYTE=80000)
C
      PARAMETER (KELEM=40000)
      PARAMETER (KVALS=360000)
C 
      DIMENSION KBUFF(JBUFL)
      DIMENSION KBUFR(JBUFL)
      DIMENSION KSUP(JSUP)  ,KSEC0(JSEC0),KSEC1(JSEC1)
      DIMENSION KSEC2(JSEC2),KSEC3(JSEC3),KSEC4(JSEC4)
      DIMENSION KEY  (JKEY),KREQ(2)
C
      REAL*8 VALUES(KVALS),VALUE(KVALS),RQV(KELEM)
      REAL*8 RVIND,EPS
      DIMENSION KTDLST(KELEM),KTDEXP(KELEM),KRQ(KELEM)
      DIMENSION KTDLST1(KELEM),KTDEXP1(KELEM)
      DIMENSION KDATA(200)
      DIMENSION IOUT(12800)
      DIMENSION IHEIGHT(10000)
C
      CHARACTER*9   CALLSN(10000),CSGN
      CHARACTER*256 CF(100),COUT,CFIN,CLIST
      CHARACTER*64 CNAMES(KELEM)
      CHARACTER*24 CUNITS(KELEM)
      CHARACTER*80 CVALS(KVALS)
      CHARACTER*80 YENC
      CHARACTER*256 CARG(10)
C
      logical olist
cs      EXTERNAL GETARG
C                                                                       
C     ------------------------------------------------------------------
C*          1. INITIALIZE CONSTANTS AND VARIABLES.
C              -----------------------------------
 100  CONTINUE
C
C     MISSING VALUE INDICATOR
C 
      olist=.false.
      callsn(1)=' '
      iunit2=55
      ITLEN=6400
      ITL=0
      IL=0
      JZ=0
      NW=0
      N=0
      NBYTES=JBPW/8
      RVIND=1.7D38
      NVIND=2147483647
      IOBS=0
      KRQL=0
      NR=2555
      KREQ(1)=0
      KREQ(2)=0
      DO 102 I=1,KELEM
      RQV(I)=RVIND
      KRQ(I)=NVIND
 102  CONTINUE
C
C     INPUT FILE NAMES
C
      NARG=IARGC()
      IF(NARG.LT.4) THEN
         PRINT*,'USAGE -- bufr_ship_anmh -f list -i infile -o outfile'
         STOP
      END IF
      NFILE=NARG
C
      DO 104 J=1,NARG
      CALL GETARG(J,CARG(J))
 104  CONTINUE

      IL=0
      II=0
      IO=0
      DO 105 J=1,NARG
      IF(CARG(J).EQ.'-i') THEN
         IN=J
      ELSEIF(CARG(J).EQ.'-o') THEN
         IO=J
      ELSEIF(CARG(J).EQ.'-f') THEN
         IL=J
      END IF
 105  CONTINUE
C
      IF(IO.EQ.0.OR.IN.EQ.0) THEN
         PRINT*,'USAGE -- bufr_ship_anmh -f list -i infile -o outfile'
         STOP
      END IF
C
      COUT=CARG(IO+1)
C
      if(IL.ne.0) then
         olist=.true.
         clist=carg(IL+1)
C
         jjl=INDEX(clist,' ')
         jjl=jjl-1
      end if
C
C
      JJ=INDEX(COUT,' ')
      JJ=JJ-1
C
      CALL PBOPEN(IUNIT1,COUT(1:JJ),'W',IRET)
      IF(IRET.EQ.-1) STOP 'OPEN FAILED ON BUFR.DAT'
      IF(IRET.EQ.-2) STOP 'INVALID FILE NAME'
      IF(IRET.EQ.-3) STOP 'INVALID OPEN MODE SPECIFIED'
C
      CFIN=CARG(IN+1) 
      ILN=INDEX(CFIN,' ')
      iln=iln-1
C
C*          1.2 OPEN FILE CONTAINING BUFR DATA.
C               -------------------------------
 120  CONTINUE
C
      IRET=0 
      CALL PBOPEN(IUNIT,CFIN(1:ILN),'R',IRET)
      IF(IRET.EQ.-1) STOP 'OPEN FAILED'
      IF(IRET.EQ.-2) STOP 'INVALID FILE NAME'
      IF(IRET.EQ.-3) STOP 'INVALID OPEN MODE SPECIFIED'
C
      IF(OLIST) THEN
         open(iunit2,file=clist(1:jjl),iostat=ios,status='old')
         if(ios.ne.0) then
            stop 'Open error on list'
         end if
C
         I=0
         DO WHILE(IOS.EQ.0)
         I=I+1
         READ(IUNIT2,'(A,1X,I5)',IOSTAT=IOS) CALLSN(I),IHEIGHT(I)
         END DO
C
         close(IUNIT2)
C
      END IF
      NHEIGHT=I-1

C
C     ----------------------------------------------------------------- 
C*          2. SET REQUEST FOR EXPANSION.
C              --------------------------
 200  CONTINUE
C
      OPRT=.FALSE.
      OENC=.TRUE.
      NCOM=1
      OCOMP=.FALSE.
      NR=0
      OSEC3=.FALSE.
C
C*          2.1 SET REQUEST FOR PARTIAL EXPANSION.
C               ----------------------------------
 210  CONTINUE
C
C     SET VARIABLE TO PACK BIG VALUES AS MISSING VALUE INDICATOR
C
      KPMISS=1
      KPRUS=0
      NOKEY=0
      CALL BUPRQ(KPMISS,KPRUS,NOKEY)
C
C     -----------------------------------------------------------------
C*          3.  READ BUFR MESSAGE.
C               ------------------
 300  CONTINUE
C
      IERR=0
      KBUFL=0
C
      IRET=0
      CALL PBBUFR(IUNIT,KBUFF,JBYTE,KBUFL,IRET) 
      IF(IRET.EQ.-1) THEN
          GO TO 900
      END IF
      IF(IRET.EQ.-2) STOP 'FILE HANDLING PROBLEM' 
      IF(IRET.EQ.-3) STOP 'ARRAY TOO SMALL FOR PRODUCT'
C
      N=N+1
      IKBUFL=KBUFL
      KBUFL=KBUFL/NBYTES+1
      IF(N.LT.NR) GO TO 300
C
C     -----------------------------------------------------------------
C*          4. EXPAND BUFR MESSAGE.
C              --------------------
 400  CONTINUE
C
      CALL BUS012(KBUFL,KBUFF,KSUP,KSEC0,KSEC1,KSEC2,KERR)
      IF(KERR.NE.0) THEN
         PRINT*,'ERROR IN BUS012: ',KERR
         PRINT*,' BUFR MESSAGE NUMBER ',N,' CORRUPTED.'
         KERR=0
         CALL MY_EXIT(2)
      END IF
C
       if(ksec1(7).ne.9.and.ksec1(7).ne.11.and.
     1    ksec1(7).ne.13.and.ksec1(7).ne.19) go to 630
c
      IF(KSUP(6).GT.1) THEN
         KEL=JWORK/KSUP(6)
         IF(KEL.GT.JELEM) KEL=JELEM
      ELSE
         KEL=KELEM
      END IF
C
      CALL BUFREX(KBUFL,KBUFF,KSUP,KSEC0 ,KSEC1,KSEC2 ,KSEC3 ,KSEC4,
     1            KEL,CNAMES,CUNITS,KVALS,VALUES,CVALS,IERR)
C
      IF(IERR.NE.0) THEN
         CALL MY_EXIT(2)
      END IF
      IOBS=IOBS+KSEC3(3)
C
      CALL BUSEL(KTDLEN,KTDLST,KTDEXL,KTDEXP,KERR)
      IF(KERR.NE.0) CALL MY_EXIT(2)
C
C*          4.1 PRINT CONTENT OF EXPANDED DATA.
C               -------------------------------
 410  CONTINUE
C
      IF(.NOT.OPRT) GO TO 500
      IF(.NOT.OSEC3) GO TO 450
C
C*          4.2 PRINT SECTION ZERO OF BUFR MESSAGE.
C               -----------------------------------
 420  CONTINUE
C

      CALL BUPRS0(KSEC0)
C
C*          4.3 PRINT SECTION ONE OF BUFR MESSAGE.
C               -----------------------------------
 430  CONTINUE
C
      CALL BUPRS1(KSEC1)
C
C
C*          4.4 PRINT SECTION TWO OF BUFR MESSAGE.
C               -----------------------------------
 440  CONTINUE
C
C              AT ECMWF SECTION 2 CONTAINS RDB KEY.
C              SO UNPACK KEY
C
      CALL BUUKEY(KSEC1,KSEC2,KEY,KSUP,KERR)
C
C              PRINT KEY
C
      CALL BUPRS2(KSUP ,KEY)
C
C*          4.5 PRINT SECTION 3 OF BUFR MESSAGE.
C               -----------------------------------
 450  CONTINUE
C
C               FIRST GET DATA DESCRIPTORS
C
      CALL BUSEL(KTDLEN,KTDLST,KTDEXL,KTDEXP,KERR)
      IF(KERR.NE.0) CALL MY_EXIT(2)
C
C               PRINT  CONTENT
C
      IF(OSEC3) THEN
         CALL BUPRS3(KSEC3,KTDLEN,KTDLST,KTDEXL,KTDEXP,KEL,CNAMES)
      END IF
C
C*         4.6 PRINT SECTION 4 (DATA).
C              -----------------------
 460  CONTINUE
C
C          IN THE CASE OF MANY SUBSETS DEFINE RANGE OF SUBSETS
C
      IF(.NOT.OO) THEN
      WRITE(*,'(A,$)') ' STARTING SUBSET TO BE PRINTED : '
      READ(*,'(BN,I4)')   IST
      WRITE(*,'(A,$)') ' ENDING SUBSET TO BE PRINTED : '
      READ(*,'(BN,I4)')   IEND
      OO=.FALSE.
      END IF
C
C              PRINT DATA
C
      ICODE=0
      CALL BUPRT(ICODE,IST,IEND,KEL,CNAMES,CUNITS,CVALS,
     1           KVALS,VALUES,KSUP,KSEC1,IERR)
C
C              RESOLVE BIT MAPS 
C
      IF(IEND.GT.KSEC3(3)) IEND=KSEC3(3)
C
      DO 461 IK=IST,IEND
C 
      CALL BUBOX(IK,KSUP,KEL,KTDEXP,CNAMES,CUNITS,KVALS,VALUES,
     1           KBOX,KAPP,KLEN,KBOXR,VALS,CBOXN,CBOXU,IERR)
C
      CALL BUPRTBOX(KBOX,KAPP,KLEN,KBOXR,VALS,CBOXN,CBOXU)
C
 461  CONTINUE
C
C     -----------------------------------------------------------------
C*          5. COLLECT DATA FOR REPACKING.
C              ---------------------------
 500  CONTINUE
C      
C     IF(.NOT.OENC) GO TO 300
C
C               FIRST GET DATA DESCRIPTORS
C
      CALL BUSEL(KTDLEN,KTDLST,KTDEXL,KTDEXP,KERR)
      IF(KERR.NE.0) CALL MY_EXIT(2)
C
C     -----------------------------------------------------------------
C*          6. PACK BUFR MESSAGE BACK INTO BUFR.
C              ---------------------------------
 600  CONTINUE
C
    
      KKK=0
      KBUFL=JBUFL
C
C     GET REPLICATION FACTORS
C
      KK=0
      DO 601 K=1,KSUP(5)
      IF(KTDEXP(K).EQ.31001.OR.KTDEXP(K).EQ.31002.OR.
     1   KTDEXP(K).EQ.31000) THEN
         KK=KK+1
         KDATA(KK)=NINT(VALUES(K))
      END IF
 601  CONTINUE
C
      KDLEN=2
      IF(KK.NE.0) KDLEN=KK
C
C     --------------------------------
C     |Modification to sections error|
C     --------------------------------
C
C     If ship already got ship anemometer height 
c     write data to target file
c
      oheight=.true.
      do i=1,ktdlen
       if(KTDLST(i).eq.010197) then
          oheight=.false.
          go to 630
       end if
      end do
c
      j=0
      do i=1,2
       j=j+1
       ktdlst1(j)=ktdlst(i)
      end do
      j=j+1
      ktdlst1(j)=010197
      j=j+1
      ktdlst1(j)=222000
      j=j+1
      ktdlst1(j)=101034
      j=j+1
      ktdlst1(j)=031031
      j=j+1
      ktdlst1(j)=001031
      j=j+1
      ktdlst1(j)=001032
      j=j+1
      ktdlst1(j)=101034
      j=j+1
      ktdlst1(j)=033007

      ktdlen1=j
      
C
C    ----------------------------------------
C    ! Modification to data section         !
C    ----------------------------------------
C
      ib=0
      do iii=1,ksup(6)
      do iiii=1,33
        ia=iiii+(iii-1)*kel
        ib=ib+1
        ibb=ib+(iii-1)*kel
        value(ibb)=values(ia)
      end do
      end do
c
      if(olist) then
         do iii=1,ksup(6)
         do iiii=34,34
           ia=iiii+(iii-1)*kel
           ib=ib+1
           ibb=ib+(iii-1)*kel
           ifound=0
           csgn=cvals(1)(1:9)
           call search(callsn,nheight,csgn,ifound)
           if(ifound.ne.0) then
              value(ibb)=iheight(ifound)
           else
              value(ibb)=rvind
           end if
         end do
         end do
      else
         do iii=1,ksup(6)
         do iiii=34,34
           ia=iiii+(iii-1)*kel
           ib=ib+1
           ibb=ib+(iii-1)*kel
           value(ibb)=rvind
         end do
         end do
      end if
c
      do iii=1,ksup(6)
      do iiii=34,67
        ia=iiii+(iii-1)*kel
        ib=ib+1
        ibb=ib+(iii-1)*kel
        value(ibb)=values(ia)
      end do
      end do
c
c     insert data present indicator
c
      ib=ib+1
      do iii=1,ksup(6)
        ibb=ib+(iii-1)*kel
        value(ibb)=0.
      end do
      do iii=1,ksup(6)
      do iiii=68,102
        ia=iiii+(iii-1)*kel
        ib=ib+1
        ibb=ib+(iii-1)*kel
        value(ibb)=values(ia)
      end do
      end do
c
c     insert% confidance
c
      ib=ib+1
      do iii=1,ksup(6)
        ibb=ib+(iii-1)*kel
        value(ibb)=70.
      end do
c
      kdata(1)=kdata(1)+1
      kdata(2)=kdata(2)+1
C
C     -----------------------------------------------------------------------
C
C*          6.2 ENCODE DATA INTO BUFR MESSAGE.
C               ------------------------------
 620  CONTINUE
C
      IF(KSEC1(5).NE.0) THEN
         CALL BUUKEY(KSEC1,KSEC2,KEY,KSUP,KERR)
         IF(KERR.NE.0) THEN
            PRINT*,'BUUKEY: ERROR ',KERR
            CALL MY_EXIT(2)
         END IF
      END IF
C
      IF(KSUP(6).EQ.0) THEN
         PRINT*,'ZERO SUBSETS'
         CALL MY_EXIT(2)
      END IF
C
C
C     GET INFORMATION FOR RDB KEY
C
C     CALL BUCREKEY(KEL,KTDEXP,KSUP,KSEC1,KSEC3,KEY,
C    1              VALUES,CVALS,KERR)
C     IF(KERR.NE.0) THEN
C        PRINT*,'ERROR IN BUCREKEY.'
C        CALL MY_EXIT(2)
C     END IF
C
C     PACK NEW RDB KEY
C
      ksec1(5)=128
      ksec2(1)=52
C
      CALL BUPKEY(KEY,KSEC1,KSEC2,KERR)
      IF(KERR.NE.0) CALL MY_EXIT(2)
C
c     KSEC3(4)=128
c     IF(KSEC3(3).GT.1) KSEC3(4)=192
c     IF(KSEC3(4).EQ.0) KSEC3(4)=192
C
      CALL BUFREN( KSEC0,KSEC1,KSEC2,KSEC3,KSEC4,
     1             KTDLEN1,KTDLST1,KDLEN,KDATA,KEL,        !KSUP(5),
     2             KVALS,VALUE,CVALS,KBUFL,KBUFR,KERR)
C
      IF(KERR.GT.0) THEN
         PRINT*,'ERROR DURING ENCODING.'
         CALL MY_EXIT(2)
      END IF
C
C           6.3 WRITE PACKED BUFR MESSAGE INTO FILE.
C               ------------------------------------
 630  CONTINUE
C
      if((ksec1(7).eq.9.or.ksec1(7).eq.11.or.
     1   ksec1(7).eq.13.or.ksec1(7).eq.19).and.oheight) then
         IKBUFL=KBUFL*4
         CALL PBWRITE(IUNIT1,KBUFR,IKBUFL,IERR)
         IF(IERR.LT.0) THEN
            PRINT*,'ERROR WRITING INTO TARGET FILE.'
            CALL MY_EXIT(2)
         END IF
      else
         CALL PBWRITE(IUNIT1,KBUFF,IKBUFL,IERR)
         IF(IERR.LT.0) THEN
            PRINT*,'ERROR WRITING INTO TARGET FILE.'
            CALL MY_EXIT(2)
         END IF
      end if
C
      NW=NW+1
C
      GO TO 300
C     -----------------------------------------------------------------
C
 810  CONTINUE
C
      WRITE(*,'(1H ,A)') 'OPEN ERROR ON INPUT FILE'
      GO TO 900
C      
 800  CONTINUE
C
      IF(IRET.EQ.-1) THEN
         PRINT*,'NUMBER OF RECORDS PROCESSED ',N
         PRINT*,'NUMBER OF RECORDS CONVERTED ',NW
c
      ELSE
         PRINT*,' BUFR : ERROR= ',IERR
      END IF
C
 900  CONTINUE
C
      PRINT*,'NUMBER OF RECORDS PROCESSED ',N
      PRINT*,'NUMBER OF RECORDS CONVERTED ',NW
C
      CALL PBCLOSE(IUNIT,IRET)
C
      CALL PBCLOSE(IUNIT1,IRET)
C
      END
      SUBROUTINE CUTZERO(CHARPAR,KMIN)
C
C**** CUTZERO - SUBROUTINE TO REMOVE ZERO CHARACTERS.
C
C**   PURPOSE
C     -------
C
C     TO REMOVE ZERO-FILL CHARACTERS FROM THE END OF A CHARACTER
C     VARIABLE.
C
C     INTERFACE
C     ---------
C
C     CALL CUTZERO(CHARPAR,KMIN)
C
C          CHARPAR  - CHARACTER VARIABLE WHICH MAY HAVE ZEROS AT THE
C                     END OF THE VALID CHARACTERS, WHICH NEED TO BE
C                     REMOVED;
C                     RETURNED WITH THE ZERO CHARACTERS CONVERTED TO
C                     BLANK.
C
C          KMIN     - INTEGER VARIABLE INDICATING A MINIMUM NUMBER OF
C                     CHARACTERS AT THE BEGINNING OF THE STRING WHICH
C                     MUST NOT BE CHANGED
C
C     THUS:
C
C     CHARPAR='ABC0000'
C     CALL CUTZERO(CHARPAR,4)
C
C     WOULD RETURN THE VALUE 'ABC0   ' IN CHAR, AND WOULD NOT
C     ALTER THE FIRST 4 CHARACTERS.
C
C     METHOD
C     ------
C
C     THE STRIG IS TESTED FOR THE EXISTANCE OF A ZERO CHARACTER.
C     IF NONE IS FOUND, NO CHANGE TAKES PLACE.
C     IF ONE OR MORE ZERO CHARACTERS ARE PRESENT, THE END OF THE
C     STRING IS LOCATED. WORKING BACKWARDS FROM THE END TO THE
C     KMIN-1 POSITION, CHARACTERS ARE TESTED FOR ZERO. IF A ZERO
C     IS FOUND, IT IS REPLACED BY BLANK. IF A NON-ZERO IS FOUND,
C     THE REPLACEMENT LOOP TERMINATES.
C
C     MODIFICATIONS
C     -------------
C
C     ORIGINAL VERSION - 25.01.95 - REX GIBSON - ECMWF.
C
      CHARACTER*(*) CHARPAR
      CHARACTER*1   YZERO
      INTEGER LEN
C
C     -----------------------------------------------------------
C
C*     1.     FIND AND REPLACE THE ZERO CHARACTERS.
C
  100 CONTINUE
      YZERO=CHAR(0)
      I1=INDEX(CHARPAR,'0')
      IF (I1.GT.0) THEN
         I2=MAX(I1,KMIN+1)
         I3=INDEX(CHARPAR,' ')-1
         IF (I3.LE.0) THEN
            I3=LEN(CHARPAR)
         ENDIF
         DO 112 J=I3,I2,-1
         IF (CHARPAR(J:J).EQ.'0') THEN
             CHARPAR(J:J)=' '
         ELSEIF (CHARPAR(J:J).EQ.YZERO) THEN
             GO TO 112
         ELSE
             GO TO 114
         ENDIF
  112    CONTINUE
C
  114    CONTINUE
      ENDIF
C
C     -----------------------------------------------------------
C
C*     2.     RETURN.
C
  200 CONTINUE
C
      END
      SUBROUTINE SEARCH(KARRAY,K,KVAL,KINDEX)
C
C**** *SEARCH*
C
C
C     PURPOSE.
C     --------
C         
C
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *SEARCH(KARRAY,K,KVAL,KINDEX)*
C             KARRAY  - list
C             K       - number of elements in the list
C             KVAL    - value to be searched for
C             KINDEX  - index of matched value
C
C     METHOD.
C     -------
C
C          NONE.
C
C
C     EXTERNALS.
C     ----------
C
C          NONE.
C
C     REFERENCE.
C     ----------
C
C          NONE.
C
C     AUTHOR.
C     -------
C
C          M. DRAGOSAVAC    *ECMWF*       15/01/92.
C
C
C     MODIFICATIONS.
C     --------------
C
C          NONE.
C
C
      IMPLICIT LOGICAL(L,O,G), CHARACTER*8(C,H,Y)
C
C
      character*(*)  KARRAY(*)
      character*(*)  KVAL
      logical found
      integer count
C
C     ------------------------------------------------------------------
C*          1.   Binary search. 
C                _____________
 100  CONTINUE
C
      IHIGH = K
      ILOW  = 1
C
      count=0
      found=.false.
      kindex=0
      numbis= int(log(real(k))/log(2.0)) +1

      ihigh = K+1
      ilow  = 1

      do while(.not.found .and.count .ne. numbis)

            mid = (ihigh + ilow)/2
            if(karray(mid).eq.kval) then
               found=.true.
            elseif(kval .lt.karray(mid)) then
               ihigh= mid
            elseif(kval.gt.karray(mid)) then
               ilow= mid
            end if
            count=count+1
      end do

      if(found) kindex=mid

C
      RETURN
      END

      PROGRAM BUFR
C
C**** *BUFR*
C
C
C     PURPOSE.
C     --------
C         Repacks Bufr multisubset data into single Bufr
C         messages creating appropriate RDB key.
C
C
C**   INTERFACE.
C     ----------
C
C          NONE.
C
C     METHOD.
C     -------
C
C          NONE.
C
C
C     EXTERNALS.
C     ----------
C
C         CALL BUSEL
C         CALL BUFREX
C         CALL BUFREN
C         CALL BUPRS0
C         CALL BUPRS1
C         CALL BUPRS2
C         CALL BUPRS3
C         CALL BUPRT
C         CALL BUUKEY
C
C     REFERENCE.
C     ----------
C
C          NONE.
C
C     AUTHOR.
C     -------
C
C          M. DRAGOSAVAC    *ECMWF*       15/02/95.
C
C
C     MODIFICATIONS.
C     --------------
C
C          NONE.
C
C
      IMPLICIT LOGICAL(L,O,G), CHARACTER*8(C,H,Y)
C
      PARAMETER(JSUP =   9,JSEC0=   3,JSEC1= 40,JSEC2=4096 ,JSEC3= 4,
     1       JSEC4=   2,JELEM=160000,JSUBS=400,JCVAL=150 ,JBUFL=512000,
#ifdef JBPW_64
     2          JBPW =  64,JTAB =3000,JCTAB=120,JCTST=1800,JCTEXT=1200,
#else
     2          JBPW =  32,JTAB =3000,JCTAB=120,JCTST=1800,JCTEXT=1200,
#endif
     3          JWORK=4096000,JKEY=46,JBYTE=512000)
C
      PARAMETER (KELEM=20000)
      PARAMETER (KVALS=360000)
C 
      DIMENSION KBUFF(JBUFL)
      DIMENSION KBUFR(JBUFL)
      DIMENSION KSUP(JSUP)  ,KSEC0(JSEC0),KSEC1(JSEC1)
      DIMENSION KSEC2(JSEC2),KSEC3(JSEC3),KSEC4(JSEC4)
      DIMENSION KEY  (JKEY),KREQ(2)
C
      REAL*8 VALUES(KVALS),VALUE(KVALS)
      REAL*8 RQV(KELEM)
      REAL*8 RVIND, EPS
      REAL*8 RLA,RLO,ZEN_ANG
      DIMENSION KTDLST(KELEM),KTDEXP(KELEM),KRQ(KELEM)
      DIMENSION KTDLST1(KELEM)
      DIMENSION KDATA(200)
      DIMENSION IOUT(12800)
C
      CHARACTER*256 CF(100),COUT,CFIN
      CHARACTER*64 CNAMES(KELEM)
      CHARACTER*24 CUNITS(KELEM)
      CHARACTER*80 CVALS(KVALS)
      CHARACTER*80 YENC
      CHARACTER*256 CARG(10)
c
cs      EXTERNAL GETARG,sat_zenith_angle
      EXTERNAL sat_zenith_angle
C                                                                       
C     ------------------------------------------------------------------
C*          1. INITIALIZE CONSTANTS AND VARIABLES.
C              -----------------------------------
 100  CONTINUE
C
C     Missing value indicator
C 
      itlen=6400
      itl=0
      jz=0
      nbytes=jbpw/8
      RVIND=1.7D38
      EPS=1.0D08
      nvind=2147483647
      iobs=0
      KRQL=0
      NR=0
      KREQ(1)=0
      KREQ(2)=0
      do 102 i=1,kelem
      rqv(i)=rvind
      krq(i)=nvind
 102  continue
c
C     Input file names
C
      narg=iargc()
      if(narg.lt.4) then
         print*,'Usage -- bufr_repack -i infiles -o outfile'
         stop
      end if
      nfile=narg
c
      do 104 j=1,narg
      call getarg(j,carg(j))
 104  continue

      ii=0
      io=0
      do 105 j=1,narg
      if(carg(j).eq.'-i') then
         in=j
      elseif(carg(j).eq.'-o') then
         io=j
      end if
 105  continue
      if(io.eq.0.or.in.eq.0) then
          print*,'Usage -- bufr_repack -i infiles -o outfile'
          stop
      end if
c
      cout=carg(io+1)
c
      if(io.lt.in) then
         ist=in+1
         iend=narg
      else
         ist=in+1
         iend=io-1
      end if
c
      jj=index(cout,' ')
c
      CALL PBOPEN(IUNIT1,cout(1:jj),'w',IRET)
      IF(IRET.EQ.-1) STOP 'open failed on bufr.dat'
      IF(IRET.EQ.-2) STOP 'Invalid file name'
      IF(IRET.EQ.-3) STOP 'Invalid open mode specified'
c
      do 101 ii=ist,iend
      cfin=carg(ii) 
      iln=index(cfin,' ')
C
C*          1.2 OPEN FILE CONTAINING BUFR DATA.
C               -------------------------------
 120  CONTINUE
C
      IRET=0 
      CALL PBOPEN(IUNIT,CFIN(1:iln),'r',IRET)
      IF(IRET.EQ.-1) STOP 'open failed'
      IF(IRET.EQ.-2) STOP 'Invalid file name'
      IF(IRET.EQ.-3) STOP 'Invalid open mode specified'
c
C     ----------------------------------------------------------------- 
C*          2. SET REQUEST FOR EXPANSION.
C              --------------------------
 200  CONTINUE
C
      OPRT=.FALSE.
      OENC=.true.
      NCOM=1
      OCOMP=.FALSE.
      NR=1
      OSEC3=.FALSE.
C
C*          2.1 SET REQUEST FOR PARTIAL EXPANSION.
C               ----------------------------------
 210  CONTINUE
C
C     set variable to pack big values as missing value indicator
C
C      KPMISS=1
C      KPRUS=0
C      CALL BUPRQ(KPMISS,KPRUS)
C
C     -----------------------------------------------------------------
C*          3.  READ BUFR MESSAGE.
C               ------------------
 300  CONTINUE
C
      IERR=0
      KBUFL=0
C
      IRET=0
      CALL PBBUFR(IUNIT,KBUFF,JBYTE,KBUFL,IRET) 
      IF(IRET.EQ.-1) THEN
          go to 900
      END IF
      IF(IRET.EQ.-2) STOP 'File handling problem' 
      IF(IRET.EQ.-3) STOP 'Array too small for product'
C
      N=N+1
      ikbufl=kbufl
      KBUFL=KBUFL/nbytes+1
      IF(N.LT.NR) GO TO 300
C
C     -----------------------------------------------------------------
C*          4. EXPAND BUFR MESSAGE.
C              --------------------
 400  CONTINUE
C
      CALL BUS012(KBUFL,KBUFF,KSUP,KSEC0,KSEC1,KSEC2,KERR)
      IF(KERR.NE.0) THEN
         PRINT*,'Error in BUS012: ',KERR
         PRINT*,' BUFR MESSAGE NUMBER ',N,' CORRUPTED.'
         KERR=0
         GO TO 300
      END IF
C
      IF(KSUP(6).GT.1) THEN
         KEL=KVALS/KSUP(6)
         IF(KEL.GT.KELEM) KEL=KELEM
      ELSE
         KEL=KELEM
      END IF
C
      CALL BUFREX(KBUFL,KBUFF,KSUP,KSEC0 ,KSEC1,KSEC2 ,KSEC3 ,KSEC4,
     1            KEL,CNAMES,CUNITS,KVALS,VALUES,CVALS,IERR)
C
      IF(IERR.NE.0) then
         if(ierr.eq.45) go to 300
         call exit(2)
      end if
      iobs=iobs+ksec3(3)
C
      CALL BUSEL(KTDLEN,KTDLST,KTDEXL,KTDEXP,KERR)
      IF(KERR.NE.0) CALL EXIT(2)
C
C*          4.1 PRINT CONTENT OF EXPANDED DATA.
C               -------------------------------
 410  CONTINUE
C
      IF(.NOT.OPRT) GO TO 500
      IF(.NOT.OSEC3) GO TO 450
C
C*          4.2 PRINT SECTION ZERO OF BUFR MESSAGE.
C               -----------------------------------
 420  CONTINUE
C

      CALL BUPRS0(KSEC0)
C
C*          4.3 PRINT SECTION ONE OF BUFR MESSAGE.
C               -----------------------------------
 430  CONTINUE
C
      CALL BUPRS1(KSEC1)
C
C
C*          4.4 PRINT SECTION TWO OF BUFR MESSAGE.
C               -----------------------------------
 440  CONTINUE
c
C              AT ECMWF SECTION 2 CONTAINS RDB KEY.
C              SO UNPACK KEY
C
      CALL BUUKEY(KSEC1,KSEC2,KEY,KSUP,KERR)
C
C              PRINT KEY
C
      CALL BUPRS2(KSUP ,KEY)
C
C*          4.5 PRINT SECTION 3 OF BUFR MESSAGE.
C               -----------------------------------
 450  CONTINUE
C
C               FIRST GET DATA DESCRIPTORS
C
      CALL BUSEL(KTDLEN,KTDLST,KTDEXL,KTDEXP,KERR)
      IF(KERR.NE.0) CALL EXIT(2)
C
C               PRINT  CONTENT
C
      IF(OSEC3) THEN
         CALL BUPRS3(KSEC3,KTDLEN,KTDLST,KTDEXL,KTDEXP,KEL,CNAMES)
      END IF
C
C*         4.6 PRINT SECTION 4 (DATA).
C              -----------------------
 460  CONTINUE
C
C          IN THE CASE OF MANY SUBSETS DEFINE RANGE OF SUBSETS
C
      IF(.NOT.OO) THEN
      WRITE(*,'(a,$)') ' STARTING SUBSET TO BE PRINTED : '
      READ(*,'(BN,I4)')   IST
      WRITE(*,'(a,$)') ' ENDING SUBSET TO BE PRINTED : '
      READ(*,'(BN,I4)')   IEND
      OO=.false.
      END IF
C
C              PRINT DATA
C
      ICODE=0
      CALL BUPRT(ICODE,IST,IEND,KEL,CNAMES,CUNITS,CVALS,
     1           KVALS,VALUES,KSUP,KSEC1,IERR)
c
c              Resolve bit maps 
C
      if(iend.gt.ksec3(3)) iend=ksec3(3)
c
      DO 461 IK=IST,IEND
C 
      CALL BUBOX(IK,KSUP,KEL,KTDEXP,CNAMES,CUNITS,KVALS,VALUES,
     1           KBOX,KAPP,KLEN,KBOXR,VALS,CBOXN,CBOXU,IERR)
C
      CALL BUPRTBOX(KBOX,KAPP,KLEN,KBOXR,VALS,CBOXN,CBOXU)
C
 461  CONTINUE
C
C     -----------------------------------------------------------------
C*          5. COLLECT DATA FOR REPACKING.
C              ---------------------------
 500  CONTINUE
C      
      IF(.NOT.OENC) GO TO 300
C
C               FIRST GET DATA DESCRIPTORS
C
      CALL BUSEL(KTDLEN,KTDLST,KTDEXL,KTDEXP,KERR)
      IF(KERR.NE.0) CALL EXIT(2)
C
C     -----------------------------------------------------------------
C*          6. PACK BUFR MESSAGE BACK INTO BUFR.
C              ---------------------------------
 600  CONTINUE
C
    
      KKK=0
      KBUFL=JBUFL
C
C     GET REPLICATION FACTORS
C
      KK=0
      DO 601 K=1,KSUP(5)
      IF(KTDEXP(K).EQ.31001.OR.KTDEXP(K).EQ.31002.OR.
     1   KTDEXP(K).EQ.31000) THEN
         KK=KK+1
         KDATA(KK)=NINT(VALUES(K))
      END IF
 601  CONTINUE
C
      KDLEN=2
      IF(KK.NE.0) KDLEN=KK
C
C           6.1 Convert subtype 88 into 89
C
 610  CONTINUE
C
      do i=1,KSUP(6)
      do j=1,222
         iv=j+(i-1)*222
         value(iv)=rvind
      end do
      end do
c
      do i=1,KSUP(6)
      do j=1,KSUP(5)
        ij=1+(i-1)*kel
        iv=1+(i-1)*222 
        id=nint(values(ij))
        value(iv)=values(ij)
c
        ij=3+(i-1)*kel 
        iv=6+(i-1)*222
        iyear=nint(values(ij))
        value(iv)=values(ij)
c
        ij=4+(i-1)*kel 
        iv=7+(i-1)*222
        value(iv)=values(ij)
c
        ij=5+(i-1)*kel 
        iv=8+(i-1)*222
        value(iv)=values(ij)
c
        ij=6+(i-1)*kel 
        iv=9+(i-1)*222
        value(iv)=values(ij)
c
        ij=7+(i-1)*kel 
        iv=10+(i-1)*222
        value(iv)=values(ij)
c
        ij=8+(i-1)*kel 
        iv=11+(i-1)*222
        value(iv)=values(ij)
c
        ij=9+(i-1)*kel 
        iv=12+(i-1)*222
        rla=values(ij)
        value(iv)=values(ij)
c
        ij=10+(i-1)*kel 
        iv=13+(i-1)*222
        rlo=values(ij)
        value(iv)=values(ij)
c
        ij=12+(i-1)*kel 
        iv=66+(i-1)*222
        value(iv)=values(ij)
c
        iv=14+(i-1)*222
        call sat_zenith_angle(id,iyear,rla,rlo,zen_ang)
        value(iv)=zen_ang 

      end do
      end do
c
c     set bit map
c
      do i=1,ksup(6)
      do j=109,214
        iv=j+(i-1)*222
        value(iv)=1.0
        if(j.eq.174) value(iv)=0.0
      end do
      end do
c
      do j=1,ksup(6)
        iv=215+(j-1)*222
        value(iv)=254.
        iv=216+(j-1)*222
        value(iv)=1.
        iv=217+(j-1)*222
        value(iv)=100.
        iv=220+(j-1)*222
        value(iv)=254.
        iv=221+(j-1)*222
        value(iv)=1.
        iv=222+(j-1)*222
        value(iv)=0.0
      end do
c
      ktdlst1( 1)=001007
      ktdlst1( 2)=001031
      ktdlst1( 3)=002196
      ktdlst1( 4)=002221
      ktdlst1( 5)=002222
      ktdlst1( 6)=004001
      ktdlst1( 7)=004002
      ktdlst1( 8)=004003
      ktdlst1( 9)=004004
      ktdlst1(10)=004005
      ktdlst1(11)=004006
      ktdlst1(12)=005001
      ktdlst1(13)=006001
      ktdlst1(14)=007024
      ktdlst1(15)=010002
      ktdlst1(16)=002252
      ktdlst1(17)=002023
      ktdlst1(18)=007004
      ktdlst1(19)=011001
      ktdlst1(20)=011002
      ktdlst1(21)=002197
      ktdlst1(22)=002198
      ktdlst1(23)=012193
      ktdlst1(24)=002197
      ktdlst1(25)=002198
      ktdlst1(26)=020193
      ktdlst1(27)=020194
      ktdlst1(28)=020012
      ktdlst1(29)=002197
      ktdlst1(30)=002198
      ktdlst1(31)=020193
      ktdlst1(32)=020194
      ktdlst1(33)=020012
      ktdlst1(34)=002197
      ktdlst1(35)=002198
      ktdlst1(36)=020193
      ktdlst1(37)=020194
      ktdlst1(38)=020012
      ktdlst1(39)=002197
      ktdlst1(40)=002198
      ktdlst1(41)=020193
      ktdlst1(42)=020194
      ktdlst1(43)=020012
      ktdlst1(44)=002197
      ktdlst1(45)=002198
      ktdlst1(46)=020193
      ktdlst1(47)=020194
      ktdlst1(48)=020012
      ktdlst1(49)=002197
      ktdlst1(50)=002198
      ktdlst1(51)=020193
      ktdlst1(52)=020194
      ktdlst1(53)=020012
      ktdlst1(54)=002252
      ktdlst1(55)=002199
      ktdlst1(56)=007004
      ktdlst1(57)=007004
      ktdlst1(58)=013003
      ktdlst1(59)=002252
      ktdlst1(60)=002254
      ktdlst1(61)=002251
      ktdlst1(62)=002197
      ktdlst1(63)=002198
      ktdlst1(64)=012195
      ktdlst1(65)=012196
      ktdlst1(66)=012063
      ktdlst1(67)=002252
      ktdlst1(68)=002254
      ktdlst1(69)=002251
      ktdlst1(70)=002197
      ktdlst1(71)=002198
      ktdlst1(72)=012195
      ktdlst1(73)=012196
      ktdlst1(74)=012063
      ktdlst1(75)=002252
      ktdlst1(76)=002254
      ktdlst1(77)=002251
      ktdlst1(78)=002197
      ktdlst1(79)=002198
      ktdlst1(80)=012195
      ktdlst1(81)=012196
      ktdlst1(82)=012063
      ktdlst1(83)=002252
      ktdlst1(84)=002254
      ktdlst1(85)=002251
      ktdlst1(86)=002197
      ktdlst1(87)=002198
      ktdlst1(88)=012195
      ktdlst1(89)=012196
      ktdlst1(90)=012063
      ktdlst1(91)=002252
      ktdlst1(92)=002254
      ktdlst1(93)=002251
      ktdlst1(94)=002197
      ktdlst1(95)=002198
      ktdlst1(96)=012195
      ktdlst1(97)=012196
      ktdlst1(98)=012063
      ktdlst1(99)=002252
      ktdlst1(100)=002254
      ktdlst1(101)=002251
      ktdlst1(102)=002197
      ktdlst1(103)=002198
      ktdlst1(104)=012195
      ktdlst1(105)=012196
      ktdlst1(106)=012063
      ktdlst1(107)=222000
      ktdlst1(108)=236000
      ktdlst1(109)=101106
      ktdlst1(110)=031031
      ktdlst1(111)=001031
      ktdlst1(112)=001032
      ktdlst1(113)=101001
      ktdlst1(114)=033007
      ktdlst1(115)=222000
      ktdlst1(116)=237000
      ktdlst1(117)=001031
      ktdlst1(118)=001032
      ktdlst1(119)=101001
      ktdlst1(120)=033252
c
      ktdlen=120
C
C*          6.2 ENCODE DATA INTO BUFR MESSAGE.
C               ------------------------------
 620  CONTINUE
C
C     repacking multisubset data one by one
C
      CALL BUUKEY(KSEC1,KSEC2,KEY,KSUP,KERR)
c
      IF(KSUP(6).EQ.0) THEN
         print*,'Zero subsets'
         call exit(2)
      END IF
c
      key(3)=89
      ksec1(7)=89
      ksec1(15)=13
c
c     Get information for RDB key
c
      CALL BUCREKEY(KTDEXP,KSUP,KSEC1,KEY,VALUES,CVALS,KERR)
      IF(KERR.NE.0) THEN
         print*,'Error in BUCREKEY.'
         call exit(2)
      end if
c
c     Pack new RDB key
c
      CALL BUPKEY(KEY,KSEC1,KSEC2,KERR)
      IF(KERR.NE.0) CALL EXIT(2)
c
         
      kel1=222
      if(ksec3(4).eq.0) ksec3(4)=192
      CALL BUFREN( KSEC0,KSEC1,KSEC2,KSEC3,KSEC4,
     1             KTDLEN,KTDLST1,KDLEN,KDATA,KEL1,        !ksup(5),
     2             KVALS,VALUE,CVALS,KBUFL,KBUFR,KERR)
C
      IF(KERR.GT.0) THEN
         PRINT*,'ERROR DURING ENCODING.'
         CALL EXIT(2)
      END IF
C
C           6.3 WRITE PACKED BUFR MESSAGE INTO FILE.
C               ------------------------------------
 630  CONTINUE
C
      ikbufl=KBUFL*4
      CALL PBWRITE(IUNIT1,kbufr,ikbufl,IERR)
      IF(IERR.LT.0) THEN
         print*,'Error writing into target file.'
         call exit(2)
      END IF
C
      GO TO 300
C     -----------------------------------------------------------------
C
 810  CONTINUE
C
      WRITE(*,'(1H ,A)') 'OPEN ERROR ON INPUT FILE'
      GO TO 900
C      
 800  CONTINUE
C
      IF(IRET.EQ.-1) THEN
         print*,'Number of records processed ',n
      ELSE
         print*,' BUFR : error= ',ierr
      END IF
C
 900  CONTINUE
C
      CALL PBCLOSE(IUNIT,IRET)
 101  CONTINUE
c
      CALL PBCLOSE(IUNIT1,IRET)
C
      END
      SUBROUTINE SAT_ZENITH_ANGLE(SAT_ID,YEAR,OBS_LAT,OBS_LON,ZEN_ANG)


       real*8 obs_lat,obs_lon
       integer sat_id,year
       real*8 zen_ang

       parameter ( dtr    = 0.017453292)
       parameter ( radius = 6371.0)
       parameter ( pi     = 3.14159)
       parameter ( height = 35800.0)

       real  sat_lat_rad,sat_lon_rad, sat_lat, sat_lon
       real  obs_lat_rad,obs_lon_rad
       real  xx,yy,zz
       real  arcl, distance
       real  ang, s

c      begin main routine

       sat_lat = 0.0
       sat_lon = 0.0

c     Meteosat 5 for INDOEX
       if (sat_id .eq. 52 .and. year .gt. 1997) sat_lon = 63.0

       sat_lat_rad = sat_lat * dtr
       sat_lon_rad = sat_lon * dtr

       obs_lat_rad = obs_lat * dtr
       obs_lon_rad = obs_lon * dtr

       xx = cos(obs_lat_rad)*cos(obs_lon_rad)
     1       - cos(sat_lat_rad)*cos(sat_lon_rad)
       yy = cos(obs_lat_rad)*sin(obs_lon_rad)
     1       - cos(sat_lat_rad)*sin(sat_lon_rad)
       zz = sin(obs_lat_rad) - sin(sat_lat_rad)

       arcl = 2.0 * asin(sqrt(xx*xx + yy*yy + zz*zz)/2.0)                                       
       distance = arcl*radius

       ang  = (360.0 * distance/(2.0 * pi * radius)) * dtr
       s    = sqrt(radius**2.0 + (radius+height)**2.0 - 
     1        2.0 * radius * (radius+height) * cos(ang))

       zen_ang = abs(asin((radius + height) * sin(ang)/s) / dtr )

       return                                                            
      end 

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities
C granted to it by virtue of its status as an intergovernmental organisation
C nor does it submit to any jurisdiction.
C

      INTEGER FUNCTION KRG2RGY(OLDFLD, NEWFLD, NUMGG)
C
C---->
C**** KRG2RGY
C
C     Purpose
C     -------
C
C     Interpolate a field based on one reduced gaussian grid to a
C     field based on a different reduced gaussian grid.
C
C
C     Interface
C     ---------
C
C     IRET = KRG2RGY(OLDFLD, NEWFLD, NUMGG)
C
C     Input
C     -----
C
C     OLDFLD - Old field in GRIB format
C     NUMGG  - Number of the new gaussian field
C
C
C     Output
C     ------
C
C     NEWFLD - New field
C
C     Function returns:
C       - the size in bytes of the new GRIB product if all is well
C       - -1, otherwise.
C
C
C     Method
C     ------
C
C     Unpack input GRIBS.
C     Create new field
C
C
C     Externals
C     ---------
C
C     GRIBEX  - Decode and encode GRIB products.
C     KINTRG  - Interpolate reduced gaussian field to reduced gaussian
C     JMALLOC - Dynamically allocate memory
C     INTLOG  - Log messages
C
C
C     Author
C     ------
C
C     S.Curic     ECMWF     November 2006
C
C----<
C
      IMPLICIT NONE
C
C     Function arguments
C
      INTEGER NUMGG, OLDFLD(*), NEWFLD(*)
C
#include "parim.h"
#include "nifld.common"
#include "nofld.common"
#include "grfixed.h"
C
C     Parameters
C
      INTEGER JPACK, JUNPACK, JPREALB
      PARAMETER (JPACK   = 4000000)
      PARAMETER (JUNPACK = 6000000)
#ifdef REAL_8
      PARAMETER (JPREALB = 8)
#else
      PARAMETER (JPREALB = 8)
#endif
C
C     Local variables
C
      INTEGER IFSEC0(JPGRIB_ISEC0),IFSEC1(JPGRIB_ISEC1),
     X IFSEC2(JPGRIB_ISEC2),IFSEC3(JPGRIB_ISEC3),IFSEC4(JPGRIB_ISEC4)
      INTEGER NFSEC2(JPGRIB_ISEC2)
      INTEGER ISIZE, LOOP
      LOGICAL LFIRST
      CHARACTER*1 HTYPE
#ifndef _CRAYFTN
#if (!defined sgi)
#ifdef POINTER_64
      INTEGER*8 IZFSEC4
#else
      INTEGER   IZFSEC4
#endif
#endif
#endif
C
      REAL PLAT(JPMAXNG)
      REAL ZFSEC2(5000), ZFSEC3(2), ZFSEC4(1)
C
      POINTER( IZFSEC4, ZFSEC4 )
C
      INTEGER IRET, ILENB, IPUNP, IWORD
C
C     Externals
C
#ifdef POINTER_64
      INTEGER*8 JMALLOC
#else
      INTEGER JMALLOC
#endif
      INTEGER KINTRG
      EXTERNAL KINTRG, JMALLOC
C
      DATA LFIRST/.TRUE./
      SAVE LFIRST, IZFSEC4
C
C     -----------------------------------------------------------------|
C*    Section 1.   Initialise
C     -----------------------------------------------------------------|
C
  100 CONTINUE
C
      KRG2RGY = 0
C
      IF( (NUMGG*2).GT.JPMAXNG ) THEN
        CALL INTLOG(JP_ERROR,'KRG2RGY: Gaussian N too big = ',NUMGG)
        CALL INTLOG(JP_ERROR,'KRG2RGY: Maximum handled = ',(JPMAXNG/2))
        KRG2RGY = -1
        GOTO 900
      ENDIF
C
C     First time, dynamically allocate memory for the field values
C
      IF( LFIRST ) THEN
        LFIRST = .FALSE.
        ISIZE = JUNPACK * JPREALB
        CALL INTLOG(JP_DEBUG,'KRG2RGY: Allocate memory = ',ISIZE)
C
        IZFSEC4 = JMALLOC(ISIZE)
#ifdef hpR64
        IZFSEC4 = IZFSEC4/(1024*1024*1024*4)
#endif
        IF( IZFSEC4.EQ.0 ) THEN
          CALL INTLOG(JP_ERROR,'KRG2RGY: JMALLOC fail IZFSEC4',JPQUIET)
          KRG2RGY = -1
          GOTO 900
        ENDIF
       ENDIF
C
C     -----------------------------------------------------------------|
C*    Section 2.   Unpack the input GRIB
C     -----------------------------------------------------------------|
C
  200 CONTINUE
C
C     Old field
C
      IRET = 1
      IPUNP = JUNPACK
      ILENB = JPACK
      IFSEC3(1) = 0
      IFSEC3(2) = INT(RMISSGV)
      ZFSEC3(1) = 0.0
      ZFSEC3(2) = RMISSGV
      CALL GRIBEX (IFSEC0,IFSEC1,IFSEC2,ZFSEC2,IFSEC3,ZFSEC3,IFSEC4,
     X             ZFSEC4,IPUNP,OLDFLD,ILENB,IWORD,'D',IRET)
      IF( IRET.GT.0 ) THEN
        WRITE(*,*) 'KRG2RGY: Old field gribex return code = ',IRET
        KRG2RGY = -1
        RETURN
      ENDIF
C
C     -----------------------------------------------------------------|
C*    Section 3.   Create new field
C     -----------------------------------------------------------------|
C
  300 CONTINUE
C
      DO LOOP = 1, JPMAXNG
        NFSEC2(LOOP) = IFSEC2(LOOP)
      ENDDO
      HTYPE = 'R'
      IF( LOCTAHEDRAL ) HTYPE = 'O'
      CALL JGETGG( NUMGG, HTYPE, PLAT, NFSEC2(23), IRET)
      IF( IRET.NE.0 ) THEN
        WRITE(*,*) 'KRG2RGY: Problem calling JGETGG, status = ',IRET
        KRG2RGY = -1
        RETURN
      ENDIF
      NFSEC2(3)  = NUMGG * 2
      NFSEC2(4)  = NINT(PLAT(1)*1000.0)
      NFSEC2(7)  = NINT(PLAT(NUMGG*2)*1000.0)
c     EMOS-199: NFSEC2(8) adjusted for reduced_gg/octahedral
c     NFSEC2(8)  = NINT((360.0-(360.0/REAL(NUMGG*4)))*1000.0)
      NFSEC2(8)  = NINT((360.0-(360.0/REAL(NFSEC2(23+NUMGG))))*1000.0)
      NFSEC2(10) = NUMGG
C
      IRET = KINTRG(IFSEC2, NFSEC2, ZFSEC4, NEWFLD)
      IF( IRET.LE.0 ) THEN
        WRITE(*,*) 'KRG2RGY: New field creation failed'
        KRG2RGY = -1
        RETURN
      ENDIF
      IF( LDOUBLE ) THEN
        CALL INTLOG(JP_DEBUG,
     X    'KRG2RGY: Set NIAREA - double interpolation',JPQUIET)
c       NIAREA(1)  = NFSEC2(4)*100
c       NIAREA(2)  = NFSEC2(5)*100
c       NIAREA(3)  = NFSEC2(7)*100
c       NIAREA(4)  = NFSEC2(8)*100
        NIAREA(1)  = 0
        NIAREA(2)  = 0
        NIAREA(3)  = 0
        NIAREA(4)  = 0
        NIGAUSS    = NUMGG
        RIGAUSS(1:NINS) = 0
        MILLEN (1:NINS) = 0
        NINS       = NUMGG*2
      ENDIF

C
      KRG2RGY = IRET
C     -----------------------------------------------------------------|
C*    Section 9.   Return
C     -----------------------------------------------------------------|
C
  900 CONTINUE
C
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE GRPRS3 (KSEC0,KSEC3,PSEC3)
C
C---->
C**** GRPRS3 - Print information from Section 3 of GRIB code.
C
C     Purpose.
C     --------
C
C     Print the information in the Bit-map section
C     Section (Section 3) of decoded GRIB data.
C
C**   Interface.
C     ----------
C
C     CALL GRPRS3 (KSEC0,KSEC3,PSEC3)
C
C     Input Parameters.
C     -----------------
C
C     KSEC0 - Array of decoded integers from Section 0.
C     KSEC3 - Array of decoded integers from Section 3.
C
C     PSEC3 - Array of decoded reals from Section 3.
C
C     Output Parameters.
C     ------------------
C
C     None.
C
C     Method.
C     -------
C
C     Fields printed as integers or reals.
C
C     Externals.
C     ----------
C
C     Common block GRPRSCM.
C
C     Reference.
C     ----------
C
C     WMO Manual on Codes re GRIB Code.
C     See also routine GRIBEX.
C
C     Comments.
C     ---------
C
C     Routine contains Sections 0 to 1 and Section 9.
C
C     Author.
C     -------
C
C     J. Hennessy    ECMWF 11.09.91
C
C     Modifications.
C     --------------
C
C     J.D.Chambers   ECMWF 20.07.94
C     Change format for printing missing data indicator to
C     allow largest negative (32-bit) number
C
C     J.D.Chambers   ECMWF 14.06.95
C     Change format for printing missing data indicator to
C     allow for MAGICS value (-1.5E+21)
C
C     J.D.Chambers   ECMWF    June 2002
C     Add option to set output stream number using environment variable
C     GRPRS_STREAM
C
C----<
C     -----------------------------------------------------------------|
C*    Section 0. Definition of variables.
C     -----------------------------------------------------------------|
C
      IMPLICIT NONE
C
#include "common/grprs.h"
C
      INTEGER KSEC0(*)
      INTEGER KSEC3(*)
      REAL PSEC3(*)
C
C     -----------------------------------------------------------------|
C*    Section 1 . Print required information.
C     -----------------------------------------------------------------|
C
  100 CONTINUE
C
      WRITE(GRPRSM,9000)
      WRITE(GRPRSM,9001)
      WRITE(GRPRSM,9002)
C
      IF( KSEC3(1).NE.0 ) THEN
        WRITE(GRPRSM,9003) KSEC3(1)
      ELSE
        WRITE(GRPRSM,9004)
      ENDIF
      WRITE(GRPRSM,9005) KSEC3(2)
C
      WRITE(GRPRSM,*)
     X  'Missing data value for real data.        ', PSEC3(2)
C
C     -----------------------------------------------------------------|
C*    Section 9 . Format statements. Return to calling routine.
C     -----------------------------------------------------------------|
C
  900 CONTINUE
C
 9000 FORMAT (1H )
 9001 FORMAT (1H ,'Section 3 - Bit-map Section.')
 9002 FORMAT (1H ,'-------------------------------------')
 9003 FORMAT (1H ,'Predetermined bit-map number.                ',I9)
 9004 FORMAT (1H ,'No predetermined bit-map.')
 9005 FORMAT (1H ,'Missing data value for integer data.    ',I14)
 9006 FORMAT (1H ,'Missing data value for real data.        ',F20.6)
C
      RETURN
C
      END

C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      INTEGER FUNCTION IRPREC (PIFELD, KSTART, KINS, POFELD, KOWE,
     1   KONS, KWEIND, KNSIND, PWFACT, PMAX, PINPNT, KPR, KERR)
C
C---->
C**** *IRPREC*
C
C     PURPOSE
C     _______
C
C     Perform additional interpolation processes for precipitation
C     fields when the input field is quasi regular.
C
C     INTERFACE
C     _________
C
C     IERR = IRPREC (PIFELD, KSTART, KINS, POFELD, KOWE, KONS,
C    1   KWEIND, KNSIND, PWFACT, PMAX, PINPNT, KPR, KERR)
C
C     Input parameters
C     ________________
C
C     PIFELD     - The input field provided by the calling routine.
C
C     KSTART     - The array offset for each line of latitude within
C                  the quasi regular field.
C
C     KINS       - The number of points in the North-South direction
C                  in the input field.
C
C     POFELD     - The output field as previously calculated.
C
C     KOWE       - The number of points in the West-East direction in
C                  the output field.
C
C     KONS       - The number of points in the North-South direction
C                  in the output field.
C
C     KWEIND     - This array contains the array offsets of the West
C                  and East points in the input array required for
C                  interpolation.
C
C     KNSIND     - This array contains the array offsets of the North
C                  and South points in the input array required for
C                  interpolation.
C
C     PWFACT     - The array of interpolating weights to the four
C                  neighbouring points for every output point.
C
C     PMAX       - Work array used to aid vectorisation.
C
C     PINPNT     - Work array used to aid vectorisation.
C
C     KPR        - The debug print switch.
C                  0  , No debugging output.
C                  1  , Produce debugging output.
C
C     KERR       - The error control flag.
C                  -ve, No error message. Return error code.
C                  0  , Hard failure with error message.
C                  +ve, Print error message. Return error code.
C
C     Output parameters
C     ________________
C
C     POFELD     - The output field as modified to allow for
C                  precipitation.
C
C     Return value
C     ____________
C
C     The error indicator (INTEGER).
C
C     Error and Warning Return Values
C     _______________________________
C
C     None
C
C     Common block usage
C     __________________
C
C     None
C
C     EXTERNALS
C     _________
C
C     INTLOG(R)    - Logs messages.
C     CHKPREC - Check if precipitation threshold has been redefined
C
C     METHOD
C     ______
C
C     The precipitation at a point is set to zero in the following
C     circumstances.
C
C     1  The interpolated precipitation is less than a threshold value.
C
C     2  There is no precipitation at the neighbouring point with the
C        highest interpolating weight.
C
C     NOTE that this operation is performed before the special
C     routines for the poles when interpolating from quasi regular
C     Gaussian grids to global latitude/longitude fields. The polar
C     values for precipitation, during such interpolations, will
C     always be the average value of the nearest Gaussian line with
C     no threshold check.
C
C     REFERENCE
C     _________
C
C     None
C
C     COMMENTS
C     ________
C
C     Program contains sections 0 to 3 and 9
C
C     AUTHOR
C     ______
C
C     K. Fielding      *ECMWF*      Nov 1993
C
C     MODIFICATIONS
C     _____________
C
C     None
C
C----<
C     _______________________________________________________
C
C
C*    Section 0. Definition of variables.
C     _______________________________________________________
C
C*    Prefix conventions for variable names
C
C     Logical      L (but not LP), global or common.
C                  O, dummy argument
C                  G, local variable
C                  LP, parameter.
C     Character    C, global or common.
C                  H, dummy argument
C                  Y (but not YP), local variable
C                  YP, parameter.
C     Integer      M and N, global or common.
C                  K, dummy argument
C                  I, local variable
C                  J (but not JP), loop control
C                  JP, parameter.
C     REAL         A to F and Q to X, global or common.
C                  P (but not PP), dummy argument
C                  Z, local variable
C                  PP, parameter.
C
C     Implicit statement to force declarations
C
      IMPLICIT NONE
C
#include "parim.h"
#include "nifld.common"
C
C     Dummy arguments
      INTEGER KOWE, KINS, KONS, KPR, KERR
      INTEGER KSTART (KINS)
      INTEGER KWEIND (2, KOWE, 2, KONS), KNSIND (2, KONS)
      REAL PIFELD (*), POFELD (KOWE, KONS)
      REAL PWFACT (4, KOWE, KONS)
      REAL PMAX (KOWE), PINPNT (KOWE)
C
C     Local variables
      LOGICAL LAT_RAIN
      INTEGER ILAT, IDIR, ISTART
      INTEGER JOLAT, JOLON, JNS, JWE
      INTEGER JPROUTINE
      PARAMETER (JPROUTINE = 23500)
C
C     _______________________________________________________
C
C*    Section 1. Initialisation
C     _______________________________________________________
C
  100 CONTINUE
C
      IF (KPR.GE.1) CALL INTLOG(JP_DEBUG,'IRPREC: Section 1.',JPQUIET)
C
      IRPREC = 0
C
      IF (KPR .GE. 1) THEN
        CALL INTLOG(JP_DEBUG,'IRPREC: No. of input fld lats = ',KINS)
        CALL INTLOG(JP_DEBUG,'IRPREC: No. of output fld lats = ',KONS)
        CALL INTLOG(JP_DEBUG,'IRPREC: No. of output fld longs = ',KOWE)
      ENDIF
C
C     _______________________________________________________
C
C*    Section 2. eliminate output precipitation based on
C                interpolation threshhold
C     _______________________________________________________
C
  200 CONTINUE
C
      IF (KPR.GE.1) CALL INTLOG(JP_DEBUG,'IRPREC: Section 2.',JPQUIET)
C
      CALL CHKPREC()
C
      DO 360 JOLAT = 1, KONS
C
         LAT_RAIN = .FALSE.
C
         DO 210 JOLON = 1, KOWE
C
            IF (POFELD (JOLON, JOLAT) .LT. ZPRECIP) THEN
               POFELD (JOLON, JOLAT) = PPZERO
            ELSE
               LAT_RAIN = .TRUE.
            ENDIF
C
  210    CONTINUE
C
C     _______________________________________________________
C
C*    Section 3. eliminate output precipitation based on
C                "nearest" point.
C
C                Do not bother if there is no precipitation on this
C                line of latitude
C     _______________________________________________________
C
  300 CONTINUE
C
      IF (KPR .GE. 1 .AND. JOLAT .EQ. 1) 
     X  CALL INTLOG(JP_DEBUG,'IRPREC: Section 3.',JPQUIET)
C
C
         IF (LAT_RAIN) THEN
C
            DO 310 JOLON = 1, KOWE
C
               PMAX (JOLON) = PPZERO
C
  310       CONTINUE
C
            DO 340 JNS = 1, 2
C
               ILAT = KNSIND (JNS, JOLAT)
               ISTART = KSTART (ILAT) - 1
C
               DO 330 JWE = 1, 2
C
                  IDIR = (JNS - 1) * 2 + JWE
C
                  DO 320 JOLON = 1, KOWE
C
                     IF (PWFACT (IDIR, JOLON, JOLAT) .GT.
     1                  PMAX (JOLON) ) THEN
C
                        PMAX (JOLON) = PWFACT (IDIR, JOLON, JOLAT)
C
                        PINPNT (JOLON) = PIFELD (ISTART +
     2                     KWEIND (JWE, JOLON, JNS, JOLAT) )
C
                     ENDIF
C
  320             CONTINUE
C
  330          CONTINUE
C
  340       CONTINUE
C
            DO 350 JOLON = 1, KOWE
C
               IF (PINPNT (JOLON) .LT. ZPRECIP)
     1            POFELD (JOLON, JOLAT) = PPZERO
C
  350       CONTINUE
C
         ENDIF
C
  360 CONTINUE
C
C     _______________________________________________________
C
C
C*    Section 9. Return to calling routine. Format statements
C     _______________________________________________________
C
  900 CONTINUE
C
      IF (KPR.GE.1) CALL INTLOG(JP_DEBUG,'IRPREC: Section 9.',JPQUIET)
C
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE JALLWN( PSHUP, KTRUNC, PNORTH, PSOUTH, PWEST, PEAST,
     X                    PLATINC, PLONINC, POUTF, KRET)
C
C---->
C**** JALLWN
C
C     PURPOSE
C     _______
C
C     This routine converts spectral input fields to standard
C     lat/long grid fields.
C
C     INTERFACE
C     _________
C
C     CALL JALLWN( PSHUP, KTRUNC, PNORTH, PSOUTH, PWEST, PEAST,
C    X                    PLATINC, PLONINC, POUTF, KRET)
C
C     Input parameters
C     ________________
C
C     PSHUP    - Spherical harmonics field, unpacked
C     KTRUNC   - Truncation number of spherical harmonics field
C     PNORTH   - Northernmost latitude for output field (degrees)
C     PSOUTH   - Southernmost latitude for output field (degrees)
C     PWEST    - Westernmost longitude for output field (degrees)
C     PEAST    - Easternmost longitude for output field (degrees)
C     PLATINC  - Grid interval between latitudes in degrees
C     PLONINC  - Grid interval between longitudes in degrees
C     INTLOG   - Output log message
C     INTLOGR  - Output log message (with real value)
C
C     Output parameters
C     ________________
C
C     POUTF    - Output grid point field
C     KRET     - Return status code
C                0 = OK
C
C     Common block usage
C     __________________
C
C     JDCNDBG
C
C     Method
C     ______
C
C     Generates the latitudes in bands, 32 at a time plus some
C     remainder.
C
C     Externals
C     _________
C
C     JALLGP  - Cnverts spectral fields to lat/long grid fields.
C     JSLLGP  - Converts stretched spectral fields to lat/long grids
C
C
C     Reference
C     _________
C
C     None.
C
C
C     Comments
C     ________
C
C     Calls JALLGP or JSLLGP to do all the work!
C
C
C     AUTHOR
C     ______
C
C     J.D.Chambers      *ECMWF*      Nov 1993
C
C     MODIFICATIONS
C     _____________
C
C     J.D.Chambers      *ECMWF*      Oct 1996
C     Replaced all code by a call to JALLGP.
C
C----<
C     _______________________________________________________
C
C*    Section 0. Definition of variables.
C     _______________________________________________________
C
      IMPLICIT NONE
#include "jparams.h"
#include "parim.h"
#include "nifld.common"
C
C     Subroutine arguments
C
      COMPLEX   PSHUP
      DIMENSION PSHUP(*)
      INTEGER   KTRUNC
      REAL      PNORTH, PSOUTH, PWEST, PEAST, PLATINC, PLONINC
      REAL      POUTF
      DIMENSION POUTF(*)
      INTEGER   KRET
C
C     Parameters
      INTEGER JPROUTINE
      PARAMETER ( JPROUTINE = 30000 )
C
C     Local variables
C
C     _______________________________________________________
C
C*    Section 1.    Initialization.
C     _______________________________________________________
C
  100 CONTINUE
      CALL JDEBUG( )
C
      IF( NDBG.GT.0 )
     X  CALL INTLOG(JP_DEBUG,'JALLWN: Calling JALLGP', JPQUIET)
C
      IF( RISTRET.NE.0 ) THEN
        CALL JSLLGP( PSHUP, KTRUNC, PNORTH, PSOUTH, PWEST, PEAST,
     X               PLATINC, PLONINC, POUTF, KRET)
      ELSE
        CALL JALLGP( PSHUP, KTRUNC, PNORTH, PSOUTH, PWEST, PEAST,
     X               PLATINC, PLONINC, POUTF, KRET)
      ENDIF
C
      IF( NDBG.GT.0 )
     X  CALL INTLOG(JP_DEBUG,'JALLWN: Returned from JALLGP', JPQUIET)
C
C     _______________________________________________________
C
C*    Section 9. Return to calling routine. Format statements
C     _______________________________________________________
C
 900  CONTINUE
C
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      INTEGER FUNCTION HNTFAP(INGRIB,INLEN)
C
C---->
C**** HNTFAP
C
C     Purpose
C     -------
C
C     Prepare to interpolate input field...
C
C
C     Interface
C     ---------
C
C     IRET = HNTFAP(INGRIB,INLEN)
C
C     Input
C     -----
C
C     INGRIB - Input field (packed).
C     INLEN  - Input field length (words).
C
C
C     Output
C     ------
C
C     Field unpacked values are in ZNFELDI, rotated if necessary.
C
C     Returns: 0, if OK. Otherwise, an error occured in interpolation.
C
C
C     Method
C     ------
C
C     Calls HNTFAPS to handle rotation when input and output fields
C     are both spectral.
C
C     Calls HNTFAPH in all other cases.
C
C
C     Externals
C     ---------
C
C     HNTFAPS - Handle rotation when input and output fields
C               are both spectral.
C     HNTFAPH - Handle rotation in all other cases.
C
C
C     Author
C     ------
C
C     J.D.Chambers     ECMWF     January 31, 2001
C
C
C----<
C
C     -----------------------------------------------------------------|
C*    Section 0.   Variables
C     -----------------------------------------------------------------|
C
      IMPLICIT NONE
C
#include "parim.h"
#include "nifld.common"
#include "nofld.common"
#include "grfixed.h"
#include "intf.h"
C
C     Parameters
C
      INTEGER JPROUTINE
      PARAMETER (JPROUTINE = 40100 )
C
C     Function arguments
C
      INTEGER INGRIB(*),INLEN
C
C     Local variables
C
      INTEGER IRET
C
C     Externals
C
      INTEGER  HNTFAPS, HNTFAPH
      EXTERNAL HNTFAPS, HNTFAPH
C
C     -----------------------------------------------------------------|
C*    Section 1.   Initialise
C     -----------------------------------------------------------------|
C
  100 CONTINUE
C
      HNTFAP = 0
C
C     -----------------------------------------------------------------|
C*    Section 2.   Split handling in case there are rotations to do.
C     -----------------------------------------------------------------|
C
  200 CONTINUE
C
C     Is the interpolation from SH to SH?
C
      IF( ((NIREPR.EQ.JPSPHERE).OR.(NIREPR.EQ.JPSPHROT)) .AND.
     X    ((NOREPR.EQ.JPSPHERE).OR.(NOREPR.EQ.JPSPHROT)) ) THEN
C
        IRET = HNTFAPS(INGRIB,INLEN)
C
      ELSE
C
        IRET = HNTFAPH(INGRIB,INLEN)
C
      ENDIF
C
      IF( IRET.NE.0 ) HNTFAP = JPROUTINE
C
C     -----------------------------------------------------------------|
C*    Section 9.   Closedown.
C     -----------------------------------------------------------------|
C
  900 CONTINUE
C
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      LOGICAL FUNCTION JFINDFN( DIRNAME, FILENAME, KLEN, KUNIT)
C
C---->
C**** JFINDFN
C
C     Purpose
C     _______
C
C     Completes the pathname given by a directory and filename, and
C     checks if the file exists.
C
C     Interface
C     _________
C
C     LFOUND = JFINDFN( DIRNAME, FILENAME, KLEN, KUNIT)
C
C     Input parameters
C     ________________
C
C     DIRNAME  - the directory name.
C     FILENAME - the file name.
C     KLEN     - number of characters in the name
C
C     Output parameters
C     _________________
C
C     The function returns .TRUE. if the file is opened; in which case:
C     FILENAME - the full pathname.
C     KLEN     - number of characters in the full pathname
C     KUNIT    - the opened file descriptor (from PBOPEN).
C
C     Otherwise it returns .FALSE. and FILENAME and KLEN are unchanged
C
C     Common block usage
C     __________________
C
C     None.
C
C     Externals
C     _________
C
C     PBOPEN  - opens a file.
C
C     Reference
C     _________
C
C     None.
C
C     Comments
C     ________
C
C     None.
C 
C     Author
C     ______
C
C     J.D.Chambers      *ECMWF*      Mar 1996
C
C----<
C     _______________________________________________________
C
      IMPLICIT NONE
C
C     Parameters
Cjdc  INTEGER JPROUTINE
Cjdc  PARAMETER ( JPROUTINE = 30800 )
C
C     Subroutine arguments
      CHARACTER*(*) DIRNAME, FILENAME
      INTEGER KLEN, KUNIT
C
C     Local variables
      INTEGER IBLANK, IRET
      CHARACTER*512 FULLPATH
      CHARACTER*256 SAVENAME
C

C     _______________________________________________________
C
C*    Section 1. Try the full path name..
C     _______________________________________________________
C
  100 CONTINUE
C
      JFINDFN = .TRUE.
      SAVENAME = FILENAME
C
      IBLANK = INDEX(DIRNAME, ' ') - 1
      FULLPATH  = DIRNAME(1:IBLANK) // '/' // FILENAME(1:KLEN)
      IBLANK = INDEX(FULLPATH, ' ') - 1
      FILENAME(1:IBLANK) = FULLPATH(1:IBLANK)
C
Cjdc  print*,'***',FILENAME(1:IBLANK),'***'
      CALL PBOPEN(KUNIT, FILENAME(1:IBLANK), 'r', IRET)
      IF( IRET.NE.0 ) THEN
        FILENAME = SAVENAME
        JFINDFN = .FALSE.
      ELSE
        KLEN = INDEX(FULLPATH, ' ') - 1
        FILENAME(1:KLEN) = FULLPATH(1:KLEN)
      ENDIF
C
C     _______________________________________________________
C
C*    Section 9. Return.
C     _______________________________________________________
C
  900 CONTINUE
C
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE CREXINIT(KBUFL,KERR)
C
C**** *CREXINIT*
C
C
C     PURPOSE.
C     --------
C         Initialize variables and constants. 
C         Read in Units conversion table
C
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *CREXINIT(KBUFL,KERR)*
C
C         INPUT:
C                 *KBUFL* - Size of CREX message in bytes
C
C         OUTPUT:
C                 *KERR*  - Return error code
C
C     METHOD.
C     -------
C
C          NONE.
C
C
C     EXTERNALS.
C     ----------
C
C          NONE.
C
C     REFERENCE.
C     ----------
C
C          NONE.
C
C     AUTHOR.
C     -------
C
C          MILAN DRAGOSAVAC    *ECMWF*       07/01/2004.
C
C
C     MODIFICATIONS.
C     --------------
C
C          NONE.
C
C
      IMPLICIT LOGICAL(L,O,G), CHARACTER*8(C,H,Y)
C

C
      PARAMETER(JSUP =   9,JSEC0=   3,JSEC1= 40,JSEC2= 64 ,JSEC3=    4,
     1          JSEC4=   2,JELEM=40000,JSUBS=400,JCVAL=150 ,JBUFL=40000,
     2          JBPW =  32,JTAB =3000,JCTAB=120,JCTST=1800,JCTEXT= 200,
     3          JWORK=360000,JKEY=46)
C
      COMMON /CREXWORK/ NBPT,NGS,NVIND,NBPTSEC2,RVIND,EPS,NE,IEOLD,
     1                  NC07YYY
C
      COMMON /CREXBEF / M,MM,N,JCV
C
C             M       -  Number of elements
C             MM      -  Number of elements
C             N       -  Number of data sub_sets
C             JCV     -  Number of character values
C
      COMMON /CREXWT/ NCREXDWINC,NCREXSCAM,NCREXAFDW,NCREXWT ,ODREPF,
     2               NCREXSTACK(JELEM),NCREXWTEN(JELEM),
     3               NCREXWTR (JELEM),NCREXWTS (JELEM),NCREXWTRV(JELEM),
     4               NCREXWTDW(JELEM),NWTIW(JELEM),NWTIWS(JELEM)
C
C             NCREXDWINC   -  data width increment
C             NCREXSCAM    -  scale multiplier
C             NCREXAFDW    -  augmented field data width
C             NCREXWT      -  pointer to working table
C             NCREXSTACK   -  list of data descriptors
C             ODREPF   -  replication (logical)
C             NCREXWTR     -  working table reference
C             NCREXWTS     -  working scale
C             NCREXWTRV    -  working reference value
C             NCREXWTDW    -  working data width
C             NWTIW    -  working data width of increments
C             NWTIWS   -  working total data width of element set
C
      COMMON /CREXUT/ YUNIT,CUNITNAME,CIA5,CIA2,NCODE,NRECORDS
C
C             NCODE  - array containing unit code number
C             CUNITNAME - array containing unit name
C             CIA5 - array  containing unit CCITTIA5 name
C             CIA2 - array  containing unit CCITTIA2 name
C             NRECORDS - number of entries in the list
C

      SAVE IFIRST
C
      DIMENSION NCODE(JCTEXT)
      CHARACTER*30 CUNITNAME(JCTEXT)
      CHARACTER*24 CIA5(JCTEXT)
      CHARACTER*24 CIA2(JCTEXT)
      CHARACTER*24 YUNIT
C
      LOGICAL OFIRST
      LOGICAL ODREPF
      REAL*8  RVIND
      REAL*8  EPS
      CHARACTER*256 CROOT
      CHARACTER*256 FILENAME
C
      INTEGER EMOSNUM
      EXTERNAL EMOSNUM
C
      FILENAME=' '
      CROOT=' '
      CALL GETENV('CREX_TABLES',CROOT)
      ILNG=INDEX(CROOT,' ')
      ILNG=ILNG-1
      IF(ILNG.EQ.1) THEN
C
C        SGI/HP/SUN CREX TABLES PATH
C
         CROOT='/home/ma/emos/tables/crex/'
C
C        ADD VERSION NUMBER
C
         ILNG=INDEX(CROOT,' ')
         IEMOSNM = EMOSNUM(1)
         WRITE(CROOT(ILNG:ILNG+5),'(I6.6)') IEMOSNM
         CROOT(ILNG+6:) = '/'
         ILNG=ILNG+6
      END IF

      NGS=KBUFL
      NE=0
      NVIND=2147483647
      RVIND=1.7D38
      EPS=1.0D-8
      M=0
      N=0
      NCREXWT=0
      ODREPF=.false.
      NCREXSCAM=0
      NCREXAFDW=0
      NCREXDWINC=0
      NC07YYY=0
      YUNIT=' '
      IFIRST=1
c
      IF(IFIRST.NE.2) THEN
C
C        Open/read table containing units associated with code numbers
C        to be used with C07YYY operator
C
         FILENAME=CROOT(1:ILNG)//'units.config.dat'
         I=INDEX(FILENAME,' ')
         I=I-1
C
         print*,'Units configuration file:'
         print*,FILENAME
         OPEN(UNIT=21,FILE=FILENAME(1:I),IOSTAT=IOS,STATUS="OLD")
         IF(IOS.NE.0) THEN
            print*,'Open error on units.config.dat'
            KERR=38
            RETURN
         END IF

         I=0
         DO I=1,JCTEXT
         READ(21,'(I3,1X,A30,A24,A24)',IOSTAT=IOS,END=100) NCODE(I),
     1                CUNITNAME(I),CIA5(I),CIA2(I)
         IF(IOS.NE.0) THEN
            WRITE(*,'(A)') 'Read error on units.config.dat'
            KERR=39
            RETURN
         END IF
C
C        WRITE(*,'(I3,1X,I3,1X,A30,A24,A24)') I, NCODE(I),
C    1                CUNITNAME(I),CIA5(I),CIA2(I)
         END DO
C
 100     CONTINUE
         NRECORDS=I-1
         IFIRST=2
         CLOSE(21)
      END IF
C
      RETURN
      END

C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

       PROGRAM SAMPLE1
C
      IMPLICIT NONE
      INTEGER IPROD
      INTEGER INTV
      REAL REALV
      CHARACTER*20 CHARV
      DIMENSION INTV(4), REALV(4), CHARV(4)
C
      INTEGER JPGRIB, JPBYTES
C
      PARAMETER (JPGRIB = 2000000)
C
C     JPBYTES is the size in bytes on an 'INTEGER'
C     Set JPBYTES = 8 on a 64-bit machine.
C
      PARAMETER (JPBYTES = 4)
C
      INTEGER INGRIB, NEWFLD
      DIMENSION INGRIB(JPGRIB), NEWFLD(JPGRIB)
C
      REAL ZNFELDI, ZNFELDO
      DIMENSION ZNFELDI(1), ZNFELDO(1)
C
      INTEGER IUNIT1, IUNIT2, IREC, INLEN, NEWLEN, IRET, NARGS
      INTEGER*4 J
C
C     Externals
      INTEGER INTOUT, INTF2, IARGC

      CHARACTER*128 INFILE, OUTFILE, CARG(4)
C
C **********************************************************************
C
C     Pick up file names from command line.
C
      NARGS = IARGC()
      IF( NARGS.LT.4 ) THEN
        print*,'Usage: interpolation_example -i inputfile -o outputfile'
        CALL EXIT(2)
      END IF

      DO 101 J=1,NARGS
      CALL GETARG(J,CARG(J))
 101  CONTINUE

      DO 102 J=1,NARGS,2
        IF(CARG(J).EQ.'-i') THEN
           INFILE=CARG(J+1)
        ELSEIF(CARG(J).EQ.'-o') THEN
           OUTFILE=CARG(J+1)
        ELSE
        print*,'Usage: interpolation_example -i inputfile -o outputfile'
        CALL EXIT(2)
        END IF
 102  CONTINUE

C     Define the packing accuracy for the new field(s).
C
      INTV(1) = 24
      IRET = INTOUT('accuracy', INTV, REALV, CHARV)
      IF ( IRET.NE.0 ) THEN
        WRITE(*,*) ' First INTOUT failed.'
        CALL EXIT(2)
      ENDIF
C
C     Define the geographical area for the new field(s).
C
      REALV(1) =  60.0
      REALV(2) = -10.0
      REALV(3) =  40.0
      REALV(4) =  15.0
      IRET = INTOUT('area', INTV, REALV, CHARV)
      IF ( IRET.NE.0 ) THEN
        WRITE(*,*) ' Second INTOUT failed.'
        CALL EXIT(2)
      ENDIF
C
C     Define the grid interval for the new field(s).
C
      REALV(1) = 1.5
      REALV(2) = 1.5
      IRET = INTOUT('grid', INTV, REALV, CHARV)
      IF ( IRET.NE.0 ) THEN
        WRITE(*,*) ' Third INTOUT failed.'
        CALL EXIT(2)
      ENDIF
C
C     Open input and output files.
C
      CALL PBOPEN(IUNIT1, INFILE, 'r', IRET)
      IF ( IRET.NE.0 ) THEN
        WRITE(*,*) ' PBOPEN failed'
        CALL EXIT(2)
      END IF
      CALL PBOPEN(IUNIT2, OUTFILE, 'w', IRET)
      IF ( IRET.NE.0 ) THEN
        WRITE(*,*) ' PBOPEN failed'
        CALL EXIT(2)
      END IF
      IPROD = 0
C
C     Start of loop through input GRIB-coded fields
C
 200  CONTINUE
        IPROD = IPROD + 1
C
C       Read next product.
C
        CALL PBGRIB(IUNIT1, INGRIB, JPGRIB*JPBYTES, IREC, IRET)
        IF ( IRET.EQ.-1 ) GOTO 900
        IF ( IRET.NE.0 ) THEN
            WRITE(*,*) ' PBGRIB failed'
            CALL EXIT(2)
         END IF
C
C       Interpolate.
C
        WRITE(*,*) ' Interpolate product number ', IPROD
        NEWLEN = JPGRIB
        INLEN  = IREC
        IRET = INTF2(INGRIB,INLEN,NEWFLD,NEWLEN)
        IF ( IRET.NE.0 ) THEN
          WRITE(*,*) ' INTF2 failed.'
          CALL EXIT(2)
        ENDIF
C
C       Write the new product to file.
C
       CALL PBWRITE( IUNIT2, NEWFLD, NEWLEN*JPBYTES, IRET)
        IF ( IRET.LT.(NEWLEN*JPBYTES) ) THEN
            WRITE(*,*) ' PBWRITE failed'
            CALL EXIT(2)
        END IF
C
C       Loop back for next product.
C
      GOTO 200
C
C     Closedown.
C
 900  CONTINUE
C
      IPROD = IPROD - 1
      WRITE(*,*) ' All done after ', IPROD, ' products.'
C
C     Close input and output files.
C 
      CALL PBCLOSE(IUNIT1, IRET)
      CALL PBCLOSE(IUNIT2, IRET)
C
      STOP
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE BUENS3(KSEC3,KTDLEN,KTDLST,KBUFL,KBUFF,KERR)
C
C**** *BUENS3*
C
C
C     PURPOSE.
C     --------
C
C          PACK SECTION 3 OF BUFR MESSAGE.
C
C
C**   INTERFACE.
C     ----------
C
C          *CALL* *BUENS3( KSEC3,KTDLEN,KTDLST,KBUFL,KBUFF,KERR)*
C
C        INPUT :
C               *KSEC3*   -  ARRAY CONTAINING SECTION 3 INFORMATION
C                            KSEC3( 1)-- LENGTH OF SECTION 3 (BYTES)
C                            KSEC3( 2)-- RESERVED
C                            KSEC3( 3)-- NUMBER OF SUBSETS
C                            KSEC3( 4)-- FLAG (DATA TYPE,DATA COMPRESSION)
C               *KTDLEN*  -  NUMBER OF DATA DESCRIPTORS IN SECTION 3
C               *KTDLST*  -  ARRAY CONTAINING DATA DESCRIPTORS IN SECTION 3
C
C        OUTPUT :
C               *KBUFL*   -  LENGTH OF BUFR MESSAGE (WORDS)
C               *KBUFF*   -  ARRAY CONTAINING BUFR MESSAGE
C               *KERR*    -  RETURNED ERROR CODE
C
C     METHOD.
C      -------
C
C
C
C
C     EXTERNALS.
C     ----------
C
C          BUPCK        - PACKS BIT PATHERN
C          BUOCTN       - SET LENGTH OF SECTION
C
C     REFERENCE.
C     ----------
C
C          NONE.
C
C     AUTHOR.
C     -------
C
C          M. DRAGOSAVAC    *ECMWF*       01/02/91.
C
C
C     MODIFICATIONS.
C     --------------
C
C          NONE.
C
C
      IMPLICIT LOGICAL(L,O,G), CHARACTER*8(C,H,Y)
C
C
#     include "parameter.F"
#     include "bcomunit.F"
#     include "bcmwork.F"
C
      DIMENSION KBUFF(KBUFL)
      DIMENSION KTDLST(KTDLEN)
C
      DIMENSION KSEC3(JSEC3)
C
#ifndef R_4
      REAL*8 RVIND
      REAL*8 EPS
#else
      REAL   RVIND
      REAL   EPS
#endif
C     ------------------------------------------------------------------
C*          1.   PACK PRELIMINARY ITEMS OF SECTION 3.
C                --------------------------------------
 100  CONTINUE
C
      IF( KERR.NE.0 ) RETURN
C
C*          1.1  KEEP POINTERS TO THE BEGINING OF THE SECTION.
C                ---------------------------------------------
 110  CONTINUE
C
      IWPTB = NWPT
      IBPTB = NBPT
C
C
C*          1.2   PACK LENGTH OF SECTION 3.
C                 -------------------------
 120  CONTINUE
C
      CALL BUPCK(NBPW,KBUFF(NWPT),0,NWPT,NBPT,24,KERR)
      IF(KERR.GT.0) THEN
         WRITE(KNTN,*) 'ERROR PACKING LENGTH OF SECTION 3.'
         RETURN
      END IF
C
C
C*          1.3    PACK ZERO BYTE AND PUT IT IN KSEC3(2).
C                  --------------------------------------
 130  CONTINUE
C
      CALL BUPCK(NBPW,KBUFF(NWPT),0,NWPT,NBPT,8,KERR)
      IF(KERR.GT.0) THEN
         WRITE(KNTN,*) 'ERROR PACKING RESERVED BYTE IN SECTION 3.'
         RETURN
      END IF
C
C*          1.4    PACK NUMBER OF DATA SUB-SETS.
C                  -----------------------------
 140  CONTINUE
C
      IF(KSEC3(3).GT.65535) THEN
         KERR=27
         CALL BUERR(KERR)
         RETURN
      END IF
C
      CALL BUPCK(NBPW,KBUFF(NWPT),KSEC3(3),NWPT,NBPT,16,KERR)
      IF(KERR.GT.0) THEN
         WRITE(KNTN,*) 'ERROR PACKING KSEC3(3) IN SECTION 3.'
         RETURN
      END IF
C
C
C*          1.5    PACK INTEGER VALUE OF THE OCTET
C                  ---------------------------------
C                  CONTAINIG FLAG BITS.
C                  --------------------
 150  CONTINUE
C
      IF(KSEC3(3).LE.1) THEN
         KSEC3(4)=IBCLR(KSEC3(4),6)
      END IF
      CALL BUPCK(NBPW,KBUFF(NWPT),KSEC3(4),NWPT,NBPT,8,KERR)
      IF(KERR.GT.0) THEN
         WRITE(KNTN,*) 'ERROR PACKING KSEC3(4) IN SECTION 3.'
         RETURN
      END IF
C
C     -----------------------------------------------------------------
C*          1.6  PACK DATA DESCRIPTORS.
C                ----------------------
 160  CONTINUE
C
C
      DO 161 I=1,KTDLEN
      IFIXIY=KTDLST(I)
C
      II=IFIXIY/1000
      IY=IFIXIY-II*1000
      IF=II/100
      IX=II-IF*100
C
      CALL BUPCK(NBPW,KBUFF(NWPT),IF,NWPT,NBPT,2,KERR)
      IF(KERR.GT.0) THEN
         WRITE(KNTN,*) 'ERROR PACKING ',I,' DESCRIPTOR IN SECTION 3.'
         RETURN
      END IF
      CALL BUPCK(NBPW,KBUFF(NWPT),IX,NWPT,NBPT,6,KERR)
      IF(KERR.GT.0) THEN
         WRITE(KNTN,*) 'ERROR PACKING ',I,' DESCRIPTOR IN SECTION 3.'
         RETURN
      END IF
      CALL BUPCK(NBPW,KBUFF(NWPT),IY,NWPT,NBPT,8,KERR)
      IF(KERR.GT.0) THEN
         WRITE(KNTN,*) 'ERROR PACKING ',I,' DESCRIPTOR IN SECTION 3.'
         RETURN
      END IF
C
C
 161  CONTINUE
C
C*          1.7  SET UP LENGTH OF THE SECTION 1.
C               --------------------------------
 170  CONTINUE
C
      CALL BUOCTN(IWPTB,IBPTB,KBUFL,KBUFF,KERR)
      IF(KERR.GT.0) RETURN
C
C
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities
C granted to it by virtue of its status as an intergovernmental organisation
C nor does it submit to any jurisdiction.
C

      INTEGER FUNCTION PDDEFS()
C
C---->
C**   PDDEFS
C
C     Purpose
C     -------
C
C     Adjust the interpolation parameters according to parameter
C     dependent requirements.
C
C     Interface
C     ---------
C
C     IRET = PDDEFS()
C
C     Input
C     -----
C
C     Input file format:
C
C       Param  lsm  wind  prec  lsm interp          ) First 2 lines
C       -----  ---  ----  ----  ----------          ) are ignored
C       131     n     y     n     n            )
C       132     n     y     n     n            )
C       140     y     n     n     n            )
C       141     y     n     n     n            )    I3,4(5X,A1)
C       142     n     n     y     n            )
C       143     n     n     y     n            )
C       144     n     n     y     n            )
C       165     n     y     n     n            )
C        :
C        :
C
C     Output
C     ------
C
C     IRET = 0 if OK.
C
C
C     Method
C     ------
C
C     Values are taken from a (text) file in a directory defined
C     by the environment variable:
C
C        "PARAMETER_PROCESSING_DEFAULTS" (if defined),
C
C     or from the directory:
C
C        /owrk/marsint/new                      (CRAY)
C        /mrfs/postproc                         (Fujitsu)
C        /usr/local/lib/metaps/tables/interpol
C        /usr/local/apps/libemos/tables/        (since version 000394)
C
C     or from an internal default array.
C
C     The file used has name defaults_for_table_nnn, where
C     nnn is the 3-digit local code table number (eg 128 for
C     ECMWF, 001 for WMO, etc ).
C
C
C     Externals
C     ---------
C
C     INTLOG  - Logs messages.
C     GETENV  - Gets environment variable information.
C     INDEX   - Locates a character in a character variable.
C     PRECIP  - Says if field is to have 'precipitation' treatment
C
C
C     Author
C     ------
C
C     J.D.Chambers       ECMWF        August 1994.
C
C----<
C
      IMPLICIT NONE
C
C     Parameters
C
      INTEGER JPROUTINE, JPNUMDF, JPND001, JPND128, JPND129
      PARAMETER (JPROUTINE = 28000)
      PARAMETER (JPNUMDF = 100)
      PARAMETER (JPND001 =   9)
      PARAMETER (JPND128 =  13)
      PARAMETER (JPND129 =  12)
C
#include "parim.h"
#include "nifld.common"
C
C     Local variables
C
      CHARACTER*256 FILENAME
      CHARACTER*256 HLINE
      INTEGER IPARAM, INEXT, NUMDFS, LOOP, INDX, IOTABLE
      CHARACTER*1 HLSM, HWIND, HPREC, HLSMI
      LOGICAL LNLSM, LNWIND, LNPREC, LNSMPAR
      DATA IOTABLE/0/
C
C     Default array
C
      CHARACTER*27 HDEFS(JPNUMDF)
C
C     External functions
C
      INTEGER DPATH_TABLES_INTERPOL
      EXTERNAL DPATH_TABLES_INTERPOL
C
C     Specified defaults
C
C     WMO table 1
C
      CHARACTER*27 TAB001(JPND001)
      DATA TAB001/
     X          '002     n     n     n     n',
     X          '033     y     y     n     n',
     X          '034     y     y     n     n',
     X          '061     y     n     y     n',
     X          '062     y     n     y     n',
     X          '063     y     n     y     n',
     X          '064     y     n     y     n',
     X          '065     y     n     y     n',
     X          '081     n     n     n     y'
     X         /
C
C     ECMWF table 128
C
      CHARACTER*27 TAB128(JPND128)
      DATA TAB128/
     X          '131     y     y     n     n',
     X          '132     y     y     n     n',
     X          '142     y     n     y     n',
     X          '143     y     n     y     n',
     X          '144     y     n     y     n',
     X          '151     n     n     n     n',
     X          '165     y     y     n     n',
     X          '166     y     y     n     n',
     X          '169     y     n     n     n',
     X          '172     n     n     n     y',
     X          '228     y     n     y     n',
     X          '239     y     n     y     n',
     X          '240     y     n     y     n'
     X         /
C
C     ECMWF table 129
C
      CHARACTER*27 TAB129(JPND129)
      DATA TAB129/
     X          '131     y     y     n     n',
     X          '132     y     y     n     n',
     X          '142     y     n     y     n',
     X          '143     y     n     y     n',
     X          '144     y     n     y     n',
     X          '151     n     n     n     n',
     X          '165     y     y     n     n',
     X          '166     y     y     n     n',
     X          '172     n     n     n     y',
     X          '228     y     n     y     n',
     X          '239     y     n     y     n',
     X          '240     y     n     y     n'
     X         /
C
      SAVE HDEFS, NUMDFS, IOTABLE, FILENAME
C
C     External functions
C
      LOGICAL PRECIP
      EXTERNAL PRECIP
C
C     Statement function
C
      LOGICAL NOTSAME, A, B
C
C     XOR or NE for logicals
C
      NOTSAME(A,B) = ((A).AND.(.NOT.(B))).OR.((B).AND.(.NOT.(A)))
C
C     ------------------------------------------------------------------
C*    Section 1.   Initialise
C     ------------------------------------------------------------------
C
 100  CONTINUE
C
      PDDEFS = 0
C
C     Start with the generic settings.
C
      LNLSM   = .TRUE.
      LNWIND  = .FALSE.
      LNPREC  = .FALSE.
      LNSMPAR = .FALSE.
C
C     ------------------------------------------------------------------
C*    Section 2.   If parameter table has changed, treat as first time
C                  through: open and read the file of default values.
C     ------------------------------------------------------------------
C
 200  CONTINUE
C
      IF( IOTABLE.NE.NITABLE ) THEN
C
        FILENAME(:) = ' '
C
        CALL INTLOG(JP_DEBUG,
     X   'PDDEFS: Try to get processing defaults file.',JPQUIET)
C
C       Get the directory name
C
        CALL GETENV( 'PARAMETER_PROCESSING_DEFAULTS', FILENAME)
        IF( FILENAME(1:1).EQ.' ' ) THEN
          INDX = DPATH_TABLES_INTERPOL(FILENAME)
          IF( INDX.EQ.0 ) THEN
            CALL INTLOG(JP_ERROR,
     X        'PDDEFS: unable to build LSM directory path.',JPQUIET)
            PDDEFS = JPROUTINE + 2
            GOTO 900
          ENDIF
        ENDIF
C
C       Build the complete file pathname
C
        INDX = INDEX(FILENAME, ' ')
        FILENAME(INDX:) = 'defaults_for_table_'
        INDX = INDEX(FILENAME, ' ')
        WRITE(FILENAME(INDX:),'(I3.3)') NITABLE
        INDX = INDX + 2
        CALL INTLOG(JP_DEBUG, FILENAME(1:INDX), JPQUIET)
        IOTABLE = NITABLE
C
        OPEN( UNIT = 1,
     X        FILE = FILENAME(1:INDX),
     X        STATUS = 'OLD',
     X        FORM = 'FORMATTED',
     X        ERR = 300)
C
C       Skip first 2 lines in the file
C
        READ(1,'(A)', END = 900) HLINE
        READ(1,'(A)', END = 900) HLINE
C
C       Read the file into the defaults array
C
        NUMDFS = 1
        DO LOOP = 1, JPNUMDF
          READ(1,'(A)', END = 220) HDEFS(NUMDFS)
          NUMDFS = NUMDFS + 1
        ENDDO
C
  220   CONTINUE
C
C       Close the file.
C
        NUMDFS = NUMDFS - 1
        CLOSE(1, ERR = 920)
C
        GOTO 400
C
C     ------------------------------------------------------------------
C*    Section 3.   If file problem, use default arrays.
C     ------------------------------------------------------------------
C
 300    CONTINUE
C
        CALL INTLOG(JP_DEBUG,
     X   'PDDEFS: No parameter processing defaults file found.',JPQUIET)
C
C       Use appropriate table
C           1 = WMO table 1
C         128 = ECMWF local code table 128
C         129 = ECMWF local code table 129
C
        IF( NITABLE.EQ.1 ) THEN
C
          DO LOOP = 1, JPND001
            HDEFS(LOOP) = TAB001(LOOP)
          ENDDO
          NUMDFS = JPND001
C
        ELSE IF( NITABLE.EQ.128 ) THEN
C
          DO LOOP = 1, JPND128
            HDEFS(LOOP) = TAB128(LOOP)
          ENDDO
          NUMDFS = JPND128
C
C
        ELSE IF( NITABLE.EQ.129 ) THEN
C
          DO LOOP = 1, JPND129
            HDEFS(LOOP) = TAB129(LOOP)
          ENDDO
          NUMDFS = JPND129
C
        ELSE
C
C         .. other (unspecified)
C
          NUMDFS = 0
C
        ENDIF
C
      ENDIF
C
C     ------------------------------------------------------------------
C*    Section 4.   Read lines in file to see if current parameter
C                  is mentioned.
C     ------------------------------------------------------------------
C
  400 CONTINUE
C
      CALL INTLOG(JP_DEBUG,'PDDEFS: Table number = ', NITABLE)
      CALL INTLOG(JP_DEBUG,'PDDEFS: Number of definitions = ', NUMDFS)
      CALL INTLOG(JP_DEBUG,'PDDEFS: Parameter number = ', NIPARAM)
      INEXT = 0
C
  410 CONTINUE
C
      INEXT = INEXT + 1
      IF( INEXT.GT.NUMDFS ) GOTO 900
      READ(HDEFS(INEXT), 9000) IPARAM, HLSM, HWIND, HPREC, HLSMI
C
C     If the current parameter, use the values defined in the table.
C
      IF( IPARAM.EQ.NIPARAM ) THEN
C
        IF( HLSM .EQ.'n' ) LNLSM   = .FALSE.
        IF( HWIND.EQ.'y' ) LNWIND  = .TRUE.
        IF( HPREC.EQ.'y' ) LNPREC  = .TRUE.
        IF( HLSMI.EQ.'y' ) LNSMPAR = .TRUE.
        GOTO 900
C
      ENDIF
C
C     Go back for next line in the array
C
      GOTO 410
C
C     ------------------------------------------------------------------
C*     Section 9.   Closedown.
C     ------------------------------------------------------------------
C
 900  CONTINUE
C
C     Only change the value if the user has not already set it.
C
      IF( .NOT. LSMSET ) THEN
        IF( NOTSAME(LNLSM,LSM) ) THEN
          LCHANGE = .TRUE.
          LSMCHNG = .TRUE.
          LSM = LNLSM
        ENDIF
      ENDIF
C
      IF( .NOT. LWINDSET ) THEN
        IF( NOTSAME(LNWIND,LWIND) ) LCHANGE = .TRUE.
        LWIND = LNWIND
      ENDIF
C
      IF( .NOT. LPRECSET ) THEN
        IF( NOTSAME(LNPREC,LPREC) ) LCHANGE = .TRUE.
        LPREC = LNPREC
      ENDIF
C
      IF( .NOT. LSMPARSET ) THEN
        IF( NOTSAME(LNSMPAR,LSMPAR) ) LCHANGE = .TRUE.
        LSMPAR = LNSMPAR
      ENDIF
C
      LPREC = PRECIP()
C
      RETURN
C
 920  CONTINUE
C
      PDDEFS = JPROUTINE + 1
      CALL INTLOG(JP_ERROR,'PDDEFS: Error closing file:',JPQUIET)
      CALL INTLOG(JP_ERROR,FILENAME,JPQUIET)
      RETURN
C
9000  FORMAT( I3,4(5X,A1))
9001  FORMAT( 1X,I3,4(5X,A1))
C
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE STRLAT( OLDLAT, STRETCH, KFLAG, NEWLAT, MFACTOR)
C
C---->
C**** STRLAT
C
C     PURPOSE
C     _______
C
C     This routine transforms between stretched and real latitudes
C     and calculates the map factor.
C
C     INTERFACE
C     _________
C
C     CALL STRLAT( OLDLAT, STRETCH, KFLAG, NEWLAT, MFACTOR)
C
C     Input parameters
C     ________________
C
C     OLDLAT  - Input latitude
C     STRETCH - Stretching factor
C     KFLAG   - Flag to show direction of transform (real <-> stretched)
C               0 = transform from real latitudes to stretched latitudes
C               1 = transform from stretched latitudes to real latitudes
C
C     Output parameters
C     ________________
C
C     NEWLAT  - Input latitude
C     MFACTOR - Map factor
C
C
C     Common block usage
C     __________________
C
C     None
C
C     Method
C     ______
C
C     Stretching factor S
C
C     Map factor,  m = S**2 + 1 + (S**2 -1)*mu
C                      -----------------------
C                              2*S
C
C     where mu = sin(lat) on the real sphere
C
C     mu = (S**2+1)*md + (S**2-1)
C          ----------------------
C          (S**2+1) + (S**2-1)*md
C
C     where md = sin(lat) on the stretched sphere.
C
C     By rearrangement:
C
C     md = (S**2+1)*mu - (S**2-1)
C          ----------------------
C          (S**2+1) - (S**2-1)*mu
C
C     Wind U and V components are transformed as
C
C       vreal = m * vtransformed
C
C     Vorticity and divergence fields are transformed as
C
C       vreal = (m*m) * vtransformed
C
C
C     Externals
C     _________
C
C     None
C
C
C     Reference
C     _________
C
C     None
C
C
C     Comments
C     ________
C
C     None.
C
C
C     AUTHOR
C     ______
C
C     J.D.Chambers      ECMWF    July 1999
C
C
C     MODIFICATIONS
C     _____________
C
C     None
C
C----<
C     _______________________________________________________
C
C
      IMPLICIT NONE
C
C     Subroutine arguments
C
      REAL OLDLAT, STRETCH, NEWLAT, MFACTOR
      INTEGER KFLAG
C
C     Parameters
C
      INTEGER JPRL2TR
      PARAMETER (JPRL2TR = 0)
      REAL PPI, DEG2RAD, RAD2DEG
      PARAMETER ( PPI = 3.14159265358979 )
      PARAMETER (DEG2RAD = PPI / 180.0)
      PARAMETER (RAD2DEG = 180.0 / PPI)
C
C     Local variables
C
      REAL A, B, ANGLE, MU, MUPRIME
C     _______________________________________________________
C
C*    Section 1.    Initialization.
C     _______________________________________________________
C
  100 CONTINUE
C
      A     = STRETCH * STRETCH + 1
      B     = A - 2
      ANGLE = OLDLAT * DEG2RAD
C
C     _______________________________________________________
C
C*    Section 2.    Work out geometry
C     _______________________________________________________
C
 200  CONTINUE
C
C     Transform from real latitudes to stretched latitudes
C
      IF( KFLAG.EQ.JPRL2TR ) THEN
        MUPRIME = SIN(ANGLE)
        MU      = (A*MUPRIME + B) / (A + B*MUPRIME)
        NEWLAT  = ASIN(MU) * RAD2DEG
C
C     Transform from stretched latitudes to real latitudes
C
      ELSE
        MU      = SIN(ANGLE)
        MUPRIME = (A*MU - B) / (A - B*MU)
        NEWLAT  = ASIN(MUPRIME) * RAD2DEG
      ENDIF
C
C     Calculate the map factor
C
      MFACTOR = (A + B*MU) / (2*STRETCH)
C
C     _______________________________________________________
C
C*    Section 9. Return to calling routine.
C     _______________________________________________________
C
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE INSMP1(KGRIB,KLENG,KMAP1,KSECM,PSEC4,KSIZE,KBITS,
     X                  PMISS,HFUNC,KNUM,KPR,KRET)
C
C---->
C**** INSMP1 - Insertion of primary bit map for routine GRIBEX.
C
C     Purpose.
C     --------
C
C     Generates a primary bit-map (Section 3 bit-map) and
C     inserts in array of GRIB coded data.
C
C**   Interface.
C     ----------
C
C     CALL INSMP1(KGRIB,KLENG,KMAP1,KSECM,PSEC4,KSIZE,KBITS,
C    X            PMISS,HFUNC,KNUM,KPR,KRET)
C
C     Input Parameters.
C     -----------------
C
C     KGRIB      - Array into which data is being packed in GRIB code.
C
C     KLENG      - Length of this array.
C
C     KMAP1      - Bit-pointer to start of primary bit-map
C                  (Section 3 bitmap) in array KGRIB.
C
C     KSECM      - Indicator of use of secondary bitmap
C                  (Section 4 bitmap) in array KGRIB.
C                  0 , No secondary bit-map.
C                  32, Secondary bit-map to be added later.
C
C     PSEC4      - Array of data values to be packed in
C                  GRIB code, containing missing data
C                  indicator PMISS where appropriate.
C
C     KSIZE      - Number of values, including missing data
C                  values, in array PSEC4.
C
C     KBITS      - Number of bits in computer word.
C
C     PMISS      - Value indicating missing data in array PSEC4.
C
C     HFUNC      - 'C' , GRIB data being packed normally.
C                  'M' , GRIB data being packed in fixed length messages
C
C     KNUM       - Number of values at each grid point.
C
C     KPR        - Debug print switch.
C                  0  , No printout.
C                  >0 , Debug printout.
C
C     Output Parameters.
C     ------------------
C
C     PSEC4      - Array of data values to be packed in
C                  GRIB code. Changes to contents depend
C                  on function performed eg
C
C                  Rn = Real data value at point n.
C                  M  = Missing data indicator.
C                  On input PSEC4 is R1 R2 M M  M R6
C
C                  Output with function 'C', single value per point:
C                    Bit-map is 1  1  0  0  0  1
C                    PSEC4 is   R1 R2 R6 M  M  M
C                                      ^
C                                      |
C                                    KSIZE
C
C                  Output with function 'C' , matrix (2x1) of values
C                  per point:
C                    Bit-map is 1  0  1
C                    PSEC4 is   R1 R2 M  R6 M  M  M
C                                         ^
C                                         |
C                                       KSIZE
C
C                  Output with function 'M' with no secondary bit-maps,
C                  single value:
C                    Bit-map is 1  1  0  0  0  1
C                    PSEC4 is   R1 R2 R6 R1 R1 R1
C                                              ^
C                                              |
C                                            KSIZE
C
C                  Output with function 'M' with secondary bit-maps,
C                  (2x1 matrix)
C                    Bit-map is 1  1  1
C                    PSEC4 is   R1 R2 M  M  M  R6
C                                              ^
C                                              |
C                                            KSIZE
C
C     KSIZE      - The number of data values remaining in
C                  array PSEC4 to be packed.
C
C     KRET       - Return code.
C                  0 , No error encountered.
C                  1 , Error in routine INXBIT.
C
C     Method.
C     -------
C
C     The bit-map contains 1 where valid data exists and 0
C     where data is missing. The corresponding data array
C     contains valid data and the missing data indicator value.
C
C     Externals.
C     ----------
C
C     INXBIT
C
C     Reference.
C     ----------
C
C     See routine GRIBEX.
C
C     Comments.
C     ---------
C
C     None.
C
C     Author.
C     -------
C
C     J. Hennessy      ECMWF      09:07:92
C
C     Modifications.
C     --------------
C
C     J. Hennessy      ECMWF      19:10:92
C     Maximum sizes increased to allow for packing of 2D spectra.
C     Number of data values 120*61*12*25
C
C     J.D.Chambers     ECMWF      09:03:94
C     Maximum size for bitmap array increased to 132000
C     to allow for products 0.5 * 0.5 degrees, whole
C     hemisphere (N or S).
C
C     J.D.Chambers     ECMWF      13:07:94
C     Maximum size for bitmap array increased to 140000
C     to allow for N160 products whole globe
C
C     J.D.Chambers     ECMWF      24:05:95
C     Handle bitmap in strips to avoid problem with very large products
C
C     J. Clochard, Meteo France, for ECMWF - January 1998.
C     Strips size (JPWORK) enlarged to 10000.
C
C----<
C     ------------------------------------------------------------------
C*    Section 0 . Definition of variables. Data statements.
C     ------------------------------------------------------------------
C
      IMPLICIT NONE
C
#include "common/grprs.h"
C
C     Parameters
C
      INTEGER JPWORK
      PARAMETER (JPWORK=10000)
C
C     Subroutine arguents
C
      INTEGER KGRIB, KLENG, KMAP1, KSECM, KSIZE, KBITS, KNUM, KPR, KRET
      DIMENSION KGRIB(*)
      REAL PSEC4, PMISS
      DIMENSION PSEC4(*)
      CHARACTER*(*) HFUNC
C
C     Local variables
C
      INTEGER IMAP1, IMISS, NEXTIN, NXTOUT, INOBT, IPT
      DIMENSION IMAP1(JPWORK)
      INTEGER JLOOP, JLOOPI, NEXT, IMANY
      REAL VALUE
C
C     ------------------------------------------------------------------
C*    Section 1 . Set initial values.
C     ------------------------------------------------------------------
C
  100 CONTINUE
C
      IF (KPR.GE.1) THEN
        WRITE(GRPRSM,*) 'INSMP1: Section 1.'
        WRITE(GRPRSM,*) '         Input values used -'
        WRITE(GRPRSM,*) ' KLENG  = ', KLENG
        WRITE(GRPRSM,*) ' KMAP1  = ', KMAP1
        WRITE(GRPRSM,*) ' KSECM  = ', KSECM
        WRITE(GRPRSM,*) ' KSIZE  = ', KSIZE
        WRITE(GRPRSM,*) ' KBITS  = ', KBITS
        WRITE(GRPRSM,*) ' PMISS  = ', PMISS
        WRITE(GRPRSM,*) ' HFUNC  = ', HFUNC
        WRITE(GRPRSM,*) ' KNUM   = ', KNUM 
      ENDIF
C
C     Reset return code to 0.
C
      KRET = 0
C
C     Check function requested.
C
      IF( (HFUNC.NE.'C') .AND. (HFUNC.NE.'M') ) THEN
        WRITE(GRPRSM,*) 'INSMP1: Invalid function requested - ', HFUNC
        KRET = 3
        GO TO 900
      ENDIF
C
C*    Set number of bits in bitmap.
C
      INOBT = KSIZE / KNUM
C
C     ------------------------------------------------------------------
C*    Section 2 . Handle fixed length records with secondary bit-maps.
C    -------------------------------------------------------------------
C
  200 CONTINUE
C
C     If fixed length records with secondary bit-maps are required,
C     insert a primary bit-map of all 1 bits and finish.
C
      IF( (HFUNC.EQ.'M') .AND. (KSECM.EQ.32) ) THEN
C
        IF( KPR.GE.1 ) WRITE(GRPRSM,*) 'INSMP1: Section 2.'
C
        DO 210 JLOOP = 1,JPWORK
          IMAP1(JLOOP)   = 1
  210   CONTINUE
C
        NEXT = 0
C
  215   CONTINUE
C
C       Pack the primary bitmap in strips of JPWORK values
C
        NEXT  = NEXT + JPWORK
        IMANY = JPWORK
C
C       Check whether end of primary bitmap reached.
C       Adjust if less than JPWORK values left to process
C
        IF( NEXT.GT.INOBT ) IMANY = INOBT + JPWORK - NEXT
C
C       Pack next strip of primary bitmap values.
C
        CALL INXBIT(KGRIB,KLENG,KMAP1,IMAP1,IMANY,KBITS,1,'C',KRET)
        IF( KRET.NE.0 ) THEN
          WRITE(GRPRSM,9003)
          KRET = 1
          GO TO 900
        ENDIF
C
C       Loop back if more strips of primary bitmap to process
C
        IF( NEXT.LT.INOBT ) GOTO 215
C
        GO TO 900
      ENDIF
C
C     ------------------------------------------------------------------
C*    Section 3 . Generate the primary bitmap.
C    -------------------------------------------------------------------
C
  300 CONTINUE
C
      IF( KPR.GE.1 ) WRITE(GRPRSM,*) 'INSMP1: Section 3.'
C
      NEXTIN = 0
      NXTOUT = 0
C
      NEXT = 0
C
C     Pack the primary bitmap in strips of JPWORK values
C
  305 CONTINUE
C
      NEXT  = NEXT + JPWORK
      IMANY = JPWORK
C
C     Check whether the end of primary bitmap has been reached.
C     Adjust if less than JPWORK values left to process.
C
      IF( NEXT.GT.INOBT ) IMANY = INOBT + JPWORK - NEXT
C
      IF (KPR.GE.1) THEN
          WRITE(GRPRSM,*) 'INSMP1: NEXT = ', NEXT
          WRITE(GRPRSM,*) 'INSMP1: IMANY = ', IMANY
          WRITE(GRPRSM,*) 'INSMP1: INOBT = ', INOBT
      ENDIF
C
C*    Reset bit-map to all 0 bits.
C
      DO 310 JLOOP = 1, IMANY
        IMAP1(JLOOP) = 0
  310 CONTINUE
C
C     Set a bit to 1 for every KNUM values which contain at
C     least 1 real data value.
C
      IPT = 0
C
      IF( KNUM.EQ.1 ) THEN
!OCL NOVREC
        DO 320 JLOOP = 1, IMANY
          IF (PSEC4(NEXTIN+JLOOP).NE.PMISS) THEN
            IMAP1(IPT+JLOOP) = 1
            NXTOUT           = NXTOUT + 1
            PSEC4(NXTOUT)    = PSEC4(NEXTIN+JLOOP)
          ENDIF
  320   CONTINUE
C
        IPT    = IPT + IMANY
        NEXTIN = NEXTIN + IMANY
C
      ELSE
C
        DO 350 JLOOP = 1, IMANY
C
          IMISS = 0
          DO 330 JLOOPI = 1, KNUM
            IF (PSEC4(NEXTIN+JLOOPI).EQ.PMISS) IMISS = IMISS + 1
  330     CONTINUE
C
C         If point not completely missing, move data forwards in data 
C         array. If no real data value found, the corresponding bit is
C         already 0.
C
          IF( IMISS.NE.KNUM ) THEN
            IMAP1(IPT+JLOOP) = 1
            DO 340 JLOOPI = 1, KNUM
              PSEC4(NXTOUT+JLOOPI) = PSEC4(NEXTIN+JLOOPI)
  340       CONTINUE
            NXTOUT = NXTOUT + KNUM
          ENDIF
C
          NEXTIN = NEXTIN + KNUM
C
  350   CONTINUE
        IPT = IPT + IMANY
C
      ENDIF
C
C     Pack next strip of primary bitmap values in GRIB coded data.
C
      CALL INXBIT(KGRIB,KLENG,KMAP1,IMAP1,IMANY,KBITS,1,'C',KRET)
      IF( KRET.NE.0 ) THEN
        WRITE(GRPRSM,9003)
        KRET = 1
        GO TO 900
      ENDIF
C
C     Loop back if more strips of primary bitmap to process
C
      IF( NEXT.LT.INOBT ) GOTO 305
C
C     Is a fixed length message required, even though a bit map is used?
C
      IF( HFUNC.EQ.'M' ) THEN
C
C       The otherwise unused part of the array is set to a genuine data
C       value so that extraction of minimum and maximum values remain
C       correct. Number of data values includes these padding values.
C
        VALUE = PSEC4(1)
        DO 360 JLOOP = NXTOUT+1, KSIZE
          PSEC4(JLOOP) = VALUE
  360   CONTINUE
C
      ELSE
C
C       Return number of points with values (ie excluding points with
C       missing data values).
C
        KSIZE = NXTOUT
C
      ENDIF
C
C     ------------------------------------------------------------------
C*    Section 9 . Return to calling routine. Format statements.
C     ------------------------------------------------------------------
C
  900 CONTINUE
C
      IF( KPR.GE.1 ) THEN
        WRITE(GRPRSM,*) 'INSMP1: Section 9.'
        WRITE(GRPRSM,*) '         Output values set -'
        WRITE(GRPRSM,*) 'INSMP1: KSIZE = ', KSIZE
      ENDIF
      RETURN
C
 9003 FORMAT (1H ,'INSMP1: Error reported by routine INXBIT.')
C
      END

!
! Copyright 1981-2016 ECMWF.
!
! This software is licensed under the terms of the Apache Licence Version 2.0
! which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
!
! In applying this licence, ECMWF does not waive the privileges and immunities
! granted to it by virtue of its status as an intergovernmental organisation
! nor does it submit to any jurisdiction.
!
! ******************************
! Modified by: Cristian Simarro, ported from GRIBEX to GRIB_API
! DATE: 17-02-2016
! ******************************
!

PROGRAM singlePointInterpolation
!
  USE eccodes

  IMPLICIT NONE
  INTEGER                                     :: IPROD
  INTEGER, DIMENSION(4)                       :: INTV
  REAL, DIMENSION(4)                          :: REALV
  CHARACTER(Len=20), DIMENSION(4)             :: CHARV
  LOGICAL                                     :: ASCII
  LOGICAL                                     :: WRITE_INTERIM_GG
  CHARACTER(Len=20)                           :: TMPGNAME
  CHARACTER(Len=20)                           :: GNAME

  INTEGER, PARAMETER                          :: JPGRIB=10000000
  INTEGER, PARAMETER                          :: JPBYTES=4
  INTEGER, PARAMETER                          :: MISSING_VALUE=-9999999
!
!     JPBYTES is the size in bytes on an 'INTEGER'
!     Set JPBYTES = 8 on a 64-bit machine.
!
  CHARACTER (LEN=1),DIMENSION(:), ALLOCATABLE :: WORK, OUTGRIB
  CHARACTER                                   :: HTYPE
  CHARACTER                                   :: GAUSSIAN
  REAL , DIMENSION(1000)                      :: LATS, LONS
  REAL                                        :: LLVALUES(1)
!
  INTEGER                                     :: isOctahedral
  CHARACTER(Len=20)                           :: gridType
  INTEGER                                     :: bitsPerValue
  INTEGER                                     :: KPTS(10024),PLATS(10024)
  INTEGER                                     :: IUNIT1, IUNIT2,IUNIT3,IUNITASCII
  INTEGER                                     :: IGRIB, IGRIB2
  INTEGER                                     :: IRET, NARGS
  INTEGER (KIND=KINDOFINT)                    :: INLEN, NEWLEN, NSIZE
  INTEGER                                     :: J
  INTEGER                                     :: NLATLON, LOOP, LOOPO
  INTEGER                                     :: EOF
  INTEGER                                     :: IFILEN
  INTEGER                                     :: NGAUSS, NPTS, NLON, NLAT
  REAL                                        :: AREA(4), GRID(2), POLE(2)
  REAL,DIMENSION(:), ALLOCATABLE              :: GLATS,GLONS,GVALUES

!
!     Externals
  INTEGER                                     :: INTOUT, INTF2, IARGC, HIRLSM
  INTEGER                                     :: HSP2GG
  EXTERNAL                                    :: HIRLSM, HSP2GG

  CHARACTER(Len=128)                          :: LLFILE, INFILE, OUTFILE
  CHARACTER(Len=128)                          :: MESSAGE = ' '
!
! **********************************************************************
!
!  Definitions and parameters
!
  DATA GRID/1.0,1.0/
  DATA POLE/-90.0,0.0/
!
!  GAUSSIAN: Set the intermediate type of the reduced grid in case of converting from SH
!  [O,N]
!
  GAUSSIAN = 'O'
!
!  Write the intermediate gaussian file?
!
  WRITE_INTERIM_GG = .FALSE.
  TMPGNAME = GAUSSIAN//'TMP'//'.grib'
!
!  Unit to use to write the ascii file if needed
!
  IUNITASCII = 16
  ASCII = .FALSE.
!
!  Accuracy in the intermediate gaussian if source is SH
!
  bitsPerValue = 16

! **********************************************************************
!
!  Pick up file names from command line.
!
  NARGS = IARGC()
  IF ( NARGS < 3 .OR. NARGS > 4) THEN
     print*,'Usage: singlePointInterpolation llfile, inputfile outputfile [a]'
     STOP
  END IF

  CALL GETARG(1,LLFILE)
  CALL GETARG(2,INFILE)
  CALL GETARG(3,OUTFILE)
  IF (NARGS == 4) THEN
    ASCII = .TRUE.
  ENDIF
!
!  Open input and output GRIB files.
!
  CALL CODES_OPEN_FILE (IUNIT1, TRIM(INFILE), 'r', IRET)
  IF ( IRET /= CODES_SUCCESS) STOP ' CODES_OPEN failed'

  CALL CODES_OPEN_FILE (IUNIT2, TRIM(OUTFILE), 'w', IRET)
  IF ( IRET /= CODES_SUCCESS ) STOP ' CODES_OPEN failed'
  IPROD = 0
  IF ( ASCII ) THEN
    OPEN(UNIT=IUNITASCII,FILE=TRIM(OUTFILE)//'.txt',IOSTAT=IRET)
    IF (IRET == 0) THEN
      WRITE(*,*)'File:',TRIM(OUTFILE),' opened'
    ELSE
      WRITE(*,*)'File:',TRIM(OUTFILE),' not opened'
      WRITE(*,*)'Input/output status = ',IRET
      WRITE(*,*)'Program will stop'
      STOP
    END IF
  END IF
  IF (WRITE_INTERIM_GG) THEN
    CALL CODES_OPEN_FILE (IUNIT3, TMPGNAME, 'w', IRET)
    IF ( IRET /= CODES_SUCCESS ) STOP ' CODES_OPEN failed'
  ENDIF
!
! Open file containing lat-lon coordinates
!
  IFILEN = INDEX(LLFILE,' ') - 1
  OPEN(UNIT=1,FILE=LLFILE,IOSTAT=IRET)
  IF (IRET /= 0) STOP 'ERROR on open of lat-lon file'
!
! Read the latitude-longitude points
!
  EOF = 0
  LOOP = 1
  NLATLON = 0
  DO WHILE (EOF == 0) 
    READ(1,*,IOSTAT=IRET) LATS(LOOP), LONS(LOOP)
    IF (IRET > 0) THEN
      STOP 'Error reading lat-lon file'
    ELSEIF (IRET < 0) THEN
      EOF=0
      EXIT
    ENDIF
    IF (LATS(LOOP) > 90.0 .OR. LATS(LOOP) < -90.0) THEN
      WRITE(*,*) 'Latitude ', LOOP, ' is faulty: (',LATS(LOOP),')'
      STOP ' Fail'
    ENDIF
    IF (LONS(LOOP) < -360.0 .OR. LONS(LOOP) > 360.0) THEN
      WRITE(*,*) 'Longitude ', LOOP, ' is faulty: (',LONS(LOOP),')'
      STOP ' Fail'
    ENDIF
    NLATLON = NLATLON + 1
    LOOP = LOOP + 1
  END DO
  CLOSE(UNIT=1)
  IF (NLATLON < 1) STOP 'No latitude/longitude pairs given'
!
  WRITE(*,*) 'Number of latitude/longitude pairs = ', NLATLON
!
! Start of loop through input GRIB-coded fields creating a HANDLER
!
  CALL CODES_ANY_NEW_FROM_FILE(IUNIT1,IGRIB,IRET)
  WRITE (*,*) 'Iterating over the messages...'
  
  DO WHILE (IRET /= CODES_END_OF_FILE)
    IF (IRET /= CODES_SUCCESS) THEN
      PRINT *, ' CODES_READ_FROM_FILE failed with error code = ', IRET
      CALL CODES_GET_ERROR_STRING(IRET,MESSAGE)
      PRINT *, TRIM(MESSAGE)
      PRINT *, 'Skipping to next message ...'
      CYCLE
    ENDIF
!    IPROD = IPROD + 1
!    WRITE(*,*) 'Message number' , IPROD

!
!  Get the gridType
!
    CALL CODES_GET(IGRIB,'gridType',gridType,IRET)
    IF ( IRET /= CODES_SUCCESS ) STOP ' CODES_GET failed for gridType'
!
!  Check if the input is SH, if it is, interpolate to GG
!
    IF ( gridType == 'sh' ) THEN
!
!  Transform to a reduced Gaussian grid
!  First copy message from HANDLER ( IGRIB ) into MEMORY ( WORK ).
!
!  WRITE (*,*) 'Found spherical harmonics input, interpolating to ',GAUSSIAN, &
!  ' GG'
      CALL CODES_GET_MESSAGE_SIZE(IGRIB,INLEN,IRET)
      IF ( IRET /= CODES_SUCCESS ) STOP ' CODES_MESSAGE_SIZE failed'
      ALLOCATE(WORK(INLEN))
      CALL CODES_COPY_MESSAGE(IGRIB,WORK,IRET)
      IF ( IRET /= CODES_SUCCESS ) STOP ' CODES_COPY_MESSAGE failed'
!      
!  Get the proper values for the new reduced grib
!
      CALL CODES_GET(IGRIB,'pentagonalResolutionParameterJ',J,IRET)
      IF ( IRET /= CODES_SUCCESS ) STOP ' CODES_GET pentagonalResolutionParameterJ failed'
      CALL CODES_GET_SIZE(IGRIB,'values',NPTS)
      IRET = HSP2GG(J,NGAUSS,KPTS,PLATS,NSIZE)
      IF( IRET.NE.0 ) THEN
          WRITE(*,*) 'Failed to find suitable gaussian grid for the'
          WRITE(*,*) 'spectral input GRIB'
          STOP 'FAIL'
      ENDIF
!      WRITE (*,*) J,NGAUSS,NSIZE,NPTS,INLEN
!
!  Create GNAME string with [N,O]NGAUSS to send to INTOUT gridname
!
      WRITE (GNAME,*) NGAUSS
      GNAME=GAUSSIAN//adjustl(GNAME)
!
!  Set the INTOUT parameters to be reduced, octahedral?
!
      IRET = INTOUT('gridname',INTV,REALV,GNAME)
      IF( IRET.NE.0 ) THEN
          WRITE(*,*) 'Failed to setup gaussian grid interpolation'
          STOP 'FAIL'
      ENDIF
      IRET = INTOUT('accuracy',bitsPerValue,REALV,CHARV)
      IF( IRET.NE.0 ) THEN
          WRITE(*,*) 'Failed to setup gaussian grid interpolation'
          STOP 'FAIL'
      ENDIF
!
!  From sh message in WORK we will interpolate to reduced OUTGRIB
!  We need to figure out NEWLEN to avoid memory waste
!
      NEWLEN = JPGRIB
      ALLOCATE(OUTGRIB(NEWLEN))
      IRET = INTF2(WORK,INLEN,OUTGRIB,NEWLEN)
      IF ( IRET /= 0 ) THEN
        WRITE(*,*) ' INTF failed, use environment JDCNDBG=1'
        STOP
      ENDIF
!
!  Create new GRIB handle from the new message OUTGRIB
!
      CALL CODES_NEW_FROM_MESSAGE(IGRIB,OUTGRIB,IRET)
      IF ( IRET /= CODES_SUCCESS ) STOP ' CODES_NEW_FROM_MESSAGE failed'
      IF (WRITE_INTERIM_GG) THEN
        CALL CODES_WRITE(IGRIB,IUNIT3,IRET)
        IF ( IRET /= CODES_SUCCESS ) STOP ' CODES_WRITE failed'
      ENDIF
      DEALLOCATE(OUTGRIB,WORK)
!
!  Finish section SH -> GG
!
    ENDIF
    
!
!  Interpolate the gaussian field to lat/long
!  At this point IGRIB is either the handler to the source or the generated interim GG
!  First let's find out the type of grid to use in the HIRLSM
!
    CALL CODES_GET(IGRIB,'gridType',gridType,IRET)
    IF ( IRET /= CODES_SUCCESS ) STOP ' CODES_GET failed for gridType'
    CALL CODES_GET(IGRIB,'isOctahedral',isOctahedral)
    IF ( gridType == 'regular_gg' ) THEN
        HTYPE = 'F'
    ELSEIF ( isOctahedral == 1 ) THEN
        HTYPE = 'O'
    ELSE
        HTYPE = 'R'
    ENDIF
!   WRITE (*,*) HTYPE
!
!  NGAUSS: Get the grib key N (old GRIBEX ISEC2(10))
!  NPTS:   Get the size of values (old GRIBEX ISEC4(1))
!  GLATS,GLONS,GVALUES: Get the data (old GRIBEX ZSEC(4))
!
    CALL CODES_GET(IGRIB,'N',NGAUSS,IRET)
    IF ( IRET /= CODES_SUCCESS ) STOP ' CODES_GET failed'
    CALL CODES_GET_SIZE(IGRIB,'values',NPTS)
    IF ( IRET /= CODES_SUCCESS ) STOP ' CODES_GET_SIZE failed'
    ALLOCATE(GLATS(NPTS))
    ALLOCATE(GLONS(NPTS))
    ALLOCATE(GVALUES(NPTS))
    CALL CODES_GRIB_GET_DATA(IGRIB,GLATS,GLONS,GVALUES)
    IF ( IRET /= CODES_SUCCESS ) STOP ' CODES_GET_DATA failed'
    
!
!  Interpolate to a single-point regular_ll as many times as lat/lon in the input file
!
    DO LOOPO = 1, NLATLON
        AREA(1) = LATS(LOOPO)
        AREA(2) = LONS(LOOPO)
        AREA(3) = LATS(LOOPO)
        AREA(4) = LONS(LOOPO)
        
        IRET = HIRLSM(.TRUE.,GVALUES,NPTS,NGAUSS,HTYPE,AREA,POLE,GRID,LLVALUES,1, &
          NLON,NLAT)
        IF( IRET.NE.0 ) THEN
          WRITE (*,*) IRET
          STOP 'Interpolation from gaussian grid to lat/lon grid failed be sure that you are using emoslib double precission r64'
        ENDIF
        IF (ASCII) THEN
          WRITE(IUNITASCII,"(1x,i5,2x,2(F8.2,1X),f8.2)") LOOPO, LATS(LOOPO), LONS(LOOPO), LLVALUES(1)
        ENDIF
    
!    
!  Set the keys and write the new values to OUT file.
!       ISEC2( 1) = 0
!       ISEC2( 2) = 1
!       ISEC2( 3) = 1
!       ISEC2( 4) = NINT(LATS(LOOPO)*1000)
!       ISEC2( 5) = NINT(LONS(LOOPO)*1000)
!       ISEC2( 6) = 128
!       ISEC2( 7) = NINT(LATS(LOOPO)*1000)
!       ISEC2( 8) = NINT(LONS(LOOPO)*1000)
!       ISEC2( 9) = 1000
!       ISEC2(10) = 1000
!       ISEC2(11) = 0
!       ISEC2(12) = 0
!       ISEC2(13) = 0
!       ISEC2(14) = 0
!       ISEC2(15) = 0
!       ISEC2(16) = 0
!       ISEC2(17) = 0
!       ISEC2(18) = 0
!       ISEC2(19) = 0
!
        CALL CODES_CLONE(IGRIB,IGRIB2)
        IF ( IRET /= CODES_SUCCESS)  STOP ' CODES_CLONE failed'
        CALL CODES_SET(IGRIB2,'gridType','regular_ll')
        CALL CODES_SET(IGRIB2,'Ni',1)
        CALL CODES_SET(IGRIB2,'Nj',1)
        CALL CODES_SET(IGRIB2,'latitudeOfFirstGridPointInDegrees',LATS(LOOPO))
        CALL CODES_SET(IGRIB2,'longitudeOfFirstGridPointInDegrees',LONS(LOOPO))
        CALL CODES_SET(IGRIB2,'latitudeOfLastGridPointInDegrees',LATS(LOOPO))
        CALL CODES_SET(IGRIB2,'longitudeOfLastGridPointInDegrees',LONS(LOOPO))
        CALL CODES_SET(IGRIB2,'iDirectionIncrementInDegrees',GRID(1))
        CALL CODES_SET(IGRIB2,'jDirectionIncrementInDegrees',GRID(2))
        CALL CODES_SET(IGRIB2,'missingValue',MISSING_VALUE)
        CALL CODES_SET(IGRIB2,'bitsPerValue',bitsPerValue)
        CALL CODES_SET(IGRIB2,'values',LLVALUES)
!
!  Finally write the data into the OUTFILE
!
        CALL CODES_WRITE(IGRIB2,IUNIT2,IRET)
        IF ( IRET /= CODES_SUCCESS)  STOP ' CODES_WRITE failed'
    END DO
!
!  Free the memory.
! 
    CALL CODES_RELEASE(IGRIB)
    CALL CODES_RELEASE(IGRIB2)
    DEALLOCATE(GLATS,GLONS,GVALUES)
!
!  Loop back for next product.
!
    CALL CODES_ANY_NEW_FROM_FILE(IUNIT1,IGRIB,IRET)    
  END DO
!
!  Close input and output files.
! 
  CALL CODES_CLOSE_FILE(IUNIT1, IRET)
  CALL CODES_CLOSE_FILE(IUNIT2, IRET)
  IF (WRITE_INTERIM_GG) THEN
    CALL CODES_CLOSE_FILE(IUNIT3,IRET)
  ENDIF
  CLOSE(UNIT=IUNITASCII)
!
  WRITE (*,*) 'Finished, check the output file ' , OUTFILE
  STOP
END PROGRAM singlePointInterpolation

C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE JSTRLL( PSHUP, KTRUNC, PNLAT, PBUILD, KLONO,
     X                    PLEG, PTRIGS, KMFAX, PZFA,   KRET)
C
C---->
C**** JSTRLL
C
C     PURPOSE
C     _______
C
C     This routine converts stretched spectral input fields to
C     standard lat/long grid fields.
C
C     INTERFACE
C     _________
C
C     CALL JSTRLL( PSHUP, KTRUNC, PNLAT, PBUILD, KLONO,
C    X              PLEG, PTRIGS, KMFAX, PZFA,   KRET)
C
C     Input parameters
C     ________________
C
C     PSHUP  - Spherical harmonics field, unpacked
C     KTRUNC - Truncation number of spherical harmonics field
C     PNLAT  - Start latitude (northernmost) for output field
C     PBUILD - Grid interval used to build the legendre coefficients
C     KLONO  - Number of longitude points along the line of latitude
C     PLEG   - Array used to hold legendre functions
C     PTRIGS - Initialized array of trig.functions (setup by JJSET99)
C     KMFAX  - Initialized array of prime factors (setup by JJSET99)
C
C     Output parameters
C     ________________
C
C     PZFA   - Output grid point field; contains one latitude row.
C     KRET   - Return status code, 0 = OK
C
C     Common block usage
C     __________________
C
C     JDCNDBG
C
C     Method
C     ______
C
C     None.
C
C     Externals
C     _________
C
C     FFT99   - Carries out FFT
C     INTLOG  - Output log message
C     INTLOGR - Output log message (with real value)
C     NMAKLL  - Make interpolation coefficients one latitude at a time
C
C     Reference
C     _________
C
C     E.C.M.W.F. Research Department technical memorandum no. 56
C                "The forecast and analysis post-processing package"
C                May 1982. J.Haseler.
C
C     Comments
C     ________
C
C     It handles transformation to a regular lat/long grid.
C
C     It is not for U and V fields (no correction is applied at the 
C     poles).
C
C
C     AUTHOR
C     ______
C
C     J.D.Chambers      ECMWF      July 1999
C
C     MODIFICATIONS
C     _____________
C
C     None.
C
C----<
C     _______________________________________________________
C
C
      IMPLICIT NONE
#include "jparams.h"
#include "parim.h"
#include "nifld.common"
C
C     Parameters
C
      INTEGER JPROUTINE
      PARAMETER ( JPROUTINE = 31300 )
      INTEGER JPN, JPS
      PARAMETER ( JPN = 1 )
      PARAMETER ( JPS = 2 )
C
C     Subroutine arguments
C
      COMPLEX PSHUP(*)
      INTEGER KTRUNC
      INTEGER KLONO, KRET
      INTEGER KMFAX(*)
      REAL PNLAT, PBUILD
      REAL PZFA(JPLONO+2), PLEG(*), PTRIGS(*)
C
C     Local variables
C
      INTEGER ILIM, IMLIM, ILN
      INTEGER ITAL, ITALA, ITALS, IMN, IMP
      INTEGER INORTH
      INTEGER JM, LOOP, JF
      INTEGER NERR
C
#ifndef _CRAYFTN
#ifdef POINTER_64
      INTEGER*8 IWORK
#endif
#endif
      REAL ZNLAT, MFACTOR
      REAL WORK
      DIMENSION WORK(1)
      POINTER ( IWORK, WORK )
      COMPLEX   ZDUM(JPTRNC + 1)
      COMPLEX   ZSUMS(JPTRNC + 1), ZSUMA(JPTRNC + 1)
      COMPLEX*16 CHOLD
C
      INTEGER ISIZE
      DATA ISIZE/0/
      SAVE ISIZE, IWORK
C
C     _______________________________________________________
C
C*    Section 1.    Initialization.
C     _______________________________________________________
C
  100 CONTINUE
C
C     First time through, dynamically allocate memory for workspace
C
      IF( ISIZE.EQ.0 ) THEN
        ISIZE =  2*JPFFT
        CALL JMEMHAN( 9, IWORK, ISIZE, 1, KRET)
        IF( KRET.NE.0 ) THEN
          CALL INTLOG(JP_ERROR,'JSTRLL: memory allocation error.',IWORK)
          KRET = JPROUTINE + 1
          GOTO 990
        ENDIF
      ENDIF
C
      IF( NDBG.GT.1 ) THEN
        CALL INTLOG(JP_DEBUG,
     X    'JSTRLL: Spherical harmonic coeffs(first 20):',JPQUIET)
        DO NDBGLP = 1, 20
          CALL INTLOGR(JP_DEBUG,' ',PSHUP( NDBGLP ))
        ENDDO
        CALL INTLOG(JP_DEBUG,'JSTRLL: Input parameters:',JPQUIET)
        CALL INTLOG(JP_DEBUG,
     X    'JSTRLL: Spherical harmonic truncation = ', KTRUNC)
        CALL INTLOGR(JP_DEBUG,
     X    'JSTRLL: Current latitude = ', PNLAT)
        CALL INTLOGR(JP_DEBUG,
     X    'JSTRLL: Grid lat. interval(leg. file) = ', PBUILD)
        CALL INTLOG(JP_DEBUG,
     X    'JSTRLL: Number of long. pts per row = ', KLONO)
        CALL INTLOG(JP_DEBUG,
     X    'JSTRLL: Trig.functions (setup by JJSET99):',JPQUIET)
        DO NDBGLP = 1, 10
          CALL INTLOGR(JP_DEBUG,' ',PTRIGS( NDBGLP ))
        ENDDO
        CALL INTLOG(JP_DEBUG,
     X    'JSTRLL: Prime factors (setup by JJSET99):',JPQUIET)
        DO NDBGLP = 1, 10
          CALL INTLOG(JP_DEBUG,' ',KMFAX( NDBGLP ))
        ENDDO
      ENDIF
C
C     If it is a stretched field, calculate the true latitude and
C     the map factor.
C
      IF( RISTRET.NE.0 ) THEN
        CALL STRLAT(PNLAT, RISTRET, 1, ZNLAT, MFACTOR)
      ELSE
        ZNLAT = PNLAT
      ENDIF
C
      ILIM   = KTRUNC + 1
      IMLIM  = KTRUNC + 1
      INORTH = -1
      ILN    = KLONO + 2
C
C     _______________________________________________________
C
C*    Section 2.   Calculate fourier coefficients
C     _______________________________________________________
C
 200  CONTINUE
C
C     Generate the legendre coefficients 'on the fly'
C
      IF( ZNLAT.GE.0 ) THEN
        CALL NMAKLL( KTRUNC, PBUILD, ZNLAT, 1, PLEG, NERR)
      ELSE
        CALL NMAKLL( KTRUNC, PBUILD, -ZNLAT, 1, PLEG, NERR)
      ENDIF
C
C     Clear array.
C
      DO JF = 1, JPLONO+2
        PZFA(JF) = 0.0
      ENDDO
C
C     Fill slots which are used
C
      IMN = 0
      IMP = 0
C
      DO JM = 1, IMLIM
        ITAL = ILIM - JM + 1
        DO LOOP = 1, ITAL
          ZDUM(LOOP) = PLEG(IMP + LOOP)*PSHUP(IMN + LOOP)
        ENDDO
C
        IMP = IMP + ITAL + 1
        IMN = IMN + ITAL
        ITALS = (ITAL + 1)/2
        ITALA = ITAL/2
        CHOLD = (0.0D0, 0.0D0)
        DO LOOP = 1, 2*ITALS, 2
          CHOLD = CHOLD + ZDUM(LOOP)
        ENDDO
        ZSUMS(JM) = CHOLD
        CHOLD = (0.0D0, 0.0D0)
        DO LOOP = 2, 2*ITALA, 2
          CHOLD = CHOLD + ZDUM(LOOP)
        ENDDO
        ZSUMA(JM) = CHOLD
C
      ENDDO
C
C     For the southern hemisphere row, the legendre functions are
C     the complex conjugates of the corresponding northern row -
C     hence the juggling with the signs in the next loop.
C
C     Note that PZFA is REAL, but the coefficients being calculated
C     are COMPLEX.  There are pairs of values for each coefficient
C     (real and imaginary parts) and pairs of values for each
C     latitude (north and south).
C
      IF( ZNLAT.GE.0 ) THEN
        DO JM = 1, IMLIM
          PZFA(2*JM -1) = REAL(ZSUMS(JM))  + REAL(ZSUMA(JM))
          PZFA(2*JM   ) = AIMAG(ZSUMS(JM)) + AIMAG(ZSUMA(JM))
        ENDDO
      ELSE
        DO JM = 1, IMLIM
          PZFA(2*JM -1) = REAL(ZSUMS(JM))  - REAL(ZSUMA(JM))
          PZFA(2*JM   ) = AIMAG(ZSUMS(JM)) - AIMAG(ZSUMA(JM))
        ENDDO
      ENDIF
C
C     _______________________________________________________
C
C*    Section 3.    Fast fourier transform
C     _______________________________________________________
C
 300  CONTINUE
C
      CALL FFT99(PZFA,WORK,PTRIGS,KMFAX,1,J2NFFT,KLONO,1,1)
C   
C     Apply map factor (squared) to vorticity or divergence
C   
      IF( (NIPARAM.EQ.138).OR.(NIPARAM.EQ.155) ) THEN
        MFACTOR = MFACTOR*MFACTOR
        DO LOOP = 1, KLONO
          PZFA(LOOP) = MFACTOR*PZFA(LOOP)
        ENDDO
      ENDIF
C
      IF( NDBG.GT.1 ) THEN
        CALL INTLOG(JP_DEBUG,
     X    'JSTRLL: Values calculated by FFT:',JPQUIET)
        DO NDBGLP = 1, 20
          CALL INTLOGR(JP_DEBUG,' ', PZFA( 1 + (NDBGLP-1)*2 ))
          CALL INTLOGR(JP_DEBUG,' ', PZFA( NDBGLP*2 ))
        ENDDO
      ENDIF
C
C     _______________________________________________________
C
C*    Section 9. Return to calling routine. Format statements
C     _______________________________________________________
C
C
 900  CONTINUE
C
      KRET = 0
C
 990  CONTINUE
      RETURN
      END

C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities
C granted to it by virtue of its status as an intergovernmental organisation
C nor does it submit to any jurisdiction.
C

#define INT_MISSING -2147483647

      SUBROUTINE CLEAR_C( )
C
C---->
C**** CLEAR_C
C
C     Purpose
C     -------
C
C     Sets start values for parameters in common block.
C
C
C     Interface
C     ---------
C
C     CALL CLEAR_C()
C
C
C     Method
C     ------
C
C     Hard coded defaults.
C
C
C     Externals
C     ---------
C
C     None.
C
C
C     Author
C     ------
C
C     J.D.Chambers       ECMWF        August 1994.
C
C----<
C
C     IMPLICIT NONE
C
C
#include "parim.h"
#include "nifld.common"
#include "nifld.extracommon"
#include "nofld.common"
#include "grfixed.h"
#include "current.h"
C
C     Local variables
C
      INTEGER IRET, LOOP
C
C     ------------------------------------------------------------------
C*    Section 1.   Initialise
C     ------------------------------------------------------------------
C
  100 CONTINUE
C
C     Set default processing flag settings.
C
      LCHANGE     = .TRUE.
      LSMCHNG     = .TRUE.
      LSM         = .TRUE.
      LPREC       = .FALSE.
      LWIND       = .FALSE.
      LOCTAHEDRAL = .FALSE.
C
C     Set default area indexes.
C
      NINS  = 0
      NIWE  = 0
      NO1NS = 0
      NO1WE = 0
      NONS  = 0
      NOWE  = 0
C
C     Defaults for output GRIB record ..
C     .. ECMWF local code table 128
C     .. level 500 hPa
C
      NOPARAM = 0
      NOTABLE = 128
      NOLEVT  = 100
      NOLEVEL = 500
      NOHFUNC = 'A'
C
C     Turn off all flags indicating that user has given a value.
C
      LSMPARSET = .FALSE.
      LSMSET    = .FALSE.
      LPRECSET  = .FALSE.
      LWINDSET  = .FALSE.
      LNIGAUS   = .FALSE.
      LNGSPEC   = .FALSE.
      LIGIVEL   = .FALSE.
      LIGIVEP   = .FALSE.
      LOGIVEL   = .FALSE.
      LOGIVEP   = .FALSE.
      LNOAREA   = .FALSE.
      LNORESO   = .FALSE.
      LNOGAUS   = .FALSE.
      LNOACC    = .FALSE.
      LNOREPR   = .FALSE.
      LNOTABL   = .FALSE.
      LNOPARA   = .FALSE.
      LNOLEVL   = .FALSE.
      LNOLEVT   = .FALSE.
      LNOGRID   = .FALSE.
      LNOFRAME  = .FALSE.
      LNOSTYLE  = .FALSE.
      LARESOL   = .FALSE.
      LINTOUT   = .FALSE.
      LIMISSV   = .FALSE.
cs double interpolation
      LDOUBLE   = .FALSE.
C
      RMISSGV   = REAL(INT_MISSING)
C
C     Clear input and output gaussian grid definitions
C
      NIGAUSS = 0
      NOGAUSS = 0
      DO 110 LOOP = 1, JPLAT
        RIGAUSS(LOOP) = 0.0
        MILLEN(LOOP) = 0
  110 CONTINUE
C
      DO 120 LOOP = 1, JPLAT
        ROGAUSS(LOOP) = 0.0
        NOLPTS(LOOP) = 0
  120 CONTINUE
C
C     Clear information about gaussian field definitions
C
      NGSPEC  = 0
      NIGAUSO = 0
      NOGAUSO = 0
      HIGAUST = 'X'
      HOGAUST = 'X'
C
C     Clear rotation angle values.
C
      NOROTA(1) = 0
      NOROTA(2) = 0
      LNOROTA   = .FALSE.
      LO12PT = .TRUE.
      LMETHOD = .FALSE.
      LNNLSM        = .FALSE.
      LNNLSM_CY41R1 = .FALSE.
C
C     Clear style and frame values
C
      NOFRAME = 0
      NOSTYLE = JPSMARS
C
C     Clear flags showing how to deal with legendre coefficients
C
      LFILEIO = .FALSE.
      LMEMORY = .FALSE.
      LSHARED = .FALSE.
      LON_FLY = .FALSE.
      LMAPPED = .FALSE.
      LIFIRST = .TRUE.
C
C     Clear fields for ISLSCP processing
C
      IF( LNIISCL ) THEN
        CALL JFREE(NIPOGRB)
        CALL JFREE(NIPNGRB)
      ENDIF
      LNIISCL = .FALSE.
C
C     ------------------------------------------------------------------
C*    Section 9.   Closedown.
C     ------------------------------------------------------------------
C
  900 CONTINUE
C
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE ECDF191(HFUNC,KSEC1,KGRIB,KLENG,KNSPT,KBITS,KPLEN,KRET)
C
C---->
C**** ECDF191
C
C     Purpose.
C     --------
C
C     GRIB coding/decoding of ECMWF local use definition 191.
C
C**   Interface.
C     ----------
C
C     CALL ECDF191(HFUNC,KSEC1,KGRIB,KLENG,KNSPT,KBITS,KRET)
C
C
C     Input
C     -----
C     HFUNC      - Requested function.
C                  'C' to code data.
C                  'D' to decode data.
C     KSEC1      - Array containing Grib Section 1 data.
C     KGRIB      - Array containing Grib coded data.
C     KLENG      - Length (words) of KGRIB.
C     KNSPT      - Bit number after which insertion/extraction starts.
C     KBITS      - Number of bits in computer word.
C     KPLEN      - Pointer to field containing length of Section 1.
C     KRET       - Response to error indicator.
C                  0        , Abort if error encountered.
C                  Non-zero , Return to calling routine
C                             even if error encountered.
C
C     Output
C     ------
C     KSEC1      - Array containing Grib Section 1 data.(Updated)
C     KGRIB      - Array containing Grib coded data.(Updated)
C     KNSPT      - Number of bit after last one inserted/extracted.
C                  (Updated)
C     KRET       - Return code.
C                  0   , No error encountered.
C                  2   , Error reported by routine INXBIT.
C
C
C     Method.
C     -------
C     Input data packed/unpacked in accordance with ECMWF usage of
C     local part of section 1 of Grib code, definition 191.
C
C
C     Externals.
C     ----------
C
C     INXBIT  - insert/extract bits
C     ABORTX  - abort the program
C     CSGNBT  - code a signed value
C     DSGNBT  - decode a signed value
C
C
C     Reference.
C     ----------
C
C     WMO Manual On Codes for Grib Code.
C
C
C     Comments.
C     ---------
C
#include "ecdf191.h"
C
C
C     Author.
C     -------
C
C     J.D.Chambers     ECMWF      December 2001
C
C
C     Modifications.
C     --------------
C
C     None
C
C
C----<
C     -----------------------------------------------------------------|
C*    Section 0 . Definition of variables. Data statements.
C     -----------------------------------------------------------------|
C
      IMPLICIT NONE
C
C     Parameter(s)
C
      INTEGER JPBYTES
C                `-----> Number of bytes in an INTEGER
#ifdef INTEGER_8
      PARAMETER( JPBYTES = 8)
#else
      PARAMETER( JPBYTES = 4)
#endif
C
C     Subroutine arguments
C
      CHARACTER*1   HFUNC
      INTEGER KSEC1, KGRIB, KLENG, KNSPT, KBITS, KPLEN, KRET
      DIMENSION KGRIB(*)
      DIMENSION KSEC1(*)
C
C     Local variables
C
      INTEGER IRET, IZERO, JLOOP, N, M, ILENS1, N_KNSPT, ICOUNT, IBITS
C
      LOGICAL LENCODE, LDECODE
C
C     -----------------------------------------------------------------|
C*    Section 1 . Set initial values.
C     -----------------------------------------------------------------|
C
  100 CONTINUE
C
      IRET = KRET
      LENCODE = ( HFUNC.EQ.'C' )
      LDECODE = .NOT. LENCODE
C
      N_KNSPT = KNSPT
C
C     -----------------------------------------------------------------|
C*    Section 2 . Handle the local extension
C     -----------------------------------------------------------------|
C
  200 CONTINUE
C
C     Octet 50 : Zero
C     Octet 51 : Zero
C     Two 8 bit fields.
C
      IF( LENCODE ) THEN
        IZERO = 0
        CALL INXBIT(KGRIB,KLENG,KNSPT,IZERO,1,KBITS,8,HFUNC,KRET)
        IF( KRET.NE.0 ) THEN
          KRET = 2
          WRITE(*,*) 'ECDF191: Error reported by routine INXBIT:'
          WRITE(*,*) '          encoding section 1, octet 50'
          GOTO 900
        ENDIF
      ELSE
        KSEC1(42) = 0
        KNSPT = KNSPT + 8
      ENDIF
C
      IF( LENCODE ) THEN
        IZERO = 0
        CALL INXBIT(KGRIB,KLENG,KNSPT,IZERO,1,KBITS,8,HFUNC,KRET)
        IF( KRET.NE.0 ) THEN
          KRET = 2
          WRITE(*,*) 'ECDF191: Error reported by routine INXBIT:'
          WRITE(*,*) '          encoding section 1, octet 51'
          GOTO 900
        ENDIF
      ELSE
        KSEC1(43) = 0
        KNSPT = KNSPT + 8
      ENDIF
C
C     Octet 52 : Format version major number
C     Octet 53 : Format version minor number
C     Two 8 bit fields.
C
      CALL INXBIT(KGRIB,KLENG,KNSPT,KSEC1(44),1,KBITS,8,HFUNC,KRET)
      IF( KRET.NE.0 ) THEN
        KRET = 2
        WRITE(*,*) 'ECDF191: Error reported by routine INXBIT:'
        IF( LENCODE ) THEN
          WRITE(*,*) '      encoding section 1, element 44.'
        ELSE
          WRITE(*,*) '      decoding section 1, octet 52.'
        ENDIF
        GOTO 900
      ENDIF
C
      CALL INXBIT(KGRIB,KLENG,KNSPT,KSEC1(45),1,KBITS,8,HFUNC,KRET)
      IF( KRET.NE.0 ) THEN
        KRET = 2
        WRITE(*,*) 'ECDF191: Error reported by routine INXBIT:'
        IF( LENCODE ) THEN
          WRITE(*,*) '      encoding section 1, element 45.'
        ELSE
          WRITE(*,*) '      decoding section 1, octet 53.'
        ENDIF
        GOTO 900
      ENDIF
C
C     Octet 54 : Original sub-centre identifier
C     One 8 bit fields.
C
      CALL INXBIT(KGRIB,KLENG,KNSPT,KSEC1(46),1,KBITS,8,HFUNC,KRET)
      IF( KRET.NE.0 ) THEN
        KRET = 2
        WRITE(*,*) 'ECDF191: Error reported by routine INXBIT:'
        IF( LENCODE ) THEN
          WRITE(*,*) '      encoding section 1, element 46.'
        ELSE
          WRITE(*,*) '      decoding section 1, octet 54.'
        ENDIF
        GOTO 900
      ENDIF
C
C     Octet 55-58 : Padding, set to zero
C     Four 8 bit fields.
C
      IF( LENCODE ) THEN
        IZERO = 0
        CALL INXBIT(KGRIB,KLENG,KNSPT,IZERO,1,KBITS,8,HFUNC,KRET)
        IF( KRET.NE.0 ) THEN
          KRET = 2
          WRITE(*,*) 'ECDF191: Error reported by routine INXBIT:'
          WRITE(*,*) '          encoding section 1, octet 55'
          GOTO 900
        ENDIF
      ELSE
        KSEC1(47) = 0
        KNSPT = KNSPT + 8
      ENDIF
C
      IF( LENCODE ) THEN
        IZERO = 0
        CALL INXBIT(KGRIB,KLENG,KNSPT,IZERO,1,KBITS,8,HFUNC,KRET)
        IF( KRET.NE.0 ) THEN
          KRET = 2
          WRITE(*,*) 'ECDF191: Error reported by routine INXBIT:'
          WRITE(*,*) '          encoding section 1, octet 56'
          GOTO 900
        ENDIF
      ELSE
        KSEC1(48) = 0
        KNSPT = KNSPT + 8
      ENDIF
C
      IF( LENCODE ) THEN
        IZERO = 0
        CALL INXBIT(KGRIB,KLENG,KNSPT,IZERO,1,KBITS,8,HFUNC,KRET)
        IF( KRET.NE.0 ) THEN
          KRET = 2
          WRITE(*,*) 'ECDF191: Error reported by routine INXBIT:'
          WRITE(*,*) '          encoding section 1, octet 57'
          GOTO 900
        ENDIF
      ELSE
        KSEC1(49) = 0
        KNSPT = KNSPT + 8
      ENDIF
C
      IF( LENCODE ) THEN
        IZERO = 0
        CALL INXBIT(KGRIB,KLENG,KNSPT,IZERO,1,KBITS,8,HFUNC,KRET)
        IF( KRET.NE.0 ) THEN
          KRET = 2
          WRITE(*,*) 'ECDF191: Error reported by routine INXBIT:'
          WRITE(*,*) '          encoding section 1, octet 58'
          GOTO 900
        ENDIF
      ELSE
        KSEC1(50) = 0
        KNSPT = KNSPT + 8
      ENDIF
C
C     Octets 59-60: Number of bytes of free format data descriptor
C     One 16 bit field
C
      CALL INXBIT(KGRIB,KLENG,KNSPT,KSEC1(51),1,KBITS,16,HFUNC,KRET)
      IF( KRET.NE.0 ) THEN
        KRET = 2
        WRITE(*,*) 'ECDF191: Error reported by routine INXBIT:'
        IF( LENCODE ) THEN
          WRITE(*,*) '      encoding section 1, element 51.'
        ELSE
          WRITE(*,*) '      decoding section 1, octets 59 - 60.'
        ENDIF
        GOTO 900
      ENDIF
C
C     Octets 61-(60+N) : Data bytes
C     N values; 8 bit values packed in integer array element
C
      N = KSEC1(51)
      ICOUNT = (N+JPBYTES-1)/JPBYTES
      IBITS  = JPBYTES*8
      CALL INXBIT(KGRIB,KLENG,KNSPT,KSEC1(52),
     X            ICOUNT,KBITS,IBITS,HFUNC,KRET)
      IF( KRET.NE.0 ) THEN
        KRET = 2
        WRITE(*,*) 'ECDF191: Error reported by routine INXBIT:'
        IF( LENCODE ) THEN
          WRITE(*,*) '    encoding section 1, elements 52 - (51+N/4).'
        ELSE
          WRITE(*,*) '    decoding section 1, octets 61 - (60+N).'
        ENDIF
        GOTO 900
      ENDIF
C
C     Octets (60+N) onwards: Padded with zeroes
C     The section will be padded with zeroes to make the overall length
C     of the section = 60 + 80*M for some M > 0.
C
      M = 60+(((ICOUNT*JPBYTES)+79)/80)*80
C
      DO JLOOP = (60+ICOUNT*JPBYTES+1), M
        IF( LENCODE ) THEN
          IZERO = 0
          CALL INXBIT(KGRIB,KLENG,KNSPT,IZERO,1,KBITS,8,HFUNC,KRET)
          IF( KRET.NE.0 ) THEN
            KRET = 2
            WRITE(*,*) 'ECDF191: Error reported by routine INXBIT:'
            WRITE(*,*) '      encoding section 1, octets (56+N) onwards'
            GOTO 900
          ENDIF
        ELSE
          KNSPT = KNSPT + 8
        ENDIF
      ENDDO
C
C     Calculate section 1 total length using original and final bit
C     positions. NB packing started at octet 50.
C
      ILENS1 = 49 + (KNSPT - N_KNSPT)/8
C
C*    Insert length of section 1, if coding data.
C     One 24-bit field.
C
      IF( LENCODE ) THEN
        CALL INXBIT(KGRIB,KLENG,KPLEN,ILENS1,1,KBITS, 24,HFUNC,KRET)
        IF( KRET.NE.0 ) THEN
          KRET = 2
          WRITE(*,*) 'ECDF191: Error reported by routine INXBIT:'
          WRITE(*,*) '         encoding length of section 1'
          GOTO 900
        ENDIF
      ENDIF
C
C     -----------------------------------------------------------------|
C*    Section 9 . Abort/return to calling routine. Format statements.
C     -----------------------------------------------------------------|
C
  900 CONTINUE
C
C     Abort if requested to do so when an error has been encountered.
C
      IF( (IRET.EQ.0).AND.(KRET.NE.0) ) THEN
        CALL ABORTX('ECDF191')
      ELSE
        RETURN
      ENDIF
C
      END

C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE BURQC(KBUFL,KBUFF,KELEM,CNAMES,CUNITS,KSUP,KSEC3,KERR)
C
C**** *BURQC*
C
C
C     PURPOSE.
C     --------
C
C          CREATE PARAMETERS NEEDED FOR PARTIAL EXPANSION OF
C     BUFR MESSAGE WITH COMPRESSED DATA ACCORDING TO REQUESTED
C     INPUT LISTS.
C
C
C**   INTERFACE.
C     ----------
C
C          *CALL* *BURQC(KBUFL,KBUFF,KELEM,CNAMES,CUNITS,KSUP,KSEC3,KERR)*
C
C        INPUT :
C               *KBUFL*   -  LENGTH OF BUFR MESSAGE (WORDS)
C               *KBUFF*   -  ARRAY CONTAINING BUFR MESSAGE
C               *KELEM*   -  DIMENSION OF CNAMES, CUNITS ARRAY
C               *CNAMES*  -  CHARACTER ARRAY CONTAINING ELEMENT NAMES
C               *CUNITS*  -  CHARACTER ARRAY CONTAINIG UNITS
C               *KSUP*    -  ARRAY CONTAINING SUPLEMENTARY INFORMATION
C                         -  KSUP( 1) -- IDIM1, DIMENSION OF KSEC1
C                         -  KSUP( 2) -- IDIM2, DIMENSION OF KSEC2
C                         -  KSUP( 3) -- IDIM3, DIMENSION OF KSEC3
C                         -  KSUP( 4) -- IDIM4, DIMENSION OF KSEC4
C                         -  KSUP( 5) -- M (NUMBER OF ELEMENTS IN VALUES ARRAY,
C                                           FIRST INDEX)
C                         -  KSUP( 6) -- N (NUMBER OF SUBSETS,SECOND INDEX OF
C                                           VALUES ARRAY)
C                         -  KSUP( 7) -- JVC (NUMBER OF ELEMENTS IN CVAL ARRAY)
C                         -  KSUP( 8) -- TOTAL BUFR MESSAGE LENGTH IN BYTES
C                         -  KSUP( 9) -- IDIM0, DIMENSION OF KSEC0
C               *KSEC3*   -  ARRAY CONTAINING SECTION 3 INFORMATION
C                            KSEC3( 1)-- LENGTH OF SECTION 3 (BYTES)
C                            KSEC3( 2)-- RESERVED
C                            KSEC3( 3)-- NUMBER OF SUBSETS
C                            KSEC3( 4)-- FLAG (DATA TYPE,DATA COMPRESSION)
C               *KERR*    -  RETURNED ERROR CODE
C
C     METHOD.
C      -------
C
C          WORD AND BIT POINTERS ARE CALCULATED FOR EVERY ELEMENT
C     IN THE EXPANDED LIST OF ELEMENTS. IF PARTIAL EXPANSION REQUESTED,
C     INDECES TO REQUIRED ELEMENTS ARE DETERMINED, AS WELL AS CORRESPONDING
C     QUALITY CONTROL, STATISTICS ETC. INFORMATION.
C
C
C     EXTERNALS.
C     ----------
C
C          BUNPCK          - UNPACKS BIT PATTERN
C          BUNPKS         - UNPACKS BIT PATTERN IN REPEATED WAY
C
C     REFERENCE.
C     ----------
C
C          NONE.
C
C     AUTHOR.
C     -------
C
C          M. DRAGOSAVAC    *ECMWF*       01/02/91.
C
C
C     MODIFICATIONS.
C     --------------
C
C          NONE.
C
C
      IMPLICIT LOGICAL(L,O,G), CHARACTER*8(C,H,Y)
C
C
#     include "parameter.F"
#     include "bcomunit.F"
#     include "bcomwork.F"
#     include "bcombef.F"
#     include "bcomwt.F"
#     include "bcomp.F"
#     include "bcomwtc.F"
#     include "bcomrq.F"
#     include "bcomreq.F"
C
      CHARACTER*64 CWTEN
      CHARACTER*24 CWTU
      CHARACTER*64 CNAMES(KELEM)
      CHARACTER*24 CUNITS(KELEM)
C
      DIMENSION KSUP(JSUP),KSEC3(JSEC3)
      DIMENSION KBUFF(KBUFL)
C
      DIMENSION IRQEI(JELEM),IQCI(JELEM),IQCDPI(JELEM)
      DIMENSION IBVAL(JELEM),IBV(JELEM)
      DIMENSION IC7(JELEM),IC8(JELEM),IC7R(JELEM),IC8R(JELEM)
      DIMENSION NQP(JELEM),ITYPE(100)
C
#ifndef R_4
      REAL*8 RVIND
      REAL*8 EPS
      REAL*8 RQVAL
      REAL*8 VAL
#else
      REAL   RVIND
      REAL   EPS
      REAL   RQVAL
      REAL   VAL
#endif
      DIMENSION IMASK(8)
C
      SAVE IBV,IBVAL
C
      DATA IMASK /1,2,4,8,16,32,64,128/
C
C
C     ------------------------------------------------------------------
C
C*          1.  DEFINE WORD/BIT POINTERS TO EVERY ELEMENT.
C               ------------------------------------------
 100  CONTINUE
C
      IF(KERR.GT.0) RETURN
C
      NFCM=1
      NFUCM=0
C
C     CHECK REQUEST VALIDITY
C
      IF(NREQ(1).EQ.0.AND.NREQ(2).NE.0) THEN
         KERR=38
         CALL BUERR(KERR)
         RETURN
      END IF
C
      MREL=0
C
      IBP32= 32 + NBPTB
C
      IB1=0
      IF(IAND(NREQ(2),IMASK(1)).NE.0) IB1=1
      IB2=0
      IF(IAND(NREQ(2),IMASK(2)).NE.0) IB2=1
      IB3=0
      IF(IAND(NREQ(2),IMASK(3)).NE.0) IB3=1
      IB4=0
      IF(IAND(NREQ(2),IMASK(4)).NE.0) IB4=1
      IB5=0
      IF(IAND(NREQ(2),IMASK(5)).NE.0) IB5=1
      IB6=0
      IF(IAND(NREQ(2),IMASK(6)).NE.0) IB6=1
C
C*          1.1 COMPRESSED DATA.
C               ----------------
 110  CONTINUE
C
      IBIT=IBP32
      IWORD=IBIT/NBPW
C
      NWORDP(1)=NWPTB+IWORD
      NBITP (1)=IBIT-IWORD*NBPW
C
      DO 111 I=2,M+1
      IWRD=NWORDP(I-1)
      IBTP=NBITP (I-1)
C
      IF(NWTDW(I-1).EQ.0) THEN
         NBITP(I) =NBITP(I-1)
         NWORDP(I)=NWORDP(I-1)
         GO TO 111
      END IF
C
      IBTP=IBTP+NWTDW(I-1)
      IF(IBTP.GE.NBPW) THEN
         IW=IBTP/NBPW
         IBTP=IBTP-IW*NBPW
         IWRD=IWRD+IW
      END IF
C
      CALL BUNPCK(NBPW,KBUFF,IDWINC,IWRD,IBTP,6,KERR)
      IF(KERR.GT.0) RETURN
      IF(IDWINC.GT.JBPW) THEN
            KERR=15
            WRITE(KNTN,*)  'BURQC :'
            CALL BUERR(KERR)
            RETURN
      END IF
      IF(IWRD.GT.KBUFL) THEN
            KERR=26
            WRITE(KNTN,*)  'BURQC :'
            CALL BUERR(KERR)
            RETURN
      END IF
C
      IF(CWTU(I-1).EQ.'CCITTIA5') THEN
         NWTIWS(I-1)=NWTDW(I-1)+6+N*IDWINC*8
      ELSEIF(NWTEN(I-1).EQ.-999) THEN
         NWTIWS(I-1)=NWTDW(I-1)+6+N*IDWINC*8
      ELSE
         NWTIWS(I-1)=NWTDW(I-1)+6+N*IDWINC
      END IF
C
      IBIT = NBITP(I-1) + NWTIWS(I-1)
      IWORD= IBIT/NBPW
C
      NBITP (I)= IBIT - IWORD*NBPW
      NWORDP(I)= NWORDP(I-1) + IWORD
C
      IF(NWORDP(I).GT.KBUFL) THEN
            KERR=26
            WRITE(KNTN,*)  'BURQC :'
            CALL BUERR(KERR)
            RETURN
      END IF
 111  CONTINUE
C
C     -----------------------------------------------------------------
C*          2. CREATE POINTERS FOR REQUESTED ELEMENTS.
C              ---------------------------------------
 200  CONTINUE
C
C
C*          2.1 CHECK IF SUBSET OF ELEMENTS REQUESTED.
C
 210  CONTINUE
C
      IF(NREQ(1).EQ.0) THEN
         DO 212 I=1,M
         INWTEN(I)=NWTEN(I)
         INWTR (I)=NWTR (I)
         INWTS (I)=NWTS (I)
         INWTDW(I)=NWTDW(I)
         INWTRV(I)=NWTRV(I)
         CNAMES(I)=CWTEN(I)
         CUNITS(I)=CWTU(I)
         INWORDP(I)=NWORDP(I)
         INBITP(I)=NBITP(I)
 212     CONTINUE
         RETURN
      END IF
C
      IF(NREQ(1).EQ.1) THEN
         DO 213 I=1,M
         IF(NWTR(I).GT.200000.AND.
     1      NWTR(I).NE.999999) THEN
            MREL=I-1
            GO TO 2133
         END IF
 213     CONTINUE
         MREL=M
C
 2133    CONTINUE
         J=0
         IF(NRQL.EQ.0) THEN
            DO 2131 I=1,MREL
            J=J+1
            INBITP(J)=NBITP(I)
            INWORDP(J)=NWORDP(I)
            INWTEN(J)=NWTEN(I)
            INWTR(J) =NWTR(I)
            INWTS(J) =NWTS(I)
            INWTDW(J)=NWTDW(I)
            INWTRV(J)=NWTRV(I)
            CNAMES(J)=CWTEN(I)
            CUNITS(J)=CWTU(I)
 2131       CONTINUE
C
            M=J
            RETURN
         ELSE
            M=MREL
            GO TO 220
         END IF
      END IF
C
      IF(NREQ(1).EQ.2) THEN
         DO 214 I=1,M
         IF(NWTR(I).EQ.235000) THEN
            M=I-1
            GO TO 2141
         END IF
 214     CONTINUE
C
 2141    CONTINUE
C
         J=0
         IF(NREQ(2).EQ.0) THEN
            DO 2142 I=1,M
            J=J+1
            INBITP(J)=NBITP(I)
            INWORDP(J)=NWORDP(I)
            INWTEN(J)=NWTEN(I)
            INWTR(J)=NWTR(I)
            INWTS(J)=NWTS(I)
            INWTDW(J)=NWTDW(I)
            INWTRV(J)=NWTRV(I)
            CNAMES(J)=CWTEN(I)
            CUNITS(J)=CWTU(I)
 2142       CONTINUE
            RETURN
         ELSE
            GO TO 220
         END IF
      END IF
C
      IF(NREQ(1).EQ.3) THEN
         DO 215 I=1,M
         IF(NWTR(I).EQ.235000) THEN
C
C           COPY CLASS 1 - 8 ELEMENTS
C
            DO 2151 III=1,M
            IF(NWTR(III).GT.8000) THEN
               J=0
               IF(NREQ(2).EQ.0) THEN
                  DO 2161 II=1,III-1
                  J=J+1
                  INBITP(J)=NBITP(II)
                  INWORDP(J)=NWORDP(II)
                  INWTR(J)=NWTR(II)
                  INWTS(J)=NWTS(II)
                  INWTRV(J)=NWTRV(II)
                  INWTDW(J)=NWTDW(II)
                  INWTEN(J)=NWTEN(II)
                  CNAMES(J)=CWTEN(II)
                  CUNITS(J)=CWTU(II)
 2161             CONTINUE
                  GO TO 2160
              ELSE
                  DO 21611 II=1,III-1
                  J=J+1
                  NBITP(J)=NBITP(II)
                  NWORDP(J)=NWORDP(II)
                  NWTR(J)=NWTR(II)
                  NWTS(J)=NWTS(II)
                  NWTRV(J)=NWTRV(II)
                  NWTDW(J)=NWTDW(II)
                  NWTEN(J)=NWTEN(II)
                  CWTEN(J)=CWTEN(II)
                  CWTU(J)=CWTU(II)
21611             CONTINUE
                  GO TO 2160

              END IF
            END IF
 2151       CONTINUE
C
 2160       CONTINUE
C
            IF(NREQ(2).EQ.0) THEN
               DO 216 II=I+1,M
               J=J+1
               INBITP(J)=NBITP(II)
               INWORDP(J)=NWORDP(II)
               INWTR(J)=NWTR(II)
               INWTS(J)=NWTS(II)
               INWTRV(J)=NWTRV(II)
               INWTDW(J)=NWTDW(II)
               INWTEN(J)=NWTEN(II)
               CNAMES(J)=CWTEN(II)
               CUNITS(J)=CWTU(II)
 216           CONTINUE
               M=J
               RETURN
            ELSE
               DO 2169 II=I+1,M
               J=J+1
               NBITP(J)=NBITP(II)
               NWORDP(J)=NWORDP(II)
               NWTR(J)=NWTR(II)
               NWTS(J)=NWTS(II)
               NWTRV(J)=NWTRV(II)
               NWTDW(J)=NWTDW(II)
               NWTEN(J)=NWTEN(II)
               CWTEN(J)=CWTEN(II)
               CWTU(J)=CWTU(II) 
 2169          CONTINUE
               M=J
               GO TO 220
            END IF
         END IF
C
 215     CONTINUE
C
         KERR=39
         CALL BUERR(KERR)
         RETURN
      ELSE
         KERR=40
         CALL BUERR(KERR)
         RETURN
      END IF
C
C
C*          2.2 CREATE INDECES TO CLASS 7/8
C               ---------------------------
 220  CONTINUE
C
      DO 225 I=1,M
      IF(NWTR(I).GT.200000.AND.
     1   NWTR(I).NE.999999) THEN
         MREL=I-1
         GO TO 226
      END IF
 225  CONTINUE
C
      MREL=M
C
 226  CONTINUE
C
      J=0
      JJ=0
      DO 221 I=1,MREL
      ICLASS=NWTR(I)/1000
      IF(ICLASS.EQ.7) THEN
         J=J+1
         IC7(J)=I
      END IF
C
      IF(ICLASS.EQ.8) THEN
         JJ=JJ+1
         IC8(JJ)=I
      END IF
 221  CONTINUE
C
      IC7L=J
      IC8L=JJ
      J=0
      JJ=0
      DO 223 I=1,NRQL
      ICLASS=NRQ(I)/1000
      IF(ICLASS.EQ.7.AND.(ABS(RQVAL(I)-RVIND)/RVIND.GT.EPS)) THEN
         J=J+1
         IC7R(J)=I
      END IF
C
      IF(ICLASS.EQ.8.AND.(ABS(RQVAL(I)-RVIND)/RVIND.GT.EPS)) THEN
         JJ=JJ+1
         IC8R(JJ)=I
      END IF
 223  CONTINUE
C
      IC7RL=J
      IC8RL=JJ
C
C*          2.3 CREATE INDECES TO THE REQUESTED ELEMENTS.
C               -----------------------------------------
 230  CONTINUE
C
      IF(IC7RL.EQ.0.AND.IC8RL.EQ.0) THEN
         IL=MREL
         IRL=NRQL
      END IF
      IF(IC7RL.NE.0.AND.IC8RL.EQ.0) THEN
         IL=IC7(1)
         IRL=IC7R(1)-1
      END IF
      IF(IC8RL.NE.0.AND.IC7RL.EQ.0) THEN
         IL=IC8(1)
         IRL=IC8R(1)-1
      END IF
      IF(IC7RL.NE.0.AND.IC8RL.NE.0) THEN
         IL=IC7(1)
         IF(IC7(1).GT.IC8(1)) IL=IC8(1)
         IRL=IC7R(1)
         IF(IC7R(1).GT.IC8R(1)) IRL=IC8R(1)
         IRL=IRL-1
      END IF
C
      DO 299 I=1,MREL
      IRQEI(I)=0
 299  CONTINUE
C
      ORQEI=.FALSE.
      DO 231 I=1,IL
      IF(IB2.EQ.0.OR.NRQL.EQ.0) THEN
         ORQEI=.TRUE.
         IRQEI(I)=I
      ELSE
         DO 232 K=1,IRL
         IF(NWTR(I).EQ.NRQ(K)) THEN
            ORQEI=.TRUE.
            IRQEI(I)=I
         END IF
 232     CONTINUE
      END IF
 231  CONTINUE
C
      IF(IC7RL.NE.0) THEN
C
C        CLASS 7 SIGNIFYING
C
         IST=1
         DO 233 IJ=1,IC7RL
         III=IC7R(IJ)
         DO 234 I=IST,IC7L
         II=IC7(I)
         IBITP=NBITP(II)
         IWORD=NWORDP(II)

         CALL BUNPCK(NBPW,KBUFF,IVAL,IWORD,IBITP,NWTDW(II),KERR)
         IF(KERR.NE.0) THEN
            CALL BUERR(KERR)
            RETURN
         END IF
         CALL BUNPCK(NBPW,KBUFF,IDWINC,IWORD,IBITP,6,KERR)
         IF(KERR.NE.0) THEN
            CALL BUERR(KERR)
            RETURN
         END IF
         CALL BUNPCK(NBPW,KBUFF,INC,IWORD,IBITP,IDWINC,KERR)
         IF(INC.EQ.NMASK(IDWINC)) IVAL=NMASK(NWTDW(II))
C
         IF(IVAL.NE.NMASK(NWTDW(II))) THEN
            ISCALE=NWTS(II)
            IREF  =NWTRV(II)
            IVAL  =IVAL+IREF+INC
            VAL   =RVIND
            IF(IVAL.NE.NMASK(NWTDW(II))) THEN
               IF(ISCALE.GT.0) THEN
                  VAL=IVAL/10.**ISCALE
               ELSE
                  IISCALE=IABS(ISCALE)
                  VAL=IVAL*10.**IISCALE
               END IF
            END IF
         ELSE
            VAL=RVIND
         END IF
C
         INEXT=IC7(I+1)-1
         IF(IC7(I+1).LE.0) INEXT=MREL
         IF(ABS(RQVAL(III)-VAL).LT.EPS.OR.
     1      ABS(RQVAL(III)-RVIND)/RVIND.LT.EPS) THEN
            DO 236 KI=II,INEXT
            IF(IB2.EQ.0) THEN
               ORQEI=.TRUE.
               IRQEI(KI)=KI
            ELSE
               IE=IC7R(IJ+1)-1
               IF(IJ.EQ.IC7RL) IE=NRQL
               IF(IC8RL.NE.0) THEN
                  DO 238 JA=1,IC8RL
                  IF(IC8R(JA).GT.III.AND.IC8R(JA).LT.IE) THEN
                     IE=IC8R(JA)-2
                     GO TO 298
                  END IF
 238              CONTINUE
               END IF
 298           CONTINUE
               DO 237 IK=III,IE
               IF(NWTR(KI).EQ.NRQ(IK)) THEN
                  ORQEI=.TRUE.
                  IRQEI(KI)=KI
               END IF
 237           CONTINUE
            END IF
 236        CONTINUE
C
            GO TO 233
         END IF
 234     CONTINUE
 233     CONTINUE
C
      END IF
C
      IF(IC8RL.NE.0) THEN
C
C        CLASS 8 SIGNIFYING
C
         IST=1
         DO 241 IJ=1,IC8RL
         III=IC8R(IJ)
         DO 242 I=IST,IC8L
         II=IC8(I)
         IBITP=NBITP(II)
         IWORD=NWORDP(II)
         CALL GBYTE(KBUFF(IWORD),IVAL,IBITP,NWTDW(II))
         ISCALE=NWTS(II)
         IREF  =NWTRV(II)
         IVAL  =IVAL+IREF
         VAL   =RVIND
         IF(IVAL.NE.NMASK(NWTDW(II))) THEN
            IF(ISCALE.GT.0) THEN
               VAL=IVAL/10.**ISCALE
            ELSE
               IISCALE=IABS(ISCALE)
               VAL=IVAL*10.**IISCALE
            END IF
         END IF
C
         INEXT=IC8(I+1)-2
         IF(IC8(I+1).EQ.0) INEXT=MREL
C
         OT=.FALSE.
         IF(ABS(VAL-RVIND)/RVIND.LT.EPS) THEN
            IVAL=NINT(VAL)
            IRQV=NINT(RQVAL(III))
C
            IF(NWTR(II).EQ.008001) THEN
               OT=.TRUE.
               IF(IAND(IVAL,IRQV).NE.IRQV) OT=.FALSE.
            ELSE
               OT=.TRUE.
               IF(ABS(VAL-RQVAL(III)).GT.EPS) OT=.FALSE.
            END IF
         END IF
C
         IF(OT) THEN
            ICL=NWTR(II-1)/1000
            IF(ICL.EQ.7) IRQEI(II-1)=II-1
            DO 244 KI=II,INEXT
            IF(IB2.EQ.0) THEN
               ORQEI=.TRUE.
               IRQEI(KI)=KI
            ELSE
               IE=IC8R(IJ+1)-1
               IF(IJ.EQ.IC8RL) IE=NRQL
               IF(IC7RL.NE.0) THEN
                  DO 248 JA=1,IC7RL
                  IF(IC7R(JA).GT.III.AND.IC7R(JA).LT.IE) THEN
                     IE=IC7R(JA)-1
                     GO TO 297
                  END IF
 248              CONTINUE
               END IF
 297           CONTINUE
               DO 245 IK=III,IE
               IF(NWTR(KI).EQ.NRQ(IK)) THEN
                 ORQEI=.TRUE.
                 IRQEI(KI)=KI
               END IF
 245           CONTINUE
            END IF
 244        CONTINUE
C
         END IF
 242     CONTINUE
 241     CONTINUE
C
      END IF
C
      IF(.NOT.ORQEI) THEN
         KERR=45
         CALL BUERR(KERR)
         M=0
         RETURN
      END IF
C
C
C
C*          3. FIND POINTERS TO QUALITY CONTROL,START OF DATA
C               ----------------------------------------------
C               PRESENT INDICATORS AND %CONFIDENCE.
C               -----------------------------------
C
 300  CONTINUE
C
      I=0
      IF(IB3.NE.0) THEN
         I=I+1
         ITYPE(I)=222000
      END IF
C
      IF(IB4.NE.0) THEN
         I=I+1
         ITYPE(I)=224000
      END IF
C
      IF(IB5.NE.0) THEN
         I=I+1
         ITYPE(I)=225000
      END IF
C
      IF(IB6.NE.0) THEN
         I=I+1
         ITYPE(I)=223000
      END IF
C
      KEND=I
      IF(KEND.EQ.0) THEN
         J=0
         DO 4011 I=1,MREL
         IF(IRQEI(I).NE.0) THEN
            II=IRQEI(I)
            J=J+1
            INWORDP(J)=NWORDP(II)
            INBITP(J)=NBITP(II)
            INWTR(J)=NWTR(II)
            INWTS(J)=NWTS(II)
            INWTRV(J)=NWTRV(II)
            INWTDW(J)=NWTDW(II)
            INWTEN(J)=NWTEN(II)
            CNAMES(J)=CWTEN(II)
            CUNITS(J)=CWTU(II)
         END IF
 4011    CONTINUE
         GO TO 900
      END IF
C
      OLIST=.FALSE.
      O236=.FALSE.
      O237=.FALSE.
C
      DO 500 KT=1,KEND
         JQPR=0
         JQUA=0
         JQCA=0
         JQC =0
         JQCC=0
         JQCS=0
         KM=MREL
C
C
C        FIND POINTERS TO OPERATORS
C
         KZ=0
         DO 3031 I=KM,M
         IF(NWTR(I).EQ.ITYPE(KT)) THEN
            KZ=KZ+1
            NQP(KZ)=I
         END IF
 3031    CONTINUE
C
         IF(KZ.EQ.0) THEN
            WRITE(KNTN,*) ITYPE(KT),' NOT PRESENT IN THIS MESSAGE.'
            GO TO 500
         ELSE
            KZ=KZ+1
            NQP(KZ)=M
         END IF
C
         DO 3033 KQ=1,KZ-1
C
         JQUA=NQP(KQ)
C
         IF(NWTR(JQUA+1).EQ.236000) THEN
            JQ236=JQUA+1
            O236=.TRUE.
         END IF
C
         IF(NWTR(JQUA+1).EQ.237000) THEN
            JQ237=JQUA+1
            O237=.TRUE.
         ELSE
            O237=.FALSE.
         END IF
C
C
C        DATA PRESENT INDICATOR
C
         IF(.NOT.O236.AND.O237) THEN
C
C           FIND LAST DEFINED BIT MAP
C
            DO 420 I=JQUA,MREL,-1
            IF(NWTR(I).EQ.236000) GO TO 421
 420        CONTINUE
C
            KERR=41
            CALL BUERR(KERR)
            RETURN
C
 421        CONTINUE
C
            O236=.TRUE.
            O237=.FALSE.
            JQ236=I
            JQ237=0
            IK=I
            IDPRF=0
            DO 3015 I=IK,M
            IF(NWTR(I).EQ.31031.OR.NWTR(I).EQ.31192) THEN
               IDPRF=IDPRF+1
               IF(IDPRF.EQ.1) JQPR=I
            ELSE
               IF(IDPRF.NE.0) GO TO 30111
            END IF
 3015       CONTINUE
C
 3016       CONTINUE
         END IF
C
C        DATA PRESENT INDICATOR
C
         IF(.NOT.O237) THEN
            IDPRF=0
            DO 301 I=JQUA,NQP(KQ+1)
            IF(NWTR(I).EQ.31031.OR.NWTR(I).EQ.31192) THEN
               IDPRF=IDPRF+1
               IF(IDPRF.EQ.1) JQPR=I
            ELSE
               IF(IDPRF.NE.0) GO TO 30111
            END IF
 301        CONTINUE
         END IF
C
30111   CONTINUE
C
C        GENERATING CENTRE
C
         DO 309 I=JQUA,NQP(KQ+1)
         IF(NWTR(I).EQ.1031) THEN
            JQCC=I
            GO TO 302
         END IF
 309     CONTINUE
C
 302     CONTINUE
C
C        GENERATING APPLICATION
C
         DO 307 I=JQUA,NQP(KQ+1)
         IF(NWTR(I).EQ.1032.OR.NWTR(I).EQ.1201.OR.
     1      NWTR(I).EQ.63191) THEN
            JQCA=I
            GO TO 3071
         END IF
 307     CONTINUE
C
 3071    CONTINUE
C
C        PERCENTAGE CONFIDENCE
C
         IF(ITYPE(KT).EQ.222000) THEN
            DO 305 I=JQUA,NQP(KQ+1)
            IF(NWTR(I)/1000.EQ.33.OR.NWTR(I).EQ.63192) THEN
               JQC=I
               GO TO 306
            END IF
 305        CONTINUE
         ELSE
C           SIGNIFICANCE
C
            DO 308 I=JQUA,NQP(KQ+1)
            IF(NWTR(I)/1000.EQ.8) THEN
               JQCS=I
               GO TO 3088
            END IF
 308        CONTINUE
C
 3088       CONTINUE
C
            DO 3051 I=JQUA,NQP(KQ+1)
            IF(NWTR(I).EQ.223255.OR.NWTR(I).EQ.224255.OR.
     1         NWTR(I).EQ.225255) THEN
               JQC=I
               GO TO 306
            END IF
 3051       CONTINUE
         END IF
C
C
 306     CONTINUE
C
C*          3.1  SET INDICES TO GET Q/C.
C                GET BIT MAP FROM DATA SECTION.
C
 310  CONTINUE
C
         IF(JQUA.EQ.0) THEN
            WRITE(KNTN,'(1H )')
        WRITE(KNTN,'(1H ,A)') 'Q/C NOT PRESENT IN THIS BUFR MESSAGE.'
            WRITE(KNTN,'(1H )')
         ELSE
C
            IF(.NOT.O237) THEN
C
               KAK=0
               IQPR=JQPR-1
               DO 311 K=1,IDPRF
               IQPR=IQPR+1
               KAK=KAK+1
               IWPT=NWORDP(IQPR)
               IBPT=NBITP (IQPR)
               CALL GBYTE(KBUFF(IWPT),IBVAL(KAK),IBPT,1)
 311           CONTINUE
            END IF
C
            IDIF=MREL-IDPRF
C
            JS=0
            IF(IDIF.NE.0) THEN
               DO 313 I=1,IDIF
               JS=JS+1
               IQCDPI(JS)=0
 313           CONTINUE
            END IF
C
            JQPRM1=JQPR-1
            DO 314 I=1,IDPRF
            JS=JS+1
            IQCDPI(JS)=I+JQPRM1
 314        CONTINUE
C
            JS=0
            IF(IDIF.NE.0) THEN
               DO 315 I=1,IDIF
               JS=JS+1
               IQCI(JS)=0
 315           CONTINUE
            END IF
C
            K=JQC-1
            DO 317 I=1,IDPRF
            OK=.TRUE.
            JS=JS+1
            IQCI(JS)=0
            IF(IBVAL(I).EQ.0) THEN
               IF(OK) K=K+1
               IQCI(JS)=K
               OK=.FALSE.
            END IF
 317        CONTINUE
C
         END IF
C
C
C*          4.  CREATE REQUESTED ELEMENT LIST.
C               ------------------------------
 400  CONTINUE
C
      IF(.NOT.OLIST) THEN
         IF(NREQ(2).EQ.0) NRQL=0
         J=0
         DO 401 I=1,MREL
         IF(IRQEI(I).NE.0) THEN
            II=IRQEI(I)
            J=J+1
            INBITP(J)=NBITP(II)
            INWORDP(J)=NWORDP(II)
            INWTR(J)  =NWTR(II)
            INWTS(J)  =NWTS(II)
            INWTRV(J) =NWTRV(II)
            INWTDW(J) =NWTDW(II)
            INWTEN(J) =NWTEN(II)
            CNAMES(J)=CWTEN(II)
            CUNITS(J)=CWTU(II)
            OLIST=.TRUE.
         END IF
 401     CONTINUE
      END IF
C
      IF(JQUA.NE.0) THEN
C
C*          4.1 ADD DATA PRESENT INDICATOR AND Q/C.
C               -----------------------------------
 410     CONTINUE
C
C                  ADD OPERATOR 222000
         J=J+1
         INWORDP(J)=NWORDP(JQUA)
         INBITP (J)=NBITP (JQUA)
         INWTR(J)  =NWTR(JQUA)
         INWTS(J)  =NWTS(JQUA)
         INWTRV(J) =NWTRV(JQUA)
         INWTDW(J) =NWTDW(JQUA)
         INWTEN(J) =NWTEN(JQUA)
         CNAMES(J)=CWTEN(JQUA)
         CUNITS(J)=CWTU(JQUA)
C
         IF(O236.AND..NOT.O237) THEN
            J=J+1
            INWORDP(J)=NWORDP(JQ236)
            INBITP (J)=NBITP (JQ236)
            INWTR(J)  =NWTR(JQ236)
            INWTS(J)  =NWTS(JQ236)
            INWTRV(J) =NWTRV(JQ236)
            INWTDW(J) =NWTDW(JQ236)
            INWTEN(J) =NWTEN(JQ236)
            CNAMES(J)=CWTEN(JQ236)
         END IF
C
         IF(O237) THEN
            J=J+1
            INWORDP(J)=NWORDP(JQ237)
            INBITP (J)=NBITP (JQ237)
            INWTR (J) =NWTR (JQ237)
            INWTS (J) =NWTS (JQ237)
            INWTRV(J) =NWTRV(JQ237)
            INWTDW(J) =NWTDW(JQ237)
            INWTEN(J) =NWTEN(JQ237)
            CNAMES(J)=CWTEN(JQ237)
            CUNITS(J)=CWTU (JQ237)
         END IF
C
         IF(.NOT.O237) THEN 
            DO 412 I=1,MREL
            IF(IRQEI(I).NE.0) THEN
               IF(IQCDPI(I).NE.0) THEN
                  J=J+1
                  INWORDP(J)=NWORDP(IQCDPI(I))
                  INBITP (J)=NBITP (IQCDPI(I))
                  INWTR(J)  =NWTR(IQCDPI(I))
                  INWTS(J)  =NWTS(IQCDPI(I))
                  INWTRV(J) =NWTRV(IQCDPI(I))
                  INWTDW(J) =NWTDW(IQCDPI(I))
                  INWTEN(J) =NWTEN(IQCDPI(I))
                  CNAMES(J)=CWTEN(IQCDPI(I))
                  CUNITS(J)=CWTU(IQCDPI(I))
               END IF
            END IF
 412        CONTINUE
         END IF
C
C
C        GENERATING CENTRE
C
         IF(JQCC.NE.0) THEN
            J=J+1
            INWORDP(J)=NWORDP(JQCC)
            INBITP (J)=NBITP (JQCC)
            INWTR(J)  =NWTR(JQCC)
            INWTS(J)  =NWTS(JQCC)
            INWTRV(J) =NWTRV(JQCC)
            INWTDW(J) =NWTDW(JQCC)
            INWTEN(J) =NWTEN(JQCC)
            CNAMES(J)=CWTEN(JQCC)
            CUNITS(J)=CWTU(JQCC)
         END IF
C
C        Q/C APPLICATION
C
         IF(JQCA.NE.0) THEN
            J=J+1
            INWORDP(J)=NWORDP(JQCA)
            INBITP (J)=NBITP (JQCA)
            INWTR(J)  =NWTR(JQCA)
            INWTS(J)  =NWTS(JQCA)
            INWTRV(J) =NWTRV(JQCA)
            INWTDW(J) =NWTDW(JQCA)
            INWTEN(J) =NWTEN(JQCA)
            CNAMES(J)=CWTEN(JQCA)
            CUNITS(J)=CWTU(JQCA)
         END IF
C
C        SIGNIFICANCE
C
         IF(JQCS.NE.0) THEN
            J=J+1
            INWORDP(J)=NWORDP(JQCS)
            INBITP (J)=NBITP (JQCS)
            INWTR(J)  =NWTR(JQCS)
            INWTS(J)  =NWTS(JQCS)
            INWTRV(J) =NWTRV(JQCS)
            INWTDW(J) =NWTDW(JQCS)
            INWTEN(J) =NWTEN(JQCS)
            CNAMES(J)=CWTEN(JQCS)
            CUNITS(J)=CWTU(JQCS)
         END IF
C
C
C        CLASS 33 ELEMENTS
C
         DO 415 I=1,MREL
         IF(IRQEI(I).NE.0) THEN
            OK=.TRUE.
            IF(IQCI(I).NE.0) THEN
               IF(OK) J=J+1
               OK=.FALSE.
               INWORDP(J)=NWORDP(IQCI(I))
               INBITP (J)=NBITP (IQCI(I))
               INWTR(J)  =NWTR  (IQCI(I))
               INWTS(J)  =NWTS  (IQCI(I))
               INWTRV(J) =NWTRV (IQCI(I))
               INWTDW(J) =NWTDW (IQCI(I))
               INWTEN(J) =NWTEN (IQCI(I))
               CNAMES(J)=CWTEN (IQCI(I))
               CUNITS(J)=CWTU  (IQCI(I))
            END IF
         END IF
 415     CONTINUE
      END IF
 3033 CONTINUE
C
C
C*          5. MAKE ONE TO ONE CORRESPONDENCE BETWEEN ELEMENTS AND
C              Q/C,STATISTICS,DIFFERENCE STATISTICS OR SUBSTITUTED VALUES
C              LEAVING BEHIND DATA PRESENT INDICATORS.
 500  CONTINUE
C
C
C*          9.  UPDATE TOTAL NUMBER OF ELEMENTS.
C               --------------------------------
 900  CONTINUE
C
      M=J
      NFCM=1
      NFUCM=0
C
      RETURN
C
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C


      SUBROUTINE FTN1CR ( KNUM , KPR ,KRET )
C
C---->
C**** FTN1CR
C
C     PURPOSE.
C     --------
C
C           GIVES FORTRAN UNIT NUMBER NOT CURRENTLY IN USE.
C
C**   INTERFACE.
C     ----------
C
C           CALL FTN1CR ( KNUM , KPR ,KRET )
C
C           INTEGER    K.
C           REAL       P.
C           LOGICAL    O.
C           CHARACTER  H.
C
C               INPUT PARAMETERS.
C               -----------------
C
C               KPR        - DEBUG PRINT SWITCH.
C                            0 , NO PRINTOUT.
C                            1 , DEBUG PRINTOUT.
C
C               OUTPUT PARAMETERS.
C               ------------------
C
C               KNUM       - FREE FORTRAN UNIT NUMBER.
C               KRET       - ERROR RETURN CODE.
C                            0   , NO ERROR ENCOUNTERED.
C                            1   , NO UNIT NUMBER FREE.
C
C     METHOD.
C     -------
C
C           INQUIRE STATEMENT ON CRAY ALIAS USED.
C
C     EXTERNALS.
C     ----------
C
C           NONE.
C
C     REFERENCE.
C     ----------
C
C           NONE.
C
C     COMMENTS.
C     ---------
C
C           ROUTINE CONTAINS SECTIONS 0 , 2  AND SECTION 9.
C
C     AUTHOR.
C     -------
C
C           J. HENNESSY      ECMWF      12.07.89.
C
C     MODIFICATIONS
C     --------------
C
C           NONE.
C
C----<
C     ----------------------------------------------------------------
C
C
C
C
C
C
C
C
C
C
C*    SECTION 0 . DEFINITION OF VARIABLES.
C     ----------------------------------------------------------------
C
      IMPLICIT LOGICAL     ( L, O, G )
      IMPLICIT CHARACTER*8 ( C, H, Y )
      IMPLICIT INTEGER     ( I, J, K, M, N )
C
C
C     ----------------------------------------------------------------
C
C
C
C
C
C
C
C
C
C*    SECTION 1 . SET INITIAL VALUES.
C     ----------------------------------------------------------------
C
 1000 CONTINUE
C
      IF (KPR.EQ.1) WRITE (*,*) 'FTN1CR : SECTION 1.'
C
      KRET = 0
C
C
C     ----------------------------------------------------------------
C
C
C
C
C
C
C
C
C
C*    SECTION 2 . INQUIRE FOR FREE UNIT.
C     ----------------------------------------------------------------
C
 2000 CONTINUE
C
      IF (KPR.EQ.1) WRITE (*,*) 'FTN1CR : SECTION 2.'
C
      DO 2010 J2010 = 99,1,-1
         IF (J2010.EQ.5) GO TO 2010
         IF (J2010.EQ.6) GO TO 2010
         WRITE (YALIAS,'(A,I2.2)') 'FT',J2010
         INQUIRE (FILE=YALIAS,EXIST=LEX)
         IF (LEX) GO TO 2010
         KNUM = J2010
         GO TO 2050
 2010 CONTINUE
C
C     NO FREE UNIT FOUND.
C
      KRET = 1
C
      WRITE (*,9001)
C
 2050 CONTINUE
C
      IF (KPR.EQ.1) WRITE (*,9002) KNUM
C
      GO TO 9000
C
C
C     ----------------------------------------------------------------
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C*    SECTION 9 . RETURN TO CALLING ROUTINE. FORMAT STATEMENTS.
C     ------------------------------------------------------------------
C
 9000 CONTINUE
C
      IF (KPR.EQ.1) WRITE (*,*) 'FTN1CR : SECTION 9.'
C
C
      RETURN
C
C
 9001 FORMAT (1H ,'FTN1CR : NO FORTRAN UNIT AVAILABLE.')
C
 9002 FORMAT (1H ,'FTN1CR : FORTRAN UNIT ALLOCATED = ',I3)
C
C
C     ------------------------------------------------------------------
C
C
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE MKFRAME(KWE,KNS,ZSEC4,ZMISS,KFRAME)
C
C---->
C**** MKFRAME
C
C     Purpose
C     -------
C
C     Remove points from inside a frame boundary.
C
C
C     Interface
C     ---------
C
C     CALL  MKFRAME(KWE,KNS,ZSEC4,ZMISS,KFRAME)
C
C     Input
C     -----
C
C     KWE    - Number of points west-east in input field.
C     KNS    - Number of points north-south in input field.
C     ZSEC4  - GRIBEX section 4 values in the field.
C     ZMISS  - Value to be used as the missing data value..
C     KFRAME - Number of points across the frame.
C
C
C     Output
C     ------
C
C     ZSEC4  - GRIBEX section 4 values with the points inside the frame
C              replaced by missing data values.
C
C
C     Method
C     ------
C
C     The field and frame are rectangular.
C
C
C     Externals
C     ---------
C
C     INTLOG  - Log error message.
C     INTLOGR - Log error message.
C
C
C     Author
C     ------
C
C     J.D.Chambers     ECMWF     May 1999.
C
C----<
C
      IMPLICIT NONE
C
C     Subroutine arguments
C
      INTEGER KWE,KNS, KFRAME
      REAL ZSEC4(*), ZMISS
C
C     Local variables
C
      INTEGER TOP, BOTTOM, LEFT, RIGHT, LOOPO, LOOPI, NEXT
C
#include "parim.h"
#include "jparams.h"
C
C ------------------------------------------------------------------
C*    Section 1.   Initialise
C ------------------------------------------------------------------
C
  100 CONTINUE
C
      IF( KFRAME.LT.1 ) GOTO 900
C
      TOP    = KFRAME + 1
      BOTTOM = KNS - KFRAME
      LEFT   = KFRAME + 1
      RIGHT  = KWE - KFRAME
C
      IF( NDBG.GT.0 ) THEN
        CALL INTLOG(JP_DEBUG,'MKFRAME: KFRAME = ', KFRAME)
        CALL INTLOG(JP_DEBUG,'MKFRAME: TOP = ', TOP)
        CALL INTLOG(JP_DEBUG,'MKFRAME: BOTTOM = ', BOTTOM)
        CALL INTLOG(JP_DEBUG,'MKFRAME: LEFT = ', LEFT)
        CALL INTLOG(JP_DEBUG,'MKFRAME: RIGHT = ', RIGHT)
        CALL INTLOGR(JP_DEBUG,'MKFRAME: ZMISS = ', ZMISS)
      ENDIF
C
      DO LOOPO = TOP, BOTTOM
        NEXT = (LOOPO-1)*KWE + (LEFT-1)
        DO LOOPI = LEFT, RIGHT
          NEXT = NEXT + 1
          ZSEC4(NEXT) = ZMISS
        ENDDO
      ENDDO
C
C ------------------------------------------------------------------
C*    Section 9.   Closedown.
C ------------------------------------------------------------------
C
  900 CONTINUE
C
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE HPSHGPW(OLDLON,OLDLAT,NEWLON,NEWLAT,
     X                   PDIRI,NUMPTS,POLE)
C
C---->
C**** HPSHGPW
C
C     Purpose
C     -------
C
C     Rotates a grid of points about the y-axis and calculates the
C     angular change between local axes at each grid point.
C
C
C     Interface
C     ---------
C
C     CALL HPSHGPW(OLDLON,OLDLAT,NEWLON,NEWLAT,PDIRI,NUMPTS,POLE)
C
C     Input
C     -----
C
C     OLDLON - Array of longitudes to be rotated (degrees)
C     OLDLAT - Array of latitudes to be rotated (degrees)
C     NUMPTS - Number of gridpoints to be rotated
C     PDIRI  - Array of initial orientation angles, eg wind directions
C              (degrees)
C     POLE   - (Lat,long) of new south pole, measured in old grid
C
C
C     Output
C     ------
C
C     NEWLON - Array of rotated longitudes (degrees, -180 < angle <= 180 )
C     NEWLAT - Array of rotated latitudes (degrees)
C     PDIRI  - Array of modified orientation angles, changed to allow for
C              the angles between coordinate axes at each point before and
C              after rotation (degrees, -180 < angle <= 180 )
C
C
C     Method
C     ------
C
C     Rotates a grid of points about the y-axis and calculates the
C     angular change to local axes at each grid point.
C
C     The z-axis is the polar axis, increasing from south to north.
C     The x-axis is line from the centre of the globe through (0N, 0E),
C     increasing from the centre out to (0N, 0E).
C     The y-axis is line from the centre of the globe through (0N, 90E),
C     increasing from the centre out to (0N, 90E).
C
C     The sign of the angular change between local axes at each grid point
C     is such that it denotes the angle of rotation to be applied to the
C     old coordinate system to let its axes coincide with the new one. The
C     angle is measured in the old coordinate system, so increments to
C     angles in PDIRI are positive for anti-clockwise rotation from old
C     x-axis to new one.
C
C     As a consequence, if the initial values in PDIRI are wind directions
C     ddd in the old coordinate system (measured to conform to meteorological
C     use), the output values of PDIRI will be ddd in the new coordinate system
C     (modulo 360).
C
C     Note that the meteorological use of ddd has effectively the opposite
C     sign to the mathematically usual way of defining angles.
C
C     The angles between the coordinate axes at each point may be obtained
C     by calling the routine with the values in PDIRI all set to zero on input.
C
C
C     Externals
C     ---------
C
C     None.
C
C
C     Author
C     ------
C
C     G.J.Cats            15 DEC 88.
C
C
C     Modified
C     --------
C
C     P.O'Sullivan        30/3/93 (wind and nonwind)
C
C     J.D.Chambers        October 1999
C
C
C----<
C     -----------------------------------------------------------------|
C
      IMPLICIT NONE
C
C     Parameters
C
      REAL EPSILON
      PARAMETER( EPSILON = 1E-5)
C                 `---------------> tolerance used for checking
C                                   proximity to +/-90.0 and 180.0
C
C     Subroutine arguments
C
      REAL OLDLON, OLDLAT, NEWLON, NEWLAT, PDIRI, POLE(2)
      DIMENSION OLDLON(*), OLDLAT(*), NEWLON(*), NEWLAT(*), PDIRI(*)
      INTEGER NUMPTS
C
C     Local variables
C
      INTEGER NXTPT
      REAL SINTHE, COSTHE, THETA
      REAL ZLAT, SINLAT, COSLAT
      REAL ZLON, SINLON, COSLON
      REAL ZNEW, LATNEW, NCOSLAT, COSNEW, LONNEW, COSDEL, DELTA, ZDIV
C
C     Statement functions
C
      REAL A
      REAL RADIAN, DEGREE, NORMAL
      REAL LONGMOD
C
C     Convert degrees to radians
C
      RADIAN(A) = (A) * 0.01745329252
C
C     Convert radians to degrees
C
      DEGREE(A) = (A) * 57.295779513
C
C     Normalise value such as sin or cos to range (-1,1)
C
      NORMAL(A) = MAX(MIN((A),1.0),-1.0)
C
C     -----------------------------------------------------------------|
C*    Section 1.   Initialise
C     -----------------------------------------------------------------|
C
      LONGMOD = -POLE(2)
      THETA  = RADIAN(POLE(1))
      SINTHE = -SIN(THETA)
      COSTHE = -COS(THETA)
C
C     -----------------------------------------------------------------|
C*    Section 2.   Handle each point separately (longitude,latitude)
C     -----------------------------------------------------------------|
C
      DO NXTPT = 1, NUMPTS
C
        ZLAT   = RADIAN(OLDLAT(NXTPT))
        SINLAT = SIN(ZLAT)
        COSLAT = COS(ZLAT)
C
        ZLON = OLDLON(NXTPT) + LONGMOD
        IF( ZLON.GT.180.0 ) ZLON = ZLON - 360.0
        IF( ABS(ZLON + 180.0).LT.EPSILON ) ZLON = 180.0
        ZLON   = RADIAN(ZLON)
        SINLON = SIN(ZLON)
        COSLON = COS(ZLON)
C
C       Calculate z coordinate of point after rotation and hence
C       its latitude after rotation since:
C         z = sin(lat)
C
        ZNEW = SINTHE*SINLAT+COSTHE*COSLAT*COSLON
        ZNEW = NORMAL(ZNEW)
        IF( ABS(ZNEW -1.0).LT.EPSILON ) Then
          LATNEW = 1.5707963268
          NEWLAT(NXTPT) = 90.0
          NCOSLAT = 0.0
        ELSE IF( ABS(ZNEW +1.0).LT.EPSILON ) THEN
          LATNEW = -1.5707963268
          NEWLAT(NXTPT) = -90.0
          NCOSLAT = 0.0
        ELSE
          LATNEW = ASIN(ZNEW)
          NEWLAT(NXTPT) = DEGREE(LATNEW)
          NCOSLAT = COS(LATNEW)
        ENDIF
C
C       Calculate x coordinate of point after rotation and hence
C       its longitude after rotation since:
C         x = cos(lat).cos(lon)
C         cos(lon) = x / cos(lat)
C
        IF( NCOSLAT.EQ.0.0 ) NCOSLAT = 1.0
        ZDIV = 1.0 / NCOSLAT
C
        COSNEW = ( (SINTHE*COSLAT*COSLON-COSTHE*SINLAT) ) * ZDIV
        COSNEW = NORMAL(COSNEW)
        LONNEW = SIGN(ACOS(COSNEW),ZLON)
        NEWLON(NXTPT) = DEGREE(LONNEW)
C
C       Use cosine rule from spherical trigonometry to find angle
C       between the directions of the meridians before and after
C       rotation.
C
        COSDEL = SINTHE*SINLON*SIN(LONNEW)+COSLON*COSNEW
        COSDEL = NORMAL(COSDEL)
        DELTA  = SIGN(ACOS(COSDEL),-COSTHE*ZLON)
C
C       Change the orientation angle (keep it in the range -180 to 180)
C
        PDIRI(NXTPT) = PDIRI(NXTPT) - DEGREE(DELTA)
        IF( PDIRI(NXTPT).GT.180.0 ) PDIRI(NXTPT) = PDIRI(NXTPT) - 360.0
        IF( PDIRI(NXTPT).LE.-180.0) PDIRI(NXTPT) = PDIRI(NXTPT) + 360.0
C
      ENDDO
C
C     -----------------------------------------------------------------|
C*    Section 9.   Closedown.
C     -----------------------------------------------------------------|
C
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      INTEGER FUNCTION OCEANP( INOCEAN, INLEN, OTOCEAN, OUTLEN)
C
C---->
C**** OCEANP
C
C     Purpose
C     -------
C
C     Interpolate GRIB format input ocean field to GRIB format ocean
C     field.
C
C
C     Interface
C     ---------
C
C     IRET = OCEANP( INOCEAN, INLEN, OTOCEAN, OUTLEN)
C
C     Input
C     -----
C
C     INOCEAN - Input ocean field  (GRIB format).
C     INLEN   - Input field length (words).
C
C
C     Output
C     ------
C
C     OTOCEAN - Output ocean field  (GRIB format).
C     OUTLEN  - Output field length (words).
C
C
C     Method
C     ------
C
C     Interpolate ocean field.
C
C     If requested X grid increment does not match input GRIB
C     increment, do a full interpolation in both x and y. Otherwise,
C     interpolate only to make grid regular.
C
C     Externals
C     ---------
C
C     JDEBUG  - Tests if debug output required.
C     GRIBEX  - GRIB decoding/encoding.
C     INTLOG  - Log error message.
C     JMEMHAN - Allocate/deallocate scratch memory.
C     INTOCN  - Carry out ocean field to field interpolation.
C
C
C     Author
C     ------
C
C     J.D.Chambers     ECMWF     May 1996
C
C     J.D.Chambers     ECMWF        Feb 1997
C     Allow for 64-bit pointers
C
C     J.D.Chambers     ECMWF        Mar 1997
C     Allow for full or partial interpolation
C     (F or R option in call to INTOCN).
C
C----<
C
      IMPLICIT NONE
C
C     Function arguments
C
      INTEGER INOCEAN, INLEN, OTOCEAN, OUTLEN
C
#include "parim.h"
#include "nifld.common"
#include "nofld.common"
#include "intf.h"
C
C     Parameters
C
      INTEGER JPROUTINE, JPALLOC, JPDEALL, JPSCR3, JPSCR4
      INTEGER JP_LAT, JP_LONG, JP_GUESS
      PARAMETER (JPROUTINE = 36900 )
      PARAMETER (JPALLOC = 1) 
      PARAMETER (JPDEALL = 0) 
      PARAMETER (JPSCR3 = 3) 
      PARAMETER (JPSCR4 = 4) 
      PARAMETER (JP_LONG = 3) 
      PARAMETER (JP_LAT  = 4) 
      PARAMETER (JP_GUESS  = 18049691) 
cs    PARAMETER (JP_GUESS  = 1675245) 
cs    PARAMETER (JP_GUESS  = 1237104) 
cs    PARAMETER (JP_GUESS  = 1038240) 
C                          `---> allow for 0.25*0.25 interpolated grid
C
C     Local variables
C
      LOGICAL LHORIZN, LFLIP
      CHARACTER*1 HFUNC
      CHARACTER*1 HINTOPT
      INTEGER IOLDN, IOLDW, IOLDS, IOLDE, IOLDEW, IOLDNS
      INTEGER LOOPLAT, LOOPLON, I, J
      REAL ZTEMP
      INTEGER IERR, KPR, IWORD, IOLDSIZ, INEWSIZ, IINTPOL, ISTAGP
      INTEGER NXP, NYP, INEWP, ITEMP
      REAL RTOP, RBOTT, RRIGHT, RLEFT, RYRES, RXRES
      REAL XARR, YARR
      DIMENSION XARR(JPGRIB_ISEC1), YARR(JPGRIB_ISEC1)
#ifndef _CRAYFTN
#ifdef POINTER_64
      INTEGER*8 INEW, IOLD
#endif
#endif
      REAL NEW, OLD
      POINTER ( INEW, NEW )
      POINTER ( IOLD, OLD )
      DIMENSION NEW( 1 ), OLD( 1 )
C
C     Externals
C
      INTEGER RESET_C, INTOCN, FIXAREA
C
C     -----------------------------------------------------------------|
C*    Section 1.   Initialise
C     -----------------------------------------------------------------|
C
  100 CONTINUE
C
C     Test if debug output required.
C
      CALL JDEBUG()
C
      CALL INTLOG(JP_DEBUG,
     X  'OCEANP: Trying to interpolate an ocean field.',JPQUIET)
C
      IF( .NOT.LNOGRID ) THEN
        CALL INTLOG(JP_FATAL,
     X    'OCEANP: GRID must be specified to interpolate an ocean field'
     X    , JPQUIET)
        OCEANP = JPROUTINE + 1
        GOTO 960
      ENDIF
C
      OCEANP = 0
      IERR   = 0
      KPR    = 0
      LFLIP = .FALSE.
C
C     Save the original area and grid definitions
C
      IOLDN  = NOAREA(1)
      IOLDW  = NOAREA(2)
      IOLDS  = NOAREA(3)
      IOLDE  = NOAREA(4)
      IOLDEW = NOGRID(1)
      IOLDNS = NOGRID(2)
C
C     -----------------------------------------------------------------|
C*    Section 2.   Unpack the input ocean field.
C     -----------------------------------------------------------------|
C
  200 CONTINUE
C
C     Decode first four sections of GRIB code to find number of values
C
      IWORD   = INLEN
      IERR    = 1
      IOLDSIZ = OUTLEN
      CALL GRIBEX(ISEC0, ISEC1, ISEC2, ZSEC2, ISEC3, ZSEC3, ISEC4,
     X            OLD, IOLDSIZ, INOCEAN, INLEN, IWORD, 'I',IERR)
C
      IF( IERR.NE.0 ) THEN
        CALL INTLOG(JP_ERROR,
     X    'OCEANP: GRIBEX option J decoding failed.',IERR)
        OCEANP = IERR
        GOTO 950
      ENDIF
C
C     Check it is an ocean field
C
      IF( (ISEC1(24).NE.1).OR.(ISEC1(37).NE.4) ) THEN
        CALL INTLOG(JP_ERROR, 'OCEANP: Not an ocean field.',JPQUIET)
        OCEANP = JPROUTINE + 3
        GOTO 950
      ENDIF
C
C     Horizontal (lat/long) field GRIB setup different from others
C
      LHORIZN = (ISEC1(60).EQ.JP_LONG).AND.(ISEC1(61).EQ.JP_LAT)
      IF( LHORIZN ) CALL INTLOG(JP_DEBUG,
     X  'OCEANP: Horizontal (lat/long) field interpolation.',JPQUIET)
C
C     Get scratch memory for unpacking the input ocean field.
C
      IOLDSIZ = ISEC2(2)*ISEC2(3)
      CALL JMEMHAN( JPSCR4, IOLD, IOLDSIZ, JPALLOC, IERR)
      IF( IERR.NE.0 ) THEN
        CALL INTLOG(JP_ERROR,
     X    'OCEANP: Scratch memory(4) allocation failed.',JPQUIET)
        OCEANP = IERR
        GOTO 950
      ENDIF
C
C     Decode data from GRIB code: -999.9 is a missing data value
C
      IWORD = INLEN
      IERR  = 1
      ZSEC3(2) = -999.9
      CALL GRIBEX(ISEC0, ISEC1, ISEC2, ZSEC2, ISEC3, ZSEC3, ISEC4,
     X            OLD, IOLDSIZ, INOCEAN, INLEN, IWORD, 'D',IERR)
C
      IF( (IERR.NE.0).AND.(IERR.NE.-2).AND.(IERR.NE.-4) ) THEN
        CALL INTLOG(JP_ERROR,'OCEANP: GRIBEX decoding failed.',IERR)
        OCEANP = IERR
        GOTO 940
      ENDIF
C
C     -----------------------------------------------------------------|
C*    Section 3.   Prepare the output ocean field.
C     -----------------------------------------------------------------|
C
  300 CONTINUE
C
C     Setup interpolation options from input GRIB characteristics.
C
      IERR = RESET_C(ISEC1, ISEC2, ZSEC2, ISEC4)
      IF( IERR.NE.0 ) THEN
        CALL INTLOG(JP_ERROR,
     X    'OCEANP: Setup interp. options from GRIB failed.',JPQUIET)
        OCEANP = IERR
        GOTO 940
      ENDIF
C
C     For horizontal field, match the desired area to the grid
C
      IERR = FIXAREA()
      IF( IERR.NE.0 ) THEN
        CALL INTLOG(JP_ERROR, 'OCEANP: FIXAREA failed.',JPQUIET)
        OCEANP = IERR
        GOTO 940
      ENDIF
C
C     Get scratch memory for output ocean field.
C     Have to guess how big the interpolated grid will be.
C
      INEWSIZ = JP_GUESS
      CALL JMEMHAN(JPSCR3, INEW, INEWSIZ*2, JPALLOC, IERR)
      IF( IERR.NE.0 ) THEN
        CALL INTLOG(JP_ERROR,
     X    'OCEANP: Scratch memory(3) allocation failed.',JPQUIET)
        OCEANP = IERR
        GOTO 940
      ENDIF
      INEWP = 1
      ITEMP = 1 + INEWSIZ
C
C     -----------------------------------------------------------------|
C*    Section 4.   Interpolate ocean field.
C     -----------------------------------------------------------------|
C
  400 CONTINUE
C
      RTOP   = FLOAT( NOAREA(1) ) / PPMULT
      RBOTT  = FLOAT( NOAREA(3) ) / PPMULT
      RRIGHT = FLOAT( NOAREA(4) ) / PPMULT
      RLEFT  = FLOAT( NOAREA(2) ) / PPMULT
C
      RYRES = FLOAT( NOGRID(2) ) / PPMULT
      RXRES = FLOAT( NOGRID(1) ) / PPMULT
C
C     Select the interpolation option
C     (default = 'R' = interpolate only to make grid regular)
C     If requested X grid increment does not match input GRIB
C     increment, interpolate in x and y ('F' = full)
C
      HINTOPT = 'R'
      IF( NOGRID(1).NE.ISEC2(9) ) HINTOPT = 'F'
C
      IERR = INTOCN(HINTOPT,'D',
     X              RTOP, RBOTT, RRIGHT, RLEFT, RYRES, RXRES,
     X              ISEC1, ISEC2, OLD, IOLDSIZ,
     X              INEWSIZ, NEW(ITEMP), XARR, YARR, NXP, NYP,
     X              NEW(INEWP),
     X              IINTPOL, ISTAGP)
      IF( IERR.NE.0 ) THEN
        CALL INTLOG(JP_ERROR, 'OCEANP: Interpolation failed.',JPQUIET)
        OCEANP = IERR
        GOTO 900
      ENDIF
C
      NOAREA(1) = NINT( (YARR(1) + YARR(2)*(NYP-1)) * PPMULT )
      NOAREA(2) = NINT( XARR(1) * PPMULT )
      NOAREA(3) = NINT( YARR(1) * PPMULT )
      NOAREA(4) = NINT( (XARR(1) + XARR(2)*(NXP-1)) * PPMULT )
C
      NOGRID(1) = NINT( ABS(XARR(2)) * PPMULT )
      NOGRID(2) = NINT( ABS(YARR(2)) * PPMULT )
      NONS = NYP
      NOWE = NXP
C
C     -----------------------------------------------------------------|
C*    Section 5.   Code new field into GRIB.
C     -----------------------------------------------------------------|
C
  500 CONTINUE
C
C     Re-order the rows from south to north to be north to south
C     (ECMWF convention).
C
      IF( LHORIZN.OR.(NOAREA(1).LT.NOAREA(3)) ) THEN
        LFLIP = .TRUE.
        DO LOOPLAT = 1, NYP/2
          I = (LOOPLAT - 1)*NXP
          J = (NYP - LOOPLAT)*NXP
          DO LOOPLON = 1, NXP
            I = I + 1
            J = J + 1
            ZTEMP  = NEW(I)
            NEW(I) = NEW(J)
            NEW(J) = ZTEMP
          ENDDO
        ENDDO
C
        IF( .NOT.LHORIZN ) THEN
          ITEMP     = NOAREA(1)
          NOAREA(1) = NOAREA(3)
          NOAREA(3) = ITEMP
C
          ITEMP    = ISEC2(4)
          ISEC2(4) = ISEC2(7)
          ISEC2(7) = ITEMP
        ENDIF
      ENDIF
C
C     Setup GRIB sections for the output product:
C
C     Use local definition 4 in GRIB section 1 ...
C
      ISEC1(73) = 0
      ITEMP = 75 + ISEC1(71) + ISEC1(72) + ISEC1(73) + ISEC1(74)
      ISEC1(ITEMP) = 0

C
      IF( LHORIZN ) THEN
        ISEC1(62) = NOAREA(1)*10
        ISEC1(63) = NOAREA(2)*10
        ISEC1(64) = NOAREA(3)*10
        ISEC1(65) = NOAREA(4)*10
        ISEC1(66) = NOGRID(1)*10
        ISEC1(67) = NOGRID(2)*10
        IF( LFLIP ) ISEC1(67) = - ISEC1(67)
        ISEC1(68) = 0
        ISEC1(69) = 0
C
C       Standard section 2 format for horizontal sections
C
        ISEC2(1) = 0
        ISEC2(2) = NXP
        ISEC2(3) = NYP
        ISEC2(4) = NOAREA(1)/100
        ISEC2(5) = NOAREA(2)/100
        ISEC2(6) = 128
        ISEC2(7) = NOAREA(3)/100
        ISEC2(8) = NOAREA(4)/100
        ISEC2(9)  = NOGRID(1)/100
        ISEC2(10) = NOGRID(2)/100
Cjdc    ISEC2(17) = 0
        DO LOOPLAT = 11, 22
          ISEC2(LOOPLAT) = 0
        ENDDO
      ELSE
C Tim-Correct headers for vertical sections
        IF( ISEC1(60).EQ.3 ) THEN
          ISEC1(63) = NOAREA(2)*10
        ELSEIF( ISEC1(60).EQ.4 ) THEN
          ISEC1(63) = NOAREA(2)*10
        ENDIF
        IF( ISEC1(61).EQ.3 ) THEN
          ISEC1(62) = NOAREA(1)*10
        ELSEIF( ISEC1(61).EQ.4 ) THEN
          ISEC1(62) = NOAREA(1)*10
        ENDIF
C
        IF( ISEC1(61).EQ.1 ) THEN
          ISEC1(64) = ISEC1(62) + NINT((NYP-1)*RYRES*1.0)
          ISEC1(65) = ISEC1(63) + NINT((NXP-1)*RXRES*1000000.0)
          ISEC1(66) = NOGRID(1)*NINT(1000000.0/PPMULT)
          ISEC1(67) = NOGRID(2)/(PPMULT/1.0)
        ELSE
          ISEC1(64) = ISEC1(62) + NINT((NYP-1)*RYRES*1000.0)
          ISEC1(65) = ISEC1(63) + NINT((NXP-1)*RXRES*1000000.0)
          ISEC1(66) = NOGRID(1)*NINT(1000000.0/PPMULT)
          ISEC1(67) = NOGRID(2)/(PPMULT/1000.0)
        ENDIF
C
        IF( LFLIP ) ISEC1(67) = - ISEC1(67)
        ISEC1(68) = 0
C
C       Special ECMWF ocean short form of GRIB section 2
C
        ISEC2(1) = 192
        ISEC2(2) = NXP
        ISEC2(3) = NYP
Cjdc    ISEC2(4) = NOAREA(1)/100000
Cjdc    ISEC2(5) = NOAREA(2)/100
Cjdc    ISEC2(6) = 0
Cjdc    ISEC2(7) = NOAREA(3)/100000
Cjdc    ISEC2(8) = NOAREA(4)/100
Cjdc    DO LOOPLAT = 9, 22
Cjdc      ISEC2(LOOPLAT) = 0
Cjdc    ENDDO
      ENDIF
C
C     Ensure there is a section 3 in case there is missing data in the
C     output area
C
      ISEC1(5) = 192
      ISEC3(1) = 0
      ZSEC3(2) = -999.9
C
      ISEC4(1) = NXP *  NYP
C
C     If grid-point output, setup for 2nd order packing if requested.
C
      IF( (NOREPR.NE.JPSPHERE).AND.(NOREPR.NE.JPSPHROT) ) THEN
        HFUNC = 'C'
        IF( NOHFUNC.EQ.'K' ) THEN
          HFUNC = 'K'
          ISEC4(4)  = 64
          ISEC4(6)  = 16
          ISEC4(9)  = 32
          ISEC4(10) = 16
          ISEC4(12) = 8
          ISEC4(13) = 4
          ISEC4(14) = 0
          ISEC4(15) = -1
        ELSE
          ISEC4(4)  = 0
          ISEC4(6)  = 0
        ENDIF
      ELSE
        HFUNC = 'C'
        IF( NOHFUNC.EQ.'C' ) THEN
          ISEC2(6) = 2
          ISEC4(4) = 64
        ELSE IF( NOHFUNC.EQ.'S' ) THEN
          ISEC2(6) = 1
          ISEC4(4) = 0
        ENDIF
      ENDIF
C
C     Switch off GRIBEX checking (sigh)
C
      CALL INTLOG(JP_DEBUG,
     X  'OCEANP: switching OFF GRIBEX checking',JPQUIET)
      CALL GRSVCK(0)
C
      IERR = 1
      CALL GRIBEX( ISEC0, ISEC1, ISEC2, ZSEC2, ISEC3, ZSEC3, ISEC4,
     X             NEW,INEWSIZ,OTOCEAN,OUTLEN,IWORD,HFUNC,IERR)
C
      IF( IERR.NE.0 ) THEN
        CALL INTLOG(JP_ERROR,'OCEANP: GRIBEX encoding failed.',IERR)
        OCEANP = JPROUTINE + 5
        GOTO 900
      ENDIF
      OUTLEN = IWORD
C
C     Switch on GRIBEX checking (sigh again)
C
      CALL INTLOG(JP_DEBUG,
     X  'OCEANP: switching ON GRIBEX checking',JPQUIET)
      CALL GRSVCK(1)
C
C     -----------------------------------------------------------------|
C*    Section 9.   Closedown.
C     -----------------------------------------------------------------|
C
  900 CONTINUE
C
C     Clear change flags for next product processing
C
      LCHANGE = .FALSE.
      LSMCHNG = .FALSE.
C
C     Return the scratch memory.
C
      CALL JMEMHAN( JPSCR3, INEW, INEWSIZ, JPDEALL, IERR)
      IF ( IERR .NE. 0 ) THEN
        CALL INTLOG(JP_ERROR,
     X    'OCEANP: Scratch memory(3) reallocation failed.',JPQUIET)
        OCEANP = IERR
      ENDIF
C
  940 CONTINUE
C
      CALL JMEMHAN( JPSCR4, IOLD, IOLDSIZ, JPDEALL, IERR)
      IF ( IERR .NE. 0 ) THEN
        CALL INTLOG(JP_ERROR,
     X    'OCEANP: Scratch memory(4) reallocation failed.',JPQUIET)
        OCEANP = IERR
      ENDIF
C
  950 CONTINUE
C
C     Restore the original area and grid definitions
C
      NOAREA(1) = IOLDN
      NOAREA(2) = IOLDW
      NOAREA(3) = IOLDS
      NOAREA(4) = IOLDE
      NOGRID(1) = IOLDEW
      NOGRID(2) = IOLDNS
C
  960 CONTINUE
C
      CALL INTLOG(JP_DEBUG,
     X  'OCEANP: Returning from interpolating an ocean field.',JPQUIET)
C
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE BUGBTS( KSEC1,KERR )
C
C**** *BUGBTS*
C
C
C     PURPOSE.
C     --------
C          LOAD BUFR TABLE B, D AND C ACCORDING TO EDITION AND VERSION
C     OF BUFR CODE.
C
C
C**   INTERFACE.
C     ----------
C
C          *CALL* *BUGBTS(KSEC1,KERR)*
C
C        OUTPUT:
C               *KSEC1*   -  ARRAY CONTAINING SECTION 1 INFORMATION
C                            KSEC1( 1)-- LENGTH OF SECTION 1 (BYTES)
C                            KSEC1( 2)-- BUFR EDITION NUMBER
C                            KSEC1( 3)-- ORIGINATING CENTRE
C                            KSEC1( 4)-- UPDATE SEQUENCE NUMBER
C                            KSEC1( 5)-- FLAG (PRESENCE OF SECTION 2)
C                            KSEC1( 6)-- BUFR MESSAGE TYPE
C                            KSEC1( 7)-- BUFR MESSAGE SUBTYPE
C                            KSEC1( 8)-- VERSION NUMBER OF LOCAL TABLE USED
C                            KSEC1( 9)-- YEAR
C                            KSEC1(10)-- MONTH
C                            KSEC1(11)-- DAY
C                            KSEC1(12)-- HOUR
C                            KSEC1(13)-- MINUTE
C                            KSEC1(14)-- BUFR MASTER TABLE
C                            KSEC1(15)-- VERSION NUMBER OF MASTER TABLE USED
C                            KSEC1(16) - KSEC1(JSEC1) -- LOCAL ADP CENTRE
C                                        INFORMATION(BYTE BY BYTE)
C
C                            FOR BUFR EDITION 3 ONWARD
C
C                            KSEC1(16)-- ORIGINATING SUB-CENTRE
C                            KSEC1(17)-- NOT USED
C                            KSEC1(18) TO KSEC1(JSEC1) - LOCAL ADP CENTRE
C                                        INFORMATION(PACKED FORM)
C
C                            FOR BUFR EDITION 4 ONWARD
C
C                            KSEC1(16)-- ORIGINATING SUB-CENTRE
C                            KSEC1(17)-- INTERNATIONAL SUB-CATEGORY (SEE COMMON TABLE C-13
C                            KSEC1(18)-- SECOND
C                            KSEC1(19)-- YEAR
C                            KSEC1(20)-- MONTH
C                            KSEC1(21)-- DAY
C                            KSEC1(22)-- HOUR
C                            KSEC1(23)-- MINUTE
C                            KSEC1(24)-- SECOND
C                            KSEC1(25)-- YEAR
C                            KSEC1(26)-- MONTH
C                            KSEC1(27)-- DAY
C                            KSEC1(28)-- HOUR
C                            KSEC1(29)-- MINUTE
C                            KSEC1(30)-- SECOND
C                            KSEC1(31)-- MOST SOUTHERN LATITUDE  (-90 to 90)
C                            KSEC1(32)-- MOST WESTERN LONGITUDE  ( 0-360)
C                            KSEC1(33)-- MOST NORTHEN LATITUDE   (-90 to 90)
C                            KSEC1(34)-- MOST EASTERN LONGITUDE  ( 0-360)
C                            KSEC1(35) TO KSEC1(JSEC1) - LOCAL ADP CENTRE INFORMATION(PACKED FORM)
C
C               *KERR*    -  RETURNED ERROR CODE
C
C     METHOD.
C     -------
C
C          NONE.
C
C
C     EXTERNALS.
C     ----------
C
C          NONE.
C
C     REFERENCE.
C     ----------
C
C          NONE.
C
C     AUTHOR.
C     -------
C
C          M. DRAGOSAVAC    *ECMWF*       17/01/91.
C
C
C     MODIFICATIONS.
C     --------------
C
C          NONE.
C
C
      IMPLICIT LOGICAL(L,O,G), CHARACTER*8(C,H,Y)
C
C
#     include "parameter.F"
#     include "bcomunit.F"
#     include "bcomwork.F"
#     include "bcomtab.F"
#     include "bcomtabc.F"
#     include "bcomct.F"
#     include "bcomctc.F"
#     include "bcomroot.F"
#     include "bcomtabload.F"
#     include "bcomtabloadc.F"
C
      CHARACTER*256 YTAB ,YTAC ,YTAD
      CHARACTER*24 YTABB,YTABC,YTABD, CTABLE_LIST
      CHARACTER*64 CTABBEN
      CHARACTER*24 CTABBU
      CHARACTER*64 CCTABBEN
      CHARACTER*24 CCTABBU
      CHARACTER*256 CROOT
      CHARACTER*64 CTEXT
C
      LOGICAL*4  OPN
#ifndef R_4
      REAL*8 RVIND
      REAL*8 EPS
#else
      REAL   RVIND
      REAL   EPS
#endif
C
      DIMENSION KSEC1(JSEC1)
C
      SAVE OFIRST
C
C     ------------------------------------------------------------------
C
C*          1.   GET BUFR TABLES/LOCAL BUFR TABLES.
C                ----------------------------------
 100  CONTINUE
C
      IF( KERR.NE.0) RETURN
C
C*          2.   SET UP BUFR TABLE FILE NAME.
C                ----------------------------
 200  CONTINUE
C
C
C             BUFR EDITION 2 NAMING CONVENTION
C
C             BXXXXXYYZZ , CXXXXXYYZZ , DXXXXXYYZZ
C
C             B      - BUFR TABLE 'B'
C             C      - BUFR TABLE 'C'
C             D      - BUFR TABLE 'D'
C             XXXXX  - ORIGINATING CENTRE
C             YY     - VERSION NUMBER OF MASTER TABLE
C                      USED( CURRENTLY 2 )
C             ZZ     - VERSION NUMBER OF LOCAL TABLE USED
C
C             BUFR EDITION 3 NAMING CONVENTION
C
C             BWWWXXXYYZZ , CWWWXXXYYZZ , DWWWXXXYYZZ
C
C             B      - BUFR TABLE 'B'
C             C      - BUFR TABLE 'C'
C             D      - BUFR TABLE 'D'
C             WWW    - ORIGINATING SUB-CENTRE
C             XXX    - ORIGINATING CENTRE
C             YY     - VERSION NUMBER OF MASTER TABLE
C                      USED( CURRENTLY 2 )
C             ZZ     - VERSION NUMBER OF LOCAL TABLE USED
C
C
C             BUFR EDITION 4 NAMING CONVENTION
C
C             BSSSWWWWWXXXXXYYYZZZ , CSSSWWWWWXXXXXYYYZZZ , DSSSWWWWWXXXXXYYYZZZ
C
C             B      - BUFR TABLE 'B'
C             C      - BUFR TABLE 'C'
C             D      - BUFR TABLE 'D'
C             SSS    - MASTER TABLE NUMBER ( zero for WMO tables)
C             WWWWWW - ORIGINATING SUB-CENTRE
C             XXXXXX - ORIGINATING CENTRE
C             YYY    - VERSION NUMBER OF MASTER
C                      TABLE USED( CURRENTLY 12 )
C             ZZZ    - VERSION NUMBER OF LOCAL TABLE USED
C
            IXX=KSEC1(3)
            IYY=KSEC1(15)
            IZZ=KSEC1(08)
C           
            IF(KSEC1(2).EQ.3) THEN
               IWW=KSEC1(16)
               ISS=KSEC1(14)
            ELSEIF(KSEC1(2).EQ.4) THEN
               IWW=KSEC1(16)
               ISS=KSEC1(14)
            ELSE
               IWW=0
               ISS=0
            END IF
C
C        IF STANDARD TABLES USED, USE WMO ORIGINATING CENTRE ID
C
         IF(KSEC1(8).EQ.0.OR.KSEC1(8).EQ.255) THEN
            IXX=0
            IWW=0
            IZZ=0
         ENDIF
C
         IF(OFIRST) THEN
            IF(IWW.EQ.NWWP.AND.IXX.EQ.NXXP.AND.IYY.EQ.NYYP.AND.
     1         IZZ.EQ.NZZP.AND.ISS.EQ.NSSP) RETURN
         END IF
C
         OFIRST=.TRUE.
C
         NSSP=ISS
         NXXP=IXX
         NYYP=IYY
         NZZP=IZZ
         NWWP=IWW
C
       WRITE(YTABB,'(A1,I3.3,2(I5.5),2(I3.3),A4)')
     1             'B',ISS,IWW,IXX,IYY,IZZ,'.TXT'
       WRITE(YTABC,'(A1,I3.3,2(I5.5),2(I3.3),A4)')
     1             'C',ISS,IWW,IXX,IYY,IZZ,'.TXT'
       WRITE(YTABD,'(A1,I3.3,2(I5.5),2(I3.3),A4)')
     1             'D',ISS,IWW,IXX,IYY,IZZ,'.TXT'
C
C
C      Find if table is already used
C
       DO I=1,JTMAX
         IF(CTABLE_LIST(I).EQ.YTABB) THEN
            CALL GET_TABLES(I)
            RETURN
         END IF
       END DO
       IF(OPRINT) THEN
          IF(OCTABLE) THEN
             WRITE(KNTN,'(A,1X,A,A,A,A,A)') 'BUFR TABLES TO BE LOADED ',
     1       YTABB,',',YTABC,',',YTABD
          ELSE
             WRITE(KNTN,'(A,1X,A,A,A)') 'BUFR TABLES TO BE LOADED ',
     1       YTABB,',',YTABD
          END IF

       END IF
C     ----------------------------------------------------------------
C*          3. OPEN AND READ FILES CONTAINING BUFR TABLES.
C              -------------------------------------------
 300  CONTINUE
C
      I=INDEX(CROOT,' ')
      IF(I.NE.0) I=I-1
C
C*          3.1 READ BUFR TABLE B.
C               ------------------
 310  CONTINUE
C
      YTAB=CROOT(1:I)//YTABB
C
      CALL BTABLE(YTAB,YTABB,KERR)
      IF(KERR.NE.0) RETURN
C
C
C*          3.2 READ BUFR TABLE C.
C               ------------------
 320  CONTINUE
C
       IF(OCTABLE) THEN
          YTAC=CROOT(1:I)//YTABC
C
          CALL CTABLE(YTAC,KERR)
          IF(KERR.NE.0) RETURN
       END IF
C
C
C*          3.3 READ BUFR TABLE D.
C               ------------------
 330  CONTINUE
C
      YTAD=CROOT(1:I)//YTABD
C
      CALL DTABLE(YTAD,KERR)
      IF(KERR.NE.0) RETURN
C
      RETURN
C
      END

C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE GRPRS3 (KSEC0,KSEC3,PSEC3)
C
C---->
C**** GRPRS3 - Print information from Section 3 of GRIB code.
C
C     Purpose.
C     --------
C
C     Print the information in the Bit-map section
C     Section (Section 3) of decoded GRIB data.
C
C**   Interface.
C     ----------
C
C     CALL GRPRS3 (KSEC0,KSEC3,PSEC3)
C
C     Input Parameters.
C     -----------------
C
C     KSEC0 - Array of decoded integers from Section 0.
C     KSEC3 - Array of decoded integers from Section 3.
C
C     PSEC3 - Array of decoded reals from Section 3.
C
C     Output Parameters.
C     ------------------
C
C     None.
C
C     Method.
C     -------
C
C     Fields printed as integers or reals.
C
C     Externals.
C     ----------
C
C     Common block GRPRSCM.
C
C     Reference.
C     ----------
C
C     WMO Manual on Codes re GRIB Code.
C     See also routine GRIBEX.
C
C     Comments.
C     ---------
C
C     Routine contains Sections 0 to 1 and Section 9.
C
C     Author.
C     -------
C
C     J. Hennessy    ECMWF 11.09.91
C
C     Modifications.
C     --------------
C
C     J.D.Chambers   ECMWF 20.07.94
C     Change format for printing missing data indicator to
C     allow largest negative (32-bit) number
C
C     J.D.Chambers   ECMWF 14.06.95
C     Change format for printing missing data indicator to
C     allow for MAGICS value (-1.5E+21)
C
C     J.D.Chambers   ECMWF    June 2002
C     Add option to set output stream number using environment variable
C     GRPRS_STREAM
C
C----<
C     -----------------------------------------------------------------|
C*    Section 0. Definition of variables.
C     -----------------------------------------------------------------|
C
      IMPLICIT NONE
C
#include "grprs.h"
C
      INTEGER KSEC0(*)
      INTEGER KSEC3(*)
      REAL PSEC3(*)
C
C     -----------------------------------------------------------------|
C*    Section 1 . Print required information.
C     -----------------------------------------------------------------|
C
  100 CONTINUE
C
      WRITE(GRPRSM,9000)
      WRITE(GRPRSM,9001)
      WRITE(GRPRSM,9002)
C
      IF( KSEC3(1).NE.0 ) THEN
        WRITE(GRPRSM,9003) KSEC3(1)
      ELSE
        WRITE(GRPRSM,9004)
      ENDIF
      WRITE(GRPRSM,9005) KSEC3(2)
C
      WRITE(GRPRSM,*)
     X  'Missing data value for real data.        ', PSEC3(2)
C
C     -----------------------------------------------------------------|
C*    Section 9 . Format statements. Return to calling routine.
C     -----------------------------------------------------------------|
C
  900 CONTINUE
C
 9000 FORMAT (1H )
 9001 FORMAT (1H ,'Section 3 - Bit-map Section.')
 9002 FORMAT (1H ,'-------------------------------------')
 9003 FORMAT (1H ,'Predetermined bit-map number.                ',I9)
 9004 FORMAT (1H ,'No predetermined bit-map.')
 9005 FORMAT (1H ,'Missing data value for integer data.    ',I14)
 9006 FORMAT (1H ,'Missing data value for real data.        ',F20.6)
C
      RETURN
C
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities
C granted to it by virtue of its status as an intergovernmental organisation
C nor does it submit to any jurisdiction.
C

      REAL FUNCTION GGLONLAT(KNUM,PLAT,KPTS,FIELD,MISSVALUE,NN,LON,LAT)
C
C---->
C**** GGLONLAT
C
C     PURPOSE
C     _______
C
C     Returns the bilinear/nearest neighbour-interpolated value at a
C     specific position, given a global, unrotated Gaussian grid
C     description. Weights/distances are calculated in lon/lat space.
C
C
C     INTERFACE
C     _________
C
C     RRET = GGLONLAT(KNUM,PLAT,KPTS,FIELD,MISSVALUE,NN,LON,LAT)
C
C
C     Input parameters
C     ________________
C
C     KNUM      - Gaussian grid number
C     PLAT      - ... latitudes array (length 2*KNUM), both hemispheres
C     KPTS      - ... number of points array at each latitude (length
C                 2*KNUM), both hemispheres
C     FIELD     - Gaussian field values array (length SUM(KPTS(:)))
C     MISSVALUE - Value to return if interpolation fails
C     NN        - If non-zero, perform nearest neighbour interpolation
C     LON       - Requested interpolation point longitude
C     LAT       - ... latitude
C
C     Return value
C     ____________
C
C     Bilinear/nearest neighbour interpolated value, missing value if
C     not successful or any interpolating values missing.
C
C
C----<
      IMPLICIT NONE

C     Arguments
      INTEGER KNUM, KPTS(*)
      INTEGER NN
      REAL PLAT(*), FIELD(*), MISSVALUE, LON, LAT

C     Local variables
      INTEGER J1, J3, I, J, M
      REAL DLAT1, DLAT3, PLON(4), A, ZSOUTH, ZNORTH !, B
      REAL V(4), W(4)  ! field values and weights around int. point


C     Initialize
      GGLONLAT = MISSVALUE
      V    = MISSVALUE
      PLON = 0.


C     Set North-neighboring indices:
C     row idices J1:                LAT <= PLAT(J1)
C     abs indices I1/I2: LON(I1) <= LON <= LON(I2)
C     longitudes:        PLON(1) <= LON <= PLON(2)
      I  = 1
      J1 = 1
      DO J = 2, KNUM*2
        IF (PLAT(J)<LAT) GOTO 100
        I  = I + KPTS(J-1)
        J1 = J
      ENDDO
100   CONTINUE

      A = REAL(360.)/REAL(KPTS(J1))  ! increment length
      M = FLOOR(LON/A)               ! n. full increments up to LON
      DO WHILE (M.GE.KPTS(J1))
        M = M - KPTS(J1)             ! guarantee M*increment < 360.
      ENDDO
      PLON(1) = REAL( M )*A
      PLON(2) = REAL(M+1)*A

      V(1) = FIELD( I+M )
      V(2) = FIELD( I+MOD(M+1,KPTS(J1)) )


C     Set South-neighboring indices (start with previous row results):
C     row idices J3:     PLAT(J3) <= LAT
C     abs indices I3/I4: LON(I3)  <= LON <= LON(I4)
C     longitudes:        PLON(3)  <= LON <= PLON(4)
      J3 = J1
      PLON(3:4) = PLON(1:2)
      V   (3:4) = V   (1:2)
      IF ( LAT.LT.PLAT(J1) .AND. LAT.GT.PLAT(MIN(J1+1,2*KNUM)) ) THEN
        I  = I + KPTS(J1)
        J3 = MIN(J1+1,2*KNUM)

        A = REAL(360.)/REAL(KPTS(J3))  ! increment length
        M = FLOOR(LON/A)
        DO WHILE (M.GE.KPTS(J3))
          M = M - KPTS(J3)             ! guarantee M*increment < 360.
        ENDDO
        PLON(3) = REAL( M )*A
        PLON(4) = REAL(M+1)*A

        V(3) = FIELD( I+M )
        V(4) = FIELD( I+MOD(M+1,KPTS(J3)) )
      ENDIF


C     Calculate weights (nn/any-missing/bilinear/linear cases)
      IF (NN.NE.0) THEN

C       Nearest neighbour interpolation
        W(1:2) = (PLAT(J1)-LAT)**2 + (PLON(1:2)-LON)**2  ! sq. distance
        W(3:4) = (PLAT(J3)-LAT)**2 + (PLON(3:4)-LON)**2  ! ...
        J = 1
        DO I = 2, 4
          IF ( V(I).NE.MISSVALUE .AND. W(I).LT.W(J) ) J = I
        ENDDO
        GGLONLAT = V(J)

      ELSEIF ( V(1).EQ.MISSVALUE .OR. V(2).EQ.MISSVALUE .OR.
     .         V(3).EQ.MISSVALUE .OR. V(4).EQ.MISSVALUE ) THEN

C       (some values are missing, nothing to do)

      ELSEIF (J1.NE.J3) THEN

#if 0
C       Method 1:
C       Bi-linear interpolation is calculated in lon/lat space, with the
C       following distribution of weights:
C
C
C            (V(1))--------(X12)------------(V(2))      (row J1)
C              /    W(4)     |        W(3)     \
C           (X13)--------(LON,LAT)-----------(X24)
C             /              |                    \
C            /     W(2)      |          W(1)       \
C            /               |                      \
C       (V(3))-------------(X34)--------------------(V(4))    (row J3)
C
C       with weights corresponding to the relative areas of the opposite
C       quadrilateral subdivisions:
C         W(1) = A( P,      X(2,4), X(3,4), 4      ) / A(1,2,3,4)
C         W(2) = A( X(1,3), P,      3,      X(3,4) ) / A(1,2,3,4)
C         W(3) = A( X(1,2), 2,      P,      X(2,4) ) / A(1,2,3,4)
C         W(4) = A( 1,      X(1,2), X(1,3), P      ) / A(1,2,3,4)

        A = (PLON(2)-PLON(4))/(PLAT(J1)-PLAT(J3))
        B = (PLAT(J1)*PLON(4)-PLAT(J3)*PLON(2))/(PLAT(J1)-PLAT(J3))
        W(1) = (LAT-PLAT(J3)) * (A*(LAT+PLAT(J3))/2.+B-LON)
        W(3) = (PLAT(J1)-LAT) * (A*(LAT+PLAT(J1))/2.+B-LON)

        A = (PLON(1)-PLON(3))/(PLAT(J1)-PLAT(J3))
        B = (PLAT(J1)*PLON(3)-PLAT(J3)*PLON(1))/(PLAT(J1)-PLAT(J3))
        W(2) = (LAT-PLAT(J3)) * (LON-A*(LAT+PLAT(J3))/2.+B)
        W(4) = (PLAT(J1)-LAT) * (LON-A*(LAT+PLAT(J1))/2.+B)
#elif 0
C       Method 2:
C       Bi-linear interpolation is calculated in lon/lat space, with the
C       following distribution of weights:
C
C
C            (V(1))----------+--------------(V(2))      (row J1)
C              |    W(4)     |        W(3)     |
C          +---+---------(LON,LAT)-------------+------+
C          |                 |                        |
C          |       W(2)      |          W(1)          |
C          |                 |                        |
C       (V(3))---------------+----------------------(V(4))    (row J3)
C
C       with weights corresponding to the relative areas of the opposite
C       quadrilateral subdivisions.

        W(1) = (LAT-PLAT(J3))*(PLON(4)-LON)
        W(2) = (LAT-PLAT(J3))*(LON-PLON(3))
        W(3) = (PLAT(J1)-LAT)*(PLON(2)-LON)
        W(4) = (PLAT(J1)-LAT)*(LON-PLON(1))
#else
C       Method 3:
C       Bi-linear interpolation is calculated in lon/lat space, with the
C       following distribution of weights (Emoslib emulation):
C
C
C            (V(1))----------+--------------(V(2))      (row J1)
C              |    W(4)     |        W(3)     |
C          +---+---------(LON,LAT)-------------+------+
C          |                 |                        |
C          |       W(2)      |          W(1)          |
C          |                 |                        |
C       (V(3))---------------+----------------------(V(4))    (row J3)
C
C       with weights corresponding to the relative areas of the opposite
C       quadrilateral subdivisions.

        DLAT1 =         REAL(NINT( PLAT(J1) * 100000 )) !PLAT(J1)
        DLAT3 =         REAL(NINT( PLAT(J3) * 100000 )) !PLAT(J3)
        DLAT1 = DLAT1 - REAL(NINT(   LAT    * 100000 ))
        DLAT3 =         REAL(NINT(   LAT    * 100000 )) - DLAT3

        ZSOUTH = PLON(4)-PLON(3)
        ZNORTH = PLON(2)-PLON(1)

        W(1) = DLAT3 * (PLON(4)-LON) !* ZSOUTH
        W(2) = DLAT3 * (LON-PLON(3)) !* ZSOUTH
        W(3) = DLAT1 * (PLON(2)-LON) !* ZNORTH
        W(4) = DLAT1 * (LON-PLON(1)) !* ZNORTH

#endif

        A = W(1)+W(2)+W(3)+W(4)
        W = W/A
        GGLONLAT = V(1)*W(1) + V(2)*W(2) + V(3)*W(3) + V(4)*W(4)

      ELSE

C       Linear interpolation
        W(1) = (PLON(2)-LON) / (PLON(2)-PLON(1))
        W(2) = 1-W(1)

        GGLONLAT = V(1)*W(1) + V(2)*W(2)

      ENDIF


      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities
C granted to it by virtue of its status as an intergovernmental organisation
C nor does it submit to any jurisdiction.
C

      INTEGER FUNCTION IARCNTL(PIFELD, KILEN, POFELD, KOLEN, KILN,
     1   OIWEGLOBE, OINPOLE, OISPOLE, KOLN, OOWEGLOBE, OONPOLE,
     2   OOSPOLE, KPR, KERR)
C
C---->
C**** *IARCNTL*
C
C     Purpose
C     -------
C
C     The global controlling routine for interpolating between a quasi
C     regular Gaussian input field and a regular Gaussian or
C     latitude/longitude output field.
C
C
C     Interface
C     ---------
C
C     IERR = IARCNTL(PIFELD, KILEN, POFELD, KOLEN, KILN, OIWEGLOBE,
C    1   OINPOLE, OISPOLE, KOLN, OOWEGLOBE, OONPOLE, OOSPOLE, KPR,
C    2   KERR)
C
C
C     Input parameters
C     ----------------
C
C     PIFELD    - The input field provided by the calling routine.
C
C     KILEN     - The length of the input field.
C
C     KOLEN     - The length of the output field.
C
C     KILN      - The Northern line number of the input field within
C                  its Gaussian field.
C
C     OIWEGLOBE - A flag indicating whether the input field is
C                 global West to East.
C
C     OINPOLE   - A flag indicating whether the North pole is
C                 included in the input field.
C
C     OISPOLE   - A flag indicating whether the South pole is
C                 include in the input field.
C
C     KOLN      - The Northern line number of the output field
C                 within its Gaussian field.
C
C     OOWEGLOBE - A flag indicating whether the output field is
C                 global West to East.
C
C     OONPOLE   - A flag indicating whether the North pole is
C                 include in the output field.
C
C     OOSPOLE   - A flag indicating whether the South pole is
C                 include in the output field.
C
C     KPR       - The debug print switch.
C                  0  , No debugging output.
C                  1  , Produce debugging output.
C
C     KERR      - The error control flag.
C                  -ve, No error message. Return error code.
C                  0  , Hard failure with error message.
C                  +ve, Print error message. Return error code.
C
C
C     Output parameters
C     -----------------
C
C     POFELD - The output field returned to the calling routine.
C
C
C     Return value
C     ------------
C
C     The error indicator (INTEGER).
C
C
C     Error and Warning Return Values
C     -------------------------------
C
C     21901 The input data representation was not valid when the
C           grid was generated. This should not happen as the data
C           representation has been previously validated.
C     21902 The output data representation was not valid when the
C           grid was generated. This should not happen as the data
C           representation has been previously validated.
C     21903 Attempt to produce global West-East field where the input
C           field was not global.
C     21904 Attempt to produce global North-South field where the
C           input field was not global.
C
C
C     Common block usage
C     ------------------
C
C     grspace.h    - The include file contains all the array space
C                    for grid to grid interpolation.
C
C     MILLEN       - The array of quasi regular Gaussian field
C                    latitude line length definition.
C     RIGAUSS      - Real array of input field Gaussian latitudes is
C                    used.
C     ROGAUSS      - Real array of output field Gaussian latitudes is
C                    used.
C
C     MILATG       - The input field latitudes.
C     MILONG       - The input field longitudes.
C     MISTRT       - The array offsets for the start of each latitude
C                    line for a quasi regular Gaussian input field.
C     MNSDIST      - The distances to neighbouring latitude lines of
C                    the input field from the associated line of
C                    latitude in the output field.
C     MNSIND       - The latitude line numbers (array offset) of the
C                    input field associated with each line of
C                    latitude in the output field.
C     MOLATG       - The output field latitudes.
C     MOLONG       - The output field longitudes.
C     MWEDIST      - This array holds the distances to neighbouring
C                    longitude points of the input field from the
C                    associated longitude points in the output field.
C     MWEIND       - This array holds the longitude points (array
C                    offset) from the input field associated with
C                    each longitude point in the output field.
C     RINPNT       - Array used to aid vectorisation in processing
C                    precipitation fields.
C     RMAX         - Array used to aid vectorisation in normalising
C                    interpolation weights and processing
C                    precipitation fields.
C     WFACT        - The array of interpolation weights for each
C                    point in the output field.
C
C     nifld.common - This file contains all the input field
C                    definition variables.
C
C     LCHANGE      - Process change flag is used and set.
C     LSMCHNG      - LSM change flag is used and set.
C     LSM          - LSM usage flag is used.
C     LSMPAR       - LSM parameter flag is used.
C     LPREC        - Precipitation flag is used.
C     LWIND        - Wind flag is used.
C
C     NIAREA       - Input field area definition (N/W/S/E) is used.
C     NIGAUSS      - Input field Gaussian truncation is used.
C     NIGRID       - Input field grid definition (WE/NS) is used.
C     NINS         - Number of grid points in NS direction for input
C                    field is used.
C     NIREPR       - Input field representation is used.
C     NIWE         - Number of grid points in WE direction for input
C                    field is used.
C
C     nofld.common - This file contains all the output field
C                    definition variables.
C
C     NOAREA       - Output field area definition (N/W/S/E) is used.
C     NOGAUSS      - Output field Gaussian truncation is used.
C     NOGRID       - Output field grid definition (WE/NS) is used.
C     NONS         - Number of grid points in NS direction for output
C                    field is used.
C     NOREPR       - Output field representation is used.
C     NOWE         - Number of grid points in WE direction for output
C                    field is used.
C
C
C     Externals
C     ---------
C
C     ABORTX     - Standard routine to kill task.
C     IGDINS     - Calculate the distances between points in an
C                  output latitude array and its North and South
C                  neighbours in the input latitude array.
C     IGGRID     - Generate the arrays of latitude and longitude
C                  points for a Gaussian truncation and area.
C     IGLGRID    - Generate the arrays of latitude and longitude
C                  points for a regular latitude longitude grid.
C     IGLSIZE    - Evaluate the array sizes for a regular
C                  latitude/longitude field.
C     IGLSMD     - Generate the land sea mask file information.
C     IGNORM     - Normalise the array of interpolation weights.
C     IGPLSM     - Force an interpolated land sea mask field back to
C                  a real 0-1 field.
C     IGPOLEG    - Calculate the values at the pole of a regular
C                  latitude/longitude field when the input is a
C                  Gaussian field.
C     IGPOLEW    - Calculates the values at the pole of a regular
C                  latitude/longitude wind field when the input is a
C                  Gaussian field.
C     IGSIZE     - Evaluate the array sizes for a Gaussian field.
C     IRDIWE     - Calculate the distances between points in an
C                  output longitude array and its West and East
C                  neighbours in the input longitude array for a
C                  quasi regular input field and regular output field.
C     IRGMEM     - This routine acquires heap space for quasi regular
C                  to regular interpolation.
C     IRGRID     - Generate the arrays of latitude points and the
C                  starting points of the lines of latitude for a
C                  quasi regular Gaussian grid.
C     IRGTOG     - Perform basic interpolation between the input and
C                  output fields for a quasi regular input field and
C                  a regular output field.
C     IRINT      - Calculate the basic unnormalised interpolation
C                  weights when interpolating from a quasi regular
C                  grid to a regular grid.
C     IRLSMB     - Calculate the effects of the land-sea masks on the
C                  unnormalised interpolation weights for a quasi
C                  regular input field and regular output field.
C     IRPREC     - Perform additional interpolation processes for
C                  precipitation fields when the input field is Quasi
C                  regular.
C     ZPREC      - Perform additional interpolation processes
C                  for precipitation
C     IRSIZE     - Evaluate the array sizes for a quasi regular
C                  Gaussian field.
C     INTLOG     - Logs messages.
C
C
C     Method
C     ------
C     This is purely a controlling routine with all the work being
C     performed in the external routines.
C
C
C     Reference
C     ---------
C     None
C
C
C     Comments
C     --------
C     None
C
C
C     Author
C     ------
C     K. Fielding      *ECMWF*      Nov 1993
C
C
C     Modifications
C     -------------
C     J.Chambers        ECMWF       Oct 1998
C     Allow field type for rotated grids.
C
C     S.Curic           ECMWF       Oct 2005
C     Add zprec routine that Perform checking
C     of precipitation
C
C----<
C     -----------------------------------------------------------------|
C*    Section 0. Definition of variables.
C     -----------------------------------------------------------------|
C
      IMPLICIT NONE
C
#include "parim.h"
#include "nifld.common"
#include "nofld.common"
#include "grspace.h"
C
C     Parameters
C
      INTEGER JPROUTINE
      PARAMETER (JPROUTINE = 21900)
C
C     Function arguments
C
      LOGICAL OIWEGLOBE, OINPOLE, OISPOLE, OOWEGLOBE, OONPOLE, OOSPOLE
      INTEGER KILEN, KOLEN, KILN, KOLN, KPR, KERR
      REAL PIFELD(KILEN), POFELD(KOLEN)
C
C     Local variables
C
      LOGICAL LFAIL, LERROR, LDEBUG, LREGOUT
      LOGICAL GINSPOLE, GIGLOBE, GISTAND, GONSPOLE, GOGLOBE, GOSTAND
      LOGICAL GPREC,LSM_VALUES
      CHARACTER*256 YIFILE, YOFILE
      CHARACTER*12 YFLAG
      INTEGER IIOFF, IINDEX, IOOFF
      INTEGER IIREC, IOREC, IERR
C
C     Working copies of area and grid arrays that may be changed
C
      INTEGER IILGRID(2), IILLINE(2), IOLGRID(2), IOLLINE(2)
C
C     External functions
C
      INTEGER IGDINS, IGGRID, IGLGRID, IGLSMD, IGNORM, IGPLSM,
     X   IGPOLEG, IGPOLEW,
     X   IRDIWE, IRGMEM, IRGRID, IRGTOG, IRINT, IRLSMB, IRPREC,
     X   ZPREC
C
C     -----------------------------------------------------------------|
C*    Section 1. Initialisation
C     -----------------------------------------------------------------|
C
  100 CONTINUE
C
      IARCNTL = 0
      IERR = 0
C
C     Set all flag variables
C
      LDEBUG  = (KPR.GE.1)
      LFAIL   = (KERR.EQ.0)
      LERROR  = (KERR.GE.0)
      LREGOUT = (NOREPR.EQ.JPREGULAR).OR.(NOREPR.EQ.JPREGROT)
C
      IF( LDEBUG ) THEN
        CALL INTLOG(JP_DEBUG,'IARCNTL: Section 1.',JPQUIET)
        CALL INTLOG(JP_DEBUG,
     X    'IARCNTL: Input field definition parameters.',JPQUIET)
        CALL INTLOG(JP_DEBUG,'IARCNTL: Representation = ',NIREPR)
        IF( NINS.NE.0 ) CALL INTLOG(JP_DEBUG,
     X    'IARCNTL: Number N-S = ',NINS)
        CALL INTLOG(JP_DEBUG,'IARCNTL: Gaussian truncation= ',NIGAUSS)
        IF( NIAREA(1).NE.0 ) THEN
          CALL INTLOG(JP_DEBUG,'IARCNTL: Area North = ',NIAREA(1))
          CALL INTLOG(JP_DEBUG,'IARCNTL: Area West  = ',NIAREA(2))
          CALL INTLOG(JP_DEBUG,'IARCNTL: Area South = ',NIAREA(3))
          CALL INTLOG(JP_DEBUG,'IARCNTL: Area East  = ',NIAREA(4))
        ENDIF
C
        CALL INTLOG(JP_DEBUG,
     X    'IARCNTL: Output field definition parameters.',JPQUIET)
        CALL INTLOG(JP_DEBUG,'IARCNTL: Representation = ',NOREPR)
        IF( NOWE.NE.0 ) CALL INTLOG(JP_DEBUG,
     X    'IARCNTL: Number W-E = ',NOWE)
        IF( NONS.NE.0 ) CALL INTLOG(JP_DEBUG,
     X    'IARCNTL: Number N-S = ',NONS)
        IF( (NOREPR.EQ.JPGAUSSIAN).OR.(NOREPR.EQ.JPQUASI) )
     X    CALL INTLOG(JP_DEBUG,'IARCNTL: Gaussian truncation= ',NOGAUSS)
        IF( LREGOUT.AND.NOGRID(1).NE.0 ) THEN
          CALL INTLOG(JP_DEBUG,'IARCNTL: Grid WE = ',NOGRID(1))
          CALL INTLOG(JP_DEBUG,'IARCNTL: Grid NS = ',NOGRID(2))
        ENDIF
        IF( NOAREA(1).NE.0 ) THEN
          CALL INTLOG(JP_DEBUG,'IARCNTL: Area North = ',NOAREA(1))
          CALL INTLOG(JP_DEBUG,'IARCNTL: Area West  = ',NOAREA(2))
          CALL INTLOG(JP_DEBUG,'IARCNTL: Area South = ',NOAREA(3))
          CALL INTLOG(JP_DEBUG,'IARCNTL: Area East  = ',NOAREA(4))
        ENDIF
C
        CALL INTLOG(JP_DEBUG,'IARCNTL: Control flag status:',JPQUIET)
C
        IF( LSMCHNG ) THEN
          CALL INTLOG(JP_DEBUG,'IARCNTL: LSM change TRUE',JPQUIET)
        ELSE
          CALL INTLOG(JP_DEBUG,'IARCNTL: LSM change FALSE',JPQUIET)
        ENDIF
C
        IF( LSM ) THEN
          CALL INTLOG(JP_DEBUG,'IARCNTL: LSM flag TRUE',JPQUIET)
        ELSE
          CALL INTLOG(JP_DEBUG,'IARCNTL: LSM flag FALSE',JPQUIET)
        ENDIF
C
        IF( LWIND ) THEN
          CALL INTLOG(JP_DEBUG,'IARCNTL: Wind flag TRUE',JPQUIET)
        ELSE
          CALL INTLOG(JP_DEBUG,'IARCNTL: Wind flag FALSE',JPQUIET)
        ENDIF
C
        IF( LPREC ) THEN
          CALL INTLOG(JP_DEBUG,'IARCNTL: Precipitn flag TRUE',JPQUIET)
        ELSE
          CALL INTLOG(JP_DEBUG,'IARCNTL: Precipitn flag FALSE',JPQUIET)
        ENDIF
C
        IF( LSMPAR ) THEN
          CALL INTLOG(JP_DEBUG,'IARCNTL: LSM param flag TRUE',JPQUIET)
        ELSE
          CALL INTLOG(JP_DEBUG,'IARCNTL: LSM param flag FALSE',JPQUIET)
        ENDIF
      ENDIF
C
C     The change of parameter option spans sections 2 to 3
C
      IF( LCHANGE ) THEN
C
C     -----------------------------------------------------------------|
C*    Section 2. Get space and define grids.
C     -----------------------------------------------------------------|
C
  200   CONTINUE
C
        IF( LDEBUG ) CALL INTLOG(JP_DEBUG,'IARCNTL: Section 2.',JPQUIET)
C
C       Get the required memory
C
        IARCNTL = IRGMEM(KPR, KERR)
        IF( IARCNTL.GT.0 ) GOTO 900
C
C       Input field definition
C
        IF( NIREPR.EQ.JPQUASI ) THEN
C
          IARCNTL = IRGRID(NIAREA, MILLEN, KILN, RIGAUSS, MISTRT,
     X                     MILATG, NINS, OIWEGLOBE, KPR, KERR)
          IF( IARCNTL.GT.0 ) GOTO 900
C
C         Is the input field global
C
          GINSPOLE = OINPOLE.AND.OISPOLE
          GIGLOBE  = OIWEGLOBE.AND.GINSPOLE
C
        ELSE
C
          IARCNTL = JPROUTINE + 1
          IF( LERROR ) THEN
            CALL INTLOG(JP_ERROR,
     X        'IARCNTL: Illegal input data representation = ',NIREPR)
            IF( LFAIL ) CALL INTLOG(JP_FATAL,
     X        'IARCNTL: Interpolation failing.',JPQUIET)
          ENDIF
          GOTO 900
C
        ENDIF
C
C       Output grid definition
C
C       Is the output field global North South
C
        GONSPOLE = OONPOLE.AND.OOSPOLE
        GOGLOBE  = OOWEGLOBE.AND.GONSPOLE
        LGLOBL   = (GOGLOBE.AND.NOAREA(2).EQ.0)
C
        IF( NOREPR.EQ.JPGAUSSIAN ) THEN
C
          IARCNTL = IGGRID(NOGAUSS, NOAREA, KOLN, ROGAUSS,
     X                     MOLONG,NOWE,MOLATG,NONS,OOWEGLOBE,KPR,KERR)
          IF( IARCNTL.GT.0 ) GOTO 900
C
        ELSEIF ( LREGOUT ) THEN
C
          IARCNTL = IGLGRID(NOGRID, NOAREA, MOLONG, NOWE, MOLATG,
     X                      NONS, OOWEGLOBE, KPR, KERR)
          IF( IARCNTL.GT.0 ) GOTO 900
C
        ELSE
C
          IARCNTL = JPROUTINE + 2
          IF( LERROR ) THEN
            CALL INTLOG(JP_ERROR,
     X        'IARCNTL: Illegal output data representation = ',NIREPR)
            IF( LFAIL ) CALL INTLOG(JP_FATAL,
     X        'IARCNTL: Interpolation failing.',JPQUIET)
          ENDIF
          GOTO 900
C
        ENDIF
C
C     -----------------------------------------------------------------|
C*    Section 3. Create output to input grid mapping and distance arrays
C     -----------------------------------------------------------------|
C
  300   CONTINUE
C
        IF( LDEBUG )
     X    CALL INTLOG(JP_DEBUG,'IARCNTL: Section 3.',JPQUIET)
C
C       First check that the input and output fields are compatible.
C
        IF( .NOT.GIGLOBE ) THEN
C
          IF( .NOT.OIWEGLOBE ) THEN
C
C           Cannot produce global output field if input field not global
C
            IF( OOWEGLOBE ) THEN
              IARCNTL = JPROUTINE + 3
              IF( LERROR ) THEN
                CALL INTLOG(JP_ERROR,
     X            'IARCNTL: Cannot produce global output from',JPQUIET)
                CALL INTLOG(JP_ERROR,
     X            'IARCNTL: non-global input.  The W-E input',JPQUIET)
                CALL INTLOG(JP_ERROR,
     X            'IARCNTL: direction was not global.',JPQUIET)
                IF( LFAIL ) CALL INTLOG(JP_FATAL,
     X            'IARCNTL: Interpolation failing.',JPQUIET)
              ENDIF
              GOTO 900
            ENDIF
C
          ENDIF
C
          IF( .NOT.GINSPOLE ) THEN
C
C           Cannot produce global output field if input field not global
C
            IF( GONSPOLE ) THEN
              IARCNTL = JPROUTINE + 4
              IF( LERROR ) THEN
                CALL INTLOG(JP_ERROR,
     X            'IARCNTL: Cannot produce global output from',JPQUIET)
                CALL INTLOG(JP_ERROR,
     X            'IARCNTL: non-global input.  The N-S input',JPQUIET)
                CALL INTLOG(JP_ERROR,
     X            'IARCNTL: direction was not global.',JPQUIET)
                IF( LFAIL ) CALL INTLOG(JP_FATAL,
     X            'IARCNTL: Interpolation failing.',JPQUIET)
              ENDIF
              GOTO 900
            ENDIF
C
          ENDIF
C
        ENDIF
C
        IARCNTL = IGDINS(MILATG, NINS, MOLATG, NONS, OINPOLE,
     X                   OISPOLE, MNSIND, MNSDIST, KPR, KERR)
        IF( IARCNTL.GT.0 ) GOTO 900
C
        IARCNTL = IRDIWE(MILLEN, NINS, MNSIND, NONS, MILONG, NIWE,
     X                   MOLONG, NOWE, MWEIND, MWEDIST, NIAREA, NOAREA,
     X                   KPR, KERR)
        IF( IARCNTL.GT.0 ) GOTO 900
C
C     The end of primary initialisation
C
      ENDIF
C
C     -----------------------------------------------------------------|
C*    Section 4. Create normalised weight arrays
C     -----------------------------------------------------------------|
C
  400 CONTINUE
C
      IF( LDEBUG ) CALL INTLOG(JP_DEBUG,'IARCNTL: Section 4.',JPQUIET)
C
C     The following code is affected by the Land Sea mask flag
C
      IF( LCHANGE.OR.LSMCHNG ) THEN
C
        IARCNTL = IRINT(MWEDIST, NOWE, MNSDIST, NONS, WFACT, KPR, KERR)
        IF( IARCNTL.GT.0 ) GOTO 900
C
        IF( LSM ) THEN
C
          IARCNTL = IGLSMD(NIDATE,NIREPR,NIGRID,NIGAUSS,NIAREA,KILN,
     X                    YIFILE,GISTAND,IILGRID,IILLINE,IIREC,KPR,KERR)
          IF( IARCNTL.GT.0 ) GOTO 900
C
          IARCNTL = IGLSMD(NODATE,NOREPR,NOGRID,NOGAUSS,NOAREA,KOLN,
     X                    YOFILE,GOSTAND,IOLGRID,IOLLINE,IOREC,KPR,KERR)
          IF( IARCNTL.GT.0 ) GOTO 900
C
          IARCNTL = IRLSMB(GISTAND, YIFILE, IIREC, IILGRID, IILLINE,
     X                    GOSTAND,YOFILE,IOREC,IOLGRID,IOLLINE,KPR,KERR)
          IF( IARCNTL.GT.0 ) GOTO 900
C
        ENDIF
C
C       Normalise the weights
C
        IARCNTL = IGNORM(WFACT, RMAX, NOWE, NONS, KPR, KERR)
        IF( IARCNTL.GT.0 ) GOTO 900
C
C       This marks the end of a change to the specfication
C       Clear the Change flags LCHANGE and LSMCHNG
C
        LCHANGE = .FALSE.
        LSMCHNG = .FALSE.
C
      ENDIF
C
C     -----------------------------------------------------------------|
C*    Section 5. Interpolate from input to output field
C     -----------------------------------------------------------------|
C
  500 CONTINUE
C
      IF( LDEBUG ) CALL INTLOG(JP_DEBUG,'IARCNTL: Section 5.',JPQUIET)
C
C     Perform basic interpolation
C
      IARCNTL = IRGTOG(PIFELD, MISTRT, NINS, NOWE, NONS, MWEIND,
     X                 MNSIND, WFACT, POFELD, KPR, KERR)
      IF( IARCNTL.GT.0 ) GOTO 900
C
C     -----------------------------------------------------------------|
C*    Section 6. Additional interpolations from input to output field
C     -----------------------------------------------------------------|
C
  600 CONTINUE
C
      IF( LDEBUG ) CALL INTLOG(JP_DEBUG,'IARCNTL: Section 6.',JPQUIET)
C
C     Precipitation field
C
C     Force processing without neighbour check
        GPREC = .FALSE.
        CALL GETENV('PRECIPITATION_NEIGHBOUR_CHECK', YFLAG)
        IF( YFLAG(1:1).EQ.'0' ) GPREC = .TRUE.

      IF( LPREC ) THEN
C
        IF( GPREC ) THEN
          IARCNTL = ZPREC(POFELD, NOWE, NONS, KPR, KERR)
        ELSE
          IARCNTL = IRPREC(PIFELD, MISTRT, NINS, POFELD, NOWE, NONS,
     X                   MWEIND, MNSIND, WFACT, RMAX, RINPNT, KPR, KERR)
        ENDIF
        IF( IARCNTL.GT.0 ) GOTO 900
C
      ENDIF
C
C     Special code for poles if Gaussian input and regular output
C
C     North pole
C
      IF( (NIREPR.EQ.JPQUASI).AND.
     X    LREGOUT            .AND.
     X    OINPOLE            .AND.
     X    OONPOLE ) THEN
C
        IIOFF = MISTRT(1)
        IOOFF = 1
        IINDEX = (JP_I_N - 1) * NOWE + 1
C
        IF( LWIND ) THEN
          IARCNTL = IGPOLEW(PIFELD(IIOFF), MILLEN(1),
     X                      POFELD(IOOFF), NOWE, MWEIND(1,IINDEX),
     X                      MWEDIST(1,IINDEX), KPR, KERR)
        ELSE
          IARCNTL = IGPOLEG(PIFELD(IIOFF), MILLEN(1),
     X                      POFELD(IOOFF), NOWE, KPR, KERR)
        ENDIF
        IF( IARCNTL.GT.0 ) GOTO 900
C
      ENDIF
C
C     South pole
C
      IF( (NIREPR.EQ.JPQUASI).AND.
     X    LREGOUT            .AND.
     X    OISPOLE            .AND.
     X    OOSPOLE ) THEN
C
        IIOFF = MISTRT(NINS)
        IOOFF = (NONS - 1) * NOWE + 1
        IINDEX = ( (NONS - 1) * 2 + JP_I_S - 1) * NOWE + 1
C
        IF( LWIND ) THEN
          IARCNTL = IGPOLEW(PIFELD(IIOFF), MILLEN(NINS),
     X                      POFELD(IOOFF), NOWE, MWEIND(1,IINDEX),
     X                      MWEDIST(1,IINDEX), KPR, KERR)
        ELSE
          IARCNTL = IGPOLEG(PIFELD(IIOFF), MILLEN(NINS),
     X                      POFELD(IOOFF), NOWE, KPR, KERR)
        ENDIF
C
        IF( IARCNTL.GT.0 ) GOTO 900
C
      ENDIF
C
C     LSM field - must be 0 or 1
C
C     Force processing real LSM
        LSM_VALUES = .FALSE.
        CALL GETENV('LSM_VALUES', YFLAG)
        IF( YFLAG(1:1).EQ.'1' ) LSM_VALUES = .TRUE.

      IF( .NOT.LSM_VALUES.AND.LSMPAR ) THEN
        IARCNTL = IGPLSM(POFELD, NOWE * NONS, KPR, KERR)
        IF( IARCNTL.GT.0 ) GOTO 900
      ENDIF
C
C     -----------------------------------------------------------------|
C*    Section 9. Return to calling routine. Format statements
C     -----------------------------------------------------------------|
C
  900 CONTINUE
C
      IF( LDEBUG ) CALL INTLOG(JP_DEBUG,'IARCNTL: Section 9.',JPQUIET)
C
      RETURN
      END

C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      INTEGER FUNCTION IGDIWE (KILONG, KIWE, KOLONG, KOWE, OWEGLOBE,
     1   KWEIND, KWEDIST, KPR, KERR)
C
C---->
C**** *IGDIWE*
C
C     PURPOSE
C     _______
C
C     Calculate the distances between points in an output longitude
C     array and its West and East neighbours in the input longitude
C     array.
C
C     INTERFACE
C     _________
C
C     IERR = IGDIWE (KILONG, KIWE, KOLONG, KOWE, OWEGLOBE, KWEIND,
C    1   KWEDIST, KPR, KERR)
C
C     Input parameters
C     ________________
C
C     KILONG     - The array of input longitudes.
C
C     KIWE       - The number of points in the West-East direction in
C                  the input field.
C
C     KOLONG     - The array of output longitudes.
C
C     KOWE       - The number of points in the West-East direction in
C                  the output field.
C
C     OWEGLOBE   - This variable will be true if the input array of
C                  longitudes spans the globe.
C
C     KPR        - The debug print switch.
C                  0  , No debugging output.
C                  1  , Produce debugging output.
C
C     KERR       - The error control flag.
C                  -ve, No error message. Return error code.
C                  0  , Hard failure with error message.
C                  +ve, Print error message. Return error code.
C
C     Output parameters
C     ________________
C
C     KWEIND     - This array will contain the array offsets of the
C                  West and East points in the input array required
C                  for interpolation.
C
C     KWEDIST    - This array holds the distances to longitude values
C                  in the input field from the associated longitude
C                  values in the output field.
C
C     Return value
C     ____________
C
C     The error indicator (INTEGER).
C
C     Error and Warning Return Values
C     _______________________________
C
C     24601 An output longitude was found that was outside the range
C           spanned by the input longitudes.
C
C     Common block usage
C     __________________
C
C     None
C
C     EXTERNALS
C     _________
C
C     INTLOG(R)    - Logs messages.
C
C     METHOD
C     ______
C
C     This routine will create the arrays of offsets and distance
C     as two arrays of length (2, Number of output longitudes).
C     This will be used for all latitude rows when both the input
C     and output grids are regular.
C
C     This routine is used to provide the values for one line of
C     latitude for quasi regular Gaussian input fields.
C
C     REFERENCE
C     _________
C
C     None
C
C     COMMENTS
C     ________
C
C     Program contains sections 0 to 2 and 9
C
C     AUTHOR
C     ______
C
C     K. Fielding      *ECMWF*      Oct 1993
C
C     MODIFICATIONS
C     _____________
C
C     None
C
C----<
C     _______________________________________________________
C
C
C*    Section 0. Definition of variables.
C     _______________________________________________________
C
C*    Prefix conventions for variable names
C
C     Logical      L (but not LP), global or common.
C                  O, dummy argument
C                  G, local variable
C                  LP, parameter.
C     Character    C, global or common.
C                  H, dummy argument
C                  Y (but not YP), local variable
C                  YP, parameter.
C     Integer      M and N, global or common.
C                  K, dummy argument
C                  I, local variable
C                  J (but not JP), loop control
C                  JP, parameter.
C     REAL         A to F and Q to X, global or common.
C                  P (but not PP), dummy argument
C                  Z, local variable
C                  PP, parameter.
C
C     Implicit statement to force declarations
C
      IMPLICIT NONE
C
#include "parim.h"
C
C     Dummy arguments
      LOGICAL OWEGLOBE
      INTEGER KIWE, KOWE, KPR, KERR
      INTEGER KILONG (KIWE + 1), KOLONG (KOWE)
      INTEGER KWEIND (2, KOWE), KWEDIST (2, KOWE)
C
C     Local variables
      INTEGER IBASE, ILOW, IUP
      INTEGER JINP, JOUT
      INTEGER JPROUTINE
      PARAMETER (JPROUTINE = 24600)
C
C     _______________________________________________________
C
C*    Section 1. Initialisation
C     _______________________________________________________
C
  100 CONTINUE
C
      IF (KPR.GE.1) CALL INTLOG(JP_DEBUG,'IGDIWE: Section 1.',JPQUIET)
C
      IGDIWE = 0
C
      IF (KPR .GE. 1) THEN
        CALL INTLOG(JP_DEBUG,'IGDIWE: Input parameters.',JPQUIET)
        CALL INTLOG(JP_DEBUG,'IGDIWE: No.input fld pts = ',KIWE)
        CALL INTLOG(JP_DEBUG,'IGDIWE: No.output fld pts = ',KOWE)
        CALL INTLOG(JP_DEBUG,'IGDIWE: Input fld spread from ',KILONG(1))
        CALL INTLOG(JP_DEBUG,'IGDIWE: to ',KILONG(KIWE))
        CALL INTLOG(JP_DEBUG,'IGDIWE: Output spread from ',KOLONG(1))
        CALL INTLOG(JP_DEBUG,'IGDIWE: to ',KOLONG(KOWE))
        IF( OWEGLOBE ) THEN
          CALL INTLOG(JP_DEBUG,
     X      'IGDIWE: Input W-E fld is global',JPQUIET)
        ELSE
          CALL INTLOG(JP_DEBUG,
     X      'IGDIWE: Input W-E fld is NOT global',JPQUIET)
        ENDIF
      ENDIF
C
C     _______________________________________________________
C
C*    Section 2. Select points around a line of latitude.
C     _______________________________________________________
C
  200 CONTINUE
C
      IF (KPR.GE.1) CALL INTLOG(JP_DEBUG,'IGDIWE: Section 2.',JPQUIET)
C
      IF (OWEGLOBE) THEN
C
        DO 230 JINP = 1, KIWE
C
C       NOTE that point number 1 is repeated as point KIWE + 1
C       to simplify the wrap around case
C
          ILOW = KILONG (JINP)
          IUP = KILONG (JINP + 1)
C
          IF (IUP .GT. ILOW) THEN
C
C           Normal case IUP > ILOW
C
            DO 210 JOUT = 1, KOWE
C
              IF (KOLONG(JOUT).GE.ILOW .AND.  KOLONG(JOUT).LT.IUP) THEN
C
C               Longitude point found
C
                KWEIND (JP_I_W, JOUT) = JINP
C
                IF (JINP .LT. KIWE) THEN
                  KWEIND (JP_I_E, JOUT) = JINP + 1
                ELSE
                  KWEIND (JP_I_E, JOUT) = 1
                ENDIF
C
                KWEDIST (JP_I_W, JOUT) = KOLONG (JOUT) - ILOW
                KWEDIST (JP_I_E, JOUT) = IUP - KOLONG (JOUT)
C
              ENDIF
C
  210       CONTINUE
C
          ELSE
C
C           Wrap around case
C
            DO 220 JOUT = 1, KOWE
C
              IF (KOLONG (JOUT) .GE. ILOW) THEN
C
C               Longitude point found between ILOW and 3600000
C
                KWEIND (JP_I_W, JOUT) = JINP
C
                IF (JINP .LT. KIWE) THEN
                  KWEIND (JP_I_E, JOUT) = JINP + 1
                ELSE
                  KWEIND (JP_I_E, JOUT) = 1
                ENDIF
C
                KWEDIST (JP_I_W, JOUT) = KOLONG (JOUT) - ILOW
                KWEDIST (JP_I_E, JOUT) = IUP + JP360 - KOLONG (JOUT)
C
              ENDIF
C
Cjdc          IF (KOLONG (JOUT) .LT. IUP) THEN
              IF (KOLONG (JOUT) .LE. IUP) THEN
C
C               Longitude point found between 0 and IUP
C
                KWEIND (JP_I_W, JOUT) = JINP
C
                IF (JINP .LT. KIWE) THEN
                  KWEIND (JP_I_E, JOUT) = JINP + 1
                ELSE
                  KWEIND (JP_I_E, JOUT) = 1
                ENDIF
C
                KWEDIST (JP_I_W, JOUT) = KOLONG (JOUT) + JP360 - ILOW
                KWEDIST (JP_I_E, JOUT) = IUP - KOLONG (JOUT)
C
              ENDIF
C
  220       CONTINUE
C
          ENDIF
C
  230   CONTINUE
C
      ELSE
C
C       Pointer to last point found if input grid is not global
C
        IBASE = 1
C
        DO 250 JOUT = 1, KOWE
C
          DO 240 JINP = IBASE, KIWE - 1
C
            ILOW = KILONG (JINP)
            IUP = KILONG (JINP + 1)
C
C           Normal case IUP > ILOW
C
Cjdc        IF (KOLONG(JOUT).GE.ILOW .AND. KOLONG(JOUT).LT.IUP) THEN
            IF (KOLONG(JOUT).GE.ILOW .AND. KOLONG(JOUT).LE.IUP) THEN
C
C             Longitude point found
C
              KWEIND (JP_I_W, JOUT) = JINP
              KWEIND (JP_I_E, JOUT) = JINP + 1
              IBASE = JINP
C
              KWEDIST (JP_I_W, JOUT) = KOLONG (JOUT) - ILOW
              KWEDIST (JP_I_E, JOUT) = IUP - KOLONG (JOUT)
C
              GO TO 250
C
C           Wrap around case
C
            ELSE IF (IUP .LT. ILOW) THEN
C
              IF (KOLONG (JOUT) .GE. ILOW) THEN
C
C               Longitude point found between ILOW and 3600000
C
                KWEIND (JP_I_W, JOUT) = JINP
                KWEIND (JP_I_E, JOUT) = JINP + 1
                IBASE = JINP
C
                KWEDIST (JP_I_W, JOUT) = KOLONG (JOUT) - ILOW
                KWEDIST (JP_I_E, JOUT) = IUP + JP360 - KOLONG (JOUT)
C
                GO TO 250
C
              ENDIF
C
Cjdc          IF (KOLONG (JOUT) .LT. IUP) THEN
              IF (KOLONG (JOUT) .LE. IUP) THEN
C
C               Longitude point found between 0 and IUP
C
                KWEIND (JP_I_W, JOUT) = JINP
                KWEIND (JP_I_E, JOUT) = JINP + 1
                IBASE = JINP
C
                KWEDIST (JP_I_W, JOUT) = KOLONG (JOUT) + JP360 - ILOW
                KWEDIST (JP_I_E, JOUT) = IUP - KOLONG (JOUT)
C
                GO TO 250
C
              ENDIF
C
            ENDIF
C
  240     CONTINUE
C
C         This statement will be reached if the output grid does not
C         fit within the input grid.
C
          IGDIWE = JPROUTINE + 1
          IF (KERR .GE. 0) THEN
            CALL INTLOG(JP_ERROR,
     X        'IGDIWE: Output long. value number = ',JOUT)
            CALL INTLOGR(JP_ERROR,
     X        'IGDIWE: Output long. value ',REAL(KOLONG(JOUT))/PPMULT)
            CALL INTLOGR(JP_ERROR,
     X        'IGDIWE: outside input range = ',REAL(KILONG(1))/PPMULT)
            CALL INTLOGR(JP_ERROR,
     X        'IGDIWE: to ',REAL(KILONG(KIWE))/PPMULT)
          ENDIF
C
          IF (KERR .EQ. 0) CALL INTLOGR(JP_FATAL,
     X      'IGDIWE: Interpolation failing.',IGDIWE)
C
          GO TO 900
C
  250   CONTINUE
C
      ENDIF
C
C     _______________________________________________________
C
C*    Section 9. Return to calling routine. Format statements
C     _______________________________________________________
C
  900 CONTINUE
C
      IF (KPR.GE.1) CALL INTLOG(JP_DEBUG,'IGDIWE: Section 9.',JPQUIET)
C
      RETURN
      END

C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE JALLWN( PSHUP, KTRUNC, PNORTH, PSOUTH, PWEST, PEAST,
     X                    PLATINC, PLONINC, POUTF, KRET)
C
C---->
C**** JALLWN
C
C     PURPOSE
C     _______
C
C     This routine converts spectral input fields to standard
C     lat/long grid fields.
C
C     INTERFACE
C     _________
C
C     CALL JALLWN( PSHUP, KTRUNC, PNORTH, PSOUTH, PWEST, PEAST,
C    X                    PLATINC, PLONINC, POUTF, KRET)
C
C     Input parameters
C     ________________
C
C     PSHUP    - Spherical harmonics field, unpacked
C     KTRUNC   - Truncation number of spherical harmonics field
C     PNORTH   - Northernmost latitude for output field (degrees)
C     PSOUTH   - Southernmost latitude for output field (degrees)
C     PWEST    - Westernmost longitude for output field (degrees)
C     PEAST    - Easternmost longitude for output field (degrees)
C     PLATINC  - Grid interval between latitudes in degrees
C     PLONINC  - Grid interval between longitudes in degrees
C     INTLOG   - Output log message
C     INTLOGR  - Output log message (with real value)
C
C     Output parameters
C     ________________
C
C     POUTF    - Output grid point field
C     KRET     - Return status code
C                0 = OK
C
C     Common block usage
C     __________________
C
C     JDCNDBG
C
C     Method
C     ______
C
C     Generates the latitudes in bands, 32 at a time plus some
C     remainder.
C
C     Externals
C     _________
C
C     JALLGP  - Cnverts spectral fields to lat/long grid fields.
C     JSLLGP  - Converts stretched spectral fields to lat/long grids
C
C
C     Reference
C     _________
C
C     None.
C
C
C     Comments
C     ________
C
C     Calls JALLGP or JSLLGP to do all the work!
C
C
C     AUTHOR
C     ______
C
C     J.D.Chambers      *ECMWF*      Nov 1993
C
C     MODIFICATIONS
C     _____________
C
C     J.D.Chambers      *ECMWF*      Oct 1996
C     Replaced all code by a call to JALLGP.
C
C----<
C     _______________________________________________________
C
C*    Section 0. Definition of variables.
C     _______________________________________________________
C
      IMPLICIT NONE
#include "jparams.h"
#include "parim.h"
#include "nifld.common"
C
C     Subroutine arguments
C
      COMPLEX   PSHUP
      DIMENSION PSHUP(*)
      INTEGER   KTRUNC
      REAL      PNORTH, PSOUTH, PWEST, PEAST, PLATINC, PLONINC
      REAL      POUTF
      DIMENSION POUTF(*)
      INTEGER   KRET
C
C     Parameters
      INTEGER JPROUTINE
      PARAMETER ( JPROUTINE = 30000 )
C
C     Local variables
C
C     _______________________________________________________
C
C*    Section 1.    Initialization.
C     _______________________________________________________
C
  100 CONTINUE
      CALL JDEBUG( )
C
      IF( NDBG.GT.0 )
     X  CALL INTLOG(JP_DEBUG,'JALLWN: Calling JALLGP', JPQUIET)
C
      IF( RISTRET.NE.0 ) THEN
        CALL JSLLGP( PSHUP, KTRUNC, PNORTH, PSOUTH, PWEST, PEAST,
     X               PLATINC, PLONINC, POUTF, KRET)
      ELSE
        CALL JALLGP( PSHUP, KTRUNC, PNORTH, PSOUTH, PWEST, PEAST,
     X               PLATINC, PLONINC, POUTF, KRET)
      ENDIF
C
      IF( NDBG.GT.0 )
     X  CALL INTLOG(JP_DEBUG,'JALLWN: Returned from JALLGP', JPQUIET)
C
C     _______________________________________________________
C
C*    Section 9. Return to calling routine. Format statements
C     _______________________________________________________
C
 900  CONTINUE
C
      RETURN
      END

C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      INTEGER FUNCTION HNTFAP(INGRIB,INLEN)
C
C---->
C**** HNTFAP
C
C     Purpose
C     -------
C
C     Prepare to interpolate input field...
C
C
C     Interface
C     ---------
C
C     IRET = HNTFAP(INGRIB,INLEN)
C
C     Input
C     -----
C
C     INGRIB - Input field (packed).
C     INLEN  - Input field length (words).
C
C
C     Output
C     ------
C
C     Field unpacked values are in ZNFELDI, rotated if necessary.
C
C     Returns: 0, if OK. Otherwise, an error occured in interpolation.
C
C
C     Method
C     ------
C
C     Calls HNTFAPS to handle rotation when input and output fields
C     are both spectral.
C
C     Calls HNTFAPH in all other cases.
C
C
C     Externals
C     ---------
C
C     HNTFAPS - Handle rotation when input and output fields
C               are both spectral.
C     HNTFAPH - Handle rotation in all other cases.
C
C
C     Author
C     ------
C
C     J.D.Chambers     ECMWF     January 31, 2001
C
C
C----<
C
C     -----------------------------------------------------------------|
C*    Section 0.   Variables
C     -----------------------------------------------------------------|
C
      IMPLICIT NONE
C
#include "parim.h"
#include "nifld.common"
#include "nofld.common"
#include "grfixed.h"
#include "intf.h"
C
C     Parameters
C
      INTEGER JPROUTINE
      PARAMETER (JPROUTINE = 40100 )
C
C     Function arguments
C
      INTEGER INGRIB(*),INLEN
C
C     Local variables
C
      INTEGER IRET
C
C     Externals
C
      INTEGER  HNTFAPS, HNTFAPH
      EXTERNAL HNTFAPS, HNTFAPH
C
C     -----------------------------------------------------------------|
C*    Section 1.   Initialise
C     -----------------------------------------------------------------|
C
  100 CONTINUE
C
      HNTFAP = 0
C
C     -----------------------------------------------------------------|
C*    Section 2.   Split handling in case there are rotations to do.
C     -----------------------------------------------------------------|
C
  200 CONTINUE
C
C     Is the interpolation from SH to SH?
C
      IF( ((NIREPR.EQ.JPSPHERE).OR.(NIREPR.EQ.JPSPHROT)) .AND.
     X    ((NOREPR.EQ.JPSPHERE).OR.(NOREPR.EQ.JPSPHROT)) ) THEN
C
        IRET = HNTFAPS(INGRIB,INLEN)
C
      ELSE
C
        IRET = HNTFAPH(INGRIB,INLEN)
C
      ENDIF
C
      IF( IRET.NE.0 ) HNTFAP = JPROUTINE
C
C     -----------------------------------------------------------------|
C*    Section 9.   Closedown.
C     -----------------------------------------------------------------|
C
  900 CONTINUE
C
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

       INTEGER FUNCTION INTF( INGRIB,INLEN,FLDIN,OUTGRIB,OUTLEN,FLDOUT)
C
C---->
C**** INTF
C
C     Purpose
C     -------
C
C     Interpolate input field...
C
C
C     Interface
C     ---------
C
C     IRET = INTF( INGRIB,INLEN,FLDIN,OUTGRIB,OUTLEN,FLDOUT)
C
C     Input
C     -----
C
C     INGRIB - Input field (packed).
C     INLEN  - Input field length (words).
C     FLDIN  - Input field (unpacked).
C
C
C     Output
C     ------
C
C     OUTGRIB - Output field (packed).
C     OUTLEN  - Output field length (words).
C     FLDOUT  - Output field (unpacked).
C
C
C     Method
C     ------
C
C     Call interpolation routines.
C
C
C     Externals
C     ---------
C
C     IBASINI - Ensure basic interpolation setup is done.
C     INSANE  - Ensure no outrageous values given for interpolation.
C     PDDEFS  - Setup interpolation using parameter dependent options.
C     PRECIP  - Says if field is to have 'precipitation' treatment
C     INTFAU  - Prepare to interpolate unpacked input field.
C     INTFAP  - Prepare to interpolate packed input field.
C     HNTFAU  - Prepare to interpolate unpacked input field (using
C               Hirlam 12-point for rotations).
C     HNTFAP  - Prepare to interpolate packed input field (using
C               Hirlam 12-point for rotations).
C     INTFB   - Interpolate input field.
C     INTLOG  - Log error message.
C     JDEBUG  - Checks environment to switch on/off debug
C     INTWAVE - Interpolate quasi-regular lat/long wave field
C               to a regular lat/long field.
C     OCEANP  - Interpolate GRIB ocean field.
C     RESET_C - Reset interpolation handling options using GRIB product.
C
C
C     Author
C     ------
C
C     J.D.Chambers     ECMWF     Aug 1994
C
C----<
C
      IMPLICIT NONE
C
C     Function arguments
C
      INTEGER INGRIB(*),OUTGRIB(*),INLEN,OUTLEN
      REAL FLDIN(*),FLDOUT(*)
C
#include "parim.h"
#include "nifld.common"
#include "nofld.common"
#include "grfixed.h"
#include "intf.h"
#include "current.h"
C
C     Parameters
C
      INTEGER JPROUTINE
      PARAMETER (JPROUTINE = 26000 )
C
C     Local variables
C
      INTEGER IWORD, IRET, IORIGLN, ISAME
      INTEGER LOOP, IIHOLD, IOHOLD
      DIMENSION IIHOLD(4), IOHOLD(4)
      INTEGER NUMTABL, NUMPROD
      LOGICAL L98WAVE, LUNROT
      CHARACTER*1 HTYPE
C
C     Externals
C
      INTEGER IBASINI, PDDEFS, INSANE
      INTEGER INTFAU, INTFAP, INTFB, HNTFAU, HNTFAP
      INTEGER INTWAVE2, INTWAVU, OCEANP, OCEANU, RESET_C !, INTWAVE
      LOGICAL PRECIP
C
C     -----------------------------------------------------------------|
C*    Section 1.   Initialise
C     -----------------------------------------------------------------|
C
  100 CONTINUE
C
      INTF = 0
      IRET = 0
      IORIGLN = OUTLEN
      NOMISS = 0
      LUNROT = .FALSE.
      OUTLROT = 0

C
C     Save input and output area definitions
C
      DO 110 LOOP = 1, 4
        IIHOLD(LOOP) = NIAREA(LOOP)
        IOHOLD(LOOP) = NOAREA(LOOP)
  110 CONTINUE
C
C     Check if debug option turned on
C
      CALL JDEBUG()
C
C     If the input is a set of U and V rotated lat/long fields,
C     set return length to zero and do not copy input to output
C
      IF( (NIREPR.EQ.JPREGULAR).AND.LWIND.AND.LNOROTA ) THEN
        OUTLEN = 0
        IRET   = 0
        CALL INTLOG(JP_DEBUG,
     X    'INTF: Input U and V rotated lat/long fields ...',JPQUIET)
        CALL INTLOG(JP_DEBUG,
     X    'INTF: ... no further interpolation has been done',JPQUIET)
        GOTO 900
      ENDIF
C
C     -----------------------------------------------------------------|
C*    Section 2.   Prepare to interpolate input field.
C     -----------------------------------------------------------------|
C
  200 CONTINUE
C
C     Ensure that basic initialisation has been done
C
      IRET = IBASINI(0)
      IF( IRET.NE.0 ) THEN
        CALL INTLOG(JP_ERROR,'INTF: basic initialisation fail.',JPQUIET)
        INTF = IRET
        GOTO 900
      ENDIF
C
C     Allocate work array ZNFELDI if not already done.
C
       LACCUR = .FALSE.
      IF( NIFORM.EQ.1 ) THEN
        IF( IZNJDCI.NE.1952999238 ) THEN
          CALL JMEMHAN( 19, IZNFLDI, JPEXPAND, 1, IRET)
          IF( IRET.NE.0 ) THEN
            CALL INTLOG(JP_WARN,'INTF: ZNFELDI allocation fail',JPQUIET)
            INTF = IRET
            GOTO 900
          ENDIF
          IZNJDCI = 1952999238
        ENDIF
C
C       Unpack the field headers for packed input.
C
        CALL INTLOG(JP_DEBUG, 'INTF: Unpack GRIB headers.',JPQUIET)
        IRET = 1
        IWORD = 0
        CALL GRIBEX(ISEC0, ISEC1, ISEC2, ZSEC2, ISEC3, ZSEC3, ISEC4,
     X              ZNFELDI, JPEXPAND, INGRIB, INLEN, IWORD, 'J',IRET)
C
        IF( (IRET.NE.0).AND.(IRET.NE.811) ) THEN
          CALL INTLOG(JP_ERROR,
     X      'INTF: Failed to unpack GRIB heders.',JPQUIET)
          INTF = IRET
          GOTO 900
        ENDIF
C
C       Reset interpolation handling options using GRIB values.
C
        IRET = RESET_C( ISEC1, ISEC2, ZSEC2, ISEC4)
        IF( IRET.NE.0 ) THEN
          CALL INTLOG(JP_WARN,
     X      'INTF: Setup of interp. options from GRIB failed',JPQUIET)
          INTF = IRET
          GOTO 900
        ENDIF
C end of NIFORM = 1
       LACCUR = .TRUE.
      ENDIF
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
cs   Regular Gaussian has to be set here for unpacked fields
      IF( NIFORM.NE.1 ) THEN
cs    this is for merging with grib_api
        LUVCOMP = .FALSE.
        IF( NOREPR.EQ.JPNOTYPE ) THEN
         IF( (NOGAUSO.NE.NOGAUSS).OR.(HOGAUST.NE.'F') ) THEN
            HTYPE = 'F'
            CALL JGETGG(NOGAUSS,HTYPE,ROGAUSS,NOLPTS,IRET)
            IF( IRET.NE.0 ) THEN
              CALL INTLOG(JP_ERROR,
     X          'INTF: JGETGG failed, NOGAUSS = ',NOGAUSS)
              INTF = IRET
              GOTO 900
            ENDIF
            NOGAUSO = NOGAUSS
            HOGAUST = HTYPE
          ENDIF
          NOREPR = JPGAUSSIAN
        ENDIF
      ENDIF
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC

C     Check that no outrageous values given for interpolation
C
      ISAME = INSANE()
      IF ( ISAME .GT. 0 ) THEN
        CALL INTLOG(JP_ERROR,
     X    'INTF: Interpolation cannot use given values.',JPQUIET)
        INTF = ISAME
        GOTO 900
      ENDIF
Cs setting of out Date
      NODATE = NIDATE
C
C     If output is same as the input, set return length to zero and
C     do not copy input to output
C
      IF( ISAME.EQ.-1 ) THEN
        OUTLEN = 0
        IRET   = 0
        CALL INTLOG(JP_DEBUG,
     X    'INTF: Output is same as the input.',JPQUIET)
        CALL INTLOG(JP_DEBUG,
     X    'INTF: No interpolation carried out.',JPQUIET)
        GOTO 900
      ENDIF
C
C     Set precipitation flag if user hasn't
C
      IF( .NOT.LPRECSET ) LPREC = PRECIP()
C
C     Handle packed fields
C
C
C     -----------------------------------------------------------------|
C*    Section 3.   Use special interpolation for:
C                  - an ECMWF wave field.
C                  - a reduced latitude-longitude field
C     -----------------------------------------------------------------|
C
  300   CONTINUE
C
        NUMTABL = NITABLE
        NUMPROD = NUMTABL*1000 + NIPARAM
        L98WAVE = (NUMTABL.EQ.140).OR.
     X            (NUMPROD.EQ.131229).OR.
     X            (NUMPROD.EQ.131232).OR.
     X            (NIREPR.EQ.26)
      IF( L98WAVE ) THEN
          CALL INTLOG(JP_DEBUG,
     X      'INTF: Wave-type interpolation required.',JPQUIET)
C
        OUTLEN = IORIGLN
        IF( NIFORM.EQ.1 ) THEN
             IRET = INTWAVE2(INGRIB,INLEN,OUTGRIB,OUTLEN)
cs             IRET = INTWAVE(INGRIB,INLEN,OUTGRIB,OUTLEN)
        ELSE
            IRET = INTWAVU(FLDIN,INLEN,FLDOUT,OUTLEN)
        ENDIF
          IF( IRET.EQ.0 ) THEN
            CALL INTLOG(JP_DEBUG,
     X        'INTF: Wave-type interpolated OK.',JPQUIET)
          ELSE
            CALL INTLOG(JP_DEBUG,
     X        'INTF: Wave-type interpolation failed.',JPQUIET)
          ENDIF
          INTF = IRET
          GOTO 900
        ENDIF
C
C     -----------------------------------------------------------------|
C*    Section 4.   Use special interpolation for an ECMWF ocean field.
C     -----------------------------------------------------------------|
C
  400   CONTINUE
C
        IF( ((ISEC1(24).EQ.1).AND.(ISEC1(37).EQ.4)).OR.LOCEAN ) THEN
C
          CALL INTLOG(JP_DEBUG,
     X      'INTF: Ocean field interpolation required.',JPQUIET)
C
          OUTLEN = IORIGLN
          IF( NIFORM.EQ.1 ) THEN
            IRET = OCEANP(INGRIB,INLEN,OUTGRIB,OUTLEN)
          ELSE
            IRET = OCEANU(FLDIN,INLEN,FLDOUT,OUTLEN)
          ENDIF
          IF( IRET.EQ.0 ) THEN
            CALL INTLOG(JP_DEBUG,
     X        'INTF: Ocean field interpolated OK.',JPQUIET)
          ELSE
            CALL INTLOG(JP_DEBUG,
     X        'INTF: Ocean field interpolation failed.',JPQUIET)
          ENDIF
          INTF = IRET
          GOTO 900
        ENDIF
C
C     -----------------------------------------------------------------|
C*    Section 7.   Continue interpolation setup in other cases.
C     -----------------------------------------------------------------|
C
  500   CONTINUE
      IF( NIFORM.EQ.1 ) THEN
C
C       Unpack (and rotate) field if necessary
C
        IF( LUSEHIR ) THEN
          IRET = HNTFAP(INGRIB,INLEN)
        ELSE
          IRET = INTFAP(INGRIB,INLEN)
        ENDIF
C
C       If a bitmap encountered with some missing values (IRET=-4),
C       product cannot be interpolated unless 'missingvalue'
C       specified via INTIN
C
        IF( .NOT.LIMISSV ) THEN
          IF( (IRET.NE.0).AND.(IRET.NE.-2) ) THEN
            IF( IRET.EQ.-4 ) THEN
              CALL INTLOG(JP_WARN,
     X        'INTF: Product has bitmap and missing data.',JPQUIET)
              CALL INTLOG(JP_WARN,
     X        'INTF: Try Using INTIN "missingvalue" option',JPQUIET)
            ENDIF
            INTF = -4
            GOTO 900
          ENDIF
        ELSE
          IF( IRET.GT.0 ) THEN
            CALL INTLOG(JP_WARN,
     X        'INTF: Problems preparing for interpolation.',JPQUIET)
            INTF = IRET
            GOTO 900
          ENDIF
        ENDIF
C
C     Handle unpacked fields
C
      ELSE
        LUNROT = .TRUE.
        IF( LUSEHIR ) THEN
          IRET = HNTFAU(FLDIN,INLEN)
        ELSE
          IRET = INTFAU(FLDIN,INLEN)
        ENDIF
      ENDIF
C
      IF( (IRET.NE.0).AND.(IRET.NE.-2) ) THEN
        CALL INTLOG(JP_WARN,'INTF: Prepare interpolate fail',JPQUIET)
        INTF = IRET
        GOTO 900
      ENDIF
C
C     Field values are now in ZNFELDI.
C
C     Setup output length same as input GRIB length in case straight
C     copy is done later (ie input is transferred direct to output
C     without postprocessing).
C
      OUTLEN = INLEN

C
C     Setup interpolation options based on parameter in field.
C
      IRET = PDDEFS()
      IF( IRET.NE.0 ) THEN
        CALL INTLOG(JP_ERROR,
     X    'INTF: Setup interpolation options from param failed',JPQUIET)
        INTF = IRET
        GOTO 900
      ENDIF
C
C     -----------------------------------------------------------------|
C*    Section 8.   Interpolate input field.
C     -----------------------------------------------------------------|
C
  700 CONTINUE
C
C     If all values missing, set flag to ensure all are missing in the
C     interpolated field.
C
      IF( ISEC4(1).LT.0 ) NOMISS = ISEC4(1)
C
C     Perform the interpolation.
C
      CALL INTLOG(JP_DEBUG,'INTF: Perform the interpolation.',JPQUIET)
C
      OUTLEN = IORIGLN
      IF( NIFORM.EQ.1 ) THEN
        IRET = INTFB( INGRIB,INLEN,OUTGRIB,OUTLEN,FLDOUT)
      ELSE
        IRET = INTFB( ZNFELDI,INLEN,OUTGRIB,OUTLEN,FLDOUT)
      ENDIF
C
      IF( LUNROT.AND.LNOROTA ) THEN
          OUTLEN = OUTLROT
      ENDIF
C
      IF( IRET.NE.0 ) THEN
        CALL INTLOG(JP_ERROR,'INTF: Interpolation failed.',JPQUIET)
        INTF = IRET
        GOTO 900
      ELSE
C
        CALL INTLOG(JP_DEBUG,
     X    'INTF: Interpolation finished successfully.',JPQUIET)
      ENDIF
C
C     -----------------------------------------------------------------|
C*    Section 9.   Closedown.
C     -----------------------------------------------------------------|
C
  900 CONTINUE
C
C     Clear change flags for next product processing
C
      LCHANGE = .FALSE.
      LSMCHNG = .FALSE.
C
C     Restore input and output area definitions
C
      DO 910 LOOP = 1, 4
        NIAREA(LOOP) = IIHOLD(LOOP)
        NOAAPI(LOOP) = NOAREA(LOOP)
        NOAREA(LOOP) = IOHOLD(LOOP)
  910 CONTINUE
C
      RETURN
      END

C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      LOGICAL FUNCTION JFINDFN( DIRNAME, FILENAME, KLEN, KUNIT)
C
C---->
C**** JFINDFN
C
C     Purpose
C     _______
C
C     Completes the pathname given by a directory and filename, and
C     checks if the file exists.
C
C     Interface
C     _________
C
C     LFOUND = JFINDFN( DIRNAME, FILENAME, KLEN, KUNIT)
C
C     Input parameters
C     ________________
C
C     DIRNAME  - the directory name.
C     FILENAME - the file name.
C     KLEN     - number of characters in the name
C
C     Output parameters
C     _________________
C
C     The function returns .TRUE. if the file is opened; in which case:
C     FILENAME - the full pathname.
C     KLEN     - number of characters in the full pathname
C     KUNIT    - the opened file descriptor (from PBOPEN).
C
C     Otherwise it returns .FALSE. and FILENAME and KLEN are unchanged
C
C     Common block usage
C     __________________
C
C     None.
C
C     Externals
C     _________
C
C     PBOPEN  - opens a file.
C
C     Reference
C     _________
C
C     None.
C
C     Comments
C     ________
C
C     None.
C 
C     Author
C     ______
C
C     J.D.Chambers      *ECMWF*      Mar 1996
C
C----<
C     _______________________________________________________
C
      IMPLICIT NONE
C
C     Parameters
Cjdc  INTEGER JPROUTINE
Cjdc  PARAMETER ( JPROUTINE = 30800 )
C
C     Subroutine arguments
      CHARACTER*(*) DIRNAME, FILENAME
      INTEGER KLEN, KUNIT
C
C     Local variables
      INTEGER IBLANK, IRET
      CHARACTER*512 FULLPATH
      CHARACTER*256 SAVENAME
C

C     _______________________________________________________
C
C*    Section 1. Try the full path name..
C     _______________________________________________________
C
  100 CONTINUE
C
      JFINDFN = .TRUE.
      SAVENAME = FILENAME
C
      IBLANK = INDEX(DIRNAME, ' ') - 1
      FULLPATH  = DIRNAME(1:IBLANK) // '/' // FILENAME(1:KLEN)
      IBLANK = INDEX(FULLPATH, ' ') - 1
      FILENAME(1:IBLANK) = FULLPATH(1:IBLANK)
C
Cjdc  print*,'***',FILENAME(1:IBLANK),'***'
      CALL PBOPEN(KUNIT, FILENAME(1:IBLANK), 'r', IRET)
      IF( IRET.NE.0 ) THEN
        FILENAME = SAVENAME
        JFINDFN = .FALSE.
      ELSE
        KLEN = INDEX(FULLPATH, ' ') - 1
        FILENAME(1:KLEN) = FULLPATH(1:KLEN)
      ENDIF
C
C     _______________________________________________________
C
C*    Section 9. Return.
C     _______________________________________________________
C
  900 CONTINUE
C
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      INTEGER FUNCTION CHKTAB2 ( KSEC1,
     X                           HFIRST, HSECOND, HTHIRD, HFOURTH)
C
C---->
C**** CHKTAB2
C
C     Purpose
C     -------
C
C     Checks whether or not a parameter appears in a given code
C     table 2 for WMO code FM 92-X Ext. GRIB (WMO standard, ECMWF local,
C     or even local from another centre).
C
C
C     Interface
C     ---------
C
C     IRET = CHKTAB2(KSEC1, HFIRST, HSECOND, HTHIRD, HFOURTH)
C
C     Input
C     -----
C
C     KSEC1  - Section 1 values for a GRIB product.
C
C
C     Output
C     ------
C
C     HFIRST  - First line of descriptor:  MARS mnemonic
C     HSECOND - Second line of descriptor: Parameter description
C     HTHIRD  - Third line of descriptor:  Units for the parameter
C     HFOURTH - Fourth line of descriptor: Description of units
C
C     Function return value is:
C            0 - Parameter found in table
C        20001 - No match found for the parameter number in the given table.
C        20002 - Error opening the file holding the given table.
C        20003 - Error finding an unused fortran unit number for reading table.
C
C
C     Method
C     ------
C
C     Use TAB2FIL to determine file name for code table.
C
C     Entry for each parameter in table has the format (without quotes):
C        "......................"         Separator
C        "051"                            Paramter number
C        "MX2T24"                         MARS mnemonic
C        "Max 2m temp"                    Parameter description
C        "K"                              Units for the parameter
C        "During previous 24 hours"       Further description
C
C     There is a termination "......................" line in the file
C     and there may be lines of comment before the first parameter entry.
C
C     The current parameter definition file is kept open between calls.
C
C
C     Externals
C     ---------
C     TAB2FIL - Builds code table 2 file name.
C
C
C     Author
C     ------
C
C     J.D.Chambers     ECMWF     March 1999
C
C
C     MODIFICATIONS
C     _____________
C
C     J. Clochard, Meteo France, for ECMWF - June 1999.
C     Argument KSEC1 instead of KPARAM and KTABLE for replacement of
C     LOCAL2K, and code tables management.
C     Use TAB2FIL function for file name building.
C
C     _______________________________________________________
C----<
C
C
      IMPLICIT NONE
C
C     Parameters
C
      INTEGER JPROUTINE, JPMAXTB, JPDITB
      PARAMETER ( JPROUTINE = 20000, JPMAXTB = 10, JPDITB = 256 )
C
C     Function arguments
C
      INTEGER KSEC1 (*)
C
      CHARACTER*(*) HFIRST, HSECOND, HTHIRD, HFOURTH
C
C     Local variables
C
      LOGICAL LNEWTAB
      INTEGER TABLE2(JPDITB,JPMAXTB), INDTAB, NUMTAB, LOOP, NEXT
      INTEGER IPR, IRET, ISTATUS, ITABLE, IPARAM, ICENTR
C
      CHARACTER*81 YFIRST(2:JPDITB,JPMAXTB), YSECOND(2:JPDITB,JPMAXTB)
      CHARACTER*81 YTHIRD(2:JPDITB,JPMAXTB), YFOURTH(2:JPDITB,JPMAXTB)
      CHARACTER*256 YFILE, YDUMMY
C
      INTEGER NUNIT
C
      SAVE NUNIT, NUMTAB, TABLE2, YFIRST, YSECOND, YTHIRD, YFOURTH
C
C     External functions
C
      INTEGER TAB2FIL
      EXTERNAL TAB2FIL
C
      DATA NUMTAB/0/
C
C
C ------------------------------------------------------------------
C*    Section 1.   Initialise
C ------------------------------------------------------------------
C
  100 CONTINUE
C
C     See if a new table is requested.
C
      ITABLE = KSEC1(1)
      IF( KSEC1(22).EQ.98 ) THEN
        ICENTR = 98
      ELSE
        ICENTR = KSEC1(2)
      ENDIF
      IPARAM = KSEC1(6)
C
      IF( MAX( ITABLE, IPARAM) .GT. 127 ) THEN
        ITABLE = 1000*ICENTR + ITABLE
      ENDIF
C
      LNEWTAB = .TRUE.
C     print *, 'CHKTAB2: TABLE2(1,:)=', TABLE2(1,:NUMTAB)
      DO LOOP = 1, NUMTAB
        IF( ITABLE.EQ.TABLE2(1,LOOP) ) THEN
          LNEWTAB = .FALSE.
          INDTAB = LOOP
          GOTO 300
        ENDIF
      ENDDO
C
C     Read values in the new table.
C
      IF( LNEWTAB ) THEN
        NUMTAB = NUMTAB + 1
        IF( NUMTAB.GT.JPMAXTB ) NUMTAB = 1
        INDTAB = NUMTAB
        TABLE2(1,INDTAB) = ITABLE
C
        DO LOOP = 2, JPDITB
          TABLE2(LOOP,INDTAB) = 0
        ENDDO
C
C       Find an unused fortran unit number
C
        IPR = 0
        CALL FTN1CR(NUNIT, IPR, IRET)
        IF( IRET.NE.0 ) THEN
          NUMTAB = NUMTAB - 1
          CHKTAB2 = JPROUTINE + 3
          RETURN
        ENDIF
C
C       Build filename
C
        IRET = TAB2FIL( KSEC1(1), IPARAM, ICENTR, YFILE )
C
C       Open file
C
        OPEN(UNIT=NUNIT, FILE=YFILE, ERR=910, IOSTAT=ISTATUS,
     X       STATUS='OLD',FORM='FORMATTED')
        REWIND(UNIT=NUNIT)
C
C ------------------------------------------------------------------
C*    Section 2.   Fill the new parameter table.
C ------------------------------------------------------------------
C
  200   CONTINUE
        NEXT = 1
C
C       Skip lines until '......................' separator found
C
  210   CONTINUE
        READ(NUNIT,'(A)',END=230) YDUMMY
        IF( YDUMMY(1:22).EQ.'......................') GOTO 225
        GOTO 210
C
C       Loop through file
C
  220   CONTINUE
          READ(NUNIT,'(A)',END=230) YDUMMY
  225     CONTINUE
          NEXT = NEXT + 1
          READ(NUNIT,'(I3.3)',END=230) TABLE2(NEXT,INDTAB)
          READ(NUNIT,'(A)',END=230) YFIRST(NEXT,INDTAB)
          READ(NUNIT,'(A)',END=230) YSECOND(NEXT,INDTAB)
          READ(NUNIT,'(A)',END=230) YTHIRD(NEXT,INDTAB)
          READ(NUNIT,'(A)',END=230) YFOURTH(NEXT,INDTAB)
        GOTO 220
C
 230    CONTINUE
C
        CLOSE(UNIT=NUNIT)
C
      ENDIF
C
C ------------------------------------------------------------------
C*    Section 3.   Search for parameter in the table.
C ------------------------------------------------------------------
C
  300 CONTINUE
C
      CHKTAB2 = JPROUTINE + 1
C
      DO LOOP = 2,JPDITB
        IF( IPARAM.EQ.TABLE2(LOOP,INDTAB) ) THEN
          HFIRST = YFIRST(LOOP,INDTAB)
          HSECOND = YSECOND(LOOP,INDTAB)
          HTHIRD = YTHIRD(LOOP,INDTAB)
          HFOURTH = YFOURTH(LOOP,INDTAB)
          CHKTAB2 = 0
          RETURN
        ENDIF
      ENDDO
C
C ------------------------------------------------------------------
C*    Section 9.   Closedown.
C ------------------------------------------------------------------
C
C     Drop through if not found.
C
      RETURN   
C
C     Error opening table file
C
 910  CONTINUE
      TABLE2(1,NUMTAB) = -1
      NUMTAB = NUMTAB - 1
      CHKTAB2 = JPROUTINE + 2
      RETURN
      END

C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE BUENS3(KSEC3,KTDLEN,KTDLST,KBUFL,KBUFF,KERR)
C
C**** *BUENS3*
C
C
C     PURPOSE.
C     --------
C
C          PACK SECTION 3 OF BUFR MESSAGE.
C
C
C**   INTERFACE.
C     ----------
C
C          *CALL* *BUENS3( KSEC3,KTDLEN,KTDLST,KBUFL,KBUFF,KERR)*
C
C        INPUT :
C               *KSEC3*   -  ARRAY CONTAINING SECTION 3 INFORMATION
C                            KSEC3( 1)-- LENGTH OF SECTION 3 (BYTES)
C                            KSEC3( 2)-- RESERVED
C                            KSEC3( 3)-- NUMBER OF SUBSETS
C                            KSEC3( 4)-- FLAG (DATA TYPE,DATA COMPRESSION)
C               *KTDLEN*  -  NUMBER OF DATA DESCRIPTORS IN SECTION 3
C               *KTDLST*  -  ARRAY CONTAINING DATA DESCRIPTORS IN SECTION 3
C
C        OUTPUT :
C               *KBUFL*   -  LENGTH OF BUFR MESSAGE (WORDS)
C               *KBUFF*   -  ARRAY CONTAINING BUFR MESSAGE
C               *KERR*    -  RETURNED ERROR CODE
C
C     METHOD.
C      -------
C
C
C
C
C     EXTERNALS.
C     ----------
C
C          BUPCK        - PACKS BIT PATHERN
C          BUOCTN       - SET LENGTH OF SECTION
C
C     REFERENCE.
C     ----------
C
C          NONE.
C
C     AUTHOR.
C     -------
C
C          M. DRAGOSAVAC    *ECMWF*       01/02/91.
C
C
C     MODIFICATIONS.
C     --------------
C
C          NONE.
C
C
      IMPLICIT LOGICAL(L,O,G), CHARACTER*8(C,H,Y)
C
C
#     include "parameter.F"
#     include "bcomunit.F"
#     include "bcmwork.F"
C
      DIMENSION KBUFF(KBUFL)
      DIMENSION KTDLST(KTDLEN)
C
      DIMENSION KSEC3(JSEC3)
C
#ifndef R_4
      REAL*8 RVIND
      REAL*8 EPS
#else
      REAL   RVIND
      REAL   EPS
#endif
C     ------------------------------------------------------------------
C*          1.   PACK PRELIMINARY ITEMS OF SECTION 3.
C                --------------------------------------
 100  CONTINUE
C
      IF( KERR.NE.0 ) RETURN
C
C*          1.1  KEEP POINTERS TO THE BEGINING OF THE SECTION.
C                ---------------------------------------------
 110  CONTINUE
C
      IWPTB = NWPT
      IBPTB = NBPT
C
C
C*          1.2   PACK LENGTH OF SECTION 3.
C                 -------------------------
 120  CONTINUE
C
      CALL BUPCK(NBPW,KBUFF(NWPT),0,NWPT,NBPT,24,KERR)
      IF(KERR.GT.0) THEN
         WRITE(KNTN,*) 'ERROR PACKING LENGTH OF SECTION 3.'
         RETURN
      END IF
C
C
C*          1.3    PACK ZERO BYTE AND PUT IT IN KSEC3(2).
C                  --------------------------------------
 130  CONTINUE
C
      CALL BUPCK(NBPW,KBUFF(NWPT),0,NWPT,NBPT,8,KERR)
      IF(KERR.GT.0) THEN
         WRITE(KNTN,*) 'ERROR PACKING RESERVED BYTE IN SECTION 3.'
         RETURN
      END IF
C
C*          1.4    PACK NUMBER OF DATA SUB-SETS.
C                  -----------------------------
 140  CONTINUE
C
      IF(KSEC3(3).GT.65535) THEN
         KERR=27
         CALL BUERR(KERR)
         RETURN
      END IF
C
      CALL BUPCK(NBPW,KBUFF(NWPT),KSEC3(3),NWPT,NBPT,16,KERR)
      IF(KERR.GT.0) THEN
         WRITE(KNTN,*) 'ERROR PACKING KSEC3(3) IN SECTION 3.'
         RETURN
      END IF
C
C
C*          1.5    PACK INTEGER VALUE OF THE OCTET
C                  ---------------------------------
C                  CONTAINIG FLAG BITS.
C                  --------------------
 150  CONTINUE
C
      IF(KSEC3(3).LE.1) THEN
         KSEC3(4)=IBCLR(KSEC3(4),6)
      END IF
      CALL BUPCK(NBPW,KBUFF(NWPT),KSEC3(4),NWPT,NBPT,8,KERR)
      IF(KERR.GT.0) THEN
         WRITE(KNTN,*) 'ERROR PACKING KSEC3(4) IN SECTION 3.'
         RETURN
      END IF
C
C     -----------------------------------------------------------------
C*          1.6  PACK DATA DESCRIPTORS.
C                ----------------------
 160  CONTINUE
C
C
      DO 161 I=1,KTDLEN
      IFIXIY=KTDLST(I)
C
      II=IFIXIY/1000
      IY=IFIXIY-II*1000
      IF=II/100
      IX=II-IF*100
C
      CALL BUPCK(NBPW,KBUFF(NWPT),IF,NWPT,NBPT,2,KERR)
      IF(KERR.GT.0) THEN
         WRITE(KNTN,*) 'ERROR PACKING ',I,' DESCRIPTOR IN SECTION 3.'
         RETURN
      END IF
      CALL BUPCK(NBPW,KBUFF(NWPT),IX,NWPT,NBPT,6,KERR)
      IF(KERR.GT.0) THEN
         WRITE(KNTN,*) 'ERROR PACKING ',I,' DESCRIPTOR IN SECTION 3.'
         RETURN
      END IF
      CALL BUPCK(NBPW,KBUFF(NWPT),IY,NWPT,NBPT,8,KERR)
      IF(KERR.GT.0) THEN
         WRITE(KNTN,*) 'ERROR PACKING ',I,' DESCRIPTOR IN SECTION 3.'
         RETURN
      END IF
C
C
 161  CONTINUE
C
C*          1.7  SET UP LENGTH OF THE SECTION 1.
C               --------------------------------
 170  CONTINUE
C
      CALL BUOCTN(IWPTB,IBPTB,KBUFL,KBUFF,KERR)
      IF(KERR.GT.0) RETURN
C
C
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities
C granted to it by virtue of its status as an intergovernmental organisation
C nor does it submit to any jurisdiction.
C

      INTEGER FUNCTION WAVEIDX(KOLDNUM,NUMOLD,OLDLATS,OLDWEST,OLDEAST,
     X                         KNEWNUM, NUMNEW, NEWLATS,
     X                         NEWIDX, DISTNEW)
C
C---->
C*****WAVEIDX*
C
C     PURPOSE
C     -------
C
C     Determines which nearest-neighbour values of an input global wave
C     2D-spectra grid field to use for an output global wave 2D-spectra
C     grid field.
C
C
C     INTERFACE
C     ---------
C
C     IRET = WAVEIDX(KOLDNUM,NUMOLD,OLDLATS,OLDWEST,OLDEAST,
C    X               KNEWNUM, NUMNEW, NEWLATS,
C    X               NEWIDX, DISTNEW)
C
C     Input arguments
C     ---------------
C
C     KOLDNUM - No. of meridians from North to South pole (input field)
C     NUMOLD  - Array giving number of points along each latitude
C               (empty latitudes have entry 0)
C     OLDLATS - input field latitudes
C     OLDWEST - western longitude of the input field (degrees)
C     OLDEAST - eastern longitude of the input field (degrees)
C
C     KNEWNUM - No. of meridians from North to South pole (output field)
C     NUMNEW  - Array giving number of points along each latitude
C               (empty latitudes have entry 0)
C     NEWLATS - output field latitudes
C
C     Output arguments
C     ----------------
C
C     NEWIDX  - Indices of four neighbours
C     DISTNEW - Distances of current 'box' edges from new point
C
C     Function returns 0 if the interpolation was OK.
C
C
C     METHOD
C     ------
C
C     The indices of the nearest four neighbouring grid points of the
C     input field is assigned to each point of the output grid.
C     The indices are zero if the output grid point is 'missing'.
C
C     The input field can be regular or quasi-regular, and can be
C     global or a subarea.
C     The output field can be regular or quasi-regular.
C
C
C     EXTERNALS
C     ---------
C
C     INTLOG  - Log error message.
C
C
C     REFERENCE
C     ---------
C
C     None
C
C
C     Author.
C     -------
C
C     J.D.Chambers      ECMWF    January  1998
C
C
C----<
C
      IMPLICIT NONE
C
#include "parim.h"
C
C     Parameters
C
      INTEGER JPROUTINE
      PARAMETER ( JPROUTINE = 19410 )
      INTEGER JPLLMAX, JPNMOUT
      PARAMETER ( JPLLMAX = 1801 ) ! allow up to 0.1 degree resolution
      PARAMETER ( JPNMOUT = 3600 ) ! allow up to 0.1 degree resolution
C
      INTEGER JPNW, JPNE, JPSW, JPSE, JPN, JPS
      INTEGER JPDISNW, JPDISNE, JPDISSW, JPDISSE
      PARAMETER (JPNW   = 1)
      PARAMETER (JPNE   = 2)
      PARAMETER (JPSW   = 3)
      PARAMETER (JPSE   = 4)
      PARAMETER (JPN    = 5)
      PARAMETER (JPS    = 6)
      PARAMETER (JPDISNW = 7)
      PARAMETER (JPDISNE = 8)
      PARAMETER (JPDISSW = 9)
      PARAMETER (JPDISSE = 10)
C
C     Function arguments
C
      INTEGER KOLDNUM, NUMOLD, KNEWNUM, NUMNEW
      DIMENSION NUMOLD(*), NUMNEW(*)
      REAL OLDWEST, OLDEAST, OLDLATS, NEWLATS
      DIMENSION OLDLATS(*), NEWLATS(*)
      INTEGER NEWIDX
      DIMENSION NEWIDX(4,*)
      REAL*4 DISTNEW
      DIMENSION DISTNEW(10,*)
C
C     Local arguments
C
      INTEGER NEWCOL, NEWROW, INCOL, LOOP, NEXT, NUMMAX
      INTEGER I_NW, I_SW, I_N, I_S, I_NE, I_SE
      REAL*8 DELONGN, DELONGS, DIFF, RESOL, DEPS
      REAL*8 DIST_NW, DIST_SW, DIST_NE, DIST_SE, DIST_N, DIST_S
      REAL*8 ZXIN, ZXIS, LON, OWEST, OEAST
      DIMENSION LON(JPNMOUT*2)
      LOGICAL LINGNS, LINGWE
      INTEGER INDEXI
      DIMENSION INDEXI(JPLLMAX)
      LOGICAL LGLOBAL
      DATA DEPS/0.0005/
      REAL*8 DINC
      LOGICAL LFULLG, LGWRAP
C
C ---------------------------------------------------------------------
C*    Section 1. Initalisation.
C ---------------------------------------------------------------------
C
  100 CONTINUE
C
      WAVEIDX = 0
      CALL INTLOG(JP_DEBUG,
     X   'WAVEIDX: Wave interpolation requested.',JPQUIET)
C
C     Check latitude/longitude grid specification
C
      IF( KOLDNUM.GT.JPLLMAX ) THEN
        CALL INTLOG(JP_ERROR,
     X    'WAVEIDX: Number of latitudes in input grid = ',KOLDNUM)
        CALL INTLOG(JP_ERROR,
     X    'WAVEIDX: And is greater than allowed maximum = ',JPLLMAX)
        WAVEIDX = JPROUTINE + 1
        GOTO 900
      ENDIF
C
C     Set up INDEXI for latitude lines in input lat/lon array
C
      INDEXI(1) = 0
      DO LOOP = 2, KOLDNUM
        INDEXI(LOOP) = INDEXI(LOOP-1) + NUMOLD(LOOP-1)
      ENDDO
C
      OEAST = OLDEAST
      OWEST = OLDWEST
C
C     Check whether the input field is global or a subarea
C
      NUMMAX = NUMOLD(1)
      DO LOOP = 2, KOLDNUM
        IF( NUMOLD(LOOP).GT.NUMMAX ) NUMMAX = NUMOLD(LOOP)
      ENDDO
      IF( NUMMAX.LE.0 ) THEN
        CALL INTLOG(JP_ERROR,
     X    'WAVEIDX: Input wave field has no points',JPQUIET)
        WAVEIDX = JPROUTINE + 2
        GOTO 900
      ENDIF
C
      LGWRAP = ABS((OEAST-OWEST) - DBLE(360.0)).LT.DEPS
      DINC = 360.0/DBLE(NUMMAX)
      LFULLG = ABS((DMOD((OEAST-OWEST+DBLE(360.0)),DBLE(360.0))
     X              +DINC)-DBLE(360.0)).LT.DEPS
C
      LGLOBAL = LFULLG.OR.LGWRAP
C
C ---------------------------------------------------------------------
C*    Section 2. Interpolation.
C ---------------------------------------------------------------------
C
  200 CONTINUE
C
      NEXT = 1
C
      DO 220 NEWROW = 1, KNEWNUM
C
C       Find old latitude rows to north and south of new latitude and
C       set up the distance between new row and the old rows to N and S.
C
        DO LOOP = 1, KOLDNUM -1
          IF( (NEWLATS(NEWROW).LE.OLDLATS(LOOP)) .AND.
     X        (NEWLATS(NEWROW).GT.OLDLATS(LOOP+1)) ) THEN
            I_N = LOOP
            I_S = MIN(LOOP+1,KOLDNUM)
            GOTO 205
          ENDIF
        ENDDO
C
        IF( NEWLATS(NEWROW).EQ.OLDLATS(KOLDNUM) ) THEN
          I_N = KOLDNUM
          I_S = KOLDNUM
        ELSE
          I_N = -1
          I_S = -1
        ENDIF
C
  205   CONTINUE
        IF( I_N.NE.I_S) THEN
          DIFF   = OLDLATS(I_N) - OLDLATS(I_S)
          DIST_N = (OLDLATS(I_N) - NEWLATS(NEWROW)) / DIFF
        ELSE
          DIST_N = 1.0
        ENDIF
        DIST_S = 1.0 - DIST_N
C
C       Check if the new interpolated row lies between 2 old rows which
C       have data points
C
        LINGNS = .FALSE.
        IF( I_N.GT.0 ) THEN
          IF( (NUMOLD(I_N).GT.0).AND.(NUMOLD(I_S).GT.0) ) THEN
C
C           Yes, so set up the grid increments.
C
C           Note that the grid increments are different depending on
C           whether or not the grid is global; global grids have an
C           extra interval at the end (eg between 358.5 and 0.0), while
C           subareas have outer limits defined by 'west' and 'east' and
C           a given number of points in between.
C
            IF( LGLOBAL ) THEN
              DELONGN = 360.0/DBLE(NUMOLD(I_N))
              DELONGS = 360.0/DBLE(NUMOLD(I_S))
            ELSE
              DELONGN = DMOD((OEAST-OWEST+DBLE(360.0)), DBLE(360.0))
     X                  / DBLE(NUMOLD(I_N)-1)
              DELONGS = DMOD((OEAST-OWEST+DBLE(360.0)), DBLE(360.0))
     X                  / DBLE(NUMOLD(I_S)-1)
            ENDIF
            LINGNS  = .TRUE.
          ENDIF
C
        ENDIF
C
C       Setup longitudes for the current row
C
        INCOL = NUMNEW(NEWROW)
        IF( INCOL.NE.0 ) THEN
          RESOL = 360.0/DBLE(INCOL)
          DO LOOP = 1, INCOL
            LON(LOOP) = DBLE(LOOP-1)*RESOL
          ENDDO
C
          DO 210 NEWCOL = 1, INCOL
C
            LINGWE = (LON(NEWCOL).GT.OWEST).OR.(LON(NEWCOL).LT.OEAST)
C
            IF( LINGNS .AND. LINGWE ) THEN
C
C             If point to be interpolated is inside the input field ,
C             work out distances from new point to four neighbours
C
              ZXIN = DMOD((LON(NEWCOL)+(DBLE(360.0)-OWEST)+DBLE(720.0)),
     X                     DBLE(360.0))
              ZXIS = ZXIN
              ZXIN = ZXIN/DELONGN + 1.0
              ZXIS = ZXIS/DELONGS + 1.0
              I_NW = INT(ZXIN)
              I_NE = I_NW + 1
              I_SW = INT(ZXIS)
              I_SE = I_SW + 1
C
C             Allow wrap-around
C
              I_NW = MOD(I_NW,NUMOLD(I_N))
              I_NE = MOD(I_NE,NUMOLD(I_N))
              I_SW = MOD(I_SW,NUMOLD(I_S))
              I_SE = MOD(I_SE,NUMOLD(I_S))
              IF( I_NW.EQ.0 ) I_NW = NUMOLD(I_N)
              IF( I_SW.EQ.0 ) I_SW = NUMOLD(I_S)
              IF( I_NE.EQ.0 ) I_NE = NUMOLD(I_N)
              IF( I_SE.EQ.0 ) I_SE = NUMOLD(I_S)
C
C             Calculate distance from interpolated point to its neighbours
C
              DIST_NW = ZXIN - REAL(I_NW)
              DIST_NE = 1.0 - DIST_NW
              DIST_SW = ZXIS - REAL(I_SW)
              DIST_SE = 1.0 - DIST_SW
C
              DISTNEW(JPDISNW,NEXT) = (DIST_NW*DIST_NW + DIST_N*DIST_N)
              DISTNEW(JPDISNE,NEXT) = (DIST_NE*DIST_NE + DIST_N*DIST_N)
              DISTNEW(JPDISSW,NEXT) = (DIST_SW*DIST_SW + DIST_S*DIST_S)
              DISTNEW(JPDISSE,NEXT) = (DIST_SE*DIST_SE + DIST_S*DIST_S)
C
              DISTNEW(JPNW,NEXT) = DIST_NW
              DISTNEW(JPNE,NEXT) = DIST_NE
              DISTNEW(JPSW,NEXT) = DIST_SW
              DISTNEW(JPSE,NEXT) = DIST_SE
              DISTNEW(JPN ,NEXT) = DIST_N
              DISTNEW(JPS ,NEXT) = DIST_S
C
              NEWIDX(JPNW,NEXT) = INDEXI(I_N)+I_NW
              NEWIDX(JPNE,NEXT) = INDEXI(I_N)+I_NE
              NEWIDX(JPSW,NEXT) = INDEXI(I_S)+I_SW
              NEWIDX(JPSE,NEXT) = INDEXI(I_S)+I_SE
C
C           If the point to be interpolated is outside the input field,
C           set it to 'land'.
C
            ELSE
C
              DISTNEW(JPNW,NEXT) = 0
              DISTNEW(JPNE,NEXT) = 0
              DISTNEW(JPSW,NEXT) = 0
              DISTNEW(JPSE,NEXT) = 0
              DISTNEW(JPN ,NEXT) = 0
              DISTNEW(JPS ,NEXT) = 0
C
              DISTNEW(JPDISNW,NEXT) = 0
              DISTNEW(JPDISNE,NEXT) = 0
              DISTNEW(JPDISSW,NEXT) = 0
              DISTNEW(JPDISSE,NEXT) = 0
C
              NEWIDX(JPNW,NEXT) = 0
              NEWIDX(JPNE,NEXT) = 0
              NEWIDX(JPSW,NEXT) = 0
              NEWIDX(JPSE,NEXT) = 0
C
            ENDIF
C
            NEXT = NEXT + 1
C
  210     CONTINUE
C
        ENDIF
C
  220 CONTINUE
C
C ---------------------------------------------------------------------
C*    Section 9. Closedown.
C ---------------------------------------------------------------------
C
  900 CONTINUE
C
      IF( WAVEIDX.EQ.0 ) THEN
        CALL INTLOG(JP_DEBUG, 'WAVEIDX: successful.',JPQUIET)
      ELSE
        CALL INTLOG(JP_ERROR, 'WAVEIDX: failed.',JPQUIET)
      ENDIF
C
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      INTEGER FUNCTION DSHSEC2(KGRIB,KLENG,INSPT,KSEC2,IBITS)
C
C---->
C**** DSHSEC2P
C
C     PURPOSE
C     _______
C
C     Decodes GRIB section 2 values for spherical harmonic fields.
C
C     INTERFACE
C     _________
C
C     IRET = DSHSEC2(KGRIB,KLENG,INSPT,KSEC2,IBITS)
C
C     Input parameters
C     ________________
C
C     KGRIB   - GRIB product unpacked so far (upto octet 6). 
C     KLENG   - Length of KGRIB.
C     INSPT   - Bit position of GRIB product unpacked so far.
C     KSEC2   - GRIB section 2 description.
C     IBITS   - Number of bits per element in KGRIB.
C     
C
C     Output parameters
C     ________________
C
C     KSEC2   - Updated GRIB section 2 description.
C     INSPT   - Updated bit position of GRIB product built so far.
C     IRET    - Function return status code, 0 = OK
C
C     Common block usage
C     __________________
C
C     None.
C
C     Method
C     ______
C
C     Unpacks values given in KGRIB into KSEC2 and updates bit
C     pointer INSPT.
C
C     Externals
C     _________
C
C     DSGNBT  - Get the sign bit and adjust value to +/-.
C     INXBIT  - Insert bit data.
C
C
C     AUTHOR
C     ______
C
C     J.D.Chambers       ECMWF     February 1999
C
C     MODIFICATIONS
C     _____________
C
C     None.
C
C----<
C     _______________________________________________________
C
C     Section 0. Definition of variables.
C     _______________________________________________________
C
      IMPLICIT NONE
C
#include "common/grprs.h"
C
C     Parameters
C
      INTEGER JP16SET
      PARAMETER ( JP16SET = 2**16 - 1 ) 
C                            ^---> 65535    =   FFFF(hex)
C
C     Function arguments
C
      INTEGER KGRIB,KLENG,INSPT,KSEC2,IBITS
      DIMENSION KGRIB(*),KSEC2(*)
C
C     Local variables
C
      INTEGER IRET
C
C     _______________________________________________________
C
C     Section 1.    Initialization.
C     _______________________________________________________
C
  100 CONTINUE
C
      DSHSEC2 = 0
C
C     _______________________________________________________
C
C     Section 2.    Unpack section 2 octets.
C     _______________________________________________________
C
  200 CONTINUE
C
C     Octets 7 - 8   : J pentagonal resolution parameter.
C     Octets 9 - 10  : K pentagonal resolution parameter.
C     Octets 11 - 12 : M pentagonal resolution parameter.
C     Three 16 bit fields.
C
      CALL INXBIT(KGRIB,KLENG,INSPT,KSEC2(2),3,IBITS, 16,'D',IRET)
      IF( IRET.NE.0 ) THEN
        DSHSEC2 = 1
        WRITE(GRPRSM,*) 'GRIBEX: Error inserting/extracting'
        WRITE(GRPRSM,*)
     X    'GRIBEX: J,K,M pentagonal resolution parameters.'
        WRITE(GRPRSM,*) 'GRIBEX: Return code = ', IRET
        GO TO 900
      ENDIF
C
C     Octet 13 : Representation type.
C     Octet 14 : Representation mode.
C     Two 8 bit fields.
C
      CALL INXBIT(KGRIB,KLENG,INSPT,KSEC2(5),2,IBITS, 8,'D',IRET)
      IF( IRET.NE.0 ) THEN
        DSHSEC2 = 1
        WRITE(GRPRSM,*) 'GRIBEX: Error inserting/extracting'
        WRITE(GRPRSM,*) 'GRIBEX: representation type or mode.'
        WRITE(GRPRSM,*) 'GRIBEX: Return code = ', IRET
        GO TO 900
      ENDIF
C
C
C     Octets 15 - 32 : Reserved.
C     Nine 16 bit fields.
C
C     Move pointer past reserved octets.
      INSPT = INSPT + 144
C
C     _______________________________________________________
C
C     Section 9. Return to calling routine.
C     _______________________________________________________
C
  900 CONTINUE
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE BUSEL2(KSUBSET,KELEM,KTDLEN,KTDLST,KTDEXL,KTDEXP,
     1                  CNAMES,CUNITS,KERR)
C
C**** *BUSEL2*
C
C
C     PURPOSE.
C     --------
C          RETURNS LIST OF DATA DESCRIPTORS AS IN SECTION 3  OF BUFR
C          MESSAGE AND TOTAL/REQUESTED LIST OF ELEMENTS, NAMES, UNITS.
C
C
C**   INTERFACE.
C     ----------
C
C          *CALL* *BUSEL2(KSUBSET,KTDLEN,KTDLST,KTDEXL,KTDEXP,CNAMES,
C                         CUNITS,CVALS,KERR)*
C
C
C        OUTPUT:
C               *KTDLEN*  -  NUMBER OF DATA DESCRIPTORS IN SECTION 3
C               *KTDLST*  -  ARRAY CONTAINING DATA DESCRIPTORS IN SECTION 3
C               *KTDEXL*  -  NUMBER OF ENTRIES IN LIST OF EXPANDED DATA
C                            DESCRIPTORS
C               *KTDEXP*  -  ARRAY CONTAINIG EXPANDED DATA DESCRIPTORS
C               *CNAMES*  -  ARRAY CONTAINING ELEMENT NAMES
C               *CUNITS*  -  ARRAY CONTAINING ELEMENT UNITS
C               *KERR*    -  RETURNED ERROR CODE
C
C
C     METHOD.
C     -------
C
C          NONE.
C
C     EXTERNALS.
C     ----------
C
C          NONE.
C
C     REFERENCE.
C     ----------
C
C          NONE.
C
C     AUTHOR.
C     -------
C
C          M. DRAGOSAVAC    *ECMWF*       15/01/2006.
C
C
C     MODIFICATIONS.
C     --------------
C
C          NONE.
C
C
      IMPLICIT LOGICAL(L,O,G), CHARACTER*8(C,H,Y)
C
C
#     include "parameter.F"
#     include "bcomunit.F"
#     include "bcomel.F"
#     include "bcomoff.F"
C
      DIMENSION  KTDLST(*),KTDEXP(*)
C
      CHARACTER*64 CNAMES(*)
      CHARACTER*24 CUNITS(*)
C
C     -----------------------------------------------------------------

C*          1.  PUT LIST OF ELEMENTS FROM COMMON BLOCK
C               --------------------------------------
C               TO REQUESTED ARRAYS.
C               --------------------
 100  CONTINUE
C
      KERR=0
C
      KTDLEN=NTDLEN
C
      DO 101 I=1,NTDLEN
      KTDLST(I)=NTDLST(I)
 101  CONTINUE
C
      IF(OMULTI) THEN
         NTDEXL=NSIZE(KSUBSET)
         KTDEXL=NTDEXL
         IJ=(KSUBSET-1)*KELEM
      ELSE
         NTDEXL=NSIZE(1)
         KTDEXL=NTDEXL
         IJ=0
      END IF

C
      DO 102 I=1,NTDEXL
      IIJ=I+IJ
      KTDEXP(I)=NWTRG(IIJ)
      CALL GET_NAME_UNIT(KTDEXP(I),CNAMES(I),CUNITS(I))
 102  CONTINUE
C
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities
C granted to it by virtue of its status as an intergovernmental organisation
C nor does it submit to any jurisdiction.
C

      SUBROUTINE JSTRWLL( PSHUP, KTRUNC, PNLAT, PBUILD, KLONO,
     X                    PLEG, PTRIGS, KMFAX, PZFA,   KRET)
C
C---->
C**** JSTRWLL
C
C     PURPOSE
C     _______
C
C     This routine converts stretched spectral wind fields to
C     standard lat/long grid fields.
C
C     INTERFACE
C     _________
C
C     CALL JSTRWLL( PSHUP, KTRUNC, PNLAT, PBUILD, KLONO,
C    X              PLEG, PTRIGS, KMFAX, PZFA,   KRET)
C
C     Input parameters
C     ________________
C
C     PSHUP  - Spherical harmonics field, unpacked
C     KTRUNC - Truncation number of spherical harmonics field
C     PNLAT  - Start latitude (northernmost) for output field
C     PBUILD - Grid interval used to build the legendre coefficients
C     KLONO  - Number of longitude points along the line of latitude
C     PLEG   - Array used to hold legendre functions
C     PTRIGS - Initialized array of trig.functions (setup by JJSET99)
C     KMFAX  - Initialized array of prime factors (setup by JJSET99)
C
C     Output parameters
C     ________________
C
C     PZFA   - Output grid point field; contains one latitude row.
C     KRET   - Return status code, 0 = OK
C
C     Common block usage
C     __________________
C
C     JDCNDBG
C
C     Method
C     ______
C
C     None.
C
C     Externals
C     _________
C
C     FFT99   - Carries out FFT
C     INTLOG  - Output log message
C     INTLOGR - Output log message (with real value)
C     NMAKLL  - Make interpolation coefficients one latitude at a time
C     JSPPOLE - Applies correction at North or South pole
C     EMOSLIB_SSCAL - Scale a vector of values
C
C     Reference
C     _________
C
C     E.C.M.W.F. Research Department technical memorandum no. 56
C                "The forecast and analysis post-processing package"
C                May 1982. J.Haseler.
C
C     Comments
C     ________
C
C     It handles transformation to a regular lat/long grid.
C
C     It is for U and V fields (a correction is applied at latitudes
C     other than the poles).
C
C
C     AUTHOR
C     ______
C
C     J.D.Chambers      ECMWF      July 1999
C
C     MODIFICATIONS
C     _____________
C
C     None.
C
C----<
C     _______________________________________________________
C
C
      IMPLICIT NONE
#include "jparams.h"
#include "parim.h"
#include "nifld.common"
C
C     Parameters
C
      INTEGER JPROUTINE
      PARAMETER ( JPROUTINE = 31300 )
      INTEGER JPN, JPS
      PARAMETER ( JPN = 1 )
      PARAMETER ( JPS = 2 )
      REAL DEG2RAD
      PARAMETER (DEG2RAD = PPI / 180.0 )
C
C     Subroutine arguments
C
      COMPLEX PSHUP(*)
      INTEGER KTRUNC
      INTEGER KLONO, KRET
      INTEGER KMFAX(*)
      REAL PNLAT, PBUILD
      REAL PZFA(JPLONO+2,2), PLEG(*), PTRIGS(*)
C
C     Local variables
C
      INTEGER ILIM, IMLIM, ILN
      INTEGER ITAL, ITALA, ITALS, IMN, IMP
      INTEGER INORTH
      INTEGER JM, LOOP, JF
      INTEGER NERR
C
#ifndef _CRAYFTN
#ifdef POINTER_64
      INTEGER*8 IWORK
#endif
#endif
      REAL ZCOSI, ZF(2*JPFFT)
      REAL ZNLAT, MFACTOR
      REAL WORK
      DIMENSION WORK(1)
      POINTER ( IWORK, WORK )
      COMPLEX   ZDUM(JPTRNC + 1)
      COMPLEX   ZSUMS(JPTRNC + 1), ZSUMA(JPTRNC + 1)
      COMPLEX*16 CHOLD
C
      INTEGER ISIZE
      DATA ISIZE/0/
      SAVE ISIZE, IWORK
C
C     Statement function
C
      LOGICAL GPOLE
      REAL ANGLE
      GPOLE(ANGLE) = ( ABS(90.0 - ABS(ANGLE) ) .LT. 1.0E-3 )
C                  = .TRUE. if LAT is 90.0 or -90.0
C
C     _______________________________________________________
C
C*    Section 1.    Initialization.
C     _______________________________________________________
C
  100 CONTINUE
C
C     First time through, dynamically allocate memory for workspace
C
      IF( ISIZE.EQ.0 ) THEN
        ISIZE =  2*JPFFT
        CALL JMEMHAN( 9, IWORK, ISIZE, 1, KRET)
        IF( KRET.NE.0 ) THEN
          CALL INTLOG(JP_ERROR,'JSTRWLL: memory allocation error',IWORK)
          KRET = JPROUTINE + 1
          GOTO 990
        ENDIF
      ENDIF
C
      IF( NDBG.GT.1 ) THEN
        CALL INTLOG(JP_DEBUG,
     X    'JSTRWLL: Spherical harmonic coeffs(first 20):',JPQUIET)
        DO NDBGLP = 1, 20
          CALL INTLOGR(JP_DEBUG,' ',PSHUP( NDBGLP ))
        ENDDO
        CALL INTLOG(JP_DEBUG,'JSTRWLL: Input parameters:',JPQUIET)
        CALL INTLOG(JP_DEBUG,
     X    'JSTRWLL: Spherical harmonic truncation = ', KTRUNC)
        CALL INTLOGR(JP_DEBUG,
     X    'JSTRWLL: Current latitude = ', PNLAT)
        CALL INTLOGR(JP_DEBUG,
     X    'JSTRWLL: Grid lat. interval(leg. file) = ', PBUILD)
        CALL INTLOG(JP_DEBUG,
     X    'JSTRWLL: Number of long. pts per row = ', KLONO)
        CALL INTLOG(JP_DEBUG,
     X    'JSTRWLL: Trig.functions (setup by JJSET99):',JPQUIET)
        DO NDBGLP = 1, 10
          CALL INTLOGR(JP_DEBUG,' ',PTRIGS( NDBGLP ))
        ENDDO
        CALL INTLOG(JP_DEBUG,
     X    'JSTRWLL: Prime factors (setup by JJSET99):',JPQUIET)
        DO NDBGLP = 1, 10
          CALL INTLOG(JP_DEBUG,' ',KMFAX( NDBGLP ))
        ENDDO
      ENDIF
C
C     If it is a stretched field, calculate the true latitude and
C     the map factor.
C
      IF( RISTRET.NE.0 ) THEN
        CALL STRLAT(PNLAT, RISTRET, 1, ZNLAT, MFACTOR)
      ELSE
        ZNLAT = PNLAT
        MFACTOR = 1.0
      ENDIF
C
      ILIM   = KTRUNC + 1
      IMLIM  = KTRUNC + 1
      INORTH = -1
      ILN    = KLONO + 2
C
C     _______________________________________________________
C
C*    Section 2.   Calculate fourier coefficients
C     _______________________________________________________
C
 200  CONTINUE
C
C     Generate the legendre coefficients 'on the fly'
C
      IF( ZNLAT.GE.0 ) THEN
        CALL NMAKLL( KTRUNC, PBUILD, ZNLAT, 1, PLEG, NERR)
      ELSE
        CALL NMAKLL( KTRUNC, PBUILD, -ZNLAT, 1, PLEG, NERR)
      ENDIF
C
C     Clear array.
C
      DO JF = 1, JPLONO+2
        PZFA(JF,JPN) = 0.0
        PZFA(JF,JPS) = 0.0
      ENDDO
C
C     Treat the poles as a special case ..
C
      IF( GPOLE(ZNLAT) ) THEN
C
        IF( NDBG.GT.1 ) CALL INTLOG(JP_DEBUG,
     X    'JSTRWLL: Pole is special case',JPQUIET)
C
        CALL JSPPOLE( PSHUP, 1, KTRUNC, .TRUE. , ZF)
        DO LOOP = 1, ILN
          PZFA(LOOP, JPN) = ZF(LOOP)
        ENDDO
C
        CALL JSPPOLE( PSHUP, 0, KTRUNC, .TRUE. , ZF)
        DO LOOP = 1, ILN
          PZFA(LOOP, JPS) = ZF(LOOP)
        ENDDO
C
C     .. otherwise not at pole
C
      ELSE
C
C       Fill slots which are used
C
        IMN = 0
        IMP = 0
C
        DO JM = 1, IMLIM
          ITAL = ILIM - JM + 1
          DO LOOP = 1, ITAL
            ZDUM(LOOP) = PLEG(IMP + LOOP)*PSHUP(IMN + LOOP)
          ENDDO
C
          IMP = IMP + ITAL + 1
          IMN = IMN + ITAL
          ITALS = (ITAL + 1)/2
          ITALA = ITAL/2
          CHOLD = (0.0D0, 0.0D0)
          DO LOOP = 1, 2*ITALS, 2
            CHOLD = CHOLD + ZDUM(LOOP)
          ENDDO
          ZSUMS(JM) = CHOLD
          CHOLD = (0.0D0, 0.0D0)
          DO LOOP = 2, 2*ITALA, 2
            CHOLD = CHOLD + ZDUM(LOOP)
          ENDDO
          ZSUMA(JM) = CHOLD
C
        ENDDO
C
C       For the southern hemisphere row, the legendre functions are
C       the complex conjugates of the corresponding northern row -
C       hence the juggling with the signs in the next loop.
C
C       Note that PZFA is REAL, but the coefficients being calculated
C       are COMPLEX.  There are pairs of values for each coefficient
C       (real and imaginary parts) and pairs of values for each
C       latitude (north and south).
C
        DO JM = 1, IMLIM
          PZFA(2*JM -1,JPN) = REAL(ZSUMS(JM))  + REAL(ZSUMA(JM))
          PZFA(2*JM   ,JPN) = AIMAG(ZSUMS(JM)) + AIMAG(ZSUMA(JM))
          PZFA(2*JM -1,JPS) = REAL(ZSUMS(JM))  - REAL(ZSUMA(JM))
          PZFA(2*JM   ,JPS) = AIMAG(ZSUMS(JM)) - AIMAG(ZSUMA(JM))
        ENDDO
C
      ENDIF
C
C     _______________________________________________________
C
C*    Section 3.    Fast fourier transform
C     _______________________________________________________
C
 300  CONTINUE
C
      CALL FFT99(PZFA,WORK,PTRIGS,KMFAX,1,JPLONO+2,KLONO,2,1)
C
      IF( NDBG.GT.1 ) THEN
        CALL INTLOG(JP_DEBUG,
     X    'JSTRWLL: Values calculated by FFT:',JPQUIET)
        DO NDBGLP = 1, 20
          CALL INTLOGR(JP_DEBUG,' ', PZFA( 1, NDBGLP ))
          CALL INTLOGR(JP_DEBUG,' ', PZFA( 2, NDBGLP ))
        ENDDO
      ENDIF
C
C     Move 'southern' latitude into leading part of array
C
      IF( ZNLAT.LT.0 ) THEN
        DO JF = 1, JPLONO+2
          PZFA(JF,JPN) = PZFA(JF,JPS)
        ENDDO
      ENDIF
C     _______________________________________________________
C
C*    Section 4.    Apply scale factor (map scale factor, and
C                   latitude correction if not pole)
C     _______________________________________________________
C
 400  CONTINUE
C
      IF( NDBG.GT.1 ) CALL INTLOG(JP_DEBUG,
     X    'JSTRWLL: Apply scale to latitude',JPQUIET)
C
      IF( .NOT. GPOLE(ZNLAT) ) THEN
        ZCOSI = MFACTOR / COS( ZNLAT * DEG2RAD )
        CALL EMOSLIB_SSCAL( KLONO, ZCOSI, PZFA( 2, JPN), 1)
      ELSE
        CALL EMOSLIB_SSCAL( KLONO, MFACTOR, PZFA( 2, JPN), 1)
      ENDIF
C     _______________________________________________________
C
C*    Section 9. Return to calling routine. Format statements
C     _______________________________________________________
C
C
 900  CONTINUE
C
      KRET = 0
C
 990  CONTINUE
      RETURN
      END

C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities
C granted to it by virtue of its status as an intergovernmental organisation
C nor does it submit to any jurisdiction.
C

      INTEGER FUNCTION PDDEFS()
C
C---->
C**   PDDEFS
C
C     Purpose
C     -------
C
C     Adjust the interpolation parameters according to parameter
C     dependent requirements.
C
C     Interface
C     ---------
C
C     IRET = PDDEFS()
C
C     Input
C     -----
C
C     Input file format:
C
C       Param  lsm  wind  prec  lsm interp          ) First 2 lines
C       -----  ---  ----  ----  ----------          ) are ignored
C       131     n     y     n     n            )
C       132     n     y     n     n            )
C       140     y     n     n     n            )
C       141     y     n     n     n            )    I3,4(5X,A1)
C       142     n     n     y     n            )
C       143     n     n     y     n            )
C       144     n     n     y     n            )
C       165     n     y     n     n            )
C        :
C        :
C
C     Output
C     ------
C
C     IRET = 0 if OK.
C
C
C     Method
C     ------
C
C     Values are taken from a (text) file in a directory defined
C     by the environment variable:
C
C        "PARAMETER_PROCESSING_DEFAULTS" (if defined),
C
C     or from the directory:
C
C        /owrk/marsint/new                      (CRAY)
C        /mrfs/postproc                         (Fujitsu)
C        /usr/local/lib/metaps/tables/interpol
C        /usr/local/apps/libemos/tables/        (since version 000394)
C
C     or from an internal default array.
C
C     The file used has name defaults_for_table_nnn, where
C     nnn is the 3-digit local code table number (eg 128 for
C     ECMWF, 001 for WMO, etc ).
C
C
C     Externals
C     ---------
C
C     INTLOG  - Logs messages.
C     GETENV  - Gets environment variable information.
C     INDEX   - Locates a character in a character variable.
C     EMOSNUM - Gives current EMOSLIB version number.
C     PRECIP  - Says if field is to have 'precipitation' treatment
C
C
C     Author
C     ------
C
C     J.D.Chambers       ECMWF        August 1994.
C
C----<
C
      IMPLICIT NONE
C
C     Parameters
C
      INTEGER JPROUTINE, JPNUMDF, JPND001, JPND128, JPND129
      PARAMETER (JPROUTINE = 28000)
      PARAMETER (JPNUMDF = 100)
      PARAMETER (JPND001 =   9)
      PARAMETER (JPND128 =  13)
      PARAMETER (JPND129 =  12)
C
#include "parim.h"
#include "nifld.common"
C
C     Local variables
C
      CHARACTER*6 YEMOSNM
      INTEGER IEMOSNM
      CHARACTER*256 FILENAME
      CHARACTER*256 YBASE
      CHARACTER*256 HLINE
      CHARACTER*256 YENVBACK
      INTEGER IPARAM, INEXT, NUMDFS, LOOP, INDX, IOTABLE
      CHARACTER*1 HLSM, HWIND, HPREC, HLSMI
      LOGICAL LNLSM, LNWIND, LNPREC, LNSMPAR
      DATA IOTABLE/0/
C
C     Default array
C
      CHARACTER*27 HDEFS(JPNUMDF)
C
C     External functions
C
      INTEGER DPATH_TABLES_INTERPOL
      EXTERNAL DPATH_TABLES_INTERPOL
C
C     Specified defaults
C
C     WMO table 1
C
      CHARACTER*27 TAB001(JPND001)
      DATA TAB001/
     X          '002     n     n     n     n',
     X          '033     y     y     n     n',
     X          '034     y     y     n     n',
     X          '061     y     n     y     n',
     X          '062     y     n     y     n',
     X          '063     y     n     y     n',
     X          '064     y     n     y     n',
     X          '065     y     n     y     n',
     X          '081     n     n     n     y'
     X         /
C
C     ECMWF table 128
C
      CHARACTER*27 TAB128(JPND128)
      DATA TAB128/
     X          '131     y     y     n     n',
     X          '132     y     y     n     n',
     X          '142     y     n     y     n',
     X          '143     y     n     y     n',
     X          '144     y     n     y     n',
     X          '151     n     n     n     n',
     X          '165     y     y     n     n',
     X          '166     y     y     n     n',
     X          '169     y     n     n     n',
     X          '172     n     n     n     y',
     X          '228     y     n     y     n',
     X          '239     y     n     y     n',
     X          '240     y     n     y     n'
     X         /
C
C     ECMWF table 129
C
      CHARACTER*27 TAB129(JPND129)
      DATA TAB129/
     X          '131     y     y     n     n',
     X          '132     y     y     n     n',
     X          '142     y     n     y     n',
     X          '143     y     n     y     n',
     X          '144     y     n     y     n',
     X          '151     n     n     n     n',
     X          '165     y     y     n     n',
     X          '166     y     y     n     n',
     X          '172     n     n     n     y',
     X          '228     y     n     y     n',
     X          '239     y     n     y     n',
     X          '240     y     n     y     n'
     X         /
C
      SAVE HDEFS, NUMDFS, IOTABLE, FILENAME
C
C     External functions
C
      INTEGER EMOSNUM
      LOGICAL PRECIP
      EXTERNAL EMOSNUM, PRECIP
C
C     Statement function
C
      LOGICAL NOTSAME, A, B
C
C     XOR or NE for logicals
C
      NOTSAME(A,B) = ((A).AND.(.NOT.(B))).OR.((B).AND.(.NOT.(A)))
C
C     ------------------------------------------------------------------
C*    Section 1.   Initialise
C     ------------------------------------------------------------------
C
 100  CONTINUE
C
      PDDEFS = 0
C
C     Start with the generic settings.
C
      LNLSM   = .TRUE.
      LNWIND  = .FALSE.
      LNPREC  = .FALSE.
      LNSMPAR = .FALSE.
C
C     ------------------------------------------------------------------
C*    Section 2.   If parameter table has changed, treat as first time
C                  through: open and read the file of default values.
C     ------------------------------------------------------------------
C
 200  CONTINUE
C
      IF( IOTABLE.NE.NITABLE ) THEN
C
        DO LOOP = 1, 256
          FILENAME(LOOP:) = ' '
        ENDDO
C
        CALL INTLOG(JP_DEBUG,
     X   'PDDEFS: Try to get processing defaults file.',JPQUIET)
C
C       Get the directory name
C
        CALL GETENV( 'PARAMETER_PROCESSING_DEFAULTS', FILENAME)
        IF( FILENAME(1:1).EQ.' ' ) THEN
          INDX = DPATH_TABLES_INTERPOL(FILENAME)
          IF( INDX.EQ.0 ) THEN
            CALL INTLOG(JP_ERROR,
     X        'PDDEFS: unable to build LSM directory path.',JPQUIET)
            PDDEFS = JPROUTINE + 2
            GOTO 900
          ENDIF
        ENDIF
C
C       Build the complete file pathname
C
        INDX = INDEX(FILENAME, ' ')
        FILENAME(INDX:) = 'defaults_for_table_'
        INDX = INDEX(FILENAME, ' ')
        WRITE(FILENAME(INDX:),'(I3.3)') NITABLE
        INDX = INDX + 2
        CALL INTLOG(JP_DEBUG, FILENAME(1:INDX), JPQUIET)
        IOTABLE = NITABLE
C
        OPEN( UNIT = 1,
     X        FILE = FILENAME(1:INDX),
     X        STATUS = 'OLD',
     X        FORM = 'FORMATTED',
     X        ERR = 300)
C
C       Skip first 2 lines in the file
C
        READ(1,'(A)', END = 900) HLINE
        READ(1,'(A)', END = 900) HLINE
C
C       Read the file into the defaults array
C
        NUMDFS = 1
        DO LOOP = 1, JPNUMDF
          READ(1,'(A)', END = 220) HDEFS(NUMDFS)
          NUMDFS = NUMDFS + 1
        ENDDO
C
  220   CONTINUE
C
C       Close the file.
C
        NUMDFS = NUMDFS - 1
        CLOSE(1, ERR = 920)
C
        GOTO 400
C
C     ------------------------------------------------------------------
C*    Section 3.   If file problem, use default arrays.
C     ------------------------------------------------------------------
C
 300    CONTINUE
C
        CALL INTLOG(JP_DEBUG,
     X   'PDDEFS: No parameter processing defaults file found.',JPQUIET)
C
C       Use appropriate table
C           1 = WMO table 1
C         128 = ECMWF local code table 128
C         129 = ECMWF local code table 129
C
        IF( NITABLE.EQ.1 ) THEN
C
          DO LOOP = 1, JPND001
            HDEFS(LOOP) = TAB001(LOOP)
          ENDDO
          NUMDFS = JPND001
C
        ELSE IF( NITABLE.EQ.128 ) THEN
C
          DO LOOP = 1, JPND128
            HDEFS(LOOP) = TAB128(LOOP)
          ENDDO
          NUMDFS = JPND128
C
C
        ELSE IF( NITABLE.EQ.129 ) THEN
C
          DO LOOP = 1, JPND129
            HDEFS(LOOP) = TAB129(LOOP)
          ENDDO
          NUMDFS = JPND129
C
        ELSE
C
C         .. other (unspecified)
C
          NUMDFS = 0
C
        ENDIF
C
      ENDIF
C
C     ------------------------------------------------------------------
C*    Section 4.   Read lines in file to see if current parameter
C                  is mentioned.
C     ------------------------------------------------------------------
C
  400 CONTINUE
C
      CALL INTLOG(JP_DEBUG,'PDDEFS: Table number = ', NITABLE)
      CALL INTLOG(JP_DEBUG,'PDDEFS: Number of definitions = ', NUMDFS)
      CALL INTLOG(JP_DEBUG,'PDDEFS: Parameter number = ', NIPARAM)
      INEXT = 0
C
  410 CONTINUE
C
      INEXT = INEXT + 1
      IF( INEXT.GT.NUMDFS ) GOTO 900
      READ(HDEFS(INEXT), 9000) IPARAM, HLSM, HWIND, HPREC, HLSMI
C
C     If the current parameter, use the values defined in the table.
C
      IF( IPARAM.EQ.NIPARAM ) THEN
C
        IF( HLSM .EQ.'n' ) LNLSM   = .FALSE.
        IF( HWIND.EQ.'y' ) LNWIND  = .TRUE.
        IF( HPREC.EQ.'y' ) LNPREC  = .TRUE.
        IF( HLSMI.EQ.'y' ) LNSMPAR = .TRUE.
        GOTO 900
C
      ENDIF
C
C     Go back for next line in the array
C
      GOTO 410
C
C     ------------------------------------------------------------------
C*     Section 9.   Closedown.
C     ------------------------------------------------------------------
C
 900  CONTINUE
C
C     Only change the value if the user has not already set it.
C
      IF( .NOT. LSMSET ) THEN
        IF( NOTSAME(LNLSM,LSM) ) THEN
          LCHANGE = .TRUE.
          LSMCHNG = .TRUE.
          LSM = LNLSM
        ENDIF
      ENDIF
C
      IF( .NOT. LWINDSET ) THEN
        IF( NOTSAME(LNWIND,LWIND) ) LCHANGE = .TRUE.
        LWIND = LNWIND
      ENDIF
C
      IF( .NOT. LPRECSET ) THEN
        IF( NOTSAME(LNPREC,LPREC) ) LCHANGE = .TRUE.
        LPREC = LNPREC
      ENDIF
C
      IF( .NOT. LSMPARSET ) THEN
        IF( NOTSAME(LNSMPAR,LSMPAR) ) LCHANGE = .TRUE.
        LSMPAR = LNSMPAR
      ENDIF
C
      LPREC = PRECIP()
C
      RETURN
C
 920  CONTINUE
C
      PDDEFS = JPROUTINE + 1
      CALL INTLOG(JP_ERROR,'PDDEFS: Error closing file:',JPQUIET)
      CALL INTLOG(JP_ERROR,FILENAME,JPQUIET)
      RETURN
C
9000  FORMAT( I3,4(5X,A1))
9001  FORMAT( 1X,I3,4(5X,A1))
C
      END

      PROGRAM BUFR_ADD_BIAS
!
!**** *BUFR_ADD_BIAS*
!
!
!     PURPOSE.
!     --------
!         Add bias information to the existing synop bufr data
!
!
!**   INTERFACE.
!     ----------
!
!          NONE.
!
!     METHOD.
!     -------
!
!          NONE.
!
!
!     EXTERNALS.
!     ----------
!
!         CALL BUSEL
!         CALL BUFREX
!         CALL BUFREN
!         CALL BUPRS0
!         CALL BUPRS1
!         CALL BUPRS2
!         CALL BUPRS3
!         CALL BUPRT
!         CALL BUUKEY
!
!     REFERENCE.
!     ----------
!
!          NONE.
!
!     AUTHOR.
!     -------
!
!          M. DRAGOSAVAC    *ECMWF*       /17/03/2004.
!
!
!     MODIFICATIONS.
!     --------------
!
!          NONE.
!
!
      IMPLICIT LOGICAL(L,O,G), CHARACTER*8(C,H,Y)
!
      PARAMETER(JSUP =   9,JSEC0=   3,JSEC1= 40,JSEC2= 4096 ,JSEC3= 4, &
            JSEC4=   2,JELEM=160000,JSUBS=400,JCVAL=150 ,JBUFL=512000, &
#ifdef JBPW_64
            JBPW =  64,JTAB =3000,JCTAB=120,JCTST=1800,JCTEXT=1200, &
#else
            JBPW =  32,JTAB =3000,JCTAB=120,JCTST=1800,JCTEXT=1200, &
#endif
            JWORK=4096000,JKEY=46,JBYTE=512000)
!
      PARAMETER (KELEM=40000)
      PARAMETER (KVALS=360000)
      PARAMETER (NSTATIONS=15000)
! 
      DIMENSION KBUFF(JBUFL)
      DIMENSION KBUFR(JBUFL)
      DIMENSION KSUP(JSUP)  ,KSEC0(JSEC0),KSEC1(JSEC1)
      DIMENSION KSEC2(JSEC2),KSEC3(JSEC3),KSEC4(JSEC4)
      DIMENSION KEY  (JKEY),KREQ(2)
!
      REAL*8 VALUES(KVALS),VALUE(KVALS),RQV(KELEM)
      REAL*8 RVIND,EPS
      REAL*8 BIAS_VALUE0, BIAS_VALUE1
!
      DIMENSION KTDLST(KELEM),KTDEXP(KELEM),KRQ(KELEM)
      DIMENSION KDATA(200)
      DIMENSION IOUT(12800)
!
      CHARACTER*256 CF(100),COUT,CFIN,CLIST
      CHARACTER*64 CNAMES(KELEM)
      CHARACTER*24 CUNITS(KELEM)
      CHARACTER*80 CVALS(KVALS)
      CHARACTER*80 YENC
      CHARACTER*256 CARG(10)
      CHARACTER*8   CIDENT, CTEMP
      INTEGER DATE
      DIMENSION ITYPE(NSTATIONS)
      DIMENSION ISBT(NSTATIONS)
      DIMENSION IPC(NSTATIONS)
      DIMENSION BIAS(NSTATIONS)
      CHARACTER*8 CID(NSTATIONS)
!
!s      EXTERNAL GETARG
!                                                                       
!     ------------------------------------------------------------------
!*          1. INITIALIZE CONSTANTS AND VARIABLES.
!              -----------------------------------
 100  CONTINUE
!
!     MISSING VALUE INDICATOR
! 
      ITLEN=6400
      ITL=0
      JZ=0
      NW=0
      N=0
      NBYTES=JBPW/8
      RVIND=1.7E38
      NVIND=2147483647
      IOBS=0
      KRQL=0
      NR=0
      KREQ(1)=0
      KREQ(2)=0
      DO 102 I=1,KELEM
      RQV(I)=RVIND
      KRQ(I)=NVIND
 102  CONTINUE
!
!     INPUT FILE NAMES
!
      NARG=IARGC()
      IF(NARG.LT.4) THEN
         PRINT*,'USAGE -- bufr_add_bias -i infile -o outfile -l list'
         STOP
      END IF
      NFILE=NARG
!
      DO 104 J=1,NARG
      CALL GETARG(J,CARG(J))
 104  CONTINUE

      II=0
      IO=0
      IN=0
      IL=0
      DO 105 J=1,NARG
      IF(CARG(J).EQ.'-i') THEN
         IN=J
      ELSEIF(CARG(J).EQ.'-o') THEN
         IO=J
      ELSEIF(CARG(J).EQ.'-l') THEN
         IL=J
      END IF
 105  CONTINUE
      IF(IO.EQ.0.OR.IN.EQ.0) THEN
         PRINT*,'USAGE -- bufr_add_bias -i infile -o outfile -l list'
         STOP
      END IF
!
      COUT=CARG(IO+1)
      CFIN=CARG(IN+1)
      CLIST=CARG(IL+1)
!
      JJ=INDEX(COUT,' ')
!
      CALL PBOPEN(IUNIT1,COUT(1:JJ),'W',IRET)
      IF(IRET.EQ.-1) STOP 'OPEN FAILED ON BUFR.DAT'
      IF(IRET.EQ.-2) STOP 'INVALID FILE NAME'
      IF(IRET.EQ.-3) STOP 'INVALID OPEN MODE SPECIFIED'
!
      ILN=INDEX(CFIN,' ')
!
!*          1.2 OPEN FILE CONTAINING BUFR DATA.
!               -------------------------------
 120  CONTINUE
!
      IRET=0 
      CALL PBOPEN(IUNIT,CFIN(1:ILN),'R',IRET)
      IF(IRET.EQ.-1) STOP 'OPEN FAILED'
      IF(IRET.EQ.-2) STOP 'INVALID FILE NAME'
      IF(IRET.EQ.-3) STOP 'INVALID OPEN MODE SPECIFIED'
!
      IF(IL.NE.0) THEN
         ILL=INDEX(CLIST,' ')
!
         OPEN(UNIT=37,FILE=CLIST(1:ILL-1),IOSTAT=IOS, &
              STATUS='OLD',FORM='FORMATTED')
!
         READ(37,'(A)') CLINE
         READ(37,'(10x,I10.10)') DATE
         READ(37,'(16x,I12.12)') NUM_STATIONS
         READ(37,'(19x,F8.2)')   TRESHOLD
         READ(37,'(A)') CLINE
         READ(37,'(A)') CLINE
!
         if(NUM_STATIONS.GT.NSTATIONS) THEN
            print*,'Error: too many stations in the list.'
            call exit(2)
         end if
         DO I=1,NUM_STATIONS
         READ(37,'(A8,I4,I5,I3,F11.2)') CID(I), ITYPE(I),ISBT(I), &
                                        IPC(I),BIAS(I)
!        write(*,*) CID(I), ITYPE(I),ISBT(I),IPC(I),BIAS(I)
         END DO

      END IF
!
!     ----------------------------------------------------------------- 
!*          2. SET REQUEST FOR EXPANSION.
!              --------------------------
 200  CONTINUE
!
      OPRT=.FALSE.
      OENC=.TRUE.
      NCOM=1
      OCOMP=.FALSE.
      NR=0
      OSEC3=.FALSE.
!
!*          2.1 SET REQUEST FOR PARTIAL EXPANSION.
!               ----------------------------------
 210  CONTINUE
!
!     SET VARIABLE TO PACK BIG VALUES AS MISSING VALUE INDICATOR
!
      KPMISS=1
      KPRUS=0
      NOKEY=0
      CALL BUPRQ(KPMISS,KPRUS,NOKEY)
!
!     -----------------------------------------------------------------
!*          3.  READ BUFR MESSAGE.
!               ------------------
 300  CONTINUE
!
      IERR=0
      KBUFL=0
!
      IRET=0
      CALL PBBUFR(IUNIT,KBUFF,JBYTE,KBUFL,IRET) 
      IF(IRET.EQ.-1) THEN
          GO TO 900
      END IF
      IF(IRET.EQ.-2) STOP 'FILE HANDLING PROBLEM' 
      IF(IRET.EQ.-3) STOP 'ARRAY TOO SMALL FOR PRODUCT'
!
      N=N+1
      IKBUFL=KBUFL
      KBUFL=KBUFL/NBYTES+1
      IF(N.LT.NR) GO TO 300
!
!     -----------------------------------------------------------------
!*          4. EXPAND BUFR MESSAGE.
!              --------------------
 400  CONTINUE
!
      CALL BUS012(KBUFL,KBUFF,KSUP,KSEC0,KSEC1,KSEC2,KERR)
      IF(KERR.NE.0) THEN
         PRINT*,'ERROR IN BUS012: ',KERR
         PRINT*,' BUFR MESSAGE NUMBER ',N,' CORRUPTED.'
         KERR=0
         GO TO 300
      END IF
      KBUFFL=KSEC0(2)
!
      OSURF=.false.
      IF(ksec1(6).ne.0.and.ksec1(6).ne.1) then
         CALL PBWRITE(IUNIT1,KBUFF,IKBUFL,IERR)
         go to 300
      else
         if(ksec1(7).eq.  1) OSURF=.true.
         if(ksec1(7).eq.  3) OSURF=.true.
         if(ksec1(7).eq.  9) OSURF=.true.
         if(ksec1(7).eq. 11) OSURF=.true.
         if(ksec1(7).eq. 13) OSURF=.true.
         if(ksec1(7).eq. 19) OSURF=.true.
         if(ksec1(7).eq. 21) OSURF=.true.
         if(ksec1(7).eq.140) OSURF=.true.
         if(ksec1(7).eq.147) OSURF=.true.
         if(ksec1(7).eq.170) OSURF=.true.
         if(ksec1(7).eq.172) OSURF=.true.
         if(ksec1(7).eq.176) OSURF=.true.
         if(ksec1(7).eq.180) OSURF=.true.
         if(ksec1(7).eq.181) OSURF=.true.
         if(ksec1(7).eq.182) OSURF=.true.
      end if
!
      if(.not.OSURF) then
         CALL PBWRITE(IUNIT1,KBUFF,IKBUFL,IERR)
         go to 300
      end if
!
      IF(KSUP(6).GT.1) THEN
         KEL=JWORK/KSUP(6)
      ELSE
         KEL=KELEM
      END IF
!
      CALL BUFREX(KBUFL,KBUFF,KSUP,KSEC0 ,KSEC1,KSEC2 ,KSEC3 ,KSEC4,&
                  KEL,CNAMES,CUNITS,KVALS,VALUES,CVALS,IERR)
!
      IF(IERR.NE.0) THEN
         IF(IERR.EQ.45) GO TO 300
         CALL EXIT(2)
      END IF
      IOBS=IOBS+KSEC3(3)
!
      CALL BUSEL(KTDLEN,KTDLST,KTDEXL,KTDEXP,KERR)
      IF(KERR.NE.0) CALL EXIT(2)
!
!*          4.1 PRINT CONTENT OF EXPANDED DATA.
!               -------------------------------
 410  CONTINUE
!
      IF(.NOT.OPRT) GO TO 500
      IF(.NOT.OSEC3) GO TO 450
!
!*          4.2 PRINT SECTION ZERO OF BUFR MESSAGE.
!               -----------------------------------
 420  CONTINUE
!

      CALL BUPRS0(KSEC0)
!
!*          4.3 PRINT SECTION ONE OF BUFR MESSAGE.
!               -----------------------------------
 430  CONTINUE
!
      CALL BUPRS1(KSEC1)
!
!
!*          4.4 PRINT SECTION TWO OF BUFR MESSAGE.
!               -----------------------------------
 440  CONTINUE
!
!              AT ECMWF SECTION 2 CONTAINS RDB KEY.
!              SO UNPACK KEY
!
      CALL BUUKEY(KSEC1,KSEC2,KEY,KSUP,KERR)
!
!              PRINT KEY
!
      CALL BUPRS2(KSUP ,KEY)
!
!*          4.5 PRINT SECTION 3 OF BUFR MESSAGE.
!               -----------------------------------
 450  CONTINUE
!
!               FIRST GET DATA DESCRIPTORS
!
      CALL BUSEL(KTDLEN,KTDLST,KTDEXL,KTDEXP,KERR)
      IF(KERR.NE.0) CALL EXIT(2)
!
!               PRINT  CONTENT
!
      IF(OSEC3) THEN
         CALL BUPRS3(KSEC3,KTDLEN,KTDLST,KTDEXL,KTDEXP,KEL,CNAMES)
      END IF
!
!*         4.6 PRINT SECTION 4 (DATA).
!              -----------------------
 460  CONTINUE
!
!          IN THE CASE OF MANY SUBSETS DEFINE RANGE OF SUBSETS
!
      IF(.NOT.OO) THEN
      WRITE(*,'(A,$)') ' STARTING SUBSET TO BE PRINTED : '
      READ(*,'(BN,I4)')   IST
      WRITE(*,'(A,$)') ' ENDING SUBSET TO BE PRINTED : '
      READ(*,'(BN,I4)')   IEND
      OO=.FALSE.
      END IF
!
!              PRINT DATA
!
      ICODE=0
      CALL BUPRT(ICODE,IST,IEND,KEL,CNAMES,CUNITS,CVALS,&
                 KVALS,VALUES,KSUP,KSEC1,IERR)
!
!              RESOLVE BIT MAPS 
!
!     IF(IEND.GT.KSEC3(3)) IEND=KSEC3(3)
!
!     DO 461 IK=IST,IEND
! 
!     CALL BUBOX(IK,KSUP,KEL,KTDEXP,CNAMES,CUNITS,KVALS,VALUES,
!    1           KBOX,KAPP,KLEN,KBOXR,VALS,CBOXN,CBOXU,IERR)
!
!     CALL BUPRTBOX(KBOX,KAPP,KLEN,KBOXR,VALS,CBOXN,CBOXU)
!
!461  CONTINUE
!
!     -----------------------------------------------------------------
!*          5. COLLECT DATA FOR REPACKING.
!              ---------------------------
 500  CONTINUE
!      
      IF(.NOT.OENC) GO TO 300
!
!               FIRST GET DATA DESCRIPTORS
!
      CALL BUSEL(KTDLEN,KTDLST,KTDEXL,KTDEXP,KERR)
      IF(KERR.NE.0) CALL EXIT(2)
!
!     -----------------------------------------------------------------
!*          6. PACK BUFR MESSAGE BACK INTO BUFR.
!              ---------------------------------
 600  CONTINUE
!
    
      KKK=0
      KBUFL=JBUFL
!
!     GET REPLICATION FACTORS
!
      KK=0
      DO 601 K=1,KSUP(5)
      IF(KTDEXP(K).EQ.31001.OR.KTDEXP(K).EQ.31002.OR.&
         KTDEXP(K).EQ.31000.OR.&
         KTDEXP(K).EQ.31000) THEN
         KK=KK+1
         KDATA(KK)=NINT(VALUES(K))
      END IF
 601  CONTINUE
!
      KDLEN=2
      IF(KK.NE.0) KDLEN=KK
!
!     --------------------------------
!     |Modification to sections 3
!     --------------------------------
!
      i_end=ksup(5)
      do i=1,ksup(5)
        if(ktdexp(i) .eq. 222000) then
          i_end=i-1
          exit 
        endif
        if(ktdexp(i) .eq. 225000) then
          i_end=i-1
          exit 
        endif
      end do
      ip=ktdlen
!
      ip=ip+1
      ktdlst(ip)=225000
      ip=ip+1
      ktdlst(ip)=236000
      ip=ip+1
      ktdlst(ip)=101000+i_end
      ip=ip+1
      ktdlst(ip)=031031
      ip=ip+1
      ktdlst(ip)=001031
      ip=ip+1
      ktdlst(ip)=001032
      ip=ip+1
      ktdlst(ip)=008024
      ip=ip+1
      if(ksec1(7).eq.140.OR.ksec1(7).eq.147) then
         ktdlst(ip)=101001
      else
         ktdlst(ip)=101002
      end if
      ip=ip+1
      ktdlst(ip)=225255
!
      ktdlen=ip
!
!     Add a new bit map and bias
!
      ip=ksup(5)

      ip=ip+1
      values(ip)=0.0
      ip=ip+1
      values(ip)=0.0
!
      i_010004=0
      i_010051=0
      i_007004=0
      nqcentries=0
      do i=1,i_end
        if(ktdexp(i) .eq. 010004.and.nqcentries.lt.2) then 
          i_010004=i
          nqcentries=nqcentries+1
        endif
        if(ktdexp(i) .eq. 010051.and.nqcentries.lt.2) then
          i_010051=i
          nqcentries=nqcentries+1
        endif
        if(ktdexp(i) .eq. 007004.and.nqcentries.lt.2) then
          i_007004=i
          nqcentries=nqcentries+1
        endif
      end do
!
      do iz=1,i_end
       ip=ip+1
       values(ip)=1.
       if(iz.eq.i_010004) values(ip)=0.
       if(iz.eq.i_010051) values(ip)=0.
       if(iz.eq.i_007004) values(ip)=0.
      end do

      ip=ip+1
      values(ip)=98.
      ip=ip+1
      values(ip)=10.
      ip=ip+1
      values(ip)=40.      ! bias
      ip=ip+1
      if(IL.eq.0) then
         values(ip)=rvind
         if(ksec1(7).ne.140.OR.ksec1(7).eq.147) then
           ip=ip+1
           values(ip)=rvind
         end if
      else
!        create identifier
         if(ksec1(7).eq.1.or.ksec1(7).eq.3.or.ksec1(7).eq.170 &
            .or.ksec1(7).eq.172.or.ksec1(7).eq.176) then
            cident=' '
            if(values(1).eq.rvind.or.values(2).eq.rvind) then
               cident=' '
               PRINT*,'Missing block and/or station number'
!              CALL PBOPEN(IUERR,'error.bufr','W',IRET)
!              CALL PBWRITE(IUERR,KBUFF,KBUFFL,IERR)
!              CALL PBCLOSE(IUERR)
            else
              write(cident,'(i2.2,i3.3)',iostat=ios) nint(values(1)),&
              nint(values(2))
              if(ios.ne.0) then
                 print*,'internal write error=',ios
                 call exit(2)
              end if
            end if
         elseif(ksec1(7).eq.9.or.ksec1(7).eq.11.or.&
             ksec1(7).eq.13.or.ksec1(7).eq.19.or.ksec1(7).eq.180) then
             cident=cvals(1)
!        elseif(ksec1(7).eq.178) then
!           if(values(1).eq.rvind.or.values(2).eq.rvind) then
!              print*,values(1),' ',values(2)
!              cident=' '
!           else
!             write(cident,'(i4.4,i10.10)',iostat=ios) nint(values(1)),
!    1        nint(values(2))
!             if(ios.ne.0) then
!                print*,'internal write error=',ios
!                call exit(2)
!             end if
!           end if
         elseif(ksec1(7).eq.9.or.ksec1(7).eq.11.or.&
            ksec1(7).eq.13.or.ksec1(7).eq.19.or.ksec1(7).eq.180) then
             cident=cvals(1)
         elseif(ksec1(7).eq.21) then
             cident=' '
             if(values(1).eq.rvind) then
                cident=' '
             else
                write(cident,'(i5.5)',iostat=ios) nint(values(1))
                if(ios.ne.0) then
                  print*,'internal write error=',ios
                  call exit(2)
               end if
            end if
         elseif((ksec1(7).eq.181).or.(ksec1(7).eq.182)) then
             cident=' '
             if(values(1).eq.rvind) then
                cident=' '
             else
                write(cident,'(i7.7)',iostat=ios) nint(values(1))
                if(ios.ne.0) then
                  print*,'internal write error=',ios
                  call exit(2)
               end if
            end if
         elseif(ksec1(7).eq.140.OR.ksec1(7).eq.147) then
             cident=' '
             cident=cvals(1)
         else
             cident=' '
         end if
         ctemp=adjustr(cident)
         call get_bias(ctemp,ksec1,NUM_STATIONS,cid,itype,&
              isbt,ipc,bias,bias_value0,bias_value1,ierr)
         values(ip)=bias_value1
         if(ksec1(7).ne.140.OR.ksec1(7).eq.147) then
            ip=ip+1
            values(ip)=bias_value0
         end if 
      end if

      kel =ip
!
!*          6.2 ENCODE DATA INTO BUFR MESSAGE.
!               ------------------------------
 620  CONTINUE
!
      KSEC3(4)=128
      IF(KSEC3(3).GT.1) KSEC3(4)=192
      CALL BUFREN( KSEC0,KSEC1,KSEC2,KSEC3,KSEC4, &
                   KTDLEN,KTDLST,KDLEN,KDATA,KEL, &       
                   KVALS,VALUES,CVALS,KBUFL,KBUFR,KERR)
!
      IF(KERR.GT.0) THEN
         PRINT*,'ERROR DURING ENCODING.'
         CALL PBOPEN(IUERR,'error.bufr','W',IRET)
         CALL PBWRITE(IUERR,KBUFF,KBUFFL,IERR)
         CALL PBCLOSE(IUERR)
         CALL EXIT(2)
      END IF

      NW=NW+1
!
!           6.3 WRITE PACKED BUFR MESSAGE INTO FILE.
!               ------------------------------------
 630  CONTINUE
!
      IKBUFL=KBUFL*4
      CALL PBWRITE(IUNIT1,KBUFR,IKBUFL,IERR)
      IF(IERR.LT.0) THEN
         PRINT*,'ERROR WRITING INTO TARGET FILE.'
         CALL EXIT(2)
      END IF
!
!
      GO TO 300
!     -----------------------------------------------------------------
!
 810  CONTINUE
!
      WRITE(*,'(1H ,A)') 'OPEN ERROR ON INPUT FILE'
      GO TO 900
!      
 800  CONTINUE
!
      IF(IRET.EQ.-1) THEN
         PRINT*,'NUMBER OF RECORDS PROCESSED ',N
         PRINT*,'NUMBER OF RECORDS CONVERTED ',NW
!
      ELSE
         PRINT*,' BUFR : ERROR= ',IERR
      END IF
!
 900  CONTINUE
!
      PRINT*,'NUMBER OF RECORDS PROCESSED ',N
      PRINT*,'NUMBER OF RECORDS CONVERTED ',NW
!
      CALL PBCLOSE(IUNIT,IRET)
!
      CALL PBCLOSE(IUNIT1,IRET)
!
      END
      SUBROUTINE CUTZERO(CHARPAR,KMIN)
!
!**** CUTZERO - SUBROUTINE TO REMOVE ZERO CHARACTERS.
!
!**   PURPOSE
!     -------
!
!     TO REMOVE ZERO-FILL CHARACTERS FROM THE END OF A CHARACTER
!     VARIABLE.
!
!     INTERFACE
!     ---------
!
!     CALL CUTZERO(CHARPAR,KMIN)
!
!          CHARPAR  - CHARACTER VARIABLE WHICH MAY HAVE ZEROS AT THE
!                     END OF THE VALID CHARACTERS, WHICH NEED TO BE
!                     REMOVED;
!                     RETURNED WITH THE ZERO CHARACTERS CONVERTED TO
!                     BLANK.
!
!          KMIN     - INTEGER VARIABLE INDICATING A MINIMUM NUMBER OF
!                     CHARACTERS AT THE BEGINNING OF THE STRING WHICH
!                     MUST NOT BE CHANGED
!
!     THUS:
!
!     CHARPAR='ABC0000'
!     CALL CUTZERO(CHARPAR,4)
!
!     WOULD RETURN THE VALUE 'ABC0   ' IN CHAR, AND WOULD NOT
!     ALTER THE FIRST 4 CHARACTERS.
!
!     METHOD
!     ------
!
!     THE STRIG IS TESTED FOR THE EXISTANCE OF A ZERO CHARACTER.
!     IF NONE IS FOUND, NO CHANGE TAKES PLACE.
!     IF ONE OR MORE ZERO CHARACTERS ARE PRESENT, THE END OF THE
!     STRING IS LOCATED. WORKING BACKWARDS FROM THE END TO THE
!     KMIN-1 POSITION, CHARACTERS ARE TESTED FOR ZERO. IF A ZERO
!     IS FOUND, IT IS REPLACED BY BLANK. IF A NON-ZERO IS FOUND,
!     THE REPLACEMENT LOOP TERMINATES.
!
!     MODIFICATIONS
!     -------------
!
!     ORIGINAL VERSION - 25.01.95 - REX GIBSON - ECMWF.
!
      CHARACTER*(*) CHARPAR
      CHARACTER*1   YZERO
      INTEGER LEN
!
!     -----------------------------------------------------------
!
!*     1.     FIND AND REPLACE THE ZERO CHARACTERS.
!
  100 CONTINUE
      YZERO=CHAR(0)
      I1=INDEX(CHARPAR,'0')
      IF (I1.GT.0) THEN
         I2=MAX(I1,KMIN+1)
         I3=INDEX(CHARPAR,' ')-1
         IF (I3.LE.0) THEN
            I3=LEN(CHARPAR)
         ENDIF
         DO 112 J=I3,I2,-1
         IF (CHARPAR(J:J).EQ.'0') THEN
             CHARPAR(J:J)=' '
         ELSEIF (CHARPAR(J:J).EQ.YZERO) THEN
             GO TO 112
         ELSE
             GO TO 114
         ENDIF
  112    CONTINUE
!
  114    CONTINUE
      ENDIF
!
!     -----------------------------------------------------------
!
!*     2.     RETURN.
!
  200 CONTINUE
!
      END
      SUBROUTINE  GET_BIAS(CIDENT,KSEC1,K_STATIONS,CID,KTYPE,KSBT,&
                KPC,BIAS,BIAS_VALUE0,BIAS_VALUE1,KERR)
!**** *GET_BIAS*
!
!
!     PURPOSE.
!     --------
!
!          Get bias value for particular station
!
!
!**   INTERFACE.
!     ----------
!
!          NONE.
!
!     METHOD.
!     -------
!
!          NONE.
!
!
!     EXTERNALS.
!     ----------
!
!          NONE.
!
!     REFERENCE.
!     ----------
!
!          NONE.
!
!     AUTHOR.
!     -------
!
!
!          M. DRAGOSAVAC    *ECMWF*       06/11/2004.
!
!
!     MODIFICATIONS.
!     --------------
!
!          NONE.
!
!
!
!     -------------------------------------------------------------

      CHARACTER*8 CIDENT
      DIMENSION KSEC1(*), KTYPE(*), KSBT(*), KPC(*),BIAS(*)
      CHARACTER*(*) CID(*)
      REAL*8 BIAS_VALUE0, BIAS_VALUE1
      
      KERR=0
      BIAS_VALUE0=1.7D38
      BIAS_VALUE1=1.7D38
!
      IF(K_STATIONS.EQ.0) RETURN

      DO I=1,K_STATIONS
        if(CIDENT.eq.CID(I)) THEN
           IF(KSEC1(6).EQ.KTYPE(I).AND.KSEC1(7).EQ.KSBT(I).AND.&
              KPC(i).EQ.0) THEN
              BIAS_VALUE0=BIAS(I)
           ELSEIF(KSEC1(6).EQ.KTYPE(I).AND.KSEC1(7).EQ.KSBT(I).AND.&
              KPC(I).EQ.1) THEN
              BIAS_VALUE1=BIAS(I)
           END IF
        END IF
      END DO
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE BUREP(KPT,KDLEN,KDATA,KJ,KJ1,KDD,KSTACK,KERR)
C
C**** *BUREP*
C
C
C     PURPOSE.
C     --------
C          RESOLVE DATA DESCRIPTOR REPLICATION PROBLEM.
C
C
C**   INTERFACE.
C     ----------
C
C          *CALL* *BUREP(KPT,KDLEN,KDATA,KJ,KJ1,KDD,KSTACK,KERR)*
C
C        INPUT :
C               *KPT*      - POINTER TOO KDATA ARRAY
C               *KDLEN*    -  DIMENSION OF KDATA ARRAY
C               *KDATA*    -  ARRAY CONTAINING DATA NEEDED FOR DATA DESCRIPTOR
C                            EXPANSION
C               *KDD*      - DATA DESCRIPTOR
C        OUTPUT:
C               *KJ*       - POINTER TO KSTACK ARRAY
C               *KJ1*      - POINTER TO LAST ELEMENT IN KSTACK
C               *KSTACK*   - LIST OF DATA DESCRIPTORS
C               *KERR*     - RETURN CODE
C
C     METHOD.
C     -------
C          NONE.
C
C     EXTERNALS.
C     ----------
C
C          BUETDR            - RESOLVE TABLE D REFERENCE
C          BUEPWT            - UPDATE WORKING TABLES
C          GBYTE             - UNPACK BIT PATHERN
C
C
C     REFERENCE.
C     ----------
C
C          NONE.
C
C     AUTHOR.
C     -------
C
C          M. DRAGOSAVAC    *ECMWF*       01/02/91.
C
C
C     MODIFICATIONS.
C     --------------
C
C          NONE.
C
C
      IMPLICIT LOGICAL(L,O,G), CHARACTER*8(C,H,Y)
C
C
C
#     include "parameter.F"
#     include "bcomunit.F"
#     include "bcmwork.F"
#     include "bcmwt.F"
#     include "bcmwtc.F"
#     include "bcmbef.F"
#     include "bcmoff.F"
C
      CHARACTER CWTEN*64,CWTU*24
      DIMENSION ILIST(JELEM)
      DIMENSION KSTACK(*)
      DIMENSION KDATA(KDLEN)
#ifndef R_4
      REAL*8 RVIND
      REAL*8 EPS
#else
      REAL   RVIND
      REAL   EPS
#endif
C
C     ------------------------------------------------------------------
C
C*          1.   STORE K, NUMBER OF DESCRIPTORS TO BE REPLICATED.
C                ------------------------------------------------
 100  CONTINUE
C
      IF( KERR.NE.0 ) RETURN
C
      IF  = KDD / 100000
      IDIF= KDD - IF * 100000
      IX  = IDIF / 1000
      IY  = IDIF - IX * 1000
      K   = IX
      IF(IY.EQ.0) ODREPF=.TRUE.
C
C*          1.1   DELAYED REPLICATION ?
C                 ---------------------
 110  CONTINUE
C
      IF( IY .NE. 0 ) THEN
C
C*          1.2   STORE NUMBER OF DESCRIPTORS, K, AND REPLICATION
C                 -----------------------------------------------
C                 FACTOR JR.
C                 ----------
 120     CONTINUE
C
         JR = IY
         GO TO 500
      END IF
C
C     ------------------------------------------------------------------
C
C*          2.   GET NEXT DESCRIPTOR.
C                --------------------
 200  CONTINUE
C
      KJ =KJ + 1
      KDD= KSTACK(KJ)
C
C     ------------------------------------------------------------------
C
C*          2.1  REPLICATION FACTOR ?
C                --------------------
 210  CONTINUE
C
      IF(KDD.NE.31001.AND.KDD.NE.31002.AND.
     1   KDD.NE.31000.AND.
     1   KDD.NE.31011.AND.KDD.NE.31012 )THEN
C
C*          2.1.1  SEQUENCE DESCRIPTOR ?
C                  ---------------------
C
         IF=KDD/100000
C
         IF( IF.EQ.3) THEN
C
C*          2.1.1.1  SOLVE TABLE D REFERENCE.
C                    ------------------------
            CALL BUETDR(KJ,KJ1,KDD,KSTACK,KERR)
            IF(KERR.GT.0) THEN
               DO 252 IQ=1,JELEM
               NSTACK(IQ)=0.
 252           CONTINUE
               RETURN
            END IF
            GO TO 200
         END IF
C
         IF( IF.EQ.2) THEN
            CALL BUOPER(KPT,KDLEN,KDATA,KJ,KDD,KSTACK,KERR)
            IF(KERR.GT.0) THEN
               CALL BUERR(KERR)
               RETURN
            END IF
            GO TO 200
         END IF
C
         KERR=36
         CALL BUERR(KERR)
         RETURN
      END IF
C
C     ------------------------------------------------------------------
C
C*          3.  UPDATE WORKING TABLE.
C               ---------------------
 300  CONTINUE
C
      IF(KDD.EQ.31031.OR.KDD.EQ.31192) THEN
         NWT=NWT+1
         NWTR(NWT)=KDD
         NWTS(NWT)=0
         NWTRV(NWT)=0
         NWTDW(NWT)=1
         M=M+1
      ELSEIF(KDD.EQ.33007.OR.KDD.EQ.63192) THEN
         NWT=NWT+1
         NWTR(NWT)=KDD
         NWTS(NWT)=0
         NWTRV(NWT)=0
         NWTDW(NWT)=7
         M=M+1
      ELSE
         CALL BUEPWT (KDD,KERR)
         IF(KERR.GT.0) RETURN
         IF(KDD.EQ.031011.or.KDD.EQ.031012) RETURN
      END IF
C
C     ------------------------------------------------------------------
C
C*          4.  STORE JR, THE REPLICATION FACTOR FROM DATA.
C               ------------------------------------------------------
 400  CONTINUE
C
      KPT=KPT+1
      IF(KPT.GT.KDLEN) THEN
         KERR=31
         CALL BUERR(KERR)
         RETURN
      END IF
C
      JR=KDATA(KPT)
C
      IF(JR.EQ.0) THEN
         IIIF=KSTACK(KJ+1)/100000
         IIII=KSTACK(KJ+1)-IIIF*100000
         IIIX=IIII/1000
         IIIY=IIII-IIIX*1000
C
         IF(IIIF.EQ.2.AND.IIIY.EQ.0) THEN
            KJ=KJ+1
            CALL BUOPER(KPT,KDLEN,KDATA,KJ,KSTACK(KJ),KSTACK,KERR)
            IF(KERR.GT.0) THEN
               CALL BUERR(KERR)
               RETURN
            END IF
         END IF

         KJ=KJ+K
         GO TO 640
      END IF

      JRTK=JR*K+KJ1-K
      IF(JRTK.GT.JELEM) THEN
         KERR=30
         CALL BUERR(KERR)
         RETURN
      END IF
C
C     CHECK IF NEXT DESCRIPTOR CANCEL OPERATOR FOR DELAYED
C     REPLICATION
C
      IIIF=KSTACK(KJ+1)/100000
      IIII=KSTACK(KJ+1)-IIIF*100000
      IIIX=IIII/1000
      IIIY=IIII-IIIX*1000
C
      IF(IIIF.EQ.2.AND.IIIY.EQ.0) THEN
         KJ=KJ+1
         CALL BUOPER(KPT,KDLEN,KDATA,KJ,KSTACK(KJ),KSTACK,KERR)
         IF(KERR.GT.0) THEN
            CALL BUERR(KERR)
            RETURN
         END IF
      END IF
C     ------------------------------------------------------------------
C*          5.  GET NEXT K DESCRIPTORS.
C               -----------------------
 500  CONTINUE
C
      DO 501 J=1,K
C
      ILIST(J)=KSTACK(KJ+J)
C
 501  CONTINUE
C
C     ------------------------------------------------------------------
C*          6.  ADD JR TIMES K DESCRIPTORS IN PLACE OF K
C               ----------------------------------------
C               DESCRIPTORS OBTAINED.
C               ---------------------
 600  CONTINUE
C
C     ------------------------------------------------------------------
C*          6.1  PUSH DOWN DESCRIPTORS IN KSTACK FOR (JR-1)*K PLACES
C                ---------------------------------------------------
C                STARTING AT KJ1 AND ENDING AT KJ+K.
C                -----------------------------------
 610  CONTINUE
C
      JRKM1=(JR-1)*K
C
      DO 611 J=KJ1,KJ+K,-1
C
      KSTACK(J+JRKM1)=KSTACK(J)
C
 611  CONTINUE
C
C*          6.2  INSERT LIST IN THE STACK.
C                -------------------------
 620  CONTINUE
C
      DO 622 J=1,JR
C
      KJJM1K=KJ+(J-1)*K
C
      DO 623 J1=1,K
C
      KSTACK(KJJM1K+J1)=ILIST(J1)
C
 623  CONTINUE
 622  CONTINUE
C
C     ------------------------------------------------------------------
C*          6.3  ADJUST DESCRIPTOR COUNT FOR LIST LENGTH.
C                ----------------------------------------
 630  CONTINUE
C
      KJ1 = KJ1  + (JR-1)*K
C
C     ------------------------------------------------------------------
C*          6.4  ADJUST NUMBER OF DATA DESCRIPTORS NOT PRESENT.
C                ----------------------------------------------
 640  CONTINUE
C
      IF(N221.NE.0)  N221= KJ1  - KJ + 1
C
C     ------------------------------------------------------------------
 700  CONTINUE
C
      RETURN
      END

C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE LGRPR4 (KSEC0,KLINE,KSEC4,PSEC4)
C
C---->
C**** lgrpr4 - Print information from Section 4 of GRIB code.
C
C     Purpose.
C     --------
C
C           Print the information in the Binary data section
C           Section (Section 4) of decoded GRIB data.
C
C**   Interface.
C     ----------
C
C           CALL lgrpr4 (KSEC0,KSEC4,PSEC4)
C
C           Integer    K.
C           Real       P.
C           Logical    O.
C           Character  H.
C
C               Input Parameters.
C               -----------------
C
C               KSEC0 - Array of decoded integers from Section 0.
C
C               KSEC4 - Array of decoded integers from Section 4.
C
C               PSEC4 - Array of decoded reals from Section 4.
C
C               Output Parameters.
C               ------------------
C
C               None.
C
C     Method.
C     -------
C
C           Fields printed as integers or reals.
C
C     Externals.
C     ----------
C
C           None.
C
C     Reference.
C     ----------
C
C           WMO Manual on Codes re GRIB Code.
C           See also routine GRIBEX.
C
C     Comments.
C     ---------
C
C           Routine contains Sections 0 to 1 and Section 9.
C
C     Author.
C     -------
C
C           J. Hennessy    ECMWF 11.09.91
C
C     Modifications.
C     --------------
C
C           K. Fielding    ecmwf 03/08/92
C           Special version with reduced printout for Monthly
C           means and time series
C
C----<
C     -----------------------------------------------------------------
C
C
C
C
C
C
C
C
C
C
C*    Section 0. Definition of variables.
C     -----------------------------------------------------------------
      IMPLICIT NONE
C
C*    Prefix conventions for variable names.
C
C     Logical      L (but not LP), global or common.
C                  O, dummy arguments.
C                  G, local variable.
C                  LP, parameter.
C     Character    C, Global or common.
C                  H, dummy arguments.
C                  Y (but not YP), local variables.
C                  YP, parameter.
C     Integer      M and N, global or common.
C                  K, dummy arguments.
C                  I, local variables.
C                  J (but not JP), loop control.
C                  JP, parameter.
C     Real         A to F and Q to X, global or common.
C                  P (but not PP), dummy arguments.
C                  Z, local variables.
C                  PP, parameter.
C
*IF DEF,CRAY
C     IMPLICIT NONE
*ENDIF
C
      INTEGER INUM
C
      INTEGER J210, J220
C
      INTEGER KSEC0
      INTEGER KSEC4
      INTEGER KLINE
C
      REAL PSEC4
C
      DIMENSION KSEC0(*)
      DIMENSION KSEC4(*)
C
      DIMENSION PSEC4(*)
C
C     -----------------------------------------------------------------
C
C
C
C
C
C
C
C
C
C
C*    Section 1 . Print integer information from KSEC4.
C     -----------------------------------------------------------------
C
  100 CONTINUE
C
      WRITE (*,9000)
      WRITE (*,9001)
      WRITE (*,9002)
C
      WRITE (*,9003) KSEC4(1)
      WRITE (*,9004) KSEC4(2)
C     WRITE (*,9005) KSEC4(3)
C     WRITE (*,9006) KSEC4(4)
C     WRITE (*,9007) KSEC4(5)
C     WRITE (*,9008) KSEC4(6)
C     WRITE (*,9009) KSEC4(7)
C     WRITE (*,9010) KSEC4(8)
C
C     -----------------------------------------------------------------
C
C
C
C
C
C
C
C
C
C
C
C*    Section 2. Print real values from PSEC4.
C     -----------------------------------------------------------------
C
  200 CONTINUE
C
      WRITE (*,9000)
C
      INUM = KSEC4(1)
      IF (INUM.LT.0)  INUM = - INUM
      IF (INUM.GT.10) INUM = 10
C
C     Print first INUM values.
C
      WRITE (*,9011) INUM
      DO 220 J220 = 0, 3
         WRITE (*, *)
      DO 210 J210=1,INUM
	 WRITE (*,9012) PSEC4(J220 * KLINE + J210)
  210 CONTINUE
  220 CONTINUE
C
C     -----------------------------------------------------------------
C
C
C
C
C
C
C
C*    Section 9 . Format statements. Return to calling routine.
C     -----------------------------------------------------------------
C
  900 CONTINUE
C
 9000 FORMAT (1H )
 9001 FORMAT (1H ,'Section 4 - Binary Data  Section.')
 9002 FORMAT (1H ,'-------------------------------------')
 9003 FORMAT (1H ,'Number of data values coded/decoded.         ',I9)
 9004 FORMAT (1H ,'Number of bits per data value.               ',I9)
 9005 FORMAT (1H ,'Type of data indicator.                      ',I9)
 9006 FORMAT (1H ,'Type of packing indicator.                   ',I9)
 9007 FORMAT (1H ,'Type of data representation.                 ',I9)
 9008 FORMAT (1H ,'Additional flags indicator.                  ',I9)
 9009 FORMAT (1H ,'Reserved.                                    ',I9)
 9010 FORMAT (1H ,'Number of values indicator.                  ',I9)
 9011 FORMAT (1H ,'First ',I4,' data values.')
 9012 FORMAT (1H ,F30.15)
C
      RETURN
C
      END

C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      INTEGER FUNCTION KRG2RG(OLDFLD, NEWFLD, NUMGG)
C
C---->
C**** KRG2RG
C
C     Purpose
C     -------
C
C     Interpolate a field based on one reduced gaussian grid to a
C     field based on a different reduced gaussian grid.
C
C
C     Interface
C     ---------
C
C     IRET = KRG2RG(OLDFLD, NEWFLD, NUMGG)
C
C     Input
C     -----
C
C     OLDFLD - Old field in GRIB format
C     NUMGG  - Number of the new gaussian field
C
C
C     Output
C     ------
C
C     NEWFLD - New field in GRIB format
C
C     Function returns:
C       - the size in bytes of the new GRIB product if all is well
C       - -1, otherwise.
C
C
C     Method
C     ------
C
C     Unpack input GRIBS.
C     Create new field and pack it into GRIB format.
C
C
C     Externals
C     ---------
C
C     GRIBEX  - Decode and encode GRIB products.
C     KINTRG  - Interpolate reduced gaussian field to reduced gaussian
C     JMALLOC - Dynamically allocate memory
C     INTLOG  - Log messages
C
C
C     Author
C     ------
C
C     J.D.Chambers     ECMWF     November 2000
C
C----<
C
      IMPLICIT NONE
C
C     Function arguments
C
      INTEGER NUMGG, OLDFLD(*), NEWFLD(*)
C
#include "parim.h"
#include "intisl.h"
#include "nifld.common"
#include "nofld.common"
C
C     Parameters
C
      INTEGER JPACK, JUNPACK, JPINTB, JPREALB, JPMAXNG
      PARAMETER (JPACK   = 4000000)
      PARAMETER (JUNPACK = 6000000)
#ifdef INTEGER_8
      PARAMETER (JPINTB = 8)
#else
      PARAMETER (JPINTB = 4)
#endif
      PARAMETER (JPMAXNG=4000)
#ifdef REAL_8
      PARAMETER (JPREALB = 8)
#else
      PARAMETER (JPREALB = 8)
#endif
C
C     Local variables
C
      INTEGER IFSEC0(JPGRIB_ISEC0),IFSEC1(JPGRIB_ISEC1),
     X IFSEC2(JPGRIB_ISEC2),IFSEC3(JPGRIB_ISEC3),IFSEC4(JPGRIB_ISEC4)
      INTEGER NFSEC0(JPGRIB_ISEC0),NFSEC1(JPGRIB_ISEC1),
     X NFSEC2(JPGRIB_ISEC2),NFSEC3(JPGRIB_ISEC3),NFSEC4(JPGRIB_ISEC4)
      INTEGER ISIZE, LOOP
      LOGICAL LFIRST
#ifndef _CRAYFTN
#if (!defined sgi)
#ifdef POINTER_64
      INTEGER*8 IZFSEC4, IPFSEC4
#else
      INTEGER   IZFSEC4, IPFSEC4
#endif
#endif
#endif
C
      REAL PLAT(JPMAXNG)
      REAL ZFSEC2(5000), ZFSEC3(2), ZFSEC4(1)
      REAL PFSEC3(2), PFSEC4(1)
C
      POINTER( IZFSEC4, ZFSEC4 )
      POINTER( IPFSEC4, PFSEC4 )
C
      INTEGER IRET, ILENB, IPUNP, IWORD
C
C     Externals
C
#ifdef POINTER_64
      INTEGER*8 JMALLOC
#else
      INTEGER JMALLOC
#endif
      INTEGER KINTRG
      EXTERNAL KINTRG, JMALLOC
C
      DATA LFIRST/.TRUE./
      SAVE LFIRST, IZFSEC4, IPFSEC4
C
C     -----------------------------------------------------------------|
C*    Section 1.   Initialise
C     -----------------------------------------------------------------|
C
  100 CONTINUE
C
      KRG2RG = 0
C
      IF( (NUMGG*2).GT.JPMAXNG ) THEN
        CALL INTLOG(JP_ERROR,'KRG2RG: Gaussian N too big = ',NUMGG)
        CALL INTLOG(JP_ERROR,'KRG2RG: Maximum handled = ',(JPMAXNG/2))
        KRG2RG = -1
        GOTO 900
      ENDIF
C
C     First time, dynamically allocate memory for the field values
C
      IF( LFIRST ) THEN
        LFIRST = .FALSE.
        ISIZE = JUNPACK * JPREALB
        CALL INTLOG(JP_DEBUG,'KRG2RG: Allocate memory = ',ISIZE)
C
        IZFSEC4 = JMALLOC(ISIZE)
#ifdef hpR64
        IZFSEC4 = IZFSEC4/(1024*1024*1024*4)
#endif
        IF( IZFSEC4.EQ.0 ) THEN
          CALL INTLOG(JP_ERROR,'KRG2RG: JMALLOC fail IZFSEC4',JPQUIET)
          KRG2RG = -1
          GOTO 900
        ENDIF
C
        IPFSEC4 = JMALLOC(ISIZE)
#ifdef hpR64
        IPFSEC4 = IPFSEC4/(1024*1024*1024*4)
#endif
        IF( IPFSEC4.EQ.0 ) THEN
          CALL INTLOG(JP_ERROR,'KRG2RG: JMALLOC fail IPFSEC4',JPQUIET)
          KRG2RG = -1
          GOTO 900
        ENDIF
      ENDIF
C
C     -----------------------------------------------------------------|
C*    Section 2.   Unpack the input GRIB
C     -----------------------------------------------------------------|
C
  200 CONTINUE
C
C     Old field
C
      IRET = 1
      IPUNP = JUNPACK
      ILENB = JPACK
      IFSEC3(1) = 0
      IFSEC3(2) = INT(RMISSGV)
      ZFSEC3(1) = 0.0
      ZFSEC3(2) = RMISSGV
      CALL GRIBEX (IFSEC0,IFSEC1,IFSEC2,ZFSEC2,IFSEC3,ZFSEC3,IFSEC4,
     X             ZFSEC4,IPUNP,OLDFLD,ILENB,IWORD,'D',IRET)
      IF( IRET.GT.0 ) THEN
        WRITE(*,*) 'KRG2RG: Old field gribex return code = ',IRET
        KRG2RG = -1
        RETURN
      ENDIF
C
C     -----------------------------------------------------------------|
C*    Section 3.   Create new field and put in GRIB format
C     -----------------------------------------------------------------|
C
  300 CONTINUE
C
      DO LOOP = 1, JPMAXNG
        NFSEC2(LOOP) = IFSEC2(LOOP)
      ENDDO
      CALL JGETGG( NUMGG, 'R', PLAT, NFSEC2(23), IRET)
      IF( IRET.NE.0 ) THEN
        WRITE(*,*) 'KRG2RG: Problem calling JGETGG, status = ',IRET
        KRG2RG = -1
        RETURN
      ENDIF
      NFSEC2(3)  = NUMGG * 2
      NFSEC2(4)  = NINT(PLAT(1)*1000.0)
      NFSEC2(7)  = NINT(PLAT(NUMGG*2)*1000.0)
      NFSEC2(8)  = NINT((360.0-(360.0/REAL(NUMGG*4)))*1000.0)
      NFSEC2(10) = NUMGG
C
      IRET = KINTRG(IFSEC2, NFSEC2, ZFSEC4, PFSEC4)
      IF( IRET.LE.0 ) THEN
        WRITE(*,*) 'KRG2RG: New field creation failed'
        KRG2RG = -1
        RETURN
      ENDIF
      IFSEC4(1) = IRET
C
      IRET = 1
      IPUNP = JUNPACK
      ILENB = JPACK
C
C     If output 'accuracy' specified, use it for the new field
C
      IF( LNOACC ) THEN
        IFSEC4(2) = NOACC
      ENDIF
C
C     There may be 'missing' values in the new field if the old field
C     has 'missing' values.
C
      IF( IFSEC1(5).EQ.192 ) THEN
        IFSEC1(5) = 192
        NFSEC3(1) = 0
        NFSEC3(2) = INT(RMISSGV)
        PFSEC3(1) = 0.0
        PFSEC3(2) = RMISSGV
      ENDIF
C
      CALL GRIBEX (IFSEC0,IFSEC1,NFSEC2,ZFSEC2,NFSEC3,PFSEC3,IFSEC4,
     X             PFSEC4,IPUNP,NEWFLD,ILENB,IWORD,'C',IRET)
      IF( IRET.NE.0 ) THEN
        WRITE(*,*) 'KRG2RG: New field gribex return code = ',IRET
        KRG2RG = -1
        RETURN
      ENDIF
C
      KRG2RG = IWORD * JPINTB
C
C     -----------------------------------------------------------------|
C*    Section 9.   Return
C     -----------------------------------------------------------------|
C
  900 CONTINUE
C
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE JMOVGG( PZFA, PWEST, KGNUM, KSTART, KROWS,
     X                   KCOLS, KLON, KJPWR, KOFSET, POUTF, KFLAG)
C---->
C
C**** JMOVGG
C
C     Purpose
C     _______
C
C     This routine moves gaussian grid point data from array PZFA to 
C     array POUTF.
C
C
C     Interface
C     _________
C
C     CALL JMOVGG( PZFA, PWEST, KGNUM, KSTART, KROWS,
C    X             KCOLS, KLON, KJPWR, KOFSET, POUTF, KFLAG)
C
C
C     Input parameters
C     ________________
C
C     PZFA      -  Input array of grid points arranged in pairs of
C                  north and south latitude bands
C     PWEST     -  Westernmost longitude for field in POUTF (degrees)
C     KGNUM     -  Gaussian number for field in POUTF
C     KSTART    -  Current first latitude number in PZFA for moving
C     KROWS     -  Number of latitude rows to store
C     KCOLS     -  Number of longitude points to store from latitude
C     KLON      -  Number of longitude points in generated latitude row
C     KJPWR     -  Multiplication factor applied to ensure that number 
C                  of longitude points > twice*spherical truncation
C     KOFSET    -  Array of offsets for start of each latitude row in
C                  the output array
C     KFLAG     -  = 1 if only the North hemisphere lats. to be moved
C                  = 2 if only the South hemisphere lats. to be moved
C                  = 3 if both North/South hemisphere lats. to be moved
C
C
C     Output parameters
C     ________________
C
C     POUTF      - Output array of grid points
C
C
C     Common block usage
C     __________________
C
C     JDCNDBG
C
C
C     Method
C     ______
C
C     Moves latitude rows of points from PZFA into the correct 
C     geographical positions in POUTF.  POUTF may already be 
C     partially full.  The distribution is symmetrical north-south.
C
C
C     Externals
C     _________
C
C     INTLOG   - Logs messages
C     INTLOGR  - Logs messages with real value.
C
C
C     Reference
C     _________
C
C
C     E.C.M.W.F. Research Department technical memorandum no. 56
C                "The forecast and analysis post-processing package"
C                May 1982. J.Haseler.
C
C
C     Comments
C     ________
C
C     For calculation purposes, the number of longitude points
C     has to be greater than 2*(output truncation) to ensure that the
C     fourier transform is exact (see Reference, page 10). 
C     Parameter JPLONO is set to 860 to ensure that PZFA will have
C     enough slots for the KLON points for all values of regular
C     grid intervals from N1 to N720.
C
C     When filling the output array POUTF, the longitude points have
C     have to be taken selectively to avoid the intermediate generated
C     points, picking up values only at the required longitudes.  The
C     magnification factor is KJPWR (a power of 2).
C
C     PZFA has values stored:
C       North lat1:  x, 1, x, 2, x, 3, x, ... , KLON, ...
C       South lat1:  x, 1, x, 2, x, 3, x, ... , KLON, ...
C       North lat2:  x, 1, x, 2, x, 3, x, ... , KLON, ...
C       South lat2:  x, 1, x, 2, x, 3, x, ... , KLON, ...
C       ... for KROWS latitudes.
C
C     The 'x' represents the extra values generated because of the
C     need for the number of points along a latitude line to be more
C     than twice the truncation of the spherical harmonics.
C
C
C     Author
C     ______
C
C     J.D.Chambers      ECMWF      Jan 1994
C
C
C     Modifications
C     _____________
C
C     None
C
C----<
C
      IMPLICIT NONE
C
#include "jparams.h"
#include "parim.h"
C
C     Subroutine arguments
      INTEGER KSTART, KGNUM
      REAL PZFA, PWEST, POUTF
      DIMENSION PZFA( JPLONO+2, 64), POUTF(*)
      INTEGER KROWS, KCOLS, KLON, KJPWR, KOFSET, KFLAG
      DIMENSION KOFSET(*)
C
C     Parameters
      INTEGER JPROUTINE
      PARAMETER( JPROUTINE = 31800 )
C
C     Local variables
      INTEGER IOFFN, IOFFS, NXTLAT, NXTLON, NEXTPT
      INTEGER LONGIT, N360, NSTART
      REAL PINTVL
C
C     _______________________________________________________
C
C*    Section 1. Initialization
C     _______________________________________________________
C
  100 CONTINUE
C
      IF ( NDBG .GT. 1) THEN
        CALL INTLOG(JP_DEBUG,'JMOVGG - Input parameters:',JPQUIET)
        CALL INTLOGR(JP_DEBUG,
     X    'Western longitude for output = ', PWEST)
        CALL INTLOG(JP_DEBUG,
     X    'JMOVGG -  Gaussian number for field = ', KGNUM)
        CALL INTLOG(JP_DEBUG,
     X    'JMOVGG - First latitude for moving = ', KSTART)
        CALL INTLOG(JP_DEBUG,
     X    'JMOVGG - Number of latitudes to store = ', KROWS)
        CALL INTLOG(JP_DEBUG,
     X    'JMOVGG - Number of longitude pts per row = ', KCOLS)
        CALL INTLOG(JP_DEBUG,
     X    'JMOVGG - No. long.pts per generated row = ', KLON)
        CALL INTLOG(JP_DEBUG,
     X    'JMOVGG - Multiplication factor applied = ', KJPWR)
        CALL INTLOG(JP_DEBUG,
     X    'JMOVGG - Move hemisphere(1=N,2=S,3=both) = ', KFLAG)
C
        CALL INTLOG(JP_DEBUG,
     X    'JMOVGG - Offsets(20) for each lat. in output array:',JPQUIET)
C
        DO 101 NDBGLP = 1, 20
          CALL INTLOG(JP_DEBUG,' ',KOFSET(NDBGLP))
  101   CONTINUE
      ENDIF
C
C     Calculate which longitude point to start from in row
      N360   = 4*KGNUM
      PINTVL = 360.0/FLOAT(N360)
      LONGIT = NINT( (360.0 + PWEST)/PINTVL )
      NSTART = MOD( LONGIT, N360)*KJPWR
      IF ( NDBG .GT. 1) THEN
        CALL INTLOGR(JP_DEBUG,
     X    'Longitude interval along row = ', PINTVL)
        CALL INTLOG(JP_DEBUG,
     X    'JMOVGG -  Start longitude = ', LONGIT)
        CALL INTLOG(JP_DEBUG,
     X    'JMOVGG -  Modulus for longitude 360deg. = ', N360)
        CALL INTLOG(JP_DEBUG,
     X    'JMOVGG -  Start point index = ', NSTART)
      ENDIF
C     _______________________________________________________
C
C
C*    Section 2. Store the points for northern latitudes, southern 
C*               latitudes or both.
C     _______________________________________________________
C
 200  CONTINUE
C
C     Store Northern latitudes ..
C     .. skipping intermediate values - see calculation of NEXTPT below
C
      IF ( KFLAG .NE. 2 ) THEN
C
        IF ( NDBG .GT. 1) CALL INTLOG(JP_DEBUG,
     X    'JMOVGG -  Storing North latitudes',JPQUIET)
C
        DO NXTLAT = 1, KROWS*2, 2
C
C         Find start offset in storage array
          IOFFN  = KOFSET(KSTART + NXTLAT/2) - 1
          DO NXTLON = 1, KCOLS
            NEXTPT = 2 + MOD( NSTART + (NXTLON-1)*KJPWR , KLON)
            POUTF( NXTLON + IOFFN ) = PZFA( NEXTPT, NXTLAT)
          ENDDO
        ENDDO
      ENDIF
C
C     Store Southern latitudes ..
C     .. skipping intermediate values - see calculation of NEXTPT below
C
      IF ( KFLAG .NE. 1 ) THEN
C
        IF ( NDBG .GT. 1) CALL INTLOG(JP_DEBUG,
     X    'JMOVGG -  Storing South latitudes',JPQUIET)
C
        DO NXTLAT = 2, KROWS*2, 2
C
C         Find start offset in storage array
          IOFFS  = KOFSET(2*KGNUM - KSTART + 1 - NXTLAT/2 + 1) - 1
          DO NXTLON = 1, KCOLS
            NEXTPT = 2 + MOD( NSTART + (NXTLON-1)*KJPWR , KLON)
            POUTF( NXTLON + IOFFS ) = PZFA( NEXTPT, NXTLAT)
          ENDDO
        ENDDO
C
      ENDIF
C
C     _______________________________________________________
C
C
C*    Section 9. Return to calling routine. Format statements
C     _______________________________________________________
C
  900 CONTINUE
C
C
      RETURN
      END

C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE ECDF191(HFUNC,KSEC1,KGRIB,KLENG,KNSPT,KBITS,KPLEN,KRET)
C
C---->
C**** ECDF191
C
C     Purpose.
C     --------
C
C     GRIB coding/decoding of ECMWF local use definition 191.
C
C**   Interface.
C     ----------
C
C     CALL ECDF191(HFUNC,KSEC1,KGRIB,KLENG,KNSPT,KBITS,KRET)
C
C
C     Input
C     -----
C     HFUNC      - Requested function.
C                  'C' to code data.
C                  'D' to decode data.
C     KSEC1      - Array containing Grib Section 1 data.
C     KGRIB      - Array containing Grib coded data.
C     KLENG      - Length (words) of KGRIB.
C     KNSPT      - Bit number after which insertion/extraction starts.
C     KBITS      - Number of bits in computer word.
C     KPLEN      - Pointer to field containing length of Section 1.
C     KRET       - Response to error indicator.
C                  0        , Abort if error encountered.
C                  Non-zero , Return to calling routine
C                             even if error encountered.
C
C     Output
C     ------
C     KSEC1      - Array containing Grib Section 1 data.(Updated)
C     KGRIB      - Array containing Grib coded data.(Updated)
C     KNSPT      - Number of bit after last one inserted/extracted.
C                  (Updated)
C     KRET       - Return code.
C                  0   , No error encountered.
C                  2   , Error reported by routine INXBIT.
C
C
C     Method.
C     -------
C     Input data packed/unpacked in accordance with ECMWF usage of
C     local part of section 1 of Grib code, definition 191.
C
C
C     Externals.
C     ----------
C
C     INXBIT  - insert/extract bits
C     ABORTX  - abort the program
C     CSGNBT  - code a signed value
C     DSGNBT  - decode a signed value
C
C
C     Reference.
C     ----------
C
C     WMO Manual On Codes for Grib Code.
C
C
C     Comments.
C     ---------
C
#include "ecdf191.h"
C
C
C     Author.
C     -------
C
C     J.D.Chambers     ECMWF      December 2001
C
C
C     Modifications.
C     --------------
C
C     None
C
C
C----<
C     -----------------------------------------------------------------|
C*    Section 0 . Definition of variables. Data statements.
C     -----------------------------------------------------------------|
C
      IMPLICIT NONE
C
C     Parameter(s)
C
      INTEGER JPBYTES
C                `-----> Number of bytes in an INTEGER
#ifdef INTEGER_8
      PARAMETER( JPBYTES = 8)
#else
      PARAMETER( JPBYTES = 4)
#endif
C
C     Subroutine arguments
C
      CHARACTER*1   HFUNC
      INTEGER KSEC1, KGRIB, KLENG, KNSPT, KBITS, KPLEN, KRET
      DIMENSION KGRIB(*)
      DIMENSION KSEC1(*)
C
C     Local variables
C
      INTEGER IRET, IZERO, JLOOP, N, M, ILENS1, N_KNSPT, ICOUNT, IBITS
C
      LOGICAL LENCODE, LDECODE
C
C     -----------------------------------------------------------------|
C*    Section 1 . Set initial values.
C     -----------------------------------------------------------------|
C
  100 CONTINUE
C
      IRET = KRET
      LENCODE = ( HFUNC.EQ.'C' )
      LDECODE = .NOT. LENCODE
C
      N_KNSPT = KNSPT
C
C     -----------------------------------------------------------------|
C*    Section 2 . Handle the local extension
C     -----------------------------------------------------------------|
C
  200 CONTINUE
C
C     Octet 50 : Zero
C     Octet 51 : Zero
C     Two 8 bit fields.
C
      IF( LENCODE ) THEN
        IZERO = 0
        CALL INXBIT(KGRIB,KLENG,KNSPT,IZERO,1,KBITS,8,HFUNC,KRET)
        IF( KRET.NE.0 ) THEN
          KRET = 2
          WRITE(*,*) 'ECDF191: Error reported by routine INXBIT:'
          WRITE(*,*) '          encoding section 1, octet 50'
          GOTO 900
        ENDIF
      ELSE
        KSEC1(42) = 0
        KNSPT = KNSPT + 8
      ENDIF
C
      IF( LENCODE ) THEN
        IZERO = 0
        CALL INXBIT(KGRIB,KLENG,KNSPT,IZERO,1,KBITS,8,HFUNC,KRET)
        IF( KRET.NE.0 ) THEN
          KRET = 2
          WRITE(*,*) 'ECDF191: Error reported by routine INXBIT:'
          WRITE(*,*) '          encoding section 1, octet 51'
          GOTO 900
        ENDIF
      ELSE
        KSEC1(43) = 0
        KNSPT = KNSPT + 8
      ENDIF
C
C     Octet 52 : Format version major number
C     Octet 53 : Format version minor number
C     Two 8 bit fields.
C
      CALL INXBIT(KGRIB,KLENG,KNSPT,KSEC1(44),1,KBITS,8,HFUNC,KRET)
      IF( KRET.NE.0 ) THEN
        KRET = 2
        WRITE(*,*) 'ECDF191: Error reported by routine INXBIT:'
        IF( LENCODE ) THEN
          WRITE(*,*) '      encoding section 1, element 44.'
        ELSE
          WRITE(*,*) '      decoding section 1, octet 52.'
        ENDIF
        GOTO 900
      ENDIF
C
      CALL INXBIT(KGRIB,KLENG,KNSPT,KSEC1(45),1,KBITS,8,HFUNC,KRET)
      IF( KRET.NE.0 ) THEN
        KRET = 2
        WRITE(*,*) 'ECDF191: Error reported by routine INXBIT:'
        IF( LENCODE ) THEN
          WRITE(*,*) '      encoding section 1, element 45.'
        ELSE
          WRITE(*,*) '      decoding section 1, octet 53.'
        ENDIF
        GOTO 900
      ENDIF
C
C     Octet 54 : Original sub-centre identifier
C     One 8 bit fields.
C
      CALL INXBIT(KGRIB,KLENG,KNSPT,KSEC1(46),1,KBITS,8,HFUNC,KRET)
      IF( KRET.NE.0 ) THEN
        KRET = 2
        WRITE(*,*) 'ECDF191: Error reported by routine INXBIT:'
        IF( LENCODE ) THEN
          WRITE(*,*) '      encoding section 1, element 46.'
        ELSE
          WRITE(*,*) '      decoding section 1, octet 54.'
        ENDIF
        GOTO 900
      ENDIF
C
C     Octet 55-58 : Padding, set to zero
C     Four 8 bit fields.
C
      IF( LENCODE ) THEN
        IZERO = 0
        CALL INXBIT(KGRIB,KLENG,KNSPT,IZERO,1,KBITS,8,HFUNC,KRET)
        IF( KRET.NE.0 ) THEN
          KRET = 2
          WRITE(*,*) 'ECDF191: Error reported by routine INXBIT:'
          WRITE(*,*) '          encoding section 1, octet 55'
          GOTO 900
        ENDIF
      ELSE
        KSEC1(47) = 0
        KNSPT = KNSPT + 8
      ENDIF
C
      IF( LENCODE ) THEN
        IZERO = 0
        CALL INXBIT(KGRIB,KLENG,KNSPT,IZERO,1,KBITS,8,HFUNC,KRET)
        IF( KRET.NE.0 ) THEN
          KRET = 2
          WRITE(*,*) 'ECDF191: Error reported by routine INXBIT:'
          WRITE(*,*) '          encoding section 1, octet 56'
          GOTO 900
        ENDIF
      ELSE
        KSEC1(48) = 0
        KNSPT = KNSPT + 8
      ENDIF
C
      IF( LENCODE ) THEN
        IZERO = 0
        CALL INXBIT(KGRIB,KLENG,KNSPT,IZERO,1,KBITS,8,HFUNC,KRET)
        IF( KRET.NE.0 ) THEN
          KRET = 2
          WRITE(*,*) 'ECDF191: Error reported by routine INXBIT:'
          WRITE(*,*) '          encoding section 1, octet 57'
          GOTO 900
        ENDIF
      ELSE
        KSEC1(49) = 0
        KNSPT = KNSPT + 8
      ENDIF
C
      IF( LENCODE ) THEN
        IZERO = 0
        CALL INXBIT(KGRIB,KLENG,KNSPT,IZERO,1,KBITS,8,HFUNC,KRET)
        IF( KRET.NE.0 ) THEN
          KRET = 2
          WRITE(*,*) 'ECDF191: Error reported by routine INXBIT:'
          WRITE(*,*) '          encoding section 1, octet 58'
          GOTO 900
        ENDIF
      ELSE
        KSEC1(50) = 0
        KNSPT = KNSPT + 8
      ENDIF
C
C     Octets 59-60: Number of bytes of free format data descriptor
C     One 16 bit field
C
      CALL INXBIT(KGRIB,KLENG,KNSPT,KSEC1(51),1,KBITS,16,HFUNC,KRET)
      IF( KRET.NE.0 ) THEN
        KRET = 2
        WRITE(*,*) 'ECDF191: Error reported by routine INXBIT:'
        IF( LENCODE ) THEN
          WRITE(*,*) '      encoding section 1, element 51.'
        ELSE
          WRITE(*,*) '      decoding section 1, octets 59 - 60.'
        ENDIF
        GOTO 900
      ENDIF
C
C     Octets 61-(60+N) : Data bytes
C     N values; 8 bit values packed in integer array element
C
      N = KSEC1(51)
      ICOUNT = (N+JPBYTES-1)/JPBYTES
      IBITS  = JPBYTES*8
      CALL INXBIT(KGRIB,KLENG,KNSPT,KSEC1(52),
     X            ICOUNT,KBITS,IBITS,HFUNC,KRET)
      IF( KRET.NE.0 ) THEN
        KRET = 2
        WRITE(*,*) 'ECDF191: Error reported by routine INXBIT:'
        IF( LENCODE ) THEN
          WRITE(*,*) '    encoding section 1, elements 52 - (51+N/4).'
        ELSE
          WRITE(*,*) '    decoding section 1, octets 61 - (60+N).'
        ENDIF
        GOTO 900
      ENDIF
C
C     Octets (60+N) onwards: Padded with zeroes
C     The section will be padded with zeroes to make the overall length
C     of the section = 60 + 80*M for some M > 0.
C
      M = 60+(((ICOUNT*JPBYTES)+79)/80)*80
C
      DO JLOOP = (60+ICOUNT*JPBYTES+1), M
        IF( LENCODE ) THEN
          IZERO = 0
          CALL INXBIT(KGRIB,KLENG,KNSPT,IZERO,1,KBITS,8,HFUNC,KRET)
          IF( KRET.NE.0 ) THEN
            KRET = 2
            WRITE(*,*) 'ECDF191: Error reported by routine INXBIT:'
            WRITE(*,*) '      encoding section 1, octets (56+N) onwards'
            GOTO 900
          ENDIF
        ELSE
          KNSPT = KNSPT + 8
        ENDIF
      ENDDO
C
C     Calculate section 1 total length using original and final bit
C     positions. NB packing started at octet 50.
C
      ILENS1 = 49 + (KNSPT - N_KNSPT)/8
C
C*    Insert length of section 1, if coding data.
C     One 24-bit field.
C
      IF( LENCODE ) THEN
        CALL INXBIT(KGRIB,KLENG,KPLEN,ILENS1,1,KBITS, 24,HFUNC,KRET)
        IF( KRET.NE.0 ) THEN
          KRET = 2
          WRITE(*,*) 'ECDF191: Error reported by routine INXBIT:'
          WRITE(*,*) '         encoding length of section 1'
          GOTO 900
        ENDIF
      ENDIF
C
C     -----------------------------------------------------------------|
C*    Section 9 . Abort/return to calling routine. Format statements.
C     -----------------------------------------------------------------|
C
  900 CONTINUE
C
C     Abort if requested to do so when an error has been encountered.
C
      IF( (IRET.EQ.0).AND.(KRET.NE.0) ) THEN
        CALL ABORTX('ECDF191')
      ELSE
        RETURN
      ENDIF
C
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C


      SUBROUTINE GETIND (KLND,KIND,KLEN,KARAY,KPR,KRET)
C
C---->
C     ----------------------------------------------------------------
C
C****
C
C     PURPOSE.
C     --------
C
C           GET INTEGER DATA FROM RECORD OF UNPACKED GRIB
C           OR PSEUDO-GRIB DATA.
C
C**   INTERFACE.
C     ----------
C
C           CALL GETIND (KLND,KIND,KLEN,KARAY,KPR,KRET)
C
C           INTEGER    K.
C           REAL       P.
C           LOGICAL    O.
C           CHARACTER  H.
C
C               INPUT PARAMETERS.
C               -----------------
C
C               KIND       - ARRAY TO RECEIVE INTEGER DATA.
C               KLEN       - LENGTH OF THIS ARRAY.
C               KARAY      - ARRAY CONTAINING UNPACKED RECORD.
C               KPR        - DEBUG PRINT SWITCH.
C                            0 , NO PRINTOUT.
C                            1 , DEBUG PRINTOUT.
C
C               KRET       - ABORT/NO ABORT WHEN ERROR FOUND.
C                            0   , ABORT IF ERROR FOUND.
C                            NON-ZERO , NO ABORT ON ERROR.
C
C               OUTPUT PARAMETERS.
C               ------------------
C
C               KRET       - ERROR RETURN CODE.
C                            0   , NO ERROR ENCOUNTERED.
C                            1   , TARGET ARRAY TOO SMALL.
C               KIND       - INTEGER DATA.
C               KLND       - NUMBER OF VALUES IN THIS ARRAY.
C
C     METHOD.
C     -------
C
C           UNPACKED DATA IS IN SELF-DEFINING RECORDS. THE REQUIRED
C           VALUES ARE LOCATED AND EXTRACTED.
C
C     EXTERNALS.
C     ----------
C
C           NONE.
C
C     REFERENCE.
C     ----------
C
C           SEE MARS FORMAT DOCUMENTATION RE GRIB, PSEUDO-GRIB AND
C           UNPACKED RECORD FORMATS.
C
C     COMMENTS.
C     ---------
C
C           PROGRAM CONTAINS SECTIONS 0 TO 2 AND SECTION 9.
C
C     AUTHOR.
C     -------
C
C           J. HENNESSY      ECMWF      18:06:86.
C
C     MODIFICATIONS
C     --------------
C           NONE.
C
C     ----------------------------------------------------------------
C----<
C
C
C
C
C
C
C
C
C
C
C*    SECTION 0 . DEFINITION OF VARIABLES.
C     ------------------------------------
C
      IMPLICIT LOGICAL     ( L, O, G )
      IMPLICIT CHARACTER*8 ( C, H, Y )
      IMPLICIT INTEGER     ( I, J, K, M, N )
C
      DIMENSION KARAY(*)
      DIMENSION KIND(KLEN)
C
C     ----------------------------------------------------------------
C
C
C
C
C
C
C
C
C
C*    SECTION 1 . SET INITIAL VALUES. CHECK INPUT PARAMETERS.
C     -------------------------------------------------------
C
 1000 CONTINUE
C
      IF (KPR.EQ.1) WRITE (*,*) 'GETIND : SECTION 1.'
C
      IRET = KRET
      KRET = 0
C
C
C*    GO TO SECTION 9 , IF ERROR IN PARAMETERS.
C
      IF (KRET.NE.0) GO TO 9000
C
C     ----------------------------------------------------------------
C
C
C
C
C
C
C
C
C
C*    SECTION 2 . LOCATE AND EXTRACT VALUES.
C     --------------------------------------
C
 2000 CONTINUE
C
      IF (KPR.EQ.1) WRITE (*,*) 'GETIND : SECTION 2.'
C
      ILB1 = KARAY(2)
      ILB2 = KARAY(2+ILB1+1)
      ILF2 = KARAY(2+ILB1+1+ILB2+1)
      ILB3 = KARAY(2+ILB1+1+ILB2+1+ILF2+1)
      ILCD = KARAY(2+ILB1+1+ILB2+1+ILF2+1+ILB3+1)
      ILFD = KARAY(2+ILB1+1+ILB2+1+ILF2+1+ILB3+1+ILCD+1)
      KLND = KARAY(2+ILB1+1+ILB2+1+ILF2+1+ILB3+1+ILCD+1+ILFD+1)
C
      IF (KLEN.LT.KLND)
     C   THEN
             KRET = 1
             WRITE (*,9001) KRET , KLND
             GO TO 9000
         ENDIF
C
      DO 2010 J=1,KLND
         KIND(J) = KARAY(J+2+ILB1+1+ILB2+1+ILF2+1+ILB3+1+ILCD+1+ILFD+1)
 2010 CONTINUE
C
C
C     ----------------------------------------------------------------
C
C
C
C
C
C
C
C*    SECTION 9 . RETURN TO CALLING ROUTINE OR ABORT. FORMAT STATEMENTS.
C     ------------------------------------------------------------------
C
 9000 CONTINUE
C
      IF (KPR.EQ.1) WRITE (*,*) 'GETIND : SECTION 9.'
C
      IF (KRET.NE.0.AND.IRET.EQ.0) CALL ABORT
C
      RETURN
C
C
 9001 FORMAT (1H ,'GETIND : ERROR CODE = ',I3,'. TARGET ARRAY MUST ',
     C            'BE AT LEAST ',I5,' WORDS LONG.')
C
C
C     ---------------------------------------------------------------
C
C
      END
C

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      INTEGER FUNCTION TAB2FIL ( KTABLE, KPARAM, KCENTR, HFILE )
C
C---->
C**** TAB2FIL
C
C     Purpose
C     -------
C
C     Build name of file that should contain, if present, the GRIB code
C     table 2 (parameters) associated to data (with valid entries) .
C
C
C     Interface
C     ---------
C
C     IRET = TAB2FIL ( KTABLE, KPARAM, KCENTR )
C
C     Input
C     -----
C
C     KTABLE - Local table 2 version number.
C     KPARAM - Parameter number.
C     KCENTR - Centre number.
C
C
C     Output
C     ------
C
C     HFILE - File name to look for and contact.
C
C     Function return value is:
C            0 - In all current cases .
C
C
C     Method
C     ------
C
C     Checks if environment variable ECMWF_LOCAL_TABLE_PATH exists to
C     define the location of the parameter tables.
C
C     Otherwise, looks for table xxx in:
C
C     ${ELTPATH}/wmostd/table_2_version_xxx for WMO standard entries ;
C
C     ${ELTPATH}/nnnnnn/local_table_2_version_xxx for ECMWF home data
C     where nnnnnn is the current EMOSLIB version ;
C
C     ${ELTPATH}/cenCCC/local_table_2_version_xxx for home data of
C     centre number CCC .
C
C     Entry for each parameter in table has the format (without quotes):
C        "......................"         Separator
C        "051"                            Paramter number
C        "MX2T24"                         MARS mnemonic
C        "Max 2m temp"                    Parameter description
C        "K"                              Units for the parameter
C        "During previous 24 hours"       Further description
C
C     There is a termination "......................" line in the file
C     and there may be lines of comment before the first parameter entry.
C
C     The parameter definition file is kept open between calls.
C
C
C     Externals
C     ---------
C     EMOSNUM - Gives current EMOSLIB version number.
C
C
C     Author
C     ------
C
C     J. Clochard, Meteo France, for ECMWF - June 1999.
C
C
C     MODIFICATIONS
C     _____________
C
C     None.
C
C     _______________________________________________________
C----<
C
C
      IMPLICIT NONE
C
#include "common/grprs.h"
#include "grbcom.h"
C
C     Function arguments
C
      INTEGER KPARAM, KTABLE, KCENTR
C
      CHARACTER*256 HFILE
C
C     Local variables
C
      INTEGER IEMOSNM, IOFFSET
C
C     External functions
C
      INTEGER EMOSNUM
      EXTERNAL EMOSNUM
C
C
C ------------------------------------------------------------------
C*    Section 1.   Initialise
C ------------------------------------------------------------------
C
  100 CONTINUE
C
      TAB2FIL = 0
C
C     Build filename
C
      HFILE = ELTPATH
      IOFFSET = INDEX( HFILE, ' ')
C
      IF( MAX( KTABLE,KPARAM) .LE. 127 ) THEN
C
        HFILE(IOFFSET:)='wmostd/table_2_version_'
        IOFFSET = INDEX( HFILE, ' ')
C
      ELSE
C
        IF( KCENTR .EQ. 98 ) THEN
C
          IEMOSNM = EMOSNUM(1)
          WRITE(HFILE(IOFFSET:IOFFSET+5),'(I6.6)') IEMOSNM
C
        ELSE
C
          HFILE(IOFFSET:IOFFSET+3)='cen'
          WRITE(HFILE(IOFFSET+3:IOFFSET+5),'(I3.3)') KCENTR
C
        ENDIF
C
        IOFFSET=IOFFSET+6
        HFILE(IOFFSET:)='/local_table_2_version_'
C
      ENDIF
C
      IOFFSET = INDEX( HFILE, ' ')
      WRITE(HFILE(IOFFSET:IOFFSET+2),'(I3.3)') KTABLE
C     print *,'TAB2FIL: HFILE = "' // HFILE(:IOFFSET+2) // '"'
C
C
C ------------------------------------------------------------------
C*    Section 9.   Closedown.
C ------------------------------------------------------------------
C
C     Drop through if not found.
C
      RETURN   
C
      END

C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C


      SUBROUTINE FTN1CR ( KNUM , KPR ,KRET )
C
C---->
C**** FTN1CR
C
C     PURPOSE.
C     --------
C
C           GIVES FORTRAN UNIT NUMBER NOT CURRENTLY IN USE.
C
C**   INTERFACE.
C     ----------
C
C           CALL FTN1CR ( KNUM , KPR ,KRET )
C
C           INTEGER    K.
C           REAL       P.
C           LOGICAL    O.
C           CHARACTER  H.
C
C               INPUT PARAMETERS.
C               -----------------
C
C               KPR        - DEBUG PRINT SWITCH.
C                            0 , NO PRINTOUT.
C                            1 , DEBUG PRINTOUT.
C
C               OUTPUT PARAMETERS.
C               ------------------
C
C               KNUM       - FREE FORTRAN UNIT NUMBER.
C               KRET       - ERROR RETURN CODE.
C                            0   , NO ERROR ENCOUNTERED.
C                            1   , NO UNIT NUMBER FREE.
C
C     METHOD.
C     -------
C
C           INQUIRE STATEMENT ON CRAY ALIAS USED.
C
C     EXTERNALS.
C     ----------
C
C           NONE.
C
C     REFERENCE.
C     ----------
C
C           NONE.
C
C     COMMENTS.
C     ---------
C
C           ROUTINE CONTAINS SECTIONS 0 , 2  AND SECTION 9.
C
C     AUTHOR.
C     -------
C
C           J. HENNESSY      ECMWF      12.07.89.
C
C     MODIFICATIONS
C     --------------
C
C           NONE.
C
C----<
C     ----------------------------------------------------------------
C
C
C
C
C
C
C
C
C
C
C*    SECTION 0 . DEFINITION OF VARIABLES.
C     ----------------------------------------------------------------
C
      IMPLICIT LOGICAL     ( L, O, G )
      IMPLICIT CHARACTER*8 ( C, H, Y )
      IMPLICIT INTEGER     ( I, J, K, M, N )
C
C
C     ----------------------------------------------------------------
C
C
C
C
C
C
C
C
C
C*    SECTION 1 . SET INITIAL VALUES.
C     ----------------------------------------------------------------
C
 1000 CONTINUE
C
      IF (KPR.EQ.1) WRITE (*,*) 'FTN1CR : SECTION 1.'
C
      KRET = 0
C
C
C     ----------------------------------------------------------------
C
C
C
C
C
C
C
C
C
C*    SECTION 2 . INQUIRE FOR FREE UNIT.
C     ----------------------------------------------------------------
C
 2000 CONTINUE
C
      IF (KPR.EQ.1) WRITE (*,*) 'FTN1CR : SECTION 2.'
C
      DO 2010 J2010 = 99,1,-1
         IF (J2010.EQ.5) GO TO 2010
         IF (J2010.EQ.6) GO TO 2010
         WRITE (YALIAS,'(A,I2.2)') 'FT',J2010
         INQUIRE (FILE=YALIAS,EXIST=LEX)
         IF (LEX) GO TO 2010
         KNUM = J2010
         GO TO 2050
 2010 CONTINUE
C
C     NO FREE UNIT FOUND.
C
      KRET = 1
C
      WRITE (*,9001)
C
 2050 CONTINUE
C
      IF (KPR.EQ.1) WRITE (*,9002) KNUM
C
      GO TO 9000
C
C
C     ----------------------------------------------------------------
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C*    SECTION 9 . RETURN TO CALLING ROUTINE. FORMAT STATEMENTS.
C     ------------------------------------------------------------------
C
 9000 CONTINUE
C
      IF (KPR.EQ.1) WRITE (*,*) 'FTN1CR : SECTION 9.'
C
C
      RETURN
C
C
 9001 FORMAT (1H ,'FTN1CR : NO FORTRAN UNIT AVAILABLE.')
C
 9002 FORMAT (1H ,'FTN1CR : FORTRAN UNIT ALLOCATED = ',I3)
C
C
C     ------------------------------------------------------------------
C
C
      END

C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE MKFRAME(KWE,KNS,ZSEC4,ZMISS,KFRAME)
C
C---->
C**** MKFRAME
C
C     Purpose
C     -------
C
C     Remove points from inside a frame boundary.
C
C
C     Interface
C     ---------
C
C     CALL  MKFRAME(KWE,KNS,ZSEC4,ZMISS,KFRAME)
C
C     Input
C     -----
C
C     KWE    - Number of points west-east in input field.
C     KNS    - Number of points north-south in input field.
C     ZSEC4  - GRIBEX section 4 values in the field.
C     ZMISS  - Value to be used as the missing data value..
C     KFRAME - Number of points across the frame.
C
C
C     Output
C     ------
C
C     ZSEC4  - GRIBEX section 4 values with the points inside the frame
C              replaced by missing data values.
C
C
C     Method
C     ------
C
C     The field and frame are rectangular.
C
C
C     Externals
C     ---------
C
C     INTLOG  - Log error message.
C     INTLOGR - Log error message.
C
C
C     Author
C     ------
C
C     J.D.Chambers     ECMWF     May 1999.
C
C----<
C
      IMPLICIT NONE
C
C     Subroutine arguments
C
      INTEGER KWE,KNS, KFRAME
      REAL ZSEC4(*), ZMISS
C
C     Local variables
C
      INTEGER TOP, BOTTOM, LEFT, RIGHT, LOOPO, LOOPI, NEXT
C
#include "parim.h"
#include "jparams.h"
C
C ------------------------------------------------------------------
C*    Section 1.   Initialise
C ------------------------------------------------------------------
C
  100 CONTINUE
C
      IF( KFRAME.LT.1 ) GOTO 900
C
      TOP    = KFRAME + 1
      BOTTOM = KNS - KFRAME
      LEFT   = KFRAME + 1
      RIGHT  = KWE - KFRAME
C
      IF( NDBG.GT.0 ) THEN
        CALL INTLOG(JP_DEBUG,'MKFRAME: KFRAME = ', KFRAME)
        CALL INTLOG(JP_DEBUG,'MKFRAME: TOP = ', TOP)
        CALL INTLOG(JP_DEBUG,'MKFRAME: BOTTOM = ', BOTTOM)
        CALL INTLOG(JP_DEBUG,'MKFRAME: LEFT = ', LEFT)
        CALL INTLOG(JP_DEBUG,'MKFRAME: RIGHT = ', RIGHT)
        CALL INTLOGR(JP_DEBUG,'MKFRAME: ZMISS = ', ZMISS)
      ENDIF
C
      DO LOOPO = TOP, BOTTOM
        NEXT = (LOOPO-1)*KWE + (LEFT-1)
        DO LOOPI = LEFT, RIGHT
          NEXT = NEXT + 1
          ZSEC4(NEXT) = ZMISS
        ENDDO
      ENDDO
C
C ------------------------------------------------------------------
C*    Section 9.   Closedown.
C ------------------------------------------------------------------
C
  900 CONTINUE
C
      RETURN
      END

C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE HPSHGPW(OLDLON,OLDLAT,NEWLON,NEWLAT,
     X                   PDIRI,NUMPTS,POLE)
C
C---->
C**** HPSHGPW
C
C     Purpose
C     -------
C
C     Rotates a grid of points about the y-axis and calculates the
C     angular change between local axes at each grid point.
C
C
C     Interface
C     ---------
C
C     CALL HPSHGPW(OLDLON,OLDLAT,NEWLON,NEWLAT,PDIRI,NUMPTS,POLE)
C
C     Input
C     -----
C
C     OLDLON - Array of longitudes to be rotated (degrees)
C     OLDLAT - Array of latitudes to be rotated (degrees)
C     NUMPTS - Number of gridpoints to be rotated
C     PDIRI  - Array of initial orientation angles, eg wind directions
C              (degrees)
C     POLE   - (Lat,long) of new south pole, measured in old grid
C
C
C     Output
C     ------
C
C     NEWLON - Array of rotated longitudes (degrees, -180 < angle <= 180 )
C     NEWLAT - Array of rotated latitudes (degrees)
C     PDIRI  - Array of modified orientation angles, changed to allow for
C              the angles between coordinate axes at each point before and
C              after rotation (degrees, -180 < angle <= 180 )
C
C
C     Method
C     ------
C
C     Rotates a grid of points about the y-axis and calculates the
C     angular change to local axes at each grid point.
C
C     The z-axis is the polar axis, increasing from south to north.
C     The x-axis is line from the centre of the globe through (0N, 0E),
C     increasing from the centre out to (0N, 0E).
C     The y-axis is line from the centre of the globe through (0N, 90E),
C     increasing from the centre out to (0N, 90E).
C
C     The sign of the angular change between local axes at each grid point
C     is such that it denotes the angle of rotation to be applied to the
C     old coordinate system to let its axes coincide with the new one. The
C     angle is measured in the old coordinate system, so increments to
C     angles in PDIRI are positive for anti-clockwise rotation from old
C     x-axis to new one.
C
C     As a consequence, if the initial values in PDIRI are wind directions
C     ddd in the old coordinate system (measured to conform to meteorological
C     use), the output values of PDIRI will be ddd in the new coordinate system
C     (modulo 360).
C
C     Note that the meteorological use of ddd has effectively the opposite
C     sign to the mathematically usual way of defining angles.
C
C     The angles between the coordinate axes at each point may be obtained
C     by calling the routine with the values in PDIRI all set to zero on input.
C
C
C     Externals
C     ---------
C
C     None.
C
C
C     Author
C     ------
C
C     G.J.Cats            15 DEC 88.
C
C
C     Modified
C     --------
C
C     P.O'Sullivan        30/3/93 (wind and nonwind)
C
C     J.D.Chambers        October 1999
C
C
C----<
C     -----------------------------------------------------------------|
C
      IMPLICIT NONE
C
C     Parameters
C
      REAL EPSILON
      PARAMETER( EPSILON = 1E-5)
C                 `---------------> tolerance used for checking
C                                   proximity to +/-90.0 and 180.0
C
C     Subroutine arguments
C
      REAL OLDLON, OLDLAT, NEWLON, NEWLAT, PDIRI, POLE(2)
      DIMENSION OLDLON(*), OLDLAT(*), NEWLON(*), NEWLAT(*), PDIRI(*)
      INTEGER NUMPTS
C
C     Local variables
C
      INTEGER NXTPT
      REAL SINTHE, COSTHE, THETA
      REAL ZLAT, SINLAT, COSLAT
      REAL ZLON, SINLON, COSLON
      REAL ZNEW, LATNEW, NCOSLAT, COSNEW, LONNEW, COSDEL, DELTA, ZDIV
C
C     Statement functions
C
      REAL A
      REAL RADIAN, DEGREE, NORMAL
      REAL LONGMOD
C
C     Convert degrees to radians
C
      RADIAN(A) = (A) * 0.01745329252
C
C     Convert radians to degrees
C
      DEGREE(A) = (A) * 57.295779513
C
C     Normalise value such as sin or cos to range (-1,1)
C
      NORMAL(A) = MAX(MIN((A),1.0),-1.0)
C
C     -----------------------------------------------------------------|
C*    Section 1.   Initialise
C     -----------------------------------------------------------------|
C
      LONGMOD = -POLE(2)
      THETA  = RADIAN(POLE(1))
      SINTHE = -SIN(THETA)
      COSTHE = -COS(THETA)
C
C     -----------------------------------------------------------------|
C*    Section 2.   Handle each point separately (longitude,latitude)
C     -----------------------------------------------------------------|
C
      DO NXTPT = 1, NUMPTS
C
        ZLAT   = RADIAN(OLDLAT(NXTPT))
        SINLAT = SIN(ZLAT)
        COSLAT = COS(ZLAT)
C
        ZLON = OLDLON(NXTPT) + LONGMOD
        IF( ZLON.GT.180.0 ) ZLON = ZLON - 360.0
        IF( ABS(ZLON + 180.0).LT.EPSILON ) ZLON = 180.0
        ZLON   = RADIAN(ZLON)
        SINLON = SIN(ZLON)
        COSLON = COS(ZLON)
C
C       Calculate z coordinate of point after rotation and hence
C       its latitude after rotation since:
C         z = sin(lat)
C
        ZNEW = SINTHE*SINLAT+COSTHE*COSLAT*COSLON
        ZNEW = NORMAL(ZNEW)
        IF( ABS(ZNEW -1.0).LT.EPSILON ) Then
          LATNEW = 1.5707963268
          NEWLAT(NXTPT) = 90.0
          NCOSLAT = 0.0
        ELSE IF( ABS(ZNEW +1.0).LT.EPSILON ) THEN
          LATNEW = -1.5707963268
          NEWLAT(NXTPT) = -90.0
          NCOSLAT = 0.0
        ELSE
          LATNEW = ASIN(ZNEW)
          NEWLAT(NXTPT) = DEGREE(LATNEW)
          NCOSLAT = COS(LATNEW)
        ENDIF
C
C       Calculate x coordinate of point after rotation and hence
C       its longitude after rotation since:
C         x = cos(lat).cos(lon)
C         cos(lon) = x / cos(lat)
C
        IF( NCOSLAT.EQ.0.0 ) NCOSLAT = 1.0
        ZDIV = 1.0 / NCOSLAT
C
        COSNEW = ( (SINTHE*COSLAT*COSLON-COSTHE*SINLAT) ) * ZDIV
        COSNEW = NORMAL(COSNEW)
        LONNEW = SIGN(ACOS(COSNEW),ZLON)
        NEWLON(NXTPT) = DEGREE(LONNEW)
C
C       Use cosine rule from spherical trigonometry to find angle
C       between the directions of the meridians before and after
C       rotation.
C
        COSDEL = SINTHE*SINLON*SIN(LONNEW)+COSLON*COSNEW
        COSDEL = NORMAL(COSDEL)
        DELTA  = SIGN(ACOS(COSDEL),-COSTHE*ZLON)
C
C       Change the orientation angle (keep it in the range -180 to 180)
C
        PDIRI(NXTPT) = PDIRI(NXTPT) - DEGREE(DELTA)
        IF( PDIRI(NXTPT).GT.180.0 ) PDIRI(NXTPT) = PDIRI(NXTPT) - 360.0
        IF( PDIRI(NXTPT).LE.-180.0) PDIRI(NXTPT) = PDIRI(NXTPT) + 360.0
C
      ENDDO
C
C     -----------------------------------------------------------------|
C*    Section 9.   Closedown.
C     -----------------------------------------------------------------|
C
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities
C granted to it by virtue of its status as an intergovernmental organisation
C nor does it submit to any jurisdiction.
C

      INTEGER FUNCTION INTWAVE2(INGRIB,INLEN,OUTGRIB,OUTLEN)
C
C---->
C**** INTWAVE2
C
C     Purpose
C     -------
C
C     Interpolate an ECMWF wave field wave field or a reduced
C     latitude-longitude field
C
C
C     Interface
C     ---------
C
C     IRET = INTWAVE2(INGRIB,INLEN,OUTGRIB,OUTLEN)
C
C     Input
C     -----
C
C     INGRIB - Input field (packed).
C     INLEN  - Input field length (words).
C
C
C     Output
C     ------
C
C     OUTGRIB - Output field (packed).
C     OUTLEN  - Output field length (words).
C
C
C     Method
C     ------
C
C     Call interpolation routine; then repack into GRIB format.
C
C
C     Externals
C     ---------
C
C     FIXAREA - Fixup area definition to correspond to grid definitions
C     GRIBEX  - Decode/encode GRIB product.
C     JMEMHAN - Handles memory allocation.
C     JDEBUG  - Checks environment to switch on/off debug
C     INTLOG  - Log error message.
C     WAVEXX1 - Interpolate wave fields (except 2D spectra)
C     WV2DXXX - Interpolate wave 2D spectra fields
C     MKFRAME - Create a 'frame' from a rectangular field
C     MKBITMP - Apply a bitmap to a rectangular field
C
C
C     Author
C     ------
C
C     S.Curic     ECMWF     Jun 2009
C
C
C----<
C
      IMPLICIT NONE
C
C     Function arguments
      INTEGER INLEN,OUTLEN
      INTEGER INGRIB(*),OUTGRIB(*)
C
#include "parim.h"
#include "nifld.common"
#include "nofld.common"
#include "intf.h"
#include "grfixed.h"
#include "jparams.h"
C
C     Parameters
      INTEGER JPROUTINE, JP2DSP, JP2DSPQ, JPMAXLT

      PARAMETER (JPROUTINE = 40200 )
      PARAMETER (JP2DSP  = 250 )  ! for 2D wave spectra (whole)
      PARAMETER (JP2DSPQ = 251 )  ! for 2D wave spectra (single)
      PARAMETER (JPMAXLT = 1801 )
C
C     Local variables
C
      CHARACTER*1 HFUNC

      REAL ZMISS
      DATA ZMISS/-9999999.0/
      INTEGER IWORD, IRET, ISIZE, NSPEC, LAT1, LOOP, IERR
      INTEGER KNUM, NUM_E_W, NUM_N_S, NFULLNS, NFULLEW
      REAL GRIDWE, GRIDNS, NORTH, SOUTH, WEST, EAST
      INTEGER NUMPTS
      DIMENSION NUMPTS(JPMAXLT)
#ifndef _CRAYFTN
#ifdef POINTER_64
      INTEGER*8 INEWAVE, IDISTNW, IZ2DSP, INEWIDX
#endif
#endif
      REAL NEWAVE
      POINTER ( INEWAVE, NEWAVE )
      DIMENSION NEWAVE( 1 )
      REAL*4 DISTNEW
      POINTER ( IDISTNW, DISTNEW )
      DIMENSION DISTNEW( 1 )
      REAL Z2DSP
      POINTER ( IZ2DSP, Z2DSP )
      DIMENSION Z2DSP( 1 )
      INTEGER NEWIDX
      POINTER ( INEWIDX, NEWIDX )
      DIMENSION NEWIDX( 1 )
      REAL RNLAT, RSLAT
      INTEGER NUMTABL, NUMPROD
      LOGICAL LCOEFFS, L98WAVE, LFRAME, LBITMP
      LOGICAL LDEBUG
      INTEGER NPARAM
      INTEGER MISSLAT, KOLDNUM
C
C     Externals
      INTEGER WAVEXX2, WV2DXX2, AREACHK, FIXAREA
      INTEGER NUMPTNS, NUMPTWE, JNORSGG, MKBITMP
C
C ------------------------------------------------------------------
C     Section 1.   Initialise
C ------------------------------------------------------------------
C
  100 CONTINUE
C
      INTWAVE2 = 0
C
      LCOEFFS = .FALSE.
C
C     Check if debug option turned on
      CALL JDEBUG()
      LDEBUG = NDBG.GT.0
C
C     Allocate work array ZNFELDI if not already done.
C
      IF( IZNJDCI.NE.1952999238 ) THEN
        CALL JMEMHAN( 19, IZNFLDI, JPEXPAND, 1, IRET)
        IF( IRET.NE.0 ) THEN
          CALL INTLOG(JP_WARN,'INTWAVE2: ZNFELDI allocate fail',JPQUIET)
          INTWAVE2= IRET
          GOTO 900
        ENDIF
        IZNJDCI = 1952999238
      ENDIF
C
C     Unpack GRIB message headers (using ZMISS as missing data value).
C
cs      IWORD   = INLEN
      IRET = 1
      ISEC3(2) = NINT(ZMISS)
      ZSEC3(2) = ZMISS
      CALL GRIBEX (ISEC0,ISEC1,ISEC2,ZSEC2,ISEC3,ZSEC3,ISEC4,
     X             ZNFELDI,JPEXPAND,INGRIB,INLEN,IWORD,'D',IRET)

      IF(IRET.GT.0) THEN
       CALL INTLOG(JP_ERROR,'INTWAVE2: GRIBEX decoding failed.',JPQUIET)
        INTWAVE2 = JPROUTINE + 1
        GOTO 900
      ENDIF

      NPARAM = ISEC1(6)
C
C     Check that the field can be handled
C
      NUMTABL = ISEC1(2)*1000 + ISEC1(1)
      NUMPROD = NUMTABL*1000 + ISEC1(6)
      L98WAVE = (NUMTABL.EQ.98140).OR.
     X          (NUMPROD.EQ.98131229).OR.
     X          (NUMPROD.EQ.98131232).OR.
     X          (NIREPR.EQ.26)
      IF( .NOT.L98WAVE ) THEN
        CALL INTLOG(JP_WARN,'INTWAVE2: Not an ECMWF wave field',JPQUIET)
        INTWAVE2 = JPROUTINE + 2
        GOTO 900
      ENDIF
      IF( ISEC2(1).NE.0 ) THEN
        CALL INTLOG(JP_WARN,
     X    'INTWAVE2: Not a lat/long field',JPQUIET)
        INTWAVE2 = JPROUTINE + 3
        GOTO 900
      ENDIF
      IF( (ISEC2(6).NE.128) .OR. (ISEC2(10).LT.10) ) THEN
        CALL INTLOG(JP_ERROR,
     X    'INTWAVE2: Cannot handle longitude increment',ISEC2(10))
        INTWAVE2 = JPROUTINE + 4
        GOTO 900
      ENDIF
C
C ------------------------------------------------------------------
C     Section 2.   Sort out interpolation area.
C ------------------------------------------------------------------
C
  200 CONTINUE
C
      NSPEC = 1
      KNUM  = ISEC2(3)
C
C     Adjust (sub-)area limits to suit the grid
C
      IRET = FIXAREA()
      IF ( IRET .NE. 0 ) THEN
        CALL INTLOG(JP_ERROR, 'INTWAVE2: FIXAREA failed.',JPQUIET)
        INTWAVE2 = JPROUTINE + 5
        GOTO 900
      ENDIF
      NORTH = FLOAT(NOAREA(1))/PPMULT
      WEST  = FLOAT(NOAREA(2))/PPMULT
      SOUTH = FLOAT(NOAREA(3))/PPMULT
      EAST  = FLOAT(NOAREA(4))/PPMULT
C
C     Calculate the number of points E-W and N-S in new grid area
C
      IF( (NOREPR.EQ.JPQUASI) .OR. (NOREPR.EQ.JPGAUSSIAN)) THEN
        GRIDWE  = NOGAUSS
        GRIDNS  = 0
      ELSE IF( NOREPR.EQ.JPREDLL ) THEN
        GRIDWE  = 360.0/NOLPTS((NOREDLL/2)+1)
        GRIDNS  = FLOAT(NOGRID(2))/PPMULT
      ELSE
        GRIDWE  = FLOAT(NOGRID(1))/PPMULT
        GRIDNS  = FLOAT(NOGRID(2))/PPMULT
      ENDIF
C
      IRET = AREACHK(GRIDWE,GRIDNS,NORTH,WEST,SOUTH,EAST)
      IF( IRET.NE.0 ) THEN
        INTWAVE2 = JPROUTINE + 6
        GOTO 900
      ENDIF
      NOAREA(1) = NINT(NORTH*PPMULT)
      NOAREA(2) = NINT(WEST*PPMULT)
      NOAREA(3) = NINT(SOUTH*PPMULT)
      NOAREA(4) = NINT(EAST*PPMULT)
C
      IF( (NOREPR.EQ.JPQUASI) .OR. (NOREPR.EQ.JPGAUSSIAN)) THEN
        GRIDWE  = 360.0/NOLPTS(NOGAUSS)
        NUM_E_W = NUMPTWE(WEST,EAST,GRIDWE)
        NFULLEW = NUMPTWE(0.0,360.0,GRIDWE) - 1
        NUM_N_S = JNORSGG(SOUTH,ROGAUSS,NOGAUSS,1) -
     X            JNORSGG(NORTH,ROGAUSS,NOGAUSS,0) + 1
        NFULLNS = NOGAUSS*2
      ELSE IF( NOREPR.EQ.JPREDLL ) THEN
        NUM_E_W = NUMPTWE(WEST,EAST,GRIDWE)
        NFULLEW = NUMPTWE(0.0,360.0,GRIDWE) - 1
        NUM_N_S = NUMPTNS(NORTH,SOUTH,GRIDNS)
        NFULLNS = NOREDLL
      ELSE
        NUM_E_W = NUMPTWE(WEST,EAST,GRIDWE)
        NFULLEW = NUMPTWE(0.0,360.0,GRIDWE) - 1
        NUM_N_S = NUMPTNS(NORTH,SOUTH,GRIDNS)
        NFULLNS = NUM_N_S
      ENDIF
C
C
C--------------------------------------------------------------------
        KNUM = NINS
cs        KNUM = ISEC2(3)
      IF( ISEC2(17).EQ.1 ) THEN
C
C       Input field is a reduced latitude/longitude grid
C
C       .. but it may be 'pseudo-gaussian' in layout
C       (ie global, symmetric about the equator but no latitude
C        at the equator)
C
        IF( (ISEC2(4).NE.90000).AND.(MOD(ISEC2(3),2).EQ.0) ) THEN
C
          DO LOOP = 1, ISEC2(3)
            NUMPTS(LOOP) = ISEC2(22+LOOP)
          ENDDO
C
        ELSE
C
          MISSLAT = (90000 - ISEC2(4))/ISEC2(10)
          DO LOOP = 1, MISSLAT
            NUMPTS(LOOP)    = 0
          ENDDO
          KOLDNUM = 1 + (90000 - ISEC2(7))/ISEC2(10)
          DO LOOP = 1, (KOLDNUM-MISSLAT)
            NUMPTS(LOOP+MISSLAT) = ISEC2(22+LOOP)
          ENDDO
          DO LOOP = (KOLDNUM+1), KNUM
            NUMPTS(LOOP)    = 0
          ENDDO
        ENDIF
      ENDIF
C
C
C ------------------------------------------------------------------
C     Section 3.   Interpolate wave fields other than 2D spectra.
C ------------------------------------------------------------------
C
  300 CONTINUE
C
C     Handle if not 2D spectra ..
C
      IF( (ISEC1(6).NE.JP2DSP).AND.(ISEC1(6).NE.JP2DSPQ) ) THEN
       IF( LDEBUG ) THEN
       CALL INTLOG(JP_DEBUG,
     X 'INTWAVE2: Interpolate wave flds other than 2D spectra',JPQUIET)
       ENDIF
C
C       Get some scratch space for the interpolated field.
C
        ISIZE = NFULLEW * NUM_N_S
        CALL JMEMHAN( 3, INEWAVE, ISIZE, 1, IRET)
        IF ( IRET.NE.0 ) THEN
          CALL INTLOG(JP_ERROR,'INTWAVE2: Get work space fail.',JPQUIET)
          INTWAVE2 = JPROUTINE + 7
          GOTO 900
        ENDIF
C
        ISIZE = NFULLEW * NFULLNS * 4
        CALL JMEMHAN( 4, INEWIDX, ISIZE, 1, IRET)
        IF ( IRET.NE.0 ) THEN
          CALL INTLOG(JP_ERROR,'INTWAVE2: Get work space fail.',JPQUIET)
          INTWAVE2 = JPROUTINE + 8
          GOTO 900
        ENDIF
C
        ISIZE = NFULLEW * NFULLNS * 10
        CALL JMEMHAN( 5, IDISTNW, ISIZE, 1, IRET)
        IF ( IRET.NE.0 ) THEN
          CALL INTLOG(JP_ERROR,'INTWAVE2: Get work space fail.',JPQUIET)
          INTWAVE2 = JPROUTINE + 9
          GOTO 900
        ENDIF

C       Interpolate the field
C
        IRET = WAVEXX2(NPARAM,KNUM,NUMPTS,NUM_N_S,GRIDNS,GRIDWE,ZNFELDI,
     X               NEWAVE,NORTH,WEST,ZMISS)
        IF( IRET.NE.0 ) THEN
         CALL INTLOG(JP_ERROR,'INTWAVE2: Interpolation failed.',JPQUIET)
          INTWAVE2 = JPROUTINE + 10
          GOTO 900
        ENDIF
C
C ------------------------------------------------------------------
C     Section 4.   Interpolate wave 2D spectra field.
C ------------------------------------------------------------------
C
      ELSE
C
  400   CONTINUE

      IF( LDEBUG ) THEN
      CALL INTLOG(JP_DEBUG,
     X 'INTWAVE2: Interpolate wave 2D spectra field',JPQUIET)
      ENDIF
C
C       Find number of 2D spectra values at each point
C
        IF( ISEC4(8).NE.0 ) LCOEFFS = .TRUE.
        IF( (ISEC4(8).NE.0).AND.(ISEC1(6).NE.JP2DSPQ) ) THEN
          NSPEC = ISEC4(50) * ISEC4(51)
          NIMATR = 1
        ELSE
          NSPEC = 1
          NIMATR = 0
        ENDIF
C
C       Get some scratch space for the interpolated field.
C
        ISIZE = NSPEC * NFULLEW * NUM_N_S
        CALL JMEMHAN( 3, INEWAVE, ISIZE, 1, IRET)
        IF ( IRET.NE.0 ) THEN
          CALL INTLOG(JP_ERROR,'INTWAVE2: Get work space fail.',JPQUIET)
          INTWAVE2 = JPROUTINE + 11
          GOTO 900
        ENDIF
C
        ISIZE = NFULLEW * NFULLNS
        CALL JMEMHAN( 4, INEWIDX, ISIZE, 1, IRET)
        IF ( IRET.NE.0 ) THEN
          CALL INTLOG(JP_ERROR,'INTWAVE2: Get work space fail.',JPQUIET)
          INTWAVE2 = JPROUTINE + 12
          GOTO 900
        ENDIF
C
C       Interpolate the field
C
        IRET = WV2DXX2(NIMATR,KNUM,NUMPTS,NUM_N_S,GRIDNS,GRIDWE,ZNFELDI,
     X               NEWAVE,NORTH,WEST,ZMISS)
        IF( IRET.NE.0 ) THEN
         CALL INTLOG(JP_ERROR,'INTWAVE2: Interpolation failed.',JPQUIET)
          INTWAVE2 = JPROUTINE + 13
          GOTO 900
        ENDIF
C
      ENDIF
C
C ------------------------------------------------------------------
C     Section 5.   Pack the interpolated field into GRIB.
C ------------------------------------------------------------------
C
  500   CONTINUE

C     If a 'bitmap' has been specified, build the bitmap
C
      LBITMP = LNOBITMP.AND.
     X         ((NOREPR.EQ.JPREGROT).OR.(NOREPR.EQ.JPREGULAR).OR.
     X          (NOREPR.EQ.JPGAUSSIAN))

      IF( LBITMP ) THEN
        CALL INTLOG(JP_DEBUG,'INTWAVE2: MKBITMP is enabled',JPQUIET)
        IERR = MKBITMP(NUM_E_W,NUM_N_S,NEWAVE,ZMISS)
        IF( IERR.NE.0 ) THEN
          CALL INTLOG(JP_ERROR,'INTFB: Problem applying bitmap',JPQUIET)
          GOTO 900
        ENDIF
      ENDIF
C     If a 'frame' has been specified, build the frame
C
       LFRAME = LNOFRAME.AND.
     X         ((NOREPR.EQ.JPREGULAR).OR.(NOREPR.EQ.JPGAUSSIAN).OR.
     X          (NOREPR.EQ.JPREGROT ).OR.(NOREPR.EQ.JPFGGROT  ) )

         CALL INTLOG(JP_DEBUG,'INTWAVE2: NUM_E_W ',NUM_E_W)
         CALL INTLOG(JP_DEBUG,'INTWAVE2: NUM_N_S ',NUM_N_S)
      IF( LFRAME ) THEN
           CALL INTLOG(JP_DEBUG,'INTWAVE2: MKFRAME is enabled',JPQUIET)
           CALL INTLOG(JP_DEBUG,'INTWAVE2: NOFRAME ',NOFRAME)
         CALL MKFRAME(NUM_E_W,NUM_N_S,NEWAVE,ZMISS,NOFRAME)
      ENDIF
C
C     GRIB sections 2 and 3 (bitmap) included
C
      ISEC1(5) = 192
C
      IF( (NOREPR.EQ.JPQUASI) .OR. (NOREPR.EQ.JPREDLL) ) THEN
C
C       Reduced gaussian or reduced lat/long with (possible) subarea
C
        IF( NOREPR.EQ.JPQUASI ) THEN
          ISEC2(1) = JPGAUSSIAN
          ISEC2(10)= NOGAUSS
        ELSE
          ISEC2(1) = JPREGULAR
          ISEC2(10)= NINT(GRIDNS*1000.0)
        ENDIF
        ISEC2(2) = 255
        ISEC2(3) = NUM_N_S
        ISEC2(5) = NINT(WEST*1000.0)
        ISEC2(6) = 0
        ISEC2(8) = NINT(EAST*1000.0)
        ISEC2(17)= 1
        ISEC4(1) = 0
C
        LAT1 = 0
 510    CONTINUE
        LAT1 = LAT1 + 1
        IF( NOREPR.EQ.JPQUASI ) THEN
          RNLAT = ROGAUSS(LAT1)
          RSLAT = ROGAUSS(LAT1+NUM_N_S-1)
        ELSE
          RNLAT = 90.0 - (LAT1-1)*GRIDNS
          RSLAT = 90.0 - (LAT1+NUM_N_S-2)*GRIDNS
        ENDIF
        IF( RNLAT.GT.NORTH ) GOTO 510
C
        ISEC2(4) = NINT(RNLAT*1000.0)
        ISEC2(7) = NINT(RSLAT*1000.0)
C
        DO LOOP = LAT1, (NUM_N_S+LAT1-1)
          ISEC2(23+LOOP-LAT1) = NOLPTS(LOOP)
          ISEC4(1) = ISEC4(1) + ISEC2(23+LOOP-LAT1)
        ENDDO
C
      ELSE
C
C       Regular gaussian or lat/long with (possible) subarea
C
        IF( NOREPR.EQ.JPGAUSSIAN ) THEN
          ISEC2(1) = JPGAUSSIAN
        ELSE
          ISEC2(1) = JPREGULAR
        ENDIF
        ISEC2(2) = NUM_E_W
        ISEC2(3) = NUM_N_S
        ISEC2(4) = NINT(NORTH*1000.0)
        ISEC2(5) = NINT(WEST*1000.0)
        ISEC2(6) = 128
        ISEC2(7) = NINT(SOUTH*1000.0)
        ISEC2(8) = NINT(EAST*1000.0)
        ISEC2(9) = NINT(GRIDWE*1000.0)
        IF( NOREPR.EQ.JPGAUSSIAN ) THEN
          ISEC2(10) = NOGAUSS
        ELSE
          ISEC2(10) = NINT(GRIDNS*1000.0)
        ENDIF
        ISEC2(17)= 0
        ISEC4(1) = NUM_E_W * NUM_N_S
      ENDIF
C
C
      ISEC3(2) = NINT(ZMISS)
      ZSEC3(2) = ZMISS
C
      ISEC4(1) = ISEC4(1) * NSPEC
      ISEC4(2) = NOACC
      IF( LCOEFFS ) ISEC4(6)  = 16
C            `-----> wave fields have additional flags for
C                    NC1 and NC2 coefficients (floats stored
C                    in integer array isec4)
      IRET = 1
C
C     If grid-point output, setup for 2nd order packing if requested.
C
      IF( (NOREPR.NE.JPSPHERE) .AND. (NOREPR.NE.JPSPHROT) ) THEN
        HFUNC = 'C'
        IF( NOHFUNC.EQ.'K' ) THEN
          HFUNC = 'K'
          ISEC4(4)  = 64
          ISEC4(6)  = 16
          ISEC4(9)  = 32
          ISEC4(10) = 16
          ISEC4(12) = 8
          ISEC4(13) = 4
          ISEC4(14) = 0
          ISEC4(15) = -1
        ELSE
          ISEC4(4)  = 0
        ENDIF
      ELSE
        HFUNC = 'C'
        IF( NOHFUNC.EQ.'C' ) THEN
          ISEC2(6) = 2
          ISEC4(4) = 64
        ELSE IF( NOHFUNC.EQ.'S' ) THEN
          ISEC2(6) = 1
          ISEC4(4) = 0
        ENDIF

      ENDIF

C
      CALL GRIBEX (ISEC0,ISEC1,ISEC2,ZSEC2,ISEC3,ZSEC3,ISEC4,
     X             NEWAVE,ISEC4(1),OUTGRIB,OUTLEN,IWORD,HFUNC,IRET)
C
      IF ( IRET.NE.0 ) THEN
        CALL INTLOG(JP_ERROR,'INTWAVE2: GRIBEX encoding failed.',IRET)
        INTWAVE2 = JPROUTINE + 14
        GOTO 900
      ENDIF
      OUTLEN = IWORD
C
C ------------------------------------------------------------------
C*    Section 9.   Closedown.
C ------------------------------------------------------------------
C
  900 CONTINUE
C
C     Clear change flags for next product processing
C
      LCHANGE = .FALSE.
      LSMCHNG = .FALSE.
C
      RETURN
      END

C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      INTEGER FUNCTION INIT_CM( KPARAM, KVAL )
C---->
C**** INIT_CM
C
C     Purpose
C     -------
C
C     Initialise common block values used by interpolation.
C
C
C     Interface
C     ---------
C
C     IRET = INIT_CM( KPARAM, KVAL )
C
C     Input
C     -----
C
C     KPARAM - Flag indicating common block element to update.
C     KVAL   - Value for element.
C
C
C     Output
C     ------
C
C     Common block entry updated.
C
C
C     Method
C     ------
C
C     1      NIFORM
C     2      NOFORM
C     3      NITABLE
C     4      NIPARAM
C     5      NIRESO
C     6      NORESO
C     7      NOACC
C     8      NIGRID(1)
C     9      NIGRID(2)
C     10     NOGRID(1)
C     11     NOGRID(2)
C     12     NIGAUSS, RIGAUSS, MILLEN, NINS, NIGAUSO, HIGAUST
C     13     NOGAUSS, ROGAUSS, NOLPTS, NONS, NOGAUSO, HOGAUST
C     14     NIAREA(1)
C     15     NIAREA(2)
C     16     NIAREA(3)
C     17     NIAREA(4)
C     18     NOAREA(1)
C     19     NOAREA(2)
C     20     NOAREA(3)
C     21     NOAREA(4)
C     22     NISCNM
C     23     NOSCNM
C     24     LSM
C     25     LWIND
C     26     LPREC
C     27     RIGAUSS, MILLEN, NINS, NIGAUSO, HIGAUST
C     28     ROGAUSS, NOLPTS, NONS, NOGAUSO, HOGAUST
C     29     LSMPAR
C
C     99     Display current values in common block.
C
C
C     Externals
C     ---------
C
C     None.
C
C
C     Author
C     ------
C
C     J.D.Chambers     ECMWF
C
C----<
C
      IMPLICIT NONE
C
C     Function arguments
C
      INTEGER KPARAM, KVAL
C
C     Local variables
C
      INTEGER IRET, LOOP
C
#include "parim.h"
#include "nifld.common"
#include "nofld.common"
#include "grfixed.h"
#include "current.h"
C
      INIT_CM = 0
C
      IF ( KPARAM .EQ.1 ) NIFORM = KVAL
C
      IF ( KPARAM .EQ.2 ) NOFORM = KVAL
C
      IF ( KPARAM .EQ.3 ) NITABLE = KVAL
C
      IF ( KPARAM .EQ.4 ) NIPARAM = KVAL
C
      IF ( KPARAM .EQ.5 ) NIRESO = KVAL
C
      IF ( KPARAM .EQ.6 ) NORESO = KVAL
C
      IF ( KPARAM .EQ.7 ) NOACC = KVAL
C
      IF ( KPARAM .EQ.8 ) NIGRID(1) = KVAL
C
      IF ( KPARAM .EQ.9 ) NIGRID(2) = KVAL
C
      IF ( KPARAM .EQ.10) NOGRID(1) = KVAL
C
      IF ( KPARAM .EQ.11) NOGRID(2) = KVAL
C
      IF ( KPARAM .EQ.12) THEN
        NIGAUSS = KVAL
        IF( (NIGAUSO.NE.NIGAUSS).OR.(HIGAUST.NE.'F') ) THEN
          CALL JGETGG( NIGAUSS, 'F', RIGAUSS, MILLEN, IRET)
          IF ( IRET .NE. 0 ) THEN
            WRITE(*,*) 'INIT_CM: JGETGG failed for NIGAUSS'
            INIT_CM = IRET
            GOTO 900
          ENDIF
          NINS = 2*NIGAUSS
          NIGAUSO = NIGAUSS
          HIGAUST = 'F'
        ENDIF
      ENDIF
C
      IF ( KPARAM .EQ.13) THEN
        NOGAUSS = KVAL
        IF( (NOGAUSO.NE.NOGAUSS).OR.(HOGAUST.NE.'F') ) THEN
          CALL JGETGG( NOGAUSS, 'F', ROGAUSS, NOLPTS, IRET)
          IF ( IRET .NE. 0 ) THEN
            WRITE(*,*) 'INIT_CM: JGETGG failed for NOGAUSS'
            INIT_CM = IRET
            GOTO 900
          ENDIF
          NONS = 2*NOGAUSS
          NOGAUSO = NOGAUSS
          HOGAUST = 'F'
        ENDIF
      ENDIF
C
      IF ( KPARAM .EQ.14) NIAREA(1) = KVAL
C
      IF ( KPARAM .EQ.15) NIAREA(2) = KVAL
C
      IF ( KPARAM .EQ.16) NIAREA(3) = KVAL
C
      IF ( KPARAM .EQ.17) NIAREA(4) = KVAL
C
      IF ( KPARAM .EQ.18) NOAREA(1) = KVAL
C
      IF ( KPARAM .EQ.19) NOAREA(2) = KVAL
C
      IF ( KPARAM .EQ.20) NOAREA(3) = KVAL
C
      IF ( KPARAM .EQ.21) NOAREA(4) = KVAL
C
      IF ( KPARAM .EQ.22) NISCNM    = KVAL
C
      IF ( KPARAM .EQ.23) NOSCNM    = KVAL
C
      IF ( KPARAM .EQ.24) THEN
        IF ( KVAL .EQ. 1) THEN
          LSM       = .TRUE.
        ELSE
          LSM       = .FALSE.
        ENDIF
      ENDIF
C
      IF ( KPARAM .EQ.25) THEN
        IF ( KVAL .EQ. 1) THEN
          LWIND     = .TRUE.
        ELSE
          LWIND     = .FALSE.
        ENDIF
      ENDIF
C
      IF ( KPARAM .EQ.26) THEN
        IF ( KVAL .EQ. 1) THEN
          LPREC     = .TRUE.
        ELSE
          LPREC     = .FALSE.
        ENDIF
      ENDIF
C
      IF ( KPARAM .EQ.27) THEN
        IF ( KVAL .EQ. 1) THEN
          IF( (NIGAUSO.NE.NIGAUSS).OR.(HIGAUST.NE.'R') ) THEN
            CALL JGETGG( NIGAUSS, 'R', RIGAUSS, MILLEN, IRET)
            IF ( IRET .NE. 0 ) THEN
              WRITE(*,*) 'INIT_CM: JGETGG failed for NIGAUSS'
              INIT_CM = IRET
              GOTO 900
            ENDIF
            NINS = 2*NIGAUSS
            NIGAUSO = NIGAUSS
            HIGAUST = 'R'
          ENDIF
        ELSE
          WRITE(*,*) 'No user input supported for reduced gaussian grid'
          INIT_CM = 999
          GOTO 900
        ENDIF
      ENDIF
C
      IF ( KPARAM .EQ.28) THEN
        IF ( KVAL .EQ. 1) THEN
          IF( (NOGAUSO.NE.NOGAUSS).OR.(HOGAUST.NE.'R') ) THEN
            CALL JGETGG( NOGAUSS, 'R', ROGAUSS, NOLPTS, IRET)
            IF ( IRET .NE. 0 ) THEN
              WRITE(*,*) 'INIT_CM: JGETGG failed for NIGAUSS'
              INIT_CM = IRET
              GOTO 900
            ENDIF
            NONS = 2*NOGAUSS
            NOGAUSO = NOGAUSS
            HOGAUST = 'R'
          ENDIF
        ELSE
          WRITE(*,*) 'No user input supported for reduced gaussian grid'
          INIT_CM = 999
          GOTO 900
        ENDIF
      ENDIF
C
      IF ( KPARAM .EQ.29) THEN
        IF ( KVAL .EQ. 1) THEN
          LSMPAR    = .TRUE.
        ELSE
          LSMPAR    = .FALSE.
        ENDIF
      ENDIF
C
      IF ( KPARAM .EQ.99) THEN
        WRITE(*,*) ' LCHANGE   = ', LCHANGE
        WRITE(*,*) ' LSMCHNG   = ', LSMCHNG
        WRITE(*,*) ' LSMSET    = ', LSMSET
        WRITE(*,*) ' LSMPARSET = ', LSMPARSET
        WRITE(*,*) ' LPRECSET  = ', LPRECSET
        WRITE(*,*) ' LWINDSET  = ', LWINDSET
        WRITE(*,*) ' NINS      = ', NINS
        WRITE(*,*) ' NIWE      = ', NIWE
        WRITE(*,*) ' NO1NS     = ', NO1NS
        WRITE(*,*) ' NO1WE     = ', NO1WE
        WRITE(*,*) ' NONS      = ', NONS
        WRITE(*,*) ' NOWE      = ', NOWE
C
        WRITE(*,*) ' NIFORM    = ', NIFORM
        WRITE(*,*) ' NOFORM    = ', NOFORM
        WRITE(*,*) ' NITABLE   = ', NITABLE
        WRITE(*,*) ' NIPARAM   = ', NIPARAM
        WRITE(*,*) ' NIRESO    = ', NIRESO
        WRITE(*,*) ' NORESO    = ', NORESO
        WRITE(*,*) ' LNORESO   = ', LNORESO
        WRITE(*,*) ' NOACC     = ', NOACC 
        WRITE(*,*) ' LNOACC    = ', LNOACC 
        WRITE(*,*) ' NIGRID(1) = ', NIGRID(1)
        WRITE(*,*) ' NIGRID(2) = ', NIGRID(2)
        WRITE(*,*) ' NOGRID(1) = ', NOGRID(1)
        WRITE(*,*) ' NOGRID(2) = ', NOGRID(2)
        WRITE(*,*) ' NIGAUSS   = ', NIGAUSS
        WRITE(*,*) ' NOGAUSS   = ', NOGAUSS
        WRITE(*,*) ' LNOGAUS   = ', LNOGAUS
        WRITE(*,*) ' NIAREA(1) = ', NIAREA(1)
        WRITE(*,*) ' NIAREA(2) = ', NIAREA(2)
        WRITE(*,*) ' NIAREA(3) = ', NIAREA(3)
        WRITE(*,*) ' NIAREA(4) = ', NIAREA(4)
        WRITE(*,*) ' NOAREA(1) = ', NOAREA(1)
        WRITE(*,*) ' NOAREA(2) = ', NOAREA(2)
        WRITE(*,*) ' NOAREA(3) = ', NOAREA(3)
        WRITE(*,*) ' NOAREA(4) = ', NOAREA(4)
        WRITE(*,*) ' NISCNM    = ', NISCNM   
        WRITE(*,*) ' NOSCNM    = ', NOSCNM   
        WRITE(*,*) ' LSM       = ', LSM      
        WRITE(*,*) ' LWIND     = ', LWIND    
        WRITE(*,*) ' LPREC     = ', LPREC    
        WRITE(*,*) ' LSMPAR    = ', LSMPAR   
      ENDIF
C
      IF ( KPARAM .GT.99) THEN
        DO 110 LOOP = 1, NINS
          WRITE(*,*) ' RIGAUSS(',LOOP,'), MILLEN(',LOOP,')=',
     X                 RIGAUSS(LOOP), MILLEN(LOOP)
  110   CONTINUE
        DO 120 LOOP = 1, NONS
          WRITE(*,*) ' ROGAUSS(',LOOP,'), NOLPTS(',LOOP,')=',
     X                 ROGAUSS(LOOP), NOLPTS(LOOP)
  120   CONTINUE
      ENDIF
C
 900  CONTINUE
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE DECFP2 (PVAL,KEXP,KMANT)
C
C---->
C**** DECFP2 - GRIB representation to floating point representation.
C
C     Purpose.
C     --------
C
C     Convert GRIB representation of a floating point
C     number to machine representation.
C
C**   Interface.
C     ----------
C
C     CALL DECFP2 (PVAL,KEXP,KMANT)
C
C
C     Input Parameters.
C     -----------------
C
C     KEXP    - 8 Bit signed exponent.
C
C     KMANT   - 24 Bit mantissa.
C
C     Output Parameters.
C     -----------------
C
C     PVAL    - Floating point number represented
C                         by KEXP and KMANT.
C
C
C     Method.
C     -------
C
C     Floating point number represented as 8 bit exponent
C     and 24 bit mantissa in integer values converted to
C     machine floating point format.
C
C
C     Externals.
C     ----------
C
C     None.
C
C
C     Reference.
C     ----------
C
C     WMO Manual on Codes re GRIB representation.
C
C
C     Comments.
C     ---------
C
C     Rewritten from DECFP, to conform to programming standards.
C     Sign bit on 0 value now ignored, if present.
C     If using 32 bit reals, check power of 16 is not so small as to
C     cause overflows (underflows!); this causes warning to be given
C     on Fujitsus.
C
C
C     Author.
C     -------
C
C     John Hennessy   ECMWF   18.06.91
C
C
C     Modifications.
C     --------------
C
C     J.D.Chambers    ECMWF   1 Aug 1996
C     Add check power that power of 16 is not so small as to cause
C     overflows.
C
C
C----<
C     -----------------------------------------------------------------
C*    Section 0 . Definition of variables.
C     -----------------------------------------------------------------
C
      IMPLICIT NONE
C
#include "common/grprs.h"
C
#include "grbcom.h"
C
C     Subroutine arguments
C
      REAL    PVAL
      INTEGER KEXP, KMANT
C
C     Local variables.
C
      INTEGER IEXP, ISIGN
      LOGICAL LDEBUG
C
C     -----------------------------------------------------------------
C*    Section 1 . Convert value of 0.0. Ignore sign bit.
C     -----------------------------------------------------------------
C
  100 CONTINUE
C
      LDEBUG = (NDBG.GT.1)
C
      IF( LDEBUG )
     X  WRITE(GRPRSM,*) 'DECFP2: KEXP = ',KEXP,'. KMANT = ',KMANT
C
Cjdc  IF ( (KEXP.EQ.128.OR.KEXP.EQ.0).AND.KMANT.EQ.0) THEN
      IF( ((KEXP.EQ.128).OR.
     X     (KEXP.EQ.0)  .OR.
     X     (KEXP.EQ.255)    )) THEN
        PVAL = 0.0
        GOTO 900
      ENDIF
C
C     -----------------------------------------------------------------
C*    Section 2 . Convert other values.
C     -----------------------------------------------------------------
C
  200 CONTINUE
C
C     Sign of value.
C
      IEXP  = KEXP
      ISIGN = 1
C
C     Set sign of exponent
C
      IF (IEXP.GE.128) THEN
        IEXP  = IEXP - 128
        ISIGN = -1
      END IF
C
C     Decode value.
C
#if (defined REAL_8) || (defined CRAY)
      PVAL = ISIGN*2.**(-24)*KMANT*16.**(IEXP-64)
C                  ---------
C                      `---> this matchs/compensates for (IEXP-70)
C                            in confp3.F (instead of (IEXP-64))
#else
C     If using 32 bit reals, check power of 16 is not so small as to
C     cause overflows (underflows!); this causes warning to be given
C     on Fujitsus.
C
      IF(IEXP.GT.32) THEN
        PVAL = ISIGN*2.**(-24)*KMANT*16.**(IEXP-64)
      ELSE
        PVAL = 0.0
      ENDIF
#endif
      IF( LDEBUG ) THEN
        WRITE(GRPRSM,*) 'DECFP2: Values used for final calculation'
        WRITE(GRPRSM,*)
     X    'DECFP2: IEXP=',IEXP,'.ISIGN=',ISIGN,'.KMANT=',KMANT
      ENDIF
C
C     -----------------------------------------------------------------
C*    Section 9. Return to calling routine.
C     -----------------------------------------------------------------
C
  900 CONTINUE
C
      IF( LDEBUG ) WRITE(GRPRSM,*) 'DECFP2: Returned value = ', PVAL
C
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities
C granted to it by virtue of its status as an intergovernmental organisation
C nor does it submit to any jurisdiction.
C


      SUBROUTINE QU2REG (PFIELD,KPOINT,KLAT,KLON,KCODE)
C
C---->
C**** QU2REG - Convert quasi-regular grid data to regular.
C
C     Purpose.
C     --------
C
C           Convert quasi-regular grid data to regular,
C           using either a linear or cubic interpolation.
C
C**   Interface.
C     ----------
C
C           CALL QU2REG (PFIELD,KPOINT,KLAT,KLON,KCODE)
C
C           Integer    K.
C           Real       P.
C           Logical    O.
C           Character  H.
C
C               Input Parameters.
C               -----------------
C
C               PFIELD     - Array containing quasi-regular grid
C                            data.
C
C               KPOINT     - Array containing list of the number of
C                            points on each latitude (or longitude) of
C                            the quasi-regular grid.
C
C               KLAT       - Number of latitude lines
C
C               KLON       - Number of longitude lines
C
C               KCODE      - Interpolation required.
C                            1 , linear - data quasi-regular on
C                                         latitude lines.
C                            3 , cubic - data quasi-regular on
C                                         latitude lines.
C                            11, linear - data quasi-regular on
C                                         longitude lines.
C                            13, cubic - data quasi-regular on
C                                         longitude lines.
C
C               Output Parameters.
C               ------------------
C
C               PFIELD     - Array containing regular grid data.
C
C     Method.
C     -------
C
C           Data is interpolated and expanded into a temporary array,
C           which is then copied back into the user's array.
C           Routine aborts if an invalid interpolation is requested or
C           field size exceeds array dimensions.
C
C     Externals.
C     ----------
C
C           ROWINA
C           ABORTX
C
C     Reference.
C     ----------
C
C           WMO Manual on Codes for GRIB code specifications of
C           quasi-regular grids.
C
C     Comments.
C     ---------
C
C           This routine is an adaptation of INTPGRR and runs
C           on the Cray only.
C
C     Author.
C     -------
C
C           J. Hennessy      ECMWF      18.06.91
C
C     Modifications.
C     --------------
C
C           J. Hennessy      ECMWF      08.10.91
C           Call to ROWINT changed to call to ROWINA.
C           ROWINA called if only number of values required is not
C           the same as the input number.
C
C           J. Hennessy      ECMWF      07.01.92
C           Call to ABORT changed to ABORTX.
C
C     -----------------------------------------------------------------
C----<
C
C
C
C
C
C
C
C
C
C
C*    Section 0. Definition of variables. Data statements.
C     -----------------------------------------------------------------
C
C*    Prefix conventions for variable names.
C
C     Logical      L (but not LP), global or common.
C                  O, dummy arguments.
C                  G, local variable.
C                  LP, parameter.
C     Character    C, Global or common.
C                  H, dummy arguments.
C                  Y (but not YP), local variables.
C                  YP, parameter.
C     Integer      M and N, global or common.
C                  K, dummy arguments.
C                  I, local variables.
C                  J (but not JP), loop control.
C                  JP, parameter.
C     Real         A to F and Q to X, global or common.
C                  P (but not PP), dummy arguments.
C                  Z, local variables.
C                  PP, parameter.
C
#ifdef CRAY

      IMPLICIT NONE
#endif

C
      INTEGER ICODE
      INTEGER ILII
      INTEGER ILIO
      INTEGER IQUANO
      INTEGER IREGNO
C
      INTEGER JPMAX
C
      INTEGER J210
      INTEGER J220
      INTEGER J225
      INTEGER J230
      INTEGER J240
C
      INTEGER KCODE
      INTEGER KLAT
      INTEGER KLON
      INTEGER KPOINT
C
      REAL    PFIELD
C
      REAL    ZLINE
      REAL    ZTEMP
      REAL    ZWORK
C
C     Maximum number of latitudes (or longitudes), for which arrays
C     are dimensioned.
C
      PARAMETER (JPMAX=320)
C
      DIMENSION PFIELD(*)
      DIMENSION ZTEMP(JPMAX*JPMAX*2)
      DIMENSION ZLINE(JPMAX*2)
      DIMENSION ZWORK(0:JPMAX*2+2,3)
C
      DIMENSION KPOINT(*)
C
C     ------------------------------------------------------------------
C
C
C
C
C
C
C
C
C
C
C*    Section 1. Set initial values.
C     ------------------------------------------------------------------
C
  100 CONTINUE
C
C     Check input parameters.
C
      IF (KCODE.NE.1.AND.KCODE.NE.3.AND.
     C    KCODE.NE.11.AND.KCODE.NE.13)
     C   THEN
             WRITE (*,9001) KCODE
             CALL ABORTX ('QU2REG')
         ENDIF
C
      IF (KLAT.GT.JPMAX)
     C   THEN
             WRITE (*,9002) KLAT , JPMAX
             CALL ABORTX ('QU2REG')
         ENDIF
C
      IF (KLON.GT.JPMAX*2)
     C   THEN
             WRITE (*,9003) KLAT , JPMAX*2
             CALL ABORTX ('QU2REG')
         ENDIF
C
C     Set array indices to 0.
C
      ILII  = 0
      ILIO  = 0
C
C     Establish values of loop parameters.
C
      IF (KCODE.GT.10)
     C   THEN
C
C            Quasi-regular along longitude lines.
C
             IQUANO = KLON
             IREGNO = KLAT
             ICODE  = KCODE - 10
         ELSE
C
C            Quasi-regular along latitude lines.
C
             IQUANO = KLAT
             IREGNO = KLON
             ICODE  = KCODE
         ENDIF
C
C     ------------------------------------------------------------------
C
C
C
C
C
C
C
C
C
C
C*    Section 2. Interpolate field from quasi to regular grid.
C     ------------------------------------------------------------------
C
  200 CONTINUE
C
      DO 230 J230=1,IQUANO
C
         IF (IREGNO.NE.KPOINT(J230))
     C      THEN
C
C               Line contains less values than required,so
C               extract quasi-regular grid values for a line
C
                DO 210 J210=1,KPOINT(J230)
                   ILII        = ILII+1
                   ZLINE(J210) = PFIELD(ILII)
  210           CONTINUE
C
C               and interpolate this line.
C
                CALL ROWINA (ZLINE,IREGNO,KPOINT(J230),ZWORK,ICODE)
C
C               Add regular grid values for this line to the temporary
C               array.
C
                DO 220 J220=1,IREGNO
                   ILIO        = ILIO+1
                   ZTEMP(ILIO) = ZLINE(J220)
  220           CONTINUE
C
            ELSE
C
C               Line contains the required number of values, so add
C               this line to the temporary array.
C
                DO 225 J225=1,IREGNO
                   ILIO        = ILIO+1
                   ILII        = ILII+1
                   ZTEMP(ILIO) = PFIELD(ILII)
  225           CONTINUE
C
            ENDIF
C
  230 CONTINUE
C
C     Copy temporary array to user array.
C
      DO 240 J240=1,KLON*KLAT
         PFIELD(J240) = ZTEMP(J240)
  240 CONTINUE
C
C     ------------------------------------------------------------------
C
C
C
C
C
C
C
C
C
C
C*    Section 9. Return to calling routine. Format statements.
C     ------------------------------------------------------------------
C
  900 CONTINUE
C
 9001 FORMAT (1H ,'QU2REG : Invalid interpolation type code = ',I3)
C
 9002 FORMAT (1H ,'QU2REG : Number of latitudes is ',I4,', maximum ',
     C                      'allowed is ',I3,'.')
C
 9003 FORMAT (1H ,'QU2REG : Number of longitudes is ',I4,', maximum ',
     C                      'allowed is ',I3,'.')
C
      RETURN
C
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities
C granted to it by virtue of its status as an intergovernmental organisation
C nor does it submit to any jurisdiction.
C

      SUBROUTINE GGVALUE(NEWFLD, NEXT, INROW, RLAT, RLON,
     X                   POLELAT, POLELON, NGAUSS, HTYPE, FIELD)
C
C---->
C**** GGVALUE
C
C     PURPOSE
C     _______
C
C     Rotates one line of latitude in a gaussian grid.
C
C     INTERFACE
C     _________
C
C     CALL GGVALUE(NEWFLD, NEXT, INROW, RLAT, RLON,
C    X             POLELAT, POLELON, NGAUSS, HTYPE, FIELD)
C
C
C     Input parameters
C     ________________
C
C     NEWFLD   - The field of values being created
C     NEXT     - Start offset of the latitude row being created
C     INROW    - The number of points in the latitude row
C     RLAT     - Target point latitude in the rotated grid
C     RLON     - Target point longitude in the rotated grid
C     POLELAT  - Latitude of the rotated South Pole
C     POLELON  - Longitude of the rotated South Pole
C     FIELD    - Original unrotated gaussian field values
C     NGAUSS   - Gaussian grid number (original, unrotated)
C     HTYPE    - Gaussian grid type (original, unrotated)
C                = 'R' for reduced ("quasi-regular"),
C                = 'O' for reduced/octahedral,
C                = 'F' for full,
C                = 'U' for user-defined reduced gaussian grid
C
C     Output parameters
C     ________________
C
C     NEWFLD(NEXT) to NEWFLD(NEXT+INROW-1) contains the latitude row
C     values.
C
C
C     METHOD
C     ______
C
C     Rotates the lat/long positions of points along a latitude row in
C     a rotated gaussian grid back to positions in the unrotated grid
C     and then interpolates values from the original grid.
C
C
C     EXTERNALS
C     _________
C
C     LL2XYZ  - Converts a latitude/longitude position to (x,y,z)
C               wrt axes through the centre of the globe. The z-axis
C               runs from the south to north pole. The x- and y-axes
C               are in the plane of the equator with the x-axis
C               pointing out through lat/long (0,0).
C     YROTATE - Rotates the globe about the new y-axis.
C     XYZ2LL  - Converts an (x,y,z) position to a latitude/longitude.
C     GGINTRP - Interpolates a value from an existing grid.
C
C
C     REFERENCE
C     _________
C
C     None
C
C
C     COMMENTS
C     ________
C
C     The input field is assumed to be global in extent, and a known
C     definition, either N160 or N80 (reduced or regular).
C
C
C     AUTHOR
C     ______
C
C     J.D.Chambers      ECMWF       April 1996
C
C
C     MODIFICATIONS
C     _____________
C
C     None.
C
C----<
C     _______________________________________________________
C
C*    Section 0. Definition of variables.
C     _______________________________________________________
C
      IMPLICIT NONE
C
C     Parameters
C
      INTEGER JPMAXGG
      PARAMETER( JPMAXGG = 1280 )
C
C     Function arguments
C
      REAL NEWFLD, RLAT, RLON, POLELAT, POLELON, FIELD
      DIMENSION NEWFLD(*), RLON(*), FIELD(*)
      INTEGER NEXT, INROW, NGAUSS
      CHARACTER*1 HTYPE
C
C     Local variables
C
      REAL X(JPMAXGG), Y(JPMAXGG), Z(JPMAXGG)
      REAL RX(JPMAXGG),RY(JPMAXGG),RZ(JPMAXGG)
      REAL OLAT(JPMAXGG),OLON(JPMAXGG)
      INTEGER LOOP
C
C     Convert the rotated row points lat/longs to (x,y,z) coordinates
C
      CALL LL2XYZ(RLAT,RLON,X,Y,Z,INROW)
C
C     Rotate the rotated row points back through the original latitude
C     rotation
C
      CALL YROTATE(-(90.0+POLELAT),X,Y,Z,RX,RY,RZ,INROW)
C
C     Convert the rotated row points adjusted (x,y,z) coordinates to
C     lat/long in the original grid (after longitude rotation)
C
      CALL XYZ2LL(RX,RY,RZ,OLAT,OLON,INROW)
C
C     Adjust the rotated line longitudes to remove the longitude
C     rotation
C
      DO LOOP = 1, INROW
        OLON(LOOP) = OLON(LOOP) + POLELON
        IF( OLON(LOOP).LT.  0. ) OLON(LOOP) = OLON(LOOP) + 360.0
        IF( OLON(LOOP).GE.360. ) OLON(LOOP) = OLON(LOOP) - 360.0
      ENDDO
C
C     Interpolate the original unrotated grid to the points in the
C     rotated line
C
      CALL GGINTRP(NEWFLD,NEXT,INROW,OLAT,OLON,NGAUSS,HTYPE,FIELD)
C
      RETURN
      END

C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      INTEGER FUNCTION IARCNTL(PIFELD, KILEN, POFELD, KOLEN, KILN,
     1   OIWEGLOBE, OINPOLE, OISPOLE, KOLN, OOWEGLOBE, OONPOLE,
     2   OOSPOLE, KPR, KERR)
C
C---->
C**** *IARCNTL*
C
C     Purpose
C     -------
C
C     The global controlling routine for interpolating between a quasi
C     regular Gaussian input field and a regular Gaussian or
C     latitude/longitude output field.
C
C
C     Interface
C     ---------
C
C     IERR = IARCNTL(PIFELD, KILEN, POFELD, KOLEN, KILN, OIWEGLOBE,
C    1   OINPOLE, OISPOLE, KOLN, OOWEGLOBE, OONPOLE, OOSPOLE, KPR,
C    2   KERR)
C
C
C     Input parameters
C     ----------------
C
C     PIFELD    - The input field provided by the calling routine.
C
C     KILEN     - The length of the input field.
C
C     KOLEN     - The length of the output field.
C
C     KILN      - The Northern line number of the input field within
C                  its Gaussian field.
C
C     OIWEGLOBE - A flag indicating whether the input field is
C                 global West to East.
C
C     OINPOLE   - A flag indicating whether the North pole is
C                 included in the input field.
C
C     OISPOLE   - A flag indicating whether the South pole is
C                 include in the input field.
C
C     KOLN      - The Northern line number of the output field
C                 within its Gaussian field.
C
C     OOWEGLOBE - A flag indicating whether the output field is
C                 global West to East.
C
C     OONPOLE   - A flag indicating whether the North pole is
C                 include in the output field.
C
C     OOSPOLE   - A flag indicating whether the South pole is
C                 include in the output field.
C
C     KPR       - The debug print switch.
C                  0  , No debugging output.
C                  1  , Produce debugging output.
C
C     KERR      - The error control flag.
C                  -ve, No error message. Return error code.
C                  0  , Hard failure with error message.
C                  +ve, Print error message. Return error code.
C
C
C     Output parameters
C     -----------------
C
C     POFELD - The output field returned to the calling routine.
C
C
C     Return value
C     ------------
C
C     The error indicator (INTEGER).
C
C
C     Error and Warning Return Values
C     -------------------------------
C
C     21901 The input data representation was not valid when the
C           grid was generated. This should not happen as the data
C           representation has been previously validated.
C     21902 The output data representation was not valid when the
C           grid was generated. This should not happen as the data
C           representation has been previously validated.
C     21903 Attempt to produce global West-East field where the input
C           field was not global.
C     21904 Attempt to produce global North-South field where the
C           input field was not global.
C
C
C     Common block usage
C     ------------------
C
C     grspace.h    - The include file contains all the array space
C                    for grid to grid interpolation.
C
C     MILLEN       - The array of quasi regular Gaussian field
C                    latitude line length definition.
C     RIGAUSS      - Real array of input field Gaussian latitudes is
C                    used.
C     ROGAUSS      - Real array of output field Gaussian latitudes is
C                    used.
C
C     MILATG       - The input field latitudes.
C     MILONG       - The input field longitudes.
C     MISTRT       - The array offsets for the start of each latitude
C                    line for a quasi regular Gaussian input field.
C     MNSDIST      - The distances to neighbouring latitude lines of
C                    the input field from the associated line of
C                    latitude in the output field.
C     MNSIND       - The latitude line numbers (array offset) of the
C                    input field associated with each line of
C                    latitude in the output field.
C     MOLATG       - The output field latitudes.
C     MOLONG       - The output field longitudes.
C     MWEDIST      - This array holds the distances to neighbouring
C                    longitude points of the input field from the
C                    associated longitude points in the output field.
C     MWEIND       - This array holds the longitude points (array
C                    offset) from the input field associated with
C                    each longitude point in the output field.
C     RINPNT       - Array used to aid vectorisation in processing
C                    precipitation fields.
C     RMAX         - Array used to aid vectorisation in normalising
C                    interpolation weights and processing
C                    precipitation fields.
C     WFACT        - The array of interpolation weights for each
C                    point in the output field.
C
C     nifld.common - This file contains all the input field
C                    definition variables.
C
C     LCHANGE      - Process change flag is used and set.
C     LSMCHNG      - LSM change flag is used and set.
C     LSM          - LSM usage flag is used.
C     LSMPAR       - LSM parameter flag is used.
C     LPREC        - Precipitation flag is used.
C     LWIND        - Wind flag is used.
C
C     NIAREA       - Input field area definition (N/W/S/E) is used.
C     NIGAUSS      - Input field Gaussian truncation is used.
C     NIGRID       - Input field grid definition (WE/NS) is used.
C     NINS         - Number of grid points in NS direction for input
C                    field is used.
C     NIREPR       - Input field representation is used.
C     NIWE         - Number of grid points in WE direction for input
C                    field is used.
C
C     nofld.common - This file contains all the output field
C                    definition variables.
C
C     NOAREA       - Output field area definition (N/W/S/E) is used.
C     NOGAUSS      - Output field Gaussian truncation is used.
C     NOGRID       - Output field grid definition (WE/NS) is used.
C     NONS         - Number of grid points in NS direction for output
C                    field is used.
C     NOREPR       - Output field representation is used.
C     NOWE         - Number of grid points in WE direction for output
C                    field is used.
C
C
C     Externals
C     ---------
C
C     ABORTX     - Standard routine to kill task.
C     IGDINS     - Calculate the distances between points in an
C                  output latitude array and its North and South
C                  neighbours in the input latitude array.
C     IGGRID     - Generate the arrays of latitude and longitude
C                  points for a Gaussian truncation and area.
C     IGLGRID    - Generate the arrays of latitude and longitude
C                  points for a regular latitude longitude grid.
C     IGLSIZE    - Evaluate the array sizes for a regular
C                  latitude/longitude field.
C     IGLSMD     - Generate the land sea mask file information.
C     IGNORM     - Normalise the array of interpolation weights.
C     IGPLSM     - Force an interpolated land sea mask field back to
C                  a real 0-1 field.
C     IGPOLEG    - Calculate the values at the pole of a regular
C                  latitude/longitude field when the input is a
C                  Gaussian field.
C     IGPOLEW    - Calculates the values at the pole of a regular
C                  latitude/longitude wind field when the input is a
C                  Gaussian field.
C     IGSIZE     - Evaluate the array sizes for a Gaussian field.
C     IRDIWE     - Calculate the distances between points in an
C                  output longitude array and its West and East
C                  neighbours in the input longitude array for a
C                  quasi regular input field and regular output field.
C     IRGMEM     - This routine acquires heap space for quasi regular
C                  to regular interpolation.
C     IRGRID     - Generate the arrays of latitude points and the
C                  starting points of the lines of latitude for a
C                  quasi regular Gaussian grid.
C     IRGTOG     - Perform basic interpolation between the input and
C                  output fields for a quasi regular input field and
C                  a regular output field.
C     IRINT      - Calculate the basic unnormalised interpolation
C                  weights when interpolating from a quasi regular
C                  grid to a regular grid.
C     IRLSMB     - Calculate the effects of the land-sea masks on the
C                  unnormalised interpolation weights for a quasi
C                  regular input field and regular output field.
C     IRPREC     - Perform additional interpolation processes for
C                  precipitation fields when the input field is Quasi
C                  regular.
C     ZPREC      - Perform additional interpolation processes
C                  for precipitation
C     IRSIZE     - Evaluate the array sizes for a quasi regular
C                  Gaussian field.
C     INTLOG     - Logs messages.
C
C
C     Method
C     ------
C     This is purely a controlling routine with all the work being
C     performed in the external routines.
C
C
C     Reference
C     ---------
C     None
C
C
C     Comments
C     --------
C     None
C
C
C     Author
C     ------
C     K. Fielding      *ECMWF*      Nov 1993
C
C
C     Modifications
C     -------------
C     J.Chambers        ECMWF       Oct 1998
C     Allow field type for rotated grids.
C
C     S.Curic           ECMWF       Oct 2005
C     Add zprec routine that Perform checking
C     of precipitation
C
C----<
C     -----------------------------------------------------------------|
C*    Section 0. Definition of variables.
C     -----------------------------------------------------------------|
C
      IMPLICIT NONE
C
#include "parim.h"
#include "nifld.common"
#include "nofld.common"
#include "grspace.h"
C
C     Parameters
C
      INTEGER JPROUTINE
      PARAMETER (JPROUTINE = 21900)
C
C     Function arguments
C
      LOGICAL OIWEGLOBE, OINPOLE, OISPOLE, OOWEGLOBE, OONPOLE, OOSPOLE
      INTEGER KILEN, KOLEN, KILN, KOLN, KPR, KERR
      REAL PIFELD(KILEN), POFELD(KOLEN)
C
C     Local variables
C
      LOGICAL LFAIL, LERROR, LDEBUG, LREGOUT
      LOGICAL GINSPOLE, GIGLOBE, GISTAND, GONSPOLE, GOGLOBE, GOSTAND
      LOGICAL GPREC,LSM_VALUES
      CHARACTER*120 YIFILE, YOFILE
      CHARACTER*12 YFLAG
      INTEGER IIOFF, IINDEX, IOOFF
      INTEGER IIREC, IOREC, IERR
C
C     Working copies of area and grid arrays that may be changed
C
      INTEGER IILGRID(2), IILLINE(2), IOLGRID(2), IOLLINE(2)
C
C     External functions
C
      INTEGER IGDINS, IGGRID, IGLGRID, IGLSMD, IGNORM, IGPLSM,
     X   IGPOLEG, IGPOLEW,
     X   IRDIWE, IRGMEM, IRGRID, IRGTOG, IRINT, IRLSMB, IRPREC,
     X   ZPREC
C
C     -----------------------------------------------------------------|
C*    Section 1. Initialisation
C     -----------------------------------------------------------------|
C
  100 CONTINUE
C
      IARCNTL = 0
      IERR = 0
C
C     Set all flag variables
C
      LDEBUG  = (KPR.GE.1)
      LFAIL   = (KERR.EQ.0)
      LERROR  = (KERR.GE.0)
      LREGOUT = (NOREPR.EQ.JPREGULAR).OR.(NOREPR.EQ.JPREGROT)
C
      IF( LDEBUG ) THEN
        CALL INTLOG(JP_DEBUG,'IARCNTL: Section 1.',JPQUIET)
        CALL INTLOG(JP_DEBUG,
     X    'IARCNTL: Input field definition parameters.',JPQUIET)
        CALL INTLOG(JP_DEBUG,'IARCNTL: Representation = ',NIREPR)
        IF( NINS.NE.0 ) CALL INTLOG(JP_DEBUG,
     X    'IARCNTL: Number N-S = ',NINS)
        CALL INTLOG(JP_DEBUG,'IARCNTL: Gaussian truncation= ',NIGAUSS)
        IF( NIAREA(1).NE.0 ) THEN
          CALL INTLOG(JP_DEBUG,'IARCNTL: Area North = ',NIAREA(1))
          CALL INTLOG(JP_DEBUG,'IARCNTL: Area West  = ',NIAREA(2))
          CALL INTLOG(JP_DEBUG,'IARCNTL: Area South = ',NIAREA(3))
          CALL INTLOG(JP_DEBUG,'IARCNTL: Area East  = ',NIAREA(4))
        ENDIF
C
        CALL INTLOG(JP_DEBUG,
     X    'IARCNTL: Output field definition parameters.',JPQUIET)
        CALL INTLOG(JP_DEBUG,'IARCNTL: Representation = ',NOREPR)
        IF( NOWE.NE.0 ) CALL INTLOG(JP_DEBUG,
     X    'IARCNTL: Number W-E = ',NOWE)
        IF( NONS.NE.0 ) CALL INTLOG(JP_DEBUG,
     X    'IARCNTL: Number N-S = ',NONS)
        IF( (NOREPR.EQ.JPGAUSSIAN).OR.(NOREPR.EQ.JPQUASI) )
     X    CALL INTLOG(JP_DEBUG,'IARCNTL: Gaussian truncation= ',NOGAUSS)
        IF( LREGOUT.AND.NOGRID(1).NE.0 ) THEN
          CALL INTLOG(JP_DEBUG,'IARCNTL: Grid WE = ',NOGRID(1))
          CALL INTLOG(JP_DEBUG,'IARCNTL: Grid NS = ',NOGRID(2))
        ENDIF
        IF( NOAREA(1).NE.0 ) THEN
          CALL INTLOG(JP_DEBUG,'IARCNTL: Area North = ',NOAREA(1))
          CALL INTLOG(JP_DEBUG,'IARCNTL: Area West  = ',NOAREA(2))
          CALL INTLOG(JP_DEBUG,'IARCNTL: Area South = ',NOAREA(3))
          CALL INTLOG(JP_DEBUG,'IARCNTL: Area East  = ',NOAREA(4))
        ENDIF
C
        CALL INTLOG(JP_DEBUG,'IARCNTL: Control flag status:',JPQUIET)
C
        IF( LSMCHNG ) THEN
          CALL INTLOG(JP_DEBUG,'IARCNTL: LSM change TRUE',JPQUIET)
        ELSE
          CALL INTLOG(JP_DEBUG,'IARCNTL: LSM change FALSE',JPQUIET)
        ENDIF
C
        IF( LSM ) THEN
          CALL INTLOG(JP_DEBUG,'IARCNTL: LSM flag TRUE',JPQUIET)
        ELSE
          CALL INTLOG(JP_DEBUG,'IARCNTL: LSM flag FALSE',JPQUIET)
        ENDIF
C
        IF( LWIND ) THEN
          CALL INTLOG(JP_DEBUG,'IARCNTL: Wind flag TRUE',JPQUIET)
        ELSE
          CALL INTLOG(JP_DEBUG,'IARCNTL: Wind flag FALSE',JPQUIET)
        ENDIF
C
        IF( LPREC ) THEN
          CALL INTLOG(JP_DEBUG,'IARCNTL: Precipitn flag TRUE',JPQUIET)
        ELSE
          CALL INTLOG(JP_DEBUG,'IARCNTL: Precipitn flag FALSE',JPQUIET)
        ENDIF
C
        IF( LSMPAR ) THEN
          CALL INTLOG(JP_DEBUG,'IARCNTL: LSM param flag TRUE',JPQUIET)
        ELSE
          CALL INTLOG(JP_DEBUG,'IARCNTL: LSM param flag FALSE',JPQUIET)
        ENDIF
      ENDIF
C
C     The change of parameter option spans sections 2 to 3
C
      IF( LCHANGE ) THEN
C
C     -----------------------------------------------------------------|
C*    Section 2. Get space and define grids.
C     -----------------------------------------------------------------|
C
  200   CONTINUE
C
        IF( LDEBUG ) CALL INTLOG(JP_DEBUG,'IARCNTL: Section 2.',JPQUIET)
C
C       Get the required memory
C
        IARCNTL = IRGMEM(KPR, KERR)
        IF( IARCNTL.GT.0 ) GOTO 900
C
C       Input field definition
C
        IF( NIREPR.EQ.JPQUASI ) THEN
C
          IARCNTL = IRGRID(NIAREA, MILLEN, KILN, RIGAUSS, MISTRT,
     X                     MILATG, NINS, OIWEGLOBE, KPR, KERR)
          IF( IARCNTL.GT.0 ) GOTO 900
C
C         Is the input field global
C
          GINSPOLE = OINPOLE.AND.OISPOLE
          GIGLOBE  = OIWEGLOBE.AND.GINSPOLE
C
        ELSE
C
          IARCNTL = JPROUTINE + 1
          IF( LERROR ) THEN
            CALL INTLOG(JP_ERROR,
     X        'IARCNTL: Illegal input data representation = ',NIREPR)
            IF( LFAIL ) CALL INTLOG(JP_FATAL,
     X        'IARCNTL: Interpolation failing.',JPQUIET)
          ENDIF
          GOTO 900
C
        ENDIF
C
C       Output grid definition
C
C       Is the output field global North South
C
        GONSPOLE = OONPOLE.AND.OOSPOLE
        GOGLOBE  = OOWEGLOBE.AND.GONSPOLE

        IF(GOGLOBE.AND.NOAREA(2).EQ.0) THEN
            LGLOBL = .TRUE.
        ELSE
            LGLOBL = .FALSE.
        ENDIF

C
        IF( NOREPR.EQ.JPGAUSSIAN ) THEN
C
          IARCNTL = IGGRID(NOGAUSS, NOAREA, KOLN, ROGAUSS,
     X                     MOLONG,NOWE,MOLATG,NONS,OOWEGLOBE,KPR,KERR)
          IF( IARCNTL.GT.0 ) GOTO 900
C
        ELSEIF ( LREGOUT ) THEN
C
          IARCNTL = IGLGRID(NOGRID, NOAREA, MOLONG, NOWE, MOLATG,
     X                      NONS, OOWEGLOBE, KPR, KERR)
          IF( IARCNTL.GT.0 ) GOTO 900
C
        ELSE
C
          IARCNTL = JPROUTINE + 2
          IF( LERROR ) THEN
            CALL INTLOG(JP_ERROR,
     X        'IARCNTL: Illegal output data representation = ',NIREPR)
            IF( LFAIL ) CALL INTLOG(JP_FATAL,
     X        'IARCNTL: Interpolation failing.',JPQUIET)
          ENDIF
          GOTO 900
C
        ENDIF
C
C     -----------------------------------------------------------------|
C*    Section 3. Create output to input grid mapping and distance arrays
C     -----------------------------------------------------------------|
C
  300   CONTINUE
C
        IF( LDEBUG )
     X    CALL INTLOG(JP_DEBUG,'IARCNTL: Section 3.',JPQUIET)
C
C       First check that the input and output fields are compatible.
C
        IF( .NOT.GIGLOBE ) THEN
C
          IF( .NOT.OIWEGLOBE ) THEN
C
C           Cannot produce global output field if input field not global
C
            IF( OOWEGLOBE ) THEN
              IARCNTL = JPROUTINE + 3
              IF( LERROR ) THEN
                CALL INTLOG(JP_ERROR,
     X            'IARCNTL: Cannot produce global output from',JPQUIET)
                CALL INTLOG(JP_ERROR,
     X            'IARCNTL: non-global input.  The W-E input',JPQUIET)
                CALL INTLOG(JP_ERROR,
     X            'IARCNTL: direction was not global.',JPQUIET)
                IF( LFAIL ) CALL INTLOG(JP_FATAL,
     X            'IARCNTL: Interpolation failing.',JPQUIET)
              ENDIF
              GOTO 900
            ENDIF
C
          ENDIF
C
          IF( .NOT.GINSPOLE ) THEN
C
C           Cannot produce global output field if input field not global
C
            IF( GONSPOLE ) THEN
              IARCNTL = JPROUTINE + 4
              IF( LERROR ) THEN
                CALL INTLOG(JP_ERROR,
     X            'IARCNTL: Cannot produce global output from',JPQUIET)
                CALL INTLOG(JP_ERROR,
     X            'IARCNTL: non-global input.  The N-S input',JPQUIET)
                CALL INTLOG(JP_ERROR,
     X            'IARCNTL: direction was not global.',JPQUIET)
                IF( LFAIL ) CALL INTLOG(JP_FATAL,
     X            'IARCNTL: Interpolation failing.',JPQUIET)
              ENDIF
              GOTO 900
            ENDIF
C
          ENDIF
C
        ENDIF
C
        IARCNTL = IGDINS(MILATG, NINS, MOLATG, NONS, OINPOLE,
     X                   OISPOLE, MNSIND, MNSDIST, KPR, KERR)
        IF( IARCNTL.GT.0 ) GOTO 900
C
        IARCNTL = IRDIWE(MILLEN, NINS, MNSIND, NONS, MILONG, NIWE,
     X                   MOLONG, NOWE, MWEIND, MWEDIST, KPR, KERR)
        IF( IARCNTL.GT.0 ) GOTO 900
C
C     The end of primary initialisation
C
      ENDIF
C
C     -----------------------------------------------------------------|
C*    Section 4. Create normalised weight arrays
C     -----------------------------------------------------------------|
C
  400 CONTINUE
C
      IF( LDEBUG ) CALL INTLOG(JP_DEBUG,'IARCNTL: Section 4.',JPQUIET)
C
C     The following code is affected by the Land Sea mask flag
C
      IF( LCHANGE.OR.LSMCHNG ) THEN
C
        IARCNTL = IRINT(MWEDIST, NOWE, MNSDIST, NONS, WFACT, KPR, KERR)
        IF( IARCNTL.GT.0 ) GOTO 900
C
        IF( LSM ) THEN
C
          IARCNTL = IGLSMD(NIDATE,NIREPR,NIGRID,NIGAUSS,NIAREA,KILN,
     X                    YIFILE,GISTAND,IILGRID,IILLINE,IIREC,KPR,KERR)
          IF( IARCNTL.GT.0 ) GOTO 900
C
          IARCNTL = IGLSMD(NODATE,NOREPR,NOGRID,NOGAUSS,NOAREA,KOLN,
     X                    YOFILE,GOSTAND,IOLGRID,IOLLINE,IOREC,KPR,KERR)
          IF( IARCNTL.GT.0 ) GOTO 900
C
          IARCNTL = IRLSMB(GISTAND, YIFILE, IIREC, IILGRID, IILLINE,
     X                    GOSTAND,YOFILE,IOREC,IOLGRID,IOLLINE,KPR,KERR)
          IF( IARCNTL.GT.0 ) GOTO 900
C
        ENDIF
C
C       Normalise the weights
C
        IARCNTL = IGNORM(WFACT, RMAX, NOWE, NONS, KPR, KERR)
        IF( IARCNTL.GT.0 ) GOTO 900
C
C       This marks the end of a change to the specfication
C       Clear the Change flags LCHANGE and LSMCHNG
C
        LCHANGE = .FALSE.
        LSMCHNG = .FALSE.
C
      ENDIF
C
C     -----------------------------------------------------------------|
C*    Section 5. Interpolate from input to output field
C     -----------------------------------------------------------------|
C
  500 CONTINUE
C
      IF( LDEBUG ) CALL INTLOG(JP_DEBUG,'IARCNTL: Section 5.',JPQUIET)
C
C     Perform basic interpolation
C
      IARCNTL = IRGTOG(PIFELD, MISTRT, NINS, NOWE, NONS, MWEIND,
     X                 MNSIND, WFACT, POFELD, KPR, KERR)
      IF( IARCNTL.GT.0 ) GOTO 900
C
C     -----------------------------------------------------------------|
C*    Section 6. Additional interpolations from input to output field
C     -----------------------------------------------------------------|
C
  600 CONTINUE
C
      IF( LDEBUG ) CALL INTLOG(JP_DEBUG,'IARCNTL: Section 6.',JPQUIET)
C
C     Precipitation field
C
C     Force processing without neighbour check
        GPREC = .FALSE.
        CALL GETENV('PRECIPITATION_NEIGHBOUR_CHECK', YFLAG)
        IF( YFLAG(1:1).EQ.'0' ) GPREC = .TRUE.

      IF( LPREC ) THEN
C
        IF( GPREC ) THEN
          IARCNTL = ZPREC(POFELD, NOWE, NONS, KPR, KERR)
        ELSE
          IARCNTL = IRPREC(PIFELD, MISTRT, NINS, POFELD, NOWE, NONS,
     X                   MWEIND, MNSIND, WFACT, RMAX, RINPNT, KPR, KERR)
        ENDIF
        IF( IARCNTL.GT.0 ) GOTO 900
C
      ENDIF
C
C     Special code for poles if Gaussian input and regular output
C
C     North pole
C
      IF( (NIREPR.EQ.JPQUASI).AND.
     X    LREGOUT            .AND.
     X    OINPOLE            .AND.
     X    OONPOLE ) THEN
C
        IIOFF = MISTRT(1)
        IOOFF = 1
        IINDEX = (JP_I_N - 1) * NOWE + 1
C
        IF( LWIND ) THEN
          IARCNTL = IGPOLEW(PIFELD(IIOFF), MILLEN(1),
     X                      POFELD(IOOFF), NOWE, MWEIND(1,IINDEX),
     X                      MWEDIST(1,IINDEX), KPR, KERR)
        ELSE
          IARCNTL = IGPOLEG(PIFELD(IIOFF), MILLEN(1),
     X                      POFELD(IOOFF), NOWE, KPR, KERR)
        ENDIF
        IF( IARCNTL.GT.0 ) GOTO 900
C
      ENDIF
C
C     South pole
C
      IF( (NIREPR.EQ.JPQUASI).AND.
     X    LREGOUT            .AND.
     X    OISPOLE            .AND.
     X    OOSPOLE ) THEN
C
        IIOFF = MISTRT(NINS)
        IOOFF = (NONS - 1) * NOWE + 1
        IINDEX = ( (NONS - 1) * 2 + JP_I_S - 1) * NOWE + 1
C
        IF( LWIND ) THEN
          IARCNTL = IGPOLEW(PIFELD(IIOFF), MILLEN(NINS),
     X                      POFELD(IOOFF), NOWE, MWEIND(1,IINDEX),
     X                      MWEDIST(1,IINDEX), KPR, KERR)
        ELSE
          IARCNTL = IGPOLEG(PIFELD(IIOFF), MILLEN(NINS),
     X                      POFELD(IOOFF), NOWE, KPR, KERR)
        ENDIF
C
        IF( IARCNTL.GT.0 ) GOTO 900
C
      ENDIF
C
C     LSM field - must be 0 or 1
C
C     Force processing real LSM
        LSM_VALUES = .FALSE.
        CALL GETENV('LSM_VALUES', YFLAG)
        IF( YFLAG(1:1).EQ.'1' ) LSM_VALUES = .TRUE.

      IF( .NOT.LSM_VALUES.AND.LSMPAR ) THEN
        IARCNTL = IGPLSM(POFELD, NOWE * NONS, KPR, KERR)
        IF( IARCNTL.GT.0 ) GOTO 900
      ENDIF
C
C     -----------------------------------------------------------------|
C*    Section 9. Return to calling routine. Format statements
C     -----------------------------------------------------------------|
C
  900 CONTINUE
C
      IF( LDEBUG ) CALL INTLOG(JP_DEBUG,'IARCNTL: Section 9.',JPQUIET)
C
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE EXTGRP(KBUFL,YBUFF, I,K,IVAL,KERR )
C
C**** *EXTGRP*
C
C
C     PURPOSE.
C     --------
C
C         Extract value of group of character
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *EXTGRP(kbufl,ybuff, i,k,ival,kerr )
C
C                    kbufl - size of ybuff in bytes
C                    ybuff - character string
C
C                    I - CONVERSION OF GROUP STARTS IN WORD I
C                        OF ARRAY 'KCHAR' .
C
C                    K - number of characters to convert
C
C
C
C     METHOD.
C     -------
C
C          NONE.
C
C
C     EXTERNALS.
C     ----------
C
C
C     REFERENCE.
C     ----------
C 
C          NONE.
C
C     AUTHOR.
C     -------
C
C
C
C     MODIFICATIONS.
C     --------------
C
C          M. D. DRAGOSAVAC    *ECMWF*       15/09/2003.
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
C
      COMMON /CREXWORK/ NBPT,NGS,NVIND,NBPTSEC2,RVIND,EPS,NE,IEOLD,
     1                  NC07YYY
C
      CHARACTER*(*) YBUFF
      CHARACTER*8 FMT
      REAL*8 RVIND, EPS
C
      DIMENSION NN(5)
C
C     ------------------------------------------------------------------
C*          1.   EXTRACT GROUP OF CHARACTERS.
C                ----------------------------
 100  CONTINUE
C
      IVAL=NVIND
C
      FMT='(I10.10)'
      WRITE(FMT(3:4),'(I2.2)') K
      FMT(6:7)=FMT(3:4)
C
C
c     Check for '-' sign
c
      IF(NE.EQ.1) THEN
         IF(YBUFF(I:I).EQ.'-') THEN
            I=I+1
         END IF
      END IF
c     
c     Check for slash or non figure character
c
      DO IZ=I,I+K-1
      IF(YBUFF(IZ:IZ).EQ.'/') RETURN
      IICH=ICHAR(YBUFF(IZ:IZ)) 
      IF(IICH.LT.48.OR.IICH.GT.57) RETURN
      END DO
c
      READ(YBUFF(I:I+K-1),FMT,IOSTAT=IOS) IVAL
      IF(IOS.NE.0) THEN
         KERR=35
         CALL CREXERR(KERR)
         RETURN
      END IF
C
      IF(YBUFF(I-1:I-1).EQ.'-') IVAL=-IVAL
C
      I=I+K
C
      RETURN
      END

      PROGRAM BUFR_ADD_BIAS
!
!**** *BUFR_ADD_BIAS*
!
!
!     PURPOSE.
!     --------
!         Add bias information to the existing synop bufr data
!
!
!**   INTERFACE.
!     ----------
!
!          NONE.
!
!     METHOD.
!     -------
!
!          NONE.
!
!
!     EXTERNALS.
!     ----------
!
!         CALL BUSEL
!         CALL BUFREX
!         CALL BUFREN
!         CALL BUPRS0
!         CALL BUPRS1
!         CALL BUPRS2
!         CALL BUPRS3
!         CALL BUPRT
!         CALL BUUKEY
!
!     REFERENCE.
!     ----------
!
!          NONE.
!
!     AUTHOR.
!     -------
!
!          M. DRAGOSAVAC    *ECMWF*       /17/03/2004.
!
!
!     MODIFICATIONS.
!     --------------
!
!          NONE.
!
!
      IMPLICIT LOGICAL(L,O,G), CHARACTER*8(C,H,Y)
!
      PARAMETER(JSUP =   9,JSEC0=   3,JSEC1= 40,JSEC2= 4096 ,JSEC3= 4, &
            JSEC4=   2,JELEM=160000,JSUBS=400,JCVAL=150 ,JBUFL=512000, &
#ifdef JBPW_64
            JBPW =  64,JTAB =3000,JCTAB=120,JCTST=1800,JCTEXT=1200, &
#else
            JBPW =  32,JTAB =3000,JCTAB=120,JCTST=1800,JCTEXT=1200, &
#endif
            JWORK=4096000,JKEY=46,JBYTE=512000)
!
      PARAMETER (KELEM=40000)
      PARAMETER (KVALS=360000)
      PARAMETER (NSTATIONS=15000)
! 
      DIMENSION KBUFF(JBUFL)
      DIMENSION KBUFR(JBUFL)
      DIMENSION KSUP(JSUP)  ,KSEC0(JSEC0),KSEC1(JSEC1)
      DIMENSION KSEC2(JSEC2),KSEC3(JSEC3),KSEC4(JSEC4)
      DIMENSION KEY  (JKEY),KREQ(2)
!
      REAL*8 VALUES(KVALS),VALUE(KVALS),RQV(KELEM)
      REAL*8 RVIND,EPS
      REAL*8 BIAS_VALUE0, BIAS_VALUE1
!
      DIMENSION KTDLST(KELEM),KTDEXP(KELEM),KRQ(KELEM)
      DIMENSION KDATA(200)
      DIMENSION IOUT(12800)
!
      CHARACTER*256 CF(100),COUT,CFIN,CLIST
      CHARACTER*64 CNAMES(KELEM)
      CHARACTER*24 CUNITS(KELEM)
      CHARACTER*80 CVALS(KVALS)
      CHARACTER*80 YENC
      CHARACTER*256 CARG(10)
      CHARACTER*8   CIDENT, CTEMP
      INTEGER DATE
      DIMENSION ITYPE(NSTATIONS)
      DIMENSION ISBT(NSTATIONS)
      DIMENSION IPC(NSTATIONS)
      DIMENSION BIAS(NSTATIONS)
      CHARACTER*8 CID(NSTATIONS)
!
!s      EXTERNAL GETARG
!                                                                       
!     ------------------------------------------------------------------
!*          1. INITIALIZE CONSTANTS AND VARIABLES.
!              -----------------------------------
 100  CONTINUE
!
!     MISSING VALUE INDICATOR
! 
      icount=0
      ITLEN=6400
      ITL=0
      JZ=0
      NW=0
      N=0
      NBYTES=JBPW/8
      RVIND=1.7E38
      NVIND=2147483647
      IOBS=0
      KRQL=0
      NR=0
      KREQ(1)=0
      KREQ(2)=0
      DO 102 I=1,KELEM
      RQV(I)=RVIND
      KRQ(I)=NVIND
 102  CONTINUE
!
!     INPUT FILE NAMES
!
      NARG=IARGC()
      IF(NARG.LT.4) THEN
         PRINT*,'USAGE -- bufr_add_bias -i infile -o outfile -l list'
         STOP
      END IF
      NFILE=NARG
!
      DO 104 J=1,NARG
      CALL GETARG(J,CARG(J))
 104  CONTINUE

      II=0
      IO=0
      IN=0
      IL=0
      DO 105 J=1,NARG
      IF(CARG(J).EQ.'-i') THEN
         IN=J
      ELSEIF(CARG(J).EQ.'-o') THEN
         IO=J
      ELSEIF(CARG(J).EQ.'-l') THEN
         IL=J
      END IF
 105  CONTINUE
      IF(IO.EQ.0.OR.IN.EQ.0) THEN
         PRINT*,'USAGE -- bufr_add_bias -i infile -o outfile -l list'
         STOP
      END IF
!
      COUT=CARG(IO+1)
      CFIN=CARG(IN+1)
      CLIST=CARG(IL+1)
!
      JJ=INDEX(COUT,' ')
!
      CALL PBOPEN(IUNIT1,COUT(1:JJ),'W',IRET)
      IF(IRET.EQ.-1) STOP 'OPEN FAILED ON BUFR.DAT'
      IF(IRET.EQ.-2) STOP 'INVALID FILE NAME'
      IF(IRET.EQ.-3) STOP 'INVALID OPEN MODE SPECIFIED'
!
      ILN=INDEX(CFIN,' ')
!
!*          1.2 OPEN FILE CONTAINING BUFR DATA.
!               -------------------------------
 120  CONTINUE
!
      IRET=0 
      CALL PBOPEN(IUNIT,CFIN(1:ILN),'R',IRET)
      IF(IRET.EQ.-1) STOP 'OPEN FAILED'
      IF(IRET.EQ.-2) STOP 'INVALID FILE NAME'
      IF(IRET.EQ.-3) STOP 'INVALID OPEN MODE SPECIFIED'
!
      IF(IL.NE.0) THEN
         ILL=INDEX(CLIST,' ')
!
         OPEN(UNIT=37,FILE=CLIST(1:ILL-1),IOSTAT=IOS, &
              STATUS='OLD',FORM='FORMATTED')
!
         READ(37,'(A)') CLINE
         READ(37,'(10x,I10.10)') DATE
         READ(37,'(16x,I12.12)') NUM_STATIONS
         READ(37,'(19x,F8.2)')   TRESHOLD
         READ(37,'(A)') CLINE
         READ(37,'(A)') CLINE
!
         if(NUM_STATIONS.GT.NSTATIONS) THEN
            print*,'Error: too many stations in the list.'
            call exit(2)
         end if
         DO I=1,NUM_STATIONS
         READ(37,'(A8,I4,I5,I3,F11.2)') CID(I), ITYPE(I),ISBT(I), &
                                        IPC(I),BIAS(I)
!        write(*,*) CID(I), ITYPE(I),ISBT(I),IPC(I),BIAS(I)
         END DO

      END IF
!
!     ----------------------------------------------------------------- 
!*          2. SET REQUEST FOR EXPANSION.
!              --------------------------
 200  CONTINUE
!
      OPRT=.FALSE.
      OENC=.TRUE.
      NCOM=1
      OCOMP=.FALSE.
      NR=0
      OSEC3=.FALSE.
!
!*          2.1 SET REQUEST FOR PARTIAL EXPANSION.
!               ----------------------------------
 210  CONTINUE
!
!     SET VARIABLE TO PACK BIG VALUES AS MISSING VALUE INDICATOR
!
      KPMISS=1
      KPRUS=0
      NOKEY=0
      CALL BUPRQ(KPMISS,KPRUS,NOKEY)
!
!     -----------------------------------------------------------------
!*          3.  READ BUFR MESSAGE.
!               ------------------
 300  CONTINUE
!
      IERR=0
      KBUFL=0
!
      IRET=0
      icount=icount+1
!     print *, '++++ processing message #',icount
      CALL PBBUFR(IUNIT,KBUFF,JBYTE,KBUFL,IRET) 
      IF(IRET.EQ.-1) THEN
          GO TO 900
      END IF
      IF(IRET.EQ.-2) STOP 'FILE HANDLING PROBLEM' 
      IF(IRET.EQ.-3) STOP 'ARRAY TOO SMALL FOR PRODUCT'
!
      N=N+1
      IKBUFL=KBUFL
      KBUFL=KBUFL/NBYTES+1
      IF(N.LT.NR) GO TO 300
!
!     -----------------------------------------------------------------
!*          4. EXPAND BUFR MESSAGE.
!              --------------------
 400  CONTINUE
!
      CALL BUS012(KBUFL,KBUFF,KSUP,KSEC0,KSEC1,KSEC2,KERR)
      IF(KERR.NE.0) THEN
         PRINT*,'ERROR IN BUS012: ',KERR
         PRINT*,' BUFR MESSAGE NUMBER ',N,' CORRUPTED.'
         KERR=0
         GO TO 300
      END IF
      KBUFFL=KSEC0(2)
!
      OSURF=.false.
      IF(ksec1(6).ne.0.and.ksec1(6).ne.1) then
         CALL PBWRITE(IUNIT1,KBUFF,IKBUFL,IERR)
         go to 300
      else
         if(ksec1(7).eq.  1) OSURF=.true.
         if(ksec1(7).eq.  3) OSURF=.true.
         if(ksec1(7).eq.  9) OSURF=.true.
         if(ksec1(7).eq. 11) OSURF=.true.
         if(ksec1(7).eq. 13) OSURF=.true.
         if(ksec1(7).eq. 19) OSURF=.true.
         if(ksec1(7).eq. 21) OSURF=.true.
         if(ksec1(7).eq.140) OSURF=.true.
         if(ksec1(7).eq.147) OSURF=.true.
         if(ksec1(7).eq.170) OSURF=.true.
         if(ksec1(7).eq.172) OSURF=.true.
         if(ksec1(7).eq.176) OSURF=.true.
         if(ksec1(7).eq.180) OSURF=.true.
         if(ksec1(7).eq.181) OSURF=.true.
         if(ksec1(7).eq.182) OSURF=.true.
      end if
!
      if(.not.OSURF) then
         CALL PBWRITE(IUNIT1,KBUFF,IKBUFL,IERR)
         go to 300
      end if
!
      IF(KSUP(6).GT.1) THEN
         KEL=JWORK/KSUP(6)
      ELSE
         KEL=KELEM
      END IF
!
      CALL BUFREX(KBUFL,KBUFF,KSUP,KSEC0 ,KSEC1,KSEC2 ,KSEC3 ,KSEC4,&
                  KEL,CNAMES,CUNITS,KVALS,VALUES,CVALS,IERR)
!
      IF(IERR.NE.0) THEN
         IF(IERR.EQ.45) GO TO 300
         CALL EXIT(2)
      END IF
      IOBS=IOBS+KSEC3(3)
!
      CALL BUSEL(KTDLEN,KTDLST,KTDEXL,KTDEXP,KERR)
      IF(KERR.NE.0) CALL EXIT(2)
!
!*          4.1 PRINT CONTENT OF EXPANDED DATA.
!               -------------------------------
 410  CONTINUE
!
      IF(.NOT.OPRT) GO TO 500
      IF(.NOT.OSEC3) GO TO 450
!
!*          4.2 PRINT SECTION ZERO OF BUFR MESSAGE.
!               -----------------------------------
 420  CONTINUE
!

      CALL BUPRS0(KSEC0)
!
!*          4.3 PRINT SECTION ONE OF BUFR MESSAGE.
!               -----------------------------------
 430  CONTINUE
!
      CALL BUPRS1(KSEC1)
!
!
!*          4.4 PRINT SECTION TWO OF BUFR MESSAGE.
!               -----------------------------------
 440  CONTINUE
!
!              AT ECMWF SECTION 2 CONTAINS RDB KEY.
!              SO UNPACK KEY
!
      CALL BUUKEY(KSEC1,KSEC2,KEY,KSUP,KERR)
!
!              PRINT KEY
!
      CALL BUPRS2(KSUP ,KEY)
!
!*          4.5 PRINT SECTION 3 OF BUFR MESSAGE.
!               -----------------------------------
 450  CONTINUE
!
!               FIRST GET DATA DESCRIPTORS
!
      CALL BUSEL(KTDLEN,KTDLST,KTDEXL,KTDEXP,KERR)
      IF(KERR.NE.0) CALL EXIT(2)
!
!               PRINT  CONTENT
!
      IF(OSEC3) THEN
         CALL BUPRS3(KSEC3,KTDLEN,KTDLST,KTDEXL,KTDEXP,KEL,CNAMES)
      END IF
!
!*         4.6 PRINT SECTION 4 (DATA).
!              -----------------------
 460  CONTINUE
!
!          IN THE CASE OF MANY SUBSETS DEFINE RANGE OF SUBSETS
!
      IF(.NOT.OO) THEN
      WRITE(*,'(A,$)') ' STARTING SUBSET TO BE PRINTED : '
      READ(*,'(BN,I4)')   IST
      WRITE(*,'(A,$)') ' ENDING SUBSET TO BE PRINTED : '
      READ(*,'(BN,I4)')   IEND
      OO=.FALSE.
      END IF
!
!              PRINT DATA
!
      ICODE=0
      CALL BUPRT(ICODE,IST,IEND,KEL,CNAMES,CUNITS,CVALS,&
                 KVALS,VALUES,KSUP,KSEC1,IERR)
!
!              RESOLVE BIT MAPS 
!
!     IF(IEND.GT.KSEC3(3)) IEND=KSEC3(3)
!
!     DO 461 IK=IST,IEND
! 
!     CALL BUBOX(IK,KSUP,KEL,KTDEXP,CNAMES,CUNITS,KVALS,VALUES,
!    1           KBOX,KAPP,KLEN,KBOXR,VALS,CBOXN,CBOXU,IERR)
!
!     CALL BUPRTBOX(KBOX,KAPP,KLEN,KBOXR,VALS,CBOXN,CBOXU)
!
!461  CONTINUE
!
!     -----------------------------------------------------------------
!*          5. COLLECT DATA FOR REPACKING.
!              ---------------------------
 500  CONTINUE
!      
      IF(.NOT.OENC) GO TO 300
!
!               FIRST GET DATA DESCRIPTORS
!
      CALL BUSEL(KTDLEN,KTDLST,KTDEXL,KTDEXP,KERR)
      IF(KERR.NE.0) CALL EXIT(2)
!
!     -----------------------------------------------------------------
!*          6. PACK BUFR MESSAGE BACK INTO BUFR.
!              ---------------------------------
 600  CONTINUE
!
    
      KKK=0
      KBUFL=JBUFL
!
!     GET REPLICATION FACTORS
!
      KK=0
      DO 601 K=1,KSUP(5)
      IF(KTDEXP(K).EQ.31001.OR.KTDEXP(K).EQ.31002.OR.&
         KTDEXP(K).EQ.31000.OR.&
         KTDEXP(K).EQ.31000) THEN
         KK=KK+1
         KDATA(KK)=NINT(VALUES(K))
      END IF
 601  CONTINUE
!
      KDLEN=2
      IF(KK.NE.0) KDLEN=KK
!
!     --------------------------------
!     |Modification to sections 3
!     --------------------------------
!
      i_end=ksup(5)
      do i=1,ksup(5)
        if(ktdexp(i) .eq. 222000) then
          i_end=i-1
          exit 
        endif
        if(ktdexp(i) .eq. 225000) then
          i_end=i-1
          exit 
        endif
      end do
! skip message if bitmap cannot be built due to YYY too big in 101YYY
      if (i_end>255) then
        print*,'message #',icount,' skipped. Too many elements'
        GO TO 300
      endif
      ip=ktdlen
!
      ip=ip+1
      ktdlst(ip)=225000
      ip=ip+1
      ktdlst(ip)=236000
      ip=ip+1
      ktdlst(ip)=101000+i_end
      ip=ip+1
      ktdlst(ip)=031031
      ip=ip+1
      ktdlst(ip)=001031
      ip=ip+1
      ktdlst(ip)=001032
      ip=ip+1
      ktdlst(ip)=008024
      ip=ip+1
      if(ksec1(7).eq.140.OR.ksec1(7).eq.147) then
         ktdlst(ip)=101001
      else
         ktdlst(ip)=101002
      end if
      ip=ip+1
      ktdlst(ip)=225255
!
      ktdlen=ip
!
!     Add a new bit map and bias
!
      ip=ksup(5)

      ip=ip+1
      values(ip)=0.0
      ip=ip+1
      values(ip)=0.0
!
      i_010004=0
      i_010051=0
      i_007004=0
      nqcentries=0
      do i=1,i_end
        if(ktdexp(i) .eq. 010004.and.nqcentries.lt.2) then 
          i_010004=i
          nqcentries=nqcentries+1
        endif
        if(ktdexp(i) .eq. 010051.and.nqcentries.lt.2) then
          i_010051=i
          nqcentries=nqcentries+1
        endif
        if(ktdexp(i) .eq. 007004.and.nqcentries.lt.2) then
          i_007004=i
          nqcentries=nqcentries+1
        endif
      end do
!
      do iz=1,i_end
       ip=ip+1
       values(ip)=1.
       if(iz.eq.i_010004) values(ip)=0.
       if(iz.eq.i_010051) values(ip)=0.
       if(iz.eq.i_007004) values(ip)=0.
      end do

      ip=ip+1
      values(ip)=98.
      ip=ip+1
      values(ip)=10.
      ip=ip+1
      values(ip)=40.      ! bias
      ip=ip+1
      if(IL.eq.0) then
         values(ip)=rvind
         if(ksec1(7).ne.140.OR.ksec1(7).eq.147) then
           ip=ip+1
           values(ip)=rvind
         end if
      else
!        create identifier
         if(ksec1(7).eq.1.or.ksec1(7).eq.3.or.ksec1(7).eq.170 &
            .or.ksec1(7).eq.172.or.ksec1(7).eq.176) then
            cident=' '
            if(values(1).eq.rvind.or.values(2).eq.rvind) then
               cident=' '
               PRINT*,'Missing block and/or station number'
!              CALL PBOPEN(IUERR,'error.bufr','W',IRET)
!              CALL PBWRITE(IUERR,KBUFF,KBUFFL,IERR)
!              CALL PBCLOSE(IUERR)
            else
              write(cident,'(i2.2,i3.3)',iostat=ios) nint(values(1)),&
              nint(values(2))
              if(ios.ne.0) then
                 print*,'internal write error=',ios
                 call exit(2)
              end if
            end if
         elseif(ksec1(7).eq.9.or.ksec1(7).eq.11.or.&
             ksec1(7).eq.13.or.ksec1(7).eq.19.or.ksec1(7).eq.180) then
             cident=cvals(1)
!        elseif(ksec1(7).eq.178) then
!           if(values(1).eq.rvind.or.values(2).eq.rvind) then
!              print*,values(1),' ',values(2)
!              cident=' '
!           else
!             write(cident,'(i4.4,i10.10)',iostat=ios) nint(values(1)),
!    1        nint(values(2))
!             if(ios.ne.0) then
!                print*,'internal write error=',ios
!                call exit(2)
!             end if
!           end if
         elseif(ksec1(7).eq.9.or.ksec1(7).eq.11.or.&
            ksec1(7).eq.13.or.ksec1(7).eq.19.or.ksec1(7).eq.180) then
             cident=cvals(1)
         elseif(ksec1(7).eq.21) then
             cident=' '
             if(values(1).eq.rvind) then
                cident=' '
             else
                write(cident,'(i5.5)',iostat=ios) nint(values(1))
                if(ios.ne.0) then
                  print*,'internal write error=',ios
                  call exit(2)
               end if
            end if
         elseif((ksec1(7).eq.181).or.(ksec1(7).eq.182)) then
             cident=' '
             if(values(1).eq.rvind) then
                cident=' '
             else
                write(cident,'(i7.7)',iostat=ios) nint(values(1))
                if(ios.ne.0) then
                  print*,'internal write error=',ios
                  call exit(2)
               end if
            end if
         elseif(ksec1(7).eq.140.OR.ksec1(7).eq.147) then
             cident=' '
             cident=cvals(1)
         else
             cident=' '
         end if
         ctemp=adjustr(cident)
         call get_bias(ctemp,ksec1,NUM_STATIONS,cid,itype,&
              isbt,ipc,bias,bias_value0,bias_value1,ierr)
         values(ip)=bias_value1
         if(ksec1(7).ne.140.OR.ksec1(7).eq.147) then
            ip=ip+1
            values(ip)=bias_value0
         end if 
      end if

      kel =ip
!
!*          6.2 ENCODE DATA INTO BUFR MESSAGE.
!               ------------------------------
 620  CONTINUE
!
      KSEC3(4)=128
      IF(KSEC3(3).GT.1) KSEC3(4)=192
      CALL BUFREN( KSEC0,KSEC1,KSEC2,KSEC3,KSEC4, &
                   KTDLEN,KTDLST,KDLEN,KDATA,KEL, &       
                   KVALS,VALUES,CVALS,KBUFL,KBUFR,KERR)
!
      IF(KERR.GT.0) THEN
         PRINT*,'ERROR DURING ENCODING. Message skipped'
         CALL PBOPEN(IUERR,'error.bufr','W',IRET)
         CALL PBWRITE(IUERR,KBUFF,KBUFFL,IERR)
         CALL PBCLOSE(IUERR)
!        CALL EXIT(2)
         GO TO 300
      END IF

      NW=NW+1
!
!           6.3 WRITE PACKED BUFR MESSAGE INTO FILE.
!               ------------------------------------
 630  CONTINUE
!
      IKBUFL=KBUFL*4
      CALL PBWRITE(IUNIT1,KBUFR,IKBUFL,IERR)
      IF(IERR.LT.0) THEN
         PRINT*,'ERROR WRITING INTO TARGET FILE.'
         CALL EXIT(2)
      END IF
!
!
      GO TO 300
!     -----------------------------------------------------------------
!
 810  CONTINUE
!
      WRITE(*,'(1H ,A)') 'OPEN ERROR ON INPUT FILE'
      GO TO 900
!      
 800  CONTINUE
!
      IF(IRET.EQ.-1) THEN
         PRINT*,'NUMBER OF RECORDS PROCESSED ',N
         PRINT*,'NUMBER OF RECORDS CONVERTED ',NW
!
      ELSE
         PRINT*,' BUFR : ERROR= ',IERR
      END IF
!
 900  CONTINUE
!
      PRINT*,'NUMBER OF RECORDS PROCESSED ',N
      PRINT*,'NUMBER OF RECORDS CONVERTED ',NW
!
      CALL PBCLOSE(IUNIT,IRET)
!
      CALL PBCLOSE(IUNIT1,IRET)
!
      END
      SUBROUTINE CUTZERO(CHARPAR,KMIN)
!
!**** CUTZERO - SUBROUTINE TO REMOVE ZERO CHARACTERS.
!
!**   PURPOSE
!     -------
!
!     TO REMOVE ZERO-FILL CHARACTERS FROM THE END OF A CHARACTER
!     VARIABLE.
!
!     INTERFACE
!     ---------
!
!     CALL CUTZERO(CHARPAR,KMIN)
!
!          CHARPAR  - CHARACTER VARIABLE WHICH MAY HAVE ZEROS AT THE
!                     END OF THE VALID CHARACTERS, WHICH NEED TO BE
!                     REMOVED;
!                     RETURNED WITH THE ZERO CHARACTERS CONVERTED TO
!                     BLANK.
!
!          KMIN     - INTEGER VARIABLE INDICATING A MINIMUM NUMBER OF
!                     CHARACTERS AT THE BEGINNING OF THE STRING WHICH
!                     MUST NOT BE CHANGED
!
!     THUS:
!
!     CHARPAR='ABC0000'
!     CALL CUTZERO(CHARPAR,4)
!
!     WOULD RETURN THE VALUE 'ABC0   ' IN CHAR, AND WOULD NOT
!     ALTER THE FIRST 4 CHARACTERS.
!
!     METHOD
!     ------
!
!     THE STRIG IS TESTED FOR THE EXISTANCE OF A ZERO CHARACTER.
!     IF NONE IS FOUND, NO CHANGE TAKES PLACE.
!     IF ONE OR MORE ZERO CHARACTERS ARE PRESENT, THE END OF THE
!     STRING IS LOCATED. WORKING BACKWARDS FROM THE END TO THE
!     KMIN-1 POSITION, CHARACTERS ARE TESTED FOR ZERO. IF A ZERO
!     IS FOUND, IT IS REPLACED BY BLANK. IF A NON-ZERO IS FOUND,
!     THE REPLACEMENT LOOP TERMINATES.
!
!     MODIFICATIONS
!     -------------
!
!     ORIGINAL VERSION - 25.01.95 - REX GIBSON - ECMWF.
!
      CHARACTER*(*) CHARPAR
      CHARACTER*1   YZERO
      INTEGER LEN
!
!     -----------------------------------------------------------
!
!*     1.     FIND AND REPLACE THE ZERO CHARACTERS.
!
  100 CONTINUE
      YZERO=CHAR(0)
      I1=INDEX(CHARPAR,'0')
      IF (I1.GT.0) THEN
         I2=MAX(I1,KMIN+1)
         I3=INDEX(CHARPAR,' ')-1
         IF (I3.LE.0) THEN
            I3=LEN(CHARPAR)
         ENDIF
         DO 112 J=I3,I2,-1
         IF (CHARPAR(J:J).EQ.'0') THEN
             CHARPAR(J:J)=' '
         ELSEIF (CHARPAR(J:J).EQ.YZERO) THEN
             GO TO 112
         ELSE
             GO TO 114
         ENDIF
  112    CONTINUE
!
  114    CONTINUE
      ENDIF
!
!     -----------------------------------------------------------
!
!*     2.     RETURN.
!
  200 CONTINUE
!
      END
      SUBROUTINE  GET_BIAS(CIDENT,KSEC1,K_STATIONS,CID,KTYPE,KSBT,&
                KPC,BIAS,BIAS_VALUE0,BIAS_VALUE1,KERR)
!**** *GET_BIAS*
!
!
!     PURPOSE.
!     --------
!
!          Get bias value for particular station
!
!
!**   INTERFACE.
!     ----------
!
!          NONE.
!
!     METHOD.
!     -------
!
!          NONE.
!
!
!     EXTERNALS.
!     ----------
!
!          NONE.
!
!     REFERENCE.
!     ----------
!
!          NONE.
!
!     AUTHOR.
!     -------
!
!
!          M. DRAGOSAVAC    *ECMWF*       06/11/2004.
!
!
!     MODIFICATIONS.
!     --------------
!
!          NONE.
!
!
!
!     -------------------------------------------------------------

      CHARACTER*8 CIDENT
      DIMENSION KSEC1(*), KTYPE(*), KSBT(*), KPC(*),BIAS(*)
      CHARACTER*(*) CID(*)
      REAL*8 BIAS_VALUE0, BIAS_VALUE1
      
      KERR=0
      BIAS_VALUE0=1.7D38
      BIAS_VALUE1=1.7D38
!
      IF(K_STATIONS.EQ.0) RETURN

      DO I=1,K_STATIONS
        if(CIDENT.eq.CID(I)) THEN
           IF(KSEC1(6).EQ.KTYPE(I).AND.KSEC1(7).EQ.KSBT(I).AND.&
              KPC(i).EQ.0) THEN
              BIAS_VALUE0=BIAS(I)
           ELSEIF(KSEC1(6).EQ.KTYPE(I).AND.KSEC1(7).EQ.KSBT(I).AND.&
              KPC(I).EQ.1) THEN
              BIAS_VALUE1=BIAS(I)
           END IF
        END IF
      END DO
      RETURN
      END

C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      INTEGER FUNCTION IGSCAN (PMAT, KNWE, KNNS, KSCAN, OINFIELD,
     1   KPR, KERR)
C
C---->
C**** *IGSCAN*
C
C     PURPOSE
C     _______
C
C     Transform a regular field between the specified external
C     scanning mode and a standard internal scanning mode.
C
C     INTERFACE
C     _________
C
C     IERR = IGSCAN (PMAT, KNWE, KNNS, KSCAN, OINFIELD, KPR, KERR)
C
C     Input parameters
C     ________________
C
C     PMAT       - The input matrix of dimension (KNWE * KNNS).
C
C     KNWE       - The number of points in the West-East direction.
C
C     KNNS       - The number of points in the North-South direction.
C
C     KSCAN      - A standard GRIB byte variable with bits 1 to 3
C                  separately significant. This means that the final
C                  value is the sum of the bit settings.
C
C                  128 , Set if points scan East to West.
C                   64 , Set if points scan South to North.
C                   32 , Set if points in the North South direction
C                        are consecutive.
C
C     OINFIELD   - Flag variable which is TRUE for an input field and
C                  FALSE for an output field.
C                  This determines the order in which the
C                  transformations are applied.
C
C     KPR        - The debug print switch.
C                  0  , No debugging output.
C                  1  , Produce debugging output.
C
C     KERR       - The error control flag.
C                  -ve, No error message. Return error code.
C                  0  , Hard failure with error message.
C                  +ve, Print error message. Return error code.
C
C     Output parameters
C     ________________
C
C     PMAT       - The transposed matrix.
C
C     Return value
C     ____________
C
C     The error indicator (INTEGER).
C
C     Error and Warning Return Values
C     _______________________________
C
C     7101  The scanning mode was not in the range 0 to 255.
C
C     Common block usage
C     __________________
C
C     None
C
C     EXTERNALS
C     _________
C
C     ABORTX     - Standard routine to kill task.
C     IGTRAN	 - Routine to transpose a rectangular matrix.
C     IGLREV     - Routine to reverse the elements within each row or
C                  each column of a rectangular matrix.
C     INTLOG     - Logs messages.
C
C     METHOD
C     ______
C
C     KSCAN = 128 is implemented by swapping elements within each
C                 column of the matrix.
C
C     KSCAN = 64 is implemented by reversing the order of the columns.
C
C     KSCAN = 32 is implemented by transposing the matrix.
C
C     An input matrix is transposed before the two reversal stages
C     are performed.
C
C     An output matrix has the matrix transposition as the final step.
C
C     REFERENCE
C     _________
C
C     None
C
C     COMMENTS
C     ________
C
C     Program contains sections 0 to 3 and 9
C
C     AUTHOR
C     ______
C
C     K. Fielding      *ECMWF*      Jan 1994
C
C     MODIFICATIONS
C     _____________
C
C     None
C
C----<
C     _______________________________________________________
C
C
C*    Section 0. Definition of variables.
C     _______________________________________________________
C
C*    Prefix conventions for variable names
C
C     Logical      L (but not LP), global or common.
C                  O, dummy argument
C                  G, local variable
C                  LP, parameter.
C     Character    C, global or common.
C                  H, dummy argument
C                  Y (but not YP), local variable
C                  YP, parameter.
C     Integer      M and N, global or common.
C                  K, dummy argument
C                  I, local variable
C                  J (but not JP), loop control
C                  JP, parameter.
C     REAL         A to F and Q to X, global or common.
C                  P (but not PP), dummy argument
C                  Z, local variable
C                  PP, parameter.
C
C     Implicit statement to force declarations
C
      IMPLICIT NONE
C
#include "parim.h"
C
C     Dummy arguments
C
      LOGICAL OINFIELD
C
      INTEGER KNWE, KNNS, KSCAN, KPR, KERR
C
      REAL PMAT (KNWE * KNNS)
C
C     Local variables
C
      LOGICAL GNSMOD, GWEMOD, GTRMOD
C
      INTEGER ISCAN, IDIR, IERR
C
      INTEGER JPMOVE
      PARAMETER (JPMOVE = (JPLAT + JPLONG) / 2)
C
      INTEGER IMOVE (JPMOVE)
C
      INTEGER JPROUTINE
C
      PARAMETER (JPROUTINE = 7100)
C
C     External functions
C
      INTEGER IGTRAN, IGLREV
C
C     _______________________________________________________
C
C
C*    Section 1. Initialisation - Evaluate scan modes
C     _______________________________________________________
C
  100 CONTINUE
C
      IF (KPR .GE. 1) CALL INTLOG(JP_DEBUG,'IGSCAN: Section 1.',JPQUIET)
C
      IGSCAN = 0
C
      IF (KPR .GE. 1) THEN
         CALL INTLOG(JP_DEBUG,'IGSCAN: Input parameters',JPQUIET)
         CALL INTLOG(JP_DEBUG,'IGSCAN: Longitude points are ',KNWE)
         CALL INTLOG(JP_DEBUG,'IGSCAN: Latitude lines are ',KNNS)
         CALL INTLOG(JP_DEBUG,'IGSCAN: Scan mode is ',KSCAN)
         IF ( OINFIELD ) THEN
           CALL INTLOG(JP_DEBUG,
     X       'IGSCAN: Input field transformation is TRUE',JPQUIET)
         ELSE
           CALL INTLOG(JP_DEBUG,
     X       'IGSCAN: Input field transformation is FALSE',JPQUIET)
         ENDIF
      ENDIF
C
      IF (KSCAN .LT. 0 .OR. KSCAN .GE. 256) THEN
         IGSCAN = JPROUTINE + 1
         IF (KERR .GE. 0) CALL INTLOG(JP_ERROR,
     X    'IGSCAN: Scan mode is not in range 0 to 255 = ',KSCAN)
         IF (KERR .EQ. 0) CALL INTLOG(JP_FATAL,
     X    'IGSCAN: Interpolation fails.',IGSCAN)
         GO TO 900
      ENDIF
C
C     Zero KSCAN means no transformation
C
      IF (KSCAN .EQ. 0) GO TO 900
C
      ISCAN = KSCAN
      GWEMOD = .FALSE.
      GNSMOD = .FALSE.
C
      IF (ISCAN .GE. 128) THEN
         ISCAN = ISCAN - 128
         GWEMOD = .TRUE.
      ENDIF
C
      IF (ISCAN .GE. 64) THEN
         ISCAN = ISCAN - 64
         GNSMOD = .TRUE.
      ENDIF
C
      GTRMOD = ISCAN .GE. 32
C
C     _______________________________________________________
C
C*    Section 2. Input field
C
C                Potential operations in order are
C
C                1 Transpose matrix
C                2 Modify West East mode
C                3 Modify North South mode
C     _______________________________________________________
C
  200 CONTINUE
C
      IF (KPR .GE. 1) CALL INTLOG(JP_DEBUG,'IGSCAN: Section 2.',JPQUIET)
C
      IF (OINFIELD) THEN
C
         IF (GTRMOD) THEN
C
            IERR = IGTRAN (PMAT, KNNS, KNWE, IMOVE, JPMOVE, KPR, KERR)
C
            IF (IERR .NE. 0) THEN
               IGSCAN = IERR
               GO TO 900
            ENDIF
C
         ENDIF
C
         IF (GWEMOD) THEN
C
            IDIR = 1
C
            IERR = IGLREV (PMAT, KNWE, KNNS, IDIR, KPR, KERR)
C
            IF (IERR .NE. 0) THEN
               IGSCAN = IERR
               GO TO 900
            ENDIF
C
         ENDIF
C
         IF (GNSMOD) THEN
C
            IDIR = 2
C
            IERR = IGLREV (PMAT, KNWE, KNNS, IDIR, KPR, KERR)
C
            IF (IERR .NE. 0) THEN
               IGSCAN = IERR
               GO TO 900
            ENDIF
C
         ENDIF
C
      ELSE
C
C     _______________________________________________________
C
C*    Section 3. Output field
C
C                Potential operations in order are
C
C                1 Modify West East mode
C                2 Modify North South mode
C                3 Transpose matrix
C     _______________________________________________________
C
  300 CONTINUE
C
      IF (KPR .GE. 1) CALL INTLOG(JP_DEBUG,'IGSCAN: Section 3.',JPQUIET)
C
         IF (GWEMOD) THEN
C
            IDIR = 1
C
            IERR = IGLREV (PMAT, KNWE, KNNS, IDIR, KPR, KERR)
C
            IF (IERR .NE. 0) THEN
               IGSCAN = IERR
               GO TO 900
            ENDIF
C
         ENDIF
C
         IF (GNSMOD) THEN
C
            IDIR = 2
C
            IERR = IGLREV (PMAT, KNWE, KNNS, IDIR, KPR, KERR)
C
            IF (IERR .NE. 0) THEN
               IGSCAN = IERR
               GO TO 900
            ENDIF
C
         ENDIF
C
         IF (GTRMOD) THEN
C
            IERR = IGTRAN (PMAT, KNWE, KNNS, IMOVE, JPMOVE, KPR, KERR)
C
            IF (IERR .NE. 0) THEN
               IGSCAN = IERR
               GO TO 900
            ENDIF
C
         ENDIF
C
      ENDIF
C
C     _______________________________________________________
C
C*    Section 9. Return to calling routine. Format statements
C     _______________________________________________________
C
  900 CONTINUE
C
      IF (KPR .GE. 1) CALL INTLOG(JP_DEBUG,'IGSCAN: Section 9.',JPQUIET)
C
      RETURN
      END

C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      INTEGER FUNCTION CHKTAB2 ( KSEC1,
     X                           HFIRST, HSECOND, HTHIRD, HFOURTH)
C
C---->
C**** CHKTAB2
C
C     Purpose
C     -------
C
C     Checks whether or not a parameter appears in a given code
C     table 2 for WMO code FM 92-X Ext. GRIB (WMO standard, ECMWF local,
C     or even local from another centre).
C
C
C     Interface
C     ---------
C
C     IRET = CHKTAB2(KSEC1, HFIRST, HSECOND, HTHIRD, HFOURTH)
C
C     Input
C     -----
C
C     KSEC1  - Section 1 values for a GRIB product.
C
C
C     Output
C     ------
C
C     HFIRST  - First line of descriptor:  MARS mnemonic
C     HSECOND - Second line of descriptor: Parameter description
C     HTHIRD  - Third line of descriptor:  Units for the parameter
C     HFOURTH - Fourth line of descriptor: Description of units
C
C     Function return value is:
C            0 - Parameter found in table
C        20001 - No match found for the parameter number in the given table.
C        20002 - Error opening the file holding the given table.
C        20003 - Error finding an unused fortran unit number for reading table.
C
C
C     Method
C     ------
C
C     Use TAB2FIL to determine file name for code table.
C
C     Entry for each parameter in table has the format (without quotes):
C        "......................"         Separator
C        "051"                            Paramter number
C        "MX2T24"                         MARS mnemonic
C        "Max 2m temp"                    Parameter description
C        "K"                              Units for the parameter
C        "During previous 24 hours"       Further description
C
C     There is a termination "......................" line in the file
C     and there may be lines of comment before the first parameter entry.
C
C     The current parameter definition file is kept open between calls.
C
C
C     Externals
C     ---------
C     TAB2FIL - Builds code table 2 file name.
C
C
C     Author
C     ------
C
C     J.D.Chambers     ECMWF     March 1999
C
C
C     MODIFICATIONS
C     _____________
C
C     J. Clochard, Meteo France, for ECMWF - June 1999.
C     Argument KSEC1 instead of KPARAM and KTABLE for replacement of
C     LOCAL2K, and code tables management.
C     Use TAB2FIL function for file name building.
C
C     _______________________________________________________
C----<
C
C
      IMPLICIT NONE
C
C     Parameters
C
      INTEGER JPROUTINE, JPMAXTB, JPDITB
      PARAMETER ( JPROUTINE = 20000, JPMAXTB = 10, JPDITB = 256 )
C
C     Function arguments
C
      INTEGER KSEC1 (*)
C
      CHARACTER*(*) HFIRST, HSECOND, HTHIRD, HFOURTH
C
C     Local variables
C
      LOGICAL LNEWTAB
      INTEGER TABLE2(JPDITB,JPMAXTB), INDTAB, NUMTAB, LOOP, NEXT
      INTEGER IPR, IRET, ISTATUS, ITABLE, IPARAM, ICENTR
C
      CHARACTER*81 YFIRST(2:JPDITB,JPMAXTB), YSECOND(2:JPDITB,JPMAXTB)
      CHARACTER*81 YTHIRD(2:JPDITB,JPMAXTB), YFOURTH(2:JPDITB,JPMAXTB)
      CHARACTER*256 YFILE, YDUMMY
C
      INTEGER NUNIT
C
      SAVE NUNIT, NUMTAB, TABLE2, YFIRST, YSECOND, YTHIRD, YFOURTH
C
C     External functions
C
      INTEGER TAB2FIL
      EXTERNAL TAB2FIL
C
      DATA NUMTAB/0/
C
C
C ------------------------------------------------------------------
C*    Section 1.   Initialise
C ------------------------------------------------------------------
C
  100 CONTINUE
C
C     See if a new table is requested.
C
      ITABLE = KSEC1(1)
      IF( KSEC1(22).EQ.98 ) THEN
        ICENTR = 98
      ELSE
        ICENTR = KSEC1(2)
      ENDIF
      IPARAM = KSEC1(6)
C
      IF( MAX( ITABLE, IPARAM) .GT. 127 ) THEN
        ITABLE = 1000*ICENTR + ITABLE
      ENDIF
C
      LNEWTAB = .TRUE.
C     print *, 'CHKTAB2: TABLE2(1,:)=', TABLE2(1,:NUMTAB)
      DO LOOP = 1, NUMTAB
        IF( ITABLE.EQ.TABLE2(1,LOOP) ) THEN
          LNEWTAB = .FALSE.
          INDTAB = LOOP
          GOTO 300
        ENDIF
      ENDDO
C
C     Read values in the new table.
C
      IF( LNEWTAB ) THEN
        NUMTAB = NUMTAB + 1
        IF( NUMTAB.GT.JPMAXTB ) NUMTAB = 1
        INDTAB = NUMTAB
        TABLE2(1,INDTAB) = ITABLE
C
        DO LOOP = 2, JPDITB
          TABLE2(LOOP,INDTAB) = 0
        ENDDO
C
C       Find an unused fortran unit number
C
        IPR = 0
        CALL FTN1CR(NUNIT, IPR, IRET)
        IF( IRET.NE.0 ) THEN
          NUMTAB = NUMTAB - 1
          CHKTAB2 = JPROUTINE + 3
          RETURN
        ENDIF
C
C       Build filename
C
        IRET = TAB2FIL( KSEC1(1), IPARAM, ICENTR, YFILE )
C
C       Open file
C
        OPEN(UNIT=NUNIT, FILE=YFILE, ERR=910, IOSTAT=ISTATUS,
     X       STATUS='OLD',FORM='FORMATTED')
        REWIND(UNIT=NUNIT)
C
C ------------------------------------------------------------------
C*    Section 2.   Fill the new parameter table.
C ------------------------------------------------------------------
C
  200   CONTINUE
        NEXT = 1
C
C       Skip lines until '......................' separator found
C
  210   CONTINUE
        READ(NUNIT,'(A)',END=230) YDUMMY
        IF( YDUMMY(1:22).EQ.'......................') GOTO 225
        GOTO 210
C
C       Loop through file
C
  220   CONTINUE
          READ(NUNIT,'(A)',END=230) YDUMMY
  225     CONTINUE
          NEXT = NEXT + 1
          READ(NUNIT,'(I3.3)',END=230) TABLE2(NEXT,INDTAB)
          READ(NUNIT,'(A)',END=230) YFIRST(NEXT,INDTAB)
          READ(NUNIT,'(A)',END=230) YSECOND(NEXT,INDTAB)
          READ(NUNIT,'(A)',END=230) YTHIRD(NEXT,INDTAB)
          READ(NUNIT,'(A)',END=230) YFOURTH(NEXT,INDTAB)
        GOTO 220
C
 230    CONTINUE
C
        CLOSE(UNIT=NUNIT)
C
      ENDIF
C
C ------------------------------------------------------------------
C*    Section 3.   Search for parameter in the table.
C ------------------------------------------------------------------
C
  300 CONTINUE
C
      CHKTAB2 = JPROUTINE + 1
C
      DO LOOP = 2,JPDITB
        IF( IPARAM.EQ.TABLE2(LOOP,INDTAB) ) THEN
          HFIRST = YFIRST(LOOP,INDTAB)
          HSECOND = YSECOND(LOOP,INDTAB)
          HTHIRD = YTHIRD(LOOP,INDTAB)
          HFOURTH = YFOURTH(LOOP,INDTAB)
          CHKTAB2 = 0
          RETURN
        ENDIF
      ENDDO
C
C ------------------------------------------------------------------
C*    Section 9.   Closedown.
C ------------------------------------------------------------------
C
C     Drop through if not found.
C
      RETURN   
C
C     Error opening table file
C
 910  CONTINUE
      TABLE2(1,NUMTAB) = -1
      NUMTAB = NUMTAB - 1
      CHKTAB2 = JPROUTINE + 2
      RETURN
      END

C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      INTEGER FUNCTION WV2DPPP(ISEC2, ISEC4, NLONS, NLATS, STEP,
     X                         OLDWAVE, NEWWAVE, NORTH, WEST, PMISS)
C
C---->
C*****WV2DPPP*
C
C     PURPOSE
C     -------
C
C     Interface routine to call WV2DINT using (inconsistent)
C     GRIB headers in 2D wave spectra fields.
C
C
C     INTERFACE
C     ---------
C
C     IRET = WV2DPPP(ISEC2, ISEC4, NLONS, NLATS, STEP,
C    X               OLDWAVE, NEWWAVE, NORTH, WEST, PMISS)
C
C     Input arguments
C     ---------------
C
C     ISEC2   - Unpacked section 2 header from 2D wave spectra field
C     ISEC4   - Unpacked section 4 header from 2D wave spectra field
C     NLONS   - Number of points E-W in new grid
C     NLATS   - Number of points N-S in new grid
C     STEP    - Output grid resolution (degrees)
C     OLDWAVE - Original wave field
C     NORTH   - Output grid northernmost latitude (degrees)
C     WEST    - Output grid westernmost longitude (degrees)
C     PMISS   - Missing data value 
C
C     Output arguments
C     ----------------

C     NEWWAVE - New wave field
C
C     Function returns 0 if the interpolation was OK.
C
C
C     METHOD
C     ------
C
C     Setes up call to WV2DINT from 2D wave spectra field headers.
C
C
C     EXTERNALS
C     ---------
C
C     None.
C
C
C     REFERENCE
C     ---------
C
C     None.
C
C
C     Author.
C     -------
C
C     J.D.Chambers      ECMWF    November 1996
C
C
C----<
C
      IMPLICIT NONE
C
C     Subroutine arguments
C
      INTEGER ISEC2, ISEC4, NLONS, NLATS
      DIMENSION ISEC2(*), ISEC4(*)
      REAL STEP, OLDWAVE, NEWWAVE, NORTH, WEST, PMISS
      DIMENSION OLDWAVE(*), NEWWAVE(*)
C
C     Parameters
C
      INTEGER JPROUTINE, JPMXLAT
      PARAMETER (JPROUTINE = 19420)
      PARAMETER (JPMXLAT = 361)
C
C     Local arguments
C
      INTEGER NSPEC, MISSLAT, LOOP, NPTS, NUMLATS
      DIMENSION NPTS(JPMXLAT)
C
C     Externals
C
      INTEGER WV2DINT
      EXTERNAL WV2DINT
C
C ---------------------------------------------------------------------
C*    Section 1. Initalisation.
C ---------------------------------------------------------------------
C
  100 CONTINUE
C
      WV2DPPP = 0
C
C     Setup number of spectra at each point
C
      IF( ISEC4(8).EQ.64 ) THEN
        NSPEC = ISEC4(50)*ISEC4(51)
      ELSE
        NSPEC = 1
      ENDIF
C
C     Calculate number of latitudes if grid had been full from
C     North pole to South pole
C
      NUMLATS = (180000/ISEC2(10)) + 1
      IF( NUMLATS.GT.JPMXLAT ) THEN
        WV2DPPP = JPROUTINE + 1
        GOTO 900
      ENDIF
C
C     Fill an array with the number of points at each latitude
C     (this is a reduced latitude/longitude grid)
C
      MISSLAT = (90000 - ISEC2(4))/ISEC2(10)
      DO LOOP = 1, MISSLAT
        NPTS(LOOP) = 0
      ENDDO
      DO LOOP = 1, ISEC2(3)
        NPTS(LOOP+MISSLAT) = ISEC2(22+LOOP)
      ENDDO
      DO LOOP = MISSLAT+ISEC2(3), NUMLATS
        NPTS(LOOP) = 0
      ENDDO
C
C ---------------------------------------------------------------------
C*    Section 2. Do the interpolation.
C ---------------------------------------------------------------------
C
  200 CONTINUE
C
      WV2DPPP = WV2DINT(NUMLATS,NPTS,NLONS,NLATS,STEP,OLDWAVE,
     X                  NEWWAVE,NORTH,WEST,NSPEC,PMISS)
C
C ---------------------------------------------------------------------
C*    Section 9. Closedown.
C ---------------------------------------------------------------------
C
  900 CONTINUE
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE CREXEX(KBUFL,YBUFF,KSUP,KSEC0,KSEC1,KSEC3,
     2                  KELEM,CNAMES,CUNITS,KVALS,VALUES,CVALS,KERR)
C
C**** *CREXEX*
C
C
C     PURPOSE.
C     --------
C          Decode Crex message into fully expanded form; returning
C          information relevant for all CREX sections, expanded values,
C          their names and units.
C
C
C**   INTERFACE.
C     ----------
C
C          *CALL* *CREXEX(KBUFL,YBUFF,KSUP,KSEC0,KSEC1,KSEC3,
C     1                   KELEM,CNAMES,CUNITS,KVALS,VALUES,CVALS,KERR)*
C
C        INPUT :
C               *KBUFL*   -  Length of CREX message (words)
C               *YBUFF*   -  Character string  containing Crex message
C               *KELEM*   -  Integer (expected number of expanded elements)
C               *KVALS*   -  Integer (expected number of data values)
C        OUTPUT:
C               *KSUP*    -  Integer array of 9 words containing
C                            suplementary information
C                         -  KSUP( 1) -- IDIM1, dimension of KSEC1
C                         -  KSUP( 2) -- Reserved
C                         -  KSUP( 3) -- IDIM3, dimension of KSEC3
C                         -  KSUP( 4) -- Reserved
C                         -  KSUP( 5) -- M (number of elements in values
C                                           array, first index)
C                         -  KSUP( 6) -- N (number of subsets,second index
C                                           of values array)
C                         -  KSUP( 7) -- JVC (number of elements in CVAL array)
C                         -  KSUP( 8) -- total CREX message length in bytes
C                         -  KSUP( 9) -- IDIM0, dimension of KSEC0
C
C               *KSEC0*   -  Integer array of 3 words containing
C                            CREX section 0 information
C                            KSEC0( 1)-- length of section 0 (bytes)
C                            KSEC0( 2)-- total length of CREX message (bytes)
C                            KSEC0( 3)-- CREX Edition number
C
C               *KSEC1*   -  Integer array of at least 40 words
C                            containing CREX section 1 information
C                            KSEC1( 1)-- Reserved
C                            KSEC1( 2)-- CREX Edition number
C                            KSEC1( 3)-- Reserved
C                            KSEC1( 4)-- Reserved
C                            KSEC1( 5)-- Reserved
C                            KSEC1( 6)-- CREX message type
C                            KSEC1( 7)-- Reserved
C                            KSEC1( 8)-- version number of local table used
C                            KSEC1( 9)-- Reserved
C                            KSEC1(10)-- Reserved
C                            KSEC1(11)-- Reserved
C                            KSEC1(12)-- Reserved
C                            KSEC1(13)-- Reserved
C                            KSEC1(14)-- CREX Master table
C                            KSEC1(15)-- version number of Master table used
C                            KSEC1(16) - KSEC1(40) -- Reserved
C
C                            Crex Edition 2
C
C               *KSEC1*   -  Integer array of at least 40 words
C                            containing CREX section 1 information
C                            KSEC1( 1)-- Reserved
C                            KSEC1( 2)-- CREX Edition number
C                            KSEC1( 3)-- Originating Centre ( oooo)
C                            KSEC1( 4)-- Update sequence number (uu)
C                            KSEC1( 5)-- Number of subsets (sss)
C                            KSEC1( 6)-- CREX data category (nnn)
C                            KSEC1( 7)-- International data sub-category (mmm)
C                            KSEC1( 8)-- version number of local table used
C                            KSEC1( 9)-- Year (yyyy)
C                            KSEC1(10)-- Month (mm)
C                            KSEC1(11)-- Day (dd)
C                            KSEC1(12)-- Hour (hh)
C                            KSEC1(13)-- Minute (mm)
C                            KSEC1(14)-- CREX Master table (tt)
C                            KSEC1(15)-- version number of Master table used (vv)
C                            KSEC1(16)-- Originating sub-centre (ppp)
C                            KSEC1(17)-- Bufr master table version number
C                            KSEC1(18)-- Bufr version number of local table used
C                            KSEC1(19) - KSEC1(40) -- Reserved
C
C
C               *KSEC3*   -  Integer array of 4 words containing
C
C                            KSEC3( 1)-- Reserved
C                            KSEC3( 2)-- Reserved
C                            KSEC3( 3)-- number of subsets
C                            KSEC3( 4)-- Reserved
C
C
C               *CNAMES*  -  Character*64  array of KELEM containing
C                            CREX Table B element names
C               *CUNITS*  -  Character*24 array of KELEM containig
C                            CREX Table B units
C               *VALUES*  -  Real*8 array of KVALS containing expanded
C                            data values
C               *CVALS*   -  Character*80 array of KVALS containing
C                            CREX code table or CCITTIA5 CREX elements
C                            entries
C               *KERR*    -  returned error code
C
C
C     METHOD.
C     -------
C
C          Crex message passed as argument to this routine is decoded
C          section by section. Suplementary information and expanded data
C          are returned as well as error code.
C
C
C     EXTERNALS.
C     ----------
C
C
C     REFERENCE.
C     ----------
C
C          NONE.
C
C     AUTHOR.
C     -------
C
C          MILAN DRAGOSAVAC    *ECMWF*       07/01/2004.
C
C
C     MODIFICATIONS.
C     --------------
C
C          NONE.
C
C
      IMPLICIT LOGICAL(L,O,G), CHARACTER*8(C,H,Y)
C
C
      PARAMETER(JSUP =   9,JSEC0=   3,JSEC1= 40,JSEC2= 64 ,JSEC3=    4,
     1          JSEC4=   2,JELEM=40000,JSUBS=400,JCVAL=150 ,JBUFL=40000,
     2          JBPW =  32,JTAB =3000,JCTAB=120,JCTST=1800,JCTEXT= 200,
     3          JWORK=360000,JKEY=46)
C
C
      DIMENSION KSUP(JSUP),KSEC0(JSEC0),KSEC1(JSEC1)
      DIMENSION KSEC3(JSEC3)
C
      COMMON /CREXOFF/ NSIZEG(JELEM),NCREXWTRG(JWORK),
     1                 NBP,NSUBSET,OMULTI
C
      REAL*8 VALUES(KVALS)
C
      CHARACTER*64 CNAMES(KELEM)
      CHARACTER*24 CUNITS(KELEM)
      CHARACTER*80 CVALS(KVALS)
C
      CHARACTER*(*) YBUFF
C
      CHARACTER*4 CECMWF
C
C     ------------------------------------------------------------------
C
C*          1.   SET CONSTANTS.
C                --------------
 100  CONTINUE
C
      KERR=0
C
      M0=1
C
      DO 101 I=1,JSEC0
      KSEC0(I)=0
 101  CONTINUE
C
      DO 102 I=1,JSEC1
      KSEC1(I)=0
 102  CONTINUE
C
      DO 103 I=1,JSEC3
      KSEC3(I)=0
 103  CONTINUE
C
      DO 104 I=1,JSUP
      KSUP(I)=0
 104  CONTINUE
C
C
      CALL CREXINIT(KBUFL,KERR)
C
C     -----------------------------------------------------------------
C*          2.  EXPAND SECTION 0.
C               -----------------
 200  CONTINUE
C
      CALL CREXS0( KBUFL,YBUFF,KSUP,KSEC0,KERR )
      IF(KERR.GT.0) RETURN
C
C     ------------------------------------------------------------------
C*          3.   EXPAND SECTION 1. 
C                ------------------
 300  CONTINUE
C
      CALL CREXS1( KBUFL,YBUFF,KSUP,KSEC0,KSEC1,KERR )
      IF(KERR.GT.0) RETURN
C
C     ------------------------------------------------------------------
C*          4.   LOAD CREX TABLES.
C                -----------------
 400  CONTINUE
C
      CALL CREXTB(KSEC1,KERR)
      IF(KERR.GT.0) RETURN
C
C     ------------------------------------------------------------------
C*          5.  EXPAND SECTION 2.
C               -----------------
 500  CONTINUE
C
      OMULTI=.TRUE.
      NSUBSET=0
C
      DO WHILE(OMULTI)
C
      NSUBSET=NSUBSET+1
C
      CALL CREXS2(KBUFL,YBUFF,KSUP,KSEC3,KELEM,CNAMES,CUNITS,KERR)
      IF(KERR.GT.0) RETURN
C
C     ------------------------------------------------------------------
C
      CALL CREXS2DATA(KBUFL ,YBUFF ,KSUP  ,KSEC3,
     1            KELEM ,CNAMES,CUNITS,KVALS,VALUES,CVALS,KERR)
      IF(KERR.GT.0) RETURN
C
      END DO
C
C     ------------------------------------------------------------------
C*          6.   EXPAND SECTION 3.
C                -----------------
 600  CONTINUE
C
      CALL CREXS5(KBUFL,YBUFF,KERR)
      IF(KERR.GT.0) RETURN
C
C     -----------------------------------------------------------------
      RETURN
C
      END

C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE JMAKLL( KUNIT, KTRUNC, PINTVL, PLAT, PLEG, KRET)
C
C---->
C**** JMAKLL
C
C     PURPOSE
C     _______
C
C     This routine creates legendre functions for latitude rows upto
C     the given latitude in a 'non-standard truncation/interval' file.
C
C     INTERFACE
C     _________
C
C     CALL JMAKLL( KUNIT, KTRUNC, PINTVL, PLAT, PLEG, KRET)
C
C     Input parameters
C     ________________
C
C     KUNIT   - Unit number for open file of legendre functions.
C     KTRUNC  - Truncation.
C     PINTVL  - Grid interval (degrees)
C     PLAT    - Latitude in degrees.
C
C     Output parameters
C     ________________
C
C     PLEG     - Array of legendre functions for the latitude.
C     KRET     - Return status code
C                0 = OK
C
C     Common block usage
C     __________________
C
C     JDCNDBG
C
C     Method
C     ______
C
C     Determine which functions already exist for the latitude rows
C     in the file, skip to the end and create necessary extra functions
C     and add to the file.
C
C     Externals
C     _________
C
C     PBSEEK    - Position the coefficients file
C     PBWRITE   - Write the coefficients file
C     INTLOG   - Output log message
C     INTLOGR  - Output log message (with real value)
C
C     Reference
C     _________
C
C     None.
C
C     Comments
C     ________
C
C     Only positive latitude values are allowed.
C
C     AUTHOR
C     ______
C
C     J.D.Chambers      *ECMWF*      Dec 1993
C
C     MODIFICATIONS
C     _____________
C
C     None.
C
C----<
C     _______________________________________________________
C
C
C*    Section 0. Definition of variables.
C     _______________________________________________________
C
C*    Prefix conventions for variable names
C
C     Logical      L (but not LP), global or common.
C                  O, dummy argument
C                  G, local variable
C                  LP, parameter.
C     Character    C, global or common.
C                  H, dummy argument
C                  Y (but not YP), local variable
C                  YP, parameter.
C     Integer      M and N, global or common.
C                  K, dummy argument
C                  I, local variable
C                  J (but not JP), loop control
C                  JP, parameter.
C     REAL         A to F and Q to X, global or common.
C                  P (but not PP), dummy argument
C                  Z, local variable
C                  PP, parameter.
C
      IMPLICIT NONE
C
#include "jparams.h"
#include "parim.h"
C
C     Parameters
      INTEGER JPROUTINE
      PARAMETER ( JPROUTINE = 30500 )
C
C     Subroutine arguments
      INTEGER KUNIT, KTRUNC, KRET
      REAL PLEG, PINTVL, PLAT
      DIMENSION PLEG(*)
C
C     Local variables
C
c      INTEGER*8 NEWPOS, NSIZE, NRET
      INTEGER NEWPOS, NSIZE, NRET
      INTEGER NROWCT, NBYTES

      REAL ZLATEST, ZLATIT, ZLAT, ALAT, PIBY2, DEG2RAD
      INTEGER NEXT, FIRST, LAST
C
C     _______________________________________________________
C
C*    Section 1.    Initialization.
C     _______________________________________________________
C
 100  CONTINUE
C
      IF( NDBG.GT.1 ) THEN
        CALL INTLOG(JP_DEBUG,'JMAKLL: Input parameters:',JPQUIET)
        CALL INTLOG(JP_DEBUG,
     X    'JMAKLL: Unit number for leg.funcs file =', KUNIT)
        CALL INTLOG(JP_DEBUG,'JMAKLL: Truncation = ', KTRUNC)
        CALL INTLOGR(JP_DEBUG,
     X    'JMAKLL: Grid interval (degrees) = ', PINTVL)
        CALL INTLOGR(JP_DEBUG,
     X    'JMAKLL: Latitude in degrees = ', PLAT)
      ENDIF
C
      IF( PLAT.LT.0.0 ) THEN
        ZLAT = 0.0
      ELSE
        ZLAT = PLAT
      ENDIF
C
C     Calculate the byte offset into the file where the legendre 
C     functions for the latitude should be.
C
#ifdef REAL_8
      NSIZE   = 8 * (KTRUNC+1)*(KTRUNC+4)/2
#else
      NSIZE   = 4 * (KTRUNC+1)*(KTRUNC+4)/2
#endif
      NEWPOS = NINT( (90.0 - ZLAT)/PINTVL ) * NSIZE
C
C     Find the current file length
C
      CALL PBSEEK( KUNIT, 0, 2, NRET)
      IF( NRET.LT.0 ) THEN
        CALL INTLOG(JP_ERROR,'JMAKLL: PBSEEK error',NRET)
	KRET = JPROUTINE + 2
	GOTO 990
      ENDIF
C
C     Use the length to determine how many rows have already been
C     put into the file
C
      NROWCT = NRET/NSIZE
      ZLATEST  = 90.0 - REAL(NROWCT) * PINTVL
C
      IF( NDBG .GT.1 ) THEN
        CALL INTLOG(JP_DEBUG,'JMAKLL: File length on open = ', NRET)
        CALL INTLOG(JP_DEBUG,
     X    'JMAKLL: Number of rows already in file = ', NROWCT)
        CALL INTLOGR(JP_DEBUG,
     X    'JMAKLL: Next latitude to go in file = ', ZLATEST)
      ENDIF
C
C     _______________________________________________________
C
C*    Section 2.    Processing.
C     _______________________________________________________
C
C     Loop through latitudes not in the file yet
C
#ifdef REAL_8
      NBYTES = (KTRUNC+1)*(KTRUNC+4)/2  * 8
#else
      NBYTES = (KTRUNC+1)*(KTRUNC+4)/2  * 4
#endif
C
      IF( NDBG.GT.1 )
     X  CALL INTLOG(JP_DEBUG,'JMAKLL: No. of bytes per row = ', NBYTES)
C
      PIBY2   = PPI / 2.0
      DEG2RAD = PPI / 180.0
C
      FIRST = NINT(ZLATEST/PINTVL)
      LAST  = NINT(ZLAT/PINTVL)
      DO NEXT = FIRST, LAST, -1
        ALAT = (NEXT*PINTVL) * DEG2RAD
C
        IF( NDBG.GT.1 ) CALL INTLOGR(JP_DEBUG,
     X    'JMAKLL: Next latitude constructed = ', (NEXT*PINTVL))
C
        CALL JSPLEG1( PLEG, ALAT, KTRUNC)
        CALL PBWRITE( KUNIT, PLEG, NBYTES, NRET)
        IF( NRET.LT.NSIZE ) THEN
          CALL INTLOG(JP_ERROR,'JMAKLL: PBWRITE error.', NRET)
          CALL INTLOG(JP_ERROR,'JMAKLL: bytes required = ', NSIZE)
	  KRET = JPROUTINE + 3
	  GOTO 990
	ENDIF
      ENDDO
C     _______________________________________________________
C
C*    Section 9. Return to calling routine. Format statements
C     _______________________________________________________
C
 900  CONTINUE
      KRET = 0
C
 990  CONTINUE
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      INTEGER FUNCTION INTUVS( KVGRIB, KDGRIB, INLEN,
     X                         KUGRIBO, KVGRIBO, OUTLEN)
C
C---->
C**** INTUVS
C
C     Purpose
C     -------
C
C     Convert GRIB format input vorticity and divergence field to
C     GRIB format U and V fields.
C
C
C     Interface
C     ---------
C
C     IRET = INTUVS( KVGRIB, KDGRIB, INLEN, KUGRIBO,KVGRIBO,OUTLEN)
C
C     Input
C     -----
C
C     KVGRIB - Input vorticity field  (spectral, GRIB format).
C     KDGRIB - Input divergence field (spectral, GRIB format).
C     INLEN  - Input field length (words).
C
C
C     Output
C     ------
C
C     KUGRIBO - Output U field (GRIB format).
C     KVGRIBO - Output V field (GRIB format).
C     OUTLEN  - Output field length (words).
C
C
C     Method
C     ------
C
C     Convert spectral vorticity/divergence to spectral U/V without
C     subsequent interpolation.
C
C     Note that a common block is used in intf.h to hold the U/V
C     fields before interpolation.
C
C     Externals
C     ---------
C
C     INTUVP - Now does all the work!
C     INTLOG - Log error message.
C
C
C     Author
C     ------
C
C     J.D.Chambers     ECMWF     Feb 1995
C
C     J.D.Chambers     ECMWF        Feb 1997
C     Allow for 64-bit pointers
C
C     J.D.Chambers     ECMWF     February 2001
C     Replace code by a call to intuvp.
C
C----<
C     -----------------------------------------------------------------|
C
      IMPLICIT NONE
C
C     Function arguments
C
      INTEGER KVGRIB(*), KDGRIB(*), INLEN
      INTEGER KUGRIBO(*), KVGRIBO(*), OUTLEN
C
#include "parim.h"
#include "nifld.common"
#include "nofld.common"
#include "grfixed.h"
#include "intf.h"
C
C     Parameters
C
      INTEGER JPROUTINE
      PARAMETER (JPROUTINE = 26900 )
C
C     Local variables
C
      INTEGER IHOLD1, IHOLD2, IHOLD3
      LOGICAL LHOLD4
C
C     Externals
C
      INTEGER INTUVP
C
C     -----------------------------------------------------------------|
C*    Section 1.   Initialise
C     -----------------------------------------------------------------|
C
  100 CONTINUE
C
C     -----------------------------------------------------------------|
C*    Section 2.   Unpack the vorticity/divergence fields.
C     -----------------------------------------------------------------|
C
  200 CONTINUE
C
C     Ensure output representation says 'spectral, no rotation'
C
      IHOLD1    = NOREPR
      NOREPR    = JPSPHERE
      IHOLD2    = NOROTA(1)
      IHOLD3    = NOROTA(2)
      NOROTA(1) = -9000000
      NOROTA(2) = 0.0
      LHOLD4    = LNOROTA
      LNOROTA   = .FALSE.
C
      INTUVS =
     X  INTUVP(KVGRIB,KDGRIB,INLEN,KUGRIBO,KVGRIBO,OUTLEN)
C
C     Restore output representation
C
      NOREPR    = IHOLD1
      NOROTA(1) = IHOLD2
      NOROTA(2) = IHOLD3
      LNOROTA   = LHOLD4
C
C     -----------------------------------------------------------------|
C*    Section 9.   Closedown.
C     -----------------------------------------------------------------|
C
  900 CONTINUE
C
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C


      SUBROUTINE PRTBL2 (IB2PAR)
C
C---->
C*
C*    NAME      : PRTBL2
C*
C*    FUNCTION  : PRINT THE INFORMATION IN THE GRDI DEFINITION
C*                BLOCK (BLOCK 2) OF DECODED GRIB DATA.
C*
C*    INPUT     : IB2PAR - ARRAY OF DECODED PARAMETERS FROM BLOCK 2.
C*
C*    JOHN HENNESSY  ECMWF 28 MAY 1985
C*
C*
C     ---------------------------------------------------------------
C----<
C
      DIMENSION IB2PAR(*)
C
      WRITE (*,9000)
 9000 FORMAT (1H0,'BLOCK 2 - GRID DEFINITION BLOCK',/)
C
      WRITE (*,9001) IB2PAR(1)
 9001 FORMAT (1H0,'DATA REPRESENTATION TYPE (TABLE 6)   ',I9)
C
C     SPHERICAL HARMONIC DATA
C
      IF (IB2PAR(1).EQ.50)
     C   THEN
C
             WRITE (*,9002) IB2PAR(2)
 9002        FORMAT (1H ,'J - PENTAGONAL RESOLUTION PARAMETER. ',I9)
             WRITE (*,9003) IB2PAR(3)
 9003        FORMAT (1H ,'K - PENTAGONAL RESOLUTION PARAMETER. ',I9)
             WRITE (*,9004) IB2PAR(4)
 9004        FORMAT (1H ,'M - PENTAGONAL RESOLUTION PARAMETER. ',I9)
             WRITE (*,9005) IB2PAR(5)
 9005        FORMAT (1H ,'REPRESENTATION TYPE (TABLE 9)        ',I9)
             WRITE (*,9006) IB2PAR(6)
 9006        FORMAT (1H ,'REPRESENTATION MODE (TABLE 10).      ',I9)
C
             RETURN
C
         ENDIF
C
C     GAUSSIAN AND REGULAR LATITUDE / LONGITUDE GRIDS.
C
      IF (IB2PAR(1).EQ.0.OR.IB2PAR(1).EQ.4)
     C   THEN
C
             WRITE (*,9102) IB2PAR(2)
 9102        FORMAT (1H ,'NO. OF POINTS ALONG A LATITUDE.      ',I9)
             WRITE (*,9103) IB2PAR(3)
 9103        FORMAT (1H ,'NO. OF POINTS ALONG A MERIDIAN.      ',I9)
             WRITE (*,9104) IB2PAR(4)
 9104        FORMAT (1H ,'LATITUDE OF ORIGIN (SOUTH -IVE)      ',I9)
             WRITE (*,9105) IB2PAR(5)
 9105        FORMAT (1H ,'LONGITUDE OF ORIGIN (WEST -IVE)      ',I9)
             WRITE (*,9106) IB2PAR(6)
 9106        FORMAT (1H ,'EXTREME POINT / INCREMENTS FLAG.     ',I9)
             WRITE (*,9107) IB2PAR(7)
 9107        FORMAT (1H ,'LATITUDE OF EXTREME POINT(SOUTH -IVE)',I9)
             WRITE (*,9108) IB2PAR(8)
 9108        FORMAT (1H ,'LONGITUDE OF EXTREME POINT(WEST -IVE)',I9)
             WRITE (*,9109) IB2PAR(9)
 9109        FORMAT (1H ,'LATITUDE INCREMENT.                  ',I9)
             IF (IB2PAR(1).EQ.0)
     C          THEN
                    WRITE (*,9110) IB2PAR(10)
 9110               FORMAT(1H ,'LONGITUDE INCREMENT.                 ',
     C                         I9)
                ENDIF
             IF (IB2PAR(1).EQ.4)
     C          THEN
                    WRITE (*,8110) IB2PAR(10)
 8110               FORMAT(1H ,'NO. OF LATITUDE LINES POLE / EQUATOR.',
     C                         I9)
                ENDIF
             WRITE (*,9111) IB2PAR(11)
 9111        FORMAT (1H ,'SCANNING MODE (CODE TABLE 8).        ',I9)
C
             RETURN
C
         ENDIF
C
      END

C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE BUSEL2(KSUBSET,KELEM,KTDLEN,KTDLST,KTDEXL,KTDEXP,
     1                  CNAMES,CUNITS,KERR)
C
C**** *BUSEL2*
C
C
C     PURPOSE.
C     --------
C          RETURNS LIST OF DATA DESCRIPTORS AS IN SECTION 3  OF BUFR
C          MESSAGE AND TOTAL/REQUESTED LIST OF ELEMENTS, NAMES, UNITS.
C
C
C**   INTERFACE.
C     ----------
C
C          *CALL* *BUSEL2(KSUBSET,KTDLEN,KTDLST,KTDEXL,KTDEXP,CNAMES,
C                         CUNITS,CVALS,KERR)*
C
C
C        OUTPUT:
C               *KTDLEN*  -  NUMBER OF DATA DESCRIPTORS IN SECTION 3
C               *KTDLST*  -  ARRAY CONTAINING DATA DESCRIPTORS IN SECTION 3
C               *KTDEXL*  -  NUMBER OF ENTRIES IN LIST OF EXPANDED DATA
C                            DESCRIPTORS
C               *KTDEXP*  -  ARRAY CONTAINIG EXPANDED DATA DESCRIPTORS
C               *CNAMES*  -  ARRAY CONTAINING ELEMENT NAMES
C               *CUNITS*  -  ARRAY CONTAINING ELEMENT UNITS
C               *KERR*    -  RETURNED ERROR CODE
C
C
C     METHOD.
C     -------
C
C          NONE.
C
C     EXTERNALS.
C     ----------
C
C          NONE.
C
C     REFERENCE.
C     ----------
C
C          NONE.
C
C     AUTHOR.
C     -------
C
C          M. DRAGOSAVAC    *ECMWF*       15/01/2006.
C
C
C     MODIFICATIONS.
C     --------------
C
C          NONE.
C
C
      IMPLICIT LOGICAL(L,O,G), CHARACTER*8(C,H,Y)
C
C
#     include "parameter.F"
#     include "bcomunit.F"
#     include "bcomel.F"
#     include "bcomoff.F"
C
      DIMENSION  KTDLST(*),KTDEXP(*)
C
      CHARACTER*64 CNAMES(*)
      CHARACTER*24 CUNITS(*)
C
C     -----------------------------------------------------------------

C*          1.  PUT LIST OF ELEMENTS FROM COMMON BLOCK
C               --------------------------------------
C               TO REQUESTED ARRAYS.
C               --------------------
 100  CONTINUE
C
      KERR=0
C
      KTDLEN=NTDLEN
C
      DO 101 I=1,NTDLEN
      KTDLST(I)=NTDLST(I)
 101  CONTINUE
C
      IF(OMULTI) THEN
         NTDEXL=NSIZE(KSUBSET)
         KTDEXL=NTDEXL
         IJ=(KSUBSET-1)*KELEM
      ELSE
         NTDEXL=NSIZE(1)
         KTDEXL=NTDEXL
         IJ=0
      END IF

C
      DO 102 I=1,NTDEXL
      IIJ=I+IJ
      KTDEXP(I)=NWTRG(IIJ)
      CALL GET_NAME_UNIT(KTDEXP(I),CNAMES(I),CUNITS(I))
 102  CONTINUE
C
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      INTEGER FUNCTION RESET_C(KSEC1,KSEC2,PSEC2,KSEC4)
C
C---->
C***  RESET_C
C
C     Purpose
C     -------
C
C     Reset interpolation common block variables according to the
C     GRIB sections 1, 2 and 4 values.
C 
C
C     Interface
C     ---------
C
C     IRET = RESET_C(KSEC1,KSEC2,PSEC2,KSEC4)
C
C
C     Input
C     -----
C
C     KSEC1   - GRIB section 1 array (integers).
C     KSEC2   - GRIB section 2 array (integers).
C     PSEC2   - GRIB section 2 array (reals).
C     KSEC4   - GRIB section 4 array (integers).
C
C
C     Externals
C     ---------
C
C     IGGLAT  - Computes gaussian latitudes for a given truncation.
C
C
C     Modifications
C     -------------
C
C     None.
C
C
C     Author
C     ------
C
C     J.D.Chambers          ECMWF    August, 1994
C
C----<
C
      IMPLICIT NONE
#include "parim.h"
#include "nifld.common"
#include "nofld.common"
#include "grfixed.h"
#include "current.h"
C
C     Function arguments
C
      INTEGER KSEC1, KSEC2, KSEC4
      DIMENSION KSEC1(*), KSEC2(*), KSEC4(*)
      REAL PSEC2
      DIMENSION PSEC2(*)
C
C     Local variables
C
      INTEGER JJPR, JJERR, ITEMP
      INTEGER I, IRET
      LOGICAL LSAME, LPQUASI
      CHARACTER*1 HTYPE
C
C     Externals
C
      INTEGER IGGLAT
      EXTERNAL IGGLAT
C
C-----------------------------------------------------------------------
C     Section 1.   Initialise
C-----------------------------------------------------------------------
C
  100 CONTINUE
C
      RESET_C = 0
C
      LPQUASI = ( KSEC2(17).EQ.1 )
C
C     Section 1, Word 1 - version number of WMO code table
C
      IF( NITABLE.NE.KSEC1(1) ) LCHANGE = .TRUE.
      NITABLE = KSEC1(1)
      IF( .NOT.LNOTABL ) NOTABLE = NITABLE
C
C     Section 1, Word 6 - parameter indicator (Code Table 2)
C
      NIPARAM = KSEC1(6)
      IF( .NOT.LNOPARA ) NOPARAM = NIPARAM
C
C     Section 1, Word 7 - Type of level indicator (Code Table 3)
C
      NILEVT = KSEC1(7)
      IF( .NOT.LNOLEVT ) NOLEVT = NILEVT
C
C     By default, upper air level does not use land-sea mask.
C     (pressure level, sigma_level, model level, missing level)
C
      IF( (NOLEVT.EQ.100) .OR.
     X    (NOLEVT.EQ.108) .OR.
     X    (NOLEVT.EQ.109) .OR.
     X    (NOLEVT.EQ.255) ) THEN
        LSM     = .FALSE.
        LSMSET  = .TRUE.
        LSMCHNG = .FALSE.
      ELSE
        LSM     = .TRUE.
        LSMSET  = .FALSE.
        LSMCHNG = .TRUE.
      ENDIF
C
C     Section 1, Word 8 - Height or pressure of level (Code Table 3)
C
      NILEVEL = KSEC1(8)
      IF( .NOT.LNOLEVL ) NOLEVEL = NILEVEL
C
C     Setup ECMWF local definition number and stream if applicable
C
      IF( KSEC1(24).EQ.1 ) THEN
        NILOCAL = KSEC1(37)
        NISTREM = KSEC1(40)
      ELSE
        NILOCAL = 0
        NISTREM = 0
      ENDIF
C
C     Section 2, Word   1    Data representation type (Code Table 6).
C
      IF( NIREPR.NE.KSEC2(1) ) THEN
        LCHANGE = .TRUE.
        NIGAUSO = 0
        HIGAUST = 'X'
        IF( .NOT.LNOGAUS ) THEN
          NOGAUSO = 0
          HOGAUST = 'X'
        ENDIF
      ENDIF
      NIREPR = KSEC2(1)
      IF( .NOT.LNOREPR ) NOREPR = NIREPR
C
C     Date of the input field (YYYYMMDD).
C
      NIDATE = (KSEC1(21)-1)*1000000
     X          + KSEC1(10)*10000 + KSEC1(11)*100 + KSEC1(12)
      NODATE = NIDATE
C
C     Stretching factor (if any)
C
      IF( (NIREPR.EQ.JPSTRGG).OR.(NIREPR.EQ.JPSTRSH) ) THEN
        RISTRET = PSEC2(2)
        IF( NIREPR.EQ.NOREPR ) THEN
          IF( NIREPR.EQ.JPSTRGG ) NOREPR = JPGAUSSIAN
          IF( NIREPR.EQ.JPSTRSH ) NOREPR = JPSPHERE
        ENDIF
        IF( NIREPR.EQ.JPSTRGG ) NIREPR = JPGAUSSIAN
        IF( NIREPR.EQ.JPSTRSH ) NIREPR = JPSPHERE
      ELSE
        RISTRET = 0.0
      ENDIF
C
C-----------------------------------------------------------------------
C      Section 2.  Latitude/longitude grid or equidistant cylindrical
C                  or Plate Carree.
C-----------------------------------------------------------------------
C
  200 CONTINUE
C
      IF ( (NIREPR.EQ.JPREGULAR).OR.(NIREPR.EQ.JPREGROT) ) THEN
C
C       Check if quasi-regular lat/long
C
        IF( LPQUASI ) NIREPR = JPREDLL
        IF( .NOT.LNOREPR ) NOREPR = NIREPR
C
        NIRESO  = 0
        NIGAUSS = 0
C
C       Latitude/longitude grid or equidistant cylindrical
C       or Plate Carree.
C
C       Section 2, Word   2    Ni - Number of points along a parallel.
C       Section 2, Word   3    Nj - Number of points along a meridian.
C
        IF( NIREPR.EQ.JPREDLL ) THEN
          NIWE = 0
        ELSE
          IF( NIWE.NE.KSEC2(2) ) LCHANGE = .TRUE.
          NIWE = KSEC2(2)
        ENDIF
C
        IF( NINS.NE.KSEC2(3) ) LCHANGE = .TRUE.
        NINS = KSEC2(3)
C
C       Section 2, Word   4    La1 - Latitude of first grid point.
C       Section 2, Word   5    Lo1 - Longitude of first grid point.
C
        IF( NIAREA(1).NE.(KSEC2(4)*JPMICRO) ) LCHANGE = .TRUE.
        NIAREA(1) = KSEC2(4) * JPMICRO
        IF( NIAREA(2).NE.(KSEC2(5)*JPMICRO) ) LCHANGE = .TRUE.
        NIAREA(2) = KSEC2(5) * JPMICRO
C
C       Section 2, Word   7    La2 - Latitude of last grid point.
C       Section 2, Word   8    Lo2 - Longitude of last grid point.
C
        IF( NIAREA(3).NE.(KSEC2(7)*JPMICRO) ) LCHANGE = .TRUE.
        NIAREA(3) = KSEC2(7) * JPMICRO
        IF( NIAREA(4).NE.(KSEC2(8)*JPMICRO) ) LCHANGE = .TRUE.
        NIAREA(4) = KSEC2(8) * JPMICRO
C
C       Section 2, Word   9    Di - i direction increment.
C       Section 2, Word  10    Dj - j direction increment.
C
        IF( NIREPR.EQ.JPREDLL ) THEN
          NIGRID(1) = 0
        ELSE
          IF( NIGRID(1).NE.(KSEC2(9)*JPMICRO) ) LCHANGE = .TRUE.
          NIGRID(1) = KSEC2(09) * JPMICRO
        ENDIF
C
        IF( NIGRID(2).NE.(KSEC2(10)*JPMICRO) ) LCHANGE = .TRUE.
        NIGRID(2) = KSEC2(10) * JPMICRO
C
C       Section 2, Word  11    Scanning mode flags (Code Table 8).
C
        IF( NISCNM.NE.KSEC2(11) ) LCHANGE = .TRUE.
        NISCNM = KSEC2(11)
C
C       Pick up regular gaussian grid definition if option 'gaussian'
C       used.
C
        IF( NOREPR.EQ.JPNOTYPE ) THEN
          IF( (NOGAUSO.NE.NOGAUSS).OR.(HOGAUST.NE.'F') ) THEN
            HTYPE = 'F'
            CALL JGETGG(NOGAUSS,HTYPE,ROGAUSS,NOLPTS,IRET)
            IF( IRET.NE.0 ) THEN
              CALL INTLOG(JP_ERROR,
     X          'RESET_C: JGETGG failed, NOGAUSS = ',NOGAUSS)
              RESET_C = IRET
              GOTO 900
            ENDIF
            NOGAUSO = NOGAUSS
            HOGAUST = 'F'
          ENDIF
          NOREPR = JPGAUSSIAN
        ENDIF
C
C       If reduced lat/long output and no user specified grid, use
C       input reduced lat/long definition for number of points at
C       each latitude
C
        IF( LPQUASI .AND. (.NOT.LNOREPR ) ) THEN
          NOREDLL = KSEC2(3)
          NONS = NINS
          DO 210 I = 1, NINS
            MILLEN(I) = KSEC2(22 + I)
 210      CONTINUE
          DO 220 I = 1, NONS
            NOLPTS(I) = MILLEN(I)
 220      CONTINUE
        ENDIF
C
C       If reduced lat/long input, read input reduced lat/long definition
C       for number of points at each latitude and set east longitude,
C       unless it is a subarea (eg Mediterranean).
C
        IF( NIREPR.EQ.JPREDLL ) THEN
          DO I = 1, NINS
            MILLEN(I) = KSEC2(22 + I)
          ENDDO
C
C         Calculate east longitude if field is global.
C         Use southern latitude to guess if it is ...
C
          IF( NIAREA(3).LT.0 ) THEN
            ITEMP = 36000000 - 36000000/MILLEN(NINS/2)
            IF( NIAREA(4).NE.ITEMP ) LCHANGE = .TRUE.
            NIAREA(4) = 36000000 - 36000000/MILLEN(NINS/2)
          ENDIF
        ENDIF
C
      ENDIF
C
C-----------------------------------------------------------------------
C      Section 3.  Spherical Harmonic Coefficients.
C-----------------------------------------------------------------------
C
  300 CONTINUE
C
      IF( (NIREPR.EQ.JPSPHERE).OR.
     X    (NIREPR.EQ.JPSTRSH).OR.
     X    (NIREPR.EQ.JPSPHROT) ) THEN
C
        NIGAUSS   = 0
        NIGRID(1) = 0
        NIGRID(2) = 0
C
C       Section 2, Word   2    J - Pentagonal resolution parameter.
C
        IF( NIRESO.NE.KSEC2(2) ) LCHANGE = .TRUE.
        NIRESO = KSEC2(2)
        IF( .NOT.LNORESO ) THEN
          IF( NORESO.NE.NIRESO ) LCHANGE = .TRUE.
          NORESO = NIRESO
        ENDIF
C
C       Pick up regular gaussian grid definition if option 'gaussian'
C       used.
C
        IF( NOREPR.EQ.JPNOTYPE ) THEN
          IF( (NOGAUSO.NE.NOGAUSS).OR.(HOGAUST.NE.'F') ) THEN
            HTYPE = 'F'
            CALL JGETGG(NOGAUSS,HTYPE,ROGAUSS,NOLPTS,IRET)
            IF( IRET.NE.0 ) THEN
              CALL INTLOG(JP_ERROR,
     X          'RESET_C: JGETGG failed, NOGAUSS = ',NOGAUSS)
              RESET_C = IRET
              GOTO 900
            ENDIF
            NOGAUSO = NOGAUSS
            HOGAUST = 'F'
          ENDIF
          NOREPR = JPGAUSSIAN
        ENDIF
C
      ENDIF
C
C-----------------------------------------------------------------------
C      Section 4.  Regular gaussian grid.
C-----------------------------------------------------------------------
C
  400 CONTINUE
C
      IF( (NIREPR.EQ.JPGAUSSIAN) .AND. (.NOT.LPQUASI) ) THEN
C
        NIRESO    = 0
        NIGRID(1) = 0
        NIGRID(2) = 0
C
C       Section 2, Word   2    Ni - Number of points along a parallel.
C       Section 2, Word   3    Nj - Number of points along a meridian.
C
        IF( NIWE.NE.KSEC2(2) ) LCHANGE = .TRUE.
        NIWE = KSEC2(2)
        IF( NINS.NE.KSEC2(3) ) LCHANGE = .TRUE.
        NINS = KSEC2(3)
C
C       Section 2, Word   4    La1 - Latitude of first grid point.
C       Section 2, Word   5    Lo1 - Longitude of first grid point.
C
        IF( NIAREA(1).NE.(KSEC2(4)*JPMICRO) ) LCHANGE = .TRUE.
        NIAREA(1) = KSEC2(4) * JPMICRO
        IF( NIAREA(2).NE.(KSEC2(5)*JPMICRO) ) LCHANGE = .TRUE.
        NIAREA(2) = KSEC2(5) * JPMICRO
C
C       Section 2, Word   7    La2 - Latitude of last grid point.
C       Section 2, Word   8    Lo2 - Longitude of last grid point.
C
        IF( NIAREA(3).NE.(KSEC2(7)*JPMICRO) ) LCHANGE = .TRUE.
        NIAREA(3) = KSEC2(7) * JPMICRO
        IF( NIAREA(4).NE.(KSEC2(8)*JPMICRO) ) LCHANGE = .TRUE.
        NIAREA(4) = KSEC2(8) * JPMICRO
C
C       Section 2, Word  10    N - Number of parallels between Pole and
C                   the Equator.
C
        IF( NIGAUSS.NE.KSEC2(10) ) LCHANGE = .TRUE.
        NIGAUSS = KSEC2(10)
C
C       Pick up gaussian definitions for input grid
C
        IF( (NIGAUSO.NE.NIGAUSS).OR.(HIGAUST.NE.'F') ) THEN
          HTYPE = 'F'
          CALL JGETGG(NIGAUSS,HTYPE,RIGAUSS,MILLEN,IRET)
          IF( IRET.NE.0 ) THEN
            CALL INTLOG(JP_ERROR,
     X        'RESET_C: JGETGG failed, NIGAUSS = ',NIGAUSS)
            RESET_C = IRET
            GOTO 900
          ENDIF
          NIGAUSO = NIGAUSS
          HIGAUST = 'F'
        ENDIF
C
C       Use same gaussian number for output unless user has
C       deliberately set a value
C
        IF( .NOT.LNOGAUS )  THEN
          IF( NOGAUSS.NE.NIGAUSS ) LCHANGE = .TRUE.
          NOGAUSS = NIGAUSS
        ENDIF
C
C       Fixup output type if 'gaussian' used to describe output and
C       not 'reduced' or 'regular'.
C
        LSAME = (NOREPR.EQ.JPNOTYPE) .AND. (NOGAUSS.EQ.NIGAUSS)
C
C       Pick up regular gaussian grid definition corresponding
C       to the input field if option 'gaussian' used.
C
        IF( (NOREPR.EQ.JPNOTYPE).AND.(.NOT.LSAME) ) THEN
          IF( (NOGAUSO.NE.NOGAUSS).OR.(HOGAUST.NE.'F') ) THEN
            HTYPE = 'F'
            CALL JGETGG(NOGAUSS,HTYPE,ROGAUSS,NOLPTS,IRET)
            IF( IRET.NE.0 ) THEN
              CALL INTLOG(JP_ERROR,
     X          'RESET_C: JGETGG failed, NOGAUSS = ',NOGAUSS)
              RESET_C = IRET
              GOTO 900
            ENDIF
            NOGAUSO = NOGAUSS
            HOGAUST = 'F'
          ENDIF
          NOREPR = JPGAUSSIAN
        ENDIF
C
C       Section 2, Word  11    Scanning mode flags (Code Table 8).
C
        IF( NISCNM.NE.KSEC2(11) ) LCHANGE = .TRUE.
        NISCNM = KSEC2(11)
C
      ENDIF
C
C-----------------------------------------------------------------------
C      Section 5.  Quasi-regular (reduced) gaussian grid.
C-----------------------------------------------------------------------
C
  500 CONTINUE
C
      IF( (NIREPR.EQ.JPGAUSSIAN) .AND. LPQUASI ) THEN
C
        NIRESO    = 0
        NIGRID(1) = 0
        NIGRID(2) = 0
C
C       Set representation(s) to "quasi-regular gaussian"
C
        NIREPR = JPQUASI
        IF( .NOT.LNOREPR ) NOREPR = NIREPR
C
C       Section 2, Word   2    Ni - Number of points along a parallel.
C                   Cannot be used for quasi-regular grids.
C       Section 2, Word   3    Nj - Number of points along a meridian.
C
        IF( NIWE.NE.0 ) LCHANGE = .TRUE.
        NIWE = 0
        IF( NINS.NE.KSEC2(3) ) LCHANGE = .TRUE.
        NINS = KSEC2(3)
C
C       Section 2, Word   4    La1 - Latitude of first grid point.
C       Section 2, Word   5    Lo1 - Longitude of first grid point.
C
        IF( NIAREA(1).NE.(KSEC2(4)*JPMICRO) ) LCHANGE = .TRUE.
        NIAREA(1) = KSEC2(4) * JPMICRO
        IF( NIAREA(2).NE.(KSEC2(5)*JPMICRO) ) LCHANGE = .TRUE.
        NIAREA(2) = KSEC2(5) * JPMICRO
C
C       Section 2, Word   7    La2 - Latitude of last grid point.
C       Section 2, Word   8    Lo2 - Longitude of last grid point.
C
        IF( NIAREA(3).NE.(KSEC2(7)*JPMICRO) ) LCHANGE = .TRUE.
        NIAREA(3) = KSEC2(7) * JPMICRO
        IF( NIAREA(4).NE.(KSEC2(8)*JPMICRO) ) LCHANGE = .TRUE.
        NIAREA(4) = KSEC2(8) * JPMICRO
C
C       Section 2, Word  10    N - Number of parallels between Pole and
C                   the Equator.
C
        IF( NIGAUSS.NE.KSEC2(10) ) THEN
          LCHANGE = .TRUE.
          JJPR = 1
          JJERR = 1
          IRET = IGGLAT( KSEC2(10)*2, RIGAUSS , JJPR, JJERR)
          IF( IRET.NE.0 ) THEN
            CALL INTLOG(JP_ERROR, 'RESET_C: IGGLAT failed',JPQUIET)
            RESET_C = IRET
            GOTO 900
          ENDIF
        ENDIF
        NIGAUSS = KSEC2(10)
C
C       Fixup output type if 'gaussian' used to describe output and
C       not 'reduced' or 'regular'.
C
        LSAME = (NOREPR.EQ.JPNOTYPE) .AND. (NOGAUSS.EQ.NIGAUSS)
C
C       Pick up regular gaussian grid definition corresponding
C       to the output field if option 'gaussian' used.
C
        IF( (NOREPR.EQ.JPNOTYPE).AND.(.NOT.LSAME) ) THEN
          IF( (NOGAUSO.NE.NOGAUSS).OR.(HOGAUST.NE.'F') ) THEN
            HTYPE = 'F'
            CALL JGETGG(NOGAUSS,HTYPE,ROGAUSS,NOLPTS,IRET)
            IF( IRET.NE.0 ) THEN
              CALL INTLOG(JP_ERROR,
     X          'RESET_C: JGETGG failed, NOGAUSS = ',NOGAUSS)
              RESET_C = IRET
              GOTO 900
            ENDIF
            NOGAUSO = NOGAUSS
            HOGAUST = 'F'
          ENDIF
          NOREPR = JPGAUSSIAN
        ENDIF
C
C       Section 2, Word  11    Scanning mode flags (Code Table 8).
C
        IF ( NISCNM .NE. KSEC2(11) ) LCHANGE = .TRUE.
        NISCNM = KSEC2(11)
C
C       Section 2, Word  23-nn
C       Number of points along each parallel in a quasi-regular grid.
C       Number of parallels is given by Nj above.
C
C       Pick up gaussian definitions for input grid
C
        IF( (NIGAUSO.NE.NIGAUSS).OR.(HIGAUST.NE.'F') ) THEN
          HTYPE = 'F'
          CALL JGETGG(NIGAUSS,HTYPE,RIGAUSS,MILLEN,IRET)
          IF( IRET.NE.0 ) THEN
            CALL INTLOG(JP_ERROR,
     X        'RESET_C: JGETGG failed, NIGAUSS = ',NIGAUSS)
            RESET_C = IRET
            GOTO 900
          ENDIF
          NIGAUSO = NIGAUSS
          HIGAUST = 'F'
        ENDIF
        DO 510 I = 1, NINS
          MILLEN(I) = KSEC2(22 + I)
 510    CONTINUE
C
C       Use same grid for output, unless user requested otherwise.
C
        IF( (.NOT.LNOGAUS) .OR. LSAME ) THEN
          IF( NOGAUSS.NE.NIGAUSS ) LCHANGE = .TRUE.
          NOGAUSS = NIGAUSS
          NONS = NINS
          DO 520 I = 1, NONS
            NOLPTS(I) = MILLEN(I)
            ROGAUSS(I) = RIGAUSS(I)
 520      CONTINUE
          NOGAUSO = NIGAUSO
          HOGAUST = HIGAUST
        ENDIF
C
      ENDIF
C
C-----------------------------------------------------------------------
C      Section 6.  Polar Stereographic grid.
C-----------------------------------------------------------------------
C
  600 CONTINUE
C
      IF ( NIREPR .EQ. 5 ) THEN
C
        NIRESO  = 0
        NIGAUSS = 0
C
C       Section 2, Word   2    Nx - Number of points along X-axis.
C       Section 2, Word   3    Ny - Number of points along Y-axis.
C
        IF( NIWE.NE.0 ) LCHANGE = .TRUE.
        NIWE = KSEC2(2)
        IF( NINS.NE.KSEC2(3) ) LCHANGE = .TRUE.
        NINS = KSEC2(3)
C
C       Section 2, Word   4    La1 - Latitude of first grid point.
C       Section 2, Word   5    Lo1 - Longitude of first grid point.
C
        IF( NIAREA(1).NE.(KSEC2(4)*JPMICRO) ) LCHANGE = .TRUE.
        NIAREA(1) = KSEC2(4) * JPMICRO
        IF( NIAREA(2).NE.(KSEC2(5)*JPMICRO) ) LCHANGE = .TRUE.
        NIAREA(2) = KSEC2(5) * JPMICRO
C
C       Section 2, Word   7    La2 - Latitude of last grid point.
C       Section 2, Word   8    Lo2 - Longitude of last grid point.
C
        IF( NIAREA(3).NE.(KSEC2(7)*JPMICRO) ) LCHANGE = .TRUE.
        NIAREA(3) = KSEC2(7) * JPMICRO
        IF( NIAREA(4).NE.(KSEC2(8)*JPMICRO) ) LCHANGE = .TRUE.
        NIAREA(4) = KSEC2(8) * JPMICRO
C
C       Section 2, Word   9    Dx - X-direction increment.
C       Section 2, Word  10    Dy - Y-direction increment.
C
        IF( NIGRID(1).NE.KSEC2(9) ) LCHANGE = .TRUE.
        NIGRID(1) = KSEC2(09)
        IF( NIGRID(2).NE.KSEC2(10) ) LCHANGE = .TRUE.
        NIGRID(2) = KSEC2(10)
C
C       Section 2, Word  11    Scanning mode flags (Code Table 8).
C
        IF( NISCNM.NE.KSEC2(11) ) LCHANGE = .TRUE.
        NISCNM = KSEC2(11)
C
      ENDIF
C
C-----------------------------------------------------------------------
C      Section 7.  Setup number of bits used for packing ouput.
C-----------------------------------------------------------------------
C
  700 CONTINUE
C
C     Section 4, Word 2 - Number  of bits used for each packed value.
C
C     Use same number of bits for packing output values for unless
C     user has deliberately set a value.
C
      NIACC = KSEC4(2)
      IF( .NOT.LNOACC ) THEN
        IF( NOACC.NE.NIACC ) LCHANGE = .TRUE.
        NOACC = NIACC
      ENDIF
C
C     If default is implied for the output grid, use the input grid
C
      IF( ( (NIREPR.EQ.JPREGULAR).OR.
     X      (NIREPR.EQ.JPREDLL)  .OR.
     X      (NIREPR.EQ.JPREGROT)     ) .AND.
     X    ( (NOREPR.EQ.JPREGULAR).OR.
     X      (NOREPR.EQ.JPREDLL)  .OR.
     X      (NOREPR.EQ.JPREGROT)     ) .AND.
     X      .NOT.LNOGRID ) THEN
        NOGRID(1) = NIGRID(1)
        NOGRID(2) = NIGRID(2)
      ENDIF
C
C-----------------------------------------------------------------------
C      Section 9.  Closedown.
C-----------------------------------------------------------------------
C
  900 CONTINUE
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE CREXTABLES(KSEC1,CREXBTR,CREXBS,CREXBDW,CREXNAMES,
     1                      CREXUNITS,CREXBP,KERR)
C
C**** *BTABLE*
C
C
C     PURPOSE.
C     --------
C          CREATE CREX TABLE B IN BINARY FORM.
C          THIS ROUTINE IS USED IN BUFR2CREX PROGRAM
C
C**   INTERFACE.
C     ----------
C          NONE.
C
C
C     *METHOD.
C      -------
C          NONE.
C
C
C     EXTERNALS.
C     ----------
C          NONE.
C
C
C
C
C     REFERENCE.
C     ----------
C
C     AUTHOR.
C     -------
C
C          MILAN DRAGOSAVAC       *ECMWF*       JANUARY 2003.
C
C
C     MODIFICATIONS.
C     --------------
C
C          NONE.
C
C
      IMPLICIT LOGICAL(L,O,G), CHARACTER*8(C,H,Y)
C
C
c
      PARAMETER(JP=3000)
C
      CHARACTER*64 CREXNAMES(JP)
      CHARACTER*24 CREXUNITS(JP)
      CHARACTER*160 YENTRY
      CHARACTER*256  YFNAME
C
      DIMENSION KSEC1(*)
      INTEGER CREXBTR(JP),CREXBS(JP),CREXBDW(JP)
      INTEGER CREXBP(64,255)
C
      CHARACTER*7   YTABB
      CHARACTER*256 CROOT
      INTEGER IEMOSNM
C
      INTEGER  EMOSNUM
      EXTERNAL EMOSNUM
C
      SAVE NXXP,NYYP,NZZP, OFIRST
C
C     ------------------------------------------------------------------
C*          1.   INITIALIZE CONSTANTS AND VARIABLES.
C                -----------------------------------
 100  CONTINUE
C
      J=0
      ICLASS0=0
      IVIND=2147483647
C
      CROOT=' '
      CALL GETENV('CREX_TABLES',CROOT)
      ILNG=INDEX(CROOT,' ')
      ILNG=ILNG-1
      IF(ILNG.EQ.1) THEN
C
C        SGI/HP/SUN CREX TABLES PATH
C
         CROOT='/home/ma/emos/tables/crex/'
C
C        ADD VERSION NUMBER
C
         ILNG=INDEX(CROOT,' ')
         IEMOSNM = EMOSNUM(1)
         WRITE(CROOT(ILNG:ILNG+5),'(I6.6)') IEMOSNM
         CROOT(ILNG+6:) = '/'
         ILNG=ILNG+6
      END IF
C
C             CREX EDITION 1 NAMING CONVENTION
C
C             BXXYYZZ , DXXYYZZ
C
C             B      - CREX TABLE 'B'
C             D      - CREX TABLE 'D'
C             XX     - Crex Master table used '00'
C             YY     - Crex Edition number used '01'
C             ZZ     - Crex Table version number '01'
C
       IXX=KSEC1(14)   ! BUFR Master Table 0
       IYY=KSEC1( 2)   ! BUFR Edition 
       IZZ=KSEC1(15)   ! Version of Master table
C
       IF(OFIRST) THEN
          IF(IXX.EQ.NXXP.AND.IYY.EQ.NYYP.AND.
     1       IZZ.EQ.NZZP) RETURN
       END IF
C
       WRITE(*,'(1H ,A)') 'Your path for crex tables is :'
       WRITE(*,'(1H ,A)')  CROOT(1:ILNG)

       OFIRST=.TRUE.

       NXXP=IXX
       NYYP=IYY
       NZZP=IZZ
C
C
      DO 101 I=1,64
      DO 101 II=1,255
       CREXBP(I,II)=0
 101  CONTINUE
C
      DO 102 I=1,JP
       CREXBTR(I)=IVIND
       CREXBS(I)=IVIND
       CREXBDW(I)=IVIND
       CREXNAMES(I)=' '
       CREXUNITS(I)=' '
 102  CONTINUE

C
      WRITE(YTABB,'(A1,I2.2,I2.2,I2.2)',iostat=ios) 'B',IXX,IYY,IZZ
      IF(IOS.NE.0) then
        KERR=33
        CALL CREXERR(KERR)
        RETURN
      END IF
C
      print*,'Crex table to be loaded :',YTABB
C
      YFNAME=CROOT(1:ILNG)//YTABB
C
      DO 301 JJ=1,99
       INQUIRE(UNIT=JJ,IOSTAT=IOS,OPENED=OPN)
       IF(.NOT.OPN) THEN
         IUNIT=JJ
         OPEN(UNIT=IUNIT,IOSTAT=IOS,ERR=401,FILE=YFNAME,
     4     FORM='FORMATTED',
     5      RECL=160,
     5     STATUS='OLD')
         GO TO 200
       END IF
 301   CONTINUE
C
C     ------------------------------------------------------------------
C*          2.   READ IN TABLE B ELEMENT.
C                ------------------------
C
 200  CONTINUE
C
      YENTRY=' '
      READ(IUNIT,'(A)',ERR=402,END=300) YENTRY
C
      J=J+1
      IF(J.GT.JP) THEN
         PRINT*,' DIMENSION TOO SMALL J=',J
         KERR=13
         RETURN
      END IF
C
C     ------------------------------------------------------------------
C*          2.1  SET ARRAYS FOR TABLE REFERENCE, ELEMENT NAME, UNITS,
C*               REFERENCE VALUE AND DATA WIDTH.
C
 210  CONTINUE
C
C
      IMINUS=0
      IMINUS=INDEX(YENTRY(12:16),'-')
      IF(IMINUS.NE.0) YENTRY(IMINUS:IMINUS)='9'
c    1  FMT='(1x,A,1x,A64,47x,A24,I3,8x,I3)')
      READ(YENTRY,'(2X,I5,1x,64x,71x,I3,7x,I3)',IOSTAT=IOS)
     1                                    CREXBTR(J),CREXBS(J),
     1                                    CREXBDW(J)
      IF(IOS.NE.0) THEN
         KERR=35
         CALL CREXERR(KERR)
         print*,'Line number ',j
         RETURN
      END IF
C
      CREXNAMES(J)=YENTRY( 9:72)
      CREXUNITS(J)=YENTRY(120:123)
C
      ICLASS=CREXBTR(J)/1000
      IYYY  =CREXBTR(J)-ICLASS*1000+1
C
      ICLASS=ICLASS+1
      CREXBP(ICLASS,IYYY)=J
C
      GO TO 200
C
 300  CONTINUE
C
      CLOSE(UNIT=IUNIT)
      RETURN
C
C
C
402   CONTINUE
      KERR=35
      CALL CREXERR(KERR)
      WRITE(*,4402) IOS,yfname
 4402 FORMAT(1H ,'Read error',i4,' on ',a)
      RETURN
C
C
 401  CONTINUE
C
      KERR=9
      CALL CREXERR(KERR)
      WRITE(*,4401) IOS,yfname
 4401 FORMAT(1H ,'Open error',i4,' on ',a)
C
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities
C granted to it by virtue of its status as an intergovernmental organisation
C nor does it submit to any jurisdiction.
C
      SUBROUTINE BUIVAR(KERR)
C
C**** *BUIVAR*
C
C
C     PURPOSE.
C     --------
C         INITIALIZE CONSTANTS AND VARIABLES.
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *BUIVAR(KERR)*
C
C     METHOD.
C     -------
C
C          NONE.
C
C
C     EXTERNALS.
C     ----------
C
C     GETENV  - GETS VALUE OF AN ENVIRONMENT VARIABLE.
C     EMOSNUM - GIVES CURRENT EMOSLIB VERSION NUMBER.
C
C     REFERENCE.
C     ----------
C
C          NONE.
C
C     AUTHOR.
C     -------
C
C          M. DRAGOSAVAC    *ECMWF*       15/03/92.
C
C
C     MODIFICATIONS.
C     --------------
C
C          NONE.
C
C
      IMPLICIT LOGICAL(L,O,G), CHARACTER*8(C,H,Y)
C
C
#     include "parameter.F"
#     include "bcomunit.F"
#     include "bcmatb.F"
#     include "bcmbef.F"
#     include "bcmwork.F"
#     include "bcmwt.F"
#     include "bcmroot.F"
#     include "bcmtabload.F"
#     include "bcmtabloadc.F"
C
      CHARACTER*256 CROOT, HDEFAULT,CPRINT
      CHARACTER*9   STD_OUT,YKNTN
      CHARACTER*24 CTABLE_LIST,CCTABBU
      CHARACTER*64 CCTABBEN
      LOGICAL OPRINT
C
C
      INTEGER IEMOSNM
#ifndef R_4
      REAL*8 RVIND
      REAL*8 EPS
#else
      REAL   RVIND
      REAL   EPS
#endif

#ifdef TABLE_PATH
      DATA HDEFAULT
     & / TABLE_PATH /
#else
      DATA HDEFAULT / '' /
#endif

C
C     EXTERNAL FUNCTIONS
C
      INTEGER EMOSNUM
      EXTERNAL EMOSNUM
C
C     ------------------------------------------------------------------
C*          1.   INITIALIZE VARIABLES AND CONSTANTS.
C                -----------------------------------
 100  CONTINUE
C
      IF(KERR.GT.0) RETURN
C
      NJA= 0
      M  =0
      MM =0
      N  =0
      JCV=0
      NBPW=JBPW
      NWPT=0
      NBPT=0
      NWPTB=0
      NBPTB=0
      NVIND=2147483647
      RVIND=1.7D38
      EPS=10.D-7
      NBENP=0
      NLTVNP=0
      NWWP=0
      NXXP=0
      NYYP=0
      NZZP=0
      NTC=0
      NTT=0
      NDWINC=0
      NSCAM=0
      NSCAM07=0
      NDWINC07=0
      N07=0
      NAFDW=0
      NFD=0
      NWT=0
      ODREPF=.FALSE.
      N221=0
      N40=0
      MREL=0
      NFCM=0
      MBMP=0
      MBMPL=0
      OMARKER=.FALSE.
      CROOT=' '
      NREP=0
      OREP=.false.
      N08=0
      NSSP=0
C
C     STANDARD OUTPUT UNIT NUMBER
C
      STD_OUT=' '
      YKNTN=' '
      CALL GETENV('STD_OUT',YKNTN)
      INKNTN=INDEX(YKNTN,' ')
      IF(INKNTN.EQ.1) THEN
        KNTN=6
      ELSE
        READ(YKNTN,'(I3.3)') KNTN
      END IF
C
      CROOT=' '
      CALL GETENV('BUFR_TABLES',CROOT)
      ILNG=INDEX(CROOT,' ')
      IF(ILNG.LE.1) THEN
        ILNG=INDEX(HDEFAULT,' ') - 1
        IF(ILNG.GT.0) THEN
          CROOT = HDEFAULT(1:ILNG)//'/bufrtables/'
        ELSE
#ifdef BUFR_TABLES_PATH
             CROOT=BUFR_TABLES_PATH
             ILNG=INDEX(CROOT,' ')
#else
             CROOT='/usr/local/apps/libemos/tables/bufr/text/'
C
C         ADD VERSION NUMBER
C
          ILNG=INDEX(CROOT,' ')
          IEMOSNM = EMOSNUM(1)
          WRITE(CROOT(ILNG:ILNG+5),'(I6.6)') IEMOSNM
          CROOT(ILNG+6:) = '/'
#endif
        ENDIF
      ENDIF
      ILNG=INDEX(CROOT,' ')
      IF (ILNG.GT.1) THEN
        IF (CROOT(ILNG-1:ILNG-1).NE.'/') CROOT(ILNG:ILNG)='/'
      ENDIF
C
      CPRINT=' '
      OPRINT=.TRUE.
      CALL GETENV('PRINT_TABLE_NAMES',CPRINT)
      ILN=INDEX(CPRINT,' ')
      IF(ILN.LE.1) THEN
         OPRINT=.TRUE.
      ELSE
         IF(CPRINT(1:ILN-1).EQ.'FALSE'.OR.
     1      CPRINT(1:ILN-1).EQ.'false') OPRINT=.FALSE.
      END IF

      IF(OPRINT) THEN
C
      WRITE(KNTN,'(1H ,A)') '                  ECMWF '
      WRITE(KNTN,'(1H )')
      WRITE(KNTN,'(1H ,A,A)') '     BUFR ENCODING SOFTWARE',
     1' VERSION -  7.2 '
      WRITE(KNTN,'(1H ,A)') '           1 April  2007. '
      WRITE(KNTN,'(1H )')
      WRITE(KNTN,'(1H )')
      WRITE(KNTN,'(1H )')
      WRITE(KNTN,'(1H ,A)') 'Your path for bufr tables is :'
      WRITE(KNTN,'(1H ,A)')  CROOT(1:ILNG+6)
      END IF
C
      DO 101 I=1,JBPW-2
      NMASK(I)=2**I-1
  101 CONTINUE
      IF(JBPW.EQ.32) THEN
         NMASK(31)=2147483647
      END IF
C
      RETURN
      END

C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE BUREP(KPT,KDLEN,KDATA,KJ,KJ1,KDD,KSTACK,KERR)
C
C**** *BUREP*
C
C
C     PURPOSE.
C     --------
C          RESOLVE DATA DESCRIPTOR REPLICATION PROBLEM.
C
C
C**   INTERFACE.
C     ----------
C
C          *CALL* *BUREP(KPT,KDLEN,KDATA,KJ,KJ1,KDD,KSTACK,KERR)*
C
C        INPUT :
C               *KPT*      - POINTER TOO KDATA ARRAY
C               *KDLEN*    -  DIMENSION OF KDATA ARRAY
C               *KDATA*    -  ARRAY CONTAINING DATA NEEDED FOR DATA DESCRIPTOR
C                            EXPANSION
C               *KDD*      - DATA DESCRIPTOR
C        OUTPUT:
C               *KJ*       - POINTER TO KSTACK ARRAY
C               *KJ1*      - POINTER TO LAST ELEMENT IN KSTACK
C               *KSTACK*   - LIST OF DATA DESCRIPTORS
C               *KERR*     - RETURN CODE
C
C     METHOD.
C     -------
C          NONE.
C
C     EXTERNALS.
C     ----------
C
C          BUETDR            - RESOLVE TABLE D REFERENCE
C          BUEPWT            - UPDATE WORKING TABLES
C          GBYTE             - UNPACK BIT PATHERN
C
C
C     REFERENCE.
C     ----------
C
C          NONE.
C
C     AUTHOR.
C     -------
C
C          M. DRAGOSAVAC    *ECMWF*       01/02/91.
C
C
C     MODIFICATIONS.
C     --------------
C
C          NONE.
C
C
      IMPLICIT LOGICAL(L,O,G), CHARACTER*8(C,H,Y)
C
C
C
#     include "parameter.F"
#     include "bcomunit.F"
#     include "bcmwork.F"
#     include "bcmwt.F"
#     include "bcmwtc.F"
#     include "bcmbef.F"
#     include "bcmoff.F"
C
      CHARACTER CWTEN*64,CWTU*24
      DIMENSION ILIST(JELEM)
      DIMENSION KSTACK(*)
      DIMENSION KDATA(KDLEN)
#ifndef R_4
      REAL*8 RVIND
      REAL*8 EPS
#else
      REAL   RVIND
      REAL   EPS
#endif
C
C     ------------------------------------------------------------------
C
C*          1.   STORE K, NUMBER OF DESCRIPTORS TO BE REPLICATED.
C                ------------------------------------------------
 100  CONTINUE
C
      IF( KERR.NE.0 ) RETURN
C
      IF  = KDD / 100000
      IDIF= KDD - IF * 100000
      IX  = IDIF / 1000
      IY  = IDIF - IX * 1000
      K   = IX
      IF(IY.EQ.0) ODREPF=.TRUE.
C
C*          1.1   DELAYED REPLICATION ?
C                 ---------------------
 110  CONTINUE
C
      IF( IY .NE. 0 ) THEN
C
C*          1.2   STORE NUMBER OF DESCRIPTORS, K, AND REPLICATION
C                 -----------------------------------------------
C                 FACTOR JR.
C                 ----------
 120     CONTINUE
C
         JR = IY
         GO TO 500
      END IF
C
C     ------------------------------------------------------------------
C
C*          2.   GET NEXT DESCRIPTOR.
C                --------------------
 200  CONTINUE
C
      KJ =KJ + 1
      KDD= KSTACK(KJ)
C
C     ------------------------------------------------------------------
C
C*          2.1  REPLICATION FACTOR ?
C                --------------------
 210  CONTINUE
C
      IF(KDD.NE.31001.AND.KDD.NE.31002.AND.
     1   KDD.NE.31000.AND.
     1   KDD.NE.31011.AND.KDD.NE.31012 )THEN
C
C*          2.1.1  SEQUENCE DESCRIPTOR ?
C                  ---------------------
C
         IF=KDD/100000
C
         IF( IF.EQ.3) THEN
C
C*          2.1.1.1  SOLVE TABLE D REFERENCE.
C                    ------------------------
            CALL BUETDR(KJ,KJ1,KDD,KSTACK,KERR)
            IF(KERR.GT.0) THEN
               DO 252 IQ=1,JELEM
               NSTACK(IQ)=0.
 252           CONTINUE
               RETURN
            END IF
            GO TO 200
         END IF
C
         IF( IF.EQ.2) THEN
            CALL BUOPER(KPT,KDLEN,KDATA,KJ,KDD,KSTACK,KERR)
            IF(KERR.GT.0) THEN
               CALL BUERR(KERR)
               RETURN
            END IF
            GO TO 200
         END IF
C
         KERR=36
         CALL BUERR(KERR)
         RETURN
      END IF
C
C     ------------------------------------------------------------------
C
C*          3.  UPDATE WORKING TABLE.
C               ---------------------
 300  CONTINUE
C
      IF(KDD.EQ.31031.OR.KDD.EQ.31192) THEN
         NWT=NWT+1
         NWTR(NWT)=KDD
         NWTS(NWT)=0
         NWTRV(NWT)=0
         NWTDW(NWT)=1
         M=M+1
      ELSEIF(KDD.EQ.33007.OR.KDD.EQ.63192) THEN
         NWT=NWT+1
         NWTR(NWT)=KDD
         NWTS(NWT)=0
         NWTRV(NWT)=0
         NWTDW(NWT)=7
         M=M+1
      ELSE
         CALL BUEPWT (KDD,KERR)
         IF(KERR.GT.0) RETURN
         IF(KDD.EQ.031011.or.KDD.EQ.031012) RETURN
      END IF
C
C     ------------------------------------------------------------------
C
C*          4.  STORE JR, THE REPLICATION FACTOR FROM DATA.
C               ------------------------------------------------------
 400  CONTINUE
C
      KPT=KPT+1
      IF(KPT.GT.KDLEN) THEN
         KERR=31
         CALL BUERR(KERR)
         RETURN
      END IF
C
      JR=KDATA(KPT)
C
      IF(JR.EQ.0) THEN
         IIIF=KSTACK(KJ+1)/100000
         IIII=KSTACK(KJ+1)-IIIF*100000
         IIIX=IIII/1000
         IIIY=IIII-IIIX*1000
C
         IF(IIIF.EQ.2.AND.IIIY.EQ.0) THEN
            KJ=KJ+1
            CALL BUOPER(KPT,KDLEN,KDATA,KJ,KSTACK(KJ),KSTACK,KERR)
            IF(KERR.GT.0) THEN
               CALL BUERR(KERR)
               RETURN
            END IF
         END IF

         KJ=KJ+K
         GO TO 640
      END IF

      JRTK=JR*K+KJ1-K
      IF(JRTK.GT.JELEM) THEN
         KERR=30
         CALL BUERR(KERR)
         RETURN
      END IF
C
C     CHECK IF NEXT DESCRIPTOR CANCEL OPERATOR FOR DELAYED
C     REPLICATION
C
      IIIF=KSTACK(KJ+1)/100000
      IIII=KSTACK(KJ+1)-IIIF*100000
      IIIX=IIII/1000
      IIIY=IIII-IIIX*1000
C
      IF(IIIF.EQ.2.AND.IIIY.EQ.0) THEN
         KJ=KJ+1
         CALL BUOPER(KPT,KDLEN,KDATA,KJ,KSTACK(KJ),KSTACK,KERR)
         IF(KERR.GT.0) THEN
            CALL BUERR(KERR)
            RETURN
         END IF
      END IF
C     ------------------------------------------------------------------
C*          5.  GET NEXT K DESCRIPTORS.
C               -----------------------
 500  CONTINUE
C
      DO 501 J=1,K
C
      ILIST(J)=KSTACK(KJ+J)
C
 501  CONTINUE
C
C     ------------------------------------------------------------------
C*          6.  ADD JR TIMES K DESCRIPTORS IN PLACE OF K
C               ----------------------------------------
C               DESCRIPTORS OBTAINED.
C               ---------------------
 600  CONTINUE
C
C     ------------------------------------------------------------------
C*          6.1  PUSH DOWN DESCRIPTORS IN KSTACK FOR (JR-1)*K PLACES
C                ---------------------------------------------------
C                STARTING AT KJ1 AND ENDING AT KJ+K.
C                -----------------------------------
 610  CONTINUE
C
      JRKM1=(JR-1)*K
C
      DO 611 J=KJ1,KJ+K,-1
C
      KSTACK(J+JRKM1)=KSTACK(J)
C
 611  CONTINUE
C
C*          6.2  INSERT LIST IN THE STACK.
C                -------------------------
 620  CONTINUE
C
      DO 622 J=1,JR
C
      KJJM1K=KJ+(J-1)*K
C
      DO 623 J1=1,K
C
      KSTACK(KJJM1K+J1)=ILIST(J1)
C
 623  CONTINUE
 622  CONTINUE
C
C     ------------------------------------------------------------------
C*          6.3  ADJUST DESCRIPTOR COUNT FOR LIST LENGTH.
C                ----------------------------------------
 630  CONTINUE
C
      KJ1 = KJ1  + (JR-1)*K
C
C     ------------------------------------------------------------------
C*          6.4  ADJUST NUMBER OF DATA DESCRIPTORS NOT PRESENT.
C                ----------------------------------------------
 640  CONTINUE
C
      IF(N221.NE.0)  N221= KJ1  - KJ + 1
C
C     ------------------------------------------------------------------
 700  CONTINUE
C
      RETURN
      END

C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      INTEGER FUNCTION IAINTLL (KIFELD, KILEN, PWEST, PEAST, PNORTH,
     1   PSOUTH, PNSINC, PWEINC, KOFELD, KOLEN, KOBITS, KPR, KERR)
C
C---->
C**** *IAINTLL*
C
C     PURPOSE
C     _______
C
C     The global controlling routine for interpolating between a GRIB
C     input field and a regular latitude longitude output field.
C
C     INTERFACE
C     _________
C
C     IERR = IAINTLL (KIFELD, KILEN, PWEST, PEAST, PNORTH, PSOUTH,
C    1   PNSINC, PWEINC, KOFELD, KOLEN, KOBITS, KPR, KERR)
C
C     Input parameters
C     ________________
C
C     KIFELD     - The input field provided by the calling routine.
C
C     KILEN      - The length of the input field.
C
C     PWEST      - The Western limit of the output field area.
C
C     PEAST      - The Eastern limit of the output field area.
C
C     PNORTH     - The Northern limit of the output field area.
C
C     PSOUTH     - The Southern limit of the output field area.
C
C     PNSINC     - The North-South stride for the output field.
C
C     PWEINC     - The West-East stride for the output field.
C
C     KOLEN      - The length of the output field.
C
C     KOBITS     - The number of bits used for packing the output array.
C
C     KPR        - The debug print switch.
C                  0  , No debugging output.
C                  1  , Produce debugging output.
C
C     KERR       - The error control flag.
C                  -ve, No error message. Return error code.
C                  0  , Hard failure with error message.
C                  +ve, Print error message. Return error code.
C
C     Output parameters
C     ________________
C
C     KOFELD     - The output field returned to the calling routine.
C
C     KOLEN      - The amount of the output array used for the packed
C                  GRIB field.
C
C     Return value
C     ____________
C
C     The error indicator (INTEGER).
C
C     Error and Warning Return Values
C     _______________________________
C
C     21301 The number of bits requested was outside the allowed
C           range 0 to 24.
C     21302 The input data representation was not valid when the GRIB
C           field had been expanded.
C
C     Common block usage
C     __________________
C
C     grfixed.h    - The include file contains all the array space
C                    for grid to grid interpolation.
C
C     MILLEN       - The array of latitude line lengths for a quasi
C                    regular input field is used.
C     RIGAUSS      - Real array of input field Gaussian latitudes is
C                    used.
C
C     ouspace.h    - This file contains the work space array
C                    definitions for the arrays to hold the unpacked
C                    real data from GRIB fields.
C
C     RIFELD       - The expanded input field is set and used.
C     ROFELD       - The expanded output field is set and used.
C
C     nifld.common - This file contains all the input field
C                    definition variables.
C
C     LCHANGE      - Process change flag is set.
C
C     NIAREA       - Input field area definition (N/W/S/E) is set.
C     NIGAUSS      - Input field Gaussian truncation is used.
C     NIGRID       - Input field grid definition (WE/NS) is used.
C     NINS         - Number of grid points in NS direction for input
C                    field is used.
C     NIREPR       - Input field representation is used.
C     NIWE         - Number of grid points in WE direction for input
C                    field is used.
C
C     nofld.common - This file contains all the output field
C                    definition variables.
C
C     NOACC        - Number of packing bits to be used for output
C                    GRIB field is set.
C     NOAREA       - Output field area definition (N/W/S/E) is set.
C     NOGRID       - Output field grid definition (WE/NS) is used..
C     NONS         - Number of grid points in NS direction for output
C                    field is set and used.
C     NOWE         - Number of grid points in WE direction for output
C                    field is set and used.
C
C     EXTERNALS
C     _________
C
C     ABORTX     - Standard routine to kill task.
C     GRIBEX     - Standard routine to unpack or pack a GRIB field.
C     IAGCNTL    - Perform regular grid to grid point interpolation.
C     IARCNTL    - Perform regular grid to grid point interpolation.
C     IAIDEF     - Initialise the input field definition variables
C                  from a GRIB definition
C     IAOLDEF    - Initialise the output field definition variables
C                  from the user supplied values.
C     IARESET    - Create the output field definition in GRIB format.
C     IARMEM     - Get space for the unpacked input and output
C                  fields.
C     IGLSIZE    - Evaluate the array sizes for a regular
C                  latitude/longitude grid and area.
C     IGSIZE     - Evaluate the array sizes for a Gaussian truncation
C                  and area.
C     IRSIZE     - Evaluate the array sizes for a quasi regular
C                  Gaussian field.
C     INTLOG     - Logs messages.
C
C     METHOD
C     ______
C
C     This is purely a controlling routine with all the work being
C     performed in the external routines.
C
C     REFERENCE
C     _________
C
C     None
C
C     COMMENTS
C     ________
C
C     Program contains sections 0 to 7 and 9
C
C     AUTHOR
C     ______
C
C     K. Fielding      *ECMWF*      Apr 1994
C
C     MODIFICATIONS
C     _____________
C
C     None
C
C----<
C     _______________________________________________________
C
C
C*    Section 0. Definition of variables.
C     _______________________________________________________
C
C*    Prefix conventions for variable names
C
C     Logical      L (but not LP), global or common.
C                  O, dummy argument
C                  G, local variable
C                  LP, parameter.
C     Character    C, global or common.
C                  H, dummy argument
C                  Y (but not YP), local variable
C                  YP, parameter.
C     Integer      M and N, global or common.
C                  K, dummy argument
C                  I, local variable
C                  J (but not JP), loop control
C                  JP, parameter.
C     REAL         A to F and Q to X, global or common.
C                  P (but not PP), dummy argument
C                  Z, local variable
C                  PP, parameter.
C
C     Implicit statement to force declarations
C
      IMPLICIT NONE
C
#include "parim.h"
#include "nifld.common"
#include "nofld.common"
#include "grfixed.h"
#include "ouspace.h"
C
C     Dummy arguments
C
      INTEGER KILEN, KOLEN, KOBITS, KPR, KERR
C
      REAL PWEST, PEAST, PNORTH, PSOUTH, PNSINC, PWEINC
C
      INTEGER KIFELD (*), KOFELD (*)
C
C     Local variables
C
      CHARACTER*1 HFUNC
      LOGICAL GIWEGLOBE, GINPOLE, GISPOLE, GOWEGLOBE, GONPOLE,
     1   GOSPOLE, GICHNG, GOCHNG
C
      INTEGER IILN, ITOTAL, IOLN
C
      INTEGER IIAREA (4), IOAREA (4)
C
      INTEGER JLAT, JSET
C
      INTEGER IERR
C
      INTEGER ISEC0 (JPGRIB_ISEC0), ISEC1 (JPGRIB_ISEC1)
      INTEGER ISEC2 (JPGRIB_ISEC2), ISEC3 (JPGRIB_ISEC3)
      INTEGER ISEC4 (JPGRIB_ISEC4)
C
      INTEGER ZSEC2 (JPGRIB_RSEC2), ZSEC3 (JPGRIB_RSEC3)
C
      INTEGER JPROUTINE
C
      PARAMETER (JPROUTINE = 21300)
C
C     External functions
C
      INTEGER IAGCNTL, IARCNTL, IAIDEF, IAOLDEF, IARESET, IARMEM,
     1   IGSIZE, IGLSIZE, IRSIZE
C
C     Transform definition variables that must be preserved
C
      SAVE IILN, IIAREA, IOLN, IOAREA, ITOTAL
      SAVE GIWEGLOBE, GINPOLE, GISPOLE, GOWEGLOBE, GONPOLE,
     1   GOSPOLE
C
C     _______________________________________________________
C
C
C*    Section 1. Initialisation
C     _______________________________________________________
C
  100 CONTINUE
C
      IF (KPR.GE.1) CALL INTLOG(JP_DEBUG,'IAINTLL: Section 1.',JPQUIET)
C
      IAINTLL = 0
C
      IERR = 0
C
      IF (KPR .GE. 1) THEN
         CALL INTLOG(JP_DEBUG,'IAINTLL: Input parameters',JPQUIET)
         CALL INTLOG(JP_DEBUG,'IAINTLL: Input array length = ',KILEN)
         CALL INTLOG(JP_DEBUG,'IAINTLL: Output array length = ',KOLEN)
         CALL INTLOG(JP_DEBUG,'IAINTLL: Out field packing bits=',KOBITS)
         CALL INTLOGR(JP_DEBUG,'IAINTLL: W-E increment is ',PWEINC)
         CALL INTLOGR(JP_DEBUG,'IAINTLL: N-S increment is ',PNSINC)
         CALL INTLOGR(JP_DEBUG,'IAINTLL: Area North = ',PNORTH)
         CALL INTLOGR(JP_DEBUG,'IAINTLL: Area West = ',PWEST)
         CALL INTLOGR(JP_DEBUG,'IAINTLL: Area South = ',PSOUTH)
         CALL INTLOGR(JP_DEBUG,'IAINTLL: Area East = ',PEAST)
      ENDIF
C
      IF (KOBITS .LT. 0 .OR. KOBITS .GT. 24) THEN
C
        IAINTLL = JPROUTINE + 1
        IF (KERR .GE. 0) THEN
          CALL INTLOG(JP_ERROR,
     X      'IAINTLL: No. bits requested = ',KOBITS)
          CALL INTLOG(JP_ERROR,
     X      'IAINTLL: Range allowed is <0 - 24>',JPQUIET)
          IF (KERR .EQ. 0) CALL INTLOG(JP_FATAL,
     X      'IAINTLL: Interpolation failing.',JPQUIET)
        ENDIF
        GO TO 900
C
      ENDIF
C
      NOACC = KOBITS
C
C     _______________________________________________________
C
C
C*    Section 2. Input grid definition from GRIB file
C     _______________________________________________________
C
  200 CONTINUE
C
      IF (KPR.GE.1) CALL INTLOG(JP_DEBUG,'IAINTLL: Section 2.',JPQUIET)
C
C     Unpack GRIB sections 0, 1 and 2 only
C
      IERR = KERR
C
C     CALL GRSDBG (KPR)
C
      CALL GRIBEX (ISEC0, ISEC1, ISEC2, ZSEC2, ISEC3, ZSEC3, ISEC4,
     1   RIFELD, 1, KIFELD, KILEN, KOLEN, 'I', IERR)
C
      IF (IERR .NE. 0) THEN
         IAINTLL = IERR
         GO TO 900
      ENDIF
C
      IERR = IAIDEF (ISEC1, ISEC2, IIAREA, MILLEN, GICHNG, KPR, KERR)
C
      IF (IERR .GT. 0) THEN
         IAINTLL = IERR
         GO TO 900
      ENDIF
C
      IF (GICHNG) THEN
C
        DO 210 JSET = 1, 4
          NIAREA (JSET) = IIAREA (JSET)
  210   CONTINUE
C
        IF (NIREPR .EQ. JPGAUSSIAN) THEN
C
          IERR = IGSIZE (NIGAUSS, NIAREA, NIWE, NINS, IILN, RIGAUSS,
     1         GIWEGLOBE, GINPOLE, GISPOLE, KPR, KERR)
C
          IF (IERR .GT. 0) THEN
            IAINTLL = IERR
            GO TO 900
          ENDIF
C
          ITOTAL = NIWE * NINS
C
        ELSE IF (NIREPR .EQ. JPQUASI) THEN
C
          IERR = IRSIZE (NIGAUSS, NIAREA, MILLEN, NIWE, NINS, IILN,
     1         ITOTAL, RIGAUSS, GIWEGLOBE, GINPOLE, GISPOLE, KPR, KERR)
C
          IF (IERR .GT. 0) THEN
            IAINTLL = IERR
            GO TO 900
          ENDIF
C
        ELSE IF (NIREPR .EQ. JPREGULAR) THEN
C
          IERR = IGLSIZE (NIGRID, NIAREA, NIWE, NINS, IILN,
     1         GIWEGLOBE, GINPOLE, GISPOLE, KPR, KERR)
C
          IF (IERR .GT. 0) THEN
            IAINTLL = IERR
            GO TO 900
          ENDIF
C
          ITOTAL = NIWE * NINS
C
        ELSE
C
          IAINTLL = JPROUTINE + 2
          IF (KERR .GE. 0) CALL INTLOG(JP_ERROR,
     X      'IAINTLL: Invalid input representation = ',NIREPR)
          IF (KERR .EQ. 0) CALL INTLOG(JP_FATAL,
     X      'IAINTLL: Interpolation failing.',JPQUIET)

          GO TO 900
C
        ENDIF
C
      ELSE
        IF (NIREPR .NE. JPQUASI) THEN
          ITOTAL = NIWE * NINS
        ELSE
          ITOTAL = 0
          DO 220 JLAT = 1, NINS
            ITOTAL = ITOTAL + MILLEN (JLAT)
  220     CONTINUE
        ENDIF
      ENDIF
C
      LCHANGE = LCHANGE .OR. GICHNG
C
C     _______________________________________________________
C
C
C*    Section 3. Output field definiton from parameters
C     _______________________________________________________
C
  300 CONTINUE
C
      IF (KPR.GE.1) CALL INTLOG(JP_DEBUG,'IAINTLL: Section 3.',JPQUIET)
C
      IERR = IAOLDEF (PWEST, PEAST, PNORTH, PSOUTH, PNSINC, PWEINC,
     1   IOAREA, GOCHNG, GIWEGLOBE, GINPOLE, GISPOLE, NIAREA, KPR,
     2   KERR)
C
      IF (IERR .GT. 0) THEN
         IAINTLL = IERR
         GO TO 900
      ENDIF
C
      IF (GOCHNG) THEN
C
         DO 310 JSET = 1, 4
            NOAREA (JSET) = IOAREA (JSET)
  310    CONTINUE
C
         NOWE = 0
         NONS = 0
C
         IERR = IGLSIZE (NOGRID, NOAREA, NOWE, NONS, IOLN, GOWEGLOBE,
     1      GONPOLE, GOSPOLE, KPR, KERR)
C
         IF (IERR .GT. 0) THEN
            IAINTLL = IERR
            GO TO 900
         ENDIF
      ENDIF
C
      LCHANGE = LCHANGE .OR. GOCHNG
C
C     _______________________________________________________
C
C
C*    Section 4. Get space for REAL input and output arrays
C     _______________________________________________________
C
  400 CONTINUE
C
      IF (KPR.GE.1) CALL INTLOG(JP_DEBUG,'IAINTLL: Section 4.',JPQUIET)
C
      IF (LCHANGE) THEN
C
         IERR = IARMEM (ITOTAL, NOWE * NONS, KPR, KERR)
C
         IF (IERR .GT. 0) THEN
            IAINTLL = IERR
            GO TO 900
         ENDIF
      ENDIF
C
C     _______________________________________________________
C
C
C*    Section 5. Fully unpack the GRIB array
C     _______________________________________________________
C
  500 CONTINUE
C
      IF (KPR.GE.1) CALL INTLOG(JP_DEBUG,'IAINTLL: Section 5.',JPQUIET)
C
      IERR = KERR
C
C     CALL GRSDBG (KPR)
C
      ISEC3(2) = NINT(RMISSGV)
      ZSEC3(2) = RMISSGV
      CALL GRIBEX (ISEC0, ISEC1, ISEC2, ZSEC2, ISEC3, ZSEC3, ISEC4,
     1   RIFELD, ITOTAL, KIFELD, KILEN, KOLEN, 'D', IERR)
C
      IF (IERR .NE. 0) THEN
         IAINTLL = IERR
         GO TO 900
      ENDIF
C
C     _______________________________________________________
C
C
C*    Section 6. Basic interpolation from input to output field
C     _______________________________________________________
C
  600 CONTINUE
C
      IF (KPR.GE.1) CALL INTLOG(JP_DEBUG,'IAINTLL: Section 6.',JPQUIET)
C
      IF (NIREPR .EQ. JPQUASI) THEN
         IERR = IARCNTL (RIFELD, ITOTAL, ROFELD, NOWE * NONS, IILN,
     1      GIWEGLOBE, GINPOLE, GISPOLE, IOLN, GOWEGLOBE, GONPOLE,
     1      GOSPOLE, KPR, KERR)
      ELSE
         IERR = IAGCNTL (RIFELD, ITOTAL, ROFELD, NOWE * NONS, IILN,
     1      GIWEGLOBE, GINPOLE, GISPOLE, IOLN, GOWEGLOBE, GONPOLE,
     1      GOSPOLE, KPR, KERR)
      ENDIF
C
      IF (IERR .NE. 0) THEN
         IAINTLL = IERR
         GO TO 900
      ENDIF
C
C     _______________________________________________________
C
C
C*    Section 7. Repack GRIB code
C     _______________________________________________________
C
  700 CONTINUE
C
      IF (KPR.GE.1) CALL INTLOG(JP_DEBUG,'IAINTLL: Section 7.',JPQUIET)
C
      IERR = IARESET (ISEC2, ISEC4, NOWE * NONS, KPR, KERR)
C
      IF (IERR .NE. 0) THEN
         IAINTLL = IERR
         GO TO 900
      ENDIF
C
      IERR = KERR
C
C     CALL GRSDBG (KPR)
C
C     PACKING specified can be second-order, simple or archive value
C
      IF( NOHFUNC.EQ.'K' ) THEN
        HFUNC = 'K'
        ISEC4(4)  = 64
        ISEC4(6)  = 16
        ISEC4(9)  = 32
        ISEC4(10) = 16
        ISEC4(12) = 8
        ISEC4(13) = 4
        ISEC4(14) = 0
        ISEC4(15) = -1
      ELSE IF( NOHFUNC.EQ.'S' ) THEN
        HFUNC = 'C'
        ISEC4(4)  = 0
        ISEC4(6)  = 0
      ELSE IF( NOHFUNC.EQ.'A' ) THEN
        IF( ISEC4(4).EQ.64 ) THEN
          HFUNC = 'K'
        ELSE
          HFUNC = 'C'
        ENDIF
      ENDIF
C
      IF( LIMISSV ) THEN
        ISEC1(5) = 192
        ISEC3(2) = NINT(RMISSGV)
        ZSEC3(2) = RMISSGV
      ENDIF
      CALL GRIBEX (ISEC0, ISEC1, ISEC2, ZSEC2, ISEC3, ZSEC3, ISEC4,
     1   ROFELD, NOWE * NONS, KOFELD, KOLEN, KOLEN, HFUNC, IERR)
C
      IF (IERR .NE. 0) THEN
         IAINTLL = IERR
         GO TO 900
      ENDIF
C
      IF (KPR .GE. 1) CALL INTLOG(JP_DEBUG,
     X  'IAINTLL: Output array length = ',KOLEN)
C
C     _______________________________________________________
C
C
C*    Section 9. Return to calling routine. Format statements
C     _______________________________________________________
C
  900 CONTINUE
C
      IF (KPR.GE.1) CALL INTLOG(JP_DEBUG,'IAINTLL: Section 9.',JPQUIET)
C
 9002 FORMAT (' IAINTLL ERROR', I6, ' - Input representation', I6,
     1   ' is not valid')
C
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      INTEGER FUNCTION IGPOLEG(PIFELD, KIWE, POFELD, KOWE, KPR, KERR)
C
C---->
C**** *IGPOLEG*
C
C     Purpose
C     -------
C
C     Calculate the values at the pole of a regular
C     latitude/longitude field when the input is a Gaussian field.
C
C     This routine is used for any field except a wind field.
C
C     Interface
C     ---------
C
C     IERR = IGPOLEG(PIFELD, KIWE, POFELD, KOWE, KPR, KERR)
C
C     Input parameters
C     ----------------
C
C     PIFELD     - A "polar" row of the input field provided by the
C                  calling routine.
C
C     KIWE       - The number of points in the West-East direction in
C                  the input field.
C
C     KOWE       - The number of points in the West-East direction in
C                  the output field.
C
C     KPR        - The debug print switch.
C                  0  , No debugging output.
C                  1  , Produce debugging output.
C
C     KERR       - The error control flag.
C                  -ve, No error message. Return error code.
C                  0  , Hard failure with error message.
C                  +ve, Print error message. Return error code.
C
C     Output parameters
C     -----------------
C
C     POFELD     - The corresponding "polar" row of the output field
C                  returned to the calling routine.
C
C     Return value
C     ------------
C
C     The error indicator (INTEGER).
C
C
C     Common block usage
C     ------------------
C
C     None
C
C     Externals
C     ---------
C
C     INTLOG(R)    - Logs messages.
C
C     Method
C     ------
C
C     A Gaussian field does not have a line of latitude at the pole
C     so this routine forces all the values on the polar line of
C     latitude to the average of the values at the nearest Gaussian
C     line in the input field.
C
C     This method was originally implemented by
C
C     K. RIDER            * ECMWF *     OCTOBER 1991.
C
C     Reference
C     ---------
C
C     None
C
C     Comments
C     --------
C
C     Program contains sections 0 to 2 and 9
C
C     Author
C     ------
C
C     K. Fielding      *ECMWF*      Oct 1993
C
C     Modifications
C     -------------
C
C     Allow for missing data values
C     J.D.Chambers      ECMWF       August 2000
C
C----<
C     -----------------------------------------------------------------|
C
      IMPLICIT NONE
C
#include "parim.h"
#include "nifld.common"
C
C     Function arguments
C
      INTEGER KIWE, KOWE, KPR, KERR
      REAL PIFELD(KIWE), POFELD(KOWE)
C
C     Local variables
C
      INTEGER JILON, JOLON, COUNT
      REAL ZSUM
C
C     Statement function
C
      REAL A, B
      LOGICAL NOTEQ
      NOTEQ(A,B) = (ABS((A)-(B)).GT.(ABS(A)*1E-3))
C
C     -----------------------------------------------------------------|
C*    Section 1. Initialisation
C     -----------------------------------------------------------------|
C
  100 CONTINUE
C
      IF( KPR.GE.1 ) CALL INTLOG(JP_DEBUG,'IGPOLEG: Section 1.',JPQUIET)
C
      IGPOLEG = 0
C
      IF( KPR.GE.1 ) THEN
        CALL INTLOG(JP_DEBUG,'IGPOLEG: No. of input fld longs. = ',KIWE)
        CALL INTLOG(JP_DEBUG,'IGPOLEG: No.of output fld longs. = ',KOWE)
      ENDIF
C
C     -----------------------------------------------------------------|
C*    Section 2. Use average value for non-winds
C     -----------------------------------------------------------------|
C
  200 CONTINUE
C
      IF( KPR.GE.1 ) CALL INTLOG(JP_DEBUG,'IGPOLEG: Section 2.',JPQUIET)
C
      ZSUM = PPZERO
      COUNT = 0
C
      IF( LIMISSV ) THEN
        DO JILON = 1, KIWE
          IF( NOTEQ(PIFELD(JILON),RMISSGV) ) THEN
            ZSUM = ZSUM + PIFELD(JILON)
            COUNT = COUNT + 1
          ENDIF
        ENDDO
      ELSE
        DO JILON = 1, KIWE
          ZSUM = ZSUM + PIFELD(JILON)
          COUNT = COUNT + 1
        ENDDO
      ENDIF
C
      IF( COUNT.GT.0 ) THEN
        ZSUM = ZSUM / REAL(COUNT)
      ELSE
        ZSUM = RMISSGV
      ENDIF
C
      DO JOLON = 1, KOWE
         POFELD(JOLON) = ZSUM
      ENDDO
C
C     -----------------------------------------------------------------|
C*    Section 9. Return to calling routine. Format statements
C     -----------------------------------------------------------------|
C
  900 CONTINUE
C
      IF( KPR.GE.1 ) CALL INTLOG(JP_DEBUG,'IGPOLEG: Section 9.',JPQUIET)
C
C
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities
C granted to it by virtue of its status as an intergovernmental organisation
C nor does it submit to any jurisdiction.
C

        SUBROUTINE JUVPOLE(PSHUP, KTRUNC, PZFA, KLONO, KRET)
C
C---->
C**** JUVPOLE
C
C     Purpose
C     -------
C     This routine creates polar wind U or V components for lat/long
C     grid fields.
C
C
C     Interface
C     ---------
C     CALL JUVPOLE(PSHUP, KTRUNC, PZFA, KLONO, KRET)
C
C
C     Input parameters
C     ----------------
C     PSHUP   - Spherical harmonics field, unpacked
C     KTRUNC  - Truncation number of spherical harmonics field
C     KLONO   - Number of longitude points in output field
C
C
C     Output parameters
C     -----------------
C     PZFA - Output grid point field; contains upto 32 each of
C            North and South latitude rows symmetrically.
C     KRET - Return status code
C            0 = OK
C
C
C     Common block usage
C     ------------------
C     JDCNDBG
C
C
C     Method
C     ------
C     For each pole, creates the reduced gaussian grid lines nearest to
C     the pole and does a linear interpolation to the polar longitude.
C
C
C     Externals
C     ---------
C     JAGGGP  - converts spectral input to a gaussian grid
C     INTLOG  - Output log message
C
C
C     Reference
C     ---------
C     None.
C
C     Comments
C     --------
C     None.
C
C
C     Author
C     ------
C     J.D.Chambers      ECMWF    October 2002
C
C
C     Modifications
C     -------------
C     None.
C
C
C----<
C     -----------------------------------------------------------------|
C
      IMPLICIT NONE
C
#include "jparams.h"
#include "parim.h"
#include "current.h"
#include "nofld.common"
#include "grfixed.h"
C
C     Subroutine arguments
C
      COMPLEX PSHUP(*)
      REAL PZFA(JPLONO + 2, 64)
      INTEGER KTRUNC, KLONO, KRET
C
C     Parameters
C
C     Local variables
C
      REAL EAST, WEST, LAT, POUTF(18), ALATS(320)
      REAL XLONG, WLEFT, XSTEP, GSTEP
      INTEGER KPTS(320), NUM, LOOP, NLEFT, NRIGHT, LUV
      CHARACTER*1 HTYPE
C
C     Externals
C
      INTEGER  IGGLAT
      EXTERNAL IGGLAT
C
C     -----------------------------------------------------------------|
C*    Section 1.  Initialization.
C     -----------------------------------------------------------------|
C
  100 CONTINUE
C
      KRET  = 0
C
      NUM = 160
      GSTEP = 360.0 / 18.0
      XSTEP = 360.0 / REAL(KLONO)
      EAST  = 360.0 - GSTEP
      WEST  = 0.0
C
C     -----------------------------------------------------------------|
C*    Section 2.  Create North pole values
C     -----------------------------------------------------------------|
C
  200 CONTINUE
C
C     Form the N160 reduced gaussian grid latitude near the North pole
C
      LAT = 90.0
      HTYPE = 'R'
      LUV = 1
      CALL JAGGGP(PSHUP, KTRUNC, LAT, LAT, WEST, EAST,
     X            NUM, HTYPE, KPTS, POUTF, LUV, KRET)
      IF( KRET.NE.0 ) THEN
        CALL INTLOG(JP_ERROR,
     X    'JUVPOLE: problem forming Northern gaussian grid latitude',
     X    JPQUIET)
        GOTO 900
      ENDIF
C
C     Interpolate to the lat/long northern latitude grid points
C
      DO LOOP = 1, KLONO
C
C       Find the gaussian neighbours on either side of lat/long point
C       and their weights
C
        XLONG = XSTEP * REAL(LOOP-1)
C
        NLEFT  = 1 + INT(XLONG/GSTEP)
        NRIGHT = NLEFT + 1
        IF( NRIGHT.GT.18 ) NRIGHT = 1
C
        WLEFT = 1.0 - (ABS((XLONG - (NLEFT-1)*GSTEP))/GSTEP)
C
        PZFA(LOOP,1) = POUTF(NLEFT)*WLEFT + POUTF(NRIGHT)*(1.0-WLEFT)
      ENDDO
C
C     -----------------------------------------------------------------|
C*    Section 3.  Create South pole values
C     -----------------------------------------------------------------|
C
  300 CONTINUE
C
C     Store latitude and point count values for the next call to JAGGGP
C     which uses the 'U' option (user supplied values).
C
      NOGAUSO = NUM
C
      KRET  = IGGLAT(NUM*2, ALATS, 1, 1)
      IF( KRET.NE.0 ) THEN
        CALL INTLOG(JP_ERROR, 'JUVPOLE: IGGLAT call failed',KRET)
        KRET = KRET
        GOTO 900
      ENDIF
C
      DO LOOP = 1, NUM*2
        NOLPTS(LOOP)  = KPTS(LOOP)
        ROGAUSS(LOOP) = ALATS(LOOP)
      ENDDO
C
C     Form the N160 reduced gaussian grid latitude near the South pole
C
      LAT = -90.0
      HTYPE = 'U'
      LUV = 1
      CALL JAGGGP(PSHUP, KTRUNC, LAT, LAT, WEST, EAST,
     X            NUM, HTYPE, KPTS, POUTF, LUV, KRET)
      IF( KRET.NE.0 ) THEN
        CALL INTLOG(JP_ERROR,
     X    'JUVPOLE: problem forming Southern gaussian grid latitude',
     X    JPQUIET)
        GOTO 900
      ENDIF
C
C     Interpolate to the lat/long southern latitude grid points
C
      DO LOOP = 1, KLONO
C
C       Find the gaussian neighbours on either side of lat/long point
C       and their weights
C
        XLONG = XSTEP * REAL(LOOP-1)
C
        NLEFT  = 1 + INT(XLONG/GSTEP)
        NRIGHT = NLEFT + 1
        IF( NRIGHT.GT.18 ) NRIGHT = 1
C
        WLEFT = 1.0 - (ABS((XLONG - (NLEFT-1)*GSTEP))/GSTEP)
C
        PZFA(LOOP,2) = POUTF(NLEFT)*WLEFT + POUTF(NRIGHT)*(1.0-WLEFT)
      ENDDO
C
C     -----------------------------------------------------------------|
C*    Section 9.  Return.
C     -----------------------------------------------------------------|
C
 900  CONTINUE
C
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

C
C
      COMMON /BCOMCTC/ CTEXT(JCTEXT)
C
C             CTEXT     - TEXT IN CODE/FLAG TABLES
C

C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      INTEGER FUNCTION TAB2FIL ( KTABLE, KPARAM, KCENTR, HFILE )
C
C---->
C**** TAB2FIL
C
C     Purpose
C     -------
C
C     Build name of file that should contain, if present, the GRIB code
C     table 2 (parameters) associated to data (with valid entries) .
C
C
C     Interface
C     ---------
C
C     IRET = TAB2FIL ( KTABLE, KPARAM, KCENTR )
C
C     Input
C     -----
C
C     KTABLE - Local table 2 version number.
C     KPARAM - Parameter number.
C     KCENTR - Centre number.
C
C
C     Output
C     ------
C
C     HFILE - File name to look for and contact.
C
C     Function return value is:
C            0 - In all current cases .
C
C
C     Method
C     ------
C
C     Checks if environment variable ECMWF_LOCAL_TABLE_PATH exists to
C     define the location of the parameter tables.
C
C     Otherwise, looks for table xxx in:
C
C     ${ELTPATH}/wmostd/table_2_version_xxx for WMO standard entries ;
C
C     ${ELTPATH}/nnnnnn/local_table_2_version_xxx for ECMWF home data
C     where nnnnnn is the current EMOSLIB version ;
C
C     ${ELTPATH}/cenCCC/local_table_2_version_xxx for home data of
C     centre number CCC .
C
C     Entry for each parameter in table has the format (without quotes):
C        "......................"         Separator
C        "051"                            Paramter number
C        "MX2T24"                         MARS mnemonic
C        "Max 2m temp"                    Parameter description
C        "K"                              Units for the parameter
C        "During previous 24 hours"       Further description
C
C     There is a termination "......................" line in the file
C     and there may be lines of comment before the first parameter entry.
C
C     The parameter definition file is kept open between calls.
C
C
C     Externals
C     ---------
C     EMOSNUM - Gives current EMOSLIB version number.
C
C
C     Author
C     ------
C
C     J. Clochard, Meteo France, for ECMWF - June 1999.
C
C
C     MODIFICATIONS
C     _____________
C
C     None.
C
C     _______________________________________________________
C----<
C
C
      IMPLICIT NONE
C
#include "grprs.h"
#include "grbcom.h"
C
C     Function arguments
C
      INTEGER KPARAM, KTABLE, KCENTR
C
      CHARACTER*256 HFILE
C
C     Local variables
C
      INTEGER IEMOSNM, IOFFSET
C
C     External functions
C
      INTEGER EMOSNUM
      EXTERNAL EMOSNUM
C
C
C ------------------------------------------------------------------
C*    Section 1.   Initialise
C ------------------------------------------------------------------
C
  100 CONTINUE
C
      TAB2FIL = 0
C
C     Build filename
C
      HFILE = ELTPATH
      IOFFSET = INDEX( HFILE, ' ')
C
      IF( MAX( KTABLE,KPARAM) .LE. 127 ) THEN
C
        HFILE(IOFFSET:)='wmostd/table_2_version_'
        IOFFSET = INDEX( HFILE, ' ')
C
      ELSE
C
        IF( KCENTR .EQ. 98 ) THEN
C
          IEMOSNM = EMOSNUM(1)
          WRITE(HFILE(IOFFSET:IOFFSET+5),'(I6.6)') IEMOSNM
C
        ELSE
C
          HFILE(IOFFSET:IOFFSET+3)='cen'
          WRITE(HFILE(IOFFSET+3:IOFFSET+5),'(I3.3)') KCENTR
C
        ENDIF
C
        IOFFSET=IOFFSET+6
        HFILE(IOFFSET:)='/local_table_2_version_'
C
      ENDIF
C
      IOFFSET = INDEX( HFILE, ' ')
      WRITE(HFILE(IOFFSET:IOFFSET+2),'(I3.3)') KTABLE
C     print *,'TAB2FIL: HFILE = "' // HFILE(:IOFFSET+2) // '"'
C
C
C ------------------------------------------------------------------
C*    Section 9.   Closedown.
C ------------------------------------------------------------------
C
C     Drop through if not found.
C
      RETURN   
C
      END

      PROGRAM BUCOMPRESS
C
C**** *BUFR*
C
C
C     PURPOSE.
C     --------
C     
C           PACKS BUFR MULTI SUBSET DATA IN THE COMPRESSED FORM
C           THE NUMBER OF SUBSETS TO BE COMPRESSED IS DEFINED IN 
C           THE NAMLIST FILE.
C
C
C**   INTERFACE.
C     ----------
C
C          BUCOMPRESS OUTFILE NAMELIST_FILENAME
C
C     METHOD.
C     -------
C
C          NONE.
C
C
C     EXTERNALS.
C     ----------
C
C         CALL BUSEL
C         CALL BUFREX
C         CALL BUFREN
C         CALL BUPRS0
C         CALL BUPRS1
C         CALL BUPRS2
C         CALL BUPRS3
C         CALL BUPRT
C         CALL BUUKEY
C
C     REFERENCE.
C     ----------
C
C          NONE.
C
C     AUTHOR.
C     -------
C
C          M. DRAGOSAVAC    *ECMWF*       15/09/87.
C
C
C     MODIFICATIONS.
C     --------------
C
C          NONE.
C
C
      IMPLICIT LOGICAL(L,O,G), CHARACTER*8(C,H,Y)
C
      PARAMETER(JSUP =   9,JSEC0=   3,JSEC1= 40,JSEC2=4096 ,JSEC3= 4,
     1       JSEC4=   2,JELEM=160000,JSUBS=400,JCVAL=150 ,JBUFL=512000,
     2          JBPW =  32,JTAB =3000,JCTAB=120,JCTST=1800,JCTEXT=1200,
     3          JWORK=4096000,JKEY=46,JBYTE=512000)
C
      PARAMETER (JTYPE=256)
      PARAMETER (KELEM=20000)
      PARAMETER (KVALS=80000)
C 
      DIMENSION KBUFF(JBUFL)
      DIMENSION KBUFR(JBUFL)
      DIMENSION KSUP(JSUP)  ,KSEC0(JSEC0),KSEC1(JSEC1)
      DIMENSION KSEC2(JSEC2),KSEC3(JSEC3),KSEC4(JSEC4)
      DIMENSION KEY  (JKEY),KREQ(2)
C
      REAL*8 VALUES(KVALS),VALUE(KVALS),VALS(KVALS)
      REAL*8 RVIND,EPS
C
      DIMENSION KTDLST(KELEM),KTDEXP(KELEM)
      DIMENSION KDATA(200)
      DIMENSION ICOMP(JTYPE)
C
      CHARACTER*256 CARG(4),COUT,CFIN
      CHARACTER*64 CNAMES(KELEM)
      CHARACTER*24 CUNITS(KELEM)
      CHARACTER*80 CVALS(KVALS)
      CHARACTER*80 CVAL(KVALS)
      CHARACTER*80 YENC
C
      CHARACTER*5 CFNAME(JTYPE)
C
C      DATA CFNAME/'st001','st002','st003','st004','st005',
C     1            'st009','st011','st012','st013','st014',
C     2            'st019','st021','st022','st023','st051',
C     2            'st061','st062','st063','st071','st072',
C     3            'st073','st082','st083','st084','st085',
C     4            'st091','st092','st095','st101','st102',
C     5            'st103','st104','st105','st106','st121',
C     6            'st122','st123','st124','st125','st127',
C     7            'st128','st131','st132','st133','st142',
C     8            'st144','st145','st164'/
C
C      DATA ICOMP/200,200,200,200,200,
C     1           200,200,200,200,200,
C     2           200,200,200,200,052,
C     2           052,052,052,052,052,
C     3           052,050,050,050,050,
C     4           001,001,001,001,001,
C     5           001,001,001,001,001,
C     5           361,001,001,001,001,
C     7            -1,001,200,200,200,
C     8           100/
C
       DATA CFNAME/JTYPE*' '/
      NAMELIST /COMPRESS/ CFNAME,ICOMP
cs      EXTERNAL GETARG
C                                                                       
C     ------------------------------------------------------------------
C*          1. INITIALIZE CONSTANTS AND VARIABLES.
C              -----------------------------------
 100  CONTINUE
C
C     MISSING VALUE INDICATOR
C 
      RVIND=1.7E38
      NVIND=2147483647
      NREAD=0
      NSUBS=0
      NW=0
      ITOTAL=0
      NBYTES=JBPW/8
C
C
C     GET INPUT AND OUTPUT FILE NAME.
C
      NARG=IARGC()
C
      IF(NARG.LT.4) THEN
         PRINT*,'USAGE -- bufr_compress -i namelist -o outfile'
         STOP
      END IF
C
      DO 101 J=1,NARG
      CALL GETARG(J,CARG(J))
 101  CONTINUE
C
      DO 102 J=1,NARG,2
      IF(CARG(J).EQ.'-i') THEN
         CFIN=CARG(J+1)
      ELSEIF(CARG(J).EQ.'-o') THEN
         COUT=CARG(J+1)
      ELSE
          PRINT*,'USAGE -- bufr_compress -i namelist -o outfile'
          STOP
      END IF
102   CONTINUE
C
      KRQL=0
      NR=0
      KREQ(1)=0
      KREQ(2)=0
C
C*          1.2 OPEN NAMELIST AND OUTPUT FILE
C               -----------------------------
 120  CONTINUE
C
C               OPEN NAMELIST
C
      OPEN(UNIT=60,FILE=CFIN,ERR=125,IOSTAT=IOS,
     1                 STATUS='OLD',
     2                 FORM='FORMATTED')
C
      GO TO 126
C
 125  CONTINUE
C
      PRINT*,'OPEN ERRO ON NAMELIST FILE.'
      CALL MY_EXIT(2)
C
 126  CONTINUE
C
      READ(60,COMPRESS)
      CLOSE(60)
C
C     CHECK HOW MANY FILES IN THE NAMELIST
C
      NFILES=256
C     DO 127 I=1,JTYPE
C     IF(CFNAME(I).EQ.' ') THEN
C        NFILES=I-1
C        GO TO 128
C     END IF
C127  CONTINUE
C
 128  CONTINUE
C
C               OPEN OUTPUT FILE
C
      PRINT*,'NUMBER OF FILES TO PROCESS=',NFILES
      II=INDEX(COUT,' ')
      II=II-1
      CALL PBOPEN(IUNIT1,COUT(1:II),'A',IRET)
      IF(IRET.EQ.-1) STOP 'OPEN FAILED ON OUTPUT FILE'
      IF(IRET.EQ.-2) STOP 'INVALID FILE NAME'
      IF(IRET.EQ.-3) STOP 'INVALID OPEN MODE SPECIFIED'
C
C               OPEN INPUT FILES
C
      DO 121 IO=1,NFILES
C
      IRET=0 
      CALL PBOPEN(IUNIT,CFNAME(IO),'R',IRET)
      IF(IRET.EQ.-1) THEN
        GO TO 121
      END IF
      IF(IRET.EQ.-2) STOP 'INVALID FILE NAME'
      IF(IRET.EQ.-3) STOP 'INVALID OPEN MODE SPECIFIED'
C
C
C     ----------------------------------------------------------------- 
C*          2. SET REQUEST FOR EXPANSION.
C              --------------------------
 200  CONTINUE
C
      ICODE=0
      NCOM=ICOMP(IO)
      OCOMP=.TRUE.
C
C
C     -----------------------------------------------------------------
C*          3.  READ BUFR MESSAGE.
C               ------------------
 300  CONTINUE
C
      IERR=0
      KBUFL=0
C
      IRET=0
      CALL PBBUFR(IUNIT,KBUFF,JBYTE,KBUFL,IRET) 
      IF(IRET.EQ.-1) THEN
         IF(N.NE.0) GO TO 600
         GO TO 122
      END IF
      IF(IRET.EQ.-2) STOP 'FILE HANDLING PROBLEM' 
      IF(IRET.EQ.-3) STOP 'ARRAY TOO SMALL FOR PRODUCT'
C
      NREAD=NREAD+1
      KBUFL=KBUFL/NBYTES+1
C
C     -----------------------------------------------------------------
C*          4. EXPAND BUFR MESSAGE.
C              --------------------
 400  CONTINUE
C
      CALL BUS012(KBUFL,KBUFF,KSUP,KSEC0,KSEC1,KSEC2,KERR)
      IF(KERR.NE.0) THEN
         PRINT*,'ERROR IN BUS012: ',KERR
         PRINT*,' BUFR MESSAGE NUMBER ',N,' CORRUPTED.'
         KERR=0
         GO TO 300
      END IF
C
      KEL=KELEM
      IF(KSUP(6).GT.1) KEL=JWORK/KSUP(6)
C
      CALL BUFREX(KBUFL,KBUFF,KSUP,KSEC0 ,KSEC1,KSEC2 ,KSEC3 ,KSEC4,
     1            KEL,CNAMES,CUNITS,KVALS,VALUES,CVALS,IERR)
C
      IF(IERR.NE.0) THEN
         IF(IERR.EQ.2) THEN
            IERR=0
         ELSE
            CALL MY_EXIT(2)
         END IF
      END IF
C
      NSUBS=NSUBS+KSEC3(3)
C
C     -----------------------------------------------------------------
C*          5. COLLECT DATA FOR REPACKING.
C              ---------------------------
 500  CONTINUE
C      
C               FIRST GET DATA DESCRIPTORS
C
      CALL BUSEL(KTDLEN,KTDLST,KTDEXL,KTDEXP,KERR)
      IF(KERR.NE.0) CALL MY_EXIT(2)
C
C     CHECK IF ANOUGH SPACE FOR COMPRESSION
C
C
C     CHECK FOR MAXIMUM NUMBER OF SUBSETS TO BE PACKED
C
      IF(NCOM.LT.0) THEN
         NCOM=JWORK/KTDEXL
         WRITE(*,'(I4,A,I3)')
     1   NCOM,' SUB-SETS COMPRESSED FOR SUB-TYPE ',KSEC1(7)
      ELSE
         IF(NCOM*KTDEXL.GT.JWORK) THEN
         PRINT*,'TOO MANY SUBSETS TO BE PACKED.'
         PRINT*,'MAXIMUM NUMBER OF SUBSETS TO BE PACKED =',JWORK/KTDEXL
         CALL MY_EXIT(2)
         END IF
      END IF
C
      DO 503 J=1,KSUP(6)
      N=N+1
C
      DO 502 I=1,KSUP(5)
      IV=I+(J-1)*KEL
      IN=I+(N-1)*KSUP(5)
C
      IF(CUNITS(I).EQ.'CCITTIA5') THEN
         IPOS =VALUES(IV)/1000.
         ICHAR=NINT(VALUES(IV)-IPOS*1000)
         KKK=KKK+1
         VALUE(IN)=KKK*1000+ICHAR
         CVAL(KKK)=CVALS(IPOS)
      ELSE
         VALUE(IN)=VALUES(IV)
      END IF
 502  CONTINUE
      IF(N.EQ.NCOM) THEN
        JLAST=J
        GO TO 600
      END IF
 503  CONTINUE
C
      IF(N.EQ.NCOM)    GO TO 600
C
      GO TO 300
C     -----------------------------------------------------------------
C*          6. PACK BUFR MESSAGE BACK INTO BUFR.
C              ---------------------------------
 600  CONTINUE
C
    
      KKK=0
      KSEC3(3)=N
      KSEC1(8)=1
      KSEC3(4)=128                    ! NO COMPRESSION
      IF(KSEC3(3).GT.1) KSEC3(4)=192  ! COMPRESSION
      N=0
      KBUFL=JBUFL
C
C     GET REPLICATION FACTORS
C
      KK=0
      DO 601 K=1,KSUP(5)
      IF(KTDEXP(K).EQ.31001.OR.KTDEXP(K).EQ.31002.OR.
     1   KTDEXP(K).EQ.31011.OR.KTDEXP(K).EQ.31012) THEN
         KK=KK+1
         KDATA(KK)=NINT(VALUES(K))
      END IF
 601  CONTINUE
C
      KDLEN=2
      IF(KK.NE.0) KDLEN=KK
C
C*          6.2 ENCODE DATA INTO BUFR MESSAGE.
C               ------------------------------
 620  CONTINUE
C
C       CALL BUUKEY(KSEC1,KSEC2,KEY,KSUP,KERR)
C
C      PACK RDB KEY
C
C
       KLM=KSUP(5)
C
       CALL SETLALO(KSEC1(7),KLA,KLO,KERR)
       IF(KERR.NE.0) CALL MY_EXIT(2)
C
       CALL FMMH( KLA,KLO,KLM,VALUE,KSEC3,RMINLAT,RMINLON,
     1           RMAXLAT,RMAXLON)
C       CALL BUUKEY(KSEC1,KSEC2,KEY,KSUP,KERR)
C       IF(KERR.NE.0) THEN
C          CALL MY_EXIT(2)
C       END IF
C
       MINLAT=NINT(RMINLAT*100000)+9000000
       MAXLAT=NINT(RMAXLAT*100000)+9000000
       MINLON=NINT(RMINLON*100000)+18000000
       MAXLON=NINT(RMAXLON*100000)+18000000
C
       KEY(10)=MINLON
       KEY(11)=MINLAT
       KEY(12)=MAXLON
       KEY(13)=MAXLAT
       KEY(14)=KSEC3(3)
C
C       CALL BUPKEY(KEY,KSEC1,KSEC2,KERR)
C       IF(KERR.NE.0) THEN
C          PRINT*,'FILE IN PROCESS IS ',CFNAME(IO)
C          CALL MY_EXIT(2)
C       END IF
C
       CALL BUFREN( KSEC0,KSEC1,KSEC2,KSEC3,KSEC4,
     1              KTDLEN,KTDLST,KDLEN,KDATA,KSUP(5),
     2              KVALS,VALUE,CVAL,KBUFL,KBUFR,KERR)
C
      IF(KERR.NE.0) THEN
         PRINT*,'ERROR DURING ENCODING.'
         CALL MY_EXIT(2)
      END IF
C
C           6.3 WRITE PACKED BUFR MESSAGE INTO FILE.
C               ------------------------------------
 630  CONTINUE
C
      ILEN=KBUFL*NBYTES
C     
      IERR=0
      CALL PBWRITE(IUNIT1,KBUFR,ILEN,IERR)
      IF(IERR.LT.0)  THEN
         PRINT*,'PBWRITE: WRITE ERROR ',IERR
         CALL MY_EXIT(2)
      END IF
C
      ITOTAL=ITOTAL+KSEC3(3)
C
      IF(IRET.EQ.-1) THEN
         NW=NW+1
         GO TO 122
      END IF
C
      NW=NW+1
C
      N=0
      IF(JLAST.LT.KSUP(6)) THEN
C
C        MOVE THE REST OF DATA INTO VALUE ARRAY
C
         DO 505 J=JLAST+1,KSUP(6)
         N=N+1
         DO 504 I=1,KSUP(5)
         IV=I+(J-1)*KEL
         IN=I+(N-1)*KSUP(5)
C
         IF(CUNITS(I).EQ.'CCITTIA5') THEN
            IPOS =VALUES(I)/1000.
            ICHAR=NINT(VALUES(IV)-IPOS*1000)
            KKK=KKK+1
            VALUE(IN)=KKK*1000+ICHAR
            CVAL(KKK)=CVALS(IPOS)
         ELSE
            VALUE(IN)=VALUES(IV)
         END IF
 504     CONTINUE
 505     CONTINUE
      END IF
C
      IF(NCOM.LE.KSUP(6)-JLAST) THEN
         KSUP(6)=KSUP(6)-JLAST
         N=0
        GO TO 500
      END IF
C
      GO TO 300
C
 122  CONTINUE
C
      IRET=0
      CALL PBCLOSE(IUNIT,IRET)
C
 121  CONTINUE
C
C     -----------------------------------------------------------------
 900  CONTINUE
C
       PRINT*,'NUMBER OF MESSAGES READ        ',NREAD
       PRINT*,'NUMBER OF MESSAGES WRITTEN     ',NW
       PRINT*,'NUMBER OF SUBSETS              ',NSUBS
       PRINT*,'NUMBER OF OBSERVATIONS WRITTEN ',ITOTAL
C
      CALL PBCLOSE(IUNIT1,IRET)
C
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities
C granted to it by virtue of its status as an intergovernmental organisation
C nor does it submit to any jurisdiction.
C

      INTEGER FUNCTION INTFB(INGRIB,INLEN,OUTGRIB,OUTLEN,FLDOUT)
C
C---->
C**** INTFB
C
C     Purpose
C     -------
C
C     Interpolate input field...
C
C
C     Interface
C     ---------
C
C     IRET = INTFB( INGRIB,INLEN,OUTGRIB,OUTLEN,FLDOUT)
C
C     Input
C     -----
C
C     INGRIB - Input field (packed).
C     INLEN  - Input field length (words).
C
C
C     Output
C     ------
C
C     OUTGRIB - Output field (packed).
C     OUTLEN  - Output field length (words).
C     FLDOUT  - Output field (unpacked).
C
C
C     Method
C     ------
C
C     Call interpolation routines; then repack if GRIB output.
C
C     Currently, subareas are not supported for reduced gaussian fields.
C     (Works OK; but need to setup values in GRIB product for number of
C      points in each latitude row)
C
C
C     Externals
C     ---------
C
C     IARCNTL - Control interp. quasi reg.Gauss -> Gaussian or lat/long
C     IAGCNTL - Control interpolation reg.Gaussian or lat/long fields.
C     JALLGP  - Converts spectral fields to lat/long grid fields.
C     JALLWN  - Converts spectral wind fields to lat/long grids.
C     JSLLGP  - Converts strectched spectral fields to lat/long grid fields.
C     JAGGGP  - Converts spectral fields to a gaussian grid field.
C     JSGGGP  - Converts strectched spectral fields to a gaussian grid field.
C     GRIBEX  - Decode/encode GRIB product.
C     IGSETUP - Setup GRIB sections for the output product.
C     JMEMHAN - Handles memory allocation.
C     IGLSIZE - Evaluate array sizes for reg. lat/long and area.
C     IGSIZE  - Evaluate array sizes for a regular Gaussian.
C     IRSIZE  - Evaluate array sizes for a quasi reg Gaussian.
C     FIXAREA - Fixup area definition to correspond to grid definitions
C     ISCRSZ  - Calculate number of values in generated field.
C     JDEBUG  - Checks environment to switch on/off debug
C     INTLOG  - Log error message.
C     OCEANP  - Interpolate GRIB ocean field.
C     MKBITMP - Apply a bitmap to a rectangular field.
C     MKFRAME - Create a 'frame' from a rectangular field.
C     DDSTYLE - Create subgrid by selecting pts from rectangular grid.
C     DSSAREA - Fixup field area (dissemination style).
C     INTISL  - Interpolate a field using ISLSCP processing.
C     KRG2RG  - Interpolate reduced gaussian to reduced gaussian (packed)
C     KRG2RGU - Interpolate reduced gaussian to reduced gaussian (unpacked)
C     KRG2RGD - Interpolate reduced gaussian to reduced gaussian
c               using intermediate interpolation
C
C
C     Author
C     ------
C
C     J.D.Chambers     ECMWF     Aug 1994
C
C     J.D.Chambers     ECMWF        Feb 1997
C     Allow for 64-bit pointers
C
C----<
C
C     IMPLICIT NONE
C
C     Function arguments
C
      INTEGER INGRIB(*),OUTGRIB(*),INLEN,OUTLEN
      REAL FLDOUT(*)
C
#include "parim.h"
#include "nifld.common"
#include "nifld.extracommon"
#include "nofld.common"
#include "grfixed.h"
#include "intf.h"
#include "jparams.h"
C
C     Parameters
C
      INTEGER JPROUTINE
      INTEGER JUNPACK
      PARAMETER (JPROUTINE = 26400 )
      PARAMETER (JUNPACK = 3000000)
C
C     Local variables
C
      REAL EW, NS, NORTH, SOUTH, WEST, EAST, RTEMP
      INTEGER IWORD, IERR, ILENF, ISIZE, IUV, IDISTEP
      REAL PNORTH, PSOUTH, PWEST, PEAST, PLATINC, PLONINC
      LOGICAL OIWEGLOBE, OINPOLE, OISPOLE
      LOGICAL OOWEGLOBE, OONPOLE, OOSPOLE
      LOGICAL LBITMP,LFRAME,LSTYLE,LGLOBAL,LSAMERS,LIQUASI
      LOGICAL LOLDLSP, LOLDLSM
      INTEGER INORTH, ISOUTH, IEAST
      INTEGER HOLDEW, HOLDNS, N_NOWE, N_NONS
      INTEGER KILN, KITOTAL, KOLN, KOTOTAL, KPR, KERR
      INTEGER LOOP, LOOPI, NEXT, ISWAP, NTRUNC, NTROLD, NTROLD2
      INTEGER LENMED
      INTEGER ILENS
      REAL*8 DISSRES
C
      DATA NTROLD/-1/, NTROLD2/-1/
      SAVE NTROLD, NTROLD2
      CHARACTER*1 HTYPE
      CHARACTER*1 HFUNC
#ifndef _CRAYFTN
#ifdef POINTER_64
#ifndef FUJITSU
      INTEGER*8 IZNFLDO
#endif
#endif
#endif
      REAL ZNFLDO , RWORK
      DIMENSION RWORK(JUNPACK)
      POINTER ( IZNFLDO, ZNFLDO )
      DIMENSION ZNFLDO( 1 )
      INTEGER NEWLSM(1), OLDLSM(1)
      POINTER( NIPNGRB, NEWLSM )
      POINTER( NIPOGRB, OLDLSM )
      LOGICAL LFIRST
      DATA LFIRST/.TRUE./
      SAVE LFIRST
C
C     Externals
C
      INTEGER IGLSIZE, IGSIZE, IRSIZE, IARCNTL, IAGCNTL, DSSAREA
      INTEGER IGSETUP, FIXAREA, ISCRSZ, AURESOL, MKBITMP !, OCEANP
      INTEGER INTISL, KRG2RG, KRG2RGU,KRG2RGZ, KRG2RGD, KRG2RGY
      CHARACTER*1 GGHTYPE
      EXTERNAL GGHTYPE
C
C     -----------------------------------------------------------------|
C*    Section 1.   Initialise
C     -----------------------------------------------------------------|
C
  100 CONTINUE
      HOLDEW = 0
      HOLDNS = 0
      IERR   = 0
      N_NONS = 0
      N_NOWE = 0
      INTFB = 0
C
C     Check if debug option turned on
      CALL JDEBUG()
      KPR = NDBG
C
      LBITMP = LNOBITMP.AND.
     X         ((NOREPR.EQ.JPREGROT).OR.(NOREPR.EQ.JPREGULAR).OR.
     X          (NOREPR.EQ.JPGAUSSIAN))
C
      LFRAME = LNOFRAME.AND.
     X         ((NOREPR.EQ.JPREGULAR).OR.(NOREPR.EQ.JPGAUSSIAN).OR.
     X          (NOREPR.EQ.JPREGROT ).OR.(NOREPR.EQ.JPFGGROT  ) )
C
      LSTYLE = LNOSTYLE.AND.
     X         (NOSTYLE.EQ.JPSDISM).AND.
     X         (NOREPR.EQ.JPREGULAR)
C
      IF( .NOT.LWINDSET ) THEN
        LWIND = ( ((NOTABLE.EQ.128).OR.(NOTABLE.EQ.129)).AND.
     X            ((NOPARAM.EQ.131).OR.(NOPARAM.EQ.132).OR.
     X            (NOPARAM.EQ.165).OR.(NOPARAM.EQ.166)) )
      ENDIF
      CALL INTLOG(JP_DEBUG,'INTFB: Wind flag = ', LWIND)
      IF( LWIND ) THEN
        IUV = 1
      ELSE
        IUV = 0
      ENDIF
C
        IF(NIFORM.EQ.1) THEN
          ILENS = ISEC4(1)
        ELSE
          ILENS = INLEN
        ENDIF

C
C     If dissemination style selection of grid points is required,
C     adjust the sub-area limits to the dissemination grid.
C
      IF( LSTYLE ) THEN
        IDISTEP = NINT(JPDISTP*PPMULT)
        EW    = NOGRID(1) / PPMULT
        NS    = NOGRID(2) / PPMULT
        NORTH = REAL(NOAREA(1)) / PPMULT
        WEST  = REAL(NOAREA(2)) / PPMULT
        SOUTH = REAL(NOAREA(3)) / PPMULT
        EAST  = REAL(NOAREA(4)) / PPMULT
C
        IERR = DSSAREA( EW, NS, NORTH, WEST, SOUTH, EAST)
        IF( IERR.NE.0 ) THEN
          CALL INTLOG(JP_ERROR,'INTFB: DSSAREA failed:',IERR)
          INTFB = IERR
          GOTO 900
        ENDIF
C
        N_NOWE = NINT((EAST-WEST)/EW) + 1
        N_NONS = NINT((NORTH-SOUTH)/NS) + 1
C
        NOAREA(1) = NINT(NORTH * PPMULT)
        NOAREA(2) = NINT(WEST  * PPMULT)
        NOAREA(3) = NINT(SOUTH * PPMULT)
        NOAREA(4) = NINT(EAST  * PPMULT)
      ENDIF
C
C     If Hirlam 12-point rotation involved, it has already been done
C     (in INTFAPH), so just copy values to array for packing.
C
      IF( LUSEHIR.AND.LNOROTA ) THEN
        ISIZE = ISEC4(1)
        IF( ISIZE.EQ.0 ) ISIZE = OUTLROT
        CALL JMEMHAN( 3, IZNFLDO, ISIZE, 1, IERR)
        IF( IERR.NE.0 ) THEN
          CALL INTLOG(JP_FATAL,'INTFB: Get scratch space fail',JPQUIET)
          INTFB = JPROUTINE + 1
          GOTO 900
        ENDIF
C
        DO LOOP = 1, ISIZE
          ZNFLDO(LOOP) = ZNFELDI(LOOP)
        ENDDO
        GOTO 700
      ENDIF
C
C     -----------------------------------------------------------------|
C*    Section 2.   Special cases!
C     -----------------------------------------------------------------|
C
  200 CONTINUE
C
C     Allocate work array ZNFELDI if not already done.
C
      IF( IZNJDCI.NE.1952999238 ) THEN
        CALL JMEMHAN( 19, IZNFLDI, JPEXPAND, 1, ierr)
        IF( IERR.NE.0 ) THEN
          CALL INTLOG(JP_ERROR,'INTFB: znfeldi allocate fail',JPQUIET)
          INTFB = IERR
          GOTO 900
        ENDIF
        IZNJDCI = 1952999238
      ENDIF
C
C     Is the interpolation from SH to grid point
C
      IF( ((NIREPR.EQ.JPSPHERE).OR.(NIREPR.EQ.JPSPHROT).OR.
     X     (NIREPR.EQ.JPSTRSH))
     X    .AND.
     X    ((NOREPR.NE.JPSPHERE).AND.(NOREPR.NE.JPSPHROT)) ) THEN
C
        NTRUNC = NORESO
C
C       Check whether a truncation is required before interpolation
C
        IF( .NOT.LNORESO ) THEN
C
C         If user did not supply a truncation value, see whether or
C         not the 'autoresol' flag is set. If not, use the input
C         truncation.
C
          IF( LARESOL ) THEN
            IF( (NOREPR.EQ.JPREGULAR).OR.(NOREPR.EQ.JPREGROT) ) THEN
              EW = FLOAT(NOGRID(1))/PPMULT
              NS = FLOAT(NOGRID(2))/PPMULT
            ELSE
              EW = 90.0/FLOAT(NOGAUSS)
              NS = EW
            ENDIF
            NTRUNC = AURESOL(EW,NS)
            IF( NTRUNC.NE.NTROLD ) THEN
              NTROLD = NTRUNC
              CALL INTLOG(JP_WARN,
     X          'INTFB: Resolution automatically set to ', NTRUNC)
            ENDIF
          ELSE
            NTRUNC = NIRESO
          ENDIF
C
        ELSE
C
C
        ENDIF
C
C       Check whether the output resolution is greater than the input
C
        IF( NTRUNC.GT.NIRESO ) THEN
C
C         Issue warning if the output resolution was user-supplied
C
          IF( .NOT.LARESOL ) THEN
C
C           Revert to the input truncation
C
            IF( NIRESO.NE.NTROLD2 ) THEN
              CALL INTLOG(JP_WARN,
     X          'INTFB: spectral -> grid point interpolation',JPQUIET)
              CALL INTLOG(JP_WARN,
     X          'INTFB: User supplied resolution = ',NTRUNC)
              CALL INTLOG(JP_WARN,
     X          'INTFB: Input field resolution   = ',NIRESO)
              CALL INTLOG(JP_WARN,
     X          'INTFB: User supplied resolution ignored',JPQUIET)
              CALL INTLOG(JP_WARN,
     X          'INTFB: Input field resolution has been used',JPQUIET)
              NTROLD2 = NIRESO
            ENDIF
            NTRUNC = NIRESO
C
          ELSE
C
C           Revert to the input truncation if auto RESOL
C
            NTRUNC = NIRESO
            IF( NTRUNC.NE.NTROLD2 ) THEN
              NTROLD2 = NTRUNC
              CALL INTLOG(JP_WARN,
     X          'INTFB: Automatic resolution selectn too high:',JPQUIET)
              CALL INTLOG(JP_WARN,
     X          'INTFB: Resolution reset to input resolution: ',NTRUNC)
            ENDIF
          ENDIF
C
        ENDIF
C
C       Truncate if a smaller resolution has been requested
C
        IF( NTRUNC.LT.NIRESO ) THEN
          CALL INTLOG(JP_DEBUG,
     X      'INTFB: Spectral coefficents truncated to ', NTRUNC)
C
          ISIZE =  (NTRUNC+1)*(NTRUNC+4)
          CALL JMEMHAN( 3, IZNFLDO, ISIZE, 1, IERR)
          IF( IERR.NE.0 ) THEN
            CALL INTLOG(JP_FATAL,
     X        'INTFB: Get scratch space failed',JPQUIET)
            INTFB = JPROUTINE + 2
            GOTO 900
          ENDIF
C
C         Generate spherical harmonics with output truncation
C
          CALL SH2SH( ZNFELDI, NIRESO, ZNFLDO, NTRUNC )
C
C         Move new spherical harmonics to 'input' array
C
          DO LOOP = 1, ISIZE
            ZNFELDI(LOOP) = ZNFLDO(LOOP)
          ENDDO
C
          NIRESO = NTRUNC
C
        ENDIF
C
      ENDIF
C
C     Is it an ocean field interpolation?
C
c sinisa this is all done in intf
c      IF( (ISEC1(24).EQ.1)       .AND.
c     X    (ISEC1(37).EQ.4)       .AND.
c     X    (NIFORM.EQ.1)          .AND.
c     X    (NOFORM.EQ.1) ) THEN
c        IERR = OCEANP(INGRIB,INLEN,OUTGRIB,OUTLEN)
c        IF( IERR.NE.0 ) THEN
c          CALL INTLOG(JP_ERROR,
c     X      'INTFB: Ocean interpolation failed.',JPQUIET)
c          INTFB = JPROUTINE + 2
c        ELSE
c          CALL INTLOG(JP_DEBUG,
c     X      'INTFB: Ocean interpolation finished successfully.',JPQUIET)
c        ENDIF
c        GOTO 900
c      ENDIF
C
C     -----------------------------------------------------------------|
C*    Section 3.   Interpolation spherical harmonics to spherical
C                  harmonics
C     -----------------------------------------------------------------|
C
  300 CONTINUE
C
      IF( ((NIREPR.EQ.JPSPHERE).OR.(NIREPR.EQ.JPSPHROT)) .AND.
     X    ((NOREPR.EQ.JPSPHERE).OR.(NOREPR.EQ.JPSPHROT) ) ) THEN
C
C       Get scratch space for interpolation
C
        CALL INTLOG(JP_DEBUG,'INTFB: SH -> SH, input is ',NIRESO)
        CALL INTLOG(JP_DEBUG,'INTFB:          output is ',NORESO)
        ISIZE = ISCRSZ()
        IF( ISIZE.LE.0 ) THEN
          CALL INTLOG(JP_ERROR,'INTFB: Get scratch space failed.',ISIZE)
          INTFB = JPROUTINE + 2
          GOTO 900
        ENDIF
        CALL JMEMHAN( 3, IZNFLDO, ISIZE, 1, IERR)
        IF( IERR.NE.0 ) THEN
          CALL INTLOG(JP_ERROR,'INTFB: Get scratch space fail.',JPQUIET)
          INTFB = JPROUTINE + 2
          GOTO 900
        ENDIF
C
        CALL SH2SH( ZNFELDI, NIRESO, ZNFLDO, NORESO )
C
        GOTO 700
C
C     If not spectral -> spectral transformation, make sure the input
C     and output area definitions have been setup.
C
      ELSE
C
C       Fixup area definition to correspond to grid definitions
C
        IF( .NOT.LSTYLE ) THEN
          IERR = FIXAREA()
          IF( IERR.NE.0 ) THEN
            CALL INTLOG(JP_ERROR,
     X        'INTFB: Fixup area definition failed.',JPQUIET)
            INTFB = JPROUTINE + 9
            GOTO 900
          ENDIF
        ENDIF
C
C       Setup geographical limits
C
        PNORTH = FLOAT( NOAREA(1) ) / PPMULT
        PWEST  = FLOAT( NOAREA(2) ) / PPMULT
        PSOUTH = FLOAT( NOAREA(3) ) / PPMULT
        PEAST  = FLOAT( NOAREA(4) ) / PPMULT
C
      ENDIF
C
C     -----------------------------------------------------------------|
C     Section 4.   Interpolation spherical harmonics to grid point.
C     -----------------------------------------------------------------|
C
  400 CONTINUE
C
      IF( (NIREPR.EQ.JPSPHERE).OR.
     X    (NIREPR.EQ.JPSTRSH) .OR.
     X    (NIREPR.EQ.JPSPHROT) ) THEN
#ifndef REAL_8
C
C       Check that double precision floats are in use if spectral
C       resolution is greater than T213
C
        IF( NIRESO.GT.213 ) THEN
          CALL INTLOG(JP_ERROR,
     X      'INTFB: Double precision must be used',JPQUIET)
          CALL INTLOG(JP_ERROR,'INTFB: for spectral resolution ',NIRESO)
          INTFB = JPROUTINE + 2
          GOTO 900
        ENDIF
#endif
        CALL INTLOG(JP_DEBUG,'INTFB: SH -> grid point',JPQUIET)
C
C       Get scratch space for interpolation
C       If dissemination style, space has to be for a 0.5x0.5 grid
C
        IF( LSTYLE ) THEN
c to be consistant with product generation
           IF(NIRESO.EQ.1279) THEN
              DISSRES = 0.125
           ELSEIF(NIRESO.EQ.799) THEN
              DISSRES = 0.25
           ELSEIF(NIRESO.EQ.639) THEN
              DISSRES = 0.25
           ELSEIF(NIRESO.EQ.511) THEN
              DISSRES = 0.5
           ELSEIF(NIRESO.EQ.399) THEN
              DISSRES = 0.5
           ELSEIF(NIRESO.EQ.319) THEN
              DISSRES = 0.5
           ELSEIF(NIRESO.EQ.255) THEN
              DISSRES = 0.5
           ELSEIF(NIRESO.EQ.155) THEN
              DISSRES = 1.5
           ELSE
              DISSRES = NOGRID(1) / PPMULT
            CALL INTLOG(JP_WARN,'INTFB: Diss resol set to: ',NOGRID(1))
           ENDIF
          IDISTEP = NINT(DISSRES*PPMULT)
C
          HOLDEW = NOGRID(1)
          HOLDNS = NOGRID(2)
          NOGRID(1) = IDISTEP
          NOGRID(2) = IDISTEP
        ENDIF
        ISIZE = ISCRSZ()
        IF( ISIZE.LE.0 ) THEN
          CALL INTLOG(JP_ERROR,'INTFB: Get scratch space failed.',ISIZE)
          INTFB = JPROUTINE + 4
          GOTO 900
        ENDIF
C
        CALL JMEMHAN( 3, IZNFLDO, ISIZE, 1, IERR)
        IF( IERR.NE.0 ) THEN
          CALL INTLOG(JP_ERROR,'INTFB: Get scratch space fail.',JPQUIET)
          INTFB = JPROUTINE + 4
          GOTO 900
        ENDIF
        IF( LSTYLE ) THEN
          NOGRID(1) = HOLDEW
          NOGRID(2) = HOLDNS
        ENDIF
C
C     -----------------------------------------------------------------|
C*    Section 4.1  Interpolation spherical harmonics to grid point.
C     -----------------------------------------------------------------|
C
  410 CONTINUE
C
        IF( (NOREPR.EQ.JPREGULAR) .OR. (NOREPR.EQ.JPREGROT) ) THEN
          CALL INTLOG(JP_DEBUG,'INTFB: SH -> lat/long',JPQUIET)
C
C         -> latitude/longitude grid
C         If dissemination style, generated grid is 0.5x0.5
C
          IF( LSTYLE ) THEN
            HOLDEW = NOGRID(1)
            HOLDNS = NOGRID(2)
            NOGRID(1) = IDISTEP
            NOGRID(2) = IDISTEP
          ENDIF
          PLONINC = FLOAT( NOGRID(1) ) / PPMULT
          PLATINC = FLOAT( NOGRID(2) ) / PPMULT
C
C         Special handling for stretched fields
C
          IF( RISTRET.NE.0 ) THEN
            CALL JSLLGP( ZNFELDI, NIRESO, PNORTH, PSOUTH, PWEST, PEAST,
     X                   PLATINC, PLONINC, ZNFLDO, IERR)
C
          ELSE
            IF( LWIND ) THEN
              CALL JALLWN(ZNFELDI, NIRESO, PNORTH, PSOUTH, PWEST, PEAST,
     X                    PLATINC, PLONINC, ZNFLDO, IERR)
            ELSE
              CALL JALLGP(ZNFELDI, NIRESO, PNORTH, PSOUTH, PWEST, PEAST,
     X                    PLATINC, PLONINC, ZNFLDO, IERR)
            ENDIF
          ENDIF
C
          IF( IERR.NE.0 ) THEN
            CALL INTLOG(JP_ERROR,
     X        'INTFB: Interpolation to lat/long field failed.',JPQUIET)
            INTFB = JPROUTINE + 4
            GOTO 900
          ENDIF
C
          IF( LSTYLE ) THEN
            NOGRID(1) = HOLDEW
            NOGRID(2) = HOLDNS
          ENDIF
C
          GOTO 700
C
        ENDIF
C
C
        IF ((NOREPR.EQ.JPGAUSSIAN).OR.(NOREPR.EQ.JPQUASI)) THEN
C
C         -> regular/reduced gaussian grid
C
          HTYPE = ''
          IF (NOREPR.EQ.JPGAUSSIAN) THEN
          CALL INTLOG(JP_DEBUG,'INTFB: SH -> regular gaussian',JPQUIET)
C           Is it a user_regular_gaussian (or standard regular gaussian)..
            HTYPE = 'F'
            IF (LOGIVEL) HTYPE = 'U'
          ELSE
          CALL INTLOG(JP_DEBUG,'INTFB: SH -> reduced gaussian',JPQUIET)
            HTYPE = 'R'
            IF (LOCTAHEDRAL) HTYPE = 'O'
            IF (LOGIVEP)     HTYPE = 'U'
          ENDIF
C
C         Special handling for stretched fields
C
          IF( RISTRET.NE.0 ) THEN
            CALL JSGGGP(ZNFELDI, NIRESO, PNORTH, PSOUTH, PWEST, PEAST,
     X                  NOGAUSS, HTYPE, NOLPTS, ZNFLDO, IUV, IERR)
          ELSE
            CALL JAGGGP(ZNFELDI, NIRESO, PNORTH, PSOUTH, PWEST, PEAST,
     X                  NOGAUSS, HTYPE, NOLPTS, ZNFLDO, IUV, IERR)
C
          ENDIF
          IF( IERR .NE. 0 ) THEN
            CALL INTLOG(JP_ERROR,
     X        'INTFB: Interpolation to gaussian field failed.',JPQUIET)
            INTFB = JPROUTINE + 4
            GOTO 900
          ENDIF
C
          GOTO 700
C
        ENDIF
C
C
C       Dropthrough => unrecognized output field type
C
        IERR  = JPROUTINE + 4
        CALL INTLOG(JP_ERROR,
     X    'INTFB: Unrecognized output field type.',NOREPR)
        INTFB = IERR
        GOTO 900
C
      ENDIF
C
C     -----------------------------------------------------------------|
C     Section 5.   Interpolate Gaussian grid to grid point.
C     -----------------------------------------------------------------|
C
  500 CONTINUE
C
C       If Hirlam 12-point rotation involved, it has already been done
C       (in INTFAPH), so just copy values to array for packing.
C
        IF( LUSEHIR.AND.LNOROTA ) THEN
C
          ISIZE = ISCRSZ()
          IF( ISIZE.LE.0 ) THEN
            CALL INTLOG(JP_ERROR,
     X        'INTFB: Get scratch space fail',ISIZE)
            INTFB = JPROUTINE + 5
            GOTO 900
          ENDIF
          CALL JMEMHAN( 3, IZNFLDO, ISIZE, 1, IERR)
          IF( IERR.NE.0 ) THEN
            CALL INTLOG(JP_FATAL,
     X        'INTFB: Get scratch space failed',JPQUIET)
            INTFB = JPROUTINE + 5
            GOTO 900
          ENDIF
C
          DO LOOP = 1, ISIZE
            ZNFLDO(LOOP) = ZNFELDI(LOOP)
          ENDDO
          GOTO 700
        ENDIF
C
C     Handle ISLSCP processing
C
      IF( LNIISCL ) THEN
        CALL INTLOG(JP_DEBUG,'INTFB: Using ISLSCP processing',JPQUIET)
        IERR = INTISL(OLDLSM, INGRIB, NEWLSM, OUTGRIB)
        IF( IERR.LT.0 ) THEN
          CALL INTLOG(JP_ERROR,'INTFB: ISLSCP processing fail',NIGAUSS)
          INTFB = JPROUTINE + 10
          GOTO 900
        ENDIF
        OUTLEN = (IERR+JPBYTES-1)/JPBYTES
        GOTO 900
      ENDIF
C
C     Reduced gaussian to reduced gaussian
C
      LIQUASI = (NIREPR.EQ.JPQUASI)
C
      IF( (LIQUASI.AND.(NOREPR.EQ.JPQUASI)) ) THEN
        IF( LDOUBLE ) THEN
          CALL INTLOG(JP_DEBUG,'INTFB: RG to RG with intermediate'
     X    ,JPQUIET)
            IF(NIFORM.EQ.1)  THEN
               IERR = KRG2RGD(INGRIB,OUTGRIB,NOMEGA,NOGAUSS)
               IF(IERR.LT.0) THEN
                 CALL INTLOG(JP_ERROR,
     X             'INTFB: KRG2RGD processing failed',JPQUIET)
                 INTFB = JPROUTINE + 10
               ELSE
                 OUTLEN = (IERR+JPBYTES-1)/JPBYTES
               ENDIF
             ELSE
               CALL INTLOG(JP_DEBUG,
     X         'INTF: RG to RG intermediate unpacked',JPQUIET)
              IERR = KRG2RGZ(INGRIB,RWORK,NIGAUSS,NOMEGA)
              IF(IERR.LT.0) THEN
                CALL INTLOG(JP_ERROR,
     X            'INTFB: KRG2RGZ processing failed',JPQUIET)
                INTFB = JPROUTINE + 10
                GOTO 900
              ELSE
                OUTLEN = IERR
              ENDIF
C             Second step
              LDOUBLE = .FALSE.
              IERR = KRG2RGZ(RWORK,FLDOUT,NOMEGA,NOGAUSS)
              LDOUBLE = .TRUE.
              IF(IERR.LT.0) THEN
                CALL INTLOG(JP_ERROR,
     X            'INTFB: KRG2RGZ processing failed',JPQUIET)
                INTFB = JPROUTINE + 10
                GOTO 900
              ELSE
                OUTLEN = IERR
              ENDIF

             ENDIF
        ELSE
            IF(NIFORM.EQ.1)  THEN
              CALL INTLOG(JP_DEBUG,'INTFB: RG to RG packed',JPQUIET)
              IERR = KRG2RG(INGRIB,OUTGRIB,NOGAUSS)
              IF(IERR.LT.0) THEN
                CALL INTLOG(JP_ERROR,
     X            'INTFB: KRG2RG processing failed',JPQUIET)
                INTFB = JPROUTINE + 10
              ELSE
                OUTLEN = (IERR+JPBYTES-1)/JPBYTES
              ENDIF
            ELSE
              CALL INTLOG(JP_DEBUG,'INTFB: RG to RG unpacked',JPQUIET)
              IERR = KRG2RGU(INGRIB,FLDOUT,NIGAUSS,NOGAUSS)
              IF(IERR.LT.0) THEN
                CALL INTLOG(JP_ERROR,
     X            'INTFB: KRG2RGU processing failed',JPQUIET)
                INTFB = JPROUTINE + 10
              ELSE
                OUTLEN = IERR
              ENDIF
            ENDIF
        ENDIF
        GOTO 900
      ENDIF
C
C     Setup flags for input and output fields
C
      CALL INTLOG(JP_DEBUG,'INTFB: grid point -> grid point.',JPQUIET)
      KERR = 1
      IF( NIREPR .EQ. JPQUASI ) THEN
        CALL INTLOG(JP_DEBUG,'INTFB: quasi input ',NIGAUSS)
        IERR = IRSIZE( NIGAUSS, NIAREA, MILLEN, NIWE, NINS, KILN,
     X                 KITOTAL, RIGAUSS, OIWEGLOBE, OINPOLE, OISPOLE,
     X                 KPR, KERR)
      ELSE IF( NIREPR.EQ.JPGAUSSIAN ) THEN
        CALL INTLOG(JP_DEBUG,'INTFB: regular gauss input ',NIGAUSS)
        IERR = IGSIZE( NIGAUSS, NIAREA, NIWE, NINS, KILN, RIGAUSS,
     X                    OIWEGLOBE, OINPOLE, OISPOLE, KPR, KERR)
      ELSE
        CALL INTLOG(JP_DEBUG,'INTFB: lat/long input lat ',NIGRID(1))
        CALL INTLOG(JP_DEBUG,'INTFB: lat/long input long ',NIGRID(2))
        IERR = IGLSIZE( NIGRID, NIAREA, NIWE, NINS, KILN, OIWEGLOBE,
     X                  OINPOLE, OISPOLE, KPR, KERR)
      ENDIF
C
      NONS = 0
      NOWE = 0
      IF( (NOREPR.EQ.JPQUASI).OR.(NOREPR.EQ.JPQGGROT) ) THEN
        CALL INTLOG(JP_DEBUG,'INTFB: quasi output ',NOGAUSS)
        IERR = IRSIZE( NOGAUSS, NOAREA, NOLPTS, NOWE, NONS, KOLN,
     X                 KOTOTAL, ROGAUSS, OOWEGLOBE, OONPOLE, OOSPOLE,
     X                 KPR, KERR)
      ELSE IF( (NOREPR.EQ.JPGAUSSIAN).OR.(NOREPR.EQ.JPFGGROT) ) THEN
        CALL INTLOG(JP_DEBUG,'INTFB: regular gauss output ',NOGAUSS)
        IERR = IGSIZE( NOGAUSS, NOAREA, NOWE, NONS, KOLN, ROGAUSS,
     X                    OOWEGLOBE, OONPOLE, OOSPOLE, KPR, KERR)
      ELSE
        CALL INTLOG(JP_DEBUG,'INTFB: lat/long output lat ',NOGRID(1))
        CALL INTLOG(JP_DEBUG,'INTFB: lat/long output long ',NOGRID(2))
C
C       If dissemination style, space has to be for a 0.5x0.5 grid
C
        IF( LSTYLE ) THEN
          IF( NIREPR.EQ.JPQUASI ) THEN
             IF(NIGAUSS.EQ.640) THEN
                DISSRES = 0.125
             ELSEIF(NIGAUSS.EQ.400) THEN
                DISSRES = 0.25
             ELSEIF(NIGAUSS.EQ.320) THEN
                DISSRES = 0.25
             ELSEIF(NIGAUSS.EQ.200) THEN
                DISSRES = 0.5
             ELSEIF(NIGAUSS.EQ.160) THEN
                DISSRES = 0.5
             ELSEIF(NIGAUSS.EQ.128) THEN
                DISSRES = 0.5
             ELSEIF(NIGAUSS.EQ.96) THEN
                DISSRES = 1.
             ELSEIF(NIGAUSS.EQ.80) THEN
                DISSRES = 1.5
             ELSE
                DISSRES = JPDISTP
               CALL INTLOG(JP_WARN,'INTFB: Diss resol set to: ',
     X          NINT(DISSRES*PPMULT))
             ENDIF
            IDISTEP = NINT(DISSRES*PPMULT)
          ENDIF
          HOLDEW = NOGRID(1)
          HOLDNS = NOGRID(2)
          If (.Not.LNOROTA) Then ! D.Jokic; Mar-2005
          NOGRID(1) = IDISTEP
          NOGRID(2) = IDISTEP
          End if ! D.Jokic; Mar-2005
        ENDIF
        IERR = IGLSIZE( NOGRID, NOAREA, NOWE, NONS, KOLN, OOWEGLOBE,
     X                  OONPOLE, OOSPOLE, KPR, KERR)
      ENDIF
C
      IF( IERR.NE.0 ) THEN
        CALL INTLOG(JP_ERROR,
     X    'INTFB: Setup of gaussian field flags failed.',IERR)
        INTFB = JPROUTINE + 6
        GOTO 900
      ENDIF
C
C     -----------------------------------------------------------------|
C     Section 5.1  Interpolate reduced Gaussian grid to grid point.
C     -----------------------------------------------------------------|
C
  510 CONTINUE
C
      ISIZE = ISCRSZ()
      IF( ISIZE.LE.0 ) THEN
        CALL INTLOG(JP_ERROR,'INTFB: Get scratch space failed.',ISIZE)
        INTFB = JPROUTINE + 2
        GOTO 900
      ENDIF
C
      CALL JMEMHAN( 3, IZNFLDO, ISIZE, 1, IERR)
      IF( IERR.NE.0 ) THEN
        CALL INTLOG(JP_ERROR,'INTFB: Get scratch space failed.',JPQUIET)
        INTFB = JPROUTINE + 2
        GOTO 900
      ENDIF
C
      IF( NIREPR.EQ.JPQUASI ) THEN
C
C       If Hirlam 12-point rotation involved, it has already been done
C       (in INTFAPH), so just copy values to array for packing.
C
       IF( LUSEHIR.AND.LNOROTA ) THEN
         DO LOOP = 1, ISIZE
           ZNFLDO(LOOP) = ZNFELDI(LOOP)
         ENDDO
       ELSE
C        Sinisa - if double interpolation involved
        IF( LDOUBLE ) THEN
         IF( NOMEGA.EQ.NIGAUSS ) THEN
          CALL INTLOG(JP_DEBUG,
     X   'INTFB: Input and Intermed. Gaussian number are same',JPQUIET)
          CALL INTLOG(JP_DEBUG,
     X    'INTFB: Double interpolation is not performed',JPQUIET)
         ELSE
           IF(NIFORM.EQ.1)  THEN
             CALL INTLOG(JP_DEBUG,
     X      'INTFB: RG2RG to unpacked - double interpolation',JPQUIET)
               IERR = KRG2RGY(INGRIB,RWORK,NOMEGA)
               IF(IERR.LT.0) THEN
                   CALL INTLOG(JP_ERROR,
     X               'INTFB: KRG2RGY processing failed',JPQUIET)
                   INTFB = JPROUTINE + 10
                   GOTO 900
               ELSE
                   LENMED = IERR
               ENDIF
            ELSE
               CALL INTLOG(JP_DEBUG,
     X          'INTFB: RG to RG intermediate unpacked',JPQUIET)
               IERR = KRG2RGZ(INGRIB,RWORK,NIGAUSS,NOMEGA)
               IF(IERR.LT.0) THEN
                 CALL INTLOG(JP_ERROR,
     X             'INTFB: KRG2RGZ processing failed',JPQUIET)
                 INTFB = JPROUTINE + 10
                 GOTO 900
               ELSE
                 LENMED = IERR
               ENDIF
            ENDIF

               DO LOOP = 1, LENMED
                 ZNFELDI(LOOP) = RWORK(LOOP)
               ENDDO
            IERR = FIXAREA()
            IF( IERR.NE.0 ) THEN
              CALL INTLOG(JP_ERROR,
     X          'INTFB: Fixup area definition failed. DI',JPQUIET)
              INTFB = JPROUTINE + 9
              GOTO 900
            ENDIF
            CALL INTLOG(JP_DEBUG,
     X        'INTFB: quasi input double interolation ',NIGAUSS)
            HTYPE = GGHTYPE(NIREPR,NIGAUSS,MILLEN)
            CALL JGETGG(NIGAUSS,HTYPE,RIGAUSS,MILLEN,IERR)
            IF ( IERR .NE. 0 ) THEN
              CALL INTLOG(JP_ERROR,
     X          'INTFB: JGETGG fail - double interpolation ',JPQUIET)
               INTFB = JPROUTINE + 10
              GOTO 900
            ENDIF

            IERR = IRSIZE( NIGAUSS, NIAREA, MILLEN, NIWE, NINS, KILN,
     X                 KITOTAL, RIGAUSS, OIWEGLOBE, OINPOLE, OISPOLE,
     X                 KPR, KERR)
         ENDIF
       ENDIF
C
C         If reduced gaussian to regular gaussian of same resolution,
C         turn off the land-sea mask processing temporarily
C
          LSAMERS = (NIGAUSS.EQ.NOGAUSS)
          LOLDLSM = LSM
          LOLDLSP = LSMPAR
          IF( (LIQUASI.AND.(NOREPR.EQ.JPGAUSSIAN).AND.LSAMERS) ) THEN
            CALL INTLOG(JP_DEBUG,
     X      'INTFB: turn off any LSM processing temporarily ', JPQUIET)
            LSM    = .FALSE.
            LSMPAR = .FALSE.
          ENDIF
          IERR = IARCNTL( ZNFELDI, JPEXPAND, ZNFLDO, ISIZE, KILN,
     X                    OIWEGLOBE, OINPOLE, OISPOLE, KOLN, OOWEGLOBE,
     X                    OONPOLE, OOSPOLE, KPR ,KERR)
          LSM    = LOLDLSM
          LSMPAR = LOLDLSP
          IF( IERR.NE.0 ) THEN
            CALL INTLOG(JP_ERROR,
     X        'INTFB: Interpolation from quasi GG field failed',JPQUIET)
            INTFB = JPROUTINE + 7
            GOTO 900
          ENDIF
C
          IF( LSTYLE ) THEN
            NOGRID(1) = HOLDEW
            NOGRID(2) = HOLDNS
          ENDIF
        ENDIF
C
        GOTO 700
C
      ENDIF
C
C     -----------------------------------------------------------------|
C*    Section 6.   Interpolate regular grid point to grid point.
C     -----------------------------------------------------------------|
C
  600 CONTINUE
C
      IERR = IAGCNTL( ZNFELDI, JPEXPAND, ZNFLDO, ISIZE, KILN,
     X                OIWEGLOBE, OINPOLE, OISPOLE, KOLN, OOWEGLOBE,
     X                OONPOLE, OOSPOLE, KPR, KERR)
      IF( IERR.NE.0 ) THEN
        CALL INTLOG(JP_ERROR,
     X    'INTFB: Interpolation from regular field failed.',JPQUIET)
        INTFB = JPROUTINE + 8
        GOTO 900
      ENDIF
C
      IF( LSTYLE ) THEN
        NOGRID(1) = HOLDEW
        NOGRID(2) = HOLDNS
      ENDIF


C     -----------------------------------------------------------------|
C*    Section 7.   Pack field into GRIB if necessary.
C     -----------------------------------------------------------------|
C
  700 CONTINUE
C
C     If dissemination 'style' selection has been chosen, select points.
C
      IF( LSTYLE ) THEN
        CALL DDSTYLE(ZNFLDO,IDISTEP,IDISTEP,NOGRID(1),NOGRID(2),IERR)
        IF( IERR.NE.0 ) THEN
         CALL INTLOG(JP_ERROR,
     X   'INTFB: Wrong requested grid increment for dissemination style'
     X    ,JPQUIET)
          INTFB = JPROUTINE + 3
          GOTO 900
        ENDIF
        NOWE = N_NOWE
        NONS = N_NONS
cs to check if it ruin gribex packing
        ISIZE = NOWE*NONS
      ENDIF
C
C     If a 'bitmap' has been specified, build the bitmap
C

        IF( LFRAME.OR.LBITMP.OR.LIMISSV ) THEN
          ISEC1(5) = 192
          ISEC3(2) = NINT(RMISSGV)
          ZSEC3(2) = RMISSGV
        ENDIF

      IF( LBITMP ) THEN
        IERR = MKBITMP(NOWE,NONS,ZNFLDO,RMISSGV)
        IF( IERR.NE.0 ) THEN
          CALL INTLOG(JP_ERROR,'INTFB: Problem applying bitmap',JPQUIET)
          INTFB = IERR
          GOTO 900
        ENDIF
      ENDIF
C
C     If a 'frame' has been specified, build the frame
C
      IF( LFRAME ) CALL MKFRAME(NOWE,NONS,ZNFLDO,RMISSGV,NOFRAME)

C
C     If the output is a GRIB product
C
      IF( NOFORM.EQ.1 ) THEN
        CALL INTLOG(JP_DEBUG,'INTFB: pack field for output',JPQUIET)
C
C       Setup GRIB sections for the output product
C
        IERR = IGSETUP(ISEC1,ISEC2,ISEC3,ISEC4)
        IF( IERR.NE.0 ) THEN
          CALL INTLOG(JP_ERROR,'INTFB: Setup GRIB section fail',JPQUIET)
          INTFB = IERR
          GOTO 900
        ENDIF
C
C
C       If there are missing values, set all values to zero
C
        IF( NOMISS.NE.0 ) THEN
          DO LOOP = 1, ISEC2(2)*ISEC2(3)
            ZNFLDO(LOOP) = 0.0
          ENDDO
        ENDIF
C
C       Make adjustments for 'dissemination style'
C
        IF( LNOSTYLE.AND.(NOSTYLE.EQ.JPSDISM) ) THEN
C
C         Turn off use of ECMWF local definition
C
Cjdc      ISEC1(24) = 0
C
C         For regular lat/long or gaussian grids, calculate the grid
C         i-direction increment using truncation
C
          IF( (ISEC2(1).NE.50).AND.(ISEC2(1).NE.60).AND.
     X        (ISEC2(1).NE.70).AND.(ISEC2(1).NE.80) ) THEN
C
            IF( (ISEC2(1).NE.5).AND.(ISEC2(17).EQ.0) ) THEN
              IF( NOSTYLE.NE.JPSDISM)
     X          ISEC2(9) = (ISEC2(8) - ISEC2(5)) / (ISEC2(2) - 1)
            ENDIF
C
          ENDIF
C
        ENDIF
C
C       Code data into GRIB
C
        ILENF = ISIZE
        IERR = 1
C
C       If grid-point output, setup for 2nd order packing if requested.
C
        IF( (NOREPR.NE.JPSPHERE) .AND. (NOREPR.NE.JPSPHROT) ) THEN
          HFUNC = 'C'
          IF( NOHFUNC.EQ.'K' ) THEN
            HFUNC = 'K'
            ISEC4(4)  = 64
            ISEC4(6)  = 16
            ISEC4(9)  = 32
            ISEC4(10) = 16
            ISEC4(12) = 8
            ISEC4(13) = 4
            ISEC4(14) = 0
            ISEC4(15) = -1
C
C
            IF( NOREPR.EQ.JPQUASI ) THEN
C
C             Complex packing does not support sub-areas of reduced
C             gaussian grids. If output is reduced gaussian, check if
C             it is global to within a tolerance of 0.1 degrees.
C
              INORTH = NINT( ROGAUSS(1) * PPMULT )
              ISOUTH = -INORTH
c             EMOS-199: adjusted for reduced_gg/octahedral
c             IEAST  = JP360 - (JP360/NOLPTS(NOGAUSS))
              IEAST  = JP360 - (JP90/NOGAUSS)
              LGLOBAL = (NOAREA(2).EQ.0)
     X          .AND. (IABS(NOAREA(1)-INORTH).LE.1000)
     X          .AND. (IABS(NOAREA(3)-ISOUTH).LE.1000)
     X          .AND. (IABS(NOAREA(4)-IEAST ).LE.1000)
C
C             Use simple packing if not global.
C
              IF( .NOT. LGLOBAL ) THEN
                HFUNC = 'C'
                ISEC4(4)  = 0
                ISEC4(6)  = 0
              ENDIF
            ENDIF
C
          ELSE IF( NOHFUNC.EQ.'S' ) THEN
            ISEC4(4)  = 0
            ISEC4(6)  = 0
          ENDIF
C
        ELSE
          HFUNC = 'C'
          IF( NOHFUNC.EQ.'C' ) THEN
            ISEC2(6) = 2
            ISEC4(4) = 64
          ELSE IF( NOHFUNC.EQ.'S' ) THEN
            ISEC2(6) = 1
            ISEC4(4) = 0
          ENDIF
        ENDIF
C
        IF( LIMISSV ) THEN
          ISEC1(5) = 192
          ISEC3(2) = NINT(RMISSGV)
          ZSEC3(2) = RMISSGV
        ENDIF
C
C       For interpolated regular lat/long field, flip latitudes if
C       they run from south to north
C       (handles special case , eg KWBC SST fields)
C
        IF( LNOGRID.AND.
     X      (NOREPR.EQ.JPREGULAR).AND.
     X      (NOAREA(1).LT.NOAREA(3)) ) THEN
C
          CALL INTLOG(JP_DEBUG,
     X      'INTFB: Flip latitudes to run North to South', JPQUIET)
          DO LOOP = 1, ISEC2(3)/2
            NEXT  = 1 + (LOOP - 1)*ISEC2(2)
            ISWAP = (ISEC2(3) - LOOP)*ISEC2(2) + 1
            DO LOOPI = 1, ISEC2(2)
              RTEMP = ZNFLDO(ISWAP)
              ZNFLDO(ISWAP) = ZNFLDO(NEXT)
              ZNFLDO(NEXT) = RTEMP
              NEXT  = NEXT + 1
              ISWAP = ISWAP + 1
            ENDDO
          ENDDO
        ENDIF
C
        CALL GRIBEX( ISEC0, ISEC1, ISEC2, ZSEC2, ISEC3, ZSEC3, ISEC4,
     X               ZNFLDO,ILENF,OUTGRIB,OUTLEN,IWORD,HFUNC,IERR)
        IF( IERR.NE.0 ) THEN
          CALL INTLOG(JP_ERROR,'INTFB: GRIBEX encoding failed.',IERR)
          INTFB = JPROUTINE + 5
          GOTO 900
        ENDIF
        OUTLEN = IWORD
C
C       Switch off use of missing value
C
        LIMISSV = .FALSE.
C
      ELSE
C
C       Otherwise, move unpacked values to user array
C
        DO LOOP = 1, ISIZE
          FLDOUT( LOOP ) = ZNFLDO( LOOP )
        ENDDO
C
C       and return the number of values, the unpacked array length
C
        OUTLEN = ISIZE
      ENDIF
C
C     -----------------------------------------------------------------|
C*    Section 9.   Closedown.
C     -----------------------------------------------------------------|
C
  900 CONTINUE
C
C     Clear change flags for next product processing
C
      LCHANGE = .FALSE.
      LSMCHNG = .FALSE.
C
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C


      SUBROUTINE RECLEN  (BLOCK,LEN,NBIT,ICODE,INDIC,LEVEL,IERR)
C
C---->
C*                                                                    *
C*    NAME      : RECLEN
C*                                                                    *
C*    FUNCTION  : CALCULATES FROM THE GRIB (OR PSEUDO GRIB) HEADERS   *
C*                THE TOTAL LENGTH OF THE RECORD, AND ALSO RETURNS    *
C*                PARAMETER NUMBER, INDICATOR OF TYPE OF LEVEL AND    *
C*                LEVEL NUMBER.                                       *
C*                                                                    *
C*    INPUT     : BLOCK = INPUT ARRAY                                 *
C*                NBIT  = NO OF BITS PER COMPUTER WORD                *
C*                                                                    *
C*    OUTPUT    : LEN   = LENGTH IN OCTETS                            *
C*                ICODE = PARAMETER NUMBER                            *
C*                INDIC = LEVEL TYPE INDICATOR                        *
C*                LEVEL = LEVEL NUMBER                                *
C*                IERR  = -1 , UNDEFINED BLOCK 3 INCLUDED.            *
C*                      = -2 , ERROR DETECTED BY SUBROUTINE OFFSET.   *
C                       = -3 , Section length of 0 found.
C*                      =  0 , NO ERROR.                              *
C*                                                                    *
C*    GENERAL   : RECLEN CALLS GBYTES                                 *
C*                             OFFSET                                 *
C*                             MODVAL                                 *
C*                                                                    *
C*    AUTHOR    : B.V. GURETZKY  03.05.85                             *
C*                                                                    *
C*    MODIFIED  : J. HENNESSY    25.11.85                             *
C                 J. Hennessy    11.11.91
C                 Checks on section lengths of 0 added.
C*                                                                    *
C     ---------------------------------------------------------------
C----<
C
      IMPLICIT  INTEGER(B,U)
      DIMENSION BLOCK(*)
      DIMENSION IBLOCK(24)
C
C     SKIP PAST LEADING 4 ASCII CHARACTERS
C
      IWORD = 1
      IOFF  = 0
      IBYTE = 8
      NVAL  = 4
      ILENG = 200
      IERR  = 0
C
      CALL OFFSET (IOFF,NVAL,IWORD,IBYTE,NBIT,ILENG,IERR)
      IF (IERR.NE.0) RETURN
C
C     EXTRACT FIRST 4 OCTETS OF BLOCK 1.
C
      CALL GBYTES (BLOCK(IWORD),IBLOCK(1),IOFF,IBYTE,0,NVAL)
      CALL OFFSET (IOFF,NVAL,IWORD,IBYTE,NBIT,ILENG,IERR)
      IF (IERR.NE.0) RETURN
C
C     IF THESE OCTETS DO NOT CONTAIN 0, 0, 24 AND 0 RESPECTIVELY
C     THEN THE DATA IS IN THE OLD VERSION OF THE CODE.
C
      IF (IBLOCK(1).EQ.0.AND.IBLOCK(2).EQ.0.AND.IBLOCK(3).EQ.24.
     C    AND.IBLOCK(4).EQ.0)
     C      THEN
                ISNEW = 1
                NVAL = 20
            ELSE
                ISNEW = 0
                NVAL = 16
            ENDIF
C
C     EXTRACT NEXT 16 OR 20 OCTETS OF BLOCK 1 - NUMBER DEPENDS
C     ON VERSION OF CODE.
C
      CALL GBYTES (BLOCK(IWORD),IBLOCK(5),IOFF,IBYTE,0,NVAL)
      CALL OFFSET (IOFF,NVAL,IWORD,IBYTE,NBIT,ILENG,IERR)
      IF (IERR.NE.0) RETURN
C
C     LENGTH OF BLOCK 0 + BLOCK 1
      LEN = 24 + (ISNEW*4)
C
C
C     PARAMETER NUMBER.
C
      ICODE = IBLOCK(5+4*ISNEW)
C
C     LEVEL TYPE
C
      INDIC = IBLOCK(6+4*ISNEW)
C
C     LEVEL DESCRIPTION
C
      KTEMP = 32 + ISNEW*224
C
      IF (INDIC.EQ.100.OR.INDIC.EQ.103.OR.INDIC.EQ.105.
     C   .OR.INDIC.EQ.107.OR.INDIC.EQ.109)
     C     THEN
               LEVEL = IBLOCK(7+ISNEW*4) * KTEMP + IBLOCK(8+ISNEW*4)
           ELSE
               LEVEL = IBLOCK(7+ISNEW*4)
           ENDIF
C
C     CHECK FOR PRESENCE OF BLOCK 2.
C
      IFLAG = IBLOCK(4+4*ISNEW)
C
      INC = 0
      IF (ISNEW.EQ.0)
     C   THEN
             IF (IFLAG.EQ.1.OR.IFLAG.EQ.3) INC = 1
         ELSE
             IF (IFLAG.EQ.128.OR.IFLAG.EQ.192) INC = 1
         ENDIF
C
C     LENGTH OF GRID DEFINITION BLOCK
C
      IF (INC.EQ.1)
     C   THEN
             CALL GBYTE (BLOCK(IWORD),LBLK,IOFF,24)
             LEN = LEN + LBLK
             IF (LBLK.EQ.0)
     C          THEN
                    IERR = -3
                    LEN  = 0
                    WRITE (*,9001)
                    RETURN
                ENDIF
C
             CALL  OFFSET (IOFF,LBLK,IWORD,8,NBIT,ILENG,IERR)
             IF (IERR.NE.0) RETURN
         ENDIF
C
C     CHECK FOR PRESENCE OF BLOCK 3
C
      INC = 0
      IF (ISNEW.EQ.0)
     C   THEN
             IF (IFLAG.EQ.2.OR.IFLAG.EQ.3) INC = 1
         ELSE
             IF (IFLAG.EQ.64.OR.IFLAG.EQ.192) INC = 1
         ENDIF
C
C
C------------------------------------------
C
C     NMC WASHINGTON SEA SURFACE TEMPERATURE ANALYSIS IS THE ONLY
C     GRIB CODED FIELD WITH BLOCK 3. IT ALSO VARIES IN LENGTH SO
C     THE LENGTH IS FIXED FOR ARCHIVAL/RETRIEVAL PURPOSES TO
C     34920 BYTES.
C
      IF (INC.EQ.1)
     C   THEN
             LEN = 34920
             RETURN
         ENDIF
C
C------------------------------------------
C
C
      IF (INC.EQ.1)
     C    THEN
              IERR = -1
              WRITE (*,*) ' RECLEN : BLOCK 3 OF GRIB CODE NOT DEFINED'
              RETURN
          ENDIF
C
C     LENGTH OF BINARY DATA BLOCK
C
      CALL GBYTE (BLOCK(IWORD),LBLK,IOFF,24)
      LEN = LEN + LBLK
C
             IF (LBLK.EQ.0)
     C          THEN
                    IERR = -3
                    LEN  = 0
                    WRITE (*,9002)
                    RETURN
                ENDIF
C
C     BLOCK 5 HAS FIXED LENGTH OF 4 OCTETS.

      LEN = LEN + 4
C
C     MAKE LENGTH MULTIPLE OF 120 OCTETS
C
      INTER = 120
      CALL MODVAL (LEN,LENB,INTER)
      LEN = LENB
C
 9001 format (1h ,'RECLEN : Length of section 2 is 0.')
C
 9002 format (1h ,'RECLEN : Length of section 4 is 0.')
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

C---->
C
C     Functions used in ocean field interpolation.
C
C     FUNCTION INTDN(XVAL)
C
C     Rounds XVAL to the largest integer less than or equal to XVAL
C     ie truncates downwards rather than towards zero.
C
C     FUNCTION LENA(HSTRING)
C
C     Returns the length of a string, ignoring blank characters at end
C
C     FUNCTION HDEGS(RVAL)
C
C     Writes a real number into a string, in a way suitable for degs lat/long.
C     RVAL   The real number
C
C     FUNCTION HMETRES(RVAL)
C
C     Writes a real number into a string, in a way suitable for metres depth.
C     RVAL   The real number
C
C----<

      INTEGER FUNCTION INTDN(XVAL)
C
C   Rounds XVAL to the largest integer less than or equal to XVAL
C   ie truncates downwards rather than towards zero.
C
      IF((XVAL.GE.0.0).OR.(XVAL.EQ.FLOAT(INT(XVAL)))) THEN
         INTDN = INT(XVAL)
      ELSE
         INTDN = INT(XVAL) - 1
      ENDIF
      RETURN
      END

      INTEGER FUNCTION INTUP(XVAL)
C
C   Rounds XVAL to the largest integer greater than or equal to XVAL
C   ie truncates upwards rather than away from zero.
C
      IF(XVAL.EQ.FLOAT(INT(XVAL))) THEN
         INTUP=INT(XVAL)
      ELSEIF(XVAL.GE.0) THEN
         INTUP=INT(XVAL+1)
      ELSE
         INTUP=INT(XVAL)
      ENDIF
      RETURN
      END

      INTEGER FUNCTION LENA(HSTRING)
C
C   Returns the length of a string, ignoring blank characters at end
C
      CHARACTER*(*) HSTRING

      DO 100 J=LEN(HSTRING),1,-1
         IF(HSTRING(J:J).NE.' ') GOTO 150
  100 CONTINUE
      J=0
  150 CONTINUE
      LENA=J

      RETURN
      END

      FUNCTION HDEGS(RVAL)
C   Writes a real number into a string, in a way suitable for degs lat/long.
C     RVAL   The real number
C
      CHARACTER*6 HDEGS

      IF(RVAL.GE.0) THEN
         IF(RVAL.LT.10.0) THEN
            WRITE(HDEGS,'(F4.2)') RVAL
         ELSEIF(RVAL.LT.100.0) THEN
            WRITE(HDEGS,'(F4.1)') RVAL
         ELSEIF(RVAL.LT.1000.0) THEN
            WRITE(HDEGS,'(F5.1)') RVAL
         ELSE
            WRITE(HDEGS,'(F5.0)') RVAL
         ENDIF
      ELSE
         IF(RVAL.GT.-10.0) THEN
            WRITE(HDEGS,'(F5.2)') RVAL
         ELSEIF(RVAL.GT.-100.0) THEN
            WRITE(HDEGS,'(F5.1)') RVAL
         ELSEIF(RVAL.GT.-1000.0) THEN
            WRITE(HDEGS,'(F6.1)') RVAL
         ELSE
            WRITE(HDEGS,'(F6.0)') RVAL
         ENDIF
      ENDIF

      RETURN
      END


      FUNCTION HMETRES(RVAL)
C   Writes a real number into a string, in a way suitable for metres depth.
C     RVAL   The real number
C
      CHARACTER*6 HMETRES

      IF(RVAL.GE.0) THEN
         IF(RVAL.LE.9.99) THEN
            IF(INT(RVAL*10)*10.EQ.INT(RVAL*100)) THEN
               WRITE(HMETRES,'(F3.1)') RVAL
            ELSE
               WRITE(HMETRES,'(F4.2)') RVAL
            ENDIF
         ELSEIF(RVAL.LE.99.9) THEN
            WRITE(HMETRES,'(F4.1)') RVAL
         ELSEIF(RVAL.LE.999.0) THEN
            WRITE(HMETRES,'(F4.0)') RVAL
         ELSE
            WRITE(HMETRES,'(F5.0)') RVAL
         ENDIF
      ELSE
         IF(RVAL.GE.-9.99) THEN
            WRITE(HMETRES,'(F5.2)') RVAL
         ELSEIF(RVAL.GE.-99.9) THEN
            WRITE(HMETRES,'(F5.1)') RVAL
         ELSEIF(RVAL.GE.-999.0) THEN
            WRITE(HMETRES,'(F5.0)') RVAL
         ELSE
            WRITE(HMETRES,'(F6.0)') RVAL
         ENDIF
      ENDIF

      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities
C granted to it by virtue of its status as an intergovernmental organisation
C nor does it submit to any jurisdiction.
C

      INTEGER FUNCTION INTOCNU(HICODE,HSCODE,RTOP,RBOTT,RRIGHT,RLEFT,
     *            RYRES,RXRES,
     *            INOCEAN,KLENP,KLENI,TARRAY,
     *            XARR,YARR,NXP,NYP,PARRAY,IINTPOL,ISTAGP)
C
C---->
C****  INTOCNU  - interpolates grib ocean data
C
C
C     PURPOSE
C     -------
C     Interpolates data to new grid, according to instructions.
C     Missing data is flagged with -999.9; this information is
C     passed to the new field.
C
C
C     Interface.
C     ----------
C
C     IRET = INTOCNU(....)
C
C     Input parameters.
C     -----------------
C
C     HICODE   Interpolation code
C               'N'  No interpolation
C               'R'  Interpolate only to make grid Regular
C               'X'  Interpolate in x only
C               'Y'  Interpolate in y only
C               'F'  Interpolate in x and y (Full)
C     HSCODE   Staggered grid code
C               'D'  Drop every second row ('even' points)
C               'X'  Augment to standard grid by x interpolation
C               'Y'  Augment to standard grid by y interpolation
C               'F'  Augment to standard grid by x-y interpolation
C     RTOP     Top of output field domain        (degrees/metres/days)
C     RBOTT    Bottom of output field domain              ( " )
C     RRIGHT   Right of output field domain               ( " )
C     RLEFT    Left of output field domain                ( " )
C     RYRES    Resolution for y-interpolation     ( " )
C     RXRES    Resolution for x-interpolation     ( " )
C     KSEC1    Product definition block (+ high res. grid data)
C     INOCEAN    Input data array
C     KLENP    Size of input array
C     KLENI    Size of scratch array (and also output array PARRAY)
C     TARRAY   Scratch array for use during interpolation
C
C     Output parameters.
C     ------------------
C
C     Returns 0 if the interpolation is successful, otherwise non-zero.
C
C     XARR     x cordinates of data values, or XO,XSTEP,
C              0.0 for regular spacing
C     YARR     y cordinates of data values, or YO,YSTEP,
C              0.0 for regular spacing
C     NXP      x dimension of output field
C     NYP      y dimension of output field
C     PARRAY   output field array
C     IINTPOL  Flag for interpolation done
C              = 0 if none,
C              = 1 if x only,
C              = 2 if y only,
C              = 3 if x and y.
C     ISTAGP   Flag to show processing done for staggered grid:
C              = 0 if none
C              = 2 if every second row dropped.
C              = 3 if interpolated in x only.
C              = 4 if interpolated in y only.
C              = 5 if interpolated in x and y.
C
C
C     Method.
C     -------
C     Convention is always to have output field array starting in bottom
C     left hand corner of the field. The positional information for the
C     data and for the axes is also given starting in the bottom left
C     hand corner.  This means YARR and INOCEAN must be inverted for the
C     default grib scanning, which starts in the top left hand corner.
C
C
C     Externals.
C     ----------
C
C     INTLOG  - Logs warning messages.
C     INTLOGR - Logs warning messages.
C
C
C     Reference.
C     ----------
C
C     None.
C
C
C     Author.
C     -------
C
C     T. Stockdale    ECMWF  23.02.93
C
C
C     Modifications.
C     --------------
C
C     T. Stockdale    ECMWF  20.05.93
C     Revised for local grib.
C
C     J.D.Chambers    ECMWF  04.10.95
C     Make into a function (remove STOPs).
C
C     T. Stockdale    ECMWF  26.09.02
C     Drop odd points (not even) from E grid, for better land sea mask
C
C     T. Stockdale    ECMWF  07.10.02
C     New standard code (matches latest rd version)
C
C----<
C     ------------------------------------------------------------------
C*    Section 0 . Definition of variables. Data statements.
C     ------------------------------------------------------------------
C
      IMPLICIT NONE
C
C     Parameters
      INTEGER JPROUTINE, JP_LONG
      PARAMETER (JPROUTINE = 33300 )
      PARAMETER (JP_LONG = 3 )
C
#include "parim.h"
#include "nifld.common"
#include "nofld.common"
C
C     Subroutine arguments.
      CHARACTER*1 HICODE,HSCODE
      REAL RTOP, RBOTT, RRIGHT, RLEFT, RYRES, RXRES
      INTEGER KLENP, KLENI, NXP, NYP, IINTPOL, ISTAGP
      REAL INOCEAN, TARRAY, XARR, YARR, PARRAY
      DIMENSION INOCEAN(*)
      DIMENSION XARR(*), YARR(*)
      DIMENSION TARRAY(KLENI), PARRAY(KLENI)
C
C     Local variables
      INTEGER NX, NY, KLAT1, KLAT2, KLON1, KXINC, KYINC, ISTAG
      INTEGER IIRREG, JGCL, J, I, JSKIP, NXLEFT, NXRIGH, IWRAP, JI
      INTEGER JIP, JJ, IOFFSET, NEWPTS, JN, IPOS, IPOSM, JPOS
      INTEGER IPOSP1M, JMIN, JMAX, JLEFT, JJP, JJEFF
      INTEGER NYLEFTI, NYLEFT, NYRIGH
      REAL XUNIT, YUNIT, RRVAL, RLVAL, RUVAL, RDVAL, RXIRES
      REAL XSIGN, XRSIGN, XFPREV, XFPOSN, RPOS, RVALL, RVALR
      REAL XVAL, XOWEST, XORES, XPSIGN, RVAL, RYIRES, YFPREV, YFPOSN
      REAL YSIGN, YPSIGN, YRSIGN, RMISS, EPS
      REAL RVALB, RVALT, XOSOUT
      LOGICAL LNEAREST
C
C     YSIGN    Flag for direction of y co-ords in data:
C              +1 if co-ords are increasing with index of INOCEAN
C              -1 if decreasing.
C     YPSIGN   Flag for direction of y co-ords in output field:
C              +1 if co-ords are increasing up the page,
C              -1 if decreasing.
C     YRSIGN   Flag for direction of y co-ords in output field relative
C              to that in data: YSIGN*YPSIGN
C     IINTPOL  Flag for interpolation:
C              0 = none,
C              1 = x only,
C              2 = y only,
C              3 = x and y
C     RMISS    Value for missing data
C     EPS      Tolerance on missing data flag
C
C
      INTEGER  INTUP, INTDN
      EXTERNAL INTUP, INTDN
C
C     Inline function - tests TRUE if A is a missing value
      REAL A
      LOGICAL MISSING
      MISSING(A) = ( ABS(RMISS-A) .LT. EPS )
C
C     ------------------------------------------------------------------
C*    Section 1 . Set initial values.
C     ------------------------------------------------------------------
C
  100 CONTINUE
C
      IWRAP  = 0
      JMAX   = 0
      NXLEFT = 0
      NYLEFT = 0
      INTOCNU = 0
C
C     Set key variables from GRIB header blocks.
C
      NX     = NIWE
      NY     = NINS
C
cs Coordinate 4 of first grid point
      KLAT1  = NIOCO4F
cs Coordinate 4 of last grid point
      KLAT2  = NIOCO4L
cs Coordinate 3 of first grid point
      KLON1  = NIOCO3F
cs i-increment
      KXINC  = NIOIINC
cs j-increment
      KYINC  = NIOJINC
C
cs Flag for normal or staggered grid
      ISTAG  = NIONOST
cs Flag for irregular grid coordinate list
      IIRREG = NIOIRGR
cs 71 Number of entries in the horizontal coordinate definition
cs 72 Number of entries in mixed coordinate definition
cs      JGCL   = 74+KSEC1(71)+KSEC1(72)
         JGCL = 0
C
cs Coordinate 3 flag (x-axis, usually longitude).
      IF(NIOCO3.EQ.1) THEN
         XUNIT = 1.0/3600.0
      ELSE
         XUNIT = 1.0E-6
      ENDIF
C
cs Coordinate 4 flag (y-axis, usually latitude).
      IF(NIOCO4.EQ.2) THEN
         YUNIT = 1.0E-3
      ELSE IF(NIOCO4.EQ.1) THEN
         YUNIT = 1.0/3600.0
      ELSE
         YUNIT = 1.0E-6
      ENDIF
C
      IINTPOL = 0
cs      RMISS   = 9999.0
cs set it from grib_api
      RMISS   = RMISSGV
      EPS     = 0.1
cs      EPS     = 0.01
C
C     ------------------------------------------------------------------
C*    Section 2 . Deal with staggered grid if present.
C     ------------------------------------------------------------------
C
  200 CONTINUE
C
C     The approach in this section is to replace the staggered grid by
C     a non-staggered version, either by interpolating the data onto new
C     grid points or by simply dropping half of the data points. A new
C     version of INOCEAN is created, and parts of KSEC1 are modified.
C     This enables the rest of INTOCNU to treat the field in a consistent
C     manner, BUT it means that KSEC1 and INOCEAN will be altered on
C     leaving this subroutine (and presently in an inconsistent way).
C
C     The interpolations coded in this section ignore the metric of the
C     staggered grid, that is they simply average neighbouring values to
C     find a new grid point value. The more general case can be added
C     later if desired.
C
C     Note: we prefer to drop odd points and keep even points, because
C     the standard version of HOPE2 uses an external mask to define the
C     land-sea mask of its even points. The mask for odd points then has
C     to be interpolated, which is less accurate, so the plots look
C     better if the even points are kept.
C
C
      IF(ISTAG.EQ.1) THEN
C
C       Drop odd row points ...
C
        IF(HSCODE.EQ.'D') THEN
          ISTAGP = 2
          NY     = NY/2
          KYINC  = KYINC*2
          DO 210 J = 1,NY
            DO 210 I = 1,NX
              INOCEAN(I+NX*(J-1)) = INOCEAN(I+NX*((J-1)*2+1))
  210     CONTINUE
C
C         Reset the grid coordinate list.
C         Remove the y coordinates of the even rows,
C         the x coordinates of the even rows, and also the first x
C         coordinate of an even regular row.
C
cs  Grid coordinate list
          IF(IIRREG.EQ.2) THEN
            KLON1 = OCCOOR(1)
            DO 212 J = 1,NY
              OCCOOR(J) = OCCOOR(1+2*J)
  212       CONTINUE
C
          ELSE IF(IIRREG.EQ.3) THEN
            KLON1 = OCCOOR(1)
            JSKIP = NX
            DO 214 J = 1,NY
              OCCOOR(JSKIP+J) = OCCOOR(JSKIP+NX+2*J)
  214       CONTINUE
          ENDIF
C
C*      Staggered grid: interpolation in x.
C
        ELSE IF(HSCODE.EQ.'X') THEN
          ISTAGP = 3
          NX     = NX*2
          KXINC  = KXINC/2
          IF(((NX*NY).GT.KLENI).OR.((NX*NY).GT.KLENP)) THEN
            CALL INTLOG(JP_ERROR,'INTOCNU: Array too small.',JPQUIET)
            CALL INTLOG(JP_ERROR,'INTOCNU: Required = ',NXP*NY)
            CALL INTLOG(JP_ERROR,'INTOCNU: Available = ',KLENP)
            CALL INTLOG(JP_ERROR,'INTOCNU: Available = ',KLENI)
            INTOCNU = JPROUTINE + 17
            GOTO 900
          ENDIF
C
C         Expand the data into a temporary array, and then copy back
C         into INOCEAN. Note the treatment of the end points, which
C         assumes a longitude wrap-round. Remember to mask land points
C         so that either both points are missing or neither.
C
          DO 220 J = 1,NY,2
            RRVAL = INOCEAN(1+(J-1)*NX/2)
            RLVAL = INOCEAN(NX/2+(J-1)*NX/2)
            IF(MISSING(RRVAL)) RLVAL = RMISS
            IF(MISSING(RLVAL)) RRVAL = RMISS
            TARRAY(1+(J-1)*NX) = (RRVAL+RLVAL)*0.5
            TARRAY(2+(J-1)*NX) = INOCEAN(1+(J-1)*NX/2)
            DO 220 I = 2,NX/2
              RRVAL = INOCEAN(I  +(J-1)*NX/2)
              RLVAL = INOCEAN(I-1+(J-1)*NX/2)
              IF(MISSING(RRVAL)) RLVAL = RMISS
              IF(MISSING(RLVAL)) RRVAL = RMISS
              TARRAY(I*2-1+(J-1)*NX) = (RRVAL+RLVAL)*0.5
              TARRAY(I*2  +(J-1)*NX) = INOCEAN(I  +(J-1)*NX/2)
  220     CONTINUE
C
          DO 222 J = 2,NY,2
            RRVAL = INOCEAN(1+(J-1)*NX/2)
            RLVAL = INOCEAN(NX/2+(J-1)*NX/2)
            IF(MISSING(RRVAL)) RLVAL = RMISS
            IF(MISSING(RLVAL)) RRVAL = RMISS
            TARRAY(NX+(J-1)*NX) = (RLVAL+RRVAL)*0.5
            TARRAY(NX-1+(J-1)*NX) = INOCEAN(NX/2+(J-1)*NX/2)
            DO 222 I = 1,NX/2-1
              RRVAL = INOCEAN(I+1+(J-1)*NX/2)
              RLVAL = INOCEAN(I  +(J-1)*NX/2)
              IF(MISSING(RRVAL)) RLVAL = RMISS
              IF(MISSING(RLVAL)) RRVAL = RMISS
              TARRAY(I*2  +(J-1)*NX) = (RLVAL+RRVAL)*0.5
              TARRAY(I*2-1+(J-1)*NX) = INOCEAN(I  +(J-1)*NX/2)
  222     CONTINUE
          DO 224 J = 1,NY
            DO 224 I = 1,NX
              INOCEAN(I+(J-1)*NX) = TARRAY(I+(J-1)*NX)
  224     CONTINUE
C
C         Reset the grid coordinate list if necessary, again making
C         use of a temporary array. Expand the x-coordinate list,
C         and remove the x coordinate of the first even point if grid
C         is regular in x.
C
          KLON1 = OCCOOR(1)
          IF((IIRREG.EQ.1).OR.(IIRREG.EQ.3)) THEN
            JSKIP = 0
            DO 226 J = 1,NX/2
              TARRAY(J*2-1) = OCCOOR(JSKIP+J)
              TARRAY(J*2)   = OCCOOR(JSKIP+NX/2+J)
  226       CONTINUE
            DO 227 J = 1,NX
              OCCOOR(JSKIP+J) = TARRAY(J)
  227       CONTINUE
          ELSE IF((IIRREG.EQ.2)) THEN
            DO 228 J = 1,NY
              OCCOOR(J) = OCCOOR(1+J)
  228       CONTINUE
          ENDIF
C
C       Staggered grid: interpolation in y.
C
        ELSE IF(HSCODE.EQ.'Y') THEN
          ISTAGP = 4
          NX     = NX*2
          KXINC  = KXINC/2
          IF(((NX*NY).GT.KLENI).OR.((NX*NY).GT.KLENP)) THEN
            CALL INTLOG(JP_ERROR,'INTOCNU: Array too small.',JPQUIET)
            CALL INTLOG(JP_ERROR,'INTOCNU: Required = ',NXP*NY)
            CALL INTLOG(JP_ERROR,'INTOCNU: Available = ',KLENP)
            CALL INTLOG(JP_ERROR,'INTOCNU: Available = ',KLENI)
            INTOCNU = JPROUTINE + 18
            GOTO 900
          ENDIF
C
C         Expand the data into a temporary array, and then copy back
C         into INOCEAN. For the polarmost rows, use X interpolation.
C
C         First the even rows...
          DO 230 J = 2,NY-1,2
            DO 230 I = 1,NX/2
              RUVAL = INOCEAN(I+(J-2)*NX/2)
              RDVAL = INOCEAN(I+(J  )*NX/2)
              IF(MISSING(RUVAL)) RDVAL = RMISS
              IF(MISSING(RDVAL)) RUVAL = RMISS
              TARRAY(I*2  +(J-1)*NX) = (RDVAL+RUVAL)*0.5
              TARRAY(I*2-1+(J-1)*NX) =  INOCEAN(I+(J-1)*NX/2)
  230     CONTINUE
          RRVAL = INOCEAN(1+(NY-1)*NX/2)
          RLVAL = INOCEAN(NX/2+(NY-1)*NX/2)
          IF(MISSING(RRVAL)) RLVAL = RMISS
          IF(MISSING(RLVAL)) RRVAL = RMISS
          TARRAY(NX+(NY-1)*NX) = (RLVAL+RRVAL)*0.5
          TARRAY(NX-1+(NY-1)*NX) = INOCEAN(NX/2+(NY-1)*NX/2)
          DO 231 I = 2,NX/2
            RRVAL = INOCEAN(I+1+(NY-1)*NX/2)
            RLVAL = INOCEAN(I+(NY-1)*NX/2)
            IF(MISSING(RRVAL)) RLVAL = RMISS
            IF(MISSING(RLVAL)) RRVAL = RMISS
            TARRAY(I*2+(NY-1)*NX) = (RRVAL+RLVAL)*0.5
            TARRAY(I*2-1+(NY-1)*NX) = INOCEAN(I+(NY-1)*NX/2)
  231     CONTINUE
C
C         Then the odd rows
          DO 232 J = 3,NY-1,2
            RUVAL = INOCEAN(NX/2+(J-2)*NX/2)
            RDVAL = INOCEAN(NX/2+(J  )*NX/2)
            IF(MISSING(RUVAL)) RDVAL = RMISS
            IF(MISSING(RDVAL)) RUVAL = RMISS
            TARRAY(1+(J-1)*NX) = (RRVAL+RLVAL)*0.5
            TARRAY(2+(J-1)*NX) = INOCEAN(1+(J-1)*NX/2)
            DO 232 I = 1,NX/2
              RUVAL = INOCEAN(I+(J-2)*NX/2)
              RDVAL = INOCEAN(I+(J  )*NX/2)
              IF(MISSING(RUVAL)) RDVAL = RMISS
              IF(MISSING(RDVAL)) RUVAL = RMISS
              TARRAY(I*2-1+(J-1)*NX) = (RDVAL+RUVAL)*0.5
              TARRAY(I*2  +(J-1)*NX) =  INOCEAN(I+(J-1)*NX/2)
  232     CONTINUE
C
          RRVAL = INOCEAN(1+(1-1)*NX/2)
          RLVAL = INOCEAN(NX/2+(1-1)*NX/2)
          IF(MISSING(RRVAL)) RLVAL = RMISS
          IF(MISSING(RLVAL)) RRVAL = RMISS
          TARRAY(1+(1-1)*NX) = (RRVAL+RLVAL)*0.5
          TARRAY(2+(1-1)*NX) = INOCEAN(1+(1-1)*NX/2)
          DO 233 I = 2,NX/2
            RRVAL = INOCEAN(I+(1-1)*NX/2)
            RLVAL = INOCEAN(I-1+(1-1)*NX/2)
            IF(MISSING(RRVAL)) RLVAL = RMISS
            IF(MISSING(RLVAL)) RRVAL = RMISS
            TARRAY(I*2-1+(1-1)*NX) = (RRVAL+RLVAL)*0.5
            TARRAY(I*2+(1-1)*NX) = INOCEAN(I+(1-1)*NX/2)
  233     CONTINUE

          DO 234 J = 1,NY
            DO 234 I = 1,NX
              INOCEAN(I+(J-1)*NX) = TARRAY(I+(J-1)*NX)
  234     CONTINUE
C
C         Reset the grid coordinate list if necessary, again making
C         use of a temporary array. Expand the x-coordinate list,
C         and remove the x coordinate of the first even point if
C         grid is regular in x.
C
          IF((IIRREG.EQ.1).OR.(IIRREG.EQ.3)) THEN
            JSKIP = 0
            DO 235 J = 1,NX/2
              TARRAY(J*2-1) = OCCOOR(JSKIP+J)
              TARRAY(J*2)   = OCCOOR(JSKIP+NX/2+J)
  235       CONTINUE
            DO 236 J = 1,NX
              OCCOOR(JSKIP+J) = TARRAY(J)
  236       CONTINUE
          ELSE IF((IIRREG.EQ.2)) THEN
            DO 237 J = 1,NY
              OCCOOR(J) = OCCOOR(1+J)
  237       CONTINUE
          ENDIF
C
C       Staggered grid: interpolation in x and y.
C
        ELSE IF(HSCODE.EQ.'F') THEN
          ISTAGP = 5
          CALL INTLOG(JP_ERROR,'INTOCNU: Staggered grid opt. F',JPQUIET)
          CALL INTLOG(JP_ERROR,'INTOCNU: (interpolate x and y)',JPQUIET)
          CALL INTLOG(JP_ERROR,'INTOCNU: not yet implemented.',JPQUIET)
          INTOCNU = JPROUTINE + 1
          GOTO 900
        ELSE
          CALL INTLOG(JP_ERROR,'INTOCNU: Staggered grid option',JPQUIET)
          CALL INTLOG(JP_ERROR,HSCODE,JPQUIET)
          CALL INTLOG(JP_ERROR,'INTOCNU: not known.',JPQUIET)
          INTOCNU = JPROUTINE + 2
          GOTO 900
        ENDIF
C
        ISTAG = 0
C
      ELSE
         ISTAGP = 0
      ENDIF
C
C     ------------------------------------------------------------------
C*    Section 3 . Set X coordinates and interpolate in X.
C     ------------------------------------------------------------------
C
  300 CONTINUE
C
C     The procedure is first to do the x interpolation (if any), and
C     copy the result into a temporary array. The y interpolation is
C     done in the next section.
C
C     The one complication here is to ensure proper longitude wrap-round
C     where appropriate.
C
C     Some plot systems have difficulty controlling the data within the
C     viewport. Because of this, and in the interests of efficiency, the
C     data arrays are truncated even if no interpolation is being done.
C
C
C     No interpolation in X.
C
      IF((HICODE.EQ.'N').OR.
     *   ((HICODE.EQ.'R').AND.((IIRREG.EQ.0).OR.(IIRREG.EQ.2))).OR.
     *   (HICODE.EQ.'Y') )  THEN
C
C       If x is longitude, set parameters up for wrap-round
C       Wrap-round activated only if longitude range of data > 350 deg.
C
        IF((IIRREG.EQ.0).OR.(IIRREG.EQ.2)) THEN
          RXIRES = KXINC*XUNIT
          NXLEFT = INTDN((RLEFT-KLON1*XUNIT)/RXIRES+1)
          NXRIGH = INTUP((RRIGHT-KLON1*XUNIT)/RXIRES+1)
          NXP    = NXRIGH-NXLEFT+1
          IF(NXP.LE.1) THEN
            CALL INTLOG(JP_ERROR,'INTOCNU: NXP negative = ',NXP)
            INTOCNU = JPROUTINE + 3
            GOTO 900
          ENDIF
          XARR(1) = KLON1*XUNIT+(NXLEFT-1)*RXIRES
          XARR(2) = KXINC*XUNIT
          XARR(3) = 0.0
cs Coordinate 3 flag (x-axis, usually longitude).
          IF( (NIOCO3.EQ.3) .AND. (KXINC*NX*XUNIT.GT.350.0) ) THEN
            IWRAP = 1
          ELSE
            IWRAP = 0
          ENDIF
C
        ELSE IF( (IIRREG.EQ.1) .OR. (IIRREG.EQ.3) ) THEN
          NXP    = NX
          NXLEFT = 1
cs          JSKIP  = JGCL
          JSKIP  = 0
          DO 312 JI = 1,NXP
            XARR(JI) = OCCOOR(JSKIP+JI)*XUNIT
  312     CONTINUE
cs Coordinate 3 flag (x-axis, usually longitude).
          IF( (NIOCO3.EQ.3) .AND. (KXINC*NX*XUNIT.GT.350.0) ) THEN
            IWRAP  = 1
            INTOCNU = JPROUTINE + 4
            GOTO 900
          ELSE
            IWRAP  = 0
          ENDIF
        ENDIF
C
        IF((NXP*NY).GT.KLENI) THEN
          CALL INTLOG(JP_ERROR,'INTOCNU: Array too small.',JPQUIET)
          CALL INTLOG(JP_ERROR,'INTOCNU: Required = ',NXP*NY)
          CALL INTLOG(JP_ERROR,'INTOCNU: Available = ',KLENI)
          INTOCNU = JPROUTINE + 5
          GOTO 900
        ENDIF
C
C       Copy the data into the temporary array
C
        DO 318 JI = 1,NXP
          JIP = JI+NXLEFT-1
          IF(IWRAP.EQ.1) THEN
            IF(JIP.LE.0)  JIP = JIP+NX
            IF(JIP.GT.NX) JIP = JIP-NX
          ENDIF
          IF((JIP.GE.1).AND.(JIP.LE.NX)) THEN
            DO 316 JJ = 1,NY
              TARRAY(JI+(JJ-1)*NXP) = INOCEAN(JIP+(JJ-1)*NX)
  316       CONTINUE
          ELSE
            DO 317 JJ = 1,NY
              TARRAY(JI+(JJ-1)*NXP) = RMISS
  317       CONTINUE
          ENDIF
  318   CONTINUE
C
C       Interpolation from a grid irregular in X.
C     ---------------------------------------------
C
      ELSE IF(((HICODE.EQ.'R').OR.
     *        (HICODE.EQ.'X').OR.
     *        (HICODE.EQ.'F')    ).AND.
     *       ((IIRREG.EQ.1).OR.(IIRREG.EQ.3))  ) THEN

        XPSIGN = SIGN(1.0,(RRIGHT-RLEFT))
        NXP    = NINT((RRIGHT-RLEFT)/RXRES*XPSIGN)+1
        IF((NXP*NY).GT.KLENI) THEN
          CALL INTLOG(JP_ERROR,'INTOCNU: Array too small.',JPQUIET)
          CALL INTLOG(JP_ERROR,'INTOCNU: Required = ',NXP*NY)
          CALL INTLOG(JP_ERROR,'INTOCNU: Available = ',KLENI)
          INTOCNU = JPROUTINE + 6
          GOTO 900
        ENDIF
        RRIGHT  = RLEFT+RXRES*XPSIGN*(NXP-1)
        XARR(1) = RLEFT
        XARR(2) = RXRES*XPSIGN
        XARR(3) = 0.0
        IINTPOL = IINTPOL+1
        IOFFSET = 0
        XSIGN   = SIGN(1.0,((OCCOOR(IOFFSET+2)-OCCOOR(IOFFSET+1))*1.0))
        XRSIGN  = XSIGN*XPSIGN
        DO 321 JI = 1,NXP*NY
          TARRAY(JI) = RMISS
  321   CONTINUE
C
C       Work through the known (irregular) data points.
C       Calculate the position of the point as a fractional number of
C       points on the new regular grid
C       (XFPOSN). If there are any points on the new grid between this
C       point and the previous one (XFPREV), then set these points by
C       interpolation between the two known points.
        XFPREV= (OCCOOR(IOFFSET+1)*XUNIT-RLEFT)/RXRES*XPSIGN- 0.5*XRSIGN
        DO 324 JI = 1,NX
          XFPOSN = (OCCOOR(IOFFSET+JI)*XUNIT-RLEFT)/(RXRES*XPSIGN)
          NEWPTS = INTDN((XFPOSN*XRSIGN))-INTDN((XFPREV*XRSIGN))
          DO 323 JN = 1,NEWPTS
            IPOS = (INTDN(XFPREV*XRSIGN)+JN)*XRSIGN+1
            RPOS = (IPOS-1)*1.0
            IF((IPOS.GE.1).AND.(IPOS.LE.NXP)) THEN
              DO 322 JJ = 1,NY
                RVALL = INOCEAN(JI-1+NX*(JJ-1))
                RVALR = INOCEAN(JI+NX*(JJ-1))
                IF(.NOT.MISSING(RVALL) .AND. .NOT.MISSING(RVALR) ) THEN
                  XVAL = (XFPOSN-RPOS)/(XFPOSN-XFPREV)*RVALL
     *                      +(RPOS-XFPREV)/(XFPOSN-XFPREV)*RVALR
                ELSE
                  XVAL = RMISS
                ENDIF
                TARRAY(IPOS+NXP*(JJ-1)) = XVAL
  322         CONTINUE
            ENDIF
  323     CONTINUE
          XFPREV = XFPOSN
  324   CONTINUE

C
C     Interpolation from a grid regular in X.
C
      ELSE IF(((HICODE.EQ.'X').OR.(HICODE.EQ.'F')).AND.
     *       ((IIRREG.EQ.0).OR.(IIRREG.EQ.2))    ) THEN

        XPSIGN = SIGN(1.0,(RRIGHT-RLEFT))
        NXP    = NINT((RRIGHT-RLEFT)/RXRES*XPSIGN)+1
        IF((NXP*NY).GT.KLENI) THEN
          CALL INTLOG(JP_ERROR,'INTOCNU: Array too small.',JPQUIET)
          CALL INTLOG(JP_ERROR,'INTOCNU: Required = ',NXP*NY)
          CALL INTLOG(JP_ERROR,'INTOCNU: Available = ',KLENI)
          INTOCNU = JPROUTINE + 7
          GOTO 900
        ENDIF
        RRIGHT  = RLEFT+RXRES*XPSIGN*(NXP-1)
        XARR(1) = RLEFT
        XARR(2) = RXRES*XPSIGN
        XARR(3) = 0.0
        IINTPOL = IINTPOL+1
C
C       Work through the new regular grid points. Calculate the position
C       of the point as a fractional number of points on the old grid.
C       Use this fractional number to estimate the value of the field
C       at the new point
C
C       (Note that just to the right of the first point, RPOS will be
C        eg 1.1, not 0.1)
C
        DO 330 JI = 1,NXP*NY
          TARRAY(JI) = RMISS
  330   CONTINUE
C
        XOWEST = KLON1*XUNIT
        XORES  = KXINC*XUNIT
        DO 3320 JI = 1,NXP
          RPOS = (RLEFT+(JI-1)*RXRES-XOWEST)/XORES + 1
          IPOS = INTDN(RPOS)
C
C         Check for out of bounds, and set to zero unless x is
C         longitude, in which case attempt to wrap round.
          IF( (IPOS.GE.1) .AND. ((IPOS+1).LE.NX) ) THEN
            DO 3310 JJ = 1,NY
              RVALL = INOCEAN(IPOS+(JJ-1)*NX)
              RVALR = INOCEAN(IPOS+1+(JJ-1)*NX)
              IF(.NOT. MISSING(RVALL) .AND. .NOT. MISSING(RVALR) ) THEN
                RVAL = (IPOS+1-RPOS)*RVALL + (RPOS-IPOS)*RVALR
C
C             Do not set to missing if there is good data close by.
              ELSEIF( (.NOT.MISSING(RVALL)) .AND.
     X                ((IPOS+1-RPOS).GT.0.5) ) THEN
                RVAL = RVALL
              ELSEIF( (.NOT. MISSING(RVALR)).AND.
     X                ((RPOS-IPOS).GT.0.5)) THEN
                RVAL = RVALR
              ELSE
                RVAL = RMISS
              ENDIF
              TARRAY(JI+(JJ-1)*NXP) = RVAL
 3310       CONTINUE
C
          ELSEIF( NIOCO3.EQ.JP_LONG ) THEN
C
C           This works only if the longitude points are equally spaced
C           around the globe, ie the gap between the first and last
C           points is equal to the gap between any other pair of
C           adjacent points.
C
            IPOSM   = MOD(IPOS,NX)
            IPOSP1M = MOD((IPOS+1),NX)
            IF(IPOSM.LE.0)   IPOSM   = IPOSM+NX
            IF(IPOSP1M.LE.0) IPOSP1M = IPOSP1M+NX
            DO 3313 JJ = 1,NY
              RVALL = INOCEAN(IPOSM+(JJ-1)*NX)
              RVALR = INOCEAN(IPOSP1M+(JJ-1)*NX)
              IF(.NOT. MISSING(RVALL) .AND. .NOT. MISSING(RVALR) ) THEN
                RVAL = (IPOS+1-RPOS)*RVALL + (RPOS-IPOS)*RVALR
C
C             Do not set to missing if there is good data close by.
              ELSEIF( (.NOT.MISSING(RVALL)) .AND.
     X               ((IPOS+1-RPOS).GT.0.5) ) THEN
                RVAL = RVALL
              ELSEIF( (.NOT. MISSING(RVALR)).AND.
     X                ((RPOS-IPOS).GT.0.5) ) THEN
                RVAL = RVALR
              ELSE
                RVAL = RMISS
              ENDIF
              IF(RVAL.GT.1E6) THEN
                RVAL = RMISS
              ENDIF
              TARRAY(JI+(JJ-1)*NXP) = RVAL
 3313       CONTINUE
          ELSE
            DO 3316 JJ = 1,NY
              TARRAY(JI+(JJ-1)*NXP) = RMISS
 3316       CONTINUE
          ENDIF
 3320    CONTINUE
C
      ELSE
        CALL INTLOG(JP_ERROR,'INTOCNU: Error in logic.',JPQUIET)
        CALL INTLOG(JP_ERROR,'INTOCNU: HICODE = ',JPQUIET)
        CALL INTLOG(JP_ERROR,HICODE,JPQUIET)
        CALL INTLOG(JP_ERROR,'INTOCNU: IIRREG = ',IIRREG)
        INTOCNU = JPROUTINE + 8
        GOTO 900
      ENDIF
C
C     ------------------------------------------------------------------
C*    Section 4 . Set Y coordinates and interpolate in Y.
C     ------------------------------------------------------------------
C
  400 CONTINUE
C
C     The x-interpolated field in the temporary array is interpolated in
C     y into the final output field array. Note that the field and the
C     coordinate array are both inverted in the y direction during this
C     section.
C
C     Some plot systems have difficulty controlling the data within the
C     viewport. Because of this, and in the interests of efficiency, the
C     data arrays are truncated even if no interpolation is being done.
C
C
C     No interpolation in Y.
C
      IF((HICODE.EQ.'N').OR.
     *   ((HICODE.EQ.'R').AND.((IIRREG.EQ.0).OR.(IIRREG.EQ.1))).OR.
     *   (HICODE.EQ.'X') )  THEN
C
C       If y is longitude, set parameters up for wrap-round
C       Wrap-round activated only if longitude range of data > 350 deg.
C
        IF((IIRREG.EQ.0).OR.(IIRREG.EQ.1)) THEN
C
C         Remember to invert calc of NYP if RYIRES -ve ... 22.04.94
          RYIRES =  KYINC*YUNIT
          IF(RYIRES.GT.0) THEN
            NYLEFT = INTDN((RBOTT-KLAT1*YUNIT)/RYIRES+1)
            NYRIGH = INTUP((RTOP-KLAT1*YUNIT)/RYIRES+1)
            NYP = NYRIGH-NYLEFT+1
          ELSE
            NYRIGH = INTUP((RBOTT-KLAT1*YUNIT)/RYIRES+1)
            NYLEFT = INTDN((RTOP-KLAT1*YUNIT)/RYIRES+1)
            NYP = NYRIGH-NYLEFT+1
          ENDIF
          IF(NYP.LE.1) THEN
            CALL INTLOG(JP_ERROR,'INTOCNU: NYP negative = ',NYP)
            INTOCNU = JPROUTINE + 9
            GOTO 900
          ENDIF
C
C         Remember to invert yarr coordinates ... 06.07.93
          YARR(1) = KLAT1*YUNIT+(NYRIGH-1)*RYIRES
          YARR(2) = -KYINC*YUNIT
          YARR(3) = 0.0
C
C         Remember NYLEFT is relative to the inverted array ... 19.01.96
C         ... but be careful to do this exactly.   01.04.97
          NYLEFTI=NYLEFT
          NYLEFT=NY+1-NYRIGH
          NYRIGH=NY+1-NYLEFTI
C
          IF((NIOCO4.EQ.3) .AND. (KYINC*NY*YUNIT.GT.350.0) ) THEN
            IWRAP = 1
          ELSE
            IWRAP = 0
          ENDIF
C
        ELSE IF(IIRREG.EQ.2) THEN
          IOFFSET = 0
          YPSIGN  = SIGN(1.0,(RTOP-RBOTT))
          YSIGN  = SIGN(1.0,((OCCOOR(IOFFSET+2)-OCCOOR(IOFFSET+1))*1.0))
          YRSIGN  = YSIGN*YPSIGN
          JMIN    = 0
          DO 410 JI = 1,NY
            YARR(JI) = OCCOOR((IOFFSET+NY+1-JI))*YUNIT
            IF(YRSIGN.LT.0.0) THEN
              IF((YARR(JI)-RBOTT)*YSIGN .GT. 0.0) JMIN = JI
              IF((YARR(JI)-RTOP )*YSIGN .GT. 0.0) JMAX = JI+1
            ELSE
              IF((YARR(JI)-RTOP )*YSIGN .GT. 0.0) JMIN = JI
              IF((YARR(JI)-RBOTT)*YSIGN .GT. 0.0) JMAX = JI+1
            ENDIF
  410     CONTINUE
          IF(JMIN.EQ.0) THEN
           CALL INTLOG(JP_ERROR,'INTOCNU: Domain out of range.',JPQUIET)
           CALL INTLOGR(JP_ERROR,'INTOCNU: Requested Y = ',RBOTT)
           CALL INTLOGR(JP_ERROR,'INTOCNU: Data limit of Y = ',YARR(1))
           INTOCNU = JPROUTINE + 10
           GOTO 900
          ENDIF
          IF(JMAX.EQ.NY+1) THEN
           CALL INTLOG(JP_ERROR,'INTOCNU: Domain out of range.',JPQUIET)
           CALL INTLOGR(JP_ERROR,'INTOCNU: Requested Y = ',RTOP)
           CALL INTLOGR(JP_ERROR,'INTOCNU: Data limit of Y = ',YARR(NY))
           INTOCNU = JPROUTINE + 11
            GOTO 900
          ENDIF
C
          NYP    = (JMAX-JMIN)+1
          NYLEFT = JMIN
          DO 411 JI = 1,NYP
            YARR(JI) = YARR(JI+(NYLEFT-1))
  411     CONTINUE
C
          IF((NIOCO4.EQ.3) .AND. (KYINC*NY*YUNIT.GT.350.0) ) THEN
           IWRAP = 1
           CALL INTLOG(JP_ERROR,'INTOCNU: Irregular wrap-round',JPQUIET)
           CALL INTLOG(JP_ERROR,'INTOCNU: not yet implemented.',JPQUIET)
           INTOCNU = JPROUTINE + 12
            GOTO 900
          ELSE
            IWRAP = 0
          ENDIF
C
        ELSE IF(IIRREG.EQ.3) THEN
          NYP    = NY
          NYLEFT = 1
          JSKIP  = NX
          DO 412 JI = 1,NYP
            YARR(JI) = OCCOOR(JSKIP+(NY+1-JI))*YUNIT
  412     CONTINUE
          IF((NIOCO4.EQ.3) .AND. (KYINC*NY*YUNIT.GT.350.0) ) THEN
           IWRAP = 1
           CALL INTLOG(JP_ERROR,'INTOCNU: Irregular wrap-round',JPQUIET)
           CALL INTLOG(JP_ERROR,'INTOCNU: not yet implemented.',JPQUIET)
           INTOCNU = JPROUTINE + 13
           GOTO 900
          ELSE
           IWRAP = 0
          ENDIF
        ENDIF
C
        IF((NXP*NYP).GT.KLENI) THEN
          CALL INTLOG(JP_ERROR,'INTOCNU: Array too small.',JPQUIET)
          CALL INTLOG(JP_ERROR,'INTOCNU: Required = ',NXP*NYP)
          CALL INTLOG(JP_ERROR,'INTOCNU: Available = ',KLENI)
          INTOCNU = JPROUTINE + 14
          GOTO 900
        ENDIF
C
C       Copy the data into the temporary array, and invert it at
C       same time.
C       Note: NYLEFT is the starting index in the inverted data array.
C
c       DO 416 JJ = 1,NYP
c         DO 414 JI = 1,NXP
c           PARRAY(JI+(JJ-1)*NXP) = TARRAY(JI+(NY-JJ)*NXP)
c 414     CONTINUE
c 416   CONTINUE
C
        DO 418 JJ = 1,NYP
cc        JJP   = JJ+NYLEFT-1
          JLEFT = NY-(NYLEFT-1)
          JJP   = JLEFT-JJ+1
          IF(IWRAP.EQ.1) THEN
            IF(JJP.LE.0)  JJP = JJP+NY
            IF(JJP.GT.NY) JJP = JJP-NY
          ENDIF
          IF((JJP.GE.1).AND.(JJP.LE.NY)) THEN
            DO 416 JI = 1,NXP
cc            PARRAY(JI+(NYP-JJ)*NXP) = TARRAY(JI+(JJP-1)*NXP)
              PARRAY(JI+(JJ-1)*NXP)   = TARRAY(JI+(JJP-1)*NXP)
  416       CONTINUE
          ELSE
            DO 417 JI = 1,NXP
              PARRAY(JI+(NYP-JJ)*NXP) = RMISS
  417       CONTINUE
          ENDIF
  418   CONTINUE
C
C     Interpolation from a grid irregular in Y.
C
      ELSE IF(((HICODE.EQ.'R').OR.
     *        (HICODE.EQ.'Y').OR.
     *        (HICODE.EQ.'F')    ).AND.
     *       ((IIRREG.EQ.2).OR.(IIRREG.EQ.3))  ) THEN
        YPSIGN = SIGN(1.0,(RTOP-RBOTT))
        IF( YPSIGN.GT.0 ) THEN
          NYP = NINT((RTOP-RBOTT+ 0.0001)/RYRES)+1
        ELSE
          NYP = NINT((RBOTT-RTOP + 0.0001)/RYRES)+1
        ENDIF
Cjdc    NYP = NINT((RTOP-RBOTT)/RYRES*YPSIGN)+1
        IF((NXP*NYP).GT.KLENI) THEN
          CALL INTLOG(JP_ERROR,'INTOCNU: Array too small.',JPQUIET)
          CALL INTLOG(JP_ERROR,'INTOCNU: Required = ',NXP*NYP)
          CALL INTLOG(JP_ERROR,'INTOCNU: Available = ',KLENI)
          INTOCNU = JPROUTINE + 15
          GOTO 900
        ENDIF
        RTOP    = RBOTT+RYRES*YPSIGN*(NYP-1)
        YARR(1) = RBOTT
        YARR(2) = RYRES*YPSIGN
        YARR(3) = 0.0
        IINTPOL = IINTPOL+2
        IF(IIRREG.EQ.2) THEN
            IOFFSET = 0
        ELSE IF(IIRREG.EQ.3) THEN
            IOFFSET = NX
        ENDIF
        YSIGN  = SIGN(1.0,((OCCOOR(IOFFSET+2)-OCCOOR(IOFFSET+1))*1.0))
        YRSIGN = YSIGN*YPSIGN
        DO 420 JI = 1,NXP*NYP
          PARRAY(JI) = RMISS
  420   CONTINUE
C
C       Work through the known (irregular) data points. Calculate the
C       position of the point as a fractional number of points on the
C       new regular grid (YFPOSN). If there are any points on the new
C       grid between this point and the previous one (YFPREV), then set
C       these points by interpolation between the two known points.
C       Check that the points are in range.
C       Note that we are willing to overlap slightly at the start, but
C       must fiddle the array arguments to do this.
C
        YFPREV= (OCCOOR(IOFFSET+1)*YUNIT-RBOTT)/RYRES*YPSIGN- 0.5*YRSIGN
        DO 428 JJ = 1,NY
          YFPOSN = (OCCOOR(IOFFSET+JJ)*YUNIT-RBOTT)/RYRES*YPSIGN
          NEWPTS =  INTDN((YFPOSN*YRSIGN)) -INTDN((YFPREV*YRSIGN))
C
C         INT truncates toward zero;
C         INTDN truncates downwards in all cases
C
          DO 426 JN = 1,NEWPTS
            IPOS = (INTDN(YFPREV*YRSIGN)+JN)*YRSIGN+1
            RPOS = (IPOS-1)*1.0
            IF((IPOS.GE.1).AND.(IPOS.LE.NYP)) THEN
              JJEFF = JJ
              IF(JJ.EQ.1) JJEFF = 2
              DO 424 JI = 1,NXP
                RVALL = TARRAY(JI+NXP*(JJEFF-2))
                RVALR = TARRAY(JI+NXP*(JJ-1))
                IF(.NOT.MISSING(RVALL) .AND. .NOT.MISSING(RVALR) ) THEN
                  XVAL = (YFPOSN-RPOS)/(YFPOSN-YFPREV)*RVALL
     *                      +(RPOS-YFPREV)/(YFPOSN-YFPREV)*RVALR
                ELSE
                  XVAL = RMISS
                ENDIF
                PARRAY(JI+NXP*(IPOS-1)) = XVAL
  424         CONTINUE
            ENDIF
  426     CONTINUE
          YFPREV = YFPOSN
  428   CONTINUE
C
C
C
C     4.3  INTERPOLATION FROM A GRID REGULAR IN Y
C     -------------------------------------------
C
      ELSEIF(((HICODE.EQ.'Y').OR.(HICODE.EQ.'F')).AND.
     *       ((IIRREG.EQ.0).OR.(IIRREG.EQ.1))    ) THEN

            LNEAREST=.TRUE.

            YPSIGN=SIGN(1.,(RTOP-RBOTT))
            NYP=NINT((RTOP-RBOTT)/RYRES*YPSIGN)+1
            IF((NXP*NYP).GT.KLENI) THEN
              CALL INTLOG(JP_ERROR,'INTOCNU: Array too small.',JPQUIET)
              CALL INTLOG(JP_ERROR,'INTOCNU: Required = ',NXP*NYP)
              CALL INTLOG(JP_ERROR,'INTOCNU: Available = ',KLENI)
              INTOCNU = JPROUTINE + 19
              GOTO 900
            ENDIF
            RTOP=RBOTT+RYRES*(NYP-1)*YPSIGN
            YARR(1)=RBOTT
            YARR(2)=RYRES*YPSIGN
            YARR(3)=0.0
C  Work through the new regular grid points. Calculate the position of
C  the point as a fractional number of points on the old grid. Use this
C  fractional number to estimate the value of the field at the new point
            IINTPOL=IINTPOL+2
            DO 335 JI=1,NXP*NYP
               PARRAY(JI)=RMISS
  335       CONTINUE
            XOSOUT=KLAT1*YUNIT
            XORES =KYINC*YUNIT
            DO 3370 JJ=1,NYP
               RPOS=(RBOTT+(JJ-1)*RYRES*YPSIGN-XOSOUT)/XORES + 1
               JPOS=INTDN(RPOS)
C  Check for out of bounds, and set to missing if this is the case
               IF((JPOS.GE.1).AND.(JPOS+1.LE.NY)) THEN
                 DO 3360 JI=1,NXP
                    RVALB = TARRAY(JI+(JPOS-1)*NXP)
                    RVALT = TARRAY(JI+(JPOS+1-1)*NXP)
                    IF(.NOT.MISSING(RVALB).AND.
     *                 .NOT.MISSING(RVALT)       ) THEN
                       RVAL=(JPOS+1-RPOS)*RVALB
     *                      +(RPOS-JPOS)*RVALT
                    ELSEIF(LNEAREST) THEN
                      IF((.NOT.MISSING(RVALB)) .AND.
     *                   ((JPOS+1-RPOS).GT.0.5)  ) THEN
                        RVAL=RVALB
                      ELSEIF((.NOT.MISSING(RVALT)).AND.
     *                   ((RPOS-JPOS).GT.0.5)  ) THEN
                        RVAL=RVALT
                      ELSE
                        RVAL=RMISS
                      ENDIF
                    ELSE
                      RVAL=RMISS
                    ENDIF
                    PARRAY(JI+(JJ-1)*NXP)=RVAL
 3360            CONTINUE
               ELSE
                  DO 3365 JI=1,NXP
                     PARRAY(JI+(JJ-1)*NXP)=RMISS
 3365             CONTINUE
               ENDIF
 3370       CONTINUE
C
C
      ELSE
        CALL INTLOG(JP_ERROR,'INTOCNU: Error in logic.',JPQUIET)
        CALL INTLOG(JP_ERROR,'INTOCNU: HICODE = ',JPQUIET)
        CALL INTLOG(JP_ERROR,HICODE,JPQUIET)
        CALL INTLOG(JP_ERROR,'INTOCNU: IIRREG = ',IIRREG)
        INTOCNU = JPROUTINE + 16
        GOTO 900
      ENDIF
C
C     ------------------------------------------------------------------
C*    Section 9 . Return.
C     ------------------------------------------------------------------
C
  900 CONTINUE
C
C
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE EXTGRPC(KBUFL,YBUFF, I,K,CVAL,KERR )
C
C**** *EXTGRP*
C
C
C     PURPOSE.
C     --------
C         CONVERT GROUP IN THE REPORT
C         TO INTEGERS IN ARRAY 'KINT' .
C
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *EXTGRP(KBUFL,YBUFF, I,K,IVAL,KERR )
C
C                    kbufl - size of ybuff in bytes
C                    ybuff - character string
C
C                    I - CONVERSION OF GROUP STARTS IN WORD I
C                        OF ARRAY 'ybuff' .
C
C                    k - number of characters to convert
C
C
C
C     METHOD.
C     -------
C
C          NONE.
C
C
C     EXTERNALS.
C     ----------
C
C
C     REFERENCE.
C     ----------
C
C          NONE.
C
C     AUTHOR.
C     -------
C
C
C
C     MODIFICATIONS.
C     --------------
C
C          M. D. DRAGOSAVAC    *ECMWF*       15/09/2003.
C
C
      IMPLICIT LOGICAL(O,G)
C
      CHARACTER*(*) YBUFF , CVAL
C
C
C     ------------------------------------------------------------------
C*          1.   EXTRACT GROUP OF CHARACTERS.
C                ----------------------------
 100  CONTINUE
C
C
      CVAL=YBUFF(I:I+K-1)
C
      I=I+K
C
C
      RETURN
      END

C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE GGVALUE(NEWFLD, NEXT, INROW, RLAT, RLON,
     X                   POLELAT, POLELON, NGAUSS, TYPE, FIELD)
C
C---->
C**** GGVALUE
C
C     PURPOSE
C     _______
C
C     Rotates one line of latitude in a gaussian grid.
C
C     INTERFACE
C     _________
C
C     CALL GGVALUE(NEWFLD, NEXT, INROW, RLAT, RLON,
C    X             POLELAT, POLELON, NGAUSS, TYPE, FIELD)
C
C
C     Input parameters
C     ________________
C
C     NEWFLD  - The field of values being created
C     NEXT    - Start offset of the latitude row being created
C     INROW   - The number of points in the latitude row
C     RLAT    - Target point latitude in the rotated grid
C     RLON    - Target point longitude in the rotated grid
C     POLELAT - Latitude of the rotated South Pole
C     POLELON - Longitude of the rotated South Pole
C     FIELD   - Original unrotated gaussian field values
C     NGAUSS  - Original unrotated gaussian field number
C     TYPE    - Original unrotated gaussian field type
C               = 'F' for full (regular) gaussian field
C               = 'R' for reduced (quasi) gaussian field
C
C     Output parameters
C     ________________
C
C     NEWFLD(NEXT) to NEWFLD(NEXT+INROW-1) contains the latitude row
C     values.
C
C
C     METHOD
C     ______
C
C     Rotates the lat/long positions of points along a latitude row in
C     a rotated gaussian grid back to positions in the unrotated grid
C     and then interpolates values from the original grid.
C
C
C     EXTERNALS
C     _________
C
C     LL2XYZ  - Converts a latitude/longitude position to (x,y,z)
C               wrt axes through the centre of the globe. The z-axis
C               runs from the south to north pole. The x- and y-axes
C               are in the plane of the equator with the x-axis
C               pointing out through lat/long (0,0).
C     YROTATE - Rotates the globe about the new y-axis.
C     XYZ2LL  - Converts an (x,y,z) position to a latitude/longitude.
C     GGINTRP - Interpolates a value from an existing grid.
C
C
C     REFERENCE
C     _________
C
C     None
C
C
C     COMMENTS
C     ________
C
C     The input field is assumed to be global in extent, and a known
C     definition, either N160 or N80 (reduced or regular).
C
C
C     AUTHOR
C     ______
C
C     J.D.Chambers      ECMWF       April 1996
C
C
C     MODIFICATIONS
C     _____________
C
C     None.
C
C----<
C     _______________________________________________________
C
C*    Section 0. Definition of variables.
C     _______________________________________________________
C
      IMPLICIT NONE
C
C     Parameters
C
      INTEGER JPMAXGG
      PARAMETER( JPMAXGG = 1280 )
C
C     Function arguments
C
      REAL NEWFLD, RLAT, RLON, POLELAT, POLELON, FIELD
      DIMENSION NEWFLD(*), RLON(*), FIELD(*)
      INTEGER NEXT, INROW, NGAUSS
      CHARACTER*1 TYPE
C
C     Local variables
C
      REAL X(JPMAXGG), Y(JPMAXGG), Z(JPMAXGG)
      REAL RX(JPMAXGG),RY(JPMAXGG),RZ(JPMAXGG)
      REAL OLAT(JPMAXGG),OLON(JPMAXGG)
      INTEGER LOOP
C
C     Convert the rotated row points lat/longs to (x,y,z) coordinates
C
      CALL LL2XYZ(RLAT,RLON,X,Y,Z,INROW)
C
C     Rotate the rotated row points back through the original latitude
C     rotation
C
      CALL YROTATE(-(90.0+POLELAT),X,Y,Z,RX,RY,RZ,INROW)
C
C     Convert the rotated row points adjusted (x,y,z) coordinates to
C     lat/long in the original grid (after longitude rotation)
C
      CALL XYZ2LL(RX,RY,RZ,OLAT,OLON,INROW)
C
C     Adjust the rotated line longitudes to remove the longitude
C     rotation
C
      DO LOOP = 1, INROW
        OLON(LOOP) = OLON(LOOP) + POLELON
        IF( OLON(LOOP).LT.0.0 )   OLON(LOOP) = OLON(LOOP) + 360.0
        IF( OLON(LOOP).GE.360.0 ) OLON(LOOP) = OLON(LOOP) - 360.0
      ENDDO
C
C     Interpolate the original unrotated grid to the points in the
C     rotated line
C
      CALL GGINTRP(NEWFLD,NEXT,INROW,OLAT,OLON,NGAUSS,TYPE,FIELD)
C
      RETURN
      END

C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE EXTGRP(KBUFL,YBUFF, I,K,IVAL,KERR )
C
C**** *EXTGRP*
C
C
C     PURPOSE.
C     --------
C
C         Extract value of group of character
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *EXTGRP(kbufl,ybuff, i,k,ival,kerr )
C
C                    kbufl - size of ybuff in bytes
C                    ybuff - character string
C
C                    I - CONVERSION OF GROUP STARTS IN WORD I
C                        OF ARRAY 'KCHAR' .
C
C                    K - number of characters to convert
C
C
C
C     METHOD.
C     -------
C
C          NONE.
C
C
C     EXTERNALS.
C     ----------
C
C
C     REFERENCE.
C     ----------
C 
C          NONE.
C
C     AUTHOR.
C     -------
C
C
C
C     MODIFICATIONS.
C     --------------
C
C          M. D. DRAGOSAVAC    *ECMWF*       15/09/2003.
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
C
      COMMON /CREXWORK/ NBPT,NGS,NVIND,NBPTSEC2,RVIND,EPS,NE,IEOLD,
     1                  NC07YYY
C
      CHARACTER*(*) YBUFF
      CHARACTER*8 FMT
      REAL*8 RVIND, EPS
C
      DIMENSION NN(5)
C
C     ------------------------------------------------------------------
C*          1.   EXTRACT GROUP OF CHARACTERS.
C                ----------------------------
 100  CONTINUE
C
      IVAL=NVIND
C
      FMT='(I10.10)'
      WRITE(FMT(3:4),'(I2.2)') K
      FMT(6:7)=FMT(3:4)
C
C
c     Check for '-' sign
c
      IF(NE.EQ.1) THEN
         IF(YBUFF(I:I).EQ.'-') THEN
            I=I+1
         END IF
      END IF
c     
c     Check for slash or non figure character
c
      DO IZ=I,I+K-1
      IF(YBUFF(IZ:IZ).EQ.'/') RETURN
      IICH=ICHAR(YBUFF(IZ:IZ)) 
      IF(IICH.LT.48.OR.IICH.GT.57) RETURN
      END DO
c
      READ(YBUFF(I:I+K-1),FMT,IOSTAT=IOS) IVAL
      IF(IOS.NE.0) THEN
         KERR=35
         CALL CREXERR(KERR)
         RETURN
      END IF
C
      IF(YBUFF(I-1:I-1).EQ.'-') IVAL=-IVAL
C
      I=I+K
C
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE GRPRS4 (KSEC0,KSEC4,PSEC4)
C
C---->
C**** GRPRS4 - Print information from Section 4 of GRIB code.
C
C     Purpose.
C     --------
C
C     Print the information in the Binary data section
C     Section (Section 4) of decoded GRIB data.
C
C**   Interface.
C     ----------
C
C     CALL GRPRS4 (KSEC0,KSEC4,PSEC4)
C
C
C     Input Parameters.
C     -----------------
C     KSEC0 - Array of decoded integers from Section 0.
C     KSEC4 - Array of decoded integers from Section 4.
C     PSEC4 - Array of decoded reals from Section 4.
C
C     Output Parameters.
C     ------------------
C
C     None.
C
C     Method.
C     -------
C
C     Fields printed as integers or reals.
C
C     Externals.
C     ----------
C
C     SETPAR
C     INXBIT.
C
C     Common block GRPRSCM.
C
C     Reference.
C     ----------
C
C     WMO Manual on Codes re GRIB Code.
C     See also routine GRIBEX.
C
C     Comments.
C     ---------
C
C     Checks environment variable GRPRS_STREAM for output stream number
C     for printing (default is 6)
C
C     Author.
C     -------
C
C     J. Hennessy    ECMWF 11.09.91
C
C     Modifications.
C     --------------
C
C     J. Hennessy    ECMWF 21.07.92
C
C     J.D.Chambers   ECMWF 20.10.93
C     Distinguish between real and integer values
C     in print of gridpoint values
C
C     J.D.Chambers   ECMWF 09.05.94
C     Print complex packing information
C
C     J.D.Chambers   ECMWF 14.06.95
C     Change format for printing missing data indicator to
C     allow for MAGICS value (-1.5E+21)
C
C     J. Clochard, Meteo France, for ECMWF - January 1998.
C     Take into account second-order packing for grid-point data.
C
C     J.D.Chambers   ECMWF    June 2002
C     Add option to set output stream number using environment variable
C     GRPRS_STREAM
C
C----<
C     -----------------------------------------------------------------|
C*    Section 0. Definition of variables.
C     -----------------------------------------------------------------|
C
      IMPLICIT NONE
C
#include "common/grprs.h"
C
      INTEGER KSEC0(*)
      INTEGER KSEC4(*)
      REAL PSEC4(*)
C
      INTEGER INUM, J210, J212, IVALUE, IBIT, IDUM, INSPT, IRET
C
C     -----------------------------------------------------------------|
C*    Section 1 . Print integer information from KSEC4.
C     -----------------------------------------------------------------|
C
  100 CONTINUE
C
      WRITE(GRPRSM,9000)
      WRITE(GRPRSM,9001)
      WRITE(GRPRSM,9002)
C
      WRITE(GRPRSM,9003) KSEC4(1)
      WRITE(GRPRSM,9004) KSEC4(2)
      WRITE(GRPRSM,9005) KSEC4(3)
      WRITE(GRPRSM,9006) KSEC4(4)
      WRITE(GRPRSM,9007) KSEC4(5)
      WRITE(GRPRSM,9008) KSEC4(6)
      WRITE(GRPRSM,9009) KSEC4(7)
      WRITE(GRPRSM,9010) KSEC4(8)
      WRITE(GRPRSM,9011) KSEC4(9)
      WRITE(GRPRSM,9012) KSEC4(10)
C     If complex packing ..
      IF ( KSEC4(4).EQ.64 ) THEN
C
        IF ( KSEC4(3).EQ.128 ) THEN
          WRITE(GRPRSM,9116) KSEC4(16)
          WRITE(GRPRSM,9117) KSEC4(17)
          WRITE(GRPRSM,9118) KSEC4(18)
          WRITE(GRPRSM,9119) KSEC4(19)
          WRITE(GRPRSM,9120) KSEC4(20)
        ELSE
          WRITE(GRPRSM,9013) KSEC4(11)
          WRITE(GRPRSM,9014) KSEC4(12)
          WRITE(GRPRSM,9015) KSEC4(13)
          WRITE(GRPRSM,9016) KSEC4(14)+KSEC4(15)
        ENDIF
C
      ENDIF
C
C     Number of non-missing values
C
      IF ( KSEC4(21).NE.0 )  WRITE(GRPRSM,9017) KSEC4(21)
C
C     Information on matrix of values , if present.
C
      IF (KSEC4(8).EQ.64)
     C   THEN
             WRITE(GRPRSM,9020) KSEC4(50)
             WRITE(GRPRSM,9021) KSEC4(51)
             WRITE(GRPRSM,9022) KSEC4(52)
             WRITE(GRPRSM,9023)
             WRITE(GRPRSM,9024) KSEC4(53)
             WRITE(GRPRSM,9025) KSEC4(54)
             WRITE(GRPRSM,9023)
             WRITE(GRPRSM,9026) KSEC4(55)
             WRITE(GRPRSM,9027) KSEC4(56)
             WRITE(GRPRSM,9028) KSEC4(57)
         ENDIF
C
C     -----------------------------------------------------------------|
C*    Section 2. Print values from PSEC4.
C     -----------------------------------------------------------------|
C
  200 CONTINUE
C
      WRITE(GRPRSM,9000)
C
      INUM = KSEC4(1)
      IF (INUM.LT.0)  INUM = - INUM
      IF (INUM.GT.20) INUM = 20
C
C     Print first INUM values.
C
      WRITE(GRPRSM,9031) INUM
C
      IF ( KSEC4(5) .EQ. 0 ) THEN
C
C     Print real values ...
        DO 210 J210=1,INUM
          WRITE(GRPRSM,9034) PSEC4(J210)
  210   CONTINUE
C
      ELSE
C
C     Print integer values ...
        CALL SETPAR(IBIT,IDUM,IDUM)
        DO 212 J212=1,INUM
           INSPT = 0
           CALL INXBIT(IVALUE,1,INSPT,PSEC4(J212),1,IBIT,IBIT,'C',IRET)
           WRITE(GRPRSM,9033) IVALUE
  212   CONTINUE
      ENDIF
C
C     -----------------------------------------------------------------|
C*    Section 9 . Format statements. Return to calling routine.
C     -----------------------------------------------------------------|
C
  900 CONTINUE
C
 9000 FORMAT(' ')
 9001 FORMAT(' Section 4 - Binary Data  Section.')
 9002 FORMAT(' -------------------------------------')
 9003 FORMAT(' Number of data values coded/decoded.         ',I9)
 9004 FORMAT(' Number of bits per data value.               ',I9)
 9005 FORMAT(' Type of data       (0=grid pt, 128=spectral).',I9)
 9006 FORMAT(' Type of packing    (0=simple, 64=complex).   ',I9)
 9007 FORMAT(' Type of data       (0=float, 32=integer).    ',I9)
 9008 FORMAT(' Additional flags   (0=none, 16=present).     ',I9)
 9009 FORMAT(' Reserved.                                    ',I9)
 9010 FORMAT(' Number of values   (0=single, 64=matrix).    ',I9)
 9011 FORMAT(' Secondary bit-maps (0=none, 32=present).     ',I9)
 9012 FORMAT(' Values width       (0=constant, 16=variable).',I9)
 9013 FORMAT(' Bits number of 2nd order values    (none=>0).',I9)
 9014 FORMAT(' General extend. 2-order packing (0=no,8=yes).',I9)
 9015 FORMAT(' Boustrophedonic ordering        (0=no,4=yes).',I9)
 9016 FORMAT(' Spatial differencing order          (0=none).',I9)
 9017 FORMAT(' Number of non-missing values                 ',I9)
 9120 FORMAT(' Pentagonal resolution parameter M for subset.',I9)
 9020 FORMAT(' First dimension (rows) of each matrix.       ',I9)
 9021 FORMAT(' Second dimension (columns) of each matrix.   ',I9)
 9022 FORMAT(' First dimension coordinate values definition.',I9)
 9023 FORMAT(' (Code Table 12)')
 9024 FORMAT(' NC1 - Number of coefficients for 1st dimension.',I7)
 9025 FORMAT(' Second dimension coordinate values definition.',I8)
 9026 FORMAT(' NC2 - Number of coefficients for 2nd dimension.',I7)
 9027 FORMAT(' 1st dimension physical signifance (Table 13). ',I8)
 9028 FORMAT(' 2nd dimension physical signifance (Table 13). ',I8)
 9031 FORMAT(' First ',I4,' data values.')
 9032 FORMAT(' ',F30.15)
C
C931020
 9033 FORMAT(' ',I15)
 9034 FORMAT(' ',G20.8)
C
C940509
 9116 FORMAT(' Byte offset of start of packed data (N).     ',I9)
 9117 FORMAT(' Power (P * 1000).                            ',I9)
 9118 FORMAT(' Pentagonal resolution parameter J for subset.',I9)
 9119 FORMAT(' Pentagonal resolution parameter K for subset.',I9)
      RETURN
C
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities
C granted to it by virtue of its status as an intergovernmental organisation
C nor does it submit to any jurisdiction.
C


      SUBROUTINE ROWINA (P,KO,KI,PW,KCODE)
C
C---->
C**** ROWINA - Interpolation of row of values.
C
C     Purpose.
C     --------
C
C           Interpolate a row of values.
C
C**   Interface.
C     ----------
C
C           CALL ROWINA (P,KO,KI,PW,KCODE)
C
C           Integer    K.
C           Real       P.
C           Logical    O.
C           Character  H.
C
C               Input Parameters.
C               -----------------
C
C               P     - Row of values to be interpolated.
C                       Dimension must be at least KO.
C
C               KO    - Number of values required.
C
C               KI    - Number of values in P on input.
C
C               PW    - Working array.
C                       Dimension must be at least (0:KO+2,3).
C
C               KCODE - Interpolation required.
C                       1 , linear.
C                       3 , cubic.
C
C               Output Parameters.
C               ------------------
C
C               P     - Now contains KO values.
C
C     Method.
C     -------
C
C           Linear or cubic interpolation performed as required.
C
C     Externals.
C     ----------
C
C           SCM0
C
C     Reference.
C     ----------
C
C           None.
C
C     Comments.
C     ---------
C
C           This is a version of ROWINT which conforms to Ansi
C           standards, achieved by passing the work array as a
C           parameter and changing lower case letters to upper case.
C
C     Author.
C     -------
C
C           J. Hennessy     ECMWF     09.10.91
C
C     Modifications.
C     --------------
C
C           J. Hennessy     ECMWF     07.01.92
C           Call to ABORT changed to ABORTX.
C
C     -----------------------------------------------------------------
C----<
C
      DIMENSION P(KO),PW(0:KO+2,3)
C
      IF(KCODE.EQ.1) THEN
         DO 102 JL=1,KI
            PW(JL,1)=P(JL)
  102    CONTINUE
         PW(KI+1,1)=P(1)
         ZRDI=REAL(KI)
         ZDO=1./REAL(KO)
C
         DO 105 JL=1,KO
            ZPOS=(JL-1)*ZDO
            ZWT=ZPOS*ZRDI
            IP=ZWT
            ZWT=ZWT-IP
            P(JL)=(1.-ZWT)*PW(IP+1,1)+ZWT*PW(IP+2,1)
  105    CONTINUE
C
      ELSEIF(KCODE.EQ.3) THEN
         DO 302 JL=1,KI
            PW(JL,1)=P(JL)
  302    CONTINUE
         PW(0,1)=P(KI)
         PW(KI+1,1)=P(1)
         PW(KI+2,1)=P(2)
         DO 305 JL=1,KI
            PW(JL,2)= - PW(JL-1,1)/3. - 0.5*PW(JL,1)
     1             + PW(JL+1,1)    - PW(JL+2,1)/6.
            PW(JL+1,3)=   PW(JL-1,1)/6. - PW(JL,1)
     1             + 0.5*PW(JL+1,1) + PW(JL+2,1)/3.
  305    CONTINUE
         CALL SCM0(PW(1,2),PW(2,3),PW(1,1),PW(2,1),KI)
         ZRDI=REAL(KI)
         ZDO=1./REAL(KO)
         DO 310 JL=1,KO
            ZPOS=(JL-1)*ZDO
            ZWT=ZPOS*ZRDI
            IP=ZWT+1
            ZWT=ZWT+1.-IP
            ZWT1 = 1. - ZWT
            P(JL)=((3.-2.*ZWT1)*PW(IP,1) + ZWT*PW(IP,2))*ZWT1*ZWT1
     1       + ((3.-2.*ZWT) *PW(IP+1,1) - ZWT1*PW(IP+1,3))*ZWT*ZWT
  310    CONTINUE
      ELSE
         WRITE (*,9001) KCODE
         CALL ABORTX ('ROWINA')
      ENDIF
C
      RETURN
C
 9001 FORMAT (1H ,'ROWINA : Invalid interpolation code = ',I4)
C
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C


      SUBROUTINE DSWMRS(IBLOSW,LOGISW,ILLGTH,INSOUT,IILGTH,RESOUT,
     S                  IRLGTH,MGRIBS,ILENSW,IBITMC,LPRINTS)
C
C---->
C**** *DSWMRS* - ROUTINE TO DECODE A MARS MODEL SWITCH.
C
C     G.K.SAKELLARIDES  ECMWF        17/05/85.
C     THE STRUCTURE IS SIMILAR TO J.HENNESSY'S SUBROUTINE *DECOGR*
C
C     PURPOSE.
C     --------
C
C          TO DECODE A MODEL SWITCH MARS RECORD FROM MARS PACKED
C          SWITCH RECORD AS WELL AS TO PRINT THE DECOTED RECORD
C          IN CASE LPRINTS=.TRUE.
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *DSWMRS(IBLOSW,LOGISW,ILLGTH,INSOUT,IILGTH,RESOUT,
C                       IRLGTH,MGRIBS,ILENSW,IBITMC)*
C        WHERE:
C              INPUT PARAMETERS
C              1.*MGRIBS* ARRAY CONTAINING THE PACKED MARS MODEL SWITCH
C              2.*ILENSW* THE LENGTH OF THE ARRAY MGRIBS (750 CRAY WORD)
C              3.*IBITMC* NUMBER OF BITS PER COMPUTER WORD.
C              4.*LPRINTS* .TRUE. IF AN OUTPUT OF THE DECOTED MARS
C                           MODEL SWITCH RECORD IS REQUIRED.
C              OUTPUT PARAMETERS
C              1.*IBLOSW* INTEGER ARRAY OF LENGTH 29 CONTAINING
C                          THE FOLLOWING INFORMATIONS OF BLOCK1.
C  1.1                        G
C  1.2                        R
C  1.3                        I
C  1.4                        B
C  1.5         IDENTIFICATION OF CENTRE)
C  1.6         MODEL IDENTIFICATION
C  1.7         GRID DEFINITION
C  1.8         FLAG (CODE TABLE 1)
C  1.9         PARAM. INTICATING THE MARS MODEL SWITCH REC.
C  1.10         TYPE OF LEVEL (CODE TABLE 3)
C  1.11         VALUE 1 OF LEVEL (CODE TABLE 3)
C  1.12         VALUE 2 OF LEVEL (CODE TABLE 3)
C  1.13         YEAR    OF INITIAL DATA
C  1.14         MONTH   OF INITIAL DATA
C  1.15         DAY     OF INITIAL DATA
C  1.16         HOUR    OF INITIAL DATA
C  1.17         MINUTE  OF INITIAL DATA
C  1.18         TIME UNIT (CODE TABLE 4)
C  1.19         TIME RANGE 1
C  1.20         TIME RANGE 2
C  1.21         TIME RANGE FLAG (CODE TABLE 5)
C  1.22-24      RESERVED
C  1.26         STARTING ADDRESS OF LOGICAL SECTION(OCTET)
C  1.27         STARTING ADDRESS OF INTEGER SECTION(OCTET)
C  1.28         STARTING ADDRESS OF REAL    SECTION(OCTET)
C  1.29         LENGTH           OF REAL    SECTION(OCTET)
C              2.*LOGISW* INTEGER ARRAY OF SUFFICIENT LENGTH WHICH
C                          CONTAINS THE LOGICALS.
C              3.*ILLGTH* ACTUAL LENGTH OF LOGICALS
C              4.*INSOUT* INTEGER ARRAY OF SUFFICIENT LENGTH WHICH
C                         CONTAINS THE INTEGERS
C              5.*IILGTH* ACTUAL LENGTH OF INTEGER
C              6.*RESOUT* REAL ARRAY OF SUFFICIENT LENGTH WHICH
C                         CONTAINS THE REALS
C              7.*IRLGTH* ACTUAL LENGTH OF REALS
C
C     EXTERNALS.
C     ----------
C
C         *GBYTES*   EXTRACT BIT FIELD
C         *GBYTE *   EXTRACT BIT FIELD
C         *OFFSET*  CALCULATES THE WORD AND BIT OFFSET OF THE START
C                   OF THE NEXT BIT FIELD.
C         *DECFP*   DECODE GRIB CODE REPRESENTATION TO FLOATING POINT
C                   NUMBER.
C
C----<
C
      DIMENSION IBLOSW(*),INSOUT(*),RESOUT(*),MGRIBS(ILENSW)
      DIMENSION ILSOUT(500)
      DIMENSION IAA(4)
      LOGICAL LOGISW(*),LPRINTS
C
C*              1. SET LOCAL VARIABLES
C
  100 CONTINUE
      IERR=0
      ILMGRIB=ILENSW
      IBITCR=IBITMC
C
C*              1.5 VARIABLES OF BLOCK 1
C
      IWORD=1
      IBYTE=8
      IVAL=24
      IOFF=0
      CALL GBYTES(MGRIBS(IWORD),IBLOSW(1),IOFF,IBYTE,0,IVAL)
      CALL OFFSET(IOFF,IVAL,IWORD,IBYTE,IBITCR,ILMGRIB,IERR)
      IF (IERR.NE.0) GO TO 900
C
C*     LENTHG OF DATA BLOCK(OCTET)
      CALL GBYTE(MGRIBS(IWORD),IBLOSW(25),IOFF,24)
      CALL OFFSET(IOFF,1,IWORD,24,IBITCR,ILMGRIB,IERR)
      IF (IERR.NE.0)GO TO 900
C
C*     STARTING ADDRESS OF LOGICAL  AND INTEGER SECTION
      IBYTE=8
      IVAL=2
      CALL GBYTES(MGRIBS(IWORD),IBLOSW(26),IOFF,IBYTE,0,IVAL)
      CALL OFFSET(IOFF,IVAL,IWORD,IBYTE,IBITCR,ILMGRIB,IERR)
      IF (IERR.NE.0)GO TO 900
C*     STARTING ADDRESS OF REAL SECTION
      CALL GBYTE(MGRIBS(IWORD),IBLOSW(28),IOFF,16)
      CALL OFFSET(IOFF,1,IWORD,16,IBITCR,ILMGRIB,IERR)
      IF (IERR.NE.0)GO TO 900
C* LENGTH OF REAL SECTION
      CALL GBYTE(MGRIBS(IWORD),IBLOSW(29),IOFF,16)
      CALL OFFSET(IOFF,1,IWORD,16,IBITCR,ILMGRIB,IERR)
      IF (IERR.NE.0)GO TO 900
C
C*              3. BLOCK 4 DATA
C                  ----
C
  300 CONTINUE
C
C*         3.1 LOGICALS
C              DECODE LOGICALS FROM MARS FORMAT
C
  310 CONTINUE
C*           FINDS LENGTH OF LOGICALS
      ILLGTH=IBLOSW(27)-IBLOSW(26)
      IBYTE=8
      IVAL=ILLGTH
      CALL GBYTES(MGRIBS(IWORD),ILSOUT(1),IOFF,IBYTE,0,IVAL)
      CALL OFFSET(IOFF,IVAL,IWORD,IBYTE,IBITCR,ILMGRIB,IERR)
      IF (IERR.NE.0) GO TO 900
      DO 314 I=1,ILLGTH
C--   LOGISW(I)=SHIFTL(ILSOUT(I),63)
      IF (ILSOUT(I).EQ.1) LOGISW(I) = .TRUE.
C--
  314 CONTINUE
C
C*         3.2 INTEGERS
C
C*      LENGTH OF INTEGERS
      IILGTH=(IBLOSW(28)-IBLOSW(27))/2
      IBYTE=16
      IVAL=IILGTH
      CALL GBYTES(MGRIBS(IWORD),INSOUT(1),IOFF,IBYTE,0,IVAL)
      CALL OFFSET(IOFF,IVAL,IWORD,IBYTE,IBITCR,ILMGRIB,IERR)
      IF (IERR.NE.0)GO TO 900
C*         3.3 REALS
C
C*    LENGTH OF REAL SECTION
      IRLGTH=IBLOSW(29)/4
      DO 335 J=1,IRLGTH
      CALL GBYTE(MGRIBS(IWORD),IEXP,IOFF,8)
      CALL OFFSET(IOFF,1,IWORD,8,IBITCR,ILMGRIB,IERR)
      IF (IERR.NE.0)GO TO 900
      CALL GBYTE(MGRIBS(IWORD),IMANT,IOFF,24)
      CALL OFFSET(IOFF,1,IWORD,24,IBITCR,ILMGRIB,IERR)
      IF (IERR.NE.0)GO TO 900
      CALL DECFP(RESOUT(J),IEXP,IMANT)
  335 CONTINUE
C
C
C*         3.4 UNUSED WORDS
C
  340 CONTINUE
C*    USED OCTET
      IUSED=33+ILLGTH+IILGTH*2+IRLGTH*4
C*    UNUSED OCTET
      IUNUSE=ILENSW*8-4-IUSED
      DO 345 J=1,IUNUSE
      CALL GBYTE(MGRIBS(IWORD),IEEE,IOFF,8)
      CALL OFFSET(IOFF,1,IWORD,8,IBITCR,ILMGRIB,IERR)
      IF (IERR.NE.0)GO TO 900
  345 CONTINUE
C
C*                3.5 CORECT LENGTH OF INTEGER SECTION
C
  350 CONTINUE
      INGL=INSOUT(6)
      INLEV=INSOUT(6+INGL+1)
      J1A=1
      J1T=6
      J2A=J1T+1
      J2T=J2A+INGL-1
      J3A=J2T+1
      J3T=J3A+14-1
      J4A=J3T+1
      J4T=J4A+INGL-1
      J5A=J4T+1
      J5T=J5A+INGL-1
      J6A=J5T+1
      J6T=J6A+10-1
      J7A=J6T+1
      J7T=J7A+INLEV-1
      J8A=J7T+1
      J8T=J8A+INLEV-1
      J9A=J8T+1
      J9T=J9A+INLEV-1
      IILGTH=J9T
C
C*          4. BLOCK 5
C
  400 CONTINUE
      CALL GBYTES(MGRIBS(IWORD),IAA(1),IOFF,8,0,4)
C
C
C*            5. OUTPUT
C
  500 CONTINUE
      IF (LPRINTS) THEN
C
         CALL ANALSW(IBLOSW,LOGISW,ILLGTH,INSOUT,IILGTH,
     S              RESOUT,IRLGTH)
C
      ENDIF
C
C*           6. RETURN
C
  600 CONTINUE
      RETURN
C
C*             9. ERROR HANDLING
C
  900 CONTINUE
      WRITE(*,9901)
      WRITE(*,'(A)') 'ERROR IN OFFSET'
      CALL ENDRUN
      STOP
 9901 FORMAT('ERROR IN SUBROUTINE DSWMRS')
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE QPASSM(A,B,C,D,TRIGS,INC1,INC2,INC3,INC4,LOT,N,IFAC,
     *    LA,IERR)
      DIMENSION A(N),B(N),C(N),D(N),TRIGS(N)
C
C---->
C
C     SUBROUTINE 'QPASSM' - PERFORMS ONE PASS THROUGH DATA AS PART
C     OF MULTIPLE REAL FFT (FOURIER ANALYSIS) ROUTINE
C
C     A IS FIRST REAL INPUT VECTOR
C         EQUIVALENCE B(1) WITH A(IFAC*LA*INC1+1)
C     C IS FIRST REAL OUTPUT VECTOR
C         EQUIVALENCE D(1) WITH C(LA*INC2+1)
C     TRIGS IS A PRECALCULATED LIST OF SINES & COSINES
C     INC1 IS THE ADDRESSING INCREMENT FOR A
C     INC2 IS THE ADDRESSING INCREMENT FOR C
C     INC3 IS THE INCREMENT BETWEEN INPUT VECTORS A
C     INC4 IS THE INCREMENT BETWEEN OUTPUT VECTORS C
C     LOT IS THE NUMBER OF VECTORS
C     N IS THE LENGTH OF THE VECTORS
C     IFAC IS THE CURRENT FACTOR OF N
C     LA = N/(PRODUCT OF FACTORS USED SO FAR)
C     IERR IS AN ERROR INDICATOR:
C              0 - PASS COMPLETED WITHOUT ERROR
C              1 - LOT GREATER THAN 64
C              2 - IFAC NOT CATERED FOR
C              3 - IFAC ONLY CATERED FOR IF LA=N/IFAC
C
C-----------------------------------------------------------------------
C----<
C
      DATA SIN36/0.587785252292473/,SIN72/0.951056516295154/,
     *    QRT5/0.559016994374947/,SIN60/0.866025403784437/
C
      M=N/IFAC
      IINK=LA*INC1
      JINK=LA*INC2
      IJUMP=(IFAC-1)*IINK
      KSTOP=(N-IFAC)/(2*IFAC)
C
      IBAD=1
      IF (LOT.GT.64) GO TO 910
      IBASE=0
      JBASE=0
      IGO=IFAC-1
      IF (IGO.EQ.7) IGO=6
      IBAD=2
      IF (IGO.LT.1.OR.IGO.GT.6) GO TO 910
      GO TO (200,300,400,500,600,800),IGO
C
C     CODING FOR FACTOR 2
C     -------------------
  200 CONTINUE
      IA=1
      IB=IA+IINK
      JA=1
      JB=JA+(2*M-LA)*INC2
C
      IF (LA.EQ.M) GO TO 290
C
      DO 220 L=1,LA
      I=IBASE
      J=JBASE
CDIR$ IVDEP
      DO 210 IJK=1,LOT
      C(JA+J)=A(IA+I)+A(IB+I)
      C(JB+J)=A(IA+I)-A(IB+I)
      I=I+INC3
      J=J+INC4
  210 CONTINUE
      IBASE=IBASE+INC1
      JBASE=JBASE+INC2
  220 CONTINUE
      JA=JA+JINK
      JINK=2*JINK
      JB=JB-JINK
      IBASE=IBASE+IJUMP
      IJUMP=2*IJUMP+IINK
      IF (JA.EQ.JB) GO TO 260
      DO 250 K=LA,KSTOP,LA
      KB=K+K
      C1=TRIGS(KB+1)
      S1=TRIGS(KB+2)
      JBASE=0
      DO 240 L=1,LA
      I=IBASE
      J=JBASE
CDIR$ IVDEP
      DO 230 IJK=1,LOT
      C(JA+J)=A(IA+I)+(C1*A(IB+I)+S1*B(IB+I))
      C(JB+J)=A(IA+I)-(C1*A(IB+I)+S1*B(IB+I))
      D(JA+J)=(C1*B(IB+I)-S1*A(IB+I))+B(IA+I)
      D(JB+J)=(C1*B(IB+I)-S1*A(IB+I))-B(IA+I)
      I=I+INC3
      J=J+INC4
  230 CONTINUE
      IBASE=IBASE+INC1
      JBASE=JBASE+INC2
  240 CONTINUE
      IBASE=IBASE+IJUMP
      JA=JA+JINK
      JB=JB-JINK
  250 CONTINUE
      IF (JA.GT.JB) GO TO 900
  260 CONTINUE
      JBASE=0
      DO 280 L=1,LA
      I=IBASE
      J=JBASE
CDIR$ IVDEP
      DO 270 IJK=1,LOT
      C(JA+J)=A(IA+I)
      D(JA+J)=-A(IB+I)
      I=I+INC3
      J=J+INC4
  270 CONTINUE
      IBASE=IBASE+INC1
      JBASE=JBASE+INC2
  280 CONTINUE
      GO TO 900
C
  290 CONTINUE
      Z=1.0/FLOAT(N)
      DO 294 L=1,LA
      I=IBASE
      J=JBASE
CDIR$ IVDEP
      DO 292 IJK=1,LOT
      C(JA+J)=Z*(A(IA+I)+A(IB+I))
      C(JB+J)=Z*(A(IA+I)-A(IB+I))
      I=I+INC3
      J=J+INC4
  292 CONTINUE
      IBASE=IBASE+INC1
      JBASE=JBASE+INC2
  294 CONTINUE
      GO TO 900
C
C     CODING FOR FACTOR 3
C     -------------------
  300 CONTINUE
      IA=1
      IB=IA+IINK
      IC=IB+IINK
      JA=1
      JB=JA+(2*M-LA)*INC2
      JC=JB
C
      IF (LA.EQ.M) GO TO 390
C
      DO 320 L=1,LA
      I=IBASE
      J=JBASE
CDIR$ IVDEP
      DO 310 IJK=1,LOT
      C(JA+J)=A(IA+I)+(A(IB+I)+A(IC+I))
      C(JB+J)=A(IA+I)-0.5*(A(IB+I)+A(IC+I))
      D(JB+J)=SIN60*(A(IC+I)-A(IB+I))
      I=I+INC3
      J=J+INC4
  310 CONTINUE
      IBASE=IBASE+INC1
      JBASE=JBASE+INC2
  320 CONTINUE
      JA=JA+JINK
      JINK=2*JINK
      JB=JB+JINK
      JC=JC-JINK
      IBASE=IBASE+IJUMP
      IJUMP=2*IJUMP+IINK
      IF (JA.EQ.JC) GO TO 360
      DO 350 K=LA,KSTOP,LA
      KB=K+K
      KC=KB+KB
      C1=TRIGS(KB+1)
      S1=TRIGS(KB+2)
      C2=TRIGS(KC+1)
      S2=TRIGS(KC+2)
      JBASE=0
      DO 340 L=1,LA
      I=IBASE
      J=JBASE
CDIR$ IVDEP
      DO 330 IJK=1,LOT
      A1=(C1*A(IB+I)+S1*B(IB+I))+(C2*A(IC+I)+S2*B(IC+I))
      B1=(C1*B(IB+I)-S1*A(IB+I))+(C2*B(IC+I)-S2*A(IC+I))
      A2=A(IA+I)-0.5*A1
      B2=B(IA+I)-0.5*B1
      A3=SIN60*((C1*A(IB+I)+S1*B(IB+I))-(C2*A(IC+I)+S2*B(IC+I)))
      B3=SIN60*((C1*B(IB+I)-S1*A(IB+I))-(C2*B(IC+I)-S2*A(IC+I)))
      C(JA+J)=A(IA+I)+A1
      D(JA+J)=B(IA+I)+B1
      C(JB+J)=A2+B3
      D(JB+J)=B2-A3
      C(JC+J)=A2-B3
      D(JC+J)=-(B2+A3)
      I=I+INC3
      J=J+INC4
  330 CONTINUE
      IBASE=IBASE+INC1
      JBASE=JBASE+INC2
  340 CONTINUE
      IBASE=IBASE+IJUMP
      JA=JA+JINK
      JB=JB+JINK
      JC=JC-JINK
  350 CONTINUE
      IF (JA.GT.JC) GO TO 900
  360 CONTINUE
      JBASE=0
      DO 380 L=1,LA
      I=IBASE
      J=JBASE
CDIR$ IVDEP
      DO 370 IJK=1,LOT
      C(JA+J)=A(IA+I)+0.5*(A(IB+I)-A(IC+I))
      D(JA+J)=-SIN60*(A(IB+I)+A(IC+I))
      C(JB+J)=A(IA+I)-(A(IB+I)-A(IC+I))
      I=I+INC3
      J=J+INC4
  370 CONTINUE
      IBASE=IBASE+INC1
      JBASE=JBASE+INC2
  380 CONTINUE
      GO TO 900
C
  390 CONTINUE
      Z=1.0/FLOAT(N)
      ZSIN60=Z*SIN60
      DO 394 L=1,LA
      I=IBASE
      J=JBASE
CDIR$ IVDEP
      DO 392 IJK=1,LOT
      C(JA+J)=Z*(A(IA+I)+(A(IB+I)+A(IC+I)))
      C(JB+J)=Z*(A(IA+I)-0.5*(A(IB+I)+A(IC+I)))
      D(JB+J)=ZSIN60*(A(IC+I)-A(IB+I))
      I=I+INC3
      J=J+INC4
  392 CONTINUE
      IBASE=IBASE+INC1
      JBASE=JBASE+INC2
  394 CONTINUE
      GO TO 900
C
C     CODING FOR FACTOR 4
C     -------------------
  400 CONTINUE
      IA=1
      IB=IA+IINK
      IC=IB+IINK
      ID=IC+IINK
      JA=1
      JB=JA+(2*M-LA)*INC2
      JC=JB+2*M*INC2
      JD=JB
C
      IF (LA.EQ.M) GO TO 490
C
      DO 420 L=1,LA
      I=IBASE
      J=JBASE
CDIR$ IVDEP
      DO 410 IJK=1,LOT
      C(JA+J)=(A(IA+I)+A(IC+I))+(A(IB+I)+A(ID+I))
      C(JC+J)=(A(IA+I)+A(IC+I))-(A(IB+I)+A(ID+I))
      C(JB+J)=A(IA+I)-A(IC+I)
      D(JB+J)=A(ID+I)-A(IB+I)
      I=I+INC3
      J=J+INC4
  410 CONTINUE
      IBASE=IBASE+INC1
      JBASE=JBASE+INC2
  420 CONTINUE
      JA=JA+JINK
      JINK=2*JINK
      JB=JB+JINK
      JC=JC-JINK
      JD=JD-JINK
      IBASE=IBASE+IJUMP
      IJUMP=2*IJUMP+IINK
      IF (JB.EQ.JC) GO TO 460
      DO 450 K=LA,KSTOP,LA
      KB=K+K
      KC=KB+KB
      KD=KC+KB
      C1=TRIGS(KB+1)
      S1=TRIGS(KB+2)
      C2=TRIGS(KC+1)
      S2=TRIGS(KC+2)
      C3=TRIGS(KD+1)
      S3=TRIGS(KD+2)
      JBASE=0
      DO 440 L=1,LA
      I=IBASE
      J=JBASE
CDIR$ IVDEP
      DO 430 IJK=1,LOT
      A0=A(IA+I)+(C2*A(IC+I)+S2*B(IC+I))
      A2=A(IA+I)-(C2*A(IC+I)+S2*B(IC+I))
      A1=(C1*A(IB+I)+S1*B(IB+I))+(C3*A(ID+I)+S3*B(ID+I))
      A3=(C1*A(IB+I)+S1*B(IB+I))-(C3*A(ID+I)+S3*B(ID+I))
      B0=B(IA+I)+(C2*B(IC+I)-S2*A(IC+I))
      B2=B(IA+I)-(C2*B(IC+I)-S2*A(IC+I))
      B1=(C1*B(IB+I)-S1*A(IB+I))+(C3*B(ID+I)-S3*A(ID+I))
      B3=(C1*B(IB+I)-S1*A(IB+I))-(C3*B(ID+I)-S3*A(ID+I))
      C(JA+J)=A0+A1
      C(JC+J)=A0-A1
      D(JA+J)=B0+B1
      D(JC+J)=B1-B0
      C(JB+J)=A2+B3
      C(JD+J)=A2-B3
      D(JB+J)=B2-A3
      D(JD+J)=-(B2+A3)
      I=I+INC3
      J=J+INC4
  430 CONTINUE
      IBASE=IBASE+INC1
      JBASE=JBASE+INC2
  440 CONTINUE
      IBASE=IBASE+IJUMP
      JA=JA+JINK
      JB=JB+JINK
      JC=JC-JINK
      JD=JD-JINK
  450 CONTINUE
      IF (JB.GT.JC) GO TO 900
  460 CONTINUE
      SIN45=SQRT(0.5)
      JBASE=0
      DO 480 L=1,LA
      I=IBASE
      J=JBASE
CDIR$ IVDEP
      DO 470 IJK=1,LOT
      C(JA+J)=A(IA+I)+SIN45*(A(IB+I)-A(ID+I))
      C(JB+J)=A(IA+I)-SIN45*(A(IB+I)-A(ID+I))
      D(JA+J)=-A(IC+I)-SIN45*(A(IB+I)+A(ID+I))
      D(JB+J)=A(IC+I)-SIN45*(A(IB+I)+A(ID+I))
      I=I+INC3
      J=J+INC4
  470 CONTINUE
      IBASE=IBASE+INC1
      JBASE=JBASE+INC2
  480 CONTINUE
      GO TO 900
C
  490 CONTINUE
      Z=1.0/FLOAT(N)
      DO 494 L=1,LA
      I=IBASE
      J=JBASE
CDIR$ IVDEP
      DO 492 IJK=1,LOT
      C(JA+J)=Z*((A(IA+I)+A(IC+I))+(A(IB+I)+A(ID+I)))
      C(JC+J)=Z*((A(IA+I)+A(IC+I))-(A(IB+I)+A(ID+I)))
      C(JB+J)=Z*(A(IA+I)-A(IC+I))
      D(JB+J)=Z*(A(ID+I)-A(IB+I))
      I=I+INC3
      J=J+INC4
  492 CONTINUE
      IBASE=IBASE+INC1
      JBASE=JBASE+INC2
  494 CONTINUE
      GO TO 900
C
C     CODING FOR FACTOR 5
C     -------------------
  500 CONTINUE
      IA=1
      IB=IA+IINK
      IC=IB+IINK
      ID=IC+IINK
      IE=ID+IINK
      JA=1
      JB=JA+(2*M-LA)*INC2
      JC=JB+2*M*INC2
      JD=JC
      JE=JB
C
      IF (LA.EQ.M) GO TO 590
C
      DO 520 L=1,LA
      I=IBASE
      J=JBASE
CDIR$ IVDEP
      DO 510 IJK=1,LOT
      A1=A(IB+I)+A(IE+I)
      A3=A(IB+I)-A(IE+I)
      A2=A(IC+I)+A(ID+I)
      A4=A(IC+I)-A(ID+I)
      A5=A(IA+I)-0.25*(A1+A2)
      A6=QRT5*(A1-A2)
      C(JA+J)=A(IA+I)+(A1+A2)
      C(JB+J)=A5+A6
      C(JC+J)=A5-A6
      D(JB+J)=-SIN72*A3-SIN36*A4
      D(JC+J)=-SIN36*A3+SIN72*A4
      I=I+INC3
      J=J+INC4
  510 CONTINUE
      IBASE=IBASE+INC1
      JBASE=JBASE+INC2
  520 CONTINUE
      JA=JA+JINK
      JINK=2*JINK
      JB=JB+JINK
      JC=JC+JINK
      JD=JD-JINK
      JE=JE-JINK
      IBASE=IBASE+IJUMP
      IJUMP=2*IJUMP+IINK
      IF (JB.EQ.JD) GO TO 560
      DO 550 K=LA,KSTOP,LA
      KB=K+K
      KC=KB+KB
      KD=KC+KB
      KE=KD+KB
      C1=TRIGS(KB+1)
      S1=TRIGS(KB+2)
      C2=TRIGS(KC+1)
      S2=TRIGS(KC+2)
      C3=TRIGS(KD+1)
      S3=TRIGS(KD+2)
      C4=TRIGS(KE+1)
      S4=TRIGS(KE+2)
      JBASE=0
      DO 540 L=1,LA
      I=IBASE
      J=JBASE
CDIR$ IVDEP
      DO 530 IJK=1,LOT
      A1=(C1*A(IB+I)+S1*B(IB+I))+(C4*A(IE+I)+S4*B(IE+I))
      A3=(C1*A(IB+I)+S1*B(IB+I))-(C4*A(IE+I)+S4*B(IE+I))
      A2=(C2*A(IC+I)+S2*B(IC+I))+(C3*A(ID+I)+S3*B(ID+I))
      A4=(C2*A(IC+I)+S2*B(IC+I))-(C3*A(ID+I)+S3*B(ID+I))
      B1=(C1*B(IB+I)-S1*A(IB+I))+(C4*B(IE+I)-S4*A(IE+I))
      B3=(C1*B(IB+I)-S1*A(IB+I))-(C4*B(IE+I)-S4*A(IE+I))
      B2=(C2*B(IC+I)-S2*A(IC+I))+(C3*B(ID+I)-S3*A(ID+I))
      B4=(C2*B(IC+I)-S2*A(IC+I))-(C3*B(ID+I)-S3*A(ID+I))
      A5=A(IA+I)-0.25*(A1+A2)
      A6=QRT5*(A1-A2)
      B5=B(IA+I)-0.25*(B1+B2)
      B6=QRT5*(B1-B2)
      A10=A5+A6
      A20=A5-A6
      B10=B5+B6
      B20=B5-B6
      A11=SIN72*B3+SIN36*B4
      A21=SIN36*B3-SIN72*B4
      B11=SIN72*A3+SIN36*A4
      B21=SIN36*A3-SIN72*A4
      C(JA+J)=A(IA+I)+(A1+A2)
      C(JB+J)=A10+A11
      C(JE+J)=A10-A11
      C(JC+J)=A20+A21
      C(JD+J)=A20-A21
      D(JA+J)=B(IA+I)+(B1+B2)
      D(JB+J)=B10-B11
      D(JE+J)=-(B10+B11)
      D(JC+J)=B20-B21
      D(JD+J)=-(B20+B21)
      I=I+INC3
      J=J+INC4
  530 CONTINUE
      IBASE=IBASE+INC1
      JBASE=JBASE+INC2
  540 CONTINUE
      IBASE=IBASE+IJUMP
      JA=JA+JINK
      JB=JB+JINK
      JC=JC+JINK
      JD=JD-JINK
      JE=JE-JINK
  550 CONTINUE
      IF (JB.GT.JD) GO TO 900
  560 CONTINUE
      JBASE=0
      DO 580 L=1,LA
      I=IBASE
      J=JBASE
CDIR$ IVDEP
      DO 570 IJK=1,LOT
      A1=A(IB+I)+A(IE+I)
      A3=A(IB+I)-A(IE+I)
      A2=A(IC+I)+A(ID+I)
      A4=A(IC+I)-A(ID+I)
      A5=A(IA+I)+0.25*(A3-A4)
      A6=QRT5*(A3+A4)
      C(JA+J)=A5+A6
      C(JB+J)=A5-A6
      C(JC+J)=A(IA+I)-(A3-A4)
      D(JA+J)=-SIN36*A1-SIN72*A2
      D(JB+J)=-SIN72*A1+SIN36*A2
      I=I+INC3
      J=J+INC4
  570 CONTINUE
      IBASE=IBASE+INC1
      JBASE=JBASE+INC2
  580 CONTINUE
      GO TO 900
C
  590 CONTINUE
      Z=1.0/FLOAT(N)
      ZQRT5=Z*QRT5
      ZSIN36=Z*SIN36
      ZSIN72=Z*SIN72
      DO 594 L=1,LA
      I=IBASE
      J=JBASE
CDIR$ IVDEP
      DO 592 IJK=1,LOT
      A1=A(IB+I)+A(IE+I)
      A3=A(IB+I)-A(IE+I)
      A2=A(IC+I)+A(ID+I)
      A4=A(IC+I)-A(ID+I)
      A5=Z*(A(IA+I)-0.25*(A1+A2))
      A6=ZQRT5*(A1-A2)
      C(JA+J)=Z*(A(IA+I)+(A1+A2))
      C(JB+J)=A5+A6
      C(JC+J)=A5-A6
      D(JB+J)=-ZSIN72*A3-ZSIN36*A4
      D(JC+J)=-ZSIN36*A3+ZSIN72*A4
      I=I+INC3
      J=J+INC4
  592 CONTINUE
      IBASE=IBASE+INC1
      JBASE=JBASE+INC2
  594 CONTINUE
      GO TO 900
C
C     CODING FOR FACTOR 6
C     -------------------
  600 CONTINUE
      IA=1
      IB=IA+IINK
      IC=IB+IINK
      ID=IC+IINK
      IE=ID+IINK
      IF=IE+IINK
      JA=1
      JB=JA+(2*M-LA)*INC2
      JC=JB+2*M*INC2
      JD=JC+2*M*INC2
      JE=JC
      JF=JB
C
      IF (LA.EQ.M) GO TO 690
C
      DO 620 L=1,LA
      I=IBASE
      J=JBASE
CDIR$ IVDEP
      DO 610 IJK=1,LOT
      A11=(A(IC+I)+A(IF+I))+(A(IB+I)+A(IE+I))
      C(JA+J)=(A(IA+I)+A(ID+I))+A11
      C(JC+J)=(A(IA+I)+A(ID+I)-0.5*A11)
      D(JC+J)=SIN60*((A(IC+I)+A(IF+I))-(A(IB+I)+A(IE+I)))
      A11=(A(IC+I)-A(IF+I))+(A(IE+I)-A(IB+I))
      C(JB+J)=(A(IA+I)-A(ID+I))-0.5*A11
      D(JB+J)=SIN60*((A(IE+I)-A(IB+I))-(A(IC+I)-A(IF+I)))
      C(JD+J)=(A(IA+I)-A(ID+I))+A11
      I=I+INC3
      J=J+INC4
  610 CONTINUE
      IBASE=IBASE+INC1
      JBASE=JBASE+INC2
  620 CONTINUE
      JA=JA+JINK
      JINK=2*JINK
      JB=JB+JINK
      JC=JC+JINK
      JD=JD-JINK
      JE=JE-JINK
      JF=JF-JINK
      IBASE=IBASE+IJUMP
      IJUMP=2*IJUMP+IINK
      IF (JC.EQ.JD) GO TO 660
      DO 650 K=LA,KSTOP,LA
      KB=K+K
      KC=KB+KB
      KD=KC+KB
      KE=KD+KB
      KF=KE+KB
      C1=TRIGS(KB+1)
      S1=TRIGS(KB+2)
      C2=TRIGS(KC+1)
      S2=TRIGS(KC+2)
      C3=TRIGS(KD+1)
      S3=TRIGS(KD+2)
      C4=TRIGS(KE+1)
      S4=TRIGS(KE+2)
      C5=TRIGS(KF+1)
      S5=TRIGS(KF+2)
      JBASE=0
      DO 640 L=1,LA
      I=IBASE
      J=JBASE
CDIR$ IVDEP
      DO 630 IJK=1,LOT
      A1=C1*A(IB+I)+S1*B(IB+I)
      B1=C1*B(IB+I)-S1*A(IB+I)
      A2=C2*A(IC+I)+S2*B(IC+I)
      B2=C2*B(IC+I)-S2*A(IC+I)
      A3=C3*A(ID+I)+S3*B(ID+I)
      B3=C3*B(ID+I)-S3*A(ID+I)
      A4=C4*A(IE+I)+S4*B(IE+I)
      B4=C4*B(IE+I)-S4*A(IE+I)
      A5=C5*A(IF+I)+S5*B(IF+I)
      B5=C5*B(IF+I)-S5*A(IF+I)
      A11=(A2+A5)+(A1+A4)
      A20=(A(IA+I)+A3)-0.5*A11
      A21=SIN60*((A2+A5)-(A1+A4))
      B11=(B2+B5)+(B1+B4)
      B20=(B(IA+I)+B3)-0.5*B11
      B21=SIN60*((B2+B5)-(B1+B4))
      C(JA+J)=(A(IA+I)+A3)+A11
      D(JA+J)=(B(IA+I)+B3)+B11
      C(JC+J)=A20-B21
      D(JC+J)=A21+B20
      C(JE+J)=A20+B21
      D(JE+J)=A21-B20
      A11=(A2-A5)+(A4-A1)
      A20=(A(IA+I)-A3)-0.5*A11
      A21=SIN60*((A4-A1)-(A2-A5))
      B11=(B5-B2)-(B4-B1)
      B20=(B3-B(IA+I))-0.5*B11
      B21=SIN60*((B5-B2)+(B4-B1))
      C(JB+J)=A20-B21
      D(JB+J)=A21-B20
      C(JD+J)=A11+(A(IA+I)-A3)
      D(JD+J)=B11+(B3-B(IA+I))
      C(JF+J)=A20+B21
      D(JF+J)=A21+B20
      I=I+INC3
      J=J+INC4
  630 CONTINUE
      IBASE=IBASE+INC1
      JBASE=JBASE+INC2
  640 CONTINUE
      IBASE=IBASE+IJUMP
      JA=JA+JINK
      JB=JB+JINK
      JC=JC+JINK
      JD=JD-JINK
      JE=JE-JINK
      JF=JF-JINK
  650 CONTINUE
      IF (JC.GT.JD) GO TO 900
  660 CONTINUE
      JBASE=0
      DO 680 L=1,LA
      I=IBASE
      J=JBASE
CDIR$ IVDEP
      DO 670 IJK=1,LOT
      C(JA+J)=(A(IA+I)+0.5*(A(IC+I)-A(IE+I)))+ SIN60*(A(IB+I)-A(IF+I))
      D(JA+J)=-(A(ID+I)+0.5*(A(IB+I)+A(IF+I)))-SIN60*(A(IC+I)+A(IE+I))
      C(JB+J)=A(IA+I)-(A(IC+I)-A(IE+I))
      D(JB+J)=A(ID+I)-(A(IB+I)+A(IF+I))
      C(JC+J)=(A(IA+I)+0.5*(A(IC+I)-A(IE+I)))-SIN60*(A(IB+I)-A(IF+I))
      D(JC+J)=-(A(ID+I)+0.5*(A(IB+I)+A(IF+I)))+SIN60*(A(IC+I)+A(IE+I))
      I=I+INC3
      J=J+INC4
  670 CONTINUE
      IBASE=IBASE+INC1
      JBASE=JBASE+INC2
  680 CONTINUE
      GO TO 900
C
  690 CONTINUE
      Z=1.0/FLOAT(N)
      ZSIN60=Z*SIN60
      DO 694 L=1,LA
      I=IBASE
      J=JBASE
CDIR$ IVDEP
      DO 692 IJK=1,LOT
      A11=(A(IC+I)+A(IF+I))+(A(IB+I)+A(IE+I))
      C(JA+J)=Z*((A(IA+I)+A(ID+I))+A11)
      C(JC+J)=Z*((A(IA+I)+A(ID+I))-0.5*A11)
      D(JC+J)=ZSIN60*((A(IC+I)+A(IF+I))-(A(IB+I)+A(IE+I)))
      A11=(A(IC+I)-A(IF+I))+(A(IE+I)-A(IB+I))
      C(JB+J)=Z*((A(IA+I)-A(ID+I))-0.5*A11)
      D(JB+J)=ZSIN60*((A(IE+I)-A(IB+I))-(A(IC+I)-A(IF+I)))
      C(JD+J)=Z*((A(IA+I)-A(ID+I))+A11)
      I=I+INC3
      J=J+INC4
  692 CONTINUE
      IBASE=IBASE+INC1
      JBASE=JBASE+INC2
  694 CONTINUE
      GO TO 900
C
C     CODING FOR FACTOR 8
C     -------------------
  800 CONTINUE
      IBAD=3
      IF (LA.NE.M) GO TO 910
      IA=1
      IB=IA+IINK
      IC=IB+IINK
      ID=IC+IINK
      IE=ID+IINK
      IF=IE+IINK
      IG=IF+IINK
      IH=IG+IINK
      JA=1
      JB=JA+LA*INC2
      JC=JB+2*M*INC2
      JD=JC+2*M*INC2
      JE=JD+2*M*INC2
      Z=1.0/FLOAT(N)
      ZSIN45=Z*SQRT(0.5)
C
      DO 820 L=1,LA
      I=IBASE
      J=JBASE
CDIR$ IVDEP
      DO 810 IJK=1,LOT
      C(JA+J)=Z*(((A(IA+I)+A(IE+I))+(A(IC+I)+A(IG+I)))+
     *    ((A(ID+I)+A(IH+I))+(A(IB+I)+A(IF+I))))
      C(JE+J)=Z*(((A(IA+I)+A(IE+I))+(A(IC+I)+A(IG+I)))-
     *    ((A(ID+I)+A(IH+I))+(A(IB+I)+A(IF+I))))
      C(JC+J)=Z*((A(IA+I)+A(IE+I))-(A(IC+I)+A(IG+I)))
      D(JC+J)=Z*((A(ID+I)+A(IH+I))-(A(IB+I)+A(IF+I)))
      C(JB+J)=Z*(A(IA+I)-A(IE+I))
     *    +ZSIN45*((A(IH+I)-A(ID+I))-(A(IF+I)-A(IB+I)))
      C(JD+J)=Z*(A(IA+I)-A(IE+I))
     *    -ZSIN45*((A(IH+I)-A(ID+I))-(A(IF+I)-A(IB+I)))
      D(JB+J)=ZSIN45*((A(IH+I)-A(ID+I))+(A(IF+I)-A(IB+I)))
     *    +Z*(A(IG+I)-A(IC+I))
      D(JD+J)=ZSIN45*((A(IH+I)-A(ID+I))+(A(IF+I)-A(IB+I)))
     *    -Z*(A(IG+I)-A(IC+I))
      I=I+INC3
      J=J+INC4
  810 CONTINUE
      IBASE=IBASE+INC1
      JBASE=JBASE+INC2
  820 CONTINUE
C
C     RETURN
C     ------
  900 CONTINUE
      IBAD=0
  910 CONTINUE
      IERR=IBAD
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities
C granted to it by virtue of its status as an intergovernmental organisation
C nor does it submit to any jurisdiction.
C

      INTEGER FUNCTION HSP2GG2(KTRUNC,NS,EW,KGAUSS,KPTS,PLATS,KSIZE)
C
C---->
C**** HSP2GG2
C
C     Purpose
C     -------
C     This routine finds a suitable Gaussian grid and spectral
C     truncation for given North-South/East-West increments.
C
C
C     Interface
C     ---------
C     IRET = HSP2GG2(KTRUNC,NS,EW,KGAUSS,KPTS,PLATS,KSIZE)
C
C
C     Input parameters
C     ----------------
C     NS     - North-South increment
C     EW     - East-West increment
C
C
C     Output parameters
C     -----------------
C     KTRUNC - spectral truncation
C     KGAUSS - Gaussian grid number
C     HTYPE  - Gaussian grid type
C              = 'R' for reduced ("quasi-regular"),
C              = 'O' for reduced/octahedral,
C              = 'F' for full,
C              = 'U' for a user-defined Gaussian grid
C     KPTS   - array giving number of points along each line of latitude
C              in the reduced Gaussian grid (both hemispheres)
C     PLATS  - array giving Gaussian latitudes (both hemispheres)
C     KSIZE  - number of points in the reduced Gaussian grid
C
C     Returns 0 if all OK, otherwise there is an error.
C
C
C     Externals
C     ---------
C     HSH2GG - Finds a suitable Gaussian grid and/or spectral truncation
C     for a given spectral truncation and/or lat/long increments.
C
C----<
      IMPLICIT NONE

!#include "parim.h"
!#include "jparams.h"

C     Arguments
      INTEGER KTRUNC, KGAUSS, KPTS(*), KSIZE
      REAL NS, EW, PLATS(*)

C     Externals
      INTEGER HSH2GG

C     Local variables
      CHARACTER*1 HTYPE

      KTRUNC = 0   ! output
      KGAUSS = 0   ! output
      HTYPE  = ''  ! output
      HSP2GG2 = HSH2GG(NS,EW,KTRUNC,KGAUSS,HTYPE,KPTS,PLATS,KSIZE)
      END

C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE CREXEX(KBUFL,YBUFF,KSUP,KSEC0,KSEC1,KSEC3,
     2                  KELEM,CNAMES,CUNITS,KVALS,VALUES,CVALS,KERR)
C
C**** *CREXEX*
C
C
C     PURPOSE.
C     --------
C          Decode Crex message into fully expanded form; returning
C          information relevant for all CREX sections, expanded values,
C          their names and units.
C
C
C**   INTERFACE.
C     ----------
C
C          *CALL* *CREXEX(KBUFL,YBUFF,KSUP,KSEC0,KSEC1,KSEC3,
C     1                   KELEM,CNAMES,CUNITS,KVALS,VALUES,CVALS,KERR)*
C
C        INPUT :
C               *KBUFL*   -  Length of CREX message (words)
C               *YBUFF*   -  Character string  containing Crex message
C               *KELEM*   -  Integer (expected number of expanded elements)
C               *KVALS*   -  Integer (expected number of data values)
C        OUTPUT:
C               *KSUP*    -  Integer array of 9 words containing
C                            suplementary information
C                         -  KSUP( 1) -- IDIM1, dimension of KSEC1
C                         -  KSUP( 2) -- Reserved
C                         -  KSUP( 3) -- IDIM3, dimension of KSEC3
C                         -  KSUP( 4) -- Reserved
C                         -  KSUP( 5) -- M (number of elements in values
C                                           array, first index)
C                         -  KSUP( 6) -- N (number of subsets,second index
C                                           of values array)
C                         -  KSUP( 7) -- JVC (number of elements in CVAL array)
C                         -  KSUP( 8) -- total CREX message length in bytes
C                         -  KSUP( 9) -- IDIM0, dimension of KSEC0
C
C               *KSEC0*   -  Integer array of 3 words containing
C                            CREX section 0 information
C                            KSEC0( 1)-- length of section 0 (bytes)
C                            KSEC0( 2)-- total length of CREX message (bytes)
C                            KSEC0( 3)-- CREX Edition number
C
C               *KSEC1*   -  Integer array of at least 40 words
C                            containing CREX section 1 information
C                            KSEC1( 1)-- Reserved
C                            KSEC1( 2)-- CREX Edition number
C                            KSEC1( 3)-- Reserved
C                            KSEC1( 4)-- Reserved
C                            KSEC1( 5)-- Reserved
C                            KSEC1( 6)-- CREX message type
C                            KSEC1( 7)-- Reserved
C                            KSEC1( 8)-- version number of local table used
C                            KSEC1( 9)-- Reserved
C                            KSEC1(10)-- Reserved
C                            KSEC1(11)-- Reserved
C                            KSEC1(12)-- Reserved
C                            KSEC1(13)-- Reserved
C                            KSEC1(14)-- CREX Master table
C                            KSEC1(15)-- version number of Master table used
C                            KSEC1(16) - KSEC1(40) -- Reserved
C
C                            Crex Edition 2
C
C               *KSEC1*   -  Integer array of at least 40 words
C                            containing CREX section 1 information
C                            KSEC1( 1)-- Reserved
C                            KSEC1( 2)-- CREX Edition number
C                            KSEC1( 3)-- Originating Centre ( oooo)
C                            KSEC1( 4)-- Update sequence number (uu)
C                            KSEC1( 5)-- Number of subsets (sss)
C                            KSEC1( 6)-- CREX data category (nnn)
C                            KSEC1( 7)-- International data sub-category (mmm)
C                            KSEC1( 8)-- version number of local table used
C                            KSEC1( 9)-- Year (yyyy)
C                            KSEC1(10)-- Month (mm)
C                            KSEC1(11)-- Day (dd)
C                            KSEC1(12)-- Hour (hh)
C                            KSEC1(13)-- Minute (mm)
C                            KSEC1(14)-- CREX Master table (tt)
C                            KSEC1(15)-- version number of Master table used (vv)
C                            KSEC1(16)-- Originating sub-centre (ppp)
C                            KSEC1(17)-- Bufr master table version number
C                            KSEC1(18)-- Bufr version number of local table used
C                            KSEC1(19) - KSEC1(40) -- Reserved
C
C
C               *KSEC3*   -  Integer array of 4 words containing
C
C                            KSEC3( 1)-- Reserved
C                            KSEC3( 2)-- Reserved
C                            KSEC3( 3)-- number of subsets
C                            KSEC3( 4)-- Reserved
C
C
C               *CNAMES*  -  Character*64  array of KELEM containing
C                            CREX Table B element names
C               *CUNITS*  -  Character*24 array of KELEM containig
C                            CREX Table B units
C               *VALUES*  -  Real*8 array of KVALS containing expanded
C                            data values
C               *CVALS*   -  Character*80 array of KVALS containing
C                            CREX code table or CCITTIA5 CREX elements
C                            entries
C               *KERR*    -  returned error code
C
C
C     METHOD.
C     -------
C
C          Crex message passed as argument to this routine is decoded
C          section by section. Suplementary information and expanded data
C          are returned as well as error code.
C
C
C     EXTERNALS.
C     ----------
C
C
C     REFERENCE.
C     ----------
C
C          NONE.
C
C     AUTHOR.
C     -------
C
C          MILAN DRAGOSAVAC    *ECMWF*       07/01/2004.
C
C
C     MODIFICATIONS.
C     --------------
C
C          NONE.
C
C
      IMPLICIT LOGICAL(L,O,G), CHARACTER*8(C,H,Y)
C
C
      PARAMETER(JSUP =   9,JSEC0=   3,JSEC1= 40,JSEC2= 64 ,JSEC3=    4,
     1          JSEC4=   2,JELEM=40000,JSUBS=400,JCVAL=150 ,JBUFL=40000,
     2          JBPW =  32,JTAB =3000,JCTAB=120,JCTST=1800,JCTEXT= 200,
     3          JWORK=360000,JKEY=46)
C
C
      DIMENSION KSUP(JSUP),KSEC0(JSEC0),KSEC1(JSEC1)
      DIMENSION KSEC3(JSEC3)
C
      COMMON /CREXOFF/ NSIZEG(JELEM),NCREXWTRG(JWORK),
     1                 NBP,NSUBSET,OMULTI
C
      REAL*8 VALUES(KVALS)
C
      CHARACTER*64 CNAMES(KELEM)
      CHARACTER*24 CUNITS(KELEM)
      CHARACTER*80 CVALS(KVALS)
C
      CHARACTER*(*) YBUFF
C
      CHARACTER*4 CECMWF
C
C     ------------------------------------------------------------------
C
C*          1.   SET CONSTANTS.
C                --------------
 100  CONTINUE
C
      KERR=0
C
      M0=1
C
      DO 101 I=1,JSEC0
      KSEC0(I)=0
 101  CONTINUE
C
      DO 102 I=1,JSEC1
      KSEC1(I)=0
 102  CONTINUE
C
      DO 103 I=1,JSEC3
      KSEC3(I)=0
 103  CONTINUE
C
      DO 104 I=1,JSUP
      KSUP(I)=0
 104  CONTINUE
C
C
      CALL CREXINIT(KBUFL,KERR)
C
C     -----------------------------------------------------------------
C*          2.  EXPAND SECTION 0.
C               -----------------
 200  CONTINUE
C
      CALL CREXS0( KBUFL,YBUFF,KSUP,KSEC0,KERR )
      IF(KERR.GT.0) RETURN
C
C     ------------------------------------------------------------------
C*          3.   EXPAND SECTION 1. 
C                ------------------
 300  CONTINUE
C
      CALL CREXS1( KBUFL,YBUFF,KSUP,KSEC0,KSEC1,KERR )
      IF(KERR.GT.0) RETURN
C
C     ------------------------------------------------------------------
C*          4.   LOAD CREX TABLES.
C                -----------------
 400  CONTINUE
C
      CALL CREXTB(KSEC1,KERR)
      IF(KERR.GT.0) RETURN
C
C     ------------------------------------------------------------------
C*          5.  EXPAND SECTION 2.
C               -----------------
 500  CONTINUE
C
      OMULTI=.TRUE.
      NSUBSET=0
C
      DO WHILE(OMULTI)
C
      NSUBSET=NSUBSET+1
C
      CALL CREXS2(KBUFL,YBUFF,KSUP,KSEC3,KELEM,CNAMES,CUNITS,KERR)
      IF(KERR.GT.0) RETURN
C
C     ------------------------------------------------------------------
C
      CALL CREXS2DATA(KBUFL ,YBUFF ,KSUP  ,KSEC3,
     1            KELEM ,CNAMES,CUNITS,KVALS,VALUES,CVALS,KERR)
      IF(KERR.GT.0) RETURN
C
      END DO
C
C     ------------------------------------------------------------------
C*          6.   EXPAND SECTION 3.
C                -----------------
 600  CONTINUE
C
      CALL CREXS5(KBUFL,YBUFF,KERR)
      IF(KERR.GT.0) RETURN
C
C     -----------------------------------------------------------------
      RETURN
C
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE GRPRS0(KSEC0)
C
C---->
C**** GRPRS0 - Print information from Section 0 of GRIB code.
C
C     Purpose.
C     --------
C
C     Print the information in the Indicator
C     Section (Section 0) of decoded GRIB data.
C
C**   Interface.
C     ----------
C
C     CALL GRPRS0(KSEC0)
C
C
C     Input Parameters.
C     -----------------
C
C     KSEC0 - Array of decoded parameters from Section 0.
C
C     Output Parameters.
C     ------------------
C
C     None.
C
C     Method.
C     -------
C
C     Fields are printed as integers.
C
C     Externals.
C     ----------
C
C     Common block GRPRSCM.
C
C     Reference.
C     ----------
C
C     WMO Manual on Codes re GRIB Code.
C     See also routine GRIBEX.
C
C     Comments.
C     ---------
C
C     Checks environment variable GRPRS_STREAM for output stream number
C     for printing (default is 6)
C
C     Author.
C     -------
C
C     J. Hennessy    ECMWF 18.06.91
C
C     Modifications.
C     --------------
C
C     J. Hennessy    ECMWF 30.08.91
C     Changes to some comments only.
C
C     J.D.Chambers   ECMWF    June 2002
C     Add option to set output stream number using environment variable
C     GRPRS_STREAM
C
C     -----------------------------------------------------------------|
C----<
C
C     -----------------------------------------------------------------|
C*    Section 0. Definition of variables
C     -----------------------------------------------------------------|
C
      IMPLICIT NONE
C
#include "common/grprs.h"
C
      INTEGER KSEC0(*)
C
C     -----------------------------------------------------------------|
C*    Section 1 . Print required information.
C     -----------------------------------------------------------------|
C
  100 CONTINUE
C
      WRITE(GRPRSM,9000)
      WRITE(GRPRSM,9001)
      WRITE(GRPRSM,9002)
      WRITE(GRPRSM,9003) KSEC0(1)
      WRITE(GRPRSM,9004) KSEC0(2)
C
C     -----------------------------------------------------------------|
C*    Section 9 . Format statements. Return to calling routine.
C     -----------------------------------------------------------------|
C
  900 CONTINUE
C
 9000 FORMAT(1H )
 9001 FORMAT(1H ,'Section 0 - Indicator Section.       ')
 9002 FORMAT(1H ,'-------------------------------------')
 9003 FORMAT(1H ,'Length of GRIB message (octets).     ',I9)
 9004 FORMAT(1H ,'GRIB Edition Number.                 ',I9)
C
      RETURN
C
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      INTEGER FUNCTION C2PACK ( KDATA,  KLENP,  KSEC4,  KGRIB,  KLENG,
     X                          KNSPT,  KBITS,  KLEN,   KREFGR, KLENGR,
     X                          KBITGR, KWORK,  KLWORK, KPOWER, KMXPWR,
     X                          KNBIFO, ODEBUG )
C
C---->
C**** C2PACK
C
C     Purpose.
C     --------
C
C     Packs end of GRIB section 4 (except final padding)
C     for second-order packing methods, and computes some descriptors.
C
C
C**   Interface.
C     ----------
C
C     KRET = C2PACK ( KDATA,  KLENP,  KSEC4,  KGRIB,  KLENG,  KNSPT,
C    X                KBITS,  KLEN,   KREFGR, KLENGR, KBITGR, KWORK,
C    X                KLWORK, KPOWER, KMXPWR, KNBIFO, ODEBUG )
C
C
C     Input Parameters.
C     ----------------
C
C     KDATA      - Array of normalized values.
C     KLENP      - Length of array KDATA.
C     KSEC4      - Array of GRIB section 4 integer descriptors.
C     KLENG      - Length of GRIB product array.
C     KNSPT      - Bit pointer for next value in GRIB product.
C     KBITS      - Number of bits per computer word.
C     KLEN       - Exact number of grid-points to handle.
C     KREFGR     - Work array, first-order values for each group.
C     KLENGR     - Work array, effective length of each group.
C     KBITGR     - Work array, bit number ("width") of each group.
C     KLWORK     - Length of work arrays.
C     KPOWER     - Auxilary array, containing precomputed powers of 2-1.
C     KMXPWR     - Maximum number of bits per original scaled value.
C     KNBIFO     - Number of BIts for coding First-Order values.
C     ODEBUG     - True for some debug printout.
C
C
C     Output Parameters.
C     -----------------
C
C     KDATA      - Used as work array for second-order values,
C                  and secondary bit-map (if any).
C     KSEC4      - Array of GRIB section 4 integer descriptors
C                  (completed).
C     KGRIB      - Array containing GRIB product.
C     KNSPT      - Bit pointer for next value in GRIB product (updated).
C     KREFGR     - Work array, re-used for variable width methods.
C     KBITGR     - Work array, re-used for variable width methods.
C     KWORK      - Work array, used for variable width methods.
C
C
C     Method.
C     -------
C
C     Follows WMO Manual of Codes.
C
C     Externals.
C     ----------
C
C     C2PKVW    - Packs 2nd-order values for variable width methods.
C     INXBIT    - Insert bits into GRIB product.
C     PRTBIN    - Transform integer value in printable "binary" format.
C     CSGNBT    - Codes an integer value and its sign bit.
C
C
C     Reference.
C     ----------
C
C     None.
C
C
C     Comments.
C     --------
C
C     On entry, KNSPT points to the first bit of section 4 
C               in the GRIB product.
C     On exit,  KNSPT points to the first unused bit of section 4,
C               (or to the first bit of section 5, if unused bit count
C                is zero) in the GRIB product.
C
C     KDATA is overwritten. This is coherent with GRIBEX coding.
C
C         Detailed use of KSEC4 as input/output argument
C         ----------------------------------------------
C
C     KSEC4(4) set to 64 to indicate complex packing.
C     KSEC4(6)  "   " 16  "    "     presence of extended flags.
C
C     KSEC4(9) used to know secondary bit-map use (0=no,32=yes).
C     KSEC4(10)  "   "   "  constant/variable width (0=constant,16=var).
C     KSEC4(11)  "   "   "  for width value, if constant.
C     KSEC4(11) used to know width of spatial differencing descriptors.
C     KSEC4(11) set to width of lengths for general extended method,
C               for consistency with D2ORDR routine.
C     KSEC4(12) used to know general extended packing (0=no,8=yes).
C     KSEC4(13)   "   "   "  boustrophedonic ordering (0=no,4=yes).
C     KSEC4(14) (0 or 2) and KSEC4(15) (0 or 1) used to know spatial
C               differencing through their sum (0=no,1/2/3=order used).
C     KSEC4(16) used to know bias for spatial differencing.
C     KSEC4(17)   "   "   "  width of lengths for general extended
C                            method.
C     KSEC4(16) set to pointer to first-order values.
C     KSEC4(17)  "   "    "    "  2nd-order     "   .
C     KSEC4(18) set to number of first-order values.
C     KSEC4(19)  "   "    "   "  2nd-order     "   .
C     KSEC4(20) used to know width of groups.
C
C
C     Author.
C     -------
C
C     J. Clochard, Meteo France, for ECMWF - January 1998.
C
C
C     Modifications.
C     _____________
C
C     J. Clochard, April 1998.
C     Update comments.
C     Introduce spatial differencing.
C
C     J. Clochard, September 1998.
C     Optimisation of bit-string encoding for variable width methods,
C     through routine C2PKVW.
C     Suppress dummy-argument KSEC1, and add KWORK/KPOWER/KMXPWR 
C     in calling syntax.
C
C
C----<
C     -----------------------------------------------------------------
C*    Section 0. Definition of variables.
C     -----------------------------------------------------------------
C
      IMPLICIT NONE
C
#include "common/grprs.h"
C
C     Parameters
C
      INTEGER JP16SET
C
      PARAMETER ( JP16SET= 2**16-1 )
C                            `---> 65535    =   FFFF(hex)
C
C     Subroutine arguments
C
      INTEGER KLENP, KLENG, KNSPT, KBITS, KLEN, KLWORK, KNBIFO, KMXPWR
      INTEGER KDATA (KLENP), KSEC4 (*), KGRIB (KLENG)
      INTEGER KREFGR (KLWORK), KLENGR (KLWORK), KBITGR (KLWORK)
      INTEGER KWORK (KLWORK), KPOWER (0:KMXPWR)
C
      LOGICAL ODEBUG
C
C     Local variables.
C
      INTEGER ICOUNT, ILDSTA, IZERO, JGROUP, ILNGTH, IFILL, INSPTB
      INTEGER IRET, J, ILVARB, IBITGW, IREFER, IFLAGX, INSPTA
      INTEGER IPTRFO, IPTRSO, IFIROV, ISECOV, IRETFN, IAUXIL
#ifndef wmogrp2o
      INTEGER IEXTRA
#endif
      INTEGER IBITGS, IPTRGS, IORDER, IWIDSD, IBIAS, ILVARX
C
      INTEGER IWORK (3)
C
      INTEGER C2PKVW
      EXTERNAL C2PKVW
C
      CHARACTER YOPER*1
C
      LOGICAL LROW, LCTWID, LSECBI, LVECTP
      LOGICAL LGENXT
C
C     -----------------------------------------------------------------
C*    Section 1 . Initialisations.
C     -----------------------------------------------------------------
C
  100 CONTINUE
      ILVARX = 0
C
#ifndef ebug2o
      IF (ODEBUG) THEN
#endif
        WRITE(GRPRSM,FMT=9100) KNSPT
#ifndef ebug2o
      ENDIF
#endif
C
      IRETFN = 0
      IZERO=0
      ILDSTA=21
      INSPTA=KNSPT
      YOPER='C'
      LSECBI=KSEC4(9).NE.0
#if (defined CRAY) || (defined FUJITSU)
      LVECTP=.TRUE.
#else
      LVECTP=.FALSE.
#endif
      LROW=.NOT.LSECBI.AND.KSEC4(12).EQ.0
      LGENXT=.NOT.LSECBI.AND.KSEC4(12).NE.0
      IORDER=KSEC4(14)+KSEC4(15)
      LCTWID=KSEC4(10).EQ.0
      IFIROV=KSEC4(18)
      IBITGW=KSEC4(20)
C
C     Enforce right values for flags, for further use by GRIBEX.
C
      KSEC4(4)=64
      KSEC4(6)=16
C
C     Compute length of "variable-length" descriptors.
C
      IF (LROW) THEN
        ILVARB=8*((8+IFIROV*IBITGW-1)/8)
      ELSEIF (LCTWID) THEN
        ILVARB=8+KLEN
      ELSEIF (LGENXT) THEN
        IBITGS=KSEC4(17)
C
        IF (IORDER.EQ.0) THEN
          ILVARX=4
        ELSE
          IWIDSD=KSEC4(11)
          IBIAS=KSEC4(16)
          ILVARX=5+(8+IWIDSD*(IORDER+1)-1)/8
        ENDIF
C
        ILVARB=8*(ILVARX+(8+IFIROV*IBITGW-1)/8)+IFIROV*IBITGS
C
C       IBITGS stored back in KSEC4(11), for consistency with D2ORDR.
C
        KSEC4(11)=IBITGS
      ELSE
        ILVARB=8*((8+IFIROV*IBITGW-1)/8)+KLEN
      ENDIF
C
C     -----------------------------------------------------------------
C*    Section 2 . Coding of fixed-length descriptors.
C     -----------------------------------------------------------------
C
  200 CONTINUE
C
C     The first 10 octets have already been coded in GRIBEX, or will
C     be in a further step of GRIBEX:
C     Length of section, flags+unused bit count, binary scale factor,
C     reference value.
C
C*    Octet 11 : Number of bits containing each first-order value.
C     One 8 bit field.
C
      KNSPT=KNSPT+10*8
      CALL INXBIT(KGRIB,KLENG,KNSPT,KNBIFO,1,KBITS, 8,YOPER,IRET)
C
      IF (IRET.NE.0) THEN
        IRETFN = 20210
        WRITE(GRPRSM,FMT=9001) 'bit number of first-order values'
        GO TO 900
      ENDIF
C
C     Octets 12 - 13: Octet number of the start of first-order packed 
C                     data.
C     One 16-bit field.
C
      IPTRFO=1+ILDSTA+(8+ILVARB-1)/8
      KSEC4(16)=IPTRFO
      CALL INXBIT(KGRIB,KLENG,KNSPT,KSEC4(16),1,KBITS,16,YOPER,IRET)
C
      IF (IRET.NE.0) THEN
        IRETFN = 20220
        WRITE(GRPRSM,FMT=9001) 'pointer to first-order packed data'
        GO TO 900
      ENDIF
C
C     Octet 14: Extended flags.
C     One 8-bit field.
C
      IFLAGX=KSEC4(9)+KSEC4(10)+KSEC4(12)+KSEC4(13)+KSEC4(14)+KSEC4(15)
      CALL INXBIT(KGRIB,KLENG,KNSPT,IFLAGX,1,KBITS, 8,YOPER,IRET)
C
      IF (IRET.NE.0) THEN
        IRETFN = 20230
        WRITE(GRPRSM,FMT=9001) 'extended flags'
        GO TO 900
      ENDIF
C
C     Octets 15 - 20: Octet number of the start of second-order packed 
C                     data, Number of first-order packed data,
C                     Number of second-order packed data.
C     Three 16-bit fields.
C
      IPTRSO=IPTRFO+(8+IFIROV*KNBIFO-1)/8
      ISECOV=KLEN-IORDER
C
      KSEC4(17)=IPTRSO
      KSEC4(18)=IFIROV
      KSEC4(19)=ISECOV
      CALL INXBIT(KGRIB,KLENG,KNSPT,KSEC4(17),3,KBITS,16,YOPER,IRET)
C
      IF (IRET.NE.0) THEN
        IRETFN = 20240
        WRITE(GRPRSM,FMT=9001) 'standard second-order descriptors'
        GO TO 900
      ENDIF
C
#ifndef wmogrp2o
C     Octet 21: Reserved by WMO, so should be zero in standard case.
C               Could be used for extra bits of group number.
C     One 8-bit field.
C
      IEXTRA=IFIROV/(JP16SET+1)
C
      IF (IEXTRA.NE.0) THEN
        CALL PRTBIN (IEXTRA,8,IAUXIL,IRET)
C
        IF (IRET.NE.0) THEN
          IAUXIL=IEXTRA
        ENDIF
C
        WRITE(GRPRSM,FMT=9255) IFIROV, JP16SET, IEXTRA, IAUXIL
      ENDIF
C
      CALL INXBIT(KGRIB,KLENG,KNSPT,IEXTRA,1,KBITS, 8,YOPER,IRET)
#else
C     Octet 21: Reserved by WMO. Set to zero.
C     One 8-bit field.
C
      CALL INXBIT(KGRIB,KLENG,KNSPT,IZERO,1,KBITS, 8,YOPER,IRET)
#endif
C
      IF (IRET.NE.0) THEN
        IRETFN = 20250
        WRITE(GRPRSM,FMT=9001) 'reserved octet (section 4, 21st)'
        GO TO 900
      ENDIF
C
C     -----------------------------------------------------------------
C*    Section 3. Coding of variable-length descriptors.
C     -----------------------------------------------------------------
C
  300 CONTINUE
C
#ifndef ebug2o
      IF (ODEBUG) THEN
#endif
        CALL PRTBIN (IFLAGX,8,IAUXIL,IRET)
C
        IF (IRET.NE.0) THEN
          IAUXIL=IFLAGX
        ENDIF
C
        WRITE(GRPRSM,FMT=9300) KNBIFO, IAUXIL, IFIROV, ISECOV, IPTRFO,
     X                          IPTRSO
        WRITE(GRPRSM,FMT=9310) 'fixed', KNSPT
#ifndef ebug2o
      ENDIF
C
#endif
C
      IF (LCTWID) THEN
C
C     Octet 22: Common width of groups.
C     One 8-bit field.
C
        CALL INXBIT(KGRIB,KLENG,KNSPT,KSEC4(11),1,KBITS,8,YOPER,IRET)
C
      ELSEIF (LGENXT) THEN
C
C     Octets 22 - 23: Width of widths, Width of lengths.
C     Two 8-bit fields.
C
        IWORK(1)=IBITGW
        IWORK(2)=IBITGS
        CALL INXBIT(KGRIB,KLENG,KNSPT,IWORK,2,KBITS,8,YOPER,IRET)
C
        IF (IRET.NE.0) THEN
          IRETFN = 20310
          WRITE(GRPRSM,FMT=9001)
     X            'Extended descriptors, 1st-order values'
          GO TO 900
        ENDIF
C
C     Octets 24-25: Octet number of the start of group sizes (lengths).
C     One 16-bit field.
C
        IPTRGS = 1 + ILDSTA + ILVARX + (8+IFIROV*IBITGW-1)/8
#ifdef ebug2o
        PRINT *,'c2pack - IBITGW =',IBITGW,', IBITGS =',IBITGS,
     X          ', IPTRGS =',IPTRGS
#endif
        CALL INXBIT(KGRIB,KLENG,KNSPT,IPTRGS,1,KBITS,16,YOPER,IRET)
C
        IF (IRET.NE.0) THEN
          IRETFN = 20315
          WRITE(GRPRSM,FMT=9001) 'General extended group size pointer'
          GO TO 900
        ELSEIF (IORDER.NE.0) THEN
C
C     Octet 26: Width of spatial differencing specific descriptors.
C     One 8-bit field.
C
          CALL INXBIT(KGRIB,KLENG,KNSPT,IWIDSD,1,KBITS,8,YOPER,IRET)
C
          IF (IRET.NE.0) THEN
            IRETFN = 20316
            WRITE(GRPRSM,FMT=9001)
     X           'Width of spatial differencing descriptors'
            GO TO 900
          ELSEIF (IWIDSD.NE.0) THEN
C
C     Octet 27-onwards: first IORDER original values and diff. bias.
C     (IORDER+1) fields of IWIDSD bits.
C
C              Temporarily use KDATA(IORDER+1) for bias and its sign.
C
            IAUXIL=IORDER+1
            IFILL=KDATA(IAUXIL)
            CALL CSGNBT(KDATA(IAUXIL),IBIAS,IWIDSD,IRET)
C
            IF (IRET.NE.0) THEN
              IRETFN = 20317
              WRITE(GRPRSM,FMT=9317) IRET
              GO TO 900
            ENDIF
C
            CALL INXBIT(KGRIB,KLENG,KNSPT,KDATA,IAUXIL,KBITS,IWIDSD,
     X                  YOPER,IRET)
C
            KDATA(IAUXIL)=IFILL
C
            IF (IRET.NE.0) THEN
              IRETFN = 20318
              WRITE(GRPRSM,FMT=9001)
     X           'First field value(s) (spatial differencing case)'
              GO TO 900
            ELSEIF (MOD (KNSPT,8).NE.0) THEN
C
C     Fill up with binary zeros till next octet boundary.
C
              IFILL=8*((8+KNSPT-1)/8)-KNSPT
              CALL INXBIT(KGRIB,KLENG,KNSPT,IZERO,1,KBITS,IFILL,
     X                    YOPER,IRET)
C
              IF (IRET.NE.0) THEN
                IRETFN = 20319
                WRITE(GRPRSM,FMT=9001)
     X             'padding after spatial differencing descriptors'
                GO TO 900
              ENDIF
C
            ENDIF
C
          ENDIF
C
        ENDIF
C
C     Octets XX - XX+(IPTRGS-1): Group widths.
C     IFIROV fields of IBITGW bits.
C
        CALL INXBIT(KGRIB,KLENG,KNSPT,KBITGR,IFIROV,KBITS,IBITGW,
     X              YOPER,IRET)
      ELSE
C
C     Octets 22 - 21+IFIROV: Group widths.
C     IFIROV fields of IBITGW bits.
C
        CALL INXBIT(KGRIB,KLENG,KNSPT,KBITGR,IFIROV,KBITS,IBITGW,
     X              YOPER,IRET)
      ENDIF
C
      IF (IRET.NE.0) THEN
        IRETFN = 20320
        WRITE(GRPRSM,FMT=9001) 'inserting group width(s)'
        GO TO 900
      ELSEIF (MOD (KNSPT,8).NE.0) THEN
C
C     Fill up with binary zeros till next octet boundary.
C
        IFILL=8*((8+KNSPT-1)/8)-KNSPT
        CALL INXBIT(KGRIB,KLENG,KNSPT,IZERO,1,KBITS,IFILL,YOPER,IRET)
C
        IF (IRET.NE.0) THEN
          IRETFN = 20330
          WRITE(GRPRSM,FMT=9001) 'padding after group width(s)'
          GO TO 900
        ENDIF
C
      ENDIF
C
      IF (LSECBI) THEN
C
C     Secondary bit-map will be inserted later, after second-order
C     values processing, to use KDATA as work array. Retain pointer.
C
        INSPTB=KNSPT
        KNSPT=KNSPT+KLEN
C
        IF (MOD (KNSPT,8).NE.0) THEN
C
C     Fill up with binary zeros till next octet boundary.
C
          IFILL=8*((8+KNSPT-1)/8)-KNSPT
          CALL INXBIT(KGRIB,KLENG,KNSPT,IZERO,1,KBITS,IFILL,YOPER,IRET)
C
          IF (IRET.NE.0) THEN
            IRETFN = 20340
            WRITE(GRPRSM,FMT=9001) 'padding after secondary bit-map'
            GO TO 900
          ENDIF
C
        ENDIF
C
      ELSEIF (LGENXT) THEN
C
C     Octets IPTRGS - (IPTRFO-1): General extended group sizes(lengths).
C     IFIROV fields of IBITGS bits.
C
        CALL INXBIT(KGRIB,KLENG,KNSPT,KLENGR,IFIROV,KBITS,IBITGS,
     X              YOPER,IRET)
C
        IF (IRET.NE.0) THEN
          IRETFN = 20350
          WRITE(GRPRSM,FMT=9001) 'General extended group sizes'
          GO TO 900
        ELSEIF (MOD (KNSPT,8).NE.0) THEN
C
C     Fill up with binary zeros till next octet boundary.
C
          IFILL=8*((8+KNSPT-1)/8)-KNSPT
          CALL INXBIT(KGRIB,KLENG,KNSPT,IZERO,1,KBITS,IFILL,YOPER,IRET)
C
          IF (IRET.NE.0) THEN
            IRETFN = 20360
            WRITE(GRPRSM,FMT=9001)
     X            'padding after General extended group sizes'
            GO TO 900
          ENDIF
C
        ENDIF
C
      ENDIF
C
      IF (KNBIFO.NE.0) THEN
C
C     Octets IPTRFO - (IPTRSO-1): First-order values (reference values
C                                                    of groups).
C     IFIROV fields of KNBIFO bits.
C
        CALL INXBIT(KGRIB,KLENG,KNSPT,KREFGR,IFIROV,KBITS,KNBIFO,
     X              YOPER,IRET)
C
        IF (IRET.NE.0) THEN
          IRETFN = 20370
          WRITE(GRPRSM,FMT=9001)
     X         'first-order values (reference values of groups)'
          GO TO 900
        ELSEIF (MOD (KNSPT,8).NE.0) THEN
C
C     Fill up with binary zeros till next octet boundary.
C
          IFILL=8*((8+KNSPT-1)/8)-KNSPT
          CALL INXBIT(KGRIB,KLENG,KNSPT,IZERO,1,KBITS,IFILL,YOPER,IRET)
C
          IF (IRET.NE.0) THEN
            IRETFN = 20380
            WRITE(GRPRSM,FMT=9001) 'padding after first-order values'
     S//' of groups.'
            GO TO 900
          ENDIF
C
        ENDIF
C
      ENDIF
C
C     -----------------------------------------------------------------
C*    Section 4. Coding of data (second-order values).
C     -----------------------------------------------------------------
C
  400 CONTINUE
C
C     Octets IPTRSO - onwards: Second-order values (deviations from
C                                                  groups references).
#ifndef ebug2o
      IF (ODEBUG) THEN
#endif
        WRITE(GRPRSM,FMT=9310) 'variable', KNSPT
#ifndef ebug2o
      ENDIF
C
#endif
      ICOUNT=IORDER
C
      IF (LCTWID) THEN
C
C                      Constant width packing.
C
        IF (KSEC4(11).NE.0) THEN
C
          DO 412 JGROUP=1,IFIROV
C
          ILNGTH=KLENGR(JGROUP)
          IREFER=KREFGR(JGROUP)
C
          DO 411 J=1,ILNGTH
          KDATA(ICOUNT+J)=KDATA(ICOUNT+J)-IREFER
  411     CONTINUE
C
          ICOUNT=ICOUNT+ILNGTH
C
  412     CONTINUE
C
C       Effective coding of second-order values, once for all groups.
C
          CALL INXBIT(KGRIB,KLENG,KNSPT,KDATA,KLEN,KBITS,
     X                KSEC4(11),YOPER,IRET)
C
          IF (IRET.NE.0) THEN
            IRETFN = 20410
            WRITE(GRPRSM,FMT=9001)
     X   'second-order values (deviations from 1st-order values)'
            GO TO 900
          ENDIF
C
        ELSE
          ICOUNT=KLEN
        ENDIF
C
      ELSE
C
C             Packing method(s) with variable width.
C
        IRETFN = C2PKVW ( KDATA,  KLENP,  KGRIB,  KLENG,  KNSPT,
     X                    KBITS,  KLEN,   KREFGR, KLENGR, KBITGR,
     X                    KWORK,  KLWORK, IFIROV, ICOUNT, KPOWER,
     X                    KMXPWR, LROW,   LVECTP, ODEBUG )
C
        IF (IRETFN.NE.0) THEN
          GOTO 900
        ENDIF
C
      ENDIF
C
      IF (ICOUNT.NE.KLEN) THEN
        IRETFN = 20420
        WRITE(GRPRSM,FMT=9420) ICOUNT, KLEN
        GO TO 900
      ENDIF      
C
C     KNSPT pointer is intentionally left as is:
C     GRIBEX will use its value back to compute unused bit count...
C     ...no adjustment to nearest octet boundary here, then.
C
C     -----------------------------------------------------------------
C*    Section 5. Compute and code secondary bit-map, if any.
C     -----------------------------------------------------------------
C
  500 CONTINUE
C
      IF (LSECBI) THEN
C
#ifndef ebug2o
        IF (ODEBUG) THEN
#endif
          WRITE(GRPRSM,FMT=9510) 'Coding secondary bit-map', INSPTB
#ifndef ebug2o
        ENDIF
C
#endif
C
        DO 511 J=1,KLEN
        KDATA(J)=0
  511   CONTINUE
C
        ICOUNT=0
C
        DO 512 JGROUP=1,IFIROV
C
        ILNGTH=KLENGR(JGROUP)
        KDATA(ICOUNT+1)=1
        ICOUNT=ICOUNT+ILNGTH
C
  512   CONTINUE        
C
C       Effective coding of secondary bit-map, once for all groups.
C
        CALL INXBIT(KGRIB,KLENG,INSPTB,KDATA,KLEN,KBITS,
     X              1,YOPER,IRET)
C
        IF (IRET.NE.0) THEN
          IRETFN = 20510
          WRITE(GRPRSM,FMT=9001) 'secondary bit-map'
          GO TO 900
#ifdef ebug2o
        ELSE
#else
        ELSEIF (ODEBUG) THEN
#endif
          WRITE(GRPRSM,FMT=9510) 'Secondary bit-map encoded', INSPTB
        ENDIF
C
      ENDIF
C
C     -----------------------------------------------------------------
C*    Section 9. Return to calling routine.
C     -----------------------------------------------------------------
C
  900 CONTINUE
C
      C2PACK = IRETFN
#ifndef ebug2o
C
      IF (ODEBUG) THEN
#endif
        WRITE(GRPRSM,FMT=9900) IRETFN, KNSPT
#ifndef ebug2o
      ENDIF
#endif
C
      RETURN
C
 9001 FORMAT (' C2PACK: Problem inserting ',A,'.')
C
 9100 FORMAT (' C2PACK: Function start, KNSPT =',I10,'.')
#ifndef wmogrp2o
C
 9255 FORMAT (' C2PACK: Group number',I8,' exceeds',I6,'.',/,TR10,
     X        'extra bits stored in 21st octet of section 4 (',I3,
     X        '=>',I8.8,').')
#endif
C
 9300 FORMAT (' C2PACK: KNBIFO =',I3,', IFLAGX =',I9.8,
     X        ', IFIROV =',I8,', ISECOV =',I8,'.',/,
     X        ' C2PACK: IPTRFO =',I8,', IPTRSO =',I8,'.')
 9310 FORMAT (' C2PACK: KNSPT after "',A,'-length" descriptors =',
     X        I10,'.')
 9317 FORMAT (
     X' C2PACK: Bias sign management problem, CSGNBT return is',I5,'.')
C
 9420 FORMAT (' C2PACK: Mismatch: sum of group lengths =',I8,
     X        ', expected = ',I8,'.')
C
 9510 FORMAT (' C2PACK: ',A,', bit pointer =',I10,'.')
C
 9900 FORMAT (' C2PACK: Function return code =',I6,', KNSPT =',I10,'.')
C
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities
C granted to it by virtue of its status as an intergovernmental organisation
C nor does it submit to any jurisdiction.
C


      SUBROUTINE DECOGB (FPDATA,ILENF,IBITS,NBIT,IB1PAR,
     C              IB2PAR,FVERT,ILENV,IGRIB,ILENG,IWORD,
     C              JLENV,JLENF,IERR)
C
C---->
C**** DECOGB - Interface using GRIBEX to decode GRIB format data.
C
C     Purpose.
C     --------
C
C           Provides a compatible interface between the old (DECOGB)
C           and new (GRIBEX) GRIB decoding software.
C
C           GRIB Code Edition Number 0 has been in use at ECMWF since
C           the end of 1985. GRIB Code Edition Number 1 came into use
C           with the introduction of the T213 model, which uses a
C           quasi-regular Gaussian grid for surface fields.
C
C           This interface decodes GRIB Code Edition Number 1 in
C           Edition 0 format and converts the quasi-regular Gaussian
C           grid to a regular grid. When this conversion is done, no
C           West/East increment is included in IB2PAR(9). The increment
C           must be calculated ie ZEWINC = 360.0 / IB2PAR(2). For
C           Gaussian N160 data the increment is .5625 and this
C           cannot be accurately represented in the required units
C           of millidegrees for IB2PAR(9).
C
C**   Interface.
C     ---------
C
C           CALL DECOGB (FPDATA,ILENF,IBITS,NBIT,IB1PAR,
C    C              IB2PAR,FVERT,ILENV,IGRIB,ILENG,IWORD,
C    C              JLENV,JLENF,IERR)
C
C               Input Parameters.
C               -----------------
C
C                 NBIT    - Number of bits in computer word
C
C                 IGRIB   - Integer array containing data in grib code.
C                 ILENG   - Length of array IGRIB.
C
C                 FVERT   - Real array to receive vertical coordinate
C                           parameters.
C                 ILENV   - Length of array FVERT.
C
C                 FPDATA  - Real array to receive decoded data values.
C                 ILENF   - Length of array FPDATA.
C
C                           !!!!!  If this is 1 only
C                           the product and grid definition sections
C                           are decoded. !!!!!
C
C                 IB1PAR  - Integer array (dimension 18) to receive
C                           product definition information.
C
C                 IB2PAR  - Integer array (dimension 11) to receive grid
C                           definition information.
C
C               Output Parameters.
C               -----------------
C
C                 Parameters from section 1 , product definition section
C                 ------------------------------------------------------
C
C                 IB1PAR  - Integer array (dimension 18) of product
C                           definition information.
C
C                 Word      Contents
C                 ----      --------
C                   1       Originating centre identifier.
C                   2       Model identification.
C                   3       Grid definition.
C                   4       Flag ( Code Table 1)
C                   5       Parameter identifier ( Code Table 2 ).
C                   6       Type of level (Code Table 3).
C                  7-8      Value(s) of levels (Code Table 3).
C                   9       Year of data
C                  10       Month of data
C                  11       Day of data
C                  12       Hour of data
C                  13       Minute of data
C                  14       Time unit (Code Table 4).
C                  15       Time range one
C                  16       Time range two
C                  17       Time range flag (Code Table 5).
C                  18       Number averaged.
C
C                           Value(s) of level can occupy 2 words.
C                           For a layer the first word defines the top
C                           and the second the bottom of the layer.
C                           For a single level, only the first word is
C                           used.
C
C                 Parameters from section 2 , grid definition section.
C                 -----------------------------------------------
C
C                 IB2PAR - Integer array (dimension 11) containing grid
C                          definition information.
C                          Use varies with data representation type.
C
C                 Word      Latitude/longitude grid
C                 ----      -----------------------
C                  1        Data representation type (Code Table 6).
C                  2        Number of points along a latitude
C                  3        Number of points along a meridian.
C                  4        Latitude of origin (South is negative).
C                  5        Longitude of origin (West is negative).
C                  6        Resolution flag. (Code Table 7)
C                  7        Latitude of extreme point (South negative).
C                  8        Longitude of extreme point (West negative).
C                  9        West/East increment
C                 10        North/South increment
C                 11        Scanning mode flags (Code Table 8)
C
C                 Word      Gaussian grid
C                 ----      -------------
C                 1-9       As for latitude/longitude grid.
C                 10        The number of latitude lines between a pole
C                           and the equator.
C                 11        Scanning mode flags (Code Table 8)
C
C                 Word      Spherical harmonics
C                 ----      -------------------
C                   1       Data representation type (Code Table 6)
C                   2       J - pentagonal resolution parameter
C                   3       K - pentagonal resolution parameter
C                   4       M - pentagonal resolution parameter
C                   5       Representation type (Code Table 9)
C                   6       Representation mode (Code Table 10)
C                 7-11      not used
C
C
C                 Use for other data representation types is
C
C                 FVERT  - Real array of vertical coordinate parameters
C                 JLENV  - Number of values in this array.
C
C                 Used for hybrid levels only.
C
C                 Parameters from section 3 , bit-map definition section
C                 --------------------------------------------------
C
C                 Not handled by this routine.
C
C                 Parameters from section 4 , binary data section.
C                 -------------------------------------------
C
C                 FPDATA  - Array of floating point values.
C                 JLENF   - Number of values in this array.
C                           JLENF is negative if missing data coded
C
C                 IBITS   - Number of bits for coded data values.
C
C                 IWORD   - Number of words decoded.
C
C                 IERR    - Error indicator.
C
C                           0, No error.
C
C                          -5, Bit-map not yet catered for.
C
C                          -6, Vertical coordinate parameter array
C                              too small.
C
C                              Other error codes as for GRIBEX.
C
C     Method.
C     -------
C
C           Subroutine GRIBEX, which can decode all editions of the
C           GRIB code, is called for the actual decoding. Sections
C           1 and 2 information is then put in Edition Number 0
C           format, and any quasi-regular Gaussian grid transformed
C           into a regular grid.
C
C     Externals.
C     ----------
C
C           GRIBEX
C           QU2REG
C
C     Reference.
C     ----------
C
C           WMO Manual on Codes for GRIB code definition.
C
C     Comments.
C     ---------
C
C           Parameter names do not conform to current programming
C           conventions, but are the same as in the old DECOGB routine.
C
C     Author.
C     -------
C
C           J. Hennessy     ECMWF     18.06.91
C
C     Modifications.
C     -------------
C
C           J. Hennessy     ECMWF     19.06.91
C           Fix to accommodate analysis section's incorrect
C           use of old DECOGB.
C
C           J. Hennessy     ECMWF     26.06.91
C           Check on size of vertical coordinate parameters array
C           added. T213 model has 12 extra levels.
C
C     -----------------------------------------------------------------
C----<
C
C
C
C
C
C
C
C
C
C
C*    Section 0. Definition of variables.
C     -----------------------------------------------------------------
C
      DIMENSION ISEC0(2)
      DIMENSION ISEC1(32)
      DIMENSION ISEC2(512)
      DIMENSION ISEC3(2)
      DIMENSION ISEC4(64)
C
      DIMENSION ZSEC2(128)
      DIMENSION ZSEC3(2)
C
      CHARACTER*1 YOPER
C
      DIMENSION FPDATA(*)
      DIMENSION FVERT(*)
      DIMENSION IGRIB(*)
      DIMENSION IB1PAR(18)
      DIMENSION IB2PAR(11)
C
C     -----------------------------------------------------------------
C
C
C
C
C
C
C
C
C
C
C
C
C*    Section 1. Decode data and convert to Edition 0 format.
C     -----------------------------------------------------------------
C
  100 CONTINUE
C
      IERR = 0
C
C     Decode sections 1 and 2 or all sections, as required.
C
      YOPER = 'Z'
C
C     Fix for incorrect usage of old DECOGB by analysis section, who
C     have always called DECOGB with ILENF equal to 0, when they
C     should have used 1. They got away with it with the old DECOGB
C     because sections 1 and 2 were decoded before the error in the
C     parameter was discovered, and they never checked the return code.
C
      IF (ILENF.EQ.0) ILENF = 1
C
      IF (ILENF.EQ.1) YOPER = 'I'
      IERX = 1
      CALL GRIBEX (ISEC0,ISEC1,ISEC2,ZSEC2,ISEC3,ZSEC3,ISEC4,
     C             FPDATA,ILENF,IGRIB,ILENG,IWORD,YOPER,IERX)
C
      IERR = IERX
C
C     Bit map not catered for by DECOGB arguments.
C
      IF (IERR.EQ.-5) WRITE (*,9001)
C
C     Error encountered.
C
      IF (IERR.GT.0) GO TO 900
C
C     Transfer information to DECOGB arguments.
C
      JLENF = ISEC4(1)
      IBITS = ISEC4(2)
      JLENV = ISEC2(12)
C
C     Section 1.
C
      DO 110 J110 = 1,18
         IB1PAR(J110) = ISEC1(J110+1)
  110 CONTINUE
C
C     Section 2.
C
      DO 111 J111 = 1,11
         IB2PAR(J111) = ISEC2(J111)
  111 CONTINUE
C
C     Go to section 9, if pseudo-GRIB data.
C
      IF (IB1PAR(5).EQ.127.OR.IB1PAR(5).EQ.128)
     C   THEN
             WRITE (*,9002) IB1PAR(5)
             GO TO 900
         ENDIF
C
C     Check size of vertical coordinate parameter array.
C
      IF (JLENV.GT.ILENV)
     C   THEN
             IERR = -6
             WRITE (*,9003) JLENV , ILENV
             GO TO 900
         ENDIF
C
C     Vertical coordinate parameters, if any,
C
      DO 112 J112 = 1,JLENV
         FVERT(J112) = ZSEC2(J112+10)
  112 CONTINUE
C
C     Go to section 9, if decoding of sections 1 and 2 only.
C
      IF (YOPER.EQ.'I')
     C   THEN
             IF (ISEC2(1).NE.4) GO TO 900
             IF (ISEC2(17).EQ.1) IB2PAR(2) = 4 * ISEC2(10)
             GO TO 900
         ENDIF
C
C     If quasi-regular Gaussian grid, convert to regular and
C     adjust section 1 and 2 information accordingly.
C
      IF (ISEC2(1).NE.4) GO TO 900
C
      IF (ISEC2(17).EQ.1)
     C   THEN
             INOLAT = ISEC2(10) * 2
             INOLNG = ISEC2(10) * 4
             CALL QU2REG (FPDATA,ISEC2(23),INOLAT,INOLNG,1)
             JLENF      = INOLAT * INOLNG
             IB2PAR(2)  = 4 * ISEC2(10)
         ENDIF
C
C     -----------------------------------------------------------------
C
C
C
C
C
C
C
C
C
C
C*    Section 9. Return to calling routine. Format statements.
C     -----------------------------------------------------------------

C
  900 CONTINUE
C
 9001 FORMAT (1H ,'DECOGB : Bit map not catered for.')
C
 9002 FORMAT (1H ,'DECOGB : Pseudo-GRIB field number ',I3)
C
 9003 FORMAT (1H ,'DECOGB : ',I3,' vertical coordinate parameters, ',
     C                      'but array size is only ',I3,'.')
C
      RETURN
C
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities
C granted to it by virtue of its status as an intergovernmental organisation
C nor does it submit to any jurisdiction.
C

      SUBROUTINE PTQUASI (KSEC2)
C
C---->
C**** PTQUASI
C
C     Purpose.
C     --------
C
C     Print the qusai-regular information in the Grid Description
C     Section (Section 2) of decoded GRIB data.
C
C**   Interface.
C     ----------
C
C     CALL PTQUASI (KSEC2)
C
C
C     Input Parameters.
C     -----------------
C
C     KSEC2 - Array of decoded integers from Section 2.
C
C
C     Output Parameters.
C     ------------------
C
C     None.
C
C
C     Method.
C     -------
C
C     See below.
C
C
C     Externals.
C     ----------
C
C     PRTBIN
C
C
C     Reference.
C     ----------
C
C     WMO Manual on Codes re GRIB Code.
C
C
C     Comments.
C     ---------
C
C     Only data representation types catered for are Gaussian
C     grid, latitude/longitude grid, Spherical Harmonics,
C     Polar stereographic and Space view perspective.
C
C
C     Author.
C     -------
C
C     J.D.Chambers   ECMWF 21.02.95
C
C
C     Modifications.
C     --------------
C
C     None.
C
C
C----<
C     -----------------------------------------------------------------
C*    Section 0. Definition of variables.
C     -----------------------------------------------------------------
C
      IMPLICIT NONE
C
#include "common/grprs.h"
C
C     Subroutine arguments
      INTEGER KSEC2
      DIMENSION KSEC2(*)
C
C     Local variables
      CHARACTER*12 YOUT
C
      INTEGER NEXTLAT, NREPEAT, LATCNT
      INTEGER J120
C
      LOGICAL NTOS
C
C     -----------------------------------------------------------------
C*    Section 1. Print quasi-grid data.
C     -----------------------------------------------------------------
C
  100 CONTINUE
C
C     See if scanning is north->south or south->north
C
      WRITE(GRPRSM,*) ' Number of points along a parallel varies.'
      NTOS = ( MOD(KSEC2(11),128) .LT. 64 )
      IF ( NTOS ) THEN
        WRITE(GRPRSM,*)
     X    ' Number of points.   Parallel. (North to South)'
      ELSE
        WRITE(GRPRSM,*)
     X    ' Number of points.   Parallel. (South to North)'
      ENDIF
C
C     Display number of points for each latitude
      LATCNT  = KSEC2(3)
      NEXTLAT = 0
      YOUT    = ' '
C
      DO 120 J120 = 1,LATCNT
        NEXTLAT = NEXTLAT + 1
        WRITE (YOUT(1:4),'(I4)') NEXTLAT
C
C       Finished?
        IF (NEXTLAT.GT.LATCNT) GO TO 900
        IF (NEXTLAT.EQ.LATCNT) THEN
          WRITE(GRPRSM,9005) KSEC2(NEXTLAT+22) , YOUT
          GO TO 900
        ENDIF
C
C       Look for neighbouring latitudes with same number of points
C
        NREPEAT = 0
  110   CONTINUE
C
C       If neighbouring latitudes have same number of points
C       increase the repeat count.
        IF (KSEC2(NEXTLAT+22+1).EQ.KSEC2(NEXTLAT+22)) THEN
          NREPEAT = NREPEAT + 1
          NEXTLAT = NEXTLAT + 1
          IF (NEXTLAT.LT.LATCNT) GO TO 110
        ENDIF
C
C       Display neighbouring latitudes with same number of points as
C       'nn to mm'.
        IF (NREPEAT.GE.1) THEN
          YOUT(5:) = ' to '
          WRITE (YOUT(9:12),'(I4)') NEXTLAT
        ENDIF
        WRITE(GRPRSM,9005) KSEC2(NEXTLAT+22) , YOUT
        YOUT = ' '
C
  120 CONTINUE
C
C     -----------------------------------------------------------------
C*    Section 9 . Format statements. Return to calling routine.
C     -----------------------------------------------------------------
C
  900 CONTINUE
C
      RETURN
C
 9005 FORMAT (1H , I5,16X,A12)
C
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE ECDEF2( HFUNC, KSEC1, KGRIB, KLENG, KNSPT, KBITS,
     X                   KPR, KRET)
C
C---->
C**** ECDEF2
C
C     Purpose.
C     --------
C
C     GRIB coding/decoding of ECMWF local use definition 2.
C     (Extensions for clusters).
C
C
C**   Interface.
C     ----------
C
C     CALL ECDEF2( HFUNC, KSEC1, KGRIB, KLENG, KNSPT, KBITS, KPR, KRET)
C
C
C     Input Parameters.
C     -----------------
C
C     HFUNC      - Requested function.
C                  'C' to code data.
C                  'D' to decode data.
C
C     KSEC1      - Array containing Grib Section 1 data.
C
C     KGRIB      - Array containing Grib coded data.
C
C     KLENG      - Length (words) of KGRIB.
C
C     KNSPT      - Bit number after which insertion/extraction starts.
C
C     KBITS      - Number of bits in computer word.
C
C
C     KPR        - Debug print switch.
C                  0  , No printout.
C                  >0 , Debug printout.
C
C     KRET       - Response to error indicator.
C                  0        , Abort if error encountered.
C                  Non-zero , Return to calling routine
C                             even if error encountered.
C
C     Output Parameters.
C     ------------------
C
C     KSEC1      - Array containing Grib Section 1 data.(Updated)
C
C     KGRIB      - Array containing Grib coded data.(Updated)
C
C     KNSPT      - Number of bit after last one inserted/extracted.(Updated)
C
C     KRET       - Return code.
C                  0   , No error encountered.
C                  2   , Error reported by routine INXBIT.
C
C     Method.
C     -------
C
C     Input data packed/unpacked in accordance with ECMWF usage of
C     local part of section 1 of Grib code, definition 2.
C
C
C     Externals.
C     ----------
C
C     INXBIT
C     ABORTX
C     CSGNBT
C     DSGNBT
C
C     Reference.
C     ----------
C
C     WMO Manual On Codes for Grib Code.
C
C
C     Comments.
C     ---------
C
C     Adapted from ECLOC1.F - simplified to handle just definition 2.
#include "ecdef2.h"
C
C
C     Author.
C     -------
C
C     J.D.Chambers     ECMWF      18th January 1995
C
C
C     Modifications.
C     --------------
C
C     None.
C
C
C----<
C     ------------------------------------------------------------------
C*    Section 0 . Definition of variables. Data statements.
C     ------------------------------------------------------------------
C
      IMPLICIT NONE
C
#include "common/grprs.h"
C
C     Parameters
      CHARACTER*1   HFUNC
      INTEGER KSEC1, KGRIB, KLENG, KNSPT, KBITS, KPR, KRET
      DIMENSION KGRIB(*)
      DIMENSION KSEC1(*)
C
C     Local variables
      INTEGER IRET, IZERO, INSPT
C
      INTEGER ILALO
      DIMENSION ILALO(8)
C
      LOGICAL LENCODE, LDECODE
C
C     ------------------------------------------------------------------
C*    Section 1 . Set initial values.
C     ------------------------------------------------------------------
C
  100 CONTINUE
C
      IRET = KRET
      LENCODE = ( HFUNC .EQ. 'C' )
      LDECODE = .NOT. LENCODE
C
C     ------------------------------------------------------------------
C*    Section 2 . Extensions for clusters (definition 2).
C     ------------------------------------------------------------------
C
  200 CONTINUE
C
      IF( KPR.GE.1 ) WRITE(GRPRSM,*) 'ECDEF2 : Section 2.'
C
C*    Octet 50 : Cluster number.
C     Octet 51 : Total number of clusters.
C     Two 8 bit fields.
C
C     Insert/extract fields.
C
      CALL INXBIT (KGRIB,KLENG,KNSPT,KSEC1(42),2,KBITS, 8,HFUNC,KRET)
      IF (KRET.NE.0) THEN
        KRET = 2
        WRITE(GRPRSM,9004)
        GO TO 900
      ENDIF
C
C*    Octet 52 : Reserved
C     Set to 0.
C
      IF ( LENCODE ) THEN
        IZERO = 0
        CALL INXBIT(KGRIB,KLENG,KNSPT, IZERO,1,KBITS,8,HFUNC,KRET)
        IF (KRET.NE.0) THEN
          KRET = 2
          WRITE(GRPRSM,9004)
        ENDIF
      ELSE
        KNSPT = KNSPT + 8
      ENDIF
C
C*    Octet 53 : Clustering method.
C     One 8 bit field.
C
C     Insert/extract field.
C
      CALL INXBIT (KGRIB,KLENG,KNSPT,KSEC1(44),1,KBITS, 8,HFUNC,KRET)
      IF (KRET.NE.0) THEN
        KRET = 2
        WRITE(GRPRSM,9004)
        GO TO 900
      ENDIF
C
C*    Octets 54-55 : Start timestep when clustering.
C     Octets 56-57 : End timestep when clustering.
C     Two 16 bit fields.
C
C     Insert/extract fields.
C
      CALL INXBIT (KGRIB,KLENG,KNSPT,KSEC1(45),2,KBITS, 16,HFUNC,KRET)
      IF (KRET.NE.0) THEN
        KRET = 2
        WRITE(GRPRSM,9004)
        GO TO 900
      ENDIF
C
C*    Octets 58-60 : Northern latitude of domain of clustering
C     Octets 61-63 : Western longitude of domain of clustering
C     Octets 64-66 : Southern latitude of domain of clustering
C     Octets 67-69 : Eastern longitude of domain of clustering
C     Four 24 bit fields.
C
C     When coding values, set sign bit to 1, if value is negative.
C
      IF ( LENCODE ) THEN
        CALL CSGNBT( ILALO(1), KSEC1(47), 24, KRET)
        CALL CSGNBT( ILALO(2), KSEC1(48), 24, KRET)
        CALL CSGNBT( ILALO(3), KSEC1(49), 24, KRET)
        CALL CSGNBT( ILALO(4), KSEC1(50), 24, KRET)
      ENDIF
C
C     Insert/extract fields.
C
      CALL INXBIT (KGRIB,KLENG,KNSPT,ILALO(1),4,KBITS, 24,HFUNC,KRET)
      IF (KRET.NE.0) THEN
        KRET = 2
        WRITE(GRPRSM,9004)
        GO TO 900
      ENDIF
C
C     When decoding values, if sign bit is 1, value is
C     negative.
C
      IF ( LDECODE ) THEN
        CALL DSGNBT( KSEC1(47), ILALO(1), 24, KRET)
        CALL DSGNBT( KSEC1(48), ILALO(2), 24, KRET)
        CALL DSGNBT( KSEC1(49), ILALO(3), 24, KRET)
        CALL DSGNBT( KSEC1(50), ILALO(4), 24, KRET)
      ENDIF
C
C*    Octet 70 : Number of cluster to which operational forecast
C                  belongs.
C     Octet 71 : Number of cluster to which control forecast
C                  belongs.
C     Octet 72 : Number of forecasts belonging to the cluster.
C     Three 8 bit fields.
C
C     Insert/extract fields.
C
      CALL INXBIT (KGRIB,KLENG,KNSPT,KSEC1(51),3,KBITS, 8,HFUNC,KRET)
      IF (KRET.NE.0) THEN
        KRET = 2
        WRITE(GRPRSM,9004)
        GO TO 900
      ENDIF
C
C*    The number of forecasts belonging to a cluster may vary,
C     but section 1 is kept a fixed length.
C
      INSPT = KNSPT + 2048
C
C*    Octets 73-328 : List of N ensemble forecast numbers.
C     KSEC1(53) 8 bit fields.
C
C     Insert/extract fields.
C
      CALL INXBIT (KGRIB,KLENG,KNSPT,KSEC1(54),KSEC1(53),KBITS, 
     X             8,HFUNC,KRET)
      IF (KRET.NE.0) THEN
        KRET = 2
        WRITE(GRPRSM,9004)
        GO TO 900
      ENDIF
C
      KNSPT = INSPT
C
      GOTO 900
C
C     ------------------------------------------------------------------
C*    Section 9 . Abort/return to calling routine. Format statements.
C     ------------------------------------------------------------------
C
  900 CONTINUE
C
      IF( KPR.GE.1 ) THEN
        WRITE(GRPRSM,*) 'ECDEF2 : Section 9.'
        WRITE(GRPRSM,*) '         Output values set -'
        WRITE(GRPRSM,9003) KNSPT
      ENDIF
C
C     Abort if requested to do so when an error has been encountered.
C
      IF (IRET.EQ.0.AND.KRET.NE.0) THEN
        CALL ABORTX ('ECDEF2')
      ELSE
        RETURN
      ENDIF
C
 9003 FORMAT (1H ,'         KNSPT  = ',I12)
C
 9004 FORMAT (' ECDEF2: Error reported by routine INXBIT.')
C
      END

      PROGRAM REPECK
C
C**** *REPACK*
C
C
C     PURPOSE.
C     --------
C         Change the date in the section 2
C
C
C**   INTERFACE.
C     ----------
C
C          NONE.
C
C     METHOD.
C     -------
C
C          NONE.
C
C
C     EXTERNALS.
C     ----------
C
C         CALL BUSEL
C         CALL BUFREX
C         CALL BUFREN
C         CALL BUPRS0
C         CALL BUPRS1
C         CALL BUPRS2
C         CALL BUPRS3
C         CALL BUPRT
C         CALL BUUKEY
C
C     REFERENCE.
C     ----------
C
C          NONE.
C
C     AUTHOR.
C     -------
C
C          M. DRAGOSAVAC    *ECMWF*       15/02/2007.
C
C
C     MODIFICATIONS.
C     --------------
C
C          NONE.
C
C
      IMPLICIT LOGICAL(L,O,G), CHARACTER*8(C,H,Y)
C
      PARAMETER(JSUP =   9,JSEC0=   3,JSEC1= 40,JSEC2=4096 ,JSEC3=   4,
     1       JSEC4=   2,JELEM=160000,JSUBS=400,JCVAL=150,JBUFL=512000,
#ifdef JBPW_64
     2          JBPW =  64,JTAB =3000,JCTAB=120,JCTST=1800,JCTEXT=1200,
#else
     2          JBPW =  32,JTAB =3000,JCTAB=120,JCTST=1800,JCTEXT=1200,
#endif
     3          JWORK=4096000,JKEY=46,JBYTE=512000)
C
      PARAMETER (KELEM=160000)
      PARAMETER (KVALS=4096000)
C 
      DIMENSION KBUFF(JBUFL)
      DIMENSION KBUFR(JBUFL)
      DIMENSION KSUP(JSUP)  ,KSEC0(JSEC0),KSEC1(JSEC1)
      DIMENSION KSEC2(JSEC2),KSEC3(JSEC3),KSEC4(JSEC4)
      DIMENSION KEY  (JKEY),KREQ(2)
C
      REAL*8  VALUES(KVALS), RQV(KELEM), RVIND, EPS
      DIMENSION KTDLST(kELEM),KTDEXP(kELEM),KRQ(KELEM)
      DIMENSION KDATA(200)
C
      CHARACTER*256 CF(100),COUT,CFIN
      CHARACTER*64 CNAMES(KELEM)
      CHARACTER*24 CUNITS(KELEM)
      CHARACTER*80 CVALS(KVALS)
      CHARACTER*80 YENC
      CHARACTER*256 CARG(10)
      CHARACTER*10 CDATE
C
cs      EXTERNAL GETARG
C                                                                       
C     ------------------------------------------------------------------
C*          1. INITIALIZE CONSTANTS AND VARIABLES.
C              -----------------------------------
 100  CONTINUE
C
C     MISSING VALUE INDICATOR
C 
      ITLEN=6400
      ITL=0
      JZ=0
      NW=0
      NBYTES=JBPW/8
      RVIND=1.7D38
      NVIND=2147483647
      IOBS=0
      KRQL=0
      NR=0
      KREQ(1)=0
      KREQ(2)=0
      DO 102 I=1,KELEM
      RQV(I)=RVIND
      KRQ(I)=NVIND
 102  CONTINUE
C
C     INPUT FILE NAMES
C
      NARG=IARGC()
      IF(NARG.LT.4) THEN
      PRINT*,'USAGE -- bufr_repack -i infile -o outfile'
         STOP
      END IF
      NFILE=NARG
C
      DO 104 J=1,NARG
      CALL GETARG(J,CARG(J))
 104  CONTINUE

      II=0
      IO=0
      DO 105 J=1,NARG
      IF(CARG(J).EQ.'-i') THEN
         IN=J
      ELSEIF(CARG(J).EQ.'-o') THEN
         IO=J
      END IF
 105  CONTINUE
      IF(IO.EQ.0.OR.IN.EQ.0) THEN
       PRINT*,'USAGE -- bufr_repack -i infile -o outfile'
         STOP
      END IF
C
      COUT=CARG(IO+1)
      CFIN=CARG(IN+1) 
C
      JJ=INDEX(COUT,' ')
C
      CALL PBOPEN(IUNIT1,COUT(1:JJ),'W',IRET)
      IF(IRET.EQ.-1) STOP 'OPEN FAILED ON BUFR.DAT'
      IF(IRET.EQ.-2) STOP 'INVALID FILE NAME'
      IF(IRET.EQ.-3) STOP 'INVALID OPEN MODE SPECIFIED'
C
      ILN=INDEX(CFIN,' ')
C
C*          1.2 OPEN FILE CONTAINING BUFR DATA.
C               -------------------------------
 120  CONTINUE
C
      IRET=0 
      CALL PBOPEN(IUNIT,CFIN(1:ILN),'R',IRET)
      IF(IRET.EQ.-1) STOP 'OPEN FAILED'
      IF(IRET.EQ.-2) STOP 'INVALID FILE NAME'
      IF(IRET.EQ.-3) STOP 'INVALID OPEN MODE SPECIFIED'
C
C     ----------------------------------------------------------------- 
C*          2. SET REQUEST FOR EXPANSION.
C              --------------------------
 200  CONTINUE
C
      OPRT=.FALSE.
      OENC=.TRUE.
      NCOM=1
      OCOMP=.FALSE.
      NR=0
      OSEC3=.FALSE.
C
C*          2.1 SET REQUEST FOR PARTIAL EXPANSION.
C               ----------------------------------
 210  CONTINUE
C
C     SET VARIABLE TO PACK BIG VALUES AS MISSING VALUE INDICATOR
C
      KPMISS=1
      KPRUS=0
      NOKEY=0
      CALL BUPRQ(KPMISS,KPRUS,NOKEY)
C
C     -----------------------------------------------------------------
C*          3.  READ BUFR MESSAGE.
C               ------------------
 300  CONTINUE
C
      IERR=0
      KBUFL=0
C
      IRET=0
      CALL PBBUFR(IUNIT,KBUFF,JBYTE,KBUFL,IRET) 
      IF(IRET.EQ.-1) THEN
          GO TO 900
      END IF
      IF(IRET.EQ.-2) STOP 'FILE HANDLING PROBLEM' 
      IF(IRET.EQ.-3) STOP 'ARRAY TOO SMALL FOR PRODUCT'
C
      N=N+1
      IKBUFL=KBUFL
      KBUFL=KBUFL/NBYTES+1
      IF(N.LT.NR) GO TO 300
C
C     -----------------------------------------------------------------
C*          4. EXPAND BUFR MESSAGE.
C              --------------------
 400  CONTINUE
C
      CALL BUS012(KBUFL,KBUFF,KSUP,KSEC0,KSEC1,KSEC2,KERR)
      IF(KERR.NE.0) THEN
         PRINT*,'ERROR IN BUS012: ',KERR
         PRINT*,' BUFR MESSAGE NUMBER ',N,' CORRUPTED.'
         KERR=0
         GO TO 300
      END IF
C
      IF(KSUP(6).GT.1) THEN
         KEL=JWORK/KSUP(6)
         if(kel.gt.kelem) kel=kelem
      ELSE
         KEL=KELEM
      END IF
C
      CALL BUFREX(KBUFL,KBUFF,KSUP,KSEC0 ,KSEC1,KSEC2 ,KSEC3 ,KSEC4,
     1            KEL,CNAMES,CUNITS,KVALS,VALUES,CVALS,IERR)
C
      IF(IERR.NE.0) THEN
         IF(IERR.EQ.45) GO TO 300
         CALL EXIT(2)
      END IF
      IOBS=IOBS+KSEC3(3)
C
      CALL BUSEL(KTDLEN,KTDLST,KTDEXL,KTDEXP,KERR)
      IF(KERR.NE.0) CALL EXIT(2)
C
C*          4.1 PRINT CONTENT OF EXPANDED DATA.
C               -------------------------------
 410  CONTINUE
C
      IF(.NOT.OPRT) GO TO 500
      IF(.NOT.OSEC3) GO TO 450
C
C*          4.2 PRINT SECTION ZERO OF BUFR MESSAGE.
C               -----------------------------------
 420  CONTINUE
C

      CALL BUPRS0(KSEC0)
C
C*          4.3 PRINT SECTION ONE OF BUFR MESSAGE.
C               -----------------------------------
 430  CONTINUE
C
      CALL BUPRS1(KSEC1)
C
C
C*          4.4 PRINT SECTION TWO OF BUFR MESSAGE.
C               -----------------------------------
 440  CONTINUE
C
C              AT ECMWF SECTION 2 CONTAINS RDB KEY.
C              SO UNPACK KEY
C
      CALL BUUKEY(KSEC1,KSEC2,KEY,KSUP,KERR)
C
C              PRINT KEY
C
      CALL BUPRS2(KSUP ,KEY)
C
C*          4.5 PRINT SECTION 3 OF BUFR MESSAGE.
C               -----------------------------------
 450  CONTINUE
C
C               FIRST GET DATA DESCRIPTORS
C
      CALL BUSEL(KTDLEN,KTDLST,KTDEXL,KTDEXP,KERR)
      IF(KERR.NE.0) CALL EXIT(2)
C
C               PRINT  CONTENT
C
      IF(OSEC3) THEN
         CALL BUPRS3(KSEC3,KTDLEN,KTDLST,KTDEXL,KTDEXP,KEL,CNAMES)
      END IF
C
C*         4.6 PRINT SECTION 4 (DATA).
C              -----------------------
 460  CONTINUE
C
C          IN THE CASE OF MANY SUBSETS DEFINE RANGE OF SUBSETS
C
      IF(.NOT.OO) THEN
      WRITE(*,'(A,$)') ' STARTING SUBSET TO BE PRINTED : '
      READ(*,'(BN,I4)')   IST
      WRITE(*,'(A,$)') ' ENDING SUBSET TO BE PRINTED : '
      READ(*,'(BN,I4)')   IEND
      OO=.FALSE.
      END IF
C
C              PRINT DATA
C
      ICODE=0
      CALL BUPRT(ICODE,IST,IEND,KEL,CNAMES,CUNITS,CVALS,
     1           KVALS,VALUES,KSUP,KSEC1,IERR)
C
C              RESOLVE BIT MAPS 
C
      IF(IEND.GT.KSEC3(3)) IEND=KSEC3(3)
C
C     DO 461 IK=IST,IEND
C 
C     CALL BUBOX(IK,KSUP,KEL,KTDEXP,CNAMES,CUNITS,KVALS,VALUES,
C    1           KBOX,KAPP,KLEN,KBOXR,VALS,CBOXN,CBOXU,IERR)
C
C     CALL BUPRTBOX(KBOX,KAPP,KLEN,KBOXR,VALS,CBOXN,CBOXU)
C
C461  CONTINUE
C
C     -----------------------------------------------------------------
C*          5. COLLECT DATA FOR REPACKING.
C              ---------------------------
 500  CONTINUE
C      
      IF(.NOT.OENC) GO TO 300
C
C               FIRST GET DATA DESCRIPTORS
C
      CALL BUSEL(KTDLEN,KTDLST,KTDEXL,KTDEXP,KERR)
      IF(KERR.NE.0) CALL EXIT(2)
C
C     -----------------------------------------------------------------
C*          6. PACK BUFR MESSAGE BACK INTO BUFR.
C              ---------------------------------
 600  CONTINUE
C
    
      KKK=0
      KBUFL=JBUFL
C
C     GET REPLICATION FACTORS
C
      KK=0
      DO 601 K=1,KSUP(5)
      IF(KTDEXP(K).EQ.31001.OR.KTDEXP(K).EQ.31002.OR.
     1   KTDEXP(K).EQ.31000) THEN
         KK=KK+1
         KDATA(KK)=NINT(VALUES(K))
      END IF
 601  CONTINUE
C
      KDLEN=2
      IF(KK.NE.0) KDLEN=KK
C
C     --------------------------------
C     |Modification to sections error|
C     --------------------------------
C
C     -----------------------------------------------------------------------
C
C*          6.2 ENCODE DATA INTO BUFR MESSAGE.
C               ------------------------------
 620  CONTINUE
C
      CALL BUUKEY(KSEC1,KSEC2,KEY,KSUP,KERR)
      IF(KERR.NE.0) THEN
         PRINT*,'BUUKEY: ERROR ',KERR
         CALL EXIT(2)
      END IF
C
      KEY(3)=205
      KSEC1(7)=205
C
C     PACK NEW RDB KEY
C
C
      CALL BUPKEY(KEY,KSEC1,KSEC2,KERR)
      IF(KERR.NE.0) CALL EXIT(2)
C
      KSEC3(4)=128
      IF(KSEC3(3).GT.1) KSEC3(4)=192
      CALL BUFREN( KSEC0,KSEC1,KSEC2,KSEC3,KSEC4,
     1             KTDLEN,KTDLST,KDLEN,KDATA,KEL,        !KSUP(5),
     2             KVALS,VALUES,CVALS,KBUFL,KBUFR,KERR)
C
      IF(KERR.GT.0) THEN
         PRINT*,'ERROR DURING ENCODING.'
         CALL EXIT(2)
      END IF
C
C           6.3 WRITE PACKED BUFR MESSAGE INTO FILE.
C               ------------------------------------
 630  CONTINUE
C
      IKBUFL=KBUFL*4
      CALL PBWRITE(IUNIT1,KBUFR,IKBUFL,IERR)
      IF(IERR.LT.0) THEN
         PRINT*,'ERROR WRITING INTO TARGET FILE.'
         CALL EXIT(2)
      END IF
C
      NW=NW+1
C
      GO TO 300
C     -----------------------------------------------------------------
C
 810  CONTINUE
C
      WRITE(*,'(1H ,A)') 'OPEN ERROR ON INPUT FILE'
      GO TO 900
C      
 800  CONTINUE
C
      IF(IRET.EQ.-1) THEN
         PRINT*,'NUMBER OF RECORDS PROCESSED ',N
         PRINT*,'NUMBER OF RECORDS CONVERTED ',NW
c
      ELSE
         PRINT*,' BUFR : ERROR= ',IERR
      END IF
C
 900  CONTINUE
C
      PRINT*,'NUMBER OF RECORDS PROCESSED ',N
      PRINT*,'NUMBER OF RECORDS CONVERTED ',NW
C
      CALL PBCLOSE(IUNIT,IRET)
C
      CALL PBCLOSE(IUNIT1,IRET)
C
      END

C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

        SUBROUTINE JUVPOLE(PSHUP, KTRUNC, PZFA, KLONO, KRET)
C
C---->
C**** JUVPOLE
C
C     Purpose
C     -------
C     This routine creates polar wind U or V components for lat/long
C     grid fields.
C
C
C     Interface
C     ---------
C     CALL JUVPOLE(PSHUP, KTRUNC, PZFA, KLONO, KRET)
C
C
C     Input parameters
C     ----------------
C     PSHUP   - Spherical harmonics field, unpacked
C     KTRUNC  - Truncation number of spherical harmonics field
C     KLONO   - Number of longitude points in output field
C
C
C     Output parameters
C     -----------------
C     PZFA - Output grid point field; contains upto 32 each of
C            North and South latitude rows symmetrically.
C     KRET - Return status code
C            0 = OK
C
C
C     Common block usage
C     ------------------
C     JDCNDBG
C
C
C     Method
C     ------
C     For each pole, creates the reduced gaussian grid lines nearest to
C     the pole and does a linear interpolation to the polar longitude.
C
C
C     Externals
C     ---------
C     JAGGGP  - converts spectral input to a gaussian grid
C     INTLOG  - Output log message
C     INTLOGR - Output log message (with real value)
C
C
C     Reference
C     ---------
C     None.
C
C     Comments
C     --------
C     None.
C
C
C     Author
C     ------
C     J.D.Chambers      ECMWF    October 2002
C
C
C     Modifications
C     -------------
C     None.
C
C
C----<
C     -----------------------------------------------------------------|
C
      IMPLICIT NONE
C
#include "jparams.h"
#include "parim.h"
#include "current.h"
#include "nofld.common"
#include "grfixed.h"
C
C     Subroutine arguments
C
      COMPLEX PSHUP(*)
      REAL PZFA(JPLONO + 2, 64)
      INTEGER KTRUNC, KLONO, KRET
C
C     Parameters
C
C     Local variables
C
      REAL EAST, WEST, LAT, POUTF(18), ALATS(320)
      REAL XLONG, WLEFT, XSTEP, GSTEP
      INTEGER KPTS(320), NUM, LOOP, NLEFT, NRIGHT
C
C     Externals
C
      INTEGER  IGGLAT
      EXTERNAL IGGLAT
C
C     -----------------------------------------------------------------|
C*    Section 1.  Initialization.
C     -----------------------------------------------------------------|
C
  100 CONTINUE
C
      KRET  = 0
C
      NUM = 160
      GSTEP = 360.0 / 18.0
      XSTEP = 360.0 / REAL(KLONO)
      EAST  = 360.0 - GSTEP
      WEST  = 0.0
C
C     -----------------------------------------------------------------|
C*    Section 2.  Create North pole values
C     -----------------------------------------------------------------|
C
  200 CONTINUE
C
C     Form the N160 reduced gaussian grid latitude near the North pole
C
      LAT = 90.0
      CALL JAGGGP( PSHUP, KTRUNC, LAT, LAT, WEST, EAST,
     X             NUM, 'R', KPTS, POUTF, 1, KRET)
      IF( KRET.NE.0 ) THEN
        CALL INTLOG(JP_ERROR,
     X    'JUVPOLE: problem forming Northern gaussian grid latitude',
     X    JPQUIET)
        GOTO 900
      ENDIF
C
C     Interpolate to the lat/long northern latitude grid points
C
      DO LOOP = 1, KLONO
C
C       Find the gaussian neighbours on either side of lat/long point
C       and their weights
C
        XLONG = XSTEP * REAL(LOOP-1)
C
        NLEFT  = 1 + INT(XLONG/GSTEP)
        NRIGHT = NLEFT + 1
        IF( NRIGHT.GT.18 ) NRIGHT = 1
C
        WLEFT = 1.0 - (ABS((XLONG - (NLEFT-1)*GSTEP))/GSTEP)
C
        PZFA(LOOP,1) = POUTF(NLEFT)*WLEFT + POUTF(NRIGHT)*(1.0-WLEFT)
      ENDDO
C
C     -----------------------------------------------------------------|
C*    Section 3.  Create South pole values
C     -----------------------------------------------------------------|
C
  300 CONTINUE
C
C     Store latitude and point count values for the next call to JAGGGP
C     which uses the 'U' option (user supplied values).
C
      NOGAUSO = NUM
C
      KRET  = IGGLAT(NUM*2, ALATS, 1, 1)
      IF( KRET.NE.0 ) THEN
        CALL INTLOG(JP_ERROR, 'JUVPOLE: IGGLAT call failed',KRET)
        KRET = KRET
        GOTO 900
      ENDIF
C
      DO LOOP = 1, NUM*2
        NOLPTS(LOOP)  = KPTS(LOOP)
        ROGAUSS(LOOP) = ALATS(LOOP)
      ENDDO
C
C     Form the N160 reduced gaussian grid latitude near the South pole
C
      LAT = -90.0
      CALL JAGGGP( PSHUP, KTRUNC, LAT, LAT, WEST, EAST,
     X             NUM, 'U', KPTS, POUTF, 1, KRET)
      IF( KRET.NE.0 ) THEN
        CALL INTLOG(JP_ERROR,
     X    'JUVPOLE: problem forming Southern gaussian grid latitude',
     X    JPQUIET)
        GOTO 900
      ENDIF
C
C     Interpolate to the lat/long southern latitude grid points
C
      DO LOOP = 1, KLONO
C
C       Find the gaussian neighbours on either side of lat/long point
C       and their weights
C
        XLONG = XSTEP * REAL(LOOP-1)
C
        NLEFT  = 1 + INT(XLONG/GSTEP)
        NRIGHT = NLEFT + 1
        IF( NRIGHT.GT.18 ) NRIGHT = 1
C
        WLEFT = 1.0 - (ABS((XLONG - (NLEFT-1)*GSTEP))/GSTEP)
C
        PZFA(LOOP,2) = POUTF(NLEFT)*WLEFT + POUTF(NRIGHT)*(1.0-WLEFT)
      ENDDO
C
C     -----------------------------------------------------------------|
C*    Section 9.  Return.
C     -----------------------------------------------------------------|
C
 900  CONTINUE
C
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities
C granted to it by virtue of its status as an intergovernmental organisation
C nor does it submit to any jurisdiction.
C

      SUBROUTINE NGINTRP(NEWFLD,NEXT,INROW,OLAT,OLON,NGAUSS,HTYPE,FIELD,
     X                   GLATS, NGPTS)
C
C---->
C**** NGINTRP
C
C     PURPOSE
C     _______
C
C     Finds values at the points of a row by interpolation within a
C     gaussian field.
C
C     INTERFACE
C     _________
C
C     CALL NGINTRP(NEWFLD,NEXT,INROW,OLAT,OLON,NGAUSS,HTYPE,FIELD)
C
C
C     Input parameters
C     ________________
C
C     NEWFLD  - The field of values being created
C     NEXT    - Start offset of the latitude row being created
C     INROW   - The number of points in the latitude row
C     OLAT    - Latitude of target point
C     OLON    - Longitude of target point
C     NGAUSS  - Gaussian grid number (original, unrotated)
C     HTYPE   - Gaussian grid type (original, unrotated)
C               = 'R' for reduced ("quasi-regular"),
C               = 'O' for reduced/octahedral,
C               = 'F' for full,
C               = 'U' for user-defined reduced gaussian grid
C     FIELD   - Original gaussian field
C     GLATS   - Gaussian latitudes for original field
C     NGPTS   - Number of points along original field latitudes
C
C
C     Output parameters
C     ________________
C
C     NEWFLD(NEXT) to NEWFLD(NEXT+INROW-1) contains the latitude row
C     values.
C
C
C     METHOD
C     ______
C
C     Uses distance weighted values of 4 neighbouring points unless
C     within small distance of one of the neighbours, in which case
C     the value at that point is used.
C
C
C     EXTERNALS
C     _________
C
C     JMKOFGG - Builds offsets to start of each latitude row in the
C               gaussian grid.
C     JNORSGG - Find nearest north/south latitude in the gaussian grid.
C     INTLOG  - Logs output messages
C
C
C     REFERENCE
C     _________
C
C     None.
C
C
C     COMMENTS
C     ________
C
C     Some loops have been split and simplified to help with
C     vectorisation on VPP.
C
C
C     AUTHOR
C     ______
C
C     J.D.Chambers      ECMWF       April 1996
C
C
C     MODIFICATIONS
C     _____________
C
C     None.
C
C----<
C     _______________________________________________________
C
C*    Section 0. Definition of variables.
C     _______________________________________________________
C
      IMPLICIT NONE
C
#include "parim.h"
C
C     Parameters
C
      INTEGER JPFACTR, JPMAXGG
      PARAMETER( JPFACTR = 10000 )
      PARAMETER( JPMAXGG = 1280 )
      REAL JPEPS
      PARAMETER( JPEPS = 1E-2)
C
C     Function arguments
C
      REAL NEWFLD, OLAT, OLON, FIELD
      DIMENSION NEWFLD(*), OLAT(*), OLON(*), FIELD(*)
      INTEGER NEXT, INROW, NGAUSS
      CHARACTER*1 HTYPE
C
C     Local variables
C
      INTEGER LOOP, IVALUE
      INTEGER NORTH, SOUTH, IWESTN, IWESTS, IEASTN, IEASTS
      REAL NSTEP, SSTEP, PEAST
      DIMENSION NORTH(JPMAXGG), SOUTH(JPMAXGG)
      DIMENSION IWESTN(JPMAXGG), IWESTS(JPMAXGG)
      DIMENSION IEASTN(JPMAXGG), IEASTS(JPMAXGG)
      DIMENSION NSTEP(JPMAXGG), SSTEP(JPMAXGG)
      REAL DNORTH, DSOUTH, DWESTN, DWESTS, DEASTN, DEASTS
      DIMENSION DNORTH(JPMAXGG), DSOUTH(JPMAXGG)
      DIMENSION DWESTN(JPMAXGG), DWESTS(JPMAXGG)
      DIMENSION DEASTN(JPMAXGG), DEASTS(JPMAXGG)
      REAL GLATS(*)
      INTEGER NGPTS(*)
      INTEGER KOFSET(JPMAXGG/2)
      INTEGER OLDGAUS
      DATA OLDGAUS/0/
      CHARACTER*1 OLDTYPE
      DATA OLDTYPE/' '/
      SAVE OLDGAUS, OLDTYPE, KOFSET
C
C     Externals
C
      INTEGER JNORSGG
      EXTERNAL JNORSGG
C
C     Statement function
C
      INTEGER X, Y
      REAL OFIELD
      OFIELD(X,Y) = FIELD(KOFSET(X)+Y)
C
C     _______________________________________________________
C
C*    Section 1. Initialization.
C     _______________________________________________________
C
  100 CONTINUE
C
C     Get gaussian grid definition (first time only)
C
      IF ( (OLDGAUS.NE.NGAUSS).OR.(OLDTYPE.NE.HTYPE) ) THEN
C
        CALL INTLOG(JP_DEBUG,
     X    'NGINTRP: Get gaussian grid type:',JPQUIET)
        CALL INTLOG(JP_DEBUG,HTYPE,JPQUIET)
        CALL INTLOG(JP_DEBUG, 'NGINTRP: grid number:',NGAUSS)
C
C       Build array of offsets in field to start of each latitude line
C
        CALL INTLOG(JP_DEBUG,'NGINTRP: Build row offsets',JPQUIET)
        IF( HTYPE.EQ.'R' .OR. HTYPE.EQ.'r' .OR.
     X      HTYPE.EQ.'O' .OR. HTYPE.EQ.'o' .OR.
     X      HTYPE.EQ.'U' .OR. HTYPE.EQ.'u' ) THEN
C         (this value will not be used by JMKOFGG)
          PEAST = 360.
        ELSE
          PEAST = 360. - (90./NGAUSS)
        ENDIF
        CALL JMKOFGG(HTYPE,1,NGAUSS*2,0.0,PEAST,NGAUSS,NGPTS,KOFSET)
        OLDGAUS = NGAUSS
        OLDTYPE = HTYPE
      ENDIF
C
C     _______________________________________________________
C
C*    Section 2. Find latitudes of grid lines to north and south of
C                the points and calculate grid interval along lines.
C     _______________________________________________________
C
  200 CONTINUE
C
      DO LOOP = 1, INROW
        NORTH(LOOP) = JNORSGG( OLAT(LOOP), GLATS, NGAUSS, 1)
      ENDDO
C
      DO LOOP = 1, INROW
        SOUTH(LOOP) = MIN( NORTH(LOOP)+1, NGAUSS*2)
        DNORTH(LOOP) = ABS(GLATS(NORTH(LOOP)) - OLAT(LOOP))
      ENDDO
C
      DO LOOP = 1, INROW
        DSOUTH(LOOP) = 1.0 - DNORTH(LOOP)
        NSTEP(LOOP) = 360.0/FLOAT(NGPTS(NORTH(LOOP)))
        SSTEP(LOOP) = 360.0/FLOAT(NGPTS(SOUTH(LOOP)))
      ENDDO
C
C     _______________________________________________________
C
C*    Section 3. Find neighbouring points.
C     _______________________________________________________
C
  300 CONTINUE
C
      DO LOOP = 1, INROW
C
C       Calculate normalised distance west and east to neighbouring
C       points on lines to north and south of the point
C
        IWESTN(LOOP) = INT(OLON(LOOP)/NSTEP(LOOP))
        IWESTS(LOOP) = INT(OLON(LOOP)/SSTEP(LOOP))
        IEASTN(LOOP) = IWESTN(LOOP) + 1
        IEASTS(LOOP) = IWESTS(LOOP) + 1
C
        DWESTN(LOOP) =
     X   ABS((OLON(LOOP) - FLOAT(IWESTN(LOOP))*NSTEP(LOOP))/NSTEP(LOOP))
        DEASTN(LOOP) = 1.0 - DWESTN(LOOP)
C
        DWESTS(LOOP) =
     X   ABS((OLON(LOOP) - FLOAT(IWESTS(LOOP))*SSTEP(LOOP))/SSTEP(LOOP))
        DEASTS(LOOP) = 1.0 - DWESTS(LOOP)
C
C       Adjust west and east for longitude wrap-around
C
        IVALUE=NGPTS(NORTH(LOOP))
        IF( IEASTN(LOOP).GE.IVALUE) THEN
          IEASTN(LOOP) = IEASTN(LOOP) - IVALUE
          IF( IWESTN(LOOP).GE.IVALUE) IWESTN(LOOP) = IWESTN(LOOP)-IVALUE
        ENDIF
C
        IVALUE=NGPTS(SOUTH(LOOP))
        IF( IEASTS(LOOP).GE.IVALUE) THEN
          IEASTS(LOOP) = IEASTS(LOOP) - IVALUE
          IF( IWESTS(LOOP).GE.IVALUE) IWESTS(LOOP) = IWESTS(LOOP)-IVALUE
        ENDIF
C
      ENDDO
C
C     _______________________________________________________
C
C*    Section 4. Interpolate using neighbouring points.
C     _______________________________________________________
C
  400 CONTINUE
C
C       Use bi-linear interpolation from four neighbouring points.
C
      DO LOOP = 1, INROW
        NEWFLD(NEXT+LOOP-1) =
     X    ( ( OFIELD(NORTH(LOOP),IWESTN(LOOP)) * DEASTN(LOOP) +
     X        OFIELD(NORTH(LOOP),IEASTN(LOOP)) * DWESTN(LOOP) )
     X      * DSOUTH(LOOP) +
     X      ( OFIELD(SOUTH(LOOP),IWESTS(LOOP)) * DEASTS(LOOP) +
     X        OFIELD(SOUTH(LOOP),IEASTS(LOOP)) * DWESTS(LOOP) )
     X      * DNORTH(LOOP) )
      ENDDO
C
C     _______________________________________________________
C
C*    Section 9. Closedown.
C     _______________________________________________________
C
  900 CONTINUE
C
      RETURN
      END

C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE BUS0123( KBUFL,KBUFF,KSUP,KSEC0,KSEC1,KSEC2,
     1                    KSEC3,KERR)
C
C**** *BUS0123*
C
C
C     PURPOSE.
C     --------
C          EXPANDS SECTION 0,1,2 AND 3 OF BUFR MESSAGE.
C
C
C**   INTERFACE.
C     ----------
C
C          *CALL* *BUS0123( KBUFL,KBUFF,KSUP,KSEC0,KSEC1,KSEC2,KSEC3,KERR)*
C
C        INPUT :
C               *KBUFL*   -  LENGTH OF BUFR MESSAGE (WORDS)
C               *KBUFF*   -  ARRAY CONTAINING BUFR MESSAGE
C        OUTPUT:
C               *KSUP*    -  ARRAY CONTAINING SUPLEMENTARY INFORMATION
C                         -  KSUP( 1) -- IDIM1, DIMENSION OF KSEC1
C                         -  KSUP( 2) -- IDIM2, DIMENSION OF KSEC2
C                         -  KSUP( 3) -- IDIM3, DIMENSION OF KSEC3
C                         -  KSUP( 4) -- IDIM4, DIMENSION OF KSEC4
C                         -  KSUP( 5) -- M (NUMBER OF ELEMENTS IN VALUES ARRAY,
C                                           FIRST INDEX)
C                         -  KSUP( 6) -- N (NUMBER OF SUBSETS,SECOND INDEX OF
C                                           VALUES ARRAY)
C                         -  KSUP( 7) -- JVC (NUMBER OF ELEMENTS IN CVAL ARRAY)
C                         -  KSUP( 8) -- TOTAL BUFR MESSAGE LENGTH IN BYTES
C                         -  KSUP( 9) -- IDIM0, DIMENSION OF KSEC0
C               *KSEC0*   -  ARRAY CONTAINING SECTION 0 INFORMATION
C                            KSEC0( 1)-- LENGTH OF SECTION 0 (BYTES)
C                            KSEC0( 2)-- TOTAL LENGTH OF BUFR MESSAGE (BYTES)
C                            KSEC0( 3)-- BUFR EDITION NUMBER
C               *KSEC1*   -  ARRAY CONTAINING SECTION 1 INFORMATION
C                            KSEC1( 1)-- LENGTH OF SECTION 1 (BYTES)
C                            KSEC1( 2)-- BUFR EDITION NUMBER
C                            KSEC1( 3)-- ORIGINATING CENTRE
C                            KSEC1( 4)-- UPDATE SEQUENCE NUMBER
C                            KSEC1( 5)-- FLAG (PRESENCE OF SECTION 2)
C                            KSEC1( 6)-- BUFR MESSAGE TYPE
C                            KSEC1( 7)-- BUFR MESSAGE SUBTYPE
C                            KSEC1( 8)-- VERSION NUMBER OF LOCAL TABLE USED
C                            KSEC1( 9)-- YEAR
C                            KSEC1(10)-- MONTH
C                            KSEC1(11)-- DAY
C                            KSEC1(12)-- HOUR
C                            KSEC1(13)-- MINUTE
C                            KSEC1(14)-- BUFR MASTER TABLE
C                            KSEC1(15)-- VERSION NUMBER OF MASTER TABLE USED
C
C                            FOR BUFR EDITION 3 ONWARD
C
C                            KSEC1(16)-- ORIGINATING SUB-CENTRE
C                            KSEC1(17)-- NOT USED
C                            KSEC1(18) TO KSEC1(JSEC1) - LOCAL ADP CENTRE
C                                        INFORMATION(PACKED FORM)
C
C                            FOR BUFR EDITION 4 ONWARD
C
C                            KSEC1(16)-- ORIGINATING SUB-CENTRE
C                            KSEC1(17)-- INTERNATIONAL SUB-CATEGORY (SEE COMMON TABLE C-13
C                            KSEC1(18)-- SECOND
C                            KSEC1(19)-- YEAR
C                            KSEC1(20)-- MONTH
C                            KSEC1(21)-- DAY
C                            KSEC1(22)-- HOUR
C                            KSEC1(23)-- MINUTE
C                            KSEC1(24)-- SECOND
C                            KSEC1(25)-- YEAR
C                            KSEC1(26)-- MONTH
C                            KSEC1(27)-- DAY
C                            KSEC1(28)-- HOUR
C                            KSEC1(29)-- MINUTE
C                            KSEC1(30)-- SECOND
C                            KSEC1(31)-- MOST SOUTHERN LATITUDE  (-90 to 90)
C                            KSEC1(32)-- MOST WESTERN LONGITUDE  ( 0-360)
C                            KSEC1(33)-- MOST NORTHEN LATITUDE   (-90 to 90)
C                            KSEC1(34)-- MOST EASTERN LONGITUDE  ( 0-360)
C                            KSEC1(35) TO KSEC1(JSEC1) - LOCAL ADP CENTRE INFORMATION(PACKED FORM)
C
C               *KSEC2*   -  ARRAY CONTAINING SECTION 2 INFORMATION
C                            KSEC2( 1)-- LENGTH OF SECTION 2 (BYTES)
C                            KSEC2( 2) TO KSEC2(47) RDB KEY
C               *KSEC3*   -  ARRAY CONTAINING SECTION 3 INFORMATION
C                            KSEC3( 1)--
C                            KSEC3( 2)--
C                            KSEC3( 3)--
C                            KSEC3( 4)--
C
C               *KERR*    -  RETURNED ERROR CODE
C
C     METHOD.
C     --------
C
C          NONE.
C
C     EXTERNALS.
C     ----------
C
C          BUEXS0          - UNPACK SECTION 0
C          BUEXS1          - UNPACK SECTION 1
C          BUEXS2          - UNPACK SECTION 2
C          BUEXS3          - UNPACK SECTION 3
C
C     REFERENCE.
C     ----------
C
C          NONE.
C
C     AUTHOR.
C     -------
C
C          M. DRAGOSAVAC    *ECMWF*       15/07/91.
C
C
C     MODIFICATIONS.
C     --------------
C
C          NONE.
C
C
      IMPLICIT LOGICAL(L,O,G), CHARACTER*8(C,H,Y)
C
C
C
#     include "parameter.F"
#     include "bcomunit.F"
#     include "bcomwork.F"
#     include "bcomwt.F"
#     include "bcomdefc.F"
#     include "bcomreq.F"
C
      DIMENSION KBUFF(KBUFL)
      DIMENSION KSUP(*),KSEC0(*),KSEC1(*)
      DIMENSION KSEC2(*),KSEC3(*)
#ifndef R_4
      REAL*8 RVIND
      REAL*8 EPS
      REAL*8 RQVAL
#else
      REAL   RVIND
      REAL   EPS
      REAL   RQVAL
#endif
C
      CHARACTER*4 CECMWF,CUSER
C
C     ------------------------------------------------------------------
C*          1.   SET CONSTANTS.
C                --------------
 100  CONTINUE
C
      KERR=0
C
      IF(CECMWF.NE.'ECMF') THEN
         CALL BUEVAR(KERR)
         CECMWF='ECMF'
      END IF
C
      IF(CUSER.NE.'USER') THEN
         NREQ(1)=0
         NREQ(2)=0
         NRQL=0
      END IF
C     -----------------------------------------------------------------
C
C*          2.  EXPAND SECTION 0.
C               -----------------
 200  CONTINUE
C
      CALL BUEXS0( KBUFL,KBUFF,KSUP,KSEC0,KERR )
      IF(KERR.GT.0) RETURN
C
C     ------------------------------------------------------------------
C
C*          3.   EXPAND SECTION 1.
C                ------------------
 300  CONTINUE
C
      CALL BUEXS1( KBUFL,KBUFF,KSUP,KSEC0,KSEC1,KERR )
      IF(KERR.GT.0) RETURN
C
C     ------------------------------------------------------------------
C
C*          4.  EXPAND SECTION 2.
C               -----------------
 400  CONTINUE
C
      CALL BUEXS2( KBUFL,KBUFF,KSUP,KSEC1,KSEC2,KERR )
      IF(KERR.GT.0) RETURN
C
C*          5.  EXPAND SECTION 3 (PRELIMINARY ITEMS).
C               -------------------------------------
 500  CONTINUE
C
      CALL BUEXS3P(KBUFL,KBUFF,KSUP,KSEC3,KERR)
C
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE CREXSRP(KBUFL,YBUFF,KSEC3,KJ,KJ1,KDD,KSTACK,KELEM,KERR)
C
C**** *CREXSRP*
C
C
C     PURPOSE.
C     --------
C          Resolve data descriptor replication problem.
C
C
C**   INTERFACE.
C     ----------
C
C          *CALL* *CREXSRP(KBUFL,YBUFF,KSEC3,KJ,KJ1,KDD,KSTACK,KELEM,KERR)*
C
C        INPUT :
C               *KBUFL*   -  length of CREX message (words)
C               *YBUFF*   -  array containing CREX message
C               *KSEC3*   -  array containig section 3 information
C               *KELEM*   -  dimension of CNAMES, CUNITS array
C               *KDD*      - data descriptor
C        OUTPUT:
C               *KJ*       - pointer to kstack array
C               *KJ1*      - pointer to last element in kstack
C               *KSTACK*   - list of data descriptors
C               *KERR*     - return code
C
C     METHOD.
C     -------
C          NONE.
C
C     EXTERNALS.
C     ----------
C
C
C
C     REFERENCE.
C     ----------
C
C          NONE.
C
C     AUTHOR.
C     -------
C
C          MILAN DRAGOSAVAC    *ECMWF*       01/02/2003.
C
C
C     MODIFICATIONS.
C     --------------
C
C          NONE.
C
C
      IMPLICIT LOGICAL(L,O,G), CHARACTER*8(C,H,Y)
C
      CHARACTER CREXWTEN*64,CREXWTU*24
C
C
      PARAMETER(JSUP =   9,JSEC0=   3,JSEC1= 40,JSEC2= 64 ,JSEC3=    4,
     1          JSEC4=   2,JELEM=40000,JSUBS=400,JCVAL=150 ,JBUFL=40000,
     2          JBPW =  32,JTAB =3000,JCTAB=120,JCTST=1800,JCTEXT= 200,
     3          JWORK=360000,JKEY=46)
C
C
      COMMON /CREXWORK/ NBPT,NGS,NVIND,NBPTSEC2,RVIND,EPS,NE,IEOLD,
     1                  NC07YYY
C
      COMMON /CREXWT/ NCREXDWINC,NCREXSCAM,NCREXAFDW,NCREXWT ,ODREPF,
     2               NCREXSTACK(JELEM),NCREXWTEN(JELEM),
     3               NCREXWTR (JELEM),NCREXWTS (JELEM),NCREXWTRV(JELEM),
     4               NCREXWTDW(JELEM),NWTIW(JELEM),NWTIWS(JELEM)
C
C             NCREXDWINC   -  data width increment
C             NCREXSCAM    -  scale multiplier
C             NCREXAFDW    -  augmented field data width
C             NCREXWT      -  pointer to working table
C             NCREXSTACK   -  list of data descriptors
C             ODREPF   -  replication (logical)
C             NCREXWTR     -  working table reference
C             NCREXWTS     -  working scale
C             NCREXWTRV    -  working reference value
C             NCREXWTDW    -  working data width
C             NWTIW    -  working data width of increments
C             NWTIWS   -  working total data width of element set
C
C
      COMMON /CREXWTC/ CREXWTEN(JELEM),CREXWTU (JELEM)
C
C             CREXWTEN    -  working table element naame
C             CREXWTU     -  working table units
C
C
      COMMON /CREXBEF / M,MM,N,JCV
C
C             M       -  Number of elements
C             MM      -  Number of elements
C             N       -  Number of data sub_sets
C             JCV     -  Number of character values
C
C
      COMMON /CREXOFF/ NSIZEG(JELEM),NCREXWTRG(JWORK),
     1                 NBP,NSUBSET,OMULTI

C
      DIMENSION ILIST(JELEM)
      DIMENSION KSTACK(*),KSEC3(JSEC3)
C
      CHARACTER*(*) YBUFF
      REAL*8 RVIND,EPS
C
C
C     ------------------------------------------------------------------
C
C*          1.   STORE K, NUMBER OF DESCRIPTORS TO BE REPLICATED.
C                ------------------------------------------------
 100  CONTINUE
C
      IF( KERR.NE.0 ) RETURN
C
      IF  = KDD / 100000
      IDIF= KDD - IF * 100000
      IX  = IDIF / 1000
      IY  = IDIF - IX * 1000
      K   = IX
C
C
C*          1.1   DELAYED REPLICATION ?
C                 ---------------------
 110  CONTINUE
C
      IF( IY .NE. 0 ) THEN
C
C*          1.2   STORE NUMBER OF DESCRIPTORS, K, AND REPLICATION
C                 -----------------------------------------------
C                 FACTOR JR.
C                 ----------
 120     CONTINUE
C
         K  = IX
         JR = IY
         GO TO 500
      ELSE
C
C           1.3   INSERT DELAYED REPLICATION 
C
         ODREPF=.TRUE.
         KDD=31002
         GO TO 300
      END IF
C
C     ------------------------------------------------------------------
C
C*          2.   GET NEXT DESCRIPTOR.
C                --------------------
 200  CONTINUE
C
      KJ =KJ + 1
      KDD= KSTACK(KJ)
C
C     ------------------------------------------------------------------
C
C*          2.1  REPLICATION FACTOR ?
C                --------------------
 210  CONTINUE
C
      IF(KDD.NE.31001.AND.KDD.NE.31002.AND.
     1   KDD.NE.31000.AND.
     1   KDD.NE.31011.AND.KDD.NE.31012 )THEN
C
C*          2.1.1  SEQUENCE DESCRIPTOR ?
C                  ---------------------
C
         IF=KDD/100000
C
         IF( IF.EQ.3) THEN
C
C*          2.1.1.1  SOLVE TABLE D REFERENCE.
C                    ------------------------
            CALL CREXSTDR(KJ,KJ1,KDD,KSTACK,KERR)
            IF(KERR.GT.0) THEN
               DO 252 IQ=1,JELEM
               NCREXSTACK(IQ)=0.
 252           CONTINUE
               RETURN
            END IF
            GO TO 200
         END IF
C
         IF( IF.EQ.2) THEN
            CALL CREXPRCO(KBUFL,YBUFF,KJ,KDD,KSTACK,KELEM,KERR)
            IF(KERR.GT.0) THEN
               CALL CREXERR(KERR)
               RETURN
            END IF
            GO TO 200
         END IF
C
         KERR=36
         CALL CREXERR(KERR)
         RETURN
      END IF
C
C     ------------------------------------------------------------------
C
C*          3.  UPDATE WORKING TABLE.
C               ---------------------
 300  CONTINUE
C
      CALL CREXUPWT(KDD,KELEM,KERR)
      IF(KERR.GT.0) RETURN
C
C     CHECK IF NEXT DESCRIPTOR CANCEL OPERATOR FOR DELAYED
C     REPLICATION
C
      IIIF=KSTACK(KJ+1)/100000
      IIII=KSTACK(KJ+1)-IIIF*100000
      IIIX=IIII/1000
      IIIY=IIII-IIIX*1000
C
      IF(IIIF.EQ.2.AND.IIIY.EQ.0) THEN
         KJ=KJ+1
         KDD=KSTACK(KJ)
         CALL CREXPRCO(KBUFL,YBUFF,KJ,KDD,KSTACK,KELEM,KERR)
         IF(KERR.GT.0) THEN
            CALL CREXERR(KERR)
            RETURN
         END IF
      END IF
C
C     ------------------------------------------------------------------
C
C*          4.  LOCATE AND STORE JR, THE REPLICATION FACTOR FROM DATA.
C               ------------------------------------------------------
 400  CONTINUE
C
C
C     UNCOMPRESSED DATA
C
      IF(NSUBSET.EQ.1) THEN
         IBPT=NBPTSEC2
      ELSE
         IBPT=NBP       
      END IF
      CALL NEXTPRT(KBUFL,YBUFF,IBPT,NGS,KERR )
      IF(KERR.NE.0) THEN
         print*,'nextprt: error ',ierr
         RETURN
      END IF
C
c     Now IBPT points to the first group
c
      ITEMP=IBPT
      CALL NEXTSEC(KBUFL,YBUFF, ITEMP,NGS,KERR )
      IF(KERR.NE.0) THEN
         print*,'nextsec: error ',ierr
         RETURN
      END IF
C
c     Now itemp points to the end of previous section
c
      CALL NEXTPRT(KBUFL,YBUFF,IBPT,ITEMP,KERR )
      IF(KERR.NE.0) THEN
         print*,'nextprt: error ',ierr
         RETURN
      END IF
c
      DO 401 J=1,NCREXWT-1
C
      IBPT=IBPT+NCREXWTDW(j)+NE
c     CALL NEXTPRT(KBUFL,YBUFF,IBPT,ITEMP,KERR )
c     IF(KERR.NE.0) THEN
c        print*,'nextprt: error ',ierr
c        RETURN
c     END IF
c
      CALL NEXTSEP(KBUFL,YBUFF,IBPT,ITEMP,KERR )
      CALL NEXTGRP(KBUFL,YBUFF,IBPT,ITEMP,KERR)
      IF(KERR.NE.0) THEN
         print*,'nextsec: error ',ierr
         RETURN
      END IF
C
 401  CONTINUE
C
      IF(NE.EQ.1) IBPT=IBPT+1
      CALL EXTGRP(KBUFL,YBUFF, IBPT,NCREXWTDW(NCREXWT),JR,KERR)
      IF(KERR.NE.0) THEN
         print*,'extgrp : error ',kerr
         RETURN
      end if
C
      IF(JR.EQ.0) THEN
         KJ=KJ+K
         GO TO 640
      END IF
C
      JRTK=JR*K+KJ1-K
      IF(JRTK.GT.JELEM) THEN
         KERR=19
         PRINT*,'BUSRP :'
         CALL CREXERR(KERR)
         PRINT*,'Replication factor =',JR
         RETURN
      END IF
C
C     ------------------------------------------------------------------
C*          5.  GET NEXT K DESCRIPTORS.
C               -----------------------
 500  CONTINUE
C
      DO 501 J=1,K
C
      ILIST(J)=KSTACK(KJ+J)
C
 501  CONTINUE
C
C     ------------------------------------------------------------------
C*          6.  ADD JR TIMES K DESCRIPTORS IN PLACE OF K
C               ----------------------------------------
C               DESCRIPTORS OBTAINED.
C               ---------------------
 600  CONTINUE
C
C     ------------------------------------------------------------------
C*          6.1  PUSH DOWN DESCRIPTORS IN KSTACK FOR (JR-1)*K PLACES
C                ---------------------------------------------------
C                STARTING AT KJ1 AND ENDING AT KJ+K.
C                -----------------------------------
 610  CONTINUE
C
      JRKM1=(JR-1)*K
C
      DO 611 J=KJ1,KJ+K,-1
C
      KSTACK(J+JRKM1)=KSTACK(J)
C
 611  CONTINUE
C
C*          6.2  INSERT LIST IN THE STACK.
C                -------------------------
 620  CONTINUE
C
      DO 622 J=1,JR
C
      KJJM1K=KJ+(J-1)*K
C
      DO 623 J1=1,K
C
      KSTACK(KJJM1K+J1)=ILIST(J1)
C
 623  CONTINUE
 622  CONTINUE
C
C     ------------------------------------------------------------------
C*          6.3  ADJUST DESCRIPTOR COUNT FOR LIST LENGTH.
C                ----------------------------------------
 630  CONTINUE
C
      KJ1 = KJ1  + (JR-1)*K
C
C     ------------------------------------------------------------------
C*          6.4  ADJUST NUMBER OF DATA DESCRIPTORS NOT PRESENT.
C                ----------------------------------------------
 640  CONTINUE
C
C
C     ------------------------------------------------------------------
 700  CONTINUE
C
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE FFT99(A,WORK,TRIGS,IFAX,INC,JUMP,N,LOT,ISIGN)
C
C---->
C**** FFT99
C
C     PURPOSE
C     _______
C
C     Multiple fast real periodic transform.
C
C
C     INTERFACE
C     _________
C
C     CALL FFT99(A,WORK,TRIGS,IFAX,INC,JUMP,N,LOT,ISIGN)
C
C
C     Input parameters
C     ________________
C
C     A      - the array containing input data
C     WORK   - an area of size (N+1)*MIN(LOT,64)
C     TRIGS  - a previously prepared list of trig function values
C     IFAX   - a previously prepared list of factors of N
C     INC    - the increment within each data 'vector'
C              (e.g. INC=1 for consecutively stored data)
C     JUMP   - the increment between the start of each data vector
C     N      - the length of the data vectors
C     LOT    - the number of data vectors
C     ISIGN  -  +1 for transform from spectral to gridpoint
C            -  -1 for transform from gridpoint to spectral
C
C     Output parameters
C     ________________
C
C     A      - the array containing output data
C
C
C     Method
C     ______
C     
C     Ordering of coefficients:
C         A(0),B(0),A(1),B(1),A(2),B(2),...,A(N/2),B(N/2)
C         where B(0) = B(N/2)=0; (N+2) locations required
C
C     Ordering of data:
C         X(N-1),X(0),X(1),X(2),...,X(N-1),X(0)
C         i.e. explicit cyclic continuity; (N+2) locations required
C
C     Vectorization is achieved by doing the transforms in parallel
C
C     N must be composed of factors 2,3 & 5 but does not have to be even
C
C     
C     Real transform of length N performed by removing redundant
C     operations from complex transform of length N
C     Definition of transforms:
C
C     ISIGN = +1:
C         X(J) = SUM(K=0,...,N-1)(C(K)*EXP(2*I*J*K*PI/N))
C         where C(K) = A(K)+I*B(K) and C(N-K) = A(K)-I*B(K)
C
C     ISIGN = -1:
C         A(K) = (1/N)*SUM(J=0,...,N-1)(X(J)*COS(2*J*K*PI/N))
C         B(K) = -(1/N)*SUM(J=0,...,N-1)(X(J)*SIN(2*J*K*PI/N))
C
C     Externals
C     _________
C
C     RPASSM  - Performs one pass through data as part of multiple real
C               FFT (fourier analysis) routine.
C     QPASSM  - Performs one pass through data as part of multiple real
C               FFT (fourier synthesis) routine.
C
C
C     Reference
C     _________
C
C     None.
C
C
C     Comments
C     ________
C
C     Tidy up of code in older version of same routine.
C
C
C     AUTHOR
C     ______
C
C     J.D.Chambers      *ECMWF*      Nov 1996
C
C
C     MODIFICATIONS
C     _____________
C
C     None.
C
C----<
C     _______________________________________________________
C
C*    Section 0. Definition of variables.
C     _______________________________________________________
C
      IMPLICIT NONE
C
C     Subroutine arguments
      REAL A, WORK, TRIGS
      INTEGER IFAX, INC, JUMP, N, LOT, ISIGN
      DIMENSION A(N),WORK(N),TRIGS(N),IFAX(10)
C
C     Local variables
      INTEGER NFAX, NX, NBLOX, NVEX, ISTART, NB, IA, I, J
      INTEGER LA, IGO, K, IFAC, IERR, IBASE, JBASE, JJ, II
      INTEGER IX, IZ
C
C ------------------------------------------------------------------
C     Section 1.   Initialise
C ------------------------------------------------------------------
C
  100 CONTINUE
C
C     Ensure factorization of N has been done.
      IF(IFAX(10).NE.N) CALL SET99(TRIGS,IFAX,N)
C
      NFAX = IFAX(1)
      IF (MOD(N,2).EQ.1) THEN
        NX = N
      ELSE
        NX = N + 1
      ENDIF
C
C     Calculate number of blocks of 64 vectors and number of vectors
C     'left over'. This remainder is transformed first.
C
      NBLOX = 1 + (LOT-1)/64
      NVEX  = LOT-(NBLOX-1)*64
C
      IF (ISIGN.EQ.1) THEN
C
C ------------------------------------------------------------------
C     Section 2.   Spectral to gridpoint transform.
C ------------------------------------------------------------------
C
  200   CONTINUE
C
C       Loop through the blocks of vectors
        ISTART = 1
        DO 270 NB = 1,NBLOX
          IA = ISTART
          I  = ISTART
          DO 210 J = 1,NVEX
            A(I+INC) = 0.5*A(I)
            I        = I + JUMP
  210     CONTINUE
C
          IF (MOD(N,2).NE.1) THEN
            I = ISTART + N*INC
            DO 220 J = 1,NVEX
              A(I) = 0.5*A(I)
              I    = I + JUMP
  220       CONTINUE
          ENDIF
C
          IA  = ISTART + INC
          LA  = 1
          IGO = 1
C
C         Work through the factors
          DO 230 K = 1,NFAX
            IFAC = IFAX(K+1)
            IERR = -1
            IF (IGO.NE.-1) THEN
              CALL RPASSM(A(IA),A(IA+LA*INC),WORK(1),WORK(IFAC*LA+1),
     X          TRIGS,INC,1,JUMP,NX,NVEX,N,IFAC,LA,IERR)
            ELSE
              CALL RPASSM(WORK(1),WORK(LA+1),A(IA),A(IA+IFAC*LA*INC),
     X          TRIGS,1,INC,NX,JUMP,NVEX,N,IFAC,LA,IERR)
            ENDIF
C
            IF (IERR.NE.0) GO TO 950
C
            LA  = IFAC*LA
            IGO = -IGO
            IA  = ISTART + INC
  230     CONTINUE
C
C         If necessary, copy results back to A
C         
          IF (MOD(NFAX,2).NE.0) THEN
            IBASE = 1
            JBASE = IA
            DO 250 JJ = 1,NVEX
              I = IBASE
              J = JBASE
              DO 240 II = 1,N
                A(J) = WORK(I)
                I    = I + 1
                J    = J + INC
  240         CONTINUE
              IBASE = IBASE + NX
              JBASE = JBASE + JUMP
  250       CONTINUE
          ENDIF
C
C         Fill in cyclic boundary values (ie repeat the data vector
C         end points at opposite end of the vector)
C         
          IX = ISTART
          IZ = ISTART + N*INC
CDIR$ IVDEP
          DO 260 J = 1,NVEX
            A(IX)     = A(IZ)
            A(IZ+INC) = A(IX+INC)
            IX        = IX + JUMP
            IZ        = IZ + JUMP
  260     CONTINUE
C
C         Adjust pointers for next block
          ISTART = ISTART + NVEX*JUMP
          NVEX   = 64
  270   CONTINUE
C
      ELSE
C
C ------------------------------------------------------------------
C     Section 3.   Gridpoint to spectral transform.
C ------------------------------------------------------------------
C
  300   CONTINUE
C
C       Loop through the blocks of vectors
        ISTART = 1
        DO 390 NB  =  1,NBLOX
          IA  = ISTART + INC
          LA  = N
          IGO = 1
C
          DO 310 K = 1,NFAX
            IFAC = IFAX(NFAX+2-K)
            LA   = LA/IFAC
            IERR = -1
            IF (IGO.NE.-1) THEN
              CALL QPASSM(A(IA),A(IA+IFAC*LA*INC),WORK(1),WORK(LA+1),
     X          TRIGS,INC,1,JUMP,NX,NVEX,N,IFAC,LA,IERR)
            ELSE
              CALL QPASSM(WORK(1),WORK(IFAC*LA+1),A(IA),A(IA+LA*INC),
     X          TRIGS,1,INC,NX,JUMP,NVEX,N,IFAC,LA,IERR)
            ENDIF
            IF (IERR.NE.0) GO TO 950
            IGO = -IGO
            IA  = ISTART + INC
  310     CONTINUE
C
C         If necessary, copy results back to A
C         
          IF (MOD(NFAX,2).NE.0) THEN
            IBASE = 1
            JBASE = IA
            DO 330 JJ = 1,NVEX
              I = IBASE
              J = JBASE
              DO 320 II = 1,N
                A(J) = WORK(I)
                I    = I + 1
                J    = J + INC
  320         CONTINUE
              IBASE = IBASE + NX
              JBASE = JBASE + JUMP
  330       CONTINUE
          ENDIF
C
C         Shift A(0) and fill in zero imaginary parts
C         
          IX = ISTART
          DO 340 J = 1,NVEX
            A(IX)     = A(IX+INC)
            A(IX+INC) = 0.0
            IX        = IX + JUMP
  340     CONTINUE
C
          IF (MOD(N,2).NE.1) THEN
            IZ = ISTART + (N+1)*INC
            DO 350 J = 1,NVEX
              A(IZ) = 0.0
              IZ    = IZ + JUMP
  350       CONTINUE
C
          ENDIF
C
C         Adjust pointers for next block
          ISTART = ISTART + NVEX*JUMP
          NVEX   = 64
  390   CONTINUE
C
      ENDIF
C
C ------------------------------------------------------------------
C     Section 9.   Closedown.
C ------------------------------------------------------------------
C
  900   CONTINUE
C
      RETURN
C
C     Error messages
C     
  950 CONTINUE
      GO TO (960,970,980) IERR
C
  960 CONTINUE
      WRITE(*,*) 'Vector length greater than 64, = ', NVEX
      GO TO 900
  970 CONTINUE
      WRITE(*,*) 'Factor not handled, =', IFAC
      GO TO 900
  980 CONTINUE
      WRITE(*,*) 'Factor only handled if LA*IFAC=N. Factor = ', IFAC
C
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities
C granted to it by virtue of its status as an intergovernmental organisation
C nor does it submit to any jurisdiction.
C

      INTEGER FUNCTION HNTFAUS(FLDIN,INLEN)
C
C---->
C**** HNTFAUS
C
C     Purpose
C     -------
C
C     Prepare to interpolate input field...
C
C
C     Interface
C     ---------
C
C     IRET = HNTFAUS( FLDIN,INLEN)
C
C     Input
C     -----
C
C     FLDIN  - Input field (unpacked).
C     INLEN  - Input field length (words).
C
C
C     Output
C     ------
C
C     Field unpacked values are in ZNFELDI, rotated if necessary.
C
C     Returns: 0, if OK. Otherwise, an error occured in rotation.
C
C
C     Method
C     ------
C
C     Rotate the field values if necessary.
C
C     Some rotation coefficients cannot be created because the
C     algorithm does not converge for rotations which are smaller
C     than a limit which depends on the spectral truncation.
C
C     If the rotation is too small, it has to be split into three
C     steps (two forward and one backward).
C
C     Current know limits are:
C
C     Truncation    Max South pole lat   Minimum rotation
C     ----------    ------------------   ----------------
C         63          -89.5                  0.5
C        106          -85                    5.0
C        159          -77                   13.0
C        213          -68                   22.0
C        319          -51                   39.0
C        511          -30.5                 59.5
C
C
C     Externals
C     ---------
C
C     INTLOG  - Log error message.
C     INTLOGR - Log error message.
C     RPHI    - Rotate a spectral field by longitude.
C     JACOBI  - Rotates spectral coefficients by latitude.
C
C
C     Author
C     ------
C
C     J.D.Chambers     ECMWF     February 2001
C
C----<
C
C     -----------------------------------------------------------------|
C*    Section 0.   Variables
C     -----------------------------------------------------------------|
C
      IMPLICIT NONE
C
C     Function arguments
C
      INTEGER INLEN
      REAL FLDIN(*)
C
#include "parim.h"
#include "nifld.common"
#include "nofld.common"
#include "grfixed.h"
#include "intf.h"
C
C     Parameters
C
      INTEGER JPROUTINE
      PARAMETER (JPROUTINE = 40140 )
      INTEGER JPLEN, JPNM
      PARAMETER ( JPNM = JPSTRUNC )
      PARAMETER ( JPLEN = (JPNM+1)*(JPNM+6) )
C
C     Local variables
C
      INTEGER     IRET
      INTEGER     ISIZE
      INTEGER     ITRUNC
      INTEGER     LOOP
      INTEGER     NBYTES
      INTEGER     NUMPTS
      LOGICAL     LOK
      LOGICAL     LSPLIT
      REAL        POLELAT
      REAL        SWORK(1)
      REAL*8      DATA(1)
      REAL*8      DLAT
      REAL*8      DLON
      REAL*8      DWORK(1)
      REAL*8      LATLIM
#ifndef _CRAYFTN
#ifdef POINTER_64
      INTEGER*8 IDATA
      INTEGER*8 IDWORK
      INTEGER*8 ISWORK
#endif
#endif
      POINTER (IDATA,  DATA)
      POINTER (IDWORK, DWORK)
      POINTER (ISWORK, SWORK)
C
      SAVE IDATA
      SAVE IDWORK
      SAVE ISIZE
      SAVE ISWORK
C
      DATA ISIZE/0/
      DATA NBYTES/4/
C
C     Externals
      LOGICAL JACOBI
      EXTERNAL JACOBI
C
C     -----------------------------------------------------------------|
C*    Section 1.   Initialise
C     -----------------------------------------------------------------|
C
  100 CONTINUE
C
      HNTFAUS = 0
      IRET    = 0
C
C     -----------------------------------------------------------------|
C*    Section 2.   Store input data.
C     -----------------------------------------------------------------|
C
  200 CONTINUE
C
C     Allocate work array ZNFELDI if not already done.
C
      IF( IZNJDCI.NE.1952999238 ) THEN
        CALL JMEMHAN( 19, IZNFLDI, JPEXPAND, 1, IRET)
        IF( IRET.NE.0 ) THEN
          CALL INTLOG(JP_WARN,'HNTFAUS: ZNFELDI allocate fail',JPQUIET)
          HNTFAUS = IRET
          GOTO 900
        ENDIF
        IZNJDCI = 1952999238
      ENDIF
C
C     Move unpacked values in from user array
C
      DO LOOP = 1, INLEN
        ZNFELDI( LOOP ) = FLDIN( LOOP )
      ENDDO
C
C     -----------------------------------------------------------------|
C*    Section 3.   Handle rotation, if necessary.
C     -----------------------------------------------------------------|
C
  300 CONTINUE
C
C     Is a rotation of the SH required?
C
      IF( LNOROTA ) THEN
C
C       Avoid rotating U or V spectral coefficients
C
        IF( (NIPARAM.EQ.JP_U).OR.(NIPARAM.EQ.JP_V) ) THEN
          CALL INTLOG(JP_ERROR,
     X      'HNTFAUS: Unable to rotate spectral U or V:',NIPARAM)
          HNTFAUS = JPROUTINE + 3
          GOTO 900
        ENDIF
C
C       Dynamically allocate memory for workspace.
C
C       (Note the multiplication by 2 for REAL*8).
C
        NUMPTS = INLEN
        ISIZE = NUMPTS*2
        CALL JMEMHAN( 11, IDWORK, ISIZE, 1, IRET)
        IF( IRET.NE.0 ) THEN
          CALL INTLOG(JP_ERROR,'HNTFAUS: memory allocation fail',IDWORK)
          HNTFAUS = JPROUTINE + 3
          GOTO 900
        ENDIF
C
C       (Note the multiplication by 2 for REAL*8).
C
        ISIZE = JPLEN*2
        CALL JMEMHAN( 15, IDATA, ISIZE, 1, IRET)
        IF( IRET.NE.0 ) THEN
          CALL INTLOG(JP_ERROR,'HNTFAUS: memory allocation fail',IDATA)
          HNTFAUS = JPROUTINE + 3
          GOTO 900
        ENDIF
C
        CALL INTLOG(JP_DEBUG,'HNTFAUS: Rotate SH field.',JPQUIET)
        CALL INTLOG(JP_DEBUG,'HNTFAUS: South pole latitude  ',NOROTA(1))
        CALL INTLOG(JP_DEBUG,'HNTFAUS: South pole longitude ',NOROTA(2))
        IF ( NOREPR.EQ.JPSPHERE )  NOREPR = JPSPHROT
        IF ( NOREPR.EQ.JPREGULAR )  NOREPR = JPREGROT
        ITRUNC = NIRESO
C
C       Some rotation coefficients cannot be created because the
C       algorithm does not converge for rotations which are smaller
C       than a limit which depends on the spectral truncation.
C
        IF( ITRUNC.LE.63 ) THEN
          LATLIM = -89.5
        ELSE IF( ITRUNC.LE.106 ) THEN
          LATLIM = -85.0
        ELSE IF( ITRUNC.LE.159 ) THEN
          LATLIM = -77.0
        ELSE IF( ITRUNC.LE.213 ) THEN
          LATLIM = -68.0
        ELSE IF( ITRUNC.LE.319 ) THEN
          LATLIM = -51.0
        ELSE IF( ITRUNC.LE.511 ) THEN
          LATLIM = -29.5
        ELSE
          HNTFAUS = JPROUTINE + 3
          GOTO 900
        ENDIF
        CALL INTLOGR(JP_DEBUG,
     X    'HNTFAUS: South pole latitude limit = ',LATLIM)
C
        POLELAT = (REAL(NOROTA(1))/JPMULT)
C
C       If the rotation is too small, it has to be split into three
C       steps (two forward and one backward).
C
        LSPLIT = POLELAT.LT.LATLIM
        IF( LSPLIT ) THEN
          DLAT = -90.0 - LATLIM
          CALL INTLOG(JP_DEBUG,
     X      'HNTFAUS: Rotation has been split into three steps',JPQUIET)
        ELSE
          DLAT = -90.0 - POLELAT
        ENDIF
#if (defined REAL_8)
C
C       Double precision REALs
C
        DLON = - REAL(NOROTA(2))/JPMULT
C
C       Rotate the spectral field by longitude.
        CALL RPHI( ZNFELDI, ITRUNC, DWORK, DLON)
C
C       Rotate the spectral field by latitude.
C
        IF( LSPLIT ) THEN
C
C         Two rotations forward ..
C
          CALL INTLOGR(JP_DEBUG,
     X      'HNTFAUS: Twice forward through angle ', DLAT)
          LOK = JACOBI(ZNFELDI, ITRUNC, DWORK, DLAT)
          IF(.NOT.LOK) THEN
            CALL INTLOG(JP_ERROR,
     X        'HNTFAUS: Spectral rotation failed',JPQUIET)
            HNTFAUS = JPROUTINE + 3
            GOTO 900
          ENDIF
          LOK = JACOBI(ZNFELDI, ITRUNC, DWORK, DLAT)
          IF(.NOT.LOK) THEN
            CALL INTLOG(JP_ERROR,
     X       'HNTFAUS: Spectral rotation failed',JPQUIET)
            HNTFAUS = JPROUTINE + 3
            GOTO 900
          ENDIF
C
C         .. and one backward
C
          DLAT = -90.0 - ( (LATLIM*2.0) - POLELAT)
          DLAT= -DLAT
          CALL INTLOGR(JP_DEBUG,
     X      'HNTFAUS: Once backward through angle ', DLAT)
        ENDIF
C
        LOK = JACOBI( ZNFELDI, ITRUNC, DWORK, DLAT)
          IF(.NOT.LOK) THEN
            CALL INTLOG(JP_ERROR,
     X        'HNTFAUS: Spectral rotation failed',JPQUIET)
            HNTFAUS = JPROUTINE + 3
            GOTO 900
          ENDIF
#else
C
C       Single precision REALs; so convert to double precision.
C
        DLAT = -90.0 - DBLE(NOROTA(1))/JPMULT
        DLON = - DBLE(NOROTA(2))/JPMULT
C
C       Expand spectral coefficients to REAL*8
C
        DO LOOP = 1, NUMPTS
          DATA(LOOP) = DBLE(ZNFELDI(LOOP))
        ENDDO
C
C       Rotate the spectral field by longitude.
C
        CALL RPHI( DATA, ITRUNC, DWORK, DLON)
C
C       Rotate the spectral field by latitude.
C
        IF( LSPLIT ) THEN
C
C         Two rotations forward ..
C
          CALL INTLOGR(JP_DEBUG,
     X      'HNTFAUS: Twice forward through angle ', DLAT)
          LOK = JACOBI(ZNFELDI, ITRUNC, DWORK, DLAT)
          IF(.NOT.LOK) THEN
            CALL INTLOG(JP_ERROR,
     X        'HNTFAUS: Spectral rotation failed',JPQUIET)
            HNTFAUS = JPROUTINE + 3
            GOTO 900
          ENDIF
          LOK = JACOBI(ZNFELDI, ITRUNC, DWORK, DLAT)
          IF(.NOT.LOK) THEN
            CALL INTLOG(JP_ERROR,
     X        'HNTFAUS: Spectral rotation failed',JPQUIET)
            HNTFAUS = JPROUTINE + 3
            GOTO 900
          ENDIF
C
C         .. and one backward
C
          DLAT = -90.0 - ( (LATLIM*2.0) - POLELAT)
          DLAT= -DLAT
          CALL INTLOGR(JP_DEBUG,
     X      'HNTFAUS: Once backward through angle ', DLAT)
        ENDIF
C
        LOK = JACOBI( DATA, ITRUNC, DWORK, DLAT)
#endif
C
        IF( .NOT.LOK ) THEN
          CALL INTLOG(JP_ERROR,'HNTFAUS: Rotation failed',JPQUIET)
          HNTFAUS = JPROUTINE + 3
          GOTO 900
        ENDIF
#if (!defined REAL_8)
C
C       Single precision REALs; repack spectral coefficients to REAL*4.
C
        DO LOOP = 1, NUMPTS
          ZNFELDI(LOOP) = SNGL(DATA(LOOP))
        ENDDO
#endif
C
      ENDIF
C
C     -----------------------------------------------------------------|
C*    Section 9.   Closedown.
C     -----------------------------------------------------------------|
C
  900 CONTINUE
C
      RETURN
      END

C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      INTEGER FUNCTION INTFB( INGRIB,INLEN,OUTGRIB,OUTLEN,FLDOUT)
C
C---->
C**** INTFB
C
C     Purpose
C     -------
C
C     Interpolate input field...
C
C
C     Interface
C     ---------
C
C     IRET = INTFB( INGRIB,INLEN,OUTGRIB,OUTLEN,FLDOUT)
C
C     Input
C     -----
C
C     INGRIB - Input field (packed).
C     INLEN  - Input field length (words).
C
C
C     Output
C     ------
C
C     OUTGRIB - Output field (packed).
C     OUTLEN  - Output field length (words).
C     FLDOUT  - Output field (unpacked).
C
C
C     Method
C     ------
C
C     Call interpolation routines; then repack if GRIB output.
C
C     Currently, subareas are not supported for reduced gaussian fields.
C     (Works OK; but need to setup values in GRIB product for number of
C      points in each latitude row)
C
C
C     Externals
C     ---------
C
C     IARCNTL - Control interp. quasi reg.Gauss -> Gaussian or lat/long
C     IAGCNTL - Control interpolation reg.Gaussian or lat/long fields.
C     JSH2SH  - Changes resolution of a field of spectral coefficients.
C     JALLGP  - Converts spectral fields to lat/long grid fields.
C     JALLWN  - Converts spectral wind fields to lat/long grids.
C     JSLLGP  - Converts strectched spectral fields to lat/long grid fields.
C     JAGGGP  - Converts spectral fields to a gaussian grid field.
C     JSGGGP  - Converts strectched spectral fields to a gaussian grid field.
C     IBASINI - Ensure basic interpolation setup is done.
C     GRIBEX  - Decode/encode GRIB product.
C     GRSVCK  - Turn off GRIB checking
C     IGSETUP - Setup GRIB sections for the output product.
C     JMEMHAN - Handles memory allocation.
C     IGLSIZE - Evaluate array sizes for reg. lat/long and area.
C     IGSIZE  - Evaluate array sizes for a regular Gaussian.
C     IRSIZE  - Evaluate array sizes for a quasi reg Gaussian.
C     FIXAREA - Fixup area definition to correspond to grid definitions
C     ISCRSZ  - Calculate number of values in generated field.
C     JDEBUG  - Checks environment to switch on/off debug
C     INTLOG  - Log error message.
C     INTLOGR - Log error message (real value).
C     OCEANP  - Interpolate GRIB ocean field.
C     MKBITMP - Apply a bitmap to a rectangular field.
C     MKFRAME - Create a 'frame' from a rectangular field.
C     DDSTYLE - Create subgrid by selecting pts from rectangular grid.
C     DSSAREA - Fixup field area (dissemination style).
C     INTISL  - Interpolate a field using ISLSCP processing.
C     KRG2RG  - Interpolate reduced gaussian to reduced gaussian (packed)
C     KRG2RGU - Interpolate reduced gaussian to reduced gaussian (unpacked)
C     KRG2RGD - Interpolate reduced gaussian to reduced gaussian
c               using intermediate interpolation
C
C
C     Author
C     ------
C
C     J.D.Chambers     ECMWF     Aug 1994
C
C     J.D.Chambers     ECMWF        Feb 1997
C     Allow for 64-bit pointers
C
C----<
C
C     IMPLICIT NONE
C
C     Function arguments
C
      INTEGER INGRIB(*),OUTGRIB(*),INLEN,OUTLEN
      REAL FLDOUT(*)
C
#include "parim.h"
#include "nifld.common"
#include "nifld.extracommon"
#include "nofld.common"
#include "grfixed.h"
#include "intf.h"
#include "jparams.h"
C
C     Parameters
C
      INTEGER JPROUTINE
      INTEGER JUNPACK, JPREALB
      PARAMETER (JPROUTINE = 26400 )
      INTEGER JPIMISS,CLASMISS,KNEWMISS
      PARAMETER (JPIMISS = -2147483647)
      PARAMETER (CLASMISS = 9999)
      REAL JPZMISS,NEWMISS
      PARAMETER (JPZMISS = -2.1474836E+09)
      PARAMETER (JUNPACK = 3000000)
      PARAMETER (JPREALB = 8)
C
C     Local variables
C
      INTEGER NWEPTS, NNSPTS
      REAL OLDS, OLDE
      REAL EW, NS, NORTH, SOUTH, WEST, EAST, RTEMP
      INTEGER IWORD, IERR, ILENF, ISIZE, IUV, IDISTEP
      REAL PNORTH, PSOUTH, PWEST, PEAST, PLATINC, PLONINC
      LOGICAL OIWEGLOBE, OINPOLE, OISPOLE
      LOGICAL OOWEGLOBE, OONPOLE, OOSPOLE
      LOGICAL LBITMP,LFRAME,LSTYLE,LGLOBAL,LSAMERS,LIQUASI
      LOGICAL LOLDLSP, LOLDLSM
      INTEGER INORTH, ISOUTH, IEAST, IWEST
      INTEGER HOLDEW, HOLDNS, N_NOWE, N_NONS
      INTEGER KILN, KITOTAL, KOLN, KOTOTAL, KPR, KERR
      INTEGER LOOP, LOOPI, NEXT, ISWAP, NTRUNC, NTROLD, NTROLD2
      INTEGER LENMED
      INTEGER IOS, ILENS
      REAL*8 DISSRES
      REAL TEMP(2048)
C
      DATA NTROLD/-1/, NTROLD2/-1/
      SAVE NTROLD, NTROLD2
      CHARACTER*1 HTYPE
      CHARACTER*1 HFUNC
      CHARACTER*6 YFLAG
#ifndef _CRAYFTN
#ifdef POINTER_64
#ifndef FUJITSU
      INTEGER*8 IZNFLDO
#endif
#endif
#endif
      REAL ZNFLDO , RWORK
      DIMENSION RWORK(JUNPACK)
      POINTER ( IZNFLDO, ZNFLDO )
      DIMENSION ZNFLDO( 1 )
      INTEGER NEWLSM(1), OLDLSM(1)
      POINTER( NIPNGRB, NEWLSM )
      POINTER( NIPOGRB, OLDLSM )
      LOGICAL LFIRST
      DATA LFIRST/.TRUE./
      SAVE LFIRST
C
C     Externals
C
      INTEGER IGLSIZE, IGSIZE, IRSIZE, IARCNTL, IAGCNTL, DSSAREA
      INTEGER IGSETUP, FIXAREA, ISCRSZ, OCEANP, AURESOL, MKBITMP
      INTEGER INTISL, KRG2RG, KRG2RGU,KRG2RGZ, KRG2RGD, KRG2RGY
#ifdef POINTER_64
      INTEGER*8 JMALLOC
#else
      INTEGER JMALLOC
#endif
C
C     -----------------------------------------------------------------|
C*    Section 1.   Initialise
C     -----------------------------------------------------------------|
C
  100 CONTINUE
      INTFB = 0
      IERR = 0
C
C     Check if debug option turned on
      CALL JDEBUG()
      KPR = NDBG
C
      LBITMP = LNOBITMP.AND.
     X         ((NOREPR.EQ.JPREGROT).OR.(NOREPR.EQ.JPREGULAR).OR.
     X          (NOREPR.EQ.JPGAUSSIAN))
C
      LFRAME = LNOFRAME.AND.
     X         ((NOREPR.EQ.JPREGULAR).OR.(NOREPR.EQ.JPGAUSSIAN).OR.
     X          (NOREPR.EQ.JPREGROT ).OR.(NOREPR.EQ.JPFGGROT  ) )
C
      LSTYLE = LNOSTYLE.AND.
     X         (NOSTYLE.EQ.JPSDISM).AND.
     X         (NOREPR.EQ.JPREGULAR)
C
      IF( .NOT.LWINDSET ) THEN
        LWIND = ( ((NOTABLE.EQ.128).OR.(NOTABLE.EQ.129)).AND.
     X            ((NOPARAM.EQ.131).OR.(NOPARAM.EQ.132).OR.
     X            (NOPARAM.EQ.165).OR.(NOPARAM.EQ.166)) )
      ENDIF
      CALL INTLOG(JP_DEBUG,'INTFB: Wind flag = ', LWIND)
      IF( LWIND ) THEN
        IUV = 1
      ELSE
        IUV = 0
      ENDIF
C
        IF(NIFORM.EQ.1) THEN
          ILENS = ISEC4(1)
        ELSE
          ILENS = INLEN
        ENDIF

C
C     If dissemination style selection of grid points is required,
C     adjust the sub-area limits to the dissemination grid.
C
      IF( LSTYLE ) THEN
        IDISTEP = NINT(JPDISTP*PPMULT)
        EW    = NOGRID(1) / PPMULT
        NS    = NOGRID(2) / PPMULT
        NORTH = REAL(NOAREA(1)) / PPMULT
        WEST  = REAL(NOAREA(2)) / PPMULT
        SOUTH = REAL(NOAREA(3)) / PPMULT
        EAST  = REAL(NOAREA(4)) / PPMULT
C
        IERR = DSSAREA( EW, NS, NORTH, WEST, SOUTH, EAST)
        IF( IERR.NE.0 ) THEN
          CALL INTLOG(JP_ERROR,'INTFB: DSSAREA failed:',IERR)
          INTFB = IERR
          GOTO 900
        ENDIF
C
        N_NOWE = NINT((EAST-WEST)/EW) + 1
        N_NONS = NINT((NORTH-SOUTH)/NS) + 1
C
        NOAREA(1) = NINT(NORTH * PPMULT)
        NOAREA(2) = NINT(WEST  * PPMULT)
        NOAREA(3) = NINT(SOUTH * PPMULT)
        NOAREA(4) = NINT(EAST  * PPMULT)
      ENDIF
C
C     If Hirlam 12-point rotation involved, it has already been done
C     (in INTFAPH), so just copy values to array for packing.
C
      IF( LUSEHIR.AND.LNOROTA ) THEN
        ISIZE = ISEC4(1)
        IF( ISIZE.EQ.0 ) ISIZE = OUTLROT
        CALL JMEMHAN( 3, IZNFLDO, ISIZE, 1, IERR)
        IF( IERR.NE.0 ) THEN
          CALL INTLOG(JP_FATAL,'INTFB: Get scratch space fail',JPQUIET)
          INTFB = JPROUTINE + 1
          GOTO 900
        ENDIF
C
        DO LOOP = 1, ISIZE
          ZNFLDO(LOOP) = ZNFELDI(LOOP)
        ENDDO
        GOTO 700
      ENDIF
C
C     -----------------------------------------------------------------|
C*    Section 2.   Special cases!
C     -----------------------------------------------------------------|
C
  200 CONTINUE
C
C     Allocate work array ZNFELDI if not already done.
C
      IF( IZNJDCI.NE.1952999238 ) THEN
        CALL JMEMHAN( 19, IZNFLDI, JPEXPAND, 1, ierr)
        IF( IERR.NE.0 ) THEN
          CALL INTLOG(JP_ERROR,'INTFB: znfeldi allocate fail',JPQUIET)
          INTFB = IERR
          GOTO 900
        ENDIF
        IZNJDCI = 1952999238
      ENDIF
C
C     Is the interpolation from SH to grid point
C
      IF( ((NIREPR.EQ.JPSPHERE).OR.(NIREPR.EQ.JPSPHROT).OR.
     X     (NIREPR.EQ.JPSTRSH))
     X    .AND.
     X    ((NOREPR.NE.JPSPHERE).AND.(NOREPR.NE.JPSPHROT)) ) THEN
C
        NTRUNC = NORESO
C
C       Check whether a truncation is required before interpolation
C
        IF( .NOT.LNORESO ) THEN
C
C         If user did not supply a truncation value, see whether or
C         not the 'autoresol' flag is set. If not, use the input
C         truncation.
C
          IF( LARESOL ) THEN
            IF( (NOREPR.EQ.JPREGULAR).OR.(NOREPR.EQ.JPREGROT) ) THEN
              EW = FLOAT(NOGRID(1))/PPMULT
              NS = FLOAT(NOGRID(2))/PPMULT
            ELSE
              EW = 90.0/FLOAT(NOGAUSS)
              NS = EW
            ENDIF
            NTRUNC = AURESOL(EW,NS)
            IF( NTRUNC.NE.NTROLD ) THEN
              NTROLD = NTRUNC
              CALL INTLOG(JP_WARN,
     X          'INTFB: Resolution automatically set to ', NTRUNC)
            ENDIF
          ELSE
            NTRUNC = NIRESO
          ENDIF
C
        ELSE
C
C
        ENDIF
C
C       Check whether the output resolution is greater than the input
C
        IF( NTRUNC.GT.NIRESO ) THEN
C
C         Issue warning if the output resolution was user-supplied
C
          IF( .NOT.LARESOL ) THEN
C
C           Revert to the input truncation
C
            IF( NIRESO.NE.NTROLD2 ) THEN
              CALL INTLOG(JP_WARN,
     X          'INTFB: spectral -> grid point interpolation',JPQUIET)
              CALL INTLOG(JP_WARN,
     X          'INTFB: User supplied resolution = ',NTRUNC)
              CALL INTLOG(JP_WARN,
     X          'INTFB: Input field resolution   = ',NIRESO)
              CALL INTLOG(JP_WARN,
     X          'INTFB: User supplied resolution ignored',JPQUIET)
              CALL INTLOG(JP_WARN,
     X          'INTFB: Input field resolution has been used',JPQUIET)
              NTROLD2 = NIRESO
            ENDIF
            NTRUNC = NIRESO
C
          ELSE
C
C           Revert to the input truncation if auto RESOL
C
            NTRUNC = NIRESO
            IF( NTRUNC.NE.NTROLD2 ) THEN
              NTROLD2 = NTRUNC
              CALL INTLOG(JP_WARN,
     X          'INTFB: Automatic resolution selectn too high:',JPQUIET)
              CALL INTLOG(JP_WARN,
     X          'INTFB: Resolution reset to input resolution: ',NTRUNC)
            ENDIF
          ENDIF
C
        ENDIF
C
C       Truncate if a smaller resolution has been requested
C
        IF( NTRUNC.LT.NIRESO ) THEN
          CALL INTLOG(JP_DEBUG,
     X      'INTFB: Spectral coefficents truncated to ', NTRUNC)
C
          ISIZE =  (NTRUNC+1)*(NTRUNC+4)
          CALL JMEMHAN( 3, IZNFLDO, ISIZE, 1, IERR)
          IF( IERR.NE.0 ) THEN
            CALL INTLOG(JP_FATAL,
     X        'INTFB: Get scratch space failed',JPQUIET)
            INTFB = JPROUTINE + 2
            GOTO 900
          ENDIF
C
C         Generate spherical harmonics with output truncation
C
          CALL SH2SH( ZNFELDI, NIRESO, ZNFLDO, NTRUNC )
C
C         Move new spherical harmonics to 'input' array
C
          DO LOOP = 1, ISIZE
            ZNFELDI(LOOP) = ZNFLDO(LOOP)
          ENDDO
C
          NIRESO = NTRUNC
C
        ENDIF
C
      ENDIF
C
C     Is it an ocean field interpolation?
C
c sinisa this is all done in intf
c      IF( (ISEC1(24).EQ.1)       .AND.
c     X    (ISEC1(37).EQ.4)       .AND.
c     X    (NIFORM.EQ.1)          .AND.
c     X    (NOFORM.EQ.1) ) THEN
c        IERR = OCEANP(INGRIB,INLEN,OUTGRIB,OUTLEN)
c        IF( IERR.NE.0 ) THEN
c          CALL INTLOG(JP_ERROR,
c     X      'INTFB: Ocean interpolation failed.',JPQUIET)
c          INTFB = JPROUTINE + 2
c        ELSE
c          CALL INTLOG(JP_DEBUG,
c     X      'INTFB: Ocean interpolation finished successfully.',JPQUIET)
c        ENDIF
c        GOTO 900
c      ENDIF
C
C     -----------------------------------------------------------------|
C*    Section 3.   Interpolation spherical harmonics to spherical
C                  harmonics
C     -----------------------------------------------------------------|
C
  300 CONTINUE
C
      IF( ((NIREPR.EQ.JPSPHERE).OR.(NIREPR.EQ.JPSPHROT)) .AND.
     X    ((NOREPR.EQ.JPSPHERE).OR.(NOREPR.EQ.JPSPHROT) ) ) THEN
C
C       Get scratch space for interpolation
C
        CALL INTLOG(JP_DEBUG,'INTFB: SH -> SH, input is ',NIRESO)
        CALL INTLOG(JP_DEBUG,'INTFB:          output is ',NORESO)
        ISIZE = ISCRSZ()
        IF( ISIZE.LE.0 ) THEN
          CALL INTLOG(JP_ERROR,'INTFB: Get scratch space failed.',ISIZE)
          INTFB = JPROUTINE + 2
          GOTO 900
        ENDIF
        CALL JMEMHAN( 3, IZNFLDO, ISIZE, 1, IERR)
        IF( IERR.NE.0 ) THEN
          CALL INTLOG(JP_ERROR,'INTFB: Get scratch space fail.',JPQUIET)
          INTFB = JPROUTINE + 2
          GOTO 900
        ENDIF
C
        CALL SH2SH( ZNFELDI, NIRESO, ZNFLDO, NORESO )
C
        GOTO 700
C
C     If not spectral -> spectral transformation, make sure the input
C     and output area definitions have been setup.
C
      ELSE
C
C       Fixup area definition to correspond to grid definitions
C
        IF( .NOT.LSTYLE ) THEN
          IERR = FIXAREA()
          IF( IERR.NE.0 ) THEN
            CALL INTLOG(JP_ERROR,
     X        'INTFB: Fixup area definition failed.',JPQUIET)
            INTFB = JPROUTINE + 9
            GOTO 900
          ENDIF
        ENDIF
C
C       Setup geographical limits
C
        PNORTH = FLOAT( NOAREA(1) ) / PPMULT
        PWEST  = FLOAT( NOAREA(2) ) / PPMULT
        PSOUTH = FLOAT( NOAREA(3) ) / PPMULT
        PEAST  = FLOAT( NOAREA(4) ) / PPMULT
C
      ENDIF
C
C     -----------------------------------------------------------------|
C     Section 4.   Interpolation spherical harmonics to grid point.
C     -----------------------------------------------------------------|
C
  400 CONTINUE
C
      IF( (NIREPR.EQ.JPSPHERE).OR.
     X    (NIREPR.EQ.JPSTRSH) .OR.
     X    (NIREPR.EQ.JPSPHROT) ) THEN
#ifndef REAL_8
C
C       Check that double precision floats are in use if spectral
C       resolution is greater than T213
C
        IF( NIRESO.GT.213 ) THEN
          CALL INTLOG(JP_ERROR,
     X      'INTFB: Double precision must be used',JPQUIET)
          CALL INTLOG(JP_ERROR,'INTFB: for spectral resolution ',NIRESO)
          INTFB = JPROUTINE + 2
          GOTO 900
        ENDIF
#endif
        CALL INTLOG(JP_DEBUG,'INTFB: SH -> grid point',JPQUIET)
C
C       Get scratch space for interpolation
C       If dissemination style, space has to be for a 0.5x0.5 grid
C
        IF( LSTYLE ) THEN
c to be consistant with product generation 
           IF(NIRESO.EQ.1279) THEN
              DISSRES = 0.125
           ELSEIF(NIRESO.EQ.799) THEN
              DISSRES = 0.25
           ELSEIF(NIRESO.EQ.639) THEN
              DISSRES = 0.25
           ELSEIF(NIRESO.EQ.511) THEN
              DISSRES = 0.5
           ELSEIF(NIRESO.EQ.399) THEN
              DISSRES = 0.5
           ELSEIF(NIRESO.EQ.319) THEN
              DISSRES = 0.5
           ELSEIF(NIRESO.EQ.255) THEN
              DISSRES = 0.5
           ELSEIF(NIRESO.EQ.155) THEN
              DISSRES = 1.5
           ELSE
              DISSRES = NOGRID(1) / PPMULT
            CALL INTLOG(JP_WARN,'INTFB: Diss resol set to: ',NOGRID(1))
           ENDIF
          IDISTEP = NINT(DISSRES*PPMULT)
C
          HOLDEW = NOGRID(1)
          HOLDNS = NOGRID(2)
          NOGRID(1) = IDISTEP
          NOGRID(2) = IDISTEP
        ENDIF
        ISIZE = ISCRSZ()
        IF( ISIZE.LE.0 ) THEN
          CALL INTLOG(JP_ERROR,'INTFB: Get scratch space failed.',ISIZE)
          INTFB = JPROUTINE + 2
          GOTO 900
        ENDIF
C
        CALL JMEMHAN( 3, IZNFLDO, ISIZE, 1, IERR)
        IF( IERR.NE.0 ) THEN
          CALL INTLOG(JP_ERROR,'INTFB: Get scratch space fail.',JPQUIET)
          INTFB = JPROUTINE + 2
          GOTO 900
        ENDIF
        IF( LSTYLE ) THEN
          NOGRID(1) = HOLDEW
          NOGRID(2) = HOLDNS
        ENDIF
C
C     -----------------------------------------------------------------|
C*    Section 4.1  Interpolation spherical harmonics to grid point.
C     -----------------------------------------------------------------|
C
  410 CONTINUE
C
        IF( (NOREPR.EQ.JPREGULAR) .OR. (NOREPR.EQ.JPREGROT) ) THEN
          CALL INTLOG(JP_DEBUG,'INTFB: SH -> lat/long',JPQUIET)
C
C         -> latitude/longitude grid
C         If dissemination style, generated grid is 0.5x0.5
C
          IF( LSTYLE ) THEN
            HOLDEW = NOGRID(1)
            HOLDNS = NOGRID(2)
            NOGRID(1) = IDISTEP
            NOGRID(2) = IDISTEP
          ENDIF
          PLONINC = FLOAT( NOGRID(1) ) / PPMULT
          PLATINC = FLOAT( NOGRID(2) ) / PPMULT
C
C         Special handling for stretched fields
C
          IF( RISTRET.NE.0 ) THEN
            CALL JSLLGP( ZNFELDI, NIRESO, PNORTH, PSOUTH, PWEST, PEAST,
     X                   PLATINC, PLONINC, ZNFLDO, IERR)
C
          ELSE
            IF( LWIND ) THEN
              CALL JALLWN(ZNFELDI, NIRESO, PNORTH, PSOUTH, PWEST, PEAST,
     X                    PLATINC, PLONINC, ZNFLDO, IERR)
            ELSE
              CALL JALLGP(ZNFELDI, NIRESO, PNORTH, PSOUTH, PWEST, PEAST,
     X                    PLATINC, PLONINC, ZNFLDO, IERR)
            ENDIF
          ENDIF
C
          IF( IERR.NE.0 ) THEN
            CALL INTLOG(JP_ERROR,
     X        'INTFB: Interpolation to lat/long field failed.',JPQUIET)
            INTFB = JPROUTINE + 3
            GOTO 900
          ENDIF
C
          IF( LSTYLE ) THEN
            NOGRID(1) = HOLDEW
            NOGRID(2) = HOLDNS
          ENDIF
C
          GOTO 700
C
        ENDIF
C
C
        IF( NOREPR.EQ.JPGAUSSIAN ) THEN
C
C         -> regular gaussian grid
C
          CALL INTLOG(JP_DEBUG,'INTFB: SH -> regular gaussian.',JPQUIET)
C
C         Is it a user_regular_gaussian (or standard regular gaussian)..
C
          IF( LOGIVEL ) THEN
            HTYPE = 'U'
          ELSE
            HTYPE = 'F'
          ENDIF
C
C         Special handling for stretched fields
C
          IF( RISTRET.NE.0 ) THEN
            CALL JSGGGP( ZNFELDI, NIRESO, PNORTH, PSOUTH, PWEST, PEAST,
     X                   NOGAUSS, HTYPE, NOLPTS, ZNFLDO, IUV, IERR)
          ELSE
            CALL JAGGGP( ZNFELDI, NIRESO, PNORTH, PSOUTH, PWEST, PEAST,
     X                   NOGAUSS, HTYPE, NOLPTS, ZNFLDO, IUV, IERR)
C
          ENDIF
          IF( IERR .NE. 0 ) THEN
            CALL INTLOG(JP_ERROR,
     X        'INTFB: Interpolation to gaussian field failed.',JPQUIET)
            INTFB = JPROUTINE + 4
            GOTO 900
          ENDIF
C
          GOTO 700
C
        ENDIF
C
C
        IF( NOREPR.EQ.JPQUASI ) THEN
C
C         -> reduced gaussian grid
C
          CALL INTLOG(JP_DEBUG,'INTFB: SH -> quasi gaussian.',JPQUIET)
C
C         Is it a user_reduced_gaussian (or standard reduced gaussian)?
C
          IF( LOGIVEP ) THEN
            HTYPE = 'U'
          ELSE
            HTYPE = 'R'
          ENDIF
C
C         Special handling for stretched fields
C
          IF( RISTRET.NE.0 ) THEN
            CALL JSGGGP( ZNFELDI, NIRESO, PNORTH, PSOUTH, PWEST, PEAST,
     X                   NOGAUSS, HTYPE, NOLPTS, ZNFLDO, IUV, IERR)
          ELSE
            CALL JAGGGP( ZNFELDI, NIRESO, PNORTH, PSOUTH, PWEST, PEAST,
     X                   NOGAUSS, HTYPE, NOLPTS, ZNFLDO, IUV, IERR)
          ENDIF
          IF( IERR .NE. 0 ) THEN
            CALL INTLOG(JP_ERROR,
     X        'INTFB: Interpolation to quasi GG field failed.',JPQUIET)
            INTFB = JPROUTINE + 4
            GOTO 900
          ENDIF
C
          GOTO 700
C
        ENDIF
C
C       Dropthrough => unrecognized output field type
C
        IERR  = JPROUTINE + 1
        CALL INTLOG(JP_ERROR,
     X    'INTFB: Unrecognized output field type.',NOREPR)
        INTFB = IERR
        GOTO 900
C
      ENDIF
C
C     -----------------------------------------------------------------|
C     Section 5.   Interpolate Gaussian grid to grid point.
C     -----------------------------------------------------------------|
C
  500 CONTINUE
C
C       If Hirlam 12-point rotation involved, it has already been done
C       (in INTFAPH), so just copy values to array for packing.
C
        IF( LUSEHIR.AND.LNOROTA ) THEN
C
          ISIZE = ISCRSZ()
          IF( ISIZE.LE.0 ) THEN
            CALL INTLOG(JP_ERROR,
     X        'INTFB: Get scratch space fail',ISIZE)
            INTFB = JPROUTINE + 5
            GOTO 900
          ENDIF
          CALL JMEMHAN( 3, IZNFLDO, ISIZE, 1, IERR)
          IF( IERR.NE.0 ) THEN
            CALL INTLOG(JP_FATAL,
     X        'INTFB: Get scratch space failed',JPQUIET)
            INTFB = JPROUTINE + 5
            GOTO 900
          ENDIF
C
          DO LOOP = 1, ISIZE
            ZNFLDO(LOOP) = ZNFELDI(LOOP)
          ENDDO
          GOTO 700
        ENDIF
C
C     Handle ISLSCP processing
C
      IF( LNIISCL ) THEN
        CALL INTLOG(JP_DEBUG,'INTFB: Using ISLSCP processing',JPQUIET)
        IERR = INTISL(OLDLSM, INGRIB, NEWLSM, OUTGRIB)
        IF( IERR.LT.0 ) THEN
          CALL INTLOG(JP_ERROR,'INTFB: ISLSCP processing fail',NIGAUSS)
          INTFB = JPROUTINE + 10
          GOTO 900
        ENDIF
        OUTLEN = (IERR+JPBYTES-1)/JPBYTES
        GOTO 900
      ENDIF
C
C     Reduced gaussian to reduced gaussian
C
      LIQUASI = (NIREPR.EQ.JPQUASI)
C
      IF( (LIQUASI.AND.(NOREPR.EQ.JPQUASI)) ) THEN
        IF( LDOUBLE ) THEN
          CALL INTLOG(JP_DEBUG,'INTFB: RG to RG with intermediate'
     X    ,JPQUIET)
            IF(NIFORM.EQ.1)  THEN
               IERR = KRG2RGD(INGRIB,OUTGRIB,NOMEGA,NOGAUSS)
               IF(IERR.LT.0) THEN
                 CALL INTLOG(JP_ERROR,
     X             'INTFB: KRG2RGD processing failed',JPQUIET)
                 INTFB = JPROUTINE + 10
               ELSE
                 OUTLEN = (IERR+JPBYTES-1)/JPBYTES
               ENDIF
             ELSE
               CALL INTLOG(JP_DEBUG,
     X         'INTF: RG to RG intermediate unpacked',JPQUIET)
              IERR = KRG2RGZ(INGRIB,RWORK,NIGAUSS,NOMEGA)
              IF(IERR.LT.0) THEN
                CALL INTLOG(JP_ERROR,
     X            'INTFB: KRG2RGZ processing failed',JPQUIET)
                INTFB = JPROUTINE + 10
                GOTO 900
              ELSE
                OUTLEN = IERR
              ENDIF
C             Second step
              LDOUBLE = .FALSE.
              IERR = KRG2RGZ(RWORK,FLDOUT,NOMEGA,NOGAUSS)
              LDOUBLE = .TRUE.
              IF(IERR.LT.0) THEN
                CALL INTLOG(JP_ERROR,
     X            'INTFB: KRG2RGZ processing failed',JPQUIET)
                INTFB = JPROUTINE + 10
                GOTO 900
              ELSE
                OUTLEN = IERR
              ENDIF

             ENDIF
        ELSE
            IF(NIFORM.EQ.1)  THEN
              CALL INTLOG(JP_DEBUG,'INTFB: RG to RG packed',JPQUIET)
              IERR = KRG2RG(INGRIB,OUTGRIB,NOGAUSS)
              IF(IERR.LT.0) THEN
                CALL INTLOG(JP_ERROR,
     X            'INTFB: KRG2RG processing failed',JPQUIET)
                INTFB = JPROUTINE + 10
              ELSE
                OUTLEN = (IERR+JPBYTES-1)/JPBYTES
              ENDIF
            ELSE
              CALL INTLOG(JP_DEBUG,'INTFB: RG to RG unpacked',JPQUIET)
              IERR = KRG2RGU(INGRIB,FLDOUT,NIGAUSS,NOGAUSS)
              IF(IERR.LT.0) THEN
                CALL INTLOG(JP_ERROR,
     X            'INTFB: KRG2RGU processing failed',JPQUIET)
                INTFB = JPROUTINE + 10
              ELSE
                OUTLEN = IERR
              ENDIF
            ENDIF
        ENDIF
        GOTO 900
      ENDIF
C
C     Setup flags for input and output fields
C
      CALL INTLOG(JP_DEBUG,'INTFB: grid point -> grid point.',JPQUIET)
      KERR = 1
      IF( NIREPR .EQ. JPQUASI ) THEN
        CALL INTLOG(JP_DEBUG,'INTFB: quasi input ',NIGAUSS)
        IERR = IRSIZE( NIGAUSS, NIAREA, MILLEN, NIWE, NINS, KILN,
     X                 KITOTAL, RIGAUSS, OIWEGLOBE, OINPOLE, OISPOLE,
     X                 KPR, KERR)
      ELSE IF( NIREPR.EQ.JPGAUSSIAN ) THEN
        CALL INTLOG(JP_DEBUG,'INTFB: regular gauss input ',NIGAUSS)
        IERR = IGSIZE( NIGAUSS, NIAREA, NIWE, NINS, KILN, RIGAUSS,
     X                    OIWEGLOBE, OINPOLE, OISPOLE, KPR, KERR)
      ELSE
        CALL INTLOG(JP_DEBUG,'INTFB: lat/long input lat ',NIGRID(1))
        CALL INTLOG(JP_DEBUG,'INTFB: lat/long input long ',NIGRID(2))
        IERR = IGLSIZE( NIGRID, NIAREA, NIWE, NINS, KILN, OIWEGLOBE,
     X                  OINPOLE, OISPOLE, KPR, KERR)
      ENDIF
C
      NONS = 0
      NOWE = 0
      IF( (NOREPR.EQ.JPQUASI).OR.(NOREPR.EQ.JPQGGROT) ) THEN
        CALL INTLOG(JP_DEBUG,'INTFB: quasi output ',NOGAUSS)
        IERR = IRSIZE( NOGAUSS, NOAREA, NOLPTS, NOWE, NONS, KOLN,
     X                 KOTOTAL, ROGAUSS, OOWEGLOBE, OONPOLE, OOSPOLE,
     X                 KPR, KERR)
      ELSE IF( (NOREPR.EQ.JPGAUSSIAN).OR.(NOREPR.EQ.JPFGGROT) ) THEN
        CALL INTLOG(JP_DEBUG,'INTFB: regular gauss output ',NOGAUSS)
        IERR = IGSIZE( NOGAUSS, NOAREA, NOWE, NONS, KOLN, ROGAUSS,
     X                    OOWEGLOBE, OONPOLE, OOSPOLE, KPR, KERR)
      ELSE
        CALL INTLOG(JP_DEBUG,'INTFB: lat/long output lat ',NOGRID(1))
        CALL INTLOG(JP_DEBUG,'INTFB: lat/long output long ',NOGRID(2))
C
C       If dissemination style, space has to be for a 0.5x0.5 grid
C
        IF( LSTYLE ) THEN
          IF( NIREPR.EQ.JPQUASI ) THEN
             IF(NIGAUSS.EQ.640) THEN
                DISSRES = 0.125
             ELSEIF(NIGAUSS.EQ.400) THEN
                DISSRES = 0.25
             ELSEIF(NIGAUSS.EQ.320) THEN
                DISSRES = 0.25
             ELSEIF(NIGAUSS.EQ.200) THEN
                DISSRES = 0.5
             ELSEIF(NIGAUSS.EQ.160) THEN
                DISSRES = 0.5
             ELSEIF(NIGAUSS.EQ.128) THEN
                DISSRES = 0.5
             ELSEIF(NIGAUSS.EQ.96) THEN
                DISSRES = 1.
             ELSEIF(NIGAUSS.EQ.80) THEN
                DISSRES = 1.5
             ELSE
                DISSRES = JPDISTP
               CALL INTLOG(JP_WARN,'INTFB: Diss resol set to: ',
     X          NINT(DISSRES*PPMULT))
             ENDIF
            IDISTEP = NINT(DISSRES*PPMULT)
          ENDIF
          HOLDEW = NOGRID(1)
          HOLDNS = NOGRID(2)
          If (.Not.LNOROTA) Then ! D.Jokic; Mar-2005
          NOGRID(1) = IDISTEP
          NOGRID(2) = IDISTEP
          End if ! D.Jokic; Mar-2005
        ENDIF
        IERR = IGLSIZE( NOGRID, NOAREA, NOWE, NONS, KOLN, OOWEGLOBE,
     X                  OONPOLE, OOSPOLE, KPR, KERR)
      ENDIF
C
      IF( IERR.NE.0 ) THEN
        CALL INTLOG(JP_ERROR,
     X    'INTFB: Setup of gaussian field flags failed.',IERR)
        INTFB = JPROUTINE + 6
        GOTO 900
      ENDIF
C
C     -----------------------------------------------------------------|
C     Section 5.1  Interpolate reduced Gaussian grid to grid point.
C     -----------------------------------------------------------------|
C
  510 CONTINUE
C
      ISIZE = ISCRSZ()
      IF( ISIZE.LE.0 ) THEN
        CALL INTLOG(JP_ERROR,'INTFB: Get scratch space failed.',ISIZE)
        INTFB = JPROUTINE + 2
        GOTO 900
      ENDIF
C
      CALL JMEMHAN( 3, IZNFLDO, ISIZE, 1, IERR)
      IF( IERR.NE.0 ) THEN
        CALL INTLOG(JP_ERROR,'INTFB: Get scratch space failed.',JPQUIET)
        INTFB = JPROUTINE + 2
        GOTO 900
      ENDIF
C
      IF( NIREPR.EQ.JPQUASI ) THEN
C
C       If Hirlam 12-point rotation involved, it has already been done
C       (in INTFAPH), so just copy values to array for packing.
C
       IF( LUSEHIR.AND.LNOROTA ) THEN
         DO LOOP = 1, ISIZE
           ZNFLDO(LOOP) = ZNFELDI(LOOP)
         ENDDO
       ELSE
C        Sinisa - if double interpolation involved
        IF( LDOUBLE ) THEN
         IF( NOMEGA.EQ.NIGAUSS ) THEN
          CALL INTLOG(JP_DEBUG,
     X   'INTFB: Input and Intermed. Gaussian number are same',JPQUIET)
          CALL INTLOG(JP_DEBUG,
     X    'INTFB: Double interpolation is not performed',JPQUIET)
         ELSE
	        IF(NIFORM.EQ.1)  THEN
             CALL INTLOG(JP_DEBUG,
     X      'INTFB: RG2RG to unpacked - double interpolation',JPQUIET)
               IERR = KRG2RGY(INGRIB,RWORK,NOMEGA)
               IF(IERR.LT.0) THEN
                   CALL INTLOG(JP_ERROR,
     X               'INTFB: KRG2RGY processing failed',JPQUIET)
                   INTFB = JPROUTINE + 10
                   GOTO 900
               ELSE
                   LENMED = IERR
               ENDIF
            ELSE
               CALL INTLOG(JP_DEBUG,
     X          'INTFB: RG to RG intermediate unpacked',JPQUIET)
               IERR = KRG2RGZ(INGRIB,RWORK,NIGAUSS,NOMEGA)
               IF(IERR.LT.0) THEN
                 CALL INTLOG(JP_ERROR,
     X             'INTFB: KRG2RGZ processing failed',JPQUIET)
                 INTFB = JPROUTINE + 10
                 GOTO 900
               ELSE
                 LENMED = IERR
               ENDIF
            ENDIF
 
               DO LOOP = 1, LENMED
                 ZNFELDI(LOOP) = RWORK(LOOP)
               ENDDO
            IERR = FIXAREA()
            IF( IERR.NE.0 ) THEN
              CALL INTLOG(JP_ERROR,
     X          'INTFB: Fixup area definition failed. DI',JPQUIET)
              INTFB = JPROUTINE + 9
              GOTO 900
            ENDIF
            CALL INTLOG(JP_DEBUG,
     X           'INTFB: quasi input double interolation ',NIGAUSS)
             CALL JGETGG( NIGAUSS, 'R', RIGAUSS, MILLEN, IERR)
             IF ( IERR .NE. 0 ) THEN
               CALL INTLOG(JP_ERROR,
     X           'INTFB: JGETGG fail - double interpolation ',JPQUIET)
                INTFB = JPROUTINE + 10
               GOTO 900
             ENDIF

            IERR = IRSIZE( NIGAUSS, NIAREA, MILLEN, NIWE, NINS, KILN,
     X                 KITOTAL, RIGAUSS, OIWEGLOBE, OINPOLE, OISPOLE,
     X                 KPR, KERR)
         ENDIF
       ENDIF
C
C         If reduced gaussian to regular gaussian of same resolution,
C         turn off the land-sea mask processing temporarily
C
          LSAMERS = (NIGAUSS.EQ.NOGAUSS)
          LOLDLSM = LSM
          LOLDLSP = LSMPAR
          IF( (LIQUASI.AND.(NOREPR.EQ.JPGAUSSIAN).AND.LSAMERS) ) THEN
            CALL INTLOG(JP_DEBUG,
     X      'INTFB: turn off any LSM processing temporarily ', JPQUIET)
            LSM    = .FALSE.
            LSMPAR = .FALSE.
          ENDIF
          IERR = IARCNTL( ZNFELDI, JPEXPAND, ZNFLDO, ISIZE, KILN,
     X                    OIWEGLOBE, OINPOLE, OISPOLE, KOLN, OOWEGLOBE,
     X                    OONPOLE, OOSPOLE, KPR ,KERR)
          LSM    = LOLDLSM
          LSMPAR = LOLDLSP
          IF( IERR.NE.0 ) THEN
            CALL INTLOG(JP_ERROR,
     X        'INTFB: Interpolation from quasi GG field failed',JPQUIET)
            INTFB = JPROUTINE + 7
            GOTO 900
          ENDIF
C
          IF( LSTYLE ) THEN
            NOGRID(1) = HOLDEW
            NOGRID(2) = HOLDNS
          ENDIF
        ENDIF
C
        GOTO 700
C
      ENDIF
C
C     -----------------------------------------------------------------|
C*    Section 6.   Interpolate regular grid point to grid point.
C     -----------------------------------------------------------------|
C
  600 CONTINUE
C
      IERR = IAGCNTL( ZNFELDI, JPEXPAND, ZNFLDO, ISIZE, KILN,
     X                OIWEGLOBE, OINPOLE, OISPOLE, KOLN, OOWEGLOBE,
     X                OONPOLE, OOSPOLE, KPR, KERR)
      IF( IERR.NE.0 ) THEN
        CALL INTLOG(JP_ERROR,
     X    'INTFB: Interpolation from regular field failed.',JPQUIET)
        INTFB = JPROUTINE + 8
        GOTO 900
      ENDIF
C
      IF( LSTYLE ) THEN
        NOGRID(1) = HOLDEW
        NOGRID(2) = HOLDNS
      ENDIF


C     -----------------------------------------------------------------|
C*    Section 7.   Pack field into GRIB if necessary.
C     -----------------------------------------------------------------|
C
  700 CONTINUE
C
C     If dissemination 'style' selection has been chosen, select points.
C
      IF( LSTYLE ) THEN
        CALL DDSTYLE(ZNFLDO,IDISTEP,IDISTEP,NOGRID(1),NOGRID(2),IERR)
        IF( IERR.NE.0 ) THEN
         CALL INTLOG(JP_ERROR,
     X   'INTFB: Wrong requested grid increment for dissemination style'
     X    ,JPQUIET)
          INTFB = JPROUTINE + 3
          GOTO 900
        ENDIF
        NOWE = N_NOWE
        NONS = N_NONS
cs to check if it ruin gribex packing
        ISIZE = NOWE*NONS
      ENDIF
C
C     If a 'bitmap' has been specified, build the bitmap
C

        IF( LFRAME.OR.LBITMP.OR.LIMISSV ) THEN
          ISEC1(5) = 192
          ISEC3(2) = NINT(RMISSGV)
          ZSEC3(2) = RMISSGV
        ENDIF

      IF( LBITMP ) THEN
        IERR = MKBITMP(NOWE,NONS,ZNFLDO,RMISSGV)
        IF( IERR.NE.0 ) THEN
          CALL INTLOG(JP_ERROR,'INTFB: Problem applying bitmap',JPQUIET)
          INTFB = IERR
          GOTO 900
        ENDIF
      ENDIF
C
C     If a 'frame' has been specified, build the frame
C
      IF( LFRAME ) CALL MKFRAME(NOWE,NONS,ZNFLDO,RMISSGV,NOFRAME)

C
C     If the output is a GRIB product
C
      IF( NOFORM.EQ.1 ) THEN
        CALL INTLOG(JP_DEBUG,'INTFB: pack field for output',JPQUIET)
C
C       Setup GRIB sections for the output product
C
        IERR = IGSETUP( ISEC1, ISEC2, ISEC4 )
        IF( IERR.NE.0 ) THEN
          CALL INTLOG(JP_ERROR,'INTFB: Setup GRIB section fail',JPQUIET)
          INTFB = IERR
          GOTO 900
        ENDIF
C
C
C       If there are missing values, set all values to zero
C
        IF( NOMISS.NE.0 ) THEN
          DO LOOP = 1, ISEC2(2)*ISEC2(3)
            ZNFLDO(LOOP) = 0.0
          ENDDO
        ENDIF
C
C       Make adjustments for 'dissemination style'
C
        IF( LNOSTYLE.AND.(NOSTYLE.EQ.JPSDISM) ) THEN
C
C         Turn off use of ECMWF local definition
C
Cjdc      ISEC1(24) = 0
C
C         For regular lat/long or gaussian grids, calculate the grid
C         i-direction increment using truncation
C
          IF( (ISEC2(1).NE.50).AND.(ISEC2(1).NE.60).AND.
     X        (ISEC2(1).NE.70).AND.(ISEC2(1).NE.80) ) THEN
C
            IF( (ISEC2(1).NE.5).AND.(ISEC2(17).EQ.0) ) THEN
              IF( NOSTYLE.NE.JPSDISM)
     X          ISEC2(9) = (ISEC2(8) - ISEC2(5)) / (ISEC2(2) - 1)
            ENDIF
C
          ENDIF
C
        ENDIF
C
C       Code data into GRIB
C
        ILENF = ISIZE
        IERR = 1
C
C       If grid-point output, setup for 2nd order packing if requested.
C
        IF( (NOREPR.NE.JPSPHERE) .AND. (NOREPR.NE.JPSPHROT) ) THEN
          HFUNC = 'C'
          IF( NOHFUNC.EQ.'K' ) THEN
            HFUNC = 'K'
            ISEC4(4)  = 64
            ISEC4(6)  = 16
            ISEC4(9)  = 32
            ISEC4(10) = 16
            ISEC4(12) = 8
            ISEC4(13) = 4
            ISEC4(14) = 0
            ISEC4(15) = -1
C
C
            IF( NOREPR.EQ.JPQUASI ) THEN
C
C             Complex packing does not support sub-areas of reduced
C             gaussian grids. If output is reduced gaussian, check if
C             it is global to within a tolerance of 0.1 degrees.
C
              LGLOBAL = .TRUE.
              INORTH    = NINT( ROGAUSS(1) * PPMULT )
              IF( IABS(NOAREA(1)-INORTH).GT.1000) LGLOBAL = .FALSE.
              ISOUTH    = - INORTH
              IF( IABS(NOAREA(3)-ISOUTH).GT.1000) LGLOBAL = .FALSE.
              IF( NOAREA(2).NE.0 ) LGLOBAL = .FALSE.
              IEAST = JP360 - (JP90/NOGAUSS)
              IF( IABS(NOAREA(4)-IEAST).GT.1000) LGLOBAL = .FALSE.
C
C             Use simple packing if not global.
C
              IF( .NOT. LGLOBAL ) THEN
                HFUNC = 'C'
                ISEC4(4)  = 0
                ISEC4(6)  = 0
              ENDIF
            ENDIF
C
          ELSE IF( NOHFUNC.EQ.'S' ) THEN
            ISEC4(4)  = 0
            ISEC4(6)  = 0
          ENDIF
C
        ELSE
          HFUNC = 'C'
          IF( NOHFUNC.EQ.'C' ) THEN
            ISEC2(6) = 2
            ISEC4(4) = 64
          ELSE IF( NOHFUNC.EQ.'S' ) THEN
            ISEC2(6) = 1
            ISEC4(4) = 0
          ENDIF
        ENDIF
C
        IF( LIMISSV ) THEN
          ISEC1(5) = 192
          ISEC3(2) = NINT(RMISSGV)
          ZSEC3(2) = RMISSGV
        ENDIF
C
C       For interpolated regular lat/long field, flip latitudes if
C       they run from south to north
C       (handles special case , eg KWBC SST fields)
C
        IF( LNOGRID.AND.
     X      (NOREPR.EQ.JPREGULAR).AND.
     X      (NOAREA(1).LT.NOAREA(3)) ) THEN
C
          CALL INTLOG(JP_DEBUG,
     X      'INTFB: Flip latitudes to run North to South', JPQUIET)
          DO LOOP = 1, ISEC2(3)/2
            NEXT  = 1 + (LOOP - 1)*ISEC2(2)
            ISWAP = (ISEC2(3) - LOOP)*ISEC2(2) + 1
            DO LOOPI = 1, ISEC2(2)
              RTEMP = ZNFLDO(ISWAP)
              ZNFLDO(ISWAP) = ZNFLDO(NEXT)
              ZNFLDO(NEXT) = RTEMP
              NEXT  = NEXT + 1
              ISWAP = ISWAP + 1
            ENDDO
          ENDDO
        ENDIF
C
        CALL GRIBEX( ISEC0, ISEC1, ISEC2, ZSEC2, ISEC3, ZSEC3, ISEC4,
     X               ZNFLDO,ILENF,OUTGRIB,OUTLEN,IWORD,HFUNC,IERR)
        IF( IERR.NE.0 ) THEN
          CALL INTLOG(JP_ERROR,'INTFB: GRIBEX encoding failed.',IERR)
          INTFB = JPROUTINE + 5
          GOTO 900
        ENDIF
        OUTLEN = IWORD
C
C       Switch off use of missing value
C
        LIMISSV = .FALSE.
C
      ELSE
C
C       Otherwise, move unpacked values to user array
C
        DO LOOP = 1, ISIZE
          FLDOUT( LOOP ) = ZNFLDO( LOOP )
        ENDDO
C
C       and return the number of values, the unpacked array length
C
        OUTLEN = ISIZE
      ENDIF
C
C     -----------------------------------------------------------------|
C*    Section 9.   Closedown.
C     -----------------------------------------------------------------|
C
  900 CONTINUE
C
C     Clear change flags for next product processing
C
      LCHANGE = .FALSE.
      LSMCHNG = .FALSE.
C
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE CREXUPWT(KDD,KELEM,KERR)
C
C**** *CREXUPWT*
C
C
C     PURPOSE.
C     --------
C          Updates working tables setting element name,unit,scale,
C     reference value and data width.
C
C
C**   INTERFACE.
C     ----------
C
C          *CALL* *CREXUPWT(KDD,KELEM,KERR)*
C
C        INPUT :
C               *KDD*     -  data descriptor
C               *KELEM*   -  dimension of CNAMES, CUNITS array
C        OUTPUT:
C               *KERR*    -  return error code
C
C     METHOD.
C     -------
C
C          NONE.
C
C
C     EXTERNALS.
C     ----------
C
C          NONE.
C
C     REFERENCE.
C     ----------
C
C          NONE.
C
C     AUTHOR.
C     -------
C
C          MILAN DRAGOSAVAC    *ECMWF*       07/01/2004.
C
C
C     MODIFICATIONS.
C     --------------
C
C          NONE.
C
C
      IMPLICIT LOGICAL(L,O,G), CHARACTER*8(C,H,Y)
C
C
      PARAMETER(JSUP =   9,JSEC0=   3,JSEC1= 40,JSEC2= 64 ,JSEC3=    4,
     1          JSEC4=   2,JELEM=40000,JSUBS=400,JCVAL=150 ,JBUFL=40000,
     2          JBPW =  32,JTAB =3000,JCTAB=120,JCTST=1800,JCTEXT= 200,
     3          JWORK=360000,JKEY=46)
C
C
      COMMON /CREXWT/ NCREXDWINC,NCREXSCAM,NCREXAFDW,NCREXWT ,ODREPF,
     2               NCREXSTACK(JELEM),NCREXWTEN(JELEM),
     3               NCREXWTR (JELEM),NCREXWTS (JELEM),NCREXWTRV(JELEM),
     4               NCREXWTDW(JELEM),NWTIW(JELEM),NWTIWS(JELEM)
C
C             NCREXDWINC   -  data width increment
C             NCREXSCAM    -  scale multiplier
C             NCREXAFDW    -  augmented field data width
C             NCREXWT      -  pointer to working table
C             NCREXSTACK   -  list of data descriptors
C             ODREPF   -  replication (logical)
C             NCREXWTR     -  working table reference
C             NCREXWTS     -  working scale
C             NCREXWTRV    -  working reference value
C             NCREXWTDW    -  working data width
C             NWTIW    -  working data width of increments
C             NWTIWS   -  working total data width of element set
C
C
      COMMON /CREXWTC/ CREXWTEN(JELEM),CREXWTU (JELEM)
C
C             CREXWTEN    -  working table element naame
C             CREXWTU     -  working table units
C
C

      COMMON/CREXTAB/ NCREXBR(JTAB),NCREXBS(JTAB)    , NCREXBDW(JTAB),
     1                NCREXDR(JTAB),NCREXDST(JTAB)   ,
     2                NCREXDL(JTAB),NCREXDSQ(JTAB*20),NCREXP(64,255)

C
C             NCREXBR     - table B,  table reference              array
C             NCREXBS     - table B,  scale                        array
C             NCREXBDW    - table B,  data width                   array
C             NCREXDR     - table D,  table reference              array
C             NCREXDST    - table D,  starting pointers            array
C             NCREXDL     - table D,  lengths                      array
C             NCREXDSQ    - table D,  list of sequence descriptors array
C
C
C

       COMMON/CREXTABC/ CREXNAME(JTAB),CREXUNIT(JTAB),CREXLST(JELEM)
C
C             CREXNAME      -  table B, ELEMENT NAME           array
C             CREXUNIT      -  table B, unit                   array
C
C
      COMMON /CREXATB/  NJA,NCREXATBTR(JTAB),NCREXATBS (JTAB),
     1                  NCREXATBRV(JTAB),NCREXATBDW(JTAB)
C
C
C             NCREXATBTR      - augmented table B table reference
C             NCREXATBS       - augmented table B scale
C             NCREXATBRV      - augmented table B reference value
C             NCREXATBDW      - augmented table B data width
C
C
      COMMON /CREXATBC/ CREXATBEN(JTAB),CREXATBU (JTAB)
C
C             CREXATBEN      - augmented table B element name
C             CREXATBU       - augmented table B units
C
C
      COMMON /CREXBEF / M,MM,N,JCV
C
C             M       -  Number of elements
C             MM      -  Number of elements
C             N       -  Number of data sub_sets
C             JCV     -  Number of character values
C
      COMMON /CREXUT/ YUNIT,CUNITNAME,CIA5,CIA2,NCODE,NRECORDS
c
c             NCODE  - array containing unit code number
c             CUNITNAME - array containing unit name
c             CIA5 - array  containing unit CCITTIA5 name
c             CIA2 - array  containing unit CCITTIA2 name
c             NRECORDS - number of entries in the list
c
C
      COMMON /CREXWORK/ NBPT,NGS,NVIND,NBPTSEC2,RVIND,EPS,NE,IEOLD,
     1                  NC07YYY
C

      DIMENSION NCODE(JCTEXT)
      CHARACTER*30 CUNITNAME(JCTEXT)
      CHARACTER*24 CIA5(JCTEXT)
      CHARACTER*24 CIA2(JCTEXT)
      CHARACTER*24 YUNIT

C
      CHARACTER*64 CREXNAME, CREXATBEN
      CHARACTER*24 CREXATBU,CREXUNIT
      CHARACTER*6  CREXLST
C
      CHARACTER*64 CREXWTEN
      CHARACTER*24 CREXWTU
      CHARACTER YCH6*6
      REAL*8 RVIND
      REAL*8 EPS
C
C
C     ------------------------------------------------------------------
C*          1.   UPDATE WORKING TABLE.
C                ---------------------
 100  CONTINUE
C
      IF( KERR.NE.0 ) RETURN
C
      ICLASS=KDD/1000
      IYYY  =KDD-ICLASS*1000+1
      ICLASS=ICLASS+1
C
C*          1.1  ASSOCIATED FIELD ?
C                ------------------
 110  CONTINUE
C
      IF(NCREXAFDW.EQ.0) GO TO 140
C
C*          1.2  UNITS ELEMENT DESCRIPTOR ?
C                --------------------------
 120  CONTINUE
C
      I=NCREXP(ICLASS,IYYY)
      IF(I.EQ.0) THEN
         KERR=23
         PRINT*,'CREXUPWT : ',KDD
         CALL CREXERR(KERR)
         DO 1 IQ=1,JELEM
         NCREXSTACK(IQ)=0.
 1       CONTINUE
         RETURN
      end if
C
      IF(CREXUNIT(I)(1:4).EQ.'CODE') GO TO 140
      IF(CREXUNIT(I)(1:4).EQ.'FLAG') GO TO 140
      IF(CREXUNIT(I)(1:3).EQ.'NUM' ) GO TO 140
C
C*          1.3   ADD SPECIAL ENTRY TO WORKING TABLE.
C                 -----------------------------------
 130  CONTINUE
C
      NCREXWT=NCREXWT+1
      CREXWTEN(NCREXWT)='ASSOCIATED FIELD'
      CREXWTU (NCREXWT)=' '
      NCREXWTDW(NCREXWT)=NCREXAFDW
      NCREXWTR (NCREXWT)= 999999
      NCREXWTEN(NCREXWT)= 0
      NCREXWTS (NCREXWT)= 0
      NCREXWTRV(NCREXWT)= 0
      NCREXAFDW=0
C
C*                UPDATE CNAMES AND CUNITS
C
      M=M+1
      IF(M.GT.KELEM) THEN
         KERR=25
         PRINT*,'CREXUPWT:'
         CALL CREXERR(KERR)
         RETURN
      END IF
C
C     ------------------------------------------------------------------
C*          1.4   SEARCH AUGMENTED TABLE *B ENTRIES .
C                 -----------------------------------
 140  CONTINUE
C
C*          1.5  GET TABLE *B ENTRY .
C                ---------------------
 150  CONTINUE
C
      I=NCREXP(ICLASS,IYYY)
      IF(I.EQ.0) THEN
         KERR=23
         PRINT*,'CREXUPWT : ',KDD
         CALL CREXERR(KERR)
         DO 2 IQ=1,JELEM
         NCREXSTACK(IQ)=0.
 2       CONTINUE
         RETURN
      END IF
C
 155  CONTINUE
C
C     -----------------------------------------------------------------
C*          1.6   MODIFY ENTRY FOR OPERATOR IN FORCE.
C                 -----------------------------------
 160  CONTINUE
C
C*                ADD ENTRY TO WORKING TABLE.
C                 ---------------------------
      NCREXWT=NCREXWT+1
      NCREXWTR (NCREXWT) = KDD
      if(NCREXSCAM.ne.0) then
         NCREXWTS (NCREXWT) = NCREXSCAM
      else
         NCREXWTS (NCREXWT) = NCREXBS (I)
      end if
      NCREXSCAM=0
c
      NCREXWTRV(NCREXWT) = NCREXBR(I) 
      if(NCREXDWINC.ne.0) then
         NCREXWTDW(NCREXWT) = NCREXDWINC
      else
         NCREXWTDW(NCREXWT) = NCREXBDW(I)
      end if
      NCREXDWINC=0
      if(NCREXWTR (NCREXWT).eq.031002) then
         NCREXWTDW(NCREXWT)=4
         NCREXWTRV(NCREXWT) = 0
      end if
C
C     CHECK IF DATA ARE PRESENT IN DATA SECTION.
C
      if(NCREXWTR(NCREXWT).eq.31011.or.
     1   NCREXWTR(NCREXWT).eq.31012) then
         if(NCREXWTR(NCREXWT-1).eq.31011.or.
     2      NCREXWTR(NCREXWT-1).eq.31012) then
            NCREXWTDW(NCREXWT)=0
         end if
      end if
C
 175  CONTINUE
C
C     ------------------------------------------------------------------
C*          1.8  UPDATE M, CNAMES, CUNITS.
C                -------------------------
 180  CONTINUE
C
      CREXWTEN(NCREXWT) = CREXNAME(I)
      IF(NC07YYY.NE.0) THEN
         CREXWTU (NCREXWT) = YUNIT
         YUNIT=' '
         NC07YYY=0
      else
         CREXWTU (NCREXWT) = CREXUNIT(I)
      END IF
      NCREXWTEN(NCREXWT) = 0
      IF(CREXUNIT(I)(1:3).EQ.'CHA') NCREXWTEN(NCREXWT)=658367
C
       M = M + 1
       IF(M.GT.KELEM) THEN
          KERR=25
          PRINT*,'CREXUPWT:'
          CALL CREXERR(KERR)
          RETURN
       END IF
C
C     -----------------------------------------------------------------
C
 200  CONTINUE
C
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      INTEGER FUNCTION IGGRID (KGTRUNC, KAREA, KLN, PGAUSS, KLONG,
     1   KNWE, KLATG, KNNS, OWEGLOBE, KPR, KERR)
C
C---->
C**** *IGGRID*
C
C     PURPOSE
C     _______
C
C     Generate the arrays of latitude and longitude points for a
C     Gaussian truncation and area.
C
C     INTERFACE
C     _________
C
C     IERR = IGGRID (KGTRUNC, KAREA, KLN, PGAUSS, KLONG, KNWE, KLATG,
C    1   KNNS, OWEGLOBE, KPR, KERR)
C
C     Input parameters
C     ________________
C
C     KGTRUNC    - The Gaussian truncation.
C
C     KAREA      - The area definition (N, W, S, E) provided by the
C                  calling routine.
C
C     KLN        - The Northern Gaussian latitude number for this area.
C
C     PGAUSS     - The full list of Gaussian latitudes for this
C                  truncation.
C
C     KNWE       - The number of points in the West-East direction in
C                  this field.
C
C     KNNS       - The number of points in the North-South direction
C                  in this field.
C
C     OWEGLOBE   - This variable will be true if the array of
C                  longitudes spans the globe and it is an input grid.
C
C     KPR        - The debug print switch.
C                  0  , No debugging output.
C                  1  , Produce debugging output.
C
C     KERR       - The error control flag.
C                  -ve, No error message. Return error code.
C                  0  , Hard failure with error message.
C                  +ve, Print error message. Return error code.
C
C     Output parameters
C     ________________
C
C     KLONG      - The array of longitudes for this Gaussian
C                  truncation and area. If OWEGLOBE is true the
C                  West-East field array has element KNWE + 1 set
C                  equal to element 1 to help with recognising where
C                  an output grid "wraps around" the break in the
C                  input grid.
C
C     KLATG      - The array of latitudes for this Gaussian
C                  truncation and area.
C
C     Return value
C     ____________
C
C     The error indicator (INTEGER).
C
C     Error and Warning Return Values
C     _______________________________
C
C     None
C
C     Common block usage
C     __________________
C
C     None
C
C     EXTERNALS
C     _________
C
C     INTLOG(R)    - Logs messages.
C
C     METHOD
C     ______
C
C     The arrays KLONG and KLATG are generated using the information
C     provided by the other parameters. Note that Gaussian latitudes
C     will be stored as NINT (PGAUSS * 1.0E4).
C
C     REFERENCE
C     _________
C
C     None
C
C     COMMENTS
C     ________
C
C     Program contains sections 0 to 3 and 9
C
C     AUTHOR
C     ______
C
C     K. Fielding      *ECMWF*      Oct 1993
C
C     MODIFICATIONS
C     _____________
C
C     None
C
C----<
C     _______________________________________________________
C
C
C*    Section 0. Definition of variables.
C     _______________________________________________________
C
C*    Prefix conventions for variable names
C
C     Logical      L (but not LP), global or common.
C                  O, dummy argument
C                  G, local variable
C                  LP, parameter.
C     Character    C, global or common.
C                  H, dummy argument
C                  Y (but not YP), local variable
C                  YP, parameter.
C     Integer      M and N, global or common.
C                  K, dummy argument
C                  I, local variable
C                  J (but not JP), loop control
C                  JP, parameter.
C     REAL         A to F and Q to X, global or common.
C                  P (but not PP), dummy argument
C                  Z, local variable
C                  PP, parameter.
C
C     Implicit statement to force declarations
C
      IMPLICIT NONE
C
#include "parim.h"
C
C     Dummy arguments
      LOGICAL OWEGLOBE
      INTEGER KGTRUNC, KNWE, KNNS, KLN, KPR, KERR
      INTEGER KAREA (4)
      INTEGER KLONG (KNWE + 1), KLATG (KNNS)
      REAL PGAUSS (*)
C
C     Local variables
C
      INTEGER IEAST, IWEST
      INTEGER JLONG, JLAT
      REAL*8 RWEST, RKKK, RLNSTR
      INTEGER JPROUTINE
      PARAMETER (JPROUTINE = 24800)
C
C     Function externals
C
C     _______________________________________________________
C
C*    Section 1. Initialisation
C     _______________________________________________________
C
  100 CONTINUE
C
      IF (KPR.GE.1) CALL INTLOG(JP_DEBUG,'IGGRID: Section 1.',JPQUIET)
C
      IGGRID = 0
C
      IF (KPR .GE. 1) THEN
        CALL INTLOG(JP_DEBUG,'IGGRID: Input parameters.',JPQUIET)
        CALL INTLOG(JP_DEBUG,'IGGRID: Northern Gaussian line is ',KLN)
        CALL INTLOG(JP_DEBUG,'IGGRID: No.long.pts = ',KNWE)
        CALL INTLOG(JP_DEBUG,'IGGRID: No.lat. pts = ',KNNS)
        CALL INTLOG(JP_DEBUG,'IGGRID: Area North = ', KAREA(1))
        CALL INTLOG(JP_DEBUG,'IGGRID: Area West  = ', KAREA(2))
        CALL INTLOG(JP_DEBUG,'IGGRID: Area South = ', KAREA(3))
        CALL INTLOG(JP_DEBUG,'IGGRID: Area East  = ', KAREA(4))
        IF( OWEGLOBE ) THEN
          CALL INTLOG(JP_DEBUG,
     X      'IGGRID: Input W-E fld is global.',JPQUIET)
        ELSE
          CALL INTLOG(JP_DEBUG,
     X      'IGGRID: Input W-E fld is NOT global.',JPQUIET)
        ENDIF
      ENDIF
C
      IF(KNWE.GT.0.AND.OWEGLOBE) THEN
          RLNSTR = (REAL(JP360)*10000.0) / REAL(KNWE)
      ELSE
          RLNSTR = (REAL(JP90)*10000.0) / REAL(KGTRUNC)
      ENDIF

      IEAST = KAREA(JPEAST)
      IWEST = KAREA(JPWEST)
C
C     _______________________________________________________
C
C*    Section 2. Generate points around a line of latitude.
C     _______________________________________________________
C
  200 CONTINUE
C
      IF (KPR.GE.1) CALL INTLOG(JP_DEBUG,'IGGRID: Section 2.',JPQUIET)
C
C     Standardise range so that EAST > WEST
C
      IF (IEAST .LT. IWEST ) THEN
C
         IF (IEAST .LT. 0) THEN
            IEAST = IEAST + JP360
         ELSE
            IWEST = IWEST - JP360
         ENDIF
C
      ENDIF
C
      RWEST = REAL(IWEST)*10000.0
C
C     Generate points in standardised range (0, jp360)
C
      DO 210 JLONG = 1, KNWE
C
         RKKK = RWEST + RLNSTR * (JLONG - 1)
         KLONG (JLONG) = NINT(RKKK/10000.0)
C
         IF (KLONG (JLONG) .LT. 0) KLONG(JLONG) = KLONG(JLONG) + JP360
C
  210 CONTINUE
C
C     Add first point to end of list if global
C
      IF (OWEGLOBE) KLONG(KNWE + 1) = KLONG (1)
C
C     _______________________________________________________
C
C*    Section 3. Generate points along a line of meridian
C     _______________________________________________________
C
  300 CONTINUE
C
      IF (KPR.GE.1) CALL INTLOG(JP_DEBUG,'IGGRID: Section 3.',JPQUIET)
C
      DO 320 JLAT = 1, KNNS
C
         KLATG (JLAT) = NINT (PGAUSS (JLAT + KLN - 1) * PPMULT)
C
  320 CONTINUE
C
C     _______________________________________________________
C
C*    Section 9. Return to calling routine. Format statements
C     _______________________________________________________
C
  900 CONTINUE
C
      IF (KPR.GE.1) CALL INTLOG(JP_DEBUG,'IGGRID: Section 9.',JPQUIET)
C
      RETURN
      END

       SUBROUTINE MY_EXIT(K)
C
       IMPLICIT NONE
       INTEGER K
#ifdef __uxp__
C
C      VPP700 CALL TO SET EXIT NUMBER
       CALL SETRCD(K)
#endif
C
       CALL EXIT(K)
C
       RETURN
       END

C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

C---->
C
C     Functions used in ocean field interpolation.
C
C     FUNCTION INTDN(XVAL)
C
C     Rounds XVAL to the largest integer less than or equal to XVAL
C     ie truncates downwards rather than towards zero.
C
C     FUNCTION LENA(HSTRING)
C
C     Returns the length of a string, ignoring blank characters at end
C
C     FUNCTION HDEGS(RVAL)
C
C     Writes a real number into a string, in a way suitable for degs lat/long.
C     RVAL   The real number
C
C     FUNCTION HMETRES(RVAL)
C
C     Writes a real number into a string, in a way suitable for metres depth.
C     RVAL   The real number
C
C----<

      INTEGER FUNCTION INTDN(XVAL)
C
C   Rounds XVAL to the largest integer less than or equal to XVAL
C   ie truncates downwards rather than towards zero.
C
      IF((XVAL.GE.0.0).OR.(XVAL.EQ.FLOAT(INT(XVAL)))) THEN
         INTDN = INT(XVAL)
      ELSE
         INTDN = INT(XVAL) - 1
      ENDIF
      RETURN
      END

      INTEGER FUNCTION INTUP(XVAL)
C
C   Rounds XVAL to the largest integer greater than or equal to XVAL
C   ie truncates upwards rather than away from zero.
C
      IF(XVAL.EQ.FLOAT(INT(XVAL))) THEN
         INTUP=INT(XVAL)
      ELSEIF(XVAL.GE.0) THEN
         INTUP=INT(XVAL+1)
      ELSE
         INTUP=INT(XVAL)
      ENDIF
      RETURN
      END

      INTEGER FUNCTION LENA(HSTRING)
C
C   Returns the length of a string, ignoring blank characters at end
C
      CHARACTER*(*) HSTRING

      DO 100 J=LEN(HSTRING),1,-1
         IF(HSTRING(J:J).NE.' ') GOTO 150
  100 CONTINUE
      J=0
  150 CONTINUE
      LENA=J

      RETURN
      END

      FUNCTION HDEGS(RVAL)
C   Writes a real number into a string, in a way suitable for degs lat/long.
C     RVAL   The real number
C
      CHARACTER*6 HDEGS

      IF(RVAL.GE.0) THEN
         IF(RVAL.LT.10.0) THEN
            WRITE(HDEGS,'(F4.2)') RVAL
         ELSEIF(RVAL.LT.100.0) THEN
            WRITE(HDEGS,'(F4.1)') RVAL
         ELSEIF(RVAL.LT.1000.0) THEN
            WRITE(HDEGS,'(F5.1)') RVAL
         ELSE
            WRITE(HDEGS,'(F5.0)') RVAL
         ENDIF
      ELSE
         IF(RVAL.GT.-10.0) THEN
            WRITE(HDEGS,'(F5.2)') RVAL
         ELSEIF(RVAL.GT.-100.0) THEN
            WRITE(HDEGS,'(F5.1)') RVAL
         ELSEIF(RVAL.GT.-1000.0) THEN
            WRITE(HDEGS,'(F6.1)') RVAL
         ELSE
            WRITE(HDEGS,'(F6.0)') RVAL
         ENDIF
      ENDIF

      RETURN
      END


      FUNCTION HMETRES(RVAL)
C   Writes a real number into a string, in a way suitable for metres depth.
C     RVAL   The real number
C
      CHARACTER*6 HMETRES

      IF(RVAL.GE.0) THEN
         IF(RVAL.LE.9.99) THEN
            IF(INT(RVAL*10)*10.EQ.INT(RVAL*100)) THEN
               WRITE(HMETRES,'(F3.1)') RVAL
            ELSE
               WRITE(HMETRES,'(F4.2)') RVAL
            ENDIF
         ELSEIF(RVAL.LE.99.9) THEN
            WRITE(HMETRES,'(F4.1)') RVAL
         ELSEIF(RVAL.LE.999.0) THEN
            WRITE(HMETRES,'(F4.0)') RVAL
         ELSE
            WRITE(HMETRES,'(F5.0)') RVAL
         ENDIF
      ELSE
         IF(RVAL.GE.-9.99) THEN
            WRITE(HMETRES,'(F5.2)') RVAL
         ELSEIF(RVAL.GE.-99.9) THEN
            WRITE(HMETRES,'(F5.1)') RVAL
         ELSEIF(RVAL.GE.-999.0) THEN
            WRITE(HMETRES,'(F5.0)') RVAL
         ELSE
            WRITE(HMETRES,'(F6.0)') RVAL
         ENDIF
      ENDIF

      RETURN
      END

C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE EXTGRPC(KBUFL,YBUFF, I,K,CVAL,KERR )
C
C**** *EXTGRP*
C
C
C     PURPOSE.
C     --------
C         CONVERT GROUP IN THE REPORT
C         TO INTEGERS IN ARRAY 'KINT' .
C
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *EXTGRP(KBUFL,YBUFF, I,K,IVAL,KERR )
C
C                    kbufl - size of ybuff in bytes
C                    ybuff - character string
C
C                    I - CONVERSION OF GROUP STARTS IN WORD I
C                        OF ARRAY 'ybuff' .
C
C                    k - number of characters to convert
C
C
C
C     METHOD.
C     -------
C
C          NONE.
C
C
C     EXTERNALS.
C     ----------
C
C
C     REFERENCE.
C     ----------
C
C          NONE.
C
C     AUTHOR.
C     -------
C
C
C
C     MODIFICATIONS.
C     --------------
C
C          M. D. DRAGOSAVAC    *ECMWF*       15/09/2003.
C
C
      IMPLICIT LOGICAL(O,G)
C
      CHARACTER*(*) YBUFF , CVAL
C
C
C     ------------------------------------------------------------------
C*          1.   EXTRACT GROUP OF CHARACTERS.
C                ----------------------------
 100  CONTINUE
C
C
      CVAL=YBUFF(I:I+K-1)
C
      I=I+K
C
C
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C


      SUBROUTINE DECEXT (KBIT,PDATA,KDATA,KGRIB,KLENB,KI,KJ,KERR)
C
C---->
C***** DECEXT - Extract values from GRIB coded data.
C
C     Purpose.
C     --------
C
C           Return unpacked values for a series of grid points from an
C           array of packed grib data, without unpacking all values.
C
C**   Interface.
C     ----------
C
C           CALL DECEXT (KBIT,PDATA,KDATA,KGRIB,KLENB,KI,KJ,KERR)
C
C           INTEGER    K.
C           REAL       P.
C           LOGICAL    O.
C           CHARACTER  H.
C
C               Input parameters.
C               -----------------
C
C                 KBIT    - Number of bits in computer word
C
C                 PDATA   - Array to receive unpacked values.
C
C                 KDATA   - Size of array PDATA (number of grid points
C                           required).
C
C                 KGRIB   - Integer array containing data in grib code.
C
C                 KLENB   - Length of array KGRIB (in words).
C
C                 KI      - I indices of required grid points.
C                           (dimensioned KDATA).
C
C                 KJ      - J indices of required grid points.
C                           (dimensioned KDATA).
C
C
C               Output parameters.
C               ------------------
C
C                 PDATA(N) - Value of grid point KI(N),KJ(N)
C
C                 KERR     - 0 if no error.
C                            -1 If not grid point field.
C                            -2 If error in routine OFFSET.
C
C     Method.
C     -------
C
C           The self defining fields of section 0 - 3 of the GRIB code
C           are used to step down to the data part of section 4. The
C           reference value and scale factor are extracted and converted
C           The packed increments for the required
C           grid points are extracted and the values calculated.
C
C     Externals.
C     ----------
C
C           GBYTE
C           GBYTES
C           DECFP
C           OFFSET
C
C     Reference.
C     ----------
C
C           MARS User Guide for details of GRIB code and fields.
C
C     Comments.
C     ---------
C
C           Subroutine contains section 0 - 2 , and section 9.
C
C     Author.
C     -------
C
C           J. Hennessy      ECMWF     09/05/88
C
C     Modifications.
C     --------------
C
C           None
C
C     ------------------------------------------------------------------
C----<
C
C
C
C
C
C*    SECTION 0 . DEFINITION OF VARIABLES.
C     ------------------------------------------------------------------
C
      IMPLICIT LOGICAL     ( L , O , G )
      IMPLICIT CHARACTER*8 ( C , H , Y )
      IMPLICIT INTEGER     ( I , J , K , M , N)
C
      DIMENSION KGRIB(KLENB)
      DIMENSION PDATA(KDATA)
      DIMENSION KI(KDATA)
      DIMENSION KJ(KDATA)
      DIMENSION IB1PAR(18)
      DIMENSION IB2PAR(12)
      DIMENSION IBLOCK(24)
C
      EQUIVALENCE (ZGRIB,JGRIB)
C
C     SET MAXIMUM NUMBER OF BITS PER DATA FIELD.
C
      DATA IMAX /60/
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C*    SECTION 1 . SKIP DOWN THROUGH GRIB SECTION TO GET TO DATA SECTION.
C     ------------------------------------------------------------------
C
 1000 CONTINUE
      ZSCALE = 0.
C
C     BLOCK 0 - INDICATOR BLOCK.
C
C     SKIP 4 OCTETS CONTAINING ASCII G R I B .
C
      IWORD = 1
      IOFF  = 0
      IBYTE = 8
      IVAL  = 4
C
      CALL OFFSET (IOFF,IVAL,IWORD,IBYTE,KBIT,KLENB,KERR)
      IF (KERR.NE.0) GO TO 9000
C
C     BLOCK 1 - PRODUCT DEFINITION BLOCK.
C
C     EXTRACT FIRST 4 OCTETS OF BLOCK 1.
C
      IVAL  = 4
C
      CALL GBYTES (KGRIB(IWORD),IBLOCK(1),IOFF,IBYTE,0,IVAL)
      CALL OFFSET (IOFF,IVAL,IWORD,IBYTE,KBIT,KLENB,KERR)
      IF (KERR.NE.0) GO TO 9000
C
C     IF THESE OCTETS DO NOT CONTAIN 0, 0, 24 AND 0 RESPECTIVELY
C     THEN THE DATA IS IN THE OLD VERSION OF THE CODE.
C
      IF (IBLOCK(1).EQ.0.AND.IBLOCK(2).EQ.0.AND.IBLOCK(3).EQ.24.
     C    AND.IBLOCK(4).EQ.0)
     C      THEN
                ISNEW = 1
                IVAL = 20
            ELSE
                ISNEW = 0
                IVAL = 16
            ENDIF
C
C     EXTRACT NEXT 16 OR 20 OCTETS OF BLOCK 1 - NUMBER DEPENDS
C     ON VERSION OF CODE.
C
      CALL GBYTES (KGRIB(IWORD),IBLOCK(5),IOFF,IBYTE,0,IVAL)
      CALL OFFSET (IOFF,IVAL,IWORD,IBYTE,KBIT,KLENB,KERR)
      IF (KERR.NE.0) GO TO 9000
C
C     TRANSFER PRODUCT DEFINITION INFORMATION.
C
      DO 1100 J1100=1,17
         IB1PAR(J1100) = IBLOCK(J1100+4*ISNEW)
 1100 CONTINUE
C
C     BLOCK 2 - GRID DESCRIPTION BLOCK.
C
C     CHECK FLAG INDICATING IF BLOCK 2 IS INCLUDED IN CODE.
C
C     INC IS SET TO 1 , IF BLOCK 2 IS INCLUDED.
C
      INC = 0
C
C
      IF (ISNEW.EQ.0)
     C   THEN
C            OLD VERSION OF CODE
C
C            BLOCKS INCLUDED    BINARY VALUE      DECIMAL VALUE
C
C                NONE             00000000               0
C                 2               00000001               1
C                 3               00000010               2
C             2 AND 3             00000011               3
C
             IF (IB1PAR(4).EQ.1.OR.IB1PAR(4).EQ.3) INC = 1
         ELSE
C            NEW VERSION
C
C            BLOCKS INCLUDED    BINARY VALUE      DECIMAL VALUE
C
C                NONE             00000000               0
C                 2               10000000             128
C                 3               01000000              64
C             2 AND 3             11000000             192
C
             IF (IB1PAR(4).EQ.128.OR.IB1PAR(4).EQ.192) INC = 1
         ENDIF
C
      IF (INC.EQ.1)
     C   THEN
C
C
C            LENGTH OF GRID DESCRIPTION BLOCK.
C
             CALL GBYTE (KGRIB(IWORD),IBLK2,IOFF,24)
             CALL OFFSET (IOFF,1,IWORD,24,KBIT,KLENB,KERR)
             IF (KERR.NE.0) GO TO 9000
C
             ILENV = (IBLK2 - 32) / 4
C
C            NUMBER OF UNUSED BITS AND RESERVED BYTE SKIPPED.
C
             CALL OFFSET (IOFF,2,IWORD,8,KBIT,KLENB,KERR)
             IF (KERR.NE.0) GO TO 9000
C
C            DATA REPRESENTATION TYPE.
C
             CALL GBYTE (KGRIB(IWORD),IB2PAR(1),IOFF,8)
             CALL OFFSET (IOFF,1,IWORD,8,KBIT,KLENB,KERR)
             IF (KERR.NE.0) GO TO 9000
C
C            CHECK FOR GAUSSIAN OR LAT/LONG GRID.
C
             IF (IB2PAR(1).NE.0.AND.IB2PAR(1).NE.4)
     C          THEN
                    KERR = -1
                    GO TO 9000
                ENDIF
C
C            NUMBER OF LATITUDE AND LONGITUDE POINTS.
C
             CALL GBYTES (KGRIB(IWORD),IB2PAR(2),IOFF,16,0,2)
             CALL OFFSET (IOFF,2,IWORD,16,KBIT,KLENB,KERR)
             IF (KERR.NE.0) GO TO 9000
C
C            LAT/LONG OF ORIGIN SKIPPED.
C
             CALL OFFSET (IOFF,2,IWORD,24,KBIT,KLENB,KERR)
             IF (KERR.NE.0) GO TO 9000
C
C            RESOLUTION FLAG SKIPPED.
C
             CALL OFFSET (IOFF,1,IWORD,8,KBIT,KLENB,KERR)
             IF (KERR.NE.0) GO TO 9000
C
C            LAT/LONG OF EXTREME POINT SKIPPED.
C
             CALL OFFSET (IOFF,2,IWORD,24,KBIT,KLENB,KERR)
             IF (KERR.NE.0) GO TO 9000
C
C            DIRECTION INCREMENTS/ NO. OF LATITUDE LINES SKIPPED.
C
             CALL OFFSET (IOFF,2,IWORD,16,KBIT,KLENB,KERR)
             IF (KERR.NE.0) GO TO 9000
C
C            SCANNING MODE FLAG SKIPPED.
C
             CALL OFFSET (IOFF,1,IWORD,8,KBIT,KLENB,KERR)
             IF (KERR.NE.0) GO TO 9000
C
C            4 RESERVED OCTETS SKIPPED.
C
             CALL OFFSET (IOFF,4,IWORD,8,KBIT,KLENB,KERR)
             IF (KERR.NE.0) GO TO 9000
C
          ENDIF
C
C
C
C
C     BLOCK 3 - BIT MAP BLOCK.
C
C     INC IS SET TO 1 , IF BLOCK 3 IS INCLUDED.
C
      INC = 0
C
C
      IF (ISNEW.EQ.0)
     C   THEN
C            OLD VERSION OF CODE
C
C            BLOCKS INCLUDED    BINARY VALUE      DECIMAL VALUE
C
C                NONE             00000000               0
C                 2               00000001               1
C                 3               00000010               2
C             2 AND 3             00000011               3
C
             IF (IB1PAR(4).EQ.2.OR.IB1PAR(4).EQ.3) INC = 1
         ELSE
C            NEW VERSION
C
C            BLOCKS INCLUDED    BINARY VALUE      DECIMAL VALUE
C
C                NONE             00000000               0
C                 2               10000000             128
C                 3               01000000              64
C             2 AND 3             11000000             192
C
             IF (IB1PAR(4).EQ.64.OR.IB1PAR(4).EQ.192) INC = 1
         ENDIF
C
      IF (INC.EQ.1)
     C     THEN
               CALL GBYTE (KGRIB(IWORD),IBLK3,IOFF,24)
               CALL OFFSET (IOFF,IBLK3,IWORD,8,KBIT,KLENB,KERR)
               IF (KERR.NE.0) GO TO 9000
           ENDIF
C
C
C
C
C
C
C
C
C*    SECTION 2. EXTRACT PACKED INCREMENTS AND CALCULATE VALUES.
C     ------------------------------------------------------------------
C
 2000  CONTINUE
C
C     BLOCK 4 - BINARY DATA BLOCK.
C     SKIP LENGTH OF BINARY DATA BLOCK.
C
      CALL OFFSET (IOFF,1,IWORD,24,KBIT,KLENB,KERR)
      IF (KERR.NE.0) GO TO 9000
C
C
C     4 BIT FLAG / 4 BIT COUNT OF UNUSED BITS AT END OF BLOCK OCTET.
C
      CALL OFFSET (IOFF,1,IWORD,8,KBIT,KLENB,KERR)
      IF (KERR.NE.0) GO TO 9000
C
C
C     GET SCALE FACTOR
C
      CALL GBYTE (KGRIB(IWORD),JSCALE,IOFF,16)
      CALL OFFSET (IOFF,1,IWORD,16,KBIT,KLENB,KERR)
      IF (KERR.NE.0) GO TO 9000
C
      ISCALE = JSCALE
      IF (JSCALE.GE.32768)
     C    THEN
              ISCALE = ISCALE - 32768
              ISCALE = - ISCALE
          ENDIF
C
C
C
C
C     GET REFERENCE VALUE (FMIN) IN GRIB FORMAT (IEXP,IMANT)
C
C
      CALL GBYTE (KGRIB(IWORD),IEXP,IOFF,8)
      CALL OFFSET (IOFF,1,IWORD,8,KBIT,KLENB,KERR)
      IF (KERR.NE.0) GO TO 9000
      CALL GBYTE (KGRIB(IWORD),IMANT,IOFF,24)
      CALL OFFSET (IOFF,1,IWORD,24,KBIT,KLENB,KERR)
      IF (KERR.NE.0) GO TO 9000
C
C
C     CHECK FOR MISSING DATA INDICATORS.
C
      IMISS = 0
      IF (JSCALE.EQ.65535.AND.IEXP.EQ.255.AND.IMANT.EQ.16777215)
     C   IMISS = 1
C
C     CONVERT REFERENCE VALUE AND SCALE FACTOR.
C
      IF (IMISS.EQ.0)
     C   THEN
             CALL DECFP (FMIN,IEXP,IMANT)
             ZSCALE = 2.**ISCALE
         ENDIF
C
C
C
C
C     GET NUMBER OF BITS IN EACH DATA VALUE.
C
      CALL GBYTE (KGRIB(IWORD),IBITS,IOFF,8)
      CALL OFFSET (IOFF,1,IWORD,8,KBIT,KLENB,KERR)
      IF (KERR.NE.0) GO TO 9000
C
C
C     CHECK NUMBER OF BITS PER DATA FIELD.
C
      IF (IBITS.GT.KBIT.OR.IBITS.GT.IMAX)
     C    THEN
              KERR = -1
              WRITE (*,9001) IBITS,KBIT,IMAX
              GO TO 9000
          ENDIF
C
C
C
C
C     DECODE DATA VALUES TO FLOATING POINT.
C
      IPW = IWORD
      IPB = IOFF
C
      DO 2100 J2100 = 1,KDATA
         IWORD = IPW
         IOFF  = IPB
         ILENF = (KI(J2100)-1) * IB2PAR(2) + KJ(J2100) - 1
         CALL OFFSET (IOFF,ILENF,IWORD,IBITS,KBIT,KLENB,KERR)
         IF (KERR.NE.0) GO TO 9000
         CALL GBYTE (KGRIB(IWORD),IDATA,IOFF,IBITS)
         PDATA(J2100)  = FMIN + IDATA * ZSCALE
 2100 CONTINUE
C
      IF (IMISS.EQ.0) GO TO 9000
C
      DO 2200 J2200 = 1,KDATA
         PDATA(J2200)  = 0.0
 2200 CONTINUE
C
C
C
C*    SECTION 9. FORMAT STATEMENTS. RETURN.
C     ------------------------------------------------------------------
C
 9000 CONTINUE
C
 9001 FORMAT (1H ,'NUMBER OF BITS PER DATA VALUE, ',I3,
     C        'EXCEEDS WORD LENGTH, ',I3,' OR MAXIMUM ',
     C        ' PERMITTED VALUE, ',I3)
      RETURN
C
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C


      SUBROUTINE PRTBK1 (IB1PAR)
C
C---->
C
C     NAME      : PRTBK1
C
C     FUNCTION  : PRINT THE INFORMATION IN THE PRODUCT DEFINITION
C                 BLOCK (BLOCK 1) OF DECODED GRIB DATA.
C
C     INPUT     : IB1PAR - ARRAY OF DECODED PARAMETERS FROM BLOCK 1.
C
C     OUTPUT    : FLAG FIELDS ARE PRINTED IN BINARY REPRESENTATION.
C                 OTHER FIELDS AS INTEGERS.
C
C     JOHN HENNESSY  ECMWF OCTOBER 1985
C
C      Modifications.
C      --------------
C            J. Hennessy   ECMWF 23:11:90
C            Printed output changed from all upper-case.
C
C     ---------------------------------------------------------------
C----<
C
      IMPLICIT INTEGER (A-Z)
C
      DIMENSION IB1PAR(*)
C
      WRITE (*,'(1H )')
      WRITE (*,9000)
 9000 FORMAT (1H ,'Section 1 - Product definition section.')
C
      WRITE (*,'(1H )')
      WRITE (*,9001) IB1PAR(1)
 9001 FORMAT (1H ,'Originating centre identifier.       ',I9)
      WRITE (*,9002) IB1PAR(2)
 9002 FORMAT (1H ,'Model identification.                ',I9)
      WRITE (*,9003) IB1PAR(3)
 9003 FORMAT (1H ,'Grid definition.                     ',I9)
      NBIT = 8
      CALL PRTBIN (IB1PAR(4),NBIT,OUT,ERR)
      WRITE (*,9004) OUT
 9004 FORMAT (1H ,'Flag (Code Table 1)                   ',I8.8)
      WRITE (*,9005) IB1PAR(5)
 9005 FORMAT (1H ,'Parameter identifier (Code Table 2). ',I9)
      WRITE (*,9006) IB1PAR(6)
 9006 FORMAT (1H ,'Type of level (Code Table 3).        ',I9)
      WRITE (*,9007) IB1PAR(7)
 9007 FORMAT (1H ,'Value 1 of level (Code Table 3).     ',I9)
      WRITE (*,9008) IB1PAR(8)
 9008 FORMAT (1H ,'Value 2 of level (Code Table 3).     ',I9)
      WRITE (*,9009) IB1PAR(9)
 9009 FORMAT (1H ,'Year of reference time of data.      ',I9)
      WRITE (*,9010) IB1PAR(10)
 9010 FORMAT (1H ,'Month of reference time of data.     ',I9)
      WRITE (*,9011) IB1PAR(11)
 9011 FORMAT (1H ,'Day of reference time of data.       ',I9)
      WRITE (*,9012) IB1PAR(12)
 9012 FORMAT (1H ,'Hour of reference time of data.      ',I9)
      WRITE (*,9013) IB1PAR(13)
 9013 FORMAT (1H ,'Minute of reference time of data.    ',I9)
      WRITE (*,9014) IB1PAR(14)
 9014 FORMAT (1H ,'Time unit (Code Table 4).            ',I9)
      WRITE (*,9015) IB1PAR(15)
 9015 FORMAT (1H ,'Time range one.                      ',I9)
      WRITE (*,9016) IB1PAR(16)
 9016 FORMAT (1H ,'Time range two.                      ',I9)
      WRITE (*,9017) IB1PAR(17)
 9017 FORMAT (1H ,'Time range indicator (Code Table 5)  ',I9)
      WRITE (*,9018) IB1PAR(18)
 9018 FORMAT (1H ,'Number averaged.                     ',I9)
C
      RETURN
C
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE ECDEF6( HFUNC, KSEC1, KGRIB, KLENG, KNSPT, KBITS,
     X                   KPLEN, KPR, KRET)
C
C---->
C**** ECDEF6
C
C     Purpose.
C     --------
C
C     GRIB coding/decoding of ECMWF local use definition 1.
C
C**   Interface.
C     ----------
C
C     CALL ECDEF6( HFUNC, KSEC1, KGRIB, KLENG, KNSPT, KBITS, KPLEN,
C    X             KPR, KRET)
C
C
C     Input Parameters.
C     -----------------
C
C     HFUNC      - Requested function.
C                  'C' to code data.
C                  'D' to decode data.
C
C     KSEC1      - Array containing Grib Section 1 data.
C
C     KGRIB      - Array containing Grib coded data.
C
C     KLENG      - Length (words) of KGRIB.
C
C     KNSPT      - Bit number after which insertion/extraction starts.
C
C     KBITS      - Number of bits in computer word.
C
C     KPLEN      - Pointer to field containing length of Section 1.
C
C     KPR        - Debug print switch.
C                  0  , No printout.
C                  >0 , Debug printout.
C
C     KRET       - Response to error indicator.
C                  0        , Abort if error encountered.
C                  Non-zero , Return to calling routine
C                             even if error encountered.
C
C     Output Parameters.
C     ------------------
C
C     KSEC1      - Array containing Grib Section 1 data.(Updated)
C
C     KGRIB      - Array containing Grib coded data.(Updated)
C
C     KNSPT      - Number of bit after last one inserted/extracted.(Updated)
C
C     KRET       - Return code.
C                  0   , No error encountered.
C                  2   , Error reported by routine INXBIT.
C
C
C     Method.
C     -------
C
C     Input data packed/unpacked in accordance with ECMWF usage of
C     local part of section 1 of Grib code, definition 1.
C
C
C     Externals.
C     ----------
C
C     INXBIT
C     ABORTX
C     CSGNBT
C     DSGNBT
C
C
C     Reference.
C     ----------
C
C     WMO Manual On Codes for Grib Code.
C
C
C     Comments.
C     ---------
C
C     Adapted from ECLOC1.F - simplified to handle just definition 1.
#include "ecdef6.h"
C
C
C     Author.
C     -------
C
C     J.D.Chambers     ECMWF       27th February 1996
C
C
C     Modifications.
C     --------------
C
C     None.
C
C
C----<
C     ------------------------------------------------------------------
C*    Section 0 . Definition of variables. Data statements.
C     ------------------------------------------------------------------
C
      IMPLICIT NONE
C
#include "common/grprs.h"
C
C     Parameters
      CHARACTER*1   HFUNC
      INTEGER KSEC1, KGRIB, KLENG, KNSPT, KBITS, KPLEN, KPR, KRET
      DIMENSION KGRIB(*)
      DIMENSION KSEC1(*)
C
C     Local variables
      INTEGER IRET, IZERO, ILOOP, LENS1, INDATE
C
      LOGICAL LENCODE
C
C     ------------------------------------------------------------------
C*    Section 1 . Set initial values.
C     ------------------------------------------------------------------
C
  100 CONTINUE
C
      IRET = KRET
      LENCODE = ( HFUNC .EQ. 'C' )
C
C     ------------------------------------------------------------------
C*    Section 2 . Handle definition 1.
C     ------------------------------------------------------------------
C
  200 CONTINUE
C
C     Octet 50-51 :Reserved.
C     Should be 0 !!
C
      IF ( LENCODE ) THEN
        IZERO = 0
        CALL INXBIT(KGRIB,KLENG,KNSPT,IZERO, 1,KBITS, 16,HFUNC,KRET)
        IF (KRET.NE.0) THEN
          KRET = 2
          WRITE(GRPRSM,9004)
        ENDIF
      ELSE
        CALL INXBIT(KGRIB,KLENG,KNSPT,KSEC1(42),2,KBITS,8,HFUNC,KRET)
        IF (KRET.NE.0) THEN
          KRET = 2
          WRITE(GRPRSM,9004)
        ENDIF
      ENDIF
C
C     Octet 52-54 : YYMMDD date of the SST field used.
C
      IF( LENCODE) THEN
        INDATE = KSEC1(44)
        IF( INDATE.GT.19000000 ) INDATE = INDATE - 19000000
      ENDIF
      CALL INXBIT(KGRIB,KLENG,KNSPT,INDATE,1,KBITS,24,HFUNC,KRET)
      IF (KRET.NE.0) THEN
        KRET = 2
        WRITE(GRPRSM,9004)
      ENDIF
      IF( .NOT. LENCODE) THEN
        IF( (INDATE.LT.19000000).AND.(INDATE.GT.100) )
     X    INDATE = INDATE + 19000000
        KSEC1(44) = INDATE
      ENDIF
C
C     Octet 55 : Type of SST field used.
C
      CALL INXBIT(KGRIB,KLENG,KNSPT,KSEC1(45), 1,KBITS, 8,HFUNC,KRET)
      IF (KRET.NE.0) THEN
        KRET = 2
        WRITE(GRPRSM,9004)
      ENDIF
C
C     Octet 56 : Count of ICE fields used (n, say).
C
      CALL INXBIT(KGRIB,KLENG,KNSPT,KSEC1(46), 1,KBITS, 8,HFUNC,KRET)
      IF (KRET.NE.0) THEN
        KRET = 2
        WRITE(GRPRSM,9004)
      ENDIF
C
C     Octet 57->54+(n*4) : YYMMDD dates and satellite numbers of the
C                          ICE fields used.
C
      DO 210 ILOOP = 1, KSEC1(46)
C
C       YYMMDD date.
        IF( LENCODE) THEN
          INDATE = KSEC1(45+(ILOOP*2))
          IF( INDATE.GT.19000000 ) INDATE = INDATE - 19000000
        ENDIF
        CALL INXBIT(KGRIB,KLENG,KNSPT,INDATE,1,KBITS,24,HFUNC,KRET)
        IF (KRET.NE.0) THEN
          KRET = 2
          WRITE(GRPRSM,9004)
        ENDIF
        IF( .NOT. LENCODE) THEN
          IF( (INDATE.LT.19000000).AND.(INDATE.GT.100) )
     X      INDATE = INDATE + 19000000
          KSEC1(45+(ILOOP*2)) = INDATE
        ENDIF
C
C       Satellite number (ICE data).
C
        CALL INXBIT(KGRIB,KLENG,KNSPT,KSEC1(46+(ILOOP*2)),
     X              1,KBITS, 8,HFUNC,KRET)
        IF (KRET.NE.0) THEN
          KRET = 2
          WRITE(GRPRSM,9004)
        ENDIF
C
  210 CONTINUE
C
C     On encoding, adjust length of section 1.
      IF( LENCODE ) THEN
        LENS1 = 56 + KSEC1(46)*4
        CALL INXBIT(KGRIB,KLENG,KPLEN,LENS1, 1,KBITS,24,HFUNC,KRET)
        IF (KRET.NE.0) THEN
          KRET = 2
          WRITE(GRPRSM,9004)
        ENDIF      
      ENDIF
C
C     ------------------------------------------------------------------
C*    Section 9 . Abort/return to calling routine. Format statements.
C     ------------------------------------------------------------------
C
  900 CONTINUE
C
      IF( KPR.GE.1 ) THEN
        WRITE(GRPRSM,*) 'ECDEF6 : Section 9.'
        WRITE(GRPRSM,*) '         Output values set -'
        WRITE(GRPRSM,*) '         KNSPT  = ', KNSPT
      ENDIF
C
C     Abort if requested to do so when an error has been encountered.
C
      IF (IRET.EQ.0.AND.KRET.NE.0) THEN
        CALL ABORTX ('ECDEF6')
      ELSE
        RETURN
      ENDIF
C
C
 9004 FORMAT (' ECDEF6: Error reported by routine INXBIT.')
C
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

C
      COMMON /BCOMP/ INWTEN(JELEM),INWTR (JELEM),INWTS (JELEM),
     1                INWTRV (JELEM),INWTDW(JELEM),
     2                INWORDP(JWORK),INBITP(JWORK)
C             INWTEN   -  WOKING TABLE
C             INWTR     -  WORKING TABLE REFERENCE
C             INWTS     -  WORKING SCALE
C             INWTRV    -  WORKING REFERENCE VALUE
C             INWTDW    -  WORKING DATA WIDTH

      subroutine psizes(s)
      character*(*) s
      character*(1) c1
      character*(1) c2
      integer len
      integer i
      real    r
      inquire(iolength=len) r
      c1 = char(len)
      inquire(iolength=len) i 
      c2 = char(len)
      s = c1 // c2
      end subroutine

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE GRSX2O ( KEXT2O )
C
C---->
C**** GRSX2O - controls use of eXTended 2nd-Order packing methods
C              for routine GRIBEX.
C
C     Purpose.
C     --------
C
C     Extended 2nd-order methods switch set on or off
C     for routine GRIBEX.
C
C
C**   Interface.
C     ----------
C
C     CALL GRSX2O ( KEXT2O )
C
C
C     Input Parameter.
C     ----------------
C
C     KEXT2O  - Extended 2nd-order methods switch flag,
C               = 0 ,        not allowed (default)
C               = Non-zero , extended methods allowed.
C
C        (Use for grid-point encoding, HOPER='C' and 'K' functions)
C
C     Output Parameters.
C     ------------------
C
C     None.
C
C
C     Method.
C     -------
C
C     The variable NEXT2O is set in the common area. All other
C     parameters are also set to default values, if they have
C     not already been set by the user.
C
C
C     Externals.
C     ----------
C
C     GRSDEF - Default setting of global variables.
C
C
C     Reference.
C     ----------
C
C     See subroutine GRIBEX.
C
C
C     Comments.
C     ---------
C
C     None.
C
C
C     Author.
C     -------
C
C     J. Clochard, Meteo France, for ECMWF - January 1998.
C
C
C     Modifications.
C     --------------
C
C     J. Clochard, Meteo France, for ECMWF - June 1999.
C     Use a static variable to determine if initialisation of
C     default values has already been done for common area variables.
C
C
C----<
C     ----------------------------------------------------------------
C*    Section 0 . Definition of variables.
C     ----------------------------------------------------------------
C
      IMPLICIT NONE
C
#include "grbcom.h"
C
C     Subroutine arguments.
      INTEGER KEXT2O
C
C     Local variables.
      INTEGER IEXT2O
C
      LOGICAL LFIRST
      SAVE LFIRST
C
      DATA LFIRST / .TRUE. /
C
C     ----------------------------------------------------------------
C*    Section 1 . Set values.
C     ----------------------------------------------------------------
C
  100 CONTINUE
C
      IEXT2O = 0
      IF (KEXT2O.NE.0) IEXT2O = 1
C
      IF (LFIRST) THEN
C
C       Common area variables may have not been set, so start by
C       trying to set default values.
C
        CALL GRSDEF
        LFIRST=.FALSE.
C
      ENDIF
C
C       Set exhaustive 2nd-order aggressive packing switch
C       to required value.
C
      NEXT2O   = IEXT2O
C
C     ----------------------------------------------------------------
C*    Section 9 . Return to calling routine.
C     ----------------------------------------------------------------
C
  900 CONTINUE
C
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities
C granted to it by virtue of its status as an intergovernmental organisation
C nor does it submit to any jurisdiction.
C

      SUBROUTINE GGINTRP(NEWFLD,NEXT,INROW,OLAT,OLON,NGAUSS,HTYPE,FIELD)
C
C---->
C**** GGINTRP
C
C     PURPOSE
C     _______
C
C     Finds values at the points of a row by interpolation within a
C     gaussian field.
C
C     INTERFACE
C     _________
C
C     CALL GGINTRP(NEWFLD,NEXT,INROW,OLAT,OLON,NGAUSS,HTYPE,FIELD)
C
C
C     Input parameters
C     ________________
C
C     NEWFLD   - The field of values being created
C     NEXT     - Start offset of the latitude row being created
C     INROW    - The number of points in the latitude row
C     OLAT     - Latitude of target point
C     OLON     - Longitude of target point
C     FIELD    - Original gaussian field
C     NGAUSS   - Gaussian field number
C     HTYPE    - Gaussian grid type (original, unrotated)
C                = 'R' for reduced ("quasi-regular") Gaussian field,
C                = 'O' for reduced/octahedral Gaussian field,
C                = 'F' for full (regular) gaussian field
C
C     Output parameters
C     ________________
C
C     NEWFLD(NEXT) to NEWFLD(NEXT+INROW-1) contains the latitude row
C     values.
C
C
C     METHOD
C     ______
C
C     Uses distance weighted values of 4 neighbouring points unless
C     within small distance of one of the neighbours, in which case
C     the value at that point is used.
C
C
C     EXTERNALS
C     _________
C
C     JGETGG  - Gets gaussian grid definition.
C     JMKOFGG - Builds offsets to start of each latitude row in the
C               gaussian grid.
C     JNORSGG - Find nearest north/south latitude in the gaussian grid.
C     INTLOG  - Logs output messages
C
C
C     REFERENCE
C     _________
C
C     None.
C
C
C     COMMENTS
C     ________
C
C     Some loops have been split and simplified to help with
C     vectorisation on VPP.
C
C
C     AUTHOR
C     ______
C
C     J.D.Chambers      ECMWF       April 1996
C
C
C     MODIFICATIONS
C     _____________
C
C     None.
C
C----<
C     _______________________________________________________
C
C*    Section 0. Definition of variables.
C     _______________________________________________________
C
      IMPLICIT NONE
C
#include "parim.h"
C
C     Parameters
C
      INTEGER JPFACTR, JPMAXGG
      PARAMETER( JPFACTR = 10000 )
      PARAMETER( JPMAXGG = 4096 )
      REAL JPEPS
      PARAMETER( JPEPS = 1E-2)
C
C     Function arguments
C
      REAL NEWFLD, OLAT, OLON, FIELD
      DIMENSION NEWFLD(*), OLAT(*), OLON(*), FIELD(*)
      INTEGER NEXT, INROW, NGAUSS
      CHARACTER*1 HTYPE
C
C     Local variables
C
      INTEGER LOOP, IVALUE
      INTEGER NORTH, SOUTH, IWESTN, IWESTS, IEASTN, IEASTS
      REAL NSTEP, SSTEP, PEAST
      DIMENSION NORTH(JPMAXGG), SOUTH(JPMAXGG)
      DIMENSION IWESTN(JPMAXGG), IWESTS(JPMAXGG)
      DIMENSION IEASTN(JPMAXGG), IEASTS(JPMAXGG)
      DIMENSION NSTEP(JPMAXGG), SSTEP(JPMAXGG)
      REAL DNORTH, DSOUTH, DWESTN, DWESTS, DEASTN, DEASTS
      DIMENSION DNORTH(JPMAXGG), DSOUTH(JPMAXGG)
      DIMENSION DWESTN(JPMAXGG), DWESTS(JPMAXGG)
      DIMENSION DEASTN(JPMAXGG), DEASTS(JPMAXGG)
      REAL GLATS(JPMAXGG/2)
      INTEGER NGPTS(JPMAXGG/2)
      INTEGER KOFSET(JPMAXGG/2)
      INTEGER KRET, OLDGAUS
      DATA OLDGAUS/0/
      CHARACTER*1 OLDTYPE
      DATA OLDTYPE/' '/
      SAVE OLDGAUS, OLDTYPE, GLATS, NGPTS, KOFSET
C
C     Externals
C
      INTEGER JNORSGG
      EXTERNAL JNORSGG
C
C     Statement function
C
      INTEGER X, Y
      REAL OFIELD
      OFIELD(X,Y) = FIELD(KOFSET(X)+Y)
C
C     _______________________________________________________
C
C*    Section 1. Initialization.
C     _______________________________________________________
C
  100 CONTINUE
C
C     Get gaussian grid definition (first time only)
C
      IF ( (OLDGAUS.NE.NGAUSS).OR.(OLDTYPE.NE.HTYPE) ) THEN
C
        CALL INTLOG(JP_DEBUG,
     X    'GGINTRP: Get gaussian grid type:',JPQUIET)
        CALL INTLOG(JP_DEBUG,HTYPE,JPQUIET)
        CALL INTLOG(JP_DEBUG, 'GGINTRP: grid number:',NGAUSS)
C
        CALL JGETGG(NGAUSS,HTYPE,GLATS,NGPTS,KRET)
        IF( KRET.NE.0 ) THEN
          CALL INTLOG(JP_ERROR,
     X      'GGINTRP: Failed to get gaussian grid definition:',JPQUIET)
          CALL INTLOG(JP_ERROR, 'GGINTRP: grid type:',JPQUIET)
          CALL INTLOG(JP_ERROR, HTYPE,JPQUIET)
          CALL INTLOG(JP_ERROR, 'GGINTRP: grid number:',NGAUSS)
          CALL ABORTX ('GGINTRP')
        ENDIF
C
C       Build array of offsets in field to start of each latitude line
C
        CALL INTLOG(JP_DEBUG,'GGINTRP: Build row offsets',JPQUIET)
        IF( HTYPE.EQ.'R' .OR. HTYPE.EQ.'r' .OR.
     X      HTYPE.EQ.'O' .OR. HTYPE.EQ.'o' .OR.
     X      HTYPE.EQ.'U' .OR. HTYPE.EQ.'u' ) THEN
C         (this value will not be used by JMKOFGG)
          PEAST = 360.
        ELSE
          PEAST = 360. - (90./NGAUSS)
        ENDIF
        CALL JMKOFGG(HTYPE,1,NGAUSS*2,0.0,PEAST,NGAUSS,NGPTS,KOFSET)
        OLDGAUS = NGAUSS
        OLDTYPE = HTYPE
      ENDIF
C
C     _______________________________________________________
C
C*    Section 2. Find latitudes of grid lines to north and south of
C                the points and calculate grid interval along lines.
C     _______________________________________________________
C
  200 CONTINUE
C
      DO LOOP = 1, INROW
        NORTH(LOOP) = JNORSGG( OLAT(LOOP), GLATS, NGAUSS, 1)
      ENDDO
C
      DO LOOP = 1, INROW
        SOUTH(LOOP) = MIN( NORTH(LOOP)+1, NGAUSS*2)
        DNORTH(LOOP) = ABS(GLATS(NORTH(LOOP)) - OLAT(LOOP))
      ENDDO
C
      DO LOOP = 1, INROW
        DSOUTH(LOOP) = 1.0 - DNORTH(LOOP)
        NSTEP(LOOP) = 360.0/FLOAT(NGPTS(NORTH(LOOP)))
        SSTEP(LOOP) = 360.0/FLOAT(NGPTS(SOUTH(LOOP)))
      ENDDO
C
C     _______________________________________________________
C
C*    Section 3. Find neighbouring points.
C     _______________________________________________________
C
  300 CONTINUE
C
      DO LOOP = 1, INROW
C
C       Calculate normalised distance west and east to neighbouring
C       points on lines to north and south of the point
C
        IWESTN(LOOP) = INT(OLON(LOOP)/NSTEP(LOOP))
        IWESTS(LOOP) = INT(OLON(LOOP)/SSTEP(LOOP))
        IEASTN(LOOP) = IWESTN(LOOP) + 1
        IEASTS(LOOP) = IWESTS(LOOP) + 1
C
        DWESTN(LOOP) =
     X   ABS((OLON(LOOP) - FLOAT(IWESTN(LOOP))*NSTEP(LOOP))/NSTEP(LOOP))
        DEASTN(LOOP) = 1.0 - DWESTN(LOOP)
C
        DWESTS(LOOP) =
     X   ABS((OLON(LOOP) - FLOAT(IWESTS(LOOP))*SSTEP(LOOP))/SSTEP(LOOP))
        DEASTS(LOOP) = 1.0 - DWESTS(LOOP)
C
C       Adjust west and east for longitude wrap-around
C
        IVALUE=NGPTS(NORTH(LOOP))
        IF( IEASTN(LOOP).GE.IVALUE) THEN
          IEASTN(LOOP) = IEASTN(LOOP) - IVALUE
          IF( IWESTN(LOOP).GE.IVALUE) IWESTN(LOOP) = IWESTN(LOOP)-IVALUE
        ENDIF
C
        IVALUE=NGPTS(SOUTH(LOOP))
        IF( IEASTS(LOOP).GE.IVALUE) THEN
          IEASTS(LOOP) = IEASTS(LOOP) - IVALUE
          IF( IWESTS(LOOP).GE.IVALUE) IWESTS(LOOP) = IWESTS(LOOP)-IVALUE
        ENDIF
C
      ENDDO
C
C     _______________________________________________________
C
C*    Section 4. Interpolate using neighbouring points.
C     _______________________________________________________
C
  400 CONTINUE
C
C       Use bi-linear interpolation from four neighbouring points.
C
      DO LOOP = 1, INROW
        NEWFLD(NEXT+LOOP-1) =
     X    ( ( OFIELD(NORTH(LOOP),IWESTN(LOOP)) * DEASTN(LOOP) +
     X        OFIELD(NORTH(LOOP),IEASTN(LOOP)) * DWESTN(LOOP) )
     X      * DSOUTH(LOOP) +
     X      ( OFIELD(SOUTH(LOOP),IWESTS(LOOP)) * DEASTS(LOOP) +
     X        OFIELD(SOUTH(LOOP),IEASTS(LOOP)) * DWESTS(LOOP) )
     X      * DNORTH(LOOP) )
      ENDDO
C
C     _______________________________________________________
C
C*    Section 9. Closedown.
C     _______________________________________________________
C
  900 CONTINUE
C
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities
C granted to it by virtue of its status as an intergovernmental organisation
C nor does it submit to any jurisdiction.
C

      REAL FUNCTION ISLPROC(RLAT,RLON,NEWTYPE,OLAT,OLON,TYPE,PT,OLDFLD)
C
C---->
C**** ISLPROC
C
C     Purpose
C     -------
C
C     Generates a new field point from its four nearest neighbours
C     taking account of matching land-sea mask types.
C
C
C     Interface
C     ---------
C
C     VALUE = ISLPROC(RLAT,RLON,NEWTYPE,OLAT,OLON,TYPE,PT,OLDFLD)
C
C     Input
C     -----
C
C     RLAT    - Latitude of the new point
C     RLON    - Longitude of the new point
C     NEWTYPE - Land-sea mask type of the new point (land/sea)
C     OLAT    - Latitudes of the four neighbouring points
C     OLON    - Longitudes of the four neighbouring points
C     TYPE    - Land-sea mask types of the four neighbouring points
C     PT      - Positions in old field array of the four neighbours
C     OLDFLD  - Array of old field values
C
C
C     Output
C     ------
C
C     Function returns a value for the new field point.
C
C
C     Method
C     ------
C
C     Find which neighbours have same land-sea mask type and use
C     them to calculate a new value by bi-linear interpolation.
C
C     Use all four neighbours if none of them have the same
C     land-sea mask type as the new point.
C
C
C     Externals
C     ---------
C
C     FORCED_NEAREST_NEIGHBOUR - check forced interpolation method
C
C
C     Author
C     ------
C
C     J.D.Chambers     ECMWF     August 2000
C
C     Modifications
C     -------------
C
C     Force nearest neighbour processing with env variable or
C     INTOUT parameter
C     S.Curic           ECMWF    September 2005
C

C----<
C
      IMPLICIT NONE
C
C     Function arguments
C
      REAL RLAT,RLON,OLAT(2),OLON(4),OLDFLD(*)
      INTEGER NEWTYPE,TYPE(4),PT(4)
C
#include "intisl.h"
#include "parim.h"
#include "nifld.common"
#include "nofld.common"
C
C     Local variables
C
      LOGICAL LVEGGY
      INTEGER MCOUNT, COUNT, LOOP, NEAREST
      REAL WEIGHT(4), MATCH(4), NWEIGHT, SWEIGHT, NORMAL
C
C     Externals
C
      LOGICAL FORCED_NEAREST_NEIGHBOUR
C
C     -----------------------------------------------------------------|
C*    Section 1.   Find which neighbours have same land-sea mask type
C     -----------------------------------------------------------------|
C
  100 CONTINUE
C
      COUNT  = 0
      DO LOOP = 1, 4
        IF( TYPE(LOOP).EQ.NEWTYPE ) THEN
          COUNT = COUNT + 1
          MATCH(LOOP) = 1.0
        ELSE
          MATCH(LOOP) = 0.0
        ENDIF
      ENDDO
C
      IF( COUNT.EQ.0 ) THEN
C
C       Use all four neighbours if none of them have the same
C       land-sea mask type as the new point
C
        COUNT = 4
        DO LOOP = 1, 4
          MATCH(LOOP) = 1.0
        ENDDO
      ENDIF
C
C     -----------------------------------------------------------------|
C*    Section 3.   Handle case when missing values are present
C     -----------------------------------------------------------------|
C
  200 CONTINUE
C
C     Identify matching neighbours with missing values
C
      IF( LIMISSV ) THEN
        MCOUNT = 0
        DO LOOP = 1, 4
          IF((MATCH(LOOP).EQ.1.0).AND.(OLDFLD(PT(LOOP)).EQ.RMISSGV))THEN
            MCOUNT = MCOUNT + 1
            MATCH(LOOP) = 0.0
            COUNT = COUNT - 1
          ENDIF
        ENDDO
C
C       Set new value to 'missing' if all neighbours are missing
C
        IF( (MCOUNT.EQ.4).OR.(COUNT.EQ.0) ) THEN
          ISLPROC = RMISSGV
          GOTO 900
        ENDIF
      ENDIF
C
C     -----------------------------------------------------------------|
C*    Section 3.   Use neighbours that match to calculate the new value
C     -----------------------------------------------------------------|
C
  300 CONTINUE
C
C     Calculate the north/south weighting values allowing for
C     southern latitude to be same as northern latitude
C
      NWEIGHT = OLAT(NORTH) - RLAT
      SWEIGHT = RLAT - OLAT(SOUTH)
      IF( SWEIGHT.EQ.0.0 ) NWEIGHT = 1.0
C
C     Calculate the weighting values for each matching neighbour
C
      WEIGHT(NWEST) = ABS((OLON(SEAST) - RLON) * SWEIGHT)
      WEIGHT(NEAST) = ABS((RLON - OLON(SWEST)) * SWEIGHT)
      WEIGHT(SWEST) = ABS((OLON(NEAST) - RLON) * NWEIGHT)
      WEIGHT(SEAST) = ABS((RLON - OLON(NWEST)) * NWEIGHT)
C
C     Normalise the weights since not all neighbours necessarily used
C
      NORMAL = ( WEIGHT(NWEST) * MATCH(NWEST) +
     X           WEIGHT(NEAST) * MATCH(NEAST) +
     X           WEIGHT(SWEST) * MATCH(SWEST) +
     X           WEIGHT(SEAST) * MATCH(SEAST) )
C
C     Special cases when matching points have no weight
C
      IF( NORMAL.EQ.0.0 )  THEN
C
C       Only one matching neighbour: set its weight so that is used
C
        IF( COUNT.EQ.1 ) THEN
          NORMAL = 1.0
          IF( MATCH(NWEST).EQ.1.0 ) WEIGHT(NWEST) = 1.0
          IF( MATCH(NEAST).EQ.1.0 ) WEIGHT(NEAST) = 1.0
          IF( MATCH(SWEST).EQ.1.0 ) WEIGHT(SWEST) = 1.0
          IF( MATCH(SEAST).EQ.1.0 ) WEIGHT(SEAST) = 1.0
C
C       Two matching neighbours: set their weights to those of the
C       neighbours on the opposite side of the interpolation rectangle
C
        ELSEIF( COUNT.EQ.2 ) THEN
          IF( (MATCH(NWEST).EQ.1.0).AND.(MATCH(NEAST).EQ.1.0) ) THEN
            WEIGHT(NWEST) = WEIGHT(SWEST)
            WEIGHT(NEAST) = WEIGHT(SWEST)
            NORMAL = WEIGHT(NWEST) + WEIGHT(NEAST)
          ELSEIF( (MATCH(NWEST).EQ.1.0).AND.(MATCH(SWEST).EQ.1.0) ) THEN
            WEIGHT(NWEST) = WEIGHT(NEAST)
            WEIGHT(SWEST) = WEIGHT(SEAST)
            NORMAL = WEIGHT(NWEST) + WEIGHT(SWEST)
          ELSEIF( (MATCH(NEAST).EQ.1.0).AND.(MATCH(SEAST).EQ.1.0) ) THEN
            WEIGHT(NEAST) = WEIGHT(NWEST)
            WEIGHT(SEAST) = WEIGHT(SWEST)
            NORMAL = WEIGHT(NEAST) + WEIGHT(SEAST)
          ELSEIF( (MATCH(SWEST).EQ.1.0).AND.(MATCH(SEAST).EQ.1.0) ) THEN
            WEIGHT(SWEST) = WEIGHT(NWEST)
            WEIGHT(SEAST) = WEIGHT(NEAST)
            NORMAL = WEIGHT(SWEST) + WEIGHT(SEAST)
          ELSEIF( (MATCH(NWEST).EQ.1.0).AND.(MATCH(SEAST).EQ.1.0) ) THEN
            WEIGHT(NWEST) = WEIGHT(NEAST)
            WEIGHT(SEAST) = WEIGHT(SWEST)
            NORMAL = WEIGHT(NWEST) + WEIGHT(SEAST)
          ELSE
            WEIGHT(NEAST) = WEIGHT(SEAST)
            WEIGHT(SWEST) = WEIGHT(NWEST)
            NORMAL = WEIGHT(NEAST) + WEIGHT(SWEST)
          ENDIF
C
C       Three matching neighbours with no weight, ie the interpolation
C       point is coincident with a grid point, but the land-sea masks
C       disagree about its type. Use it anyway.
C
        ELSE
          IF( MATCH(NWEST).EQ.0.0 ) THEN
            MATCH(NWEST) = 1.0
            NORMAL = WEIGHT(NWEST)
          ELSE IF( MATCH(NEAST).EQ.0.0 ) THEN
            MATCH(NEAST) = 1.0
            NORMAL = WEIGHT(NEAST)
          ELSE IF( MATCH(SWEST).EQ.0.0 ) THEN
            MATCH(SWEST) = 1.0
            NORMAL = WEIGHT(SWEST)
          ELSE
            MATCH(SEAST) = 1.0
            NORMAL = WEIGHT(SEAST)
          ENDIF
        ENDIF
      ENDIF
C
C     -----------------------------------------------------------------|
C*    Section 4.   Interpolate
C     -----------------------------------------------------------------|
C
  400 CONTINUE
C
      WEIGHT(NWEST) = WEIGHT(NWEST)/NORMAL
      WEIGHT(NEAST) = WEIGHT(NEAST)/NORMAL
      WEIGHT(SWEST) = WEIGHT(SWEST)/NORMAL
      WEIGHT(SEAST) = WEIGHT(SEAST)/NORMAL

C     Use nearest neighbour if required
      LVEGGY = FORCED_NEAREST_NEIGHBOUR(LMETHOD,NITABLE,NIPARAM)
C
      IF( LVEGGY ) THEN
        NEAREST = NWEST
        IF( WEIGHT(NEAST).GT.WEIGHT(NEAREST) ) NEAREST = NEAST
        IF( WEIGHT(SWEST).GT.WEIGHT(NEAREST) ) NEAREST = SWEST
        IF( WEIGHT(SEAST).GT.WEIGHT(NEAREST) ) NEAREST = SEAST
        ISLPROC = OLDFLD(PT(NEAREST))
C
      ELSE
C
        ISLPROC = ( (OLDFLD(PT(NWEST)) * WEIGHT(NWEST) * MATCH(NWEST)) +
     X              (OLDFLD(PT(NEAST)) * WEIGHT(NEAST) * MATCH(NEAST)) +
     X              (OLDFLD(PT(SWEST)) * WEIGHT(SWEST) * MATCH(SWEST)) +
     X              (OLDFLD(PT(SEAST)) * WEIGHT(SEAST) * MATCH(SEAST)) )
      ENDIF
C
C     -----------------------------------------------------------------|
C*    Section 9.   Return
C     -----------------------------------------------------------------|
C
  900 CONTINUE
C
      RETURN
      END

C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C


      SUBROUTINE DSWMRS(IBLOSW,LOGISW,ILLGTH,INSOUT,IILGTH,RESOUT,
     S                  IRLGTH,MGRIBS,ILENSW,IBITMC,LPRINTS)
C
C---->
C**** *DSWMRS* - ROUTINE TO DECODE A MARS MODEL SWITCH.
C
C     G.K.SAKELLARIDES  ECMWF        17/05/85.
C     THE STRUCTURE IS SIMILAR TO J.HENNESSY'S SUBROUTINE *DECOGR*
C
C     PURPOSE.
C     --------
C
C          TO DECODE A MODEL SWITCH MARS RECORD FROM MARS PACKED
C          SWITCH RECORD AS WELL AS TO PRINT THE DECOTED RECORD
C          IN CASE LPRINTS=.TRUE.
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *DSWMRS(IBLOSW,LOGISW,ILLGTH,INSOUT,IILGTH,RESOUT,
C                       IRLGTH,MGRIBS,ILENSW,IBITMC)*
C        WHERE:
C              INPUT PARAMETERS
C              1.*MGRIBS* ARRAY CONTAINING THE PACKED MARS MODEL SWITCH
C              2.*ILENSW* THE LENGTH OF THE ARRAY MGRIBS (750 CRAY WORD)
C              3.*IBITMC* NUMBER OF BITS PER COMPUTER WORD.
C              4.*LPRINTS* .TRUE. IF AN OUTPUT OF THE DECOTED MARS
C                           MODEL SWITCH RECORD IS REQUIRED.
C              OUTPUT PARAMETERS
C              1.*IBLOSW* INTEGER ARRAY OF LENGTH 29 CONTAINING
C                          THE FOLLOWING INFORMATIONS OF BLOCK1.
C  1.1                        G
C  1.2                        R
C  1.3                        I
C  1.4                        B
C  1.5         IDENTIFICATION OF CENTRE)
C  1.6         MODEL IDENTIFICATION
C  1.7         GRID DEFINITION
C  1.8         FLAG (CODE TABLE 1)
C  1.9         PARAM. INTICATING THE MARS MODEL SWITCH REC.
C  1.10         TYPE OF LEVEL (CODE TABLE 3)
C  1.11         VALUE 1 OF LEVEL (CODE TABLE 3)
C  1.12         VALUE 2 OF LEVEL (CODE TABLE 3)
C  1.13         YEAR    OF INITIAL DATA
C  1.14         MONTH   OF INITIAL DATA
C  1.15         DAY     OF INITIAL DATA
C  1.16         HOUR    OF INITIAL DATA
C  1.17         MINUTE  OF INITIAL DATA
C  1.18         TIME UNIT (CODE TABLE 4)
C  1.19         TIME RANGE 1
C  1.20         TIME RANGE 2
C  1.21         TIME RANGE FLAG (CODE TABLE 5)
C  1.22-24      RESERVED
C  1.26         STARTING ADDRESS OF LOGICAL SECTION(OCTET)
C  1.27         STARTING ADDRESS OF INTEGER SECTION(OCTET)
C  1.28         STARTING ADDRESS OF REAL    SECTION(OCTET)
C  1.29         LENGTH           OF REAL    SECTION(OCTET)
C              2.*LOGISW* INTEGER ARRAY OF SUFFICIENT LENGTH WHICH
C                          CONTAINS THE LOGICALS.
C              3.*ILLGTH* ACTUAL LENGTH OF LOGICALS
C              4.*INSOUT* INTEGER ARRAY OF SUFFICIENT LENGTH WHICH
C                         CONTAINS THE INTEGERS
C              5.*IILGTH* ACTUAL LENGTH OF INTEGER
C              6.*RESOUT* REAL ARRAY OF SUFFICIENT LENGTH WHICH
C                         CONTAINS THE REALS
C              7.*IRLGTH* ACTUAL LENGTH OF REALS
C
C     EXTERNALS.
C     ----------
C
C         *GBYTES*   EXTRACT BIT FIELD
C         *GBYTE *   EXTRACT BIT FIELD
C         *OFFSET*  CALCULATES THE WORD AND BIT OFFSET OF THE START
C                   OF THE NEXT BIT FIELD.
C         *DECFP*   DECODE GRIB CODE REPRESENTATION TO FLOATING POINT
C                   NUMBER.
C
C----<
C
      DIMENSION IBLOSW(*),INSOUT(*),RESOUT(*),MGRIBS(ILENSW)
      DIMENSION ILSOUT(500)
      DIMENSION IAA(4)
      LOGICAL LOGISW(*),LPRINTS
C
C*              1. SET LOCAL VARIABLES
C
  100 CONTINUE
      IERR=0
      ILMGRIB=ILENSW
      IBITCR=IBITMC
C
C*              1.5 VARIABLES OF BLOCK 1
C
      IWORD=1
      IBYTE=8
      IVAL=24
      IOFF=0
      CALL GBYTES(MGRIBS(IWORD),IBLOSW(1),IOFF,IBYTE,0,IVAL)
      CALL OFFSET(IOFF,IVAL,IWORD,IBYTE,IBITCR,ILMGRIB,IERR)
      IF (IERR.NE.0) GO TO 900
C
C*     LENTHG OF DATA BLOCK(OCTET)
      CALL GBYTE(MGRIBS(IWORD),IBLOSW(25),IOFF,24)
      CALL OFFSET(IOFF,1,IWORD,24,IBITCR,ILMGRIB,IERR)
      IF (IERR.NE.0)GO TO 900
C
C*     STARTING ADDRESS OF LOGICAL  AND INTEGER SECTION
      IBYTE=8
      IVAL=2
      CALL GBYTES(MGRIBS(IWORD),IBLOSW(26),IOFF,IBYTE,0,IVAL)
      CALL OFFSET(IOFF,IVAL,IWORD,IBYTE,IBITCR,ILMGRIB,IERR)
      IF (IERR.NE.0)GO TO 900
C*     STARTING ADDRESS OF REAL SECTION
      CALL GBYTE(MGRIBS(IWORD),IBLOSW(28),IOFF,16)
      CALL OFFSET(IOFF,1,IWORD,16,IBITCR,ILMGRIB,IERR)
      IF (IERR.NE.0)GO TO 900
C* LENGTH OF REAL SECTION
      CALL GBYTE(MGRIBS(IWORD),IBLOSW(29),IOFF,16)
      CALL OFFSET(IOFF,1,IWORD,16,IBITCR,ILMGRIB,IERR)
      IF (IERR.NE.0)GO TO 900
C
C*              3. BLOCK 4 DATA
C                  ----
C
  300 CONTINUE
C
C*         3.1 LOGICALS
C              DECODE LOGICALS FROM MARS FORMAT
C
  310 CONTINUE
C*           FINDS LENGTH OF LOGICALS
      ILLGTH=IBLOSW(27)-IBLOSW(26)
      IBYTE=8
      IVAL=ILLGTH
      CALL GBYTES(MGRIBS(IWORD),ILSOUT(1),IOFF,IBYTE,0,IVAL)
      CALL OFFSET(IOFF,IVAL,IWORD,IBYTE,IBITCR,ILMGRIB,IERR)
      IF (IERR.NE.0) GO TO 900
      DO 314 I=1,ILLGTH
C--   LOGISW(I)=SHIFTL(ILSOUT(I),63)
      IF (ILSOUT(I).EQ.1) LOGISW(I) = .TRUE.
C--
  314 CONTINUE
C
C*         3.2 INTEGERS
C
C*      LENGTH OF INTEGERS
      IILGTH=(IBLOSW(28)-IBLOSW(27))/2
      IBYTE=16
      IVAL=IILGTH
      CALL GBYTES(MGRIBS(IWORD),INSOUT(1),IOFF,IBYTE,0,IVAL)
      CALL OFFSET(IOFF,IVAL,IWORD,IBYTE,IBITCR,ILMGRIB,IERR)
      IF (IERR.NE.0)GO TO 900
C*         3.3 REALS
C
C*    LENGTH OF REAL SECTION
      IRLGTH=IBLOSW(29)/4
      DO 335 J=1,IRLGTH
      CALL GBYTE(MGRIBS(IWORD),IEXP,IOFF,8)
      CALL OFFSET(IOFF,1,IWORD,8,IBITCR,ILMGRIB,IERR)
      IF (IERR.NE.0)GO TO 900
      CALL GBYTE(MGRIBS(IWORD),IMANT,IOFF,24)
      CALL OFFSET(IOFF,1,IWORD,24,IBITCR,ILMGRIB,IERR)
      IF (IERR.NE.0)GO TO 900
      CALL DECFP(RESOUT(J),IEXP,IMANT)
  335 CONTINUE
C
C
C*         3.4 UNUSED WORDS
C
  340 CONTINUE
C*    USED OCTET
      IUSED=33+ILLGTH+IILGTH*2+IRLGTH*4
C*    UNUSED OCTET
      IUNUSE=ILENSW*8-4-IUSED
      DO 345 J=1,IUNUSE
      CALL GBYTE(MGRIBS(IWORD),IEEE,IOFF,8)
      CALL OFFSET(IOFF,1,IWORD,8,IBITCR,ILMGRIB,IERR)
      IF (IERR.NE.0)GO TO 900
  345 CONTINUE
C
C*                3.5 CORECT LENGTH OF INTEGER SECTION
C
  350 CONTINUE
      INGL=INSOUT(6)
      INLEV=INSOUT(6+INGL+1)
      J1A=1
      J1T=6
      J2A=J1T+1
      J2T=J2A+INGL-1
      J3A=J2T+1
      J3T=J3A+14-1
      J4A=J3T+1
      J4T=J4A+INGL-1
      J5A=J4T+1
      J5T=J5A+INGL-1
      J6A=J5T+1
      J6T=J6A+10-1
      J7A=J6T+1
      J7T=J7A+INLEV-1
      J8A=J7T+1
      J8T=J8A+INLEV-1
      J9A=J8T+1
      J9T=J9A+INLEV-1
      IILGTH=J9T
C
C*          4. BLOCK 5
C
  400 CONTINUE
      CALL GBYTES(MGRIBS(IWORD),IAA(1),IOFF,8,0,4)
C
C
C*            5. OUTPUT
C
  500 CONTINUE
      IF (LPRINTS) THEN
C
         CALL ANALSW(IBLOSW,LOGISW,ILLGTH,INSOUT,IILGTH,
     S              RESOUT,IRLGTH)
C
      ENDIF
C
C*           6. RETURN
C
  600 CONTINUE
      RETURN
C
C*             9. ERROR HANDLING
C
  900 CONTINUE
      WRITE(*,9901)
      WRITE(*,'(A)') 'ERROR IN OFFSET'
      CALL ENDRUN
      STOP
 9901 FORMAT('ERROR IN SUBROUTINE DSWMRS')
      END

C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE BUEPMRK(KSEC3,KVALS,VALUES,KELEM,KERR)
C
C**** *BUEPMRK*
C
C
C     PURPOSE.
C     --------
C
C          PROCESS MARKER OPERATOR, RELACING IT WITH CORRESPONDING
C     TABLE B ELEMENT DESCRIPTOR.
C
C
C**   INTERFACE.
C     ----------
C
C          *CALL* *BUEPMRK(KSEC3,KVALS,VALUES,KELEM,KERR)*
C
C        INPUT :
C               *KSEC3*   -  ARRAY CONTAINING SECTION 3 INFORMATION
C                            KSEC3( 1)-- LENGTH OF SECTION 3 (BYTES)
C                            KSEC3( 2)-- RESERVED
C                            KSEC3( 3)-- NUMBER OF SUBSETS
C                            KSEC3( 4)-- FLAG (DATA TYPE,DATA
C                                        COMPRESSION)
C               *KVALS*   -  DIMENSION OF VALUES ARRAY
C               *VALUES*  -  ARAY CONTAINING DATA
C               *KELEM*   -  DIMENSION OF CNAMES, CUNITS ARRAY
C        OUTPUT:
C               *KERR*    -  RETURNED ERROR CODE
C
C     METHOD.
C     -------
C          NONE.
C
C     EXTERNALS.
C     ----------
C
C          BUNPCK          - UNPACKS BIT PATTERN
C          BUNPKS         - UNPACKS BIT PATTERN IN REPEATED WAY
C
C     REFERENCE.
C     ----------
C
C          NONE.
C
C     AUTHOR.
C     -------
C
C          M. DRAGOSAVAC    *ECMWF*       01/02/91.
C
C
C     MODIFICATIONS.
C     --------------
C
C          M. DRAGOSAVAC 1/10/92 :
C
C
C
      IMPLICIT LOGICAL(L,O,G), CHARACTER*8(C,H,Y)
C
C
#     include "parameter.F"
#     include "bcomunit.F"
#     include "bcmwork.F"
#     include "bcmbef.F"
#     include "bcmwt.F"
#     include "bcmwtc.F"
#     include "bcmrq.F"
C
      CHARACTER CWTEN*64,CWTU*24
      DIMENSION KSEC3(JSEC3)
#ifndef R_4
      REAL*8 VALUES(KVALS)
      REAL*8 RVIND
      REAL*8 EPS
#else
      REAL   VALUES(KVALS)
      REAL   RVIND
      REAL   EPS
#endif
C
      DIMENSION IMASK(8)
      DATA IMASK/1,2,4,8,16,32,64,128/
C
C     ------------------------------------------------------------------
C*          1.  FINED OPERATOR 223000 TO 237255.
C               --------------------------------
 100  CONTINUE
C
      IF(KERR.GT.0) RETURN
C
C
C           1.1 CHECK IF DATA ARE COMRESSED.
C               ----------------------------
 110  CONTINUE
C
      IB=0
      IF(IAND(KSEC3(4),IMASK(7)).NE.0) IB=1
C
C*          1.2 FIND POSITION OF OPREATORS.
C               ---------------------------
 120  CONTINUE
C
      DO 121 J=1,M
C
      NR223=0
      NR224=0
      NR225=0
      NR232=0
C
C
      IF(NWTR(J).EQ.222000) THEN
C
C        SET POINTER TO THE LAST DATA ELEMENT
C
         IF(MREL.EQ.0) MREL=J-1
C
C
C        CHECK IF BACKWARD REFERENCE BIT MAP DEFINED
C
         IF(NWTR(J+1).EQ.236000) THEN
            NP236000=J+1
            OBF=.TRUE.
            J2=J+2
C
C           DELAYED REPLICATION FACTOR CAN FOLLOW 236000
C
            IF(NWTR(J2).EQ.031001.OR.NWTR(J2).EQ.031000.OR.
     1         NWTR(J2).EQ.031002) J2=J+3
C
            DO 122 I=J2,M
            IF(NWTR(I).EQ.031031) THEN
C
C              FIND  FIRST POINTER TO DATA PRESENT INDICATOR
C
               IF(OBF) MBMP=I
               OBF=.FALSE.
            ELSE
C
C              LAST POINTER TO DATA PRESENT INDICATOR
C
               MBMPL=I-1
               GO TO 121
            END IF
 122        CONTINUE
         END IF
      END IF
      IF(NWTR(J).EQ.223000) THEN
C
C        SET POINTER TO THE LAST DATA ELEMENT
C
         IF(MREL.EQ.0) MREL=J-1
C
         NP223000=J
C
C        CHECK IF BACKWARD REFERENCE BIT MAP DEFINED
C
         IF(NWTR(J+1).EQ.236000) THEN
            NP236000=J+1
            OBF=.TRUE.
            J2=J+2
C
C           DELAYED REPLICATION FACTOR CAN FOLLOW 236000
C
            IF(NWTR(J2).EQ.031001.OR.NWTR(J2).EQ.031000.OR.
     1         NWTR(J2).EQ.031002) J2=J+3
C
            DO 123 I=J2,M
            IF(NWTR(I).EQ.031031) THEN
C
C              FIND  FIRST POINTER TO DATA PRESENT INDICATOR
C
               IF(OBF) MBMP=I
               OBF=.FALSE.
            ELSE
C
C              LAST POINTER TO DATA PRESENT INDICATOR
C
               MBMPL=I-1
               GO TO 200
            END IF
 123        CONTINUE
         END IF
         GO TO 200
      END IF
      IF(NWTR(J).EQ.224000) THEN
C
C        SET POINTER TO THE LAST DATA ELEMENT
C
         IF(MREL.EQ.0) MREL=J-1
C
         NP224000=J
C
C        CHECK IF BACKWARD REFERENCE BIT MAP DEFINED
C
         IF(NWTR(J+1).EQ.236000) THEN
            NP236000=J+1
            OBF=.TRUE.
            J2=J+2
C
C           DELAYED REPLICATION FACTOR CAN FOLLOW 236000
C
            IF(NWTR(J2).EQ.031001.OR.NWTR(J2).EQ.031000.OR.
     1         NWTR(J2).EQ.031002) J2=J+3
C
            DO 124 I=J2,M
            IF(NWTR(I).EQ.031031) THEN
C
C              FIND  FIRST POINTER TO DATA PRESENT INDICATOR
C
               IF(OBF) MBMP=I
               OBF=.FALSE.
            ELSE
C
C              LAST POINTER TO DATA PRESENT INDICATOR
C
               MBMPL=I-1
               GO TO 300
            END IF
 124        CONTINUE
         END IF
         GO TO 300
      END IF
      IF(NWTR(J).EQ.225000) THEN
C
C        SET POINTER TO THE LAST DATA ELEMENT
C
         IF(MREL.EQ.0) MREL=J-1
C
         NP225000=J
C
C        CHECK IF BACKWARD REFERENCE BIT MAP DEFINED
C
         IF(NWTR(J+1).EQ.236000) THEN
            NP236000=J+1
            OBF=.TRUE.
            J2=J+2
C
C           DELAYED REPLICATION FACTOR CAN FOLLOW 236000
C
            IF(NWTR(J2).EQ.031001.OR.NWTR(J2).EQ.031000.OR.
     1         NWTR(J2).EQ.031002) J2=J+3
C
            DO 125 I=J2,M
            IF(NWTR(I).EQ.031031) THEN
C
C              FIND  FIRST POINTER TO DATA PRESENT INDICATOR
C
               IF(OBF) MBMP=I
               OBF=.FALSE.
            ELSE
C
C              LAST POINTER TO DATA PRESENT INDICATOR
C
               MBMPL=I-1
               GO TO 400
            END IF
 125        CONTINUE
         END IF
         GO TO 400
      END IF
      IF(NWTR(J).EQ.232000) THEN
C
C        SET POINTER TO THE LAST DATA ELEMENT
C
         IF(MREL.EQ.0) MREL=J-1
C
         NP232000=J
C
C        CHECK IF BACKWARD REFERENCE BIT MAP DEFINED
C
         IF(NWTR(J+1).EQ.236000) THEN
            NP236000=J+1
            OBF=.TRUE.
            J2=J+2
C
C           DELAYED REPLICATION FACTOR CAN FOLLOW 236000
C
            IF(NWTR(J2).EQ.031001.OR.NWTR(J2).EQ.031000.OR.
     1         NWTR(J2).EQ.031002) J2=J+3
C
            DO 126 I=J2,M
            IF(NWTR(I).EQ.031031) THEN
C
C              FIND  FIRST POINTER TO DATA PRESENT INDICATOR
C
               IF(OBF) MBMP=I
               OBF=.FALSE.
            ELSE
C
C              LAST POINTER TO DATA PRESENT INDICATOR
C
               MBMPL=I-1
               GO TO 500
            END IF
 126        CONTINUE
         END IF
         GO TO 500
      END IF
C
      IF(NWTR(J).EQ.235000) THEN
C
C        RESET POINTER  POINTER TO THE LAST DATA ELEMENT
C
         MREL=0
         MBMP=0
         MBMPL=0
      END IF
C
      IF(NWTR(J).EQ.237255) THEN
C
C        RESET POINTERS TO THE BIT MAP
C
         MBMP=0
         MBMPL=0
      END IF
C
      GO TO 121
C
C     -----------------------------------------------------------------
C*          2.  PROCESS SUBSTITUTED VALUES OPERATOR.
C               ------------------------------------
C
 200  CONTINUE
C
C*          2.1 FIND FIRST ACCURANCE OD 223255.
C               -------------------------------
 210  CONTINUE
C
      NP223255=0
      DO 211 I=NP223000,M
      IF(NWTR(I).EQ.223255) THEN
         NP223255=I
         GO TO 220
      END IF
 211  CONTINUE
C
      GO TO 121
C
C*          2.2 COUNT NUMBER OF DATA PRESENT INDICATORS.
C               ----------------------------------------
 220  CONTINUE
C
      IF(MBMP.EQ.0) THEN
         I223=0
         OF223=.TRUE.
         DO 221 I=NP223000,NP223255
         IF(NWTR(I).EQ.031031) THEN
            IF(OF223) THEN
               I223=I
               OF223=.FALSE.
            END IF
            NR223=NR223+1
         END IF
 221     CONTINUE
      ELSE
         I223=MBMP
         NR223=MBMPL-MBMP+1
      END IF
C
C
C*          2.5 DEFINE POINTER REFERING BACK TO DATA.
C               -------------------------------------
 250  CONTINUE
C
      ISUBST=MREL-NR223+1
C
C*          2.6 REPLACE MARKERS WITH CORRESPONDING DATA WIDTHS.
C               -----------------------------------------------
C
 260  CONTINUE
C
      DO 261 I=I223,NR223+I223
      IF(VALUES(I).EQ.0) THEN
C
 262     CONTINUE
C
         IF(NWTR(NP223255).EQ.223255) THEN
            NWTDW (NP223255)=NWTDW(ISUBST)
            NWTR  (NP223255)=NWTR (ISUBST)
            NWTRV (NP223255)=NWTRV(ISUBST)
            NWTS  (NP223255)=NWTS (ISUBST)
            CWTEN (NP223255)=CWTEN(ISUBST)
            CWTU  (NP223255)=CWTU (ISUBST)
            NWTEN (NP223255)=NWTEN(ISUBST)
            ISUBST=ISUBST+1
            NP223255=NP223255+1
         ELSE
            NP223255=NP223255+1
            GO TO 262
         END IF
      ELSE
         ISUBST=ISUBST+1
      END IF
 261  CONTINUE
C
      GO TO 121
C
C     -----------------------------------------------------------------
C*          3.  PROCESS FIRST ORDER STATISTICS OPERATOR.
C               ----------------------------------------
 300  CONTINUE
C
C*          3.1 FIND FIRST ACCURANCE OD 224255.
C               -------------------------------
 310  CONTINUE
C
      NP224255=0
      DO 311 I=NP224000,M
      IF(NWTR(I).EQ.224255) THEN
         NP224255=I
         GO TO 320
      END IF
 311  CONTINUE
C
      GO TO 121
C
C*          3.2 COUNT NUMBER OF DATA PRESENT INDICATORS.
C               ----------------------------------------
 320  CONTINUE
C
      IF(MBMP.EQ.0) THEN
         I224=0
         OF224=.TRUE.
         DO 321 I=NP224000,NP224255
         IF(NWTR(I).EQ.031031) THEN
            IF(OF224) THEN
               I224=I
               OF224=.FALSE.
            END IF
            NR224=NR224+1
         END IF
 321     CONTINUE
      ELSE
         I224=MBMP
         NR224=MBMPL-MBMP+1
      END IF
C
C
C*          3.5 DEFINE POINTER REFERING BACK TO DATA.
C               -------------------------------------
 350  CONTINUE
C
      ISUBST=MREL-NR224+1
C
C*          3.6 REPLACE MARKERS WITH CORRESPONDING DATA WIDTHS.
C               -----------------------------------------------
C
 360  CONTINUE
C
      DO 361 I=I224,NR224+I224
      IF(VALUES(I).EQ.0) THEN
C
 362     CONTINUE
C
         IF(NWTR(NP224255).EQ.224255) THEN
            NWTDW (NP224255)=NWTDW(ISUBST)
            NWTR  (NP224255)=NWTR (ISUBST)
            NWTRV (NP224255)=NWTRV(ISUBST)
            NWTS  (NP224255)=NWTS (ISUBST)
            CWTEN (NP224255)=CWTEN(ISUBST)
            CWTU  (NP224255)=CWTU (ISUBST)
            NWTEN (NP224255)=NWTEN(ISUBST)
            ISUBST=ISUBST+1
            NP224255=NP224255+1
         ELSE
            NP224255=NP224255+1
            GO TO 362
         END IF
      ELSE
         ISUBST=ISUBST+1
      END IF
 361  CONTINUE
C
      GO TO 121
C
C
C     -----------------------------------------------------------------
C*          4.  PROCESS DIFFERENCE STATISTICS OPERATOR.
C               ---------------------------------------
 400  CONTINUE
C
C
C*          4.1 FIND FIRST ACCURANCE OD 225255.
C               -------------------------------
 410  CONTINUE
C
      NP225255=0
      DO 411 I=NP225000,M
      IF(NWTR(I).EQ.225255) THEN
         NP225255=I
         GO TO 420
      END IF
 411  CONTINUE
C
      GO TO 121
C
C*          4.2 COUNT NUMBER OF DATA PRESENT INDICATORS.
C               ----------------------------------------
 420  CONTINUE
C
      IF(MBMP.EQ.0) THEN
         I225=0
         OF225=.TRUE.
         DO 421 I=NP225000,NP225255
         IF(NWTR(I).EQ.031031) THEN
            IF(OF225) THEN
               I225=I
               OF225=.FALSE.
            END IF
            NR225=NR225+1
         END IF
 421     CONTINUE
      ELSE
         I225=MBMP
         NR225=MBMPL-MBMP+1
      END IF
C
C
C*          4.5 DEFINE POINTER REFERING BACK TO DATA.
C               -------------------------------------
 450  CONTINUE
C
      ISUBST=MREL-NR225+1
C
C*          4.6 REPLACE MARKERS WITH CORRESPONDING DATA WIDTHS.
C               -----------------------------------------------
C
 460  CONTINUE
C
      DO 461 I=I225,NR225+I225
      IF(VALUES(I).EQ.0) THEN
C
 462     CONTINUE
C
         IF(NWTR(NP225255).EQ.225255) THEN
            NWTR  (NP225255)=NWTR (ISUBST)
C
C           CHANGE REFERENCE VALUE TO BE CENTRED AROUND ZERO
C           AND INCREASE DATA WIDTH BY 1
C
            IF(NWTEN(ISUBST).NE.-999) THEN
               NWTRV (NP225255)=-2**NWTDW(ISUBST)
               NWTDW (NP225255)=NWTDW(ISUBST)+1
            ELSE
               NWTRV (NP225255)=NWTDW(ISUBST)
               NWTDW (NP225255)=NWTDW(ISUBST)
               NWTEN (NP225255)=NWTEN(ISUBST)
            END IF
C
            NWTS  (NP225255)=NWTS (ISUBST)
            CWTEN (NP225255)=CWTEN(ISUBST)
            CWTU  (NP225255)=CWTU (ISUBST)
            NWTEN(NP225255)=NWTEN(ISUBST)
            ISUBST=ISUBST+1
            NP225255=NP225255+1
         ELSE
            NP225255=NP225255+1
            GO TO 462
         END IF
      ELSE
         ISUBST=ISUBST+1
      END IF
 461  CONTINUE
C
      GO TO 121
C
C     -----------------------------------------------------------------
C*          5.  PROCESS REPLACE/RETAINED OPERATOR.
C               ----------------------------------
 500  CONTINUE
C
C
C*          5.1 FIND FIRST ACCURANCE OF 232255.
C               -------------------------------
 510  CONTINUE
C
      NP232255=0
      DO 511 I=NP232000,M
      IF(NWTR(I).EQ.232255) THEN
         NP232255=I
         GO TO 520
      END IF
 511  CONTINUE
C
      GO TO 121
C
C*          5.2 COUNT NUMBER OF DATA PRESENT INDICATORS.
C               ----------------------------------------
 520  CONTINUE
C
      IF(MBMP.EQ.0) THEN
         I232=0
         OF232=.TRUE.
         DO 521 I=NP232000,NP232255
         IF(NWTR(I).EQ.031031) THEN
            IF(OF232) THEN
               I232=I
               OF232=.FALSE.
            END IF
            NR232=NR232+1
         END IF
 521     CONTINUE
      ELSE
         I232=MBMP
         NR232=MBMPL-MBMP+1
      END IF
C
C
C*          5.5 DEFINE POINTER REFERING BACK TO DATA.
C               -------------------------------------
 550  CONTINUE
C
      ISUBST=MREL-NR232+1
C
C*          5.6 REPLACE MARKERS WITH CORRESPONDING DATA WIDTHS.
C               -----------------------------------------------
C
 560  CONTINUE
C
      DO 561 I=I232,NR232+I232
      IF(VALUES(I).EQ.0) THEN
C
 562     CONTINUE
C
         IF(NWTR(NP232255).EQ.232255) THEN
            NWTDW (NP232255)=NWTDW(ISUBST)
            NWTR  (NP232255)=NWTR (ISUBST)
            NWTRV (NP232255)=NWTRV(ISUBST)
            NWTS  (NP232255)=NWTS (ISUBST)
            CWTEN (NP232255)=CWTEN(ISUBST)
            CWTU  (NP232255)=CWTU (ISUBST)
            NWTEN(NP232255)=NWTEN(ISUBST)
            ISUBST=ISUBST+1
            NP232255=NP232255+1
         ELSE
            NP232255=NP232255+1
            GO TO 562
         END IF
      ELSE
         ISUBST=ISUBST+1
      END IF
 561  CONTINUE
C
C     -----------------------------------------------------------------
 121  CONTINUE
C
      RETURN
C
C
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE CHKPREC()
C
C---->
C**** CHKPREC
C
C     Purpose
C     -------
C
C     Determines whether or not the current field is to be
C     considered for 'precipitation' treatment.
C
C
C     Interface
C     ---------
C
C     CALL CHKPREC()
C
C     Input
C     -----
C
C     None
C
C
C     Output
C     ------
C
C     Sets the precipitation threshold if give by environment variable
C     PRECIPITATION_THRESHOLD. Otherwise gives it a default value.
C
C
C     Method
C     ------
C
C     See below.
C
C
C     Externals
C     ---------
C
C     INTLOG  - Logs messages
C
C     Uses common block nifld.common
C
C
C     Author
C     ------
C
C     J.D.Chambers     ECMWF     December 2003
C
C----<
C
C
      IMPLICIT NONE
C
#include "parim.h"
#include "nifld.common"
C
C     Local variables
C
      CHARACTER*20 PTHRESH
      INTEGER IBLANK
      LOGICAL LFIRST
      DATA LFIRST/.TRUE./
      SAVE LFIRST
C
C     -----------------------------------------------------------------|
C*    Section 1. Initialise
C     -----------------------------------------------------------------|
C
  100 CONTINUE
C
      IF( LFIRST ) THEN
        LFIRST = .FALSE.
        CALL GETENV('PRECIPITATION_THRESHOLD',PTHRESH)
        IBLANK = INDEX(PTHRESH, ' ')
        IF( IBLANK.GT.1 ) THEN
          READ(PTHRESH,'(F15.8)') ZPRECIP
        ELSE
          ZPRECIP = 0.00005
        ENDIF
C
        CALL INTLOGR(JP_DEBUG,
     X    'CHKPREC: PRECIPITATION_THRESHOLD = ',ZPRECIP)
      ENDIF
C
C     -----------------------------------------------------------------|
C*    Section 9.   Return
C     -----------------------------------------------------------------|
C
  900 CONTINUE
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities
C granted to it by virtue of its status as an intergovernmental organisation
C nor does it submit to any jurisdiction.
C

      SUBROUTINE ECDEF5( HFUNC, KSEC1, KGRIB, KLENG, KNSPT, KBITS,
     X                    KPR, KRET)
C
C---->
C**** ECDEF5
C
C     Purpose.
C     --------
C
C     GRIB coding/decoding of ECMWF local use definition 5.
C     (Extensions for forecast probabilities).
C
C
C**   Interface.
C     ----------
C
C     CALL ECDEF5( HFUNC, KSEC1, KGRIB, KLENG, KNSPT, KBITS, KPR, KRET)
C
C
C     Input Parameters.
C     -----------------
C
C     HFUNC      - Requested function.
C                  'C' to code data.
C                  'D' to decode data.
C
C     KSEC1      - Array containing Grib Section 1 data.
C
C     KGRIB      - Array containing Grib coded data.
C
C     KLENG      - Length (words) of KGRIB.
C
C     KNSPT      - Bit number after which insertion/extraction starts.
C
C     KBITS      - Number of bits in computer word.
C
C     KPR        - Debug print switch.
C                  0  , No printout.
C                  >0 , Debug printout.
C
C     KRET       - Response to error indicator.
C                  0        , Abort if error encountered.
C                  Non-zero , Return to calling routine
C                             even if error encountered.
C
C     Output Parameters.
C     ------------------
C
C     KSEC1      - Array containing Grib Section 1 data.(Updated)
C
C     KGRIB      - Array containing Grib coded data.(Updated)
C
C     KNSPT      - Number of bit after last one inserted/extracted.(Updated)
C
C     KRET       - Return code.
C                  0   , No error encountered.
C                  2   , Error reported by routine INXBIT.
C
C
C     Method.
C     -------
C
C     Input data packed/unpacked in accordance with ECMWF usage of
C     local part of section 1 of Grib code, definition 1.
C
C
C     Externals.
C     ----------
C
C     INXBIT
C     ABORTX
C     CSGNBT
C     DSGNBT
C
C
C     Reference.
C     ----------
C
C     WMO Manual On Codes for Grib Code.
C
C
C     Comments.
C     ---------
C
C     Adapted from ECLOC1.F - simplified to handle just definition 5.
#include "ecdef5.h"
C
C
C     Author.
C     -------
C
C     J.D.Chambers     ECMWF      18th January 1995
C
C
C     Modifications.
C     --------------
C
C     None.
C
C
C----<
C     ------------------------------------------------------------------
C*    Section 0 . Definition of variables. Data statements.
C     ------------------------------------------------------------------
C
      IMPLICIT NONE
C
#include "common/grprs.h"
C
C     Parameters
      CHARACTER*1   HFUNC
      INTEGER KSEC1, KGRIB, KLENG, KNSPT, KBITS, KPR, KRET
      DIMENSION KGRIB(*)
      DIMENSION KSEC1(*)
C
C     Local variables
      INTEGER IRET, IZERO, I16BIT
C
      INTEGER ILALO
      DIMENSION ILALO(8)
C
      LOGICAL LENCODE, LDECODE
C
C     16-bits set to 1
      DATA I16BIT/ 65535 /
C
C     ------------------------------------------------------------------
C*    Section 1 . Set initial values.
C     ------------------------------------------------------------------
C
  100 CONTINUE
C
      IRET = KRET
      LENCODE = ( HFUNC .EQ. 'C' )
      LDECODE = .NOT. LENCODE
C
C     ------------------------------------------------------------------
C*    Section 2 . Extensions Forecast probabilities (definition 5).
C     ------------------------------------------------------------------
C
  200 CONTINUE
C
C*    Octet 50 : Forecast probability number
C                One 8 bit field.
C
C     Insert/extract field.
C
      CALL INXBIT (KGRIB,KLENG,KNSPT,KSEC1(42),1,KBITS, 8,HFUNC,KRET)
      IF (KRET.NE.0) THEN
        KRET = 2
        WRITE(GRPRSM,9004)
        GO TO 900
      ENDIF
C
C*    Octet 51 : Total number of forecast probabilities
C                One 8 bit field.
C
C     Insert/extract field.
C
      CALL INXBIT (KGRIB,KLENG,KNSPT,KSEC1(43),1,KBITS, 8,HFUNC,KRET)
      IF (KRET.NE.0) THEN
        KRET = 2
        WRITE(GRPRSM,9004)
        GO TO 900
      ENDIF
C
C*    Octet 52 : Threshold units decimal scale factor.
C                One 8 bit field.
C
C     When coding data, set sign bit to 1 if value is negative:
      IF ( LENCODE ) CALL CSGNBT( ILALO(1), KSEC1(44),  8, KRET)
C
C     Insert/extract field.
C
      CALL INXBIT (KGRIB,KLENG,KNSPT,ILALO(1),1,KBITS, 8,HFUNC,KRET)
      IF (KRET.NE.0) THEN
        KRET = 2
        WRITE(GRPRSM,9004)
        GO TO 900
      ENDIF
C
C     When decoding, use sign bit ( =  1 if value is negative)
      IF ( LDECODE ) CALL DSGNBT( KSEC1(44), ILALO(1),  8, KRET)
C
C     Octet 53 : Threshold indicator.
C                One 8 bit field.
C
C     Insert/extract field.
C
      CALL INXBIT (KGRIB,KLENG,KNSPT,KSEC1(45),1,KBITS, 8,HFUNC,KRET)
      IF (KRET.NE.0) THEN
        KRET = 2
        WRITE(GRPRSM,9004)
        GO TO 900
      ENDIF
C
C
C*    Octet 54-55 : Lower threshold.
C                   One 16 bit field.
C
C     Check if lower threshold is present ..
      IF ( KSEC1(45) .NE. 2 ) THEN
C
C       When coding data, set sign bit to 1 if value is negative:
        IF ( LENCODE ) CALL CSGNBT( ILALO(1), KSEC1(46), 16, KRET)
C
C       Insert/extract fields.
C
        CALL INXBIT(KGRIB,KLENG,KNSPT,ILALO(1),1,KBITS,16,HFUNC,KRET)
        IF (KRET.NE.0) THEN
          KRET = 2
          WRITE(GRPRSM,9004)
          GO TO 900
        ENDIF
C
C       When decoding, use sign bit ( =  1 if value is negative)
        IF ( LDECODE ) CALL DSGNBT( KSEC1(46), ILALO(1), 16, KRET)
C
C     .. if not present, set value to 16 bits all set to 1
      ELSE
          IF ( LENCODE ) THEN
            I16BIT = 65535
            CALL INXBIT(KGRIB,KLENG,KNSPT,I16BIT,1,KBITS,16,HFUNC,KRET)
            IF (KRET.NE.0) THEN
              KRET = 2
              WRITE(GRPRSM,9004)
              GO TO 900
            ENDIF
          ELSE
            I16BIT = 65535
            KSEC1(46) = I16BIT
            KNSPT = KNSPT + 16
          ENDIF
      ENDIF
C
C     Octet 56-57 : Upper threshold.
C                   One 16 bit field.
C
C     Check if upper threshold is present ..
      IF ( KSEC1(45) .NE. 1 ) THEN
C
C       When coding data, set sign bit to 1 if value is negative:
        IF ( LENCODE ) CALL CSGNBT( ILALO(1), KSEC1(47), 16, KRET)
C
C       Insert/extract fields.
C
        CALL INXBIT(KGRIB,KLENG,KNSPT,ILALO(1),1,KBITS,16,HFUNC,KRET)
        IF (KRET.NE.0) THEN
          KRET = 2
          WRITE(GRPRSM,9004)
          GO TO 900
        ENDIF
C
C       When decoding, use sign bit ( =  1 if value is negative)
        IF ( LDECODE ) CALL DSGNBT( KSEC1(47), ILALO(1), 16, KRET)
C
      ELSE
        IF ( LENCODE ) THEN
          I16BIT = 65535
          CALL INXBIT(KGRIB,KLENG,KNSPT,I16BIT,1,KBITS,16,HFUNC,KRET)
          IF (KRET.NE.0) THEN
            KRET = 2
            WRITE(GRPRSM,9004)
            GO TO 900
          ENDIF
        ELSE
          I16BIT = 65535
          KSEC1(47) = I16BIT
          KNSPT = KNSPT + 16
        ENDIF
      ENDIF
C
C
C     Octet 58 : Reserved - set to zero.
C                One 8 bit field.
C
C     Insert/extract field.
      IZERO = 0
      CALL INXBIT (KGRIB,KLENG,KNSPT, IZERO ,1,KBITS, 8,HFUNC,KRET)
      IF (KRET.NE.0) THEN
        KRET = 2
        WRITE(GRPRSM,9004)
        GO TO 900
      ENDIF
C
C     ------------------------------------------------------------------
C*    Section 9 . Abort/return to calling routine. Format statements.
C     ------------------------------------------------------------------
C
  900 CONTINUE
C
      IF( KPR.GE.1 ) THEN
        WRITE(GRPRSM,*) 'ECDEF5 : Section 9.'
        WRITE(GRPRSM,*) '         Output values set -'
        WRITE(GRPRSM,9003) KNSPT
      ENDIF
C
C     Abort if requested to do so when an error has been encountered.
C
      IF (IRET.EQ.0.AND.KRET.NE.0) THEN
        CALL ABORTX ('ECDEF5')
      ELSE
        RETURN
      ENDIF
C
 9003 FORMAT (1H ,'         KNSPT  = ',I12)
C
 9004 FORMAT (' ECDEF5: Error reported by routine INXBIT.')
C
      END

C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      INTEGER FUNCTION HSP2GG2(KTRUNC,NS,EW,KGAUSS,KPTS,PLATS,KSIZE)
C
C---->
C**** HSP2GG2
C
C     Purpose
C     -------
C
C     This routine finds a suitable gaussian grid for a given
C     spectral truncation.
C
C
C     Interface
C     ---------
C
C     IRET = HSP2GG2(KTRUNC,KGAUSS,KPTS,KSIZE)
C
C
C     Input parameters
C     ----------------
C
C     KTRUNC - The spectral truncation
C
C
C     Output parameters
C     -----------------
C
C     KGAUSS - The gaussian number
C     KPTS   - Array giving number of points along each line of latitude
C              in the reduced gaussian grid (both hemispheres)
C     PLATS  - Array giving gaussian latitudes (both hemispheres)
C     KSIZE  - The number of points in the reduced gaussian grid
C
C     Returns 0 if all OK, otherwise there is an error.
C
C
C     Common block usage
C     ------------------
C
C     None
C
C
C     Method
C     ------
C
C     None
C
C
C     Externals
C     ---------
C
C     JGETGG - Reads the definition of a gaussian grid
C
C
C     Reference
C     ---------
C
C     None.
C
C
C     Comments
C     --------
C
C     None.
C
C
C     Author
C     ------
C
C     J.D.Chambers      ECMWF      February 2001
C
C
C     Modifications
C     -------------
C
C     S.Curic     ECMWF      March 2005
C     Added checking for a automatic trancation T255, T399, T799, T2047 
C     and corresponding gaussian grid.
C
C     S.Curic     ECMWF      April 2008
C     Added checking for a automatic trancation T1279
C     and corresponding gaussian grid.
C
C
C     S.Curic     ECMWF      Semptember 2009
C     Match T255 and T213 against N128 instead of N160
C     upon Alan Geer request
C
C----<
C     -----------------------------------------------------------------|
C*    Section 0. Definition of variables.
C     -----------------------------------------------------------------|
C
      IMPLICIT NONE
C
#include "parim.h"
C
C     Function arguments
C
      INTEGER KTRUNC, KGAUSS, KPTS(*), KSIZE
      REAL NS, EW, STEP
      REAL PLATS(*)
#include "jparams.h"
C
C     Local variables
C
      INTEGER LOOP, IRET
      LOGICAL LDEBUG
C
C
C     -----------------------------------------------------------------|
C     Section 1.  Initialise.
C     -----------------------------------------------------------------|
      STEP = MIN(ABS(NS),ABS(EW))
C
  100 CONTINUE
C
      HSP2GG2 = 0
c
      CALL JDEBUG()
      LDEBUG = ( NDBG.NE.0 )

C     2.5 and greater -> T63
C
      IF( STEP.GE.2.5 ) THEN
        KTRUNC = 63
        KGAUSS  = 48
        GOTO 890
      ENDIF
C
C     1.5 to 2.5      -> T106
C
      IF( STEP.GE.1.5 ) THEN
        KTRUNC = 106
        KGAUSS = 80
        GOTO 890
      ENDIF
C
C     1.5 to 2.5      -> T191
C
CCC      IF( STEP.GE.0.4 ) THEN
CCC        KTRUNC = 191
CCC        KGAUSS  = 96
CCC        GOTO 890
CCC      ENDIF
C
C     0.6 to 1.5      -> T213
C
      IF( STEP.GE.0.6 ) THEN
        KTRUNC = 213
        KGAUSS  = 128
        GOTO 890
      ENDIF
C
C     0.4 to 0.6      -> T319
C
      IF( STEP.GE.0.4 ) THEN
        KTRUNC = 319
        KGAUSS  = 160
        GOTO 890
      ENDIF
C
C     0.3 to 0.4      -> T511
C
      IF( STEP.GE.0.3 ) THEN
        KTRUNC  = 511
        KGAUSS  = 256
        GOTO 890
      ENDIF
C
C     0.15 to 0.3      -> T799
C
      IF( STEP.GE.0.15 ) THEN
        KTRUNC  = 799
        KGAUSS  = 400
        GOTO 890
      ENDIF

C
C     0.09 to 0.15      -> T1279
C
      IF( STEP.GE.0.09 ) THEN
        KTRUNC  = 1279
        KGAUSS  = 640
        GOTO 890
      ENDIF
c
      KTRUNC  = 2047
      KGAUSS  = 1024
C
C     Get the reduced gaussian grid information and count the
C     number of points.
C
  890 CONTINUE
      CALL JGETGG(KGAUSS,'R',PLATS,KPTS,IRET)
      IF( IRET.NE.0 ) THEN
        CALL INTLOG(JP_ERROR,
     X    'HSP2GG2: JGETGG failed to get gaussian data',JPQUIET)
        HSP2GG2 = 2
        GOTO 900
      ENDIF
C
      KSIZE = 0
      DO LOOP = 1, KGAUSS*2
        KSIZE = KSIZE + KPTS(LOOP)
      ENDDO

      IF( LDEBUG ) THEN
          CALL INTLOG(JP_DEBUG,
     X    'HSP2GG2: Corresponding Spectral Truncation:',KTRUNC)
          CALL INTLOG(JP_DEBUG,
     X    'HSP2GG2: Corresponding Gaussian Number:',KGAUSS)
      ENDIF
C
C     -----------------------------------------------------------------|
C     Section 9.  Return.
C     -----------------------------------------------------------------|
C
  900 CONTINUE
C
      RETURN
      END

C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE GRPRS0(KSEC0)
C
C---->
C**** GRPRS0 - Print information from Section 0 of GRIB code.
C
C     Purpose.
C     --------
C
C     Print the information in the Indicator
C     Section (Section 0) of decoded GRIB data.
C
C**   Interface.
C     ----------
C
C     CALL GRPRS0(KSEC0)
C
C
C     Input Parameters.
C     -----------------
C
C     KSEC0 - Array of decoded parameters from Section 0.
C
C     Output Parameters.
C     ------------------
C
C     None.
C
C     Method.
C     -------
C
C     Fields are printed as integers.
C
C     Externals.
C     ----------
C
C     Common block GRPRSCM.
C
C     Reference.
C     ----------
C
C     WMO Manual on Codes re GRIB Code.
C     See also routine GRIBEX.
C
C     Comments.
C     ---------
C
C     Checks environment variable GRPRS_STREAM for output stream number
C     for printing (default is 6)
C
C     Author.
C     -------
C
C     J. Hennessy    ECMWF 18.06.91
C
C     Modifications.
C     --------------
C
C     J. Hennessy    ECMWF 30.08.91
C     Changes to some comments only.
C
C     J.D.Chambers   ECMWF    June 2002
C     Add option to set output stream number using environment variable
C     GRPRS_STREAM
C
C     -----------------------------------------------------------------|
C----<
C
C     -----------------------------------------------------------------|
C*    Section 0. Definition of variables
C     -----------------------------------------------------------------|
C
      IMPLICIT NONE
C
#include "grprs.h"
C
      INTEGER KSEC0(*)
C
C     -----------------------------------------------------------------|
C*    Section 1 . Print required information.
C     -----------------------------------------------------------------|
C
  100 CONTINUE
C
      WRITE(GRPRSM,9000)
      WRITE(GRPRSM,9001)
      WRITE(GRPRSM,9002)
      WRITE(GRPRSM,9003) KSEC0(1)
      WRITE(GRPRSM,9004) KSEC0(2)
C
C     -----------------------------------------------------------------|
C*    Section 9 . Format statements. Return to calling routine.
C     -----------------------------------------------------------------|
C
  900 CONTINUE
C
 9000 FORMAT(1H )
 9001 FORMAT(1H ,'Section 0 - Indicator Section.       ')
 9002 FORMAT(1H ,'-------------------------------------')
 9003 FORMAT(1H ,'Length of GRIB message (octets).     ',I9)
 9004 FORMAT(1H ,'GRIB Edition Number.                 ',I9)
C
      RETURN
C
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities
C granted to it by virtue of its status as an intergovernmental organisation
C nor does it submit to any jurisdiction.
C

      INTEGER FUNCTION AREACHK(EW,NS,NORTH,WEST,SOUTH,EAST)
C
C---->
C**** AREACHK
C
C     Purpose
C     -------
C
C     Fixup input/output field area definitions according to grid
C     specification.
C
C
C     Interface
C     ---------
C
C     IRET = AREACHK(EW,NS,NORTH,WEST,SOUTH,EAST)
C
C     Input
C     -----
C
C     For latitude/longitude grids:
C     EW    =  East-west grid interval (degrees)
C     NS    =  North-south grid interval (degrees)
C
C     For gaussian grids:
C     EW    =  gaussian grid number
C     NS    =  0
C
C     NORTH =  North latitude (degrees)
C     WEST  =  West longitude (degrees)
C     SOUTH =  South latitude (degrees)
C     EAST  =  East longitude (degrees)
C
C     For spherical harmonics:
C     EW    =  0
C     NS    =  0
C     NORTH =  0
C     WEST  =  0
C     SOUTH =  0
C     EAST  =  0
C
C
C     Output
C     ------
C
C     NORTH =  North latitude, adjusted if necessary (degrees)
C     WEST  =  West longitude, adjusted if necessary (degrees)
C     SOUTH =  South latitude, adjusted if necessary (degrees)
C     EAST  =  East longitude, adjusted if necessary (degrees)
C
C
C     Method
C     ------
C
C     If default (0/0/0/0) selected for input, input area is set
C       - to global for lat/long grid
C       - to global for gaussian grid
C
C     Output area is adjusted to fit the given grid by expanding
C     the area if necessary.
C
C
C     Externals
C     ---------
C
C     DSSAREA - Fixup input/output field area (dissemination style).
C     JGETGG  - Reads the definition of a gaussian grid.
C     JNORSGG - Finds the lat row in a gauss grid N or S of given lat
C     INTLOG  - Logs error messages.
C
C
C     Author
C     ------
C
C     J.D.Chambers     ECMWF     Apr 1996
C
C----<
C
      IMPLICIT NONE
C
#include "parim.h"
#include "nifld.common"
#include "nofld.common"
C
C     Parameters
C
      INTEGER JPROUTINE
      PARAMETER (JPROUTINE = 19200 )
      REAL RRMULT
#if (defined hp) && (!defined INTEGER_8)
      INTEGER NP90, NP360, NFACTOR
      PARAMETER ( NFACTOR = 10 )
#else
      INTEGER*8 NP90, NP360, NFACTOR
      PARAMETER ( NFACTOR = 1000 )
#endif
      PARAMETER ( NP90    = JP90*NFACTOR )
      PARAMETER ( NP360   = JP360*NFACTOR )
      PARAMETER ( RRMULT  = (PPMULT*NFACTOR) )
C
C     Function arguments
C
      REAL EW, NS, NORTH, WEST, SOUTH, EAST
C
C     Local variables
C
#if (defined hp) && (!defined INTEGER_8)
      INTEGER INORTH, IWEST, ISOUTH, IEAST, IEW, INS
      INTEGER TNORTH, TWEST, TSOUTH, TEAST
      INTEGER NWEST, NEAST
#else
      INTEGER*8 INORTH, IWEST, ISOUTH, IEAST, IEW, INS
      INTEGER*8 TNORTH, TWEST, TSOUTH, TEAST
      INTEGER*8 NWEST, NEAST
#endif
      CHARACTER*12 YFLAG
      CHARACTER*1 HTYPE
      INTEGER NGAUSS, NOLD, IRET, KPTS
      DIMENSION KPTS(JPGTRUNC*2)
      DATA NOLD /0/
      REAL RNORTH, RSOUTH
      LOGICAL LDEFIN, LGAUSS, LSPHERE, LSUBAR, LINSIDE
      REAL RGAUSS
      DIMENSION RGAUSS(JPGTRUNC*2)
      REAL*8 DEW, DNS, DNORTH, DWEST, DSOUTH, DEAST
C
C     Externals
C
      INTEGER JNORSGG, DSSAREA
C
      SAVE NOLD, RGAUSS
C
C     -----------------------------------------------------------------|
C*    Section 1.   Initialise
C     -----------------------------------------------------------------|
C
  100 CONTINUE
      AREACHK = 0
      LINSIDE=.FALSE.
      LGAUSS  = ( NS.EQ.0.0 )
      LSPHERE = ( (EW.EQ.0.0).AND.(NS.EQ.0.0) )

C     Force grid points inside required area
       CALL GETENV('MARS_INTERPOLATION_INWARDS', YFLAG)
       IF( YFLAG(1:1).EQ.'1' ) LINSIDE = .TRUE.

C     Don't adjust area if rotation specified
C
      IF( LNOROTA ) GOTO 900
C
C     If dissemination style areas required ...
C
      IF( (LNOSTYLE.AND.(NOSTYLE.EQ.JPSDISM)).OR.LINSIDE ) THEN
        AREACHK = DSSAREA( EW, NS, NORTH, WEST, SOUTH, EAST )
        GOTO 900
      ENDIF
C
C     If it's gaussian, pick up the gaussian grid definitions unless
C     they have already been retrieved.
C
      IF( LGAUSS.AND..NOT.LSPHERE ) THEN
        NGAUSS = NINT( EW )
#if (defined hp) && (!defined INTEGER_8)
        IF( NGAUSS.GE.256 ) THEN
          CALL INTLOG(JP_ERROR,
     X      'AREACHK: unsafe to use 32-bit HP version for gaussian = ',
     X      NGAUSS)
          AREACHK = JPROUTINE + 1
          GOTO 900
        ENDIF
#endif
        IF( NGAUSS.GT.JPGTRUNC ) THEN
          CALL INTLOG(JP_ERROR,
     X      'AREACHK: Gaussian grid number ', NGAUSS)
          CALL INTLOG(JP_ERROR,
     X      'AREACHK: exceeds current expected maximum ', JPGTRUNC)
          AREACHK = JPROUTINE + 1
          GOTO 900
        ENDIF
C
        IF( NGAUSS.NE.NOLD ) THEN
          NOLD = NGAUSS
          HTYPE = 'F'
          CALL JGETGG(NOLD,HTYPE,RGAUSS,KPTS,IRET)
          IF( IRET.NE.0 ) THEN
            CALL INTLOG(JP_ERROR,
     X        'AREACHK: Failed to pick up gaussian ', JPQUIET)
            CALL INTLOG(JP_ERROR,
     X        'AREACHK: definitions for resolution = ', NOLD)
            AREACHK = JPROUTINE + 2
            GOTO 900
          ENDIF
        ENDIF
      ENDIF
C
C     -----------------------------------------------------------------|
C*    Section 2.   Fixup area if default (0/0/0/0).
C     -----------------------------------------------------------------|
C
  200 CONTINUE
C


C Sinisa added if input area is not global because of stagered grids
C WARNING: the staggered grid condition does not seem good...
      LSUBAR  = ( (NIAREA(1).NE.0).AND.(NIAREA(2).NE.0).AND.
     X            (NIAREA(3).NE.0).AND.(NIAREA(4).NE.0) )
      LSTAGGL = ( (LSUBAR).AND.
     X            (IABS(JP360 - NIAREA(4) - NIAREA(2)).LT.1000) )
      LDEFIN  = ( (NORTH.EQ.0).AND.(WEST.EQ.0).AND.
     X            (SOUTH.EQ.0).AND.(EAST.EQ.0) )
C
      IF( LDEFIN ) THEN
C
        IF( .NOT.LGAUSS ) THEN
C
C         Regular lat/long grid ..
C
          NORTH = 90.0
          WEST  = 0
          SOUTH = -NORTH
          EAST  = 360.0 - EW
C
        ELSE IF( LSPHERE ) THEN
C
C         Spherical harmonics
C
          NORTH = 90.0
          WEST  = 0
          SOUTH = -90.0
          EAST  = 360.0
C
C
        ELSE
C
C         Gaussian grid ..
C WARN: (issue EMOS-199) EAST calculation is only for [F|N] grids, O
C (octahedral) has a finer resolution at the equator for the same NGAUSS
C
          INORTH = JNORSGG( 90.0, RGAUSS, NGAUSS, 0)
          NORTH  = RGAUSS(INORTH)
          WEST   = 0
          ISOUTH = JNORSGG( -90.0, RGAUSS, NGAUSS, 1)
          SOUTH  = -NORTH
          EAST   = 360.0 - 90.0/FLOAT(NGAUSS)
        ENDIF
      ENDIF
C
      IF( LSPHERE ) GOTO 900
C
C     Don't fixup area for ocean products
C
CTim      IF( NILOCAL.EQ.4 ) GOTO 900
C
C     -----------------------------------------------------------------|
C*    Section 3.   Fixup west-east area to correspond to the grid.
C     -----------------------------------------------------------------|
C
  300 CONTINUE
C
      IF( .NOT.LGAUSS ) THEN
C
C       Regular lat/long grid only ..
C
        DEW = EW
        IEW = DNINT( DBLE(DEW * RRMULT) )
C
      ELSE
C
C       Gaussian grid ..
C
C WARN: (issue EMOS-199) EAST calculation is only for [F|N] grids, O
C (octahedral) has a finer resolution at the equator for the same NGAUSS
        IEW = DNINT( (DBLE(NP90) / DBLE(NGAUSS)) )
C
      ENDIF
C
C     Standardise range so that WEST and EAST are >= 0,
C     and EAST > WEST.
C
      IF( WEST.LT.0.0 ) THEN
        WEST = WEST + 360.0
        EAST = EAST + 360.0
      ENDIF
      IF( EAST.GE.WEST ) THEN
        DEAST = EAST
      ELSE
        DEAST = EAST + 360.0
      ENDIF
C
      DWEST = WEST
      IEAST = DNINT( DEAST * DBLE(RRMULT) + 0.1 )
      TEAST = IEAST
      IWEST =  DINT( DWEST * DBLE(RRMULT) + 0.1 )
      TWEST = IWEST
C
C     Round east boundary to nearest gridpoint eastwards,
C     and west boundary to nearest gridpoint westwards.
C
      NEAST = (IEAST+IEW-1) / IEW
      IEAST = NEAST * IEW


        IF(.NOT.LSTAGGL.AND.LSUBAR.AND.IEAST.GT.TEAST) THEN
           IEAST = IEAST - IEW
        ENDIF


      NWEST = IWEST / IEW
      IWEST = NWEST * IEW

c Sinisa to add 1 point if we have stagered global field
        IF(.NOT.LSTAGGL.AND.LSUBAR.AND.IWEST.LT.TWEST) THEN
             IWEST = IWEST + IEW
        ENDIF
C
C     Try to catch special case: global west-east with wrap-around.
C
      IF( (IEAST-IWEST).GE.NP360 ) THEN
        IF( LGAUSS) THEN
          IEAST = IWEST + (4*NGAUSS-1)*IEW
        ELSE
          IEAST = IWEST + NP360 - IEW
        ENDIF
      ENDIF
C
C     Ensure East and West still in range (0,360)
C
      IF( IEAST.GT.NP360 ) THEN
        IEAST = IEAST - NP360
        IWEST = IWEST - NP360
      ENDIF
      IF( IWEST.LT.-NP360 ) THEN
        IEAST = IEAST + NP360
        IWEST = IWEST + NP360
      ENDIF
C
C     Ensure East-West spread is not greater than 360
C
      IF( (IEAST-IWEST).GT.NP360 ) THEN
        IF( LGAUSS) THEN
          IEAST = IWEST + (4*NGAUSS-1)*IEW
        ELSE
          IEAST = IWEST + NP360 - IEW
        ENDIF
      ENDIF
C
C     Apply adjustment when east and west boundaries are the same
C     longitude (0/360) to give a global grid.
C
      IF( ( (IWEST.EQ.-NP360).AND.(IEAST.EQ.0)     ).OR.
     X    ( (IWEST.EQ.0)     .AND.(IEAST.EQ.NP360) ).OR.
     X    ( (IWEST.EQ.NP360) .AND.(IEAST.EQ.NP360) ) ) THEN
        IWEST = 0
        IF( LGAUSS) THEN
          IEAST = (4*NGAUSS-1)*IEW
        ELSE
          IEAST = NP360 - IEW
        ENDIF
      ENDIF
C
      WEST  = DBLE(IWEST) / RRMULT
      EAST  = DBLE(IEAST) / RRMULT
C
      IF( (EAST.LT.WEST).OR.(EAST.GT.360.0) ) THEN
        CALL INTLOG(JP_ERROR,
     X    'AREACHK: Faulty longitude limits', JPQUIET)
        CALL INTLOGR(JP_ERROR,'AREACHK: East = ', EAST)
        CALL INTLOGR(JP_ERROR,'AREACHK: West = ', WEST)
        AREACHK = JPROUTINE + 3
        GOTO 900
      ENDIF
C
C     -----------------------------------------------------------------|
C*    Section 4.   Fixup north-south area to correspond to the grid.
C     -----------------------------------------------------------------|
C
  400 CONTINUE
c for ocean fields, adjust ew but not ns boundaries
      IF( NILOCAL.EQ.4 ) GOTO 900
C
      IF( .NOT.LGAUSS ) THEN
C
C       Regular lat/long grid only ..
C
C       Round north boundary to nearest gridpoint northwards.
C
        DNS = NS
        INS = DNINT( DBLE(DNS * RRMULT) )
        DNORTH = NORTH
        INORTH = DNINT( DBLE(DNORTH * RRMULT) )
        TNORTH = INORTH
        IF( INORTH.GE.0 ) THEN
          INORTH = (INORTH+INS-1) / INS
        ELSE
          INORTH = INORTH / INS
        ENDIF
        INORTH = INORTH * INS

        IF( INORTH.GT.NP90 ) INORTH = NP90
        IF( INORTH.LT.-NP90 ) INORTH = -NP90

        IF(.NOT.LSTAGGL.AND.LSUBAR.AND.INORTH.GT.TNORTH) THEN
             INORTH = INORTH - INS
        ENDIF

        NORTH = DBLE(INORTH) / RRMULT
C
C       Round south boundary to nearest gridpoint southwards.
C
        DSOUTH = SOUTH
        ISOUTH = DNINT( DBLE(DSOUTH * RRMULT) )
        TSOUTH = ISOUTH
        IF( ISOUTH.GE.0 ) THEN
          ISOUTH = ISOUTH / INS
        ELSE
          ISOUTH = (ISOUTH-INS+1) / INS
        ENDIF
        ISOUTH = ISOUTH * INS

        IF( ISOUTH.GT.NP90 ) ISOUTH = NP90
        IF( ISOUTH.LT.-NP90 ) ISOUTH = -NP90

        IF(.NOT.LSTAGGL.AND.LSUBAR.AND.ISOUTH.LT.TSOUTH) THEN
             ISOUTH = ISOUTH + INS
        ENDIF


        SOUTH = DBLE(ISOUTH) / RRMULT
C
      ELSE
C
C       Gaussian grid ..
C
C       Round north boundary to nearest gridpoint northwards.
C
        RNORTH = NORTH
        INORTH = JNORSGG( RNORTH, RGAUSS, NGAUSS, 1)
        NORTH  = RGAUSS(INORTH)
C
C       Round south boundary to nearest gridpoint southwards.
C
        RSOUTH = SOUTH
        ISOUTH = JNORSGG( RSOUTH, RGAUSS, NGAUSS, 0)
        SOUTH  = RGAUSS(ISOUTH)
C
      ENDIF
C
C     -----------------------------------------------------------------|
C*    Section 9.   Closedown.
C     -----------------------------------------------------------------|
C
  900 CONTINUE
C
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE BUS012( KBUFL,KBUFF,KSUP,KSEC0,KSEC1,KSEC2,KERR)
C
C**** *BUS012*
C
C
C     PURPOSE.
C     --------
C          EXPANDS SECTION 0,1 AND 2 OF BUFR MESSAGE.
C
C
C**   INTERFACE.
C     ----------
C
C          *CALL* *BUS012( KBUFL,KBUFF,KSUP,KSEC0,KSEC1,KSEC2,KERR)*
C
C        INPUT :
C               *KBUFL*   -  LENGTH OF BUFR MESSAGE (WORDS)
C               *KBUFF*   -  ARRAY CONTAINING BUFR MESSAGE
C        OUTPUT:
C               *KSUP*    -  ARRAY CONTAINING SUPLEMENTARY INFORMATION
C                         -  KSUP( 1) -- IDIM1, DIMENSION OF KSEC1
C                         -  KSUP( 2) -- IDIM2, DIMENSION OF KSEC2
C                         -  KSUP( 3) -- IDIM3, DIMENSION OF KSEC3
C                         -  KSUP( 4) -- IDIM4, DIMENSION OF KSEC4
C                         -  KSUP( 5) -- M (NUMBER OF ELEMENTS IN VALUES ARRAY,
C                                           FIRST INDEX)
C                         -  KSUP( 6) -- N (NUMBER OF SUBSETS,SECOND INDEX OF
C                                           VALUES ARRAY)
C                         -  KSUP( 7) -- JVC (NUMBER OF ELEMENTS IN CVAL ARRAY)
C                         -  KSUP( 8) -- TOTAL BUFR MESSAGE LENGTH IN BYTES
C                         -  KSUP( 9) -- IDIM0, DIMENSION OF KSEC0
C               *KSEC0*   -  ARRAY CONTAINING SECTION 0 INFORMATION
C                            KSEC0( 1)-- LENGTH OF SECTION 0 (BYTES)
C                            KSEC0( 2)-- TOTAL LENGTH OF BUFR MESSAGE (BYTES)
C                            KSEC0( 3)-- BUFR EDITION NUMBER
C               *KSEC1*   -  ARRAY CONTAINING SECTION 1 INFORMATION
C                            KSEC1( 1)-- LENGTH OF SECTION 1 (BYTES)
C                            KSEC1( 2)-- BUFR EDITION NUMBER
C                            KSEC1( 3)-- ORIGINATING CENTRE
C                            KSEC1( 4)-- UPDATE SEQUENCE NUMBER
C                            KSEC1( 5)-- FLAG (PRESENCE OF SECTION 2)
C                            KSEC1( 6)-- BUFR MESSAGE TYPE
C                            KSEC1( 7)-- BUFR MESSAGE SUBTYPE
C                            KSEC1( 8)-- VERSION NUMBER OF LOCAL TABLE USED
C                            KSEC1( 9)-- YEAR
C                            KSEC1(10)-- MONTH
C                            KSEC1(11)-- DAY
C                            KSEC1(12)-- HOUR
C                            KSEC1(13)-- MINUTE
C                            KSEC1(14)-- BUFR MASTER TABLE
C                            KSEC1(15)-- VERSION NUMBER OF MASTER TABLE USED
C
C                            FOR BUFR EDITION 3 ONWARD
C
C                            KSEC1(16)-- ORIGINATING SUB-CENTRE
C                            KSEC1(17)-- NOT USED
C                            KSEC1(18) TO KSEC1(JSEC1) - LOCAL ADP CENTRE
C                                        INFORMATION(PACKED FORM)
C
C                            FOR BUFR EDITION 4 ONWARD
C
C                            KSEC1(16)-- ORIGINATING SUB-CENTRE
C                            KSEC1(17)-- INTERNATIONAL SUB-CATEGORY (SEE COMMON TABLE C-13
C                            KSEC1(18)-- SECOND
C                            KSEC1(19)-- YEAR
C                            KSEC1(20)-- MONTH
C                            KSEC1(21)-- DAY
C                            KSEC1(22)-- HOUR
C                            KSEC1(23)-- MINUTE
C                            KSEC1(24)-- SECOND
C                            KSEC1(25)-- YEAR
C                            KSEC1(26)-- MONTH
C                            KSEC1(27)-- DAY
C                            KSEC1(28)-- HOUR
C                            KSEC1(29)-- MINUTE
C                            KSEC1(30)-- SECOND
C                            KSEC1(31)-- MOST SOUTHERN LATITUDE  (-90 to 90)
C                            KSEC1(32)-- MOST WESTERN LONGITUDE  ( 0-360)
C                            KSEC1(33)-- MOST NORTHEN LATITUDE   (-90 to 90)
C                            KSEC1(34)-- MOST EASTERN LONGITUDE  ( 0-360)
C                            KSEC1(35) TO KSEC1(JSEC1) - LOCAL ADP CENTRE INFORMATION(PACKED FORM)
C
C               *KSEC2*   -  ARRAY CONTAINING SECTION 2 INFORMATION
C                            KSEC2( 1)-- LENGTH OF SECTION 2 (BYTES)
C                            KSEC2( 2) TO KSEC2(47) RDB KEY
C               *KERR*    -  RETURNED ERROR CODE
C
C     METHOD.
C     --------
C
C          NONE.
C
C     EXTERNALS.
C     ----------
C
C          BUEXS0          - UNPACK SECTION 0
C          BUEXS1          - UNPACK SECTION 1
C          BUEXS2          - UNPACK SECTION 2
C
C     REFERENCE.
C     ----------
C
C          NONE.
C
C     AUTHOR.
C     -------
C
C          M. DRAGOSAVAC    *ECMWF*       15/07/91.
C
C
C     MODIFICATIONS.
C     --------------
C
C          NONE.
C
C
      IMPLICIT LOGICAL(L,O,G), CHARACTER*8(C,H,Y)
C
C
C
#     include "parameter.F"
#     include "bcomunit.F"
#     include "bcomwork.F"
#     include "bcomwt.F"
#     include "bcomdefc.F"
#     include "bcomreq.F"
C
      DIMENSION KBUFF(KBUFL)
      DIMENSION KSUP(*),KSEC0(*),KSEC1(*)
      DIMENSION KSEC2(*)
      DIMENSION KSEC3(JSEC3)
#ifndef R_4
      REAL*8 RVIND
      REAL*8 EPS
      REAL*8 RQVAL
#else
      REAL   RVIND
      REAL   EPS
      REAL   RQVAL
#endif
C
      CHARACTER*4 CECMWF,CUSER
C
C     ------------------------------------------------------------------
C*          1.   SET CONSTANTS.
C                --------------
 100  CONTINUE
C
      KERR=0
C
      IF(CECMWF.NE.'ECMF') THEN
         CALL BUEVAR(KERR)
         CECMWF='ECMF'
      END IF
C
      IF(CUSER.NE.'USER') THEN
         NREQ(1)=0
         NREQ(2)=0
         NRQL=0
      END IF
C     -----------------------------------------------------------------
C
C*          2.  EXPAND SECTION 0.
C               -----------------
 200  CONTINUE
C
      CALL BUEXS0( KBUFL,KBUFF,KSUP,KSEC0,KERR )
      IF(KERR.GT.0) RETURN
C
C     ------------------------------------------------------------------
C
C*          3.   EXPAND SECTION 1.
C                ------------------
 300  CONTINUE
C
      CALL BUEXS1( KBUFL,KBUFF,KSUP,KSEC0,KSEC1,KERR )
      IF(KERR.GT.0) RETURN
C
C     ------------------------------------------------------------------
C
C*          4.  EXPAND SECTION 2.
C               -----------------
 400  CONTINUE
C
      CALL BUEXS2( KBUFL,KBUFF,KSUP,KSEC1,KSEC2,KERR )
      IF(KERR.GT.0) RETURN
C
C*          5.  EXPAND SECTION 3 (PRELIMINARY ITEMS).
C               -------------------------------------
 500  CONTINUE
C
      CALL BUEXS3P(KBUFL,KBUFF,KSUP,KSEC3,KERR)
C
      RETURN
      END

C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      INTEGER FUNCTION C2PACK ( KDATA,  KLENP,  KSEC4,  KGRIB,  KLENG,
     X                          KNSPT,  KBITS,  KLEN,   KREFGR, KLENGR,
     X                          KBITGR, KWORK,  KLWORK, KPOWER, KMXPWR,
     X                          KNBIFO, ODEBUG )
C
C---->
C**** C2PACK
C
C     Purpose.
C     --------
C
C     Packs end of GRIB section 4 (except final padding)
C     for second-order packing methods, and computes some descriptors.
C
C
C**   Interface.
C     ----------
C
C     KRET = C2PACK ( KDATA,  KLENP,  KSEC4,  KGRIB,  KLENG,  KNSPT,
C    X                KBITS,  KLEN,   KREFGR, KLENGR, KBITGR, KWORK,
C    X                KLWORK, KPOWER, KMXPWR, KNBIFO, ODEBUG )
C
C
C     Input Parameters.
C     ----------------
C
C     KDATA      - Array of normalized values.
C     KLENP      - Length of array KDATA.
C     KSEC4      - Array of GRIB section 4 integer descriptors.
C     KLENG      - Length of GRIB product array.
C     KNSPT      - Bit pointer for next value in GRIB product.
C     KBITS      - Number of bits per computer word.
C     KLEN       - Exact number of grid-points to handle.
C     KREFGR     - Work array, first-order values for each group.
C     KLENGR     - Work array, effective length of each group.
C     KBITGR     - Work array, bit number ("width") of each group.
C     KLWORK     - Length of work arrays.
C     KPOWER     - Auxilary array, containing precomputed powers of 2-1.
C     KMXPWR     - Maximum number of bits per original scaled value.
C     KNBIFO     - Number of BIts for coding First-Order values.
C     ODEBUG     - True for some debug printout.
C
C
C     Output Parameters.
C     -----------------
C
C     KDATA      - Used as work array for second-order values,
C                  and secondary bit-map (if any).
C     KSEC4      - Array of GRIB section 4 integer descriptors
C                  (completed).
C     KGRIB      - Array containing GRIB product.
C     KNSPT      - Bit pointer for next value in GRIB product (updated).
C     KREFGR     - Work array, re-used for variable width methods.
C     KBITGR     - Work array, re-used for variable width methods.
C     KWORK      - Work array, used for variable width methods.
C
C
C     Method.
C     -------
C
C     Follows WMO Manual of Codes.
C
C     Externals.
C     ----------
C
C     C2PKVW    - Packs 2nd-order values for variable width methods.
C     INXBIT    - Insert bits into GRIB product.
C     PRTBIN    - Transform integer value in printable "binary" format.
C     CSGNBT    - Codes an integer value and its sign bit.
C
C
C     Reference.
C     ----------
C
C     None.
C
C
C     Comments.
C     --------
C
C     On entry, KNSPT points to the first bit of section 4 
C               in the GRIB product.
C     On exit,  KNSPT points to the first unused bit of section 4,
C               (or to the first bit of section 5, if unused bit count
C                is zero) in the GRIB product.
C
C     KDATA is overwritten. This is coherent with GRIBEX coding.
C
C         Detailed use of KSEC4 as input/output argument
C         ----------------------------------------------
C
C     KSEC4(4) set to 64 to indicate complex packing.
C     KSEC4(6)  "   " 16  "    "     presence of extended flags.
C
C     KSEC4(9) used to know secondary bit-map use (0=no,32=yes).
C     KSEC4(10)  "   "   "  constant/variable width (0=constant,16=var).
C     KSEC4(11)  "   "   "  for width value, if constant.
C     KSEC4(11) used to know width of spatial differencing descriptors.
C     KSEC4(11) set to width of lengths for general extended method,
C               for consistency with D2ORDR routine.
C     KSEC4(12) used to know general extended packing (0=no,8=yes).
C     KSEC4(13)   "   "   "  boustrophedonic ordering (0=no,4=yes).
C     KSEC4(14) (0 or 2) and KSEC4(15) (0 or 1) used to know spatial
C               differencing through their sum (0=no,1/2/3=order used).
C     KSEC4(16) used to know bias for spatial differencing.
C     KSEC4(17)   "   "   "  width of lengths for general extended
C                            method.
C     KSEC4(16) set to pointer to first-order values.
C     KSEC4(17)  "   "    "    "  2nd-order     "   .
C     KSEC4(18) set to number of first-order values.
C     KSEC4(19)  "   "    "   "  2nd-order     "   .
C     KSEC4(20) used to know width of groups.
C
C
C     Author.
C     -------
C
C     J. Clochard, Meteo France, for ECMWF - January 1998.
C
C
C     Modifications.
C     _____________
C
C     J. Clochard, April 1998.
C     Update comments.
C     Introduce spatial differencing.
C
C     J. Clochard, September 1998.
C     Optimisation of bit-string encoding for variable width methods,
C     through routine C2PKVW.
C     Suppress dummy-argument KSEC1, and add KWORK/KPOWER/KMXPWR 
C     in calling syntax.
C
C
C----<
C     -----------------------------------------------------------------
C*    Section 0. Definition of variables.
C     -----------------------------------------------------------------
C
      IMPLICIT NONE
C
#include "grprs.h"
C
C     Parameters
C
      INTEGER JP16SET
C
      PARAMETER ( JP16SET= 2**16-1 )
C                            `---> 65535    =   FFFF(hex)
C
C     Subroutine arguments
C
      INTEGER KLENP, KLENG, KNSPT, KBITS, KLEN, KLWORK, KNBIFO, KMXPWR
      INTEGER KDATA (KLENP), KSEC4 (*), KGRIB (KLENG)
      INTEGER KREFGR (KLWORK), KLENGR (KLWORK), KBITGR (KLWORK)
      INTEGER KWORK (KLWORK), KPOWER (0:KMXPWR)
C
      LOGICAL ODEBUG
C
C     Local variables.
C
      INTEGER ICOUNT, ILDSTA, IZERO, JGROUP, ILNGTH, IFILL, INSPTB
      INTEGER IRET, J, ILVARB, IBITGW, IREFER, IFLAGX, INSPTA
      INTEGER IPTRFO, IPTRSO, IFIROV, ISECOV, IRETFN, IAUXIL
#ifndef wmogrp2o
      INTEGER IEXTRA
#endif
      INTEGER IBITGS, IPTRGS, IORDER, IWIDSD, IBIAS, ILVARX
C
      INTEGER IWORK (3)
C
      INTEGER C2PKVW
      EXTERNAL C2PKVW
C
      CHARACTER YOPER*1
C
      LOGICAL LROW, LCTWID, LSECBI, LVECTP
      LOGICAL LGENXT
C
C     -----------------------------------------------------------------
C*    Section 1 . Initialisations.
C     -----------------------------------------------------------------
C
  100 CONTINUE
C
#ifndef ebug2o
      IF (ODEBUG) THEN
#endif
        WRITE(GRPRSM,FMT=9100) KNSPT
#ifndef ebug2o
      ENDIF
#endif
C
      IRETFN = 0
      IZERO=0
      ILDSTA=21
      INSPTA=KNSPT
      YOPER='C'
      LSECBI=KSEC4(9).NE.0
#if (defined CRAY) || (defined FUJITSU)
      LVECTP=.TRUE.
#else
      LVECTP=.FALSE.
#endif
      LROW=.NOT.LSECBI.AND.KSEC4(12).EQ.0
      LGENXT=.NOT.LSECBI.AND.KSEC4(12).NE.0
      IORDER=KSEC4(14)+KSEC4(15)
      LCTWID=KSEC4(10).EQ.0
      IFIROV=KSEC4(18)
      IBITGW=KSEC4(20)
C
C     Enforce right values for flags, for further use by GRIBEX.
C
      KSEC4(4)=64
      KSEC4(6)=16
C
C     Compute length of "variable-length" descriptors.
C
      IF (LROW) THEN
        ILVARB=8*((8+IFIROV*IBITGW-1)/8)
      ELSEIF (LCTWID) THEN
        ILVARB=8+KLEN
      ELSEIF (LGENXT) THEN
        IBITGS=KSEC4(17)
C
        IF (IORDER.EQ.0) THEN
          ILVARX=4
        ELSE
          IWIDSD=KSEC4(11)
          IBIAS=KSEC4(16)
          ILVARX=5+(8+IWIDSD*(IORDER+1)-1)/8
        ENDIF
C
        ILVARB=8*(ILVARX+(8+IFIROV*IBITGW-1)/8)+IFIROV*IBITGS
C
C       IBITGS stored back in KSEC4(11), for consistency with D2ORDR.
C
        KSEC4(11)=IBITGS
      ELSE
        ILVARB=8*((8+IFIROV*IBITGW-1)/8)+KLEN
      ENDIF
C
C     -----------------------------------------------------------------
C*    Section 2 . Coding of fixed-length descriptors.
C     -----------------------------------------------------------------
C
  200 CONTINUE
C
C     The first 10 octets have already been coded in GRIBEX, or will
C     be in a further step of GRIBEX:
C     Length of section, flags+unused bit count, binary scale factor,
C     reference value.
C
C*    Octet 11 : Number of bits containing each first-order value.
C     One 8 bit field.
C
      KNSPT=KNSPT+10*8
      CALL INXBIT(KGRIB,KLENG,KNSPT,KNBIFO,1,KBITS, 8,YOPER,IRET)
C
      IF (IRET.NE.0) THEN
        IRETFN = 20210
        WRITE(GRPRSM,FMT=9001) 'bit number of first-order values'
        GO TO 900
      ENDIF
C
C     Octets 12 - 13: Octet number of the start of first-order packed 
C                     data.
C     One 16-bit field.
C
      IPTRFO=1+ILDSTA+(8+ILVARB-1)/8
      KSEC4(16)=IPTRFO
      CALL INXBIT(KGRIB,KLENG,KNSPT,KSEC4(16),1,KBITS,16,YOPER,IRET)
C
      IF (IRET.NE.0) THEN
        IRETFN = 20220
        WRITE(GRPRSM,FMT=9001) 'pointer to first-order packed data'
        GO TO 900
      ENDIF
C
C     Octet 14: Extended flags.
C     One 8-bit field.
C
      IFLAGX=KSEC4(9)+KSEC4(10)+KSEC4(12)+KSEC4(13)+KSEC4(14)+KSEC4(15)
      CALL INXBIT(KGRIB,KLENG,KNSPT,IFLAGX,1,KBITS, 8,YOPER,IRET)
C
      IF (IRET.NE.0) THEN
        IRETFN = 20230
        WRITE(GRPRSM,FMT=9001) 'extended flags'
        GO TO 900
      ENDIF
C
C     Octets 15 - 20: Octet number of the start of second-order packed 
C                     data, Number of first-order packed data,
C                     Number of second-order packed data.
C     Three 16-bit fields.
C
      IPTRSO=IPTRFO+(8+IFIROV*KNBIFO-1)/8
      ISECOV=KLEN-IORDER
C
      KSEC4(17)=IPTRSO
      KSEC4(18)=IFIROV
      KSEC4(19)=ISECOV
      CALL INXBIT(KGRIB,KLENG,KNSPT,KSEC4(17),3,KBITS,16,YOPER,IRET)
C
      IF (IRET.NE.0) THEN
        IRETFN = 20240
        WRITE(GRPRSM,FMT=9001) 'standard second-order descriptors'
        GO TO 900
      ENDIF
C
#ifndef wmogrp2o
C     Octet 21: Reserved by WMO, so should be zero in standard case.
C               Could be used for extra bits of group number.
C     One 8-bit field.
C
      IEXTRA=IFIROV/(JP16SET+1)
C
      IF (IEXTRA.NE.0) THEN
        CALL PRTBIN (IEXTRA,8,IAUXIL,IRET)
C
        IF (IRET.NE.0) THEN
          IAUXIL=IEXTRA
        ENDIF
C
        WRITE(GRPRSM,FMT=9255) IFIROV, JP16SET, IEXTRA, IAUXIL
      ENDIF
C
      CALL INXBIT(KGRIB,KLENG,KNSPT,IEXTRA,1,KBITS, 8,YOPER,IRET)
#else
C     Octet 21: Reserved by WMO. Set to zero.
C     One 8-bit field.
C
      CALL INXBIT(KGRIB,KLENG,KNSPT,IZERO,1,KBITS, 8,YOPER,IRET)
#endif
C
      IF (IRET.NE.0) THEN
        IRETFN = 20250
        WRITE(GRPRSM,FMT=9001) 'reserved octet (section 4, 21st)'
        GO TO 900
      ENDIF
C
C     -----------------------------------------------------------------
C*    Section 3. Coding of variable-length descriptors.
C     -----------------------------------------------------------------
C
  300 CONTINUE
C
#ifndef ebug2o
      IF (ODEBUG) THEN
#endif
        CALL PRTBIN (IFLAGX,8,IAUXIL,IRET)
C
        IF (IRET.NE.0) THEN
          IAUXIL=IFLAGX
        ENDIF
C
        WRITE(GRPRSM,FMT=9300) KNBIFO, IAUXIL, IFIROV, ISECOV, IPTRFO,
     X                          IPTRSO
        WRITE(GRPRSM,FMT=9310) 'fixed', KNSPT
#ifndef ebug2o
      ENDIF
C
#endif
C
      IF (LCTWID) THEN
C
C     Octet 22: Common width of groups.
C     One 8-bit field.
C
        CALL INXBIT(KGRIB,KLENG,KNSPT,KSEC4(11),1,KBITS,8,YOPER,IRET)
C
      ELSEIF (LGENXT) THEN
C
C     Octets 22 - 23: Width of widths, Width of lengths.
C     Two 8-bit fields.
C
        IWORK(1)=IBITGW
        IWORK(2)=IBITGS
        CALL INXBIT(KGRIB,KLENG,KNSPT,IWORK,2,KBITS,8,YOPER,IRET)
C
        IF (IRET.NE.0) THEN
          IRETFN = 20310
          WRITE(GRPRSM,FMT=9001)
     X            'Extended descriptors, 1st-order values'
          GO TO 900
        ENDIF
C
C     Octets 24-25: Octet number of the start of group sizes (lengths).
C     One 16-bit field.
C
        IPTRGS = 1 + ILDSTA + ILVARX + (8+IFIROV*IBITGW-1)/8
#ifdef ebug2o
        PRINT *,'c2pack - IBITGW =',IBITGW,', IBITGS =',IBITGS,
     X          ', IPTRGS =',IPTRGS
#endif
        CALL INXBIT(KGRIB,KLENG,KNSPT,IPTRGS,1,KBITS,16,YOPER,IRET)
C
        IF (IRET.NE.0) THEN
          IRETFN = 20315
          WRITE(GRPRSM,FMT=9001) 'General extended group size pointer'
          GO TO 900
        ELSEIF (IORDER.NE.0) THEN
C
C     Octet 26: Width of spatial differencing specific descriptors.
C     One 8-bit field.
C
          CALL INXBIT(KGRIB,KLENG,KNSPT,IWIDSD,1,KBITS,8,YOPER,IRET)
C
          IF (IRET.NE.0) THEN
            IRETFN = 20316
            WRITE(GRPRSM,FMT=9001)
     X           'Width of spatial differencing descriptors'
            GO TO 900
          ELSEIF (IWIDSD.NE.0) THEN
C
C     Octet 27-onwards: first IORDER original values and diff. bias.
C     (IORDER+1) fields of IWIDSD bits.
C
C              Temporarily use KDATA(IORDER+1) for bias and its sign.
C
            IAUXIL=IORDER+1
            IFILL=KDATA(IAUXIL)
            CALL CSGNBT(KDATA(IAUXIL),IBIAS,IWIDSD,IRET)
C
            IF (IRET.NE.0) THEN
              IRETFN = 20317
              WRITE(GRPRSM,FMT=9317) IRET
              GO TO 900
            ENDIF
C
            CALL INXBIT(KGRIB,KLENG,KNSPT,KDATA,IAUXIL,KBITS,IWIDSD,
     X                  YOPER,IRET)
C
            KDATA(IAUXIL)=IFILL
C
            IF (IRET.NE.0) THEN
              IRETFN = 20318
              WRITE(GRPRSM,FMT=9001)
     X           'First field value(s) (spatial differencing case)'
              GO TO 900
            ELSEIF (MOD (KNSPT,8).NE.0) THEN
C
C     Fill up with binary zeros till next octet boundary.
C
              IFILL=8*((8+KNSPT-1)/8)-KNSPT
              CALL INXBIT(KGRIB,KLENG,KNSPT,IZERO,1,KBITS,IFILL,
     X                    YOPER,IRET)
C
              IF (IRET.NE.0) THEN
                IRETFN = 20319
                WRITE(GRPRSM,FMT=9001)
     X             'padding after spatial differencing descriptors'
                GO TO 900
              ENDIF
C
            ENDIF
C
          ENDIF
C
        ENDIF
C
C     Octets XX - XX+(IPTRGS-1): Group widths.
C     IFIROV fields of IBITGW bits.
C
        CALL INXBIT(KGRIB,KLENG,KNSPT,KBITGR,IFIROV,KBITS,IBITGW,
     X              YOPER,IRET)
      ELSE
C
C     Octets 22 - 21+IFIROV: Group widths.
C     IFIROV fields of IBITGW bits.
C
        CALL INXBIT(KGRIB,KLENG,KNSPT,KBITGR,IFIROV,KBITS,IBITGW,
     X              YOPER,IRET)
      ENDIF
C
      IF (IRET.NE.0) THEN
        IRETFN = 20320
        WRITE(GRPRSM,FMT=9001) 'inserting group width(s)'
        GO TO 900
      ELSEIF (MOD (KNSPT,8).NE.0) THEN
C
C     Fill up with binary zeros till next octet boundary.
C
        IFILL=8*((8+KNSPT-1)/8)-KNSPT
        CALL INXBIT(KGRIB,KLENG,KNSPT,IZERO,1,KBITS,IFILL,YOPER,IRET)
C
        IF (IRET.NE.0) THEN
          IRETFN = 20330
          WRITE(GRPRSM,FMT=9001) 'padding after group width(s)'
          GO TO 900
        ENDIF
C
      ENDIF
C
      IF (LSECBI) THEN
C
C     Secondary bit-map will be inserted later, after second-order
C     values processing, to use KDATA as work array. Retain pointer.
C
        INSPTB=KNSPT
        KNSPT=KNSPT+KLEN
C
        IF (MOD (KNSPT,8).NE.0) THEN
C
C     Fill up with binary zeros till next octet boundary.
C
          IFILL=8*((8+KNSPT-1)/8)-KNSPT
          CALL INXBIT(KGRIB,KLENG,KNSPT,IZERO,1,KBITS,IFILL,YOPER,IRET)
C
          IF (IRET.NE.0) THEN
            IRETFN = 20340
            WRITE(GRPRSM,FMT=9001) 'padding after secondary bit-map'
            GO TO 900
          ENDIF
C
        ENDIF
C
      ELSEIF (LGENXT) THEN
C
C     Octets IPTRGS - (IPTRFO-1): General extended group sizes(lengths).
C     IFIROV fields of IBITGS bits.
C
        CALL INXBIT(KGRIB,KLENG,KNSPT,KLENGR,IFIROV,KBITS,IBITGS,
     X              YOPER,IRET)
C
        IF (IRET.NE.0) THEN
          IRETFN = 20350
          WRITE(GRPRSM,FMT=9001) 'General extended group sizes'
          GO TO 900
        ELSEIF (MOD (KNSPT,8).NE.0) THEN
C
C     Fill up with binary zeros till next octet boundary.
C
          IFILL=8*((8+KNSPT-1)/8)-KNSPT
          CALL INXBIT(KGRIB,KLENG,KNSPT,IZERO,1,KBITS,IFILL,YOPER,IRET)
C
          IF (IRET.NE.0) THEN
            IRETFN = 20360
            WRITE(GRPRSM,FMT=9001)
     X            'padding after General extended group sizes'
            GO TO 900
          ENDIF
C
        ENDIF
C
      ENDIF
C
      IF (KNBIFO.NE.0) THEN
C
C     Octets IPTRFO - (IPTRSO-1): First-order values (reference values
C                                                    of groups).
C     IFIROV fields of KNBIFO bits.
C
        CALL INXBIT(KGRIB,KLENG,KNSPT,KREFGR,IFIROV,KBITS,KNBIFO,
     X              YOPER,IRET)
C
        IF (IRET.NE.0) THEN
          IRETFN = 20370
          WRITE(GRPRSM,FMT=9001)
     X         'first-order values (reference values of groups)'
          GO TO 900
        ELSEIF (MOD (KNSPT,8).NE.0) THEN
C
C     Fill up with binary zeros till next octet boundary.
C
          IFILL=8*((8+KNSPT-1)/8)-KNSPT
          CALL INXBIT(KGRIB,KLENG,KNSPT,IZERO,1,KBITS,IFILL,YOPER,IRET)
C
          IF (IRET.NE.0) THEN
            IRETFN = 20380
            WRITE(GRPRSM,FMT=9001) 'padding after first-order values'
     S//' of groups.'
            GO TO 900
          ENDIF
C
        ENDIF
C
      ENDIF
C
C     -----------------------------------------------------------------
C*    Section 4. Coding of data (second-order values).
C     -----------------------------------------------------------------
C
  400 CONTINUE
C
C     Octets IPTRSO - onwards: Second-order values (deviations from
C                                                  groups references).
#ifndef ebug2o
      IF (ODEBUG) THEN
#endif
        WRITE(GRPRSM,FMT=9310) 'variable', KNSPT
#ifndef ebug2o
      ENDIF
C
#endif
      ICOUNT=IORDER
C
      IF (LCTWID) THEN
C
C                      Constant width packing.
C
        IF (KSEC4(11).NE.0) THEN
C
          DO 412 JGROUP=1,IFIROV
C
          ILNGTH=KLENGR(JGROUP)
          IREFER=KREFGR(JGROUP)
C
          DO 411 J=1,ILNGTH
          KDATA(ICOUNT+J)=KDATA(ICOUNT+J)-IREFER
  411     CONTINUE
C
          ICOUNT=ICOUNT+ILNGTH
C
  412     CONTINUE
C
C       Effective coding of second-order values, once for all groups.
C
          CALL INXBIT(KGRIB,KLENG,KNSPT,KDATA,KLEN,KBITS,
     X                KSEC4(11),YOPER,IRET)
C
          IF (IRET.NE.0) THEN
            IRETFN = 20410
            WRITE(GRPRSM,FMT=9001)
     X   'second-order values (deviations from 1st-order values)'
            GO TO 900
          ENDIF
C
        ELSE
          ICOUNT=KLEN
        ENDIF
C
      ELSE
C
C             Packing method(s) with variable width.
C
        IRETFN = C2PKVW ( KDATA,  KLENP,  KGRIB,  KLENG,  KNSPT,
     X                    KBITS,  KLEN,   KREFGR, KLENGR, KBITGR,
     X                    KWORK,  KLWORK, IFIROV, ICOUNT, KPOWER,
     X                    KMXPWR, LROW,   LVECTP, ODEBUG )
C
        IF (IRETFN.NE.0) THEN
          GOTO 900
        ENDIF
C
      ENDIF
C
      IF (ICOUNT.NE.KLEN) THEN
        IRETFN = 20420
        WRITE(GRPRSM,FMT=9420) ICOUNT, KLEN
        GO TO 900
      ENDIF      
C
C     KNSPT pointer is intentionally left as is:
C     GRIBEX will use its value back to compute unused bit count...
C     ...no adjustment to nearest octet boundary here, then.
C
C     -----------------------------------------------------------------
C*    Section 5. Compute and code secondary bit-map, if any.
C     -----------------------------------------------------------------
C
  500 CONTINUE
C
      IF (LSECBI) THEN
C
#ifndef ebug2o
        IF (ODEBUG) THEN
#endif
          WRITE(GRPRSM,FMT=9510) 'Coding secondary bit-map', INSPTB
#ifndef ebug2o
        ENDIF
C
#endif
C
        DO 511 J=1,KLEN
        KDATA(J)=0
  511   CONTINUE
C
        ICOUNT=0
C
        DO 512 JGROUP=1,IFIROV
C
        ILNGTH=KLENGR(JGROUP)
        KDATA(ICOUNT+1)=1
        ICOUNT=ICOUNT+ILNGTH
C
  512   CONTINUE        
C
C       Effective coding of secondary bit-map, once for all groups.
C
        CALL INXBIT(KGRIB,KLENG,INSPTB,KDATA,KLEN,KBITS,
     X              1,YOPER,IRET)
C
        IF (IRET.NE.0) THEN
          IRETFN = 20510
          WRITE(GRPRSM,FMT=9001) 'secondary bit-map'
          GO TO 900
#ifdef ebug2o
        ELSE
#else
        ELSEIF (ODEBUG) THEN
#endif
          WRITE(GRPRSM,FMT=9510) 'Secondary bit-map encoded', INSPTB
        ENDIF
C
      ENDIF
C
C     -----------------------------------------------------------------
C*    Section 9. Return to calling routine.
C     -----------------------------------------------------------------
C
  900 CONTINUE
C
      C2PACK = IRETFN
#ifndef ebug2o
C
      IF (ODEBUG) THEN
#endif
        WRITE(GRPRSM,FMT=9900) IRETFN, KNSPT
#ifndef ebug2o
      ENDIF
#endif
C
      RETURN
C
 9001 FORMAT (' C2PACK: Problem inserting ',A,'.')
C
 9100 FORMAT (' C2PACK: Function start, KNSPT =',I10,'.')
#ifndef wmogrp2o
C
 9255 FORMAT (' C2PACK: Group number',I8,' exceeds',I6,'.',/,TR10,
     X        'extra bits stored in 21st octet of section 4 (',I3,
     X        '=>',I8.8,').')
#endif
C
 9300 FORMAT (' C2PACK: KNBIFO =',I3,', IFLAGX =',I9.8,
     X        ', IFIROV =',I8,', ISECOV =',I8,'.',/,
     X        ' C2PACK: IPTRFO =',I8,', IPTRSO =',I8,'.')
 9310 FORMAT (' C2PACK: KNSPT after "',A,'-length" descriptors =',
     X        I10,'.')
 9317 FORMAT (
     X' C2PACK: Bias sign management problem, CSGNBT return is',I5,'.')
C
 9420 FORMAT (' C2PACK: Mismatch: sum of group lengths =',I8,
     X        ', expected = ',I8,'.')
C
 9510 FORMAT (' C2PACK: ',A,', bit pointer =',I10,'.')
C
 9900 FORMAT (' C2PACK: Function return code =',I6,', KNSPT =',I10,'.')
C
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities
C granted to it by virtue of its status as an intergovernmental organisation
C nor does it submit to any jurisdiction.
C


      SUBROUTINE GENDIR (HPARAM,KARRAY,KLEN,HLINE,KIN,KOUT,HLAST,KRET)
C
C---->
C**** GENDIR - Generate directive lines for MARS.
C
C     Purpose.
C     --------
C
C           Creates mars directive line(s) in character format
C           from list of integers.
C
C**   Interface.
C     ----------
C
C           CALL GENDIR (HPARAM,KARRAY,KLEN,HLINE,KIN,KOUT,HLAST,KRET)
C
C           Integer    K.
C           Real       P.
C           Logical    O.
C           Character  H.
C
C               Input parameters.
C               -----------------
C
C               HPARAM     - MARS parameter being used.
C               KARRAY     - Array of required values.
C               KLEN       - Number of values.
C               HLINE      - Array of 80 character variables.
C               KIN        - Dimension of array HLINE.
C               HLAST      - Terminating character for directive line(s)
C               KRET       - Abort/no abort when error found.
C                            0   , abort if error found.
C                            Non-zero , no abort on error.
C
C               Output parameters.
C               ------------------
C
C               LINE       - MARS directive line(s)
C               KOUT       - Number of lines generated.
C               KRET       - Error return code.
C                            0   , No error encountered.
C                            1   , Output character array too small.
C
C     Method.
C     -------
C
C           Integers converted to characters and packed to remove
C           spaces. Lines are broken at / character for MARS input.
C
C     Externals.
C     ----------
C
C           RTB
C           REMSP
C
C     Reference.
C     ----------
C
C           MARS User Guide for directive description.
C
C     Comments.
C     ---------
C
C           See also GENINT which performs the reverse function.
C           Program contains sections 0 to 2 and section 9.
C
C     Author.
C     -------
C
C           J. Hennessy      ECMWF      16:10:86.
C
C     Modifications.
C     --------------
C
C           J. Hennessy      ECMWF      10:07:91.
C           Print of error message added.
C
C     ----------------------------------------------------------------
C----<
C
C
C
C
C
C
C
C
C
C
C*    Section 0 . Definition of variables.
C     ----------------------------------------------------------------
C
      IMPLICIT LOGICAL     ( L, O, G )
      IMPLICIT CHARACTER*8 ( C, H, Y )
      IMPLICIT INTEGER     ( I, J, K, M, N )
C
      INTEGER RTB
C
C
      CHARACTER*80  HLINE
      CHARACTER*10  YTEMP
      CHARACTER*(*) HPARAM
      CHARACTER*1   HLAST
C
      DIMENSION KARRAY(*)
      DIMENSION HLINE(KIN)
C
C
C     ----------------------------------------------------------------
C
C
C
C
C
C
C
C
C
C*    Section 1 . Set initial values.
C     ----------------------------------------------------------------
C
 1000 CONTINUE
C
      IRET = KRET
      KRET = 0
C
C     ----------------------------------------------------------------
C
C
C
C
C
C
C
C
C
C*    Section 2 . Convert integer data to required character format.
C     ----------------------------------------------------------------
C
 2000 CONTINUE
C
      KOUT                     = 1
      HLINE(KOUT)(1:)          = HPARAM(1:)
      ILEN                     = RTB (HLINE(KOUT))
      ICHAR                    = ILEN + 1
      HLINE(KOUT)(ICHAR:ICHAR) = '='
      ICHAR                    = ICHAR + 1
C
      DO 2010 I=1,KLEN
         WRITE (YTEMP(1:10),'(I10)') KARRAY(I)
         CALL REMSP (YTEMP)
         ILEN  = RTB (YTEMP)
         ILAST = ILEN + ICHAR
         IF (ILAST.GT.80)
     C      THEN
                ICHAR = 1
                KOUT  = KOUT + 1
                IF (KOUT.GT.KIN)
     C             THEN
                       KRET = 1
                       WRITE (*,9001) KIN , KOUT
                       GO TO 9000
                   ENDIF
            ENDIF
         HLINE(KOUT)(ICHAR:) = YTEMP(1:ILEN)
         ICHAR               = ICHAR + ILEN
         HLINE(KOUT)(ICHAR:) = '/'
         ICHAR               = ICHAR + 1
 2010 CONTINUE
C
      ILEN                   = RTB (HLINE(KOUT))
      HLINE(KOUT)(ILEN:ILEN) = HLAST
C
C     ----------------------------------------------------------------
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C*    Section 9 . Return to calling routine or abort.
C     ------------------------------------------------------------------
C
 9000 CONTINUE
C
 9001 FORMAT (1H ,'GENDIR : Character array is dimensioned ',I3,
     C            ' but should be at least ',I3,'.')
C
      IF (KRET.NE.0.AND.IRET.EQ.0) CALL ABORT
C
      RETURN
C
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE CREXPRT(K,KSUB1,KSUB2,KELEM,CNAMES,CUNITS,
     1                 CVALS,KVALS,VALUES,KSUP,KSEC1,KERR)
C
C**** *CREXPRT*
C
C
C     PURPOSE.
C     --------
C           PRINT EXPANDED CREX MESSAG.
C
C
C**   INTERFACE.
C     ----------
C
C           *CALL* *CREXPRT(K,KSUB1,KSUB2,KELEM,CNAMES,CUNITS,
C                         CVALS,KVALS,VALUES,KSUP,KSEC1,KERR)*
C
C        INPUT :
C               *K*       -  SWITCH TO PRINT WITH/WITOUT CONTENT OF CODE TABLES
C                            0  - NO  CODE TABLE CONTENT
C                            1  - YES CODE TABLE CONTENT
C               *KSUB1*   -  STARTING SUBSET
C               *KSUB2*   -  ENDING SUBSET
C               *KELEM*   -  DIMENSION OF CNAMES, CUNITS ARRAY
C               *CNAMES*  -  CHARACTER ARRAY CONTAINING ELEMENT NAMES
C               *CUNITS*  -  CHARACTER ARRAY CONTAINIG UNITS
C               *CVALS*   -  CHARACTER ARRAY CONTAINING CREX CODE TABLE
C                            ENTRIES
C               *KVALS*   -  DIMENSION OF VALUES ARRAY
C               *VALUES*  -  REAL*8 ARRAY (EXPANDED DATA VALUES)
C
C               *KSUP*    -  Integer array of 9 words containing
C                            suplementary information
C                         -  KSUP( 1) -- IDIM1, dimension of KSEC1
C                         -  KSUP( 2) -- Reserved
C                         -  KSUP( 3) -- IDIM3, dimension of KSEC3
C                         -  KSUP( 4) -- Reserved
C                         -  KSUP( 5) -- M (number of elements in values
C                                           array, first index)
C                         -  KSUP( 6) -- N (number of subsets,second index
C                                           of values array)
C                         -  KSUP( 7) -- JVC (number of elements in CVAL array)
C                         -  KSUP( 8) -- total CREX message length in bytes
C                         -  KSUP( 9) -- IDIM0, dimension of KSEC0
C
C               *KSEC1*   -  Integer array of at least 40 words
C                            containing CREX section 1 information
C                            KSEC1( 1)-- Reserved
C                            KSEC1( 2)-- CREX Edition number
C                            KSEC1( 3)-- Reserved
C                            KSEC1( 4)-- Reserved
C                            KSEC1( 5)-- Reserved
C                            KSEC1( 6)-- CREX message type
C                            KSEC1( 7)-- Reserved
C                            KSEC1( 8)-- version number of local table used
C                            KSEC1( 9)-- Reserved
C                            KSEC1(10)-- Reserved
C                            KSEC1(11)-- Reserved
C                            KSEC1(12)-- Reserved
C                            KSEC1(13)-- Reserved
C                            KSEC1(14)-- CREX Master table
C                            KSEC1(15)-- version number of Master table used
C                            KSEC1(16) - KSEC1(40) -- Reserved
C
C
C                            Crex Edition 2
C
C               *KSEC1*   -  Integer array of at least 40 words
C                            containing CREX section 1 information
C                            KSEC1( 1)-- Reserved
C                            KSEC1( 2)-- CREX Edition number
C                            KSEC1( 3)-- Originating Centre ( oooo)
C                            KSEC1( 4)-- Update sequence number (uu)
C                            KSEC1( 5)-- Number of subsets (sss)
C                            KSEC1( 6)-- CREX data category (nnn)
C                            KSEC1( 7)-- International data sub-category (mmm)
C                            KSEC1( 8)-- version number of local table used
C                            KSEC1( 9)-- Year (yyyy)
C                            KSEC1(10)-- Month (mm)
C                            KSEC1(11)-- Day (dd)
C                            KSEC1(12)-- Hour (hh)
C                            KSEC1(13)-- Minute (mm)
C                            KSEC1(14)-- CREX Master table (tt)
C                            KSEC1(15)-- version number of Master table used (vv)
C                            KSEC1(16)-- Originating sub-centre (ppp)
C                            KSEC1(17)-- Bufr master table version number
C                            KSEC1(18)-- Bufr version number of local table used
C                            KSEC1(19) - KSEC1(40) -- Reserved
C
C        OUTPUT:
C               *KERR*    -  RETURNED ERROR CODE
C
C
C
C
C     METHOD.
C     -------
C
C            NONE
C
C     EXTERNALS.
C     ----------
C
C            NONE.
C
C     REFERENCE.
C     ----------
C
C          NONE.
C
C     AUTHOR.
C     -------
C
C          MILAN DRAGOSAVAC    *ECMWF*       04/02/2003.
C
C     MODIFICATIONS.
C     --------------
C
C          NONE.
C
      IMPLICIT LOGICAL(L,O,G), CHARACTER*8(C,H,Y)
C
C
      PARAMETER(JSUP =   9,JSEC0=   3,JSEC1= 40,JSEC2= 64 ,JSEC3=    4,
     1          JSEC4=   2,JELEM=40000,JSUBS=400,JCVAL=150 ,JBUFL=40000,
     2          JBPW =  32,JTAB =3000,JCTAB=120,JCTST=1800,JCTEXT= 200,
     3          JWORK=360000,JKEY=46)
C
      COMMON /CREXWORK/ NBPT,NGS,NVIND,NBPTSEC2,RVIND,EPS,NE,IEOLD,
     1                  NC07YYY

C
      CHARACTER*64 CNAMES(KELEM)
      CHARACTER*24 CUNITS(KELEM)
      CHARACTER*80 CVALS(KVALS)
      CHARACTER YCHAR*30,YLONG*320
C
C
      DIMENSION KTDLST(JELEM)
      DIMENSION KTDEXP(JELEM)

      DIMENSION KSUP(*),KSEC1(*)
      REAL*8 VALUES(KVALS)
      REAL*8 RVIND, EPS
C
C
C     ------------------------------------------------------------------
C
C*          1.   PRINT CREX MESSAGE.
C                -------------------
 100  CONTINUE
C
      KERR=0
C
      ISUB1=KSUB1
      ISUB2=KSUB2
      IF(ISUB1.LE.0.OR.ISUB2.LE.0) THEN
         WRITE(*,'(A)')    ' WARNING - NEGATIVE KSUB1 OR KSUB2.'
         WRITE(*,'(A,I5)') ' WARNING - NUMBER OF SUBSETS IS ',KSUP(6)
         RETURN
      END IF
      IF(ISUB1.GT.KSUP(6)) THEN
         WRITE(*,'(A,I5)') ' WARNING - NUMBER OF SUBSETS IS ',KSUP(6)
         RETURN
      END IF
      IF(ISUB2.GT.KSUP(6)) THEN
         ISUB2=KSUP(6)
         WRITE(*,'(A,I5)') ' WARNING - KSUB2 REPLACED BY ',KSUP(6)
      END IF
C
      JQCP1= 0
C
      IF(K.EQ.0) THEN
         JQPR=0
         JQUA=0
         JQC=0
C          DO 171 J171=1,KSUP(5)
C          IF(CNAMES(J171)(1:8).EQ.'DATA PRE') THEN
C            JQPR=J171
C            GO TO 172
C          END IF
C  171     CONTINUE
C  172     DO 173 J173=1,KSUP(5)
C          IF(CNAMES(J173)(1:9).EQ.'QUALITY I') JQUA=J173
C  173     CONTINUE
C          DO 174 J174=1,KSUP(5)
C          IF(CNAMES(J174)(1:3).EQ.'% C') THEN
C            JQC =J174
C            GO TO 175
C          END IF
C  174     CONTINUE
C
C  175     CONTINUE
C
C         WRITE(*,'(1H1)')
C
C         WRITE(*,'(1H ,A)')    'EXPANDED CREX MESSAGE  '
C         WRITE(*,'(1H ,//)')
C         WRITE(*,'(1H ,A,I6)') 'CREX MESSAGE  DATA TYPE   ',KSEC1(6)
C         WRITE(*,'(1H ,A,I6)') 'RDB DATA SUBTYPE          ',KSEC1(7)
C         WRITE(*,'(1H ,A,I6)') 'TOTAL BUFR LENGTH (BYTES) ',KSUP(8)
C
         NTYPE=KSEC1(7)
         IF(JQUA.EQ.0) THEN      !IF(JQUA.NE.0) THEN
            JQUA=KSUP(5)
C
            DO 103 JB=ISUB1,ISUB2
            CALL CREXSEL2(JB,KELEM,KTDLEN,KTDLST,KTDEXL,KTDEXP,CNAMES,
     1                  CUNITS,KERR)
            JQUA=KTDEXL
C
            ILN=0
            WRITE(*,'(1H )')
C
            DO 104 JA=1,JQUA
C
            ILN=ILN+1
            JAJB=JA+(JB-1)*KELEM
C
            IF(ABS(VALUES(JAJB)-RVIND).LT.EPS) THEN
               WRITE(*,9918) ILN,CNAMES(JA),CUNITS(JA)
            ELSE
               IF(CUNITS(JA)(1:4).EQ.'CCIT') THEN
                  I=NINT(VALUES(JAJB)/1000)
                  NCHAR=VALUES(JAJB)-I*1000
                  NW=NCHAR/80
                  NWOFF=NCHAR-NW*80
                  IF(NWOFF.NE.0) NW=NW+1
C
                  YLONG=' '
                  YLONG(1:80)=CVALS(I)
C
                  II=I
                  DO 125 JC=1,NW-1
                  II=II+1
                  KF=JC*80+1
                  KL=(JC+1)*80
                  YLONG(KF:KL)=CVALS(II)
 125              CONTINUE
C
                  NLINE=NCHAR/30
                  IDIF =NCHAR-NLINE*30
                  IF(IDIF.NE.0) NLINE=NLINE+1
                  YCHAR=' '
                  YCHAR=YLONG(1:30)
C
                  WRITE(*,9919)ILN,CNAMES(JA),VALUES(JAJB),
     1                         CUNITS(JA),YCHAR
C
                  IF(NLINE.GT.1) THEN
                     DO 130 JJ=1,NLINE-1
C
                     K2=JJ*30+1
                     K1=(JJ+1)*30
                     YCHAR=' '
                     YCHAR=YLONG(K2:K1)
C
                     WRITE(*,9920) YCHAR
 130                 CONTINUE
C
                   END IF
               ELSE
                  WRITE(*,9917) ILN,CNAMES(JA),VALUES(JAJB),
     1            CUNITS(JA)
               END IF
            END IF
C
 104        CONTINUE
 103        CONTINUE
C
         ELSE
            JQPRM1=JQPR-1
            JQC=JQC-1
C
            DO 101 JB=ISUB1,ISUB2
C
            ILN=0
            JQCP1=0
C
            WRITE(*,'(1H )')
C
            DO 102 JA=1,JQUA-1
C
            ILN=ILN+1
            JAJB=JA+(JB-1)*KELEM
            JQPJB=JQPRM1+JA+(JB-1)*KELEM
C
            IF(VALUES(JQPJB).EQ.0.0) THEN
               JQCP1=JQCP1+1
               JQCPP1=JQC+JQCP1+(JB-1)*KELEM
               IF(ABS(VALUES(JAJB)-RVIND).LT.EPS) THEN
                  WRITE(*,9918) ILN,CNAMES(JA),CUNITS(JA)
               ELSE
                  WRITE(*,9916) ILN,CNAMES(JA),VALUES(JAJB),
     1            CUNITS(JA),
     1            CNAMES(JQC+JQCP1),VALUES(JQCPP1),
     1            CUNITS(JQC+JQCP1)
               END IF
            ELSE
               IF(ABS(VALUES(JAJB)-RVIND).LT.EPS) THEN
                  WRITE(*,9918) ILN,CNAMES(JA),CUNITS(JA)
                  IF(NTYPE.EQ.5.OR.NTYPE.EQ.3) JQCP1=JQCP1+1
               ELSE
                  WRITE(*,9917) ILN,CNAMES(JA),VALUES(JAJB),
     1            CUNITS(JA)
                  IF(NTYPE.EQ.5.OR.NTYPE.EQ.3) JQCP1=JQCP1+1
               END IF
            END IF
C
C
 102        CONTINUE
 101        CONTINUE
C
         END IF
      END IF
C
      IF(K.EQ.1) THEN
C
C---------------------------------------------------------------------
          WRITE(*,'(1H1)')
C
          WRITE(*,'(1H ,A)') 'WARNING : PRINTING CONTENT OF CODE'//
     1   ' TABLES NOT YET IMPLEMENTED.'
          RETURN
C---------------------------------------------------------------------
C
C          WRITE(*,'(1H ,A)')    'EXPANDED CREX MESSAGE  '
C          WRITE(*,'(1H ,//)')
C          WRITE(*,'(1H ,A,I6)') 'RDB DATA TYPE             ',KSEC1(6)
C          WRITE(*,'(1H ,A,I6)') 'RDB DATA SUBTYPE          ',KSEC1(7)
C          WRITE(*,'(1H ,A,I6)') 'TOTAL BUFR LENGTH (BYTES) ',KSUP(8)
C
C          DO 150 JB=1,KSUP(6)
C
C          WRITE(*,'(1H )')
C
C          DO 160 JA=1,KSUP(5)
C
C          JAJB=JA+(JB-1)*KELEM
C
C          IF(ABS(VALUES(JAJB)-RVIND).LT.EPS) THEN
C             WRITE(*,9903) CNAMES(JA)(1:32),CUNITS(JA)
C             WRITE(*,9903) CNAMES(JA)(33:64)
C          ELSE
C             IF(CUNITS(JA)(1:10).EQ.'CODE TABLE'.OR.
C     1         CUNITS(JA)(1:9) .EQ.'CCITTIA5'     ) THEN
C                I=NINT(VALUES(JAJB)/1000)
C                NCHAR=VALUES(JAJB)-I*1000
C                NW=NCHAR/80
C                NWOFF=NCHAR-NW*80
C                IF(NWOFF.NE.0) NW=NW+1
CC
C                YLONG(1:80)=CVALS(I)
C
C                II=I
C                DO 165 JC=1,NW-1
C                II=II+1
C                KF=JC*80+1
C                KL=(JC+1)*80
C                YLONG(KF:KL)=CVALS(II)
C  165           CONTINUE
C
C                NLINE=NCHAR/30
C                IDIF =NCHAR-NLINE*30
C                IF(IDIF.NE.0) NLINE=NLINE+1
C                YCHAR=YLONG(1:30)
C
C                WRITE(*,9904)CNAMES(JA)(1:32),VALUES(JAJB),
C     1         CUNITS(JA),YCHAR
C                WRITE(*,9904)CNAMES(JA)(33:64)
C
C                IF(NLINE.GT.1) THEN
C                   DO 170 JJ=1,NLINE-1
C
C                   K2=JJ*30+1
C                   K1=(JJ+1)*30
C                   YCHAR=YLONG(K2:K1)
C
C                   WRITE(*,9905) YCHAR
C  170              CONTINUE
C
C                END IF
C             ELSE
C                WRITE(*,9906) CNAMES(JA)(1:32),VALUES(JAJB),
C     1                       CUNITS(JA)
C                WRITE(*,9906) CNAMES(JA)(33:64)
C             END IF
C          END IF
C
C  160     CONTINUE
C  150     CONTINUE
C
        END IF
C
C
C       RETURN
C
C     ------------------------------------------------------------------
C
 200  CONTINUE
C
C     ------------------------------------------------------------------
 9903 FORMAT(1H ,A,'     MISSING',2X,A)
 9904 FORMAT(1H ,A,F20.4,2X,A,2X,A)
 9905 FORMAT(1H ,100X,A)
 9906 FORMAT(1H ,I5,1X,A,E14.4,2X,A)
 9916 FORMAT(1H ,I5,1X,A15,1X,F20.4,1X,A20,1X,A15,1X,F3.0,1X,A15)
 9917 FORMAT(1H ,I5,1X,A15,1X,F20.4,1X,A24)
 9918 FORMAT(1H ,I5,1X,A15,1X,'             MISSING',1X,A24)
 9919 FORMAT(1H ,I5,1X,A15,1X,F20.4,1X,A24,1X,A)
 9920 FORMAT(1H ,62X,A)
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C


      SUBROUTINE CCF1CR (HEXP,HSTR,HDIS,HTYP,HREP,HLEV,HARE,HPER,HFIR,
     C      HOWN,HBAK,HCLS,HFAM,HRUT,KPR,KRET)
C
C
C---->
C**** CCF1CR
C
C     PURPOSE.
C     --------
C
C           CREATE REQUESTED NODES IN CFS FOR MARS ARCHIVING.
C
C**   INTERFACE.
C     ----------
C
C           CALL CCF1CR (HEXP,HSTR,HDIS,HTYP,HREP,HLEV,HARE,HPER,HFIR,
C    C      HOWN,HBAK,HCLS,HFAM,HRUT,KPR,KRET)
C
C           INTEGER    K.
C           REAL       P.
C           LOGICAL    O.
C           CHARACTER  H.
C
C               INPUT PARAMETERS.
C               -----------------
C
C               HEXP       - 4 CHARACTER EXPERIMENT IDENTIFIER.
C
C               HSTR       - ARCHIVE STREAM.
C                            FOR RESEARCH.
C                               DA - DAILY ARCHIVE.
C                            FOR OPERATIONS.
C                               DA - DAILY ARCHIVE.
C                               CH - CHERNOBYL ARCHIVE.
C                               TG - TOGA ARCHIVE.
C                               MO - MONTHLY.
C
C               HDIS       - NEW , NEW ENTRY REQUIRED.
C                            OLD , DELETE OLD ENTRY BEFORE MAKING
C                                  NEW ONE.
C
C               HTYP       - AN , ANALYSIS.
C                            IA , INITIALISED ANALYSIS.
C                            FG , FIRST GUESS.
C                            FC , FORECAST.
C                            EA , ERRORS IN ANALYSIS.
C                            CL , CLIMATOLOGY.
C
C
C               HREP       - SH , SPHERICAL HARMONICS.
C                            GG , GAUSSIAN GRID.
C                            LL , LAT/LONG GRID.
C
C               HLEV       - M , MODEL LEVELS.
C                            P , PRESSURE LEVELS.
C                            S , SURFACE.
C
C               HARE       - G , GLOBAL DATA.
C
C               HPER       - S , SHORT RETENTION PERIOD.
C                            M , MEDIUM RETENTION PERIOD.
C                            P , PERMANENT RETENTION.
C
C               HFIR       - DATE OF FIRST ARCHIVE (YYMMDD).
C
C               HOWN       - OWNER'S PASSWORD. 6 CHARACTERS FOR
C                            RESEARCH EXPERIMENTS, 5 FOR OPERATIONS.
C
C               HBAK       - 0 , NO BACKUP NODES REQUIRED.
C                            1 , 1 BACKUP OF NODES REQUIRED.
C
C               HCLS       - RD , RESEARCH DEPARTMENT.
C                            OD , OPERATIONS DEPARTMENT.
C
C               HFAM       - N, NO FAMILY ATTRIBUTE IN NODES.
C                            Y , FAMILY ATTRIBUTES IN NODES.
C
C               HRUT       - ROOT NODE TO BE USED.
C                            FOR RESEARCH
C                               P , PRODUCTION ROOT MARSR.
C                               T , TEST ROOT MATSR.
C                            FOR OPERATIONS
C                               P , PRODUCTION ROOT MARST.
C                               O , OLD PRODUCTION ROOT MARSO.
C                               T , TEST ROOT MATST.
C
C               KPR        - DEBUG PRINT SWITCH.
C                            0 , NO PRINTOUT.
C                            1 , DEBUG PRINTOUT.
C
C               OUTPUT PARAMETERS.
C               ------------------
C
C               KRET       - ERROR RETURN CODE.
C                            0   , NO ERROR ENCOUNTERED.
C                            1   , ERROR IN REMOVING OLD NODES.
C                            2   , ERROR IN CREATING NEW NODES.
C                            3   , ERROR IN ADDING VALIDATION ENTRIES.
C                            4   , ERROR IN ADDING FAMILY ATTRIBUTE.
C                            5   , ERROR IN PASSWORD.
C                            6   , ATTEMPT TO DELETE OPERATIONAL NODE.
C                            7   , EXPERIMENT IDENTIFIER NOT FOUR
C                                  CHARACTERS.
C                            8   , DATE OF FIRST ARCHIVE NOT 6 DIGITS.
C
C     METHOD.
C     -------
C
C           ROOT NODES ARE ASSUMED TO EXIST. CACHE NODES CREATED
C           AUTOMATICALLY, BACKUP NODES IF REQUIRED.
C           DELETION OF OPERATIONAL NODES IS PROHIBITED.
C
C     EXTERNALS.
C     ----------
C
C           ECFILE
C
C     REFERENCE.
C     ----------
C
C           MARS DESIGN NOTE 30. FILE 460 24.03.88.
C
C     COMMENTS.
C     ---------
C
C           ROUTINE CONTAINS SECTIONS 0 TO 4 AND SECTION 9.
C           ADDITION OF FAMILY ATTRIBUTE NOT POSSIBLE IN FIRST VERSION.
C
C     AUTHOR.
C     -------
C
C           J. HENNESSY      ECMWF      28:06:89.
C
C     MODIFICATIONS
C     --------------
C
C           NONE.
C
C----<
C     ----------------------------------------------------------------
C
C
C
C
C
C
C
C
C
C
C*    SECTION 0 . DEFINITION OF VARIABLES.
C     ----------------------------------------------------------------
C
      IMPLICIT LOGICAL     ( L, O, G )
      IMPLICIT CHARACTER*8 ( C, H, Y )
      IMPLICIT INTEGER     ( I, J, K, M, N )
C
C
      CHARACTER*4  HEXP
      CHARACTER*2  HSTR
      CHARACTER*4  HDIS
      CHARACTER*4  HTYP
      CHARACTER*4  HREP
      CHARACTER*4  HLEV
      CHARACTER*4  HARE
      CHARACTER*1  HPER
      CHARACTER*6  HFIR
      CHARACTER*6  HOWN
      CHARACTER*1  HBAK
      CHARACTER*2  HCLS
      CHARACTER*1  HFAM
      CHARACTER*1  HRUT
C
      CHARACTER*36 YLINE
C
      CHARACTER*160 YREQ
C
      CHARACTER*6  YNODE1
      CHARACTER*3  YNODE2
      CHARACTER*5  YNODE3
      CHARACTER*5  YNODE4
      CHARACTER*5  YNODE5
C
      DIMENSION IREASON(3)
C
      DIMENSION YLINE(3)
C
C
C     ----------------------------------------------------------------
C
C
C
C
C
C
C
C
C
C*    SECTION 1 . SET INITIAL VALUES. CHECK PARAMETERS.
C     ----------------------------------------------------------------
C
 1000 CONTINUE
C
      IF (KPR.EQ.1) WRITE (*,*) 'CCF1CR : SECTION 1.'
C
      KRET = 0
C
C*    CHECK THAT EXPERIMENT OR STREAM IDENTIFIER IS 4 CHARACTERS LONG.
C
      I = INDEX (HEXP,' ')
      IF (I.NE.0)
     C   THEN
             KRET = 7
             WRITE (*,9006) HEXP
             GO TO 9000
         ENDIF
C
C*    CHECK THAT FIRST ARCHIVE DATE CONSISTS OF 6 DIGITS.
C
      I = INDEX (HFIR,' ')
      IF (I.NE.0)
     C   THEN
             KRET = 8
             WRITE (*,9007) HFIR
             GO TO 9000
         ENDIF
C
C
C*    FOR COMPATIBILITY WITH PREVIOUS USER INTERFACE A FEW DEFAULT
C     VALUES HAVE TO BE SET UP, WHEN NONE ARE PROVIDED.
C
      IF (HCLS.EQ.'  ') HCLS = 'RD'
      IF (HFAM.EQ.' ')  HFAM = 'N'
      IF (HCLS.EQ.'RD') HFAM = 'N'
      IF (HCLS.EQ.'RD') HSTR = 'DA'
      IF (HRUT.EQ.' ')  HRUT = 'P'
C
C
C     CHECK THAT OWNER'S PASSWORD IS CORRECT LENGTH ( 5 FOR OPERATIONS
C     6 FOR RESEARCH).
C
      IL = INDEX (HOWN,' ')
      IF (IL.EQ.6) IL = 5
      IF (IL.EQ.0) IL = 6
      IF (IL.EQ.5.AND.HCLS.NE.'OD') KRET = 5
      IF (IL.EQ.6.AND.HCLS.NE.'RD') KRET = 5
      IF (KRET.EQ.5)
     C   THEN
             WRITE (*,9008) HOWN
             GO TO 9000
         ENDIF
C
C*    RESEARCH ARCHIVE IS DAILY ARCHIVE ONLY. OPERATIONAL ARCHIVES
C     HAVE SEVERAL STREAMS, WHICH ARE USED TO MAKE UP CFS PATHNAME,
C     IN THE SAME NODE AS THE RESEARCH EXPERIMENT IDENTIFIER.
C
      IF (HCLS.EQ.'OD')
     C   THEN
             HEXP = 'OPER'
             IF (HSTR.EQ.'CH') HEXP = 'CHER'
             IF (HSTR.EQ.'TG') HEXP = 'TOGA'
         ENDIF
C
C*    SET UP VALUES FOR FIRST 5 NODES EG MARSR/FC/EXPV/SPGS/1989.
C
C     NODE 1.
C
      IF (HCLS.EQ.'RD'.AND.HRUT.EQ.'P') YNODE1 = '/MARSR'
      IF (HCLS.EQ.'RD'.AND.HRUT.EQ.'T') YNODE1 = '/MATSR'
C
      IF (HCLS.EQ.'OD'.AND.HRUT.EQ.'T') YNODE1 = '/MATST'
      IF (HCLS.EQ.'OD'.AND.HRUT.EQ.'O') YNODE1 = '/MARSO'
      IF (HCLS.EQ.'OD'.AND.HRUT.EQ.'P') YNODE1 = '/MARST'
C
C     NODE 2.
C
      YNODE2 = '/'//HTYP(1:2)
C
C     NODE 3.
C
      YNODE3 = '/'//HEXP
C
C     NODE 4.
C
      YNODE4 = '/'//HREP(1:1)//HLEV(1:1)//HARE(1:1)//HPER
C
C     NODE 5.
C
      YNODE5 = '/19'//HFIR(1:2)
C
C
C     ----------------------------------------------------------------
C
C
C
C
C
C
C
C
C
C*    SECTION 2 . REMOVE ANY EXISTING NODES AND FILES, IF REQUIRED.
C     ----------------------------------------------------------------
C
 2000 CONTINUE
C
      IF (KPR.EQ.1) WRITE (*,*) 'CCF1CR : SECTION 2.'
C
      IF (HDIS(1:1).EQ.'O')
     C   THEN
C
C*           REMOVAL OF OPERATIONAL NODES AND FILES NOT ALLOWED.
C
             IF (HCLS.EQ.'OD'.AND.(HRUT.EQ.'P'.OR.HRUT.EQ.'O'))
     C          THEN
                    KRET = 6
                    WRITE (*,9004)
                    GO TO 9000
                ENDIF
C
             YTEMP = 'REMOVE'
             CALL LDC1CR (YTEMP,HOWN(1:IL),HEXP,HTYP,HCLS,HSTR,HRUT,
     C                     KPR,IRC)
C
C            IGNORE RETURN CODE FOR EXPERIMENT DOES NOT EXIST.
C
             IF (IRC.GT.1)
     C          THEN
                    KRET = 1
                    WRITE (*,9005)
                    GO TO 9000
                ENDIF
         ENDIF
C
C     ----------------------------------------------------------------
C
C
C
C
C
C
C
C
C
C*    SECTION 3 . CREATE NODE (AND BACKUP NODES IF REQUIRED).
C     ----------------------------------------------------------------
C
 3000 CONTINUE
C
      IF (KPR.EQ.1) WRITE (*,*) 'CCF1CR : SECTION 3.'
C
      DO 3900 J3900 = 1 , 4
C
C*    IF FIRST TIME THROUGH SET UP /ROOT/TYPE NODES.
C
      IF (J3900.EQ.1)
     C   THEN
             YLINE(1) = YNODE1//YNODE2//','
             YLINE(2) = '/CACHE'//YNODE1//YNODE2//','
             YLINE(3) = '/MARSBACKUP'//YNODE1//YNODE2//','
         ENDIF
C
C*    IF SECOND TIME THROUGH SET UP /ROOT/TYPE/EXPVER NODES.
C
      IF (J3900.EQ.2)
     C   THEN
             YLINE(1) = YNODE1//YNODE2//YNODE3//','
             YLINE(2) = '/CACHE'//YNODE1//YNODE2//YNODE3//','
             YLINE(3) = '/MARSBACKUP'//YNODE1//YNODE2//YNODE3//','
         ENDIF
C
C*    IF THIRD TIME THROUGH SET UP /ROOT/TYPE/EXPVER/DESCRIPTOR NODES.
C
      IF (J3900.EQ.3)
     C   THEN
             YLINE(1) = YNODE1//YNODE2//YNODE3//YNODE4//','
             YLINE(2) = '/CACHE'//YNODE1//YNODE2//YNODE3//YNODE4//','
             YLINE(3) = '/MARSBACKUP'//YNODE1//YNODE2//YNODE3//YNODE4
     C                     //','
         ENDIF
C
C*    IF FOURTH TIME THROUGH SET UP /ROOT/TYPE/EXPVER/DESCRIPTOR/YEAR
C     NODES.
C
      IF (J3900.EQ.4)
     C   THEN
             YLINE(1) = YNODE1//YNODE2//YNODE3//YNODE4//YNODE5//','
             YLINE(2) = '/CACHE'//YNODE1//YNODE2//YNODE3//YNODE4
     C                     //YNODE5//','
             YLINE(3) = '/MARSBACKUP'//YNODE1//YNODE2//YNODE3//YNODE4
     C                     //YNODE5//','
         ENDIF
C
C
      J = 0
C
 3100 CONTINUE
C
      J = J + 1
      I = INDEX (YLINE(J),',')
      YREQ = 'FN=ADD,NA,PATH='//YLINE(J)(1:I)//'UVAL=UV1/WMB/'
     C          //HOWN(1:IL)//'/S.'
      IF (KPR.EQ.1) WRITE (*,9003) YREQ
      CALL ECFILE (IERR,IREASON,YREQ)
C
C     TRAP RETURN CODES FOR NODE ALREADY EXISTS.
C
      IF (IERR .EQ. 9.
     C   AND.IREASON(1).EQ.1.
     C   AND.IREASON(2).EQ.2.
     C   AND.IREASON(3).EQ.12) GO TO 3300
C
      IF (IERR.NE.0)
     C   THEN
             WRITE (*,9001) IERR , IREASON
             WRITE (*,9003) YREQ
             KRET = 2
             GO TO 9000
         ENDIF
C
C     ADD VALIDATION ENTRY.
C
      YREQ = 'FN=MODIFY,PW='//HOWN(1:IL)//',NA,PATH='//YLINE(J)(1:I)//
     C             'AVAL=PUB/IR/-/S.'
      IF (KPR.EQ.1) WRITE (*,9003) YREQ
      CALL ECFILE (IERR,IREASON,YREQ)
C
C     TRAP RETURN CODES FOR ENTRY ALREADY EXISTS.
C
      IF (IERR .EQ. 9.
     C   AND.IREASON(1).EQ.1.
     C   AND.IREASON(2).EQ.115.
     C   AND.IREASON(3).EQ.5) GO TO 3300
C
      IF (IERR.NE.0)
     C   THEN
             WRITE (*,9002) IERR , IREASON
             WRITE (*,9003) YREQ
             KRET = 3
             GO TO 9000
         ENDIF
C
 3300 CONTINUE
C
C     CREATE CACHE NODES.
C
      IF (J.LT.2) GO TO 3100
C
C     CREAT BACKUP NODES IF REQUIRED.
C
      IF (HBAK.EQ.'1'.AND.J.EQ.2) GO TO 3100
C
 3900 CONTINUE
C
C    ----------------------------------------------------------------
C
C
C
C
C
C
C
C
C
C
C*    SECTION 4 . ADD FAMILY ATTRIBUTES.
C    ----------------------------------------------------------------
C
 4000 CONTINUE
C
      IF (KPR.EQ.1) WRITE (*,*) 'CCF1CR : SECTION 4.'
C
      IF (HFAM.EQ.'Y')
     C   THEN
             KRET = 4
             WRITE (*,*) 'CCF1CR : FAMILY ATTRIBUTES NOT IMPLEMENTED.'
             GO TO 9000
         ENDIF
C
C     ----------------------------------------------------------------
C
C
C
C
C
C
C
C
C
C
C
C
C*    SECTION 9 . RETURN TO CALLING ROUTINE. FORMAT STATEMENTS.
C     ------------------------------------------------------------------
C
 9000 CONTINUE
C
      IF (KPR.EQ.1) WRITE (*,*) 'CCF1CR : SECTION 9.'
C
C
      RETURN
C
C
 9001 FORMAT (1H ,'CCF1CR : NODE CREATION ERROR. FAILURE CODE = ',I3,
     C            ' , REASON CODES = ',3I6,' .')
C
 9002 FORMAT (1H ,'CCF1CR : VALIDATION ENTRY. FAILURE CODE = ',I3,
     C            ' , REASON CODES = ',3I6,' .')
C
 9003 FORMAT (1H ,A)
C
 9004 FORMAT (1H ,'CCF1CR : OPERATIONAL NODE DELETION ILLEGAL.')
C
 9005 FORMAT (1H ,'CCF1CR : DELETION OF OLD NODES/FILES FAILED.')
C
 9006 FORMAT (1H ,'CCF1CR : EXPERIMENT IDENTIFIER NOT 4 CHARACTERS - ',
     C             A)
C
 9007 FORMAT (1H ,'CCF1CR : FIRST ARCHIVE DATE NOT 6 DIGITS - ',A)
C
 9008 FORMAT (1H ,'CCF1CR : OWNER (PASSWORD) INVALID - ',A)
C
C     ------------------------------------------------------------------
C
C
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE BUEXS33(KBUFL,KBUFF,KSEC3,KERR)
C
C**** *BUEXS33*
C
C
C     PURPOSE.
C     --------
C
C          EXPAND SECTION 3 OF BUFR MESSAGE.
C               (PRELIMINARY ITEMS)
C
C
C**   INTERFACE.
C     ----------
C
C          *CALL* *BUEXS33( KBUFL,KBUFF,KSEC3,KERR)*
C
C        INPUT :
C               *KBUFL*   -  LENGTH OF BUFR MESSAGE (WORDS)
C               *KBUFF*   -  ARRAY CONTAINING BUFR MESSAGE
C        OUTPUT:
C               *KSEC3*
C               *KERR*    -  RETURNED ERROR CODE
C
C     METHOD.
C      -------
C
C
C          NONE.
C
C     EXTERNALS.
C     ----------
C
C          BUNEXS        - SET WORD AND BIT POINTERS AT THE BEGINING OF
C                          NEXT SECTION
C          BUNPCK        - UNPACKS BIT PATTERN
C
C     REFERENCE.
C     ----------
C
C          NONE.
C
C     AUTHOR.
C     -------
C
C          M. DRAGOSAVAC    *ECMWF*       01/02/91.
C
C
C     MODIFICATIONS.
C     --------------
C
C          NONE.
C
C
      IMPLICIT LOGICAL(L,O,G), CHARACTER*8(C,H,Y)
C
C
#     include "parameter.F"
#     include "bcomunit.F"
#     include "bcomwork.F"
C
      DIMENSION KBUFF(KBUFL)
      DIMENSION KSEC3(*)
#ifndef R_4
      REAL*8 RVIND
      REAL*8 EPS
#else
      REAL   RVIND
      REAL   EPS
#endif
C
C     ------------------------------------------------------------------
C
C*          1.   EXPAND PRELIMINARY ITEMS OF SECTION 3.
C                --------------------------------------
 100  CONTINUE
C
      IF( KERR.NE.0 ) RETURN
C
C*          1.1   SET THE POINTERS NWPT AND NBPT TO THE
C                 -------------------------------------
C                 BEGINING OF THE SECTION 3.
C                 --------------------------
 110  CONTINUE
C
      NWPT = NWPTB
      NBPT = NBPTB
C
C*          1.2   UNPACK LENGTH OF SECTION 3.
C                 ---------------------------
 120  CONTINUE
C
      CALL BUNPCK(NBPW,KBUFF,KSEC3(1),NWPT,NBPT,24,KERR)
      IF(KERR.GT.0) RETURN
C
C
C*          1.3    UNPACK ZERO BYTE AND PUT IT IN KSEC3(2).
C                  ----------------------------------------
 130  CONTINUE
C
      CALL BUNPCK(NBPW,KBUFF,KSEC3(2),NWPT,NBPT,8,KERR)
      IF(KERR.GT.0) RETURN
C
C*          1.4    UNPACK NUMBER OF DATA SUB-SETS.
C                  -------------------------------
 140  CONTINUE
C
      CALL BUNPCK(NBPW,KBUFF,KSEC3(3),NWPT,NBPT,16,KERR)
      IF(KERR.GT.0) RETURN
      IF(KSEC3(3).LE.0) THEN
         KERR=32
         WRITE(KNTN,*)  ' BUEXS3 :'
         CALL BUERR(KERR)
         RETURN
      END IF
C
      CALL BUNPCK(NBPW,KBUFF,KSEC3(4),NWPT,NBPT,8,KERR)
      IF(KERR.GT.0) RETURN
C     -----------------------------------------------------------------
C
      NWPT = NWPTB
      NBPT = NBPTB      
C
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      INTEGER FUNCTION INTISL(OLDLSM, OLDFLD, NEWLSM, NEWFLD)
C
C---->
C**** INTISL
C
C     Purpose
C     -------
C
C     Interpolate a field based on an old land-sea mask to a field
C     based on a different land-sea mask.
C
C
C     Interface
C     ---------
C
C     IRET = INTISL(OLDLSM, OLDFLD, NEWLSM, NEWFLD)
C
C     Input
C     -----
C
C     OLDLSM - Old land-sea mask in GRIB format
C     OLDFLD - Old field in GRIB format
C     NEWLSM - New land-sea mask in GRIB format
C
C
C     Output
C     ------
C
C     NEWFLD - New field in GRIB format
C
C     Function returns:
C       - the size in bytes of the new GRIB product if all is well
C       - -1, otherwise.
C
C
C     Method
C     ------
C
C     Unpack input GRIBS.
C     Create new field and pack it into GRIB format.
C
C
C     Externals
C     ---------
C
C     GRIBEX  - Decode and encode GRIB products.
C     NEWISL  - Interpolate old field to new using both land-sea masks.
C     JMALLOC - Dynamically allocate memory
C     INTLOG  - Log messages
C
C
C     Author
C     ------
C
C     J.D.Chambers     ECMWF     August 2000
C
C----<
C
      IMPLICIT NONE
C
C     Function arguments
C
      INTEGER OLDLSM(*), OLDFLD(*), NEWLSM(*), NEWFLD(*)
C
#include "parim.h"
#include "nifld.common"
#include "nofld.common"
C
C     Parameters
C
      INTEGER JPINTB, JPREALB
      PARAMETER (JPINTB = 4)
#ifdef REAL_8
      PARAMETER (JPREALB = 8)
#else
      PARAMETER (JPREALB = 8)
#endif
C
C     Local variables
C
      INTEGER IXSEC4(512)
      INTEGER ILSEC0(2),ILSEC1(1024),ILSEC2(1024),ILSEC3(2),ILSEC4(512)
      INTEGER IFSEC0(2),IFSEC1(1024),IFSEC2(1024),IFSEC3(2),IFSEC4(512)
      INTEGER IMSEC0(2),IMSEC1(1024),IMSEC2(1024),IMSEC3(2),IMSEC4(512)
      INTEGER                                     NFSEC3(2)
C     INTEGER NFSEC0(2),NFSEC1(1024),NFSEC2(1024),          NFSEC4(512)
      INTEGER KLSEC4, KFSEC4, KMSEC4, KPSEC4, NEWTYPE
#ifndef _CRAYFTN
#if (!defined sgi)
#ifdef POINTER_64
      INTEGER*8 IZLSEC4, IZFSEC4, IZMSEC4, IPFSEC4
#else
      INTEGER IZLSEC4, IZFSEC4, IZMSEC4, IPFSEC4
#endif
#endif
#endif
C
      REAL ZDUMMY
      REAL ZLSEC2(1500), ZLSEC3(2), ZLSEC4(1)
      REAL ZFSEC2(1500), ZFSEC3(2), ZFSEC4(1)
      REAL ZMSEC2(1500), ZMSEC3(2), ZMSEC4(1)
      REAL               PFSEC3(2), PFSEC4(1)  !PFSEC2(1500)
C
      POINTER( IZLSEC4, ZLSEC4 )
      POINTER( IZFSEC4, ZFSEC4 )
      POINTER( IZMSEC4, ZMSEC4 )
      POINTER( IPFSEC4, PFSEC4 )
C
      INTEGER IRET, ILENB, IPUNP, IWORD
C
C     Externals
C
      INTEGER NEWISL
#ifdef POINTER_64
      INTEGER*8 JMALLOC
#else
      INTEGER JMALLOC
#endif
      EXTERNAL NEWISL, JMALLOC
C
      DATA KLSEC4/0/, KFSEC4/0/, KMSEC4/0/, KPSEC4/0/
      SAVE KLSEC4, KFSEC4, KMSEC4, KPSEC4
      SAVE IZLSEC4, IZFSEC4, IZMSEC4, IPFSEC4
C
C     -----------------------------------------------------------------|
C*    Section 1.   Initialise
C     -----------------------------------------------------------------|
C
  100 CONTINUE
C
      INTISL = 0
C
C     -----------------------------------------------------------------|
C*    Section 2.   Dynamically allocate memory for the old land-sea mask
C                  values and old field values.
C     -----------------------------------------------------------------|
C
  200 CONTINUE
C
C     Old land-sea mask
C
      IRET = 1
      IPUNP = 1
      ILENB = NIPOGRS
      CALL GRIBEX (ILSEC0,ILSEC1,ILSEC2,ZLSEC2,ILSEC3,ZLSEC3,IXSEC4,
     X             ZDUMMY,IPUNP,OLDLSM,ILENB,IWORD,'J',IRET)
      IF( IRET.NE.0 ) THEN
        WRITE(*,*) 'INTISL: Old lsm gribex return code = ',IRET
        INTISL = -1
        RETURN
      ENDIF
C
      IF( KLSEC4.LT.(IXSEC4(1)*JPREALB) ) THEN
        IF( KLSEC4.NE.0 ) THEN
          CALL JFREE(IZLSEC4)
          CALL JFREE(IZFSEC4)
        ENDIF
        KLSEC4 = IXSEC4(1)*JPREALB
        KFSEC4 = KLSEC4
        CALL INTLOG(JP_DEBUG,'INTISL: Allocate old memory = ',KLSEC4)
        IZLSEC4 = JMALLOC(KLSEC4)
        IZFSEC4 = JMALLOC(KFSEC4)
#ifdef hpR64
        IZLSEC4 = IZLSEC4/(1024*1024*1024*4)
        IZFSEC4 = IZFSEC4/(1024*1024*1024*4)
#endif
        IF( (IZLSEC4.EQ.0).OR.(IZFSEC4.EQ.0) ) THEN
          CALL INTLOG(JP_ERROR,'INTISL: JMALLOC fail oldies',JPQUIET)
          INTISL = -1
          GOTO 900
        ENDIF
      ENDIF
C
      IRET = 1
      IPUNP = IXSEC4(1)
      ILENB = NIPOGRS
      CALL GRIBEX (ILSEC0,ILSEC1,ILSEC2,ZLSEC2,ILSEC3,ZLSEC3,ILSEC4,
     X             ZLSEC4,IPUNP,OLDLSM,ILENB,IWORD,'D',IRET)
      IF( IRET.NE.0 ) THEN
        WRITE(*,*) 'INTISL: Old lsm gribex return code = ',IRET
        INTISL = -1
        RETURN
      ENDIF
C
C     Old field
C
      IRET = 1
      IPUNP = IXSEC4(1)
      ILENB = NIPOGRS
      IF( LIMISSV ) THEN
        IFSEC3(2) = NINT(RMISSGV)
        ZFSEC3(2) = RMISSGV
      ENDIF
      CALL GRIBEX (IFSEC0,IFSEC1,IFSEC2,ZFSEC2,IFSEC3,ZFSEC3,IFSEC4,
     X             ZFSEC4,IPUNP,OLDFLD,ILENB,IWORD,'D',IRET)
      IF( ((IRET.EQ.-2).OR.(IRET.EQ.-4)).AND.
     X    (LIMISSV.EQV.(.FALSE.)) ) THEN
        WRITE(*,*) 'INTISL: Old field has a bitmap'
        WRITE(*,*) 'INTISL: A missing value must be specified'
        INTISL = -1
        RETURN
      ELSE IF( IRET.GT.0 ) THEN
        WRITE(*,*) 'INTISL: Old field gribex return code = ',IRET
        INTISL = -1
        RETURN
      ENDIF
C
C     -----------------------------------------------------------------|
C*    Section 3.   Dynamically allocate memory for the master land-sea
C                  mask values and new field values.
C     -----------------------------------------------------------------|
C
  300 CONTINUE
C
C     New land-sea mask
C
      IRET = 1
      IPUNP = 1
      ILENB = NIPNGRS
      CALL GRIBEX (IMSEC0,IMSEC1,IMSEC2,ZMSEC2,IMSEC3,ZMSEC3,IXSEC4,
     X             ZDUMMY,IPUNP,NEWLSM,ILENB,IWORD,'J',IRET)
      IF( IRET.NE.0 ) THEN
        WRITE(*,*) 'INTISL: Master lsm gribex return code = ',IRET
        INTISL = -1
        RETURN
      ENDIF
C
C     Dynamically allocate memory for the master land-sea mask values
C     and new field values
C
      IF( KMSEC4.LT.(IXSEC4(1)*JPREALB) ) THEN
        IF( KMSEC4.NE.0 ) THEN
          CALL JFREE(IZMSEC4)
          CALL JFREE(IPFSEC4)
        ENDIF
        KMSEC4 = IXSEC4(1)*JPREALB
        KPSEC4 = KMSEC4
        CALL INTLOG(JP_DEBUG,'INTISL: Allocate new memory = ',KMSEC4)
        IZMSEC4 = JMALLOC(KMSEC4)
        IPFSEC4 = JMALLOC(KPSEC4)
#ifdef hpR64
        IZMSEC4 = IZMSEC4/(1024*1024*1024*4)
        IPFSEC4 = IPFSEC4/(1024*1024*1024*4)
#endif
        IF( (IZMSEC4.EQ.0).OR.(IPFSEC4.EQ.0) ) THEN
          CALL INTLOG(JP_ERROR,'INTISL: JMALLOC fail newies',JPQUIET)
          INTISL = -1
          GOTO 900
        ENDIF
      ENDIF
C
      IRET = 1
      IPUNP = IXSEC4(1)
      ILENB = NIPNGRS
      CALL GRIBEX (IMSEC0,IMSEC1,IMSEC2,ZMSEC2,IMSEC3,ZMSEC3,IMSEC4,
     X             ZMSEC4,IPUNP,NEWLSM,ILENB,IWORD,'D',IRET)
      IF( IRET.NE.0 ) THEN
        WRITE(*,*) 'INTISL: Master lsm gribex return code = ',IRET
        INTISL = -1
        RETURN
      ENDIF
C
C     Requested field must match the new land-sea mask
C
      NEWTYPE = NOREPR
      IF( NOREPR.EQ.JPQUASI ) NEWTYPE = JPGAUSSIAN
      IF( (NEWTYPE.NE.IMSEC2(1)).OR.
     X    ((NOREPR.NE.JPQUASI).AND.(IMSEC2(17).NE.0)).OR.
     X    ((NOREPR.EQ.JPQUASI).AND.(IMSEC2(17).NE.1)) ) THEN
        CALL INTLOG(JP_ERROR,
     X    'INTISL: Land-sea mask not suitable',JPQUIET)
        INTISL = -1
        RETURN
      ENDIF
C
C     -----------------------------------------------------------------|
C*    Section 4.   Create new field and put in GRIB format
C     -----------------------------------------------------------------|
C
  400 CONTINUE
C
      IRET = NEWISL(ILSEC2, IMSEC2, ZLSEC4, ZFSEC4, ZMSEC4, PFSEC4)
      IF( IRET.NE.0 ) THEN
        WRITE(*,*) 'INTISL: New field creation failed'
        INTISL = -1
        RETURN
      ENDIF
C
      IRET = 1
      IPUNP = IXSEC4(1)
      ILENB = NIPNGRS
C
C     There may be 'missing' values in the new field if the old field
C     has 'missing' values.
C
      IF( IFSEC1(5).EQ.192 ) THEN
        IFSEC1(5) = 192
        NFSEC3(1) = 0
        NFSEC3(2) = INT(RMISSGV)
        PFSEC3(1) = 0.0
        PFSEC3(2) = RMISSGV
      ENDIF
C
      CALL GRIBEX (IFSEC0,IFSEC1,IMSEC2,ZMSEC2,NFSEC3,PFSEC3,IMSEC4,
     X             PFSEC4,IPUNP,NEWFLD,ILENB,IWORD,'C',IRET)
      IF( IRET.NE.0 ) THEN
        WRITE(*,*) 'INTISL: New field gribex return code = ',IRET
        INTISL = -1
        RETURN
      ENDIF
C
      INTISL = IWORD * JPINTB
C
C     -----------------------------------------------------------------|
C*    Section 9.   Return
C     -----------------------------------------------------------------|
C
  900 CONTINUE
C
      RETURN
      END

C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE ECDEF2( HFUNC, KSEC1, KGRIB, KLENG, KNSPT, KBITS,
     X                   KPR, KRET)
C
C---->
C**** ECDEF2
C
C     Purpose.
C     --------
C
C     GRIB coding/decoding of ECMWF local use definition 2.
C     (Extensions for clusters).
C
C
C**   Interface.
C     ----------
C
C     CALL ECDEF2( HFUNC, KSEC1, KGRIB, KLENG, KNSPT, KBITS, KPR, KRET)
C
C
C     Input Parameters.
C     -----------------
C
C     HFUNC      - Requested function.
C                  'C' to code data.
C                  'D' to decode data.
C
C     KSEC1      - Array containing Grib Section 1 data.
C
C     KGRIB      - Array containing Grib coded data.
C
C     KLENG      - Length (words) of KGRIB.
C
C     KNSPT      - Bit number after which insertion/extraction starts.
C
C     KBITS      - Number of bits in computer word.
C
C
C     KPR        - Debug print switch.
C                  0  , No printout.
C                  >0 , Debug printout.
C
C     KRET       - Response to error indicator.
C                  0        , Abort if error encountered.
C                  Non-zero , Return to calling routine
C                             even if error encountered.
C
C     Output Parameters.
C     ------------------
C
C     KSEC1      - Array containing Grib Section 1 data.(Updated)
C
C     KGRIB      - Array containing Grib coded data.(Updated)
C
C     KNSPT      - Number of bit after last one inserted/extracted.(Updated)
C
C     KRET       - Return code.
C                  0   , No error encountered.
C                  2   , Error reported by routine INXBIT.
C
C     Method.
C     -------
C
C     Input data packed/unpacked in accordance with ECMWF usage of
C     local part of section 1 of Grib code, definition 2.
C
C
C     Externals.
C     ----------
C
C     INXBIT
C     ABORTX
C     CSGNBT
C     DSGNBT
C
C     Reference.
C     ----------
C
C     WMO Manual On Codes for Grib Code.
C
C
C     Comments.
C     ---------
C
C     Adapted from ECLOC1.F - simplified to handle just definition 2.
#include "ecdef2.h"
C
C
C     Author.
C     -------
C
C     J.D.Chambers     ECMWF      18th January 1995
C
C
C     Modifications.
C     --------------
C
C     None.
C
C
C----<
C     ------------------------------------------------------------------
C*    Section 0 . Definition of variables. Data statements.
C     ------------------------------------------------------------------
C
      IMPLICIT NONE
C
#include "grprs.h"
C
C     Parameters
      CHARACTER*1   HFUNC
      INTEGER KSEC1, KGRIB, KLENG, KNSPT, KBITS, KPR, KRET
      DIMENSION KGRIB(*)
      DIMENSION KSEC1(*)
C
C     Local variables
      INTEGER IRET, IZERO, INSPT
C
      INTEGER ILALO
      DIMENSION ILALO(8)
C
      LOGICAL LENCODE, LDECODE
C
C     ------------------------------------------------------------------
C*    Section 1 . Set initial values.
C     ------------------------------------------------------------------
C
  100 CONTINUE
C
      IRET = KRET
      LENCODE = ( HFUNC .EQ. 'C' )
      LDECODE = .NOT. LENCODE
C
C     ------------------------------------------------------------------
C*    Section 2 . Extensions for clusters (definition 2).
C     ------------------------------------------------------------------
C
  200 CONTINUE
C
      IF( KPR.GE.1 ) WRITE(GRPRSM,*) 'ECDEF2 : Section 2.'
C
C*    Octet 50 : Cluster number.
C     Octet 51 : Total number of clusters.
C     Two 8 bit fields.
C
C     Insert/extract fields.
C
      CALL INXBIT (KGRIB,KLENG,KNSPT,KSEC1(42),2,KBITS, 8,HFUNC,KRET)
      IF (KRET.NE.0) THEN
        KRET = 2
        WRITE(GRPRSM,9004)
        GO TO 900
      ENDIF
C
C*    Octet 52 : Reserved
C     Set to 0.
C
      IF ( LENCODE ) THEN
        IZERO = 0
        CALL INXBIT(KGRIB,KLENG,KNSPT, IZERO,1,KBITS,8,HFUNC,KRET)
        IF (KRET.NE.0) THEN
          KRET = 2
          WRITE(GRPRSM,9004)
        ENDIF
      ELSE
        KNSPT = KNSPT + 8
      ENDIF
C
C*    Octet 53 : Clustering method.
C     One 8 bit field.
C
C     Insert/extract field.
C
      CALL INXBIT (KGRIB,KLENG,KNSPT,KSEC1(44),1,KBITS, 8,HFUNC,KRET)
      IF (KRET.NE.0) THEN
        KRET = 2
        WRITE(GRPRSM,9004)
        GO TO 900
      ENDIF
C
C*    Octets 54-55 : Start timestep when clustering.
C     Octets 56-57 : End timestep when clustering.
C     Two 16 bit fields.
C
C     Insert/extract fields.
C
      CALL INXBIT (KGRIB,KLENG,KNSPT,KSEC1(45),2,KBITS, 16,HFUNC,KRET)
      IF (KRET.NE.0) THEN
        KRET = 2
        WRITE(GRPRSM,9004)
        GO TO 900
      ENDIF
C
C*    Octets 58-60 : Northern latitude of domain of clustering
C     Octets 61-63 : Western longitude of domain of clustering
C     Octets 64-66 : Southern latitude of domain of clustering
C     Octets 67-69 : Eastern longitude of domain of clustering
C     Four 24 bit fields.
C
C     When coding values, set sign bit to 1, if value is negative.
C
      IF ( LENCODE ) THEN
        CALL CSGNBT( ILALO(1), KSEC1(47), 24, KRET)
        CALL CSGNBT( ILALO(2), KSEC1(48), 24, KRET)
        CALL CSGNBT( ILALO(3), KSEC1(49), 24, KRET)
        CALL CSGNBT( ILALO(4), KSEC1(50), 24, KRET)
      ENDIF
C
C     Insert/extract fields.
C
      CALL INXBIT (KGRIB,KLENG,KNSPT,ILALO(1),4,KBITS, 24,HFUNC,KRET)
      IF (KRET.NE.0) THEN
        KRET = 2
        WRITE(GRPRSM,9004)
        GO TO 900
      ENDIF
C
C     When decoding values, if sign bit is 1, value is
C     negative.
C
      IF ( LDECODE ) THEN
        CALL DSGNBT( KSEC1(47), ILALO(1), 24, KRET)
        CALL DSGNBT( KSEC1(48), ILALO(2), 24, KRET)
        CALL DSGNBT( KSEC1(49), ILALO(3), 24, KRET)
        CALL DSGNBT( KSEC1(50), ILALO(4), 24, KRET)
      ENDIF
C
C*    Octet 70 : Number of cluster to which operational forecast
C                  belongs.
C     Octet 71 : Number of cluster to which control forecast
C                  belongs.
C     Octet 72 : Number of forecasts belonging to the cluster.
C     Three 8 bit fields.
C
C     Insert/extract fields.
C
      CALL INXBIT (KGRIB,KLENG,KNSPT,KSEC1(51),3,KBITS, 8,HFUNC,KRET)
      IF (KRET.NE.0) THEN
        KRET = 2
        WRITE(GRPRSM,9004)
        GO TO 900
      ENDIF
C
C*    The number of forecasts belonging to a cluster may vary,
C     but section 1 is kept a fixed length.
C
      INSPT = KNSPT + 2048
C
C*    Octets 73-328 : List of N ensemble forecast numbers.
C     KSEC1(53) 8 bit fields.
C
C     Insert/extract fields.
C
      CALL INXBIT (KGRIB,KLENG,KNSPT,KSEC1(54),KSEC1(53),KBITS, 
     X             8,HFUNC,KRET)
      IF (KRET.NE.0) THEN
        KRET = 2
        WRITE(GRPRSM,9004)
        GO TO 900
      ENDIF
C
      KNSPT = INSPT
C
      GOTO 900
C
C     ------------------------------------------------------------------
C*    Section 9 . Abort/return to calling routine. Format statements.
C     ------------------------------------------------------------------
C
  900 CONTINUE
C
      IF( KPR.GE.1 ) THEN
        WRITE(GRPRSM,*) 'ECDEF2 : Section 9.'
        WRITE(GRPRSM,*) '         Output values set -'
        WRITE(GRPRSM,9003) KNSPT
      ENDIF
C
C     Abort if requested to do so when an error has been encountered.
C
      IF (IRET.EQ.0.AND.KRET.NE.0) THEN
        CALL ABORTX ('ECDEF2')
      ELSE
        RETURN
      ENDIF
C
 9003 FORMAT (1H ,'         KNSPT  = ',I12)
C
 9004 FORMAT (' ECDEF2: Error reported by routine INXBIT.')
C
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

#ifdef CRAY
      SUBROUTINE BLCKCR (UN1,UN2,BUF,IRET)
C
C---->
C**********************************************************************
C*                                                                    *
C*    NAME      : BLCKCR
C*                                                                    *
C*    FUNCTION  : CONVERTS AN UNBLOCKED DATASET                       *
C*                INTO A BLOCKED DATASET                              *
C*                                                                    *
C*    INPUT     : UN1   = INPUT  LUN                                  *
C*                UN2   = OUTPUT LUN                                  *
C*                BUF   = WORK AREA
C*                                                                    *
C*    OUTPUT    : IRET  = -100   BUFFER IN  ERROR                     *
C*                      = -200   BUFFER OUT ERROR                     *
C*                      > 0      NO. OF RECORDS WRITTEN               *
C*                      < 0      ERRORS REPORTED BY SUBROUTINES       *
C*                                                                    *
C*    GENERAL   : BLCKCR  CALLS  RECLEN                               *
C*                               OFFSET                               *
C*                               MODVAL                               *
C*                                                                    *
C*    AUTHOR    : B.V. GURETZKY     V.E.  DAY                         *
C*                                                                    *
C*    MODIFIED  : J. HENNESSY       26.11.85                          *
C*                      "           24.06.86
C*                      "           19.08.86
C*                                                                    *
C**********************************************************************
C----<
C
      IMPLICIT INTEGER (B,U)
      DIMENSION BUF(*)
C
C     NO. OF BITS PER CRAY WORD
      DATA NBIT /64/
C
C     BLOCK LENGTH FOR CRAY FILES (ICB) = 512
      DATA ICB /512/
C
C
      IRET = 0
      IRES = 0
      INT1 = 0
      IOFF = 0
      IPR  = 1

C     READ FIRST BLOCK AND GET LENGTH OF FIRST DATA RECORD.
C
      BUFFER IN (UN1,0) (BUF(1),BUF(ICB))
      IF (UNIT(UN1)) 100,5500,10000
C
  100 CALL RECLEN (BUF(1),LEN,NBIT,ICODE,INDIC,LEVEL,KERR)
      IF (KERR.NE.0)
     C   THEN
             IRET = KERR
             RETURN
         ENDIF
C
C     PRINT RECORD LENGTH , IF REQUIRED.
C
      IF (IPR.EQ.1) WRITE (*,9111) LEN
 9111 FORMAT (1H ,'BLCKCR : RECORD LENGTH (BYTES) = ',I9)
C     MAKE LENGTH MULTIPLE OF ICB
C
      LENW = LEN / 8
      CALL MODVAL (LENW,IE,ICB)
      IB = ICB
C
      DO 5000 J = 1,10000
C
C        READ ENOUGH BLOCKS TO INCLUDE REMAINDER OF CURRENT
C        DATA RECORD.
C
         IF (IPR.EQ.1) WRITE (*,9112) IB , IE
 9112 FORMAT (1H ,'BLCKCR : IB = ',I8,'   IE = ',I8)
         IF (IB.NE.IE)
     C      THEN
                BUFFER IN (UN1,0) (BUF(IB+1),BUF(IE))
                IOSTAT = UNIT(UN1)
                IF (IPR.EQ.1) WRITE (*,7878) IOSTAT
 7878           FORMAT (1H ,'IOSTAT = ',I4)
                IF (UNIT(UN1)) 1000,5500,10000
            ENDIF
C
C        WRITE FIELD IN UNBLOCKED FORMAT
C
 1000    BUFFER OUT (UN2,0) (BUF(1),BUF(LENW))
         IOSTAT = UNIT(UN2)
         IF (IOSTAT.GT.0) GO TO 10100
         IRET = IRET + 1
C
C        MOVE REMAINDER OF BLOCK TO FRONT OF BUFFER.
C
         INTER = IE - LENW
         DO 2000 K = 1,INTER
            BUF(K) = BUF(LENW+K)
 2000    CONTINUE
         IB = INTER
C
C        READ NEXT BLOCK TO CHECK LENGTH OF NEXT RECORD
C        AND END-OF-FILE
C
         IF (INTER.LT.ICB)
     C      THEN
                BUFFER IN (UN1,0) (BUF(INTER+1),BUF(INTER+ICB))
                IF (UNIT(UN1)) 3000,2500,10000
 2500           CONTINUE
                BUFFER IN (UN1,0) (BUF(INTER+1),BUF(INTER+ICB))
                IF (UNIT(UN1)) 3000,5500,10000
 3000           CONTINUE
                IB = IB + ICB
            ENDIF
C
C        GET  LENGTH FOR NEXT RECORD.
C
         CALL RECLEN (BUF(1),LEN,NBIT,ICODE,INDIC,LEVEL,KERR)
         IF (KERR.NE.0)
     C      THEN
                IRET = KERR
                RETURN
            ENDIF
C
         LENW = LEN / 8
C
C        MAKE LENGTH MULTIPLE OF ICB
C
         INT = LENW - IB
         CALL MODVAL (INT,IE,ICB)
C
C        READ OF SHORT RECORDS MAY BE COMPLETE.
C
         IF (INT.LT.0) IE = 0
         IE = IB + IE

 5000 CONTINUE

 5500 CONTINUE

      RETURN
C
10000 CONTINUE
      IRET               = -100
      WRITE (*,*) ' BLCKCR : BUFFER IN ERROR'
      RETURN
C
10100 CONTINUE
      IRET               = -200
      WRITE (*,*) ' BLCKCR : BUFFER OUT ERROR'
      RETURN
C
      END
#endif

C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

       SUBROUTINE BUSBYTESR4(DESTINATION,KSOURCE,KSKIP,KWIDTH,
     1                       KSKIPBETWEEN,KNUMBER)
C
C**** *BUSBYTESR4*
C
C
C     PURPOSE.
C     --------
C          
C
C**   INTERFACE.
C     ----------
C          NONE.
C
C
C
C
C     *METHOD.
C      -------
C          NONE.
C
C
C
C     EXTERNALS.
C     ----------
C          NONE.
C
C
C
C
C     REFERENCE.
C     ----------
C
C
C     AUTHOR.
C     -------
C
C          M. DRAGOSAVAC       *ECMWF*       JULY 2008
C
C
C     MODIFICATIONS.
C     --------------
C
C          NONE.
C
C
      IMPLICIT LOGICAL(L,O,G), CHARACTER*8(C,H,Y)

      REAL*4 DESTINATION

      CALL SBYTES(DESTINATION,KSOURCE,KSKIP,KWIDTH,KSKIPBETWEEN,KNUMBER)
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities
C granted to it by virtue of its status as an intergovernmental organisation
C nor does it submit to any jurisdiction.
C

      INTEGER FUNCTION AURESOL(NS,EW)
C
C---->
C**** AURESOL
C
C     Purpose
C     -------
C
C     Returns the default truncation for a given
C     latitude--longitude grid resolution.
C
C
C     Interface
C     ---------
C
C     KTRUNC = AURESOL(NS,EW)
C
C     Input
C     -----
C
C     NS     = north-south grid increment in degrees
C     EW     = east-west   grid increment in degrees
C
C     Output
C     ------
C
C     KTRUNC = Triangular truncation (e.g. 106 for T106)
C
C
C     Method
C     ------
C
C       Grid increment           Truncation
C       --------------           ----------
C
C       [2.5 and greater         T63
C
C       [1.5 to 2.5[             T106
C
C       [0.6 to 1.5[             T213
C
C       [0.4 to 0.6[             T319
C
C       [0.3 to 0.4[             T511
C
C       [0.15 to 0.3[            T799
C
C       [0.09 to 0.15[           T1279
C
C       [0 to 0.09[              T2047
C
C
C     Externals
C     ---------
C
C     None.
C
C     Author
C     ------
C
C     J.D.Chambers ECMWF Mar 1998
C
C
C     Reference.
C     ----------
C
C     None.
C
C     Modifications
C     -------------
C
C     S.Curic     ECMWF        April 2005
C     Add T799 and T1023
C
C ------------------------------------------------------------------
C----<
C
      IMPLICIT NONE

C     Function arguments
      REAL NS, EW

C     Local variables
      REAL STEP

      STEP = MIN(ABS(NS),ABS(EW))
      IF( STEP.GE.2.5 ) THEN       ! 2.5  <= step        -> T63
        AURESOL =   63
      ELSEIF( STEP.GE.1.5 ) THEN   ! 1.5  <= step < 2.5  -> T106
        AURESOL =  106
C     ELSEIF( STEP.GE.0.4 ) THEN   ! 1.5  <= step < 2.5  -> T191
C       AURESOL =  191
      ELSEIF( STEP.GE.0.6 ) THEN   ! 0.6  <= step < 1.5  -> T213
        AURESOL =  213
      ELSEIF( STEP.GE.0.4 ) THEN   ! 0.4  <= step < 0.6  -> T319
        AURESOL =  319
      ELSEIF( STEP.GE.0.3 ) THEN   ! 0.3  <= step < 0.4  -> T511
        AURESOL =  511
      ELSEIF( STEP.GE.0.15 ) THEN  ! 0.15 <= step < 0.3  -> T799
        AURESOL =  799
      ELSEIF( STEP.GE.0.09 ) THEN  ! 0.09 <= step < 0.15 -> T1279
        AURESOL = 1279
      ELSE                         ! highest truncation/resolution
        AURESOL = 2047
      ENDIF

      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      INTEGER FUNCTION GETTRU()
C
C---->
C*****GETTRU*
C
C     PURPOSE
C     -------
C
C      Finding Corresponding Truncation 
C
#include "parim.h"
#include "nofld.common"

      GETTRU = NORESO

        CALL INTLOG(JP_DEBUG,
     X 'GETTRU: Corresponding Truncation',GETTRU)
C
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities
C granted to it by virtue of its status as an intergovernmental organisation
C nor does it submit to any jurisdiction.
C

      INTEGER FUNCTION HSH2GG(NS,EW,KTRUNC,KNUM,HTYPE,KPTS,PLATS,KSIZE)
C
C---->
C**** HSH2GG
C
C     Purpose
C     -------
C
C     Finds a suitable Gaussian grid and/or spectral truncation for a
C     given spectral truncation and/or lat/long increments. There are
C     three modes (by order of precedence):
C     - providing NS,EW sets KTRUNC (using AURESOL) and KNUM/HTYPE
C     - providing KTRUNC sets KNUM/HTYPE
C     - providing KNUM sets KTRUNC
C     With KNUM/HTYPE set, the Gaussian grid definition is obtained with
C     JGETGG.
C     Parameters with value zero are assumed not provided.
C     Historically, this merges the functionality of:
C     - HSP2GG
C     - HSP2GG2
C     - HSP2GG3
C
C
C     Interface
C     ---------
C
C     IRET = HSH2GG(NS,EW,KTRUNC,KNUM,HTYPE,KPTS,PLATS,KSIZE)
C
C
C     Input parameters
C     ----------------
C     NS     - North-South increment
C     EW     - East-West increment
C
C
C     Input/output parameters
C     ----------------
C     KTRUNC - The spectral truncation
C     KNUM   - Gaussian grid number
C     HTYPE  - Gaussian grid type
C              = 'R' for reduced ("quasi-regular"),
C              = 'O' for reduced/octahedral,
C              = 'F' for full,
C              = 'U' for a user-defined Gaussian grid
C
C
C     Output parameters
C     -----------------
C     KPTS   - Array giving number of points along each line of latitude
C              in the reduced Gaussian grid (both hemispheres)
C     PLATS  - Array giving Gaussian latitudes (both hemispheres)
C     KSIZE  - The number of points in the reduced Gaussian grid
C
C     Returns 0 if all OK, otherwise there is an error.
C
C
C     Externals
C     ---------
C
C     JGETGG  - Reads the definition of a Gaussian grid
C     AURESOL - Returns the default truncation for a given
C               latitude--longitude grid resolution
C
C
C     Author
C     ------
C
C     J.D.Chambers      ECMWF      February 2001
C
C
C     Modifications
C     -------------
C
C     S.Curic     ECMWF      March 2005
C     Added checking for a automatic trancation T255, T399, T799, T2047
C     and corresponding Gaussian grid.
C
C     S.Curic     ECMWF      April 2008
C     Added checking for a automatic trancation T1279
C     and corresponding Gaussian grid.
C
C     S.Curic     ECMWF      Semptember 2009
C     Match T255 and T213 against N128 instead of N160
C     upon Alan Geer request
C
C
C----<
C     -----------------------------------------------------------------|
C*    Section 0. Definition of variables
C     -----------------------------------------------------------------|

      IMPLICIT NONE
#include "parim.h"
#include "jparams.h"

C     Function arguments
      INTEGER KTRUNC, KNUM, KPTS(*), KSIZE
      REAL NS, EW, PLATS(*)
      CHARACTER*1 HTYPE

C     Local variables
      INTEGER I, IRET
      REAL STEP

C     Externals
      INTEGER AURESOL
      EXTERNAL AURESOL

C     -----------------------------------------------------------------|
C     Section 1.  Initialise
C     -----------------------------------------------------------------|

      HSH2GG = 0

C     -----------------------------------------------------------------|
C     Section 2.  Set adequate truncation/grid number
C     -----------------------------------------------------------------|


C     if lat/long increments are provided, set automatic KTRUNC truncation
      IF( (KTRUNC.EQ.0) .AND. (KNUM.EQ.0) ) KTRUNC = AURESOL(NS,EW)


C     from a given truncation (KTRUNC) find a Gaussian number (KNUM)
      IF (KTRUNC.NE.0) THEN
        IF( KTRUNC.NE.  63 .AND. KTRUNC.NE.  64 .AND.
     .      KTRUNC.NE.  95 .AND. KTRUNC.NE.  96 .AND.
     .      KTRUNC.NE. 106 .AND. KTRUNC.NE. 107 .AND.
     .      KTRUNC.NE. 159 .AND. KTRUNC.NE. 160 .AND.
     .      KTRUNC.NE. 191 .AND. KTRUNC.NE. 192 .AND.
     .      KTRUNC.NE. 213 .AND. KTRUNC.NE. 214 .AND.
     .      KTRUNC.NE. 255 .AND. KTRUNC.NE. 256 .AND.
     .      KTRUNC.NE. 319 .AND. KTRUNC.NE. 320 .AND.
     .      KTRUNC.NE. 399 .AND. KTRUNC.NE. 400 .AND.
     .      KTRUNC.NE. 511 .AND. KTRUNC.NE. 512 .AND.
     .      KTRUNC.NE. 639 .AND. KTRUNC.NE. 640 .AND.
     .      KTRUNC.NE. 799 .AND. KTRUNC.NE. 800 .AND.
     .      KTRUNC.NE.1279 .AND. KTRUNC.NE.1280 .AND.
     .      KTRUNC.NE.2047 .AND. KTRUNC.NE.2048 ) THEN
          CALL INTLOG(JP_ERROR,'HSH2GG: truncation unsupported',KTRUNC)
          HSH2GG = 2
          GOTO 900
        ENDIF
        STEP = MIN(ABS(NS),ABS(EW))
        IF(     (KTRUNC.EQ.  63).OR.(KTRUNC.EQ.  64).OR.
     .          (KTRUNC.EQ.  95).OR.(KTRUNC.EQ.  96).OR.
     .          (STEP.GE.2.5) ) THEN                         ! 2.5  <= step        -> T63
          KNUM =   48
        ELSEIF( (KTRUNC.EQ. 106).OR.(KTRUNC.EQ. 107).OR.
     .          (KTRUNC.EQ. 159).OR.(KTRUNC.EQ. 160).OR.
     .          (STEP.GE.1.5) ) THEN                         ! 1.5  <= step < 2.5  -> T106
          KNUM =   80
        ELSEIF( (KTRUNC.EQ. 191).OR.(KTRUNC.EQ. 192).OR.
     .          (STEP.GE.0.4 .AND. .FALSE.) ) THEN           ! 1.5  <= step < 2.5  -> T191 (commented)
          KNUM =   96
        ELSEIF( (KTRUNC.EQ. 213).OR.(KTRUNC.EQ. 214).OR.
     .          (KTRUNC.EQ. 255).OR.(KTRUNC.EQ. 256).OR.     ! Enfo 2004
     .          (STEP.GE.0.6) ) THEN                         ! 0.6  <= step < 1.5  -> T213
          KNUM =  128
        ELSEIF( (KTRUNC.EQ. 319).OR.(KTRUNC.EQ. 320).OR.
     .          (STEP.GE.0.4) ) THEN                         ! 0.4  <= step < 0.6  -> T319
          KNUM =  160
        ELSEIF( (KTRUNC.EQ. 399).OR.(KTRUNC.EQ. 400) ) THEN  ! Enfo 2005
          KNUM =  200
        ELSEIF( (KTRUNC.EQ. 511).OR.(KTRUNC.EQ. 512).OR.     ! Oper 2004
     .          (STEP.GE.0.3) ) THEN                         ! 0.3  <= step < 0.4  -> T511
          KNUM =  256
        ELSEIF( (KTRUNC.EQ. 639).OR.(KTRUNC.EQ. 640) ) THEN
          KNUM =  320
        ELSEIF( (KTRUNC.EQ. 799).OR.(KTRUNC.EQ. 800).OR.     ! Oper 2005
     .          (STEP.GE.0.15) ) THEN                        ! 0.15 <= step < 0.3  -> T799
          KNUM =  400
        ELSEIF( (KTRUNC.EQ.1279).OR.(KTRUNC.EQ.1280).OR.     ! Jan Haseler
     .          (STEP.GE.0.09) ) THEN                        ! 0.09 <= step < 0.15 -> T1279
          KNUM =  640
        ELSEIF( (KTRUNC.EQ.2047).OR.(KTRUNC.EQ.2048).OR.     ! Mariano
     .          (STEP.LT.0.09) ) THEN                        ! 0.09 <= step < 0.15 -> T1279
          KNUM = 1024
        ENDIF
        HTYPE = 'R'


C     from a given Gaussian number (KNUM) find a truncation (KTRUNC)
      ELSEIF (KNUM.NE.0) THEN
        IF( KNUM.NE.  48 .AND. KNUM.NE.  80 .AND. KNUM.NE.  96 .AND.
     .      KNUM.NE. 128 .AND. KNUM.NE. 160 .AND. KNUM.NE. 200 .AND.
     .      KNUM.NE. 256 .AND. KNUM.NE. 320 .AND. KNUM.NE. 400 .AND.
     .      KNUM.NE. 640 .AND. KNUM.NE.1024 .AND. KNUM.NE.1280 ) THEN
        CALL INTLOG(JP_ERROR,'HSH2GG: Gaussian number unsupported',KNUM)
          HSH2GG = 2
          GOTO 900
        ENDIF
        IF(     KNUM.EQ.  48 ) THEN
C         KTRUNC =   63
          KTRUNC =   95
        ELSEIF( KNUM.EQ.  80 ) THEN
          KTRUNC =  159
        ELSEIF( KNUM.EQ.  96 ) THEN
          KTRUNC =  191              ! Elias 2014
        ELSEIF( KNUM.EQ. 128 ) THEN
C         KTRUNC =  213
          KTRUNC =  255              ! Enfo 2004
        ELSEIF( KNUM.EQ. 160 ) THEN
          KTRUNC =  319
        ELSEIF( KNUM.EQ. 200 ) THEN
          KTRUNC =  399              ! Enfo 2005
        ELSEIF( KNUM.EQ. 256 ) THEN
          KTRUNC =  511              ! Oper 2004
        ELSEIF( KNUM.EQ. 320 ) THEN
          KTRUNC =  639
        ELSEIF( KNUM.EQ. 400 ) THEN
          KTRUNC =  799              ! Oper 2005
        ELSEIF( KNUM.EQ. 640 ) THEN
          KTRUNC = 1279              ! Jan Haseler
        ELSEIF( KNUM.EQ.1024 ) THEN
          KTRUNC = 2047              ! Mariano
        ELSEIF( KNUM.EQ.1280 ) THEN
          KTRUNC = 1279              ! (cubic octahedral)
        ENDIF

      ENDIF

C     -----------------------------------------------------------------|
C     Section 3.  Get the reduced Gaussian grid and count points
C     -----------------------------------------------------------------|

      CALL INTLOG(JP_DEBUG,'HSH2GG: spectral truncation:',KTRUNC)
      CALL INTLOG(JP_DEBUG,'HSH2GG: Gaussian grid: '//HTYPE,KNUM)
      IF( HTYPE.NE.'R' .AND. HTYPE.NE.'O' .AND.
     X    HTYPE.NE.'F' .AND. HTYPE.NE.'U' ) THEN
        CALL INTLOG(JP_ERROR,
     X    'HSH2GG: Gaussian type unsupported: '//HTYPE,JPQUIET)
        HSH2GG = 3
        GOTO 900
      ENDIF
      CALL JGETGG(KNUM,HTYPE,PLATS,KPTS,IRET)
      IF( IRET.NE.0 ) THEN
        CALL INTLOG(JP_ERROR, 'HSH2GG: JGETGG failed',JPQUIET)
        HSH2GG = 3
      ELSE
        KSIZE = 0
        DO I = 1, KNUM*2
          KSIZE = KSIZE + KPTS(I)
        ENDDO
      ENDIF

C     -----------------------------------------------------------------|
C     Section 9.  Return
C     -----------------------------------------------------------------|

  900 CONTINUE
      RETURN

      END

C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      INTEGER FUNCTION WV2DXXX(ISEC2,ISEC4,NLATS,STEPNS,STEPWE,
     X                         OLDWAVE,NEWIDX,NEWWAVE,NORTH,WEST,PMISS)
C
C---->
C*****WV2DXXX*
C
C     PURPOSE
C     -------
C
C     Interpolates 2D wave spectra fields.
C
C
C     INTERFACE
C     ---------
C
C     IRET = WV2DXXX(ISEC2,ISEC4,NLATS,STEPNS,STEPWE,
C    X               OLDWAVE,NEWIDX,NEWWAVE,NORTH,WEST,PMISS)
C
C     Input arguments
C     ---------------
C
C     ISEC2   - Unpacked section 2 header from 2D wave spectra field
C     ISEC4   - Unpacked section 4 header from 2D wave spectra field
C     NLATS   - Number of points N-S in new grid
C     STEPNS  - Output grid north-south resolution (degrees)
C     STEPWE  - Output grid west-east resolution (degrees)
C     OLDWAVE - Original wave field
C     NORTH   - Output grid northernmost latitude (degrees)
C     WEST    - Output grid westernmost longitude (degrees)
C     PMISS   - Missing data value 
C
C     Output arguments
C     ----------------
C
C     NEWIDX  - Indices of old grid points used for new grid points
C     NEWWAVE - New wave field
C
C     Function returns 0 if the interpolation was OK.
C
C
C     METHOD
C     ------
C
C     Builds the index of nearest neighbour points for the output grid.
C     Then works through the output grid points, checking for subarea
C     boundaries and looking up nearset neighbour 2D spectra values
C     (which may be missing data).
C
C
C     EXTERNALS
C     ---------
C
C     WV2DIDX - builds the index of nearest neighbour points
C     NUMPTWE - Calculates number of grid points between west/east
C               area boundaries
C     VALPINA - Looks up bitmap value
C     ONEBITS - Counts number of 1s in a GRIB section 3 bitmap
C     NUMVALS - Counts the values in the secondary bitmap.
C     SOFFSET - Finds the section offsets in GRIB message
C     INTLOG  - Log error message
C
C
C     REFERENCE
C     ---------
C
C     None.
C
C
C     Author.
C     -------
C
C     J.D.Chambers      ECMWF    November 1996
C
C
C     Modifications
C     -------------
C
C     J.D.Chambers      ECMWF    April 1998
C     Handle parameter 251 as a simple form of wave 2D spectra.
C     (A field containing one direction and one frequency).
C
C
C----<
C
      IMPLICIT NONE
C
C     Subroutine arguments
C
      INTEGER ISEC2, ISEC4, NLATS
      DIMENSION ISEC2(*), ISEC4(*)
      REAL STEPNS, STEPWE, OLDWAVE, NEWWAVE, NORTH, WEST, PMISS
      DIMENSION OLDWAVE(*), NEWWAVE(*)
      INTEGER NEWIDX
      DIMENSION NEWIDX(*)
C
C     Parameters
C
      INTEGER JPROUTINE, JPMXLAT, JPNSPEC
      PARAMETER (JPROUTINE = 40000)
      PARAMETER (JPMXLAT = 1801)
      PARAMETER (JPNSPEC = 600)
C
C     Local arguments
C
      LOGICAL LSIMPLE
      INTEGER IEOFSET, IWOFSET, ISTART, IWEST
      REAL SOUTH, EAST, PTLAT, PTLONG, AWEST, OLDWEST, OLDEAST
      REAL REFVAL, SCALE
      INTEGER NPDATA, INSPT, NEXP, NMANT, NRETA, NRETB, NLENG, NBIT
      INTEGER NVALS
      INTEGER ISCALE, NSCALE, IBITS, ITEMP, NPBTMP2, IBITMAP, NUNUSED
      DIMENSION IBITMAP(JPNSPEC)
      INTEGER IRET, IS0, IS1, IS2, IS3, IS4, IEDITN
      INTEGER NEXT, NEXTWV, NROW, NCOL, INDEX, ILOCATE
      INTEGER NSPEC, MISSLAT, LOOP, NPTS, NUMLATS, NUMNEW
      INTEGER KOLDNUM, KNEWNUM
      DIMENSION NPTS(JPMXLAT), NUMNEW(JPMXLAT)
      REAL RLATINC, OLDLATS, NEWLATS, ROWINC
      DIMENSION OLDLATS(JPMXLAT), NEWLATS(JPMXLAT)
C
C     Externals
C
      INTEGER WV2DIDX, SOFFSET, VALPINA, NUMVALS, ONEBITS, NUMPTWE
      EXTERNAL WV2DIDX, SOFFSET, VALPINA, NUMVALS, ONEBITS, NUMPTWE
C
#include "parim.h"
#include "nifld.common"
#include "nofld.common"
#include "grspace.h"
C
C ---------------------------------------------------------------------
C*    Section 1. Initalisation.
C ---------------------------------------------------------------------
C
  100 CONTINUE
C
      WV2DXXX = 0
C
C     Initialise the bitmap value lookup function and function
C     which counts the values in the secondary bitmap.
C
      IRET = VALPINA(0,0,0)
      IRET = NUMVALS(0,0,0)
C
C     Setup number of spectra at each point
C
      IF( ISEC4(8).EQ.0 ) THEN
        LSIMPLE = .TRUE.
        NSPEC   = 1
      ELSE
        LSIMPLE = .FALSE.
        NSPEC   = ISEC4(50)*ISEC4(51)
      ENDIF
C
      IF( NSPEC.GT.JPNSPEC) THEN
        CALL INTLOG(JP_ERROR,
     X    'WV2DXXX: Number of wave spectra at each grid pt = ',NSPEC)
        CALL INTLOG(JP_ERROR,
     X    'WV2DXXX: And is greater than allowed maximum = ',JPNSPEC)
        WV2DXXX = JPROUTINE + 1
        GOTO 900
      ENDIF
C
C     Calculate number of latitudes if grid had been full from
C     North pole to South pole
C
      NUMLATS = (180000/ISEC2(10)) + 1
      IF( NUMLATS.GT.JPMXLAT ) THEN
        CALL INTLOG(JP_ERROR,
     X    'WV2DXXX: Number of latitudes in input grid = ',NUMLATS)
        CALL INTLOG(JP_ERROR,
     X    'WV2DXXX: And is greater than allowed maximum = ',JPMXLAT)
        WV2DXXX = JPROUTINE + 2
        GOTO 900
      ENDIF
      RLATINC = FLOAT(ISEC2(10))/1000
      DO LOOP = 1, NUMLATS
        OLDLATS(LOOP) = 90.0 - (LOOP-1)*RLATINC
      ENDDO
C
C     Fill an array with the number of points at each latitude for the
C     input field (this is a reduced latitude/longitude grid)
C
      MISSLAT = (90000 - ISEC2(4))/ISEC2(10)
      DO LOOP = 1, MISSLAT
        NPTS(LOOP)    = 0
      ENDDO
      KOLDNUM = 1 + (90000 - ISEC2(7))/ISEC2(10)
      DO LOOP = 1, (KOLDNUM-MISSLAT)
        IF( NIREPR.EQ.JPREDLL ) THEN
          NPTS(LOOP+MISSLAT) = ISEC2(22+LOOP)
        ELSE
          NPTS(LOOP+MISSLAT) = ISEC2(2)
        ENDIF
      ENDDO
      DO LOOP = (KOLDNUM+1), NUMLATS
        NPTS(LOOP)    = 0
      ENDDO
C
C ---------------------------------------------------------------------
C*    Section 2. Setup number of points at each latitude for the
C                output latitude/longitude field.
C ---------------------------------------------------------------------
C
  200 CONTINUE
C
      IF( (NOREPR.EQ.JPQUASI) .OR. (NOREPR.EQ.JPGAUSSIAN) ) THEN
C
C       Reduced (quasi-regular) gaussian output
C
        KNEWNUM = NOGAUSS*2
        DO LOOP = 1, KNEWNUM
          NUMNEW(LOOP)  = NOLPTS(LOOP)
          NEWLATS(LOOP) = ROGAUSS(LOOP)
        ENDDO
C
      ELSE IF( NOREPR.EQ.JPREDLL ) THEN
C
C       Reduced (quasi-regular) lat/long output
C
        KNEWNUM = NOREDLL
        DO LOOP = 1, KNEWNUM
          NUMNEW(LOOP)  = NOLPTS(LOOP)
          NEWLATS(LOOP) = ROREDLL(LOOP)
        ENDDO
C
      ELSE
C
C       Regular output
C
        MISSLAT = NINT((90.0 - NORTH)/STEPNS)
        DO LOOP = 1, MISSLAT
          NUMNEW(LOOP)    = 0
        ENDDO
        DO LOOP = 1, NLATS
          NUMNEW(LOOP+MISSLAT) = NINT(360.0/STEPWE)
        ENDDO
C
        KNEWNUM = MISSLAT + NLATS
        DO LOOP = 1, KNEWNUM
          NEWLATS(LOOP) = 90.0 - (LOOP-1)*STEPNS
        ENDDO
C
      ENDIF
C
C ---------------------------------------------------------------------
C*    Section 3. Get the input GRIB field characteristics.
C ---------------------------------------------------------------------
C
  300 CONTINUE
C
C     Calculate the indices of the input grid points to be used for
C     the output points
C
      OLDWEST = FLOAT(ISEC2(5))/1000
      OLDEAST = FLOAT(ISEC2(8))/1000
      WV2DXXX = WV2DIDX(NUMLATS,NPTS,OLDLATS,OLDWEST,OLDEAST,
     X                  KNEWNUM, NUMNEW, NEWLATS, NEWIDX)
      IF( WV2DXXX.NE.0 ) THEN
        CALL INTLOG(JP_ERROR,
     X    'WV2DXXX: Unable to calculate output grid indices',JPQUIET)
        WV2DXXX = JPROUTINE + 3
        GOTO 900
      ENDIF
C
C     Find section offsets for the GRIB product
C
      IRET = SOFFSET(OLDWAVE, IS0, IS1, IS2, IS3, IS4, IEDITN)
      IF( IRET.NE.0 ) THEN
        CALL INTLOG(JP_ERROR,
     X    'WV2DXXX: Problem finding section offsets for GRIB',JPQUIET)
        WV2DXXX = JPROUTINE + 4
        GOTO 900
      ENDIF
C
C     Get the overall length of OLDWAVE
C
#ifdef INTEGER_8
      NBIT = 64
#else
      NBIT = 32
#endif
      INSPT = (IS0 + 4) * 8
      CALL INXBIT(OLDWAVE,10,INSPT,NLENG,1,NBIT,24,'D',NRETA)
      IF( NRETA.NE.0 ) THEN
        CALL INTLOG(JP_ERROR,
     X    'WV2DXXX: Problem extracting overall length of GRIB',JPQUIET)
        WV2DXXX = JPROUTINE + 5
        GOTO 900
      ENDIF
C
C     Get the scale factor
C
      INSPT = (IS4 + 4) * 8
      CALL INXBIT(OLDWAVE,NLENG,INSPT,NSCALE,1,NBIT,16,'D',NRETA)
      IF( NRETA.NE.0 ) THEN
        CALL INTLOG(JP_ERROR,
     X    'WV2DXXX: Problem extracting scale factor in GRIB',JPQUIET)
        WV2DXXX = JPROUTINE + 6
        GOTO 900
      ENDIF
      CALL DSGNBT(ISCALE,NSCALE,16,NRETA)
      IF( NRETA.NE.0 ) THEN
        CALL INTLOG(JP_ERROR,
     X    'WV2DXXX: Problem setting sign of scale factor',JPQUIET)
        WV2DXXX = JPROUTINE + 7
        GOTO 900
      ENDIF
      SCALE = 2.0**(FLOAT(ISCALE))
C
C     Get the reference value
C
      CALL INXBIT(OLDWAVE,NLENG,INSPT,NEXP,1,NBIT,8,'D',NRETA)
      CALL INXBIT(OLDWAVE,NLENG,INSPT,NMANT,1,NBIT,24,'D',NRETB)
      IF( (NRETA.NE.0) .OR. (NRETB.NE.0) ) THEN
        CALL INTLOG(JP_ERROR,
     X    'WV2DXXX: Problem getting reference value from GRIB',JPQUIET)
        WV2DXXX = JPROUTINE + 8
        GOTO 900
      ENDIF
      CALL DECFP2(REFVAL,NEXP,NMANT)
C
C     Get number of bits per packed value
C
      CALL INXBIT(OLDWAVE,NLENG,INSPT,IBITS,1,NBIT,8,'D',NRETA)
      IF( NRETA.NE.0 ) THEN
        CALL INTLOG(JP_ERROR,
     X    'WV2DXXX: Problem getting number of bits per word',JPQUIET)
        WV2DXXX = JPROUTINE + 9
        GOTO 900
      ENDIF
C
C     (Pointer INSPT is currently at octet 12 in GRIB section 4)
C
C     Set up pointers to start of secondary bitmap and start of packed
C     data values
C
#ifdef INTEGER_8
      NBIT = 64
#else
      NBIT = 32
#endif
      NPBTMP2 = (IS4 + 24)*8 + (ISEC4(53)+ISEC4(55))*32
C
      IF( .NOT. LSIMPLE ) THEN
        NPDATA  = NPBTMP2 + NSPEC*ONEBITS(OLDWAVE,IS3)
      ELSE
        NPDATA  = NPBTMP2
      ENDIF
      NPDATA  = ((NPDATA + 7)/8)*8
C
C ---------------------------------------------------------------------
C*    Section 4. Work through the output subarea.
C ---------------------------------------------------------------------
C
  400 CONTINUE
C
C     Fill in the wave spectra values
C
      NEXT = 0
      NEXTWV = 0
C
      SOUTH = NOAREA(3)/PPMULT
      EAST  = NOAREA(4)/PPMULT
      ISTART = 0
C
C     Work down through latitudes from north to south.
C
      DO NROW = 1, KNEWNUM
C
C       If inside north-south (subarea) boundaries ..
C
        IF( (NOREPR.EQ.JPGAUSSIAN).OR.(NOREPR.EQ.JPQUASI) ) THEN
          PTLAT = ROGAUSS(NROW)
        ELSE
          PTLAT = 90.0 - (NROW-1)*STEPNS
        ENDIF
C
        IF( (PTLAT.LE.NORTH).AND.(ABS(PTLAT-SOUTH).GT.-0.0005) ) THEN
C
C         Calculate number of points between west boundary of area and
C         Greenwich
C
          ROWINC = 360.0/NUMNEW(NROW)
C
          IWEST = INT(WEST/ROWINC)
          IF( (WEST.GT.0.0).AND.(WEST.NE.(IWEST*ROWINC)) )
     X      IWEST = IWEST + 1
          AWEST = IWEST * ROWINC
          IWOFSET = NUMPTWE(AWEST,0.0,ROWINC)
          IEOFSET = NUMPTWE(AWEST,EAST,ROWINC)
C
C         Work through subarea longitudes from west to east.
C
          DO NCOL = 1, NUMNEW(NROW)
            PTLONG = AWEST + (NCOL-1)*ROWINC
            NEXT = NUMPTWE(AWEST,PTLONG,ROWINC)
            IF( (NEXT.LE.IEOFSET).AND.(NEXT.GE.0) ) THEN
C
C             .. and inside west-east (subarea) boundaries
C
              NEXT = 1 + NEXT - IWOFSET
              IF( NEXT.LE.0) NEXT = NEXT + NUMNEW(NROW)
              NEXT = NEXT + ISTART
              INDEX = NEWIDX(NEXT)
              ILOCATE = VALPINA(OLDWAVE, IS3+6, INDEX)
C
              IF( ILOCATE.EQ.0 ) THEN
C
C               Nearest neighbour is a 'missing' point
C
                DO LOOP = 1, NSPEC
                  NEXTWV = NEXTWV + 1
                  NEWWAVE(NEXTWV) = PMISS
                ENDDO
C
              ELSE
C
C               Nearest neighbour has values
C
                IF( LSIMPLE ) THEN
                  INSPT = NPDATA + (ILOCATE - 1)*IBITS
                  NVALS = 1
                  IBITMAP(1) = 1
                ELSE
C
C                 Count the number of values in the secondary bitmap upto
C                 the current point and pick up its secondary bitmap.
C
                  INSPT = NPBTMP2 + (ILOCATE - 1)*NSPEC
                  NVALS = NUMVALS(OLDWAVE,NPBTMP2,INSPT)
                  CALL INXBIT(OLDWAVE,NLENG,INSPT,IBITMAP,NSPEC,
     X                        NBIT,1,'D',NRETA)
                  IF( NRETA.NE.0 ) THEN
                    CALL INTLOG(JP_ERROR,
     X              'WV2DXXX: Problem getting neighbours 2ndary bitmap',
     X              JPQUIET)
                    WV2DXXX = JPROUTINE + 10
                    GOTO 900
                  ENDIF
C
C                 Pick up the values at the current point
C
                  INSPT = NPDATA + NVALS*IBITS
                ENDIF
C
                DO LOOP = 1, NSPEC
                  NEXTWV = NEXTWV + 1
                  IF( IBITMAP(LOOP).EQ.0 ) THEN
C
C                   ..missing
C
                    NEWWAVE(NEXTWV) = PMISS
C
                  ELSE
C
C                   ..retrieve and recreate the packed value
C
                    CALL INXBIT(OLDWAVE,NLENG,INSPT,ITEMP,1,
     X                          NBIT,IBITS,'D',NRETA)
                    IF( NRETA.NE.0 ) THEN
                      CALL INTLOG(JP_ERROR,
     X                'WV2DXXX: Problem getting nearest neighbour',
     X                JPQUIET)
                      WV2DXXX = JPROUTINE + 11
                      GOTO 900
                    ENDIF
                    NEWWAVE(NEXTWV) = REFVAL + FLOAT(ITEMP)*SCALE
                  ENDIF
                ENDDO
C
              ENDIF
            ENDIF
          ENDDO
C
        ENDIF
        ISTART = ISTART + NUMNEW(NROW)
      ENDDO
C
C ---------------------------------------------------------------------
C*    Section 9. Closedown.
C ---------------------------------------------------------------------
C
  900 CONTINUE
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities
C granted to it by virtue of its status as an intergovernmental organisation
C nor does it submit to any jurisdiction.
C

#if (defined IBM_POWER4)
@PROCESS ALIAS(NOPTEOVRLP)
#endif
      INTEGER FUNCTION CSECT4( PDATA, KTRUNC, KSEC1, KSEC4,
     X                         KGRIB, KLENG, KNSPT, KBITS, KPACK)
C
C---->
C**** CSECT4
C
C     Purpose.
C     --------
C
C     Code GRIB section 4 for complex packing of spherical harmonics.
C
C
C**   Interface.
C     ----------
C
C     KRET = CSECT4( PDATA, KTRUNC, KSEC1, KSEC4,
C    X               KGRIB, KLENG, KNSPT, KBITS, KPACK)
C
C
C     Input Parameters.
C     -----------------
C
C     PDATA      - Array of floating point values.
C     KTRUNC     - Truncation of the spherical harmonic coefficients.
C     KSEC1      - Array of GRIB section 1 values
C     KSEC4      - Array of GRIB section 4 values
C     KLENG      - Length of GRIB product array
C     KNSPT      - Bit pointer for next value in GRIB product
C     KBITS      - Number of bits per computer word.
C     KPACK      - Number of bits per packed value.
C
C
C     Output Parameters.
C     -----------------
C
C     KGRIB      - Array containing GRIB product.
C     KNSPT      - Bit pointer for next value in GRIB product(updated)
C
C
C     Method.
C     -------
C
C                            <subset>|
C
C     Given numbers:         cccccccc|cccccc
C                              cccccc|cccccc
C                                cccc|cccccc
C                                  cc|cccccc
C                                    |cccccc
C                                       cccc
C                                         cc
C
C
C     Externals.
C     ----------
C
C     GSCALE    - Apply power sclaing to values to be packed.
C     PACKCF    - Store unscaled coefficients in GRIB product.
C     CMPCK     - Make the values to be packed contiguous in memory.
C     MAXMIN    - Find max/min values of array.
C     INXBIT    - Insert bits into GRIB product.
C     REF2GRB   - Convert reference value to IBM floating point format.
C     CONFP3    - Convert to IBM floating point format.
C     DECFP     - Decode from IBM floating point format.
C     CALCOP    - Calculate the P scale factor for a field
C     JMALLOC   - Routine to acquire memory
C     JFREE     - Routine to release memory
C
C     Reference.
C     ----------
C
C     None.
C
C
C     Comments.
C     --------
C
C     On entry, KNSPT points to the first bit of section 4 in the GRIB
C               product.
C     On exit,  KNSPT points to the first bit of section 5 in the GRIB
C               product.
C
C
C     Author.
C     -------
C
C     J.D.Chambers     ECMWF      06:05:94
C
C
C     Modifications.
C     _____________
C
C     J.Clochard, Meteo France, for ECMWF - January 1998.
C     Use of external JFREE instead of FREE.
C
C     P.J.Towers       ECMWF      18.07.02
C     Optimised for IBM Power4.
C         -Added @PROCESS ALIAS(NOPTEOVRLP) directive
C         -Replaced Nint(x) by Int(x+0.5)
C         -Replaced division by scale by multiplication by reciprocal
C
C
C----<
C     -----------------------------------------------------------------
C*    Section 0. Definition of variables.
C     -----------------------------------------------------------------
C
      IMPLICIT NONE
C
#include "common/grprs.h"
C
C     Parameters
C
      INTEGER JP15BIT, JP87SET, JPBYTES
#ifdef REAL_8
      PARAMETER (JPBYTES = 8)
#else
      PARAMETER (JPBYTES = 4)
#endif
      PARAMETER ( JP15BIT= 2**15 )
C                            `---> 32768    =   8000(hex)
      PARAMETER ( JP87SET= 192 )
C                            `--->          =     C0(hex)
C
C     Subroutine arguments
C
      INTEGER KTRUNC, KSEC1, KSEC4, KGRIB, KLENG, KNSPT, KBITS, KPACK
      REAL PDATA
      DIMENSION PDATA(*), KGRIB(*), KSEC1(*), KSEC4(*)
C
C     Local variables.
C
      INTEGER J110, LOOP, IPOWER, ISUBSET
#if (defined USE_NO_POINTERS)
      INTEGER NREST, NLOOPS, ILOOP
#endif
      INTEGER ILENF, ISTATUS
      INTEGER IRET, IRETA, IRETB, IEXP, IMANT, ITEMP
      INTEGER INSPT1, INSPTA, INSPTB, ILEN, ISCALE, ISIGN
      INTEGER ILEN4, INIL, IL, IFLAG, ISIZE
C
#ifndef USE_NO_POINTERS
#ifndef _CRAYFTN
#ifdef POINTER_64
      INTEGER*8 IPIVAL
#endif
#endif
      POINTER (IPIVAL, IVAL)
      INTEGER IVAL(1)
      SAVE IPIVAL, ISIZE
#else
      INTEGER IVAL(1000)
#endif
C
      REAL ZCHANGE, ZMAX, ZREF, ZMIN, ZSCALE,ZRECIP
#if defined(CRAY) || defined(IBM) || defined(CYBER) || defined(hpiaR32)
      REAL    ZS
#else
      DOUBLE PRECISION    ZS
#endif
C
#include "grbcom.h"
C
C     Externals
C
#ifdef POINTER_64
      INTEGER*8 JMALLOC
#else
      INTEGER JMALLOC
#endif
      INTEGER PACKCF, GSCALE, CALCOP, REF2GRB
      EXTERNAL PACKCF, GSCALE, CALCOP, REF2GRB, JMALLOC
C
      DATA ISIZE/0/
C
C     -----------------------------------------------------------------
C*    Section 1 . Change units of data values , if required.
C     -----------------------------------------------------------------
C
  100 CONTINUE
C
      CSECT4 = 0
#ifndef USE_NO_POINTERS
C
C     Allocate memory (first time only)
C
      IF( ISIZE.LT.((KTRUNC+1)*(KTRUNC+2)*JPBYTES) ) THEN
        IF( ISIZE.NE.0 ) CALL JFREE(IPIVAL)
        ISIZE = (KTRUNC+1)*(KTRUNC+2)*JPBYTES
        IPIVAL = JMALLOC(ISIZE)
#ifdef hpR64
        IPIVAL = IPIVAL/(1024*1024*1024*4)
#endif
        IF( IPIVAL.EQ.0 ) THEN
          WRITE(GRPRSM,*) 'CSECT4: Memory allocation failed.'
          WRITE(GRPRSM,*) 'CSECT4: Number of bytes required = ', ISIZE
          CSECT4 = 16112
          GOTO 900
        ENDIF
      ENDIF
#endif
C
C     Preserve bit position of start of section 4.
      INSPT1 = KNSPT
C
C     Apply decimal scaling if required.
      IF (KSEC1(23).NE.0) THEN
        ZCHANGE = 10.0**KSEC1(23)
        ILENF = (KTRUNC+1) * (KTRUNC+2)
        DO 110 J110 = 1 , ILENF
          PDATA(J110) = PDATA(J110) * ZCHANGE
  110   CONTINUE
      ENDIF
C
C     -----------------------------------------------------------------
C*    Section 2.  Check given truncations.
C     -----------------------------------------------------------------
C
  200 CONTINUE
C
      ISUBSET = KSEC4(18)
      IF ( ISUBSET .GT. KTRUNC ) THEN
        WRITE(GRPRSM,*) 'CSECT4: Invalid subset truncation given'
        WRITE(GRPRSM,*) 'CSECT4: ISUBSET, KTRUNC =', ISUBSET, KTRUNC
        CSECT4 = 16000
        GOTO 900
      ENDIF
C
C     -----------------------------------------------------------------
C*    Section 3 . Apply power scaling to field.
C     -----------------------------------------------------------------

  300 CONTINUE
C
C     If user supplied the P factor, use it ..
      IF ( NONOFF .EQ. 0 ) THEN
        IPOWER  = KSEC4(17)
C
C     .. otherwise calculate the P factor for the field ..
      ELSE
        IPOWER  = CALCOP( PDATA, KTRUNC, ISUBSET)
        IF( IPOWER.LT.-10000 ) THEN
          CSECT4 = 16001
          GOTO 900
        ENDIF
        KSEC4(17) = IPOWER
      ENDIF
C     .. and scale the field.
      IRET = GSCALE( PDATA, KTRUNC, ISUBSET, IPOWER, 'I')
      IF ( IRET .NE. 0 ) THEN
        CSECT4 = 16002
        GOTO 900
      ENDIF
C
C
C     -----------------------------------------------------------------
C*    Section 4 . Store subset of coefficients (IBM style).
C     -----------------------------------------------------------------
C
  400 CONTINUE
C
C     Adjust pointer to avoid first 18 octets -> filled in later.
      INSPTA = KNSPT
      KNSPT = KNSPT + 18*8
      IRET = PACKCF( PDATA,KTRUNC,ISUBSET,KGRIB,KLENG,KNSPT,KBITS)
      IF ( IRET .NE. 0 ) THEN
        CSECT4 = 16003
        GOTO 900
      ENDIF
C
C     Reset bit pointer to start of section 4.
      INSPTB = KNSPT
      KNSPT = INSPTA
C
C     -----------------------------------------------------------------
C*    Section 5 . Find the max and min for the values to be scaled.
C     -----------------------------------------------------------------
C
  500 CONTINUE
C
C     Rearrange the values to be packed so they are contiguous.
      CALL CMPCK( PDATA, KTRUNC, ISUBSET)
C
C     Find the max and min for the contiguous values
      ILEN = (KTRUNC+1)*(KTRUNC+2) - (ISUBSET+1)*(ISUBSET+2)
      CALL MAXMIN( PDATA, ILEN, ZMAX, ZMIN)
C
C     Calculate the scale and reference value
      ZREF = ZMIN
      ZS = (ZMAX-ZREF) / (2**(KSEC4(2)+1)-1)
#ifdef CRAY
      IF (ZS.NE.0.0) ZS = ALOG(ZS) / ALOG(2.0) + 2.0
#else
      IF (ZS.NE.0.0) ZS = LOG(ZS) / LOG(2.0) + 2.0
#endif
#if defined hpR32 || defined (__alpha) || defined hpR64 || defined hpiaR64
      ISCALE = MIN (INT(ZS),INT(ZS+DSIGN(1.0D0,ZS)))
#elif defined (linux) || defined (darwin)
      ISCALE = MIN (INT(ZS),INT(ZS+SIGN(1.D0,ZS)))
#else
      ISCALE = MIN (INT(ZS),INT(ZS+SIGN(1.,ZS)))
#endif
      ZSCALE = 2.0**ISCALE
C
C     Set scale factor sign bit.
      IF (ISCALE.LT.0) THEN
        ISCALE = -ISCALE
        ISIGN  = JP15BIT
        ISCALE = ISCALE + ISIGN
      ENDIF
C
C*    Octets 5 - 6 : Scale factor.
C     One 16 bit field.
C
C     Adjust bit pointer over first 4 octets and insert scale factor.
      KNSPT = KNSPT + 4*8
      CALL INXBIT(KGRIB,KLENG,KNSPT,ISCALE,1,KBITS, 16,'C',IRET)
      IF (IRET.NE.0) THEN
        WRITE(GRPRSM,*) 'CSECT4: Problem packing scale factor.'
        CSECT4 = 16004
        GO TO 900
      ENDIF
C
C*    Octets 7 - 10 : Reference value.
C     One 8 bit and one 24 bit field.
C
C     Convert floating point to GRIB representation.
      ISTATUS = REF2GRB(ZREF, IEXP, IMANT, KBITS)
      IF( ISTATUS.NE.0 ) THEN
        WRITE(GRPRSM,*) 'CSECT4: REF2GRB reference value problem'
        WRITE(GRPRSM,*) 'CSECT4: for parameter ', KSEC1(6)
        WRITE(GRPRSM,*) 'CSECT4: level type ', KSEC1(7)
        WRITE(GRPRSM,*) 'CSECT4: level ', KSEC1(8), KSEC1(9)
      ENDIF
C
C     Insert reference value exponent and mantissa.
      CALL INXBIT(KGRIB,KLENG,KNSPT,IEXP,1,KBITS, 8,'C',IRETA)
      CALL INXBIT(KGRIB,KLENG,KNSPT,IMANT,1,KBITS, 24,'C',IRETB)
      IRET = IRETA + IRETB
      IF (IRET.NE.0) THEN
        WRITE(GRPRSM,*) 'CSECT4: Problem packing reference value.'
        CSECT4 = 16005
        GO TO 900
      ENDIF
C
C     -----------------------------------------------------------------
C*    Section 6 . Store octets 11 to 18.
C     -----------------------------------------------------------------
C
  600 CONTINUE
C
C*    Octet 11 : Number of bits containing each packed value.
C     One 8 bit field.
C
C     Insert number of bits for each packed value.
      CALL INXBIT(KGRIB,KLENG,KNSPT,KSEC4(2),1,KBITS, 8,'C',IRET)
      IF (IRET.NE.0) THEN
        WRITE(GRPRSM,*) 'CSECT4: Problem packing number of bits/value.'
        CSECT4 = 16006
        GO TO 900
      ENDIF
C
C     Octets 12 - 13: Octet number of the start of packed data
C     One 16-bit field.
C
C     Insert octet number of the start of packed data.
      KSEC4(16) = KNSPT/8 + 7 + 4*(ISUBSET+1)*(ISUBSET+2)
      CALL INXBIT(KGRIB,KLENG,KNSPT,KSEC4(16),1,KBITS,16,'C',IRET)
      IF (IRET.NE.0) THEN
        WRITE(GRPRSM,*) 'CSECT4: Problem packing start of packed data.'
        CSECT4 = 16007
        GO TO 900
      ENDIF
C
C     Octets 14 - 15: Scaling factor; power of Laplacian operator
C                     applied to field before packing.
C     One 16-bit field.
C
C     Set sign bit if value is negative.
      IF (KSEC4(17).LT.0) THEN
        ITEMP = - KSEC4(17)
        ITEMP = ITEMP + JP15BIT
      ELSE
        ITEMP = KSEC4(17)
      ENDIF
C
C     Insert scaling power.
      CALL INXBIT(KGRIB,KLENG,KNSPT,ITEMP,1,KBITS,16,'C',IRET)
      IF (IRET.NE.0) THEN
        WRITE(GRPRSM,*) 'CSECT4: Problem packing scaling power.'
        CSECT4 = 16008
        GO TO 900
      ENDIF
C
C     Octets 16 - 18: Pentagonal resolution parameters J,K,M
C                     specifying truncation of subset of data
C                     represented unpacked.
C     Three 8-bit fields.
C
C     Insert pentagonal resolution parameters.
      CALL INXBIT(KGRIB,KLENG,KNSPT,KSEC4(18),3,KBITS, 8,'C',IRET)
      IF (IRET.NE.0) THEN
        WRITE(GRPRSM,*)
     X    'CSECT4: Problem packing pentagonal resolution params.'
        CSECT4 = 16009
        GO TO 900
      ENDIF
C
C     -----------------------------------------------------------------
C*    Section 7 . Adjust, scale and pack the binary values.
C     -----------------------------------------------------------------
C
  700 CONTINUE
#ifndef USE_NO_POINTERS
      ZRECIP=1.0/ZSCALE
C
      DO LOOP = 1 , ILEN
#ifdef VAX
        IVAL(LOOP)   = JNINT( (PDATA(LOOP) - ZREF) / ZSCALE )
#else
        IVAL(LOOP)   =  INT( (PDATA(LOOP) - ZREF ) * ZRECIP + 0.5 )
#endif
      ENDDO
C
C     Adjust bit pointer to end of stored subset of coefficients and
C     store packed binary values in GRIB product -> updates bit pointer.
C
      KNSPT = INSPTB
      CALL INXBIT (KGRIB,KLENG,KNSPT,IVAL,ILEN, KBITS,KPACK, 'C',IRET)
      IF ( IRET .NE. 0 ) THEN
        WRITE(GRPRSM,*) 'CSECT4: Problem packing bits'
        CSECT4 = 16010
        GOTO 900
      ENDIF
#else
      NLOOPS = ILEN / 1000
      NREST  = ILEN - (NLOOPS)*1000
      KNSPT  = INSPTB
C
      DO ILOOP = 1, NLOOPS
        DO LOOP = 1 , 1000
#ifdef VAX
          IVAL(LOOP) = JNINT((PDATA((ILOOP-1)*1000+LOOP)-ZREF)/ZSCALE)
#else
          IVAL(LOOP) =  NINT((PDATA((ILOOP-1)*1000+LOOP)-ZREF)/ZSCALE)
#endif
        ENDDO
C
C       Adjust bit pointer to end of stored subset of coefficients and
C       store packed binary values in GRIB product -> updates bit pointer.
C
        CALL INXBIT(KGRIB,KLENG,KNSPT,IVAL,1000,KBITS,KPACK,'C',IRET)
        IF( IRET.NE.0 ) THEN
          WRITE(GRPRSM,*) 'CSECT4: Problem packing bits'
          CSECT4 = 16010
          GOTO 900
        ENDIF
      ENDDO
C
      DO LOOP = 1, NREST
#ifdef VAX
        IVAL(LOOP) = JNINT((PDATA((NLOOPS*1000)+LOOP)-ZREF)/ZSCALE)
#else
        IVAL(LOOP) =  NINT((PDATA((NLOOPS*1000)+LOOP)-ZREF)/ZSCALE)
#endif
      ENDDO
C
C       Adjust bit pointer to end of stored subset of coefficients and
C       store packed binary values in GRIB product -> updates bit pointer.
C
      CALL INXBIT (KGRIB,KLENG,KNSPT,IVAL,NREST,KBITS,KPACK,'C',IRET)
      IF( IRET.NE.0 ) THEN
        WRITE(GRPRSM,*) 'CSECT4: Problem packing bits'
        CSECT4 = 16010
        GOTO 900
      ENDIF
#endif
C
C     -----------------------------------------------------------------
C*    Section 8 . Fill in first 4 octets of section 4.
C     -----------------------------------------------------------------
C
  800 CONTINUE
C
C     Adjust length of section 4 (in bits) to a multiple of 16.
      ILEN4 = KNSPT - INSPT1
      IL    = ILEN4 / 16
      IL    = ILEN4 - ( IL * 16 )
      INIL  = 0
      IF (IL.NE.0) INIL = 16 - IL
      KNSPT = KNSPT + INIL
      ILEN4 = ILEN4 + INIL
C
C     Set length of section 4 to octets.
      ILEN4 = ILEN4 / 8
C
C     Octets 1 - 3: Length of section.
C     One 24-bit field.
C
      CALL INXBIT(KGRIB,KLENG,INSPT1,ILEN4,1,KBITS,24,'C',IRET)
      IF (IRET.NE.0) THEN
        WRITE(GRPRSM,*) 'CSECT4: Problem packing length of section.'
        CSECT4 = 16010
        GO TO 900
      ENDIF
C
C     Octet 4:
C     One 4-bit field -> flag, spherical harmonics/complex/float point
C     One 4-bit field -> number of unused bits at end of section 4.
C
      IFLAG = JP87SET + INIL
      CALL INXBIT(KGRIB,KLENG,INSPT1,IFLAG,1,KBITS,8,'C',IRET)
      IF (IRET.NE.0) THEN
        WRITE(GRPRSM,*) 'CSECT4: Problem packing flag.'
        CSECT4 = 16011
        GO TO 900
      ENDIF
C
C     -----------------------------------------------------------------
C*    Section 9. Return to calling routine.
C     -----------------------------------------------------------------
C
  900 CONTINUE
C
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities
C granted to it by virtue of its status as an intergovernmental organisation
C nor does it submit to any jurisdiction.
C

      SUBROUTINE GRCHK1(KSEC1,KRET)
C
C---->
C**** GRCHK1 - Check parameters for Section 1 of GRIB code.
C
C     Purpose.
C     --------
C
C     Check parameters for Section 1 of GRIB code against
C     valid values for GRIB Code Edition 1.
C
C**   Interface.
C     ----------
C
C     CALL GRCHK1(KSEC1,KRET)
C
C
C     Input Parameters.
C     -----------------
C
C     KSEC1      - Array containing parameters for section
C                  1 of GRIB code.
C
C     Output Parameters.
C     ------------------
C
C     KRET       - Return code.
C                  0   , No error encountered.
C                  1   , Error in GRIB code parameter.
C
C     Method.
C     -------
C
C     Values checked against current code/flag tables
C     and against maximum or minimum permitted values.
C     They are also checked against the current status
C     of the implementation of GRIBEX and ECMWF usage.
C
C     Externals.
C     ----------
C
C     KWCHK1  - Check Washington ensemble products local usage.
C     CHKTAB2 - Checks whether parameter appears in know code tables 2
C
C     Reference.
C     ----------
C
C     WMO Manual on Codes for GRIB code.
C
C     Comments.
C     ---------
C
C     None.
C
C     Author.
C     -------
C
C     J. Hennessy      ECMWF      18.06.91
C
C     Modifications.
C     --------------
C
C     J. Hennessy      ECMWF      30.08.91
C     Checks for bit-map present removed.
C     Check for negative value for century removed.
C
C     J. Hennessy      ECMWF      02.12.91
C     Changes to Table 2 and Parameter number checks.
C
C     J. Hennessy      ECMWF      22.07.92
C     Missing data value (255) allowed for originating centre
C     and parameter number.
C     Additional checks for experimental space view
C     perspective added.
C
C     J. Hennessy      ECMWF      09.11.92
C     Checks for ECMWF local use 1 and 2 added.
C
C     J. Hennessy      ECMWF      24.05.93
C     Checks for ECMWF local use 3 and 4 added.
C
C     J. Hennessy      ECMWF      08.06.93
C     Meteosat 3 and Goes 6 added.
C
C     J.D.Chambers     ECMWF      20.10.93
C     Checks for ECMWF local use 5 added.
C
C     J.D.Chambers     ECMWF      07.02.94
C     Add satellite streams 52,53 and satellite ids 121, 122
C
C     J.D.Chambers     ECMWF      10.05.94
C     Fix test of KSEC1(43) - total forecast number can be 0
C
C     J.D.Chambers     ECMWF      12.05.94
C     Checks for ECMWF local use 7 added.
C
C     J.D.Chambers     ECMWF      09.06.94
C     Allow missing data indicator(255) for date/time/...
C
C     J.D.Chambers     ECMWF      17.06.94
C     Add CLASS = 3 for ERA.
C
C     J.D.Chambers     ECMWF      19.09.94
C     Allow single field in an average.
C     Remove restriction that number of fields missing from an
C     average should be less than the number in the average.
C
C     J.D.Chambers     ECMWF      23.11.94
C     Only check for reserved fields if ECMWF local usage 1.
C
C     J.D.Chambers     ECMWF      02.02.95
C     Allow types 17 and 18 (ensemble mean/standard deviations).
C
C     J.D.Chambers     ECMWF      14.02.95
C     Allow type 52 (sensitivity forecast)
C
C     J.D.Chambers     ECMWF      28.03.95
C     Allow parameters 127 & 128 in code table 2, ECMWF table 128
C
C     J.D.Chambers     ECMWF      09.10.95
C     Check Washington ensemble products local usage.
C
C     J.D.Chambers     ECMWF      27.02.96
C     Allow for ECMWF local use definition 6.
C
C     J.D.Chambers     ECMWF      04.11.96
C     Add CLASS = 4, TYPE = 21, STREAM = 2231/2232/2233 for ECSN.
C
C     J.D.Chambers     ECMWF      08.01.98
C     Add TYPE = 22 (climate simulation, 360 day year) for ECSN.
C
C     J.D.Chambers     ECMWF      13.02.98
C     Add EPS tubes and SSTs.
C
C     J.D.Chambers     ECMWF      April 1998
C     Add wave 2D spectra directions and frequencies
C
C     J.D.Chambers     ECMWF      April 1998
C     Update WMO valid table entries.
C
C     J. Clochard, Meteo France, for ECMWF - June 1999.
C     Adapt CHKTAB2 to new calling syntax.
C
C     J.D.Chambers     ECMWF      April 2000
C     Add CLASS = 6 for DEMETER.
C     Add CLASS = 7 for PROVOST.
C
C     J.D.Chambers     ECMWF      October 2002
C     Add TYPE = 27 for extreme forecast index
C         TYPE = 28 for extreme forecast index control
C
C     J.D.Chambers     ECMWF      March 2003
C     Add TYPE = 33 for 4D variational increments
C
C     J.D.Chambers     ECMWF      April 2003
C     Add CLASS = 8 for ELDAS
C     Add TYPE = 34 for gridded observations
C     Add TYPE = 90-99 for Mars development
C     Add STREAM = 1061-1069 for Mars development
C     Add STREAM = 1100 and 1101 for ELDAS
C
C     J.D.Chambers     ECMWF      April 2003
C     Add type 64 - signal variance
C
C     J.D.Chambers     ECMWF      February 2004
C     Add monthly forecast streams, 1200 - 1211
C
C     J.D.Chambers     ECMWF      February 2004
C     Add monthly forecast streams, 1220 - 1224
C
C     J.D.Chambers     ECMWF      March 2004
C     Add Delayed CutOff streams, 1028 and 1029
C
C     J.D.Chambers     ECMWF      September 2004
C     Add local definition 24
C
C     J.D.Chambers     ECMWF      November 2004
C     Add local definition 25
C
C     J.D.Chambers     ECMWF      January 2005
C     Add streams 1039 and 1084
C
C     S.Curic     ECMWF      March 2005
C     Add STREAM = 1024 Daily archive hindcast
C         STREAM = 1034 Ensemble forecast overlap
C         STREAM = 1039 Ensemble forecast hindcasts (changed name)
C         STREAM = 1084 Ensemble wave hindcast (changed name)
C         STREAM = 1085 Wave hindcast
C         STREAM = 1086 Wave ensemble forecast overlap
C         STREAM = 1087
C     Add TYPE = 29 Probability Boundaries
C         TYPE = 36 Probability Distribution
C         TYPE = 37 Cluster information
C     Add CLASS = 10 Cosmo leps
C         CLASS = 11 Ensembles
C
C     S.Curic     ECMWF      March 2005
C     Add type of level 211 Ocean wave data (ECMWF extention)
C                       212 Wave spectra
C
C     S.Curic     ECMWF      July 2005
C     Add STREAM = 1075 Monthly means of Daily forecast accumulations
C     Add Time range indicator = 120 Average of N Forecast. Each product
C             is an accumulation from forecast lenght P1 to forecast
C              lenght P2, with reference times at intervals P2-P1
C     S.Curic     ECMWF      September 2005
C        211 level type has been replaced with 209 because 211 is
C        in use by NCEP
C     Add CLASS = 12 TIGGE
C
C     S.Curic     ECMWF      January 2006
C     Add CLASS = 14 ERA Interim
C
C     M.Fuentes   ECMWF      February 2006
C     Add TYPE = 65 CV (Cal/Val)
C
C     S.Curic     ECMWF      March 2006
C     Add STREAM = 1030  Ensemble Data Assimilation
C         STREAM = 1076  Monthly Means Daily climatology
C         STREAM = 1088  Ensemble Wave Data Assimilation
C         STREAM = 1089  Daily climatology wave
C
C     S.Curic     ECMWF      April 2006
C     Add STREAM = 1230  Multi-model Multi-annual Forecast
C         STREAM = 1231  Multi-model Multi-annual Forecast means
C         STREAM = 1232  Multi-model Multi-annual Forecast wave
C         STREAM = 1233  Multi-model Multi-annual Forecast wave means
C
C     S.Curic     ECMWF      January 2007
C     Add Satellite identifiers 56, 171
C
C     S.Curic     ECMWF      February 2007
C          STREAM = 1032 efho Ensemble Forecast Hindcast Overlap
C          STREAM = 1033 enfh Ensemble Forecast Hindcasts
C          STREAM = 1078 ewho Ensemble Forecast Wave Hindcast Overlap
C          STREAM = 1079 enwh Ensemble Forecast Wave Hindcasts
C
C     S.Curic     ECMWF      February 2007
C     Add CLASS = 15 SREPS Short-Range Ensemble Prediction System
C
C     S.Curic     ECMWF      July 2007
C     Add TYPE = 38       Unassigned
C         TYPE = 39       Unassigned
C
C     M.Fuentes   ECMWF      July 2007
C     Add STREAM = 1040   efhm Ensemble Forecast Hindcast Means
C
C     S.Curic     ECMWF      July 2007
C     Add CLASS = 16 dt (Data Targeting System)
C
C     S.Curic     ECMWF      July 2008
C     Add TYPE = 32      Climate Distribution (CD)
C         TYPE = 38      Shift Of Tails (SOT)
C     Add STREAM = 1077  Wave Ensemble forecast Hindcast Stat (WEHS)
C
C     S.Curic     ECMWF      September 2008
C     Add STREAM = 1240  Eurosip
C     Add STREAM = 1241  EUROSIP Hindcast Monthly Means
C
C     S.Curic     ECMWF      January 2010
C     Add CLASS = 19 MACC Monitoring Atmos. Composition and Climate
C
C     S.Curic     ECMWF      January 2010
C     Add CLASS = 20 PE Permanent experiments
C
C
C     S.Curic     ECMWF      September 2010
C     Add TYPE = 45     Cluster representative  CR
C
C     S.Curic     ECMWF      November 2010
C     Add satellite streams 172,257
C
C
C     S.Curic     ECMWF      December 2010
C     Add stream 1022  fsob forecast sensitivity to observations
C     Add stream 1023  fsow forecast sensitivity to observations wave
C     Add type  47    taem    time average ensemble mean
C     Add type  48    taes    time average ensemble standard deviation
C
C----<
C     -----------------------------------------------------------------|
C*    Section 0 . Definition of variables. Data statements.
C     -----------------------------------------------------------------|
C
      IMPLICIT NONE
C
#include "common/grprs.h"
C
C     Subroutine arguments
C
      INTEGER KRET, KSEC1
      DIMENSION KSEC1(*)
C
C     Parameters
C
      INTEGER JPAVAC, JPTYP, JPSTR, JP1, JP3, JP4, JP5, JPIDSAT
      PARAMETER (JPAVAC=9)
      PARAMETER (JP1=4)
      PARAMETER (JP3=40)
      PARAMETER (JP4=12)
      PARAMETER (JP5=17)
      PARAMETER (JPTYP=71)
      PARAMETER (JPSTR=126)
      PARAMETER (JPIDSAT = 28)
C
C     Local variables
C
      LOGICAL LECMWF, LKWBC
C
      INTEGER LOOP, NRET, IDSATEL, NUMBER
      INTEGER IAC, IAVAC, IRET, ISTRE, ITAB1
      INTEGER ITAB3, ITAB4, ITAB5, ITEMP, ITYPE
C
      DIMENSION IDSATEL(JPIDSAT)
      DIMENSION ITAB1(JP1)
      DIMENSION ITAB3(JP3)
      DIMENSION ITAB4(JP4)
      DIMENSION ITAB5(JP5)
      DIMENSION IAVAC(JPAVAC)
      DIMENSION ITYPE(JPTYP)
      DIMENSION ISTRE(JPSTR)
C
      CHARACTER*121 HFIRST, HSECOND, HTHIRD, HFOURTH
C
      SAVE ITAB1, ITAB3, ITAB4, ITAB5, IAVAC
      SAVE ITYPE, ISTRE, IDSATEL
C
C     Externals
C
      INTEGER CHKTAB2
      EXTERNAL CHKTAB2
C
C     Valid values given in Code Table 1.
C
      DATA ITAB1  /0,128,64,192/
C
C     Valid values given in Code Table 3.
C
      DATA ITAB3 /1,2,3,4,5,6,7,8,9,20,
     X            100,101,102,103,104,105,106,107,108,109,
     X            110,111,112,113,114,115,116,117,119,
     X            120,121,125,128,141,160,200,201,209,210,212/
C
C     Valid values given in Code Table 4.
C
      DATA ITAB4 /0,1,2,3,4,5,6,7,10,11,12,
     X            254/
C
C     Valid values given in Code Table 5.
C
      DATA ITAB5 /0,1,2,3,4,5,
     X            10,
     X            113,114,115,116,117,118,119,
     X            120,123,124/
C
C     Valid values given in Code Table 5, for averages and
C     accumulations.
C
      DATA IAVAC /113,114,115,116,117,118,119,
     X            123,124/
C
C     Valid values for type.
C

      DATA ITYPE /    1, 2, 3, 4, 5, 6, 7, 8, 9,
     X            10,11,12,13,14,15,16,17,18,19,
     X            20,21,22,23,24,25,26,27,28,29,
     X            30,31,32,33,34,35,36,37,38,39,
     X            40,41,42,45,47,48,
     X            50,51,52,
     X            60,61,62,63,64,65,
     X            70,71,72,
     X            80,81,82,83,
     X            90,91,92,93,94,95,96,97,98,99/
C
C     Valid values for stream.
C
      DATA ISTRE /
     X      50,  51,  52,  53,  54, 55,
     X     119, 120, 121, 122, 130, 140,
     X     150, 151, 152, 201, 250, 251, 252, 253, 254, 255, 256,
     X     1022,1023,
     X     1024,1025,1026,1027,1028,1029,1030,1032,1033,
     X     1034,1035,1036,1037,1038,1039,
     X     1040,1041,1042,1043,1044,1045,1046,1047,
     X     1050,1051,1052,1053,1054,1055,1056,
     X     1060,1061,1062,1063,1064,1065,1066,1067,1068,1069,
     X     1070,1071,1072,1073,1074,1075,1076,1077,1078,1079,
     X     1080,1081,1082,1083,1084,1085,1086,1087,1088,1089,
     X     1090,1091,1092,1093,1094,1095,1096,1097,
     X     1100,1101,1110,
     X     1200,1201,1202,1203,1204,1205,1206,1207,1208,1209,
     X     1210,1211,
     X     1220,1221,1222,1223,1224,
     X     1230,1231,1232,1233,
     X     1240,1241,
     X     2231,2232,2233,
     X     2240,2241,2242,2243/
C
C
C     Valid values for satellite identifiers
C
      DATA IDSATEL/
     X   50, 51, 52, 53, 54, 55, 56,119, 120, 121, 122, 130, 140,
     X  150, 151, 152, 171, 172, 199, 201, 250, 251, 252, 253,
     X   254, 255, 256, 257/
C
C     -----------------------------------------------------------------|
C*    Section 1 . Set initial values.
C     -----------------------------------------------------------------|
C
  100 CONTINUE
C
C     Reset return code.
      KRET = 0
C
C     -----------------------------------------------------------------|
C*    Section 2 . Check values against code tables and extreme values.
C     -----------------------------------------------------------------|
C
  200 CONTINUE
C
C*    Check Parameter Table version number.
C
      IF( (KSEC1(1).LT.1).OR.(KSEC1(1).GT.254) ) THEN
        WRITE(GRPRSM,9001) KSEC1(1)
        KRET = 1
      ENDIF
C
C*    Check Identification of centre. Code Table 0.
C     Currently only values 1 to 98 inclusive are used.
C     Missing value indicator (255) is allowed.
C
      IF( (KSEC1(2).LT.0).OR.(KSEC1(2).GT.255) ) THEN
        WRITE(GRPRSM,9002) KSEC1(2)
        KRET = 1
      ENDIF
C
      LECMWF = ( KSEC1(2).EQ.98 ).OR.
     X         ( (KSEC1(2).EQ.80).AND.
     X           (KSEC1(24).EQ.1).AND.
     X           (KSEC1(37).EQ.50) )
      LKWBC  = ( (KSEC1(2).EQ.7) .AND. (KSEC1(22).NE.98) )
C
C*    Check Generating process identification number.
C
      IF( (KSEC1(3).LT.1).OR.(KSEC1(3).GT.255) ) THEN
        WRITE(GRPRSM,9003) KSEC1(3)
        KRET = 1
      ENDIF
C
C*    Check Grid definition.
C
      IF( (KSEC1(4).LT.1).OR.(KSEC1(4).GT.255) ) THEN
        WRITE(GRPRSM,9004) KSEC1(4)
        KRET = 1
      ENDIF
C
C*    Check Flag. Code Table 1.
C
      DO LOOP = 1, JP1
         IF( KSEC1(5).EQ.ITAB1(LOOP) ) GOTO 215
      ENDDO
C
      WRITE(GRPRSM,9005) KSEC1(5)
      KRET = 1
C
  215 CONTINUE
C
C*    Cross check that, if uncatalogued grid is specified, Section
C     2, Grid description section, is included.
C
      IF( (KSEC1(4).EQ.255).AND.
     X    ( (KSEC1(5).EQ.0).OR.(KSEC1(5).EQ.64) ) ) THEN
        KRET = 1
        WRITE(GRPRSM,9014)
      ENDIF
C
C*    Check Parameter indicator. Code Table 2.
C
      IF( (KSEC1(6).LT.1).OR.(KSEC1(6).GT.255) ) THEN
        WRITE(GRPRSM,9006) KSEC1(6)
        KRET = 1
      ENDIF
C
C*    Check ECMWF Parameter Table Number and Parameter Indicators.
C
      IF( LECMWF ) THEN
C
        IRET = CHKTAB2(KSEC1,HFIRST,HSECOND,HTHIRD,HFOURTH)
C
        IF( IRET.EQ.20001 ) THEN
C
          IF( MIN( KSEC1(1),KSEC1(6)) .LE. 127 ) THEN
            WRITE(GRPRSM,*)
     X        'GRCHK1: WMO code table 2 version ', KSEC1(1)
          ELSEIF (LECMWF) THEN
            WRITE(GRPRSM,*)
     X        'GRCHK1: ECMWF local table 2 version ', KSEC1(1)
          ELSE
            WRITE(GRPRSM,*)
     X 'GRCHK1: originating centre local table 2 version ', KSEC1(1)
          ENDIF
C
          WRITE(GRPRSM,*)
     X        '        does not contain parameter  ', KSEC1(6)
C
        ENDIF
C
      ENDIF
C
C*    Check International Table useage.
C
      IF( (KSEC1(1).LT.127).AND.(KSEC1(6).GT.127) ) THEN
        WRITE(GRPRSM,9024) KSEC1(6) , KSEC1(1)
      ENDIF
C
C*    Check Indicator of type of level. Code Table 3.
C     Experimental space view uses this field as satellite
C     identification.
C
      IF( (KSEC1(6).EQ.127).AND.(KSEC1(1).EQ.1) ) THEN
C
C       Satellite identification.
C
        NRET = 1
        DO LOOP = 1, JPIDSAT
          IF( KSEC1(7).EQ.IDSATEL(LOOP) ) NRET = 0
        ENDDO
C
        IF( NRET.EQ.1 ) THEN
          WRITE(GRPRSM,*)
     X        'GRCHK1: Invalid satellite identifier: ',KSEC1(7)
          KRET = 1
        ENDIF

      ELSE
C
        IRET = 0
C
C       Type of level.
C
        DO LOOP = 1, JP3
          IF( KSEC1(7).EQ.ITAB3(LOOP) ) GOTO 225
        ENDDO
C
        IRET = 1
C
  225   CONTINUE
C
C       ECMWF uses 200 for pseudo-levels.
C
        IF( (KSEC1(7).EQ.200).AND.LECMWF ) IRET = 0
        IF( IRET.EQ.1 ) THEN
          WRITE(GRPRSM,9015) KSEC1(7)
          KRET = 1
        ENDIF
C

C
      ENDIF
C
C     For certain level types no description is necessary and
C     those fields should be 0.
C
      IF( (KSEC1(7).LT.8).OR.(KSEC1(7).EQ.102) ) THEN
        ITEMP = KSEC1(8) + KSEC1(9)
        IF( ITEMP.NE.0 ) THEN
          KRET = 1
          WRITE(GRPRSM,9023) KSEC1(7) , KSEC1(8) , KSEC1(9)
        ENDIF
      ENDIF
C
C*    Check Year of century.
C
C
      IF( (KSEC1(10).LT.0).OR.(KSEC1(10).GT.100) ) THEN
        IF( KSEC1(10).NE.255 ) THEN
          WRITE(GRPRSM,9008) KSEC1(10)
          KRET = 1
        ENDIF
      ENDIF
C
C*    Month check.
C
      IF( (KSEC1(11).LT.1).OR.(KSEC1(11).GT.12) ) THEN
        IF( KSEC1(10).NE.255 ) THEN
          WRITE(GRPRSM,9009) KSEC1(11)
          KRET = 1
        ENDIF
      ENDIF
C
C*    Day check.
C
      IF( (KSEC1(12).LT.1).OR.(KSEC1(12).GT.31) ) THEN
        IF( KSEC1(10).NE.255 ) THEN
          WRITE(GRPRSM,9010) KSEC1(12)
          KRET = 1
        ENDIF
      ENDIF
C
C*    Hour check.
C
      IF( (KSEC1(13).LT.0).OR.(KSEC1(13).GT.23) ) THEN
        IF( KSEC1(10).NE.255 ) THEN
          WRITE(GRPRSM,9011) KSEC1(13)
          KRET = 1
        ENDIF
      ENDIF
C
C*    Minute check.
C
      IF( (KSEC1(14).LT.0).OR.(KSEC1(14).GT.59) ) THEN
        IF( KSEC1(10).NE.255 ) THEN
          WRITE(GRPRSM,9012) KSEC1(14)
          KRET = 1
        ENDIF
      ENDIF
C
C*    Indicator of unit of time check. Code Table 4.
C
      DO LOOP = 1, JP4
        IF( KSEC1(15).EQ.ITAB4(LOOP) ) GOTO 245
      ENDDO
C
      WRITE(GRPRSM,9013) KSEC1(15)
      KRET = 1
C
  245 CONTINUE
C
C*    Time range indicator check. Code Table 5.
C
      DO LOOP = 1, JP5
        IF( KSEC1(18).EQ.ITAB5(LOOP) ) GOTO 255
      ENDDO
C
      WRITE(GRPRSM,9019) KSEC1(18)
      KRET = 1
C
  255 CONTINUE
C
C*    Cross check Time range indicator and Number averaged or
C     accumulated.
C
      IAC = 0
      DO LOOP = 1, JPAVAC
        IF( KSEC1(18).EQ.IAVAC(LOOP) ) IAC = 1
      ENDDO
C
C     If average or accumulation, check for valid numbers
C     of included and missing values.
C
      IF( IAC.EQ.1. ) THEN
        IF( KSEC1(19).LT.1 ) THEN
          WRITE(GRPRSM,9016) KSEC1(18) , KSEC1(19)
Cjdc      KRET = 1
        ENDIF
        IF( KSEC1(20).LT.0 ) THEN
          WRITE(GRPRSM,9020) KSEC1(18) , KSEC1(20)
Cjdc      KRET = 1
        ENDIF
      ENDIF
C
C*    Century check.
C
C     ECMWF data starts in 20th century.
C commented to allow work Simona
C
cs      IF( (KSEC1(21).LT.20).AND.LECMWF ) THEN
cs        WRITE(GRPRSM,9021) KSEC1(21)
cs        KRET = 1
cs      ENDIF
C
C*    Decimal scale factor check.
C
C     At ECMWF the scale factor is always 0.
C
Cjdc  IF( (KSEC1(23).NE.0).AND.LECMWF ) THEN
Cjdc    WRITE(GRPRSM,9022) KSEC1(23)
Cjdc    KRET = 1
Cjdc  ENDIF
C
C*    Flag field, indicating local ECMWF usage.
C
      IF( (KSEC1(24).NE.0).AND.(KSEC1(24).NE.1) ) THEN
        WRITE(GRPRSM,9025)
        KRET = 1
      ENDIF
C
C     -----------------------------------------------------------------|
C*    Section 3 . Check validity of values for ECMWF local use.
C     -----------------------------------------------------------------|
C
  300 CONTINUE
C
      IF( (KSEC1(24).EQ.1).AND.LECMWF ) THEN
C
C*      Check reserved fields are zero.
C
        DO LOOP = 25, 36
          IF( KSEC1(LOOP).NE.0 ) WRITE(GRPRSM,9026)
        ENDDO
C
C       Check local definition number.
C
        IF( (KSEC1(37).LT.1).OR.(KSEC1(37).GT.254) ) THEN
          KRET = 1
          WRITE(GRPRSM,9101) KSEC1(37)
        ENDIF
C
C       Check Class.
C         1 = operations
C         2 = research
C         3 = ECMWF re-analysis
C         4 = European Climate Support Network (ECSN).
C         5 = ERA 40 (ECMWF 40-year re-analysis)
C         6 = DEMETER
C         7 = PROVOST
C         8 = ELDAS
C         9 = TOST
C        10 = COSMO
C        11 = Ensembles
C        12 = TIGGE
C        14 = ERA Interim
C        15 = SREPS
C        16 = dt (Data Targeting System)
C        17 = la LACE ALADIN
C        18 = yt YOTC
C        19 = MACC
C        99 = ECMWF testing
C
C      1-120 = Member State
C        121 = Generic Member State
C
        IF( (KSEC1(38).LT.1).OR.
     X      ((KSEC1(38).GT.20).AND.
     X       (KSEC1(38).LT.99).OR.(KSEC1(38).GT.121)) ) THEN
          KRET = 1
          WRITE(GRPRSM,9102) KSEC1(38)
        ENDIF
C
C       Check Type.
C
        DO LOOP = 1, JPTYP
          IF( KSEC1(39).EQ.ITYPE(LOOP) ) GOTO 325
        ENDDO
C
        WRITE(GRPRSM,9103 ) KSEC1(39)
        KRET = 1
C
  325   CONTINUE
C
C       Check Stream.
C
         DO LOOP = 1, JPSTR
           IF( KSEC1(40).EQ.ISTRE(LOOP) ) GOTO 335
         ENDDO
C
         WRITE(GRPRSM,9104) KSEC1(40)
         KRET = 1
C
  335    CONTINUE
C
C        No check on the ASCII Version Number.
C
C
C        Check ECMWF local definition 1.
C        (MARS labelling or ensemble forecast data)
C
         IF( KSEC1(37).EQ.1 ) THEN
C
C          Check ensemble forecast number and total forecasts number.
C          (ECMWF ensemble seasonal forecasts, stream 1090, uses
C          2-byte ensemble forecast number)
C
           IF( KSEC1(40).NE.1090 ) THEN
C
             IF( (KSEC1(42).LT.0).OR.(KSEC1(42).GT.255) ) THEN
               KRET = 1
               WRITE(GRPRSM,9105) KSEC1(42)
             ENDIF
C
             IF( (KSEC1(43).LT.0).OR.(KSEC1(43).GT.255) ) THEN
               KRET = 1
               WRITE(GRPRSM,9106) KSEC1(43)
             ENDIF
C
           ELSE
C
             IF( (KSEC1(42).LT.0).OR.(KSEC1(42).GT.65535) ) THEN
               KRET = 1
               WRITE(GRPRSM,9105) KSEC1(42)
             ENDIF
C
           ENDIF
C
         ENDIF
C
C        Check ECMWF local definition 2.
C        (Cluster means and standard deviations)
C
         IF( KSEC1(37).EQ.2 ) THEN
C
C          Check cluster number.
C
           IF( (KSEC1(42).LT.1).OR.(KSEC1(42).GT.255) ) THEN
             KRET = 1
             WRITE(GRPRSM,9107)
           ENDIF
C
C          Check total number of clusters.
C
           IF( (KSEC1(43).LT.1).OR.(KSEC1(43).GT.255) ) THEN
             KRET = 1
             WRITE(GRPRSM,9108)
           ENDIF
C
C          Check clustering method.
C
           IF( (KSEC1(44).LT.1).OR.(KSEC1(44).GT.3) ) THEN
             KRET = 1
             WRITE(GRPRSM,9109)
           ENDIF
C
         ENDIF
C
C        Check ECMWF local definition 6.
C        (Surface temperatures)
C
         IF( KSEC1(37).EQ.6 ) THEN
C
C          Check type for SST field.
C
           IF( (KSEC1(45).LT.0).OR.(KSEC1(45).GT.2) ) THEN
             KRET = 1
             WRITE(GRPRSM,*)
     X         'GRCHK1: Invalid type for SST field = ',KSEC1(45)
           ENDIF
C
C          Check count of ICE fields used.
C
           IF( KSEC1(46).LT.0 ) THEN
             KRET = 1
             WRITE(GRPRSM,*)
     X         'GRCHK1: Invalid count of ICE fields used = ',KSEC1(46)
           ENDIF
C
         ENDIF
C
       ENDIF
C
C        Check ECMWF local definition 18.
C        (Multi-analysis ensemble data)
C
         IF( KSEC1(37).EQ.18 ) THEN
C
C          Check list of WMO centre identifiers
C
           NUMBER = KSEC1(46)
           IF( NUMBER.LT.0 ) THEN
             KRET = 1
             WRITE(GRPRSM,*)
     X         'GRCHK1: WMO id list count invalid = ',NUMBER
           ENDIF
C
           IF( NUMBER.GT.15 ) THEN
             KRET = 1
             WRITE(GRPRSM,*)
     X         'GRCHK1: WMO id list count greater than 15 = ',NUMBER
           ENDIF
C
         ENDIF
C
C     -----------------------------------------------------------------|
C*    Section 4 . Check validity of values for Washington ensemble
C                 products local usage.
C     -----------------------------------------------------------------|
C
  400 CONTINUE
C
Cjdc  IF( (KSEC1(24).EQ.1).AND.LKWBC ) CALL KWCHK1(KSEC1,KRET)
C
C     -----------------------------------------------------------------|
C*    Section 9 . Return to calling routine. Format statements.
C     -----------------------------------------------------------------|
C
  900 CONTINUE
C
      RETURN
C
 9001 FORMAT (1H ,'GRCHK1: Invalid Parameter Table version number - ',
     C             I5)
 9002 FORMAT (1H ,'GRCHK1: Invalid Identification of Centre - ',I5)
 9003 FORMAT (1H ,'GRCHK1: Invalid Generating Process - ',I5)
 9004 FORMAT (1H ,'GRCHK1: Invalid Grid Definition - ',I5)
 9005 FORMAT (1H ,'GRCHK1: Invalid flag field - ',I5,' decimal.')
 9006 FORMAT (1H ,'GRCHK1: Invalid Indicator of parameter - ',I5)
 9008 FORMAT (1H ,'GRCHK1: Invalid year of century - ',I5)
 9009 FORMAT (1H ,'GRCHK1: Invalid month - ',I5)
 9010 FORMAT (1H ,'GRCHK1: Invalid day - ',I5)
 9011 FORMAT (1H ,'GRCHK1: Invalid hour - ',I5)
 9012 FORMAT (1H ,'GRCHK1: Invalid minute - ',I5)
 9013 FORMAT (1H ,'GRCHK1: Invalid Indicator of unit of time - ',I5)
 9014 FORMAT (1H ,'GRCHK1: Uncatalogued grid and no Section 2.')
 9015 FORMAT (1H ,'GRCHK1: Invalid indicator of type of level - ',I5)
 9016 FORMAT (1H ,'GRCHK1: Inconsistent Time Range Indicator',
     C            ' - ',I5,' and number included in averages - ',I5)
 9019 FORMAT (1H ,'GRCHK1: Invalid Time Range Indicator - ',I5)
 9020 FORMAT (1H ,'GRCHK1: Inconsistent Time Range Indicator',
     C            ' - ',I5,' and number missing from averages - ',I5)
 9021 FORMAT (1H ,'GRCHK1: Invalid century of reference time - ',I5)
 9022 FORMAT (1H ,'GRCHK1: Invalid decimal scale factor - ',I5)
 9023 FORMAT (1H ,'GRCHK1: For level type ',I3,' descriptions are',
     C            'invalid - ',I5,3X,I5)
 9024 FORMAT (1H ,'GRCHK1: ** WARNING ** Parameter number ',I3,' is',
     C            ' not defined in International Table number ',I3,'.')
 9025 FORMAT (1H ,'GRCHK1: Local use flag KSEC1(24) should be',
     C                      ' 0 or 1.')
 9026 FORMAT (1H ,'GRCHK1: Reserved fields KSEC1(25->36) should be 0 ',
     C                      'to avoid problems with future releases.')
C
 9101 FORMAT (1H ,'GRCHK1: Invalid local use definition: ',I8)
C
 9102 FORMAT (1H ,'GRCHK1: Invalid class - ',I5)
C
 9103 FORMAT (1H ,'GRCHK1: Invalid type - ',I5)
C
 9104 FORMAT (1H ,'GRCHK1: Invalid stream - ',I5)
C
 9105 FORMAT (1H ,'GRCHK1: Invalid ensemble forecast number - ',I5)
C
 9106 FORMAT (1H ,'GRCHK1: Invalid total number of forecasts - ',I5)
C
 9107 FORMAT (1H ,'GRCHK1: Invalid cluster number - ',I5)
C
 9108 FORMAT (1H ,'GRCHK1: Invalid total number of clusters - ',I5)
C
 9109 FORMAT (1H ,'GRCHK1: Invalid clustering method - ',I5)
C
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities
C granted to it by virtue of its status as an intergovernmental organisation
C nor does it submit to any jurisdiction.
C

      INTEGER FUNCTION INTUVDH(PDATA,KSIZE,KGRIB,KGRBSZ,HOPER,KPARAM)
C
C---->
C**** INTUVDH
C
C     Purpose
C     -------
C
C     Encodes/decodes data into/from GRIB code.
C
C
C     Interface
C     ---------
C
C     IRET = INTUVDH(PDATA,KSIZE,KGRIB,KGRBSZ,HOPER,KPARAM)
C
C     Input
C     -----
C
C     PDATA - Unpacked field values (if encoding)
C     KSIZE - Number of unpacked values (if encoding)
C     KGRIB  - Input field in GRIB format (if decoding)
C     KGRBSZ - Input field length (words) (if decoding)
C     HOPER  - Coding option ('I', 'D' or 'C' only)
C     KPARAM - Parameter number of the field (for encoding)
C
C
C     Output
C     ------
C
C     PDATA  - Unpacked field values (if decoding)
C     KSIZE  - Number of unpacked values (if decoding)
C     KGRIB  - Output field in GRIB format (if encoding)
C     KGRBSZ - Output field length (words) (if encoding)
C
C
C     Method
C     ------
C
C     Uses arrays in intf.h for unpacking GRIB headers.
C
C
C     Externals
C     ---------
C
C     GRSVCK  - Turns off GRIBEX checking.
C     GRIBEX  - Encode/decode GRIB product.
C     IGSETUP - Setup GRIB sections for the output product.
C
C
C     Author
C     ------
C
C     J.D.Chambers     ECMWF     February 2001
C
C
C----<
C
C     -----------------------------------------------------------------|
C*    Section 0.   Variables
C     -----------------------------------------------------------------|
C
      IMPLICIT NONE
C
#include "parim.h"
#include "intf.h"
#include "nifld.common"
#include "nofld.common"
C
C     Function arguments
C
      REAL PDATA(*)
      INTEGER KSIZE,KGRIB(*),KGRBSZ, KPARAM
      CHARACTER*1 HOPER
C
C     Local variables
C
      INTEGER IERR, IWORD
      CHARACTER*1 HFUNC
C
C     Externals
C
      INTEGER IGSETUP
      EXTERNAL IGSETUP
C
C     -----------------------------------------------------------------|
C*    Section 1.   Initialise.
C     -----------------------------------------------------------------|
C
  100 CONTINUE
      INTUVDH = 0
      IERR    = 0
C
C     -----------------------------------------------------------------|
C*    Section 2.   Decode data from GRIB code (no checking).
C     -----------------------------------------------------------------|
C
  200 CONTINUE
C
      IF( HOPER.NE.'C' ) THEN
        CALL GRSVCK(0)
C
        IERR = 1
        ISEC3(2) = NINT(RMISSGV)
        ZSEC3(2) = RMISSGV
        CALL GRIBEX(ISEC0, ISEC1, ISEC2, ZSEC2, ISEC3, ZSEC3, ISEC4,
     X              PDATA, KSIZE, KGRIB, KGRBSZ, IWORD, HOPER,IERR)
C
        INTUVDH = IERR
        GOTO 900
      ENDIF
C
C     -----------------------------------------------------------------|
C*    Section 3.   Encode data into GRIB code.
C     -----------------------------------------------------------------|
C
  300 CONTINUE
C
C     Setup GRIB sections for the output product
C
      IERR = IGSETUP(ISEC1,ISEC2,ISEC3,ISEC4)
      IF( IERR.NE.0 ) THEN
        CALL INTLOG(JP_ERROR,'INTUVDH: GRIB section setup fail',JPQUIET)
        INTUVDH = IERR
        GOTO 900
      ENDIF
C
C     Code data into GRIB
C
      ISEC1(6) = KPARAM
      IERR = 1
C
C     If grid-point output, setup for 2nd order packing if requested.
C
      IF( (NOREPR.NE.JPSPHERE) .AND. (NOREPR.NE.JPSPHROT) ) THEN
        HFUNC = 'C'
        IF( NOHFUNC.EQ.'K' ) THEN
          HFUNC = 'K'
          ISEC4(4)  = 64
          ISEC4(6)  = 16
          ISEC4(9)  = 32
          ISEC4(10) = 16
          ISEC4(12) = 8
          ISEC4(13) = 4
          ISEC4(14) = 0
          ISEC4(15) = -1
        ELSE
          ISEC4(4)  = 0
          ISEC4(6)  = 0
        ENDIF
        IF( LIMISSV ) THEN
          ISEC1(5) = 192
          ISEC3(2) = NINT(RMISSGV)
          ZSEC3(2) = RMISSGV
        ENDIF
      ELSE
        ISEC1(5) = 128
        HFUNC = 'C'
        IF( NOHFUNC.EQ.'C' ) THEN
          ISEC2(6) = 2
          ISEC4(4) = 64
        ELSE IF( NOHFUNC.EQ.'S' ) THEN
          ISEC2(6) = 1
          ISEC4(4) = 0
        ENDIF
      ENDIF
C
      CALL GRIBEX( ISEC0, ISEC1, ISEC2, ZSEC2, ISEC3, ZSEC3, ISEC4,
     X             PDATA,KSIZE,KGRIB,KGRBSZ,IWORD,HFUNC,IERR)
      IF( IERR.NE.0 ) THEN
        CALL INTLOG(JP_ERROR,'INTUVDH: GRIBEX encoding failed.',IERR)
        INTUVDH = IERR
        GOTO 900
      ENDIF
      KGRBSZ = IWORD
      INTUVDH = 0
C
C     -----------------------------------------------------------------|
C*    Section 9.   Return
C     -----------------------------------------------------------------|
C
  900 CONTINUE
C
      RETURN
      END

C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE FFT99(A,WORK,TRIGS,IFAX,INC,JUMP,N,LOT,ISIGN)
C
C---->
C**** FFT99
C
C     PURPOSE
C     _______
C
C     Multiple fast real periodic transform.
C
C
C     INTERFACE
C     _________
C
C     CALL FFT99(A,WORK,TRIGS,IFAX,INC,JUMP,N,LOT,ISIGN)
C
C
C     Input parameters
C     ________________
C
C     A      - the array containing input data
C     WORK   - an area of size (N+1)*MIN(LOT,64)
C     TRIGS  - a previously prepared list of trig function values
C     IFAX   - a previously prepared list of factors of N
C     INC    - the increment within each data 'vector'
C              (e.g. INC=1 for consecutively stored data)
C     JUMP   - the increment between the start of each data vector
C     N      - the length of the data vectors
C     LOT    - the number of data vectors
C     ISIGN  -  +1 for transform from spectral to gridpoint
C            -  -1 for transform from gridpoint to spectral
C
C     Output parameters
C     ________________
C
C     A      - the array containing output data
C
C
C     Method
C     ______
C     
C     Ordering of coefficients:
C         A(0),B(0),A(1),B(1),A(2),B(2),...,A(N/2),B(N/2)
C         where B(0) = B(N/2)=0; (N+2) locations required
C
C     Ordering of data:
C         X(N-1),X(0),X(1),X(2),...,X(N-1),X(0)
C         i.e. explicit cyclic continuity; (N+2) locations required
C
C     Vectorization is achieved by doing the transforms in parallel
C
C     N must be composed of factors 2,3 & 5 but does not have to be even
C
C     
C     Real transform of length N performed by removing redundant
C     operations from complex transform of length N
C     Definition of transforms:
C
C     ISIGN = +1:
C         X(J) = SUM(K=0,...,N-1)(C(K)*EXP(2*I*J*K*PI/N))
C         where C(K) = A(K)+I*B(K) and C(N-K) = A(K)-I*B(K)
C
C     ISIGN = -1:
C         A(K) = (1/N)*SUM(J=0,...,N-1)(X(J)*COS(2*J*K*PI/N))
C         B(K) = -(1/N)*SUM(J=0,...,N-1)(X(J)*SIN(2*J*K*PI/N))
C
C     Externals
C     _________
C
C     RPASSM  - Performs one pass through data as part of multiple real
C               FFT (fourier analysis) routine.
C     QPASSM  - Performs one pass through data as part of multiple real
C               FFT (fourier synthesis) routine.
C
C
C     Reference
C     _________
C
C     None.
C
C
C     Comments
C     ________
C
C     Tidy up of code in older version of same routine.
C
C
C     AUTHOR
C     ______
C
C     J.D.Chambers      *ECMWF*      Nov 1996
C
C
C     MODIFICATIONS
C     _____________
C
C     None.
C
C----<
C     _______________________________________________________
C
C*    Section 0. Definition of variables.
C     _______________________________________________________
C
      IMPLICIT NONE
C
C     Subroutine arguments
      REAL A, WORK, TRIGS
      INTEGER IFAX, INC, JUMP, N, LOT, ISIGN
      DIMENSION A(N),WORK(N),TRIGS(N),IFAX(10)
C
C     Local variables
      INTEGER NFAX, NX, NBLOX, NVEX, ISTART, NB, IA, I, J
      INTEGER LA, IGO, K, IFAC, IERR, IBASE, JBASE, JJ, II
      INTEGER IX, IZ
C
C ------------------------------------------------------------------
C     Section 1.   Initialise
C ------------------------------------------------------------------
C
  100 CONTINUE
C
C     Ensure factorization of N has been done.
      IF(IFAX(10).NE.N) CALL SET99(TRIGS,IFAX,N)
C
      NFAX = IFAX(1)
      IF (MOD(N,2).EQ.1) THEN
        NX = N
      ELSE
        NX = N + 1
      ENDIF
C
C     Calculate number of blocks of 64 vectors and number of vectors
C     'left over'. This remainder is transformed first.
C
      NBLOX = 1 + (LOT-1)/64
      NVEX  = LOT-(NBLOX-1)*64
C
      IF (ISIGN.EQ.1) THEN
C
C ------------------------------------------------------------------
C     Section 2.   Spectral to gridpoint transform.
C ------------------------------------------------------------------
C
  200   CONTINUE
C
C       Loop through the blocks of vectors
        ISTART = 1
        DO 270 NB = 1,NBLOX
          IA = ISTART
          I  = ISTART
          DO 210 J = 1,NVEX
            A(I+INC) = 0.5*A(I)
            I        = I + JUMP
  210     CONTINUE
C
          IF (MOD(N,2).NE.1) THEN
            I = ISTART + N*INC
            DO 220 J = 1,NVEX
              A(I) = 0.5*A(I)
              I    = I + JUMP
  220       CONTINUE
          ENDIF
C
          IA  = ISTART + INC
          LA  = 1
          IGO = 1
C
C         Work through the factors
          DO 230 K = 1,NFAX
            IFAC = IFAX(K+1)
            IERR = -1
            IF (IGO.NE.-1) THEN
              CALL RPASSM(A(IA),A(IA+LA*INC),WORK(1),WORK(IFAC*LA+1),
     X          TRIGS,INC,1,JUMP,NX,NVEX,N,IFAC,LA,IERR)
            ELSE
              CALL RPASSM(WORK(1),WORK(LA+1),A(IA),A(IA+IFAC*LA*INC),
     X          TRIGS,1,INC,NX,JUMP,NVEX,N,IFAC,LA,IERR)
            ENDIF
C
            IF (IERR.NE.0) GO TO 950
C
            LA  = IFAC*LA
            IGO = -IGO
            IA  = ISTART + INC
  230     CONTINUE
C
C         If necessary, copy results back to A
C         
          IF (MOD(NFAX,2).NE.0) THEN
            IBASE = 1
            JBASE = IA
            DO 250 JJ = 1,NVEX
              I = IBASE
              J = JBASE
              DO 240 II = 1,N
                A(J) = WORK(I)
                I    = I + 1
                J    = J + INC
  240         CONTINUE
              IBASE = IBASE + NX
              JBASE = JBASE + JUMP
  250       CONTINUE
          ENDIF
C
C         Fill in cyclic boundary values (ie repeat the data vector
C         end points at opposite end of the vector)
C         
          IX = ISTART
          IZ = ISTART + N*INC
CDIR$ IVDEP
          DO 260 J = 1,NVEX
            A(IX)     = A(IZ)
            A(IZ+INC) = A(IX+INC)
            IX        = IX + JUMP
            IZ        = IZ + JUMP
  260     CONTINUE
C
C         Adjust pointers for next block
          ISTART = ISTART + NVEX*JUMP
          NVEX   = 64
  270   CONTINUE
C
      ELSE
C
C ------------------------------------------------------------------
C     Section 3.   Gridpoint to spectral transform.
C ------------------------------------------------------------------
C
  300   CONTINUE
C
C       Loop through the blocks of vectors
        ISTART = 1
        DO 390 NB  =  1,NBLOX
          IA  = ISTART + INC
          LA  = N
          IGO = 1
C
          DO 310 K = 1,NFAX
            IFAC = IFAX(NFAX+2-K)
            LA   = LA/IFAC
            IERR = -1
            IF (IGO.NE.-1) THEN
              CALL QPASSM(A(IA),A(IA+IFAC*LA*INC),WORK(1),WORK(LA+1),
     X          TRIGS,INC,1,JUMP,NX,NVEX,N,IFAC,LA,IERR)
            ELSE
              CALL QPASSM(WORK(1),WORK(IFAC*LA+1),A(IA),A(IA+LA*INC),
     X          TRIGS,1,INC,NX,JUMP,NVEX,N,IFAC,LA,IERR)
            ENDIF
            IF (IERR.NE.0) GO TO 950
            IGO = -IGO
            IA  = ISTART + INC
  310     CONTINUE
C
C         If necessary, copy results back to A
C         
          IF (MOD(NFAX,2).NE.0) THEN
            IBASE = 1
            JBASE = IA
            DO 330 JJ = 1,NVEX
              I = IBASE
              J = JBASE
              DO 320 II = 1,N
                A(J) = WORK(I)
                I    = I + 1
                J    = J + INC
  320         CONTINUE
              IBASE = IBASE + NX
              JBASE = JBASE + JUMP
  330       CONTINUE
          ENDIF
C
C         Shift A(0) and fill in zero imaginary parts
C         
          IX = ISTART
          DO 340 J = 1,NVEX
            A(IX)     = A(IX+INC)
            A(IX+INC) = 0.0
            IX        = IX + JUMP
  340     CONTINUE
C
          IF (MOD(N,2).NE.1) THEN
            IZ = ISTART + (N+1)*INC
            DO 350 J = 1,NVEX
              A(IZ) = 0.0
              IZ    = IZ + JUMP
  350       CONTINUE
C
          ENDIF
C
C         Adjust pointers for next block
          ISTART = ISTART + NVEX*JUMP
          NVEX   = 64
  390   CONTINUE
C
      ENDIF
C
C ------------------------------------------------------------------
C     Section 9.   Closedown.
C ------------------------------------------------------------------
C
  900   CONTINUE
C
      RETURN
C
C     Error messages
C     
  950 CONTINUE
      GO TO (960,970,980) IERR
C
  960 CONTINUE
      WRITE(*,*) 'Vector length greater than 64, = ', NVEX
      GO TO 900
  970 CONTINUE
      WRITE(*,*) 'Factor not handled, =', IFAC
      GO TO 900
  980 CONTINUE
      WRITE(*,*) 'Factor only handled if LA*IFAC=N. Factor = ', IFAC
C
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities
C granted to it by virtue of its status as an intergovernmental organisation
C nor does it submit to any jurisdiction.
C


      SUBROUTINE GRCHK3 (KSEC1,KSEC3,PSEC3,KRET)
C
C---->
C**** GRCHK3 - Check parameters for Section 3 of GRIB Code.
C
C     Purpose.
C     --------
C
C           Check parameters for Section 3 of GRIB code against
C           valid values for GRIB Edition 1.
C
C**   Interface.
C     ----------
C
C           CALL GRCHK3 (KSEC1,KSEC3,PSEC3,KRET)
C
C           Integer    K.
C           Real       P.
C           Logical    O.
C           Character  H.
C
C               Input Parameters.
C               -----------------
C
C               KSEC1      - Array containing integer parameters for
C                            section 1 of GRIB code.
C
C               KSEC3      - Array containing integer parameters for
C                            section 3 of GRIB code.
C
C               PSEC3      - Array containing real parameters for
C                            section 3 of GRIB code.
C
C               Output Parameters.
C               ------------------
C
C               KRET       - Return code.
C                            0   , No error encountered.
C                            1   , Error in GRIB Code parameter.
C
C     Method.
C     -------
C
C           Values checked against current code/flag tables
C           and against maximum or minimum permitted values.
C           They are also checked against the current status
C           of the implementation of GRIBEX and ECMWF usage.
C
C     Externals.
C     ----------
C
C           None.
C
C     Reference.
C     ----------
C
C           WMO Manual on Codes for GRIB Code.
C
C     Comments.
C     ---------
C
C           Routine contains Sections 0 to 5 and Section 9.
C
C     Author.
C     -------
C
C           J. Hennessy      ECMWF      16.09.91
C
C     Modifications.
C     --------------
C
C           J. Hennessy      ECMWF      01.10.91
C           Additional parameter KSEC1 and PSEC3 added.
C
C     ----------------------------------------------------------------
C----<
C
C
C
C
C
C
C
C
C
C
C*    Section 0 . Definition of variables. Data statements.
C     ----------------------------------------------------------------
C
C*    Prefix conventions for variable names.
C
C     Logical      L (but not LP), global or common.
C                  O, dummy arguments.
C                  G, local variable.
C                  LP, parameter.
C     Character    C, Global or common.
C                  H, dummy arguments.
C                  Y (but not YP), local variables.
C                  YP, parameter.
C     Integer      M and N, global or common.
C                  K, dummy arguments.
C                  I, local variables.
C                  J (but not JP), loop control.
C                  JP, parameter.
C     Real         A to F and Q to X, global or common.
C                  P (but not PP), dummy arguments.
C                  Z, local variables.
C                  PP, parameter.
C

      IMPLICIT NONE
C
#include "common/grprs.h"
C
      INTEGER KRET
      INTEGER KSEC1
      INTEGER KSEC3
C
      REAL    PSEC3
C
      DIMENSION KSEC1(*)
      DIMENSION KSEC3(*)
C
      DIMENSION PSEC3(*)
C
C     ----------------------------------------------------------------
C
C
C
C
C
C
C
C
C
C
C*    Section 1 . Set initial values.
C     ----------------------------------------------------------------
C
  100 CONTINUE
C
C     Reset return code.
C
      KRET = 0
C
C     ----------------------------------------------------------------
C
C
C
C
C
C
C
C
C
C
C*    Section 2 . Check values.
C     ----------------------------------------------------------------
C
  200 CONTINUE
C
C*    Check bit-map table reference field.
C
      IF (KSEC3(1).LT.0.OR.KSEC3(1).GT.65535)
     C   THEN
             KRET = 1
             WRITE(GRPRSM,9001) KSEC3(1)
         ENDIF
C
C     ----------------------------------------------------------------
C
C
C
C
C
C
C
C
C
C
C
C*    Section 9 . Return to calling routine. Format statements.
C     ----------------------------------------------------------------
C
  900 CONTINUE
C
 9001 FORMAT (1H ,'GRCHK3 : Invalid bit-map table reference - ',I9)
C
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C


      SUBROUTINE DECOPS (NAME,CHDATA,ILENCH,FPDATA,ILENFP,INDATA,ILENIN,
     C                   NBYTE,LGDATA,ILENLG,IB1PAR,IPSCOD,ILENPS,
     C                   JLENCH,JLENFP,JLENIN,JLENLG,IRSERV,NBIT,IWORD,
     C                   IERR )
C
C---->
C*
C*     NAME     : DECOPS
C*
C*     FUNCTION : DECODE PSEUDO-GRIB CODED DATA.
C*
C*     INPUT    : NBIT     - NUMBER OF BITS IN COMPUTER WORD
C*
C*                IPSCOD   - INTEGER ARRAY OF DATA IN PSEUDO-GRIB CODE.
C*                ILENPS   - LENGTH OF ARRAY IPSCOD.
C*
C*                CHDATA   - CHARACTER VARIABLE TO RECEIVE DECODED
C*                           CHARACTER DATA.
C*                ILENCH   - LENGTH OF THIS VARIABLE
C*
C*                FPDATA   - REAL ARRAY TO RECEIVE DECODED F.P. VALUES.
C*                ILENFP   - LENGTH OF THIS ARRAY.
C*
C*                INDATA   - INTEGER ARRAY TO RECEIVE DECODED INTEGERS
C*                ILENIN   - LENGTH OF THIS ARRAY.
C*
C*                LGDATA   - LOGICAL ARRAY TO RECEIVE DECODED LOGICALS
C*                ILENLG   - LENGTH OF THIS ARRAY.
C*
C*                          IF ANY LENGTH (ILENCH,-FP,-IN,-LG) IS SET
C*                          TO 1, ONLY BLOCK 0 AND BLOCK 1 ARE DECODED.
C*
C*                IB1PAR  - INTEGER ARRAY (DIMENSION 18) TO RECEIVE
C*                          DATA DEFINITION INFORMATION.
C*
C*
C*     OUTPUT   : PARAMETER FROM BLOCK 0
C*                ----------------------
C*
C*                NAME    - CHARACTER VARIABLE, 4 LETTERS OF CODE NAME.
C*
C*
C*                PARAMETERS FROM BLOCK 1 , PRODUCT DEFINITION BLOCK.
C*                --------------------------------------------------
C*
C*                IB1PAR  - INTEGER ARRAY (DIMENSION 18) OF DATA
C*                          DEFINITION INFORMATION.
C*
C*                WORD      CONTENTS
C*                ----      --------
C*                  1       ORIGINATING CENTRE IDENTIFIER.
C*                  2       MODEL IDENTIFICATION.
C*                  3       GRID DEFINITION.
C*                  4       FLAG ( CODE TABLE 1)
C*                  5       PARAMETER IDENTIFIER ( CODE TABLE 2 ).
C*                  6       TYPE OF LEVEL (CODE TABLE 3).
C*                 7-8      VALUE(S) OF LEVELS (CODE TABLE 3).
C*                  9       YEAR OF DATA
C*                 10       MONTH OF DATA
C*                 11       DAY OF DATA
C*                 12       HOUR OF DATA
C*                 13       MINUTE OF DATA
C*                 14       TIME UNIT (CODE TABLE 4).
C*                 15       TIME RANGE ONE
C*                 16       TIME RANGE TWO
C*                 17       TIME RANGE FLAG (CODE TABLE 5).
C*                 18       NUMBER AVERAGED.
C*
C*                          VALUE(S) OF LEVEL CAN OCCUPY 2 WORDS..
C*                          FOR A LAYER THE FIRST WORD DEFINES THE TOP
C*                          AND THE SECOND THE BOTTOM OF THE LAYER.
C*                          FOR A SINGLE LEVEL, ONLY THE FIRST WORD IS
C*                          USED.
C*
C*
C*
C*                PARAMETERS FROM BLOCK 4 , BINARY DATA BLOCK.
C*                -------------------------------------------
C*
C*                CHDATA   - UNPACKED CHARACTER DATA
C*                JLENCH   - NUMBER OF CHARACTERS. NEGATIVE IF
C*                           MISSING DATA CODED.
C*
C*                FPDATA  - ARRAY OF FLOATING POINT VALUES.
C*                JLENFP  - NUMBER OF VALUES IN THIS ARRAY.
C*                          JLENFP IS NEGATIVE IF MISSING DATA CODED
C*
C*                INDATA  - ARRAY OF INTEGER VALUES.
C*                JLENIN  - NUMBER OF VALUES IN THIS ARRAY.
C*                          JLENIN IS NEGATIVE IF MISSING DATA CODED
C*
C*                LGDATA  - ARRAY OF LOGICAL VALUES.
C*                JLENLG  - NUMBER OF VALUES IN THIS ARRAY.
C*                          JLENLG IS NEGATIVE IF MISSING DATA CODED
C*
C*                NBYTE   - NUMBER OF BYTES FOR INTEGER VALUES.
C*
C*                IRSERV  - NUMBER OF BYTES IN DATA BLOCK RESERVED
C*                          FOR FUTURE USE.
C*
C*
C*                OTHER PARAMETERS.
C*                ----------------
C*
C*                IWORD   - NUMBER OF WORDS DECODED.
C*
C*                IERR    - ERROR INDICATOR.
C*
C*                          0, NO ERROR.
C*
C*                         -2, INPUT ARRAY HOLDS FEWER CODED VALUES
C*                             THAN EXPECTED.
C*                         -3, OUTPUT ARRAY/VARIABLE TOO SMALL TO HOLD
C*                             DECODED DATA VALUES.
C*                         -4, CURRENTLY UNDEFINED OPTION SELECTED.
C*
C*                          1, NO BLOCK 5 FOUND.
C*
C*    GENERAL  : DECOPS CALLS GBYTE
C*                            GBYTES
C*                            OFFSET
C*                            DECFP
C*
C*    AUTHOR   : J.HENNESSY  23.01.86
C*
C*    MODIFIED : J.HENNESSY  06.06.86
C*                    "      21.08.86
C*
C*               J.Hennessy  17.09.90
C*               Lower case letters as well as the characters
C*               _ - . , added.
C*
C     ---------------------------------------------------------------
C---->
C
C
      PARAMETER (NCHAR=67)
C
C
      LOGICAL     LGDATA
      CHARACTER*4 NAME
      CHARACTER*1 CHAR
      CHARACTER*(*) CHDATA
C
C
C
      DIMENSION FPDATA(*),INDATA(*),LGDATA(*)
      DIMENSION IPSCOD(ILENPS),IBLOCK(24),IB1PAR(18)
      DIMENSION IASCII(NCHAR)
      DIMENSION CHAR(NCHAR)
C
C
      DATA IASCII /65 ,66 ,67 ,68 ,69 ,70 ,71 ,72 ,73 ,74 ,75 ,76 ,77 ,
     C             78 ,79 ,80 ,81 ,82 ,83 ,84 ,85 ,86 ,87 ,88 ,89 ,90 ,
     C             48 ,49 ,50 ,51 ,52 ,53 ,54 ,55 ,56 ,57 ,32 ,
     C             97 ,98 ,99 ,100,101,102,103,104,105,106,107,108,109,
     C             110,111,112,113,114,115,116,117,118,119,120,121,122,
     C             95 ,46 ,44 , 45  /
C
      DATA CHAR   /'A','B','C','D','E','F','G','H','I','J','K','L','M',
     C             'N','O','P','Q','R','S','T','U','V','W','X','Y','Z',
     C             '0','1','2','3','4','5','6','7','8','9',' ',
     C             'a','b','c','d','e','f','g','h','i','j','k','l','m',
     C             'n','o','p','q','r','s','t','u','v','w','x','y','z',
     C              '_','.',',','-' /
C
C
C
C
C
C
      IERR = 0
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C********************************************************************
C*
C*    BLOCK 0 - INDICATOR BLOCK.
C*
C********************************************************************
C
C
C     EXTRACT 4 OCTETS CONTAINING ASCII NAME.
C
      IWORD = 1
      IOFF  = 0
      IBYTE = 8
      NVAL  = 4
C
      CALL GBYTES (IPSCOD(1),IBLOCK(1),0,IBYTE,0,NVAL)
      CALL OFFSET (IOFF,NVAL,IWORD,IBYTE,NBIT,ILENPS,IERR)
      IF (IERR.NE.0) RETURN
C
      DO 100 I=1,36
         IF (IBLOCK(1).EQ.IASCII(I)) NAME(1:1) = CHAR(I)
         IF (IBLOCK(2).EQ.IASCII(I)) NAME(2:2) = CHAR(I)
         IF (IBLOCK(3).EQ.IASCII(I)) NAME(3:3) = CHAR(I)
         IF (IBLOCK(4).EQ.IASCII(I)) NAME(4:4) = CHAR(I)
  100 CONTINUE
C
C
C
C
C
C
C********************************************************************
C*
C*    BLOCK 1 - PRODUCT DEFINITION BLOCK.
C*
C********************************************************************
C
C
C     EXTRACT FIRST 4 OCTETS OF BLOCK 1.
C
      NVAL  = 4
C
      CALL GBYTES (IPSCOD(IWORD),IBLOCK(1),IOFF,IBYTE,0,NVAL)
      CALL OFFSET (IOFF,NVAL,IWORD,IBYTE,NBIT,ILENPS,IERR)
      IF (IERR.NE.0) RETURN
C
C     IF THESE OCTETS DO NOT CONTAIN 0, 0, 24 AND 0 RESPECTIVELY
C     THEN THE DATA IS IN THE OLD VERSION OF THE CODE.
C
      IF (IBLOCK(1).EQ.0.AND.IBLOCK(2).EQ.0.AND.IBLOCK(3).EQ.24.
     C    AND.IBLOCK(4).EQ.0)
     C      THEN
                ISNEW = 1
                NVAL = 20
            ELSE
                ISNEW = 0
                NVAL = 16
            ENDIF
C
C     EXTRACT NEXT 16 OR 20 OCTETS OF BLOCK 1 - NUMBER DEPENDS
C     ON VERSION OF CODE.
C
      CALL GBYTES (IPSCOD(IWORD),IBLOCK(5),IOFF,IBYTE,0,NVAL)
      CALL OFFSET (IOFF,NVAL,IWORD,IBYTE,NBIT,ILENPS,IERR)
      IF (IERR.NE.0) RETURN
C
C     TRANSFER PRODUCT DEFINITION INFORMATION TO OUTPUT ARRAY.
C     EXCEPT FOR NUMBER AVERAGED.
C
      DO 200 I=1,17
         IB1PAR(I) = IBLOCK(I+4*ISNEW)
  200 CONTINUE
C
C
      WRITE(*,*) ' '
      WRITE(*,*) '     ******************************************'
      WRITE(*,*) '     ******************************************'
      WRITE(*,*) '     **                                      **'      
      WRITE(*,*) '     ** DECOPS is not Year-2000 compliant;   **'
      WRITE(*,*) '     ** dates are returned as 2 digits.      **'
      WRITE(*,*) '     **                                      **'
      WRITE(*,*) '     ** Please switch to using DECOPS2 which **'
      WRITE(*,*) '     ** returns dates as 4 digits in the     **'
      WRITE(*,*) '     ** range 1900 upwards.                  **'
      WRITE(*,*) '     **                                      **'
      WRITE(*,*) '     ** DECOPS will be set to abort after    **'
      WRITE(*,*) '     ** January 1999.                        **'
      WRITE(*,*) '     **                                      **'
      WRITE(*,*) '     ******************************************'
      WRITE(*,*) '     ******************************************'
      WRITE(*,*) ' '
C
C
C     NUMBER AVERAGED OCCUPIES 2 OCTETS.
C
      IB1PAR(18) = IBLOCK(18+4*ISNEW) * 256 + IBLOCK(19+4*ISNEW)
C
C
C
C
C
C***
C*    DESCRIPTION OF LEVEL OR LAYER ( CODE TABLE 3 ).
C***
C
C     CERTAIN LEVEL TYPES REQUIRE THAT THE DESCRIPTION OCCUPY
C     BOTH 8 BIT FIELDS. PUT SINGLE VALUE IN FIRST LEVEL WORD.
C
      KTEMP = 32 + (ISNEW*224)
      IF ((IB1PAR(6).EQ. 20).OR.
     X    (IB1PAR(6).EQ.100).OR.
     X    (IB1PAR(6).EQ.103).OR.
     X    (IB1PAR(6).EQ.105).OR.
     X    (IB1PAR(6).EQ.107).OR.
     X    (IB1PAR(6).EQ.109).OR.
     X    (IB1PAR(6).EQ.111).OR.
     X    (IB1PAR(6).EQ.113).OR.
     X    (IB1PAR(6).EQ.115).OR.
     X    (IB1PAR(6).EQ.117).OR.
     X    (IB1PAR(6).EQ.125).OR.
     X    (IB1PAR(6).EQ.160) ) THEN
              IB1PAR(7) = IB1PAR(7) * KTEMP + IB1PAR(8)
              IB1PAR(8) = 0
          ENDIF
C
C
C
C
C
C
C
C
C
C***
C*    TIME RANGE.
C***
C
C     ONE TIME RANGE CAN OCCUPY TWO OCTETS.
C
      IF (IB1PAR(17).EQ.10)
     C   THEN
             IB1PAR(15) = IB1PAR(15) * KTEMP + IB1PAR(16)
             IB1PAR(16) = 0
         ENDIF
C
C
C
C
C
C
C
C
C
C***
C*    CHECK IF DECODING OF ONLY BLOCKS 0 AND 1 HAS BEEN REQUESTED.
C***
C
      IF (ILENFP.EQ.1.OR.ILENIN.EQ.1.OR.ILENLG.EQ.1) RETURN
      IF (ILENCH.EQ.1) RETURN
C
C
C
C
C
C
C
C
C
C
C********************************************************************
C*
C*    BLOCK 4 - BINARY DATA BLOCK.
C*
C********************************************************************
C
C
C
C***
C*    GET LENGTH OF BINARY DATA BLOCK.
C***
C
C
      IPW = IWORD
      IPB = IOFF
C
      CALL GBYTE (IPSCOD(IWORD),LBIN,IOFF,24)
      CALL OFFSET (IOFF,1,IWORD,24,NBIT,ILENPS,IERR)
      IF (IERR.NE.0) RETURN
C
C
C
C
C
C
C
C***
C*    OCTET 4 IS RESERVED.
C*    (IT IS USED IN OLDER VERSIONS OF BUDGET VALUE RECORDS AND
C*    IT GIVES THE STARTING OCTET ADDRESS OF LOGICAL VALUES, A
C*    FIXED VALUE OF 34 OR 38)
C***
C
      CALL GBYTE (IPSCOD(IWORD),ISTLG,IOFF,8)
      IOLDBV = 0
      IF (ISTLG.EQ.34.OR.ISTLG.EQ.38) IOLDBV = 1
C
C
      CALL OFFSET (IOFF,1,IWORD,8,NBIT,ILENPS,IERR)
      IF (IERR.NE.0) RETURN
C
C
C
C
C
C
C
C
C***
C*    OCTET 5 - MISSING DATA FLAG. (IN OLDER VERSIONS OF BUDGET VALUE
C*    RECORD IT GIVES STARTING OCTET ADDRESS OF INTEGER VALUES)
C***
C
      CALL GBYTE (IPSCOD(IWORD),IMISS,IOFF,8)
      CALL OFFSET (IOFF,1,IWORD,8,NBIT,ILENPS,IERR)
      IF (IERR.NE.0) RETURN
C
      IF (IOLDBV.EQ.1)
     C   THEN
             ISTIN = IMISS
             IMISS = 0
         ENDIF
C
C
C
C
C
C
C
C***
C*    OCTETS 6-7 IN OLDER VERSIONS OF BUDGET VALUE RECORDS GIVE
C*    STARTING BYTE ADDRESS OF FLOATING POINT VALUES SECTION.
C*    OCTETS 8-9 GIVING THE LENGTH OF THE FLOATING POINT DATA
C*    SECTION IN OCTETS.
C***
C
      IF (IOLDBV.EQ.1)
     C   THEN
             CALL GBYTE (IPSCOD(IWORD),ISTFP,IOFF,16)
             CALL OFFSET (IOFF,1,IWORD,16,NBIT,ILENPS,IERR)
             IF (IERR.NE.0) RETURN
C
             CALL GBYTE (IPSCOD(IWORD),LENFP,IOFF,16)
             CALL OFFSET (IOFF,1,IWORD,16,NBIT,ILENPS,IERR)
             IF (IERR.NE.0) RETURN
C
C            NUMBER OF FLOATING POINT VALUES.
C            4 BYTES PER FLOATING POINT NUMBER.
C
             JLENFP = LENFP / 4
C
C            NUMBER OF LOGICAL VALUES.
C
             JLENLG = ISTIN - ISTLG
C
C            NUMBER OF INTEGER VALUES.
C            2 OCTETS PER INTEGER.
C
             NBYTE = 2
             IBITS = NBYTE * 8
             JLENIN = ( ISTFP - ISTIN ) / NBYTE
C
C            NO CHARACTER DATA IN OLD FORMAT.
C
             JLENCH = 0
C
C            CHECK NUMBERS OF DATA ITEMS AGAINST DIMENSIONS
C            OF TARGET ARRAYS.
C
             IF (JLENFP.GT.ILENFP)
     C          THEN
                    IERR = -3
                    WRITE (*,9001) JLENFP
                ENDIF
C
             IF (JLENLG.GT.ILENLG)
     C          THEN
                    IERR = -3
                    WRITE (*,9002) JLENLG
                ENDIF
C
             IF (JLENIN.GT.ILENIN)
     C          THEN
                    IERR = -3
                    WRITE (*,9003) JLENIN
                ENDIF
C
             IF (IERR.NE.0) RETURN
C
C            NOW WE GO AROUND THE HOUSES AS THIS OLD DATA
C            HAS THE DIFFERENT DATA TYPES STORED IN A DIFFERENT
C            ORDER.
C
C            LOGICAL VARIABLES FIRST.
C
             GO TO 450
C
         ENDIF
C
C
C
C
C
C
C***
C*    OCTET 6 - NUMBER OF BYTES PER INTEGER.
C***
C
      CALL GBYTE (IPSCOD(IWORD),NBYTE,IOFF,8)
      CALL OFFSET (IOFF,1,IWORD,8,NBIT,ILENPS,IERR)
      IF (IERR.NE.0) RETURN
C
      IBITS = NBYTE * 8
C
C
C
C
C
C
C
C***
C*    OCTETS 7-8 ARE RESERVED.
C***
C
      CALL OFFSET (IOFF,2,IWORD,8,NBIT,ILENPS,IERR)
      IF (IERR.NE.0) RETURN
C
C
C
C
C
C
C
C***
C*    OCTETS 9-11 - NUMBER OF CHARACTERS IN CHARACTER SECTION.
C***
C
      CALL GBYTE (IPSCOD(IWORD),JLENCH,IOFF,24)
      CALL OFFSET (IOFF,1,IWORD,24,NBIT,ILENPS,IERR)
      IF (IERR.NE.0) RETURN
C
      IF (JLENCH.GT.ILENCH)
     C   THEN
             IERR = -3
             WRITE (*,9004) JLENCH
             RETURN
         ENDIF
C
C
C
C
C
C
C
C
C***
C*    OCTETS 12-14 , NUMBER OF FLOATING POINT VALUES.
C***
C
      CALL GBYTE (IPSCOD(IWORD),JLENFP,IOFF,24)
      CALL OFFSET (IOFF,1,IWORD,24,NBIT,ILENPS,IERR)
      IF (IERR.NE.0) RETURN
C
      IF (JLENFP.GT.ILENFP)
     C   THEN
             IERR = -3
             WRITE (*,9001) JLENFP
             RETURN
         ENDIF
C
C
C
C
C
C
C
C
C
C***
C*    OCTETS 15-17 , NUMBER OF INTEGER VALUES.
C***
C
      CALL GBYTE (IPSCOD(IWORD),JLENIN,IOFF,24)
      CALL OFFSET (IOFF,1,IWORD,24,NBIT,ILENPS,IERR)
      IF (IERR.NE.0) RETURN
C
      IF (JLENIN.GT.ILENIN)
     C   THEN
             IERR = -3
             WRITE (*,9003) JLENIN
             RETURN
         ENDIF
C
C
C
C
C
C
C
C
C
C***
C*    OCTETS 18-20 , NUMBER OF LOGICALS.
C***
C
      CALL GBYTE (IPSCOD(IWORD),JLENLG,IOFF,24)
      CALL OFFSET (IOFF,1,IWORD,24,NBIT,ILENPS,IERR)
      IF (IERR.NE.0) RETURN
C
      IF (JLENLG.GT.ILENLG)
     C   THEN
             IERR = -3
             WRITE (*,9002) JLENLG
             RETURN
         ENDIF
C
C
C
C
C
C
C
C
C
C***
C*    OCTETS 21-23 , NUMBER OF RESERVED OCTETS.
C***
C
      CALL GBYTE (IPSCOD(IWORD),IRSERV,IOFF,24)
      CALL OFFSET (IOFF,1,IWORD,24,NBIT,ILENPS,IERR)
      IF (IERR.NE.0) RETURN
C
C
C
C
C
C
C
C
C
C***
C*    OCTETS 24-32 ARE RESERVED
C***
C
      CALL OFFSET (IOFF,9,IWORD,8,NBIT,ILENPS,IERR)
      IF (IERR.NE.0) RETURN
C
C
C
C
C
C
C
C***
C*    OCTET 33- ,GET FLOATING POINT NUMBERS AND CONVERT.
C***
C
  250 CONTINUE
C
      IF (JLENFP.NE.0)
     C   THEN
C
             DO 300 I=1,JLENFP
                CALL GBYTE (IPSCOD(IWORD),IEXP,IOFF,8)
                CALL OFFSET (IOFF,1,IWORD,8,NBIT,ILENPS,IERR)
                IF (IERR.NE.0) RETURN
                CALL GBYTE (IPSCOD(IWORD),IMANT,IOFF,24)
                CALL OFFSET (IOFF,1,IWORD,24,NBIT,ILENPS,IERR)
                IF (IERR.NE.0) RETURN
                CALL DECFP (FPDATA(I),IEXP,IMANT)
  300        CONTINUE
C
         ENDIF
C
C     NO CHARACTER DATA IN OLD BUDGET VALUE RECORDS.
C
      IF (IOLDBV.EQ.1) GO TO 550
C
C
C
C
C
C
C
C
C
C***
C*    GET INTEGER VALUES.
C***
C
  350 CONTINUE
C
      IF (JLENIN.NE.0)
     C   THEN
C
C            SET UP MASK FOR NEGATIVE NUMBERS
C
             NEGSIN = 2 ** (IBITS-1)
C
C            MAXIMUM SIZE INTEGER IN GIVEN FIELD WIDTH.
C
             MAXINT = NEGSIN - 1
C
             DO 400 I=1,JLENIN
                CALL GBYTE (IPSCOD(IWORD),KTEMP,IOFF,IBITS)
                CALL OFFSET (IOFF,1,IWORD,IBITS,NBIT,ILENPS,IERR)
                IF (IERR.NE.0) RETURN
C
C               HANDLE NEGATIVE NUMBERS
C
                IF (KTEMP.GT.MAXINT)
     C             THEN
                       KTEMP = KTEMP - NEGSIN
                       KTEMP = - KTEMP
                   ENDIF
C
                INDATA(I) = KTEMP
  400        CONTINUE
C
         ENDIF
C
C
C     FOR OLDER BUDGET VALUES OUR LAST STOP IS FOR FLOATING POINT
C     VALUES.
C
      IF (IOLDBV.EQ.1) GO TO 250
C
C
C
C***
C*    GET LOGICALS AND CONVERT.
C***
C
  450 CONTINUE
C
      IF (JLENLG.NE.0)
     C   THEN
C
             DO 500 I=1,JLENLG
                CALL GBYTE (IPSCOD(IWORD),KTEMP,IOFF,8)
                CALL OFFSET (IOFF,1,IWORD,8,NBIT,ILENPS,IERR)
                IF (IERR.NE.0) RETURN
C
                LGDATA(I) = .FALSE.
                IF (KTEMP.EQ.1) LGDATA(I) = .TRUE.
  500        CONTINUE
C
         ENDIF
C
C
C     FOR OLD BUDGET VALUE VERSION WE JUMP AGAIN.
C     NEXT STOP ON TOUR IS FOR INTEGER VALUES.
C
      IF (IOLDBV.EQ.1) GO TO 350
C
C
C
C
C
C
C
C
C
C
C
C
C***
C*    GET CHARACTER DATA.
C***
C
      IF (JLENCH.NE.0)
     C   THEN
             DO 530 I=1,JLENCH
                CALL GBYTE (IPSCOD(IWORD),KTEMP,IOFF,8)
                CALL OFFSET (IOFF,1,IWORD,8,NBIT,ILENPS,IERR)
                IF (IERR.NE.0) RETURN
                DO 525 J=1,NCHAR
                   IF (KTEMP.EQ.IASCII(J))
     C                THEN
                          CHDATA(I:I) = CHAR(J)
                          GO TO 530
                      ENDIF
  525           CONTINUE
                IERR = -6
                WRITE (*,9016)
 9016           FORMAT (1H ,'DECOPS : Character data contains other ',
     C                 'than _ - . , letters, figures or spaces.')
                RETURN
  530       CONTINUE
         ENDIF
C
C
C
C
C
C
C
C***
C*    RESERVED BYTES IN DATA BLOCK.
C***
C
      CALL OFFSET (IOFF,IRSERV,IWORD,8,NBIT,ILENPS,IERR)
      IF (IERR.NE.0) RETURN
C
C
C
C
C
C
C
C
C
C***
C*    SKIP ANY ZERO FILL AT END OF DATA BLOCK.
C***
C
  550 CONTINUE
C
      L = (IWORD-IPW) * NBIT + IOFF -IPB
      L = LBIN * 8 - L
      IF (L.NE.0)
     C    THEN
              CALL OFFSET (IOFF,1,IWORD,L,NBIT,ILENPS,IERR)
              IF (IERR.NE.0) RETURN
          ENDIF
C
C
C
C
C********************************************************************
C*
C*    BLOCK 5 - END BLOCK.
C*
C********************************************************************
C
C     CHECK 7 7 7 7 AT END OF CODED DATA.
C
C
      CALL GBYTES (IPSCOD(IWORD),IBLOCK(1),IOFF,8,0,4)
C
C     55 IS THE VALUE OF ASCII CHARACTER '7'
C
      DO 600 I=1,4
         IF (IBLOCK(I).NE.55) IERR = 1
  600 CONTINUE
C
      IF (IERR.EQ.1) WRITE (*,*) ' NO 7777 GROUP FOUND '
C
C
C
C     SET NUMBER OF VALUES NEGATIVE, IF MISSING DATA VALUES.
C
      IF (IMISS.GE.8)
     C   THEN
             JLENCH = -JLENCH
             IMISS  =  IMISS - 8
         ENDIF
C
      IF (IMISS.GE.4)
     C   THEN
             JLENFP = -JLENFP
             IMISS  =  IMISS - 4
         ENDIF
C
      IF (IMISS.GE.2)
     C   THEN
             JLENIN = -JLENIN
             IMISS  =  IMISS - 2
         ENDIF
C
      IF (IMISS.EQ.1) JLENLG = -JLENLG
C
C
      RETURN
C
 9001 FORMAT (1H ,'DECOPS : Target real array must be at least ',
     C             I10,' words long.')
C
 9002 FORMAT (1H ,'DECOPS : Target logical array must be at least ',
     C             I10,' words long.')
C
 9003 FORMAT (1H ,'DECOPS : Target integer array must be at least ',
     C             I10,' words long.')
C
 9004 FORMAT (1H ,'DECOPS : Target character string must be at least ',
     C             I10,' characters long.')
C
C
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities
C granted to it by virtue of its status as an intergovernmental organisation
C nor does it submit to any jurisdiction.
C

      INTEGER FUNCTION WV2DINT(KNUM,NUMPTS,KE_W,KN_S,RESON,OLDWAVE,
     X                         NEWWAVE,NORTH,WEST,KNSPEC,PMISS,RNS)
C
C---->
C*****WV2DINT*
C
C     PURPOSE
C     -------
C
C     To interpolate a wave field quasi-regular latitude
C     longitude grid to a regular latitude/longitude grid.
C
C
C     INTERFACE
C     ---------
C
C     IRET = WV2DINT(KNUM,NUMPTS,KE_W,KN_S,RESON,OLDWAVE,
C                    NEWWAVE,NORTH,WEST,KNSPEC,PMISS,RNS)
C
C     Input arguments
C     ---------------
C
C     KNUM    - No. of meridians from North to South pole (input field)
C     NUMPTS  - Array giving number of points along each latitude
C               (empty latitudes have entry 0)
C     KE_W    - First dimension of new array
C               = Number of points E-W in new grid
C     KN_S    - Second dimension of new array
C               = Number of points N-S in new grid
C     RESON   - Output grid resolution (degrees)
C     OLDWAVE - Original wave field
C     NORTH   - Output grid northernmost latitude (degree)
C     WEST    - Output grid westernmost  longitude (degree)
C     KNSPEC  - Number of 2D spectra values at each wave point
C     PMISS   - Missing data value
C     RNS     - Difference in degrees in NS disrection
C
C     Output arguments
C     ----------------

C     NEWWAVE - New wave field
C
C     Function returns 0 if the interpolation was OK.
C
C
C     METHOD
C     ------
C
C     The nearest neighbouring grid point value is assigned to
C     the interpolated point.
C
C     The output (sub) is the same as the input area.
C
C
C     EXTERNALS
C     ---------
C
C     INTLOG  - Log error message.
C
C
C     REFERENCE
C     ---------
C
C     Based on:
C         SUBROUTINE INTERPOLATE
C         Peter Janssen     ECMWF    September 1995
C     and:
C         SUBROUTINE EXPOINT
C         Heinz Gunther     ECMWF    December  1989
C
C
C     Author.
C     -------
C
C     J.D.Chambers      ECMWF    November 1996
C
C     J.D.Chambers      ECMWF    September 1998
C     Modified to handle subarea input/output.
C     The output (sub) is the same as the input area.
C
C
C----<
C
      IMPLICIT NONE
C
#include "parim.h"
C
C     Parameters
      INTEGER JPROUTINE
      PARAMETER ( JPROUTINE = 19410 )
      INTEGER JPLLMAX
      PARAMETER ( JPLLMAX = 1801 )
C                             `--> allow upto 0.1 degree resolution for
C                                  Mediterranean, 0.1 for Global
      INTEGER JPNMOUT
      PARAMETER ( JPNMOUT = 1800 )
C                             `--> allow upto 0.1 degree resolution for
C                                  Mediterranean, 0.1 for Global
C
C     Subroutine arguments
C
      INTEGER KNUM, NUMPTS, KE_W, KN_S, KNSPEC
      DIMENSION NUMPTS(*)
      REAL RESON, OLDWAVE, NEWWAVE, NORTH, WEST, PMISS
      REAL RNS
      DIMENSION OLDWAVE(*)
      DIMENSION NEWWAVE(KE_W,KN_S)
C
C     Local arguments
C
      INTEGER NLAT, K, NEWCOL, NEWROW
      INTEGER I_N, I_S
      REAL DELAT
      REAL DIST_N, DIST_S
      REAL LAT
      DIMENSION LAT(JPNMOUT+1)
      INTEGER INDEX
      DIMENSION INDEX(JPLLMAX)
C
      REAL OLDLATS(JPLLMAX), OLDEAST
      INTEGER NEXT, NUMNEW(JPLLMAX)
      INTEGER IRET, W251IDX
      EXTERNAL W251IDX
      INTEGER XKNUM,XKE_W,XKN_S
      DATA XKNUM/-1/,XKE_W/-1/,XKN_S/-1/
      REAL XRESON,XNORTH,XWEST
      DATA XRESON/-999.0/,XNORTH/-999.0/,XWEST/-999.0/
      INTEGER IFIRST, NEWIDX(3600*1801)
      DATA IFIRST/0/
      REAL DEPS
      DATA DEPS/0.00005/
C
      SAVE IFIRST,XKNUM,XKE_W,XKN_S,XRESON,XNORTH,XWEST,NEWIDX
C
C
C ---------------------------------------------------------------------
C*    Section 1. Initalisation.
C ---------------------------------------------------------------------
C
  100 CONTINUE
C
      WV2DINT = 0
      CALL INTLOG(JP_DEBUG,
     X   'WV2DINT: Wave interpolation requested.',JPQUIET)
C
C     Check only new-style 2D wave spectra (parameter 251)
C
      IF( KNSPEC.GT.1 ) THEN
        CALL INTLOG(JP_ERROR,
     X    'WV2DINT: Only single-value 2D spectra field allowed',JPQUIET)
        CALL INTLOG(JP_ERROR,
     X    'WV2DINT: Value given = ',KNSPEC)
        WV2DINT = JPROUTINE + 1
        GOTO 900
      ENDIF
C
C     Check reduced latitude/longitude grid specification
C
      IF( KNUM.GT.JPLLMAX ) THEN
        CALL INTLOG(JP_ERROR,
     X    'WV2DINT: Number of latitudes in input lat/long grid = ',KNUM)
        CALL INTLOG(JP_ERROR,
     X    'WV2DINT: And is greater than allowed maximum = ',JPLLMAX)
        WV2DINT = JPROUTINE + 2
        GOTO 900
      ENDIF
C
C     Ensure working array dimensions are adequate for required output.
C
      IF( (KE_W.GT.JPNMOUT*2).OR.(KN_S.GT.JPNMOUT+1) ) THEN
        CALL INTLOG(JP_ERROR,
     X    'WV2DINT: Internal array dimensions are too small',JPQUIET)
        CALL INTLOG(JP_ERROR,
     X    'WV2DINT: for given lat/long output field.',JPQUIET)
        WV2DINT = JPROUTINE + 3
        GOTO 900
      ENDIF
C
C     Set up index for latitude lines in the input reduced lat/lon array
C
      INDEX(1) = 0
      DO K = 2, KNUM
        INDEX(K) = INDEX(K-1) + NUMPTS(K-1)
      ENDDO
C
C     Calculate latitudes and longitudes of output grid points.
C
C
      DO K = 1, KN_S
        LAT(K) = NORTH - FLOAT(K-1)*RESON
        NUMNEW(K)  = KE_W ! 0
      ENDDO

      DELAT  = RNS/(KNUM-1)

      DO k=1,KNUM
          OLDLATS(K) = NORTH - FLOAT(K-1)*DELAT
      END DO
C
      IF( ABS((KE_W*RESON)-360.0).LT.DEPS ) THEN
        OLDEAST = WEST + KE_W*RESON
      ELSE
        OLDEAST = WEST + (KE_W-1)*RESON
      ENDIF
C
C     Initialise all points with 'missing data' indicator
C
      DO NEWROW = 1, KN_S
        DO NEWCOL = 1, KE_W
          NEWWAVE(NEWCOL,NEWROW) = PMISS
        ENDDO
      ENDDO
C
C ---------------------------------------------------------------------
C*    Section 2. Interpolation.
C ---------------------------------------------------------------------
C
  200 CONTINUE
C
C     Only calculate the indices on the first time through
C
      IF( (IFIRST.EQ.0 )     .OR.
     X    ( KNUM.NE.XKNUM )  .OR.
     X    ( KE_W.NE.XKE_W )  .OR.
     X    ( KN_S.NE.XKN_S )  .OR.
     X    ( RESON.NE.XRESON ).OR.
     X    ( NORTH.NE.XNORTH ).OR.
     X    ( WEST.NE.XWEST ) ) THEN
        IRET = W251IDX(KNUM,NUMPTS,OLDLATS,WEST,OLDEAST,
     X                 KN_S,NUMNEW,LAT,NEWIDX)
        IFIRST = 1
        XKNUM  = KNUM
        XKE_W  = KE_W
        XKN_S  = KN_S
        XRESON = RESON
        XNORTH = NORTH
        XWEST  = WEST
      ENDIF
C
C      DELAT  = 180.0/(KNUM-1)
      DELAT  = RNS/(KNUM-1)
      NEXT = 0
C
      DO 220 NEWROW = 1, KN_S
C
C       Set up the distance between new row and the old rows to N and S.
C
        NLAT   = NINT((NORTH - LAT(NEWROW))/DELAT) + 1
        I_N    = NLAT
        I_S    = MIN(I_N+1,KNUM*2)
        DIST_N = ((NORTH - DELAT*(I_N-1)) - LAT(NEWROW)) / DELAT
        DIST_S = 1.0 - DIST_N
C
C       Check if the new interpolated row lies between 2 old rows which
C       have data points
C
        IF( (NUMPTS(I_N).GT.0).AND.(NUMPTS(I_S).GT.0) ) THEN
C
C         Yes, use the calculated indices
C
          DO 210 NEWCOL = 1, KE_W
C
            NEXT = NEXT + 1
C
            NEWWAVE(NEWCOL,NEWROW) = OLDWAVE(NEWIDX(NEXT))
C
  210     CONTINUE
        Else
           NEXT = NEXT + KE_W
        ENDIF
C
  220 CONTINUE
C
C ---------------------------------------------------------------------
C*    Section 9. Closedown.
C ---------------------------------------------------------------------
C
  900 CONTINUE
C
      IF( WV2DINT.EQ.0 ) THEN
        CALL INTLOG(JP_DEBUG,
     X    'WV2DINT: Wave interpolation successful.',JPQUIET)
      ELSE
        CALL INTLOG(JP_DEBUG,
     X    'WV2DINT: Wave interpolation failed.',JPQUIET)
      ENDIF
C
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      INTEGER FUNCTION IRSIZE (KGTRUNC, KAREA, KLLEN, KNWE, KNNS, KLN,
     1   KTOTAL, PGAUSS, OWEGLOBE, ONPOLE, OSPOLE, KPR, KERR)
C
C---->
C**** *IRSIZE*
C
C     PURPOSE
C     _______
C
C     Evaluate the array sizes for a quasi regular Gaussian field.
C
C     INTERFACE
C     _________
C
C     IERR = IRSIZE (KGTRUNC, KAREA, KLLEN, KNWE, KNNS, KLN,
C    1   KTOTAL, PGAUSS, OWEGLOBE, ONPOLE, OSPOLE, KPR, KERR)
C
C     Input parameters
C     ________________
C
C     KGTRUNC    - The Gaussian truncation.
C
C     KAREA      - The field area definition (N, W, S, E) provided by
C                  the calling routine.
C
C     KLLEN      - This array contains the quasi regular Gaussian
C                  line length definition.
C
C     KPR        - The debug print switch.
C                  0  , No debugging output.
C                  1  , Produce debugging output.
C
C     KERR       - The error control flag.
C                  -ve, No error message. Return error code.
C                  0  , Hard failure with error message.
C                  +ve, Print error message. Return error code.
C
C     Output parameters
C     ________________
C
C     KNWE       - The maximum number of points in the West-East
C                  direction for this quasi regular Gaussian grid.
C
C     KNNS       - The number of points in the North-South direction
C                  in the field.
C
C     KLN        - The Northern Gaussian latitude number for this
C                  area.
C
C     KTOTAL     - The total field length for this quasi regular
C                  Gaussian grid and area.
C
C     PGAUSS     - The full list of Gaussian latitudes for this
C                  truncation.
C
C     OWEGLOBE   - This variable will be true if the array of
C                  longitudes spans the globe.
C
C     ONPOLE     - This variable will be true if the North polar line
C                  of latitude is included in the grid.
C
C     OSPOLE     - This variable will be true if the South polar line
C                  of latitude is included in the grid.
C
C     Return value
C     ____________
C
C     The error indicator (INTEGER).
C
C     Error and Warning Return Values
C     _______________________________
C
C     23801 A non-global area was requested and this option is not
C           supported yet.
C
C     Common block usage
C     __________________
C
C     None
C
C     EXTERNALS
C     _________
C
C     IGGLAT     - Compute Gaussian lines of latitude for a given
C                  truncation.
C     INTLOG(R)  - Logs messages.
C
C     METHOD
C     ______
C
C
C     A global definition is generated for the quasi regular field
C     and all three flag variable are set TRUE.
C
C     A REAL array of the full set of Gaussian latitudes is generated
C     for the Gaussian truncation requested.
C
C     REFERENCE
C     _________
C
C     None
C
C     COMMENTS
C     ________
C
C     Program contains sections 0 to 4 and 9
C
C     AUTHOR
C     ______
C
C     K. Fielding      *ECMWF*      Nov 1993
C
C     MODIFICATIONS
C     _____________
C
C     None
C
C----<
C     _______________________________________________________
C
C
C*    Section 0. Definition of variables.
C     _______________________________________________________
C
C*    Prefix conventions for variable names
C
C     Logical      L (but not LP), global or common.
C                  O, dummy argument
C                  G, local variable
C                  LP, parameter.
C     Character    C, global or common.
C                  H, dummy argument
C                  Y (but not YP), local variable
C                  YP, parameter.
C     Integer      M and N, global or common.
C                  K, dummy argument
C                  I, local variable
C                  J (but not JP), loop control
C                  JP, parameter.
C     REAL         A to F and Q to X, global or common.
C                  P (but not PP), dummy argument
C                  Z, local variable
C                  PP, parameter.
C
C     Implicit statement to force declarations
C
      IMPLICIT NONE
C
#include "parim.h"
C
C     Dummy arguments
      LOGICAL OWEGLOBE, ONPOLE, OSPOLE
      INTEGER KGTRUNC, KNWE, KNNS, KLN, KTOTAL, KPR, KERR
      INTEGER KAREA (4), KLLEN (*)
      REAL PGAUSS (*)
C
C     Local variables
      LOGICAL GZERO
      INTEGER IGAUSS, ILATNUM, ILS, INDIST, ISDIST, IERR
      INTEGER JLAT
      INTEGER JPROUTINE
      PARAMETER (JPROUTINE = 23800)
C
C     Function externals
C
      INTEGER IGGLAT
C
C     _______________________________________________________
C
C*    Section 1. Initialisation
C     _______________________________________________________
C
  100 CONTINUE
C
      IF (KPR.GE.1) CALL INTLOG(JP_DEBUG,'IRSIZE: Section 1.',JPQUIET)
C
      IRSIZE = 0
C
      IF (KPR .GE. 1) THEN
        CALL INTLOG(JP_DEBUG,'IRSIZE: Input parameters.',JPQUIET)
        CALL INTLOG(JP_DEBUG,
     X     'IRSIZE: Gaussian truncation = ',KGTRUNC)
        IF (KNNS .NE. 0) CALL INTLOG(JP_DEBUG,
     X    'IRSIZE: No.lat. pts = ',KNNS)
C
        CALL INTLOG(JP_DEBUG,'IRSIZE: Area North = ', KAREA(1))
        CALL INTLOG(JP_DEBUG,'IRSIZE: Area West  = ', KAREA(2))
        CALL INTLOG(JP_DEBUG,'IRSIZE: Area South = ', KAREA(3))
        CALL INTLOG(JP_DEBUG,'IRSIZE: Area East  = ', KAREA(4))
      ENDIF
C
      GZERO = .FALSE.
C
      ILATNUM = KGTRUNC * 2
C
C     _______________________________________________________
C
C*    Section 2. If all elements of KAREA are zero generate
C                a global field
C     _______________________________________________________
C
  200 CONTINUE
C
      IF (KPR.GE.1) CALL INTLOG(JP_DEBUG,'IRSIZE: Section 2.',JPQUIET)
C
Cxxx  IF (KAREA (JPEAST) .NE. 0 .OR. KAREA (JPWEST) .NE. 0) THEN
C
Cxxx     IRSIZE = JPROUTINE + 1
Cxxx     IF (KERR .GE. 0) WRITE (*, 9001) IRSIZE,
Cxxx 1      REAL (KAREA (JPNORTH) ) / PPMULT,
Cxxx 2      REAL (KAREA (JPWEST) ) / PPMULT,
Cxxx 3      REAL (KAREA (JPSOUTH) ) / PPMULT,
Cxxx 4      REAL (KAREA (JPEAST) ) / PPMULT
Cxxx     IF (KERR .EQ. 0) CALL ABORTX ('IRSIZE')
Cxxx     GO TO 900
Cxxx  ENDIF
C
      OWEGLOBE = .TRUE.
C
C     _______________________________________________________
C
C*    Section 3. Generate points along a line of meridian
C     _______________________________________________________
C
  300 CONTINUE
C
      IF (KPR.GE.1) CALL INTLOG(JP_DEBUG,'IRSIZE: Section 3.',JPQUIET)
C
C     Generate full Gaussian latitudes for this truncation
C
      IERR = IGGLAT (ILATNUM, PGAUSS, KPR, KERR)
C
      IF (IERR .GT. 0) THEN
         IRSIZE = IERR
         GO TO 900
      ENDIF
C
C     Find Gaussian lines corresponding to North and South points
C     provided
C
      KLN = 1
      ILS = ILATNUM
C
      IF (KNNS .EQ. 0) THEN
C
C       Number of lines not set (output field)
C
        KLN = 0
        ILS = ILATNUM
C
        DO 310 JLAT = 2, ILATNUM
C
          IGAUSS = NINT (PGAUSS (JLAT) * PPMULT)
C
          IF (KLN .EQ. 0 .AND. KAREA (JPNORTH) .GT. IGAUSS) THEN
            KLN = JLAT - 1
            KAREA (JPNORTH) = NINT (PGAUSS (KLN) * PPMULT)
          ENDIF
C
          IF (ILS.EQ.ILATNUM .AND. KAREA(JPSOUTH).GE.IGAUSS) THEN
            ILS = JLAT
            KAREA (JPSOUTH) = NINT (PGAUSS (ILS) * PPMULT)
          ENDIF
C
  310   CONTINUE
C
        KNNS = ILS - KLN + 1
C
      ELSE
C
C       Number of lines set (input field)
C
        JLAT = 1
        KLN = JLAT
        ILS = JLAT
C
        INDIST = ABS (NINT (PGAUSS (JLAT) * PPMULT) - KAREA (JPNORTH) )
        ISDIST = ABS (NINT (PGAUSS (JLAT) * PPMULT) - KAREA (JPSOUTH) )
C
        DO 320 JLAT = 2, ILATNUM
C
          IF (ABS (NINT (PGAUSS (JLAT) * PPMULT) - KAREA (JPNORTH) )
     1         .LT. INDIST) THEN
C
             KLN = JLAT
             INDIST = ABS(NINT(PGAUSS (JLAT) * PPMULT) - KAREA(JPNORTH))
C
          ENDIF
C
          IF (ABS (NINT (PGAUSS (JLAT) * PPMULT) - KAREA (JPSOUTH) )
     1         .LT. ISDIST) THEN
C
            ILS = JLAT
            ISDIST = ABS(NINT(PGAUSS(JLAT) * PPMULT) - KAREA(JPSOUTH))
C
          ENDIF
C
  320   CONTINUE
C
        IF (KNNS .NE. ILS - KLN + 1) THEN
          IRSIZE = JPROUTINE + 2
          IF (KERR .GE. 0) THEN
            CALL INTLOG(JP_ERROR,
     X        'IRSIZE: No. lines specified = ',KNNS)
            CALL INTLOG(JP_ERROR,
     X        'IRSIZE: Gaussian N limit = ',KLN)
            CALL INTLOG(JP_ERROR,
     X        'IRSIZE: Gaussian S limit = ',ILS)
          ENDIF
C
          IF (KERR .EQ. 0) CALL INTLOG(JP_FATAL,
     X      'IGLSIZE: Interpolation failed.',IRSIZE)
          GO TO 900
        ENDIF
C
      ENDIF
C
      ONPOLE = KLN .EQ. 1
      OSPOLE = ILS .EQ. ILATNUM
C
      KNNS = ILS - KLN + 1
C
      KAREA (JPNORTH) = NINT (PGAUSS (KLN) * PPMULT)
      KAREA (JPSOUTH) = NINT (PGAUSS (ILS) * PPMULT)
C
C     _______________________________________________________
C
C*    Section 4. Use line lengths to set maximum length and total
C     _______________________________________________________
C
  400 CONTINUE
C
      IF (KPR.GE.1) CALL INTLOG(JP_DEBUG,'IRSIZE: Section 4.',JPQUIET)
C
      KNWE = KLLEN (KGTRUNC)
C
      KTOTAL = 0
C
      DO 410 JLAT = KLN, ILS
C
        KTOTAL = KTOTAL + KLLEN (JLAT)
C
  410 CONTINUE
C
      IF (KPR .GE. 1) THEN
        CALL INTLOG(JP_DEBUG,'IRSIZE: Output parameters.',JPQUIET)
        CALL INTLOG(JP_DEBUG,'IRSIZE: Max W-E line len = ',KNWE)
        CALL INTLOG(JP_DEBUG,'IRSIZE: No lat lines = ',KNNS)
        CALL INTLOG(JP_DEBUG,'IRSIZE: Total no.pts = ',KTOTAL)
        CALL INTLOG(JP_DEBUG,'IGLSIZE: Northern line no. =',KLN)
        CALL INTLOG(JP_DEBUG,'IGLSIZE: Southern line no. =',ILS)
C
        IF( OWEGLOBE ) THEN
          CALL INTLOG(JP_DEBUG,'IGLSIZE: W-E fld is global',JPQUIET)
        ELSE
          CALL INTLOG(JP_DEBUG,'IGLSIZE: W-E fld is NOT global',JPQUIET)
        ENDIF
C
        IF( ONPOLE ) THEN
          CALL INTLOG(JP_DEBUG,'IGLSIZE: N pole is in fld.',JPQUIET)
        ELSE
          CALL INTLOG(JP_DEBUG,'IGLSIZE: N pole is NOT in fld.',JPQUIET)
        ENDIF
C
        IF( OSPOLE ) THEN
          CALL INTLOG(JP_DEBUG,'IGLSIZE: S pole is in fld.',JPQUIET)
        ELSE
          CALL INTLOG(JP_DEBUG,'IGLSIZE: S pole is NOT in fld.',JPQUIET)
        ENDIF
C
      ENDIF
C
C     _______________________________________________________
C
C*    Section 9. Return to calling routine. Format statements
C     _______________________________________________________
C
  900 CONTINUE
C
      IF (KPR.GE.1) CALL INTLOG(JP_DEBUG,'IRSIZE: Section 9.',JPQUIET)
C
C9001 FORMAT (' IRSIZE ERROR', I6, ' - One of the area limits is ',
C    1   'non-zero.' / 22X, 'They are', 4F10.4)
C
      RETURN
      END

      PROGRAM DCHANGE
      IMPLICIT NONE
C
      INTEGER JPACK, JPBYTES
      PARAMETER (JPACK = 280000)
      PARAMETER (JPBYTES = 4)
      REAL MAXFLT
      PARAMETER (MAXFLT = 2147483647.0)
C
      INTEGER ISEC0(2),ISEC1(1024),ISEC2(1024),ISEC3(2),ISEC4(512)
      INTEGER IUSEC0(2),IUSEC1(1024),IUSEC2(1024),IUSEC3(2), IUSEC4(512)
C
      REAL ZSEC2(512),ZSEC3(2),ZSEC4(JPACK*4),USEC4(JPACK*4)
      INTEGER INBUFF(JPACK)
      INTEGER IRET, FILE1, FILE2, JCOUNT
      INTEGER ILENB, LENOUT, IPUNP, IWORD, LOOP
C
      CHARACTER*4 CNMEXP
      CHARACTER*128 INFILE, OUTFILE, NAMFILE
      INTEGER IJDC, IARGC
cs      EXTERNAL IARGC, GETENV
C
      NAMELIST /USHEAD/IUSEC0,IUSEC1,IUSEC2,IUSEC3,IUSEC4,CNMEXP
C
C     -----------------------------------------------------------------|
C
      IJDC = IARGC()
      IF( IJDC.LT.3 ) THEN
        WRITE(*,*) 'Usage: Dchange_grib namelist input output'
        STOP 'Faulty program options'
      ENDIF
C
      CALL GETARG(1,NAMFILE)
      CALL GETARG(2,INFILE)
      CALL GETARG(3,OUTFILE)
C
C     Open the input file
C
      CALL PBOPEN(FILE1, INFILE, "R", IRET)
      IF( IRET.NE.0 ) THEN
        WRITE(*, *) 'Return code from PBOPEN = ',IRET
        CALL PBCLOSE(FILE1, IRET)
        STOP 'Fault in PBOPEN opening input file'
      ENDIF
C
C     Open the output file
C
      CALL PBOPEN(FILE2, OUTFILE, "w", IRET)
      IF( IRET.NE.0 ) THEN
        WRITE (*, *) 'Return code from PBOPEN = ',IRET
        STOP 'Fault in PBOPEN opening output file'
      ENDIF
C
C     -----------------------------------------------------------------|
C
C     Initialize namelist, read input
C
      DO LOOP =1,2
        IUSEC3(LOOP)=-999
      ENDDO
C
      DO LOOP=1,1024
        IUSEC1(LOOP)=-999
      ENDDO
C
      DO LOOP=1,1024
        IUSEC2(LOOP)=-999
      ENDDO
C
      DO LOOP=1,512
        IUSEC4(LOOP)=-999
      ENDDO
C
      CNMEXP='9999'
C
      OPEN(12,FILE=NAMFILE,FORM='FORMATTED',STATUS='OLD',ERR=900)
C
      READ(12,USHEAD)
C      
      DO LOOP=1,1024
        IF(IUSEC1(LOOP).NE.-999) THEN
          WRITE(*,*)
     X      "Element ",LOOP," of header 1 changed to ",IUSEC1(LOOP)
        ENDIF
      ENDDO   
C
      IF (CNMEXP(1:4).NE.'9999') WRITE(*,*)
     1   "EXPVER (element 41 of header 1) changed to ",CNMEXP(1:4)


      DO LOOP=1,1024
        IF(IUSEC2(LOOP).NE.-999) THEN
          WRITE(*,*)
     X      "Element ",LOOP," of header 2 changed to ",IUSEC2(LOOP)
        ENDIF
      ENDDO
C
      DO LOOP=1,2
        IF(IUSEC3(LOOP).NE.-999) THEN
          WRITE(*,*)
     X      "Element ",LOOP," of header 3 changed to ",IUSEC3(LOOP)
        ENDIF
      ENDDO
C   
      DO LOOP=1,512
        IF(IUSEC4(LOOP).NE.-999) THEN
          WRITE(*,*)
     X      "Element ",LOOP," of header 4 changed to ",IUSEC4(LOOP)
        ENDIF
      ENDDO
C
C     -----------------------------------------------------------------|
C
      JCOUNT = 0
C
   50 CONTINUE
C
C     Read packed field into INBUFF.
C
      ILENB = JPACK*JPBYTES
      CALL PBGRIB(FILE1, INBUFF, ILENB, LENOUT, IRET )
      IF( IRET.LT.0 ) THEN
        IF( IRET.EQ.-1 ) THEN
C
          CALL PBCLOSE(FILE2, IRET)
          IF( IRET.LT.0 ) THEN
            WRITE(*, *) 'Return code from PBCLOSE = ',IRET
            STOP 'Fault in PBCLOSE closing output file'
          ENDIF
C
          CALL PBCLOSE(FILE1, IRET)
          WRITE(*, *) 'Number of GRIB products changed = ',JCOUNT
          STOP 'End-of-file for input'
        ELSE
          WRITE (*, *) 'Return code from PBGRIB = ',IRET
          CALL PBCLOSE(FILE1, IRET)
          WRITE(*,*) 'Fault in PBGRIB reading product number ', JCOUNT
          STOP 'Fault in PBGRIB reading product'
        ENDIF
      ENDIF
C
      JCOUNT = JCOUNT + 1
C
C     Unpack GRIB message.
C
      ZSEC3(2) = -MAXFLT
      ISEC3(2) = INT(ZSEC3(2))
      IRET = 1
      IPUNP = JPACK * JPBYTES
      ILENB = (LENOUT + (JPBYTES-1))/JPBYTES
      CALL GRIBEX (ISEC0,ISEC1,ISEC2,ZSEC2,ISEC3,ZSEC3,ISEC4,
     X             ZSEC4,IPUNP,INBUFF,ILENB,IWORD,'D',IRET)
      IF( IRET.GT.0 ) THEN
        WRITE(*,*) 'GRIBEX problem decoding product ',JCOUNT
        WRITE(*,*) 'GRIBEX return code = ',IRET
        STOP 'GRIBEX error'
      ENDIF
C
C     -----------------------------------------------------------------|
C
C     Repack the field and write to results file
C
C
C     Changes the header, according to user requests
C
      DO LOOP=1,1024
        IF(IUSEC1(LOOP).NE.-999) ISEC1(LOOP)=IUSEC1(LOOP)
      ENDDO
C
      IF (CNMEXP(1:4).NE.'9999')  READ(CNMEXP,'(A4)') ISEC1(41)
C
      DO LOOP=1,1024
        IF(IUSEC2(LOOP).NE.-999) ISEC2(LOOP)=IUSEC2(LOOP)
      ENDDO
C
      DO LOOP=1,2
        IF(IUSEC3(LOOP).NE.-999) ISEC3(LOOP)=IUSEC3(LOOP)
      ENDDO
C
      DO LOOP=1,512
        IF(IUSEC4(LOOP).NE.-999) ISEC4(LOOP)=IUSEC4(LOOP)
      ENDDO
C
      IRET = 1
      IPUNP = ISEC4(1)
      ILENB = JPACK
      CALL GRIBEX (ISEC0,ISEC1,ISEC2,ZSEC2,ISEC3,ZSEC3,ISEC4,
     X             ZSEC4,IPUNP,INBUFF,ILENB,IWORD,'C',IRET)
      IF( IRET.GT.0 ) THEN
        WRITE(*,*) 'GRIBEX problem encoding product ',JCOUNT
        WRITE(*,*) 'GRIBEX return code = ',IRET
        STOP 'GRIBEX error'
      ENDIF
C
      LENOUT = IWORD * JPBYTES
      CALL PBWRITE(FILE2, INBUFF, LENOUT, IRET)
      IF( IRET.LT.LENOUT ) THEN
        WRITE(*,*) 'Problem writing product ',JCOUNT
        WRITE(*,*) 'Return code from PBWRITE = ',IRET
        STOP 'Fault in PBWRITE'
      ENDIF
C
C     -----------------------------------------------------------------|
C
      GOTO 50
C
  900 CONTINUE
C
      WRITE(*, *) 'Namelist OPEN failed'
C
      STOP
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C


      SUBROUTINE SORTF (UN1,UN2,IRET)
C
C---->
C**********************************************************************
C*                                                                    *
C*    NAME      : SORTF                                               *
C*                                                                    *
C*    FUNCTION  : SORTS FIELDS IN A FILE IN ASCENDING ORDER           *
C*                                                                    *
C*    INPUT     : UN1   = INPUT  LUN                                  *
C*                UN2   = OUTPUT LUN                                  *
C*                                                                    *
C*    OUTPUT    : IRET  = -10    INSUFFICENT BUFFER LENGTH            *
C*                      = -100   BUFFER IN ERROR                      *
C*                      = -200   BUFFER OUT ERROR                     *
C*                      = -300   UNRECOGNISED LEVEL TYPE.
C*                      = -400   LEVEL SEQUENCE ERROR.
C*                      > 0      NO. OF FIELDS WRITTEN                *
C*                      < 0      ERROR CODES FROM SUBROUTINES.        *
C*                                                                    *
C*    GENERAL   : SORTF CALLS RECLEN                                  *
C*                            SORT                                    *
C*                                                                    *
C*    AUTHOR    : B.V. GURETZKY   16.07.85                            *
C*                                                                    *
C*    MOFIFIED  : J. HENNESSY     26.11.85                            *
C                 J. HENNESSY     23.03.87
C*                                                                    *
C**********************************************************************
C----<
C
      IMPLICIT INTEGER (B,R,U)
      PARAMETER (BLEN=500000)
      DIMENSION BUF(BLEN)
C
C     NO OF BITS  PER WORD
      DATA NBIT /64/
C
      DATA IPR /1/
C
C
      IRET               = 0
      IB                 = 0
      LEN                = 0
      NOF                = -1
      RECNO              = 0
      ICODE              = 0
      INTER              = 0



C      SKIP TO END OF FILE AND CHECK LAST FIELD.
C
      DO 2000 J = 1,10000
         BUFFER IN (UN1,0) (BUF(1),BUF(BLEN))
         IUNIT = UNIT(UN1)
         IF (UNIT(UN1)) 1000,2500,10000
 1000    CONTINUE
         RECNO = RECNO + 1
 2000 CONTINUE
C
C     IF LAST FIELD IS LN SURFACE PRESSURE OR BUDGET VALUE
C     RECORD, WRITE TO OUTPUT FILE.
C
 2500 CALL RECLEN (BUF(1),LEN,NBIT,ICODE,INDIC,LEVEL,JERR)
      IF (JERR.NE.0)
     C   THEN
             IRET = JERR
             RETURN
         ENDIF
C
C     IDENTIFY LEVEL TYPE FOR SEQUENCE CHECKING PURPOSES.
C
C     SURFACE DATA.
C
      IF (INDIC.EQ.1)
     C   THEN
             INTER = 0
             ITYPE = 0
             GO TO 2600
         ENDIF
C
C     PRESSURE LEVEL DATA.
C
      IF (INDIC.EQ.100)
     C   THEN
             INTER = 9999
             ITYPE = 1
             GO TO 2600
         ENDIF
C
C     MODEL LEVEL DATA.
C
      IF (INDIC.EQ.109)
     C   THEN
             INTER = 0
             ITYPE = 2
             GO TO 2600
         ENDIF
C
C     INVALID LEVEL TYPE.
C
      IRET = -300
      WRITE (*,9001) INDIC
 9001 FORMAT (1H ,'SORTF : INVALID LEVEL TYPE - ',I3)
      RETURN
C
 2600 CONTINUE
C
      IF (ICODE.EQ.152.OR.ICODE.EQ.128)
     C   THEN
             IRET        = IRET   +  1
             LEN         = LEN    /  8
             RECNO       = RECNO  -  1
             BUFFER OUT (UN2,0) (BUF(1),BUF(LEN))
             IUNIT       = UNIT(UN2)
             IF (IPR.EQ.1) WRITE (*,9101) LEVEL,ICODE
 9101        FORMAT (1H ,'LEVEL ',I5,' FIELD ',I5)
             IF (IUNIT.GT.0) GO TO 10500
         ENDIF
C
      REWIND UN1
C
C     START AGAIN AT BEGINNING OF FILE FOR OTHER FIELDS.
C
      DO 5000 J = 1,RECNO
C
C        READ AS MANY FIELDS AS POSSIBLE INTO MEMORY.
C
         LEVEL = INTER
         BUFFER IN (UN1,0) (BUF(IB+1),BUF(BLEN))
         IUNIT = UNIT(UN1)
         IF (UNIT(UN1)) 3000,5500,10000
 3000    CONTINUE
         NOF = NOF + 1
C
C        IF LEVEL CHANGES THEN SORT PREVIOUS FIELDS.
C
         CALL RECLEN (BUF(IB+1),LEN,NBIT,ICODE,INDIC,INTER,JERR)
            IF (JERR.NE.0)
     C         THEN
                   IRET = JERR
                   RETURN
               ENDIF
C
         LEN = LENGTH(UN1)
         IF ((INTER.NE.LEVEL).AND.(J.GT.1))
     C      THEN
C
C               FIRST CHECK THAT LEVEL SEQUENCE IS CORRECT.
C
                IF ( (ITYPE.EQ.1.AND.INTER.GT.LEVEL) .OR.
     C               (ITYPE.EQ.2.AND.INTER.LT.LEVEL) )
     C             THEN
                       IRET = - 400
                       WRITE (*,9002)
 9002                  FORMAT (1H ,'SORTF : LEVEL SEQUENCE ERROR.')
                       RETURN
                   ENDIF
C
C               SORT FIELDS
C
                CALL SORT (BUF(1),NOF,UN2,IRET,NBIT)
                IF (IRET.LE.0) RETURN
C
C               MOVE LAST FIELD TO BUFFER START
C
                NOF = 0
                DO 4000 K = 1,LEN
                   BUF(K) = BUF(IB+K)
 4000           CONTINUE
                IB = 0
C
            ENDIF
C
C        CHECK BUFFER LIMITS
C
         IB = IB + LEN
         IF (IB+LEN.GT.BLEN)
     C      THEN
                IRET = -10
                WRITE (*,9000) J
 9000           FORMAT (' SORTF : NOT ENOUGH MEMORY FOR FIELD :',I4.4)
                RETURN
            ENDIF
C
C
 5000 CONTINUE
C
C     SORT LAST SET OF FIELDS.
C
 5500 NOF = NOF + 1
      CALL SORT (BUF(1),NOF,UN2,IRET,NBIT)
C
      RETURN
C
10000 CONTINUE
      IRET = -100
      WRITE (*,*) ' SORTF : BUFFER IN ERROR'
      RETURN
C
10500 CONTINUE
      IRET = -200
      WRITE (*,*) ' SORTF : BUFFER OUT ERROR'
      RETURN
C
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE BUPRS0(KSEC0)
C
C**** *BUPRS0*
C
C
C     PURPOSE.
C     --------
C           PRINT SECTION 0 OF BUFR MESSAGE.
C
C
C**   INTERFACE.
C     ----------
C
C           *CALL* *BUPRS0(KSEC0)*
C
C        INPUT :
C               *KSEC0*   -  ARRAY CONTAINING SECTION 0 INFORMATION
C                            KSEC0( 1)-- LENGTH OF SECTION 0 (BYTES)
C                            KSEC0( 2)-- TOTAL LENGTH OF BUFR MESSAGE (BYTES)
C                            KSEC0( 3)-- BUFR EDITION NUMBER
C
C     METHOD.
C     -------
C
C            NONE
C
C     EXTERNALS.
C     ----------
C
C            NONE.
C
C     REFERENCE.
C     ----------
C
C          NONE.
C
C     AUTHOR.
C     -------
C
C          M. DRAGOSAVAC    *ECMWF*       04/02/91.
C
C     MODIFICATIONS.
C     --------------
C
C          NONE.
C
      IMPLICIT LOGICAL(L,O,G), CHARACTER*8(C,H,Y)
C
C
#     include "parameter.F"
#     include "bcomunit.F"
C
      DIMENSION KSEC0(JSEC0)
C
C     ------------------------------------------------------------------
C
C*          1.   PRINT SECTION 0.
C                ----------------
 100  CONTINUE
C
      WRITE(KNTN,'(1H1)')
C
      WRITE(KNTN,'(1H ,A)')    '         BUFR SECTION 0    '
      WRITE(KNTN,'(1H )')
      WRITE(KNTN,'(1H ,A,I10)') 'LENGTH OF SECTION 0 (BYTES)         ',
     1                       KSEC0(1)
      WRITE(KNTN,'(1H ,A,I10)') 'TOTAL LENGTH OF BUFR MESSAGE (BYTES)',
     1                       KSEC0(2)
      WRITE(KNTN,'(1H ,A,I10)') 'BUFR EDITION NUMBER                 ',
     1                       KSEC0(3)
C
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C


      INTEGER FUNCTION RTB (CHAR)
C
C---->
C*
C*    NAME      : RTB
C*
C*    FUNCTION  : COUNT THE NUMBER OF CHARACTERS IN A CHARACTER
C*                STRING, EXCLUDING TRAILING SPACES.
C*
C*    INPUT     : CHAR - CHARACTER STRING
C*
C*    OUTPUT    : RTB  - NO OF CHARACTERS
C*
C*    GENERAL   : RTB CALLS  -----
C*
C*    AUTHOR    : J.HENNESSY  15.4.85
C*
C     ---------------------------------------------------------------
C----<
C
      CHARACTER*(*) CHAR
C
      J = LEN (CHAR)
C
C     No trailing blanks.
C
      IF (CHAR(J:J).NE.' ')
     C     THEN
               RTB = J
               RETURN
           ENDIF
C
C     String with trailing blanks.
C
      DO 100 I = J,1,-1
         IF (CHAR(I:I).NE.' ')
     C          THEN
                    RTB = I
                    RETURN
                ENDIF
  100 CONTINUE
C
C     String consists of only blanks.
C
      RTB = 0
C
      RETURN
      END

C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

C
      COMMON /BCOMP/ INWTEN(JELEM),INWTR (JELEM),INWTS (JELEM),
     1                INWTRV (JELEM),INWTDW(JELEM),
     2                INWORDP(JWORK),INBITP(JWORK)
C             INWTEN   -  WOKING TABLE
C             INWTR     -  WORKING TABLE REFERENCE
C             INWTS     -  WORKING SCALE
C             INWTRV    -  WORKING REFERENCE VALUE
C             INWTDW    -  WORKING DATA WIDTH

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE CREXSEL2(KSUBSET,KELEM,KTDLEN,KTDLST,KTDEXL,KTDEXP,
     1                    CNAMES,CUNITS,KERR)
C
C**** *CREXSEL2*
C
C
C
C     PURPOSE.
C     --------
C          Returns list of Data Descriptors as in Section 1  of Crex
C          message and total/requested list of elements.
C
C
C**   INTERFACE.
C     ----------
C
C          *CALL* *CREXSEL(KSUBSET,KELEM,KTDLEN,KTDLST,KTDEXL,KTDEXP,
C                          CNAMES,CUNITS,KERR)*
C
C
C        INPUT: *KSUBSET* -  Subset number
C               *KELEM*   -  
C        OUTPUT:
C               *KTDLEN*  -  number of data descriptors in section 1
C               *KTDLST*  -  array containing data descriptors in section 1
C               *KTDEXL*  -  number of entries in list of expanded data
C                            descriptors
C               *KTDEXP*  -  array containig expanded data descriptors
C               *CNAMES*  -  ARRAY CONTAINING ELEMENT NAMES
C               *CUNITS*  -  ARRAY CONTAINING ELEMENT UNITS
C               *KERR*    -  returned error code
C
C
C     METHOD.
C     -------
C
C          NONE.
C
C     EXTERNALS.
C     ----------
C
C          NONE.
C
C     REFERENCE.
C     ----------
C
C          NONE.
C
C     AUTHOR.
C     -------
C
C          MILAN DRAGOSAVAC    *ECMWF*       07/01/2004.
C
C
C     MODIFICATIONS.
C     --------------
C
C          NONE.
C
C
      IMPLICIT LOGICAL(L,O,G), CHARACTER*8(C,H,Y)
C
C
      PARAMETER(JSUP =   9,JSEC0=   3,JSEC1= 40,JSEC2= 64 ,JSEC3=    4,
     1          JSEC4=   2,JELEM=40000,JSUBS=400,JCVAL=150 ,JBUFL=40000,
     2          JBPW =  32,JTAB =3000,JCTAB=120,JCTST=1800,JCTEXT= 200,
     3          JWORK=360000,JKEY=46)
C
C
      COMMON /CREXEL/ NCREXTDLEN,NCREXTDLST(JELEM),NCREXTDEXL,
     1                NCREXTDEXP(JELEM)
C
C             NCREXTDLEN - number of Data descriptors in section 1
C             NCREXTDLST - list of Data descriptors
C             NCREXTDEXL - number of expanded Data Descriptors
C             NCREXTDEXP - list of expanded Data descriptors
C
C
      COMMON /CREXOFF/ NSIZEG(JELEM),NCREXWTRG(JWORK),
     1                 NBP,NSUBSET,OMULTI
C
      DIMENSION  KTDLST(*),KTDEXP(*)
C
      CHARACTER*64 CNAMES(*)
      CHARACTER*24 CUNITS(*)
C
C     -----------------------------------------------------------------

C*          1.  PUT LIST OF ELEMENTS FROM COMMON BLOCK
C               --------------------------------------
C               TO REQUESTED ARRAYS.
C               --------------------
 100  CONTINUE
C
      KERR=0
C
      KTDLEN=NCREXTDLEN
C
      DO 101 I=1,NCREXTDLEN
      KTDLST(I)=NCREXTDLST(I)
 101  CONTINUE
C
      NTDEXL=NSIZEG(KSUBSET)
      KTDEXL=NTDEXL
      IJ=(KSUBSET-1)*KELEM

      DO 102 I=1,KTDEXL
      IIJ=I+IJ
      KTDEXP(I)=NCREXWTRG(IIJ)
      CALL CREX_GET_NAME_UNIT(KTDEXP(I),CNAMES(I),CUNITS(I))
 102  CONTINUE
C
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      subroutine swap_bytes8(r1,r2)
c     ---------------------------------
      implicit none

      real*8 r1, r2
      real*8 r18
      real*8 r28
      integer*8 kint18,kint28

      equivalence(r18,kint18)
      equivalence(r28,kint28)



c Reverse order of bytes

      r18=r1

      call mvbits(kint18, 56, 8, kint28, 0)
      call mvbits(kint18, 48, 8, kint28, 8)
      call mvbits(kint18, 40, 8, kint28,16)
      call mvbits(kint18, 32, 8, kint28,24)
      call mvbits(kint18, 24, 8, kint28,32)
      call mvbits(kint18, 16, 8, kint28,40)
      call mvbits(kint18,  8, 8, kint28,48)
      call mvbits(kint18,  0, 8, kint28,56)


      r2=r28

      return
      end

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C


      SUBROUTINE CODEGC (FPDATA,ILENF,IBITS,NBIT,IB1PAR,IB2PAR,IB3PAR,
     C                   IBLEN,IBMAP,FVERT,ILENV,IGRIB,ILENG,IWORD,
     C                   IROUND,IERR)
C
C
C---->
C*
C*     NAME     : CODEGC
C*
C*     FUNCTION : CODE ARRAY OF FLOATING POINT VALUES
C*                IN WMO GRIB CODE.
C*
C*     INPUT    : PARAMETERS FOR BLOCK 1 , PRODUCT DEFINITION BLOCK.
C*                --------------------------------------------------
C*                IB1PAR - INTEGER ARRAY (DIMENSION 18) OF PRODUCT
C*                         DEFINITION INFORMATION.
C*
C*                WORD      CONTENTS
C*                ----      --------
C*                  1       ORIGINATING CENTRE IDENTIFIER.
C*                  2       MODEL IDENTIFICATION.
C*                  3       GRID DEFINITION.
C*                  4       FLAG ( CODE TABLE 1 ).
C*                  5       PARAMETER IDENTIFIER (CODE TABLE 2).
C*                  6       TYPE OF LEVEL (CODE TABLE 3).
C*                 7-8      VALUE(S) OF LEVEL (CODE TABLE 3).
C*                  9       YEAR OF DATA
C*                 10       MONTH OF DATA
C*                 11       DAY OF DATA
C*                 12       HOUR OF DATA
C*                 13       MINUTE OF DATA
C*                 14       TIME UNIT (CODE TABLE 4).
C*                 15       TIME RANGE ONE
C*                 16       TIME RANGE TWO
C*                 17       TIME RANGE FLAG (CODE TABLE 5).
C*                 18       NUMBER AVERAGED.
C*
C*                          VALUE(S) OF LEVEL CAN OCCUPY 2 WORDS.
C*                          FOR A LAYER THE FIRST WORD DEFINES THE TOP
C*                          AND THE SECOND THE BOTTOM OF THE LAYER.
C*                          FOR A SINGLE LEVEL, ONLY THE FIRST WORD IS
C*                          USED.
C*
C*                PARAMETERS FOR BLOCK 2 , GRID DEFINITION BLOCK.
C*                -----------------------------------------------
C*                IB2PAR - INTEGER ARRAY (DIMENSION 11) CONTAINING GRID
C*                         DEFINITION INFORMATION.
C*                         USE VARIES WITH REPRESENTATION TYPE.
C*
C*                WORD      LAT/LONG GRID
C*                ----      -------------
C*                 1        DATA REPRESENTATION TYPE (CODE TABLE 6)
C*                 2        NO. OF POINTS ALONG A LATITUDE
C*                 3        NO. OF POINTS ALONG A MERIDIAN
C*                 4        LATITUDE OF ORIGIN (SOUTH - IVE).
C*                 5        LONGITUDE OF ORIGIN (WEST - IVE).
C*                 6        RESOLUTION FLAG. (CODE TABLE 7)
C*                 7        LATITUDE OF EXTREME POINT (SOUTH - IVE).
C*                 8        LONGITUDE OF EXTREME POINT (WEST - IVE).
C*                 9        LATITUDE INCREMENT
C*                10        LONGITUDE INCREMENT
C*                11        SCANNING MODE FLAGS (CODE TABLE 8)
C*
C*                WORD      GAUSSIAN GRID
C*                ----      -------------
C*                1-9       AS FOR LAT/LONGITUDE GRID.
C*                10        THE NUMBER OF LATITUDE LINES BETWEEN A POLE
C*                          AND THE EQUATOR.
C*                11        SCANNING MODE FLAGS (CODE TABLE 8)
C*
C*                WORD      SPHERICAL HARMONICS
C*                ----      -------------------
C*                  1       DATA REPRESENTATION TYPE (CODE TABLE 6)
C*                  2       J - PENTAGONAL RESOLUTION PARAMETER
C*                  3       K - PENTAGONAL RESOLUTION PARAMETER
C*                  4       M - PENTAGONAL RESOLUTION PARAMETER
C*                  5       REPRESENTATION TYPE (CODE TABLE 9)
C*                  6       REPRESENTATION MODE (CODE TABLE 10)
C*                7-11      NOT USED
C*
C*
C*                USE FOR OTHER DATA REPRESENTATION TYPES IS
C*                TO BE DEFINED LATER.
C*
C*                FVERT  - REAL ARRAY OF VERTICAL COORDINATE PARAMETERS
C*                ILENV  - LENGTH OF THIS ARRAY (NUMBER OF COORDINATE
C*                         PARAMETERS).
C*
C*                USED FOR HYBRID LEVELS ONLY.
C*
C*
C*                PARAMETERS FOR BLOCK 3 , BIT-MAP DEFINITION BLOCK.
C*                --------------------------------------------------
C*
C*                TO BE DEFINED LATER.
C*
C*                PARAMETERS FOR BLOCK 4 , BINARY DATA BLOCK.
C*                -------------------------------------------
C*                FPDATA  - ARRAY OF FLOATING POINT VALUES.
C*
C*                          ****
C*                              VALUES IN THIS ARRAY ARE OVERWRITTEN
C*                              BY THE SUBROUTINE.
C*                                                              ****
C*
C*                ILENF   - LENGTH OF THIS ARRAY (NUMBER OF DATA
C*                          VALUES TO BE CODED)
C*                IBITS   - NUMBER OF BITS FOR CODED DATA VALUES.
C*
C*                          TO INDICATE MISSING DATA VALUES, ILENF IS
C*                          MADE NEGATIVE AND ALL DATA VALUES SET TO 0.
C*
C*                OTHER PARAMETERS
C*                ----------------
C*
C*                NBIT    - NUMBER OF BITS IN COMPUTER WORD.
C*
C*                IGRIB   - ARRAY TO RECEIVE DATA IN GRIB CODE.
C*                ILENG   - LENGTH OF THIS ARRAY.
C*
C*                IROUND  - 0 , NO ROUNDING.
C*                          1 , ROUND TO NEAREST 120 OCTETS.
C*
C*    OUTPUT    : IGRIB   - DATA CODED IN GRIB CODE.
C*                IWORD   - NUMBER OF WORDS OCCUPIED BY CODED DATA.
C*
C*                IERR    - ERROR INDICATOR.
C*
C*                           0, NO ERROR.
C*
C*                          -1, NUMBER OF BITS PER DATA VALUE EXCEEDS
C*                              WORD LENGTH, OR MAXIMUM ALLOWED.
C*                          -2, OUTPUT ARRAY TOO SMALL TO HOLD CODED
C*                              DATA VALUES.
C*                          -3, CURRENTLY UNDEFINED OPTION SELECTED.
C*                          -4, MISSING DATA FIELD CONTAINS NON-ZERO.
C*
C*                           1, INVALID ORIGINATING CENTRE.
C*                           2, INVALID MODEL IDENTIFICATION.
C*                           3, INVALID GRID DEFINITION.
C*                           4, INVALID BLOCK INDICATOR FLAG
C*                           5, INVALID PARAMETER IDENTIFIER.
C*                           6, INVALID LEVEL TYPE INDICATOR.
C*                           7, ERROR IN DESCRIPTION OF LEVELS.
C*                           8, DATE/TIME ERROR.
C*                           9, INVALID TIME UNIT OR RANGE.
C*                          10, INVALID DATA REPRESENTATION TYPE.
C*                          11, INVALID EXTREME POINT/INCREMENT FLAG.
C*                          12, INVALID SCANNING MODE FLAGS.
C*
C*    JOHN HENNESSY , ECMWF , NOVEMBER 1985
C*
C*
C----<
C     ---------------------------------------------------------------
C
C
C
C
C
C
      DIMENSION FPDATA(ILENF),ILAT(2)
      DIMENSION IGRIB(ILENG),IBLOCK(24),IBMAP(IBLEN)
      DIMENSION FVERT(ILENV),IB1PAR(18),IB2PAR(11),IB3PAR(2)
C
      EQUIVALENCE (ZGRIB,JGRIB)
C
C
C     SET MAXIMUM NUMBER OF BITS PER DATA FIELD.
C
      DATA IMAX /32/
C
C     CLEAR ERROR INDICATOR.
C
      IERR = 0
C
C
C
C
C
C********************************************************************
C*
C*    CHECK FOR MISSING DATA INDICATORS.
C*
C********************************************************************
C
C
      IMISS = 0
      IF (ILENF.LT.0)
     C   THEN
             KLENF = - ILENF
             IMISS = 1
             DO 50 I=1,KLENF
                IF (FPDATA(I).NE.0.)
     C             THEN
                       IERR = -4
                       WRITE (*,9012)
 9012                  FORMAT (1H ,'NON-ZERO VALUE IN MISSING DATA',
     C                          ' FIELD.')
                       RETURN
                   ENDIF
   50        CONTINUE
         ELSE
             KLENF = ILENF
         ENDIF
C
C
C
C
C********************************************************************
C*
C*    CHECK NUMBER OF BITS PER DATA FIELD.
C*
C********************************************************************
C
C
      IF (IBITS.GT.NBIT.OR.IBITS.GT.IMAX)
     C    THEN
              IERR = -1
              WRITE (*,9000) IBITS,NBIT,IMAX
 9000         FORMAT (1H ,'NUMBER OF BITS PER DATA VALUE, ',I3,
     C                'EXCEEDS WORD LENGTH, ',I3,' OR MAXIMUM ',
     C                ' PERMITTED VALUE, ',I3)
              RETURN
          ENDIF
C
C
C
C
C
C
C
C
C
C
C
C********************************************************************
C*
C*    BLOCK 0 - INDICATOR BLOCK.
C*
C********************************************************************
C
C
C
C***
C*    THE LETTERS G R I B ARE INSERTED IN THE
C*    FIRST 4 ELEMENTS OF 'IBLOCK'.
C***
C
      IBLOCK(1) = 71
      IBLOCK(2) = 82
      IBLOCK(3) = 73
      IBLOCK(4) = 66
C
      IWORD = 1
      IBYTE = 8
      NVAL  = 4
      IOFF  = 0
C
C     PACK 4 8-BIT FIELDS IN BLOCK 0 OF CODED ARRAY.
C
      CALL SBYTES (IGRIB(IWORD),IBLOCK(1),IOFF,IBYTE,0,NVAL)
      CALL OFFSET (IOFF,NVAL,IWORD,IBYTE,NBIT,ILENG,IERR)
      IF (IERR.NE.0) RETURN
C
C
C
C
C
C
C
C
C********************************************************************
C*
C*    BLOCK 1 - PRODUCT DEFINITION BLOCK.
C*
C********************************************************************
C
C
C
C***
C*    LENGTH OF BLOCK 1 (IN OCTETS) IN FIRST 3 OCTETS.
C***
C
      IBLOCK(1) = 0
      IBLOCK(2) = 0
      IBLOCK(3) = 24
C
C
C
C
C***
C*    FOURTH OCTET RESERVED AND SET TO 0.
C***
C
      IBLOCK(4) = 0
C
C
C
C
C
C
C***
C*    IDENTIFICATION OF CENTRE
C***
      IBLOCK(5) = IB1PAR(1)
      IF (IB1PAR(1).LT.1.OR.IB1PAR(1).GT.98)
     C   THEN
             IERR = 1
             WRITE (*,9001) IB1PAR(1)
 9001        FORMAT (1H ,'INVALID ORIGINATING CENTRE ',I3)
             RETURN
         ENDIF
C
C
C
C
C
C
C
C***
C*    MODEL IDENTIFICATION
C***
C
      IBLOCK(6) = IB1PAR(2)
      IF (IB1PAR(2).LT.1.OR.IB1PAR(2).GT.255)
     C   THEN
             IERR = 2
             WRITE (*,9002) IB1PAR(2)
 9002        FORMAT (1H ,'INVALID MODEL IDENTIFICATION ',I4)
             RETURN
         ENDIF
C
C
C
C
C
C
C
C
C***
C*    GRID DEFINITION
C***
C
      IBLOCK(7) = IB1PAR(3)
      IF (IB1PAR(3).LT.1.OR.IB1PAR(3).GT.255)
     C   THEN
             IERR = 3
             WRITE (*,9003) IB1PAR(3)
 9003        FORMAT (1H ,'INVALID GRID IDENTIFICATION ',I4)
             RETURN
         ENDIF
C
C
C
C
C
C
C
C
C***
C*    OPTIONAL BLOCK INDICATOR FLAGS ( CODE TABLE 1 ).
C***
C
C     BLOCKS INCLUDED    BINARY VALUE      DECIMAL VALUE
C
C         NONE             00000000               0
C          2               10000000             128
C          3               01000000              64
C         2 AND 3          11000000             192
C
      IBLOCK(8) = IB1PAR(4)
C
C     SHIFT 2-BIT FLAG FIELD RIGHT BY 6 BITS TO FACILITATE CHECKING
C
      KTEMP = IB1PAR(4) / 64
C
      IF (KTEMP.LT.0.OR.KTEMP.GT.3)    IERR = 4
C
C     CHECK IF GRID SPECIFIED IS UNCATALOGUED.
C
      IF (IB1PAR(3).EQ.255.AND.IB1PAR(4).EQ.0)  IERR = 4
      IF (IB1PAR(3).EQ.255.AND.IB1PAR(4).EQ.64) IERR = 4
C
      IF (IERR.NE.0)
     C   THEN
             CALL PRTBIN (IB1PAR(4),8,KTEMP,ERR)
             WRITE (*,9004) KTEMP
 9004        FORMAT (1H ,'INVALID BLOCK INDICATOR FLAG ',I8.8)
             RETURN
         ENDIF
C
C
C
C
C***
C*    PARAMETER IDENTIFIER ( CODE TABLE 2 ).
C***
C
      IBLOCK(9) = IB1PAR(5)
      IF (IB1PAR(5).LT.0.OR.IB1PAR(5).GT.255)
     C   THEN
             IERR = 5
             WRITE (*,9005) IB1PAR(5)
 9005        FORMAT (1H ,'INVALID PARAMETER ',I4)
             RETURN
         ENDIF
C
C
C
C
C***
C*    INDICATOR OF LEVEL TYPE ( CODE TABLE 3 ).
C***
C
      IBLOCK(10) = IB1PAR(6)
C
C*    CODE FIGURES FOR LEVEL TYPE RANGE FROM 0 - 110, WITH 200
C     BEING USED FOR PSEUDO-LEVELS.
C
      IF (IB1PAR(6).LT.0.OR.IB1PAR(6).GT.110) IERR = 6
      IF (IB1PAR(6).EQ.200) IERR = 0
      IF (IERR.EQ.6)
     C   THEN
             WRITE (*,9006) IB1PAR(6)
 9006        FORMAT (1H ,'INVALID LEVEL TYPE ',I4)
             RETURN
         ENDIF
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C***
C*    DESCRIPTION OF LEVEL OR LAYER ( CODE TABLE 3 ).
C***
C
C
C
C     FOR CERTAIN SPECIAL LEVELS NO FURTHER DESCRIPTION IS
C     NECESSARY, AND THE FIELDS ARE SET TO 0.
C
      IF (IB1PAR(6).LT.100.OR.IB1PAR(6).EQ.102)
     C    THEN
              IB1PAR(7) = 0
              IB1PAR(8) = 0
          ENDIF
C
      IBLOCK(11) = IB1PAR(7)
      IBLOCK(12) = IB1PAR(8)
C
C     CERTAIN LEVEL TYPES REQUIRE THAT THE DESCRIPTION OCCUPY
C     BOTH 8 BIT FIELDS.
C
      IF (IB1PAR(6).EQ.100.OR.IB1PAR(6).EQ.103.OR.IB1PAR(6).EQ.105.
     C    OR.IB1PAR(6).EQ.107.OR.IB1PAR(6).EQ.109)
     C    THEN
C             8 LOW ORDER BITS IN IBLOCK(12)
C             HIGH ORDER BITS IN IBLOCK(11)
C
              IBLOCK(12) = IBLOCK(11)
              IBLOCK(11) = IBLOCK(11) / 256
              IBLOCK(12) = IBLOCK(12) - IBLOCK(11) * 256
C
C             CHECK MAXIMUM POSSIBLE IN 16 BITS.
C
              IF (IB1PAR(7).GT.65535) IERR = 7
          ELSE
              IF (IB1PAR(7).GT.255.OR.IB1PAR(8).GT.255) IERR = 7
          ENDIF
C
      IF (IERR.NE.0)
     C    THEN
              WRITE (*,9007) IB1PAR(7),IB1PAR(8)
 9007         FORMAT (1H ,'LEVEL DESCRIPTION ERROR ',I8,3X,I8)
              RETURN
          ENDIF
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C***
C*    DATE AND TIME. CHECK VALID RANGES AND MISSING DATA VALUES.
C***
C
      IBLOCK(13) = IB1PAR(9)
      IERY = 0
      IF (IB1PAR(9).LT.0.OR.IB1PAR(9).GT.99) IERY = 1
      IF (IB1PAR(9).EQ.255) IERY = 0
      IBLOCK(14) = IB1PAR(10)
      IERM = 0
      IF (IB1PAR(10).LT.1.OR.IB1PAR(10).GT.12) IERM = 1
      IF (IB1PAR(10).EQ.255) IERM = 0
      IBLOCK(15) = IB1PAR(11)
      IERD = 0
      IF (IB1PAR(11).LT.1.OR.IB1PAR(11).GT.31) IERD = 1
      IF (IB1PAR(11).EQ.255) IERD = 0
      IBLOCK(16) = IB1PAR(12)
      IERH = 0
      IF (IB1PAR(12).LT.0.OR.IB1PAR(12).GT.23) IERH = 1
      IF (IB1PAR(12).EQ.255) IERH = 0
      IBLOCK(17) = IB1PAR(13)
      IERN = 0
      IF (IB1PAR(13).LT.0.OR.IB1PAR(13).GT.59) IERN = 1
      IF (IB1PAR(13).EQ.255) IERN = 0
C
      IERR = IERY + IERM + IERD + IERH + IERN
C
      IF (IERR.NE.0)
     C    THEN
              IERR = 8
              WRITE (*,9008) IB1PAR(9),IB1PAR(10),IB1PAR(11),IB1PAR(12),
     C                       IB1PAR(13)
 9008         FORMAT (1H ,'INVALID DATE/TIME ',3I2,' / ',2I2)
              RETURN
          ENDIF
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C***
C*    UNIT OF TIME - ( CODE TABLE 4 ).
C*    TIME RANGE(S) AND TIME RANGE INDICATOR ( CODE TABLE 5 ).
C***
C
C     TIME UNIT.
C
      IBLOCK(18) = IB1PAR(14)
      IF (IB1PAR(14).LT.0.OR.IB1PAR(14).GT.7) IERR = 9
C
C*    TIME UNIT CODES ARE IN THE RANGE 0 - 7, WITH 254 USED FOR SECONDS.
C
      IF (IB1PAR(14).EQ.254) IERR = 0
C
C     THERE CAN BE ONE OR TWO TIME RANGES, EACH IN 1 OCTECT OR
C     ONE TIME RANGE IN 2 OCTECTS.
C
      IF (IB1PAR(17).EQ.0.OR.IB1PAR(17).EQ.1
     C .OR.IB1PAR(17).EQ.10)   IB1PAR(16)  = 0
C
C     CROSS CHECK RANGE VALUES AND FLAG VALUES.
C
      IF (IB1PAR(15).GT.65535.OR.IB1PAR(15).LT.0)   IERR = 9
      IF (IB1PAR(15).GT.255.AND.IB1PAR(17).NE.10)   IERR = 9
      IF (IB1PAR(16).GT.255.OR.IB1PAR(16).LT.0)     IERR = 9
      IF (IB1PAR(17).LT.0.OR.IB1PAR(17).GT.10)      IERR = 9
      IF (IERR.NE.0)
     C    THEN
              WRITE (*,9009) IB1PAR(14),IB1PAR(15),IB1PAR(16),IB1PAR(17)
 9009         FORMAT (1H ,'TIME UNIT/TIME 1/TIME 2/INDICATOR ERROR - ',
     C                I8,2X,'/',I8,2X,'/',I8,2X,'/',I8)
              RETURN
          ENDIF
C
      IBLOCK(19) = IB1PAR(15)
      IBLOCK(20) = IB1PAR(16)
C
C     ONE TIME RANGE OCCUPYING BOTH OCTETS.
C
      IF (IB1PAR(17).EQ.10)
     C   THEN
C            8 LOW ORDER BITS IN IBLOCK(20)
C            HIGH ORDER BITS IN IBLOCK(19)
C
             IBLOCK(20) = IBLOCK(19)
             IBLOCK(19) = IBLOCK(19) / 256
             IBLOCK(20) = IBLOCK(20) - IBLOCK(19) * 256
         ENDIF
C
C     TIME RANGE INDICATOR
C
      IBLOCK(21) = IB1PAR(17)
C
C
C
C
C
C
C
C***
C*    NUMBER AVERAGED.
C***
C
      IBLOCK(22) = 0
      IBLOCK(23) = 0
C
C
C     CHECK CONSISTENCY INDICATOR AND NUMBER FIELD.
C
      IF (IB1PAR(17).EQ.3.AND.IB1PAR(18).EQ.0)
     C   THEN
             IERR = 12
             WRITE (*,9013) IB1PAR(17),IB1PAR(18)
 9013        FORMAT (1H ,'INDICATOR/NUMBER AVERAGED ERROR - ',
     C                I8,2X,'/',I8)
             RETURN
         ENDIF
C
C     VALUE IN TWO OCTETS.
C
      IBLOCK(22) = IB1PAR(18)
C
C     8 LOW ORDER BITS IN IBLOCK(23)
C     HIGH ORDER BITS IN IBLOCK(22)
C
      IBLOCK(23) = IBLOCK(22)
      IBLOCK(22) = IBLOCK(22) / 256
      IBLOCK(23) = IBLOCK(23) - IBLOCK(22) * 256
C
C
C
C
C
C
C***
C*    RESERVED ELEMENT.
C***
C
      IBLOCK(24) = 0
C
C
C
C
C
C
C
C***
C*
C*    PACK 24 8-BIT FIELDS OF BLOCK 1 IN CODED ARRAY.
C*
C***
C
      IBYTE = 8
      NVAL = 24
C
      CALL SBYTES (IGRIB(IWORD),IBLOCK(1),IOFF,IBYTE,0,NVAL)
      CALL OFFSET (IOFF,NVAL,IWORD,IBYTE,NBIT,ILENG,IERR)
      IF (IERR.NE.0) RETURN
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C********************************************************************
C*
C*    BLOCK 2 - GRID DESCRIPTION BLOCK.
C*
C********************************************************************
C
C
C
C
C***
C*    SET ARRAY IBLOCK TO 0 . IT IS USED TO ZERO FILL RESERVED OCTETS.
C***
C
      DO 100 I=1,24
         IBLOCK(I) = 0
  100 CONTINUE
C
C
C
C
C***
C*    LAT/LONGITUDE GRID, GAUSSIAN GRID AND SPHERICAL HARMONICS
C*    ARE THE ONLY DATA REPRESENTATIONS HANDLED.
C***
C
      IF (IB1PAR(4).EQ.128.OR.IB1PAR(4).EQ.192)
     C   THEN
             IF (IB2PAR(1).NE.0.AND.IB2PAR(1).NE.4.AND.IB2PAR(1).NE.50)
     C          THEN
                     WRITE (*,*)'GRID DESCRIPTION BLOCK NOT YET DEFINED'
                     IERR = -3
                     RETURN
                ENDIF
C
C
C
C
C***
C*       LENGTH OF GRID DESCRIPTION BLOCK.
C***
C
C        LENGTH IS 32 OCTETS FOR LAT/LONG, GAUSSIAN AND SPHERICAL
C        HARMONICS . FOR ANY DATA  ON HYBRID LEVELS THE
C        VERTICAL COORDINATES ARE ADDED.
C
         I = 32
         IF (IB1PAR(6).GT.108) I = I + ILENV * 4
C
         CALL SBYTE (IGRIB(IWORD),I,IOFF,24)
         CALL OFFSET (IOFF,1,IWORD,24,NBIT,ILENG,IERR)
         IF (IERR.NE.0) RETURN
C
C
C
C
C***
C*       NUMBER OF UNUSED BITS AT END OF BLOCK.
C*       CURRENT DEFINITION IMPLIES 0.
C***
C
         CALL SBYTE (IGRIB(IWORD),IBLOCK(1),IOFF,8)
         CALL OFFSET (IOFF,1,IWORD,8,NBIT,ILENG,IERR)
         IF (IERR.NE.0) RETURN
C
C
C
C
C
C***
C*       NEXT OCTET IS RESERVED.
C***
C
         CALL SBYTE (IGRIB(IWORD),IBLOCK(1),IOFF,8)
         CALL OFFSET (IOFF,1,IWORD,8,NBIT,ILENG,IERR)
         IF (IERR.NE.0) RETURN
C
C
C
C
C
C
C***
C*       DATA REPRESENTATION TYPE.
C***
C
         IF (IB2PAR(1).LT.0.OR.IB2PAR(1).GT.4) IERR = 10
         IF (IB2PAR(1).EQ.50) IERR = 0
         IF (IERR.NE.0)
     C      THEN
                IERR = 10
                WRITE (*,9010) IB2PAR(1)
 9010           FORMAT (1H ,'INVALID DATA REPRESENTATION TYPE - ',I3)
                RETURN
            ENDIF
         CALL SBYTE (IGRIB(IWORD),IB2PAR(1),IOFF,8)
         CALL OFFSET (IOFF,1,IWORD,8,NBIT,ILENG,IERR)
         IF (IERR.NE.0) RETURN
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C***
C*       LAT/LONG OR GAUSSIAN GRID.
C***
C
         IF (IB2PAR(1).EQ.0.OR.IB2PAR(1).EQ.4)
     C    THEN
C
C            NUMBER OF LAT/LONG POINTS.
C
             CALL SBYTES (IGRIB(IWORD),IB2PAR(2),IOFF,16,0,2)
             CALL OFFSET (IOFF,2,IWORD,16,NBIT,ILENG,IERR)
             IF (IERR.NE.0) RETURN
C
C            LAT/LONG OF ORIGIN.
C            SIGN BIT SET TO 1 IF VALUES ARE NEGATIVE.
C
             DO 200 I=1,2
                ILAT(I) = IB2PAR(I+3)
                ISIGN   = 0
                IF (ILAT(I).LT.0)
     C            THEN
                      ISIGN   = 8388608
                      ILAT(I) = - ILAT(I)
                  ENDIF
                ILAT(I) = ILAT(I) + ISIGN
  200        CONTINUE
C
             CALL SBYTES (IGRIB(IWORD),ILAT(1),IOFF,24,0,2)
             CALL OFFSET (IOFF,2,IWORD,24,NBIT,ILENG,IERR)
             IF (IERR.NE.0) RETURN
C
C            RESOLUTION FLAG.
C
C            INCREMENTS       BINARY CODE     DECIMAL VALUE
C
C             NOT GIVEN        00000000              0
C              GIVEN           10000000            128
C
C
C            SHIFT 1 BIT FLAG FIELD TO LOW ORDER BIT
C
             KTEMP = IB2PAR(6) / 128
C
             IF (KTEMP.LE.0.OR.KTEMP.GT.1)
     C          THEN
                    CALL PRTBIN (IB2PAR(6),8,KTEMP,ERR)
                    WRITE (*,9011) KTEMP
 9011               FORMAT (1H ,'INVALID RESOLUTION FLAG ',I8.8)
                    IERR = 11
                    RETURN
                ENDIF
C
C            SET TO ALL 1-BITS UNUSED INCREMENT FIELDS.
C
             IF (IB2PAR(6).EQ.0)
     C          THEN
C                   1111111111111111 BINARY = 65535 DECIMAL
                    IB2PAR(9)  = 65535
                    IB2PAR(10) = 65535
                ENDIF
C
             CALL SBYTE (IGRIB(IWORD),IB2PAR(6),IOFF,8)
             CALL OFFSET (IOFF,1,IWORD,8,NBIT,ILENG,IERR)
             IF (IERR.NE.0) RETURN
C
C            LAT/LONG OF EXTREME POINT.
C
C            SIGN BIT SET TO 1 IF VALUES ARE NEGATIVE.
C
             DO 300 I=1,2
                ILAT(I) = IB2PAR(I+6)
                ISIGN   = 0
                IF (ILAT(I).LT.0)
     C            THEN
                      ISIGN   = 8388608
                      ILAT(I) = - ILAT(I)
                  ENDIF
                ILAT(I) = ILAT(I) + ISIGN
  300        CONTINUE
C
             CALL SBYTES (IGRIB(IWORD),ILAT(1),IOFF,24,0,2)
             CALL OFFSET (IOFF,2,IWORD,24,NBIT,ILENG,IERR)
             IF (IERR.NE.0) RETURN
C
C
C
C            DIRECTION INCREMENTS / NUMBER OF LATITUDE LINES.
C
             CALL SBYTES (IGRIB(IWORD),IB2PAR(9),IOFF,16,0,2)
             CALL OFFSET (IOFF,2,IWORD,16,NBIT,ILENG,IERR)
             IF (IERR.NE.0) RETURN
C
C            SCANNING MODE FLAGS.
C
C            VALID VALUES       VALUE / 32
C             BINARY             DECIMAL
C
C              00000000               0
C              10000000               4
C              01000000               2
C              11000000               6
C              00100000               1
C              10100000               5
C              01100000               3
C              11100000               7
C
C            SHIFT 3 BIT FLAG FIELD TO LOW ORDER BITS.
C
             KTEMP = IB2PAR(11) / 32
C
             IF (KTEMP.LT.0.OR.KTEMP.GT.7)
     C          THEN
                    CALL PRTBIN (IB2PAR(11),8,KTEMP,ERR)
                    WRITE (*,9014) KTEMP
 9014               FORMAT (1H ,'INVALID SCANNING MODE FLAGS ',I8.8)
                    IERR = 12
                    RETURN
                ENDIF
C
             CALL SBYTE (IGRIB(IWORD),IB2PAR(11),IOFF,8)
             CALL OFFSET (IOFF,1,IWORD,8,NBIT,ILENG,IERR)
             IF (IERR.NE.0) RETURN
C
C            4 RESERVED OCTETS.
C
             CALL SBYTES (IGRIB(IWORD),IBLOCK(1),IOFF,8,0,4)
             CALL OFFSET (IOFF,4,IWORD,8,NBIT,ILENG,IERR)
             IF (IERR.NE.0) RETURN
C
          ENDIF
C
C
C
C
C
C
C
C
C
C
C
C***
C*       SPHERICAL HARMONIC DATA.
C***
C
         IF (IB2PAR(1).EQ.50)
     C    THEN
C
C            PENTAGONAL RESOLUTION PARAMETERS.
C
             CALL SBYTES (IGRIB(IWORD),IB2PAR(2),IOFF,16,0,3)
             CALL OFFSET (IOFF,3,IWORD,16,NBIT,ILENG,IERR)
             IF (IERR.NE.0) RETURN
C
C            REPRESENTATION TYPE AND MODE.
C
             CALL SBYTES (IGRIB(IWORD),IB2PAR(5),IOFF,8,0,2)
             CALL OFFSET (IOFF,2,IWORD,8,NBIT,ILENG,IERR)
             IF (IERR.NE.0) RETURN
C
C            18 RESERVED OCTETS.
C
             CALL SBYTES (IGRIB(IWORD),IBLOCK(1),IOFF,8,0,18)
             CALL OFFSET (IOFF,18,IWORD,8,NBIT,ILENG,IERR)
             IF (IERR.NE.0) RETURN
C
          ENDIF
C
C
C
C
C***
C*       ADD VERTICAL COORDINATE PARAMETERS FOR HYBRID LEVELS.
C***
C
         IF (IB1PAR(6).GT.108)
     C    THEN
             DO 400 I=1,ILENV
                 CALL CONFP (FVERT(I),IEXP,IMANT)
                 CALL SBYTE (IGRIB(IWORD),IEXP,IOFF,8)
                 CALL OFFSET (IOFF,1,IWORD,8,NBIT,ILENG,IERR)
                 IF (IERR.NE.0) RETURN
                 CALL SBYTE (IGRIB(IWORD),IMANT,IOFF,24)
                 CALL OFFSET (IOFF,1,IWORD,24,NBIT,ILENG,IERR)
                 IF (IERR.NE.0) RETURN
  400        CONTINUE
C
          ENDIF
C
         ENDIF
C
C
C
C
C
C
C
C
C
C********************************************************************
C*
C*    BLOCK 3 (IF REQUIRED) - BIT MAP BLOCK.
C*
C********************************************************************
C
      IF (IB1PAR(4).EQ.64.OR.IB1PAR(4).EQ.192)
     C     THEN
C***
C*            SET UP  LENGTH OG BLOCK 3.
C***
              NUB=0
              NGRD=IB2PAR(2)*IB2PAR(3)
              NOCT=NGRD/8
              IBOF=NGRD-NOCT*8
C
              IF(IBOF.NE.0) THEN
                               NUB=8-IBOF
                               NOCT=NOCT+1
                            END IF
C
              IF(MOD(NOCT,2).NE.0) THEN
                                      NUB=NUB+8
                                      NOCT=NOCT+1
                                   END IF
C
              ILEN3=NOCT+6
C
              CALL SBYTE(IGRIB(IWORD),ILEN3,IOFF,24)
              CALL OFFSET(IOFF,1,IWORD,24,NBIT,ILENG,IERR)
              IF(IERR.NE.0) RETURN
C
C*            SET UP NUMBER OF UNUSED BITS AT THE END OF BLOCK.
C
              CALL SBYTE(IGRIB(IWORD),NUB,IOFF,8)
              CALL OFFSET(IOFF,1,IWORD,8,NBIT,ILENG,IERR)
              IF(IERR.NE.0) RETURN
C
C*            SET OCTET 5-6 OCTET (NUMERIC).
C
              CALL SBYTE(IGRIB(IWORD),0,IOFF,16)
              CALL OFFSET(IOFF,1,IWORD,16,NBIT,ILENG,IERR)
              IF(IERR.NE.0) RETURN
C
C*            SET UP BIT MAP.
C
              DO 310 J=1,IBLEN
C
              CALL SBYTE(IGRIB(IWORD),IBMAP(J),IOFF,1)
              CALL OFFSET(IOFF,1,IWORD,1,NBIT,ILENG,IERR)
              IF(IERR.NE.0) RETURN
C
 310  CONTINUE
C
C*            SET UP UNUSED BITS.
C
              CALL SBYTES(IGRIB(IWORD),0,IOFF,1,0,NUB)
              CALL OFFSET(IOFF,NUB,IWORD,1,NBIT,ILENG,IERR)
              IF(IERR.NE.0) RETURN
           ENDIF
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C********************************************************************
C*
C*    BLOCK 4 - BINARY DATA BLOCK.
C*
C********************************************************************
C
C
C***
C*    RETAIN POINTERS TO WORD AND BIT POSITION OF BINARY DATA
C*    BLOCK LENGTH FIELD. ENTER LENGTH AS 0.
C***
C
      IPW = IWORD
      IPB = IOFF
C
      CALL SBYTE (IGRIB(IWORD),IBLOCK(1),IOFF,24)
      CALL OFFSET (IOFF,1,IWORD,24,NBIT,ILENG,IERR)
      IF (IERR.NE.0) RETURN
C
C
C
C
C
C
C
C
C
C
C
C***
C*    4 BIT FLAG / 4 BIT COUNT OF UNUSED BITS AT END OF BLOCK OCTET.
C***
C
C     FLAG IS 1000 FOR SPHERICAL HARMONICS, 0000 FOR LAT/LONG
C     OR GAUSSIAN GRID.
C
      IREP = 0
      IF (IB2PAR(1).EQ.50) IREP = 1
C
C     FLAG FIELD IS IREP SHIFTED LEFT BY 7 BITS
C
      IFLAG = IREP * 128
C
      CALL SBYTE (IGRIB(IWORD),IFLAG,IOFF,8)
      CALL OFFSET (IOFF,1,IWORD,8,NBIT,ILENG,IERR)
      IF (IERR.NE.0) RETURN
C
C
C
C
C
C
C
C
C
C
C
C***
C*    FIND MAXIMUM AND MINIMUM VALUES IN DATA ARRAY. FOR
C*    DATA IN SPHERICAL HARMONIC FORM THE FIRST WORD CONTAINS
C*    THE REAL (0,0)COEFFICIENT, WHICH IS TREATED SEPARATELY.
C***
C
C
      ILEN = KLENF - IREP
      CALL MXMN (FPDATA(IREP+1),ILEN,FMAX,FMIN)
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C***
C*    SCALE FACTOR.
C***
C
C     CALCULATE SCALE FACTOR
C
      S = (FMAX-FMIN)/(2**(IBITS+1)-1)
      IF (S.NE.0.) S = ALOG(S)/ALOG(2.) + 2.
      ISCALE = MIN(INT(S),INT(S+SIGN(1.,S)))
C
C
C
C
C     SET SIGN BIT (BIT 16) AND PUT SCALE FACTOR INTO REMAINING
C     15 BITS OF CODED 16 BIT FIELD.
C
      JSCALE = ISCALE
      ISIGN = 0
      IF (JSCALE.LT.0)
     C    THEN
              ISIGN  = 32768
              JSCALE = - JSCALE
          ENDIF
      JSCALE = JSCALE + ISIGN
C
      ZSCALE = 2.**ISCALE
C
C     FOR MISSING DATA SCALE FACTOR IS SET TO ALL 1-BITS.
C
      IF (IMISS.EQ.1) JSCALE = 65535
C
      CALL SBYTE (IGRIB(IWORD),JSCALE,IOFF,16)
      CALL OFFSET (IOFF,1,IWORD,16,NBIT,ILENG,IERR)
      IF (IERR.NE.0) RETURN
C
C
C
C
C
C
C
C
C
C***
C*    MINIMUM (REFERENCE) VALUE.
C***
C
C     CONVERT MINIMUM VALUE (FMIN) TO GRIB FORMAT (IEXP,IMANT)
C
      CALL CONFP (FMIN,IEXP,IMANT)
C
C     EXPONENT AND MANTISSA SET TO ALL 1-BITS FOR MISSING DATA.
C
      IF (IMISS.EQ.1)
     C   THEN
             IEXP  = 255
             IMANT = 16777215
         ENDIF
      CALL SBYTE (IGRIB(IWORD),IEXP,IOFF,8)
      CALL OFFSET (IOFF,1,IWORD,8,NBIT,ILENG,IERR)
      IF (IERR.NE.0) RETURN
      CALL SBYTE (IGRIB(IWORD),IMANT,IOFF,24)
      CALL OFFSET (IOFF,1,IWORD,24,NBIT,ILENG,IERR)
      IF (IERR.NE.0) RETURN
C
C
C
C
C***
C*    NUMBER OF BITS IN EACH DATA VALUE.
C***
C
      CALL SBYTE (IGRIB(IWORD),IBITS,IOFF,8)
      CALL OFFSET (IOFF,1,IWORD,8,NBIT,ILENG,IERR)
      IF (IERR.NE.0) RETURN
C
C
C
C
C***
C*    IF SPHERICAL HARMONICS DATA, NEXT 4 OCTETS ARE DIFFERENT FORMAT.
C***
C
      IF (IREP.EQ.1)
     C    THEN
C
C            STORE REAL (0,0) COEFFICIENT IN FLOATING
C            POINT FORM.
C
             CALL CONFP (FPDATA(1),IEXP,IMANT)
C
             CALL SBYTE (IGRIB(IWORD),IEXP,IOFF,8)
             CALL OFFSET (IOFF,1,IWORD,8,NBIT,ILENG,IERR)
             IF (IERR.NE.0) RETURN
             CALL SBYTE (IGRIB(IWORD),IMANT,IOFF,24)
             CALL OFFSET (IOFF,1,IWORD,24,NBIT,ILENG,IERR)
             IF (IERR.NE.0) RETURN
          ENDIF
C
C
C
C
C***
C*    SCALE AND STORE DATA VALUES.
C***
C
      DO 600 I = IREP+1 , KLENF
         JGRIB     = NINT ( (FPDATA(I)-FMIN) / ZSCALE )
         FPDATA(I) = ZGRIB
  600 CONTINUE
C
      ILENFM = KLENF - IREP
      CALL SBYTES (IGRIB(IWORD),FPDATA(IREP+1),IOFF,IBITS,0,ILENFM)
      CALL OFFSET (IOFF,ILENFM,IWORD,IBITS,NBIT,ILENG,IERR)
      IF (IERR.NE.0) RETURN
C
C
C
C
C
C
C
C
C
C
C
C***
C*    ENTER LENGTH OF BINARY DATA BLOCK, HAVING ENSURED THAT
C*    THE LENGTH IS AN EVEN NUMBER OF OCTETS.
C***
C
C     LENGTH OF BINARY DATA BLOCK IN BITS.
C
      LBIN = (IWORD-IPW) * NBIT + IOFF - IPB
C
      L = LBIN / 16
      L = LBIN - ( L*16 )
C
C     FILL UNUSED PORTION OF LAST 2 OCTETS WITH BINARY ZEROES.
C
      LNIL = 0
      IF (L.NE.0)
     C    THEN
              LNIL = 16 - L
              CALL SBYTE (IGRIB(IWORD),IBLOCK(1),IOFF,LNIL)
              CALL OFFSET (IOFF,1,IWORD,LNIL,NBIT,ILENG,IERR)
              IF (IERR.NE.0) RETURN
          ENDIF
C
      LBIN = (IWORD-IPW) * NBIT + IOFF - IPB
C
C     ENTER LENGTH - IN OCTETS - OF DATA BLOCK.
C
      LBIN = LBIN / 8
      CALL SBYTE (IGRIB(IPW),LBIN,IPB,24)
      CALL OFFSET (IPB,1,IPW,24,NBIT,ILENG,IERR)
C
C     ENTER NUMBER OF UNUSED BITS IN FLAG/BIT COUNT FIELD.
C
      IFLAG = IFLAG + LNIL
      CALL SBYTE (IGRIB(IPW),IFLAG,IPB,8)
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C********************************************************************
C*
C*    BLOCK 5 - END BLOCK.
C*
C********************************************************************
C
C
C***
C*    ADD 7 7 7 7 TO CODED DATA.
C***
C
      IBLOCK(1) = 55
      IBLOCK(2) = 55
      IBLOCK(3) = 55
      IBLOCK(4) = 55
C
      CALL SBYTES (IGRIB(IWORD),IBLOCK(1),IOFF,8,0,4)
      CALL OFFSET (IOFF,4,IWORD,8,NBIT,ILENG,IERR)
      IF (IERR.NE.0) RETURN
C
C
C***
C*    SET ANY UNUSED PART OF LAST WORD TO BINARY ZEROES.
C***
C
      IF (IOFF.NE.0)
     C   THEN
             KBITS = NBIT - IOFF
             CALL SBYTE (IGRIB(IWORD),IBLOCK(1),IOFF,KBITS)
         ELSE
             IWORD = IWORD - 1
         ENDIF
C
C
C
C***
C*    ROUND TO 120 OCTETS, IF REQUIRED.
C***
C
      IF (IROUND.EQ.1)
     C   THEN
             NUMBIT = IWORD * NBIT
             I = NUMBIT / 960
             I = I * 960
             I = NUMBIT - I
             IF (I.NE.0) I = (960 - I) / NBIT
C
             DO 700 J=IWORD+1,IWORD+I
                IGRIB(J) = 0
  700        CONTINUE
C
             IWORD = IWORD + I
         ENDIF
C
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities
C granted to it by virtue of its status as an intergovernmental organisation
C nor does it submit to any jurisdiction.
C

      INTEGER FUNCTION INTOUT( HPARN, INTV, REALV, CHARV)
C
C---->
C**** INTOUT
C
C     Purpose
C     -------
C
C     Change output field parameters in common block.
C
C     Interface
C     ---------
C
C     Input
C     -----
C
C     HPARN - MARS parameter name.
C     INTV  - MARS parameter value(s) (Integer).
C     REALV - MARS parameter value(s) (Real).
C     CHARV - MARS parameter value(s) (Character).
C
C
C     Method
C     ------
C
C     Recognise MARS paramter and reset appropriate common
C     variable value(s).
C
C
C     Externals
C     ---------
C
C     JDEBUG   - Check if debug switched on.
C     IBASINI  - Check basic initialisation of common blocks is done.
C     CHEQUAL  - Compare two ASCII strings without regard to case.
C     INTLOG   - Log error message.
C     IGGLAT   - Compute gaussian latitudes for given truncation.
C
C
C     Author
C     ------
C
C     J.D.Chambers       ECMWF        August 1994.
C
C     Modifications.
C     --------------
C
C     S. Curic      ECMWF      28.05.07
C     added jpeg packing just for merging with grib_api
C
C----<
C
      IMPLICIT NONE
C
C     Parameters
C
      INTEGER JPROUTINE
      PARAMETER (JPROUTINE = 28200)
C
C     Function arguments
C
      CHARACTER*(*) HPARN
      CHARACTER*(*) CHARV
      REAL REALV(*)
      INTEGER INTV(*)
C
#include "parim.h"
#include "nifld.common"
#include "nofld.common"
#include "grfixed.h"
#include "current.h"
C
C     Local variables
C
      INTEGER ITEMP, I, IRET, IFILE1
      LOGICAL LFOUND
      CHARACTER*1 CTEMP
      CHARACTER*8 CTEMP8
C
C     Externals
C
      LOGICAL CHEQUAL, ISOCTAHEDRAL, ISGGVALID
      INTEGER IGGLAT, JINDEX
      EXTERNAL CHEQUAL, ISOCTAHEDRAL, ISGGVALID
      EXTERNAL IGGLAT, JINDEX
C
C     -----------------------------------------------------------------|
C     Section 1.   Initialise
C     -----------------------------------------------------------------|
C
  100 CONTINUE
C
      INTOUT = 0
      LFOUND = .FALSE.
C
C     Check if debug turned on
      CALL JDEBUG()
C
C     Ensures basic initialisation of common blocks is done
      CALL IBASINI(0)
C
      CALL INTLOG(JP_DEBUG, 'INTOUT: option = ' // HPARN ,JPQUIET)
C
C     -----------------------------------------------------------------|
C     Section 2.   Decode request
C     -----------------------------------------------------------------|
C
  200 CONTINUE
C
C     Output grid name.
C     Note: compared to INTOUT('gridname'), rotation is supported
C
      IF( CHEQUAL( HPARN, 1, 8, 'gridname') ) THEN
        CALL INTLOG(JP_DEBUG, 'INTOUT: gridname = '//CHARV,JPQUIET)
        LFOUND = .TRUE.
C
C       Make sure we read a grid type and grid number from input
        I = MIN(8,LEN(CHARV))
        IF( 0.LT.INDEX(CHARV,CHAR(0)) ) I=MIN(I,INDEX(CHARV,CHAR(0))-1)
        IF( 0.LT.INDEX(CHARV,' '    ) ) I=MIN(I,INDEX(CHARV,' '    )-1)
        CTEMP8(1:8) = ' '
        CTEMP8 = CHARV(1:I)
        CTEMP = ' '
        ITEMP = 0
        IF(   .TRUE.   ) READ(CTEMP8,'(A1,I4)',ERR=203) CTEMP, ITEMP
  203   IF( ITEMP.EQ.0 ) READ(CTEMP8,'(A1,I3)',ERR=204) CTEMP, ITEMP
  204   IF( ITEMP.EQ.0 ) READ(CTEMP8,'(A1,I2)',ERR=205) CTEMP, ITEMP
  205   IF( ITEMP.EQ.0 ) READ(CTEMP8,'(A1,I1)',ERR=206) CTEMP, ITEMP
  206   IF( ITEMP.EQ.0 ) THEN
          PRINT *, "INTOUT: Invalid gridname (interpreting CHARV)"
          PRINT *, "  CHARV='"//CHARV//"'"
          PRINT *, "  CTEMP8='"//CTEMP8//"'"
          PRINT *, "  CTEMP='"//CTEMP//"'"
          PRINT *, "  ITEMP=", ITEMP
          IRET   = JPROUTINE + 1
          INTOUT = IRET
          CALL INTLOG(JP_ERROR,
     X      'INTOUT: Invalid gridname: '//TRIM(CTEMP8), JPQUIET)
          GOTO 900
        ENDIF
C
C       Make sure we have a valid grid type, following JGETGG
C       (possible results are [ROF], uppercase)
        IF(     CHEQUAL(CTEMP,1,1,'N') ) THEN
          CTEMP = 'R'
        ELSEIF( CHEQUAL(CTEMP,1,1,'O') ) THEN
          CTEMP = 'O'
        ELSEIF( CHEQUAL(CTEMP,1,1,'F') ) THEN
          CTEMP = 'F'
        ELSE
          IRET   = JPROUTINE + 2
          INTOUT = IRET
          CALL INTLOG(JP_ERROR,
     X      'INTOUT: Invalid gridname: '//TRIM(CTEMP8)//
     X      ' (type "'//TRIM(CTEMP)//'" not recognized)', JPQUIET)
          GOTO 900
        ENDIF
C
C       Make sure we have a valid grid number
        IF( .NOT.ISGGVALID(CTEMP,ITEMP) ) THEN
          IRET   = JPROUTINE + 2
          INTOUT = IRET
          CALL INTLOG(JP_ERROR,
     X      'INTOUT: Invalid grid: '//TRIM(CTEMP8)//
     X      ' (number not recognized)', JPQUIET)
          GOTO 900
        ENDIF
C
C       Generate output grid structure if necessary
        I = JPNOTYPE
        IF( CTEMP.EQ.'F' .AND. .NOT. LNOROTA ) I = JPGAUSSIAN
        IF( CTEMP.EQ.'F' .AND.       LNOROTA ) I = JPFGGROT
        IF( CTEMP.NE.'F' .AND. .NOT. LNOROTA ) I = JPQUASI
        IF( CTEMP.NE.'F' .AND.       LNOROTA ) I = JPQGGROT
        LCHANGE = (NOREPR .EQ.JPNOTYPE) .OR.
     X            (NOREPR .NE.I)        .OR.
     X            (NOGAUSO.NE.ITEMP)    .OR.
     X            (NOGAUSS.NE.ITEMP)    .OR.
     X            (HOGAUST.NE.CTEMP)
        IF( LCHANGE ) THEN
          CALL JGETGG( ITEMP, CTEMP, ROGAUSS, NOLPTS, IRET)
          IF( IRET .NE. 0 ) THEN
            CALL INTLOG(JP_ERROR,
     X        'INTOUT: JGETGG fail for NOGAUSS = ',ITEMP)
            INTOUT = IRET
            GOTO 900
          ENDIF
        ENDIF
        NOGAUSO = ITEMP
        NOGAUSS = ITEMP
        HOGAUST = CTEMP
C
C       Compute first and last latlon grid points
        NOAREA(1) = INT( ROGAUSS(1) * PPMULT )
        NOAREA(2) = 0
        NOAREA(3) = INT( ROGAUSS(NOGAUSS*2) * PPMULT )
        NOAREA(4) = JP360 - JP360/NOLPTS(NOGAUSS)
        NOPCNT = 0
        DO I = 1, NOGAUSS*2
          NOPCNT = NOPCNT + NOLPTS(I)
        ENDDO
C
C       Additional global state variables changes
        LOCTAHEDRAL = CTEMP.EQ.'O'
        IF( CTEMP.EQ.'F' ) THEN
          NOREPR = JPGAUSSIAN
          IF( LNOROTA ) NOREPR = JPFGGROT
        ELSE
          NOREPR = JPQUASI
          IF( LNOROTA ) NOREPR = JPQGGROT
        ENDIF
        LNOREPR = .TRUE.
        LNOGRID = .FALSE.
        NOGRID(1) = 0
        NOGRID(2) = 0
C
        GOTO 900
      ENDIF
C
C     Output grid.
C
      IF( CHEQUAL( HPARN, 1, 4, 'grid') ) THEN
        LFOUND = .TRUE.
C       (Ignore the call if the grid values = 0.)
        IF( (REALV(1) .EQ. 0) .OR. (REALV(2) .EQ. 0) ) GOTO 900
        IF( (NOREPR.NE.JPREGULAR).AND.(NOREPR.NE.JPREGROT) ) THEN
          LCHANGE = .TRUE.
          NOGAUSS = 0
        ENDIF
        IF( LNOROTA ) THEN
          NOREPR  = JPREGROT
        ELSE
          NOREPR  = JPREGULAR
        ENDIF
        LNOREPR = .TRUE.
        CALL INTLOGR(JP_DEBUG, 'INTOUT: grid e-w = ',REALV(1))
        CALL INTLOGR(JP_DEBUG, 'INTOUT: grid n-s = ',REALV(2))
        DO I = 1, 2
          ITEMP = INT( REALV(I)*PPMULT)
          IF( NOGRID(I) .NE. ITEMP ) LCHANGE = .TRUE.
          NOGRID(I) = ITEMP
        ENDDO
        LNOGRID = .TRUE.
        GOTO 900
      ENDIF
C
C     Output regular (gaussian).
C
      IF( CHEQUAL( HPARN, 1, 7, 'regular') ) THEN
        LFOUND = .TRUE.
C       (Ignore the call if the gaussian value = 0.)
        IF( INTV(1) .EQ. 0 ) GOTO 900
        IF( NOREPR .NE. JPGAUSSIAN ) THEN
          LCHANGE = .TRUE.
          NOGRID(1) = 0
          NOGRID(2) = 0
          LNOGRID = .FALSE.
        ENDIF
        IF( LNOROTA ) THEN
          NOREPR  = JPFGGROT
        ELSE
          NOREPR  = JPGAUSSIAN
        ENDIF
        LNOREPR = .TRUE.
        IF( NOGAUSS .NE. INTV(1) ) LCHANGE = .TRUE.
        CALL INTLOG(JP_DEBUG, 'INTOUT: regular = ',INTV(1))
        NOGAUSS = INTV(1)
        LNOGAUS = .TRUE.
        IF( (NOGAUSO.NE.NOGAUSS).OR.(HOGAUST.NE.'F') ) THEN
          CTEMP = 'F'
          CALL JGETGG(NOGAUSS,CTEMP,ROGAUSS,NOLPTS,IRET)
          IF( IRET .NE. 0 ) THEN
            CALL INTLOG(JP_ERROR,
     X        'INTOUT: JGETGG fail for NOGAUSS = ',NOGAUSS)
            INTOUT = IRET
            GOTO 900
          ENDIF
          NOGAUSO = NOGAUSS
          HOGAUST = CTEMP
        ENDIF
C
        NONS = NOGAUSS*2
        GOTO 900
      ENDIF
C
C     Output truncation.
C
      IF( CHEQUAL( HPARN, 1, 10, 'truncation') ) THEN
        LFOUND = .TRUE.
C       (Ignore the call if the truncation value < 0.)
        IF( INTV(1) .LT. 0 ) GOTO 900
        IF( NOREPR .NE. JPSPHERE ) LCHANGE = .TRUE.
        IF( .NOT. LNOREPR ) NOREPR  = JPSPHERE
        LNOREPR = .TRUE.
        IF( NORESO .NE. INTV(1) ) LCHANGE = .TRUE.
        CALL INTLOG(JP_DEBUG, 'INTOUT: truncation = ',INTV(1))
        NORESO  = INTV(1)
        LNORESO = .TRUE.
        GOTO 900
      ENDIF
C
C
C
C     Output gaussian => same output type as input.
C     Double Interpolation
C
      IF( CHEQUAL( HPARN, 1, 20, 'intermediate_gaussian') ) THEN
        LFOUND = .TRUE.
C       (Ignore the call if the gaussian value = 0.)
        IF( INTV(1) .EQ. 0 ) GOTO 900
        IF( NOMEGA .NE. INTV(1) ) LCHANGE = .TRUE.
        CALL INTLOG(JP_DEBUG,'INTOUT: Intermediate gaussian = ',INTV(1))
        NOMEGA = INTV(1)
        LDOUBLE = .TRUE.
c        NOREPR = JPNOTYPE
c        LNOREPR = .TRUE.
c        NONS = NOGAUSS*2
        GOTO 900
      ENDIF
C
C     Interpolation method
C
      IF( CHEQUAL( HPARN, 1, 13, 'interpolation') ) THEN
        LFOUND = .TRUE.
        LNNLSM_CY41R1 = .FALSE.
        CALL INTLOG(JP_DEBUG, 'INTOUT: interpolation = '
     X   // CHARV ,JPQUIET)
        IF( CHEQUAL( CHARV, 1, 17, 'nearest neighbour') ) THEN
          IF( .NOT. LMETHOD ) LCHANGE = .TRUE.
          LMETHOD = .TRUE.
        ELSEIF( CHEQUAL( CHARV, 1, 8, 'bilinear') ) THEN
          IF( .NOT. LO12PT ) LCHANGE = .TRUE.
          LO12PT = .FALSE.
        ELSEIF( CHEQUAL( CHARV, 1, 11, 'nearest lsm') ) THEN
          IF( .NOT. LNNLSM ) LCHANGE = .TRUE.
          LNNLSM        = .TRUE.
          LNNLSM_CY41R1 = .TRUE.
        ELSEIF( CHEQUAL( CHARV, 1, 3, 'off') ) THEN
          LNNLSM  = .FALSE.
          LMETHOD = .FALSE.
        ELSE
          IF( LMETHOD ) LCHANGE = .TRUE.
          LMETHOD = .FALSE.
          LO12PT  = .TRUE.
          LNNLSM  = .FALSE.
        ENDIF
        GOTO 900
      ENDIF
C

C     Output ito be generated by automatically selected truncation
C     (autoresol).
C
      IF( CHEQUAL( HPARN, 1, 9, 'autoresol') ) THEN
        LFOUND = .TRUE.
        CALL INTLOG(JP_DEBUG, 'INTOUT: autoresol (1 = on) = ',INTV(1))
        IF( INTV(1).EQ.1 ) THEN
          LARESOL = .TRUE.
        ELSE
          LARESOL = .FALSE.
        ENDIF
      ENDIF
C
C     Output data format.
C
      IF( CHEQUAL( HPARN, 1, 4, 'form') ) THEN
        LFOUND = .TRUE.
        CALL INTLOG(JP_DEBUG, 'INTOUT: form = ' // CHARV ,JPQUIET)
        IF( CHEQUAL( CHARV, 1, 4, 'grib') ) THEN
          IF( NOFORM .EQ. 0 ) LCHANGE = .TRUE.
          NOFORM = 1
        ELSE
          IF( NOFORM .EQ. 1 ) LCHANGE = .TRUE.
          NOFORM = 0
        ENDIF
        GOTO 900
      ENDIF
C
C     Input level.
C
      IF( CHEQUAL( HPARN, 1, 5, 'level') ) THEN
        LFOUND = .TRUE.
        IF( NOLEVEL .NE. INTV(1) ) LCHANGE = .TRUE.
        CALL INTLOG(JP_DEBUG, 'INTOUT: level = ',INTV(1))
        NOLEVEL = INTV(1)
        LNOLEVL = .TRUE.
        GOTO 900
      ENDIF
C
C     Input level type.
C
      IF( CHEQUAL( HPARN, 1, 7, 'levtype') ) THEN
        LFOUND = .TRUE.
        IF( NOLEVT .NE. INTV(1) ) LCHANGE = .TRUE.
        CALL INTLOG(JP_DEBUG, 'INTOUT: levtype = ',INTV(1))
        NOLEVT  = INTV(1)
        LNOLEVT = .TRUE.
        GOTO 900
      ENDIF
C
C     Input table.
C
      IF( CHEQUAL( HPARN, 1, 5, 'table') ) THEN
        LFOUND = .TRUE.
        IF( NOTABLE .NE. INTV(1) ) LCHANGE = .TRUE.
        CALL INTLOG(JP_DEBUG, 'INTOUT: table = ',INTV(1))
        NOTABLE = INTV(1)
        LNOTABL = .TRUE.
        GOTO 900
      ENDIF
C
C     Input parameter.
C
      IF( CHEQUAL( HPARN, 1, 9, 'parameter') ) THEN
        LFOUND = .TRUE.
        IF( NOPARAM .NE. INTV(1) ) LCHANGE = .TRUE.
        CALL INTLOG(JP_DEBUG, 'INTOUT: parameter = ',INTV(1))
        NOPARAM = INTV(1)
        LNOPARA = .TRUE.
        GOTO 900
      ENDIF
C
C     Output accuracy.
C
      IF( CHEQUAL( HPARN, 1, 8, 'accuracy') ) THEN
        LFOUND = .TRUE.
C       (Ignore the call if the truncation value = 0.)
        IF( INTV(1) .EQ. 0 ) GOTO 900
        IF( NOACC .NE. INTV(1) ) LCHANGE = .TRUE.
        CALL INTLOG(JP_DEBUG, 'INTOUT: accuracy = ',INTV(1))
        NOACC  = INTV(1)
        LNOACC = .TRUE.
        GOTO 900
      ENDIF
C
C     Output gaussian => same output type as input.
C
      IF( CHEQUAL( HPARN, 1, 8, 'gaussian') ) THEN
        LFOUND = .TRUE.
C       (Ignore the call if the gaussian value = 0.)
        IF( INTV(1) .EQ. 0 ) GOTO 900
        IF( NOGAUSS .NE. INTV(1) ) LCHANGE = .TRUE.
        CALL INTLOG(JP_DEBUG, 'INTOUT: gaussian = ',INTV(1))
        NOGAUSS = INTV(1)
        LNOGAUS = .TRUE.
        NOREPR = JPNOTYPE
        LNOREPR = .TRUE.
        NONS = NOGAUSS*2
        GOTO 900
      ENDIF
C
C     Output area.
C
      IF( CHEQUAL( HPARN, 1, 4, 'area') ) THEN
        LFOUND = .TRUE.
        CALL INTLOGR(JP_DEBUG, 'INTOUT: north = ',REALV(1))
        CALL INTLOGR(JP_DEBUG, 'INTOUT: west  = ',REALV(2))
        CALL INTLOGR(JP_DEBUG, 'INTOUT: south = ',REALV(3))
        CALL INTLOGR(JP_DEBUG, 'INTOUT: east  = ',REALV(4))
        DO I = 1, 4
          ITEMP = INT( REALV(I)*PPMULT)
          IF( NOAREA(I) .NE. ITEMP ) LCHANGE = .TRUE.
          NOAREA(I) = ITEMP
        ENDDO
        LNOAREA = (NOAREA(1).NE.0).OR.(NOAREA(2).NE.0).OR.
     X            (NOAREA(3).NE.0).OR.(NOAREA(4).NE.0)
        GOTO 900
      ENDIF
C
C     Output scan.
C
      IF( CHEQUAL( HPARN, 1, 4, 'scan') ) THEN
        LFOUND = .TRUE.
        IF( NOSCNM .NE. INTV(1) ) LCHANGE = .TRUE.
        CALL INTLOG(JP_DEBUG, 'INTOUT: scan = ',INTV(1))
        NOSCNM = INTV(1)
        GOTO 900
      ENDIF
C
C     Output packing.
C
C     Values for PACKING
C       SIMPLE
C       COMPLEX
C       SECOND ORDER
C       ARCHIVED VALUE
C
      IF( CHEQUAL( HPARN, 1, 7, 'packing') ) THEN
        LFOUND = .TRUE.
        CALL INTLOG(JP_DEBUG, 'INTOUT: packing = ' // CHARV ,JPQUIET)
        IF( CHEQUAL( CHARV, 1, 6, 'second') ) THEN
          IF( NOHFUNC.NE.'K' ) LCHANGE = .TRUE.
          NOHFUNC = 'K'
        ELSE IF( CHEQUAL( CHARV, 1, 6, 'simple') ) THEN
          IF( NOHFUNC.NE.'S' ) LCHANGE = .TRUE.
          NOHFUNC = 'S'
        ELSE IF( CHEQUAL( CHARV, 1, 7, 'archive') ) THEN
          IF( NOHFUNC.NE.'A' ) LCHANGE = .TRUE.
          NOHFUNC = 'A'
        ELSE IF( CHEQUAL( CHARV, 1, 7, 'complex') ) THEN
          IF( NOHFUNC.NE.'C' ) LCHANGE = .TRUE.
          NOHFUNC = 'C'
        ELSE IF( CHEQUAL( CHARV, 1, 4, 'jpeg') ) THEN
          IF( NOHFUNC.NE.'J' ) LCHANGE = .TRUE.
          NOHFUNC = 'J'
        ELSE
          CALL INTLOG(JP_ERROR,
     X      'INTOUT: Invalid value for PACKING: ' // CHARV(1:6),JPQUIET)
          LFOUND = .FALSE.
        ENDIF
        GOTO 900
      ENDIF
C
C     Output reduced.
C
      IF( CHEQUAL( HPARN, 1,  7, 'reduced') ) THEN
        LFOUND = .TRUE.
C
C       (Ignore the call if the reduced value = 0.)
        IF( INTV(1) .EQ. 0 ) GOTO 900
C
C       (Check for changes to internal interp. request)
        LCHANGE = ((NOGAUSS.NE.INTV(1)) .OR. LOCTAHEDRAL )
        LOCTAHEDRAL = .FALSE.
C
        CALL INTLOG(JP_DEBUG, 'INTOUT: '//TRIM(HPARN)//' = ',INTV(1))
        NOGAUSS = INTV(1)
        LNOGAUS = .TRUE.
        IF( NOREPR .NE. JPQUASI ) THEN
          LCHANGE = .TRUE.
          NOGRID(1) = 0
          NOGRID(2) = 0
          LNOGRID = .FALSE.
        ENDIF
        IF( LNOROTA ) THEN
          NOREPR  = JPQGGROT
        ELSE
          NOREPR  = JPQUASI
        ENDIF
        LNOREPR = .TRUE.
        IF( (NOGAUSO.NE.NOGAUSS) .OR. (HOGAUST.EQ.'O')
     X      .OR. ((HOGAUST.NE.'R') .AND. (HOGAUST.NE.'O')) ) THEN
          CTEMP = 'R'
          CALL JGETGG(NOGAUSS,CTEMP,ROGAUSS,NOLPTS,IRET)
          IF( IRET .NE. 0 ) THEN
            CALL INTLOG(JP_ERROR,
     X        'INTOUT: JGETGG fail for NOGAUSS = ',NOGAUSS)
            INTOUT = IRET
            GOTO 900
          ENDIF
          NOGAUSO = NOGAUSS
          HOGAUST = CTEMP
        ENDIF
C
        NOAREA(1) = INT( ROGAUSS(1) * PPMULT )
        NOAREA(2) = 0
        NOAREA(3) = INT( ROGAUSS(NOGAUSS*2) * PPMULT )
        NOAREA(4) = JP360 - JP360/NOLPTS(NOGAUSS)
C
        NOPCNT = 0
        DO I = 1, NOGAUSS*2
          NOPCNT = NOPCNT + NOLPTS(I)
        ENDDO
C
        GOTO 900
      ENDIF
C
C     Output user_regular_gaussian
C
      IF( CHEQUAL( HPARN, 1, 21, 'user_regular_gaussian') ) THEN
        LFOUND = .TRUE.
        IF( NOREPR .NE. JPGAUSSIAN ) THEN
          LCHANGE = .TRUE.
          NOGRID(1) = 0
          NOGRID(2) = 0
          LNOGRID = .FALSE.
        ENDIF
C       (Ignore the call if the user_regular_gaussian value = 0.)
        IF( INTV(1) .EQ. 0 ) GOTO 900
        IF( NOGAUSS .NE. INTV(1) ) LCHANGE = .TRUE.
        CALL INTLOG(JP_DEBUG,'INTOUT: user_regular_gaussian = ',INTV(1))
        NOGAUSS = INTV(1)
        LNOGAUS = .TRUE.
        IF( LNOROTA ) THEN
          NOREPR  = JPFGGROT
        ELSE
          NOREPR  = JPGAUSSIAN
        ENDIF
        LNOREPR = .TRUE.
C
        NONS = NOGAUSS*2
        NOLPTS(1:NOGAUSS*2) = NOGAUSS*4
        NOGAUSO = NOGAUSS
        HOGAUST = 'U'
        LOGIVEP = .TRUE.
        LOCTAHEDRAL = .FALSE.
C
        GOTO 900
      ENDIF
C
C     Output user_reduced_gaussian
C
      IF( CHEQUAL( HPARN, 1, 21, 'user_reduced_gaussian') ) THEN
        LFOUND = .TRUE.
        IF( NOREPR .NE. JPQUASI ) THEN
          LCHANGE = .TRUE.
          NOGRID(1) = 0
          NOGRID(2) = 0
          LNOGRID = .FALSE.
        ENDIF
C       (Ignore the call if the user_reduced_gaussian value = 0.)
        IF( INTV(1) .EQ. 0 ) GOTO 900
        IF( NOGAUSS .NE. INTV(1) ) LCHANGE = .TRUE.
        CALL INTLOG(JP_DEBUG,'INTOUT: user_reduced_gaussian = ',INTV(1))
        NOGAUSS = INTV(1)
        LNOGAUS = .TRUE.
        IF( LNOROTA ) THEN
          NOREPR  = JPQGGROT
        ELSE
          NOREPR  = JPQUASI
        ENDIF
        LNOREPR = .TRUE.
        GOTO 900
      ENDIF
C
C     Output g_pnts.
C
      IF( CHEQUAL( HPARN, 1, 6, 'g_pnts') ) THEN
        LFOUND = .TRUE.
        IF( NOGAUSS .LE. 0 ) THEN
          IRET   = JPROUTINE + 1
          CALL INTLOG(JP_ERROR,
     X      'INTOUT: Impossible number of gaussian latitudes.',NOGAUSS)
          INTOUT = IRET
          GOTO 900
        ENDIF
C
        DO I = 1, NOGAUSS
          NOLPTS(I)                 = INTV(I)
          NOLPTS(NOGAUSS*2 + 1 - I) = INTV(I)
        ENDDO
C
        NOPCNT = 0
        DO I = 1, NOGAUSS*2
          NOPCNT = NOPCNT + NOLPTS(I)
        ENDDO
        NOGAUSO = NOGAUSS
        HOGAUST = 'U'
        LOGIVEP = .TRUE.
        LOCTAHEDRAL = ISOCTAHEDRAL(NOGAUSS,NOLPTS)
        GOTO 900
      ENDIF
C
C     Output g_lats.
C
      IF( CHEQUAL( HPARN, 1, 6, 'g_lats') ) THEN
        LFOUND = .TRUE.
        IF( NOGAUSS .LE. 0 ) THEN
          IRET   = JPROUTINE + 1
          CALL INTLOG(JP_ERROR,
     X      'INTOUT: Impossible number of gaussian latitudes.',NOGAUSS)
          INTOUT = IRET
          GOTO 900
        ENDIF
C
        DO I = 1, NOGAUSS
          ROGAUSS(I)                 =  REALV(I)
          ROGAUSS(NOGAUSS*2 + 1 - I) = -REALV(I)
        ENDDO
C
        NOAREA(1) = INT( ROGAUSS(1) * PPMULT )
        NOAREA(2) = 0
        NOAREA(3) = INT( ROGAUSS(NOGAUSS*2) * PPMULT )
        NOAREA(4) = JP360 - JP360/NOLPTS(NOGAUSS)
        NOGAUSO = NOGAUSS
        HOGAUST = 'U'
        LOGIVEL = .TRUE.
        GOTO 900
      ENDIF
C
C     Output rotation.
C
      IF( CHEQUAL( HPARN, 1, 8, 'rotation') ) THEN
        LFOUND = .TRUE.
C
        IF( CHEQUAL(CHARV,1,3,'off') ) THEN
          LNOROTA = .FALSE.
          NOROTA(1) = -99999999
          NOROTA(2) = -99999999
          IF( NOREPR.EQ.JPSPHROT ) NOREPR = JPSPHERE
          IF( NOREPR.EQ.JPREGROT ) NOREPR = JPREGULAR
          IF( NOREPR.EQ.JPQGGROT ) NOREPR = JPQUASI
          IF( NOREPR.EQ.JPFGGROT ) NOREPR = JPGAUSSIAN
        ELSE
          LNOROTA = .TRUE.
          CALL INTLOGR(JP_DEBUG, 'INTOUT: S.pole latitude  = ',REALV(1))
          CALL INTLOGR(JP_DEBUG, 'INTOUT: S.pole longitude = ',REALV(2))
          DO I = 1, 2
            ITEMP = INT( REALV(I)*PPMULT)
            IF( NOROTA(I) .NE. ITEMP ) LCHANGE = .TRUE.
            NOROTA(I) = ITEMP
          ENDDO
          IF( NOREPR.EQ.JPSPHERE )   NOREPR = JPSPHROT
          IF( NOREPR.EQ.JPREGULAR )  NOREPR = JPREGROT
          IF( NOREPR.EQ.JPQUASI )    NOREPR = JPQGGROT
          IF( NOREPR.EQ.JPGAUSSIAN ) NOREPR = JPFGGROT
        ENDIF
        GOTO 900
      ENDIF
C
C     Interpolation scheme to use for rotations
C
      IF( CHEQUAL( HPARN, 1, 8, '12-point') ) THEN
        LFOUND = .TRUE.
        CALL INTLOG(JP_DEBUG, 'INTOUT: 12-point = ' // CHARV ,JPQUIET)
C
        IF( CHEQUAL(CHARV,1,3,'yes') ) THEN
          LO12PT = .TRUE.
        ELSE
          LO12PT = .FALSE.
        ENDIF
        GOTO 900
      ENDIF
C
C     Output user_reduced_latlon
C
      IF( CHEQUAL( HPARN, 1, 19, 'user_reduced_latlon') ) THEN
        LFOUND = .TRUE.
        IF( NOREPR .NE. JPREDLL ) THEN
          LCHANGE = .TRUE.
          NOGRID(1) = 0
Cjdc      NOGRID(2) = REALV(2)
          LNOGRID = .FALSE.
        ENDIF
C       (Ignore the call if the user_reduced_latlon value = 0.)
        IF( INTV(1) .EQ. 0 ) GOTO 900
        IF( NOREDLL .NE. INTV(1) ) LCHANGE = .TRUE.
        CALL INTLOG(JP_DEBUG, 'INTOUT: user_reduced_latlon = ',INTV(1))
        NOREDLL = INTV(1)
        LNOREDL = .TRUE.
        IF( LNOROTA ) THEN
          NOREPR  = JPREDLROT
        ELSE
          NOREPR  = JPREDLL
        ENDIF
        LNOREPR = .TRUE.
        GOTO 900
      ENDIF
C
C     Output set raduced_laltlon
C
      IF( CHEQUAL( HPARN, 1, 10, 'red_latlon') ) THEN
        LFOUND = .TRUE.
          NOGRID(1) = 0
          NOGRID(2) = REALV(2)
        IF( NOREPR .NE. JPREDLL ) THEN
          LCHANGE = .TRUE.
          LNOGRID = .FALSE.
        ENDIF
C       (Ignore the call if the user_reduced_latlon value = 0.)
cs        IF( INTV(1) .EQ. 0 ) GOTO 900
        CALL INTLOG(JP_DEBUG, 'INTOUT: reduced_latlon ns = ',NOGRID(2))
cs        NOREDLL = INTV(1)
        LNOREDL = .TRUE.
        IF( LNOROTA ) THEN
          NOREPR  = JPREDLROT
        ELSE
          NOREPR  = JPREDLL
        ENDIF
        LNOREPR = .TRUE.
        GOTO 900
      ENDIF
C
C     Output ll_pnts.
C
      IF( CHEQUAL( HPARN, 1, 7, 'll_pnts') ) THEN
        LFOUND = .TRUE.
        IF( NOREDLL .LE. 0 ) THEN
          IRET   = JPROUTINE + 1
          CALL INTLOG(JP_ERROR,
     X      'INTOUT: Impossible number of latitudes.',NOREDLL)
          INTOUT = IRET
          GOTO 900
        ENDIF
C
        NOLPTS(1:NOREDLL) = INTV(1:NOREDLL)
C
        NOPCNT = 0
        DO I = 1, NOREDLL-1
          NOPCNT = NOPCNT + NOLPTS(I)
        ENDDO
        LOGIVEP = .TRUE.
        GOTO 900
      ENDIF
C
C     Output ll_lats.
C
      IF( CHEQUAL( HPARN, 1, 7, 'll_lats') ) THEN
        LFOUND = .TRUE.
        IF( NOREDLL .LE. 0 ) THEN
          IRET   = JPROUTINE + 1
          CALL INTLOG(JP_ERROR,
     X      'INTOUT: Impossible number of latitudes.',NOREDLL)
          INTOUT = IRET
          GOTO 900
        ENDIF
C
        ROREDLL(1:NOREDLL) = REALV(1:NOREDLL)
C
        NOAREA(1) = INT( ROREDLL(1) * PPMULT )
        NOAREA(2) = 0
        NOAREA(3) = INT( ROREDLL(NOREDLL) * PPMULT )
        NOAREA(4) = JP360 - JP360/NOLPTS(NOREDLL/2)
        LOGIVEL   = .TRUE.
        GOTO 900
      ENDIF
C
C     Reduced gaussian definition from file
C
      IF( CHEQUAL( HPARN, 1, 15, 'gauss_from_file') ) THEN
        LFOUND = .TRUE.
        CALL INTLOG(JP_DEBUG,
     X    'INTOUT: gauss_from_file = ' // CHARV ,JPQUIET)
C
C       Open the input file
C
        CALL PBOPEN(IFILE1, CHARV, 'R', IRET)
        IF( IRET.NE.0 ) THEN
          CALL INTLOG(JP_ERROR,
     X      'INTOUT: Unable to use gaussian definition file:',JPQUIET)
          CALL INTLOG(JP_ERROR,CHARV,JPQUIET)
          INTOUT = JPROUTINE + 1
          GOTO 900
        ENDIF
C
C       Read gaussian number, then number of points at each latitude
C
        CALL PBREAD(IFILE1, NOGAUSS, JPBYTES, IRET)
        IF( IRET.NE.JPBYTES ) THEN
          CALL INTLOG(JP_ERROR,
     X      'INTOUT: Problem reading gaussian no. from file:',JPQUIET)
          CALL PBCLOSE(IFILE1, IRET)
          INTOUT = JPROUTINE + 1
          GOTO 900
        ENDIF
C
        IF( NOGAUSS .LE. 0 ) THEN
          IRET   = JPROUTINE + 1
          CALL INTLOG(JP_ERROR,
     X      'INTOUT: Impossible number of gaussian latitudes.',NOGAUSS)
          INTOUT = IRET
          GOTO 900
        ENDIF
C
        CALL PBREAD(IFILE1, NOLPTS, JPBYTES*NOGAUSS, IRET)
        IF( IRET.NE.JPBYTES*NOGAUSS ) THEN
          CALL INTLOG(JP_ERROR,
     X      'INTOUT: Problem reading gaussian pts from file:',JPQUIET)
          CALL PBCLOSE(IFILE1, IRET)
          INTOUT = JPROUTINE + 1
          GOTO 900
        ENDIF
C
        CALL PBCLOSE(IFILE1, IRET)
C
        DO I = 1, NOGAUSS
          NOLPTS(NOGAUSS*2 + 1 - I) = NOLPTS(I)
        ENDDO
C
        NOPCNT = 0
        DO I = 1, NOGAUSS*2
          NOPCNT = NOPCNT + NOLPTS(I)
        ENDDO
        NOGAUSO = NOGAUSS
        HOGAUST = 'U'
        LOGIVEP = .TRUE.
        LOGIVEL = .TRUE.
        LOCTAHEDRAL = ISOCTAHEDRAL(NOGAUSS,NOLPTS)
C
        IRET = IGGLAT(NOGAUSS*2, ROGAUSS, 0, 1)
        IF( IRET.NE.0 ) THEN
          CALL INTLOG(JP_ERROR,
     X      'INTOUT: Problem calculating gaussian latitudes',JPQUIET)
          INTOUT = JPROUTINE + 1
          GOTO 900
        ENDIF
C
        IF( LNOROTA ) THEN
          NOREPR = JPQGGROT
        ELSE
          NOREPR = JPQUASI
        ENDIF
        LNOREPR = .TRUE.
C
        GOTO 900
      ENDIF
C
C     Output grid creation style
C
      IF( CHEQUAL( HPARN, 1, 5, 'style') ) THEN
        LFOUND = .TRUE.
        CALL INTLOG(JP_DEBUG, 'INTOUT: style = ' // CHARV ,JPQUIET)
        IF( CHEQUAL( CHARV, 1, 13, 'dissemination') ) THEN
          ITEMP = JPSDISM
        ELSE
          ITEMP = JPSMARS
        ENDIF
        IF( NOSTYLE .NE. ITEMP ) LCHANGE = .TRUE.
        NOSTYLE = ITEMP
        LNOSTYLE = .TRUE.
        GOTO 900
      ENDIF
C
C     Output grid frame
C
      IF( CHEQUAL( HPARN, 1, 5, 'frame') ) THEN
        LFOUND = .TRUE.
        CALL INTLOG(JP_DEBUG, 'INTOUT: frame = ',INTV(1))
        ITEMP = INTV(1)
        IF( NOFRAME .NE. ITEMP ) LCHANGE = .TRUE.
        NOFRAME = ITEMP
        LNOFRAME = (NOFRAME.GT.0)
        GOTO 900
      ENDIF
C
C     Output grid bitmap
C
      IF( CHEQUAL( HPARN, 1, 6, 'bitmap') ) THEN
        LFOUND = .TRUE.
        CALL INTLOG(JP_DEBUG, 'INTOUT: bitmap = ' // CHARV ,JPQUIET)
        ITEMP  = JINDEX(CHARV)
        IF( ITEMP.LT.1 ) THEN
          CALL INTLOG(JP_WARN,
     X      'INTOUT: No bitmap filename given.',JPQUIET)
          INTOUT = JPROUTINE + 1
          GOTO 900
        ELSE
          IF( NOBITMP(1:ITEMP).NE.CHARV(1:ITEMP) ) LCHANGE = .TRUE.
          NOBITMP = ' '
          NOBITMP(1:ITEMP) = CHARV(1:ITEMP)
          LNOBITMP = .TRUE.
        ENDIF
        GOTO 900
      ENDIF
C
C     Output gaussian grid specification
C
      IF( CHEQUAL( HPARN, 1, 13, 'specification') ) THEN
        LFOUND = .TRUE.
        CALL INTLOG(JP_DEBUG, 'INTOUT: specification = ', INTV(1))
        IF( (INTV(1).NE.12).AND.(INTV(1).NE.18) ) THEN
          CALL INTLOG(JP_ERROR,
     X      'INTOUT: invalid value for specification = ',INTV(1))
          INTOUT = JPROUTINE + 2
          GOTO 900
        ENDIF
C
        IF( NGSPEC.NE.INTV(1) ) THEN
          LCHANGE = .TRUE.
          NGSPEC  = INTV(1)
          LNGSPEC = .TRUE.
        ENDIF
        IF( LNOGAUS ) THEN
          CALL INTLOG(JP_DEBUG,
     X      'INTOUT: replace gaussian specification = ', NOGAUSS)
          CTEMP = 'R'
          CALL JGETGG(NOGAUSS,CTEMP,ROGAUSS,NOLPTS,IRET)
          IF( IRET .NE. 0 ) THEN
            CALL INTLOG(JP_ERROR,
     X        'INTOUT: JGETGG fail for NOGAUSS = ',NOGAUSS)
            INTOUT = IRET
            GOTO 900
          ENDIF
          NOGAUSO = NOGAUSS
          HOGAUST = CTEMP
C
          IF( .NOT.LNOAREA ) THEN
            CALL INTLOG(JP_DEBUG,
     X        'INTOUT: now replace output area definition',JPQUIET)
            NOAREA(1) = INT( ROGAUSS(1) * PPMULT )
            NOAREA(2) = 0
            NOAREA(3) = INT( ROGAUSS(NOGAUSS*2) * PPMULT )
            NOAREA(4) = JP360 - JP360/NOLPTS(NOGAUSS)
            NOPCNT = 0
            DO I = 1, NOGAUSS*2
              NOPCNT = NOPCNT + NOLPTS(I)
            ENDDO
            GOTO 900
          ENDIF
        ENDIF
        GOTO 900
      ENDIF
C
C     -----------------------------------------------------------------|
C     Section 9.   Closedown.
C     -----------------------------------------------------------------|
C
  900 CONTINUE
      IF( .NOT. LFOUND ) THEN
        CALL INTLOG(JP_ERROR,
     X    'INTOUT: Unknown keyword or option used:', JPQUIET)
        CALL INTLOG(JP_ERROR, HPARN, JPQUIET)
        INTOUT = JPROUTINE + 2
      ENDIF
C
C     Set flag to show function has been called
      LINTOUT = .TRUE.
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      INTEGER FUNCTION C2GENE ( KDATA,  KLENP,  KSEC4,  KGRIB,  KLENG,
     X                          KNSPT,  KBITS,  OCOMGR, OLONLY, KLEN4,
     X                          KFIROV, KLEN,   KREFGR, KLENGR, KBITGR,
     X                          KWORK,  KLWORK, KSTART, KPOWER, KMXPWR,
     X                          KPCWID, KXCWID, KNBIFO, KNCMIN, KMINPK,
     X                          KLWORX, ODEBUG )
C
C---->
C**** C2GENE
C
C     Purpose.
C     --------
C
C     Performs a general second-order packing method for section 4
C     of GRIB, and/or computes only length of section 4, with/without
C     coding, with this method.
C
C     "General" means with explicit descriptors to describe groups
C     position and width (not row-by-row, nor constant-width).
C
C     When extended 2nd-order packing is enabled, then KSEC4(12:15)
C     values determin if extensions are concerned. Extensions are:
C
C     - general extended 2nd-order packing, which is the same as WMO
C      except for documentation of descriptors (held more economically);
C
C     - boustrophedonic ordering, which is held outside of the routine
C       (field re-ordering, swapping values in even rank rows).
C
C     - spatial differencing, which is held mostly outside of the
C       routine (apply general extended 2nd-order compression algorithm,
C       with or without boustrophedonic ordering, to values obtained
C       through computation of differences between adjacent values,
C       repeated to order wished).
C
C**   Interface.
C     ----------
C
C     KRET = C2GENE ( KDATA,  KLENP,  KSEC4,  KGRIB,  KLENG,  KNSPT,
C    X                KBITS,  OCOMGR, OLONLY, KLEN4,  KFIROV, KLEN,
C    X                KREFGR, KLENGR, KBITGR, KWORK,  KLWORK, KSTART,
C    X                KPOWER, KMXPWR, KPCWID, KXCWID, KNBIFO, KNCMIN,
C    X                KMINPK, KLWORX, ODEBUG )
C
C
C     Input Parameters for all options.
C     --------------------------------
C
C     KDATA      - Array of normalized values.
C     KLENP      - Length of array KDATA.
C     KSEC4      - Array of GRIB section 4 integer descriptors.
C                  KSEC4(12) indicates type of general 2nd-order packing
C                  (applies only to descriptors): 
C                   0 => standard WMO descriptors
C                   8 => extended     descriptors
C                  KSEC4(13) indicates if boustrophedonic ordering
C                  (values swapped in rows of even rank) is selected:
C                   0 => standard        ordering
C                   4 => boustrophedonic ordering
C                  KSEC4(14:15) indicates if spatial differencing is on:
C                   0:0 => no spatial differencing
C                   0:1,2:0,2:1 => spatial differencing applied at order
C                                  equal to KSEC4(14)+KSEC4(15)
C     KLENG      - Length of GRIB product array.
C     KNSPT      - Bit pointer for next value in GRIB product.
C     KBITS      - Number of bits per computer word.
C     OCOMGR     - True if COMputing of GRoup arrays is requested.
C     OLONLY     - True if Length ONLY is requested (no coding).
C     KLEN       - Exact number of grid-points to handle.
C     KLWORK     - Length of work arrays.
C     KPOWER     - Auxilary array, precomputed (powers of 2)-1.
C     KMXPWR     - Maximum number of bits per original scaled value.
C     KPCWID     - Auxilary array, precomputed widths.
C     KXCWID     - Maximum width associated to KPCWID.
C     KNCMIN     - Minimum increment to use when determining groups.
C     KMINPK     - Initial (minimum) length of groups.
C     ODEBUG     - True for some debug printout.
C
C
C     Output Parameters for all options.
C     ---------------------------------
C
C     KSEC4      - Array of GRIB section 4 integer descriptors.
C                  (updated, except when both OCOMGR is false
C                   and OLONLY it true)
C     KLEN4      - Length of section 4.
C     KLWORX     - Maximum work space used.
C
C     Output Parameters when OLONLY is false.
C     --------------------------------------
C
C     KGRIB      - Array containing GRIB product.
C     KNSPT      - Bit pointer for next value in GRIB product (updated).
C     KWORK      - Used as work array by C2PACK.
C
C     Output Parameters when OCOMGR is true,
C      Input Parameters when OCOMGR is false.
C     --------------------------------------
C
C     KREFGR     - Work array, first-order values for each row.
C     KLENGR     - Work array, effective length of each row.
C     KBITGR     - Work array, bit number ("width") of each row.
C     KNBIFO     - Number of BIts for coding First-Order values.
C
C     Output Parameters when OCOMGR is true,
C      Input parameter in all cases.
C     --------------------------------------
C
C     KDATA      - Used as work array by C2PACK.
C
C     Input Parameter when OCOMGR is false.
C     -------------------------------------
C
C     KSTART     - First index value of precomputed work arrays KREFGR,
C                  KLENGR and KBITGR.
C
C     Method.
C     -------
C
C     Follows WMO Manual of Codes.
C
C     If requested through OCOMGR, a first scan computes work arrays,
C     bit number for coding first-order values and length of section 4.
C
C     If requested, coding is applied in a second scan, using
C     descriptors computed in the first scan, possibly in a previous
C     call.
C
C     Algorithm used to determine groups is derived from Harry R. Glahn
C     (U.S. Met Service), from a working paper submitted to WMO SGDR&C
C     in 1995.
C
C     If extended 2nd-order packing is enabled, then call with OCOMGR
C     to .FALSE. and OLONLY to .TRUE. is enabled, to support aggressive
C     packing without having to recompute work arrays, which would be
C     the same for general WMO and extended packings (for the same
C     option of field ordering: either both boustrophedonic
C     or both not).
C
C     Externals.
C     ----------
C
C     MAXMNI    - Computes extrema of integer array.
C     C2BITW    - Computes bit width of a positive integer value.
C     C2PACK    - Encodes descriptors and data.
C
C
C     Reference.
C     ----------
C
C     None.
C
C
C     Comments.
C     --------
C
C     On entry, KNSPT points to the first bit of section 4 
C               in the GRIB product.
C     On exit,  KNSPT points to the first unused bit of section 4,
C               (or to the first bit of section 5, if unused bit count
C                is zero) in the GRIB product.
C
C     KDATA is overwritten when coding is requested.
C     This is coherent with GRIBEX.
C
C     Boustrophedonic ordering, if selected, is formally transparent to
C     the current routine. Pre-processing is held at calling routine
C     level (C2ORDR), coding at C2PACK level.
C
C     Author.
C     -------
C
C     J. Clochard, Meteo France, for ECMWF - January 1998.
C
C
C     Modifications.
C     _____________
C
C     J. Clochard, April 1998.
C     Use C2BITW function for bit width computations, out of
C     the splitting algorithm itself.
C     Introduce spatial differencing.
C
C     J. Clochard, July 1998.
C     Set KLWORX to KLWORK when out of work space in direct algorithm.
C
C     J. Clochard, September 1998.
C     Update comments.
C     Adjust KLWORX within splitting algorithm.
C     Limit index range used in KWORK for "small" initial groups number.
C     Suppress KSEC1/KSEC2/KSEC3 dummy-arguments.
C         "    KSEC1, add KWORK/KPOWER/KMXPWR argument in C2PACK call.
C
C     J. Clochard, June 1999.
C     Use precomputed array to determine widths . Dummy-arguments
C     KPCWID and KXCWID added . Assumption is made that KXCWID
C     is at least (KMXPWR+1)/2 .
C
C
C----<
C     -----------------------------------------------------------------
C*    Section 0. Definition of variables.
C     -----------------------------------------------------------------
C
      IMPLICIT NONE
C
#include "common/grprs.h"
C
C     Subroutine arguments
C
      INTEGER KLENP, KLENG, KNSPT, KBITS, KLEN4, KNCMIN, KLWORX, KXCWID
      INTEGER KLEN, KLWORK, KMXPWR, KNBIFO, KFIROV, KMINPK, KSTART
C
      INTEGER KDATA (KLENP), KSEC4 (*), KPCWID (0:*)
      INTEGER KGRIB (KLENG), KREFGR (KLWORK), KLENGR (KLWORK)
      INTEGER KBITGR (KLWORK), KPOWER (0:KMXPWR), KWORK (KLWORK)
C
      LOGICAL OLONLY, OCOMGR, ODEBUG
C
C     Local variables.
C
      INTEGER IRETFN, ICOUNT, INBIFO, ILDSTA, IDMAX, IDMIN, IXLDST
      INTEGER IGROUP, ISIZEG, IPOWER, INBITO, ILENSO, IXLEN4, IXGRBD
      INTEGER IOFF, J, IFIROV, INCMIN, IBITGW, IMAXAB, IMINAB, IMINPK
      INTEGER IMAXA, IMINA, ISOMAX, INBITA, IMAXC, IMINC, IXBIGW, ILCWID
      INTEGER IMAXAC, IMINAC, IMAXB, IMINB, ISIZEA, ISIZEB, ISIZEC
      INTEGER IXFIRO, ISTART, ILWORK, ILEN
      INTEGER IBITGS, ILENGS, ILDSTG, INDNEW, ILEN4O, IORDER, IWIDSD
      INTEGER IBIAS
      INTEGER IAUXIL, IGRADD, ILEN4S, IGROUS, J2, ILASTG, INGRAD, IPOSGR
C
      INTEGER C2PACK, C2BITW
      EXTERNAL C2PACK, C2BITW
C
      LOGICAL LB2A
      LOGICAL LGENXT
C
      REAL ZGAIN
C
C     Function computing lenth of section 4 (in octets), using as
C     arguments length of static descriptors, number of 1st-order
C     values, width of widthes, and length (bits) of descriptors
C     for groups bounds.
C
C     Length must always be an even number of octets.
C
      IXLEN4 ( IXLDST, IXFIRO, IXBIGW, IXGRBD ) =       2 * ( (
     X   IXLDST + (8+IXFIRO*IXBIGW-1)/8 + (8+IXGRBD-1)/8
     X          + (8+IXFIRO*INBIFO-1)/8 + (8+ILENSO-1)/8
     X                                                        +1 ) / 2 )
C
C
C     -----------------------------------------------------------------
C*    Section 1 . Performs initial checks.
C     -----------------------------------------------------------------
C
  100 CONTINUE
      ILEN4O=0
C
      LGENXT=KSEC4(12).NE.0
#ifndef ebug2o
      IF (ODEBUG) THEN
#endif
        WRITE(GRPRSM,FMT=9100) OCOMGR, OLONLY, KNSPT
C
        IF (LGENXT) THEN 
          WRITE(GRPRSM,FMT=9101) 'general extended'
        ELSE
          WRITE(GRPRSM,FMT=9101) 'general WMO standard'
        ENDIF
C
#ifndef ebug2o
      ENDIF
#endif
C
      IRETFN = 0
      ILCWID = KPOWER(KXCWID)+1
      IORDER=KSEC4(14)+KSEC4(15)
      ICOUNT=IORDER
      ILEN=KLEN-IORDER
      IWIDSD=KSEC4(11)
      IBIAS=KSEC4(16)
      ILDSTA=21
      INBITO=KSEC4(2)
      KLWORX=0
C
      IF (.NOT.OCOMGR) THEN
C
        INBIFO=KNBIFO
        IFIROV=KFIROV
        KLWORX=KFIROV
        ISTART=KSTART
        IBITGW=KSEC4(20)
C
        IF (LGENXT) THEN
          IBITGS=KSEC4(17)
        ENDIF
C
        IF (OLONLY) THEN
          ILENSO=KSEC4(19)
          GOTO 260
        ENDIF
        GOTO 300
C
      ENDIF
C
C     -----------------------------------------------------------------
C*    Section 2 . Computing of group characteristics.
C     -----------------------------------------------------------------
C
  200 CONTINUE
C
      IGROUP=0
      INCMIN=MIN (MAX (KNCMIN,1),1+ILEN/4)
      IMINPK=MIN (MAX (KMINPK,2*INCMIN),1+ILEN/2)
      ISIZEG=IMINPK
      ISTART=1
C
#ifndef ebug2o
      IF (ODEBUG) THEN
#endif
        WRITE(GRPRSM,FMT=9200) INBITO, (KSEC4(J),J=1,15),
     X                          INCMIN, ISIZEG
#ifndef ebug2o
      ENDIF
C
#endif
C
C     -----------------------------------------------------------------
C               Determination of an "initial" group, called A.
C     -----------------------------------------------------------------
C
  210 CONTINUE
C
      ISIZEA=MIN (ISIZEG,KLEN-ICOUNT)
C
C     Extrema computed in-line for better efficiency.
C
      IMAXA=KDATA(ICOUNT+1)
      IMINA=KDATA(ICOUNT+1)
C
      DO 211 J=2,ISIZEA
      IMAXA=MAX (IMAXA,KDATA(ICOUNT+J))
      IMINA=MIN (IMINA,KDATA(ICOUNT+J))
  211 CONTINUE
C
  212 CONTINUE
C
      LB2A=.FALSE.
      ISOMAX=IMAXA-IMINA
C
      IF (ISOMAX.LT.ILCWID) THEN
        INBITA=KPCWID(ISOMAX)
      ELSE
        INBITA=KXCWID+KPCWID(ISOMAX/ILCWID)
      ENDIF
C
      IPOWER=KPOWER(INBITA)
C
      IOFF=ICOUNT+ISIZEA
#ifdef ebug2o
      PRINT *,'c2gene - ICOUNT/ISIZEA/IMINA/IMAXA/INBITA/IPOWER=',
     X                  ICOUNT,ISIZEA,IMINA,IMAXA,INBITA,IPOWER
#endif
C
      IF (IOFF.EQ.KLEN) THEN
C
C       Just finished. Group A is closed.
C
        GOTO 240
C
      ENDIF
C
C     -----------------------------------------------------------------
C               Try to add an increment C to initial group A.
C     -----------------------------------------------------------------
C
  220 CONTINUE
C
      IF (KLEN-(IOFF+INCMIN).LE.ISIZEG/2) THEN
C
C          Avoid too small group at the end.
C
        INCMIN=KLEN-IOFF
      ENDIF
C
      IMAXC=KDATA(IOFF+1)
      IMINC=KDATA(IOFF+1)
C
#ifdef CRAY
CDIR$ NOVECTOR
#endif
#ifdef FUJITSU
!OCL SCALAR
#endif
      DO 221 J=2,INCMIN
      IMAXC=MAX (IMAXC,KDATA(IOFF+J))
      IMINC=MIN (IMINC,KDATA(IOFF+J))
  221 CONTINUE
#ifdef CRAY
CDIR$ VECTOR
#endif
#ifdef FUJITSU
!OCL VECTOR
#endif
C
      IMAXAC=MAX (IMAXA,IMAXC)
      IMINAC=MIN (IMINA,IMINC)
      ISOMAX=IMAXAC-IMINAC
#ifdef ebug2o
      PRINT *,'c2gene - IOFF/INCMIN/IMINC/IMAXC/IMINAC/IMAXAC=',
     X                  IOFF,INCMIN,IMINC,IMAXC,IMINAC,IMAXAC
#endif
C
      IF (ISOMAX.GT.IPOWER) THEN
C
C       Added to A, increment C would not fit in same width as A.
C       Group A is closed.
C
        GOTO 240
C
      ELSEIF ((IOFF+INCMIN).EQ.KLEN) THEN
C
C       Group C is added to group A. Finished.
C
        ISIZEA=ISIZEA+INCMIN
        IMAXA=IMAXAC
        IMINA=IMINAC
        GOTO 240
C
      ENDIF
C
C       Increment C would fit, if added to A.
C
C       See width of group B, following group A, with its length
C       determined in the same way as A.
C
      ISIZEB=MIN (ISIZEG,KLEN-IOFF)
      IMAXB=IMAXC
      IMINB=IMINC
C
      DO 222 J=INCMIN+1,ISIZEB
      IMAXB=MAX (IMAXB,KDATA(IOFF+J))
      IMINB=MIN (IMINB,KDATA(IOFF+J))
  222 CONTINUE
C
      ISOMAX=IMAXB-IMINB
      IMAXAB=MAX (IMAXA,IMAXB)
      IMINAB=MIN (IMINA,IMINB)
#ifdef ebug2o
      PRINT *,'c2gene - IMINB/IMAXB/IMINAB/IMAXAB=',
     X                  IMINB,IMAXB,IMINAB,IMAXAB
#endif
C
      IF (ISOMAX.LE.IPOWER/2.AND.IPOWER.GT.0) THEN
C
C       Group B has a smaller width than A.
C
C       Group A is closed, B replaces A, reminds that new initial group
C       characteristics (with the exception of width) have already been
C       computed.
C
        LB2A=.TRUE.
        GOTO 240
C
      ELSEIF ((IMAXAB-IMINAB).LE.IPOWER) THEN
C
C       Group B just fits with A, and is added to A as an extended
C       C group.
C
        ISIZEC=ISIZEB
        IMAXAC=IMAXAB
        IMINAC=IMINAB
C
      ELSE
C
C       Group B has a width at least equal to A, and would not fit
C       if added to A.
C
C       Group C is added to group A, and another C-type group
C       has to be checked.
C
        ISIZEC=INCMIN
C
      ENDIF
C
C       Incremental group (C or B) added to A.
C
      ISIZEA=ISIZEA+ISIZEC
      IMAXA=IMAXAC
      IMINA=IMINAC
      IOFF=IOFF+ISIZEC
C
      IF (IOFF.LT.KLEN) THEN
C
C       Another C-type group has to be checked...
C
        GOTO 220
C
      ENDIF
C
C       ...otherwise, finished.
C
C     -----------------------------------------------------------------
C     No incremental group may be added. Current A group is closed.
C     -----------------------------------------------------------------
C
  240 CONTINUE
C
      IGROUP=IGROUP+1
      KLENGR(IGROUP)=ISIZEA
      ICOUNT=ICOUNT+ISIZEA
      KBITGR(IGROUP)=INBITA
      ISOMAX=IMAXA-IMINA
C
C     Maximum use of width for second-order values: the maximum value
C     of group will be encoded with the biggest value fitting within
C     INBITA bits, and keeping reference value positive or zero.
C
C     The goal is to get the lowest reference value, thus trying
C     (desperately) to save bit(s) to encode the first-order values.
C
      KREFGR(IGROUP)=MAX (0,IMINA-(IPOWER-ISOMAX))
#ifdef ebug2o
      PRINT *,'c2gene - IGROUP/ISIZEA/INBITA/IMINA/IMAXA/refer=',
     X                  IGROUP,ISIZEA,INBITA,IMINA,IMAXA,KREFGR(IGROUP)
#endif
C
      IF (ICOUNT.EQ.KLEN) THEN
C
C       Work finished.
C
        GOTO 250
C
      ELSEIF (IGROUP.GE.KLWORK) THEN
C
C     Out of work space.
C
        IRETFN = 21240
        WRITE(GRPRSM,FMT=9240) KLWORK
        KLWORX=KLWORK
        GOTO 900
C
      ELSEIF (LB2A) THEN
C
C       Transforms B group into A group.
C
        ISIZEA=ISIZEB
        IMAXA=IMAXB
        IMINA=IMINB
C
C       Go back, starting by width computing.
C
        GOTO 212
C
      ELSE
C
C       Another A group must be determined.
C
        GOTO 210
C
      ENDIF
C
C     -----------------------------------------------------------------
C     Groups have been determined. Computes associated descriptors.
C     -----------------------------------------------------------------
C
  250 CONTINUE
C
      KLWORX=IGROUP
      IFIROV=IGROUP
C
C     Number of bits necessary to code first-order values.
C
      CALL MAXMNI (KREFGR,IFIROV,IDMAX,IDMIN)
      INBIFO = C2BITW ( IDMAX,  INBITO, KPOWER, KMXPWR )
C
C     Length (bits) of second-order values.
C
      ILENSO=0
C
      DO 253 J=1,IFIROV
      ILENSO=ILENSO+KLENGR(J)*KBITGR(J)
  253 CONTINUE
C
C     -----------------------------------------------------------------
C     Descriptors that are computed even if OCOMGR is false.
C     -----------------------------------------------------------------
C
  260 CONTINUE      
C
      IF (LGENXT) THEN
C
C       Compute group width (width of widths), that may be here
C       different than 8.
C 
        CALL MAXMNI (KBITGR,IFIROV,ISOMAX,IAUXIL)
        IBITGW = C2BITW ( ISOMAX, INBITO, KPOWER, KMXPWR )
C
C       Compute width of lengths.
C 
        CALL MAXMNI (KLENGR,IFIROV,IDMAX,IDMIN)
        IBITGS = C2BITW ( IDMAX,  KMXPWR, KPOWER, KMXPWR )
C
        KSEC4(17)=IBITGS
C
        IF (IORDER.EQ.0) THEN
          ILDSTG=ILDSTA+4
        ELSE
          ILDSTG=ILDSTA+5+(8+IWIDSD*(IORDER+1)-1)/8
        ENDIF
C
#ifndef ebug2o
        IF (ODEBUG) THEN
#endif
          WRITE(GRPRSM,FMT=9260) IAUXIL, ISOMAX, IBITGW, IDMIN, IDMAX,
     X                            IBITGS
#ifndef ebug2o
        ENDIF
C
#endif
      ELSE
C
C      Define group width (width of widths).
C
        IBITGW=8
C
      ENDIF
C
      KSEC4(20)=IBITGW
C
      IF (OCOMGR) THEN
C
        KSEC4(19)=ILENSO
        KNBIFO=INBIFO
        KFIROV=IFIROV
C
      ENDIF
C
C     -----------------------------------------------------------------
C     Compute full length of section 4 of GRIB.
C     -----------------------------------------------------------------
C 
      IF (LGENXT) THEN
C
        ILENGS=IFIROV*IBITGS
        KLEN4=IXLEN4 ( ILDSTG, IFIROV, IBITGW, ILENGS )
C
#ifndef ebug2o
        IF (ODEBUG) THEN
#endif
          WRITE(GRPRSM,FMT=9270) KLEN4
          ILEN4O=KLEN4
#ifndef ebug2o
        ENDIF
C
#endif
C     -----------------------------------------------------------------
C        Try to reduce size of lengthes descriptors, splitting groups
C        that require exactly IBITGS bits for their lengthes.
C     -----------------------------------------------------------------
C
        IAUXIL=MIN (KLWORK/2,IFIROV)
C
  270   CONTINUE
C
        IGROUP=0
        IGRADD=0
        IDMAX=KPOWER(IBITGS-1)+1
C
        DO 271 J=1,IFIROV
C
        IF (KLENGR(J).GE.IDMAX) THEN
C
          IF (IGROUP.GE.IAUXIL) THEN
C
C           Out of work space. No (further) splitting performed.
C
            KLWORX=MAX (KLWORX,IAUXIL+IGROUP)
            GOTO 280
C
          ELSE
C
C           Compute number of sub-groups that would replace current
C           group, with a length requiring one bit less for encoding.
C           (2, except when original length=2**IBITGS-1, where 3
C            sub-groups are necessary)
C
C
            IGROUP=IGROUP+1
            KWORK(IGROUP)=J
            KWORK(IAUXIL+IGROUP)=1+(KLENGR(J)+1)/IDMAX
            IGRADD=IGRADD+KWORK(IAUXIL+IGROUP)
C  
          ENDIF
C
        ENDIF
C
  271   CONTINUE
C
        IGRADD=IGRADD-IGROUP
        IGROUS=IFIROV+IGRADD
        ILENGS=IGROUS*(IBITGS-1)
        ILEN4S=IXLEN4 ( ILDSTG, IGROUS, IBITGW, ILENGS )
        KLWORX=MAX (KLWORX,IAUXIL+IGROUP)
C
#ifndef ebug2o
        IF (ODEBUG) THEN
#endif
          WRITE(GRPRSM,FMT=9271) IFIROV, IGRADD, ILEN4S
#ifndef ebug2o
        ENDIF
C
#endif
        IF (IGROUS.LE.KLWORK.AND.ILEN4S.LT.KLEN4) THEN
C
C         Splitting performed, leading to better compression ratio
C         with some shorter groups.
C
          ILASTG=IFIROV
C
          DO 275 J=IGROUP,1,-1
C
          IPOSGR=KWORK(J)
          INGRAD=KWORK(IAUXIL+J)
C
C         Push up groups above current group to split.
C
#ifdef CRAY
CDIR$ IVDEP
#endif
#ifdef FUJITSU
!OCL NOVREC
#endif
          DO 273 J2=ILASTG,IPOSGR+1,-1
C
          KREFGR(J2+IGRADD)=KREFGR(J2)
          KBITGR(J2+IGRADD)=KBITGR(J2)
          KLENGR(J2+IGRADD)=KLENGR(J2)
C
  273     CONTINUE
C
#ifdef ebug2o
          PRINT *,'c2gene - after loop 273: ',IPOSGR+1+IGRADD
#endif
C
C         Split current group.
C
#ifdef CRAY
CDIR$ NOVECTOR
#endif
#ifdef FUJITSU
!OCL SCALAR
#endif
          DO 274 J2=INGRAD,1,-1
C
          INDNEW=J2-INGRAD+IGRADD+IPOSGR
#ifdef ebug2o
          PRINT *,INDNEW
#endif
          KREFGR(INDNEW)=KREFGR(IPOSGR)
          KBITGR(INDNEW)=KBITGR(IPOSGR)
          KLENGR(INDNEW)=(KLENGR(IPOSGR)+INGRAD-J2)/INGRAD
C
  274     CONTINUE
#ifdef CRAY
CDIR$ VECTOR
#endif
#ifdef FUJITSU
!OCL VECTOR
#endif
C
#ifdef ebug2o
          PRINT *,'c2gene - J/IPOSGR/INGRAD/ILASTG/IGRADD/len=',
     X             J, IPOSGR, INGRAD, ILASTG, IGRADD,
     X        (KLENGR(J2-INGRAD+IGRADD+IPOSGR),J2=1,INGRAD)
#endif
C
          IGRADD=IGRADD-(INGRAD-1)
          ILASTG=IPOSGR-1
C
  275     CONTINUE
C
#ifndef ebug2o
          IF (ODEBUG) THEN
#endif
            WRITE(GRPRSM,FMT=9272) IGROUS, IBITGS-1
#ifndef ebug2o
          ENDIF
C
#endif
C
C         Update descriptors.
C
          IBITGS=IBITGS-1
          IFIROV=IGROUS
          KLWORX=MAX (KLWORX,IGROUS)
          KSEC4(17)=IBITGS
          KFIROV=IFIROV
          KLEN4=ILEN4S
C
C         Loop back to try another splitting.
C
          GOTO 270
C
        ELSEIF (KLEN4.NE.ILEN4O) THEN
C
#ifndef ebug2o
          IF (ODEBUG) THEN
#endif
            ZGAIN=REAL (100*(ILEN4O-KLEN4)) / REAL (ILEN4O)
            WRITE(GRPRSM,FMT=9273) ZGAIN
#ifndef ebug2o
          ENDIF
C
#endif
        ENDIF
C
      ELSE
C
        KLEN4=IXLEN4 ( ILDSTA, IFIROV, IBITGW, KLEN )
C
      ENDIF
C
  280 CONTINUE
C
      IF (OLONLY) THEN
C
C       Length has been computed, go back without any coding.
C
        GOTO 900
C
      ENDIF
C
C     -----------------------------------------------------------------
C*    Section 3. Definition of fixed-length descriptors, and coding.
C     -----------------------------------------------------------------
C
  300 CONTINUE
C
C     The first 10 octets have already been coded in GRIBEX, or will
C     be in a further step of GRIBEX:
C     Length of section, flags+unused bit count, binary scale factor,
C     reference value.
C
#ifndef ebug2o
      IF (ODEBUG) THEN
#endif
        WRITE(GRPRSM,FMT=9300) 
#ifndef ebug2o
      ENDIF
C
#endif
C     Enforce right values for extended flags.
C
      IF (LGENXT) THEN
        KSEC4( 9)=0
        KSEC4(12)=8
      ELSE
        KSEC4( 9)=32
        KSEC4(12)=0
      ENDIF      
C
      KSEC4(10)=16
C
C     Extra descriptors.
C
      KSEC4(18)=KFIROV
      KSEC4(20)=IBITGW
      ILWORK=KLWORK-ISTART+1
C
      IRETFN = C2PACK ( KDATA,  KLENP,  KSEC4,  KGRIB,  KLENG,  KNSPT,
     X                  KBITS,  KLEN,   KREFGR(ISTART), KLENGR(ISTART),
     X                  KBITGR(ISTART), KWORK, ILWORK,  KPOWER, KMXPWR,
     X                  KNBIFO, ODEBUG )
C
C     -----------------------------------------------------------------
C*    Section 9. Return to calling routine.
C     -----------------------------------------------------------------
C
  900 CONTINUE
C
      C2GENE = IRETFN
#ifndef ebug2o
C
      IF (ODEBUG) THEN
#endif
        WRITE(GRPRSM,FMT=9900) IRETFN, OCOMGR, OLONLY, KNSPT
#ifndef ebug2o
      ENDIF
#endif
C
      RETURN
C
 9100 FORMAT (' C2GENE: Function start, OCOMGR = ',L1,
     X        ', OLONLY = ',L1,', KNSPT =',I10,'.')
 9101 FORMAT (' C2GENE: Type of 2nd order packing requested: ',A,'.')
C
 9200 FORMAT (' C2GENE: Computing work arrays, INBITO =',I3,'.',/,
     X        ' C2GENE: KSEC4(1:15)=',I9,I3,I4,3I3,I2,4I3,4I2,'.',/,
     X        ' C2GENE: INCMIN =',I3,', ISIZEG =',I6,'.')
C
 9240 FORMAT (' C2GENE: Groups number exceeds work space (',I8,') .')
C
 9260 FORMAT (' C2GENE: Min, Max, Width of widths/lengths =',2(I3,','),
     X        I2,' /',2(I8,','),I3,'.')
C
 9270 FORMAT (' C2GENE: Length of section 4 for general extended case:'
     X        ,I9,'.')
 9271 FORMAT (' C2GENE: Group splitting test, from',I8,' groups',SP,
     X        I7,SS,', s4 length',I9,'.')
 9272 FORMAT (' C2GENE: Group splitting performed,',I8,
     X        ' groups, new width of lengths =',I3,'.')
 9273 FORMAT (' C2GENE: Relative gain of group splitting on section 4 ',
     X        'length:',F5.1,' %.')
C
 9300 FORMAT (' C2GENE: Coding phase - calling C2PACK.')
C
 9900 FORMAT (' C2GENE: Function return code=',I6,
     X        ', OCOMGR/OLONLY/KNSPT=',2L1,I10,'.')
C
      END

C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE CHKPREC()
C
C---->
C**** CHKPREC
C
C     Purpose
C     -------
C
C     Determines whether or not the current field is to be
C     considered for 'precipitation' treatment.
C
C
C     Interface
C     ---------
C
C     CALL CHKPREC()
C
C     Input
C     -----
C
C     None
C
C
C     Output
C     ------
C
C     Sets the precipitation threshold if give by environment variable
C     PRECIPITATION_THRESHOLD. Otherwise gives it a default value.
C
C
C     Method
C     ------
C
C     See below.
C
C
C     Externals
C     ---------
C
C     INTLOG  - Logs messages
C
C     Uses common block nifld.common
C
C
C     Author
C     ------
C
C     J.D.Chambers     ECMWF     December 2003
C
C----<
C
C
      IMPLICIT NONE
C
#include "parim.h"
#include "nifld.common"
C
C     Local variables
C
      CHARACTER*20 PTHRESH
      INTEGER IBLANK
      LOGICAL LFIRST
      DATA LFIRST/.TRUE./
      SAVE LFIRST
C
C     -----------------------------------------------------------------|
C*    Section 1. Initialise
C     -----------------------------------------------------------------|
C
  100 CONTINUE
C
      IF( LFIRST ) THEN
        LFIRST = .FALSE.
        CALL GETENV('PRECIPITATION_THRESHOLD',PTHRESH)
        IBLANK = INDEX(PTHRESH, ' ')
        IF( IBLANK.GT.1 ) THEN
          READ(PTHRESH,'(F15.8)') ZPRECIP
        ELSE
          ZPRECIP = 0.00005
        ENDIF
C
        CALL INTLOGR(JP_DEBUG,
     X    'CHKPREC: PRECIPITATION_THRESHOLD = ',ZPRECIP)
      ENDIF
C
C     -----------------------------------------------------------------|
C*    Section 9.   Return
C     -----------------------------------------------------------------|
C
  900 CONTINUE
      RETURN
      END

      SUBROUTINE GRSDEF
C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C
C
C---->
C**** GRSDEF
C
C     Purpose.
C     --------
C     Sets initial values for common area variables and environment
C     variables for the GRIBEX package, if not already done.
C
C
C     Interface.
C     ----------
C     CALL GRSDEF

C
C     Input Parameters.
C     -----------------
C     None.
C
C
C     Output Parameters.
C     ------------------
C     None.
C
C
C     Method.
C     -------
C     Self-explanatory.
C
C
C     Externals.
C     ----------
C     EMOSNUM - Returns current EMOSLIB version number
C
C
C     Reference.
C     ----------
C     See subroutine GRIBEX.
C
C
C     Comments.
C     ---------
C     None
C
C
C     Author.
C     -------
C     J. Clochard, Meteo France, for ECMWF - March 1998.
C
C
C     Modifications.
C     --------------
C     J. Clochard, Meteo France, for ECMWF - June 1999.
C     Add variable NSUBCE.
C     Use a static variable to determine if initialisation has already
C     been done. NUSER removed .
C     Reverse defaults for NEXT2O and NLOC2O, for consistency with
C     version 13.023 of software .
C
C     J.D.Chambers     ECMWF   September 2002
C     Read environment variables first time through.
C
C     E. Fucile   ECMWF  October 2008
C     added environment variable GRIBEX_DUMP_DATA_ON_ERROR
C     to dump data files in a file when an error occurs
C
C----<
C     ----------------------------------------------------------------
C*    Section 0 . Definition of variables.
C     ----------------------------------------------------------------
C
      IMPLICIT NONE
C
#include "common/grprs.h"
#include "grbcom.h"
C
C     Local variables
C
      INTEGER IOFFSET
      CHARACTER*10 HNDBG, HNVCK, YNUMBER
      CHARACTER*256 HDEFAULT, HBTDEFT
      LOGICAL LFIRST
      SAVE LFIRST
C
#ifdef TABLE_PATH
      DATA HDEFAULT 
     X / TABLE_PATH /
#else
      DATA HDEFAULT / '' /
#endif

#ifdef __uxp__
      DATA HBTDEFT /'/vpp700/mrfs/postproc/'/
#else
c      DATA HBTDEFT /'/home/ma/emos/tables/'/
      DATA HBTDEFT /'/usr/local/apps/libemos/tables/'/
#endif
C
      DATA LFIRST / .TRUE. /
C
C     External(s)
C
      INTEGER EMOSNUM
C
C     ----------------------------------------------------------------
C*    Section 1 . Set values, conditionally.
C     ----------------------------------------------------------------
C
  100 CONTINUE
C
      IF( .NOT. LFIRST) GOTO 900
C
C     Mark common area values set.
      LFIRST = .FALSE.
C
C     Common area variables have not been set. Set them.
C
C     User supplied reference value.
      FREF   = 0.0
C
C     Reference value supplied by user flag. Set to off.
      NFREF  = 0
C
C     User supplied maximum value.
      FMAX   = 0.0
C
C     Maximum value supplied by user flag. Set to off.
      NFMAX  = 0
C
C     Set rounding to 120 bytes on.
      NRND   = 1
C
C     Set P factor switch to default, user supplies the P factor.
      NONOFF = 0
C
C     Set abort flag to NO abort
      NOABORT = 1
C
C     Exhaustive use of all possible second-order packing methods
C     for HOPER='K'. Set to off.
      NUM2OK  = 0
C
C     Use of extended second-order packing methods for grid-point
C     encoding (HOPER='C' and 'K'). Set to on.
      NEXT2O  = 1
C
C     Use of non-local second-order packing methods for grid-point
C     encoding (HOPER='C' and 'K'). Set to on.
      NLOC2O  = 1
C
C     Use of (all valid) sub-centre values for ECMWF fields encoding .
C     encoding. Set to off.
      NSUBCE  = 0
C
C     ----------------------------------------------------------------
C*    Section 2. Set up values controlled by environment variables
C     ----------------------------------------------------------------
C
  200 CONTINUE
C
C     Set debug print on/off.
C
      NDBG   = 0
      CALL GETENV('GRIBEX_DEBUG',HNDBG)
      IOFFSET = INDEX( HNDBG, ' ')
      IF( IOFFSET.GT.1 ) THEN
        IF( HNDBG(1:2).EQ.'ON') THEN
          NDBG = 1
        ELSE IF( HNDBG(1:1).EQ.'1') THEN
          NDBG = 1
        ELSE IF( HNDBG(1:1).EQ.'2') THEN
          NDBG = 2
        ELSE
          NDBG = 0
        ENDIF
      ENDIF
C
C     Set DUMPDATA to dump data values on error
C
      DUMPDATA   = 0
      CALL GETENV('GRIBEX_DUMP_DATA_ON_ERROR',DUMPPATH)
      IOFFSET = INDEX( DUMPPATH, ' ')
      IF( IOFFSET.GT.2 ) THEN
        IF( DUMPPATH(1:3).EQ.'OFF') THEN
          DUMPDATA=0
        ELSE
          DUMPDATA=1
        ENDIF
      ENDIF

C
C     Set GRIB value checking on/off.
C
      NVCK   = 1
      CALL GETENV('GRIBEX_CHECK',HNVCK)
      IOFFSET = INDEX( HNVCK, ' ')
      IF( IOFFSET.GT.2 ) THEN
        IF( HNVCK(1:3).EQ.'OFF') THEN
          NVCK = 0
        ELSE
          NVCK = 1
        ENDIF
      ENDIF
C
C     See if output stream needs changing
C
      CALL GETENV('GRPRS_STREAM', YNUMBER)
      IOFFSET = INDEX( YNUMBER, ' ')
      IF( IOFFSET.GT.1 ) THEN
        IF( IOFFSET.EQ.2 ) THEN
          READ(YNUMBER,'(I1.1)') GRPRSM
        ELSE IF( IOFFSET.EQ.3 ) THEN
          READ(YNUMBER,'(I2.2)') GRPRSM
        ELSE
          WRITE(GRPRSM,*)
     X    'GRSDEF: Invalid value for GRPRS_STREAM: ' // YNUMBER
          GRPRSM = 6
        ENDIF
      ELSE
        GRPRSM = 6
      ENDIF
C
      IF( GRPRSM.LT.1 ) THEN
        WRITE(*,*) 'GRSDEF: Invalid number for GRPRS_STREAM: ', GRPRSM
        GRPRSM = 6
      ENDIF
C
C     Set EMOSLIB version number
C
      IF( (NEMOSLB.EQ.0).OR.(NEMOSET.EQ.0) ) THEN
        IF( NDBG.GT.0 ) THEN
          NEMOSLB = EMOSNUM(0)
        ELSE
          NEMOSLB = EMOSNUM(1)
        ENDIF
        NEMOSET = 1
      ENDIF
C
C     Set pathname for parameter table lookup
C
      CALL GETENV( 'ECMWF_LOCAL_TABLE_PATH', ELTPATH)
      IOFFSET = INDEX( ELTPATH, ' ')
      IF( IOFFSET.LE.1 ) THEN
      IOFFSET = INDEX(HDEFAULT,' ') - 1
       IF(IOFFSET.GT.0) THEN
           ELTPATH = HDEFAULT(1:IOFFSET)//'/gribtables/'
       ELSE 
c           ELTPATH = '/usr/local/lib/metaps/tables/gribex/'
c           ELTPATH = '/home/ma/emos/tables/gribex/'
           ELTPATH = '/usr/local/apps/libemos/tables/gribex/'
       ENDIF
      ENDIF
C
C     Set pathname for bitmask file
C
      CALL GETENV( 'LOCAL_BITMAP_PATH', ELBPATH)
      IOFFSET = INDEX( ELBPATH, ' ')
      IF(IOFFSET.LE. 1) THEN
        ELBPATH = HBTDEFT
      ENDIF
C
C     Display values if debug is ON
C
      IF( NDBG.GT.0 ) THEN
C
        WRITE(GRPRSM,*) 'GRSDEF: ***********************************'
        WRITE(GRPRSM,*) 'GRSDEF: Environment variable settings:'
C
        WRITE(GRPRSM,*) 'GRSDEF: GRIBEX_DEBUG is ON'
C
        IF( NVCK.GT.0 ) THEN
          WRITE(GRPRSM,*) 'GRSDEF: GRIBEX_CHECK is ON'
        ELSE
          WRITE(GRPRSM,*) 'GRSDEF: GRIBEX_CHECK is OFF'
        ENDIF
C
        WRITE(GRPRSM,*) 'GRSDEF: GRPRS_STREAM is ', GRPRSM
C
        WRITE(GRPRSM,9000) NEMOSLB
C
        IOFFSET = INDEX( ELTPATH, ' ')
        WRITE(GRPRSM,*)
     X    'GRSDEF: ECMWF_LOCAL_TABLE_PATH is ' // ELTPATH(1:IOFFSET)
C
        IOFFSET = INDEX( ELBPATH, ' ')
        WRITE(GRPRSM,*)
     X    'GRSDEF: LOCAL_BITMAP_PATH is ' // ELBPATH(1:IOFFSET)
C
        WRITE(GRPRSM,*) 'GRSDEF: ***********************************'
      ENDIF
C
C     ----------------------------------------------------------------
C*    Section 9 . Return to calling routine.
C     ----------------------------------------------------------------
C
  900 CONTINUE
C
      RETURN
 9000 FORMAT(' GRSDEF: EMOSLIB version number (EMOS_CYCLE) is ',(I6.6))
C
      END

C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

       PROGRAM CREX
C
C**** *CREX*
C
C
C     PURPOSE.
C     --------
C         Example of creating CREX message
C
C
C**   INTERFACE.
C     ----------
C
C          NONE.
C
C     METHOD.
C     -------
C
C          NONE.
C
C
C     EXTERNALS.
C     ----------
C
C
C     REFERENCE.
C     ----------
C
C          NONE.
C
C     AUTHOR.
C     -------
C
C          MILAN DRAGOSAVAC    *ECMWF*       07/01/2004.
C
C
C     MODIFICATIONS.
C     --------------
C
C          NONE.
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
      PARAMETER(JSUP =   9,JSEC0=   3,JSEC1= 40,JSEC3=    4,
     1          JBUFL= 8192)
C
      PARAMETER (KDLEN=200,KELEM=2000)
      PARAMETER (KVALS=80000)
C 
      DIMENSION KBUFR(JBUFL)
      DIMENSION KSEC0(JSEC0),KSEC1(JSEC1), KSEC3(JSEC3)
C
      REAL*8  VALUES(KVALS)
      REAL*8 RVIND
C
      DIMENSION KDATA(KDLEN)
C
      CHARACTER*6  CREXKTDLST(KELEM),CREXKTDEXP(KELEM)
      CHARACTER*64 CNAMES(kelem)
      CHARACTER*24 CUNITS(kelem)
      CHARACTER*80 CVALS(KVALS)
      CHARACTER*80 YENC
      CHARACTER*256 COUT, CARG(4)
C      
      CHARACTER*15000 YOUT
      EQUIVALENCE(KBUFR(1),YOUT)
C
C                                                                       
C     ------------------------------------------------------------------
C*          1. INITIALIZE CONSTANTS AND VARIABLES.
C              -----------------------------------
 100  CONTINUE
C
      RVIND=1.7D38
      NVIND=2147483647
C
C     GET INPUT AND OUTPUT FILE NAME.
C
      NARG=IARGC()
C
      IF(NARG.LT.2) THEN
         print*,'Usage -- create_crex -o outfile'
         STOP
      END IF
C
      COUT=' '
      CFIN=' '
C
      DO 101 J=1,NARG
      CALL GETARG(J,CARG(J))
 101  CONTINUE
C
      DO 102 J=1,NARG,2
        IF(CARG(J).EQ.'-o') THEN
           COUT=CARG(J+1)
        ELSE
            print*,'Usage -- create_crex -o outfile'
            STOP
        END IF
 102  CONTINUE
C
      JJ=INDEX(COUT,' ')
      JJ=JJ-1
C
      CALL PBOPEN(IUNIT1,COUT(1:JJ),'w',IRET)
      IF(IRET.EQ.-1) STOP 'open failed on bufr.dat'
      IF(IRET.EQ.-2) STOP 'Invalid file name'
      IF(IRET.EQ.-3) STOP 'Invalid open mode specified'
C
C     INITIALIZE DELAYED REPLICATION FACTORS OR REFERENCE VALUES ETD.
C
      KDATA( 1)=0
      KDATA( 2)=0
      KDATA( 3)=0
      KDATA( 4)=0
C
      DO I=5,KDLEN
       KDATA(I)=0
      END DO
C
      KDLENG=200
C
C     SET DATA DECSRIPTORS
C
      CREXKTDLST(  1)= "D07005"
c
      KTDLEN=1

      KSEC0(1)=0
      KSEC0(2)=0
      KSEC0(3)=2      ! Crex edition number
C
C     SECTION 1 CONTENT
C
      KSEC1(1)=0
      KSEC1(2)=2     ! CREX Edition number (currently)
      KSEC1(3)=98    ! Originating centre
      KSEC1(4)=0     ! Update sequence number
      KSEC1(5)=1     ! Number of subsets
      KSEC1(6)=0     ! CREX data category
      KSEC1(7)=2     ! International data sub-category
      KSEC1(8)=0     ! version number of local table used
      KSEC1(9)=2003  ! Year
      KSEC1(10)=12   ! Month
      KSEC1(11)=2   ! Day
      KSEC1(12)=12   ! Hour
      KSEC1(13)=0    ! Minute
      KSEC1(14)=0    ! CREX Master table ( 0 for standard WMO crex tables)
      KSEC1(15)=3    ! CREX table version number
      KSEC1(16)=0    ! Originating sub-centre
      KSEC1(17)=14   ! BUFR master table version number
      KSEC1(18)=0    ! BUFR local table version number
C

      K=1
      CALL CREXDES(K,KSEC1,KTDLEN,CREXKTDLST,KDLEN,KDATA,KELEM,
     1            KTDEXL,CREXKTDEXP,CNAMES,CUNITS,KERR)
      IF(KERR.NE.0) THEN
         print*,'CREXDES: error'
         STOP
      END IF

C
C     SET VALUES TO BE PACKED
C
      K=1
      KSUBSETS=1
c
      DO J=1,KSUBSETS

      IK=(J-1)*KELEM
      N=1
      VALUES(N+IK)=13.         ! Block number
      N=N+1                    !
      VALUES(N+IK)=274.        ! station number
      N=N+1                    !
      VALUES(N+IK)=0.          ! type of station
      N=N+1                    !
      VALUES(N+IK)=2003.       ! year
      N=N+1                    !
      VALUES(N+IK)=12.         ! month
      N=N+1                    !
      VALUES(N+IK)=2.          ! day
      N=N+1                    !
      VALUES(N+IK)=12.         ! hour
      N=N+1                    !
      VALUES(N+IK)=0.          ! minute
      N=N+1
      VALUES(N+IK)=45.2        ! lat
      N=N+1                    !
      VALUES(N+IK)=20.5        ! lon
      N=N+1                    !
      VALUES(N+IK)=170.        ! station height
      N=N+1                    !
      VALUES(N+IK)=102000.     ! station level pressure
      N=N+1
      VALUES(N+IK)=102500.     ! msl pressure
      N=N+1                    !
      VALUES(N+IK)=100.        ! pressure change
      N=N+1                    !
      VALUES(N+IK)=rvind       ! characteristic of pressure change
      N=N+1                    !
      VALUES(N+IK)=300.        ! wind dir
      N=N+1                    !
      VALUES(N+IK)=8.5         ! wind speed
      N=N+1                    !
      VALUES(N+IK)=-5.0        ! T
      N=N+1                    !
      VALUES(N+IK)=-7.0        ! Td
      N=N+1                    !
      VALUES(N+IK)=70.         ! RH
      N=N+1                    !
      VALUES(N+IK)=1000.       ! visibility
      N=N+1                    !
      VALUES(N+IK)=rvind          
      N=N+1                    !
      VALUES(N+IK)=rvind
      N=N+1                    !
      VALUES(N+IK)=rvind         
      N=N+1                    !
      VALUES(N+IK)=rvind
      N=N+1                    !
      VALUES(N+IK)=rvind
c
      DO I=N,47
      N=N+1                    !
      VALUES(N+IK)=rvind        
      END DO
C                    !
      END DO                    !
C
C     SET CCITTIA5 CALL SIGN 
C
      DO I=1,200
      CVALS( I )=' '
      END DO
C
C
C     SECTION 3 CONTENT
C
      KSEC3(1)=0         ! TOTAL LENGTH OF SECTION 3
      KSEC3(2)=0         ! RESERVED
      KSEC3(3)= ksubsets ! NUMBER OF SUBSETS
      KSEC3(4)=0
C
      IREP=0
C
C
C*          6. PACK CREX MESSAGE
C              -----------------
 600  CONTINUE
C
C
      KERR=0
      CALL CREXEN( KSEC0,KSEC1,KSEC3,
     1             KTDLEN,crexKTDLST,KDLENG,KDATA,KELEM,
     2             KVALS,VALUES,CVALS,KBUFL,KBUFR,KERR)
C

      IF(KERR.GT.0) THEN
         CALL EXIT(2)
      ELSEIF(KERR.lt.0) then
         print*,'Encoding return_code=',kerr
      END IF 
C
C
      ILEN=KBUFL
C     ILEN=KSEC0(2)
C
      IERR=0
      CALL PBWRITE(IUNIT1,KBUFR,ILEN,IERR)
      IF(IERR.LT.0) THEN
         print*,'Error writing into target file.'
         CALL EXIT(2)
      END IF
C
C     Print CREX message on screen
      print*,yout(1:ilen)
C
C     -----------------------------------------------------------------
C
 900  CONTINUE
C
      STOP
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities
C granted to it by virtue of its status as an intergovernmental organisation
C nor does it submit to any jurisdiction.
C

      INTEGER FUNCTION KINTRG(OLDGEO,NEWGEO,OLDFLD,NEWFLD)
C
C---->
C**** KINTRG
C
C     Purpose
C     -------
C     Interpolate a reduced gaussian field a reduced gaussian field
C     with a different resolution.
C
C
C     Interface
C     ---------
C     IRET = KINTRG(OLDGEO,NEWGEO,OLDFLD,NEWFLD)
C
C     Input
C     -----
C     OLDGEO - GRIB section 2 describing grid of old field.
C     NEWGEO - GRIB section 2 describing grid of new field.
C     OLDFLD - Array of values for old field.
C
C
C     Output
C     ------
C     NEWFLD - Array of values for new field.
C
C     Function returns:
C       - number of points in the new field, if all is well
C       - negative, otherwise.
C
C
C     Method
C     ------
C     Build up field offsets from input geometries.
C     For each point of the new field, find in the old field the four
C     nearest neighbours' positions and values.
C     Calculate new value from the neighbours.
C
C
C     Externals
C     ---------
C
C     IGGLAT  - Compute gaussian lines of latitude
C     JNORSGG - Find gaussian latitudes to north and south of latitude
C     KNFROM4 - Calculate value of new field point
C     INTLOG  - Logs messages
C     FORCED_NEAREST_NEIGHBOUR - check forced interpolation method
C
C
C     Author
C     ------
C     J.D.Chambers     ECMWF     November 2000
C
C     Modifications
C     -------------
C
C     Force nearest neighbour processing with env variable or
C     INTOUT parameter
C     S.Curic           ECMWF    September 2005
C
C     Add fudging factor for computation of index in original field
C     S.Curic           ECMWF    October 2006
C
C     Leave comments after adding support for octahedral grids
C     S.Siemen          ECMWF    April 2015
C
C----<
C
      IMPLICIT NONE
C
C     Function arguments
C
      INTEGER OLDGEO(*),NEWGEO(*)
      REAL OLDFLD(*),NEWFLD(*)
C
#include "intisl.h"
#include "parim.h"
#include "nifld.common"
#include "nofld.common"
C
C     Local variables
C
      LOGICAL LVEGGY
      INTEGER TOTAL, NEXT, LOOP, NEWOFF(JPMAXNG), OLDOFF(JPMAXNG)
      INTEGER LATIT, LONG, IRET, NPTS
      INTEGER LAT(2), LON(4)
      INTEGER PT(4)
      REAL OLAT(2), OLON(4)
      REAL RLATOLD(JPMAXNG), RLATNEW(JPMAXNG), RLAT, RLON
C
C     Externals
C
      LOGICAL FORCED_NEAREST_NEIGHBOUR
      INTEGER IGGLAT, JNORSGG
      REAL KNFROM4
      EXTERNAL IGGLAT, JNORSGG, KNFROM4
C
C     -----------------------------------------------------------------|
C*    Section 1.   Build working values using input geometries.
C     -----------------------------------------------------------------|
C
  100 CONTINUE
C
      KINTRG = 0
C
      IF( (NEWGEO(NGAUSS)*2).GT.JPMAXNG ) THEN
        CALL INTLOG(JP_ERROR,
     X    'KINTRG: Gaussian N too big = ',NEWGEO(NGAUSS))
        CALL INTLOG(JP_ERROR,'KINTRG: Maximum handled = ',(JPMAXNG/2))
        KINTRG = -1
        GOTO 900
      ENDIF
C
cs   set global for grib_api
      LGLOBL = .TRUE.
cs
C     Use nearest neighbour if required
      LVEGGY = FORCED_NEAREST_NEIGHBOUR(LMETHOD,NITABLE,NIPARAM)
      IF( LVEGGY ) CALL INTLOG(JP_DEBUG,
     X  'KINTRG: nearest neighbour processing',JPQUIET)
C
C     -----------------------------------------------------------------|
C*    Section 2.   Calculate number of points in new field and offset
C                  to start of each latitude in the new grid
C     -----------------------------------------------------------------|
C
  200 CONTINUE
C
      NEWOFF(1) = 0
      TOTAL = NEWGEO(NPOINTS)
C
C     For all latitudes ...
C
      DO LOOP = 2, NEWGEO(NJ)
        NEWOFF(LOOP) = NEWOFF(LOOP-1) + NEWGEO(NPOINTS-2+LOOP)
        TOTAL = TOTAL + NEWGEO(NPOINTS-1+LOOP)
      ENDDO
C
C     Get the gaussian latitudes for the new field
C
      IRET = IGGLAT(NEWGEO(NGAUSS)*2,RLATNEW,0,-1)
      IF( IRET.NE.0 ) THEN
        WRITE(*,*) 'KINTRG: Problem call igglat for new grid'
        KINTRG = -1
        RETURN
      ENDIF
C
      CALL INTLOG(JP_DEBUG,'KINTRG: No. of pts in new field = ',TOTAL)
C
C     -----------------------------------------------------------------|
C*    Section 3.   Get the gaussian latitudes for the old field and
C                  setup the offsets to the start of each latitude.
C     -----------------------------------------------------------------|
C
  300 CONTINUE
C
      OLDOFF(1) = 0
      DO LOOP = 2, OLDGEO(NJ)
        OLDOFF(LOOP) = OLDOFF(LOOP-1) + OLDGEO(NPOINTS-2+LOOP)
      ENDDO
C
      IRET = IGGLAT(OLDGEO(NGAUSS)*2,RLATOLD,0,-1)
      IF( IRET.NE.0 ) THEN
        WRITE(*,*) 'KINTRG: Problem call igglat for old grid'
        KINTRG = -1
        RETURN
      ENDIF
C
C     -----------------------------------------------------------------|
C*    Section 4.   Work through the points in the new field.
C     -----------------------------------------------------------------|
C
  400 CONTINUE
C
      DO NEXT = 1, TOTAL
C
C       Calculate lat/long
C
C        For all latitudes ...
C
        DO LOOP = 1, NEWGEO(NJ)
          IF( NEWOFF(LOOP).GE.NEXT ) THEN
            LATIT = LOOP - 1
            GOTO 410
          ENDIF
        ENDDO
        LATIT = NEWGEO(NJ)
C
  410   CONTINUE
C
        LONG = NEXT - NEWOFF(LATIT)
C
        RLAT = RLATNEW(LATIT)
        RLON = (REAL(LONG-1)*360.0)/REAL(NEWGEO(NPOINTS+LATIT-1))
C
C       Find four neighbours in the old field with their types
C       (Find NW neighbour and deduce the others).
C
        LAT(NORTH) = JNORSGG(RLAT,RLATOLD,OLDGEO(NGAUSS),1)
        LAT(SOUTH) = JNORSGG(RLAT,RLATOLD,OLDGEO(NGAUSS),0)
C
        OLAT(NORTH) = RLATOLD(LAT(NORTH))
        OLAT(SOUTH) = RLATOLD(LAT(SOUTH))
C
C
C
C
CCCCCCCCCCCCCCCCC  N O R T H  CCCCCCCCCCCCCCCC
C
C       How many points in a row
C
        NPTS = OLDGEO(NPOINTS-1+LAT(NORTH))
C
C       How far in is the longitude
C
        LON(NWEST) = 1 + INT(RLON/(360.0/REAL(NPTS)))
        LON(NEAST) = LON(NWEST) + 1
        IF( LON(NEAST).GT.NPTS ) LON(NEAST) = 1
C
C       Longitude in degree
C
        OLON(NWEST) = (REAL(LON(NWEST)-1)*360.0)/REAL(NPTS)
        IF( LON(NEAST).EQ.1 ) THEN
          OLON(NEAST) = 360.0
        ELSE
          OLON(NEAST) = (REAL(LON(NEAST)-1)*360.0)/REAL(NPTS)
        ENDIF
C
CCCCCCCCCCCCCCCCC  S O U T H  CCCCCCCCCCCCCCCC
C
        NPTS = OLDGEO(NPOINTS-1+LAT(SOUTH))

        LON(SWEST) = 1 + INT(RLON/(360.0/REAL(NPTS)))

        LON(SEAST) = LON(SWEST) + 1
        IF( LON(SEAST).GT.NPTS ) LON(SEAST) = 1
C
        OLON(SWEST) = (REAL(LON(SWEST)-1)*360.0)/REAL(NPTS)
        IF( LON(SEAST).EQ.1 ) THEN
          OLON(SEAST) = 360.0
        ELSE
          OLON(SEAST) = (REAL(LON(SEAST)-1)*360.0)/REAL(NPTS)
        ENDIF
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
        PT(NWEST) = OLDOFF(LAT(NORTH)) + LON(NWEST)
        PT(NEAST) = OLDOFF(LAT(NORTH)) + LON(NEAST)
        PT(SWEST) = OLDOFF(LAT(SOUTH)) + LON(SWEST)
        PT(SEAST) = OLDOFF(LAT(SOUTH)) + LON(SEAST)
C
C        IF (NEXT .LT. 100) THEN
c        WRITE(*,*) 'KINTRG: XXX ',NEXT,' > ',RLAT,' - ',RLON,' > ',NPTS
c        WRITE(*,*) 'KINTRG:  I> : ',PT(NWEST),' ',PT(NEAST),' ',PT(SWEST),' ',PT(SEAST)
C        ENDIF
C
C       Interpolate the new value
C
        NEWFLD(NEXT) = KNFROM4(LVEGGY,RLAT,RLON,OLAT,OLON,PT,OLDFLD)
C
      ENDDO
C
      KINTRG = TOTAL
C
C     -----------------------------------------------------------------|
C*    Section 9.   Return
C     -----------------------------------------------------------------|
C
  900 CONTINUE
C
      RETURN
      END

C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C


      SUBROUTINE GENDIR (HPARAM,KARRAY,KLEN,HLINE,KIN,KOUT,HLAST,KRET)
C
C---->
C**** GENDIR - Generate directive lines for MARS.
C
C     Purpose.
C     --------
C
C           Creates mars directive line(s) in character format
C           from list of integers.
C
C**   Interface.
C     ----------
C
C           CALL GENDIR (HPARAM,KARRAY,KLEN,HLINE,KIN,KOUT,HLAST,KRET)
C
C           Integer    K.
C           Real       P.
C           Logical    O.
C           Character  H.
C
C               Input parameters.
C               -----------------
C
C               HPARAM     - MARS parameter being used.
C               KARRAY     - Array of required values.
C               KLEN       - Number of values.
C               HLINE      - Array of 80 character variables.
C               KIN        - Dimension of array HLINE.
C               HLAST      - Terminating character for directive line(s)
C               KRET       - Abort/no abort when error found.
C                            0   , abort if error found.
C                            Non-zero , no abort on error.
C
C               Output parameters.
C               ------------------
C
C               LINE       - MARS directive line(s)
C               KOUT       - Number of lines generated.
C               KRET       - Error return code.
C                            0   , No error encountered.
C                            1   , Output character array too small.
C
C     Method.
C     -------
C
C           Integers converted to characters and packed to remove
C           spaces. Lines are broken at / character for MARS input.
C
C     Externals.
C     ----------
C
C           RTB
C           REMSP
C
C     Reference.
C     ----------
C
C           MARS User Guide for directive description.
C
C     Comments.
C     ---------
C
C           See also GENINT which performs the reverse function.
C           Program contains sections 0 to 2 and section 9.
C
C     Author.
C     -------
C
C           J. Hennessy      ECMWF      16:10:86.
C
C     Modifications.
C     --------------
C
C           J. Hennessy      ECMWF      10:07:91.
C           Print of error message added.
C
C     ----------------------------------------------------------------
C----<
C
C
C
C
C
C
C
C
C
C
C*    Section 0 . Definition of variables.
C     ----------------------------------------------------------------
C
      IMPLICIT LOGICAL     ( L, O, G )
      IMPLICIT CHARACTER*8 ( C, H, Y )
      IMPLICIT INTEGER     ( I, J, K, M, N )
C
      INTEGER RTB
C
C
      CHARACTER*80  HLINE
      CHARACTER*10  YTEMP
      CHARACTER*(*) HPARAM
      CHARACTER*1   HLAST
C
      DIMENSION KARRAY(*)
      DIMENSION HLINE(KIN)
C
C
C     ----------------------------------------------------------------
C
C
C
C
C
C
C
C
C
C*    Section 1 . Set initial values.
C     ----------------------------------------------------------------
C
 1000 CONTINUE
C
      IRET = KRET
      KRET = 0
C
C     ----------------------------------------------------------------
C
C
C
C
C
C
C
C
C
C*    Section 2 . Convert integer data to required character format.
C     ----------------------------------------------------------------
C
 2000 CONTINUE
C
      KOUT                     = 1
      HLINE(KOUT)(1:)          = HPARAM(1:)
      ILEN                     = RTB (HLINE(KOUT))
      ICHAR                    = ILEN + 1
      HLINE(KOUT)(ICHAR:ICHAR) = '='
      ICHAR                    = ICHAR + 1
C
      DO 2010 I=1,KLEN
         WRITE (YTEMP(1:10),'(I10)') KARRAY(I)
         CALL REMSP (YTEMP)
         ILEN  = RTB (YTEMP)
         ILAST = ILEN + ICHAR
         IF (ILAST.GT.80)
     C      THEN
                ICHAR = 1
                KOUT  = KOUT + 1
                IF (KOUT.GT.KIN)
     C             THEN
                       KRET = 1
		       WRITE (*,9001) KIN , KOUT
                       GO TO 9000
                   ENDIF
            ENDIF
         HLINE(KOUT)(ICHAR:) = YTEMP(1:ILEN)
         ICHAR               = ICHAR + ILEN
         HLINE(KOUT)(ICHAR:) = '/'
         ICHAR               = ICHAR + 1
 2010 CONTINUE
C
      ILEN                   = RTB (HLINE(KOUT))
      HLINE(KOUT)(ILEN:ILEN) = HLAST
C
C     ----------------------------------------------------------------
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C*    Section 9 . Return to calling routine or abort.
C     ------------------------------------------------------------------
C
 9000 CONTINUE
C
 9001 FORMAT (1H ,'GENDIR : Character array is dimensioned ',I3,
     C            ' but should be at least ',I3,'.')
C
      IF (KRET.NE.0.AND.IRET.EQ.0) CALL ABORT
C
      RETURN
C
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities
C granted to it by virtue of its status as an intergovernmental organisation
C nor does it submit to any jurisdiction.
C
      SUBROUTINE GRIBEX (KSEC0,KSEC1,KSEC2,PSEC2,KSEC3,PSEC3,KSEC4,
     C                   PSEC4,KLENP,KGRIB,KLENG,KWORD,HOPER,KRET)
C---->
#include "gribex.h"
C----<
C     -----------------------------------------------------------------|
C*    Section 0 . Definition of variables. Data statements.
C     -----------------------------------------------------------------|
C
      IMPLICIT NONE
C
#include "common/grprs.h"
C
C     Subroutine arguments
C
      INTEGER KSEC0,KSEC1,KSEC2,KSEC3,KSEC4,KGRIB
      DIMENSION KGRIB(*), KSEC0(*), KSEC1(*)
      DIMENSION KSEC2(*), KSEC3(*), KSEC4(*)
      INTEGER KLENP,KLENG,KWORD, KRET
      REAL PSEC2, PSEC3, PSEC4
      DIMENSION PSEC2(*), PSEC3(*), PSEC4(*)
      CHARACTER*(*) HOPER
C
C     Local variables
C
      INTEGER N, NP, NINC
      REAL  JPEPSLN
      PARAMETER (JPEPSLN=1E-12)
C                         `-----> tolerance used to check equality
C                                 of floating point numbers - needed
C                                 on some platforms (eg vpp700, linux)
      CHARACTER*1   YFUNC, YTEMP
      INTEGER IJDC, JLOOP, JLOOPO, ISTATUS, ISECLEN
      INTEGER IDUMP
#ifdef REAL_BIGGER_THAN_INTEGER
      INTEGER IINDEX, ILOOPS, NREM, JPNSEC4, ILNGTH
      PARAMETER (JPNSEC4=12800)
      INTEGER*4 NSEC4
      DIMENSION NSEC4(JPNSEC4)
      REAL*4    XSEC4
      DIMENSION XSEC4(JPNSEC4)
      EQUIVALENCE (NSEC4(1), XSEC4(1))
      INTEGER*8 IJDCXX
      REAL*8    RJDCXX
#else
      INTEGER IJDCXX
      REAL    RJDCXX
#endif
      EQUIVALENCE (IJDCXX, RJDCXX)
      INTEGER I,IBLEN,IBITS,IBMAP,IBMAP2,IBYTEX,ICOUNT,NBYTE
      INTEGER IEXP, IFLAG, IFLAGX, IFPT, IL
      INTEGER ILEN, ILENF, ILEN1, ILEN2, ILEN3, ILEN4
      INTEGER IMANT, IMISNG, IMISS, IMODAY, INC
      INTEGER INIL, INITAL, INOLAT, INOLNG, INSPT, INUB
      INTEGER INUM, IOFF, IPL, IPLEN, IPSEUD
      INTEGER IPVPL, IRESOL, ISBMAP, NONMISS
      INTEGER ISCALE, ISINT, ISKALE
      INTEGER ISKIP, ITEMP, ITRND, IVALS, IP7777
      INTEGER IEAST, IWEST, ILOEXT, INROWS
C
      INTEGER JPEDNO, JPLEN1
      INTEGER KRETA, KRETB
      INTEGER ITRUNC, ISUBSET, IS3BYTE
      INTEGER NBPV
      REAL RANGE
C
C     Wave coordinate information held in KSEC4 are 32-bit REALs,
C     so REAL*4 ZREAL4 must be used for encoding/decoding.
C
      REAL*4  ZREAL4
      REAL    ZMAXV, ZMAX, ZMIN, ZMISNG, ZMSVAL, ZREAL, ZREF, ZVAL
#if defined(CRAY) || defined(CYBER) ||((defined IBM)&&(!defined rs6000))
      REAL    ZS, ZAUXIL
#else
      DOUBLE PRECISION    ZS, ZAUXIL
#endif
      REAL    ZSCALE
C
      LOGICAL LENCODE, LDECODE, LPDEBUG
      LOGICAL LGRDPT, LSPHERC, LCOMPLX
      LOGICAL LECMWF, LECLOC, LKWBCE, LSST11
      LOGICAL LLARGE
      LOGICAL LQUASI, LSECT2, LSECT3, LPERIO
      LOGICAL L_IORJ
      LOGICAL LALLPOS
      LOGICAL LVEGGY
      LOGICAL LSATIMG
      INTEGER NITABLE, NICENTRE, NIPARAM
C
C     Externals
C
      INTEGER EGGSEC2, DGGSEC2, ELLSEC2, DLLSEC2, ESHSEC2, DSHSEC2
      INTEGER EOCSEC2, DOCSEC2, ESVSEC2, DSVSEC2, EMESEC2, DMESEC2
      INTEGER CSECT4, DSECT4A, GBITMAP, D2ORDR, C2ORDR, REF2GRB
      INTEGER ONEBITS, D13FLAG
C#ifdef GRIB2
C     INTEGER G2ENCOD
C     EXTERNAL G2ENCOD
C#endif
      EXTERNAL CSECT4, DSECT4A, GBITMAP, D2ORDR, C2ORDR, REF2GRB
      EXTERNAL EGGSEC2, DGGSEC2, ELLSEC2, DLLSEC2, ESHSEC2, DSHSEC2
      EXTERNAL EOCSEC2, DOCSEC2, ESVSEC2, DSVSEC2, EMESEC2, DMESEC2
      EXTERNAL ONEBITS, D13FLAG
C
C     GRIB code version number used in coding data.
C
      PARAMETER (JPEDNO=1)
C
C     GRIBEX version number
C
      INTEGER IGRIBEX
      CHARACTER*6 YGRIBEX
C
C     Length (in octets) used for Section 1, when coding data.
C
      PARAMETER (JPLEN1=28)
C
      INTEGER IPARM, ILALO, IGRIB, I7777
      DIMENSION IPARM(4), ILALO(2), IGRIB(4), I7777(4)
C
      INTEGER JP24SET, JP23SET, JP16SET, JP8SET
      PARAMETER ( JP24SET = 2**24 - 1 )
C                            ^---> 16777215 = FFFFFF(hex)
      PARAMETER ( JP23SET = 2**23 - 1 )
C                            ^---> 8388607  = 7FFFFF(hex)
      PARAMETER ( JP16SET = 2**16 - 1 )
C                            ^---> 65535    =   FFFF(hex)
      PARAMETER ( JP8SET  = 2**8 - 1 )
C                            ^---> 255      =     FF(hex)
C
C     Predetermined bitmask variables
C
#ifndef USE_NO_POINTERS
      INTEGER IBTMAP, IBTVALS
#ifndef _CRAYFTN
#ifdef POINTER_64
      INTEGER*8 IBTPTR
#endif
#endif
      POINTER (IBTPTR,IBTMAP)
      DIMENSION IBTMAP(1)
#endif
C
#include "grbcom.h"
C
C     Missing data indicator for integer and real values in GRIB code
C     header fields.
C
      EQUIVALENCE (IMISNG,ZMISNG)
C
      EQUIVALENCE (ZREAL4,ISINT)
C
      SAVE INITAL, IBITS, IMISNG, NBYTE
C
C     Characters GRIB and 7777 in Ascii for use in Sections 0 and 5
C     of GRIB code.
C
      DATA IGRIB /71,82,73,66/
      DATA I7777 /55,55,55,55/
      DATA YGRIBEX/'13.040'/, IGRIBEX/13040/
C
C     Initialise local variables
C
      DATA YFUNC/' '/,YTEMP/' '/
      DATA IJDC/0/,JLOOP/0/,JLOOPO/0/
#ifdef REAL_BIGGER_THAN_INTEGER
      DATA IINDEX/0/,ILOOPS/0/,NREM/0/,ILNGTH/0/
#endif
      DATA IJDCXX/0/,I/0/,IBLEN/0/,IBITS/0/,IBMAP/0/,IBMAP2/0/
      DATA IBYTEX/0/,ICOUNT/0/,NBYTE/0/
      DATA IEXP/0/,IFLAG/0/,IFLAGX/0/,IFPT/0/,IL/0/
      DATA ILEN/0/,ILENF/0/,ILEN1/0/,ILEN2/0/,ILEN3/0/,ILEN4/0/
      DATA IMANT/0/,IMISNG/0/,IMISS/0/,IMODAY/0/,INC/0/
      DATA INIL/0/,INITAL/0/,INOLAT/0/,INOLNG/0/,INSPT/0/,INUB/0/
      DATA INUM/0/,IOFF/0/,IPL/0/,IPLEN/0/,IPSEUD/0/
      DATA IPVPL/0/,IRESOL/0/,ISBMAP/0/,NONMISS/0/
      DATA ISCALE/0/,ISINT/0/,ISKALE/0/
      DATA ISKIP/0/,ITEMP/0/,ITRND/0/,IVALS/0/,IP7777/0/
      DATA IEAST/0/,IWEST/0/,ILOEXT/0/,INROWS/0/
C
      DATA KRETA/0/,KRETB/0/,ITRUNC/0/,ISUBSET/0/
C
      DATA ZMAXV/0.0/,ZMAX/0.0/,ZMIN/0.0/,ZMSVAL/0.0/
      DATA ZREF/0.0/,ZVAL/0.0/,ZS/0.0/,ZAUXIL/0.0/,ZSCALE/0.0/
C
      DATA LENCODE/.FALSE./,LDECODE/.FALSE./,LPDEBUG/.FALSE./
      DATA LGRDPT/.FALSE./,LSPHERC/.FALSE./,LCOMPLX/.FALSE./
      DATA LECMWF/.FALSE./,LECLOC/.FALSE./,LKWBCE/.FALSE./
      DATA LSST11/.FALSE./,LLARGE/.FALSE./,LQUASI/.FALSE./
      DATA LSECT2/.FALSE./,LSECT3/.FALSE./,LPERIO/.FALSE./
      DATA L_IORJ/.FALSE./,LALLPOS/.FALSE./
C
C     -----------------------------------------------------------------|
C*    Section 1 . Set initial values.
C     -----------------------------------------------------------------|
C
  100 CONTINUE
      ISECLEN = 0
C
CC    Avoid using GRIBEX at (almost) all costs
      WRITE(GRPRSM,*) 'GRIBEX: functionality superseded by GRIB_API.'
#ifdef GRIBEX_ABORT
      CALL ABORTX('GRIBEX')
#endif
C
C     Handle 'V' option - display version number
C
      IF( HOPER(1:1).EQ.'V' ) THEN
        WRITE(GRPRSM,*) 'GRIBEX: Version is ',YGRIBEX
        KRET = IGRIBEX
        RETURN
      ENDIF
C
C     Clear definition 13  flag
C
      N13FLAG = -1
C
C     Clear flag indicating GRIB product longer than 2**23-1 bytes long.
      LLARGE = .FALSE.
C
C     Initialise flag indicating 'quasi-regular grid'
      LQUASI = .FALSE.
C
C*    Set number of bits per computer word,missing data indicator and
C     the number of bytes per computer word first time through.
C     Try to set default values for parameters in common area,
C     if not already set by user via calls to the GRS--- routines.
C
      IF( INITAL.EQ.0) THEN
        CALL SETPAR (IBITS,IMISNG,NDBG)
        NBYTE = IBITS/8
        INITAL = 1
        CALL GRSDEF
      ENDIF
C
      IMISS = 0
C
C
C     Set encoding/decoding flags initially dependent on 'L' option,
C     since this option skips round most processing.
      LENCODE = ( HOPER(1:1) .NE. 'L' )
      LDECODE = ( HOPER(1:1) .EQ. 'L' )
C
      LPDEBUG = ( NDBG.GE.1 )
C
      IF( LPDEBUG ) THEN
        WRITE(GRPRSM,*) 'GRIBEX: Version is ',YGRIBEX
        WRITE(GRPRSM,*) 'GRIBEX: Section 1. Input values used -'
        WRITE(GRPRSM,*)
     X  'GRIBEX: Length of GRIB array (KLENG) = ',KLENG
        WRITE(GRPRSM,*)
     X  'GRIBEX: Length of data array (KLENP) = ',KLENP
        WRITE(GRPRSM,*) 'GRIBEX: Operation code = ', HOPER
Ce
Ce      Extra printout if encoding
Ce
        IF( HOPER.EQ.'C'.OR.HOPER.EQ.'M'.OR.HOPER.EQ.'K') THEN
          KSEC0(2) = JPEDNO
          CALL GRPRS1(KSEC0,KSEC1)
Ce
          LSECT2 = KSEC1(5).GE.128
          LSECT3 = MOD(KSEC1(5),128).GE.64
Ce
Ce        Print section 2 if present.
Ce
          IF( LSECT2 ) CALL GRPRS2(KSEC0,KSEC2,PSEC2)
Ce
Ce        Print section 3 if present.
Ce
          IF( LSECT3 ) CALL GRPRS3(KSEC0,KSEC3,PSEC3)
Ce
Ce        Print section 4.
Ce
          CALL GRPRS4(KSEC0,KSEC4,PSEC4)
Ce
Ce        Special print for 2D spectra wave field real values in
Ce        section 4
Ce
          IF( (KSEC1(1).EQ.140) .AND.
     X        (KSEC1(2).EQ. 98) .AND.
     X        (KSEC1(24).EQ. 1) .AND.
     X        ( (KSEC1(40).EQ.1045).OR.(KSEC1(40).EQ.1081) ) .AND.
     X        ( (KSEC1(6) .EQ. 250).OR.(KSEC1(6) .EQ. 251) ) )
     X      CALL GRPRS4W(KSEC4)
        ENDIF
      ENDIF
C
C     Reset return code to 0, retaining input value to decide
C     on abort / no abort, if error encountered later.
C
      NOABORT = KRET
      KRET    = 0
C
C     IPSEUD is used to indicate pseudo-GRIB data encountered,
C     when decoding.
C     ISBMAP is the bit-map section flag and indicates what decoding
C     has been done on bit-maps and data.
C     See informative return codes for KRET when decoding.
C
      IPSEUD = 0
      ISBMAP = 0
C
C     Reset bit-pointer to 0.
C
      INSPT = 0
C
C     -----------------------------------------------------------------|
C
C
C
C
C
C
C
C
C
C
C*    Section 2 . Check input parameters.
C     -----------------------------------------------------------------|
C
  200 CONTINUE
C
      IF( LPDEBUG ) WRITE(GRPRSM,*)
     X 'GRIBEX: Section 2. Check input parameters.'
C
C*    Check that valid function has been requested.
C
      YFUNC = HOPER
#ifdef USE_NO_POINTERS
      IF( YFUNC.EQ.'R' ) THEN
        KRET = 201
        WRITE(GRPRSM,*) 'GRIBEX: Invalid function requested - ',HOPER
        WRITE(GRPRSM,*) 'GRIBEX: Return code = ', KRET
        GO TO 900
      ENDIF
#endif
      L_IORJ = (HOPER.EQ.'I').OR.(HOPER.EQ.'J')
      IF( YFUNC.NE.'C'.AND.YFUNC.NE.'D'.AND.(.NOT.L_IORJ).AND.
     X    YFUNC.NE.'L'.AND.YFUNC.NE.'R'.AND.YFUNC.NE.'S'.AND.
     X    YFUNC.NE.'X'.AND.YFUNC.NE.'Z'.AND.YFUNC.NE.'M'.AND.
     X    YFUNC.NE.'G'.AND.YFUNC.NE.'A'.AND.YFUNC.NE.'B'.AND.
     X    YFUNC.NE.'K') THEN
        KRET = 201
        WRITE(GRPRSM,*) 'GRIBEX: Invalid function requested - ',HOPER
        WRITE(GRPRSM,*) 'GRIBEX: Return code = ', KRET
        GO TO 900
      ENDIF
C
C     Function 'A' encodes 8-bit data.
      IF( HOPER.EQ.'A') YFUNC = 'C'
C
C     Function 'B' decodes 8-bit data.
      IF( HOPER.EQ.'B') YFUNC = 'D'
C
C*    Function 'L' returns the length of the GRIB message and
C     GRIB Edition number only, so no array initialisation is
C     necessary.
C
      IF( YFUNC.EQ.'L') GO TO 300
C
C*    Function 'M' is for coding data, and if a bit map is encountered
C     GRIB messages are made a fixed length. HOPER is passed to the
C     bit-map handling routine.
C
      IF( HOPER.EQ.'M') YFUNC = 'C'
C
C*    Function 'K' is the same as 'C', but for grid-point fields,
C     an "aggressive packing" is performed: all user-allowed strategies
C     for second-order packing are attempted, in order to make the
C     shortest GRIB message.
C
      IF( HOPER.EQ.'K') YFUNC = 'C'
C
C*    Function 'I' is for decoding of sections 0, 1 and 2
C     of GRIB code only. Value of HOPER is checked at the start of
C     decoding section 3.
C*    Function 'J' is for decoding of sections 0, 1, 2, 3 and 4.
C
      IF( L_IORJ) YFUNC = 'D'
C
C*    Function 'R' is the same as 'D', but if a quasi-regular
C     Gaussian is encountered, it is converted to a regular one.
C     Value of HOPER is checked near end of section 8.
C
      IF( HOPER.EQ.'R') YFUNC = 'D'
C
C*    Function 'S' is the same as 'D', but if analysis data in
C     GRIB Experimental Edition is encountered, the time range
C     indicator flag is set to indicate initialised analysis.
C     Value of HOPER is checked  when time range indicator has
C     been extracted.
C
      IF( HOPER.EQ.'S') YFUNC = 'D'
C
C*    Function 'X' is the same as 'D', but only the data
C     at the requested points is unpacked.
C     Value of HOPER is checked prior to unpacking data values.
C
      IF( HOPER.EQ.'X') YFUNC = 'D'
C
C*    Function 'G' is the same as 'D', but only the reference
C     value and scale factor are unpacked. A pointer to packed data
C     is returned.
C     Value of HOPER is checked prior to unpacking data values.
C
      IF( HOPER.EQ.'G') YFUNC = 'D'
C
C*    Function 'Z' is for decoding only the information which could
C     be handled by the the old decoding routine DECOGB (eg no bit
C     maps) and is used by the new DECOGB interface.
C
      IF( HOPER.EQ.'Z') YFUNC = 'D'
C
      LENCODE = ( YFUNC.EQ.'C' )
      LDECODE = ( YFUNC.EQ.'D' )
Cd
Cd    Set up the definition 13 flag variable
Cd
      IF( LDECODE ) N13FLAG = D13FLAG(KGRIB)
C
C*    Preset some arrays to 0.
C
      IF( LENCODE ) THEN
Ce
Ce      Check number of bits per data field fits size of computer word.
Ce
        IF( IBITS.LT.KSEC4(2)) THEN
          KRET = 202
          WRITE(GRPRSM,*)
     X  'GRIBEX: Number of bits per data value = ',KSEC4(2)
          WRITE(GRPRSM,*)
     X  'GRIBEX: This exceeds word length which = ',IBITS
          WRITE(GRPRSM,*) 'GRIBEX: Return code = ', KRET
          GO TO 900
        ENDIF
Ce
Ce      Check number of bits is not zero or negative
Ce
        IF( KSEC4(2) .LT. 0 ) THEN
          KRET = 204
          WRITE(GRPRSM,*)
     X  'GRIBEX: Number of bits per data value = ',KSEC4(2)
          WRITE(GRPRSM,*) 'GRIBEX: This must be positive.'
          WRITE(GRPRSM,*) 'GRIBEX: Return code = ', KRET
          GOTO 900
        ELSEIF( KSEC4(2) .EQ. 0 ) THEN
          WRITE(GRPRSM,*)
     X  'GRIBEX: Number of bits per data value = ',KSEC4(2)
          KSEC4(2) = 8
          WRITE(GRPRSM,*)
     X  'GRIBEX: This must be positive - enforced to ',
     X               KSEC4(2)
        ENDIF
Ce
Ce      Check if number of bits per packed value = number of bits per
Ce      computer word.
Ce
        LALLPOS = KSEC4(2) .EQ. IBITS
Ce
Ce      If entire field is missing, check that all data values are zero.
Ce
        IF( KSEC4(1).LT.0) THEN
          IMISS = 1
          ILENF = - KSEC4(1)
          DO 210 JLOOP = 1 , ILENF
            IF( PSEC4(JLOOP).NE.0.0) THEN
              KRET = 203
              WRITE(GRPRSM,*)
     X  'GRIBEX: Non-zero value in missing data field.'
              WRITE(GRPRSM,*) 'GRIBEX: Return code = ', KRET
              GO TO 900
            ENDIF
  210     CONTINUE
        ELSE
          IMISS = 0
          ILENF = KSEC4(1)
        ENDIF
Ce
Ce      If input data is integer, change it to real.
Ce
        IF( ( KSEC4(5).EQ.32 ).AND.( HOPER.NE.'A' ) )
     X    CALL RORINT(PSEC4,PSEC4,ILENF,'R')
Ce
        DO 215 JLOOP = 21,24
          KSEC4(JLOOP) = 0
  215   CONTINUE
Ce
      ELSE
Cd
Cd      Preset arrays to receive section header information to 0.
Cd      Routine GSBITE resets data array to 0.
Cd
        DO 220 JLOOP = 1,25
          KSEC1(JLOOP) = 0
  220   CONTINUE
Cd
        DO 230 JLOOP = 1,22
          KSEC2(JLOOP) = 0
  230   CONTINUE
Cd
        DO 240 JLOOP = 1,33
          KSEC4(JLOOP) = 0
  240   CONTINUE
Cd
      ENDIF
C
C     -----------------------------------------------------------------|
C
C
C
C
C
C
C
C
C
C
C*    Section 3 . Indicator Section (Section 0) of GRIB code.
C     -----------------------------------------------------------------|
C
  300 CONTINUE
C
C#ifdef GRIB2
C      IF( LENCODE.AND.(KSEC0(2).EQ.2) ) THEN
C        IF( LPDEBUG ) WRITE(GRPRSM,*) 'GRIBEX: Section 3. Handle GRIB2'
C        KRET = G2ENCOD(KSEC0,KSEC1,KSEC2,KSEC3,KSEC4,
C     X                 PSEC2,PSEC3,PSEC4,PSEC3(2))
C        RETURN
C      ENDIF
C#endif
C
      IF( LPDEBUG ) WRITE(GRPRSM,*)
     X  'GRIBEX: Section 3. Handle GRIB Indicator Section (Section 0)'
C
C*    Octets 1 - 4 : The letters G R I B.
C     Four 8 bit fields.
C
      IF( LENCODE ) THEN
Ce
Ce      Insert the letters G R I B.
Ce
        CALL INXBIT(KGRIB,KLENG,INSPT,IGRIB(1),4,IBITS, 8,YFUNC,KRET)
        IF( KRET.NE.0) THEN
          KRET = 301
          WRITE(GRPRSM,*)
     X  'GRIBEX: Error inserting/extracting letters GRIB'
          WRITE(GRPRSM,*) 'GRIBEX: Return code = ', KRET
          GO TO 900
        ENDIF
      ELSE
Cd
Cd      When decoding data, check letters -> GRIB, BUDG or TIDE.
Cd
        CALL INXBIT(KGRIB,KLENG,INSPT,IPARM(1),4,IBITS, 8,YFUNC,KRET)
        IF( KRET.NE.0) THEN
          KRET = 301
          WRITE(GRPRSM,*)
     X  'GRIBEX: Error inserting/extracting letters GRIB'
          WRITE(GRPRSM,*) 'GRIBEX: Return code = ', KRET
          GO TO 900
        ENDIF
Cd
Cd      Check that 'GRIB' is found where expected.
Cd
        IF( IPARM(1).EQ.71.AND.IPARM(2).EQ.82.AND.
     X      IPARM(3).EQ.73.AND.IPARM(4).EQ.66) GO TO 310
Cd
Cd      ECMWF pseudo-grib data uses 'BUDG' and 'TIDE'.
Cd
        IF( IPARM(1).EQ.66.AND.IPARM(2).EQ.85.AND.
     X      IPARM(3).EQ.68.AND.IPARM(4).EQ.71) GO TO 310
Cd
        IF( IPARM(1).EQ.84.AND.IPARM(2).EQ.73.AND.
     X      IPARM(3).EQ.68.AND.IPARM(4).EQ.69) GO TO 310
Cd
Cd      Data is not GRIB or pseudo-grib.
Cd
        KRET = 305
        WRITE(GRPRSM,*) 'GRIBEX: Input data is not GRIB or pseudo-grib.'
        WRITE(GRPRSM,*) 'GRIBEX: Return code = ', KRET
        GO TO 900
Cd
      ENDIF
C
  310 CONTINUE
C
C*    Octets 5 - 7 : Length of message.
C     One 24 bit field.
C
      IF( LENCODE ) THEN
Ce
Ce      When coding data, skip field. Length is inserted
Ce      later, when known.
Ce      Update bit-pointer.
Ce
        INSPT = INSPT + 24
      ELSE
Cd
Cd      Extract field.
Cd
        CALL INXBIT(KGRIB,KLENG,INSPT,ITEMP,1,IBITS, 24,YFUNC,KRET)
        IF( KRET.NE.0) THEN
          KRET = 302
          WRITE(GRPRSM,*)
     X  'GRIBEX: Error extracting length of GRIB message.'
          WRITE(GRPRSM,*) 'GRIBEX: Return code = ', KRET
          GO TO 900
        ENDIF
Cd
Cd      When decoding, use most-significant bit as a sign bit.
Cd
        IF( LDECODE ) CALL DSGNBT( KSEC0(1), ITEMP, 24, KRET)
Cd
Cd      If count is negative, have to rescale by factor of -120.
Cd      This is a fixup to get round the restriction on product lengths
Cd      due to the count being only 24 bits. It is only possible because
Cd      the (default) rounding for GRIB products is 120 bytes.
Cd
        IF( KSEC0(1).LT.0 ) THEN
          IF( LPDEBUG ) WRITE(GRPRSM,*)
     X      'GRIBEX: Special case, negative length multiplied by -120'
          LLARGE = .TRUE.
          KSEC0(1) = KSEC0(1) * (-120)
        ENDIF
      ENDIF
C
C*    Octet 8 : GRIB Edition Number.
C     One 8 bit field.
C
      IF( LENCODE ) THEN
Ce
Ce      Set value, if coding data.
Ce
        KSEC0(2) = JPEDNO
        CALL INXBIT(KGRIB,KLENG,INSPT,KSEC0(2),1,IBITS, 8,YFUNC,KRET)
        IF( KRET.NE.0) THEN
          KRET = 303
          WRITE(GRPRSM,*)
     X      'GRIBEX: Error inserting/extracting GRIB Edition Number.'
          WRITE(GRPRSM,*) 'GRIBEX: Return code = ', KRET
          GO TO 900
        ENDIF
Ce
      ELSE
Cd
Cd      Extract field.
Cd
        CALL INXBIT(KGRIB,KLENG,INSPT,KSEC0(2),1,IBITS, 8,YFUNC,KRET)
        IF( KRET.NE.0) THEN
          KRET = 303
          WRITE(GRPRSM,*)
     X      'GRIBEX: Error inserting/extracting GRIB Edition Number.'
          WRITE(GRPRSM,*) 'GRIBEX: Return code = ', KRET
          GO TO 900
        ENDIF
Cd
Cd      When decoding or calculating length, previous editions
Cd      of the GRIB code must be taken into account.
Cd
Cd      In the table below, covering sections 0 and 1 of the GRIB
Cd      code, octet numbering is from the beginning of the GRIB
Cd      message;
Cd      * indicates that the value is not available in the code edition;
Cd      R indicates reserved, should be set to 0;
Cd      Experimental edition is considered as edition -1.
Cd
Cd      GRIB code edition -1 has fixed length of 20 octets for
Cd      section 1, the length not included in the message.
Cd      GRIB code edition 0 has fixed length of 24 octets for
Cd      section 1, the length being included in the message.
Cd      GRIB code edition 1 can have different lengths for section
Cd      1, the minimum being 28 octets, length being included in
Cd      the message.
Cd
Cd                                              Octet numbers for code
Cd                                                       editions
Cd
Cd                     Contents.                   -1      0      1
Cd                     ---------                ----------------------
Cd           Letters GRIB                          1-4    1-4    1-4
Cd           Total length of GRIB message.          *      *     5-7
Cd           GRIB code edition number               *      *      8
Cd           Length of Section 1.                   *     5-7    9-11
Cd           Reserved octet (R).                    *      8(R)   *
Cd           Version no. of Code Table 2.           *      *     12
Cd           Identification of centre.              5      9     13
Cd           Generating process.                    6     10     14
Cd           Grid definition .                      7     11     15
Cd           Flag (Code Table 1).                   8     12     16
Cd           Indicator of parameter.                9     13     17
Cd           Indicator of type of level.           10     14     18
Cd           Height, pressure etc of levels.      11-12  15-16  19-20
Cd           Year of century.                      13     17     21
Cd           Month.                                14     18     22
Cd           Day.                                  15     19     23
Cd           Hour.                                 16     20     24
Cd           Minute.                               17     21     25
Cd           Indicator of unit of time.            18     22     26
Cd           P1 - Period of time.                  19     23     27
Cd           P2 - Period of time                  20(R)   24     28
Cd           or reserved octet (R).
Cd           Time range indicator.                21(R)   25     29
Cd           or reserved octet (R).
Cd           Number included in average.       22-23(R)  26-27  30-31
Cd           or reserved octet (R).
Cd           Number missing from average.         24(R)  28(R)   32
Cd           or reserved octet (R).
Cd           Century of data.                       *      *     33
Cd           Designates sub-centre if not 0.        *      *     34
Cd           Decimal scale factor.                  *      *    35-36
Cd           Reserved. Set to 0.                    *      *    37-48
Cd           (Need not be present)
Cd           For originating centre use only.       *      *    49-nn
Cd           (Need not be present)
Cd
Cd      Identify which GRIB code edition is being decoded.
Cd
Cd      In GRIB edition 1, the edition number is in octet 8.
Cd      In GRIB edition 0, octet 8 is reserved and set to 0.
Cd      In GRIB edition -1, octet 8 is a flag field and can have a
Cd      a valid value of 0, 1, 2 or 3.
Cd
Cd      However, GRIB edition number 0 has a fixed
Cd      length of 24, included in the message, for section 1, so
Cd      if the value extracted from octets 5-7 is 24 and that from
Cd      octet 8 is 0, it is safe to assume edition 0 of the code.
Cd
        IF( KSEC0(1).EQ.24.AND.KSEC0(2).EQ.0) THEN
Cd
Cd        Set bit-pointer back by 32 bits (4 octets).
          INSPT = INSPT - 32
Cd
Cd        Set length of GRIB message to missing data value.
          KSEC0(1) = IMISNG
Cd
          GO TO 400
        ENDIF
Cd
Cd      In GRIB Edition -1, octets 22 and 23 are reserved and set
Cd      to 0. These octets in Edition 1 are the month and the day,
Cd      and must be non-zero.
Cd
        ITEMP = 168
        CALL INXBIT(KGRIB,KLENG,ITEMP,IMODAY,1,IBITS, 16,YFUNC,KRET)
        IF( KRET.NE.0) THEN
          KRET = 304
          WRITE(GRPRSM,*)
     X  'GRIBEX: Error extracting octets 22 and 23 for'
          WRITE(GRPRSM,*) 'GRIBEX: Experimental Edition check.'
          WRITE(GRPRSM,*) 'GRIBEX: Return code = ', KRET
          GO TO 900
        ENDIF
Cd
        IF( IMODAY.EQ.0) THEN
Cd
Cd        Set bit-pointer back by 32 bits (4 octets).
          INSPT = INSPT - 32
Cd
          KSEC0(2) = -1
Cd
Cd        Set length of GRIB message to missing data value.
Cd
          KSEC0(1) = IMISNG
Cd
Cd        Set length of section 1 of GRIB code to 20 octets.
Cd
          ILEN1 = 20
Cd
Cd        Skip next 4 octets, as they do not exist in
Cd        the Experimental Edition of the code. ie
Cd        length of Section and Table 2 Version Number.
Cd
          GO TO 401
        ENDIF
Cd
      ENDIF
C
C*    If Grib Edition 1 and only length is required, go to section 9.
C
      IF( YFUNC.EQ.'L') GO TO 900
C
C     -----------------------------------------------------------------|
C
C
C
C
C
C
C
C
C
C
C*    Section 4 . Product Definition Section (Section 1) of GRIB code.
C    -----------------------------------------------------------------
C
  400 CONTINUE
C
      IF( LPDEBUG ) WRITE(GRPRSM,*)
     X  'GRIBEX: Section 4. Handle Product Definition (Section 1)'
C
C*    Check consistency of values given, with GRIB code, if required.
C
      IF( NVCK.EQ.1.AND. LENCODE ) THEN
        CALL GRCHK1(KSEC1,KRET)
        IF( KRET.NE.0) THEN
          KRET = 499
          WRITE(GRPRSM,*)
     X  'GRIBEX: Error found when checking values for'
          WRITE(GRPRSM,*) 'GRIBEX: Section 1 against valid GRIB values.'
          WRITE(GRPRSM,*) 'GRIBEX: Return code = ', KRET
          GO TO 900
        ENDIF
      ENDIF
C
C*    Octets 1 - 3 : Length of Section.
C     One 24 bit field.
C
      IF( LENCODE ) THEN
Ce
Ce      Set value, if coding data.
        ILEN1 = JPLEN1
Ce
Ce      Extra octets if ECMWF local definition usage in section 1.
Ce
        LECMWF = (KSEC1(2) .EQ.98)
        LECLOC = (KSEC1(2) .EQ.98) .OR.
     X           (KSEC1(22).EQ.98)
        LSST11 = (KSEC1( 6).EQ.139) .AND.
     X           (KSEC1( 7).EQ.  1) .AND.
     X           (KSEC1(22).EQ. 98)
        LKWBCE = (KSEC1( 2).EQ.  7) .AND.
     X           (KSEC1(22).NE. 98)
Ce
        IF( LPDEBUG ) WRITE(GRPRSM,*)
     X  'GRIBEX: Local extension in use for...'
        IF( LPDEBUG.AND.LECLOC ) WRITE(GRPRSM,*)
     X  'GRIBEX: ECMWF data'
        IF( LPDEBUG.AND.LKWBCE ) WRITE(GRPRSM,*)
     X  'GRIBEX: KWBC ensemble data'
        IF( LPDEBUG.AND.LSST11 ) WRITE(GRPRSM,*) 'GRIBEX: SST data'
Ce
      ENDIF
C
C     Insert / extract field.
C
      CALL INXBIT(KGRIB,KLENG,INSPT,ILEN1,1,IBITS, 24,YFUNC,KRET)
      IF( KRET.NE.0) THEN
        KRET = 401
        WRITE(GRPRSM,*)
     X    'GRIBEX: Error inserting/extracting length of Section 1.'
        WRITE(GRPRSM,*) 'GRIBEX: Return code = ', KRET
        GO TO 900
      ENDIF
C
C*    Octet 4  : Version Number of Table 2.
C     One 8 bit field.
C
C     Insert / extract field.
C
      CALL INXBIT(KGRIB,KLENG,INSPT,KSEC1(1),1,IBITS, 8,YFUNC,KRET)
      IF( KRET.NE.0) THEN
        KRET = 402
        WRITE(GRPRSM,*)
     X    'GRIBEX: Error inserting/extracting Param Table Version No.'
        WRITE(GRPRSM,*) 'GRIBEX: Return code = ', KRET
        GO TO 900
      ENDIF
C
  401 CONTINUE
C
C*    Check Edition number.
C
      IF( LPDEBUG ) WRITE(GRPRSM,*)
     X  'GRIBEX: GRIB Edition Number = ',KSEC0(2)
      IF( KSEC0(2).GT.1) THEN
        KRET = 413
        WRITE(GRPRSM,*) 'GRIBEX: Grib Edition not catered for.'
        WRITE(GRPRSM,*) 'GRIBEX: Return code = ', KRET
        GO TO 900
      ENDIF
C
C*    Print length of Section 1, if required.
C
      IF( LPDEBUG ) WRITE(GRPRSM,*)
     X  'GRIBEX: Length of Section 1 of GRIB = ',ILEN1,' octets.'
C
C*    Octet 5  : Identification of centre.
C     Octet 6  : Generating process identification.
C     Octet 7  : Grid definition.
C     Octet 8  : Flag.
C     Octet 9  : Indicator of parameter.
C     Octet 10 : Indicator of type of level.
C                (or satellite identifier)
C                Satellite useage as defined by INPE/CPTEC
C                and used by ECMWF, pending final definition
C                by WMO.
C     Six 8 bit fields.
C
C     Insert / extract fields.
C
      CALL INXBIT(KGRIB,KLENG,INSPT,KSEC1(2),6,IBITS, 8,YFUNC,KRET)
      IF( KRET.NE.0) THEN
        KRET = 403
        WRITE(GRPRSM,*)
     X  'GRIBEX: Error inserting/extracting six fields from'
        WRITE(GRPRSM,*)
     X  'GRIBEX: Identification of Centre to Indicator of'
        WRITE(GRPRSM,*) 'GRIBEX: type of level.'
        WRITE(GRPRSM,*) 'GRIBEX: Return code = ', KRET
        GO TO 900
      ENDIF
C
C     If decoding, fix-up for Experimental Edition and Edition 0
C     of GRIB code.
C
      IF( .NOT. LENCODE ) THEN
Cd
Cd      Set logical flag for ECMWF data
Cd
        LECMWF = (KSEC1(2).EQ.98)
Cd
Cd      In GRIB Experimental Edition and Edition 0
Cd      the International Table Version Number in use was 0.
Cd      ECMWF has always used its own local table. It is the same
Cd      for Experimental Edition, Edition 0 and Edition 1 and is
Cd      local table number 128.
Cd
        IF( KSEC0(2).LT.1) THEN
          IF( LECMWF ) THEN
Cd
Cd          ECMWF data. Local table number.
            KSEC1(1) = 128
          ELSE
Cd
Cd          International table number.
Cd          KSEC1(1) = 0 is already preset.
          ENDIF
        ENDIF
Cd
Cd      Fix-up for flag field, which was different in Experimental
Cd      Edition.
Cd
Cd                        Experimental          Editions 0 and 1
Cd                        Edition
Cd
Cd           Sections     Binary    Decimal     Binary    Decimal
Cd           included     value     value       value     value
Cd
Cd             none       00000000    0         00000000     0
Cd              2         00000001    1         10000000   128
Cd              3         00000010    2         01000000    64
Cd           2 and 3      00000011    3         11000000   192
Cd
        IF( KSEC0(2).EQ.-1) THEN
          IF( KSEC1(5).EQ.1) KSEC1(5) = 128
          IF( KSEC1(5).EQ.2) KSEC1(5) = 64
          IF( KSEC1(5).EQ.3) KSEC1(5) = 192
        ENDIF
      ENDIF
      LSECT2 = KSEC1(5).GE.128
      LSECT3 = MOD(KSEC1(5),128).GE.64
C
C*    Once the flag field has been extracted, no further fields
C     from section 1 of the GRIB code are required, when length
C     of GRIB or pseudo-Grib message only is required.
C
      IF( YFUNC.EQ.'L') THEN
C
C       Length of section 0 + section 1 is 28 octets (224 bits)
C       for GRIB Edition 0 and 24 octets (192 bits) for
C       Experimental edition.
C       Set bit-pointer and jump to extraction of length of section 3.
C
        INSPT = 224
        IF( KSEC0(2).EQ.-1) INSPT = 192
        GO TO 500
      ENDIF
C
C*    Octets 11 - 12 : Height, pressure etc of levels or
C                      satellite spectral band.
C                      Satellite useage as defined by INPE/CPTEC
C                      and used by ECMWF, pending final definition
C                      by WMO.
C     One 16 bit field or two 8 bit fields.
C
C     Satellite image if WMO table and parameter 127
C
      LSATIMG = ((KSEC1(1).LT.128).AND.(KSEC1(6).EQ.127))
C
C     For certain level types, no description is necessary, so when
C     decoding the fields are set to 0 regardless of bit string content.
C
      IF( (.NOT.LENCODE).AND.
     X    (.NOT.LSATIMG).AND.
     X    ( ((KSEC1(7).LT.100).AND.(KSEC1(7).NE.20)).OR.
     X      (KSEC1(7).EQ.102) .OR.
     X      (KSEC1(7).EQ.200) .OR.
     X      (KSEC1(7).EQ.201) ) ) THEN
Cd
Cd      Update bit-pointer and skip extraction.
        KSEC1(8) = 0
        KSEC1(9) = 0
        INSPT = INSPT + 16
        GO TO 402
      ENDIF
C
C     Certain level types require that the description occupies
C     both octets.
C     Satellite Spectral band occupies both octets.
C     Satellite useage as defined by INPE/CPTEC
C     and used by ECMWF, pending final definition by WMO.
C     Image data uses 2 octets.
C
      IF( (KSEC1(7).NE. 20).AND.
     X    (KSEC1(7).NE.100).AND.
     X    (KSEC1(7).NE.103).AND.
     X    (KSEC1(7).NE.105).AND.
     X    (KSEC1(7).NE.107).AND.
     X    (KSEC1(7).NE.109).AND.
     X    (KSEC1(7).NE.111).AND.
     X    (KSEC1(7).NE.113).AND.
     X    (KSEC1(7).NE.115).AND.
     X    (KSEC1(7).NE.117).AND.
     X    (KSEC1(7).NE.125).AND.
     X    (KSEC1(7).NE.127).AND.
     X    (KSEC1(7).NE.160).AND.
     X    (KSEC1(7).NE.210).AND.
     X    (.NOT.LSATIMG) ) THEN
C
C       Two 8 bit fields.
        INUM  = 2
        IBLEN = 8
      ELSE
C
C       One 16 bit field.
        INUM     = 1
        IBLEN    = 16
        KSEC1(9) = 0
      ENDIF
C
C     Insert / extract fields.
C
      CALL INXBIT(KGRIB,KLENG,INSPT,KSEC1(8),INUM,IBITS,
     X             IBLEN,YFUNC,KRET)
      IF( KRET.NE.0) THEN
        KRET = 404
        WRITE(GRPRSM,*) 'GRIBEX: Error inserting/extracting Height,'
        WRITE(GRPRSM,*) 'GRIBEX: pressure, etc of levels.'
        WRITE(GRPRSM,*) 'GRIBEX: Return code = ', KRET
        GO TO 900
      ENDIF
C
C*    Fix-up for ECMWF upper-air data incorrectly coded in Experimental
C     Edition.
C
      IF( KSEC0(2).EQ.-1.AND. LECMWF ) THEN
        ITEMP = INSPT - 16
        INUM  = 2
        IBLEN = 8
        CALL INXBIT(KGRIB,KLENG,ITEMP,KSEC1(8),INUM,IBITS,
     X               IBLEN,YFUNC,KRET)
        IF( KRET.NE.0) THEN
          KRET = 404
          WRITE(GRPRSM,*) 'GRIBEX: Error inserting/extracting Height,'
          WRITE(GRPRSM,*) 'GRIBEX: pressure, etc of levels.'
          WRITE(GRPRSM,*) 'GRIBEX: Return code = ', KRET
          GO TO 900
        ENDIF
        KSEC1(8) = KSEC1(8) * 32 + KSEC1(9)
        KSEC1(9) = 0
      ENDIF
C
  402 CONTINUE
C
C*    Octet 13 : Year of century.
C     Octet 14 : Month.
C     Octet 15 : Day.
C     Octet 16 : Hour.
C     Octet 17 : Minute.
C     Octet 18 : Indicator of unit of time range..
C     Six 8 bit fields.
C
C     Insert / extract fields.
C
      CALL INXBIT(KGRIB,KLENG,INSPT,KSEC1(10),6,IBITS, 8,YFUNC,KRET)
      IF( KRET.NE.0) THEN
        KRET = 405
        WRITE(GRPRSM,*)
     X  'GRIBEX: Error inserting/extracting six fields from'
        WRITE(GRPRSM,*)
     X  'GRIBEX: Year of century to Indicator of unit of'
        WRITE(GRPRSM,*) 'GRIBEX: time range.'
        WRITE(GRPRSM,*) 'GRIBEX: Return code = ', KRET
        GO TO 900
      ENDIF
C
C*    Fix-up for unit of time, which was different in Experimental
C     Edition.
C
C
C                  Experimental          Editions 0 and 1
C                  Edition
C
C     Meaning      Decimal               Decimal
C                  value                 value
C
C     Minute       0 or 30                 0
C     Hour         1 or 40                 1
C     Day          2 or 50                 2
C     Month        3 or 60                 3
C     Year         4 or 70                 4
C     Decade       5 or 80                 5
C     Normal         6                     6
C     Century      7 or 90                 7
C     Second         -                   254
C
      IF( KSEC0(2).EQ.-1) THEN
        IF( KSEC1(15).EQ.90) KSEC1(15) = 7
        IF( KSEC1(15).GT.10) KSEC1(15) = (KSEC1(15) / 10) - 3
      ENDIF
C
C*    Octets 19 - 20 : Period of time.
C     One 16 bit field or two 8 bit fields.
C
      IF( LENCODE .AND.KSEC1(18).EQ.10) THEN
Ce
Ce      One 16 bit field.
        INUM  = 1
        IBLEN = 16
      ELSE
Ce
Ce      Two 8 bit fields.
        INUM  = 2
        IBLEN = 8
      ENDIF
C
C     Insert / extract fields.
C
      CALL INXBIT(KGRIB,KLENG,INSPT,KSEC1(16),INUM,IBITS,
     X            IBLEN,YFUNC,KRET)
      IF( KRET.NE.0) THEN
        KRET = 406
        WRITE(GRPRSM,*)
     X  'GRIBEX: Error inserting/extracting Period of time.'
        WRITE(GRPRSM,*) 'GRIBEX: Return code = ', KRET
        GO TO 900
      ENDIF
C
C*    Octet 21 : Time range indicator.
C     One 8 bit field.
C
C     Insert / extract field.
C
      CALL INXBIT(KGRIB,KLENG,INSPT,KSEC1(18),1,IBITS, 8,YFUNC,KRET)
      IF( KRET.NE.0) THEN
        KRET = 407
        WRITE(GRPRSM,*)
     X    'GRIBEX: Error inserting/extracting time range indicator.'
        WRITE(GRPRSM,*) 'GRIBEX: Return code = ', KRET
        GO TO 900
      ENDIF
C
C*    When decoding, period of time field and time range
C     indicator may need modification.
C
      IF( .NOT. LENCODE ) THEN
Cd
Cd      When decoding, length of period of time field is known
Cd      only at this time. If a 16 bit field is indicated, put
Cd      the two extracted 8-bit fields together.
Cd
        IF( KSEC1(18).EQ.10) THEN
Cd
Cd        One 16 bit field.
          KSEC1(16) = KSEC1(16) * 256 + KSEC1(17)
          KSEC1(17) = 0
        ENDIF
Cd
Cd      If data is known to be initialised analysis and GRIB is
Cd      Experimental Edition, set time range indicator flag.
Cd
        IF( KSEC1(16).EQ.0.AND.HOPER.EQ.'S'.AND.KSEC0(2).EQ.-1)
     X    KSEC1(18) = 1
Cd
      ENDIF
C
C*    Octet 22 - 23 : Number averaged.
C     One 16 bit field.
C
C     Insert / extract field.
C
      CALL INXBIT(KGRIB,KLENG,INSPT,KSEC1(19),1,IBITS, 16,YFUNC,KRET)
      IF( KRET.NE.0) THEN
        KRET = 408
        WRITE(GRPRSM,*)
     X  'GRIBEX: Error inserting/extracting number averaged.'
        WRITE(GRPRSM,*) 'GRIBEX: Return code = ', KRET
        GO TO 900
      ENDIF
C
C*    Octet 24 : Number missing from averages etc.
C     One 8 bit field.
C
      CALL INXBIT(KGRIB,KLENG,INSPT,KSEC1(20),1,IBITS, 8,YFUNC,KRET)
      IF( KRET.NE.0) THEN
        KRET = 409
        WRITE(GRPRSM,*)
     X  'GRIBEX: Error inserting/extracting number missing'
        WRITE(GRPRSM,*) 'GRIBEX: from averages etc.'
        WRITE(GRPRSM,*) 'GRIBEX: Return code = ', KRET
        GO TO 900
      ENDIF
C
C*    This is the end of Section 1 if Edition 0 or -1 of GRIB code.
C     Set other fields to be compatible with Edition 1, where possible.
C
      IF( KSEC0(2).LT.1) THEN
C
C       Century of data.
C
C       All ECMWF data in Edition 0 or -1 is 20th century.
C       Otherwise set century to missing data value.
C
        IF( LECMWF ) THEN
          KSEC1(21) = 20
        ELSE
          KSEC1(21) = IMISNG
        ENDIF
C
C       Reserved field and decimal scale factor field (which
C       was always 0).
C
C       KSEC1(22) and KSEC1(23) set to 0.
C
        KSEC1(22) = 0
        KSEC1(23) = 0
        GO TO 499
      ENDIF
C
C*    Octet 25 : Century of data.
C     One 8 bit field.
C
C     Insert / extract field.
C
      CALL INXBIT(KGRIB,KLENG,INSPT,KSEC1(21),1,IBITS, 8,YFUNC,KRET)
      IF( KRET.NE.0) THEN
        KRET = 410
        WRITE(GRPRSM,*)
     X  'GRIBEX: Error inserting/extracting century of data'
        WRITE(GRPRSM,*) 'GRIBEX: or reserved field.'
        WRITE(GRPRSM,*) 'GRIBEX: Return code = ', KRET
        GO TO 900
      ENDIF
C
C*    Octet 26 : Sub-centre.
C     ( Now used at ECMWF/Washington to designate a sub-centre
C       =   2 for NMC ensemble products(decoding only).
C       =  98 for EPS products from Washington with ECMWF extensions.
C       = 231 Meteo France Climate Centre (ECSN)
C       = 232 MPI Climate Centre (ECSN)
C       = 233 UKMO Climate Centre (ECSN)
C       = 240 for ECMWF seasonal forecast centre (PROVOST).
C       = 241 for Meteo France seasonal forecast centre (PROVOST).
C       = 242 for EDF seasonal forecast centre (PROVOST).
C       = 243 for UKMO seasonal forecast centre (PROVOST).
C       = 0   otherwise. )
C
C     One 8 bit field.
C
      IF( LENCODE ) THEN
Ce
Ce      When coding ECMWF data, sub-centre is set to 0 unless a
Ce      designated sub-centre or explicitly enabled by previous user
Ce      call to GRSUBC.
Ce
        IF( .NOT.LECMWF .OR. NSUBCE.EQ.1 ) THEN
          ITEMP = KSEC1(22)
Ce
        ELSE IF( (KSEC1(22).EQ. 98) .OR.
     X           (KSEC1(22).EQ.231) .OR.
     X           (KSEC1(22).EQ.232) .OR.
     X           (KSEC1(22).EQ.233) .OR.
     X           (KSEC1(22).EQ.240) .OR.
     X           (KSEC1(22).EQ.241) .OR.
     X           (KSEC1(22).EQ.242) .OR.
     X           (KSEC1(22).EQ.243) )THEN
          ITEMP = KSEC1(22)
Ce
        ELSE
          ITEMP = 0
        ENDIF
      ENDIF
C
      CALL INXBIT(KGRIB,KLENG,INSPT, ITEMP, 1,IBITS, 8,YFUNC,KRET)
      IF( KRET.NE.0) THEN
        KRET = 810
        WRITE(GRPRSM,*) 'GRIBEX: Error inserting dummy zero.'
        WRITE(GRPRSM,*) 'GRIBEX: Return code = ', KRET
        GO TO 900
      ENDIF
C
Cd
      IF( LDECODE ) THEN
Cd
Cd      When decoding, KSEC1(22) is set to message content.
Cd
        KSEC1(22) = ITEMP
Cd
Cd      Set flags for known special local extensions to section 1:
Cd        ECMWF data
Cd        Washington SST data
Cd        Washington ensemble data
Cd
        LECLOC = (KSEC1(2).EQ.98) .OR.
     X           (KSEC1(22).EQ.98)
        LSST11 = (KSEC1( 6).EQ.139) .AND.
     X           (KSEC1( 7).EQ.  1) .AND.
     X           (KSEC1(22).EQ. 98)
        LKWBCE = (KSEC1( 2).EQ.  7) .AND.
     X           (KSEC1(22).NE. 98)
Cd
        IF( LPDEBUG ) WRITE(GRPRSM,*)
     X  'GRIBEX: Local extension in use for...'
        IF( LPDEBUG.AND.LECLOC ) WRITE(GRPRSM,*) 'GRIBEX: ECMWF data'
        IF( LPDEBUG.AND.LKWBCE ) WRITE(GRPRSM,*)
     X  'GRIBEX: KWBC ensemble data'
        IF( LPDEBUG.AND.LSST11 ) WRITE(GRPRSM,*) 'GRIBEX: SST data'
Cd
      ENDIF
C
C*    Octets 27 - 28 : Units decimal scale factor.
C     One 16 bit field.
C
C     When coding, set sign bit if value is negative.
C
      IF( LENCODE ) CALL CSGNBT( ITEMP, KSEC1(23), 16, KRET)
C
C     Insert / extract field.
C
      CALL INXBIT(KGRIB,KLENG,INSPT,ITEMP,1,IBITS, 16,YFUNC,KRET)
      IF( KRET.NE.0) THEN
        KRET = 411
        WRITE(GRPRSM,*)
     X  'GRIBEX: Error inserting/extracting units decimal'
        WRITE(GRPRSM,*) 'GRIBEX: scale factor.'
        WRITE(GRPRSM,*) 'GRIBEX: Return code = ', KRET
        GO TO 900
      ENDIF
C
C     When decoding, set sign bit if value is negative.
C
      IF( LDECODE ) CALL DSGNBT( KSEC1(23), ITEMP, 16, KRET)
C
      IF( LENCODE ) THEN
Ce
Ce      When coding data, the reserved octets 29-40 need not
Ce      be present and are not included, unless ECMWF local
Ce      use of octets 41 onwards is indicated.
Ce
        IF( KSEC1(24).EQ.1.AND.((LECLOC.OR.LSST11).OR.LKWBCE)) THEN
Ce
Ce        Fill reserved octets with 0.
Ce
          DO 410 JLOOP = 29,40
            CALL INXBIT(KGRIB,KLENG,INSPT, 0, 1,IBITS, 8,YFUNC,KRET)
            IF( KRET.NE.0) THEN
              KRET = 810
              WRITE(GRPRSM,*) 'GRIBEX: Error inserting dummy zero.'
              WRITE(GRPRSM,*) 'GRIBEX: Return code = ', KRET
              GO TO 900
            ENDIF
  410     CONTINUE
Ce
Ce        Have to set sectionLength for KWBC ensemble products to
Ce        force proper encoding
Ce
          IF( LKWBCE ) THEN
            IF( KSEC1(42).NE.0) THEN
              IF( KSEC1(46).NE.0) THEN
#ifdef linux
                ISECLEN = (256 + 86)*256*256
              ELSE
                ISECLEN = (256 + 60)*256*256
              ENDIF
#else
                ISECLEN = 86*256 + 1
              ELSE
                ISECLEN = 60*256 + 1
              ENDIF
#endif
            ENDIF
            KGRIB(3) = ISECLEN
          ENDIF
Ce
Ce        Insert local ECMWF data.
          KRET = NOABORT
          CALL ECLOC1(YFUNC,KSEC1,KGRIB,INSPT,IBITS,KRET)
          IF( KRET.NE.0) THEN
            KRET = 412
            WRITE(GRPRSM,*)
     X  'GRIBEX: Error inserting/extracting ECMWF local'
            WRITE(GRPRSM,*) 'GRIBEX: data.'
            WRITE(GRPRSM,*) 'GRIBEX: Return code = ', KRET
            GO TO 900
          ENDIF
Ce
        ENDIF
Ce
      ELSE
Cd
Cd      When decoding data the reserved octets are skipped.
Cd      If local use is not ECMWF usage or Washington ensemble usage,
Cd      the local use octets are also skipped.
Cd      Presence is indicated by length of section > 28 octets.
Cd
        IF( ILEN1.GT.28.AND. (LECLOC.OR.LKWBCE.OR.LSST11) ) THEN
Cd
Cd        Set decoded values as zero and move pointer past
Cd        reserved octets.
Cd
          DO 420 JLOOP = 25,36
            KSEC1(JLOOP) = 0
  420     CONTINUE
          INSPT = INSPT + 96
Cd
Cd        Set flag to indicate local use.
          KSEC1(24) = 1
Cd
Cd        Extract local ECMWF data.
Cd        .. or Washington ensemble data.
Cd
          KRET = NOABORT
          IF( (LECLOC.OR.LSST11).OR.LKWBCE )
     X      CALL ECLOC1(YFUNC,KSEC1,KGRIB,INSPT,IBITS,KRET)
          IF( KRET.NE.0) THEN
            KRET = 412
            WRITE(GRPRSM,*)
     X  'GRIBEX: Error inserting/extracting ECMWF or'
            WRITE(GRPRSM,*) 'GRIBEX: Washington local data.'
            WRITE(GRPRSM,*) 'GRIBEX: Return code = ', KRET
            GO TO 900
          ENDIF
Cd
        ELSE
          IF( ILEN1.GT.28) INSPT = INSPT + (ILEN1-28) * 8
        ENDIF
Cd
      ENDIF
C
  499 CONTINUE
C
C*    Check for ECMWF pseudo-grib data. This saves calling GRIBEX
C     with function 'I' to check if the data is GRIB data, and another
C     call with function 'D' when GRIB data is found.
C
      IF( (.NOT.LENCODE).AND.(KSEC1(6).EQ.127.OR.KSEC1(6).EQ.128)) THEN
        IF( KSEC1(1).EQ.128.AND. LECMWF ) THEN
Cd
          IPSEUD = -6
Cd
Cd        Change function to 'L' so that section 0 is fully decoded.
          YFUNC = 'L'
          GO TO 500
        ENDIF
      ENDIF
C
C     -----------------------------------------------------------------|
C
C
C
C
C
C
C
C
C
C
C*    Section 5 . Grid Description Section (Section 2) of GRIB code.
C     -----------------------------------------------------------------|
C
  500 CONTINUE
C
      IF( LPDEBUG ) WRITE(GRPRSM,*)
     X  'GRIBEX: Section 5. Handle Grid Description Section (Section 2)'
C
      IF( .NOT.LSECT2 ) THEN
C
        IF( LDECODE ) THEN
Cd
Cd      If decoding data, set section 2 values to missing data indicator
Cd
          DO 505 JLOOP=1,22
            KSEC2(JLOOP) = IMISNG
  505     CONTINUE
        ENDIF
Cd
Cd    Go to section 6, if no grid description included.
Cd
        GO TO 600
      ENDIF
C
C*    Check consistency of values given, with GRIB code, if required.
C
      IF( NVCK.EQ.1.AND. LENCODE ) THEN
        CALL GRCHK2 (KSEC1,KSEC2,PSEC2,KRET)
        IF( KRET.NE.0) THEN
          KRET = 599
          WRITE(GRPRSM,*)
     X  'GRIBEX: Error found when checking values for'
          WRITE(GRPRSM,*)
     X  'GRIBEX: Section 2 against valid GRIB values.'
          WRITE(GRPRSM,*) 'GRIBEX: Return code = ', KRET
          GO TO 900
        ENDIF
      ENDIF
C
C*    Octets 1 - 3 : Length of section.
C     One 24 bit field.
C
C     Calculate length of section, if coding data.
C
      IF( LENCODE ) THEN
Ce
Ce      Length is normally 32 + stretched and/or rotated
Ce      parameters + vertical coordinate parameters + list of
Ce      numbers of points.
Ce      (Lambert conformal and Mercator are 42 octets in length,
Ce      while Space view is 40 for ECMWF (44 in GRIB specification)
Ce
Ce      Ordinary Grid.
Ce
        INC = 0
Ce
Ce      Space view perspective.
Ce
        IF( KSEC2(1).EQ.90) INC = 12
Ce
Ce      Lambert or Mercator +10.
Ce
        IF( KSEC2(1).EQ.3.OR.KSEC2(1).EQ.1) INC = 10
Ce
Ce
Ce      Rotated grid.
Ce      (Gaussian, Latitude/longitude or Spherical Harmonics)
Ce
        IF( KSEC2(1).EQ.10.OR.KSEC2(1).EQ.14.OR.KSEC2(1).EQ.60) INC = 10
Ce
Ce      Stretched grid.
Ce      (Gaussian, Latitude/longitude or Spherical Harmonics)
Ce
        IF( KSEC2(1).EQ.20.OR.KSEC2(1).EQ.24.OR.KSEC2(1).EQ.70) INC = 10
Ce
Ce      Stretched and rotated grid.
Ce      (Gaussian, Latitude/longitude or Spherical Harmonics)
Ce
        IF( KSEC2(1).EQ.30.OR.KSEC2(1).EQ.34.OR.KSEC2(1).EQ.80) INC = 20
Ce
Ce      Calculate data offset allowing for quasi-regular grid
Ce      (Polar sterographic cannot be a quasi-regular grid)
Ce
        LQUASI = ( KSEC2(17).EQ.1 ) .AND. (KSEC2(1).NE.5)
        IF( LQUASI ) THEN
          ILEN2 = 32 + INC + (KSEC2(12)*4) + 2*KSEC2(3)
        ELSE
          ILEN2 = 32 + INC + (KSEC2(12)*4)
        ENDIF
Ce
      ENDIF
C
C     Insert / extract field.
      CALL INXBIT(KGRIB,KLENG,INSPT,ILEN2,1,IBITS, 24,YFUNC,KRET)
      IF( KRET.NE.0) THEN
        KRET = 501
        WRITE(GRPRSM,*) 'GRIBEX: Error inserting/extracting'
        WRITE(GRPRSM,*) 'GRIBEX: length of Section 2.'
        WRITE(GRPRSM,*) 'GRIBEX: Return code = ', KRET
        GO TO 900
      ENDIF
C
C*    Print length of Section 2, if required.
C
      IF( LPDEBUG ) WRITE(GRPRSM,*)
     X  'GRIBEX: Length of Section 2 of GRIB = ',ILEN2,' octets.'
C
C*    If only length is required, update bit-pointer and jump
C     to extraction of length of section 3.
C
      IF( YFUNC.EQ.'L') THEN
        INSPT = INSPT -24 + ILEN2 * 8
        GO TO 600
      ENDIF
C
C*    Octet 4 : NV - number of vertical coordinate parameters.
C     One 8 bit field.
C
C     Insert / extract field.
C
      CALL INXBIT(KGRIB,KLENG,INSPT,KSEC2(12),1,IBITS, 8,YFUNC,KRET)
      IF( KRET.NE.0) THEN
        KRET = 502
        WRITE(GRPRSM,*) 'GRIBEX: Error inserting/extracting'
        WRITE(GRPRSM,*)
     X  'GRIBEX: number of Vertical coordinate parameters.'
        WRITE(GRPRSM,*) 'GRIBEX: Return code = ', KRET
        GO TO 900
      ENDIF
C
C*    Fixup for Editions -1 and 0 of GRIB code, where number
C     of Vertical Coordinate Parameters must be calculated,
C     as this octet contained the number of unused bits at the
C     end of the section, which by definition of the section
C     always had to be 0.
C
      IF( KSEC0(2).LT.1) THEN
        KSEC2(12) = ( ILEN2 - 32 ) / 4
      ENDIF
C
C*    Octet 5 : PV - location of list of vertical coordinate parameters,
C                    if any,
C               or
C               PL - location of list of numbers of points, if no PV,
C               or
C               255 - no PV or PL.
C     One 8 bit field.
C
      IF( LENCODE ) THEN
Ce
Ce      Set value, if coding data.
Ce
Ce      Neither present is default.
        IPVPL = 255
Ce
Ce      Vertical coordinate parameters present.
        IF( KSEC2(12).NE.0) IPVPL = 32 + INC + 1
Ce
Ce      List of number of points present, if no vertical
Ce      coordinate parameters present and if quasi-regular grid.
Ce
        IF( LQUASI.AND.KSEC2(12).EQ.0) IPVPL = 32 + INC + 1
Ce
Ce      Insert field.
Ce
        CALL INXBIT(KGRIB,KLENG,INSPT,IPVPL,1,IBITS, 8,YFUNC,KRET)
        IF( KRET.NE.0) THEN
          KRET = 503
          WRITE(GRPRSM,*) 'GRIBEX: Error inserting/extracting'
          WRITE(GRPRSM,*)
     X  'GRIBEX: location of List of vertical coordinate'
          WRITE(GRPRSM,*)
     X  'GRIBEX: parameters or List of numbers of points.'
          WRITE(GRPRSM,*) 'GRIBEX: Return code = ', KRET
          GO TO 900
        ENDIF
Ce
      ELSE
Cd
Cd      If decoding data.  Extract field.
Cd
        CALL INXBIT(KGRIB,KLENG,INSPT,IPVPL,1,IBITS, 8,YFUNC,KRET)
        IF( KRET.NE.0) THEN
          KRET = 503
          WRITE(GRPRSM,*) 'GRIBEX: Error inserting/extracting'
          WRITE(GRPRSM,*)
     X  'GRIBEX: location of List of vertical coordinate'
          WRITE(GRPRSM,*)
     X  'GRIBEX: parameters or List of numbers of points.'
          WRITE(GRPRSM,*) 'GRIBEX: Return code = ', KRET
          GO TO 900
        ENDIF
Cd
Cd      Experimental space view perspective data  received
Cd      at ECMWF has all 0 bits.
Cd      0 is illegal for all data types, so change it.
Cd
        IF( IPVPL.EQ.0) IPVPL = 255
Cd
Cd      Neither present, so set regular grid indicator.
Cd
        IF( IPVPL.EQ.255) THEN
          KSEC2(17) = 0
          LQUASI = .FALSE.
        ENDIF
Cd
Cd      Vertical coordinate parameters present.
Cd      If the length of section is greater than the
Cd      end of the vertical coordinate parameters, then
Cd      there is a list of numbers of points following, so
Cd      set quasi-regular grid indicator.
Cd
        IF( KSEC2(12).NE.0) THEN
          IPL = 4 * KSEC2(12) + IPVPL - 1
          IF( IPL.LT.ILEN2) THEN
            KSEC2(17) = 1
            LQUASI = .TRUE.
          ENDIF
        ENDIF
Cd
Cd
Cd      List of number of points present, no vertical
Cd      coordinate parameters present, so set quasi-regular
Cd      grid indicator.
Cd
        IF( KSEC2(12).EQ.0.AND.IPVPL.NE.255) THEN
          KSEC2(17) = 1
          LQUASI = .TRUE.
        ENDIF
Cd
Cd      Fixup for Editions -1 and 0 of GRIB code, where
Cd      all grids were regular.
Cd
        IF( KSEC0(2).LT.1) THEN
          KSEC2(17) = 0
          LQUASI = .FALSE.
        ENDIF
Cd
      ENDIF
C
C*    Octet 6 : Data representation type.
C     One 8 bit field.
C
C     Insert / extract field.
C
      CALL INXBIT(KGRIB,KLENG,INSPT,KSEC2(1),1,IBITS, 8,YFUNC,KRET)
      IF( KRET.NE.0) THEN
        KRET = 504
        WRITE(GRPRSM,*) 'GRIBEX: Error inserting/extracting'
        WRITE(GRPRSM,*) 'GRIBEX: data representation type.'
        WRITE(GRPRSM,*) 'GRIBEX: Return code = ', KRET
        GO TO 900
      ENDIF
C
      LSPHERC = .FALSE.
      LGRDPT = .TRUE.
C
C****
C     Gaussian grid definition.
C****
C
      IF( KSEC2(1).EQ.4. .OR.
     X    KSEC2(1).EQ.14 .OR.
     X    KSEC2(1).EQ.24 .OR.
     X    KSEC2(1).EQ.34     ) THEN
C
        IF( LENCODE ) THEN
          KRET = EGGSEC2(KGRIB,KLENG,INSPT,KSEC0,KSEC2,IBITS,LQUASI)
          IF( KRET.NE.0 ) THEN
            WRITE(GRPRSM,*)
     X  'GRIBEX: Error encoding gaussian grid section 2'
            KRET = 540
            GOTO 900
          ENDIF
        ELSE
          KRET = DGGSEC2(KGRIB,KLENG,INSPT,KSEC0,KSEC2,IBITS,IMISNG)
          IF( KRET.NE.0 ) THEN
            WRITE(GRPRSM,*)
     X  'GRIBEX: Error decoding gaussian grid section 2'
            KRET = 541
            GOTO 900
          ENDIF
        ENDIF
C
        GO TO 520
      ENDIF
C
C****
C     Latitude/longitude grid definition,
C     Equidistant Cylindrical or Plate Carree.
C****
C
      IF( KSEC2(1).EQ.0  .OR.
     X    KSEC2(1).EQ.10 .OR.
     X    KSEC2(1).EQ.20 .OR.
     X    KSEC2(1).EQ.30     ) THEN
C
        IF( LENCODE ) THEN
          KRET = ELLSEC2(KGRIB,KLENG,INSPT,KSEC0,KSEC2,IBITS,LQUASI)
          IF( KRET.NE.0 ) THEN
            WRITE(GRPRSM,*)
     X  'GRIBEX: Error encoding lat/long grid section 2'
            KRET = 542
            GOTO 900
          ENDIF
        ELSE
          KRET = DLLSEC2(KGRIB,KLENG,INSPT,KSEC0,KSEC2,IBITS,IMISNG)
          IF( KRET.NE.0 ) THEN
            WRITE(GRPRSM,*)
     X  'GRIBEX: Error decoding lat/long grid section 2'
            KRET = 543
            GOTO 900
          ENDIF
        ENDIF
C
        GO TO 520
      ENDIF
C
C****
C     Spherical Harmonic format.
C****
C
      IF( KSEC2(1).EQ.50 .OR.
     X    KSEC2(1).EQ.60 .OR.
     X    KSEC2(1).EQ.70 .OR.
     X    KSEC2(1).EQ.80     ) THEN
C
        LSPHERC = .TRUE.
        LGRDPT = .FALSE.
C
        IF( LENCODE ) THEN
          KRET = ESHSEC2(KGRIB,KLENG,INSPT,KSEC0,KSEC2,IBITS)
          IF( KRET.NE.0 ) THEN
            WRITE(GRPRSM,*) 'GRIBEX: Error encoding spectral section 2'
            KRET = 544
            GOTO 900
          ENDIF
        ELSE
          KRET = DSHSEC2(KGRIB,KLENG,INSPT,KSEC2,IBITS)
          IF( KRET.NE.0 ) THEN
            WRITE(GRPRSM,*) 'GRIBEX: Error decoding spectral section 2'
            KRET = 545
            GOTO 900
          ENDIF
        ENDIF
C
        ITRUNC = KSEC2(2)
C
        GOTO 520
      ENDIF
C
C****
C*    Polar Stereographic.
C****
C
      IF( KSEC2(1).EQ.5) THEN
C
C*      Octets 7 - 8  : Ni - number of points along X-axis.
C       Octets 9 - 10 : Nj - number of points along Y-axis.
C       Two 16 bit fields.
C
C       Insert / extract fields.
C
        CALL INXBIT(KGRIB,KLENG,INSPT,KSEC2(2),2,IBITS, 16,YFUNC,KRET)
        IF( KRET.NE.0) THEN
          KRET = 523
          WRITE(GRPRSM,*) 'GRIBEX: Error inserting/extracting'
          WRITE(GRPRSM,*)
     X  'GRIBEX: number of points along X or Y axis.'
          WRITE(GRPRSM,*) 'GRIBEX: Return code = ', KRET
          GO TO 900
        ENDIF
C
C*      Octets 11 - 13 : La1 - latitude of first grid point.
C       Octets 14 - 16 : Lo1 - longitude of first grid point.
C       Two 24 bit fields.
C
C       When coding data, set sign bit to 1, if value is negative.
C
        IF( LENCODE ) THEN
          CALL CSGNBT( ILALO(1), KSEC2(4), 24, KRET)
          CALL CSGNBT( ILALO(2), KSEC2(5), 24, KRET)
        ENDIF
C
C       Insert / extract fields.
C
        CALL INXBIT(KGRIB,KLENG,INSPT,ILALO(1),2,IBITS, 24,YFUNC,KRET)
        IF( KRET.NE.0) THEN
          KRET = 506
          WRITE(GRPRSM,*) 'GRIBEX: Error inserting/extracting'
          WRITE(GRPRSM,*)
     X  'GRIBEX: latitude or longitude of first grid pt.'
          WRITE(GRPRSM,*) 'GRIBEX: Return code = ', KRET
          GO TO 900
        ENDIF
C
C       When decoding data, if sign bit is 1, value is negative.
C
        IF( LDECODE ) THEN
          CALL DSGNBT( KSEC2(4), ILALO(1), 24, KRET)
          CALL DSGNBT( KSEC2(5), ILALO(2), 24, KRET)
        ENDIF
C
C*      Octet 17 : Resolution and components flag.
C       One 8 bit field.
C
C       Resolution flag ( KSEC2(6) ) is not applicable.
C
        KSEC2(6) = 0
        IF( LENCODE ) IRESOL = KSEC2(18)+KSEC2(19)
C
C       Insert / extract field.
C
        CALL INXBIT(KGRIB,KLENG,INSPT,IRESOL,1,IBITS, 8,YFUNC,KRET)
        IF( KRET.NE.0) THEN
          KRET = 507
          WRITE(GRPRSM,*) 'GRIBEX: Error inserting/extracting'
          WRITE(GRPRSM,*) 'GRIBEX: components flag.'
          WRITE(GRPRSM,*) 'GRIBEX: Return code = ', KRET
          GO TO 900
        ENDIF
C
        IF( LDECODE ) THEN
Cd
Cd        All flag fields are already set to 0, so
          IF( IRESOL.EQ.0) GO TO 513
Cd
Cd        Fix up for flag which was different in Experimental edition.
Cd
          IF( KSEC0(2).EQ.-1.AND.(IRESOL.EQ.1.OR.IRESOL.EQ.3))
     X      IRESOL = 128
Cd
Cd        Resolution flag is not applicable.
          IF( IRESOL.GE.128) IRESOL = IRESOL - 128
Cd
Cd        Set earth flag.
          IF( IRESOL.GE.64) THEN
            KSEC2(18) = 64
            IRESOL    = IRESOL - 64
          ENDIF
Cd
Cd        Set components flag.
          KSEC2(19) = IRESOL
Cd
        ENDIF
C
  513   CONTINUE
C
C       Insert / extract field.
C
C       CALL INXBIT(KGRIB,KLENG,INSPT,KSEC2(6),1,IBITS, 8,YFUNC,KRET)
C       IF( KRET.NE.0) THEN
C         KRET = 507
C         WRITE(GRPRSM,*) 'GRIBEX: Error inserting/extracting'
C         WRITE(GRPRSM,*) 'GRIBEX: components flag.'
C         WRITE(GRPRSM,*) 'GRIBEX: Return code = ', KRET
C         GO TO 900
C       ENDIF
C
C*      Octets 18 - 20 : LoV - orientation of the grid.
C       One 24 bit field.
C
C       When coding data, set sign bit to 1, if value is negative.
C
        IF( LENCODE ) CALL CSGNBT( ILALO(1), KSEC2(7), 24, KRET)
C
C       Insert / extract fields.
C
        CALL INXBIT(KGRIB,KLENG,INSPT,ILALO(1),1,IBITS, 24,YFUNC,KRET)
        IF( KRET.NE.0) THEN
          KRET = 508
          WRITE(GRPRSM,*) 'GRIBEX: Error inserting/extracting'
          WRITE(GRPRSM,*)
     X  'GRIBEX: latitude or longitude of last grid point.'
          WRITE(GRPRSM,*) 'GRIBEX: Return code = ', KRET
          GO TO 900
        ENDIF
C
C       When decoding data, if sign bit is 1, value is negative.
C
        IF( LDECODE ) CALL DSGNBT( KSEC2(7), ILALO(1), 24, KRET)
C
C*      Octets 21 - 23 : Dx - X direction grid length.
C*      Octets 24 - 26 : Dy - Y direction grid length.
C       Two 24 bit fields.
C
C       Insert / extract fields.
C
        CALL INXBIT(KGRIB,KLENG,INSPT,KSEC2(9),2,IBITS, 24,YFUNC,KRET)
        IF( KRET.NE.0) THEN
          KRET = 524
          WRITE(GRPRSM,*) 'GRIBEX: Error inserting/extracting'
          WRITE(GRPRSM,*) 'GRIBEX: X or Y axis grid length.'
          WRITE(GRPRSM,*) 'GRIBEX: Return code = ', KRET
          GO TO 900
        ENDIF
C
C*      Octet 27 : Projection centre flag.
C       One 8-bit field.
C
C       Insert / extract field.
C
        CALL INXBIT(KGRIB,KLENG,INSPT,KSEC2(13),1,IBITS, 8,YFUNC,KRET)
        IF( KRET.NE.0) THEN
          KRET = 525
          WRITE(GRPRSM,*) 'GRIBEX: Error inserting/extracting'
          WRITE(GRPRSM,*) 'GRIBEX: Projection centre flag.'
          WRITE(GRPRSM,*) 'GRIBEX: Return code = ', KRET
          GO TO 900
        ENDIF
C
C*      Octet 28 : Scanning mode flags.
C       One 8 bit field.
C
C       Insert / extract field.
C
        CALL INXBIT(KGRIB,KLENG,INSPT,KSEC2(11),1,IBITS, 8,YFUNC,KRET)
        IF( KRET.NE.0) THEN
          KRET = 511
          WRITE(GRPRSM,*) 'GRIBEX: Error inserting/extracting'
          WRITE(GRPRSM,*) 'GRIBEX: scanning mode flags.'
          WRITE(GRPRSM,*) 'GRIBEX: Return code = ', KRET
          GO TO 900
        ENDIF
C
C       Fix-up for flag which was different in Experimental Edition.
        IF( KSEC0(2).EQ.-1.AND.KSEC2(11).EQ.1) KSEC2(11) = 0
C
C*      Octets 29 - 32 : Reserved.
C       Two 16 bit fields.
C
C       If insertion, set bits to 0.
        IF( LENCODE ) THEN
          CALL INXBIT(KGRIB,KLENG,INSPT, 0, 1,IBITS, 32,YFUNC,KRET)
          IF( KRET.NE.0) THEN
            KRET = 810
            WRITE(GRPRSM,*) 'GRIBEX: Error inserting dummy zero.'
            WRITE(GRPRSM,*) 'GRIBEX: Return code = ', KRET
            GO TO 900
          ENDIF
        ELSE
Cd
Cd        If extraction, only update bit pointer.
          INSPT = INSPT + 32
        ENDIF
C
        GO TO 520
      ENDIF
C
C****
C*    Space view perspective or orthographic.
C****
C
      IF( KSEC2(1).EQ.90) THEN
C
        IF( LENCODE ) THEN
          KRET = ESVSEC2(KGRIB,KLENG,INSPT,KSEC2,IBITS,ILEN2)
          IF( KRET.NE.0 ) THEN
            WRITE(GRPRSM,*) 'GRIBEX: Error encoding spectral section 2'
            KRET = 546
            GOTO 900
          ENDIF
        ELSE
          KRET = DSVSEC2(KGRIB,KLENG,INSPT,KSEC2,IBITS,ILEN2)
          IF( KRET.NE.0 ) THEN
            WRITE(GRPRSM,*) 'GRIBEX: Error decoding spectral section 2'
            KRET = 547
            GOTO 900
          ENDIF
        ENDIF
C
C
        GO TO 520
C
      ENDIF
C
C****
C*    Mercator
C****
C
      IF( KSEC2(1).EQ.1) THEN
C
        IF( LENCODE ) THEN
          KRET = EMESEC2(KGRIB,KLENG,INSPT,KSEC0,KSEC2,IBITS,LQUASI)
          IF( KRET.NE.0 ) THEN
            WRITE(GRPRSM,*) 'GRIBEX: Error encoding Mercator section 2'
            KRET = 546
            GOTO 900
          ENDIF
        ELSE
          KRET = DMESEC2(KGRIB,KLENG,INSPT,KSEC0,KSEC2,IBITS,IMISNG)
          IF( KRET.NE.0 ) THEN
            WRITE(GRPRSM,*) 'GRIBEX: Error decoding Mercator section 2'
            KRET = 547
            GOTO 900
          ENDIF
        ENDIF
C
C
        GO TO 520
C
      ENDIF
C
C****
C*    Lambert Conformal.
C****
C
      IF( KSEC2(1).EQ.3) THEN
C
C*      Octets 7 - 8  : Ni - number of points along X-axis.
C       Octets 9 - 10 : Nj - number of points along Y-axis.
C       Two 16 bit fields.
C
C       Insert / extract fields.
C
        CALL INXBIT(KGRIB,KLENG,INSPT,KSEC2(2),2,IBITS, 16,YFUNC,KRET)
        IF( KRET.NE.0) THEN
          KRET = 523
          WRITE(GRPRSM,*) 'GRIBEX: Error inserting/extracting'
          WRITE(GRPRSM,*)
     X  'GRIBEX: number of points along X or Y axis.'
          WRITE(GRPRSM,*) 'GRIBEX: Return code = ', KRET
          GO TO 900
        ENDIF
C
C*      Octets 11 - 13 : La1 - latitude of first grid point.
C       Octets 14 - 16 : Lo1 - longitude of first grid point.
C       Two 24 bit fields.
C
Ce      When coding data, set sign bit to 1, if value is negative.
Ce
        IF( LENCODE ) THEN
          CALL CSGNBT( ILALO(1), KSEC2(4), 24, KRET)
          CALL CSGNBT( ILALO(2), KSEC2(5), 24, KRET)
        ENDIF
C
C       Insert / extract fields.
C
        CALL INXBIT(KGRIB,KLENG,INSPT,ILALO(1),2,IBITS, 24,YFUNC,KRET)
        IF( KRET.NE.0) THEN
          KRET = 506
          WRITE(GRPRSM,*) 'GRIBEX: Error inserting/extracting'
          WRITE(GRPRSM,*)
     X  'GRIBEX: latitude or longitude of first grid pt.'
          WRITE(GRPRSM,*) 'GRIBEX: Return code = ', KRET
          GO TO 900
        ENDIF
C
Cd      When decoding data, if sign bit is 1, value is negative.
Cd
        IF( LDECODE ) THEN
          CALL DSGNBT( KSEC2(4), ILALO(1), 24, KRET)
          CALL DSGNBT( KSEC2(5), ILALO(2), 24, KRET)
        ENDIF
C
C*      Octet 17 : Resolution and components flag.
C       One 8 bit field.
C
C       Resolution flag ( KSEC2(6) ) is not applicable.
C
        IF( LENCODE ) IRESOL = KSEC2(18)+KSEC2(19)+KSEC2(6)
C
C       Insert / extract field.
C
        CALL INXBIT(KGRIB,KLENG,INSPT,IRESOL,1,IBITS, 8,YFUNC,KRET)
        IF( KRET.NE.0) THEN
          KRET = 507
          WRITE(GRPRSM,*) 'GRIBEX: Error inserting/extracting'
          WRITE(GRPRSM,*) 'GRIBEX: components flag.'
          WRITE(GRPRSM,*) 'GRIBEX: Return code = ', KRET
          GO TO 900
        ENDIF
C
        IF( LDECODE ) THEN
Cd
Cd        If all flag fields are already set to 0, bypass.
Cd
          IF( IRESOL.EQ.0) GO TO 515
Cd
Cd        Resolution flag is not applicable.
Cd
          IF( IRESOL.GE.128) THEN
            KSEC2(6) = 128
            IRESOL   = IRESOL - 128
          ENDIF
Cd
Cd        Set earth flag.
Cd
          IF( IRESOL.GE.64) THEN
            KSEC2(18) = 64
            IRESOL    = IRESOL - 64
          ENDIF
Cd
Cd        Set components flag.
Cd
          KSEC2(19) = IRESOL
Cd
        ENDIF
C
  515   CONTINUE
C
C       Insert / extract field.
C
C*      Octets 18 - 20 : LoV - orientation of the grid.
C       One 24 bit field.
C
Ce      When coding data, set sign bit to 1, if value is negative.
Ce
        IF( LENCODE ) CALL CSGNBT( ILALO(1), KSEC2(7), 24, KRET)
C
C       Insert / extract fields.
C
        CALL INXBIT(KGRIB,KLENG,INSPT,ILALO(1),1,IBITS, 24,YFUNC,KRET)
        IF( KRET.NE.0) THEN
          KRET = 508
          WRITE(GRPRSM,*)
     X  'GRIBEX: Error inserting/extracting'
          WRITE(GRPRSM,*)
     X  'GRIBEX: latitude or longitude of last grid point.'
          WRITE(GRPRSM,*) 'GRIBEX: Return code = ', KRET
          GO TO 900
        ENDIF
C
Cd      When decoding data, if sign bit is 1, value is negative.
Cd
        IF( LDECODE ) CALL DSGNBT( KSEC2(7), ILALO(1), 24, KRET)
C
C*      Octets 21 - 23 : Dx - X direction grid length.
C*      Octets 24 - 26 : Dy - Y direction grid length.
C       Two 24 bit fields.
C
C       Insert / extract fields.
C
        CALL INXBIT(KGRIB,KLENG,INSPT,KSEC2(9),2,IBITS, 24,YFUNC,KRET)
        IF( KRET.NE.0) THEN
          KRET = 524
          WRITE(GRPRSM,*) 'GRIBEX: Error inserting/extracting'
          WRITE(GRPRSM,*) 'GRIBEX: X or Y axis grid length.'
          WRITE(GRPRSM,*) 'GRIBEX: Return code = ', KRET
          GO TO 900
        ENDIF
C
C*      Octet 27 : Projection centre flag.
C       One 8-bit field.
C
C       Insert / extract field.
C
        CALL INXBIT(KGRIB,KLENG,INSPT,KSEC2(13),1,IBITS, 8,YFUNC,KRET)
        IF( KRET.NE.0) THEN
          KRET = 525
          WRITE(GRPRSM,*) 'GRIBEX: Error inserting/extracting'
          WRITE(GRPRSM,*) 'GRIBEX: Projection centre flag.'
          WRITE(GRPRSM,*) 'GRIBEX: Return code = ', KRET
          GO TO 900
        ENDIF
C
C*      Octet 28 : Scanning mode flags.
C       One 8 bit field.
C
C       Insert / extract field.
C
        CALL INXBIT(KGRIB,KLENG,INSPT,KSEC2(11),1,IBITS, 8,YFUNC,KRET)
        IF( KRET.NE.0) THEN
          KRET = 511
          WRITE(GRPRSM,*) 'GRIBEX: Error inserting/extracting'
          WRITE(GRPRSM,*) 'GRIBEX: scanning mode flags.'
          WRITE(GRPRSM,*) 'GRIBEX: Return code = ', KRET
          GO TO 900
        ENDIF
C
C       Fix-up for flag which was different in Experimental
C            Edition.
C
        IF( KSEC0(2).EQ.-1.AND.KSEC2(11).EQ.1) KSEC2(11) = 0
C
C*      Octets 29 - 31 : Latin 1.
C*      Octets 32 - 34 : Latin 2.
C       Two 24 bit fields.
C
Ce      When coding data, set sign bit to 1, if value is negative.
Ce
        IF( LENCODE ) THEN
          CALL CSGNBT( ILALO(1), KSEC2(14), 24, KRET)
          CALL CSGNBT( ILALO(2), KSEC2(15), 24, KRET)
        ENDIF
C
C       Insert / extract fields.
C
        CALL INXBIT(KGRIB,KLENG,INSPT,ILALO(1),2,IBITS, 24,YFUNC,KRET)
        IF( KRET.NE.0) THEN
          KRET = 531
          WRITE(GRPRSM,*) 'GRIBEX: Error inserting/extracting'
          WRITE(GRPRSM,*)
     X  'GRIBEX: Latin1 or Latin2 of secants points.'
          WRITE(GRPRSM,*) 'GRIBEX: Return code = ', KRET
          GO TO 900
        ENDIF
C
Cd      When decoding data, if sign bit is 1, value is negative.
C
        IF( LDECODE ) THEN
          CALL DSGNBT( KSEC2(14), ILALO(1), 24, KRET)
          CALL DSGNBT( KSEC2(15), ILALO(2), 24, KRET)
        ENDIF
C
C*      Octets 35 - 37 : Latitude of the southern pole.
C*      Octets 38 - 40 : Longitude of the southern pole.
C       Two 24 bit fields.
C
Ce      When coding data, set sign bit to 1, if value is negative.
Ce
        IF( LENCODE ) THEN
          CALL CSGNBT( ILALO(1), KSEC2(20), 24, KRET)
          CALL CSGNBT( ILALO(2), KSEC2(21), 24, KRET)
        ENDIF
C
C       Insert / extract fields.
C
        CALL INXBIT(KGRIB,KLENG,INSPT,ILALO(1),2,IBITS, 24,YFUNC,KRET)
        IF( KRET.NE.0) THEN
          KRET = 532
          WRITE(GRPRSM,*) 'GRIBEX: Error inserting/extracting'
          WRITE(GRPRSM,*)
     X  'GRIBEX: latitude/longitude of southern pole.'
          WRITE(GRPRSM,*) 'GRIBEX: Return code = ', KRET
          GO TO 900
        ENDIF
C
Cd      When decoding data, if sign bit is 1, value is negative.
Cd
        IF( LDECODE ) THEN
          CALL DSGNBT( KSEC2(20), ILALO(1), 24, KRET)
          CALL DSGNBT( KSEC2(21), ILALO(2), 24, KRET)
        ENDIF
C
C*      Octets 41 - 42 : Reserved.
C       One 16 bit fields.
C
        IF( LENCODE ) THEN
C
Ce        All bits already set to 0.
Ce        No insertion, only update bit pointer.
Ce
          INSPT = INSPT + 16
Ce
        ELSE
Cd
Cd        No extraction, only update bit pointer.
Cd
          INSPT = INSPT + 16
Cd
        ENDIF
C
        GO TO 520
      ENDIF
C
C
C****
C     Ocean grid definition.
C****
C
      IF( KSEC2(1).EQ.192 ) THEN
C
        IF( LENCODE ) THEN
          KRET = EOCSEC2(KGRIB,KLENG,INSPT,KSEC2,IBITS)
          IF( KRET.NE.0 ) THEN
            WRITE(GRPRSM,*)
     X  'GRIBEX: Error encoding ECMWF ocean section 2'
            KRET = 546
            GOTO 900
          ENDIF
        ELSE
          KRET = DOCSEC2(KGRIB,KLENG,INSPT,KSEC2,IBITS)
          IF( KRET.NE.0 ) THEN
            WRITE(GRPRSM,*)
     X  'GRIBEX: Error decoding ECMWF ocean section 2'
            KRET = 547
            GOTO 900
          ENDIF
        ENDIF
        GOTO 520
C
      ENDIF
C
C****
C*    Other representation types not yet catered for.
C****
C
      KRET = 598
      WRITE(GRPRSM,*)
     X  'GRIBEX: Representation type not catered for:',KSEC2(1)
      WRITE(GRPRSM,*) 'GRIBEX: Return code = ', KRET
      GO TO 900
C
C*    Rotation parameters for rotated or stretched and rotated grids.
C     (Gaussian, Latitude/longitude or Spherical Harmonics)
C
  520 CONTINUE
C
      IF( KSEC2(1).EQ.10.OR.KSEC2(1).EQ.30.OR.
     X    KSEC2(1).EQ.14.OR.KSEC2(1).EQ.34.OR.
     X    KSEC2(1).EQ.60.OR.KSEC2(1).EQ.80) THEN
C
C*      Octets 33 - 35 : Latitude of the southern pole.
C       Octets 36 - 38 : Longitude of the southern pole.
C       Two 24 bit fields.
C
C       When coding data, set sign bit to 1, if value is negative.
C
        IF( LENCODE ) THEN
          CALL CSGNBT( ILALO(1), KSEC2(13), 24, KRET)
          CALL CSGNBT( ILALO(2), KSEC2(14), 24, KRET)
        ENDIF
C
C       Insert / extract fields.
C
        CALL INXBIT(KGRIB,KLENG,INSPT,ILALO(1),2,IBITS, 24,YFUNC,KRET)
        IF( KRET.NE.0) THEN
          KRET = 517
          WRITE(GRPRSM,*) 'GRIBEX: Error inserting/extracting'
          WRITE(GRPRSM,*)
     X  'GRIBEX: latitude or longitude of southern pole.'
          WRITE(GRPRSM,*) 'GRIBEX: Return code = ', KRET
          GO TO 900
        ENDIF
C
C       When decoding data, if sign bit is 1, value is negative.
C
        IF( LDECODE ) THEN
          CALL DSGNBT( KSEC2(13), ILALO(1), 24, KRET)
          CALL DSGNBT( KSEC2(14), ILALO(2), 24, KRET)
        ENDIF
C
C*      Octets 39 - 42 : Angle of rotation.
C       One 8 bit and one 24 bit field.
C
        IF( LENCODE ) THEN
Ce
Ce        Convert floating point to GRIB representation.
          ITRND = 1
          CALL CONFP3 (PSEC2(1),IEXP,IMANT,IBITS,ITRND)
        ENDIF
C
C       Insert / extract fields.
C
        CALL INXBIT(KGRIB,KLENG,INSPT,IEXP,1,IBITS, 8,YFUNC,KRETA)
        CALL INXBIT(KGRIB,KLENG,INSPT,IMANT,1,IBITS, 24,YFUNC,KRETB)
        KRET = KRET + KRETB
        IF( KRET.NE.0) THEN
          KRET = 518
          WRITE(GRPRSM,*) 'GRIBEX: Error inserting/extracting'
          WRITE(GRPRSM,*) 'GRIBEX: angle of rotation.'
          WRITE(GRPRSM,*) 'GRIBEX: Return code = ', KRET
          GO TO 900
        ENDIF
C
        IF( LDECODE ) THEN
Cd
Cd        Convert GRIB representation to floating point.
          CALL DECFP2 (PSEC2(1),IEXP,IMANT)
Cd
        ENDIF
      ENDIF
C
C*    Stretching parameters for stretched grids.
C     (Gaussian, Latitude/longitude or Spherical Harmonics)
C
      IF( KSEC2(1).EQ.20.OR.KSEC2(1).EQ.24.OR.KSEC2(1).EQ.70) THEN
C
C*      Octets 33 - 35 : Latitude of pole of stretching.
C       Octets 36 - 38 : Longitude of pole of stretching.
C       Two 24 bit fields.
C
C       When coding data, set sign bit to 1, if value is negative.
C
        IF( LENCODE ) THEN
          CALL CSGNBT( ILALO(1), KSEC2(15), 24, KRET)
          CALL CSGNBT( ILALO(2), KSEC2(16), 24, KRET)
        ENDIF
C
C       Insert / extract fields.
C
        CALL INXBIT(KGRIB,KLENG,INSPT,ILALO(1),2,IBITS, 24,YFUNC,KRET)
        IF( KRET.NE.0) THEN
          KRET = 519
          WRITE(GRPRSM,*) 'GRIBEX: Error inserting/extracting'
          WRITE(GRPRSM,*)
     X  'GRIBEX: latitude/longitude of pole of stretching.'
          WRITE(GRPRSM,*) 'GRIBEX: Return code = ', KRET
          GO TO 900
        ENDIF
C
C       When decoding data, if sign bit is 1, value is negative.
C
        IF( LDECODE ) THEN
          CALL DSGNBT( KSEC2(15), ILALO(1), 24, KRET)
          CALL DSGNBT( KSEC2(16), ILALO(2), 24, KRET)
        ENDIF
C
C*      Octets 39 - 42 : Stretching factor.
C       One 8 bit and one 24 bit field.
C
C       Convert floating point to GRIB representation.
        ITRND = 1
        IF( LENCODE ) CALL CONFP3 (PSEC2(2),IEXP,IMANT,IBITS,ITRND)
C
C       Insert / extract fields.
C
        CALL INXBIT(KGRIB,KLENG,INSPT,IEXP,1,IBITS, 8,YFUNC,KRETA)
        CALL INXBIT(KGRIB,KLENG,INSPT,IMANT,1,IBITS, 24,YFUNC,KRETB)
        KRET = KRETA + KRETB
        IF( KRET.NE.0) THEN
          KRET = 520
          WRITE(GRPRSM,*) 'GRIBEX: Error inserting/extracting'
          WRITE(GRPRSM,*) 'GRIBEX: stretching factor.'
          WRITE(GRPRSM,*) 'GRIBEX: Return code = ', KRET
          GO TO 900
        ENDIF
C
C       Convert GRIB representation to floating point.
        IF( LDECODE ) CALL DECFP2 (PSEC2(2),IEXP,IMANT)
C
      ENDIF
C
C*    Stretching parameters for stretched and rotated grids.
C     (Gaussian, Latitude/longitude or Spherical Harmonics)
C
      IF( KSEC2(1).EQ.30.OR.KSEC2(1).EQ.34.OR.KSEC2(1).EQ.80) THEN
C
C*      Octets 43 - 45 : Latitude of pole of stretching.
C       Octets 46 - 48 : Longitude of pole of stretching.
C       Two 24 bit fields.
C
C       When coding data, set sign bit to 1, if value is negative.
C
        IF( LENCODE ) THEN
          CALL CSGNBT( ILALO(1), KSEC2(15), 24, KRET)
          CALL CSGNBT( ILALO(2), KSEC2(16), 24, KRET)
        ENDIF
C
C       Insert / extract fields.
C
        CALL INXBIT(KGRIB,KLENG,INSPT,ILALO(1),2,IBITS, 24,YFUNC,KRET)
        IF( KRET.NE.0) THEN
          KRET = 519
          WRITE(GRPRSM,*)
     X  'GRIBEX: Error inserting/extracting'
          WRITE(GRPRSM,*)
     X  'GRIBEX: latitude/longitude of pole of stretching.'
          WRITE(GRPRSM,*) 'GRIBEX: Return code = ', KRET
          GO TO 900
        ENDIF
C
C       When decoding data, if sign bit is 1, value is negative.
C
        IF( LDECODE ) THEN
          CALL DSGNBT( KSEC2(15), ILALO(1), 24, KRET)
          CALL DSGNBT( KSEC2(16), ILALO(2), 24, KRET)
        ENDIF
C
C*      Octets 49 - 52 : Stretching factor.
C       One 8 bit and one 24 bit field.
C
C       Convert floating point to GRIB representation.
        ITRND = 1
        IF( LENCODE ) CALL CONFP3 (PSEC2(2),IEXP,IMANT,IBITS,ITRND)
C
C       Insert / extract fields.
C
        CALL INXBIT(KGRIB,KLENG,INSPT,IEXP,1,IBITS, 8,YFUNC,KRETA)
        CALL INXBIT(KGRIB,KLENG,INSPT,IMANT,1,IBITS, 24,YFUNC,KRETB)
        KRET = KRETA + KRETB
        IF( KRET.NE.0) THEN
          KRET = 520
          WRITE(GRPRSM,*) 'GRIBEX: Error inserting/extracting'
          WRITE(GRPRSM,*) 'GRIBEX: stretching factor.'
          WRITE(GRPRSM,*) 'GRIBEX: Return code = ', KRET
          GO TO 900
        ENDIF
C
C       Convert GRIB representation to floating point.
C
        IF( LDECODE ) CALL DECFP2 (PSEC2(2),IEXP,IMANT)
C
      ENDIF
C
C*    Vertical coordinate parameters, if any.
C
      IF( KSEC2(12).NE.0) THEN
        ITRND = 1
        DO 530 JLOOP = 1 , KSEC2(12)
C
C         One 8 bit and one 24 bit field.
C
Ce        Convert floating point to GRIB representation.
          IF( LENCODE )
     X      CALL CONFP3 (PSEC2(JLOOP+10),IEXP,IMANT, IBITS,ITRND)
C
C         Insert / extract fields.
C
          CALL INXBIT(KGRIB,KLENG,INSPT,IEXP,1,IBITS, 8,YFUNC,KRETA)
          CALL INXBIT(KGRIB,KLENG,INSPT,IMANT,1,IBITS, 24,YFUNC,KRETB)
          KRET = KRETA + KRETB
          IF( KRET.NE.0) THEN
            KRET = 521
            WRITE(GRPRSM,*) 'GRIBEX: Error inserting/extracting'
            WRITE(GRPRSM,*) 'GRIBEX: vertical coordinate parameters.'
            WRITE(GRPRSM,*) 'GRIBEX: Return code = ', KRET
            GO TO 900
          ENDIF
C
Cd        Convert GRIB representation to floating point.
          IF( LDECODE ) CALL DECFP2 (PSEC2(JLOOP+10),IEXP,IMANT)
C
  530   CONTINUE
      ENDIF
C
C*    List of number of points, if any.
C     Number of 16 bit fields.
C
      IF( LQUASI) THEN
C
C       Insert / extract fields.
C
        CALL INXBIT(KGRIB,KLENG,INSPT,KSEC2(23),KSEC2(3),IBITS,
     X               16,YFUNC,KRET)
        IF( KRET.NE.0) THEN
          KRET = 522
          WRITE(GRPRSM,*) 'GRIBEX: Error inserting/extracting'
          WRITE(GRPRSM,*) 'GRIBEX: list of numbers of points.'
          WRITE(GRPRSM,*) 'GRIBEX: Return code = ', KRET
          GO TO 900
        ENDIF
      ENDIF
C
C     -----------------------------------------------------------------|
C
C
C
C
C
C
C
C
C
C
C*    Section 6 . Bit Map Section (section 3) of GRIB code.
C     -----------------------------------------------------------------|
C
  600 CONTINUE
C
      IF( LPDEBUG ) WRITE(GRPRSM,*)
     X  'GRIBEX: Section 6. Handle Bit Map Section (Section 3)'
C
C*    Go to section 9, if decoding of identification sections only and
C     GRIB Code Edition is higher than 0. If Edition is lower the
C     length of the GRIB message needs to be calculated, so change
C     function to 'L' to complete decoding of section 0.
C     Number of data values decoded ( KSEC4(1) ) already set to 0.
C
      IF( HOPER(1:1).EQ.'I') THEN
        IF( KSEC0(2).GT.0) THEN
          GO TO 900
        ELSE
          YFUNC = 'L'
        ENDIF
      ENDIF
C
C*    Set integer or real missing data value.
C
      IF( KSEC4(5) .EQ. 0 )  THEN
        ZMSVAL = PSEC3(2)
      ELSE
        ZMSVAL = REAL(KSEC3(2))
      ENDIF
C
C*    Go to section 7, if no bit map required.
C
      IF( .NOT.LSECT3 ) GO TO 700
C
C*    Set bit-map flag and attempt no decoding of bit-map, if
C     routine has been called by the DECOGB interface routine,
C     which is provided for upward compatibility with old software.
C
      IF( HOPER.EQ.'Z') THEN
        ISBMAP = -5
        WRITE(GRPRSM,*) 'GRIBEX: Bit-map found. No data decoded.'
        WRITE(GRPRSM,*) 'GRIBEX: Return code = ', ISBMAP
        GO TO 900
      ENDIF
C
C*    Check consistency of values given, with GRIB code, if required.
C
      IF( NVCK.EQ.1.AND. LENCODE ) THEN
        CALL GRCHK3 (KSEC1,KSEC3,PSEC3,KRET)
        IF( KRET.NE.0) THEN
          KRET = 699
          WRITE(GRPRSM,*)
     X  'GRIBEX: Error found checking values for section 3'
          WRITE(GRPRSM,*) 'GRIBEX: Return code = ', KRET
          GO TO 900
        ENDIF
      ENDIF
C
C*    When coding data, calculate the length of section and number
C     of unused bits.
C
      IF( LENCODE ) THEN
Ce
        IF( KSEC3(1).NE.0) THEN
Ce
Ce        Predetermined bit-map table included.
Ce        Length of section is 6 octets, number of unused bits is 0.
          ILEN3 = 6
          INUB  = 0
Cjdc      KRET = GBITMAP(KSEC3(1), IBTVALS, NONMISS, IBTPTR, NBYTE)
Cjdc      IVALS = NONMISS
Ce
        ELSE
Ce
Ce        Bit-map included in section 3.
Ce        Length of section = 6 octets of header + length of
Ce        bit-map, rounded to a multiple of 2 octets.
Ce
Ce        Set IVALS to the number of bits in the bit-map.
          IF( KSEC4(8).EQ.0) THEN
Ce
Ce          Each bit in the bit-map represents a single value.
            IVALS = ILENF
          ELSE
Ce
Ce          Each bit in the bit-map represents a matrix of values.
            IVALS = ILENF / (KSEC4(50)*KSEC4(51))
          ENDIF
Ce
          ITEMP = 48 + IVALS
          ILEN3 = ( ITEMP + 15 ) / 16
          ILEN3 = ILEN3 * 2
Ce
Ce        Number of unused bits.
          INUB = ILEN3 * 8 - ITEMP
Ce
        ENDIF
Ce
      ENDIF
C
C*    Octets 1 - 3 : Length of section.
C     One 24 bit field.
C
C     Insert/extract field.
C
      CALL INXBIT(KGRIB,KLENG,INSPT,ILEN3,1,IBITS, 24,YFUNC,KRET)
        IF( KRET.NE.0) THEN
          KRET = 601
          WRITE(GRPRSM,*)
     X      'GRIBEX: Error inserting/extracting section 3 length'
          WRITE(GRPRSM,*) 'GRIBEX: Return code = ', KRET
          GO TO 900
        ENDIF
C
C*    Print length of Section 3, if required.
C
      IF( LPDEBUG ) WRITE(GRPRSM,*)
     X  'GRIBEX: Length of Section 3 of GRIB = ',ILEN3,' octets.'
C
C     If only length is required, update bit-pointer and jump
C     to extraction of length of section 4.
C
      IF( YFUNC.EQ.'L') THEN
        INSPT = INSPT -24 + ILEN3 * 8
        GO TO 700
      ENDIF
C
C*    Octet 4 : Number of unused bits at end of section.
C     One 8 bit field.
C
C     Insert/extract field.
C
      CALL INXBIT(KGRIB,KLENG,INSPT,INUB,1,IBITS, 8,YFUNC,KRET)
        IF( KRET.NE.0) THEN
          KRET = 602
          WRITE(GRPRSM,*) 'GRIBEX: Error inserting/extracting number'
          WRITE(GRPRSM,*)
     X  'GRIBEX: unused bits at the end of Section 3.'
          WRITE(GRPRSM,*) 'GRIBEX: Return code = ', KRET
          GO TO 900
        ENDIF
C
C*    Octets 5-6 : Bit-map table reference.
C     One 16 bit field.
C
C     Insert/extract field.
C
      CALL INXBIT(KGRIB,KLENG,INSPT,KSEC3(1),1,IBITS, 16,YFUNC,KRET)
      IF( KRET.NE.0) THEN
        KRET = 603
        WRITE(GRPRSM,*)
     X    'GRIBEX: Error inserting/extracting bit-map reference table'
        WRITE(GRPRSM,*) 'GRIBEX: Return code = ', KRET
        GO TO 900
      ENDIF
C
C*    Set integer or real missing data value.
C
      IF( KSEC4(5) .EQ. 0 )  THEN
        ZMSVAL = PSEC3(2)
      ELSE
        ZMSVAL = REAL(KSEC3(2))
      ENDIF
C
C*    Finished if a predetermined bit-map table is given.
C
      IF( KSEC3(1).NE.0) GO TO 700
C
C*    Bit-map definition included.
C
      IF( LENCODE ) THEN
Ce
Ce      Insert primary bit-map. Set function for fixed length
Ce      messages if required.
Ce
        YTEMP = YFUNC
        IF( HOPER.EQ.'M') YTEMP = 'M'
Ce
        IF( KSEC4(8).EQ.64) THEN
Ce
Ce        Matrix of values at a point.
          ITEMP = KSEC4(50) * KSEC4(51)
        ELSE
Ce
Ce        Single value at each point.
          ITEMP = 1
        ENDIF
Ce
Ce      Retain pointer to bit-map location.
Ce
        IBMAP = INSPT
Ce
        CALL INSMP1 (KGRIB,KLENG,INSPT,KSEC4(9),PSEC4,
     X               ILENF,IBITS,ZMSVAL,YTEMP,ITEMP,NDBG,KRET)
        IF( KRET.NE.0) THEN
          KRET = 604
          WRITE(GRPRSM,*) 'GRIBEX: Error inserting primary bit map.'
          WRITE(GRPRSM,*) 'GRIBEX: Return code = ', KRET
          GO TO 900
        ENDIF
Ce
Ce      Number of data values remaining to be handled
Ce      is now in ILENF, which is used when finding maximum and
Ce      minimum values etc. When a matrix of values is present
Ce      PSEC4 may still contain missing data indicators for each
Ce      matrix.
Ce
Ce      Effective number of points will be returned in KSEC4(21).
Ce
        NONMISS = ILENF
Ce
Ce      Unused bits at end of section.
Ce      These bits are already set to 0, so update bit-pointer only.
Ce
        INSPT = INSPT + INUB
Ce
      ELSE
Cd
Cd      Retain pointer to bit-map location.
Cd
        IBMAP = INSPT
Cd
Cd      IVALS is the number of bits in the bit-map. It is the same
Cd      as the number of data values (including missing data
Cd      values to be decoded) when each point represents a single
Cd      data value. When each bit in the bit-map represents a
Cd      matrix of values, it is the number of matrices.
Cd
        IVALS = (ILEN3 - 6) * 8 - INUB
Cd
Cd      Update bit-pointer to start of section 4 of Grib message.
        INSPT = INSPT - 48 + ILEN3 * 8
Cd
      ENDIF
C
C     -----------------------------------------------------------------|
C
C
C
C
C
C
C
C
C
C
C*    Section 7 . Binary Data Section (section 4) of GRIB code.
C     -----------------------------------------------------------------|
C
  700 CONTINUE
C
      IF( LPDEBUG ) WRITE(GRPRSM,*)
     X  'GRIBEX: Section 7. Handle Binary Data Section (Section 4)'
C
C*    Check consistency of values given, with GRIB code, if required.
C
      IF( NVCK.EQ.1.AND. LENCODE ) THEN
        CALL GRCHK4 (KSEC1,KSEC4,PSEC4,KRET)
        IF( KRET.NE.0) THEN
          KRET = 799
          WRITE(GRPRSM,*)
     X      'GRIBEX: Error found when checking values for section 4'
          WRITE(GRPRSM,*) 'GRIBEX: Return code = ', KRET
          GO TO 900
        ENDIF
      ENDIF
C
C*    Retain value of the pointer to the first bit in Section 4.
C     When coding data, this is needed later to insert the length
C     of Section 4 and the number of unused bits.
C     When decoding data, this is used later to calculate the
C     number of packed data values which have to be decoded.
C
      IPLEN = INSPT
C
C*    Octets 1 - 3 : Length of section.
C     One 24 bit field.
C
      IF( LENCODE ) THEN
Ce
Ce      Increment pointer.
        INSPT = INSPT + 24
      ELSE
Cd
Cd      Extract field.
Cd
        CALL INXBIT(KGRIB,KLENG,INSPT,ILEN4,1,IBITS, 24,YFUNC,KRET)
        IF( KRET.NE.0) THEN
          KRET = 701
          WRITE(GRPRSM,*) 'GRIBEX: Error extracting section 4 length'
          WRITE(GRPRSM,*) 'GRIBEX: Return code = ', KRET
          GO TO 900
        ENDIF
Cd
Cd      If a very large product, the section 4 length field holds
Cd      the number of bytes in the product after section 4 upto
Cd      the end of the padding bytes.
Cd      This is a fixup to get round the restriction on product lengths
Cd      due to the count being only 24 bits. It is only possible because
Cd      the (default) rounding for GRIB products is 120 bytes.
Cd

Cljbf   in case of big fields, revert the
Cljbf   workaround in decoding in case we realize it
Cljbf   is not paked using the *120 trick
Cljbf

        IF( LLARGE .AND. ILEN4.GT.120) THEN
          KSEC0(1) = KSEC0(1) / 120
          KSEC0(1) = KSEC0(1) * 2
          LLARGE = .FALSE.
        ENDIF

        IF( LLARGE ) ILEN4 = KSEC0(1) - (INSPT/8) - ILEN4 + 3
Cd
Cd      Print length of Section 4, if required.
Cd
        IF( LPDEBUG ) WRITE(GRPRSM,*)
     X    'GRIBEX: Length of Section 4 of GRIB = ',ILEN4,' octets.'
Cd
Cd      Set length if required, by updating bit-pointer and
Cd      adding length of section 5 (32 bits). Length in bytes.
Cd      Finished if length only required, so go to section 9.
Cd
        IF( YFUNC.EQ.'L'.OR.HOPER.EQ.'X') THEN
          KSEC0(1) = (INSPT - 24 + ILEN4 * 8 + 32) / 8
          IF( YFUNC.EQ.'L') GO TO 900
        ENDIF
Cd
      ENDIF
C
C*    Octet 4 : 4 bit flag field and 4 bit unused bit count field.
C     One 8 bit field for insertion/extraction purposes.
C
      IF( LENCODE ) THEN
Ce
Ce      Type of data (spherical harmonic coefficients or grid
Ce      point) is taken from KSEC4(3) only if no Section 2 is
Ce      included.(This allows for data coded without Section 2).
Ce
        IF( LSECT2 ) THEN
Ce
Ce        If section 2 is present, it says if data is spherical harmonic
Ce
          IF( LSPHERC ) THEN
            KSEC4(3) = 128
          ELSE
            KSEC4(3) = 0
          ENDIF
Ce
        ELSE
Ce
Ce        Section 4 says if it's spherical harmonic data..
Ce
          LSPHERC = ( KSEC4(3) .EQ. 128 )
          LGRDPT  = .NOT.LSPHERC
        ENDIF
Ce
Ce      When coding data, field is inserted later, when
Ce      number of unused bits is known and added to it.
Ce
Ce      Increment pointer.
        INSPT = INSPT + 8
Ce
      ELSE
Cd
Cd      Decoding -> extract field.
Cd
        CALL INXBIT(KGRIB,KLENG,INSPT,IFLAG,1,IBITS, 8,YFUNC,KRET)
        IF( KRET.NE.0) THEN
          KRET = 706
          WRITE(GRPRSM,*)
     X  'GRIBEX: Error extracting section 4 flag field.'
          WRITE(GRPRSM,*) 'GRIBEX: Return code = ', KRET
          GO TO 900
        ENDIF
Cd
Cd      All flags already preset to 0.
Cd
        IF( KSEC0(2).EQ.-1) THEN
Cd
Cd        In the Experimental Edition flag field was
Cd        0000 for grid point data.
Cd        0001 for spherical harmonic data.
Cd
          ITEMP = IFLAG / 16
          INIL  = IFLAG - ITEMP * 16
          IF( ITEMP.NE.0) KSEC4(3) = 128
          GO TO 710
        ENDIF
Cd
        IF( KSEC0(2).EQ.0) THEN
Cd
Cd        In Edition 0 flag field only 2 first bits had significance.
Cd
Cd        0- for grid point data.
Cd        1- for spherical harmonic data.
Cd        -0 for simple packing.
Cd        -1 for complex packing (only supported for spectral data).
Cd
          IF( IFLAG.GE.128) THEN
            KSEC4(3) = 128
            IFLAG    = IFLAG - 128
          ENDIF
Cd
          IF( IFLAG.GE.64) THEN
            KSEC4(4) = 64
            IFLAG    = IFLAG - 64
          ENDIF
Cd
          INIL  = IFLAG
        ELSEIF( KSEC0(2).EQ.1) THEN
Cd
Cd        In Edition 1 flag field all 4 bits have significance.
Cd
Cd        0--- for grid point data.
Cd        1--- for spherical harmonic data.
Cd        -0-- for simple packing.
Cd        -1-- for complex or second order packing.
Cd        --0- for floating point values.
Cd        --1- for integer values.
Cd        ---0 for no additional flags at Octet 14.
Cd        ---1 for additional flags at Octet 14.
Cd
          IF( IFLAG.GE.128) THEN
            KSEC4(3) = 128
            IFLAG    = IFLAG - 128
          ENDIF
Cd
          IF( IFLAG.GE.64) THEN
            KSEC4(4) = 64
            IFLAG    = IFLAG - 64
          ENDIF
Cd
          IF( IFLAG.GE.32) THEN
            KSEC4(5) = 32
            IFLAG    = IFLAG - 32
          ENDIF
Cd
          IF( IFLAG.GE.16) THEN
            KSEC4(6) = 16
            IFLAG    = IFLAG - 16
          ENDIF
Cd
          INIL  = IFLAG
        ENDIF
Cd
  710   CONTINUE
Cd
Cd      Type of data (spherical harmonic coefficients or grid
Cd      point) is taken from KSEC4(3) only if no Section 2 is
Cd      included.(This allows for data coded without Section 2).
Cd
        IF( .NOT.LSECT2 ) THEN
          LSPHERC = ( KSEC4(3) .EQ. 128 )
          LGRDPT  = .NOT.LSPHERC
        ELSEIF( LSPHERC ) THEN
          KSEC4(3) = 128
        ELSE
          KSEC4(3) = 0
        ENDIF
Cd
Cd      Print number of unused bits, if required.
Cd
        IF( LPDEBUG ) WRITE(GRPRSM,*)
     X    'GRIBEX: Number of unused bits is ',INIL,'.'
Cd
      ENDIF
C
C*    Complex packing supported for spherical harmonics.
      LCOMPLX = (LSPHERC .AND. ( KSEC4(4).EQ.64 ) ) .OR.
     X          (LSPHERC .AND. LSECT2 .AND. ( KSEC2(6).EQ.2 ) )
C
C     Check input specification is consistent
      IF( LCOMPLX .AND. LSECT2 ) THEN
        IF( ( KSEC4(4).NE.64 ) .AND. ( KSEC2(6).EQ.2 )  ) THEN
           WRITE(GRPRSM,*) ' COMPLEX mismatch. KSEC4(4) = ', KSEC4(4)
           WRITE(GRPRSM,*) ' COMPLEX mismatch. KSEC2(6) = ', KSEC2(6)
           KRET = 807
           GOTO 900
        ELSEIF( ( KSEC4(4).EQ.64 ) .AND. ( KSEC2(6).NE.2 )  ) THEN

           WRITE(GRPRSM,*) ' COMPLEX mismatch. KSEC4(4) = ', KSEC4(4)
           WRITE(GRPRSM,*) ' COMPLEX mismatch. KSEC2(6) = ', KSEC2(6)
           KRET = 807
           GOTO 900
        ENDIF
      ELSEIF( LCOMPLX ) THEN
C
C         Truncation of full spectrum, which is supposed triangular,
C         has to be diagnosed. Define also sub-set truncation.
C
        IF (LENCODE) THEN
Ce
          ISUBSET = KSEC4(18)
Ce
Ce        When encoding, use the total number of data.
Ce
          ITEMP = KSEC4(1)
          ITRUNC= ( NINT ( SQRT ( REAL ( 4 * ITEMP + 1 ) ) ) - 3 ) / 2
Ce
        ELSE
Cd
Cd        When decoding, use section 4 descriptors.
Cd
          INSPT=INSPT+6*8
          CALL INXBIT(KGRIB,KLENG,INSPT,KSEC4(2),1,IBITS, 8,YFUNC,KRET)
          IF( KRET.NE.0) THEN
          KRET = 709
          WRITE(GRPRSM,*) 'GRIBEX: Error inserting/extracting number of'
          WRITE(GRPRSM,*) 'GRIBEX: bits per data value'
          WRITE(GRPRSM,*) 'GRIBEX: Return code = ', KRET
            GO TO 900
          ENDIF
Cd
          CALL INXBIT(KGRIB,KLENG,INSPT,ITEMP,1,IBITS,16,YFUNC,KRET)
          IF( KRET.NE.0) THEN
            KRET = 796
            WRITE(GRPRSM,*)
     X 'GRIBEX: Error extracting pointer to packed data.'
            WRITE(GRPRSM,*) 'GRIBEX: Return code = ', KRET
            GO TO 900
          ENDIF
Cd
          INSPT=INSPT+16
          CALL INXBIT(KGRIB,KLENG,INSPT,ISUBSET,1,IBITS, 8,YFUNC,KRET)
          IF( KRET.NE.0) THEN
            KRET = 797
            WRITE(GRPRSM,*)
     X 'GRIBEX: Error extracting sub-set truncation.'
            WRITE(GRPRSM,*) 'GRIBEX: Return code = ', KRET
            GO TO 900
          ENDIF
Cd
          IF (KSEC0(2).GE.1) THEN
            ITEMP = ILEN4 * 8 - INIL + (ITEMP-IPLEN/8) * 8
            ITEMP = ( ITEMP - 32 * ( ISUBSET + 1 ) * (ISUBSET + 2 ) )
     X               / KSEC4(2)
            ITRUNC= ( NINT ( SQRT ( REAL ( 4 * ITEMP + 1 ) ) ) - 3 ) / 2
          ELSE
            ITEMP = ILEN4 * 8 - INIL + (ITEMP-1) * 8
            ITEMP = ( ITEMP - 32 * ( ISUBSET + 1 ) ** 2 ) / KSEC4(2)
            ITRUNC= NINT ( SQRT ( REAL ( ITEMP ) ) ) - 1
          ENDIF
Cd
        ENDIF
C
        IF( LPDEBUG) WRITE(GRPRSM,*)
     X    'GRIBEX: diagnosed truncation of full spectrum is ', ITRUNC
C
      ELSE
        ISUBSET = 0
      ENDIF
C
C *******************************************
C
C     Handle complex packing of section 4.
C     (Avoid decoding of section 4 if 'I' or 'J' option)
C
      IF( LCOMPLX.AND.(.NOT.L_IORJ) ) THEN
C
C       Adjust bit pointer to start of section
        INSPT = IPLEN
C
        IF( LENCODE) THEN
C
C         Encoding ...
          KRET = CSECT4( PSEC4, ITRUNC, KSEC1, KSEC4,
     X                   KGRIB, KLENG, INSPT, IBITS, KSEC4(2))
        ELSE
C
C         Decoding ...
          KRET = DSECT4A( PSEC4, ITRUNC, KSEC0, KSEC1, KSEC4,
     X                   KGRIB, KLENG, INSPT, IBITS, KSEC4(2))
C
C         Special case when no.bits per packed value = no.bits per word
          IF( KRET .EQ. 16123 ) KRET = 205
        ENDIF
C
C       Give up if error reported.
        IF( KRET .NE. 0 ) GOTO 900
C
C       Got to deal with section 5 if OK.
        GOTO 799
      ENDIF
C
C *******************************************
C
C     Complex packing ("Second order packing") for grid point.
C
      IF( LGRDPT .AND. (KSEC4(4).NE.0.OR.HOPER.EQ.'K') ) THEN
C
        IF( LENCODE .AND. KSEC4(6).EQ.0 ) THEN
          KRET = 703
          WRITE(GRPRSM,*)
     X      'GRIBEX: Second-order packing implies additional flags'
          WRITE(GRPRSM,*) 'GRIBEX: Return code = ', KRET
          GO TO 900
        ELSEIF( HOPER.EQ.'G'.OR.HOPER.EQ.'A'.OR.HOPER.EQ.'B' ) THEN
          KRET = 704
          WRITE(GRPRSM,*) 'GRIBEX: Function ',HOPER,' invalid for'
          WRITE(GRPRSM,*)
     X  'GRIBEX: second-order packed field (grid-point).'
          WRITE(GRPRSM,*) 'GRIBEX: Return code = ', KRET
          GO TO 900
C
        ELSEIF( LDECODE ) THEN
Cd
Cd        Decoding ...
Cd
          INSPT=IPLEN
          KRET = D2ORDR( PSEC4, KLENP, KSEC1, KSEC2, KSEC3, KSEC4,
     X                   KGRIB, KLENG, INSPT, IBITS, HOPER, ILEN4,
     X                   INIL,  ZREF, ZSCALE, IBMAP, IVALS, NDBG )
Cd
Cd        Give up if error reported.
          IF( KRET .NE. 0 ) GOTO 900
Cd
Cd        At this stage, PSEC4 contains normalized INTEGER values.
Cd
          IFPT=0
          ILEN=KSEC4(1)
Cd
          IF( L_IORJ ) THEN
            KSEC4(34)=INSPT
Cd
Cjdc        IF( HOPER.EQ.'J' ) GOTO 815
            GOTO 900
          ELSE
            GOTO 796
          ENDIF
C
        ENDIF
C
C       Encoding is performed later, once the normalization of
C       field values into normalized integer values is performed.
C
      ENDIF
C
C*    Set IFPT to the number of data values stored in floating point
C     rather than packed format.
C     For simple packing of data in spherical harmonic
C     format the first word contains the real (0,0) coefficient,
C     which is treated separately. IFPT is 1 for spherical
C     harmonics, 0 for other data.
C
      IF( LGRDPT ) THEN
        IFPT = 0
      ELSE
        IFPT = 1
      ENDIF
C
C*    Octets 5 - 6 : Scale factor.
C     One 16 bit field.
C
C     Calculate scale factor, if coding data.
C
      IF( LENCODE ) THEN
Ce
Ce      Change units of data values , if required.
Ce
        IF( KSEC1(23).NE.0) THEN
          DO 720 JLOOP = 1 , ILENF
            PSEC4(JLOOP) = PSEC4(JLOOP)*(10.0**KSEC1(23))
  720     CONTINUE
        ENDIF
Ce
Ce      Find maximum and minimum values in data array, ignoring
Ce      any missing-data values, if secondary bit-maps are
Ce      indicated. Values not being packed are skipped.
Ce
        ILEN = ILENF - IFPT
Ce
        IF( KSEC4(8).EQ.64.AND.KSEC4(9).EQ.32) THEN
Ce
Ce        Secondary bit maps present.
Ce
          CALL MAXMN2 (PSEC4(IFPT+1),ILEN,ZMSVAL,ZMAX,ZMIN)
Ce
        ELSE
Ce
Ce        No secondary bit maps present.
Ce
          IF( HOPER.NE.'A' ) CALL MAXMIN(PSEC4(IFPT+1),ILEN,ZMAX,ZMIN)
Ce
        ENDIF
Ce
        IF( LPDEBUG ) THEN
          WRITE(GRPRSM,*) 'GRIBEX: Maximum value calculated = ', ZMAX
          WRITE(GRPRSM,*) 'GRIBEX: Minimum value calculated = ', ZMIN
        ENDIF
Ce
Ce      Calculate and pack scale factor.
Ce
Ce      If user has supplied a reference value, use it.
        IF( NFREF.EQ.1) THEN
          ZREF = FREF
Ce
Ce        If integer data being packed, ensure that
Ce        reference value represents an integer.
          IF(  KSEC4(5) .EQ. 32 ) THEN
#ifdef VAX
            ITEMP = JNINT(ZREF)
#else
            ITEMP = NINT(ZREF)
#endif
            ZREF  = REAL(ITEMP)
          ENDIF
Ce
Ce        Use user-supplied value unless it exceeds the minimum value.
Ce        Otherwise use the minimum value.
Ce
          IF( ZREF.GT.ZMIN) THEN
            WRITE(GRPRSM,*)
     X  'GRIBEX: User supplied reference value ',ZREF
            WRITE(GRPRSM,*) 'GRIBEX: exceeds minimum value ',ZMIN
            WRITE(GRPRSM,*) 'GRIBEX: Minimum value used instead.'
            ZREF = ZMIN
          ENDIF
Ce
        ELSE
          ZREF = ZMIN
        ENDIF
Ce
Ce      If user has supplied a maximum value, use it.
Ce
        IF( NFMAX.EQ.1) THEN
          ZMAXV = FMAX
Ce
Ce        If integer data being packed, ensure that
Ce        maximum value represents an integer.
          IF(  KSEC4(5) .EQ. 32 ) THEN
#ifdef VAX
            ITEMP = JNINT(ZMAXV)
#else
            ITEMP = NINT(ZMAXV)
#endif
            ZMAXV  = REAL(ITEMP)
          ENDIF
Ce
Ce        Use user-supplied value unless it is less than the maximum
Ce        value. Otherwise use the maximum value.
Ce
          IF( ZMAXV.LT.ZMAX) THEN
            WRITE(GRPRSM,*)
     X  'GRIBEX: User supplied maximum value ',ZMAXV
            WRITE(GRPRSM,*) 'GRIBEX: is less than maximum value ',ZMAX
            WRITE(GRPRSM,*) 'GRIBEX: Maximum value used instead.'
            ZMAXV = ZMAX
          ENDIF
Ce
        ELSE
          ZMAXV = ZMAX
        ENDIF
Ce
        IF( LPDEBUG ) THEN
          WRITE(GRPRSM,*) 'GRIBEX: Maximum value used = ', ZMAXV
          WRITE(GRPRSM,*) 'GRIBEX: Minimum value used = ', ZREF
        ENDIF
Ce
        IF( (HOPER .EQ. 'A') .OR. (HOPER .EQ. 'B') ) THEN
          ZREF = 0.0
          ZS = 0.0
          ISCALE = 0
          ZSCALE = 1.0
        ELSE
Ce
Ce        Before using reference value, convert floating point to GRIB
Ce        representation and come back with (possibly) adjusted value.
Ce
          ISTATUS = REF2GRB(ZREF, IEXP, IMANT, IBITS)
          IF( ISTATUS.NE.0 ) THEN
            WRITE(GRPRSM,*) 'GRIBEX: REF2GRB reference value problem'
            WRITE(GRPRSM,*) 'GRIBEX: for parameter ', KSEC1(6)
            WRITE(GRPRSM,*) 'GRIBEX: level type ', KSEC1(7)
            WRITE(GRPRSM,*) 'GRIBEX: level ', KSEC1(8), KSEC1(9)
          ENDIF

Ce
Ce        If KSEC4(2) is less than (IBITS-1), then IS is taken as the
Ce        largest integer that enables the following formula :
Ce
Ce        0 <= (ZMAXV-ZREF) / (2**IS) < 2**KSEC4(2)-0.5
Ce
Ce        (NINT of the ratio above is a positive integer that fits in
Ce         KSEC4(2) bits) ; this is equivalent to
Ce
Ce        2**(IS-1) <= (ZMAXV-ZREF) / (2**KSEC4(2)-0.5) < 2**IS
Ce        or :
Ce        2**IS     <= (ZMAXV-ZREF) / (2**(KSEC4(2)+1)-1) < 2**(IS+1)
Ce
Ce        Otherwise, the 0.5 is replaced by 1. to avoid any problem
Ce        with the numerical representation of a signed integer .
Ce
Cjdc      IF( LALLPOS) THEN
Cjdc        ZAUXIL = 1.
Cjdc        ZS = (ZMAXV-ZREF) / (2.**REAL(KSEC4(2))-1.)
Cjdc      ELSEIF( KSEC4(2).EQ.(IBITS-1) ) THEN
Cjdc        ZAUXIL = 1.
Cjdc        ZS = (ZMAXV-ZREF) / REAL(2**KSEC4(2)-1)
Cjdc      ELSE
Cjdc        ZAUXIL = 2.
Cjdc        ZS = (ZMAXV-ZREF) / REAL(2**(KSEC4(2)+1)-1)
Cjdc      ENDIF
Ce
#ifdef CRAY
Cjdc      IF( ZS.NE.0.0) ZS = ALOG(ZS) / ALOG(2.) + ZAUXIL
#else
Cjdc      IF( ZS.NE.0.0) ZS = LOG(ZS) / LOG(2.) + ZAUXIL
#endif
Cjdc      ISCALE = MIN (INT(ZS),INT(ZS+SIGN(1.,ZS)))
Cjdc
C
C         Adjust number of bits per value if full integer length to
C         avoid hitting most significant bit (sign bit).
C
          NBPV  = KSEC4(2)
          IF( NBPV.EQ.IBITS ) NBPV = NBPV - 1

C
C        Adjust the minumum value to be the scale factor in case the
C        scale factor coded cannot represent the minimun value (loss of precision)
C        This should be done before computing the range of the scale factor, as the
C        unpacking will be done
C        Using the reference value coded


          IF(ZMIN.NE.ZREF) THEN
            IF( LPDEBUG ) THEN
                 WRITE(GRPRSM,*)
     X  'GRIBEX: Minimum value rectified from ', ZMIN, ' to ', ZREF,
     X  'to match reference value precision'
            ENDIF
          ENDIF

C
C         Calculate the binary scaling factor to spread the range of
C         values over the number of bits per value.
C         Limit scaling to 2**-126 to 2**127 (using IEEE 32-bit floats
C         as a guideline).
C
          ZS = 1.0
          RANGE = (ZMAX-ZREF)

          IF( ABS(ZMAX-ZMIN).LT.JPEPSLN ) THEN
            ISCALE = 0
          ELSE IF( ABS(RANGE-1.0).LT.JPEPSLN ) THEN
            ISCALE = 1 - NBPV
          ELSE IF( RANGE.GT.1.0 ) THEN
            DO JLOOP = 1, 127
              ZS = 2.0 * ZS
              IF( ZS.GT.(RANGE+JPEPSLN) ) THEN
                ISCALE = JLOOP - NBPV
                GOTO 727
              ENDIF
            ENDDO
            WRITE(GRPRSM,*)
C
     X       'GRIBEX: Problem calculating binary scale value for encode'
            KRET = 707
            GOTO 900
C
  727       CONTINUE
          ELSE
            DO JLOOP = 1, 126
              ZS = ZS / 2.0
              IF( ZS.LT.(RANGE-JPEPSLN) ) THEN
                ISCALE = 1 - JLOOP - NBPV
                GOTO 728
              ENDIF
            ENDDO
C
            WRITE(GRPRSM,*)
     X       'GRIBEX: Problem calculating binary scale value for encode'
            KRET = 707
            GOTO 900
  728       CONTINUE
          ENDIF
C
#if (defined VAX) || (defined rs6000) || defined (__alpha) || defined hpR64
Cjdc      ISCALE = MIN (INT(ZS),INT(ZS+DSIGN(1.0D0,ZS)))
#else
Cjdc      ISCALE = MIN (INT(ZS),INT(ZS+SIGN(1.,ZS)))
#endif
Ce
Ce        Limit scale factor to head off problems of 'rogue' fields
Ce        which are flat except for one pimple value
Ce        (Is this still needed?)
Ce
          IF( ISCALE.LT.-99 ) THEN
            WRITE(GRPRSM,*)
     X  ' GRIBEX: scaling factor changed from ', ISCALE
            WRITE(GRPRSM,*)
     X  ' GRIBEX:                          to ', -99
            ISCALE = -99
          ENDIF
          IF( ISCALE.GT.99 ) THEN
            WRITE(GRPRSM,*)
     X  ' GRIBEX: scaling factor changed from ', ISCALE
            WRITE(GRPRSM,*)
     X  ' GRIBEX:                          to ',  99
            ISCALE =  99
          ENDIF
Ce
          ZSCALE = 2.**ISCALE
          IF( LPDEBUG ) THEN
            WRITE(GRPRSM,*) 'GRIBEX: Encoding ZMAX = ', ZMAX
            WRITE(GRPRSM,*) 'GRIBEX: Encoding ZREF = ', ZREF
            WRITE(GRPRSM,*) 'GRIBEX: Encoding RANGE = ', RANGE
            WRITE(GRPRSM,*)
     X  'GRIBEX: Encoding scaling value = ', ZSCALE
            WRITE(GRPRSM,*)
     X  'GRIBEX: Encoding scaling value = 2 to power ',
     X        ISCALE
          ENDIF
Ce
Ce        Set sign bit.
Ce
          ITEMP = ISCALE
          CALL CSGNBT( ISCALE, ITEMP, 16, KRET)
        ENDIF
Ce
Ce      Scale factor has all bits set to 1 for missing fields.
Ce      (ECMWF convention only).
Ce
        IF( IMISS.EQ.1) ISCALE = JP16SET
Ce
      ENDIF
C
C     Insert / extract field.
C
      CALL INXBIT(KGRIB,KLENG,INSPT,ISCALE,1,IBITS, 16,YFUNC,KRET)
      IF( KRET.NE.0) THEN
        KRET = 707
        WRITE(GRPRSM,*)
     X  'GRIBEX: Error inserting/extracting scale factor.'
        WRITE(GRPRSM,*) 'GRIBEX: Return code = ', KRET
        GO TO 900
      ENDIF
Cd
Cd    If decoding, set scale factor.
Cd
      IF( LDECODE ) THEN
        ISKALE = ISCALE
        CALL DSGNBT( ISCALE, ISKALE, 16, KRET)
Cd
Cd      Limit scale factor to head off problems of 'rogue' fields
Cd      which are flat except for one pimple value
        IF( ISCALE .LT. -99 ) THEN
          WRITE(GRPRSM,*)
     X  ' GRIBEX: scaling factor changed from ', ISCALE
          WRITE(GRPRSM,*)
     X  ' GRIBEX:                          to ', -99
          ISCALE = -99
        ENDIF
        IF( ISCALE .GT.  99 ) THEN
          WRITE(GRPRSM,*)
     X  ' GRIBEX: scaling factor changed from ', ISCALE
          WRITE(GRPRSM,*)
     X  ' GRIBEX:                          to ',  99
          ISCALE =  99
        ENDIF
Cd
        ZSCALE = 2.**ISCALE
C
        IF( LPDEBUG ) THEN
          WRITE(GRPRSM,*)
     X  'GRIBEX: Decoding scaling value = ', ZSCALE
          WRITE(GRPRSM,*)
     X  'GRIBEX: Decoding scaling value = 2 to power ',
     X      ISCALE
        ENDIF
      ENDIF
C
C*    Octets 7 - 10 : Reference value.
C     One 8 bit and one 24 bit field.
C
      IF( LENCODE ) THEN
Ce
        IF( IMISS.EQ.1) THEN
Ce
Ce        For missing, these data fields are set to all 1 bits.
          IEXP   = JP8SET
          IMANT  = JP24SET
        ENDIF
Ce
      ENDIF
C
C     Insert / extract fields.
C
      CALL INXBIT(KGRIB,KLENG,INSPT,IEXP,1,IBITS, 8,YFUNC,KRETA)
      CALL INXBIT(KGRIB,KLENG,INSPT,IMANT,1,IBITS, 24,YFUNC,KRETB)
      KRET = KRETA + KRETB
      IF( KRET.NE.0) THEN
        KRET = 708
        WRITE(GRPRSM,*)
     X  'GRIBEX: Error inserting/extracting reference value'
        WRITE(GRPRSM,*) 'GRIBEX: Return code = ', KRET
        GO TO 900
      ENDIF
C
C     Conversion from GRIB format, if decoding.
C
      IF( LDECODE ) THEN
Cd
Cd      Set IMISS to 1 if entire field is missing, i.e. scale
Cd      factor, exponent and mantissa with all bits set to 1.
Cd
        IMISS = 0
        IF( ISKALE.EQ.JP16SET.AND.IEXP.EQ.JP8SET.AND.IMANT.EQ.JP24SET)
     X    IMISS = 1
Cd
Cd      Convert GRIB representation to floating point.
Cd
        IF( IMISS.EQ.0) THEN
Cd
Cd        Field is present.
          CALL DECFP2 (ZREF,IEXP,IMANT)
        ELSE
Cd
Cd        Field is missing. Print warning message and
Cd        field identification sections of Grib code,
Cd        forcing field data values to 0.
Cd
          WRITE(GRPRSM,*)
     X  'GRIBEX: Following field is missing ***********'
          CALL GRPRS1 (KSEC0,KSEC1)
          ZREF   = 0
          ZSCALE = 0
        ENDIF
        IF( LPDEBUG ) WRITE(GRPRSM,*)
     X    'GRIBEX: Decoded reference value = ',ZREF
      ENDIF
Cd
C*    Octet 11 : Number of bits containing each packed value.
C     One 8 bit field.
C
C     Insert / extract field.
C
      IF( .NOT.LGRDPT.OR.KSEC4(4).EQ.0) THEN
        CALL INXBIT(KGRIB,KLENG,INSPT,KSEC4(2),1,IBITS, 8,YFUNC,KRET)
        IF( KRET.NE.0) THEN
          KRET = 709
          WRITE(GRPRSM,*)
     X  'GRIBEX: Error inserting/extracting number of'
          WRITE(GRPRSM,*) 'GRIBEX: bits per data value'
          WRITE(GRPRSM,*) 'GRIBEX: Return code = ', KRET
          GO TO 900
        ENDIF
C
      ELSE
C
C        In second-order packing case, this number may differ from
C        the value specified for normalization process (KSEC4(2)).
C        Field is inserted later, within function C2ORDR or related
C        C2* sub-functions.
C
        INSPT=INSPT+8
C
      ENDIF
C
      IF( LDECODE ) THEN
Cd
Cd      Check if number of bits per packed value = number of bits per
Cd      computer word.
Cd
        LALLPOS = KSEC4(2) .EQ. IBITS
Cd
      ENDIF
C
C*    Octets 12 et sequentia can contain further header
C     information, depending on data representation type.
C
C
C*    For grid point data, simple packing, single value at each
C     grid point there is no further header information and
C     packed data begins in octet 12.
C
C*    For grid point data, simple packing, with a matrix of
C     values at each grid point further information is added.
C
      IF( LGRDPT .AND.KSEC4(6).EQ.16.AND.KSEC4(4).EQ.0) THEN
C
C       Octets 12 - 13. N - octet number at which packed
C       data begins.
C       One 16 bit field.
C
C            !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
C            !                                                !
C            ! This is the WMO definition, but it is entirely !
C            ! inadequate when secondary bit maps are present !
C            ! eg 3x3 global grid with a matrix of values     !
C            ! 12x26 at each point. This gives a bit map with !
C            ! a length of 285480 octets which cannot be given!
C            ! in 16 bits.                                    !
C            !                                                !
C            ! ECMWF uses the following definition  for its   !
C            ! wave model data.                               !
C            ! N - Number of secondary bit maps               !
C            !     (ie the number of points which are 'not    !
C            !      missing').                                !
C            !     This definition will accommodate a 1x1     !
C            !     degree global grid.                        !
C            !                                                !
C            !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
C
        IF( LENCODE ) THEN
Ce
Ce        Octet number = 25 + NC1 + NC2
Ce
          IBYTEX = 25 + KSEC4(53) + KSEC4(55)
Ce
Ce        Add in length of bit-maps, if present.
Ce        Length in bits is the number of values
Ce        remaining to be packed rounded
Ce        up to a number of octets.
Ce
          IF( KSEC4(9).EQ.32) IBYTEX = IBYTEX + (ILENF+7) / 8
Ce
Ce        ECMWF wave model usage.
Ce        ECMWF is centre number 98, and local code table
Ce        2 used for wave models is 140.
Ce
          IF( LECLOC .AND.KSEC1(1).EQ.140) THEN
            IBYTEX = ILENF / (KSEC4(50) * KSEC4(51))
          ENDIF
        ENDIF
C
C       Insert / extract fields.
C
        CALL INXBIT(KGRIB,KLENG,INSPT,IBYTEX,1,IBITS, 16,YFUNC,KRET)
        IF( KRET.NE.0) THEN
          KRET = 720
          WRITE(GRPRSM,*)
     X  'GRIBEX: Error inserting/extracting octet number'
          WRITE(GRPRSM,*) 'GRIBEX: at which packed data begins'
          WRITE(GRPRSM,*) 'GRIBEX: Return code = ', KRET
          GO TO 900
        ENDIF
C
C       Special fix to handle overflow of this 16-bit field when
C       a large wave field is being decoded
C
        IF( LLARGE .AND. (IBYTEX.LT.2000) ) IBYTEX = IBYTEX + 65536
C
C       Octet 14. Extended flags.
C       One 8 bit field.
C
        IF( LENCODE ) IFLAGX = KSEC4(8) + KSEC4(9) + KSEC4(10)
C
C       Insert / extract fields.
C
        CALL INXBIT(KGRIB,KLENG,INSPT,IFLAGX,1,IBITS, 8,YFUNC,KRET)
        IF( KRET.NE.0) THEN
          KRET = 721
          WRITE(GRPRSM,*)
     X      'GRIBEX: Error inserting/extracting extended flag field'
          WRITE(GRPRSM,*) 'GRIBEX: Return code = ', KRET
          GO TO 900
        ENDIF
C
        IF( LDECODE ) THEN
Cd
Cd        In Edition 1 only 3 bits are used.
Cd
Cd        -0------ for single datum at each grid point.
Cd        -1------ for matrix of values at each point.
Cd        --0----- for no secondary bit-maps.
Cd        --1----- for secondary bit-maps present.
Cd        ---0---- for second order values constant width.
Cd        ---1---- for second order values different widths.
Cd
          IF( IFLAGX.GE.64) THEN
            KSEC4(8) = 64
            IFLAGX   = IFLAGX - 64
          ENDIF
Cd
          IF( IFLAGX.GE.32) THEN
            KSEC4(9) = 32
            IFLAGX   = IFLAGX - 32
          ENDIF
Cd
          IF( IFLAGX.GE.16) THEN
            KSEC4(10) = 16
            IFLAGX   = IFLAGX - 16
          ENDIF
        ENDIF
C
C       Octets 15 - 16. NR - first dimension (rows) of
C       each matrix.
C       Octets 17 - 18. NC - second dimension (columns) of
C       each matrix.
C       Two 16 bit fields.
C
C       Insert / extract fields.
C
        CALL INXBIT(KGRIB,KLENG,INSPT,KSEC4(50),2,IBITS, 16,YFUNC,KRET)
        IF( KRET.NE.0) THEN
          KRET = 722
          WRITE(GRPRSM,*) 'GRIBEX: Error inserting/extracting first or'
          WRITE(GRPRSM,*) 'GRIBEX: second dimension of matrix'
          WRITE(GRPRSM,*) 'GRIBEX: Return code = ', KRET
          GO TO 900
        ENDIF
C
C       Octet 19. First dimension coordinate values
C       definition.
C       Octet 20. NC1 - Number of coefficients or values
C       used to specify first dimension coordinate function.
C       Octet 21. Second dimension coordinate values
C       definition.
C       Octet 22. NC2 - Number of coefficients or values
C       used to specify second dimension coordinate function.
C       Octet 23. First dimension physical significance.
C       Octet 24. Second dimension physical significance.
C       Six 8 bit fields.
C
C       Insert / extract fields.
C
        CALL INXBIT(KGRIB,KLENG,INSPT,KSEC4(52),6,IBITS, 8,YFUNC,KRET)
        IF( KRET.NE.0) THEN
          KRET = 723
          WRITE(GRPRSM,*)
     X  'GRIBEX: Error inserting/extracting six fields'
          WRITE(GRPRSM,*)
     X  'GRIBEX: from 1st dimension coordinate value on'
          WRITE(GRPRSM,*) 'GRIBEX: Return code = ', KRET
          GO TO 900
        ENDIF
C
C       Octets 25 - (24+NC1).
C       Coefficients to define first dimension coordinate
C       values in functional form, or the explicit
C       coordinate values.
C       Octets (25+NC1) - (24+NC1+NC2).
C       Coefficients to define second dimension coordinate
C       values in functional form, or the explicit
C       coordinate values.
C       (NC1+NC2) 8 bit fields.
C
C            !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
C            !                                                !
C            ! This is the WMO definition, but it is very     !
C            ! limited and can only accommodate small integer !
C            ! fields values.                                 !
C            !                                                !
C            ! ECMWF needs to use floating point numbers and  !
C            ! for the wave models the definition is NC1+NC2  !
C            ! (8 bit and 24 bit) fields.
C            !                                                !
C            !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
C
        ITEMP = KSEC4(53) + KSEC4(55)
C
C       ECMWF wave model usage.
C       ECMWF is centre number 98, and local code table
C       2 used for wave models is 140.
C
        IF( LECLOC .AND.KSEC1(1).EQ.140) THEN
          ITRND = 1
          DO 730 JLOOP=1,ITEMP
C
C           One 8 bit and one 24 bit field.
C
            IF( LENCODE ) THEN
Ce
Ce            Convert floating point to GRIB representation.
              ISINT = KSEC4(JLOOP+59)
              ZREAL = ZREAL4
              CALL CONFP3 (ZREAL,IEXP,IMANT, IBITS,ITRND)
            ENDIF
C
C           Insert / extract fields.
C
            CALL INXBIT(KGRIB,KLENG,INSPT,IEXP,1,IBITS, 8,YFUNC,KRETA)
            CALL INXBIT(KGRIB,KLENG,INSPT,IMANT,1,IBITS,24,YFUNC,KRETB)
            KRET = KRETA + KRETB
            IF( KRET.NE.0) THEN
              KRET = 724
              WRITE(GRPRSM,*)
     X  'GRIBEX: Error inserting/extracting first or'
              WRITE(GRPRSM,*)
     X  'GRIBEX: second dimension coefficients'
              WRITE(GRPRSM,*) 'GRIBEX: Return code = ', KRET
              GO TO 900
            ENDIF
C
            IF( LDECODE ) THEN
Cd
Cd            Convert GRIB representation to floating point.
              CALL DECFP2 (ZREAL,IEXP,IMANT)
              ZREAL4 = ZREAL
              KSEC4(JLOOP+59) = ISINT
            ENDIF
C
  730     CONTINUE
        ELSE
C
C         Insert / extract fields.
C
          CALL INXBIT(KGRIB,KLENG,INSPT,KSEC4(57),ITEMP,
     X                 IBITS,8,YFUNC,KRET)
          IF( KRET.NE.0) THEN
            KRET = 724
            WRITE(GRPRSM,*)
     X  'GRIBEX: Error inserting/extracting first or'
            WRITE(GRPRSM,*) 'GRIBEX: second dimension coefficients'
            WRITE(GRPRSM,*) 'GRIBEX: Return code = ', KRET
            GO TO 900
          ENDIF
        ENDIF
C
C       Matrix bit-maps may follow.
C
        IF( KSEC4(9).EQ.32) THEN
          ITEMP = KSEC4(50) * KSEC4(51)
          IF( LENCODE ) THEN
            CALL INSMP2 (KGRIB,KLENG,INSPT,PSEC4,
     X                   ILENF,IBITS,ZMSVAL,YFUNC,
     X                   ITEMP,NDBG,KRET)
            IF( KRET.NE.0) THEN
              KRET = 725
              WRITE(GRPRSM,*)
     X  'GRIBEX: Error inserting secondary bit-map'
              WRITE(GRPRSM,*) 'GRIBEX: Return code = ', KRET
              GO TO 900
            ENDIF
            ILEN = ILENF
          ELSE
Cd
Cd          Retain pointer to bit-map location.
            IBMAP2 = INSPT
Cd
Cd          Set pointer to start of packed data.
Cd
            IF( LECLOC .AND.KSEC1(1).EQ.140) THEN
              ITEMP = KSEC4(50)*KSEC4(51)*IBYTEX
              ITEMP = (ITEMP+7) / 8
              INSPT = INSPT + ITEMP * 8
            ELSE
              INSPT = INSPT + (IBYTEX-25-KSEC4(53) -KSEC4(55)) * 8
            ENDIF
C
          ENDIF
        ENDIF
C
      ENDIF
C
C*    For spherical harmonic data (simple packing), real (0,0)
C     coefficient is in floating point representation in
C     octets 12-15.
C     One 8 bit and one 24 bit field.
C
      IF( LSPHERC ) THEN
C
C       Convert floating point to GRIB representation.
        ITRND = 1
        IF( LENCODE ) CALL CONFP3 (PSEC4(1),IEXP,IMANT,IBITS,ITRND)
C
C       Insert / extract fields.
C
        CALL INXBIT(KGRIB,KLENG,INSPT,IEXP,1,IBITS, 8,YFUNC,KRETA)
        CALL INXBIT(KGRIB,KLENG,INSPT,IMANT,1,IBITS, 24,YFUNC,KRETB)
        KRET = KRETA + KRETB
        IF( KRET.NE.0) THEN
          KRET = 711
          WRITE(GRPRSM,*)
     X      'GRIBEX: Error inserting/extracting real coefficient'
          WRITE(GRPRSM,*) 'GRIBEX: Return code = ', KRET
          GO TO 900
        ENDIF
C
        IF( LDECODE .AND. (.NOT. L_IORJ) ) THEN
Cd
Cd        Convert GRIB representation to floating point.
Cd
          IF( IMISS.EQ.1) THEN
            PSEC4(1) = 0.0
          ELSE
            CALL DECFP2 (PSEC4(1),IEXP,IMANT)
          ENDIF
        ENDIF
      ENDIF
C
C*    Octet N onwards - Packed data.
C
C     If decoding , calculate number of data values, unless
C     number has been given by user for 'X' function.
C
      IF( LDECODE ) THEN
        IF( HOPER.EQ.'X') THEN
          ILEN = KSEC4(34)
Cdx
Cdx     Otherwise, use the byte counts
        ELSEIF( KSEC4(2).NE.0) THEN
          ILEN = (IPLEN+(ILEN4*8)-INSPT-INIL)/KSEC4(2)
Cd
Cd      If explicitly constant field, use section 2 information
Cd
        ELSEIF( .NOT.LSECT2 ) THEN
          KRET = 726
          WRITE(GRPRSM,*)
     X  'GRIBEX: Constant (0-bit) field without section 2'
          WRITE(GRPRSM,*) 'GRIBEX: not supported'
          WRITE(GRPRSM,*) 'GRIBEX: Return code = ', KRET
          GO TO 900
        ELSEIF( LSPHERC ) THEN
          KRET = 727
          WRITE(GRPRSM,*) 'GRIBEX: Constant (0-bit) spectral field'
          WRITE(GRPRSM,*) 'GRIBEX: not supported'
          WRITE(GRPRSM,*) 'GRIBEX: Return code = ', KRET
          GO TO 900
        ELSEIF( HOPER.EQ.'G'.OR.HOPER.EQ.'B') THEN
          KRET = 728
          WRITE(GRPRSM,*)
     X      'GRIBEX: Constant (0-bit) field: function ',HOPER(:1)
          WRITE(GRPRSM,*) 'not supported'
          WRITE(GRPRSM,*) 'GRIBEX: Return code = ', KRET
          GO TO 900
        ELSEIF( LQUASI ) THEN
Cd
          IF( MOD(KSEC2(11),64).LT.32) THEN
            INROWS=KSEC2(3)
          ELSE
            INROWS=KSEC2(2)
          ENDIF
Cd
          ILEN=0
Cd
          DO 740 JLOOP = 1 , INROWS
            ILEN=ILEN+KSEC2(22+JLOOP)
  740     CONTINUE
Cd
        ELSE
          ILEN=KSEC2(2)*KSEC2(3)
        ENDIF
Cd
Cd      Total number of values = packed + unpacked.
Cd
        IF( HOPER .EQ. 'B' ) THEN
          KSEC4(1) = (ILEN+NBYTE-1)/NBYTE
          KSEC4(21) = ILEN
Cd
        ELSE
          KSEC4(1) = ILEN + IFPT
        ENDIF
Cd
Cd      Check length of output array.
Cd
        IF( (KSEC4(1).GT.KLENP) .AND.
     X       (HOPER.NE.'G')      .AND.
     X       (HOPER.NE.'J')    ) THEN
          KRET = 710
          WRITE(GRPRSM,*)
     X  'GRIBEX: Output array too small. Length = ',KLENP
          WRITE(GRPRSM,*) 'GRIBEX: Number of values = ', KSEC4(1)
          WRITE(GRPRSM,*) 'GRIBEX: Return code = ', KRET
          GO TO 900
        ENDIF
Cd
        IF( KSEC4(2).EQ.0) THEN
C
          IF( LPDEBUG ) WRITE(GRPRSM,*)
     X      'GRIBEX: Explicitly constant field (0-bit).'
C
C          Explicitly constant field, filled directly.
C
          IF( HOPER.NE.'J') THEN
C
            IF( KSEC1(23).EQ.0) THEN
              ZVAL = ZREF
            ELSE
              ZVAL = ZREF / 10.**KSEC1(23)
            ENDIF
C
            DO 750 JLOOP = 1 , ILEN
              PSEC4(IFPT+JLOOP) = ZVAL
  750       CONTINUE
C
          ENDIF
C
Cx        Option 'X', only a few points extracted.
Cx
          IF( HOPER.EQ.'X') THEN
Cx
Cx          Convert to integer if original data was integer.
Cx
            IF( KSEC4(5).EQ.32 ) CALL RORINT(PSEC4,PSEC4,KSEC4(1),'I')
            GO TO 900
Cx
          ENDIF
C
          GOTO 800
C
        ENDIF
C
      ENDIF
C
C
C*    Scale and store, or extract and scale data values.
C
C     Only a few points to be unpacked.
C
      IF( HOPER.EQ.'X') THEN
Cx
Cx      Check that a section 2 is present.
Cx
        IF( .NOT.LSECT2 ) THEN
          KRET = 798
          WRITE(GRPRSM,*)
     X  'GRIBEX: Function is X but no section 2 included'
          WRITE(GRPRSM,*) 'GRIBEX: Return code = ', KRET
          GO TO 900
        ENDIF
Cx
Cx      Check that no bit-map is included.
Cx
        IF( LSECT3 ) THEN
          KRET = 717
          WRITE(GRPRSM,*)
     X  'GRIBEX: Function is X and a bit-map is included'
          WRITE(GRPRSM,*) 'GRIBEX: Return code = ', KRET
          GO TO 900
        ENDIF
Cx
Cx      Check that field is Gaussian or latitude/longitude grid.
Cx
        IF( KSEC2(1).NE.0.AND.KSEC2(1).NE.4.AND.
     X      KSEC2(1).NE.10.AND.KSEC2(1).NE.14.AND.
     X      KSEC2(1).NE.20.AND.KSEC2(1).NE.24.AND.
     X      KSEC2(1).NE.30.AND.KSEC2(1).NE.34) THEN
          KRET = 716
          WRITE(GRPRSM,*) 'GRIBEX: Function is X and field is not'
          WRITE(GRPRSM,*)
     X  'GRIBEX: Gaussian or Latitude/longitude field'
          WRITE(GRPRSM,*) 'GRIBEX: Return code = ', KRET
          GO TO 900
        ENDIF
Cx
Cx      Check that scanning mode is West to East and North to South.
Cx
        IF( KSEC2(11).NE.0) THEN
          KRET = 715
          WRITE(GRPRSM,*)
     X  'GRIBEX: Function is X and scanning mode is not'
          WRITE(GRPRSM,*) 'GRIBEX: North to South and West to East'
          WRITE(GRPRSM,*) 'GRIBEX: Return code = ', KRET
          GO TO 900
        ENDIF
Cx
Cx      Check that number of points required does not exceed
Cx      maximum or minimum allowed.
Cx
        IF( KSEC4(34).GT.4.OR.KSEC4(34).LT.1) THEN
          KRET = 714
          WRITE(GRPRSM,*)
     X      'GRIBEX: Invalid no. of values for function X = ',KSEC4(34)
          WRITE(GRPRSM,*) 'GRIBEX: Return code = ', KRET
          GO TO 900
        ENDIF
Cx
        ITEMP = 1
Cx
Cx      Take into account decimal scaling factor, if any.
Cx
        IF( KSEC1(23).NE.0) THEN
          ZREF = ZREF / 10.**KSEC1(23)
          ZSCALE = ZSCALE / 10.**KSEC1(23)
        ENDIF
Cx
Cx      Skip down latitude rows.
        DO 770 JLOOPO = 1,KSEC4(34)
Cx
Cx        Regular grid.
          IF( .NOT. LQUASI) THEN
            ISKIP = (KSEC4(34+ITEMP)-1) * KSEC2(2)
Cx
Cx        Quasi-regular grid.
          ELSE
            ISKIP = 0
            DO 760 JLOOP = 1,KSEC4(34+ITEMP) - 1
              ISKIP = ISKIP + KSEC2(22+JLOOP)
  760       CONTINUE
          ENDIF
Cx
Cx        Skip any points not required on this latitude row.
          ISKIP = ISKIP + KSEC4(34+ITEMP+1) - 1
Cx
Cx        Calculate number of bits in these values and add
Cx        to current value of bit-pointer.
          ISKIP = ISKIP * KSEC4(2) + INSPT
Cx
Cx        Extract value from 1 point.
          CALL INXBIT(KGRIB,KLENG,ISKIP,IJDC,1,
     X                IBITS,KSEC4(2),YFUNC,KRET)
          IF( KRET.NE.0) THEN
            KRET = 712
            WRITE(GRPRSM,*) 'GRIBEX: Error extracting data values'
            WRITE(GRPRSM,*) 'GRIBEX: Return code = ', KRET
            GO TO 900
          ENDIF
          IJDCXX = IJDC
Cx
          IF( KSEC4(5).EQ.32 ) THEN
Cx
Cx          Integer values
Cx
#if (defined REAL_BIGGER_THAN_INTEGER)
            PSEC4(JLOOPO) = ZREF + DBLE(IJDCXX)*ZSCALE
#else
            PSEC4(JLOOPO) = ZREF + IJDCXX*ZSCALE
#endif
            IJDCXX = PSEC4(JLOOPO)
            PSEC4(JLOOPO) = RJDCXX
Cx
          ELSE
Cx
Cx          Real values
Cx
#if (defined REAL_BIGGER_THAN_INTEGER)
            PSEC4(JLOOPO) = ZREF + DBLE(IJDCXX)*ZSCALE
#else
            PSEC4(JLOOPO) = ZREF + IJDCXX*ZSCALE
#endif
          ENDIF
          ITEMP = ITEMP + 2
  770   CONTINUE
Cx
        GOTO 900
      ENDIF
C
C*******************************************************************
C     All data to be unpacked or packed.
C*******************************************************************
C
C     Scale the fields using the reference value and scaling factor
C
      IF( LENCODE .AND. (HOPER .NE. 'A')  )
     X  CALL INSCAL(PSEC4(IFPT+1),PSEC4(IFPT+1),ILEN,ZREF,ZSCALE,NBPV)
C
C     Insert / extract fields, unless special 'G' operation or
C     if 'J' option in effect.
C
      IF( LENCODE.AND.LGRDPT.AND.(KSEC4(4).NE.0.OR.HOPER.EQ.'K')) THEN
Ce
Ce*******************************************
Ce
Ce      Complex packing ("second-order packing") for grid-point.
Ce
        INSPT=INSPT-11*8
        KRET = C2ORDR( PSEC4, KLENP, KSEC1, KSEC2, KSEC3, KSEC4,
     X                 KGRIB, KLENG, INSPT, IBITS, HOPER, IBMAP,
     X                 IVALS, ZREF,  ZMAX,  ILEN,  NDBG )
Ce
Ce      Give up if error reported.
        IF( KRET .NE. 0 ) GOTO 900
Ce
C
      ELSEIF( (HOPER.NE.'G') .AND. (.NOT.L_IORJ) ) THEN
Cd
#ifdef REAL_BIGGER_THAN_INTEGER
        IF( LDECODE .AND. (HOPER.NE.'B') ) THEN
Cd
Cd        Split the values into groups of length 'JPNSEC4' (maximum)
Cd
          ILOOPS = 1+(ILEN-1)/JPNSEC4
          IINDEX = IFPT
Cd
          DO 785 JLOOPO = 1, ILOOPS
            ILNGTH = MIN(JPNSEC4,ILEN-(JLOOPO-1)*JPNSEC4)
            CALL INXBIT(KGRIB,KLENG,INSPT,NSEC4,ILNGTH,
     X                   IBITS,KSEC4(2),YFUNC,KRET)
            IF( KRET.NE.0) THEN
              KRET = 712
              WRITE(GRPRSM,*) 'GRIBEX: Error extracting data values'
              WRITE(GRPRSM,*) 'GRIBEX: Return code = ', KRET
              GO TO 900
            ENDIF
            DO 780 JLOOP = 1, ILNGTH
              PSEC4(IINDEX + JLOOP) = ZREF + NSEC4(JLOOP)*ZSCALE
  780       CONTINUE
            IINDEX = IINDEX + ILNGTH
  785     CONTINUE
Cd
Cd        Change units of data values, if required.
Cd
          IF( KSEC1(23).NE.0) THEN
            DO 790 JLOOP = 1 , KSEC4(1)
              PSEC4(JLOOP) = PSEC4(JLOOP)/10.0**KSEC1(23)
  790       CONTINUE
          ENDIF
          GOTO 799
        ENDIF
Cb
Cb      Handle data for option 'B'
Cb
        IF( HOPER.EQ.'B' ) THEN
Cb
          ILOOPS = 1+(ILEN/NBYTE-1)/JPNSEC4
          IINDEX = IFPT
Cb
          DO 794 JLOOPO = 1, ILOOPS
            ILNGTH = MIN(JPNSEC4,ILEN-(JLOOPO-1)*JPNSEC4)
            CALL INXBIT(KGRIB,KLENG,INSPT,NSEC4,ILNGTH,
     X                  IBITS,KSEC4(2),YFUNC,KRET)
            IF( KRET.NE.0) THEN
              KRET = 712
              WRITE(GRPRSM,*) 'GRIBEX: Error extracting data values'
              WRITE(GRPRSM,*) 'GRIBEX: Return code = ', KRET
              GO TO 900
            ENDIF
Cb
            DO 792 JLOOP = 1, ILNGTH
              PSEC4(IINDEX + JLOOP) = XSEC4(JLOOP)
  792       CONTINUE
Cb
            IINDEX = IINDEX + ILNGTH
  794     CONTINUE
Cb
          GOTO 799
Cb
        ENDIF
#endif
C
        IF( (HOPER.NE.'A') .AND. (HOPER.NE.'B') ) THEN
          CALL INXBIT( KGRIB,KLENG,INSPT,PSEC4(IFPT+1),ILEN,
     X                 IBITS,KSEC4(2),YFUNC,KRET)
        ELSE
          CALL INXBIT( KGRIB,KLENG,INSPT,PSEC4(IFPT+1),ILEN/NBYTE,
     X                 IBITS,IBITS,YFUNC,KRET)
        ENDIF
        IF( KRET.NE.0) THEN
          KRET = 712
          WRITE(GRPRSM,*)
     X  'GRIBEX: Error inserting/extracting data values'
          WRITE(GRPRSM,*) 'GRIBEX: Return code = ', KRET
          GO TO 900
        ENDIF
C
       ELSE
C
Cgj     Option 'G' or 'J' in effect.
Cgj
        KSEC4(34) = INSPT
C
        IF( .NOT. L_IORJ ) THEN
Cg
Cg        Option 'G' ...
Cg
Cg        Return reference value, binary scale factor and
Cg        bit pointer to start of packed data.
C
          PSEC4(1) = ZREF
          PSEC4(2) = ZSCALE
        ENDIF
Cj
        IF( HOPER.EQ.'J' ) GOTO 815
Cj
        GO TO 900
Cd
      ENDIF
C
  796 CONTINUE
C
      IF( LDECODE .AND. (HOPER .NE. 'B') ) THEN
Cd
       CALL EXSCAL(PSEC4(IFPT+1),PSEC4(IFPT+1),ILEN,ZREF,ZSCALE,LALLPOS)
Cd
Cd      Change units of data values, if required.
Cd
        IF( KSEC1(23).NE.0) THEN
          DO 798 JLOOP = 1 , KSEC4(1)
            PSEC4(JLOOP) = PSEC4(JLOOP)/10.0**KSEC1(23)
  798     CONTINUE
        ENDIF
Cd
      ENDIF
C
 799  CONTINUE
C
C*    Enter length of binary data section, ensuring that the
C     length is an even number of octets, padding with binary
C     zeroes as required.
C     One 24 bit field.
C
      IF( YFUNC.NE.'C') GO TO 800
Ce
Ce    Length of section 4, in bits.
Ce
      ILEN4 = INSPT - IPLEN
      IL    = ILEN4 / 16
      IL    = ILEN4 - ( IL * 16 )
      INIL  = 0
      IF( IL.NE.0) THEN
        INIL = 16 - IL
Ce
Ce      Insert padding zeroes at end of section 4
Ce
        ITEMP = 0
        CALL INXBIT(KGRIB,KLENG,INSPT,ITEMP,1,IBITS,INIL,YFUNC,KRET)
        IF( KRET.NE.0) THEN
          KRET = 734
          WRITE(GRPRSM,*)
     X      'GRIBEX: Error inserting padding zeroes at end of section 4'
          WRITE(GRPRSM,*) 'GRIBEX: Return code = ',KRET
          GO TO 900
        ENDIF
        ILEN4 = ILEN4 + INIL
      ENDIF
Ce
      ILEN4 = ILEN4 / 8
Ce
Ce    Because of the restriction on product lengths to 3 octets,
Ce    if a very large product, the section 4 length field holds
Ce    the number of bytes in the product after section 4 upto
Ce    the end of the padding bytes.
Ce    This is only feasible because the (default) rounding for
Ce    GRIB products is 120 bytes.
Ce    In this case, delay encoding the value until section 5 has
Ce    been encoded.
Ce
      IF( ILEN4.GE.JP23SET ) THEN
        LLARGE = .TRUE.
        IPLEN = IPLEN + 24
      ELSE
Ce
Ce      Insert field.
        CALL INXBIT(KGRIB,KLENG,IPLEN,ILEN4,1,IBITS, 24,YFUNC,KRET)
        IF( KRET.NE.0) THEN
          KRET = 701
          WRITE(GRPRSM,*) 'GRIBEX: Error inserting section 4 length'
          WRITE(GRPRSM,*) 'GRIBEX: Return code = ', KRET
                 GO TO 900
        ENDIF
      ENDIF
Ce
Ce    Enter flag / unused bits field.
Ce    One 8 bit field.
Ce    Two 4 bit fields.
Ce
      IFLAG = KSEC4(3) + KSEC4(4) + KSEC4(5) + KSEC4(6)
      IFLAG = IFLAG + INIL
Ce
Ce    Print number of unused bits, if required.
      IF( LPDEBUG ) WRITE(GRPRSM,*)
     X  'GRIBEX: Number of unused bits is ',INIL,'.'
Ce
Ce    Insert field.
      CALL INXBIT(KGRIB,KLENG,IPLEN,IFLAG,1,IBITS, 8,YFUNC,KRET)
      IF( KRET.NE.0) THEN
        KRET = 713
        WRITE(GRPRSM,*)
     X    'GRIBEX: Error inserting/extracting flag and unused bit field'
        WRITE(GRPRSM,*) 'GRIBEX: Return code = ', KRET
        GO TO 900
      ENDIF
C
C     -----------------------------------------------------------------|
C
C
C
C
C
C
C
C
C
C
C*    Section 8 . Code/decode End Section (Section 5) of GRIB code.
C     -----------------------------------------------------------------|
C
  800 CONTINUE
C
      IF( LPDEBUG ) WRITE(GRPRSM,*)
     X  'GRIBEX: Section 8. Handle End Section (Section 5)'
C
C*    Ascii 7 7 7 7 at end of coded data.
C     Four 8 bit fields.
C
      IF( LENCODE ) THEN
Ce
Ce      Insert field.
        IP7777 = INSPT
        CALL INXBIT(KGRIB,KLENG,INSPT,I7777(1),4,IBITS, 8,YFUNC,KRET)
        IF( KRET.NE.0) THEN
          KRET = 801
          WRITE(GRPRSM,*) 'GRIBEX: Error inserting 7777 group'
          WRITE(GRPRSM,*) 'GRIBEX: Return code = ',KRET
          GO TO 900
        ENDIF
Ce
Ce      Length of GRIB message.
        KSEC0(1) = INSPT / 8
        ITEMP = KSEC0(1)
Ce
Ce    Because of the restriction on product lengths to 3 octets, if
Ce    more than 24 bits is needed, rescale by a factor of -120 to give
Ce    a (smaller) negative count.  It is only possible because
Ce    the (default) rounding for GRIB products is 120 bytes.
Ce
        IF( ITEMP.GE.JP23SET ) THEN
          LLARGE = .TRUE.
        ELSE
Ce
Ce        When encoding, use most-significant bit as a sign bit.
Ce
          CALL CSGNBT( KSEC0(1), ITEMP, 24, KRET)
Ce
Ce        Insert field.
          ITEMP = 32
          CALL INXBIT(KGRIB,KLENG,ITEMP,KSEC0(1),1,IBITS, 24,YFUNC,KRET)
          IF( KRET.NE.0) THEN
            KRET = 802
            WRITE(GRPRSM,*)
     X  'GRIBEX: Error inserting length of GRIB message'
            WRITE(GRPRSM,*) 'GRIBEX: Return code = ', KRET
            GO TO 900
          ENDIF
        ENDIF
Ce
Cjdc  ELSE
      ENDIF
Cj
Cj      'J' option jumps here for possible bitmap adjustment
Cj      to number of values in field section 4.
Cj
  815 CONTINUE
C
      IF( LDECODE ) THEN
Cj
        IF( L_IORJ ) GOTO 816
Cj
Cd      Skip padding.
        INSPT = INSPT + INIL
Cd
        CALL INXBIT(KGRIB,KLENG,INSPT,IPARM(1),4,IBITS, 8,YFUNC,KRET)
        IF( KRET.NE.0) THEN
          KRET = 801
          WRITE(GRPRSM,*) 'GRIBEX: Error extracting 7777 group'
          WRITE(GRPRSM,*) 'GRIBEX: Return code = ',KRET
          GO TO 900
        ENDIF
Cd      Check that length is consistent with the number of the header file
Cd      this will not happen for very large grib products with the *120 nightmare fix
Cd      in this *120 case the KSEC0(1) is updated with the value of the pointer/8
        IF( LLARGE) THEN
        IF( KSEC0(1).NE.INSPT/8) THEN
           IF( LPDEBUG ) THEN
            WRITE(GRPRSM,*) 'GRIBEX: Large product found', KSEC0(1)
           ENDIF
           KSEC0(1) = INSPT/8
           IF( LPDEBUG ) THEN
            WRITE(GRPRSM,*) 'GRIBEX: KSEC0(1) updated to = ', KSEC0(1)
           ENDIF
          ENDIF
        ENDIF
Cd
Cd      Check that 7777 group is found where expected.
        ICOUNT = 0
        DO 810 JLOOP = 1 , 4
          IF( IPARM(JLOOP).NE.55) ICOUNT = ICOUNT + 1
  810   CONTINUE
        IF( ICOUNT.NE.0) THEN
          KRET = 805
          WRITE(GRPRSM,*)
     X  'GRIBEX: End of message 7777 group not found.'
          WRITE(GRPRSM,*) 'GRIBEX: Return code = ', KRET
          GO TO 900
        ENDIF
Cd
Cd      Final handling when bit-maps included.
Cd
  816   CONTINUE
Cd
        IF( LSECT3 ) THEN
Cd
Cd        Bit-map included in GRIB message.
          IF( KSEC3(1).EQ.0) THEN
Cd
            IF( KSEC4(8).EQ.0.OR.KSEC4(9).EQ.0) THEN
Cd
Cd            Single value at each point.
Cd
              ITEMP = 1
Cd
Cd          Pointer IBMAP2 is set negative if there
Cd          are no matrix bit-maps.
Cd
              IBMAP2 = -1
              ITEMP = 1
            ELSE
Cd
Cd            Matrix of values at a point.
Cd
              ITEMP = KSEC4(50) * KSEC4(51)
            ENDIF
Cd
            IF( .NOT.L_IORJ ) THEN
Cd
Cd            Check user array is big enough before using bitmap to
Cd            fill missing data values (not relevant for 'J' option)
Cd
              IF( KLENP .LT. (IVALS*ITEMP) ) THEN
                WRITE(GRPRSM,*)
     X  'GRIBEX: Output array is not big enough to'
                WRITE(GRPRSM,*)
     X  'GRIBEX: allow expansion using bitmaps'
                KRET = 729
                GOTO 900
              ENDIF
Cd
Cd            Expand using bitmaps
Cd
              CALL EXTMAP(KGRIB,KLENG,IBMAP,IBMAP2,KSEC4(1),PSEC4,IVALS,
     X                    IBITS,ISBMAP,ZMSVAL,ITEMP,NDBG,KRET,NONMISS)
              IF( KRET.NE.0) THEN
                KRET = 806
                WRITE(GRPRSM,*)
     X            'GRIBEX: Error extracting primary/secondary bit map.'
                WRITE(GRPRSM,*) 'GRIBEX: Return code = ', KRET
                GO TO 900
              ENDIF
              KSEC4(1) = IVALS*ITEMP
Cj
            ELSE IF( HOPER.EQ.'J' ) THEN
Cj
Cj            Cannot handle secondary bitmaps for 'J' option counting
Cj
              IF( IBMAP2.NE.-1 ) THEN
                WRITE(GRPRSM,*)
     X            'GRIBEX: Cannot handle 2ndary bitmaps for J option'
                KRET = 811
                GOTO 900
Cj
              ELSE
Cj
Cj              Count bits in primary bitmap only ('J' option)
Cj
                IS3BYTE = (IBMAP/8 - 6)
                NONMISS = ONEBITS(KGRIB,IS3BYTE)
                KSEC4(21) = NONMISS
                KSEC4(1)  = IVALS
              ENDIF
            ENDIF
Cd
          ELSE
#ifdef USE_NO_POINTERS
            WRITE(GRPRSM,*)
     X        'GRIBEX: predetermined bit-map reference not handled'
              KRET = 735
              GOTO 900
#else
Cd
Cd          Predetermined bit-map reference only.
Cd          (Secondary bitmaps not handled in this case).
Cd
            IBMAP2 = -1
Cd
Cd          Single value at each point.
Cd
            ITEMP = 1
Cd
Cd          Get the bitmask
Cd
            KRET = GBITMAP(KSEC3(1), IBTVALS, NONMISS, IBTPTR, NBYTE)
            IF( KRET.NE.0 ) THEN
              WRITE(GRPRSM,*) 'GRIBEX: Problem getting bitmap'
              GOTO 900
            ENDIF
Cd
Cd          Expand using bitmap
Cd
            IBMAP = 0
Cd
Cd          Set integer or real missing data value.
Cd
            IF( KSEC4(5) .EQ. 0 )  THEN
              ZMSVAL = PSEC3(2)
            ELSE
              ZMSVAL = REAL(KSEC3(2))
            ENDIF
            CALL EXTMAP(IBTMAP, KLENG, IBMAP, IBMAP2, KSEC4(1), PSEC4,
     X                  IBTVALS,IBITS, ISBMAP,ZMSVAL, ITEMP, NDBG, KRET,
     X                  NONMISS)
            IF( KRET.NE.0) THEN
              KRET = 806
              WRITE(GRPRSM,*)
     X          'GRIBEX: Error extracting primary or secondary bit map.'
              WRITE(GRPRSM,*) 'GRIBEX: Return code = ', KRET
              GO TO 900
            ENDIF
            KSEC4(1) = IBTVALS*ITEMP
Cd
#endif
          ENDIF
        ENDIF
Cd
#ifndef USE_NO_POINTERS
Cd
Cd      If required, convert quasi-regular grid to regular.
Cd
        IF( HOPER.EQ.'R'.AND.LQUASI) THEN
Cr
Cr        Quasi-regular gaussian ..
Cr
          IF( (KSEC2(1).EQ. 4).OR.
     X        (KSEC2(1).EQ.14).OR.
     X        (KSEC2(1).EQ.24).OR.
     X        (KSEC2(1).EQ.34) ) THEN
Cr
Cr          Gaussian grid must be global
Cr
            INOLAT = KSEC2(10) * 2
Cr
            IF( KSEC2(3).NE.INOLAT ) THEN
              KRET = 808
              WRITE(GRPRSM,*)
     X          'GRIBEX: Error converting quasi-regular gaussian grid'
              WRITE(GRPRSM,*) 'GRIBEX: to regular. Grid must be global.'
              WRITE(GRPRSM,*) 'GRIBEX: Return code = ',KRET
              GO TO 900
            ENDIF
Cr
            INOLNG    = INOLAT * 2
            KSEC2(9)  = NINT(360000.0/REAL(INOLNG))
            LPERIO = .TRUE.
C
C           Some ECMWF 'vegetation' parameters have to be interpolated
C           using 'nearest neighbour' processing
C
            NITABLE  = KSEC1(1)
            NICENTRE = KSEC1(2)
            NIPARAM  = KSEC1(6)
            LVEGGY = (NITABLE.EQ.128).AND.
     X               (NICENTRE.EQ.98).AND.
     X               ((NIPARAM.EQ.27).OR.
     X                (NIPARAM.EQ.28).OR.
     X                (NIPARAM.EQ.29).OR.
     X                (NIPARAM.EQ.30))
            IF( LPDEBUG ) THEN
              IF( LVEGGY ) WRITE(GRPRSM,*)
     X          'GRIBEX: Nearest neighbour processing used for R option'
            ENDIF
            CALL QU2REG3(PSEC4,KSEC2(23),INOLAT,INOLNG,1,ZMSVAL,KRET,
     X                   LSECT3,LPERIO,LVEGGY)
            IF( KRET .NE. 0 ) THEN
              KRET = 808
              WRITE(GRPRSM,*)
     X          'GRIBEX: Error converting quasi-regular gaussian grid'
              WRITE(GRPRSM,*)
     X          'GRIBEX: to regular. Return code = ',KRET
              GO TO 900
            ENDIF
Cr
Cr        Quasi-regular latitude-longitude ..
Cr
          ELSE IF( (KSEC2(1).EQ. 0).OR.
     X             (KSEC2(1).EQ.10).OR.
     X             (KSEC2(1).EQ.20).OR.
     X             (KSEC2(1).EQ.30) ) THEN
            INOLAT    = IABS(KSEC2(4) - KSEC2(7))
            IEAST   = KSEC2(5)
Cr
Cr          Special case: symmetrical about equator, no equator
Cr          Have to calculate extreme longitude
Cr          (Fixup for reduced lat/long grids reporting last point
Cr          correctly)
Cr
            IF((MOD(KSEC2(3),2).EQ.0).AND.(KSEC2(4).EQ.(-KSEC2(7))))THEN
              N = KSEC2(3)/2
              NP = KSEC2(22+N)
              NINC = 360000/NP
              KSEC2(8) = IEAST + NINC*(NP-1)
              KSEC2(9) = NINC
            ENDIF
            IWEST   = KSEC2(8)
            IF( IWEST .LT. IEAST ) IWEST = IWEST + 360000
            INOLNG    = IABS(IWEST - IEAST)
Cr
Cr          Allow for missing Di or Dj increment.
Cr
            IF( KSEC2(9) .EQ. IMISNG ) THEN
              INOLAT    = 1 + INOLAT/ KSEC2(10)
              INOLNG    = 1 + INOLNG/ KSEC2(10)
              KSEC2(9)  = KSEC2(10)
            ELSE
              INOLAT    = 1 + INOLAT/ KSEC2(9)
              INOLNG    = 1 + INOLNG/ KSEC2(9)
              KSEC2(10) = KSEC2(9)
            ENDIF
Cr
Cr          Check if input domain is periodic.
Cr
            ILOEXT = KSEC2(8)+(1-2*(KSEC2(11)/128))*KSEC2(9)
            LPERIO = MOD( IABS(ILOEXT-KSEC2(5) ), 360000) .EQ. 0
            CALL QU2REG3(PSEC4,KSEC2(23),INOLAT,INOLNG,1,ZMSVAL,KRET,
     X                   LSECT3,LPERIO,LVEGGY)
            IF( KRET .NE. 0 ) THEN
              KRET = 808
              WRITE(GRPRSM,*)
     X          'GRIBEX: Error converting quasi-regular gaussian grid'
              WRITE(GRPRSM,*)
     X          'GRIBEX: to regular. Return code = ',KRET
              GO TO 900
            ENDIF
Cr
          ENDIF
Cr
          KSEC4(1)  = INOLAT * INOLNG
          KSEC2(2)  = INOLNG
          KSEC2(3)  = INOLAT
          KSEC2(6)  = 128
          KSEC2(17) = 0
          LQUASI = .FALSE.
        ENDIF
#endif
Cj
        IF( HOPER.EQ.'J' ) GOTO 900
Cj
Cd
Cd      Convert to integer if original data was integer.
Cd
        IF( ( KSEC4(5) .EQ. 32 ) .AND. (HOPER.NE.'B') )
     X    CALL RORINT(PSEC4,PSEC4,KSEC4(1),'I')
Cd
Cd      Set number of values decoded negative, if missing data.
Cd
        IF( IMISS.EQ.1) KSEC4(1) = - KSEC4(1)
Cd
Cd      If GRIB Edition number is -1 or 0, set GRIB message
Cd      length for return to user.
Cd
        IF( KSEC0(2).EQ.-1.OR.KSEC0(2).EQ.0) KSEC0(1) = INSPT / 8
Cd
        GO TO 900
Cd
      ENDIF
C
C*    Set unused part of last word to binary zeroes.
C
      KWORD    = INSPT / IBITS
      ITEMP    = KWORD * IBITS
      IOFF     = INSPT - ITEMP
      IF( IOFF.NE.0) THEN
        CALL INXBIT(KGRIB,KLENG,INSPT,0,1,IBITS,(IBITS-IOFF),YFUNC,KRET)
        IF( KRET.NE.0) THEN
          KRET = 809
          WRITE(GRPRSM,*)
     X  'GRIBEX: Error padding unused part of GRIB to zero'
          WRITE(GRPRSM,*) 'GRIBEX: Return code = ', KRET
          GO TO 900
        ENDIF
        KWORD = KWORD + 1
      ENDIF
C
C*    Round length to a multiple of 120 octets, if required,
C     Set any additional words to 0.
C
      IF( (NRND.EQ.1).OR.LLARGE ) THEN
        I = INSPT / 960
        I = I * 960
        I = INSPT - I
        IF( I.NE.0) THEN
          I = (960 - I)
          ITEMP = MOD(I,8)
          CALL INXBIT(KGRIB,KLENG,INSPT,0,1,IBITS,ITEMP,YFUNC,KRET)
          IF( KRET.NE.0) THEN
            KRET = 810
            WRITE(GRPRSM,*)
     X  'GRIBEX: Error padding GRIB to multiple of 120'
            WRITE(GRPRSM,*) 'GRIBEX: Return code = ', KRET
            GO TO 900
          ENDIF
          ITEMP = I/8
          DO 820 JLOOP = 1, ITEMP
            CALL INXBIT(KGRIB,KLENG,INSPT,0,1,IBITS,8,YFUNC,KRET)
            IF( KRET.NE.0) THEN
              KRET = 810
              WRITE(GRPRSM,*)
     X  'GRIBEX: Error padding GRIB to multiple of 120'
              WRITE(GRPRSM,*) 'GRIBEX: Return code = ', KRET
              GO TO 900
            ENDIF
  820     CONTINUE
          I = I / IBITS
        ENDIF
        KWORD = KWORD + I
      ENDIF
Ce
      IF( LLARGE.AND.LENCODE ) THEN
Ce
Ce      Because of the restriction on product lengths to 3 octets, if
Ce      more than 24 bits is needed, rescale by a factor of -120 to give
Ce      a (smaller) negative count.  It is only possible because
Ce      the (default) rounding for GRIB products is 120 bytes.
Ce
        ITEMP = (KWORD*(IBITS/8)) / (-120)
Ce
Ce      When encoding, use most-significant bit as a sign bit.
Ce
        CALL CSGNBT( KSEC0(1), ITEMP, 24, KRET)
Ce
Ce      Insert product length field.
        ITEMP = 32
        CALL INXBIT(KGRIB,KLENG,ITEMP,KSEC0(1),1,IBITS, 24,YFUNC,KRET)
        IF( KRET.NE.0) THEN
          KRET = 802
          WRITE(GRPRSM,*)
     X  'GRIBEX: Error inserting length of GRIB message'
          WRITE(GRPRSM,*) 'GRIBEX: Return code = ', KRET
          GO TO 900
        ENDIF
Ce
Ce      If encoding a very large product, the section 4 length field
Ce      holds the number of bytes in the product after section 4 upto
Ce      the end of the padding bytes. In this case, the setting
Ce      of this field has been postponed upto this point.
Ce
        IPLEN = IPLEN - 32
        ILEN4 = KWORD*(IBITS/8) - (IP7777/8)
Ce
Ce      Insert section 4 length.
        CALL INXBIT(KGRIB,KLENG,IPLEN,ILEN4,1,IBITS, 24,YFUNC,KRET)
        IF( KRET.NE.0) THEN
          KRET = 802
          WRITE(GRPRSM,*)
     X  'GRIBEX: Error inserting length of GRIB section 4'
          WRITE(GRPRSM,*) 'GRIBEX: Return code = ', KRET
          GO TO 900
        ENDIF
      ENDIF
C
C     -----------------------------------------------------------------|
C
C
C
C
C
C
C
C
C
C
C*    Section 9 . Abort/return to calling routine.
C     -----------------------------------------------------------------|
C
  900 CONTINUE
C
      IF( LPDEBUG ) THEN
        WRITE(GRPRSM,*) 'GRIBEX: Section 9.'
        WRITE(GRPRSM,*) 'GRIBEX: Output values set -'
        IF( LDECODE ) THEN
          CALL GRPRS0(KSEC0)
          CALL GRPRS1(KSEC0,KSEC1)
Cd
Cd        Print section 2 if present.
Cd
          IF( LSECT2 ) CALL GRPRS2(KSEC0,KSEC2,PSEC2)
Cd
Cd        Print section 3 if present.
Cd
          IF( LSECT3 ) CALL GRPRS3(KSEC0,KSEC3,PSEC3)
Cd
          CALL GRPRS4(KSEC0,KSEC4,PSEC4)
Cd
Cd        Special print for 2D spectra wave field real values in
Cd        section 4
Cd
          IF( (KSEC1(1).EQ.140) .AND.
     X        (KSEC1(2).EQ. 98) .AND.
     X        (KSEC1(24).EQ. 1) .AND.
     X        ( (KSEC1(40).EQ.1045).OR.(KSEC1(40).EQ.1081) ) .AND.
     X        ( (KSEC1(6) .EQ. 250).OR.(KSEC1(6) .EQ. 251) ) )
     X      CALL GRPRS4W(KSEC4)
        ENDIF
      ENDIF
C
C     Effective number of points in masked field returned in KSEC4(21).
C     Bit-map pointer within masked field returned in KSEC4(22).
C
      IF( LSECT3 ) THEN
        KSEC4(21) = NONMISS
        KSEC4(22) = IBMAP
      ENDIF
C
C     Length of section 4 (octets) in KSEC4(23).
C     Unused bit count returned in KSEC4(24).
C
      KSEC4(23) = ILEN4
      KSEC4(24) = INIL
C
C*    If no error has been encountered, set return code to informative
C     value, if required.
C
C     Set pseudo-GRIB data encountered.
C
      IF( KRET.EQ.0.AND.IPSEUD.NE.0) KRET = IPSEUD
C
C     Set data with bit-map encountered (unless 'J' option in use).
C
      IF( (KRET.EQ.0.AND.ISBMAP.NE.0).AND.(HOPER.NE.'J')) KRET = ISBMAP
C
C Dumping data values on a file if an error occurs and the environment
C variable GRIBEX_DUMP_DATA_ON_ERROR is set
        IF (( HOPER.EQ.'C'.OR.HOPER.EQ.'M'.OR.HOPER.EQ.'K')
     x  .AND.DUMPDATA.NE.0) THEN
          IDUMP = 42  ! FIXME: not guaranteed to be universally unique
          OPEN(IDUMP,FILE=DUMPPATH,FORM='FORMATTED',STATUS='UNKNOWN')
          DO jloop=1,klenp
            WRITE(IDUMP,'(E20.10)') PSEC4(jloop)
          ENDDO
          CLOSE(IDUMP)
        ENDIF
C
C*    Abort if an error has been encountered and user has requested
C     an abort. Informative values are negative and do not cause an
C     abort.
C
      IF( (NOABORT.EQ.0) .AND. (KRET.GT.0) ) THEN
C
C       Try to print some useful information before aborting
C
        WRITE(GRPRSM,*) 'GRIBEX: ********************************'
        WRITE(GRPRSM,*) 'GRIBEX: Version is ',YGRIBEX
        WRITE(GRPRSM,*) 'GRIBEX: KLENP = ', KLENP
        WRITE(GRPRSM,*) 'GRIBEX: KLENG = ', KLENG
        WRITE(GRPRSM,*) 'GRIBEX: HOPER = ', HOPER
        WRITE(GRPRSM,*) 'GRIBEX: ********************************'
        DO 910 JLOOP = 1, 43
          WRITE(GRPRSM,*) 'GRIBEX: KSEC1(',JLOOP,') = ', KSEC1(JLOOP)
  910   CONTINUE
        WRITE(GRPRSM,*) 'GRIBEX: ********************************'
        DO 920 JLOOP = 1, 22
          WRITE(GRPRSM,*) 'GRIBEX: KSEC2(',JLOOP,') = ', KSEC2(JLOOP)
  920   CONTINUE
        WRITE(GRPRSM,*) 'GRIBEX: ********************************'
        DO 930 JLOOP = 1, 10
          WRITE(GRPRSM,*) 'GRIBEX: PSEC2(',JLOOP,') = ', PSEC2(JLOOP)
  930   CONTINUE
        WRITE(GRPRSM,*) 'GRIBEX: ********************************'
        DO 940 JLOOP = 1, 2
          WRITE(GRPRSM,*) 'GRIBEX: KSEC3(',JLOOP,') = ', KSEC3(JLOOP)
  940   CONTINUE
        WRITE(GRPRSM,*) 'GRIBEX: ********************************'
        DO 950 JLOOP = 1, 2
          WRITE(GRPRSM,*) 'GRIBEX: PSEC3(',JLOOP,') = ', PSEC3(JLOOP)
  950   CONTINUE
        WRITE(GRPRSM,*) 'GRIBEX: ********************************'
        DO 960 JLOOP = 1, 20
          WRITE(GRPRSM,*) 'GRIBEX: KSEC4(',JLOOP,') = ', KSEC4(JLOOP)
  960   CONTINUE
        WRITE(GRPRSM,*) 'GRIBEX: ********************************'
        DO 970 JLOOP = 1, 20
          WRITE(GRPRSM,*) 'GRIBEX: PSEC4(',JLOOP,') = ', PSEC4(JLOOP)
  970   CONTINUE
        WRITE(GRPRSM,*) 'GRIBEX: ********************************'
        CALL ABORTX ('GRIBEX')
      ELSE
        RETURN
      ENDIF
C
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities
C granted to it by virtue of its status as an intergovernmental organisation
C nor does it submit to any jurisdiction.
C

      INTEGER FUNCTION INSANE( )
C
C---->
C**** INSANE
C
C     Purpose
C     -------
C
C     Check interpolate options before processing.
C
C
C     Interface
C     ---------
C
C     IRET = INSANE( )
C
C     Input
C     -----
C
C     Common blocks nifld.common and nofld.common
C
C
C     Output
C     ------
C
C     Returns: 0 if no problems spotted.
C              -1 if output is same as the input
C
C
C     Method
C     ------
C
C     See below!
C
C
C     Externals
C     ---------
C
C     ISSAME  - Checks if input specification is same as output.
C     INTLOG  - Logs error messages.
C     INTLOGR - Logs error messages.
C
C
C     Author
C     ------
C
C     J.D.Chambers     ECMWF     Feb 1995
C
C----<
C
      IMPLICIT NONE
C
C     Function arguments
C
#include "parim.h"
#include "nifld.common"
#include "nofld.common"
#include "grfixed.h"
C
C     Parameters
      INTEGER JPROUTINE
      PARAMETER (JPROUTINE = 27200 )
      INTEGER JPMAXRES
      PARAMETER (JPMAXRES = JPSTRUNC)
C
C     Local variables
C
      CHARACTER*12 YFLAG
      INTEGER IERR, MINGRID
      REAL GRIDINT
      LOGICAL LINCHECK,LNLIMIT
C
C     Externals
      LOGICAL ISSAME
      INTEGER FFTCHK
C
C     -----------------------------------------------------------------|
C*    Section 1.   Initialise
C     -----------------------------------------------------------------|
C
  100 CONTINUE
      INSANE = 0
      IERR = 0
C
C     Exit if output is same as input ...
C
      IF ( ISSAME() ) THEN
        INSANE = -1
        GOTO 900
      ENDIF
C
C     Check output packing accuracy requested (packed output only)
C
      IF ( NOFORM .EQ. 1 ) THEN
        IF ( (NOACC .GT. 30) .OR. (NOACC .LT. 1) ) THEN
          CALL INTLOG(JP_DEBUG,
     X        'INSANE: Invalid output packing given ',NOACC)
          NOACC = 16
          CALL INTLOG(JP_DEBUG,
     X        'INSANE: Changed to ',NOACC)
cs          CALL INTLOG(JP_ERROR,
cs     X      'Sorry!: Invalid output packing given',NOACC)
cs          IERR   = JPROUTINE + 1
cs          CALL INTLOG(JP_ERROR,
cs     X      '        Must be between 1 and 30 bits per value.',IERR)
cs          INSANE = IERR
cs          GOTO 900
        ENDIF
      ENDIF
C
C     -----------------------------------------------------------------|
C*    Section 2.   Check valid input/output representations.
C     -----------------------------------------------------------------|
C
  200 CONTINUE
C
C     Input
C
      IF ( (NIREPR .NE. JPREGULAR ) .AND.
     X     (NIREPR .NE. JPREDLL   ) .AND.
     X     (NIREPR .NE. JPSPHERE  ) .AND.
     X     (NIREPR .NE. JPSPHROT  ) .AND.
     X     (NIREPR .NE. JPGAUSSIAN) .AND.
     X     (NIREPR .NE. JPSTRSH   ) .AND.
     X     (NIREPR .NE. JPSTRGG   ) .AND.
     X     (NIREPR .NE. JPQUASI   ) ) THEN
        CALL INTLOG(JP_ERROR,
     X    'Sorry!: Invalid input representation.', NIREPR)
        INSANE = JPROUTINE + 21
        GOTO 900
      ENDIF
C
C     Output
C
      IF ( (NOREPR .NE. JPREGULAR ) .AND.
     X     (NOREPR .NE. JPREGROT  ) .AND.
     X     (NOREPR .NE. JPSPHERE  ) .AND.
     X     (NOREPR .NE. JPSPHROT  ) .AND.
     X     (NOREPR .NE. JPGAUSSIAN) .AND.
     X     (NOREPR .NE. JPSTRSH   ) .AND.
     X     (NOREPR .NE. JPSTRGG   ) .AND.
     X     (NOREPR .NE. JPQUASI   ) .AND.
     X     (NOREPR .NE. JPFGGROT  ) .AND.
     X     (NOREPR .NE. JPQGGROT  ) .AND.
     X     (NOREPR .NE. JPREDLL   ) ) THEN
        CALL INTLOG(JP_ERROR,
     X    'Sorry!: Invalid output representation.', NOREPR)
        INSANE = JPROUTINE + 22
        GOTO 900
      ENDIF
C
C     Input / output combination
C
      IF ( (NOREPR.EQ.JPSPHERE).OR.(NOREPR.EQ.JPSPHROT) ) THEN
        IF ( (NIREPR.NE.JPSPHERE).AND.(NIREPR.NE.JPSPHROT) ) THEN
C
C         Set flag to discontinue attempts at interpolation, ie
C         force output to be same as input
C
          INSANE = -1
          GOTO 900
        ENDIF
      ENDIF
C
C     -----------------------------------------------------------------|
C*    Section 3.   Check spectral to grid options.
C     -----------------------------------------------------------------|
C
  300 CONTINUE
C
      MINGRID = JP0P5 / 10
C
      IF ( (NIREPR.EQ.JPSPHERE).OR.(NIREPR.EQ.JPSPHROT) ) THEN
C
C       Check resolution not too large
C
        IF( (NOREPR.NE.JPSPHERE).AND.(NIRESO.GT.JPMAXRES) ) THEN
C
C         Problem unless a suitable truncation is on-the-way
C
          IF( LARESOL.OR.LNORESO ) THEN
            IF( MIN(NOGRID(1),NOGRID(2)).LT.MINGRID ) THEN
              CALL INTLOG(JP_ERROR,
     X        'Sorry!: Despite truncation,', JPQUIET)
              CALL INTLOG(JP_ERROR,
     X        '        spectral to grid transformation', JPQUIET)
              CALL INTLOG(JP_ERROR,
     X        '        cannot be done (grid too fine).', JPQUIET)
              CALL INTLOG(JP_ERROR,
     X        '        Grid west-east (* 10**-5)   = ', NOGRID(1))
              CALL INTLOG(JP_ERROR,
     X        '        Grid north-south (* 10**-5) = ', NOGRID(2))
              CALL INTLOG(JP_ERROR,
     X        '        Minimum allowed (* 10**-5)  = ', MINGRID)
              IERR   = JPROUTINE + 31
              INSANE = IERR
              GOTO 900
            ENDIF
C
          ELSE
C
            CALL INTLOG(JP_ERROR,
     X      'Sorry!: Spectral truncation too large for ', JPQUIET)
            CALL INTLOG(JP_ERROR,
     X      '        spectral to grid transformation.', JPQUIET)
            CALL INTLOG(JP_ERROR,
     X      '        Truncation given = ', NIRESO)
            CALL INTLOG(JP_ERROR,
     X      '        Max. truncation handled = ', JPMAXRES)
            IERR   = JPROUTINE + 31
            INSANE = IERR
            GOTO 900
          ENDIF
C
        ENDIF
C
C       Check resolution not too small
C
        IF ( (NOREPR .NE. JPSPHERE) .AND. (NIRESO .LE. 0) ) THEN
          IERR   = JPROUTINE + 32
          CALL INTLOG(JP_ERROR,
     X      'Sorry!: Spectral truncation too small for ', JPQUIET)
          CALL INTLOG(JP_ERROR,
     X      '        spectral to grid transformation.', JPQUIET)
          CALL INTLOG(JP_ERROR,
     X      '        Truncation given = ', NIRESO)
          CALL INTLOG(JP_ERROR,
     X      '        Truncation must be > ', 0)
          INSANE = IERR
          GOTO 900
        ENDIF
C
C       Check grid interval
C
        IF ( (NOREPR.EQ.JPREGULAR).OR.(NOREPR.EQ.JPREGROT) ) THEN
C
C         Not too small
C
C if env variable 1 no check of interval
      LNLIMIT = .TRUE.
      CALL GETENV('INCREMENT_NO_LIMIT', YFLAG)
      IF(YFLAG(1:1).EQ.'1' ) LNLIMIT = .FALSE.

C
        IF(LNLIMIT) THEN
          IF( (NOGRID(1).LT.MINGRID).OR.(NOGRID(2).LT.MINGRID) ) THEN
            IERR   = JPROUTINE + 33
            CALL INTLOG(JP_ERROR,
     X        'Sorry!: Grid interval too small for ', JPQUIET)
            CALL INTLOG(JP_ERROR,
     X        '        spectral to grid transformation.', JPQUIET)
            CALL INTLOG(JP_ERROR,
     X        '         Latitude interval given = ', NOGRID(1))
            CALL INTLOG(JP_ERROR,
     X        '        Longitude interval given = ', NOGRID(2))
            CALL INTLOG(JP_ERROR,
     X        '         Min. interval handled = ', MINGRID)
            INSANE = IERR
            GOTO 900
          ENDIF
       ELSE
          CALL INTLOG(JP_DEBUG,
     X    'INSANE: Increments checking disabled',JPQUIET)
       ENDIF
C
C         Not too large
C
          IF ( (NOGRID(1).GT.JP90) .OR. (NOGRID(2).GT.JP90) ) THEN
            IERR   = JPROUTINE + 34
            CALL INTLOG(JP_ERROR,
     X        'Sorry!: Grid interval too large for ', JPQUIET)
            CALL INTLOG(JP_ERROR,
     X        '        spectral to grid transformation.', JPQUIET)
            CALL INTLOG(JP_ERROR,
     X        '         Latitude interval given = ', NOGRID(1))
            CALL INTLOG(JP_ERROR,
     X        '        Longitude interval given = ', NOGRID(2))
            CALL INTLOG(JP_ERROR,
     X        '         Max. interval handled = ', JP90)
            INSANE = IERR
            GOTO 900
          ENDIF
C
C         A multiple of 0.0005
C
C if env variable 1 no check of increments
      LINCHECK = .FALSE.
      CALL GETENV('INCREMENT_CHECK', YFLAG)
      IF(YFLAG(1:1).EQ.'1' ) LINCHECK = .TRUE.

      IF( LINCHECK ) CALL INTLOG(JP_DEBUG,
     X  'INSANE: Increments checking disabled',JPQUIET)
C
        IF(.NOT.LINCHECK) THEN
          IF ( (MOD(NOGRID(1),5).NE.0) .OR.
     X         (MOD(NOGRID(2),5).NE.0) ) THEN
            IERR   = JPROUTINE + 35
            CALL INTLOG(JP_ERROR,
     X        'Sorry!: Grid must be a multiple of 0.0005 ', JPQUIET)
            CALL INTLOG(JP_ERROR,
     X        '         Latitude interval given = ', NOGRID(1))
            CALL INTLOG(JP_ERROR,
     X        '        Longitude interval given = ', NOGRID(2))
            INSANE = IERR
            GOTO 900
          ENDIF
        ENDIF
      ENDIF
C
C       Check if combination of truncation and longitude grid interval
C       can be handled by the FFT algorithm.
C
        IERR = 1
        GRIDINT = -1.0
C
        IF ( (NOREPR.EQ.JPREGULAR).OR.(NOREPR.EQ.JPREGROT) ) THEN
          GRIDINT = FLOAT(NOGRID(2))/FLOAT(JPMULT)
          IERR = FFTCHK( NIRESO, GRIDINT )
          IF ( IERR.NE.1 ) THEN
            CALL INTLOG(JP_ERROR,
     X      'Sorry!: Invalid combination of spectral number = ', NIRESO)
            CALL INTLOGR(JP_ERROR,
     X        '        and longitude grid interval = ', GRIDINT)
            CALL INTLOG(JP_ERROR,
     X        '        for FFT algorithm in use.', JPQUIET)
            INSANE = JPROUTINE + 36
            GOTO 900
          ENDIF
        ENDIF
C
        IF ( (NOREPR.EQ.JPGAUSSIAN).OR.(NOREPR.EQ.JPQUASI) ) THEN
          GRIDINT = 360.0/FLOAT(NOGAUSS)
          IERR = FFTCHK( NIRESO, GRIDINT )
          IF ( IERR.NE.1 ) THEN
            CALL INTLOG(JP_ERROR,
     X      'Sorry!: Invalid combination of spectral number = ', NIRESO)
            CALL INTLOGR(JP_ERROR,
     X        '        and longitude grid intvl = ', GRIDINT)
            CALL INTLOG(JP_ERROR,
     X        '        from gaussian number = ', NOGAUSS)
              CALL INTLOG(JP_ERROR,
     X          '        for FFT algorithm in use.', JPQUIET)
            INSANE = JPROUTINE + 37
            GOTO 900
          ENDIF
        ENDIF
C
      ENDIF
C
C     -----------------------------------------------------------------|
C*    Section 4.   Check legal area definition.
C     -----------------------------------------------------------------|
C
  400 CONTINUE
C
C     Don't check area for ocean products
C
      IF( NILOCAL.EQ.4 ) GOTO 900
C
      IF ( (NOAREA(1).GT.JP90).OR.(NOAREA(1).LT.-JP90) ) THEN
        IERR   = JPROUTINE + 41
        CALL INTLOG(JP_ERROR,
     X    'Sorry!: Output area definition illegal',JPQUIET)
        CALL INTLOG(JP_ERROR,
     X    '        Northern limit given as ', NOAREA(1))
        INSANE = IERR
        GOTO 900
      ENDIF
C
      IF ( (NOAREA(3).GT.JP90).OR.(NOAREA(3).LT.-JP90) ) THEN
        IERR   = JPROUTINE + 42
        CALL INTLOG(JP_ERROR,
     X    'Sorry!: Output area definition illegal',JPQUIET)
        CALL INTLOG(JP_ERROR,
     X    '        Southern limit given as ', NOAREA(3))
        INSANE = IERR
        GOTO 900
      ENDIF
C
      IF ( (NOAREA(2).GT.JP360).OR.(NOAREA(2).LT.-JP360) ) THEN
        IERR   = JPROUTINE + 43
        CALL INTLOG(JP_ERROR,
     X    'Sorry!: Output area definition illegal',JPQUIET)
        CALL INTLOG(JP_ERROR,
     X    '        Western limit given as ', NOAREA(2))
        INSANE = IERR
        GOTO 900
      ENDIF
C
      IF ( (NOAREA(4).GT.JP360).OR.(NOAREA(4).LT.-JP360) ) THEN
        IERR   = JPROUTINE + 44
        CALL INTLOG(JP_ERROR,
     X    'Sorry!: Output area definition illegal',JPQUIET)
        CALL INTLOG(JP_ERROR,
     X    '        Eastern limit given as ', NOAREA(4))
        INSANE = IERR
        GOTO 900
      ENDIF
C
C     Subarea not supported for reduced gaussian grids
C
      IF( LNOAREA.AND.
     X    ((NOREPR.EQ.JPQUASI).OR.
     X     (NOREPR.EQ.JPQGGROT).OR.
     X     (NOREPR.EQ.JPSTRGG)) ) THEN
        IERR   = JPROUTINE + 45
        CALL INTLOG(JP_ERROR,
     X    'Sorry!: Subarea not supported for reduced gaussian grids',
     X    JPQUIET)
        INSANE = IERR
        GOTO 900
      ENDIF
C
C     Subarea not supported for reduced lat/lon to reduced lat/lon
C
      IF( LNOAREA.AND.
     X    ((NIREPR.EQ.JPREDLL).AND.(NOREPR.EQ.JPREDLL)) ) THEN
        IERR   = JPROUTINE + 46
        CALL INTLOG(JP_ERROR,
     X    'Sorry!: Subarea not supported for reduced lat/lon '//
     X    'to reduced lat/lon grids',
     X    JPQUIET)
        INSANE = IERR
        GOTO 900
      ENDIF
C
C     -----------------------------------------------------------------|
C*    Section 5.   Check legal gaussian grid definition.
C     -----------------------------------------------------------------|
C
  500 CONTINUE
C
C     If input is quasi- regular gaussian, a grid definition must be
C     supplied in a GRIB record or by the caller, or the grid must be
C     a known definition.
C
      IF ( (NIREPR.EQ.JPQUASI) ) THEN
        IF ( (.NOT. (LIGIVEL.AND.LIGIVEP)) .AND.
     X       (.NOT. (NIFORM.EQ.1))       ) THEN
          IF (
     x         (NIGAUSS.NE.32) .AND.
     x         (NIGAUSS.NE.48) .AND.
     x         (NIGAUSS.NE.64) .AND.
     x         (NIGAUSS.NE.80) .AND.
     x         (NIGAUSS.NE.96) .AND.
     x         (NIGAUSS.NE.128).AND.
     X         (NIGAUSS.NE.160).AND.
     X         (NIGAUSS.NE.200).AND.
     X         (NIGAUSS.NE.256).AND.
     X         (NIGAUSS.NE.320).AND.
     X         (NIGAUSS.NE.400).AND.
     X         (NIGAUSS.NE.512).AND.
     X         (NIGAUSS.NE.640).AND.
     X         (NIGAUSS.NE.1024).AND.
     X         (NIGAUSS.NE.1280) ) THEN
            CALL INTLOG(JP_ERROR,
     X        'Sorry!: No definition for quasi gauss. input',NIGAUSS)
            INSANE = JPROUTINE + 51
            GOTO 900
          ENDIF
        ENDIF
      ENDIF
C
C     -----------------------------------------------------------------|
C*    Section 6.   Check legal rotation definition.
C     -----------------------------------------------------------------|
C
  600 CONTINUE
C
C     Check for rotation.
C
      IF ( LNOROTA ) THEN
C
C       Only allowed rotations are:
C        - spectral to regular lat/long
C        - regular gaussian to regular lat/long
C        - reduced gaussian to regular lat/long
C
        IF( ((NOREPR.NE.JPREGROT).AND.(NOREPR.NE.JPREGULAR)).OR.
     X      ((NIREPR.NE.JPSPHERE)  .AND.
     X       (NIREPR.NE.JPGAUSSIAN).AND.
     X       (NIREPR.NE.JPQUASI)) ) THEN
          INSANE = JPROUTINE + 61
          GOTO 900
        ENDIF
C
C       Check rotation angles.
C
        IF ( (NOROTA(1).LT.-JP360) .OR. (NOROTA(1).GT.JP360) ) THEN
          CALL INTLOG(JP_ERROR,
     X      'Sorry!: Rotation longitude out of range = ',NOROTA(1))
          INSANE = JPROUTINE + 62
          GOTO 900
        ENDIF
C
        IF ( (NOROTA(2).LT.-JP180) .OR. (NOROTA(2).GT.JP180) ) THEN
          CALL INTLOG(JP_ERROR,
     X      'Sorry!: Rotation longitude out of range = ',NOROTA(2))
          INSANE = JPROUTINE + 63
          GOTO 900
        ENDIF
      ENDIF
C
C     -----------------------------------------------------------------|
C*    Section 7.   Check legal definition for table, parameter, level
C                  type.
C     -----------------------------------------------------------------|
C
  700 CONTINUE
C
C     Table
C
c      IF ( (NOTABLE.LT.0) .OR. (NOTABLE.GT.255) ) THEN
      IF (NOTABLE.LT.0) THEN
        CALL INTLOG(JP_ERROR,
     X      'Sorry!: Table definition out of range = ', NOTABLE)
        INSANE = JPROUTINE + 71
        GOTO 900
      ENDIF
C
C     Parameter
C
cs      IF ( (NOPARAM.LT.0) .OR. (NOPARAM.GT.255) ) THEN
      IF ( NOPARAM.LT.0 ) THEN
        CALL INTLOG(JP_ERROR,
     X      'Sorry!: Parameter definition out of range = ', NOPARAM)
        INSANE = JPROUTINE + 72
        GOTO 900
      ENDIF
C
C     Level type
C
      IF ( (NOLEVT.LT.0) .OR. (NOLEVT.GT.255) ) THEN
        CALL INTLOG(JP_ERROR,
     X      'Sorry!:  Level type definition out of range = ', NOLEVT)
        INSANE = JPROUTINE + 73
        GOTO 900
      ENDIF
C
C     -----------------------------------------------------------------|
C*    Section 9.   Closedown.
C     -----------------------------------------------------------------|
C
  900 CONTINUE
C
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities
C granted to it by virtue of its status as an intergovernmental organisation
C nor does it submit to any jurisdiction.
C


      SUBROUTINE INXMAP (KGRIB,KLENG,KMAPT,PSEC4,KSIZE,KBITS,KSBMAP,
     C                     PMISS,HFUNC,KPR,KRET)
C
C---->
C**** INXMAP - Bit map handling for routine GRIBEX.
C
C     Purpose.
C     --------
C
C           1) Extract a bit-map from an array of GRIB coded data and
C              insert missing data value in appropriate places in the
C              array of already decoded data values.
C
C           2) Generate a bit-map and insert in array of GRIB coded
C              data and remove missing data values from the array of
C              values being encoded in GRIB code.
C
C**   Interface.
C     ----------
C
C           CALL INXMAP (KGRIB,KLENG,KMAPT,PSEC4,KSIZE,KBITS,KSBMAP,
C    C                     PMISS,HFUNC,KPR,KRET)
C
C           Integer    K.
C           Real       P.
C           Logical    O.
C           Character  H.
C
C               Input Parameters.
C               -----------------
C
C               KGRIB      - Array of GRIB data being coded/decoded.
C
C               KLENG      - Length of this array.
C
C               KMAPT      - Bit-pointer to start of bit-map in
C                            array KGRIB.
C
C               PSEC4      - Array of data values decoded or to be
C                            coded in GRIB.
C
C               KSIZE      - Size of bit-map ie number of values,
C                            including missing data values, in array
C                            PSEC4.
C
C               KBITS      - Number of bits in computer word.
C
C               PMISS      - Value indicating missing data in array
C                            PSEC4.
C
C               HFUNC      - 'C' , GRIB data being coded.
C                            'M' , GRIB data being coded in fixed length
C                                  messages.
C                            'D' , GRIB data being decoded.
C
C               KPR        - Debug print switch.
C                            0 , No printout.
C                            1 , Debug printout.
C
C               Output Parameters.
C               ------------------
C
C               KSBMAP     - Bit-map flag.
C                            Used only when decoding data.
C                            -2 , All bits in the bit-map set to 1.
C                                 There is no missing data.
C                            -4 , Some points have no data. User
C                                 supplied value for missing data
C                                 indicator in appropriate places in
C                                 the array PSEC4.
C
C               KSIZE      - When coding data, the number of real data
C                            values in array PSEC4. Not changed when
C                            decoding.
C
C               KRET       - Return code.
C                            0 , No error encountered.
C                            1 , Error in routine INXBIT.
C                            2 , Bit-map size exceeds maximum.
C                            3 , Invalid function requested.
C
C     Method.
C     -------
C
C           The bit-map contains 1 where valid data exists and 0
C           where data is missing. The corresponding data array
C           contains valid data and the missing data indicator value.
C
C     Externals.
C     ----------
C
C           INXBIT
C
C     Reference.
C     ----------
C
C           See routine GRIBEX.
C
C     Comments.
C     ---------
C
C           Routine contains Sections 0 to 4 and Section 9.
C
C     Author.
C     -------
C
C           J. Hennessy      ECMWF      09:09:91
C
C     Modifications.
C     --------------
C
C           J. Hennessy      ECMWF      08:11:91
C           Parameter KMACH removed from list of input parameters.
C           Optional abort removed.
C
C940309     J.D.Chambers     ECMWF      09:03:94
C940309     Maximum size for bitmap array increased to 132000
C940309     to allow for products 0.5 * 0.5 degrees, whole
C940309     hemisphere (N or S).
C
C     ------------------------------------------------------------------
C----<
C
C
C
C
C
C
C
C
C
C
C*    Section 0 . Definition of variables. Data statements.
C     ------------------------------------------------------------------
C
C*    Prefix conventions for variable names.
C
C     Logical      L (but not LP), global or common.
C                  O, dummy arguments.
C                  G, local variable.
C                  LP, parameter.
C     Character    C, Global or common.
C                  H, dummy arguments.
C                  Y (but not YP), local variables.
C                  YP, parameter.
C     Integer      M and N, global or common.
C                  K, dummy arguments.
C                  I, local variables.
C                  J (but not JP), loop control.
C                  JP, parameter.
C     Real         A to F and Q to X, global or common.
C                  P (but not PP), dummy arguments.
C                  Z, local variables.
C                  PP, parameter.
C
C
      IMPLICIT NONE
C
#include "common/grprs.h"
C
      CHARACTER*(*) HFUNC
      CHARACTER*1   YFUNC
C
      INTEGER IMAP
      INTEGER INEXT
C
      INTEGER JPMAP
C
      INTEGER J320
      INTEGER J330
      INTEGER J420
      INTEGER J430
      INTEGER J431
C
      INTEGER KBITS
      INTEGER KGRIB
      INTEGER KLENG
      INTEGER KMAPT
      INTEGER KPR
      INTEGER KRET
      INTEGER KSBMAP
      INTEGER KSIZE
C
      REAL PMISS
      REAL PSEC4
C
      REAL ZSEC4
C
C*    Maximum size of bit-map which can be handled.
C
C940309 PARAMETER (JPMAP=41472)
      PARAMETER (JPMAP=132000)
C
      DIMENSION IMAP(JPMAP)
C
      DIMENSION PSEC4(*)
      DIMENSION ZSEC4(JPMAP)
C
C     ------------------------------------------------------------------
C
C
C
C
C
C
C
C
C
C
C*    Section 1 . Set initial values.
C     ------------------------------------------------------------------
C
  100 CONTINUE
C
      IF (KPR.EQ.1)
     C   THEN
             WRITE(GRPRSM,*) 'INXMAP : Section 1.'
             WRITE(GRPRSM,*) '         Input values used -'
             WRITE(GRPRSM,9004) HFUNC
             WRITE(GRPRSM,9005) KSIZE
         ENDIF
C
C     Reset return code to
C
      KRET  = 0
C
      INEXT = 0
C
      YFUNC = HFUNC
C
C     ------------------------------------------------------------------
C
C
C
C
C
C
C
C
C
C
C*    Section 2 .  Check input parameters.
C     ------------------------------------------------------------------
C
  200 CONTINUE
C
      IF (KPR.EQ.1) WRITE(GRPRSM,*) 'INXMAP : Section 2.'
C
C*    Check that bit-map size does not exceed maximum permitted.
C
      IF (JPMAP.LT.KSIZE)
     C   THEN
             WRITE(GRPRSM,9001) KSIZE , JPMAP
             KRET = 2
             GO TO 900
         ENDIF

C     ------------------------------------------------------------------
C
C
C
C
C
C
C
C
C
C
C*    Section 3 . Decoding of bit-map and data.
C     ------------------------------------------------------------------
C
  300 CONTINUE
C
      IF (KPR.EQ.1) WRITE(GRPRSM,*) 'INXMAP : Section 3.'
C
      IF (YFUNC.EQ.'D')
     C   THEN
C
C*           Extract bit-map from GRIB coded data.
C
             CALL INXBIT (KGRIB,KLENG,KMAPT,IMAP,KSIZE,KBITS,1,
     C                     YFUNC,KRET)
C
             IF (KRET.NE.0)
     C          THEN
                    WRITE(GRPRSM,9003)
                    KRET = 1
                    GO TO 900
                ENDIF
C
C*           Copy data to temporary array and insert missing data
C            indicator in temporary array, in accordance with the
C            bit map values.
C
             DO 320 J320=1,KSIZE
                IF (IMAP(J320).EQ.0)
     C             THEN
                         ZSEC4(J320) = PMISS
                   ELSE
                       INEXT       = INEXT + 1
                       ZSEC4(J320) = PSEC4(INEXT)
                   ENDIF
  320        CONTINUE
C
C*           Set bit-map flag, and if missing data is indicated
C            transfer data to original array.
C
             IF (INEXT.NE.KSIZE)
     C          THEN
                    KSBMAP = -4
                    DO 330 J330=1,KSIZE
                       PSEC4(J330) = ZSEC4(J330)
  330               CONTINUE
                ELSE
                    KSBMAP = -2
                ENDIF
C
             GO TO 900
C
         ENDIF
C
C    -------------------------------------------------------------------
C
C
C
C
C
C
C
C
C
C
C*    Section 4 . Generation of bit-map.
C    -------------------------------------------------------------------
C
  400 CONTINUE
C
      IF (KPR.EQ.1) WRITE(GRPRSM,*) 'INXMAP : Section 4.'
C
      IF (YFUNC.EQ.'C'.OR.YFUNC.EQ.'M')
     C   THEN
C
C*           Copy data to temporary array and remove missing data
C            indicator in temporary array, generating the bit-map
C            in accordance with the missing data values.
C
             DO 420 J420=1,KSIZE
                IF (PSEC4(J420).EQ.PMISS)
     C             THEN
                       IMAP(J420)   = 0
                   ELSE
                       IMAP(J420)   = 1
                       INEXT        = INEXT + 1
                       ZSEC4(INEXT) = PSEC4(J420)
                   ENDIF
  420        CONTINUE
C
C*           Insert bit-map in GRIB coded data.
C
             CALL INXBIT (KGRIB,KLENG,KMAPT,IMAP,KSIZE,KBITS,1,
     C                     YFUNC,KRET)
C
             IF (KRET.NE.0)
     C          THEN
                    WRITE(GRPRSM,9003)
                    KRET = 1
                    GO TO 900
                ENDIF
C
C*           If missing data is indicated transfer data to original
C            array.
C
             IF (INEXT.NE.KSIZE)
     C          THEN
                    DO 430 J430=1,INEXT
                       PSEC4(J430) = ZSEC4(J430)
  430               CONTINUE
C
                    IF (YFUNC.EQ.'M')
     C                 THEN
C
C                          Fixed length messages required, even though
C                          a bit map is used. The otherwise unused part
C                          of the array is set to a genuine data value
C                          so that extraction of minimum and maximum
C                          values remain correct. Number of data values
C                          includes these padding values.
C
                           DO 431 J431=INEXT+1,KSIZE
                              PSEC4(J431) = PSEC4(1)
  431                      CONTINUE
                       ELSE
C
C                          Return number of real values (excluding
C                          missing data values).
C
                           KSIZE = INEXT
                       ENDIF
                ENDIF
C
             GO TO 900
C
         ENDIF
C
C*    Invalid function requested.
C
      WRITE(GRPRSM,9002) YFUNC
      KRET = 3
C
C     ------------------------------------------------------------------
C
C
C
C
C
C
C
C
C
C
C*    Section 9 . Return to calling routine. Format statements.
C     ------------------------------------------------------------------
C
  900 CONTINUE
C
      IF (KPR.EQ.1)
     C   THEN
             WRITE(GRPRSM,*) 'INXMAP : Section 9.'
             WRITE(GRPRSM,*) '         Output values set -'
             WRITE(GRPRSM,9005) KSIZE
             WRITE(GRPRSM,9006) KSBMAP
         ENDIF
C
 9001 FORMAT (1H ,'INXMAP : Bit-map size is ',I6,', maximum allowed',
     C            ' is ',I6,'.')
C
 9002 FORMAT (1H ,'INXMAP : Invalid function requested - ',A1)
C
 9003 FORMAT (1H ,'INXMAP : Error reported by routine INXBIT.')
C
 9004 FORMAT (1H ,'         HFUNC  = ',A1)
C
 9005 FORMAT (1H ,'         KSIZE  = ',I6)
C
 9006 FORMAT (1H ,'         KSBMAP = ',I6)
C
      RETURN
C
      END

C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C


      SUBROUTINE CCF1CR (HEXP,HSTR,HDIS,HTYP,HREP,HLEV,HARE,HPER,HFIR,
     C      HOWN,HBAK,HCLS,HFAM,HRUT,KPR,KRET)
C
C
C---->
C**** CCF1CR
C
C     PURPOSE.
C     --------
C
C           CREATE REQUESTED NODES IN CFS FOR MARS ARCHIVING.
C
C**   INTERFACE.
C     ----------
C
C           CALL CCF1CR (HEXP,HSTR,HDIS,HTYP,HREP,HLEV,HARE,HPER,HFIR,
C    C      HOWN,HBAK,HCLS,HFAM,HRUT,KPR,KRET)
C
C           INTEGER    K.
C           REAL       P.
C           LOGICAL    O.
C           CHARACTER  H.
C
C               INPUT PARAMETERS.
C               -----------------
C
C               HEXP       - 4 CHARACTER EXPERIMENT IDENTIFIER.
C
C               HSTR       - ARCHIVE STREAM.
C                            FOR RESEARCH.
C                               DA - DAILY ARCHIVE.
C                            FOR OPERATIONS.
C                               DA - DAILY ARCHIVE.
C                               CH - CHERNOBYL ARCHIVE.
C                               TG - TOGA ARCHIVE.
C                               MO - MONTHLY.
C
C               HDIS       - NEW , NEW ENTRY REQUIRED.
C                            OLD , DELETE OLD ENTRY BEFORE MAKING
C                                  NEW ONE.
C
C               HTYP       - AN , ANALYSIS.
C                            IA , INITIALISED ANALYSIS.
C                            FG , FIRST GUESS.
C                            FC , FORECAST.
C                            EA , ERRORS IN ANALYSIS.
C                            CL , CLIMATOLOGY.
C
C
C               HREP       - SH , SPHERICAL HARMONICS.
C                            GG , GAUSSIAN GRID.
C                            LL , LAT/LONG GRID.
C
C               HLEV       - M , MODEL LEVELS.
C                            P , PRESSURE LEVELS.
C                            S , SURFACE.
C
C               HARE       - G , GLOBAL DATA.
C
C               HPER       - S , SHORT RETENTION PERIOD.
C                            M , MEDIUM RETENTION PERIOD.
C                            P , PERMANENT RETENTION.
C
C               HFIR       - DATE OF FIRST ARCHIVE (YYMMDD).
C
C               HOWN       - OWNER'S PASSWORD. 6 CHARACTERS FOR
C                            RESEARCH EXPERIMENTS, 5 FOR OPERATIONS.
C
C               HBAK       - 0 , NO BACKUP NODES REQUIRED.
C                            1 , 1 BACKUP OF NODES REQUIRED.
C
C               HCLS       - RD , RESEARCH DEPARTMENT.
C                            OD , OPERATIONS DEPARTMENT.
C
C               HFAM       - N, NO FAMILY ATTRIBUTE IN NODES.
C                            Y , FAMILY ATTRIBUTES IN NODES.
C
C               HRUT       - ROOT NODE TO BE USED.
C                            FOR RESEARCH
C                               P , PRODUCTION ROOT MARSR.
C                               T , TEST ROOT MATSR.
C                            FOR OPERATIONS
C                               P , PRODUCTION ROOT MARST.
C                               O , OLD PRODUCTION ROOT MARSO.
C                               T , TEST ROOT MATST.
C
C               KPR        - DEBUG PRINT SWITCH.
C                            0 , NO PRINTOUT.
C                            1 , DEBUG PRINTOUT.
C
C               OUTPUT PARAMETERS.
C               ------------------
C
C               KRET       - ERROR RETURN CODE.
C                            0   , NO ERROR ENCOUNTERED.
C                            1   , ERROR IN REMOVING OLD NODES.
C                            2   , ERROR IN CREATING NEW NODES.
C                            3   , ERROR IN ADDING VALIDATION ENTRIES.
C                            4   , ERROR IN ADDING FAMILY ATTRIBUTE.
C                            5   , ERROR IN PASSWORD.
C                            6   , ATTEMPT TO DELETE OPERATIONAL NODE.
C                            7   , EXPERIMENT IDENTIFIER NOT FOUR
C                                  CHARACTERS.
C                            8   , DATE OF FIRST ARCHIVE NOT 6 DIGITS.
C
C     METHOD.
C     -------
C
C           ROOT NODES ARE ASSUMED TO EXIST. CACHE NODES CREATED
C           AUTOMATICALLY, BACKUP NODES IF REQUIRED.
C           DELETION OF OPERATIONAL NODES IS PROHIBITED.
C
C     EXTERNALS.
C     ----------
C
C           ECFILE
C
C     REFERENCE.
C     ----------
C
C           MARS DESIGN NOTE 30. FILE 460 24.03.88.
C
C     COMMENTS.
C     ---------
C
C           ROUTINE CONTAINS SECTIONS 0 TO 4 AND SECTION 9.
C           ADDITION OF FAMILY ATTRIBUTE NOT POSSIBLE IN FIRST VERSION.
C
C     AUTHOR.
C     -------
C
C           J. HENNESSY      ECMWF      28:06:89.
C
C     MODIFICATIONS
C     --------------
C
C           NONE.
C
C----<
C     ----------------------------------------------------------------
C
C
C
C
C
C
C
C
C
C
C*    SECTION 0 . DEFINITION OF VARIABLES.
C     ----------------------------------------------------------------
C
      IMPLICIT LOGICAL     ( L, O, G )
      IMPLICIT CHARACTER*8 ( C, H, Y )
      IMPLICIT INTEGER     ( I, J, K, M, N )
C
C
      CHARACTER*4  HEXP
      CHARACTER*2  HSTR
      CHARACTER*4  HDIS
      CHARACTER*4  HTYP
      CHARACTER*4  HREP
      CHARACTER*4  HLEV
      CHARACTER*4  HARE
      CHARACTER*1  HPER
      CHARACTER*6  HFIR
      CHARACTER*6  HOWN
      CHARACTER*1  HBAK
      CHARACTER*2  HCLS
      CHARACTER*1  HFAM
      CHARACTER*1  HRUT
C
      CHARACTER*36 YLINE
C
      CHARACTER*160 YREQ
C
      CHARACTER*6  YNODE1
      CHARACTER*3  YNODE2
      CHARACTER*5  YNODE3
      CHARACTER*5  YNODE4
      CHARACTER*5  YNODE5
C
      DIMENSION IREASON(3)
C
      DIMENSION YLINE(3)
C
C
C     ----------------------------------------------------------------
C
C
C
C
C
C
C
C
C
C*    SECTION 1 . SET INITIAL VALUES. CHECK PARAMETERS.
C     ----------------------------------------------------------------
C
 1000 CONTINUE
C
      IF (KPR.EQ.1) WRITE (*,*) 'CCF1CR : SECTION 1.'
C
      KRET = 0
C
C*    CHECK THAT EXPERIMENT OR STREAM IDENTIFIER IS 4 CHARACTERS LONG.
C
      I = INDEX (HEXP,' ')
      IF (I.NE.0)
     C   THEN
             KRET = 7
             WRITE (*,9006) HEXP
             GO TO 9000
         ENDIF
C
C*    CHECK THAT FIRST ARCHIVE DATE CONSISTS OF 6 DIGITS.
C
      I = INDEX (HFIR,' ')
      IF (I.NE.0)
     C   THEN
             KRET = 8
             WRITE (*,9007) HFIR
             GO TO 9000
         ENDIF
C
C
C*    FOR COMPATIBILITY WITH PREVIOUS USER INTERFACE A FEW DEFAULT
C     VALUES HAVE TO BE SET UP, WHEN NONE ARE PROVIDED.
C
      IF (HCLS.EQ.'  ') HCLS = 'RD'
      IF (HFAM.EQ.' ')  HFAM = 'N'
      IF (HCLS.EQ.'RD') HFAM = 'N'
      IF (HCLS.EQ.'RD') HSTR = 'DA'
      IF (HRUT.EQ.' ')  HRUT = 'P'
C
C
C     CHECK THAT OWNER'S PASSWORD IS CORRECT LENGTH ( 5 FOR OPERATIONS
C     6 FOR RESEARCH).
C
      IL = INDEX (HOWN,' ')
      IF (IL.EQ.6) IL = 5
      IF (IL.EQ.0) IL = 6
      IF (IL.EQ.5.AND.HCLS.NE.'OD') KRET = 5
      IF (IL.EQ.6.AND.HCLS.NE.'RD') KRET = 5
      IF (KRET.EQ.5)
     C   THEN
             WRITE (*,9008) HOWN
             GO TO 9000
         ENDIF
C
C*    RESEARCH ARCHIVE IS DAILY ARCHIVE ONLY. OPERATIONAL ARCHIVES
C     HAVE SEVERAL STREAMS, WHICH ARE USED TO MAKE UP CFS PATHNAME,
C     IN THE SAME NODE AS THE RESEARCH EXPERIMENT IDENTIFIER.
C
      IF (HCLS.EQ.'OD')
     C   THEN
             HEXP = 'OPER'
             IF (HSTR.EQ.'CH') HEXP = 'CHER'
             IF (HSTR.EQ.'TG') HEXP = 'TOGA'
         ENDIF
C
C*    SET UP VALUES FOR FIRST 5 NODES EG MARSR/FC/EXPV/SPGS/1989.
C
C     NODE 1.
C
      IF (HCLS.EQ.'RD'.AND.HRUT.EQ.'P') YNODE1 = '/MARSR'
      IF (HCLS.EQ.'RD'.AND.HRUT.EQ.'T') YNODE1 = '/MATSR'
C
      IF (HCLS.EQ.'OD'.AND.HRUT.EQ.'T') YNODE1 = '/MATST'
      IF (HCLS.EQ.'OD'.AND.HRUT.EQ.'O') YNODE1 = '/MARSO'
      IF (HCLS.EQ.'OD'.AND.HRUT.EQ.'P') YNODE1 = '/MARST'
C
C     NODE 2.
C
      YNODE2 = '/'//HTYP(1:2)
C
C     NODE 3.
C
      YNODE3 = '/'//HEXP
C
C     NODE 4.
C
      YNODE4 = '/'//HREP(1:1)//HLEV(1:1)//HARE(1:1)//HPER
C
C     NODE 5.
C
      YNODE5 = '/19'//HFIR(1:2)
C
C
C     ----------------------------------------------------------------
C
C
C
C
C
C
C
C
C
C*    SECTION 2 . REMOVE ANY EXISTING NODES AND FILES, IF REQUIRED.
C     ----------------------------------------------------------------
C
 2000 CONTINUE
C
      IF (KPR.EQ.1) WRITE (*,*) 'CCF1CR : SECTION 2.'
C
      IF (HDIS(1:1).EQ.'O')
     C   THEN
C
C*           REMOVAL OF OPERATIONAL NODES AND FILES NOT ALLOWED.
C
             IF (HCLS.EQ.'OD'.AND.(HRUT.EQ.'P'.OR.HRUT.EQ.'O'))
     C          THEN
                    KRET = 6
                    WRITE (*,9004)
                    GO TO 9000
                ENDIF
C
             YTEMP = 'REMOVE'
             CALL LDC1CR (YTEMP,HOWN(1:IL),HEXP,HTYP,HCLS,HSTR,HRUT,
     C                     KPR,IRC)
C
C            IGNORE RETURN CODE FOR EXPERIMENT DOES NOT EXIST.
C
             IF (IRC.GT.1)
     C          THEN
                    KRET = 1
                    WRITE (*,9005)
                    GO TO 9000
                ENDIF
         ENDIF
C
C     ----------------------------------------------------------------
C
C
C
C
C
C
C
C
C
C*    SECTION 3 . CREATE NODE (AND BACKUP NODES IF REQUIRED).
C     ----------------------------------------------------------------
C
 3000 CONTINUE
C
      IF (KPR.EQ.1) WRITE (*,*) 'CCF1CR : SECTION 3.'
C
      DO 3900 J3900 = 1 , 4
C
C*    IF FIRST TIME THROUGH SET UP /ROOT/TYPE NODES.
C
      IF (J3900.EQ.1)
     C   THEN
             YLINE(1) = YNODE1//YNODE2//','
             YLINE(2) = '/CACHE'//YNODE1//YNODE2//','
             YLINE(3) = '/MARSBACKUP'//YNODE1//YNODE2//','
         ENDIF
C
C*    IF SECOND TIME THROUGH SET UP /ROOT/TYPE/EXPVER NODES.
C
      IF (J3900.EQ.2)
     C   THEN
             YLINE(1) = YNODE1//YNODE2//YNODE3//','
             YLINE(2) = '/CACHE'//YNODE1//YNODE2//YNODE3//','
             YLINE(3) = '/MARSBACKUP'//YNODE1//YNODE2//YNODE3//','
         ENDIF
C
C*    IF THIRD TIME THROUGH SET UP /ROOT/TYPE/EXPVER/DESCRIPTOR NODES.
C
      IF (J3900.EQ.3)
     C   THEN
             YLINE(1) = YNODE1//YNODE2//YNODE3//YNODE4//','
             YLINE(2) = '/CACHE'//YNODE1//YNODE2//YNODE3//YNODE4//','
             YLINE(3) = '/MARSBACKUP'//YNODE1//YNODE2//YNODE3//YNODE4
     C                     //','
         ENDIF
C
C*    IF FOURTH TIME THROUGH SET UP /ROOT/TYPE/EXPVER/DESCRIPTOR/YEAR
C     NODES.
C
      IF (J3900.EQ.4)
     C   THEN
             YLINE(1) = YNODE1//YNODE2//YNODE3//YNODE4//YNODE5//','
             YLINE(2) = '/CACHE'//YNODE1//YNODE2//YNODE3//YNODE4
     C                     //YNODE5//','
             YLINE(3) = '/MARSBACKUP'//YNODE1//YNODE2//YNODE3//YNODE4
     C                     //YNODE5//','
         ENDIF
C
C
      J = 0
C
 3100 CONTINUE
C
      J = J + 1
      I = INDEX (YLINE(J),',')
      YREQ = 'FN=ADD,NA,PATH='//YLINE(J)(1:I)//'UVAL=UV1/WMB/'
     C          //HOWN(1:IL)//'/S.'
      IF (KPR.EQ.1) WRITE (*,9003) YREQ
      CALL ECFILE (IERR,IREASON,YREQ)
C
C     TRAP RETURN CODES FOR NODE ALREADY EXISTS.
C
      IF (IERR .EQ. 9.
     C   AND.IREASON(1).EQ.1.
     C   AND.IREASON(2).EQ.2.
     C   AND.IREASON(3).EQ.12) GO TO 3300
C
      IF (IERR.NE.0)
     C   THEN
             WRITE (*,9001) IERR , IREASON
             WRITE (*,9003) YREQ
             KRET = 2
             GO TO 9000
         ENDIF
C
C     ADD VALIDATION ENTRY.
C
      YREQ = 'FN=MODIFY,PW='//HOWN(1:IL)//',NA,PATH='//YLINE(J)(1:I)//
     C             'AVAL=PUB/IR/-/S.'
      IF (KPR.EQ.1) WRITE (*,9003) YREQ
      CALL ECFILE (IERR,IREASON,YREQ)
C
C     TRAP RETURN CODES FOR ENTRY ALREADY EXISTS.
C
      IF (IERR .EQ. 9.
     C   AND.IREASON(1).EQ.1.
     C   AND.IREASON(2).EQ.115.
     C   AND.IREASON(3).EQ.5) GO TO 3300
C
      IF (IERR.NE.0)
     C   THEN
             WRITE (*,9002) IERR , IREASON
             WRITE (*,9003) YREQ
             KRET = 3
             GO TO 9000
         ENDIF
C
 3300 CONTINUE
C
C     CREATE CACHE NODES.
C
      IF (J.LT.2) GO TO 3100
C
C     CREAT BACKUP NODES IF REQUIRED.
C
      IF (HBAK.EQ.'1'.AND.J.EQ.2) GO TO 3100
C
 3900 CONTINUE
C
C    ----------------------------------------------------------------
C
C
C
C
C
C
C
C
C
C
C*    SECTION 4 . ADD FAMILY ATTRIBUTES.
C    ----------------------------------------------------------------
C
 4000 CONTINUE
C
      IF (KPR.EQ.1) WRITE (*,*) 'CCF1CR : SECTION 4.'
C
      IF (HFAM.EQ.'Y')
     C   THEN
             KRET = 4
             WRITE (*,*) 'CCF1CR : FAMILY ATTRIBUTES NOT IMPLEMENTED.'
             GO TO 9000
         ENDIF
C
C     ----------------------------------------------------------------
C
C
C
C
C
C
C
C
C
C
C
C
C*    SECTION 9 . RETURN TO CALLING ROUTINE. FORMAT STATEMENTS.
C     ------------------------------------------------------------------
C
 9000 CONTINUE
C
      IF (KPR.EQ.1) WRITE (*,*) 'CCF1CR : SECTION 9.'
C
C
      RETURN
C
C
 9001 FORMAT (1H ,'CCF1CR : NODE CREATION ERROR. FAILURE CODE = ',I3,
     C            ' , REASON CODES = ',3I6,' .')
C
 9002 FORMAT (1H ,'CCF1CR : VALIDATION ENTRY. FAILURE CODE = ',I3,
     C            ' , REASON CODES = ',3I6,' .')
C
 9003 FORMAT (1H ,A)
C
 9004 FORMAT (1H ,'CCF1CR : OPERATIONAL NODE DELETION ILLEGAL.')
C
 9005 FORMAT (1H ,'CCF1CR : DELETION OF OLD NODES/FILES FAILED.')
C
 9006 FORMAT (1H ,'CCF1CR : EXPERIMENT IDENTIFIER NOT 4 CHARACTERS - ',
     C             A)
C
 9007 FORMAT (1H ,'CCF1CR : FIRST ARCHIVE DATE NOT 6 DIGITS - ',A)
C
 9008 FORMAT (1H ,'CCF1CR : OWNER (PASSWORD) INVALID - ',A)
C
C     ------------------------------------------------------------------
C
C
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities
C granted to it by virtue of its status as an intergovernmental organisation
C nor does it submit to any jurisdiction.
C

C     Determine if FFTW should be used, instead of the usual FFT99 (as
C     per the environment)

      LOGICAL FUNCTION FORCED_FFTW(FORCED)

      IMPLICIT NONE

      LOGICAL FORCED
      CHARACTER*12 YFLAG

C     Set if FORCED, or set by env
      FORCED_FFTW = FORCED
      IF( .NOT. FORCED_FFTW ) THEN
        CALL GETENV('EMOSLIB_FORCED_FFTW', YFLAG)
        FORCED_FFTW = (YFLAG(1:1).EQ.'1')
      ENDIF

      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE CTABLE(YNAME,KERR)
C
C**** *CTABLE*
C
C
C     PURPOSE.
C     --------
C          THE MAIN PURPOSE OF THIS PROGRAMME IS TO CREATE WORKING
C          CODE TABLES FOR *BUFR* DECODING.
C
C**   INTERFACE.
C     ----------
C          NONE.
C
C
C
C
C     *METHOD.
C      -------
C          NONE.
C
C
C
C     EXTERNALS.
C     ----------
C          NONE.
C
C
C
C
C     REFERENCE.
C     ----------
C
C          BINARY UNIVERSAL FORM FOR DATA REPRESENTATION, *FM 94 BUFR*.
C
C          J.K.GIBSON AND *M.DRAGOSAVAC,1987:* DECODING *DATA *REPRESENTATION
C                          *FM 94 BUFR*,*TECHNICAL *MEMORANDUM *NO. 134
C
C          J.K.GIBSON,1986:*EMOS 2 - *STANDARDS FOR SOFTWARE DEVELOPMENT
C                           AND MAINTANANCE *,*TECHICAL MEMORANDUM *NO.
C                           *ECMWF*.
C
C
C     AUTHOR.
C     -------
C
C          M. DRAGOSAVAC       *ECMWF*       JANUARY 1991.
C
C
C     MODIFICATIONS.
C     --------------
C
C          NONE.
C
C
      IMPLICIT LOGICAL(L,O,G), CHARACTER*8(C,H,Y)
C
#     include "parameter.F"
#     include "bcomwork.F"
#     include "bcomtab.F"
#     include "bcomtabc.F"
#     include "bcomct.F"
#     include "bcomctc.F"
#     include "bcomroot.F"
#     include "bcomtabload.F"
#     include "bcomtabloadc.F"


C
      CHARACTER*64 CTEXT
      CHARACTER*64 CTABBEN
      CHARACTER*24 CTABBU
      CHARACTER*256 YFNAME
      CHARACTER*(*) YNAME
      CHARACTER*120 YENTRY
C
      REAL*8 RVIND,EPS
C
C     ------------------------------------------------------------------
C*          1.   SET INITIAL CONSTANTS AND POINTERS
C                ----------------------------------
 100  CONTINUE
C
      J=0
      YFNAME=' '
C
      DO 101 I=1,JCTEXT
      CTEXT(I)=' '
 101  CONTINUE
C
      DO 102 I=1,JCTAB
      NREF(I)=0
      NSTART(I)=0
      NLEN(I)=0
 102  CONTINUE
C
      DO 103 I=1,JCTST
      NCODNUM(I)=0
      NSTARTC(I)=0
      NLENC  (I)=0
 103  CONTINUE
C
      II=INDEX(YNAME,' ')
      II=II-1
      YFNAME=YNAME(1:II)
      II=INDEX(YFNAME,' ')
      II=II-1
      CALL GET_FREE_UNIT(IUNIT)
      OPEN(UNIT=IUNIT,FILE=YFNAME(1:II),ERR=401,STATUS='OLD')
C
C     ------------------------------------------------------------------
C*          2.   READ IN CODE TABLE ENTRY
C                ------------------------
 200  CONTINUE
C
C
      READ(IUNIT,'(A)',ERR=402,END=300) YENTRY
C
      J = J+1
C
      IF(J.GT.JCTAB) THEN
         PRINT*,' DIMENSION TOO SMALL J=',J
         kerr=66
         return
      END IF 
C
C     ------------------------------------------------------------------
C*          2.1  SET ARRAYS FOR CODE TABLE TABLE REFERENCE, STARTING POINTERS
C                FOR LIST OF CODE NUMBERS, LENGTH , LIST OF CODE NUMBERS,
C                STARTING POINTERS AND LENGTH OF TEXT INFORMATION.
 210  CONTINUE
C
      READ(YENTRY,'(I6,1X,I4,1X,I4,1X,I2)',IOSTAT=ios) NREF(J),NLEN(J),
     1                                                NCODE,NLINE
      if(ios.ne.0) then
         print*,YENTRY
         print*,'Internal read error 1'
         return
      end if
    
C
      IF(J.EQ.1) THEN
         NSTART (J)  = 1
         NSTARTC(J)  = 1
         IPT = 1
         IIPT= 1
      ELSE
         NSTART(J)   = NSTART(J-1) + NLEN(J-1)
         IPT         = NSTART(J)
         IIPT        = IIPT + 1
         NSTARTC(IPT)= IIPT
      END IF
C
C
      NCODNUM(IPT)=NCODE
      NLENC ( IPT)=NLINE
C
      CTEXT (IIPT)=YENTRY(21:80)
C     -------------------------------------------------------------------
      IF(NLENC(IPT).GT.1) THEN
         DO 220 JA=1,NLENC(IPT)-1
         READ(IUNIT,'(A)',END=300) YENTRY
         IIPT=IIPT+1
         CTEXT(IIPT)=YENTRY(21:80)
 220     CONTINUE
      END IF
C
      IF(NLEN(J).GT.1) THEN
         DO 230 JA=1,NLEN(J)-1
         READ(IUNIT,'(A)',END=300) YENTRY
         READ(YENTRY,'(12X,I4,1X,I2)',IOSTAT=IOS) NCODE,NLINE
         if(IOS.ne.0) then
            print*,YENTRY
            print*,'Internal read error 2'
            return
         end if
         IPT   = IPT + 1
         IIPT  =IIPT + 1
         NCODNUM(IPT)= NCODE
         NSTARTC(IPT)=  IIPT
         NLENC  (IPT)=NLINE
         CTEXT(IIPT) = YENTRY(21:80)
         IF(NLENC(IPT).GT.1) THEN
            DO 240 JB=1,NLENC(IPT)-1
            READ(IUNIT,'(A)',END=300) YENTRY
            IIPT=IIPT+1
            CTEXT(IIPT)=YENTRY(21:80)
 240        CONTINUE
         END IF
 230     CONTINUE
      END IF
C
      GO TO 200
C
C     ------------------------------------------------------------------
 300  CONTINUE
C
      IF(NTT.EQ.JTMAX.AND.NTC.NE.0) THEN
         DO J=1,JCTAB
            MNREF(J,NTC)=NREF(J)
            MNSTART(J,NTC)=NSTART(J)
            MNLEN(J,NTC)=NLEN(J)
         END DO
         DO J=1,JCTST
            MNCODNUM(J,NTC)=NCODNUM(J)
            MNSTARTC(J,NTC)=NSTARTC(J)
            MNLENC(J,NTC)=NLENC(J)
         END DO
         DO J=1,JCTEXT
            CCTEXT(J,NTC)=CTEXT(J)
         END DO
      ELSE
         DO J=1,JCTAB
            MNREF(J,NTT)=NREF(J)
            MNSTART(J,NTT)=NSTART(J)
            MNLEN(J,NTT)=NLEN(J)
         END DO
         DO J=1,JCTST
            MNCODNUM(J,NTT)=NCODNUM(J)
            MNSTARTC(J,NTT)=NSTARTC(J)
            MNLENC(J,NTT)=NLENC(J)
         END DO
         DO J=1,JCTEXT
            CCTEXT(J,NTT)=CTEXT(J)
         END DO

      END IF

      CLOSE(IUNIT)
C
C     write(*,'(1h )')
C     write(*,'(1H ,a,i4)') 'Total number of entries in Table C is ',j
C
      RETURN
C     -----------------------------------------------------------------
 400  CONTINUE
C
 401  CONTINUE
C
      KERR=62
      WRITE(*,4401) IOS,YFNAME
 4401 FORMAT(1H ,'Open error ',i4,' on ',a)
      RETURN
C
 402  CONTINUE
      KERR=7
      WRITE(*,4402) IOS,YFNAME
 4402 FORMAT(1H ,'Read error ',i4,' on ',a)
      RETURN
C
      END

C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE BUEXS33(KBUFL,KBUFF,KSEC3,KERR)
C
C**** *BUEXS33*
C
C
C     PURPOSE.
C     --------
C
C          EXPAND SECTION 3 OF BUFR MESSAGE.
C               (PRELIMINARY ITEMS)
C
C
C**   INTERFACE.
C     ----------
C
C          *CALL* *BUEXS33( KBUFL,KBUFF,KSEC3,KERR)*
C
C        INPUT :
C               *KBUFL*   -  LENGTH OF BUFR MESSAGE (WORDS)
C               *KBUFF*   -  ARRAY CONTAINING BUFR MESSAGE
C        OUTPUT:
C               *KSEC3*
C               *KERR*    -  RETURNED ERROR CODE
C
C     METHOD.
C      -------
C
C
C          NONE.
C
C     EXTERNALS.
C     ----------
C
C          BUNEXS        - SET WORD AND BIT POINTERS AT THE BEGINING OF
C                          NEXT SECTION
C          BUNPCK        - UNPACKS BIT PATTERN
C
C     REFERENCE.
C     ----------
C
C          NONE.
C
C     AUTHOR.
C     -------
C
C          M. DRAGOSAVAC    *ECMWF*       01/02/91.
C
C
C     MODIFICATIONS.
C     --------------
C
C          NONE.
C
C
      IMPLICIT LOGICAL(L,O,G), CHARACTER*8(C,H,Y)
C
C
#     include "parameter.F"
#     include "bcomunit.F"
#     include "bcomwork.F"
C
      DIMENSION KBUFF(KBUFL)
      DIMENSION KSEC3(*)
#ifndef R_4
      REAL*8 RVIND
      REAL*8 EPS
#else
      REAL   RVIND
      REAL   EPS
#endif
C
C     ------------------------------------------------------------------
C
C*          1.   EXPAND PRELIMINARY ITEMS OF SECTION 3.
C                --------------------------------------
 100  CONTINUE
C
      IF( KERR.NE.0 ) RETURN
C
C*          1.1   SET THE POINTERS NWPT AND NBPT TO THE
C                 -------------------------------------
C                 BEGINING OF THE SECTION 3.
C                 --------------------------
 110  CONTINUE
C
      NWPT = NWPTB
      NBPT = NBPTB
C
C*          1.2   UNPACK LENGTH OF SECTION 3.
C                 ---------------------------
 120  CONTINUE
C
      CALL BUNPCK(NBPW,KBUFF,KSEC3(1),NWPT,NBPT,24,KERR)
      IF(KERR.GT.0) RETURN
C
C
C*          1.3    UNPACK ZERO BYTE AND PUT IT IN KSEC3(2).
C                  ----------------------------------------
 130  CONTINUE
C
      CALL BUNPCK(NBPW,KBUFF,KSEC3(2),NWPT,NBPT,8,KERR)
      IF(KERR.GT.0) RETURN
C
C*          1.4    UNPACK NUMBER OF DATA SUB-SETS.
C                  -------------------------------
 140  CONTINUE
C
      CALL BUNPCK(NBPW,KBUFF,KSEC3(3),NWPT,NBPT,16,KERR)
      IF(KERR.GT.0) RETURN
      IF(KSEC3(3).LE.0) THEN
         KERR=32
         WRITE(KNTN,*)  ' BUEXS3 :'
         CALL BUERR(KERR)
         RETURN
      END IF
C
      CALL BUNPCK(NBPW,KBUFF,KSEC3(4),NWPT,NBPT,8,KERR)
      IF(KERR.GT.0) RETURN
C     -----------------------------------------------------------------
C
      NWPT = NWPTB
      NBPT = NBPTB      
C
      RETURN
      END

c Copyright 1981-2016 ECMWF.
c
c This software is licensed under the terms of the Apache Licence 
c Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
c
c In applying this licence, ECMWF does not waive the privileges and immunities 
c granted to it by virtue of its status as an intergovernmental organisation 
c nor does it submit to any jurisdiction.
c

      SUBROUTINE RPASSM(A,B,C,D,TRIGS,INC1,INC2,INC3,INC4,ILOT,N,IFAC,
     *    ILA,IERR)
      REAL A(*),B(*),C(*),D(*),TRIGS(*)
C
C     SUBROUTINE 'RPASSM' - PERFORMS ONE PASS THROUGH DATA AS PART
C     OF MULTIPLE REAL FFT (FOURIER SYNTHESIS) ROUTINE
C
C     A IS FIRST REAL INPUT VECTOR
C         EQUIVALENCE B(1) WITH A (ILA*INC1+1)
C     C IS FIRST REAL OUTPUT VECTOR
C         EQUIVALENCE D(1) WITH C(IFAC*ILA*INC2+1)
C     TRIGS IS A PRECALCULATED LIST OF SINES & COSINES
C     INC1 IS THE ADDRESSING INCREMENT FOR A
C     INC2 IS THE ADDRESSING INCREMENT FOR C
C     INC3 IS THE INCREMENT BETWEEN INPUT VECTORS A
C     INC4 IS THE INCREMENT BETWEEN OUTPUT VECTORS C
C     ILOT IS THE NUMBER OF VECTORS
C     N IS THE LENGTH OF THE VECTORS
C     IFAC IS THE CURRENT FACTOR OF N
C     ILA IS THE PRODUCT OF PREVIOUS FACTORS
C     IERR IS AN ERROR INDICATOR:
C              0 - PASS COMPLETED WITHOUT ERROR
C              1 - ILOT GREATER THAN 64
C              2 - IFAC NOT CATERED FOR
C              3 - IFAC ONLY CATERED FOR IF ILA=N/IFAC
C
C-----------------------------------------------------------------------
C
      REAL A10(512),A11(512),
     *     A20(512),A21(512),
     *     B10(512),B11(512),B20(512),B21(512)
C
      SAVE SIN36, SIN72, QRT5, SIN60
C
      DATA SIN36/0.587785252292473/,SIN72/0.951056516295154/,
     *    QRT5/0.559016994374947/,SIN60/0.866025403784437/
C
      M=N/IFAC
      IINK=ILA*INC1
      JINK=ILA*INC2
      JUMP=(IFAC-1)*JINK
      KSTOP=(N-IFAC)/(2*IFAC)
C
      IBAD=1
      IF (ILOT.GT.512) GO TO 910
      IBASE=0
      JBASE=0
      IGO=IFAC-1
      IF (IGO.EQ.7) IGO=6
      IBAD=2
      IF (IGO.LT.1.OR.IGO.GT.6) GO TO 910
      GO TO (200,300,400,500,600,800),IGO
C
C     CODING FOR FACTOR 2
C     -------------------
  200 CONTINUE
      IA=1
      IB=IA+(2*M-ILA)*INC1
      JA=1
      JB=JA+JINK
C
      IF (ILA.EQ.M) GO TO 290
C
      DO 220 IL=1,ILA
      I=IBASE
      J=JBASE
CDIR$ IVDEP
*VOCL LOOP,NOVREC
      DO 210 IJK=1,ILOT
      C(JA+J)=A(IA+I)+A(IB+I)
      C(JB+J)=A(IA+I)-A(IB+I)
      I=I+INC3
      J=J+INC4
  210 CONTINUE
      IBASE=IBASE+INC1
      JBASE=JBASE+INC2
  220 CONTINUE
      IA=IA+IINK
      IINK=2*IINK
      IB=IB-IINK
      IBASE=0
      JBASE=JBASE+JUMP
      JUMP=2*JUMP+JINK
      IF (IA.EQ.IB) GO TO 260
      DO 250 K=ILA,KSTOP,ILA
      KB=K+K
      C1=TRIGS(KB+1)
      S1=TRIGS(KB+2)
      IBASE=0
      DO 240 IL=1,ILA
      I=IBASE
      J=JBASE
CDIR$ IVDEP
*VOCL LOOP,NOVREC
      DO 230 IJK=1,ILOT
      C(JA+J)=A(IA+I)+A(IB+I)
      D(JA+J)=B(IA+I)-B(IB+I)
      C(JB+J)=C1*(A(IA+I)-A(IB+I))-S1*(B(IA+I)+B(IB+I))
      D(JB+J)=S1*(A(IA+I)-A(IB+I))+C1*(B(IA+I)+B(IB+I))
      I=I+INC3
      J=J+INC4
  230 CONTINUE
      IBASE=IBASE+INC1
      JBASE=JBASE+INC2
  240 CONTINUE
      IA=IA+IINK
      IB=IB-IINK
      JBASE=JBASE+JUMP
  250 CONTINUE
      IF (IA.GT.IB) GO TO 900
  260 CONTINUE
      IBASE=0
      DO 280 IL=1,ILA
      I=IBASE
      J=JBASE
CDIR$ IVDEP
*VOCL LOOP,NOVREC
      DO 270 IJK=1,ILOT
      C(JA+J)=A(IA+I)
      C(JB+J)=-B(IA+I)
      I=I+INC3
      J=J+INC4
  270 CONTINUE
      IBASE=IBASE+INC1
      JBASE=JBASE+INC2
  280 CONTINUE
      GO TO 900
C
  290 CONTINUE
      DO 294 IL=1,ILA
      I=IBASE
      J=JBASE
CDIR$ IVDEP
*VOCL LOOP,NOVREC
      DO 292 IJK=1,ILOT
      C(JA+J)=2.0*(A(IA+I)+A(IB+I))
      C(JB+J)=2.0*(A(IA+I)-A(IB+I))
      I=I+INC3
      J=J+INC4
  292 CONTINUE
      IBASE=IBASE+INC1
      JBASE=JBASE+INC2
  294 CONTINUE
      GO TO 900
C
C     CODING FOR FACTOR 3
C     -------------------
  300 CONTINUE
      IA=1
      IB=IA+(2*M-ILA)*INC1
      IC=IB
      JA=1
      JB=JA+JINK
      JC=JB+JINK
C
      IF (ILA.EQ.M) GO TO 390
C
      DO 320 IL=1,ILA
      I=IBASE
      J=JBASE
CDIR$ IVDEP
*VOCL LOOP,NOVREC
      DO 310 IJK=1,ILOT
      C(JA+J)=A(IA+I)+A(IB+I)
      C(JB+J)=(A(IA+I)-0.5*A(IB+I))-(SIN60*(B(IB+I)))
      C(JC+J)=(A(IA+I)-0.5*A(IB+I))+(SIN60*(B(IB+I)))
      I=I+INC3
      J=J+INC4
  310 CONTINUE
      IBASE=IBASE+INC1
      JBASE=JBASE+INC2
  320 CONTINUE
      IA=IA+IINK
      IINK=2*IINK
      IB=IB+IINK
      IC=IC-IINK
      JBASE=JBASE+JUMP
      JUMP=2*JUMP+JINK
      IF (IA.EQ.IC) GO TO 360
      DO 350 K=ILA,KSTOP,ILA
      KB=K+K
      KC=KB+KB
      C1=TRIGS(KB+1)
      S1=TRIGS(KB+2)
      C2=TRIGS(KC+1)
      S2=TRIGS(KC+2)
      IBASE=0
      DO 340 IL=1,ILA
      I=IBASE
      J=JBASE
CDIR$ IVDEP
*VOCL LOOP,NOVREC
      DO 330 IJK=1,ILOT
      C(JA+J)=A(IA+I)+(A(IB+I)+A(IC+I))
      D(JA+J)=B(IA+I)+(B(IB+I)-B(IC+I))
      C(JB+J)=
     *    C1*((A(IA+I)-0.5*(A(IB+I)+A(IC+I)))-(SIN60*(B(IB+I)+B(IC+
     *  I))))
     *   -S1*((B(IA+I)-0.5*(B(IB+I)-B(IC+I)))+(SIN60*(A(IB+I)-A(IC+
     *  I))))
      D(JB+J)=
     *    S1*((A(IA+I)-0.5*(A(IB+I)+A(IC+I)))-(SIN60*(B(IB+I)+B(IC+
     *  I))))
     *   +C1*((B(IA+I)-0.5*(B(IB+I)-B(IC+I)))+(SIN60*(A(IB+I)-A(IC+
     *  I))))
      C(JC+J)=
     *    C2*((A(IA+I)-0.5*(A(IB+I)+A(IC+I)))+(SIN60*(B(IB+I)+B(IC+
     *  I))))
     *   -S2*((B(IA+I)-0.5*(B(IB+I)-B(IC+I)))-(SIN60*(A(IB+I)-A(IC+
     *  I))))
      D(JC+J)=
     *    S2*((A(IA+I)-0.5*(A(IB+I)+A(IC+I)))+(SIN60*(B(IB+I)+B(IC+
     *  I))))
     *   +C2*((B(IA+I)-0.5*(B(IB+I)-B(IC+I)))-(SIN60*(A(IB+I)-A(IC+
     *  I))))
      I=I+INC3
      J=J+INC4
  330 CONTINUE
      IBASE=IBASE+INC1
      JBASE=JBASE+INC2
  340 CONTINUE
      IA=IA+IINK
      IB=IB+IINK
      IC=IC-IINK
      JBASE=JBASE+JUMP
  350 CONTINUE
      IF (IA.GT.IC) GO TO 900
  360 CONTINUE
      IBASE=0
      DO 380 IL=1,ILA
      I=IBASE
      J=JBASE
CDIR$ IVDEP
*VOCL LOOP,NOVREC
      DO 370 IJK=1,ILOT
      C(JA+J)=A(IA+I)+A(IB+I)
      C(JB+J)=(0.5*A(IA+I)-A(IB+I))-(SIN60*B(IA+I))
      C(JC+J)=-(0.5*A(IA+I)-A(IB+I))-(SIN60*B(IA+I))
      I=I+INC3
      J=J+INC4
  370 CONTINUE
      IBASE=IBASE+INC1
      JBASE=JBASE+INC2
  380 CONTINUE
      GO TO 900
C
  390 CONTINUE
      SSIN60=2.0*SIN60
      DO 394 IL=1,ILA
      I=IBASE
      J=JBASE
CDIR$ IVDEP
*VOCL LOOP,NOVREC
      DO 392 IJK=1,ILOT
      C(JA+J)=2.0*(A(IA+I)+A(IB+I))
      C(JB+J)=(2.0*A(IA+I)-A(IB+I))-(SSIN60*B(IB+I))
      C(JC+J)=(2.0*A(IA+I)-A(IB+I))+(SSIN60*B(IB+I))
      I=I+INC3
      J=J+INC4
  392 CONTINUE
      IBASE=IBASE+INC1
      JBASE=JBASE+INC2
  394 CONTINUE
      GO TO 900
C
C     CODING FOR FACTOR 4
C     -------------------
  400 CONTINUE
      IA=1
      IB=IA+(2*M-ILA)*INC1
      IC=IB+2*M*INC1
      ID=IB
      JA=1
      JB=JA+JINK
      JC=JB+JINK
      JD=JC+JINK
C
      IF (ILA.EQ.M) GO TO 490
C
      DO 420 IL=1,ILA
      I=IBASE
      J=JBASE
CDIR$ IVDEP
*VOCL LOOP,NOVREC
      DO 410 IJK=1,ILOT
      C(JA+J)=(A(IA+I)+A(IC+I))+A(IB+I)
      C(JB+J)=(A(IA+I)-A(IC+I))-B(IB+I)
      C(JC+J)=(A(IA+I)+A(IC+I))-A(IB+I)
      C(JD+J)=(A(IA+I)-A(IC+I))+B(IB+I)
      I=I+INC3
      J=J+INC4
  410 CONTINUE
      IBASE=IBASE+INC1
      JBASE=JBASE+INC2
  420 CONTINUE
      IA=IA+IINK
      IINK=2*IINK
      IB=IB+IINK
      IC=IC-IINK
      ID=ID-IINK
      JBASE=JBASE+JUMP
      JUMP=2*JUMP+JINK
      IF (IB.EQ.IC) GO TO 460
      DO 450 K=ILA,KSTOP,ILA
      KB=K+K
      KC=KB+KB
      KD=KC+KB
      C1=TRIGS(KB+1)
      S1=TRIGS(KB+2)
      C2=TRIGS(KC+1)
      S2=TRIGS(KC+2)
      C3=TRIGS(KD+1)
      S3=TRIGS(KD+2)
      IBASE=0
      DO 440 IL=1,ILA
      I=IBASE
      J=JBASE
CDIR$ IVDEP
*VOCL LOOP,NOVREC
      DO 430 IJK=1,ILOT
      C(JA+J)=(A(IA+I)+A(IC+I))+(A(IB+I)+A(ID+I))
      D(JA+J)=(B(IA+I)-B(IC+I))+(B(IB+I)-B(ID+I))
      C(JC+J)=
     *    C2*((A(IA+I)+A(IC+I))-(A(IB+I)+A(ID+I)))
     *   -S2*((B(IA+I)-B(IC+I))-(B(IB+I)-B(ID+I)))
      D(JC+J)=
     *    S2*((A(IA+I)+A(IC+I))-(A(IB+I)+A(ID+I)))
     *   +C2*((B(IA+I)-B(IC+I))-(B(IB+I)-B(ID+I)))
      C(JB+J)=
     *    C1*((A(IA+I)-A(IC+I))-(B(IB+I)+B(ID+I)))
     *   -S1*((B(IA+I)+B(IC+I))+(A(IB+I)-A(ID+I)))
      D(JB+J)=
     *    S1*((A(IA+I)-A(IC+I))-(B(IB+I)+B(ID+I)))
     *   +C1*((B(IA+I)+B(IC+I))+(A(IB+I)-A(ID+I)))
      C(JD+J)=
     *    C3*((A(IA+I)-A(IC+I))+(B(IB+I)+B(ID+I)))
     *   -S3*((B(IA+I)+B(IC+I))-(A(IB+I)-A(ID+I)))
      D(JD+J)=
     *    S3*((A(IA+I)-A(IC+I))+(B(IB+I)+B(ID+I)))
     *   +C3*((B(IA+I)+B(IC+I))-(A(IB+I)-A(ID+I)))
      I=I+INC3
      J=J+INC4
  430 CONTINUE
      IBASE=IBASE+INC1
      JBASE=JBASE+INC2
  440 CONTINUE
      IA=IA+IINK
      IB=IB+IINK
      IC=IC-IINK
      ID=ID-IINK
      JBASE=JBASE+JUMP
  450 CONTINUE
      IF (IB.GT.IC) GO TO 900
  460 CONTINUE
      IBASE=0
      SIN45=SQRT(0.5)
      DO 480 IL=1,ILA
      I=IBASE
      J=JBASE
CDIR$ IVDEP
*VOCL LOOP,NOVREC
      DO 470 IJK=1,ILOT
      C(JA+J)=A(IA+I)+A(IB+I)
      C(JB+J)=SIN45*((A(IA+I)-A(IB+I))-(B(IA+I)+B(IB+I)))
      C(JC+J)=B(IB+I)-B(IA+I)
      C(JD+J)=-SIN45*((A(IA+I)-A(IB+I))+(B(IA+I)+B(IB+I)))
      I=I+INC3
      J=J+INC4
  470 CONTINUE
      IBASE=IBASE+INC1
      JBASE=JBASE+INC2
  480 CONTINUE
      GO TO 900
C
  490 CONTINUE
      DO 494 IL=1,ILA
      I=IBASE
      J=JBASE
CDIR$ IVDEP
*VOCL LOOP,NOVREC
      DO 492 IJK=1,ILOT
      C(JA+J)=2.0*((A(IA+I)+A(IC+I))+A(IB+I))
      C(JB+J)=2.0*((A(IA+I)-A(IC+I))-B(IB+I))
      C(JC+J)=2.0*((A(IA+I)+A(IC+I))-A(IB+I))
      C(JD+J)=2.0*((A(IA+I)-A(IC+I))+B(IB+I))
      I=I+INC3
      J=J+INC4
  492 CONTINUE
      IBASE=IBASE+INC1
      JBASE=JBASE+INC2
  494 CONTINUE
      GO TO 900
C
C     CODING FOR FACTOR 5
C     -------------------
  500 CONTINUE
      IA=1
      IB=IA+(2*M-ILA)*INC1
      IC=IB+2*M*INC1
      ID=IC
      IE=IB
      JA=1
      JB=JA+JINK
      JC=JB+JINK
      JD=JC+JINK
      JE=JD+JINK
C
      IF (ILA.EQ.M) GO TO 590
C
      DO 520 IL=1,ILA
      I=IBASE
      J=JBASE
CDIR$ IVDEP
*VOCL LOOP,NOVREC
      DO 510 IJK=1,ILOT
      C(JA+J)=A(IA+I)+(A(IB+I)+A(IC+I))
      C(JB+J)=((A(IA+I)-0.25*(A(IB+I)+A(IC+I)))+QRT5*(A(IB+I)-A(IC+
     *  I)))
     *    -(SIN72*B(IB+I)+SIN36*B(IC+I))
      C(JC+J)=((A(IA+I)-0.25*(A(IB+I)+A(IC+I)))-QRT5*(A(IB+I)-A(IC+
     *  I)))
     *    -(SIN36*B(IB+I)-SIN72*B(IC+I))
      C(JD+J)=((A(IA+I)-0.25*(A(IB+I)+A(IC+I)))-QRT5*(A(IB+I)-A(IC+
     *  I)))
     *    +(SIN36*B(IB+I)-SIN72*B(IC+I))
      C(JE+J)=((A(IA+I)-0.25*(A(IB+I)+A(IC+I)))+QRT5*(A(IB+I)-A(IC+
     *  I)))
     *    +(SIN72*B(IB+I)+SIN36*B(IC+I))
      I=I+INC3
      J=J+INC4
  510 CONTINUE
      IBASE=IBASE+INC1
      JBASE=JBASE+INC2
  520 CONTINUE
      IA=IA+IINK
      IINK=2*IINK
      IB=IB+IINK
      IC=IC+IINK
      ID=ID-IINK
      IE=IE-IINK
      JBASE=JBASE+JUMP
      JUMP=2*JUMP+JINK
      IF (IB.EQ.ID) GO TO 560
      DO 550 K=ILA,KSTOP,ILA
      KB=K+K
      KC=KB+KB
      KD=KC+KB
      KE=KD+KB
      C1=TRIGS(KB+1)
      S1=TRIGS(KB+2)
      C2=TRIGS(KC+1)
      S2=TRIGS(KC+2)
      C3=TRIGS(KD+1)
      S3=TRIGS(KD+2)
      C4=TRIGS(KE+1)
      S4=TRIGS(KE+2)
      IBASE=0
      DO 540 IL=1,ILA
      I=IBASE
      J=JBASE
CDIR$ IVDEP
*VOCL LOOP,NOVREC
      DO 530 IJK=1,ILOT
C
      A10(IJK)=(A(IA+I)-0.25*((A(IB+I)+A(IE+I))+(A(IC+I)+A(ID+I))))
     *    +QRT5*((A(IB+I)+A(IE+I))-(A(IC+I)+A(ID+I)))
      A20(IJK)=(A(IA+I)-0.25*((A(IB+I)+A(IE+I))+(A(IC+I)+A(ID+I))))
     *    -QRT5*((A(IB+I)+A(IE+I))-(A(IC+I)+A(ID+I)))
      B10(IJK)=(B(IA+I)-0.25*((B(IB+I)-B(IE+I))+(B(IC+I)-B(ID+I))))
     *    +QRT5*((B(IB+I)-B(IE+I))-(B(IC+I)-B(ID+I)))
      B20(IJK)=(B(IA+I)-0.25*((B(IB+I)-B(IE+I))+(B(IC+I)-B(ID+I))))
     *    -QRT5*((B(IB+I)-B(IE+I))-(B(IC+I)-B(ID+I)))
      A11(IJK)=SIN72*(B(IB+I)+B(IE+I))+SIN36*(B(IC+I)+B(ID+I))
      A21(IJK)=SIN36*(B(IB+I)+B(IE+I))-SIN72*(B(IC+I)+B(ID+I))
      B11(IJK)=SIN72*(A(IB+I)-A(IE+I))+SIN36*(A(IC+I)-A(ID+I))
      B21(IJK)=SIN36*(A(IB+I)-A(IE+I))-SIN72*(A(IC+I)-A(ID+I))
C
      C(JA+J)=A(IA+I)+((A(IB+I)+A(IE+I))+(A(IC+I)+A(ID+I)))
      D(JA+J)=B(IA+I)+((B(IB+I)-B(IE+I))+(B(IC+I)-B(ID+I)))
      C(JB+J)=C1*(A10(IJK)-A11(IJK))-S1*(B10(IJK)+B11(IJK))
      D(JB+J)=S1*(A10(IJK)-A11(IJK))+C1*(B10(IJK)+B11(IJK))
      C(JE+J)=C4*(A10(IJK)+A11(IJK))-S4*(B10(IJK)-B11(IJK))
      D(JE+J)=S4*(A10(IJK)+A11(IJK))+C4*(B10(IJK)-B11(IJK))
      C(JC+J)=C2*(A20(IJK)-A21(IJK))-S2*(B20(IJK)+B21(IJK))
      D(JC+J)=S2*(A20(IJK)-A21(IJK))+C2*(B20(IJK)+B21(IJK))
      C(JD+J)=C3*(A20(IJK)+A21(IJK))-S3*(B20(IJK)-B21(IJK))
      D(JD+J)=S3*(A20(IJK)+A21(IJK))+C3*(B20(IJK)-B21(IJK))
C
      I=I+INC3
      J=J+INC4
  530 CONTINUE
      IBASE=IBASE+INC1
      JBASE=JBASE+INC2
  540 CONTINUE
      IA=IA+IINK
      IB=IB+IINK
      IC=IC+IINK
      ID=ID-IINK
      IE=IE-IINK
      JBASE=JBASE+JUMP
  550 CONTINUE
      IF (IB.GT.ID) GO TO 900
  560 CONTINUE
      IBASE=0
      DO 580 IL=1,ILA
      I=IBASE
      J=JBASE
CDIR$ IVDEP
*VOCL LOOP,NOVREC
      DO 570 IJK=1,ILOT
      C(JA+J)=(A(IA+I)+A(IB+I))+A(IC+I)
      C(JB+J)=(QRT5*(A(IA+I)-A(IB+I))+(0.25*(A(IA+I)+A(IB+I))-A(IC+
     *  I)))
     *    -(SIN36*B(IA+I)+SIN72*B(IB+I))
      C(JE+J)=-(QRT5*(A(IA+I)-A(IB+I))+(0.25*(A(IA+I)+A(IB+I))-A(IC+
     *  I)))
     *    -(SIN36*B(IA+I)+SIN72*B(IB+I))
      C(JC+J)=(QRT5*(A(IA+I)-A(IB+I))-(0.25*(A(IA+I)+A(IB+I))-A(IC+
     *  I)))
     *    -(SIN72*B(IA+I)-SIN36*B(IB+I))
      C(JD+J)=-(QRT5*(A(IA+I)-A(IB+I))-(0.25*(A(IA+I)+A(IB+I))-A(IC+
     *  I)))
     *    -(SIN72*B(IA+I)-SIN36*B(IB+I))
      I=I+INC3
      J=J+INC4
  570 CONTINUE
      IBASE=IBASE+INC1
      JBASE=JBASE+INC2
  580 CONTINUE
      GO TO 900
C
  590 CONTINUE
      QQRT5=2.0*QRT5
      SSIN36=2.0*SIN36
      SSIN72=2.0*SIN72
      DO 594 IL=1,ILA
      I=IBASE
      J=JBASE
CDIR$ IVDEP
*VOCL LOOP,NOVREC
      DO 592 IJK=1,ILOT
      C(JA+J)=2.0*(A(IA+I)+(A(IB+I)+A(IC+I)))
      C(JB+J)=(2.0*(A(IA+I)-0.25*(A(IB+I)+A(IC+I)))
     *    +QQRT5*(A(IB+I)-A(IC+I)))-(SSIN72*B(IB+I)+SSIN36*B(IC+I))
      C(JC+J)=(2.0*(A(IA+I)-0.25*(A(IB+I)+A(IC+I)))
     *    -QQRT5*(A(IB+I)-A(IC+I)))-(SSIN36*B(IB+I)-SSIN72*B(IC+I))
      C(JD+J)=(2.0*(A(IA+I)-0.25*(A(IB+I)+A(IC+I)))
     *    -QQRT5*(A(IB+I)-A(IC+I)))+(SSIN36*B(IB+I)-SSIN72*B(IC+I))
      C(JE+J)=(2.0*(A(IA+I)-0.25*(A(IB+I)+A(IC+I)))
     *    +QQRT5*(A(IB+I)-A(IC+I)))+(SSIN72*B(IB+I)+SSIN36*B(IC+I))
      I=I+INC3
      J=J+INC4
  592 CONTINUE
      IBASE=IBASE+INC1
      JBASE=JBASE+INC2
  594 CONTINUE
      GO TO 900
C
C     CODING FOR FACTOR 6
C     -------------------
  600 CONTINUE
      IA=1
      IB=IA+(2*M-ILA)*INC1
      IC=IB+2*M*INC1
      ID=IC+2*M*INC1
      IE=IC
      IF=IB
      JA=1
      JB=JA+JINK
      JC=JB+JINK
      JD=JC+JINK
      JE=JD+JINK
      JF=JE+JINK
C
      IF (ILA.EQ.M) GO TO 690
C
      DO 620 IL=1,ILA
      I=IBASE
      J=JBASE
CDIR$ IVDEP
*VOCL LOOP,NOVREC
      DO 610 IJK=1,ILOT
      C(JA+J)=(A(IA+I)+A(ID+I))+(A(IB+I)+A(IC+I))
      C(JD+J)=(A(IA+I)-A(ID+I))-(A(IB+I)-A(IC+I))
      C(JB+J)=((A(IA+I)-A(ID+I))+0.5*(A(IB+I)-A(IC+I)))
     *    -(SIN60*(B(IB+I)+B(IC+I)))
      C(JF+J)=((A(IA+I)-A(ID+I))+0.5*(A(IB+I)-A(IC+I)))
     *    +(SIN60*(B(IB+I)+B(IC+I)))
      C(JC+J)=((A(IA+I)+A(ID+I))-0.5*(A(IB+I)+A(IC+I)))
     *    -(SIN60*(B(IB+I)-B(IC+I)))
      C(JE+J)=((A(IA+I)+A(ID+I))-0.5*(A(IB+I)+A(IC+I)))
     *    +(SIN60*(B(IB+I)-B(IC+I)))
      I=I+INC3
      J=J+INC4
  610 CONTINUE
      IBASE=IBASE+INC1
      JBASE=JBASE+INC2
  620 CONTINUE
      IA=IA+IINK
      IINK=2*IINK
      IB=IB+IINK
      IC=IC+IINK
      ID=ID-IINK
      IE=IE-IINK
      IF=IF-IINK
      JBASE=JBASE+JUMP
      JUMP=2*JUMP+JINK
      IF (IC.EQ.ID) GO TO 660
      DO 650 K=ILA,KSTOP,ILA
      KB=K+K
      KC=KB+KB
      KD=KC+KB
      KE=KD+KB
      KF=KE+KB
      C1=TRIGS(KB+1)
      S1=TRIGS(KB+2)
      C2=TRIGS(KC+1)
      S2=TRIGS(KC+2)
      C3=TRIGS(KD+1)
      S3=TRIGS(KD+2)
      C4=TRIGS(KE+1)
      S4=TRIGS(KE+2)
      C5=TRIGS(KF+1)
      S5=TRIGS(KF+2)
      IBASE=0
      DO 640 IL=1,ILA
      I=IBASE
      J=JBASE
CDIR$ IVDEP
*VOCL LOOP,NOVREC
      DO 630 IJK=1,ILOT
C
      A11(IJK)= (A(IE+I)+A(IB+I))+(A(IC+I)+A(IF+I))
      A20(IJK)=(A(IA+I)+A(ID+I))-0.5*A11(IJK)
      A21(IJK)=SIN60*((A(IE+I)+A(IB+I))-(A(IC+I)+A(IF+I)))
      B11(IJK)= (B(IB+I)-B(IE+I))+(B(IC+I)-B(IF+I))
      B20(IJK)=(B(IA+I)-B(ID+I))-0.5*B11(IJK)
      B21(IJK)=SIN60*((B(IB+I)-B(IE+I))-(B(IC+I)-B(IF+I)))
C
      C(JA+J)=(A(IA+I)+A(ID+I))+A11(IJK)
      D(JA+J)=(B(IA+I)-B(ID+I))+B11(IJK)
      C(JC+J)=C2*(A20(IJK)-B21(IJK))-S2*(B20(IJK)+A21(IJK))
      D(JC+J)=S2*(A20(IJK)-B21(IJK))+C2*(B20(IJK)+A21(IJK))
      C(JE+J)=C4*(A20(IJK)+B21(IJK))-S4*(B20(IJK)-A21(IJK))
      D(JE+J)=S4*(A20(IJK)+B21(IJK))+C4*(B20(IJK)-A21(IJK))
C
      A11(IJK)=(A(IE+I)-A(IB+I))+(A(IC+I)-A(IF+I))
      B11(IJK)=(B(IE+I)+B(IB+I))-(B(IC+I)+B(IF+I))
      A20(IJK)=(A(IA+I)-A(ID+I))-0.5*A11(IJK)
      A21(IJK)=SIN60*((A(IE+I)-A(IB+I))-(A(IC+I)-A(IF+I)))
      B20(IJK)=(B(IA+I)+B(ID+I))+0.5*B11(IJK)
      B21(IJK)=SIN60*((B(IE+I)+B(IB+I))+(B(IC+I)+B(IF+I)))
C
      C(JD+J)=
     *  C3*((A(IA+I)-A(ID+I))+A11(IJK))-S3*((B(IA+I)+B(ID+I))-B11(IJK))
      D(JD+J)=
     *  S3*((A(IA+I)-A(ID+I))+A11(IJK))+C3*((B(IA+I)+B(ID+I))-B11(IJK))
      C(JB+J)=C1*(A20(IJK)-B21(IJK))-S1*(B20(IJK)-A21(IJK))
      D(JB+J)=S1*(A20(IJK)-B21(IJK))+C1*(B20(IJK)-A21(IJK))
      C(JF+J)=C5*(A20(IJK)+B21(IJK))-S5*(B20(IJK)+A21(IJK))
      D(JF+J)=S5*(A20(IJK)+B21(IJK))+C5*(B20(IJK)+A21(IJK))
C
      I=I+INC3
      J=J+INC4
  630 CONTINUE
      IBASE=IBASE+INC1
      JBASE=JBASE+INC2
  640 CONTINUE
      IA=IA+IINK
      IB=IB+IINK
      IC=IC+IINK
      ID=ID-IINK
      IE=IE-IINK
      IF=IF-IINK
      JBASE=JBASE+JUMP
  650 CONTINUE
      IF (IC.GT.ID) GO TO 900
  660 CONTINUE
      IBASE=0
      DO 680 IL=1,ILA
      I=IBASE
      J=JBASE
CDIR$ IVDEP
*VOCL LOOP,NOVREC
      DO 670 IJK=1,ILOT
      C(JA+J)=A(IB+I)+(A(IA+I)+A(IC+I))
      C(JD+J)=B(IB+I)-(B(IA+I)+B(IC+I))
      C(JB+J)=(SIN60*(A(IA+I)-A(IC+I)))-(0.5*(B(IA+I)+B(IC+I))+B(IB+
     *  I))
      C(JF+J)=-(SIN60*(A(IA+I)-A(IC+I)))-(0.5*(B(IA+I)+B(IC+I))+B(IB+
     *  I))
      C(JC+J)=SIN60*(B(IC+I)-B(IA+I))+(0.5*(A(IA+I)+A(IC+I))-A(IB+I))
      C(JE+J)=SIN60*(B(IC+I)-B(IA+I))-(0.5*(A(IA+I)+A(IC+I))-A(IB+I))
      I=I+INC3
      J=J+INC4
  670 CONTINUE
      IBASE=IBASE+INC1
      JBASE=JBASE+INC2
  680 CONTINUE
      GO TO 900
C
  690 CONTINUE
      SSIN60=2.0*SIN60
      DO 694 IL=1,ILA
      I=IBASE
      J=JBASE
CDIR$ IVDEP
*VOCL LOOP,NOVREC
      DO 692 IJK=1,ILOT
      C(JA+J)=(2.0*(A(IA+I)+A(ID+I)))+(2.0*(A(IB+I)+A(IC+I)))
      C(JD+J)=(2.0*(A(IA+I)-A(ID+I)))-(2.0*(A(IB+I)-A(IC+I)))
      C(JB+J)=(2.0*(A(IA+I)-A(ID+I))+(A(IB+I)-A(IC+I)))
     *    -(SSIN60*(B(IB+I)+B(IC+I)))
      C(JF+J)=(2.0*(A(IA+I)-A(ID+I))+(A(IB+I)-A(IC+I)))
     *    +(SSIN60*(B(IB+I)+B(IC+I)))
      C(JC+J)=(2.0*(A(IA+I)+A(ID+I))-(A(IB+I)+A(IC+I)))
     *    -(SSIN60*(B(IB+I)-B(IC+I)))
      C(JE+J)=(2.0*(A(IA+I)+A(ID+I))-(A(IB+I)+A(IC+I)))
     *    +(SSIN60*(B(IB+I)-B(IC+I)))
      I=I+INC3
      J=J+INC4
  692 CONTINUE
      IBASE=IBASE+INC1
      JBASE=JBASE+INC2
  694 CONTINUE
      GO TO 900
C
C     CODING FOR FACTOR 8
C     -------------------
  800 CONTINUE
      IBAD=3
      IF (ILA.NE.M) GO TO 910
      IA=1
      IB=IA+ILA*INC1
      IC=IB+2*ILA*INC1
      ID=IC+2*ILA*INC1
      IE=ID+2*ILA*INC1
      JA=1
      JB=JA+JINK
      JC=JB+JINK
      JD=JC+JINK
      JE=JD+JINK
      JF=JE+JINK
      JG=JF+JINK
      JH=JG+JINK
      SSIN45=SQRT(2.0)
C
      DO 820 IL=1,ILA
      I=IBASE
      J=JBASE
CDIR$ IVDEP
*VOCL LOOP,NOVREC
      DO 810 IJK=1,ILOT
      C(JA+J)=2.0*(((A(IA+I)+A(IE+I))+A(IC+I))+(A(IB+I)+A(ID+I)))
      C(JE+J)=2.0*(((A(IA+I)+A(IE+I))+A(IC+I))-(A(IB+I)+A(ID+I)))
      C(JC+J)=2.0*(((A(IA+I)+A(IE+I))-A(IC+I))-(B(IB+I)-B(ID+I)))
      C(JG+J)=2.0*(((A(IA+I)+A(IE+I))-A(IC+I))+(B(IB+I)-B(ID+I)))
      C(JB+J)=2.0*((A(IA+I)-A(IE+I))-B(IC+I))
     *    +SSIN45*((A(IB+I)-A(ID+I))-(B(IB+I)+B(ID+I)))
      C(JF+J)=2.0*((A(IA+I)-A(IE+I))-B(IC+I))
     *    -SSIN45*((A(IB+I)-A(ID+I))-(B(IB+I)+B(ID+I)))
      C(JD+J)=2.0*((A(IA+I)-A(IE+I))+B(IC+I))
     *    -SSIN45*((A(IB+I)-A(ID+I))+(B(IB+I)+B(ID+I)))
      C(JH+J)=2.0*((A(IA+I)-A(IE+I))+B(IC+I))
     *    +SSIN45*((A(IB+I)-A(ID+I))+(B(IB+I)+B(ID+I)))
      I=I+INC3
      J=J+INC4
  810 CONTINUE
      IBASE=IBASE+INC1
      JBASE=JBASE+INC2
  820 CONTINUE
C
C     RETURN
C     ------
  900 CONTINUE
      IBAD=0
  910 CONTINUE
      IERR=IBAD
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities
C granted to it by virtue of its status as an intergovernmental organisation
C nor does it submit to any jurisdiction.
C

      SUBROUTINE JMVUGG(PZFA, KNORTH, KSOUTH, PWEST, KGNUM, KSTART,
     X                  KDIFF, KROWS, KCOLS, KLON, KJPWR, KOFSET, POUTF)
C
C---->
C**** JMVUGG
C
C     Purpose
C     _______
C
C     This routine moves gaussian grid point data from array PZFA to
C     array POUTF. It handles the case when the number of latitudes
C     is different in the two hemispheres.
C
C
C     Interface
C     _________
C
C     CALL JMVUGG(PZFA, KNORTH, KSOUTH, PWEST, KGNUM, KSTART,
C    X            KDIFF, KROWS, KCOLS, KLON, KJPWR, KOFSET, POUTF)
C
C
C     Input parameters
C     ________________
C
C     PZFA      -  Input array of grid points arranged in pairs of
C                  north and south latitude bands
C     KNORTH    -  Northernmost latitude row number for field in POUTF
C     KSOUTH    -  Southernmost latitude row number for field in POUTF
C     PWEST     -  Westernmost longitude for field in POUTF (degrees)
C     KGNUM     -  Gaussian number for field in POUTF
C     KSTART    -  Current first latitude number in PZFA
C     KDIFF     -  Offset to  first latitude row in PZFA for moving
C     KROWS     -  Number of latitude rows to store
C     KCOLS     -  Number of longitude points to store from latitude
C     KLON      -  Number of longitude points in generated latitude row
C     KJPWR     -  Multiplication factor applied to ensure that number
C                  of longitude points > twice*spherical truncation
C     KOFSET    -  Array of offsets for start of each latitude row in
C                  the output array
C
C
C     Output parameters
C     ________________
C
C     POUTF      - Output array of grid points
C
C
C     Common block usage
C     __________________
C
C     JDCNDBG
C
C
C     Method
C     ______
C
C     Moves latitude rows of points from PZFA into the correct
C     geographical positions in POUTF.  POUTF may already be
C     partially full.  The distribution is not symmetrical north-south.
C
C
C     Externals
C     _________
C
C     JMOVGG    - Move points of symmetric grid to array
C     INTLOG   - Logs messages
C     INTLOGR  - Logs messages with real value.
C
C
C     Reference
C     _________
C
C     E.C.M.W.F. Research Department technical memorandum no. 56
C                "The forecast and analysis post-processing package"
C                May 1982. J.Haseler.
C
C
C     Comments
C     ________
C
C     For calculation purposes, the number of longitude points
C     has to be greater than 2*(output truncation) to ensure that the
C     fourier transform is exact (see Reference, page 10).
C     Parameter JPLONO is set to 860 to ensure that PZFA will have
C     enough slots for the KLON points for all values of regular
C     grid intervals from N1 to N720.
C
C     When filling the output array POUTF, the longitude points have
C     have to be taken selectively to avoid the intermediate generated
C     points, picking up values only at the required longitudes.  The
C     magnification factor is KJPWR (a power of 2).
C
C     PZFA has values stored:
C       North lat1:  x, 1, x, 2, x, 3, x, ... , KLON, ...
C       South lat1:  x, 1, x, 2, x, 3, x, ... , KLON, ...
C       North lat2:  x, 1, x, 2, x, 3, x, ... , KLON, ...
C       South lat2:  x, 1, x, 2, x, 3, x, ... , KLON, ...
C       ... for KROWS latitudes.
C
C     The 'x' represents the extra values generated because of the
C     need for the number of points along a latitude line to be more
C     than twice the truncation of the spherical harmonics.
C
C
C     Author
C     ______
C
C     J.D.Chambers      ECMWF      Jan 1994
C
C
C     Modifications
C     _____________
C
C     None
C
C----<
C
      IMPLICIT NONE
C     _______________________________________________________
C
C
#include "jparams.h"
#include "parim.h"
C
C     Subroutine arguments
      INTEGER KNORTH, KSOUTH, KGNUM, KSTART, KDIFF, POUTF
      INTEGER KROWS, KCOLS, KLON, KJPWR, KOFSET
      DIMENSION KOFSET(*)
      REAL PZFA, PWEST
      DIMENSION PZFA( JPLONO+2, 64), POUTF(*)
C
C     Parameters
      INTEGER JPROUTINE
      PARAMETER( JPROUTINE = 32000 )
C
C     Local variables
      INTEGER INROWS, NROWS, NFLAG
      INTEGER LATEST
      INTEGER NTOP, NBASE
C
C     _______________________________________________________
C
C*    Section 1. Initialization.
C     _______________________________________________________
C
  100 CONTINUE
C
      IF ( NDBG .GT. 1) THEN
        CALL INTLOG(JP_DEBUG,'JMVUGG - Input parameters:',JPQUIET)
        CALL INTLOG(JP_DEBUG,
     X    'JMVUGG - Northern latitude for output = ', KNORTH)
        CALL INTLOG(JP_DEBUG,
     X    'JMVUGG - Southern latitude for output = ', KSOUTH)
        CALL INTLOGR(JP_DEBUG,
     X    'JMVUGG - Western longitude for output = ', PWEST)
        CALL INTLOG(JP_DEBUG,
     X    'JMVUGG - Gaussian number for field = ', KGNUM)
        CALL INTLOG(JP_DEBUG,
     X    'JMVUGG - First latitude for moving = ', KSTART)
        CALL INTLOG(JP_DEBUG,
     X    'JMVUGG - Offset to first lat. for moving = ', KDIFF)
        CALL INTLOG(JP_DEBUG,
     X    'JMVUGG - Number of latitudes to store = ', KROWS)
        CALL INTLOG(JP_DEBUG,
     X    'JMVUGG - Number of longitude pts per row = ', KCOLS)
        CALL INTLOG(JP_DEBUG,
     X    'JMVUGG - No. long.pts per generated row = ', KLON)
        CALL INTLOG(JP_DEBUG,
     X    'JMVUGG - Multiplication factor applied = ', KJPWR)
        CALL INTLOG(JP_DEBUG,
     X    'JMVUGG - Offsets(20) of each lat. in output array:',JPQUIET)
C
        DO 101 NDBGLP = 1, 20
          CALL INTLOG(JP_DEBUG,' ',KOFSET(NDBGLP))
  101   CONTINUE
      ENDIF
C
      LATEST = 1
      NTOP   = KSTART + KDIFF
      NBASE  = KSTART + (KROWS - 1)
      INROWS = KROWS
      NROWS  = INROWS
C
      IF ( NDBG .GT. 1) THEN
        CALL INTLOG(JP_DEBUG,
     X    'JMVUGG - Current northernmost lat = ', NTOP)
        CALL INTLOG(JP_DEBUG,
     X    'JMVUGG - Current southernmost lat = ', NBASE)
      ENDIF
C     _______________________________________________________
C
C*    Section 2. Processing more North than South, or more South
C                than North.
C     _______________________________________________________
C
  200 CONTINUE
C
C     See if overall there are more rows in Northern Hemisphere than
C     Southern
      IF ( KNORTH .LE. (2*KGNUM - KSOUTH) ) THEN
C
        IF ( NDBG .GT. 1) CALL INTLOG(JP_DEBUG,
     X    'JMVUGG - More rows in North Hemis. than South',JPQUIET)
C
C       Yes, so see if there are any rows in the current batch for the
C       south as well as the north
        IF ( NBASE .LT. (2*KGNUM - KSOUTH) ) THEN
C
C         None for south in current batch, move all rows to north.
          NFLAG = 1
C
          IF ( NDBG .GT. 1) CALL INTLOG(JP_DEBUG,
     X      'JMVUGG - No rows for S, move rows to N = ', NROWS)
C
          CALL JMOVGG( PZFA, PWEST, KGNUM, KSTART, NROWS, KCOLS,
     X                 KLON, KJPWR, KOFSET, POUTF, NFLAG)
        ELSE
C
C         Some for south.
C
C         Move rows for north only first.
          IF ( (2*KGNUM-KSOUTH) .GT. (NTOP-1) ) THEN
            NROWS = (2*KGNUM-KSOUTH) - NTOP + 1
            NFLAG = 1
C
            IF ( NDBG .GT. 1) CALL INTLOG(JP_DEBUG,
     X        'JMVUGG - Move North rows only first = ', NROWS)
C
            CALL JMOVGG( PZFA, PWEST, KGNUM, KSTART, NROWS, KCOLS,
     X                   KLON, KJPWR, KOFSET, POUTF, NFLAG)
            NTOP   = KSTART + NROWS
            LATEST = LATEST + (2 * NROWS)
            NROWS  = INROWS - NROWS
          ENDIF
C
C         Then move rows for both.
          IF ( NROWS .GT. 0 ) THEN
            NFLAG = 3
C
            IF ( NDBG .GT. 1) CALL INTLOG(JP_DEBUG,
     X        'JMVUGG - Move common lat.(N & S) = ', NROWS)
C
            CALL JMOVGG( PZFA( 1, LATEST), PWEST, KGNUM, NTOP,
     X                   NROWS, KCOLS, KLON, KJPWR, KOFSET, POUTF,NFLAG)
          ENDIF
        ENDIF
C
C     Overall there are more rows in Southern Hemisphere than Northern
      ELSE
C
            IF ( NDBG .GT. 1) CALL INTLOG(JP_DEBUG,
     X        'JMVUGG - More rows in South Hemis. than North',JPQUIET)
C
C
C       So see if there are any rows in the current batch for the
C       north as well as the south
        IF ( NBASE .LT. KNORTH ) THEN
C
C         None for north in current batch, move all rows to south.
          NFLAG = 2
C
          IF ( NDBG .GT. 1) CALL INTLOG(JP_DEBUG,
     X      'JMVUGG - No rows for N, move rows to S = ', NROWS)
C
          CALL JMOVGG( PZFA, PWEST, KGNUM, KSTART, NROWS, KCOLS,
     X                 KLON, KJPWR, KOFSET, POUTF, NFLAG)
        ELSE
C
C         Some for north.  Move rows for south only first.
          NROWS = KNORTH - NTOP + KDIFF
          IF ( NROWS .GT. 0 ) THEN
C
            IF ( NDBG .GT. 1) CALL INTLOG(JP_DEBUG,
     X        'JMVUGG - Move South rows only first = ', NROWS)
C
            NFLAG = 2
            CALL JMOVGG( PZFA, PWEST, KGNUM, KSTART, NROWS, KCOLS,
     X                   KLON, KJPWR, KOFSET, POUTF, NFLAG)
            LATEST = LATEST + (2 * NROWS)
            NROWS = INROWS - NROWS
          ELSE
            NROWS = INROWS
          ENDIF
C
C         Then move rows for both.
          NFLAG = 3
          IF ( NROWS .GT. 0 ) THEN
C
            IF ( NDBG .GT. 1) CALL INTLOG(JP_DEBUG,
     X        'JMVUGG - Move common lats(N & S) = ', NROWS)
C
            CALL JMOVGG( PZFA( 1, LATEST), PWEST, KGNUM, NTOP,
     X                   NROWS, KCOLS, KLON, KJPWR, KOFSET, POUTF,NFLAG)
          ENDIF
        ENDIF
      ENDIF
C     _______________________________________________________
C
C
C*    Section 9. Return to calling routine. Format statements
C     _______________________________________________________
C
  900 CONTINUE
C
C
      RETURN
      END

C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      INTEGER FUNCTION GETTRU()
C
C---->
C*****GETTRU*
C
C     PURPOSE
C     -------
C
C      Finding Corresponding Truncation 
C
#include "parim.h"
#include "nofld.common"

      GETTRU = NORESO

        CALL INTLOG(JP_DEBUG,
     X 'GETTRU: Corresponding Truncation',GETTRU)
C
      RETURN
      END

      PROGRAM BUFRNT1
C
C**** *BUFRNT1*
C
C
C     PURPOSE.
C     --------
C         REPACKS BUFR MULTISUBSET DATA INTO SINGLE BUFR
C         MESSAGES AND  APPROPRIATE RDB KEY.
C
C
C**   INTERFACE.
C     ----------
C
C          NONE.
C
C     METHOD.
C     -------
C
C          NONE.
C
C
C     EXTERNALS.
C     ----------
C
C         CALL BUSEL
C         CALL BUFREX
C         CALL BUFREN
C         CALL BUPRS0
C         CALL BUPRS1
C         CALL BUPRS2
C         CALL BUPRS3
C         CALL BUPRT
C         CALL BUUKEY
C
C     REFERENCE.
C     ----------
C
C          NONE.
C
C     AUTHOR.
C     -------
C
C          M. DRAGOSAVAC    *ECMWF*       15/02/95.
C
C
C     MODIFICATIONS.
C     --------------
C
C          NONE.
C
C
      IMPLICIT LOGICAL(L,O,G), CHARACTER*8(C,H,Y)
C
      PARAMETER(JSUP =   9,JSEC0=   3,JSEC1= 40,JSEC2=4096 ,JSEC3= 4,
     1       JSEC4=   2,JELEM=160000,JSUBS=400,JCVAL=150 ,JBUFL=512000,
#ifdef JBPW_64
     2       JBPW =  64,JTAB =3000,JCTAB=120,JCTST=1800,JCTEXT=1200,
#else
     2       JBPW =  32,JTAB =3000,JCTAB=120,JCTST=1800,JCTEXT=1200,
#endif
     3       JWORK=4096000,JKEY=46,JBYTE=512000)
C
      PARAMETER (KELEM=160000)
      PARAMETER (KVALS=4096000)
C 
      DIMENSION KBUFF(JBUFL)
      DIMENSION KBUFR(JBUFL)
      DIMENSION KSUP(JSUP)  ,KSEC0(JSEC0),KSEC1(JSEC1)
      DIMENSION KSEC2(JSEC2),KSEC3(JSEC3),KSEC4(JSEC4)
      DIMENSION KEY  (JKEY),KREQ(2)
C
      REAL*8 VALUES(KVALS),VALUE(KVALS),RQV(KELEM)
      REAL*8 RVIND,EPS
      DIMENSION KTDLST(KELEM),KTDEXP(KELEM),KRQ(KELEM)
      DIMENSION KDATA(200)
      DIMENSION IOUT(128000)
C
      CHARACTER*256 CF(100),COUT,CFIN
      CHARACTER*64 CNAMES(KELEM)
      CHARACTER*24 CUNITS(KELEM)
      CHARACTER*80 CVALS(KVALS)
      CHARACTER*80 YENC
      CHARACTER*256 CARG(10)
C
cs      EXTERNAL GETARG
C                                                                       
C     ------------------------------------------------------------------
C*          1. INITIALIZE CONSTANTS AND VARIABLES.
C              -----------------------------------
 100  CONTINUE
C
C     MISSING VALUE INDICATOR
C 
      KERR=0
      ITLEN=128000
      ITL=0
      JZ=0
      NBYTES=JBPW/8
      RVIND=1.7E38
      NVIND=2147483647
      IOBS=0
      KRQL=0
      NR=0
      KREQ(1)=0
      KREQ(2)=0
      DO 102 I=1,KELEM
      RQV(I)=RVIND
      KRQ(I)=NVIND
 102  CONTINUE
C
C     INPUT FILE NAMES
C
      NARG=IARGC()
      IF(NARG.LT.4) THEN
         PRINT*,'USAGE -- bufr_nt1 -i infiles -o outfile'
         STOP
      END IF
      NFILE=NARG
C
      DO 104 J=1,NARG
      CALL GETARG(J,CARG(J))
 104  CONTINUE

      II=0
      IO=0
      DO 105 J=1,NARG
      IF(CARG(J).EQ.'-i') THEN
         IN=J
      ELSEIF(CARG(J).EQ.'-o') THEN
         IO=J
      END IF
 105  CONTINUE
      IF(IO.EQ.0.OR.IN.EQ.0) THEN
          PRINT*,'USAGE -- bufr_nt1 -i infiles -o outfile'
          STOP
      END IF
C
      COUT=CARG(IO+1)
C
      IF(IO.LT.IN) THEN
         IST=IN+1
         IEND=NARG
      ELSE
         IST=IN+1
         IEND=IO-1
      END IF
C
      JJ=INDEX(COUT,' ')
C
      CALL PBOPEN(IUNIT1,COUT(1:JJ),'W',IRET)
      IF(IRET.EQ.-1) STOP 'OPEN FAILED ON BUFR.DAT'
      IF(IRET.EQ.-2) STOP 'INVALID FILE NAME'
      IF(IRET.EQ.-3) STOP 'INVALID OPEN MODE SPECIFIED'
C
      DO 101 II=IST,IEND
      CFIN=CARG(II) 
      ILN=INDEX(CFIN,' ')
C
C*          1.2 OPEN FILE CONTAINING BUFR DATA.
C               -------------------------------
 120  CONTINUE
C
      IRET=0 
      CALL PBOPEN(IUNIT,CFIN(1:ILN),'R',IRET)
      IF(IRET.EQ.-1) STOP 'OPEN FAILED'
      IF(IRET.EQ.-2) STOP 'INVALID FILE NAME'
      IF(IRET.EQ.-3) STOP 'INVALID OPEN MODE SPECIFIED'
C
C     ----------------------------------------------------------------- 
C*          2. SET REQUEST FOR EXPANSION.
C              --------------------------
 200  CONTINUE
C
      OPRT=.FALSE.
      OENC=.TRUE.
      NCOM=1
      OCOMP=.FALSE.
      NR=1
      OSEC3=.FALSE.
C
C*          2.1 SET REQUEST FOR PARTIAL EXPANSION.
C               ----------------------------------
 210  CONTINUE
C
C     SET VARIABLE TO PACK BIG VALUES AS MISSING VALUE INDICATOR
C
C      KPMISS=1
C      KPRUS=0
C      CALL BUPRQ(KPMISS,KPRUS)
C
C     -----------------------------------------------------------------
C*          3.  READ BUFR MESSAGE.
C               ------------------
 300  CONTINUE
C
      IERR=0
      KBUFL=0
C
      IRET=0
      CALL PBBUFR(IUNIT,KBUFF,JBYTE,KBUFL,IRET) 
      IF(IRET.EQ.-1) THEN
          GO TO 900
      END IF
      IF(IRET.EQ.-2) STOP 'FILE HANDLING PROBLEM' 
      IF(IRET.EQ.-3) STOP 'ARRAY TOO SMALL FOR PRODUCT'
C
      N=N+1
      KBUFL=KBUFL/NBYTES+1
      IF(N.LT.NR) GO TO 300
C
C     -----------------------------------------------------------------
C*          4. EXPAND BUFR MESSAGE.
C              --------------------
 400  CONTINUE
C
      CALL BUS012(KBUFL,KBUFF,KSUP,KSEC0,KSEC1,KSEC2,KERR)
      IF(KERR.NE.0) THEN
         PRINT*,'ERROR IN BUS012: ',KERR
         PRINT*,' BUFR MESSAGE NUMBER ',N,' CORRUPTED.'
         KERR=0
         GO TO 300
      END IF
C
      IF(KSUP(6).GT.1) THEN
         KEL=KVALS/KSUP(6)
         IF(KEL.GT.KELEM) KEL=KELEM
C
         CALL BUFREX(KBUFL,KBUFF,KSUP,KSEC0 ,KSEC1,KSEC2 ,KSEC3 ,KSEC4,
     1            KEL,CNAMES,CUNITS,KVALS,VALUES,CVALS,IERR)
      ELSE 
         ITL=ITL+KBUFL
         IF(ITL.GT.ITLEN) THEN
            ITL=ITL-KBUFL
            ITL=ITL*NBYTES
            IERR=0
            CALL PBWRITE(IUNIT1,IOUT,ITL,IERR)
            IF(IERR.LT.0) THEN
               PRINT*,'ERROR WRITING INTO TARGET FILE.'
               CALL MY_EXIT(2)
            END IF
            JZ=0
            ITL=0
            ITL=ITL+KBUFL
            DO 432 IZ=1,KBUFL
            JZ=JZ+1
            IOUT(JZ)=KBUFF(IZ)
 432        CONTINUE

         ELSE
            DO 431 IZ=1,KBUFL
            JZ=JZ+1
            IOUT(JZ)=KBUFF(IZ)
 431        CONTINUE
C
         END IF
         GO TO 300
 
      END IF
C
      IF(IERR.NE.0) THEN
         IF(IERR.EQ.45) GO TO 300
         CALL MY_EXIT(2)
      END IF
C
      IOBS=IOBS+KSEC3(3)
C
      CALL BUSEL(KTDLEN,KTDLST,KTDEXL,KTDEXP,KERR)
      IF(KERR.NE.0) CALL MY_EXIT(2)
C
C*          4.1 PRINT CONTENT OF EXPANDED DATA.
C               -------------------------------
 410  CONTINUE
C
      IF(.NOT.OPRT) GO TO 500
      IF(.NOT.OSEC3) GO TO 450
C
C*          4.2 PRINT SECTION ZERO OF BUFR MESSAGE.
C               -----------------------------------
 420  CONTINUE
C

      CALL BUPRS0(KSEC0)
C
C*          4.3 PRINT SECTION ONE OF BUFR MESSAGE.
C               -----------------------------------
 430  CONTINUE
C
      CALL BUPRS1(KSEC1)
C
C
C*          4.4 PRINT SECTION TWO OF BUFR MESSAGE.
C               -----------------------------------
 440  CONTINUE
C
C              AT ECMWF SECTION 2 CONTAINS RDB KEY.
C              SO UNPACK KEY
C
      CALL BUUKEY(KSEC1,KSEC2,KEY,KSUP,KERR)
C
C              PRINT KEY
C
      CALL BUPRS2(KSUP ,KEY)
C
C*          4.5 PRINT SECTION 3 OF BUFR MESSAGE.
C               -----------------------------------
 450  CONTINUE
C
C               FIRST GET DATA DESCRIPTORS
C
      CALL BUSEL(KTDLEN,KTDLST,KTDEXL,KTDEXP,KERR)
      IF(KERR.NE.0) CALL MY_EXIT(2)
C
C               PRINT  CONTENT
C
      IF(OSEC3) THEN
         CALL BUPRS3(KSEC3,KTDLEN,KTDLST,KTDEXL,KTDEXP,KEL,CNAMES)
      END IF
C
C*         4.6 PRINT SECTION 4 (DATA).
C              -----------------------
 460  CONTINUE
C
C          IN THE CASE OF MANY SUBSETS DEFINE RANGE OF SUBSETS
C
      IF(.NOT.OO) THEN
      WRITE(*,'(A,$)') ' STARTING SUBSET TO BE PRINTED : '
      READ(*,'(BN,I4)')   IST
      WRITE(*,'(A,$)') ' ENDING SUBSET TO BE PRINTED : '
      READ(*,'(BN,I4)')   IEND
      OO=.FALSE.
      END IF
C
C              PRINT DATA
C
      ICODE=0
      CALL BUPRT(ICODE,IST,IEND,KEL,CNAMES,CUNITS,CVALS,
     1           KVALS,VALUES,KSUP,KSEC1,IERR)
C
C              RESOLVE BIT MAPS 
C
      IF(IEND.GT.KSEC3(3)) IEND=KSEC3(3)
C
      DO 461 IK=IST,IEND
C 
      CALL BUBOX(IK,KSUP,KEL,KTDEXP,CNAMES,CUNITS,KVALS,VALUES,
     1           KBOX,KAPP,KLEN,KBOXR,VALS,CBOXN,CBOXU,IERR)
C
      CALL BUPRTBOX(KBOX,KAPP,KLEN,KBOXR,VALS,CBOXN,CBOXU)
C
 461  CONTINUE
C
C     -----------------------------------------------------------------
C*          5. COLLECT DATA FOR REPACKING.
C              ---------------------------
 500  CONTINUE
C      
      IF(.NOT.OENC) GO TO 300
C
C               FIRST GET DATA DESCRIPTORS
C
      CALL BUSEL(KTDLEN,KTDLST,KTDEXL,KTDEXP,KERR)
      IF(KERR.NE.0) CALL MY_EXIT(2)
C
C     -----------------------------------------------------------------
C*          6. PACK BUFR MESSAGE BACK INTO BUFR.
C              ---------------------------------
 600  CONTINUE
C
    
      KKK=0
      KSEC3(3)=1              ! ONE SUBSET
C     KSEC1(8)=1
C      KSEC1(15)=2
      KSEC3(4)=128            ! NO COMPRESSION
      KBUFL=JBUFL
C
C     GET REPLICATION FACTORS
C
      KK=0
      DO 601 K=1,KSUP(5)
      IF(KTDEXP(K).EQ.31001.OR.KTDEXP(K).EQ.31002) THEN
         KK=KK+1
         KDATA(KK)=NINT(VALUES(K))
      END IF
 601  CONTINUE
C
      KDLEN=2
      IF(KK.NE.0) KDLEN=KK
C
C*          6.2 ENCODE DATA INTO BUFR MESSAGE.
C               ------------------------------
 620  CONTINUE
C
      IF(KSUP(6).EQ.0) THEN
         PRINT*,'ZERO SUBSETS'
         CALL MY_EXIT(2)
      END IF
C
      DO 621 IX=1,KSUP(6)
      DO 622 IY=1,KSUP(5)
      IZ=IY+(IX-1)*KEL
      VALUE(IY)=VALUES(IZ)
622   CONTINUE
C
C     REPACKING MULTISUBSET DATA ONE BY ONE
C
      IF(IAND(KSEC1(5),128).NE.0) THEN
         CALL BUUKEY(KSEC1,KSEC2,KEY,KSUP,KERR)
         IF(KERR.NE.0) THEN
            PRINT*,'BUUKEY: ERROR'
            CALL MY_EXIT(2)
         END IF

C
C        GET INFORMATION FOR RDB KEY
C
         CALL BUCRKEY(KEL,KTDEXP,KSUP,KSEC1,KSEC3,KEY,
     1                VALUE,CVALS,KERR)
         IF(KERR.NE.0) THEN
            PRINT*,'BUCRKEY: ERROR ',KERR
            KERR=0
            GO TO 621
         END IF
C
C        PACK NEW RDB KEY
C
      
         CALL BUPKEY(KEY,KSEC1,KSEC2,KERR)
         IF(KERR.NE.0) THEN
            PRINT*,'BUPKEY:ERROR'
            CALL MY_EXIT(2)
         END IF
      END IF
C
      CALL BUFREN( KSEC0,KSEC1,KSEC2,KSEC3,KSEC4,
     1             KTDLEN,KTDLST,KDLEN,KDATA,KEL,        !KSUP(5),
     2             KVALS,VALUE,CVALS,KBUFL,KBUFR,KERR)
C
      IF(KERR.NE.0) THEN
         PRINT*,'ERROR DURING ENCODING.'
         CALL MY_EXIT(2)
      END IF
C
C           6.3 WRITE PACKED BUFR MESSAGE INTO FILE.
C               ------------------------------------
 630  CONTINUE
C
      ITL=ITL+KBUFL
      IF(ITL.GT.ITLEN) THEN
         ITL=ITL-KBUFL
         ITL=ITL*NBYTES
         IERR=0
         CALL PBWRITE(IUNIT1,IOUT,ITL,IERR)
         IF(IERR.LT.0) THEN
            PRINT*,'ERROR WRITING INTO TARGET FILE.'
            CALL MY_EXIT(2)
         END IF
         JZ=0
         ITL=0
         ITL=ITL+KBUFL
         DO 632 IZ=1,KBUFL
         JZ=JZ+1
         IOUT(JZ)=KBUFR(IZ)
 632     CONTINUE
      ELSE
         DO 631 IZ=1,KBUFL
         JZ=JZ+1
         IOUT(JZ)=KBUFR(IZ)
 631     CONTINUE
C
      END IF

 621  CONTINUE
C
      GO TO 300
C     -----------------------------------------------------------------
C
 810  CONTINUE
C
      WRITE(*,'(1H ,A)') 'OPEN ERROR ON INPUT FILE'
      GO TO 900
C      
 800  CONTINUE
C
      IF(IRET.EQ.-1) THEN
         PRINT*,'NUMBER OF RECORDS PROCESSED ',N
      ELSE
         PRINT*,' BUFR : ERROR= ',IERR
      END IF
C
 900  CONTINUE
C
      CALL PBCLOSE(IUNIT,IRET)
 101  CONTINUE
C
      ITL=ITL*NBYTES
      IERR=0
      CALL PBWRITE(IUNIT1,IOUT,ITL,IERR)
      IF(IERR.LT.0) THEN
         PRINT*,'ERROR WRITING INTO TARGET FILE.'
         CALL MY_EXIT(2)
      END IF
      CALL PBCLOSE(IUNIT1,IRET)
C
      END

C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

#if (defined IBM_POWER4)
@PROCESS ALIAS(NOPTEOVRLP)
#endif
      INTEGER FUNCTION CSECT4( PDATA, KTRUNC, KSEC1, KSEC4,
     X                         KGRIB, KLENG, KNSPT, KBITS, KPACK)
C
C---->
C**** CSECT4
C
C     Purpose.
C     --------
C
C     Code GRIB section 4 for complex packing of spherical harmonics.
C
C
C**   Interface.
C     ----------
C
C     KRET = CSECT4( PDATA, KTRUNC, KSEC1, KSEC4,
C    X               KGRIB, KLENG, KNSPT, KBITS, KPACK)
C
C
C     Input Parameters.
C     -----------------
C
C     PDATA      - Array of floating point values.
C     KTRUNC     - Truncation of the spherical harmonic coefficients.
C     KSEC1      - Array of GRIB section 1 values
C     KSEC4      - Array of GRIB section 4 values
C     KLENG      - Length of GRIB product array
C     KNSPT      - Bit pointer for next value in GRIB product
C     KBITS      - Number of bits per computer word.
C     KPACK      - Number of bits per packed value.
C
C
C     Output Parameters.
C     -----------------
C
C     KGRIB      - Array containing GRIB product.
C     KNSPT      - Bit pointer for next value in GRIB product(updated)
C
C
C     Method.
C     -------
C
C                            <subset>|
C
C     Given numbers:         cccccccc|cccccc
C                              cccccc|cccccc
C                                cccc|cccccc
C                                  cc|cccccc
C                                    |cccccc
C                                       cccc
C                                         cc
C
C
C     Externals.
C     ----------
C
C     GSCALE    - Apply power sclaing to values to be packed.
C     PACKCF    - Store unscaled coefficients in GRIB product.
C     CMPCK     - Make the values to be packed contiguous in memory.
C     MAXMIN    - Find max/min values of array.
C     INXBIT    - Insert bits into GRIB product.
C     REF2GRB   - Convert reference value to IBM floating point format.
C     CONFP3    - Convert to IBM floating point format.
C     DECFP     - Decode from IBM floating point format.
C     CALCOP    - Calculate the P scale factor for a field
C     JMALLOC   - Routine to acquire memory
C     JFREE     - Routine to release memory
C
C     Reference.
C     ----------
C
C     None.
C
C
C     Comments.
C     --------
C
C     On entry, KNSPT points to the first bit of section 4 in the GRIB
C               product.
C     On exit,  KNSPT points to the first bit of section 5 in the GRIB
C               product.
C
C
C     Author.
C     -------
C
C     J.D.Chambers     ECMWF      06:05:94
C
C
C     Modifications.
C     _____________
C
C     J.Clochard, Meteo France, for ECMWF - January 1998.
C     Use of external JFREE instead of FREE.
C     
C     P.J.Towers       ECMWF      18.07.02
C     Optimised for IBM Power4.
C         -Added @PROCESS ALIAS(NOPTEOVRLP) directive 
C         -Replaced Nint(x) by Int(x+0.5)
C         -Replaced division by scale by multiplication by reciprocal
C
C
C----<
C     -----------------------------------------------------------------
C*    Section 0. Definition of variables.
C     -----------------------------------------------------------------
C
      IMPLICIT NONE
C
#include "grprs.h"
C
C     Parameters
C
      INTEGER JP15BIT, JP87SET, JPBYTES
#ifdef REAL_8
      PARAMETER (JPBYTES = 8)
#else
      PARAMETER (JPBYTES = 4)
#endif
      PARAMETER ( JP15BIT= 2**15 )
C                            `---> 32768    =   8000(hex)
      PARAMETER ( JP87SET= 192 )
C                            `--->          =     C0(hex)
C
C     Subroutine arguments
C
      INTEGER KTRUNC, KSEC1, KSEC4, KGRIB, KLENG, KNSPT, KBITS, KPACK
      REAL PDATA
      DIMENSION PDATA(*), KGRIB(*), KSEC1(*), KSEC4(*)
C
C     Local variables.
C
      INTEGER J110,NREST,NLOOPS,ILOOP,LOOP,ILENF,IPOWER,ISUBSET,ISTATUS
      INTEGER IRET, IRETA, IRETB, IEXP, IMANT, ITEMP
      INTEGER INSPT1, INSPTA, INSPTB, ILEN, ISCALE, ISIGN
      INTEGER ILEN4, INIL, IL, IFLAG, ISIZE
C
#ifndef USE_NO_POINTERS
#ifndef _CRAYFTN
#ifdef POINTER_64
      INTEGER*8 IPIVAL
#endif
#endif
      POINTER (IPIVAL, IVAL)
      INTEGER IVAL(1)
      SAVE IPIVAL, ISIZE
#else
      INTEGER IVAL(1000)
#endif
C
      REAL ZCHANGE, ZMAX, ZREF, ZMIN, ZSCALE,ZRECIP
#if defined(CRAY) || defined(IBM) || defined(CYBER) || defined(hpiaR32)
      REAL    ZS
#else
      DOUBLE PRECISION    ZS
#endif
C
#include "grbcom.h"
C
C     Externals
C
#ifdef POINTER_64
      INTEGER*8 JMALLOC
#else
      INTEGER JMALLOC
#endif
      INTEGER PACKCF, GSCALE, CALCOP, REF2GRB
      EXTERNAL PACKCF, GSCALE, CALCOP, REF2GRB, JMALLOC
C
      DATA ISIZE/0/
C
C     -----------------------------------------------------------------
C*    Section 1 . Change units of data values , if required.
C     -----------------------------------------------------------------
C
  100 CONTINUE
C
      CSECT4 = 0
#ifndef USE_NO_POINTERS
C
C     Allocate memory (first time only)
C
      IF( ISIZE.LT.((KTRUNC+1)*(KTRUNC+2)*JPBYTES) ) THEN
        IF( ISIZE.NE.0 ) CALL JFREE(IPIVAL)
        ISIZE = (KTRUNC+1)*(KTRUNC+2)*JPBYTES
        IPIVAL = JMALLOC(ISIZE)
#ifdef hpR64
        IPIVAL = IPIVAL/(1024*1024*1024*4)
#endif
        IF( IPIVAL.EQ.0 ) THEN
          WRITE(GRPRSM,*) 'CSECT4: Memory allocation failed.'
          WRITE(GRPRSM,*) 'CSECT4: Number of bytes required = ', ISIZE
          CSECT4 = 16112
          GOTO 900
        ENDIF
      ENDIF
#endif
C
C     Preserve bit position of start of section 4.
      INSPT1 = KNSPT
C
C     Apply decimal scaling if required.
      IF (KSEC1(23).NE.0) THEN
        ZCHANGE = 10.0**KSEC1(23)
        ILENF = (KTRUNC+1) * (KTRUNC+2)
        DO 110 J110 = 1 , ILENF
          PDATA(J110) = PDATA(J110) * ZCHANGE
  110   CONTINUE
      ENDIF
C
C     -----------------------------------------------------------------
C*    Section 2.  Check given truncations.
C     -----------------------------------------------------------------
C
  200 CONTINUE
C
      ISUBSET = KSEC4(18)
      IF ( ISUBSET .GT. KTRUNC ) THEN
        WRITE(GRPRSM,*) 'CSECT4: Invalid subset truncation given'
        WRITE(GRPRSM,*) 'CSECT4: ISUBSET, KTRUNC =', ISUBSET, KTRUNC
        CSECT4 = 16000
        GOTO 900
      ENDIF
C
C     -----------------------------------------------------------------
C*    Section 3 . Apply power scaling to field.
C     -----------------------------------------------------------------

  300 CONTINUE
C
C     If user supplied the P factor, use it ..
      IF ( NONOFF .EQ. 0 ) THEN
        IPOWER  = KSEC4(17)
C
C     .. otherwise calculate the P factor for the field ..
      ELSE
        IPOWER  = CALCOP( PDATA, KTRUNC, ISUBSET)
        IF( IPOWER.LT.-10000 ) THEN
          CSECT4 = 16001
          GOTO 900
        ENDIF
        KSEC4(17) = IPOWER
      ENDIF
C     .. and scale the field.
      IRET = GSCALE( PDATA, KTRUNC, ISUBSET, IPOWER, 'I')
      IF ( IRET .NE. 0 ) THEN
        CSECT4 = 16002
        GOTO 900
      ENDIF
C
C
C     -----------------------------------------------------------------
C*    Section 4 . Store subset of coefficients (IBM style).
C     -----------------------------------------------------------------
C
  400 CONTINUE
C
C     Adjust pointer to avoid first 18 octets -> filled in later.
      INSPTA = KNSPT
      KNSPT = KNSPT + 18*8
      IRET = PACKCF( PDATA,KTRUNC,ISUBSET,KGRIB,KLENG,KNSPT,KBITS)
      IF ( IRET .NE. 0 ) THEN
        CSECT4 = 16003
        GOTO 900
      ENDIF
C
C     Reset bit pointer to start of section 4.
      INSPTB = KNSPT
      KNSPT = INSPTA
C
C     -----------------------------------------------------------------
C*    Section 5 . Find the max and min for the values to be scaled.
C     -----------------------------------------------------------------
C
  500 CONTINUE
C
C     Rearrange the values to be packed so they are contiguous.
      CALL CMPCK( PDATA, KTRUNC, ISUBSET)
C
C     Find the max and min for the contiguous values
      ILEN = (KTRUNC+1)*(KTRUNC+2) - (ISUBSET+1)*(ISUBSET+2)
      CALL MAXMIN( PDATA, ILEN, ZMAX, ZMIN)
C
C     Calculate the scale and reference value
      ZREF = ZMIN
      ZS = (ZMAX-ZREF) / (2**(KSEC4(2)+1)-1)
#ifdef CRAY
      IF (ZS.NE.0.0) ZS = ALOG(ZS) / ALOG(2.0) + 2.0
#else
      IF (ZS.NE.0.0) ZS = LOG(ZS) / LOG(2.0) + 2.0
#endif
#if defined hpR32 || defined (__alpha) || defined hpR64 || defined hpiaR64
      ISCALE = MIN (INT(ZS),INT(ZS+DSIGN(1.0D0,ZS)))
#elif defined (linux) || defined (darwin)
      ISCALE = MIN (INT(ZS),INT(ZS+SIGN(1.D0,ZS)))
#else
      ISCALE = MIN (INT(ZS),INT(ZS+SIGN(1.,ZS)))
#endif
      ZSCALE = 2.0**ISCALE
C 
C     Set scale factor sign bit.
      IF (ISCALE.LT.0) THEN
        ISCALE = -ISCALE
        ISIGN  = JP15BIT
        ISCALE = ISCALE + ISIGN
      ENDIF
C
C*    Octets 5 - 6 : Scale factor.
C     One 16 bit field.
C
C     Adjust bit pointer over first 4 octets and insert scale factor.
      KNSPT = KNSPT + 4*8
      CALL INXBIT(KGRIB,KLENG,KNSPT,ISCALE,1,KBITS, 16,'C',IRET)
      IF (IRET.NE.0) THEN
        WRITE(GRPRSM,*) 'CSECT4: Problem packing scale factor.'
        CSECT4 = 16004
        GO TO 900
      ENDIF
C
C*    Octets 7 - 10 : Reference value.
C     One 8 bit and one 24 bit field.
C
C     Convert floating point to GRIB representation.
      ISTATUS = REF2GRB(ZREF, IEXP, IMANT, KBITS)
      IF( ISTATUS.NE.0 ) THEN
        WRITE(GRPRSM,*) 'CSECT4: REF2GRB reference value problem'
        WRITE(GRPRSM,*) 'CSECT4: for parameter ', KSEC1(6)
        WRITE(GRPRSM,*) 'CSECT4: level type ', KSEC1(7)
        WRITE(GRPRSM,*) 'CSECT4: level ', KSEC1(8), KSEC1(9)
      ENDIF
C
C     Insert reference value exponent and mantissa.
      CALL INXBIT(KGRIB,KLENG,KNSPT,IEXP,1,KBITS, 8,'C',IRETA)
      CALL INXBIT(KGRIB,KLENG,KNSPT,IMANT,1,KBITS, 24,'C',IRETB)
      IRET = IRETA + IRETB
      IF (IRET.NE.0) THEN
        WRITE(GRPRSM,*) 'CSECT4: Problem packing reference value.'
        CSECT4 = 16005
        GO TO 900
      ENDIF
C
C     -----------------------------------------------------------------
C*    Section 6 . Store octets 11 to 18.
C     -----------------------------------------------------------------
C
  600 CONTINUE
C
C*    Octet 11 : Number of bits containing each packed value.
C     One 8 bit field.
C
C     Insert number of bits for each packed value.
      CALL INXBIT(KGRIB,KLENG,KNSPT,KSEC4(2),1,KBITS, 8,'C',IRET)
      IF (IRET.NE.0) THEN
        WRITE(GRPRSM,*) 'CSECT4: Problem packing number of bits/value.'
        CSECT4 = 16006
        GO TO 900
      ENDIF
C
C     Octets 12 - 13: Octet number of the start of packed data
C     One 16-bit field.
C
C     Insert octet number of the start of packed data.
      KSEC4(16) = KNSPT/8 + 7 + 4*(ISUBSET+1)*(ISUBSET+2)
      CALL INXBIT(KGRIB,KLENG,KNSPT,KSEC4(16),1,KBITS,16,'C',IRET)
      IF (IRET.NE.0) THEN
        WRITE(GRPRSM,*) 'CSECT4: Problem packing start of packed data.'
        CSECT4 = 16007
        GO TO 900
      ENDIF
C
C     Octets 14 - 15: Scaling factor; power of Laplacian operator
C                     applied to field before packing.
C     One 16-bit field.
C
C     Set sign bit if value is negative.
      IF (KSEC4(17).LT.0) THEN
        ITEMP = - KSEC4(17)
        ITEMP = ITEMP + JP15BIT
      ELSE
        ITEMP = KSEC4(17)
      ENDIF
C 
C     Insert scaling power.
      CALL INXBIT(KGRIB,KLENG,KNSPT,ITEMP,1,KBITS,16,'C',IRET)
      IF (IRET.NE.0) THEN
        WRITE(GRPRSM,*) 'CSECT4: Problem packing scaling power.'
        CSECT4 = 16008
        GO TO 900
      ENDIF
C
C     Octets 16 - 18: Pentagonal resolution parameters J,K,M
C                     specifying truncation of subset of data
C                     represented unpacked.
C     Three 8-bit fields.
C
C     Insert pentagonal resolution parameters.
      CALL INXBIT(KGRIB,KLENG,KNSPT,KSEC4(18),3,KBITS, 8,'C',IRET)
      IF (IRET.NE.0) THEN
        WRITE(GRPRSM,*)
     X    'CSECT4: Problem packing pentagonal resolution params.'
        CSECT4 = 16009
        GO TO 900
      ENDIF
C
C     -----------------------------------------------------------------
C*    Section 7 . Adjust, scale and pack the binary values.
C     -----------------------------------------------------------------
C
  700 CONTINUE
#ifndef USE_NO_POINTERS
      ZRECIP=1.0/ZSCALE
C
      DO LOOP = 1 , ILEN
#ifdef VAX
        IVAL(LOOP)   = JNINT( (PDATA(LOOP) - ZREF) / ZSCALE )
#else
        IVAL(LOOP)   =  INT( (PDATA(LOOP) - ZREF ) * ZRECIP + 0.5 )
#endif
      ENDDO
C
C     Adjust bit pointer to end of stored subset of coefficients and
C     store packed binary values in GRIB product -> updates bit pointer.
C
      KNSPT = INSPTB
      CALL INXBIT (KGRIB,KLENG,KNSPT,IVAL,ILEN, KBITS,KPACK, 'C',IRET)
      IF ( IRET .NE. 0 ) THEN
        WRITE(GRPRSM,*) 'CSECT4: Problem packing bits'
        CSECT4 = 16010
        GOTO 900
      ENDIF
#else
      NLOOPS = ILEN / 1000
      NREST  = ILEN - (NLOOPS)*1000
      KNSPT  = INSPTB
C
      DO ILOOP = 1, NLOOPS
        DO LOOP = 1 , 1000
#ifdef VAX
          IVAL(LOOP) = JNINT((PDATA((ILOOP-1)*1000+LOOP)-ZREF)/ZSCALE)
#else
          IVAL(LOOP) =  NINT((PDATA((ILOOP-1)*1000+LOOP)-ZREF)/ZSCALE)
#endif
        ENDDO
C
C       Adjust bit pointer to end of stored subset of coefficients and
C       store packed binary values in GRIB product -> updates bit pointer.
C
        CALL INXBIT(KGRIB,KLENG,KNSPT,IVAL,1000,KBITS,KPACK,'C',IRET)
        IF( IRET.NE.0 ) THEN
          WRITE(GRPRSM,*) 'CSECT4: Problem packing bits'
          CSECT4 = 16010
          GOTO 900
        ENDIF
      ENDDO
C
      DO LOOP = 1, NREST
#ifdef VAX
        IVAL(LOOP) = JNINT((PDATA((NLOOPS*1000)+LOOP)-ZREF)/ZSCALE)
#else
        IVAL(LOOP) =  NINT((PDATA((NLOOPS*1000)+LOOP)-ZREF)/ZSCALE)
#endif
      ENDDO
C
C       Adjust bit pointer to end of stored subset of coefficients and
C       store packed binary values in GRIB product -> updates bit pointer.
C
      CALL INXBIT (KGRIB,KLENG,KNSPT,IVAL,NREST,KBITS,KPACK,'C',IRET)
      IF( IRET.NE.0 ) THEN
        WRITE(GRPRSM,*) 'CSECT4: Problem packing bits'
        CSECT4 = 16010
        GOTO 900
      ENDIF
#endif
C
C     -----------------------------------------------------------------
C*    Section 8 . Fill in first 4 octets of section 4.
C     -----------------------------------------------------------------
C
  800 CONTINUE
C 
C     Adjust length of section 4 (in bits) to a multiple of 16.
      ILEN4 = KNSPT - INSPT1
      IL    = ILEN4 / 16
      IL    = ILEN4 - ( IL * 16 )
      INIL  = 0
      IF (IL.NE.0) INIL = 16 - IL
      KNSPT = KNSPT + INIL
      ILEN4 = ILEN4 + INIL
C 
C     Set length of section 4 to octets.
      ILEN4 = ILEN4 / 8
C
C     Octets 1 - 3: Length of section.
C     One 24-bit field.
C
      CALL INXBIT(KGRIB,KLENG,INSPT1,ILEN4,1,KBITS,24,'C',IRET)
      IF (IRET.NE.0) THEN
        WRITE(GRPRSM,*) 'CSECT4: Problem packing length of section.'
        CSECT4 = 16010
        GO TO 900
      ENDIF
C
C     Octet 4:
C     One 4-bit field -> flag, spherical harmonics/complex/float point
C     One 4-bit field -> number of unused bits at end of section 4.
C
      IFLAG = JP87SET + INIL
      CALL INXBIT(KGRIB,KLENG,INSPT1,IFLAG,1,KBITS,8,'C',IRET)
      IF (IRET.NE.0) THEN
        WRITE(GRPRSM,*) 'CSECT4: Problem packing flag.'
        CSECT4 = 16011
        GO TO 900
      ENDIF
C
C     -----------------------------------------------------------------
C*    Section 9. Return to calling routine.
C     -----------------------------------------------------------------
C
  900 CONTINUE
C
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C


      SUBROUTINE CONFP (FVAL,IEXP,IMANT)
C
C
C
C
C
C---->
C********************************************************************
C*
C*    NAME      : CONFP
C*
C*    FUNCTION  : CONVERT FLOATING POINT NUMBER FROM MACHINE
C*                REPRESENTATION TO GRIB REPRESENTATION.
C*
C*    INPUT     : FVAL  - FLOATING POINT NUMBER TO BE CONVERTED.
C*
C*    OUTPUT    : IEXP  - 8 BIT SIGNED EXPONENT
C*                IMANT - 24 BIT MANTISSA
C*                FVAL  - UNCHANGED.
C*
C*    JOHN HENNESSY , ECMWF , 15TH APRIL 1985
C*
C********************************************************************
C----<
C
C
      IF (FVAL.EQ.0.0)
     C   THEN
             IEXP = 128
             IMANT = 0
             RETURN
         ENDIF
C
C
      EPS = 1.0E-12
      REF = FVAL
C
C     SIGN OF VALUE
C
      ISIGN = 0
      IF (REF.LE.0.)
     C   THEN
             ISIGN = 128
             REF = - REF
         ENDIF
C
C
C
C
C
C     EXPONENT
C
      IF (REF.EQ.0.0)
     C   THEN
            IEXP = 0
         ELSE
            IEXP = INT(ALOG(REF)*(1.0/ALOG(16.0))+64.0+1.0+EPS)
         ENDIF
C
      IF (IEXP.LT.0  ) IEXP = 0
      IF (IEXP.GT.127) IEXP = 127
C
C
C
C
C
C
C
C
C
C
C     MANTISSA
C
      IMANT = NINT (REF/16.0**(IEXP-70))
C
C     ADD SIGN BIT TO EXPONENT.
C
      IEXP = IEXP + ISIGN
C
C
C
C
      RETURN
C
      END

C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C


      SUBROUTINE GRCHK3 (KSEC1,KSEC3,PSEC3,KRET)
C
C---->
C**** GRCHK3 - Check parameters for Section 3 of GRIB Code.
C
C     Purpose.
C     --------
C
C           Check parameters for Section 3 of GRIB code against
C           valid values for GRIB Edition 1.
C
C**   Interface.
C     ----------
C
C           CALL GRCHK3 (KSEC1,KSEC3,PSEC3,KRET)
C
C           Integer    K.
C           Real       P.
C           Logical    O.
C           Character  H.
C
C               Input Parameters.
C               -----------------
C
C               KSEC1      - Array containing integer parameters for
C                            section 1 of GRIB code.
C
C               KSEC3      - Array containing integer parameters for
C                            section 3 of GRIB code.
C
C               PSEC3      - Array containing real parameters for
C                            section 3 of GRIB code.
C
C               Output Parameters.
C               ------------------
C
C               KRET       - Return code.
C                            0   , No error encountered.
C                            1   , Error in GRIB Code parameter.
C
C     Method.
C     -------
C
C           Values checked against current code/flag tables
C           and against maximum or minimum permitted values.
C           They are also checked against the current status
C           of the implementation of GRIBEX and ECMWF usage.
C
C     Externals.
C     ----------
C
C           None.
C
C     Reference.
C     ----------
C
C           WMO Manual on Codes for GRIB Code.
C
C     Comments.
C     ---------
C
C           Routine contains Sections 0 to 5 and Section 9.
C
C     Author.
C     -------
C
C           J. Hennessy      ECMWF      16.09.91
C
C     Modifications.
C     --------------
C
C           J. Hennessy      ECMWF      01.10.91
C           Additional parameter KSEC1 and PSEC3 added.
C
C     ----------------------------------------------------------------
C----<
C
C
C
C
C
C
C
C
C
C
C*    Section 0 . Definition of variables. Data statements.
C     ----------------------------------------------------------------
C
C*    Prefix conventions for variable names.
C
C     Logical      L (but not LP), global or common.
C                  O, dummy arguments.
C                  G, local variable.
C                  LP, parameter.
C     Character    C, Global or common.
C                  H, dummy arguments.
C                  Y (but not YP), local variables.
C                  YP, parameter.
C     Integer      M and N, global or common.
C                  K, dummy arguments.
C                  I, local variables.
C                  J (but not JP), loop control.
C                  JP, parameter.
C     Real         A to F and Q to X, global or common.
C                  P (but not PP), dummy arguments.
C                  Z, local variables.
C                  PP, parameter.
C

      IMPLICIT NONE
C
#include "grprs.h"
C
      INTEGER KRET
      INTEGER KSEC1
      INTEGER KSEC3
C
      REAL    PSEC3
C
      DIMENSION KSEC1(*)
      DIMENSION KSEC3(*)
C
      DIMENSION PSEC3(*)
C
C     ----------------------------------------------------------------
C
C
C
C
C
C
C
C
C
C
C*    Section 1 . Set initial values.
C     ----------------------------------------------------------------
C
  100 CONTINUE
C
C     Reset return code.
C
      KRET = 0
C
C     ----------------------------------------------------------------
C
C
C
C
C
C
C
C
C
C
C*    Section 2 . Check values.
C     ----------------------------------------------------------------
C
  200 CONTINUE
C
C*    Check bit-map table reference field.
C
      IF (KSEC3(1).LT.0.OR.KSEC3(1).GT.65535)
     C   THEN
	     KRET = 1
	     WRITE(GRPRSM,9001) KSEC3(1)
         ENDIF
C
C     ----------------------------------------------------------------
C
C
C
C
C
C
C
C
C
C
C
C*    Section 9 . Return to calling routine. Format statements.
C     ----------------------------------------------------------------
C
  900 CONTINUE
C
 9001 FORMAT (1H ,'GRCHK3 : Invalid bit-map table reference - ',I9)
C
      RETURN
      END

C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C


      SUBROUTINE DECOPS (NAME,CHDATA,ILENCH,FPDATA,ILENFP,INDATA,ILENIN,
     C                   NBYTE,LGDATA,ILENLG,IB1PAR,IPSCOD,ILENPS,
     C                   JLENCH,JLENFP,JLENIN,JLENLG,IRSERV,NBIT,IWORD,
     C                   IERR )
C
C---->
C*
C*     NAME     : DECOPS
C*
C*     FUNCTION : DECODE PSEUDO-GRIB CODED DATA.
C*
C*     INPUT    : NBIT     - NUMBER OF BITS IN COMPUTER WORD
C*
C*                IPSCOD   - INTEGER ARRAY OF DATA IN PSEUDO-GRIB CODE.
C*                ILENPS   - LENGTH OF ARRAY IPSCOD.
C*
C*                CHDATA   - CHARACTER VARIABLE TO RECEIVE DECODED
C*                           CHARACTER DATA.
C*                ILENCH   - LENGTH OF THIS VARIABLE
C*
C*                FPDATA   - REAL ARRAY TO RECEIVE DECODED F.P. VALUES.
C*                ILENFP   - LENGTH OF THIS ARRAY.
C*
C*                INDATA   - INTEGER ARRAY TO RECEIVE DECODED INTEGERS
C*                ILENIN   - LENGTH OF THIS ARRAY.
C*
C*                LGDATA   - LOGICAL ARRAY TO RECEIVE DECODED LOGICALS
C*                ILENLG   - LENGTH OF THIS ARRAY.
C*
C*                          IF ANY LENGTH (ILENCH,-FP,-IN,-LG) IS SET
C*                          TO 1, ONLY BLOCK 0 AND BLOCK 1 ARE DECODED.
C*
C*                IB1PAR  - INTEGER ARRAY (DIMENSION 18) TO RECEIVE
C*                          DATA DEFINITION INFORMATION.
C*
C*
C*     OUTPUT   : PARAMETER FROM BLOCK 0
C*                ----------------------
C*
C*                NAME    - CHARACTER VARIABLE, 4 LETTERS OF CODE NAME.
C*
C*
C*                PARAMETERS FROM BLOCK 1 , PRODUCT DEFINITION BLOCK.
C*                --------------------------------------------------
C*
C*                IB1PAR  - INTEGER ARRAY (DIMENSION 18) OF DATA
C*                          DEFINITION INFORMATION.
C*
C*                WORD      CONTENTS
C*                ----      --------
C*                  1       ORIGINATING CENTRE IDENTIFIER.
C*                  2       MODEL IDENTIFICATION.
C*                  3       GRID DEFINITION.
C*                  4       FLAG ( CODE TABLE 1)
C*                  5       PARAMETER IDENTIFIER ( CODE TABLE 2 ).
C*                  6       TYPE OF LEVEL (CODE TABLE 3).
C*                 7-8      VALUE(S) OF LEVELS (CODE TABLE 3).
C*                  9       YEAR OF DATA
C*                 10       MONTH OF DATA
C*                 11       DAY OF DATA
C*                 12       HOUR OF DATA
C*                 13       MINUTE OF DATA
C*                 14       TIME UNIT (CODE TABLE 4).
C*                 15       TIME RANGE ONE
C*                 16       TIME RANGE TWO
C*                 17       TIME RANGE FLAG (CODE TABLE 5).
C*                 18       NUMBER AVERAGED.
C*
C*                          VALUE(S) OF LEVEL CAN OCCUPY 2 WORDS..
C*                          FOR A LAYER THE FIRST WORD DEFINES THE TOP
C*                          AND THE SECOND THE BOTTOM OF THE LAYER.
C*                          FOR A SINGLE LEVEL, ONLY THE FIRST WORD IS
C*                          USED.
C*
C*
C*
C*                PARAMETERS FROM BLOCK 4 , BINARY DATA BLOCK.
C*                -------------------------------------------
C*
C*                CHDATA   - UNPACKED CHARACTER DATA
C*                JLENCH   - NUMBER OF CHARACTERS. NEGATIVE IF
C*                           MISSING DATA CODED.
C*
C*                FPDATA  - ARRAY OF FLOATING POINT VALUES.
C*                JLENFP  - NUMBER OF VALUES IN THIS ARRAY.
C*                          JLENFP IS NEGATIVE IF MISSING DATA CODED
C*
C*                INDATA  - ARRAY OF INTEGER VALUES.
C*                JLENIN  - NUMBER OF VALUES IN THIS ARRAY.
C*                          JLENIN IS NEGATIVE IF MISSING DATA CODED
C*
C*                LGDATA  - ARRAY OF LOGICAL VALUES.
C*                JLENLG  - NUMBER OF VALUES IN THIS ARRAY.
C*                          JLENLG IS NEGATIVE IF MISSING DATA CODED
C*
C*                NBYTE   - NUMBER OF BYTES FOR INTEGER VALUES.
C*
C*                IRSERV  - NUMBER OF BYTES IN DATA BLOCK RESERVED
C*                          FOR FUTURE USE.
C*
C*
C*                OTHER PARAMETERS.
C*                ----------------
C*
C*                IWORD   - NUMBER OF WORDS DECODED.
C*
C*                IERR    - ERROR INDICATOR.
C*
C*                          0, NO ERROR.
C*
C*                         -2, INPUT ARRAY HOLDS FEWER CODED VALUES
C*                             THAN EXPECTED.
C*                         -3, OUTPUT ARRAY/VARIABLE TOO SMALL TO HOLD
C*                             DECODED DATA VALUES.
C*                         -4, CURRENTLY UNDEFINED OPTION SELECTED.
C*
C*                          1, NO BLOCK 5 FOUND.
C*
C*    GENERAL  : DECOPS CALLS GBYTE
C*                            GBYTES
C*                            OFFSET
C*                            DECFP
C*
C*    AUTHOR   : J.HENNESSY  23.01.86
C*
C*    MODIFIED : J.HENNESSY  06.06.86
C*                    "      21.08.86
C*
C*               J.Hennessy  17.09.90
C*               Lower case letters as well as the characters
C*               _ - . , added.
C*
C     ---------------------------------------------------------------
C---->
C
C
      PARAMETER (NCHAR=67)
C
C
      LOGICAL     LGDATA
      CHARACTER*4 NAME
      CHARACTER*1 CHAR
      CHARACTER*(*) CHDATA
C
C
C
      DIMENSION FPDATA(*),INDATA(*),LGDATA(*)
      DIMENSION IPSCOD(ILENPS),IBLOCK(24),IB1PAR(18)
      DIMENSION IASCII(NCHAR)
      DIMENSION CHAR(NCHAR)
C
C
      DATA IASCII /65 ,66 ,67 ,68 ,69 ,70 ,71 ,72 ,73 ,74 ,75 ,76 ,77 ,
     C             78 ,79 ,80 ,81 ,82 ,83 ,84 ,85 ,86 ,87 ,88 ,89 ,90 ,
     C             48 ,49 ,50 ,51 ,52 ,53 ,54 ,55 ,56 ,57 ,32 ,
     C             97 ,98 ,99 ,100,101,102,103,104,105,106,107,108,109,
     C             110,111,112,113,114,115,116,117,118,119,120,121,122,
     C             95 ,46 ,44 , 45  /
C
      DATA CHAR   /'A','B','C','D','E','F','G','H','I','J','K','L','M',
     C             'N','O','P','Q','R','S','T','U','V','W','X','Y','Z',
     C             '0','1','2','3','4','5','6','7','8','9',' ',
     C             'a','b','c','d','e','f','g','h','i','j','k','l','m',
     C             'n','o','p','q','r','s','t','u','v','w','x','y','z',
     C              '_','.',',','-' /
C
C
C
C
C
C
      IERR = 0
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C********************************************************************
C*
C*    BLOCK 0 - INDICATOR BLOCK.
C*
C********************************************************************
C
C
C     EXTRACT 4 OCTETS CONTAINING ASCII NAME.
C
      IWORD = 1
      IOFF  = 0
      IBYTE = 8
      NVAL  = 4
C
      CALL GBYTES (IPSCOD(1),IBLOCK(1),0,IBYTE,0,NVAL)
      CALL OFFSET (IOFF,NVAL,IWORD,IBYTE,NBIT,ILENPS,IERR)
      IF (IERR.NE.0) RETURN
C
      DO 100 I=1,36
         IF (IBLOCK(1).EQ.IASCII(I)) NAME(1:1) = CHAR(I)
         IF (IBLOCK(2).EQ.IASCII(I)) NAME(2:2) = CHAR(I)
         IF (IBLOCK(3).EQ.IASCII(I)) NAME(3:3) = CHAR(I)
         IF (IBLOCK(4).EQ.IASCII(I)) NAME(4:4) = CHAR(I)
  100 CONTINUE
C
C
C
C
C
C
C********************************************************************
C*
C*    BLOCK 1 - PRODUCT DEFINITION BLOCK.
C*
C********************************************************************
C
C
C     EXTRACT FIRST 4 OCTETS OF BLOCK 1.
C
      NVAL  = 4
C
      CALL GBYTES (IPSCOD(IWORD),IBLOCK(1),IOFF,IBYTE,0,NVAL)
      CALL OFFSET (IOFF,NVAL,IWORD,IBYTE,NBIT,ILENPS,IERR)
      IF (IERR.NE.0) RETURN
C
C     IF THESE OCTETS DO NOT CONTAIN 0, 0, 24 AND 0 RESPECTIVELY
C     THEN THE DATA IS IN THE OLD VERSION OF THE CODE.
C
      IF (IBLOCK(1).EQ.0.AND.IBLOCK(2).EQ.0.AND.IBLOCK(3).EQ.24.
     C    AND.IBLOCK(4).EQ.0)
     C      THEN
                ISNEW = 1
                NVAL = 20
            ELSE
                ISNEW = 0
                NVAL = 16
            ENDIF
C
C     EXTRACT NEXT 16 OR 20 OCTETS OF BLOCK 1 - NUMBER DEPENDS
C     ON VERSION OF CODE.
C
      CALL GBYTES (IPSCOD(IWORD),IBLOCK(5),IOFF,IBYTE,0,NVAL)
      CALL OFFSET (IOFF,NVAL,IWORD,IBYTE,NBIT,ILENPS,IERR)
      IF (IERR.NE.0) RETURN
C
C     TRANSFER PRODUCT DEFINITION INFORMATION TO OUTPUT ARRAY.
C     EXCEPT FOR NUMBER AVERAGED.
C
      DO 200 I=1,17
         IB1PAR(I) = IBLOCK(I+4*ISNEW)
  200 CONTINUE
C
C
      WRITE(*,*) ' '
      WRITE(*,*) '     ******************************************'
      WRITE(*,*) '     ******************************************'
      WRITE(*,*) '     **                                      **'      
      WRITE(*,*) '     ** DECOPS is not Year-2000 compliant;   **'
      WRITE(*,*) '     ** dates are returned as 2 digits.      **'
      WRITE(*,*) '     **                                      **'
      WRITE(*,*) '     ** Please switch to using DECOPS2 which **'
      WRITE(*,*) '     ** returns dates as 4 digits in the     **'
      WRITE(*,*) '     ** range 1900 upwards.                  **'
      WRITE(*,*) '     **                                      **'
      WRITE(*,*) '     ** DECOPS will be set to abort after    **'
      WRITE(*,*) '     ** January 1999.                        **'
      WRITE(*,*) '     **                                      **'
      WRITE(*,*) '     ******************************************'
      WRITE(*,*) '     ******************************************'
      WRITE(*,*) ' '
C
C
C     NUMBER AVERAGED OCCUPIES 2 OCTETS.
C
      IB1PAR(18) = IBLOCK(18+4*ISNEW) * 256 + IBLOCK(19+4*ISNEW)
C
C
C
C
C
C***
C*    DESCRIPTION OF LEVEL OR LAYER ( CODE TABLE 3 ).
C***
C
C     CERTAIN LEVEL TYPES REQUIRE THAT THE DESCRIPTION OCCUPY
C     BOTH 8 BIT FIELDS. PUT SINGLE VALUE IN FIRST LEVEL WORD.
C
      KTEMP = 32 + (ISNEW*224)
      IF ((IB1PAR(6).EQ. 20).OR.
     X    (IB1PAR(6).EQ.100).OR.
     X    (IB1PAR(6).EQ.103).OR.
     X    (IB1PAR(6).EQ.105).OR.
     X    (IB1PAR(6).EQ.107).OR.
     X    (IB1PAR(6).EQ.109).OR.
     X    (IB1PAR(6).EQ.111).OR.
     X    (IB1PAR(6).EQ.113).OR.
     X    (IB1PAR(6).EQ.115).OR.
     X    (IB1PAR(6).EQ.117).OR.
     X    (IB1PAR(6).EQ.125).OR.
     X    (IB1PAR(6).EQ.160) ) THEN
              IB1PAR(7) = IB1PAR(7) * KTEMP + IB1PAR(8)
              IB1PAR(8) = 0
          ENDIF
C
C
C
C
C
C
C
C
C
C***
C*    TIME RANGE.
C***
C
C     ONE TIME RANGE CAN OCCUPY TWO OCTETS.
C
      IF (IB1PAR(17).EQ.10)
     C   THEN
             IB1PAR(15) = IB1PAR(15) * KTEMP + IB1PAR(16)
             IB1PAR(16) = 0
         ENDIF
C
C
C
C
C
C
C
C
C
C***
C*    CHECK IF DECODING OF ONLY BLOCKS 0 AND 1 HAS BEEN REQUESTED.
C***
C
      IF (ILENFP.EQ.1.OR.ILENIN.EQ.1.OR.ILENLG.EQ.1) RETURN
      IF (ILENCH.EQ.1) RETURN
C
C
C
C
C
C
C
C
C
C
C********************************************************************
C*
C*    BLOCK 4 - BINARY DATA BLOCK.
C*
C********************************************************************
C
C
C
C***
C*    GET LENGTH OF BINARY DATA BLOCK.
C***
C
C
      IPW = IWORD
      IPB = IOFF
C
      CALL GBYTE (IPSCOD(IWORD),LBIN,IOFF,24)
      CALL OFFSET (IOFF,1,IWORD,24,NBIT,ILENPS,IERR)
      IF (IERR.NE.0) RETURN
C
C
C
C
C
C
C
C***
C*    OCTET 4 IS RESERVED.
C*    (IT IS USED IN OLDER VERSIONS OF BUDGET VALUE RECORDS AND
C*    IT GIVES THE STARTING OCTET ADDRESS OF LOGICAL VALUES, A
C*    FIXED VALUE OF 34 OR 38)
C***
C
      CALL GBYTE (IPSCOD(IWORD),ISTLG,IOFF,8)
      IOLDBV = 0
      IF (ISTLG.EQ.34.OR.ISTLG.EQ.38) IOLDBV = 1
C
C
      CALL OFFSET (IOFF,1,IWORD,8,NBIT,ILENPS,IERR)
      IF (IERR.NE.0) RETURN
C
C
C
C
C
C
C
C
C***
C*    OCTET 5 - MISSING DATA FLAG. (IN OLDER VERSIONS OF BUDGET VALUE
C*    RECORD IT GIVES STARTING OCTET ADDRESS OF INTEGER VALUES)
C***
C
      CALL GBYTE (IPSCOD(IWORD),IMISS,IOFF,8)
      CALL OFFSET (IOFF,1,IWORD,8,NBIT,ILENPS,IERR)
      IF (IERR.NE.0) RETURN
C
      IF (IOLDBV.EQ.1)
     C   THEN
             ISTIN = IMISS
             IMISS = 0
         ENDIF
C
C
C
C
C
C
C
C***
C*    OCTETS 6-7 IN OLDER VERSIONS OF BUDGET VALUE RECORDS GIVE
C*    STARTING BYTE ADDRESS OF FLOATING POINT VALUES SECTION.
C*    OCTETS 8-9 GIVING THE LENGTH OF THE FLOATING POINT DATA
C*    SECTION IN OCTETS.
C***
C
      IF (IOLDBV.EQ.1)
     C   THEN
             CALL GBYTE (IPSCOD(IWORD),ISTFP,IOFF,16)
             CALL OFFSET (IOFF,1,IWORD,16,NBIT,ILENPS,IERR)
             IF (IERR.NE.0) RETURN
C
             CALL GBYTE (IPSCOD(IWORD),LENFP,IOFF,16)
             CALL OFFSET (IOFF,1,IWORD,16,NBIT,ILENPS,IERR)
             IF (IERR.NE.0) RETURN
C
C            NUMBER OF FLOATING POINT VALUES.
C            4 BYTES PER FLOATING POINT NUMBER.
C
             JLENFP = LENFP / 4
C
C            NUMBER OF LOGICAL VALUES.
C
             JLENLG = ISTIN - ISTLG
C
C            NUMBER OF INTEGER VALUES.
C            2 OCTETS PER INTEGER.
C
             NBYTE = 2
             IBITS = NBYTE * 8
             JLENIN = ( ISTFP - ISTIN ) / NBYTE
C
C            NO CHARACTER DATA IN OLD FORMAT.
C
             JLENCH = 0
C
C            CHECK NUMBERS OF DATA ITEMS AGAINST DIMENSIONS
C            OF TARGET ARRAYS.
C
             IF (JLENFP.GT.ILENFP)
     C          THEN
                    IERR = -3
                    WRITE (*,9001) JLENFP
                ENDIF
C
             IF (JLENLG.GT.ILENLG)
     C          THEN
                    IERR = -3
                    WRITE (*,9002) JLENLG
                ENDIF
C
             IF (JLENIN.GT.ILENIN)
     C          THEN
                    IERR = -3
                    WRITE (*,9003) JLENIN
                ENDIF
C
             IF (IERR.NE.0) RETURN
C
C            NOW WE GO AROUND THE HOUSES AS THIS OLD DATA
C            HAS THE DIFFERENT DATA TYPES STORED IN A DIFFERENT
C            ORDER.
C
C            LOGICAL VARIABLES FIRST.
C
             GO TO 450
C
         ENDIF
C
C
C
C
C
C
C***
C*    OCTET 6 - NUMBER OF BYTES PER INTEGER.
C***
C
      CALL GBYTE (IPSCOD(IWORD),NBYTE,IOFF,8)
      CALL OFFSET (IOFF,1,IWORD,8,NBIT,ILENPS,IERR)
      IF (IERR.NE.0) RETURN
C
      IBITS = NBYTE * 8
C
C
C
C
C
C
C
C***
C*    OCTETS 7-8 ARE RESERVED.
C***
C
      CALL OFFSET (IOFF,2,IWORD,8,NBIT,ILENPS,IERR)
      IF (IERR.NE.0) RETURN
C
C
C
C
C
C
C
C***
C*    OCTETS 9-11 - NUMBER OF CHARACTERS IN CHARACTER SECTION.
C***
C
      CALL GBYTE (IPSCOD(IWORD),JLENCH,IOFF,24)
      CALL OFFSET (IOFF,1,IWORD,24,NBIT,ILENPS,IERR)
      IF (IERR.NE.0) RETURN
C
      IF (JLENCH.GT.ILENCH)
     C   THEN
             IERR = -3
             WRITE (*,9004) JLENCH
             RETURN
         ENDIF
C
C
C
C
C
C
C
C
C***
C*    OCTETS 12-14 , NUMBER OF FLOATING POINT VALUES.
C***
C
      CALL GBYTE (IPSCOD(IWORD),JLENFP,IOFF,24)
      CALL OFFSET (IOFF,1,IWORD,24,NBIT,ILENPS,IERR)
      IF (IERR.NE.0) RETURN
C
      IF (JLENFP.GT.ILENFP)
     C   THEN
             IERR = -3
             WRITE (*,9001) JLENFP
             RETURN
         ENDIF
C
C
C
C
C
C
C
C
C
C***
C*    OCTETS 15-17 , NUMBER OF INTEGER VALUES.
C***
C
      CALL GBYTE (IPSCOD(IWORD),JLENIN,IOFF,24)
      CALL OFFSET (IOFF,1,IWORD,24,NBIT,ILENPS,IERR)
      IF (IERR.NE.0) RETURN
C
      IF (JLENIN.GT.ILENIN)
     C   THEN
             IERR = -3
             WRITE (*,9003) JLENIN
             RETURN
         ENDIF
C
C
C
C
C
C
C
C
C
C***
C*    OCTETS 18-20 , NUMBER OF LOGICALS.
C***
C
      CALL GBYTE (IPSCOD(IWORD),JLENLG,IOFF,24)
      CALL OFFSET (IOFF,1,IWORD,24,NBIT,ILENPS,IERR)
      IF (IERR.NE.0) RETURN
C
      IF (JLENLG.GT.ILENLG)
     C   THEN
             IERR = -3
             WRITE (*,9002) JLENLG
             RETURN
         ENDIF
C
C
C
C
C
C
C
C
C
C***
C*    OCTETS 21-23 , NUMBER OF RESERVED OCTETS.
C***
C
      CALL GBYTE (IPSCOD(IWORD),IRSERV,IOFF,24)
      CALL OFFSET (IOFF,1,IWORD,24,NBIT,ILENPS,IERR)
      IF (IERR.NE.0) RETURN
C
C
C
C
C
C
C
C
C
C***
C*    OCTETS 24-32 ARE RESERVED
C***
C
      CALL OFFSET (IOFF,9,IWORD,8,NBIT,ILENPS,IERR)
      IF (IERR.NE.0) RETURN
C
C
C
C
C
C
C
C***
C*    OCTET 33- ,GET FLOATING POINT NUMBERS AND CONVERT.
C***
C
  250 CONTINUE
C
      IF (JLENFP.NE.0)
     C   THEN
C
             DO 300 I=1,JLENFP
                CALL GBYTE (IPSCOD(IWORD),IEXP,IOFF,8)
                CALL OFFSET (IOFF,1,IWORD,8,NBIT,ILENPS,IERR)
                IF (IERR.NE.0) RETURN
                CALL GBYTE (IPSCOD(IWORD),IMANT,IOFF,24)
                CALL OFFSET (IOFF,1,IWORD,24,NBIT,ILENPS,IERR)
                IF (IERR.NE.0) RETURN
                CALL DECFP (FPDATA(I),IEXP,IMANT)
  300        CONTINUE
C
         ENDIF
C
C     NO CHARACTER DATA IN OLD BUDGET VALUE RECORDS.
C
      IF (IOLDBV.EQ.1) GO TO 550
C
C
C
C
C
C
C
C
C
C***
C*    GET INTEGER VALUES.
C***
C
  350 CONTINUE
C
      IF (JLENIN.NE.0)
     C   THEN
C
C            SET UP MASK FOR NEGATIVE NUMBERS
C
             NEGSIN = 2 ** (IBITS-1)
C
C            MAXIMUM SIZE INTEGER IN GIVEN FIELD WIDTH.
C
             MAXINT = NEGSIN - 1
C
             DO 400 I=1,JLENIN
                CALL GBYTE (IPSCOD(IWORD),KTEMP,IOFF,IBITS)
                CALL OFFSET (IOFF,1,IWORD,IBITS,NBIT,ILENPS,IERR)
                IF (IERR.NE.0) RETURN
C
C               HANDLE NEGATIVE NUMBERS
C
                IF (KTEMP.GT.MAXINT)
     C             THEN
                       KTEMP = KTEMP - NEGSIN
                       KTEMP = - KTEMP
                   ENDIF
C
                INDATA(I) = KTEMP
  400        CONTINUE
C
         ENDIF
C
C
C     FOR OLDER BUDGET VALUES OUR LAST STOP IS FOR FLOATING POINT
C     VALUES.
C
      IF (IOLDBV.EQ.1) GO TO 250
C
C
C
C***
C*    GET LOGICALS AND CONVERT.
C***
C
  450 CONTINUE
C
      IF (JLENLG.NE.0)
     C   THEN
C
             DO 500 I=1,JLENLG
                CALL GBYTE (IPSCOD(IWORD),KTEMP,IOFF,8)
                CALL OFFSET (IOFF,1,IWORD,8,NBIT,ILENPS,IERR)
                IF (IERR.NE.0) RETURN
C
                LGDATA(I) = .FALSE.
                IF (KTEMP.EQ.1) LGDATA(I) = .TRUE.
  500        CONTINUE
C
         ENDIF
C
C
C     FOR OLD BUDGET VALUE VERSION WE JUMP AGAIN.
C     NEXT STOP ON TOUR IS FOR INTEGER VALUES.
C
      IF (IOLDBV.EQ.1) GO TO 350
C
C
C
C
C
C
C
C
C
C
C
C
C***
C*    GET CHARACTER DATA.
C***
C
      IF (JLENCH.NE.0)
     C   THEN
             DO 530 I=1,JLENCH
                CALL GBYTE (IPSCOD(IWORD),KTEMP,IOFF,8)
                CALL OFFSET (IOFF,1,IWORD,8,NBIT,ILENPS,IERR)
                IF (IERR.NE.0) RETURN
                DO 525 J=1,NCHAR
                   IF (KTEMP.EQ.IASCII(J))
     C                THEN
                          CHDATA(I:I) = CHAR(J)
                          GO TO 530
                      ENDIF
  525           CONTINUE
                IERR = -6
                WRITE (*,9016)
 9016           FORMAT (1H ,'DECOPS : Character data contains other ',
     C                 'than _ - . , letters, figures or spaces.')
                RETURN
  530       CONTINUE
         ENDIF
C
C
C
C
C
C
C
C***
C*    RESERVED BYTES IN DATA BLOCK.
C***
C
      CALL OFFSET (IOFF,IRSERV,IWORD,8,NBIT,ILENPS,IERR)
      IF (IERR.NE.0) RETURN
C
C
C
C
C
C
C
C
C
C***
C*    SKIP ANY ZERO FILL AT END OF DATA BLOCK.
C***
C
  550 CONTINUE
C
      L = (IWORD-IPW) * NBIT + IOFF -IPB
      L = LBIN * 8 - L
      IF (L.NE.0)
     C    THEN
              CALL OFFSET (IOFF,1,IWORD,L,NBIT,ILENPS,IERR)
              IF (IERR.NE.0) RETURN
          ENDIF
C
C
C
C
C********************************************************************
C*
C*    BLOCK 5 - END BLOCK.
C*
C********************************************************************
C
C     CHECK 7 7 7 7 AT END OF CODED DATA.
C
C
      CALL GBYTES (IPSCOD(IWORD),IBLOCK(1),IOFF,8,0,4)
C
C     55 IS THE VALUE OF ASCII CHARACTER '7'
C
      DO 600 I=1,4
         IF (IBLOCK(I).NE.55) IERR = 1
  600 CONTINUE
C
      IF (IERR.EQ.1) WRITE (*,*) ' NO 7777 GROUP FOUND '
C
C
C
C     SET NUMBER OF VALUES NEGATIVE, IF MISSING DATA VALUES.
C
      IF (IMISS.GE.8)
     C   THEN
             JLENCH = -JLENCH
             IMISS  =  IMISS - 8
         ENDIF
C
      IF (IMISS.GE.4)
     C   THEN
             JLENFP = -JLENFP
             IMISS  =  IMISS - 4
         ENDIF
C
      IF (IMISS.GE.2)
     C   THEN
             JLENIN = -JLENIN
             IMISS  =  IMISS - 2
         ENDIF
C
      IF (IMISS.EQ.1) JLENLG = -JLENLG
C
C
      RETURN
C
 9001 FORMAT (1H ,'DECOPS : Target real array must be at least ',
     C             I10,' words long.')
C
 9002 FORMAT (1H ,'DECOPS : Target logical array must be at least ',
     C             I10,' words long.')
C
 9003 FORMAT (1H ,'DECOPS : Target integer array must be at least ',
     C             I10,' words long.')
C
 9004 FORMAT (1H ,'DECOPS : Target character string must be at least ',
     C             I10,' characters long.')
C
C
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE BUOPERC(KPT,KDLEN,KDATA,KJ,KDD,KSTACK,KERR)
C
C
C**** *BUOPERC*
C
C
C     PURPOSE.
C     --------
C
C          PROCESS BUFR OPERATOR.
C
C**   INTERFACE.
C     ----------
C
C          *CALL* *BUOPERC(KPT,KDLEN,KDATA,KJ,KDD,KSTACK,KERR)*
C
C        INPUT :
C               *KPT*    - POINTER TO KDATA ARRAY
C               *KDLEN*  - DIMENSION OF KDATA ARRAY
C               *KDATA*  - ARRAY CONTAINING DATA NEEDED FOR DESCRIPTOR
C                          EXPANSION
C               *KJ*     - POINTER T ARRAY KSTACK
C               *KDD*    - DATA DESCRIPTOR
C        OUTPUT:
C               *KSTACK* - LIST OF DESCRIPTORS
C               *KERR*   - RETURN ERROR CODE
C
C     *METHOD.
C      -------
C
C          NONE.
C
C
C     EXTERNALS.
C     ----------
C
C          BUUATB           - UPDATE AUGMENTED TABLE B
C
C     REFERENCE.
C     ----------
C
C          NONE.
C
C     AUTHOR.
C     -------
C
C          M. DRAGOSAVAC    *ECMWF*       01/02/91.
C
C
C     MODIFICATIONS.
C     --------------
C
C          NONE.
C
C
      IMPLICIT LOGICAL(L,O,G), CHARACTER*8(C,H,Y)
C
C
#     include "parameter.F"
#     include "bcomunit.F"
#     include "bcmwork.F"
#     include "bcmwt.F"
#     include "bcmwtc.F"
#     include "bcmbef.F"
C
      CHARACTER CWTEN*64,CWTU*24
C
#ifndef R_4
      REAL*8 RVIND
      REAL*8 EPS
#else
      REAL   RVIND
      REAL   EPS
#endif
      DIMENSION KSTACK(*)
      DIMENSION KDATA(KDLEN)
C
C     ------------------------------------------------------------------
C
C*          1.   DETERMINE *F *X AND *Y.
C                -----------------------
 100  CONTINUE
C
      IF( KERR.NE.0 ) RETURN
C
      IF  = KDD / 100000
      IDIF= KDD - IF * 100000
      IX  = IDIF / 1000
      IY  = IDIF - IX * 1000
C
      IF( IF.NE.2 ) THEN
         KERR=21
         CALL BUERR(KERR)
         WRITE(KNTN,*) KDD,' IS TO BE OPEATOR'
         GO TO 400
      END IF
C
C*          1.1   CHANGE DATA WIDTH ?
C                 -------------------
 110  CONTINUE
C
      IF(IX.EQ.1) THEN
         NDWINC= NDWINC + (IY-128)
         IF(IY.EQ.0) NDWINC=0
         GO TO 400
      END IF
C
C*          1.2   CHANGE SCALE ?
C                 --------------
 120  CONTINUE
C
      IF(IX.EQ.2) THEN
C
C*          1.2.1  UPDATE SCALE MULTIPLIER.
C                  ------------------------
C
         NSCAM=NSCAM + (IY-128)
         IF(IY.EQ.0) NSCAM=0
         GO TO 400
      END IF
C
C*          1.3  CHANGE REFERENCE VALUE ?
C                ------------------------
 130  CONTINUE
C
      IF(IX.EQ.3) THEN
C
C*          1.3.1  UPDATE AUGMENTED TABLE B.
C                  -------------------------
         CALL BUAUG(KPT,KDLEN,KDATA,KJ,IY,KSTACK,KERR)
         GO TO 400
      END IF
C
C*          1.4   ADD ASSOCIATED FIELD ?
C                 ----------------------
 140  CONTINUE
C
      IF(IX.EQ.4) THEN
C
C*          1.4.1   UPDATE ASSOCIATED FIELD WIDTH.
C                   ------------------------------
         IF(IY.EQ.0) THEN
            NFD=NFD-1
            IF(NFD.LT.0) THEN
               KERR=51
               CALL BUERR(KERR)
               RETURN
            ELSEIF(NFD.EQ.0) THEN
               NAFDW=0
            END IF
         ELSE
            NFD=NFD+1
            NAFDWA(NFD)=IY
         END IF
         GO TO 400
      END IF

C
C*          1.5   SIGNIFY CHARACTER ?
C                 -------------------
 150  CONTINUE
C
      IF(IX.EQ.5) THEN
C
C*          1.5.1  ADD SPECIAL ENTRY TO WORKING TABLE.
C                  -----------------------------------
         NWT = NWT + 1
         CWTEN(NWT)='CHARACTERS'
         CWTU (NWT)=' '
         NWTR (NWT)= 0
         NWTDW(NWT)= IY * 8
         NWTEN(NWT)=658367
         M=M+1
         GO TO 400
      END IF
C
C*          1.5.2 SIGNIFY DATA WIDTH FOR IMMEDISTELY
C                 FOLLOWED LOCAL DESCRIPTOR
C
 152  CONTINUE
C
      IF(IX.EQ.6) THEN
         NWT = NWT + 1
         KJ=KJ+1
         CWTEN(NWT)='UNKNOWN'
         CWTU (NWT)='UNKNOWN'
         NWTR (NWT)= KSTACK(KJ)
         NWTDW(NWT)= IY
         NWTS (NWT)= 0
         NWTRV(NWT)= 0
         NWTEN(NWT)= NVIND
         M=NWT
C
C        CHECK IF LOCAL TABLE ENTRY KNOWN
C        --------------------------------
C
C         DO 153 I=1,JTAB
C         IF(NWTR(NWT).EQ.NTABBTR(I)) THEN
C            CWTEN(NWT)=CTABBEN(I)
C            CWTU (NWT)=CTABBU (I)
C            IF(CWTU(NWT)(1:3).EQ.'CCI') NWTEN(NWT)=65367
C            NWTS (NWT)=NTABBS (I)
C            NWTRV(NWT)=NTABBRV(I)
C            NWTDW(NWT)=NTABBDW(I)
C            NWTEN(NWT)=NTABBTR(I)
C            GO TO 400
C         END IF
C  153    CONTINUE
C
         GO TO 400
      END IF
C
      IF(IX.EQ.7) THEN
C
C*          1.5.4  UPDATE SCALE MULTIPLIER.
C                  ------------------------
C
         IF(IY.EQ.0) THEN
            N07     =0
            NSCAM07 =0
            NDWINC07=0
         ELSE
            N07=IY
            NSCAM07 =IY
            NDWINC07=((10*IY)+2)/3
         END IF
         GO TO 400
      END IF

      IF(IX.EQ.8) THEN
C
C*          1.5.5  UPDATE DATA WIDTH FOR CCITTIA5
C                  ------------------------------
C
         IF(IY.EQ.0) THEN
            N08     =0
         ELSE
            N07=IY
         END IF
         GO TO 400
      END IF

C
C*          1.6   QUALITY INFORMATION FOLLOWS.
C                 ----------------------------
 160  CONTINUE
C
      IF(IX.EQ.62) THEN
C
         IF(IY.EQ.0) GO TO 400
C
C*          1.7.1  ADD SPECIAL ENTRY TO WORKING TABLE.
C                  -----------------------------------
         NWT = NWT + 1
         CWTEN(NWT)='QUALITY INFORMATION FOLLOW'
         CWTU (NWT)=' '
         NWTDW(NWT)= 0
         NWTR (NWT)= KDD
         NWTRV(NWT)= 0
         NWTEN(NWT)= 0
         NWTS (NWT)= 0
         M=M+1
         IF(M.GT.JELEM) THEN
            KERR=30
            WRITE(KNTN,*)  'BUOPER:'
            CALL BUERR(KERR)
            RETURN
         END IF
         GO TO 400
      END IF
C
C
C*          2.  PROCESSING NEW OPERATORS.
C               -------------------------
 200  CONTINUE
C
C
C*          2.1   DATA NOT PRESENT.
C                 -----------------
 210  CONTINUE
C
      IF(IX.EQ.21) THEN
         N221=IY
         GO TO 400
      END IF
C
C
C*          2.2   QUALITY INFORMATION FOLLOWS.
C                 ----------------------------
 220  CONTINUE
C
      IF(IX.EQ.22) THEN
C
C*          1.7.2  ADD SPECIAL ENTRY TO WORKING TABLE.
C                  -----------------------------------
         NWT = NWT + 1
         CWTEN(NWT)='QUALITY INFORMATION FOLLOW'
         CWTU (NWT)=' '
         NWTDW(NWT)= 0
         NWTR (NWT)= 222000
         NWTRV(NWT)= 0
         NWTEN(NWT)= 0
         NWTS (NWT)= 0
         M=M+1
         IF(M.GT.JELEM) THEN
            KERR=30
            WRITE(KNTN,*)  'BUOPER:'
            CALL BUERR(KERR)
            RETURN
         END IF
         GO TO 400
      END IF
C
C
C*          2.3   SUBSTITUTED VALUES FOLLOWS.
C                 ---------------------------
 230  CONTINUE
C
      IF(IX.EQ.23) THEN
         IF(IY.EQ.0) THEN
            NWT=NWT+1
            CWTEN(NWT)='SUBSTITUTED VALUES FOLLOW'
            CWTU (NWT)=' '
            NWTDW(NWT)=0
            NWTR (NWT)=223000
            NWTRV(NWT)= 0
            NWTEN(NWT)= 0
            NWTS (NWT)= 0
            M=M+1
            IF(M.GT.JELEM) THEN
               KERR=30
               WRITE(KNTN,*)  'BUOPER:'
               CALL BUERR(KERR)
               RETURN
            END IF
            GO TO 400
         ELSE
            IF(NFD.NE.0) THEN
               DO I=1,NFD
               NWT=NWT+1
               CWTEN(NWT)='ASSOCIATED FIELD'
               CWTU (NWT)=' '
               NWTDW(NWT)= 0
               NWTR (NWT)= 0
               NWTRV(NWT)= 0
               NWTEN(NWT)= 0
               NWTS (NWT)= 0
               M=M+1
               END DO
               IF(M.GT.JELEM) THEN
                  KERR=30
                  WRITE(KNTN,*)  'BUOPER:'
                  CALL BUERR(KERR)
                  RETURN
               END IF
            END IF
            OMARKER=.TRUE.
            NWT=NWT+1
            CWTEN(NWT)='SUBSTITUTED VALUE MARKER'
            CWTU (NWT)=' '
            NWTDW(NWT)= 0
            NWTR (NWT)=KDD
            NWTRV(NWT)= 0
            NWTEN(NWT)= 0
            NWTS (NWT)= 0
            M=M+1
            IF(M.GT.JELEM) THEN
               KERR=30
               WRITE(KNTN,*)  'BUOPER:'
               CALL BUERR(KERR)
               RETURN
            END IF
            GO TO 400
         END IF
      END IF
C
C
C*          2.4   FIRST ORDER STATISTICS FOLLOWS.
C                 -------------------------------
 240  CONTINUE
C
      IF(IX.EQ.24) THEN
         IF(IY.EQ.0) THEN
            NWT=NWT+1
            CWTEN(NWT)='FIRST ORDER STATISTICS FOLLOW'
            CWTU (NWT)=' '
            NWTDW(NWT)= 0
            NWTR (NWT)=224000
            NWTRV(NWT)= 0
            NWTEN(NWT)= 0
            NWTS (NWT)= 0
            M=M+1
            IF(M.GT.JELEM) THEN
               KERR=30
               WRITE(KNTN,*)  'BUOPER:'
               CALL BUERR(KERR)
               RETURN
            END IF
            GO TO 400
         ELSE
            IF(NFD.NE.0) THEN
               DO I=1,NFD
               NWT=NWT+1
               CWTEN(NWT)='ASSOCIATED FIELD'
               CWTU (NWT)=' '
               NWTDW(NWT)= 0
               NWTR (NWT)= 0
               NWTRV(NWT)= 0
               NWTEN(NWT)= 0
               NWTS (NWT)= 0
               M=M+1
               END DO
               IF(M.GT.JELEM) THEN
                  KERR=30
                  WRITE(KNTN,*)  'BUOPER:'
                  CALL BUERR(KERR)
                  RETURN
               END IF
            END IF
            OMARKER=.TRUE.
            NWT=NWT+1
            CWTEN(NWT)='FIRST ORDER STATISTICS VALUE MARKER'
            CWTU (NWT)=' '
            NWTDW(NWT)= 0
            NWTR (NWT)=KDD
            NWTRV(NWT)= 0
            NWTEN(NWT)= 0
            NWTS (NWT)= 0
            M=M+1
            IF(M.GT.JELEM) THEN
               KERR=30
               WRITE(KNTN,*)  'BUOPER:'
               CALL BUERR(KERR)
               RETURN
            END IF
            GO TO 400
         END IF
      END IF
C
C*          2.5   DIFFERENCE STATISTICAL VALUES FOLLOW.
C                 -------------------------------------
 250  CONTINUE
C
      IF(IX.EQ.25) THEN
         IF(IY.EQ.0) THEN
            NWT=NWT+1
            CWTEN(NWT)='DIFFERENCE STATISTICAL VALUES FOLLOW'
            CWTU (NWT)=' '
            NWTDW(NWT)= 0
            NWTR (NWT)=225000
            NWTRV(NWT)= 0
            NWTEN(NWT)= 0
            NWTS (NWT)= 0
            M=M+1
            IF(M.GT.JELEM) THEN
               KERR=30
               WRITE(KNTN,*)  'BUOPER:'
               CALL BUERR(KERR)
               RETURN
            END IF
            GO TO 400
         ELSE
            IF(NFD.NE.0) THEN
               DO I=1,NFD
               NWT=NWT+1
               CWTEN(NWT)='ASSOCIATED FIELD'
               CWTU (NWT)=' '
               NWTDW(NWT)= 0
               NWTR (NWT)= 0
               NWTRV(NWT)= 0
               NWTEN(NWT)= 0
               NWTS (NWT)= 0
               M=M+1
               END DO
               IF(M.GT.JELEM) THEN
                  KERR=30
                  WRITE(KNTN,*)  'BUOPER:'
                  CALL BUERR(KERR)
                  RETURN
               END IF
            END IF
            OMARKER=.TRUE.
            NWT=NWT+1
            CWTEN(NWT)='DIFFERENCE STATISTICS VALUE MARKER'
            CWTU (NWT)=' '
            NWTDW(NWT)= 0
            NWTR (NWT)=KDD
            NWTRV(NWT)= 0
            NWTEN(NWT)= 0
            NWTS (NWT)= 0
            M=M+1
            IF(M.GT.JELEM) THEN
               KERR=30
               WRITE(KNTN,*)  'BUOPER:'
               CALL BUERR(KERR)
               RETURN
            END IF
            GO TO 400
         END IF
      END IF
C
C
C*          2.6   REPLACED/RETAINED VALUES FOLLOWS.
C                 ---------------------------------
 260  CONTINUE
C
      IF(IX.EQ.32) THEN
         IF(IY.EQ.0) THEN
            NWT=NWT+1
            CWTEN(NWT)='REPLACE/RETAINED VALUES FOLLOW'
            CWTU (NWT)=' '
            NWTDW(NWT)= 0
            NWTR (NWT)=232000
            NWTRV(NWT)= 0
            NWTEN(NWT)= 0
            NWTS (NWT)= 0
            M=M+1
            IF(M.GT.JELEM) THEN
               KERR=30
               WRITE(KNTN,*)  'BUOPER:'
               CALL BUERR(KERR)
               RETURN
            END IF
            GO TO 400
         ELSE
            IF(NFD.NE.0) THEN
               DO I=1,NFD
               NWT=NWT+1
               CWTEN(NWT)='ASSOCIATED FIELD'
               CWTU (NWT)=' '
               NWTDW(NWT)= 0
               NWTR (NWT)= 0
               NWTRV(NWT)= 0
               NWTEN(NWT)= 0
               NWTS (NWT)= 0
               M=M+1
               END DO
               IF(M.GT.JELEM) THEN
                  KERR=30
                  WRITE(KNTN,*)  'BUOPER:'
                  CALL BUERR(KERR)
                  RETURN
               END IF
            END IF
            OMARKER=.TRUE.
            NWT=NWT+1
            CWTEN(NWT)='REPLACE/RETAINED VALUE MARKER'
            CWTU (NWT)=' '
            NWTDW(NWT)= 0
            NWTR (NWT)=KDD
            NWTRV(NWT)= 0
            NWTEN(NWT)= 0
            NWTS (NWT)= 0
            M=M+1
            IF(M.GT.JELEM) THEN
               KERR=30
               WRITE(KNTN,*)  'BUOPER:'
               CALL BUERR(KERR)
               RETURN
            END IF
            GO TO 400
         END IF
      END IF
C
C*          2.7   CANCEL BACKWARD DATA REFERENCE.
C                 -------------------------------
 270  CONTINUE
C
      IF(IX.EQ.35) THEN
C
C*          2.7.2  ADD SPECIAL ENTRY TO WORKING TABLE.
C                  -----------------------------------
         NWT = NWT + 1
         CWTEN(NWT)='CANCEL BACKWARD DATA REFERENCE'
         CWTU (NWT)=' '
         NWTDW(NWT)= 0
         NWTR (NWT)= 235000
         NWTRV(NWT)= 0
         NWTEN(NWT)= 0
         NWTS (NWT)= 0
C
         M=M+1
         IF(M.GT.JELEM) THEN
            KERR=30
            WRITE(KNTN,*)  'BUOPER:'
            CALL BUERR(KERR)
            RETURN
         END IF
         GO TO 400
      END IF
C
C*          2.8   DEFINE BACKWARD REFERENCE BIT MAP.
C                 ----------------------------------
 280  CONTINUE
C
      IF(IX.EQ.36) THEN
C
C*          2.8.1  ADD SPECIAL ENTRY TO WORKING TABLE.
C                  -----------------------------------
         NWT = NWT + 1
         CWTEN(NWT)='BACKWARD REFERENCE BIT MAP'
         CWTU (NWT)=' '
         NWTDW(NWT)= 0
         NWTR (NWT)= 236000
         NWTRV(NWT)= 0
         NWTEN(NWT)= 0
         NWTS (NWT)= 0
C
         M=M+1
         IF(M.GT.JELEM) THEN
            KERR=30
            WRITE(KNTN,*)  'BUOPER:'
            CALL BUERR(KERR)
            RETURN
         END IF
         GO TO 400
      END IF
C
C*          2.9   DEFINE BACKWARD REFERENCE BIT MAP.
C                 ----------------------------------
 290  CONTINUE
C
      IF(IX.EQ.37) THEN
         IF(IY.EQ.0) THEN
C
C*          2.8.1  ADD SPECIAL ENTRY TO WORKING TABLE.
C                  -----------------------------------
            NWT = NWT + 1
            CWTEN(NWT)='USE PREVIOUSLY DEFINED BIT MAP'
            CWTU (NWT)=' '
            NWTDW(NWT)= 0
            NWTR (NWT)= 237000
            NWTRV(NWT)= 0
            NWTEN(NWT)= 0
            NWTS (NWT)= 0
C
            M=M+1
            IF(M.GT.JELEM) THEN
               KERR=30
               WRITE(KNTN,*)  'BUOPER:'
               CALL BUERR(KERR)
               RETURN
            END IF
            GO TO 400
         ELSE
C
C*          2.8.2  ADD SPECIAL ENTRY TO WORKING TABLE.
C                  -----------------------------------
            NWT = NWT + 1
            CWTEN(NWT)='CANCEL PREDEFINED BIT MAP'
            CWTU (NWT)=' '
            NWTDW(NWT)= 0
            NWTR (NWT)= KDD
            NWTRV(NWT)= 0
            NWTEN(NWT)= 0
            NWTS (NWT)= 0
C
            M=M+1
            IF(M.GT.JELEM) THEN
               KERR=30
               WRITE(KNTN,*)  'BUOPER:'
               CALL BUERR(KERR)
               RETURN
            END IF
            GO TO 400

         END IF
      END IF
C
      IF(IX.EQ.9) THEN
         IF(IY.EQ.0) THEN
            N40=0
         ELSE
            N40=IY
         END IF
C
         GO TO 400
      END IF
C
C
C*    5. DEFINE EVENT 
C        ------------
 500  CONTINUE
C
      IF(IX.EQ.41) THEN 
         IF(IY.EQ.0) THEN
C
C         5.1.1 ADD SPECIAL ENTRY TO WORKING TABLE.
C               -----------------------------------
            NWT = NWT + 1
            CWTEN(NWT)='DEFINE EVENT'
            CWTU (NWT)=' '
            NWTDW(NWT)= 0
            NWTR (NWT)= 241000
            NWTRV(NWT)= 0
            NWTEN(NWT)= 0
            NWTS (NWT)= 0
C
            M=M+1
            IF(M.GT.JELEM) THEN
               KERR=30
               WRITE(KNTN,*)  'BUOPER:'
               CALL BUERR(KERR)
               RETURN
            END IF
            GO TO 400
         ELSE
C
C*          5.1.1  ADD SPECIAL ENTRY TO WORKING TABLE.
C                  -----------------------------------
            NWT = NWT + 1
            CWTEN(NWT)='CANCEL DEFINE EVENT'
            CWTU (NWT)=' '
            NWTDW(NWT)= 0
            NWTR (NWT)= KDD
            NWTRV(NWT)= 0
            NWTEN(NWT)= 0
            NWTS (NWT)= 0
C
            M=M+1
            IF(M.GT.JELEM) THEN
               KERR=30
               WRITE(KNTN,*)  'BUOPER:'
               CALL BUERR(KERR)
               RETURN
            END IF 
            GO TO 400
         END IF
      END IF
C
C*        5.1  DEFINE CONDITIONING EVENT
C              -------------------------
 510  CONTINUE
C
      IF(IX.EQ.42) THEN
         IF(IY.EQ.0) THEN
C
C         5.1.1 ADD SPECIAL ENTRY TO WORKING TABLE.
C               -----------------------------------
            NWT = NWT + 1
            CWTEN(NWT)='DEFINE CONDITIONING EVENT'
            CWTU (NWT)=' '
            NWTDW(NWT)= 0
            NWTR (NWT)= 242000
            NWTRV(NWT)= 0
            NWTEN(NWT)= 0
            NWTS (NWT)= 0
C
            M=M+1
            IF(M.GT.JELEM) THEN
               KERR=30
               WRITE(KNTN,*)  'BUOPER:'
               CALL BUERR(KERR)
               RETURN
            END IF
            GO TO 400
         ELSE
C
C*          5.1.2  ADD SPECIAL ENTRY TO WORKING TABLE.
C                  -----------------------------------
            NWT = NWT + 1
            CWTEN(NWT)='CANCEL DEFINE CONDITIONING EVENT'
            CWTU (NWT)=' '
            NWTDW(NWT)= 0
            NWTR (NWT)= KDD
            NWTRV(NWT)= 0
            NWTEN(NWT)= 0
            NWTS (NWT)= 0
C
            M=M+1
            IF(M.GT.JELEM) THEN
               KERR=30
               WRITE(KNTN,*)  'BUOPER:'
               CALL BUERR(KERR)
               RETURN
            END IF
            GO TO 400
         END IF
      END IF
C*        5.2  DEFINE CONDITIONING EVENT
C              -------------------------
 520  CONTINUE
C
      IF(IX.EQ.43) THEN
         IF(IY.EQ.0) THEN
C
C         5.2.1 ADD SPECIAL ENTRY TO WORKING TABLE.
C               -----------------------------------
            NWT = NWT + 1
            CWTEN(NWT)='CATEGORICAL FORECAST VALUES FOLLOW'
            CWTU (NWT)=' '
            NWTDW(NWT)= 0
            NWTR (NWT)= 243000
            NWTRV(NWT)= 0
            NWTEN(NWT)= 0
            NWTS (NWT)= 0
C
            M=M+1
            IF(M.GT.JELEM) THEN
               KERR=30
               WRITE(KNTN,*)  'BUOPER:'
               CALL BUERR(KERR)
               RETURN
            END IF
            GO TO 400
         ELSE
C
C*          5.2.2  ADD SPECIAL ENTRY TO WORKING TABLE.
C                  -----------------------------------
            NWT = NWT + 1
            CWTEN(NWT)='CANCEL CATEGORICAL FORECAST VALUES FOLLOW'
            CWTU (NWT)=' '
            NWTDW(NWT)= 0
            NWTR (NWT)= KDD
            NWTRV(NWT)= 0
            NWTEN(NWT)= 0
            NWTS (NWT)= 0
C
            M=M+1
            IF(M.GT.JELEM) THEN
               KERR=30
               WRITE(KNTN,*)  'BUOPER:'
               CALL BUERR(KERR)
               RETURN
            END IF
            GO TO 400
         END IF
      END IF
C     ------------------------------------------------------------------
C
 300  CONTINUE
C
      KERR=22
      WRITE(KNTN,*)  'BUOPER:'
      CALL BUERR(KERR)
C
C     ------------------------------------------------------------------
C
 400  CONTINUE
C
      RETURN
      END

C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      INTEGER FUNCTION IRSIZE (KGTRUNC, KAREA, KLLEN, KNWE, KNNS, KLN,
     1   KTOTAL, PGAUSS, OWEGLOBE, ONPOLE, OSPOLE, KPR, KERR)
C
C---->
C**** *IRSIZE*
C
C     PURPOSE
C     _______
C
C     Evaluate the array sizes for a quasi regular Gaussian field.
C
C     INTERFACE
C     _________
C
C     IERR = IRSIZE (KGTRUNC, KAREA, KLLEN, KNWE, KNNS, KLN,
C    1   KTOTAL, PGAUSS, OWEGLOBE, ONPOLE, OSPOLE, KPR, KERR)
C
C     Input parameters
C     ________________
C
C     KGTRUNC    - The Gaussian truncation.
C
C     KAREA      - The field area definition (N, W, S, E) provided by
C                  the calling routine.
C
C     KLLEN      - This array contains the quasi regular Gaussian
C                  line length definition.
C
C     KPR        - The debug print switch.
C                  0  , No debugging output.
C                  1  , Produce debugging output.
C
C     KERR       - The error control flag.
C                  -ve, No error message. Return error code.
C                  0  , Hard failure with error message.
C                  +ve, Print error message. Return error code.
C
C     Output parameters
C     ________________
C
C     KNWE       - The maximum number of points in the West-East
C                  direction for this quasi regular Gaussian grid.
C
C     KNNS       - The number of points in the North-South direction
C                  in the field.
C
C     KLN        - The Northern Gaussian latitude number for this
C                  area.
C
C     KTOTAL     - The total field length for this quasi regular
C                  Gaussian grid and area.
C
C     PGAUSS     - The full list of Gaussian latitudes for this
C                  truncation.
C
C     OWEGLOBE   - This variable will be true if the array of
C                  longitudes spans the globe.
C
C     ONPOLE     - This variable will be true if the North polar line
C                  of latitude is included in the grid.
C
C     OSPOLE     - This variable will be true if the South polar line
C                  of latitude is included in the grid.
C
C     Return value
C     ____________
C
C     The error indicator (INTEGER).
C
C     Error and Warning Return Values
C     _______________________________
C
C     23801 A non-global area was requested and this option is not
C           supported yet.
C
C     Common block usage
C     __________________
C
C     None
C
C     EXTERNALS
C     _________
C
C     IGGLAT     - Compute Gaussian lines of latitude for a given
C                  truncation.
C     INTLOG(R)  - Logs messages.
C
C     METHOD
C     ______
C
C
C     A global definition is generated for the quasi regular field
C     and all three flag variable are set TRUE.
C
C     A REAL array of the full set of Gaussian latitudes is generated
C     for the Gaussian truncation requested.
C
C     REFERENCE
C     _________
C
C     None
C
C     COMMENTS
C     ________
C
C     Program contains sections 0 to 4 and 9
C
C     AUTHOR
C     ______
C
C     K. Fielding      *ECMWF*      Nov 1993
C
C     MODIFICATIONS
C     _____________
C
C     None
C
C----<
C     _______________________________________________________
C
C
C*    Section 0. Definition of variables.
C     _______________________________________________________
C
C*    Prefix conventions for variable names
C
C     Logical      L (but not LP), global or common.
C                  O, dummy argument
C                  G, local variable
C                  LP, parameter.
C     Character    C, global or common.
C                  H, dummy argument
C                  Y (but not YP), local variable
C                  YP, parameter.
C     Integer      M and N, global or common.
C                  K, dummy argument
C                  I, local variable
C                  J (but not JP), loop control
C                  JP, parameter.
C     REAL         A to F and Q to X, global or common.
C                  P (but not PP), dummy argument
C                  Z, local variable
C                  PP, parameter.
C
C     Implicit statement to force declarations
C
      IMPLICIT NONE
C
#include "parim.h"
C
C     Dummy arguments
      LOGICAL OWEGLOBE, ONPOLE, OSPOLE
      INTEGER KGTRUNC, KNWE, KNNS, KLN, KTOTAL, KPR, KERR
      INTEGER KAREA (4), KLLEN (*)
      REAL PGAUSS (*)
C
C     Local variables
      LOGICAL GZERO
      INTEGER IGAUSS, ILATNUM, ILS, INDIST, ISDIST, IERR
      INTEGER JLAT
      INTEGER JPROUTINE
      PARAMETER (JPROUTINE = 23800)
C
C     Function externals
C
      INTEGER IGGLAT
C
C     _______________________________________________________
C
C*    Section 1. Initialisation
C     _______________________________________________________
C
  100 CONTINUE
C
      IF (KPR.GE.1) CALL INTLOG(JP_DEBUG,'IRSIZE: Section 1.',JPQUIET)
C
      IRSIZE = 0
C
      IF (KPR .GE. 1) THEN
        CALL INTLOG(JP_DEBUG,'IRSIZE: Input parameters.',JPQUIET)
        CALL INTLOG(JP_DEBUG,
     X     'IRSIZE: Gaussian truncation = ',KGTRUNC)
        IF (KNNS .NE. 0) CALL INTLOG(JP_DEBUG,
     X    'IRSIZE: No.lat. pts = ',KNNS)
C
        CALL INTLOG(JP_DEBUG,'IRSIZE: Area North = ', KAREA(1))
        CALL INTLOG(JP_DEBUG,'IRSIZE: Area West  = ', KAREA(2))
        CALL INTLOG(JP_DEBUG,'IRSIZE: Area South = ', KAREA(3))
        CALL INTLOG(JP_DEBUG,'IRSIZE: Area East  = ', KAREA(4))
      ENDIF
C
      GZERO = .FALSE.
C
      ILATNUM = KGTRUNC * 2
C
C     _______________________________________________________
C
C*    Section 2. If all elements of KAREA are zero generate
C                a global field
C     _______________________________________________________
C
  200 CONTINUE
C
      IF (KPR.GE.1) CALL INTLOG(JP_DEBUG,'IRSIZE: Section 2.',JPQUIET)
C
Cxxx  IF (KAREA (JPEAST) .NE. 0 .OR. KAREA (JPWEST) .NE. 0) THEN
C
Cxxx     IRSIZE = JPROUTINE + 1
Cxxx     IF (KERR .GE. 0) WRITE (*, 9001) IRSIZE,
Cxxx 1      REAL (KAREA (JPNORTH) ) / PPMULT,
Cxxx 2      REAL (KAREA (JPWEST) ) / PPMULT,
Cxxx 3      REAL (KAREA (JPSOUTH) ) / PPMULT,
Cxxx 4      REAL (KAREA (JPEAST) ) / PPMULT
Cxxx     IF (KERR .EQ. 0) CALL ABORTX ('IRSIZE')
Cxxx     GO TO 900
Cxxx  ENDIF
C
      OWEGLOBE = .TRUE.
C
C     _______________________________________________________
C
C*    Section 3. Generate points along a line of meridian
C     _______________________________________________________
C
  300 CONTINUE
C
      IF (KPR.GE.1) CALL INTLOG(JP_DEBUG,'IRSIZE: Section 3.',JPQUIET)
C
C     Generate full Gaussian latitudes for this truncation
C
      IERR = IGGLAT (ILATNUM, PGAUSS, KPR, KERR)
C
      IF (IERR .GT. 0) THEN
         IRSIZE = IERR
         GO TO 900
      ENDIF
C
C     Find Gaussian lines corresponding to North and South points
C     provided
C
      KLN = 1
      ILS = ILATNUM
C
      IF (KNNS .EQ. 0) THEN
C
C       Number of lines not set (output field)
C
        KLN = 0
        ILS = ILATNUM
C
        DO 310 JLAT = 2, ILATNUM
C
          IGAUSS = NINT (PGAUSS (JLAT) * PPMULT)
C
          IF (KLN .EQ. 0 .AND. KAREA (JPNORTH) .GT. IGAUSS) THEN
            KLN = JLAT - 1
            KAREA (JPNORTH) = NINT (PGAUSS (KLN) * PPMULT)
          ENDIF
C
          IF (ILS.EQ.ILATNUM .AND. KAREA(JPSOUTH).GE.IGAUSS) THEN
            ILS = JLAT
            KAREA (JPSOUTH) = NINT (PGAUSS (ILS) * PPMULT)
          ENDIF
C
  310   CONTINUE
C
        KNNS = ILS - KLN + 1
C
      ELSE
C
C       Number of lines set (input field)
C
        JLAT = 1
        KLN = JLAT
        ILS = JLAT
C
        INDIST = ABS (NINT (PGAUSS (JLAT) * PPMULT) - KAREA (JPNORTH) )
        ISDIST = ABS (NINT (PGAUSS (JLAT) * PPMULT) - KAREA (JPSOUTH) )
C
        DO 320 JLAT = 2, ILATNUM
C
          IF (ABS (NINT (PGAUSS (JLAT) * PPMULT) - KAREA (JPNORTH) )
     1         .LT. INDIST) THEN
C
             KLN = JLAT
             INDIST = ABS(NINT(PGAUSS (JLAT) * PPMULT) - KAREA(JPNORTH))
C
          ENDIF
C
          IF (ABS (NINT (PGAUSS (JLAT) * PPMULT) - KAREA (JPSOUTH) )
     1         .LT. ISDIST) THEN
C
            ILS = JLAT
            ISDIST = ABS(NINT(PGAUSS(JLAT) * PPMULT) - KAREA(JPSOUTH))
C
          ENDIF
C
  320   CONTINUE
C
        IF (KNNS .NE. ILS - KLN + 1) THEN
          IRSIZE = JPROUTINE + 2
          IF (KERR .GE. 0) THEN
            CALL INTLOG(JP_ERROR,
     X        'IRSIZE: No. lines specified = ',KNNS)
            CALL INTLOG(JP_ERROR,
     X        'IRSIZE: Gaussian N limit = ',KLN)
            CALL INTLOG(JP_ERROR,
     X        'IRSIZE: Gaussian S limit = ',ILS)
          ENDIF
C
          IF (KERR .EQ. 0) CALL INTLOG(JP_FATAL,
     X      'IGLSIZE: Interpolation failed.',IRSIZE)
          GO TO 900
        ENDIF
C
      ENDIF
C
      ONPOLE = KLN .EQ. 1
      OSPOLE = ILS .EQ. ILATNUM
C
      KNNS = ILS - KLN + 1
C
      KAREA (JPNORTH) = NINT (PGAUSS (KLN) * PPMULT)
      KAREA (JPSOUTH) = NINT (PGAUSS (ILS) * PPMULT)
C
C     _______________________________________________________
C
C*    Section 4. Use line lengths to set maximum length and total
C     _______________________________________________________
C
  400 CONTINUE
C
      IF (KPR.GE.1) CALL INTLOG(JP_DEBUG,'IRSIZE: Section 4.',JPQUIET)
C
      KNWE = KLLEN (KGTRUNC)
C
      KTOTAL = 0
C
      DO 410 JLAT = KLN, ILS
C
        KTOTAL = KTOTAL + KLLEN (JLAT)
C
  410 CONTINUE
C
      IF (KPR .GE. 1) THEN
        CALL INTLOG(JP_DEBUG,'IRSIZE: Output parameters.',JPQUIET)
        CALL INTLOG(JP_DEBUG,'IRSIZE: Max W-E line len = ',KNWE)
        CALL INTLOG(JP_DEBUG,'IRSIZE: No lat lines = ',KNNS)
        CALL INTLOG(JP_DEBUG,'IRSIZE: Total no.pts = ',KTOTAL)
        CALL INTLOG(JP_DEBUG,'IGLSIZE: Northern line no. =',KLN)
        CALL INTLOG(JP_DEBUG,'IGLSIZE: Southern line no. =',ILS)
C
        IF( OWEGLOBE ) THEN
          CALL INTLOG(JP_DEBUG,'IGLSIZE: W-E fld is global',JPQUIET)
        ELSE
          CALL INTLOG(JP_DEBUG,'IGLSIZE: W-E fld is NOT global',JPQUIET)
        ENDIF
C
        IF( ONPOLE ) THEN
          CALL INTLOG(JP_DEBUG,'IGLSIZE: N pole is in fld.',JPQUIET)
        ELSE
          CALL INTLOG(JP_DEBUG,'IGLSIZE: N pole is NOT in fld.',JPQUIET)
        ENDIF
C
        IF( OSPOLE ) THEN
          CALL INTLOG(JP_DEBUG,'IGLSIZE: S pole is in fld.',JPQUIET)
        ELSE
          CALL INTLOG(JP_DEBUG,'IGLSIZE: S pole is NOT in fld.',JPQUIET)
        ENDIF
C
      ENDIF
C
C     _______________________________________________________
C
C*    Section 9. Return to calling routine. Format statements
C     _______________________________________________________
C
  900 CONTINUE
C
      IF (KPR.GE.1) CALL INTLOG(JP_DEBUG,'IRSIZE: Section 9.',JPQUIET)
C
C9001 FORMAT (' IRSIZE ERROR', I6, ' - One of the area limits is ',
C    1   'non-zero.' / 22X, 'They are', 4F10.4)
C
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities
C granted to it by virtue of its status as an intergovernmental organisation
C nor does it submit to any jurisdiction.
C

      INTEGER FUNCTION QGOCT(NLAT)
C
C---->
C**** QGOCT
C
C     PURPOSE
C     _______
C
C     Returns number of points at each Gaussian latitude (to fill pl array)
C     for a reduced Gaussian grid, in octahedral progression series
C
C
C     Input parameters
C     ________________
C
C     NLAT - latitude index starting from pole (1-based)
C
C----<
      IMPLICIT NONE
      INTEGER NLAT
      QGOCT = 16+4*MAX(NLAT,1)
      END FUNCTION

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities
C granted to it by virtue of its status as an intergovernmental organisation
C nor does it submit to any jurisdiction.
C


      SUBROUTINE UNBKOUT (KUNIT,KARRAY,KINLEN,KOUTLEN,KEOF,KRET)
C
C---->
C**** UNBKOUT - Write a record to a pure binary file.
C
C     Purpose.
C     --------
C
C           Provides standard interface to write unblocked COS
C           files or UNICOS pure binary files.
C
C**   Interface.
C     ----------
C
C           CALL UNBKOUT (KUNIT,KARRAY,KINLEN,KOUTLEN,KEOF,KRET)
C
C           INTEGER    K.
C           REAL       P.
C           LOGICAL    O.
C           CHARACTER  H.
C
C               Input parameters.
C               -----------------
C
C               KUNIT      - Fortran unit number of file to be written.
C                            1 to 99.
C
C               KARRAY     - Array containing record to be written.
C
C               KINLEN     - Length of this array, in words.
C
C               KOUTLEN    - Length of record to be written (in words).
C                            If this is 0 length is assumed to be in
C                            the first word of the record.
C                            This is the case with MARS data in unpacked
C                            format.
C
C               KEOF       - 0, If not last write to this file.
C                            1, Last write to this file, so write
C                               record and flush output buffer.
C                            2, Last record already written, so
C                               flush output buffer.
C
C               KRET       - 0, Routine to abort if error encountered.
C                            1, Return to calling routine even if error.
C
C                            Adding 100 to KRET will add debug printout
C                            eg values of input and output parameters.
C
C                            Valid values for KRET are thus 0, 1, 100
C                            or 101.
C
C               Output parameters.
C               ------------------
C
C               KOUTLEN    - Length of record written, in words.
C
C               KRET       - Return code.
C                            0, No error encountered.
C                            1, Write error.
C                            2, Not used.
C                            3, Not used.
C                            4, Not used.
C                            5, No data transferred because user's array
C                               is smaller than the record length.
C                            6, Maximum number of files opened for write
C                               by user program exceeded.
C                            7, Error detected in parameters.
C
C     Method.
C     -------
C
C           Data is written in 512 word blocks. The length of each
C           record is taken from the first word (or input parameter)
C           and all full blocks are then written. Unless it is the last
C           write to the file, any remaining words are kept to use
C           as the start of the next block to be written.
C
C           An array of Fortran numbers in use is kept, with a
C           corresponding array of pointers to the next part of
C           data to be written to each one. When the last write is
C           made to a file, these entries are reset to 0.
C
C           If an error is encountered, an error message is printed.
C
C     Externals.
C     ----------
C
C           None.
C
C     Reference.
C     ----------
C
C           Cray CFT77 Manual.
C
C     Comments.
C     ---------
C
C           Maximum number of files which can be handled in one
C           program is 20
C
C           Routine contains Sections 0 to 3 and Section 9.
C
C     Author.
C     -------
C
C           J. Hennessy      ECMWF      24:04:90.
C
C     Modifications
C     --------------
C
C           J. Hennessy      ECMWF      31:10:90.
C           Do not write empty last block, when flushing buffer.
C
C           B. Raoult        ECMWF      29:11:90
C           Fix bug in zero-filling of short and last records.
C
C     ----------------------------------------------------------------
C----<
C
C
C
C
C
C
C
C
C
C
C*    Section 0 . Definition of variables.
C     ----------------------------------------------------------------
C
      IMPLICIT LOGICAL     ( L, O, G )
      IMPLICIT CHARACTER*8 ( C, H, Y )
      IMPLICIT INTEGER     ( I, J, K, M, N )
C
      PARAMETER (JPBLOK=512)
      PARAMETER (JPFILS= 20)
C
      DIMENSION KARRAY(KINLEN)
      DIMENSION IOBUFF(JPFILS*JPBLOK)
      DIMENSION ISTART(JPFILS)
      DIMENSION IFTNOS(JPFILS)
C
      DATA ISTART /JPFILS*0/
      DATA IFTNOS /JPFILS*0/
C
      SAVE IOBUFF
      SAVE ISTART
      SAVE IFTNOS
C
C     ----------------------------------------------------------------
C
C
C
C
C
C
C
C
C
C*    Section 1 . Check parameters. Set initial values.
C     ----------------------------------------------------------------
C
 1000 CONTINUE
C
C*    Set print switch, if required.
C
      IF (KRET.GE.100)
     C   THEN
             KPR = 1
         ELSE
             KPR = 0
         ENDIF
C
C*    Print input parameters, if required.
C
      IF (KPR.EQ.1)
     C   THEN
             WRITE (*,*) 'UNBKOUT : Section 1.'
             WRITE (*,*) '         Input values used -'
             WRITE (*,9904) KUNIT
             WRITE (*,9905) KINLEN
             WRITE (*,9907) KOUTLEN
             WRITE (*,9906) KRET
             WRITE (*,9908) KEOF
         ENDIF
C
C*    Check input parameters.
C
      IRET = 0
      IF (KRET.GE.100) KRET = KRET - 100
C
C*    Invalid value given for return code.
C
      IF (KRET.LT.0.OR.KRET.GT.1)
     C   THEN
             IRET = 7
             WRITE (*,9910) KRET
             GO TO 9000
         ENDIF
C
C*    Fortran unit numbers must be between 1 and 99 inclusive.
C
      IF (KUNIT.LT.1.OR.KUNIT.GT.99)
     C   THEN
             IRET = 7
             WRITE (*,9911) KUNIT
             GO TO 9000
         ENDIF
C
C*    Retain last write indicator.
C
      IF (KEOF.LT.0.OR.KEOF.GT.2)
     C   THEN
             IRET = 7
             WRITE (*,9916) KEOF
             GO TO 9000
         ENDIF
C
      IEOF = KEOF
      KEOF = 0
C
C*    Locate Fortran unit number in list of active numbers.
C
      DO 1010 J1010=1,JPFILS
         IF (IFTNOS(J1010).EQ.KUNIT)
     C      THEN
                IB = ISTART(J1010)
                IP = J1010
                GO TO 1030
            ENDIF
 1010 CONTINUE
C
C*    None found, so first time in. Set table entries.
C
      DO 1020 J1020=1,JPFILS
         IF (IFTNOS(J1020).EQ.0)
     C      THEN
                IB = 0
                IP = J1020
                IFTNOS(J1020) = KUNIT
                GO TO 1030
            ENDIF
 1020 CONTINUE
C
C*    No table entry free. Maximum number of files exceeded.
C
      IRET = 6
      WRITE (*,9912) JPFILS
      GO TO 9000
C
C*    Set pointer to array holding last part of data not written.
C
 1030 CONTINUE
C
      IPR = IP
      IP  =  (IP-1) * JPBLOK + 1
C
C     IOBUFF(IP) to IOBUFF(IP+B) are the remaining words after
C     last block written.
C
C*    Flush output buffer only requested.
C
      IF (IEOF.EQ.2) GO TO 3575
C
C     ----------------------------------------------------------------
C
C
C
C
C
C
C
C
C
C*    Section 2 . Get length of next record.
C     ----------------------------------------------------------------
C
 2000 CONTINUE
C
      IF (KPR.EQ.1)
     C   THEN
             WRITE (*,*) 'UNBKOUT : Section 2.'
             WRITE (*,9909) IPR , IP , IB
         ENDIF
C
C     Get length of record.
C
      IF (KOUTLEN.EQ.0)
     C   THEN
             ILENW = KARRAY(1)
         ELSE
             ILENW = KOUTLEN
         ENDIF
C
C     Ensure that user's array is large enough.
C
      IF (KINLEN.LT.ILENW)
     C   THEN
             IRET = 5
             WRITE (*,9917) KINLEN , ILENW
             GO TO 9000
         ENDIF
C
      IF (KPR.EQ.1) WRITE (*,9902) ILENW
C
C     ----------------------------------------------------------------
C
C
C
C
C
C
C
C
C
C*    Section 3 . Write complete blocks.
C     ----------------------------------------------------------------
C
 3000 CONTINUE
C
      IF (KPR.EQ.1) WRITE (*,*) 'UNBKOUT : Section 3.'
C
C     If the record is 1 block or more in length write it to file.
C     Write partial last block into IOBUFF, preceding ones to file.
C
      IF ((IB+ILENW).GE.JPBLOK)
     C   THEN
C
C            Copy enough words from user array to complete first block.
C
             IF (IB.EQ.0) GO TO 3200
             DO 3050 J3050 = 1,JPBLOK - IB
                IOBUFF(IP+J3050+IB-1) = KARRAY(J3050)
 3050        CONTINUE
C
             IC = IB
             IB = JPBLOK - IB
C
C            Write first block.
C
             BUFFER OUT (KUNIT,0) (IOBUFF(IP),IOBUFF(IP+JPBLOK-1))
             IF (UNIT(KUNIT)) 3200,3700,3700
C
 3200        CONTINUE
C
C            Check if length to be written was exactly 1 block.
C
             IF ((ILENW + IC).EQ.JPBLOK)
     C          THEN
                    INTER = 0
                    GO TO 3555
                ENDIF
C
             ILENR = ILENW - IB
             IDIFF = MOD (ILENR,JPBLOK)
             IF (IDIFF.NE.0)
     C          THEN
                    ILENR = ILENR - IDIFF
                ELSE
                    ILENR = ILENR - JPBLOK
                ENDIF
             IE    = IB + ILENR
C
C            For a short record there may not be a full
C            second block.
C
             IF (IE.EQ.IB) GO TO 3400
C
C            If remaining part of record to be written is a multiple
C            of the block size, write complete record.
C
             IF ((ILENW-IE).EQ.JPBLOK) IE = IE + JPBLOK
C
             BUFFER OUT (KUNIT,0) (KARRAY(IB+1),KARRAY(IE))
             IF (UNIT(KUNIT)) 3400,3700,3700
C
C            Put end of field in IOBUFF.
C
 3400        CONTINUE
C
             INTER = ILENW - IE
             DO 3500 J3500=1,INTER
                IOBUFF(IP+J3500-1) = KARRAY(IE+J3500)
 3500        CONTINUE
C
         ELSE
C
C            Add short record to buffer.
C
             DO 3550 J3550 = 1,ILENW
                IOBUFF(IP+J3550+IB-1) = KARRAY(J3550)
 3550        CONTINUE
             INTER = IB + ILENW
C
         ENDIF
C
 3555 CONTINUE
C
      IB      = INTER
      KOUTLEN = ILENW
C
C     Fill unused part of buffer with zeroes.
C
      DO 3560 J3560 = IB+1,JPBLOK
         IOBUFF(J3560+IP-1) = 0
 3560 CONTINUE
C
C     Write last part of last record if end of file.
C     Do not write empty last block, when flushing buffer.
C
 3575 CONTINUE
C
      IF (IEOF.GT.0)
     C   THEN
             IF (IB.EQ.0) GO TO 3600
             DO 3580 J3580 = IB+1,JPBLOK
                IOBUFF(J3580+IP-1) = 0
 3580        CONTINUE
             BUFFER OUT (KUNIT,0) (IOBUFF(IP),IOBUFF(IP+JPBLOK-1))
             IF (UNIT(KUNIT)) 3600 , 3700 , 3700
         ENDIF
C
 3600 CONTINUE
C
C     Save pointer to start of next write area, unless last write.
C
      IF (IEOF.GT.0)
     C   THEN
             IFTNOS(IPR) = 0
             ISTART(IPR) = 0
         ELSE
             ISTART(IPR) = IB
         ENDIF
C
      GO TO 9000
C
 3700        CONTINUE
C
C*           Write error, go to section 9.
C
             IRET = 1
             WRITE (*,9913) KUNIT
C
C    ----------------------------------------------------------------
C
C
C
C
C
C
C
C
C
C*    Section 9 . Return to calling routine. Format statements.
C     ------------------------------------------------------------------
C
 9000 CONTINUE
C
      IF (KPR.EQ.1)
     C THEN
           WRITE (*,*) 'UNBKOUT : Section 9.'
           WRITE (*,*) '         Output values set -'
           WRITE (*,9907) KOUTLEN
           WRITE (*,9908) KEOF
           WRITE (*,9906) IRET
       ENDIF
C
C
      IF (IRET.NE.0.AND.IRET.NE.2)
     C   THEN
             WRITE (*,9903) IRET
             IF (KRET.EQ.0) CALL ABORT
         ENDIF
C
      KRET = IRET
C
 9902 FORMAT (1H ,'UNBKOUT : Record length (words) = ',I8)
C
 9903 FORMAT (1H ,'UNBKOUT : Return code = ',I6)
C
 9904 FORMAT (1H ,9X,'KUNIT   = ',I6)
C
 9905 FORMAT (1H ,9X,'KINLEN  = ',I6)
C
 9906 FORMAT (1H ,9X,'KRET    = ',I6)
C
 9907 FORMAT (1H ,9X,'KOUTLEN = ',I6)
C
 9908 FORMAT (1H ,9X,'KEOF    = ',I6)
C
 9909 FORMAT (1H ,'IPR = ',I4,'  IP = ',I8,'  IB = ',I8)
C
 9910 FORMAT (1H ,'UNBKOUT : KRET on input is ',I4,
     C         '. Valid values are 0,1,100 or 101.')
 9911 FORMAT (1H ,'UNBKOUT : KUNIT on input is ',I4,
     C         '. Valid values are 1 to 99.')
 9912 FORMAT (1H ,'UNBKOUT : Maximum number of files (',I2,
     C         ' exceeded.')
 9913 FORMAT (1H ,'UNBKOUT : Error in writing file number ',I2)
C
 9916 FORMAT (1H ,'UNBKOUT : KEOF on input is ',I4,
     C         '. Valid values are 0,1 or 2.')
 9917 FORMAT (1H ,'UNBKOUT : Array length is ',I6,' words, but record',
     C        ' length is ',I6,' words.')
C
      RETURN
C
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      INTEGER FUNCTION NUMPTWE(WEST,EAST,GRIDSTEP)
C
C---->
C**** NUMPTWE
C
C     Purpose
C     -------
C
C     Calculate number of grid points in the range from west to east.
C
C
C     Interface
C     ---------
C
C     IRET = NUMPTWE(WEST,EAST,GRIDSTEP)
C
C     Input
C     -----
C
C     WEST     - Western boundary in degrees
C     EAST     - Eastern boundary in degrees
C     GRIDSTEP - Grid interval in degrees
C
C
C     Output
C     ------
C
C     Function returns the number of grid points in the east-west
C     interval.
C
C
C     Method
C     ------
C
C     The grid is assumed to start at Greenwich.
C
C
C     Externals
C     ---------
C
C     None.
C
C     Author
C     ------
C
C     J.D.Chambers     ECMWF     Nov 1997
C
C
C     Modifications
C     -------------
C
C     None.
C
C----<
C
      IMPLICIT NONE
C
C     Function arguments
C
      REAL EAST, WEST, GRIDSTEP
C
C     Local variables
C
      INTEGER NL
      REAL*8 DEAST, DWEST
      REAL*8 LEFT, RIGHT, STEP, EPS
      DATA EPS/1.0E-3/
C
C     Statement function
      LOGICAL EQUAL
      REAL*8 A, B
      EQUAL(A,B) = ( ABS(A-B) .LT.EPS )
C
C ------------------------------------------------------------------
C     Section 1.   Initialise
C ------------------------------------------------------------------
C
  100 CONTINUE
C
C     Make all longitudes positive for calculation of difference
C
      DEAST = EAST
      DWEST = WEST
      RIGHT = DEAST + 360.0
      LEFT  = DWEST + 360.0
      STEP  = GRIDSTEP
      IF( RIGHT.LT.LEFT) RIGHT = RIGHT + 360.0
C
C ------------------------------------------------------------------
C     Section 2.   Calculate the number of points in the interval
C ------------------------------------------------------------------
C
  200 CONTINUE
C
C     Equal boundaries
C
      IF( EQUAL(LEFT,RIGHT) ) THEN
        NUMPTWE = 1
        GOTO 900
      ENDIF
C
C     Calculate offset of westernmost gridpoint
C
      NL = INT((LEFT+EPS)/STEP)
      IF( .NOT. EQUAL(LEFT,(NL*STEP)) ) NL = NL + 1
C
      RIGHT = RIGHT - (NL*STEP)
      NUMPTWE = INT((RIGHT+EPS)/STEP) + 1
C
C ------------------------------------------------------------------
C     Section 9.   Return
C ------------------------------------------------------------------
C
  900 CONTINUE
C
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE KWCHK1(KSEC1,KRET)
C
C---->
C**** KWCHK1
C
C     Purpose.
C     --------
C
C     Check parameters for Washington ensemble products Section 1
C     of GRIB code against valid values for GRIB Code Edition 1.
C
C**   Interface.
C     ----------
C
C     CALL KWCHK1(KSEC1,KRET)
C
C
C     Input Parameters.
C     -----------------
C
C     KSEC1      - Array containing parameters for section
C                  1 of GRIB code.
C
C     Output Parameters.
C     ------------------
C
C     KRET       - Return code.
C                  0   , No error encountered.
C                  1   , Error in GRIB code parameter.
C
C     Method.
C     -------
C
C     Values checked against Washington ensemble product usage.
C
C
C     Externals.
C     ----------
C
C     None.
C
C
C     Reference.
C     ----------
C
C     WMO Manual on Codes for GRIB code.
C
C
C     Comments.
C     ---------
C
C     Routine contains Sections 0 to 2 and Section 9.
C
C
C     Author.
C     -------
C
C     J.D.Chambers     ECMWF      09.10.95
C
C     Modifications.
C     --------------
C
C     None.
C
C----<
C     ----------------------------------------------------------------
C*    Section 0 . Definition of variables. Data statements.
C     ----------------------------------------------------------------
C
      IMPLICIT NONE
C
#include "common/grprs.h"
C
C     Subroutine arguments
      INTEGER KSEC1, KRET
      DIMENSION KSEC1(*)
C
C     Local variables
C
#ifdef CRAY
      INTEGER MMASK
#endif
      INTEGER IVERSN, IV0001, IV0011
      DATA IV0001/808464433/, IV0011/808464689/
C
C     IV0001 = right-justified ascii '0001'
C     IV0011 = right-justified ascii '0011'
C
C     ----------------------------------------------------------------
C*    Section 1 . Set initial values.
C     ----------------------------------------------------------------
C
  100 CONTINUE
C
C     Reset return code.
      KRET = 0
C
C     ----------------------------------------------------------------
C*    Section 2 . Check usage.
C     ----------------------------------------------------------------
C
  200 CONTINUE
C
C     Ensemble forecast data
      IF(KSEC1(37).NE.1) THEN
        WRITE(GRPRSM,*)
     X      'KWCHK1: Invalid Ensemble f/c data flag = ',KSEC1(37)
        KRET = 1
        GOTO 900
      ENDIF
C
C     Class.
      IF( KSEC1(38).NE.1 ) THEN
        WRITE(GRPRSM,*) 'KWCHK1: Invalid class code = ',KSEC1(38)
        KRET = 1
        GOTO 900
      ENDIF
C
C     Type.
      IF( (KSEC1(39).NE.10) .AND. (KSEC1(39).NE.11) ) THEN
        WRITE(GRPRSM,*) 'KWCHK1: Invalid type code = ',KSEC1(39)
        KRET = 1
        GOTO 900
      ENDIF
C
C     Stream.
      IF( KSEC1(40).NE.1051 ) THEN
        WRITE(GRPRSM,*) 'KWCHK1: Invalid stream code = ',KSEC1(40)
        KRET = 1
        GOTO 900
      ENDIF
C
C     Version number.
      IVERSN = KSEC1(41)
#if (!defined rs6000)
#ifdef CRAY
C
C     Mask least significant 32 bits for integer comparison
      MMASK = MASK(96)
      IVERSN = AND( IVERSN, MMASK)
#endif
      IF( (IVERSN.NE.IV0001) .AND. (IVERSN.NE.IV0011) ) THEN
        WRITE(GRPRSM,*) 'KWCHK1: Invalid version number = ', IVERSN
        KRET = 1
        GOTO 900
      ENDIF
#endif
C
C     Number of perturbed forecast.
      IF( KSEC1(39).EQ.10 ) THEN
        IF( KSEC1(42).NE.0 ) THEN
          WRITE(GRPRSM,*)
     X      'KWCHK1: Invalid control f/c number = ',KSEC1(42)
          KRET = 1
          GOTO 900
        ENDIF
C
      ELSE
        IF( (KSEC1(42).LT.0) .OR. (KSEC1(42).GT.11) ) THEN
          WRITE(GRPRSM,*)
     X      'KWCHK1: Invalid perturbed f/c number = ',KSEC1(42)
          KRET = 1
          GOTO 900
        ENDIF
      ENDIF
C
C     Total number of forecasts in ensemble.
      IF( (KSEC1(43).LT.0) .OR. (KSEC1(43).GT.11) ) THEN
        WRITE(GRPRSM,*)
     X      'KWCHK1: Invalid total f/cs in ensemble = ',KSEC1(43)
        KRET = 1
        GOTO 900
      ENDIF
C
C     ----------------------------------------------------------------
C*    Section 9 . Return to calling routine. Format statements.
C     ----------------------------------------------------------------
C
  900 CONTINUE
C
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities
C granted to it by virtue of its status as an intergovernmental organisation
C nor does it submit to any jurisdiction.
C

      SUBROUTINE JOPNGGF(IPLEG,KNUM,KTRUNC,KUNIT,PLAT,KRET)
C
C---->
C**** JOPNGGF
C
C     Purpose
C     _______
C
C     This routine finds a file of legendre polynomials corresponding
C     to a given grid interval and truncation, allocates memory, reads
C     the coefficients into the memory and returns a unit number.
C
C     Interface
C     _________
C
C     CALL JOPNGGF(IPLEG,KNUM,KTRUNC,KUNIT,PLAT,KRET)
C
C     Input parameters
C     ________________
C
C     KNUM    - Gaussian grid number
C     KTRUNC  - Spherical truncation
C     PLAT    - Array of latitudes for the gaussian grid
C
C     Output parameters
C     _________________
C
C     IPLEG   - Pointer to memory array used for legendre coefficients
C     KUNIT   - Unit number from PBOPEN
C               0 , open failed
C     KRET    - Return status code
C               0 = OK
C
C     Common block usage
C     __________________
C
C     Uses common JDCSPGP for size NISIZE7
C
C     Method
C     ______
C
C     Builds a file name from the truncation and grid interval and
C     tries to open a file of that name.
C
C     If the file is already open (from a previous call) the
C     previous unit number is returned.
C     If a different file is already open (from a previous call), the
C     existing file is closed.
C
C     If no file can be found, a file is created. Memory is dynamically
C     allocted and the coefficients are read into the memory array.
C
C     Externals
C     _________
C
C     PBOPEN3  - Open binary file and return unit number
C     PBREAD3  - Read binary file
C     PBCLOSE3 - Close binary file
C     JFINDIR  - Find the file of legendre coefficients
C     JMAKGG   - Makes a file of legendre coefficients
C     INTLOG   - Output log message
C
C     Reference
C     _________
C
C     NONE
C
C     Comments
C     ________
C
C     The filename for the legendre polynomials has the form:
C         cf_xxxx_nnnn   Truncation xxxx, Gaussian number nnnn
C     For example,
C         cf_0213_0160          T213    N160
C         cf_0106_0080          T106    N80
C
C     On the C90, the file of polynomials may be cached in /owrk/marsint
C
C     Otherwise the file is located in (or will be created in) the first
C     directory given by one of the following (in the order listed, if
C     they exist):
C         environment variable PPDIR
C     or
C         the current working directory.
C
C
C     Author
C     ______
C
C     J.D.Chambers      *ECMWF*      Jun 1996
C
C     Modifications
C     _____________
C
C     J.D.Chambers     ECMWF        Feb 1997
C     Allow for 64-bit pointers
C
C     S.Curic      *ECMWF*      Apr 2005
C     Change filename format because of N1048
C
C----<
C     _______________________________________________________
C
      IMPLICIT NONE
C
#include "parim.h"
#include "jparams.h"
#include "jparam2.h"
C
C     Parameters
C
      INTEGER JPROUTINE
      PARAMETER ( JPROUTINE = 30810 )
C
C     Subroutine arguments
C
      REAL      PLAT(*)
      INTEGER   KNUM, KTRUNC, KUNIT, KRET
C
C     Local variables
C
      INTEGER IRET
      INTEGER IOFFSET
      INTEGER NPBYTES
      INTEGER ISIZE
      INTEGER*8 ITEMP
      INTEGER IRET1
      CHARACTER*12 YFLAG
#ifdef REAL_8
      DATA NPBYTES/8/
#else
      DATA NPBYTES/4/
#endif
#ifndef _CRAYFTN
#ifdef POINTER_64
      INTEGER*8 IRPLEG
#endif
#endif
      REAL RPLEG(1)
      POINTER ( IRPLEG, RPLEG )
      LOGICAL LFOUND
      CHARACTER*256 DIRNAME
      CHARACTER*256 FILENAME
      CHARACTER*512 FULLPATH
      CHARACTER*20 YPFN
#ifdef REAL_8
      DATA YPFN/'CF_xxxx_nnnn'/
#else
      DATA YPFN/'cf_xxxx_nnnn'/
#endif
      INTEGER NUNIT
      DATA NUNIT/0/
#ifndef _CRAYFTN
#ifdef POINTER_64
      INTEGER*8 IPLEG
#endif
#endif
      REAL ALEG
      DIMENSION ALEG(1)
      POINTER ( IPLEG, ALEG )
C
      SAVE NUNIT
C
C     Externals
C
      LOGICAL JFINDIR, JFINDFN3
      INTEGER JCHMOD
      EXTERNAL JFINDIR, JFINDFN3
      EXTERNAL JCHMOD
C
C     _______________________________________________________
C
C*    Section 1. See if required file already in use.
C     _______________________________________________________
C
  100 CONTINUE
C
C     Setup the file name
C
      WRITE(YPFN(4: 7), '(I4.4)') KTRUNC
      WRITE(YPFN(9:12), '(I4.4)') KNUM
      CALL INTLOG(JP_DEBUG,
     X  'JOPNGGF: Coefficients file to open is:', JPQUIET)
      CALL INTLOG(JP_DEBUG, YPFN, JPQUIET)
C
C     If file already open, return the existing unit number
C
      IF( YPFN.EQ.YOLDGG ) THEN
        CALL INTLOG(JP_DEBUG,'JOPNGGF: File already open.',JPQUIET)
        KUNIT = NUNIT
        GOTO 900
C
      ELSE
C
C       Otherwise, ensure existing unit is closed
C
        IF( NUNIT.NE.0 ) THEN
          CALL PBCLOSE3( NUNIT, IRET)
          NUNIT=0
        ENDIF
      ENDIF
C
C     _______________________________________________________
C
C*    Section 2. See if the file has already been created.
C     _______________________________________________________
C
  200 CONTINUE
C
      IOFFSET = INDEX(YPFN,' ') - 1
      FILENAME = YPFN(1:IOFFSET)
C
      LFOUND = JFINDIR('PPDIR', DIRNAME)
      IF( LFOUND ) THEN
        LFOUND = JFINDFN3(DIRNAME,FILENAME,IOFFSET,NUNIT)
        IF( LFOUND ) GOTO 500
      ENDIF
C
C     Try present working directory
C
      IOFFSET = INDEX(YPFN,' ') - 1
      FILENAME = YPFN(1:IOFFSET)
      CALL PBOPEN3( NUNIT, FILENAME(1:IOFFSET), 'r', IRET)
      IF( IRET.EQ.0 ) GOTO 500
C     _______________________________________________________
C
C*    Section 3. File doesn't exist, find a suitable directory for it.
C     _______________________________________________________
C
  300 CONTINUE
C
      LFOUND = JFINDIR('PPDIR', DIRNAME)
      IF( LFOUND ) THEN
        IOFFSET = INDEX(DIRNAME, ' ') - 1
        FULLPATH  = DIRNAME(1:IOFFSET) // '/' // FILENAME
        IOFFSET = INDEX(FULLPATH, ' ') - 1
        FILENAME(1:IOFFSET) = FULLPATH(1:IOFFSET)
        CALL PBOPEN3( NUNIT, FILENAME(1:IOFFSET), 'w', IRET)
        IF( IRET.EQ.0 ) GOTO 400
      ENDIF
C
C     Try present working directory
C
      IOFFSET = INDEX(YPFN,' ') - 1
      FILENAME = YPFN(1:IOFFSET)
      CALL PBOPEN3( NUNIT, FILENAME(1:IOFFSET), 'w', IRET)
      IF( IRET.NE.0 ) THEN
        CALL INTLOG(JP_FATAL,'JOPNGGF: PBOPEN3 error.',IRET)
        KRET = JPROUTINE + 1
        GOTO 990
      ENDIF
C     _______________________________________________________
C
C*    Section 4. Create the coefficients file.
C     _______________________________________________________
C
  400 CONTINUE
C
C     Let user know that a new file is being created.
C
      CALL INTLOG(JP_DEBUG,'JOPNGGF: Creating new coefficients file:',
     X            JPQUIET)
      CALL INTLOG(JP_DEBUG,FILENAME(1:IOFFSET), JPQUIET)
C
C     Change access mode to 'read only' for all users.
C
      IRET = JCHMOD(FILENAME(1:IOFFSET),'0444')
      IF( IRET.NE.0 ) THEN
        CALL INTLOG(JP_FATAL,'JOPNGGF: JCHMOD error.',IRET)
        KRET = JPROUTINE + 2
        GOTO 990
      ENDIF
C
C     Allocate memory for the array used in making the file
C
      ISIZE = (KTRUNC+1)*(KTRUNC+4)/2
      IF( ISIZE.GT.NISIZE7 ) THEN
        CALL JMEMHAN( 7, IRPLEG, ISIZE, 1, KRET)
        IF( KRET.NE.0 ) THEN
          CALL INTLOG(JP_FATAL,'JOPNGGF: memory allocate error',IRPLEG)
          KRET = JPROUTINE + 3
          GOTO 990
        ENDIF
        NISIZE7 = ISIZE
      ENDIF
C
C     Make coefficients file
C
      CALL JMAKGG3( NUNIT, KTRUNC, KNUM, PLAT, RPLEG, KRET)
      IF( KRET.NE.0 ) GOTO 990
C
C     De-allocate memory for the array used in making the file
C
      CALL JMEMHAN( 7, IRPLEG, ISIZE, 0, KRET)
      IF( KRET.NE.0 ) THEN
        CALL INTLOG(JP_FATAL,'JOPNGGF: memory dealloc error',IRPLEG)
        KRET = JPROUTINE + 4
        GOTO 990
      ENDIF
      NISIZE7 = 0
C
C     Close coefficients file
C
      CALL PBCLOSE3( NUNIT, IRET)
      IF( IRET.NE.0 ) THEN
        CALL INTLOG(JP_FATAL,'JOPNGGF: PBCLOSE error.',IRET)
        KRET = JPROUTINE + 5
        GOTO 990
      ENDIF
      NUNIT=0
C
C     Reopen with read access
C
      CALL PBOPEN3( NUNIT, FILENAME(1:IOFFSET), 'r', IRET)
      IF( IRET.NE.0 ) THEN
        CALL INTLOG(JP_FATAL,'JOPNGGF: PBOPEN error.',IRET)
        KRET = JPROUTINE + 6
        GOTO 990
      ENDIF
C     _______________________________________________________
C
C*    Section 5. File now open with read access.
C     _______________________________________________________
C
  500 CONTINUE
C
C     Allocate memory for the file and read the file into memory
C
      ISIZE = ((KTRUNC+1)*(KTRUNC+4)/2)*KNUM
      IF( ISIZE.GT.NISIZE7 ) THEN
            CALL JMEMHAN2( 7, IPLEG, ISIZE, 1, KRET)
cs            CALL JMEMHAN( 7, IPLEG, ISIZE, 1, KRET)
        IF( KRET.NE.0 ) THEN
          CALL INTLOG(JP_FATAL,'JOPNGGF: memory allocation error',IPLEG)
          KRET = JPROUTINE + 7
          GOTO 990
        ENDIF
        NISIZE7 = ISIZE
      ENDIF
C
       ITEMP = ISIZE
cs       ITEMP = ISIZE*NPBYTES
       ITEMP = ITEMP*8

      CALL GETENV('USE_PBREAD4', YFLAG)
      IF(YFLAG(1:1).EQ.'1') THEN
           CALL PBREAD4(NUNIT, ALEG, ITEMP, IRET1)
      ELSE
cs          print*,'PBREAD5 -----------'
           CALL PBREAD5(NUNIT, ALEG, ITEMP, IRET1)
      ENDIF
           IF( IRET1.NE.ITEMP ) THEN
              CALL INTLOG(JP_FATAL,'JOPNGGF: PBREAD4 error.',IRET1)
              KRET = JPROUTINE + 8
              GOTO 990
           ENDIF
cs           CALL PBREAD3(NUNIT, ALEG, (ISIZE*NPBYTES), IRET)
cs           IF( IRET.NE.(ISIZE*NPBYTES) ) THEN
cs             CALL INTLOG(JP_FATAL,'JOPNGGF: PBREAD3 error.',IRET)
cs             KRET = JPROUTINE + 8
cs             GOTO 990
cs           ENDIF
C
C     The file is no longer required
C
      CALL PBCLOSE3( NUNIT, IRET)
      IF( IRET.NE.0 ) THEN
        CALL INTLOG(JP_FATAL,'JOPNGGF: PBCLOSE3 error.',IRET)
        NUNIT = 0
        KRET = JPROUTINE + 9
        GOTO 990
      ENDIF
      NUNIT=0
C
      KUNIT = NUNIT
      YOLDGG = YPFN
C
C     _______________________________________________________
C
C*    Section 9. Return to calling routine.
C     _______________________________________________________
C
  900 CONTINUE
C
      KRET = 0
C
 990  CONTINUE
C
      RETURN
      END

C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      INTEGER FUNCTION IRLREV (PMAT, KLEN, KLLEN, KCOL, KDIR, KPR,
     1   KERR)
C
C---->
C**** *IRLREV*
C
C     PURPOSE
C     _______
C
C     This routine reverses either the rows or the columns of a quasi
C     regular matrix.
C
C     INTERFACE
C     _________
C
C     IERR = IRLREV (PMAT, KLEN, KLLEN, KCOL, KDIR, KPR, KERR)
C
C     Input parameters
C     ________________
C
C     PMAT       - The input matrix of dimension (KLEN).
C
C     KLEN       - The length of the array PMAT.
C
C     KLLEN      - The lengths of each column within PMAT.
C
C     KCOL       - The number of entries in KLLEN and columns in PMAT.
C
C     KDIR       - 1   Reverses the order of the rows.
C                      West-East reversal for meteorological fields.
C                  2   Reverses the order of the columns.
C                      North-South reversal for meteorological fields.
C
C     KPR        - The debug print switch.
C                  0  , No debugging output.
C                  1  , Produce debugging output.
C
C     KERR       - The error control flag.
C                  (No longer used, kept for backward compatibility.
C                   Used to be used as follows:
C                  -ve, No error message. Return error code.
C                  0  , Hard failure with error message.
C                  +ve, Print error message. Return error code.)
C
C
C     Output parameters
C     ________________
C
C     PMAT       - The transformed matrix.
C
C
C     Return value
C     ____________
C
C     The error indicator (INTEGER).
C
C     7501  A column swap has been attempted where the lengths in the
C           array KLLEN are not symmetric about the middle value.
C
C
C     Common block usage
C     __________________
C
C     None
C
C
C     EXTERNALS
C     _________
C
C     INTLOG     - Generate log messages.
C
C
C     METHOD
C     ______
C
C     KDIR = 1 is implemented by swapping corresponding columns of
C              the matrix.
C
C     KDIR = 2 is implemented by reversing the elements within each
C              column.
C
C
C     REFERENCE
C     _________
C
C     None
C
C
C     COMMENTS
C     ________
C
C     None.
C
C
C     AUTHOR
C     ______
C
C     K. Fielding      *ECMWF*      Jan 1994
C
C
C     MODIFICATIONS
C     _____________
C
C     J.D.Chambers      ECMWF        Sept 1995
C
C----<
C     _______________________________________________________
C
      IMPLICIT NONE
C
#include "parim.h"
C
C     Function arguments
      INTEGER KLEN, KCOL, KDIR, KPR, KERR
      INTEGER KLLEN (KCOL)
      REAL PMAT (KLEN)
C
C     Local variables
      INTEGER IHALF, ISTARTL, ISTARTU, ILINE
      INTEGER JSTEP, JMOVE
      REAL ZTEMP
C
C     Parameters.
      INTEGER JPROUTINE
      PARAMETER (JPROUTINE = 7500)
C
C     _______________________________________________________
C
C*    Section 1. Initialisation
C     _______________________________________________________
C
  100 CONTINUE
C
      IF (KPR.GE.1) CALL INTLOG(JP_DEBUG,'IRLREV: Section 1.',JPQUIET)
C
      IRLREV = 0
C
      IF (KPR .GE. 1) THEN
        CALL INTLOG(JP_DEBUG,'IRLREV: Input parameters.',JPQUIET)
        CALL INTLOG(JP_DEBUG,'IRLREV: Matrix length = ',KLEN)
        CALL INTLOG(JP_DEBUG,'IRLREV: Number of rows = ',KCOL)
        CALL INTLOG(JP_DEBUG,'IRLREV: Direction value = ',KDIR)
      ENDIF
C
C     _______________________________________________________
C
C*    Section 2. Matrix COLUMN reversal (Field row interchange - WE)
C     _______________________________________________________
C
  200 CONTINUE
C
      IF (KPR.GE.1) CALL INTLOG(JP_DEBUG,'IRLREV: Section 2.',JPQUIET)
C
      IF (KDIR .EQ. 1) THEN
C
        ISTARTL = 0
C
        DO 220 JSTEP = 1, KCOL
C
          ILINE = KLLEN (JSTEP)
          IHALF = ILINE / 2
C
          DO 210 JMOVE = 1, IHALF
            ZTEMP = PMAT(ISTARTL + ILINE + 1 - JMOVE)
            PMAT(ISTARTL + ILINE + 1 - JMOVE) = PMAT(ISTARTL + JMOVE)
            PMAT(ISTARTL + JMOVE) = ZTEMP
  210     CONTINUE
C
          ISTARTL = ISTARTL + ILINE
C
  220   CONTINUE
C
      ELSE
C
C     _______________________________________________________
C
C*    Section 3. Matrix ROW reversal (Field column interchange - NS)
C     _______________________________________________________
C
  300 CONTINUE
C
        IF (KPR.GE.1) CALL INTLOG(JP_DEBUG,'IRLREV: Section 3.',JPQUIET)
C
        IHALF = KCOL / 2
C
        ISTARTL = 0
        ISTARTU = KLEN - KLLEN (KCOL)
C
        DO 320 JMOVE = 1, IHALF
C
C         The quasi regular line lengths must be symmetric for this
C         operation.
C
          IF (KLLEN (JMOVE) .NE. KLLEN (KCOL + 1 - JMOVE) ) THEN
            IRLREV = JPROUTINE + 1
C
            CALL INTLOG(JP_ERROR,
     X        'IRLREV: Line of latitude reversal failed', JPQUIET)
            CALL INTLOG(JP_ERROR,'IRLREV: at lat.lines = ',JMOVE)
            CALL INTLOG(JP_ERROR,'IRLREV: and = ',(KCOL+1-JMOVE))
            CALL INTLOG(JP_ERROR,
     X        'IRLREV: Lengths are not the same.', JPQUIET)
            CALL INTLOG(JP_ERROR,'IRLREV: 1st length = ', KLLEN (JMOVE))
            CALL INTLOG(JP_ERROR,
     X        'IRLREV: 2nd length = ',KLLEN(KCOL+1-JMOVE))
C
          ENDIF
C
          DO 310 JSTEP = 1, KLLEN (JMOVE)
C
            ZTEMP = PMAT (ISTARTU + JSTEP)
            PMAT (ISTARTU + JSTEP) = PMAT (ISTARTL + JSTEP)
            PMAT (ISTARTL + JSTEP) = ZTEMP
C
  310     CONTINUE
C
          ISTARTL = ISTARTL + KLLEN (JMOVE)
          ISTARTU = ISTARTU - KLLEN (KCOL - JMOVE)
C
  320   CONTINUE
C
      ENDIF
C
C     _______________________________________________________
C
C*    Section 9. Return to calling routine. Format statements
C     _______________________________________________________
C
  900 CONTINUE
C
      IF (KPR.GE.1) CALL INTLOG(JP_DEBUG,'IRLREV: Section 9.',JPQUIET)
C
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities
C granted to it by virtue of its status as an intergovernmental organisation
C nor does it submit to any jurisdiction.
C

      INTEGER FUNCTION IGSIZE(KGTRUNC, KAREA, KNWE, KNNS, KLN,
     X   PGAUSS, OWEGLOBE, ONPOLE, OSPOLE, KPR, KERR)
C
C---->
C**** *IGSIZE*
C
C     Purpose
C     -------
C     Evaluate the array sizes for a Gaussian truncation and area.
C
C
C     Interface
C     ---------
C     IERR = IGSIZE(KGTRUNC, KAREA, KNWE, KNNS, KLN,
C    X              PGAUSS, OWEGLOBE, ONPOLE, OSPOLE, KPR, KERR)
C
C
C     Input parameters
C     ----------------
C     KGTRUNC - The Gaussian truncation.
C     KAREA   - The field area definition (N, W, S, E) provided by
C               the calling routine.
C     KNWE    - The number of points in the West-East direction in
C               the field. This will be zero for an output field.
C     KNNS    - The number of points in the North-South direction
C               in the field. This will be zero for an output field.
C     KPR     - The debug print switch.
C                0  , No debugging output.
C                1  , Produce debugging output.
C     KERR    - The error control flag.
C                -ve, No error message. Return error code.
C                0  , Hard failure with error message.
C                +ve, Print error message. Return error code.
C
C
C     Output parameters
C     -----------------
C     KAREA    - The North and South values will be modified to
C                contain the values of the Gaussian latitudes used.
C     KNWE     - The number of points in the West-East direction in
C                the field.
C     KNNS     - The number of points in the North-South direction
C                in the field.
C     KLN      - The Northern Gaussian latitude number for this area.
C     PGAUSS   - The full list of Gaussian latitudes for this
C                truncation.
C     OWEGLOBE - This variable will be true if the array of
C                longitudes spans the globe.
C     ONPOLE   - This variable will be true if the North polar line
C                of latitude is included in the grid.
C     OSPOLE   - This variable will be true if the South polar line
C                of latitude is included in the grid.
C
C
C     Return value
C     ------------
C     The error indicator (INTEGER).
C
C
C     Error and Warning Return Values
C     -------------------------------
C     -1 The Eastern limit of the range did not have the expected
C        value. The Western value will be assumed to be correct. This
C        could arise because of known deficiencies in the GRIB
C        representation and will be treated as a WARNING error.
C
C     22501 The specified number of lines of latitude did not match
C           the Gaussian lines nearest the North and South values
C           provided.
C
C
C     Common block usage
C     ------------------
C     None
C
C
C     Externals
C     ---------
C     IGGLAT   - Compute Gaussian lines of latitude for a given
C                truncation.
C     INTLOG(R) - Logs messages.
C
C
C     Method
C     ------
C     If all the elements of the array KAREA are zero then a standard
C     global grid is generated and all elements of the array KAREA are
C     rewritten with the appropriate values. Otherwise it is assumed
C     that the West and East limits in KAREA have been validated. If
C     the number of longitude points is provided a warning will be
C     given if the West to East range does not match the number of
C     longitude points times the stride.
C
C     If the number of lines of longitude and latitude are not set on
C     entry then the North and South limits in KAREA will be expanded
C     outward to the next Gaussian latitudes. If the number of lines
C     of longitude and latitude are set on entry then the nearest
C     points to the North and South limits provided are chosen. It is
C     an error if these points do not provide the correct number of
C     latitudes. The revised North and South limits are written back
C     into the array KAREA.
C
C
C     Reference
C     ---------
C     None
C
C
C     Comments
C     --------
C     None
C
C
C     Author
C     ------
C     K. Fielding      *ECMWF*      Oct 1993
C
C
C     Modifications
C     -------------
C     Allow for unusual NCEP gaussian grids
C     J.D.Chambers   ECMWF   October 2000
C
C----<
C     -----------------------------------------------------------------|
C*    Section 0. Definition of variables.
C     -----------------------------------------------------------------|
C
      IMPLICIT NONE
C
#include "parim.h"
C
C     Parameters
C
      INTEGER JPROUTINE
      PARAMETER(JPROUTINE = 22500)
C
C     Function arguments
C
      LOGICAL OWEGLOBE, ONPOLE, OSPOLE
      INTEGER KGTRUNC, KNWE, KNNS, KLN, KPR, KERR, KAREA(4)
      REAL PGAUSS(*)
C
C     Local variables
C
      INTEGER ILNSTR, IEAST, IWEST, IREACH, ILATNUM, IGAUSS
      INTEGER INDIST, ISDIST, ILS, IERR, JLAT
      LOGICAL LPRINT
C
C     Function externals
C
      INTEGER IGGLAT
C
C     -----------------------------------------------------------------|
C*    Section 1. Initialisation
C     -----------------------------------------------------------------|
C
  100 CONTINUE
C
      IGSIZE = 0
      LPRINT = KPR.GE.1
C
      IF( LPRINT ) THEN
        CALL INTLOG(JP_DEBUG,'IGSIZE: Section 1.',JPQUIET)
        CALL INTLOG(JP_DEBUG,'IGSIZE: Input parameters.',JPQUIET)
        CALL INTLOG(JP_DEBUG,'IGSIZE: Gaussian truncation = ',KGTRUNC)
        CALL INTLOG(JP_DEBUG,'IGSIZE: No.long pts = ',KNWE)
        CALL INTLOG(JP_DEBUG,'IGSIZE: No.lat. pts = ',KNNS)
        CALL INTLOG(JP_DEBUG,'IGSIZE: Area North = ',KAREA(1))
        CALL INTLOG(JP_DEBUG,'IGSIZE: Area West  = ',KAREA(2))
        CALL INTLOG(JP_DEBUG,'IGSIZE: Area South = ',KAREA(3))
        CALL INTLOG(JP_DEBUG,'IGSIZE: Area East  = ',KAREA(4))
      ENDIF
C
      ILNSTR = JP90 / KGTRUNC
      ILATNUM = KGTRUNC * 2
C
C     -----------------------------------------------------------------|
C*    Section 2. If all elements of KAREA are missing generate
C                a global field
C     -----------------------------------------------------------------|
C
  200 CONTINUE
C
      IF( LPRINT ) CALL INTLOG(JP_DEBUG,'IGSIZE: Section 2.',JPQUIET)
C
      IF( (KAREA(JPEAST).EQ.0) .AND.
     X    (KAREA(JPWEST).EQ.0) .AND.
     X    (KAREA(JPNORTH).EQ.0).AND.
     X    (KAREA(JPSOUTH).EQ.0) ) THEN
C
        KAREA(JPNORTH) = JP90
        KAREA(JPWEST)  = 0
        KAREA(JPSOUTH) = - JP90
        KAREA(JPEAST)  = JP360 - ILNSTR
C
      ENDIF
C
C     -----------------------------------------------------------------|
C*    Section 3. Generate points around a line of latitude.
C     -----------------------------------------------------------------|
C
  300 CONTINUE
C
      IF( LPRINT ) CALL INTLOG(JP_DEBUG,'IGSIZE: Section 3.',JPQUIET)
C
C     Force both KAREA(JPWEST) and KAREA(JPEAST) into standard
C     range (0 to JP360)
C
      IF( KAREA(JPWEST).LT.0 ) KAREA(JPWEST) = KAREA(JPWEST) + JP360
      IF( KAREA(JPEAST).LT.0 ) KAREA(JPEAST) = KAREA(JPEAST) + JP360
C
C     Standardise range so that EAST > WEST
C
      IEAST = KAREA(JPEAST)
      IWEST = KAREA(JPWEST)
C
      IF( IEAST.LT.IWEST ) THEN
        IF( IEAST.LT.0 ) THEN
          IEAST = IEAST + JP360
          KAREA(JPEAST) = IEAST
        ELSE
          IWEST = IWEST - JP360
          KAREA(JPWEST) = IWEST
        ENDIF
      ENDIF
C
      IF( KNWE.EQ.0 ) THEN
C
C       Is it a global grid ?
C
        IREACH   = IEAST - IWEST + ILNSTR
        OWEGLOBE = IREACH.GE.JP360
C
C       Number of points along line is
C
        KNWE = NINT( FLOAT(IREACH) / FLOAT(ILNSTR) )
        IF( OWEGLOBE ) KNWE = 4*KGTRUNC
C
      ELSE
C
C       Number of points is set (input field)
C
        IF( (IWEST + (KNWE - 1)*ILNSTR).NE.IEAST ) THEN
C
C         Warn of possible mismatch
C
          IGSIZE = - 1
          CALL INTLOG(JP_WARN,
     X      'IGSIZE: West-East range does not match the',JPQUIET)
          CALL INTLOG(JP_WARN,
     X      'IGSIZE: number of points and the stride.',JPQUIET)
          CALL INTLOGR(JP_WARN,
     X      'IGSIZE: West = ',REAL(KAREA(JPWEST))/PPMULT)
          CALL INTLOGR(JP_WARN,
     X      'IGSIZE: East = ',REAL(KAREA(JPEAST))/PPMULT)
          CALL INTLOG(JP_WARN,'IGSIZE: No. of points = ',KNWE)
          CALL INTLOGR(JP_WARN,'IGSIZE: Stride = ',REAL(ILNSTR)/PPMULT)
        ENDIF
C
C       NCEP products for DEMETER are pseudo gaussian
C       (regular N48 in longitude direction, N47 in latitude direction)
C
        OWEGLOBE = KNWE.GE.(KGTRUNC*4)
C
      ENDIF
C
C     -----------------------------------------------------------------|
C*    Section 4. Generate points along a line of meridian
C     -----------------------------------------------------------------|
C
  400 CONTINUE
C
      IF( LPRINT ) CALL INTLOG(JP_DEBUG,'IGSIZE: Section 4.',JPQUIET)
C
C     Generate full Gaussian latitudes for this truncation
C
      IERR = IGGLAT(ILATNUM, PGAUSS, KPR, KERR)
C
      IF( IERR.GT.0 ) THEN
        IGSIZE = IERR
        GOTO 900
      ENDIF
C
C     Find Gaussian lines corresponding to given North and South points
C
C     Number of lines not set (output field)
C
      IF( KNNS.EQ.0 ) THEN
        KLN = 0
        ILS = ILATNUM
C
        DO JLAT = 2, ILATNUM
          IGAUSS = NINT(PGAUSS(JLAT) * PPMULT)
C
          IF( (KLN.EQ.0).AND.((KAREA(JPNORTH)-IGAUSS).GT.1000) ) THEN
            KLN = JLAT - 1
            KAREA(JPNORTH) = NINT(PGAUSS(KLN) * PPMULT)
          ENDIF
C
          IF( (ILS.EQ.ILATNUM).AND.(KAREA(JPSOUTH).GE.IGAUSS) ) THEN
            ILS = JLAT
            KAREA(JPSOUTH) = NINT(PGAUSS(ILS) * PPMULT)
          ENDIF
        ENDDO
C
        KNNS = ILS - KLN + 1
C
      ELSE
C
C       Number of lines set (input field)
C
        KLN = 1
        ILS = 1
C
        INDIST = ABS(NINT(PGAUSS(1) * PPMULT) - KAREA(JPNORTH) )
        ISDIST = ABS(NINT(PGAUSS(1) * PPMULT) - KAREA(JPSOUTH) )
C
        DO JLAT = 2, ILATNUM
C
          IF( (ABS(NINT(PGAUSS(JLAT)*PPMULT) - KAREA(JPNORTH) ) )
     X         .LT.INDIST) THEN
            KLN    = JLAT
            INDIST = ABS(NINT(PGAUSS(JLAT) * PPMULT) - KAREA(JPNORTH) )
          ENDIF
C
          IF( (ABS(NINT(PGAUSS(JLAT)*PPMULT) - KAREA(JPSOUTH) ) )
     X         .LT.ISDIST) THEN
            ILS    = JLAT
            ISDIST = ABS(NINT(PGAUSS(JLAT) * PPMULT) - KAREA(JPSOUTH) )
          ENDIF
C
        ENDDO
C
        IF( KNNS.NE.(ILS - KLN + 1) ) THEN
          IGSIZE = JPROUTINE + 1
          IF( KERR.GE.0 ) THEN
            CALL INTLOG(JP_ERROR,
     X          'IGSIZE: No.of lines specified = ',KNNS)
            CALL INTLOG(JP_ERROR,
     X          'IGSIZE: does not match the',JPQUIET)
            CALL INTLOG(JP_ERROR,
     X          'IGSIZE: Gaussian line limits = ', KLN)
            CALL INTLOG(JP_ERROR,
     X          'IGSIZE: and ',ILS)
          ENDIF
          IF( KERR.EQ.0 ) CALL INTLOG(JP_FATAL,
     X        'Interpolation failed.', JPQUIET)
          GOTO 900
        ENDIF
C
      ENDIF
C
      ONPOLE = KLN.EQ.1
      OSPOLE = ILS.EQ.ILATNUM
C
      KAREA(JPNORTH) = NINT(PGAUSS(KLN) * PPMULT)
      KAREA(JPSOUTH) = NINT(PGAUSS(ILS) * PPMULT)
C
      IF( LPRINT ) THEN
        CALL INTLOG(JP_DEBUG,'IGSIZE: Output parameters.',JPQUIET)
        CALL INTLOG(JP_DEBUG,'IGSIZE: No.long pts = ',KNWE)
        CALL INTLOG(JP_DEBUG,'IGSIZE: No.lat. pts = ',KNNS)
        CALL INTLOG(JP_DEBUG,'IGSIZE: Stride along lat = ',ILNSTR)
        CALL INTLOG(JP_DEBUG,'IGSIZE: North line number = ',KLN)
        CALL INTLOG(JP_DEBUG,'IGSIZE: South line number = ',ILS)
        IF( OWEGLOBE ) THEN
          CALL INTLOG(JP_DEBUG,
     X      'IGSIZE: Field is global West-East.',JPQUIET)
        ELSE
          CALL INTLOG(JP_DEBUG,
     X      'IGSIZE: Field is NOT global West-East.',JPQUIET)
        ENDIF
        IF( ONPOLE ) THEN
          CALL INTLOG(JP_DEBUG,
     X      'IGSIZE: North Pole is in field.',JPQUIET)
        ELSE
          CALL INTLOG(JP_DEBUG,
     X      'IGSIZE: North Pole NOT is in field.',JPQUIET)
        ENDIF
        IF( OSPOLE ) THEN
          CALL INTLOG(JP_DEBUG,
     X      'IGSIZE: South Pole is in field.',JPQUIET)
        ELSE
          CALL INTLOG(JP_DEBUG,
     X      'IGSIZE: South Pole NOT is in field.',JPQUIET)
        ENDIF
      ENDIF
C
C     -----------------------------------------------------------------|
C*    Section 9. Return to calling routine. Format statements
C     -----------------------------------------------------------------|
C
  900 CONTINUE
C
      IF( LPRINT ) CALL INTLOG(JP_DEBUG,'IGSIZE: Section 9.',JPQUIET)
C
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE CREXS0( KBUFL,YBUFF,KSUP,KSEC0,KERR)
C
C**** *BUEXS0*
C
C
C     PURPOSE.
C     --------
C          Expands section 0 of Crex message. 
C
C
C**   INTERFACE.
C     ----------
C
C          *CALL* *CREXS0( KBUFL,YBUFF,KSUP,KSEC0,KERR)*
C
C        INPUT :
C               *KBUFL*   -  length of CREX message (words)
C               *YBUFF*   -  Character string containing Crex message
C        OUTPUT:
C               *KSUP*    -  Integer array of 9 words containing
C                            suplementary information
C                         -  KSUP( 1) -- IDIM1, dimension of KSEC1
C                         -  KSUP( 2) -- Reserved
C                         -  KSUP( 3) -- IDIM3, dimension of KSEC3
C                         -  KSUP( 4) -- Reserved
C                         -  KSUP( 5) -- M (number of elements in values
C                                           array, first index)
C                         -  KSUP( 6) -- N (number of subsets,second index
C                                           of values array)
C                         -  KSUP( 7) -- JVC (number of elements in CVAL array)
C                         -  KSUP( 8) -- total CREX message length in bytes
C                         -  KSUP( 9) -- IDIM0, dimension of KSEC0
C
C               *KSEC0*   -  array containing section 0 information
C                            KSEC0( 1)-- length of section 0 (bytes)
C                            KSEC0( 2)-- total length of CREX message (bytes)
C                            KSEC0( 3)-- Not used
C
C               *KERR*    -  returned error code
C
C     METHOD.
C     --------
C
C          NONE.
C
C     EXTERNALS.
C     ----------
C
C
C     REFERENCE.
C     ----------
C
C          NONE.
C
C     AUTHOR.
C     -------
C
C          MILAN DRAGOSAVAC    *ECMWF*       07/01/2004.
C
C
C     MODIFICATIONS.
C     --------------
C
C          NONE.
C
C
      IMPLICIT LOGICAL(L,O,G), CHARACTER*8(C,H,Y)
C
      COMMON /CREXWORK/ NBPT,NGS,NVIND,NBPTSEC2,RVIND,EPS,NE,IEOLD,
     1                  NC07YYY
C
      DIMENSION KSEC0(*)
      DIMENSION KSUP(*)
      CHARACTER*(*) YBUFF
C
      CHARACTER*4 YCREX
      REAL*8 RVIND,EPS
C
C     ------------------------------------------------------------------
C*          1.   EXPAND SECTION 0.
C                -----------------
 100  CONTINUE
C
      IF( KERR.NE.0 ) RETURN
C
      KSEC0(1)=4
      KSEC0(2)=KBUFL
      KSUP(8) =KBUFL
C
C*          1.1  INITIALIZE WORKING POINTERS NWPT AND NBPT.
C                ------------------------------------------
      NBPT = 1
C
C*          1.2  UNPACK FIRST FOUR OCTETS CONTAINING *CREX*.
C                -------------------------------------------
C
      IF(YBUFF(NBPT:NBPT+3).ne.'CREX') then
         KERR=1
         print*,'This bulletin is not CREX message.'
         RETURN
      END IF
C
C           1.2 Position pointer to begining of section1.
C               ---------------------------------------------
 120  CONTINUE
C
      NBPT=NBPT+4
      IF(NBPT.GT.KBUFL) THEN
         KERR=26
         print*,'CREXS0:'
         CALL CREXERR(KERR)
         RETURN
      END IF
C
      IRET=0
      CALL NEXTSEC(KBUFL,YBUFF,NBPT,NGS,KERR)
      IF(KERR.NE.0) THEN
         KERR=40
         print*,'NEXTSEC :' 
         CALL CREXERR(KERR)
         RETURN
      END IF
C
      CALL NEXTGRP(KBUFL,YBUFF,NBPT,NGS,KERR)
      IF(KERR.NE.0) THEN
         KERR=41
         print*,'NEXTGRP : '
         CALL CREXERR(KERR)
         RETURN
      END IF
C
      RETURN
C     -----------------------------------------------------------------
C
      END

C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE GET_TABLES(K)
C
C**** *GET_TABLES*
C
C
C     PURPOSE.
C     --------
C          GET TABLES FROM THE ARRAY OF TABLES
C
C**   INTERFACE.
C     ----------
C          NONE.
C
C
C     *METHOD.
C      -------
C          NONE.
C
C
C     EXTERNALS.
C     ----------
C          NONE.
C
C
C
C
C     REFERENCE.
C     ----------
C
C          BINARY UNIVERSAL FORM FOR DATA REPRESENTATION, FM 94 BUFR.
C
C          J.K.GIBSON AND M.DRAGOSAVAC,1987: DECODING DATA 
C          REPRESENTATION FM 94 BUFR,TECHNICAL MEMORANDUM NO.
C
C          J.K.GIBSON,1986:EMOS 2 - STANDARDS FOR SOFTWARE DEVELOPMENT
C          AND MAINTANANCE ,TECHICAL MEMORANDUM NO.       ECMWF.
C
C
C     AUTHOR.
C     -------
C
C          M. DRAGOSAVAC       *ECMWF*       JANUARY 2007
C
C
C     MODIFICATIONS.
C     --------------
C
C          NONE.
C
C
      IMPLICIT LOGICAL(L,O,G), CHARACTER*8(C,H,Y)
C
#     include "parameter.F"
#     include "bcomtab.F"
#     include "bcomtabc.F"
#     include "bcomtabload.F"
#     include "bcomtabloadc.F"

C
      CHARACTER*64 CTABBEN,CCTABBEN
      CHARACTER*24 CTABBU,CCTABBU,CTABLE_LIST
C
C     ------------------------------------------------------------------
C*          1.   INITIALIZE CONSTANTS AND VARIABLES.
C                -----------------------------------
 100  CONTINUE
C
C
      IF(K.LT.1.OR.K.GT.JTMAX) THEN
         print*,'Table number > JTMAX'
         call exit(2)
      END IF
      DO 101 I=1,64
      DO 101 ii=1,255
      NTABP(I,II)=MTABP(I,II,K)
 101  CONTINUE
C
      DO 102 I=1,JTAB
      NTABBTR(I)=MTABBTR(I,K)
      NTABBS (I)=MTABBS (I,K)
      NTABBRV(I)=MTABBRV(I,K)
      NTABBDW(I)=MTABBDW(I,K)
      CTABBEN(I)=CCTABBEN(I,K)
      CTABBU (I)=CCTABBU(I,K)
      NTABDTR(I)=MTABDTR(I,K)
      NTABDL (I)=MTABDL(I,K)
      NTABDST(I)=MTABDST(I,K)
 102  CONTINUE
      DO I=1,JTAB*20
      NTABDSQ(I)=MTABDSQ(I,K)
      END DO
C
C     ------------------------------------------------------------------
      RETURN
      END

C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

C
      COMMON /BCOMOFF/ NSIZEG(JELEM),NSIZE(JELEM),NWTRG(JWORK),
     1                 NWTDWG(JWORK),NWP,NBP,NSUBSET,OMULTI,OS4

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE NEXTGRP(KBUFL,YBUFF,I,J,KERR)
C
C**** *NEXTGRP*
C
C
C     PURPOSE.
C     --------
C         LOCATE THE NEXT SEPARATOR
C         CHARACTER WHICH IS NOT 'CR' OR 'LF' OR 'SPACE' OR '+'
C
C         INPUT     : KBUFL - size if ybuff
C                     YBUFF - character string
C                     I     - SCAN STARTS AT byte 'I' OF YBUFF
C                     J     - SCAN ENDS AT byte 'J' OF YBUFF
C
C         OUTPUT    : I     - POSITION OF NEXT 'CR' OR 'LF' OR 'SPACE'
C                             OR '+'
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *NEXTGRP(KBUFL,YBUFF,I,J,KERR)*
C
C     METHOD.
C     -------
C
C          NONE.
C
C
C     EXTERNALS.
C     ----------
C
C         NONE.
C
C     REFERENCE.
C     ----------
C
C          NONE.
C
C     AUTHOR.
C     -------
C
C
C
C     MODIFICATIONS.
C     --------------
C
C          MILAN DRAGOSAVAC    *ECMWF*       07/01/2004.
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
      CHARACTER*(*) YBUFF
      CHARACTER*1 CR,LF,SPACE,PLUS,MINUS
C
      COMMON /CREXWORK/ NBPT,NGS,NVIND,NBPTSEC2,RVIND,EPS,NE,IEOLD,
     1                  NC07YYY
      REAL*8 RVIND, EPS
C
C     ------------------------------------------------------------------
C
C*          1.   SCAN BULLETIN.
C                --------------
 100  CONTINUE
C
C     'CR' = 13 , 'LF' = 10 , 'SPACE' = 32 'PLUS' = 43
C
      KERR=0
      cr=char(13)
      lf=char(10)
      space=char(32)
      plus=char(43)
      minus='-'
C
      i=iabs(i)
      k = i
      do 101 i=k,j
      if(NE.eq.0) then
         if(ybuff(I:I).ne.cr.and.
     1      ybuff(I:I).ne.lf.and.
     2      ybuff(I:I).ne.space.and.
     2      ybuff(I:I).ne.minus.and.
     2      ybuff(I:I+2).ne.'E++'.and.
     3      ybuff(I:I).ne.plus) return
      else
         if(ybuff(I:I).ne.cr.and.
     1      ybuff(I:I).ne.lf.and.
     2      ybuff(I:I).ne.space.and.
     2      ybuff(I:I+2).ne.'E++'.and.
     3      ybuff(I:I).ne.plus) return
      end if
  101 continue
C
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C


      SUBROUTINE CODEGR (FPDATA,ILENF,IBITS,NBIT,IB1PAR,
     C              IB2PAR,FVERT,ILENV,IGRIB,ILENG,IWORD,
     C              IROUND,IERR)
C
C
C---->
C*
C*     NAME     : CODEGR
C*
C*     FUNCTION : CODE ARRAY OF FLOATING POINT VALUES IN WMO GRIB
C*                CODE - WITH ECMWF EXTENSIONS.
C*
C*     INPUT    : PARAMETERS FOR BLOCK 1 , PRODUCT DEFINITION BLOCK.
C*                --------------------------------------------------
C*                IB1PAR - INTEGER ARRAY (DIMENSION 17) OF PRODUCT
C*                         DEFINITION INFORMATION.
C*
C*                WORD      CONTENTS
C*                ----      --------
C*                  1       ORIGINATING CENTRE IDENTIFIER.
C*                  2       MODEL IDENTIFICATION.
C*                  3       GRID DEFINITION.
C*                  4       FLAG ( CODE TABLE 1 ).
C*                  5       PARAMETER IDENTIFIER (CODE TABLE 2).
C*                  6       TYPE OF LEVEL (CODE TABLE 3).
C*                 7-8      VALUE(S) OF LEVEL (CODE TABLE 3).
C*                  9       YEAR OF DATA
C*                 10       MONTH OF DATA
C*                 11       DAY OF DATA
C*                 12       HOUR OF DATA
C*                 13       MINUTE OF DATA
C*                 14       TIME UNIT (CODE TABLE 4).
C*                 15       TIME RANGE ONE
C*                 16       TIME RANGE TWO
C*                 17       TIME RANGE FLAG (CODE TABLE 5).
C*
C*                          VALUE(S) OF LEVEL CAN OCCUPY 2 WORDS.
C*                          FOR A LAYER THE FIRST WORD DEFINES THE TOP
C*                          AND THE SECOND THE BOTTOM OF THE LAYER.
C*                          FOR A SINGLE LEVEL, ONLY THE FIRST WORD IS
C*                          USED.
C*
C*                PARAMETERS FOR BLOCK 2 , GRID DEFINITION BLOCK.
C*                -----------------------------------------------
C*                IB2PAR - INTEGER ARRAY (DIMENSION 11) CONTAINING GRID
C*                         DEFINITION INFORMATION.
C*                         USE VARIES WITH REPRESENTATION TYPE.
C*
C*                WORD      LAT/LONG GRID
C*                ----      -------------
C*                 1        DATA REPRESENTATION TYPE (CODE TABLE 6)
C*                 2        NO. OF POINTS ALONG A LATITUDE
C*                 3        NO. OF POINTS ALONG A MERIDIAN
C*                 4        LATITUDE OF ORIGIN (SOUTH - IVE).
C*                 5        LONGITUDE OF ORIGIN (WEST - IVE).
C*                 6        EXTREME POINT/INCREMENTS FLAG.(CODE TABLE 7)
C*                 7        LATITUDE OF EXTREME POINT (SOUTH - IVE).
C*                 8        LONGITUDE OF EXTREME POINT (WEST - IVE).
C*                 9        LATITUDE INCREMENT
C*                10        LONGITUDE INCREMENT
C*                11        SCANNING MODE (CODE TABLE 8)
C*
C*                WORD      GAUSSIAN GRID
C*                ----      -------------
C*                1-9       AS FOR LAT/LONGITUDE GRID.
C*                10        THE NUMBER OF LATITUDE LINES BETWEEN A POLE
C*                          AND THE EQUATOR.
C*                11        SCANNING MODE (CODE TABLE 8)
C*
C*                WORD      SPHERICAL HARMONICS
C*                ----      -------------------
C*                  1       DATA REPRESENTATION TYPE (CODE TABLE 6)
C*                  2       J - PENTAGONAL RESOLUTION PARAMETER
C*                  3       K - PENTAGONAL RESOLUTION PARAMETER
C*                  4       M - PENTAGONAL RESOLUTION PARAMETER
C*                  5       REPRESENTATION TYPE (CODE TABLE 9)
C*                  6       REPRESENTATION MODE (CODE TABLE 10)
C*                7-11      NOT USED
C*
C*
C*                USE FOR OTHER DATA REPRESENTATION TYPES IS
C*                TO BE DEFINED LATER.
C*
C*                FVERT  - REAL ARRAY OF VERTICAL COORDINATE PARAMETERS
C*                ILENV  - LENGTH OF THIS ARRAY (NUMBER OF COORDINATE
C*                         PARAMETERS).
C*
C*                USED FOR HYBRID LEVELS ONLY.
C*
C*
C*                PARAMETERS FOR BLOCK 3 , BIT-MAP DEFINITION BLOCK.
C*                --------------------------------------------------
C*
C*                TO BE DEFINED LATER.
C*
C*                PARAMETERS FOR BLOCK 4 , BINARY DATA BLOCK.
C*                -------------------------------------------
C*                FPDATA  - ARRAY OF FLOATING POINT VALUES.
C*                ILENF   - LENGTH OF THIS ARRAY (NUMBER OF DATA
C*                          VALUES TO BE CODED)
C*                IBITS   - NUMBER OF BITS FOR CODED DATA VALUES.
C*
C*                          TO INDICATE MISSING DATA VALUES, ILENF IS
C*                          MADE NEGATIVE AND ALL DATA VALUES SET TO 0.
C*
C*                OTHER PARAMETERS
C*                ----------------
C*
C*                NBIT    - NUMBER OF BITS IN COMPUTER WORD.
C*
C*                IGRIB   - ARRAY TO RECEIVE DATA IN GRIB CODE.
C*                ILENG   - LENGTH OF THIS ARRAY.
C*
C*                IROUND  - 0 , NO ROUNDING.
C*                          1 , ROUND TO NEAREST 120 OCTETS.
C*
C*    OUTPUT    : IGRIB   - DATA CODED IN GRIB CODE.
C*                IWORD   - NUMBER OF WORDS OCCUPIED BY CODED DATA.
C*
C*                IERR    - ERROR INDICATOR.
C*
C*                           0, NO ERROR.
C*
C*                          -1, NUMBER OF BITS PER DATA VALUE EXCEEDS
C*                              WORD LENGTH, OR MAXIMUM ALLOWED.
C*                          -2, OUTPUT ARRAY TOO SMALL TO HOLD CODED
C*                              DATA VALUES.
C*                          -3, CURRENTLY UNDEFINED OPTION SELECTED.
C*                          -4, MISSING DATA FIELD CONTAINS NON-ZERO.
C*
C*                           1, INVALID ORIGINATING CENTRE.
C*                           2, INVALID MODEL IDENTIFICATION.
C*                           3, INVALID GRID DEFINITION.
C*                           4, INVALID BLOCK INDICATOR FLAG
C*                           5, INVALID PARAMETER IDENTIFIER.
C*                           6, INVALID LEVEL TYPE INDICATOR.
C*                           7, ERROR IN DESCRIPTION OF LEVELS.
C*                           8, DATE/TIME ERROR.
C*                           9, INVALID TIME UNIT OR RANGE.
C*                          10, INVALID DATA REPRESENTATION TYPE.
C*                          11, INVALID EXTREME POINT/INCREMENT FLAG.
C*
C*    JOHN HENNESSY , ECMWF , 15TH APRIL 1985
C*
C*
C----<
C     ---------------------------------------------------------------
C
C
C
C
C
C
      DIMENSION FPDATA(*),ILAT(2)
      DIMENSION IGRIB(ILENG),IBLOCK(24)
      DIMENSION FVERT(ILENV),IB1PAR(17),IB2PAR(11)
C
      EQUIVALENCE (ZGRIB,JGRIB)
C
C
C     SET MAXIMUM NUMBER OF BITS PER DATA FIELD.
C
      DATA IMAX /60/
C
C     CLEAR ERROR INDICATOR.
C
      IERR = 0
C
C
C
C
C
C********************************************************************
C*
C*    CHECK FOR MISSING DATA INDICATORS.
C*
C********************************************************************
C
C
      IMISS = 0
      IF (ILENF.LT.0)
     C   THEN
             KLENF = - ILENF
             IMISS = 1
             DO 50 I=1,KLENF
                IF (FPDATA(I).NE.0.)
     C             THEN
                       IERR = -4
                       WRITE (*,9012)
 9012                  FORMAT (1H ,'NON-ZERO VALUE IN MISSING DATA',
     C                          ' FIELD.')
                       RETURN
                   ENDIF
   50        CONTINUE
         ELSE
             KLENF = ILENF
         ENDIF
C
C
C
C
C********************************************************************
C*
C*    CHECK NUMBER OF BITS PER DATA FIELD.
C*
C********************************************************************
C
C
      IF (IBITS.GT.NBIT.OR.IBITS.GT.IMAX)
     C    THEN
              IERR = -1
              WRITE (*,9000) IBITS,NBIT,IMAX
 9000         FORMAT (1H ,'NUMBER OF BITS PER DATA VALUE, ',I3,
     C                'EXCEEDS WORD LENGTH, ',I3,' OR MAXIMUM ',
     C                ' PERMITTED VALUE, ',I3)
              RETURN
          ENDIF
C
C
C
C
C
C
C
C
C
C
C
C********************************************************************
C*
C*    BLOCK 1 - PRODUCT DEFINITION BLOCK.
C*
C********************************************************************
C
C
C
C***
C*    THE LETTERS G R I B ARE INSERTED IN THE
C*    FIRST 4 ELEMENTS OF 'IBLOCK'.
C***
C
      IBLOCK(1) = 71
      IBLOCK(2) = 82
      IBLOCK(3) = 73
      IBLOCK(4) = 66
C
C
C
C
C
C
C
C
C***
C*    IDENTIFICATION OF CENTRE
C***
      IBLOCK(5) = IB1PAR(1)
      IF (IB1PAR(1).LT.1.OR.IB1PAR(1).GT.98)
     C   THEN
             IERR = 1
             WRITE (*,9001) IB1PAR(1)
 9001        FORMAT (1H ,'INVALID ORIGINATING CENTRE ',I3)
             RETURN
         ENDIF
C
C
C
C
C
C
C
C***
C*    MODEL IDENTIFICATION
C***
C
      IBLOCK(6) = IB1PAR(2)
      IF (IB1PAR(2).LT.1.OR.IB1PAR(2).GT.255)
     C   THEN
             IERR = 2
             WRITE (*,9002) IB1PAR(2)
 9002        FORMAT (1H ,'INVALID MODEL IDENTIFICATION ',I4)
             RETURN
         ENDIF
C
C
C
C
C
C
C
C
C***
C*    GRID DEFINITION
C***
C
      IBLOCK(7) = IB1PAR(3)
      IF (IB1PAR(3).LT.1.OR.IB1PAR(3).GT.255)
     C   THEN
             IERR = 3
             WRITE (*,9003) IB1PAR(3)
 9003        FORMAT (1H ,'INVALID GRID IDENTIFICATION ',I4)
             RETURN
         ENDIF
C
C
C
C
C
C
C
C
C***
C*    OPTIONAL BLOCK INDICATOR FLAG ( CODE TABLE 1 ).
C***
C
      IBLOCK(8) = IB1PAR(4)
      IF (IB1PAR(4).LT.0.OR.IB1PAR(4).GT.3)    IERR = 4
C
C     CHECK IF GRID SPECIFIED IS UNCATALOGUED.
C
      IF (IB1PAR(3).EQ.255.AND.IB1PAR(4).EQ.0) IERR = 4
      IF (IB1PAR(3).EQ.255.AND.IB1PAR(4).EQ.2) IERR = 4
C
      IF (IERR.NE.0)
     C   THEN
             WRITE (*,9004) IB1PAR(4)
 9004        FORMAT (1H ,'INVALID BLOCK INDICATOR ',I4)
             RETURN
         ENDIF
C
C
C
C
C***
C*    PARAMETER IDENTIFIER ( CODE TABLE 2 ).
C***
C
      IBLOCK(9) = IB1PAR(5)
      IF (IB1PAR(5).LT.0.OR.IB1PAR(5).GT.255)
     C   THEN
             IERR = 5
             WRITE (*,9005) IB1PAR(5)
 9005        FORMAT (1H ,'INVALID PARAMETER ',I4)
             RETURN
         ENDIF
C
C
C
C
C***
C*    INDICATOR OF LEVEL TYPE ( CODE TABLE 3 ).
C***
C
      IBLOCK(10) = IB1PAR(6)
      IF (IB1PAR(6).LT.0.OR.IB1PAR(6).GT.110)
     C   THEN
             IERR = 6
             WRITE (*,9006) IB1PAR(6)
 9006        FORMAT (1H ,'INVALID LEVEL TYPE ',I4)
             RETURN
         ENDIF
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C***
C*    DESCRIPTION OF LEVEL OR LAYER ( CODE TABLE 3 ).
C***
C
C
C
C     FOR CERTAIN SPECIAL LEVELS NO FURTHER DESCRIPTION IS
C     NECESSARY, AND THE FIELDS ARE SET TO 0.
C
      IF (IB1PAR(6).LT.100.OR.IB1PAR(6).EQ.102)
     C    THEN
              IB1PAR(7) = 0
              IB1PAR(8) = 0
          ENDIF
C
      IBLOCK(11) = IB1PAR(7)
      IBLOCK(12) = IB1PAR(8)
C
C     CERTAIN LEVEL TYPES REQUIRE THAT THE DESCRIPTION OCCUPY
C     BOTH 8 BIT FIELDS.
C
      IF (IB1PAR(6).EQ.100.OR.IB1PAR(6).EQ.103.OR.IB1PAR(6).EQ.105.
     C    OR.IB1PAR(6).EQ.107.OR.IB1PAR(6).EQ.109)
     C    THEN
              IBLOCK(12) = IBLOCK(11)
              IBLOCK(11) = IBLOCK(11) / 32
              IBLOCK(12) = IBLOCK(12) - IBLOCK(11) * 32
              IF (IB1PAR(7).GT.65535) IERR = 7
          ELSE
              IF (IB1PAR(7).GT.255.OR.IB1PAR(8).GT.255) IERR = 7
          ENDIF
C
      IF (IERR.NE.0)
     C    THEN
              WRITE (*,9007) IB1PAR(7),IB1PAR(8)
 9007         FORMAT (1H ,'LEVEL DESCRIPTION ERROR ',I8,3X,I8)
              RETURN
          ENDIF
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C***
C*    DATE AND TIME
C***
C
      IBLOCK(13) = IB1PAR(9)
      IF (IB1PAR(9).LT.0.OR.IB1PAR(9).GT.99)   IERR = 8
      IBLOCK(14) = IB1PAR(10)
      IF (IB1PAR(10).LT.1.OR.IB1PAR(10).GT.12) IERR = 8
      IBLOCK(15) = IB1PAR(11)
      IF (IB1PAR(11).LT.1.OR.IB1PAR(11).GT.31) IERR = 8
      IBLOCK(16) = IB1PAR(12)
      IF (IB1PAR(12).LT.0.OR.IB1PAR(12).GT.23) IERR = 8
      IBLOCK(17) = IB1PAR(13)
      IF (IB1PAR(13).LT.0.OR.IB1PAR(13).GT.59) IERR = 8
C
      IF (IERR.NE.0)
     C    THEN
              WRITE (*,9008) IB1PAR(9),IB1PAR(10),IB1PAR(11),IB1PAR(12),
     C                       IB1PAR(13)
 9008         FORMAT (1H ,'INVALID DATE/TIME ',3I2,' / ',2I2)
              RETURN
          ENDIF
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C***
C*    UNIT OF TIME , TIME RANGE(S) AND TIME RANGE FLAG ( CODE TABLE 5 ).
C***
C
C     TIME UNIT.
C
      IBLOCK(18) = IB1PAR(14)
      IF (IB1PAR(14).LT.0.OR.IB1PAR(14).GT.90) IERR = 9
C
C     THERE CAN BE ONE OR TWO TIME RANGES, EACH IN 1 OCTECT OR
C     ONE TIME RANGE IN 2 OCTECTS.
C
      IF (IB1PAR(17).EQ.0.OR.IB1PAR(17).EQ.10)   IB1PAR(16)  = 0
C
C     CROSS CHECK RANGE VALUES AND FLAG VALUES.
C
      IF (IB1PAR(15).GT.65535.OR.IB1PAR(15).LT.0)   IERR = 9
      IF (IB1PAR(15).GT.255.AND.IB1PAR(17).NE.10)   IERR = 9
      IF (IB1PAR(16).GT.255.OR.IB1PAR(16).LT.0)     IERR = 9
      IF (IB1PAR(17).LT.0.OR.IB1PAR(17).GT.10)      IERR = 9
      IF (IERR.NE.0)
     C    THEN
              WRITE (*,9009) IB1PAR(14),IB1PAR(15),IB1PAR(16),IB1PAR(17)
 9009         FORMAT (1H ,'TIME UNIT/RANGE1/RANGE2/FLAG ERROR - ',
     C                I8,2X,'/',I8,2X,'/',I8,2X,'/',I8)
              RETURN
          ENDIF
C
      IBLOCK(19) = IB1PAR(15)
      IBLOCK(20) = IB1PAR(16)
C
C     ONE TIME RANGE OCCUPYING BOTH OCTETS.
C
      IF (IB1PAR(17).EQ.10)
     C   THEN
             IBLOCK(20) = IBLOCK(19)
             IBLOCK(19) = IBLOCK(19) / 32
             IBLOCK(20) = IBLOCK(20) - IBLOCK(19) * 32
         ENDIF
C
C     TIME RANGE FLAG
C
      IBLOCK(21) = IB1PAR(17)
C
C
C
C
C
C
C
C
C
C
C***
C*    RESERVED ELEMENTS.
C***
C
      IBLOCK(22) = 0
      IBLOCK(23) = 0
      IBLOCK(24) = 0
C
C
C
C
C
C
C
C********************************************************************
C*
C*    PACK 24 8-BIT FIELDS OF BLOCK 1 IN CODED ARRAY.
C*
C********************************************************************
C
      IWORD = 1
      IBYTE = 8
      NVAL = 24
      IOFF = 0
C
      CALL SBYTES (IGRIB(IWORD),IBLOCK(1),IOFF,IBYTE,0,NVAL)
      CALL OFFSET (IOFF,NVAL,IWORD,IBYTE,NBIT,ILENG,IERR)
      IF (IERR.NE.0) RETURN
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C********************************************************************
C*
C*    BLOCK 2 - GRID DESCRIPTION BLOCK.
C*
C********************************************************************
C
C
C
C
C***
C*    SET ARRAY IBLOCK TO 0 . IT IS USED TO ZERO FILL RESERVED OCTETS.
C***
C
      DO 100 I=1,24
         IBLOCK(I) = 0
  100 CONTINUE
C
C
C
C
C***
C*    LAT/LONGITUDE GRID, GAUSSIAN GRID AND SPHERICAL HARMONICS
C*    ARE THE ONLY DATA REPRESENTATIONS HANDLED.
C***
C
      IF (IB1PAR(4).EQ.1.OR.IB1PAR(4).EQ.3)
     C   THEN
             IF (IB2PAR(1).NE.0.AND.IB2PAR(1).NE.4.AND.IB2PAR(1).NE.50)
     C          THEN
                     WRITE (*,*)'GRID DESCRIPTION BLOCK NOT YET DEFINED'
                     IERR = -3
                     RETURN
                ENDIF
C
C
C
C
C***
C*       LENGTH OF GRID DESCRIPTION BLOCK.
C***
C
C        LENGTH IS 32 OCTETS FOR LAT/LONG, GAUSSIAN AND SPHERICAL
C        HARMONICS . FOR ANY DATA  ON HYBRID LEVELS THE
C        VERTICAL COORDINATES ARE ADDED.
C
         I = 32
         IF (IB1PAR(6).GT.108) I = I + ILENV * 4
C
         CALL SBYTE (IGRIB(IWORD),I,IOFF,24)
         CALL OFFSET (IOFF,1,IWORD,24,NBIT,ILENG,IERR)
         IF (IERR.NE.0) RETURN
C
C
C
C
C***
C*       NUMBER OF UNUSED BITS AT END OF BLOCK.
C*       CURRENT DEFINITION IMPLIES 0.
C***
C
         CALL SBYTE (IGRIB(IWORD),IBLOCK(1),IOFF,8)
         CALL OFFSET (IOFF,1,IWORD,8,NBIT,ILENG,IERR)
         IF (IERR.NE.0) RETURN
C
C
C
C
C
C***
C*       NEXT OCTET IS RESERVED.
C***
C
         CALL SBYTE (IGRIB(IWORD),IBLOCK(I),IOFF,8)
         CALL OFFSET (IOFF,1,IWORD,8,NBIT,ILENG,IERR)
         IF (IERR.NE.0) RETURN
C
C
C
C
C
C
C***
C*       DATA REPRESENTATION TYPE.
C***
C
         IF (IB2PAR(1).LT.0.OR.IB2PAR(1).GT.4) IERR = 10
         IF (IB2PAR(1).EQ.50) IERR = 0
         IF (IERR.NE.0)
     C      THEN
                IERR = 10
                WRITE (*,9010) IB2PAR(1)
 9010           FORMAT (1H ,'INVALID DATA REPRESENTATION TYPE - ',I3)
                RETURN
            ENDIF
         CALL SBYTE (IGRIB(IWORD),IB2PAR(1),IOFF,8)
         CALL OFFSET (IOFF,1,IWORD,8,NBIT,ILENG,IERR)
         IF (IERR.NE.0) RETURN
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C***
C*       LAT/LONG OR GAUSSIAN GRID.
C***
C
         IF (IB2PAR(1).EQ.0.OR.IB2PAR(1).EQ.4)
     C    THEN
C
C            NUMBER OF LAT/LONG POINTS.
C
             CALL SBYTES (IGRIB(IWORD),IB2PAR(2),IOFF,16,0,2)
             CALL OFFSET (IOFF,2,IWORD,16,NBIT,ILENG,IERR)
             IF (IERR.NE.0) RETURN
C
C            LAT/LONG OF ORIGIN.
C            SIGN BIT SET TO 1 IF VALUES ARE NEGATIVE.
C
             DO 200 I=1,2
                ILAT(I) = IB2PAR(I+3)
                ISIGN   = 0
                IF (ILAT(I).LT.0)
     C            THEN
                      ISIGN   = 8388608
                      ILAT(I) = - ILAT(I)
                  ENDIF
                ILAT(I) = ILAT(I) + ISIGN
  200        CONTINUE
C
             CALL SBYTES (IGRIB(IWORD),ILAT(1),IOFF,24,0,2)
             CALL OFFSET (IOFF,2,IWORD,24,NBIT,ILENG,IERR)
             IF (IERR.NE.0) RETURN
C
C            EXTREME POINT / INCREMENTS FLAG.
C            SET TO 0 UNUSED EXTREME POINT/ INCREMENT FIELDS.
C
             IF (IB2PAR(6).LE.1.OR.IB2PAR(6).GT.3)
     C          THEN
                    WRITE (*,9011) IB2PAR(6)
 9011               FORMAT (1H ,'INVALID EXTREME POINT / INCREMENT',
     C                          ' FLAG - ',I3)
                    IERR = 11
                    RETURN
                ENDIF
C
             IF (IB2PAR(6).EQ.1)
     C          THEN
                    IB2PAR(7) = 0
                    IB2PAR(8) = 0
                ENDIF
C
             IF (IB2PAR(6).EQ.2)
     C          THEN
                    IB2PAR(9)  = 0
                    IB2PAR(10) = 0
                ENDIF
C
             CALL SBYTE (IGRIB(IWORD),IB2PAR(6),IOFF,8)
             CALL OFFSET (IOFF,1,IWORD,8,NBIT,ILENG,IERR)
             IF (IERR.NE.0) RETURN
C
C            LAT/LONG OF EXTREME POINT.
C
C            SIGN BIT SET TO 1 IF VALUES ARE NEGATIVE.
C
             DO 300 I=1,2
                ILAT(I) = IB2PAR(I+6)
                ISIGN   = 0
                IF (ILAT(I).LT.0)
     C            THEN
                      ISIGN   = 8388608
                      ILAT(I) = - ILAT(I)
                  ENDIF
                ILAT(I) = ILAT(I) + ISIGN
  300        CONTINUE
C
             CALL SBYTES (IGRIB(IWORD),ILAT(1),IOFF,24,0,2)
             CALL OFFSET (IOFF,2,IWORD,24,NBIT,ILENG,IERR)
             IF (IERR.NE.0) RETURN
C
C
C
C            DIRECTION INCREMENTS / NUMBER OF LATITUDE LINES.
C
             CALL SBYTES (IGRIB(IWORD),IB2PAR(9),IOFF,16,0,2)
             CALL OFFSET (IOFF,2,IWORD,16,NBIT,ILENG,IERR)
             IF (IERR.NE.0) RETURN
C
C            SCANNING MODE.
C
             CALL SBYTE (IGRIB(IWORD),IB2PAR(11),IOFF,8)
             CALL OFFSET (IOFF,1,IWORD,8,NBIT,ILENG,IERR)
             IF (IERR.NE.0) RETURN
C
C            4 RESERVED OCTETS.
C
             CALL SBYTES (IGRIB(IWORD),IBLOCK(1),IOFF,8,0,4)
             CALL OFFSET (IOFF,4,IWORD,8,NBIT,ILENG,IERR)
             IF (IERR.NE.0) RETURN
C
          ENDIF
C
C
C
C
C
C
C
C
C
C
C
C***
C*       SPHERICAL HARMONIC DATA.
C***
C
         IF (IB2PAR(1).EQ.50)
     C    THEN
C
C            PENTAGONAL RESOLUTION PARAMETERS.
C
             CALL SBYTES (IGRIB(IWORD),IB2PAR(2),IOFF,16,0,3)
             CALL OFFSET (IOFF,3,IWORD,16,NBIT,ILENG,IERR)
             IF (IERR.NE.0) RETURN
C
C            REPRESENTATION TYPE AND MODE.
C
             CALL SBYTES (IGRIB(IWORD),IB2PAR(5),IOFF,8,0,2)
             CALL OFFSET (IOFF,2,IWORD,8,NBIT,ILENG,IERR)
             IF (IERR.NE.0) RETURN
C
C            18 RESERVED OCTETS.
C
             CALL SBYTES (IGRIB(IWORD),IBLOCK(1),IOFF,8,0,18)
             CALL OFFSET (IOFF,18,IWORD,8,NBIT,ILENG,IERR)
             IF (IERR.NE.0) RETURN
C
          ENDIF
C
C
C
C
C***
C*       ADD VERTICAL COORDINATE PARAMETERS FOR HYBRID LEVELS.
C***
C
         IF (IB1PAR(6).GT.108)
     C    THEN
             DO 400 I=1,ILENV
                 CALL CONFP (FVERT(I),IEXP,IMANT)
                 CALL SBYTE (IGRIB(IWORD),IEXP,IOFF,8)
                 CALL OFFSET (IOFF,1,IWORD,8,NBIT,ILENG,IERR)
                 IF (IERR.NE.0) RETURN
                 CALL SBYTE (IGRIB(IWORD),IMANT,IOFF,24)
                 CALL OFFSET (IOFF,1,IWORD,24,NBIT,ILENG,IERR)
                 IF (IERR.NE.0) RETURN
  400        CONTINUE
C
          ENDIF
C
         ENDIF
C
C
C
C
C
C
C
C
C
C********************************************************************
C*
C*    BLOCK 3 (IF REQUIRED) - BIT MAP BLOCK.
C*
C********************************************************************
C
      IF (IB1PAR(4).EQ.2.OR.IB1PAR(4).EQ.3)
     C     THEN
               WRITE (*,*)'BIT MAP BLOCK NOT YET DEFINED'
               IERR = -3
               RETURN
           ENDIF
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C********************************************************************
C*
C*    BLOCK 4 - BINARY DATA BLOCK.
C*
C********************************************************************
C
C
C***
C*    RETAIN POINTERS TO WORD AND BIT POSITION OF BINARY DATA
C*    BLOCK LENGTH FIELD. ENTER LENGTH AS 0.
C***
C
      IPW = IWORD
      IPB = IOFF
C
      CALL SBYTE (IGRIB(IWORD),IBLOCK(1),IOFF,24)
      CALL OFFSET (IOFF,1,IWORD,24,NBIT,ILENG,IERR)
      IF (IERR.NE.0) RETURN
C
C
C
C
C
C
C
C
C
C
C
C***
C*    4 BIT FLAG / 4 BIT COUNT OF UNUSED BITS AT END OF BLOCK OCTET.
C***
C
C     FLAG IS 1 FOR SPHERICAL HARMONICS, 0 FOR LAT/LONG OR GAUSSIAN.
C
      IREP = 0
      IF (IB2PAR(1).EQ.50) IREP = 1
      IFLAG = IREP * 16
C
      CALL SBYTE (IGRIB(IWORD),IFLAG,IOFF,8)
      CALL OFFSET (IOFF,1,IWORD,8,NBIT,ILENG,IERR)
      IF (IERR.NE.0) RETURN
C
C
C
C
C
C
C
C
C
C
C
C***
C*    FIND MAXIMUM AND MINIMUM VALUES IN DATA ARRAY. FOR
C*    DATA IN SPHERICAL HARMONIC FORM THE FIRST WORD CONTAINS
C*    THE REAL (0,0)COEFFICIENT, WHICH IS TREATED SEPARATELY.
C***
C
C
      ILEN = KLENF - IREP
      CALL MXMN (FPDATA(IREP+1),ILEN,FMAX,FMIN)
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C***
C*    SCALE FACTOR.
C***
C
C     CALCULATE SCALE FACTOR
C
      S = (FMAX-FMIN)/(2**(IBITS+1)-1)
      IF (S.NE.0.) S = ALOG(S)/ALOG(2.) + 2.
      ISCALE = MIN(INT(S),INT(S+SIGN(1.,S)))
C
C
C
C
C     SET SIGN BIT (BIT 16) AND PUT SCALE FACTOR INTO REMAINING
C     15 BITS OF CODED 16 BIT FIELD.
C
      JSCALE = ISCALE
      ISIGN = 0
      IF (JSCALE.LT.0)
     C    THEN
              ISIGN  = 32768
              JSCALE = - JSCALE
          ENDIF
      JSCALE = JSCALE + ISIGN
C
      ZSCALE = 2.**ISCALE
C
C     FOR MISSING DATA SCALE FACTOR IS SET TO ALL 1-BITS.
C
      IF (IMISS.EQ.1) JSCALE = 65535
C
      CALL SBYTE (IGRIB(IWORD),JSCALE,IOFF,16)
      CALL OFFSET (IOFF,1,IWORD,16,NBIT,ILENG,IERR)
      IF (IERR.NE.0) RETURN
C
C
C
C
C
C
C
C
C
C***
C*    MINIMUM (REFERENCE) VALUE.
C***
C
C     CONVERT MINIMUM VALUE (FMIN) TO GRIB FORMAT (IEXP,IMANT)
C
      CALL CONFP (FMIN,IEXP,IMANT)
C
C     EXPONENT AND MANTISSA SET TO ALL 1-BITS FOR MISSING DATA.
C
      IF (IMISS.EQ.1)
     C   THEN
             IEXP  = 255
             IMANT = 16777215
         ENDIF
      CALL SBYTE (IGRIB(IWORD),IEXP,IOFF,8)
      CALL OFFSET (IOFF,1,IWORD,8,NBIT,ILENG,IERR)
      IF (IERR.NE.0) RETURN
      CALL SBYTE (IGRIB(IWORD),IMANT,IOFF,24)
      CALL OFFSET (IOFF,1,IWORD,24,NBIT,ILENG,IERR)
      IF (IERR.NE.0) RETURN
C
C
C
C
C***
C*    NUMBER OF BITS IN EACH DATA VALUE.
C***
C
      CALL SBYTE (IGRIB(IWORD),IBITS,IOFF,8)
      CALL OFFSET (IOFF,1,IWORD,8,NBIT,ILENG,IERR)
      IF (IERR.NE.0) RETURN
C
C
C
C
C***
C*    IF SPHERICAL HARMONICS DATA, NEXT 4 OCTETS ARE DIFFERENT FORMAT.
C***
C
      IF (IREP.EQ.1)
     C    THEN
C
C            STORE REAL (0,0) COEFFICIENT IN FLOATING
C            POINT FORM.
C
             CALL CONFP (FPDATA(1),IEXP,IMANT)
C
             CALL SBYTE (IGRIB(IWORD),IEXP,IOFF,8)
             CALL OFFSET (IOFF,1,IWORD,8,NBIT,ILENG,IERR)
             IF (IERR.NE.0) RETURN
             CALL SBYTE (IGRIB(IWORD),IMANT,IOFF,24)
             CALL OFFSET (IOFF,1,IWORD,24,NBIT,ILENG,IERR)
             IF (IERR.NE.0) RETURN
          ENDIF
C
C
C
C
C***
C*    SCALE AND STORE DATA VALUES.
C***
C
      DO 600 I = IREP+1 , KLENF
         JGRIB     = NINT ( (FPDATA(I)-FMIN) / ZSCALE )
         FPDATA(I) = ZGRIB
  600 CONTINUE
C
      ILENFM = KLENF - IREP
      CALL SBYTES (IGRIB(IWORD),FPDATA(IREP+1),IOFF,IBITS,0,ILENFM)
      CALL OFFSET (IOFF,ILENFM,IWORD,IBITS,NBIT,ILENG,IERR)
      IF (IERR.NE.0) RETURN
C
C
C
C
C
C
C
C
C
C
C
C***
C*    ENTER LENGTH OF BINARY DATA BLOCK, HAVING ENSURED THAT
C*    THE LENGTH IS AN EVEN NUMBER OF OCTETS.
C***
C
C     LENGTH OF BINARY DATA BLOCK IN BITS.
C
      LBIN = (IWORD-IPW) * NBIT + IOFF - IPB
C
      L = LBIN / 16
      L = LBIN - ( L*16 )
C
C     FILL UNUSED PORTION OF LAST 2 OCTETS WITH BINARY ZEROES.
C
      LNIL = 0
      IF (L.NE.0)
     C    THEN
              LNIL = 16 - L
              CALL SBYTE (IGRIB(IWORD),IFILL,IOFF,LNIL)
              CALL OFFSET (IOFF,1,IWORD,LNIL,NBIT,ILENG,IERR)
              IF (IERR.NE.0) RETURN
          ENDIF
C
      LBIN = (IWORD-IPW) * NBIT + IOFF - IPB
C
C     ENTER LENGTH - IN OCTETS - OF DATA BLOCK.
C
      LBIN = LBIN / 8
      CALL SBYTE (IGRIB(IPW),LBIN,IPB,24)
      CALL OFFSET (IPB,1,IPW,24,NBIT,ILENG,IERR)
C
C     ENTER NUMBER OF UNUSED BITS IN FLAG/BIT COUNT FIELD.
C
      IFLAG = IFLAG + LNIL
      CALL SBYTE (IGRIB(IPW),IFLAG,IPB,8)
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C********************************************************************
C*
C*    BLOCK 5 - END BLOCK.
C*
C********************************************************************
C
C
C***
C*    ADD 7 7 7 7 TO CODED DATA.
C***
C
      IBLOCK(1) = 55
      IBLOCK(2) = 55
      IBLOCK(3) = 55
      IBLOCK(4) = 55
C
      CALL SBYTES (IGRIB(IWORD),IBLOCK(1),IOFF,8,0,4)
      CALL OFFSET (IOFF,4,IWORD,8,NBIT,ILENG,IERR)
      IF (IERR.NE.0) RETURN
C
C
C***
C*    SET ANY UNUSED PART OF LAST WORD TO BINARY ZEROES.
C***
C
      IF (IOFF.NE.0)
     C   THEN
             KBITS = NBIT - IOFF
             CALL SBYTE (IGRIB(IWORD),IFILL,IOFF,KBITS)
         ELSE
             IWORD = IWORD - 1
         ENDIF
C
C
C
C***
C*    ROUND TO 120 OCTETS, IF REQUIRED.
C***
C
      IF (IROUND.EQ.1)
     C   THEN
             NUMBIT = IWORD * NBIT
             I = NUMBIT / 960
             I = I * 960
             I = NUMBIT - I
             IF (I.NE.0) I = (960 - I) / NBIT
C
             DO 700 J=IWORD+1,IWORD+I
                IGRIB(J) = 0
  700        CONTINUE
C
             IWORD = IWORD + I
         ENDIF
C
      RETURN
      END

C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      subroutine swap_bytes8(r1,r2)
c     ---------------------------------
      implicit none

      real*8 r1, r2
      real*8 r18
      real*8 r28
      integer*8 kint18,kint28

      equivalence(r18,kint18)
      equivalence(r28,kint28)



c Reverse order of bytes

      r18=r1

      call mvbits(kint18, 56, 8, kint28, 0)
      call mvbits(kint18, 48, 8, kint28, 8)
      call mvbits(kint18, 40, 8, kint28,16)
      call mvbits(kint18, 32, 8, kint28,24)
      call mvbits(kint18, 24, 8, kint28,32)
      call mvbits(kint18, 16, 8, kint28,40)
      call mvbits(kint18,  8, 8, kint28,48)
      call mvbits(kint18,  0, 8, kint28,56)


      r2=r28

      return
      end

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE BUUNPS(KBPW,KSOURC,KDEST,KWPT,KBPT,KSIZE,KSKIPB,K,KERR)
C
C**** *BUUNPS*
C
C
C     PURPOSE.
C     --------
C          PURPOSE OF THIS ROUTINE IS TO UNPACK BIT STRING OF
C     KSIZE BITS, STARTED AT WORD KWPT OF ARRAY KSOURC AFTER
C     SKIPPING KBPT BITS. RESULT IS PUT INTO KDEST.
C
C**   INTERFACE.
C     ----------
C
C          *CALL* *BUUNPS(KBPW,KSOURC,KDEST,KWPT,KBPT,KSIZE,KSKIPB,K,KERR)*
C
C        INPUT :
C                 *KBPW*      - NUMBER OF BITS PER COMPUTER WORD
C                 *KSOURC*    - SOURCE (CONTINUOUS BIT STRING OF
C                               ARBITRARY LENGTH)
C                 *KWPT*      - WORD POINTER
C                 *KBPT*      - BIT POINTER
C                 *KSIZE*     - NUMBER OF BITS TO BE EXTRACTED
C                 *KSKIPB*    - NUMBER OF BITS TO SKIP BETWEEN ELEMENTS
C                 *K*         - ITERATION
C        OUTPUT:
C                 *KDEST*     - DESTINATION
C                 *KERR*      - RETURN ERROR CODE
C
C     METHOD.
C     -------
C
C            NONE.
C
C
C     EXTERNALS.
C     ----------
C
C
C          GBYTES     - UNPACK BIT PATTERN
C
C
C     REFERENCE.
C     ----------
C
C          NONE.
C
C     AUTHOR.
C     -------
C
C          M. DRAGOSAVAC    *ECMWF*       15/01/91.
C
C
C     MODIFICATIONS.
C     --------------
C
C          NONE.
C
C
      IMPLICIT LOGICAL(L,O,G), CHARACTER*8(C,H,Y)
C
      DIMENSION KSOURC(*),KDEST(*)
C
C     ------------------------------------------------------------------
C*          1.   EXTRACT BIT PATTERN.
C                --------------------
 100  CONTINUE
C
      IF(KERR.GT.0) RETURN
C
      IF(KSIZE.GT.KBPW) THEN
         KERR=13
         WRITE(KNTN,*)' BUUNPS :'
         CALL BUERR(KERR)
      END IF
C
      CALL GBYTES(KSOURC(KWPT),KDEST,KBPT,KSIZE,KSKIPB,K)
C
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE CREXETDR(KJ,KJ1,KDD,KSTACK,KERR)
C
C**** *CREXETDR*
C
C
C     PURPOSE.
C     --------
C          SOLVE BUFR TABLE D REFERENCE.
C
C
C**   INTERFACE.
C     ----------
C
C          *CALL* *CREXETDR(KJ,KJ1,KDD,KSTACK,KERR)*
C
C        INPUT :
C                 *KDD*      - DATA DESCRIPTOR
C        OUTPUT:
C                 *KJ*       - POINTER TO KSTACK ARRAY
C                 *KJ1*      - POINTER TO LAST ELEMENT IN KSTACK
C                 *KSTACK*   - LIST OF DATA DESCRIPTORS
C                 *KERR*     - RETURN ERROR CODE
C
C
C     METHOD.
C     -------
C
C           NONE.
C
C     EXTERNALS.
C     ----------
C
C           NONE.
C
C     REFERENCE.
C     ----------
C
C          NONE.
C
C     AUTHOR.
C     -------
C
C          M. DRAGOSAVAC    *ECMWF*       01/02/91.
C
C
C     MODIFICATIONS.
C     --------------
C
C          NONE.
C
C
      IMPLICIT LOGICAL(L,O,G), CHARACTER*8(C,H,Y)
C
C
      PARAMETER(JSUP =   9,JSEC0=   3,JSEC1= 40,JSEC2= 64 ,JSEC3=    4,
     1          JSEC4=2,JELEM=40000,JSUBS=400,JCVAL=150 ,JBUFL=40000,
     2          JBPW =  32,JTAB =3000,JCTAB=120,JCTST=1800,JCTEXT= 200,
     3          JWORK=360000,JKEY=46)
C
C
      COMMON /CRWT/ NCREXDWINC,NCREXSCAM,NCREXAFDW,NCREXWT ,ODREPF,
     2             NCREXSTACK(JELEM),NCREXWTEN(JELEM),
     3             NCREXWTR (JELEM),NCREXWTS (JELEM),
     4             NCREXWTDW(JELEM)
C
C             NCREXDWINC   -  data width increment
C             NCREXSCAM    -  scale multiplier
C             NCREXAFDW    -  augmented field data width
C             NCREXWT      -  pointer to working table
C             NCREXSTACK   -  list of data descriptors
C             ODREPF   -  replication (logical)
C             NCREXWTR     -  working table reference
C             NCREXWTS     -  working scale
C             NCREXWTDW    -  working data width
C
      CHARACTER CREXWTEN*64,CREXWTU*24
C
C
      COMMON/CRTAB/ NCREXBR(JTAB),NCREXBS(JTAB)    , NCREXBDW(JTAB),
     1              NCREXDR(JTAB),NCREXDST(JTAB)   ,
     2              NCREXDL(JTAB),NCREXDSQ(JTAB*20),NCREXP(64,255)

C
C             NCREXBR     - table B,  table reference              array
C             NCREXBS     - table B,  scale                        array
C             NCREXBDW    - table B,  data width                   array
C             NCREXDR    - table D,  table reference              array
C             NCREXDST    - table D,  starting pointers            array
C             NCREXDL     - table D,  lengths                      array
C             NCREXDSQ    - table D,  list of sequence descriptors array
C
       COMMON /CRTABC/ CREXNAME(JTAB),CREXUNIT(JTAB)
C
C             CREXNAME      -  table B, ELEMENT NAME           array
C             CREXUNIT      -  table B, unit                   array
C
C
C
      CHARACTER*64 CREXNAME
      CHARACTER*24 CREXUNIT
C
      DIMENSION ILIST(JELEM),KSTACK(*)
C
C     ------------------------------------------------------------------
C
C*          1.   OBTAIN LIST OF DESCRIPTORS FROM BUFR TABLE D.
C                ---------------------------------------------
 100  CONTINUE
C
      IF( KERR.NE.0 ) RETURN
C
      DO 110 J=1,JTAB
C
      IF(KDD.EQ.NCREXDR(J)) THEN
         I=J
         GO TO 120
      END IF
C
 110  CONTINUE
C
      KERR=20
      WRITE(*,*)  'CREXETDR : ',KDD
      CALL CREXERR(KERR)
      RETURN
C
 120  CONTINUE
C
      J1=NCREXDST(I)
      J2=NCREXDL (I)
      J3=0
C
      DO 121 J=J1,J1+J2-1
C
      J3 = J3 +1
      ILIST(J3) = NCREXDSQ(J)
C
 121  CONTINUE
C
C     ------------------------------------------------------------------
C*          2.  PUSH DOWN DATA DESCRIPTION DESCRIPTORS
C               --------------------------------------
C               TO MAKE ROOM FOR LIST.
C               ----------------------
 200  CONTINUE
C
      J2M1=J2-1
C
      DO 210 J=KJ1,KJ+1,-1
C
      KSTACK(J+J2M1) = KSTACK(J)
C
 210  CONTINUE
C
C     ------------------------------------------------------------------
C*          3.  INSERT LIST IN PLACE OF SEQUENCE DESCRIPTORS.
C               ---------------------------------------------
 300  CONTINUE
C
      KJM1=KJ-1
C
      DO 310 J=1,J3
C
      KSTACK(KJM1+J)= ILIST(J)
C
 310  CONTINUE
C
C     ------------------------------------------------------------------
C*          4.  ADJUST DESCRIPTOR COUNT FOR LIST LENGTH.
C               ----------------------------------------
 400  CONTINUE
C
      KJ  = KJ  - 1
      KJ1 = KJ1 +J3 -1
C     ------------------------------------------------------------------
C*          4.1  ADJUST NUMBER OF DATA DESCRIPTORS NOT PRESENT.
C                ----------------------------------------------
 610  CONTINUE
C
      IF(N221.NE.0)  N221= KJ1  - KJ + 1
C     -----------------------------------------------------------------
 500  CONTINUE
C
      RETURN
C
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      INTEGER FUNCTION PACKCF( PARRAY, KTRUNC, KSUBSET, KGRIB, KLENG,
     X                          KNSPT, KBITS)
C
C---->
C**** PACKCF
C
C     Purpose.
C     --------
C
C     Moves the unscaled values from an array of spherical harmonic
C     coefficients, just the first "KSUBSET" triangle of coefficients.
C
C**   Interface.
C     ----------
C
C     IRET = PACKCF(PARRAY,KTRUNC,KSUBSET,KGRIB,KLENG,KNSPT,KBITS)
C
C
C     Input Parameters.
C     -----------------
C
C     PARRAY     - Array of spherical harmonic coefficients.
C     KTRUNC     - Truncation of the spherical harmonic coefficients.
C     KSUBSET    - Number indicating truncation of subset to move.
C     KNSPT      - Bit pointer for next free position in KGRIB.
C
C
C     Output Parameters.
C     ------------------
C
C     KGRIB      - Array containing generated GRIB product.
C     KLENG      - Length of KGRIB
C     KNSPT      - Bit pointer for next free position in KGRIB(updated).
C     KBITS      - Number of bits per computer word.
C
C     Returns 0 if OK, otherwise prints an error message and returns
C     an error code.
C
C
C     Method.
C     -------
C                           <KSUBSET>|
C
C     Given numbers:         cccccccc|cccccc
C                              cccccc|cccccc
C                                cccc|cccccc
C                                  cc|cccccc
C                                    |cccccc
C                                       cccc
C                                         cc
C
C      Converts and moves :  cccccccc
C                              cccccc
C                                cccc
C                                  cc
C
C     Externals.
C     ----------
C
C     CONFP3  - Convert floating point value to storage format
#if (defined CRAY) || (defined __uxp__ ) || (defined IBM_POWER4)
C     GSBITE  - Store bit pattern (Vectorized Fortran).
#endif
C     SBYTES  - Store bit pattern
C
C
C     Reference.
C     ----------
C
C     None.
C
C
C     Comments.
C     ---------
C
C     KSUBSET must be less than or equal to KTRUNC.
C
C
C     Author.
C     -------
C
C     J.D.Chambers     ECMWF      13:04:94
C
C
C     Modifications.
C     --------------
C
C     None.
C
C
C----<
C     ----------------------------------------------------------------
C*    Section 0 . Definition of variables. Data statements.
C     ----------------------------------------------------------------
C
C
      IMPLICIT NONE
C
#include "common/grprs.h"
C
C     Parameters
      INTEGER JPMAXT
      PARAMETER ( JPMAXT = 2047 + 1 )
C
C     Subroutine arguments
C
      INTEGER KTRUNC, KSUBSET, KNSPT, KGRIB, KLENG, KBITS
C
      REAL PARRAY
      DIMENSION PARRAY(*), KGRIB(KLENG)
C
C     Local variables.
      INTEGER JCOL, JROW, INDEX, ILAST, ITRND, IEXP, IMANT, INEXT
      INTEGER INSPT, INEED, IWORD, IOFF
      DIMENSION IEXP(JPMAXT*2), IMANT(JPMAXT*2)
C
#if (defined CRAY) || (defined __uxp__ ) || (defined IBM_POWER4)
C
C     Values in IMASK are set in the first call to routine GSBITE, and
C     are used in subsequent calls.
C
      INTEGER IMASK
      DIMENSION IMASK(65)
      SAVE IMASK
C
C     Force routine GSBITE to calculate bit-masks first time through.
      DATA IMASK(2) /0/
#endif
C
C     ----------------------------------------------------------------
C*    Section 1 . Check for valid truncation and start values.
C     ----------------------------------------------------------------
C
  100 CONTINUE
C
C     Check for valid truncation and subset values
C
      PACKCF = 0
      IF ( KSUBSET .GT. KTRUNC ) THEN
        WRITE(GRPRSM,*) 'PACKCF: Invalid subset/truncation given'
        WRITE(GRPRSM,*) 'PACKCF: KSUBSET, KTRUNC =', KSUBSET, KTRUNC
        PACKCF = 16400
        GOTO 900
      ENDIF
C
C     Check that the GRIB area is big enough.
      INEED = ( KNSPT + (KSUBSET+1)*(KSUBSET+2)*32 ) / KBITS
      IF (INEED.GT.KLENG) THEN
        PACKCF = 16401
        WRITE(GRPRSM,*) 'PACKCF: GRIB area is not big enough.'
        GOTO 900
      ENDIF
C
C     ----------------------------------------------------------------
C*    Section 2. Convert values to IBM format exponent and mantissa.
C                Handle values 2 at a time (real and imaginary parts)
C     ----------------------------------------------------------------
C
  200 CONTINUE
C
      ITRND = 1
      ILAST = KSUBSET+1
      INDEX = -1
C
C     Loop through rows in the subset
      DO 490 JROW = 1 , ILAST
C
C       Pick up columns in subset
        INEXT = 0
        DO 210 JCOL = JROW , KTRUNC+1
          INDEX = INDEX + 2
          IF ( ILAST .GE. JCOL ) THEN
C
C           Convert floating point nos. to GRIB and insert fields.
C           Real part ..
            INEXT = INEXT + 1
            CALL CONFP3( PARRAY(INDEX), IEXP(INEXT), IMANT(INEXT),
     X                   KBITS, ITRND)
C
C           Imaginary part ..
            INEXT = INEXT + 1
            CALL CONFP3( PARRAY(INDEX+1), IEXP(INEXT), IMANT(INEXT),
     X                   KBITS, ITRND)
          ENDIF
  210   CONTINUE
C
C     ----------------------------------------------------------------
C*    Section 3. Move exponents into bit array.
C     ----------------------------------------------------------------
C
  300   CONTINUE
C
C*      Calculate word pointer and offset.
        INSPT = KNSPT
        IWORD = INSPT / KBITS
        IOFF  = INSPT - IWORD * KBITS
        IWORD = IWORD + 1
C
#if (defined CRAY) || (defined __uxp__ ) || (defined IBM_POWER4)
        IF (INEXT.GE.8) THEN
C
C         Vectorising routine GSBITE.
          CALL GSBITE( KGRIB(IWORD), IEXP, IOFF, 8, 24, INEXT, KBITS,
     X                 IMASK, 'C')
        ELSE
C
C         Scalar faster.
          CALL SBYTES( KGRIB(IWORD), IEXP, IOFF, 8, 24, INEXT)
        ENDIF
#elif (defined CYBER)
        CALL SBYTES6( KGRIB(IWORD), IEXP, IOFF, 8, 24, INEXT)
#else
        CALL SBYTES( KGRIB(IWORD), IEXP, IOFF, 8, 24, INEXT)
#endif
C
C     ----------------------------------------------------------------
C*    Section 4. Move mantissae into bit array.
C     ----------------------------------------------------------------
C
  400   CONTINUE
C
C*      Calculate word pointer and offset.
        INSPT = KNSPT + 8
        IWORD = INSPT / KBITS
        IOFF  = INSPT - IWORD * KBITS
        IWORD = IWORD + 1
C
#if (defined CRAY) || (defined __uxp__ ) || (defined IBM_POWER4)
        IF (INEXT.GE.8) THEN
C
C         Vectorising routine GSBITE.
          CALL GSBITE( KGRIB(IWORD), IMANT, IOFF, 24, 8, INEXT, KBITS,
     X                 IMASK, 'C')
        ELSE
C
C         Scalar faster.
          CALL SBYTES( KGRIB(IWORD), IMANT, IOFF, 24, 8, INEXT)
        ENDIF
#elif (defined CYBER)
        CALL SBYTES6( KGRIB(IWORD), IMANT, IOFF, 24, 8, INEXT)
#else
        CALL SBYTES( KGRIB(IWORD), IMANT, IOFF, 24, 8, INEXT)
#endif
C
C       Update the bit pointer
        KNSPT = KNSPT +  32 * INEXT
C
  490 Continue
C     End of loop through rows of the subset
C
C
C     ----------------------------------------------------------------
C*    Section 5. Update pointer.
C     ----------------------------------------------------------------
C
  500 CONTINUE
C
C     ----------------------------------------------------------------
C*    Section 9. Return to calling routine.
C     ----------------------------------------------------------------
C
  900 CONTINUE
C
      RETURN
C
      END

C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      INTEGER FUNCTION AURESOL(NS,EW)
C
C---->
C**** AURESOL
C
C     Purpose
C     -------
C
C     Returns the default truncation for a given
C     latitude--longitude grid resolution.
C
C
C     Interface
C     ---------
C
C     KTRUNC = AURESOL(NS,EW)
C
C     Input
C     -----
C
C     NS     = north-south grid increment in degrees
C     EW     = east-west   grid increment in degrees
C
C     Output
C     ------
C
C     KTRUNC = Triangular truncation (e.g. 106 for T106)
C
C
C     Method
C     ------
C
C       Grid increment           Truncation
C       --------------           ----------
C
C       [2.5 and greater          T63
C
C       [1.5 to 2.5[              T106
C
C       [0.6 to 1.5[              T213
C
C       [0.4 to 0.6[              T319
C
C       [0.3 to 0.4[              T511
C
C       [0.15 to 0.3[             T799
C
C       [0   to 0.15[             T1023
C
C
C     Externals
C     ---------
C
C     None.
C
C     Author
C     ------
C
C     J.D.Chambers ECMWF Mar 1998
C
C
C     Reference.
C     ----------
C
C     None.
C
C     Modifications
C     -------------
C
C     S.Curic     ECMWF        April 2005
C     Add T799 and T1023
C
C ------------------------------------------------------------------
C----<
C
      IMPLICIT NONE
C
#include "parim.h"
#include "nifld.common"
#include "nofld.common"
C
C     Function arguments
C
      REAL NS, EW
C
C     Local variables
C
C     Function statement(s)
C
      REAL STEP
C
      STEP = MIN(ABS(NS),ABS(EW))
C
C     -----------------------------------------------------------------|
C*    Section 1.   Initialise
C     -----------------------------------------------------------------|
C
  100 CONTINUE
C
C     2.5 and greater -> T63
C
      IF( STEP.GE.2.5 ) THEN
        AURESOL = 63
        GOTO 900
      ENDIF
C
C     1.5 to 2.5      -> T106
C
      IF( STEP.GE.1.5 ) THEN
        AURESOL = 106
        GOTO 900
      ENDIF
C
C     0.6 to 1.5      -> T213
C
      IF( STEP.GE.0.6 ) THEN
        AURESOL = 213
        GOTO 900
      ENDIF
C
C     0.4 to 0.6      -> T319
C
      IF( STEP.GE.0.4 ) THEN
        AURESOL = 319
        GOTO 900
      ENDIF
C
C     0.3 to 0.4      -> T511
C
      IF( STEP.GE.0.3 ) THEN
        AURESOL = 511
        GOTO 900
      ENDIF
C
C     0.15 to 0.3      -> T799
C
      IF( STEP.GE.0.15 ) THEN
        AURESOL = 799
        GOTO 900
      ENDIF

C
C     0.09 to 0.15      -> T1279
C
      IF( STEP.GE.0.09 ) THEN
        AURESOL = 1279
        GOTO 900
      ENDIF
C
C     less than 0.09   -> T2047
C
      AURESOL = 2047

C
  900 CONTINUE
C
      END

C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities
C granted to it by virtue of its status as an intergovernmental organisation
C nor does it submit to any jurisdiction.
C

      INTEGER FUNCTION INTOUT( HPARN, INTV, REALV, CHARV)
C
C---->
C**** INTOUT
C
C     Purpose
C     -------
C
C     Change output field parameters in common block.
C
C     Interface
C     ---------
C
C     Input
C     -----
C
C     HPARN - MARS parameter name.
C     INTV  - MARS parameter value(s) (Integer).
C     REALV - MARS parameter value(s) (Real).
C     CHARV - MARS parameter value(s) (Character).
C
C
C     Method
C     ------
C
C     Recognise MARS paramter and reset appropriate common
C     variable value(s).
C
C
C     Externals
C     ---------
C
C     JDEBUG   - Check if debug switched on.
C     IBASINI  - Check basic initialisation of common blocks is done.
C     CHEQUAL  - Compare two ASCII strings without regard to case.
C     INTLOG(R)- Log error message.
C     IGGLAT   - Compute gaussian latitudes for given truncation.
C
C
C     Author
C     ------
C
C     J.D.Chambers       ECMWF        August 1994.
C
C     Modifications.
C     --------------
C
C     S. Curic      ECMWF      28.05.07
C     added jpeg packing just for merging with grib_api
C
C----<
C
      IMPLICIT NONE
C
C     Function arguments
C
      CHARACTER*(*) HPARN
      CHARACTER*(*) CHARV
      REAL REALV(*)
      INTEGER INTV(*)
C
C     Parameters
C
      INTEGER JPROUTINE
      PARAMETER ( JPROUTINE = 28200 )
C
#include "parim.h"
#include "nifld.common"
#include "nofld.common"
#include "grfixed.h"
#include "current.h"
C
C     Local variables
C
      INTEGER ITEMP, I, IRET, ILOOP, ILAST, IFILE1
      LOGICAL LFOUND
C
C     Externals
C
      LOGICAL CHEQUAL
      EXTERNAL CHEQUAL
      INTEGER IGGLAT, JINDEX
      EXTERNAL IGGLAT, JINDEX
      LOGICAL LOCTAHEDRAL_REQ
C
C     -----------------------------------------------------------------|
C     Section 1.   Initialise
C     -----------------------------------------------------------------|
C
  100 CONTINUE
C
      INTOUT  = 0
      LFOUND = .FALSE.
C
C     Check if debug turned on
      CALL JDEBUG()
C
C     Ensures basic initialisation of common blocks is done
      CALL IBASINI(0)
C
      CALL INTLOG(JP_DEBUG, 'INTOUT: option = ' // HPARN ,JPQUIET)
C
C     -----------------------------------------------------------------|
C     Section 2.   Decode request
C     -----------------------------------------------------------------|
C
  200 CONTINUE
C
C     Output grid.
C
      IF( CHEQUAL( HPARN, 1, 4, 'grid') ) THEN
        LFOUND = .TRUE.
C       (Ignore the call if the grid values = 0.)
        IF( (REALV(1) .EQ. 0) .OR. (REALV(2) .EQ. 0) ) GOTO 900
        IF( (NOREPR.NE.JPREGULAR).AND.(NOREPR.NE.JPREGROT) ) THEN
          LCHANGE = .TRUE.
          NOGAUSS = 0
        ENDIF
        IF( LNOROTA ) THEN
          NOREPR  = JPREGROT
        ELSE
          NOREPR  = JPREGULAR
        ENDIF
        LNOREPR = .TRUE.
        CALL INTLOGR(JP_DEBUG, 'INTOUT: grid e-w = ',REALV(1))
        CALL INTLOGR(JP_DEBUG, 'INTOUT: grid n-s = ',REALV(2))
        DO I = 1, 2
          ITEMP = INT( REALV(I)*PPMULT)
          IF( NOGRID(I) .NE. ITEMP ) LCHANGE = .TRUE.
          NOGRID(I) = ITEMP
        ENDDO
        LNOGRID = .TRUE.
        GOTO 900
      ENDIF
C
C     Output regular (gaussian).
C
      IF( CHEQUAL( HPARN, 1, 7, 'regular') ) THEN
        LFOUND = .TRUE.
C       (Ignore the call if the gaussian value = 0.)
        IF( INTV(1) .EQ. 0 ) GOTO 900
        IF( NOREPR .NE. JPGAUSSIAN ) THEN
          LCHANGE = .TRUE.
          NOGRID(1) = 0
          NOGRID(2) = 0
          LNOGRID = .FALSE.
        ENDIF
        IF( LNOROTA ) THEN
          NOREPR  = JPFGGROT
        ELSE
          NOREPR  = JPGAUSSIAN
        ENDIF
        LNOREPR = .TRUE.
        IF( NOGAUSS .NE. INTV(1) ) LCHANGE = .TRUE.
        CALL INTLOG(JP_DEBUG, 'INTOUT: regular = ',INTV(1))
        NOGAUSS = INTV(1)
        LNOGAUS = .TRUE.
        IF( (NOGAUSO.NE.NOGAUSS).OR.(HOGAUST.NE.'F') ) THEN
          CALL JGETGG( NOGAUSS, 'F', ROGAUSS, NOLPTS, IRET)
          IF( IRET .NE. 0 ) THEN
            CALL INTLOG(JP_ERROR,
     X        'INTOUT: JGETGG fail for NOGAUSS = ',NOGAUSS)
            INTOUT = IRET
            GOTO 900
          ENDIF
          NOGAUSO = NOGAUSS
          HOGAUST = 'F'
        ENDIF
C
        NONS = 2*NOGAUSS
        GOTO 900
      ENDIF
C
C     Output truncation.
C
      IF( CHEQUAL( HPARN, 1, 10, 'truncation') ) THEN
        LFOUND = .TRUE.
C       (Ignore the call if the truncation value < 0.)
        IF( INTV(1) .LT. 0 ) GOTO 900
        IF( NOREPR .NE. JPSPHERE ) LCHANGE = .TRUE.
        IF( .NOT. LNOREPR ) NOREPR  = JPSPHERE
        LNOREPR = .TRUE.
        IF( NORESO .NE. INTV(1) ) LCHANGE = .TRUE.
        CALL INTLOG(JP_DEBUG, 'INTOUT: truncation = ',INTV(1))
        NORESO  = INTV(1)
        LNORESO = .TRUE.
        GOTO 900
      ENDIF
C
C
C
C     Output gaussian => same output type as input.
C     Double Interpolation
C
      IF( CHEQUAL( HPARN, 1, 20, 'intermediate_gaussian') ) THEN
        LFOUND = .TRUE.
C       (Ignore the call if the gaussian value = 0.)
        IF( INTV(1) .EQ. 0 ) GOTO 900
        IF( NOMEGA .NE. INTV(1) ) LCHANGE = .TRUE.
        CALL INTLOG(JP_DEBUG,'INTOUT: Intermediate gaussian = ',INTV(1))
        NOMEGA = INTV(1)
        LDOUBLE = .TRUE.
c        NOREPR = JPNOTYPE
c        LNOREPR = .TRUE.
c        NONS = 2*NOGAUSS
        GOTO 900
      ENDIF
C
C     Interpolation method
C
      IF( CHEQUAL( HPARN, 1, 13, 'interpolation') ) THEN
        LFOUND = .TRUE.
        LNNLSM_CY41R1 = .FALSE.
        CALL INTLOG(JP_DEBUG, 'INTOUT: interpolation = '
     X   // CHARV ,JPQUIET)
        IF( CHEQUAL( CHARV, 1, 17, 'nearest neighbour') ) THEN
          IF( .NOT. LMETHOD ) LCHANGE = .TRUE.
          LMETHOD = .TRUE.
        ELSEIF( CHEQUAL( CHARV, 1, 8, 'bilinear') ) THEN
          IF( .NOT. LO12PT ) LCHANGE = .TRUE.
          LO12PT = .FALSE.
        ELSEIF( CHEQUAL( CHARV, 1, 11, 'nearest lsm') ) THEN
          IF( .NOT. LNNLSM ) LCHANGE = .TRUE.
          LNNLSM        = .TRUE.
          LNNLSM_CY41R1 = .TRUE.
        ELSEIF( CHEQUAL( CHARV, 1, 3, 'off') ) THEN
          LNNLSM  = .FALSE.
          LMETHOD = .FALSE.
        ELSE
          IF( LMETHOD ) LCHANGE = .TRUE.
          LMETHOD = .FALSE.
          LO12PT  = .TRUE.
          LNNLSM  = .FALSE.
        ENDIF
        GOTO 900
      ENDIF
C

C     Output ito be generated by automatically selected truncation
C     (autoresol).
C
      IF( CHEQUAL( HPARN, 1, 9, 'autoresol') ) THEN
        LFOUND = .TRUE.
        CALL INTLOG(JP_DEBUG, 'INTOUT: autoresol (1 = on) = ',INTV(1))
        IF( INTV(1).EQ.1 ) THEN
          LARESOL = .TRUE.
        ELSE
          LARESOL = .FALSE.
        ENDIF
      ENDIF
C
C     Output data format.
C
      IF( CHEQUAL( HPARN, 1, 4, 'form') ) THEN
        LFOUND = .TRUE.
        CALL INTLOG(JP_DEBUG, 'INTOUT: form = ' // CHARV ,JPQUIET)
        IF( CHEQUAL( CHARV, 1, 4, 'grib') ) THEN
          IF( NOFORM .EQ. 0 ) LCHANGE = .TRUE.
          NOFORM = 1
        ELSE
          IF( NOFORM .EQ. 1 ) LCHANGE = .TRUE.
          NOFORM = 0
        ENDIF
        GOTO 900
      ENDIF
C
C     Input level.
C
      IF( CHEQUAL( HPARN, 1, 5, 'level') ) THEN
        LFOUND = .TRUE.
        IF( NOLEVEL .NE. INTV(1) ) LCHANGE = .TRUE.
        CALL INTLOG(JP_DEBUG, 'INTOUT: level = ',INTV(1))
        NOLEVEL = INTV(1)
        LNOLEVL = .TRUE.
        GOTO 900
      ENDIF
C
C     Input level type.
C
      IF( CHEQUAL( HPARN, 1, 7, 'levtype') ) THEN
        LFOUND = .TRUE.
        IF( NOLEVT .NE. INTV(1) ) LCHANGE = .TRUE.
        CALL INTLOG(JP_DEBUG, 'INTOUT: levtype = ',INTV(1))
        NOLEVT  = INTV(1)
        LNOLEVT = .TRUE.
        GOTO 900
      ENDIF
C
C     Input table.
C
      IF( CHEQUAL( HPARN, 1, 5, 'table') ) THEN
        LFOUND = .TRUE.
        IF( NOTABLE .NE. INTV(1) ) LCHANGE = .TRUE.
        CALL INTLOG(JP_DEBUG, 'INTOUT: table = ',INTV(1))
        NOTABLE = INTV(1)
        LNOTABL = .TRUE.
        GOTO 900
      ENDIF
C
C     Input parameter.
C
      IF( CHEQUAL( HPARN, 1, 9, 'parameter') ) THEN
        LFOUND = .TRUE.
        IF( NOPARAM .NE. INTV(1) ) LCHANGE = .TRUE.
        CALL INTLOG(JP_DEBUG, 'INTOUT: parameter = ',INTV(1))
        NOPARAM = INTV(1)
        LNOPARA = .TRUE.
        GOTO 900
      ENDIF
C
C     Output accuracy.
C
      IF( CHEQUAL( HPARN, 1, 8, 'accuracy') ) THEN
        LFOUND = .TRUE.
C       (Ignore the call if the truncation value = 0.)
        IF( INTV(1) .EQ. 0 ) GOTO 900
        IF( NOACC .NE. INTV(1) ) LCHANGE = .TRUE.
        CALL INTLOG(JP_DEBUG, 'INTOUT: accuracy = ',INTV(1))
        NOACC  = INTV(1)
        LNOACC = .TRUE.
        GOTO 900
      ENDIF
C
C     Output gaussian => same output type as input.
C
      IF( CHEQUAL( HPARN, 1, 8, 'gaussian') ) THEN
        LFOUND = .TRUE.
C       (Ignore the call if the gaussian value = 0.)
        IF( INTV(1) .EQ. 0 ) GOTO 900
        IF( NOGAUSS .NE. INTV(1) ) LCHANGE = .TRUE.
        CALL INTLOG(JP_DEBUG, 'INTOUT: gaussian = ',INTV(1))
        NOGAUSS = INTV(1)
        LNOGAUS = .TRUE.
        NOREPR = JPNOTYPE
        LNOREPR = .TRUE.
        NONS = 2*NOGAUSS
        GOTO 900
      ENDIF
C
C     Output area.
C
      IF( CHEQUAL( HPARN, 1, 4, 'area') ) THEN
        LFOUND = .TRUE.
        CALL INTLOGR(JP_DEBUG, 'INTOUT: north = ',REALV(1))
        CALL INTLOGR(JP_DEBUG, 'INTOUT: west  = ',REALV(2))
        CALL INTLOGR(JP_DEBUG, 'INTOUT: south = ',REALV(3))
        CALL INTLOGR(JP_DEBUG, 'INTOUT: east  = ',REALV(4))
        DO I = 1, 4
          ITEMP = INT( REALV(I)*PPMULT)
          IF( NOAREA(I) .NE. ITEMP ) LCHANGE = .TRUE.
          NOAREA(I) = ITEMP
        ENDDO
        LNOAREA = (NOAREA(1).NE.0).OR.(NOAREA(2).NE.0).OR.
     X            (NOAREA(3).NE.0).OR.(NOAREA(4).NE.0)
        GOTO 900
      ENDIF
C
C     Output scan.
C
      IF( CHEQUAL( HPARN, 1, 4, 'scan') ) THEN
        LFOUND = .TRUE.
        IF( NOSCNM .NE. INTV(1) ) LCHANGE = .TRUE.
        CALL INTLOG(JP_DEBUG, 'INTOUT: scan = ',INTV(1))
        NOSCNM = INTV(1)
        GOTO 900
      ENDIF
C
C     Output packing.
C
C     Values for PACKING
C       SIMPLE
C       COMPLEX
C       SECOND ORDER
C       ARCHIVED VALUE
C
      IF( CHEQUAL( HPARN, 1, 7, 'packing') ) THEN
        LFOUND = .TRUE.
        CALL INTLOG(JP_DEBUG, 'INTOUT: packing = ' // CHARV ,JPQUIET)
        IF( CHEQUAL( CHARV, 1, 6, 'second') ) THEN
          IF( NOHFUNC.NE.'K' ) LCHANGE = .TRUE.
          NOHFUNC = 'K'
        ELSE IF( CHEQUAL( CHARV, 1, 6, 'simple') ) THEN
          IF( NOHFUNC.NE.'S' ) LCHANGE = .TRUE.
          NOHFUNC = 'S'
        ELSE IF( CHEQUAL( CHARV, 1, 7, 'archive') ) THEN
          IF( NOHFUNC.NE.'A' ) LCHANGE = .TRUE.
          NOHFUNC = 'A'
        ELSE IF( CHEQUAL( CHARV, 1, 7, 'complex') ) THEN
          IF( NOHFUNC.NE.'C' ) LCHANGE = .TRUE.
          NOHFUNC = 'C'
        ELSE IF( CHEQUAL( CHARV, 1, 4, 'jpeg') ) THEN
          IF( NOHFUNC.NE.'J' ) LCHANGE = .TRUE.
          NOHFUNC = 'J'
        ELSE
          CALL INTLOG(JP_ERROR,
     X      'INTOUT: Invalid value for PACKING: ' // CHARV(1:6),JPQUIET)
          LFOUND = .FALSE.
        ENDIF
        GOTO 900
      ENDIF
C
C     Output reduced.
C
      IF( CHEQUAL( HPARN, 1,  7, 'reduced') .OR.
     X    CHEQUAL( HPARN, 1, 10, 'octahedral') ) THEN
        LFOUND = .TRUE.
C       (Ignore the call if the reduced value = 0.)
        IF( INTV(1) .EQ. 0 ) GOTO 900
        IF( NOGAUSS .NE. INTV(1) ) LCHANGE = .TRUE.
        CALL INTLOG(JP_DEBUG, 'INTOUT: reduced = ',INTV(1))
        NOGAUSS = INTV(1)
        LNOGAUS = .TRUE.
        IF( NOREPR .NE. JPQUASI ) THEN
          LCHANGE = .TRUE.
          NOGRID(1) = 0
          NOGRID(2) = 0
          LNOGRID = .FALSE.
        ENDIF
        IF( LNOROTA ) THEN
          NOREPR  = JPQGGROT
        ELSE
          NOREPR  = JPQUASI
        ENDIF
        LNOREPR = .TRUE.
        IF( (NOGAUSO.NE.NOGAUSS).OR.(HOGAUST.NE.'R') ) THEN
          CALL JGETGG( NOGAUSS, 'R', ROGAUSS, NOLPTS, IRET)
          IF( IRET .NE. 0 ) THEN
            CALL INTLOG(JP_ERROR,
     X        'INTOUT: JGETGG fail for NOGAUSS = ',NOGAUSS)
            INTOUT = IRET
            GOTO 900
          ENDIF
          NOGAUSO = NOGAUSS
          HOGAUST = 'R'
        ENDIF
C
        NOAREA(1) = INT( ROGAUSS(1) * PPMULT )
        NOAREA(2) = 0
        NOAREA(3) = INT( ROGAUSS(NOGAUSS*2) * PPMULT )
        NOAREA(4) = JP360 - JP360/NOLPTS(NOGAUSS)
        NOPCNT = 0
        DO ILOOP = 1, NOGAUSS*2
          NOPCNT = NOPCNT + NOLPTS(ILOOP)
        ENDDO
C
C       Check octahedral request
C
        LOCTAHEDRAL_REQ = CHEQUAL(HPARN,1,10,'octahedral') .AND.
     X                    (INTV(1) .NE. 0)
        IF ((LOCTAHEDRAL_REQ .AND. .NOT. LOCTAHEDRAL) .OR.
     X      (.NOT. LOCTAHEDRAL_REQ .AND. LOCTAHEDRAL)) THEN
          LCHANGE = .TRUE.
        ENDIF
        LOCTAHEDRAL = LOCTAHEDRAL_REQ
        GOTO 900
      ENDIF
C
C     Output user_regular_gaussian
C
      IF( CHEQUAL( HPARN, 1, 21, 'user_regular_gaussian') ) THEN
        LFOUND = .TRUE.
        IF( NOREPR .NE. JPGAUSSIAN ) THEN
          LCHANGE = .TRUE.
          NOGRID(1) = 0
          NOGRID(2) = 0
          LNOGRID = .FALSE.
        ENDIF
C       (Ignore the call if the user_regular_gaussian value = 0.)
        IF( INTV(1) .EQ. 0 ) GOTO 900
        IF( NOGAUSS .NE. INTV(1) ) LCHANGE = .TRUE.
        CALL INTLOG(JP_DEBUG,'INTOUT: user_regular_gaussian = ',INTV(1))
        NOGAUSS = INTV(1)
        LNOGAUS = .TRUE.
        IF( LNOROTA ) THEN
          NOREPR  = JPFGGROT
        ELSE
          NOREPR  = JPGAUSSIAN
        ENDIF
        LNOREPR = .TRUE.
C
        ILAST = NOGAUSS*2
        DO ILOOP = 1, ILAST
          NOLPTS(ILOOP) = NOGAUSS*4
        ENDDO
        NOGAUSO = NOGAUSS
        HOGAUST = 'U'
        LOGIVEP   = .TRUE.
C
        GOTO 900
      ENDIF
C
C     Output user_reduced_gaussian
C
      IF( CHEQUAL( HPARN, 1, 21, 'user_reduced_gaussian') ) THEN
        LFOUND = .TRUE.
        IF( NOREPR .NE. JPQUASI ) THEN
          LCHANGE = .TRUE.
          NOGRID(1) = 0
          NOGRID(2) = 0
          LNOGRID = .FALSE.
        ENDIF
C       (Ignore the call if the user_reduced_gaussian value = 0.)
        IF( INTV(1) .EQ. 0 ) GOTO 900
        IF( NOGAUSS .NE. INTV(1) ) LCHANGE = .TRUE.
        CALL INTLOG(JP_DEBUG,'INTOUT: user_reduced_gaussian = ',INTV(1))
        NOGAUSS = INTV(1)
        LNOGAUS = .TRUE.
        IF( LNOROTA ) THEN
          NOREPR  = JPQGGROT
        ELSE
          NOREPR  = JPQUASI
        ENDIF
        LNOREPR = .TRUE.
        GOTO 900
      ENDIF
C
C     Output g_pnts.
C
      IF( CHEQUAL( HPARN, 1, 6, 'g_pnts') ) THEN
        LFOUND = .TRUE.
        IF( NOGAUSS .LE. 0 ) THEN
          IRET   = JPROUTINE + 1
          CALL INTLOG(JP_ERROR,
     X      'INTOUT: Impossible number of gaussian latitudes.',NOGAUSS)
          INTOUT = IRET
          GOTO 900
        ENDIF
C
        ILAST = NOGAUSS*2 + 1
        DO ILOOP = 1, NOGAUSS
          NOLPTS(ILOOP) = INTV(ILOOP)
          ILAST = ILAST - 1
          NOLPTS(ILAST) = INTV(ILOOP)
        ENDDO
C
        NOPCNT = 0
        DO ILOOP = 1, NOGAUSS*2
          NOPCNT = NOPCNT + NOLPTS(ILOOP)
        ENDDO
        NOGAUSO = NOGAUSS
        HOGAUST = 'U'
        LOGIVEP = .TRUE.
        GOTO 900
      ENDIF
C
C     Output g_lats.
C
      IF( CHEQUAL( HPARN, 1, 6, 'g_lats') ) THEN
        LFOUND = .TRUE.
        IF( NOGAUSS .LE. 0 ) THEN
          IRET   = JPROUTINE + 1
          CALL INTLOG(JP_ERROR,
     X      'INTOUT: Impossible number of gaussian latitudes.',NOGAUSS)
          INTOUT = IRET
          GOTO 900
        ENDIF
C
        ILAST = NOGAUSS*2 + 1
        DO ILOOP = 1, NOGAUSS
          ROGAUSS(ILOOP) = REALV(ILOOP)
          ILAST = ILAST - 1
          ROGAUSS(ILAST) = -REALV(ILOOP)
        ENDDO
C
        NOAREA(1) = INT( ROGAUSS(1) * PPMULT )
        NOAREA(2) = 0
        NOAREA(3) = INT( ROGAUSS(NOGAUSS*2) * PPMULT )
        NOAREA(4) = JP360 - JP360/NOLPTS(NOGAUSS)
        NOGAUSO = NOGAUSS
        HOGAUST = 'U'
        LOGIVEL   = .TRUE.
        GOTO 900
      ENDIF
C
C     Output rotation.
C
      IF( CHEQUAL( HPARN, 1, 8, 'rotation') ) THEN
        LFOUND = .TRUE.
C
        IF( CHEQUAL(CHARV,1,3,'off') ) THEN
          LNOROTA = .FALSE.
          NOROTA(1) = -99999999
          NOROTA(2) = -99999999
          IF( NOREPR.EQ.JPSPHROT ) NOREPR = JPSPHERE
          IF( NOREPR.EQ.JPREGROT ) NOREPR = JPREGULAR
          IF( NOREPR.EQ.JPQGGROT ) NOREPR = JPQUASI
          IF( NOREPR.EQ.JPFGGROT ) NOREPR = JPGAUSSIAN
        ELSE
          LNOROTA = .TRUE.
          CALL INTLOGR(JP_DEBUG, 'INTOUT: S.pole latitude  = ',REALV(1))
          CALL INTLOGR(JP_DEBUG, 'INTOUT: S.pole longitude = ',REALV(2))
          DO I = 1, 2
            ITEMP = INT( REALV(I)*PPMULT)
            IF( NOROTA(I) .NE. ITEMP ) LCHANGE = .TRUE.
            NOROTA(I) = ITEMP
          ENDDO
          IF( NOREPR.EQ.JPSPHERE )   NOREPR = JPSPHROT
          IF( NOREPR.EQ.JPREGULAR )  NOREPR = JPREGROT
          IF( NOREPR.EQ.JPQUASI )    NOREPR = JPQGGROT
          IF( NOREPR.EQ.JPGAUSSIAN ) NOREPR = JPFGGROT
        ENDIF
        GOTO 900
      ENDIF
C
C     Interpolation scheme to use for rotations
C
      IF( CHEQUAL( HPARN, 1, 8, '12-point') ) THEN
        LFOUND = .TRUE.
        CALL INTLOG(JP_DEBUG, 'INTOUT: 12-point = ' // CHARV ,JPQUIET)
C
        IF( CHEQUAL(CHARV,1,3,'yes') ) THEN
          LO12PT = .TRUE.
        ELSE
          LO12PT = .FALSE.
        ENDIF
        GOTO 900
      ENDIF
C
C     Output user_reduced_latlon
C
      IF( CHEQUAL( HPARN, 1, 19, 'user_reduced_latlon') ) THEN
        LFOUND = .TRUE.
        IF( NOREPR .NE. JPREDLL ) THEN
          LCHANGE = .TRUE.
          NOGRID(1) = 0
Cjdc      NOGRID(2) = REALV(2)
          LNOGRID = .FALSE.
        ENDIF
C       (Ignore the call if the user_reduced_latlon value = 0.)
        IF( INTV(1) .EQ. 0 ) GOTO 900
        IF( NOREDLL .NE. INTV(1) ) LCHANGE = .TRUE.
        CALL INTLOG(JP_DEBUG, 'INTOUT: user_reduced_latlon = ',INTV(1))
        NOREDLL = INTV(1)
        LNOREDL = .TRUE.
        IF( LNOROTA ) THEN
          NOREPR  = JPREDLROT
        ELSE
          NOREPR  = JPREDLL
        ENDIF
        LNOREPR = .TRUE.
        GOTO 900
      ENDIF
C
C     Output set raduced_laltlon
C
      IF( CHEQUAL( HPARN, 1, 10, 'red_latlon') ) THEN
        LFOUND = .TRUE.
          NOGRID(1) = 0
          NOGRID(2) = REALV(2)
        IF( NOREPR .NE. JPREDLL ) THEN
          LCHANGE = .TRUE.
          LNOGRID = .FALSE.
        ENDIF
C       (Ignore the call if the user_reduced_latlon value = 0.)
cs        IF( INTV(1) .EQ. 0 ) GOTO 900
        CALL INTLOG(JP_DEBUG, 'INTOUT: reduced_latlon ns = ',NOGRID(2))
cs        NOREDLL = INTV(1)
        LNOREDL = .TRUE.
        IF( LNOROTA ) THEN
          NOREPR  = JPREDLROT
        ELSE
          NOREPR  = JPREDLL
        ENDIF
        LNOREPR = .TRUE.
        GOTO 900
      ENDIF
C
C     Output ll_pnts.
C
      IF( CHEQUAL( HPARN, 1, 7, 'll_pnts') ) THEN
        LFOUND = .TRUE.
        IF( NOREDLL .LE. 0 ) THEN
          IRET   = JPROUTINE + 1
          CALL INTLOG(JP_ERROR,
     X      'INTOUT: Impossible number of latitudes.',NOREDLL)
          INTOUT = IRET
          GOTO 900
        ENDIF
C
        ILAST = NOREDLL
        DO ILOOP = 1, NOREDLL
          NOLPTS(ILOOP) = INTV(ILOOP)
        ENDDO
C
        NOPCNT = 0
        DO ILOOP = 1, NOREDLL-1
          NOPCNT = NOPCNT + NOLPTS(ILOOP)
        ENDDO
        LOGIVEP = .TRUE.
        GOTO 900
      ENDIF
C
C     Output ll_lats.
C
      IF( CHEQUAL( HPARN, 1, 7, 'll_lats') ) THEN
        LFOUND = .TRUE.
        IF( NOREDLL .LE. 0 ) THEN
          IRET   = JPROUTINE + 1
          CALL INTLOG(JP_ERROR,
     X      'INTOUT: Impossible number of latitudes.',NOREDLL)
          INTOUT = IRET
          GOTO 900
        ENDIF
C
        DO ILOOP = 1, NOREDLL
          ROREDLL(ILOOP) = REALV(ILOOP)
        ENDDO
C
        NOAREA(1) = INT( ROREDLL(1) * PPMULT )
        NOAREA(2) = 0
        NOAREA(3) = INT( ROREDLL(NOREDLL) * PPMULT )
        NOAREA(4) = JP360 - JP360/NOLPTS(NOREDLL/2)
        LOGIVEL   = .TRUE.
        GOTO 900
      ENDIF
C
C     Reduced gaussian definition from file
C
      IF( CHEQUAL( HPARN, 1, 15, 'gauss_from_file') ) THEN
        LFOUND = .TRUE.
        CALL INTLOG(JP_DEBUG,
     X    'INTOUT: gauss_from_file = ' // CHARV ,JPQUIET)
C
C       Open the input file
C
        CALL PBOPEN(IFILE1, CHARV, 'R', IRET)
        IF( IRET.NE.0 ) THEN
          CALL INTLOG(JP_ERROR,
     X      'INTOUT: Unable to use gaussian definition file:',JPQUIET)
          CALL INTLOG(JP_ERROR,CHARV,JPQUIET)
          INTOUT = JPROUTINE + 1
          GOTO 900
        ENDIF
C
C       Read gaussian number, then number of points at each latitude
C
        CALL PBREAD(IFILE1, NOGAUSS, JPBYTES, IRET)
        IF( IRET.NE.JPBYTES ) THEN
          CALL INTLOG(JP_ERROR,
     X      'INTOUT: Problem reading gaussian no. from file:',JPQUIET)
          CALL PBCLOSE(IFILE1, IRET)
          INTOUT = JPROUTINE + 1
          GOTO 900
        ENDIF
C
        IF( NOGAUSS .LE. 0 ) THEN
          IRET   = JPROUTINE + 1
          CALL INTLOG(JP_ERROR,
     X      'INTOUT: Impossible number of gaussian latitudes.',NOGAUSS)
          INTOUT = IRET
          GOTO 900
        ENDIF
C
        CALL PBREAD(IFILE1, NOLPTS, JPBYTES*NOGAUSS, IRET)
        IF( IRET.NE.JPBYTES*NOGAUSS ) THEN
          CALL INTLOG(JP_ERROR,
     X      'INTOUT: Problem reading gaussian pts from file:',JPQUIET)
          CALL PBCLOSE(IFILE1, IRET)
          INTOUT = JPROUTINE + 1
          GOTO 900
        ENDIF
C
        CALL PBCLOSE(IFILE1, IRET)
C
        ILAST = NOGAUSS*2 + 1
        DO ILOOP = 1, NOGAUSS
          ILAST = ILAST - 1
          NOLPTS(ILAST) = NOLPTS(ILOOP)
        ENDDO
C
        NOPCNT = 0
        DO ILOOP = 1, NOGAUSS*2
          NOPCNT = NOPCNT + NOLPTS(ILOOP)
        ENDDO
        NOGAUSO = NOGAUSS
        HOGAUST = 'U'
        LOGIVEP = .TRUE.
        LOGIVEL = .TRUE.
C
        IRET = IGGLAT(NOGAUSS*2, ROGAUSS, 0, 1)
        IF( IRET.NE.0 ) THEN
          CALL INTLOG(JP_ERROR,
     X      'INTOUT: Problem calculating gaussian latitudes',JPQUIET)
          INTOUT = JPROUTINE + 1
          GOTO 900
        ENDIF
C
        IF( LNOROTA ) THEN
          NOREPR = JPQGGROT
        ELSE
          NOREPR = JPQUASI
        ENDIF
        LNOREPR = .TRUE.
C
        GOTO 900
      ENDIF
C
C     Output grid creation style
C
      IF( CHEQUAL( HPARN, 1, 5, 'style') ) THEN
        LFOUND = .TRUE.
        CALL INTLOG(JP_DEBUG, 'INTOUT: style = ' // CHARV ,JPQUIET)
        IF( CHEQUAL( CHARV, 1, 13, 'dissemination') ) THEN
          ITEMP = JPSDISM
        ELSE
          ITEMP = JPSMARS
        ENDIF
        IF( NOSTYLE .NE. ITEMP ) LCHANGE = .TRUE.
        NOSTYLE = ITEMP
        LNOSTYLE = .TRUE.
        GOTO 900
      ENDIF
C
C     Output grid frame
C
      IF( CHEQUAL( HPARN, 1, 5, 'frame') ) THEN
        LFOUND = .TRUE.
        CALL INTLOG(JP_DEBUG, 'INTOUT: frame = ',INTV(1))
        ITEMP = INTV(1)
        IF( NOFRAME .NE. ITEMP ) LCHANGE = .TRUE.
        NOFRAME = ITEMP
        LNOFRAME = (NOFRAME.GT.0)
        GOTO 900
      ENDIF
C
C     Output grid bitmap
C
      IF( CHEQUAL( HPARN, 1, 6, 'bitmap') ) THEN
        LFOUND = .TRUE.
        CALL INTLOG(JP_DEBUG, 'INTOUT: bitmap = ' // CHARV ,JPQUIET)
        ITEMP  = JINDEX(CHARV)
        IF( ITEMP.LT.1 ) THEN
          CALL INTLOG(JP_WARN,
     X      'INTOUT: No bitmap filename given.',JPQUIET)
          INTOUT = JPROUTINE + 1
          GOTO 900
        ELSE
          IF( NOBITMP(1:ITEMP).NE.CHARV(1:ITEMP) ) LCHANGE = .TRUE.
          NOBITMP = ' '
          NOBITMP(1:ITEMP) = CHARV(1:ITEMP)
          LNOBITMP = .TRUE.
        ENDIF
        GOTO 900
      ENDIF
C
C     Output gaussian grid specification
C
      IF( CHEQUAL( HPARN, 1, 13, 'specification') ) THEN
        LFOUND = .TRUE.
        CALL INTLOG(JP_DEBUG, 'INTOUT: specification = ', INTV(1))
        IF( (INTV(1).NE.12).AND.(INTV(1).NE.18) ) THEN
          CALL INTLOG(JP_ERROR,
     X      'INTOUT: invalid value for specification = ',INTV(1))
          INTOUT = JPROUTINE + 2
          GOTO 900
        ENDIF
C
        IF( NGSPEC.NE.INTV(1) ) THEN
          LCHANGE = .TRUE.
          NGSPEC  = INTV(1)
          LNGSPEC = .TRUE.
        ENDIF
        IF( LNOGAUS ) THEN
          CALL INTLOG(JP_DEBUG,
     X      'INTOUT: replace gaussian specification = ', NOGAUSS)
          CALL JGETGG( NOGAUSS, 'R', ROGAUSS, NOLPTS, IRET)
          IF( IRET .NE. 0 ) THEN
            CALL INTLOG(JP_ERROR,
     X        'INTOUT: JGETGG fail for NOGAUSS = ',NOGAUSS)
            INTOUT = IRET
            GOTO 900
          ENDIF
          NOGAUSO = NOGAUSS
          HOGAUST = 'R'
C
          IF( .NOT.LNOAREA ) THEN
            CALL INTLOG(JP_DEBUG,
     X        'INTOUT: now replace output area definition',JPQUIET)
            NOAREA(1) = INT( ROGAUSS(1) * PPMULT )
            NOAREA(2) = 0
            NOAREA(3) = INT( ROGAUSS(NOGAUSS*2) * PPMULT )
            NOAREA(4) = JP360 - JP360/NOLPTS(NOGAUSS)
            NOPCNT = 0
            DO ILOOP = 1, NOGAUSS*2
              NOPCNT = NOPCNT + NOLPTS(ILOOP)
            ENDDO
            GOTO 900
          ENDIF
        ENDIF
        GOTO 900
      ENDIF
C
C     -----------------------------------------------------------------|
C      Section 9.   Closedown.
C     -----------------------------------------------------------------|
C
  900 CONTINUE
      IF( .NOT. LFOUND ) THEN
        CALL INTLOG(JP_ERROR,
     X    'INTOUT: Unknown keyword or option used:', JPQUIET)
        CALL INTLOG(JP_ERROR, HPARN, JPQUIET)
        INTOUT = JPROUTINE + 2
      ENDIF
C
C     Set flag to show function has been called
      LINTOUT = .TRUE.
      RETURN
      END

C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      INTEGER FUNCTION C2GENE ( KDATA,  KLENP,  KSEC4,  KGRIB,  KLENG,
     X                          KNSPT,  KBITS,  OCOMGR, OLONLY, KLEN4,
     X                          KFIROV, KLEN,   KREFGR, KLENGR, KBITGR,
     X                          KWORK,  KLWORK, KSTART, KPOWER, KMXPWR,
     X                          KPCWID, KXCWID, KNBIFO, KNCMIN, KMINPK,
     X                          KLWORX, ODEBUG )
C
C---->
C**** C2GENE
C
C     Purpose.
C     --------
C
C     Performs a general second-order packing method for section 4
C     of GRIB, and/or computes only length of section 4, with/without
C     coding, with this method.
C
C     "General" means with explicit descriptors to describe groups
C     position and width (not row-by-row, nor constant-width).
C
C     When extended 2nd-order packing is enabled, then KSEC4(12:15)
C     values determin if extensions are concerned. Extensions are:
C
C     - general extended 2nd-order packing, which is the same as WMO
C      except for documentation of descriptors (held more economically);
C
C     - boustrophedonic ordering, which is held outside of the routine
C       (field re-ordering, swapping values in even rank rows).
C
C     - spatial differencing, which is held mostly outside of the
C       routine (apply general extended 2nd-order compression algorithm,
C       with or without boustrophedonic ordering, to values obtained
C       through computation of differences between adjacent values,
C       repeated to order wished).
C
C**   Interface.
C     ----------
C
C     KRET = C2GENE ( KDATA,  KLENP,  KSEC4,  KGRIB,  KLENG,  KNSPT,
C    X                KBITS,  OCOMGR, OLONLY, KLEN4,  KFIROV, KLEN,
C    X                KREFGR, KLENGR, KBITGR, KWORK,  KLWORK, KSTART,
C    X                KPOWER, KMXPWR, KPCWID, KXCWID, KNBIFO, KNCMIN,
C    X                KMINPK, KLWORX, ODEBUG )
C
C
C     Input Parameters for all options.
C     --------------------------------
C
C     KDATA      - Array of normalized values.
C     KLENP      - Length of array KDATA.
C     KSEC4      - Array of GRIB section 4 integer descriptors.
C                  KSEC4(12) indicates type of general 2nd-order packing
C                  (applies only to descriptors): 
C                   0 => standard WMO descriptors
C                   8 => extended     descriptors
C                  KSEC4(13) indicates if boustrophedonic ordering
C                  (values swapped in rows of even rank) is selected:
C                   0 => standard        ordering
C                   4 => boustrophedonic ordering
C                  KSEC4(14:15) indicates if spatial differencing is on:
C                   0:0 => no spatial differencing
C                   0:1,2:0,2:1 => spatial differencing applied at order
C                                  equal to KSEC4(14)+KSEC4(15)
C     KLENG      - Length of GRIB product array.
C     KNSPT      - Bit pointer for next value in GRIB product.
C     KBITS      - Number of bits per computer word.
C     OCOMGR     - True if COMputing of GRoup arrays is requested.
C     OLONLY     - True if Length ONLY is requested (no coding).
C     KLEN       - Exact number of grid-points to handle.
C     KLWORK     - Length of work arrays.
C     KPOWER     - Auxilary array, precomputed (powers of 2)-1.
C     KMXPWR     - Maximum number of bits per original scaled value.
C     KPCWID     - Auxilary array, precomputed widths.
C     KXCWID     - Maximum width associated to KPCWID.
C     KNCMIN     - Minimum increment to use when determining groups.
C     KMINPK     - Initial (minimum) length of groups.
C     ODEBUG     - True for some debug printout.
C
C
C     Output Parameters for all options.
C     ---------------------------------
C
C     KSEC4      - Array of GRIB section 4 integer descriptors.
C                  (updated, except when both OCOMGR is false
C                   and OLONLY it true)
C     KLEN4      - Length of section 4.
C     KLWORX     - Maximum work space used.
C
C     Output Parameters when OLONLY is false.
C     --------------------------------------
C
C     KGRIB      - Array containing GRIB product.
C     KNSPT      - Bit pointer for next value in GRIB product (updated).
C     KWORK      - Used as work array by C2PACK.
C
C     Output Parameters when OCOMGR is true,
C      Input Parameters when OCOMGR is false.
C     --------------------------------------
C
C     KREFGR     - Work array, first-order values for each row.
C     KLENGR     - Work array, effective length of each row.
C     KBITGR     - Work array, bit number ("width") of each row.
C     KNBIFO     - Number of BIts for coding First-Order values.
C
C     Output Parameters when OCOMGR is true,
C      Input parameter in all cases.
C     --------------------------------------
C
C     KDATA      - Used as work array by C2PACK.
C
C     Input Parameter when OCOMGR is false.
C     -------------------------------------
C
C     KSTART     - First index value of precomputed work arrays KREFGR,
C                  KLENGR and KBITGR.
C
C     Method.
C     -------
C
C     Follows WMO Manual of Codes.
C
C     If requested through OCOMGR, a first scan computes work arrays,
C     bit number for coding first-order values and length of section 4.
C
C     If requested, coding is applied in a second scan, using
C     descriptors computed in the first scan, possibly in a previous
C     call.
C
C     Algorithm used to determine groups is derived from Harry R. Glahn
C     (U.S. Met Service), from a working paper submitted to WMO SGDR&C
C     in 1995.
C
C     If extended 2nd-order packing is enabled, then call with OCOMGR
C     to .FALSE. and OLONLY to .TRUE. is enabled, to support aggressive
C     packing without having to recompute work arrays, which would be
C     the same for general WMO and extended packings (for the same
C     option of field ordering: either both boustrophedonic
C     or both not).
C
C     Externals.
C     ----------
C
C     MAXMNI    - Computes extrema of integer array.
C     C2BITW    - Computes bit width of a positive integer value.
C     C2PACK    - Encodes descriptors and data.
C
C
C     Reference.
C     ----------
C
C     None.
C
C
C     Comments.
C     --------
C
C     On entry, KNSPT points to the first bit of section 4 
C               in the GRIB product.
C     On exit,  KNSPT points to the first unused bit of section 4,
C               (or to the first bit of section 5, if unused bit count
C                is zero) in the GRIB product.
C
C     KDATA is overwritten when coding is requested.
C     This is coherent with GRIBEX.
C
C     Boustrophedonic ordering, if selected, is formally transparent to
C     the current routine. Pre-processing is held at calling routine
C     level (C2ORDR), coding at C2PACK level.
C
C     Author.
C     -------
C
C     J. Clochard, Meteo France, for ECMWF - January 1998.
C
C
C     Modifications.
C     _____________
C
C     J. Clochard, April 1998.
C     Use C2BITW function for bit width computations, out of
C     the splitting algorithm itself.
C     Introduce spatial differencing.
C
C     J. Clochard, July 1998.
C     Set KLWORX to KLWORK when out of work space in direct algorithm.
C
C     J. Clochard, September 1998.
C     Update comments.
C     Adjust KLWORX within splitting algorithm.
C     Limit index range used in KWORK for "small" initial groups number.
C     Suppress KSEC1/KSEC2/KSEC3 dummy-arguments.
C         "    KSEC1, add KWORK/KPOWER/KMXPWR argument in C2PACK call.
C
C     J. Clochard, June 1999.
C     Use precomputed array to determine widths . Dummy-arguments
C     KPCWID and KXCWID added . Assumption is made that KXCWID
C     is at least (KMXPWR+1)/2 .
C
C
C----<
C     -----------------------------------------------------------------
C*    Section 0. Definition of variables.
C     -----------------------------------------------------------------
C
      IMPLICIT NONE
C
#include "grprs.h"
C
C     Subroutine arguments
C
      INTEGER KLENP, KLENG, KNSPT, KBITS, KLEN4, KNCMIN, KLWORX, KXCWID
      INTEGER KLEN, KLWORK, KMXPWR, KNBIFO, KFIROV, KMINPK, KSTART
C
      INTEGER KDATA (KLENP), KSEC4 (*), KPCWID (0:*)
      INTEGER KGRIB (KLENG), KREFGR (KLWORK), KLENGR (KLWORK)
      INTEGER KBITGR (KLWORK), KPOWER (0:KMXPWR), KWORK (KLWORK)
C
      LOGICAL OLONLY, OCOMGR, ODEBUG
C
C     Local variables.
C
      INTEGER IRETFN, ICOUNT, INBIFO, ILDSTA, IDMAX, IDMIN, IXLDST
      INTEGER IGROUP, ISIZEG, IPOWER, INBITO, ILENSO, IXLEN4, IXGRBD
      INTEGER IOFF, J, IFIROV, INCMIN, IBITGW, IMAXAB, IMINAB, IMINPK
      INTEGER IMAXA, IMINA, ISOMAX, INBITA, IMAXC, IMINC, IXBIGW, ILCWID
      INTEGER IMAXAC, IMINAC, IMAXB, IMINB, ISIZEA, ISIZEB, ISIZEC
      INTEGER IXFIRO, ISTART, ILWORK, ILEN
      INTEGER IBITGS, ILENGS, ILDSTG, INDNEW, ILEN4O, IORDER, IWIDSD
      INTEGER IBIAS
      INTEGER IAUXIL, IGRADD, ILEN4S, IGROUS, J2, ILASTG, INGRAD, IPOSGR
C
      INTEGER C2PACK, C2BITW
      EXTERNAL C2PACK, C2BITW
C
      LOGICAL LB2A
      LOGICAL LGENXT
C
      REAL ZGAIN
C
C     Function computing lenth of section 4 (in octets), using as
C     arguments length of static descriptors, number of 1st-order
C     values, width of widthes, and length (bits) of descriptors
C     for groups bounds.
C
C     Length must always be an even number of octets.
C
      IXLEN4 ( IXLDST, IXFIRO, IXBIGW, IXGRBD ) =       2 * ( (
     X   IXLDST + (8+IXFIRO*IXBIGW-1)/8 + (8+IXGRBD-1)/8
     X          + (8+IXFIRO*INBIFO-1)/8 + (8+ILENSO-1)/8
     X                                                        +1 ) / 2 )
C
C
C     -----------------------------------------------------------------
C*    Section 1 . Performs initial checks.
C     -----------------------------------------------------------------
C
  100 CONTINUE
C
      LGENXT=KSEC4(12).NE.0
#ifndef ebug2o
      IF (ODEBUG) THEN
#endif
        WRITE(GRPRSM,FMT=9100) OCOMGR, OLONLY, KNSPT
C
        IF (LGENXT) THEN 
          WRITE(GRPRSM,FMT=9101) 'general extended'
        ELSE
          WRITE(GRPRSM,FMT=9101) 'general WMO standard'
        ENDIF
C
#ifndef ebug2o
      ENDIF
#endif
C
      IRETFN = 0
      ILCWID = KPOWER(KXCWID)+1
      IORDER=KSEC4(14)+KSEC4(15)
      ICOUNT=IORDER
      ILEN=KLEN-IORDER
      IWIDSD=KSEC4(11)
      IBIAS=KSEC4(16)
      ILDSTA=21
      INBITO=KSEC4(2)
      KLWORX=0
C
      IF (.NOT.OCOMGR) THEN
C
        INBIFO=KNBIFO
        IFIROV=KFIROV
        KLWORX=KFIROV
        ISTART=KSTART
        IBITGW=KSEC4(20)
C
        IF (LGENXT) THEN
          IBITGS=KSEC4(17)
        ENDIF
C
        IF (OLONLY) THEN
          ILENSO=KSEC4(19)
          GOTO 260
        ENDIF
        GOTO 300
C
      ENDIF
C
C     -----------------------------------------------------------------
C*    Section 2 . Computing of group characteristics.
C     -----------------------------------------------------------------
C
  200 CONTINUE
C
      IGROUP=0
      INCMIN=MIN (MAX (KNCMIN,1),1+ILEN/4)
      IMINPK=MIN (MAX (KMINPK,2*INCMIN),1+ILEN/2)
      ISIZEG=IMINPK
      ISTART=1
C
#ifndef ebug2o
      IF (ODEBUG) THEN
#endif
        WRITE(GRPRSM,FMT=9200) INBITO, (KSEC4(J),J=1,15),
     X                          INCMIN, ISIZEG
#ifndef ebug2o
      ENDIF
C
#endif
C
C     -----------------------------------------------------------------
C               Determination of an "initial" group, called A.
C     -----------------------------------------------------------------
C
  210 CONTINUE
C
      ISIZEA=MIN (ISIZEG,KLEN-ICOUNT)
C
C     Extrema computed in-line for better efficiency.
C
      IMAXA=KDATA(ICOUNT+1)
      IMINA=KDATA(ICOUNT+1)
C
      DO 211 J=2,ISIZEA
      IMAXA=MAX (IMAXA,KDATA(ICOUNT+J))
      IMINA=MIN (IMINA,KDATA(ICOUNT+J))
  211 CONTINUE
C
  212 CONTINUE
C
      LB2A=.FALSE.
      ISOMAX=IMAXA-IMINA
C
      IF (ISOMAX.LT.ILCWID) THEN
        INBITA=KPCWID(ISOMAX)
      ELSE
        INBITA=KXCWID+KPCWID(ISOMAX/ILCWID)
      ENDIF
C
      IPOWER=KPOWER(INBITA)
C
      IOFF=ICOUNT+ISIZEA
#ifdef ebug2o
      PRINT *,'c2gene - ICOUNT/ISIZEA/IMINA/IMAXA/INBITA/IPOWER=',
     X                  ICOUNT,ISIZEA,IMINA,IMAXA,INBITA,IPOWER
#endif
C
      IF (IOFF.EQ.KLEN) THEN
C
C       Just finished. Group A is closed.
C
        GOTO 240
C
      ENDIF
C
C     -----------------------------------------------------------------
C               Try to add an increment C to initial group A.
C     -----------------------------------------------------------------
C
  220 CONTINUE
C
      IF (KLEN-(IOFF+INCMIN).LE.ISIZEG/2) THEN
C
C          Avoid too small group at the end.
C
        INCMIN=KLEN-IOFF
      ENDIF
C
      IMAXC=KDATA(IOFF+1)
      IMINC=KDATA(IOFF+1)
C
#ifdef CRAY
CDIR$ NOVECTOR
#endif
#ifdef FUJITSU
!OCL SCALAR
#endif
      DO 221 J=2,INCMIN
      IMAXC=MAX (IMAXC,KDATA(IOFF+J))
      IMINC=MIN (IMINC,KDATA(IOFF+J))
  221 CONTINUE
#ifdef CRAY
CDIR$ VECTOR
#endif
#ifdef FUJITSU
!OCL VECTOR
#endif
C
      IMAXAC=MAX (IMAXA,IMAXC)
      IMINAC=MIN (IMINA,IMINC)
      ISOMAX=IMAXAC-IMINAC
#ifdef ebug2o
      PRINT *,'c2gene - IOFF/INCMIN/IMINC/IMAXC/IMINAC/IMAXAC=',
     X                  IOFF,INCMIN,IMINC,IMAXC,IMINAC,IMAXAC
#endif
C
      IF (ISOMAX.GT.IPOWER) THEN
C
C       Added to A, increment C would not fit in same width as A.
C       Group A is closed.
C
        GOTO 240
C
      ELSEIF ((IOFF+INCMIN).EQ.KLEN) THEN
C
C       Group C is added to group A. Finished.
C
        ISIZEA=ISIZEA+INCMIN
        IMAXA=IMAXAC
        IMINA=IMINAC
        GOTO 240
C
      ENDIF
C
C       Increment C would fit, if added to A.
C
C       See width of group B, following group A, with its length
C       determined in the same way as A.
C
      ISIZEB=MIN (ISIZEG,KLEN-IOFF)
      IMAXB=IMAXC
      IMINB=IMINC
C
      DO 222 J=INCMIN+1,ISIZEB
      IMAXB=MAX (IMAXB,KDATA(IOFF+J))
      IMINB=MIN (IMINB,KDATA(IOFF+J))
  222 CONTINUE
C
      ISOMAX=IMAXB-IMINB
      IMAXAB=MAX (IMAXA,IMAXB)
      IMINAB=MIN (IMINA,IMINB)
#ifdef ebug2o
      PRINT *,'c2gene - IMINB/IMAXB/IMINAB/IMAXAB=',
     X                  IMINB,IMAXB,IMINAB,IMAXAB
#endif
C
      IF (ISOMAX.LE.IPOWER/2.AND.IPOWER.GT.0) THEN
C
C       Group B has a smaller width than A.
C
C       Group A is closed, B replaces A, reminds that new initial group
C       characteristics (with the exception of width) have already been
C       computed.
C
        LB2A=.TRUE.
        GOTO 240
C
      ELSEIF ((IMAXAB-IMINAB).LE.IPOWER) THEN
C
C       Group B just fits with A, and is added to A as an extended
C       C group.
C
        ISIZEC=ISIZEB
        IMAXAC=IMAXAB
        IMINAC=IMINAB
C
      ELSE
C
C       Group B has a width at least equal to A, and would not fit
C       if added to A.
C
C       Group C is added to group A, and another C-type group
C       has to be checked.
C
        ISIZEC=INCMIN
C
      ENDIF
C
C       Incremental group (C or B) added to A.
C
      ISIZEA=ISIZEA+ISIZEC
      IMAXA=IMAXAC
      IMINA=IMINAC
      IOFF=IOFF+ISIZEC
C
      IF (IOFF.LT.KLEN) THEN
C
C       Another C-type group has to be checked...
C
        GOTO 220
C
      ENDIF
C
C       ...otherwise, finished.
C
C     -----------------------------------------------------------------
C     No incremental group may be added. Current A group is closed.
C     -----------------------------------------------------------------
C
  240 CONTINUE
C
      IGROUP=IGROUP+1
      KLENGR(IGROUP)=ISIZEA
      ICOUNT=ICOUNT+ISIZEA
      KBITGR(IGROUP)=INBITA
      ISOMAX=IMAXA-IMINA
C
C     Maximum use of width for second-order values: the maximum value
C     of group will be encoded with the biggest value fitting within
C     INBITA bits, and keeping reference value positive or zero.
C
C     The goal is to get the lowest reference value, thus trying
C     (desperately) to save bit(s) to encode the first-order values.
C
      KREFGR(IGROUP)=MAX (0,IMINA-(IPOWER-ISOMAX))
#ifdef ebug2o
      PRINT *,'c2gene - IGROUP/ISIZEA/INBITA/IMINA/IMAXA/refer=',
     X                  IGROUP,ISIZEA,INBITA,IMINA,IMAXA,KREFGR(IGROUP)
#endif
C
      IF (ICOUNT.EQ.KLEN) THEN
C
C       Work finished.
C
        GOTO 250
C
      ELSEIF (IGROUP.GE.KLWORK) THEN
C
C     Out of work space.
C
        IRETFN = 21240
        WRITE(GRPRSM,FMT=9240) KLWORK
        KLWORX=KLWORK
        GOTO 900
C
      ELSEIF (LB2A) THEN
C
C       Transforms B group into A group.
C
        ISIZEA=ISIZEB
        IMAXA=IMAXB
        IMINA=IMINB
C
C       Go back, starting by width computing.
C
        GOTO 212
C
      ELSE
C
C       Another A group must be determined.
C
        GOTO 210
C
      ENDIF
C
C     -----------------------------------------------------------------
C     Groups have been determined. Computes associated descriptors.
C     -----------------------------------------------------------------
C
  250 CONTINUE
C
      KLWORX=IGROUP
      IFIROV=IGROUP
C
C     Number of bits necessary to code first-order values.
C
      CALL MAXMNI (KREFGR,IFIROV,IDMAX,IDMIN)
      INBIFO = C2BITW ( IDMAX,  INBITO, KPOWER, KMXPWR )
C
C     Length (bits) of second-order values.
C
      ILENSO=0
C
      DO 253 J=1,IFIROV
      ILENSO=ILENSO+KLENGR(J)*KBITGR(J)
  253 CONTINUE
C
C     -----------------------------------------------------------------
C     Descriptors that are computed even if OCOMGR is false.
C     -----------------------------------------------------------------
C
  260 CONTINUE      
C
      IF (LGENXT) THEN
C
C       Compute group width (width of widths), that may be here
C       different than 8.
C 
        CALL MAXMNI (KBITGR,IFIROV,ISOMAX,IAUXIL)
        IBITGW = C2BITW ( ISOMAX, INBITO, KPOWER, KMXPWR )
C
C       Compute width of lengths.
C 
        CALL MAXMNI (KLENGR,IFIROV,IDMAX,IDMIN)
        IBITGS = C2BITW ( IDMAX,  KMXPWR, KPOWER, KMXPWR )
C
        KSEC4(17)=IBITGS
C
        IF (IORDER.EQ.0) THEN
          ILDSTG=ILDSTA+4
        ELSE
          ILDSTG=ILDSTA+5+(8+IWIDSD*(IORDER+1)-1)/8
        ENDIF
C
#ifndef ebug2o
        IF (ODEBUG) THEN
#endif
          WRITE(GRPRSM,FMT=9260) IAUXIL, ISOMAX, IBITGW, IDMIN, IDMAX,
     X                            IBITGS
#ifndef ebug2o
        ENDIF
C
#endif
      ELSE
C
C      Define group width (width of widths).
C
        IBITGW=8
C
      ENDIF
C
      KSEC4(20)=IBITGW
C
      IF (OCOMGR) THEN
C
        KSEC4(19)=ILENSO
        KNBIFO=INBIFO
        KFIROV=IFIROV
C
      ENDIF
C
C     -----------------------------------------------------------------
C     Compute full length of section 4 of GRIB.
C     -----------------------------------------------------------------
C 
      IF (LGENXT) THEN
C
        ILENGS=IFIROV*IBITGS
        KLEN4=IXLEN4 ( ILDSTG, IFIROV, IBITGW, ILENGS )
C
#ifndef ebug2o
        IF (ODEBUG) THEN
#endif
          WRITE(GRPRSM,FMT=9270) KLEN4
          ILEN4O=KLEN4
#ifndef ebug2o
        ENDIF
C
#endif
C     -----------------------------------------------------------------
C        Try to reduce size of lengthes descriptors, splitting groups
C        that require exactly IBITGS bits for their lengthes.
C     -----------------------------------------------------------------
C
        IAUXIL=MIN (KLWORK/2,IFIROV)
C
  270   CONTINUE
C
        IGROUP=0
        IGRADD=0
        IDMAX=KPOWER(IBITGS-1)+1
C
        DO 271 J=1,IFIROV
C
        IF (KLENGR(J).GE.IDMAX) THEN
C
          IF (IGROUP.GE.IAUXIL) THEN
C
C           Out of work space. No (further) splitting performed.
C
            KLWORX=MAX (KLWORX,IAUXIL+IGROUP)
            GOTO 280
C
          ELSE
C
C           Compute number of sub-groups that would replace current
C           group, with a length requiring one bit less for encoding.
C           (2, except when original length=2**IBITGS-1, where 3
C            sub-groups are necessary)
C
C
            IGROUP=IGROUP+1
            KWORK(IGROUP)=J
            KWORK(IAUXIL+IGROUP)=1+(KLENGR(J)+1)/IDMAX
            IGRADD=IGRADD+KWORK(IAUXIL+IGROUP)
C  
          ENDIF
C
        ENDIF
C
  271   CONTINUE
C
        IGRADD=IGRADD-IGROUP
        IGROUS=IFIROV+IGRADD
        ILENGS=IGROUS*(IBITGS-1)
        ILEN4S=IXLEN4 ( ILDSTG, IGROUS, IBITGW, ILENGS )
        KLWORX=MAX (KLWORX,IAUXIL+IGROUP)
C
#ifndef ebug2o
        IF (ODEBUG) THEN
#endif
          WRITE(GRPRSM,FMT=9271) IFIROV, IGRADD, ILEN4S
#ifndef ebug2o
        ENDIF
C
#endif
        IF (IGROUS.LE.KLWORK.AND.ILEN4S.LT.KLEN4) THEN
C
C         Splitting performed, leading to better compression ratio
C         with some shorter groups.
C
          ILASTG=IFIROV
C
          DO 275 J=IGROUP,1,-1
C
          IPOSGR=KWORK(J)
          INGRAD=KWORK(IAUXIL+J)
C
C         Push up groups above current group to split.
C
#ifdef CRAY
CDIR$ IVDEP
#endif
#ifdef FUJITSU
!OCL NOVREC
#endif
          DO 273 J2=ILASTG,IPOSGR+1,-1
C
          KREFGR(J2+IGRADD)=KREFGR(J2)
          KBITGR(J2+IGRADD)=KBITGR(J2)
          KLENGR(J2+IGRADD)=KLENGR(J2)
C
  273     CONTINUE
C
#ifdef ebug2o
          PRINT *,'c2gene - after loop 273: ',IPOSGR+1+IGRADD
#endif
C
C         Split current group.
C
#ifdef CRAY
CDIR$ NOVECTOR
#endif
#ifdef FUJITSU
!OCL SCALAR
#endif
          DO 274 J2=INGRAD,1,-1
C
          INDNEW=J2-INGRAD+IGRADD+IPOSGR
#ifdef ebug2o
          PRINT *,INDNEW
#endif
          KREFGR(INDNEW)=KREFGR(IPOSGR)
          KBITGR(INDNEW)=KBITGR(IPOSGR)
          KLENGR(INDNEW)=(KLENGR(IPOSGR)+INGRAD-J2)/INGRAD
C
  274     CONTINUE
#ifdef CRAY
CDIR$ VECTOR
#endif
#ifdef FUJITSU
!OCL VECTOR
#endif
C
#ifdef ebug2o
          PRINT *,'c2gene - J/IPOSGR/INGRAD/ILASTG/IGRADD/len=',
     X             J, IPOSGR, INGRAD, ILASTG, IGRADD,
     X        (KLENGR(J2-INGRAD+IGRADD+IPOSGR),J2=1,INGRAD)
#endif
C
          IGRADD=IGRADD-(INGRAD-1)
          ILASTG=IPOSGR-1
C
  275     CONTINUE
C
#ifndef ebug2o
          IF (ODEBUG) THEN
#endif
            WRITE(GRPRSM,FMT=9272) IGROUS, IBITGS-1
#ifndef ebug2o
          ENDIF
C
#endif
C
C         Update descriptors.
C
          IBITGS=IBITGS-1
          IFIROV=IGROUS
          KLWORX=MAX (KLWORX,IGROUS)
          KSEC4(17)=IBITGS
          KFIROV=IFIROV
          KLEN4=ILEN4S
C
C         Loop back to try another splitting.
C
          GOTO 270
C
        ELSEIF (KLEN4.NE.ILEN4O) THEN
C
#ifndef ebug2o
          IF (ODEBUG) THEN
#endif
            ZGAIN=REAL (100*(ILEN4O-KLEN4)) / REAL (ILEN4O)
            WRITE(GRPRSM,FMT=9273) ZGAIN
#ifndef ebug2o
          ENDIF
C
#endif
        ENDIF
C
      ELSE
C
        KLEN4=IXLEN4 ( ILDSTA, IFIROV, IBITGW, KLEN )
C
      ENDIF
C
  280 CONTINUE
C
      IF (OLONLY) THEN
C
C       Length has been computed, go back without any coding.
C
        GOTO 900
C
      ENDIF
C
C     -----------------------------------------------------------------
C*    Section 3. Definition of fixed-length descriptors, and coding.
C     -----------------------------------------------------------------
C
  300 CONTINUE
C
C     The first 10 octets have already been coded in GRIBEX, or will
C     be in a further step of GRIBEX:
C     Length of section, flags+unused bit count, binary scale factor,
C     reference value.
C
#ifndef ebug2o
      IF (ODEBUG) THEN
#endif
        WRITE(GRPRSM,FMT=9300) 
#ifndef ebug2o
      ENDIF
C
#endif
C     Enforce right values for extended flags.
C
      IF (LGENXT) THEN
        KSEC4( 9)=0
        KSEC4(12)=8
      ELSE
        KSEC4( 9)=32
        KSEC4(12)=0
      ENDIF      
C
      KSEC4(10)=16
C
C     Extra descriptors.
C
      KSEC4(18)=KFIROV
      KSEC4(20)=IBITGW
      ILWORK=KLWORK-ISTART+1
C
      IRETFN = C2PACK ( KDATA,  KLENP,  KSEC4,  KGRIB,  KLENG,  KNSPT,
     X                  KBITS,  KLEN,   KREFGR(ISTART), KLENGR(ISTART),
     X                  KBITGR(ISTART), KWORK, ILWORK,  KPOWER, KMXPWR,
     X                  KNBIFO, ODEBUG )
C
C     -----------------------------------------------------------------
C*    Section 9. Return to calling routine.
C     -----------------------------------------------------------------
C
  900 CONTINUE
C
      C2GENE = IRETFN
#ifndef ebug2o
C
      IF (ODEBUG) THEN
#endif
        WRITE(GRPRSM,FMT=9900) IRETFN, OCOMGR, OLONLY, KNSPT
#ifndef ebug2o
      ENDIF
#endif
C
      RETURN
C
 9100 FORMAT (' C2GENE: Function start, OCOMGR = ',L1,
     X        ', OLONLY = ',L1,', KNSPT =',I10,'.')
 9101 FORMAT (' C2GENE: Type of 2nd order packing requested: ',A,'.')
C
 9200 FORMAT (' C2GENE: Computing work arrays, INBITO =',I3,'.',/,
     X        ' C2GENE: KSEC4(1:15)=',I9,I3,I4,3I3,I2,4I3,4I2,'.',/,
     X        ' C2GENE: INCMIN =',I3,', ISIZEG =',I6,'.')
C
 9240 FORMAT (' C2GENE: Groups number exceeds work space (',I8,') .')
C
 9260 FORMAT (' C2GENE: Min, Max, Width of widths/lengths =',2(I3,','),
     X        I2,' /',2(I8,','),I3,'.')
C
 9270 FORMAT (' C2GENE: Length of section 4 for general extended case:'
     X        ,I9,'.')
 9271 FORMAT (' C2GENE: Group splitting test, from',I8,' groups',SP,
     X        I7,SS,', s4 length',I9,'.')
 9272 FORMAT (' C2GENE: Group splitting performed,',I8,
     X        ' groups, new width of lengths =',I3,'.')
 9273 FORMAT (' C2GENE: Relative gain of group splitting on section 4 ',
     X        'length:',F5.1,' %.')
C
 9300 FORMAT (' C2GENE: Coding phase - calling C2PACK.')
C
 9900 FORMAT (' C2GENE: Function return code=',I6,
     X        ', OCOMGR/OLONLY/KNSPT=',2L1,I10,'.')
C
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE SH2SH(UFLDIN, KRESIN, UFLDOU, KRESOU)
      IMPLICIT NONE
C
C---->
C**** SH2SH
C
C     Purpose
C     _______
C
C     This routine produces a field of spectral coefficients in UFLDOU
C     of truncation KRESOU from a field of spectral coeeficients in
C     UFLDIN of truncation KRESIN.
C
C
C     Interface
C     _________
C
C     CALL SH2SH(UFLDIN, KRESIN, UFLDOU, KRESOU)
C
C
C     Input parameters
C     ________________
C
C     UFLDIN       - field of spectral coefficients
C     KRESIN       - truncation of input field
C     KRESOU       - truncation of output field
C
C
C     Output parameters
C     ________________
C
C     UFLDOU       - field of spectral coefficients
C
C
C     Common block usage
C     __________________
C
C     None
C
C
C     Method
C     ______
C
C     If the input truncation is greater than (or equal to) the output
C     truncation, coefficients are transferred reduced for the output.
C
C     If the input truncation is less than the output truncation,
C     all coefficients are transferred and padded with zeroes for the
C     output.
C
C
C     Externals
C     _________
C
C     None
C
C
C     Reference
C     _________
C
C     None
C
C
C     Comments
C     ________
C
C     Arrays for the input and output fields must be defined large
C     enough for the coefficients implied by the truncations.  Thus
C     the dimension for UFLDOU must be at least:
C         ( KRESOU + 1) * ( KRESOU + 2 ) /2
C
C
C     Author
C     ______
C
C     J.D.Chambers       ECMWF      8th Nov 1993
C
C
C     Modifications
C     _____________
C
C     None
C
C----<
C     _______________________________________________________
C
C
C*    Section 0. Definition of variables.
C     _______________________________________________________
C
C*    Prefix conventions for variable names
C
C     Logical      L (but not LP), global or common.
C                  O, dummy argument
C                  G, local variable
C                  LP, parameter.
C     Character    C, global or common.
C                  H, dummy argument
C                  Y (but not YP), local variable
C                  YP, parameter.
C     Integer      M and N, global or common.
C                  K, dummy argument
C                  I, local variable
C                  J (but not JP), loop control
C                  JP, parameter.
C     Real         A to F and Q to X, global or common.
C                  P (but not PP), dummy argument
C                  Z, local variable
C                  PP, parameter.
C     Complex      U, dummy argument
C
C     _______________________________________________________
C
C     Subroutine arguments
      COMPLEX UFLDIN(*),UFLDOU(*)
      INTEGER KRESIN, KRESOU
C
C     Local variables
      INTEGER ITINP1, ITOUP1, ILIM, IMLIM, IMN, IMP, IADD
      INTEGER JM, JN
C
C     _______________________________________________________
C
C
C*    Section 1. Initialization
C     _______________________________________________________
C
  100 CONTINUE
C
C     Initialize loop control variables
C
      ITINP1 = KRESIN + 1
      ITOUP1 = KRESOU + 1
      ILIM   = ITOUP1
      IMLIM  = ITOUP1
      IMN = 1
      IMP = 1
C
C     _______________________________________________________
C
C
C*    Section 2. Computation.
C     _______________________________________________________
C
  200 CONTINUE
C
C     Check if desired output truncation greater than input ...
C
      IADD = KRESIN - KRESOU
      IF ( IADD .GE. 0 ) THEN
C
C     ... input truncation not less than desired output ...
C     ... move truncated lines of coefficients
        DO 230 JM = 1, IMLIM
          DO 220 JN = JM, ILIM
            UFLDOU(IMP) = UFLDIN(IMN)
            IMP = IMP + 1
            IMN = IMN + 1
220       CONTINUE
C                                Skip coefficients being truncated
        IMN = IMN + IADD
230     CONTINUE
C
C     ... input truncation is less than desired output ...
C     ... pad each output line of coefficients with zeroes
      ELSE
        DO 250 JM = 1, IMLIM
          DO 240 JN = JM, ILIM
            IF ( JN .GT. ITINP1 .OR. JM .GT. ITINP1) THEN
C                                At end of input coefficients in
C                                current row, then set values to
C                                zero in output
              UFLDOU(IMP) = 0.0
            ELSE
              UFLDOU(IMP) = UFLDIN(IMN)
              IMN = IMN + 1
            ENDIF
            IMP = IMP + 1
240       CONTINUE
250     CONTINUE
      ENDIF
C
C     _______________________________________________________
C
C
C*    Section 9. Return to calling routine.
C     _______________________________________________________
C
  900 CONTINUE
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities
C granted to it by virtue of its status as an intergovernmental organisation
C nor does it submit to any jurisdiction.
C

      INTEGER FUNCTION MKBITMP(KWE,KNS,ZSEC4,ZMISS)
C
C---->
C**** MKBITMP
C
C     Purpose
C     -------
C
C     Remove points using a bitmap.
C
C
C     Interface
C     ---------
C
C     CALL  MKBITMP(KWE,KNS,ZSEC4,ZMISS)
C
C     Input
C     -----
C
C     KWE    - Number of points west-east in input field.
C     KNS    - Number of points north-south in input field.
C     ZSEC4  - GRIBEX section 4 values in the field.
C     ZMISS  - Value to be used as the missing data value..
C
C
C     Output
C     ------
C
C     ZSEC4  - GRIBEX section 4 values with the points marked as
C              'missing' by the bitmap replaced by missing data values.
C
C     Function returns 0 if all OK.
C
C
C     Method
C     ------
C
C     The field and bitmap are rectangular.
C     Use NOBITMP, the name of a file describing the bitmap.
C
C
C     Externals
C     ---------
C
C     INTLOG  - Log error message.
C     MAKEMAP - Build a bitmap from definition in a file.
C     GMAPBIT - Get the bit value from a given position in a bitmap.
C     JFREE   - Frees dynamically allocated memory.
C
C
C     Author
C     ------
C
C     J.D.Chambers     ECMWF     April 2000.
C
C----<
C
      IMPLICIT NONE
C
C     Subroutine arguments
C
      INTEGER KWE,KNS
      REAL ZSEC4(*), ZMISS
C
C     Parameters
C
      INTEGER JPROUTINE
      PARAMETER ( JPROUTINE = 44000 )
C
C     Local variables
C
      INTEGER IRET,BITMAP,NROWS,NCOLS,NVALUE,NEXT,IROW,ICOL,NINDEX
      INTEGER OLDROWS, OLDCOLS, LOOP
      CHARACTER*256 OLDFILE
      DATA OLDFILE/' '/, BITMAP/-1/
      SAVE BITMAP,OLDROWS,OLDCOLS,OLDFILE
C
C     Externals
C
      INTEGER  MAKEMAP, GMAPBIT, JINDEX
      EXTERNAL MAKEMAP, GMAPBIT, JINDEX
C
#include "parim.h"
#include "jparams.h"
#include "nofld.common"
C
C     -----------------------------------------------------------------|
C*    Section 1.   Initialise
C     -----------------------------------------------------------------|
C
  100 CONTINUE
C
      MKBITMP = 0
C
C     Only build bitmap if filename has changed since last time through
C
      NINDEX = JINDEX(NOBITMP)
      IF( NINDEX.LT.1 ) THEN
        CALL INTLOG(JP_WARN,'MKBITMP: No bitmap name given',JPQUIET)
        CALL INTLOG(JP_WARN,'MKBITMP: BITMAP NOT APPLIED',JPQUIET)
        MKBITMP = JPROUTINE + 1
        GOTO 900
      ENDIF
C
      IF( OLDFILE(1:NINDEX).NE.NOBITMP(1:NINDEX) ) THEN
        OLDFILE(1:NINDEX) = NOBITMP(1:NINDEX)
        IF( NDBG.NE.0 )
     X    CALL INTLOG(JP_DEBUG,
     X      'MKBITMP: New BITMAP: '//OLDFILE(1:NINDEX),JPQUIET)
C
        IF( BITMAP.NE.-1 ) CALL JFREE(BITMAP)
C
        IRET = MAKEMAP(NOBITMP,NROWS,NCOLS,BITMAP)
        IF( IRET.NE.0 ) THEN
          CALL INTLOG(JP_WARN,'MKBITMP: Failed to make bitmap',IRET)
          CALL INTLOG(JP_WARN,'MKBITMP: BITMAP NOT APPLIED',JPQUIET)
          DO LOOP = 1, 256
            OLDFILE(LOOP:LOOP) = ' '
          ENDDO
          MKBITMP = JPROUTINE + 2
          GOTO 900
        ENDIF
        OLDROWS = NROWS
        OLDCOLS = NCOLS
      ELSE
        NROWS = OLDROWS
        NCOLS = OLDCOLS
      ENDIF
C
      IF( (NROWS.NE.KNS).OR.(NCOLS.NE.KWE) ) THEN
        CALL INTLOG(JP_WARN,'MKBITMP: Bitmap invalid for area',JPQUIET)
        CALL INTLOG(JP_WARN,'MKBITMP: No. of subarea rows    = ',KNS)
        CALL INTLOG(JP_WARN,'MKBITMP: No. of subarea columns = ',KWE)
        CALL INTLOG(JP_WARN,'MKBITMP: No. of bitmap rows    = ',NROWS)
        CALL INTLOG(JP_WARN,'MKBITMP: No. of bitmap columns = ',NCOLS)
        CALL INTLOG(JP_WARN,'MKBITMP: BITMAP NOT APPLIED',JPQUIET)
        MKBITMP = JPROUTINE + 3
        GOTO 900
      ENDIF
C
C     -----------------------------------------------------------------|
C*    Section 2.   Use bitmap to force missing values
C     -----------------------------------------------------------------|
C
  200 CONTINUE
C
      IF( NDBG.NE.0 )
     X  CALL INTLOG(JP_DEBUG,'MKBITMP: BITMAP applied',JPQUIET)
C
      NEXT = 0
      DO IROW = 1, KNS
        DO ICOL = 1, KWE
          NEXT = NEXT + 1
          NVALUE = GMAPBIT(BITMAP,NCOLS,IROW,ICOL)
          IF( NVALUE.EQ.0 ) ZSEC4(NEXT) = ZMISS
        ENDDO
      ENDDO
C
C     -----------------------------------------------------------------|
C*    Section 9.   Closedown.
C     -----------------------------------------------------------------|
C
  900 CONTINUE
C
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities
C granted to it by virtue of its status as an intergovernmental organisation
C nor does it submit to any jurisdiction.
C

      SUBROUTINE EXSCAL (PDATA,KDATA,KLEN,PREF,PSCALE,LALLPOS)
C
C---->
C**** EXSCAL - Vectorise calculation of values.
C
C     Purpose.
C     --------
C
C     Vectorise calculation of values.
C
C**   Interface.
C     ----------
C
C     CALL EXSCAL (PDATA,KDATA,KLEN,PREF,PSCALE,LALLPOS)
C
C
C     Input Parameters.
C     -----------------
C
C     KDATA   - Array of integer increments
C     KLEN    - Number of values to be converted.
C     PREF    - Reference value.
C     PSCALE  - Scale factor.
C     LALLPOS - .TRUE. if all packed value occupies full (integer)
C                      word, eg 32 bits on a 32-bit integer machine.
C
C     Output Parameters.
C     -----------------
C
C     PDATA   - Array of floating point values.
C
C     Method.
C     -------
C
C     The reference value is added to each increment,
C     and the result is then multiplied by the scale factor.
C
C     Externals.
C     ----------
C
C     None.
C
C     Reference.
C     ----------
C
C     WMO Manual on Codes re GRIB representation.
C
C     Comments.
C     --------
C
C     PDATA and KDATA are really the same array. This routine
C     is just a device to force vectorisation on the Cray,
C     without the necessity of using another array.
C
C
C     Author.
C     -------
C
C     J. Hennessy     ECMWF     25.06.91
C
C
C     Modifications.
C     _____________
C
C     J.D.Chambers    ECMWF     06.09.95
C     Reverse processing in loop to run from last to first in
C     case reals are larger than integers.
C
C     J.D.Chambers    ECMWF     16.05.96
C     Handle case when packed value occupies full word.
C
C----<
C     -----------------------------------------------------------------
C     Section 0.    Definition of variables.
C     -----------------------------------------------------------------
C
      IMPLICIT NONE
C
C     Subroutine arguments
      INTEGER KDATA
      INTEGER KLEN
      INTEGER LOOP
      REAL PDATA
      REAL PREF
      REAL PSCALE
      LOGICAL LALLPOS
      DIMENSION PDATA(KLEN)
      DIMENSION KDATA(KLEN)
C
      REAL*8 BIG, RTEMP
      DATA BIG /4294967296.0/
C
C     -----------------------------------------------------------------
C*    Section 1 . Calculation of values.
C     -----------------------------------------------------------------
C
  100 CONTINUE
#ifdef CRAY
C
      DO 110 LOOP = KLEN, 1, -1
        PDATA(LOOP) = PREF + KDATA(LOOP)*PSCALE
  110 CONTINUE
#else
C
      IF( .NOT. LALLPOS ) THEN
        DO 110 LOOP = KLEN, 1, -1
          PDATA(LOOP) = PREF + KDATA(LOOP)*PSCALE
  110   CONTINUE
C
C     Packed values use all bits in integer word, ie sign bit is
C     really a data bit.
      ELSE
        DO 120 LOOP = KLEN, 1, -1
          IF( KDATA(LOOP) .GE. 0 ) THEN
            PDATA(LOOP) = PREF + KDATA(LOOP)*PSCALE
          ELSE
            RTEMP = BIG + DBLE(KDATA(LOOP))
            PDATA(LOOP) = PREF + RTEMP*PSCALE
          ENDIF
  120   CONTINUE
      ENDIF
#endif
C
C     -----------------------------------------------------------------
C*    Section 9. Return to calling routine.
C     -----------------------------------------------------------------
C
  900 CONTINUE
      RETURN
      END

C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities
C granted to it by virtue of its status as an intergovernmental organisation
C nor does it submit to any jurisdiction.
C
      SUBROUTINE GRIBEX (KSEC0,KSEC1,KSEC2,PSEC2,KSEC3,PSEC3,KSEC4,
     C                   PSEC4,KLENP,KGRIB,KLENG,KWORD,HOPER,KRET)
C---->
#include "gribex.h"
C----<
C     -----------------------------------------------------------------|
C*    Section 0 . Definition of variables. Data statements.
C     -----------------------------------------------------------------|
C
      IMPLICIT NONE
C
#include "grprs.h"
C
C     Subroutine arguments
C
      INTEGER KSEC0,KSEC1,KSEC2,KSEC3,KSEC4,KGRIB
      DIMENSION KGRIB(*), KSEC0(*), KSEC1(*)
      DIMENSION KSEC2(*), KSEC3(*), KSEC4(*)
      INTEGER KLENP,KLENG,KWORD, KRET
      REAL PSEC2, PSEC3, PSEC4
      DIMENSION PSEC2(*), PSEC3(*), PSEC4(*)
      CHARACTER*(*) HOPER
C
C     Local variables
C
      INTEGER N, NP, NINC
      REAL  JPEPSLN
      PARAMETER (JPEPSLN=1E-12)
C                         `-----> tolerance used to check equality
C                                 of floating point numbers - needed
C                                 on some platforms (eg vpp700, linux)
      CHARACTER*1   YFUNC, YTEMP
      INTEGER IJDC, JLOOP, JLOOPO, ISTATUS, ISECLEN
      INTEGER IDUMP
#ifdef REAL_BIGGER_THAN_INTEGER
      INTEGER IINDEX, ILOOPS, NREM, JPNSEC4, ILNGTH
      PARAMETER (JPNSEC4=12800)
      INTEGER*4 NSEC4
      DIMENSION NSEC4(JPNSEC4)
      REAL*4    XSEC4
      DIMENSION XSEC4(JPNSEC4)
      EQUIVALENCE (NSEC4(1), XSEC4(1))
      INTEGER*8 IJDCXX
      REAL*8    RJDCXX
#else
      INTEGER IJDCXX
      REAL    RJDCXX
#endif
      EQUIVALENCE (IJDCXX, RJDCXX)
      INTEGER I,IBLEN,IBITS,IBMAP,IBMAP2,IBYTEX,ICOUNT,NBYTE
      INTEGER IEXP, IFLAG, IFLAGX, IFPT, IL
      INTEGER ILEN, ILENF, ILEN1, ILEN2, ILEN3, ILEN4
      INTEGER IMANT, IMISNG, IMISS, IMODAY, INC
      INTEGER INIL, INITAL, INOLAT, INOLNG, INSPT, INUB
      INTEGER INUM, IOFF, IPL, IPLEN, IPSEUD
      INTEGER IPVPL, IRESOL, ISBMAP, NONMISS
      INTEGER ISCALE, ISINT, ISKALE
      INTEGER ISKIP, ITEMP, ITRND, IVALS, IP7777
      INTEGER IEAST, IWEST, ILOEXT, INROWS
C
      INTEGER JPEDNO, JPLEN1
      INTEGER KRETA, KRETB
      INTEGER ITRUNC, ISUBSET, IS3BYTE
      INTEGER NBPV
      REAL RANGE
C
C     Wave coordinate information held in KSEC4 are 32-bit REALs,
C     so REAL*4 ZREAL4 must be used for encoding/decoding.
C
      REAL*4  ZREAL4
      REAL    ZMAXV, ZMAX, ZMIN, ZMISNG, ZMSVAL, ZREAL, ZREF, ZVAL
#if defined(CRAY) || defined(CYBER) ||((defined IBM)&&(!defined rs6000))
      REAL    ZS, ZAUXIL
#else
      DOUBLE PRECISION    ZS, ZAUXIL
#endif
      REAL    ZSCALE
C
      LOGICAL LENCODE, LDECODE, LPDEBUG
      LOGICAL LGRDPT, LSPHERC, LCOMPLX
      LOGICAL LECMWF, LECLOC, LKWBCE, LSST11
      LOGICAL LLARGE
      LOGICAL LQUASI, LSECT2, LSECT3, LPERIO
      LOGICAL L_IORJ
      LOGICAL LALLPOS
      LOGICAL LVEGGY
      LOGICAL LSATIMG
      INTEGER NITABLE, NICENTRE, NIPARAM
C
C     Externals
C
      INTEGER EGGSEC2, DGGSEC2, ELLSEC2, DLLSEC2, ESHSEC2, DSHSEC2
      INTEGER EOCSEC2, DOCSEC2, ESVSEC2, DSVSEC2, EMESEC2, DMESEC2
      INTEGER CSECT4, DSECT4A, GBITMAP, D2ORDR, C2ORDR, REF2GRB
      INTEGER ONEBITS, D13FLAG
C#ifdef GRIB2
C     INTEGER G2ENCOD
C     EXTERNAL G2ENCOD
C#endif
      EXTERNAL CSECT4, DSECT4A, GBITMAP, D2ORDR, C2ORDR, REF2GRB
      EXTERNAL EGGSEC2, DGGSEC2, ELLSEC2, DLLSEC2, ESHSEC2, DSHSEC2
      EXTERNAL EOCSEC2, DOCSEC2, ESVSEC2, DSVSEC2, EMESEC2, DMESEC2
      EXTERNAL ONEBITS, D13FLAG
C
C     GRIB code version number used in coding data.
C
      PARAMETER (JPEDNO=1)
C
C     GRIBEX version number
C
      INTEGER IGRIBEX
      CHARACTER*6 YGRIBEX
C
C     Length (in octets) used for Section 1, when coding data.
C
      PARAMETER (JPLEN1=28)
C
      INTEGER IPARM, ILALO, IGRIB, I7777
      DIMENSION IPARM(4), ILALO(2), IGRIB(4), I7777(4)
C
      INTEGER JP24SET, JP23SET, JP16SET, JP8SET
      PARAMETER ( JP24SET = 2**24 - 1 )
C                            ^---> 16777215 = FFFFFF(hex)
      PARAMETER ( JP23SET = 2**23 - 1 )
C                            ^---> 8388607  = 7FFFFF(hex)
      PARAMETER ( JP16SET = 2**16 - 1 )
C                            ^---> 65535    =   FFFF(hex)
      PARAMETER ( JP8SET  = 2**8 - 1 )
C                            ^---> 255      =     FF(hex)
C
C     Predetermined bitmask variables
C
#ifndef USE_NO_POINTERS
      INTEGER IBTMAP, IBTVALS
#ifndef _CRAYFTN
#ifdef POINTER_64
      INTEGER*8 IBTPTR
#endif
#endif
      POINTER (IBTPTR,IBTMAP)
      DIMENSION IBTMAP(1)
#endif
C
#include "grbcom.h"
C
C     Missing data indicator for integer and real values in GRIB code
C     header fields.
C
      EQUIVALENCE (IMISNG,ZMISNG)
C
      EQUIVALENCE (ZREAL4,ISINT)
C
      SAVE INITAL, IBITS, IMISNG, NBYTE
C
C     Characters GRIB and 7777 in Ascii for use in Sections 0 and 5
C     of GRIB code.
C
      DATA IGRIB /71,82,73,66/
      DATA I7777 /55,55,55,55/
      DATA YGRIBEX/'13.040'/, IGRIBEX/13040/
C
C     Initialise local variables
C
      DATA YFUNC/' '/,YTEMP/' '/
      DATA IJDC/0/,JLOOP/0/,JLOOPO/0/
#ifdef REAL_BIGGER_THAN_INTEGER
      DATA IINDEX/0/,ILOOPS/0/,NREM/0/,ILNGTH/0/
#endif
      DATA IJDCXX/0/,I/0/,IBLEN/0/,IBITS/0/,IBMAP/0/,IBMAP2/0/
      DATA IBYTEX/0/,ICOUNT/0/,NBYTE/0/
      DATA IEXP/0/,IFLAG/0/,IFLAGX/0/,IFPT/0/,IL/0/
      DATA ILEN/0/,ILENF/0/,ILEN1/0/,ILEN2/0/,ILEN3/0/,ILEN4/0/
      DATA IMANT/0/,IMISNG/0/,IMISS/0/,IMODAY/0/,INC/0/
      DATA INIL/0/,INITAL/0/,INOLAT/0/,INOLNG/0/,INSPT/0/,INUB/0/
      DATA INUM/0/,IOFF/0/,IPL/0/,IPLEN/0/,IPSEUD/0/
      DATA IPVPL/0/,IRESOL/0/,ISBMAP/0/,NONMISS/0/
      DATA ISCALE/0/,ISINT/0/,ISKALE/0/
      DATA ISKIP/0/,ITEMP/0/,ITRND/0/,IVALS/0/,IP7777/0/
      DATA IEAST/0/,IWEST/0/,ILOEXT/0/,INROWS/0/
C
      DATA KRETA/0/,KRETB/0/,ITRUNC/0/,ISUBSET/0/
C
      DATA ZMAXV/0.0/,ZMAX/0.0/,ZMIN/0.0/,ZMSVAL/0.0/
      DATA ZREF/0.0/,ZVAL/0.0/,ZS/0.0/,ZAUXIL/0.0/,ZSCALE/0.0/
C
      DATA LENCODE/.FALSE./,LDECODE/.FALSE./,LPDEBUG/.FALSE./
      DATA LGRDPT/.FALSE./,LSPHERC/.FALSE./,LCOMPLX/.FALSE./
      DATA LECMWF/.FALSE./,LECLOC/.FALSE./,LKWBCE/.FALSE./
      DATA LSST11/.FALSE./,LLARGE/.FALSE./,LQUASI/.FALSE./
      DATA LSECT2/.FALSE./,LSECT3/.FALSE./,LPERIO/.FALSE./
      DATA L_IORJ/.FALSE./,LALLPOS/.FALSE./
C
C     -----------------------------------------------------------------|
C*    Section 1 . Set initial values.
C     -----------------------------------------------------------------|
C
  100 CONTINUE
CC    Avoid using GRIBEX at (almost) all costs
      WRITE(GRPRSM,*) 'GRIBEX: functionality superseded by GRIB_API.'
#ifdef GRIBEX_ABORT
      CALL ABORTX('GRIBEX')
#endif
C
C     Handle 'V' option - display version number
C
      IF( HOPER(1:1).EQ.'V' ) THEN
        WRITE(GRPRSM,*) 'GRIBEX: Version is ',YGRIBEX
        KRET = IGRIBEX
        RETURN
      ENDIF
C
C     Clear definition 13  flag
C
      N13FLAG = -1
C
C     Clear flag indicating GRIB product longer than 2**23-1 bytes long.
      LLARGE = .FALSE.
C
C     Initialise flag indicating 'quasi-regular grid'
      LQUASI = .FALSE.
C
C*    Set number of bits per computer word,missing data indicator and
C     the number of bytes per computer word first time through.
C     Try to set default values for parameters in common area,
C     if not already set by user via calls to the GRS--- routines.
C
      IF( INITAL.EQ.0) THEN
        CALL SETPAR (IBITS,IMISNG,NDBG)
        NBYTE = IBITS/8
        INITAL = 1
        CALL GRSDEF
      ENDIF
C
      IMISS = 0
C
C
C     Set encoding/decoding flags initially dependent on 'L' option,
C     since this option skips round most processing.
      LENCODE = ( HOPER(1:1) .NE. 'L' )
      LDECODE = ( HOPER(1:1) .EQ. 'L' )
C
      LPDEBUG = ( NDBG.GE.1 )
C
      IF( LPDEBUG ) THEN
        WRITE(GRPRSM,*) 'GRIBEX: Version is ',YGRIBEX
        WRITE(GRPRSM,*) 'GRIBEX: Section 1. Input values used -'
        WRITE(GRPRSM,*)
     X  'GRIBEX: Length of GRIB array (KLENG) = ',KLENG
        WRITE(GRPRSM,*)
     X  'GRIBEX: Length of data array (KLENP) = ',KLENP
        WRITE(GRPRSM,*) 'GRIBEX: Operation code = ', HOPER
Ce
Ce      Extra printout if encoding
Ce
        IF( HOPER.EQ.'C'.OR.HOPER.EQ.'M'.OR.HOPER.EQ.'K') THEN
          KSEC0(2) = JPEDNO
          CALL GRPRS1(KSEC0,KSEC1)
Ce
          LSECT2 = KSEC1(5).GE.128
          LSECT3 = MOD(KSEC1(5),128).GE.64
Ce
Ce        Print section 2 if present.
Ce
          IF( LSECT2 ) CALL GRPRS2(KSEC0,KSEC2,PSEC2)
Ce
Ce        Print section 3 if present.
Ce
          IF( LSECT3 ) CALL GRPRS3(KSEC0,KSEC3,PSEC3)
Ce
Ce        Print section 4.
Ce
          CALL GRPRS4(KSEC0,KSEC4,PSEC4)
Ce
Ce        Special print for 2D spectra wave field real values in
Ce        section 4
Ce
          IF( (KSEC1(1).EQ.140) .AND.
     X        (KSEC1(2).EQ. 98) .AND.
     X        (KSEC1(24).EQ. 1) .AND.
     X        ( (KSEC1(40).EQ.1045).OR.(KSEC1(40).EQ.1081) ) .AND.
     X        ( (KSEC1(6) .EQ. 250).OR.(KSEC1(6) .EQ. 251) ) )
     X      CALL GRPRS4W(KSEC4)
        ENDIF
      ENDIF
C
C     Reset return code to 0, retaining input value to decide
C     on abort / no abort, if error encountered later.
C
      NOABORT = KRET
      KRET    = 0
C
C     IPSEUD is used to indicate pseudo-GRIB data encountered,
C     when decoding.
C     ISBMAP is the bit-map section flag and indicates what decoding
C     has been done on bit-maps and data.
C     See informative return codes for KRET when decoding.
C
      IPSEUD = 0
      ISBMAP = 0
C
C     Reset bit-pointer to 0.
C
      INSPT = 0
C
C     -----------------------------------------------------------------|
C
C
C
C
C
C
C
C
C
C
C*    Section 2 . Check input parameters.
C     -----------------------------------------------------------------|
C
  200 CONTINUE
C
      IF( LPDEBUG ) WRITE(GRPRSM,*)
     X 'GRIBEX: Section 2. Check input parameters.'
C
C*    Check that valid function has been requested.
C
      YFUNC = HOPER
#ifdef USE_NO_POINTERS
      IF( YFUNC.EQ.'R' ) THEN
        KRET = 201
        WRITE(GRPRSM,*) 'GRIBEX: Invalid function requested - ',HOPER
        WRITE(GRPRSM,*) 'GRIBEX: Return code = ', KRET
        GO TO 900
      ENDIF
#endif
      L_IORJ = (HOPER.EQ.'I').OR.(HOPER.EQ.'J')
      IF( YFUNC.NE.'C'.AND.YFUNC.NE.'D'.AND.(.NOT.L_IORJ).AND.
     X    YFUNC.NE.'L'.AND.YFUNC.NE.'R'.AND.YFUNC.NE.'S'.AND.
     X    YFUNC.NE.'X'.AND.YFUNC.NE.'Z'.AND.YFUNC.NE.'M'.AND.
     X    YFUNC.NE.'G'.AND.YFUNC.NE.'A'.AND.YFUNC.NE.'B'.AND.
     X    YFUNC.NE.'K') THEN
        KRET = 201
        WRITE(GRPRSM,*) 'GRIBEX: Invalid function requested - ',HOPER
        WRITE(GRPRSM,*) 'GRIBEX: Return code = ', KRET
        GO TO 900
      ENDIF
C
C     Function 'A' encodes 8-bit data.
      IF( HOPER.EQ.'A') YFUNC = 'C'
C
C     Function 'B' decodes 8-bit data.
      IF( HOPER.EQ.'B') YFUNC = 'D'
C
C*    Function 'L' returns the length of the GRIB message and
C     GRIB Edition number only, so no array initialisation is
C     necessary.
C
      IF( YFUNC.EQ.'L') GO TO 300
C
C*    Function 'M' is for coding data, and if a bit map is encountered
C     GRIB messages are made a fixed length. HOPER is passed to the
C     bit-map handling routine.
C
      IF( HOPER.EQ.'M') YFUNC = 'C'
C
C*    Function 'K' is the same as 'C', but for grid-point fields,
C     an "aggressive packing" is performed: all user-allowed strategies
C     for second-order packing are attempted, in order to make the
C     shortest GRIB message.
C
      IF( HOPER.EQ.'K') YFUNC = 'C'
C
C*    Function 'I' is for decoding of sections 0, 1 and 2
C     of GRIB code only. Value of HOPER is checked at the start of
C     decoding section 3.
C*    Function 'J' is for decoding of sections 0, 1, 2, 3 and 4.
C
      IF( L_IORJ) YFUNC = 'D'
C
C*    Function 'R' is the same as 'D', but if a quasi-regular
C     Gaussian is encountered, it is converted to a regular one.
C     Value of HOPER is checked near end of section 8.
C
      IF( HOPER.EQ.'R') YFUNC = 'D'
C
C*    Function 'S' is the same as 'D', but if analysis data in
C     GRIB Experimental Edition is encountered, the time range
C     indicator flag is set to indicate initialised analysis.
C     Value of HOPER is checked  when time range indicator has
C     been extracted.
C
      IF( HOPER.EQ.'S') YFUNC = 'D'
C
C*    Function 'X' is the same as 'D', but only the data
C     at the requested points is unpacked.
C     Value of HOPER is checked prior to unpacking data values.
C
      IF( HOPER.EQ.'X') YFUNC = 'D'
C
C*    Function 'G' is the same as 'D', but only the reference
C     value and scale factor are unpacked. A pointer to packed data
C     is returned.
C     Value of HOPER is checked prior to unpacking data values.
C
      IF( HOPER.EQ.'G') YFUNC = 'D'
C
C*    Function 'Z' is for decoding only the information which could
C     be handled by the the old decoding routine DECOGB (eg no bit
C     maps) and is used by the new DECOGB interface.
C
      IF( HOPER.EQ.'Z') YFUNC = 'D'
C
      LENCODE = ( YFUNC.EQ.'C' )
      LDECODE = ( YFUNC.EQ.'D' )
Cd
Cd    Set up the definition 13 flag variable
Cd
      IF( LDECODE ) N13FLAG = D13FLAG(KGRIB)
C
C*    Preset some arrays to 0.
C
      IF( LENCODE ) THEN
Ce
Ce      Check number of bits per data field fits size of computer word.
Ce
        IF( IBITS.LT.KSEC4(2)) THEN
          KRET = 202
          WRITE(GRPRSM,*)
     X  'GRIBEX: Number of bits per data value = ',KSEC4(2)
          WRITE(GRPRSM,*)
     X  'GRIBEX: This exceeds word length which = ',IBITS
          WRITE(GRPRSM,*) 'GRIBEX: Return code = ', KRET
          GO TO 900
        ENDIF
Ce
Ce      Check number of bits is not zero or negative
Ce
        IF( KSEC4(2) .LT. 0 ) THEN
          KRET = 204
          WRITE(GRPRSM,*)
     X  'GRIBEX: Number of bits per data value = ',KSEC4(2)
          WRITE(GRPRSM,*) 'GRIBEX: This must be positive.'
          WRITE(GRPRSM,*) 'GRIBEX: Return code = ', KRET
          GOTO 900
        ELSEIF( KSEC4(2) .EQ. 0 ) THEN
          WRITE(GRPRSM,*)
     X  'GRIBEX: Number of bits per data value = ',KSEC4(2)
          KSEC4(2) = 8
          WRITE(GRPRSM,*)
     X  'GRIBEX: This must be positive - enforced to ',
     X               KSEC4(2)
        ENDIF
Ce
Ce      Check if number of bits per packed value = number of bits per
Ce      computer word.
Ce
        LALLPOS = KSEC4(2) .EQ. IBITS
Ce
Ce      If entire field is missing, check that all data values are zero.
Ce
        IF( KSEC4(1).LT.0) THEN
          IMISS = 1
          ILENF = - KSEC4(1)
          DO 210 JLOOP = 1 , ILENF
            IF( PSEC4(JLOOP).NE.0.0) THEN
              KRET = 203
              WRITE(GRPRSM,*)
     X  'GRIBEX: Non-zero value in missing data field.'
              WRITE(GRPRSM,*) 'GRIBEX: Return code = ', KRET
              GO TO 900
            ENDIF
  210     CONTINUE
        ELSE
          IMISS = 0
          ILENF = KSEC4(1)
        ENDIF
Ce
Ce      If input data is integer, change it to real.
Ce
        IF( ( KSEC4(5).EQ.32 ).AND.( HOPER.NE.'A' ) )
     X    CALL RORINT(PSEC4,PSEC4,ILENF,'R')
Ce
        DO 215 JLOOP = 21,24
          KSEC4(JLOOP) = 0
  215   CONTINUE
Ce
      ELSE
Cd
Cd      Preset arrays to receive section header information to 0.
Cd      Routine GSBITE resets data array to 0.
Cd
        DO 220 JLOOP = 1,25
          KSEC1(JLOOP) = 0
  220   CONTINUE
Cd
        DO 230 JLOOP = 1,22
          KSEC2(JLOOP) = 0
  230   CONTINUE
Cd
        DO 240 JLOOP = 1,33
          KSEC4(JLOOP) = 0
  240   CONTINUE
Cd
      ENDIF
C
C     -----------------------------------------------------------------|
C
C
C
C
C
C
C
C
C
C
C*    Section 3 . Indicator Section (Section 0) of GRIB code.
C     -----------------------------------------------------------------|
C
  300 CONTINUE
C
C#ifdef GRIB2
C      IF( LENCODE.AND.(KSEC0(2).EQ.2) ) THEN
C        IF( LPDEBUG ) WRITE(GRPRSM,*) 'GRIBEX: Section 3. Handle GRIB2'
C        KRET = G2ENCOD(KSEC0,KSEC1,KSEC2,KSEC3,KSEC4,
C     X                 PSEC2,PSEC3,PSEC4,PSEC3(2))
C        RETURN
C      ENDIF
C#endif
C
      IF( LPDEBUG ) WRITE(GRPRSM,*)
     X  'GRIBEX: Section 3. Handle GRIB Indicator Section (Section 0)'
C
C*    Octets 1 - 4 : The letters G R I B.
C     Four 8 bit fields.
C
      IF( LENCODE ) THEN
Ce
Ce      Insert the letters G R I B.
Ce
        CALL INXBIT(KGRIB,KLENG,INSPT,IGRIB(1),4,IBITS, 8,YFUNC,KRET)
        IF( KRET.NE.0) THEN
          KRET = 301
          WRITE(GRPRSM,*)
     X  'GRIBEX: Error inserting/extracting letters GRIB'
          WRITE(GRPRSM,*) 'GRIBEX: Return code = ', KRET
          GO TO 900
        ENDIF
      ELSE
Cd
Cd      When decoding data, check letters -> GRIB, BUDG or TIDE.
Cd
        CALL INXBIT(KGRIB,KLENG,INSPT,IPARM(1),4,IBITS, 8,YFUNC,KRET)
        IF( KRET.NE.0) THEN
          KRET = 301
          WRITE(GRPRSM,*)
     X  'GRIBEX: Error inserting/extracting letters GRIB'
          WRITE(GRPRSM,*) 'GRIBEX: Return code = ', KRET
          GO TO 900
        ENDIF
Cd
Cd      Check that 'GRIB' is found where expected.
Cd
        IF( IPARM(1).EQ.71.AND.IPARM(2).EQ.82.AND.
     X      IPARM(3).EQ.73.AND.IPARM(4).EQ.66) GO TO 310
Cd
Cd      ECMWF pseudo-grib data uses 'BUDG' and 'TIDE'.
Cd
        IF( IPARM(1).EQ.66.AND.IPARM(2).EQ.85.AND.
     X      IPARM(3).EQ.68.AND.IPARM(4).EQ.71) GO TO 310
Cd
        IF( IPARM(1).EQ.84.AND.IPARM(2).EQ.73.AND.
     X      IPARM(3).EQ.68.AND.IPARM(4).EQ.69) GO TO 310
Cd
Cd      Data is not GRIB or pseudo-grib.
Cd
        KRET = 305
        WRITE(GRPRSM,*) 'GRIBEX: Input data is not GRIB or pseudo-grib.'
        WRITE(GRPRSM,*) 'GRIBEX: Return code = ', KRET
        GO TO 900
Cd
      ENDIF
C
  310 CONTINUE
C
C*    Octets 5 - 7 : Length of message.
C     One 24 bit field.
C
      IF( LENCODE ) THEN
Ce
Ce      When coding data, skip field. Length is inserted
Ce      later, when known.
Ce      Update bit-pointer.
Ce
        INSPT = INSPT + 24
      ELSE
Cd
Cd      Extract field.
Cd
        CALL INXBIT(KGRIB,KLENG,INSPT,ITEMP,1,IBITS, 24,YFUNC,KRET)
        IF( KRET.NE.0) THEN
          KRET = 302
          WRITE(GRPRSM,*)
     X  'GRIBEX: Error extracting length of GRIB message.'
          WRITE(GRPRSM,*) 'GRIBEX: Return code = ', KRET
          GO TO 900
        ENDIF
Cd
Cd      When decoding, use most-significant bit as a sign bit.
Cd
        IF( LDECODE ) CALL DSGNBT( KSEC0(1), ITEMP, 24, KRET)
Cd
Cd      If count is negative, have to rescale by factor of -120.
Cd      This is a fixup to get round the restriction on product lengths
Cd      due to the count being only 24 bits. It is only possible because
Cd      the (default) rounding for GRIB products is 120 bytes.
Cd
        IF( KSEC0(1).LT.0 ) THEN
          IF( LPDEBUG ) WRITE(GRPRSM,*)
     X      'GRIBEX: Special case, negative length multiplied by -120'
          LLARGE = .TRUE.
          KSEC0(1) = KSEC0(1) * (-120)
        ENDIF
      ENDIF
C
C*    Octet 8 : GRIB Edition Number.
C     One 8 bit field.
C
      IF( LENCODE ) THEN
Ce
Ce      Set value, if coding data.
Ce
        KSEC0(2) = JPEDNO
        CALL INXBIT(KGRIB,KLENG,INSPT,KSEC0(2),1,IBITS, 8,YFUNC,KRET)
        IF( KRET.NE.0) THEN
          KRET = 303
          WRITE(GRPRSM,*)
     X      'GRIBEX: Error inserting/extracting GRIB Edition Number.'
          WRITE(GRPRSM,*) 'GRIBEX: Return code = ', KRET
          GO TO 900
        ENDIF
Ce
      ELSE
Cd
Cd      Extract field.
Cd
        CALL INXBIT(KGRIB,KLENG,INSPT,KSEC0(2),1,IBITS, 8,YFUNC,KRET)
        IF( KRET.NE.0) THEN
          KRET = 303
          WRITE(GRPRSM,*)
     X      'GRIBEX: Error inserting/extracting GRIB Edition Number.'
          WRITE(GRPRSM,*) 'GRIBEX: Return code = ', KRET
          GO TO 900
        ENDIF
Cd
Cd      When decoding or calculating length, previous editions
Cd      of the GRIB code must be taken into account.
Cd
Cd      In the table below, covering sections 0 and 1 of the GRIB
Cd      code, octet numbering is from the beginning of the GRIB
Cd      message;
Cd      * indicates that the value is not available in the code edition;
Cd      R indicates reserved, should be set to 0;
Cd      Experimental edition is considered as edition -1.
Cd
Cd      GRIB code edition -1 has fixed length of 20 octets for
Cd      section 1, the length not included in the message.
Cd      GRIB code edition 0 has fixed length of 24 octets for
Cd      section 1, the length being included in the message.
Cd      GRIB code edition 1 can have different lengths for section
Cd      1, the minimum being 28 octets, length being included in
Cd      the message.
Cd
Cd                                              Octet numbers for code
Cd                                                       editions
Cd
Cd                     Contents.                   -1      0      1
Cd                     ---------                ----------------------
Cd           Letters GRIB                          1-4    1-4    1-4
Cd           Total length of GRIB message.          *      *     5-7
Cd           GRIB code edition number               *      *      8
Cd           Length of Section 1.                   *     5-7    9-11
Cd           Reserved octet (R).                    *      8(R)   *
Cd           Version no. of Code Table 2.           *      *     12
Cd           Identification of centre.              5      9     13
Cd           Generating process.                    6     10     14
Cd           Grid definition .                      7     11     15
Cd           Flag (Code Table 1).                   8     12     16
Cd           Indicator of parameter.                9     13     17
Cd           Indicator of type of level.           10     14     18
Cd           Height, pressure etc of levels.      11-12  15-16  19-20
Cd           Year of century.                      13     17     21
Cd           Month.                                14     18     22
Cd           Day.                                  15     19     23
Cd           Hour.                                 16     20     24
Cd           Minute.                               17     21     25
Cd           Indicator of unit of time.            18     22     26
Cd           P1 - Period of time.                  19     23     27
Cd           P2 - Period of time                  20(R)   24     28
Cd           or reserved octet (R).
Cd           Time range indicator.                21(R)   25     29
Cd           or reserved octet (R).
Cd           Number included in average.       22-23(R)  26-27  30-31
Cd           or reserved octet (R).
Cd           Number missing from average.         24(R)  28(R)   32
Cd           or reserved octet (R).
Cd           Century of data.                       *      *     33
Cd           Designates sub-centre if not 0.        *      *     34
Cd           Decimal scale factor.                  *      *    35-36
Cd           Reserved. Set to 0.                    *      *    37-48
Cd           (Need not be present)
Cd           For originating centre use only.       *      *    49-nn
Cd           (Need not be present)
Cd
Cd      Identify which GRIB code edition is being decoded.
Cd
Cd      In GRIB edition 1, the edition number is in octet 8.
Cd      In GRIB edition 0, octet 8 is reserved and set to 0.
Cd      In GRIB edition -1, octet 8 is a flag field and can have a
Cd      a valid value of 0, 1, 2 or 3.
Cd
Cd      However, GRIB edition number 0 has a fixed
Cd      length of 24, included in the message, for section 1, so
Cd      if the value extracted from octets 5-7 is 24 and that from
Cd      octet 8 is 0, it is safe to assume edition 0 of the code.
Cd
        IF( KSEC0(1).EQ.24.AND.KSEC0(2).EQ.0) THEN
Cd
Cd        Set bit-pointer back by 32 bits (4 octets).
          INSPT = INSPT - 32
Cd
Cd        Set length of GRIB message to missing data value.
          KSEC0(1) = IMISNG
Cd
          GO TO 400
        ENDIF
Cd
Cd      In GRIB Edition -1, octets 22 and 23 are reserved and set
Cd      to 0. These octets in Edition 1 are the month and the day,
Cd      and must be non-zero.
Cd
        ITEMP = 168
        CALL INXBIT(KGRIB,KLENG,ITEMP,IMODAY,1,IBITS, 16,YFUNC,KRET)
        IF( KRET.NE.0) THEN
          KRET = 304
          WRITE(GRPRSM,*)
     X  'GRIBEX: Error extracting octets 22 and 23 for'
          WRITE(GRPRSM,*) 'GRIBEX: Experimental Edition check.'
          WRITE(GRPRSM,*) 'GRIBEX: Return code = ', KRET
          GO TO 900
        ENDIF
Cd
        IF( IMODAY.EQ.0) THEN
Cd
Cd        Set bit-pointer back by 32 bits (4 octets).
          INSPT = INSPT - 32
Cd
          KSEC0(2) = -1
Cd
Cd        Set length of GRIB message to missing data value.
Cd
          KSEC0(1) = IMISNG
Cd
Cd        Set length of section 1 of GRIB code to 20 octets.
Cd
          ILEN1 = 20
Cd
Cd        Skip next 4 octets, as they do not exist in
Cd        the Experimental Edition of the code. ie
Cd        length of Section and Table 2 Version Number.
Cd
          GO TO 401
        ENDIF
Cd
      ENDIF
C
C*    If Grib Edition 1 and only length is required, go to section 9.
C
      IF( YFUNC.EQ.'L') GO TO 900
C
C     -----------------------------------------------------------------|
C
C
C
C
C
C
C
C
C
C
C*    Section 4 . Product Definition Section (Section 1) of GRIB code.
C    -----------------------------------------------------------------
C
  400 CONTINUE
C
      IF( LPDEBUG ) WRITE(GRPRSM,*)
     X  'GRIBEX: Section 4. Handle Product Definition (Section 1)'
C
C*    Check consistency of values given, with GRIB code, if required.
C
      IF( NVCK.EQ.1.AND. LENCODE ) THEN
        CALL GRCHK1(KSEC1,KRET)
        IF( KRET.NE.0) THEN
          KRET = 499
          WRITE(GRPRSM,*)
     X  'GRIBEX: Error found when checking values for'
          WRITE(GRPRSM,*) 'GRIBEX: Section 1 against valid GRIB values.'
          WRITE(GRPRSM,*) 'GRIBEX: Return code = ', KRET
          GO TO 900
        ENDIF
      ENDIF
C
C*    Octets 1 - 3 : Length of Section.
C     One 24 bit field.
C
      IF( LENCODE ) THEN
Ce
Ce      Set value, if coding data.
        ILEN1 = JPLEN1
Ce
Ce      Extra octets if ECMWF local definition usage in section 1.
Ce
        LECMWF = (KSEC1(2) .EQ.98)
        LECLOC = (KSEC1(2) .EQ.98) .OR.
     X           (KSEC1(22).EQ.98)
        LSST11 = (KSEC1( 6).EQ.139) .AND.
     X           (KSEC1( 7).EQ.  1) .AND.
     X           (KSEC1(22).EQ. 98)
        LKWBCE = (KSEC1( 2).EQ.  7) .AND.
     X           (KSEC1(22).NE. 98)
Ce
        IF( LPDEBUG ) WRITE(GRPRSM,*)
     X  'GRIBEX: Local extension in use for...'
        IF( LPDEBUG.AND.LECLOC ) WRITE(GRPRSM,*)
     X  'GRIBEX: ECMWF data'
        IF( LPDEBUG.AND.LKWBCE ) WRITE(GRPRSM,*)
     X  'GRIBEX: KWBC ensemble data'
        IF( LPDEBUG.AND.LSST11 ) WRITE(GRPRSM,*) 'GRIBEX: SST data'
Ce
      ENDIF
C
C     Insert / extract field.
C
      CALL INXBIT(KGRIB,KLENG,INSPT,ILEN1,1,IBITS, 24,YFUNC,KRET)
      IF( KRET.NE.0) THEN
        KRET = 401
        WRITE(GRPRSM,*)
     X    'GRIBEX: Error inserting/extracting length of Section 1.'
        WRITE(GRPRSM,*) 'GRIBEX: Return code = ', KRET
        GO TO 900
      ENDIF
C
C*    Octet 4  : Version Number of Table 2.
C     One 8 bit field.
C
C     Insert / extract field.
C
      CALL INXBIT(KGRIB,KLENG,INSPT,KSEC1(1),1,IBITS, 8,YFUNC,KRET)
      IF( KRET.NE.0) THEN
        KRET = 402
        WRITE(GRPRSM,*)
     X    'GRIBEX: Error inserting/extracting Param Table Version No.'
        WRITE(GRPRSM,*) 'GRIBEX: Return code = ', KRET
        GO TO 900
      ENDIF
C
  401 CONTINUE
C
C*    Check Edition number.
C
      IF( LPDEBUG ) WRITE(GRPRSM,*)
     X  'GRIBEX: GRIB Edition Number = ',KSEC0(2)
      IF( KSEC0(2).GT.1) THEN
        KRET = 413
        WRITE(GRPRSM,*) 'GRIBEX: Grib Edition not catered for.'
        WRITE(GRPRSM,*) 'GRIBEX: Return code = ', KRET
        GO TO 900
      ENDIF
C
C*    Print length of Section 1, if required.
C
      IF( LPDEBUG ) WRITE(GRPRSM,*)
     X  'GRIBEX: Length of Section 1 of GRIB = ',ILEN1,' octets.'
C
C*    Octet 5  : Identification of centre.
C     Octet 6  : Generating process identification.
C     Octet 7  : Grid definition.
C     Octet 8  : Flag.
C     Octet 9  : Indicator of parameter.
C     Octet 10 : Indicator of type of level.
C                (or satellite identifier)
C                Satellite useage as defined by INPE/CPTEC
C                and used by ECMWF, pending final definition
C                by WMO.
C     Six 8 bit fields.
C
C     Insert / extract fields.
C
      CALL INXBIT(KGRIB,KLENG,INSPT,KSEC1(2),6,IBITS, 8,YFUNC,KRET)
      IF( KRET.NE.0) THEN
        KRET = 403
        WRITE(GRPRSM,*)
     X  'GRIBEX: Error inserting/extracting six fields from'
        WRITE(GRPRSM,*)
     X  'GRIBEX: Identification of Centre to Indicator of'
        WRITE(GRPRSM,*) 'GRIBEX: type of level.'
        WRITE(GRPRSM,*) 'GRIBEX: Return code = ', KRET
        GO TO 900
      ENDIF
C
C     If decoding, fix-up for Experimental Edition and Edition 0
C     of GRIB code.
C
      IF( .NOT. LENCODE ) THEN
Cd
Cd      Set logical flag for ECMWF data
Cd
        LECMWF = (KSEC1(2).EQ.98)
Cd
Cd      In GRIB Experimental Edition and Edition 0
Cd      the International Table Version Number in use was 0.
Cd      ECMWF has always used its own local table. It is the same
Cd      for Experimental Edition, Edition 0 and Edition 1 and is
Cd      local table number 128.
Cd
        IF( KSEC0(2).LT.1) THEN
          IF( LECMWF ) THEN
Cd
Cd          ECMWF data. Local table number.
            KSEC1(1) = 128
          ELSE
Cd
Cd          International table number.
Cd          KSEC1(1) = 0 is already preset.
          ENDIF
        ENDIF
Cd
Cd      Fix-up for flag field, which was different in Experimental
Cd      Edition.
Cd
Cd                        Experimental          Editions 0 and 1
Cd                        Edition
Cd
Cd           Sections     Binary    Decimal     Binary    Decimal
Cd           included     value     value       value     value
Cd
Cd             none       00000000    0         00000000     0
Cd              2         00000001    1         10000000   128
Cd              3         00000010    2         01000000    64
Cd           2 and 3      00000011    3         11000000   192
Cd
        IF( KSEC0(2).EQ.-1) THEN
          IF( KSEC1(5).EQ.1) KSEC1(5) = 128
          IF( KSEC1(5).EQ.2) KSEC1(5) = 64
          IF( KSEC1(5).EQ.3) KSEC1(5) = 192
        ENDIF
      ENDIF
      LSECT2 = KSEC1(5).GE.128
      LSECT3 = MOD(KSEC1(5),128).GE.64
C
C*    Once the flag field has been extracted, no further fields
C     from section 1 of the GRIB code are required, when length
C     of GRIB or pseudo-Grib message only is required.
C
      IF( YFUNC.EQ.'L') THEN
C
C       Length of section 0 + section 1 is 28 octets (224 bits)
C       for GRIB Edition 0 and 24 octets (192 bits) for
C       Experimental edition.
C       Set bit-pointer and jump to extraction of length of section 3.
C
        INSPT = 224
        IF( KSEC0(2).EQ.-1) INSPT = 192
        GO TO 500
      ENDIF
C
C*    Octets 11 - 12 : Height, pressure etc of levels or
C                      satellite spectral band.
C                      Satellite useage as defined by INPE/CPTEC
C                      and used by ECMWF, pending final definition
C                      by WMO.
C     One 16 bit field or two 8 bit fields.
C
C     Satellite image if WMO table and parameter 127
C
      LSATIMG = ((KSEC1(1).LT.128).AND.(KSEC1(6).EQ.127))
C
C     For certain level types, no description is necessary, so when
C     decoding the fields are set to 0 regardless of bit string content.
C
      IF( (.NOT.LENCODE).AND.
     X    (.NOT.LSATIMG).AND.
     X    ( ((KSEC1(7).LT.100).AND.(KSEC1(7).NE.20)).OR.
     X      (KSEC1(7).EQ.102) .OR.
     X      (KSEC1(7).EQ.200) .OR.
     X      (KSEC1(7).EQ.201) ) ) THEN
Cd
Cd      Update bit-pointer and skip extraction.
        KSEC1(8) = 0
        KSEC1(9) = 0
        INSPT = INSPT + 16
        GO TO 402
      ENDIF
C
C     Certain level types require that the description occupies
C     both octets.
C     Satellite Spectral band occupies both octets.
C     Satellite useage as defined by INPE/CPTEC
C     and used by ECMWF, pending final definition by WMO.
C     Image data uses 2 octets.
C
      IF( (KSEC1(7).NE. 20).AND.
     X    (KSEC1(7).NE.100).AND.
     X    (KSEC1(7).NE.103).AND.
     X    (KSEC1(7).NE.105).AND.
     X    (KSEC1(7).NE.107).AND.
     X    (KSEC1(7).NE.109).AND.
     X    (KSEC1(7).NE.111).AND.
     X    (KSEC1(7).NE.113).AND.
     X    (KSEC1(7).NE.115).AND.
     X    (KSEC1(7).NE.117).AND.
     X    (KSEC1(7).NE.125).AND.
     X    (KSEC1(7).NE.127).AND.
     X    (KSEC1(7).NE.160).AND.
     X    (KSEC1(7).NE.210).AND.
     X    (.NOT.LSATIMG) ) THEN
C
C       Two 8 bit fields.
        INUM  = 2
        IBLEN = 8
      ELSE
C
C       One 16 bit field.
        INUM     = 1
        IBLEN    = 16
        KSEC1(9) = 0
      ENDIF
C
C     Insert / extract fields.
C
      CALL INXBIT(KGRIB,KLENG,INSPT,KSEC1(8),INUM,IBITS,
     X             IBLEN,YFUNC,KRET)
      IF( KRET.NE.0) THEN
        KRET = 404
        WRITE(GRPRSM,*) 'GRIBEX: Error inserting/extracting Height,'
        WRITE(GRPRSM,*) 'GRIBEX: pressure, etc of levels.'
        WRITE(GRPRSM,*) 'GRIBEX: Return code = ', KRET
        GO TO 900
      ENDIF
C
C*    Fix-up for ECMWF upper-air data incorrectly coded in Experimental
C     Edition.
C
      IF( KSEC0(2).EQ.-1.AND. LECMWF ) THEN
        ITEMP = INSPT - 16
        INUM  = 2
        IBLEN = 8
        CALL INXBIT(KGRIB,KLENG,ITEMP,KSEC1(8),INUM,IBITS,
     X               IBLEN,YFUNC,KRET)
        IF( KRET.NE.0) THEN
          KRET = 404
          WRITE(GRPRSM,*) 'GRIBEX: Error inserting/extracting Height,'
          WRITE(GRPRSM,*) 'GRIBEX: pressure, etc of levels.'
          WRITE(GRPRSM,*) 'GRIBEX: Return code = ', KRET
          GO TO 900
        ENDIF
        KSEC1(8) = KSEC1(8) * 32 + KSEC1(9)
        KSEC1(9) = 0
      ENDIF
C
  402 CONTINUE
C
C*    Octet 13 : Year of century.
C     Octet 14 : Month.
C     Octet 15 : Day.
C     Octet 16 : Hour.
C     Octet 17 : Minute.
C     Octet 18 : Indicator of unit of time range..
C     Six 8 bit fields.
C
C     Insert / extract fields.
C
      CALL INXBIT(KGRIB,KLENG,INSPT,KSEC1(10),6,IBITS, 8,YFUNC,KRET)
      IF( KRET.NE.0) THEN
        KRET = 405
        WRITE(GRPRSM,*)
     X  'GRIBEX: Error inserting/extracting six fields from'
        WRITE(GRPRSM,*)
     X  'GRIBEX: Year of century to Indicator of unit of'
        WRITE(GRPRSM,*) 'GRIBEX: time range.'
        WRITE(GRPRSM,*) 'GRIBEX: Return code = ', KRET
        GO TO 900
      ENDIF
C
C*    Fix-up for unit of time, which was different in Experimental
C     Edition.
C
C
C                  Experimental          Editions 0 and 1
C                  Edition
C
C     Meaning      Decimal               Decimal
C                  value                 value
C
C     Minute       0 or 30                 0
C     Hour         1 or 40                 1
C     Day          2 or 50                 2
C     Month        3 or 60                 3
C     Year         4 or 70                 4
C     Decade       5 or 80                 5
C     Normal         6                     6
C     Century      7 or 90                 7
C     Second         -                   254
C
      IF( KSEC0(2).EQ.-1) THEN
        IF( KSEC1(15).EQ.90) KSEC1(15) = 7
        IF( KSEC1(15).GT.10) KSEC1(15) = (KSEC1(15) / 10) - 3
      ENDIF
C
C*    Octets 19 - 20 : Period of time.
C     One 16 bit field or two 8 bit fields.
C
      IF( LENCODE .AND.KSEC1(18).EQ.10) THEN
Ce
Ce      One 16 bit field.
        INUM  = 1
        IBLEN = 16
      ELSE
Ce
Ce      Two 8 bit fields.
        INUM  = 2
        IBLEN = 8
      ENDIF
C
C     Insert / extract fields.
C
      CALL INXBIT(KGRIB,KLENG,INSPT,KSEC1(16),INUM,IBITS,
     X            IBLEN,YFUNC,KRET)
      IF( KRET.NE.0) THEN
        KRET = 406
        WRITE(GRPRSM,*)
     X  'GRIBEX: Error inserting/extracting Period of time.'
        WRITE(GRPRSM,*) 'GRIBEX: Return code = ', KRET
        GO TO 900
      ENDIF
C
C*    Octet 21 : Time range indicator.
C     One 8 bit field.
C
C     Insert / extract field.
C
      CALL INXBIT(KGRIB,KLENG,INSPT,KSEC1(18),1,IBITS, 8,YFUNC,KRET)
      IF( KRET.NE.0) THEN
        KRET = 407
        WRITE(GRPRSM,*)
     X    'GRIBEX: Error inserting/extracting time range indicator.'
        WRITE(GRPRSM,*) 'GRIBEX: Return code = ', KRET
        GO TO 900
      ENDIF
C
C*    When decoding, period of time field and time range
C     indicator may need modification.
C
      IF( .NOT. LENCODE ) THEN
Cd
Cd      When decoding, length of period of time field is known
Cd      only at this time. If a 16 bit field is indicated, put
Cd      the two extracted 8-bit fields together.
Cd
        IF( KSEC1(18).EQ.10) THEN
Cd
Cd        One 16 bit field.
          KSEC1(16) = KSEC1(16) * 256 + KSEC1(17)
          KSEC1(17) = 0
        ENDIF
Cd
Cd      If data is known to be initialised analysis and GRIB is
Cd      Experimental Edition, set time range indicator flag.
Cd
        IF( KSEC1(16).EQ.0.AND.HOPER.EQ.'S'.AND.KSEC0(2).EQ.-1)
     X    KSEC1(18) = 1
Cd
      ENDIF
C
C*    Octet 22 - 23 : Number averaged.
C     One 16 bit field.
C
C     Insert / extract field.
C
      CALL INXBIT(KGRIB,KLENG,INSPT,KSEC1(19),1,IBITS, 16,YFUNC,KRET)
      IF( KRET.NE.0) THEN
        KRET = 408
        WRITE(GRPRSM,*)
     X  'GRIBEX: Error inserting/extracting number averaged.'
        WRITE(GRPRSM,*) 'GRIBEX: Return code = ', KRET
        GO TO 900
      ENDIF
C
C*    Octet 24 : Number missing from averages etc.
C     One 8 bit field.
C
      CALL INXBIT(KGRIB,KLENG,INSPT,KSEC1(20),1,IBITS, 8,YFUNC,KRET)
      IF( KRET.NE.0) THEN
        KRET = 409
        WRITE(GRPRSM,*)
     X  'GRIBEX: Error inserting/extracting number missing'
        WRITE(GRPRSM,*) 'GRIBEX: from averages etc.'
        WRITE(GRPRSM,*) 'GRIBEX: Return code = ', KRET
        GO TO 900
      ENDIF
C
C*    This is the end of Section 1 if Edition 0 or -1 of GRIB code.
C     Set other fields to be compatible with Edition 1, where possible.
C
      IF( KSEC0(2).LT.1) THEN
C
C       Century of data.
C
C       All ECMWF data in Edition 0 or -1 is 20th century.
C       Otherwise set century to missing data value.
C
        IF( LECMWF ) THEN
          KSEC1(21) = 20
        ELSE
          KSEC1(21) = IMISNG
        ENDIF
C
C       Reserved field and decimal scale factor field (which
C       was always 0).
C
C       KSEC1(22) and KSEC1(23) set to 0.
C
        KSEC1(22) = 0
        KSEC1(23) = 0
        GO TO 499
      ENDIF
C
C*    Octet 25 : Century of data.
C     One 8 bit field.
C
C     Insert / extract field.
C
      CALL INXBIT(KGRIB,KLENG,INSPT,KSEC1(21),1,IBITS, 8,YFUNC,KRET)
      IF( KRET.NE.0) THEN
        KRET = 410
        WRITE(GRPRSM,*)
     X  'GRIBEX: Error inserting/extracting century of data'
        WRITE(GRPRSM,*) 'GRIBEX: or reserved field.'
        WRITE(GRPRSM,*) 'GRIBEX: Return code = ', KRET
        GO TO 900
      ENDIF
C
C*    Octet 26 : Sub-centre.
C     ( Now used at ECMWF/Washington to designate a sub-centre
C       =   2 for NMC ensemble products(decoding only).
C       =  98 for EPS products from Washington with ECMWF extensions.
C       = 231 Meteo France Climate Centre (ECSN)
C       = 232 MPI Climate Centre (ECSN)
C       = 233 UKMO Climate Centre (ECSN)
C       = 240 for ECMWF seasonal forecast centre (PROVOST).
C       = 241 for Meteo France seasonal forecast centre (PROVOST).
C       = 242 for EDF seasonal forecast centre (PROVOST).
C       = 243 for UKMO seasonal forecast centre (PROVOST).
C       = 0   otherwise. )
C
C     One 8 bit field.
C
      IF( LENCODE ) THEN
Ce
Ce      When coding ECMWF data, sub-centre is set to 0 unless a
Ce      designated sub-centre or explicitly enabled by previous user
Ce      call to GRSUBC.
Ce
        IF( .NOT.LECMWF .OR. NSUBCE.EQ.1 ) THEN
          ITEMP = KSEC1(22)
Ce
        ELSE IF( (KSEC1(22).EQ. 98) .OR.
     X           (KSEC1(22).EQ.231) .OR.
     X           (KSEC1(22).EQ.232) .OR.
     X           (KSEC1(22).EQ.233) .OR.
     X           (KSEC1(22).EQ.240) .OR.
     X           (KSEC1(22).EQ.241) .OR.
     X           (KSEC1(22).EQ.242) .OR.
     X           (KSEC1(22).EQ.243) )THEN
          ITEMP = KSEC1(22)
Ce
        ELSE
          ITEMP = 0
        ENDIF
      ENDIF
C
      CALL INXBIT(KGRIB,KLENG,INSPT, ITEMP, 1,IBITS, 8,YFUNC,KRET)
      IF( KRET.NE.0) THEN
        KRET = 810
        WRITE(GRPRSM,*) 'GRIBEX: Error inserting dummy zero.'
        WRITE(GRPRSM,*) 'GRIBEX: Return code = ', KRET
        GO TO 900
      ENDIF
C
Cd
      IF( LDECODE ) THEN
Cd
Cd      When decoding, KSEC1(22) is set to message content.
Cd
        KSEC1(22) = ITEMP
Cd
Cd      Set flags for known special local extensions to section 1:
Cd        ECMWF data
Cd        Washington SST data
Cd        Washington ensemble data
Cd
        LECLOC = (KSEC1(2).EQ.98) .OR.
     X           (KSEC1(22).EQ.98)
        LSST11 = (KSEC1( 6).EQ.139) .AND.
     X           (KSEC1( 7).EQ.  1) .AND.
     X           (KSEC1(22).EQ. 98)
        LKWBCE = (KSEC1( 2).EQ.  7) .AND.
     X           (KSEC1(22).NE. 98)
Cd
        IF( LPDEBUG ) WRITE(GRPRSM,*)
     X  'GRIBEX: Local extension in use for...'
        IF( LPDEBUG.AND.LECLOC ) WRITE(GRPRSM,*) 'GRIBEX: ECMWF data'
        IF( LPDEBUG.AND.LKWBCE ) WRITE(GRPRSM,*)
     X  'GRIBEX: KWBC ensemble data'
        IF( LPDEBUG.AND.LSST11 ) WRITE(GRPRSM,*) 'GRIBEX: SST data'
Cd
      ENDIF
C
C*    Octets 27 - 28 : Units decimal scale factor.
C     One 16 bit field.
C
C     When coding, set sign bit if value is negative.
C
      IF( LENCODE ) CALL CSGNBT( ITEMP, KSEC1(23), 16, KRET)
C
C     Insert / extract field.
C
      CALL INXBIT(KGRIB,KLENG,INSPT,ITEMP,1,IBITS, 16,YFUNC,KRET)
      IF( KRET.NE.0) THEN
        KRET = 411
        WRITE(GRPRSM,*)
     X  'GRIBEX: Error inserting/extracting units decimal'
        WRITE(GRPRSM,*) 'GRIBEX: scale factor.'
        WRITE(GRPRSM,*) 'GRIBEX: Return code = ', KRET
        GO TO 900
      ENDIF
C
C     When decoding, set sign bit if value is negative.
C
      IF( LDECODE ) CALL DSGNBT( KSEC1(23), ITEMP, 16, KRET)
C
      IF( LENCODE ) THEN
Ce
Ce      When coding data, the reserved octets 29-40 need not
Ce      be present and are not included, unless ECMWF local
Ce      use of octets 41 onwards is indicated.
Ce
        IF( KSEC1(24).EQ.1.AND.((LECLOC.OR.LSST11).OR.LKWBCE)) THEN
Ce
Ce        Fill reserved octets with 0.
Ce
          DO 410 JLOOP = 29,40
            CALL INXBIT(KGRIB,KLENG,INSPT, 0, 1,IBITS, 8,YFUNC,KRET)
            IF( KRET.NE.0) THEN
              KRET = 810
              WRITE(GRPRSM,*) 'GRIBEX: Error inserting dummy zero.'
              WRITE(GRPRSM,*) 'GRIBEX: Return code = ', KRET
              GO TO 900
            ENDIF
  410     CONTINUE
Ce
Ce        Have to set sectionLength for KWBC ensemble products to
Ce        force proper encoding
Ce
          IF( LKWBCE ) THEN
            IF( KSEC1(42).NE.0) THEN
              IF( KSEC1(46).NE.0) THEN
#ifdef linux
                ISECLEN = (256 + 86)*256*256
              ELSE
                ISECLEN = (256 + 60)*256*256
              ENDIF
#else
                ISECLEN = 86*256 + 1
              ELSE
                ISECLEN = 60*256 + 1
              ENDIF
#endif
            ENDIF
            KGRIB(3) = ISECLEN
          ENDIF
Ce
Ce        Insert local ECMWF data.
          KRET = NOABORT
          CALL ECLOC1(YFUNC,KSEC1,KGRIB,INSPT,IBITS,KRET)
          IF( KRET.NE.0) THEN
            KRET = 412
            WRITE(GRPRSM,*)
     X  'GRIBEX: Error inserting/extracting ECMWF local'
            WRITE(GRPRSM,*) 'GRIBEX: data.'
            WRITE(GRPRSM,*) 'GRIBEX: Return code = ', KRET
            GO TO 900
          ENDIF
Ce
        ENDIF
Ce
      ELSE
Cd
Cd      When decoding data the reserved octets are skipped.
Cd      If local use is not ECMWF usage or Washington ensemble usage,
Cd      the local use octets are also skipped.
Cd      Presence is indicated by length of section > 28 octets.
Cd
        IF( ILEN1.GT.28.AND. (LECLOC.OR.LKWBCE.OR.LSST11) ) THEN
Cd
Cd        Set decoded values as zero and move pointer past
Cd        reserved octets.
Cd
          DO 420 JLOOP = 25,36
            KSEC1(JLOOP) = 0
  420     CONTINUE
          INSPT = INSPT + 96
Cd
Cd        Set flag to indicate local use.
          KSEC1(24) = 1
Cd
Cd        Extract local ECMWF data.
Cd        .. or Washington ensemble data.
Cd
          KRET = NOABORT
          IF( (LECLOC.OR.LSST11).OR.LKWBCE )
     X      CALL ECLOC1(YFUNC,KSEC1,KGRIB,INSPT,IBITS,KRET)
          IF( KRET.NE.0) THEN
            KRET = 412
            WRITE(GRPRSM,*)
     X  'GRIBEX: Error inserting/extracting ECMWF or'
            WRITE(GRPRSM,*) 'GRIBEX: Washington local data.'
            WRITE(GRPRSM,*) 'GRIBEX: Return code = ', KRET
            GO TO 900
          ENDIF
Cd
        ELSE
          IF( ILEN1.GT.28) INSPT = INSPT + (ILEN1-28) * 8
        ENDIF
Cd
      ENDIF
C
  499 CONTINUE
C
C*    Check for ECMWF pseudo-grib data. This saves calling GRIBEX
C     with function 'I' to check if the data is GRIB data, and another
C     call with function 'D' when GRIB data is found.
C
      IF( (.NOT.LENCODE).AND.(KSEC1(6).EQ.127.OR.KSEC1(6).EQ.128)) THEN
        IF( KSEC1(1).EQ.128.AND. LECMWF ) THEN
Cd
          IPSEUD = -6
Cd
Cd        Change function to 'L' so that section 0 is fully decoded.
          YFUNC = 'L'
          GO TO 500
        ENDIF
      ENDIF
C
C     -----------------------------------------------------------------|
C
C
C
C
C
C
C
C
C
C
C*    Section 5 . Grid Description Section (Section 2) of GRIB code.
C     -----------------------------------------------------------------|
C
  500 CONTINUE
C
      IF( LPDEBUG ) WRITE(GRPRSM,*)
     X  'GRIBEX: Section 5. Handle Grid Description Section (Section 2)'
C
      IF( .NOT.LSECT2 ) THEN
C
        IF( LDECODE ) THEN
Cd
Cd      If decoding data, set section 2 values to missing data indicator
Cd
          DO 505 JLOOP=1,22
            KSEC2(JLOOP) = IMISNG
  505     CONTINUE
        ENDIF
Cd
Cd    Go to section 6, if no grid description included.
Cd
        GO TO 600
      ENDIF
C
C*    Check consistency of values given, with GRIB code, if required.
C
      IF( NVCK.EQ.1.AND. LENCODE ) THEN
        CALL GRCHK2 (KSEC1,KSEC2,PSEC2,KRET)
        IF( KRET.NE.0) THEN
          KRET = 599
          WRITE(GRPRSM,*)
     X  'GRIBEX: Error found when checking values for'
          WRITE(GRPRSM,*)
     X  'GRIBEX: Section 2 against valid GRIB values.'
          WRITE(GRPRSM,*) 'GRIBEX: Return code = ', KRET
          GO TO 900
        ENDIF
      ENDIF
C
C*    Octets 1 - 3 : Length of section.
C     One 24 bit field.
C
C     Calculate length of section, if coding data.
C
      IF( LENCODE ) THEN
Ce
Ce      Length is normally 32 + stretched and/or rotated
Ce      parameters + vertical coordinate parameters + list of
Ce      numbers of points.
Ce      (Lambert conformal and Mercator are 42 octets in length,
Ce      while Space view is 40 for ECMWF (44 in GRIB specification)
Ce
Ce      Ordinary Grid.
Ce
        INC = 0
Ce
Ce      Space view perspective.
Ce
        IF( KSEC2(1).EQ.90) INC = 12
Ce
Ce      Lambert or Mercator +10.
Ce
        IF( KSEC2(1).EQ.3.OR.KSEC2(1).EQ.1) INC = 10
Ce
Ce
Ce      Rotated grid.
Ce      (Gaussian, Latitude/longitude or Spherical Harmonics)
Ce
        IF( KSEC2(1).EQ.10.OR.KSEC2(1).EQ.14.OR.KSEC2(1).EQ.60) INC = 10
Ce
Ce      Stretched grid.
Ce      (Gaussian, Latitude/longitude or Spherical Harmonics)
Ce
        IF( KSEC2(1).EQ.20.OR.KSEC2(1).EQ.24.OR.KSEC2(1).EQ.70) INC = 10
Ce
Ce      Stretched and rotated grid.
Ce      (Gaussian, Latitude/longitude or Spherical Harmonics)
Ce
        IF( KSEC2(1).EQ.30.OR.KSEC2(1).EQ.34.OR.KSEC2(1).EQ.80) INC = 20
Ce
Ce      Calculate data offset allowing for quasi-regular grid
Ce      (Polar sterographic cannot be a quasi-regular grid)
Ce
        LQUASI = ( KSEC2(17).EQ.1 ) .AND. (KSEC2(1).NE.5)
        IF( LQUASI ) THEN
          ILEN2 = 32 + INC + (KSEC2(12)*4) + 2*KSEC2(3)
        ELSE
          ILEN2 = 32 + INC + (KSEC2(12)*4)
        ENDIF
Ce
      ENDIF
C
C     Insert / extract field.
      CALL INXBIT(KGRIB,KLENG,INSPT,ILEN2,1,IBITS, 24,YFUNC,KRET)
      IF( KRET.NE.0) THEN
        KRET = 501
        WRITE(GRPRSM,*) 'GRIBEX: Error inserting/extracting'
        WRITE(GRPRSM,*) 'GRIBEX: length of Section 2.'
        WRITE(GRPRSM,*) 'GRIBEX: Return code = ', KRET
        GO TO 900
      ENDIF
C
C*    Print length of Section 2, if required.
C
      IF( LPDEBUG ) WRITE(GRPRSM,*)
     X  'GRIBEX: Length of Section 2 of GRIB = ',ILEN2,' octets.'
C
C*    If only length is required, update bit-pointer and jump
C     to extraction of length of section 3.
C
      IF( YFUNC.EQ.'L') THEN
        INSPT = INSPT -24 + ILEN2 * 8
        GO TO 600
      ENDIF
C
C*    Octet 4 : NV - number of vertical coordinate parameters.
C     One 8 bit field.
C
C     Insert / extract field.
C
      CALL INXBIT(KGRIB,KLENG,INSPT,KSEC2(12),1,IBITS, 8,YFUNC,KRET)
      IF( KRET.NE.0) THEN
        KRET = 502
        WRITE(GRPRSM,*) 'GRIBEX: Error inserting/extracting'
        WRITE(GRPRSM,*)
     X  'GRIBEX: number of Vertical coordinate parameters.'
        WRITE(GRPRSM,*) 'GRIBEX: Return code = ', KRET
        GO TO 900
      ENDIF
C
C*    Fixup for Editions -1 and 0 of GRIB code, where number
C     of Vertical Coordinate Parameters must be calculated,
C     as this octet contained the number of unused bits at the
C     end of the section, which by definition of the section
C     always had to be 0.
C
      IF( KSEC0(2).LT.1) THEN
        KSEC2(12) = ( ILEN2 - 32 ) / 4
      ENDIF
C
C*    Octet 5 : PV - location of list of vertical coordinate parameters,
C                    if any,
C               or
C               PL - location of list of numbers of points, if no PV,
C               or
C               255 - no PV or PL.
C     One 8 bit field.
C
      IF( LENCODE ) THEN
Ce
Ce      Set value, if coding data.
Ce
Ce      Neither present is default.
        IPVPL = 255
Ce
Ce      Vertical coordinate parameters present.
        IF( KSEC2(12).NE.0) IPVPL = 32 + INC + 1
Ce
Ce      List of number of points present, if no vertical
Ce      coordinate parameters present and if quasi-regular grid.
Ce
        IF( LQUASI.AND.KSEC2(12).EQ.0) IPVPL = 32 + INC + 1
Ce
Ce      Insert field.
Ce
        CALL INXBIT(KGRIB,KLENG,INSPT,IPVPL,1,IBITS, 8,YFUNC,KRET)
        IF( KRET.NE.0) THEN
          KRET = 503
          WRITE(GRPRSM,*) 'GRIBEX: Error inserting/extracting'
          WRITE(GRPRSM,*)
     X  'GRIBEX: location of List of vertical coordinate'
          WRITE(GRPRSM,*)
     X  'GRIBEX: parameters or List of numbers of points.'
          WRITE(GRPRSM,*) 'GRIBEX: Return code = ', KRET
          GO TO 900
        ENDIF
Ce
      ELSE
Cd
Cd      If decoding data.  Extract field.
Cd
        CALL INXBIT(KGRIB,KLENG,INSPT,IPVPL,1,IBITS, 8,YFUNC,KRET)
        IF( KRET.NE.0) THEN
          KRET = 503
          WRITE(GRPRSM,*) 'GRIBEX: Error inserting/extracting'
          WRITE(GRPRSM,*)
     X  'GRIBEX: location of List of vertical coordinate'
          WRITE(GRPRSM,*)
     X  'GRIBEX: parameters or List of numbers of points.'
          WRITE(GRPRSM,*) 'GRIBEX: Return code = ', KRET
          GO TO 900
        ENDIF
Cd
Cd      Experimental space view perspective data  received
Cd      at ECMWF has all 0 bits.
Cd      0 is illegal for all data types, so change it.
Cd
        IF( IPVPL.EQ.0) IPVPL = 255
Cd
Cd      Neither present, so set regular grid indicator.
Cd
        IF( IPVPL.EQ.255) THEN
          KSEC2(17) = 0
          LQUASI = .FALSE.
        ENDIF
Cd
Cd      Vertical coordinate parameters present.
Cd      If the length of section is greater than the
Cd      end of the vertical coordinate parameters, then
Cd      there is a list of numbers of points following, so
Cd      set quasi-regular grid indicator.
Cd
        IF( KSEC2(12).NE.0) THEN
          IPL = 4 * KSEC2(12) + IPVPL - 1
          IF( IPL.LT.ILEN2) THEN
            KSEC2(17) = 1
            LQUASI = .TRUE.
          ENDIF
        ENDIF
Cd
Cd
Cd      List of number of points present, no vertical
Cd      coordinate parameters present, so set quasi-regular
Cd      grid indicator.
Cd
        IF( KSEC2(12).EQ.0.AND.IPVPL.NE.255) THEN
          KSEC2(17) = 1
          LQUASI = .TRUE.
        ENDIF
Cd
Cd      Fixup for Editions -1 and 0 of GRIB code, where
Cd      all grids were regular.
Cd
        IF( KSEC0(2).LT.1) THEN
          KSEC2(17) = 0
          LQUASI = .FALSE.
        ENDIF
Cd
      ENDIF
C
C*    Octet 6 : Data representation type.
C     One 8 bit field.
C
C     Insert / extract field.
C
      CALL INXBIT(KGRIB,KLENG,INSPT,KSEC2(1),1,IBITS, 8,YFUNC,KRET)
      IF( KRET.NE.0) THEN
        KRET = 504
        WRITE(GRPRSM,*) 'GRIBEX: Error inserting/extracting'
        WRITE(GRPRSM,*) 'GRIBEX: data representation type.'
        WRITE(GRPRSM,*) 'GRIBEX: Return code = ', KRET
        GO TO 900
      ENDIF
C
      LSPHERC = .FALSE.
      LGRDPT = .TRUE.
C
C****
C     Gaussian grid definition.
C****
C
      IF( KSEC2(1).EQ.4. .OR.
     X    KSEC2(1).EQ.14 .OR.
     X    KSEC2(1).EQ.24 .OR.
     X    KSEC2(1).EQ.34     ) THEN
C
        IF( LENCODE ) THEN
          KRET = EGGSEC2(KGRIB,KLENG,INSPT,KSEC0,KSEC2,IBITS,LQUASI)
          IF( KRET.NE.0 ) THEN
            WRITE(GRPRSM,*)
     X  'GRIBEX: Error encoding gaussian grid section 2'
            KRET = 540
            GOTO 900
          ENDIF
        ELSE
          KRET = DGGSEC2(KGRIB,KLENG,INSPT,KSEC0,KSEC2,IBITS,IMISNG)
          IF( KRET.NE.0 ) THEN
            WRITE(GRPRSM,*)
     X  'GRIBEX: Error decoding gaussian grid section 2'
            KRET = 541
            GOTO 900
          ENDIF
        ENDIF
C
        GO TO 520
      ENDIF
C
C****
C     Latitude/longitude grid definition,
C     Equidistant Cylindrical or Plate Carree.
C****
C
      IF( KSEC2(1).EQ.0  .OR.
     X    KSEC2(1).EQ.10 .OR.
     X    KSEC2(1).EQ.20 .OR.
     X    KSEC2(1).EQ.30     ) THEN
C
        IF( LENCODE ) THEN
          KRET = ELLSEC2(KGRIB,KLENG,INSPT,KSEC0,KSEC2,IBITS,LQUASI)
          IF( KRET.NE.0 ) THEN
            WRITE(GRPRSM,*)
     X  'GRIBEX: Error encoding lat/long grid section 2'
            KRET = 542
            GOTO 900
          ENDIF
        ELSE
          KRET = DLLSEC2(KGRIB,KLENG,INSPT,KSEC0,KSEC2,IBITS,IMISNG)
          IF( KRET.NE.0 ) THEN
            WRITE(GRPRSM,*)
     X  'GRIBEX: Error decoding lat/long grid section 2'
            KRET = 543
            GOTO 900
          ENDIF
        ENDIF
C
        GO TO 520
      ENDIF
C
C****
C     Spherical Harmonic format.
C****
C
      IF( KSEC2(1).EQ.50 .OR.
     X    KSEC2(1).EQ.60 .OR.
     X    KSEC2(1).EQ.70 .OR.
     X    KSEC2(1).EQ.80     ) THEN
C
        LSPHERC = .TRUE.
        LGRDPT = .FALSE.
C
        IF( LENCODE ) THEN
          KRET = ESHSEC2(KGRIB,KLENG,INSPT,KSEC0,KSEC2,IBITS)
          IF( KRET.NE.0 ) THEN
            WRITE(GRPRSM,*) 'GRIBEX: Error encoding spectral section 2'
            KRET = 544
            GOTO 900
          ENDIF
        ELSE
          KRET = DSHSEC2(KGRIB,KLENG,INSPT,KSEC2,IBITS)
          IF( KRET.NE.0 ) THEN
            WRITE(GRPRSM,*) 'GRIBEX: Error decoding spectral section 2'
            KRET = 545
            GOTO 900
          ENDIF
        ENDIF
C
        ITRUNC = KSEC2(2)
C
        GOTO 520
      ENDIF
C
C****
C*    Polar Stereographic.
C****
C
      IF( KSEC2(1).EQ.5) THEN
C
C*      Octets 7 - 8  : Ni - number of points along X-axis.
C       Octets 9 - 10 : Nj - number of points along Y-axis.
C       Two 16 bit fields.
C
C       Insert / extract fields.
C
        CALL INXBIT(KGRIB,KLENG,INSPT,KSEC2(2),2,IBITS, 16,YFUNC,KRET)
        IF( KRET.NE.0) THEN
          KRET = 523
          WRITE(GRPRSM,*) 'GRIBEX: Error inserting/extracting'
          WRITE(GRPRSM,*)
     X  'GRIBEX: number of points along X or Y axis.'
          WRITE(GRPRSM,*) 'GRIBEX: Return code = ', KRET
          GO TO 900
        ENDIF
C
C*      Octets 11 - 13 : La1 - latitude of first grid point.
C       Octets 14 - 16 : Lo1 - longitude of first grid point.
C       Two 24 bit fields.
C
C       When coding data, set sign bit to 1, if value is negative.
C
        IF( LENCODE ) THEN
          CALL CSGNBT( ILALO(1), KSEC2(4), 24, KRET)
          CALL CSGNBT( ILALO(2), KSEC2(5), 24, KRET)
        ENDIF
C
C       Insert / extract fields.
C
        CALL INXBIT(KGRIB,KLENG,INSPT,ILALO(1),2,IBITS, 24,YFUNC,KRET)
        IF( KRET.NE.0) THEN
          KRET = 506
          WRITE(GRPRSM,*) 'GRIBEX: Error inserting/extracting'
          WRITE(GRPRSM,*)
     X  'GRIBEX: latitude or longitude of first grid pt.'
          WRITE(GRPRSM,*) 'GRIBEX: Return code = ', KRET
          GO TO 900
        ENDIF
C
C       When decoding data, if sign bit is 1, value is negative.
C
        IF( LDECODE ) THEN
          CALL DSGNBT( KSEC2(4), ILALO(1), 24, KRET)
          CALL DSGNBT( KSEC2(5), ILALO(2), 24, KRET)
        ENDIF
C
C*      Octet 17 : Resolution and components flag.
C       One 8 bit field.
C
C       Resolution flag ( KSEC2(6) ) is not applicable.
C
        KSEC2(6) = 0
        IF( LENCODE ) IRESOL = KSEC2(18)+KSEC2(19)
C
C       Insert / extract field.
C
        CALL INXBIT(KGRIB,KLENG,INSPT,IRESOL,1,IBITS, 8,YFUNC,KRET)
        IF( KRET.NE.0) THEN
          KRET = 507
          WRITE(GRPRSM,*) 'GRIBEX: Error inserting/extracting'
          WRITE(GRPRSM,*) 'GRIBEX: components flag.'
          WRITE(GRPRSM,*) 'GRIBEX: Return code = ', KRET
          GO TO 900
        ENDIF
C
        IF( LDECODE ) THEN
Cd
Cd        All flag fields are already set to 0, so
          IF( IRESOL.EQ.0) GO TO 513
Cd
Cd        Fix up for flag which was different in Experimental edition.
Cd
          IF( KSEC0(2).EQ.-1.AND.(IRESOL.EQ.1.OR.IRESOL.EQ.3))
     X      IRESOL = 128
Cd
Cd        Resolution flag is not applicable.
          IF( IRESOL.GE.128) IRESOL = IRESOL - 128
Cd
Cd        Set earth flag.
          IF( IRESOL.GE.64) THEN
            KSEC2(18) = 64
            IRESOL    = IRESOL - 64
          ENDIF
Cd
Cd        Set components flag.
          KSEC2(19) = IRESOL
Cd
        ENDIF
C
  513   CONTINUE
C
C       Insert / extract field.
C
C       CALL INXBIT(KGRIB,KLENG,INSPT,KSEC2(6),1,IBITS, 8,YFUNC,KRET)
C       IF( KRET.NE.0) THEN
C         KRET = 507
C         WRITE(GRPRSM,*) 'GRIBEX: Error inserting/extracting'
C         WRITE(GRPRSM,*) 'GRIBEX: components flag.'
C         WRITE(GRPRSM,*) 'GRIBEX: Return code = ', KRET
C         GO TO 900
C       ENDIF
C
C*      Octets 18 - 20 : LoV - orientation of the grid.
C       One 24 bit field.
C
C       When coding data, set sign bit to 1, if value is negative.
C
        IF( LENCODE ) CALL CSGNBT( ILALO(1), KSEC2(7), 24, KRET)
C
C       Insert / extract fields.
C
        CALL INXBIT(KGRIB,KLENG,INSPT,ILALO(1),1,IBITS, 24,YFUNC,KRET)
        IF( KRET.NE.0) THEN
          KRET = 508
          WRITE(GRPRSM,*) 'GRIBEX: Error inserting/extracting'
          WRITE(GRPRSM,*)
     X  'GRIBEX: latitude or longitude of last grid point.'
          WRITE(GRPRSM,*) 'GRIBEX: Return code = ', KRET
          GO TO 900
        ENDIF
C
C       When decoding data, if sign bit is 1, value is negative.
C
        IF( LDECODE ) CALL DSGNBT( KSEC2(7), ILALO(1), 24, KRET)
C
C*      Octets 21 - 23 : Dx - X direction grid length.
C*      Octets 24 - 26 : Dy - Y direction grid length.
C       Two 24 bit fields.
C
C       Insert / extract fields.
C
        CALL INXBIT(KGRIB,KLENG,INSPT,KSEC2(9),2,IBITS, 24,YFUNC,KRET)
        IF( KRET.NE.0) THEN
          KRET = 524
          WRITE(GRPRSM,*) 'GRIBEX: Error inserting/extracting'
          WRITE(GRPRSM,*) 'GRIBEX: X or Y axis grid length.'
          WRITE(GRPRSM,*) 'GRIBEX: Return code = ', KRET
          GO TO 900
        ENDIF
C
C*      Octet 27 : Projection centre flag.
C       One 8-bit field.
C
C       Insert / extract field.
C
        CALL INXBIT(KGRIB,KLENG,INSPT,KSEC2(13),1,IBITS, 8,YFUNC,KRET)
        IF( KRET.NE.0) THEN
          KRET = 525
          WRITE(GRPRSM,*) 'GRIBEX: Error inserting/extracting'
          WRITE(GRPRSM,*) 'GRIBEX: Projection centre flag.'
          WRITE(GRPRSM,*) 'GRIBEX: Return code = ', KRET
          GO TO 900
        ENDIF
C
C*      Octet 28 : Scanning mode flags.
C       One 8 bit field.
C
C       Insert / extract field.
C
        CALL INXBIT(KGRIB,KLENG,INSPT,KSEC2(11),1,IBITS, 8,YFUNC,KRET)
        IF( KRET.NE.0) THEN
          KRET = 511
          WRITE(GRPRSM,*) 'GRIBEX: Error inserting/extracting'
          WRITE(GRPRSM,*) 'GRIBEX: scanning mode flags.'
          WRITE(GRPRSM,*) 'GRIBEX: Return code = ', KRET
          GO TO 900
        ENDIF
C
C       Fix-up for flag which was different in Experimental Edition.
        IF( KSEC0(2).EQ.-1.AND.KSEC2(11).EQ.1) KSEC2(11) = 0
C
C*      Octets 29 - 32 : Reserved.
C       Two 16 bit fields.
C
C       If insertion, set bits to 0.
        IF( LENCODE ) THEN
          CALL INXBIT(KGRIB,KLENG,INSPT, 0, 1,IBITS, 32,YFUNC,KRET)
          IF( KRET.NE.0) THEN
            KRET = 810
            WRITE(GRPRSM,*) 'GRIBEX: Error inserting dummy zero.'
            WRITE(GRPRSM,*) 'GRIBEX: Return code = ', KRET
            GO TO 900
          ENDIF
        ELSE
Cd
Cd        If extraction, only update bit pointer.
          INSPT = INSPT + 32
        ENDIF
C
        GO TO 520
      ENDIF
C
C****
C*    Space view perspective or orthographic.
C****
C
      IF( KSEC2(1).EQ.90) THEN
C
        IF( LENCODE ) THEN
          KRET = ESVSEC2(KGRIB,KLENG,INSPT,KSEC2,IBITS,ILEN2)
          IF( KRET.NE.0 ) THEN
            WRITE(GRPRSM,*) 'GRIBEX: Error encoding spectral section 2'
            KRET = 546
            GOTO 900
          ENDIF
        ELSE
          KRET = DSVSEC2(KGRIB,KLENG,INSPT,KSEC2,IBITS,ILEN2)
          IF( KRET.NE.0 ) THEN
            WRITE(GRPRSM,*) 'GRIBEX: Error decoding spectral section 2'
            KRET = 547
            GOTO 900
          ENDIF
        ENDIF
C
C
        GO TO 520
C
      ENDIF
C
C****
C*    Mercator
C****
C
      IF( KSEC2(1).EQ.1) THEN
C
        IF( LENCODE ) THEN
          KRET = EMESEC2(KGRIB,KLENG,INSPT,KSEC0,KSEC2,IBITS,LQUASI)
          IF( KRET.NE.0 ) THEN
            WRITE(GRPRSM,*) 'GRIBEX: Error encoding Mercator section 2'
            KRET = 546
            GOTO 900
          ENDIF
        ELSE
          KRET = DMESEC2(KGRIB,KLENG,INSPT,KSEC0,KSEC2,IBITS,IMISNG)
          IF( KRET.NE.0 ) THEN
            WRITE(GRPRSM,*) 'GRIBEX: Error decoding Mercator section 2'
            KRET = 547
            GOTO 900
          ENDIF
        ENDIF
C
C
        GO TO 520
C
      ENDIF
C
C****
C*    Lambert Conformal.
C****
C
      IF( KSEC2(1).EQ.3) THEN
C
C*      Octets 7 - 8  : Ni - number of points along X-axis.
C       Octets 9 - 10 : Nj - number of points along Y-axis.
C       Two 16 bit fields.
C
C       Insert / extract fields.
C
        CALL INXBIT(KGRIB,KLENG,INSPT,KSEC2(2),2,IBITS, 16,YFUNC,KRET)
        IF( KRET.NE.0) THEN
          KRET = 523
          WRITE(GRPRSM,*) 'GRIBEX: Error inserting/extracting'
          WRITE(GRPRSM,*)
     X  'GRIBEX: number of points along X or Y axis.'
          WRITE(GRPRSM,*) 'GRIBEX: Return code = ', KRET
          GO TO 900
        ENDIF
C
C*      Octets 11 - 13 : La1 - latitude of first grid point.
C       Octets 14 - 16 : Lo1 - longitude of first grid point.
C       Two 24 bit fields.
C
Ce      When coding data, set sign bit to 1, if value is negative.
Ce
        IF( LENCODE ) THEN
          CALL CSGNBT( ILALO(1), KSEC2(4), 24, KRET)
          CALL CSGNBT( ILALO(2), KSEC2(5), 24, KRET)
        ENDIF
C
C       Insert / extract fields.
C
        CALL INXBIT(KGRIB,KLENG,INSPT,ILALO(1),2,IBITS, 24,YFUNC,KRET)
        IF( KRET.NE.0) THEN
          KRET = 506
          WRITE(GRPRSM,*) 'GRIBEX: Error inserting/extracting'
          WRITE(GRPRSM,*)
     X  'GRIBEX: latitude or longitude of first grid pt.'
          WRITE(GRPRSM,*) 'GRIBEX: Return code = ', KRET
          GO TO 900
        ENDIF
C
Cd      When decoding data, if sign bit is 1, value is negative.
Cd
        IF( LDECODE ) THEN
          CALL DSGNBT( KSEC2(4), ILALO(1), 24, KRET)
          CALL DSGNBT( KSEC2(5), ILALO(2), 24, KRET)
        ENDIF
C
C*      Octet 17 : Resolution and components flag.
C       One 8 bit field.
C
C       Resolution flag ( KSEC2(6) ) is not applicable.
C
        IF( LENCODE ) IRESOL = KSEC2(18)+KSEC2(19)+KSEC2(6)
C
C       Insert / extract field.
C
        CALL INXBIT(KGRIB,KLENG,INSPT,IRESOL,1,IBITS, 8,YFUNC,KRET)
        IF( KRET.NE.0) THEN
          KRET = 507
          WRITE(GRPRSM,*) 'GRIBEX: Error inserting/extracting'
          WRITE(GRPRSM,*) 'GRIBEX: components flag.'
          WRITE(GRPRSM,*) 'GRIBEX: Return code = ', KRET
          GO TO 900
        ENDIF
C
        IF( LDECODE ) THEN
Cd
Cd        If all flag fields are already set to 0, bypass.
Cd
          IF( IRESOL.EQ.0) GO TO 515
Cd
Cd        Resolution flag is not applicable.
Cd
          IF( IRESOL.GE.128) THEN
            KSEC2(6) = 128
            IRESOL   = IRESOL - 128
          ENDIF
Cd
Cd        Set earth flag.
Cd
          IF( IRESOL.GE.64) THEN
            KSEC2(18) = 64
            IRESOL    = IRESOL - 64
          ENDIF
Cd
Cd        Set components flag.
Cd
          KSEC2(19) = IRESOL
Cd
        ENDIF
C
  515   CONTINUE
C
C       Insert / extract field.
C
C*      Octets 18 - 20 : LoV - orientation of the grid.
C       One 24 bit field.
C
Ce      When coding data, set sign bit to 1, if value is negative.
Ce
        IF( LENCODE ) CALL CSGNBT( ILALO(1), KSEC2(7), 24, KRET)
C
C       Insert / extract fields.
C
        CALL INXBIT(KGRIB,KLENG,INSPT,ILALO(1),1,IBITS, 24,YFUNC,KRET)
        IF( KRET.NE.0) THEN
          KRET = 508
          WRITE(GRPRSM,*)
     X  'GRIBEX: Error inserting/extracting'
          WRITE(GRPRSM,*)
     X  'GRIBEX: latitude or longitude of last grid point.'
          WRITE(GRPRSM,*) 'GRIBEX: Return code = ', KRET
          GO TO 900
        ENDIF
C
Cd      When decoding data, if sign bit is 1, value is negative.
Cd
        IF( LDECODE ) CALL DSGNBT( KSEC2(7), ILALO(1), 24, KRET)
C
C*      Octets 21 - 23 : Dx - X direction grid length.
C*      Octets 24 - 26 : Dy - Y direction grid length.
C       Two 24 bit fields.
C
C       Insert / extract fields.
C
        CALL INXBIT(KGRIB,KLENG,INSPT,KSEC2(9),2,IBITS, 24,YFUNC,KRET)
        IF( KRET.NE.0) THEN
          KRET = 524
          WRITE(GRPRSM,*) 'GRIBEX: Error inserting/extracting'
          WRITE(GRPRSM,*) 'GRIBEX: X or Y axis grid length.'
          WRITE(GRPRSM,*) 'GRIBEX: Return code = ', KRET
          GO TO 900
        ENDIF
C
C*      Octet 27 : Projection centre flag.
C       One 8-bit field.
C
C       Insert / extract field.
C
        CALL INXBIT(KGRIB,KLENG,INSPT,KSEC2(13),1,IBITS, 8,YFUNC,KRET)
        IF( KRET.NE.0) THEN
          KRET = 525
          WRITE(GRPRSM,*) 'GRIBEX: Error inserting/extracting'
          WRITE(GRPRSM,*) 'GRIBEX: Projection centre flag.'
          WRITE(GRPRSM,*) 'GRIBEX: Return code = ', KRET
          GO TO 900
        ENDIF
C
C*      Octet 28 : Scanning mode flags.
C       One 8 bit field.
C
C       Insert / extract field.
C
        CALL INXBIT(KGRIB,KLENG,INSPT,KSEC2(11),1,IBITS, 8,YFUNC,KRET)
        IF( KRET.NE.0) THEN
          KRET = 511
          WRITE(GRPRSM,*) 'GRIBEX: Error inserting/extracting'
          WRITE(GRPRSM,*) 'GRIBEX: scanning mode flags.'
          WRITE(GRPRSM,*) 'GRIBEX: Return code = ', KRET
          GO TO 900
        ENDIF
C
C       Fix-up for flag which was different in Experimental
C            Edition.
C
        IF( KSEC0(2).EQ.-1.AND.KSEC2(11).EQ.1) KSEC2(11) = 0
C
C*      Octets 29 - 31 : Latin 1.
C*      Octets 32 - 34 : Latin 2.
C       Two 24 bit fields.
C
Ce      When coding data, set sign bit to 1, if value is negative.
Ce
        IF( LENCODE ) THEN
          CALL CSGNBT( ILALO(1), KSEC2(14), 24, KRET)
          CALL CSGNBT( ILALO(2), KSEC2(15), 24, KRET)
        ENDIF
C
C       Insert / extract fields.
C
        CALL INXBIT(KGRIB,KLENG,INSPT,ILALO(1),2,IBITS, 24,YFUNC,KRET)
        IF( KRET.NE.0) THEN
          KRET = 531
          WRITE(GRPRSM,*) 'GRIBEX: Error inserting/extracting'
          WRITE(GRPRSM,*)
     X  'GRIBEX: Latin1 or Latin2 of secants points.'
          WRITE(GRPRSM,*) 'GRIBEX: Return code = ', KRET
          GO TO 900
        ENDIF
C
Cd      When decoding data, if sign bit is 1, value is negative.
C
        IF( LDECODE ) THEN
          CALL DSGNBT( KSEC2(14), ILALO(1), 24, KRET)
          CALL DSGNBT( KSEC2(15), ILALO(2), 24, KRET)
        ENDIF
C
C*      Octets 35 - 37 : Latitude of the southern pole.
C*      Octets 38 - 40 : Longitude of the southern pole.
C       Two 24 bit fields.
C
Ce      When coding data, set sign bit to 1, if value is negative.
Ce
        IF( LENCODE ) THEN
          CALL CSGNBT( ILALO(1), KSEC2(20), 24, KRET)
          CALL CSGNBT( ILALO(2), KSEC2(21), 24, KRET)
        ENDIF
C
C       Insert / extract fields.
C
        CALL INXBIT(KGRIB,KLENG,INSPT,ILALO(1),2,IBITS, 24,YFUNC,KRET)
        IF( KRET.NE.0) THEN
          KRET = 532
          WRITE(GRPRSM,*) 'GRIBEX: Error inserting/extracting'
          WRITE(GRPRSM,*)
     X  'GRIBEX: latitude/longitude of southern pole.'
          WRITE(GRPRSM,*) 'GRIBEX: Return code = ', KRET
          GO TO 900
        ENDIF
C
Cd      When decoding data, if sign bit is 1, value is negative.
Cd
        IF( LDECODE ) THEN
          CALL DSGNBT( KSEC2(20), ILALO(1), 24, KRET)
          CALL DSGNBT( KSEC2(21), ILALO(2), 24, KRET)
        ENDIF
C
C*      Octets 41 - 42 : Reserved.
C       One 16 bit fields.
C
        IF( LENCODE ) THEN
C
Ce        All bits already set to 0.
Ce        No insertion, only update bit pointer.
Ce
          INSPT = INSPT + 16
Ce
        ELSE
Cd
Cd        No extraction, only update bit pointer.
Cd
          INSPT = INSPT + 16
Cd
        ENDIF
C
        GO TO 520
      ENDIF
C
C
C****
C     Ocean grid definition.
C****
C
      IF( KSEC2(1).EQ.192 ) THEN
C
        IF( LENCODE ) THEN
          KRET = EOCSEC2(KGRIB,KLENG,INSPT,KSEC2,IBITS)
          IF( KRET.NE.0 ) THEN
            WRITE(GRPRSM,*)
     X  'GRIBEX: Error encoding ECMWF ocean section 2'
            KRET = 546
            GOTO 900
          ENDIF
        ELSE
          KRET = DOCSEC2(KGRIB,KLENG,INSPT,KSEC2,IBITS)
          IF( KRET.NE.0 ) THEN
            WRITE(GRPRSM,*)
     X  'GRIBEX: Error decoding ECMWF ocean section 2'
            KRET = 547
            GOTO 900
          ENDIF
        ENDIF
        GOTO 520
C
      ENDIF
C
C****
C*    Other representation types not yet catered for.
C****
C
      KRET = 598
      WRITE(GRPRSM,*)
     X  'GRIBEX: Representation type not catered for:',KSEC2(1)
      WRITE(GRPRSM,*) 'GRIBEX: Return code = ', KRET
      GO TO 900
C
C*    Rotation parameters for rotated or stretched and rotated grids.
C     (Gaussian, Latitude/longitude or Spherical Harmonics)
C
  520 CONTINUE
C
      IF( KSEC2(1).EQ.10.OR.KSEC2(1).EQ.30.OR.
     X    KSEC2(1).EQ.14.OR.KSEC2(1).EQ.34.OR.
     X    KSEC2(1).EQ.60.OR.KSEC2(1).EQ.80) THEN
C
C*      Octets 33 - 35 : Latitude of the southern pole.
C       Octets 36 - 38 : Longitude of the southern pole.
C       Two 24 bit fields.
C
C       When coding data, set sign bit to 1, if value is negative.
C
        IF( LENCODE ) THEN
          CALL CSGNBT( ILALO(1), KSEC2(13), 24, KRET)
          CALL CSGNBT( ILALO(2), KSEC2(14), 24, KRET)
        ENDIF
C
C       Insert / extract fields.
C
        CALL INXBIT(KGRIB,KLENG,INSPT,ILALO(1),2,IBITS, 24,YFUNC,KRET)
        IF( KRET.NE.0) THEN
          KRET = 517
          WRITE(GRPRSM,*) 'GRIBEX: Error inserting/extracting'
          WRITE(GRPRSM,*)
     X  'GRIBEX: latitude or longitude of southern pole.'
          WRITE(GRPRSM,*) 'GRIBEX: Return code = ', KRET
          GO TO 900
        ENDIF
C
C       When decoding data, if sign bit is 1, value is negative.
C
        IF( LDECODE ) THEN
          CALL DSGNBT( KSEC2(13), ILALO(1), 24, KRET)
          CALL DSGNBT( KSEC2(14), ILALO(2), 24, KRET)
        ENDIF
C
C*      Octets 39 - 42 : Angle of rotation.
C       One 8 bit and one 24 bit field.
C
        IF( LENCODE ) THEN
Ce
Ce        Convert floating point to GRIB representation.
          ITRND = 1
          CALL CONFP3 (PSEC2(1),IEXP,IMANT,IBITS,ITRND)
        ENDIF
C
C       Insert / extract fields.
C
        CALL INXBIT(KGRIB,KLENG,INSPT,IEXP,1,IBITS, 8,YFUNC,KRETA)
        CALL INXBIT(KGRIB,KLENG,INSPT,IMANT,1,IBITS, 24,YFUNC,KRETB)
        KRET = KRET + KRETB
        IF( KRET.NE.0) THEN
          KRET = 518
          WRITE(GRPRSM,*) 'GRIBEX: Error inserting/extracting'
          WRITE(GRPRSM,*) 'GRIBEX: angle of rotation.'
          WRITE(GRPRSM,*) 'GRIBEX: Return code = ', KRET
          GO TO 900
        ENDIF
C
        IF( LDECODE ) THEN
Cd
Cd        Convert GRIB representation to floating point.
          CALL DECFP2 (PSEC2(1),IEXP,IMANT)
Cd
        ENDIF
      ENDIF
C
C*    Stretching parameters for stretched grids.
C     (Gaussian, Latitude/longitude or Spherical Harmonics)
C
      IF( KSEC2(1).EQ.20.OR.KSEC2(1).EQ.24.OR.KSEC2(1).EQ.70) THEN
C
C*      Octets 33 - 35 : Latitude of pole of stretching.
C       Octets 36 - 38 : Longitude of pole of stretching.
C       Two 24 bit fields.
C
C       When coding data, set sign bit to 1, if value is negative.
C
        IF( LENCODE ) THEN
          CALL CSGNBT( ILALO(1), KSEC2(15), 24, KRET)
          CALL CSGNBT( ILALO(2), KSEC2(16), 24, KRET)
        ENDIF
C
C       Insert / extract fields.
C
        CALL INXBIT(KGRIB,KLENG,INSPT,ILALO(1),2,IBITS, 24,YFUNC,KRET)
        IF( KRET.NE.0) THEN
          KRET = 519
          WRITE(GRPRSM,*) 'GRIBEX: Error inserting/extracting'
          WRITE(GRPRSM,*)
     X  'GRIBEX: latitude/longitude of pole of stretching.'
          WRITE(GRPRSM,*) 'GRIBEX: Return code = ', KRET
          GO TO 900
        ENDIF
C
C       When decoding data, if sign bit is 1, value is negative.
C
        IF( LDECODE ) THEN
          CALL DSGNBT( KSEC2(15), ILALO(1), 24, KRET)
          CALL DSGNBT( KSEC2(16), ILALO(2), 24, KRET)
        ENDIF
C
C*      Octets 39 - 42 : Stretching factor.
C       One 8 bit and one 24 bit field.
C
C       Convert floating point to GRIB representation.
        ITRND = 1
        IF( LENCODE ) CALL CONFP3 (PSEC2(2),IEXP,IMANT,IBITS,ITRND)
C
C       Insert / extract fields.
C
        CALL INXBIT(KGRIB,KLENG,INSPT,IEXP,1,IBITS, 8,YFUNC,KRETA)
        CALL INXBIT(KGRIB,KLENG,INSPT,IMANT,1,IBITS, 24,YFUNC,KRETB)
        KRET = KRETA + KRETB
        IF( KRET.NE.0) THEN
          KRET = 520
          WRITE(GRPRSM,*) 'GRIBEX: Error inserting/extracting'
          WRITE(GRPRSM,*) 'GRIBEX: stretching factor.'
          WRITE(GRPRSM,*) 'GRIBEX: Return code = ', KRET
          GO TO 900
        ENDIF
C
C       Convert GRIB representation to floating point.
        IF( LDECODE ) CALL DECFP2 (PSEC2(2),IEXP,IMANT)
C
      ENDIF
C
C*    Stretching parameters for stretched and rotated grids.
C     (Gaussian, Latitude/longitude or Spherical Harmonics)
C
      IF( KSEC2(1).EQ.30.OR.KSEC2(1).EQ.34.OR.KSEC2(1).EQ.80) THEN
C
C*      Octets 43 - 45 : Latitude of pole of stretching.
C       Octets 46 - 48 : Longitude of pole of stretching.
C       Two 24 bit fields.
C
C       When coding data, set sign bit to 1, if value is negative.
C
        IF( LENCODE ) THEN
          CALL CSGNBT( ILALO(1), KSEC2(15), 24, KRET)
          CALL CSGNBT( ILALO(2), KSEC2(16), 24, KRET)
        ENDIF
C
C       Insert / extract fields.
C
        CALL INXBIT(KGRIB,KLENG,INSPT,ILALO(1),2,IBITS, 24,YFUNC,KRET)
        IF( KRET.NE.0) THEN
          KRET = 519
          WRITE(GRPRSM,*)
     X  'GRIBEX: Error inserting/extracting'
          WRITE(GRPRSM,*)
     X  'GRIBEX: latitude/longitude of pole of stretching.'
          WRITE(GRPRSM,*) 'GRIBEX: Return code = ', KRET
          GO TO 900
        ENDIF
C
C       When decoding data, if sign bit is 1, value is negative.
C
        IF( LDECODE ) THEN
          CALL DSGNBT( KSEC2(15), ILALO(1), 24, KRET)
          CALL DSGNBT( KSEC2(16), ILALO(2), 24, KRET)
        ENDIF
C
C*      Octets 49 - 52 : Stretching factor.
C       One 8 bit and one 24 bit field.
C
C       Convert floating point to GRIB representation.
        ITRND = 1
        IF( LENCODE ) CALL CONFP3 (PSEC2(2),IEXP,IMANT,IBITS,ITRND)
C
C       Insert / extract fields.
C
        CALL INXBIT(KGRIB,KLENG,INSPT,IEXP,1,IBITS, 8,YFUNC,KRETA)
        CALL INXBIT(KGRIB,KLENG,INSPT,IMANT,1,IBITS, 24,YFUNC,KRETB)
        KRET = KRETA + KRETB
        IF( KRET.NE.0) THEN
          KRET = 520
          WRITE(GRPRSM,*) 'GRIBEX: Error inserting/extracting'
          WRITE(GRPRSM,*) 'GRIBEX: stretching factor.'
          WRITE(GRPRSM,*) 'GRIBEX: Return code = ', KRET
          GO TO 900
        ENDIF
C
C       Convert GRIB representation to floating point.
C
        IF( LDECODE ) CALL DECFP2 (PSEC2(2),IEXP,IMANT)
C
      ENDIF
C
C*    Vertical coordinate parameters, if any.
C
      IF( KSEC2(12).NE.0) THEN
        ITRND = 1
        DO 530 JLOOP = 1 , KSEC2(12)
C
C         One 8 bit and one 24 bit field.
C
Ce        Convert floating point to GRIB representation.
          IF( LENCODE )
     X      CALL CONFP3 (PSEC2(JLOOP+10),IEXP,IMANT, IBITS,ITRND)
C
C         Insert / extract fields.
C
          CALL INXBIT(KGRIB,KLENG,INSPT,IEXP,1,IBITS, 8,YFUNC,KRETA)
          CALL INXBIT(KGRIB,KLENG,INSPT,IMANT,1,IBITS, 24,YFUNC,KRETB)
          KRET = KRETA + KRETB
          IF( KRET.NE.0) THEN
            KRET = 521
            WRITE(GRPRSM,*) 'GRIBEX: Error inserting/extracting'
            WRITE(GRPRSM,*) 'GRIBEX: vertical coordinate parameters.'
            WRITE(GRPRSM,*) 'GRIBEX: Return code = ', KRET
            GO TO 900
          ENDIF
C
Cd        Convert GRIB representation to floating point.
          IF( LDECODE ) CALL DECFP2 (PSEC2(JLOOP+10),IEXP,IMANT)
C
  530   CONTINUE
      ENDIF
C
C*    List of number of points, if any.
C     Number of 16 bit fields.
C
      IF( LQUASI) THEN
C
C       Insert / extract fields.
C
        CALL INXBIT(KGRIB,KLENG,INSPT,KSEC2(23),KSEC2(3),IBITS,
     X               16,YFUNC,KRET)
        IF( KRET.NE.0) THEN
          KRET = 522
          WRITE(GRPRSM,*) 'GRIBEX: Error inserting/extracting'
          WRITE(GRPRSM,*) 'GRIBEX: list of numbers of points.'
          WRITE(GRPRSM,*) 'GRIBEX: Return code = ', KRET
          GO TO 900
        ENDIF
      ENDIF
C
C     -----------------------------------------------------------------|
C
C
C
C
C
C
C
C
C
C
C*    Section 6 . Bit Map Section (section 3) of GRIB code.
C     -----------------------------------------------------------------|
C
  600 CONTINUE
C
      IF( LPDEBUG ) WRITE(GRPRSM,*)
     X  'GRIBEX: Section 6. Handle Bit Map Section (Section 3)'
C
C*    Go to section 9, if decoding of identification sections only and
C     GRIB Code Edition is higher than 0. If Edition is lower the
C     length of the GRIB message needs to be calculated, so change
C     function to 'L' to complete decoding of section 0.
C     Number of data values decoded ( KSEC4(1) ) already set to 0.
C
      IF( HOPER(1:1).EQ.'I') THEN
        IF( KSEC0(2).GT.0) THEN
          GO TO 900
        ELSE
          YFUNC = 'L'
        ENDIF
      ENDIF
C
C*    Set integer or real missing data value.
C
      IF( KSEC4(5) .EQ. 0 )  THEN
        ZMSVAL = PSEC3(2)
      ELSE
        ZMSVAL = REAL(KSEC3(2))
      ENDIF
C
C*    Go to section 7, if no bit map required.
C
      IF( .NOT.LSECT3 ) GO TO 700
C
C*    Set bit-map flag and attempt no decoding of bit-map, if
C     routine has been called by the DECOGB interface routine,
C     which is provided for upward compatibility with old software.
C
      IF( HOPER.EQ.'Z') THEN
        ISBMAP = -5
        WRITE(GRPRSM,*) 'GRIBEX: Bit-map found. No data decoded.'
        WRITE(GRPRSM,*) 'GRIBEX: Return code = ', ISBMAP
        GO TO 900
      ENDIF
C
C*    Check consistency of values given, with GRIB code, if required.
C
      IF( NVCK.EQ.1.AND. LENCODE ) THEN
        CALL GRCHK3 (KSEC1,KSEC3,PSEC3,KRET)
        IF( KRET.NE.0) THEN
          KRET = 699
          WRITE(GRPRSM,*)
     X  'GRIBEX: Error found checking values for section 3'
          WRITE(GRPRSM,*) 'GRIBEX: Return code = ', KRET
          GO TO 900
        ENDIF
      ENDIF
C
C*    When coding data, calculate the length of section and number
C     of unused bits.
C
      IF( LENCODE ) THEN
Ce
        IF( KSEC3(1).NE.0) THEN
Ce
Ce        Predetermined bit-map table included.
Ce        Length of section is 6 octets, number of unused bits is 0.
          ILEN3 = 6
          INUB  = 0
Cjdc      KRET = GBITMAP(KSEC3(1), IBTVALS, NONMISS, IBTPTR, NBYTE)
Cjdc      IVALS = NONMISS
Ce
        ELSE
Ce
Ce        Bit-map included in section 3.
Ce        Length of section = 6 octets of header + length of
Ce        bit-map, rounded to a multiple of 2 octets.
Ce
Ce        Set IVALS to the number of bits in the bit-map.
          IF( KSEC4(8).EQ.0) THEN
Ce
Ce          Each bit in the bit-map represents a single value.
            IVALS = ILENF
          ELSE
Ce
Ce          Each bit in the bit-map represents a matrix of values.
            IVALS = ILENF / (KSEC4(50)*KSEC4(51))
          ENDIF
Ce
          ITEMP = 48 + IVALS
          ILEN3 = ( ITEMP + 15 ) / 16
          ILEN3 = ILEN3 * 2
Ce
Ce        Number of unused bits.
          INUB = ILEN3 * 8 - ITEMP
Ce
        ENDIF
Ce
      ENDIF
C
C*    Octets 1 - 3 : Length of section.
C     One 24 bit field.
C
C     Insert/extract field.
C
      CALL INXBIT(KGRIB,KLENG,INSPT,ILEN3,1,IBITS, 24,YFUNC,KRET)
        IF( KRET.NE.0) THEN
          KRET = 601
          WRITE(GRPRSM,*)
     X      'GRIBEX: Error inserting/extracting section 3 length'
          WRITE(GRPRSM,*) 'GRIBEX: Return code = ', KRET
          GO TO 900
        ENDIF
C
C*    Print length of Section 3, if required.
C
      IF( LPDEBUG ) WRITE(GRPRSM,*)
     X  'GRIBEX: Length of Section 3 of GRIB = ',ILEN3,' octets.'
C
C     If only length is required, update bit-pointer and jump
C     to extraction of length of section 4.
C
      IF( YFUNC.EQ.'L') THEN
        INSPT = INSPT -24 + ILEN3 * 8
        GO TO 700
      ENDIF
C
C*    Octet 4 : Number of unused bits at end of section.
C     One 8 bit field.
C
C     Insert/extract field.
C
      CALL INXBIT(KGRIB,KLENG,INSPT,INUB,1,IBITS, 8,YFUNC,KRET)
        IF( KRET.NE.0) THEN
          KRET = 602
          WRITE(GRPRSM,*) 'GRIBEX: Error inserting/extracting number'
          WRITE(GRPRSM,*)
     X  'GRIBEX: unused bits at the end of Section 3.'
          WRITE(GRPRSM,*) 'GRIBEX: Return code = ', KRET
          GO TO 900
        ENDIF
C
C*    Octets 5-6 : Bit-map table reference.
C     One 16 bit field.
C
C     Insert/extract field.
C
      CALL INXBIT(KGRIB,KLENG,INSPT,KSEC3(1),1,IBITS, 16,YFUNC,KRET)
      IF( KRET.NE.0) THEN
        KRET = 603
        WRITE(GRPRSM,*)
     X    'GRIBEX: Error inserting/extracting bit-map reference table'
        WRITE(GRPRSM,*) 'GRIBEX: Return code = ', KRET
        GO TO 900
      ENDIF
C
C*    Set integer or real missing data value.
C
      IF( KSEC4(5) .EQ. 0 )  THEN
        ZMSVAL = PSEC3(2)
      ELSE
        ZMSVAL = REAL(KSEC3(2))
      ENDIF
C
C*    Finished if a predetermined bit-map table is given.
C
      IF( KSEC3(1).NE.0) GO TO 700
C
C*    Bit-map definition included.
C
      IF( LENCODE ) THEN
Ce
Ce      Insert primary bit-map. Set function for fixed length
Ce      messages if required.
Ce
        YTEMP = YFUNC
        IF( HOPER.EQ.'M') YTEMP = 'M'
Ce
        IF( KSEC4(8).EQ.64) THEN
Ce
Ce        Matrix of values at a point.
          ITEMP = KSEC4(50) * KSEC4(51)
        ELSE
Ce
Ce        Single value at each point.
          ITEMP = 1
        ENDIF
Ce
Ce      Retain pointer to bit-map location.
Ce
        IBMAP = INSPT
Ce
        CALL INSMP1 (KGRIB,KLENG,INSPT,KSEC4(9),PSEC4,
     X               ILENF,IBITS,ZMSVAL,YTEMP,ITEMP,NDBG,KRET)
        IF( KRET.NE.0) THEN
          KRET = 604
          WRITE(GRPRSM,*) 'GRIBEX: Error inserting primary bit map.'
          WRITE(GRPRSM,*) 'GRIBEX: Return code = ', KRET
          GO TO 900
        ENDIF
Ce
Ce      Number of data values remaining to be handled
Ce      is now in ILENF, which is used when finding maximum and
Ce      minimum values etc. When a matrix of values is present
Ce      PSEC4 may still contain missing data indicators for each
Ce      matrix.
Ce
Ce      Effective number of points will be returned in KSEC4(21).
Ce
        NONMISS = ILENF
Ce
Ce      Unused bits at end of section.
Ce      These bits are already set to 0, so update bit-pointer only.
Ce
        INSPT = INSPT + INUB
Ce
      ELSE
Cd
Cd      Retain pointer to bit-map location.
Cd
        IBMAP = INSPT
Cd
Cd      IVALS is the number of bits in the bit-map. It is the same
Cd      as the number of data values (including missing data
Cd      values to be decoded) when each point represents a single
Cd      data value. When each bit in the bit-map represents a
Cd      matrix of values, it is the number of matrices.
Cd
        IVALS = (ILEN3 - 6) * 8 - INUB
Cd
Cd      Update bit-pointer to start of section 4 of Grib message.
        INSPT = INSPT - 48 + ILEN3 * 8
Cd
      ENDIF
C
C     -----------------------------------------------------------------|
C
C
C
C
C
C
C
C
C
C
C*    Section 7 . Binary Data Section (section 4) of GRIB code.
C     -----------------------------------------------------------------|
C
  700 CONTINUE
C
      IF( LPDEBUG ) WRITE(GRPRSM,*)
     X  'GRIBEX: Section 7. Handle Binary Data Section (Section 4)'
C
C*    Check consistency of values given, with GRIB code, if required.
C
      IF( NVCK.EQ.1.AND. LENCODE ) THEN
        CALL GRCHK4 (KSEC1,KSEC4,PSEC4,KRET)
        IF( KRET.NE.0) THEN
          KRET = 799
          WRITE(GRPRSM,*)
     X      'GRIBEX: Error found when checking values for section 4'
          WRITE(GRPRSM,*) 'GRIBEX: Return code = ', KRET
          GO TO 900
        ENDIF
      ENDIF
C
C*    Retain value of the pointer to the first bit in Section 4.
C     When coding data, this is needed later to insert the length
C     of Section 4 and the number of unused bits.
C     When decoding data, this is used later to calculate the
C     number of packed data values which have to be decoded.
C
      IPLEN = INSPT
C
C*    Octets 1 - 3 : Length of section.
C     One 24 bit field.
C
      IF( LENCODE ) THEN
Ce
Ce      Increment pointer.
        INSPT = INSPT + 24
      ELSE
Cd
Cd      Extract field.
Cd
        CALL INXBIT(KGRIB,KLENG,INSPT,ILEN4,1,IBITS, 24,YFUNC,KRET)
        IF( KRET.NE.0) THEN
          KRET = 701
          WRITE(GRPRSM,*) 'GRIBEX: Error extracting section 4 length'
          WRITE(GRPRSM,*) 'GRIBEX: Return code = ', KRET
          GO TO 900
        ENDIF
Cd
Cd      If a very large product, the section 4 length field holds
Cd      the number of bytes in the product after section 4 upto
Cd      the end of the padding bytes.
Cd      This is a fixup to get round the restriction on product lengths
Cd      due to the count being only 24 bits. It is only possible because
Cd      the (default) rounding for GRIB products is 120 bytes.
Cd

Cljbf   in case of big fields, revert the
Cljbf   workaround in decoding in case we realize it
Cljbf   is not paked using the *120 trick
Cljbf

        IF( LLARGE .AND. ILEN4.GT.120) THEN
          KSEC0(1) = KSEC0(1) / 120
          KSEC0(1) = KSEC0(1) * 2
          LLARGE = .FALSE.
        ENDIF

        IF( LLARGE ) ILEN4 = KSEC0(1) - (INSPT/8) - ILEN4 + 3
Cd
Cd      Print length of Section 4, if required.
Cd
        IF( LPDEBUG ) WRITE(GRPRSM,*)
     X    'GRIBEX: Length of Section 4 of GRIB = ',ILEN4,' octets.'
Cd
Cd      Set length if required, by updating bit-pointer and
Cd      adding length of section 5 (32 bits). Length in bytes.
Cd      Finished if length only required, so go to section 9.
Cd
        IF( YFUNC.EQ.'L'.OR.HOPER.EQ.'X') THEN
          KSEC0(1) = (INSPT - 24 + ILEN4 * 8 + 32) / 8
          IF( YFUNC.EQ.'L') GO TO 900
        ENDIF
Cd
      ENDIF
C
C*    Octet 4 : 4 bit flag field and 4 bit unused bit count field.
C     One 8 bit field for insertion/extraction purposes.
C
      IF( LENCODE ) THEN
Ce
Ce      Type of data (spherical harmonic coefficients or grid
Ce      point) is taken from KSEC4(3) only if no Section 2 is
Ce      included.(This allows for data coded without Section 2).
Ce
        IF( LSECT2 ) THEN
Ce
Ce        If section 2 is present, it says if data is spherical harmonic
Ce
          IF( LSPHERC ) THEN
            KSEC4(3) = 128
          ELSE
            KSEC4(3) = 0
          ENDIF
Ce
        ELSE
Ce
Ce        Section 4 says if it's spherical harmonic data..
Ce
          LSPHERC = ( KSEC4(3) .EQ. 128 )
          LGRDPT  = .NOT.LSPHERC
        ENDIF
Ce
Ce      When coding data, field is inserted later, when
Ce      number of unused bits is known and added to it.
Ce
Ce      Increment pointer.
        INSPT = INSPT + 8
Ce
      ELSE
Cd
Cd      Decoding -> extract field.
Cd
        CALL INXBIT(KGRIB,KLENG,INSPT,IFLAG,1,IBITS, 8,YFUNC,KRET)
        IF( KRET.NE.0) THEN
          KRET = 706
          WRITE(GRPRSM,*)
     X  'GRIBEX: Error extracting section 4 flag field.'
          WRITE(GRPRSM,*) 'GRIBEX: Return code = ', KRET
          GO TO 900
        ENDIF
Cd
Cd      All flags already preset to 0.
Cd
        IF( KSEC0(2).EQ.-1) THEN
Cd
Cd        In the Experimental Edition flag field was
Cd        0000 for grid point data.
Cd        0001 for spherical harmonic data.
Cd
          ITEMP = IFLAG / 16
          INIL  = IFLAG - ITEMP * 16
          IF( ITEMP.NE.0) KSEC4(3) = 128
          GO TO 710
        ENDIF
Cd
        IF( KSEC0(2).EQ.0) THEN
Cd
Cd        In Edition 0 flag field only 2 first bits had significance.
Cd
Cd        0- for grid point data.
Cd        1- for spherical harmonic data.
Cd        -0 for simple packing.
Cd        -1 for complex packing (only supported for spectral data).
Cd
          IF( IFLAG.GE.128) THEN
            KSEC4(3) = 128
            IFLAG    = IFLAG - 128
          ENDIF
Cd
          IF( IFLAG.GE.64) THEN
            KSEC4(4) = 64
            IFLAG    = IFLAG - 64
          ENDIF
Cd
          INIL  = IFLAG
        ELSEIF( KSEC0(2).EQ.1) THEN
Cd
Cd        In Edition 1 flag field all 4 bits have significance.
Cd
Cd        0--- for grid point data.
Cd        1--- for spherical harmonic data.
Cd        -0-- for simple packing.
Cd        -1-- for complex or second order packing.
Cd        --0- for floating point values.
Cd        --1- for integer values.
Cd        ---0 for no additional flags at Octet 14.
Cd        ---1 for additional flags at Octet 14.
Cd
          IF( IFLAG.GE.128) THEN
            KSEC4(3) = 128
            IFLAG    = IFLAG - 128
          ENDIF
Cd
          IF( IFLAG.GE.64) THEN
            KSEC4(4) = 64
            IFLAG    = IFLAG - 64
          ENDIF
Cd
          IF( IFLAG.GE.32) THEN
            KSEC4(5) = 32
            IFLAG    = IFLAG - 32
          ENDIF
Cd
          IF( IFLAG.GE.16) THEN
            KSEC4(6) = 16
            IFLAG    = IFLAG - 16
          ENDIF
Cd
          INIL  = IFLAG
        ENDIF
Cd
  710   CONTINUE
Cd
Cd      Type of data (spherical harmonic coefficients or grid
Cd      point) is taken from KSEC4(3) only if no Section 2 is
Cd      included.(This allows for data coded without Section 2).
Cd
        IF( .NOT.LSECT2 ) THEN
          LSPHERC = ( KSEC4(3) .EQ. 128 )
          LGRDPT  = .NOT.LSPHERC
        ELSEIF( LSPHERC ) THEN
          KSEC4(3) = 128
        ELSE
          KSEC4(3) = 0
        ENDIF
Cd
Cd      Print number of unused bits, if required.
Cd
        IF( LPDEBUG ) WRITE(GRPRSM,*)
     X    'GRIBEX: Number of unused bits is ',INIL,'.'
Cd
      ENDIF
C
C*    Complex packing supported for spherical harmonics.
      LCOMPLX = (LSPHERC .AND. ( KSEC4(4).EQ.64 ) ) .OR.
     X          (LSPHERC .AND. LSECT2 .AND. ( KSEC2(6).EQ.2 ) )
C
C     Check input specification is consistent
      IF( LCOMPLX .AND. LSECT2 ) THEN
        IF( ( KSEC4(4).NE.64 ) .AND. ( KSEC2(6).EQ.2 )  ) THEN
           WRITE(GRPRSM,*) ' COMPLEX mismatch. KSEC4(4) = ', KSEC4(4)
           WRITE(GRPRSM,*) ' COMPLEX mismatch. KSEC2(6) = ', KSEC2(6)
           KRET = 807
           GOTO 900
        ELSEIF( ( KSEC4(4).EQ.64 ) .AND. ( KSEC2(6).NE.2 )  ) THEN

           WRITE(GRPRSM,*) ' COMPLEX mismatch. KSEC4(4) = ', KSEC4(4)
           WRITE(GRPRSM,*) ' COMPLEX mismatch. KSEC2(6) = ', KSEC2(6)
           KRET = 807
           GOTO 900
        ENDIF
      ELSEIF( LCOMPLX ) THEN
C
C         Truncation of full spectrum, which is supposed triangular,
C         has to be diagnosed. Define also sub-set truncation.
C
        IF (LENCODE) THEN
Ce
          ISUBSET = KSEC4(18)
Ce
Ce        When encoding, use the total number of data.
Ce
          ITEMP = KSEC4(1)
          ITRUNC= ( NINT ( SQRT ( REAL ( 4 * ITEMP + 1 ) ) ) - 3 ) / 2
Ce
        ELSE
Cd
Cd        When decoding, use section 4 descriptors.
Cd
          INSPT=INSPT+6*8
          CALL INXBIT(KGRIB,KLENG,INSPT,KSEC4(2),1,IBITS, 8,YFUNC,KRET)
          IF( KRET.NE.0) THEN
          KRET = 709
          WRITE(GRPRSM,*) 'GRIBEX: Error inserting/extracting number of'
          WRITE(GRPRSM,*) 'GRIBEX: bits per data value'
          WRITE(GRPRSM,*) 'GRIBEX: Return code = ', KRET
            GO TO 900
          ENDIF
Cd
          CALL INXBIT(KGRIB,KLENG,INSPT,ITEMP,1,IBITS,16,YFUNC,KRET)
          IF( KRET.NE.0) THEN
            KRET = 796
            WRITE(GRPRSM,*)
     X 'GRIBEX: Error extracting pointer to packed data.'
            WRITE(GRPRSM,*) 'GRIBEX: Return code = ', KRET
            GO TO 900
          ENDIF
Cd
          INSPT=INSPT+16
          CALL INXBIT(KGRIB,KLENG,INSPT,ISUBSET,1,IBITS, 8,YFUNC,KRET)
          IF( KRET.NE.0) THEN
            KRET = 797
            WRITE(GRPRSM,*)
     X 'GRIBEX: Error extracting sub-set truncation.'
            WRITE(GRPRSM,*) 'GRIBEX: Return code = ', KRET
            GO TO 900
          ENDIF
Cd
          IF (KSEC0(2).GE.1) THEN
            ITEMP = ILEN4 * 8 - INIL + (ITEMP-IPLEN/8) * 8
            ITEMP = ( ITEMP - 32 * ( ISUBSET + 1 ) * (ISUBSET + 2 ) )
     X               / KSEC4(2)
            ITRUNC= ( NINT ( SQRT ( REAL ( 4 * ITEMP + 1 ) ) ) - 3 ) / 2
          ELSE
            ITEMP = ILEN4 * 8 - INIL + (ITEMP-1) * 8
            ITEMP = ( ITEMP - 32 * ( ISUBSET + 1 ) ** 2 ) / KSEC4(2)
            ITRUNC= NINT ( SQRT ( REAL ( ITEMP ) ) ) - 1
          ENDIF
Cd
        ENDIF
C
        IF( LPDEBUG) WRITE(GRPRSM,*)
     X    'GRIBEX: diagnosed truncation of full spectrum is ', ITRUNC
C
      ELSE
        ISUBSET = 0
      ENDIF
C
C *******************************************
C
C     Handle complex packing of section 4.
C     (Avoid decoding of section 4 if 'I' or 'J' option)
C
      IF( LCOMPLX.AND.(.NOT.L_IORJ) ) THEN
C
C       Adjust bit pointer to start of section
        INSPT = IPLEN
C
        IF( LENCODE) THEN
C
C         Encoding ...
          KRET = CSECT4( PSEC4, ITRUNC, KSEC1, KSEC4,
     X                   KGRIB, KLENG, INSPT, IBITS, KSEC4(2))
        ELSE
C
C         Decoding ...
          KRET = DSECT4A( PSEC4, ITRUNC, KSEC0, KSEC1, KSEC4,
     X                   KGRIB, KLENG, INSPT, IBITS, KSEC4(2))
C
C         Special case when no.bits per packed value = no.bits per word
          IF( KRET .EQ. 16123 ) KRET = 205
        ENDIF
C
C       Give up if error reported.
        IF( KRET .NE. 0 ) GOTO 900
C
C       Got to deal with section 5 if OK.
        GOTO 799
      ENDIF
C
C *******************************************
C
C     Complex packing ("Second order packing") for grid point.
C
      IF( LGRDPT .AND. (KSEC4(4).NE.0.OR.HOPER.EQ.'K') ) THEN
C
        IF( LENCODE .AND. KSEC4(6).EQ.0 ) THEN
          KRET = 703
          WRITE(GRPRSM,*)
     X      'GRIBEX: Second-order packing implies additional flags'
          WRITE(GRPRSM,*) 'GRIBEX: Return code = ', KRET
          GO TO 900
        ELSEIF( HOPER.EQ.'G'.OR.HOPER.EQ.'A'.OR.HOPER.EQ.'B' ) THEN
          KRET = 704
          WRITE(GRPRSM,*) 'GRIBEX: Function ',HOPER,' invalid for'
          WRITE(GRPRSM,*)
     X  'GRIBEX: second-order packed field (grid-point).'
          WRITE(GRPRSM,*) 'GRIBEX: Return code = ', KRET
          GO TO 900
C
        ELSEIF( LDECODE ) THEN
Cd
Cd        Decoding ...
Cd
          INSPT=IPLEN
          KRET = D2ORDR( PSEC4, KLENP, KSEC1, KSEC2, KSEC3, KSEC4,
     X                   KGRIB, KLENG, INSPT, IBITS, HOPER, ILEN4,
     X                   INIL,  ZREF, ZSCALE, IBMAP, IVALS, NDBG )
Cd
Cd        Give up if error reported.
          IF( KRET .NE. 0 ) GOTO 900
Cd
Cd        At this stage, PSEC4 contains normalized INTEGER values.
Cd
          IFPT=0
          ILEN=KSEC4(1)
Cd
          IF( L_IORJ ) THEN
            KSEC4(34)=INSPT
Cd
Cjdc        IF( HOPER.EQ.'J' ) GOTO 815
            GOTO 900
          ELSE
            GOTO 796
          ENDIF
C
        ENDIF
C
C       Encoding is performed later, once the normalization of
C       field values into normalized integer values is performed.
C
      ENDIF
C
C*    Set IFPT to the number of data values stored in floating point
C     rather than packed format.
C     For simple packing of data in spherical harmonic
C     format the first word contains the real (0,0) coefficient,
C     which is treated separately. IFPT is 1 for spherical
C     harmonics, 0 for other data.
C
      IF( LGRDPT ) THEN
        IFPT = 0
      ELSE
        IFPT = 1
      ENDIF
C
C*    Octets 5 - 6 : Scale factor.
C     One 16 bit field.
C
C     Calculate scale factor, if coding data.
C
      IF( LENCODE ) THEN
Ce
Ce      Change units of data values , if required.
Ce
        IF( KSEC1(23).NE.0) THEN
          DO 720 JLOOP = 1 , ILENF
            PSEC4(JLOOP) = PSEC4(JLOOP)*(10.0**KSEC1(23))
  720     CONTINUE
        ENDIF
Ce
Ce      Find maximum and minimum values in data array, ignoring
Ce      any missing-data values, if secondary bit-maps are
Ce      indicated. Values not being packed are skipped.
Ce
        ILEN = ILENF - IFPT
Ce
        IF( KSEC4(8).EQ.64.AND.KSEC4(9).EQ.32) THEN
Ce
Ce        Secondary bit maps present.
Ce
          CALL MAXMN2 (PSEC4(IFPT+1),ILEN,ZMSVAL,ZMAX,ZMIN)
Ce
        ELSE
Ce
Ce        No secondary bit maps present.
Ce
          IF( HOPER.NE.'A' ) CALL MAXMIN(PSEC4(IFPT+1),ILEN,ZMAX,ZMIN)
Ce
        ENDIF
Ce
        IF( LPDEBUG ) THEN
          WRITE(GRPRSM,*) 'GRIBEX: Maximum value calculated = ', ZMAX
          WRITE(GRPRSM,*) 'GRIBEX: Minimum value calculated = ', ZMIN
        ENDIF
Ce
Ce      Calculate and pack scale factor.
Ce
Ce      If user has supplied a reference value, use it.
        IF( NFREF.EQ.1) THEN
          ZREF = FREF
Ce
Ce        If integer data being packed, ensure that
Ce        reference value represents an integer.
          IF(  KSEC4(5) .EQ. 32 ) THEN
#ifdef VAX
            ITEMP = JNINT(ZREF)
#else
            ITEMP = NINT(ZREF)
#endif
            ZREF  = REAL(ITEMP)
          ENDIF
Ce
Ce        Use user-supplied value unless it exceeds the minimum value.
Ce        Otherwise use the minimum value.
Ce
          IF( ZREF.GT.ZMIN) THEN
            WRITE(GRPRSM,*)
     X  'GRIBEX: User supplied reference value ',ZREF
            WRITE(GRPRSM,*) 'GRIBEX: exceeds minimum value ',ZMIN
            WRITE(GRPRSM,*) 'GRIBEX: Minimum value used instead.'
            ZREF = ZMIN
          ENDIF
Ce
        ELSE
          ZREF = ZMIN
        ENDIF
Ce
Ce      If user has supplied a maximum value, use it.
Ce
        IF( NFMAX.EQ.1) THEN
          ZMAXV = FMAX
Ce
Ce        If integer data being packed, ensure that
Ce        maximum value represents an integer.
          IF(  KSEC4(5) .EQ. 32 ) THEN
#ifdef VAX
            ITEMP = JNINT(ZMAXV)
#else
            ITEMP = NINT(ZMAXV)
#endif
            ZMAXV  = REAL(ITEMP)
          ENDIF
Ce
Ce        Use user-supplied value unless it is less than the maximum
Ce        value. Otherwise use the maximum value.
Ce
          IF( ZMAXV.LT.ZMAX) THEN
            WRITE(GRPRSM,*)
     X  'GRIBEX: User supplied maximum value ',ZMAXV
            WRITE(GRPRSM,*) 'GRIBEX: is less than maximum value ',ZMAX
            WRITE(GRPRSM,*) 'GRIBEX: Maximum value used instead.'
            ZMAXV = ZMAX
          ENDIF
Ce
        ELSE
          ZMAXV = ZMAX
        ENDIF
Ce
        IF( LPDEBUG ) THEN
          WRITE(GRPRSM,*) 'GRIBEX: Maximum value used = ', ZMAXV
          WRITE(GRPRSM,*) 'GRIBEX: Minimum value used = ', ZREF
        ENDIF
Ce
        IF( (HOPER .EQ. 'A') .OR. (HOPER .EQ. 'B') ) THEN
          ZREF = 0.0
          ZS = 0.0
          ISCALE = 0
          ZSCALE = 1.0
        ELSE
Ce
Ce        Before using reference value, convert floating point to GRIB
Ce        representation and come back with (possibly) adjusted value.
Ce
          ISTATUS = REF2GRB(ZREF, IEXP, IMANT, IBITS)
          IF( ISTATUS.NE.0 ) THEN
            WRITE(GRPRSM,*) 'GRIBEX: REF2GRB reference value problem'
            WRITE(GRPRSM,*) 'GRIBEX: for parameter ', KSEC1(6)
            WRITE(GRPRSM,*) 'GRIBEX: level type ', KSEC1(7)
            WRITE(GRPRSM,*) 'GRIBEX: level ', KSEC1(8), KSEC1(9)
          ENDIF

Ce
Ce        If KSEC4(2) is less than (IBITS-1), then IS is taken as the
Ce        largest integer that enables the following formula :
Ce
Ce        0 <= (ZMAXV-ZREF) / (2**IS) < 2**KSEC4(2)-0.5
Ce
Ce        (NINT of the ratio above is a positive integer that fits in
Ce         KSEC4(2) bits) ; this is equivalent to
Ce
Ce        2**(IS-1) <= (ZMAXV-ZREF) / (2**KSEC4(2)-0.5) < 2**IS
Ce        or :
Ce        2**IS     <= (ZMAXV-ZREF) / (2**(KSEC4(2)+1)-1) < 2**(IS+1)
Ce
Ce        Otherwise, the 0.5 is replaced by 1. to avoid any problem
Ce        with the numerical representation of a signed integer .
Ce
Cjdc      IF( LALLPOS) THEN
Cjdc        ZAUXIL = 1.
Cjdc        ZS = (ZMAXV-ZREF) / (2.**REAL(KSEC4(2))-1.)
Cjdc      ELSEIF( KSEC4(2).EQ.(IBITS-1) ) THEN
Cjdc        ZAUXIL = 1.
Cjdc        ZS = (ZMAXV-ZREF) / REAL(2**KSEC4(2)-1)
Cjdc      ELSE
Cjdc        ZAUXIL = 2.
Cjdc        ZS = (ZMAXV-ZREF) / REAL(2**(KSEC4(2)+1)-1)
Cjdc      ENDIF
Ce
#ifdef CRAY
Cjdc      IF( ZS.NE.0.0) ZS = ALOG(ZS) / ALOG(2.) + ZAUXIL
#else
Cjdc      IF( ZS.NE.0.0) ZS = LOG(ZS) / LOG(2.) + ZAUXIL
#endif
Cjdc      ISCALE = MIN (INT(ZS),INT(ZS+SIGN(1.,ZS)))
Cjdc
C
C         Adjust number of bits per value if full integer length to
C         avoid hitting most significant bit (sign bit).
C
          NBPV  = KSEC4(2)
          IF( NBPV.EQ.IBITS ) NBPV = NBPV - 1

C
C        Adjust the minumum value to be the scale factor in case the
C        scale factor coded cannot represent the minimun value (loss of precision)
C        This should be done before computing the range of the scale factor, as the
C        unpacking will be done
C        Using the reference value coded


          IF(ZMIN.NE.ZREF) THEN
            IF( LPDEBUG ) THEN
                 WRITE(GRPRSM,*)
     X  'GRIBEX: Minimum value rectified from ', ZMIN, ' to ', ZREF,
     X  'to match reference value precision'
            ENDIF
          ENDIF

C
C         Calculate the binary scaling factor to spread the range of
C         values over the number of bits per value.
C         Limit scaling to 2**-126 to 2**127 (using IEEE 32-bit floats
C         as a guideline).
C
          ZS = 1.0
          RANGE = (ZMAX-ZREF)

          IF( ABS(ZMAX-ZMIN).LT.JPEPSLN ) THEN
            ISCALE = 0
          ELSE IF( ABS(RANGE-1.0).LT.JPEPSLN ) THEN
            ISCALE = 1 - NBPV
          ELSE IF( RANGE.GT.1.0 ) THEN
            DO JLOOP = 1, 127
              ZS = 2.0 * ZS
              IF( ZS.GT.(RANGE+JPEPSLN) ) THEN
                ISCALE = JLOOP - NBPV
                GOTO 727
              ENDIF
            ENDDO
            WRITE(GRPRSM,*)
C
     X       'GRIBEX: Problem calculating binary scale value for encode'
            KRET = 707
            GOTO 900
C
  727       CONTINUE
          ELSE
            DO JLOOP = 1, 126
              ZS = ZS / 2.0
              IF( ZS.LT.(RANGE-JPEPSLN) ) THEN
                ISCALE = 1 - JLOOP - NBPV
                GOTO 728
              ENDIF
            ENDDO
C
            WRITE(GRPRSM,*)
     X       'GRIBEX: Problem calculating binary scale value for encode'
            KRET = 707
            GOTO 900
  728       CONTINUE
          ENDIF
C
#if (defined VAX) || (defined rs6000) || defined (__alpha) || defined hpR64
Cjdc      ISCALE = MIN (INT(ZS),INT(ZS+DSIGN(1.0D0,ZS)))
#else
Cjdc      ISCALE = MIN (INT(ZS),INT(ZS+SIGN(1.,ZS)))
#endif
Ce
Ce        Limit scale factor to head off problems of 'rogue' fields
Ce        which are flat except for one pimple value
Ce        (Is this still needed?)
Ce
          IF( ISCALE.LT.-99 ) THEN
            WRITE(GRPRSM,*)
     X  ' GRIBEX: scaling factor changed from ', ISCALE
            WRITE(GRPRSM,*)
     X  ' GRIBEX:                          to ', -99
            ISCALE = -99
          ENDIF
          IF( ISCALE.GT.99 ) THEN
            WRITE(GRPRSM,*)
     X  ' GRIBEX: scaling factor changed from ', ISCALE
            WRITE(GRPRSM,*)
     X  ' GRIBEX:                          to ',  99
            ISCALE =  99
          ENDIF
Ce
          ZSCALE = 2.**ISCALE
          IF( LPDEBUG ) THEN
            WRITE(GRPRSM,*) 'GRIBEX: Encoding ZMAX = ', ZMAX
            WRITE(GRPRSM,*) 'GRIBEX: Encoding ZREF = ', ZREF
            WRITE(GRPRSM,*) 'GRIBEX: Encoding RANGE = ', RANGE
            WRITE(GRPRSM,*)
     X  'GRIBEX: Encoding scaling value = ', ZSCALE
            WRITE(GRPRSM,*)
     X  'GRIBEX: Encoding scaling value = 2 to power ',
     X        ISCALE
          ENDIF
Ce
Ce        Set sign bit.
Ce
          ITEMP = ISCALE
          CALL CSGNBT( ISCALE, ITEMP, 16, KRET)
        ENDIF
Ce
Ce      Scale factor has all bits set to 1 for missing fields.
Ce      (ECMWF convention only).
Ce
        IF( IMISS.EQ.1) ISCALE = JP16SET
Ce
      ENDIF
C
C     Insert / extract field.
C
      CALL INXBIT(KGRIB,KLENG,INSPT,ISCALE,1,IBITS, 16,YFUNC,KRET)
      IF( KRET.NE.0) THEN
        KRET = 707
        WRITE(GRPRSM,*)
     X  'GRIBEX: Error inserting/extracting scale factor.'
        WRITE(GRPRSM,*) 'GRIBEX: Return code = ', KRET
        GO TO 900
      ENDIF
Cd
Cd    If decoding, set scale factor.
Cd
      IF( LDECODE ) THEN
        ISKALE = ISCALE
        CALL DSGNBT( ISCALE, ISKALE, 16, KRET)
Cd
Cd      Limit scale factor to head off problems of 'rogue' fields
Cd      which are flat except for one pimple value
        IF( ISCALE .LT. -99 ) THEN
          WRITE(GRPRSM,*)
     X  ' GRIBEX: scaling factor changed from ', ISCALE
          WRITE(GRPRSM,*)
     X  ' GRIBEX:                          to ', -99
          ISCALE = -99
        ENDIF
        IF( ISCALE .GT.  99 ) THEN
          WRITE(GRPRSM,*)
     X  ' GRIBEX: scaling factor changed from ', ISCALE
          WRITE(GRPRSM,*)
     X  ' GRIBEX:                          to ',  99
          ISCALE =  99
        ENDIF
Cd
        ZSCALE = 2.**ISCALE
C
        IF( LPDEBUG ) THEN
          WRITE(GRPRSM,*)
     X  'GRIBEX: Decoding scaling value = ', ZSCALE
          WRITE(GRPRSM,*)
     X  'GRIBEX: Decoding scaling value = 2 to power ',
     X      ISCALE
        ENDIF
      ENDIF
C
C*    Octets 7 - 10 : Reference value.
C     One 8 bit and one 24 bit field.
C
      IF( LENCODE ) THEN
Ce
        IF( IMISS.EQ.1) THEN
Ce
Ce        For missing, these data fields are set to all 1 bits.
          IEXP   = JP8SET
          IMANT  = JP24SET
        ENDIF
Ce
      ENDIF
C
C     Insert / extract fields.
C
      CALL INXBIT(KGRIB,KLENG,INSPT,IEXP,1,IBITS, 8,YFUNC,KRETA)
      CALL INXBIT(KGRIB,KLENG,INSPT,IMANT,1,IBITS, 24,YFUNC,KRETB)
      KRET = KRETA + KRETB
      IF( KRET.NE.0) THEN
        KRET = 708
        WRITE(GRPRSM,*)
     X  'GRIBEX: Error inserting/extracting reference value'
        WRITE(GRPRSM,*) 'GRIBEX: Return code = ', KRET
        GO TO 900
      ENDIF
C
C     Conversion from GRIB format, if decoding.
C
      IF( LDECODE ) THEN
Cd
Cd      Set IMISS to 1 if entire field is missing, i.e. scale
Cd      factor, exponent and mantissa with all bits set to 1.
Cd
        IMISS = 0
        IF( ISKALE.EQ.JP16SET.AND.IEXP.EQ.JP8SET.AND.IMANT.EQ.JP24SET)
     X    IMISS = 1
Cd
Cd      Convert GRIB representation to floating point.
Cd
        IF( IMISS.EQ.0) THEN
Cd
Cd        Field is present.
          CALL DECFP2 (ZREF,IEXP,IMANT)
        ELSE
Cd
Cd        Field is missing. Print warning message and
Cd        field identification sections of Grib code,
Cd        forcing field data values to 0.
Cd
          WRITE(GRPRSM,*)
     X  'GRIBEX: Following field is missing ***********'
          CALL GRPRS1 (KSEC0,KSEC1)
          ZREF   = 0
          ZSCALE = 0
        ENDIF
        IF( LPDEBUG ) WRITE(GRPRSM,*)
     X    'GRIBEX: Decoded reference value = ',ZREF
      ENDIF
Cd
C*    Octet 11 : Number of bits containing each packed value.
C     One 8 bit field.
C
C     Insert / extract field.
C
      IF( .NOT.LGRDPT.OR.KSEC4(4).EQ.0) THEN
        CALL INXBIT(KGRIB,KLENG,INSPT,KSEC4(2),1,IBITS, 8,YFUNC,KRET)
        IF( KRET.NE.0) THEN
          KRET = 709
          WRITE(GRPRSM,*)
     X  'GRIBEX: Error inserting/extracting number of'
          WRITE(GRPRSM,*) 'GRIBEX: bits per data value'
          WRITE(GRPRSM,*) 'GRIBEX: Return code = ', KRET
          GO TO 900
        ENDIF
C
      ELSE
C
C        In second-order packing case, this number may differ from
C        the value specified for normalization process (KSEC4(2)).
C        Field is inserted later, within function C2ORDR or related
C        C2* sub-functions.
C
        INSPT=INSPT+8
C
      ENDIF
C
      IF( LDECODE ) THEN
Cd
Cd      Check if number of bits per packed value = number of bits per
Cd      computer word.
Cd
        LALLPOS = KSEC4(2) .EQ. IBITS
Cd
      ENDIF
C
C*    Octets 12 et sequentia can contain further header
C     information, depending on data representation type.
C
C
C*    For grid point data, simple packing, single value at each
C     grid point there is no further header information and
C     packed data begins in octet 12.
C
C*    For grid point data, simple packing, with a matrix of
C     values at each grid point further information is added.
C
      IF( LGRDPT .AND.KSEC4(6).EQ.16.AND.KSEC4(4).EQ.0) THEN
C
C       Octets 12 - 13. N - octet number at which packed
C       data begins.
C       One 16 bit field.
C
C            !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
C            !                                                !
C            ! This is the WMO definition, but it is entirely !
C            ! inadequate when secondary bit maps are present !
C            ! eg 3x3 global grid with a matrix of values     !
C            ! 12x26 at each point. This gives a bit map with !
C            ! a length of 285480 octets which cannot be given!
C            ! in 16 bits.                                    !
C            !                                                !
C            ! ECMWF uses the following definition  for its   !
C            ! wave model data.                               !
C            ! N - Number of secondary bit maps               !
C            !     (ie the number of points which are 'not    !
C            !      missing').                                !
C            !     This definition will accommodate a 1x1     !
C            !     degree global grid.                        !
C            !                                                !
C            !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
C
        IF( LENCODE ) THEN
Ce
Ce        Octet number = 25 + NC1 + NC2
Ce
          IBYTEX = 25 + KSEC4(53) + KSEC4(55)
Ce
Ce        Add in length of bit-maps, if present.
Ce        Length in bits is the number of values
Ce        remaining to be packed rounded
Ce        up to a number of octets.
Ce
          IF( KSEC4(9).EQ.32) IBYTEX = IBYTEX + (ILENF+7) / 8
Ce
Ce        ECMWF wave model usage.
Ce        ECMWF is centre number 98, and local code table
Ce        2 used for wave models is 140.
Ce
          IF( LECLOC .AND.KSEC1(1).EQ.140) THEN
            IBYTEX = ILENF / (KSEC4(50) * KSEC4(51))
          ENDIF
        ENDIF
C
C       Insert / extract fields.
C
        CALL INXBIT(KGRIB,KLENG,INSPT,IBYTEX,1,IBITS, 16,YFUNC,KRET)
        IF( KRET.NE.0) THEN
          KRET = 720
          WRITE(GRPRSM,*)
     X  'GRIBEX: Error inserting/extracting octet number'
          WRITE(GRPRSM,*) 'GRIBEX: at which packed data begins'
          WRITE(GRPRSM,*) 'GRIBEX: Return code = ', KRET
          GO TO 900
        ENDIF
C
C       Special fix to handle overflow of this 16-bit field when
C       a large wave field is being decoded
C
        IF( LLARGE .AND. (IBYTEX.LT.2000) ) IBYTEX = IBYTEX + 65536
C
C       Octet 14. Extended flags.
C       One 8 bit field.
C
        IF( LENCODE ) IFLAGX = KSEC4(8) + KSEC4(9) + KSEC4(10)
C
C       Insert / extract fields.
C
        CALL INXBIT(KGRIB,KLENG,INSPT,IFLAGX,1,IBITS, 8,YFUNC,KRET)
        IF( KRET.NE.0) THEN
          KRET = 721
          WRITE(GRPRSM,*)
     X      'GRIBEX: Error inserting/extracting extended flag field'
          WRITE(GRPRSM,*) 'GRIBEX: Return code = ', KRET
          GO TO 900
        ENDIF
C
        IF( LDECODE ) THEN
Cd
Cd        In Edition 1 only 3 bits are used.
Cd
Cd        -0------ for single datum at each grid point.
Cd        -1------ for matrix of values at each point.
Cd        --0----- for no secondary bit-maps.
Cd        --1----- for secondary bit-maps present.
Cd        ---0---- for second order values constant width.
Cd        ---1---- for second order values different widths.
Cd
          IF( IFLAGX.GE.64) THEN
            KSEC4(8) = 64
            IFLAGX   = IFLAGX - 64
          ENDIF
Cd
          IF( IFLAGX.GE.32) THEN
            KSEC4(9) = 32
            IFLAGX   = IFLAGX - 32
          ENDIF
Cd
          IF( IFLAGX.GE.16) THEN
            KSEC4(10) = 16
            IFLAGX   = IFLAGX - 16
          ENDIF
        ENDIF
C
C       Octets 15 - 16. NR - first dimension (rows) of
C       each matrix.
C       Octets 17 - 18. NC - second dimension (columns) of
C       each matrix.
C       Two 16 bit fields.
C
C       Insert / extract fields.
C
        CALL INXBIT(KGRIB,KLENG,INSPT,KSEC4(50),2,IBITS, 16,YFUNC,KRET)
        IF( KRET.NE.0) THEN
          KRET = 722
          WRITE(GRPRSM,*) 'GRIBEX: Error inserting/extracting first or'
          WRITE(GRPRSM,*) 'GRIBEX: second dimension of matrix'
          WRITE(GRPRSM,*) 'GRIBEX: Return code = ', KRET
          GO TO 900
        ENDIF
C
C       Octet 19. First dimension coordinate values
C       definition.
C       Octet 20. NC1 - Number of coefficients or values
C       used to specify first dimension coordinate function.
C       Octet 21. Second dimension coordinate values
C       definition.
C       Octet 22. NC2 - Number of coefficients or values
C       used to specify second dimension coordinate function.
C       Octet 23. First dimension physical significance.
C       Octet 24. Second dimension physical significance.
C       Six 8 bit fields.
C
C       Insert / extract fields.
C
        CALL INXBIT(KGRIB,KLENG,INSPT,KSEC4(52),6,IBITS, 8,YFUNC,KRET)
        IF( KRET.NE.0) THEN
          KRET = 723
          WRITE(GRPRSM,*)
     X  'GRIBEX: Error inserting/extracting six fields'
          WRITE(GRPRSM,*)
     X  'GRIBEX: from 1st dimension coordinate value on'
          WRITE(GRPRSM,*) 'GRIBEX: Return code = ', KRET
          GO TO 900
        ENDIF
C
C       Octets 25 - (24+NC1).
C       Coefficients to define first dimension coordinate
C       values in functional form, or the explicit
C       coordinate values.
C       Octets (25+NC1) - (24+NC1+NC2).
C       Coefficients to define second dimension coordinate
C       values in functional form, or the explicit
C       coordinate values.
C       (NC1+NC2) 8 bit fields.
C
C            !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
C            !                                                !
C            ! This is the WMO definition, but it is very     !
C            ! limited and can only accommodate small integer !
C            ! fields values.                                 !
C            !                                                !
C            ! ECMWF needs to use floating point numbers and  !
C            ! for the wave models the definition is NC1+NC2  !
C            ! (8 bit and 24 bit) fields.
C            !                                                !
C            !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
C
        ITEMP = KSEC4(53) + KSEC4(55)
C
C       ECMWF wave model usage.
C       ECMWF is centre number 98, and local code table
C       2 used for wave models is 140.
C
        IF( LECLOC .AND.KSEC1(1).EQ.140) THEN
          ITRND = 1
          DO 730 JLOOP=1,ITEMP
C
C           One 8 bit and one 24 bit field.
C
            IF( LENCODE ) THEN
Ce
Ce            Convert floating point to GRIB representation.
              ISINT = KSEC4(JLOOP+59)
              ZREAL = ZREAL4
              CALL CONFP3 (ZREAL,IEXP,IMANT, IBITS,ITRND)
            ENDIF
C
C           Insert / extract fields.
C
            CALL INXBIT(KGRIB,KLENG,INSPT,IEXP,1,IBITS, 8,YFUNC,KRETA)
            CALL INXBIT(KGRIB,KLENG,INSPT,IMANT,1,IBITS,24,YFUNC,KRETB)
            KRET = KRETA + KRETB
            IF( KRET.NE.0) THEN
              KRET = 724
              WRITE(GRPRSM,*)
     X  'GRIBEX: Error inserting/extracting first or'
              WRITE(GRPRSM,*)
     X  'GRIBEX: second dimension coefficients'
              WRITE(GRPRSM,*) 'GRIBEX: Return code = ', KRET
              GO TO 900
            ENDIF
C
            IF( LDECODE ) THEN
Cd
Cd            Convert GRIB representation to floating point.
              CALL DECFP2 (ZREAL,IEXP,IMANT)
              ZREAL4 = ZREAL
              KSEC4(JLOOP+59) = ISINT
            ENDIF
C
  730     CONTINUE
        ELSE
C
C         Insert / extract fields.
C
          CALL INXBIT(KGRIB,KLENG,INSPT,KSEC4(57),ITEMP,
     X                 IBITS,8,YFUNC,KRET)
          IF( KRET.NE.0) THEN
            KRET = 724
            WRITE(GRPRSM,*)
     X  'GRIBEX: Error inserting/extracting first or'
            WRITE(GRPRSM,*) 'GRIBEX: second dimension coefficients'
            WRITE(GRPRSM,*) 'GRIBEX: Return code = ', KRET
            GO TO 900
          ENDIF
        ENDIF
C
C       Matrix bit-maps may follow.
C
        IF( KSEC4(9).EQ.32) THEN
          ITEMP = KSEC4(50) * KSEC4(51)
          IF( LENCODE ) THEN
            CALL INSMP2 (KGRIB,KLENG,INSPT,PSEC4,
     X                   ILENF,IBITS,ZMSVAL,YFUNC,
     X                   ITEMP,NDBG,KRET)
            IF( KRET.NE.0) THEN
              KRET = 725
              WRITE(GRPRSM,*)
     X  'GRIBEX: Error inserting secondary bit-map'
              WRITE(GRPRSM,*) 'GRIBEX: Return code = ', KRET
              GO TO 900
            ENDIF
            ILEN = ILENF
          ELSE
Cd
Cd          Retain pointer to bit-map location.
            IBMAP2 = INSPT
Cd
Cd          Set pointer to start of packed data.
Cd
            IF( LECLOC .AND.KSEC1(1).EQ.140) THEN
              ITEMP = KSEC4(50)*KSEC4(51)*IBYTEX
              ITEMP = (ITEMP+7) / 8
              INSPT = INSPT + ITEMP * 8
            ELSE
              INSPT = INSPT + (IBYTEX-25-KSEC4(53) -KSEC4(55)) * 8
            ENDIF
C
          ENDIF
        ENDIF
C
      ENDIF
C
C*    For spherical harmonic data (simple packing), real (0,0)
C     coefficient is in floating point representation in
C     octets 12-15.
C     One 8 bit and one 24 bit field.
C
      IF( LSPHERC ) THEN
C
C       Convert floating point to GRIB representation.
        ITRND = 1
        IF( LENCODE ) CALL CONFP3 (PSEC4(1),IEXP,IMANT,IBITS,ITRND)
C
C       Insert / extract fields.
C
        CALL INXBIT(KGRIB,KLENG,INSPT,IEXP,1,IBITS, 8,YFUNC,KRETA)
        CALL INXBIT(KGRIB,KLENG,INSPT,IMANT,1,IBITS, 24,YFUNC,KRETB)
        KRET = KRETA + KRETB
        IF( KRET.NE.0) THEN
          KRET = 711
          WRITE(GRPRSM,*)
     X      'GRIBEX: Error inserting/extracting real coefficient'
          WRITE(GRPRSM,*) 'GRIBEX: Return code = ', KRET
          GO TO 900
        ENDIF
C
        IF( LDECODE .AND. (.NOT. L_IORJ) ) THEN
Cd
Cd        Convert GRIB representation to floating point.
Cd
          IF( IMISS.EQ.1) THEN
            PSEC4(1) = 0.0
          ELSE
            CALL DECFP2 (PSEC4(1),IEXP,IMANT)
          ENDIF
        ENDIF
      ENDIF
C
C*    Octet N onwards - Packed data.
C
C     If decoding , calculate number of data values, unless
C     number has been given by user for 'X' function.
C
      IF( LDECODE ) THEN
        IF( HOPER.EQ.'X') THEN
          ILEN = KSEC4(34)
Cdx
Cdx     Otherwise, use the byte counts
        ELSEIF( KSEC4(2).NE.0) THEN
          ILEN = (IPLEN+(ILEN4*8)-INSPT-INIL)/KSEC4(2)
Cd
Cd      If explicitly constant field, use section 2 information
Cd
        ELSEIF( .NOT.LSECT2 ) THEN
          KRET = 726
          WRITE(GRPRSM,*)
     X  'GRIBEX: Constant (0-bit) field without section 2'
          WRITE(GRPRSM,*) 'GRIBEX: not supported'
          WRITE(GRPRSM,*) 'GRIBEX: Return code = ', KRET
          GO TO 900
        ELSEIF( LSPHERC ) THEN
          KRET = 727
          WRITE(GRPRSM,*) 'GRIBEX: Constant (0-bit) spectral field'
          WRITE(GRPRSM,*) 'GRIBEX: not supported'
          WRITE(GRPRSM,*) 'GRIBEX: Return code = ', KRET
          GO TO 900
        ELSEIF( HOPER.EQ.'G'.OR.HOPER.EQ.'B') THEN
          KRET = 728
          WRITE(GRPRSM,*)
     X      'GRIBEX: Constant (0-bit) field: function ',HOPER(:1)
          WRITE(GRPRSM,*) 'not supported'
          WRITE(GRPRSM,*) 'GRIBEX: Return code = ', KRET
          GO TO 900
        ELSEIF( LQUASI ) THEN
Cd
          IF( MOD(KSEC2(11),64).LT.32) THEN
            INROWS=KSEC2(3)
          ELSE
            INROWS=KSEC2(2)
          ENDIF
Cd
          ILEN=0
Cd
          DO 740 JLOOP = 1 , INROWS
            ILEN=ILEN+KSEC2(22+JLOOP)
  740     CONTINUE
Cd
        ELSE
          ILEN=KSEC2(2)*KSEC2(3)
        ENDIF
Cd
Cd      Total number of values = packed + unpacked.
Cd
        IF( HOPER .EQ. 'B' ) THEN
          KSEC4(1) = (ILEN+NBYTE-1)/NBYTE
          KSEC4(21) = ILEN
Cd
        ELSE
          KSEC4(1) = ILEN + IFPT
        ENDIF
Cd
Cd      Check length of output array.
Cd
        IF( (KSEC4(1).GT.KLENP) .AND.
     X       (HOPER.NE.'G')      .AND.
     X       (HOPER.NE.'J')    ) THEN
          KRET = 710
          WRITE(GRPRSM,*)
     X  'GRIBEX: Output array too small. Length = ',KLENP
          WRITE(GRPRSM,*) 'GRIBEX: Number of values = ', KSEC4(1)
          WRITE(GRPRSM,*) 'GRIBEX: Return code = ', KRET
          GO TO 900
        ENDIF
Cd
        IF( KSEC4(2).EQ.0) THEN
C
          IF( LPDEBUG ) WRITE(GRPRSM,*)
     X      'GRIBEX: Explicitly constant field (0-bit).'
C
C          Explicitly constant field, filled directly.
C
          IF( HOPER.NE.'J') THEN
C
            IF( KSEC1(23).EQ.0) THEN
              ZVAL = ZREF
            ELSE
              ZVAL = ZREF / 10.**KSEC1(23)
            ENDIF
C
            DO 750 JLOOP = 1 , ILEN
              PSEC4(IFPT+JLOOP) = ZVAL
  750       CONTINUE
C
          ENDIF
C
Cx        Option 'X', only a few points extracted.
Cx
          IF( HOPER.EQ.'X') THEN
Cx
Cx          Convert to integer if original data was integer.
Cx
            IF( KSEC4(5).EQ.32 ) CALL RORINT(PSEC4,PSEC4,KSEC4(1),'I')
            GO TO 900
Cx
          ENDIF
C
          GOTO 800
C
        ENDIF
C
      ENDIF
C
C
C*    Scale and store, or extract and scale data values.
C
C     Only a few points to be unpacked.
C
      IF( HOPER.EQ.'X') THEN
Cx
Cx      Check that a section 2 is present.
Cx
        IF( .NOT.LSECT2 ) THEN
          KRET = 798
          WRITE(GRPRSM,*)
     X  'GRIBEX: Function is X but no section 2 included'
          WRITE(GRPRSM,*) 'GRIBEX: Return code = ', KRET
          GO TO 900
        ENDIF
Cx
Cx      Check that no bit-map is included.
Cx
        IF( LSECT3 ) THEN
          KRET = 717
          WRITE(GRPRSM,*)
     X  'GRIBEX: Function is X and a bit-map is included'
          WRITE(GRPRSM,*) 'GRIBEX: Return code = ', KRET
          GO TO 900
        ENDIF
Cx
Cx      Check that field is Gaussian or latitude/longitude grid.
Cx
        IF( KSEC2(1).NE.0.AND.KSEC2(1).NE.4.AND.
     X      KSEC2(1).NE.10.AND.KSEC2(1).NE.14.AND.
     X      KSEC2(1).NE.20.AND.KSEC2(1).NE.24.AND.
     X      KSEC2(1).NE.30.AND.KSEC2(1).NE.34) THEN
          KRET = 716
          WRITE(GRPRSM,*) 'GRIBEX: Function is X and field is not'
          WRITE(GRPRSM,*)
     X  'GRIBEX: Gaussian or Latitude/longitude field'
          WRITE(GRPRSM,*) 'GRIBEX: Return code = ', KRET
          GO TO 900
        ENDIF
Cx
Cx      Check that scanning mode is West to East and North to South.
Cx
        IF( KSEC2(11).NE.0) THEN
          KRET = 715
          WRITE(GRPRSM,*)
     X  'GRIBEX: Function is X and scanning mode is not'
          WRITE(GRPRSM,*) 'GRIBEX: North to South and West to East'
          WRITE(GRPRSM,*) 'GRIBEX: Return code = ', KRET
          GO TO 900
        ENDIF
Cx
Cx      Check that number of points required does not exceed
Cx      maximum or minimum allowed.
Cx
        IF( KSEC4(34).GT.4.OR.KSEC4(34).LT.1) THEN
          KRET = 714
          WRITE(GRPRSM,*)
     X      'GRIBEX: Invalid no. of values for function X = ',KSEC4(34)
          WRITE(GRPRSM,*) 'GRIBEX: Return code = ', KRET
          GO TO 900
        ENDIF
Cx
        ITEMP = 1
Cx
Cx      Take into account decimal scaling factor, if any.
Cx
        IF( KSEC1(23).NE.0) THEN
          ZREF = ZREF / 10.**KSEC1(23)
          ZSCALE = ZSCALE / 10.**KSEC1(23)
        ENDIF
Cx
Cx      Skip down latitude rows.
        DO 770 JLOOPO = 1,KSEC4(34)
Cx
Cx        Regular grid.
          IF( .NOT. LQUASI) THEN
            ISKIP = (KSEC4(34+ITEMP)-1) * KSEC2(2)
Cx
Cx        Quasi-regular grid.
          ELSE
            ISKIP = 0
            DO 760 JLOOP = 1,KSEC4(34+ITEMP) - 1
              ISKIP = ISKIP + KSEC2(22+JLOOP)
  760       CONTINUE
          ENDIF
Cx
Cx        Skip any points not required on this latitude row.
          ISKIP = ISKIP + KSEC4(34+ITEMP+1) - 1
Cx
Cx        Calculate number of bits in these values and add
Cx        to current value of bit-pointer.
          ISKIP = ISKIP * KSEC4(2) + INSPT
Cx
Cx        Extract value from 1 point.
          CALL INXBIT(KGRIB,KLENG,ISKIP,IJDC,1,
     X                IBITS,KSEC4(2),YFUNC,KRET)
          IF( KRET.NE.0) THEN
            KRET = 712
            WRITE(GRPRSM,*) 'GRIBEX: Error extracting data values'
            WRITE(GRPRSM,*) 'GRIBEX: Return code = ', KRET
            GO TO 900
          ENDIF
          IJDCXX = IJDC
Cx
          IF( KSEC4(5).EQ.32 ) THEN
Cx
Cx          Integer values
Cx
#if (defined REAL_BIGGER_THAN_INTEGER)
            PSEC4(JLOOPO) = ZREF + DBLE(IJDCXX)*ZSCALE
#else
            PSEC4(JLOOPO) = ZREF + IJDCXX*ZSCALE
#endif
            IJDCXX = PSEC4(JLOOPO)
            PSEC4(JLOOPO) = RJDCXX
Cx
          ELSE
Cx
Cx          Real values
Cx
#if (defined REAL_BIGGER_THAN_INTEGER)
            PSEC4(JLOOPO) = ZREF + DBLE(IJDCXX)*ZSCALE
#else
            PSEC4(JLOOPO) = ZREF + IJDCXX*ZSCALE
#endif
          ENDIF
          ITEMP = ITEMP + 2
  770   CONTINUE
Cx
        GOTO 900
      ENDIF
C
C*******************************************************************
C     All data to be unpacked or packed.
C*******************************************************************
C
C     Scale the fields using the reference value and scaling factor
C
      IF( LENCODE .AND. (HOPER .NE. 'A')  )
     X  CALL INSCAL(PSEC4(IFPT+1),PSEC4(IFPT+1),ILEN,ZREF,ZSCALE,NBPV)
C
C     Insert / extract fields, unless special 'G' operation or
C     if 'J' option in effect.
C
      IF( LENCODE.AND.LGRDPT.AND.(KSEC4(4).NE.0.OR.HOPER.EQ.'K')) THEN
Ce
Ce*******************************************
Ce
Ce      Complex packing ("second-order packing") for grid-point.
Ce
        INSPT=INSPT-11*8
        KRET = C2ORDR( PSEC4, KLENP, KSEC1, KSEC2, KSEC3, KSEC4,
     X                 KGRIB, KLENG, INSPT, IBITS, HOPER, IBMAP,
     X                 IVALS, ZREF,  ZMAX,  ILEN,  NDBG )
Ce
Ce      Give up if error reported.
        IF( KRET .NE. 0 ) GOTO 900
Ce
C
      ELSEIF( (HOPER.NE.'G') .AND. (.NOT.L_IORJ) ) THEN
Cd
#ifdef REAL_BIGGER_THAN_INTEGER
        IF( LDECODE .AND. (HOPER.NE.'B') ) THEN
Cd
Cd        Split the values into groups of length 'JPNSEC4' (maximum)
Cd
          ILOOPS = 1+(ILEN-1)/JPNSEC4
          IINDEX = IFPT
Cd
          DO 785 JLOOPO = 1, ILOOPS
            ILNGTH = MIN(JPNSEC4,ILEN-(JLOOPO-1)*JPNSEC4)
            CALL INXBIT(KGRIB,KLENG,INSPT,NSEC4,ILNGTH,
     X                   IBITS,KSEC4(2),YFUNC,KRET)
            IF( KRET.NE.0) THEN
              KRET = 712
              WRITE(GRPRSM,*) 'GRIBEX: Error extracting data values'
              WRITE(GRPRSM,*) 'GRIBEX: Return code = ', KRET
              GO TO 900
            ENDIF
            DO 780 JLOOP = 1, ILNGTH
              PSEC4(IINDEX + JLOOP) = ZREF + NSEC4(JLOOP)*ZSCALE
  780       CONTINUE
            IINDEX = IINDEX + ILNGTH
  785     CONTINUE
Cd
Cd        Change units of data values, if required.
Cd
          IF( KSEC1(23).NE.0) THEN
            DO 790 JLOOP = 1 , KSEC4(1)
              PSEC4(JLOOP) = PSEC4(JLOOP)/10.0**KSEC1(23)
  790       CONTINUE
          ENDIF
          GOTO 799
        ENDIF
Cb
Cb      Handle data for option 'B'
Cb
        IF( HOPER.EQ.'B' ) THEN
Cb
          ILOOPS = 1+(ILEN/NBYTE-1)/JPNSEC4
          IINDEX = IFPT
Cb
          DO 794 JLOOPO = 1, ILOOPS
            ILNGTH = MIN(JPNSEC4,ILEN-(JLOOPO-1)*JPNSEC4)
            CALL INXBIT(KGRIB,KLENG,INSPT,NSEC4,ILNGTH,
     X                  IBITS,KSEC4(2),YFUNC,KRET)
            IF( KRET.NE.0) THEN
              KRET = 712
              WRITE(GRPRSM,*) 'GRIBEX: Error extracting data values'
              WRITE(GRPRSM,*) 'GRIBEX: Return code = ', KRET
              GO TO 900
            ENDIF
Cb
            DO 792 JLOOP = 1, ILNGTH
              PSEC4(IINDEX + JLOOP) = XSEC4(JLOOP)
  792       CONTINUE
Cb
            IINDEX = IINDEX + ILNGTH
  794     CONTINUE
Cb
          GOTO 799
Cb
        ENDIF
#endif
C
        IF( (HOPER.NE.'A') .AND. (HOPER.NE.'B') ) THEN
          CALL INXBIT( KGRIB,KLENG,INSPT,PSEC4(IFPT+1),ILEN,
     X                 IBITS,KSEC4(2),YFUNC,KRET)
        ELSE
          CALL INXBIT( KGRIB,KLENG,INSPT,PSEC4(IFPT+1),ILEN/NBYTE,
     X                 IBITS,IBITS,YFUNC,KRET)
        ENDIF
        IF( KRET.NE.0) THEN
          KRET = 712
          WRITE(GRPRSM,*)
     X  'GRIBEX: Error inserting/extracting data values'
          WRITE(GRPRSM,*) 'GRIBEX: Return code = ', KRET
          GO TO 900
        ENDIF
C
       ELSE
C
Cgj     Option 'G' or 'J' in effect.
Cgj
        KSEC4(34) = INSPT
C
        IF( .NOT. L_IORJ ) THEN
Cg
Cg        Option 'G' ...
Cg
Cg        Return reference value, binary scale factor and
Cg        bit pointer to start of packed data.
C
          PSEC4(1) = ZREF
          PSEC4(2) = ZSCALE
        ENDIF
Cj
        IF( HOPER.EQ.'J' ) GOTO 815
Cj
        GO TO 900
Cd
      ENDIF
C
  796 CONTINUE
C
      IF( LDECODE .AND. (HOPER .NE. 'B') ) THEN
Cd
       CALL EXSCAL(PSEC4(IFPT+1),PSEC4(IFPT+1),ILEN,ZREF,ZSCALE,LALLPOS)
Cd
Cd      Change units of data values, if required.
Cd
        IF( KSEC1(23).NE.0) THEN
          DO 798 JLOOP = 1 , KSEC4(1)
            PSEC4(JLOOP) = PSEC4(JLOOP)/10.0**KSEC1(23)
  798     CONTINUE
        ENDIF
Cd
      ENDIF
C
 799  CONTINUE
C
C*    Enter length of binary data section, ensuring that the
C     length is an even number of octets, padding with binary
C     zeroes as required.
C     One 24 bit field.
C
      IF( YFUNC.NE.'C') GO TO 800
Ce
Ce    Length of section 4, in bits.
Ce
      ILEN4 = INSPT - IPLEN
      IL    = ILEN4 / 16
      IL    = ILEN4 - ( IL * 16 )
      INIL  = 0
      IF( IL.NE.0) THEN
        INIL = 16 - IL
Ce
Ce      Insert padding zeroes at end of section 4
Ce
        ITEMP = 0
        CALL INXBIT(KGRIB,KLENG,INSPT,ITEMP,1,IBITS,INIL,YFUNC,KRET)
        IF( KRET.NE.0) THEN
          KRET = 734
          WRITE(GRPRSM,*)
     X      'GRIBEX: Error inserting padding zeroes at end of section 4'
          WRITE(GRPRSM,*) 'GRIBEX: Return code = ',KRET
          GO TO 900
        ENDIF
        ILEN4 = ILEN4 + INIL
      ENDIF
Ce
      ILEN4 = ILEN4 / 8
Ce
Ce    Because of the restriction on product lengths to 3 octets,
Ce    if a very large product, the section 4 length field holds
Ce    the number of bytes in the product after section 4 upto
Ce    the end of the padding bytes.
Ce    This is only feasible because the (default) rounding for
Ce    GRIB products is 120 bytes.
Ce    In this case, delay encoding the value until section 5 has
Ce    been encoded.
Ce
      IF( ILEN4.GE.JP23SET ) THEN
        LLARGE = .TRUE.
        IPLEN = IPLEN + 24
      ELSE
Ce
Ce      Insert field.
        CALL INXBIT(KGRIB,KLENG,IPLEN,ILEN4,1,IBITS, 24,YFUNC,KRET)
        IF( KRET.NE.0) THEN
          KRET = 701
          WRITE(GRPRSM,*) 'GRIBEX: Error inserting section 4 length'
          WRITE(GRPRSM,*) 'GRIBEX: Return code = ', KRET
                 GO TO 900
        ENDIF
      ENDIF
Ce
Ce    Enter flag / unused bits field.
Ce    One 8 bit field.
Ce    Two 4 bit fields.
Ce
      IFLAG = KSEC4(3) + KSEC4(4) + KSEC4(5) + KSEC4(6)
      IFLAG = IFLAG + INIL
Ce
Ce    Print number of unused bits, if required.
      IF( LPDEBUG ) WRITE(GRPRSM,*)
     X  'GRIBEX: Number of unused bits is ',INIL,'.'
Ce
Ce    Insert field.
      CALL INXBIT(KGRIB,KLENG,IPLEN,IFLAG,1,IBITS, 8,YFUNC,KRET)
      IF( KRET.NE.0) THEN
        KRET = 713
        WRITE(GRPRSM,*)
     X    'GRIBEX: Error inserting/extracting flag and unused bit field'
        WRITE(GRPRSM,*) 'GRIBEX: Return code = ', KRET
        GO TO 900
      ENDIF
C
C     -----------------------------------------------------------------|
C
C
C
C
C
C
C
C
C
C
C*    Section 8 . Code/decode End Section (Section 5) of GRIB code.
C     -----------------------------------------------------------------|
C
  800 CONTINUE
C
      IF( LPDEBUG ) WRITE(GRPRSM,*)
     X  'GRIBEX: Section 8. Handle End Section (Section 5)'
C
C*    Ascii 7 7 7 7 at end of coded data.
C     Four 8 bit fields.
C
      IF( LENCODE ) THEN
Ce
Ce      Insert field.
        IP7777 = INSPT
        CALL INXBIT(KGRIB,KLENG,INSPT,I7777(1),4,IBITS, 8,YFUNC,KRET)
        IF( KRET.NE.0) THEN
          KRET = 801
          WRITE(GRPRSM,*) 'GRIBEX: Error inserting 7777 group'
          WRITE(GRPRSM,*) 'GRIBEX: Return code = ',KRET
          GO TO 900
        ENDIF
Ce
Ce      Length of GRIB message.
        KSEC0(1) = INSPT / 8
        ITEMP = KSEC0(1)
Ce
Ce    Because of the restriction on product lengths to 3 octets, if
Ce    more than 24 bits is needed, rescale by a factor of -120 to give
Ce    a (smaller) negative count.  It is only possible because
Ce    the (default) rounding for GRIB products is 120 bytes.
Ce
        IF( ITEMP.GE.JP23SET ) THEN
          LLARGE = .TRUE.
        ELSE
Ce
Ce        When encoding, use most-significant bit as a sign bit.
Ce
          CALL CSGNBT( KSEC0(1), ITEMP, 24, KRET)
Ce
Ce        Insert field.
          ITEMP = 32
          CALL INXBIT(KGRIB,KLENG,ITEMP,KSEC0(1),1,IBITS, 24,YFUNC,KRET)
          IF( KRET.NE.0) THEN
            KRET = 802
            WRITE(GRPRSM,*)
     X  'GRIBEX: Error inserting length of GRIB message'
            WRITE(GRPRSM,*) 'GRIBEX: Return code = ', KRET
            GO TO 900
          ENDIF
        ENDIF
Ce
Cjdc  ELSE
      ENDIF
Cj
Cj      'J' option jumps here for possible bitmap adjustment
Cj      to number of values in field section 4.
Cj
  815 CONTINUE
C
      IF( LDECODE ) THEN
Cj
        IF( L_IORJ ) GOTO 816
Cj
Cd      Skip padding.
        INSPT = INSPT + INIL
Cd
        CALL INXBIT(KGRIB,KLENG,INSPT,IPARM(1),4,IBITS, 8,YFUNC,KRET)
        IF( KRET.NE.0) THEN
          KRET = 801
          WRITE(GRPRSM,*) 'GRIBEX: Error extracting 7777 group'
          WRITE(GRPRSM,*) 'GRIBEX: Return code = ',KRET
          GO TO 900
        ENDIF
Cd      Check that length is consistent with the number of the header file
Cd      this will not happen for very large grib products with the *120 nightmare fix
Cd      in this *120 case the KSEC0(1) is updated with the value of the pointer/8
        IF( LLARGE) THEN
        IF( KSEC0(1).NE.INSPT/8) THEN
           IF( LPDEBUG ) THEN
            WRITE(GRPRSM,*) 'GRIBEX: Large product found', KSEC0(1)
           ENDIF
           KSEC0(1) = INSPT/8
           IF( LPDEBUG ) THEN
            WRITE(GRPRSM,*) 'GRIBEX: KSEC0(1) updated to = ', KSEC0(1)
           ENDIF
          ENDIF
        ENDIF
Cd
Cd      Check that 7777 group is found where expected.
        ICOUNT = 0
        DO 810 JLOOP = 1 , 4
          IF( IPARM(JLOOP).NE.55) ICOUNT = ICOUNT + 1
  810   CONTINUE
        IF( ICOUNT.NE.0) THEN
          KRET = 805
          WRITE(GRPRSM,*)
     X  'GRIBEX: End of message 7777 group not found.'
          WRITE(GRPRSM,*) 'GRIBEX: Return code = ', KRET
          GO TO 900
        ENDIF
Cd
Cd      Final handling when bit-maps included.
Cd
  816   CONTINUE
Cd
        IF( LSECT3 ) THEN
Cd
Cd        Bit-map included in GRIB message.
          IF( KSEC3(1).EQ.0) THEN
Cd
            IF( KSEC4(8).EQ.0.OR.KSEC4(9).EQ.0) THEN
Cd
Cd            Single value at each point.
Cd
              ITEMP = 1
Cd
Cd          Pointer IBMAP2 is set negative if there
Cd          are no matrix bit-maps.
Cd
              IBMAP2 = -1
              ITEMP = 1
            ELSE
Cd
Cd            Matrix of values at a point.
Cd
              ITEMP = KSEC4(50) * KSEC4(51)
            ENDIF
Cd
            IF( .NOT.L_IORJ ) THEN
Cd
Cd            Check user array is big enough before using bitmap to
Cd            fill missing data values (not relevant for 'J' option)
Cd
              IF( KLENP .LT. (IVALS*ITEMP) ) THEN
                WRITE(GRPRSM,*)
     X  'GRIBEX: Output array is not big enough to'
                WRITE(GRPRSM,*)
     X  'GRIBEX: allow expansion using bitmaps'
                KRET = 729
                GOTO 900
              ENDIF
Cd
Cd            Expand using bitmaps
Cd
              CALL EXTMAP(KGRIB,KLENG,IBMAP,IBMAP2,KSEC4(1),PSEC4,IVALS,
     X                    IBITS,ISBMAP,ZMSVAL,ITEMP,NDBG,KRET,NONMISS)
              IF( KRET.NE.0) THEN
                KRET = 806
                WRITE(GRPRSM,*)
     X            'GRIBEX: Error extracting primary/secondary bit map.'
                WRITE(GRPRSM,*) 'GRIBEX: Return code = ', KRET
                GO TO 900
              ENDIF
              KSEC4(1) = IVALS*ITEMP
Cj
            ELSE IF( HOPER.EQ.'J' ) THEN
Cj
Cj            Cannot handle secondary bitmaps for 'J' option counting
Cj
              IF( IBMAP2.NE.-1 ) THEN
                WRITE(GRPRSM,*)
     X            'GRIBEX: Cannot handle 2ndary bitmaps for J option'
                KRET = 811
                GOTO 900
Cj
              ELSE
Cj
Cj              Count bits in primary bitmap only ('J' option)
Cj
                IS3BYTE = (IBMAP/8 - 6)
                NONMISS = ONEBITS(KGRIB,IS3BYTE)
                KSEC4(21) = NONMISS
                KSEC4(1)  = IVALS
              ENDIF
            ENDIF
Cd
          ELSE
#ifdef USE_NO_POINTERS
            WRITE(GRPRSM,*)
     X        'GRIBEX: predetermined bit-map reference not handled'
              KRET = 735
              GOTO 900
#else
Cd
Cd          Predetermined bit-map reference only.
Cd          (Secondary bitmaps not handled in this case).
Cd
            IBMAP2 = -1
Cd
Cd          Single value at each point.
Cd
            ITEMP = 1
Cd
Cd          Get the bitmask
Cd
            KRET = GBITMAP(KSEC3(1), IBTVALS, NONMISS, IBTPTR, NBYTE)
            IF( KRET.NE.0 ) THEN
              WRITE(GRPRSM,*) 'GRIBEX: Problem getting bitmap'
              GOTO 900
            ENDIF
Cd
Cd          Expand using bitmap
Cd
            IBMAP = 0
Cd
Cd          Set integer or real missing data value.
Cd
            IF( KSEC4(5) .EQ. 0 )  THEN
              ZMSVAL = PSEC3(2)
            ELSE
              ZMSVAL = REAL(KSEC3(2))
            ENDIF
            CALL EXTMAP(IBTMAP, KLENG, IBMAP, IBMAP2, KSEC4(1), PSEC4,
     X                  IBTVALS,IBITS, ISBMAP,ZMSVAL, ITEMP, NDBG, KRET,
     X                  NONMISS)
            IF( KRET.NE.0) THEN
              KRET = 806
              WRITE(GRPRSM,*)
     X          'GRIBEX: Error extracting primary or secondary bit map.'
              WRITE(GRPRSM,*) 'GRIBEX: Return code = ', KRET
              GO TO 900
            ENDIF
            KSEC4(1) = IBTVALS*ITEMP
Cd
#endif
          ENDIF
        ENDIF
Cd
#ifndef USE_NO_POINTERS
Cd
Cd      If required, convert quasi-regular grid to regular.
Cd
        IF( HOPER.EQ.'R'.AND.LQUASI) THEN
Cr
Cr        Quasi-regular gaussian ..
Cr
          IF( (KSEC2(1).EQ. 4).OR.
     X        (KSEC2(1).EQ.14).OR.
     X        (KSEC2(1).EQ.24).OR.
     X        (KSEC2(1).EQ.34) ) THEN
Cr
Cr          Gaussian grid must be global
Cr
            INOLAT = KSEC2(10) * 2
Cr
            IF( KSEC2(3).NE.INOLAT ) THEN
              KRET = 808
              WRITE(GRPRSM,*)
     X          'GRIBEX: Error converting quasi-regular gaussian grid'
              WRITE(GRPRSM,*) 'GRIBEX: to regular. Grid must be global.'
              WRITE(GRPRSM,*) 'GRIBEX: Return code = ',KRET
              GO TO 900
            ENDIF
Cr
            INOLNG    = INOLAT * 2
            KSEC2(9)  = NINT(360000.0/REAL(INOLNG))
            LPERIO = .TRUE.
C
C           Some ECMWF 'vegetation' parameters have to be interpolated
C           using 'nearest neighbour' processing
C
            NITABLE  = KSEC1(1)
            NICENTRE = KSEC1(2)
            NIPARAM  = KSEC1(6)
            LVEGGY = (NITABLE.EQ.128).AND.
     X               (NICENTRE.EQ.98).AND.
     X               ((NIPARAM.EQ.27).OR.
     X                (NIPARAM.EQ.28).OR.
     X                (NIPARAM.EQ.29).OR.
     X                (NIPARAM.EQ.30))
            IF( LPDEBUG ) THEN
              IF( LVEGGY ) WRITE(GRPRSM,*)
     X          'GRIBEX: Nearest neighbour processing used for R option'
            ENDIF
            CALL QU2REG3(PSEC4,KSEC2(23),INOLAT,INOLNG,1,ZMSVAL,KRET,
     X                   LSECT3,LPERIO,LVEGGY)
            IF( KRET .NE. 0 ) THEN
              KRET = 808
              WRITE(GRPRSM,*)
     X          'GRIBEX: Error converting quasi-regular gaussian grid'
              WRITE(GRPRSM,*)
     X          'GRIBEX: to regular. Return code = ',KRET
              GO TO 900
            ENDIF
Cr
Cr        Quasi-regular latitude-longitude ..
Cr
          ELSE IF( (KSEC2(1).EQ. 0).OR.
     X             (KSEC2(1).EQ.10).OR.
     X             (KSEC2(1).EQ.20).OR.
     X             (KSEC2(1).EQ.30) ) THEN
            INOLAT    = IABS(KSEC2(4) - KSEC2(7))
            IEAST   = KSEC2(5)
Cr
Cr          Special case: symmetrical about equator, no equator
Cr          Have to calculate extreme longitude
Cr          (Fixup for reduced lat/long grids reporting last point
Cr          correctly)
Cr
            IF((MOD(KSEC2(3),2).EQ.0).AND.(KSEC2(4).EQ.(-KSEC2(7))))THEN
              N = KSEC2(3)/2
              NP = KSEC2(22+N)
              NINC = 360000/NP
              KSEC2(8) = IEAST + NINC*(NP-1)
              KSEC2(9) = NINC
            ENDIF
            IWEST   = KSEC2(8)
            IF( IWEST .LT. IEAST ) IWEST = IWEST + 360000
            INOLNG    = IABS(IWEST - IEAST)
Cr
Cr          Allow for missing Di or Dj increment.
Cr
            IF( KSEC2(9) .EQ. IMISNG ) THEN
              INOLAT    = 1 + INOLAT/ KSEC2(10)
              INOLNG    = 1 + INOLNG/ KSEC2(10)
              KSEC2(9)  = KSEC2(10)
            ELSE
              INOLAT    = 1 + INOLAT/ KSEC2(9)
              INOLNG    = 1 + INOLNG/ KSEC2(9)
              KSEC2(10) = KSEC2(9)
            ENDIF
Cr
Cr          Check if input domain is periodic.
Cr
            ILOEXT = KSEC2(8)+(1-2*(KSEC2(11)/128))*KSEC2(9)
            LPERIO = MOD( IABS(ILOEXT-KSEC2(5) ), 360000) .EQ. 0
            CALL QU2REG3(PSEC4,KSEC2(23),INOLAT,INOLNG,1,ZMSVAL,KRET,
     X                   LSECT3,LPERIO,LVEGGY)
            IF( KRET .NE. 0 ) THEN
              KRET = 808
              WRITE(GRPRSM,*)
     X          'GRIBEX: Error converting quasi-regular gaussian grid'
              WRITE(GRPRSM,*)
     X          'GRIBEX: to regular. Return code = ',KRET
              GO TO 900
            ENDIF
Cr
          ENDIF
Cr
          KSEC4(1)  = INOLAT * INOLNG
          KSEC2(2)  = INOLNG
          KSEC2(3)  = INOLAT
          KSEC2(6)  = 128
          KSEC2(17) = 0
          LQUASI = .FALSE.
        ENDIF
#endif
Cj
        IF( HOPER.EQ.'J' ) GOTO 900
Cj
Cd
Cd      Convert to integer if original data was integer.
Cd
        IF( ( KSEC4(5) .EQ. 32 ) .AND. (HOPER.NE.'B') )
     X    CALL RORINT(PSEC4,PSEC4,KSEC4(1),'I')
Cd
Cd      Set number of values decoded negative, if missing data.
Cd
        IF( IMISS.EQ.1) KSEC4(1) = - KSEC4(1)
Cd
Cd      If GRIB Edition number is -1 or 0, set GRIB message
Cd      length for return to user.
Cd
        IF( KSEC0(2).EQ.-1.OR.KSEC0(2).EQ.0) KSEC0(1) = INSPT / 8
Cd
        GO TO 900
Cd
      ENDIF
C
C*    Set unused part of last word to binary zeroes.
C
      KWORD    = INSPT / IBITS
      ITEMP    = KWORD * IBITS
      IOFF     = INSPT - ITEMP
      IF( IOFF.NE.0) THEN
        CALL INXBIT(KGRIB,KLENG,INSPT,0,1,IBITS,(IBITS-IOFF),YFUNC,KRET)
        IF( KRET.NE.0) THEN
          KRET = 809
          WRITE(GRPRSM,*)
     X  'GRIBEX: Error padding unused part of GRIB to zero'
          WRITE(GRPRSM,*) 'GRIBEX: Return code = ', KRET
          GO TO 900
        ENDIF
        KWORD = KWORD + 1
      ENDIF
C
C*    Round length to a multiple of 120 octets, if required,
C     Set any additional words to 0.
C
      IF( (NRND.EQ.1).OR.LLARGE ) THEN
        I = INSPT / 960
        I = I * 960
        I = INSPT - I
        IF( I.NE.0) THEN
          I = (960 - I)
          ITEMP = MOD(I,8)
          CALL INXBIT(KGRIB,KLENG,INSPT,0,1,IBITS,ITEMP,YFUNC,KRET)
          IF( KRET.NE.0) THEN
            KRET = 810
            WRITE(GRPRSM,*)
     X  'GRIBEX: Error padding GRIB to multiple of 120'
            WRITE(GRPRSM,*) 'GRIBEX: Return code = ', KRET
            GO TO 900
          ENDIF
          ITEMP = I/8
          DO 820 JLOOP = 1, ITEMP
            CALL INXBIT(KGRIB,KLENG,INSPT,0,1,IBITS,8,YFUNC,KRET)
            IF( KRET.NE.0) THEN
              KRET = 810
              WRITE(GRPRSM,*)
     X  'GRIBEX: Error padding GRIB to multiple of 120'
              WRITE(GRPRSM,*) 'GRIBEX: Return code = ', KRET
              GO TO 900
            ENDIF
  820     CONTINUE
          I = I / IBITS
        ENDIF
        KWORD = KWORD + I
      ENDIF
Ce
      IF( LLARGE.AND.LENCODE ) THEN
Ce
Ce      Because of the restriction on product lengths to 3 octets, if
Ce      more than 24 bits is needed, rescale by a factor of -120 to give
Ce      a (smaller) negative count.  It is only possible because
Ce      the (default) rounding for GRIB products is 120 bytes.
Ce
        ITEMP = (KWORD*(IBITS/8)) / (-120)
Ce
Ce      When encoding, use most-significant bit as a sign bit.
Ce
        CALL CSGNBT( KSEC0(1), ITEMP, 24, KRET)
Ce
Ce      Insert product length field.
        ITEMP = 32
        CALL INXBIT(KGRIB,KLENG,ITEMP,KSEC0(1),1,IBITS, 24,YFUNC,KRET)
        IF( KRET.NE.0) THEN
          KRET = 802
          WRITE(GRPRSM,*)
     X  'GRIBEX: Error inserting length of GRIB message'
          WRITE(GRPRSM,*) 'GRIBEX: Return code = ', KRET
          GO TO 900
        ENDIF
Ce
Ce      If encoding a very large product, the section 4 length field
Ce      holds the number of bytes in the product after section 4 upto
Ce      the end of the padding bytes. In this case, the setting
Ce      of this field has been postponed upto this point.
Ce
        IPLEN = IPLEN - 32
        ILEN4 = KWORD*(IBITS/8) - (IP7777/8)
Ce
Ce      Insert section 4 length.
        CALL INXBIT(KGRIB,KLENG,IPLEN,ILEN4,1,IBITS, 24,YFUNC,KRET)
        IF( KRET.NE.0) THEN
          KRET = 802
          WRITE(GRPRSM,*)
     X  'GRIBEX: Error inserting length of GRIB section 4'
          WRITE(GRPRSM,*) 'GRIBEX: Return code = ', KRET
          GO TO 900
        ENDIF
      ENDIF
C
C     -----------------------------------------------------------------|
C
C
C
C
C
C
C
C
C
C
C*    Section 9 . Abort/return to calling routine.
C     -----------------------------------------------------------------|
C
  900 CONTINUE
C
      IF( LPDEBUG ) THEN
        WRITE(GRPRSM,*) 'GRIBEX: Section 9.'
        WRITE(GRPRSM,*) 'GRIBEX: Output values set -'
        IF( LDECODE ) THEN
          CALL GRPRS0(KSEC0)
          CALL GRPRS1(KSEC0,KSEC1)
Cd
Cd        Print section 2 if present.
Cd
          IF( LSECT2 ) CALL GRPRS2(KSEC0,KSEC2,PSEC2)
Cd
Cd        Print section 3 if present.
Cd
          IF( LSECT3 ) CALL GRPRS3(KSEC0,KSEC3,PSEC3)
Cd
          CALL GRPRS4(KSEC0,KSEC4,PSEC4)
Cd
Cd        Special print for 2D spectra wave field real values in
Cd        section 4
Cd
          IF( (KSEC1(1).EQ.140) .AND.
     X        (KSEC1(2).EQ. 98) .AND.
     X        (KSEC1(24).EQ. 1) .AND.
     X        ( (KSEC1(40).EQ.1045).OR.(KSEC1(40).EQ.1081) ) .AND.
     X        ( (KSEC1(6) .EQ. 250).OR.(KSEC1(6) .EQ. 251) ) )
     X      CALL GRPRS4W(KSEC4)
        ENDIF
      ENDIF
C
C     Effective number of points in masked field returned in KSEC4(21).
C     Bit-map pointer within masked field returned in KSEC4(22).
C
      IF( LSECT3 ) THEN
        KSEC4(21) = NONMISS
        KSEC4(22) = IBMAP
      ENDIF
C
C     Length of section 4 (octets) in KSEC4(23).
C     Unused bit count returned in KSEC4(24).
C
      KSEC4(23) = ILEN4
      KSEC4(24) = INIL
C
C*    If no error has been encountered, set return code to informative
C     value, if required.
C
C     Set pseudo-GRIB data encountered.
C
      IF( KRET.EQ.0.AND.IPSEUD.NE.0) KRET = IPSEUD
C
C     Set data with bit-map encountered (unless 'J' option in use).
C
      IF( (KRET.EQ.0.AND.ISBMAP.NE.0).AND.(HOPER.NE.'J')) KRET = ISBMAP
C
C Dumping data values on a file if an error occurs and the environment
C variable GRIBEX_DUMP_DATA_ON_ERROR is set
        IF (( HOPER.EQ.'C'.OR.HOPER.EQ.'M'.OR.HOPER.EQ.'K')
     x  .AND.DUMPDATA.NE.0) THEN
          IDUMP = 42  ! FIXME: not guaranteed to be universally unique
          OPEN(IDUMP,FILE=DUMPPATH,FORM='FORMATTED',STATUS='UNKNOWN')
          DO jloop=1,klenp
            WRITE(IDUMP,'(E20.10)') PSEC4(jloop)
          ENDDO
          CLOSE(IDUMP)
        ENDIF
C
C*    Abort if an error has been encountered and user has requested
C     an abort. Informative values are negative and do not cause an
C     abort.
C
      IF( (NOABORT.EQ.0) .AND. (KRET.GT.0) ) THEN
C
C       Try to print some useful information before aborting
C
        WRITE(GRPRSM,*) 'GRIBEX: ********************************'
        WRITE(GRPRSM,*) 'GRIBEX: Version is ',YGRIBEX
        WRITE(GRPRSM,*) 'GRIBEX: KLENP = ', KLENP
        WRITE(GRPRSM,*) 'GRIBEX: KLENG = ', KLENG
        WRITE(GRPRSM,*) 'GRIBEX: HOPER = ', HOPER
        WRITE(GRPRSM,*) 'GRIBEX: ********************************'
        DO 910 JLOOP = 1, 43
          WRITE(GRPRSM,*) 'GRIBEX: KSEC1(',JLOOP,') = ', KSEC1(JLOOP)
  910   CONTINUE
        WRITE(GRPRSM,*) 'GRIBEX: ********************************'
        DO 920 JLOOP = 1, 22
          WRITE(GRPRSM,*) 'GRIBEX: KSEC2(',JLOOP,') = ', KSEC2(JLOOP)
  920   CONTINUE
        WRITE(GRPRSM,*) 'GRIBEX: ********************************'
        DO 930 JLOOP = 1, 10
          WRITE(GRPRSM,*) 'GRIBEX: PSEC2(',JLOOP,') = ', PSEC2(JLOOP)
  930   CONTINUE
        WRITE(GRPRSM,*) 'GRIBEX: ********************************'
        DO 940 JLOOP = 1, 2
          WRITE(GRPRSM,*) 'GRIBEX: KSEC3(',JLOOP,') = ', KSEC3(JLOOP)
  940   CONTINUE
        WRITE(GRPRSM,*) 'GRIBEX: ********************************'
        DO 950 JLOOP = 1, 2
          WRITE(GRPRSM,*) 'GRIBEX: PSEC3(',JLOOP,') = ', PSEC3(JLOOP)
  950   CONTINUE
        WRITE(GRPRSM,*) 'GRIBEX: ********************************'
        DO 960 JLOOP = 1, 20
          WRITE(GRPRSM,*) 'GRIBEX: KSEC4(',JLOOP,') = ', KSEC4(JLOOP)
  960   CONTINUE
        WRITE(GRPRSM,*) 'GRIBEX: ********************************'
        DO 970 JLOOP = 1, 20
          WRITE(GRPRSM,*) 'GRIBEX: PSEC4(',JLOOP,') = ', PSEC4(JLOOP)
  970   CONTINUE
        WRITE(GRPRSM,*) 'GRIBEX: ********************************'
        CALL ABORTX ('GRIBEX')
      ELSE
        RETURN
      ENDIF
C
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE NEXTSEP(KBUFL,YBUFF,I,J,KERR)
C
C**** *NEXTSEP*
C
C
C     PURPOSE.
C     --------
C         LOCATE THE NEXT SEPARATOR
C         CHARACTER WHICH IS 'CR' OR 'LF' OR 'SPACE' OR '+'
C
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *NEXTSEP(KBUFL,YBUFF,I,J,KERR)*
C         INPUT     : KBUFL - size if ybuff
C                     YBUFF - character string
C                     I     - SCAN STARTS AT byte 'I' OF YBUFF
C                     J     - SCAN ENDS AT byte 'J' OF YBUFF
C
C         OUTPUT    : I     - POSITION OF NEXT 'CR' OR 'LF' OR 'SPACE'
C                             OR '+'

C
C     METHOD.
C     -------
C
C          NONE.
C
C
C     EXTERNALS.
C     ----------
C
C         NONE.
C
C     REFERENCE.
C     ----------
C
C          NONE.
C
C     AUTHOR.
C     -------
C
C
C
C     MODIFICATIONS.
C     --------------
C
C          MILAN DRAGOSAVAC    *ECMWF*       15/02/2003.
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
      CHARACTER*(*) YBUFF
      CHARACTER*1 cr,lf,space,plus,minus 
C
      COMMON /CREXWORK/ NBPT,NGS,NVIND,NBPTSEC2,RVIND,EPS,NE,IEOLD,
     1                  NC07YYY
      REAL*8 RVIND,EPS
C
C     ------------------------------------------------------------------
C
C*          1.   SCAN BULLETIN.
C                --------------
 100  CONTINUE
C
C     'CR' = 13 , 'LF' = 10 , 'SPACE' = 32 'PLUS' = 43,
C
      cr=char(13)
      lf=char(10)
      space=char(32)
      plus=char(43)
      minus='-'
C
      i=iabs(i)
      k = i
      do 101 i=k,j
       if(NE.eq.0) then
         if(ybuff(I:I).eq.cr.or.
     1      ybuff(I:I).eq.lf.or.
     2      ybuff(I:I).eq.space.or.
     3      ybuff(I:I).eq.minus.or.
     3      ybuff(I:I).eq.plus) return
       else
         if(ybuff(I:I).eq.cr.or.
     1      ybuff(I:I).eq.lf.or.
     2      ybuff(I:I).eq.space.or.
     3      ybuff(I:I).eq.plus) return
       end if
  101 continue
C
      return
      end

C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C


      SUBROUTINE INXMAP (KGRIB,KLENG,KMAPT,PSEC4,KSIZE,KBITS,KSBMAP,
     C                     PMISS,HFUNC,KPR,KRET)
C
C---->
C**** INXMAP - Bit map handling for routine GRIBEX.
C
C     Purpose.
C     --------
C
C           1) Extract a bit-map from an array of GRIB coded data and
C              insert missing data value in appropriate places in the
C              array of already decoded data values.
C
C           2) Generate a bit-map and insert in array of GRIB coded
C              data and remove missing data values from the array of
C              values being encoded in GRIB code.
C
C**   Interface.
C     ----------
C
C           CALL INXMAP (KGRIB,KLENG,KMAPT,PSEC4,KSIZE,KBITS,KSBMAP,
C    C                     PMISS,HFUNC,KPR,KRET)
C
C           Integer    K.
C           Real       P.
C           Logical    O.
C           Character  H.
C
C               Input Parameters.
C               -----------------
C
C               KGRIB      - Array of GRIB data being coded/decoded.
C
C               KLENG      - Length of this array.
C
C               KMAPT      - Bit-pointer to start of bit-map in
C                            array KGRIB.
C
C               PSEC4      - Array of data values decoded or to be
C                            coded in GRIB.
C
C               KSIZE      - Size of bit-map ie number of values,
C                            including missing data values, in array
C                            PSEC4.
C
C               KBITS      - Number of bits in computer word.
C
C               PMISS      - Value indicating missing data in array
C                            PSEC4.
C
C               HFUNC      - 'C' , GRIB data being coded.
C                            'M' , GRIB data being coded in fixed length
C                                  messages.
C                            'D' , GRIB data being decoded.
C
C               KPR        - Debug print switch.
C                            0 , No printout.
C                            1 , Debug printout.
C
C               Output Parameters.
C               ------------------
C
C               KSBMAP     - Bit-map flag.
C                            Used only when decoding data.
C                            -2 , All bits in the bit-map set to 1.
C                                 There is no missing data.
C                            -4 , Some points have no data. User
C                                 supplied value for missing data
C                                 indicator in appropriate places in
C                                 the array PSEC4.
C
C               KSIZE      - When coding data, the number of real data
C                            values in array PSEC4. Not changed when
C                            decoding.
C
C               KRET       - Return code.
C                            0 , No error encountered.
C                            1 , Error in routine INXBIT.
C                            2 , Bit-map size exceeds maximum.
C                            3 , Invalid function requested.
C
C     Method.
C     -------
C
C           The bit-map contains 1 where valid data exists and 0
C           where data is missing. The corresponding data array
C           contains valid data and the missing data indicator value.
C
C     Externals.
C     ----------
C
C           INXBIT
C
C     Reference.
C     ----------
C
C           See routine GRIBEX.
C
C     Comments.
C     ---------
C
C           Routine contains Sections 0 to 4 and Section 9.
C
C     Author.
C     -------
C
C           J. Hennessy      ECMWF      09:09:91
C
C     Modifications.
C     --------------
C
C           J. Hennessy      ECMWF      08:11:91
C           Parameter KMACH removed from list of input parameters.
C           Optional abort removed.
C
C940309     J.D.Chambers     ECMWF      09:03:94
C940309     Maximum size for bitmap array increased to 132000
C940309     to allow for products 0.5 * 0.5 degrees, whole
C940309     hemisphere (N or S).
C
C     ------------------------------------------------------------------
C----<
C
C
C
C
C
C
C
C
C
C
C*    Section 0 . Definition of variables. Data statements.
C     ------------------------------------------------------------------
C
C*    Prefix conventions for variable names.
C
C     Logical      L (but not LP), global or common.
C                  O, dummy arguments.
C                  G, local variable.
C                  LP, parameter.
C     Character    C, Global or common.
C                  H, dummy arguments.
C                  Y (but not YP), local variables.
C                  YP, parameter.
C     Integer      M and N, global or common.
C                  K, dummy arguments.
C                  I, local variables.
C                  J (but not JP), loop control.
C                  JP, parameter.
C     Real         A to F and Q to X, global or common.
C                  P (but not PP), dummy arguments.
C                  Z, local variables.
C                  PP, parameter.
C
C
      IMPLICIT NONE
C
#include "grprs.h"
C
      CHARACTER*(*) HFUNC
      CHARACTER*1   YFUNC
C
      INTEGER IMAP
      INTEGER INEXT
C
      INTEGER JPMAP
C
      INTEGER J320
      INTEGER J330
      INTEGER J420
      INTEGER J430
      INTEGER J431
C
      INTEGER KBITS
      INTEGER KGRIB
      INTEGER KLENG
      INTEGER KMAPT
      INTEGER KPR
      INTEGER KRET
      INTEGER KSBMAP
      INTEGER KSIZE
C
      REAL PMISS
      REAL PSEC4
C
      REAL ZSEC4
C
C*    Maximum size of bit-map which can be handled.
C
C940309 PARAMETER (JPMAP=41472)
      PARAMETER (JPMAP=132000)
C
      DIMENSION IMAP(JPMAP)
C
      DIMENSION PSEC4(*)
      DIMENSION ZSEC4(JPMAP)
C
C     ------------------------------------------------------------------
C
C
C
C
C
C
C
C
C
C
C*    Section 1 . Set initial values.
C     ------------------------------------------------------------------
C
  100 CONTINUE
C
      IF (KPR.EQ.1)
     C   THEN
             WRITE(GRPRSM,*) 'INXMAP : Section 1.'
             WRITE(GRPRSM,*) '         Input values used -'
	     WRITE(GRPRSM,9004) HFUNC
	     WRITE(GRPRSM,9005) KSIZE
         ENDIF
C
C     Reset return code to
C
      KRET  = 0
C
      INEXT = 0
C
      YFUNC = HFUNC
C
C     ------------------------------------------------------------------
C
C
C
C
C
C
C
C
C
C
C*    Section 2 .  Check input parameters.
C     ------------------------------------------------------------------
C
  200 CONTINUE
C
      IF (KPR.EQ.1) WRITE(GRPRSM,*) 'INXMAP : Section 2.'
C
C*    Check that bit-map size does not exceed maximum permitted.
C
      IF (JPMAP.LT.KSIZE)
     C   THEN
	     WRITE(GRPRSM,9001) KSIZE , JPMAP
	     KRET = 2
	     GO TO 900
         ENDIF

C     ------------------------------------------------------------------
C
C
C
C
C
C
C
C
C
C
C*    Section 3 . Decoding of bit-map and data.
C     ------------------------------------------------------------------
C
  300 CONTINUE
C
      IF (KPR.EQ.1) WRITE(GRPRSM,*) 'INXMAP : Section 3.'
C
      IF (YFUNC.EQ.'D')
     C   THEN
C
C*           Extract bit-map from GRIB coded data.
C
             CALL INXBIT (KGRIB,KLENG,KMAPT,IMAP,KSIZE,KBITS,1,
     C                     YFUNC,KRET)
C
             IF (KRET.NE.0)
     C          THEN
		    WRITE(GRPRSM,9003)
		    KRET = 1
		    GO TO 900
                ENDIF
C
C*           Copy data to temporary array and insert missing data
C            indicator in temporary array, in accordance with the
C            bit map values.
C
             DO 320 J320=1,KSIZE
	        IF (IMAP(J320).EQ.0)
     C             THEN
	  	       ZSEC4(J320) = PMISS
                   ELSE
		       INEXT       = INEXT + 1
		       ZSEC4(J320) = PSEC4(INEXT)
                   ENDIF
  320        CONTINUE
C
C*           Set bit-map flag, and if missing data is indicated
C            transfer data to original array.
C
             IF (INEXT.NE.KSIZE)
     C          THEN
		    KSBMAP = -4
                    DO 330 J330=1,KSIZE
	               PSEC4(J330) = ZSEC4(J330)
  330               CONTINUE
                ELSE
		    KSBMAP = -2
		ENDIF
C
             GO TO 900
C
         ENDIF
C
C    -------------------------------------------------------------------
C
C
C
C
C
C
C
C
C
C
C*    Section 4 . Generation of bit-map.
C    -------------------------------------------------------------------
C
  400 CONTINUE
C
      IF (KPR.EQ.1) WRITE(GRPRSM,*) 'INXMAP : Section 4.'
C
      IF (YFUNC.EQ.'C'.OR.YFUNC.EQ.'M')
     C   THEN
C
C*           Copy data to temporary array and remove missing data
C            indicator in temporary array, generating the bit-map
C            in accordance with the missing data values.
C
             DO 420 J420=1,KSIZE
	        IF (PSEC4(J420).EQ.PMISS)
     C             THEN
		       IMAP(J420)   = 0
                   ELSE
		       IMAP(J420)   = 1
		       INEXT        = INEXT + 1
		       ZSEC4(INEXT) = PSEC4(J420)
                   ENDIF
  420        CONTINUE
C
C*           Insert bit-map in GRIB coded data.
C
             CALL INXBIT (KGRIB,KLENG,KMAPT,IMAP,KSIZE,KBITS,1,
     C                     YFUNC,KRET)
C
             IF (KRET.NE.0)
     C          THEN
		    WRITE(GRPRSM,9003)
		    KRET = 1
		    GO TO 900
                ENDIF
C
C*           If missing data is indicated transfer data to original
C            array.
C
             IF (INEXT.NE.KSIZE)
     C          THEN
                    DO 430 J430=1,INEXT
	               PSEC4(J430) = ZSEC4(J430)
  430               CONTINUE
C
                    IF (YFUNC.EQ.'M')
     C                 THEN
C
C                          Fixed length messages required, even though
C                          a bit map is used. The otherwise unused part
C                          of the array is set to a genuine data value
C                          so that extraction of minimum and maximum
C                          values remain correct. Number of data values
C                          includes these padding values.
C
                           DO 431 J431=INEXT+1,KSIZE
	                      PSEC4(J431) = PSEC4(1)
  431                      CONTINUE
		       ELSE
C
C                          Return number of real values (excluding
C                          missing data values).
C
                           KSIZE = INEXT
                       ENDIF
		ENDIF
C
	     GO TO 900
C
         ENDIF
C
C*    Invalid function requested.
C
      WRITE(GRPRSM,9002) YFUNC
      KRET = 3
C
C     ------------------------------------------------------------------
C
C
C
C
C
C
C
C
C
C
C*    Section 9 . Return to calling routine. Format statements.
C     ------------------------------------------------------------------
C
  900 CONTINUE
C
      IF (KPR.EQ.1)
     C   THEN
             WRITE(GRPRSM,*) 'INXMAP : Section 9.'
             WRITE(GRPRSM,*) '         Output values set -'
	     WRITE(GRPRSM,9005) KSIZE
	     WRITE(GRPRSM,9006) KSBMAP
         ENDIF
C
 9001 FORMAT (1H ,'INXMAP : Bit-map size is ',I6,', maximum allowed',
     C            ' is ',I6,'.')
C
 9002 FORMAT (1H ,'INXMAP : Invalid function requested - ',A1)
C
 9003 FORMAT (1H ,'INXMAP : Error reported by routine INXBIT.')
C
 9004 FORMAT (1H ,'         HFUNC  = ',A1)
C
 9005 FORMAT (1H ,'         KSIZE  = ',I6)
C
 9006 FORMAT (1H ,'         KSBMAP = ',I6)
C
      RETURN
C
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE INTLOG(KLEVEL, MESSAGE, KNUM)
C
C---->
C**** INTLOG
C
C     PURPOSE
C     _______
C
C     This routine logs error messages.
C
C
C     INTERFACE
C     _________
C
C     CALL INTLOG(KLEVEL, MESSAGE, KNUM)
C
C
C     Input parameters
C     ________________
C
C     KLEVEL   - Severity level for reported message
C                = 0 for debug
C                = 1 for information
C                = 2 for warning
C                = 3 for error
C                = 4 for fatal
C     MESSAGE  - Message text
C     KNUM     - Message number
C
C
C     Output parameters
C     ________________
C
C     None.
C
C
C     Common block usage
C     __________________
C
C     LDEBUG in /INTLOGC/ controls display of message
C                 = 0 for no display
C                 = 1 to display
C
C
C     Method
C     ______
C
C     Prints message and number if debug flag is 'on'.
C
C
C     Externals
C     _________
C
C     INTLOGT  - sends any ERROR, FATAL or WARN message to the
C                MARS server.
C
C
C     Comments
C     ________
C
C     LDEBUG is toggled by a call to INTLOGD.
C
C
C     AUTHOR
C     ______
C
C     J.D.Chambers      *ECMWF*      Jul 1995
C
C
C     MODIFICATIONS
C     _____________
C
C     J.D.Chambers      *ECMWF*      March 1996
C     Prepare error message for MARS server.
C
C
C----<
C     _______________________________________________________
C
      IMPLICIT NONE
C
#include "parim.h"
C
C     Subroutine arguments.
C
      INTEGER KLEVEL
      INTEGER KNUM
      CHARACTER *(*) MESSAGE
C
#include "intlog.h"

#ifdef MPI_DEBUG
#include "mpif.h" 
#endif

C
C     Local variables.
C
      CHARACTER*120 NEWMESS
      INTEGER NLEV, LOOP
      CHARACTER*5 TITLE(JP_FATAL+1)
      DATA TITLE/'DEBUG',
     X           'INFO ',
     X           'WARN ',
     X           'ERROR',
     X           'FATAL'/
      INTEGER ILEN

#ifdef MPI_DEBUG
      INTEGER my_id, ierr
      Data my_id /-1/
      Save my_id
#endif

C
C ------------------------------------------------------------------
C*    Section 1.   Initialise
C ------------------------------------------------------------------
C
  100 CONTINUE
C
C     Ensure valid level is used.
      NLEV = KLEVEL + 1
      IF ( KLEVEL .GT. JP_FATAL) NLEV = JP_FATAL + 1
C
      DO LOOP = 1, 120
        NEWMESS(LOOP:LOOP) = ' '
      ENDDO
C
C ------------------------------------------------------------------
C*    Section 2.   Prepare ERROR or FATAL message for MARS server.
C ------------------------------------------------------------------
C
  200 CONTINUE
C
      ILEN = LEN(MESSAGE)
      IF( ILEN.GT.105 ) ILEN = 105

#ifdef MPI_DEBUG
      if (my_id.eq.-1) Then
      call MPI_COMM_RANK (MPI_COMM_WORLD, my_id, ierr)
      my_id = my_id + 1
      end if
#endif

      NEWMESS(1:ILEN) = MESSAGE(1:ILEN)
      ILEN = ILEN + 1
      IF(KNUM.NE.JPQUIET) THEN
        IF( ABS(KNUM).LT.1000 ) THEN
          WRITE(NEWMESS(ILEN:),'(I4)') KNUM
        ELSE IF ( ABS(KNUM).LT.100000 ) THEN
          WRITE(NEWMESS(ILEN:),'(I7)') KNUM
        ELSE IF ( ABS(KNUM).LT.100000000 ) THEN
          WRITE(NEWMESS(ILEN:),'(I10)') KNUM
        ELSE
          WRITE(NEWMESS(ILEN:),'(I15)') KNUM
        ENDIF
      ENDIF

C
C     Send the message
C
      IF( KLEVEL.GE.JP_WARN ) CALL INTLOGT(NEWMESS)
C
#ifdef MPI_DEBUG
      IF( LDEBUG ) WRITE(*,9001) my_id,TITLE(NLEV),NEWMESS
 9001 FORMAT(i4,' INTLOG ',A5,': ',A120)
#else
      IF( LDEBUG ) WRITE(*,9001) TITLE(NLEV),NEWMESS
 9001 FORMAT('INTLOG ',A5,': ',A120)

#endif
C
C ------------------------------------------------------------------
C*    Section 9.   Closedown.
C ------------------------------------------------------------------
C
  900 CONTINUE
C
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities
C granted to it by virtue of its status as an intergovernmental organisation
C nor does it submit to any jurisdiction.
C

      SUBROUTINE ECDEF50(HFUNC,KSEC1,KGRIB,KLENG,KNSPT,KBITS,KRET)
C
C---->
C**** ECDEF50
C
C     Purpose.
C     --------
C
C     GRIB coding/decoding of ECMWF local use definition 50.
C
C**   Interface.
C     ----------
C
C     CALL ECDEF50(HFUNC,KSEC1,KGRIB,KLENG,KNSPT,KBITS,KRET)
C
C
C     Input
C     -----
C     HFUNC      - Requested function.
C                  'C' to code data.
C                  'D' to decode data.
C     KSEC1      - Array containing Grib Section 1 data.
C     KGRIB      - Array containing Grib coded data.
C     KLENG      - Length (words) of KGRIB.
C     KNSPT      - Bit number after which insertion/extraction starts.
C     KBITS      - Number of bits in computer word.
C     KRET       - Response to error indicator.
C                  0        , Abort if error encountered.
C                  Non-zero , Return to calling routine
C                             even if error encountered.
C
C     Output
C     ------
C     KSEC1      - Array containing Grib Section 1 data.(Updated)
C     KGRIB      - Array containing Grib coded data.(Updated)
C     KNSPT      - Number of bit after last one inserted/extracted.
C                  (Updated)
C     KRET       - Return code.
C                  0   , No error encountered.
C                  2   , Error reported by routine INXBIT.
C
C
C     Method.
C     -------
C     Input data packed/unpacked in accordance with ECMWF usage of
C     local part of section 1 of Grib code, definition 50.
C
C
C     Externals.
C     ----------
C
C     INXBIT  - insert/extract bits
C     ABORTX  - abort the program
C     CSGNBT  - code a signed value
C     DSGNBT  - decode a signed value
C
C
C     Reference.
C     ----------
C
C     WMO Manual On Codes for Grib Code.
C
C
C     Comments.
C     ---------
C
#include "ecdef50.h"
C
C
C     Author.
C     -------
C
C     J.D.Chambers     ECMWF      December 2001
C
C
C     Modifications.
C     --------------
C
C     None
C
C
C----<
C     -----------------------------------------------------------------|
C*    Section 0 . Definition of variables. Data statements.
C     -----------------------------------------------------------------|
C
      IMPLICIT NONE
C
C     Subroutine arguments
C
      CHARACTER*1   HFUNC
      INTEGER KSEC1, KGRIB, KLENG, KNSPT, KBITS, KRET
      DIMENSION KGRIB(*)
      DIMENSION KSEC1(*)
C
C     Local variables
C
      INTEGER IRET, IZERO, JLOOP
CC    INTEGER ITEMP, IRETA
C
      LOGICAL LENCODE, LDECODE
C
C     -----------------------------------------------------------------|
C*    Section 1 . Set initial values.
C     -----------------------------------------------------------------|
C
  100 CONTINUE
C
      IRET = KRET
      LENCODE = ( HFUNC.EQ.'C' )
      LDECODE = .NOT. LENCODE
C
C     -----------------------------------------------------------------|
C*    Section 2 . Handle the local extension
C     -----------------------------------------------------------------|
C
  200 CONTINUE
C
C     Octet 50 : Number
C     Octet 51 : Total
C     Octet 52 : Model identifier
C     Three 8 bit fields.
C
      CALL INXBIT(KGRIB,KLENG,KNSPT,KSEC1(42),3,KBITS,8,HFUNC,KRET)
      IF( KRET.NE.0 ) THEN
        KRET = 2
        WRITE(*,*) 'ECDEF50: Error reported by routine INXBIT:'
        IF( LENCODE ) THEN
          WRITE(*,*) '      encoding section 1, elements 42 - 44.'
        ELSE
          WRITE(*,*) '      decoding section 1, octets 50 - 52.'
        ENDIF
        GOTO 900
      ENDIF
C
C     Octets 53-56: Latitude of North-west corner of area
C     Octets 57-60: Longitude of North-west corner of area
C     Octets 61-64: Latitude of South-east corner of area
C     Octets 65-68: Longitude of South-east corner of area
C     Four 32 bit fields.
C
      CALL INXBIT(KGRIB,KLENG,KNSPT,KSEC1(45),4,KBITS,32,HFUNC,KRET)
      IF( KRET.NE.0 ) THEN
        KRET = 2
        WRITE(*,*) 'ECDEF50: Error reported by routine INXBIT:'
        IF( LENCODE ) THEN
          WRITE(*,*) '      encoding section 1, elements 45 - 48.'
        ELSE
          WRITE(*,*) '      decoding section 1, octets 53 - 68.'
        ENDIF
        GOTO 900
      ENDIF
C
C     Octets 69-116 : Reserved for ECMWF additions.
C     Octet 69 : Original parameter number
C     Octet 70 : Original parameter table number
C     Octets 71-116 : Reserved for ECMWF additions.
C
      CALL INXBIT(KGRIB,KLENG,KNSPT,KSEC1(49),2,KBITS,8,HFUNC,KRET)
      IF( KRET.NE.0 ) THEN
        KRET = 2
        WRITE(*,*) 'ECDEF50: Error reported by routine INXBIT:'
        IF( LENCODE ) THEN
          WRITE(*,*) '      encoding section 1, elements 49 - 50.'
        ELSE
          WRITE(*,*) '      decoding section 1, octets 69 - 70.'
        ENDIF
        GOTO 900
      ENDIF
C
      IF( LENCODE ) THEN
        DO JLOOP = 71, 116
          IZERO = 0
          CALL INXBIT(KGRIB,KLENG,KNSPT,IZERO,1,KBITS,8,HFUNC,KRET)
          IF( KRET.NE.0 ) THEN
            KRET = 2
            WRITE(*,*) 'ECDEF50: Error reported by routine INXBIT:'
            WRITE(*,*) '      encoding section 1, octets 71 - 116'
            GOTO 900
          ENDIF
        ENDDO
      ELSE
        DO JLOOP = 51, 60
          KSEC1(JLOOP) = 0
        ENDDO
        KNSPT = KNSPT + 46*8
      ENDIF
C
C     Octets 117-300 : Optional data.
C     Forty-six 32 bit fields.
C
      DO JLOOP = 61, 106
        CALL INXBIT(
     X    KGRIB,KLENG,KNSPT,KSEC1(JLOOP),1,KBITS,32,HFUNC,KRET)
        IF( KRET.NE.0 ) THEN
          KRET = 2
          WRITE(*,*) 'ECDEF50: Error reported by routine INXBIT:'
          IF( LENCODE ) THEN
            WRITE(*,*) '      encoding section 1, elements 61 - 106.'
          ELSE
            WRITE(*,*) '      decoding section 1, octets 117 - 300.'
          ENDIF
          GOTO 900
        ENDIF
      ENDDO
C
C     -----------------------------------------------------------------|
C*    Section 9 . Abort/return to calling routine. Format statements.
C     -----------------------------------------------------------------|
C
  900 CONTINUE
C
C     Abort if requested to do so when an error has been encountered.
C
      IF( (IRET.EQ.0).AND.(KRET.NE.0) ) THEN
        CALL ABORTX('ECDEF50')
      ELSE
        RETURN
      ENDIF
C
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities
C granted to it by virtue of its status as an intergovernmental organisation
C nor does it submit to any jurisdiction.
C

      INTEGER FUNCTION GASETUP(KSEC1,KSEC2,KSEC3,KSEC4,RSEC2,ZASEC3)
C
C---->
C**** GASETUP
C
C     Purpose
C     -------
C
C     Setup GRIB sections 1, 2, 3 & 4 for the new interpolation product.
C     For grib_api.
C
C     Interface
C     ---------
C
C     IRET GASETUP(KSEC1,KSEC2,KSEC3,KSEC4,RSEC2,ZASEC3)
C
C     Input
C     -----
C
C     KSEC1   - Section 1 values
C     KSEC2   - Section 2 values
C     KSEC3   - Section 3 values
C     KSEC4   - Section 4 values
C     RSEC2   - Section 2 values, auxiliary (for floating numbers requiring sub-millidegree representations)
C     ZASEC3  - ?
C
C     Output
C     ------
C
C     KSEC1   - Section 1 values (modified)
C     KSEC2   - Section 2 values (modified)
C     KSEC3   - Section 3 values (modified)
C     KSEC4   - Section 4 values (modified)
C     RSEC2   - Section 2 values, auxiliary (for floating numbers requiring sub-millidegree representations)
C     ZASEC3  - ?
C
C     Method
C     ------
C
C     Use common block values and existing values from the original GRIB
C     product used for interpolation.
C
C
C     Externals
C     ---------
C
C     INTLOG   - Logs messages.
C
C
C     Author
C     ------
C
C     J.D.Chambers     ECMWF     Aug 1994
C
C----<
C
      IMPLICIT NONE
C
#include "parim.h"
#include "nifld.common"
#include "nofld.common"
#include "intf.h"
#include "grfixed.h"
C
C     Parameter(s)
C
      INTEGER JPROUTINE
      PARAMETER ( JPROUTINE = 19100 )
C
C     Function arguments
C
      INTEGER KSEC1(*), KSEC2(*), KSEC3(*), KSEC4(*)
      REAL RSEC2(JPGRIB_ISEC2), ZASEC3(*)
C
C     Local variables
C
      LOGICAL LIROTAT, LOROTAT
      INTEGER ITEMP
      REAL RTEMP
C
C***********************************************************************
C     Section 1.   Startup.
C***********************************************************************
C
 100  CONTINUE
C
      GASETUP = 0
C
C     Check a recognized data representation type is being processed
C
      IF ( (NOREPR .NE.JPREGULAR  ) .AND.
     X     (NOREPR .NE.JPREGROT   ) .AND.
     X     (NOREPR .NE.JPGAUSSIAN ) .AND.
     X     (NOREPR .NE.JPFGGROT   ) .AND.
     X     (NOREPR .NE.JPQUASI    ) .AND.
     X     (NOREPR .NE.JPQGGROT   ) .AND.
     X     (NOREPR .NE.JPSPHROT   ) .AND.
     X     (NOREPR .NE.JPREDLL    ) .AND.
     X     (NOREPR .NE.JPSPHERE   ) ) GOTO 910
C
C     Set flags if input is rotated or if a rotation angle has been given
C
      LIROTAT = (NIREPR.EQ.JPSPHROT).OR.
     X          (NIREPR.EQ.JPREGROT).OR.
     X          (NIREPR.EQ.JPFGGROT).OR.
     X          (NIREPR.EQ.JPQGGROT)
C
      LOROTAT = ((NOROTA(1).NE.-9000000).AND.(NOROTA(1).NE.0)).OR.
     X          (NOROTA(2).NE.0)
     X          .OR. (NOREPR.EQ.JPSPHROT .OR.
     X                NOREPR.EQ.JPREGROT .OR.
     X                NOREPR.EQ.JPFGGROT .OR.
     X                NOREPR.EQ.JPQGGROT)
C
C***********************************************************************
C     Section 2.   Setup output product section 2.
C***********************************************************************
C
 300  CONTINUE
C
C     Data representation type
C
C     Adjust output representation type if field is rotated
C
      IF( LIROTAT.OR.LOROTAT ) THEN
        KSEC2(1) = NOREPR
        IF(NOREPR.EQ.JPREGULAR )  KSEC2(1) = JPREGROT
        IF(NOREPR.EQ.JPSPHERE )   KSEC2(1) = JPSPHROT
        IF(NOREPR.EQ.JPQUASI )    KSEC2(1) = JPFGGROT
        IF(NOREPR.EQ.JPQGGROT )   KSEC2(1) = JPFGGROT
        IF(NOREPR.EQ.JPGAUSSIAN ) KSEC2(1) = JPFGGROT
C
      ELSE
C
        IF( (NOREPR.EQ.JPQUASI).OR.(NOREPR.EQ.JPQGGROT) ) THEN
          KSEC2(1) = JPGAUSSIAN
        ELSE
          KSEC2(1) = NOREPR
        ENDIF
      ENDIF
C
C***********************************************************************
C     Section 3.1. Setup section 2 for lat/long, equidistant
C                  cylindrical or plate carre grids.
C***********************************************************************
C
 310  CONTINUE
C
      IF ( (NOREPR.EQ.JPREGULAR).OR.(NOREPR.EQ.JPREGROT) ) THEN
C
C       For south to north grids, only global area allowed (eg KWBC SST)
C
cs        IF( KSEC2(4).LT.KSEC2(7) ) THEN
cs          IF((NOAAPI(1).NE.(-NOAAPI(3))).AND.(NOAAPI(3).NE.JP90)) THEN
cs            CALL INTLOG(JP_ERROR,
cs     X        'GASETUP: Subareas not allowed interpolating',JPQUIET)
cs            CALL INTLOG(JP_ERROR,
cs     X        'GASETUP: grids running from south to north',JPQUIET)
cs            GASETUP = JPROUTINE + 2
cs            GOTO 900
cs          ENDIF
cs        ENDIF
C
C       Number of points along a parallel
C
        KSEC2(2) = NOWE
C
C       Number of points along a meridian
C
        KSEC2(3) = NONS
C
C       Resolution flag, increments are given
C
        KSEC2(6) = 128
C
C       Latitude and longitude of first/last grid point
C       La1/Lo1 - NOAAPI(1): north, NOAAPI(2): west
C       La2/Lo2 - NOAAPI(3): south, NOAAPI(4): east
C       EMOS-214: store REAL values in parallel data structure (real precision), for values that requiring sub-millidegree precision
C
        IF( NOAAPI(1).GE.0 ) THEN
          KSEC2(4) = (NOAAPI(1)+(JPMICRO/2)) / JPMICRO
        ELSE
          KSEC2(4) = (NOAAPI(1)-(JPMICRO/2)) / JPMICRO
        ENDIF
        IF( NOAAPI(2).GE.0 ) THEN
          KSEC2(5) = (NOAAPI(2)+(JPMICRO/2)) / JPMICRO
        ELSE
          KSEC2(5) = (NOAAPI(2)-(JPMICRO/2)) / JPMICRO
        ENDIF
        IF( NOAAPI(3).GE.0 ) THEN
          KSEC2(7) = (NOAAPI(3)+(JPMICRO/2)) / JPMICRO
        ELSE
          KSEC2(7) = (NOAAPI(3)-(JPMICRO/2)) / JPMICRO
        ENDIF
        IF( NOAAPI(4).GE.0 ) THEN
          KSEC2(8) = (NOAAPI(4)+(JPMICRO/2)) / JPMICRO
        ELSE
          KSEC2(8) = (NOAAPI(4)-(JPMICRO/2)) / JPMICRO
        ENDIF
        RSEC2(4:5) = FLOAT(NOAAPI(1:2))/JPMULT
        RSEC2(7:8) = FLOAT(NOAAPI(3:4))/JPMULT
C
C       Flip latitudes if they run from south to north
C       Set scanning mode flags
C
        IF( NOAAPI(1).LT.NOAAPI(3) ) THEN
          IF( LNOGRID ) THEN
            ITEMP = KSEC2(7)
            KSEC2(7) = KSEC2(4)
            KSEC2(4) = ITEMP
            RTEMP = RSEC2(7)
            RSEC2(7) = RSEC2(4)
            RSEC2(4) = RTEMP
            KSEC2(11) = 0
          ELSE
            KSEC2(11) = 64
          ENDIF
        ELSE
          KSEC2(11) = NOSCNM
        ENDIF
C
C       i and j  direction increments
C       EMOS-214: store REAL values in parallel data structure (real precision), for values that requiring sub-millidegree precision
C
        KSEC2( 9) = (NOGRID(1) + (JPMICRO/2)) / JPMICRO
        KSEC2(10) = (NOGRID(2) + (JPMICRO/2)) / JPMICRO
        RSEC2( 9) = FLOAT(NOGRID(1))/JPMULT
        RSEC2(10) = FLOAT(NOGRID(2))/JPMULT
C
C       Following left same as for input product
C       - no.of vertical coordinate parameters,
C       - lat/long of southern pole of rotation
C       - lat/long of pole of stretching
C
C       If rotated, put in new lat/long of southern pole of rotation
C       EMOS-214: store REAL values in parallel data structure (real precision), for values that requiring sub-millidegree precision
C
        IF( LIROTAT.OR.LOROTAT ) THEN
          IF( NOROTA(1).GE.0 ) THEN
            KSEC2(13) = (NOROTA(1) + (JPMICRO/2)) / JPMICRO
          ELSE
            KSEC2(13) = (NOROTA(1) - (JPMICRO/2)) / JPMICRO
          ENDIF
          IF( NOROTA(2).GE.0 ) THEN
            KSEC2(14) = (NOROTA(2) + (JPMICRO/2)) / JPMICRO
          ELSE
            KSEC2(14) = (NOROTA(2) - (JPMICRO/2)) / JPMICRO
          ENDIF
          RSEC2(13:14) = FLOAT(NOROTA(1:2))/JPMULT
        ENDIF
C
C       Regular grid flag
C
        KSEC2(17) = 0
C
C       Following left same as for input product
C       - earth flag
C       - components flag
C     Set the components flag for rotated U and V coefficients
C
        IF(LUVCOMP) THEN
          KSEC2(19) = 8
        ENDIF

C       - reserved fields
C
C     OCEAN
        IF(LOCEAN) THEN
c there is always bitmap for ocean
          ZASEC3(2) = RMISSGV
          KSEC3(2)  = int(RMISSGV)
          KSEC1(5)  = 192
c-------------------
          KSEC1(37) = 4
          KSEC1(60) = NIOCO3
          KSEC1(61) = NIOCO4
          KSEC1(62) = NOOCO4F
          KSEC1(63) = NOOCO3F
          KSEC1(64) = NOOCO4L
          KSEC1(65) = NOOCO3L
          KSEC1(66) = NOOIINC
          KSEC1(67) = NOOJINC
          KSEC1(68) = NOOIRGR
          KSEC1(69) = NOONOST
          KSEC1(71) = 0
          KSEC1(72) = 0
          KSEC1(73) = 0
          KSEC1(74) = 0
        ENDIF
      ENDIF
C
C***********************************************************************
C     Section 3.2. Setup section 2 for gaussian grids.
C***********************************************************************
C
 320  CONTINUE
C
      IF ( NOREPR.EQ.JPQUASI    .OR. NOREPR.EQ.JPQGGROT .OR.
     X     NOREPR.EQ.JPGAUSSIAN .OR. NOREPR.EQ.JPFGGROT ) THEN
C
C       Number of points along a parallel
C
C       For a regular gaussian grid only
        IF( (NOREPR.EQ.JPGAUSSIAN).OR.(NOREPR.EQ.JPFGGROT) ) THEN
          KSEC2(2) = NOWE
        ELSE
          KSEC2(2) = 0
        ENDIF
C
C       Number of points along a meridian
C
        KSEC2(3) = NONS
C
C       Resolution flag
C       For a regular gaussian grid only, increments are given
C
        IF( (NOREPR.EQ.JPGAUSSIAN).OR.(NOREPR.EQ.JPFGGROT) ) THEN
          KSEC2(6) = 128
        ELSE
          KSEC2(6) = 0
        ENDIF
C
C       Latitude and longitude of first/last grid point
C       La1/Lo1 - NOAAPI(1): north, NOAAPI(2): west
C       La2/Lo2 - NOAAPI(3): south, NOAAPI(4): east
C       EMOS-214: store REAL values in parallel data structure (real precision), for values that requiring sub-millidegree precision
C
        IF( NOAAPI(1).GE.0 ) THEN
          KSEC2(4) = (NOAAPI(1)+(JPMICRO/2)) / JPMICRO
        ELSE
          KSEC2(4) = (NOAAPI(1)-(JPMICRO/2)) / JPMICRO
        ENDIF
        IF( NOAAPI(2).GE.0 ) THEN
          KSEC2(5) = (NOAAPI(2)+(JPMICRO/2)) / JPMICRO
        ELSE
          KSEC2(5) = (NOAAPI(2)-(JPMICRO/2)) / JPMICRO
        ENDIF
        IF( NOAAPI(3).GE.0 ) THEN
          KSEC2(7) = (NOAAPI(3)+(JPMICRO/2)) / JPMICRO
        ELSE
          KSEC2(7) = (NOAAPI(3)-(JPMICRO/2)) / JPMICRO
        ENDIF
        IF( NOAAPI(4).GE.0 ) THEN
          KSEC2(8) = (NOAAPI(4)+(JPMICRO/2)) / JPMICRO
        ELSE
          KSEC2(8) = (NOAAPI(4)-(JPMICRO/2)) / JPMICRO
        ENDIF
        RSEC2(4:5) = FLOAT(NOAAPI(1:2))/JPMULT
        RSEC2(7:8) = FLOAT(NOAAPI(3:4))/JPMULT
        IF( (.NOT. LNOAREA .AND. (
     X      (NOREPR.EQ.JPQUASI    .OR. NOREPR.EQ.JPQGGROT))) .OR.
     X      (LGLOBL .AND.
     X      (NOREPR.EQ.JPGAUSSIAN .OR. NOREPR.EQ.JPFGGROT)) ) THEN
          RSEC2(4) = ROGAUSS(1)
          RSEC2(5) = 0
          RSEC2(7) = ROGAUSS(NOGAUSS*2)
          RSEC2(8) = 360. - 360./FLOAT(NOLPTS(NOGAUSS))
        ENDIF
C
C       i direction increment
C
C       For a regular gaussian grid, only
C
        KSEC2(9) = 0
        RSEC2(9) = 0.
        IF( (NOREPR.EQ.JPGAUSSIAN).OR.(NOREPR.EQ.JPFGGROT) ) THEN
          KSEC2(9) = (((JP90)/NOGAUSS)+(JPMICRO/2)) / JPMICRO
          RSEC2(9) = (FLOAT(JP90)/FLOAT(NOGAUSS))/JPMULT
        ENDIF
C
C       Number of parallels between a pole and the Equator
C
        KSEC2(10) = NOGAUSS
C
C       Scanning mode flags
C
        KSEC2(11) = NOSCNM
C
C       Following left same as for input product
C       - no.of vertical coordinate parameters,
C       - lat/long of southern pole of rotation
C       - lat/long of pole of stretching
C
C       If rotated, put in new lat/long of southern pole of rotation
C       EMOS-214: store REAL values in parallel data structure (real precision), for values that requiring sub-millidegree precision
C
        IF( LIROTAT.OR.LOROTAT ) THEN
          IF( NOROTA(1).GE.0 ) THEN
            KSEC2(13) = (NOROTA(1) + (JPMICRO/2)) / JPMICRO
          ELSE
            KSEC2(13) = (NOROTA(1) - (JPMICRO/2)) / JPMICRO
          ENDIF
          IF( NOROTA(2).GE.0 ) THEN
            KSEC2(14) = (NOROTA(2) + (JPMICRO/2)) / JPMICRO
          ELSE
            KSEC2(14) = (NOROTA(2) - (JPMICRO/2)) / JPMICRO
          ENDIF
          RSEC2(13:14) = FLOAT(NOROTA(1:2))/JPMULT
        ENDIF
C
C       Regular grid flag
C
        IF( (NOREPR.EQ.JPGAUSSIAN).OR.(NOREPR.EQ.JPFGGROT) ) THEN
          KSEC2(17) = 0
        ELSE
          KSEC2(17) = 1
        ENDIF
C
C       Following left same as for input product
C       - earth flag
C       - components flag
C     Set the components flag for rotated U and V coefficients
C
        IF(LUVCOMP) THEN
          KSEC2(19) = 8
        ENDIF

C       - reserved fields
C
C       For reduced grid, move in number of points along each parallel
C
          IF( (NOREPR.EQ.JPQUASI) .OR.
     X        (NOREPR.EQ.JPQGGROT) ) THEN
          DO ITEMP = 1, KSEC2(3)
            KSEC2(22+ITEMP) = NOLPTS(ITEMP)
          ENDDO
        ENDIF
C
      ENDIF
C
C***********************************************************************
C     Section 3.3. Setup section 2 for spherical harmonic coefficients.
C***********************************************************************
C
 330  CONTINUE
C
      IF ( (NOREPR.EQ.JPSPHERE).OR.(NOREPR.EQ.JPSPHROT) ) THEN
C
C       I, K, M pentagonal resolution parameters
C
        KSEC2(2) = NORESO
        KSEC2(3) = NORESO
        KSEC2(4) = NORESO
C
C       Representation type, associated legendre functions of the
C                            first kind
        KSEC2(5) = 1
C
C       Representation mode, complex packing
C
        KSEC2(6) = 2
C
C       Following left same as for input product
C       - reserved words 7-11
C       - no.of vertical coordinate parameters,
C       - lat/long of southern pole of rotation
C       - lat/long of pole of stretching
C       - reserved words 17-22
C
C       If rotated, put in new lat/long of southern pole of rotation
C       EMOS-214: store REAL values in parallel data structure (real precision), for values that requiring sub-millidegree precision
C
        IF( LIROTAT.OR.LOROTAT ) THEN
          IF( NOROTA(1).GE.0 ) THEN
            KSEC2(13) = (NOROTA(1) + (JPMICRO/2)) / JPMICRO
          ELSE
            KSEC2(13) = (NOROTA(1) - (JPMICRO/2)) / JPMICRO
          ENDIF
          IF( NOROTA(2).GE.0 ) THEN
            KSEC2(14) = (NOROTA(2) + (JPMICRO/2)) / JPMICRO
          ELSE
            KSEC2(14) = (NOROTA(2) - (JPMICRO/2)) / JPMICRO
          ENDIF
          RSEC2(13:14) = FLOAT(NOROTA(1:2))/JPMULT
        ENDIF
      ENDIF
C
C***********************************************************************
C     Section 3.   Setup output bitmap section 3.
C***********************************************************************
      IF(ISEC1(5).EQ.192) THEN
         KSEC3(2)  = NINT(RMISSGV)
         ZASEC3(2) = RMISSGV
cs         KSEC3(2)  = ISEC3(2)
cs         ZASEC3(2) = ZSEC3(2)
         KSEC1(5)  = 192
         ISEC1(5)  = 0
      ENDIF
C
C***********************************************************************
C     Section 4.   Setup output product section 4.
C***********************************************************************
C
 400  CONTINUE
C
C     Number of values to be packed
C
      IF ( (NOREPR.EQ.JPSPHERE).OR.(NOREPR.EQ.JPSPHROT) ) THEN
        KSEC4(1) = (NORESO + 1) * (NORESO + 2)
      ELSE IF( (NOREPR.EQ.JPQUASI).OR.(NOREPR.EQ.JPQGGROT) ) THEN
        KSEC4(1) = NOPCNT
      ELSE
        KSEC4(1) = NOWE * NONS
      ENDIF
C
C     If all the values are missing, set the count of values negative
C
      IF(NOMISS.NE.0) THEN
        KSEC4(1) = -KSEC4(1)
      ENDIF
C
C     Number of bits used for each packed value
C
      IF(LNOACC) THEN
        KSEC4(2) = NOACC
      ELSE
        KSEC4(2) = NIACC
      ENDIF
C
C     Type of data, spherical harmonic = 128, grid point = 0
C
      IF ( (NOREPR.EQ.JPSPHERE).OR.(NOREPR.EQ.JPSPHROT) ) THEN
        KSEC4(3) = 128
      ELSE
        KSEC4(3) = 0
      ENDIF
C
C     Type of packing, spherical harmonic = complex
C
      IF ( (NOREPR.EQ.JPSPHERE).OR.(NOREPR.EQ.JPSPHROT) ) THEN
        KSEC4(4) = 1
      ELSE
        KSEC4(4) = 4
      ENDIF

C     Sinisa added jpeg packing just for merging with grib_api
        IF( NOHFUNC.EQ.'C' ) THEN
c  spectral complex
            KSEC4(4) = 1
        ELSEIF( NOHFUNC.EQ.'S'.AND.NOREPR.EQ.JPSPHERE ) THEN
c  spectral simple
            KSEC4(4) = 2
        ELSEIF( NOHFUNC.EQ.'J' ) THEN
c  grid jpeg
            KSEC4(4) = 3
        ELSEIF( NOHFUNC.EQ.'S' ) THEN
c  grid simple
            KSEC4(4) = 4
        ELSEIF( NOHFUNC.EQ.'K' ) THEN
c  grid second order
            KSEC4(4) = 7
        ENDIF
C
C     Type of data = floating point
C
      KSEC4(5) = 0
C
C     Additional flags indicator = none
C
      KSEC4(6) = 0
C
C     Reserved word, set to 0
C
      KSEC4(7) = 0
C
C     Following set to simplest case
C     - no.of values indicator
C     - secondary bitmaps indicator
C     - values width indicator
C     - no.of bits for 2nd order values
C
      KSEC4(8)  = 0
      KSEC4(9)  = 0
      KSEC4(10) = 0
      KSEC4(11) = 0
C
C     Reserved words, set to 0
C
      KSEC4(12) = 0
      KSEC4(13) = 0
      KSEC4(14) = 0
      KSEC4(15) = 0
C
C     If spherical harmonics, set following for complex packing
C
      IF ( (NOREPR.EQ.JPSPHERE).OR.(NOREPR.EQ.JPSPHROT) ) THEN
C
C       KSEC4(16), pointer to start of packed data, setup by packing
C       KSEC4(17), scaling factor P, unchanged from input
C       KSEC4(18), pentagonal resolution parameter J for packing of subset,
C                  unchanged from input
C       KSEC4(19), pentagonal resolution parameter K for packing of subset,
C                  unchanged from input
C       KSEC4(20), pentagonal resolution parameter M for packing of subset,
C                  unchanged from input
C
      ELSE
        KSEC4(16:20) = 0
      ENDIF
C
C     Words 21-33 reserved, set to zero.
C
      KSEC4(21:33) = 0
C
C***********************************************************************
C     Section 9.   Closedown
C***********************************************************************
C
 900  CONTINUE
C
      RETURN
C
C     Invalid data represntation type
C
 910  CONTINUE
      CALL INTLOG(JP_ERROR,
     X  'GASETUP: Data representation type not recognized: ',NOREPR)
      CALL INTLOG(JP_ERROR,
     X  'GASETUP: Only the following types are recognized:',JPQUIET)
      CALL INTLOG(JP_ERROR,'GASETUP: Lat/long grid = ', JPREGULAR)
      CALL INTLOG(JP_ERROR,'GASETUP: Lat/long (rotated) = ', JPREGROT)
      CALL INTLOG(JP_ERROR,'GASETUP: regular gaussian = ', JPGAUSSIAN)
      CALL INTLOG(JP_ERROR,'GASETUP: reg gauss rotated = ', JPFGGROT)
      CALL INTLOG(JP_ERROR,'GASETUP: reduced gaussian = ', JPQUASI)
      CALL INTLOG(JP_ERROR,'GASETUP: red gauss rotated = ', JPQUASI)
      CALL INTLOG(JP_ERROR,'GASETUP: spherical harmonic = ', JPSPHERE)
      CALL INTLOG(JP_ERROR,'GASETUP: spectral (rotated) = ', JPSPHROT)
C
      GASETUP = JPROUTINE + 1
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE ECDEF3( HFUNC, KSEC1, KGRIB, KLENG, KNSPT, KBITS,
     X                   KPR, KRET)
C
C---->
C**** ECDEF3
C
C     Purpose.
C     --------
C
C     GRIB coding/decoding of ECMWF local use definition 3.
C     (Satellite image data).
C
C**   Interface.
C     ----------
C
C     CALL ECDEF3( HFUNC, KSEC1, KGRIB, KLENG, KNSPT, KBITS, KPR, KRET)
C
C
C     Input Parameters.
C     -----------------
C
C     HFUNC      - Requested function.
C                  'C' to code data.
C                  'D' to decode data.
C
C     KSEC1      - Array containing Grib Section 1 data.
C
C     KGRIB      - Array containing Grib coded data.
C
C     KLENG      - Length (words) of KGRIB.
C
C     KNSPT      - Bit number after which insertion/extraction starts.
C
C     KBITS      - Number of bits in computer word.
C
C     KPR        - Debug print switch.
C                  0  , No printout.
C                  >0 , Debug printout.
C
C     KRET       - Response to error indicator.
C                  0        , Abort if error encountered.
C                  Non-zero , Return to calling routine
C                                       even if error encountered.
C
C     Output Parameters.
C     ------------------
C
C     KSEC1      - Array containing Grib Section 1 data.(Updated)
C
C     KGRIB      - Array containing Grib coded data.(Updated)
C
C     KNSPT      - Number of bit after last one inserted/extracted.(Updated)
C
C     KRET       - Return code.
C                  0   , No error encountered.
C                  2   , Error reported by routine INXBIT.
C
C     Method.
C     -------
C
C     Input data packed/unpacked in accordance with ECMWF usage of
C     local part of section 1 of Grib code, definition 3.
C
C
C     Externals.
C     ----------
C
C     INXBIT
C     ABORTX
C     CSGNBT
C     DSGNBT
C
C
C     Reference.
C     ----------
C
C     WMO Manual On Codes for Grib Code.
C
C
C     Comments.
C     ---------
C
C     Adapted from ECLOC1.F - simplified to handle just definition 3.
#include "ecdef3.h"
C
C
C     Author.
C     -------
C
C     J.D.Chambers     ECMWF      18th January 1995
C
C
C     Modifications.
C     --------------
C
C     None.
C
C
C----<
C     ------------------------------------------------------------------
C*    Section 0 . Definition of variables. Data statements.
C     ------------------------------------------------------------------
C
      IMPLICIT NONE
C
#include "common/grprs.h"
C
C     Parameters
      CHARACTER*1   HFUNC
      INTEGER KSEC1, KGRIB, KLENG, KNSPT, KBITS, KPR, KRET
      DIMENSION KGRIB(*)
      DIMENSION KSEC1(*)
C
C     Local variables
      INTEGER IRET, IZERO
C
      LOGICAL LENCODE
C
C     ------------------------------------------------------------------
C*    Section 1 . Set initial values.
C     ------------------------------------------------------------------
C
  100 CONTINUE
C
      IRET = KRET
      LENCODE = ( HFUNC .EQ. 'C' )
C
C     ------------------------------------------------------------------
C*    Section 2 .  Satellite image data, definition 3.
C     ------------------------------------------------------------------
C
  200 CONTINUE
C
C     Octet 50 : band  number.
C     Octet 51 : function code.
C     Two 8 bit fields.
C
C     Insert/extract fields.
C
      CALL INXBIT (KGRIB,KLENG,KNSPT,KSEC1(42),2,KBITS, 8,HFUNC,KRET)
      IF (KRET.NE.0) THEN
        KRET = 2
        WRITE(GRPRSM,9004)
      ENDIF
C
C     Octet 52 : Reserved.
C     Set to 0.
C
      IF ( LENCODE ) THEN
        IZERO = 0
        CALL INXBIT(KGRIB,KLENG,KNSPT,IZERO,1,KBITS,8,HFUNC,KRET)
        IF (KRET.NE.0) THEN
          KRET = 2
          WRITE(GRPRSM,9004)
        ENDIF
      ELSE
        KNSPT = KNSPT + 8
      ENDIF
C
C
C     ------------------------------------------------------------------
C*    Section 9 . Abort/return to calling routine. Format statements.
C     ------------------------------------------------------------------
C
  900 CONTINUE
C
      IF( KPR.GE.1 ) THEN
        WRITE(GRPRSM,*) 'ECDEF3 : Section 9.'
        WRITE(GRPRSM,*) '         Output values set -'
        WRITE(GRPRSM,9003) KNSPT
      ENDIF
C
C     Abort if requested to do so when an error has been encountered.
C
      IF (IRET.EQ.0.AND.KRET.NE.0) THEN
        CALL ABORTX ('ECDEF3')
      ELSE
        RETURN
      ENDIF
C
 9003 FORMAT (1H ,'         KNSPT  = ',I12)
C
 9004 FORMAT (' ECDEF3: Error reported by routine INXBIT.')
C
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE BUENS4(KSEC3,KSEC4,KELEM,KVALS,VALUES,CVALS,
     1                  KBUFL,KBUFF,KERR)
C
C**** *BUENS4*
C
C
C     PURPOSE.
C     --------
C          PACK PRELIMINARY ITEMS AND DATA OF SECTION 4 OF BUFR MESSAGE.
C
C
C**   INTERFACE.
C     ----------
C
C          *CALL* *BUENS4(KSEC3,KSEC4,KELEM,KVALS,VALUES,CVALS,
C                         KBUFL,KBUFF,KERR)*
C
C        INPUT :
C               *KSEC3*   -  ARRAY CONTAINING SECTION 3 INFORMATION
C                            KSEC3( 1)-- LENGTH OF SECTION 3 (BYTES)
C                            KSEC3( 2)-- RESERVED
C                            KSEC3( 3)-- NUMBER OF SUBSETS
C                            KSEC3( 4)-- FLAG (DATA TYPE,DATA COMPRESSION)
C               *KSEC4*   -  ARRAY CONTAINING SECTION 4 INFORMATION
C                            KSEC4( 1)-- LENGTH OF SECTION 4 (BYTES)
C                            KSEC4( 2)-- RESERVED
C               *KELEM*   -  NUMBER OF ELEMENTS IN BUFR TEMPLATE
C               *KVALS*   -  DIMENSION OF VALUES ARRAY
C               *VALUES*  -  REAL ARRAY (EXPANDED DATA VALUES)
C
C        OUTPUT :
C               *KBUFL*   -  LENGTH OF BUFR MESSAGE (WORDS)
C               *KBUFF*   -  ARRAY CONTAINING BUFR MESSAGE
C               *KERR*    -  RETURNED ERROR CODE
C
C     METHOD.
C     -------
C
C           NONE.
C
C
C     EXTERNALS.
C     ----------
C
C          BUPCK          -  PACK BIT PATHERN
C          BUPKS          -  PACK BIT PATHERN IN REPEATED WAY,
C                            POINTER ADJUSTMENT
C          BUOCTN         -  SET LENGTH OF SECTION
C
C
C     REFERENCE.
C     ----------
C
C          NONE.
C
C     AUTHOR.
C     -------
C
C          M. DRAGOSAVAC    *ECMWF*       17/01/91.
C
C
C     MODIFICATIONS.
C     --------------
C
C          NONE.
C
C
      IMPLICIT LOGICAL(L,O,G), CHARACTER*8(C,H,Y)
C
C
#     include "parameter.F"
#     include "bcomunit.F"
#     include "bcmwork.F"
#     include "bcmwt.F"
#     include "bcmwtc.F"
#     include "bcmbef.F"
#     include "bcprq.F"
#     include "bcmoff.F"
C
      CHARACTER*64 CWTEN
      CHARACTER*24 CWTU
C
      DIMENSION KBUFF(KBUFL)
C
      DIMENSION KSEC3(JSEC3),KSEC4(JSEC4)
#ifndef R_4
      REAL*8 VALUES(KVALS)
      REAL*8 RVIND
      REAL*8 EPS
      REAL*8 VAL,VAL8S
      REAL*8 VCHECK
      REAL*8 RVALS(JWORK)
#else
      REAL   VALUES(KVALS)
      REAL   RVIND
      REAL   EPS
      REAL   VAL
      REAL   VCHECK
      REAL   RVALS(JWORK)
#endif
C
      REAL*4 RVALS4(JWORK)
      REAL*4 VAL4,VAL4S
      INTEGER*4 I4
      REAL*8 R8
      REAL*4 R4
      LOGICAL OBIG, OEQUAL
      LOGICAL BIG_ENDIAN
C
      DIMENSION IVALS(JWORK),INC(JELEM),ILOCVAL(JELEM)
      DIMENSION IIVALS(JELEM)
C
      CHARACTER*80 CVALS(KVALS)
      CHARACTER*80 YVAL
C
      DIMENSION IMASK(8),IMAXV(32)
      DATA IMASK/1,2,4,8,16,32,64,128/
C     DATA ILOCVAL/JELEM*0/
C
      DATA IMAXV/1,3,7,15,31,63,127,255,511,1023,2047,4095,8191,
     1  16383,32767,65535,131071,262143,524287,1048575,2097151,
     2  4194305,8388607,16777215,33554431,671108863,134217727,
     3  268435455,536870911,1073741823,2147483647,2147483647/
C
      SAVE IWPTB,IBPTB
C     ------------------------------------------------------------------
C*          1.  PACK PRELIMINARY ITEMS OF SECTION 4.
C               ------------------------------------
 100  CONTINUE
C
      IF(KERR.GT.0) RETURN
C
#if defined(gfortran)
      R4=HUGE(R4)
      R8=HUGE(R8)
#else
      R4=3.4028235e+38
      R8=1.7976931348623157D+308
#endif
C
C*          1.1  KEEP POINTERS TO THE BEGINING OF THE SECTION.
C                ---------------------------------------------
 110  CONTINUE
C
      IF(OMULTI) THEN
        IF(NSUBSET.EQ.1) THEN
           IWPTB = NWPT
           IBPTB = NBPT 
        END IF
      ELSE
         IWPTB = NWPT
         IBPTB = NBPT
      END IF

c     IF(OMULTI.AND.NSUBSET.EQ.1) THEN
      IF(NSUBSET.EQ.1) THEN
C
C*          1.2  PACK LENGTH OF SECTION 4.
C                -------------------------
 120  CONTINUE
C
         CALL BUPCK(NBPW,KBUFF(NWPT),0,NWPT,NBPT,24,KERR)
         IF(KERR.GT.0) THEN
            WRITE(KNTN,*) 'ERROR PACKING LENGTH OF SECTION 4.'
            RETURN
         END IF
C
C*          1.4  PACK RESERVED BYTE.
C                -------------------
 140     CONTINUE
C
         CALL BUPCK(NBPW,KBUFF(NWPT),0,NWPT,NBPT, 8,KERR)
         IF(KERR.GT.0) THEN
            WRITE(KNTN,*)'ERROR PACKING RESERVED BYTE IN SECTION 4.'
            RETURN
         END IF
C
      END IF
C     -----------------------------------------------------------------
C*          2. PACK DATA.
C              ----------
 200  CONTINUE
C
C      IKK=KELEM*KSEC3(3)
C      IF(IKK.GT.JWORK) THEN
C         KERR=17
C         CALL BUERR(KERR)
C         WRITE(KNTN,*)'CHECK VALUES OF KELEM AND NUMBER OF SUBSETS KSEC3(3).'
C         RETURN
C      END IF
C      IF(IKK.GT.KVALS) THEN
C         KERR=14
C         CALL BUERR(KERR)
C         WRITE(KNTN,*)'KVALS MUST BE GREATER THAN KELEM*KSEC3(3).'
C         RETURN
C      END IF
C
C*          2.1  CHECK IF DATA HAS TO BE COMRESSED.
C                ----------------------------------
 210  CONTINUE
C
      IB=0
      IF(IAND(KSEC3(4),IMASK(7)).NE.0) IB=1
C
C
C     ------------------------------------------------------------------
C
C*          3.  UNCOMPRESSED DATA.
C               ------------------
 300  CONTINUE
C
      IF(IB.EQ.0) THEN
C
         N=KSEC3(3)
         IF(OMULTI) N=1
         
         DO 301 I=1,N
C
         IF(OMULTI) THEN
            IM1K=(NSUBSET-1)*KELEM
         ELSE
            IM1K=(I-1)*KELEM
         END IF
C
         DO 302 J=1,M
C
         
C        IF(NWTR(J).EQ.31011.OR.NWTR(J).EQ.31012) THEN
C           IRP=VALUES(J+IM1K)             
C           DO III=J+2,J+IRP
C            NWTDW(iii)=0
C           END DO
C        END IF
C
         IF(NWTDW(J).EQ.0) GO TO 302
C
         
         IREF  =NWTRV(J)
         ISCALE=NWTS (J)
         IBDW  =NWTDW(J)
C
         JI=J+IM1K
C
         VAL=VALUES(JI)
         IF(NWTEN(J).EQ.-999) THEN
            IBYTES=NWTDW(J)/8
            IF(ABS(VAL-RVIND)/RVIND.LE.EPS) THEN
               IF(IBYTES.EQ.4) VAL=R4
               IF(IBYTES.EQ.8) VAL=R8
            END IF
            IF(IBYTES.EQ.4) THEN
               VAL4=VAL
               OBIG=BIG_ENDIAN()
               IF(.NOT.OBIG) THEN
                  CALL SWAP_BYTES4(VAL4,VAL4S)
                  VAL4=VAL4S
               END IF
               CALL BUGBYTESR4(VAL4,ILOCVAL,0,8,0,IBYTES)
            ELSE
               OBIG=BIG_ENDIAN()
               IF(.NOT.OBIG) THEN
                  CALL SWAP_BYTES8(VAL,VAL8S)
                  VAL=VAL8S
               END IF
               CALL BUGBYTESR8(VAL,ILOCVAL,0,8,0,IBYTES)
            END IF
            ISKIP=0
            CALL BUPKS(NBPW,KBUFF(NWPT),ILOCVAL,NWPT,NBPT,8,
     1                ISKIP,IBYTES,KERR)
            IF(KERR.GT.0) THEN
               WRITE(KNTN,*)'BUENS4 :'
               WRITE(KNTN,*)'ERROR PACKING REAL IEEE'
               CALL BUERR(KERR)
               RETURN
            END IF
            GO TO 302
         END IF
C
         IF(NWTEN(J).EQ.836970) THEN
            IF(VAL.LT.0) THEN
               IPACK=ABS(NINT(VAL))
               IBDW1=1
               CALL BUPCK(NBPW,KBUFF(NWPT),1,NWPT,NBPT,IBDW1,KERR)
               IBDWM1=IBDW-1
               CALL BUPCK(NBPW,KBUFF(NWPT),IPACK,NWPT,NBPT,IBDWM1,KERR)
            ELSE
               IPACK=NINT(VAL)
               CALL BUPCK(NBPW,KBUFF(NWPT),IPACK,NWPT,NBPT,IBDW,KERR)
            END IF
            GO TO 302
         END IF
C
         IF(NWTEN(J).EQ.658367) THEN
            IF(ABS(VAL-RVIND)/RVIND.LE.EPS) THEN
              YVAL=' '
              NCHAR=NWTDW(J)
              DO 3031 II=1,NCHAR/8
C             IPACK=ICHAR(YVAL(II:II))
              IPACK=255
              IF(IPACK.GT.IMAXV(8)) IPACK=IMAXV(8)
              CALL BUPCK(NBPW,KBUFF(NWPT),IPACK,NWPT,NBPT,8,KERR)
              IF(KERR.GT.0) THEN
                 WRITE(KNTN,*)'ERROR PACKING ',JI,' VALUE FOR ',J,
     1                        ' ELEMENT.'
                 RETURN
              END IF
 3031         CONTINUE
              GO TO 302

            ELSE
              IST=NINT(VAL)/1000
              YVAL=CVALS(IST)
              NCHAR=NWTDW(J)/8
              DO 303 II=1,NCHAR
              IPACK=ICHAR(YVAL(II:II))
              IF(IPACK.GT.IMAXV(8)) IPACK=IMAXV(8)
              CALL BUPCK(NBPW,KBUFF(NWPT),IPACK,NWPT,NBPT,8,KERR)
              IF(KERR.GT.0) THEN
                 WRITE(KNTN,*)'ERROR PACKING ',JI,' VALUE FOR ',J,
     1                        ' ELEMENT.'
                 RETURN
              END IF
 303          CONTINUE
              GO TO 302
            END IF
         END IF
C        
         IF(ABS(VAL-RVIND)/RVIND.LE.EPS) THEN
            CALL BUPCK(NBPW,KBUFF(NWPT),NMASK(IBDW),NWPT,NBPT,IBDW,KERR)
            IF(KERR.GT.0) THEN
               WRITE(KNTN,*)'ERROR PACKING ',JI,' VALUE FOR ',J,
     1                      ' ELEMENT.'
               RETURN
            END IF
         ELSE
C
C        CHECK VAL VALUE FOR POSSIBLE OVERFLOW
C

            IF(NOFL.EQ.1) THEN
               IF(ABS(VAL).LT.EPS) VAL = 0.0
               IF(VAL.GE.0) THEN
                  ICHECK=IMAXV(IBDW)
                  ICHECK=ICHECK+IREF
                  VCHECK=ICHECK*10.**(-ISCALE)
C
                  IF(VAL .GT. VCHECK) THEN
                     WRITE(KNTN,*) 'VALUE=',VAL,'TOO BIG FOR ',
     1                      J,' ELEMENT ',I,' SUBSET.'
                     VAL=VCHECK+1.
                  END IF
               ELSE
                  VCHECK=IREF/10.**ISCALE
                  IF(VAL.LT.VCHECK) THEN
                WRITE(KNTN,*)'VALUE=',VAL,'TOO BIG NEGATIVE FOR ',
     1                      J,' ELEMENT ',I,' SUBSET.'
                     VAL=IREF/10.**ISCALE-1.
                  END IF
               END IF
            END IF

            IF(ISCALE.LT.0) THEN
               ISCALE=IABS(ISCALE)
               IPACK=NINT(VAL/10.**ISCALE) - IREF
            ELSE
               IPACK=NINT(VAL*10.**ISCALE) - IREF
            END IF
C
C           CHECK IF VALUE TO BE PACKED NEGATIVE
C
            IF(IPACK.LT.0) THEN
               KERR=-33
               WRITE(KNTN,*)'BUENS4:'
               WRITE(KNTN,*)'VALUE ',IPACK,' IS NEGATIVE'
               WRITE(KNTN,*)'PROBABLY REFERENCE VALUE TOO BIG.'
               WRITE(KNTN,*)J,' ELEMENT = ',NWTR(J),
     1               ' REFERENCE VALUE = ',IREF
               IPACK=0
               WRITE(KNTN,*)'ELEMENT VALUE PACKED AS',IREF
            END IF
C
C*          CHECK IF VALUE TO BE PACKED TOO BIG.
C
            IF(IPACK.GT.IMAXV(IBDW)) THEN
C
               IF(NPMISS.EQ.0) THEN
                KERR=-28
                WRITE(KNTN,*)'VALUE ',IPACK,' TOO BIG.'
                WRITE(KNTN,*)'VALUE FOR ',J,' ELEMENT AND ',I,
     1                       ' SUBSET'
                WRITE(KNTN,*)'PACKED AS MISSING VALUE FOR',
     1                         ' DATA WIDTH -1.'
                IPACK=IMAXV(IBDW)-1
               ELSE
C
C                 ALL ELEMENTS IN CLASS 1 TO 9 MUST BE CORRECT
C
                  IF(NWTR(J).GE.31000.AND.NWTR(J).LE.31012) THEN
                     WRITE(KNTN,*)'VALUE ',IPACK,' TOO BIG.'
                     WRITE(KNTN,*)'VALUE FOR ',J,' ELEMENT AND ',I,
     1                           ' SUBSET'
                     KERR=28
                     CALL BUERR(KERR)
                     RETURN
                  END IF
C
                  KERR=-28
                  WRITE(KNTN,*)'VALUE ',IPACK,' TOO BIG.'
                  WRITE(KNTN,*)'VALUE FOR ',J,' ELEMENT AND ',I,
     1                         ' SUBSET'
                  WRITE(KNTN,*)'PACKED AS MISSING VALUE FOR',
     1                         '  DATA WIDTH.'
                  IPACK=IMAXV(IBDW)
               END IF
            END IF
            CALL BUPCK(NBPW,KBUFF(NWPT),IPACK,NWPT,NBPT,IBDW,KERR)
            IF(KERR.GT.0) THEN
               WRITE(KNTN,*)'ERROR PACKING ',JI,' VALUE FOR ',J,
     1         ' ELEMENT.'
               WRITE(KNTN,*)'VALUE ',IPACK,' DATA WIDTH ',IBDW,
     1         ' BITS'
               RETURN
            END IF
         END IF
C
 302     CONTINUE
 301     CONTINUE
C
         NWP=NWPT
         NBP=NBPT
      END IF
C
C*          4.  COMPRESS DATA.
C               --------------
 400  CONTINUE
C
      IF(IB.EQ.1) THEN
         DO 402 J=1,M
C
         IF(NWTDW(J).EQ.0) GO TO 402
C
         IREF  =NWTRV(J)
         ISCALE=NWTS (J)
         IBDW  =NWTDW(J)
C
         DO 401 I=1,KSEC3(3)
C
         JI=J+(I-1)*KELEM
C
         IF(NWTEN(J).EQ.658367) THEN
            IVALS(JI)=VALUES(JI)
            GO TO 401
         END IF
C
         IF(NWTEN(J).EQ.-999) THEN
            IF(NWTDW(J).EQ.32) THEN
               IF(ABS(VALUES(JI)-RVIND)/RVIND.LT.EPS) THEN
                  RVALS4(JI)=R4
               ELSE
                  RVALS4(JI)=VALUES(JI)
               END IF
            ELSE
              IF(ABS(VALUES(JI)-RVIND)/RVIND.LT.EPS) THEN 
                 RVALS(JI)=R8
               ELSE
                 RVALS(JI)=VALUES(JI)
               END IF
            END IF
            GO TO 401
         END IF
C
         IF(NWTEN(J).EQ.836970) THEN
            ISG_REF=0
            IF(VALUES(JI).LT.0) ISG_REF=1
            IVALS(JI)=IABS(NINT(VALUES(JI)))
            GO TO 401
         END IF
C
         IF(ABS(VALUES(JI)-RVIND)/RVIND.LE.EPS) THEN
            IVALS(JI)=NMASK(IBDW)
         ELSE
            IF(NOFL.EQ.1) THEN
               IF(VALUES(JI).GE.0) THEN
                  ICHECK=IMAXV(IBDW)
                  ICHECK=ICHECK+IREF
                  VCHECK=ICHECK*10.**(-ISCALE)
C
                  IF(VALUES(JI) .GT. VCHECK) THEN
                     WRITE(KNTN,*) 'VALUE=',VALUES(JI),'TOO BIG FOR ',
     1                      J,' ELEMENT AND ',I,' SUBSET.'
                     VALUES(JI)=VCHECK+1.
                  END IF
               ELSE
                  VCHECK=IREF/10.**ISCALE
                  IF(VALUES(JI).LT.VCHECK) THEN 
                     WRITE(KNTN,*) 'VALUE=',VALUES(JI),
     1                      'TOO BIG NEGATIVE FOR ',
     1                      J,' ELEMENT AND ',I,' SUBSET.'
                     VALUES(JI)=IREF/10.**ISCALE-1.
                  END IF
               END IF
            END IF
C
            IF(ISCALE.LT.0) THEN
               ISCAL=IABS(ISCALE)
               IPACK=NINT(VALUES(JI)/10.**ISCAL ) - IREF
            ELSE
               IPACK=NINT(VALUES(JI)*10.**ISCALE) - IREF
            END IF
C
            IF(IPACK.LT.0) THEN
               WRITE(KNTN,*)'BUENS4 :'
               KERR=-33
               WRITE(KNTN,*)'VALUE ',IPACK,' IS NEGATIVE'
               WRITE(KNTN,*)'PROBABLY REFERENCE VALUE TOO BIG.'
               WRITE(KNTN,*)J,'ELEMENT = ',NWTR(J),
     1                    ' REFERENCE VALUE = ',IREF
               IPACK=0
               WRITE(KNTN,*)'ELEMENT PACKED AS',IREF
            END IF
C
C           REPLACE IPACK VALUE WITH MISSING VALUE FOR IBDW -1 
C           IF GREATER THEN MAXIMUM ALLOWED.
C
            IF(IPACK.GT.IMAXV(IBDW)) THEN
C
               IF(NPMISS.EQ.0) THEN
                  KERR=-28
                  WRITE(KNTN,*)'VALUE ',IPACK,' TOO BIG.'
                  WRITE(KNTN,*)'VALUE FOR ',J,' ELEMENT AND ',I,
     1            ' SUBSET'
                  WRITE(KNTN,*)'PACKED AS MISSING VALUE FOR DATA ',
     1                         'WIDTH -1.'
                  IPACK=IMAXV(IBDW)-1
               ELSE
C
C                 ALL ELEMENTS IN CLASS 1 TO 9 MUST BE CORRECT
C
                  IF(NWTR(J).GE.31000.AND.NWTR(J).LE.31012) THEN
                     KERR=28
                     CALL BUERR(KERR)
                     WRITE(KNTN,*)'VALUE ',IPACK,' TOO BIG.'
                     WRITE(KNTN,*)'VALUE FOR ',J,' ELEMENT AND ',I,
     1               ' SUBSET'
                     RETURN
                  END IF
C
                  KERR=-28
                  WRITE(KNTN,*)'VALUE ',IPACK,' TOO BIG.'
                  WRITE(KNTN,*)'VALUE FOR ',J,' ELEMENT AND ',I,
     1            ' SUBSET'
                  WRITE(KNTN,*)'PACKED AS MISSING VALUE.'
                  IPACK=IMAXV(IBDW)
               END IF
            END IF
            IVALS(JI)=IPACK
C
         END IF
C
 401     CONTINUE
 402     CONTINUE
C
C*          4.1  CHECK IF ALL VALUES ARE MISSING.
C
 410  CONTINUE
C
         DO 411 I=1,M
C
         IF(NWTDW(I).EQ.0) GO TO 411
         IBDW  =NWTDW(I)
C
         OMIS=.TRUE.
         IF(NWTEN(I).EQ.658367) THEN
            OMIS=.FALSE.
         ELSEIF(NWTEN(I).EQ.-999) THEN
            OMIS=.FALSE.
         ELSE
            DO 412 J=1,KSEC3(3)
            IJ=I+(J-1)*KELEM
            IF(IVALS(IJ).NE.NMASK(IBDW)) THEN
               OMIS=.FALSE.
            END IF
 412        CONTINUE
         END IF
C
         IF(.NOT.OMIS) THEN
C
            IF(NWTEN(I).NE.658367.AND.NWTEN(I).NE.-999) THEN
C
C              FIND MINIMUM VALUE FOR ELEMENT
C
               MIN=IVALS(I)
               DO 413 J=1,KSEC3(3)
               IJ=I+(J-1)*KELEM
               IF(IVALS(IJ).LT.MIN) MIN=IVALS(IJ)
 413           CONTINUE
C
C              FIND INCREMENTS
C
               DO 414 J=1,KSEC3(3)
               IJ=I+(J-1)*KELEM
               INC(J)=IVALS(IJ)-MIN
               IF(IVALS(IJ).EQ.NMASK(IBDW)) INC(J)=NVIND
 414           CONTINUE
C
C              FIND NUMBER OF BITS NEEDED FOR MAX VALUE OF INCREMENT
C
               MAX=0
               DO 415 J=1,KSEC3(3)
               IF(INC(J).NE.NVIND.AND.INC(J).GT.MAX) MAX=INC(J)
 415           CONTINUE
C
C              CHECK IF ALL INCREMENTS ARE ZERO
C
               INC0=0
               DO 419 J=1,KSEC3(3)
               IF(INC(J).NE.0) INC0=1
 419           CONTINUE
C
C              FIND NUMBER OF BITS NEEDED
C
               IF(INC0.NE.0) THEN
                  MAX=MAX+1
                  DO 416 J=1,32
                  IR=MAX/2
                  IF(IR.EQ.0) GO TO 417
                  MAX=IR
 416              CONTINUE
C
               END IF
C
 417           CONTINUE
C
               INCBIT=0
               IF(INC0.NE.0) INCBIT=J
C
C              REPLACE MISSING VALUES FOR INCREMENT BY ALL BITS SET TO 1.
C
               DO 418 J=1,KSEC3(3)
               IF(INC(J).EQ.NVIND) INC(J)=NMASK(INCBIT)
 418           CONTINUE
            END IF
         END IF
C
C*          4.2  PACK DATA IN COMPRESSED FORM.
C                -----------------------------
 420  CONTINUE
C
         IF(NWTEN(I).EQ.658367) THEN
C
            OSTRING=.TRUE.
            JI1=I
            IST1=IVALS(JI1)/1000
            ICS=NWTDW(I)/8
C           ICS=NINT(VALUES(JI1))-IST1*1000
            NCSMAX=ICS
            DO  IX=ICS,1,-1
            IF(CVALS(IST1)(IX:IX).NE.' ') THEN
               NCS=IX
               GO TO 522
            END IF
            END DO

 522        NCSMAX=NCS
            DO J=2,KSEC3(3)
            JI=I+(J-1)*KELEM
            IST=VALUES(JI)/1000
            IF(CVALS(IST1).NE.CVALS(IST)) OSTRING=.FALSE.
C           FIND MAX SIZE OF STRINGS
            ICS=NWTDW(I)/8
C           ICS=NINT(VALUES(JI))-IST*1000
            DO  IX=ICS,1,-1
            IF(CVALS(IST)(IX:IX).NE.' ') THEN
               NCS=IX
               GO TO 521
            END IF
            END DO
 521        CONTINUE
            IF(NCS.GT.NCSMAX) NCSMAX=NCS 
            END DO

C
            IF(OSTRING) THEN
C
              INCHAR=NWTDW(I)/8
              ISKIP=0
              DO II=1,INCHAR
              IPACK=ICHAR(CVALS(IST1)(II:II))
              CALL BUPCK(NBPW,KBUFF(NWPT),IPACK,NWPT,NBPT,8,KERR) 
              IF(KERR.GT.0) THEN
                 WRITE(KNTN,*)'BUENS4 :'
                 CALL BUERR(KERR)
                 RETURN
              END IF
              END DO
              IPACK=0
              CALL BUPCK(NBPW,KBUFF(NWPT),IPACK,NWPT,NBPT,6,KERR)
              IF(KERR.GT.0) THEN
                 WRITE(KNTN,*)'BUENS4 :'
                 CALL BUERR(KERR)
                 RETURN
              END IF
            ELSE
C
C           PACK LOCAL REFERENCE VALUE FOR ELEMENT
C
            INCHAR=NWTDW(I)/8
            ISKIP=0
            CALL BUPKS(NBPW,KBUFF(NWPT),ILOCVAL,NWPT,NBPT,8,
     1                ISKIP,INCHAR,KERR)
            IF(KERR.GT.0) THEN
               WRITE(KNTN,*)'BUENS4 :'
               WRITE(KNTN,*)'ERROR PACKING LOCAL REFERENCE VALUE'
               CALL BUERR(KERR)
               RETURN
            END IF
C
C           PACK NUMBER OF BITS FOR INCREMENTS/NUMBER OF CHARACTERS
C
C           CALL BUPCK(NBPW,KBUFF(NWPT),INCHAR,NWPT,NBPT,6,KERR)
            CALL BUPCK(NBPW,KBUFF(NWPT),NCSMAX,NWPT,NBPT,6,KERR)
            IF(KERR.GT.0) THEN
              WRITE(KNTN,*)'BUENS4 :'
              WRITE(KNTN,*)'ERROR PACKING NUMBER OF BITS FOR INCREMENTS'
              CALL BUERR(KERR)
              RETURN
            END IF
C
C           PACK INCREMENTS
C
            DO 421 J=1,KSEC3(3)
C
            JI=I+(J-1)*KELEM
C
            IST=IVALS(JI)/1000
            YVAL=CVALS(IST)
C
            DO 423 II=1,NCSMAX
            IPACK=ICHAR(YVAL(II:II))
            CALL BUPCK(NBPW,KBUFF(NWPT),IPACK,NWPT,NBPT,8,KERR)
            IF(KERR.GT.0) THEN
               WRITE(KNTN,*)'BUENS4 :'
               CALL BUERR(KERR)
               RETURN
            END IF
 423        CONTINUE
C
 421        CONTINUE
C
            END IF
         ELSEIF(NWTEN(I).EQ.-999) THEN
C
            OEQUAL=.TRUE.
            DO J=1,KSEC3(3)-1
            JI=I+(J-1)*KELEM
            JII=I+J*KELEM
            IF(NWTDW(I).EQ.32) THEN
               IF(ABS(RVALS4(JI)-RVALS4(JII))/RVALS4(JII).GT.EPS) THEN
                  OEQUAL=.FALSE.
                  GO TO 4444
               END IF

            ELSE
               IF(ABS(RVALS(JI)-RVALS(JII))/RVALS(JII).GT.EPS) THEN
                  OEQUAL=.FALSE.
                  GO TO 4444
               END IF
            END IF
            END DO
C
C           PACK LOCAL REFERENCE VALUE FOR ELEMENT
C
4444        INCHAR=NWTDW(I)/8
            ISKIP=0

            IF(.NOT.OEQUAL) THEN
C
              CALL BUPKS(NBPW,KBUFF(NWPT),ILOCVAL,NWPT,NBPT,8,
     1                  ISKIP,INCHAR,KERR)
              IF(KERR.GT.0) THEN
                 WRITE(KNTN,*)'BUENS4 :'
                 WRITE(KNTN,*)'ERROR PACKING LOCAL REFERENCE VALUE'
                 CALL BUERR(KERR)
                 RETURN
              END IF
C
C             PACK NUMBER OF BITS FOR INCREMENTS/NUMBER OF CHARACTERS
C
              CALL BUPCK(NBPW,KBUFF(NWPT),INCHAR,NWPT,NBPT,6,KERR)
              IF(KERR.GT.0) THEN
                 WRITE(KNTN,*)'BUENS4 :'
                 WRITE(KNTN,*)'ERROR PACKING NUMBER OF BITS
     1                         FOR INCREMENTS'
                 CALL BUERR(KERR)
                 RETURN
              END IF
C
C             PACK INCREMENTS
C
              DO J=1,KSEC3(3)
C
              JI=I+(J-1)*KELEM
C
              IF(NWTDW(I).EQ.32) THEN
                 VAL4=RVALS4(JI)
                 CALL BUGBYTESR4(VAL4,IIVALS,0,8,0,INCHAR)
              ELSE
                 VAL=RVALS(JI)
                 CALL BUGBYTESR8(VAL,IIVALS,0,8,0,INCHAR)
              END IF
C
              DO IZ=1,INCHAR
               IPACK=IIVALS(IZ)
               CALL BUPCK(NBPW,KBUFF(NWPT),IPACK,NWPT,NBPT,8,KERR)
              END DO
C
              END DO

            ELSE

              IBYTES=NWTDW(I)/8
              IF(IBYTES.EQ.4) THEN
                 VAL4=RVALS4(I)
                 OBIG=BIG_ENDIAN()
                 IF(.NOT.OBIG) THEN
                    CALL SWAP_BYTES4(VAL4,VAL4S)
                    VAL4=VAL4S
                 END IF
                 CALL BUGBYTESR4(VAL4,ILOCVAL,0,8,0,IBYTES)
              ELSE
                 VAL=RVALS(I)
                 OBIG=BIG_ENDIAN()
                 IF(.NOT.OBIG) THEN
                    CALL SWAP_BYTES8(VAL,VAL8S)
                    VAL=VAL8S
                 END IF
                 CALL BUGBYTESR8(VAL,ILOCVAL,0,8,0,IBYTES)
              END IF
              ISKIP=0
              CALL BUPKS(NBPW,KBUFF(NWPT),ILOCVAL,NWPT,NBPT,8,
     1                  ISKIP,IBYTES,KERR)
              IF(KERR.GT.0) THEN
                 WRITE(KNTN,*)'BUENS4 :'
                 WRITE(KNTN,*)'ERROR PACKING REAL IEEE'
                 CALL BUERR(KERR)
                 RETURN
              END IF
C
              CALL BUPCK(NBPW,KBUFF(NWPT),0,NWPT,NBPT,6,KERR)
              IF(KERR.GT.0) THEN
                 WRITE(KNTN,*)'BUENS4 :'
                 WRITE(KNTN,*)'ERROR PACKING NUMBER OF BITS FOR'
                 WRITE(KNTN,*)'INCREMENTS FOR ',I,' ELEMENT.'
                 RETURN
              END IF

            END IF
C
 4211       CONTINUE
C
         ELSE
             IF(OMIS) THEN
C
C               PACK LOCAL REFERENCE VALUE FOR ELEMENT SET TO MISSING VALUE.
C
                CALL BUPCK(NBPW,KBUFF(NWPT),NMASK(IBDW),NWPT,NBPT,
     1                     IBDW,KERR)
                IF(KERR.GT.0) THEN
                   WRITE(KNTN,*)'BUENS4 :'
                   WRITE(KNTN,*)'ERROR PACKING LOCAL REFERENCE VALUE '
                   WRITE(KNTN,*)I,' ELEMENT.'
                   RETURN
                END IF
C
C               PACK NUMBER OF BITS FOR INCREMENTS (SET TO ZERO)
C
                CALL BUPCK(NBPW,KBUFF(NWPT),0,NWPT,NBPT,6,KERR)
                IF(KERR.GT.0) THEN
                   WRITE(KNTN,*)'BUENS4 :'
                   WRITE(KNTN,*)'ERROR PACKING NUMBER OF BITS FOR'
                   WRITE(KNTN,*)'INCREMENTS FOR ',I,' ELEMENT.'
                   RETURN
                END IF
C
             ELSE
C
                IF(INCBIT.EQ.0) THEN
C
C
C                  PACK LOCAL REFERENCE VALUE FOR ELEMENT
C
                 IF(NWTEN(I).EQ.836970) THEN
                  IF(ISG_REF.EQ.1) THEN
                    CALL BUPCK(NBPW,KBUFF(NWPT),1,NWPT,NBPT,1,KERR)
                    CALL BUPCK(NBPW,KBUFF(NWPT),MIN,NWPT,NBPT,IBDW-1,
     1                         KERR)
                  ELSE
                    CALL BUPCK(NBPW,KBUFF(NWPT),MIN,NWPT,NBPT,IBDW,
     1                         KERR)
                    IF(KERR.GT.0) THEN
                      WRITE(KNTN,*)'BUENS4 :'
                      WRITE(KNTN,*)'ERROR PACKING LOCAL REFERENCE VALUE'
                      WRITE(KNTN,*)'FOR ',I,' ELEMENT IN ',IBDW,' BITS.'
                      RETURN
                    END IF
                  END IF
                 ELSE
                   CALL BUPCK(NBPW,KBUFF(NWPT),MIN,NWPT,NBPT,IBDW,KERR)
                   IF(KERR.GT.0) THEN
                      WRITE(KNTN,*)'BUENS4 :'
                      WRITE(KNTN,*)'ERROR PACKING LOCAL REFERENCE VALUE'
                      WRITE(KNTN,*)'FOR ',I,' ELEMENT IN ',IBDW,' BITS.'
                      RETURN
                   END IF
                 ENDIF
C
C                  PACK NUMBER OF BITS FOR INCREMENTS
C
                   CALL BUPCK(NBPW,KBUFF(NWPT),INCBIT,NWPT,NBPT,6,KERR)
                   IF(KERR.GT.0) THEN
                      WRITE(KNTN,*)'BUENS4 :'
                      WRITE(KNTN,*)'ERROR PACKING NUMBER OF BITS FOR'
                      WRITE(KNTN,*)'INCREMENTS FOR ',I,' ELEMENT.'
                      RETURN
                   END IF
C
                ELSE
C
C                  PACK LOCAL REFERENCE VALUE FOR ELEMENT
C
                   IF(NWTEN(I).EQ.836970) THEN
                      IF(ISG_REF.EQ.1) THEN
                         CALL BUPCK(NBPW,KBUFF(NWPT),1,NWPT,NBPT,1,KERR)
                         CALL BUPCK(NBPW,KBUFF(NWPT),MIN,NWPT,NBPT,
     1                              IBDW-1,KERR)
                      ELSE
                         CALL BUPCK(NBPW,KBUFF(NWPT),MIN,NWPT,NBPT,IBDW,
     1                              KERR)
                         IF(KERR.GT.0) THEN
                            WRITE(KNTN,*)'BUENS4 :'
                      WRITE(KNTN,*)'ERROR PACKING LOCAL REFERENCE VALUE'
                      WRITE(KNTN,*)'FOR ',I,' ELEMENT IN ',IBDW,' BITS.'
                            RETURN
                         END IF
                      END IF
                   ELSE
                     CALL BUPCK(NBPW,KBUFF(NWPT),MIN,NWPT,NBPT,IBDW,
     1                          KERR)
                      IF(KERR.GT.0) THEN
                         WRITE(KNTN,*)'BUENS4 :'
                      WRITE(KNTN,*)'ERROR PACKING LOCAL REFERENCE VALUE'
                      WRITE(KNTN,*)'FOR ',I,' ELEMENT IN ',IBDW,' BITS.'
                         RETURN
                      END IF
                   ENDIF

C
C                  PACK NUMBER OF BITS FOR INCREMENTS
C
                   CALL BUPCK(NBPW,KBUFF(NWPT),INCBIT,NWPT,NBPT,6,KERR)
                   IF(KERR.GT.0) THEN
                      WRITE(KNTN,*)'BUENS4 :'
                      WRITE(KNTN,*)'ERROR PACKING NUMBER OF BITS FOR'
                      WRITE(KNTN,*)  'INCREMENTS FOR ',I,' ELEMENT.'
                      RETURN
                   END IF
C
C                  PACK INCREMENTS
C
                   CALL BUPKS(NBPW,KBUFF(NWPT),INC,NWPT,NBPT,
     1                        INCBIT,0,KSEC3(3),KERR)
                   IF(KERR.GT.0) THEN
                      WRITE(KNTN,*)  'BUENS4 :'
                      WRITE(KNTN,*)  'ERROR PACKING INCREMENTS FOR',I,
     1                ' ELEMENT'
                      RETURN
                   END IF
C
                END IF
             END IF
          END IF
C
 411     CONTINUE
C
      END IF
C
C*          5.  SET UP LENGTH OF THE SECTION 4.
C               --------------------------------
 500  CONTINUE
C
      IF(OMULTI) THEN
         IF(NSUBSET.EQ.KSEC3(3)) THEN
            CALL BUOCTN(IWPTB,IBPTB,KBUFL,KBUFF,KERR)
            IF(KERR.GT.0) THEN
               CALL BUERR(KERR)
               RETURN
            END IF
         END IF
      ELSE
         CALL BUOCTN(IWPTB,IBPTB,KBUFL,KBUFF,KERR)
         IF(KERR.GT.0) THEN
            CALL BUERR(KERR)
            RETURN
         END IF
      END IF
C
C     ------------------------------------------------------------------
      RETURN
      END

C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      INTEGER FUNCTION IAIDEF (KSEC1, KSEC2, KIAREA, KLLEN, OICHNG,
     1   KPR, KERR)
C
C---->
C**** *IAIDEF*
C
C     PURPOSE
C     _______
C
C     Generate an input field definition from the GRIB definition.
C
C     INTERFACE
C     _________
C
C     IERR = IAIDEF (KSEC1, KSEC2, KIAREA, KLLEN, OICHNG, KPR, KERR)
C
C     Input parameters
C     ________________
C
C     KSEC1      - The GRIB Section 1 array for the input field.
C
C     KSEC2      - The GRIB Section 2 array for the input field.
C
C     KIAREA     - The previous input field area used for comparison.
C
C     KLLEN      - The previous latitude line lengths for a quasi
C                  regular Gaussian field used for comparison.
C
C     KPR        - The debug print switch.
C                  0  , No debugging output.
C                  1  , Produce debugging output.
C
C     KERR       - The error control flag.
C                  -ve, No error message. Return error code.
C                  0  , Hard failure with error message.
C                  +ve, Print error message. Return error code.
C
C     Output parameters
C     ________________
C
C     KIAREA     - The area for this field.
C
C     KLLEN      - The latitude line lengths for a quasi regular
C                  Gaussian field.
C
C     OICHNG     - A flag indicating whether the field definition has
C                  changed since the previous call to this routine.
C
C     Return value
C     ____________
C
C     The error indicator (INTEGER).
C
C     Error and Warning Return Values
C     _______________________________
C
C     21701 The data representation was not valid.
C     21702 The scan mode was not valid.
C
C     Common block usage
C     __________________
C
C     nifld.common - This file contains all the input field
C                    definition variables.
C
C     LSMCHNG      - LSM change flag is set.
C     LSM          - LSM usage flag is set.
C     LSMPAR       - LSM parameter flag is set.
C     LPREC        - Precipitation flag is set.
C     LWIND        - Wind flag is set.
C
C     NIGAUSS      - Input field Gaussian truncation is used and set.
C     NIGRID       - Input field grid definition (WE/NS) is used and
C                    set.
C     NINS         - Number of grid points in NS direction for input
C                    field is used and set.
C     NIPARAM      - Input field parameter number is used and set.
C     NIREPR       - Input field representation is used and set.
C     NISCNM       - Input field scanning mode is set.
C     NITABLE      - Input field table number is used and set.
C     NIWE         - Number of grid points in WE direction for input
C                    field is used and set.
C
C     EXTERNALS
C     _________
C
C     PRECIP       - Says if field is to have 'precipitation' treatment
C     SETPAR       - Standard routine used to generate "missing" data
C                    values for GRIB fields.
C     INTLOG       - Logs messages.
C
C     METHOD
C     ______
C
C     This routine uses sections 1 and 2 of the input GRIB field to
C     generate the input field definition. This definition is
C     compared with the previous field definition to see if any
C     change of definition has occurred.
C
C     REFERENCE
C     _________
C
C     None
C
C     COMMENTS
C     ________
C
C     Program contains sections 0 to 3 and 9
C
C     AUTHOR
C     ______
C
C     K. Fielding      *ECMWF*      Apr 1994
C
C     MODIFICATIONS
C     _____________
C
C     None
C
C----<
C     _______________________________________________________
C
C
C*    Section 0. Definition of variables.
C     _______________________________________________________
C
C*    Prefix conventions for variable names
C
C     Logical      L (but not LP), global or common.
C                  O, dummy argument
C                  G, local variable
C                  LP, parameter.
C     Character    C, global or common.
C                  H, dummy argument
C                  Y (but not YP), local variable
C                  YP, parameter.
C     Integer      M and N, global or common.
C                  K, dummy argument
C                  I, local variable
C                  J (but not JP), loop control
C                  JP, parameter.
C     REAL         A to F and Q to X, global or common.
C                  P (but not PP), dummy argument
C                  Z, local variable
C                  PP, parameter.
C
C     Implicit statement to force declarations
C
      IMPLICIT NONE
C
#include "parim.h"
#include "nifld.common"
C
C     Subroutine arguments
      LOGICAL OICHNG
      INTEGER KPR, KERR
      INTEGER KSEC1 (JPGRIB_ISEC1), KSEC2 (JPGRIB_ISEC2), KIAREA (4)
      INTEGER KLLEN (*)
C
C     Local variables
      LOGICAL GNLSM
      INTEGER ITEMP, IMISS, IWEST, IEAST, IERR
      INTEGER JSET
      INTEGER JPROUTINE
      PARAMETER (JPROUTINE = 21700)
C
C     External functions
C
      LOGICAL PRECIP
C
C     _______________________________________________________
C
C*    Section 1. Initialisation
C     _______________________________________________________
C
  100 CONTINUE
C
      IF (KPR.GE.1) CALL INTLOG(JP_DEBUG,'IAIDEF: Section 1.',JPQUIET)
C
      IAIDEF = 0
      IERR = 0
      OICHNG = .FALSE.
C
C     Get GRIB missing data value
C
      CALL SETPAR (ITEMP, IMISS, KPR)
C
C     _______________________________________________________
C
C*    Section 2. Set Grib Section 2 variables and check consistency
C     _______________________________________________________
C
  200 CONTINUE
C
      IF (KPR.GE.1) CALL INTLOG(JP_DEBUG,'IAIDEF: Section 2.',JPQUIET)
C
C     Representation
C
      IF (KSEC2 (JPSEC2_REP) .EQ. JPGAUSSIAN .AND.
     1   KSEC2 (JPSEC2_QUASI) .EQ. 1) THEN
         ITEMP = JPQUASI
      ELSE
         ITEMP = KSEC2 (JPSEC2_REP)
      ENDIF
C
      IF (ITEMP .NE. NIREPR) THEN
         NIREPR = ITEMP
         OICHNG = .TRUE.
      ENDIF
C
C     Only grid point input data allowed now
C
      IF (NIREPR .NE. JPQUASI .AND. NIREPR .NE. JPGAUSSIAN .AND.
     X  NIREPR .NE. JPREGULAR) THEN
        IAIDEF = JPROUTINE + 1
        IF (KERR .GE. 0) THEN
          CALL INTLOG(JP_ERROR,
     X      'IAIDEF: Illegal input representation = ',NIREPR)
          IF (KERR .EQ. 0) CALL INTLOG(JP_FATAL,
     X      'IAIDEF: Interpolation failing.',JPQUIET)
        ENDIF
        GO TO 900
      ENDIF
C
C     scan mode
C
      NISCNM  = KSEC2 (JPSEC2_SCAN)
C
      IF (NISCNM .NE. 0) THEN
        IAIDEF = JPROUTINE + 2
        IF (KERR .GE. 0) THEN
          CALL INTLOG(JP_ERROR,'IAIDEF: Illegal scan mode = ',NISCNM)
          IF (KERR .EQ. 0) CALL INTLOG(JP_FATAL,
     X      'IAIDEF: Interpolation failing.',JPQUIET)
        ENDIF
        GO TO 900
      ENDIF
C
C     Number of lines North-South and West-East
C
      IF (KSEC2 (JPSEC2_NLAT) .NE. NINS) THEN
        NINS = KSEC2 (JPSEC2_NLAT)
        OICHNG = .TRUE.
      ENDIF
C
      IF (NIREPR.NE.JPQUASI .AND. KSEC2(JPSEC2_NLONG).NE.NIWE) THEN
        NIWE = KSEC2 (JPSEC2_NLONG)
        OICHNG = .TRUE.
      ENDIF
C
C     North, South, West and East limits
C
      IF (KSEC2 (JPSEC2_NORTH) * 10 .NE. KIAREA (JPNORTH) ) THEN
        KIAREA (JPNORTH) = KSEC2 (JPSEC2_NORTH) * 10
        OICHNG = .TRUE.
      ENDIF
C
      IF (KSEC2 (JPSEC2_SOUTH) * 10 .NE. KIAREA (JPSOUTH) ) THEN
        KIAREA (JPSOUTH) = KSEC2 (JPSEC2_SOUTH) * 10
        OICHNG = .TRUE.
      ENDIF
C
      IWEST = KSEC2 (JPSEC2_WEST) * 10
C
C     Make West and East points an ordered pair
C
      IF (NIREPR .EQ. JPQUASI) THEN
        IEAST = 0
      ELSE
        IEAST = KSEC2 (JPSEC2_EAST) * 10
C
        IF (IEAST .LT. IWEST) THEN
          IF (IEAST .LE. 0) THEN
            IEAST = IEAST + JP360
          ELSE
            IWEST = IWEST - JP360
          ENDIF
        ENDIF
      ENDIF
C
      IF (IEAST .NE. KIAREA (JPEAST) ) THEN
        KIAREA (JPEAST) = IEAST
        OICHNG = .TRUE.
      ENDIF
C
      IF (IWEST .NE. KIAREA (JPWEST) ) THEN
        KIAREA (JPWEST) = IWEST
        OICHNG = .TRUE.
      ENDIF
C
      IF (NIREPR .EQ. JPREGULAR) THEN
C
C       Direction increments for regular grids
C
        IF (KSEC2 (JPSEC2_DLONG) .EQ. IMISS) THEN
          ITEMP = (KIAREA (JPEAST) - KIAREA (JPWEST) ) / NIWE + 1
        ELSE
          ITEMP = KSEC2 (JPSEC2_DLONG) * 10
        ENDIF
C
        IF (NIGRID (JPWESTEP) .NE. ITEMP) THEN
          NIGRID (JPWESTEP) = ITEMP
          OICHNG = .TRUE.
        ENDIF
C
        IF (KSEC2 (JPSEC2_DLAT) .EQ. IMISS) THEN
          ITEMP = (KIAREA (JPNORTH) - KIAREA (JPSOUTH) ) / NINS + 1
        ELSE
          ITEMP = KSEC2 (JPSEC2_DLAT) * 10
        ENDIF
C
        IF (NIGRID (JPNSSTEP) .NE. ITEMP) THEN
          NIGRID (JPNSSTEP) = ITEMP
          OICHNG = .TRUE.
        ENDIF
C
      ELSE IF (NIREPR .EQ. JPGAUSSIAN) THEN
C
        IF (NIGAUSS .NE. KSEC2 (JPSEC2_GTRUNC) ) THEN
          NIGAUSS = KSEC2 (JPSEC2_GTRUNC)
          OICHNG = .TRUE.
        ENDIF
C
      ELSE IF (NIREPR .EQ. JPQUASI) THEN
C
        IF (NIGAUSS .NE. KSEC2 (JPSEC2_GTRUNC) ) THEN
          NIGAUSS = KSEC2 (JPSEC2_GTRUNC)
          NIWE = NIGAUSS * 4
          OICHNG = .TRUE.
        ENDIF
C
C     Set line length definitions for Quasi regular field
C
        DO 210 JSET = 1, NINS
          IF (KLLEN (JSET) .NE. KSEC2 (JPSEC2_QUDEF + JSET) ) THEN
            KLLEN (JSET) = KSEC2 (JPSEC2_QUDEF + JSET)
            OICHNG = .TRUE.
          ENDIF
  210   CONTINUE
C
      ENDIF
C
C     _______________________________________________________
C
C*    Section 3. Set Grib Section 1 variables and flags
C     _______________________________________________________
C
  300 CONTINUE
C
      IF (KPR.GE.1) CALL INTLOG(JP_DEBUG,'IAIDEF: Section 3.',JPQUIET)
C
      NITABLE = KSEC1 (JPSEC1_TABLE)
      NIPARAM = KSEC1 (JPSEC1_PARAM)
C
C     Setup ECMWF local definition number and stream if applicable
C
      IF( KSEC1(24).EQ.1 ) THEN
        NILOCAL = KSEC1(37)
        NISTREM = KSEC1(40)
      ELSE
        NILOCAL = 0
        NISTREM = 0
      ENDIF
C
      LPREC = PRECIP()
C
      IF (NITABLE .EQ. 1) THEN
C
C       WMO International table for meteorological parameters
C
        LWIND = NIPARAM .EQ. JP_WMO_U .OR. NIPARAM .EQ. JP_WMO_V
C
        LSMPAR = NIPARAM .EQ. JP_WMO_LSM
C
        GNLSM = .NOT. (NIPARAM .EQ. JP_WMO_MSL .OR. LSMPAR)
C
        IF (GNLSM .NEQV. LSM) THEN
          LSMCHNG = .TRUE.
          LSM = GNLSM
        ENDIF
C
      ELSE IF (NITABLE .EQ. 128) THEN
C
C       ECMWF local code table 2 for meteorological parameters
C
        LWIND = NIPARAM .EQ. JP_U .OR. NIPARAM .EQ. JP_V .OR.
     X      NIPARAM .EQ. JP_10U .OR. NIPARAM .EQ. JP_10V
C
        LSMPAR = NIPARAM .EQ. JP_LSM
C
        GNLSM = .NOT. (NIPARAM .EQ. JP_MSL .OR. LSMPAR)
C
        IF (GNLSM .NEQV. LSM) THEN
          LSMCHNG = .TRUE.
          LSM = GNLSM
        ENDIF
C
      ELSE IF (NITABLE .EQ. 129) THEN
C
C       ECMWF local code table for gradients of parameters
C
        LWIND = .FALSE.
        LSMPAR = .FALSE.
C
        IF (.NOT. LSM) THEN
          LSMCHNG = .TRUE.
          LSM = .TRUE.
        ENDIF
C
      ELSE IF (NITABLE .EQ. 130) THEN
C
C       ECMWF local code table for ASTEX experiments
C
        LWIND = .FALSE.
        LSMPAR = .FALSE.
C
        IF (.NOT. LSM) THEN
          LSMCHNG = .TRUE.
          LSM = .TRUE.
        ENDIF
C
      ELSE IF (NITABLE .EQ. 131) THEN
C
C       ECMWF local code table for probability forecasts
C
        LWIND = .FALSE.
        LSMPAR = .FALSE.
C
        IF (.NOT. LSM) THEN
          LSMCHNG = .TRUE.
          LSM = .TRUE.
        ENDIF
C
      ELSE IF (NITABLE .EQ. 140) THEN
C
C       ECMWF local code table for wave models
C
        LWIND = .FALSE.
        LSMPAR = .FALSE.
C
        IF (.NOT. LSM) THEN
          LSMCHNG = .TRUE.
          LSM = .TRUE.
        ENDIF
C
      ELSE IF (NITABLE .EQ. 150) THEN
C
C       ECMWF local code table ocean data
C
        LWIND = .FALSE.
        LSMPAR = .FALSE.
C
        IF (.NOT. LSM) THEN
          LSMCHNG = .TRUE.
          LSM = .TRUE.
        ENDIF
C
      ELSE
C
C       Unexpected code table found
C
        LWIND = .FALSE.
        LSMPAR = .FALSE.
C
        IF (.NOT. LSM) THEN
          LSMCHNG = .TRUE.
          LSM = .TRUE.
        ENDIF
C
      ENDIF
C
      IF (KPR .GE. 1) THEN
        CALL INTLOG(JP_DEBUG,
     X    'IAIDEF: Input field definition parameters.',JPQUIET)
        CALL INTLOG(JP_DEBUG,'IAIDEF: Parameter value = ',NIPARAM)
        CALL INTLOG(JP_DEBUG,'IAIDEF: Representation = ',NIREPR)
        IF (NIWE .NE. 0) CALL INTLOG(JP_DEBUG,
     X    'IAIDEF: Number W-E = ',NIWE)
        IF (NINS .NE. 0) CALL INTLOG(JP_DEBUG,
     X    'IAIDEF: Number N-S = ',NINS)
        IF (NIREPR .EQ. JPGAUSSIAN .OR. NIREPR .EQ. JPQUASI)
     X    CALL INTLOG(JP_DEBUG,'IAIDEF: Gaussian truncation = ',NIGAUSS)
        IF (NIREPR .EQ. JPREGULAR .AND. NIGRID (1) .NE. 0) THEN
          CALL INTLOG(JP_DEBUG,'IAIDEF: Grid WE = ',NIGRID (1))
          CALL INTLOG(JP_DEBUG,'IAIDEF: Grid NS = ',NIGRID (2))
        ENDIF
        IF (KIAREA (1) .NE. 0) THEN
          CALL INTLOG(JP_DEBUG,'IAIDEF: Area North = ',KIAREA(1))
          CALL INTLOG(JP_DEBUG,'IAIDEF: Area West  = ',KIAREA(2))
          CALL INTLOG(JP_DEBUG,'IAIDEF: Area South = ',KIAREA(3))
          CALL INTLOG(JP_DEBUG,'IAIDEF: Area East  = ',KIAREA(4))
        ENDIF
C
        CALL INTLOG(JP_DEBUG,'IAIDEF: Control flag status:',JPQUIET)
C
        IF( OICHNG ) THEN
          CALL INTLOG(JP_DEBUG,'IAIDEF:Input fld change TRUE',JPQUIET)
        ELSE
          CALL INTLOG(JP_DEBUG,'IAIDEF:Input fld change FALSE',JPQUIET)
        ENDIF
C
        IF( LSMCHNG ) THEN
          CALL INTLOG(JP_DEBUG,'IAIDEF: LSM change TRUE',JPQUIET)
        ELSE
          CALL INTLOG(JP_DEBUG,'IAIDEF: LSM change FALSE',JPQUIET)
        ENDIF
C
        IF( LSM ) THEN
          CALL INTLOG(JP_DEBUG,'IAIDEF: LSM flag TRUE',JPQUIET)
        ELSE
          CALL INTLOG(JP_DEBUG,'IAIDEF: LSM flag FALSE',JPQUIET)
        ENDIF
C
        IF( LWIND ) THEN
          CALL INTLOG(JP_DEBUG,'IAIDEF: Wind flag TRUE',JPQUIET)
        ELSE
          CALL INTLOG(JP_DEBUG,'IAIDEF: Wind flag FALSE',JPQUIET)
        ENDIF
C
        IF( LPREC ) THEN
          CALL INTLOG(JP_DEBUG,'IAIDEF: Precipitn flag TRUE',JPQUIET)
        ELSE
          CALL INTLOG(JP_DEBUG,'IAIDEF: Precipitn flag FALSE',JPQUIET)
        ENDIF
C
        IF( LSMPAR ) THEN
          CALL INTLOG(JP_DEBUG,'IAIDEF: LSM param flag TRUE',JPQUIET)
        ELSE
          CALL INTLOG(JP_DEBUG,'IAIDEF: LSM param flag FALSE',JPQUIET)
        ENDIF
      ENDIF
C
C     _______________________________________________________
C
C*    Section 9. Return to calling routine. Format statements
C     _______________________________________________________
C
  900 CONTINUE
C
      IF (KPR.GE.1) CALL INTLOG(JP_DEBUG,'IAIDEF: Section 9.',JPQUIET)
C
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE BUEPMRKC(KSEC3,KVALS,VALUES,KELEM,CNAMES,CUNITS,KERR)
C
C**** *BUEPMRKC*
C
C
C     PURPOSE.
C     --------
C
C          PROCESS MARKER OPERATOR, RELACING IT WITH CORRESPONDING
C     TABLE B ELEMENT DESCRIPTOR.
C
C
C**   INTERFACE.
C     ----------
C
C          *CALL* *BUEPMRKC(KSEC3,KVALS,VALUES,KELEM,CNAMES,
C                           CUNITS,KERR)*
C
C        INPUT :
C               *KSEC3*   -  ARRAY CONTAINING SECTION 3 INFORMATION
C                            KSEC3( 1)-- LENGTH OF SECTION 3 (BYTES)
C                            KSEC3( 2)-- RESERVED
C                            KSEC3( 3)-- NUMBER OF SUBSETS
C                            KSEC3( 4)-- FLAG (DATA TYPE,DATA
C                                        COMPRESSION)
C               *KVALS*   -  DIMENSION OF VALUES ARRAY
C               *VALUES*  -  ARAY CONTAINING DATA
C               *KELEM*   -  DIMENSION OF CNAMES, CUNITS ARRAY
C               *CNAMES*  -  CHARACTER ARRAY CONTAINING ELEMENT NAMES
C               *CUNITS*  -  CHARACTER ARRAY CONTAINIG UNITS
C        OUTPUT:
C               *KERR*    -  RETURNED ERROR CODE
C
C     METHOD.
C     -------
C          NONE.
C
C     EXTERNALS.
C     ----------
C
C          BUNPCK          - UNPACKS BIT PATTERN
C          BUNPKS         - UNPACKS BIT PATTERN IN REPEATED WAY
C
C     REFERENCE.
C     ----------
C
C          NONE.
C
C     AUTHOR.
C     -------
C
C          M. DRAGOSAVAC    *ECMWF*       01/02/91.
C
C
C     MODIFICATIONS.
C     --------------
C
C          M. DRAGOSAVAC 1/10/92 :
C
C
C
      IMPLICIT LOGICAL(L,O,G), CHARACTER*8(C,H,Y)
C
C
#     include "parameter.F"
#     include "bcomunit.F"
#     include "bcmwork.F"
#     include "bcmbef.F"
#     include "bcmwt.F"
#     include "bcmwtc.F"
#     include "bcmrq.F"
C
      CHARACTER*64 CWTEN
      CHARACTER*24 CWTU
      CHARACTER*64 CNAMES(KELEM)
      CHARACTER*24 CUNITS(KELEM)
      DIMENSION    KSEC3(JSEC3)
#ifndef R_4
      REAL*8 VALUES(KVALS)
      REAL*8 RVIND
      REAL*8 EPS
#else
      REAL   VALUES(KVALS)
      REAL   RVIND
      REAL   EPS
#endif
C
      DIMENSION IMASK(8)
      DATA IMASK/1,2,4,8,16,32,64,128/
C
C     ------------------------------------------------------------------
C*          1.  FINED OPERATOR 223000 TO 237255.
C               --------------------------------
 100  CONTINUE
C
      IF(KERR.GT.0) RETURN
C
C
C           1.1 CHECK IF DATA ARE COMRESSED.
C               ----------------------------
 110  CONTINUE
C
      IB=0
      IF(IAND(KSEC3(4),IMASK(7)).NE.0) IB=1
C
C*          1.2 FIND POSITION OF OPREATORS.
C               ---------------------------
 120  CONTINUE
C
      DO 121 J=1,M
C
      NR223=0
      NR224=0
      NR225=0
      NR232=0
C
C
      IF(NWTR(J).EQ.222000) THEN
C
C        SET POINTER TO THE LAST DATA ELEMENT
C
         IF(MREL.EQ.0) MREL=J-1
C
C        CHECK IF BACKWARD REFERENCE BIT MAP DEFINED
C
         IF(NWTR(J+1).EQ.236000) THEN
            NP236000=J+1
            OBF=.TRUE.
            J2=J+2
C
C           DELAYED REPLICATION FACTOR CAN FOLLOW 236000
C
            IF(NWTR(J2).EQ.031001.OR.NWTR(J2).EQ.031000.OR.
     1         NWTR(J2).EQ.031002) J2=J+3
C
            DO 122 I=J2,M
            IF(NWTR(I).EQ.031031) THEN
C
C              FIND  FIRST POINTER TO DATA PRESENT INDICATOR
C
               IF(OBF) MBMP=I
               OBF=.FALSE.
            ELSE
C
C              LAST POINTER TO DATA PRESENT INDICATOR
C
               MBMPL=I-1
               GO TO 121
            END IF
 122        CONTINUE
         END IF
      END IF
      IF(NWTR(J).EQ.223000) THEN
C
C        SET POINTER TO THE LAST DATA ELEMENT
C
         IF(MREL.EQ.0) MREL=J-1
C
         NP223000=J
C
C        CHECK IF BACKWARD REFERENCE BIT MAP DEFINED
C
         IF(NWTR(J+1).EQ.236000) THEN
            NP236000=J+1
            OBF=.TRUE.
            J2=J+2
C
C           DELAYED REPLICATION FACTOR CAN FOLLOW 236000
C
            IF(NWTR(J2).EQ.031001.OR.NWTR(J2).EQ.031000.OR.
     1         NWTR(J2).EQ.031002) J2=J+3
C
            DO 123 I=J2,M
            IF(NWTR(I).EQ.031031) THEN
C
C              FIND  FIRST POINTER TO DATA PRESENT INDICATOR
C
               IF(OBF) MBMP=I
               OBF=.FALSE.
            ELSE
C
C              LAST POINTER TO DATA PRESENT INDICATOR
C
               MBMPL=I-1
               GO TO 200
            END IF
 123        CONTINUE
         END IF
         GO TO 200
      END IF
      IF(NWTR(J).EQ.224000) THEN
C
C        SET POINTER TO THE LAST DATA ELEMENT
C
         IF(MREL.EQ.0) MREL=J-1
C
         NP224000=J
C
C        CHECK IF BACKWARD REFERENCE BIT MAP DEFINED
C
         IF(NWTR(J+1).EQ.236000) THEN
            NP236000=J+1
            OBF=.TRUE.
            J2=J+2
C
C           DELAYED REPLICATION FACTOR CAN FOLLOW 236000
C
            IF(NWTR(J2).EQ.031001.OR.NWTR(J2).EQ.031000.OR.
     1         NWTR(J2).EQ.031002) J2=J+3
C
            DO 124 I=J2,M
            IF(NWTR(I).EQ.031031) THEN
C
C              FIND  FIRST POINTER TO DATA PRESENT INDICATOR
C
               IF(OBF) MBMP=I
               OBF=.FALSE.
            ELSE
C
C              LAST POINTER TO DATA PRESENT INDICATOR
C
               MBMPL=I-1
               GO TO 300
            END IF
 124        CONTINUE
         END IF
         GO TO 300
      END IF
      IF(NWTR(J).EQ.225000) THEN
C
C        SET POINTER TO THE LAST DATA ELEMENT
C
         IF(MREL.EQ.0) MREL=J-1
C
         NP225000=J
C
C        CHECK IF BACKWARD REFERENCE BIT MAP DEFINED
C
         IF(NWTR(J+1).EQ.236000) THEN
            NP236000=J+1
            OBF=.TRUE.
            J2=J+2
C
C           DELAYED REPLICATION FACTOR CAN FOLLOW 236000
C
            IF(NWTR(J2).EQ.031001.OR.NWTR(J2).EQ.031000.OR.
     1         NWTR(J2).EQ.031002) J2=J+3
C
            DO 125 I=J2,M
            IF(NWTR(I).EQ.031031) THEN
C
C              FIND  FIRST POINTER TO DATA PRESENT INDICATOR
C
               IF(OBF) MBMP=I
               OBF=.FALSE.
            ELSE
C
C              LAST POINTER TO DATA PRESENT INDICATOR
C
               MBMPL=I-1
               GO TO 400
            END IF
 125        CONTINUE
         END IF
         GO TO 400
      END IF
      IF(NWTR(J).EQ.232000) THEN
C
C        SET POINTER TO THE LAST DATA ELEMENT
C
         IF(MREL.EQ.0) MREL=J-1
C
         NP232000=J
C
C        CHECK IF BACKWARD REFERENCE BIT MAP DEFINED
C
         IF(NWTR(J+1).EQ.236000) THEN
            NP236000=J+1
            OBF=.TRUE.
            J2=J+2
C
C           DELAYED REPLICATION FACTOR CAN FOLLOW 236000
C
            IF(NWTR(J2).EQ.031001.OR.NWTR(J2).EQ.031000.OR.
     1         NWTR(J2).EQ.031002) J2=J+3
C
            DO 126 I=J2,M
            IF(NWTR(I).EQ.031031) THEN
C
C              FIND  FIRST POINTER TO DATA PRESENT INDICATOR
C
               IF(OBF) MBMP=I
               OBF=.FALSE.
            ELSE
C
C              LAST POINTER TO DATA PRESENT INDICATOR
C
               MBMPL=I-1
               GO TO 500
            END IF
 126        CONTINUE
         END IF
         GO TO 500
      END IF
C
      IF(NWTR(J).EQ.235000) THEN
C
C        RESET POINTER  POINTER TO THE LAST DATA ELEMENT
C
         MREL=0
         MBMP=0
         MBMPL=0
      END IF
C
      IF(NWTR(J).EQ.237255) THEN
C
C        RESET POINTERS TO THE BIT MAP
C
         MBMP=0
         MBMPL=0
      END IF
C
      GO TO 121
C
C     -----------------------------------------------------------------
C*          2.  PROCESS SUBSTITUTED VALUES OPERATOR.
C               ------------------------------------
C
 200  CONTINUE
C
C*          2.1 FIND FIRST ACCURANCE OD 223255.
C               -------------------------------
 210  CONTINUE
C
      NP223255=0
      DO 211 I=NP223000,M
      IF(NWTR(I).EQ.223255) THEN
         NP223255=I
         GO TO 220
      END IF
 211  CONTINUE
C
      GO TO 121
C
C*          2.2 COUNT NUMBER OF DATA PRESENT INDICATORS.
C               ----------------------------------------
 220  CONTINUE
C
      IF(MBMP.EQ.0) THEN
         I223=0
         OF223=.TRUE.
         DO 221 I=NP223000,NP223255
         IF(NWTR(I).EQ.031031) THEN
            IF(OF223) THEN
               I223=I
               OF223=.FALSE.
            END IF
            NR223=NR223+1
         END IF
 221     CONTINUE
      ELSE
         I223=MBMP
         NR223=MBMPL-MBMP+1
      END IF
C
C
C*          2.5 DEFINE POINTER REFERING BACK TO DATA.
C               -------------------------------------
 250  CONTINUE
C
      ISUBST=MREL-NR223+1
C
C*          2.6 REPLACE MARKERS WITH CORRESPONDING DATA WIDTHS.
C               -----------------------------------------------
C
 260  CONTINUE
C
      DO 261 I=I223,NR223+I223
      IF(VALUES(I).EQ.0) THEN
C
 262     CONTINUE
C
         IF(NWTR(NP223255).EQ.223255) THEN
            NWTDW (NP223255)=NWTDW(ISUBST)
            NWTR  (NP223255)=NWTR (ISUBST)
            NWTRV (NP223255)=NWTRV(ISUBST)
            NWTS  (NP223255)=NWTS (ISUBST)
            CWTEN (NP223255)=CWTEN(ISUBST)
            CWTU  (NP223255)=CWTU (ISUBST)
            NWTEN (NP223255)=NWTEN(ISUBST)
            ISUBST=ISUBST+1
            NP223255=NP223255+1
         ELSE
            NP223255=NP223255+1
            GO TO 262
         END IF
      ELSE
         ISUBST=ISUBST+1
      END IF
 261  CONTINUE
C
      GO TO 121
C
C     -----------------------------------------------------------------
C*          3.  PROCESS FIRST ORDER STATISTICS OPERATOR.
C               ----------------------------------------
 300  CONTINUE
C
C*          3.1 FIND FIRST ACCURANCE OD 224255.
C               -------------------------------
 310  CONTINUE
C
      NP224255=0
      DO 311 I=NP224000,M
      IF(NWTR(I).EQ.224255) THEN
         NP224255=I
         GO TO 320
      END IF
 311  CONTINUE
C
      GO TO 121
C
C*          3.2 COUNT NUMBER OF DATA PRESENT INDICATORS.
C               ----------------------------------------
 320  CONTINUE
C
      IF(MBMP.EQ.0) THEN
         I224=0
         OF224=.TRUE.
         DO 321 I=NP224000,NP224255
         IF(NWTR(I).EQ.031031) THEN
            IF(OF224) THEN
               I224=I
               OF224=.FALSE.
            END IF
            NR224=NR224+1
         END IF
 321     CONTINUE
      ELSE
         I224=MBMP
         NR224=MBMPL-MBMP+1
      END IF
C
C
C*          3.5 DEFINE POINTER REFERING BACK TO DATA.
C               -------------------------------------
 350  CONTINUE
C
      ISUBST=MREL-NR224+1
C
C*          3.6 REPLACE MARKERS WITH CORRESPONDING DATA WIDTHS.
C               -----------------------------------------------
C
 360  CONTINUE
C
      DO 361 I=I224,NR224+I224
      IF(VALUES(I).EQ.0) THEN
C
 362     CONTINUE
C
         IF(NWTR(NP224255).EQ.224255) THEN
            NWTDW (NP224255)=NWTDW(ISUBST)
            NWTR  (NP224255)=NWTR (ISUBST)
            NWTRV (NP224255)=NWTRV(ISUBST)
            NWTS  (NP224255)=NWTS (ISUBST)
            CWTEN (NP224255)=CWTEN(ISUBST)
            CWTU  (NP224255)=CWTU (ISUBST)
            NWTEN (NP224255)=NWTEN(ISUBST)
            ISUBST=ISUBST+1
            NP224255=NP224255+1
         ELSE
            NP224255=NP224255+1
            GO TO 362
         END IF
      ELSE
         ISUBST=ISUBST+1
      END IF
 361  CONTINUE
C
      GO TO 121
C
C
C     -----------------------------------------------------------------
C*          4.  PROCESS DIFFERENCE STATISTICS OPERATOR.
C               ---------------------------------------
 400  CONTINUE
C
C
C*          4.1 FIND FIRST ACCURANCE OD 225255.
C               -------------------------------
 410  CONTINUE
C
      NP225255=0
      DO 411 I=NP225000,M
      IF(NWTR(I).EQ.225255) THEN
         NP225255=I
         GO TO 420
      END IF
 411  CONTINUE
C
      GO TO 121
C
C*          4.2 COUNT NUMBER OF DATA PRESENT INDICATORS.
C               ----------------------------------------
 420  CONTINUE
C
      IF(MBMP.EQ.0) THEN
         I225=0
         OF225=.TRUE.
         DO 421 I=NP225000,NP225255
         IF(NWTR(I).EQ.031031) THEN
            IF(OF225) THEN
               I225=I
               OF225=.FALSE.
            END IF
            NR225=NR225+1
         END IF
 421     CONTINUE
      ELSE
         I225=MBMP
         NR225=MBMPL-MBMP+1
      END IF
C
C
C*          4.5 DEFINE POINTER REFERING BACK TO DATA.
C               -------------------------------------
 450  CONTINUE
C
      ISUBST=MREL-NR225+1
C
C*          4.6 REPLACE MARKERS WITH CORRESPONDING DATA WIDTHS.
C               -----------------------------------------------
C
 460  CONTINUE
C
      DO 461 I=I225,NR225+I225
      IF(VALUES(I).EQ.0) THEN
C
 462     CONTINUE
C
         IF(NWTR(NP225255).EQ.225255) THEN
            NWTR  (NP225255)=NWTR (ISUBST)
C
C           CHANGE REFERENCE VALUE TO BE CENTRED AROUND ZERO
C           AND INCREASE DATA WIDTH BY 1
C
            IF(NWTEN(ISUBST).NE.-999) THEN
               NWTRV (NP225255)=-2**NWTDW(ISUBST)
               NWTDW (NP225255)=NWTDW(ISUBST)+1
            ELSE
               NWTRV (NP225255)=NWTDW(ISUBST)
               NWTDW (NP225255)=NWTDW(ISUBST)
               NWTEN (NP225255)=NWTEN(ISUBST)
            END IF
C
            NWTS  (NP225255)=NWTS (ISUBST)
            CWTEN (NP225255)=CWTEN(ISUBST)
            CWTU  (NP225255)=CWTU (ISUBST)
            ISUBST=ISUBST+1
            NP225255=NP225255+1
         ELSE
            NP225255=NP225255+1
            GO TO 462
         END IF
      ELSE
         ISUBST=ISUBST+1
      END IF
 461  CONTINUE
C
      GO TO 121
C
C     -----------------------------------------------------------------
C*          5.  PROCESS REPLACE/RETAINED OPERATOR.
C               ----------------------------------
 500  CONTINUE
C
C
C*          5.1 FIND FIRST ACCURANCE OF 232255.
C               -------------------------------
 510  CONTINUE
C
      NP232255=0
      DO 511 I=NP232000,M
      IF(NWTR(I).EQ.232255) THEN
         NP232255=I
         GO TO 520
      END IF
 511  CONTINUE
C
      GO TO 121
C
C*          5.2 COUNT NUMBER OF DATA PRESENT INDICATORS.
C               ----------------------------------------
 520  CONTINUE
C
      IF(MBMP.EQ.0) THEN
         I232=0
         OF232=.TRUE.
         DO 521 I=NP232000,NP232255
         IF(NWTR(I).EQ.031031) THEN
            IF(OF232) THEN
               I232=I
               OF232=.FALSE.
            END IF
            NR232=NR232+1
         END IF
 521     CONTINUE
      ELSE
         I232=MBMP
         NR232=MBMPL-MBMP+1
      END IF
C
C
C*          5.5 DEFINE POINTER REFERING BACK TO DATA.
C               -------------------------------------
 550  CONTINUE
C
      ISUBST=MREL-NR232+1
C
C*          5.6 REPLACE MARKERS WITH CORRESPONDING DATA WIDTHS.
C               -----------------------------------------------
C
 560  CONTINUE
C
      DO 561 I=I232,NR232+I232
      IF(VALUES(I).EQ.0) THEN
C
 562     CONTINUE
C
         IF(NWTR(NP232255).EQ.232255) THEN
            NWTDW (NP232255)=NWTDW(ISUBST)
            NWTR  (NP232255)=NWTR (ISUBST)
            NWTRV (NP232255)=NWTRV(ISUBST)
            NWTS  (NP232255)=NWTS (ISUBST)
            CWTEN (NP232255)=CWTEN(ISUBST)
            CWTU  (NP232255)=CWTU (ISUBST)
            ISUBST=ISUBST+1
            NP232255=NP232255+1
         ELSE
            NP232255=NP232255+1
            GO TO 562
         END IF
      ELSE
         ISUBST=ISUBST+1
      END IF
 561  CONTINUE
C
C     -----------------------------------------------------------------
 121  CONTINUE
C
      RETURN
C
C
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE NMAKGG( KTRUNC, KNEXT, PLAT, KNUM, PLEG, KRET)
C
C---->
C**** NMAKGG
C
C     PURPOSE
C     _______
C
C     This routine creates legendre functions for latitude rows from
C     the given latitude.
C
C     INTERFACE
C     _________
C
C     CALL NMAKGG( KTRUNC, KNEXT, PLAT, KNUM, PLEG, KRET)
C
C     Input parameters
C     ________________
C
C     KTRUNC  - Truncation.
C     KNEXT   - Index (in PLAT) of next latitude at which to start
C     PLAT    - Array of gaussian latitudes
C     KNUM    - Number of latitudes to produce
C
C     Output parameters
C     ________________
C
C     PLEG     - Array of legendre functions for the latitude.
C     KRET     - Return status code
C                0 = OK
C
C     Common block usage
C     __________________
C
C     JDCNDBG
C
C     Method
C     ______
C
C     See below.
C
C     Externals
C     _________
C
C     INTLOG   - Output log message
C     INTLOGR  - Output log message (with real value)
C
C     Reference
C     _________
C
C     None.
C
C     Comments
C     ________
C
C     None at present.
C
C     AUTHOR
C     ______
C
C     J.D.Chambers      *ECMWF*      June 1999
C
C     MODIFICATIONS
C     _____________
C
C     None.
C
C----<
C
      IMPLICIT NONE
C
#include "jparams.h"
#include "parim.h"
C
C     Parameters
C
      INTEGER JPROUTINE
      PARAMETER ( JPROUTINE = 30500 )
C
C     Subroutine arguments
C
      INTEGER KTRUNC, KNEXT, KRET, KNUM
      REAL PLEG, PLAT
      DIMENSION PLEG(*), PLAT(*)
C
C     Local variables
C
      INTEGER NEXT, ILAT
      REAL ALAT, DEG2RAD
C
C     _______________________________________________________
C
C*    Section 1.    Initialization.
C     _______________________________________________________
C
 100  CONTINUE
C
      IF ( NDBG .GT. 1) THEN
        CALL INTLOG(JP_DEBUG,'NMAKGG: Input parameters:',JPQUIET)
        CALL INTLOG(JP_DEBUG,'NMAKGG: Truncation = ', KTRUNC)
        CALL INTLOG(JP_DEBUG,'NMAKGG: Number of latitudes = ', KNUM)
        CALL INTLOG(JP_DEBUG, 'NMAKGG: Next latitude = ', KNEXT)
        CALL INTLOGR(JP_DEBUG, 'NMAKGG: Lat.in degrees = ', PLAT(KNEXT))
      ENDIF
C
C     _______________________________________________________
C
C*    Section 2.    Processing.
C     _______________________________________________________
C
      DEG2RAD = PPI / 180.0
C
      NEXT = 1
      DO ILAT = 1, KNUM
        ALAT = PLAT(KNEXT+ILAT-1) * DEG2RAD
C
        IF ( NDBG .GT. 1) CALL INTLOGR(JP_DEBUG,
     X    'NMAKGG: Next latitude constructed = ', ALAT)
C
        CALL JSPLEG1( PLEG(NEXT), ALAT, KTRUNC)
        NEXT = NEXT + (KTRUNC+1)*(KTRUNC+4)/2
      ENDDO
C     _______________________________________________________
C
C*    Section 9. Return to calling routine. Format statements
C     _______________________________________________________
C
 900  CONTINUE
      KRET = 0
C
 990  CONTINUE
      RETURN
      END

c Copyright 1981-2012 ECMWF.
c
c This software is licensed under the terms of the Apache Licence 
c Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
c
c In applying this licence, ECMWF does not waive the privileges and immunities 
c granted to it by virtue of its status as an intergovernmental organisation 
c nor does it submit to any jurisdiction.
c

      SUBROUTINE RPASSM(A,B,C,D,TRIGS,INC1,INC2,INC3,INC4,ILOT,N,IFAC,
     *    ILA,IERR)
      REAL A(*),B(*),C(*),D(*),TRIGS(*)
C
C     SUBROUTINE 'RPASSM' - PERFORMS ONE PASS THROUGH DATA AS PART
C     OF MULTIPLE REAL FFT (FOURIER SYNTHESIS) ROUTINE
C
C     A IS FIRST REAL INPUT VECTOR
C         EQUIVALENCE B(1) WITH A (ILA*INC1+1)
C     C IS FIRST REAL OUTPUT VECTOR
C         EQUIVALENCE D(1) WITH C(IFAC*ILA*INC2+1)
C     TRIGS IS A PRECALCULATED LIST OF SINES & COSINES
C     INC1 IS THE ADDRESSING INCREMENT FOR A
C     INC2 IS THE ADDRESSING INCREMENT FOR C
C     INC3 IS THE INCREMENT BETWEEN INPUT VECTORS A
C     INC4 IS THE INCREMENT BETWEEN OUTPUT VECTORS C
C     ILOT IS THE NUMBER OF VECTORS
C     N IS THE LENGTH OF THE VECTORS
C     IFAC IS THE CURRENT FACTOR OF N
C     ILA IS THE PRODUCT OF PREVIOUS FACTORS
C     IERR IS AN ERROR INDICATOR:
C              0 - PASS COMPLETED WITHOUT ERROR
C              1 - ILOT GREATER THAN 64
C              2 - IFAC NOT CATERED FOR
C              3 - IFAC ONLY CATERED FOR IF ILA=N/IFAC
C
C-----------------------------------------------------------------------
C
      REAL A10(512),A11(512),
     *     A20(512),A21(512),
     *     B10(512),B11(512),B20(512),B21(512)
C
      SAVE SIN36, SIN72, QRT5, SIN60
C
      DATA SIN36/0.587785252292473/,SIN72/0.951056516295154/,
     *    QRT5/0.559016994374947/,SIN60/0.866025403784437/
C
      M=N/IFAC
      IINK=ILA*INC1
      JINK=ILA*INC2
      JUMP=(IFAC-1)*JINK
      KSTOP=(N-IFAC)/(2*IFAC)
C
      IBAD=1
      IF (ILOT.GT.512) GO TO 910
      IBASE=0
      JBASE=0
      IGO=IFAC-1
      IF (IGO.EQ.7) IGO=6
      IBAD=2
      IF (IGO.LT.1.OR.IGO.GT.6) GO TO 910
      GO TO (200,300,400,500,600,800),IGO
C
C     CODING FOR FACTOR 2
C     -------------------
  200 CONTINUE
      IA=1
      IB=IA+(2*M-ILA)*INC1
      JA=1
      JB=JA+JINK
C
      IF (ILA.EQ.M) GO TO 290
C
      DO 220 IL=1,ILA
      I=IBASE
      J=JBASE
CDIR$ IVDEP
*VOCL LOOP,NOVREC
      DO 210 IJK=1,ILOT
      C(JA+J)=A(IA+I)+A(IB+I)
      C(JB+J)=A(IA+I)-A(IB+I)
      I=I+INC3
      J=J+INC4
  210 CONTINUE
      IBASE=IBASE+INC1
      JBASE=JBASE+INC2
  220 CONTINUE
      IA=IA+IINK
      IINK=2*IINK
      IB=IB-IINK
      IBASE=0
      JBASE=JBASE+JUMP
      JUMP=2*JUMP+JINK
      IF (IA.EQ.IB) GO TO 260
      DO 250 K=ILA,KSTOP,ILA
      KB=K+K
      C1=TRIGS(KB+1)
      S1=TRIGS(KB+2)
      IBASE=0
      DO 240 IL=1,ILA
      I=IBASE
      J=JBASE
CDIR$ IVDEP
*VOCL LOOP,NOVREC
      DO 230 IJK=1,ILOT
      C(JA+J)=A(IA+I)+A(IB+I)
      D(JA+J)=B(IA+I)-B(IB+I)
      C(JB+J)=C1*(A(IA+I)-A(IB+I))-S1*(B(IA+I)+B(IB+I))
      D(JB+J)=S1*(A(IA+I)-A(IB+I))+C1*(B(IA+I)+B(IB+I))
      I=I+INC3
      J=J+INC4
  230 CONTINUE
      IBASE=IBASE+INC1
      JBASE=JBASE+INC2
  240 CONTINUE
      IA=IA+IINK
      IB=IB-IINK
      JBASE=JBASE+JUMP
  250 CONTINUE
      IF (IA.GT.IB) GO TO 900
  260 CONTINUE
      IBASE=0
      DO 280 IL=1,ILA
      I=IBASE
      J=JBASE
CDIR$ IVDEP
*VOCL LOOP,NOVREC
      DO 270 IJK=1,ILOT
      C(JA+J)=A(IA+I)
      C(JB+J)=-B(IA+I)
      I=I+INC3
      J=J+INC4
  270 CONTINUE
      IBASE=IBASE+INC1
      JBASE=JBASE+INC2
  280 CONTINUE
      GO TO 900
C
  290 CONTINUE
      DO 294 IL=1,ILA
      I=IBASE
      J=JBASE
CDIR$ IVDEP
*VOCL LOOP,NOVREC
      DO 292 IJK=1,ILOT
      C(JA+J)=2.0*(A(IA+I)+A(IB+I))
      C(JB+J)=2.0*(A(IA+I)-A(IB+I))
      I=I+INC3
      J=J+INC4
  292 CONTINUE
      IBASE=IBASE+INC1
      JBASE=JBASE+INC2
  294 CONTINUE
      GO TO 900
C
C     CODING FOR FACTOR 3
C     -------------------
  300 CONTINUE
      IA=1
      IB=IA+(2*M-ILA)*INC1
      IC=IB
      JA=1
      JB=JA+JINK
      JC=JB+JINK
C
      IF (ILA.EQ.M) GO TO 390
C
      DO 320 IL=1,ILA
      I=IBASE
      J=JBASE
CDIR$ IVDEP
*VOCL LOOP,NOVREC
      DO 310 IJK=1,ILOT
      C(JA+J)=A(IA+I)+A(IB+I)
      C(JB+J)=(A(IA+I)-0.5*A(IB+I))-(SIN60*(B(IB+I)))
      C(JC+J)=(A(IA+I)-0.5*A(IB+I))+(SIN60*(B(IB+I)))
      I=I+INC3
      J=J+INC4
  310 CONTINUE
      IBASE=IBASE+INC1
      JBASE=JBASE+INC2
  320 CONTINUE
      IA=IA+IINK
      IINK=2*IINK
      IB=IB+IINK
      IC=IC-IINK
      JBASE=JBASE+JUMP
      JUMP=2*JUMP+JINK
      IF (IA.EQ.IC) GO TO 360
      DO 350 K=ILA,KSTOP,ILA
      KB=K+K
      KC=KB+KB
      C1=TRIGS(KB+1)
      S1=TRIGS(KB+2)
      C2=TRIGS(KC+1)
      S2=TRIGS(KC+2)
      IBASE=0
      DO 340 IL=1,ILA
      I=IBASE
      J=JBASE
CDIR$ IVDEP
*VOCL LOOP,NOVREC
      DO 330 IJK=1,ILOT
      C(JA+J)=A(IA+I)+(A(IB+I)+A(IC+I))
      D(JA+J)=B(IA+I)+(B(IB+I)-B(IC+I))
      C(JB+J)=
     *    C1*((A(IA+I)-0.5*(A(IB+I)+A(IC+I)))-(SIN60*(B(IB+I)+B(IC+
     *  I))))
     *   -S1*((B(IA+I)-0.5*(B(IB+I)-B(IC+I)))+(SIN60*(A(IB+I)-A(IC+
     *  I))))
      D(JB+J)=
     *    S1*((A(IA+I)-0.5*(A(IB+I)+A(IC+I)))-(SIN60*(B(IB+I)+B(IC+
     *  I))))
     *   +C1*((B(IA+I)-0.5*(B(IB+I)-B(IC+I)))+(SIN60*(A(IB+I)-A(IC+
     *  I))))
      C(JC+J)=
     *    C2*((A(IA+I)-0.5*(A(IB+I)+A(IC+I)))+(SIN60*(B(IB+I)+B(IC+
     *  I))))
     *   -S2*((B(IA+I)-0.5*(B(IB+I)-B(IC+I)))-(SIN60*(A(IB+I)-A(IC+
     *  I))))
      D(JC+J)=
     *    S2*((A(IA+I)-0.5*(A(IB+I)+A(IC+I)))+(SIN60*(B(IB+I)+B(IC+
     *  I))))
     *   +C2*((B(IA+I)-0.5*(B(IB+I)-B(IC+I)))-(SIN60*(A(IB+I)-A(IC+
     *  I))))
      I=I+INC3
      J=J+INC4
  330 CONTINUE
      IBASE=IBASE+INC1
      JBASE=JBASE+INC2
  340 CONTINUE
      IA=IA+IINK
      IB=IB+IINK
      IC=IC-IINK
      JBASE=JBASE+JUMP
  350 CONTINUE
      IF (IA.GT.IC) GO TO 900
  360 CONTINUE
      IBASE=0
      DO 380 IL=1,ILA
      I=IBASE
      J=JBASE
CDIR$ IVDEP
*VOCL LOOP,NOVREC
      DO 370 IJK=1,ILOT
      C(JA+J)=A(IA+I)+A(IB+I)
      C(JB+J)=(0.5*A(IA+I)-A(IB+I))-(SIN60*B(IA+I))
      C(JC+J)=-(0.5*A(IA+I)-A(IB+I))-(SIN60*B(IA+I))
      I=I+INC3
      J=J+INC4
  370 CONTINUE
      IBASE=IBASE+INC1
      JBASE=JBASE+INC2
  380 CONTINUE
      GO TO 900
C
  390 CONTINUE
      SSIN60=2.0*SIN60
      DO 394 IL=1,ILA
      I=IBASE
      J=JBASE
CDIR$ IVDEP
*VOCL LOOP,NOVREC
      DO 392 IJK=1,ILOT
      C(JA+J)=2.0*(A(IA+I)+A(IB+I))
      C(JB+J)=(2.0*A(IA+I)-A(IB+I))-(SSIN60*B(IB+I))
      C(JC+J)=(2.0*A(IA+I)-A(IB+I))+(SSIN60*B(IB+I))
      I=I+INC3
      J=J+INC4
  392 CONTINUE
      IBASE=IBASE+INC1
      JBASE=JBASE+INC2
  394 CONTINUE
      GO TO 900
C
C     CODING FOR FACTOR 4
C     -------------------
  400 CONTINUE
      IA=1
      IB=IA+(2*M-ILA)*INC1
      IC=IB+2*M*INC1
      ID=IB
      JA=1
      JB=JA+JINK
      JC=JB+JINK
      JD=JC+JINK
C
      IF (ILA.EQ.M) GO TO 490
C
      DO 420 IL=1,ILA
      I=IBASE
      J=JBASE
CDIR$ IVDEP
*VOCL LOOP,NOVREC
      DO 410 IJK=1,ILOT
      C(JA+J)=(A(IA+I)+A(IC+I))+A(IB+I)
      C(JB+J)=(A(IA+I)-A(IC+I))-B(IB+I)
      C(JC+J)=(A(IA+I)+A(IC+I))-A(IB+I)
      C(JD+J)=(A(IA+I)-A(IC+I))+B(IB+I)
      I=I+INC3
      J=J+INC4
  410 CONTINUE
      IBASE=IBASE+INC1
      JBASE=JBASE+INC2
  420 CONTINUE
      IA=IA+IINK
      IINK=2*IINK
      IB=IB+IINK
      IC=IC-IINK
      ID=ID-IINK
      JBASE=JBASE+JUMP
      JUMP=2*JUMP+JINK
      IF (IB.EQ.IC) GO TO 460
      DO 450 K=ILA,KSTOP,ILA
      KB=K+K
      KC=KB+KB
      KD=KC+KB
      C1=TRIGS(KB+1)
      S1=TRIGS(KB+2)
      C2=TRIGS(KC+1)
      S2=TRIGS(KC+2)
      C3=TRIGS(KD+1)
      S3=TRIGS(KD+2)
      IBASE=0
      DO 440 IL=1,ILA
      I=IBASE
      J=JBASE
CDIR$ IVDEP
*VOCL LOOP,NOVREC
      DO 430 IJK=1,ILOT
      C(JA+J)=(A(IA+I)+A(IC+I))+(A(IB+I)+A(ID+I))
      D(JA+J)=(B(IA+I)-B(IC+I))+(B(IB+I)-B(ID+I))
      C(JC+J)=
     *    C2*((A(IA+I)+A(IC+I))-(A(IB+I)+A(ID+I)))
     *   -S2*((B(IA+I)-B(IC+I))-(B(IB+I)-B(ID+I)))
      D(JC+J)=
     *    S2*((A(IA+I)+A(IC+I))-(A(IB+I)+A(ID+I)))
     *   +C2*((B(IA+I)-B(IC+I))-(B(IB+I)-B(ID+I)))
      C(JB+J)=
     *    C1*((A(IA+I)-A(IC+I))-(B(IB+I)+B(ID+I)))
     *   -S1*((B(IA+I)+B(IC+I))+(A(IB+I)-A(ID+I)))
      D(JB+J)=
     *    S1*((A(IA+I)-A(IC+I))-(B(IB+I)+B(ID+I)))
     *   +C1*((B(IA+I)+B(IC+I))+(A(IB+I)-A(ID+I)))
      C(JD+J)=
     *    C3*((A(IA+I)-A(IC+I))+(B(IB+I)+B(ID+I)))
     *   -S3*((B(IA+I)+B(IC+I))-(A(IB+I)-A(ID+I)))
      D(JD+J)=
     *    S3*((A(IA+I)-A(IC+I))+(B(IB+I)+B(ID+I)))
     *   +C3*((B(IA+I)+B(IC+I))-(A(IB+I)-A(ID+I)))
      I=I+INC3
      J=J+INC4
  430 CONTINUE
      IBASE=IBASE+INC1
      JBASE=JBASE+INC2
  440 CONTINUE
      IA=IA+IINK
      IB=IB+IINK
      IC=IC-IINK
      ID=ID-IINK
      JBASE=JBASE+JUMP
  450 CONTINUE
      IF (IB.GT.IC) GO TO 900
  460 CONTINUE
      IBASE=0
      SIN45=SQRT(0.5)
      DO 480 IL=1,ILA
      I=IBASE
      J=JBASE
CDIR$ IVDEP
*VOCL LOOP,NOVREC
      DO 470 IJK=1,ILOT
      C(JA+J)=A(IA+I)+A(IB+I)
      C(JB+J)=SIN45*((A(IA+I)-A(IB+I))-(B(IA+I)+B(IB+I)))
      C(JC+J)=B(IB+I)-B(IA+I)
      C(JD+J)=-SIN45*((A(IA+I)-A(IB+I))+(B(IA+I)+B(IB+I)))
      I=I+INC3
      J=J+INC4
  470 CONTINUE
      IBASE=IBASE+INC1
      JBASE=JBASE+INC2
  480 CONTINUE
      GO TO 900
C
  490 CONTINUE
      DO 494 IL=1,ILA
      I=IBASE
      J=JBASE
CDIR$ IVDEP
*VOCL LOOP,NOVREC
      DO 492 IJK=1,ILOT
      C(JA+J)=2.0*((A(IA+I)+A(IC+I))+A(IB+I))
      C(JB+J)=2.0*((A(IA+I)-A(IC+I))-B(IB+I))
      C(JC+J)=2.0*((A(IA+I)+A(IC+I))-A(IB+I))
      C(JD+J)=2.0*((A(IA+I)-A(IC+I))+B(IB+I))
      I=I+INC3
      J=J+INC4
  492 CONTINUE
      IBASE=IBASE+INC1
      JBASE=JBASE+INC2
  494 CONTINUE
      GO TO 900
C
C     CODING FOR FACTOR 5
C     -------------------
  500 CONTINUE
      IA=1
      IB=IA+(2*M-ILA)*INC1
      IC=IB+2*M*INC1
      ID=IC
      IE=IB
      JA=1
      JB=JA+JINK
      JC=JB+JINK
      JD=JC+JINK
      JE=JD+JINK
C
      IF (ILA.EQ.M) GO TO 590
C
      DO 520 IL=1,ILA
      I=IBASE
      J=JBASE
CDIR$ IVDEP
*VOCL LOOP,NOVREC
      DO 510 IJK=1,ILOT
      C(JA+J)=A(IA+I)+(A(IB+I)+A(IC+I))
      C(JB+J)=((A(IA+I)-0.25*(A(IB+I)+A(IC+I)))+QRT5*(A(IB+I)-A(IC+
     *  I)))
     *    -(SIN72*B(IB+I)+SIN36*B(IC+I))
      C(JC+J)=((A(IA+I)-0.25*(A(IB+I)+A(IC+I)))-QRT5*(A(IB+I)-A(IC+
     *  I)))
     *    -(SIN36*B(IB+I)-SIN72*B(IC+I))
      C(JD+J)=((A(IA+I)-0.25*(A(IB+I)+A(IC+I)))-QRT5*(A(IB+I)-A(IC+
     *  I)))
     *    +(SIN36*B(IB+I)-SIN72*B(IC+I))
      C(JE+J)=((A(IA+I)-0.25*(A(IB+I)+A(IC+I)))+QRT5*(A(IB+I)-A(IC+
     *  I)))
     *    +(SIN72*B(IB+I)+SIN36*B(IC+I))
      I=I+INC3
      J=J+INC4
  510 CONTINUE
      IBASE=IBASE+INC1
      JBASE=JBASE+INC2
  520 CONTINUE
      IA=IA+IINK
      IINK=2*IINK
      IB=IB+IINK
      IC=IC+IINK
      ID=ID-IINK
      IE=IE-IINK
      JBASE=JBASE+JUMP
      JUMP=2*JUMP+JINK
      IF (IB.EQ.ID) GO TO 560
      DO 550 K=ILA,KSTOP,ILA
      KB=K+K
      KC=KB+KB
      KD=KC+KB
      KE=KD+KB
      C1=TRIGS(KB+1)
      S1=TRIGS(KB+2)
      C2=TRIGS(KC+1)
      S2=TRIGS(KC+2)
      C3=TRIGS(KD+1)
      S3=TRIGS(KD+2)
      C4=TRIGS(KE+1)
      S4=TRIGS(KE+2)
      IBASE=0
      DO 540 IL=1,ILA
      I=IBASE
      J=JBASE
CDIR$ IVDEP
*VOCL LOOP,NOVREC
      DO 530 IJK=1,ILOT
C
      A10(IJK)=(A(IA+I)-0.25*((A(IB+I)+A(IE+I))+(A(IC+I)+A(ID+I))))
     *    +QRT5*((A(IB+I)+A(IE+I))-(A(IC+I)+A(ID+I)))
      A20(IJK)=(A(IA+I)-0.25*((A(IB+I)+A(IE+I))+(A(IC+I)+A(ID+I))))
     *    -QRT5*((A(IB+I)+A(IE+I))-(A(IC+I)+A(ID+I)))
      B10(IJK)=(B(IA+I)-0.25*((B(IB+I)-B(IE+I))+(B(IC+I)-B(ID+I))))
     *    +QRT5*((B(IB+I)-B(IE+I))-(B(IC+I)-B(ID+I)))
      B20(IJK)=(B(IA+I)-0.25*((B(IB+I)-B(IE+I))+(B(IC+I)-B(ID+I))))
     *    -QRT5*((B(IB+I)-B(IE+I))-(B(IC+I)-B(ID+I)))
      A11(IJK)=SIN72*(B(IB+I)+B(IE+I))+SIN36*(B(IC+I)+B(ID+I))
      A21(IJK)=SIN36*(B(IB+I)+B(IE+I))-SIN72*(B(IC+I)+B(ID+I))
      B11(IJK)=SIN72*(A(IB+I)-A(IE+I))+SIN36*(A(IC+I)-A(ID+I))
      B21(IJK)=SIN36*(A(IB+I)-A(IE+I))-SIN72*(A(IC+I)-A(ID+I))
C
      C(JA+J)=A(IA+I)+((A(IB+I)+A(IE+I))+(A(IC+I)+A(ID+I)))
      D(JA+J)=B(IA+I)+((B(IB+I)-B(IE+I))+(B(IC+I)-B(ID+I)))
      C(JB+J)=C1*(A10(IJK)-A11(IJK))-S1*(B10(IJK)+B11(IJK))
      D(JB+J)=S1*(A10(IJK)-A11(IJK))+C1*(B10(IJK)+B11(IJK))
      C(JE+J)=C4*(A10(IJK)+A11(IJK))-S4*(B10(IJK)-B11(IJK))
      D(JE+J)=S4*(A10(IJK)+A11(IJK))+C4*(B10(IJK)-B11(IJK))
      C(JC+J)=C2*(A20(IJK)-A21(IJK))-S2*(B20(IJK)+B21(IJK))
      D(JC+J)=S2*(A20(IJK)-A21(IJK))+C2*(B20(IJK)+B21(IJK))
      C(JD+J)=C3*(A20(IJK)+A21(IJK))-S3*(B20(IJK)-B21(IJK))
      D(JD+J)=S3*(A20(IJK)+A21(IJK))+C3*(B20(IJK)-B21(IJK))
C
      I=I+INC3
      J=J+INC4
  530 CONTINUE
      IBASE=IBASE+INC1
      JBASE=JBASE+INC2
  540 CONTINUE
      IA=IA+IINK
      IB=IB+IINK
      IC=IC+IINK
      ID=ID-IINK
      IE=IE-IINK
      JBASE=JBASE+JUMP
  550 CONTINUE
      IF (IB.GT.ID) GO TO 900
  560 CONTINUE
      IBASE=0
      DO 580 IL=1,ILA
      I=IBASE
      J=JBASE
CDIR$ IVDEP
*VOCL LOOP,NOVREC
      DO 570 IJK=1,ILOT
      C(JA+J)=(A(IA+I)+A(IB+I))+A(IC+I)
      C(JB+J)=(QRT5*(A(IA+I)-A(IB+I))+(0.25*(A(IA+I)+A(IB+I))-A(IC+
     *  I)))
     *    -(SIN36*B(IA+I)+SIN72*B(IB+I))
      C(JE+J)=-(QRT5*(A(IA+I)-A(IB+I))+(0.25*(A(IA+I)+A(IB+I))-A(IC+
     *  I)))
     *    -(SIN36*B(IA+I)+SIN72*B(IB+I))
      C(JC+J)=(QRT5*(A(IA+I)-A(IB+I))-(0.25*(A(IA+I)+A(IB+I))-A(IC+
     *  I)))
     *    -(SIN72*B(IA+I)-SIN36*B(IB+I))
      C(JD+J)=-(QRT5*(A(IA+I)-A(IB+I))-(0.25*(A(IA+I)+A(IB+I))-A(IC+
     *  I)))
     *    -(SIN72*B(IA+I)-SIN36*B(IB+I))
      I=I+INC3
      J=J+INC4
  570 CONTINUE
      IBASE=IBASE+INC1
      JBASE=JBASE+INC2
  580 CONTINUE
      GO TO 900
C
  590 CONTINUE
      QQRT5=2.0*QRT5
      SSIN36=2.0*SIN36
      SSIN72=2.0*SIN72
      DO 594 IL=1,ILA
      I=IBASE
      J=JBASE
CDIR$ IVDEP
*VOCL LOOP,NOVREC
      DO 592 IJK=1,ILOT
      C(JA+J)=2.0*(A(IA+I)+(A(IB+I)+A(IC+I)))
      C(JB+J)=(2.0*(A(IA+I)-0.25*(A(IB+I)+A(IC+I)))
     *    +QQRT5*(A(IB+I)-A(IC+I)))-(SSIN72*B(IB+I)+SSIN36*B(IC+I))
      C(JC+J)=(2.0*(A(IA+I)-0.25*(A(IB+I)+A(IC+I)))
     *    -QQRT5*(A(IB+I)-A(IC+I)))-(SSIN36*B(IB+I)-SSIN72*B(IC+I))
      C(JD+J)=(2.0*(A(IA+I)-0.25*(A(IB+I)+A(IC+I)))
     *    -QQRT5*(A(IB+I)-A(IC+I)))+(SSIN36*B(IB+I)-SSIN72*B(IC+I))
      C(JE+J)=(2.0*(A(IA+I)-0.25*(A(IB+I)+A(IC+I)))
     *    +QQRT5*(A(IB+I)-A(IC+I)))+(SSIN72*B(IB+I)+SSIN36*B(IC+I))
      I=I+INC3
      J=J+INC4
  592 CONTINUE
      IBASE=IBASE+INC1
      JBASE=JBASE+INC2
  594 CONTINUE
      GO TO 900
C
C     CODING FOR FACTOR 6
C     -------------------
  600 CONTINUE
      IA=1
      IB=IA+(2*M-ILA)*INC1
      IC=IB+2*M*INC1
      ID=IC+2*M*INC1
      IE=IC
      IF=IB
      JA=1
      JB=JA+JINK
      JC=JB+JINK
      JD=JC+JINK
      JE=JD+JINK
      JF=JE+JINK
C
      IF (ILA.EQ.M) GO TO 690
C
      DO 620 IL=1,ILA
      I=IBASE
      J=JBASE
CDIR$ IVDEP
*VOCL LOOP,NOVREC
      DO 610 IJK=1,ILOT
      C(JA+J)=(A(IA+I)+A(ID+I))+(A(IB+I)+A(IC+I))
      C(JD+J)=(A(IA+I)-A(ID+I))-(A(IB+I)-A(IC+I))
      C(JB+J)=((A(IA+I)-A(ID+I))+0.5*(A(IB+I)-A(IC+I)))
     *    -(SIN60*(B(IB+I)+B(IC+I)))
      C(JF+J)=((A(IA+I)-A(ID+I))+0.5*(A(IB+I)-A(IC+I)))
     *    +(SIN60*(B(IB+I)+B(IC+I)))
      C(JC+J)=((A(IA+I)+A(ID+I))-0.5*(A(IB+I)+A(IC+I)))
     *    -(SIN60*(B(IB+I)-B(IC+I)))
      C(JE+J)=((A(IA+I)+A(ID+I))-0.5*(A(IB+I)+A(IC+I)))
     *    +(SIN60*(B(IB+I)-B(IC+I)))
      I=I+INC3
      J=J+INC4
  610 CONTINUE
      IBASE=IBASE+INC1
      JBASE=JBASE+INC2
  620 CONTINUE
      IA=IA+IINK
      IINK=2*IINK
      IB=IB+IINK
      IC=IC+IINK
      ID=ID-IINK
      IE=IE-IINK
      IF=IF-IINK
      JBASE=JBASE+JUMP
      JUMP=2*JUMP+JINK
      IF (IC.EQ.ID) GO TO 660
      DO 650 K=ILA,KSTOP,ILA
      KB=K+K
      KC=KB+KB
      KD=KC+KB
      KE=KD+KB
      KF=KE+KB
      C1=TRIGS(KB+1)
      S1=TRIGS(KB+2)
      C2=TRIGS(KC+1)
      S2=TRIGS(KC+2)
      C3=TRIGS(KD+1)
      S3=TRIGS(KD+2)
      C4=TRIGS(KE+1)
      S4=TRIGS(KE+2)
      C5=TRIGS(KF+1)
      S5=TRIGS(KF+2)
      IBASE=0
      DO 640 IL=1,ILA
      I=IBASE
      J=JBASE
CDIR$ IVDEP
*VOCL LOOP,NOVREC
      DO 630 IJK=1,ILOT
C
      A11(IJK)= (A(IE+I)+A(IB+I))+(A(IC+I)+A(IF+I))
      A20(IJK)=(A(IA+I)+A(ID+I))-0.5*A11(IJK)
      A21(IJK)=SIN60*((A(IE+I)+A(IB+I))-(A(IC+I)+A(IF+I)))
      B11(IJK)= (B(IB+I)-B(IE+I))+(B(IC+I)-B(IF+I))
      B20(IJK)=(B(IA+I)-B(ID+I))-0.5*B11(IJK)
      B21(IJK)=SIN60*((B(IB+I)-B(IE+I))-(B(IC+I)-B(IF+I)))
C
      C(JA+J)=(A(IA+I)+A(ID+I))+A11(IJK)
      D(JA+J)=(B(IA+I)-B(ID+I))+B11(IJK)
      C(JC+J)=C2*(A20(IJK)-B21(IJK))-S2*(B20(IJK)+A21(IJK))
      D(JC+J)=S2*(A20(IJK)-B21(IJK))+C2*(B20(IJK)+A21(IJK))
      C(JE+J)=C4*(A20(IJK)+B21(IJK))-S4*(B20(IJK)-A21(IJK))
      D(JE+J)=S4*(A20(IJK)+B21(IJK))+C4*(B20(IJK)-A21(IJK))
C
      A11(IJK)=(A(IE+I)-A(IB+I))+(A(IC+I)-A(IF+I))
      B11(IJK)=(B(IE+I)+B(IB+I))-(B(IC+I)+B(IF+I))
      A20(IJK)=(A(IA+I)-A(ID+I))-0.5*A11(IJK)
      A21(IJK)=SIN60*((A(IE+I)-A(IB+I))-(A(IC+I)-A(IF+I)))
      B20(IJK)=(B(IA+I)+B(ID+I))+0.5*B11(IJK)
      B21(IJK)=SIN60*((B(IE+I)+B(IB+I))+(B(IC+I)+B(IF+I)))
C
      C(JD+J)=
     *  C3*((A(IA+I)-A(ID+I))+A11(IJK))-S3*((B(IA+I)+B(ID+I))-B11(IJK))
      D(JD+J)=
     *  S3*((A(IA+I)-A(ID+I))+A11(IJK))+C3*((B(IA+I)+B(ID+I))-B11(IJK))
      C(JB+J)=C1*(A20(IJK)-B21(IJK))-S1*(B20(IJK)-A21(IJK))
      D(JB+J)=S1*(A20(IJK)-B21(IJK))+C1*(B20(IJK)-A21(IJK))
      C(JF+J)=C5*(A20(IJK)+B21(IJK))-S5*(B20(IJK)+A21(IJK))
      D(JF+J)=S5*(A20(IJK)+B21(IJK))+C5*(B20(IJK)+A21(IJK))
C
      I=I+INC3
      J=J+INC4
  630 CONTINUE
      IBASE=IBASE+INC1
      JBASE=JBASE+INC2
  640 CONTINUE
      IA=IA+IINK
      IB=IB+IINK
      IC=IC+IINK
      ID=ID-IINK
      IE=IE-IINK
      IF=IF-IINK
      JBASE=JBASE+JUMP
  650 CONTINUE
      IF (IC.GT.ID) GO TO 900
  660 CONTINUE
      IBASE=0
      DO 680 IL=1,ILA
      I=IBASE
      J=JBASE
CDIR$ IVDEP
*VOCL LOOP,NOVREC
      DO 670 IJK=1,ILOT
      C(JA+J)=A(IB+I)+(A(IA+I)+A(IC+I))
      C(JD+J)=B(IB+I)-(B(IA+I)+B(IC+I))
      C(JB+J)=(SIN60*(A(IA+I)-A(IC+I)))-(0.5*(B(IA+I)+B(IC+I))+B(IB+
     *  I))
      C(JF+J)=-(SIN60*(A(IA+I)-A(IC+I)))-(0.5*(B(IA+I)+B(IC+I))+B(IB+
     *  I))
      C(JC+J)=SIN60*(B(IC+I)-B(IA+I))+(0.5*(A(IA+I)+A(IC+I))-A(IB+I))
      C(JE+J)=SIN60*(B(IC+I)-B(IA+I))-(0.5*(A(IA+I)+A(IC+I))-A(IB+I))
      I=I+INC3
      J=J+INC4
  670 CONTINUE
      IBASE=IBASE+INC1
      JBASE=JBASE+INC2
  680 CONTINUE
      GO TO 900
C
  690 CONTINUE
      SSIN60=2.0*SIN60
      DO 694 IL=1,ILA
      I=IBASE
      J=JBASE
CDIR$ IVDEP
*VOCL LOOP,NOVREC
      DO 692 IJK=1,ILOT
      C(JA+J)=(2.0*(A(IA+I)+A(ID+I)))+(2.0*(A(IB+I)+A(IC+I)))
      C(JD+J)=(2.0*(A(IA+I)-A(ID+I)))-(2.0*(A(IB+I)-A(IC+I)))
      C(JB+J)=(2.0*(A(IA+I)-A(ID+I))+(A(IB+I)-A(IC+I)))
     *    -(SSIN60*(B(IB+I)+B(IC+I)))
      C(JF+J)=(2.0*(A(IA+I)-A(ID+I))+(A(IB+I)-A(IC+I)))
     *    +(SSIN60*(B(IB+I)+B(IC+I)))
      C(JC+J)=(2.0*(A(IA+I)+A(ID+I))-(A(IB+I)+A(IC+I)))
     *    -(SSIN60*(B(IB+I)-B(IC+I)))
      C(JE+J)=(2.0*(A(IA+I)+A(ID+I))-(A(IB+I)+A(IC+I)))
     *    +(SSIN60*(B(IB+I)-B(IC+I)))
      I=I+INC3
      J=J+INC4
  692 CONTINUE
      IBASE=IBASE+INC1
      JBASE=JBASE+INC2
  694 CONTINUE
      GO TO 900
C
C     CODING FOR FACTOR 8
C     -------------------
  800 CONTINUE
      IBAD=3
      IF (ILA.NE.M) GO TO 910
      IA=1
      IB=IA+ILA*INC1
      IC=IB+2*ILA*INC1
      ID=IC+2*ILA*INC1
      IE=ID+2*ILA*INC1
      JA=1
      JB=JA+JINK
      JC=JB+JINK
      JD=JC+JINK
      JE=JD+JINK
      JF=JE+JINK
      JG=JF+JINK
      JH=JG+JINK
      SSIN45=SQRT(2.0)
C
      DO 820 IL=1,ILA
      I=IBASE
      J=JBASE
CDIR$ IVDEP
*VOCL LOOP,NOVREC
      DO 810 IJK=1,ILOT
      C(JA+J)=2.0*(((A(IA+I)+A(IE+I))+A(IC+I))+(A(IB+I)+A(ID+I)))
      C(JE+J)=2.0*(((A(IA+I)+A(IE+I))+A(IC+I))-(A(IB+I)+A(ID+I)))
      C(JC+J)=2.0*(((A(IA+I)+A(IE+I))-A(IC+I))-(B(IB+I)-B(ID+I)))
      C(JG+J)=2.0*(((A(IA+I)+A(IE+I))-A(IC+I))+(B(IB+I)-B(ID+I)))
      C(JB+J)=2.0*((A(IA+I)-A(IE+I))-B(IC+I))
     *    +SSIN45*((A(IB+I)-A(ID+I))-(B(IB+I)+B(ID+I)))
      C(JF+J)=2.0*((A(IA+I)-A(IE+I))-B(IC+I))
     *    -SSIN45*((A(IB+I)-A(ID+I))-(B(IB+I)+B(ID+I)))
      C(JD+J)=2.0*((A(IA+I)-A(IE+I))+B(IC+I))
     *    -SSIN45*((A(IB+I)-A(ID+I))+(B(IB+I)+B(ID+I)))
      C(JH+J)=2.0*((A(IA+I)-A(IE+I))+B(IC+I))
     *    +SSIN45*((A(IB+I)-A(ID+I))+(B(IB+I)+B(ID+I)))
      I=I+INC3
      J=J+INC4
  810 CONTINUE
      IBASE=IBASE+INC1
      JBASE=JBASE+INC2
  820 CONTINUE
C
C     RETURN
C     ------
  900 CONTINUE
      IBAD=0
  910 CONTINUE
      IERR=IBAD
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      INTEGER FUNCTION HNEI12
     X  (L12PNT,KLEN,RLAT,RLON,KGAUSS,KPTS,PLATIN,
     X   KSCHEME,PDLAT,PDLO0,PDLO1,PDLO2,PDLO3,KLA,NEIGH)
C
C---->
C**** HNEI12
C
C     Purpose
C     -------
C
C     This routine accepts a vector of points and finds the 12
C     neighbours for each point suitable for horizontal interpolation.
C
C
C     Interface
C     ---------
C
C     IRET = HNEI12(L12PNT,KLEN,RLAT,RLON,KGAUSS,KPTS,PLATIN,
C    X              KSCHEME,PDLAT,PDLO0,PDLO1,PDLO2,PDLO3,KLA,NEIGH)
C
C
C     Input parameters
C     ----------------
C
C     L12PNT - Chooses between 12-point and 4-point interpolation
C              = .TRUE. for 12-point horizontal
C              = .FALSE. for 4-point
C     KLEN   - Number of points along the vector
C     RLAT   - List of latitudes for points.
C     RLON   - List of longitudes for points.
C     KGAUSS - Original gaussian field number.
C     KPTS   - List giving number of points in each latitude in original
C              gaussian field.
C     PLATIN - Original gaussian field latitudes (north and south).
C
C
C     Output parameters
C     -----------------
C
C     KSCHEME - Flag showing interpolation scheme to use for point
C               0 = 12-point
C               1 = 4-point bilinear
C               2 = nearest neighbour
C     PDLAT   - Meridian linear weight.
C     PDLO0   - Zonal linear weight for the latitude of point 5.
C     PDLO1   - Zonal linear weight for the latitude of point 1.
C     PDLO2   - Zonal linear weight for the latitude of point 3.
C     PDLO3   - Zonal linear weight for the latitude of point 11.
C     KLA     - Latitude number in original field of latitude north of
C               each point in the vector.
C     NEIGH   - List of indices in the original field of neighbouring
C               point values for each point in the vector.
C
C     Returns 0 if function successful, non-zero otherwise.
C
C     Common block usage
C     ------------------
C
C     None.
C
C
C     Method
C     ------
C
C     Numbering of the points (I is the interpolation point):
C
C                   13       5       6      14
C
C                    7       1       2       8
C                               (I)
C                    9       3       4      10
C
C                   15      11      12      16
C
C     The 12-point interpolation is not possible if either of the top
C     two rows is above the original field northern latitude. The
C     nearest neighbour is used if both rows are above, and a 4-pt
C     bilinear interpolation is used if the top row is above.
C     Similarily, if either of the bottom two rows is below the original
C     field southern latitude.
C
C
C     Externals
C     ---------
C
C     INTLOG  - Log error message.
C     JNORSGG - Finds gaussian latitude north or south of given latitude
C     JDEBUG  - Tests if debug output required.
C     JMALLOC - Dynamically allocate memory
C     JFREE   - Free dynamically allocated memory
C
C
C     Reference
C     ---------
C
C     ECMWF Meteorological Bulletin M1.6/7
C     IFS Documentation
C     Part VI: Technical and Computational Procedures (CY21R4)
C     March 2000
C     Section 2.3
C
C
C     Comments
C     --------
C
C     None.
C
C
C     Author
C     ------
C
C     J.D.Chambers      ECMWF      January 2001
C
C
C     Modifications
C     -------------
C
C     None.
C
C----<
C     -----------------------------------------------------------------|
C*    Section 0. Definition of variables.
C     -----------------------------------------------------------------|
C
      IMPLICIT NONE
#include "parim.h"
C
C     Parameters
C
      INTEGER JP12PT, JP4PT, JPNEARN
      PARAMETER (JP12PT  = 0)
      PARAMETER (JP4PT   = 1)
      PARAMETER (JPNEARN = 2)
C
C     Function arguments
C
      LOGICAL L12PNT
      INTEGER KLEN, KGAUSS, KPTS(KGAUSS*2)
      REAL RLAT(KLEN), RLON(KLEN), PLATIN(KGAUSS*2)
C
      INTEGER KLA(KLEN), KSCHEME(KLEN)
      REAL PDLAT(KLEN),PDLO0(KLEN),PDLO1(KLEN),PDLO2(KLEN),PDLO3(KLEN)
      INTEGER NEIGH(12,*)
C
C     Local variables
C
      INTEGER NEXT, LOOP, NBYTES
      INTEGER NLAT0, NLAT1, NLAT2, NLAT3, NLAT(12), NLONG(12)
      REAL STEP0, STEP1, STEP2, STEP3
      INTEGER NPREV, ISIZE, ISIZOLD, IOFFSET(1)
      POINTER( IPOFF, IOFFSET )
C
      DATA ISIZOLD/-1/, NPREV/-1/
      SAVE ISIZOLD,IPOFF,NPREV
C
C     Externals
C
      INTEGER JNORSGG
#ifdef POINTER_64
      INTEGER*8 JMALLOC
#else
      INTEGER JMALLOC
#endif
C
C     -----------------------------------------------------------------|
C     Section 1.  Initialise.
C     -----------------------------------------------------------------|
C
  100 CONTINUE
C
      HNEI12 = 0
C
      CALL JDEBUG()
C
C     Get memory for offset array.
C
      ISIZE = KGAUSS*2 + 1
      IF( ISIZE.GT.ISIZOLD ) THEN
C
        IF( ISIZOLD.GT.0 ) CALL JFREE(IPOFF)
C
        NBYTES = ISIZE * JPBYTES
        IPOFF = JMALLOC(NBYTES)
#ifdef hpR64
        IPOFF = IPOFF/(1024*1024*1024*4)
#endif
        IF( IPOFF.EQ.0 ) THEN
          CALL INTLOG(JP_WARN,'HNEI12: Memory allocate fail ',JPQUIET)
          HNEI12 = 1
          GOTO 900
        ENDIF
C
        ISIZOLD = ISIZE
        NPREV = -1
C
      ENDIF
C
C     Build up offsets to start of each latitude in the original field.
C
      IF( KGAUSS.NE.NPREV ) THEN
        IOFFSET(1) = 1
        DO LOOP = 2, (KGAUSS*2+1)
          IOFFSET(LOOP) = IOFFSET(LOOP-1) + KPTS(LOOP-1)
        ENDDO
        NPREV = KGAUSS
      ENDIF
C
C     -----------------------------------------------------------------|
C       Section 2.  Loop through points along the vector.
C     -----------------------------------------------------------------|
C
  200 CONTINUE
C
      DO NEXT = 1,KLEN
C
C       Clear current neighbour indices
C
        DO LOOP = 1, 12
          NEIGH(LOOP,NEXT) = 0
        ENDDO
C
C       Find latitude numbers for neighbours.
C
C       First find latitude numbers to north and south of the point
C
C     -----------------------------------------------------------------|
C       Section 3. Nearest neighbour to be used.
C     -----------------------------------------------------------------|
C
  300   CONTINUE
C
        IF( RLAT(NEXT).GT.PLATIN(1) ) THEN
          CALL INTLOG(JP_DEBUG,
     X      'HNEI12: Nearest neighbour to south used for point ',NEXT)
C
C         Above northern latitude of original field, so use nearest
C         neighbour (point 3 or 4)
C
          STEP2 = 360.0 / REAL(KPTS(1))
          NLONG( 3) = 1 + INT(RLON(NEXT)/STEP2)
          IF( NLONG( 3).GT.KPTS(1) ) NLONG( 3) = 1
          NLONG( 4) = NLONG(3) + 1
          IF( NLONG( 4).GT.KPTS(1) ) NLONG( 4) = 1
C
          IF( ABS((RLON(NEXT) - REAL(NLONG(3)-1)*STEP2 )) .LE.
     X        ABS((RLON(NEXT) - REAL(NLONG(4)-1)*STEP2 )) ) THEN
            NEIGH(3,NEXT) = NLONG(3)
          ELSE
            NEIGH(4,NEXT) = NLONG(4)
          ENDIF
          KSCHEME(NEXT) = JPNEARN
          GOTO 600
        ENDIF
C
        IF( RLAT(NEXT).LT.PLATIN(KGAUSS*2) ) THEN
          CALL INTLOG(JP_DEBUG,
     X      'HNEI12: Nearest neighbour to north used for point ',NEXT)
C
C         Below southern latitude of original field, so use nearest
C         neighbour (point 1 or 2)
C
          STEP1 = 360.0 / REAL(KPTS(KGAUSS*2))
          NLONG( 1) = 1 + INT(RLON(NEXT)/STEP1)
          IF( NLONG( 1).GT.KPTS(KGAUSS*2) ) NLONG( 1) = 1
          NLONG( 2) = NLONG(1) + 1
          IF( NLONG( 2).GT.KPTS(KGAUSS*2) ) NLONG( 2) = 1
C
          IF( ABS((RLON(NEXT) - REAL(NLONG(1)-1)*STEP1 )) .LE.
     X        ABS((RLON(NEXT) - REAL(NLONG(2)-1)*STEP1 )) ) THEN
            NEIGH(1,NEXT) = IOFFSET(KGAUSS*2) + NLONG(1) - 1
          ELSE
            NEIGH(2,NEXT) = IOFFSET(KGAUSS*2) + NLONG(2) - 1
          ENDIF
          KSCHEME(NEXT) = JPNEARN
          GOTO 600
        ENDIF
C
        NLAT1 = JNORSGG(RLAT(NEXT),PLATIN,KGAUSS,1)
        NLAT2 = JNORSGG(RLAT(NEXT),PLATIN,KGAUSS,0)
C
        IF( NLAT2.EQ.NLAT1) NLAT2 = NLAT1 + 1
C
C       Find outer latitude numbers to north and south of the point
C
        NLAT0 = NLAT1 - 1
        NLAT3 = NLAT2 + 1
C
C     -----------------------------------------------------------------|
C       Section 4. 4-point bilinear to be used.
C     -----------------------------------------------------------------|
C
  400   CONTINUE
C
        IF( (NLAT0.EQ.0).OR.(NLAT3.GT.KGAUSS*2).OR.(.NOT.L12PNT) ) THEN
Cjdc      CALL INTLOG(JP_DEBUG,
Cjdc X      'HNEI12: 4-pt bilinear interpolation used for point ',NEXT)
C
C         Between two northern latitudes or two southern latitudes of
C         original field, so use 4-point bilinear interpolation
C         (points 1, 2, 3 and 4)
C
C         Points 1 and 2
C
          STEP1 = 360.0 / REAL(KPTS(NLAT1))
          NLONG(1) = 1 + INT(RLON(NEXT)/STEP1)
          IF( NLONG(1).GT.KPTS(NLAT1) ) NLONG(1) = 1
          NLONG(2) = NLONG(1) + 1
          IF( NLONG(2).GT.KPTS(NLAT1) ) NLONG(2) = 1
C
          NEIGH(1,NEXT) = IOFFSET(NLAT1) + NLONG(1) - 1
          NEIGH(2,NEXT) = IOFFSET(NLAT1) + NLONG(2) - 1
C
C         Points 3 and 4
C
          STEP2 = 360.0 / REAL(KPTS(NLAT2))
          NLONG( 3) = 1 + INT(RLON(NEXT)/STEP2)
          IF( NLONG( 3).GT.KPTS(NLAT2) ) NLONG( 3) = 1
          NLONG( 4) = NLONG(3) + 1
          IF( NLONG( 4).GT.KPTS(NLAT2) ) NLONG( 4) = 1
C
          NEIGH(3,NEXT) = IOFFSET(NLAT2) + NLONG(3) - 1
          NEIGH(4,NEXT) = IOFFSET(NLAT2) + NLONG(4) - 1
C
C         Calculate zonal linear weights for the latitudes.
C
          PDLO1(NEXT) = ( RLON(NEXT) - REAL(NLONG(1)-1)*STEP1 ) / STEP1
          PDLO2(NEXT) = ( RLON(NEXT) - REAL(NLONG(3)-1)*STEP2 ) / STEP2
C
          KLA(NEXT) = NLAT1
          PDLAT(NEXT) = ( RLAT(NEXT) - PLATIN(NLAT1) ) /
     X                  ( PLATIN(NLAT2) - PLATIN(NLAT1) )
C
          KSCHEME(NEXT) = JP4PT
          GOTO 600
        ENDIF
C
C     -----------------------------------------------------------------|
C       Section 5. 12-point interpolation to be used.
C     -----------------------------------------------------------------|
C
  500   CONTINUE
C
        KSCHEME(NEXT) = JP12PT
C
        KLA(NEXT) = NLAT1
        PDLAT(NEXT) = ( RLAT(NEXT) - PLATIN(NLAT1) ) /
     X                ( PLATIN(NLAT2) - PLATIN(NLAT1) )
C
C       Northernmost
C
        NLAT(5) = NLAT0
        NLAT(6) = NLAT0
C
C       Northern
C
        NLAT(7) = NLAT1
        NLAT(1) = NLAT1
        NLAT(2) = NLAT1
        NLAT(8) = NLAT1
C
C       Southern
C
        NLAT( 9) = NLAT2
        NLAT( 3) = NLAT2
        NLAT( 4) = NLAT2
        NLAT(10) = NLAT2
C
C       Southernmost
C
        NLAT(11) = NLAT3
        NLAT(12) = NLAT3
C
C     -----------------------------------------------------------------|
C       Find longitude numbers for neighbours.
C     -----------------------------------------------------------------|
C
C       Northernmost
C
        STEP0 = 360.0 / REAL(KPTS(NLAT0))
        NLONG(5) = 1 + INT(RLON(NEXT)/STEP0)
        IF( NLONG(5).GT.KPTS(NLAT0) ) NLONG(5) = 1
        NLONG(6) = NLONG(5) + 1
        IF( NLONG(6).GT.KPTS(NLAT0) ) NLONG(6) = 1
C
C       Northern
C
        STEP1 = 360.0 / REAL(KPTS(NLAT1))
        NLONG(1) = 1 + INT(RLON(NEXT)/STEP1)
        IF( NLONG(1).GT.KPTS(NLAT1) ) NLONG(1) = 1
        NLONG(7) = NLONG(1) - 1
        IF( NLONG(7).LT.1 ) NLONG(7) = KPTS(NLAT1)
        NLONG(2) = NLONG(1) + 1
        IF( NLONG(2).GT.KPTS(NLAT1) ) NLONG(2) = 1
        NLONG(8) = NLONG(2) + 1
        IF( NLONG(8).GT.KPTS(NLAT1) ) NLONG(8) = 1
C
C       Southern
C
        STEP2 = 360.0 / REAL(KPTS(NLAT2))
        NLONG( 3) = 1 + INT(RLON(NEXT)/STEP2)
        IF( NLONG( 3).GT.KPTS(NLAT2) ) NLONG( 3) = 1
        NLONG( 9) = NLONG(3) - 1
        IF( NLONG( 9).LT.1 ) NLONG( 9) = KPTS(NLAT2)
        NLONG( 4) = NLONG(3) + 1
        IF( NLONG( 4).GT.KPTS(NLAT2) ) NLONG( 4) = 1
        NLONG(10) = NLONG(4) + 1
        IF( NLONG(10).GT.KPTS(NLAT2) ) NLONG(10) = 1
C
C       Southernmost
C
        STEP3 = 360.0 / REAL(KPTS(NLAT3))
        NLONG(11) = 1 + INT(RLON(NEXT)/STEP3)
        IF( NLONG(11).GT.KPTS(NLAT3) ) NLONG(11) = 1
        NLONG(12) = NLONG(11) + 1
        IF( NLONG(12).GT.KPTS(NLAT3) ) NLONG(12) = 1
C
C     -----------------------------------------------------------------|
C       Calculate zonal linear weights for the latitudes.
C     -----------------------------------------------------------------|
C
        PDLO0(NEXT) = ( RLON(NEXT) - REAL(NLONG(5)-1)*STEP0 ) / STEP0
C
        PDLO1(NEXT) = ( RLON(NEXT) - REAL(NLONG(1)-1)*STEP1 ) / STEP1
C
        PDLO2(NEXT) = ( RLON(NEXT) - REAL(NLONG(3)-1)*STEP2 ) / STEP2
C
        PDLO3(NEXT) = ( RLON(NEXT) - REAL(NLONG(11)-1)*STEP3 ) / STEP3
C
C     -----------------------------------------------------------------|
C       Store indices of the neighbours.
C     -----------------------------------------------------------------|
C
        DO LOOP = 1, 12
          NEIGH(LOOP,NEXT) = IOFFSET(NLAT(LOOP)) + NLONG(LOOP) - 1
        ENDDO
C
C     -----------------------------------------------------------------|
C     Section 6.  End of loop along vector of points.
C     -----------------------------------------------------------------|
C
  600   CONTINUE
C
      ENDDO
C
C     -----------------------------------------------------------------|
C     Section 9.  Return
C     -----------------------------------------------------------------|
C
  900 CONTINUE
C
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C


      SUBROUTINE GETIB2 (KLIB2,KIB2,KLENG,KARRAY,KPR,KRET)
C
C---->
C**** GETIB2 - Extract integer values from section 2 of GRIB record.
C
C     Purpose.
C     --------
C
C           Get integer values from section 2 of unpacked GRIB or
C           Pseudo-grib records, retrieved from MARS.
C
C**   Interface.
C     ----------
C
C           CALL GETIB2 (KLIB2,KIB2,KLENG,KARRAY,KPR,KRET)
C
C           INTEGER    K.
C           REAL       P.
C           LOGICAL    O.
C           CHARACTER  H.
C
C               Input parameters.
C               -----------------
C
C               KIB2       - Array to receive section 2 values.
C               KLENG      - Length of this array.
C               KARRAY     - Array containing unpacked record.
C               KPR        - Debug print switch.
C                            0 , No printout.
C                            1 , Debug printout.
C                            2 , Print section 2 values.
C
C               KRET       - Abort/no abort when error found.
C                            0   , Abort if error found.
C                            Non-zero , no abort if error found.
C
C               Output parameters.
C               ------------------
C
C               KIB2       - Array containing values from section 2.
C               KLIB2      - Number of values in this array.
C               KRET       - Error return code.
C                            0   , No error encountered.
C                            1   , Target array too small.
C
C     Method.
C     -------
C
C           Unpacked data is in self defining records. The required
C           values are located and extracted.
C
C     Externals.
C     ----------
C
C           PRTBK2
C
C     Reference.
C     ----------
C
C           See MARS format documentation re GRIB, Pseudo-grib and
C           unpacked formats.
C
C     Comments.
C     ---------
C
C           Routine contains sections 0 to 2 and section 9.
C
C     Author.
C     -------
C
C           J. Hennessy      ECMWF      18:06:86.
C
C     Modifications
C     --------------
C
C           None.
C
C     ---------------------------------------------------------------
C----<
C
C
C
C
C
C
C
C
C
C
C*    SECTION 0 . DEFINITION OF VARIABLES.
C     ------------------------------------
C
      IMPLICIT LOGICAL     ( L, O, G )
      IMPLICIT CHARACTER*8 ( C, H, Y )
      IMPLICIT INTEGER     ( I, J, K, M, N )
C
      DIMENSION KARRAY(*)
      DIMENSION KIB2(KLENG)
C
C     ---------------------------------------------------------------
C
C
C
C
C
C
C
C
C
C
C
C*    SECTION 1 . SET INITIAL VALUES. CHECK INPUT PARAMETERS.
C     -------------------------------------------------------
C
 1000 CONTINUE
C
      IF (KPR.EQ.1) WRITE (*,*) 'GETIB2 : SECTION 1.'
C
      IRET = KRET
      KRET = 0
C
C     --------------------------------------------------------------
C
C
C
C
C
C
C
C
C
C
C*    SECTION 2 . EXTRACT VALUES . PRINT IF REQUIRED.
C     -----------------------------------------------
C
 2000 CONTINUE
C
      IF (KPR.EQ.1) WRITE (*,*) 'GETIB2 : SECTION 2.'
C
      ILIB1 = KARRAY(2)
      KLIB2 = KARRAY(2+ILIB1+1)
C
      IF (KLENG.LT.KLIB2)
     C   THEN
             KRET = 1
             WRITE (*,9001) KRET , KLIB2
             GO TO 9000
         ENDIF
C
      DO 2010 J=1,KLIB2
         KIB2(J) = KARRAY(J+2+ILIB1+1)
 2010 CONTINUE
C
      IF (KPR.GT.0) CALL PRTBK2(KIB2)
C
C     ------------------------------------------------------------------
C
C
C
C
C
C
C
C
C
C
C
C*    SECTION 9 . RETURN TO CALLING ROUTINE OR ABORT. FORMAT STATEMENTS.
C     ------------------------------------------------------------------
C
 9000 CONTINUE
C
      IF (KPR.EQ.1) WRITE (*,*) 'GETIB2 : SECTION 9.'
C
      IF (KRET.NE.0.AND.IRET.EQ.0) CALL ABORT
C
      RETURN
C
C
 9001 FORMAT (1H ,'GETIB2 : ERROR CODE = ',I3,'. TARGET ARRAY MUST BE ',
     C             ' AT LEAST ',I5,' WORDS LONG.')
C
C     ------------------------------------------------------------------
C
C
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities
C granted to it by virtue of its status as an intergovernmental organisation
C nor does it submit to any jurisdiction.
C

      SUBROUTINE GRCHK2 (KSEC1,KSEC2,PSEC2,KRET)
C
C---->
C**** GRCHK2 - Check parameters for Section 2 of GRIB Code.
C
C     Purpose.
C     --------
C
C     Check parameters for Section 2 of GRIB code against
C     valid values for GRIB Edition 1.
C
C**   Interface.
C     ----------
C
C     CALL GRCHK2 (KSEC1,KSEC2,PSEC2,KRET)
C
C
C     Input Parameters.
C     -----------------
C
C     KSEC1      - Array containing integer parameters for
C                  section 1 of GRIB code.
C
C     KSEC2      - Array containing integer parameters for
C                  section 2 of GRIB code.
C
C     PSEC2      - Array containing real parameters for
C                  section 2 of GRIB code.
C
C     Output Parameters.
C     ------------------
C
C     KRET       - Return code.
C                  0   , No error encountered.
C                  1   , Error in GRIB Code parameter.
C
C     Method.
C     -------
C
C     Values checked against current code/flag tables
C     and against maximum or minimum permitted values.
C     They are also checked against the current status
C     of the implementation of GRIBEX and ECMWF usage.
C
C     Externals.
C     ----------
C
C     None.
C
C     Reference.
C     ----------
C
C     WMO Manual on Codes for GRIB Code.
C
C     Comments.
C     ---------
C
C     None.
C
C     Author.
C     -------
C
C     J. Hennessy      ECMWF      18.06.91
C
C     Modifications.
C     --------------
C
C     J. Hennessy      ECMWF      30.08.91
C     Polar stereographic representation type allowed.
C
C     J. Hennessy      ECMWF      01.10.91
C     Space view or orthographic representation allowed.
C     Additional parameters KSEC1 and PSEC2 added.
C
C     J.D.Chambers     ECMWF      27.04.94
C     Allow complex packing for spherical harmonics
C
C     J.D.Chambers     ECMWF      03.04.95
C     Allow Lambert conformal.
C
C     J.D.Chambers     ECMWF      July 2004
C     Allow Mercator
C
C----<
C     ----------------------------------------------------------------
C     Section 0 . Definition of variables. Data statements.
C     ----------------------------------------------------------------
C
      IMPLICIT NONE
C
#include "common/grprs.h"
C
C     Parameters
C
      INTEGER JP6, JP6X, JP8
      PARAMETER (JP6=23)
      PARAMETER (JP6X=17)
      PARAMETER (JP8=8)
C
C     Subroutine arguments
C
      INTEGER KSEC1, KSEC2, KRET
      DIMENSION KSEC1(*)
      DIMENSION KSEC2(*)
      REAL PSEC2
      DIMENSION PSEC2(*)
C
C     Local variables
C
      LOGICAL LQUASI
      INTEGER LOOP
C
      INTEGER ITAB6, ITAB6X, ITAB8
      DIMENSION ITAB6(JP6)
      DIMENSION ITAB6X(JP6X)
      DIMENSION ITAB8(JP8)
C
C     Valid values given in Code Table 6.
C
      DATA ITAB6 /  0,  1,  2,  3,  4,  5,  6,  7,  8,  9,
     X             10, 13, 14,
     X             20, 24, 30, 34, 50, 60, 70, 80, 90,
     X            192 /
C
C     Code Table 6 values currently supported by GRIBEX.
C
      DATA ITAB6X /0,1,3,4,5,10,14,20,24,30,34,50,60,70,80,90,192/
C
C     Valid values given in Code Table 8.
C
      DATA ITAB8 /0,128,64,192,32,160,96,224/
C
C     ----------------------------------------------------------------
C     Section 1 . Set initial values.
C     ----------------------------------------------------------------
C
  100 CONTINUE
C
C     Reset return code.
      KRET = 0
C
C     ----------------------------------------------------------------
C     Section 2 . Check values against code tables and extreme values.
C     ----------------------------------------------------------------
C
  200 CONTINUE
C
C     Number of vertical coordinate parameters.
C
      IF (KSEC2(12).LT.0.OR.KSEC2(12).GT.255) THEN
        KRET = 1
        WRITE(GRPRSM,9019) KSEC2(12)
      ENDIF
C
C     Check Data Representation Type.
C
      DO LOOP = 1,JP6
        IF (KSEC2(1).EQ.ITAB6(LOOP)) GO TO 202
      ENDDO
C
      KRET = 1
      WRITE(GRPRSM,9001) KSEC2(1)
C
  202 CONTINUE
C
C     Check Data Representation Type currently supported.
C
      DO LOOP = 1,JP6X
        IF (KSEC2(1).EQ.ITAB6X(LOOP)) GO TO 204
      ENDDO
C
      KRET = 1
      WRITE(GRPRSM,9002) KSEC2(1)
      GO TO 900
C
  204 CONTINUE
C
C     Earth flag.
C
      IF (KSEC2(18).NE.0.AND.KSEC2(18).NE.64) THEN
        KRET = 1
        WRITE(GRPRSM,9005) KSEC2(18)
      ENDIF
C
C     Check ECMWF usage.(0 except for space view perspective)
C
      IF (KSEC2(18).NE.0.AND.KSEC1(2).EQ.98.AND.KSEC2(1).NE.90) THEN
        KRET = 1
        WRITE(GRPRSM,9007)
      ENDIF
C
C     Components flag.
C
      IF (KSEC2(19).NE.0.AND.KSEC2(19).NE.8) THEN
        KRET = 1
        WRITE(GRPRSM,9006) KSEC2(19)
      ENDIF
C
C     Check ECMWF usage.
C
      IF(KSEC2(19).NE.0.AND.KSEC2(19).NE.8.AND.KSEC1(2).EQ.98) THEN
        KRET = 1
        WRITE(GRPRSM,9008)
      ENDIF
C
      LQUASI = (KSEC2(17) .EQ. 1)
C
C     ----------------------------------------------------------------
C     Section 3. Checks on latitude/longitude grids.
C     ----------------------------------------------------------------
C
  300 CONTINUE
C
      IF ( KSEC2(1).EQ.0  .OR. KSEC2(1).EQ.10 .OR.
     X     KSEC2(1).EQ.20 .OR. KSEC2(1).EQ.30 ) THEN
C
C       Number of points along a parallel.
C
        IF ( KSEC2(2).LT.1. OR. KSEC2(2).GT.65535 ) THEN
          IF ( .NOT. LQUASI ) THEN
            KRET = 1
            WRITE(GRPRSM,9022) KSEC2(2)
          ENDIF
        ENDIF
C
C       Number of points along a meridian.
C
        IF ( KSEC2(3).LT.1 .OR. KSEC2(3).GT.65535 ) THEN
          IF ( .NOT. LQUASI ) THEN
            KRET = 1
            WRITE(GRPRSM,9023) KSEC2(3)
          ENDIF
        ENDIF
C
C       Latitude of first grid point.
C
        IF (KSEC2(4).LT.-90000.OR.KSEC2(4).GT.90000) THEN
          KRET = 1
          WRITE(GRPRSM,9015) KSEC2(4)
        ENDIF
C
C       Longitude of first grid point.
C
        IF (KSEC2(5).LT.-360000.OR.KSEC2(5).GT.360000) THEN
          KRET = 1
          WRITE(GRPRSM,9016) KSEC2(5)
        ENDIF
C
C       Resolution flag.
C
        IF (KSEC2(6).NE.0.AND.KSEC2(6).NE.128) THEN
          KRET = 1
          WRITE(GRPRSM,9003) KSEC2(6)
        ENDIF
C
C       Latitude of last grid point.
C
        IF (KSEC2(7).LT.-90000.OR.KSEC2(7).GT.90000) THEN
          KRET = 1
          WRITE(GRPRSM,9020) KSEC2(7)
        ENDIF
C
C       Longitude of last grid point.
C
        IF (KSEC2(8).LT.-360000.OR.KSEC2(8).GT.360000) THEN
          KRET = 1
          WRITE(GRPRSM,9021) KSEC2(8)
        ENDIF
C
C       Direction increments, if included.
C
        IF (KSEC2(6).EQ.128) THEN
          IF (KSEC2(9).LT.1.OR.KSEC2(9).GT.65535) THEN
            IF( .NOT. LQUASI ) THEN
              KRET = 1
              WRITE(GRPRSM,9024) KSEC2(9)
            ENDIF
          ENDIF
C
          IF (KSEC2(10).LT.1.OR.KSEC2(10).GT.65535) THEN
            IF( .NOT. LQUASI ) THEN
              KRET = 1
              WRITE(GRPRSM,9025) KSEC2(10)
            ENDIF
          ENDIF
        ENDIF
C
C       Scanning mode flag.
C
        DO LOOP = 1, JP8
          IF (KSEC2(11).EQ.ITAB8(LOOP)) GO TO 302
        ENDDO
C
        KRET = 1
        WRITE(GRPRSM,9004) KSEC2(11)
C
  302   CONTINUE
C
C       Regular / Quasi-regular grid check.
C
        IF (KSEC2(17).NE.0.AND.KSEC2(17).NE.1) THEN
          KRET = 1
          WRITE(GRPRSM,9009) KSEC2(17)
        ENDIF
C
        GO TO 900
      ENDIF
C
C     ----------------------------------------------------------------
C     Section 4. Checks on Gaussian grids.
C     ----------------------------------------------------------------
C
  400 CONTINUE
C
      IF ( KSEC2(1).EQ.4  .OR. KSEC2(1).EQ.14 .OR.
     X     KSEC2(1).EQ.24 .OR. KSEC2(1).EQ.34) THEN
C
C       Latitude of first grid point.
C
        IF (KSEC2(4).LT.-90000.OR.KSEC2(4).GT.90000) THEN
          KRET = 1
          WRITE(GRPRSM,9015) KSEC2(4)
        ENDIF
C
C       Longitude of first grid point.
C
        IF (KSEC2(5).LT.-360000.OR.KSEC2(5).GT.360000) THEN
          KRET = 1
          WRITE(GRPRSM,9016) KSEC2(5)
        ENDIF
C
C       Latitude of last grid point.
C
        IF (KSEC2(7).LT.-90000.OR.KSEC2(7).GT.90000) THEN
          KRET = 1
          WRITE(GRPRSM,9020) KSEC2(7)
        ENDIF
C
C       Longitude of last grid point.
C
        IF (KSEC2(8).LT.-360000.OR.KSEC2(8).GT.360000) THEN
          KRET = 1
          WRITE(GRPRSM,9021) KSEC2(8)
        ENDIF
C
C       i-direction increment, if included.
C
        IF (KSEC2(6).EQ.128) THEN
          IF (KSEC2(9).LT.1.OR.KSEC2(9).GT.65535) THEN
            KRET = 1
            WRITE(GRPRSM,9024) KSEC2(9)
          ENDIF
        ENDIF
C
C       Number of parallels beween pole and equator.
C
        IF (KSEC2(10).LT.1.OR.KSEC2(10).GT.65535) THEN
          KRET = 1
          WRITE(GRPRSM,9026) KSEC2(10)
        ENDIF
C
C       Increment flag.
C
        IF (KSEC2(6).NE.0.AND.KSEC2(6).NE.128) THEN
          KRET = 1
          WRITE(GRPRSM,9003) KSEC2(6)
        ENDIF
C
C       Scanning mode flag.
C
        DO LOOP = 1, JP8
          IF (KSEC2(11).EQ.ITAB8(LOOP)) GO TO 402
        ENDDO
C
        KRET = 1
        WRITE(GRPRSM,9004) KSEC2(11)
C
  402   CONTINUE
C
C       Regular / Quasi-regular grid check.
C
        IF (KSEC2(17).NE.0.AND.KSEC2(17).NE.1) THEN
          KRET = 1
          WRITE(GRPRSM,9009) KSEC2(17)
        ENDIF
C
C       Cross-check increments flag and quasi-regular indicator.
C
        IF ( LQUASI .AND.KSEC2(6).EQ.128) THEN
          KRET = 1
          WRITE(GRPRSM,9011)
        ENDIF
C
        GO TO 900
      ENDIF
C
C     ----------------------------------------------------------------
C     Section 5. Checks on Polar Stereographic data.
C
C     ----------------------------------------------------------------
C
  500 CONTINUE
C
      IF (KSEC2(1).EQ.5) THEN
C
C       Number of points along X-axis.
C
        IF (KSEC2(2).LT.1.OR.KSEC2(2).GT.65535) THEN
          KRET = 1
          WRITE(GRPRSM,9027) KSEC2(2)
        ENDIF
C
C       Number of points along Y-axis.
C
        IF (KSEC2(3).LT.1.OR.KSEC2(3).GT.65535) THEN
          KRET = 1
          WRITE(GRPRSM,9028) KSEC2(3)
        ENDIF
C
C       Latitude of first grid point.
C
        IF (KSEC2(4).LT.-90000.OR.KSEC2(4).GT.90000) THEN
          KRET = 1
          WRITE(GRPRSM,9015) KSEC2(4)
        ENDIF
C
C       Longitude of first grid point.
C
        IF (KSEC2(5).LT.-360000.OR.KSEC2(5).GT.360000) THEN
          KRET = 1
          WRITE(GRPRSM,9016) KSEC2(5)
        ENDIF
C
C       Orientation of the grid.
C
        IF (KSEC2(7).LT.-360000.OR.KSEC2(7).GT.360000) THEN
          KRET = 1
          WRITE(GRPRSM,9017) KSEC2(7)
        ENDIF
C
C       Grid lengths.
C
        IF (KSEC2(9).LT.1.OR.KSEC2(9).GT.16777215) THEN
          KRET = 1
          WRITE(GRPRSM,9029) KSEC2(9)
        ENDIF
C
        IF (KSEC2(10).LT.1.OR.KSEC2(10).GT.16777215) THEN
          KRET = 1
          WRITE(GRPRSM,9030) KSEC2(10)
        ENDIF
C
C       Projection centre.
C
C       The use of 1 by the Polar Stereographic projection in this
C       octet is inconsistent with Lambert conformal et al
C       representation where bit 1 is set 1 to indicate North pole.
C
        IF (KSEC2(13).NE.0.AND.KSEC2(13).NE.1) THEN
          KRET = 1
          WRITE(GRPRSM,9018) KSEC2(13)
        ENDIF
C
        GO TO 900
      ENDIF
C
C     ----------------------------------------------------------------
C     Section 6. Checks on spherical harmonic data.
C     ----------------------------------------------------------------
C
  600 CONTINUE
C
      IF ( KSEC2(1).EQ.50 .OR. KSEC2(1).EQ.60 .OR.
     X     KSEC2(1).EQ.70 .OR. KSEC2(1).EQ.80 ) THEN
C
C       Spectral data representation type.
C
        IF (KSEC2(5).NE.1) THEN
          KRET = 1
          WRITE(GRPRSM,9012) KSEC2(5)
        ENDIF
C
C       Spectral data representation mode.
C
        IF (KSEC2(6).NE.1.AND.KSEC2(6).NE.2) THEN
          KRET = 1
          WRITE(GRPRSM,9013) KSEC2(6)
        ENDIF
C
        GO TO 900
      ENDIF
C
C     ----------------------------------------------------------------
C     Section 7 . Checks on space view perspective.
C     ----------------------------------------------------------------
C
  700 CONTINUE
C
      IF (KSEC2(1).EQ.90) THEN
        GO TO 900
      ENDIF
C
C     ----------------------------------------------------------------
C     Section 8. Checks on Lambert conformal data.
C     ----------------------------------------------------------------
C
  800 CONTINUE
C
      IF (KSEC2(1).EQ.3) THEN
C
C       Number of points along X-axis.
C
        IF (KSEC2(2).LT.1.OR.KSEC2(2).GT.65535) THEN
          KRET = 1
          WRITE(GRPRSM,9027) KSEC2(2)
        ENDIF
C
C       Number of points along Y-axis.
C
        IF (KSEC2(3).LT.1.OR.KSEC2(3).GT.65535) THEN
          KRET = 1
          WRITE(GRPRSM,9028) KSEC2(3)
        ENDIF
C
C       Latitude of first grid point.
C
        IF (KSEC2(4).LT.-90000.OR.KSEC2(4).GT.90000) THEN
          KRET = 1
          WRITE(GRPRSM,9015) KSEC2(4)
        ENDIF
C
C
C       Longitude of first grid point.
C
        IF (KSEC2(5).LT.-360000.OR.KSEC2(5).GT.360000) THEN
          KRET = 1
          WRITE(GRPRSM,9016) KSEC2(5)
        ENDIF
C
C       Orientation of the grid.
C
        IF (KSEC2(7).LT.-360000.OR.KSEC2(7).GT.360000) THEN
          KRET = 1
          WRITE(GRPRSM,9017) KSEC2(7)
        ENDIF
C
C       Grid lengths.
C
        IF (KSEC2(9).LT.1.OR.KSEC2(9).GT.16777215) THEN
          KRET = 1
          WRITE(GRPRSM,9029) KSEC2(9)
        ENDIF
C
        IF (KSEC2(10).LT.1.OR.KSEC2(10).GT.16777215) THEN
          KRET = 1
          WRITE(GRPRSM,9030) KSEC2(10)
        ENDIF
C
C       Projection centre.
C
        IF (KSEC2(13).NE.0.AND.KSEC2(13).NE.64.AND.KSEC2(13).NE.
     X       128.AND.KSEC2(13).NE.192) THEN
          KRET = 1
          WRITE(GRPRSM,9018) KSEC2(13)
        ENDIF
C
C       Latitude Latin 1.
C
        IF (KSEC2(14).LT.-90000.OR.KSEC2(14).GT.90000) THEN
          KRET = 1
          WRITE(GRPRSM,9015) KSEC2(14)
        ENDIF
C
C       Latitude Latin 2.
C
        IF (KSEC2(15).LT.-90000.OR.KSEC2(15).GT.90000) THEN
          KRET = 1
          WRITE(GRPRSM,9015) KSEC2(15)
        ENDIF
C
C       Latitude of southern pole.
C
        IF (KSEC2(20).LT.-90000.OR.KSEC2(20).GT.90000) THEN
          KRET = 1
          WRITE(GRPRSM,9015) KSEC2(20)
        ENDIF
C
C       Longitude of southern pole.
C
        IF (KSEC2(21).LT.-360000.OR.KSEC2(21).GT.360000) THEN
          KRET = 1
          WRITE(GRPRSM,9016) KSEC2(21)
        ENDIF
C
        GO TO 900
      ENDIF
C
C     ----------------------------------------------------------------
C     Section 9 . Return to calling routine. Format statements.
C     ----------------------------------------------------------------
C
  900 CONTINUE
C
 9001 FORMAT (1H ,'GRCHK2 : Invalid data representation type - ',I3)
 9002 FORMAT (1H ,'GRCHK2 : Unsupported data representation type - ',I3)
 9003 FORMAT (1H ,'GRCHK2 : Invalid increments flag - ',I3)
 9004 FORMAT (1H ,'GRCHK2 : Invalid scanning mode flag - ',I3)
 9005 FORMAT (1H ,'GRCHK2 : Invalid earth flag - ',I3)
 9006 FORMAT (1H ,'GRCHK2 : Invalid components flag - ',I3)
 9007 FORMAT (1H ,'GRCHK2 : Earth flag - ECMWF usage is 0.')
 9008 FORMAT (1H ,'GRCHK2 : Components flag - ECMWF usage is 0.')
 9009 FORMAT (1H ,'GRCHK2 : Invalid quasi / regular indicator - ',I3)
 9011 FORMAT (1H ,'GRCHK2 : Quasi-regular Gaussian grid cannot have',
     C            ' direction increments included.')
 9012 FORMAT (1H ,'GRCHK2 : Invalid spectral representation type - ',I3)
 9013 FORMAT (1H ,'GRCHK2 : Invalid spectral representation mode - ',I3)
 9014 FORMAT (1H ,'GRCHK2 : Complex spectral representation mode ',
     C            'not catered for.')
 9015 FORMAT (1H ,'GRCHK2 : Invalid latitude of first grid point - ',
     C               I10)
 9016 FORMAT (1H ,'GRCHK2 : Invalid longitude of first grid point - ',
     C               I10)
 9017 FORMAT (1H ,'GRCHK2 : Invalid orientation of the grid - ',
     C               I10)
 9018 FORMAT (1H ,'GRCHK2 : Invalid projection centre flag - ',I3)
 9019 FORMAT (1H ,'GRCHK2 : Invalid number of vertical coordinate ',
     C            'parameters - ',I8)
 9020 FORMAT (1H ,'GRCHK2 : Invalid latitude of last grid point - ',
     C               I10)
 9021 FORMAT (1H ,'GRCHK2 : Invalid longitude of last grid point - ',
     C               I10)
 9022 FORMAT (1H ,'GRCHK2 : Invalid number of points along a parallel',
     C              ' - ', I10)
 9023 FORMAT (1H ,'GRCHK2 : Invalid number of points along a meridian',
     C              ' - ', I10)
 9024 FORMAT (1H ,'GRCHK2 : Invalid i-direction increment - ',I10)
 9025 FORMAT (1H ,'GRCHK2 : Invalid j-direction increment - ',I10)
 9026 FORMAT (1H ,'GRCHK2 : Invalid number of parallels - ',I10)
 9027 FORMAT (1H ,'GRCHK2 : Invalid number of points along X-axis',
     C              ' - ', I10)
 9028 FORMAT (1H ,'GRCHK2 : Invalid number of points along Y-axis',
     C              ' - ', I10)
 9029 FORMAT (1H ,'GRCHK2 : Invalid X-direction grid length - ',I10)
 9030 FORMAT (1H ,'GRCHK2 : Invalid Y-direction grid length - ',I10)
C
      RETURN
C
      END

C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C


      SUBROUTINE CONFP (FVAL,IEXP,IMANT)
C
C
C
C
C
C---->
C********************************************************************
C*
C*    NAME      : CONFP
C*
C*    FUNCTION  : CONVERT FLOATING POINT NUMBER FROM MACHINE
C*                REPRESENTATION TO GRIB REPRESENTATION.
C*
C*    INPUT     : FVAL  - FLOATING POINT NUMBER TO BE CONVERTED.
C*
C*    OUTPUT    : IEXP  - 8 BIT SIGNED EXPONENT
C*                IMANT - 24 BIT MANTISSA
C*                FVAL  - UNCHANGED.
C*
C*    JOHN HENNESSY , ECMWF , 15TH APRIL 1985
C*
C********************************************************************
C----<
C
C
      IF (FVAL.EQ.0.0)
     C   THEN
             IEXP = 128
             IMANT = 0
             RETURN
         ENDIF
C
C
      EPS = 1.0E-12
      REF = FVAL
C
C     SIGN OF VALUE
C
      ISIGN = 0
      IF (REF.LE.0.)
     C   THEN
             ISIGN = 128
             REF = - REF
         ENDIF
C
C
C
C
C
C     EXPONENT
C
      IF (REF.EQ.0.0)
     C   THEN
            IEXP = 0
         ELSE
            IEXP = INT(ALOG(REF)*(1.0/ALOG(16.0))+64.0+1.0+EPS)
         ENDIF
C
      IF (IEXP.LT.0  ) IEXP = 0
      IF (IEXP.GT.127) IEXP = 127
C
C
C
C
C
C
C
C
C
C
C     MANTISSA
C
      IMANT = NINT (REF/16.0**(IEXP-70))
C
C     ADD SIGN BIT TO EXPONENT.
C
      IEXP = IEXP + ISIGN
C
C
C
C
      RETURN
C
      END

       PROGRAM MAKESTATION
C
C**** *MAKESTATION*
C
C
C     PURPOSE.
C     --------
c
C         Extract data from Empress WMO VOL A DB
c         to create binary station list for preprocessing.
c
C**   INTERFACE.
C     ----------
C
C         none.
C
C     METHOD.
C     -------
C
C          NONE.
C
C
C     EXTERNALS.
C     ----------
C
C
C     REFERENCE.
C     ----------
C
C          NONE.
C
C     AUTHOR.
C     -------
C
C          M. DRAGOSAVAC    *ECMWF*       15/01/2009
C
C
C     MODIFICATIONS.
C     --------------
C
C          NONE.
C
C
c     ------------------------------------------------------------------
c           1. Initialize Empress Data Base.
c              -----------------------------
 100  continue
c
c
c*          2. Select data for analysis.
c              -------------------------
 200  continue
c
      call station
c
c*          3. Clean up.
c              ---------
 300  continue
c
c
c     stop
      end
      SUBROUTINE STATION
C
C
C**** *STATION*
C
C
C     PURPOSE.
C     --------
c
C         CREATE PACKED FORM OF WMO STATION LIST
C         FOR PREPROCESSING. 
c
C**   INTERFACE.
C     ----------
C
C         none.
C
C     METHOD.
C     -------
C
C          NONE.
C
C
C     EXTERNALS.
C     ----------
C
C          *Empress data base routines*
C
C     REFERENCE.
C     ----------
C
C          NONE.
C
C     AUTHOR.
C     -------
C
C          M. DRAGOSAVAC    *ECMWF*       03/02/2009
C
C
C     MODIFICATIONS.
C     --------------
C
C          NONE.
C
C
      IMPLICIT LOGICAL(L,O,G), CHARACTER*8(C,H,Y)
C
c
      character*2 csp00,csp03,csp06,csp09,csp12,csp15
      character*2 csp18,csp21
      character*1 cuat00,cuat06,cuat12,cuat18

      character*32 cstation
c
      character*120 cline
c
c
c
C     ------------------------------------------------------------------
c
c           1.2.1 Open wmo station list
c                 ---------------------
      open(unit=28,file='wmo.txt',iostat=ios,
     1             form='formatted',
     2             recl=120,status='old')
      if(ios .ne.0) then
         print*,'Error opening wmo.txt file.'
         call exit(2)
      end if

      open(unit=29,file='synop2bufr_station.txt',iostat=ios,
     1             form='formatted',
     2             recl=130,status='unknown')
      if(ios .ne.0) then
         print*,'Error opening wmo.txt file.'
         call exit(2)
      end if

      icount=0
c
 200  continue
c
c
c     read(28,'(a)') cline
c
c*            2.2 Read data
c                 --------------
 220  continue
c
      isthp=0
      istha=0
      read(28,fmt=8888,iostat=ios,end=300) irgcoun, iblock,
     1                                     istno, rlat, rlon,
     2                                     isthp, istha ,ipcode,
     3                                     csp00,csp03,csp06,
     4                                     csp09,csp12,csp15,
     5                                     csp18,csp21,
     6                                     cuat00,cuat06,cuat12,
     7                                     cuat18,cstation
      if(ios.ne.0) then
         print*,'Read error on wmo.txt file'
         call exit(2)
      end if

      icount=icount+1
c
 8888 format(i4,1x,i2,1x,i3,1x,f7.2,1x,f7.2,1x,i4,1x,i4,1x,i1,
     1       1x,8(a2,1x),4(a,1x),a)
      rt=99.9
      rvis=99.9
      rprec=99.9
      rvinds=99.9
      write(29,fmt=8889,iostat=ios) irgcoun, iblock,
     1                                     istno, rlat, rlon,
     2                                     isthp, istha ,ipcode,
     3                                     csp00,csp03,csp06,
     4                                     csp09,csp12,csp15,
     5                                     csp18,csp21,
     6                                     cuat00,cuat06,cuat12,
     7                                     cuat18,cstation,rt,rvis,
     8                                     rprec,rvinds
c
 8889 format(i4,1x,i2.2,i3.3,1x,f7.2,1x,f7.2,1x,i4,1x,i4,1x,i1,
     1       1x,8(a2,1x),4(a,1x),a,1x,F4.1,3(3x,F4.1))

      go to 220
c
c
c*          3. Clean table request.
c              --------------------
 300  continue
c
c
      print*,'Number of stations retreived ',icount
c
c
c     -------------------------------------------------------------------
c
      END

C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE JOPNLLF( IALEG, PINTVL, KTRUNC, KUNIT, PBUILD, KRET)
C
C---->
C**** JOPNLLF
C
C     Purpose
C     _______
C
C     This routine finds a file of legendre polynomials corresponding
C     to a given grid interval and truncation, allocates memory, reads
C     the coefficients into the memory and returns a unit number.
C
C     Interface
C     _________
C
C     CALL JOPNLLF( IALEG, PINTVL, KTRUNC, KUNIT, PBUILD, KRET)
C
C     Input parameters
C     ________________
C
C     PINTVL  - Grid interval in degrees
C     KTRUNC  - Spherical truncation
C
C     Output parameters
C     _________________
C
C     IALEG   - Pointer for memory array for legendre coefficients
C     KUNIT   - Unit number from PBOPEN
C               0 , open failed
C     PBUILD  - Grid interval used to build the legendre 
C               coefficients file (degrees)
C     KRET    - Return status code
C               0 = OK
C
C     Common block usage
C     __________________
C
C     Uses common JDCSPGP for size NISIZE6
C
C     Method
C     ______
C
C     Builds a file name from the truncation and grid interval and
C     tries to open a file of that name.
C
C     If the file is already open (from a previous call), the
C     previous unit number is returned.
C     If a different file is already open (from a previous call), the
C     the existing file is closed.
C
C     If no file can be located, a file is created. Memory is dynamically
C     allocted and the coefficients are read into the memory array.
C
C     Externals
C     _________
C
C     PBOPEN3  - Open binary file and return unit number
C     PBREAD3  - Read binary file
C     PBCLOSE3 - Close binary file
C     JFINDIR  - Find the file of legendre coefficients
C     JMAKLL   - Makes a file of legendre coefficients
C     INTLOG   - Output log message
C     JCHMOD   - Change file permissions
C     RENAME   - Rename file
C
C     Reference
C     _________
C
C     NONE
C
C     Comments
C     ________
C
C     The Legendre polynomials for the transforms may be held in
C     a ready-made file whose name is held in an environment variable:
C         cf_txxxx_raabbbbb       Txxxx   aa.bbbbb degrees
C     For example,
C         cf_t0213_r0050000       T213    0.5 degrees
C         cf_t0106_r0250000       T106    2.5 degrees
C
C     On the C90, the file of polynomials may be cached in /owrk/marsint
C
C     Otherwise the file is located in (or will be created in) the first
C     directory given by one of the following (in the order listed, if
C     they exist):
C         environment variable PPDIR
C     or
C         the current working directory.
C
C     Author
C     ______
C
C     J.D.Chambers      *ECMWF*      Jun 1996
C
C     Modifications
C     _____________
C
C     J.D.Chambers     ECMWF        Feb 1997
C     Allow for 64-bit pointers
C
C----<
C     _______________________________________________________
C
      IMPLICIT NONE
C
#include "parim.h"
#include "jparams.h"
#include "jparam2.h"
C
C     Parameters
C
      INTEGER JPROUTINE
      PARAMETER ( JPROUTINE = 30910 )
C
C     Subroutine arguments
C
      REAL      PINTVL, PBUILD
      INTEGER   KTRUNC, KUNIT, KRET
C
C     Local variables
C
      INTEGER IRET, IOFFSET, ISIZE, NPBYTES
      INTEGER*8 IRET1, ITEMP
      CHARACTER*12 YFLAG
#ifdef REAL_8
      DATA NPBYTES/8/
#else
      DATA NPBYTES/4/
#endif
      LOGICAL LFOUND
      CHARACTER*256 DIRNAME
      CHARACTER*256 FILENAME, FILEDUM
      CHARACTER*512 FULLPATH
      CHARACTER*20 YPFN
#ifdef REAL_8
      DATA YPFN/'CF_Txxxx_Raabbbbb'/
#else
      DATA YPFN/'cf_txxxx_raabbbbb'/
#endif
      INTEGER NUNIT
      DATA NUNIT/0/
#ifndef _CRAYFTN
#ifdef POINTER_64
      INTEGER*8 IALEG
#endif
#endif
      REAL ALEG
      DIMENSION ALEG(1)
      POINTER ( IALEG, ALEG )
C
      SAVE NUNIT
C
C     Externals
C
      LOGICAL JFINDIR
      LOGICAL JFINDFN3
      INTEGER JCHMOD, RENAME
C
C     _______________________________________________________
C
C*    Section 1. See if required file already in use.
C     _______________________________________________________
C
  100 CONTINUE
C
C     Setup the filename: cf_txxxx_raabbbbb
C
      WRITE(YPFN(5:8),'(I4.4)') KTRUNC
      WRITE(YPFN(11:17),'(I7.7)') NINT(PINTVL*JPMULT)
      CALL INTLOG(JP_DEBUG,
     X  'JOPNLLF: Coefficients file to open is:', JPQUIET)
      CALL INTLOG(JP_DEBUG, YPFN, JPQUIET)
      PBUILD = PINTVL
C
C     If file already open, return the existing unit number
C
      IF( YPFN.EQ.YOLDLL ) THEN
        CALL INTLOG(JP_DEBUG,'JOPNLLF: File already open.',JPQUIET)
        KUNIT = NUNIT
        GOTO 900
      ENDIF
C
C     Otherwise, ensure existing unit is closed
C
      IF( NUNIT.NE.0 ) THEN
        CALL PBCLOSE3(NUNIT, IRET)
        IF( IRET.NE.0 ) THEN
          CALL INTLOG(JP_ERROR,'JOPNLLF: PBCLOSE3 error',IRET)
          KRET = JPROUTINE + 1
          GOTO 990
        ENDIF
        NUNIT = 0
      ENDIF
C     _______________________________________________________
C
C*    Section 2. See if the file has already been created.
C     _______________________________________________________
C
  200 CONTINUE
C
C     Set appropriate build inteval 
C
      WRITE(YPFN(11:17),'(I7.7)') NINT(PBUILD*JPMULT)
C
      IOFFSET = INDEX(YPFN,' ') - 1
      FILENAME = YPFN(1:IOFFSET)
C
      LFOUND = JFINDIR('PPDIR', DIRNAME)
      IF( LFOUND ) THEN
        LFOUND = JFINDFN3(DIRNAME,FILENAME,IOFFSET,NUNIT)
        IF( LFOUND ) GOTO 500
      ENDIF
C
C     Try present working directory
C
      IOFFSET = INDEX(YPFN, ' ') - 1
      FILENAME = YPFN(1:IOFFSET)
      CALL PBOPEN3( NUNIT, FILENAME(1:IOFFSET), 'r', IRET)
      IF( IRET.EQ.0 ) GOTO 500
C     _______________________________________________________
C
C*    Section 3. File doesn't exist, find a suitable directory for it.
C     _______________________________________________________
C
  300 CONTINUE
C
      LFOUND = JFINDIR('PPDIR', DIRNAME)
      IF ( LFOUND ) THEN
        IOFFSET = INDEX(DIRNAME, ' ') - 1
        FULLPATH = DIRNAME(1:IOFFSET) // '/' // FILENAME
        IOFFSET = INDEX(FULLPATH, ' ') - 1
        FILENAME(1:IOFFSET) = FULLPATH(1:IOFFSET)
        FILEDUM(1:IOFFSET) = FILENAME(1:IOFFSET)
#ifdef REAL_8
        FILEDUM(IOFFSET-16:IOFFSET-15) = 'XX'
#else
        FILEDUM(IOFFSET-16:IOFFSET-15) = 'xx'
#endif
        CALL PBOPEN3(NUNIT, FILEDUM(1:IOFFSET), 'w', IRET)
        IF( IRET.EQ.0 ) GOTO 400
      ENDIF
C
C     Try present working directory
C
      IOFFSET = INDEX(YPFN,' ') - 1
      FILENAME = YPFN(1:IOFFSET)
      FILEDUM(1:IOFFSET) = FILENAME(1:IOFFSET)
#ifdef REAL_8
      FILEDUM(IOFFSET-16:IOFFSET-15) = 'XX'
#else
      FILEDUM(IOFFSET-16:IOFFSET-15) = 'xx'
#endif
      CALL PBOPEN3(NUNIT, FILEDUM(1:IOFFSET), 'w', IRET)
      IF( IRET.NE.0 ) THEN
        CALL INTLOG(JP_FATAL,'JOPNLLF: PBOPEN3 error.',IRET)
        KRET = JPROUTINE + 2
        GOTO 990
      ENDIF
C     _______________________________________________________
C
C*    Section 4. Create the coefficients file.
C     _______________________________________________________
C
  400 CONTINUE
C
C     Let user know that a new file is being created.
C
      IOFFSET = INDEX(FILENAME, ' ') - 1
      CALL INTLOG(JP_DEBUG,'JOPNLLF: Creating new coefficients file:',
     X            JPQUIET)
      CALL INTLOG(JP_DEBUG,FILENAME(1:IOFFSET), JPQUIET)
C
C     Change access mode to 'read only' for all users.
C
      IRET = JCHMOD(FILEDUM(1:IOFFSET),'0444')
      IF( IRET.NE.0 ) THEN
        CALL INTLOG(JP_FATAL,'JOPNLLF: JCHMOD error.',IRET)
        KRET = JPROUTINE + 3
        GOTO 990
      ENDIF
C
C     Allocate memory for the array used in making the file
C
      ISIZE = (KTRUNC+1)*(KTRUNC+4)*(NINT(90.0/PBUILD)+1)/2
      IF( ISIZE.GT.NISIZE6 ) THEN
        CALL JMEMHAN( 6, IALEG, ISIZE, 1, KRET)
        IF( KRET.NE.0 ) THEN
          CALL INTLOG(JP_FATAL,'JOPNLLF: memory allocation error',IALEG)
          KRET = JPROUTINE + 3
          GOTO 990
        ENDIF
        NISIZE6 = ISIZE
      ENDIF
C
C     Make coefficients file
C
      CALL JMAKLL3( NUNIT, KTRUNC, PBUILD, 0.0, ALEG, KRET)
      IF ( KRET .NE. 0 ) GOTO 990
C
C     De-allocate memory for the array used in making the file
C
      CALL JMEMHAN( 6, IALEG, ISIZE, 0, KRET)
      IF( KRET.NE.0 ) THEN
        CALL INTLOG(JP_FATAL,'JOPNLLF: memory dealloc error',IALEG)
        KRET = JPROUTINE + 4
        GOTO 990
      ENDIF
      NISIZE6 = 0
C
C     Close rename it, re-open for reading, leave it open.
C
      CALL PBCLOSE3( NUNIT, IRET)
      IF( IRET.NE.0 ) THEN
        CALL INTLOG(JP_FATAL,'JOPNLLF: PBCLOSE3 error.',IRET)
        KRET = JPROUTINE + 5
        GOTO 990
      ENDIF
      NUNIT=0
C
      IRET = RENAME(FILEDUM(1:IOFFSET),FILENAME(1:IOFFSET))
      IF( IRET.NE.0 ) THEN
        CALL INTLOG(JP_FATAL,'JOPNLLF: RENAME of file failed',JPQUIET)
        KRET = JPROUTINE + 5
        GOTO 990
      ENDIF
C
      CALL PBOPEN3( NUNIT, FILENAME(1:IOFFSET), 'r', IRET)
      IF( IRET.NE.0 ) THEN
        CALL INTLOG(JP_FATAL,'JOPNLLF: PBOPEN3 error.',IRET)
        KRET = JPROUTINE + 6
        GOTO 990
      ENDIF
C     _______________________________________________________
C
C*    Section 5. File now open with read access.
C     _______________________________________________________
C
  500 CONTINUE
C
C     Allocate memory for the file and read it into memory
C
      ISIZE = (KTRUNC+1)*(KTRUNC+4)*(NINT(90.0/PBUILD)+1)/2
      IF( ISIZE.GT.NISIZE6 ) THEN
        CALL JMEMHAN2( 6, IALEG, ISIZE, 1, KRET)
cs        CALL JMEMHAN( 6, IALEG, ISIZE, 1, KRET)
        IF( KRET.NE.0 ) THEN
          CALL INTLOG(JP_FATAL,'JOPNLLF: memory allocation error',IALEG)
          KRET = JPROUTINE + 7
          GOTO 990
        ENDIF
        NISIZE6 = ISIZE
      ENDIF
      ITEMP = ISIZE
      ITEMP = ITEMP*8
C
      CALL GETENV('USE_PBREAD4', YFLAG)
      IF(YFLAG(1:1).EQ.'1') THEN
           CALL PBREAD4(NUNIT, ALEG, ITEMP, IRET1)
      ELSE
           print*,'PBREAD5 ',ITEMP
           CALL PBREAD5(NUNIT, ALEG, ITEMP, IRET1)
      ENDIF
C
      IF( IRET1.NE.ITEMP ) THEN
        CALL INTLOG(JP_FATAL,'JOPNLLF: PBREAD5 error.',IRET1)
        KRET = JPROUTINE + 8
        GOTO 990
      ENDIF
cs      CALL PBREAD3(NUNIT, ALEG, (ISIZE*NPBYTES), IRET)
cs      IF( IRET.NE.(ISIZE*NPBYTES) ) THEN
cs        CALL INTLOG(JP_FATAL,'JOPNLLF: PBREAD3 error.',IRET)
cs        KRET = JPROUTINE + 8
cs        GOTO 990
cs      ENDIF
C
C     The file is no longer required
C
      CALL PBCLOSE3( NUNIT, IRET)
      IF ( IRET .NE. 0 ) THEN
        CALL INTLOG(JP_FATAL,'JOPNLLF: PBCLOSE3 error.',IRET)
        NUNIT = 0
        KRET = JPROUTINE + 9
        GOTO 990
      ENDIF
      NUNIT=0
C
      KUNIT = NUNIT
      YOLDLL  = YPFN
C
C     _______________________________________________________
C
C*    Section 9. Return to calling routine. Format statements
C     _______________________________________________________
C
  900 CONTINUE
C
      KRET = 0
C
 990  CONTINUE
C
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities
C granted to it by virtue of its status as an intergovernmental organisation
C nor does it submit to any jurisdiction.
C

      SUBROUTINE JWSCAL( PZFA, KLATS, KLONS, KFIRST, PLATS)
C
C---->
C**** JWSCAL
C
C     PURPOSE
C     _______
C
C     This routine applies a scale factor to all latitudes except
C     the poles
C
C     INTERFACE
C     _________
C
C     CALL JWSCAL( PZFA, KLATS, KLONS, KFIRST, PLATS)
C
C     Input parameters
C     ________________
C
C     PZFA     - Array of wind field (U or V) fourier coefficients
C     KLATS    - Number of latitude lines in PZFA
C     KLONS    - Number of longitude points in each line of latitude
C     KFIRST   - First latitude to process in PLATS
C     PLATS    - Array of gaussian latitudes (degrees)
C
C     Output parameters
C     ________________
C
C     PZFA     - Modified array of fourier coefficients
C
C     Common block usage
C     __________________
C
C     None.
C
C     Method
C     ______
C
C     Apply latitude-dependent scale factor to all coefficients.
C     It is assumed that no latitude is at the North or South pole.
C
C     Externals
C     _________
C
C     EMOSLIB_SSCAL  - Apply scalar correction to row of values
C
C
C     Reference
C     _________
C
C     None
C
C
C     Comments
C     ________
C
C     PZFA contains pairs of north/south latitudes.
C
C
C     AUTHOR
C     ______
C
C     J.D.Chambers      *ECMWF*      Jan 1994
C
C     MODIFICATIONS
C     _____________
C
C     None.
C
C----<
C     _______________________________________________________
C
C*    Section 0. Definition of variables.
C     _______________________________________________________
C
C*    Prefix conventions for variable names
C
C     Logical      L (but not LP), global or common.
C                  O, dummy argument
C                  G, local variable
C                  LP, parameter.
C     Character    C, global or common.
C                  H, dummy argument
C                  Y (but not YP), local variable
C                  YP, parameter.
C     Integer      M and N, global or common.
C                  K, dummy argument
C                  I, local variable
C                  J (but not JP), loop control
C                  JP, parameter.
C     Real         A to F and Q to X, global or common.
C                  P (but not PP), dummy argument
C                  Z, local variable
C                  PP, parameter.
C
      IMPLICIT NONE
C
#include "jparams.h"
C
C     Subroutine arguments
C
      REAL   PZFA
      DIMENSION PZFA(JPLONO+2, 64)
      INTEGER   KLATS, KLONS, KFIRST
      REAL      PLATS
      DIMENSION PLATS(*)
C
C     Local variables
C
      INTEGER JNEXTLAT, INORTH, ISOUTH
      REAL ZCOSI, ZLAT, ZPIBY2, ZDEGR
C     _______________________________________________________
C
C*    Section 1.    Initialization.
C     _______________________________________________________
C
  100 CONTINUE
      ZPIBY2 = PPI / 2.0
      ZDEGR  = PPI / 180.0
C
C     _______________________________________________________
C
C*    Section 2.    Apply scale factor to all latitudes.
C     _______________________________________________________
C
 200  CONTINUE
      INORTH = -1
      DO 220 JNEXTLAT = 1, KLATS
        ZLAT  = PLATS( KFIRST + JNEXTLAT - 1 )
        INORTH = INORTH + 2
        ISOUTH = INORTH + 1
        ZCOSI = 1.0 / COS( ZLAT * ZDEGR )
        CALL EMOSLIB_SSCAL( KLONS, ZCOSI, PZFA( 2, INORTH), 1)
        CALL EMOSLIB_SSCAL( KLONS, ZCOSI, PZFA( 2, ISOUTH), 1)
 220  CONTINUE
C     _______________________________________________________
C
C*    Section 9. Return to calling routine.
C     _______________________________________________________
C
 900  CONTINUE
C
      RETURN
      END

C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C


      SUBROUTINE UNBKOUT (KUNIT,KARRAY,KINLEN,KOUTLEN,KEOF,KRET)
C
C---->
C**** UNBKOUT - Write a record to a pure binary file.
C
C     Purpose.
C     --------
C
C           Provides standard interface to write unblocked COS
C           files or UNICOS pure binary files.
C
C**   Interface.
C     ----------
C
C           CALL UNBKOUT (KUNIT,KARRAY,KINLEN,KOUTLEN,KEOF,KRET)
C
C           INTEGER    K.
C           REAL       P.
C           LOGICAL    O.
C           CHARACTER  H.
C
C               Input parameters.
C               -----------------
C
C               KUNIT      - Fortran unit number of file to be written.
C                            1 to 99.
C
C               KARRAY     - Array containing record to be written.
C
C               KINLEN     - Length of this array, in words.
C
C               KOUTLEN    - Length of record to be written (in words).
C                            If this is 0 length is assumed to be in
C                            the first word of the record.
C                            This is the case with MARS data in unpacked
C                            format.
C
C               KEOF       - 0, If not last write to this file.
C                            1, Last write to this file, so write
C                               record and flush output buffer.
C                            2, Last record already written, so
C                               flush output buffer.
C
C               KRET       - 0, Routine to abort if error encountered.
C                            1, Return to calling routine even if error.
C
C                            Adding 100 to KRET will add debug printout
C                            eg values of input and output parameters.
C
C                            Valid values for KRET are thus 0, 1, 100
C                            or 101.
C
C               Output parameters.
C               ------------------
C
C               KOUTLEN    - Length of record written, in words.
C
C               KRET       - Return code.
C                            0, No error encountered.
C                            1, Write error.
C                            2, Not used.
C                            3, Not used.
C                            4, Not used.
C                            5, No data transferred because user's array
C                               is smaller than the record length.
C                            6, Maximum number of files opened for write
C                               by user program exceeded.
C                            7, Error detected in parameters.
C
C     Method.
C     -------
C
C           Data is written in 512 word blocks. The length of each
C           record is taken from the first word (or input parameter)
C           and all full blocks are then written. Unless it is the last
C           write to the file, any remaining words are kept to use
C           as the start of the next block to be written.
C
C           An array of Fortran numbers in use is kept, with a
C           corresponding array of pointers to the next part of
C           data to be written to each one. When the last write is
C           made to a file, these entries are reset to 0.
C
C           If an error is encountered, an error message is printed.
C
C     Externals.
C     ----------
C
C           None.
C
C     Reference.
C     ----------
C
C           Cray CFT77 Manual.
C
C     Comments.
C     ---------
C
C           Maximum number of files which can be handled in one
C           program is 20
C
C           Routine contains Sections 0 to 3 and Section 9.
C
C     Author.
C     -------
C
C           J. Hennessy      ECMWF      24:04:90.
C
C     Modifications
C     --------------
C
C           J. Hennessy      ECMWF      31:10:90.
C           Do not write empty last block, when flushing buffer.
C
C           B. Raoult        ECMWF      29:11:90
C           Fix bug in zero-filling of short and last records.
C
C     ----------------------------------------------------------------
C----<
C
C
C
C
C
C
C
C
C
C
C*    Section 0 . Definition of variables.
C     ----------------------------------------------------------------
C
      IMPLICIT LOGICAL     ( L, O, G )
      IMPLICIT CHARACTER*8 ( C, H, Y )
      IMPLICIT INTEGER     ( I, J, K, M, N )
C
      PARAMETER (JPBLOK=512)
      PARAMETER (JPFILS= 20)
C
      DIMENSION KARRAY(KINLEN)
      DIMENSION IOBUFF(JPFILS*JPBLOK)
      DIMENSION ISTART(JPFILS)
      DIMENSION IFTNOS(JPFILS)
C
      DATA ISTART /JPFILS*0/
      DATA IFTNOS /JPFILS*0/
C
      SAVE IOBUFF
      SAVE ISTART
      SAVE IFTNOS
C
C     ----------------------------------------------------------------
C
C
C
C
C
C
C
C
C
C*    Section 1 . Check parameters. Set initial values.
C     ----------------------------------------------------------------
C
 1000 CONTINUE
C
C*    Set print switch, if required.
C
      IF (KRET.GE.100)
     C   THEN
             KPR = 1
         ELSE
             KPR = 0
         ENDIF
C
C*    Print input parameters, if required.
C
      IF (KPR.EQ.1)
     C   THEN
             WRITE (*,*) 'UNBKOUT : Section 1.'
             WRITE (*,*) '         Input values used -'
             WRITE (*,9904) KUNIT
             WRITE (*,9905) KINLEN
             WRITE (*,9907) KOUTLEN
             WRITE (*,9906) KRET
             WRITE (*,9908) KEOF
         ENDIF
C
C*    Check input parameters.
C
      IRET = 0
      IF (KRET.GE.100) KRET = KRET - 100
C
C*    Invalid value given for return code.
C
      IF (KRET.LT.0.OR.KRET.GT.1)
     C   THEN
             IRET = 7
             WRITE (*,9910) KRET
             GO TO 9000
         ENDIF
C
C*    Fortran unit numbers must be between 1 and 99 inclusive.
C
      IF (KUNIT.LT.1.OR.KUNIT.GT.99)
     C   THEN
             IRET = 7
             WRITE (*,9911) KUNIT
             GO TO 9000
         ENDIF
C
C*    Retain last write indicator.
C
      IF (KEOF.LT.0.OR.KEOF.GT.2)
     C   THEN
             IRET = 7
             WRITE (*,9916) KEOF
             GO TO 9000
         ENDIF
C
      IEOF = KEOF
      KEOF = 0
C
C*    Locate Fortran unit number in list of active numbers.
C
      DO 1010 J1010=1,JPFILS
         IF (IFTNOS(J1010).EQ.KUNIT)
     C      THEN
                IB = ISTART(J1010)
                IP = J1010
                GO TO 1030
            ENDIF
 1010 CONTINUE
C
C*    None found, so first time in. Set table entries.
C
      DO 1020 J1020=1,JPFILS
         IF (IFTNOS(J1020).EQ.0)
     C      THEN
                IB = 0
                IP = J1020
                IFTNOS(J1020) = KUNIT
                GO TO 1030
            ENDIF
 1020 CONTINUE
C
C*    No table entry free. Maximum number of files exceeded.
C
      IRET = 6
      WRITE (*,9912) JPFILS
      GO TO 9000
C
C*    Set pointer to array holding last part of data not written.
C
 1030 CONTINUE
C
      IPR = IP
      IP  =  (IP-1) * JPBLOK + 1
C
C     IOBUFF(IP) to IOBUFF(IP+B) are the remaining words after
C     last block written.
C
C*    Flush output buffer only requested.
C
      IF (IEOF.EQ.2) GO TO 3575
C
C     ----------------------------------------------------------------
C
C
C
C
C
C
C
C
C
C*    Section 2 . Get length of next record.
C     ----------------------------------------------------------------
C
 2000 CONTINUE
C
      IF (KPR.EQ.1)
     C   THEN
             WRITE (*,*) 'UNBKOUT : Section 2.'
             WRITE (*,9909) IPR , IP , IB
         ENDIF
C
C     Get length of record.
C
      IF (KOUTLEN.EQ.0)
     C   THEN
             ILENW = KARRAY(1)
         ELSE
             ILENW = KOUTLEN
         ENDIF
C
C     Ensure that user's array is large enough.
C
      IF (KINLEN.LT.ILENW)
     C   THEN
             IRET = 5
             WRITE (*,9917) KINLEN , ILENW
             GO TO 9000
         ENDIF
C
      IF (KPR.EQ.1) WRITE (*,9902) ILENW
C
C     ----------------------------------------------------------------
C
C
C
C
C
C
C
C
C
C*    Section 3 . Write complete blocks.
C     ----------------------------------------------------------------
C
 3000 CONTINUE
C
      IF (KPR.EQ.1) WRITE (*,*) 'UNBKOUT : Section 3.'
C
C     If the record is 1 block or more in length write it to file.
C     Write partial last block into IOBUFF, preceding ones to file.
C
      IF ((IB+ILENW).GE.JPBLOK)
     C   THEN
C
C            Copy enough words from user array to complete first block.
C
             IF (IB.EQ.0) GO TO 3200
             DO 3050 J3050 = 1,JPBLOK - IB
                IOBUFF(IP+J3050+IB-1) = KARRAY(J3050)
 3050        CONTINUE
C
             IC = IB
             IB = JPBLOK - IB
C
C            Write first block.
C
             BUFFER OUT (KUNIT,0) (IOBUFF(IP),IOBUFF(IP+JPBLOK-1))
             IF (UNIT(KUNIT)) 3200,3700,3700
C
 3200        CONTINUE
C
C            Check if length to be written was exactly 1 block.
C
             IF ((ILENW + IC).EQ.JPBLOK)
     C          THEN
                    INTER = 0
                    GO TO 3555
                ENDIF
C
             ILENR = ILENW - IB
             IDIFF = MOD (ILENR,JPBLOK)
             IF (IDIFF.NE.0)
     C          THEN
                    ILENR = ILENR - IDIFF
                ELSE
                    ILENR = ILENR - JPBLOK
                ENDIF
             IE    = IB + ILENR
C
C            For a short record there may not be a full
C            second block.
C
             IF (IE.EQ.IB) GO TO 3400
C
C            If remaining part of record to be written is a multiple
C            of the block size, write complete record.
C
             IF ((ILENW-IE).EQ.JPBLOK) IE = IE + JPBLOK
C
             BUFFER OUT (KUNIT,0) (KARRAY(IB+1),KARRAY(IE))
             IF (UNIT(KUNIT)) 3400,3700,3700
C
C            Put end of field in IOBUFF.
C
 3400        CONTINUE
C
             INTER = ILENW - IE
             DO 3500 J3500=1,INTER
                IOBUFF(IP+J3500-1) = KARRAY(IE+J3500)
 3500        CONTINUE
C
         ELSE
C
C            Add short record to buffer.
C
             DO 3550 J3550 = 1,ILENW
                IOBUFF(IP+J3550+IB-1) = KARRAY(J3550)
 3550        CONTINUE
             INTER = IB + ILENW
C
         ENDIF
C
 3555 CONTINUE
C
      IB      = INTER
      KOUTLEN = ILENW
C
C     Fill unused part of buffer with zeroes.
C
      DO 3560 J3560 = IB+1,JPBLOK
         IOBUFF(J3560+IP-1) = 0
 3560 CONTINUE
C
C     Write last part of last record if end of file.
C     Do not write empty last block, when flushing buffer.
C
 3575 CONTINUE
C
      IF (IEOF.GT.0)
     C   THEN
	     IF (IB.EQ.0) GO TO 3600
             DO 3580 J3580 = IB+1,JPBLOK
                IOBUFF(J3580+IP-1) = 0
 3580        CONTINUE
             BUFFER OUT (KUNIT,0) (IOBUFF(IP),IOBUFF(IP+JPBLOK-1))
             IF (UNIT(KUNIT)) 3600 , 3700 , 3700
         ENDIF
C
 3600 CONTINUE
C
C     Save pointer to start of next write area, unless last write.
C
      IF (IEOF.GT.0)
     C   THEN
             IFTNOS(IPR) = 0
             ISTART(IPR) = 0
         ELSE
             ISTART(IPR) = IB
         ENDIF
C
      GO TO 9000
C
 3700        CONTINUE
C
C*           Write error, go to section 9.
C
             IRET = 1
             WRITE (*,9913) KUNIT
C
C    ----------------------------------------------------------------
C
C
C
C
C
C
C
C
C
C*    Section 9 . Return to calling routine. Format statements.
C     ------------------------------------------------------------------
C
 9000 CONTINUE
C
      IF (KPR.EQ.1)
     C THEN
           WRITE (*,*) 'UNBKOUT : Section 9.'
           WRITE (*,*) '         Output values set -'
           WRITE (*,9907) KOUTLEN
           WRITE (*,9908) KEOF
           WRITE (*,9906) IRET
       ENDIF
C
C
      IF (IRET.NE.0.AND.IRET.NE.2)
     C   THEN
             WRITE (*,9903) IRET
             IF (KRET.EQ.0) CALL ABORT
         ENDIF
C
      KRET = IRET
C
 9902 FORMAT (1H ,'UNBKOUT : Record length (words) = ',I8)
C
 9903 FORMAT (1H ,'UNBKOUT : Return code = ',I6)
C
 9904 FORMAT (1H ,9X,'KUNIT   = ',I6)
C
 9905 FORMAT (1H ,9X,'KINLEN  = ',I6)
C
 9906 FORMAT (1H ,9X,'KRET    = ',I6)
C
 9907 FORMAT (1H ,9X,'KOUTLEN = ',I6)
C
 9908 FORMAT (1H ,9X,'KEOF    = ',I6)
C
 9909 FORMAT (1H ,'IPR = ',I4,'  IP = ',I8,'  IB = ',I8)
C
 9910 FORMAT (1H ,'UNBKOUT : KRET on input is ',I4,
     C         '. Valid values are 0,1,100 or 101.')
 9911 FORMAT (1H ,'UNBKOUT : KUNIT on input is ',I4,
     C         '. Valid values are 1 to 99.')
 9912 FORMAT (1H ,'UNBKOUT : Maximum number of files (',I2,
     C         ' exceeded.')
 9913 FORMAT (1H ,'UNBKOUT : Error in writing file number ',I2)
C
 9916 FORMAT (1H ,'UNBKOUT : KEOF on input is ',I4,
     C         '. Valid values are 0,1 or 2.')
 9917 FORMAT (1H ,'UNBKOUT : Array length is ',I6,' words, but record',
     C        ' length is ',I6,' words.')
C
      RETURN
C
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE CREXS5(KBUFL,YBUFF,KERR)
C
C**** *CREXS5*
C
C
C     PURPOSE.
C     --------
C         Expand CREX section 5
C
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *CREXS5(KBUFL,YBUFF,KERR)*
C
C     METHOD.
C     -------
C
C          NONE.
C
C
C     EXTERNALS.
C     ----------
C
C          NONE.
C
C     REFERENCE.
C     ----------
C
C          NONE.
C
C     AUTHOR.
C     -------
C
C          MILAN DRAGOSAVAC    *ECMWF*       15/02/92.
C
C
C     MODIFICATIONS.
C     --------------
C
C          NONE.
C
C
      IMPLICIT LOGICAL(L,O,G), CHARACTER*8(C,H,Y)
C

      PARAMETER(JSUP =   9,JSEC0=   3,JSEC1= 40,JSEC2= 64 ,JSEC3=    4,
     1          JSEC4=   2,JELEM=40000,JSUBS=400,JCVAL=150 ,JBUFL=40000,
     2          JBPW =  32,JTAB =3000,JCTAB=120,JCTST=1800,JCTEXT= 200,
     3          JWORK=360000,JKEY=46)
C
      CHARACTER*(*) YBUFF
C
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities
C granted to it by virtue of its status as an intergovernmental organisation
C nor does it submit to any jurisdiction.
C

      INTEGER FUNCTION INTFAP(INGRIB,INLEN)
C
C---->
C**** INTFAP
C
C     Purpose
C     -------
C
C     Prepare to interpolate input field...
C
C
C     Interface
C     ---------
C
C     IRET = INTFAP(INGRIB,INLEN)
C
C     Input
C     -----
C
C     INGRIB - Input field (packed).
C     INLEN  - Input field length (words).
C
C
C     Output
C     ------
C
C     Field unpacked values are in ZNFELDI, rotated if necessary.
C
C     Returns: 0, if OK. Otherwise, an error occured in interpolation.
C
C
C     Method
C     ------
C
C     Unpack field.
C
C     Rotate the field values if necessary.
C
C     Some rotation coefficients cannot be created because the
C     algorithm does not converge for rotations which are smaller
C     than a limit which depends on the spectral truncation.
C
C     If the rotation is too small, it has to be split into three
C     steps (two forward and one backward).
C
C     Current know limits are:
C
C     Truncation    Max South pole lat   Minimum rotation
C     ----------    ------------------   ----------------
C         63          -89.5                  0.5
C        106          -85                    5.0
C        159          -77                   13.0
C        213          -68                   22.0
C        319          -51                   39.0
C        511          -30.5                 59.5
C
C
C     Externals
C     ---------
C
C     GRIBEX  - Decode/encode GRIB product.
C     GRSVCK  - Turn off GRIB checking
C     INTLOG  - Log error message.
C     INTLOGR - Log error message.
C     RPHI    - Rotate a spectral field by longitude.
C     JACOBI  - Rotates spectral coefficients by latitude.
C
C
C     Author
C     ------
C
C     J.D.Chambers     ECMWF     Jan 1995
C
C     J.D.Chambers     ECMWF        Feb 1997
C     Allow for 64-bit pointers
C
C     J.D.Chambers     ECMWF        Oct 2000
C     Split rotations if less than minimum for the truncation
C
C----<
C
C     -----------------------------------------------------------------|
C*    Section 0.   Variables
C
C
      IMPLICIT NONE
C
C     Function arguments
      INTEGER INGRIB(*),INLEN
C
#include "parim.h"
#include "nifld.common"
#include "nofld.common"
#include "grfixed.h"
#include "intf.h"
C
C     Parameters
      INTEGER JPROUTINE
      PARAMETER (JPROUTINE = 26200 )
      INTEGER JPLEN, JPNM
      PARAMETER ( JPNM = JPSTRUNC )
      PARAMETER ( JPLEN = (JPNM+1)*(JPNM+6) )
C
C     Local variables
C
      REAL POLELAT, POLELON
      CHARACTER*1 HTYPE
      INTEGER NUMPTS, NGAUSS
      INTEGER IWORD, IERR, KPR, NBYTES, ITRUNC, LOOP, IRET
      INTEGER ISIZE
      DATA ISIZE/0/
C
      REAL SWORK
      DIMENSION SWORK(1)
#ifndef _CRAYFTN
#ifdef POINTER_64
      INTEGER*8 ISWORK
#endif
#endif
      POINTER ( ISWORK, SWORK)
C
      REAL*8 DWORK
      DIMENSION DWORK(1)
#ifndef _CRAYFTN
#ifdef POINTER_64
      INTEGER*8 IDWORK
#endif
#endif
      POINTER ( IDWORK, DWORK)
C
      REAL*8 DATA
      DIMENSION DATA(1)
#ifndef _CRAYFTN
#ifdef POINTER_64
      INTEGER*8 IDATA
#endif
#endif
      POINTER ( IDATA, DATA)
C
      SAVE ISIZE, ISWORK, IDWORK, IDATA
C
      REAL*8 DLON, DLAT, LATLIM
      LOGICAL LOK, LSPLIT
      DATA NBYTES/4/
C
C     Externals
      INTEGER NGROTAT
      EXTERNAL NGROTAT
      LOGICAL JACOBI
      EXTERNAL JACOBI
C
C     -----------------------------------------------------------------|
C*    Section 1.   Initialise
C     -----------------------------------------------------------------|
C
  100 CONTINUE
      INTFAP = 0
      IERR = 0
      KPR = 0
C
C     -----------------------------------------------------------------|
C*    Section 2.   Decode data from the GRIB code
C     -----------------------------------------------------------------|
C
  200 CONTINUE
C
C     Decode data from GRIB code (no checking)
C
      IWORD = INLEN
      IERR  =  0
      CALL GRSVCK(0)
      IERR = 1
      ISEC3(2) = NINT(RMISSGV)
      ZSEC3(2) = RMISSGV
      CALL GRIBEX(ISEC0, ISEC1, ISEC2, ZSEC2, ISEC3, ZSEC3, ISEC4,
     X            ZNFELDI, JPEXPAND, INGRIB, INLEN, IWORD, 'D',IERR)
C
      IF( IERR.LT.0) THEN
        IF( (IERR.EQ.-2).OR.(IERR.EQ.-4) ) THEN
          CALL INTLOG(JP_DEBUG,'INTFAP: Use missing value',JPQUIET)
          LIMISSV = .TRUE.
        ELSE
          CALL INTLOG(JP_ERROR,'INTFAP: GRIBEX decoding fail.',IERR)
          INTFAP = IERR
          GOTO 900
        ENDIF
      ELSE IF( IERR.GT.0 ) THEN
        CALL INTLOG(JP_ERROR,'INTFAP: GRIBEX decoding failed.',IERR)
        INTFAP = IERR
        GOTO 900
      ENDIF
C
C     -----------------------------------------------------------------|
C*    Section 3.   Handle spectral rotation, if necessary.
C     -----------------------------------------------------------------|
C
  300 CONTINUE
C
C     Is the interpolation from SH with a rotation of the SH first?
C
      IF( ((NIREPR.EQ.JPSPHERE).OR.(NIREPR.EQ.JPSPHROT)) .AND.
     X    LNOROTA ) THEN
C
C       Avoid rotating U or V spectral coefficients
C
        IF( (NIPARAM.EQ.131).OR.(NIPARAM.EQ.132) ) THEN
          CALL INTLOG(JP_ERROR,
     X      'INTFAP: Unable to rotate spectral U or V:',NIPARAM)
          INTFAP = JPROUTINE + 6
          GOTO 900
        ENDIF
C
C       Dynamically allocate memory for workspace.
C
C       (Note the multiplication by 2 for REAL*8).
C
        ISIZE =  (2*(JPNM+1)*(JPNM+6))*2
        CALL JMEMHAN( 11, IDWORK, ISIZE, 1, IRET)
        IF( IRET.NE.0 ) THEN
          CALL INTLOG(JP_ERROR,'INTFAP: memory allocation fail',IDWORK)
          INTFAP = JPROUTINE + 1
          GOTO 900
        ENDIF
C
C       (Note the multiplication by 2 for REAL*8).
C
        ISIZE =  JPLEN*2
        CALL JMEMHAN( 15, IDATA, ISIZE, 1, IRET)
        IF( IRET.NE.0 ) THEN
          CALL INTLOG(JP_ERROR,'INTFAP: memory allocation fail',IDATA)
          INTFAP = JPROUTINE + 2
          GOTO 900
        ENDIF
C
        CALL INTLOG(JP_DEBUG,'INTFAP: Rotate SH field.',JPQUIET)
        CALL INTLOG(JP_DEBUG,'INTFAP: South pole latitude  ',NOROTA(1))
        CALL INTLOG(JP_DEBUG,'INTFAP: South pole longitude ',NOROTA(2))
        IF ( NOREPR.EQ.JPSPHERE )  NOREPR = JPSPHROT
        IF ( NOREPR.EQ.JPREGULAR )  NOREPR = JPREGROT
        ITRUNC = ISEC2(2)
C
C       Some rotation coefficients cannot be created because the
C       algorithm does not converge for rotations which are smaller
C       than a limit which depends on the spectral truncation.
C
        IF( ITRUNC.LE.63 ) THEN
          LATLIM = -89.5
        ELSE IF( ITRUNC.LE.106 ) THEN
          LATLIM = -85.0
        ELSE IF( ITRUNC.LE.159 ) THEN
          LATLIM = -77.0
        ELSE IF( ITRUNC.LE.213 ) THEN
          LATLIM = -68.0
        ELSE IF( ITRUNC.LE.319 ) THEN
          LATLIM = -51.0
        ELSE IF( ITRUNC.LE.511 ) THEN
          LATLIM = -29.5
        ELSE
          INTFAP = JPROUTINE + 7
          GOTO 900
        ENDIF
        CALL INTLOGR(JP_DEBUG,
     X    'INTFAP: South pole latitude limit = ',LATLIM)
C
        POLELAT = (REAL(NOROTA(1))/JPMULT)
C
C       If the rotation is too small, it has to be split into three
C       steps (two forward and one backward).
C
        LSPLIT = POLELAT.LT.LATLIM
        IF( LSPLIT ) THEN
          DLAT = -90.0 - LATLIM
          CALL INTLOG(JP_DEBUG,
     X      'INTFAP: Rotation has been split into three steps',JPQUIET)
        ELSE
          DLAT = -90.0 - POLELAT
        ENDIF
#if (defined REAL_8)
C
C       Double precision REALs
C
        DLON = - REAL(NOROTA(2))/JPMULT
C
C       Rotate the spectral field by longitude.
        CALL RPHI( ZNFELDI, ITRUNC, DWORK, DLON)
C
C       Rotate the spectral field by latitude.
C
        IF( LSPLIT ) THEN
C
C         Two rotations forward ..
C
          CALL INTLOGR(JP_DEBUG,
     X      'INTFAP: Twice forward through angle ', DLAT)
          LOK = JACOBI(ZNFELDI, ITRUNC, DWORK, DLAT)
          IF(.NOT.LOK) THEN
            CALL INTLOG(JP_ERROR,
     X        'INTFAP: Spectral rotation failed',JPQUIET)
            INTFAP = JPROUTINE + 3
            GOTO 900
          ENDIF
          LOK = JACOBI(ZNFELDI, ITRUNC, DWORK, DLAT)
          IF(.NOT.LOK) THEN
            CALL INTLOG(JP_ERROR,
     X       'INTFAP: Spectral rotation failed',JPQUIET)
            INTFAP = JPROUTINE + 3
            GOTO 900
          ENDIF
C
C         .. and one backward
C
          DLAT = -90.0 - ( (LATLIM*2.0) - POLELAT)
          DLAT= -DLAT
          CALL INTLOGR(JP_DEBUG,
     X      'INTFAP: Once backward through angle ', DLAT)
        ENDIF
C
        LOK = JACOBI( ZNFELDI, ITRUNC, DWORK, DLAT)
          IF(.NOT.LOK) THEN
            CALL INTLOG(JP_ERROR,
     X        'INTFAP: Spectral rotation failed',JPQUIET)
            INTFAP = JPROUTINE + 3
            GOTO 900
          ENDIF
#else
C
C       Single precision REALs; so convert to double precision.
C
        DLAT = -90.0 - DBLE(NOROTA(1))/JPMULT
        DLON = - DBLE(NOROTA(2))/JPMULT
C
C       Expand spectral coefficients to REAL*8
C
        DO LOOP = 1, ISEC4(1)
          DATA(LOOP) = DBLE(ZNFELDI(LOOP))
        ENDDO
C
C       Rotate the spectral field by longitude.
        CALL RPHI( DATA, ITRUNC, DWORK, DLON)
C
C       Rotate the spectral field by latitude.
C
        IF( LSPLIT ) THEN
C
C         Two rotations forward ..
C
          CALL INTLOGR(JP_DEBUG,
     X      'INTFAP: Twice forward through angle ', DLAT)
          LOK = JACOBI(ZNFELDI, ITRUNC, DWORK, DLAT)
          IF(.NOT.LOK) THEN
            CALL INTLOG(JP_ERROR,
     X        'INTFAP: Spectral rotation failed',JPQUIET)
            INTFAP = JPROUTINE + 3
            GOTO 900
          ENDIF
          LOK = JACOBI(ZNFELDI, ITRUNC, DWORK, DLAT)
          IF(.NOT.LOK) THEN
            CALL INTLOG(JP_ERROR,
     X        'INTFAP: Spectral rotation failed',JPQUIET)
            INTFAP = JPROUTINE + 3
            GOTO 900
          ENDIF
C
C         .. and one backward
C
          DLAT = -90.0 - ( (LATLIM*2.0) - POLELAT)
          DLAT= -DLAT
          CALL INTLOGR(JP_DEBUG,
     X      'INTFAP: Once backward through angle ', DLAT)
        ENDIF
C
        LOK = JACOBI( DATA, ITRUNC, DWORK, DLAT)
#endif
C
        IF(.NOT.LOK) THEN
          CALL INTLOG(JP_ERROR,'INTFAP: Spectral rotation fail',JPQUIET)
          INTFAP = JPROUTINE + 3
          GOTO 900
        ENDIF
#if (!defined REAL_8)
C
C       Single precision REALs; repack spectral coefficients to REAL*4.
C
        DO LOOP = 1, ISEC4(1)
          ZNFELDI(LOOP) = SNGL(DATA(LOOP))
        ENDDO
#endif
C
      ENDIF
C
C     -----------------------------------------------------------------|
C*    Section 4.   Handle gaussian rotation, if necessary.
C     -----------------------------------------------------------------|
C
  400 CONTINUE
C
C     Is the interpolation from gaussian with a rotation of the
C     gaussian first?
C
      IF( ((NIREPR.EQ.JPGAUSSIAN).OR.(NIREPR.EQ.JPQUASI)) .AND.
     X    LNOROTA ) THEN
C
        CALL INTLOG(JP_DEBUG,'INTFAP: Rotate gaussian field.',JPQUIET)
        CALL INTLOG(JP_DEBUG,'INTFAP: South pole latitude  ',NOROTA(1))
        CALL INTLOG(JP_DEBUG,'INTFAP: South pole longitude ',NOROTA(2))
C
C       Dynamically allocate memory for workspace.
C
        NUMPTS = ISEC4(1)
        ISIZE  = NUMPTS
        CALL JMEMHAN( 11, ISWORK, ISIZE, 1, IRET)
        IF( IRET.NE.0 ) THEN
          CALL INTLOG(JP_ERROR,'INTFAP: memory allocation fail',ISWORK)
          INTFAP = JPROUTINE + 4
          GOTO 900
        ENDIF
C
C       Rotate the gaussian field.
C
        POLELAT = REAL(NOROTA(1))/JPMULT
        POLELON = REAL(NOROTA(2))/JPMULT
        NGAUSS = ISEC2(3)/2
        IF( NIREPR.EQ.JPGAUSSIAN ) THEN
          HTYPE = 'F'
        ELSE
          HTYPE = 'R'
        ENDIF
        IRET =NGROTAT(ZNFELDI,SWORK,NUMPTS,POLELAT,POLELON,HTYPE,NGAUSS)
        IF( IRET.NE.0 ) THEN
          CALL INTLOG(JP_ERROR,'INTFAP: Gaussian rotation fail',JPQUIET)
          INTFAP = JPROUTINE + 5
          GOTO 900
        ENDIF
C
C       Move rotated field back into field original array.
C
        DO LOOP = 1, NUMPTS
          ZNFELDI(LOOP) = SWORK(LOOP)
        ENDDO
C
      ENDIF
C
C
C     -----------------------------------------------------------------|
C*    Section 9.   Closedown.
C     -----------------------------------------------------------------|
C
  900 CONTINUE
C
      RETURN
      END

C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      INTEGER FUNCTION NUMPTWE(WEST,EAST,GRIDSTEP)
C
C---->
C**** NUMPTWE
C
C     Purpose
C     -------
C
C     Calculate number of grid points in the range from west to east.
C
C
C     Interface
C     ---------
C
C     IRET = NUMPTWE(WEST,EAST,GRIDSTEP)
C
C     Input
C     -----
C
C     WEST     - Western boundary in degrees
C     EAST     - Eastern boundary in degrees
C     GRIDSTEP - Grid interval in degrees
C
C
C     Output
C     ------
C
C     Function returns the number of grid points in the east-west
C     interval.
C
C
C     Method
C     ------
C
C     The grid is assumed to start at Greenwich.
C
C
C     Externals
C     ---------
C
C     None.
C
C     Author
C     ------
C
C     J.D.Chambers     ECMWF     Nov 1997
C
C
C     Modifications
C     -------------
C
C     None.
C
C----<
C
      IMPLICIT NONE
C
C     Function arguments
C
      REAL EAST, WEST, GRIDSTEP
C
C     Local variables
C
      INTEGER NL
      REAL*8 DEAST, DWEST
      REAL*8 LEFT, RIGHT, STEP, EPS
      DATA EPS/1.0E-3/
C
C     Statement function
      LOGICAL EQUAL
      REAL*8 A, B
      EQUAL(A,B) = ( ABS(A-B) .LT.EPS )
C
C ------------------------------------------------------------------
C     Section 1.   Initialise
C ------------------------------------------------------------------
C
  100 CONTINUE
C
C     Make all longitudes positive for calculation of difference
C
      DEAST = EAST
      DWEST = WEST
      RIGHT = DEAST + 360.0
      LEFT  = DWEST + 360.0
      STEP  = GRIDSTEP
      IF( RIGHT.LT.LEFT) RIGHT = RIGHT + 360.0
C
C ------------------------------------------------------------------
C     Section 2.   Calculate the number of points in the interval
C ------------------------------------------------------------------
C
  200 CONTINUE
C
C     Equal boundaries
C
      IF( EQUAL(LEFT,RIGHT) ) THEN
        NUMPTWE = 1
        GOTO 900
      ENDIF
C
C     Calculate offset of westernmost gridpoint
C
      NL = INT((LEFT+EPS)/STEP)
      IF( .NOT. EQUAL(LEFT,(NL*STEP)) ) NL = NL + 1
C
      RIGHT = RIGHT - (NL*STEP)
      NUMPTWE = INT((RIGHT+EPS)/STEP) + 1
C
C ------------------------------------------------------------------
C     Section 9.   Return
C ------------------------------------------------------------------
C
  900 CONTINUE
C
      RETURN
      END

C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE GETUSR (HNAM)
      IMPLICIT LOGICAL     ( L , O , G )
      IMPLICIT CHARACTER*8 ( C , H , Y )
      IMPLICIT INTEGER     ( I , J , K , M , N )
C---->
C
C*    MARS common areas containing job environment information,
C     parameter settings etc.
C
C     NFTNOS - 12 Fortran unit numbers used by MARS.
C              NFTNOS(1) is MARSLOG file. Cracked MARS directives.
C              NFTNOS(2) is MARSPAR file. MARS directives in
C                        network transmission format.
C              NFTNOS(5) is unit 5 , standard input.
C              NFTNOS(6) is unit 6 , standard output.
C              NFTNOS(7) is MARSDEF or MARSDEFNEXT, language
C                        definition, operational or test.
C              Set by routine JENVXX.
C     NUMREQ - Total number of requests.
C     NUMFIL - Numbers of different files to be accessed.
C              NUMFIL(1) , Total number of files to accessed.
C              NUMFIL(2) , Number of IBM disk files to accessed.
C              NUMFIL(3) , Number of IBM MSS files to be accessed.
C              NUMFIL(4) , Number of IBM tape files to be accessed.
C              NUMFIL(5) , Number of worker machine files to accessed.
C     NCNDAY - Century day.
C              Set by routine JENVXX.
C     NJMODE - Mode in which MARS job is running.
C              -1, Quit issued.
C              0 , Checkout directives only.
C              1 , Connected mode (normal mode retains connection
C                  with IBM at all times).
C              2 , Disconnected mode (send requests to IBM and
C                  terminate).
C                  Not yet implemented.
C     NJOBSQ - Unique number identifying job or process.
C              Set by routine JENVXX.
C     NUMBIT - Number of bits in computer word.
C              Set by routine JENVXX.
C     NDBUGS - Debug print switch for IBM.
C              0 , No debug printout.     .
C              8 , Debug print on IBM.
C              Set by routine JENVXX.
C     NDBUGL - Debug level indicator for worker machine.
C              0 , No debug print.
C              4 , Trace through subroutine sections and
C                  values of parameters on entry as well as
C                  other print statements used when actually
C                  debugging.
C              Set by routine JENVXX.
C     NJBCAT - Category assigned to job by MARS.
C              0 , Archive request.
C              1 , Manage request.
C              2 , Checkout request.
C              3 , Costonly request.
C              4 , Retrieval from online Operational database on the
C                  worker machine.
C              5 , Retrieve guaranteed online (on IBM ) data.
C              6 , Retrieve online (on IBM ) data.
C                  Not yet implemented. Treated as category 7.
C              7 , Retrieve off-line (on IBM ) data.
C              8 , Retrieval of research department data from
C                  online Research database on worker machine.
C     NPRITY - Priority assigned to job by MARS.
C              1 , High.
C              2 , Normal.
C              3 , Low.
C     NIAORB - 0 , Current job is an active mode job.
C              1 , Current job is in interactive edit mode.
C              Set by routine JENVXX.
C
C---->
      INTEGER NFTNOS
      INTEGER NCNDAY
      INTEGER NJMODE
      INTEGER NJOBSQ
      INTEGER NUMBIT
      INTEGER NDBUGS
      INTEGER NDBUGL
      INTEGER NJBCAT
      INTEGER NPRITY
      INTEGER NIAORB
      INTEGER NFLTYP
      INTEGER NUMFIL
      INTEGER NUMREQ
C
      DIMENSION NFTNOS(12)
      DIMENSION NUMFIL(5)
C
      COMMON /INTGCOM/ NFTNOS , NCNDAY , NJMODE , NJOBSQ , NUMBIT ,
     C                 NDBUGS , NDBUGL , NJBCAT , NPRITY , NIAORB ,
     C                 NFLTYP , NUMFIL , NUMREQ
C
C     COPSYS - Name of computer operating system.
C              UNICOS
C              COS
C              NOS/VE
C              VMS
C              MVS/XA
C              Set by routine calling MARSXX.
C     CWMACH - Name of machine on which MARS is running.
C              CRAY
C              CYBER
C              VAX
C              IBM
C              Set by routine JENVXX.
C     CCDATE - Date at start of job in yymmdd format.
C              Set by routine JENVXX.
C     CCTIME - Time at start of job in hhmmss format.
C              Set by routine JENVXX.
C     CJNAME - Name of job or process.
C              Set by routine JENVXX.
C     CACCNT - Account under which job is running.
C     CWMARS - Connect to test or operational MARS/IBM.
C              MATS , Test version.
C              MARS , Operational version.
C              Set by routine JENVXX.
C     CWLANG - Use test or operational version of MARS language.
C              MARSDEF - Operational version.
C              MATSDEF - Test version.
C              Set by routine JENVCO for COS version.
C     CWLAPA - Use test or operational version of MARS language.
C              .../.../marsdef - Operational version.
C              .../.../matsdef - Test version.
C              Set by routine JENVUN for UNICOS version.
C     CWTMDR - Temporary file directory.
C              Set by JENVUN.
C     CWUSER - User name.
C              Set by JENVUN.
C     CUSFDB - FDB Usage indicator.
C              NEVER , Never attempt to access FDB.
C              ALWAYS, Always attempt to access FDB.
C              DEFAULT, Analyse request before deciding usage.
C              Set by JENVUN.
C     CWEDNO - GRIB Code Edition indicator.
C              OFF , use current edition.
C              ON  , use edition 0.
C
      CHARACTER*8   COPSYS
      CHARACTER*8   CWMACH
      CHARACTER*3   CWUSER
      CHARACTER*6   CCDATE
      CHARACTER*6   CCTIME
      CHARACTER*4   CWMARS
      CHARACTER*7   CWLANG
      CHARACTER*7   CUSFDB
      CHARACTER*48  CWLAPA
      CHARACTER*48  CWTMDR
      CHARACTER*16  CJNAME
      CHARACTER*16  CACCNT
      CHARACTER*3   CWEDNO
C
      COMMON /CHARCOM/ COPSYS , CWMACH , CCDATE , CCTIME , CJNAME ,
     C                 CACCNT , CWMARS , CWLANG , CWLAPA , CWTMDR ,
     C                 CWUSER , CUSFDB , CWEDNO
C
      CHARACTER*3 HNAM
      HNAM = CWUSER
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      INTEGER FUNCTION IGLSMR (KILSMN, KILSMS, KOLSM, KNINDEX,
     1   KSINDEX, KOWE, PWFACT, KPR, KERR)
C
C---->
C**** *IGLSMR*
C
C     PURPOSE
C     -------
C
C     Calculate the effects of the land-sea masks for one line of
C     latitude on the unnormalised interpolation weights.
C
C     INTERFACE
C     ---------
C
C     IERR = IGLSMR (KILSMN, KILSMS, KOLSM, KNINDEX, KSINDEX,
C    1   KOWE, PWFACT, KPR, KERR)
C
C     Input parameters
C     ----------------
C
C     KILSMN     - The land sea mask for the line of latitude of the
C                  input field North of the output row.
C
C     KILSMS     - The land sea mask for the line of latitude of the
C                  input field South of the output row.
C
C     KOLSM      - The land sea mask for the current line of latitude
C                  of the output field.
C
C     KNINDEX    - This array contains the array offsets of the West
C                  and East points in the input line of latitude North
C                  of the current output field line of latitude.
C
C     KSINDEX    - This array contains the array offsets of the West
C                  and East points in the input line of latitude South
C                  of the current output field line of latitude.
C
C     KOWE       - The number of output field points in the West-East
C                  direction for this line of latitude.
C
C     PWFACT     - The array of interpolating weights to the four
C                  neighbouring points for every output point in this
C                  line of latitude.
C
C     KPR        - The debug print switch.
C                  0  , No debugging output.
C                  1  , Produce debugging output.
C
C     KERR       - The error control flag.
C                  -ve, No error message. Return error code.
C                  0  , Hard failure with error message.
C                  +ve, Print error message. Return error code.
C
C     Output parameters
C     ________________
C
C     PWFACT     - The modified array of interpolating weights to the
C                  four neighbouring points for every output point in
C                  this line of latitude.
C
C     Return value
C     ------------
C
C     The error indicator (INTEGER).
C
C     Error and Warning Return Values
C     _______________________________
C
C     None
C
C     Common block usage
C     __________________
C
C     None
C
C     Externals
C     ---------
C
C     INTLOG(R) - Logs messages.
C
C
C     Method
C     ------
C
C     Every time that a point in the input array has a land-sea mask
C     value (0-1) that does not match the corresponding output point
C     its interpolating value is multiplied by a scaling factor
C     (currently 0.2). This reduces the influence of such points on
C     the final interpolation.
C
C     The parameter list is designed to allow for quasi regular input
C     fields with different grid spacing in the Northern and Southern
C     lines of latitude.
C
C
C     Reference
C     ---------
C     None
C
C
C     Comments
C     --------
C     None
C
C
C     AUTHOR
C     ------
C     K. Fielding      *ECMWF*      Oct 1993
C
C
C     Modifications
C     -------------
C
C     None
C
C----<
C
C     -----------------------------------------------------------------|
C*    Section 0. Definition of variables.
C     -----------------------------------------------------------------|
C
C
      IMPLICIT NONE
C
#include "parim.h"
C
C     Dummy arguments
      INTEGER KOWE, KPR, KERR
      INTEGER KNINDEX (2, KOWE), KSINDEX (2, KOWE)
      INTEGER KILSMN (*), KILSMS (*), KOLSM (KOWE)
      REAL PWFACT (4, KOWE)
C
C     Local variables
      INTEGER JOLON
C
C     Multiplication factor for unlike land-sea masks
C
      REAL PPLSM
      PARAMETER (PPLSM = 0.2E0)
C
      INTEGER JPROUTINE
      PARAMETER (JPROUTINE = 25300)
C
C     -----------------------------------------------------------------|
C*    Section 1. Initialisation
C     -----------------------------------------------------------------|
C
  100 CONTINUE
C
      IF( KPR.GE.1 ) CALL INTLOG(JP_DEBUG,'IGLSMR: Section 1.',JPQUIET)
C
      IGLSMR = 0
C
      IF (KPR .GE. 1) 
     X  CALL INTLOG(JP_DEBUG,'IGLSMR: No. of output longitudes = ',KOWE)
C
C     -----------------------------------------------------------------|
C*    Section 2. Calculate arrays of weights
C     -----------------------------------------------------------------|
C
  200 CONTINUE
C
      IF (KPR.GE.1) CALL INTLOG(JP_DEBUG,'IGLSMR: Section 2.',JPQUIET)
C
C     Now modify the unormalised weight for land-sea mask
C
      DO 210 JOLON = 1, KOWE
C
         IF (KILSMN (KNINDEX (JP_I_W, JOLON)) .NE.
     1      KOLSM (JOLON) )
     2         PWFACT (JP_I_NW, JOLON) =
     3            PWFACT (JP_I_NW, JOLON) * PPLSM
C
         IF (KILSMN (KNINDEX (JP_I_E, JOLON)) .NE.
     1      KOLSM (JOLON) )
     2         PWFACT (JP_I_NE, JOLON) =
     3            PWFACT (JP_I_NE, JOLON) * PPLSM
C
         IF (KILSMS (KSINDEX (JP_I_W, JOLON)) .NE.
     1      KOLSM (JOLON) )
     2         PWFACT (JP_I_SW, JOLON) =
     3            PWFACT (JP_I_SW, JOLON) * PPLSM
C
         IF (KILSMS (KSINDEX (JP_I_E, JOLON)) .NE.
     1      KOLSM (JOLON) )
     2         PWFACT (JP_I_SE, JOLON) =
     3            PWFACT (JP_I_SE, JOLON) * PPLSM
C
  210 CONTINUE
C
C     -----------------------------------------------------------------|
C*    Section 9. Return to calling routine. Format statements
C     -----------------------------------------------------------------|
C
  900 CONTINUE
C
      IF( KPR.GE.1 ) CALL INTLOG(JP_DEBUG,'IGLSMR: Section 9.',JPQUIET)
C
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE GBYTE  (SOURCE,DEST,IOFSET,IBYTSZ)
C
C---->
C**** GBYTE  - Extract a single bit field. Cray routine.
C
C*    FUNCTION: GET A SINGLE BIT FIELD FROM SOURCE INTO DEST
C*
C*    INPUT   : SOURCE(1)= WORD CONTAINING START OF BIT FIELD
C*              DEST     = TARGET WORD
C*              IOFSET   = OFFSET IN BITS FOR START OF THE FIELD
C*              IBYTSZ   = LENGTH OF FIELD IN BITS
C*
C*    OUTPUT  : SOURCE,IOFSET,IBYTSZ UNCHANGED
C*              DEST CONTAINS FIELD RIGHT JUSTIFIED
C*
C*    AUTHOR  : M.MIQUEU   08/1981 (REWRITTEN FROM J.MARTELLET'S)
C*
C----<
      PARAMETER(NBPW=64)
      INTEGER SOURCE(1),DEST
      INTEGER SH1
      SH1=IOFSET+IBYTSZ-NBPW

      IF(SH1.GT.0) GO TO 2


C     BYTES DO NOT SPAN WORDS


      SH1=NBPW+SH1


      DEST=AND(
     1          SHIFT(SOURCE(1),SH1),
     2          SHIFT(MASK(IBYTSZ),IBYTSZ)
     3        )

      RETURN

C     BYTE SPANS WORDS

2     CONTINUE


      DEST=OR(
     1        SHIFT(
     2              AND(SOURCE(1),COMPL(MASK(IOFSET)))
     3              ,SH1),
     4        SHIFT(
     5              AND(SOURCE(2),MASK(SH1))
     6              ,SH1)
     7       )



      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities
C granted to it by virtue of its status as an intergovernmental organisation
C nor does it submit to any jurisdiction.
C

      INTEGER FUNCTION HIRLSM(L12PNT,OLDFLD,KOUNT,KGAUSS,
     X  HTYPE,AREA,POLE,GRID,NEWFLD,KSIZE,NLON,NLAT)
C
C---->
C**** HIRLSM
C
C     Purpose
C     -------
C
C     This routine creates a rotated regular lat/long field from a
C     reduced gaussian field using 12-point horizontal interpolation
C     and land-sea masks.
C
C
C     Interface
C     ---------
C
C     IRET = HIRLSM(L12PNT,OLDFLD,KOUNT,KGAUSS,HTYPE,AREA,POLE,GRID,
C    X              NEWFLD,KSIZE,NLON,NLAT)
C
C
C     Input parameters
C     ----------------
C
C     L12PNT - Chooses between 12-point and 4-point interpolation
C              = .TRUE. for 12-point horizontal
C              = .FALSE. for 4-point
C     OLDFLD - Array of values from the (old) reduced gaussian field
C     KOUNT  - Number of values in OLDFLD
C     KGAUSS - Gaussian grid number
C     HTYPE  - Gaussian grid type
C              = 'R' for reduced ("quasi-regular"),
C              = 'O' for reduced/octahedral,
C              = 'F' for full,
C              = 'U' for a user-defined gaussian grid
C     AREA   - Limits of output area (N/W/S/E)
C     POLE   - Pole of rotation (lat/long)
C     GRID   - Output lat/long grid increments (we/ns)
C     KSIZE  - The size of the output array to fill with the regular
C              lat/long field
C
C
C     Output parameters
C     -----------------
C
C     NEWFLD - The array of values for the regular lat/long field
C     NLON   - Number of longitudes in the regular lat/long field
C     NLAT   - Number of latitudes in the regular lat/long field
C
C     Returns 0 if function successful, non-zero otherwise.
C
C     Common block usage
C     ------------------
C
C     nifld.common
C     nofld.common
C
C
C     Method
C     ------
C
C     Numbering of the points (I is the interpolation point):
C
C                   13       5       6      14
C
C                    7       1       2       8
C                               (I)
C                    9       3       4      10
C
C                   15      11      12      16
C
C     The 12-point interpolation is not possible if either of the top
C     two rows is above the original field northern latitude. The
C     nearest neighbour is used if both rows are above, and a 4-pt
C     bilinear interpolation is used if the top row is above.
C     Similarily, if either of the bottom two rows is below the original
C     field southern latitude.
C
C
C     Externals
C     ---------
C
C     INTLOG  - Logs messages
C     JGETGG  - Reads the definition of a gaussian grid
C     HGENGRD - Calculates original lat/long (before rotation) for
C               a rotated grid
C     HNEI12  - Finds neighbours for points for interpolation
C     HWTS12  - Calculates weightings for points for interpolation
C     CHKPREC - Check if precipitation threshold has been redefined
C     HWTSLSM - Calculates LSM weightings for points for interpolation
C     HGETLSM - Reads values for gaussian land-sea mask
C     FORCED_NEAREST_NEIGHBOUR - check forced interpolation method
C     HIRLSM_USERSPACE_1_GET   - HIRLAM userspace memory #1
C     HIRLSM_USERSPACE_2_GET   - HIRLAM userspace memory #2
C     HIRLSM_USERSPACE_3_GET   - HIRLAM userspace memory #3
C     HIRLSM_USERSPACE_4_GET   - HIRLAM userspace memory #4
C     HIRLSM_USERSPACE_5_GET   - HIRLAM userspace memory #5
C
C
C     Reference
C     ---------
C
C     None.
C
C
C     Comments
C     --------
C
C     None.
C
C
C     Author
C     ------
C
C     J.D.Chambers      ECMWF      January 2001
C
C
C     Modifications
C     -------------
C
C     None.
C
C----<
C     -----------------------------------------------------------------|
C*    Section 0. Definition of variables.
C     -----------------------------------------------------------------|
C
      IMPLICIT NONE
C
#include "parim.h"
#include "nifld.common"
#include "nofld.common"
C
C     Parameters
C
      INTEGER JNORTH, JSOUTH, JWEST, JEAST, JW_E, JN_S
      INTEGER JP12PT, JP4PT
      PARAMETER (JP12PT = 0)
      PARAMETER (JP4PT  = 1)
      PARAMETER (JNORTH = 1)
      PARAMETER (JWEST  = 2)
      PARAMETER (JSOUTH = 3)
      PARAMETER (JEAST  = 4)
      PARAMETER (JW_E   = 1)
      PARAMETER (JN_S   = 2)
C
C     Function arguments
C
      LOGICAL L12PNT
      INTEGER KOUNT, KGAUSS, KSIZE, NLON, NLAT
      REAL AREA(4), POLE(2), GRID(2)
      REAL OLDFLD(*), NEWFLD(KSIZE)
      CHARACTER*1 HTYPE
C
C     Local variables
C
      INTEGER NEXT, LOOP, IRET, NLEN, NBYTES, NUMBER
      INTEGER NEAREST, NEND, COUNT
      INTEGER NJPR,  NJPB
      INTEGER NPREV
      INTEGER INUM
      INTEGER IOSIZE, INSIZE
      INTEGER NEWSIZE
      REAL OLDAREA(4), OLDPOLE(2), OLDGRID(2)
      REAL OLDLSM(1)
      POINTER (IPOLDLS, OLDLSM )
C
      INTEGER KSCHEME(1),NEIGH(12,1), KLA(1)
      REAL PWTS(12,1)
      POINTER (IPKSCHE, KSCHEME)
      POINTER (IPNEIGH, NEIGH)
      POINTER (IPKLA,   KLA)
      POINTER (IPPWTS,  PWTS)
      LOGICAL LVEGGY
      CHARACTER*12 Y1FLAG, Y2FLAG
      LOGICAL LNEWSPC, LOLDNEW
      LOGICAL LSOIL  ! Special processing for soil parameters
      LOGICAL LITAL
      LOGICAL LVEGGY2
      INTEGER KSCHEMEN(1)
      REAL PWTSN(12,1)
      POINTER (IPKSCHEN, KSCHEMEN)
      POINTER (IPPWTSN,  PWTSN)
C
      REAL PDLO0(1),PDLO1(1),PDLO2(1),PDLO3(1),PDLAT(1)
      POINTER (IPPDLO0, PDLO0)
      POINTER (IPPDLO1, PDLO1)
      POINTER (IPPDLO2, PDLO2)
      POINTER (IPPDLO3, PDLO3)
      POINTER (IPPDLAT, PDLAT)
C
      INTEGER IGG, IGGOLD
      INTEGER KPTS(1)
      REAL GLATS(1)
      INTEGER IOFFS(1)
      POINTER (IPKPTS,  KPTS)
      POINTER (IPIOFFS, IOFFS)
      POINTER (IPGLATS, GLATS)
C
      INTEGER ILL
      REAL RLAT(1),RLON(1)
      POINTER (IPRLAT, RLAT)
      POINTER (IPRLON, RLON)
C
      REAL OLD(KOUNT)
C
      CHARACTER*7 FNAME
      PARAMETER  (FNAME = 'HIRLSM ')
C
      DATA IGGOLD/-1/, NUMBER/-1/, NPREV/-1/
C
      REAL NEWLSM(1)
      POINTER (IPNEWLS, NEWLSM)
      DATA OLDAREA/4*-1.0/, OLDPOLE/2*-1.0/, OLDGRID/2*-1.0/
      DATA IOSIZE/-1/, INSIZE/-1/
      DATA IPNEWLS/0/, IPOLDLS/0/
C
      SAVE IGGOLD, NUMBER, NPREV
      SAVE IPKPTS, IPIOFFS, IPGLATS, IPOLDLS
      SAVE IOSIZE, INSIZE
      SAVE OLDAREA, OLDPOLE, OLDGRID
C
C     Externals
C
      LOGICAL FORCED_NEAREST_NEIGHBOUR
      INTEGER HNEI12
      INTEGER HGENGRD
      INTEGER HGETLSM
#ifdef POINTER_64
      INTEGER*8
#else
      INTEGER
#endif
     X  HIRLSM_USERSPACE_1_GET,
     X  HIRLSM_USERSPACE_2_GET,
     X  HIRLSM_USERSPACE_3_GET,
     X  HIRLSM_USERSPACE_4_GET,
     X  HIRLSM_USERSPACE_5_GET
C
C     Statement functions
C
      REAL A, B
      LOGICAL NOTEQ
C
C     Tests that A is not (almost) equal to B
C
      NOTEQ(A,B) = (ABS((A)-(B)).GT.(ABS(A)*1E-3))
C
C     -----------------------------------------------------------------|
C     Section 1.  Initialise.
C     -----------------------------------------------------------------|
C
  100 CONTINUE
      IPKSCHEN = 0
      IPPWTSN  = 0
      HIRLSM = 0
C
      CALL JDEBUG()
C
      IF( L12PNT ) THEN
        CALL INTLOG(JP_DEBUG,FNAME//': 12-pt interpolation',JPQUIET)
      ELSE
        CALL INTLOG(JP_DEBUG,FNAME//': 4-pt interpolation',JPQUIET)
      ENDIF
C
      CALL CHKPREC()
      IF( LPREC )THEN
        CALL INTLOG(JP_DEBUG,
     X    FNAME//': precipitation threshold applied',JPQUIET)
      ELSE
        CALL INTLOG(JP_DEBUG,
     X    FNAME//': precipitation threshold not applied',JPQUIET)
      ENDIF

      IF( HTYPE.NE.'O' .AND. HTYPE.NE.'R' .AND. HTYPE.NE.'U' ) THEN
        CALL INTLOG(JP_ERROR,
     X    FNAME//': Gaussian type unsupported ('//HTYPE//')',JPQUIET)
        HIRLSM = 1
        GOTO 900
      ENDIF


C     Set method based on environment variables
      CALL GETENV('SOIL_PARAM',            Y1FLAG)
      CALL GETENV('NEAREST_NEIGHBOUR_NEW', Y2FLAG)


C     Use nearest neighbour if required
      LVEGGY = FORCED_NEAREST_NEIGHBOUR(LMETHOD,NITABLE,NIPARAM)


C
C     Fields with bitmap (as SST) and VEGGY Parameters are treated
C     with a corrected nearest neighbour method matching LSM
C     Force nearest neighbour for same type lsm processing
C      with INTOUT parameter
      LVEGGY2 = .FALSE.
      LSOIL   = .FALSE.  ! Special processing for soil parameters
      LITAL   = .FALSE.
      IF( Y2FLAG(1:1).EQ.'1'.OR.LNNLSM ) THEN
C       envvar NEAREST_NEIGHBOUR_NEW=1, or
C       intout interpolation="nearest lsm"
        IF(LVEGGY) LVEGGY2 = .TRUE.
        LVEGGY = .FALSE.
        LITAL  = .TRUE.
      ELSEIF( Y1FLAG(1:1).EQ.'1' .AND. LVEGGY ) THEN
C       envvar SOIL_PARAM=1, and
C       ( vegetation parameter or
C         envvar NEAREST_NEIGHBOUR=1 or
C         intout interpolation="nearest neighbour" )
        LSOIL  = .TRUE.
        LVEGGY = .FALSE.
      ENDIF

      IF( LVEGGY ) CALL INTLOG(JP_DEBUG,
     X  FNAME//': nearest neighbour processing: vegetation',JPQUIET)
      IF( LSOIL  ) CALL INTLOG(JP_DEBUG,
     X  FNAME//': nearest neighbour processing: soil',      JPQUIET)
      IF( LITAL  ) CALL INTLOG(JP_DEBUG,
     X  FNAME//': nearest neighbour processing: new',       JPQUIET)


C
C     Dynamically allocate memory for gaussian grid information.
C
      IGG = KGAUSS*2
      IF( IGG.GT.IGGOLD ) THEN
C
        NBYTES = (IGG*JPRLEN) + (2*IGG+1)*JPBYTES
C
        IPKPTS = HIRLSM_USERSPACE_1_GET(NBYTES)
#ifdef hpR64
        IPKPTS = IPKPTS/(1024*1024*1024*4)
#endif
        IF( IPKPTS.EQ.0 ) THEN
          CALL INTLOG(JP_ERROR,
     X      FNAME//': Memory allocate fail',JPQUIET)
          HIRLSM = 1
          GOTO 900
        ENDIF
C
        IPGLATS = IPKPTS  + (IGG*JPBYTES)
        IPIOFFS = IPGLATS + (IGG*JPRLEN)
C
        IGGOLD = IGG
        NPREV = -1
C
      ENDIF
C
C     Has gaussian grid changed from last time through?
C
CC    LOLDNEW = (KGAUSS.NE.NPREV)  this forces reloading the LSM always!
      LOLDNEW = .TRUE.
C
C     Build up offsets to start of each latitude in original field(s)
      IF( LOLDNEW ) THEN
        CALL INTLOG(JP_DEBUG,FNAME//': trying Gaussian '//HTYPE,KGAUSS)
        CALL JGETGG(KGAUSS,HTYPE,GLATS,KPTS,IRET)
        IF( IRET.NE.0 ) THEN
          CALL INTLOG(JP_ERROR,
     X      FNAME//': JGETGG failed to get gaussian data',JPQUIET)
          HIRLSM = 2
          GOTO 900
        ENDIF
C
        IOFFS(1) = 1
        DO LOOP = 2, (KGAUSS*2+1)
          IOFFS(LOOP) = IOFFS(LOOP-1) + KPTS(LOOP-1)
        ENDDO
C
        NPREV = KGAUSS
      ENDIF
C
      NUMBER = (IOFFS(KGAUSS*2+1) - 1)
      IF( NUMBER.NE.KOUNT ) THEN
        CALL INTLOG(JP_ERROR,FNAME//': Given no. of points =',KOUNT)
        CALL INTLOG(JP_ERROR,FNAME//': Expected no. of pts =',NUMBER)
        HIRLSM = 4
        GOTO 900
      ENDIF
C
C     Preserve the input field
C     (in case OLDFLD and NEWFLD are the same arrays)
C
      OLD(1:NUMBER) = OLDFLD(1:NUMBER)
C
C     If old land-sea mask has changed, pick up different land-sea mask
C
      IF( LOLDNEW ) THEN
C
C       Allocate memory for old land-sea mask
C
        IOSIZE = NUMBER*JPRLEN
        IPOLDLS = HIRLSM_USERSPACE_2_GET(IOSIZE)
        IF( IPOLDLS.EQ.0 ) THEN
          CALL INTLOG(JP_ERROR,
     X      FNAME//': Memory allocate fail',JPQUIET)
          HIRLSM = 4
          GOTO 900
        ENDIF
C
C       Read values for different land-sea mask in memory
C
        NEWSIZE = NUMBER*JPRLEN
        IRET = HGETLSM(KGAUSS,HTYPE,OLDLSM,NEWSIZE)
Cs        IRET = HGETLSM(KGAUSS,OLDLSM,IOSIZE)

        IF( IRET.NE.0 ) THEN
          CALL INTLOG(JP_ERROR,
     X      FNAME//': HGETLSM failed to get LSM data',JPQUIET)
          HIRLSM = 4
          GOTO 900
        ENDIF
      ENDIF
C
C     -----------------------------------------------------------------|
C     Section 2.  Generate the lat/long points for the output grid
C     -----------------------------------------------------------------|
C
  200 CONTINUE
C
C Sinisa put nint instead int (SC Aug-2005)
      NLON = 1 + NINT((AREA(JEAST) - AREA(JWEST)) / GRID(JW_E))
      NLAT = 1 + NINT((AREA(JNORTH) - AREA(JSOUTH)) / GRID(JN_S))
C
      NLEN = NLON * NLAT

      NOWE = NLON
      NONS = NLAT
C
C     Check that given array is big enough for the new field.
C
      IF( NLEN.GT.KSIZE ) THEN
        CALL INTLOG(JP_ERROR,FNAME//': Given array size = ',KSIZE)
        CALL INTLOG(JP_ERROR,FNAME//': Required size = = ',NLEN)
        HIRLSM = 5
        GOTO 900
      ENDIF
C
C     Dynamically allocate memory for lat/long arrays.
C
      ILL = NLEN
      NBYTES = 2*ILL*JPRLEN
C
      IPRLON = HIRLSM_USERSPACE_3_GET(NBYTES)
#ifdef hpR64
      IPRLON = IPRLON/(1024*1024*1024*4)
#endif
      IF( IPRLON.EQ.0 ) THEN
        CALL INTLOG(JP_ERROR,
     X    FNAME//': Memory allocate fail',JPQUIET)
        HIRLSM = 6
        GOTO 900
      ENDIF
C
      IPRLAT  = IPRLON + (ILL*JPRLEN)
C
      IRET = HGENGRD(AREA,POLE,GRID,NLON,NLAT,RLAT,RLON)
      IF( IRET.NE.0 ) THEN
        CALL INTLOG(JP_ERROR,
     X    FNAME//': HGENGRD failed to get lat/lon grid data',JPQUIET)
        HIRLSM = 7
        GOTO 900
      ENDIF
C
C     -----------------------------------------------------------------|
C     Section 3.  Find neighbours for each point for interpolation.
C     -----------------------------------------------------------------|
C
  300 CONTINUE
C
C     Dynamically allocate memory for interpolation arrays.
C
      NJPR=17
      NJPB=14
      IF (LITAL.AND.L12PNT) THEN
        NJPR=29
        NJPB=15
      ENDIF
      NBYTES = (NJPR*JPRLEN + NJPB*JPBYTES) * ILL
C
      IPPDLO0 = HIRLSM_USERSPACE_4_GET(NBYTES)
#ifdef hpR64
      IPPDLO0 = IPPDLO0/(1024*1024*1024*4)
#endif
      IF( IPPDLO0.EQ.0 ) THEN
        CALL INTLOG(JP_ERROR,
     X    FNAME//': Memory allocate fail',JPQUIET)
        HIRLSM = 8
        GOTO 900
      ENDIF
C
      IPPDLO1 = IPPDLO0 + (ILL*JPRLEN)
      IPPDLO2 = IPPDLO1 + (ILL*JPRLEN)
      IPPDLO3 = IPPDLO2 + (ILL*JPRLEN)
      IPPDLAT = IPPDLO3 + (ILL*JPRLEN)
      IPPWTS  = IPPDLAT + (ILL*JPRLEN)
      IPKSCHE = IPPWTS  + (12*ILL*JPRLEN)
      IPKLA   = IPKSCHE + (ILL*JPBYTES)
      IPNEIGH = IPKLA   + (ILL*JPBYTES)
      IF (LITAL.AND.L12PNT) THEN
        IPPWTSN  = IPNEIGH + (12*ILL*JPBYTES)
        IPKSCHEN = IPPWTSN  + (12*ILL*JPRLEN)
      ENDIF
C
C
C     -----------------------------------------------------------------|
C     Section 4.  Create the new land-sea mask
C     -----------------------------------------------------------------|
C
  400 CONTINUE
C
C     Create new land-sea mask if specification has changed
C
      LNEWSPC = .FALSE.
      IF( AREA(1).NE.OLDAREA(1) ) LNEWSPC = .TRUE.
      IF( AREA(2).NE.OLDAREA(2) ) LNEWSPC = .TRUE.
      IF( AREA(3).NE.OLDAREA(3) ) LNEWSPC = .TRUE.
      IF( AREA(4).NE.OLDAREA(4) ) LNEWSPC = .TRUE.
      IF( GRID(1).NE.OLDGRID(1) ) LNEWSPC = .TRUE.
      IF( GRID(2).NE.OLDGRID(2) ) LNEWSPC = .TRUE.
      IF( POLE(1).NE.OLDPOLE(1) ) LNEWSPC = .TRUE.
      IF( POLE(2).NE.OLDPOLE(2) ) LNEWSPC = .TRUE.
C
      IF( .NOT.LNEWSPC ) GOTO 500
C
      OLDAREA(1) = AREA(1)
      OLDAREA(2) = AREA(2)
      OLDAREA(3) = AREA(3)
      OLDAREA(4) = AREA(4)
      OLDGRID(1) = GRID(1)
      OLDGRID(2) = GRID(2)
      OLDPOLE(1) = POLE(1)
      OLDPOLE(2) = POLE(2)
C
C     Allocate memory for new land-sea mask
C
      INSIZE = NLEN*JPRLEN
      IPNEWLS = HIRLSM_USERSPACE_5_GET(INSIZE)
      IF( IPNEWLS.EQ.0 ) THEN
        CALL INTLOG(JP_ERROR,
     X    FNAME//': Memory allocation fail',JPQUIET)
        HIRLSM = 4
        GOTO 900
      ENDIF
C
C     Find neighbours.
C     (Note: 4-point scheme is used for land-sea mask interpolation).
C
      IRET = HNEI12(.FALSE.,NLEN,RLAT,RLON,KGAUSS,KPTS,GLATS,
     X              KSCHEME,PDLAT,PDLO0,PDLO1,PDLO2,PDLO3,KLA,NEIGH)
      IF( IRET.NE.0 ) THEN
        CALL INTLOG(JP_ERROR,
     X    FNAME//': HNEI12 failed to find neighbours',JPQUIET)
        HIRLSM = 9
        GOTO 900
      ENDIF
C
C     Perform the interpolation for the new land-sea mask.
C
      CALL HWTS12
     X  (NLEN,KSCHEME,KLA,PDLAT,GLATS,PDLO0,PDLO1,PDLO2,PDLO3,NEIGH,
     X   PWTS)
C
C     Calculate the interpolated grid point values
C
      DO LOOP = 1, NLEN
        IF( KSCHEME(LOOP).EQ.JP12PT ) THEN
          NEWLSM(LOOP) =
     X      OLDLSM(NEIGH( 1,LOOP)) * PWTS( 1,LOOP) +
     X      OLDLSM(NEIGH( 2,LOOP)) * PWTS( 2,LOOP) +
     X      OLDLSM(NEIGH( 3,LOOP)) * PWTS( 3,LOOP) +
     X      OLDLSM(NEIGH( 4,LOOP)) * PWTS( 4,LOOP) +
     X      OLDLSM(NEIGH( 5,LOOP)) * PWTS( 5,LOOP) +
     X      OLDLSM(NEIGH( 6,LOOP)) * PWTS( 6,LOOP) +
     X      OLDLSM(NEIGH( 7,LOOP)) * PWTS( 7,LOOP) +
     X      OLDLSM(NEIGH( 8,LOOP)) * PWTS( 8,LOOP) +
     X      OLDLSM(NEIGH( 9,LOOP)) * PWTS( 9,LOOP) +
     X      OLDLSM(NEIGH(10,LOOP)) * PWTS(10,LOOP) +
     X      OLDLSM(NEIGH(11,LOOP)) * PWTS(11,LOOP) +
     X      OLDLSM(NEIGH(12,LOOP)) * PWTS(12,LOOP)
C
        ELSE IF( KSCHEME(LOOP).EQ.JP4PT ) THEN
C
          NEWLSM(LOOP) =
     X      OLDLSM(NEIGH( 1,LOOP)) * PWTS( 1,LOOP) +
     X      OLDLSM(NEIGH( 2,LOOP)) * PWTS( 2,LOOP) +
     X      OLDLSM(NEIGH( 3,LOOP)) * PWTS( 3,LOOP) +
     X      OLDLSM(NEIGH( 4,LOOP)) * PWTS( 4,LOOP)
C
C
        ELSE
          DO NEXT = 1, 4
            IF( NEIGH(NEXT,LOOP).NE.0 )
     X        NEWLSM(LOOP) = OLDLSM(NEIGH(NEXT,LOOP))
          ENDDO
C
        ENDIF
C
      ENDDO

C
C     -----------------------------------------------------------------|
C     Section 5.  Perform the 12-point horizontal interpolation.
C     -----------------------------------------------------------------|
C
  500 CONTINUE
C
C     Fin neighbours.
C
      IRET = HNEI12(L12PNT,NLEN,RLAT,RLON,KGAUSS,KPTS,GLATS,
     X              KSCHEME,PDLAT,PDLO0,PDLO1,PDLO2,PDLO3,KLA,NEIGH)
      IF( IRET.NE.0 ) THEN
        CALL INTLOG(JP_ERROR,
     X    FNAME//': HNEI12 failed to find neighbours',JPQUIET)
        HIRLSM = 5
        GOTO 900
      ENDIF
C
C     Setup the 12-point horizontal interpolation weights
C
      CALL HWTSLSM
     X  (NLEN,KSCHEME,KLA,PDLAT,GLATS,PDLO0,PDLO1,PDLO2,PDLO3,NEIGH,
     X   OLDLSM,NEWLSM,PWTS)
C
C     Calculate the interpolated grid point values
C
      IF (LITAL.AND.L12PNT) THEN
        DO LOOP = 1, NLEN
          IF (KSCHEME(LOOP).EQ.JP12PT) THEN
            KSCHEMEN(LOOP)=JP4PT
          ELSE
            KSCHEMEN(LOOP)=KSCHEME(LOOP)
          ENDIF
        ENDDO
        CALL HWTSLSM
     X  (NLEN,KSCHEMEN,KLA,PDLAT,GLATS,PDLO0,PDLO1,PDLO2,PDLO3,NEIGH,
     X   OLDLSM,NEWLSM,PWTSN)
      ENDIF

      DO LOOP = 1, NLEN
        IF( KSCHEME(LOOP).EQ.JP12PT ) THEN
C
C     See if any of the neighbours are missing
C
          COUNT = 0
          IF( NOTEQ(OLD(NEIGH( 1,LOOP)),RMISSGV) ) COUNT = COUNT + 1
          IF( NOTEQ(OLD(NEIGH( 2,LOOP)),RMISSGV) ) COUNT = COUNT + 1
          IF( NOTEQ(OLD(NEIGH( 3,LOOP)),RMISSGV) ) COUNT = COUNT + 1
          IF( NOTEQ(OLD(NEIGH( 4,LOOP)),RMISSGV) ) COUNT = COUNT + 1
          IF( NOTEQ(OLD(NEIGH( 5,LOOP)),RMISSGV) ) COUNT = COUNT + 1
          IF( NOTEQ(OLD(NEIGH( 6,LOOP)),RMISSGV) ) COUNT = COUNT + 1
          IF( NOTEQ(OLD(NEIGH( 7,LOOP)),RMISSGV) ) COUNT = COUNT + 1
          IF( NOTEQ(OLD(NEIGH( 8,LOOP)),RMISSGV) ) COUNT = COUNT + 1
          IF( NOTEQ(OLD(NEIGH( 9,LOOP)),RMISSGV) ) COUNT = COUNT + 1
          IF( NOTEQ(OLD(NEIGH(10,LOOP)),RMISSGV) ) COUNT = COUNT + 1
          IF( NOTEQ(OLD(NEIGH(11,LOOP)),RMISSGV) ) COUNT = COUNT + 1
          IF( NOTEQ(OLD(NEIGH(12,LOOP)),RMISSGV) ) COUNT = COUNT + 1
C
C         Interpolate using twelve neighbours if none are missing
C
        IF( LVEGGY) THEN
            NEAREST = 1
            IF( PWTS( 2,LOOP).GT.PWTS(NEAREST,LOOP) ) NEAREST = 2
            IF( PWTS( 3,LOOP).GT.PWTS(NEAREST,LOOP) ) NEAREST = 3
            IF( PWTS( 4,LOOP).GT.PWTS(NEAREST,LOOP) ) NEAREST = 4
            IF( PWTS( 5,LOOP).GT.PWTS(NEAREST,LOOP) ) NEAREST = 5
            IF( PWTS( 6,LOOP).GT.PWTS(NEAREST,LOOP) ) NEAREST = 6
            IF( PWTS( 7,LOOP).GT.PWTS(NEAREST,LOOP) ) NEAREST = 7
            IF( PWTS( 8,LOOP).GT.PWTS(NEAREST,LOOP) ) NEAREST = 8
            IF( PWTS( 9,LOOP).GT.PWTS(NEAREST,LOOP) ) NEAREST = 9
            IF( PWTS(10,LOOP).GT.PWTS(NEAREST,LOOP) ) NEAREST =10
            IF( PWTS(11,LOOP).GT.PWTS(NEAREST,LOOP) ) NEAREST =11
            IF( PWTS(12,LOOP).GT.PWTS(NEAREST,LOOP) ) NEAREST =12
            NEWFLD(LOOP) = OLD(NEIGH( NEAREST,LOOP))
        ELSE IF( LSOIL ) THEN
          IF(NEWLSM(LOOP).GE.0.5)THEN
            NEAREST = 1
            IF( PWTS( 2,LOOP).GT.PWTS(NEAREST,LOOP) .AND.
     X        (OLDLSM(NEIGH( 2,LOOP)).GE.0.5)) NEAREST =  2
            IF( PWTS( 3,LOOP).GT.PWTS(NEAREST,LOOP) .AND.
     X        (OLDLSM(NEIGH( 3,LOOP)).GE.0.5)) NEAREST =  3
            IF( PWTS( 4,LOOP).GT.PWTS(NEAREST,LOOP) .AND.
     X        (OLDLSM(NEIGH( 4,LOOP)).GE.0.5)) NEAREST =  4
            IF( PWTS( 5,LOOP).GT.PWTS(NEAREST,LOOP) .AND.
     X        (OLDLSM(NEIGH( 5,LOOP)).GE.0.5)) NEAREST =  5
            IF( PWTS( 6,LOOP).GT.PWTS(NEAREST,LOOP) .AND.
     X        (OLDLSM(NEIGH( 6,LOOP)).GE.0.5)) NEAREST =  6
            IF( PWTS( 7,LOOP).GT.PWTS(NEAREST,LOOP) .AND.
     X        (OLDLSM(NEIGH( 7,LOOP)).GE.0.5)) NEAREST =  7
            IF( PWTS( 8,LOOP).GT.PWTS(NEAREST,LOOP) .AND.
     X        (OLDLSM(NEIGH( 8,LOOP)).GE.0.5)) NEAREST =  8
            IF( PWTS( 9,LOOP).GT.PWTS(NEAREST,LOOP) .AND.
     X        (OLDLSM(NEIGH( 9,LOOP)).GE.0.5)) NEAREST =  9
            IF( PWTS(10,LOOP).GT.PWTS(NEAREST,LOOP) .AND.
     X        (OLDLSM(NEIGH(10,LOOP)).GE.0.5)) NEAREST = 10
            IF( PWTS(11,LOOP).GT.PWTS(NEAREST,LOOP) .AND.
     X        (OLDLSM(NEIGH(11,LOOP)).GE.0.5)) NEAREST = 11
            IF( PWTS(12,LOOP).GT.PWTS(NEAREST,LOOP) .AND.
     X        (OLDLSM(NEIGH(12,LOOP)).GE.0.5)) NEAREST = 12
          ELSE
            NEAREST = 1
            IF( PWTS( 2,LOOP).GT.PWTS(NEAREST,LOOP) .AND.
     X        (OLDLSM(NEIGH( 2,LOOP)).LT.0.5)) NEAREST =  2
            IF( PWTS( 3,LOOP).GT.PWTS(NEAREST,LOOP) .AND.
     X        (OLDLSM(NEIGH( 3,LOOP)).LT.0.5)) NEAREST =  3
            IF( PWTS( 4,LOOP).GT.PWTS(NEAREST,LOOP) .AND.
     X        (OLDLSM(NEIGH( 4,LOOP)).LT.0.5)) NEAREST =  4
            IF( PWTS( 5,LOOP).GT.PWTS(NEAREST,LOOP) .AND.
     X        (OLDLSM(NEIGH( 5,LOOP)).LT.0.5)) NEAREST =  5
            IF( PWTS( 6,LOOP).GT.PWTS(NEAREST,LOOP) .AND.
     X        (OLDLSM(NEIGH( 6,LOOP)).LT.0.5)) NEAREST =  6
            IF( PWTS( 7,LOOP).GT.PWTS(NEAREST,LOOP) .AND.
     X        (OLDLSM(NEIGH( 7,LOOP)).LT.0.5)) NEAREST =  7
            IF( PWTS( 8,LOOP).GT.PWTS(NEAREST,LOOP) .AND.
     X        (OLDLSM(NEIGH( 8,LOOP)).LT.0.5)) NEAREST =  8
            IF( PWTS( 9,LOOP).GT.PWTS(NEAREST,LOOP) .AND.
     X        (OLDLSM(NEIGH( 9,LOOP)).LT.0.5)) NEAREST =  9
            IF( PWTS(10,LOOP).GT.PWTS(NEAREST,LOOP) .AND.
     X        (OLDLSM(NEIGH(10,LOOP)).LT.0.5)) NEAREST = 10
            IF( PWTS(11,LOOP).GT.PWTS(NEAREST,LOOP) .AND.
     X        (OLDLSM(NEIGH(11,LOOP)).LT.0.5)) NEAREST = 11
            IF( PWTS(12,LOOP).GT.PWTS(NEAREST,LOOP) .AND.
     X        (OLDLSM(NEIGH(12,LOOP)).LT.0.5)) NEAREST = 12
          ENDIF
            NEWFLD(LOOP) = OLD(NEIGH( NEAREST,LOOP))
        ELSE
          IF( COUNT.EQ.12 .AND..NOT.LVEGGY2) THEN
            NEWFLD(LOOP) =
     X        OLD(NEIGH( 1,LOOP)) * PWTS( 1,LOOP) +
     X        OLD(NEIGH( 2,LOOP)) * PWTS( 2,LOOP) +
     X        OLD(NEIGH( 3,LOOP)) * PWTS( 3,LOOP) +
     X        OLD(NEIGH( 4,LOOP)) * PWTS( 4,LOOP) +
     X        OLD(NEIGH( 5,LOOP)) * PWTS( 5,LOOP) +
     X        OLD(NEIGH( 6,LOOP)) * PWTS( 6,LOOP) +
     X        OLD(NEIGH( 7,LOOP)) * PWTS( 7,LOOP) +
     X        OLD(NEIGH( 8,LOOP)) * PWTS( 8,LOOP) +
     X        OLD(NEIGH( 9,LOOP)) * PWTS( 9,LOOP) +
     X        OLD(NEIGH(10,LOOP)) * PWTS(10,LOOP) +
     X        OLD(NEIGH(11,LOOP)) * PWTS(11,LOOP) +
     X        OLD(NEIGH(12,LOOP)) * PWTS(12,LOOP)
C
C         Set missing if all neighbours are missing
C
          ELSE IF( COUNT.EQ.0 .AND..NOT.LVEGGY2) THEN
            NEWFLD(LOOP) = RMISSGV
C
C         Otherwise, use the nearest neighbour
C
          ELSE


      IF(LITAL)THEN
           NEAREST = 1
           IF(NEWLSM(LOOP).GE.0.5)THEN     !land point
            INUM=0
            DO NEXT=1,4
              IF(OLDLSM(NEIGH( NEXT,LOOP)).GE.0.5)THEN
                INUM=INUM+1
                IF( INUM.GE.2)THEN
                  IF(PWTSN( NEXT,LOOP).GT.PWTSN(NEAREST,LOOP)) THEN
                    NEAREST = NEXT
                  ENDIF
                ELSEIF( INUM.EQ.1) THEN
                  NEAREST = NEXT
                ENDIF
              ENDIF
            ENDDO

            ELSE  !sea point

            INUM=0
            DO NEXT=1,4
              IF(OLDLSM(NEIGH( NEXT,LOOP)).LT.0.5)THEN
                INUM=INUM+1
                IF( INUM.GE.2)THEN
                  IF(PWTSN( NEXT,LOOP).GT.PWTSN(NEAREST,LOOP)) THEN
                    NEAREST = NEXT
                  ENDIF
                ELSEIF( INUM.EQ.1) THEN
                  NEAREST = NEXT
                ENDIF
              ENDIF
            ENDDO

            ENDIF  !end if sea/land
       ELSE
            NEAREST = 1
            IF( PWTS( 2,LOOP).GT.PWTS(NEAREST,LOOP) ) NEAREST = 2
            IF( PWTS( 3,LOOP).GT.PWTS(NEAREST,LOOP) ) NEAREST = 3
            IF( PWTS( 4,LOOP).GT.PWTS(NEAREST,LOOP) ) NEAREST = 4
            IF( PWTS( 5,LOOP).GT.PWTS(NEAREST,LOOP) ) NEAREST = 5
            IF( PWTS( 6,LOOP).GT.PWTS(NEAREST,LOOP) ) NEAREST = 6
            IF( PWTS( 7,LOOP).GT.PWTS(NEAREST,LOOP) ) NEAREST = 7
            IF( PWTS( 8,LOOP).GT.PWTS(NEAREST,LOOP) ) NEAREST = 8
            IF( PWTS( 9,LOOP).GT.PWTS(NEAREST,LOOP) ) NEAREST = 9
            IF( PWTS(10,LOOP).GT.PWTS(NEAREST,LOOP) ) NEAREST =10
            IF( PWTS(11,LOOP).GT.PWTS(NEAREST,LOOP) ) NEAREST =11
            IF( PWTS(12,LOOP).GT.PWTS(NEAREST,LOOP) ) NEAREST =12
       ENDIF

            NEWFLD(LOOP) = OLD(NEIGH( NEAREST,LOOP))

          ENDIF
        ENDIF
C
        ELSE IF( KSCHEME(LOOP).EQ.JP4PT ) THEN
C
C     See if any of the neighbours are missing
C
          COUNT = 0
          IF( NOTEQ(OLD(NEIGH( 1,LOOP)),RMISSGV) ) COUNT = COUNT + 1
          IF( NOTEQ(OLD(NEIGH( 2,LOOP)),RMISSGV) ) COUNT = COUNT + 1
          IF( NOTEQ(OLD(NEIGH( 3,LOOP)),RMISSGV) ) COUNT = COUNT + 1
          IF( NOTEQ(OLD(NEIGH( 4,LOOP)),RMISSGV) ) COUNT = COUNT + 1
C
C         Interpolate using four neighbours if none are missing
C
        IF( LVEGGY) THEN

            NEAREST = 1
            IF( PWTS( 2,LOOP).GT.PWTS(NEAREST,LOOP) ) NEAREST = 2
            IF( PWTS( 3,LOOP).GT.PWTS(NEAREST,LOOP) ) NEAREST = 3
            IF( PWTS( 4,LOOP).GT.PWTS(NEAREST,LOOP) ) NEAREST = 4
            NEWFLD(LOOP) = OLD(NEIGH( NEAREST,LOOP))

        ELSE IF( LSOIL ) THEN

          IF(NEWLSM(LOOP).GE.0.5)THEN
C           land point
            NEAREST = 1
            IF( PWTS( 2,LOOP).GT.PWTS(NEAREST,LOOP) .AND.
     X        (OLDLSM(NEIGH( 2,LOOP)).GE.0.5)) NEAREST = 2
            IF( PWTS( 3,LOOP).GT.PWTS(NEAREST,LOOP) .AND.
     X        (OLDLSM(NEIGH( 3,LOOP)).GE.0.5)) NEAREST = 3
            IF( PWTS( 4,LOOP).GT.PWTS(NEAREST,LOOP) .AND.
     X        (OLDLSM(NEIGH( 4,LOOP)).GE.0.5)) NEAREST = 4
          ELSE
C           sea point
            NEAREST = 1
            IF( PWTS( 2,LOOP).GT.PWTS(NEAREST,LOOP) .AND.
     X        (OLDLSM(NEIGH( 2,LOOP)).LT.0.5)) NEAREST = 2
            IF( PWTS( 3,LOOP).GT.PWTS(NEAREST,LOOP) .AND.
     X        (OLDLSM(NEIGH( 3,LOOP)).LT.0.5)) NEAREST = 3
            IF( PWTS( 4,LOOP).GT.PWTS(NEAREST,LOOP) .AND.
     X        (OLDLSM(NEIGH( 4,LOOP)).LT.0.5)) NEAREST = 4
          ENDIF
          NEWFLD(LOOP) = OLD(NEIGH( NEAREST,LOOP))

        ELSE

          IF( COUNT.EQ.4 .AND. .NOT.LVEGGY2) THEN
            NEWFLD(LOOP) =
     X        OLD(NEIGH( 1,LOOP)) * PWTS( 1,LOOP) +
     X        OLD(NEIGH( 2,LOOP)) * PWTS( 2,LOOP) +
     X        OLD(NEIGH( 3,LOOP)) * PWTS( 3,LOOP) +
     X        OLD(NEIGH( 4,LOOP)) * PWTS( 4,LOOP)
C
C         Set missing if all neighbours are missing
C
          ELSE IF( COUNT.EQ.0 .AND. .NOT.LVEGGY2) THEN
            NEWFLD(LOOP) = RMISSGV
C
C         Otherwise, use the nearest neighbour
C
          ELSE

            IF(LITAL)THEN

              IF(NEWLSM(LOOP).GE.0.5)THEN
C               land point
                NEAREST = 1
                INUM=0
                DO NEXT=1,4
                  IF(OLDLSM(NEIGH( NEXT,LOOP)).GE.0.5)THEN
                    INUM=INUM+1
                    IF( INUM.GE.2)THEN
                      IF(PWTS( NEXT,LOOP).GT.PWTS(NEAREST,LOOP)) THEN
                        NEAREST = NEXT
                      ENDIF
                    ELSEIF( INUM.EQ.1) THEN
                      NEAREST = NEXT
                    ENDIF
                  ENDIF
                ENDDO
              ELSE
C               sea point
                NEAREST = 1
                INUM=0
                DO NEXT=1,4
                  IF(OLDLSM(NEIGH( NEXT,LOOP)).LT.0.5)THEN
                    INUM=INUM+1
                    IF( INUM.GE.2)THEN
                      IF(PWTS( NEXT,LOOP).GT.PWTS(NEAREST,LOOP)) THEN
                        NEAREST = NEXT
                      ENDIF
                    ELSEIF( INUM.EQ.1) THEN
                      NEAREST = NEXT
                    ENDIF
                  ENDIF
                ENDDO
              ENDIF

            ELSE

c             (.NOT. LITAL)
              NEAREST = 1
              IF( PWTS( 2,LOOP).GT.PWTS(NEAREST,LOOP) ) NEAREST = 2
              IF( PWTS( 3,LOOP).GT.PWTS(NEAREST,LOOP) ) NEAREST = 3
              IF( PWTS( 4,LOOP).GT.PWTS(NEAREST,LOOP) ) NEAREST = 4

            ENDIF

            NEWFLD(LOOP) = OLD(NEIGH( NEAREST,LOOP))
          ENDIF
       ENDIF
C
        ELSE
          DO NEXT = 1, 4
            IF( NEIGH(NEXT,LOOP).NE.0 )
     X        NEWFLD(LOOP) = OLD(NEIGH(NEXT,LOOP))
          ENDDO
C
        ENDIF
C
C       Remove precipitation if less than a 'trace' or if nearest
C       neighbour is less than a trace
C
        IF( LPREC ) THEN
          IF( NEWFLD(LOOP).LT.ZPRECIP ) THEN
            NEWFLD(LOOP) = 0.0
          ELSE
            NEAREST = 1
            NEND = 12
            IF( KSCHEME(LOOP).NE.JP12PT ) NEND = 4
            DO NEXT = 2, NEND
              IF( PWTS( NEXT,LOOP).GT.PWTS( NEAREST,LOOP) )
     X          NEAREST = NEXT
            ENDDO
            IF( OLD(NEIGH(NEAREST,LOOP)).LT.ZPRECIP ) NEWFLD(LOOP) = 0.0
          ENDIF
        ENDIF
C
C       For sea-ice cover, ensure no values are outside the range (0,1)
C
        IF( (NIPARAM.EQ.31).AND.(NITABLE.EQ.128) ) THEN
          IF( NOTEQ( NEWFLD(LOOP),RMISSGV) ) THEN
            IF( NEWFLD(LOOP).GT.1.0 ) NEWFLD(LOOP) = 1.0
            IF( NEWFLD(LOOP).LT.0.0 ) NEWFLD(LOOP) = 0.0
          ENDIF
        ENDIF
      ENDDO
C
C     -----------------------------------------------------------------|
C     Section 9.  Return.
C     -----------------------------------------------------------------|
C
  900 CONTINUE
      RETURN
      END

C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      INTEGER FUNCTION IGSIZE(KGTRUNC, KAREA, KNWE, KNNS, KLN,
     X   PGAUSS, OWEGLOBE, ONPOLE, OSPOLE, KPR, KERR)
C
C---->
C**** *IGSIZE*
C
C     Purpose
C     -------
C     Evaluate the array sizes for a Gaussian truncation and area.
C
C
C     Interface
C     ---------
C     IERR = IGSIZE(KGTRUNC, KAREA, KNWE, KNNS, KLN,
C    X              PGAUSS, OWEGLOBE, ONPOLE, OSPOLE, KPR, KERR)
C
C
C     Input parameters
C     ----------------
C     KGTRUNC - The Gaussian truncation.
C     KAREA   - The field area definition (N, W, S, E) provided by
C               the calling routine.
C     KNWE    - The number of points in the West-East direction in
C               the field. This will be zero for an output field.
C     KNNS    - The number of points in the North-South direction
C               in the field. This will be zero for an output field.
C     KPR     - The debug print switch.
C                0  , No debugging output.
C                1  , Produce debugging output.
C     KERR    - The error control flag.
C                -ve, No error message. Return error code.
C                0  , Hard failure with error message.
C                +ve, Print error message. Return error code.
C
C
C     Output parameters
C     -----------------
C     KAREA    - The North and South values will be modified to
C                contain the values of the Gaussian latitudes used.
C     KNWE     - The number of points in the West-East direction in
C                the field.
C     KNNS     - The number of points in the North-South direction
C                in the field.
C     KLN      - The Northern Gaussian latitude number for this area.
C     PGAUSS   - The full list of Gaussian latitudes for this
C                truncation.
C     OWEGLOBE - This variable will be true if the array of
C                longitudes spans the globe.
C     ONPOLE   - This variable will be true if the North polar line
C                of latitude is included in the grid.
C     OSPOLE   - This variable will be true if the South polar line
C                of latitude is included in the grid.
C
C
C     Return value
C     ------------
C     The error indicator (INTEGER).
C
C
C     Error and Warning Return Values
C     -------------------------------
C     -1 The Eastern limit of the range did not have the expected
C        value. The Western value will be assumed to be correct. This
C        could arise because of known deficiencies in the GRIB
C        representation and will be treated as a WARNING error.
C
C     22501 The specified number of lines of latitude did not match
C           the Gaussian lines nearest the North and South values
C           provided.
C
C
C     Common block usage
C     ------------------
C     None
C
C
C     Externals
C     ---------
C     IGGLAT   - Compute Gaussian lines of latitude for a given
C                truncation.
C     INTLOG(R) - Logs messages.
C
C
C     Method
C     ------
C     If all the elements of the array KAREA are zero then a standard
C     global grid is generated and all elements of the array KAREA are
C     rewritten with the appropriate values. Otherwise it is assumed
C     that the West and East limits in KAREA have been validated. If
C     the number of longitude points is provided a warning will be
C     given if the West to East range does not match the number of
C     longitude points times the stride.
C
C     If the number of lines of longitude and latitude are not set on
C     entry then the North and South limits in KAREA will be expanded
C     outward to the next Gaussian latitudes. If the number of lines
C     of longitude and latitude are set on entry then the nearest
C     points to the North and South limits provided are chosen. It is
C     an error if these points do not provide the correct number of
C     latitudes. The revised North and South limits are written back
C     into the array KAREA.
C
C
C     Reference
C     ---------
C     None
C
C
C     Comments
C     --------
C     None
C
C
C     Author
C     ------
C     K. Fielding      *ECMWF*      Oct 1993
C
C
C     Modifications
C     -------------
C     Allow for unusual NCEP gaussian grids
C     J.D.Chambers   ECMWF   October 2000
C
C----<
C     -----------------------------------------------------------------|
C*    Section 0. Definition of variables.
C     -----------------------------------------------------------------|
C
      IMPLICIT NONE
C
#include "parim.h"
C
C     Parameters
C
      INTEGER JPROUTINE
      PARAMETER(JPROUTINE = 22500)
C
C     Function arguments
C
      LOGICAL OWEGLOBE, ONPOLE, OSPOLE
      INTEGER KGTRUNC, KNWE, KNNS, KLN, KPR, KERR, KAREA(4)
      REAL PGAUSS(*)
C
C     Local variables
C
      INTEGER ILNSTR, IEAST, IWEST, IREACH, ILATNUM, IGAUSS
      INTEGER INDIST, ISDIST, ILS, IERR, JLAT
      LOGICAL LPRINT
C
C     Function externals
C
      INTEGER IGGLAT
C
C     -----------------------------------------------------------------|
C*    Section 1. Initialisation
C     -----------------------------------------------------------------|
C
  100 CONTINUE
C
      IGSIZE = 0
      LPRINT = KPR.GE.1
C
      IF( LPRINT ) THEN
        CALL INTLOG(JP_DEBUG,'IGSIZE: Section 1.',JPQUIET)
        CALL INTLOG(JP_DEBUG,'IGSIZE: Input parameters.',JPQUIET)
        CALL INTLOG(JP_DEBUG,'IGSIZE: Gaussian truncation = ',KGTRUNC)
        CALL INTLOG(JP_DEBUG,'IGSIZE: No.long pts = ',KNWE)
        CALL INTLOG(JP_DEBUG,'IGSIZE: No.lat. pts = ',KNNS)
        CALL INTLOG(JP_DEBUG,'IGSIZE: Area North = ',KAREA(1))
        CALL INTLOG(JP_DEBUG,'IGSIZE: Area West  = ',KAREA(2))
        CALL INTLOG(JP_DEBUG,'IGSIZE: Area South = ',KAREA(3))
        CALL INTLOG(JP_DEBUG,'IGSIZE: Area East  = ',KAREA(4))
      ENDIF
C
      ILNSTR = JP90 / KGTRUNC
      ILATNUM = KGTRUNC * 2
C
C     -----------------------------------------------------------------|
C*    Section 2. If all elements of KAREA are missing generate
C                a global field
C     -----------------------------------------------------------------|
C
  200 CONTINUE
C
      IF( LPRINT ) CALL INTLOG(JP_DEBUG,'IGSIZE: Section 2.',JPQUIET)
C
      IF( (KAREA(JPEAST).EQ.0) .AND.
     X    (KAREA(JPWEST).EQ.0) .AND.
     X    (KAREA(JPNORTH).EQ.0).AND.
     X    (KAREA(JPSOUTH).EQ.0) ) THEN
C
        KAREA(JPNORTH) = JP90
        KAREA(JPWEST)  = 0
        KAREA(JPSOUTH) = - JP90
        KAREA(JPEAST)  = JP360 - ILNSTR
C
      ENDIF
C
C     -----------------------------------------------------------------|
C*    Section 3. Generate points around a line of latitude.
C     -----------------------------------------------------------------|
C
  300 CONTINUE
C
      IF( LPRINT ) CALL INTLOG(JP_DEBUG,'IGSIZE: Section 3.',JPQUIET)
C
C     Force both KAREA(JPWEST) and KAREA(JPEAST) into standard
C     range (0 to JP360)
C
      IF( KAREA(JPWEST).LT.0 ) KAREA(JPWEST) = KAREA(JPWEST) + JP360
      IF( KAREA(JPEAST).LT.0 ) KAREA(JPEAST) = KAREA(JPEAST) + JP360
C
C     Standardise range so that EAST > WEST
C
      IEAST = KAREA(JPEAST)
      IWEST = KAREA(JPWEST)
C
      IF( IEAST.LT.IWEST ) THEN
        IF( IEAST.LT.0 ) THEN
          IEAST = IEAST + JP360
          KAREA(JPEAST) = IEAST
        ELSE
          IWEST = IWEST - JP360
          KAREA(JPWEST) = IWEST
        ENDIF
      ENDIF
C
      IF( KNWE.EQ.0 ) THEN
C
C       Is it a global grid ?
C
        IREACH   = IEAST - IWEST + ILNSTR
        OWEGLOBE = IREACH.GE.JP360
C
C       Number of points along line is
C
        KNWE = NINT( FLOAT(IREACH) / FLOAT(ILNSTR) )
C
      ELSE
C
C       Number of points is set (input field)
C
        IF( (IWEST + (KNWE - 1)*ILNSTR).NE.IEAST ) THEN
C
C         Warn of possible mismatch
C
          IGSIZE = - 1
          CALL INTLOG(JP_WARN,
     X      'IGSIZE: West-East range does not match the',JPQUIET)
          CALL INTLOG(JP_WARN,
     X      'IGSIZE: number of points and the stride.',JPQUIET)
          CALL INTLOGR(JP_WARN,
     X      'IGSIZE: West = ',REAL(KAREA(JPWEST))/PPMULT)
          CALL INTLOGR(JP_WARN,
     X      'IGSIZE: East = ',REAL(KAREA(JPEAST))/PPMULT)
          CALL INTLOG(JP_WARN,'IGSIZE: No. of points = ',KNWE)
          CALL INTLOGR(JP_WARN,'IGSIZE: Stride = ',REAL(ILNSTR)/PPMULT)
        ENDIF
C
C       NCEP products for DEMETER are pseudo gaussian
C       (regular N48 in longitude direction, N47 in latitude direction)
C
        OWEGLOBE = KNWE.GE.(KGTRUNC*4)
C
      ENDIF
C
C     -----------------------------------------------------------------|
C*    Section 4. Generate points along a line of meridian
C     -----------------------------------------------------------------|
C
  400 CONTINUE
C
      IF( LPRINT ) CALL INTLOG(JP_DEBUG,'IGSIZE: Section 4.',JPQUIET)
C
C     Generate full Gaussian latitudes for this truncation
C
      IERR = IGGLAT(ILATNUM, PGAUSS, KPR, KERR)
C
      IF( IERR.GT.0 ) THEN
        IGSIZE = IERR
        GOTO 900
      ENDIF
C
C     Find Gaussian lines corresponding to given North and South points
C
C     Number of lines not set (output field)
C
      IF( KNNS.EQ.0 ) THEN
        KLN = 0
        ILS = ILATNUM
C
        DO JLAT = 2, ILATNUM
          IGAUSS = NINT(PGAUSS(JLAT) * PPMULT)
C
          IF( (KLN.EQ.0).AND.((KAREA(JPNORTH)-IGAUSS).GT.1000) ) THEN
            KLN = JLAT - 1
            KAREA(JPNORTH) = NINT(PGAUSS(KLN) * PPMULT)
          ENDIF
C
          IF( (ILS.EQ.ILATNUM).AND.(KAREA(JPSOUTH).GE.IGAUSS) ) THEN
            ILS = JLAT
            KAREA(JPSOUTH) = NINT(PGAUSS(ILS) * PPMULT)
          ENDIF
        ENDDO
C
        KNNS = ILS - KLN + 1
C
      ELSE
C
C       Number of lines set (input field)
C
        KLN = 1
        ILS = 1
C
        INDIST = ABS(NINT(PGAUSS(1) * PPMULT) - KAREA(JPNORTH) )
        ISDIST = ABS(NINT(PGAUSS(1) * PPMULT) - KAREA(JPSOUTH) )
C
        DO JLAT = 2, ILATNUM
C
          IF( (ABS(NINT(PGAUSS(JLAT)*PPMULT) - KAREA(JPNORTH) ) )
     X         .LT.INDIST) THEN
            KLN    = JLAT
            INDIST = ABS(NINT(PGAUSS(JLAT) * PPMULT) - KAREA(JPNORTH) )
          ENDIF
C
          IF( (ABS(NINT(PGAUSS(JLAT)*PPMULT) - KAREA(JPSOUTH) ) )
     X         .LT.ISDIST) THEN
            ILS    = JLAT
            ISDIST = ABS(NINT(PGAUSS(JLAT) * PPMULT) - KAREA(JPSOUTH) )
          ENDIF
C
        ENDDO
C
        IF( KNNS.NE.(ILS - KLN + 1) ) THEN
          IGSIZE = JPROUTINE + 1
          IF( KERR.GE.0 ) THEN
            CALL INTLOG(JP_ERROR,
     X          'IGSIZE: No.of lines specified = ',KNNS)
            CALL INTLOG(JP_ERROR,
     X          'IGSIZE: does not match the',JPQUIET)
            CALL INTLOG(JP_ERROR,
     X          'IGSIZE: Gaussian line limits = ', KLN)
            CALL INTLOG(JP_ERROR,
     X          'IGSIZE: and ',ILS)
          ENDIF
          IF( KERR.EQ.0 ) CALL INTLOG(JP_FATAL,
     X        'Interpolation failed.', JPQUIET)
          GOTO 900
        ENDIF
C
      ENDIF
C
      ONPOLE = KLN.EQ.1
      OSPOLE = ILS.EQ.ILATNUM
C
      KAREA(JPNORTH) = NINT(PGAUSS(KLN) * PPMULT)
      KAREA(JPSOUTH) = NINT(PGAUSS(ILS) * PPMULT)
C
      IF( LPRINT ) THEN
        CALL INTLOG(JP_DEBUG,'IGSIZE: Output parameters.',JPQUIET)
        CALL INTLOG(JP_DEBUG,'IGSIZE: No.long pts = ',KNWE)
        CALL INTLOG(JP_DEBUG,'IGSIZE: No.lat. pts = ',KNNS)
        CALL INTLOG(JP_DEBUG,'IGSIZE: Stride along lat = ',ILNSTR)
        CALL INTLOG(JP_DEBUG,'IGSIZE: North line number = ',KLN)
        CALL INTLOG(JP_DEBUG,'IGSIZE: South line number = ',ILS)
        IF( OWEGLOBE ) THEN
          CALL INTLOG(JP_DEBUG,
     X      'IGSIZE: Field is global West-East.',JPQUIET)
        ELSE
          CALL INTLOG(JP_DEBUG,
     X      'IGSIZE: Field is NOT global West-East.',JPQUIET)
        ENDIF
        IF( ONPOLE ) THEN
          CALL INTLOG(JP_DEBUG,
     X      'IGSIZE: North Pole is in field.',JPQUIET)
        ELSE
          CALL INTLOG(JP_DEBUG,
     X      'IGSIZE: North Pole NOT is in field.',JPQUIET)
        ENDIF
        IF( OSPOLE ) THEN
          CALL INTLOG(JP_DEBUG,
     X      'IGSIZE: South Pole is in field.',JPQUIET)
        ELSE
          CALL INTLOG(JP_DEBUG,
     X      'IGSIZE: South Pole NOT is in field.',JPQUIET)
        ENDIF
      ENDIF
C
C     -----------------------------------------------------------------|
C*    Section 9. Return to calling routine. Format statements
C     -----------------------------------------------------------------|
C
  900 CONTINUE
C
      IF( LPRINT ) CALL INTLOG(JP_DEBUG,'IGSIZE: Section 9.',JPQUIET)
C
      RETURN
      END

C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE CREXS0( KBUFL,YBUFF,KSUP,KSEC0,KERR)
C
C**** *BUEXS0*
C
C
C     PURPOSE.
C     --------
C          Expands section 0 of Crex message. 
C
C
C**   INTERFACE.
C     ----------
C
C          *CALL* *CREXS0( KBUFL,YBUFF,KSUP,KSEC0,KERR)*
C
C        INPUT :
C               *KBUFL*   -  length of CREX message (words)
C               *YBUFF*   -  Character string containing Crex message
C        OUTPUT:
C               *KSUP*    -  Integer array of 9 words containing
C                            suplementary information
C                         -  KSUP( 1) -- IDIM1, dimension of KSEC1
C                         -  KSUP( 2) -- Reserved
C                         -  KSUP( 3) -- IDIM3, dimension of KSEC3
C                         -  KSUP( 4) -- Reserved
C                         -  KSUP( 5) -- M (number of elements in values
C                                           array, first index)
C                         -  KSUP( 6) -- N (number of subsets,second index
C                                           of values array)
C                         -  KSUP( 7) -- JVC (number of elements in CVAL array)
C                         -  KSUP( 8) -- total CREX message length in bytes
C                         -  KSUP( 9) -- IDIM0, dimension of KSEC0
C
C               *KSEC0*   -  array containing section 0 information
C                            KSEC0( 1)-- length of section 0 (bytes)
C                            KSEC0( 2)-- total length of CREX message (bytes)
C                            KSEC0( 3)-- Not used
C
C               *KERR*    -  returned error code
C
C     METHOD.
C     --------
C
C          NONE.
C
C     EXTERNALS.
C     ----------
C
C
C     REFERENCE.
C     ----------
C
C          NONE.
C
C     AUTHOR.
C     -------
C
C          MILAN DRAGOSAVAC    *ECMWF*       07/01/2004.
C
C
C     MODIFICATIONS.
C     --------------
C
C          NONE.
C
C
      IMPLICIT LOGICAL(L,O,G), CHARACTER*8(C,H,Y)
C
      COMMON /CREXWORK/ NBPT,NGS,NVIND,NBPTSEC2,RVIND,EPS,NE,IEOLD,
     1                  NC07YYY
C
      DIMENSION KSEC0(*)
      DIMENSION KSUP(*)
      CHARACTER*(*) YBUFF
C
      CHARACTER*4 YCREX
      REAL*8 RVIND,EPS
C
C     ------------------------------------------------------------------
C*          1.   EXPAND SECTION 0.
C                -----------------
 100  CONTINUE
C
      IF( KERR.NE.0 ) RETURN
C
      KSEC0(1)=4
      KSEC0(2)=KBUFL
      KSUP(8) =KBUFL
C
C*          1.1  INITIALIZE WORKING POINTERS NWPT AND NBPT.
C                ------------------------------------------
      NBPT = 1
C
C*          1.2  UNPACK FIRST FOUR OCTETS CONTAINING *CREX*.
C                -------------------------------------------
C
      IF(YBUFF(NBPT:NBPT+3).ne.'CREX') then
         KERR=1
         print*,'This bulletin is not CREX message.'
         RETURN
      END IF
C
C           1.2 Position pointer to begining of section1.
C               ---------------------------------------------
 120  CONTINUE
C
      NBPT=NBPT+4
      IF(NBPT.GT.KBUFL) THEN
         KERR=26
         print*,'CREXS0:'
         CALL CREXERR(KERR)
         RETURN
      END IF
C
      IRET=0
      CALL NEXTSEC(KBUFL,YBUFF,NBPT,NGS,KERR)
      IF(KERR.NE.0) THEN
         KERR=40
         print*,'NEXTSEC :' 
         CALL CREXERR(KERR)
         RETURN
      END IF
C
      CALL NEXTGRP(KBUFL,YBUFF,NBPT,NGS,KERR)
      IF(KERR.NE.0) THEN
         KERR=41
         print*,'NEXTGRP : '
         CALL CREXERR(KERR)
         RETURN
      END IF
C
      RETURN
C     -----------------------------------------------------------------
C
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE BUETDR(KJ,KJ1,KDD,KSTACK,KERR)
C
C**** *BUETDR*
C
C
C     PURPOSE.
C     --------
C          SOLVE BUFR TABLE D REFERENCE.
C
C
C**   INTERFACE.
C     ----------
C
C          *CALL* *BUETDR(KJ,KJ1,KDD,KSTACK,KERR)*
C
C        INPUT :
C                 *KDD*      - DATA DESCRIPTOR
C        OUTPUT:
C                 *KJ*       - POINTER TO KSTACK ARRAY
C                 *KJ1*      - POINTER TO LAST ELEMENT IN KSTACK
C                 *KSTACK*   - LIST OF DATA DESCRIPTORS
C                 *KERR*     - RETURN ERROR CODE
C
C
C     METHOD.
C     -------
C
C           NONE.
C
C     EXTERNALS.
C     ----------
C
C           NONE.
C
C     REFERENCE.
C     ----------
C
C          NONE.
C
C     AUTHOR.
C     -------
C
C          M. DRAGOSAVAC    *ECMWF*       01/02/91.
C
C
C     MODIFICATIONS.
C     --------------
C
C          NONE.
C
C
      IMPLICIT LOGICAL(L,O,G), CHARACTER*8(C,H,Y)
C
C
#     include "parameter.F"
#     include "bcomunit.F"
#     include "bcmwt.F"
#     include "bcmwtc.F"
#     include "bcmtab.F"
#     include "bcmtabc.F"
C
      CHARACTER CTABBEN*64,CTABBU*24
C
      DIMENSION ILIST(JELEM),KSTACK(*)
C
C     ------------------------------------------------------------------
C
C*          1.   OBTAIN LIST OF DESCRIPTORS FROM BUFR TABLE D.
C                ---------------------------------------------
 100  CONTINUE
C
      IF( KERR.NE.0 ) RETURN
C
      DO 110 J=1,JTAB
C
      IF(KDD.EQ.NTABDTR(J)) THEN
         I=J
         GO TO 120
      END IF
C
 110  CONTINUE
C
      KERR=20
      CALL BUERR(KERR)
      WRITE(KNTN,*)  'REFERENCE INVOLVED ',KDD
      RETURN
C
 120  CONTINUE
C
      J1=NTABDST(I)
      J2=NTABDL (I)
      J3=0
C
      DO 121 J=J1,J1+J2-1
C
      J3 = J3 +1
      ILIST(J3) = NTABDSQ(J)
C
 121  CONTINUE
C
C     ------------------------------------------------------------------
C*          2.  PUSH DOWN DATA DESCRIPTION DESCRIPTORS
C               --------------------------------------
C               TO MAKE ROOM FOR LIST.
C               ----------------------
 200  CONTINUE
C
      J2M1=J2-1
C
      DO 210 J=KJ1,KJ+1,-1
C
      KSTACK(J+J2M1) = KSTACK(J)
C
 210  CONTINUE
C
C     ------------------------------------------------------------------
C*          3.  INSERT LIST IN PLACE OF SEQUENCE DESCRIPTORS.
C               ---------------------------------------------
 300  CONTINUE
C
      KJM1=KJ-1
C
      DO 310 J=1,J3
C
      KSTACK(KJM1+J)= ILIST(J)
C
 310  CONTINUE
C
C     ------------------------------------------------------------------
C*          4.  ADJUST DESCRIPTOR COUNT FOR LIST LENGTH.
C               ----------------------------------------
 400  CONTINUE
C
      KJ  = KJ  - 1
      KJ1 = KJ1 +J3 -1
C     ------------------------------------------------------------------
C*          4.1  ADJUST NUMBER OF DATA DESCRIPTORS NOT PRESENT.
C                ----------------------------------------------
 610  CONTINUE
C
      IF(N221.NE.0)  N221= KJ1  - KJ + 1
C     -----------------------------------------------------------------
 500  CONTINUE
C
      RETURN
C
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE INSMP2 (KGRIB,KLENG,KMAP2,PSEC4,KSIZE,KBITS,
     X                     PMISS,HFUNC,KNUM,KPR,KRET)
C
C---->
C**** INSMP2 - Insertion of secondary bit maps for routine GRIBEX.
C
C     Purpose.
C     --------
C
C     Generates secondary bit-maps (Section 4 bit-maps) and
C     inserts in array of GRIB coded data.
C
C**   Interface.
C     ----------
C
C     CALL INSMP2 (KGRIB,KLENG,KMAP2,PSEC4,KSIZE,KBITS,
C    X                     PMISS,HFUNC,KNUM,KPR,KRET)
C
C
C     Input Parameters.
C     -----------------
C
C     KGRIB      - Array into which data is being packed in GRIB code.
C
C     KLENG      - Length of this array.
C
C     KMAP2      - Bit-pointer to start of secondary bit maps
C                  (Section 4 bitmaps) in array KGRIB.
C
C     PSEC4      - Array of data values to be packed in
C                  GRIB code, containing missing data
C                  indicator PMISS where appropriate.
C
C     KSIZE      - Number of values, including missing data
C                  values, in array PSEC4.
C
C     KBITS      - Number of bits in computer word.
C
C     PMISS      - Value indicating missing data in array PSEC4.
C
C     HFUNC      - 'C' , GRIB data packed normally.
C                  'M' , GRIB data being packed in fixed length messages
C
C     KNUM       - Number of values at each grid point.
C
C     KPR        - Debug print switch.
C                  0  , No printout.
C                  >0 , Debug printout.
C
C     Output Parameters.
C     ------------------
C
C     KSIZE      - The number of data values remaining in
C                  array PSEC4 to be packed.
C
C     KRET       - Return code.
C                  0 , No error encountered.
C                  1 , Error in routine INXBIT.
#if (!defined VAX)
C                  2 , Memory allocation problem.
C                  3 , Memory deallocation problem.
#else
C                  4 , (VAX only) Number of values at each grid point
C                      (KNUM) is greater than allowed (JPWORK).
#endif
C
C     Method.
C     -------
C
C     The bit-map contains 1 where valid data exists and 0
C     where data is missing. The corresponding data array
C     contains valid data and the missing data indicator value.
C
C     Externals.
C     ----------
C
C     INXBIT
C
C     Reference.
C     ----------
C
C     See routine GRIBEX.
C
C     Comments.
C     ---------
C
C     None.
C
C     Author.
C     -------
C
C     J. Hennessy      ECMWF      09:07:92
C
C     Modifications.
C     --------------
C
C     J. Hennessy      ECMWF      19:10:92
C     Maximum sizes increased to allow for packing of
C     2D spectra.
C     Number of data values 120*61*12*25
C
C     J.D.Chambers     ECMWF      09:03:94
C     Maximum size for bitmap array increased to 132000
C     to allow for products 0.5 * 0.5 degrees, whole
C     hemisphere (N or S).
C
C     J.D.Chambers     ECMWF      24:05:95
C     Handle bitmap in strips to avoid problem with very large products
C
C     J.D.Chambers     ECMWF        Feb 1997
C     Allow for 64-bit pointers
C
C     J.D.Chambers     ECMWF        April 1998
C     Remove dynamic allocation of work array
C
C     J. Clochard, Meteo France, for ECMWF - January 1998.
C     Strips size (JPWORK) enlarged to 10000.
C
C----<
C     ------------------------------------------------------------------
C*    Section 0 . Definition of variables. Data statements.
C     ------------------------------------------------------------------
C
      IMPLICIT NONE
C
#include "common/grprs.h"
C
C     Parameters
C
      INTEGER JPWORK
      PARAMETER (JPWORK=10000)
C
C     Subroutine arguments
C
      INTEGER KBITS, KGRIB, KLENG, KMAP2, KNUM, KPR, KRET, KSIZE
      DIMENSION KGRIB(*)
      REAL PMISS, PSEC4
      DIMENSION PSEC4(*)
      CHARACTER*(*) HFUNC
C
C     Local variables
C
      INTEGER NEXTIN, NXTOUT, IPT, ITEMP
      INTEGER JLOOP, JLOOPI
      INTEGER LENGTH
      REAL VALUE
C
C     Work array.
C
      INTEGER IMAP2
      DIMENSION IMAP2(JPWORK)
C
C     ------------------------------------------------------------------
C*    Section 1 . Set initial values.
C     ------------------------------------------------------------------
C
  100 CONTINUE
C
      IF( KPR.GE.1 ) THEN
        WRITE(GRPRSM,*) 'INSMP2: Section 1.'
        WRITE(GRPRSM,*) '         Input values used -'
        WRITE(GRPRSM,*) '         HFUNC  = ', HFUNC
        WRITE(GRPRSM,*) '         KSIZE  = ', KSIZE
        WRITE(GRPRSM,*) '         KNUM   = ', KNUM 
      ENDIF
C
C     Reset return code to
      KRET  = 0
C
C     ------------------------------------------------------------------
C*    Section 2 .  Check input parameters.
C     ------------------------------------------------------------------
C
  200 CONTINUE
C
      IF( KPR.GE.1 ) WRITE(GRPRSM,*) 'INSMP2: Section 2.'
C
C*    Check function requested.
C
      IF( (HFUNC.NE.'C').AND.(HFUNC.NE.'M') ) THEN
        WRITE(GRPRSM,*) 'INSMP2: Invalid function requested - ', HFUNC
        KRET = 3
        GO TO 900
      ENDIF
C
      LENGTH = KNUM
C
C     Check there is enough space for packing secondary bitmap
C
      IF( LENGTH.GT.JPWORK ) THEN
        WRITE(GRPRSM,*) 'INSMP2: Number of values at each grid point'
        WRITE(GRPRSM,*)
     X    'INSMP2: (KNUM) is greater than allowed (JPWORK).'
        KRET = 4
        GOTO 900
      ENDIF
C
C     ------------------------------------------------------------------
C*    Section 3 . Generation of bit-map.
C    -------------------------------------------------------------------
C
  300 CONTINUE
C
      IF( KPR.GE.1 ) WRITE(GRPRSM,*) 'INSMP2: Section 3.'
C
      NEXTIN = 0
      NXTOUT = 0
C
C*    Generate the bit-map in accordance with the missing data
C     values.
C
      DO 320 JLOOP = 1, KSIZE, KNUM
        IPT = 0
C
        DO 310 JLOOPI = 1, KNUM
C
          IF (PSEC4(JLOOPI+NEXTIN).EQ.PMISS) THEN
C
C           If missing data indicator, set secondary bitmap flag to 0
C
            IMAP2(IPT+JLOOPI) = 0
C
          ELSE
C
C           If not missing, set secondary bitmap flag to 1 and
C           move data forwards in data array.
C
            IMAP2(IPT+JLOOPI) = 1
            NXTOUT            = NXTOUT + 1
            PSEC4(NXTOUT)     = PSEC4(NEXTIN+JLOOPI)
          ENDIF
  310   CONTINUE
        IPT = IPT + KNUM
C
C*      Insert bit-map in GRIB coded data.
C
        CALL INXBIT(KGRIB,KLENG,KMAP2,IMAP2,KNUM,KBITS,1,'C',KRET)
        IF (KRET.NE.0) THEN
          WRITE(GRPRSM,9003)
          KRET = 1
          GO TO 900
        ENDIF
C
        NEXTIN = NEXTIN + KNUM
C
  320 CONTINUE
C
C*    Bit map must be a multiple of 8 bits.
C
      ITEMP = (KMAP2+7) / 8
      ITEMP = ITEMP * 8
      IF (ITEMP.NE.KMAP2) THEN
        IMAP2(1) = 0
        ITEMP = ITEMP - KMAP2
        CALL INXBIT(KGRIB,KLENG,KMAP2,IMAP2,1,KBITS,ITEMP,'C',KRET)
        IF (KRET.NE.0) THEN
          WRITE(GRPRSM,9003)
          KRET = 1
          GO TO 900
        ENDIF
      ENDIF
C
C     Is a fixed length message required, even though a bit map is used?
C
      IF (HFUNC.EQ.'M') THEN
C
C       The otherwise unused part of the array is set to a genuine data
C       value so that extraction of minimum and maximum values remain
C       correct. Number of data values includes these padding values.
C
        VALUE = PSEC4(1)
        DO 330 JLOOP = NXTOUT+1, KSIZE
          PSEC4(JLOOP) = VALUE
  330   CONTINUE
C
      ELSE
C
C       Return number of points with values (ie excluding points with
C       missing data values).
C
        KSIZE = NXTOUT
C
      ENDIF
C
C     ------------------------------------------------------------------
C*    Section 9 . Return to calling routine. Format statements.
C     ------------------------------------------------------------------
C
  900 CONTINUE
C
      IF (KPR.GE.1) THEN
        WRITE(GRPRSM,*) 'INSMP2: Section 9.'
        WRITE(GRPRSM,*) '         Output values set -'
        WRITE(GRPRSM,*) 'INSMP2: KSIZE = ', KSIZE
      ENDIF
C
      RETURN
C
 9003 FORMAT (1H ,'INSMP2: Error reported by routine INXBIT.')
C
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities
C granted to it by virtue of its status as an intergovernmental organisation
C nor does it submit to any jurisdiction.
C

      SUBROUTINE ECLOC1(HFUNC,KSEC1,KGRIB,KNSPT,KBITS,KRET)
C
C---->
C**** ECLOC1
C
C     Purpose.
C     --------
C
C     GRIB coding/decoding of ECMWF local use of Section 1.
C
C**   Interface.
C     ----------
C
C     CALL ECLOC1(HFUNC,KSEC1,KGRIB,KNSPT,KBITS,KRET)
C
C
C     Input Parameters.
C     -----------------
C
C     HFUNC      - Requested function.
C                  'C' to code data.
C                  'D' to decode data.
C     KSEC1      - Array containing Grib Section 1 data.
C     KGRIB      - Array containing Grib coded data.
C     KNSPT      - Bit number after which insertion or
C                  extraction starts.
C     KBITS      - Number of bits in computer word.
C
C
C     Output Parameters.
C     ------------------
C
C     KSEC1      - Array containing Grib Section 1 data.
C
C     KGRIB      - Array containing Grib coded data.
C
C     KNSPT      - Number of bit after last one inserted or
C                              extracted.
C
C     KRET       - Return code.
C                  0   , No error encountered.
C                  1   , Invalid local use definition.
C                  2   , Error reported by routine INXBIT.
C                  3   , 3d or 4d analysis not implemented.
C
C     Method.
C     -------
C
C     Input data packed/unpacked in accordance with ECMWF usage of
C     local part of section 1 of Grib code.
C
C
C     Externals.
C     ----------
C
C     INXBIT  - insert/extract bit data
C     ABORTX  - abort program
C     CSGNBT  - encode sign bit
C     DSGNBT  - decode sign bit
C     ELDEFS  - encode ECMWF section 1, local usage definitions
C     DLDEFS  - decode ECMWF section 1, local usage definitions
#ifdef LITTLE_ENDIAN
C     SWAP4   - swap order of characters in the experiment version
#endif
C
C
C     Reference.
C     ----------
C
C     WMO Manual On Codes for Grib Code.
C
C
C     Comments.
C     ---------
C
C     None.
C
C
C     Author.
C     -------
C
C     J. Hennessy      ECMWF      03:11:92.
C
C
C     Modifications.
C     --------------
C
C     J. Hennessy      ECMWF      21:05:93.
C     Additional parameter KPLEN added. Local usage definitions
C     3 and 4 added.
C
C     J.D.Chambers     ECMWF      18:10:93.
C     Local usage definition 5 added.
C
C     J.D.Chambers     ECMWF      12.05.94
C     ECMWF local usage definition 7 added.
C     (Sensitivity gradient/Trajectory forecast data).
C     Change to use CSGNBT and DSGNBT to code and decode sign bits
C
C     J.D.Chambers     ECMWF      02.06.94
C     Fix handling of local use section 1 for MARS labelling
C
C     J.D.Chambers     ECMWF      11.11.94
C     Fix overwrite of constant zero
C
C     J.D.Chambers     ECMWF      18.01.95
C     Use subroutine calls (ECDEF1, ... ) to handle ECMWF
C     section 1 local usage definitions.
C
C     J.D.Chambers     ECMWF      September 2004
C     Use ELDEFS and DLDEFS to handle ECMWF
C     section 1 local usage definitions.
C
C----<
C     -----------------------------------------------------------------|
C*    Section 0 . Definition of variables. Data statements.
C     -----------------------------------------------------------------|
C
      IMPLICIT NONE
C
#include "grbcom.h"
#include "common/grprs.h"
C
C     Subroutine arguments
C
      CHARACTER*(*) HFUNC
      INTEGER KSEC1, KGRIB, KNSPT, KBITS, KRET
      DIMENSION KGRIB(*)
      DIMENSION KSEC1(*)
C
C     Parameter(s)
C
      INTEGER JPBITS
#ifdef INTEGER_8
      PARAMETER ( JPBITS = 64 )
#else
      PARAMETER ( JPBITS = 32 )
#endif
C
C     Local variables
C
      INTEGER NUMBYTS, NUMVALS, IOFFSET
CC    INTEGER ILEN, LOOP, ITEMP(1000)
      INTEGER NUMBER
C
      LOGICAL LENCODE, LDEBUG
C
C     Function(s)
C
      INTEGER LDEFNUM
C
C     -----------------------------------------------------------------|
C*    Section 1 . Set initial values.
C     -----------------------------------------------------------------|
C
  100 CONTINUE
C
      LDEBUG = (NDBG.GE.1)
C
      IF( LDEBUG ) THEN
        WRITE(GRPRSM,*) 'ECLOC1: Section 1.'
        WRITE(GRPRSM,*) '         Input values used -'
        WRITE(GRPRSM,*) '         HFUNC  = ', HFUNC
        WRITE(GRPRSM,*) '         KNSPT  = ', KNSPT
      ENDIF
C
C     Reset return code to 0.
C
      KRET = 0
C
      LENCODE = ( HFUNC(1:1).EQ.'C' )
C
C     -----------------------------------------------------------------|
C*    Section 2 .  Check input parameters.
C     -----------------------------------------------------------------|
C
  200 CONTINUE
C
      IF( LDEBUG ) WRITE(GRPRSM,*) 'ECLOC1: Section 2.'
C
      IOFFSET = 1 + (KNSPT / KBITS)
C
C     KWBC non-ensemble products have:
C       ksec1( 2) = 7     (originating centre = KWBC)
C       ksec1(22) = 98    (subcentre          = ECMWF)
C     For these, an ECMWF local definition applies.
C
      IF( LENCODE ) THEN
        NUMBER = KSEC1(2)*1000000 + KSEC1(22)*1000 + KSEC1(37)
        CALL ELDEFS(NUMBER,KSEC1(37),KGRIB(IOFFSET),NUMVALS,NUMBYTS)
        IF( NUMBYTS.LE.0 ) THEN
          KRET = 1
          GOTO 900
        ENDIF
        NUMBYTS = NUMBYTS + 40
        CALL ISEC1L(KGRIB,NUMBYTS)
        NUMBYTS = NUMBYTS - 40
      ELSE
        NUMBER = LDEFNUM(KSEC1(2),KSEC1(22),KGRIB(IOFFSET))
        CALL DLDEFS(NUMBER,KGRIB(IOFFSET),KSEC1(37),NUMVALS,NUMBYTS)
        IF( NUMBYTS.LE.0 ) THEN
          KRET = 1
          GOTO 900
        ENDIF
      ENDIF
      KNSPT = KNSPT + (NUMBYTS*8)
C
C     -----------------------------------------------------------------|
C*    Section 9 . Abort/return to calling routine. Format statements.
C     -----------------------------------------------------------------|
C
  900 CONTINUE
C
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      INTEGER FUNCTION CALCOP( PSPEC, KTRUNC, KSUBSP)
C
C---->
C**** *CALCOP*  - linear fit of spectrum to (n*(n+1))**P
C
C     Purpose.
C     --------
C 
C     GRIB allows for "complex packing" of spectral coeficients.
C     This means that a sub-spectrum is not packed and, for the rest,
C     a multiplying factor is applied before packing.  The factor is
C     (n*(n+1))**p, where n is the total wave-number.
C
C     This routine returns an optimal P based on the field itself.
C     
C
C**   Interface.
C     ----------
C     
C     IP = CALCOP( PSPEC, KTRUNC, KSUBSP)
C
C
C     Input arguments.
C     ----------------
C
C     PSPEC   - spectral field
C     KTRUNC  - spectral truncation of field
C     KSUBSP  - truncation of "non-packed" sub-spectrum
C
C
C     Output arguments.
C     -----------------
C
C     The function return value is the integer value of P*1000.
C     The value is constrained to be in the range (-10000, +10000).
C                                
C
C     Method.
C     -------
C     
C     Consider F(n,m) = (n*(n+1))**(-P) * G(n,m), where F(n,m) is the
C     original spectral field and n the total wavenumber.  The aim
C     is to minimize G in a 1 norm with respect to P.  This can only
C     partially be achieved.
C
C     What we do is to to compute H(n), where
C         H(n) = max(F(n,m))    with respect to m.
C
C     We then perform a least square fit for the equation
C         log(H(n)) = beta0+beta1*log(n*(n+1)).
C
C     To ensure a better fit for the lower end of the spectrum, we
C     apply an (arbitrary) weighting function before fitting
C          W(n) = 1.0 / (n-KSUBSP+1)
C
C
C     Externals.
C     ----------
C
C     None.
C
C
C     Reference.
C     ----------
C     
C     Seber, G.A.F. (1979). Linear Regression Analyses.
C     John Wiley and Sons
C
C     ECMWF Research Department documentation of the IFS
C
C
C     Author.
C     -------
C
C     Mats Hamrud     ECMWF      5th May 1994
C
C
C     Modifications.
C     --------------
C
C     John Chambers   ECMWF      6th Sept 1994
C     Add original field truncation as a parameter.
C     Use GRIB ordering of spherical harmonic coefficients in input.
C
C     John Chambers   ECMWF      21st Nov 1994
C     Use double precision intrinsics on VAX
C
C     Lubia Vinhas    ECMWF      9th Oct 1996
C     Intrinsic function MAX in ALPHA platform needs
C
C----<
C     ------------------------------------------------------------------
C
      IMPLICIT NONE
C
#include "common/grprs.h"
C
C     Parameters
      INTEGER JPTMAX
      PARAMETER ( JPTMAX = 2047 )
C                  
C     JPTMAX is current maximum truncation value for input field
C
C     Subroutine arguments
      REAL PSPEC
      DIMENSION PSPEC(*)
      INTEGER KTRUNC, KSUBSP
C
C     Local arguments
      INTEGER ISMIN, ISMAX, INDEX, JN, JM
#ifdef CRAY
      REAL ZEPS, ZZ, ZXMW, ZYMW, ZWSUM, ZX, ZY, ZSUM1, ZSUM2
      REAL ZP
      REAL ZBETA1
      REAL ZW(0:(JPTMAX+1)), ZNORM(0:(JPTMAX+1))
#else
      DOUBLE PRECISION ZEPS, ZZ, ZXMW, ZYMW, ZWSUM, ZX, ZY, ZSUM1, ZSUM2
      DOUBLE PRECISION ZP
      DOUBLE PRECISION ZBETA1
      DOUBLE PRECISION ZW(0:(JPTMAX+1)), ZNORM(0:(JPTMAX+1))
#endif
C      
C     ------------------------------------------------------------------
C*    Section 1. Do initial setup and calulate the (arbitrary) weights.
C     ------------------------------------------------------------------
C
 100  CONTINUE
C
C     Check internal arrays can handle the truncation
C
      IF( KTRUNC.GT.JPTMAX ) THEN
        WRITE(GRPRSM,*)
     X    'CALCOP: Cannot use the given truncation ', KTRUNC
        WRITE(GRPRSM,*) 'CALCOP: Maximum handled is ', JPTMAX
        CALCOP = -99999
        RETURN
      ENDIF
C
      ISMIN = KSUBSP+1
      ISMAX = KTRUNC+1
      ZEPS  = 1.0E-15
C
C     Set up the weights.
#ifdef IBM
      ZZ = DBLE(ISMAX-ISMIN+1)
#else
      ZZ = REAL(ISMAX-ISMIN+1)
#endif
      DO 110 JN = ISMIN, ISMAX      
#ifdef IBM
        ZW(JN) = ZZ / DBLE(JN-ISMIN+1)
#else
        ZW(JN) = ZZ / REAL(JN-ISMIN+1)
#endif
 110  CONTINUE
C      
C     ------------------------------------------------------------------
C*    Section 2. Compute norms.
C     ------------------------------------------------------------------
C
 200  CONTINUE
C
C     Initialise array to zero.
      DO 210 JN = ISMIN, ISMAX
        ZNORM(JN) = 0.0
 210  CONTINUE
C
C     Form norms.
C     Handle values 2 at a time (real and imaginary parts)
C
C     First the rows affected by the subset
      INDEX = -1
      DO 230 JM = 0 , KSUBSP-1
        DO 220 JN = JM , KTRUNC
          INDEX = INDEX + 2
          IF ( JN .GE. KSUBSP ) THEN
#if defined (VAX) || defined (IBM) || defined (__alpha) || defined hpR64 || defined hpiaR64
            ZNORM(JN) = MAX(ZNORM(JN), DBLE(ABS(PSPEC(INDEX))))
            ZNORM(JN) = MAX(ZNORM(JN), DBLE(ABS(PSPEC(INDEX+1))))
#else
            ZNORM(JN) = MAX(ZNORM(JN), ABS(PSPEC(INDEX)))
            ZNORM(JN) = MAX(ZNORM(JN), ABS(PSPEC(INDEX+1)))
#endif
          ENDIF
  220   CONTINUE
  230 CONTINUE
C
C     Next the rows not affected by the subset
      DO 250 JM = KSUBSP , KTRUNC
        DO 240 JN = JM , KTRUNC
          INDEX = INDEX + 2
#if defined (VAX) || defined (IBM) || defined (__alpha) || defined hpR64 || defined hpiaR64
          ZNORM(JN) = DMAX1(ZNORM(JN), DBLE(ABS(PSPEC(INDEX))))
          ZNORM(JN) = DMAX1(ZNORM(JN), DBLE(ABS(PSPEC(INDEX+1))))
#else
          ZNORM(JN) = MAX(ZNORM(JN), ABS(PSPEC(INDEX)))
          ZNORM(JN) = MAX(ZNORM(JN), ABS(PSPEC(INDEX+1)))
#endif
  240   CONTINUE
  250 CONTINUE
C
C     Ensure the norms have a value which is not too small in case of
C     problems with math functions (e.g. LOG).
C
      DO 290 JN = ISMIN, ISMAX
#if defined (VAX) || defined (IBM) || defined hpR64 || defined hpiaR64
        ZNORM(JN) = DMAX1(ZNORM(JN), ZEPS)
#else
        ZNORM(JN) = MAX(ZNORM(JN), ZEPS)
#endif
        IF(ZNORM(JN).EQ.ZEPS) ZW(JN) = 100.*ZEPS
 290  CONTINUE     
C      
C     ------------------------------------------------------------------
C*    Section 3. Do linear fit to find the slope (ZBETA1).
C     ------------------------------------------------------------------
C
 300  CONTINUE
C
      ZXMW  = 0.0
      ZYMW  = 0.0
      ZWSUM = 0.0
C
C     Sum the weighted X and Ys.
      DO 310 JN = ISMIN, ISMAX
#ifdef IBM
        ZX    = LOG(DBLE(JN*(JN+1)))
#else
        ZX    = LOG(REAL(JN*(JN+1)))
#endif
        ZY    = LOG(ZNORM(JN))
        ZXMW  = ZXMW+ZX*ZW(JN)
        ZYMW  = ZYMW+ZY*ZW(JN)
        ZWSUM = ZWSUM+ZW(JN)
 310  CONTINUE
C
C     Form mean weighted X and Y.
      ZXMW  = ZXMW / ZWSUM
      ZYMW  = ZYMW / ZWSUM
      ZSUM1 = 0.0
      ZSUM2 = 0.0
C
C     Perform a least square fit for the equation
      DO 320 JN = ISMIN, ISMAX
#ifdef IBM
        ZX    = LOG(DBLE(JN*(JN+1)))
#else
        ZX    = LOG(REAL(JN*(JN+1)))
#endif
        ZY    = LOG(ZNORM(JN))
        ZSUM1 = ZSUM1+ZW(JN)*(ZY-ZYMW)*(ZX-ZXMW)
        ZSUM2 = ZSUM2+ZW(JN)*(ZX-ZXMW)**2
 320  CONTINUE
C 
C     Calculate the slope.
      ZBETA1 = ZSUM1 / ZSUM2     
C      
C     ------------------------------------------------------------------
C*    Section 9. Closedown.
C     ------------------------------------------------------------------
C
 900  CONTINUE
C
      ZP = -ZBETA1
#ifdef CRAY
      ZP = MAX(-9.999, MIN(9.999, ZP))
#endif
#if defined (VAX) || defined (IBM) || defined hpR64 || defined hpiaR64
      ZP = DMAX1(-9.999D0, DMIN1(9.999D0, ZP))
#endif
#if !defined(VAX) && !defined(CRAY) && !defined(IBM)
      ZP = MAX(-9.999D0, MIN(9.999D0, ZP))
#endif
C
#ifdef IBM
      CALCOP = IDINT( ZP * 1000.0 )
#else
      CALCOP = INT( ZP * 1000.0 )
#endif
C
      RETURN
      END

      PROGRAM BUFRCHECK
C
C**** *BUFR*
C
C
C     PURPOSE.
C     --------
C         CHECKS UP BUFR MESSAGE. THE SIZES OF SECTION AND POSITION OF 
C         7777 IS CHECKED
C
C
C**   INTERFACE.
C     ----------
C
C          NONE.
C
C     METHOD.
C     -------
C
C          NONE.
C
C
C     EXTERNALS.
C     ----------
C
C         CALL BUSEL
C         CALL BUFREX
C         CALL BUFREN
C         CALL BUPRS0
C         CALL BUPRS1
C         CALL BUPRS2
C         CALL BUPRS3
C         CALL BUPRT
C         CALL BUUKEY
C
C     REFERENCE.
C     ----------
C
C          NONE.
C
C     AUTHOR.
C     -------
C
C          M. DRAGOSAVAC    *ECMWF*       15/09/87.
C
C
C     MODIFICATIONS.
C     --------------
C
C          NONE.
C
C
      IMPLICIT LOGICAL(L,O,G), CHARACTER*8(C,H,Y)
C
      PARAMETER(JSUP =   9,JSEC0=   3,JSEC1= 40,JSEC2=4096 ,JSEC3= 4,
     1       JSEC4=   2,JELEM=160000,JSUBS=400,JCVAL=150 ,JBUFL=512000,
#ifdef JBPW_64
     2       JBPW =  64,JTAB =3000,JCTAB=120,JCTST=1800,JCTEXT=1200,
#else
     2       JBPW =  32,JTAB =3000,JCTAB=120,JCTST=1800,JCTEXT=1200,
#endif
     3       JWORK=4096000,JKEY=46,JBYTE=512000)
C
C 
      DIMENSION KBUFF(JBUFL)
      REAL*8 RVIND,EPS
C
      CHARACTER*256 CF,COUT,CARG(4)
C
cs      EXTERNAL GETARG
C                                                                       
C     ------------------------------------------------------------------
C*          1. INITIALIZE CONSTANTS AND VARIABLES.
C              -----------------------------------
 100  CONTINUE
C
C     MISSING VALUE INDICATOR
C 
      NBYTPW=JBPW/8
      RVIND=1.7D38
      NVIND=2147483647
      N=0
      CF=' '
C
C     INPUT FILE NAME
C
C     GET INPUT AND OUTPUT FILE NAME.
C
      NARG=IARGC()
C
      IF(NARG.NE.2) THEN
         PRINT*,'USAGE -- bufr_check -i infile ' 
         STOP
      END IF
C
      DO 101 J=1,NARG
      CALL GETARG(J,CARG(J))
 101  CONTINUE
C
      IF(CARG(1).NE.'-i'.AND.CARG(1).NE.'-I'.OR.
     1   CARG(2).EQ.' ') THEN
         PRINT*,'USAGE -- bufr_check -i infile '
         STOP
      END IF
C
      CF=CARG(2)
      II=INDEX(CF,' ')
C
C*          1.2 OPEN FILE CONTAINING BUFR DATA.
C               -------------------------------
 120  CONTINUE
C
      IRET=0 
      CALL PBOPEN(IUNIT,CF(1:II),'R',IRET)
      IF(IRET.EQ.-1) STOP 'OPEN FAILED'
      IF(IRET.EQ.-2) STOP 'INVALID FILE NAME'
      IF(IRET.EQ.-3) STOP 'INVALID OPEN MODE SPECIFIED'
C
C
C     ----------------------------------------------------------------- 
C*          3.  READ BUFR MESSAGE.
C               ------------------
 300  CONTINUE
C
      IERR=0
      KBUFL=0
      IRET=0
C
      CALL PBBUFR(IUNIT,KBUFF,JBYTE,KBUFL,IRET) 
      IF(IRET.EQ.-1) THEN
         PRINT*,'NUMBER OF BUFR MESSAGES PROCCESSED-',N
         STOP 'EOF'
      END IF
      IF(IRET.EQ.-2) STOP 'FILE HANDLING PROBLEM' 
      IF(IRET.EQ.-3) STOP 'ARRAY TOO SMALL FOR PRODUCT'
C
      N=N+1
C
C     -----------------------------------------------------------------
C*          4. EXPAND BUFR MESSAGE.
C              --------------------
 400  CONTINUE
C
      CALL RECL(N,KBUFL,KBUFF,KLEN,IERR)
      GO TO 300
C
      END
      SUBROUTINE RECL(K,KBUFL,KBUFF,KLEN,KERR)
C                                                                       
C**** *RECL*                                                         
C                                                                       
C                                                                       
C     PURPOSE.                                                          
C     --------                                                          
C          GET TOTAL BUFR MESSAGE LENGTH.
C                                                                       
C**   INTERFACE.                                                        
C     ----------                                                        
C                                                                       
C          *CALL* *RECL(KBUFL,KBUFF,KLEN,KERR)*
C
C        INPUT :
C               *KBUFL*   -  LENGTH OF BUFR MESSAGE (WORDS)
C               *KBUFF*   -  ARRAY CONTAINING BUFR MESSAGE
C        OUTPUT:
C               *KLEN*    -  TOTAL BUFR LENGTH
C               *KERR*    -  RETURNED ERROR CODE
C                            0 - OK.
C                            
C     METHOD.                                                           
C     --------                                                          
C                                                                       
C          NONE.                                                       
C                                                                       
C     EXTERNALS.                                                        
C     ----------                                                        
C                                                                       
C          BUNPKS          - UNPACK BIT PATTERN IN REPEATED WAY
C          BUNPCK          - UNPACK BIT PATTERN         
C                                                                       
C     REFERENCE.                                                        
C     ----------                                                        
C                                                                       
C          NONE.                                                        
C                                                                       
C     AUTHOR.                                                           
C     -------                                                           
C                                                                       
C          M. DRAGOSAVAC    *ECMWF*       15/09/91.                  
C                                                                       
C                                                                       
C     MODIFICATIONS.                                                    
C     --------------                                                    
C                                                                       
C          NONE.                                                        
C                                                                       
C                                                                       
      IMPLICIT LOGICAL(L,O,G), CHARACTER*8(C,H,Y)                       
C                                                                       
C                                                                       
      PARAMETER(JSUP =   9,JSEC0=   3,JSEC1= 40,JSEC2= 4096 ,JSEC3= 4,
     1          JSEC4=   2,JELEM=20000,JSUBS=400,JCVAL=150 ,JBUFL= 8192,
     2          JBPW =  32,JTAB =1000,JCTAB=120,JCTST=1800,JCTEXT= 200,
     3          JWORK=80000,JKEY=46)
C
      COMMON /BCOMWORK/ NBPW,NWPT,NBPT,NWPTB,NBPTB,NMASK(JBPW)
     1,                 NVIND,RVIND,NBENP,NLTVNP,NWWP,NXXP,NYYP,NZZP,EPS
C
      DIMENSION KBUFF(*)
      DIMENSION IBUFR(4)                                                
C
      CHARACTER*4 YBUFR
C
C     ------------------------------------------------------------------
C*          1.   EXPAND SECTION 0.                                      
C                -----------------                                      
 100  CONTINUE                                                          
C                                                                       
      KERR=0
      NBPW=JBPW
      IBPW=JBPW/8
      NWPT = 1                                                          
      NBPT = 0                                                          
      KLEN=0
      ILEN0=0
      ILEN1=0
      ILEN2=0
      ILEN3=0
      ILEN4=0
      ILEN5=0
C                                                                       
C*          1.2  UNPACK FIRST FOUR OCTETS CONTAINING *BUFR*.            
C                -------------------------------------------            
C                                                                       
      CALL BUNPKS(NBPW,KBUFF,IBUFR,NWPT,NBPT,8,0,4,KERR)
      IF(KERR.NE.0) RETURN
C                                                                       
C*          1.3  CHECK IF FIRST FOUR OCTETS ARE 'BUFR'.
C                --------------------------------------
      YBUFR=CHAR(IBUFR(1))//CHAR(IBUFR(2))//
     1      CHAR(IBUFR(3))//CHAR(IBUFR(4))
      IF(YBUFR.NE.'BUFR') THEN
         PRINT*,'FIRST FOUR CHARACTERS ARE NOT BUFR.'
         KERR=1
         RETURN                                 
      END IF                                    
C
C*          1.4 UNPACK BUFR EDITION NUMBER (IT IS 8TH BYTE ).
C               ---------------------------------------------
C
      IWPT=56/NBPW+1
      IBPT=56-(IWPT-1)*NBPW
C
      CALL BUNPCK(NBPW,KBUFF,IED,IWPT,IBPT,8,KERR)
C
      IF(IED.GE.2) THEN
C                                                                       
C*          1.5 UNPACK TOTAL LENGTH OF BUFR MESSAGE.
C               ------------------------------------
C
         CALL BUNPCK(NBPW,KBUFF,KLEN,NWPT,NBPT,24,KERR)
C
C
C*          2.9  CHECK IF LAST FOUR OCTETS ARE '7777'.
C                --------------------------------------
         NWPT = KLEN/IBPW
         NBPT = (KLEN-NWPT*IBPW)*8
         CALL BUNPKS(NBPW,KBUFF,IBUFR,NWPT,NBPT,8,0,4,KERR)
         YBUFR=CHAR(IBUFR(1))//CHAR(IBUFR(2))//
     1         CHAR(IBUFR(3))//CHAR(IBUFR(4))
         IF(YBUFR(1:4).NE.'7777') THEN
            PRINT*,'WRONG BUFR MESSAGE---------------------------',K
            PRINT*,'7777 NOT AT WRITE PLACE.',YBUFR,' FOUND INSTEAD.'
            PRINT*,'TOTAL LENGTH UNPACKED  ',KLEN,' BYTES'
            IB=KBUFL
            PRINT*,'INPUT BUFR MESSAGE LENGTH ',IB,' BYTES'
            RETURN                                 
         END IF                                    
         RETURN
      END IF
C                                                                       
C*          1.7 SET LENGTH OF SECTION 0.
C               ------------------------
C
      ILEN0= 4
C
C                                                                       
C*          1.8 UNPACK LENGTH OF SECTION 1.                             
C               ----------------------------                            
C
      CALL BUNPCK(NBPW,KBUFF,ILEN1,NWPT,NBPT,24,KERR)
C                                                                       
C*          1.9 SET THE POINTERS NWPTB AND NBPTB.                     
C               ---------------------------------                     
C               TO BEGINING OF THE NEXT SECTION.                      
C               --------------------------------                      
C
      CALL BUNEXS(ILEN1)                                             
C                                                                       
C
C*          2.0  UNPACK BUFR EDITION NUMBER/MASTER TABLE USED.
C                ---------------------------------------------
C
      CALL BUNPCK(NBPW,KBUFF,IDUMMY,NWPT,NBPT, 8,KERR)
C                                                                       
C*          2.1  UNPACK ORIGINATING CENTRE.                             
C                --------------------------                             
      CALL BUNPCK(NBPW,KBUFF,IDUMMY,NWPT,NBPT,16,KERR)
C                                                                       
C*          2.2  UNPACK UPDATE SEQUENCE NUMBER.                         
C                ------------------------------                         
C
      CALL BUNPCK(NBPW,KBUFF,IDUMMY,NWPT,NBPT, 8,KERR)
C                                                                       
C*          2.3  UNPACK INTEGER VALUE OF THE OCTET CONTAINING           
C                --------------------------------------------           
C                 FLAG BITS(ZERO IF SECTION TWO IS NOT PRESENT).        
C                 ----------------------------------------------        
C
      CALL BUNPCK(NBPW,KBUFF,IFLAG,NWPT,NBPT, 8,KERR)
C                            
C*          2.4 SET THE POINTERS NWPT AND NBPT AT THE BEGINING OF SECTION.
C              -----------------------------------------------------------
C
      NWPT = NWPTB                                                      
      NBPT = NBPTB                                                      
C                                                                       
      IF(IFLAG.NE.0) THEN
C
C*          2.5  UNPACK LENGTH OF SECTION 2.                            
C                ---------------------------                            
         CALL BUNPCK(NBPW,KBUFF,ILEN2,NWPT,NBPT,24,KERR)
C                                                                       
         CALL BUNEXS(ILEN2)                                             
C
      END IF
C                                                                       
C                                                                       
C*          2.6   UNPACK LENGTH OF SECTION 3.                           
C                 ---------------------------                           
C                                                                       
      NWPT = NWPTB                                                      
      NBPT = NBPTB                                                      
      CALL BUNPCK(NBPW,KBUFF,ILEN3,NWPT,NBPT,24,KERR)
C
      CALL BUNEXS(ILEN3)                                             
C                                                                       
C                                                                       
C*          2.7  UNPACK LENGTH OF SECTION 4.                            
C                ---------------------------                            
      NWPT = NWPTB                                                      
      NBPT = NBPTB                                                      
      CALL BUNPCK(NBPW,KBUFF,ILEN4,NWPT,NBPT,24,KERR)
C
      CALL BUNEXS(ILEN4) 
C
C*          2.8  UNPACK LAST FOUR OCTETS CONTAINING '7777'.            
C                ------------------------------------------            
C                                                                       
      NWPT = NWPTB                                                      
      NBPT = NBPTB                                                      
      CALL BUNPKS(NBPW,KBUFF,IBUFR,NWPT,NBPT,8,0,4,KERR)
C                                                                       
C*          2.9  CHECK IF FIRST FOUR OCTETS ARE 'BUFR'.
C                --------------------------------------
      YBUFR=CHAR(IBUFR(1))//CHAR(IBUFR(2))//
     1      CHAR(IBUFR(3))//CHAR(IBUFR(4))
      IF(YBUFR(1:4).NE.'7777') THEN
         PRINT*,'WRONG BUFR MESSAGE---------------------------',K
         PRINT*,' LENGTH OF SECTION 0',ILEN0
         PRINT*,' LENGTH OF SECTION 1',ILEN1
         PRINT*,' LENGTH OF SECTION 2',ILEN2
         PRINT*,' LENGTH OF SECTION 3',ILEN3
         PRINT*,' LENGTH OF SECTION 4',ILEN4
         PRINT*,' LENGTH OF SECTION 5',ILEN5
         IB=KBUFL
         PRINT*,' INPUT RECORD LENGTH',IB,' BYTES'
         RETURN                                 
      END IF                                    
C
      ILEN5=4
      KLEN=ILEN0+ILEN1+ILEN2+ILEN3+ILEN4+ILEN5
C
      IBUFL=KBUFL
      IF(KLEN.GT.IBUFL) THEN
         PRINT*,'WRONG BUFR MESSAGE---------------------------',K
         PRINT*,' LENGTH OF SECTION 0',ILEN0
         PRINT*,' LENGTH OF SECTION 1',ILEN1
         PRINT*,' LENGTH OF SECTION 2',ILEN2
         PRINT*,' LENGTH OF SECTION 3',ILEN3
         PRINT*,' LENGTH OF SECTION 4',ILEN4
         PRINT*,' LENGTH OF SECTION 5',ILEN5
         IB=KBUFL
         PRINT*,' INPUT RECORD LENGTH',IB,' BYTES'
         PRINT*,' INPUT RECORD TOO SHORT.'
         RETURN
      END IF
C
C     	  -----------------------------------------------------------------
C
      RETURN                                      
      END                                                               

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities
C granted to it by virtue of its status as an intergovernmental organisation
C nor does it submit to any jurisdiction.
C

      INTEGER FUNCTION IRGMEM (KPR, KERR)
C
C---->
C**** *IRGMEM*
C
C     PURPOSE
C     _______
C
C     This routine acquires heap space for reduced_gg to regular_ll
C     interpolations.
C
C     INTERFACE
C     _________
C
C     IERR = IRGMEM (KPR, KERR)
C
C     Input parameters
C     ________________
C
C     KPR        - The debug print switch.
C                  0  , No debugging output.
C                  1  , Produce debugging output.
C
C     KERR       - The error control flag.
C                  -ve, No error message. Return error code.
C                  0  , Hard failure with error message.
C                  +ve, Print error message. Return error code.
C
C     Output parameters
C     ________________
C
C     None
C
C     Return value
C     ____________
C
C     The error indicator (INTEGER).
C
C     Error and Warning Return Values
C     _______________________________
C
C     None
C
C     Common block usage
C     __________________
C
C     nifld.common - This file contains all the input field
C                    definition variables.
C
C     NINS         - Number of grid points in NS direction for input
C                    field (used in grspace.h).
C     NIWE         - Number of grid points in WE direction for input
C                    field (used in grspace.h).
C
C     nofld.common - This file contains all the output field
C                    definition variables.
C
C     NONS         - Number of grid points in NS direction for output
C                    field (used in grspace.h).
C     NOWE         - Number of grid points in WE direction for output
C                    field (used in grspace.h).
C
C     grspace.h    - This file contains all the work space array
C                    definitions for grid point to grid point
C                    interpolation.
C
C     GRID_POINT
C
C     NILATGP      - POINTER to array MILATG.
C     NILONGP      - POINTER to array MILONG.
C     NILSMP       - POINTER to array MILSM.
C     NINPNTP      - POINTER to array RINPNT.
C     NISTRTP      - POINTER to array MISTRT.
C     NNSDISTP     - POINTER to array MNSDIST.
C     NNSINDP      - POINTER to array MNSIND.
C     NMAXP        - POINTER to array RMAX.
C     NOLATGP      - POINTER to array MOLATG.
C     NOLONGP      - POINTER to array MOLONG.
C     NOLSMP       - POINTER to array MOLSM.
C     NWEDISTP     - POINTER to array MWEDIST.
C     NWEINDP      - POINTER to array MWEIND.
C     NWFACTP      - POINTER to array WFACT.
C
C     MILATG       - Dynamic array of length (NINS) (see nifld.common)
C                    which holds the values of the input field
C                    latitudes.
C     MILONG       - Dynamic array of length (NIWE + 1) (see
C                    nifld.common) which holds the values of the
C                    input field longitudes.
C     MILSM        - Dynamic array of length (NIWE, 2) (see
C                    nifld.common) used in calculating the effects of
C                    the land sea mask on interpolation.
C     MISTRT       - Dynamic array of length (NINS) (see nifld.common)
C                    which holds the array offsets of the start of
C                    each latitude line for a quasi regular Gaussian
C                    input field. No space is assigned to this array
C                    for a regular input field.
C     MNSDIST      - Dynamic array of length (2, NONS) (see
C                    nofld.common) which holds the distances to
C                    neighbouring latitude lines of the input field
C                    from the associated line of latitude in the
C                    output field.
C     MNSIND       - Dynamic array of length (2, NONS) (see
C                    nofld.common) which holds the latitude line
C                    numbers (array offset) of the input field
C                    associated with each line of latitude in the
C                    output field.
C     MOLATG       - Dynamic array of length (NONS) (see nofld.common)
C                    which holds the values of the output field
C                    latitudes.
C     MOLONG       - Dynamic array of length (NOWE) (see nofld.common)
C                    which holds the values of the output field
C                    longitudes.
C     MOLSM        - Dynamic array of length (NOWE) (see nofld.common)
C                    used in calculating the effects of the land sea
C                    mask on interpolation.
C     MWEDIST      - Dynamic array of length (2, NONS) (see
C                    nofld.common) for a regular input field and of
C                    length (2, 2 * NONS * NOWE) (see nofld.common)
C                    for a quasi regular Gaussian input field.
C                    This array holds the distances to neighbouring
C                    longitude points of the input field from the
C                    associated longitude points in the output field.
C     MWEIND       - Dynamic array of length (2, NONS) (see
C                    nofld.common) for a regular input field and of
C                    length (2, 2 * NONS * NOWE) (see nofld.common)
C                    for a quasi regular Gaussian input field.
C                    This array holds the longitude points (array
C                    offset) from the input field associated with each
C                    longitude point in the output field.
C     RINPNT       - Dynamic array of length (NOWE) (see nofld.common)
C                    used to aid vectorisation in processing
C                    precipitation fields.
C     RMAX         - Dynamic array of length (NOWE) (see nofld.common)
C                    used to aid vectorisation in processing
C                    precipitation fields.
C     WFACT        - Dynamic array of length (4, NOWE * NONS) (see
C                    nofld.common) which holds the interpolation
C                    weights for each point in the output field.
C
C     EXTERNALS
C     _________
C
C     IGALLOC    - Get a heap allocation for array space.
C     INTLOG     - Logs messages.
C
C     METHOD
C     ______
C
C     This routine calculates how much heap space is required. IGALLOC
C     is then used to acquire the required space. Finally the POINTERs
C     in grspace.h are initialised to allow using the dynamic arrays.
C
C     REFERENCE
C     _________
C
C     None
C
C     COMMENTS
C     ________
C
C     Program contains sections 0 to 3 and 9
C
C     AUTHOR
C     ______
C
C     K. Fielding      *ECMWF*      Jan 1994
C
C     MODIFICATIONS
C     _____________
C
C     None
C
C----<


C     Section 0. Definition of variables
      IMPLICIT NONE

#include "parim.h"
#include "nifld.common"
#include "nofld.common"
#include "grspace.h"

C     Dummy arguments
      INTEGER KPR, KERR

C     Local variables
#ifdef POINTER_64
      INTEGER*8 IBASE
#else
      INTEGER IBASE
#endif
      INTEGER*8 SIZES(14)
      INTEGER IREQUEST, IERR, I

C     External functions
      INTEGER IGALLOC


C     Section 1. Initialisation
  100 CONTINUE
      IF( KPR.GE.1 ) CALL INTLOG(JP_DEBUG,'IRGMEM: Section 1.',JPQUIET)
      IRGMEM = 0


C     Section 2. Calculate memory required and get heap
  200 CONTINUE

C     We are having trouble when using POINTER values in arithmetic
C     where we get overflow when we don't expect it. Like the POINTER is
C     interpreted as a 32-bit length value. For that reason we calculate
C     an OFFSET and add DELTA values to it before reading its value out
C     into the various base addresses which are then not used again in
C     further calculations.
C
C     Specify array allocation sizes:
C     - uses JPRLEN for REAL arrays
C     - uses JPILEN for INTEGER arrays
      SIZES( 1) = JPRLEN * (NOWE*NONS*4)    ! NWFACTP  / WFACT
      SIZES( 2) = JPRLEN * (NOWE)           ! NMAXP    / RMAX   (#1 precipitation)
      SIZES( 3) = JPRLEN * (NOWE)           ! NINPNTP  / RINPNT (#2)
      SIZES( 4) = JPILEN * (NIWE+1)         ! NILONGP  / MILONG
      SIZES( 5) = JPILEN * (NINS)           ! NILATGP  / MILATG
      SIZES( 6) = JPILEN * (NOWE)           ! NOLONGP  / MOLONG
      SIZES( 7) = JPILEN * (NONS)           ! NOLATGP  / MOLATG
      SIZES( 8) = JPILEN * (NONS*2)         ! NNSINDP  / MNSIND
      SIZES( 9) = JPILEN * (NONS*2)         ! NNSDISTP / MNSDIST
      SIZES(10) = JPILEN * (NOWE*2*NONS*2)  ! NWEINDP  / MWEIND (*)
      SIZES(11) = JPILEN * (NOWE*2*NONS*2)  ! NWEDISTP / MWEDIST (*)
      SIZES(12) = JPILEN * (NINS)           ! NISTRTP  / MISTRT (*, not used for regular input grids)
      SIZES(13) = JPILEN * (NIWE*2)         ! NILSMP   / MILSM (#1 lsm)
      SIZES(14) = JPILEN * (NOWE)           ! NOLSMP   / MOLSM (#2)

C     Get the required memory
      IREQUEST = 0
      DO I = 1, 14
        IREQUEST = IREQUEST + SIZES(I)
      ENDDO
      IERR = IGALLOC(JPINNER,IREQUEST,IBASE,KPR,KERR)
      IF (IERR.GT.0) THEN
         IRGMEM = IERR
         GOTO 900
      ENDIF

C     Set POINTER addresses
      NWFACTP  = IBASE
      NMAXP    = SIZES( 1) + NWFACTP
      NINPNTP  = SIZES( 2) + NMAXP
      NILONGP  = SIZES( 3) + NINPNTP
      NILATGP  = SIZES( 4) + NILONGP
      NOLONGP  = SIZES( 5) + NILATGP
      NOLATGP  = SIZES( 6) + NOLONGP
      NNSINDP  = SIZES( 7) + NOLATGP
      NNSDISTP = SIZES( 8) + NNSINDP
      NWEINDP  = SIZES( 9) + NNSDISTP
      NWEDISTP = SIZES(10) + NWEINDP
      NISTRTP  = SIZES(11) + NWEDISTP
      NILSMP   = SIZES(12) + NISTRTP
      NOLSMP   = SIZES(13) + NILSMP

C     Display pointers information
      IF( KPR.GE.1 ) THEN
        CALL INTLOG(JP_DEBUG,'IRGMEM: ************************',JPQUIET)
        CALL INTLOG(JP_DEBUG,'IRGMEM: * Output addresses:',     JPQUIET)
        CALL INTLOG(JP_DEBUG,'IRGMEM: * (print might overflow)',JPQUIET)
        CALL INTLOG(JP_DEBUG,'IRGMEM: - WFACT        = ',NWFACTP)
        CALL INTLOG(JP_DEBUG,'IRGMEM: - RMAX         = ',NMAXP)
        CALL INTLOG(JP_DEBUG,'IRGMEM: - RINPNT       = ',NINPNTP)
        CALL INTLOG(JP_DEBUG,'IRGMEM: - Input long.  = ',NILONGP)
        CALL INTLOG(JP_DEBUG,'IRGMEM: - Input lat.   = ',NILATGP)
        CALL INTLOG(JP_DEBUG,'IRGMEM: - Output long. = ',NOLONGP)
        CALL INTLOG(JP_DEBUG,'IRGMEM: - Output lat.  = ',NOLATGP)
        CALL INTLOG(JP_DEBUG,'IRGMEM: - NS offset    = ',NNSINDP)
        CALL INTLOG(JP_DEBUG,'IRGMEM: - NS distance  = ',NNSDISTP)
        CALL INTLOG(JP_DEBUG,'IRGMEM: - WE offset    = ',NWEINDP)
        CALL INTLOG(JP_DEBUG,'IRGMEM: - WE distance  = ',NWEDISTP)
        CALL INTLOG(JP_DEBUG,'IRGMEM: - Line start   = ',NISTRTP)
        CALL INTLOG(JP_DEBUG,'IRGMEM: - Input LSM    = ',NILSMP)
        CALL INTLOG(JP_DEBUG,'IRGMEM: - Output LSM   = ',NOLSMP)
        CALL INTLOG(JP_DEBUG,'IRGMEM: ***********************', JPQUIET)
      ENDIF


C     Section 9. Return to calling routine
  900 CONTINUE
      IF (KPR.GE.1)  CALL INTLOG(JP_DEBUG,'IRGMEM: Section 9.',JPQUIET)


      END

C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE CREXETDR(KJ,KJ1,KDD,KSTACK,KERR)
C
C**** *CREXETDR*
C
C
C     PURPOSE.
C     --------
C          SOLVE BUFR TABLE D REFERENCE.
C
C
C**   INTERFACE.
C     ----------
C
C          *CALL* *CREXETDR(KJ,KJ1,KDD,KSTACK,KERR)*
C
C        INPUT :
C                 *KDD*      - DATA DESCRIPTOR
C        OUTPUT:
C                 *KJ*       - POINTER TO KSTACK ARRAY
C                 *KJ1*      - POINTER TO LAST ELEMENT IN KSTACK
C                 *KSTACK*   - LIST OF DATA DESCRIPTORS
C                 *KERR*     - RETURN ERROR CODE
C
C
C     METHOD.
C     -------
C
C           NONE.
C
C     EXTERNALS.
C     ----------
C
C           NONE.
C
C     REFERENCE.
C     ----------
C
C          NONE.
C
C     AUTHOR.
C     -------
C
C          M. DRAGOSAVAC    *ECMWF*       01/02/91.
C
C
C     MODIFICATIONS.
C     --------------
C
C          NONE.
C
C
      IMPLICIT LOGICAL(L,O,G), CHARACTER*8(C,H,Y)
C
C
      PARAMETER(JSUP =   9,JSEC0=   3,JSEC1= 40,JSEC2= 64 ,JSEC3=    4,
     1          JSEC4=2,JELEM=40000,JSUBS=400,JCVAL=150 ,JBUFL=40000,
     2          JBPW =  32,JTAB =3000,JCTAB=120,JCTST=1800,JCTEXT= 200,
     3          JWORK=360000,JKEY=46)
C
C
      COMMON /CRWT/ NCREXDWINC,NCREXSCAM,NCREXAFDW,NCREXWT ,ODREPF,
     2             NCREXSTACK(JELEM),NCREXWTEN(JELEM),
     3             NCREXWTR (JELEM),NCREXWTS (JELEM),
     4             NCREXWTDW(JELEM)
C
C             NCREXDWINC   -  data width increment
C             NCREXSCAM    -  scale multiplier
C             NCREXAFDW    -  augmented field data width
C             NCREXWT      -  pointer to working table
C             NCREXSTACK   -  list of data descriptors
C             ODREPF   -  replication (logical)
C             NCREXWTR     -  working table reference
C             NCREXWTS     -  working scale
C             NCREXWTDW    -  working data width
C
      CHARACTER CREXWTEN*64,CREXWTU*24
C
C
      COMMON/CRTAB/ NCREXBR(JTAB),NCREXBS(JTAB)    , NCREXBDW(JTAB),
     1              NCREXDR(JTAB),NCREXDST(JTAB)   ,
     2              NCREXDL(JTAB),NCREXDSQ(JTAB*20),NCREXP(64,255)

C
C             NCREXBR     - table B,  table reference              array
C             NCREXBS     - table B,  scale                        array
C             NCREXBDW    - table B,  data width                   array
C             NCREXDR    - table D,  table reference              array
C             NCREXDST    - table D,  starting pointers            array
C             NCREXDL     - table D,  lengths                      array
C             NCREXDSQ    - table D,  list of sequence descriptors array
C
       COMMON /CRTABC/ CREXNAME(JTAB),CREXUNIT(JTAB)
C
C             CREXNAME      -  table B, ELEMENT NAME           array
C             CREXUNIT      -  table B, unit                   array
C
C
C
      CHARACTER*64 CREXNAME
      CHARACTER*24 CREXUNIT
C
      DIMENSION ILIST(JELEM),KSTACK(*)
C
C     ------------------------------------------------------------------
C
C*          1.   OBTAIN LIST OF DESCRIPTORS FROM BUFR TABLE D.
C                ---------------------------------------------
 100  CONTINUE
C
      IF( KERR.NE.0 ) RETURN
C
      DO 110 J=1,JTAB
C
      IF(KDD.EQ.NCREXDR(J)) THEN
         I=J
         GO TO 120
      END IF
C
 110  CONTINUE
C
      KERR=20
      WRITE(*,*)  'CREXETDR : ',KDD
      CALL CREXERR(KERR)
      RETURN
C
 120  CONTINUE
C
      J1=NCREXDST(I)
      J2=NCREXDL (I)
      J3=0
C
      DO 121 J=J1,J1+J2-1
C
      J3 = J3 +1
      ILIST(J3) = NCREXDSQ(J)
C
 121  CONTINUE
C
C     ------------------------------------------------------------------
C*          2.  PUSH DOWN DATA DESCRIPTION DESCRIPTORS
C               --------------------------------------
C               TO MAKE ROOM FOR LIST.
C               ----------------------
 200  CONTINUE
C
      J2M1=J2-1
C
      DO 210 J=KJ1,KJ+1,-1
C
      KSTACK(J+J2M1) = KSTACK(J)
C
 210  CONTINUE
C
C     ------------------------------------------------------------------
C*          3.  INSERT LIST IN PLACE OF SEQUENCE DESCRIPTORS.
C               ---------------------------------------------
 300  CONTINUE
C
      KJM1=KJ-1
C
      DO 310 J=1,J3
C
      KSTACK(KJM1+J)= ILIST(J)
C
 310  CONTINUE
C
C     ------------------------------------------------------------------
C*          4.  ADJUST DESCRIPTOR COUNT FOR LIST LENGTH.
C               ----------------------------------------
 400  CONTINUE
C
      KJ  = KJ  - 1
      KJ1 = KJ1 +J3 -1
C     ------------------------------------------------------------------
C*          4.1  ADJUST NUMBER OF DATA DESCRIPTORS NOT PRESENT.
C                ----------------------------------------------
 610  CONTINUE
C
      IF(N221.NE.0)  N221= KJ1  - KJ + 1
C     -----------------------------------------------------------------
 500  CONTINUE
C
      RETURN
C
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE INXBIT (KGRIB,KLENG,KNSPT,KPARM,KNUM,KBIT,
     C                   KBLEN,HFUNC,KRET)
C
C---->
C**** INXBIT - Insert/extract bits consecutively in/from a given array
C
C     Purpose.
C     --------
C
C           Take rightmost KBLEN bits from KNUM words of KPARM
C           and insert them consecutively in KGRIB, starting at
C           bit after KNSPT or vice versa.
C
C**   Interface.
C     ----------
C
C           CALL INXBIT (KGRIB,KLENG,KNSPT,KPARM,KNUM,KBIT,
C    C                   KBLEN,KRET)
C
C           Integer    K.
C           Real       P.
C           Logical    O.
C           Character  H.
C
C               Input Parameters.
C               -----------------
C
C               KGRIB      - Array containing bitstream.
C               KLENG      - Length (words) of this array.
C               KNSPT      - Bit number after which insertion or
C                            extraction starts.
C               KPARM      - Array from which bits are taken for
C                            insertion in the bitstream or to which
C                            bits are extracted from the bitstream.
C               KBIT       - Number of bits in computer word.
C               KNUM       - Number of bit fields inserted/extracted.
C               KBLEN      - Number of bits per bit field.
C               HFUNC      - Requested function.
C                            'C' to insert bits in bitstream,
C                            'D' to extract bits from bitstream.
C
C               Output Parameters.
C               ------------------
C
C               KNSPT      - Bit number of last bit inserted/extracted.
C
C               KRET       - Return code.
C                            0 , No error encountered.
C                            1 , Insertion/extraction exceeded
C                                array boundary.
C
C     Method.
C     -------
C
C           Word and offset pointer calculated before calling
C           insertion/extraction routines.
C
C     Externals.
C     ----------
C
C           SBYTES
C           GBYTES
C
C     Reference.
C     ----------
C
C           ECLIB documentation on SBYTES and GBYTES.
C
C     Comments.
C     ---------
C
C           SUN version of routine.
C           Routine contains Sections 0 to 3 and Section 9.
C
C     Author.
C     -------
C
C           J. Hennessy      ECMWF      18.06.91
C
C     Modifications.
C     --------------
C
C           J. Hennessy      ECMWF      08.11.91
C           Parameter KMACH removed from list of input parameters.
C
C           J. Hennessy      ECMWF      12.10.92
C           Dimension of IMASK changed from 64 to 65.
C
C     ----------------------------------------------------------------
C----<
C
C
C
C
C
C
C
C
C
C
C*    Section 0 . Definition of variables. Data statements.
C     ----------------------------------------------------------------
C
C*    Prefix conventions for variable names.
C
C     Logical      L (but not LP), global or common.
C                  O, dummy arguments.
C                  G, local variable.
C                  LP, parameter.
C     Character    C, Global or common.
C                  H, dummy arguments.
C                  Y (but not YP), local variables.
C                  YP, parameter.
C     Integer      M and N, global or common.
C                  K, dummy arguments.
C                  I, local variables.
C                  J (but not JP), loop control.
C                  JP, parameter.
C     Real         A to F and Q to X, global or common.
C                  P (but not PP), dummy arguments.
C                  Z, local variables.
C                  PP, parameter.
C
      INTEGER IND
      INTEGER INUM
      INTEGER IOFF
      INTEGER IPR
      INTEGER IWORD
C
      INTEGER KBIT
      INTEGER KBLEN
      INTEGER KGRIB
      INTEGER KLENG
      INTEGER KNSPT
      INTEGER KNUM
      INTEGER KPARM
      INTEGER KRET
C
      INTEGER J901
C
      DIMENSION KGRIB(KLENG)
      DIMENSION KPARM(*)
C
      CHARACTER*1 HFUNC
C
C
C     Debug print switch.
C
      DATA IPR /0/
C
C     ----------------------------------------------------------------
C
C
C
C
C
C
C
C
C
C
C*    Section 1 . Set initial values.
C     ----------------------------------------------------------------
C
  100 CONTINUE
C
      IF (IPR.EQ.1)
     C   THEN
             WRITE (*,*) 'INXBIT : Section 1.'
             WRITE (*,*) '         Input values used -'
             WRITE (*,9009) KLENG
             WRITE (*,9002) KNSPT
             WRITE (*,9004) KBIT
             WRITE (*,9005) HFUNC
         ENDIF
C
      KRET = 0
C
C     ----------------------------------------------------------------
C
C
C
C
C
C
C
C
C
C
C*    Section 2 . Bit insertion/extraction.
C     ----------------------------------------------------------------
C
  200 CONTINUE
C
      IF (IPR.EQ.1) WRITE (*,*) 'INXBIT : Section 2.'
C
C*    Calculate word pointer and offset.
C
      IWORD = KNSPT / KBIT
      IOFF  = KNSPT - IWORD * KBIT
      IWORD = IWORD + 1
      IF (IPR.EQ.1) WRITE (*,9003) IWORD , IOFF
C
C     Insert/extract bits.
C
      IF (HFUNC.EQ.'C')
     C   THEN
             CALL SBYTES (KGRIB(IWORD),KPARM,IOFF,KBLEN,0,KNUM)
         ELSE
             CALL GBYTES (KGRIB(IWORD),KPARM,IOFF,KBLEN,0,KNUM)
         ENDIF
C
C     Update pointer.
C
      KNSPT = KNSPT + KBLEN * KNUM
C
C     ----------------------------------------------------------------
C
C
C
C
C
C
C
C
C
C
C*    Section 3 . Check out of range.
C    -----------------------------------------------------------------
C
  300 CONTINUE
C
      IF (IPR.EQ.1) WRITE (*,*) 'INXBIT : Section 3.'
C
      IND = KNSPT / KBIT
      IF (IND.GT.KLENG)
     C   THEN
             KRET = 1
             WRITE (*,9001) IND , KLENG
         ENDIF
C
C     ----------------------------------------------------------------
C
C
C
C
C
C
C
C
C
C
C*    Section 9 . Return to calling routine. Format statements.
C     ----------------------------------------------------------------
C
  900 CONTINUE
C
      IF (IPR.EQ.1)
     C   THEN
             INUM = KNUM
             IF (INUM.GT.360)
     C          THEN
                    INUM = 360
                    WRITE (*,9007) INUM
                ENDIF
             DO 901 J901=1,INUM
               IF (HFUNC.EQ.'C')
     C             THEN
                       WRITE (*,9006) KPARM(J901)
                   ELSE
                       WRITE (*,9008) KPARM(J901)
                   ENDIF
  901        CONTINUE
             WRITE (*,*) 'INXBIT : Section 9.'
             WRITE (*,*) '         Output values set -'
             WRITE (*,9002) KNSPT
         ENDIF
C
C
 9001 FORMAT (1H ,'INXBIT : Word ',I8,' is outside array bounds ',I8)
C
 9002 FORMAT (1H ,'         KNSPT  = ',I8)
C
 9003 FORMAT (1H ,'INXBIT : Word is',I8,', bit offset is ',I2)
C
 9004 FORMAT (1H ,'         KBIT   = ',I8)
C
 9005 FORMAT (1H ,'         HFUNC  = ',A)
C
 9006 FORMAT (1H ,'         Inserted value = ',I20)
C
 9007 FORMAT (1H ,'         First ',I9,' values.')
C
 9008 FORMAT (1H ,'         Extracted value = ',I20)
C
 9009 FORMAT (1H ,'         KLENG  = ',I20)
C
      RETURN
C
      END
      SUBROUTINE ABORTX (HNAME)
C
C**** ABORTX - Terminates execution of program.
C
C     Purpose.
C     --------
C
C           Terminates execution of program.
C
C**   Interface.
C     ----------
C
C           CALL ABORTX (HNAME)
C
C           Integer    K.
C           Real       P.
C           Logical    O.
C           Character  H.
C
C               Input Parameters.
C               -----------------
C
C               HNAME      - Name of calling routine.
C
C               Output Parameters.
C               ------------------
C
C               None.
C
C     Method.
C     -------
C
C           Prints message and terminates.
C
C     Externals.
C     ----------
C
C           ABORT
C
C     Reference.
C     ----------
C
C           None.
C
C     Comments.
C     ---------
C
C           SUN version of routine.
C           Routine contains Sections 0 to 1 and Section 9.
C
C     Author.
C     -------
C
C           J. Hennessy      ECMWF      13.11.91
C
C     Modifications.
C     --------------
C
C           None.
C
C     ------------------------------------------------------------------
C
C
C
C
C
C
C
C
C
C
C*    Section 0 . Definition of variables.
C     ------------------------------------------------------------------
C
C*    Prefix conventions for variable names.
C
C     Logical      L (but not LP), global or common.
C                  O, dummy arguments.
C                  G, local variable.
C                  LP, parameter.
C     Character    C, Global or common.
C                  H, dummy arguments.
C                  Y (but not YP), local variables.
C                  YP, parameter.
C     Integer      M and N, global or common.
C                  K, dummy arguments.
C                  I, local variables.
C                  J (but not JP), loop control.
C                  JP, parameter.
C     Real         A to F and Q to X, global or common.
C                  P (but not PP), dummy arguments.
C                  Z, local variables.
C                  PP, parameter.
C
C
      CHARACTER*(*) HNAME
C
C     ------------------------------------------------------------------
C
C
C
C
C
C
C
C
C
C
C*    Section 1 . Print message and terminate.
C     ------------------------------------------------------------------
C
  100 CONTINUE
C
      WRITE (*,9001) HNAME
C
      CALL ABORT
C
C     ------------------------------------------------------------------
C
C
C
C
C
C
C
C
C
C*    Section 9 . Format statements.
C     ------------------------------------------------------------------
C
  900 CONTINUE
C
 9001 FORMAT (1H ,'ABORTX : Routine ',A,' has requested program',
     C               ' termination.')
C
      RETURN
C
      END
      SUBROUTINE SETPAR (KBIT,KNEG,KPR)
C
C**** SETPAR - Set number of bits in word. Set maximum negative integer.
C
C     Purpose.
C     --------
C
C           Set number of bits in word. Set maximum negative integer.
C
C**   Interface.
C     ----------
C
C           CALL SETPAR (KBIT,KNEG,KPR)
C
C           Integer    K.
C           Real       P.
C           Logical    O.
C           Character  H.
C
C               Input Parameters.
C               -----------------
C
C               KPR        - Debug print switch.
C                            1 , print out.
C                            0 , No print out.
C
C               Output Parameters.
C               ------------------
C
C               KBIT       - Number of bits in computer word.
C
C               KNEG       - Maximum negative integer.
C
C     Method.
C     -------
C
C           Values are assigned.
C
C     Externals.
C     ----------
C
C           None.
C
C     Reference.
C     ----------
C
C           None.
C
C     Comments.
C     ---------
C
C           SUN version of routine.
C           Routine contains Sections 0 to 3 and Section 9.
C
C     Author.
C     -------
C
C           J. Hennessy      ECMWF      28.10.91
C
C     Modifications.
C     --------------
C
C           None.
C
C     ------------------------------------------------------------------
C
C
C
C
C
C
C
C
C
C
C*    Section 0 . Definition of variables. Data statements.
C     ------------------------------------------------------------------
C
C*    Prefix conventions for variable names.
C
C     Logical      L (but not LP), global or common.
C                  O, dummy arguments.
C                  G, local variable.
C                  LP, parameter.
C     Character    C, Global or common.
C                  H, dummy arguments.
C                  Y (but not YP), local variables.
C                  YP, parameter.
C     Integer      M and N, global or common.
C                  K, dummy arguments.
C                  I, local variables.
C                  J (but not JP), loop control.
C                  JP, parameter.
C     Real         A to F and Q to X, global or common.
C                  P (but not PP), dummy arguments.
C                  Z, local variables.
C                  PP, parameter.
C
C
      INTEGER KBIT
      INTEGER KNEG
      INTEGER KPR
C
C     ------------------------------------------------------------------
C
C
C
C
C
C
C
C
C
C
C*    Section 1 . Assign values.
C     ------------------------------------------------------------------
C
  100 CONTINUE
C
      IF (KPR.EQ.1)  WRITE (*,*) ' SETPAR : Section 1.'
C
      KBIT = 32
      KNEG = -2147483647
C
C     ------------------------------------------------------------------
C
C
C
C
C
C
C
C
C
C*    Section 9 . Return to calling routine. Format statements.
C     ------------------------------------------------------------------
C
  900 CONTINUE
C
      IF (KPR.EQ.1)
     C   THEN
             WRITE (*,*) ' SETPAR : Section 9.'
             WRITE (*,*) '          Output values set -'
             WRITE (*,9001) KBIT
             WRITE (*,9002) KNEG
         ENDIF
C
 9001 FORMAT (1H ,'          KBIT = ',I3)
C
 9002 FORMAT (1H ,'          KNEG = ',I22)
C
      RETURN
C
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      INTEGER FUNCTION C2DOSD ( KDATA,  KLENP,  KSEC4,  OCOMSD, KLEN,  
     X                          KWORK,  KLWORK, KPOWER, KMXPWR, KPCWID,
     X                          KXCWID, KMINPK, KLWORX, KBIAS,  KWIDSD,
     X                          KWIDOR, OCBIAS, ODEBUG )
C
C---->
C**** C2DOSD
C
C     Purpose.
C     --------
C
C     Depending on actual arguments, Diagnose Order of Spatial
C     Differences, and/or when requested and order is not null,
C     computes spatial differences for GRIB second-order extended
C     packing.
C
C**   Interface.
C     ----------
C
C     IORDER = C2DOSD ( KDATA,  KLENP,  KSEC4,  OCOMSD, KLEN,   KWORK,
C    X                  KLWORK, KPOWER, KMXPWR, KPCWID, KXCWID, KMINPK,
C    X                  KLWORX, KBIAS,  KWIDSD, KWIDOR, OCBIAS, ODEBUG )
C
C     Function result value is the order of spatial differencing
C     (diagnosed or imposed).
C
C     Input Parameters.
C     -----------------
C
C     KDATA      - Array of normalized values.
C     KLENP      - Length of array KDATA.
C     KSEC4      - Array of GRIB section 4 integer descriptors.
C     OCOMSD     - True for COMputing Spatial Differences.
C     KLEN       - Exact number of grid-points to handle.
C     KLWORK     - Length of work array KWORK.
C     KPOWER     - Auxilary array, precomputed (powers of 2)-1.
C     KMXPWR     - Maximum number of bits allowed.
C     KPCWID     - Auxilary array, precomputed widths.
C     KXCWID     - Maximum width associated to KPCWID.
C     KMINPK     - Initial (minimum) length of groups.
C     KBIAS      - BIAS of spatial differences (if OCBIAS is .FALSE.).
C     OCBIAS     - True for Computation of BIAS.
C     ODEBUG     - True for some debug printout.
C
C
C     Output Parameters (effective only if function value is non zero).
C     ------------------
C
C     KDATA      - Array of normalized values (transformed).
C     KWORK      - Work array.
C     KLWORX     - Upper index used within KWORK array.
C     KBIAS      - BIAS of spatial differences.
C     KWIDSD     - WIDth of Spatial Differencing specific descriptors.
C     KWIDOR     - WIDth of field, after possible transformation.
C
C
C     Method.
C     -------
C
C     If requested (KSEC4(14) or KSEC4(15) equal to -1), first
C     compute "best" order of spatial differencing (up to 3) to be
C     applied to KDATA. Estimation is made through comparison of
C     average ranges of original field and of spatial differencing,
C     starting from order 1.
C
C     If requested through OCOMSD and when order is non zero, computes
C     spatial differences on KDATA (keeping the first IORDER values
C     from original field, for encoding).
C
C
C     Externals.
C     ----------
C
C     MAXMNI    - Computes extrema of integer array.
C     C2RNGE    - Computes range diagnostics.
C     C2BITW    - Computes bit width of a positive integer value.
C
C
C     Reference.
C     ----------
C
C     None.
C
C
C     Comments.
C     --------
C
C     Best order is considered reached when average range is found
C     greater than previously diagnosed. This feature is derived from
C     practice, and reduces CPU costs.
C
C     Work array use when diagnostic is requested:
C
C     -if OCOMSD is true and if KLWORK is greater than (or equal to)
C      (2*KLEN-3), there is no recomputation from KDATA itself;
C
C     -if KLWORK is greater than (or equal to) (KLEN-1), then KWORK
C      is used recursively;
C
C     -otherwise, KDATA has to be used in slices and computation is
C      more expensive.
C
C
C     Author.
C     -------
C
C     J. Clochard, Meteo France, for ECMWF - April 1998.
C
C
C     Modifications.
C     _____________
C
C     J. Clochard, June 1999.
C     Use precomputed array to determine widths . Dummy-arguments
C     KPCWID and KXCWID added . Assumption is made that KXCWID
C     is at least (KMXPWR+1)/2 . KPCWID/KXCWID added in C2RNGE calls .
C
C
C----<
C     -----------------------------------------------------------------
C*    Section 0. Definition of variables.
C     -----------------------------------------------------------------
C
      IMPLICIT NONE
C
#include "common/grprs.h"
C
C     Parameters
C
      INTEGER JPORDR
C
C       Maximum order of spatial differencing allowed.
C
      PARAMETER ( JPORDR=3 )
C
C     Subroutine arguments
C
      INTEGER KLENP, KLWORX, KLEN, KLWORK, KMXPWR, KMINPK, KBIAS, KWIDOR
      INTEGER KWIDSD, KXCWID
      INTEGER KDATA (KLENP), KSEC4 (*), KPOWER (0:KMXPWR), KPCWID (0:*)
      INTEGER KWORK (KLWORK)
C
      LOGICAL OCOMSD, ODEBUG, OCBIAS
C
C     Local variables.
C
      INTEGER IBASE, IOFFWK, IREFER, J, INPACK, IMIN, IMAX, IXORDR
      INTEGER INBIFO, ILEN, IMAXAB, IWIDAB, IDIAGN, IOFFWP, ILWORX
      INTEGER JORDER, IORDER, IAUX1, IAUX2, IAUX3, IRANGE, IBITGW
      INTEGER INPACW, INBSEQ, JSEQ, ILWORK, IAUXIL, INPACS, IXBITS
C
      INTEGER IDIAGO ( 0:JPORDR ), IMINAB (JPORDR), INBIAB (JPORDR)
C
      INTEGER C2BITW, C2RNGE
      EXTERNAL C2BITW, C2RNGE
C
      INTRINSIC ABS
C
      LOGICAL L1PASS, LCBIAS, LIBIAS
C
C     -----------------------------------------------------------------
C*    Section 1 . Performs initial checks.
C     -----------------------------------------------------------------
C
  100 CONTINUE
C
#ifndef ebug2o
      IF (ODEBUG) THEN
#endif
        WRITE(GRPRSM,FMT=9100) OCOMSD, OCBIAS
#ifndef ebug2o
      ENDIF
#endif
C
      IXORDR=MIN (JPORDR,KLEN)
      IXBITS=KSEC4(2)
      ILWORX=0
      IBASE=0
      L1PASS=OCOMSD.AND.KLWORK.GE.(KLEN-1)
      LIBIAS=.FALSE.
C
      IF (KSEC4(14).NE.-1.AND.KSEC4(15).NE.-1) THEN
C
C         Order of spatial differencing explicitly specified.
C
        IORDER=MIN ( IXORDR, KSEC4(14)+KSEC4(15) )
        LCBIAS=OCBIAS
        L1PASS=.FALSE.
        GOTO 400
C
      ELSEIF (OCOMSD.AND.KLWORK.GE.2*KLEN-3) THEN
C
        IBASE=KLEN-1
C
      ENDIF
C
      LCBIAS=.FALSE.
C
C     -----------------------------------------------------------------
C*    Section 2 . Computes average range of original normalized values.
C     -----------------------------------------------------------------
C
  200 CONTINUE
C
      INPACK=KLEN/KMINPK
      IDIAGN=0
      IWIDAB=0
      IREFER=0
C
      IOFFWK = C2RNGE ( INPACK, KMINPK, KSEC4(2), KDATA,  IDIAGN,
     X                  IWIDAB, IREFER, KPOWER,   KMXPWR, KPCWID,
     X                  KXCWID )
C
      INBIFO = C2BITW ( IREFER, KSEC4(2), KPOWER, KMXPWR )
C
      IBITGW = C2BITW ( IWIDAB, KSEC4(2), KPOWER, KMXPWR )
C
C     IDIAGN=(IDIAGN+7)/8
      IDIAGN=(IDIAGN+7)/8+(INPACK*IBITGW+7)/8+(INPACK*INBIFO+7)/8
C     IDIAGN=(IDIAGN+7)/8+(INPACK*IBITGW+7)/8
      IDIAGO(0)=IDIAGN
      IORDER=0
C
#ifndef ebug2o
      IF (ODEBUG) THEN
#endif
        PRINT *, 'IDIAGO(0) = ', IDIAGN, INPACK, IBITGW, INBIFO
C
        WRITE(GRPRSM,FMT=9211) 'original values', KMINPK, IDIAGO(0)
#ifndef ebug2o
      ENDIF
C
#endif
C
C     -----------------------------------------------------------------
C*    Section 3 . Computes average range of spatial differences.
C     -----------------------------------------------------------------
C
  300 CONTINUE
C
      IOFFWP=0
      INPACW=KLWORK/KMINPK
      ILWORK=INPACW*KMINPK
C
C           Loop on order of spatial differencing.
C
      DO 329 JORDER=1,IXORDR
C
C           Compute spatial differences.
C
      ILEN=KLEN-JORDER
      INPACK=ILEN/KMINPK
      IDIAGO(JORDER)=0
      IWIDAB=0
      IREFER=-KPOWER(KMXPWR)
      IOFFWK=MOD (JORDER-1,2)*IBASE
      IXBITS=MIN(IXBITS+1,KMXPWR)
C
      IF (L1PASS) THEN
C
        IF (JORDER.EQ.1) THEN
C
          DO 301 J=1,ILEN
          KWORK(IOFFWK+J)=KDATA(J+1)-KDATA(J)
  301     CONTINUE
C
        ELSE
C
#ifdef CRAY
CDIR$ IVDEP
#endif
#ifdef FUJITSU
!OCL NOVREC
#endif
          DO 302 J=1,ILEN
          KWORK(IOFFWK+J)=KWORK(IOFFWP+J+1)-KWORK(IOFFWP+J)
  302     CONTINUE
C
        ENDIF
C
        IOFFWP=IOFFWK
        ILWORX = MAX ( ILWORX, IOFFWK+ILEN )
C
        CALL MAXMNI (KWORK(IOFFWK+1),ILEN,IMAXAB,IMINAB(JORDER))
C
C         Check that extrema difference would not lead to overflow.
C
        IRANGE=IMAXAB/2-IMINAB(JORDER)/2
C
        IF (IRANGE.GT.KPOWER(KMXPWR-1)) THEN
          IORDER=JORDER-1
          WRITE(GRPRSM,FMT=9301) JORDER, IORDER
          GOTO 330
        ENDIF
C
        IAUXIL = C2RNGE ( INPACK, KMINPK, IXBITS, KWORK(IOFFWK+1),
     X                    IDIAGO(JORDER), IWIDAB, IREFER, KPOWER,
     X                    KMXPWR, KPCWID, KXCWID )
C
      ELSE
C
C       Work array too short. Data array processed into slices.
C
        INBSEQ=1+(ILEN-1)/ILWORK
        IMAXAB=-KPOWER(KMXPWR)
        IMINAB(JORDER)=KPOWER(KMXPWR)
C
        DO 314 JSEQ=1,INBSEQ
C
        IAUXIL=MIN (ILWORK,ILEN-(JSEQ-1)*ILWORK)
        INPACS=MIN (INPACW,INPACK-(JSEQ-1)*INPACW)
C
        IF (JORDER.EQ.1) THEN
C
          DO 311 J=1,IAUXIL
          KWORK(J)=KDATA(IOFFWK+J+1)-KDATA(IOFFWK+J)
  311     CONTINUE
C
        ELSEIF (JORDER.EQ.2) THEN
C
          DO 312 J=1,IAUXIL
          IAUX1=KDATA(IOFFWK+J+1)-KDATA(IOFFWK+J  )
          IAUX2=KDATA(IOFFWK+J+2)-KDATA(IOFFWK+J+1)
          KWORK(J)=IAUX2-IAUX1
  312     CONTINUE
C
        ELSE
C
          DO 313 J=1,IAUXIL
          IAUX1=KDATA(IOFFWK+J+1)-KDATA(IOFFWK+J  )
          IAUX2=KDATA(IOFFWK+J+2)-KDATA(IOFFWK+J+1)
          IAUX3=KDATA(IOFFWK+J+3)-KDATA(IOFFWK+J+2)
          KWORK(J)=(IAUX3-IAUX2)-(IAUX2-IAUX1)
  313     CONTINUE
C
        ENDIF
C
        ILWORX = MAX ( ILWORX, IAUXIL )
C
        CALL MAXMNI (KWORK,IAUXIL,IMAX,IMIN)
        IMAXAB=MAX (IMAXAB,IMAX)
        IMINAB(JORDER)=MIN (IMINAB(JORDER),IMIN)
C
C         Check that extrema difference would not lead to overflow.
C
        IRANGE=IMAXAB/2-IMINAB(JORDER)/2
C
        IF (IRANGE.GT.KPOWER(KMXPWR-1)) THEN
          IORDER=JORDER-1
          WRITE(GRPRSM,FMT=9301) JORDER, IORDER
          GOTO 330
        ELSEIF (INPACS.GT.0) THEN
C
          IAUXIL = C2RNGE ( INPACS,         KMINPK, IXBITS, KWORK,
     S                      IDIAGO(JORDER), IWIDAB, IREFER,
     S                      KPOWER,         KMXPWR, KPCWID, KXCWID )
          IOFFWK=IOFFWK+IAUXIL
C
        ENDIF
C
  314   CONTINUE
C
      ENDIF
C
      IRANGE=IMAXAB-IMINAB(JORDER)
C
      INBIAB(JORDER) = C2BITW ( IRANGE, KSEC4(2)+JORDER,
     X                          KPOWER, KMXPWR )
C
      INBIFO = C2BITW ( IREFER, IXBITS, KPOWER, KMXPWR )
C
      IBITGW = C2BITW ( IWIDAB, IXBITS, KPOWER, KMXPWR )
C
      IXBITS=INBIAB(JORDER)
C
C     IDIAGO(JORDER)=(IDIAGO(JORDER)+7)/8
      IDIAGO(JORDER)=(IDIAGO(JORDER)+7)/8+(INPACK*IBITGW+7)/8
     S               +(INPACK*INBIFO+7)/8
C     IDIAGO(JORDER)=(IDIAGO(JORDER)+7)/8+(INPACK*IBITGW+7)/8
C
#ifndef ebug2o
      IF (ODEBUG) THEN
#endif
        PRINT *, 'JORDER=', JORDER, ', IDIAGO(.) = ', IDIAGO(JORDER),
     S           INPACK, IBITGW, INBIFO
C
        WRITE(GRPRSM,FMT=9211) 'spatial differences', KMINPK,
     S                            IDIAGO(JORDER)
#ifndef ebug2o
      ENDIF
C
#endif
C
      IF (IDIAGO(JORDER).LT.IDIAGN) THEN
C
#ifndef ebug2o
        IF (ODEBUG) THEN
#endif
          WRITE(GRPRSM,FMT=9312) 'in favour', JORDER
#ifndef ebug2o
        ENDIF
C
#endif
        IDIAGN=IDIAGO(JORDER)
        IORDER=JORDER
C
      ELSE
C
#ifndef ebug2o
        IF (ODEBUG) THEN
#endif
          WRITE(GRPRSM,FMT=9312) '*NOT* in favour', JORDER
#ifndef ebug2o
        ENDIF
C
#endif
        GOTO 330
C
      ENDIF
C
  329 CONTINUE
C
  330 CONTINUE
C
      LIBIAS=.TRUE.
#ifndef ebug2o
C
      IF (ODEBUG) THEN
#endif
C
        DO 331 J=IORDER+2,JPORDR
        IDIAGO(J)=0
  331   CONTINUE
C
        WRITE(GRPRSM,FMT=9331) IORDER, IDIAGO
#ifndef ebug2o
      ENDIF
#endif
C
C     -----------------------------------------------------------------
C*    Section 4 . Computes spatial differences back into KDATA.
C     -----------------------------------------------------------------
C
  400 CONTINUE
C
      IF (IORDER.EQ.0) THEN
C
C         Prognosis is that spatial differencing is not worth.
C         Nothing more to do then.
C
        GOTO 900
C
      ELSEIF (.NOT.OCOMSD) THEN
C
C         Computing of spatial differences not requested.
C
        GOTO 500
C
      ELSEIF (IBASE.NE.0.OR.(IORDER.EQ.IXORDR.AND.L1PASS)) THEN
C
C         Required data have been computed above, and are still
C         available.
C
        IOFFWK=MOD(IORDER-1,2)*IBASE
#ifdef ebug2o
        PRINT *,'c2dosd - Execution of loop 401, IORDER= ',IORDER,
     X          ', IOFFWK= ',IOFFWK
#endif
C
        DO 401 J=1,KLEN-IORDER
        KDATA(IORDER+J)=KWORK(IOFFWK+J)-IMINAB(IORDER)
  401   CONTINUE
C
      ELSEIF (LCBIAS) THEN
C
C               Spatial differences first computed without bias.
C
        IF (IORDER.EQ.1) THEN
#ifdef ebug2o
C
          PRINT *,'c2dosd - Execution of loop 402, IORDER= ',IORDER
#endif
C
          DO 402 J=KLEN,2,-1
          KDATA(J)=KDATA(J)-KDATA(J-1)
  402     CONTINUE
C
        ELSEIF (IORDER.EQ.2) THEN
#ifdef ebug2o
C
          PRINT *,'c2dosd - Execution of loop 403, IORDER= ',IORDER
#endif
C
          DO 403 J=KLEN,3,-1
          IAUX1=KDATA(J-1)-KDATA(J-2)
          IAUX2=KDATA(J  )-KDATA(J-1)
          KDATA(J)=IAUX2-IAUX1
  403     CONTINUE
C
        ELSE
#ifdef ebug2o
C
          PRINT *,'c2dosd - Execution of loop 404, IORDER= ',IORDER
#endif
C
          DO 404 J=KLEN,4,-1
          IAUX1=KDATA(J-2)-KDATA(J-3)
          IAUX2=KDATA(J-1)-KDATA(J-2)
          IAUX3=KDATA(J  )-KDATA(J-1)
          KDATA(J)=(IAUX3-IAUX2)-(IAUX2-IAUX1)
  404     CONTINUE
C
        ENDIF
C
C             Now compute and remove bias.
C
        ILEN=KLEN-IORDER
        CALL MAXMNI (KDATA(IORDER+1),ILEN,IMAXAB,IMINAB(IORDER))
#ifdef ebug2o
C
        PRINT *,'c2dosd - Execution of loop 405, IORDER= ',IORDER,
     X           ', Computed bias= ',IMINAB(IORDER)
#endif
C
        DO 405 J=IORDER+1,KLEN
        KDATA(J)=KDATA(J)-IMINAB(IORDER)
  405   CONTINUE
C
C             Compute width of spatial differences.
C
        IRANGE=IMAXAB-IMINAB(IORDER)
C
        INBIAB(IORDER) = C2BITW ( IRANGE, KSEC4(2)+IORDER,
     X                            KPOWER, KMXPWR )
C
      ELSEIF (IORDER.EQ.1) THEN
C
C         Explicit computing for 1st-order spatial differences.
C
#ifdef ebug2o
        PRINT *,'c2dosd - Execution of loop 412, IORDER= ',IORDER,
     X           ', Bias= ',KBIAS
C
#endif
        DO 412 J=KLEN,2,-1
        KDATA(J)=KDATA(J)-KDATA(J-1)-KBIAS
  412   CONTINUE
C
      ELSEIF (IORDER.EQ.2) THEN
C
C         Explicit computing for 2nd-order spatial differences.
C
#ifdef ebug2o
        PRINT *,'c2dosd - Execution of loop 413, IORDER= ',IORDER,
     X           ', Bias= ',KBIAS
C
#endif
        DO 413 J=KLEN,3,-1
        IAUX1=KDATA(J-1)-KDATA(J-2)
        IAUX2=KDATA(J  )-KDATA(J-1)
        KDATA(J)=IAUX2-IAUX1-KBIAS
  413   CONTINUE
C
      ELSE
C
C         Explicit computing for 3rd-order spatial differences.
C
#ifdef ebug2o
        PRINT *,'c2dosd - Execution of loop 414, IORDER= ',IORDER,
     X           ', Bias= ',KBIAS
C
#endif
        DO 414 J=KLEN,4,-1
        IAUX1=KDATA(J-2)-KDATA(J-3)
        IAUX2=KDATA(J-1)-KDATA(J-2)
        IAUX3=KDATA(J  )-KDATA(J-1)
        KDATA(J)=(IAUX3-IAUX2)-(IAUX2-IAUX1)-KBIAS
  414   CONTINUE
C
      ENDIF
C
C       Note that the IORDER first values of KDATA are kept unchanged.
C       These "integration constants" will be packed separately.
C
C     -----------------------------------------------------------------
C*    Section 5 . Computes additional descriptors.
C     -----------------------------------------------------------------
C
  500 CONTINUE
C
      IF (LCBIAS.OR.LIBIAS) THEN
C
        KBIAS=IMINAB(IORDER)
        KWIDOR=INBIAB(IORDER)
C
C          Extra descriptors specific to spatial differencing are
C          the IORDER first values of "original" field, the bias
C          of spatial differences, and the width for all of them.
C
        CALL MAXMNI (KDATA,IORDER,IMAX,IMIN)
        IAUX1 = C2BITW ( IMAX, KMXPWR, KPOWER, KMXPWR )
        IAUX2=IABS (KBIAS)
        IAUX3 = C2BITW ( IAUX2, KMXPWR, KPOWER, KMXPWR )
        KWIDSD=MAX (IAUX1,1+IAUX3)
C
#ifndef ebug2o
        IF (ODEBUG) THEN
#endif
          WRITE(GRPRSM,FMT=9420) IORDER, KWIDOR, KWIDSD,
     X                            (KDATA(J),J=1,IORDER), KBIAS
#ifndef ebug2o
        ENDIF
#endif
C
      ENDIF
C
C     -----------------------------------------------------------------
C*    Section 9 . Return to calling routine.
C     -----------------------------------------------------------------
C
  900 CONTINUE
C
      KLWORX=ILWORX
C
      C2DOSD = IORDER
C
#ifndef ebug2o
C
      IF (ODEBUG) THEN
#endif
        WRITE(GRPRSM,FMT=9900) IORDER
#ifndef ebug2o
      ENDIF
#endif
C
      RETURN
C
 9100 FORMAT (' C2DOSD: Function start, OCOMSD = ',L1,', OCBIAS = ',
     X        L1,'.')
C
 9211 FORMAT (' C2DOSD: Approx. s4 length, ',A,',',I3,
     X        '-length groups:',I9,'.')
C
 9301 FORMAT (' C2DOSD: integer overflow for JORDER =',I2,
     X        '. IORDER set to',I2,'.')
C
 9312 FORMAT (' C2DOSD: Range diagnostic is ',A,
     X        ' of spatial differences, order',I2,'.')
 9331 FORMAT (' C2DOSD: Selected order:',I2,', range diagnostics:',
     X        4I8,'.')
C
 9420 FORMAT (' C2DOSD: KWIDSD/KWIDOR/KDATA(1:',I1,')/KBIAS=',2I3,5I11)
C
 9900 FORMAT (' C2DOSD: Function return code =',I3,'.')
C
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE NEXTSUBSET(KBUFL,YBUFF, I,J,KERR )
C
C**** *NEXTSUBSET*
C
C
C     PURPOSE.
C     --------
C
C         SCANS BULLETIN IN 'KCHAR' FOR NEXT '+CrCrLf' CHARACTER.
C
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *NEXTSUBSET((KBUFL,YBUFF, I,J,KERR)*
C         INPUT     : KBUFL - size of ybuff in bytes
C                     YBUFF - character string
C                     I     - scan starts at character I.
C                     J     - scan stops at character J .
C
C         OUTPUT    : I     - position of required character
C                             character not found.
C                     KERR  - return error code

C
C     METHOD.
C     -------
C
C          NONE.
C
C
C     EXTERNALS.
C     ----------
C
C         NONE.
C
C     REFERENCE.
C     ----------
C
C          NONE.
C
C     AUTHOR.
C     -------
C
C          MILAN DRAGOSAVAC    *ECMWF*      05/11/2003
C
C
C     MODIFICATIONS.
C     --------------
C
C          NONE.
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
      character*(*) ybuff
      character*1 plus
      character*4 plcrlf 
C
C     ------------------------------------------------------------------
C*          1.   SCANE BULLETIN FOR NEXT '+CrCrLf'
C                ---------------------------------
 100  CONTINUE
C
      plus='+'
      plcrlf='+'//char(13)//char(13)//char(10)
C

      i = iabs(i)
      k = i
      do 101 i=k,j
         if(ybuff(i-1:i-1).ne.plus.and.ybuff(i:i).eq.plus.and.
     1      ybuff(i+1:i+1).ne.plus) then
            return
         end if
  101 continue
C
      I=J
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE  BUCREKEY(KTDEXP,KSUP,KSEC1,KEY,VALUES,CVALS,KERR)
C**** *BUCREKEY*
C
C
C     PURPOSE.
C     --------
C
C          EXTRACT ELEMENTS NEEDED FOR RDB KEY DEFINITION
C          FROM VALUES AND CVALS ARRAYS.
C
C
C**   INTERFACE.
C     ----------
C
C          NONE.
C
C     METHOD.
C     -------
C
C          NONE.
C
C
C     EXTERNALS.
C     ----------
C
C          NONE.
C
C     REFERENCE.
C     ----------
C
C          NONE.
C
C     AUTHOR.
C     -------
C
C
C          M. DRAGOSAVAC    *ECMWF*       06/02/95.
C
C
C     MODIFICATIONS.
C     --------------
C
C          NONE.
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
C     -------------------------------------------------------------
      DIMENSION KEY(*),KSUP(*),KSEC1(*),KTDEXP(*)
#ifndef R_4
      REAL*8 VALUES(*)
#else
      REAL   VALUES(*)
#endif
      CHARACTER*(*)CVALS(*)
      CHARACTER*5 CBLOCK
C
 100  CONTINUE
C
C     IPAID - AIRCRAFT FLIGHT NUMBER INDEX
C     IPSID - SATELLITE IDENTIFIER INDEX
C     IPBUOY - BUOY/PLATFORM IDENTIFIER INDEX
C     IPARN - AIRCRAFT REGISTRATION NUMBER INDEX
C     IPMET - METAR ICAO ID
C     IPSHIP - SHIPS' CALL SIGN INDEX
C     IPBLOK - WMO BLOCK NUMBER INDEX
C     IPSTAT - WMO STATION NUMBER INDEX
C     IPYEAR - YEAR INDEX
C     IPMONTH - MONTH INDEX
C     IPDAY - DAY INDEX
C     IPHOUR - HOUR INDEX
C     IPMINUTE - MINUTE INDEX
C     IPSECOND - SECOND INDEX
C     IPLAT - LATITUDE INDEX
C     IPLON - LONGITUDE INDEX
C     IPLAT - LATITUDE INDEX
C     IPLON - LONGITUDE INDEX
C 
      KERR=0
C
      IPAID=0
      IPSID=0
      IPBUOY=0
      IPARN=0
      IPMET=0
      IPSHIP=0
      IPBLOK=0
      IPSTAT=0
      IPYEAR=0
      IPMONTH=0
      IPDAY=0
      IPHOUR=0
      IPMINUTE=0
      IPSECOND=0
      IPLAT=0
      IPLON=0
      DO 107 I=16,24
      KEY(I)=32
 107  CONTINUE
C
      IEND = 26
      IF( KSEC1(7).EQ.57 ) IEND = 36
      DO 101 I=1,IEND
      IF(KTDEXP(I).EQ.001006) IPAID=I
      IF(KTDEXP(I).EQ.001007) IPSID=I
      IF(KTDEXP(I).EQ.001005) IPBUOY=I
C     IF(KTDEXP(I).EQ.001008) IPARN=I
      IF(KTDEXP(I).EQ.001063) IPMET=I
      IF(KTDEXP(I).EQ.001011) IPSHIP=I
      IF(KTDEXP(I).EQ.001001) IPBLOK=I
      IF(KTDEXP(I).EQ.001002) IPSTAT=I
      IF(KTDEXP(I).EQ.004001) IPYEAR=I
      IF(KTDEXP(I).EQ.004002) IPMONTH=I
      IF(KTDEXP(I).EQ.004003) IPDAY=I
      IF(KTDEXP(I).EQ.004004) IPHOUR=I
      IF(KTDEXP(I).EQ.004005) IPMINUTE=I
      IF(KTDEXP(I).EQ.004006) IPSECOND=I
      IF(KTDEXP(I).EQ.005001) IPLAT=I
      IF(KTDEXP(I).EQ.006001) IPLON=I
      IF(KTDEXP(I).EQ.005002) IPLAT=I
      IF(KTDEXP(I).EQ.006002) IPLON=I
 101  CONTINUE
C
      KEY(4)=VALUES(IPYEAR)
      KEY(5)=VALUES(IPMONTH)
      KEY(6)=VALUES(IPDAY)
      KEY(7)=VALUES(IPHOUR)
      KEY(8)=VALUES(IPMINUTE)
      IF(IPSECOND.NE.0) KEY(9)=VALUES(IPSECOND)
C
      KEY(10)=NINT(VALUES(IPLON)*100000.+18000000)
      KEY(11)=NINT(VALUES(IPLAT)*100000.+9000000)
      KEY(12)=NINT(VALUES(IPLON)*100000.+18000000)
      KEY(13)=NINT(VALUES(IPLAT)*100000.+9000000)
      KEY(14)=1
C
C        SATELITTE ID
C
      IF(IPSID.NE.0) THEN
         KEY(15)=VALUES(IPSID)
      END IF
C
C        WMO BLOCK AND STATION NUMBER
C
      IF(IPBLOK.NE.0) THEN
         KEY(16)=NINT(VALUES(IPBLOK))*1000+NINT(VALUES(IPSTAT))
         WRITE(CBLOCK,'(I5.5)') KEY(16)
         J=15
         DO 105 I=1,5
         KEY(J+I)=ICHAR(CBLOCK(I:I))
 105     CONTINUE
      END IF
C
C        BUOY/PALTFORM ID
C
      IF(IPBUOY.NE.0) THEN
         KEY(16)=NINT(VALUES(IPBUOY))
         WRITE(CBLOCK,'(I5.5)') KEY(16)
         J=15
         DO 106 I=1,5
         KEY(J+I)=ICHAR(CBLOCK(I:I))
 106     CONTINUE
      END IF
C
C        AIRCRAFT IDENTIFIER
C
      IF(IPAID.NE.0) THEN
        IP=(VALUES(IPAID)/1000)
        INCH=NINT(VALUES(IPAID)-IP*1000)      
        J=15
        DO 102 I=1,INCH
        KEY(J+I)=ICHAR(CVALS(IP)(I:I))
 102    CONTINUE
      END IF
C
C        AIRCRAFT REGISTRATION NUMBER
C
      IF(IPARN.NE.0) THEN      
        IP=(VALUES(IPARN)/1000)
        INCH=NINT(VALUES(IPARN)-IP*1000)
        J=15
        DO 103 I=1,INCH
        KEY(J+I)=ICHAR(CVALS(IP)(I:I))
 103    CONTINUE
      END IF
C
C       SHIP'S CALL SIGN
C
      IF(IPSHIP.NE.0) THEN      
        IP=(VALUES(IPSHIP)/1000)
        INCH=NINT(VALUES(IPSHIP)-IP*1000)
        J=15
        DO 104 I=1,INCH
        KEY(J+I)=ICHAR(CVALS(IP)(I:I))
 104    CONTINUE
      END IF
C
C      METAR ID
C
      IF(IPMET.NE.0) THEN
        IP=(VALUES(IPMET)/1000)
        INCH=NINT(VALUES(IPMET)-IP*1000)
        J=15
        DO 194 I=1,INCH
        KEY(J+I)=ICHAR(CVALS(IP)(I:I))
 194    CONTINUE
      END IF

      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE JSPPOLE(PSHUP,KNUMB,KTRUNC,OMARS,PXF)
      IMPLICIT NONE
C
C---->
C**** *JSPPOLE* - Calculates fourier coefficient for U or V at pole
C
C     Purpose
C     -------
C
C     Calculates fourier coefficient for first harmonic only
C     for U and V wind component at the pole.
C
C     Interface
C     ---------
C
C     CALL JSPPOLE(PSHUP,KNUMB,KTRUNC,OMARS,PXF)
C
C     Input parameters
C     ----------------
C
C     PSHUP    - Unpacked harmonics field, unpacked
C     KNUMB    - 1 for North Pole, otherwise South Pole
C     KTRUNC   - Number (value) of the trucation 
C     OMARS    - .TRUE. if data is from MARS 
C     PXF      - Fourier coefficients (zero on input)
C
C
C     Output parameters
C     -----------------
C
C     PXF(2)   - Single fourier coefficient calculated
C
C
C     Common block usage
C     -----------------
C
C     None.
C
C
C     Externals
C     ---------
C
C     None.
C
C
C     Author
C     ------
C
C     J.D.Chambers     *ECMWF*      Oct 1993
C
C
C     Modifications
C     -------------
C
C     None.
C
C
C     Comments
C     --------
C
C     Created from SPPOLE. 
C     Changed to provide all parameters in the call, i.e. no common
C     blocks are used.
C
C
C     Method
C     ------
C
C     None.
C
C
C     Reference
C     _________
C
C     None.
C
C----<
C     _______________________________________________________
C
C*    Section 0. Definition of variables.
C     _______________________________________________________
C
C*    Prefix conventions for variable names
C
C     Logical      L (but not LP), global or common.
C                  O, dummy argument
C                  G, local variable
C                  LP, parameter.
C     Character    C, global or common.
C                  H, dummy argument
C                  Y (but not YP), local variable
C                  YP, parameter.
C     Integer      M and N, global or common.
C                  K, dummy argument
C                  I, local variable
C                  J (but not JP), loop control
C                  JP, parameter.
C     REAL         A to F and Q to X, global or common.
C                  P (but not PP), dummy argument
C                  Z, local variable
C                  PP, parameter.
C
C     Dummy arguments
C
      COMPLEX   PSHUP
      INTEGER   KNUMB
      INTEGER   KTRUNC
      LOGICAL   OMARS
      COMPLEX   PXF
      DIMENSION PSHUP(*)
      DIMENSION PXF(*)
C
C     Local variables
C
      INTEGER   I1, ITIN1, ITOUT1, JN
      REAL      Z1, Z2, ZNORM, ZP1, ZP2, ZPOL
C 
C     -----------------------------------------------------------
C
C*    1.    Set initial values
C           ------------------
C
 100  CONTINUE
C
      ITIN1  = KTRUNC + 1
      ITOUT1 = KTRUNC
C
      ZPOL = 1.
      IF (KNUMB .NE. 1) ZPOL = -1.0
C
      ZP1  = -1.0
      ZP2  = -3.0 * ZPOL
      I1   = ITIN1 + 1
C
C*    2.    Change normalisation (if flagged as necessary)
C           --------------------
C
 200  CONTINUE
C
      IF (OMARS) THEN
         ZNORM = -SQRT(2.0)
      ELSE
         ZNORM = 1
      ENDIF
C
C
C*    3.    Calculation
C           -----------
C
 300  CONTINUE
      PXF(2) = (0.0,0.0)
C
C     Calculate the fourier coefficient for the first harmonic only.
      DO 310 JN = 1,ITOUT1,2
C
        Z1 = SQRT( (2.0*JN + 1.0)/(2.0*JN*(JN + 1.0)) )
        Z2 = SQRT( (2.0*(JN + 1.0) +1.0)/(2.0*(JN +1.0)*(JN +2.0)) )
C
        IF (JN .EQ. ITOUT1) Z2 = 0.0
C
        PXF(2) = PXF(2) +(Z1*ZP1*PSHUP(I1) +Z2*ZP2*PSHUP(I1+1))*ZNORM
        ZP1   = ZP1 - 2.0*(JN + 1.0) - 1.0
        ZP2   = ZP2 - (2.0*(JN + 2.0) + 1.0)*ZPOL
        I1    = I1 + 2
C
 310  CONTINUE
C
C     -------------------------------------------------------------
C
      RETURN
C
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities
C granted to it by virtue of its status as an intergovernmental organisation
C nor does it submit to any jurisdiction.
C

      INTEGER FUNCTION INTUVU( PVYIN, PDVIN, INLEN,
     X                         PUOUT, PVOUT, OUTLEN)
C
C---->
C**** INTUVU
C
C     Purpose
C     -------
C
C     Interpolate unpacked input vorticity and divergence field to
C     unpacked U and V fields.
C
C
C     Interface
C     ---------
C
C     IERR = INTUVU( PVYIN, PDVIN, INLEN, PUOUT,PVOUT,OUTLEN)
C
C     Input
C     -----
C
C     PVYIN  - Input vorticity field  (unpacked array).
C     PDVIN  - Input divergence field (unpacked array).
C     INLEN  - Input field length (words).
C
C
C     Output
C     ------
C
C     PUOUT  - Output U field (unpacked array).
C     PVOUT  - Output V field (unpacked array).
C     OUTLEN - Output field length (words).
C
C
C     Method
C     ------
C
C     Convert spectral vorticity/divergence to spectral U/V and then
C     interpolate U and V to output fields.
C
C
C     Externals
C     ---------
C
C     JVOD2UV - Converts spectral vorticity/divergence to spectral U/V.
C     JMEMHAN - Allocate scratch memory.
C     INTFAU  - Prepare to interpolate unpacked input field.
C     INTFBU  - Interpolate unpacked input field.
C     INTLOG  - Log error message.
C
C
C     Author
C     ------
C
C     J.D.Chambers     ECMWF     Feb 1995
C
C     J.D.Chambers     ECMWF        Feb 1997
C     Allow for 64-bit pointers
C
C----<
C
      IMPLICIT NONE
C
#include "parim.h"
#include "nifld.common"
#include "nofld.common"
#include "grfixed.h"
#include "intf.h"
#include "current.h"
C
C     Parameters
C
      INTEGER JPROUTINE, JPALLOC, JPSCR3, JPSCR5
      PARAMETER (JPROUTINE = 27000)
      PARAMETER (JPALLOC = 1)
      PARAMETER (JPSCR3 = 3)
      PARAMETER (JPSCR5 = 5)
C
C     Function arguments
C
      INTEGER INLEN, OUTLEN
      REAL PVYIN(INLEN), PDVIN(INLEN), PUOUT(*), PVOUT(*)
C
C     Local variables
C
      CHARACTER*1 HOLDTYP
      CHARACTER*1 HTYPE
      INTEGER IDIVOFF
      INTEGER IERR
      INTEGER IOHOLD(4)
      INTEGER IPVORT
      INTEGER ISIZE
      INTEGER ISZUV
      INTEGER KK
      INTEGER KPR
      INTEGER KPTS(JPGTRUNC*2)
      INTEGER LOOP
      INTEGER MTRUNC
      INTEGER NCOUNT
      INTEGER NGAUSS
      INTEGER NLAT
      INTEGER NLON
      INTEGER NOLD
      INTEGER NTROLD
      INTEGER NTROLD2
      INTEGER NTRUNC
      INTEGER NUMPTS
      INTEGER NUVFLAG
      LOGICAL LFRAME
      LOGICAL LOLDWIND
      LOGICAL LSFCUVI
      LOGICAL LSPCUVI
      LOGICAL LSPECUV
      LOGICAL LSTYLE
      REAL AREA(4)
      REAL EAST
      REAL EW
      REAL GLATS(JPGTRUNC*2)
      REAL GRID(2)
      REAL NORTH
      REAL NS
      REAL OLDGRID(2)
      REAL POLE(2)
      REAL SOUTH
      REAL WEST
C
      LOGICAL LFIRST, LNEWUV
      CHARACTER*3 EXTRA
      DATA LFIRST/.TRUE./, LNEWUV/.TRUE./, EXTRA/'NO '/
      SAVE LFIRST, LNEWUV
C
      DATA NTROLD/-1/, NTROLD2/-1/
      SAVE NTROLD, NTROLD2
      INTEGER IP_U, IP_V

      REAL RGGRID, SWORK
      POINTER (IRGGRID, RGGRID(1) )
      POINTER (ISWORK, SWORK(1) )
#ifndef _CRAYFTN
#ifdef POINTER_64
      INTEGER*8 IZNFLDO
#endif
#endif
      REAL ZNFLDO
      POINTER ( IZNFLDO, ZNFLDO )
      DIMENSION ZNFLDO( 1 )
#ifndef _CRAYFTN
#ifdef POINTER_64
      INTEGER*8 IUV
#endif
#endif
      REAL UV
      POINTER ( IUV, UV )
      DIMENSION UV( 1 )
C
C     Externals
C
      INTEGER INTFAU, INTFBU, AURESOL, DSSAREA, FIXAREA
      INTEGER HIRLAMW, HSH2GG
      INTEGER HRG2GGW, HLL2LLW
      EXTERNAL INTFAU, INTFBU, AURESOL, DSSAREA, FIXAREA
      EXTERNAL HIRLAMW, HSH2GG
      EXTERNAL HRG2GGW, HLL2LLW
C
C     -----------------------------------------------------------------|
C*    Section 1.   Initialise
C     -----------------------------------------------------------------|
C
  100 CONTINUE
      IERR     = 0
      KPR      = 0
      LOLDWIND = .FALSE.
      INTUVU   = 0
C
C
C     Save output area definitions
C
      DO 110 LOOP = 1, 4
        IOHOLD(LOOP) = NOAREA(LOOP)
  110 CONTINUE

      LFRAME = LNOFRAME.AND.
     X         ((NOREPR.EQ.JPREGULAR).OR.(NOREPR.EQ.JPGAUSSIAN).OR.
     X          (NOREPR.EQ.JPREGROT ).OR.(NOREPR.EQ.JPFGGROT  ) )

      IF( LFIRST ) THEN
        CALL GETENV('IGNORE_UV_EXTRA_MODE', EXTRA)
        IF((EXTRA(1:1).EQ.'Y').OR.(EXTRA(1:1).EQ.'y')) LNEWUV = .FALSE.
        IF( LNEWUV ) THEN
          CALL INTLOG(JP_DEBUG,
     X      'INTUVU: IGNORE_UV_EXTRA_MODE not turned on',JPQUIET)
        ELSE
          CALL INTLOG(JP_DEBUG,
     X      'INTUVU: IGNORE_UV_EXTRA_MODE turned on',JPQUIET)
        ENDIF
        LFIRST = .FALSE.
      ENDIF
C
      NOLD = NIRESO
C
      LSPECUV = (NOREPR.EQ.JPSPHERE).OR.(NOREPR.EQ.JPSPHROT)
      LSPCUVI = (NIREPR.EQ.JPSPHERE).OR.(NIREPR.EQ.JPSPHROT)
      LSFCUVI = (.NOT.LSPCUVI).AND.LNOROTA

C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
cs    Regular Gaussian has to be set here
      IF( NOREPR.EQ.JPNOTYPE ) THEN
        IF( (NOGAUSO.NE.NOGAUSS).OR.(HOGAUST.NE.'F') ) THEN
          HTYPE = 'F'
          CALL JGETGG(NOGAUSS,HTYPE,ROGAUSS,NOLPTS,IERR)
          IF( IERR.NE.0 ) THEN
            CALL INTLOG(JP_ERROR,
     X        'INTUVU: JGETGG failed, NOGAUSS = ',NOGAUSS)
            INTUVU = IERR
            GOTO 900
          ENDIF
          NOGAUSO = NOGAUSS
          HOGAUST = HTYPE
        ENDIF
        NOREPR = JPGAUSSIAN
      ENDIF
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C     -----------------------------------------------------------------|
C*    Section 2. Convert spectral vorticity/divergence to spectral U/V
C     -----------------------------------------------------------------|
C
  200 CONTINUE
C
      IF( LSPECUV ) THEN
C
C       Spectral U and V for Tn are to be generated from vorticity
C       and divergence spectral T(n-1)
C
        IF( LARESOL.AND.LNEWUV ) THEN
          IF( (NOGRID(1).NE.0).AND.(NOGRID(2).NE.0) ) THEN
            EW = FLOAT(NOGRID(1))/PPMULT
            NS = FLOAT(NOGRID(2))/PPMULT
            NTRUNC = AURESOL(NS,EW) - 1
          ELSE IF( NOGAUSS.NE.0 ) THEN
            EW = 90.0/FLOAT(NOGAUSS)
            NS = EW
            NTRUNC = AURESOL(NS,EW) - 1
          ELSE IF( LNORESO ) THEN
            NTRUNC = NORESO - 1
          ELSE
            NTRUNC = NIRESO - 1
          ENDIF
          IF( NTRUNC.GT.(NIRESO-1) ) NTRUNC = NIRESO - 1
C
        ELSE IF( LNORESO ) THEN
          NTRUNC = NORESO - 1
        ELSE
          NTRUNC = NIRESO - 1
        ENDIF
C
        IF( LNEWUV ) THEN
          MTRUNC = NTRUNC + 1
        ELSE
          NTRUNC = NTRUNC + 1
          MTRUNC = NTRUNC
        ENDIF
C
C     -----------------------------------------------------------------|
C       Use old-style processing if IGNORE_UV_EXTRA_MODE = Y
C     -----------------------------------------------------------------|
C
        IF( .NOT.LNEWUV ) THEN
C
          CALL INTLOG(JP_DEBUG,'INTUVU: vo/div truncation = ', NIRESO)
C
C         Get scratch memory for U and V spectral fields.
C         U and V memory areas are adjacent.
C
          ISZUV = (NIRESO+1)*(NIRESO+2)
          IP_U = 1
          IP_V = 1 + ISZUV
          CALL JMEMHAN( JPSCR3, IUV, ISZUV*2, JPALLOC, IERR)
          IF ( IERR .NE. 0 ) THEN
            CALL INTLOG(JP_ERROR,'INTUVU: Memory allocn fail',JPQUIET)
            INTUVU = IERR
            GOTO 900
          ENDIF
C
C         Generate U and V with same truncation as input fields.
C
          CALL INTLOG(JP_DEBUG,
     X      'INTUVU: Make intermediate U/V with truncation = ', NIRESO)
C
          CALL JVOD2UV(PVYIN,PDVIN,NIRESO,UV(IP_U),UV(IP_V),NIRESO)
C
C         Is the output a truncated spectral field?
C
          IF( LNORESO ) THEN
C
            CALL INTLOG(JP_DEBUG,
     X        'INTUVU: Produce spectral output with truncation',NORESO)
C
            ISIZE = (NORESO+1)*(NORESO+2)
            CALL JMEMHAN( JPSCR5, IZNFLDO, ISIZE, JPALLOC, IERR)
            IF( IERR.NE.0 ) THEN
              CALL INTLOG(JP_FATAL,'INTUVU: Get scratch fail',JPQUIET)
              INTUVU = JPROUTINE + 2
              GOTO 900
            ENDIF
C
            CALL SH2SH( UV(IP_U), NIRESO, ZNFLDO, NORESO )
            DO LOOP = 1, ISIZE
              PUOUT(LOOP) = ZNFLDO(LOOP)
            ENDDO
C
            CALL SH2SH( UV(IP_V), NIRESO, ZNFLDO, NORESO )
            DO LOOP = 1, ISIZE
              PVOUT(LOOP) = ZNFLDO(LOOP)
            ENDDO
C
            NIRESO = NORESO
C
            OUTLEN = ISZUV

            GOTO 900
C
          ENDIF
C
C     -----------------------------------------------------------------|
C       Use new-style processing if IGNORE_UV_EXTRA_MODE not set
C     -----------------------------------------------------------------|
C
        ELSE
C
          CALL INTLOG(JP_DEBUG,'INTUVU: vo/div truncation = ', NTRUNC)
          CALL INTLOG(JP_DEBUG,'INTUVU: U/V truncation    = ', MTRUNC)
C
C         Truncate vorticity and divergence to correspond to U/V
C
          ISIZE =  (MTRUNC+1)*(MTRUNC+2)
          CALL JMEMHAN( JPSCR5, IZNFLDO, ISIZE*2, JPALLOC, IERR)
          IF( IERR.NE.0 ) THEN
            CALL INTLOG(JP_ERROR,
     X        'INTUVU: Scratch memory type 5 allocn failed.',JPQUIET)
            INTUVU = JPROUTINE + 2
            GOTO 900
          ENDIF
C
          IPVORT = 1
          CALL SH2SH( PVYIN, NIRESO, ZNFLDO, NTRUNC )
C
          IDIVOFF = 1 + (NTRUNC+1)*(NTRUNC+2)
          CALL SH2SH( PDVIN, NIRESO, ZNFLDO(IDIVOFF), NTRUNC )
C
C         Get scratch memory for U and V spectral fields.
C         U and V memory areas are adjacent.
C
          ISZUV = (MTRUNC+1)*(MTRUNC+2)
          IP_U = 1
          IP_V = 1 + ISZUV
C
          ISIZE = ISZUV*2
          CALL JMEMHAN( JPSCR3, IUV, ISIZE, JPALLOC, IERR)
          IF ( IERR .NE. 0 ) THEN
          CALL INTLOG(JP_ERROR,
     X      'INTUVU: Scratch memory type 3 allocation failed.',JPQUIET)
          INTUVU = IERR
          GOTO 900
        ENDIF
C
C       Generate U and V spectral fields
C
          CALL JVOD2UV(ZNFLDO(IPVORT),ZNFLDO(IDIVOFF),NTRUNC,
     X                 UV(IP_U),UV(IP_V),MTRUNC)
C
          DO LOOP = 1, ISZUV
            PUOUT(LOOP) = UV(LOOP)
            PVOUT(LOOP) = UV(LOOP+ISZUV)
          ENDDO
C
C
          OUTLEN = ISZUV
cs  added in case of packing after conversion
          NORESO = MTRUNC
C
          GOTO 900
C
        ENDIF
C
      ENDIF
C
C     -----------------------------------------------------------------|
C*    Section 3.   Generate grid point GRIB format U and V fields.
C     -----------------------------------------------------------------|
C
  300 CONTINUE
C
cs    this is for merging with grib_api
      LUVCOMP = .FALSE.
C     Spectral U and V for Tn are to be generated from vorticity
C     and divergence spectral T(n-1)
C
C     See whether or not the 'autoresol' flag is set.
C     If not, use the input truncation.
C
      IF( LARESOL ) THEN
        IF( (NOREPR.EQ.JPREGULAR).OR.(NOREPR.EQ.JPREGROT) ) THEN
          EW = FLOAT(NOGRID(1))/PPMULT
          NS = FLOAT(NOGRID(2))/PPMULT
        ELSE
          EW = 90.0/FLOAT(NOGAUSS)
          NS = EW
        ENDIF
        NTRUNC = AURESOL(EW,NS)
        IF( NTRUNC.NE.NTROLD ) THEN
          NTROLD = NTRUNC
          CALL INTLOG(JP_WARN,
     X      'INTUVU: Resolution automatically set to ', NTRUNC)
        ENDIF
      ELSE IF( LNORESO ) THEN
        NTRUNC = NORESO
      ELSE
        NTRUNC = NIRESO
      ENDIF
C
C     Check whether the output resolution is greater than the input
C
      IF( NTRUNC.GT.NIRESO ) THEN
C
C       Issue warning if the output resolution was user-supplied
C
        IF( .NOT.LARESOL ) THEN
C
C         Revert to the input truncation
C
          IF( NIRESO.NE.NTROLD2 ) THEN
            CALL INTLOG(JP_WARN,
     X        'INTUVU: spectral -> grid point interpolation',JPQUIET)
            CALL INTLOG(JP_WARN,
     X        'INTUVU: User supplied resolution = ',NTRUNC)
            CALL INTLOG(JP_WARN,
     X        'INTUVU: Input field resolution   = ',NIRESO)
            CALL INTLOG(JP_WARN,
     X        'INTUVU: User supplied resolution ignored',JPQUIET)
            CALL INTLOG(JP_WARN,
     X        'INTUVU: Input field resolution has been used',JPQUIET)
            NTROLD2 = NIRESO
          ENDIF
          NTRUNC = NIRESO
C
        ELSE
C
C         Revert to the input truncation
C
          NTRUNC = NIRESO
          IF( NTRUNC.NE.NTROLD2 ) THEN
            NTROLD2 = NTRUNC
            CALL INTLOG(JP_WARN,
     X        'INTUVU: Automatic resolution selectn too high',JPQUIET)
            CALL INTLOG(JP_WARN,
     X        'INTUVU: Resolution reset to input resolution: ',NTRUNC)
          ENDIF
C
        ENDIF
      ENDIF
C
C     IF extra mode is in use, adjust the calculated truncation.
C
      MTRUNC = NTRUNC
      IF( LNEWUV ) NTRUNC = MTRUNC - 1
C
      CALL INTLOG(JP_DEBUG,'INTUVU: vo/div truncation = ', NTRUNC)
      CALL INTLOG(JP_DEBUG,'INTUVU: U/V truncation    = ', MTRUNC)
C
      ISIZE = (MTRUNC+1)*(MTRUNC+2)
      CALL JMEMHAN( JPSCR5, IZNFLDO, ISIZE*2, JPALLOC, IERR)
      IF( IERR.NE.0 ) THEN
        CALL INTLOG(JP_FATAL,
     X    'INTUVU: Get scratch space failed',JPQUIET)
        INTUVU = JPROUTINE + 3
        GOTO 900
      ENDIF
C
C     Adjust the vorticity and divergence by one wave number before
C     conversion to U and V
C
      IPVORT = 1
      IDIVOFF = 1 + (NTRUNC+1)*(NTRUNC+2)
C
      CALL SH2SH( PVYIN, NIRESO, ZNFLDO, NTRUNC )
C
      CALL SH2SH( PDVIN, NIRESO, ZNFLDO(IDIVOFF), NTRUNC )
C
C     Get scratch memory for U and V spectral fields.
C     U and V memory areas are adjacent.
C
      ISZUV = (MTRUNC+1)*(MTRUNC+2)
      IP_U  = 1
      IP_V  = IP_U + ISZUV
C
      ISIZE = ISZUV*2
      CALL JMEMHAN( JPSCR3, IUV, ISIZE, JPALLOC, IERR)
      IF( IERR.NE.0 ) THEN
        CALL INTLOG(JP_ERROR,
     X    'INTUVU: Scratch memory type 3 allocation failed.',JPQUIET)
        INTUVU = IERR
        GOTO 900
      ENDIF
C
C     Generate U and V spectral fields
C
      CALL JVOD2UV(ZNFLDO(IPVORT),ZNFLDO(IDIVOFF),NTRUNC,
     X             UV(IP_U),UV(IP_V),MTRUNC)
C
      NIRESO = MTRUNC
C
C
      LSTYLE = LNOSTYLE.AND.
     X         (NOSTYLE.EQ.JPSDISM).AND.
     X         (NOREPR.EQ.JPREGULAR)
C
        IF( LSTYLE ) THEN
            EW    = NOGRID(1) / PPMULT
            NS    = NOGRID(2) / PPMULT
            NORTH = REAL(NOAREA(1)) / PPMULT
            WEST  = REAL(NOAREA(2)) / PPMULT
            SOUTH = REAL(NOAREA(3)) / PPMULT
            EAST  = REAL(NOAREA(4)) / PPMULT
C
            IERR = DSSAREA( EW, NS, NORTH, WEST, SOUTH, EAST)
            IF( IERR.NE.0 ) THEN
              CALL INTLOG(JP_ERROR,'INTUVU: DSSAREA failed:',IERR)
              INTUVU = JPROUTINE + 3
              GOTO 900
            ENDIF
C
            NOAREA(1) = NINT(NORTH * PPMULT)
            NOAREA(2) = NINT(WEST  * PPMULT)
            NOAREA(3) = NINT(SOUTH * PPMULT)
            NOAREA(4) = NINT(EAST  * PPMULT)
         ELSE
C           Fixup area definition to correspond to grid definitions
             IERR = FIXAREA()
             IF ( IERR .NE. 0 ) THEN
               CALL INTLOG(JP_ERROR,
     X           'INTUVU: Fixup area definition failed.',JPQUIET)
               INTUVU = IERR
               GOTO 900
             ENDIF
         ENDIF
      DO KK = 1,4
          NOAAPI(KK) = NOAREA(KK)
      ENDDO

      NIFORM = 0
      NIPARAM = JP_U
      LWIND = .TRUE.
      LOLDWIND = LWINDSET
      LWINDSET = .TRUE.
C
      IF(LSFCUVI)   GOTO 850
      IF( LNOROTA ) GOTO 700

C     -----------------------------------------------------------------|
C*    Section 4.   Interpolate U field.
C     -----------------------------------------------------------------|
C
  400 CONTINUE
C
      IERR = INTFAU( UV(IP_U), ISZUV, PUOUT, OUTLEN)
      IF ( IERR .NE. 0 ) THEN
        CALL INTLOG(JP_ERROR,
     X    'INTUVU: Prepare to interpolate failed.',JPQUIET)
        INTUVU = IERR
        GOTO 900
      ENDIF
C
      IERR = INTFBU( UV(IP_U), ISZUV, PUOUT, OUTLEN)
C
      IF ( IERR .NE. 0 ) THEN
        CALL INTLOG(JP_ERROR,'INTUVU: Interpolation failed.',JPQUIET)
        INTUVU = IERR
        GOTO 900
      ENDIF
C
C     -----------------------------------------------------------------|
C*    Section 5.   Interpolate V field.
C     -----------------------------------------------------------------|
C
  500 CONTINUE
C
      NIPARAM = JP_V
      IERR = INTFAU( UV(IP_V), ISZUV, PVOUT, OUTLEN)
      IF ( IERR .NE. 0 ) THEN
        CALL INTLOG(JP_ERROR,
     X    'INTUVU: Prepare to interpolate failed.',JPQUIET)
        INTUVU = IERR
        GOTO 900
      ENDIF
C
      IERR = INTFBU( UV(IP_V), ISZUV, PVOUT, OUTLEN)
C
      IF ( IERR .NE. 0 ) THEN
        CALL INTLOG(JP_ERROR,
     X    'INTUVU: INTFBU interpolate failed.',JPQUIET)
        INTUVU = IERR
        GOTO 900
      ENDIF

cs      GOTO 900
       GOTO 890
C
C     -----------------------------------------------------------------|
C*    Section 6.  Initialise spectral to grid-point with rotation
C     -----------------------------------------------------------------|
C
  700 CONTINUE
      IF( .NOT.LUSEHIR ) THEN
        CALL INTLOG(JP_ERROR,
     X    'INTUVU: Unable to rotate spectral U or V:',JPQUIET)
        INTUVU  = JPROUTINE + 6
        GOTO 900
      ENDIF
C
      IF( (NOREPR.NE.JPREGROT).AND.(NOREPR.NE.JPREGULAR) ) THEN
        CALL INTLOG(JP_ERROR,
     X    'INTUVU: For U/V, only regular lat/long',JPQUIET)
        CALL INTLOG(JP_ERROR,
     X    'INTUVU: output rotated grids allowed',JPQUIET)
        INTUVU  = JPROUTINE + 6
        GOTO 900
      ENDIF
C
cs this is for merging with grib_api
      LUVCOMP = .TRUE.
      CALL INTLOG(JP_DEBUG,'INTUVU: Rotate the U & V fields',JPQUIET)
      CALL INTLOG(JP_DEBUG,'INTUVU: South pole lat  ',NOROTA(1))
      CALL INTLOG(JP_DEBUG,'INTUVU: South pole long ',NOROTA(2))
C
C     Fill area limits (handles case when default 0/0/0/0 given)
C
cssssssssss
cs      IERR = FIXAREA()
cs      IF( IERR.NE.0 ) THEN
cs        CALL INTLOG(JP_ERROR,'INTUVU: area fixup failed',JPQUIET)
cs        INTUVU = JPROUTINE + 6
cs        GOTO 900
cs      ENDIF
C
      AREA(1) = REAL(NOAREA(1))/PPMULT
      AREA(2) = REAL(NOAREA(2))/PPMULT
      AREA(3) = REAL(NOAREA(3))/PPMULT
      AREA(4) = REAL(NOAREA(4))/PPMULT
C
      GRID(1) = REAL(NOGRID(1))/PPMULT
      GRID(2) = REAL(NOGRID(2))/PPMULT
C
      POLE(1) = REAL(NOROTA(1))/PPMULT
      POLE(2) = REAL(NOROTA(2))/PPMULT
C
C     -----------------------------------------------------------------|
C*    Section 7.   Convert spectral to suitable global reduced gaussian
C     -----------------------------------------------------------------|
C
  800 CONTINUE
C
      NTRUNC = NIRESO
      NGAUSS = 0
      HTYPE  = ''
      NS = 0.
      EW = 0.
      IERR = HSH2GG(NS,EW,NTRUNC,NGAUSS,HTYPE,KPTS,GLATS,ISIZE)
      IF( IERR.NE.0 ) THEN
        CALL INTLOG(JP_ERROR,
     X    'INTUVU: problem getting data for reduced grid',NTRUNC)
        INTUVU = JPROUTINE + 7
        GOTO 900
      ENDIF
      NCOUNT = ISIZE
C
C     Dynamically allocate memory for global reduced gaussian grid
C
      CALL JMEMHAN( 18, IRGGRID, (NCOUNT*2), 1, IERR)
      IF( IERR.NE.0 ) THEN
        CALL INTLOG(JP_ERROR,
     X    'INTUVU: memory alloc for reduced grid fail',JPQUIET)
        INTUVU = JPROUTINE + 7
        GOTO 900
      ENDIF
C
C     Set flag to show field is a wind component
C
      NUVFLAG = 1
C
C     Create the reduced gaussian grid
C
      HOLDTYP = HOGAUST
      WEST = 0.0
      EAST = 360.0 - (360.0/FLOAT(KPTS(NGAUSS)))
C
C     U component
C
      CALL JAGGGP(UV(IP_U),NTRUNC,GLATS(1),GLATS(NGAUSS*2),WEST,
     X            EAST,NGAUSS,HTYPE,KPTS,RGGRID,NUVFLAG,IERR)
      IF( IERR.NE.0 ) THEN
        CALL INTLOG(JP_ERROR,
     X    'INTUVU: spectral to reduced gaussian failed',JPQUIET)
        INTUVU = JPROUTINE + 7
        GOTO 900
      ENDIF
C
      HOGAUST = HOLDTYP
C
C     V component
C
      CALL JAGGGP(UV(IP_V),NTRUNC,GLATS(1),GLATS(NGAUSS*2),WEST,
     X            EAST,NGAUSS,HTYPE,KPTS,RGGRID(1+NCOUNT),NUVFLAG,IERR)
      IF( IERR.NE.0 ) THEN
        CALL INTLOG(JP_ERROR,
     X    'INTUVU: spectral to reduced gaussian failed',JPQUIET)
        INTUVU = JPROUTINE + 7
        GOTO 900
      ENDIF

      HOGAUST = HOLDTYP


C     -----------------------------------------------------------------|
C*    Section 8.   Rotate using 12-point horizontal interpolation
C     -----------------------------------------------------------------|
C
  810 CONTINUE
C
C     Dynamically allocate memory for rotated lat/long grid
C
      NLON = 1 + NINT(FLOAT(NOAREA(JPEAST)  - NOAREA(JPWEST)) /
     X       NOGRID(JPWESTEP))
      NLAT = 1 + NINT(FLOAT(NOAREA(JPNORTH) - NOAREA(JPSOUTH)) /
     X       NOGRID(JPNSSTEP))
C
      NUMPTS = NLON * NLAT
      ISIZE  = NUMPTS * 2
      CALL JMEMHAN( 11, ISWORK, ISIZE, 1, IERR)
      IF( IERR.NE.0 ) THEN
        CALL INTLOG(JP_ERROR,
     X    'INTUVU: memory alloc for lat/long grid fail',JPQUIET)
        INTUVU = JPROUTINE + 8
        GOTO 900
      ENDIF
C
      IERR = HIRLAMW(LO12PT,RGGRID,RGGRID(1+NCOUNT),NCOUNT,NGAUSS,HTYPE,
     X  AREA,POLE,GRID,SWORK,SWORK(1+NUMPTS),NUMPTS,NLON,NLAT)
C
      IF( IERR.NE.0 ) THEN
        CALL INTLOG(JP_ERROR,
     X    'INTUVU: HIRLAMW rotation failed',JPQUIET)
        INTUVU = JPROUTINE + 8
        GOTO 900
      ENDIF
c
      DO LOOP = 1, NUMPTS
          PUOUT(LOOP) = SWORK(LOOP)
          PVOUT(LOOP) = SWORK(LOOP+NUMPTS)
      ENDDO

      OUTLEN = NUMPTS

cs       GOTO 900
       GOTO 890
c     -----------------------------------------------------------------|
C*    Section 8.1   Grid to rotated grid  point
C     -----------------------------------------------------------------|
  850 CONTINUE
C*    8.1a   Generate interpolated lat/long U and V fields.
C     -----------------------------------------------------------------|
C
cs this is for merging with grib_api
      LUVCOMP = .TRUE.
C
      IF( (NOREPR.EQ.JPREGULAR).OR.(NOREPR.EQ.JPREGROT) ) THEN
C
C       Dynamically allocate scrath space for rotated lat/long grid
C
        NLON = 1 + NINT(FLOAT(NOAREA(JPEAST)  - NOAREA(JPWEST)) /
     X         NOGRID(JPWESTEP))
        NLAT = 1 + NINT(FLOAT(NOAREA(JPNORTH) - NOAREA(JPSOUTH)) /
     X         NOGRID(JPNSSTEP))
C
        NOWE = NLON
        NONS = NLAT
        OUTLEN = NLON * NLAT
C
C       Rotate reduced gaussian to lat/long
C
        IF( (NIREPR.EQ.JPGAUSSIAN).OR.(NIREPR.EQ.JPQUASI) ) THEN
        CALL INTLOG(JP_DEBUG,
     X    'INTUVU: Rotate reduced gaussian to lat/long',JPQUIET)
          IERR = HIRLAMW(LO12PT,
     X                   PVYIN,PDVIN,INLEN,
     X                   NOGAUSS,HTYPE,AREA,POLE,GRID,
     X                   PUOUT,PVOUT,OUTLEN,NLON,NLAT)
          IF( IERR.NE.0 ) THEN
            CALL INTLOG(JP_ERROR,
     X        'INTUVU: HIRLAMW rotation failed',JPQUIET)
            INTUVU = JPROUTINE + 8
            GOTO 900
          ENDIF
C
C       Rotate lat/long to lat/long
C
        ELSE
        CALL INTLOG(JP_DEBUG,
     X    'INTUVU: Rotate lat/long to lat/long',JPQUIET)
          OLDGRID(1) = REAL(NIGRID(1)) / PPMULT
          OLDGRID(2) = REAL(NIGRID(2)) / PPMULT
          IERR = HLL2LLW(LO12PT,PVYIN,PDVIN,
     X                   OLDGRID,AREA,POLE,GRID,
     X                   PUOUT,PVOUT,OUTLEN,NLON,NLAT)
          IF( IERR.NE.0 ) THEN
            CALL INTLOG(JP_ERROR,
     X        'INTUVU: HLL2LLW rotation failed',JPQUIET)
            INTUVU = JPROUTINE + 8
            GOTO 900
          ENDIF
        ENDIF
C
      ELSE

*    Section 8.1b   Generate interpolated gaussian U and V fields.
C     -----------------------------------------------------------------|
C
C
        CALL INTLOG(JP_DEBUG,
     X    'INTUVU: Rotate gaussian to gaussian',JPQUIET)
C
C       Dynamically allocate memory for rotated gaussian grids
C
        NUMPTS = NOGAUSS * NOGAUSS
        OUTLEN = 2 * NUMPTS * 8
C
cs        NGAUSS = ISEC2(10)
        IERR = HRG2GGW(LO12PT,
     X                 PVYIN,PDVIN,INLEN,
     X                 NIGAUSS,AREA,POLE,NOGAUSS,HOGAUST,
     X                 PUOUT,PVOUT,OUTLEN,NUMPTS)
        IF( IERR.NE.0 ) THEN
          CALL INTLOG(JP_ERROR,
     X        'INTUVU: HRG2GGW rotation failed',JPQUIET)
            INTUVU = JPROUTINE + 8
            GOTO 900
          ENDIF
C
      ENDIF
C
  890 CONTINUE
      IF( LFRAME ) THEN
        NLON = 1 + NINT(FLOAT(NOAREA(JPEAST)  - NOAREA(JPWEST)) /
     X         NOGRID(JPWESTEP))
        NLAT = 1 + NINT(FLOAT(NOAREA(JPNORTH) - NOAREA(JPSOUTH)) /
     X         NOGRID(JPNSSTEP))
        ISEC1(5) = 192
        ISEC3(2) = NINT(RMISSGV)
        ZSEC3(2) = RMISSGV
        LIMISSV = .TRUE.
        CALL MKFRAME(NLON,NLAT,PUOUT,RMISSGV,NOFRAME)
        CALL MKFRAME(NLON,NLAT,PVOUT,RMISSGV,NOFRAME)
      ENDIF

C
C
C     -----------------------------------------------------------------|
C*    Section 9.   Closedown.
C     -----------------------------------------------------------------|
C
  900 CONTINUE
C
C     Clear change flags for next product processing
      LCHANGE = .FALSE.
      LSMCHNG = .FALSE.
      LWINDSET = LOLDWIND
      DO 910 LOOP = 1, 4
        NOAREA(LOOP) = IOHOLD(LOOP)
  910 CONTINUE
C
      NIRESO = NOLD
C
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE NEXTSEC(KBUFL,YBUFF, I,J,KERR )
C
C**** *NEXTSEC*
C
C
C     PURPOSE.
C     --------
C
C         Scan ybuff for '++' characters
C
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *NEXTSEC(I,J)*
C         INPUT     : KBUFL - size of ybuff in bytes
C                     YBUFF - character string
C                     I     - scan starts at word I.
C                     J     - scan stops at word J .
C
C         OUTPUT    : I     - position of required character.
C                     KERR  - error code

C
C     METHOD.
C     -------
C
C          NONE.
C
C
C     EXTERNALS.
C     ----------
C
C         NONE.
C
C     REFERENCE.
C     ----------
C
C          NONE.
C
C     AUTHOR.
C     -------
C
C          MILAN DRAGOSAVAC    *ECMWF*      07/01/2004.
C
C
C     MODIFICATIONS.
C     --------------
C
C          NONE.
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
      CHARACTER*(*) YBUFF
      CHARACTER*2 plusplus
C
C     ------------------------------------------------------------------
C*          1.   SCANE BULLETIN FOR NEXT '=' SIGN.
C                ---------------------------------
 100  CONTINUE
C
      plusplus='++'
C
      
      i = iabs(i)
      k = i
      do 101 i=k,j
         if(ybuff(i:i+1).eq.plusplus) return
  101 continue
C
      i=j
      RETURN
      END

      PROGRAM BUFR0T2
C
C**** *BUFR0T2*
C
C
C     PURPOSE.
C     --------
C        CONVERT BUFR EDITION 0 TO BUFR EDITION 2 MESSAGES
C
C
C**   INTERFACE.
C     ----------
C
C          NONE.
C
C     METHOD.
C     -------
C
C          NONE.
C
C
C     EXTERNALS.
C     ----------
C
C         CALL BUSEL
C         CALL BUFREX
C         CALL BUFREN
C         CALL BUPRS0
C         CALL BUPRS1
C         CALL BUPRS2
C         CALL BUPRS3
C         CALL BUPRT
C         CALL BUUKEY
C
C     REFERENCE.
C     ----------
C
C          NONE.
C
C     AUTHOR.
C     -------
C
C          M. DRAGOSAVAC    *ECMWF*       15/09/94
C
C
C     MODIFICATIONS.
C     --------------
C
C          NONE.
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
      PARAMETER(JSUP =   9,JSEC0=   3,JSEC1= 40,JSEC2=4096 ,JSEC3= 4,
     1       JSEC4=   2,JELEM=160000,JSUBS=400,JCVAL=150 ,JBUFL=512000,
#ifdef JBPW_64
     2      JBPW =  64,JTAB =3000,JCTAB=120,JCTST=1800,JCTEXT=1200,
#else
     2      JBPW =  32,JTAB =3000,JCTAB=120,JCTST=1800,JCTEXT=1200,
#endif
     3      JWORK=4096000,JKEY=46,JBYTE=512000)
C
      PARAMETER (KELEM=160000)
      PARAMETER (KVALS=4096000)
C 
      DIMENSION KBUFF(JBUFL)
      DIMENSION KBUFR(JBUFL)
      DIMENSION KSUP(JSUP)  ,KSEC0(JSEC0),KSEC1(JSEC1)
      DIMENSION KSEC2(JSEC2),KSEC3(JSEC3),KSEC4(JSEC4)
      DIMENSION KEY  (JKEY)
C
      REAL*8 VALUES(KVALS),VALUE(KVALS),VALS(KVALS)
      REAL*8 RVIND,EPS
C
      DIMENSION KTDLST(KELEM),KTDEXP(KELEM)
      DIMENSION KTDLST1(KELEM),KTDEXP1(KELEM)
      DIMENSION KDATA(200)
C
      CHARACTER*256 CF,CF1
      CHARACTER*64 CNAMES(KELEM)
      CHARACTER*24 CUNITS(KELEM)
      CHARACTER*80 CVALS(KVALS)
      CHARACTER*80 CVAL(KVALS)
      CHARACTER*80 YENC
      CHARACTER*9  CSHIP
      CHARACTER*256 CINFILE,COUTFILE,CARG(4)
C
C     ------------------------------------------------------------------
C*          1. INITIALIZE CONSTANTS AND VARIABLES.
C              -----------------------------------
 100  CONTINUE
C
C     MISSING VALUE INDICATOR
C 
      RVIND=1.7D38
      EPS=10.D-8
      NREAD=0 
      NBYTPW=JBPW/8
      N=0
C
C     GET INPUT AND OUTPUT FILE NAME.
C
      NARG=IARGC()
C
      IF(NARG.LT.4) THEN
         PRINT*,'USAGE -- bufr_0t2 -i infile -o outfile'
         STOP
      END IF
C
      DO 101 J=1,NARG
      CALL GETARG(J,CARG(J))
 101  CONTINUE
C
      DO 102 J=1,NARG,2
      IF(CARG(J).EQ.'-i') THEN
         CINFILE=CARG(J+1)
      ELSEIF(CARG(J).EQ.'-o') THEN
         COUTFILE=CARG(J+1)
      ELSE
          PRINT*,'USAGE -- bufr_0t2 -i infile -o outfile'
          STOP
      END IF
 102  CONTINUE
C
      II=INDEX(CINFILE,' ')
      JJ=INDEX(COUTFILE,' ')
      II=II-1
      JJ=JJ-1
      KRQL=0
      NW=0
      NR=0
C
C*          1.2 OPEN FILE CONTAINING BUFR DATA.
C               -------------------------------
 120  CONTINUE
C
      IRET=0 
      CALL PBOPEN(IUNIT,CINFILE(1:II),'R',IRET)
      IF(IRET.EQ.-1) STOP 'OPEN FAILED'
      IF(IRET.EQ.-2) STOP 'INVALID FILE NAME'
      IF(IRET.EQ.-3) STOP 'INVALID OPEN MODE SPECIFIED'
C
      CALL PBOPEN(IUNIT1,COUTFILE(1:JJ),'W',IRET)
      IF(IRET.EQ.-1) STOP 'OPEN FAILED ON BUFR.DAT'
      IF(IRET.EQ.-2) STOP 'INVALID FILE NAME'
      IF(IRET.EQ.-3) STOP 'INVALID OPEN MODE SPECIFIED'
C
C     ----------------------------------------------------------------- 
C*          2. SET REQUEST FOR EXPANSION.
C              --------------------------
 200  CONTINUE
C
      OPRT=.FALSE.
      ICODE=0
      OENC=.TRUE.
      OCOMP=.FALSE.
      NR=1
C
 201  CONTINUE
C
      OSEC3=.FALSE.
C
C*          2.1 SET REQUEST FOR PARTIAL EXPANSION.
C               ----------------------------------
 210  CONTINUE
C
C     -----------------------------------------------------------------
C*          3.  READ BUFR MESSAGE.
C               ------------------
 300  CONTINUE
C
      IERR=0
      KBUFL=0
C
      IRET=0
      CALL PBBUFR(IUNIT,KBUFF,JBYTE,KBUFL,IRET) 
      IF(IRET.EQ.-1) THEN
          PRINT*,'NUMBER OF ORIGINAL  MESSAGES  ',NREAD
          PRINT*,'NUMBER OF CONVERTED MESSAGES  ',NW
          GO TO 900
      END IF
      IF(IRET.EQ.-2) STOP 'FILE HANDLING PROBLEM' 
      IF(IRET.EQ.-3) STOP 'ARRAY TOO SMALL FOR PRODUCT'
C
      NREAD=NREAD+1
      N=N+1
      NBYTES=KBUFL
      KBUFL=KBUFL/NBYTPW+1
      IF(NREAD.LT.NR) GO TO 300
C
C     -----------------------------------------------------------------
C*          4. EXPAND BUFR MESSAGE.
C              --------------------
 400  CONTINUE
C
      KERR=0
      CALL BUS012(KBUFL,KBUFF,KSUP,KSEC0,KSEC1,KSEC2,KERR)
      IF(KERR.NE.0) THEN
         PRINT*,'ERROR IN BUS012: ',KERR
         PRINT*,' BUFR MESSAGE NUMBER ',N,' CORRUPTED.'
         CALL MY_EXIT(2)
      END IF
C
C          BUFR EDITION 2 DATA WILL NOT BE CONVERTED
C
      IF(KSEC0(3).EQ.2.AND.KSEC1(7).NE.142) THEN
C         PRINT*,'BUFR SUBTYPE ',KSEC1(7),'  NOT CONVERTED'
         CALL PBWRITE(IUNIT1,KBUFF,NBYTES,IERR)
         IF(IRET.EQ.-1) THEN
            PRINT*,'ERROR DURING WRITE ON BUFR.DAT'
            CALL MY_EXIT(2)
         END IF
         NW=NW+1
         GO TO 300
      END IF
C
      IERR=0
      IF(KSUP(6).GT.1) THEN
         KEL=JWORK/KSUP(6)
      ELSE
         KEL=KELEM
      END IF
C
      CALL BUFREX(KBUFL,KBUFF,KSUP,KSEC0 ,KSEC1,KSEC2 ,
     1            KSEC3 ,KSEC4,KEL,CNAMES,CUNITS,KVALS,
     2            VALUES,CVALS,IERR)
C
      IF(IERR.NE.0)  THEN
         IF(IERR.EQ.2) THEN
            IERR=0
            GO TO 410
         ELSE
            PRINT*,'BUFREX: ERROR ', IERR
            CALL MY_EXIT(2)
         END IF
      END IF
C
C
C*          4.1 PRINT CONTENT OF EXPANDED DATA.
C               -------------------------------
 410  CONTINUE
C
      IF(.NOT.OPRT) GO TO 500
      IF(.NOT.OSEC3) GO TO 450
C
C*          4.2 PRINT SECTION ZERO OF BUFR MESSAGE.
C               -----------------------------------
 420  CONTINUE
C

      CALL BUPRS0(KSEC0)
C
C*          4.3 PRINT SECTION ONE OF BUFR MESSAGE.
C               -----------------------------------
 430  CONTINUE
C
      CALL BUPRS1(KSEC1)
C
C
C*          4.4 PRINT SECTION TWO OF BUFR MESSAGE.
C               -----------------------------------
 440  CONTINUE
C
C              AT ECMWF SECTION 2 CONTAINS RDB KEY.
C              SO UNPACK KEY
C
      CALL BUUKEY(KSEC1,KSEC2,KEY,KSUP,KERR)
      IF(KERR.NE.0) THEN
         PRINT*,'BUUKEY:ERROR ',KERR
         CALL MY_EXIT(2)
      END IF

C
C              PRINT KEY
C
      CALL BUPRS2(KSUP ,KEY)
C
C*          4.5 PRINT SECTION 3 OF BUFR MESSAGE.
C               -----------------------------------
 450  CONTINUE
C
C               FIRST GET DATA DESCRIPTORS
C
      CALL BUSEL(KTDLEN,KTDLST,KTDEXL,KTDEXP,KERR)
      IF(KERR.NE.0) THEN
       PRINT*,'BUSEL : ERROR ',KERR
       CALL MY_EXIT(2)
      END IF
C
C               PRINT  CONTENT
C
      IF(OSEC3) THEN
         CALL BUPRS3(KSEC3,KTDLEN,KTDLST,KTDEXL,KTDEXP,KEL,CNAMES)
      END IF
C
C*         4.6 PRINT SECTION 4 (DATA).
C              -----------------------
 460  CONTINUE
C
C     -----------------------------------------------------------------
C*          5. COLLECT DATA FOR REPACKING.
C              ---------------------------
 500  CONTINUE
C      
      IF(.NOT.OENC) GO TO 300
C
C               FIRST GET DATA DESCRIPTORS
C
      KERR=0
      CALL BUSEL(KTDLEN,KTDLST,KTDEXL,KTDEXP,KERR)
      IF(KERR.NE.0) THEN
         PRINT*,'BUSEL : ERROR ',KERR
         CALL MY_EXIT(2)
      END IF
C
      KERR=0
      CALL BUUKEY(KSEC1,KSEC2,KEY,KSUP,KERR)
      IF(KERR.NE.0) THEN
         PRINT*,'BUUKEY:ERROR ',KERR
         CALL MY_EXIT(2)
      END IF
C
C
C     HIGH RESOLUTION TOVS 120 KM GOT WRONG SUBTYPE 
C     AND RDB TYPE
C
      IF(KSEC1(2).EQ.0.AND.KSEC1(6).EQ.3.AND.KSEC1(7).EQ.0) THEN
         KSEC1(3)=98
         KSEC1(7)=51
         KSEC1(6)=3
C         KEY(2)=2
C         KEY(3)=51
C         KEY(4)=NINT(VALUES(2))
C         KEY(5)=NINT(VALUES(3))
C         KEY(6)=NINT(VALUES(4))
C         KEY(7)=NINT(VALUES(5))
C         KEY(8)=NINT(VALUES(6))
C         KEY(9)=NINT(VALUES(7))
C         KEY(14)=KSEC3(3)
C         KEY(15)=NINT(VALUES(1))
      END IF
C
C     IF HIGH LEVEL STATION CHANGE SUBTYPE TO 5 LOCALLY
C
      IF(KTDLST(1).EQ.307007) THEN
         KSEC1(7)=5
      END IF
C
C     SOME SHIP CALL SIGNS HAVE ZERO APPEND
C
      IF(KSEC1(7).GE.11.AND.KSEC1(7).LE.14.OR.KSEC1(7).EQ.19.OR.
     1   KSEC1(7).EQ.92.OR.KSEC1(7).EQ.102) THEN
         CSHIP=' '
         CALL CUTZERO(CVALS(1),1)
         DO 505 IC=1,9
         CSHIP(IC:IC)=CHAR(KEY(IC+15))
 505     CONTINUE
         CALL CUTZERO(CSHIP,1)
         DO 506 IC=1,9
         KEY(IC+15)=ICHAR(CSHIP(IC:IC))
 506     CONTINUE 
      END IF
C
C     FOR SOME OCEANOGRAPHIC DATA DATE IN THE SECTION 1 IS BAD
C
      IF(KSEC1(7).GE.131.AND.KSEC1(7).LE.133) THEN
         IYEAR=NINT(VALUES(2))-1900
         IMONTH=NINT(VALUES(3))
         IDAY=NINT(VALUES(4))
         IHOUR=NINT(VALUES(5))
         IMIN=NINT(VALUES(6))
         IF(KSEC1(9).NE.IYEAR) THEN
            KSEC1(9)=IYEAR
            KSEC1(10)=IMONTH
            KSEC1(11)=IDAY
            KSEC1(12)=IHOUR
            KSEC1(13)=IMIN
         END IF
         IF(KSEC1(7).GE.132.AND.KSEC1(7).LE.133) THEN
             CSHIP=' '
             CALL CUTZERO(CVALS(1),1)
             DO 507 IC=1,9
             CSHIP(IC:IC)=CHAR(KEY(IC+15))
 507         CONTINUE
             CALL CUTZERO(CSHIP,1)
             DO 508 IC=1,9
             KEY(IC+15)=ICHAR(CSHIP(IC:IC))
 508         CONTINUE
         END IF
      END IF 
C
      KERR=0
      IF(KSEC0(3).GT.1) THEN
         CALL BUCON2(KSEC1(7),KSUP,KTDLEN,KTDLST,
     1               KTDLST1,KTDEXL,KTDEXP,KEL,KVALS,
     2               VALUES,VALUE,KDLEN,KDATA,KERR)
      ELSE
         CALL BUCONV(KSEC1(7),KSUP,KTDLEN,KTDLST,
     1              KTDLST1,KTDEXL,KTDEXP,KEL,KVALS,
     2              VALUES,VALUE,KDLEN,KDATA,KERR)
      END IF
      IF(KERR.NE.0) THEN
         PRINT*,'BAD CONVERSION FOR SUBTYPE -',KSEC1(7)
         CALL MY_EXIT(2)
      END IF
C
C     CHANGE BACK SYNOP HIGH LEVEL STATION SUBTYPE
C
      IF(KSEC1(7).EQ.5) KSEC1(7)=1
C
C     -----------------------------------------------------------------
C*          6. PACK BUFR MESSAGE BACK INTO BUFR.
C              ---------------------------------
 600  CONTINUE
C
    
      KKK=0
      KSEC1(8)=1
      KSEC1(15)=2
      KSEC0(3)=2              ! EDITION 2 OF BUFR MESSAGE
C     KSEC3(4)=128            ! NO COMPRESSION
C     IF(KSEC3(3).GT.1) KSEC3(4)=192
      N=0
      KBUFL=JBUFL
C
C*          6.2 ENCODE DATA INTO BUFR MESSAGE.
C               ------------------------------
 620  CONTINUE
C
      KERR=0
      KEY(1)=52
      KSEC2(1)=52
      CALL BUPKEY(KEY,KSEC1,KSEC2,KERR)
      IF(KERR.NE.0) THEN
        PRINT*,'BUPKEY: ERROR',KERR
        CALL MY_EXIT(2)
      END IF
C
      KERR=0
       CALL BUFREN( KSEC0,KSEC1,KSEC2,KSEC3,KSEC4,
     1              KTDLEN,KTDLST1,KDLEN,KDATA,KEL,
     2              KVALS,VALUE,CVALS,KBUFL,KBUFR,KERR)
C
      IF(KERR.GT.0) THEN
         PRINT*,'ERROR DURING ENCODING.'
         PRINT*,'MESSAGE NUMBER ',N
         PRINT*,'BUFR SUBTYPE ',KSEC1(7)
         CALL MY_EXIT(2)
      END IF
C
C           6.3 WRITE PACKED BUFR MESSAGE INTO FILE.
C               ------------------------------------
 630  CONTINUE
C
      ILEN=KBUFL*NBYTPW
      CALL PBWRITE(IUNIT1,KBUFR,ILEN,IERR)
      IF(IRET.EQ.-1) THEN
         PRINT*,'ERROR DURING WRITE INTO OUTPUT FILE.'
         CALL MY_EXIT(2)
      END IF
C
      NW=NW+1
C
      GO TO 300
C     -----------------------------------------------------------------
C
C      
 900  CONTINUE
C
      CALL PBCLOSE(IUNIT,IRET)
      CALL PBCLOSE(IUNIT1,IRET)
C
      END
      SUBROUTINE BUCONV(KST,KSUP,KTDLEN,KTDLST,KTDLST1,KTDEXL,KTDEXP,
     1                  KELEM,KVALS,VALUES,VALUE,KDLEN,KDATA,KERR)
C
C**** *BUCONV*
C
C
C     PURPOSE.
C     --------
C         CONVERTS BUFR EDITION 0 TO EDITION 2 DATA.
C         
C
C
C**   INTERFACE.
C     ----------
C
C              *CALL BUCONV(KST,KTDLEN,KTDLST,KTDLST1,KTDEXL,KTDEXP,
C                           KELEM,KVALS,VALUES,VALUE,KERR)*
C
C     METHOD.
C     -------
C
C          NONE.
C
C
C     EXTERNALS.
C     ----------
C
C
C     REFERENCE.
C     ----------
C
C          NONE.
C
C     AUTHOR.
C     -------
C
C          M. DRAGOSAVAC    *ECMWF*       15/09/94
C
C
C     MODIFICATIONS.
C     --------------
C
C          NONE.
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
      DIMENSION KTDLST(*),KTDEXP(*)
      DIMENSION KTDLST1(*),KSUP(*),KDATA(*)
      REAL*8 VALUES(*),VALUE(*)
      REAL*8 RVIND,EPS
C
C     ------------------------------------------------------------------
C*          1. INITIALIZE CONSTANTS AND VARIABLES.
C              -----------------------------------
 100  CONTINUE
C
C     MISSING VALUE INDICATOR
C
      RVIND=1.7D38
      EPS=10.D-8
C
      IF(KST.EQ.1.OR.KST.EQ.3.OR.KST.EQ.5) THEN
C
C        SYNOP LAND SUBTYPES 1 AND 3 AND 5 HIGH LEVEL STATION
C
C
C        CHANGE OPERATOR
C
         J=0
C
         DO 101 I=1,KTDLEN
C
         IF(KTDLST(I).GT.262000.AND.KTDLST(I).LT.300000) THEN
            J=J+1
            KTDLST1(J)=222000
         ELSEIF(KTDLST(I).EQ.262000) THEN
               GO TO 101
         ELSEIF(KTDLST(I).GT.101000.AND.KTDLST(I).LE.101049) THEN
            J=J+1
            IF(KST.LE.3) KTDLST1(J)=101049
            IF(KST.EQ.5) KTDLST1(J)=101033
         ELSEIF(KTDLST(I).EQ.063191) THEN
            J=J+1
            KTDLST1(J)=001201
         ELSEIF(KTDLST(I).EQ.063192) THEN
            J=J+1
            KTDLST1(J)=033007
         ELSEIF(KTDLST(I).EQ.031192) THEN
            J=J+1
            KTDLST1(J)=031031
            J=J+1
            KTDLST1(J)=001031
         ELSE
            J=J+1
            KTDLST1(J)=KTDLST(I)
         END IF
C
 101     CONTINUE
C
         KTDLEN=J
C
C        FIND FIRST AND LAST POINTER TO DATA PRESENT INDICATOR
C
         ODPF=.FALSE.
C
         DO 102 I=1,KTDEXL
         IF(KTDEXP(I).EQ.31192) THEN
            IF(.NOT.ODPF) IDPF=I
            ODPF=.TRUE.
         ELSE
            IF(ODPF) THEN
               IDPL=I-1
               GO TO 103
            END IF
         END IF
 102     CONTINUE
C
 103     CONTINUE
C
C        FIND START OF % CONFIDENCE
C
         DO 104 I=IDPL,KTDEXL
         IF(KTDEXP(I).EQ.63192) THEN
            IPCF=I
            GO TO 105
         END IF
 104     CONTINUE
C
 105     CONTINUE
C
C        MAKE DATA SUITABLE FOR COMPRESSION
C
         J=0
         KDLEN=0
         IPC=IPCF-1
C
         DO 106 I=1,KTDEXL
         J=J+1
         IF(KTDEXP(I).EQ.031001.OR.KTDEXP(I).EQ.031002) THEN
            KDLEN=KDLEN+1
            KDATA(KDLEN)=NINT(VALUES(I))
            GO TO 106
         END IF
C
         IF(KTDEXP(I).EQ.063191) THEN    ! GENERATING APPLICATION
            VALUE(J)=98.                 ! GENERATING CENTRE
            J=J+1
            VALUE(J)=1.
            GO TO 106
         END IF
C
         IF(KTDEXP(I).EQ.031192) THEN
            VALUE(J)=0.    ! DATA PRESENT
            GO TO 106
         END IF
C
         IF(KTDEXP(I).EQ.063192) THEN            ! % CONF
            DO 107 K=IDPF,IDPL
            IF(VALUES(K).GT.0.) THEN
               VALUE(J)=RVIND
               J=J+1
            ELSE
               IPC=IPC+1
               VALUE(J)=VALUES(IPC)
               J=J+1
            END IF
 107        CONTINUE
            GO TO 110
         END IF
C
         IF(KTDEXP(I).GE.13019.AND.KTDEXP(I).LE.13023) THEN
            IF(ABS(VALUES(I)-RVIND)/RVIND.LT.EPS) THEN
               VALUE(J)=VALUES(I)
            ELSE
               VALUE(J)=VALUES(I)*1000.
            END IF
         ELSE
            VALUE(J)=VALUES(I)
         END IF
C
 106     CONTINUE
C
 110     CONTINUE
C
         KERR=0
         RETURN
      END IF
C
      IF(KST.EQ.2.OR.KST.EQ.4) THEN
C
C        SYNOP LAND SECOND RECORD 2,4
C
C        CHANGE OPERATOR
C
         J=0
C
         DO 901 I=1,KTDLEN
C
         IF(KTDLST(I).GT.262000.AND.KTDLST(I).LT.300000) THEN
            J=J+1
            KTDLST1(J)=222000
         ELSEIF(KTDLST(I).EQ.262000) THEN
               GO TO 901
         ELSEIF(KTDLST(I).GT.101000.AND.KTDLST(I).LE.101022) THEN
            J=J+1
            IF(KST.EQ.2) KTDLST1(J)=101022
            IF(KST.EQ.4) KTDLST1(J)=101022
         ELSEIF(KTDLST(I).EQ.063191) THEN
            J=J+1
            KTDLST1(J)=001201
         ELSEIF(KTDLST(I).EQ.063192) THEN
            J=J+1
            KTDLST1(J)=033007
         ELSEIF(KTDLST(I).EQ.031192) THEN
            J=J+1
            KTDLST1(J)=031031
            J=J+1
            KTDLST1(J)=001031
         ELSEIF(KTDLST(I).EQ.14011) THEN
            J=J+1
            KTDLST1(J)=14015
         ELSEIF(KTDLST(I).EQ.14032) THEN
            J=J+1
            KTDLST1(J)=14031
         ELSEIF(KTDLST(I).EQ.20063) THEN
            J=J+1
            KTDLST1(J)=20192
         ELSE
            J=J+1
            KTDLST1(J)=KTDLST(I)
         END IF
C
 901     CONTINUE
C
         KTDLEN=J
C
C        FIND FIRST AND LAST POINTER TO DATA PRESENT INDICATOR
C
         ODPF=.FALSE.
C
         DO 902 I=1,KTDEXL
         IF(KTDEXP(I).EQ.31192) THEN
            IF(.NOT.ODPF) IDPF=I
            ODPF=.TRUE.
         ELSE
            IF(ODPF) THEN
               IDPL=I-1
               GO TO 903
            END IF
         END IF
 902     CONTINUE
C
 903     CONTINUE
C
C        FIND START OF % CONFIDENCE
C
         DO 904 I=IDPL,KTDEXL
         IF(KTDEXP(I).EQ.63192) THEN
            IPCF=I
            GO TO 905
         END IF
 904     CONTINUE
C
 905     CONTINUE
C
C        MAKE DATA SUITABLE FOR COMPRESSION
C
         J=0
         KDLEN=0
         IPC=IPCF-1
C
         DO 906 I=1,KTDEXL
         J=J+1
         IF(KTDEXP(I).EQ.031001.OR.KTDEXP(I).EQ.031002) THEN
            KDLEN=KDLEN+1
            KDATA(KDLEN)=NINT(VALUES(I))
         END IF
C
         IF(KTDEXP(I).EQ.063191) THEN    ! GENERATING APPLICATION
            VALUE(J)=98.                 ! GENERATING CENTRE
            J=J+1
            VALUE(J)=1.
            GO TO 906
         END IF
C
         IF(KTDEXP(I).EQ.031192) THEN
            VALUE(J)=0.    ! DATA PRESENT
            GO TO 906
         END IF
C
         IF(KTDEXP(I).EQ.063192) THEN            ! % CONF
            DO 907 K=IDPF,IDPL
            IF(VALUES(K).GT.0.) THEN
               VALUE(J)=RVIND
               J=J+1
            ELSE
               IPC=IPC+1
               VALUE(J)=VALUES(IPC)
               J=J+1
            END IF
 907        CONTINUE
            GO TO 910
         END IF
C
         IF(KTDEXP(I).GE.13019.AND.KTDEXP(I).LE.13023) THEN
            IF(ABS(VALUES(I)-RVIND)/RVIND.LT.EPS) THEN
               VALUE(J)=VALUES(I)
            ELSE
               VALUE(J)=VALUES(I)*1000.
            END IF
         ELSE
            VALUE(J)=VALUES(I)
         END IF
C
 906     CONTINUE
C
 910     CONTINUE
C
         KERR=0
         RETURN
      END IF
C
      IF(KST.EQ.09.OR.KST.EQ.11.OR.
     1   KST.EQ.13.OR.KST.EQ.19) THEN
C
C        SYNOP SHIP 9,11,13,19
C        ---------------------
C
C        CHANGE OPERATOR
C
         J=0
C
         DO 201 I=1,KTDLEN
C
         IF(KTDLST(I).GT.262000.AND.KTDLST(I).LT.300000) THEN
            J=J+1
            KTDLST1(J)=222000
         ELSEIF(KTDLST(I).EQ.262000) THEN
               GO TO 201
         ELSEIF(KTDLST(I).GT.101000.AND.KTDLST(I).LT.101033) THEN
            J=J+1
            KTDLST1(J)=101033
         ELSEIF(KTDLST(I).EQ.063191) THEN
            J=J+1
            KTDLST1(J)=001201
         ELSEIF(KTDLST(I).EQ.063192) THEN
            J=J+1
            KTDLST1(J)=033007
         ELSEIF(KTDLST(I).EQ.031192) THEN
            J=J+1
            KTDLST1(J)=031031
            J=J+1
            KTDLST1(J)=001031
         ELSE
            J=J+1
            IF(KTDLST(I).EQ.308004) THEN
               KTDLST1(J)=KTDLST(I)
               J=J+1
               KTDLST1(J)=12005
            ELSE
               KTDLST1(J)=KTDLST(I)
            END IF
         END IF
C
 201     CONTINUE
C
         KTDLEN=J
C
C
C        FIND FIRST AND LAST POINTER TO DATA PRESENT INDICATOR
C
         ODPF=.FALSE.
C
         DO 202 I=1,KTDEXL
         IF(KTDEXP(I).EQ.31192) THEN
            IF(.NOT.ODPF) IDPF=I
            ODPF=.TRUE.
         ELSE
            IF(ODPF) THEN
               IDPL=I-1
               GO TO 203
            END IF
         END IF
 202     CONTINUE
C
 203     CONTINUE
C
C        FIND START OF % CONFIDENCE
C
         DO 204 I=IDPL,KTDEXL
         IF(KTDEXP(I).EQ.63192) THEN
            IPCF=I
            GO TO 205
         END IF
 204     CONTINUE
C
 205     CONTINUE
C
C        MAKE DATA SUITABLE FOR COMPRESSION
C
         J=0
         KDLEN=0
         IPC=IPCF-1
C
         DO 206 I=1,KTDEXL
         J=J+1
         IF(KTDEXP(I).EQ.031001.OR.KTDEXP(I).EQ.031002) THEN
            KDLEN=KDLEN+1
            KDATA(KDLEN)=NINT(VALUES(I))
         END IF
C
         IF(KTDEXP(I).EQ.063191) THEN    ! GENERATING APPLICATION
            VALUE(J)=0.                  ! ONE MORE DATA PRESENT INDICATOR
            J=J+1 
            VALUE(J)=98.                 ! GENERATING CENTRE
            J=J+1
            VALUE(J)=1.
            GO TO 206
         END IF
C
         IF(KTDEXP(I).EQ.031192) THEN
            VALUE(J)=0.    ! DATA PRESENT
            GO TO 206
         END IF
C
         IF(KTDEXP(I).EQ.063192) THEN            ! % CONF
            DO 207 K=IDPF,IDPL
            IF(VALUES(K).GT.0.) THEN
               VALUE(J)=RVIND
               J=J+1
            ELSE
               IPC=IPC+1
               VALUE(J)=VALUES(IPC)
               J=J+1
            END IF
 207        CONTINUE
            VALUE(J)=RVIND
            GO TO 210
         END IF
C
         IF(KTDEXP(I).EQ.022042) THEN
            VALUE(J)=VALUES(I)
C
C           ADD 012005 DEW POINT TEMPERATURE AT 2M
C
            J=J+1
            VALUE(J)=RVIND
         ELSE
            VALUE(J)=VALUES(I)
         END IF
C
 206     CONTINUE
C
 210     CONTINUE
C
         KERR=0
         RETURN
      END IF
      IF(KST.EQ.12.OR.KST.EQ.14) THEN
C
C         SYNOP SHIP SECOND RECORD
C
C        CHANGE OPERATOR
C
         J=0
C
         DO 701 I=1,KTDLEN
C
         IF(KTDLST(I).GT.262000.AND.KTDLST(I).LT.300000) THEN
            J=J+1
            KTDLST1(J)=222000
         ELSEIF(KTDLST(I).EQ.262000) THEN
               GO TO 701
         ELSEIF(KTDLST(I).GT.101000.AND.KTDLST(I).LE.101039) THEN
            J=J+1
            IF(KST.EQ.12) KTDLST1(J)=101039
            IF(KST.EQ.14) KTDLST1(J)=101039
         ELSEIF(KTDLST(I).EQ.063191) THEN
            J=J+1
            KTDLST1(J)=001201
         ELSEIF(KTDLST(I).EQ.063192) THEN
            J=J+1
            KTDLST1(J)=033007
         ELSEIF(KTDLST(I).EQ.031192) THEN
            J=J+1
            KTDLST1(J)=031031
            J=J+1
            KTDLST1(J)=001031
         ELSEIF(KTDLST(I).EQ.13031) THEN
            J=J+1
            KTDLST1(J)=22001
            J=J+1
            KTDLST1(J)=22011
            J=J+1
            KTDLST1(J)=22021
            J=J+1
            KTDLST1(J)=13031
         ELSEIF(KTDLST(I).EQ.14011) THEN
            J=J+1
            KTDLST1(J)=14015
         ELSEIF(KTDLST(I).EQ.14032) THEN
            J=J+1
            KTDLST1(J)=14031
         ELSEIF(KTDLST(I).EQ.20063) THEN
            J=J+1
            KTDLST1(J)=20192
         ELSE
            J=J+1
            KTDLST1(J)=KTDLST(I)
         END IF
C
 701     CONTINUE
C
         KTDLEN=J
C
C        FIND FIRST AND LAST POINTER TO DATA PRESENT INDICATOR
C
         ODPF=.FALSE.
C
         DO 702 I=1,KTDEXL
         IF(KTDEXP(I).EQ.31192) THEN
            IF(.NOT.ODPF) IDPF=I
            ODPF=.TRUE.
         ELSE
            IF(ODPF) THEN
               IDPL=I-1
               GO TO 703
            END IF
         END IF
 702     CONTINUE
C
 703     CONTINUE
C
C        FIND START OF % CONFIDENCE
C
         DO 704 I=IDPL,KTDEXL
         IF(KTDEXP(I).EQ.63192) THEN
            IPCF=I
            GO TO 705
         END IF
 704     CONTINUE
C
 705     CONTINUE
C
C        MAKE DATA SUITABLE FOR COMPRESSION
C
         J=0
         KDLEN=0
         ISTAT=0
         IPC=IPCF-1
C
         DO 706 I=1,KTDEXL
         J=J+1
         IF(KTDEXP(I).EQ.031001.OR.KTDEXP(I).EQ.031002) THEN
            KDLEN=KDLEN+1
            KDATA(KDLEN)=NINT(VALUES(I))
         END IF
C
         IF(KTDEXP(I).EQ.063191) THEN    ! GENERATING APPLICATION
            VALUE(J)=98.                 ! GENERATING CENTRE
            J=J+1
            VALUE(J)=1.
            GO TO 706
         END IF
C
         IF(KTDEXP(I).EQ.031192) THEN
            ISTAT=ISTAT+1
            IF(ISTAT.EQ.23) THEN
               VALUE(J)=0.
               J=J+1
               VALUE(J)=0.
               J=J+1
               VALUE(J)=0.
               J=J+1
               VALUE(J)=0.
               GO TO 706
            END IF
            VALUE(J)=0.    ! DATA PRESENT
            GO TO 706
         END IF
C
         IF(KTDEXP(I).EQ.063192) THEN            ! % CONF
            IC=0
            DO 707 K=IDPF,IDPL
            IC=IC+1
            IF(IC.EQ.23) THEN
               IF(VALUES(K).GT.0.) THEN
                  VALUE(J)=RVIND
                  J=J+1
                  VALUE(J)=RVIND
                  J=J+1
                  VALUE(J)=RVIND
                  J=J+1
                  VALUE(J)=RVIND
                  J=J+1
                  GO TO 707
               ELSE
                  IPC=IPC+1
                  VALUE(J)=VALUES(IPC)
                  J=J+1
                  VALUE(J)=RVIND
                  J=J+1
                  VALUE(J)=RVIND
                  J=J+1
                  VALUE(J)=RVIND
                  J=J+1
                  GO TO 707
               END IF
            END IF
            IF(VALUES(K).GT.0.) THEN
               VALUE(J)=RVIND
               J=J+1
            ELSE
               IPC=IPC+1
               VALUE(J)=VALUES(IPC)
               J=J+1
            END IF
 707        CONTINUE
            GO TO 710
         END IF
C
         IF(KTDEXP(I).EQ.13031) THEN
            VALUE(J)=RVIND
            J=J+1
            VALUE(J)=RVIND
            J=J+1
            VALUE(J)=RVIND
            J=J+1
            VALUE(J)=VALUES(I)
            GO TO 706
         END IF
C
         IF(KTDEXP(I).GE.22021.AND.KTDEXP(I).LE.22023) THEN
            IF(ABS(VALUES(I)-RVIND)/RVIND.LT.EPS) THEN
               VALUE(J)=VALUES(I)
            ELSE
               VALUE(J)=VALUES(I)/10.
            END IF
            GO TO 706
         END IF
C
         IF(KTDEXP(I).GE.13019.AND.KTDEXP(I).LE.13023) THEN
            IF(ABS(VALUES(I)-RVIND)/RVIND.LT.EPS) THEN
               VALUE(J)=VALUES(I)
            ELSE
               VALUE(J)=VALUES(I)*1000.
            END IF
         ELSE
            VALUE(J)=VALUES(I)
         END IF
C
 706     CONTINUE
C
 710     CONTINUE
C
         KERR=0
         RETURN
      END IF
C
      IF(KST.GE.21.AND.KST.LE.23) THEN
C
C        DRIBU BATHY TESA 21,22,23
C        -------------------------
C
C        CHANGE OPERATOR
C
         J=0
C
         DO 301 I=1,KTDLEN
C
         IF(KTDLST(I).GT.262000.AND.KTDLST(I).LT.300000) THEN
            J=J+1
            KTDLST1(J)=222000
         ELSEIF(KTDLST(I).EQ.262000) THEN
               GO TO 301
         ELSEIF(KTDLST(I).GT.101000.AND.KTDLST(I).LT.101032) THEN
            J=J+1
            KTDLST1(J)=101032
         ELSEIF(KTDLST(I).EQ.063191) THEN
            J=J+1
            KTDLST1(J)=001201
         ELSEIF(KTDLST(I).EQ.063192) THEN
            J=J+1
            KTDLST1(J)=033007
         ELSEIF(KTDLST(I).EQ.031192) THEN
            J=J+1
            KTDLST1(J)=031031
            J=J+1
            KTDLST1(J)=001031
         ELSE
            J=J+1
            KTDLST1(J)=KTDLST(I)
         END IF
C
 301     CONTINUE
C
         KTDLEN=J
C
C        FIND FIRST AND LAST POINTER TO DATA PRESENT INDICATOR
C
         ODPF=.FALSE.
C
         DO 302 I=1,KTDEXL
         IF(KTDEXP(I).EQ.31192) THEN
            IF(.NOT.ODPF) IDPF=I
            ODPF=.TRUE.
         ELSE
            IF(ODPF) THEN
               IDPL=I-1
               GO TO 303
            END IF
         END IF
 302     CONTINUE
C
 303     CONTINUE
C
C        FIND START OF % CONFIDENCE
C
         DO 304 I=IDPL,KTDEXL
         IF(KTDEXP(I).EQ.63192) THEN
            IPCF=I
            GO TO 305
         END IF
 304     CONTINUE
C
 305     CONTINUE
C
C        MAKE DATA SUITABLE FOR COMPRESSION
C
         J=0
         KDLEN=0
         IPC=IPCF-1
C
         DO 306 I=1,KTDEXL
         J=J+1
         IF(KTDEXP(I).EQ.031001.OR.KTDEXP(I).EQ.031002) THEN
            KDLEN=KDLEN+1
            KDATA(KDLEN)=NINT(VALUES(I))
         END IF
C
         IF(KTDEXP(I).EQ.063191) THEN    ! GENERATING APPLICATION
            VALUE(J)=98.                 ! GENERATING CENTRE
            J=J+1
            VALUE(J)=1.
            GO TO 306
         END IF
C
         IF(KTDEXP(I).EQ.031192) THEN
            VALUE(J)=0.    ! DATA PRESENT
            GO TO 306
         END IF
C
         IF(KTDEXP(I).EQ.063192) THEN            ! % CONF
            DO 307 K=IDPF,IDPL
            IF(VALUES(K).GT.0.) THEN
               VALUE(J)=RVIND
               J=J+1
            ELSE
               IPC=IPC+1
               VALUE(J)=VALUES(IPC)
               J=J+1
            END IF
 307        CONTINUE
            GO TO 310
         END IF
C
         VALUE(J)=VALUES(I)
C
 306     CONTINUE
C
 310     CONTINUE
C
         KERR=0
         RETURN
      END IF
      IF(KST.EQ.51.OR.KST.EQ.52) THEN
C
C        MOVE FIRST 12 ELEMENTS
C
         DO 854 J=1,12
         DO 851 I=1,KSUP(6)
         IJ=J+(I-1)*KELEM
         VALUE(IJ)=VALUES(IJ)
 851     CONTINUE
 854     CONTINUE
C
C        INSERT SATELLITE LOCATION COUNTER
C
         DO 856 I=1,KSUP(6)
         IJ=13+(I-1)*KELEM
         VALUE(IJ)=RVIND
 856     CONTINUE
C
C        MOVE THE REST OF THE DATA
C
         JJ=13
         DO 858 J=13,KSUP(5)
         JJ=JJ+1
         DO 857 I=1,KSUP(6)
         IJ=J+(I-1)*KELEM
         IZ=JJ+(I-1)*KELEM
         VALUE(IZ)=VALUES(IJ)
 857     CONTINUE
 858     CONTINUE
C
         DO 853 I=1,12
         KTDLST1(I)=KTDLST(I)
 853     CONTINUE
         KTDLST1(13)=027020
         J=13
         DO 852 I=13,KTDLEN
         J=J+1
         KTDLST1(J)=KTDLST(I)
 852     CONTINUE
         KTDLEN=KTDLEN+1
         KERR=0
         RETURN
      END IF
C
      IF(KST.GE.61.AND.KST.LE.63.OR.
     1   KST.GE.71.AND.KST.LE.73.OR.
     2   KST.GE.82.AND.KST.LE.85 ) THEN
C
C        SATEM 500 KM 61,62,63 AND TOVS 250 KM. 71,72,73
C        ------------------------------------------------
C        CHANGE OPERATOR
C
         J=0
C
         DO 501 I=1,KTDLEN
C
         IF(KTDLST(I).GT.262000.AND.KTDLST(I).LT.300000) THEN
            J=J+1
            KTDLST1(J)=222000
         ELSEIF(KTDLST(I).EQ.262000) THEN
               GO TO 501
         ELSEIF(KTDLST(I).GT.101000.AND.KTDLST(I).LT.101063) THEN
            J=J+1
            IF(KST.EQ.61) KTDLST1(J)=101063
            IF(KST.EQ.62) KTDLST1(J)=101033
            IF(KST.EQ.63) KTDLST1(J)=101048
            IF(KST.EQ.71) KTDLST1(J)=101063
            IF(KST.EQ.72) KTDLST1(J)=101033
            IF(KST.EQ.73) KTDLST1(J)=101048
            IF(KST.EQ.82) KTDLST1(J)=101015
            IF(KST.EQ.83) KTDLST1(J)=101014
            IF(KST.EQ.84) KTDLST1(J)=101012
            IF(KST.EQ.85) KTDLST1(J)=101014
         ELSEIF(KTDLST(I).EQ.063191) THEN
            J=J+1
            KTDLST1(J)=001201
         ELSEIF(KTDLST(I).EQ.063192) THEN
            J=J+1
            KTDLST1(J)=033007
         ELSEIF(KTDLST(I).EQ.031192) THEN
            J=J+1
            KTDLST1(J)=031031
            J=J+1
            KTDLST1(J)=001031
         ELSE
            J=J+1
            KTDLST1(J)=KTDLST(I)
         END IF
C
 501     CONTINUE
C
         KTDLEN=J
C
C        FIND FIRST AND LAST POINTER TO DATA PRESENT INDICATOR
C
         ODPF=.FALSE.
C
         DO 502 I=1,KTDEXL
         IF(KTDEXP(I).EQ.31192) THEN
            IF(.NOT.ODPF) IDPF=I
            ODPF=.TRUE.
         ELSE
            IF(ODPF) THEN
               IDPL=I-1
               GO TO 503
            END IF
         END IF
 502     CONTINUE
C
 503     CONTINUE
C
C        FIND START OF % CONFIDENCE
C
         DO 504 I=IDPL,KTDEXL
         IF(KTDEXP(I).EQ.63192) THEN
            IPCF=I
            GO TO 505
         END IF
 504     CONTINUE
C
 505     CONTINUE
C
C        MAKE DATA SUITABLE FOR COMPRESSION
C
         J=0
         KDLEN=0
         IPC=IPCF-1
C
         DO 506 I=1,KTDEXL
         J=J+1
         IF(KTDEXP(I).EQ.031001.OR.KTDEXP(I).EQ.031002) THEN
            KDLEN=KDLEN+1
            KDATA(KDLEN)=NINT(VALUES(I))
         END IF
C
         IF(KTDEXP(I).EQ.063191) THEN    ! GENERATING APPLICATION
            DO 5061 I5061=1,KSUP(6)
            IV=J+(I5061-1)*KELEM
 5061       VALUE(IV)=98.                 ! GENERATING CENTRE
            J=J+1
            DO 5062 I5062=1,KSUP(6)
            IV=J+(I5062-1)*KELEM
 5062       VALUE(IV)=1.
            GO TO 506
         END IF
C
         IF(KTDEXP(I).EQ.031192) THEN
            DO 5063 I5063=1,KSUP(6)
            IV=J+(I5063-1)*KELEM
 5063       VALUE(IV)=0.                         ! DATA PRESENT
            GO TO 506
         END IF
C
         IF(KTDEXP(I).EQ.063192) THEN            ! % CONF
            DO 507 K=IDPF,IDPL
            IF(VALUES(K).GT.0.) THEN
               IPC=IPC+1
               DO 5071 I5071=1,KSUP(6)
               IV=J+(I5071-1)*KELEM
               VALUE(IV)=RVIND
 5071          CONTINUE
               J=J+1
            ELSE
               IPC=IPC+1
               DO 5072 I5072=1,KSUP(6)
               IPP=IPC+(I5072-1)*KELEM
               IV =J  +(I5072-1)*KELEM
               VALUE(IV)=VALUES(IPP)
 5072          CONTINUE
               J=J+1
            END IF
 507        CONTINUE
            GO TO 510
         END IF
C
         IF(KTDEXP(I).EQ.13016) THEN
C
C           CHANGE UNITS FOR PRECIPITABLE WATER
C
            DO 5081 I5081=1,KSUP(6)
            IN=I+(I5081-1)*KELEM
            IV=J+(I5081-1)*KELEM
            IF(ABS(VALUES(IN)-RVIND)/RVIND.LT.EPS) THEN
               VALUE(IV)=RVIND
            ELSE
               VALUE(IV)=VALUES(IN)*1000.
            END IF
 5081       CONTINUE
         ELSE
            DO 5082 I5082=1,KSUP(6)
            IN=I+(I5082-1)*KELEM
            IV=J+(I5082-1)*KELEM
 5082       VALUE(IV)=VALUES(IN)
         END IF
C
 506     CONTINUE
C
 510     CONTINUE
C
         KERR=0
         RETURN
      END IF
C
      IF(KST.EQ.101.OR.KST.GE.91.AND.KST.LE.92.OR.
     1   KST.GE.131.AND.KST.LE.133) THEN
C
C         TEMP LAND STATIONS AND PILOT 91,92
C         ----------------------------------
         J=0
C
         DO 601 I=1,KTDLEN
C
         IF(KTDLST(I).GT.262000.AND.KTDLST(I).LT.300000) THEN
            J=J+1
            KTDLST1(J)=222000
         ELSEIF(KTDLST(I).EQ.262000) THEN
               GO TO 601
         ELSEIF(KTDLST(I).EQ.063191) THEN
            J=J+1
            KTDLST1(J)=001201
         ELSEIF(KTDLST(I).EQ.063192) THEN
            J=J+1
            KTDLST1(J)=033007
         ELSEIF(KTDLST(I).EQ.031192) THEN
            J=J+1
            KTDLST1(J)=031031
            J=J+1
            KTDLST1(J)=001031
         ELSE
            J=J+1
            KTDLST1(J)=KTDLST(I)
         END IF
C
 601     CONTINUE
C
         KTDLEN=J
C
C        FIND FIRST AND LAST POINTER TO DATA PRESENT INDICATOR
C
         ODPF=.FALSE.
C
         DO 602 I=1,KTDEXL
         IF(KTDEXP(I).EQ.31192) THEN
            IF(.NOT.ODPF) IDPF=I
            ODPF=.TRUE.
         ELSE
            IF(ODPF) THEN
               IDPL=I-1
               GO TO 603
            END IF
         END IF
 602     CONTINUE
C
 603     CONTINUE
C
C        FIND START OF % CONFIDENCE
C
         DO 604 I=IDPL,KTDEXL
         IF(KTDEXP(I).EQ.63192) THEN
            IPCF=I
            GO TO 605
         END IF
 604     CONTINUE
C
 605     CONTINUE
C
C        MAKE DATA SUITABLE FOR COMPRESSION
C
         J=0
         KDLEN=0
         IPC=IPCF-1
C
         DO 606 I=1,KTDEXL
         J=J+1
         IF(KTDEXP(I).EQ.031001.OR.KTDEXP(I).EQ.031002) THEN
            KDLEN=KDLEN+1
            KDATA(KDLEN)=NINT(VALUES(I))
         END IF
C
         IF(KTDEXP(I).EQ.063191) THEN    ! GENERATING APPLICATION
            VALUE(J)=98.                 ! GENERATING CENTRE
            J=J+1
            VALUE(J)=1.
            GO TO 606
         END IF
C
         IF(KTDEXP(I).EQ.031192) THEN
            VALUE(J)=VALUES(I)             !0.    ! DATA PRESENT
            GO TO 606
         END IF
C
         IF(KTDEXP(I).EQ.063192) THEN            ! % CONF
            VALUE(J)=VALUES(I)
            GO TO 606
         END IF
C
         IF(KTDEXP(I).EQ.10003.OR.KTDEXP(I).EQ.10008) THEN
            IF(ABS(VALUES(I)-RVIND)/RVIND.GT.EPS) THEN
               VALUE(J)=(VALUES(I)/9.8)*9.80665
            ELSE
               VALUE(J)=VALUES(I)
            END IF
         ELSE
            VALUE(J)=VALUES(I)
         END IF
C
 606     CONTINUE
C
 610     CONTINUE
C
         KERR=0
         RETURN
      END IF
      IF(KST.EQ.102) THEN
C
C        TEMP SHIP 102
C        -------------
         J=0
         OSHEAR=.FALSE.
C
         DO 801 I=1,KTDLEN
C
         IF(KTDLST(I).GT.262000.AND.KTDLST(I).LT.300000) THEN
            J=J+1
            KTDLST1(J)=222000
         ELSEIF(KTDLST(I).EQ.262000) THEN
               GO TO 801
         ELSEIF(KTDLST(I).EQ.063191) THEN
            J=J+1
            KTDLST1(J)=001201
         ELSEIF(KTDLST(I).EQ.063192) THEN
            J=J+1
            KTDLST1(J)=033007
         ELSEIF(KTDLST(I).EQ.031192) THEN
            J=J+1
            KTDLST1(J)=031031
            J=J+1
            KTDLST1(J)=001031
         ELSEIF(KTDLST(I).EQ.309014) THEN
            J=J+1
            KTDLST1(J)=309196
         ELSE
            J=J+1
            KTDLST1(J)=KTDLST(I)
            IF(KTDLST(I).EQ.11061.OR.KTDLST(I).EQ.11062) OSHEAR=.TRUE.
         END IF
C
 801     CONTINUE
C
         KTDLEN=J
C
C        FIND FIRST AND LAST POINTER TO DATA PRESENT INDICATOR
C
         ODPF=.FALSE.
C
         DO 802 I=1,KTDEXL
         IF(KTDEXP(I).EQ.31192) THEN
            IF(.NOT.ODPF) IDPF=I
            ODPF=.TRUE.
         ELSE
            IF(ODPF) THEN
               IDPL=I-1
               GO TO 803
            END IF
         END IF
 802     CONTINUE
C
 803     CONTINUE
C
C        FIND START OF % CONFIDENCE
C
         DO 804 I=IDPL,KTDEXL
         IF(KTDEXP(I).EQ.63192) THEN
            IPCF=I
            GO TO 805
         END IF
 804     CONTINUE
C
 805     CONTINUE
C
C        MAKE DATA SUITABLE FOR COMPRESSION
C
         J=0
         KDLEN=0
         ISTAT=0
         IPC=IPCF-1
C
         DO 806 I=1,KTDEXL
         J=J+1
         IF(KTDEXP(I).EQ.031001.OR.KTDEXP(I).EQ.031002) THEN
            KDLEN=KDLEN+1
            KDATA(KDLEN)=NINT(VALUES(I))
            IF(KDLEN.EQ.2.AND..NOT.OSHEAR) THEN
               KDATA(KDLEN)=NINT(VALUES(I))+1
            END IF
            IF(KDLEN.EQ.3.AND.OSHEAR) THEN
               KDATA(KDLEN)=NINT(VALUES(I))+1
            END IF
         END IF
C
         IF(KTDEXP(I).EQ.063191) THEN    ! GENERATING APPLICATION
            VALUE(J)=98.                 ! GENERATING CENTRE
            J=J+1
            VALUE(J)=1.
            GO TO 806
         END IF
C
         IF(KTDEXP(I).EQ.031192) THEN
            ISTAT=ISTAT+1
            IF(ISTAT.EQ.12) THEN
               VALUE(J)=VALUES(I)
               J=J+1
               VALUE(J)=1.
               VALUE(IDPF)=VALUES(IDPF-1)+1
            ELSE
               VALUE(J)=VALUES(I)
            END IF
            GO TO 806
         END IF
C
         IF(KTDEXP(I).EQ.063192) THEN            ! % CONF
            VALUE(J)=VALUES(I)
            GO TO 806
         END IF
C
         IF(KTDEXP(I).EQ.006002) THEN
            VALUE(J)=VALUES(I)
            J=J+1
            VALUE(J)=RVIND                    ! INSERT STATION HEIGHT
            GO TO 806
         END IF
C
         IF(KTDEXP(I).EQ.10003.OR.KTDEXP(I).EQ.10008) THEN
            IF(ABS(VALUES(I)-RVIND)/RVIND.GT.EPS) THEN
               VALUE(J)=(VALUES(I)/9.8)*9.80665
            ELSE
               VALUE(J)=VALUES(I)
            END IF
         ELSE
            VALUE(J)=VALUES(I)
         END IF
C
 806     CONTINUE
C
 810     CONTINUE
C
         KERR=0
         RETURN
      END IF
      IF(KST.EQ.142.OR.KST.EQ.144.OR.KST.EQ.164) THEN
C
C        AIREP DATA 142 , AMDAR DATA 144, PAOB 164
C
C        CHANGE OPERATOR
C
         J=0
C
         DO 401 I=1,KTDLEN
C
         IF(KTDLST(I).GT.262000.AND.KTDLST(I).LT.300000) THEN
            J=J+1
            KTDLST1(J)=222000
         ELSEIF(KTDLST(I).EQ.262000) THEN
               GO TO 401
         ELSEIF(KTDLST(I).GT.101000.AND.KTDLST(I).LE.101018) THEN
            J=J+1
            IF(KST.EQ.164) KTDLST1(J)=101011
            IF(KST.EQ.142) KTDLST1(J)=101018
         ELSEIF(KTDLST(I).EQ.063191) THEN
            J=J+1
            KTDLST1(J)=001201
         ELSEIF(KTDLST(I).EQ.063192) THEN
            J=J+1
            KTDLST1(J)=033007
         ELSEIF(KTDLST(I).EQ.031192) THEN
            J=J+1
            KTDLST1(J)=031031
            J=J+1
            KTDLST1(J)=001031
         ELSE
            J=J+1
            KTDLST1(J)=KTDLST(I)
         END IF
C
 401     CONTINUE
C
         KTDLEN=J
C
C        FIND FIRST AND LAST POINTER TO DATA PRESENT INDICATOR
C
         ODPF=.FALSE.
C
         DO 402 I=1,KTDEXL
         IF(KTDEXP(I).EQ.31192) THEN
            IF(.NOT.ODPF) IDPF=I
            ODPF=.TRUE.
         ELSE
            IF(ODPF) THEN
               IDPL=I-1
               GO TO 403
            END IF
         END IF
 402     CONTINUE
C
 403     CONTINUE
C
C        FIND START OF % CONFIDENCE
C
         DO 404 I=IDPL,KTDEXL
         IF(KTDEXP(I).EQ.63192) THEN
            IPCF=I
            GO TO 405
         END IF
 404     CONTINUE
C
 405     CONTINUE
C
C        MAKE DATA SUITABLE FOR COMPRESSION
C
         J=0
         KDLEN=0
         IPC=IPCF-1
C
         DO 406 I=1,KTDEXL
         J=J+1
         IF(KTDEXP(I).EQ.031001.OR.KTDEXP(I).EQ.031002) THEN
            KDLEN=KDLEN+1
            KDATA(KDLEN)=NINT(VALUES(I))
         END IF
C
         IF(KTDEXP(I).EQ.063191) THEN    ! GENERATING APPLICATION
            VALUE(J)=98.                 ! GENERATING CENTRE
            J=J+1
            VALUE(J)=1.
            GO TO 406
         END IF
C
         IF(KTDEXP(I).EQ.031192) THEN
            VALUE(J)=0.    ! DATA PRESENT
            GO TO 406
         END IF
C
         IF(KTDEXP(I).EQ.063192) THEN            ! % CONF
            DO 407 K=IDPF,IDPL
            IF(VALUES(K).GT.0.) THEN
               VALUE(J)=RVIND
               J=J+1
            ELSE
               IPC=IPC+1
               VALUE(J)=VALUES(IPC)
               J=J+1
            END IF
 407        CONTINUE
            GO TO 410
         END IF
C
         VALUE(J)=VALUES(I)
C
 406     CONTINUE
C
 410     CONTINUE
C
         KERR=0
         RETURN
      END IF
C
      KERR=1
C
      RETURN
      END
      SUBROUTINE BUCON2(KST,KSUP,KTDLEN,KTDLST,KTDLST1,KTDEXL,KTDEXP,
     1                  KELEM,KVALS,VALUES,VALUE,KDLEN,KDATA,KERR)
C
C**** *BUCON2*
C
C
C     PURPOSE.
C     --------
C         CONVERTS BUFR EDITION 0 TO EDITION 2 DATA.
C         
C
C
C**   INTERFACE.
C     ----------
C
C              *CALL BUCON2(KST,KTDLEN,KTDLST,KTDLST1,KTDEXL,KTDEXP,
C                           KELEM,KVALS,VALUES,VALUE,KERR)*
C
C     METHOD.
C     -------
C
C          NONE.
C
C
C     EXTERNALS.
C     ----------
C
C
C     REFERENCE.
C     ----------
C
C          NONE.
C
C     AUTHOR.
C     -------
C
C          M. DRAGOSAVAC    *ECMWF*       15/09/94
C
C
C     MODIFICATIONS.
C     --------------
C
C          NONE.
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
      DIMENSION KTDLST(*),KTDEXP(*)
      DIMENSION KTDLST1(*),KSUP(*),KDATA(*)
      REAL*8 VALUES(*),VALUE(*)
      REAL*8 RVIND,EPS
C
C     ------------------------------------------------------------------
C*          1. INITIALIZE CONSTANTS AND VARIABLES.
C              -----------------------------------
 100  CONTINUE
C
C     MISSING VALUE INDICATOR
C
      RVIND=1.7D38
      EPS=10.D-8
C
      IF(KST.EQ.142) THEN
C
C        AIREP OBSERVATION (ERA PROJECT)
C
C
C        CHANGE OPERATOR
C
         J=0
C
         DO 101 I=1,KTDLEN
C
         IF(KTDLST(I).EQ.101000) THEN
            J=J+1
            KTDLST1(J)=101018
         ELSEIF(KTDLST(I).EQ.31002) THEN
               GO TO 101
         ELSE
            J=J+1
            KTDLST1(J)=KTDLST(I)
         END IF
C
 101     CONTINUE
C
         KTDLEN=J
C
C        FIND FIRST AND LAST POINTER TO DATA PRESENT INDICATOR
C
         ODPF=.FALSE.
C
         DO 102 I=1,KTDEXL
         IF(KTDEXP(I).EQ.31031) THEN
            IF(.NOT.ODPF) IDPF=I
            ODPF=.TRUE.
         ELSE
            IF(ODPF) THEN
               IDPL=I-1
               GO TO 103
            END IF
         END IF
 102     CONTINUE
C
 103     CONTINUE
C
C        FIND START OF % CONFIDENCE
C
         DO 104 I=IDPL,KTDEXL
         IF(KTDEXP(I).EQ.033007) THEN
            IPCF=I
            GO TO 105
         END IF
 104     CONTINUE
C
 105     CONTINUE
C
C        MAKE DATA SUITABLE FOR COMPRESSION
C
         J=0
         KDLEN=0
         IPC=IPCF-1
C
         DO 106 I=1,KTDEXL
         J=J+1
C
         IF(KTDEXP(I).EQ.031002) THEN
            J=J-1
            GO TO 106
         END IF
C
         IF(KTDEXP(I).EQ.031031) THEN
            VALUE(J)=0.    ! DATA PRESENT
            GO TO 106
         END IF
C
         IF(KTDEXP(I).EQ.033007) THEN            ! % CONF
            DO 107 K=IDPF,IDPL
            IF(VALUES(K).GT.0.) THEN
               VALUE(J)=RVIND
               J=J+1
            ELSE
               IPC=IPC+1
               VALUE(J)=VALUES(IPC)
               J=J+1
            END IF
 107        CONTINUE
            GO TO 110
         END IF
C
         VALUE(J)=VALUES(I)
C
 106     CONTINUE
C
 110     CONTINUE
C
         KERR=0
         RETURN
      END IF
C
      KERR=1
      PRINT*,'NO CONVERTION FOR ',KST,' SUBTYPE.'
C
      END
      SUBROUTINE CUTZERO(CHARPAR,KMIN)
C
C**** CUTZERO - SUBROUTINE TO REMOVE ZERO CHARACTERS.
C
C**   PURPOSE
C     -------
C
C     TO REMOVE ZERO-FILL CHARACTERS FROM THE END OF A CHARACTER
C     VARIABLE.
C
C     INTERFACE
C     ---------
C
C     CALL CUTZERO(CHARPAR,KMIN)
C
C          CHARPAR  - CHARACTER VARIABLE WHICH MAY HAVE ZEROS AT THE
C                     END OF THE VALID CHARACTERS, WHICH NEED TO BE
C                     REMOVED;
C                     RETURNED WITH THE ZERO CHARACTERS CONVERTED TO
C                     BLANK.
C
C          KMIN     - INTEGER VARIABLE INDICATING A MINIMUM NUMBER OF
C                     CHARACTERS AT THE BEGINNING OF THE STRING WHICH
C                     MUST NOT BE CHANGED
C
C     THUS:
C
C     CHARPAR='ABC0000'
C     CALL CUTZERO(CHARPAR,4)
C
C     WOULD RETURN THE VALUE 'ABC0   ' IN CHAR, AND WOULD NOT
C     ALTER THE FIRST 4 CHARACTERS.
C
C     METHOD
C     ------
C
C     THE STRIG IS TESTED FOR THE EXISTANCE OF A ZERO CHARACTER.
C     IF NONE IS FOUND, NO CHANGE TAKES PLACE.
C     IF ONE OR MORE ZERO CHARACTERS ARE PRESENT, THE END OF THE
C     STRING IS LOCATED. WORKING BACKWARDS FROM THE END TO THE
C     KMIN-1 POSITION, CHARACTERS ARE TESTED FOR ZERO. IF A ZERO
C     IS FOUND, IT IS REPLACED BY BLANK. IF A NON-ZERO IS FOUND,
C     THE REPLACEMENT LOOP TERMINATES.
C
C     MODIFICATIONS
C     -------------
C
C     ORIGINAL VERSION - 25.01.95 - REX GIBSON - ECMWF.
C
      CHARACTER*(*) CHARPAR
      CHARACTER*1   YZERO
      INTEGER LEN
C
C     -----------------------------------------------------------
C
C*     1.     FIND AND REPLACE THE ZERO CHARACTERS.
C
  100 CONTINUE
      YZERO=CHAR(0)
      I1=INDEX(CHARPAR,'0')
      IF (I1.GT.0) THEN
         I2=MAX(I1,KMIN+1)
         I3=INDEX(CHARPAR,' ')-1
         IF (I3.LE.0) THEN
            I3=LEN(CHARPAR)
         ENDIF
         DO 112 J=I3,I2,-1
         IF (CHARPAR(J:J).EQ.'0') THEN
             CHARPAR(J:J)=' '
         ELSEIF (CHARPAR(J:J).EQ.YZERO) THEN
             GO TO 112
         ELSE
             GO TO 114
         ENDIF
  112    CONTINUE
C
  114    CONTINUE
      ENDIF
C
C     -----------------------------------------------------------
C
C*     2.     RETURN.
C
  200 CONTINUE
C
      END

C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE SH2SH(UFLDIN, KRESIN, UFLDOU, KRESOU)
      IMPLICIT NONE
C
C---->
C**** SH2SH
C
C     Purpose
C     _______
C
C     This routine produces a field of spectral coefficients in UFLDOU
C     of truncation KRESOU from a field of spectral coeeficients in
C     UFLDIN of truncation KRESIN.
C
C
C     Interface
C     _________
C
C     CALL SH2SH(UFLDIN, KRESIN, UFLDOU, KRESOU)
C
C
C     Input parameters
C     ________________
C
C     UFLDIN       - field of spectral coefficients
C     KRESIN       - truncation of input field
C     KRESOU       - truncation of output field
C
C
C     Output parameters
C     ________________
C
C     UFLDOU       - field of spectral coefficients
C
C
C     Common block usage
C     __________________
C
C     None
C
C
C     Method
C     ______
C
C     If the input truncation is greater than (or equal to) the output
C     truncation, coefficients are transferred reduced for the output.
C
C     If the input truncation is less than the output truncation,
C     all coefficients are transferred and padded with zeroes for the
C     output.
C
C
C     Externals
C     _________
C
C     None
C
C
C     Reference
C     _________
C
C     None
C
C
C     Comments
C     ________
C
C     Arrays for the input and output fields must be defined large
C     enough for the coefficients implied by the truncations.  Thus
C     the dimension for UFLDOU must be at least:
C         ( KRESOU + 1) * ( KRESOU + 2 ) /2
C
C
C     Author
C     ______
C
C     J.D.Chambers       ECMWF      8th Nov 1993
C
C
C     Modifications
C     _____________
C
C     None
C
C----<
C     _______________________________________________________
C
C
C*    Section 0. Definition of variables.
C     _______________________________________________________
C
C*    Prefix conventions for variable names
C
C     Logical      L (but not LP), global or common.
C                  O, dummy argument
C                  G, local variable
C                  LP, parameter.
C     Character    C, global or common.
C                  H, dummy argument
C                  Y (but not YP), local variable
C                  YP, parameter.
C     Integer      M and N, global or common.
C                  K, dummy argument
C                  I, local variable
C                  J (but not JP), loop control
C                  JP, parameter.
C     Real         A to F and Q to X, global or common.
C                  P (but not PP), dummy argument
C                  Z, local variable
C                  PP, parameter.
C     Complex      U, dummy argument
C
C     _______________________________________________________
C
C     Subroutine arguments
      COMPLEX UFLDIN(*),UFLDOU(*)
      INTEGER KRESIN, KRESOU
C
C     Local variables
      INTEGER ITINP1, ITOUP1, ILIM, IMLIM, IMN, IMP, IADD
      INTEGER JM, JN
C
C     _______________________________________________________
C
C
C*    Section 1. Initialization
C     _______________________________________________________
C
  100 CONTINUE
C
C     Initialize loop control variables
C
      ITINP1 = KRESIN + 1
      ITOUP1 = KRESOU + 1
      ILIM   = ITOUP1
      IMLIM  = ITOUP1
      IMN = 1
      IMP = 1
C
C     _______________________________________________________
C
C
C*    Section 2. Computation.
C     _______________________________________________________
C
  200 CONTINUE
C
C     Check if desired output truncation greater than input ...
C
      IADD = KRESIN - KRESOU
      IF ( IADD .GE. 0 ) THEN
C
C     ... input truncation not less than desired output ...
C     ... move truncated lines of coefficients
        DO 230 JM = 1, IMLIM
          DO 220 JN = JM, ILIM
            UFLDOU(IMP) = UFLDIN(IMN)
            IMP = IMP + 1
            IMN = IMN + 1
220       CONTINUE
C                                Skip coefficients being truncated
        IMN = IMN + IADD
230     CONTINUE
C
C     ... input truncation is less than desired output ...
C     ... pad each output line of coefficients with zeroes
      ELSE
        DO 250 JM = 1, IMLIM
          DO 240 JN = JM, ILIM
            IF ( JN .GT. ITINP1 .OR. JM .GT. ITINP1) THEN
C                                At end of input coefficients in
C                                current row, then set values to
C                                zero in output
              UFLDOU(IMP) = 0.0
            ELSE
              UFLDOU(IMP) = UFLDIN(IMN)
              IMN = IMN + 1
            ENDIF
            IMP = IMP + 1
240       CONTINUE
250     CONTINUE
      ENDIF
C
C     _______________________________________________________
C
C
C*    Section 9. Return to calling routine.
C     _______________________________________________________
C
  900 CONTINUE
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE INTLOGD(KONOFF)
C
C---->
C**** INTLOGD
C
C     PURPOSE
C     _______
C
C     This routine toggles the debug flag LDEBUG.
C
C
C     INTERFACE
C     _________
C
C     CALL INTLOG(KONOFF)
C
C
C     Input parameters
C     ________________
C
C     KONOFF   - value to set in the debug flag LDEBUG.
C                = 0 for 'off'.
C                = 1 for 'on'.
C
C
C     Output parameters
C     ________________
C
C     None.
C
C
C     Common block usage
C     __________________
C
C     LDEBUG in /INTLOGC/ controls display of message
C                 = 0 for no display
C                 = 1 to display
C
C
C     Method
C     ______
C
C     Toggle flag.
C
C
C     Externals
C     _________
C
C     None.
C
C
C     Comments
C     ________
C
C     LDEBUG is toggled by a call to INTLOGD.
C
C
C     AUTHOR
C     ______
C
C     J.D.Chambers      *ECMWF*      Jul 1995
C
C
C     MODIFICATIONS
C     _____________
C
C     None.
C
C
C----<
C     _______________________________________________________
C
C     Subroutine arguments.
      INTEGER KONOFF
#include "intlog.h"
C
      LDEBUG =  (KONOFF.EQ.1)
C
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE ECDEF14( HFUNC, KSEC1, KGRIB, KLENG, KNSPT, KBITS,
     X                    KPLEN, KPR, KRET)
C
C---->
C**** ECDEF14
C
C     Purpose.
C     --------
C
C     GRIB coding/decoding of ECMWF local use definition 14.
C
C**   Interface.
C     ----------
C
C     CALL ECDEF14( HFUNC, KSEC1, KGRIB, KLENG, KNSPT, KBITS, KPR, KRET)
C
C
C     Input Parameters.
C     -----------------
C
C     HFUNC      - Requested function.
C                  'C' to code data.
C                  'D' to decode data.
C
C     KSEC1      - Array containing Grib Section 1 data.
C
C     KGRIB      - Array containing Grib coded data.
C
C     KLENG      - Length (words) of KGRIB.
C
C     KNSPT      - Bit number after which insertion/extraction starts.
C
C     KBITS      - Number of bits in computer word.
C
C     KPLEN      - Pointer to field containing length of Section 1
C
C     KPR        - Debug print switch.
C                  0  , No printout.
C                  >0 , Debug printout.
C
C     KRET       - Response to error indicator.
C                  0        , Abort if error encountered.
C                  Non-zero , Return to calling routine
C                             even if error encountered.
C
C     Output Parameters.
C     ------------------
C
C     KSEC1      - Array containing Grib Section 1 data.(Updated)
C
C     KGRIB      - Array containing Grib coded data.(Updated)
C
C     KNSPT      - Number of bit after last one inserted/extracted.
C                  (Updated)
C
C     KRET       - Return code.
C                  0   , No error encountered.
C                  2   , Error reported by routine INXBIT.
C
C
C     Method.
C     -------
C
C     Input data packed/unpacked in accordance with ECMWF usage of
C     local part of section 1 of Grib code, definition 14.
C
C
C     Externals.
C     ----------
C
C     INXBIT  - insert/extract bits
C     ABORTX  - abort the program
C
C
C     Reference.
C     ----------
C
C     WMO Manual On Codes for Grib Code.
C
C
C     Comments.
C     ---------
C
#include "ecdef14.h"
C
C
C     Author.
C     -------
C
C     J.D.Chambers     ECMWF      August 1998
C
C
C     Modifications.
C     --------------
C
C     None
C
C
C----<
C     ------------------------------------------------------------------
C*    Section 0 . Definition of variables. Data statements.
C     ------------------------------------------------------------------
C
      IMPLICIT NONE
C
#include "common/grprs.h"
C
C     Parameters
C
      CHARACTER*1 HFUNC
      INTEGER KSEC1, KGRIB, KLENG, KNSPT, KBITS, KPLEN, KPR, KRET
      DIMENSION KGRIB(*)
      DIMENSION KSEC1(*)
C
C     Local variables
C
      INTEGER IRET, IZERO, JLOP, LENS1, NF, NLEFT
C
      LOGICAL LENCODE, LDECODE
C
C     ------------------------------------------------------------------
C*    Section 1 . Set initial values.
C     ------------------------------------------------------------------
C
  100 CONTINUE
C
      IRET = KRET
      LENCODE = ( HFUNC.EQ.'C' )
      LDECODE = .NOT. LENCODE
C
C     ------------------------------------------------------------------
C*    Section 2 . Handle brightness temperature
C     ------------------------------------------------------------------
C
  200 CONTINUE
C
C     Octet 50: As for MARS labelling (zero or ensemble forecast number)
C     Octet 51: As for MARS labelling (zero or total no. in ensembles)
C     Octet 52: Channel number
C     Three 8-bit fields.
C
      CALL INXBIT(KGRIB,KLENG,KNSPT,KSEC1(42),3,KBITS,8,HFUNC,KRET)
      IF (KRET.NE.0) THEN
        KRET = 2
        WRITE(GRPRSM,*) 'ECDEF14: Error reported by routine INXBIT:'
        IF( LENCODE ) THEN
          WRITE(GRPRSM,*) '      encoding section 1, elements 42 - 44.'
        ELSE
          WRITE(GRPRSM,*) '      decoding section 1, octets 50 - 52.'
        ENDIF
      ENDIF
C
C     Octets 53-56: Integer scaling factor applied to frequencies
C     One 32-bit field.
C
      CALL INXBIT(KGRIB,KLENG,KNSPT,KSEC1(45),1,KBITS,32,HFUNC,KRET)
      IF (KRET.NE.0) THEN
        KRET = 2
        WRITE(GRPRSM,*) 'ECDEF14: Error reported by routine INXBIT:'
        IF( LENCODE ) THEN
          WRITE(GRPRSM,*) '      encoding section 1, element 45.'
        ELSE
          WRITE(GRPRSM,*) '      decoding section 1, octets 53 - 56.'
        ENDIF
      ENDIF
C
C     Octet 57: Total number of frequencies (Nf)
C     One 8-bit field.
C
      CALL INXBIT(KGRIB,KLENG,KNSPT,KSEC1(46),1,KBITS,8,HFUNC,KRET)
      IF (KRET.NE.0) THEN
        KRET = 2
        WRITE(GRPRSM,*) 'ECDEF14: Error reported by routine INXBIT:'
        IF( LENCODE ) THEN
          WRITE(GRPRSM,*) '      encoding section 1, element 46.'
        ELSE
          WRITE(GRPRSM,*) '      decoding section 1, octets 57.'
        ENDIF
      ENDIF
C
C     Octets 58-60: Spare (set to zero)
C     Three 8-bit fields.
C
      IF( LENCODE ) THEN
        DO 210 JLOP = 58, 60
          IZERO = 0
          CALL INXBIT(KGRIB,KLENG,KNSPT,IZERO,1,KBITS,8,HFUNC,KRET)
          IF (KRET.NE.0) THEN
            KRET = 2
            WRITE(GRPRSM,*) 'ECDEF14: Error reported by routine INXBIT:'
            WRITE(GRPRSM,*) '      encoding section 1, octets 58 - 60.'
          ENDIF
  210   CONTINUE
      ELSE
        KNSPT = KNSPT + 3*8
      ENDIF
C
C     Octet 61 onwards: List of Nf scaled directions
C     Nf 32-bit fields.
C
      NF = KSEC1(46)
      DO 220 JLOP = 47, (46+NF)
        CALL INXBIT(KGRIB,KLENG,KNSPT,KSEC1(JLOP),1,KBITS,32,HFUNC,KRET)
        IF (KRET.NE.0) THEN
          KRET = 2
          WRITE(GRPRSM,*) 'ECDEF14: Error reported by routine INXBIT:'
          IF( LENCODE ) THEN
            WRITE(GRPRSM,*)
     X  '      encoding section 1, elements 47 onwards'
          ELSE
            WRITE(GRPRSM,*)
     X  '      decoding section 1, octets 61 onwards.'
          ENDIF
        ENDIF
  220 CONTINUE
C
C     Octets at end of header:Spare - set to zero.
C     (255-NF) 32-bit fields.
C
      NLEFT = 255 - NF
      IF( LENCODE ) THEN
        DO 230 JLOP = 1, NLEFT
          IZERO = 0
          CALL INXBIT(KGRIB,KLENG,KNSPT,IZERO,1,KBITS,32,HFUNC,KRET)
          IF (KRET.NE.0) THEN
            KRET = 2
            WRITE(GRPRSM,*) 'ECDEF11: Error reported by routine INXBIT:'
            WRITE(GRPRSM,*)
     X  '      encoding section 1, spare octets at end.'
          ENDIF
  230   CONTINUE
      ELSE
        KNSPT = KNSPT + (NLEFT*32)
      ENDIF
C
C     On encoding, record the length of section 1.
C
      IF( LENCODE ) THEN
        LENS1 = 1080
        CALL INXBIT(KGRIB,KLENG,KPLEN,LENS1, 1,KBITS,24,HFUNC,KRET)
        IF (KRET.NE.0) THEN
          KRET = 2
          WRITE(GRPRSM,*) 'ECDEF14: Error reported by routine INXBIT:'
          WRITE(GRPRSM,*) '         encoding length of section 1.'
        ENDIF
      ENDIF
C
C     ------------------------------------------------------------------
C*    Section 9 . Abort/return to calling routine. Format statements.
C     ------------------------------------------------------------------
C
  900 CONTINUE
C
      IF( KPR.GE.1 ) THEN
        WRITE(GRPRSM,*) 'ECDEF14: Section 9.'
        WRITE(GRPRSM,*) '        Output values set, KNSPT = ', KNSPT
      ENDIF
C
C     Abort if requested to do so when an error has been encountered.
C
      IF (IRET.EQ.0.AND.KRET.NE.0) THEN
        CALL ABORTX ('ECDEF14')
      ELSE
        RETURN
      ENDIF
C
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      INTEGER FUNCTION IGBESS(KTRUNC, PBESJ0, KPR, KERR)
C
C---->
C**** *IGBESS*
C
C     PURPOSE
C     _______
C
C     Computes initial approximations to Gaussian latitudes.
C
C     INTERFACE
C     _________
C
C     IERR = IGBESS(KTRUNC, PBESJ0, KPR, KERR)
C
C     Input parameters
C     ________________
C
C     KTRUNC     - This is the number of zeros of the J0 Bessel
C                  function required.
C
C
C     KPR        - The debug print switch.
C                  0  , No debugging output.
C                  1  , Produce debugging output.
C
C     KERR       - The error control flag.
C                  -ve, No error message. Return error code.
C                  0  , Hard failure with error message.
C                  +ve, Print error message. Return error code.
C
C     Output parameters
C     ________________
C
C     PBESJ0     - The output array of zeros of the J0 Bessel function.
C
C     Return Value
C     ____________
C
C     The error indicator (INTEGER).
C
C     Error and Warning Return Values
C     _______________________________
C
C     None
C
C     Common block usage
C     __________________
C
C     None
C
C     EXTERNALS
C     _________
C
C     INTLOG(R)    - Logs messages.
C
C     METHOD
C     ______
C
C     The first JPLOOK values are obtained from a look-up table
C     (ZPBES). Any additional values requested are approximated by
C     adding PI (3.14159...) to the previous value.
C
C     REFERENCE
C     _________
C
C     None
C
C     COMMENTS
C     ________
C
C     This routine is adapted from that in the old Marsint library.
C     The interface and the variable names have been modified.
C
C     Program contains sections 0 to 2 and 9
C
C     AUTHOR
C     ______
C
C     K. Fielding      *ECMWF*      Oct 1993
C
C     MODIFICATIONS
C     _____________
C
C     None
C
C----<
C     _______________________________________________________
C
C*    Section 0. Definition of variables.
C     _______________________________________________________
C
      IMPLICIT NONE
C
#include "jparams.h"
#include "parim.h"
C
C     Dummy arguments
      INTEGER KTRUNC, KPR, KERR
      REAL PBESJ0 (*)
C
C     Local variables
      INTEGER ILOOK
      INTEGER JAPPRX, JLOOK
      INTEGER JPROUTINE
      PARAMETER (JPROUTINE = 24400)
      REAL ZPBES (JPLOOK)
      DATA ZPBES        /   2.4048255577E0,   5.5200781103E0,
     1    8.6537279129E0,  11.7915344391E0,  14.9309177086E0,
     2   18.0710639679E0,  21.2116366299E0,  24.3524715308E0,
     3   27.4934791320E0,  30.6346064684E0,  33.7758202136E0,
     4   36.9170983537E0,  40.0584257646E0,  43.1997917132E0,
     5   46.3411883717E0,  49.4826098974E0,  52.6240518411E0,
     6   55.7655107550E0,  58.9069839261E0,  62.0484691902E0,
     7   65.1899648002E0,  68.3314693299E0,  71.4729816036E0,
     8   74.6145006437E0,  77.7560256304E0,  80.8975558711E0,
     9   84.0390907769E0,  87.1806298436E0,  90.3221726372E0,
     A   93.4637187819E0,  96.6052679510E0,  99.7468198587E0,
     1  102.8883742542E0, 106.0299309165E0, 109.1714896498E0,
     2  112.3130502805E0, 115.4546126537E0, 118.5961766309E0,
     3  121.7377420880E0, 124.8793089132E0, 128.0208770059E0,
     4  131.1624462752E0, 134.3040166383E0, 137.4455880203E0,
     5  140.5871603528E0, 143.7287335737E0, 146.8703076258E0,
     6  150.0118824570E0, 153.1534580192E0, 156.2950342685E0 /
C
C     _______________________________________________________
C
C*    Section 1. Extract initial values from look up table
C     _______________________________________________________
C
  100 CONTINUE
C
      IF (KPR.GE.1) CALL INTLOG(JP_DEBUG,'IGBESS: Section 1.',JPQUIET)
C
      IGBESS = 0
C
      IF (KPR .GE. 1) CALL INTLOG(JP_DEBUG,
     X  'IGBESS: No.values requested = ',KTRUNC)
C
      ILOOK = MIN (KTRUNC, JPLOOK)
C
      DO 110 JLOOK = 1, ILOOK
        PBESJ0(JLOOK) = ZPBES(JLOOK)
  110 CONTINUE
C
C     _______________________________________________________
C
C*    Section 2. Approximate any extra values required
C     _______________________________________________________
C
  200 CONTINUE
C
      IF(KPR.GE.1) CALL INTLOG(JP_DEBUG,'IGBESS: Section 2.',JPQUIET)
C
      DO 210 JAPPRX = ILOOK + 1, KTRUNC
        PBESJ0(JAPPRX) = PBESJ0(JPLOOK) + PPI*(JAPPRX - ILOOK)
  210 CONTINUE
C
C     _______________________________________________________
C
C*    Section 9. Return to calling routine. Format statements
C     _______________________________________________________
C
  900 CONTINUE
C
      IF(KPR.GE.1) CALL INTLOG(JP_DEBUG,'IGBESS: Section 9.',JPQUIET)
C
      RETURN
      END

C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE ECDEF50(HFUNC,KSEC1,KGRIB,KLENG,KNSPT,KBITS,KRET)
C
C---->
C**** ECDEF50
C
C     Purpose.
C     --------
C
C     GRIB coding/decoding of ECMWF local use definition 50.
C
C**   Interface.
C     ----------
C
C     CALL ECDEF50(HFUNC,KSEC1,KGRIB,KLENG,KNSPT,KBITS,KRET)
C
C
C     Input
C     -----
C     HFUNC      - Requested function.
C                  'C' to code data.
C                  'D' to decode data.
C     KSEC1      - Array containing Grib Section 1 data.
C     KGRIB      - Array containing Grib coded data.
C     KLENG      - Length (words) of KGRIB.
C     KNSPT      - Bit number after which insertion/extraction starts.
C     KBITS      - Number of bits in computer word.
C     KRET       - Response to error indicator.
C                  0        , Abort if error encountered.
C                  Non-zero , Return to calling routine
C                             even if error encountered.
C
C     Output
C     ------
C     KSEC1      - Array containing Grib Section 1 data.(Updated)
C     KGRIB      - Array containing Grib coded data.(Updated)
C     KNSPT      - Number of bit after last one inserted/extracted.
C                  (Updated)
C     KRET       - Return code.
C                  0   , No error encountered.
C                  2   , Error reported by routine INXBIT.
C
C
C     Method.
C     -------
C     Input data packed/unpacked in accordance with ECMWF usage of
C     local part of section 1 of Grib code, definition 50.
C
C
C     Externals.
C     ----------
C
C     INXBIT  - insert/extract bits
C     ABORTX  - abort the program
C     CSGNBT  - code a signed value
C     DSGNBT  - decode a signed value
C
C
C     Reference.
C     ----------
C
C     WMO Manual On Codes for Grib Code.
C
C
C     Comments.
C     ---------
C
#include "ecdef50.h"
C
C
C     Author.
C     -------
C
C     J.D.Chambers     ECMWF      December 2001
C
C
C     Modifications.
C     --------------
C
C     None
C
C
C----<
C     -----------------------------------------------------------------|
C*    Section 0 . Definition of variables. Data statements.
C     -----------------------------------------------------------------|
C
      IMPLICIT NONE
C
C     Subroutine arguments
C
      CHARACTER*1   HFUNC
      INTEGER KSEC1, KGRIB, KLENG, KNSPT, KBITS, KRET
      DIMENSION KGRIB(*)
      DIMENSION KSEC1(*)
C
C     Local variables
C
      INTEGER IRET, IZERO, JLOOP, ITEMP, IRETA
C
      LOGICAL LENCODE, LDECODE
C
C     -----------------------------------------------------------------|
C*    Section 1 . Set initial values.
C     -----------------------------------------------------------------|
C
  100 CONTINUE
C
      IRET = KRET
      LENCODE = ( HFUNC.EQ.'C' )
      LDECODE = .NOT. LENCODE
C
C     -----------------------------------------------------------------|
C*    Section 2 . Handle the local extension
C     -----------------------------------------------------------------|
C
  200 CONTINUE
C
C     Octet 50 : Number
C     Octet 51 : Total
C     Octet 52 : Model identifier
C     Three 8 bit fields.
C
      CALL INXBIT(KGRIB,KLENG,KNSPT,KSEC1(42),3,KBITS,8,HFUNC,KRET)
      IF( KRET.NE.0 ) THEN
        KRET = 2
        WRITE(*,*) 'ECDEF50: Error reported by routine INXBIT:'
        IF( LENCODE ) THEN
          WRITE(*,*) '      encoding section 1, elements 42 - 44.'
        ELSE
          WRITE(*,*) '      decoding section 1, octets 50 - 52.'
        ENDIF
        GOTO 900
      ENDIF
C
C     Octets 53-56: Latitude of North-west corner of area
C     Octets 57-60: Longitude of North-west corner of area
C     Octets 61-64: Latitude of South-east corner of area
C     Octets 65-68: Longitude of South-east corner of area
C     Four 32 bit fields.
C
      CALL INXBIT(KGRIB,KLENG,KNSPT,KSEC1(45),4,KBITS,32,HFUNC,KRET)
      IF( KRET.NE.0 ) THEN
        KRET = 2
        WRITE(*,*) 'ECDEF50: Error reported by routine INXBIT:'
        IF( LENCODE ) THEN
          WRITE(*,*) '      encoding section 1, elements 45 - 48.'
        ELSE
          WRITE(*,*) '      decoding section 1, octets 53 - 68.'
        ENDIF
        GOTO 900
      ENDIF
C
C     Octets 69-116 : Reserved for ECMWF additions.
C     Octet 69 : Original parameter number
C     Octet 70 : Original parameter table number
C     Octets 71-116 : Reserved for ECMWF additions.
C
      CALL INXBIT(KGRIB,KLENG,KNSPT,KSEC1(49),2,KBITS,8,HFUNC,KRET)
      IF( KRET.NE.0 ) THEN
        KRET = 2
        WRITE(*,*) 'ECDEF50: Error reported by routine INXBIT:'
        IF( LENCODE ) THEN
          WRITE(*,*) '      encoding section 1, elements 49 - 50.'
        ELSE
          WRITE(*,*) '      decoding section 1, octets 69 - 70.'
        ENDIF
        GOTO 900
      ENDIF
C
      IF( LENCODE ) THEN
        DO JLOOP = 71, 116
          IZERO = 0
          CALL INXBIT(KGRIB,KLENG,KNSPT,IZERO,1,KBITS,8,HFUNC,KRET)
          IF( KRET.NE.0 ) THEN
            KRET = 2
            WRITE(*,*) 'ECDEF50: Error reported by routine INXBIT:'
            WRITE(*,*) '      encoding section 1, octets 71 - 116'
            GOTO 900
          ENDIF
        ENDDO
      ELSE
        DO JLOOP = 51, 60
          KSEC1(JLOOP) = 0
        ENDDO
        KNSPT = KNSPT + 46*8
      ENDIF
C
C     Octets 117-300 : Optional data.
C     Forty-six 32 bit fields.
C
      DO JLOOP = 61, 106
        CALL INXBIT(
     X    KGRIB,KLENG,KNSPT,KSEC1(JLOOP),1,KBITS,32,HFUNC,KRET)
        IF( KRET.NE.0 ) THEN
          KRET = 2
          WRITE(*,*) 'ECDEF50: Error reported by routine INXBIT:'
          IF( LENCODE ) THEN
            WRITE(*,*) '      encoding section 1, elements 61 - 106.'
          ELSE
            WRITE(*,*) '      decoding section 1, octets 117 - 300.'
          ENDIF
          GOTO 900
        ENDIF
      ENDDO
C
C     -----------------------------------------------------------------|
C*    Section 9 . Abort/return to calling routine. Format statements.
C     -----------------------------------------------------------------|
C
  900 CONTINUE
C
C     Abort if requested to do so when an error has been encountered.
C
      IF( (IRET.EQ.0).AND.(KRET.NE.0) ) THEN
        CALL ABORTX('ECDEF50')
      ELSE
        RETURN
      ENDIF
C
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE JDEBUG( )
C
C---->
C**** JDEBUG
C
C     PURPOSE
C     _______
C
C     This routine checks whether the debug flag is to be turned on.
C
C
C     INTERFACE
C     _________
C
C     CALL JDEBUG( )
C
C     Input parameters
C     ________________
C
C     None
C
C
C     Output parameters
C     ________________
C
C     None
C
C
C     Common block usage
C     __________________
C
C     JDCNDBG - set flag NDBG.
C     JDCSPGP - set flag LFREECF, etc.
C
C
C     Method
C     ______
C
C     On first call, checks whether or not the environment 
C     variable JDCNDBG exists.
C
C
C     Externals
C     _________
C
C     GETENV    - Checks value of an environment variable.
C     INTLOGD   - Switchs on/off the printing off interpoaltion messages
C
C
C     Reference
C     _________
C
C     None
C
C
C     Comments
C     ________
C
C     None.
C
C
C     AUTHOR
C     ______
C
C     J.D.Chambers      *ECMWF*      Mar 1994
C
C
C     MODIFICATIONS
C     _____________
C
C     J.D.Chambers      *ECMWF*      5 Sep 1995
C     Add call to intlogd.
C
C     J.D.Chambers      *ECMWF*      19 Mar 1998
C     Add setting of LFREECF, etc
C
C----<
C
      IMPLICIT NONE
#include "jparams.h"
#include "jparam2.h"
C
C     Local variables
C
      INTEGER NFIRST
      DATA NFIRST/0/
      CHARACTER*12 YFLAG
      SAVE NFIRST
C
C     _______________________________________________________
C
C*    Section 1.    Initialization.
C     _______________________________________________________
C
  100 CONTINUE
C
      IF( NFIRST.EQ.0 ) THEN
        NFIRST = 1
C
C       Set debug level to control which messages are displayed
C
        CALL GETENV('JDCNDBG', YFLAG)
        IF( YFLAG(1:1).EQ.' ' ) THEN
           NDBG = 0
           CALL GETENV('EMOSLIB_DEBUG', YFLAG)
        ENDIF
        IF( YFLAG(1:1).EQ.'1' ) NDBG = 1
        IF( YFLAG(1:1).EQ.'2' ) NDBG = 2
        IF( YFLAG(1:1).EQ.'3' ) NDBG = 3
        IF( NDBG.EQ.0 ) THEN
          CALL INTLOGD(0)
        ELSE
          CALL INTLOGD(1)
        ENDIF
C
C       Initialise the flags controlling handling of spectral -> grid
C       interpolation coefficients memory unless already set by user
C
        IF( NFREECF.NE.11041967 ) THEN
          LFREECF = .FALSE.
          NFREECF = 11041967
        ENDIF
C
C       Clear the sizes of the memory areas used for coefficients in
C       spectral -> grid interpolations
C
        NISIZE6 = 0
        NISIZE7 = 0
C
      ENDIF
C
C     _______________________________________________________
C
C*    Section 9. Return to calling routine.
C     _______________________________________________________
C
 900  CONTINUE
C
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE GRSMAX (PMAX)
C
C---->
C**** GRSMAX - Set user defined maximum value for routine GRIBEX.
C
C     Purpose.
C     --------
C
C           Set user defined maximum value for GRIB code for
C           routine GRIBEX.
C
C**   Interface.
C     ----------
C
C           CALL GRSMAX (PMAX)
C
C           Integer    K.
C           Real       P.
C           Logical    O.
C           Character  H.
C
C               Input Parameters.
C               -----------------
C
C               PMAX        - Maximum value required.
C
C               Output Parameters.
C               ------------------
C
C               None.
C
C     Method.
C     -------
C
C           The flag variable NFMAX is set to indicate that the
C           user has supplied a maximum value and the variable
C           FMAX is set to the required maximum value. These
C           variables are in the common area. All other parameters
C           are also set to default values, if they have not already
C           been set by the user.
C
C     Externals.
C     ----------
C
C           None.
C
C     Reference.
C     ----------
C
C           See subroutine GRIBEX.
C
C     Comments.
C     ---------
C
C           Routine contains Sections 0 to 1 and Section 9.
C
C     Author.
C     -------
C
C           J. Hennessy      ECMWF      25.06.91
C
C     Modifications.
C     --------------
C
C           J. Hennessy      ECMWF      28.08.91
C           Changes to some comments only.
C
C           J. Hennessy      ECMWF      14.11.91
C           Changes to common area.
C
C           J.D.Chambers     ECMWF      13.09.94
C           Add NONOFF and NOABORT, use grbcom.h
C
C           J. Clochard, Meteo France, for ECMWF - March 1998.
C           Use GRSDEF routine for default setting.
C
C           J. Clochard, Meteo France, for ECMWF - June 1999.
C           Use a static variable to determine if initialisation of
C           default values has already been done for common area
C           variables.
C
C----<
C     ----------------------------------------------------------------
C*    Section 0 . Definition of variables.
C     ----------------------------------------------------------------
C
      IMPLICIT NONE
C
#include "grbcom.h"
C
      REAL    PMAX
C
      LOGICAL LFIRST
      SAVE LFIRST
C
      DATA LFIRST / .TRUE. /
C
C     ----------------------------------------------------------------
C*    Section 1 . Set values.
C     ----------------------------------------------------------------
C
  100 CONTINUE
C
      IF (LFIRST) THEN
C
C       Common area variables may have not been set, so start by
C       trying to set default values.
C
        CALL GRSDEF
        LFIRST=.FALSE.
C
      ENDIF
C
C     Set maximum value to required value.
C
      FMAX   = PMAX
C
C     Maximum value supplied by user flag. Set to on.
C
      NFMAX  = 1
C
C     ----------------------------------------------------------------
C*    Section 9 . Return to calling routine.
C     ----------------------------------------------------------------
C
  900 CONTINUE
C
      RETURN
C
      END

C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE BUENS4(KSEC3,KSEC4,KELEM,KVALS,VALUES,CVALS,
     1                  KBUFL,KBUFF,KERR)
C
C**** *BUENS4*
C
C
C     PURPOSE.
C     --------
C          PACK PRELIMINARY ITEMS AND DATA OF SECTION 4 OF BUFR MESSAGE.
C
C
C**   INTERFACE.
C     ----------
C
C          *CALL* *BUENS4(KSEC3,KSEC4,KELEM,KVALS,VALUES,CVALS,
C                         KBUFL,KBUFF,KERR)*
C
C        INPUT :
C               *KSEC3*   -  ARRAY CONTAINING SECTION 3 INFORMATION
C                            KSEC3( 1)-- LENGTH OF SECTION 3 (BYTES)
C                            KSEC3( 2)-- RESERVED
C                            KSEC3( 3)-- NUMBER OF SUBSETS
C                            KSEC3( 4)-- FLAG (DATA TYPE,DATA COMPRESSION)
C               *KSEC4*   -  ARRAY CONTAINING SECTION 4 INFORMATION
C                            KSEC4( 1)-- LENGTH OF SECTION 4 (BYTES)
C                            KSEC4( 2)-- RESERVED
C               *KELEM*   -  NUMBER OF ELEMENTS IN BUFR TEMPLATE
C               *KVALS*   -  DIMENSION OF VALUES ARRAY
C               *VALUES*  -  REAL ARRAY (EXPANDED DATA VALUES)
C
C        OUTPUT :
C               *KBUFL*   -  LENGTH OF BUFR MESSAGE (WORDS)
C               *KBUFF*   -  ARRAY CONTAINING BUFR MESSAGE
C               *KERR*    -  RETURNED ERROR CODE
C
C     METHOD.
C     -------
C
C           NONE.
C
C
C     EXTERNALS.
C     ----------
C
C          BUPCK          -  PACK BIT PATHERN
C          BUPKS          -  PACK BIT PATHERN IN REPEATED WAY,
C                            POINTER ADJUSTMENT
C          BUOCTN         -  SET LENGTH OF SECTION
C
C
C     REFERENCE.
C     ----------
C
C          NONE.
C
C     AUTHOR.
C     -------
C
C          M. DRAGOSAVAC    *ECMWF*       17/01/91.
C
C
C     MODIFICATIONS.
C     --------------
C
C          NONE.
C
C
      IMPLICIT LOGICAL(L,O,G), CHARACTER*8(C,H,Y)
C
C
#     include "parameter.F"
#     include "bcomunit.F"
#     include "bcmwork.F"
#     include "bcmwt.F"
#     include "bcmwtc.F"
#     include "bcmbef.F"
#     include "bcprq.F"
#     include "bcmoff.F"
C
      CHARACTER*64 CWTEN
      CHARACTER*24 CWTU
C
      DIMENSION KBUFF(KBUFL)
C
      DIMENSION KSEC3(JSEC3),KSEC4(JSEC4)
#ifndef R_4
      REAL*8 VALUES(KVALS)
      REAL*8 RVIND
      REAL*8 EPS
      REAL*8 VAL,VAL8S
      REAL*8 VCHECK
      REAL*8 RVALS(JWORK)
#else
      REAL   VALUES(KVALS)
      REAL   RVIND
      REAL   EPS
      REAL   VAL
      REAL   VCHECK
      REAL   RVALS(JWORK)
#endif
C
      REAL*4 RVALS4(JWORK)
      REAL*4 VAL4,VAL4S
      INTEGER*4 I4
      REAL*8 R8
      REAL*4 R4
      LOGICAL OBIG, OEQUAL
      LOGICAL BIG_ENDIAN
C
      DIMENSION IVALS(JWORK),INC(JELEM),ILOCVAL(JELEM)
      DIMENSION IIVALS(JELEM)
C
      CHARACTER*80 CVALS(KVALS)
      CHARACTER*80 YVAL
C
      DIMENSION IMASK(8),IMAXV(32)
      DATA IMASK/1,2,4,8,16,32,64,128/
C     DATA ILOCVAL/JELEM*0/
C
      DATA IMAXV/1,3,7,15,31,63,127,255,511,1023,2047,4095,8191,
     1  16383,32767,65535,131071,262143,524287,1048575,2097151,
     2  4194305,8388607,16777215,33554431,671108863,134217727,
     3  268435455,536870911,1073741823,2147483647,2147483647/
C
      SAVE IWPTB,IBPTB
C     ------------------------------------------------------------------
C*          1.  PACK PRELIMINARY ITEMS OF SECTION 4.
C               ------------------------------------
 100  CONTINUE
C
      IF(KERR.GT.0) RETURN
C
      R4=3.4028235e+38
      R8=1.7976931348623157D+308
C
C*          1.1  KEEP POINTERS TO THE BEGINING OF THE SECTION.
C                ---------------------------------------------
 110  CONTINUE
C
      IF(OMULTI) THEN
        IF(NSUBSET.EQ.1) THEN
           IWPTB = NWPT
           IBPTB = NBPT 
        END IF
      ELSE
         IWPTB = NWPT
         IBPTB = NBPT
      END IF

c     IF(OMULTI.AND.NSUBSET.EQ.1) THEN
      IF(NSUBSET.EQ.1) THEN
C
C*          1.2  PACK LENGTH OF SECTION 4.
C                -------------------------
 120  CONTINUE
C
         CALL BUPCK(NBPW,KBUFF(NWPT),0,NWPT,NBPT,24,KERR)
         IF(KERR.GT.0) THEN
            WRITE(KNTN,*) 'ERROR PACKING LENGTH OF SECTION 4.'
            RETURN
         END IF
C
C*          1.4  PACK RESERVED BYTE.
C                -------------------
 140     CONTINUE
C
         CALL BUPCK(NBPW,KBUFF(NWPT),0,NWPT,NBPT, 8,KERR)
         IF(KERR.GT.0) THEN
            WRITE(KNTN,*)'ERROR PACKING RESERVED BYTE IN SECTION 4.'
            RETURN
         END IF
C
      END IF
C     -----------------------------------------------------------------
C*          2. PACK DATA.
C              ----------
 200  CONTINUE
C
C      IKK=KELEM*KSEC3(3)
C      IF(IKK.GT.JWORK) THEN
C         KERR=17
C         CALL BUERR(KERR)
C         WRITE(KNTN,*)'CHECK VALUES OF KELEM AND NUMBER OF SUBSETS KSEC3(3).'
C         RETURN
C      END IF
C      IF(IKK.GT.KVALS) THEN
C         KERR=14
C         CALL BUERR(KERR)
C         WRITE(KNTN,*)'KVALS MUST BE GREATER THAN KELEM*KSEC3(3).'
C         RETURN
C      END IF
C
C*          2.1  CHECK IF DATA HAS TO BE COMRESSED.
C                ----------------------------------
 210  CONTINUE
C
      IB=0
      IF(IAND(KSEC3(4),IMASK(7)).NE.0) IB=1
C
C
C     ------------------------------------------------------------------
C
C*          3.  UNCOMPRESSED DATA.
C               ------------------
 300  CONTINUE
C
      IF(IB.EQ.0) THEN
C
         N=KSEC3(3)
         IF(OMULTI) N=1
         
         DO 301 I=1,N
C
         IF(OMULTI) THEN
            IM1K=(NSUBSET-1)*KELEM
         ELSE
            IM1K=(I-1)*KELEM
         END IF
C
         DO 302 J=1,M
C
         
C        IF(NWTR(J).EQ.31011.OR.NWTR(J).EQ.31012) THEN
C           IRP=VALUES(J+IM1K)             
C           DO III=J+2,J+IRP
C            NWTDW(iii)=0
C           END DO
C        END IF
C
         IF(NWTDW(J).EQ.0) GO TO 302
C
         
         IREF  =NWTRV(J)
         ISCALE=NWTS (J)
         IBDW  =NWTDW(J)
C
         JI=J+IM1K
C
         VAL=VALUES(JI)
         IF(NWTEN(J).EQ.-999) THEN
            IBYTES=NWTDW(J)/8
            IF(ABS(VAL-RVIND)/RVIND.LE.EPS) THEN
               IF(IBYTES.EQ.4) VAL=R4
               IF(IBYTES.EQ.8) VAL=R8
            END IF
            IF(IBYTES.EQ.4) THEN
               VAL4=VAL
               OBIG=BIG_ENDIAN()
               IF(.NOT.OBIG) THEN
                  CALL SWAP_BYTES4(VAL4,VAL4S)
                  VAL4=VAL4S
               END IF
               CALL BUGBYTESR4(VAL4,ILOCVAL,0,8,0,IBYTES)
            ELSE
               OBIG=BIG_ENDIAN()
               IF(.NOT.OBIG) THEN
                  CALL SWAP_BYTES8(VAL,VAL8S)
                  VAL=VAL8S
               END IF
               CALL BUGBYTESR8(VAL,ILOCVAL,0,8,0,IBYTES)
            END IF
            ISKIP=0
            CALL BUPKS(NBPW,KBUFF(NWPT),ILOCVAL,NWPT,NBPT,8,
     1                ISKIP,IBYTES,KERR)
            IF(KERR.GT.0) THEN
               WRITE(KNTN,*)'BUENS4 :'
               WRITE(KNTN,*)'ERROR PACKING REAL IEEE'
               CALL BUERR(KERR)
               RETURN
            END IF
            GO TO 302
         END IF
C
         IF(NWTEN(J).EQ.836970) THEN
            IF(VAL.LT.0) THEN
               IPACK=ABS(NINT(VAL))
               IBDW1=1
               CALL BUPCK(NBPW,KBUFF(NWPT),1,NWPT,NBPT,IBDW1,KERR)
               IBDWM1=IBDW-1
               CALL BUPCK(NBPW,KBUFF(NWPT),IPACK,NWPT,NBPT,IBDWM1,KERR)
            ELSE
               IPACK=NINT(VAL)
               CALL BUPCK(NBPW,KBUFF(NWPT),IPACK,NWPT,NBPT,IBDW,KERR)
            END IF
            GO TO 302
         END IF
C
         IF(NWTEN(J).EQ.658367) THEN
            IF(ABS(VAL-RVIND)/RVIND.LE.EPS) THEN
              YVAL=' '
              NCHAR=NWTDW(J)
              DO 3031 II=1,NCHAR/8
C             IPACK=ICHAR(YVAL(II:II))
              IPACK=255
              IF(IPACK.GT.IMAXV(8)) IPACK=IMAXV(8)
              CALL BUPCK(NBPW,KBUFF(NWPT),IPACK,NWPT,NBPT,8,KERR)
              IF(KERR.GT.0) THEN
                 WRITE(KNTN,*)'ERROR PACKING ',JI,' VALUE FOR ',J,
     1                        ' ELEMENT.'
                 RETURN
              END IF
 3031         CONTINUE
              GO TO 302

            ELSE
              IST=NINT(VAL)/1000
              YVAL=CVALS(IST)
              NCHAR=NWTDW(J)/8
              DO 303 II=1,NCHAR
              IPACK=ICHAR(YVAL(II:II))
              IF(IPACK.GT.IMAXV(8)) IPACK=IMAXV(8)
              CALL BUPCK(NBPW,KBUFF(NWPT),IPACK,NWPT,NBPT,8,KERR)
              IF(KERR.GT.0) THEN
                 WRITE(KNTN,*)'ERROR PACKING ',JI,' VALUE FOR ',J,
     1                        ' ELEMENT.'
                 RETURN
              END IF
 303          CONTINUE
              GO TO 302
            END IF
         END IF
C        
         IF(ABS(VAL-RVIND)/RVIND.LE.EPS) THEN
            CALL BUPCK(NBPW,KBUFF(NWPT),NMASK(IBDW),NWPT,NBPT,IBDW,KERR)
            IF(KERR.GT.0) THEN
               WRITE(KNTN,*)'ERROR PACKING ',JI,' VALUE FOR ',J,
     1                      ' ELEMENT.'
               RETURN
            END IF
         ELSE
C
C        CHECK VAL VALUE FOR POSSIBLE OVERFLOW
C

            IF(NOFL.EQ.1) THEN
               IF(ABS(VAL).LT.EPS) VAL = 0.0
               IF(VAL.GE.0) THEN
                  ICHECK=IMAXV(IBDW)
                  ICHECK=ICHECK+IREF
                  VCHECK=ICHECK*10.**(-ISCALE)
C
                  IF(VAL .GT. VCHECK) THEN
                     WRITE(KNTN,*) 'VALUE=',VAL,'TOO BIG FOR ',
     1                      J,' ELEMENT ',I,' SUBSET.'
                     VAL=VCHECK+1.
                  END IF
               ELSE
                  VCHECK=IREF/10.**ISCALE
                  IF(VAL.LT.VCHECK) THEN
                WRITE(KNTN,*)'VALUE=',VAL,'TOO BIG NEGATIVE FOR ',
     1                      J,' ELEMENT ',I,' SUBSET.'
                     VAL=IREF/10.**ISCALE-1.
                  END IF
               END IF
            END IF

            IF(ISCALE.LT.0) THEN
               ISCALE=IABS(ISCALE)
               IPACK=NINT(VAL/10.**ISCALE) - IREF
            ELSE
               IPACK=NINT(VAL*10.**ISCALE) - IREF
            END IF
C
C           CHECK IF VALUE TO BE PACKED NEGATIVE
C
            IF(IPACK.LT.0) THEN
               KERR=-33
               WRITE(KNTN,*)'BUENS4:'
               WRITE(KNTN,*)'VALUE ',IPACK,' IS NEGATIVE'
               WRITE(KNTN,*)'PROBABLY REFERENCE VALUE TOO BIG.'
               WRITE(KNTN,*)J,' ELEMENT = ',NWTR(J),
     1               ' REFERENCE VALUE = ',IREF
               IPACK=0
               WRITE(KNTN,*)'ELEMENT VALUE PACKED AS',IREF
            END IF
C
C*          CHECK IF VALUE TO BE PACKED TOO BIG.
C
            IF(IPACK.GT.IMAXV(IBDW)) THEN
C
               IF(NPMISS.EQ.0) THEN
                KERR=-28
                WRITE(KNTN,*)'VALUE ',IPACK,' TOO BIG.'
                WRITE(KNTN,*)'VALUE FOR ',J,' ELEMENT AND ',I,
     1                       ' SUBSET'
                WRITE(KNTN,*)'PACKED AS MISSING VALUE FOR',
     1                         ' DATA WIDTH -1.'
                IPACK=IMAXV(IBDW)-1
               ELSE
C
C                 ALL ELEMENTS IN CLASS 1 TO 9 MUST BE CORRECT
C
                  IF(NWTR(J).GE.31000.AND.NWTR(J).LE.31012) THEN
                     WRITE(KNTN,*)'VALUE ',IPACK,' TOO BIG.'
                     WRITE(KNTN,*)'VALUE FOR ',J,' ELEMENT AND ',I,
     1                           ' SUBSET'
                     KERR=28
                     CALL BUERR(KERR)
                     RETURN
                  END IF
C
                  KERR=-28
                  WRITE(KNTN,*)'VALUE ',IPACK,' TOO BIG.'
                  WRITE(KNTN,*)'VALUE FOR ',J,' ELEMENT AND ',I,
     1                         ' SUBSET'
                  WRITE(KNTN,*)'PACKED AS MISSING VALUE FOR',
     1                         '  DATA WIDTH.'
                  IPACK=IMAXV(IBDW)
               END IF
            END IF
            CALL BUPCK(NBPW,KBUFF(NWPT),IPACK,NWPT,NBPT,IBDW,KERR)
            IF(KERR.GT.0) THEN
               WRITE(KNTN,*)'ERROR PACKING ',JI,' VALUE FOR ',J,
     1         ' ELEMENT.'
               WRITE(KNTN,*)'VALUE ',IPACK,' DATA WIDTH ',IBDW,
     1         ' BITS'
               RETURN
            END IF
         END IF
C
 302     CONTINUE
 301     CONTINUE
C
         NWP=NWPT
         NBP=NBPT
      END IF
C
C*          4.  COMPRESS DATA.
C               --------------
 400  CONTINUE
C
      IF(IB.EQ.1) THEN
         DO 402 J=1,M
C
         IF(NWTDW(J).EQ.0) GO TO 402
C
         IREF  =NWTRV(J)
         ISCALE=NWTS (J)
         IBDW  =NWTDW(J)
C
         DO 401 I=1,KSEC3(3)
C
         JI=J+(I-1)*KELEM
C
         IF(NWTEN(J).EQ.658367) THEN
            IVALS(JI)=VALUES(JI)
            GO TO 401
         END IF
C
         IF(NWTEN(J).EQ.-999) THEN
            IF(NWTDW(J).EQ.32) THEN
               IF(ABS(VALUES(JI)-RVIND)/RVIND.LT.EPS) THEN
                  RVALS4(JI)=R4
               ELSE
                  RVALS4(JI)=VALUES(JI)
               END IF
            ELSE
              IF(ABS(VALUES(JI)-RVIND)/RVIND.LT.EPS) THEN 
                 RVALS(JI)=R8
               ELSE
                 RVALS(JI)=VALUES(JI)
               END IF
            END IF
            GO TO 401
         END IF
C
         IF(NWTEN(J).EQ.836970) THEN
            ISG_REF=0
            IF(VALUES(JI).LT.0) ISG_REF=1
            IVALS(JI)=IABS(NINT(VALUES(JI)))
            GO TO 401
         END IF
C
         IF(ABS(VALUES(JI)-RVIND)/RVIND.LE.EPS) THEN
            IVALS(JI)=NMASK(IBDW)
         ELSE
            IF(NOFL.EQ.1) THEN
               IF(VALUES(JI).GE.0) THEN
                  ICHECK=IMAXV(IBDW)
                  ICHECK=ICHECK+IREF
                  VCHECK=ICHECK*10.**(-ISCALE)
C
                  IF(VALUES(JI) .GT. VCHECK) THEN
                     WRITE(KNTN,*) 'VALUE=',VALUES(JI),'TOO BIG FOR ',
     1                      J,' ELEMENT AND ',I,' SUBSET.'
                     VALUES(JI)=VCHECK+1.
                  END IF
               ELSE
                  VCHECK=IREF/10.**ISCALE
                  IF(VALUES(JI).LT.VCHECK) THEN 
                     WRITE(KNTN,*) 'VALUE=',VALUES(JI),
     1                      'TOO BIG NEGATIVE FOR ',
     1                      J,' ELEMENT AND ',I,' SUBSET.'
                     VALUES(JI)=IREF/10.**ISCALE-1.
                  END IF
               END IF
            END IF
C
            IF(ISCALE.LT.0) THEN
               ISCAL=IABS(ISCALE)
               IPACK=NINT(VALUES(JI)/10.**ISCAL ) - IREF
            ELSE
               IPACK=NINT(VALUES(JI)*10.**ISCALE) - IREF
            END IF
C
            IF(IPACK.LT.0) THEN
               WRITE(KNTN,*)'BUENS4 :'
               KERR=-33
               WRITE(KNTN,*)'VALUE ',IPACK,' IS NEGATIVE'
               WRITE(KNTN,*)'PROBABLY REFERENCE VALUE TOO BIG.'
               WRITE(KNTN,*)J,'ELEMENT = ',NWTR(J),
     1                    ' REFERENCE VALUE = ',IREF
               IPACK=0
               WRITE(KNTN,*)'ELEMENT PACKED AS',IREF
            END IF
C
C           REPLACE IPACK VALUE WITH MISSING VALUE FOR IBDW -1 
C           IF GREATER THEN MAXIMUM ALLOWED.
C
            IF(IPACK.GT.IMAXV(IBDW)) THEN
C
               IF(NPMISS.EQ.0) THEN
                  KERR=-28
                  WRITE(KNTN,*)'VALUE ',IPACK,' TOO BIG.'
                  WRITE(KNTN,*)'VALUE FOR ',J,' ELEMENT AND ',I,
     1            ' SUBSET'
                  WRITE(KNTN,*)'PACKED AS MISSING VALUE FOR DATA ',
     1                         'WIDTH -1.'
                  IPACK=IMAXV(IBDW)-1
               ELSE
C
C                 ALL ELEMENTS IN CLASS 1 TO 9 MUST BE CORRECT
C
                  IF(NWTR(J).GE.31000.AND.NWTR(J).LE.31012) THEN
                     KERR=28
                     CALL BUERR(KERR)
                     WRITE(KNTN,*)'VALUE ',IPACK,' TOO BIG.'
                     WRITE(KNTN,*)'VALUE FOR ',J,' ELEMENT AND ',I,
     1               ' SUBSET'
                     RETURN
                  END IF
C
                  KERR=-28
                  WRITE(KNTN,*)'VALUE ',IPACK,' TOO BIG.'
                  WRITE(KNTN,*)'VALUE FOR ',J,' ELEMENT AND ',I,
     1            ' SUBSET'
                  WRITE(KNTN,*)'PACKED AS MISSING VALUE.'
                  IPACK=IMAXV(IBDW)
               END IF
            END IF
            IVALS(JI)=IPACK
C
         END IF
C
 401     CONTINUE
 402     CONTINUE
C
C*          4.1  CHECK IF ALL VALUES ARE MISSING.
C
 410  CONTINUE
C
         DO 411 I=1,M
C
         IF(NWTDW(I).EQ.0) GO TO 411
         IBDW  =NWTDW(I)
C
         OMIS=.TRUE.
         IF(NWTEN(I).EQ.658367) THEN
            OMIS=.FALSE.
         ELSEIF(NWTEN(I).EQ.-999) THEN
            OMIS=.FALSE.
         ELSE
            DO 412 J=1,KSEC3(3)
            IJ=I+(J-1)*KELEM
            IF(IVALS(IJ).NE.NMASK(IBDW)) THEN
               OMIS=.FALSE.
            END IF
 412        CONTINUE
         END IF
C
         IF(.NOT.OMIS) THEN
C
            IF(NWTEN(I).NE.658367.AND.NWTEN(I).NE.-999) THEN
C
C              FIND MINIMUM VALUE FOR ELEMENT
C
               MIN=IVALS(I)
               DO 413 J=1,KSEC3(3)
               IJ=I+(J-1)*KELEM
               IF(IVALS(IJ).LT.MIN) MIN=IVALS(IJ)
 413           CONTINUE
C
C              FIND INCREMENTS
C
               DO 414 J=1,KSEC3(3)
               IJ=I+(J-1)*KELEM
               INC(J)=IVALS(IJ)-MIN
               IF(IVALS(IJ).EQ.NMASK(IBDW)) INC(J)=NVIND
 414           CONTINUE
C
C              FIND NUMBER OF BITS NEEDED FOR MAX VALUE OF INCREMENT
C
               MAX=0
               DO 415 J=1,KSEC3(3)
               IF(INC(J).NE.NVIND.AND.INC(J).GT.MAX) MAX=INC(J)
 415           CONTINUE
C
C              CHECK IF ALL INCREMENTS ARE ZERO
C
               INC0=0
               DO 419 J=1,KSEC3(3)
               IF(INC(J).NE.0) INC0=1
 419           CONTINUE
C
C              FIND NUMBER OF BITS NEEDED
C
               IF(INC0.NE.0) THEN
                  MAX=MAX+1
                  DO 416 J=1,32
                  IR=MAX/2
                  IF(IR.EQ.0) GO TO 417
                  MAX=IR
 416              CONTINUE
C
               END IF
C
 417           CONTINUE
C
               INCBIT=0
               IF(INC0.NE.0) INCBIT=J
C
C              REPLACE MISSING VALUES FOR INCREMENT BY ALL BITS SET TO 1.
C
               DO 418 J=1,KSEC3(3)
               IF(INC(J).EQ.NVIND) INC(J)=NMASK(INCBIT)
 418           CONTINUE
            END IF
         END IF
C
C*          4.2  PACK DATA IN COMPRESSED FORM.
C                -----------------------------
 420  CONTINUE
C
         IF(NWTEN(I).EQ.658367) THEN
C
            OSTRING=.TRUE.
            JI1=I
            IST1=IVALS(JI1)/1000
            ICS=NWTDW(I)/8
C           ICS=NINT(VALUES(JI1))-IST1*1000
            NCSMAX=ICS
            DO  IX=ICS,1,-1
            IF(CVALS(IST1)(IX:IX).NE.' ') THEN
               NCS=IX
               GO TO 522
            END IF
            END DO

 522        NCSMAX=NCS
            DO J=2,KSEC3(3)
            JI=I+(J-1)*KELEM
            IST=VALUES(JI)/1000
            IF(CVALS(IST1).NE.CVALS(IST)) OSTRING=.FALSE.
C           FIND MAX SIZE OF STRINGS
            ICS=NWTDW(I)/8
C           ICS=NINT(VALUES(JI))-IST*1000
            DO  IX=ICS,1,-1
            IF(CVALS(IST)(IX:IX).NE.' ') THEN
               NCS=IX
               GO TO 521
            END IF
            END DO
 521        CONTINUE
            IF(NCS.GT.NCSMAX) NCSMAX=NCS 
            END DO

C
            IF(OSTRING) THEN
C
              INCHAR=NWTDW(I)/8
              ISKIP=0
              DO II=1,INCHAR
              IPACK=ICHAR(CVALS(IST1)(II:II))
              CALL BUPCK(NBPW,KBUFF(NWPT),IPACK,NWPT,NBPT,8,KERR) 
              IF(KERR.GT.0) THEN
                 WRITE(KNTN,*)'BUENS4 :'
                 CALL BUERR(KERR)
                 RETURN
              END IF
              END DO
              IPACK=0
              CALL BUPCK(NBPW,KBUFF(NWPT),IPACK,NWPT,NBPT,6,KERR)
              IF(KERR.GT.0) THEN
                 WRITE(KNTN,*)'BUENS4 :'
                 CALL BUERR(KERR)
                 RETURN
              END IF
            ELSE
C
C           PACK LOCAL REFERENCE VALUE FOR ELEMENT
C
            INCHAR=NWTDW(I)/8
            ISKIP=0
            CALL BUPKS(NBPW,KBUFF(NWPT),ILOCVAL,NWPT,NBPT,8,
     1                ISKIP,INCHAR,KERR)
            IF(KERR.GT.0) THEN
               WRITE(KNTN,*)'BUENS4 :'
               WRITE(KNTN,*)'ERROR PACKING LOCAL REFERENCE VALUE'
               CALL BUERR(KERR)
               RETURN
            END IF
C
C           PACK NUMBER OF BITS FOR INCREMENTS/NUMBER OF CHARACTERS
C
C           CALL BUPCK(NBPW,KBUFF(NWPT),INCHAR,NWPT,NBPT,6,KERR)
            CALL BUPCK(NBPW,KBUFF(NWPT),NCSMAX,NWPT,NBPT,6,KERR)
            IF(KERR.GT.0) THEN
              WRITE(KNTN,*)'BUENS4 :'
              WRITE(KNTN,*)'ERROR PACKING NUMBER OF BITS FOR INCREMENTS'
              CALL BUERR(KERR)
              RETURN
            END IF
C
C           PACK INCREMENTS
C
            DO 421 J=1,KSEC3(3)
C
            JI=I+(J-1)*KELEM
C
            IST=IVALS(JI)/1000
            YVAL=CVALS(IST)
C
            DO 423 II=1,NCSMAX
            IPACK=ICHAR(YVAL(II:II))
            CALL BUPCK(NBPW,KBUFF(NWPT),IPACK,NWPT,NBPT,8,KERR)
            IF(KERR.GT.0) THEN
               WRITE(KNTN,*)'BUENS4 :'
               CALL BUERR(KERR)
               RETURN
            END IF
 423        CONTINUE
C
 421        CONTINUE
C
            END IF
         ELSEIF(NWTEN(I).EQ.-999) THEN
C
            OEQUAL=.TRUE.
            DO J=1,KSEC3(3)-1
            JI=I+(J-1)*KELEM
            JII=I+J*KELEM
            IF(NWTDW(I).EQ.32) THEN
               IF(ABS(RVALS4(JI)-RVALS4(JII))/RVALS4(JII).GT.EPS) THEN
                  OEQUAL=.FALSE.
                  GO TO 4444
               END IF

            ELSE
               IF(ABS(RVALS(JI)-RVALS(JII))/RVALS(JII).GT.EPS) THEN
                  OEQUAL=.FALSE.
                  GO TO 4444
               END IF
            END IF
            END DO
C
C           PACK LOCAL REFERENCE VALUE FOR ELEMENT
C
4444        INCHAR=NWTDW(I)/8
            ISKIP=0

            IF(.NOT.OEQUAL) THEN
C
              CALL BUPKS(NBPW,KBUFF(NWPT),ILOCVAL,NWPT,NBPT,8,
     1                  ISKIP,INCHAR,KERR)
              IF(KERR.GT.0) THEN
                 WRITE(KNTN,*)'BUENS4 :'
                 WRITE(KNTN,*)'ERROR PACKING LOCAL REFERENCE VALUE'
                 CALL BUERR(KERR)
                 RETURN
              END IF
C
C             PACK NUMBER OF BITS FOR INCREMENTS/NUMBER OF CHARACTERS
C
              CALL BUPCK(NBPW,KBUFF(NWPT),INCHAR,NWPT,NBPT,6,KERR)
              IF(KERR.GT.0) THEN
                 WRITE(KNTN,*)'BUENS4 :'
                 WRITE(KNTN,*)'ERROR PACKING NUMBER OF BITS
     1                         FOR INCREMENTS'
                 CALL BUERR(KERR)
                 RETURN
              END IF
C
C             PACK INCREMENTS
C
              DO J=1,KSEC3(3)
C
              JI=I+(J-1)*KELEM
C
              IF(NWTDW(I).EQ.32) THEN
                 VAL4=RVALS4(JI)
                 CALL BUGBYTESR4(VAL4,IIVALS,0,8,0,INCHAR)
              ELSE
                 VAL=RVALS(JI)
                 CALL BUGBYTESR8(VAL,IIVALS,0,8,0,INCHAR)
              END IF
C
              DO IZ=1,INCHAR
               IPACK=IIVALS(IZ)
               CALL BUPCK(NBPW,KBUFF(NWPT),IPACK,NWPT,NBPT,8,KERR)
              END DO
C
              END DO

            ELSE

              IBYTES=NWTDW(I)/8
              IF(IBYTES.EQ.4) THEN
                 VAL4=RVALS4(I)
                 OBIG=BIG_ENDIAN()
                 IF(.NOT.OBIG) THEN
                    CALL SWAP_BYTES4(VAL4,VAL4S)
                    VAL4=VAL4S
                 END IF
                 CALL BUGBYTESR4(VAL4,ILOCVAL,0,8,0,IBYTES)
              ELSE
                 VAL=RVALS(I)
                 OBIG=BIG_ENDIAN()
                 IF(.NOT.OBIG) THEN
                    CALL SWAP_BYTES8(VAL,VAL8S)
                    VAL=VAL8S
                 END IF
                 CALL BUGBYTESR8(VAL,ILOCVAL,0,8,0,IBYTES)
              END IF
              ISKIP=0
              CALL BUPKS(NBPW,KBUFF(NWPT),ILOCVAL,NWPT,NBPT,8,
     1                  ISKIP,IBYTES,KERR)
              IF(KERR.GT.0) THEN
                 WRITE(KNTN,*)'BUENS4 :'
                 WRITE(KNTN,*)'ERROR PACKING REAL IEEE'
                 CALL BUERR(KERR)
                 RETURN
              END IF
C
              CALL BUPCK(NBPW,KBUFF(NWPT),0,NWPT,NBPT,6,KERR)
              IF(KERR.GT.0) THEN
                 WRITE(KNTN,*)'BUENS4 :'
                 WRITE(KNTN,*)'ERROR PACKING NUMBER OF BITS FOR'
                 WRITE(KNTN,*)'INCREMENTS FOR ',I,' ELEMENT.'
                 RETURN
              END IF

            END IF
C
 4211       CONTINUE
C
         ELSE
             IF(OMIS) THEN
C
C               PACK LOCAL REFERENCE VALUE FOR ELEMENT SET TO MISSING VALUE.
C
                CALL BUPCK(NBPW,KBUFF(NWPT),NMASK(IBDW),NWPT,NBPT,
     1                     IBDW,KERR)
                IF(KERR.GT.0) THEN
                   WRITE(KNTN,*)'BUENS4 :'
                   WRITE(KNTN,*)'ERROR PACKING LOCAL REFERENCE VALUE '
                   WRITE(KNTN,*)I,' ELEMENT.'
                   RETURN
                END IF
C
C               PACK NUMBER OF BITS FOR INCREMENTS (SET TO ZERO)
C
                CALL BUPCK(NBPW,KBUFF(NWPT),0,NWPT,NBPT,6,KERR)
                IF(KERR.GT.0) THEN
                   WRITE(KNTN,*)'BUENS4 :'
                   WRITE(KNTN,*)'ERROR PACKING NUMBER OF BITS FOR'
                   WRITE(KNTN,*)'INCREMENTS FOR ',I,' ELEMENT.'
                   RETURN
                END IF
C
             ELSE
C
                IF(INCBIT.EQ.0) THEN
C
C
C                  PACK LOCAL REFERENCE VALUE FOR ELEMENT
C
                 IF(NWTEN(I).EQ.836970) THEN
                  IF(ISG_REF.EQ.1) THEN
                    CALL BUPCK(NBPW,KBUFF(NWPT),1,NWPT,NBPT,1,KERR)
                    CALL BUPCK(NBPW,KBUFF(NWPT),MIN,NWPT,NBPT,IBDW-1,
     1                         KERR)
                  ELSE
                    CALL BUPCK(NBPW,KBUFF(NWPT),MIN,NWPT,NBPT,IBDW,
     1                         KERR)
                    IF(KERR.GT.0) THEN
                      WRITE(KNTN,*)'BUENS4 :'
                      WRITE(KNTN,*)'ERROR PACKING LOCAL REFERENCE VALUE'
                      WRITE(KNTN,*)'FOR ',I,' ELEMENT IN ',IBDW,' BITS.'
                      RETURN
                    END IF
                  END IF
                 ELSE
                   CALL BUPCK(NBPW,KBUFF(NWPT),MIN,NWPT,NBPT,IBDW,KERR)
                   IF(KERR.GT.0) THEN
                      WRITE(KNTN,*)'BUENS4 :'
                      WRITE(KNTN,*)'ERROR PACKING LOCAL REFERENCE VALUE'
                      WRITE(KNTN,*)'FOR ',I,' ELEMENT IN ',IBDW,' BITS.'
                      RETURN
                   END IF
                 ENDIF
C
C                  PACK NUMBER OF BITS FOR INCREMENTS
C
                   CALL BUPCK(NBPW,KBUFF(NWPT),INCBIT,NWPT,NBPT,6,KERR)
                   IF(KERR.GT.0) THEN
                      WRITE(KNTN,*)'BUENS4 :'
                      WRITE(KNTN,*)'ERROR PACKING NUMBER OF BITS FOR'
                      WRITE(KNTN,*)'INCREMENTS FOR ',I,' ELEMENT.'
                      RETURN
                   END IF
C
                ELSE
C
C                  PACK LOCAL REFERENCE VALUE FOR ELEMENT
C
                   IF(NWTEN(I).EQ.836970) THEN
                      IF(ISG_REF.EQ.1) THEN
                         CALL BUPCK(NBPW,KBUFF(NWPT),1,NWPT,NBPT,1,KERR)
                         CALL BUPCK(NBPW,KBUFF(NWPT),MIN,NWPT,NBPT,
     1                              IBDW-1,KERR)
                      ELSE
                         CALL BUPCK(NBPW,KBUFF(NWPT),MIN,NWPT,NBPT,IBDW,
     1                              KERR)
                         IF(KERR.GT.0) THEN
                            WRITE(KNTN,*)'BUENS4 :'
                      WRITE(KNTN,*)'ERROR PACKING LOCAL REFERENCE VALUE'
                      WRITE(KNTN,*)'FOR ',I,' ELEMENT IN ',IBDW,' BITS.'
                            RETURN
                         END IF
                      END IF
                   ELSE
                     CALL BUPCK(NBPW,KBUFF(NWPT),MIN,NWPT,NBPT,IBDW,
     1                          KERR)
                      IF(KERR.GT.0) THEN
                         WRITE(KNTN,*)'BUENS4 :'
                      WRITE(KNTN,*)'ERROR PACKING LOCAL REFERENCE VALUE'
                      WRITE(KNTN,*)'FOR ',I,' ELEMENT IN ',IBDW,' BITS.'
                         RETURN
                      END IF
                   ENDIF

C
C                  PACK NUMBER OF BITS FOR INCREMENTS
C
                   CALL BUPCK(NBPW,KBUFF(NWPT),INCBIT,NWPT,NBPT,6,KERR)
                   IF(KERR.GT.0) THEN
                      WRITE(KNTN,*)'BUENS4 :'
                      WRITE(KNTN,*)'ERROR PACKING NUMBER OF BITS FOR'
                      WRITE(KNTN,*)  'INCREMENTS FOR ',I,' ELEMENT.'
                      RETURN
                   END IF
C
C                  PACK INCREMENTS
C
                   CALL BUPKS(NBPW,KBUFF(NWPT),INC,NWPT,NBPT,
     1                        INCBIT,0,KSEC3(3),KERR)
                   IF(KERR.GT.0) THEN
                      WRITE(KNTN,*)  'BUENS4 :'
                      WRITE(KNTN,*)  'ERROR PACKING INCREMENTS FOR',I,
     1                ' ELEMENT'
                      RETURN
                   END IF
C
                END IF
             END IF
          END IF
C
 411     CONTINUE
C
      END IF
C
C*          5.  SET UP LENGTH OF THE SECTION 4.
C               --------------------------------
 500  CONTINUE
C
      IF(OMULTI) THEN
         IF(NSUBSET.EQ.KSEC3(3)) THEN
            CALL BUOCTN(IWPTB,IBPTB,KBUFL,KBUFF,KERR)
            IF(KERR.GT.0) THEN
               CALL BUERR(KERR)
               RETURN
            END IF
         END IF
      ELSE
         CALL BUOCTN(IWPTB,IBPTB,KBUFL,KBUFF,KERR)
         IF(KERR.GT.0) THEN
            CALL BUERR(KERR)
            RETURN
         END IF
      END IF
C
C     ------------------------------------------------------------------
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities
C granted to it by virtue of its status as an intergovernmental organisation
C nor does it submit to any jurisdiction.
C

        subroutine bufrin(kunit,karray,kinlen,koutlen,keof,kret)
C---->
C
C       This subroutine mimics the behaviour of the original BUFRIN
C       but makes a call to PBBUFR to retrieve BUFR products.
C
C----<
        integer icalls
        data icalls/0/
C
C First time through, print a warning message
        if (icalls .eq. 0) then
          icalls = icalls + 1
          write(*,*) ' *********************************************'
          write(*,*) ' *********************************************'
          write(*,*) ' You are using an obsolete subroutine (BUFRIN)'
          write(*,*) ' for retrieving BUFR products.'
          write(*,*) ' Please change to using PBBUFR.'
          write(*,*) ' *********************************************'
          write(*,*) ' *********************************************'
        endif
C
        call pbbufr(kunit,karray,kinlen,koutlen,kret)
        if ( kret .eq. -3) then
          write(*,*) ' Buffer not big enough for BUFR product'
          kret = -5
        endif
C
        return
        end

C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      INTEGER FUNCTION HNEI12
     X  (L12PNT,KLEN,RLAT,RLON,KGAUSS,KPTS,PLATIN,
     X   KSCHEME,PDLAT,PDLO0,PDLO1,PDLO2,PDLO3,KLA,NEIGH)
C
C---->
C**** HNEI12
C
C     Purpose
C     -------
C
C     This routine accepts a vector of points and finds the 12
C     neighbours for each point suitable for horizontal interpolation.
C
C
C     Interface
C     ---------
C
C     IRET = HNEI12(L12PNT,KLEN,RLAT,RLON,KGAUSS,KPTS,PLATIN,
C    X              KSCHEME,PDLAT,PDLO0,PDLO1,PDLO2,PDLO3,KLA,NEIGH)
C
C
C     Input parameters
C     ----------------
C
C     L12PNT - Chooses between 12-point and 4-point interpolation
C              = .TRUE. for 12-point horizontal
C              = .FALSE. for 4-point
C     KLEN   - Number of points along the vector
C     RLAT   - List of latitudes for points.
C     RLON   - List of longitudes for points.
C     KGAUSS - Original gaussian field number.
C     KPTS   - List giving number of points in each latitude in original
C              gaussian field.
C     PLATIN - Original gaussian field latitudes (north and south).
C
C
C     Output parameters
C     -----------------
C
C     KSCHEME - Flag showing interpolation scheme to use for point
C               0 = 12-point
C               1 = 4-point bilinear
C               2 = nearest neighbour
C     PDLAT   - Meridian linear weight.
C     PDLO0   - Zonal linear weight for the latitude of point 5.
C     PDLO1   - Zonal linear weight for the latitude of point 1.
C     PDLO2   - Zonal linear weight for the latitude of point 3.
C     PDLO3   - Zonal linear weight for the latitude of point 11.
C     KLA     - Latitude number in original field of latitude north of
C               each point in the vector.
C     NEIGH   - List of indices in the original field of neighbouring
C               point values for each point in the vector.
C
C     Returns 0 if function successful, non-zero otherwise.
C
C     Common block usage
C     ------------------
C
C     None.
C
C
C     Method
C     ------
C
C     Numbering of the points (I is the interpolation point):
C
C                   13       5       6      14
C
C                    7       1       2       8
C                               (I)
C                    9       3       4      10
C
C                   15      11      12      16
C
C     The 12-point interpolation is not possible if either of the top
C     two rows is above the original field northern latitude. The
C     nearest neighbour is used if both rows are above, and a 4-pt
C     bilinear interpolation is used if the top row is above.
C     Similarily, if either of the bottom two rows is below the original
C     field southern latitude.
C
C
C     Externals
C     ---------
C
C     INTLOG  - Log error message.
C     JNORSGG - Finds gaussian latitude north or south of given latitude
C     JDEBUG  - Tests if debug output required.
C     JMALLOC - Dynamically allocate memory
C     JFREE   - Free dynamically allocated memory
C
C
C     Reference
C     ---------
C
C     ECMWF Meteorological Bulletin M1.6/7
C     IFS Documentation
C     Part VI: Technical and Computational Procedures (CY21R4)
C     March 2000
C     Section 2.3
C
C
C     Comments
C     --------
C
C     None.
C
C
C     Author
C     ------
C
C     J.D.Chambers      ECMWF      January 2001
C
C
C     Modifications
C     -------------
C
C     None.
C
C----<
C     -----------------------------------------------------------------|
C*    Section 0. Definition of variables.
C     -----------------------------------------------------------------|
C
      IMPLICIT NONE
#include "parim.h"
C
C     Parameters
C
      INTEGER JP12PT, JP4PT, JPNEARN
      PARAMETER (JP12PT  = 0)
      PARAMETER (JP4PT   = 1)
      PARAMETER (JPNEARN = 2)
C
C     Function arguments
C
      LOGICAL L12PNT
      INTEGER KLEN, KGAUSS, KPTS(KGAUSS*2)
      REAL RLAT(KLEN), RLON(KLEN), PLATIN(KGAUSS*2)
C
      INTEGER KLA(KLEN), KSCHEME(KLEN)
      REAL PDLAT(KLEN),PDLO0(KLEN),PDLO1(KLEN),PDLO2(KLEN),PDLO3(KLEN)
      INTEGER NEIGH(12,*)
C
C     Local variables
C
      INTEGER NEXT, LOOP, NBYTES
      INTEGER NLAT0, NLAT1, NLAT2, NLAT3, NLAT(12), NLONG(12)
      REAL STEP0, STEP1, STEP2, STEP3
      INTEGER NPREV, ISIZE, ISIZOLD, IOFFSET(1)
      POINTER( IPOFF, IOFFSET )
C
      DATA ISIZOLD/-1/, NPREV/-1/
      SAVE ISIZOLD,IPOFF,NPREV
C
C     Externals
C
      INTEGER JNORSGG
#ifdef POINTER_64
      INTEGER*8 JMALLOC
#else
      INTEGER JMALLOC
#endif
C
C     -----------------------------------------------------------------|
C     Section 1.  Initialise.
C     -----------------------------------------------------------------|
C
  100 CONTINUE
C
      HNEI12 = 0
C
      CALL JDEBUG()
C
C     Get memory for offset array.
C
      ISIZE = KGAUSS*2 + 1
      IF( ISIZE.GT.ISIZOLD ) THEN
C
        IF( ISIZOLD.GT.0 ) CALL JFREE(IPOFF)
C
        NBYTES = ISIZE * JPBYTES
        IPOFF = JMALLOC(NBYTES)
#ifdef hpR64
        IPOFF = IPOFF/(1024*1024*1024*4)
#endif
        IF( IPOFF.EQ.0 ) THEN
          CALL INTLOG(JP_WARN,'HNEI12: Memory allocate fail ',JPQUIET)
          HNEI12 = 1
          GOTO 900
        ENDIF
C
        ISIZOLD = ISIZE
        NPREV = -1
C
      ENDIF
C
C     Build up offsets to start of each latitude in the original field.
C
      IF( KGAUSS.NE.NPREV ) THEN
        IOFFSET(1) = 1
        DO LOOP = 2, (KGAUSS*2+1)
          IOFFSET(LOOP) = IOFFSET(LOOP-1) + KPTS(LOOP-1)
        ENDDO
        NPREV = KGAUSS
      ENDIF
C
C     -----------------------------------------------------------------|
C       Section 2.  Loop through points along the vector.
C     -----------------------------------------------------------------|
C
  200 CONTINUE
C
      DO NEXT = 1,KLEN
C
C       Clear current neighbour indices
C
        DO LOOP = 1, 12
          NEIGH(LOOP,NEXT) = 0
        ENDDO
C
C       Find latitude numbers for neighbours.
C
C       First find latitude numbers to north and south of the point
C
C     -----------------------------------------------------------------|
C       Section 3. Nearest neighbour to be used.
C     -----------------------------------------------------------------|
C
  300   CONTINUE
C
        IF( RLAT(NEXT).GT.PLATIN(1) ) THEN
          CALL INTLOG(JP_DEBUG,
     X      'HNEI12: Nearest neighbour to south used for point ',NEXT)
C
C         Above northern latitude of original field, so use nearest
C         neighbour (point 3 or 4)
C
          STEP2 = 360.0 / REAL(KPTS(1))
          NLONG( 3) = 1 + INT(RLON(NEXT)/STEP2)
          IF( NLONG( 3).GT.KPTS(1) ) NLONG( 3) = 1
          NLONG( 4) = NLONG(3) + 1
          IF( NLONG( 4).GT.KPTS(1) ) NLONG( 4) = 1
C
          IF( ABS((RLON(NEXT) - REAL(NLONG(3)-1)*STEP2 )) .LE.
     X        ABS((RLON(NEXT) - REAL(NLONG(4)-1)*STEP2 )) ) THEN
            NEIGH(3,NEXT) = NLONG(3)
          ELSE
            NEIGH(4,NEXT) = NLONG(4)
          ENDIF
          KSCHEME(NEXT) = JPNEARN
          GOTO 600
        ENDIF
C
        IF( RLAT(NEXT).LT.PLATIN(KGAUSS*2) ) THEN
          CALL INTLOG(JP_DEBUG,
     X      'HNEI12: Nearest neighbour to north used for point ',NEXT)
C
C         Below southern latitude of original field, so use nearest
C         neighbour (point 1 or 2)
C
          STEP1 = 360.0 / REAL(KPTS(KGAUSS*2))
          NLONG( 1) = 1 + INT(RLON(NEXT)/STEP1)
          IF( NLONG( 1).GT.KPTS(KGAUSS*2) ) NLONG( 1) = 1
          NLONG( 2) = NLONG(1) + 1
          IF( NLONG( 2).GT.KPTS(KGAUSS*2) ) NLONG( 2) = 1
C
          IF( ABS((RLON(NEXT) - REAL(NLONG(1)-1)*STEP1 )) .LE.
     X        ABS((RLON(NEXT) - REAL(NLONG(2)-1)*STEP1 )) ) THEN
            NEIGH(1,NEXT) = IOFFSET(KGAUSS*2) + NLONG(1) - 1
          ELSE
            NEIGH(2,NEXT) = IOFFSET(KGAUSS*2) + NLONG(2) - 1
          ENDIF
          KSCHEME(NEXT) = JPNEARN
          GOTO 600
        ENDIF
C
        NLAT1 = JNORSGG(RLAT(NEXT),PLATIN,KGAUSS,1)
        NLAT2 = JNORSGG(RLAT(NEXT),PLATIN,KGAUSS,0)
C
        IF( NLAT2.EQ.NLAT1) NLAT2 = NLAT1 + 1
C
C       Find outer latitude numbers to north and south of the point
C
        NLAT0 = NLAT1 - 1
        NLAT3 = NLAT2 + 1
C
C     -----------------------------------------------------------------|
C       Section 4. 4-point bilinear to be used.
C     -----------------------------------------------------------------|
C
  400   CONTINUE
C
        IF( (NLAT0.EQ.0).OR.(NLAT3.GT.KGAUSS*2).OR.(.NOT.L12PNT) ) THEN
Cjdc      CALL INTLOG(JP_DEBUG,
Cjdc X      'HNEI12: 4-pt bilinear interpolation used for point ',NEXT)
C
C         Between two northern latitudes or two southern latitudes of
C         original field, so use 4-point bilinear interpolation
C         (points 1, 2, 3 and 4)
C
C         Points 1 and 2
C
          STEP1 = 360.0 / REAL(KPTS(NLAT1))
          NLONG(1) = 1 + INT(RLON(NEXT)/STEP1)
          IF( NLONG(1).GT.KPTS(NLAT1) ) NLONG(1) = 1
          NLONG(2) = NLONG(1) + 1
          IF( NLONG(2).GT.KPTS(NLAT1) ) NLONG(2) = 1
C
          NEIGH(1,NEXT) = IOFFSET(NLAT1) + NLONG(1) - 1
          NEIGH(2,NEXT) = IOFFSET(NLAT1) + NLONG(2) - 1
C
C         Points 3 and 4
C
          STEP2 = 360.0 / REAL(KPTS(NLAT2))
          NLONG( 3) = 1 + INT(RLON(NEXT)/STEP2)
          IF( NLONG( 3).GT.KPTS(NLAT2) ) NLONG( 3) = 1
          NLONG( 4) = NLONG(3) + 1
          IF( NLONG( 4).GT.KPTS(NLAT2) ) NLONG( 4) = 1
C
          NEIGH(3,NEXT) = IOFFSET(NLAT2) + NLONG(3) - 1
          NEIGH(4,NEXT) = IOFFSET(NLAT2) + NLONG(4) - 1
C
C         Calculate zonal linear weights for the latitudes.
C
          PDLO1(NEXT) = ( RLON(NEXT) - REAL(NLONG(1)-1)*STEP1 ) / STEP1
          PDLO2(NEXT) = ( RLON(NEXT) - REAL(NLONG(3)-1)*STEP2 ) / STEP2
C
          KLA(NEXT) = NLAT1
          PDLAT(NEXT) = ( RLAT(NEXT) - PLATIN(NLAT1) ) /
     X                  ( PLATIN(NLAT2) - PLATIN(NLAT1) )
C
          KSCHEME(NEXT) = JP4PT
          GOTO 600
        ENDIF
C
C     -----------------------------------------------------------------|
C       Section 5. 12-point interpolation to be used.
C     -----------------------------------------------------------------|
C
  500   CONTINUE
C
        KSCHEME(NEXT) = JP12PT
C
        KLA(NEXT) = NLAT1
        PDLAT(NEXT) = ( RLAT(NEXT) - PLATIN(NLAT1) ) /
     X                ( PLATIN(NLAT2) - PLATIN(NLAT1) )
C
C       Northernmost
C
        NLAT(5) = NLAT0
        NLAT(6) = NLAT0
C
C       Northern
C
        NLAT(7) = NLAT1
        NLAT(1) = NLAT1
        NLAT(2) = NLAT1
        NLAT(8) = NLAT1
C
C       Southern
C
        NLAT( 9) = NLAT2
        NLAT( 3) = NLAT2
        NLAT( 4) = NLAT2
        NLAT(10) = NLAT2
C
C       Southernmost
C
        NLAT(11) = NLAT3
        NLAT(12) = NLAT3
C
C     -----------------------------------------------------------------|
C       Find longitude numbers for neighbours.
C     -----------------------------------------------------------------|
C
C       Northernmost
C
        STEP0 = 360.0 / REAL(KPTS(NLAT0))
        NLONG(5) = 1 + INT(RLON(NEXT)/STEP0)
        IF( NLONG(5).GT.KPTS(NLAT0) ) NLONG(5) = 1
        NLONG(6) = NLONG(5) + 1
        IF( NLONG(6).GT.KPTS(NLAT0) ) NLONG(6) = 1
C
C       Northern
C
        STEP1 = 360.0 / REAL(KPTS(NLAT1))
        NLONG(1) = 1 + INT(RLON(NEXT)/STEP1)
        IF( NLONG(1).GT.KPTS(NLAT1) ) NLONG(1) = 1
        NLONG(7) = NLONG(1) - 1
        IF( NLONG(7).LT.1 ) NLONG(7) = KPTS(NLAT1)
        NLONG(2) = NLONG(1) + 1
        IF( NLONG(2).GT.KPTS(NLAT1) ) NLONG(2) = 1
        NLONG(8) = NLONG(2) + 1
        IF( NLONG(8).GT.KPTS(NLAT1) ) NLONG(8) = 1
C
C       Southern
C
        STEP2 = 360.0 / REAL(KPTS(NLAT2))
        NLONG( 3) = 1 + INT(RLON(NEXT)/STEP2)
        IF( NLONG( 3).GT.KPTS(NLAT2) ) NLONG( 3) = 1
        NLONG( 9) = NLONG(3) - 1
        IF( NLONG( 9).LT.1 ) NLONG( 9) = KPTS(NLAT2)
        NLONG( 4) = NLONG(3) + 1
        IF( NLONG( 4).GT.KPTS(NLAT2) ) NLONG( 4) = 1
        NLONG(10) = NLONG(4) + 1
        IF( NLONG(10).GT.KPTS(NLAT2) ) NLONG(10) = 1
C
C       Southernmost
C
        STEP3 = 360.0 / REAL(KPTS(NLAT3))
        NLONG(11) = 1 + INT(RLON(NEXT)/STEP3)
        IF( NLONG(11).GT.KPTS(NLAT3) ) NLONG(11) = 1
        NLONG(12) = NLONG(11) + 1
        IF( NLONG(12).GT.KPTS(NLAT3) ) NLONG(12) = 1
C
C     -----------------------------------------------------------------|
C       Calculate zonal linear weights for the latitudes.
C     -----------------------------------------------------------------|
C
        PDLO0(NEXT) = ( RLON(NEXT) - REAL(NLONG(5)-1)*STEP0 ) / STEP0
C
        PDLO1(NEXT) = ( RLON(NEXT) - REAL(NLONG(1)-1)*STEP1 ) / STEP1
C
        PDLO2(NEXT) = ( RLON(NEXT) - REAL(NLONG(3)-1)*STEP2 ) / STEP2
C
        PDLO3(NEXT) = ( RLON(NEXT) - REAL(NLONG(11)-1)*STEP3 ) / STEP3
C
C     -----------------------------------------------------------------|
C       Store indices of the neighbours.
C     -----------------------------------------------------------------|
C
        DO LOOP = 1, 12
          NEIGH(LOOP,NEXT) = IOFFSET(NLAT(LOOP)) + NLONG(LOOP) - 1
        ENDDO
C
C     -----------------------------------------------------------------|
C     Section 6.  End of loop along vector of points.
C     -----------------------------------------------------------------|
C
  600   CONTINUE
C
      ENDDO
C
C     -----------------------------------------------------------------|
C     Section 9.  Return
C     -----------------------------------------------------------------|
C
  900 CONTINUE
C
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      INTEGER FUNCTION IGPOLEW(PIFELD, KIWE, POFELD, KOWE, KWEIND,
     1   KWEDIST, KPR, KERR)
C
C---->
C**** *IGPOLEW*
C
C     Purpose
C     -------
C
C     Calculates the values at the pole of a regular
C     latitude/longitude wind field when the input is a Gaussian field.
C
C     This routine is only used for a wind field.
C
C     Interface
C     ---------
C
C     IERR = IGPOLEW(PIFELD, KIWE, POFELD, KOWE, KWEIND, KWEDIST,
C    1   KPR, KERR)
C
C     Input parameters
C     ----------------
C
C     PIFELD     - A "polar" row of the input field provided by the
C                  calling routine.
C
C     KIWE       - The number of points in the West-East direction in
C                  the input field.
C
C     KOWE       - The number of points in the West-East direction in
C                  the output field.
C
C     KWEIND     - This array contains the array offsets of the West
C                  and East points in the input array required for
C                  interpolation.
C
C     KWEDIST    - This array holds the distances to longitude values
C                  in the input field from the associated longitude
C                  values in the output field.
C
C     KPR        - The debug print switch.
C                  0  , No debugging output.
C                  1  , Produce debugging output.
C
C     KERR       - The error control flag.
C                  -ve, No error message. Return error code.
C                  0  , Hard failure with error message.
C                  +ve, Print error message. Return error code.
C
C     Output parameters
C     -----------------
C
C     POFELD     - The corresponding "polar" row of the output field
C                  returned to the calling routine.
C
C     Return value
C     ------------
C
C     The error indicator (INTEGER).
C
C     Error and Warning Return Values
C
C     None
C
C     Common block usage
C     ------------------
C
C     None
C
C     Externals
C     ---------
C
C     INTLOG(R)    - Logs messages.
C
C     Method
C     ------
C
C     A Gaussian field does not have a line of latitude at the pole
C     so this routine performs a linear interpolation of points on the
C     nearest Gaussian line and then puts these values into the output
C     array. The intention is to provide U and V values at the pole
C     which have a "directional" value.
C
C     This method was originally implemented by
C
C     K. RIDER            * ECMWF *     OCTOBER 1991.
C
C     Reference
C     ---------
C
C     None
C
C     Comments
C     --------
C
C     Program contains sections 0 to 2 and 9
C
C     Author
C     ------
C
C     K. Fielding      *ECMWF*      Oct 1993
C
C     Modifications
C     -------------
C
C     Allow for missing data values
C     J.D.Chambers      ECMWF       August 2000
C
C----<
C     -----------------------------------------------------------------|
C*    Section 0. Definition of variables.
C     -----------------------------------------------------------------|
C
      IMPLICIT NONE
C
#include "parim.h"
#include "nifld.common"
C
C     Function arguments
C
      INTEGER KIWE, KOWE, KPR, KERR
      INTEGER KWEIND(2, KOWE), KWEDIST(2, KOWE)
      REAL PIFELD(KIWE), POFELD(KOWE)
C
C     Local variables
C
      INTEGER JOLON, COUNT
      REAL ZLOW, ZHIGH
C
C     Statement function
C
      REAL A, B
      LOGICAL NOTEQ
      NOTEQ(A,B) = (ABS((A)-(B)).GT.(ABS(A)*1E-3))
C
C     -----------------------------------------------------------------|
C*    Section 1. Initialisation
C     -----------------------------------------------------------------|
C
  100 CONTINUE
C
      IF( KPR.GE.1 ) CALL INTLOG(JP_DEBUG,'IGPOLEW: Section 1.',JPQUIET)
C
      IGPOLEW = 0
C
      IF( KPR.GE.1 ) THEN
        CALL INTLOG(JP_DEBUG,'IGPOLEW: No.input fld longs = ',KIWE)
        CALL INTLOG(JP_DEBUG,'IGPOLEW: No.output fld longs = ',KOWE)
      ENDIF
C
C     -----------------------------------------------------------------|
C*    Section 2. Interpolation code for winds
C     -----------------------------------------------------------------|
C
  200 CONTINUE
C
      IF( KPR.GE.1 ) CALL INTLOG(JP_DEBUG,'IGPOLEW: Section 2.',JPQUIET)
C
      DO JOLON = 1, KOWE
C
C       Compute weigths for west and east neighbours
C
        ZLOW = REAL(KWEDIST(JP_I_E,JOLON)) /
     X      REAL(KWEDIST(JP_I_E,JOLON) + KWEDIST(JP_I_W,JOLON) )
C
        ZHIGH = PPONE - ZLOW
C
C       Count non-missing data values
C
        IF( LIMISSV ) THEN
          COUNT = 0
          IF( NOTEQ(PIFELD(KWEIND(JP_I_W,JOLON)),RMISSGV) )
     X      COUNT = COUNT + 1
          IF( NOTEQ(PIFELD(KWEIND(JP_I_E,JOLON)),RMISSGV) )
     X      COUNT = COUNT + 1
        ELSE
          COUNT = 2
        ENDIF
C
C       Interpolate using both neighbours if neither is missing
C
        IF( COUNT.EQ.2 ) THEN
          POFELD(JOLON) = ZLOW  * PIFELD(KWEIND(JP_I_W,JOLON)) +
     X                    ZHIGH * PIFELD(KWEIND(JP_I_E,JOLON))
C
C       Set missing if all neighbours are missing
C
        ELSE IF( COUNT.EQ.0 ) THEN
          POFELD(JOLON) = RMISSGV
C
C       Otherwise, use the nearest neighbour
C
        ELSE IF( ZLOW.GT.ZHIGH ) THEN
          POFELD(JOLON) = PIFELD(KWEIND(JP_I_W,JOLON))
        ELSE
          POFELD(JOLON) = PIFELD(KWEIND(JP_I_E,JOLON))
        ENDIF
C
      ENDDO
C
C     -----------------------------------------------------------------|
C*    Section 9. Return to calling routine. Format statements
C     -----------------------------------------------------------------|
C
  900 CONTINUE
C
      IF( KPR.GE.1 ) CALL INTLOG(JP_DEBUG,'IGPOLEW: Section 9.',JPQUIET)
C
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities
C granted to it by virtue of its status as an intergovernmental organisation
C nor does it submit to any jurisdiction.
C

      INTEGER FUNCTION NGROTAT(OLDFLD, NEWFLD, NUMPTS, POLELAT, POLELON,
     X                         HTYPE, NGAUSS)
C
C---->
C**** NGROTAT
C
C     PURPOSE
C     _______
C
C     Generates a rotated gaussian grid.
C
C     INTERFACE
C     _________
C
C     IRET = NGROTAT(OLDFLD,NEWFLD,NUMPTS,POLELAT,POLELON,HTYPE,NGAUSS)
C
C
C     Input parameters
C     ________________
C
C     OLDFLD  - Original gaussian grid field.
C     NUMPTS  - Total number of points in the original field.
C     POLELAT - Latitude of the South Pole of rotation.
C     POLELON - Longitude of the South Pole of rotation.
C     NGAUSS  - Gaussian grid number
C     HTYPE   - Gaussian grid type
C               = 'R' for reduced ("quasi-regular"),
C               = 'O' for reduced/octahedral,
C               = 'F' for full,
C               = 'U' for user-defined reduced gaussian grid
C
C     Output parameters
C     ________________
C
C     NEWFLD  = New gaussian grid field.
C               (This can be the same array as OLDFLD).
C
C     Function returns zero if interpolation ran OK.
C
C
C     METHOD
C     ______
C
C     The nearest gaussian latitude row is found.
C
C     Work space is dynamically allocated. It is retained for future
C     calls.
C
C     EXTERNALS
C     _________
C
C     IGGLAT  - Compute Gaussian latitudes for a given truncation.
C     NGVALUE - Calculates the interpolated value at a point of the new
C               gaussian grid.
C     INTLOG  - Logs output messages
C     INTLOGR - Logs output messages
C     JMEMHAN - Dynamically allocate work array
C
C
C     REFERENCE
C     _________
C
C     None
C
C
C     COMMENTS
C     ________
C
C     The input field is assumed to be global in extent, and a known
C     definition, either N160 or N80 (reduced or regular).
C     The output field has the same type and dimensions as the input
C     field.
C
C
C     AUTHOR
C     ______
C
C     J.D.Chambers      ECMWF       April 1996
C
C
C     MODIFICATIONS
C     _____________
C
C     None.
C
C
C----<
C     _______________________________________________________
C
C*    Section 0. Definition of variables.
C     _______________________________________________________
C
      IMPLICIT NONE
C
#include "parim.h"
#include "intf.h"
C
C     Parameters
C
      INTEGER JPROUTINE, JPMAXGG
      PARAMETER( JPROUTINE = 38500 )
      PARAMETER (JPMAXGG = 1280)
C
C     Subroutine arguments
C
      REAL OLDFLD, NEWFLD, POLELAT, POLELON
      INTEGER NUMPTS, NGAUSS
      DIMENSION OLDFLD(NUMPTS), NEWFLD(NUMPTS)
      CHARACTER*1 HTYPE
C
C     Local variables
C
      REAL GLATS(JPMAXGG)
      INTEGER NGPTS(JPMAXGG)
      INTEGER OLDGAUS
      DATA OLDGAUS/0/
      CHARACTER*1 OLDTYPE
      DATA OLDTYPE/' '/
      SAVE GLATS, NGPTS, OLDGAUS, OLDTYPE
C
      INTEGER NEXT, NEXLAT, INROW, LOOP, KRET
      REAL STEPLON, RLAT, RLON
      DIMENSION RLON(JPMAXGG*2)
C
      INTEGER ISIZE
      DATA ISIZE/0/
      REAL DUMI
      POINTER (IDUMI, DUMI)
      DIMENSION DUMI(1)
      SAVE IDUMI, ISIZE
C
C     Externals
C
      INTEGER IGGLAT
C
C     _______________________________________________________
C
C*    Section 1. Initialization.
C     _______________________________________________________
C
  100 CONTINUE
C
      NGROTAT = 0
C
      CALL INTLOG(JP_DEBUG,
     X  'NGROTAT: Number of pts in original field = ',NUMPTS)
      CALL INTLOGR(JP_DEBUG,
     X  'NGROTAT: Latitude of the South Pole of rotation = ',POLELAT)
      CALL INTLOGR(JP_DEBUG,
     X  'NGROTAT: Longitude of the South Pole of rotation = ',POLELON)
      CALL INTLOG(JP_DEBUG,'NGROTAT: Get gaussian grid type:',JPQUIET)
      CALL INTLOG(JP_DEBUG,HTYPE,JPQUIET)
      CALL INTLOG(JP_DEBUG,'NGROTAT: grid number:',NGAUSS)
C
C     Get gaussian grid definition (first time only)
C
      IF( (OLDGAUS.NE.NGAUSS).OR.(OLDTYPE.NE.HTYPE)) THEN
        CALL INTLOG(JP_DEBUG,
     X    'NGROTAT: Get definitions for gaussian grid type:',JPQUIET)
        CALL INTLOG(JP_DEBUG,HTYPE,JPQUIET)
        CALL INTLOG(JP_DEBUG,'NGROTAT: grid number:',NGAUSS)
C
        KRET = IGGLAT(NGAUSS*2, GLATS, 0, 1)
        IF( KRET.NE.0 ) THEN
          CALL INTLOG(JP_ERROR, 'NGROTAT: IGGLAT call failed',KRET)
          NGROTAT = JPROUTINE + 2
          GOTO 900
        ENDIF
        DO LOOP = 1, NGAUSS
          NGPTS(LOOP) = ISEC2(22+LOOP)
          NGPTS(2*NGAUSS+1-LOOP) = NGPTS(LOOP)
        ENDDO
        OLDGAUS = NGAUSS
        OLDTYPE = HTYPE
      ENDIF
C
C     Allocate work space if not already done.
C
      IF( ISIZE.LT.NUMPTS ) THEN
        ISIZE = NUMPTS
        CALL JMEMHAN(18,IDUMI,ISIZE,1,KRET)
        IF( KRET.NE.0 ) THEN
          CALL INTLOG(JP_ERROR,
     X      'NGROTAT: Memory allocation failed: status = ',KRET)
          NGROTAT = JPROUTINE + 2
          GOTO 900
        ENDIF
      ENDIF
C
C     Move the original field to the work array
C
      DO LOOP = 1, NUMPTS
        DUMI(LOOP) = OLDFLD(LOOP)
      ENDDO
C     _______________________________________________________
C
C*    Section 2. Work through latitude lines from north to south
C     _______________________________________________________
C
  200 CONTINUE
C
      NEXT = 1
C
      DO NEXLAT = 1, NGAUSS*2
        INROW = NGPTS(NEXLAT)
        STEPLON = 360.0/INROW
        RLAT = GLATS(NEXLAT)
C
C       Fill in longitudes along current line of latitude
C
        DO LOOP = 1, INROW
          RLON(LOOP) = (LOOP-1)*STEPLON
        ENDDO
C
C       Rotate the current line of latitude
C
        CALL NGVALUE(NEWFLD,NEXT,INROW,RLAT,RLON,
     X               POLELAT,POLELON,NGAUSS,HTYPE,DUMI,GLATS,NGPTS)
C
        NEXT = NEXT + INROW
C
      ENDDO
C
C     _______________________________________________________
C
C*    Section 9. Return to calling routine.
C     _______________________________________________________
C
  900 CONTINUE
C
      CALL INTLOG(JP_DEBUG,'NGROTAT: Return from NGROTAT:',JPQUIET)
C
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities
C granted to it by virtue of its status as an intergovernmental organisation
C nor does it submit to any jurisdiction.
C

      INTEGER FUNCTION JNORSGG( PLAT, PGGLAT, KNUM, KUP)
C
C---->
C**** JNORSGG
C
C     PURPOSE
C     _______
C
C     This routine determines which latitude row in a gaussian grid is
C     north or south of a given latitude.
C
C
C     INTERFACE
C     _________
C
C     I = JNORSGG( PLAT, PGGLAT, KNUM, KUP)
C
C
C     Input parameters
C     ________________
C
C     PLAT   - Given latitude
C     PGGLAT - Array of gaussian grid latitudes (both north and south
C              values)
C     KNUM   - Gaussian grid number
C     KUP    - Indicator to say if the returned row number should be
C              north or south of the given latitude
C              = 0 for south, = 1 for north
C
C
C     Output parameters
C     ________________
C
C     Returned value is the latitude row number.
C
C
C     Common block usage
C     __________________
C
C     None
C
C
C     METHOD
C     ______
C
C     The nearest gaussian latitude row is found.
C
C
C     EXTERNALS
C     _________
C
C     None
C
C
C     REFERENCE
C     _________
C
C     None
C
C
C     COMMENTS
C     ________
C
C     All input values are assumed to be reasonable!
C
C
C     AUTHOR
C     ______
C
C     J.D.Chambers      ECMWF       Jan 1994
C
C
C     MODIFICATIONS
C     _____________
C
C     J.D.Chambers      ECMWF       Mar 1996
C     Guess position to start search (an optimisation dodge)
C
C     J.D.Chambers      ECMWF       Aug 1996
C     Accept latitude if within 1000th of a degree of stored latitude.
C
C     J.D.Chambers      ECMWF       Oct 1996
C     Accept latitude if within 100th of a degree of stored latitude.
C
C----<
C     _______________________________________________________
C
C*    Section 0. Definition of variables.
C     _______________________________________________________
C
      IMPLICIT NONE
C
#include "parim.h"
C
C     Function arguments
C
      REAL PLAT, PGGLAT
      DIMENSION PGGLAT(*)
      INTEGER KNUM, KUP
C
C     Local variables
C
      INTEGER J202, NPOS, NPLAT, NGGLAT, IGUESS
      REAL JPFACTOR
      PARAMETER ( JPFACTOR = PPMULT/JPMICRO )
C
      REAL DELTA, OLDPLAT
      INTEGER IFIRST
      DATA IFIRST/0/, OLDPLAT/100.0/
      SAVE IFIRST, DELTA, IGUESS, OLDPLAT, NPLAT
C
C     _______________________________________________________
C
C*    Section 1. Initialization.
C     _______________________________________________________
C
  100 CONTINUE
C
C     Setup delta estimate between gaussian latitudes
      IF( IFIRST.NE. KNUM ) THEN
        IFIRST = KNUM
        DELTA  = 90.0/FLOAT(KNUM-1)
      ENDIF
C
      IF( OLDPLAT.NE.PLAT ) THEN
        OLDPLAT = PLAT
        IGUESS = INT( (90.0 - PLAT)/DELTA ) + 1
        NPLAT  = NINT(PLAT*JPFACTOR+0.5)
      ENDIF
C     _______________________________________________________
C
C*    Section 2. Processing.
C     _______________________________________________________
C
  200 CONTINUE
C
C     Check latitudes in the gaussian definition array
CDIR$ NOVECTOR
      DO 202 J202 = IGUESS, 2*KNUM
C       Accept latitude if within 100th of a degree of stored latitude.
        NGGLAT = NINT(PGGLAT(J202)*JPFACTOR+0.5)
        IF ( NPLAT .GE. NGGLAT ) THEN
          IF ( NPLAT .EQ. NGGLAT ) THEN
            NPOS = J202
          ELSE
            NPOS = J202 - KUP
          ENDIF
          GOTO 900
        ENDIF
  202 CONTINUE
C
C
C     On drop-through (e.g. for -90.0), use southernmost latitude
      NPOS = 2*KNUM
C
C     _______________________________________________________
C
C*    Section 9. Return to calling routine. Format statements
C     _______________________________________________________
C
  900 CONTINUE
C
C     Allow for latitude above northernmost in array (e.g. 90.0).
      IF ( NPOS .LT. 1 ) NPOS = 1
C
      JNORSGG = NPOS
C
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities
C granted to it by virtue of its status as an intergovernmental organisation
C nor does it submit to any jurisdiction.
C

      INTEGER FUNCTION DSSAREA(EW,NS,NORTH,WEST,SOUTH,EAST)
C
C---->
C**** DSSAREA
C
C     Purpose
C     -------
C
C     Fixup input/output field area definitions according to grid
C     specification (dissemination style).
C
C
C     Interface
C     ---------
C
C     IRET = DSSAREA(EW,NS,NORTH,WEST,SOUTH,EAST)
C
C     Input
C     -----
C
C     For latitude/longitude grids:
C     EW    =  East-west grid interval (degrees)
C     NS    =  North-south grid interval (degrees)
C
C     For gaussian grids:
C     EW    =  gaussian grid number
C     NS    =  0
C
C     NORTH =  North latitude (degrees)
C     WEST  =  West longitude (degrees)
C     SOUTH =  South latitude (degrees)
C     EAST  =  East longitude (degrees)
C
C     For spherical harmonics:
C     EW    =  0
C     NS    =  0
C     NORTH =  0
C     WEST  =  0
C     SOUTH =  0
C     EAST  =  0
C
C
C     Output
C     ------
C
C     NORTH =  North latitude, adjusted if necessary (degrees)
C     WEST  =  West longitude, adjusted if necessary (degrees)
C     SOUTH =  South latitude, adjusted if necessary (degrees)
C     EAST  =  East longitude, adjusted if necessary (degrees)
C
C     The function returns 0 if OK.
C     Otherwise a non-zero is returned and the values NORTH, WEST,
C     SOUTH, and EAST are left unchanged.
C
C
C     Method
C     ------
C
C     If default (0/0/0/0) selected for input, input area is set
C       - to global for lat/long grid
C       - to global for gaussian grid
C
C     Output area is adjusted:
C
C     (1) by shrinking to fit the default dissemination 0.5x0.5 grid
C         on its north and west boundaries.
C     (2) by calculating the east boundary from the new west as an
C         integral number of new grid west-east increments to fit
C         inside the specified area.
C     (3) by calculating the south boundary from the new north as an
C         integral number of new grid north-south increments to fit
C         inside the specified area.
C
C
C     Externals
C     ---------
C
C     JGETGG  - Reads the definition of a gaussian grid.
C     JNORSGG - Finds the lat row in a gauss grid N or S of given lat
C     INTLOG  - Logs error messages.
C
C
C     Author
C     ------
C
C     J.D.Chambers     ECMWF     May 1999
C
C----<
C
      IMPLICIT NONE
C
#include "parim.h"
#include "nifld.common"
C
C     Parameters
C
      INTEGER JPROUTINE
      PARAMETER (JPROUTINE = 19200 )
      REAL*8 RRMULT
#if (defined hp) && (!defined INTEGER_8)
      INTEGER NP90, NP360, NFACTOR
      PARAMETER ( NFACTOR = 10 )
#else
      INTEGER*8 NP90, NP360, NFACTOR
      PARAMETER ( NFACTOR = 1000 )
#endif
      INTEGER NR90
      PARAMETER ( NR90    = 90 )
      PARAMETER ( NP90    = JP90*NFACTOR )
      PARAMETER ( NP360   = JP360*NFACTOR )
      PARAMETER ( RRMULT  = (PPMULT*NFACTOR) )
C
C     Function arguments
C
      REAL EW, NS, NORTH, WEST, SOUTH, EAST
C
C     Local variables
C
#if (defined hp) && (!defined INTEGER_8)
      INTEGER INORTH, IWEST, ISOUTH, IEAST, IEW, INS
      INTEGER NWEST
#else
      INTEGER*8 INORTH, IWEST, ISOUTH, IEAST, IEW, INS
      INTEGER*8 NWEST
#endif
      CHARACTER*1 HTYPE
      INTEGER NGAUSS, NOLD, IRET, KPTS, NWEPTS, NNSPTS
      REAL RNORTH, RSOUTH
      REAL ONORTH, OWEST, OSOUTH, OEAST
      REAL RGAUSS, RESEW
      REAL*8 DEW, DNS, DNORTH, DWEST, DSOUTH, DEAST
      REAL*8 EPS
      LOGICAL LDEFIN, LGAUSS, LSPHERE
      DIMENSION KPTS(JPGTRUNC*2)
      DIMENSION RGAUSS(JPGTRUNC*2)
      DATA NOLD /0/
C
C     Externals
C
      INTEGER JNORSGG
C
      SAVE NOLD, RGAUSS
C
C     Statement functions
C
      REAL*8 A
      REAL B
      REAL*8 X
      REAL Y
C
      LOGICAL GREATER
      LOGICAL SMALLER
C
      GREATER(A,B) = ( (A-DBLE(B)).GT.EPS )
      SMALLER(X,Y) = ( (DBLE(Y)-X).GT.EPS )
C
      DATA EPS/1E-5/
C
C     -----------------------------------------------------------------|
C*    Section 1.   Initialise
C     -----------------------------------------------------------------|
C
  100 CONTINUE
C
      CALL INTLOGR(JP_DEBUG,'DSSAREA: input w-e   = ', EW)
      CALL INTLOGR(JP_DEBUG,'DSSAREA: input n-s   = ', NS)
      CALL INTLOGR(JP_DEBUG,'DSSAREA: input north = ', NORTH)
      CALL INTLOGR(JP_DEBUG,'DSSAREA: input south = ', SOUTH)
      CALL INTLOGR(JP_DEBUG,'DSSAREA: input west  = ', WEST)
      CALL INTLOGR(JP_DEBUG,'DSSAREA: input east  = ', EAST)
C
      ONORTH = NORTH
      OSOUTH = SOUTH
      OWEST  = WEST
      OEAST  = EAST
C
      DSSAREA = 0
      LGAUSS  = ( NS.EQ.0.0 )
      LSPHERE = ( (EW.EQ.0.0).AND.(NS.EQ.0.0) )
C
C     If it's gaussian, pick up the gaussian grid definitions unless
C     they have already been retrieved.
C
      IF( LGAUSS.AND..NOT.LSPHERE ) THEN
        NGAUSS = NINT( EW )
#if (defined hp) && (!defined INTEGER_8)
        IF( NGAUSS.GE.256 ) THEN
          CALL INTLOG(JP_ERROR,
     X      'DSSAREA: unsafe to use 32-bit HP version for gaussian = ',
     X      NGAUSS)
          DSSAREA = JPROUTINE + 1
          GOTO 900
        ENDIF
#endif
        IF( NGAUSS.GT.JPGTRUNC ) THEN
          CALL INTLOG(JP_ERROR,
     X      'DSSAREA: Gaussian grid number ', NGAUSS)
          CALL INTLOG(JP_ERROR,
     X      'DSSAREA: exceeds current expected maximum ', JPGTRUNC)
          DSSAREA = JPROUTINE + 1
          GOTO 900
        ENDIF
C
        IF( NGAUSS.NE.NOLD ) THEN
          NOLD = NGAUSS
          HTYPE = 'F'
          CALL JGETGG(NOLD,HTYPE,RGAUSS,KPTS,IRET)
          IF( IRET.NE.0 ) THEN
            CALL INTLOG(JP_ERROR,
     X        'DSSAREA: Failed to pick up gaussian ', JPQUIET)
            CALL INTLOG(JP_ERROR,
     X        'DSSAREA: definitions for resolution = ', NOLD)
            DSSAREA = JPROUTINE + 1
            GOTO 900
          ENDIF
        ENDIF
      ENDIF
C
C     -----------------------------------------------------------------|
C*    Section 2.   Fixup area if default (0/0/0/0).
C     -----------------------------------------------------------------|
C
  200 CONTINUE
C
      LDEFIN = ( (NORTH.EQ.0).AND.(WEST.EQ.0).AND.
     X           (SOUTH.EQ.0).AND.(EAST.EQ.0) )
C
      IF( LDEFIN ) THEN
C
        IF( .NOT.LGAUSS ) THEN
C
C         Regular lat/long grid ..
C
          NORTH = 90.0
          WEST  = 0
          SOUTH = -NORTH
          EAST  = 360.0 - EW
C
        ELSE IF( LSPHERE ) THEN
C
C         Spherical harmonics
C
          NORTH = 90.0
          WEST  = 0
          SOUTH = -90.0
          EAST  = 360.0
C
C
        ELSE
C
C         Gaussian grid ..
C WARN: (issue EMOS-199) EAST calculation is only for [F|N] grids, O
C (octahedral) has a finer resolution at the equator for the same NGAUSS
C
          INORTH = JNORSGG( 90.0, RGAUSS, NGAUSS, 0)
          NORTH  = RGAUSS(INORTH)
          WEST   = 0
          ISOUTH = JNORSGG( -90.0, RGAUSS, NGAUSS, 1)
          SOUTH  = RGAUSS(ISOUTH)
          EAST   = 360.0 - 90.0/REAL(NGAUSS)
        ENDIF
C
        GOTO 900
      ENDIF
C
      IF( LSPHERE ) GOTO 900
C
C     Don't fixup area for ocean products
C
      IF( NILOCAL.EQ.4 ) GOTO 900
C
C     -----------------------------------------------------------------|
C*    Section 3.   Fixup west-east area to correspond to the grid.
C     -----------------------------------------------------------------|
C
  300 CONTINUE
C
      IF( EAST.GT.360.0.AND.EAST.LT.361.0 ) THEN
        CALL INTLOGR(JP_WARN,
     X    'DSSAREA: Faulty East lon limits', EAST)
        EAST = 360.0
        CALL INTLOGR(JP_WARN,
     X    'DSSAREA: Changed East to', EAST)
      ENDIF
c
      IF( (WEST.LT.-360.0).OR.(WEST.GT.360.0).OR.
     X    (EAST.LT.-360.0).OR.(EAST.GT.360.0) ) THEN
        CALL INTLOG(JP_ERROR,
     X    'DSSAREA: Faulty input langitude limits', JPQUIET)
        CALL INTLOGR(JP_ERROR,'DSSAREA: West = ', WEST)
        CALL INTLOGR(JP_ERROR,'DSSAREA: East = ', EAST)
        NORTH = ONORTH
        SOUTH = OSOUTH
        WEST  = OWEST
        EAST  = OEAST
        DSSAREA = JPROUTINE + 4
        GOTO 900
      ENDIF
C
      IF( .NOT. LGAUSS ) THEN
C
C       Regular lat/long grid only ..
C
        DEW = JPDISTP * RRMULT
        IEW = DNINT( DBLE(DEW) )
        RESEW = EW
C
      ELSE
C
C       Gaussian grid ..
C
        DEW = DBLE(NP90) / DBLE(NGAUSS)
        IEW = DNINT( DBLE(DEW) )
        RESEW = DBLE(NR90) / DBLE(NGAUSS)
C
      ENDIF
C
C     Ensure West < East
C
      IF( WEST.GT.EAST ) WEST = WEST - 360.0
      DWEST = WEST
      IWEST = DNINT( DBLE(DWEST * RRMULT) )
C
C     Find west boundary to nearest dissemination gridpoint eastwards.
C     From this value, calculate the east limit using the requested
C     grid increment.
C
      IF( IWEST.GT.0 ) THEN
        NWEST =  DINT(DBLE(IWEST + IEW - 1) / DEW)
        IWEST = DNINT(DBLE(NWEST) * DEW)
      ELSE
        NWEST =  DINT(DBLE(-IWEST) / DEW)
        IWEST = DNINT(DBLE(-NWEST) * DEW)
      ENDIF
C
      DWEST = DBLE(IWEST)/RRMULT
C
      DEAST = EAST
C
      NWEPTS = NINT( (DEAST - DWEST) / RESEW )
      DEAST  = DWEST + (NWEPTS*RESEW)
      IF( GREATER(DEAST,EAST) ) DEAST = DEAST - RESEW
      CALL INTLOGR(JP_DEBUG,'DSSAREA: calculated west  = ', DWEST)
      CALL INTLOGR(JP_DEBUG,'DSSAREA: calculated east  = ', DEAST)
      IEAST = DNINT( DBLE(DEAST * RRMULT) )
C
C     Try to catch special case: global west-east with wrap-around.
C
      IF( (IEAST-IWEST).GE.NP360 ) THEN
        IF( LGAUSS) THEN
          IEAST = IWEST + (4*NGAUSS-1)*RESEW*RRMULT
        ELSE
          IEAST = IWEST + NP360 - RESEW*RRMULT
        ENDIF
      ENDIF
C
C     Ensure East and West still in range (0,360)
C
      IF( IEAST.GT.NP360 ) THEN
        IEAST = IEAST - NP360
        IWEST = IWEST - NP360
      ENDIF
      IF( IWEST.LT.-NP360 ) THEN
        IEAST = IEAST + NP360
        IWEST = IWEST + NP360
      ENDIF
C
C     Ensure East-West spread is not greater than 360
C
      IF( (IEAST-IWEST).GT.NP360 ) THEN
        IF( LGAUSS) THEN
          IEAST = IWEST + (4*NGAUSS-1)*IEW
        ELSE
          IEAST = IWEST + NP360 - IEW
        ENDIF
      ENDIF
C
C     Apply adjustment when east and west boundaries are the same
C     longitude (0/360) to give a global grid.
C
      IF( ( (IWEST.EQ.-NP360).AND.(IEAST.EQ.0)     ) .OR.
     X    ( (IWEST.EQ.0)     .AND.(IEAST.EQ.NP360) ) .OR.
     X    ( (IWEST.EQ.NP360) .AND.(IEAST.EQ.NP360) )  ) THEN
        IWEST = 0
        IF( LGAUSS) THEN
          IEAST = (4*NGAUSS-1)*IEW
        ELSE
          IEAST = NP360 - IEW
        ENDIF
      ENDIF
C
      DWEST  = DBLE(IWEST) / RRMULT
      DEAST  = DBLE(IEAST) / RRMULT
      WEST  = DBLE(IWEST) / RRMULT
      EAST  = DBLE(IEAST) / RRMULT
C
      IF( (EAST.LT.WEST).OR.(EAST.GT.360.0) ) THEN
        CALL INTLOG(JP_ERROR,
     X    'DSSAREA: Faulty calculated longitude limits', JPQUIET)
        CALL INTLOGR(JP_ERROR,'DSSAREA: East = ', EAST)
        CALL INTLOGR(JP_ERROR,'DSSAREA: West = ', WEST)
        NORTH = ONORTH
        SOUTH = OSOUTH
        WEST  = OWEST
        EAST  = OEAST
        DSSAREA = JPROUTINE + 3
        GOTO 900
      ENDIF
C
C     -----------------------------------------------------------------|
C*    Section 4.   Fixup north-south area to correspond to the grid.
C     -----------------------------------------------------------------|
C
  400 CONTINUE
C
      IF( NORTH.LT.SOUTH ) THEN
        CALL INTLOG(JP_ERROR,
     X    'DSSAREA: Faulty input latitude limits', JPQUIET)
        CALL INTLOGR(JP_ERROR,'DSSAREA: North = ', NORTH)
        CALL INTLOGR(JP_ERROR,'DSSAREA: South = ', SOUTH)
        DSSAREA = JPROUTINE + 1
        GOTO 900
      ENDIF
cs
      IF( NORTH.GT.90.0 ) THEN
        CALL INTLOGR(JP_WARN,
     X    'DSSAREA: Faulty North lat limits', NORTH)
        NORTH = 90.0
        CALL INTLOGR(JP_WARN,
     X    'DSSAREA: Changed North to', NORTH)
      ENDIF
cs
      IF( SOUTH.LT.-90.0 ) THEN
        CALL INTLOGR(JP_WARN,
     X    'DSSAREA: Faulty South lat limits', SOUTH)
        SOUTH = -90.0
        CALL INTLOGR(JP_WARN,
     X    'DSSAREA: Changed South to', SOUTH)
      ENDIF

      IF( .NOT.LGAUSS ) THEN
C
C       Regular lat/long grid only ..
C
        DNS = JPDISTP * RRMULT
        INS = DNINT( DBLE(DNS) )
C
C       Find north boundary to nearest dissemination gridpoint south.
C       From this value, calculate the south limit using the requested
C       grid increment.
C
        DNORTH = NORTH
        INORTH = DNINT( DBLE(DNORTH * RRMULT) )
        IF( INORTH.GE.0 ) THEN
          INORTH = INORTH / INS
        ELSE
          INORTH = (INORTH-INS+1) / INS
        ENDIF
        INORTH = INORTH * INS
        IF( INORTH .GT. NP90 ) INORTH = NP90
        IF( INORTH .LT. -NP90 ) INORTH = -NP90
        NORTH = DBLE(INORTH) / RRMULT
C
        DNORTH = NORTH
        DSOUTH = SOUTH
        NNSPTS = NINT( (DNORTH - DSOUTH) / NS )
        DSOUTH = DNORTH - (NNSPTS* NS)
        IF( SMALLER(DSOUTH,SOUTH) ) DSOUTH = DSOUTH + NS
        CALL INTLOGR(JP_DEBUG,'DSSAREA: calculated north = ', DNORTH)
        CALL INTLOGR(JP_DEBUG,'DSSAREA: calculated south = ', DSOUTH)
        ISOUTH = DNINT( DBLE(DSOUTH * RRMULT) )

        IF( ISOUTH .GT. NP90 ) ISOUTH = NP90
        IF( ISOUTH .LT. -NP90 ) ISOUTH = -NP90
        SOUTH = DBLE(ISOUTH) / RRMULT
C
      ELSE
C
C       Gaussian grid ..
C
C       Round north boundary to nearest gridpoint southwards.
C
        RNORTH = NORTH
        INORTH = JNORSGG( RNORTH, RGAUSS, NGAUSS, 0)
        NORTH  = RGAUSS(INORTH)
C
C       Round south boundary to nearest gridpoint northwards.
C
        RSOUTH = SOUTH
        ISOUTH = JNORSGG( RSOUTH, RGAUSS, NGAUSS, 1)
        SOUTH  = RGAUSS(ISOUTH)
C
      ENDIF
C
C     -----------------------------------------------------------------|
C*    Section 9.   Closedown.
C     -----------------------------------------------------------------|
C
  900 CONTINUE
C
      RETURN
      END

C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE GRCHK2 (KSEC1,KSEC2,PSEC2,KRET)
C
C---->
C**** GRCHK2 - Check parameters for Section 2 of GRIB Code.
C
C     Purpose.
C     --------
C
C     Check parameters for Section 2 of GRIB code against
C     valid values for GRIB Edition 1.
C
C**   Interface.
C     ----------
C
C     CALL GRCHK2 (KSEC1,KSEC2,PSEC2,KRET)
C
C
C     Input Parameters.
C     -----------------
C
C     KSEC1      - Array containing integer parameters for
C                  section 1 of GRIB code.
C
C     KSEC2      - Array containing integer parameters for
C                  section 2 of GRIB code.
C
C     PSEC2      - Array containing real parameters for
C                  section 2 of GRIB code.
C
C     Output Parameters.
C     ------------------
C
C     KRET       - Return code.
C                  0   , No error encountered.
C                  1   , Error in GRIB Code parameter.
C
C     Method.
C     -------
C
C     Values checked against current code/flag tables
C     and against maximum or minimum permitted values.
C     They are also checked against the current status
C     of the implementation of GRIBEX and ECMWF usage.
C
C     Externals.
C     ----------
C
C     None.
C
C     Reference.
C     ----------
C
C     WMO Manual on Codes for GRIB Code.
C
C     Comments.
C     ---------
C
C     None.
C
C     Author.
C     -------
C
C     J. Hennessy      ECMWF      18.06.91
C
C     Modifications.
C     --------------
C
C     J. Hennessy      ECMWF      30.08.91
C     Polar stereographic representation type allowed.
C
C     J. Hennessy      ECMWF      01.10.91
C     Space view or orthographic representation allowed.
C     Additional parameters KSEC1 and PSEC2 added.
C
C     J.D.Chambers     ECMWF      27.04.94
C     Allow complex packing for spherical harmonics
C
C     J.D.Chambers     ECMWF      03.04.95
C     Allow Lambert conformal.
C
C     J.D.Chambers     ECMWF      July 2004
C     Allow Mercator
C
C----<
C     ----------------------------------------------------------------
C     Section 0 . Definition of variables. Data statements.
C     ----------------------------------------------------------------
C
      IMPLICIT NONE
C
#include "grprs.h"
C
C     Parameters
C
      INTEGER JP6, JP6X, JP8
      PARAMETER (JP6=23)
      PARAMETER (JP6X=17)
      PARAMETER (JP8=8)
C
C     Subroutine arguments
C
      INTEGER KSEC1, KSEC2, KRET
      DIMENSION KSEC1(*)
      DIMENSION KSEC2(*)
      REAL PSEC2
      DIMENSION PSEC2(*)
C
C     Local variables
C
      LOGICAL LQUASI
      INTEGER LOOP
C
      INTEGER ITAB6, ITAB6X, ITAB8
      DIMENSION ITAB6(JP6)
      DIMENSION ITAB6X(JP6X)
      DIMENSION ITAB8(JP8)
C
C     Valid values given in Code Table 6.
C
      DATA ITAB6 /  0,  1,  2,  3,  4,  5,  6,  7,  8,  9,
     X             10, 13, 14,
     X             20, 24, 30, 34, 50, 60, 70, 80, 90,
     X            192 /
C
C     Code Table 6 values currently supported by GRIBEX.
C
      DATA ITAB6X /0,1,3,4,5,10,14,20,24,30,34,50,60,70,80,90,192/
C
C     Valid values given in Code Table 8.
C
      DATA ITAB8 /0,128,64,192,32,160,96,224/
C
C     ----------------------------------------------------------------
C     Section 1 . Set initial values.
C     ----------------------------------------------------------------
C
  100 CONTINUE
C
C     Reset return code.
      KRET = 0
C
C     ----------------------------------------------------------------
C     Section 2 . Check values against code tables and extreme values.
C     ----------------------------------------------------------------
C
  200 CONTINUE
C
C     Number of vertical coordinate parameters.
C
      IF (KSEC2(12).LT.0.OR.KSEC2(12).GT.255) THEN
       	KRET = 1
	WRITE(GRPRSM,9019) KSEC2(12)
      ENDIF
C
C     Check Data Representation Type.
C
      DO LOOP = 1,JP6
	IF (KSEC2(1).EQ.ITAB6(LOOP)) GO TO 202
      ENDDO
C
      KRET = 1
      WRITE(GRPRSM,9001) KSEC2(1)
C
  202 CONTINUE
C
C     Check Data Representation Type currently supported.
C
      DO LOOP = 1,JP6X
	IF (KSEC2(1).EQ.ITAB6X(LOOP)) GO TO 204
      ENDDO
C
      KRET = 1
      WRITE(GRPRSM,9002) KSEC2(1)
      GO TO 900
C
  204 CONTINUE
C
C     Earth flag.
C
      IF (KSEC2(18).NE.0.AND.KSEC2(18).NE.64) THEN
       	KRET = 1
	WRITE(GRPRSM,9005) KSEC2(18)
      ENDIF
C
C     Check ECMWF usage.(0 except for space view perspective)
C
      IF (KSEC2(18).NE.0.AND.KSEC1(2).EQ.98.AND.KSEC2(1).NE.90) THEN
 	KRET = 1
	WRITE(GRPRSM,9007)
      ENDIF
C
C     Components flag.
C
      IF (KSEC2(19).NE.0.AND.KSEC2(19).NE.8) THEN
	KRET = 1
	WRITE(GRPRSM,9006) KSEC2(19)
      ENDIF
C
C     Check ECMWF usage.
C
      IF(KSEC2(19).NE.0.AND.KSEC2(19).NE.8.AND.KSEC1(2).EQ.98) THEN
	KRET = 1
	WRITE(GRPRSM,9008)
      ENDIF
C
      LQUASI = (KSEC2(17) .EQ. 1)
C
C     ----------------------------------------------------------------
C     Section 3. Checks on latitude/longitude grids.
C     ----------------------------------------------------------------
C
  300 CONTINUE
C
      IF ( KSEC2(1).EQ.0  .OR. KSEC2(1).EQ.10 .OR.
     X     KSEC2(1).EQ.20 .OR. KSEC2(1).EQ.30 ) THEN
C
C       Number of points along a parallel.
C
	IF ( KSEC2(2).LT.1. OR. KSEC2(2).GT.65535 ) THEN
          IF ( .NOT. LQUASI ) THEN
	    KRET = 1
	    WRITE(GRPRSM,9022) KSEC2(2)
          ENDIF
        ENDIF
C
C       Number of points along a meridian.
C
	IF ( KSEC2(3).LT.1 .OR. KSEC2(3).GT.65535 ) THEN
          IF ( .NOT. LQUASI ) THEN
	    KRET = 1
	    WRITE(GRPRSM,9023) KSEC2(3)
          ENDIF
        ENDIF
C
C       Latitude of first grid point.
C
	IF (KSEC2(4).LT.-90000.OR.KSEC2(4).GT.90000) THEN
	  KRET = 1
	  WRITE(GRPRSM,9015) KSEC2(4)
        ENDIF
C
C       Longitude of first grid point.
C
	IF (KSEC2(5).LT.-360000.OR.KSEC2(5).GT.360000) THEN
	  KRET = 1
	  WRITE(GRPRSM,9016) KSEC2(5)
        ENDIF
C
C       Resolution flag.
C
	IF (KSEC2(6).NE.0.AND.KSEC2(6).NE.128) THEN
	  KRET = 1
	  WRITE(GRPRSM,9003) KSEC2(6)
        ENDIF
C
C       Latitude of last grid point.
C
	IF (KSEC2(7).LT.-90000.OR.KSEC2(7).GT.90000) THEN
	  KRET = 1
	  WRITE(GRPRSM,9020) KSEC2(7)
        ENDIF
C
C       Longitude of last grid point.
C
	IF (KSEC2(8).LT.-360000.OR.KSEC2(8).GT.360000) THEN
	  KRET = 1
	  WRITE(GRPRSM,9021) KSEC2(8)
        ENDIF
C
C       Direction increments, if included.
C
        IF (KSEC2(6).EQ.128) THEN
	  IF (KSEC2(9).LT.1.OR.KSEC2(9).GT.65535) THEN
            IF( .NOT. LQUASI ) THEN
	      KRET = 1
	      WRITE(GRPRSM,9024) KSEC2(9)
            ENDIF
          ENDIF
C
	  IF (KSEC2(10).LT.1.OR.KSEC2(10).GT.65535) THEN
            IF( .NOT. LQUASI ) THEN
	      KRET = 1
	      WRITE(GRPRSM,9025) KSEC2(10)
            ENDIF
          ENDIF
        ENDIF
C
C       Scanning mode flag.
C
        DO LOOP = 1, JP8
	  IF (KSEC2(11).EQ.ITAB8(LOOP)) GO TO 302
        ENDDO
C
        KRET = 1
        WRITE(GRPRSM,9004) KSEC2(11)
C
  302   CONTINUE
C
C       Regular / Quasi-regular grid check.
C
	IF (KSEC2(17).NE.0.AND.KSEC2(17).NE.1) THEN
	  KRET = 1
	  WRITE(GRPRSM,9009) KSEC2(17)
        ENDIF
C
        GO TO 900
      ENDIF
C
C     ----------------------------------------------------------------
C     Section 4. Checks on Gaussian grids.
C     ----------------------------------------------------------------
C
  400 CONTINUE
C
      IF ( KSEC2(1).EQ.4  .OR. KSEC2(1).EQ.14 .OR.
     X     KSEC2(1).EQ.24 .OR. KSEC2(1).EQ.34) THEN
C
C       Latitude of first grid point.
C
	IF (KSEC2(4).LT.-90000.OR.KSEC2(4).GT.90000) THEN
	  KRET = 1
	  WRITE(GRPRSM,9015) KSEC2(4)
        ENDIF
C
C       Longitude of first grid point.
C
	IF (KSEC2(5).LT.-360000.OR.KSEC2(5).GT.360000) THEN
	  KRET = 1
	  WRITE(GRPRSM,9016) KSEC2(5)
        ENDIF
C
C       Latitude of last grid point.
C
	IF (KSEC2(7).LT.-90000.OR.KSEC2(7).GT.90000) THEN
	  KRET = 1
	  WRITE(GRPRSM,9020) KSEC2(7)
        ENDIF
C
C       Longitude of last grid point.
C
	IF (KSEC2(8).LT.-360000.OR.KSEC2(8).GT.360000) THEN
	  KRET = 1
	  WRITE(GRPRSM,9021) KSEC2(8)
        ENDIF
C
C       i-direction increment, if included.
C
        IF (KSEC2(6).EQ.128) THEN
	  IF (KSEC2(9).LT.1.OR.KSEC2(9).GT.65535) THEN
	    KRET = 1
	    WRITE(GRPRSM,9024) KSEC2(9)
          ENDIF
        ENDIF
C
C       Number of parallels beween pole and equator.
C
        IF (KSEC2(10).LT.1.OR.KSEC2(10).GT.65535) THEN
	  KRET = 1
	  WRITE(GRPRSM,9026) KSEC2(10)
        ENDIF
C
C       Increment flag.
C
	IF (KSEC2(6).NE.0.AND.KSEC2(6).NE.128) THEN
	  KRET = 1
	  WRITE(GRPRSM,9003) KSEC2(6)
        ENDIF
C
C       Scanning mode flag.
C
        DO LOOP = 1, JP8
	  IF (KSEC2(11).EQ.ITAB8(LOOP)) GO TO 402
        ENDDO
C
        KRET = 1
        WRITE(GRPRSM,9004) KSEC2(11)
C
  402   CONTINUE
C
C       Regular / Quasi-regular grid check.
C
	IF (KSEC2(17).NE.0.AND.KSEC2(17).NE.1) THEN
	  KRET = 1
	  WRITE(GRPRSM,9009) KSEC2(17)
        ENDIF
C
C       Cross-check increments flag and quasi-regular indicator.
C
	IF ( LQUASI .AND.KSEC2(6).EQ.128) THEN
	  KRET = 1
	  WRITE(GRPRSM,9011)
        ENDIF
C
        GO TO 900
      ENDIF
C
C     ----------------------------------------------------------------
C     Section 5. Checks on Polar Stereographic data.
C
C     ----------------------------------------------------------------
C
  500 CONTINUE
C
      IF (KSEC2(1).EQ.5) THEN
C
C       Number of points along X-axis.
C
	IF (KSEC2(2).LT.1.OR.KSEC2(2).GT.65535) THEN
	  KRET = 1
	  WRITE(GRPRSM,9027) KSEC2(2)
        ENDIF
C
C       Number of points along Y-axis.
C
	IF (KSEC2(3).LT.1.OR.KSEC2(3).GT.65535) THEN
	  KRET = 1
	  WRITE(GRPRSM,9028) KSEC2(3)
        ENDIF
C
C       Latitude of first grid point.
C
	IF (KSEC2(4).LT.-90000.OR.KSEC2(4).GT.90000) THEN
	  KRET = 1
	  WRITE(GRPRSM,9015) KSEC2(4)
        ENDIF
C
C       Longitude of first grid point.
C
	IF (KSEC2(5).LT.-360000.OR.KSEC2(5).GT.360000) THEN
	  KRET = 1
	  WRITE(GRPRSM,9016) KSEC2(5)
        ENDIF
C
C       Orientation of the grid.
C
	IF (KSEC2(7).LT.-360000.OR.KSEC2(7).GT.360000) THEN
	  KRET = 1
	  WRITE(GRPRSM,9017) KSEC2(7)
        ENDIF
C
C       Grid lengths.
C
	IF (KSEC2(9).LT.1.OR.KSEC2(9).GT.16777215) THEN
	  KRET = 1
	  WRITE(GRPRSM,9029) KSEC2(9)
        ENDIF
C
	IF (KSEC2(10).LT.1.OR.KSEC2(10).GT.16777215) THEN
	  KRET = 1
	  WRITE(GRPRSM,9030) KSEC2(10)
        ENDIF
C
C       Projection centre.
C
C       The use of 1 by the Polar Stereographic projection in this
C       octet is inconsistent with Lambert conformal et al
C       representation where bit 1 is set 1 to indicate North pole.
C
	IF (KSEC2(13).NE.0.AND.KSEC2(13).NE.1) THEN
	  KRET = 1
	  WRITE(GRPRSM,9018) KSEC2(13)
        ENDIF
C
        GO TO 900
      ENDIF
C
C     ----------------------------------------------------------------
C     Section 6. Checks on spherical harmonic data.
C     ----------------------------------------------------------------
C
  600 CONTINUE
C
      IF ( KSEC2(1).EQ.50 .OR. KSEC2(1).EQ.60 .OR.
     X     KSEC2(1).EQ.70 .OR. KSEC2(1).EQ.80 ) THEN
C
C       Spectral data representation type.
C
        IF (KSEC2(5).NE.1) THEN
	  KRET = 1
	  WRITE(GRPRSM,9012) KSEC2(5)
        ENDIF
C
C       Spectral data representation mode.
C
	IF (KSEC2(6).NE.1.AND.KSEC2(6).NE.2) THEN
	  KRET = 1
	  WRITE(GRPRSM,9013) KSEC2(6)
        ENDIF
C
        GO TO 900
      ENDIF
C
C     ----------------------------------------------------------------
C     Section 7 . Checks on space view perspective.
C     ----------------------------------------------------------------
C
  700 CONTINUE
C
      IF (KSEC2(1).EQ.90) THEN
	GO TO 900
      ENDIF
C
C     ----------------------------------------------------------------
C     Section 8. Checks on Lambert conformal data.
C     ----------------------------------------------------------------
C
  800 CONTINUE
C
      IF (KSEC2(1).EQ.3) THEN
C
C       Number of points along X-axis.
C
        IF (KSEC2(2).LT.1.OR.KSEC2(2).GT.65535) THEN
          KRET = 1
          WRITE(GRPRSM,9027) KSEC2(2)
        ENDIF
C
C       Number of points along Y-axis.
C
        IF (KSEC2(3).LT.1.OR.KSEC2(3).GT.65535) THEN
          KRET = 1
          WRITE(GRPRSM,9028) KSEC2(3)
        ENDIF
C
C       Latitude of first grid point.
C
        IF (KSEC2(4).LT.-90000.OR.KSEC2(4).GT.90000) THEN
          KRET = 1
          WRITE(GRPRSM,9015) KSEC2(4)
        ENDIF
C
C
C       Longitude of first grid point.
C
        IF (KSEC2(5).LT.-360000.OR.KSEC2(5).GT.360000) THEN
          KRET = 1
          WRITE(GRPRSM,9016) KSEC2(5)
        ENDIF
C
C       Orientation of the grid.
C
        IF (KSEC2(7).LT.-360000.OR.KSEC2(7).GT.360000) THEN
          KRET = 1
          WRITE(GRPRSM,9017) KSEC2(7)
        ENDIF
C
C       Grid lengths.
C
        IF (KSEC2(9).LT.1.OR.KSEC2(9).GT.16777215) THEN
          KRET = 1
          WRITE(GRPRSM,9029) KSEC2(9)
        ENDIF
C
        IF (KSEC2(10).LT.1.OR.KSEC2(10).GT.16777215) THEN
          KRET = 1
          WRITE(GRPRSM,9030) KSEC2(10)
        ENDIF
C
C       Projection centre.
C
        IF (KSEC2(13).NE.0.AND.KSEC2(13).NE.64.AND.KSEC2(13).NE.
     X       128.AND.KSEC2(13).NE.192) THEN
          KRET = 1
          WRITE(GRPRSM,9018) KSEC2(13)
        ENDIF
C
C       Latitude Latin 1.
C
        IF (KSEC2(14).LT.-90000.OR.KSEC2(14).GT.90000) THEN
          KRET = 1
          WRITE(GRPRSM,9015) KSEC2(14)
        ENDIF
C
C       Latitude Latin 2.
C
        IF (KSEC2(15).LT.-90000.OR.KSEC2(15).GT.90000) THEN
          KRET = 1
          WRITE(GRPRSM,9015) KSEC2(15)
        ENDIF
C
C       Latitude of southern pole.
C
        IF (KSEC2(20).LT.-90000.OR.KSEC2(20).GT.90000) THEN
          KRET = 1
          WRITE(GRPRSM,9015) KSEC2(20)
        ENDIF
C
C       Longitude of southern pole.
C
        IF (KSEC2(21).LT.-360000.OR.KSEC2(21).GT.360000) THEN
          KRET = 1
          WRITE(GRPRSM,9016) KSEC2(21)
        ENDIF
C
        GO TO 900
      ENDIF
C
C     ----------------------------------------------------------------
C     Section 9 . Return to calling routine. Format statements.
C     ----------------------------------------------------------------
C
  900 CONTINUE
C
 9001 FORMAT (1H ,'GRCHK2 : Invalid data representation type - ',I3)
 9002 FORMAT (1H ,'GRCHK2 : Unsupported data representation type - ',I3)
 9003 FORMAT (1H ,'GRCHK2 : Invalid increments flag - ',I3)
 9004 FORMAT (1H ,'GRCHK2 : Invalid scanning mode flag - ',I3)
 9005 FORMAT (1H ,'GRCHK2 : Invalid earth flag - ',I3)
 9006 FORMAT (1H ,'GRCHK2 : Invalid components flag - ',I3)
 9007 FORMAT (1H ,'GRCHK2 : Earth flag - ECMWF usage is 0.')
 9008 FORMAT (1H ,'GRCHK2 : Components flag - ECMWF usage is 0.')
 9009 FORMAT (1H ,'GRCHK2 : Invalid quasi / regular indicator - ',I3)
 9011 FORMAT (1H ,'GRCHK2 : Quasi-regular Gaussian grid cannot have',
     C            ' direction increments included.')
 9012 FORMAT (1H ,'GRCHK2 : Invalid spectral representation type - ',I3)
 9013 FORMAT (1H ,'GRCHK2 : Invalid spectral representation mode - ',I3)
 9014 FORMAT (1H ,'GRCHK2 : Complex spectral representation mode ',
     C            'not catered for.')
 9015 FORMAT (1H ,'GRCHK2 : Invalid latitude of first grid point - ',
     C               I10)
 9016 FORMAT (1H ,'GRCHK2 : Invalid longitude of first grid point - ',
     C               I10)
 9017 FORMAT (1H ,'GRCHK2 : Invalid orientation of the grid - ',
     C               I10)
 9018 FORMAT (1H ,'GRCHK2 : Invalid projection centre flag - ',I3)
 9019 FORMAT (1H ,'GRCHK2 : Invalid number of vertical coordinate ',
     C            'parameters - ',I8)
 9020 FORMAT (1H ,'GRCHK2 : Invalid latitude of last grid point - ',
     C               I10)
 9021 FORMAT (1H ,'GRCHK2 : Invalid longitude of last grid point - ',
     C               I10)
 9022 FORMAT (1H ,'GRCHK2 : Invalid number of points along a parallel',
     C              ' - ', I10)
 9023 FORMAT (1H ,'GRCHK2 : Invalid number of points along a meridian',
     C              ' - ', I10)
 9024 FORMAT (1H ,'GRCHK2 : Invalid i-direction increment - ',I10)
 9025 FORMAT (1H ,'GRCHK2 : Invalid j-direction increment - ',I10)
 9026 FORMAT (1H ,'GRCHK2 : Invalid number of parallels - ',I10)
 9027 FORMAT (1H ,'GRCHK2 : Invalid number of points along X-axis',
     C              ' - ', I10)
 9028 FORMAT (1H ,'GRCHK2 : Invalid number of points along Y-axis',
     C              ' - ', I10)
 9029 FORMAT (1H ,'GRCHK2 : Invalid X-direction grid length - ',I10)
 9030 FORMAT (1H ,'GRCHK2 : Invalid Y-direction grid length - ',I10)
C
      RETURN
C
      END

C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE JWSCAL( PZFA, KLATS, KLONS, KFIRST, PLATS)
C
C---->
C**** JWSCAL
C
C     PURPOSE
C     _______
C
C     This routine applies a scale factor to all latitudes except
C     the poles
C
C     INTERFACE
C     _________
C
C     CALL JWSCAL( PZFA, KLATS, KLONS, KFIRST, PLATS)
C
C     Input parameters
C     ________________
C
C     PZFA     - Array of wind field (U or V) fourier coefficients
C     KLATS    - Number of latitude lines in PZFA
C     KLONS    - Number of longitude points in each line of latitude
C     KFIRST   - First latitude to process in PLATS
C     PLATS    - Array of gaussian latitudes (degrees)
C
C     Output parameters
C     ________________
C
C     PZFA     - Modified array of fourier coefficients
C
C     Common block usage
C     __________________
C
C     None.
C
C     Method
C     ______
C
C     Apply latitude-dependent scale factor to all coefficients.
C     It is assumed that no latitude is at the North or South pole.
C
C     Externals
C     _________
C
C     SSCAL  - Apply scalar correction to row of values
C
C
C     Reference
C     _________
C
C     None
C
C
C     Comments
C     ________
C
C     PZFA contains pairs of north/south latitudes.
C
C
C     AUTHOR
C     ______
C
C     J.D.Chambers      *ECMWF*      Jan 1994
C
C     MODIFICATIONS
C     _____________
C
C     None.
C
C----<
C     _______________________________________________________
C
C*    Section 0. Definition of variables.
C     _______________________________________________________
C
C*    Prefix conventions for variable names
C
C     Logical      L (but not LP), global or common.
C                  O, dummy argument
C                  G, local variable
C                  LP, parameter.
C     Character    C, global or common.
C                  H, dummy argument
C                  Y (but not YP), local variable
C                  YP, parameter.
C     Integer      M and N, global or common.
C                  K, dummy argument
C                  I, local variable
C                  J (but not JP), loop control
C                  JP, parameter.
C     Real         A to F and Q to X, global or common.
C                  P (but not PP), dummy argument
C                  Z, local variable
C                  PP, parameter.
C
      IMPLICIT NONE
C
#include "jparams.h"
C
C     Subroutine arguments
C
      REAL   PZFA
      DIMENSION PZFA(JPLONO+2, 64)
      INTEGER   KLATS, KLONS, KFIRST
      REAL      PLATS
      DIMENSION PLATS(*)
C
C     Local variables
C
      INTEGER JNEXTLAT, INORTH, ISOUTH
      REAL ZCOSI, ZLAT, ZPIBY2, ZDEGR
C     _______________________________________________________
C
C*    Section 1.    Initialization.
C     _______________________________________________________
C
  100 CONTINUE
      ZPIBY2 = PPI / 2.0
      ZDEGR  = PPI / 180.0
C
C     _______________________________________________________
C
C*    Section 2.    Apply scale factor to all latitudes.
C     _______________________________________________________
C
 200  CONTINUE
      INORTH = -1
      DO 220 JNEXTLAT = 1, KLATS
        ZLAT  = PLATS( KFIRST + JNEXTLAT - 1 )
        INORTH = INORTH + 2
        ISOUTH = INORTH + 1
        ZCOSI = 1.0 / COS( ZLAT * ZDEGR )
        CALL SSCAL( KLONS, ZCOSI, PZFA( 2, INORTH), 1)
        CALL SSCAL( KLONS, ZCOSI, PZFA( 2, ISOUTH), 1)
 220  CONTINUE
C     _______________________________________________________
C
C*    Section 9. Return to calling routine.
C     _______________________________________________________
C
 900  CONTINUE
C
      RETURN
      END

c Copyright 1981-2016 ECMWF.
c
c This software is licensed under the terms of the Apache Licence 
c Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
c
c In applying this licence, ECMWF does not waive the privileges and immunities 
c granted to it by virtue of its status as an intergovernmental organisation 
c nor does it submit to any jurisdiction.
c

      SUBROUTINE GPFA(A,B,TRIGS,INC,JUMP,N,LOT,ISIGN)
*
*        SUBROUTINE 'GPFA'
*        SELF-SORTING IN-PLACE GENERALIZED PRIME FACTOR (COMPLEX) FFT
*
*        CALL GPFA(A,B,TRIGS,INC,JUMP,N,LOT,ISIGN)
*
*        A IS FIRST REAL INPUT/OUTPUT VECTOR
*        B IS FIRST IMAGINARY INPUT/OUTPUT VECTOR
*        TRIGS IS A TABLE OF TWIDDLE FACTORS, PRECALCULATED
*              BY CALLING SUBROUTINE 'SETGPFA'
*        INC IS THE INCREMENT WITHIN EACH DATA VECTOR
*        JUMP IS THE INCREMENT BETWEEN DATA VECTORS
*        N IS THE LENGTH OF THE TRANSFORMS:
*          -----------------------------------
*            N = (2**IP) * (3**IQ) * (5**IR)
*          -----------------------------------
*        LOT IS THE NUMBER OF TRANSFORMS
*        ISIGN = +1 FOR FORWARD TRANSFORM
*              = -1 FOR INVERSE TRANSFORM
*
*        WRITTEN BY CLIVE TEMPERTON ECMWF 1990
*
*----------------------------------------------------------------------
*
*        DEFINITION OF TRANSFORM
*        -----------------------
*
*        X(J) = SUM(K=0,...,N-1)(C(K)*EXP(ISIGN*2*I*J*K*PI/N))
*
*---------------------------------------------------------------------
*
*        FOR A MATHEMATICAL DEVELOPMENT OF THE ALGORITHM USED,
*        SEE:
*
*        C TEMPERTON : "A GENERALIZED PRIME FACTOR FFT ALGORITHM
*          FOR ANY N = (2**P)(3**Q)(5**R)",
*          SIAM J. SCI. STAT. COMP., MAY 1992.
*
*----------------------------------------------------------------------
*
      DIMENSION A(*), B(*), TRIGS(*)
      DIMENSION NJ(3)
*
*     DECOMPOSE N INTO FACTORS 2,3,5
*     ------------------------------
      NN = N
      IFAC = 2
*
      DO 30 LL = 1 , 3
      KK = 0
   10 CONTINUE
      IF (MOD(NN,IFAC).NE.0) GO TO 20
      KK = KK + 1
      NN = NN / IFAC
      GO TO 10
   20 CONTINUE
      NJ(LL) = KK
      IFAC = IFAC + LL
   30 CONTINUE
*
      IF (NN.NE.1) THEN
         WRITE(6,40) N
   40    FORMAT(' *** WARNING!!!',I10,' IS NOT A LEGAL VALUE OF N ***')
         RETURN
      ENDIF
*
      IP = NJ(1)
      IQ = NJ(2)
      IR = NJ(3)
*
*     COMPUTE THE TRANSFORM
*     ---------------------
      I = 1
      IF (IP.GT.0) THEN
         CALL GPFA2(A,B,TRIGS,INC,JUMP,N,IP,LOT,ISIGN)
         I = I + 2 * ( 2**IP)
      ENDIF
      IF (IQ.GT.0) THEN
         CALL GPFA3(A,B,TRIGS(I),INC,JUMP,N,IQ,LOT,ISIGN)
         I = I + 2 * (3**IQ)
      ENDIF
      IF (IR.GT.0) THEN
         CALL GPFA5(A,B,TRIGS(I),INC,JUMP,N,IR,LOT,ISIGN)
      ENDIF
*
      RETURN
      END

C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities
C granted to it by virtue of its status as an intergovernmental organisation
C nor does it submit to any jurisdiction.
C

      INTEGER FUNCTION IRGMEM (KPR, KERR)
C
C---->
C**** *IRGMEM*
C
C     PURPOSE
C     _______
C
C     This routine acquires heap space for quasi regular to regular
C     interpolation.
C
C     INTERFACE
C     _________
C
C     IERR = IRGMEM (KPR, KERR)
C
C     Input parameters
C     ________________
C
C     KPR        - The debug print switch.
C                  0  , No debugging output.
C                  1  , Produce debugging output.
C
C     KERR       - The error control flag.
C                  -ve, No error message. Return error code.
C                  0  , Hard failure with error message.
C                  +ve, Print error message. Return error code.
C
C     Output parameters
C     ________________
C
C     None
C
C     Return value
C     ____________
C
C     The error indicator (INTEGER).
C
C     Error and Warning Return Values
C     _______________________________
C
C     None
C
C     Common block usage
C     __________________
C
C     nifld.common - This file contains all the input field
C                    definition variables.
C
C     NINS         - Number of grid points in NS direction for input
C                    field (used in grspace.h).
C     NIWE         - Number of grid points in WE direction for input
C                    field (used in grspace.h).
C
C     nofld.common - This file contains all the output field
C                    definition variables.
C
C     NONS         - Number of grid points in NS direction for output
C                    field (used in grspace.h).
C     NOWE         - Number of grid points in WE direction for output
C                    field (used in grspace.h).
C
C     grspace.h    - This file contains all the work space array
C                    definitions for grid point to grid point
C                    interpolation.
C
C     GRID_POINT
C
C     NILATGP      - POINTER to array MILATG.
C     NILONGP      - POINTER to array MILONG.
C     NILSMP       - POINTER to array MILSM.
C     NINPNTP      - POINTER to array RINPNT.
C     NISTRTP      - POINTER to array MISTRT.
C     NNSDISTP     - POINTER to array MNSDIST.
C     NNSINDP      - POINTER to array MNSIND.
C     NMAXP        - POINTER to array RMAX.
C     NOLATGP      - POINTER to array MOLATG.
C     NOLONGP      - POINTER to array MOLONG.
C     NOLSMP       - POINTER to array MOLSM.
C     NWEDISTP     - POINTER to array MWEDIST.
C     NWEINDP      - POINTER to array MWEIND.
C     NWFACTP      - POINTER to array WFACT.
C
C     MILATG       - Dynamic array of length (NINS) (see nifld.common)
C                    which holds the values of the input field
C                    latitudes.
C     MILONG       - Dynamic array of length (NIWE + 1) (see
C                    nifld.common) which holds the values of the
C                    input field longitudes.
C     MILSM        - Dynamic array of length (NIWE, 2) (see
C                    nifld.common) used in calculating the effects of
C                    the land sea mask on interpolation.
C     MISTRT       - Dynamic array of length (NINS) (see nifld.common)
C                    which holds the array offsets of the start of
C                    each latitude line for a quasi regular Gaussian
C                    input field. No space is assigned to this array
C                    for a regular input field.
C     MNSDIST      - Dynamic array of length (2, NONS) (see
C                    nofld.common) which holds the distances to
C                    neighbouring latitude lines of the input field
C                    from the associated line of latitude in the
C                    output field.
C     MNSIND       - Dynamic array of length (2, NONS) (see
C                    nofld.common) which holds the latitude line
C                    numbers (array offset) of the input field
C                    associated with each line of latitude in the
C                    output field.
C     MOLATG       - Dynamic array of length (NONS) (see nofld.common)
C                    which holds the values of the output field
C                    latitudes.
C     MOLONG       - Dynamic array of length (NOWE) (see nofld.common)
C                    which holds the values of the output field
C                    longitudes.
C     MOLSM        - Dynamic array of length (NOWE) (see nofld.common)
C                    used in calculating the effects of the land sea
C                    mask on interpolation.
C     MWEDIST      - Dynamic array of length (2, NONS) (see
C                    nofld.common) for a regular input field and of
C                    length (2, 2 * NONS * NOWE) (see nofld.common)
C                    for a quasi regular Gaussian input field. This
C                    array holds the distances to neighbouring
C                    longitude points of the input field from the
C                    associated longitude points in the output field.
C     MWEIND       - Dynamic array of length (2, NONS) (see
C                    nofld.common) for a regular input field and of
C                    length (2, 2 * NONS * NOWE) (see nofld.common)
C                    for a quasi regular Gaussian input field. This
C                    array holds the longitude points (array offset)
C                    from the input field associated with each
C                    longitude point in the output field.
C     RINPNT       - Dynamic array of length (NOWE) (see nofld.common)
C                    used to aid vectorisation in processing
C                    precipitation fields.
C     RMAX         - Dynamic array of length (NOWE) (see nofld.common)
C                    used to aid vectorisation in processing
C                    precipitation fields.
C     WFACT        - Dynamic array of length (4, NOWE * NONS) (see
C                    nofld.common) which holds the interpolation
C                    weights for each point in the output field.
C
C     EXTERNALS
C     _________
C
C     IGALLOC    - Get a heap allocation for array space.
C     INTLOG(R)  - Logs messages.
C
C     METHOD
C     ______
C
C     This routine first calculates how much heap space is required.
C     IGALLOC is then used to acquire the required space. Finally the
C     POINTERs are initialised to allow use of the dynamic arrays.
C
C     REFERENCE
C     _________
C
C     None
C
C     COMMENTS
C     ________
C
C     Program contains sections 0 to 3 and 9
C
C     AUTHOR
C     ______
C
C     K. Fielding      *ECMWF*      Jan 1994
C
C     MODIFICATIONS
C     _____________
C
C     None
C
C----<
C     -----------------------------------------------------------------|
C*    Section 0. Definition of variables.
C     -----------------------------------------------------------------|
C
      IMPLICIT NONE
C
#include "parim.h"
#include "nifld.common"
#include "nofld.common"
#include "grspace.h"
C
C     Dummy arguments
C
      INTEGER*8 DELTA
      INTEGER*8 OFFSET

      INTEGER KPR, KERR
C
C     Local variables
C
#ifdef POINTER_64
      INTEGER*8 IBASE
#else
      INTEGER IBASE
#endif
      INTEGER IREQUEST, IERR
C
C     External functions
C
      INTEGER IGALLOC
C
C     -----------------------------------------------------------------|
C*    Section 1. Initialisation
C     -----------------------------------------------------------------|
C
  100 CONTINUE
C
      IF( KPR.GE.1 ) CALL INTLOG(JP_DEBUG,'IRGMEM: Section 1.',JPQUIET)
C
      IRGMEM = 0
C
C     -----------------------------------------------------------------|
C*    Section 2. Calculate memory required and get heap
C     -----------------------------------------------------------------|
C
  200 CONTINUE
C
      IF( KPR.GE.1 ) CALL INTLOG(JP_DEBUG,'IRGMEM: Section 2.',JPQUIET)
C
C     REAL arrays (This may change for double precision version)
C
      IREQUEST = 4 * NOWE * NONS * JPRLEN
C
C     Fields for precipitation calculations
C
      IREQUEST = IREQUEST + 2 * NOWE * JPRLEN
C
C     Fixed integer fields
C
      IREQUEST = IREQUEST + (NIWE + 1 + NINS + NOWE + 5 * NONS) *
     1  JPILEN
C
C     Reduced Gaussian input fields (These change for regular fields)
C
c     IREQUEST = IREQUEST + (8 * NOWE * NONS + NINS) * JPILEN
      IREQUEST = IREQUEST
     1  + JPILEN * (2 * NONS) * (4 * NOWE + 20)  ! account for RGG/octahedral
     2  + JPILEN * NINS
C
C     Fields for LSM calculations
C
      IREQUEST = IREQUEST + (2 * NIWE + NOWE) * JPILEN
C
C     Get the required memory
C
      IERR = IGALLOC (JPINNER, IREQUEST, IBASE, KPR, KERR)
C
      IF( IERR.GT.0 ) THEN
         IRGMEM = IERR
         GOTO 900
      ENDIF
C
C     -----------------------------------------------------------------|
C*    Section 3. Initialise base addresses for POINTER arrays
C     -----------------------------------------------------------------|
C
  300 CONTINUE
C
      IF( KPR.GE.1 ) CALL INTLOG(JP_DEBUG,'IRGMEM: Section 3.',JPQUIET)
C
C     REAL arrays first to ease conversion to DOUBLE PRECISION
C
      NWFACTP = IBASE
C
C     Precipitation REAL arrays
C
C     We are having trouble when using POINTER values in arithmetic
C     where we get overflow when we don't expect it. Like the POINTER
C     is interpreted as a 32-bit length value. For that reason we
C     calculate an OFFSET and add DELTA values to it before reading
C     its value out into the various base addresses which are then not
C     used again in further calculations.


      OFFSET = NWFACTP + 4 * NOWE * NONS * JPRLEN
      NMAXP = OFFSET
C      NMAXP = NWFACTP + 4 * NOWE * NONS * JPRLEN

      DELTA = NOWE * JPRLEN
      OFFSET = OFFSET + DELTA
      NINPNTP = OFFSET
C      NINPNTP = NMAXP + NOWE * JPRLEN

C
C     This offset may change if DOUBLE PRECISION
C
      DELTA = NOWE * JPRLEN
      OFFSET = OFFSET + DELTA
      NILONGP = OFFSET
C      NILONGP = NINPNTP + NOWE * JPRLEN

C
      DELTA = (NIWE + 1) * JPILEN
      OFFSET = OFFSET + DELTA
      NILATGP = OFFSET
C      NILATGP  = NILONGP + (NIWE + 1) * JPILEN

      DELTA = NINS * JPILEN
      OFFSET = OFFSET + DELTA
      NOLONGP = OFFSET
C      NOLONGP = NILATGP + NINS * JPILEN

      DELTA = NOWE * JPILEN
      OFFSET = OFFSET + DELTA
      NOLATGP = OFFSET
C      NOLATGP  = NOLONGP + NOWE * JPILEN

      DELTA = NONS * JPILEN
      OFFSET = OFFSET + DELTA
      NNSINDP = OFFSET
C      NNSINDP = NOLATGP + NONS * JPILEN

      DELTA = 2 * NONS * JPILEN
      OFFSET = OFFSET + DELTA
      NNSDISTP = OFFSET
C      NNSDISTP = NNSINDP + 2 * NONS * JPILEN

C
      DELTA = 2 * NONS * JPILEN
      OFFSET = OFFSET + DELTA
      NWEINDP = OFFSET
C      NWEINDP = NNSDISTP  + 2 * NONS * JPILEN

      DELTA = 4 * NOWE * NONS * JPILEN
      OFFSET = OFFSET + DELTA
      NWEDISTP = OFFSET
C      NWEDISTP = NWEINDP + 4 * NOWE * NONS * JPILEN

      DELTA = 4 * NOWE * NONS * JPILEN
      OFFSET = OFFSET + DELTA
      NISTRTP = OFFSET
C      NISTRTP  = NWEDISTP + 4 * NOWE * NONS * JPILEN

C
C     LSM arrays
C
      DELTA = NINS * JPILEN
      OFFSET = OFFSET + DELTA
      NILSMP = OFFSET
c      NILSMP = NISTRTP + NINS * JPILEN

      DELTA = 2 * NIWE * JPILEN
      OFFSET = OFFSET + DELTA
      NOLSMP = OFFSET
c      NOLSMP = NILSMP + 2 * NIWE * JPILEN

C
      IF( KPR.GE.1 ) THEN
        CALL INTLOG(JP_DEBUG,'IRGMEM: ************************',JPQUIET)
        CALL INTLOG(JP_DEBUG,'IRGMEM: * Some address values',JPQUIET)
        CALL INTLOG(JP_DEBUG,'IRGMEM: * may display overflowed',JPQUIET)
        CALL INTLOG(JP_DEBUG,'IRGMEM: * when printed to screen',JPQUIET)
        CALL INTLOG(JP_DEBUG,'IRGMEM: ************************',JPQUIET)
        CALL INTLOG(JP_DEBUG,'IRGMEM: Output base addresses.',JPQUIET)
        CALL INTLOG(JP_DEBUG,'IRGMEM: WFACT address = ',NWFACTP)
        CALL INTLOG(JP_DEBUG,'IRGMEM: RMAX address = ',NMAXP)
        CALL INTLOG(JP_DEBUG,'IRGMEM: RINPNT address = ',NINPNTP)
        CALL INTLOG(JP_DEBUG,'IRGMEM: Input long.address = ',NILONGP)
        CALL INTLOG(JP_DEBUG,'IRGMEM: Input lat.address = ',NILATGP)
        CALL INTLOG(JP_DEBUG,'IRGMEM: Output long.address = ',NOLONGP)
        CALL INTLOG(JP_DEBUG,'IRGMEM: Output lat.address = ',NOLATGP)
        CALL INTLOG(JP_DEBUG,'IRGMEM: NS offset address = ',NNSINDP)
        CALL INTLOG(JP_DEBUG,'IRGMEM: NS distance address = ',NNSDISTP)
        CALL INTLOG(JP_DEBUG,'IRGMEM: WE offset address = ',NWEINDP)
        CALL INTLOG(JP_DEBUG,'IRGMEM: WE distance address = ',NWEDISTP)
        CALL INTLOG(JP_DEBUG,'IRGMEM: Line start array addr.= ',NISTRTP)
        CALL INTLOG(JP_DEBUG,'IRGMEM: Input LSM address = ',NILSMP)
        CALL INTLOG(JP_DEBUG,'IRGMEM: Output LSM address = ',NOLSMP)

      ENDIF
C

C     -----------------------------------------------------------------|
C*    Section 9. Return to calling routine. Format statements
C     -----------------------------------------------------------------|
C
  900 CONTINUE
C
      IF( KPR.GE.1 ) CALL INTLOG(JP_DEBUG,'IRGMEM: Section 9.',JPQUIET)
C
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities
C granted to it by virtue of its status as an intergovernmental organisation
C nor does it submit to any jurisdiction.
C

      SUBROUTINE CODEPS( NAME,CHDATA,ILENCH,FPDATA,ILENFP,INDATA,ILENIN,
     X                   NBYTE,LGDATA,ILENLG,IB1PAR,IPSCOD,ILENPS,
     X                   IRSERV,NBIT,IWORD,IROUND,IERR)
C
C---->
C**** CODEPS - Pack pseudo-grib product.
C
C     Purpose.
C     --------
C
C     Packs character data and arrays of floating point, integer
C     and logical values in machine-independent pseudo-grib format.
C
C**   Interface.
C     ----------
C
C     CALL CODEPS( NAME,CHDATA,ILENCH,FPDATA,ILENFP,INDATA,ILENIN,
C    X                   NBYTE,LGDATA,ILENLG,IB1PAR,IPSCOD,ILENPS,
C    X                   IRSERV,NBIT,IWORD,IROUND,IERR)
C
C
C
C     Input Parameters.
C     -----------------
C
C     NAME    - 4 Letters (Code name for section 0).
C     CHDATA  - Character string (letters and figures only) (section 4).
C     ILENCH  - Length of this string (Maximum length is 600).
C               To indicate missing data ILENCH is made
C               negative and string is all spaces.
C     FPDATA  - Array of floating point values (section 4).
C     ILENFP  - Length of this array (number of data values to be coded)
C               To indicate missing data values, ILENFP is made
C               negative and all data values are set to 0.
C     INDATA  - Array of integer values (section 4).
C     ILENIN  - Length of this array (number of data values to be coded)
C               To indicate missing data values, ILENIN is made
C               negative and all data values are set to 0.
C     NBYTE   - Number of bytes (8-bit) needed for integers.
C     LGDATA  - Array of logical values (section 4).
C     ILENLG  - Length of this array (number of data values to be coded)
C               To indicate missing data values, ILENLG is made
C               negative and all data values are set .false.
C     IB1PAR  - Integer array of data definition information (section 1)
C     ILENPS  - Length of array IPSCOD in bytes.
C     IRSERV  - Number of bytes reserved in data section for future use.
C     NBIT    - Number of bits per computer word.
C     IROUND  - 0 , no rounding.
C               1 , round to nearest 120 octets.
C
C     Output Parameters.
C     -----------------
C
C     IPSCOD  - Data coded in pseudo-grib code.
C     ILENPS  - Length of this array.
C     IWORD   - Number of words occupied by coded data.
C     IERR    - Error indicator.
C                0, no error.
C               -1, number of bytes per integer exceeds
C                   word length, or maximum allowed, is 0
C                   or negative.
C               -2, output array too small to hold coded
C                   data values.
C               -3, currently undefined option selected.
C               -4, missing data field contains non-zero.
C                   ( space for missing character data,
C                   and .false. for logicals.)
C               -5, integer larger than field width has
C                   been encountered.
C               -6, character data contains other than
C                   letters, figures or spaces.
C                1, invalid originating centre.
C                2, invalid model identification.
C                3, invalid grid identification.
C                4, invalid section indicator flag
C                5, invalid parameter identifier.
C                6, invalid level type.
C                7, level description error.
C                8, date/time error.
C                9, invalid time unit or range.
C               10, indicator/number averaged error.
C
C
C     Externals.
C     ----------
C
C     SBYTE
C     SBYTES
C     CONFPA
C     PRTBIN
C     OFFSET
C
C
C     Comments.
C     ---------
C
C     Section 1 , data definition section (IB1PAR).
C
C     Word      Contents
C     ----      --------
C       1       Originating centre identifier.
C       2       Model identification.
C       3       Grid definition.
C       4       Flag (table 1)
C       5       Parameter identifier (code table 2).
C       6       Type of level (code table 3).
C      7-8      Value(s) of levels (code table 3).
C       9       Year of data
C      10       Month of data
C      11       Day of data
C      12       Hour of data
C      13       Minute of data
C      14       Time unit (code table 4).
C      15       Time range one
C      16       Time range two
C      17       Time range flag (code table 5).
C      18       Number averaged.
C
C     Code tables are those for WMO GRIB code.
C
C     Value(s) of level can occupy 2 words.
C     For a layer the first word defines the top
C     and the second the bottom of the layer.
C     For a single level, only the first word is used.
C
C     Elements not used or inapplicable should be set to 255.
C
C
C     Author.
C     -------
C
C     J.Hennessy   05.02.86
C
C
C     Modifications.
C     --------------
C
C     J.Hennessy   06.06.86
C                  19.08.86
C                  21.08.86
C
C     J.Hennessy   17.09.90
C     Lower case letters as well as the characters
C     _ - . , added.
C
C     J.D.Chambers    ECMWF    13.09.94
C     Inhibit abort if NOABORT = 1, use grbcom.h
C
C     J.D.Chambers    ECMWF    12.08.96
C     Call CONFP3 instead of CONFP.
C
C     J.D.Chambers    ECMWF    April 1998
C     Call CONFPA instead of CONFP3.
C     (Vectorization improvement from D.Dent).
C
C----<
C********************************************************************
C
      IMPLICIT NONE
C
C     Parameters
      INTEGER NTYPE, NCHAR
      PARAMETER (NTYPE=2)
      PARAMETER (NCHAR=67)
C
C     Subroutine arguments
      CHARACTER*4 NAME
      CHARACTER*(*) CHDATA
      INTEGER ILENCH, ILENFP, INDATA, ILENIN, NBYTE, ILENLG, IB1PAR
      INTEGER IPSCOD, ILENPS, IRSERV, NBIT, IWORD, IROUND, IERR
      REAL FPDATA
      LOGICAL     LGDATA
      DIMENSION FPDATA(*), INDATA(*), LGDATA(*)
      DIMENSION IPSCOD(*), IB1PAR(*)
C
C     Local variables
      CHARACTER*1 CHAR
      DIMENSION CHAR(NCHAR)
      INTEGER IBLOCK
      DIMENSION IBLOCK(24)
      INTEGER IASCII
      DIMENSION IASCII(NCHAR)
      CHARACTER*4 VNAME
      DIMENSION VNAME(NTYPE)
      INTEGER JPAR, JLEN
      DIMENSION JPAR(NTYPE),JLEN(NTYPE)
C
C
      DATA IASCII /65 ,66 ,67 ,68 ,69 ,70 ,71 ,72 ,73 ,74 ,75 ,76 ,77 ,
     X             78 ,79 ,80 ,81 ,82 ,83 ,84 ,85 ,86 ,87 ,88 ,89 ,90 ,
     X             48 ,49 ,50 ,51 ,52 ,53 ,54 ,55 ,56 ,57 ,32 ,
     X             97 ,98 ,99 ,100,101,102,103,104,105,106,107,108,109,
     X             110,111,112,113,114,115,116,117,118,119,120,121,122,
     X             95 ,46 ,44 ,45  /
C
      DATA CHAR   /'A','B','C','D','E','F','G','H','I','J','K','L','M',
     X             'N','O','P','Q','R','S','T','U','V','W','X','Y','Z',
     X             '0','1','2','3','4','5','6','7','8','9',' ' ,
     X             'a','b','c','d','e','f','g','h','i','j','k','l','m',
     X             'n','o','p','q','r','s','t','u','v','w','x','y','z',
     X             '_','.',',','-' /
C
      DATA VNAME  /'BUDG','TIDE'/
C
      DATA JLEN   / 6000 , 25320/
C
      DATA JPAR   / 128  , 127  /
C
C     SET MAXIMUM NUMBER OF BITS FOR INTEGER FIELDS.
      INTEGER ICMISS, KLENCH, I, IFMISS, KLENFP, IIMISS, KLENIN
      INTEGER ILMISS, KLENLG, IBITS, IBYTE, NVAL, IOFF, KTEMP
      INTEGER KERR, IPW, IPB, NEGSIN, MAXINT, ISIGN
CC    INTEGER IEXP, IMANT
      INTEGER NTRUE, J, LBIN, L, LNIL, KBITS, NUMBIT, N
C
#include "grbcom.h"
C
C
C     Clear error indicator.
      IERR = 0
C
C
C********************************************************************
C
C     Check for missing data indicators.
C
C********************************************************************
C
C     Character data.
C
      ICMISS = 0
      IF (ILENCH.LT.0) THEN
        KLENCH = -ILENCH
        ICMISS = 1
        DO 50 I=1,KLENCH
          IF (CHDATA(I:I).NE.' ') THEN
            IERR = -4
            WRITE(*,*) 'CODEPS: Invalid value in missing data field.'
            RETURN
          ENDIF
   50   CONTINUE
      ELSE
        KLENCH = ILENCH
      ENDIF
C
C     Floating point numbers.
C
      IFMISS = 0
      IF (ILENFP.LT.0) THEN
        KLENFP = - ILENFP
        IFMISS = 1
        DO 100 I=1,KLENFP
          IF (FPDATA(I).NE.0.) THEN
            IERR = -4
            WRITE(*,*) 'CODEPS: Invalid value in missing data field.'
            RETURN
          ENDIF
  100   CONTINUE
      ELSE
        KLENFP = ILENFP
      ENDIF
C
C     Integers.
C
      IIMISS = 0
      IF (ILENIN.LT.0) THEN
        KLENIN = - ILENIN
        IIMISS = 1
        DO 200 I=1,KLENIN
          IF (INDATA(I).NE.0) THEN
            IERR = -4
            WRITE(*,*) 'CODEPS: Invalid value in missing data field.'
            RETURN
          ENDIF
  200   CONTINUE
      ELSE
        KLENIN = ILENIN
      ENDIF
C
C     Logicals.
C
      ILMISS = 0
      IF (ILENLG.LT.0) THEN
        KLENLG = - ILENLG
        ILMISS = 1
        DO 300 I=1,KLENLG
          IF (LGDATA(I).NEQV..FALSE.) THEN
            IERR = -4
            WRITE(*,*) 'CODEPS: Invalid value in missing data field.'
            RETURN
          ENDIF
  300   CONTINUE
      ELSE
        KLENLG = ILENLG
      ENDIF
C
C
C
C********************************************************************
C
C     Check number of bytes for integer numbers.
C
C********************************************************************
C
      IBITS = NBYTE * 8
C
      IF (IBITS.GT.NBIT) THEN
        WRITE(*,*) 'CODEPS: Number of bits per data value ', IBITS
        WRITE(*,*) '        exceeds word length ', NBIT
        IERR = -1
        RETURN
      ENDIF
C
      IF (IBITS.LE.0) THEN
        WRITE(*,*) 'CODEPS: Maximum permitted value ', IBITS
        WRITE(*,*) '        should be positive.'
        IERR = -1
        RETURN
      ENDIF
C
C
C********************************************************************
C
C     Section 0 - INDICATOR Section.
C
C********************************************************************
C
C
C     The letters of the code name are inserted in the
C     first 4 elements of 'IBLOCK'.
      DO 400 I=1,36
         IF (NAME(1:1).EQ.CHAR(I)) IBLOCK(1) = IASCII(I)
         IF (NAME(2:2).EQ.CHAR(I)) IBLOCK(2) = IASCII(I)
         IF (NAME(3:3).EQ.CHAR(I)) IBLOCK(3) = IASCII(I)
         IF (NAME(4:4).EQ.CHAR(I)) IBLOCK(4) = IASCII(I)
  400 CONTINUE
C
C     Pack 4 8-bit fields in section 0 of coded array.
      IWORD = 1
      IBYTE = 8
      NVAL  = 4
      IOFF  = 0
      CALL SBYTES(IPSCOD(IWORD),IBLOCK(1),IOFF,IBYTE,0,NVAL)
      CALL OFFSET(IOFF,NVAL,IWORD,IBYTE,NBIT,ILENPS,IERR)
      IF (IERR.NE.0) RETURN
C
C
C********************************************************************
C
C     Section 1 - PRODUCT DEFINITION Section.
C
C********************************************************************
C
C
C     Length of section 1 (in octets) in first 3 octets.
      IBLOCK(1) = 0
      IBLOCK(2) = 0
      IBLOCK(3) = 24
C
C     Fourth octet reserved and set to 0.
      IBLOCK(4) = 0
C
C     Identification of centre
      IBLOCK(5) = IB1PAR(1)
      IF (IB1PAR(1).LT.1.OR.IB1PAR(1).GT.98) THEN
        IERR = 1
        WRITE(*,*) 'CODEPS: Invalid originating centre ', IB1PAR(1)
        RETURN
      ENDIF
C
C     Model identification
      IBLOCK(6) = IB1PAR(2)
      IF (IB1PAR(2).LT.1.OR.IB1PAR(2).GT.255) THEN
        IERR = 2
        WRITE(*,*) 'CODEPS: Invalid model identification ', IB1PAR(2)
        RETURN
      ENDIF
C
C     Grid definition
      IBLOCK(7) = IB1PAR(3)
      IF (IB1PAR(3).LT.1.OR.IB1PAR(3).GT.255) THEN
        IERR = 3
        WRITE(*,*) 'CODEPS: Invalid grid definition ', IB1PAR(3)
        RETURN
      ENDIF
C
C     Optional section indicator flags ( code table 1 ).
C
C     Sections included  Binary value      Decimal value
C
C         NONE             00000000               0
C          2               10000000             128
C          3               01000000              64
C         2 AND 3          11000000             192
C
      IBLOCK(8) = IB1PAR(4)
C
C     Shift 2-bit flag field right by 6 bits to facilitate checking
      KTEMP = IB1PAR(4) / 64
      IF (KTEMP.NE.0) IERR = 4
      IF (IERR.NE.0) THEN
        CALL PRTBIN(IB1PAR(4),8,KTEMP,KERR)
        WRITE(*,*) 'CODEPS: Invalid section indicator flag ', KTEMP
        WRITE(*,*) 'CODEPS: Return code from PRTBIN = ', KERR
        RETURN
      ENDIF
C
C     Parameter identifier ( code table 2 ).
      IBLOCK(9) = IB1PAR(5)
      IF (IB1PAR(5).LT.0.OR.IB1PAR(5).GT.255) THEN
        IERR = 5
        WRITE(*,*) 'CODEPS: Invalid parameter ', IB1PAR(5)
        RETURN
      ENDIF
C
C     Indicator of level type ( code table 3 ).
      IBLOCK(10) = IB1PAR(6)
      IF (IB1PAR(6).LT.0.OR.IB1PAR(6).GT.255) THEN
        IERR = 6
        WRITE(*,*) 'CODEPS: Invalid level type ', IB1PAR(6)
        RETURN
      ENDIF
C
C     Description of level or layer ( code table 3 ).
C
C     For certain special levels no further description is
C     necessary, and the fields are set to 0.
C
      IF (((IB1PAR(6).LT.100).AND.(IB1PAR(6).NE.20)).OR.
     X     (IB1PAR(6).EQ.102) .OR.
     X     (IB1PAR(6).EQ.200) .OR.
     X     (IB1PAR(6).EQ.201)) THEN
        IB1PAR(7) = 0
        IB1PAR(8) = 0
      ENDIF
C
      IBLOCK(11) = IB1PAR(7)
      IBLOCK(12) = IB1PAR(8)
C
C     Certain level types require that the description occupy
C     both 8 bit fields.
C
      IF ((IB1PAR(6).EQ. 20).OR.
     X    (IB1PAR(6).EQ.100).OR.
     X    (IB1PAR(6).EQ.103).OR.
     X    (IB1PAR(6).EQ.105).OR.
     X    (IB1PAR(6).EQ.107).OR.
     X    (IB1PAR(6).EQ.109).OR.
     X    (IB1PAR(6).EQ.111).OR.
     X    (IB1PAR(6).EQ.113).OR.
     X    (IB1PAR(6).EQ.115).OR.
     X    (IB1PAR(6).EQ.117).OR.
     X    (IB1PAR(6).EQ.125).OR.
     X    (IB1PAR(6).EQ.160) ) THEN
C
C       8 low order bits in IBLOCK(12)
C       High order bits in IBLOCK(11)
        IBLOCK(12) = IBLOCK(11)
        IBLOCK(11) = IBLOCK(11) / 256
        IBLOCK(12) = IBLOCK(12) - IBLOCK(11) * 256
C
C       Check maximum possible in 16 bits not exceeded.
        IF (IB1PAR(7).GT.65535) IERR = 7
      ELSE
        IF (IB1PAR(7).GT.255.OR.IB1PAR(8).GT.255) IERR = 7
      ENDIF
C
      IF (IERR.NE.0) THEN
        WRITE(*,*) 'CODEPS: Level description error ', IB1PAR(7),
     X                                                  IB1PAR(8)
        RETURN
      ENDIF
C
C     Date and time
C     (Allow: YYYY format, years 1900 upto 2154
C      or       YY format, years   00 upto  254)
C
      IF( IB1PAR(9).GT.1900 ) THEN
        IBLOCK(13) = IB1PAR(9) - 1900
      ELSE
        IBLOCK(13) = IB1PAR(9)
      ENDIF
      IF (IBLOCK(13).LT.0.OR.IBLOCK(13).GT.254) IERR = 8
C
      IBLOCK(14) = IB1PAR(10)
      IF (IB1PAR(10).LT.1.OR.IB1PAR(10).GT.12) IERR = 8
      IBLOCK(15) = IB1PAR(11)
      IF (IB1PAR(11).LT.1.OR.IB1PAR(11).GT.31) IERR = 8
      IBLOCK(16) = IB1PAR(12)
      IF (IB1PAR(12).LT.0.OR.IB1PAR(12).GT.23) IERR = 8
      IBLOCK(17) = IB1PAR(13)
      IF (IB1PAR(13).LT.0.OR.IB1PAR(13).GT.59) IERR = 8
C
      IF (IERR.NE.0) THEN
        WRITE(*,9010) IB1PAR(9),IB1PAR(10),IB1PAR(11),IB1PAR(12),
     X                       IB1PAR(13)
 9010   FORMAT('CODEPS: Invalid date/time ',I4.4,2I2.2,' / ',2I2.2)
        RETURN
      ENDIF
C
C     Unit of time - ( code table 4 ).
C     Time range(s) and time range indicator ( code table 5 ).
C
C     Time unit.
      IBLOCK(18) = IB1PAR(14)
      IF (IB1PAR(14).LT.0.OR.IB1PAR(14).GT.7) IERR = 9
C
C     There can be one or two time ranges, each in 1 octect or
C     one time range in 2 octects.
      IF (IB1PAR(17).EQ.0.OR.
     X    IB1PAR(17).EQ.1.OR.
     X    IB1PAR(17).EQ.10)   IB1PAR(16)  = 0
C
C     Cross check range values and flag values.
      IF (IB1PAR(15).GT.65535.OR.IB1PAR(15).LT.0)   IERR = 9
      IF (IB1PAR(15).GT.255.AND.IB1PAR(17).NE.10)   IERR = 9
      IF (IB1PAR(16).GT.255.OR.IB1PAR(16).LT.0)     IERR = 9
      IF (IB1PAR(17).LT.0.OR.IB1PAR(17).GT.10)      IERR = 9
      IF (IERR.NE.0) THEN
        WRITE(*,9011) IB1PAR(14),IB1PAR(15),IB1PAR(16),IB1PAR(17)
 9011   FORMAT(1H ,'CODEPS: Time unit/Time 1/Time 2/indicator error - ',
     X                I8,2X,'/',I8,2X,'/',I8,2X,'/',I8)
        RETURN
      ENDIF
C
      IBLOCK(19) = IB1PAR(15)
      IBLOCK(20) = IB1PAR(16)
C
C     One time range occupying both octets.
      IF (IB1PAR(17).EQ.10) THEN
C
C       8 low order bits in IBLOCK(20)
C       High order bits in IBLOCK(19)
        IBLOCK(20) = IBLOCK(19)
        IBLOCK(19) = IBLOCK(19) / 256
        IBLOCK(20) = IBLOCK(20) - IBLOCK(19) * 256
      ENDIF
C
C     Time range indicator
      IBLOCK(21) = IB1PAR(17)
C
C     Number averaged.
      IBLOCK(22) = 0
      IBLOCK(23) = 0
C
C     Check consistency of indicator and number averaged fields.
      IF (IB1PAR(17).EQ.3.AND.IB1PAR(18).EQ.0) THEN
        IERR = 10
        WRITE(*,9012) IB1PAR(17),IB1PAR(18)
 9012   FORMAT(1H ,'CODEPS: Indicator/number averaged error - ',
     C                I8,2X,'/',I8)
        RETURN
      ENDIF
C
C     Value in two octets.
      IBLOCK(22) = IB1PAR(18)
C
C     8 low order bits in IBLOCK(23)
C     High order bits in IBLOCK(22)
      IBLOCK(23) = IBLOCK(22)
      IBLOCK(22) = IBLOCK(22) / 256
      IBLOCK(23) = IBLOCK(23) - IBLOCK(22) * 256
C
C     Reserved element.
      IBLOCK(24) = 0
C
C     Pack 24 8-bit fields of section 1 in coded array.
      IBYTE = 8
      NVAL = 24
      CALL SBYTES(IPSCOD(IWORD),IBLOCK(1),IOFF,IBYTE,0,NVAL)
      CALL OFFSET(IOFF,NVAL,IWORD,IBYTE,NBIT,ILENPS,IERR)
      IF (IERR.NE.0) RETURN
C
C     Set array IBLOCK to 0 . it is used to zero fill reserved octets.
      DO 500 I=1,24
         IBLOCK(I) = 0
  500 CONTINUE
C
C
C********************************************************************
C
C     Section 4 - BINARY DATA Section.
C
C********************************************************************
C
C
C     Octets 1-3 - length of data section (in octets).
C
C     Retain pointers to word and bit position of binary data
C     section length field. enter length as 0.
C
      IPW = IWORD
      IPB = IOFF
      CALL SBYTE(IPSCOD(IWORD),IBLOCK(1),IOFF,24)
      CALL OFFSET(IOFF,1,IWORD,24,NBIT,ILENPS,IERR)
      IF (IERR.NE.0) RETURN
C
C     Octet 4 is reserved.
      CALL SBYTE(IPSCOD(IWORD),IBLOCK(1),IOFF,8)
      CALL OFFSET(IOFF,1,IWORD,8,NBIT,ILENPS,IERR)
      IF (IERR.NE.0) RETURN
C
C     Octet 5 - missing data flag.
C
C     1---  missing character data
C     -1--  missing floating point data
C     --1-  missing integer data
C     ---1  missing logical data
C
      KTEMP = ICMISS*8 + IFMISS*4 + IIMISS*2 + ILMISS
      CALL SBYTE(IPSCOD(IWORD),KTEMP,IOFF,8)
      CALL OFFSET(IOFF,1,IWORD,8,NBIT,ILENPS,IERR)
      IF (IERR.NE.0) RETURN
C
C     Octet 6 - number of bytes per integer.
      CALL SBYTE(IPSCOD(IWORD),NBYTE,IOFF,8)
      CALL OFFSET(IOFF,1,IWORD,8,NBIT,ILENPS,IERR)
      IF (IERR.NE.0) RETURN
C
C     Octets 7-8 reserved.
      CALL SBYTES(IPSCOD(IWORD),IBLOCK(1),IOFF,8,0,2)
      CALL OFFSET(IOFF,2,IWORD,8,NBIT,ILENPS,IERR)
      IF (IERR.NE.0) RETURN
C
C     Octets 9-11 - number of characters in character data.
      CALL SBYTE(IPSCOD(IWORD),KLENCH,IOFF,24)
      CALL OFFSET(IOFF,1,IWORD,24,NBIT,ILENPS,IERR)
      IF (IERR.NE.0) RETURN
C
C     Octets 12-14 - number of floating point values
      CALL SBYTE(IPSCOD(IWORD),KLENFP,IOFF,24)
      CALL OFFSET(IOFF,1,IWORD,24,NBIT,ILENPS,IERR)
      IF (IERR.NE.0) RETURN
C
C     Octets 15-17 - number of integer values
      CALL SBYTE(IPSCOD(IWORD),KLENIN,IOFF,24)
      CALL OFFSET(IOFF,1,IWORD,24,NBIT,ILENPS,IERR)
      IF (IERR.NE.0) RETURN
C
C     Octets 18-20 - number of logicals
      CALL SBYTE(IPSCOD(IWORD),KLENLG,IOFF,24)
      CALL OFFSET(IOFF,1,IWORD,24,NBIT,ILENPS,IERR)
      IF (IERR.NE.0) RETURN
C
C     Octets 21-23 - number of bytes in data section reserved.
      CALL SBYTE(IPSCOD(IWORD),IRSERV,IOFF,24)
      CALL OFFSET(IOFF,1,IWORD,24,NBIT,ILENPS,IERR)
      IF (IERR.NE.0) RETURN
C
C     Octets 24-32 are reserved.
      CALL SBYTES(IPSCOD(IWORD),IBLOCK(1),IOFF,8,0,9)
      CALL OFFSET(IOFF,9,IWORD,8,NBIT,ILENPS,IERR)
      IF (IERR.NE.0) RETURN
C
C     Octet 33-   floating point numbers.
C
C     Convert values to pseudo-grib format (IEXP,IMANT)
C
      IF (KLENFP.NE.0)
     X  CALL CONFPA(FPDATA,KLENFP,IOFF,IPSCOD(IWORD),IWORD,ILENPS,NBIT)
C
C     Integer values
C
      IF (KLENIN.NE.0) THEN
C
C       Set up mask for negative numbers.
        NEGSIN = 2 ** (IBITS-1)
C
C       Maximum size integer in given field width.
        MAXINT = NEGSIN - 1
C
        DO 700 I=1,KLENIN
          KTEMP = INDATA(I)
C
C         Handle negative numbers.
          ISIGN = 0
          IF (KTEMP.LT.0) THEN
            KTEMP = - KTEMP
            ISIGN = NEGSIN
          ENDIF
C
C         Check size of numbers.
          IF (KTEMP.GT.MAXINT) THEN
            IERR = -5
            WRITE(*,*) 'CODEPS: Integer larger than field specified'
            RETURN
          ENDIF
C
C         Include sign bit.
          KTEMP = KTEMP + ISIGN
          CALL SBYTE(IPSCOD(IWORD),KTEMP,IOFF,IBITS)
          CALL OFFSET(IOFF,1,IWORD,IBITS,NBIT,ILENPS,IERR)
          IF (IERR.NE.0) RETURN
C
  700   CONTINUE
C
      ENDIF
C
C     Logical values
C
      IF (KLENLG.NE.0) THEN
        DO 800 I=1,KLENLG
          NTRUE = 0
          IF (LGDATA(I).EQV..TRUE.) NTRUE = 1
          CALL SBYTE(IPSCOD(IWORD),NTRUE,IOFF,8)
          CALL OFFSET(IOFF,1,IWORD,8,NBIT,ILENPS,IERR)
          IF (IERR.NE.0) RETURN
  800   CONTINUE
C
      ENDIF
C
C     Character data.
C
      IF (KLENCH.NE.0) THEN
        DO 850 I=1,KLENCH
          DO 825 J=1,NCHAR
            IF (CHDATA(I:I).EQ.CHAR(J)) THEN
              KTEMP = IASCII(J)
              CALL SBYTE(IPSCOD(IWORD),KTEMP,IOFF,8)
              CALL OFFSET(IOFF,1,IWORD,8,NBIT,ILENPS,IERR)
              IF (IERR.NE.0) RETURN
              GO TO 850
            ENDIF
  825     CONTINUE
          IERR = -6
          WRITE(*,*) 'CODEPS: Character data contains other than '
          WRITE(*,*) '         _ - . , letters, figures or spaces.'
          RETURN
  850   CONTINUE
      ENDIF
C
C     Reserved bytes
C
      IF (IRSERV.NE.0) THEN
        DO 900 I=1,IRSERV
          CALL SBYTE(IPSCOD(IWORD),IBLOCK(1),IOFF,8)
          CALL OFFSET(IOFF,1,IWORD,8,NBIT,ILENPS,IERR)
          IF (IERR.NE.0) RETURN
  900   CONTINUE
C
      ENDIF
C
C     Enter length of binary data section, having ensured that
C     the length is an even number of octets.
C
C     Length of binary data section in bits.
C
      LBIN = (IWORD-IPW) * NBIT + IOFF - IPB
      L = LBIN / 16
      L = LBIN - ( L*16 )
C
C     Fill unused portion of last 2 octets with binary zeroes.
      LNIL = 0
      IF (L.NE.0) THEN
        LNIL = 16 - L
        CALL SBYTE(IPSCOD(IWORD),IBLOCK(1),IOFF,LNIL)
        CALL OFFSET(IOFF,1,IWORD,LNIL,NBIT,ILENPS,IERR)
        IF (IERR.NE.0) RETURN
      ENDIF
      LBIN = (IWORD-IPW) * NBIT + IOFF - IPB
C
C     Enter length - in octets - of data section.
      LBIN = LBIN / 8
      CALL SBYTE(IPSCOD(IPW),LBIN,IPB,24)
      CALL OFFSET(IPB,1,IPW,24,NBIT,ILENPS,IERR)
C
C********************************************************************
C
C     Section 5 - END Section.
C
C********************************************************************
C
C
C     Add 7 7 7 7 to coded data.
      IBLOCK(1) = 55
      IBLOCK(2) = 55
      IBLOCK(3) = 55
      IBLOCK(4) = 55
      CALL SBYTES(IPSCOD(IWORD),IBLOCK(1),IOFF,8,0,4)
      CALL OFFSET(IOFF,4,IWORD,8,NBIT,ILENPS,IERR)
      IF (IERR.NE.0) RETURN
C
C     Set any unused part of last word to binary zeroes.
      IF (IOFF.NE.0) THEN
        KBITS = NBIT - IOFF
        CALL SBYTE(IPSCOD(IWORD),IBLOCK(1),IOFF,KBITS)
      ELSE
        IWORD = IWORD - 1
      ENDIF
C
C     Round to 120 octets, if required.
      IF (IROUND.EQ.1) THEN
        NUMBIT = IWORD * NBIT
        I = NUMBIT / 960
        I = I * 960
        I = NUMBIT - I
        IF (I.NE.0) I = (960 - I) / NBIT
        DO 1000 J=IWORD+1,IWORD+I
          IPSCOD(J) = 0
 1000   CONTINUE
C
        IWORD = IWORD + I
      ENDIF
C
C     Check consistency of record name, parameter number and
C     record length.
C
C     This may cause problems in the future if old
C     versions of the budget value records are unpacked
C     and then repacked.
C
C     Diagnostic records can have different lengths.
C
      IF (NAME.EQ.'DIAG') GO TO 9999
C
      N = (NBIT * IWORD) / 8
      KERR = 0
      DO 1100 I=1,NTYPE
        IF (VNAME(I).EQ.NAME) THEN
          IF (N.NE.JLEN(I)) KERR = 1
          IF (IB1PAR(5).NE.JPAR(I)) KERR = 1
          IF (KERR.NE.0) THEN
            WRITE(*,9013) N , IB1PAR(5)
 9013       FORMAT(1H ,'CODEPS: Illegal record length = ',I6,
     X      ' octets, or invalid parameter no. = ', I6,'.')
C
            IF( NOABORT .EQ. 0 ) CALL ABORT
          ENDIF
          GO TO 9999
        ENDIF
C
 1100 CONTINUE
C
      WRITE(*,*) 'CODEPS: Invalid record name supplied - ', NAME
      IF( NOABORT .EQ. 0 ) CALL ABORT
C
C
 9999 RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities
C granted to it by virtue of its status as an intergovernmental organisation
C nor does it submit to any jurisdiction.
C

        SUBROUTINE PBPSEU(KUNIT,KARRAY,KINLEN,KOUTLEN,KRET)
C
C---->
C**** PBPSEU
C
C     PURPOSE
C     _______
C
C     Reads next PSEUDO GRIB product from a file.
C
C     INTERFACE
C     _________
C
C     CALL PBPSEU(KUNIT,KARRAY,KINLEN,KOUTLEN,KRET)
C
C
C     Input parameters
C     ________________
C
C     KUNIT  - Unit number for the file returned from PBOPEN
C     KARRAY - FORTRAN array big enough to hold the PSEU product
C     KINLEN - Size in BYTES of the FORTRAN array
C
C
C     Output parameters
C     ________________
C
C     KOUTLEN - Size in BYTES of the PSEU product read
C     KRET    -  0  if a PSEU product has been successfully read
C               -1  if end-of-file is hit before a PSEU product is read
C               -3  if the size of KARRAY is not sufficient for the
C                   PSEU product
C
C
C     Common block usage
C     __________________
C
C     None.
C
C
C     Method
C     ______
C
C     Calls PSEUREAD.
C
C
C     Externals
C     _________
C
C     PSEUREAD - Read next PSEUDO GRIB product.
C
C
C     AUTHOR
C     ______
C
C     J.D.Chambers       ECMWF
C
C
C     MODIFICATIONS
C     _____________
C
C     None.
C
C******************************************************************************
C----<
C
C     Subroutine arguments
C
      INTEGER KARRAY(1)
      INTEGER KUNIT,KINLEN,KOUTLEN,KRET
C
C     Local argument(s)
C
      INTEGER NREAD, IRET
C
C     Get the PSEU product
C
      CALL PSEUREAD( KARRAY, KINLEN, NREAD, IRET, KUNIT )
C
C     Escape if the user buffer is too small to hold even the early sections of
C     the product or EOF encountered
C
      IF( IRET.EQ.-4 ) THEN
        KOUTLEN = NREAD
        KRET = -1
        RETURN
      ENDIF
C
C     Escape if no PSEU product is found in the file
C
      IF( IRET.EQ.-1 ) THEN
        KOUTLEN = 0
        KRET = -1
        RETURN
      ENDIF
C
C     Check if the array is big enough for the PSEU product
C
      IF( IRET.EQ.-3 ) THEN
        KOUTLEN = NREAD
        KRET = -3
        RETURN
      ENDIF
C
C     Set success code if product retrieved
C
      IF( NREAD.GE.0 )  THEN
        KOUTLEN = NREAD
        KRET = 0
      ENDIF
C
      RETURN
      END

C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE CREXS5(KBUFL,YBUFF,KERR)
C
C**** *CREXS5*
C
C
C     PURPOSE.
C     --------
C         Expand CREX section 5
C
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *CREXS5(KBUFL,YBUFF,KERR)*
C
C     METHOD.
C     -------
C
C          NONE.
C
C
C     EXTERNALS.
C     ----------
C
C          NONE.
C
C     REFERENCE.
C     ----------
C
C          NONE.
C
C     AUTHOR.
C     -------
C
C          MILAN DRAGOSAVAC    *ECMWF*       15/02/92.
C
C
C     MODIFICATIONS.
C     --------------
C
C          NONE.
C
C
      IMPLICIT LOGICAL(L,O,G), CHARACTER*8(C,H,Y)
C

      PARAMETER(JSUP =   9,JSEC0=   3,JSEC1= 40,JSEC2= 64 ,JSEC3=    4,
     1          JSEC4=   2,JELEM=40000,JSUBS=400,JCVAL=150 ,JBUFL=40000,
     2          JBPW =  32,JTAB =3000,JCTAB=120,JCTST=1800,JCTEXT= 200,
     3          JWORK=360000,JKEY=46)
C
      CHARACTER*(*) YBUFF
C
      RETURN
      END

C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      INTEGER FUNCTION IGLSMR (KILSMN, KILSMS, KOLSM, KNINDEX,
     1   KSINDEX, KOWE, PWFACT, KPR, KERR)
C
C---->
C**** *IGLSMR*
C
C     PURPOSE
C     -------
C
C     Calculate the effects of the land-sea masks for one line of
C     latitude on the unnormalised interpolation weights.
C
C     INTERFACE
C     ---------
C
C     IERR = IGLSMR (KILSMN, KILSMS, KOLSM, KNINDEX, KSINDEX,
C    1   KOWE, PWFACT, KPR, KERR)
C
C     Input parameters
C     ----------------
C
C     KILSMN     - The land sea mask for the line of latitude of the
C                  input field North of the output row.
C
C     KILSMS     - The land sea mask for the line of latitude of the
C                  input field South of the output row.
C
C     KOLSM      - The land sea mask for the current line of latitude
C                  of the output field.
C
C     KNINDEX    - This array contains the array offsets of the West
C                  and East points in the input line of latitude North
C                  of the current output field line of latitude.
C
C     KSINDEX    - This array contains the array offsets of the West
C                  and East points in the input line of latitude South
C                  of the current output field line of latitude.
C
C     KOWE       - The number of output field points in the West-East
C                  direction for this line of latitude.
C
C     PWFACT     - The array of interpolating weights to the four
C                  neighbouring points for every output point in this
C                  line of latitude.
C
C     KPR        - The debug print switch.
C                  0  , No debugging output.
C                  1  , Produce debugging output.
C
C     KERR       - The error control flag.
C                  -ve, No error message. Return error code.
C                  0  , Hard failure with error message.
C                  +ve, Print error message. Return error code.
C
C     Output parameters
C     ________________
C
C     PWFACT     - The modified array of interpolating weights to the
C                  four neighbouring points for every output point in
C                  this line of latitude.
C
C     Return value
C     ------------
C
C     The error indicator (INTEGER).
C
C     Error and Warning Return Values
C     _______________________________
C
C     None
C
C     Common block usage
C     __________________
C
C     None
C
C     Externals
C     ---------
C
C     INTLOG(R) - Logs messages.
C
C
C     Method
C     ------
C
C     Every time that a point in the input array has a land-sea mask
C     value (0-1) that does not match the corresponding output point
C     its interpolating value is multiplied by a scaling factor
C     (currently 0.2). This reduces the influence of such points on
C     the final interpolation.
C
C     The parameter list is designed to allow for quasi regular input
C     fields with different grid spacing in the Northern and Southern
C     lines of latitude.
C
C
C     Reference
C     ---------
C     None
C
C
C     Comments
C     --------
C     None
C
C
C     AUTHOR
C     ------
C     K. Fielding      *ECMWF*      Oct 1993
C
C
C     Modifications
C     -------------
C
C     None
C
C----<
C
C     -----------------------------------------------------------------|
C*    Section 0. Definition of variables.
C     -----------------------------------------------------------------|
C
C
      IMPLICIT NONE
C
#include "parim.h"
C
C     Dummy arguments
      INTEGER KOWE, KPR, KERR
      INTEGER KNINDEX (2, KOWE), KSINDEX (2, KOWE)
      INTEGER KILSMN (*), KILSMS (*), KOLSM (KOWE)
      REAL PWFACT (4, KOWE)
C
C     Local variables
      INTEGER JOLON
C
C     Multiplication factor for unlike land-sea masks
C
      REAL PPLSM
      PARAMETER (PPLSM = 0.2E0)
C
      INTEGER JPROUTINE
      PARAMETER (JPROUTINE = 25300)
C
C     -----------------------------------------------------------------|
C*    Section 1. Initialisation
C     -----------------------------------------------------------------|
C
  100 CONTINUE
C
      IF( KPR.GE.1 ) CALL INTLOG(JP_DEBUG,'IGLSMR: Section 1.',JPQUIET)
C
      IGLSMR = 0
C
      IF (KPR .GE. 1) 
     X  CALL INTLOG(JP_DEBUG,'IGLSMR: No. of output longitudes = ',KOWE)
C
C     -----------------------------------------------------------------|
C*    Section 2. Calculate arrays of weights
C     -----------------------------------------------------------------|
C
  200 CONTINUE
C
      IF (KPR.GE.1) CALL INTLOG(JP_DEBUG,'IGLSMR: Section 2.',JPQUIET)
C
C     Now modify the unormalised weight for land-sea mask
C
      DO 210 JOLON = 1, KOWE
C
         IF (KILSMN (KNINDEX (JP_I_W, JOLON)) .NE.
     1      KOLSM (JOLON) )
     2         PWFACT (JP_I_NW, JOLON) =
     3            PWFACT (JP_I_NW, JOLON) * PPLSM
C
         IF (KILSMN (KNINDEX (JP_I_E, JOLON)) .NE.
     1      KOLSM (JOLON) )
     2         PWFACT (JP_I_NE, JOLON) =
     3            PWFACT (JP_I_NE, JOLON) * PPLSM
C
         IF (KILSMS (KSINDEX (JP_I_W, JOLON)) .NE.
     1      KOLSM (JOLON) )
     2         PWFACT (JP_I_SW, JOLON) =
     3            PWFACT (JP_I_SW, JOLON) * PPLSM
C
         IF (KILSMS (KSINDEX (JP_I_E, JOLON)) .NE.
     1      KOLSM (JOLON) )
     2         PWFACT (JP_I_SE, JOLON) =
     3            PWFACT (JP_I_SE, JOLON) * PPLSM
C
  210 CONTINUE
C
C     -----------------------------------------------------------------|
C*    Section 9. Return to calling routine. Format statements
C     -----------------------------------------------------------------|
C
  900 CONTINUE
C
      IF( KPR.GE.1 ) CALL INTLOG(JP_DEBUG,'IGLSMR: Section 9.',JPQUIET)
C
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

       SUBROUTINE RPHI( DATA, NM, WORK, SLON)
C
C---->
C**** RPHI
C
C     Purpose
C     -------
C
C     Rotates spectral coefficients by longitude.
C
C
C     Interface
C     ---------
C
C     CALL RPHI(DATA,NM,WORK,SLON)
C
C     Input
C     -----
C
C     DATA   = Input spectral field of REAL*8s of size (NM+1)*(NM+2).
C     NM     = Triangular truncation (e.g. 106)
C     WORK   = Work space of size at least 2*(NM+1).
C     SLON   = Rotation angle (REAL*8).
C              (degrees, positive => rotate west to east). 
C
C     Output
C     ------
C
C     Transformed fields are returned in data.
C
C
C     Method
C     ------
C
C     See reference below.
C
C
C     Externals
C     ---------
C
C     None.
C
C
C     Author
C     ------
C
C     R.McGrath and P.Lynch    HIRLAM
C
C
C     Reference.
C     ----------
C
C     "Spectral synthesis on rotated and regular grids"
C     by P.Lynch and R.McGrath (Irish Meteorological Service).
C
C
C     Modifications
C     -------------
C
C     J.D.Chambers       ECMWF     October 1995
C     Reformat and put into clearcase.
C
C ------------------------------------------------------------------
C----<
C
      IMPLICIT NONE
C
#include "jparams.h"
C
C     Function arguments
      COMPLEX*16 DATA
      COMPLEX*16 WORK
      DIMENSION DATA(*), WORK(*)
      REAL*8 SLON
      INTEGER NM
C
C     Parameters
      INTEGER JPROUTINE
      PARAMETER (JPROUTINE = 26000 )
C
C     Local variables
      COMPLEX*16 CC
      INTEGER IPMN, NS, M, J
      REAL*8 RAD, XLON
C
C ------------------------------------------------------------------
C*    Section 1.   Initialise
C ------------------------------------------------------------------
C
  100 CONTINUE
C
      IPMN = ((NM+1)*(NM+2))/2
      RAD  = 180.0/PPI
      XLON = -SLON/RAD
C
C ------------------------------------------------------------------
C*    Section 2.   Transform the fields.
C ------------------------------------------------------------------
C
  200 CONTINUE
C
      NS = 1
      CC = (1.0,0.0)
C
      DO 215 M = 1,NM+1
        DO 210 J = NS,NS+NM-M+1
          WORK(J) = CC
  210   CONTINUE
C
        NS = J
        CC = CEXP(CMPLX(0.0,REAL(XLON*M)))
  215 CONTINUE
C
C     Transform fields in output array.
        DO 220 J = 1,IPMN
          DATA(J) = WORK(J)*DATA(J)
  220   CONTINUE
C
C ------------------------------------------------------------------
C*    Section 9.   Return.
C ------------------------------------------------------------------
C
  900 CONTINUE
C
      RETURN
      END

C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities
C granted to it by virtue of its status as an intergovernmental organisation
C nor does it submit to any jurisdiction.
C

      INTEGER FUNCTION HIRLSM(L12PNT,OLDFLD,KOUNT,KGAUSS,AREA,
     X                        POLE,GRID,NEWFLD,KSIZE,NLON,NLAT)
C
C---->
C**** HIRLSM
C
C     Purpose
C     -------
C
C     This routine creates a rotated regular lat/long field from a
C     reduced gaussian field using 12-point horizontal interpolation
C     and land-sea masks.
C
C
C     Interface
C     ---------
C
C     IRET = HIRLSM(L12PNT,OLDFLD,KOUNT,KGAUSS,AREA,
C    X              POLE,GRID,NEWFLD,KSIZE,NLON,NLAT)
C
C
C     Input parameters
C     ----------------
C
C     L12PNT - Chooses between 12-point and 4-point interpolation
C              = .TRUE. for 12-point horizontal
C              = .FALSE. for 4-point
C     OLDFLD - Array of values from the (old) reduced gaussian field
C     KOUNT  - Number of values in OLDFLD
C     KGAUSS - Gaussian number of the reduced gaussian field
C     AREA   - Limits of output area (N/W/S/E)
C     POLE   - Pole of rotation (lat/long)
C     GRID   - Output lat/long grid increments (we/ns)
C     KSIZE  - The size of the output array to fill with the regular
C              lat/long field
C
C
C     Output parameters
C     -----------------
C
C     NEWFLD  - The array of values for the regular lat/long field
C     NLON    - Number of longitudes in the regular lat/long field
C     NLAT    - Number of latitudes in the regular lat/long field
C
C     Returns 0 if function successful, non-zero otherwise.
C
C     Common block usage
C     ------------------
C
C     nifld.common
C     nofld.common
C
C
C     Method
C     ------
C
C     Numbering of the points (I is the interpolation point):
C
C                   13       5       6      14
C
C                    7       1       2       8
C                               (I)
C                    9       3       4      10
C
C                   15      11      12      16
C
C     The 12-point interpolation is not possible if either of the top
C     two rows is above the original field northern latitude. The
C     nearest neighbour is used if both rows are above, and a 4-pt
C     bilinear interpolation is used if the top row is above.
C     Similarily, if either of the bottom two rows is below the original
C     field southern latitude.
C
C
C     Externals
C     ---------
C
C     INTLOG  - Log error message.
C     JMALLOC - Dynamically allocate memory
C     JFREE   - Free dynamically allocated memory
C     JGETGG  - Reads the definition of a gaussian grid
C     HGENGRD - Calculates original lat/long (before rotation) for
C               a rotated grid
C     HNEI12  - Finds neighbours for points for interpolation
C     HWTS12  - Calculates weightings for points for interpolation
C     CHKPREC - Check if precipitation threshold has been redefined
C     HWTSLSM - Calculates LSM weightings for points for interpolation
C     HGETLSM - Reads values for gaussian land-sea mask
C
C
C     Reference
C     ---------
C
C     None.
C
C
C     Comments
C     --------
C
C     None.
C
C
C     Author
C     ------
C
C     J.D.Chambers      ECMWF      January 2001
C
C
C     Modifications
C     -------------
C
C     None.
C
C----<
C     -----------------------------------------------------------------|
C*    Section 0. Definition of variables.
C     -----------------------------------------------------------------|
C
      IMPLICIT NONE
C
#include "parim.h"
#include "nifld.common"
#include "nofld.common"
C
C     Parameters
C
      INTEGER JNORTH, JSOUTH, JWEST, JEAST, JW_E, JN_S, JLAT, JLON
      INTEGER JP12PT, JP4PT, JPNEARN
      PARAMETER (JP12PT  = 0)
      PARAMETER (JP4PT   = 1)
      PARAMETER (JPNEARN = 2)
      PARAMETER (JNORTH = 1 )
      PARAMETER (JWEST  = 2 )
      PARAMETER (JSOUTH = 3 )
      PARAMETER (JEAST  = 4 )
      PARAMETER (JW_E  = 1 )
      PARAMETER (JN_S  = 2 )
      PARAMETER (JLAT  = 1 )
      PARAMETER (JLON  = 2 )
C
C     Function arguments
C
      LOGICAL L12PNT
      INTEGER KOUNT, KGAUSS, KSIZE, NLON, NLAT
      REAL AREA(4), POLE(2), GRID(2)
      REAL OLDFLD(*), NEWFLD(KSIZE)
C
C     Local variables
C
      INTEGER NEXT, LOOP, IRET, NLEN, NBYTES, NUMBER
      INTEGER NEAREST, NEND, COUNT
      INTEGER NJPR,  NJPB
      INTEGER NPREV
      INTEGER loop1, INUM
      INTEGER IOSIZE, INSIZE
      INTEGER NEWSIZE
      REAL OLDAREA(4), OLDPOLE(2), OLDGRID(2)
      REAL OLDLSM(1)
      POINTER (IPOLDLS, OLDLSM )
C
      LOGICAL LNEW, LFIRST
      INTEGER KSCHEME(1),NEIGH(12,1), KLA(1)
      REAL PWTS(12,1)
      POINTER (IPKSCHE, KSCHEME)
      POINTER (IPNEIGH, NEIGH)
      POINTER (IPKLA,   KLA)
      POINTER (IPPWTS,  PWTS)
      LOGICAL LVEGGY
      CHARACTER*12 YFLAG
      CHARACTER*12 Y1FLAG, Y2FLAG
      LOGICAL LNEWSPC, LOLDNEW, LSOIL, LITAL, LVEGGY2
      INTEGER KSCHEMEN(1)
      REAL PWTSN(12,1)
      POINTER (IPKSCHEN, KSCHEMEN)
      POINTER (IPPWTSN,  PWTSN)
C
      REAL PDLO0(1),PDLO1(1),PDLO2(1),PDLO3(1),PDLAT(1)
      POINTER (IPPDLO0, PDLO0)
      POINTER (IPPDLO1, PDLO1)
      POINTER (IPPDLO2, PDLO2)
      POINTER (IPPDLO3, PDLO3)
      POINTER (IPPDLAT, PDLAT)
C
      INTEGER IGG, IGGOLD
      INTEGER KPTS(1)
      REAL GLATS(1)
      INTEGER IOFFS(1)
      POINTER (IPKPTS,  KPTS)
      POINTER (IPIOFFS, IOFFS)
      POINTER (IPGLATS, GLATS)
C
      INTEGER ILL, ILLOLD
      REAL RLAT(1),RLON(1)
      POINTER (IPRLAT, RLAT)
      POINTER (IPRLON, RLON)
C
      REAL OLD(KOUNT)
C
      CHARACTER*7 FUNCNAME
      PARAMETER  (FUNCNAME = 'HIRLSM ')
C
      DATA IGGOLD/-1/, ILLOLD/-1/
      DATA NUMBER/-1/
      DATA LNEW/.FALSE./, LFIRST/.TRUE./
      DATA NPREV/-1/
C
      REAL NEWLSM(1)
      POINTER (IPNEWLS, NEWLSM)
      DATA OLDAREA/4*-1.0/, OLDPOLE/2*-1.0/, OLDGRID/2*-1.0/
      DATA IOSIZE/-1/, INSIZE/-1/
      DATA IPNEWLS/0/, IPOLDLS/0/
C
      SAVE LNEW, LFIRST
      SAVE IPKSCHE, IPNEIGH, IPKLA, IPPWTS
      SAVE IPPDLO0, IPPDLO1, IPPDLO2, IPPDLO3, IPPDLAT
      SAVE IGGOLD, IPKPTS, IPIOFFS, IPGLATS
      SAVE ILLOLD, IPRLAT, IPRLON
      SAVE NUMBER
      SAVE NPREV
      SAVE IOSIZE, INSIZE, IPNEWLS, IPOLDLS, IPPWTSN,IPKSCHEN
      SAVE OLDAREA, OLDPOLE, OLDGRID
C
C     Externals
C
      INTEGER HNEI12
      INTEGER HGENGRD
      INTEGER HGETLSM
#ifdef POINTER_64
      INTEGER*8 JMALLOC
#else
      INTEGER JMALLOC
#endif
C
C     Statement functions
C
      REAL A, B
      LOGICAL NOTEQ
C
C     Tests that A is not (almost) equal to B
C
      NOTEQ(A,B) = (ABS((A)-(B)).GT.(ABS(A)*1E-3))
C
C     -----------------------------------------------------------------|
C     Section 1.  Initialise.
C     -----------------------------------------------------------------|
C
  100 CONTINUE
C
      HIRLSM = 0
C
      CALL JDEBUG()
C
      IF( L12PNT ) THEN
        CALL INTLOG(JP_DEBUG,FUNCNAME//': 12-pt interpolation',JPQUIET)
      ELSE
        CALL INTLOG(JP_DEBUG,FUNCNAME//': 4-pt interpolation',JPQUIET)
      ENDIF
C
      CALL CHKPREC()
      IF( LPREC )THEN
        CALL INTLOG(JP_DEBUG,
     X    FUNCNAME//': precipitation threshold applied',JPQUIET)
      ELSE
        CALL INTLOG(JP_DEBUG,
     X    FUNCNAME//': precipitation threshold not applied',JPQUIET)
      ENDIF


C     Set method based on environment variables
      CALL GETENV('NEAREST_NEIGHBOUR',     YFLAG)
      CALL GETENV('SOIL_PARAM',            Y1FLAG)
      CALL GETENV('NEAREST_NEIGHBOUR_NEW', Y2FLAG)    


C     Are we handling vegetation parameter
C     (force nearest neighbour processing with env variable or INTOUT)
      LVEGGY = (NITABLE.EQ.128).AND.
     X         ((NIPARAM.EQ.27).OR.
     X          (NIPARAM.EQ.28).OR.
     X          (NIPARAM.EQ.29).OR.
     X          (NIPARAM.EQ.30).OR.
     X          (NIPARAM.EQ.43) )
      IF( YFLAG(1:1).EQ.'1' ) LVEGGY = .TRUE.
      IF( LMETHOD )           LVEGGY = .TRUE.

C     
C     Fields with bitmap (as SST) and VEGGY Parameters are treated
C     with a corrected nearest neighbour method matching LSM
C     Force nearest neighbour for same type lsm processing
C      with INTOUT parameter
      LVEGGY2 = .FALSE.
      LSOIL   = .FALSE.  ! Special procesing for soil parameters
      LITAL   = .FALSE.
      IF( Y2FLAG(1:1).EQ.'1'.OR.LNNLSM ) THEN
C       envvar NEAREST_NEIGHBOUR_NEW=1, or
C       intout interpolation="nearest lsm"
        IF(LVEGGY) LVEGGY2 = .TRUE.
        LVEGGY = .FALSE.
        LITAL  = .TRUE.
      ELSEIF( Y1FLAG(1:1).EQ.'1' .AND. LVEGGY ) THEN
C       envvar SOIL_PARAM=1, and
C       ( vegetation parameter or
C         envvar NEAREST_NEIGHBOUR=1 or
C         intout interpolation="nearest neighbour" )
        LSOIL  = .TRUE.
        LVEGGY = .FALSE.
      ENDIF

      IF( LVEGGY ) CALL INTLOG(JP_DEBUG,
     X  FUNCNAME//': nearest neighbour processing: vegetation',JPQUIET)
      IF( LSOIL  ) CALL INTLOG(JP_DEBUG,
     X  FUNCNAME//': nearest neighbour processing: soil',      JPQUIET)
      IF( LITAL  ) CALL INTLOG(JP_DEBUG,
     X  FUNCNAME//': nearest neighbour processing: new',       JPQUIET)


C
C     Dynamically allocate memory for gaussian grid information.
C
      IGG = KGAUSS*2
      IF( IGG.GT.IGGOLD ) THEN
C
        IF( IGGOLD.GT.0 ) CALL JFREE(IPKPTS)
C
        NBYTES = (IGG*JPRLEN) + (2*IGG+1)*JPBYTES
C
        IPKPTS = JMALLOC(NBYTES)
#ifdef hpR64
        IPKPTS = IPKPTS/(1024*1024*1024*4)
#endif
        IF( IPKPTS.EQ.0 ) THEN
          CALL INTLOG(JP_ERROR,
     X      FUNCNAME//': Memory allocate fail',JPQUIET)
          HIRLSM = 1
          GOTO 900
        ENDIF
C
        IPGLATS = IPKPTS  + (IGG*JPBYTES)
        IPIOFFS = IPGLATS + (IGG*JPRLEN)
C
        IGGOLD = IGG
        NPREV = -1
C
      ENDIF
C
C     Has gaussian grid changed from last time through?
C
CC    LOLDNEW = (KGAUSS.NE.NPREV)  this forces reloading the LSM always!
      LOLDNEW = .TRUE.
C
C     Build up offsets to start of each latitude in original field(s)
C
      IF( LOLDNEW ) THEN
C
        CALL JGETGG(KGAUSS,'R',GLATS,KPTS,IRET)
        IF( IRET.NE.0 ) THEN
          CALL INTLOG(JP_ERROR,
     X      FUNCNAME//': JGETGG failed to get gaussian data',JPQUIET)
          HIRLSM = 2
          GOTO 900
        ENDIF
C
        IOFFS(1) = 1
        DO LOOP = 2, (KGAUSS*2+1)
          IOFFS(LOOP) = IOFFS(LOOP-1) + KPTS(LOOP-1)
        ENDDO
C
        NPREV = KGAUSS
      ENDIF
C
      NUMBER = (IOFFS(KGAUSS*2+1) - 1)
      IF( NUMBER.NE.KOUNT ) THEN
        CALL INTLOG(JP_ERROR,
     X    FUNCNAME//': Given number of points =',KOUNT)
        CALL INTLOG(JP_ERROR,
     X    FUNCNAME//': Expected number of pts =',NUMBER)
        HIRLSM = 4
        GOTO 900
      ENDIF
C
C     Preserve the input field
C     (in case OLDFLD and NEWFLD are the same arrays)
C
      DO LOOP = 1, NUMBER
        OLD(LOOP) = OLDFLD(LOOP)
      ENDDO
C
C     If old land-sea mask has changed, pick up different land-sea mask
C
      IF( LOLDNEW ) THEN
C
C       Allocate memory for old land-sea mask
C
        IF( IOSIZE.LT.(NUMBER*JPRLEN) ) THEN
          IOSIZE = NUMBER*JPRLEN
          IF( IPOLDLS.GT.0 ) CALL JFREE(IPOLDLS)
          IPOLDLS = JMALLOC(IOSIZE)
          IF( IPOLDLS.EQ.0 ) THEN
            CALL INTLOG(JP_ERROR,
     X        FUNCNAME//': Memory allocate fail',JPQUIET)
            HIRLSM = 4
            GOTO 900
          ENDIF
        ENDIF
C
C       Read values for different land-sea mask in memory
C
        NEWSIZE = NUMBER*JPRLEN
        IRET = HGETLSM(KGAUSS,OLDLSM,NEWSIZE)
Cs        IRET = HGETLSM(KGAUSS,OLDLSM,IOSIZE)

        IF( IRET.NE.0 ) THEN
          CALL INTLOG(JP_ERROR,
     X      FUNCNAME//': HGETLSM failed to get LSM data',JPQUIET)
          HIRLSM = 4
          GOTO 900
        ENDIF
      ENDIF
C
C     -----------------------------------------------------------------|
C     Section 2.  Generate the lat/long points for the output grid
C     -----------------------------------------------------------------|
C
  200 CONTINUE
C
C Sinisa put nint instead int (SC Aug-2005)
      NLON = 1 + NINT((AREA(JEAST) - AREA(JWEST)) / GRID(JW_E))
      NLAT = 1 + NINT((AREA(JNORTH) - AREA(JSOUTH)) / GRID(JN_S))
C
      NLEN = NLON * NLAT

      NOWE = NLON
      NONS = NLAT
C
C     Check that given array is big enough for the new field.
C
      IF( NLEN.GT.KSIZE ) THEN
        CALL INTLOG(JP_ERROR,FUNCNAME//': Given array size = ',KSIZE)
        CALL INTLOG(JP_ERROR,FUNCNAME//': Required size = = ',NLEN)
        HIRLSM = 5
        GOTO 900
      ENDIF
C
C     Dynamically allocate memory for lat/long arrays.
C
      ILL = NLEN
      IF( ILL.GT.ILLOLD ) THEN
C
        LNEW = .TRUE.
C
        IF( ILLOLD.GT.0 ) CALL JFREE(IPRLON)
C
        NBYTES = 2*ILL*JPRLEN
C
        IPRLON = JMALLOC(NBYTES)
#ifdef hpR64
        IPRLON = IPRLON/(1024*1024*1024*4)
#endif
        IF( IPRLON.EQ.0 ) THEN
          CALL INTLOG(JP_ERROR,
     X      FUNCNAME//': Memory allocate fail',JPQUIET)
          HIRLSM = 6
          GOTO 900
        ENDIF
C
        IPRLAT  = IPRLON + (ILL*JPRLEN)
C
        ILLOLD = ILL
C
      ENDIF
C
      IRET = HGENGRD(AREA,POLE,GRID,NLON,NLAT,RLAT,RLON)
      IF( IRET.NE.0 ) THEN
        CALL INTLOG(JP_ERROR,
     X    FUNCNAME//': HGENGRD failed to get lat/lon grid data',JPQUIET)
        HIRLSM = 7
        GOTO 900
      ENDIF
C
C     -----------------------------------------------------------------|
C     Section 3.  Find neighbours for each point for interpolation.
C     -----------------------------------------------------------------|
C
  300 CONTINUE
C
C     Dynamically allocate memory for interpolation arrays.
C
      IF( LNEW ) THEN
C
        IF( .NOT.LFIRST ) CALL JFREE(IPPDLO0)
C
        NJPR=17
        NJPB=14
        IF (LITAL.AND.L12PNT) THEN
          NJPR=29
          NJPB=15
        ENDIF
        NBYTES = (NJPR*JPRLEN + NJPB*JPBYTES) * ILL
C
        IPPDLO0 = JMALLOC(NBYTES)
#ifdef hpR64
        IPPDLO0 = IPPDLO0/(1024*1024*1024*4)
#endif
        IF( IPPDLO0.EQ.0 ) THEN
          CALL INTLOG(JP_ERROR,
     X      FUNCNAME//': Memory allocate fail',JPQUIET)
          HIRLSM = 8
          GOTO 900
        ENDIF
C
        IPPDLO1 = IPPDLO0 + (ILL*JPRLEN)
        IPPDLO2 = IPPDLO1 + (ILL*JPRLEN)
        IPPDLO3 = IPPDLO2 + (ILL*JPRLEN)
        IPPDLAT = IPPDLO3 + (ILL*JPRLEN)
        IPPWTS  = IPPDLAT + (ILL*JPRLEN)
        IPKSCHE = IPPWTS  + (12*ILL*JPRLEN)
        IPKLA   = IPKSCHE + (ILL*JPBYTES)
        IPNEIGH = IPKLA   + (ILL*JPBYTES)
        IF (LITAL.AND.L12PNT) THEN
          IPPWTSN  = IPNEIGH + (12*ILL*JPBYTES)
          IPKSCHEN = IPPWTSN  + (12*ILL*JPRLEN)
        ENDIF
C
        LFIRST = .FALSE.
        LNEW   = .FALSE.
C
      ENDIF
C
C     -----------------------------------------------------------------|
C     Section 4.  Create the new land-sea mask
C     -----------------------------------------------------------------|
C
  400 CONTINUE
C
C     Create new land-sea mask if specification has changed
C
      LNEWSPC = .FALSE.
      IF( AREA(1).NE.OLDAREA(1) ) LNEWSPC = .TRUE.
      IF( AREA(2).NE.OLDAREA(2) ) LNEWSPC = .TRUE.
      IF( AREA(3).NE.OLDAREA(3) ) LNEWSPC = .TRUE.
      IF( AREA(4).NE.OLDAREA(4) ) LNEWSPC = .TRUE.
      IF( GRID(1).NE.OLDGRID(1) ) LNEWSPC = .TRUE.
      IF( GRID(2).NE.OLDGRID(2) ) LNEWSPC = .TRUE.
      IF( POLE(1).NE.OLDPOLE(1) ) LNEWSPC = .TRUE.
      IF( POLE(2).NE.OLDPOLE(2) ) LNEWSPC = .TRUE.
C
      IF( .NOT.LNEWSPC ) GOTO 500
C
      OLDAREA(1) = AREA(1)
      OLDAREA(2) = AREA(2)
      OLDAREA(3) = AREA(3)
      OLDAREA(4) = AREA(4)
      OLDGRID(1) = GRID(1)
      OLDGRID(2) = GRID(2)
      OLDPOLE(1) = POLE(1)
      OLDPOLE(2) = POLE(2)
C
C     Allocate memory for new land-sea mask
C
      IF( INSIZE.LT.(NLEN*JPRLEN) ) THEN
        INSIZE = NLEN*JPRLEN
        IF( IPNEWLS.GT.0 ) CALL JFREE(IPNEWLS)
        IPNEWLS = JMALLOC(INSIZE)
        IF( IPNEWLS.EQ.0 ) THEN
          CALL INTLOG(JP_ERROR,
     X      FUNCNAME//': Memory allocation fail',JPQUIET)
          HIRLSM = 4
          GOTO 900
        ENDIF
      ENDIF
C
C     Find neighbours.
C     (Note: 4-point scheme is used for land-sea mask interpolation).
C
      IRET = HNEI12(.FALSE.,NLEN,RLAT,RLON,KGAUSS,KPTS,GLATS,
     X              KSCHEME,PDLAT,PDLO0,PDLO1,PDLO2,PDLO3,KLA,NEIGH)
      IF( IRET.NE.0 ) THEN
        CALL INTLOG(JP_ERROR,
     X    FUNCNAME//': HNEI12 failed to find neighbours',JPQUIET)
        HIRLSM = 9
        GOTO 900
      ENDIF
C
C     Perform the interpolation for the new land-sea mask.
C
      CALL HWTS12
     X  (NLEN,KSCHEME,KLA,PDLAT,GLATS,PDLO0,PDLO1,PDLO2,PDLO3,NEIGH,
     X   PWTS)
C
C     Calculate the interpolated grid point values
C
      DO LOOP = 1, NLEN
        IF( KSCHEME(LOOP).EQ.JP12PT ) THEN
          NEWLSM(LOOP) =
     X      OLDLSM(NEIGH( 1,LOOP)) * PWTS( 1,LOOP) +
     X      OLDLSM(NEIGH( 2,LOOP)) * PWTS( 2,LOOP) +
     X      OLDLSM(NEIGH( 3,LOOP)) * PWTS( 3,LOOP) +
     X      OLDLSM(NEIGH( 4,LOOP)) * PWTS( 4,LOOP) +
     X      OLDLSM(NEIGH( 5,LOOP)) * PWTS( 5,LOOP) +
     X      OLDLSM(NEIGH( 6,LOOP)) * PWTS( 6,LOOP) +
     X      OLDLSM(NEIGH( 7,LOOP)) * PWTS( 7,LOOP) +
     X      OLDLSM(NEIGH( 8,LOOP)) * PWTS( 8,LOOP) +
     X      OLDLSM(NEIGH( 9,LOOP)) * PWTS( 9,LOOP) +
     X      OLDLSM(NEIGH(10,LOOP)) * PWTS(10,LOOP) +
     X      OLDLSM(NEIGH(11,LOOP)) * PWTS(11,LOOP) +
     X      OLDLSM(NEIGH(12,LOOP)) * PWTS(12,LOOP)
C
        ELSE IF( KSCHEME(LOOP).EQ.JP4PT ) THEN
C
          NEWLSM(LOOP) =
     X      OLDLSM(NEIGH( 1,LOOP)) * PWTS( 1,LOOP) +
     X      OLDLSM(NEIGH( 2,LOOP)) * PWTS( 2,LOOP) +
     X      OLDLSM(NEIGH( 3,LOOP)) * PWTS( 3,LOOP) +
     X      OLDLSM(NEIGH( 4,LOOP)) * PWTS( 4,LOOP)
C
C
        ELSE
          DO NEXT = 1, 4
            IF( NEIGH(NEXT,LOOP).NE.0 )
     X        NEWLSM(LOOP) = OLDLSM(NEIGH(NEXT,LOOP))
          ENDDO
C
        ENDIF
C
      ENDDO

C
C     -----------------------------------------------------------------|
C     Section 5.  Perform the 12-point horizontal interpolation.
C     -----------------------------------------------------------------|
C
  500 CONTINUE
C
C     Fin neighbours.
C
      IRET = HNEI12(L12PNT,NLEN,RLAT,RLON,KGAUSS,KPTS,GLATS,
     X              KSCHEME,PDLAT,PDLO0,PDLO1,PDLO2,PDLO3,KLA,NEIGH)
      IF( IRET.NE.0 ) THEN
        CALL INTLOG(JP_ERROR,
     X    FUNCNAME//': HNEI12 failed to find neighbours',JPQUIET)
        HIRLSM = 5
        GOTO 900
      ENDIF
C
C     Setup the 12-point horizontal interpolation weights
C
      CALL HWTSLSM
     X  (NLEN,KSCHEME,KLA,PDLAT,GLATS,PDLO0,PDLO1,PDLO2,PDLO3,NEIGH,
     X   OLDLSM,NEWLSM,PWTS)
C
C     Calculate the interpolated grid point values
C
      IF (LITAL.AND.L12PNT) THEN
        DO LOOP = 1, NLEN
          IF (KSCHEME(LOOP).EQ.JP12PT) THEN
            KSCHEMEN(LOOP)=JP4PT
          ELSE
            KSCHEMEN(LOOP)=KSCHEME(LOOP)
          ENDIF
        ENDDO
        CALL HWTSLSM
     X  (NLEN,KSCHEMEN,KLA,PDLAT,GLATS,PDLO0,PDLO1,PDLO2,PDLO3,NEIGH,
     X   OLDLSM,NEWLSM,PWTSN)
      ENDIF

      DO LOOP = 1, NLEN
        IF( KSCHEME(LOOP).EQ.JP12PT ) THEN
C
C     See if any of the neighbours are missing
C
          COUNT = 0
          IF( NOTEQ(OLD(NEIGH( 1,LOOP)),RMISSGV) ) COUNT = COUNT + 1
          IF( NOTEQ(OLD(NEIGH( 2,LOOP)),RMISSGV) ) COUNT = COUNT + 1
          IF( NOTEQ(OLD(NEIGH( 3,LOOP)),RMISSGV) ) COUNT = COUNT + 1
          IF( NOTEQ(OLD(NEIGH( 4,LOOP)),RMISSGV) ) COUNT = COUNT + 1
          IF( NOTEQ(OLD(NEIGH( 5,LOOP)),RMISSGV) ) COUNT = COUNT + 1
          IF( NOTEQ(OLD(NEIGH( 6,LOOP)),RMISSGV) ) COUNT = COUNT + 1
          IF( NOTEQ(OLD(NEIGH( 7,LOOP)),RMISSGV) ) COUNT = COUNT + 1
          IF( NOTEQ(OLD(NEIGH( 8,LOOP)),RMISSGV) ) COUNT = COUNT + 1
          IF( NOTEQ(OLD(NEIGH( 9,LOOP)),RMISSGV) ) COUNT = COUNT + 1
          IF( NOTEQ(OLD(NEIGH(10,LOOP)),RMISSGV) ) COUNT = COUNT + 1
          IF( NOTEQ(OLD(NEIGH(11,LOOP)),RMISSGV) ) COUNT = COUNT + 1
          IF( NOTEQ(OLD(NEIGH(12,LOOP)),RMISSGV) ) COUNT = COUNT + 1
C
C         Interpolate using twelve neighbours if none are missing
C
        IF( LVEGGY) THEN
            NEAREST = 1
            IF( PWTS( 2,LOOP).GT.PWTS(NEAREST,LOOP) ) NEAREST = 2
            IF( PWTS( 3,LOOP).GT.PWTS(NEAREST,LOOP) ) NEAREST = 3
            IF( PWTS( 4,LOOP).GT.PWTS(NEAREST,LOOP) ) NEAREST = 4
            IF( PWTS( 5,LOOP).GT.PWTS(NEAREST,LOOP) ) NEAREST = 5
            IF( PWTS( 6,LOOP).GT.PWTS(NEAREST,LOOP) ) NEAREST = 6
            IF( PWTS( 7,LOOP).GT.PWTS(NEAREST,LOOP) ) NEAREST = 7
            IF( PWTS( 8,LOOP).GT.PWTS(NEAREST,LOOP) ) NEAREST = 8
            IF( PWTS( 9,LOOP).GT.PWTS(NEAREST,LOOP) ) NEAREST = 9
            IF( PWTS(10,LOOP).GT.PWTS(NEAREST,LOOP) ) NEAREST =10
            IF( PWTS(11,LOOP).GT.PWTS(NEAREST,LOOP) ) NEAREST =11
            IF( PWTS(12,LOOP).GT.PWTS(NEAREST,LOOP) ) NEAREST =12
            NEWFLD(LOOP) = OLD(NEIGH( NEAREST,LOOP))
        ELSE IF( LSOIL ) THEN
          IF(NEWLSM(LOOP).GE.0.5)THEN
            NEAREST = 1
            IF( PWTS( 2,LOOP).GT.PWTS(NEAREST,LOOP) .AND.
     X        (OLDLSM(NEIGH( 2,LOOP)).GE.0.5)) NEAREST =  2
            IF( PWTS( 3,LOOP).GT.PWTS(NEAREST,LOOP) .AND.
     X        (OLDLSM(NEIGH( 3,LOOP)).GE.0.5)) NEAREST =  3
            IF( PWTS( 4,LOOP).GT.PWTS(NEAREST,LOOP) .AND.
     X        (OLDLSM(NEIGH( 4,LOOP)).GE.0.5)) NEAREST =  4
            IF( PWTS( 5,LOOP).GT.PWTS(NEAREST,LOOP) .AND.
     X        (OLDLSM(NEIGH( 5,LOOP)).GE.0.5)) NEAREST =  5
            IF( PWTS( 6,LOOP).GT.PWTS(NEAREST,LOOP) .AND.
     X        (OLDLSM(NEIGH( 6,LOOP)).GE.0.5)) NEAREST =  6
            IF( PWTS( 7,LOOP).GT.PWTS(NEAREST,LOOP) .AND.
     X        (OLDLSM(NEIGH( 7,LOOP)).GE.0.5)) NEAREST =  7
            IF( PWTS( 8,LOOP).GT.PWTS(NEAREST,LOOP) .AND.
     X        (OLDLSM(NEIGH( 8,LOOP)).GE.0.5)) NEAREST =  8
            IF( PWTS( 9,LOOP).GT.PWTS(NEAREST,LOOP) .AND.
     X        (OLDLSM(NEIGH( 9,LOOP)).GE.0.5)) NEAREST =  9
            IF( PWTS(10,LOOP).GT.PWTS(NEAREST,LOOP) .AND.
     X        (OLDLSM(NEIGH(10,LOOP)).GE.0.5)) NEAREST = 10
            IF( PWTS(11,LOOP).GT.PWTS(NEAREST,LOOP) .AND.
     X        (OLDLSM(NEIGH(11,LOOP)).GE.0.5)) NEAREST = 11
            IF( PWTS(12,LOOP).GT.PWTS(NEAREST,LOOP) .AND.
     X        (OLDLSM(NEIGH(12,LOOP)).GE.0.5)) NEAREST = 12
          ELSE
            NEAREST = 1
            IF( PWTS( 2,LOOP).GT.PWTS(NEAREST,LOOP) .AND.
     X        (OLDLSM(NEIGH( 2,LOOP)).LT.0.5)) NEAREST =  2
            IF( PWTS( 3,LOOP).GT.PWTS(NEAREST,LOOP) .AND.
     X        (OLDLSM(NEIGH( 3,LOOP)).LT.0.5)) NEAREST =  3
            IF( PWTS( 4,LOOP).GT.PWTS(NEAREST,LOOP) .AND.
     X        (OLDLSM(NEIGH( 4,LOOP)).LT.0.5)) NEAREST =  4
            IF( PWTS( 5,LOOP).GT.PWTS(NEAREST,LOOP) .AND.
     X        (OLDLSM(NEIGH( 5,LOOP)).LT.0.5)) NEAREST =  5
            IF( PWTS( 6,LOOP).GT.PWTS(NEAREST,LOOP) .AND.
     X        (OLDLSM(NEIGH( 6,LOOP)).LT.0.5)) NEAREST =  6
            IF( PWTS( 7,LOOP).GT.PWTS(NEAREST,LOOP) .AND.
     X        (OLDLSM(NEIGH( 7,LOOP)).LT.0.5)) NEAREST =  7
            IF( PWTS( 8,LOOP).GT.PWTS(NEAREST,LOOP) .AND.
     X        (OLDLSM(NEIGH( 8,LOOP)).LT.0.5)) NEAREST =  8
            IF( PWTS( 9,LOOP).GT.PWTS(NEAREST,LOOP) .AND.
     X        (OLDLSM(NEIGH( 9,LOOP)).LT.0.5)) NEAREST =  9
            IF( PWTS(10,LOOP).GT.PWTS(NEAREST,LOOP) .AND.
     X        (OLDLSM(NEIGH(10,LOOP)).LT.0.5)) NEAREST = 10
            IF( PWTS(11,LOOP).GT.PWTS(NEAREST,LOOP) .AND.
     X        (OLDLSM(NEIGH(11,LOOP)).LT.0.5)) NEAREST = 11
            IF( PWTS(12,LOOP).GT.PWTS(NEAREST,LOOP) .AND.
     X        (OLDLSM(NEIGH(12,LOOP)).LT.0.5)) NEAREST = 12
          ENDIF
            NEWFLD(LOOP) = OLD(NEIGH( NEAREST,LOOP))
        ELSE
          IF( COUNT.EQ.12 .AND..NOT.LVEGGY2) THEN
            NEWFLD(LOOP) =
     X        OLD(NEIGH( 1,LOOP)) * PWTS( 1,LOOP) +
     X        OLD(NEIGH( 2,LOOP)) * PWTS( 2,LOOP) +
     X        OLD(NEIGH( 3,LOOP)) * PWTS( 3,LOOP) +
     X        OLD(NEIGH( 4,LOOP)) * PWTS( 4,LOOP) +
     X        OLD(NEIGH( 5,LOOP)) * PWTS( 5,LOOP) +
     X        OLD(NEIGH( 6,LOOP)) * PWTS( 6,LOOP) +
     X        OLD(NEIGH( 7,LOOP)) * PWTS( 7,LOOP) +
     X        OLD(NEIGH( 8,LOOP)) * PWTS( 8,LOOP) +
     X        OLD(NEIGH( 9,LOOP)) * PWTS( 9,LOOP) +
     X        OLD(NEIGH(10,LOOP)) * PWTS(10,LOOP) +
     X        OLD(NEIGH(11,LOOP)) * PWTS(11,LOOP) +
     X        OLD(NEIGH(12,LOOP)) * PWTS(12,LOOP)
C
C         Set missing if all neighbours are missing
C
          ELSE IF( COUNT.EQ.0 .AND..NOT.LVEGGY2) THEN
            NEWFLD(LOOP) = RMISSGV
C
C         Otherwise, use the nearest neighbour
C
          ELSE


      IF(LITAL)THEN     !land point
           IF(NEWLSM(LOOP).GE.0.5)THEN     !land point
            INUM=0
            DO NEXT=1,4
              IF(OLDLSM(NEIGH( NEXT,LOOP)).GE.0.5)THEN
                INUM=INUM+1
                IF( INUM.GE.2)THEN
                  IF(PWTSN( NEXT,LOOP).GT.PWTSN(NEAREST,LOOP)) THEN
                    NEAREST = NEXT
                  ENDIF
                ELSEIF( INUM.EQ.1) THEN
                  NEAREST = NEXT
                ENDIF
              ENDIF
            ENDDO

            ELSE  !sea point

            INUM=0
            DO NEXT=1,4
              IF(OLDLSM(NEIGH( NEXT,LOOP)).LT.0.5)THEN
                INUM=INUM+1
                IF( INUM.GE.2)THEN
                  IF(PWTSN( NEXT,LOOP).GT.PWTSN(NEAREST,LOOP)) THEN
                    NEAREST = NEXT
                  ENDIF
                ELSEIF( INUM.EQ.1) THEN
                  NEAREST = NEXT
                ENDIF
              ENDIF
            ENDDO

            ENDIF  !end if sea/land
       ELSE
            NEAREST = 1
            IF( PWTS( 2,LOOP).GT.PWTS(NEAREST,LOOP) ) NEAREST = 2
            IF( PWTS( 3,LOOP).GT.PWTS(NEAREST,LOOP) ) NEAREST = 3
            IF( PWTS( 4,LOOP).GT.PWTS(NEAREST,LOOP) ) NEAREST = 4
            IF( PWTS( 5,LOOP).GT.PWTS(NEAREST,LOOP) ) NEAREST = 5
            IF( PWTS( 6,LOOP).GT.PWTS(NEAREST,LOOP) ) NEAREST = 6
            IF( PWTS( 7,LOOP).GT.PWTS(NEAREST,LOOP) ) NEAREST = 7
            IF( PWTS( 8,LOOP).GT.PWTS(NEAREST,LOOP) ) NEAREST = 8
            IF( PWTS( 9,LOOP).GT.PWTS(NEAREST,LOOP) ) NEAREST = 9
            IF( PWTS(10,LOOP).GT.PWTS(NEAREST,LOOP) ) NEAREST =10
            IF( PWTS(11,LOOP).GT.PWTS(NEAREST,LOOP) ) NEAREST =11
            IF( PWTS(12,LOOP).GT.PWTS(NEAREST,LOOP) ) NEAREST =12
       ENDIF

            NEWFLD(LOOP) = OLD(NEIGH( NEAREST,LOOP))

          ENDIF
        ENDIF
C
        ELSE IF( KSCHEME(LOOP).EQ.JP4PT ) THEN
C
C     See if any of the neighbours are missing
C
          COUNT = 0
          IF( NOTEQ(OLD(NEIGH( 1,LOOP)),RMISSGV) ) COUNT = COUNT + 1
          IF( NOTEQ(OLD(NEIGH( 2,LOOP)),RMISSGV) ) COUNT = COUNT + 1
          IF( NOTEQ(OLD(NEIGH( 3,LOOP)),RMISSGV) ) COUNT = COUNT + 1
          IF( NOTEQ(OLD(NEIGH( 4,LOOP)),RMISSGV) ) COUNT = COUNT + 1
C
C         Interpolate using four neighbours if none are missing
C
        IF( LVEGGY) THEN

            NEAREST = 1
            IF( PWTS( 2,LOOP).GT.PWTS(NEAREST,LOOP) ) NEAREST = 2
            IF( PWTS( 3,LOOP).GT.PWTS(NEAREST,LOOP) ) NEAREST = 3
            IF( PWTS( 4,LOOP).GT.PWTS(NEAREST,LOOP) ) NEAREST = 4
            NEWFLD(LOOP) = OLD(NEIGH( NEAREST,LOOP))

        ELSE IF( LSOIL ) THEN

          IF(NEWLSM(LOOP).GE.0.5)THEN
C           land point
            NEAREST = 1
            IF( PWTS( 2,LOOP).GT.PWTS(NEAREST,LOOP) .AND.
     X        (OLDLSM(NEIGH( 2,LOOP)).GE.0.5)) NEAREST = 2
            IF( PWTS( 3,LOOP).GT.PWTS(NEAREST,LOOP) .AND.
     X        (OLDLSM(NEIGH( 3,LOOP)).GE.0.5)) NEAREST = 3
            IF( PWTS( 4,LOOP).GT.PWTS(NEAREST,LOOP) .AND.
     X        (OLDLSM(NEIGH( 4,LOOP)).GE.0.5)) NEAREST = 4
          ELSE
C           sea point
            NEAREST = 1
            IF( PWTS( 2,LOOP).GT.PWTS(NEAREST,LOOP) .AND.
     X        (OLDLSM(NEIGH( 2,LOOP)).LT.0.5)) NEAREST = 2
            IF( PWTS( 3,LOOP).GT.PWTS(NEAREST,LOOP) .AND.
     X        (OLDLSM(NEIGH( 3,LOOP)).LT.0.5)) NEAREST = 3
            IF( PWTS( 4,LOOP).GT.PWTS(NEAREST,LOOP) .AND.
     X        (OLDLSM(NEIGH( 4,LOOP)).LT.0.5)) NEAREST = 4
          ENDIF
          NEWFLD(LOOP) = OLD(NEIGH( NEAREST,LOOP))

        ELSE

          IF( COUNT.EQ.4 .AND. .NOT.LVEGGY2) THEN
            NEWFLD(LOOP) =
     X        OLD(NEIGH( 1,LOOP)) * PWTS( 1,LOOP) +
     X        OLD(NEIGH( 2,LOOP)) * PWTS( 2,LOOP) +
     X        OLD(NEIGH( 3,LOOP)) * PWTS( 3,LOOP) +
     X        OLD(NEIGH( 4,LOOP)) * PWTS( 4,LOOP)
C
C         Set missing if all neighbours are missing
C
          ELSE IF( COUNT.EQ.0 .AND. .NOT.LVEGGY2) THEN
            NEWFLD(LOOP) = RMISSGV
C
C         Otherwise, use the nearest neighbour
C
          ELSE

            IF(LITAL)THEN

              IF(NEWLSM(LOOP).GE.0.5)THEN
C               land point
                INUM=0
                DO NEXT=1,4
                  IF(OLDLSM(NEIGH( NEXT,LOOP)).GE.0.5)THEN
                    INUM=INUM+1
                    IF( INUM.GE.2)THEN
                      IF(PWTS( NEXT,LOOP).GT.PWTS(NEAREST,LOOP)) THEN
                        NEAREST = NEXT
                      ENDIF
                    ELSEIF( INUM.EQ.1) THEN
                      NEAREST = NEXT
                    ENDIF
                  ENDIF
                ENDDO
              ELSE
C               sea point
                INUM=0
                DO NEXT=1,4
                  IF(OLDLSM(NEIGH( NEXT,LOOP)).LT.0.5)THEN
                    INUM=INUM+1
                    IF( INUM.GE.2)THEN
                      IF(PWTS( NEXT,LOOP).GT.PWTS(NEAREST,LOOP)) THEN
                        NEAREST = NEXT
                      ENDIF
                    ELSEIF( INUM.EQ.1) THEN
                      NEAREST = NEXT
                    ENDIF
                  ENDIF
                ENDDO
              ENDIF

            ELSE

c             (.NOT. LITAL)
              NEAREST = 1
              IF( PWTS( 2,LOOP).GT.PWTS(NEAREST,LOOP) ) NEAREST = 2
              IF( PWTS( 3,LOOP).GT.PWTS(NEAREST,LOOP) ) NEAREST = 3
              IF( PWTS( 4,LOOP).GT.PWTS(NEAREST,LOOP) ) NEAREST = 4

            ENDIF

            NEWFLD(LOOP) = OLD(NEIGH( NEAREST,LOOP))
          ENDIF
       ENDIF
C
        ELSE
          DO NEXT = 1, 4
            IF( NEIGH(NEXT,LOOP).NE.0 )
     X        NEWFLD(LOOP) = OLD(NEIGH(NEXT,LOOP))
          ENDDO
C
        ENDIF
C
C       Remove precipitation if less than a 'trace' or if nearest
C       neighbour is less than a trace
C
        IF( LPREC ) THEN
          IF( NEWFLD(LOOP).LT.ZPRECIP ) THEN
            NEWFLD(LOOP) = 0.0
          ELSE
            NEAREST = 1
            NEND = 12
            IF( KSCHEME(LOOP).NE.JP12PT ) NEND = 4
            DO NEXT = 2, NEND
              IF( PWTS( NEXT,LOOP).GT.PWTS( NEAREST,LOOP) )
     X          NEAREST = NEXT
            ENDDO
            IF( OLD(NEIGH(NEAREST,LOOP)).LT.ZPRECIP ) NEWFLD(LOOP) = 0.0
          ENDIF
        ENDIF
C
C       For sea-ice cover, ensure no values are outside the range (0,1)
C
        IF( (NIPARAM.EQ.31).AND.(NITABLE.EQ.128) ) THEN
          IF( NOTEQ( NEWFLD(LOOP),RMISSGV) ) THEN
            IF( NEWFLD(LOOP).GT.1.0 ) NEWFLD(LOOP) = 1.0
            IF( NEWFLD(LOOP).LT.0.0 ) NEWFLD(LOOP) = 0.0
          ENDIF
        ENDIF
      ENDDO
C
C     -----------------------------------------------------------------|
C     Section 9.  Return.
C     -----------------------------------------------------------------|
C
  900 CONTINUE
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities
C granted to it by virtue of its status as an intergovernmental organisation
C nor does it submit to any jurisdiction.
C


      SUBROUTINE PRTBK2 (IB2PAR)
C
C---->
C
C     NAME      : PRTBK2
C
C     FUNCTION  : PRINT THE INFORMATION IN THE GRDI DEFINITION
C                 BLOCK (BLOCK 2) OF DECODED GRIB DATA.
C
C     INPUT     : IB2PAR - ARRAY OF DECODED PARAMETERS FROM BLOCK 2.
C
C     OUTPUT    : FLAG FIELDS ARE PRINTED IN BINARY REPRESENTATION.
C                 OTHER FIELDS AS INTEGERS.
C
C     JOHN HENNESSY  ECMWF OCTOBER 1985
C
C     Modifications.
C     --------------
C
C         J. Hennessy   ECMWF  23:11:90
C         Output changed from all upper-case.
C
C     ---------------------------------------------------------------
C----<
C
      IMPLICIT INTEGER (A-Z)
C
      DIMENSION IB2PAR(*)
C
      WRITE (*,'(1H )')
      WRITE (*,9000)
 9000 FORMAT (1H ,'Section 2 - Grid definition section.')
C
      WRITE (*,'(1H )')
      WRITE (*,9001) IB2PAR(1)
 9001 FORMAT (1H ,'Data representation type (Table 6)   ',I9)
C
C     SPHERICAL HARMONIC DATA
C
      IF (IB2PAR(1).EQ.50)
     C   THEN
C
             WRITE (*,9002) IB2PAR(2)
 9002        FORMAT (1H ,'J - Pentagonal resolution parameter. ',I9)
             WRITE (*,9003) IB2PAR(3)
 9003        FORMAT (1H ,'K - Pentagonal resolution parameter. ',I9)
             WRITE (*,9004) IB2PAR(4)
 9004        FORMAT (1H ,'M - Pentagonal resolution parameter. ',I9)
             WRITE (*,9005) IB2PAR(5)
 9005        FORMAT (1H ,'Representation type (Table 9)        ',I9)
             WRITE (*,9006) IB2PAR(6)
 9006        FORMAT (1H ,'Representation mode (Table 10).      ',I9)
             WRITE (*,9007) (IB2PAR(I),I=7,11)
 9007        FORMAT (1H ,'Not used.                            ',I9)
C
             RETURN
C
         ENDIF
C
C     GAUSSIAN AND REGULAR LATITUDE / LONGITUDE GRIDS.
C
      IF (IB2PAR(1).EQ.0.OR.IB2PAR(1).EQ.4)
     C   THEN
C
             WRITE (*,9102) IB2PAR(2)
 9102        FORMAT (1H ,'No. of points along a latitude.      ',I9)
             WRITE (*,9103) IB2PAR(3)
 9103        FORMAT (1H ,'No. of points along a meridian.      ',I9)
             WRITE (*,9104) IB2PAR(4)
 9104        FORMAT (1H ,'Latitude of origin.                  ',I9)
             WRITE (*,9200)
 9200        FORMAT (1H ,'(Southern latitudes are negative.)')
             WRITE (*,9105) IB2PAR(5)
 9105        FORMAT (1H ,'Longitude of origin.                 ',I9)
             WRITE (*,9201)
 9201        FORMAT (1H ,'(Western longitudes are negative.)')
             NBIT = 8
             CALL PRTBIN (IB2PAR(6),NBIT,OUT,ERR)
             WRITE (*,9106) OUT
 9106        FORMAT (1H ,'Resolution flag.                      ',I8.8)
             WRITE (*,9107) IB2PAR(7)
 9107        FORMAT (1H ,'Latitude of extreme point.           ',I9)
             WRITE (*,9200)
             WRITE (*,9108) IB2PAR(8)
 9108        FORMAT (1H ,'Longitude of extreme point.          ',I9)
             WRITE (*,9201)
             WRITE (*,9109) IB2PAR(9)
 9109        FORMAT (1H ,'East-West increment.                 ',I9)
             IF (IB2PAR(1).EQ.0)
     C          THEN
                    WRITE (*,9110) IB2PAR(10)
 9110               FORMAT (1H ,'North-South increment.               ',
     C                         I9)
                ENDIF
             IF (IB2PAR(1).EQ.4)
     C          THEN
                    WRITE (*,8110) IB2PAR(10)
 8110               FORMAT(1H ,'No. of latitude lines pole / equator.',
     C                         I9)
                ENDIF
             NBIT = 8
             CALL PRTBIN (IB2PAR(11),NBIT,OUT,ERR)
             WRITE (*,9111) OUT
 9111        FORMAT (1H ,'Scanning mode flags (Code Table 8)    ',I8.8)
C
             RETURN
C
         ENDIF
C
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      LOGICAL FUNCTION JACOBI(DATA,NM,W,SLAT)
C
C---->
C**** JACOBI
C
C     Purpose
C     -------
C
C     Rotates spectral fields by latitude.
C
C
C     Interface
C     ---------
C
C     IRET = JACOBI(DATA,NM,W,SLAT)
C
C     Input
C     -----
C
C     NM      - Triangular truncation number of the field.
C     DATA    - Linear array of REAL*8s of size (NM+1)*(NM+2)
C               holding the field.
C     W       - Work array of REAL*8s of size (NM+1)*(NM+2).
C     SLAT    - Rotation angle (degrees, REAL*8)
C              (degrees, negative => rotate counter-clockwise about the
C                                    new Z-axis).
C     
C
C     Output
C     ------
C
C     DATA    - The transformed field.
C
C     Function returns .FALSE. if data cannot be transformed.
C
C
C     Method
C     ------
C
C     See reference paper below.
C
C     A file of rotation coefficients is opened corresponding to
C     the triangular truncation NM and the rotation angle SLAT:
C
C           $PP_ROT_DIR/rot_coefs_Tttt_nnnnnnnnn
C     (or $SCRATCH/rot_coefs_Tttt_nnnnnnnnn,
C      or     $PWD/rot_coefs_Tttt_nnnnnnnnn)
C
C     where:
C            ttt =  triangular truncation
C      nnnnnnnnn =  SLAT*100000,
C     or
C           $PP_ROT_DIR/rot_coefs_Tttt_Mnnnnnnnn
C     (or $SCRATCH/rot_coefs_Tttt_Mnnnnnnnn,
C      or     $PWD/rot_coefs_Tttt_Mnnnnnnnn)
C
C     where:
C            ttt =  triangular truncation
C       nnnnnnnn =  -SLAT*100000 if SLAT is negative.
C
C     If the file does not exist it is created. During creation, the
C     filename is ROTpppppp_Tttt_nnnnnnnnn, where pppppp is the current
C     process ID.
C
C     The file of rotation coefficients is UNLINKed by the process after
C     being opened for reading. This causes the file to be removed when
C     the process terminates.
C
C
C     Externals
C     ---------
C
C     INTLOG  - Logs messages.
C     INTLOGR - Logs messages.
C     GETENV  - to get environment variable data.
C     GETPID  - to get the current process ID.
C     RENAME  - to change a filename.
C     UNLINK  - to remove a file.
C
C
C     Author
C     ------
C
C     R.McGrath and P.Lynch    HIRLAM
C
C
C     Reference.
C     ----------
C
C     "Spectral synthesis on rotated and regular grids"
C     by P.Lynch and R.McGrath (Irish Meteorological Service).
C     
C
C----<
C---------------------------------------------------------------------
C
      IMPLICIT NONE
C
#include "jparams.h"
#include "parim.h"
C
C     Function arguments.
C
      REAL*8 DATA, W
      DIMENSION DATA(*), W(*)
      INTEGER NM
      REAL*8 SLAT
C
C     Parameters.
C
      REAL*8 EPS
      PARAMETER(EPS = 1.0E-10)
      INTEGER JPNM_MAX
      PARAMETER( JPNM_MAX = 640 )
      INTEGER NPBYTES
      PARAMETER( NPBYTES = 8 )
C
C     Local variables.
C
#ifndef REAL_8
      REAL SSLAT
#endif
      LOGICAL LFOR
      INTEGER I, ISKIP, J, N, MM, K, IEND, IPLUG, IPID
      INTEGER NN, M, NDEX
      REAL*8 SIMAG, S, TEMP, DSLAT
      REAL*8 RAD, TANB, SINB, COSB, Q, RNKN, BNKN, SQNN
      REAL*8 SQNN1, SQ2N, PKN, PK1N, RNKN1, SREAL ,RNK0, RNK1
      REAL*8 WISQR(JPNM_MAX)
      REAL*8 WIB(JPNM_MAX)
      REAL*8 WIR(JPNM_MAX)
      REAL*8 WIDAT(2*JPNM_MAX)
      CHARACTER*256 FILEDUM
      CHARACTER*256 FILENAME
      CHARACTER*24 COEFILE
      DATA COEFILE/'rot_coefs_Tnnn_nnnnnnnnn'/
      INTEGER FIRST, IUNIT, IRET, ILAT, OLDLAT, OLDTRUN, IOFFSET
      INTEGER IFSIZE
      INTEGER NMP1TM, MINUS1
      DATA FIRST/0/, OLDLAT/10000000/, OLDTRUN/0/
      SAVE FIRST, IUNIT, ILAT, OLDLAT, OLDTRUN, FILENAME, COEFILE
C
C     Externals
C
#ifndef gfortran
      INTEGER GETPID, UNLINK, RENAME
      EXTERNAL GETPID, UNLINK, RENAME
#endif
C
C     Statement function
C
      REAL*8 A, B
      LOGICAL ABSCHK
      ABSCHK(A,B) = (ABS(A-B) .LT. EPS*(ABS(A) + ABS(B)))
C
C     W array: 1 -> (NM+1)*(NM+2) for PMN/SQRT(2*N+1) values.
C
C     RNKM values in WIR (for M>0),
C                 in WIB (M<0).
C     Array of temporary SQRT values in WISQR, and
C     temporary transformed data in WIDAT
C
C ------------------------------------------------------------------
C*    Section 1.   Initialise
C ------------------------------------------------------------------
C
  100 CONTINUE
C
      IOFFSET = 0
      JACOBI = .FALSE.
C
      CALL INTLOG(JP_DEBUG,'JACOBI: truncation = ', NM)
#ifndef REAL_8
      SSLAT = SNGL(SLAT)
      CALL INTLOGR(JP_DEBUG,'JACOBI: rotation angle = ', SSLAT)
#else
      CALL INTLOGR(JP_DEBUG,'JACOBI: rotation angle = ', SLAT)
#endif
C
C     Exit immediately if rotation angle is zero.
C
      IF (ABS(SLAT).LT.EPS) THEN
        JACOBI = .TRUE.
        GOTO 999
      ENDIF
C
C     Change to radians.
C
      RAD   = 180.0/PPI
      DSLAT = SLAT/RAD
      TANB  = TAN(DSLAT/(2.0))
      SINB  = SIN(DSLAT)
      COSB  = COS(DSLAT)
      Q     = SQRT(2.0)/2.0
C
C ------------------------------------------------------------------
C*    Section 2.   Generate PMN/SQRT(2*N+1) values in W.
C ------------------------------------------------------------------
C
  200 CONTINUE
C
      W(1)  = 1.0
      W(2)  = COSB
C
      ISKIP = NM + 1
      DO 210 I = 1,ISKIP
        W(1+ISKIP*I)   = W(1+ISKIP*I-ISKIP)*SINB*
     X                   SQRT(DBLE(2*I-1)/DBLE(2*I))
        W(1+ISKIP*I+1) = COSB*DSQRT(DBLE(2*I+1))*W(1+ISKIP*I)
  210 CONTINUE
C
      DO 220 I = 2,ISKIP-1
C
        DO 215 J = 0,ISKIP-I+1
          W(I+J*ISKIP+1) = COSB*DSQRT(DBLE((2*I+2*J-1)*(2*I+2*J-1))/
     X                     DBLE((I+2*J)*I))*W(I+J*ISKIP)
     X                     -    DSQRT(DBLE((I-1)*(I+2*J-1))/
     X                     DBLE((I+2*J)*I))*W(I+J*ISKIP-1)
  215   CONTINUE
C
  220 CONTINUE
C
C ------------------------------------------------------------------
C*    Section 3.   Generate the rotation coefficients RNKM.
C ------------------------------------------------------------------
C
  300 CONTINUE
C
C     Generate the rotation coefficients RNKM (K = M dashed in note)
C     and store in W.  For K = 0 special case.
C
C     PMN = W(M*(NM+1) + (N-M+1))
C
C     Hold the input latitude and check if it is the same as the one
C     used the last time through
C
      ILAT = NINT(SLAT*100000)
      IF( (ILAT.EQ.OLDLAT).AND.(OLDTRUN.EQ.NM) ) THEN
C
C       Rewind the existing open coefficients file.
C
        CALL PBSEEK(IUNIT,0,0,IRET)
        IF( IRET.NE.0 ) THEN
          CALL INTLOG(JP_FATAL,'JACOBI: Rewind failed.',JPQUIET)
          CALL PBCLOSE(IUNIT,IRET)
          JACOBI = .FALSE.
          GOTO 999
        ENDIF
C
      ELSE
C
C       A different coefficients file is needed.
C
        IF( FIRST.NE.0 ) THEN
          CALL PBCLOSE(IUNIT,IRET)
          IF( IRET.NE.0 ) THEN
            CALL INTLOG(JP_ERROR,'JACOBI: PBCLOSE failed.',JPQUIET)
            JACOBI = .FALSE.
          ENDIF
        ENDIF
        OLDLAT = ILAT
        OLDTRUN = NM
C
C       Setup the file name: rot_coefs_Tnnn_nnnnnnnnn
C       (Path is given by PP_ROT_DIR, SCRATCH, or PWD.)
C
        CALL GETENV('PP_ROT_DIR',FILENAME)
        IOFFSET = INDEX(FILENAME,' ')
        IF( IOFFSET.EQ.1) THEN
          CALL GETENV('SCRATCH',FILENAME)
          IOFFSET = INDEX(FILENAME,' ')
          IF( IOFFSET.EQ.1) THEN
            FILENAME = '.'
          ENDIF
        ENDIF
C
        IOFFSET = INDEX(FILENAME,' ')
        WRITE(COEFILE(12:14),'(I3.3)') NM
        IF( ILAT.GE.0) THEN
          WRITE(COEFILE(16:),'(I9.9)') ILAT
        ELSE
          COEFILE(16:) = 'M'
          WRITE(COEFILE(17:),'(I8.8)') -ILAT
        ENDIF
        FILENAME = FILENAME(1:IOFFSET-1) // '/' // COEFILE
C
        FILEDUM = FILENAME
        IPID = GETPID()
        IF( IPID.LT.0 ) THEN
          CALL INTLOG(JP_FATAL,'JACOBI: GETPID failed',JPQUIET)
          JACOBI = .FALSE.
          GOTO 999
        ENDIF
        IOFFSET = INDEX(FILENAME,' ')
        IPLUG = INDEX(FILENAME,'rot_coefs') + 3
        WRITE(FILEDUM(IPLUG:IPLUG+5),'(I6.6)') IPID
C
C       Try to open the file to see if it already exists
C
        CALL PBOPEN(IUNIT,FILENAME(1:IOFFSET-1),'r',IRET)
        IF( IRET.NE.0 ) THEN
          CALL INTLOG(JP_DEBUG,'JACOBI: PBOPEN for read failed',JPQUIET)
          CALL INTLOG(JP_DEBUG,'JACOBI: Non-existent file:',JPQUIET)
C
C         Set flag to show file does not exist
C
          FIRST = 0
C
        ELSE
C
C         File exists
C
          FIRST = 1
C
C         Unlink the file so it disappears on close
C
          FIRST = 1
          IRET = UNLINK(FILENAME(1:IOFFSET-1))
          IF( IRET.NE.0 ) THEN
            CALL INTLOG(JP_FATAL,'JACOBI: UNLINK failed',JPQUIET)
            JACOBI = .FALSE.
            GOTO 999
          ENDIF
C
C         Calculate the coefficients file size and check file is
C         the correct size (coefficients are REAL*8)
C
          IFSIZE = 8*(NM*(2*NM*NM + 9*NM +13)/3)
          CALL PBSEEK(IUNIT,0,2,IRET)
          IF( IRET.LT.0 ) THEN
            CALL INTLOG(JP_FATAL,'JACOBI: PBSEEK failed.',JPQUIET)
            CALL PBCLOSE(IUNIT,IRET)
            JACOBI = .FALSE.
            GOTO 999
          ENDIF
C
          IF( IFSIZE.NE.IRET) THEN
            CALL INTLOG(JP_FATAL,
     X        'JACOBI: Coefficients file size incorrect = ',IRET)
            CALL INTLOG(JP_FATAL,
     X        'JACOBI: Expected file size is            = ',IFSIZE)
            CALL PBCLOSE(IUNIT,IRET)
            JACOBI = .FALSE.
            GOTO 999
          ENDIF
C
C         Rewind the coefficients file.
C
          CALL PBSEEK(IUNIT,0,0,IRET)
          IF( IRET.NE.0 ) THEN
            CALL INTLOG(JP_FATAL,'JACOBI: Rewind failed.',JPQUIET)
            CALL PBCLOSE(IUNIT,IRET)
            JACOBI = .FALSE.
            GOTO 999
          ENDIF
        ENDIF
      ENDIF      
C
      DO 530 N = 1,NM
        RNKN  = (0.5*(1.0 + COSB))**N
        BNKN  = (0.5*(1.0 - COSB))**N
        SQNN  = DSQRT(DBLE((N+1)*N))
        SQNN1 = SQNN*SINB
        SQ2N  = DSQRT(2.0/DBLE(N))/SINB
C
C       Save SQRTS.
C
        DO 325 MM = 0,N
          WISQR(MM+1) = DSQRT(DBLE((N+MM)*(N-MM+1)))*SINB
  325   CONTINUE
C
        NN = 1
C
C       Generate RNKM, M = 0 to N.
C
        DO 490 K = N,0,-1
C
C         Generate the coefficients file if it doesn't exist
C
          IF( FIRST.EQ.0 ) THEN
            FIRST = -1
            CALL INTLOG(JP_DEBUG, 'JACOBI: PBOPEN for write',JPQUIET)
            IOFFSET = INDEX(FILEDUM,' ')
            CALL PBOPEN(IUNIT,FILEDUM(1:IOFFSET-1),'w',IRET)
            IF( IRET.NE.0 ) THEN
C
C             Try to use present working directory
C
              CALL INTLOG(JP_ERROR,
     X          'JACOBI: PBOPEN for write failed',JPQUIET)
              FILENAME = COEFILE
              FILEDUM  = COEFILE
              IOFFSET = INDEX(FILEDUM,' ')
              CALL PBOPEN(IUNIT,FILEDUM(1:IOFFSET-1),'w',IRET)
              IF( IRET.NE.0 ) THEN
                CALL INTLOG(JP_ERROR,
     X            'JACOBI: PBOPEN for write failed',JPQUIET)
                JACOBI = .FALSE.
                GOTO 999
              ENDIF
            ENDIF
          ENDIF
C
          IF( FIRST.LE.0) THEN
C
            PKN = W(K*(NM+1) + (N-K+1))
            IF (K.EQ.0) GOTO 400
C
C           For K > 0, go forward from zero.
C
            PK1N = W((K-1)*(NM+1) + (N-(K-1)+1))
C
C           Flip sign if necessary.
C
            IF (MOD(K,2).NE.0)THEN
              PKN = -PKN
            ELSE
              PK1N = -PK1N
            ENDIF
C
C           Work using forward recurrence as long as coefficient
C           calculated passes checks.
C
            LFOR = .TRUE.
C
            RNK0 = PKN
            RNK1 = (-DBLE(K)*TANB*PKN + (WISQR(K+1)/SINB)*PK1N)/SQNN
C
C           Recurrence starts at 2 for M = 0
C
            WIR(1) = RNK0
            WIR(2) = RNK1
C
            DO 330 MM = 1,N-1
              WIR(MM+2) = (2.0*WIR(MM+1)*(DBLE(MM)*COSB-DBLE(K))
     X                      - WISQR(MM+1)*WIR(MM)) /WISQR(MM+2)
C
C             Apply check to generated coefficient to see if its
C             absolute value is greater than 1.  If so, have to
C             switch to using backwards recurrences.
C
              IF (ABS(WIR(MM+2)).GT.1.0)THEN
                LFOR = .FALSE.
                IEND = MM + 3
                GOTO 335
              ENDIF
  330       CONTINUE
C
C           If forward recurrence appears OK so far,
C           test last element RNKN by comparing with WIR(N+1).
C
            IEND = N + 2
            IF (ABSCHK(RNKN,WIR(N+1))) GOTO 345
C
C           If test failed, try generating coefficients using
C           backwards recurrences.
C
  335       CONTINUE
C
C           Work backwards from the top.
C           Specify N; K is already set from the loop above.
C           Stop at M = 1 (NOT 0).
C
            RNKN1 = RNKN*SQ2N*(DBLE(N)*COSB-DBLE(K))
            WIR(N+1) = RNKN
C
C           Check whether difference is within prescribed tolerance.
C
            IF (LFOR .AND. ABSCHK(RNKN1,WIR(N))) GO  TO 345
            WIR(N) = RNKN1
C
C           For M = 0:
C
            DO 340 MM = N-1,1,-1
              S = (2.0*WIR(MM+1)*(DBLE(MM)*COSB-DBLE(K))
     X              - (WISQR(MM+2)*WIR(MM+2))) / WISQR(MM+1)
C
C             Accept these if forward recursion failed before
C             reaching this point.
C
              IF (MM+1.LT.IEND)THEN
                IF (ABSCHK(S,WIR(MM))) GOTO 345
              ENDIF
              WIR(MM) = S
C
C             If absolute value is greater than 1, give up gracefully
C
              IF (ABS(S).GT.1.0) GOTO 920
  340       CONTINUE
C
            GOTO 920
C
  345       CONTINUE
C
C           Now RNKM for M = 0,-N
C
C           RNKM M = -1,-N
C
C           Forward recurrence starts at 1 for M = 0, 2 for -1 etc.
C
            LFOR = .TRUE.
C
            WIB(1) = RNK0
            WIB(2) = -RNK1-RNK0*DBLE(2*K)/(SQNN1)
C
            DO 350 MM = 1,(N-1)
              WIB(MM+2) = (2.0*WIB(MM+1)*(DBLE(-MM)*COSB-DBLE(K))
     X              - WISQR(MM+1)*SINB*WIB(MM)) /WISQR(MM+2)
C
C             Apply check to generated coefficient to see if its
C             absolute value is greater than 1.  If so, have to
C             switch to using backwards recurrences.
C
              IF (ABS(WIB(MM+2)).GT.1.0)THEN
                LFOR = .FALSE.
                IEND = MM + 3
                GOTO 355
              ENDIF
  350       CONTINUE
C
C           If forward recurrence appears OK so far,
C           test last element BNKN by comparing with WIB(N+1).
C
            IEND = N + 1
            IF (ABSCHK(BNKN,WIB(N+1))) GOTO 400
C
C           If test failed, try generating coefficients using backwards
C           recurrences.
C
  355       CONTINUE
C
C           Get R values.
C           First RNKN, then next highest RNKN1.
C
            RNKN1 = -BNKN*SQ2N*(DBLE(N)*COSB + DBLE(K))
C
C           Work backwards from the top.
C           Specify N; K is already set from the loop above.
C
C           Stop at M = 1 (NOT 0).
C
            WIB(N+1) = BNKN
            IF (LFOR .AND. ABSCHK(RNKN1,WIB(N))) GOTO 400
            WIB(N) = RNKN1
C
            DO 360 MM = N-1,1,-1
              S = (2.0*WIB(MM+1)*(DBLE(-MM)*COSB-DBLE(K))
     X              - (WISQR(MM+2)*WIB(MM+2))) / WISQR(MM+1)
C
C             Accept backwards generated coefficients if forward
C             recursion failed before reaching this point.
C
              IF ( (MM.LT.IEND ) .AND. ABSCHK(S,WIB(MM)) ) GOTO 400
              WIB(MM) = S
C
C             If absolute value is greater than 1, give up.
C
              IF (ABS(S).GT.1.0) GOTO 910
C
  360       CONTINUE
C
C           End of backwards recurrences reached with no agreed
C           coefficients, give up.
C
            GOTO 910
C
C ------------------------------------------------------------------
C*    Section 4.   Got RNKM. Now transform spectral data.
C ------------------------------------------------------------------
C
  400       CONTINUE
C
C           Write coefficients to file
C
            CALL PBWRITE(IUNIT,WIR,(N+1)*NPBYTES,IRET)
            IF( IRET.NE.((N+1)*NPBYTES) ) THEN
              CALL INTLOG(JP_FATAL,'JACOBI: PBWRITE failed.',JPQUIET)
              CALL PBCLOSE(IUNIT,IRET)
              JACOBI = .FALSE.
              GOTO 999
            ENDIF
C
            CALL PBWRITE(IUNIT,WIB,(N+1)*NPBYTES,IRET)
            IF( IRET.NE.((N+1)*NPBYTES) ) THEN
              CALL INTLOG(JP_FATAL,'JACOBI: PBWRITE failed.',JPQUIET)
              CALL PBCLOSE(IUNIT,IRET)
              JACOBI = .FALSE.
              GOTO 999
            ENDIF
        
          ELSE
C
  415       CONTINUE
C
            PKN  = W(K*(NM+1) + (N-K+1))
            PK1N = W((K-1)*(NM+1) + (N-(K-1)+1))
C
C           Flip sign if necessary.
C
            IF (MOD(K,2).NE.0)THEN
              PKN  = -PKN
            ELSE
              PK1N = -PK1N
            ENDIF
C
C           Read coefficients from file
C
            CALL PBREAD(IUNIT,WIR,(N+1)*NPBYTES,IRET)
            IF( IRET.NE.((N+1)*NPBYTES) ) THEN
              CALL INTLOG(JP_FATAL,'JACOBI: PBREAD failed.',JPQUIET)
              CALL PBCLOSE(IUNIT,IRET)
              JACOBI = .FALSE.
              GOTO 999
            ENDIF
C
            CALL PBREAD(IUNIT,WIB,(N+1)*NPBYTES,IRET)
            IF( IRET.NE.((N+1)*NPBYTES) ) THEN
              CALL INTLOG(JP_FATAL,'JACOBI: PBREAD failed.',JPQUIET)
              CALL PBCLOSE(IUNIT,IRET)
              JACOBI = .FALSE.
              GOTO 999
            ENDIF
C
          ENDIF
C
C         Special case when K=0.
C
          IF( K.EQ.0) THEN
C
            SREAL = DATA(2*(N+1)-1)*PKN
            SIMAG = 0.0
            DO 420 M = 1,N
              NMP1TM = (NM+1)*M
              SREAL = SREAL
     X        + 2.0*DATA(2*(NMP1TM-((M-1)*M)/2+1+N-M)-1)
     X        * W(NMP1TM+(N-M+1))
  420       CONTINUE
C
            NDEX        = 1+N
            WIDAT(NN)   = SREAL
            WIDAT(NN+1) = SIMAG
            NN          = NN + 2
C
          ELSE
C
            SREAL  = DATA(2*(N+1)-1)*PKN
            SIMAG  = 0.0
            MINUS1 = -1
            DO 440 M = 1,N
              SREAL = SREAL +
     X              DATA(2*((NM+1)*M-((M-1)*M)/2+1+N-M)-1)
     X              * (WIR(M+1)+WIB(M+1)*MINUS1)
              SIMAG = SIMAG -
     X              DATA(2*((NM+1)*M -((M-1)*M)/2+1+N-M))
     X              * (-WIR(M+1)+WIB(M+1)*MINUS1)
              MINUS1 = -MINUS1
  440       CONTINUE
C
            NDEX        = (NM+1)*K - ((K-1)*K)/2+1+N-K
            WIDAT(NN)   = SREAL
            WIDAT(NN+1) = SIMAG
            NN          = NN + 2
          ENDIF
C
C         Update RNKN at both ends of the forward and backward
C         recurrences.
C
          TEMP = DSQRT(DBLE(N+K)/DBLE(N-K+1))
          RNKN = RNKN*TEMP*SINB/(1+COSB)
          BNKN = -BNKN*TEMP*(1+COSB)/SINB
  490   CONTINUE
C
C       End of inner loop.
C
C ------------------------------------------------------------------
C*    Section 5.   Now place the values of the rotated spectral
C                  coefficients in DATA.
C ------------------------------------------------------------------
C
  500 CONTINUE
C
        NN = 1
        DO 520 K = N,0,-1
          NDEX = (NM+1)*K - ((K-1)*K)/2+1+N-K
          DATA(2*NDEX-1) = WIDAT(NN)
          DATA(2*NDEX)   = WIDAT(NN+1)
          NN = NN + 2
C
  520   CONTINUE
C
  530 CONTINUE
C
C ------------------------------------------------------------------
C*    Section 9.   Return.
C ------------------------------------------------------------------
C
  900 CONTINUE
C
      JACOBI = .TRUE.
C
C     If coefficients file has just been generated:
C      - close it,
C      - rename it,
C      - re-open for reading
C      - unlink it, so it can disappear when closed,
C      - leave it open.
C
      IF( FIRST.LE.0 ) THEN
        FIRST = 1
        CALL PBCLOSE(IUNIT,IRET)
        IF( IRET.NE.0 ) THEN
          CALL INTLOG(JP_ERROR,'JACOBI: PBCLOSE failed.',JPQUIET)
          JACOBI = .FALSE.
          GOTO 999
        ENDIF
C
        FILEDUM(IOFFSET:IOFFSET) = CHAR(0)
        FILENAME(IOFFSET:IOFFSET) = CHAR(0)
        IRET = RENAME(FILEDUM(1:IOFFSET-1),FILENAME(1:IOFFSET-1))
        IF( IRET.NE.0 ) THEN
          CALL INTLOG(JP_FATAL,'JACOBI: RENAME of file failed',JPQUIET)
          JACOBI = .FALSE.
          GOTO 999
        ENDIF
C
        CALL INTLOG(JP_DEBUG, 'JACOBI: PBOPEN for read',JPQUIET)
        IOFFSET = INDEX(FILENAME,' ')
        CALL PBOPEN(IUNIT,FILENAME(1:IOFFSET-1),'r',IRET)
        IF( IRET.NE.0 ) THEN
          CALL INTLOG(JP_FATAL,'JACOBI: PBOPEN for read failed',JPQUIET)
          JACOBI = .FALSE.
          GOTO 999
        ENDIF
C
        IRET = UNLINK(FILENAME(1:IOFFSET-1))
        IF( IRET.NE.0 ) THEN
          CALL INTLOG(JP_ERROR,'JACOBI: UNLINK of file failed',JPQUIET)
          JACOBI = .FALSE.
          GOTO 999
        ENDIF
      ENDIF
C
  999 CONTINUE
      RETURN
C
C     Failure to converge with M < 0.
C
  910 CONTINUE
      CALL INTLOG(JP_FATAL,'JACOBI: Failure to converge M < 0', JPQUIET)
      JACOBI = .FALSE.
      GOTO 999
C
C     Failure to converge with M > 0.
C
  920 CONTINUE
      CALL INTLOG(JP_FATAL,'JACOBI: Failure to converge M > 0', JPQUIET)
      JACOBI = .FALSE.
      GOTO 999
      END

C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE INSMP2 (KGRIB,KLENG,KMAP2,PSEC4,KSIZE,KBITS,
     X                     PMISS,HFUNC,KNUM,KPR,KRET)
C
C---->
C**** INSMP2 - Insertion of secondary bit maps for routine GRIBEX.
C
C     Purpose.
C     --------
C
C     Generates secondary bit-maps (Section 4 bit-maps) and
C     inserts in array of GRIB coded data.
C
C**   Interface.
C     ----------
C
C     CALL INSMP2 (KGRIB,KLENG,KMAP2,PSEC4,KSIZE,KBITS,
C    X                     PMISS,HFUNC,KNUM,KPR,KRET)
C
C
C     Input Parameters.
C     -----------------
C
C     KGRIB      - Array into which data is being packed in GRIB code.
C
C     KLENG      - Length of this array.
C
C     KMAP2      - Bit-pointer to start of secondary bit maps
C                  (Section 4 bitmaps) in array KGRIB.
C
C     PSEC4      - Array of data values to be packed in
C                  GRIB code, containing missing data
C                  indicator PMISS where appropriate.
C
C     KSIZE      - Number of values, including missing data
C                  values, in array PSEC4.
C
C     KBITS      - Number of bits in computer word.
C
C     PMISS      - Value indicating missing data in array PSEC4.
C
C     HFUNC      - 'C' , GRIB data packed normally.
C                  'M' , GRIB data being packed in fixed length messages
C
C     KNUM       - Number of values at each grid point.
C
C     KPR        - Debug print switch.
C                  0  , No printout.
C                  >0 , Debug printout.
C
C     Output Parameters.
C     ------------------
C
C     KSIZE      - The number of data values remaining in
C                  array PSEC4 to be packed.
C
C     KRET       - Return code.
C                  0 , No error encountered.
C                  1 , Error in routine INXBIT.
#if (!defined VAX)
C                  2 , Memory allocation problem.
C                  3 , Memory deallocation problem.
#else
C                  4 , (VAX only) Number of values at each grid point
C                      (KNUM) is greater than allowed (JPWORK).
#endif
C
C     Method.
C     -------
C
C     The bit-map contains 1 where valid data exists and 0
C     where data is missing. The corresponding data array
C     contains valid data and the missing data indicator value.
C
C     Externals.
C     ----------
C
C     INXBIT
C
C     Reference.
C     ----------
C
C     See routine GRIBEX.
C
C     Comments.
C     ---------
C
C     None.
C
C     Author.
C     -------
C
C     J. Hennessy      ECMWF      09:07:92
C
C     Modifications.
C     --------------
C
C     J. Hennessy      ECMWF      19:10:92
C     Maximum sizes increased to allow for packing of
C     2D spectra.
C     Number of data values 120*61*12*25
C
C     J.D.Chambers     ECMWF      09:03:94
C     Maximum size for bitmap array increased to 132000
C     to allow for products 0.5 * 0.5 degrees, whole
C     hemisphere (N or S).
C
C     J.D.Chambers     ECMWF      24:05:95
C     Handle bitmap in strips to avoid problem with very large products
C
C     J.D.Chambers     ECMWF        Feb 1997
C     Allow for 64-bit pointers
C
C     J.D.Chambers     ECMWF        April 1998
C     Remove dynamic allocation of work array
C
C     J. Clochard, Meteo France, for ECMWF - January 1998.
C     Strips size (JPWORK) enlarged to 10000.
C
C----<
C     ------------------------------------------------------------------
C*    Section 0 . Definition of variables. Data statements.
C     ------------------------------------------------------------------
C
      IMPLICIT NONE
C
#include "grprs.h"
C
C     Parameters
C
      INTEGER JPWORK
      PARAMETER (JPWORK=10000)
C
C     Subroutine arguments
C
      INTEGER KBITS, KGRIB, KLENG, KMAP2, KNUM, KPR, KRET, KSIZE
      DIMENSION KGRIB(*)
      REAL PMISS, PSEC4
      DIMENSION PSEC4(*)
      CHARACTER*(*) HFUNC
C
C     Local variables
C
      INTEGER NEXTIN, NXTOUT, IPT, ITEMP
      INTEGER JLOOP, JLOOPI
      INTEGER LENGTH
      REAL VALUE
C
C     Work array.
C
      INTEGER IMAP2
      DIMENSION IMAP2(JPWORK)
C
C     ------------------------------------------------------------------
C*    Section 1 . Set initial values.
C     ------------------------------------------------------------------
C
  100 CONTINUE
C
      IF( KPR.GE.1 ) THEN
        WRITE(GRPRSM,*) 'INSMP2: Section 1.'
        WRITE(GRPRSM,*) '         Input values used -'
        WRITE(GRPRSM,*) '         HFUNC  = ', HFUNC
        WRITE(GRPRSM,*) '         KSIZE  = ', KSIZE
        WRITE(GRPRSM,*) '         KNUM   = ', KNUM 
      ENDIF
C
C     Reset return code to
      KRET  = 0
C
C     ------------------------------------------------------------------
C*    Section 2 .  Check input parameters.
C     ------------------------------------------------------------------
C
  200 CONTINUE
C
      IF( KPR.GE.1 ) WRITE(GRPRSM,*) 'INSMP2: Section 2.'
C
C*    Check function requested.
C
      IF( (HFUNC.NE.'C').AND.(HFUNC.NE.'M') ) THEN
        WRITE(GRPRSM,*) 'INSMP2: Invalid function requested - ', HFUNC
        KRET = 3
        GO TO 900
      ENDIF
C
      LENGTH = KNUM
C
C     Check there is enough space for packing secondary bitmap
C
      IF( LENGTH.GT.JPWORK ) THEN
        WRITE(GRPRSM,*) 'INSMP2: Number of values at each grid point'
        WRITE(GRPRSM,*)
     X    'INSMP2: (KNUM) is greater than allowed (JPWORK).'
        KRET = 4
        GOTO 900
      ENDIF
C
C     ------------------------------------------------------------------
C*    Section 3 . Generation of bit-map.
C    -------------------------------------------------------------------
C
  300 CONTINUE
C
      IF( KPR.GE.1 ) WRITE(GRPRSM,*) 'INSMP2: Section 3.'
C
      NEXTIN = 0
      NXTOUT = 0
C
C*    Generate the bit-map in accordance with the missing data
C     values.
C
      DO 320 JLOOP = 1, KSIZE, KNUM
        IPT = 0
C
        DO 310 JLOOPI = 1, KNUM
C
          IF (PSEC4(JLOOPI+NEXTIN).EQ.PMISS) THEN
C
C           If missing data indicator, set secondary bitmap flag to 0
C
            IMAP2(IPT+JLOOPI) = 0
C
          ELSE
C
C           If not missing, set secondary bitmap flag to 1 and
C           move data forwards in data array.
C
            IMAP2(IPT+JLOOPI) = 1
            NXTOUT            = NXTOUT + 1
            PSEC4(NXTOUT)     = PSEC4(NEXTIN+JLOOPI)
          ENDIF
  310   CONTINUE
        IPT = IPT + KNUM
C
C*      Insert bit-map in GRIB coded data.
C
        CALL INXBIT(KGRIB,KLENG,KMAP2,IMAP2,KNUM,KBITS,1,'C',KRET)
        IF (KRET.NE.0) THEN
          WRITE(GRPRSM,9003)
          KRET = 1
          GO TO 900
        ENDIF
C
        NEXTIN = NEXTIN + KNUM
C
  320 CONTINUE
C
C*    Bit map must be a multiple of 8 bits.
C
      ITEMP = (KMAP2+7) / 8
      ITEMP = ITEMP * 8
      IF (ITEMP.NE.KMAP2) THEN
        IMAP2(1) = 0
        ITEMP = ITEMP - KMAP2
        CALL INXBIT(KGRIB,KLENG,KMAP2,IMAP2,1,KBITS,ITEMP,'C',KRET)
        IF (KRET.NE.0) THEN
          WRITE(GRPRSM,9003)
          KRET = 1
          GO TO 900
        ENDIF
      ENDIF
C
C     Is a fixed length message required, even though a bit map is used?
C
      IF (HFUNC.EQ.'M') THEN
C
C       The otherwise unused part of the array is set to a genuine data
C       value so that extraction of minimum and maximum values remain
C       correct. Number of data values includes these padding values.
C
        VALUE = PSEC4(1)
        DO 330 JLOOP = NXTOUT+1, KSIZE
          PSEC4(JLOOP) = VALUE
  330   CONTINUE
C
      ELSE
C
C       Return number of points with values (ie excluding points with
C       missing data values).
C
        KSIZE = NXTOUT
C
      ENDIF
C
C     ------------------------------------------------------------------
C*    Section 9 . Return to calling routine. Format statements.
C     ------------------------------------------------------------------
C
  900 CONTINUE
C
      IF (KPR.GE.1) THEN
        WRITE(GRPRSM,*) 'INSMP2: Section 9.'
        WRITE(GRPRSM,*) '         Output values set -'
        WRITE(GRPRSM,*) 'INSMP2: KSIZE = ', KSIZE
      ENDIF
C
      RETURN
C
 9003 FORMAT (1H ,'INSMP2: Error reported by routine INXBIT.')
C
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

C
      COMMON /BCOMEL/ NTDLEN,NTDLST(JELEM),NTDEXL,NTDEXP(JELEM)
C
C             NTDLEN - NUMBER OF DATA DESCRIPTORS IN SECTION 3
C             NTDLST - LIST OF DATA DESCRIPTORS
C             NTDEXL - NUMBER OF EXPANDED DATA DESCRIPTORS
C             NTDEXP - LIST OF EXPANDED DATA DESCRIPTORS

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities
C granted to it by virtue of its status as an intergovernmental organisation
C nor does it submit to any jurisdiction.
C

      INTEGER FUNCTION HNTFAPS(INGRIB,INLEN)
C
C---->
C**** HNTFAPS
C
C     Purpose
C     -------
C
C     Prepare to interpolate input spectral field.
C
C
C     Interface
C     ---------
C
C     IRET = HNTFAPS(INGRIB,INLEN)
C
C     Input
C     -----
C
C     INGRIB - Input field (packed).
C     INLEN  - Input field length (words).
C
C
C     Output
C     ------
C
C     Field unpacked values are in ZNFELDI, rotated if necessary.
C
C     Returns: 0, if OK. Otherwise, an error occured in rotation.
C
C
C     Method
C     ------
C
C     Unpack field.
C
C     Rotate the field values if necessary.
C
C     Some rotation coefficients cannot be created because the
C     algorithm does not converge for rotations which are smaller
C     than a limit which depends on the spectral truncation.
C
C     If the rotation is too small, it has to be split into three
C     steps (two forward and one backward).
C
C     Current know limits are:
C
C     Truncation    Max South pole lat   Minimum rotation
C     ----------    ------------------   ----------------
C         63          -89.5                  0.5
C        106          -85                    5.0
C        159          -77                   13.0
C        213          -68                   22.0
C        319          -51                   39.0
C        511          -30.5                 59.5
C
C
C     Externals
C     ---------
C
C     GRIBEX  - Decode/encode GRIB product.
C     GRSVCK  - Turn off GRIB checking
C     INTLOG  - Log error message.
C     INTLOGR - Log error message.
C     RPHI    - Rotate a spectral field by longitude.
C     JACOBI  - Rotates spectral coefficients by latitude.
C
C
C     Author
C     ------
C
C     J.D.Chambers     ECMWF     January 31, 2001
C
C
C----<
C
C     -----------------------------------------------------------------|
C*    Section 0.   Variables
C     -----------------------------------------------------------------|
C
      IMPLICIT NONE
C
C     Function arguments
C
      INTEGER INGRIB(*),INLEN
C
#include "parim.h"
#include "nifld.common"
#include "nofld.common"
#include "grfixed.h"
#include "intf.h"
C
C     Parameters
C
      INTEGER JPROUTINE
      PARAMETER (JPROUTINE = 40120 )
      INTEGER JPLEN, JPNM
      PARAMETER ( JPNM = JPSTRUNC )
      PARAMETER ( JPLEN = (JPNM+1)*(JPNM+6) )
C
C     Local variables
C
      INTEGER IERR
      INTEGER IRET
      INTEGER ISIZE
      INTEGER ITRUNC
      INTEGER IWORD
      INTEGER KPR
      INTEGER NBYTES
      LOGICAL LOK
      LOGICAL LSPLIT
      REAL    POLELAT
      REAL*8  DLAT
      REAL*8  DLON
      REAL*8  LATLIM
#if (!defined REAL_8)
      INTEGER LOOP
#endif
      DATA NBYTES/4/
      DATA ISIZE/0/
      SAVE ISIZE
C
      REAL   SWORK(1)
      REAL*8 DWORK(1)
      REAL*8 DATA(1)
#ifndef _CRAYFTN
#ifdef POINTER_64
      INTEGER*8 ISWORK
      INTEGER*8 IDWORK
      INTEGER*8 IDATA
#endif
#endif
      POINTER (ISWORK, SWORK)
      POINTER (IDWORK, DWORK)
      POINTER (IDATA,  DATA)
      SAVE ISWORK
      SAVE IDWORK
      SAVE IDATA
C
C     Externals
C
      LOGICAL JACOBI
      EXTERNAL JACOBI
C
C     -----------------------------------------------------------------|
C*    Section 1.   Initialise
C     -----------------------------------------------------------------|
C
  100 CONTINUE
      HNTFAPS = 0
      IERR = 0
      KPR = 0
C
C     -----------------------------------------------------------------|
C*    Section 2.   Decode data from the GRIB code
C     -----------------------------------------------------------------|
C
  200 CONTINUE
C
C     Decode data from GRIB code (no checking)
C
      IWORD = INLEN
      IERR  =  0
      CALL GRSVCK(0)
      IERR = 1
      ISEC3(2) = NINT(RMISSGV)
      ZSEC3(2) = RMISSGV
      CALL GRIBEX(ISEC0, ISEC1, ISEC2, ZSEC2, ISEC3, ZSEC3, ISEC4,
     X            ZNFELDI, JPEXPAND, INGRIB, INLEN, IWORD, 'D',IERR)
C
      IF( IERR.LT.0) THEN
        IF( (IERR.EQ.-2).OR.(IERR.EQ.-4) ) THEN
          CALL INTLOG(JP_DEBUG,'HNTFAPS: Use missing value',JPQUIET)
          LIMISSV = .TRUE.
        ELSE
          CALL INTLOG(JP_ERROR,'HNTFAPS: GRIBEX decoding fail.',IERR)
          HNTFAPS = IERR
          GOTO 900
        ENDIF
      ELSE IF( IERR.GT.0 ) THEN
        CALL INTLOG(JP_ERROR,'HNTFAPS: GRIBEX decoding failed.',IERR)
        HNTFAPS = IERR
        GOTO 900
      ENDIF
C
C     -----------------------------------------------------------------|
C*    Section 3.   Handle rotation, if necessary.
C     -----------------------------------------------------------------|
C
  300 CONTINUE
C
C     Is a rotation of the SH required?
C
      IF( LNOROTA ) THEN
C
C       Avoid rotating U or V spectral coefficients
C
        IF( (NIPARAM.EQ.JP_U).OR.(NIPARAM.EQ.JP_V) ) THEN
          CALL INTLOG(JP_ERROR,
     X      'HNTFAPS: Unable to rotate spectral U or V:',NIPARAM)
          HNTFAPS = JPROUTINE + 3
          GOTO 900
        ENDIF
C
C       Dynamically allocate memory for workspace.
C
C       (Note the multiplication by 2 for REAL*8).
C
        ISIZE =  (2*(JPNM+1)*(JPNM+6))*2
        CALL JMEMHAN( 11, IDWORK, ISIZE, 1, IRET)
        IF( IRET.NE.0 ) THEN
          CALL INTLOG(JP_ERROR,'HNTFAPS: memory allocation fail',IDWORK)
          HNTFAPS = JPROUTINE + 3
          GOTO 900
        ENDIF
C
C       (Note the multiplication by 2 for REAL*8).
C
        ISIZE =  JPLEN*2
        CALL JMEMHAN( 15, IDATA, ISIZE, 1, IRET)
        IF( IRET.NE.0 ) THEN
          CALL INTLOG(JP_ERROR,'HNTFAPS: memory allocation fail',IDATA)
          HNTFAPS = JPROUTINE + 3
          GOTO 900
        ENDIF
C
        CALL INTLOG(JP_DEBUG,'HNTFAPS: Rotate SH field.',JPQUIET)
        CALL INTLOG(JP_DEBUG,'HNTFAPS: South pole latitude  ',NOROTA(1))
        CALL INTLOG(JP_DEBUG,'HNTFAPS: South pole longitude ',NOROTA(2))
        IF ( NOREPR.EQ.JPSPHERE )  NOREPR = JPSPHROT
        IF ( NOREPR.EQ.JPREGULAR )  NOREPR = JPREGROT
        ITRUNC = ISEC2(2)
C
C       Some rotation coefficients cannot be created because the
C       algorithm does not converge for rotations which are smaller
C       than a limit which depends on the spectral truncation.
C
        IF( ITRUNC.LE.63 ) THEN
          LATLIM = -89.5
        ELSE IF( ITRUNC.LE.106 ) THEN
          LATLIM = -85.0
        ELSE IF( ITRUNC.LE.159 ) THEN
          LATLIM = -77.0
        ELSE IF( ITRUNC.LE.213 ) THEN
          LATLIM = -68.0
        ELSE IF( ITRUNC.LE.319 ) THEN
          LATLIM = -51.0
        ELSE IF( ITRUNC.LE.511 ) THEN
          LATLIM = -29.5
        ELSE
          HNTFAPS = JPROUTINE + 3
          GOTO 900
        ENDIF
        CALL INTLOGR(JP_DEBUG,
     X    'HNTFAPS: South pole latitude limit = ',LATLIM)
C
        POLELAT = (REAL(NOROTA(1))/JPMULT)
C
C       If the rotation is too small, it has to be split into three
C       steps (two forward and one backward).
C
        LSPLIT = POLELAT.LT.LATLIM
        IF( LSPLIT ) THEN
          DLAT = -90.0 - LATLIM
          CALL INTLOG(JP_DEBUG,
     X      'HNTFAPS: Rotation has been split into three steps',JPQUIET)
        ELSE
          DLAT = -90.0 - POLELAT
        ENDIF
#if (defined REAL_8)
C
C       Double precision REALs
C
        DLON = - REAL(NOROTA(2))/JPMULT
C
C       Rotate the spectral field by longitude.
C
        CALL RPHI( ZNFELDI, ITRUNC, DWORK, DLON)
C
C       Rotate the spectral field by latitude.
C
        IF( LSPLIT ) THEN
C
C         Two rotations forward ..
C
          CALL INTLOGR(JP_DEBUG,
     X      'HNTFAPS: Twice forward through angle ', DLAT)
          LOK = JACOBI(ZNFELDI, ITRUNC, DWORK, DLAT)
          IF(.NOT.LOK) THEN
            CALL INTLOG(JP_ERROR,
     X        'HNTFAPS: Spectral rotation failed',JPQUIET)
            HNTFAPS = JPROUTINE + 3
            GOTO 900
          ENDIF
          LOK = JACOBI(ZNFELDI, ITRUNC, DWORK, DLAT)
          IF(.NOT.LOK) THEN
            CALL INTLOG(JP_ERROR,
     X       'HNTFAPS: Spectral rotation failed',JPQUIET)
            HNTFAPS = JPROUTINE + 3
            GOTO 900
          ENDIF
C
C         .. and one backward
C
          DLAT = -90.0 - ( (LATLIM*2.0) - POLELAT)
          DLAT= -DLAT
          CALL INTLOGR(JP_DEBUG,
     X      'HNTFAPS: Once backward through angle ', DLAT)
        ENDIF
C
        LOK = JACOBI( ZNFELDI, ITRUNC, DWORK, DLAT)
          IF(.NOT.LOK) THEN
            CALL INTLOG(JP_ERROR,
     X        'HNTFAPS: Spectral rotation failed',JPQUIET)
            HNTFAPS = JPROUTINE + 3
            GOTO 900
          ENDIF
#else
C
C       Single precision REALs; so convert to double precision.
C
        DLAT = -90.0 - DBLE(NOROTA(1))/JPMULT
        DLON = - DBLE(NOROTA(2))/JPMULT
C
C       Expand spectral coefficients to REAL*8
C
        DO LOOP = 1, ISEC4(1)
          DATA(LOOP) = DBLE(ZNFELDI(LOOP))
        ENDDO
C
C       Rotate the spectral field by longitude.
        CALL RPHI( DATA, ITRUNC, DWORK, DLON)
C
C       Rotate the spectral field by latitude.
C
        IF( LSPLIT ) THEN
C
C         Two rotations forward ..
C
          CALL INTLOGR(JP_DEBUG,
     X      'HNTFAPS: Twice forward through angle ', DLAT)
          LOK = JACOBI(ZNFELDI, ITRUNC, DWORK, DLAT)
          IF(.NOT.LOK) THEN
            CALL INTLOG(JP_ERROR,
     X        'HNTFAPS: Spectral rotation failed',JPQUIET)
            HNTFAPS = JPROUTINE + 3
            GOTO 900
          ENDIF
          LOK = JACOBI(ZNFELDI, ITRUNC, DWORK, DLAT)
          IF(.NOT.LOK) THEN
            CALL INTLOG(JP_ERROR,
     X        'HNTFAPS: Spectral rotation failed',JPQUIET)
            HNTFAPS = JPROUTINE + 3
            GOTO 900
          ENDIF
C
C         .. and one backward
C
          DLAT = -90.0 - ( (LATLIM*2.0) - POLELAT)
          DLAT= -DLAT
          CALL INTLOGR(JP_DEBUG,
     X      'HNTFAPS: Once backward through angle ', DLAT)
        ENDIF
C
        LOK = JACOBI( DATA, ITRUNC, DWORK, DLAT)
#endif
C
        IF( .NOT.LOK ) THEN
          CALL INTLOG(JP_ERROR,'HNTFAPS: Rotation failed',JPQUIET)
          HNTFAPS = JPROUTINE + 3
          GOTO 900
        ENDIF
#if (!defined REAL_8)
C
C       Single precision REALs; repack spectral coefficients to REAL*4.
C
        DO LOOP = 1, ISEC4(1)
          ZNFELDI(LOOP) = SNGL(DATA(LOOP))
        ENDDO
#endif
C
      ENDIF
C
C     -----------------------------------------------------------------|
C*    Section 9.   Closedown.
C     -----------------------------------------------------------------|
C
  900 CONTINUE
C
      RETURN
      END

C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

       PROGRAM DECODE_BUFR_IMAGE
C
C**** *DECODE_BUFR_IMAGE*
C
C
C     PURPOSE.
C     --------
C         Expnds Opera run-length encoded composite images
C         and creates image header and image file.
C
C
C**   INTERFACE.
C     ----------
C
C          NONE.
C
C     METHOD.
C     -------
C
C          NONE.
C
C
C     EXTERNALS.
C     ----------
C
C     REFERENCE.
C     ----------
C
C          NONE.
C
C     AUTHOR.
C     -------
C
C          M. DRAGOSAVAC    *ECMWF*       15/07/2008.
C
C
C     MODIFICATIONS.
C     --------------
C
C          NONE.
C
C
      IMPLICIT LOGICAL(L,O,G), CHARACTER*8(C,H,Y)
C
      PARAMETER(JSUP =   9,JSEC0=   3,JSEC1= 40,JSEC2=4096,JSEC3=   4,
     1          JSEC4=2,JELEM=320000,JSUBS=400,JCVAL=150 ,JBUFL=512000,
#ifdef JBPW_64
     2          JBPW =  64,JTAB =3000,JCTAB=3000,JCTST=9000,JCTEXT=9000,
#else
     2          JBPW =  32,JTAB =3000,JCTAB=3000,JCTST=9000,JCTEXT=9000,
#endif
     3          JWORK=4096000,JKEY=46, JTMAX=10,JTCLAS=64,JTEL=255)

C
      PARAMETER (JIMG=2500000)
      PARAMETER (KELEM=320000)
      PARAMETER (KVALS=4096000)
   
C 
      DIMENSION KBUFF(JBUFL)
      DIMENSION KBUFR(JBUFL)
      DIMENSION KSUP(JSUP)  ,KSEC0(JSEC0),KSEC1(JSEC1)
      DIMENSION KSEC2(JSEC2),KSEC3(JSEC3),KSEC4(JSEC4)
C
      REAL*8 VALUES(KVALS),VALUES_IMG(500)
      INTEGER IMAGE(JIMG)
      DIMENSION KTDLST(KELEM),KTDEXP(KELEM)
      DIMENSION KTDEXP_IMG(KELEM)
C
      CHARACTER*256 CF,COUT,CARG(4),COUT1,COUT2,COUT3
      CHARACTER*64 CNAMES(KELEM),CNAMES_IMG(KELEM)
      CHARACTER*24 CUNITS(KELEM),CUNITS_IMG(KELEM)
      CHARACTER*80 CVALS(KELEM),CVALS_IMG(KELEM)
      REAL*8 RVIND
C
C     ------------------------------------------------------------------
C*          1. INITIALIZE CONSTANTS AND VARIABLES.
C              -----------------------------------
 100  CONTINUE
C
C     MISSING VALUE INDICATOR
C 
      NBYTPW=JBPW/8
      RVIND=1.7D38
      NVIND=2147483647
      IOBS=0
      N=0
C
C
C
C     GET INPUT AND OUTPUT FILE NAME.
C
      NARG=IARGC()
C
C
      DO 104 J=1,NARG
      CALL GETARG(J,CARG(J))
 104  CONTINUE

      IF(NARG.EQ.0) THEN
         PRINT*,'USAGE -- decode_bufr_image infile'
         STOP
      END IF
C
      DO 101 II=1,NARG

      CF=CARG(II)
      ILN=INDEX(CF,' ')-1
C
C*          1.2 OPEN FILE CONTAINING BUFR DATA.
C               -------------------------------
 120  CONTINUE
C
      IRET=0 
      CALL PBOPEN(IUNIT,CF(1:ILN),'R',IRET)
      IF(IRET.EQ.-1) STOP 'OPEN FAILED'
      IF(IRET.EQ.-2) STOP 'INVALID FILE NAME'
      IF(IRET.EQ.-3) STOP 'INVALID OPEN MODE SPECIFIED'
C
      COUT1=CF(1:ILN-5)//'.img'
      ILN1=INDEX(COUT1,' ')-1
      CALL PBOPEN(IUNIT1,COUT1(1:ILN1),'W',IRET)
      IF(IRET.EQ.-1) STOP 'OPEN FAILED ON *.img file'
      IF(IRET.EQ.-2) STOP 'INVALID FILE NAME'
      IF(IRET.EQ.-3) STOP 'INVALID OPEN MODE SPECIFIED'
C
      COUT2=CF(1:ILN-5)//'.img_header'
      ILN2=INDEX(COUT2,' ')-1
      IUNIT2=40
      OPEN(UNIT=IUNIT2,FILE=COUT2(1:ILN2),STATUS='UNKNOWN',IOSTAT=ios)
      IF(IOS.NE.0) THEN
        PRINT*,'Open error on ',COUT2(1:ILN2)
        STOP 
      END IF
         
C
      COUT3=CF(1:ILN-5)//'.section_1'
      ILN3=INDEX(COUT3,' ')-1
      IUNIT3=41
      OPEN(UNIT=IUNIT3,FILE=COUT3(1:ILN3),STATUS='UNKNOWN',IOSTAT=ios)
      IF(IOS.NE.0) THEN
        PRINT*,'Open error on ',COUT3(1:ILN3)
        STOP 
      END IF
C
C     ----------------------------------------------------------------- 
C
C*          3.  READ BUFR MESSAGE.
C               ------------------
 300  CONTINUE
C
      IERR=0
      KBUFL=0
C
      CALL PBBUFR(IUNIT,KBUFF,JBUFL,KBUFL,IERR) 
      IF(IERR.EQ.-1) THEN
         PRINT*,'NUMBER OF SUBSETS     ',IOBS
         PRINT*,'NUMBER OF MESSAGES    ',N
         STOP 'EOF'
      END IF
      IF(IERR.EQ.-2) STOP 'FILE HANDLING PROBLEM' 
      IF(IERR.EQ.-3) STOP 'ARRAY TOO SMALL FOR PRODUCT'
C
      N=N+1
      PRINT*,'----------------------------------',N,' ',KBUFL
      KBUFL=KBUFL/NBYTPW+1
C
C     -----------------------------------------------------------------
C*          4. EXPAND BUFR MESSAGE.
C              --------------------
 400  CONTINUE
C
      CALL BUS0123( KBUFL,KBUFF,KSUP,KSEC0,KSEC1,KSEC2,KSEC3,IERR)
      IF(IERR.NE.0) THEN
         PRINT*,'ERROR IN BUS012: ',IERR
         PRINT*,' BUFR MESSAGE NUMBER ',N,' CORRUPTED.'
         IERR=0
         GO TO 300
      END IF
C
      KEL=KVALS/KSEC3(3)
      IF(KEL.GT.KELEM) KEL=KELEM
C
      CALL BUFREX(KBUFL,KBUFF,KSUP,KSEC0 ,KSEC1,KSEC2 ,KSEC3 ,KSEC4,
     1            KEL,CNAMES,CUNITS,KVALS,VALUES,CVALS,IERR)
C
      IF(IERR.NE.0) THEN
         CALL EXIT(2)
      END IF
C
      IOBS=IOBS+KSEC3(3)
C
C
      ISUBSET=1
      CALL BUSEL2(ISUBSET,KEL,KTDLEN,KTDLST,KTDEXL,KTDEXP,CNAMES,
     1            CUNITS,IERR)
C     IF(IERR.NE.0) CALL EXIT(2)
C
C     Get full image as array of pixel values

      CALL BUGET_OPERA_IMAGE(KSEC1,KTDEXL,KTDEXP,CNAMES,CUNITS,
     1      KELEM,KVALS,VALUES,CVALS,KTDEXL_IMG,KTDEXP_IMG,
     2      CNAMES_IMG,CUNITS_IMG,KVALS_IMG,VALUES_IMG,
     3      CVALS_IMG,KSIZE_IMG_BYTES,IMAGE,KPIXEL_SIZE,KERR)

c
c
C
C     Write image meta data into file
C     -------------------------------
      DO I=1,KTDEXL_IMG
      WRITE(IUNIT2,'(I6,1X,A64,1x,F20.8,1x,a24)') I,CNAMES_IMG(I),
     c                                VALUES_IMG(I),CUNITS_IMG(I)
      END DO

C
C     Write bufr section 1 into file
C     ------------------------------
      CALL BBUPRS1(IUNIT3,KSEC1)
      IMX=KSIZE_IMG_BYTES
C   
C     Write image ( pixel values ) into file
C     -----------------------------------------------------------------
      CALL PBWRITE(IUNIT1,IMAGE,IMX,IERR)
C
C
      GO TO 900 
C     -----------------------------------------------------------------
C
 810  CONTINUE
C
      WRITE(*,'(1H ,A)') 'OPEN ERROR ON INPUT FILE'
      GO TO 900
C      
 800  CONTINUE
C
      IF(IRET.EQ.-1) THEN
         PRINT*,'NUMBER OF RECORDS PROCESSED ',N
         PRINT*,'NUMBER OF OBSERVATIONS      ',IOBS
      ELSE
         PRINT*,' BUFR : ERROR= ',IERR
      END IF
C
 900  CONTINUE
C
      CALL PBCLOSE(IUNIT,IRET)
      CALL PBCLOSE(IUNIT1,IRET)
      CLOSE(IUNIT2)
      CLOSE(IUNIT3)
 101  CONTINUE
C
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities
C granted to it by virtue of its status as an intergovernmental organisation
C nor does it submit to any jurisdiction.
C

      PROGRAM gg_latitudes
C
C---->
C**** gg_latitudes
C
C     Purpose
C     -------
C
C     Command-line interface to JGETGG (interpolation).
C
C
C     Externals
C     ---------
C
C     JGETGG - Reads the definition of a gaussian grid.
C
C----<
C

C     Declarations
      IMPLICIT NONE
      INTEGER IARGC

      ! local variables
      INTEGER I, J
      CHARACTER*5 ARG, GRID

      ! global variables (all this to get to NGSPEC)
      INTEGER
     X  NILOCAL, NISTREM, NGSPEC ,
     X  NIFORM , NIREPR , NIGRID , NIAREA , NIGAUSS, NIRESO ,
     X  NIWE   , NINS   , NISCNM , NIPARAM, NITABLE, NIACC  ,
     X  NJDCDOT, NIPCNT , NILEVEL, NILEVT , NIDATE , NICOMP ,
     X  NISLSCP, NIPOGRS, NIPNGRS, NIMATR
      REAL RISTRET, RMISSGV
      DIMENSION NIGRID(2)
      DIMENSION NIAREA(4)
      COMMON /JDNIFLD/
     X  RISTRET, RMISSGV,
     X  NILOCAL, NISTREM, NGSPEC ,
     X  NIFORM , NIREPR , NIGAUSS, NIRESO ,
     X  NIWE   , NINS   , NISCNM , NIPARAM, NITABLE, NIACC  ,
     X  NJDCDOT, NIPCNT , NILEVEL, NILEVT , NIDATE , NICOMP ,
     X  NISLSCP, NIPOGRS, NIPNGRS, NIGRID , NIAREA , NIMATR
      SAVE /JDNIFLD/

      ! JGETGG arguments
      INTEGER KNUM, KRET
      CHARACTER*1 HTYPE
      INTEGER KPTS(4000) ! (in parim.h, JPLAT = 4000)
      REAL    PLAT(4000) ! ...


C     Check arguments count
      IF (IARGC() < 1) THEN
          PRINT *,
     X'Usage -- gg_latitudes [|-12] [[N|O|F]KNUM] ...'
          PRINT *, '  -12     -- force RGG specification (NGSPEC=12)'
          PRINT *, '  [N|O|F] -- Gaussian grid type(s)'
          PRINT *, '             N: "quasi-regular" (default)'
          PRINT *, '             O: octahedral'
          PRINT *, '             F: non-reduced'
          PRINT *, '  KNUM    -- Gaussian grid number(s), up to 2000'
          STOP
      END IF


C     Process arguments in order
      NGSPEC = 0
      DO J = 1, IARGC()
          CALL GETARG(J,ARG)
          IF (ARG=='-12') THEN

C             Force RGG specification
              NGSPEC = 12

          ELSE IF (ARG(1:1).NE.'N' .AND.
     X             ARG(1:1).NE.'O' .AND.
     X             ARG(1:1).NE.'F') THEN

C             Gaussian grid type has to be specified
              PRINT *,'Error: ARG="',ARG,'", ARG(1:1)!="[N|O|F]"'
              CALL EXIT(-1)

          ELSE

C             Set Gaussian grid type (HTYPE) & number (KNUM)
C             (read ([NOF])([0-9]{4}), HTYPE=$1, KNUM=$2)
              KNUM = 0
              READ (ARG,'(A1,I4)') HTYPE, KNUM
              IF (HTYPE=='N') HTYPE = 'R'
              IF (KNUM.GT.2000) THEN
                  PRINT *,'Error: ARG="',ARG,'" KNUM>2000'
                  CALL EXIT(-1)
              END IF

C             Call JGETGG
              KPTS = 0
              PLAT = 0.
              CALL JGETGG(KNUM,HTYPE,PLAT,KPTS,KRET)
              IF (KRET.NE.0) THEN
                  PRINT *,'Error: ARG="',ARG,'" JGETGG KRET=',KRET
                  CALL EXIT(KRET)
              END IF

C             Output
76            FORMAT(8X,A5,8X,A4,8X,A12)
77            FORMAT(8X,I5,8X,I4,8X,F12.5)
              IF (HTYPE.EQ.'R') WRITE(GRID,'(A,I0)') 'N',   KNUM
              IF (HTYPE.NE.'R') WRITE(GRID,'(A,I0)') HTYPE, KNUM
              WRITE(*,76) GRID,    'KPTS',  'PLAT        '
              WRITE(*,76) '-----', '----',  '------------'
              DO I = 1, KNUM*2
              WRITE(*,77) I,       KPTS(I), PLAT(I)
              END DO

          END IF
      END DO

      END PROGRAM

C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

       PROGRAM BUFR
C
C**** *BUFR*
C
C
C     PURPOSE.
C     --------
C         An example of using Bufr packing/unpacking software.
C         It will create synop data in bufr edition 4 
C
C
C**   INTERFACE.
C     ----------
C
C          NONE.
C
C     METHOD.
C     -------
C
C          NONE.
C
C
C     EXTERNALS.
C     ----------
C
C
C     REFERENCE.
C     ----------
C
C          NONE.
C
C     AUTHOR.
C     -------
C
C          M. DRAGOSAVAC    *ECMWF*       05/04/2005.
C
C
C     MODIFICATIONS.
C     --------------
C
C          NONE.
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
C
      PARAMETER(JSUP =  9,JSEC0=   3,JSEC1= 40,JSEC2=4096,JSEC3=    4,
     1          JSEC4=2,JELEM=320000,JSUBS=400,JCVAL=150 ,JBUFL=512000,
#ifdef JBPW_64
     2          JBPW =  64,JTAB =3000,JCTAB=120,JCTST=1800,JCTEXT= 200,
#else
     2          JBPW =  32,JTAB =3000,JCTAB=120,JCTST=1800,JCTEXT= 200,
#endif
     3          JWORK=4096000,JKEY=46)

C
      PARAMETER (KDLEN=200,KELEM=4000)
      parameter (KVALS=4000,KVALS1=4000)
C 
      DIMENSION KBUFR(JBUFL)
      DIMENSION KSUP(JSUP)  ,KSEC0(JSEC0),KSEC1(JSEC1)
      DIMENSION KSEC2(JSEC2),KSEC3(JSEC3),KSEC4(JSEC4)
      DIMENSION KEY  (JKEY)
      DIMENSION ISUP(JSUP)  ,ISEC0(JSEC0),ISEC1(JSEC1)
      DIMENSION ISEC2(JSEC2),ISEC3(JSEC3),ISEC4(JSEC4)
C
#ifndef R_4
      REAL*8  VALUES(KVALS),VALUE(KVALS1)
      REAL*8  RQV(KELEM)
      REAL*8  RVIND
#else
      REAL    VALUES(KVALS),VALUE(KVALS1)
      REAL    RQV(KELEM)
      REAL    RVIND
#endif

      DIMENSION KTDLST(KELEM),KTDEXP(KELEM),KRQ(KELEM)
      DIMENSION ITDLST(KELEM),ITDEXP(KELEM)
      DIMENSION KDATA(KDLEN),IDATA(KDLEN)
C
      CHARACTER*8  CF
      CHARACTER*64 CNAMES(KELEM),CNAME(KELEM)
      CHARACTER*24 CUNITS(KELEM),CUNIT(KELEM)
      CHARACTER*80 CVALS(KVALS)
      CHARACTER*80 CVAL (KVALS1)
      CHARACTER*80 YENC
C
C                                                                       
C     ------------------------------------------------------------------
C*          1. INITIALIZE CONSTANTS AND VARIABLES.
C              -----------------------------------
 100  CONTINUE
C
C
      RVIND=1.7D38
C
 
      CALL PBOPEN(IUNIT1,'synop.bufr','W',IRET)
      IF(IRET.EQ.-1) STOP 'OPEN FAILED ON synop.dat'
      IF(IRET.EQ.-2) STOP 'INVALID FILE NAME'
      IF(IRET.EQ.-3) STOP 'INVALID OPEN MODE SPECIFIED'
C

C
C     INITIALIZE DELAYED REPLICATION FACTORS OR REFERENCE VALUES ETD.
C
      DO 101 I=1,KDLEN
      KDATA(I)=1
      VALUES(I)=RVIND
 101  CONTINUE
C
c
      KDLENG=3
C
C
C     SET DATA DECSRIPTORS
C

 
      ktdlst(    1)=  307080
 
      ktdlen=1

      values(  1)=11.        !001001  WMO BLOCK NUMBER
      values(  2)=423.       !001002  WMO STATION NUMBER
      values(  3)=1020.      !001015  STATION OR SITE NAME
      values(  4)=1.         !002001  TYPE OF STATION
      values(  5)=2007.      !004001  YEAR
      values(  6)=11.        !004002  MONTH
      values(  7)=21.        !004003  DAY
      values(  8)=12.        !004004  HOUR
      values(  9)=0.         !004005  MINUTE
      values( 10)=49.66944   !005001  LATITUDE (HIGH ACCURACY)
      values( 11)=12.67778   !006001  LONGITUDE (HIGH ACCURACY)
      values( 12)=742.2      !007030  HEIGHT OF STATION GROUND ABOVE MEAN SEA LEVEL (SEE NOTE 3)
      values( 13)=747.       !007031  HEIGHT OF BAROMETER ABOVE MEAN SEA LEVEL (SEE NOTE 4)
      values( 14)=92520.     !010004  PRESSURE
      values( 15)=rvind      !010051  PRESSURE REDUCED TO MEAN SEA LEVEL
      values( 16)=-60.       !010061  3-HOUR PRESSURE CHANGE
      values( 17)=5.         !010063  CHARACTERISTIC OF PRESSURE TENDENCY
      values( 18)=rvind      !010062  24-HOUR PRESSURE CHANGE
      values( 19)=92500.     !007004  PRESSURE
      values( 20)=749.       !010009  GEOPOTENTIAL HEIGHT
      values( 21)=1.95       !007032  HEIGHT OF SENSOR ABOVE LOCAL GROUND (OR DECK OF MARINE PLATFORM)
      values( 22)=270.85     !012101  TEMPERATURE/DRY-BULB TEMPERATURE
      values( 23)=270.45     !012103  DEW-POINT TEMPERATURE
      values( 24)=97.        !013003  RELATIVE HUMIDITY
      values( 25)=4.8        !007032  HEIGHT OF SENSOR ABOVE LOCAL GROUND (OR DECK OF MARINE PLATFORM)
      values( 26)=200.       !020001  HORIZONTAL VISIBILITY
      values( 27)=1.12       !007032  HEIGHT OF SENSOR ABOVE LOCAL GROUND (OR DECK OF MARINE PLATFORM)
      values( 28)=rvind      !013023  TOTAL PRECIPITATION PAST 24 HOURS
      values( 29)=rvind      !007032  HEIGHT OF SENSOR ABOVE LOCAL GROUND (OR DECK OF MARINE PLATFORM)
      values( 30)=100.       !020010  CLOUD COVER (TOTAL)
      values( 31)=5.         !008002  VERTICAL SIGNIFICANCE (SURFACE OBSERVATIONS)
      values( 32)=9.         !020011  CLOUD AMOUNT
      values( 33)=0.         !020013  HEIGHT OF BASE OF CLOUD
      values( 34)=62.        !020012  CLOUD TYPE
      values( 35)=61.        !020012  CLOUD TYPE
      values( 36)=60.        !020012  CLOUD TYPE
      values( 37)=1.         !031001  DELAYED DESCRIPTOR REPLICATION FACTOR
      values( 38)=5.         !008002  VERTICAL SIGNIFICANCE (SURFACE OBSERVATIONS)
      values( 39)=9.         !020011  CLOUD AMOUNT
      values( 40)=59.        !020012  CLOUD TYPE
      values( 41)=0.         !020013  HEIGHT OF BASE OF CLOUD
      values( 42)=1.         !031001  DELAYED DESCRIPTOR REPLICATION FACTOR
      values( 43)=11.        !008002  VERTICAL SIGNIFICANCE (SURFACE OBSERVATIONS)
      values( 44)=rvind      !020011  CLOUD AMOUNT
      values( 45)=rvind      !020012  CLOUD TYPE
      values( 46)=rvind      !020014  HEIGHT OF TOP OF CLOUD
      values( 47)=rvind      !020017  CLOUD TOP DESCRIPTION
      values( 48)=7.         !008002  VERTICAL SIGNIFICANCE (SURFACE OBSERVATIONS)
      values( 49)=rvind      !020054  TRUE DIRECTION FROM WHICH CLOUDS ARE MOVING
      values( 50)=8.         !008002  VERTICAL SIGNIFICANCE (SURFACE OBSERVATIONS)
      values( 51)=rvind      !020054  TRUE DIRECTION FROM WHICH CLOUDS ARE MOVING
      values( 52)=9.         !008002  VERTICAL SIGNIFICANCE (SURFACE OBSERVATIONS)
      values( 53)=rvind      !020054  TRUE DIRECTION FROM WHICH CLOUDS ARE MOVING
      values( 54)=rvind      !008002  VERTICAL SIGNIFICANCE (SURFACE OBSERVATIONS)
      values( 55)=rvind      !005021  BEARING OR AZIMUTH
      values( 56)=rvind      !007021  ELEVATION (SEE NOTE 2)
      values( 57)=rvind      !020012  CLOUD TYPE
      values( 58)=rvind      !005021  BEARING OR AZIMUTH
      values( 59)=rvind      !007021  ELEVATION (SEE NOTE 2)
      values( 60)=rvind      !020062  STATE OF THE GROUND (WITH OR WITHOUT SNOW)
      values( 61)=rvind      !013013  TOTAL SNOW DEPTH
      values( 62)=rvind      !012113  GROUND MINIMUM TEMPERATURE, PAST 12 HOURS
      values( 63)=49.        !020003  PRESENT WEATHER (SEE NOTE 1)
      values( 64)=-6.        !004024  TIME PERIOD OR DISPLACEMENT
      values( 65)=4.         !020004  PAST WEATHER (1) (SEE NOTE 2)
      values( 66)=4.         !020005  PAST WEATHER (2) (SEE NOTE 2)
      values( 67)=-1.        !004024  TIME PERIOD OR DISPLACEMENT
      values( 68)=rvind      !014031  TOTAL SUNSHINE
      values( 69)=-24.       !004024  TIME PERIOD OR DISPLACEMENT
      values( 70)=rvind      !014031  TOTAL SUNSHINE
      values( 71)=1.12       !007032  HEIGHT OF SENSOR ABOVE LOCAL GROUND (OR DECK OF MARINE PLATFORM)
      values( 72)=-6.        !004024  TIME PERIOD OR DISPLACEMENT
      values( 73)=0.         !013011  TOTAL PRECIPITATION/TOTAL WATER EQUIVALENT
      values( 74)=-1.        !004024  TIME PERIOD OR DISPLACEMENT
      values( 75)=0.         !013011  TOTAL PRECIPITATION/TOTAL WATER EQUIVALENT
      values( 76)=1.95       !007032  HEIGHT OF SENSOR ABOVE LOCAL GROUND (OR DECK OF MARINE PLATFORM)
      values( 77)=-12.       !004024  TIME PERIOD OR DISPLACEMENT
      values( 78)=0.         !004024  TIME PERIOD OR DISPLACEMENT
      values( 79)=rvind      !012111  MAXIMUM TEMPERATURE, AT HEIGHT AND OVER PERIOD SPECIFIED
      values( 80)=-12.       !004024  TIME PERIOD OR DISPLACEMENT
      values( 81)=0.         !004024  TIME PERIOD OR DISPLACEMENT
      values( 82)=rvind      !012112  MINIMUM TEMPERATURE, AT HEIGHT AND OVER PERIOD SPECIFIED
      values( 83)=10.25      !007032  HEIGHT OF SENSOR ABOVE LOCAL GROUND (OR DECK OF MARINE PLATFORM)
      values( 84)=8.         !002002  TYPE OF INSTRUMENTATION FOR WIND MEASUREMENT
      values( 85)=2.         !008021  TIME SIGNIFICANCE
      values( 86)=-10.       !004025  TIME PERIOD OR DISPLACEMENT
      values( 87)=110.       !011001  WIND DIRECTION
      values( 88)=5.         !011002  WIND SPEED
      values( 89)=rvind      !008021  TIME SIGNIFICANCE
      values( 90)=-10.       !004025  TIME PERIOD OR DISPLACEMENT
      values( 91)=rvind      !011043  MAXIMUM WIND GUST DIRECTION
      values( 92)=rvind      !011041  MAXIMUM WIND GUST SPEED
      values( 93)=-360.      !004025  TIME PERIOD OR DISPLACEMENT
      values( 94)=rvind      !011043  MAXIMUM WIND GUST DIRECTION
      values( 95)=12.        !011041  MAXIMUM WIND GUST SPEED
      values( 96)=rvind      !007032  HEIGHT OF SENSOR ABOVE LOCAL GROUND (OR DECK OF MARINE PLATFORM)
      values( 97)=-24.       !004024  TIME PERIOD OR DISPLACEMENT
      values( 98)=rvind      !002004  TYPE OF INSTRUMENTATION FOR EVAPORATION MEASUREMENT OR TYPE OF C
      values( 99)=rvind      !013033  EVAPORATION/EVAPOTRANSPIRATION
      values(100)=-1.        !004024  TIME PERIOD OR DISPLACEMENT
      values(101)=rvind      !014002  LONG-WAVE RADIATION, INTEGRATED OVER PERIOD SPECIFIED
      values(102)=rvind      !014004  SHORT-WAVE RADIATION, INTEGRATED OVER PERIOD SPECIFIED
      values(103)=rvind      !014016  NET RADIATION, INTEGRATED OVER PERIOD SPECIFIED
      values(104)=rvind      !014028  GLOBAL SOLAR RADIATION (HIGH ACCURACY), INTEGRATED OVER PERIOD S
      values(105)=rvind      !014029  DIFFUSE SOLAR RADIATION (HIGH ACCURACY), INTEGRATED OVER PERIOD
      values(106)=rvind      !014030  DIRECT SOLAR RADIATION (HIGH ACCURACY), INTEGRATED OVER PERIOD S
      values(107)=-24.       !004024  TIME PERIOD OR DISPLACEMENT
      values(108)=rvind      !014002  LONG-WAVE RADIATION, INTEGRATED OVER PERIOD SPECIFIED
      values(109)=rvind      !014004  SHORT-WAVE RADIATION, INTEGRATED OVER PERIOD SPECIFIED
      values(110)=rvind      !014016  NET RADIATION, INTEGRATED OVER PERIOD SPECIFIED
      values(111)=rvind      !014028  GLOBAL SOLAR RADIATION (HIGH ACCURACY), INTEGRATED OVER PERIOD S
      values(112)=rvind      !014029  DIFFUSE SOLAR RADIATION (HIGH ACCURACY), INTEGRATED OVER PERIOD
      values(113)=rvind      !014030  DIRECT SOLAR RADIATION (HIGH ACCURACY), INTEGRATED OVER PERIOD S
      values(114)=rvind      !004024  TIME PERIOD OR DISPLACEMENT
      values(115)=rvind      !004024  TIME PERIOD OR DISPLACEMENT
      values(116)=rvind      !012049  TEMPERATURE CHANGE OVER SPECIFIED PERIOD

 
C     SET CCITTIA5 STATION OR SITE NAME

      cvals(1)='PRIMDA'
C
C
C     SECTION 0 CONTENT
C
      KSEC0(1)=0      ! TOTAL LENGTH OF SECTION 0
      KSEC0(2)=0      ! TOTAL LENGTH OF BUFR MESSAGE
      KSEC0(3)=4      ! BUFR EDITION NUMBER
C
C     SECTION 1 CONTENT
C
      KSEC1(1)=22    ! TOTTAL LENGTH OF SECTION 1 (  set to 18 for edition <= 3)
      KSEC1(2)=4     ! BUFR EDITION NUMBER
      KSEC1(3)=89    ! ORIGINATING CENTRE
      KSEC1(4)=1     ! UPDATE SEQUENCE NUMBER
      KSEC1(5)=0     ! FLAG (PRESENCE OF SECTION 2)
      KSEC1(6)=0     ! DATA CATEGORY
      KSEC1(7)=0     ! LOCAL DATA SUB-CATEGORY
      KSEC1(8)=0     ! VERSION NUMBER OF LOCAL TABLE USED
      KSEC1(9)=nint(values(5)) 
      if(KSEC1(2).le.3) then
        if(ksec1(9).gt.2000) then
           ksec1(9)=ksec1(9)-2000
        else
           ksec1(9)=ksec1(9)-1900
        end if
      end if
      KSEC1(10)=nint(values(6))
      KSEC1(11)=nint(values(7))   ! DAY
      KSEC1(12)=nint(values(8))   ! HOUR
      KSEC1(13)=nint(values(9))   ! MINUTE
      KSEC1(14)=0    ! BUFR MASTER TABLE( ZERO) FOR METEOROLOGICAL DATA)
      KSEC1(15)=13   ! VERSION NUMBER OF MASTER TABLE USED
      KSEC1(16)=255  ! ORIGINATING SUB-CENTRE
      KSEC1(17)=2    ! INTERNATIONAL SUB-CATEGORY
      KSEC1(18)=0    ! SECOND
      
C
C     SECTION 2 CONTENT
C
      KSEC2(1)=52
C
      DO 110 I=2,JSEC2
      KSEC2(I)=0
 110  CONTINUE
C
C     SECTION 3 CONTENT
C
      KSEC3(1)=0     ! TOTAL LENGTH OF SECTION 3
      KSEC3(2)=0     ! RESERVED
      KSEC3(3)=1
      KSEC3(4)=0     ! 64 FOR COMPRESSION/ 0 MANY SUBSETS
      if(KSEC3(3).GT.1) KSEC3(4)=64
C
      IREP=0
C
C
C*          6. PACK BUFR MESSAGE
C              -----------------
 600  CONTINUE
C
C---------------------------------------------------------------
C              This call is not needed for packing. It just 
C              prints expanded list corresponding to ktdlst sequence
C              and delayed replications in kdata array. This four
C              lines can be deleted or commented out.
      K=1
      CALL BUXDES(K,KSEC1,KTDLEN,KTDLST,KDLENG,KDATA,KELEM,
     1            KTDEXL,KTDEXP,CNAMES,CUNITS,KERR)
C
      IF(KERR.NE.0) CALL EXIT(2)
C---------------------------------------------------------------
C
C
C*          6.2 ENCODE DATA INTO BUFR MESSAGE.
C               ------------------------------
 620  CONTINUE
C
      KBUFL=3000
      KPMISS=1
      KPRUS=1
      NOKEY=0
      CALL BUPRQ(KPMISS,KPRUS,NOKEY)
C
      KERR=0
      CALL BUFREN( KSEC0,KSEC1,KSEC2,KSEC3,KSEC4,
     1             KTDLEN,KTDLST,KDLENG,KDATA,KELEM,
     2             KVALS,VALUES,CVALS,KBUFL,KBUFR,KERR)
C

      IF(KERR.GT.0) THEN
         CALL EXIT(2)
      ELSEIF(KERR.lt.0) then
         print*,'Encoding return_code=',kerr
      END IF 
c
C     ILEN=KBUFL*JBPW/8
      ILEN=KSEC0(2)
C
      IERR=0
      CALL PBWRITE(IUNIT1,KBUFR,ILEN,IERR)
      IF(IERR.LT.0) THEN
         PRINT*,'ERROR WRITING INTO TARGET FILE.'
         CALL EXIT(2)
      END IF

C
C     -----------------------------------------------------------------
C*          7. UNPACK MESSAGE.
C              -------------
 700  CONTINUE
C
      DO 702 I=1,KVALS1
      VALUE(I)=RVIND
 702  CONTINUE
c
 701  CONTINUE
C
      CALL BUFREX(KBUFL,KBUFR,ISUP,ISEC0 ,ISEC1,ISEC2 ,ISEC3 ,ISEC4,
     1            KELEM,CNAME,CUNIT,KVALS1,VALUE,CVAL,IERR)
c
      IF(IERR.NE.0) CALL EXIT(2)
C
      CALL BUPRS0(ISEC0)
      CALL BUPRS1(ISEC1)
      CALL BUUKEY(ISEC1,ISEC2,KEY,ISUP,KERR)
      CALL BUPRS2(ISUP ,KEY)
      ISUBSET=1
      CALL BUSEL2(ISUBSET,KELEM,KTDLEN,KTDLST,KTDEXL,KTDEXP,CNAMES,
     1            CUNITS,IERR)
      CALL BUPRS3(ISEC3,KTDLEN,KTDLST,KTDEXL,KTDEXP,KELEM,CNAME)
C
      WRITE(*,'(a,$)') ' STARTING SUBSET TO BE PRINTED : '
      READ(*,'(I5)')   IST
      WRITE(*,'(a,$)') ' ENDING SUBSET TO BE PRINTED : '
      READ(*,'(I6)')   IEND
C
      ICODE=0
      CALL BUPRT(ICODE,IST,IEND,KELEM,CNAME,CUNIT,CVAL,
     1           KVALS1,VALUE,ISUP,ISEC1,IERR)
C
C      
      IREP=IREP+1
C   
      IF(IREP.GT.3) GO TO 900 
      GO TO 900
C
 810  CONTINUE
C
      WRITE(*,'(1H ,A)') 'OPEN ERROR ON INPUT FILE'
      GO TO 900
C      
 800  CONTINUE
C
      IF(IERR.EQ.-1) THEN
         print*,'Number of records processed ',IREP
      ELSE
         print*,' BUFR : error= ',ierr
      END IF
C
 900  CONTINUE
C
      STOP
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE BUPKEY( KEY,KSEC1,KSEC2,KERR )
C
C**** *BUPKEY*
C
C
C     PURPOSE.
C     --------
C          PACK LOCAL ECMWF INFORMATION (RDB KEY) INTO KSEC2 ARRAY.
C
C
C**   INTERFACE.
C     ----------
C          *CALL* *BUPKEY(KEY,KSEC1,KSEC2,KERR)*
C
C        INPUT :
C               *KEY*     -  ARRAY CONTAINING RDB INFORMATION
C                            KEY( 1)-- LENGTH OF SECTION 2 (BYTES)
C                            KEY( 2)-- RDB TYPE
C                            KEY( 3)-- RDB SUBTYPE
C                            KEY( 4)-- YEAR
C                            KEY( 5)-- MONTH
C                            KEY( 6)-- DAY
C                            KEY( 7)-- HOUR
C                            KEY( 8)-- MINUTE
C                            KEY( 9)-- SECOND
C                            KEY(10)-- LONGITUDE1
C                            KEY(11)-- LATITUDE1
C                            KEY(12)-- LONGITUDE2
C                            KEY(13)-- LATITUDE2
C                            KEY(14)-- NUMBER OF SUBSETS
C                            KEY(15)-- IDENT (NUMERIC)
C                            KEY(16)-- IDENT ( CCITTIA5) ONE CHARACTER
C                            KEY(17)-- IDENT ( CCITTIA5) ONE CHARACTER
C                            KEY(18)-- IDENT ( CCITTIA5) ONE CHARACTER
C                            KEY(19)-- IDENT ( CCITTIA5) ONE CHARACTER
C                            KEY(20)-- IDENT ( CCITTIA5) ONE CHARACTER
C                            KEY(21)-- IDENT ( CCITTIA5) ONE CHARACTER
C                            KEY(22)-- IDENT ( CCITTIA5) ONE CHARACTER
C                            KEY(23)-- IDENT ( CCITTIA5) ONE CHARACTER
C                            KEY(24)-- IDENT ( CCITTIA5) ONE CHARACTER
C                            KEY(25)-- TOTAL BUFR MESSAGE LENGTH
C                            KEY(26)-- DAY    (RDB INSERTION)
C                            KEY(27)-- HOUR   (RDB INSERTION)
C                            KEY(28)-- MINUTE (RDB INSERTION)
C                            KEY(29)-- SECOND (RDB INSERTION)
C                            KEY(30)-- DAY    (MDB INSERTION)
C                            KEY(31)-- HOUR   (MDB INSERTION)
C                            KEY(32)-- MINUTE (MDB INSERTION)
C                            KEY(33)-- SECOND (MDB INSERTION)
C                            KEY(34)-- CORRECTION NUMBER
C                            KEY(35)-- PART
C                            KEY(36)-- 0
C                            KEY(37)-- CORRECTION NUMBER
C                            KEY(38)-- PART
C                            KEY(39)-- 0
C                            KEY(40)-- CORRECTION NUMBER
C                            KEY(41)-- PART
C                            KEY(42)-- 0
C                            KEY(43)-- CORRECTION NUMBER
C                            KEY(44)-- PART
C                            KEY(45)-- 0
C                            KEY(46)-- THE LOWEST Q/C % CONFIDENCE
C               *KSEC1*   -  ARRAY CONTAINING SECTION 1 INFORMATION
C                            KSEC1( 1)-- LENGTH OF SECTION 1 (BYTES)
C                            KSEC1( 2)-- BUFR EDITION NUMBER
C                            KSEC1( 3)-- ORIGINATING CENTRE
C                            KSEC1( 4)-- UPDATE SEQUENCE NUMBER
C                            KSEC1( 5)-- FLAG (PRESENCE OF SECTION 2)
C                            KSEC1( 6)-- BUFR MESSAGE TYPE
C                            KSEC1( 7)-- BUFR MESSAGE SUBTYPE
C                            KSEC1( 8)-- VERSION NUMBER OF LOCAL TABLE USED
C                            KSEC1( 9)-- YEAR
C                            KSEC1(10)-- MONTH
C                            KSEC1(11)-- DAY
C                            KSEC1(12)-- HOUR
C                            KSEC1(13)-- MINUTE
C                            KSEC1(14)-- BUFR MASTER TABLE
C                            KSEC1(15)-- VERSION NUMBER OF MASTER TABLE USED
C                            KSEC1(16) TO KSEC1(JSEC1) - LOCAL ADP CENTRE
C                                        INFORMATION(PACKED FORM)
C
C                            FOR BUFR EDITION 3 ONWARD
C
C                            KSEC1(16)-- ORIGINATING SUB-CENTRE
C                            KSEC1(17)-- NOT USED
C                            KSEC1(18) TO KSEC1(JSEC1) - LOCAL ADP CENTRE
C                                        INFORMATION(PACKED FORM)
C
C                            FOR BUFR EDITION 4 ONWARD
C
C                            KSEC1(16)-- ORIGINATING SUB-CENTRE
C                            KSEC1(17)-- INTERNATIONAL SUB-CATEGORY (SEE COMMON TABLE C-13
C                            KSEC1(18)-- SECOND
C                            KSEC1(19)-- YEAR
C                            KSEC1(20)-- MONTH
C                            KSEC1(21)-- DAY
C                            KSEC1(22)-- HOUR
C                            KSEC1(23)-- MINUTE
C                            KSEC1(24)-- SECOND
C                            KSEC1(25)-- YEAR
C                            KSEC1(26)-- MONTH
C                            KSEC1(27)-- DAY
C                            KSEC1(28)-- HOUR
C                            KSEC1(29)-- MINUTE
C                            KSEC1(30)-- SECOND
C                            KSEC1(31)-- MOST SOUTHERN LATITUDE  (-90 to 90)
C                            KSEC1(32)-- MOST WESTERN LONGITUDE  ( 0-360)
C                            KSEC1(33)-- MOST NORTHEN LATITUDE   (-90 to 90)
C                            KSEC1(34)-- MOST EASTERN LONGITUDE  ( 0-360)
C                            KSEC1(35) TO KSEC1(JSEC1) - LOCAL ADP CENTRE INFORMATION(PACKED FORM)
C
C        OUTPUT:
C               *KSEC2*   -  ARRAY CONTAINING SECTION 2 INFORMATION
C                            KSEC2( 1)-- LENGTH OF SECTION 2 (BYTES)
C                            KSEC2( 2) TO KSEC2(JSEC2) LOCAL ADP CENTRE
C                                        INFORMATION(PACKED FORM)
C               *KERR*    -  RETURNED ERROR CODE
C
C     METHOD.
C     -------
C
C          NONE.
C
C
C     EXTERNALS.
C     ----------
C
C
C     REFERENCE.
C     ----------
C
C          NONE.
C
C     AUTHOR.
C     -------
C
C          M. DRAGOSAVAC    *ECMWF*       17/01/91.
C
C
C     MODIFICATIONS.
C     --------------
C
C          NONE.
C
C
      IMPLICIT LOGICAL(L,O,G), CHARACTER*8(C,H,Y)
C
C
#     include "parameter.F"
#     include "bcomunit.F"
#     include "bcmwork.F"
#     include "bcmdefc.F"
C
      CHARACTER*4 CECMWF,CUSER
C
#ifndef R_4
      REAL*8 RVIND
      REAL*8 EPS
#else
      REAL   RVIND
      REAL   EPS
#endif
      DIMENSION KSEC1(JSEC1),KSEC2(JSEC2),KEY(JKEY)
      DIMENSION IDUM(8),KSEC3(JSEC3)
C
      DATA IDUM/8*0/

C
C*          1.  PACK LOCAL ADP CENTRE INFORMATION INTO KSEC2 ARRAY.
C                --------------------------------------------------
C
      KERR=0
C     
      IF(CECMWF.NE.'ECMF') THEN
         CALL BUIVAR(KERR)
         CECMWF='ECMF'
      END IF

C
C      IF(KSEC1(3).EQ.98) THEN
         IW=2
         IB=0
         CALL BUPCK(NBPW,KSEC2(IW),KEY(2)       ,IW,IB, 8,KERR)
         IF(KERR.GT.0) THEN
            WRITE(KNTN,*)  'ERROR PACKING KEY(2).'
            RETURN
         END IF
         CALL BUPCK(NBPW,KSEC2(IW),KEY(3)       ,IW,IB, 8,KERR)
         IF(KERR.GT.0) THEN
            WRITE(KNTN,*)  'ERROR PACKING KEY(3).'
            RETURN
         END IF
         CALL BUPCK(NBPW,KSEC2(IW),KEY(4)       ,IW,IB,12,KERR)
         IF(KERR.GT.0) THEN
            WRITE(KNTN,*)  'ERROR PACKING KEY(4).'
            RETURN
         END IF
         CALL BUPCK(NBPW,KSEC2(IW),KEY(5)       ,IW,IB, 4,KERR)
         IF(KERR.GT.0) THEN
            WRITE(KNTN,*)  'ERROR PACKING KEY(5).'
            RETURN
         END IF
         CALL BUPCK(NBPW,KSEC2(IW),KEY(6)       ,IW,IB, 6,KERR)
         IF(KERR.GT.0) THEN
            WRITE(KNTN,*)  'ERROR PACKING KEY(6).'
            RETURN
         END IF
         CALL BUPCK(NBPW,KSEC2(IW),KEY(7)       ,IW,IB, 5,KERR)
         IF(KERR.GT.0) THEN
            WRITE(KNTN,*)  'ERROR PACKING KEY(7).'
            RETURN
         END IF
         CALL BUPCK(NBPW,KSEC2(IW),KEY(8)       ,IW,IB, 6,KERR)
         IF(KERR.GT.0) THEN
            WRITE(KNTN,*)  'ERROR PACKING KEY(8).'
            RETURN
         END IF
         CALL BUPCK(NBPW,KSEC2(IW),KEY(9)       ,IW,IB, 6,KERR)
         IF(KERR.GT.0) THEN
            WRITE(KNTN,*)  'ERROR PACKING KEY(9).'
            RETURN
         END IF
         CALL BUPCK(NBPW,KSEC2(IW),0            ,IW,IB, 1,KERR)
         IF(KERR.GT.0) RETURN
         CALL BUPCK(NBPW,KSEC2(IW),KEY(10)      ,IW,IB,26,KERR)
         IF(KERR.GT.0) THEN
            WRITE(KNTN,*)  'ERROR PACKING KEY(10).'
            RETURN
         END IF
         CALL BUPCK(NBPW,KSEC2(IW),0            ,IW,IB, 6,KERR)
         IF(KERR.GT.0) RETURN
         CALL BUPCK(NBPW,KSEC2(IW),KEY(11)      ,IW,IB,25,KERR)
         IF(KERR.GT.0) THEN
            WRITE(KNTN,*)  'ERROR PACKING KEY(11).'
            RETURN
         END IF
         CALL BUPCK(NBPW,KSEC2(IW),0            ,IW,IB, 7,KERR)
         IF(KERR.GT.0) RETURN
C
         IF(KEY(14).GT.1.OR.KEY(2).EQ.2.OR.KEY(2).EQ.3.OR.
     1      KEY(2).EQ.12.OR.KEY(2).EQ.8) THEN
            CALL BUPCK(NBPW,KSEC2(IW),KEY(12)   ,IW,IB,26,KERR)
            IF(KERR.GT.0) THEN
               WRITE(KNTN,*)  'ERROR PACKING KEY(12).'
               RETURN
            END IF
            CALL BUPCK(NBPW,KSEC2(IW),0         ,IW,IB, 6,KERR)
            IF(KERR.GT.0) RETURN
            CALL BUPCK(NBPW,KSEC2(IW),KEY(13)   ,IW,IB,25,KERR)
            IF(KERR.GT.0) THEN
               WRITE(KNTN,*)  'ERROR PACKING KEY(13).'
               RETURN
            END IF
            CALL BUPCK(NBPW,KSEC2(IW),0         ,IW,IB, 7,KERR)
            IF(KERR.GT.0) RETURN
            IF(KEY(14).GT.255.OR.KEY(3).GE.121.AND.
     1         KEY(3).LE.130.OR.KEY(3).EQ.31) THEN
               CALL BUPCK(NBPW,KSEC2(IW),KEY(14),IW,IB,16,KERR)
               IF(KERR.GT.0) THEN
                  WRITE(KNTN,*)  'ERROR PACKING KEY(14).'
                  RETURN
               END IF
               CALL BUPCK(NBPW,KSEC2(IW),KEY(15),IW,IB,16,KERR)
               IF(KERR.GT.0) THEN
                  WRITE(KNTN,*)  'ERROR PACKING KEY(15).'
                  RETURN
               END IF
               CALL BUPKS(NBPW,KSEC2(IW),IDUM  ,IW,IB,8,0,4,KERR)
               IF(KERR.GT.0) RETURN
               CALL BUPCK(NBPW,KSEC2(IW),0      ,IW,IB, 8,KERR)
               IF(KERR.GT.0) RETURN
            ELSE
               CALL BUPCK(NBPW,KSEC2(IW),KEY(14),IW,IB, 8,KERR)
               IF(KERR.GT.0) THEN
                  WRITE(KNTN,*)  'ERROR PACKING KEY(14).'
                  RETURN
               END IF
               CALL BUPCK(NBPW,KSEC2(IW),KEY(15),IW,IB,16,KERR)
               IF(KERR.GT.0) THEN
                  WRITE(KNTN,*)  'ERROR PACKING KEY(15).'
                  RETURN
               END IF
               CALL BUPKS(NBPW,KSEC2(IW),IDUM      ,IW,IB,8,0,4,KERR)
               IF(KERR.GT.0) RETURN
               CALL BUPCK(NBPW,KSEC2(IW),0      ,IW,IB,16,KERR)
               IF(KERR.GT.0) RETURN
            END IF
            GO TO 140
         ELSE
            CALL BUPKS(NBPW,KSEC2(IW),KEY(16),IW,IB,8,0,9,KERR)
            IF(KERR.GT.0) THEN
               WRITE(KNTN,*)  'ERROR PACKING KEY(16).'
               RETURN
            END IF
            CALL BUPKS(NBPW,KSEC2(IW),IDUM(1),IW,IB,8,0,8,KERR)
            IF(KERR.GT.0) RETURN
         END IF
C
C
C*          1.4 SUB KEY INFORMATION.
C               --------------------
 140  CONTINUE
C
         CALL BUPCK(NBPW,KSEC2(IW),KEY(25),IW,IB,16,KERR)
         IF(KERR.GT.0) THEN
            WRITE(KNTN,*)  'ERROR PACKING KEY(25).'
            RETURN
         END IF
         CALL BUPCK(NBPW,KSEC2(IW),KEY(26),IW,IB, 6,KERR)
         IF(KERR.GT.0) THEN
            WRITE(KNTN,*)  'ERROR PACKING KEY(26).'
            RETURN
         END IF
         CALL BUPCK(NBPW,KSEC2(IW),KEY(27),IW,IB, 5,KERR)
         IF(KERR.GT.0) THEN
            WRITE(KNTN,*)  'ERROR PACKING KEY(27).'
            RETURN
         END IF
         CALL BUPCK(NBPW,KSEC2(IW),KEY(28),IW,IB, 6,KERR)
         IF(KERR.GT.0) THEN
            WRITE(KNTN,*)  'ERROR PACKING KEY(28).'
            RETURN
         END IF
         CALL BUPCK(NBPW,KSEC2(IW),KEY(29),IW,IB, 6,KERR)
         IF(KERR.GT.0) THEN
            WRITE(KNTN,*)  'ERROR PACKING KEY(29).'
            RETURN
         END IF
         CALL BUPCK(NBPW,KSEC2(IW),0      ,IW,IB, 1,KERR)
         IF(KERR.GT.0) RETURN
C
         CALL BUPCK(NBPW,KSEC2(IW),KEY(30),IW,IB, 6,KERR)
         IF(KERR.GT.0) THEN
            WRITE(KNTN,*)  'ERROR PACKING KEY(30).'
            RETURN
         END IF
         CALL BUPCK(NBPW,KSEC2(IW),KEY(31),IW,IB, 5,KERR)
         IF(KERR.GT.0) THEN
            WRITE(KNTN,*)  'ERROR PACKING KEY(31).'
            RETURN
         END IF
         CALL BUPCK(NBPW,KSEC2(IW),KEY(32),IW,IB, 6,KERR)
         IF(KERR.GT.0) THEN
            WRITE(KNTN,*)  'ERROR PACKING KEY(32).'
            RETURN
         END IF
         CALL BUPCK(NBPW,KSEC2(IW),KEY(33),IW,IB, 6,KERR)
         IF(KERR.GT.0) THEN
            WRITE(KNTN,*)  'ERROR PACKING KEY(33).'
            RETURN
         END IF
         CALL BUPCK(NBPW,KSEC2(IW),0      ,IW,IB, 1,KERR)
         IF(KERR.GT.0) RETURN
         CALL BUPCK(NBPW,KSEC2(IW),KEY(34),IW,IB, 6,KERR)
         IF(KERR.GT.0) THEN
            WRITE(KNTN,*)  'ERROR PACKING KEY(34).'
            RETURN
         END IF
         CALL BUPCK(NBPW,KSEC2(IW),KEY(35),IW,IB, 1,KERR)
         IF(KERR.GT.0) THEN
            WRITE(KNTN,*)  'ERROR PACKING KEY(35).'
            RETURN
         END IF
         CALL BUPCK(NBPW,KSEC2(IW),KEY(36),IW,IB, 1,KERR)
         IF(KERR.GT.0) THEN
            WRITE(KNTN,*)  'ERROR PACKING KEY(36).'
            RETURN
         END IF
         CALL BUPCK(NBPW,KSEC2(IW),KEY(37),IW,IB, 6,KERR)
         IF(KERR.GT.0) THEN
            WRITE(KNTN,*)  'ERROR PACKING KEY(37).'
            RETURN
         END IF
         CALL BUPCK(NBPW,KSEC2(IW),KEY(38),IW,IB, 1,KERR)
         IF(KERR.GT.0) THEN
            WRITE(KNTN,*)  'ERROR PACKING KEY(38).'
            RETURN
         END IF
         CALL BUPCK(NBPW,KSEC2(IW),KEY(39),IW,IB, 1,KERR)
         IF(KERR.GT.0) THEN
            WRITE(KNTN,*)  'ERROR PACKING KEY(39).'
            RETURN
         END IF
         CALL BUPCK(NBPW,KSEC2(IW),KEY(40),IW,IB, 6,KERR)
         IF(KERR.GT.0) THEN
            WRITE(KNTN,*)  'ERROR PACKING KEY(40).'
            RETURN
         END IF
         CALL BUPCK(NBPW,KSEC2(IW),KEY(41),IW,IB, 1,KERR)
         IF(KERR.GT.0) THEN
            WRITE(KNTN,*)  'ERROR PACKING KEY(41).'
            RETURN
         END IF
         CALL BUPCK(NBPW,KSEC2(IW),KEY(42),IW,IB, 1,KERR)
         IF(KERR.GT.0) THEN
            WRITE(KNTN,*)  'ERROR PACKING KEY(42).'
            RETURN
         END IF
         CALL BUPCK(NBPW,KSEC2(IW),KEY(43),IW,IB, 6,KERR)
         IF(KERR.GT.0) THEN
            WRITE(KNTN,*)  'ERROR PACKING KEY(43).'
            RETURN
         END IF
         CALL BUPCK(NBPW,KSEC2(IW),KEY(44),IW,IB, 1,KERR)
         IF(KERR.GT.0) THEN
            WRITE(KNTN,*)  'ERROR PACKING KEY(44).'
            RETURN
         END IF
         CALL BUPCK(NBPW,KSEC2(IW),KEY(45),IW,IB, 1,KERR)
         IF(KERR.GT.0) THEN
            WRITE(KNTN,*)  'ERROR PACKING KEY(45).'
            RETURN
         END IF
         CALL BUPCK(NBPW,KSEC2(IW),KEY(46),IW,IB, 8,KERR)
         IF(KERR.GT.0) THEN
            WRITE(KNTN,*)  'ERROR PACKING KEY(46).'
            RETURN
         END IF
C
C      ELSE
C         WRITE(KNTN,'(1H )')
C         WRITE(KNTN,'(1H ,A)') 'BUPKEY : KEY DEFINITION NOT PACKED.'
C         WRITE(KNTN,'(1H )')
C      END IF
C
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE CREXS2DATA(KBUFL ,YBUFF ,KSUP  ,KSEC3, KELEM,
     1                      CNAMES,CUNITS,KVALS,VALUES,CVALS,KERR)
C
C**** *CREXS2DATA*
C
C
C     PURPOSE.
C     --------
C          Expand section 2 of Crex (data section)
C
C
C**   INTERFACE.
C     ----------
C
C          *CALL* *CREXS2DATA(KBUFL,YBUFF,KSUP,KSEC3,KELEM,CNAMES,
C                         CUNITS,KVALS,VALUES,CVALS,KERR)*
C
C        INPUT :
C               *KBUFL*   -  length of CREX message (words)
C               *YBUFF*   -  Character string containing data
C               *KELEM*   -  dimension of CNAMES, CUNITS array
C               *KVALS*   -  dimension of VALUES array
C        OUTPUT:
C               *KSUP*    -  Integer array of 9 words containing
C                            suplementary information
C                         -  KSUP( 1) -- IDIM1, dimension of KSEC1
C                         -  KSUP( 2) -- Reserved
C                         -  KSUP( 3) -- IDIM3, dimension of KSEC3
C                         -  KSUP( 4) -- Reserved
C                         -  KSUP( 5) -- M (number of elements in values
C                                           array, first index)
C                         -  KSUP( 6) -- N (number of subsets,second index
C                                           of values array)
C                         -  KSUP( 7) -- JVC (number of elements in CVAL array)
C                         -  KSUP( 8) -- total CREX message length in bytes
C                         -  KSUP( 9) -- IDIM0, dimension of KSEC0
C
C               *KSEC3*   -  array containing section 3 information
C                            KSEC3( 1)-- length of section 3 (bytes)
C                            KSEC3( 2)-- reserved
C                            KSEC3( 3)-- number of subsets
C                            KSEC3( 4)-- flag (data type,data compression)
C               *CNAMES*  -  character array containing element names
C               *CUNITS*  -  character array containig units
C               *VALUES*  -  real*8 array (expanded data values)
C               *CVALS*   -  character array containing text
C               *KERR*    -  returned error code
C
C     METHOD.
C     -------
C
C           NONE.
C
C
C     EXTERNALS.
C     ----------
C
C
C
C     REFERENCE.
C     ----------
C
C          NONE.
C
C     AUTHOR.
C     -------
C
C          MILAN DRAGOSAVAC    *ECMWF*       17/01/2003.
C
C
C     MODIFICATIONS.
C     --------------
C
C          NONE.
C
C--------------------------------------------------------------------------------------------
      IMPLICIT LOGICAL(L,O,G), CHARACTER*8(C,H,Y)
C
C
      PARAMETER(JSUP =   9,JSEC0=   3,JSEC1= 40,JSEC2= 64 ,JSEC3=    4,
     1          JSEC4=   2,JELEM=40000,JSUBS=400,JCVAL=150 ,JBUFL=40000,
     2          JBPW =  32,JTAB =3000,JCTAB=120,JCTST=1800,JCTEXT= 200,
     3          JWORK=360000,JKEY=46)
C
      COMMON /CREXWORK/ NBPT,NGS,NVIND,NBPTSEC2,RVIND,EPS,NE,IEOLD,
     1                  NC07YYY
C
C
      COMMON /CREXWT/ NCREXDWINC,NCREXSCAM,NCREXAFDW,NCREXWT ,ODREPF,
     2               NCREXSTACK(JELEM),NCREXWTEN(JELEM),
     3               NCREXWTR (JELEM),NCREXWTS (JELEM),NCREXWTRV(JELEM),
     4               NCREXWTDW(JELEM),NWTIW(JELEM),NWTIWS(JELEM)
C
C             NCREXDWINC   -  data width increment
C             NCREXSCAM    -  scale multiplier
C             NCREXAFDW    -  augmented field data width
C             NCREXWT      -  pointer to working table
C             NCREXSTACK   -  list of data descriptors
C             ODREPF   -  replication (logical)
C             NCREXWTR     -  working table reference
C             NCREXWTS     -  working scale
C             NCREXWTRV    -  working reference value
C             NCREXWTDW    -  working data width
C             NWTIW    -  working data width of increments
C             NWTIWS   -  working total data width of element set
C
      CHARACTER CREXWTEN*64,CREXWTU*24
C
C
      COMMON /CREXWTC/ CREXWTEN(JELEM),CREXWTU (JELEM)
C
C             CREXWTEN    -  working table element naame
C             CREXWTU     -  working table units
C
C
C
      COMMON /CREXBEF / M,MM,N,JCV
C
C             M       -  Number of elements
C             MM      -  Number of elements
C             N       -  Number of data sub_sets
C             JCV     -  Number of character values
C
C
C
      COMMON /CREXOFF/ NSIZEG(JELEM),NCREXWTRG(JWORK),
     1                 NBP,NSUBSET,OMULTI
C
C
      CHARACTER*64 CNAMES(KELEM)
      CHARACTER*24 CUNITS(KELEM)
      CHARACTER*80 CVALS(KVALS),CH
C
      CHARACTER*(*) YBUFF
C
      DIMENSION ILIST(JELEM),IVALUES(JELEM) 
C
C
      REAL*8 VALUES(KVALS)
      REAL*8 RVIND
      REAL*8 EPS
C
      DIMENSION KSUP(JSUP),KSEC3(JSEC3)
C
C     ------------------------------------------------------------------
C*          1.  EXPAND PRELIMINARY ITEMS FROM SECTION4.
C               ---------------------------------------
 100  CONTINUE
C
C                JCV - POINTER TO CVALS ARRAY
C                JWT - POINTER TO WORKING TABLE ARRAY
C                JNS - POINTER TO VALUES ARRAY FOR SUB-SETS.
C
      IF(KERR.GT.0) RETURN
C
      IF(NSUBSET.EQ.1) THEN
         JCV = 0
      END IF
      OREPF =.FALSE.
      IEOLD=0
C
C     ------------------------------------------------------------------
C
C*          3.  Expand the data
C               ---------------
 300  CONTINUE
C
         IF(KELEM.LT.M) THEN
            KERR=25
            CALL CREXERR(KERR)
            RETURN
         END IF
c
         JNS=NSUBSET
C
         KSEC3(4)=0
         KSUP(5)=NSIZEG(NSUBSET)
C
         CALL NEXTPRT(KBUFL,YBUFF,NBPT,NGS,KERR )
         IF(KERR.NE.0) THEN
            print*,'nextprt: error ',ierr
            RETURN
         END IF
c
         ITEMP=NBPT
         CALL NEXTSEC(KBUFL,YBUFF, ITEMP,NGS,KERR )
         IF(KERR.NE.0) THEN
            print*,'nextsec: error ',ierr
            RETURN
         END IF
c
 301     CONTINUE
C
         KSEC3(3)=JNS
         KSUP(6)=JNS
C
         JNSK=(JNS-1)*KELEM
         IF(JNSK.GT.KVALS) THEN
            KERR=14
            CALL CREXERR(KERR)
            print*,'Size of values array too small.'
            print*,'Number of subsets=',jns
            print*,'Number of elements=',M
            print*,'Kelem=',KELEM

            RETURN
         END IF
C
         DO IZ=JNSK+1,JNSK+M
         VALUES(IZ)=RVIND
         END DO
C
         DO 302 JWT=1,M
C
         JWTJNS=JWT+JNSK
C

         IF(NCREXWTDW(JWT).EQ.0) THEN
            VALUES(JWTJNS)=0.0
            GO TO 302
         END IF
C
         NBPTKEEP=NBPT
c        CALL NEXTSEP(KBUFL,YBUFF,NBPT,ITEMP,KERR)
         CALL NEXTPRT(KBUFL,YBUFF,NBPT,ITEMP,KERR )
         IF(NBPT.GE.ITEMP) GO TO 600
c
c
c        Check for next E
C
         IF(NE.EQ.1) THEN
            IE=ICHAR(YBUFF(NBPT:NBPT))-48
            IF(IE.LT.0.OR.IE.GT.9) THEN
               print*,'E leading character is not a figure',
     1                 'for ',JWT,' element.'
               IEOLD=IEOLD+1
               IF(IEOLD.EQ.10) IEOLD=0
               CALL NEXTSEP(KBUFL,YBUFF,NBPT,ITEMP,KERR)
               VALUES(JWTJNS)=RVIND
               GO TO 302
            END IF
c
            IF((IE-IEOLD).EQ.1.OR.(IE-IEOLD).EQ.-9) THEN
               IEOLD=IE
            ELSE
c              check next group
               IBPT=NBPT
               CALL NEXTSEP(KBUFL,YBUFF,IBPT,ITEMP,KERR)
               CALL NEXTPRT(KBUFL,YBUFF,IBPT,ITEMP,KERR )
               IENEXT=ICHAR(YBUFF(NBPT:NBPT))-48 
               IF((IENEXT-IEOLD).GE.2.OR.(IENEXT-IEOLD).LT.0) THEN
                   print*,JWT,' Group is missing for ',NCREXWTR(JWT),
     1                    ' element.'
                  IEOLD=IEOLD+1
                  IF(IEOLD.EQ.10) IEOLD=0
                  NBPT=NBPTKEEP
                  VALUES(JWTJNS)=RVIND
                  GO TO 302
               END IF
            END IF
            NBPT=NBPT+1
         ELSE
c              check next group
c              nbpt points to first character of next group
               IBPT=NBPT
               CALL NEXTSEP(KBUFL,YBUFF,IBPT,ITEMP,KERR)
               if((IBPT-NBPT).ne.NCREXWTDW(JWT)) THEN
                  if(NCREXWTEN(JWT).eq.658367) THEN
                     izz=NBPT+NCREXWTDW(JWT)
                     if(YBUFF(izz:izz).eq.' ') then
                        IBPT=NBPT+NCREXWTDW(JWT)   
                        go to 305
                     end if
                  end if
                  do iz=JWT-1,1,-1
                  if(NCREXWTDW(JWT).eq.NCREXWTDW(iz)) then
                     print*,iz,'Group is possibly missing ',
     1                      NCREXWTR(iz),
     2               'values replaced with missing value'
                     VALUES(iz)=rvind
                  else
                     go to 111
                  end if
                  end do
c                    
                  
 111              CONTINUE
                  IF(NCREXWTEN(JWT).EQ.658367) THEN
                     JCV=JCV+1
                     VALUES(JWTJNS)=JCV*1000+NCREXWTDW(JWT)
                     CVALS(JCV)=' '
                  ELSE
                     VALUES(JWTJNS)=RVIND
                  END IF
                  NBPT=IBPT
                  GO TO 302
                end if
         END IF
C
 305  CONTINUE
C
         IF(NCREXWTR(JWT).EQ.31011.OR.
     1      NCREXWTR(JWT).EQ.31012) OREPF=.TRUE.
C
C
C     ------------------------------------------------------------------
C*          3.1 CHARACTER DATA ?
C               ----------------
 310  CONTINUE
C
         IF(NCREXWTEN(JWT).EQ.658367) THEN
C
C*          3.2  OBTAIN CHARACTER DATA FROM DATA SECTION.
C                ----------------------------------------
 320  CONTINUE
C
            IY=NCREXWTDW(JWT)
C
            CALL EXTGRPC(KBUFL,YBUFF, NBPT,IY,CH,KERR)
            IF(KERR.NE.0) THEN
               print*,'extgrpc : problem for ',JWT,' th' 
               print*,' element', NCREXWTR(JWT)
               print*,'Element is missing'
            END IF
C
C*          3.3  MOVE CHARACTER DATA TO "CVALS".
C                -------------------------------
 330  CONTINUE
C
            IYLINE=IY/80
            IYOFF =IY-IYLINE*80
            JCVINC=IYLINE
C
            JCV = JCV + 1
            JCVW= JCV
C
            IF(IYLINE.EQ.0) THEN
               CVALS(JCVW)(1:iy)=ch(1:iY)
            ELSE
               DO 332 J=1,IYLINE
               DO 333 JJ=1,80
               CVALS(JCVW)(JJ:JJ)= CH(JJ:JJ)
 333           CONTINUE
C
               JCVW=JCVW+1
C
 332           CONTINUE
C
               DO 334 J=1,IYOFF
               CVALS(JCVW)(J:J)= CH(J:J)
 334           CONTINUE
C
            END IF
C
C*          3.4  COMPUTE POINTER VALUES TO BE STORED IN "VALUES".
C                ------------------------------------------------
 340  CONTINUE
C
            VALUES(JWTJNS) = JCV*1000 + IY
            JCV            = JCV + JCVINC
C
            GO TO 302
C
         END IF
C
C*          3.5  OBTAIN VALUE FROM DATA SECTION.
C                -------------------------------
 350  CONTINUE
C
         CALL EXTGRP(KBUFL,YBUFF, NBPT,NCREXWTDW(JWT),IVAL,KERR)
         IF(KERR.NE.0) THEN
            print*,'extgrp : error ',kerr
            RETURN
         END IF
C
C     -----------------------------------------------------------------
C*          3.6  UPDATE THE ARRAY "VALUES".
C                --------------------------
 360  CONTINUE
C
C
C        CHECK IF DATA IS MISSING
C
         IF(IVAL.EQ.NVIND) THEN
            VALUES(JWTJNS)=RVIND
         ELSE
            IF(CREXWTU(JWT)(1:4).EQ.'FLAG') then
               CALL OCTAL2DEC(IVAL,IIVAL,KERR)
               IVAL=IIVAL
            END IF
            IF(NCREXWTS(JWT).GT.0) THEN
               VALUES(JWTJNS)= IVAL/10.**NCREXWTS(JWT)
            ELSE
               IIWTS=IABS(NCREXWTS(JWT))
               VALUES(JWTJNS)= IVAL*10.**IIWTS
            END IF
         END IF
C
         CALL NEXTSEP(KBUFL,YBUFF,NBPT,ITEMP,KERR)
c
         IF(NBPT.GE.ITEMP) THEN
            OMULTI=.FALSE.
            GO TO 600
         END IF
C
 302     CONTINUE
C
         ITEMP1=NBPT
         CALL NEXTSUBSET(KBUFL,YBUFF, ITEMP1,NGS,KERR )
         IF(ITEMP1.LT.NGS) THEN
c           JNS=JNS+1
            N=JNS
            IEOLD=0
c           GO TO 301
         ELSE
            OMULTI=.FALSE.
         END IF 
C
         KSUP(7)=JCV
C
C     -----------------------------------------------------------------
C*            6.  SET SUPPLEMENTARY INFORMATION.
C                 ------------------------------
C
 600  CONTINUE
C
      NBP=NBPT
      KSUP(4)= 2
C
C     ------------------------------------------------------------------
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      INTEGER FUNCTION YYYY2CY(YYYY, CENTURY, YEAR)
C
C---->
C**** YYYY2CY
C
C     Purpose
C     -------
C
C     Return WMO defined century and year from YYYY date.
C
C
C     Interface
C     ---------
C
C     IRET = YYYY2CY(YYYY, CENTURY, YEAR)
C
C     Input
C     -----
C
C     YYYY    = Integer date in YYYY formay (eg 1998)
C
C
C     Output
C     ------
C
C     CENTURY = Integer century in CC format (eg 20 for 1998)
C     YEAR    = Integer year in range 1 to 100 (eg 98 for 1998)
C
C     Returns 0 if function worked OK.
C     Otherwise an illegal year has been give.
C
C
C     Method
C     ------
C
C     Last year in century is year 100
C     (eg year 2000 is century 20, year 100)
C
C
C     Author
C     ------
C
C     J.D.Chambers     ECMWF     Sept 1998
C
C
C ------------------------------------------------------------------
C----<
C
      IMPLICIT NONE
C
C     Function arguments
C
      INTEGER YYYY, CENTURY, YEAR
C
C ------------------------------------------------------------------
C*    Section 1.   Check valid input year (0000 to 9999)
C ------------------------------------------------------------------
C
  100 CONTINUE
C
C     Check valid input year (0000 to 9999)
C
      IF( (YYYY.LT.0).OR.(YYYY.GT.9999) ) THEN
        YYYY2CY = 1
        RETURN
      ENDIF
C
      YEAR = YYYY - 1
      YEAR = MOD(YEAR,100) + 1
C
      CENTURY = (YYYY/100 +1 )
      IF( YEAR.EQ.100 ) CENTURY = CENTURY - 1
C
C ------------------------------------------------------------------
C*    Section 9.   Return
C ------------------------------------------------------------------
C
  900 CONTINUE
C
      YYYY2CY = 0
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities
C granted to it by virtue of its status as an intergovernmental organisation
C nor does it submit to any jurisdiction.
C

      SUBROUTINE QU2REG2(PFIELD,KPOINT,KLAT,KLON,KCODE,PMSVAL,KRET)
C
C---->
C**** QU2REG - Convert quasi-regular grid data to regular.
C
C     Purpose.
C     --------
C
C     Convert quasi-regular grid data to regular,
C     using either a linear or cubic interpolation.
C
C
C**   Interface.
C     ----------
C
C     CALL QU2REG2(PFIELD,KPOINT,KLAT,KLON,KCODE,PMSVAL)
C
C
C     Input Parameters.
C     -----------------
C
C     PFIELD     - Array containing quasi-regular grid
C                  data.
C
C     KPOINT     - Array containing list of the number of
C                  points on each latitude (or longitude) of
C                  the quasi-regular grid.
C
C     KLAT       - Number of latitude lines
C
C     KLON       - Number of longitude lines
C
C     KCODE      - Interpolation required.
C                  1 , linear - data quasi-regular on
C                               latitude lines.
C                  3 , cubic -  data quasi-regular on
C                               latitude lines.
C                  11, linear - data quasi-regular on
C                               longitude lines.
C                  13, cubic -  data quasi-regular on
C                               longitude lines.
C
C     PMSVAL     - Value used for missing data indicator.
C
C
C     Output Parameters.
C     ------------------
C
C     KRET       - return code
C                  0 = OK
C                  non-zero indicates fatal error
C
C
C     Output Parameters.
C     ------------------
C
C     PFIELD     - Array containing regular grid data.
C
C
C     Method.
C     -------
C
C     Data is interpolated and expanded into a temporary array,
C     which is then copied back into the user's array.
C     Returns an error code if an invalid interpolation is requested
C     or field size exceeds array dimensions.
C
C
C     Externals.
C     ----------
C
C     ROWINA2
C
C
C     Reference.
C     ----------
C
C     WMO Manual on Codes for GRIB code specifications of
C     quasi-regular grids.
C
C
C     Comments.
C     ---------
C
C     This routine is an adaptation of QU2REG to allow missing data
C     values, and hence bit mapped fields.
C
C
C     Author.
C     -------
C
C     J.D.Chambers     ECMWF      22.07.94
C
C
C     Modifications.
C     --------------
C
C     J.D.Chambers     ECMWF      13.09.94
C     Add return code KRET and remove calls to ABORT.
C
C     J.D.Chambers     ECMWF        Feb 1997
C     Allow for 64-bit pointers
C
C
C----<
C     -----------------------------------------------------------------
C*    Section 0. Definition of variables. Data statements.
C     -----------------------------------------------------------------
C
      IMPLICIT NONE
C
C     Parameters
C
      INTEGER JPBYTES, JPMAX
#ifdef REAL_8
      PARAMETER (JPBYTES = 8)
#else
      PARAMETER (JPBYTES = 4)
#endif
      PARAMETER (JPMAX=721)
C     Maximum number of latitudes (or longitudes), for which arrays
C     are dimensioned.
C
C     Subroutine arguments
C
      REAL PFIELD, PMSVAL
      DIMENSION PFIELD(*)
      INTEGER KPOINT, KLAT, KLON, KCODE, KRET
      DIMENSION KPOINT(*)
C
C     Local variables.
C
      INTEGER ICODE, ILII, ILIO, IQUANO, IREGNO
      INTEGER J210, J220, J225, J230, J240
C
      REAL ZLINE, ZWORK
      DIMENSION ZLINE(JPMAX*2)
      DIMENSION ZWORK(0:JPMAX*2+2,3)
C
#ifndef _CRAYFTN
#ifdef POINTER_64
      INTEGER*8 IZTEMP
#endif
#endif
      REAL ZTEMP
      DIMENSION ZTEMP(1)
      POINTER ( IZTEMP, ZTEMP )
      INTEGER ISIZE
      SAVE ISIZE, IZTEMP
C
C     Externals
C
#ifdef POINTER_64
      INTEGER*8 JMALLOC
#else
      INTEGER JMALLOC
#endif
      EXTERNAL JMALLOC
C
      DATA ISIZE/0/
C
C     ------------------------------------------------------------------
C*    Section 1. Set initial values.
C     ------------------------------------------------------------------
C
  100 CONTINUE
C
      KRET = 0
C
C     Check input parameters.
C
      IF (KCODE.NE.1.AND.KCODE.NE.3.AND.KCODE.NE.11.AND.KCODE.NE.13)
     X  THEN
        WRITE (*,9001) KCODE
        KRET = 1
        GOTO 900
      ENDIF
C
      IF (KLAT.GT.JPMAX) THEN
        WRITE (*,9002) KLAT , JPMAX
        KRET = 2
        GOTO 900
      ENDIF
C
      IF (KLON.GT.JPMAX*2) THEN
        WRITE (*,9003) KLAT , JPMAX*2
        KRET = 3
        GOTO 900
      ENDIF
C
C     Set array indices to 0.
C
      ILII  = 0
      ILIO  = 0
C
C     Establish values of loop parameters.
C
      IF (KCODE.GT.10) THEN
C
C       Quasi-regular along longitude lines.
C
        IQUANO = KLON
        IREGNO = KLAT
        ICODE  = KCODE - 10
      ELSE
C
C       Quasi-regular along latitude lines.
C
        IQUANO = KLAT
        IREGNO = KLON
        ICODE  = KCODE
      ENDIF
C
C     Allocate memory (first time only)
      IF( ISIZE.EQ.0 ) THEN
        ISIZE = (JPMAX*JPMAX*2)*JPBYTES
        IZTEMP = JMALLOC(ISIZE)
#ifdef hpR64
        IZTEMP = IZTEMP/(1024*1024*1024*4)
#endif
        IF( IZTEMP.EQ.0 ) THEN
          WRITE(*,*) 'QU2REG2: Memory allocation failed.'
          WRITE(*,*) 'QU2REG2: Number of bytes required = ', ISIZE
          KRET = 5
          GOTO 900
        ENDIF
      ENDIF
C
C     ------------------------------------------------------------------
C*    Section 2. Interpolate field from quasi to regular grid.
C     ------------------------------------------------------------------
C
  200 CONTINUE
C
      DO 230 J230=1,IQUANO
C
        IF (IREGNO.NE.KPOINT(J230)) THEN
C
C         Line contains less values than required,so
C         extract quasi-regular grid values for a line
C
          DO 210 J210=1,KPOINT(J230)
            ILII        = ILII+1
            ZLINE(J210) = PFIELD(ILII)
  210     CONTINUE
C
C         and interpolate this line.
C
          CALL ROWINA2( ZLINE, IREGNO, KPOINT(J230), ZWORK, ICODE,
     X                  PMSVAL, KRET)
          IF ( KRET .NE. 0 ) GOTO 900
C
C         Add regular grid values for this line to the temporary array.
C
          DO 220 J220=1,IREGNO
            ILIO        = ILIO+1
            ZTEMP(ILIO) = ZLINE(J220)
  220     CONTINUE
C
        ELSE
C
C         Line contains the required number of values, so add
C         this line to the temporary array.
C
          DO 225 J225=1,IREGNO
            ILIO        = ILIO+1
            ILII        = ILII+1
            ZTEMP(ILIO) = PFIELD(ILII)
  225     CONTINUE
C
        ENDIF
C
  230 CONTINUE
C
C     Copy temporary array to user array.
C
      DO 240 J240=1,KLON*KLAT
        PFIELD(J240) = ZTEMP(J240)
  240 CONTINUE
C
C     ------------------------------------------------------------------
C*    Section 9. Return to calling routine. Format statements.
C     ------------------------------------------------------------------
C
  900 CONTINUE
C
      RETURN
C
 9001 FORMAT (1H ,'QU2REG : Invalid interpolation type code = ',I3)
C
 9002 FORMAT (1H ,'QU2REG : Number of latitudes is ',I4,', maximum ',
     C                      'allowed is ',I3,'.')
C
 9003 FORMAT (1H ,'QU2REG : Number of longitudes is ',I4,', maximum ',
     C                      'allowed is ',I3,'.')
C
      END

C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      INTEGER FUNCTION ZPREC (POFELD, KOWE, KONS, KPR, KERR)
C
C---->
C**** *ZPREC*
C
C     PURPOSE
C     _______
C
C     Perform additional interpolation processes for precipitation
C     fields
C
C     INTERFACE
C     _________
C
C     IERR = ZPREC ( POFELD, KOWE, KONS, KPR, KERR)
C
C     Input parameters
C     ________________
C
C     POFELD     - The output field as previously calculated.
C
C     KOWE       - The number of points in the West-East direction in
C                  the output field.
C
C     KONS       - The number of points in the North-South direction
C                  in the output field.
C
C     KPR        - The debug print switch.
C                  0  , No debugging output.
C                  1  , Produce debugging output.
C
C     KERR       - The error control flag.
C                  -ve, No error message. Return error code.
C                  0  , Hard failure with error message.
C                  +ve, Print error message. Return error code.
C
C     Output parameters
C     ________________
C
C     POFELD     - The output field as modified to allow for
C                  precipitation.
C
C     Return value
C     ____________
C
C     The error indicator (INTEGER).
C
C     Error and Warning Return Values
C     _______________________________
C
C     None
C
C     Common block usage
C     __________________
C
C     None
C
C     EXTERNALS
C     _________
C
C     INTLOG(R)    - Logs messages.
C     CHKPREC - Check if precipitation threshold has been redefined
C
C     METHOD
C     ______
C
C     The precipitation at a point is set to zero if the value is less
C     then threshold 
C
C     REFERENCE
C     _________
C
C     None
C
C     COMMENTS
C     ________
C
C     Program contains sections 0 to 3
C
C     AUTHOR
C     ______
C
C     S. Curic      *ECMWF*      Sep 2005
C
C     MODIFICATIONS
C     _____________
C
C     None
C
C----<
C     _______________________________________________________
C
C
C*    Section 0. Definition of variables.
C     _______________________________________________________
C
C*    Prefix conventions for variable names
C
C     Logical      L (but not LP), global or common.
C                  O, dummy argument
C                  G, local variable
C                  LP, parameter.
C     Character    C, global or common.
C                  H, dummy argument
C                  Y (but not YP), local variable
C                  YP, parameter.
C     Integer      M and N, global or common.
C                  K, dummy argument
C                  I, local variable
C                  J (but not JP), loop control
C                  JP, parameter.
C     REAL         A to F and Q to X, global or common.
C                  P (but not PP), dummy argument
C                  Z, local variable
C                  PP, parameter.
C
C     Implicit statement to force declarations
C
      IMPLICIT NONE
C
#include "parim.h"
#include "nifld.common"
C
C     Dummy arguments
      INTEGER KOWE, KONS, KPR, KERR
      REAL POFELD (KOWE, KONS)
C
C     Local variables
      INTEGER JOLAT, JOLON
      INTEGER JPROUTINE
      PARAMETER (JPROUTINE = 23500)
C
C     _______________________________________________________
C
C*    Section 1. Initialisation
C     _______________________________________________________
C
      IF (KPR.GE.1) CALL INTLOG(JP_DEBUG,'ZPREC: Section 1.',JPQUIET)
C
      ZPREC = 0
C
      IF (KPR .GE. 1) THEN
        CALL INTLOG(JP_DEBUG,'ZPREC: No. of output fld lats = ',KONS)
        CALL INTLOG(JP_DEBUG,'ZPREC: No. of output fld longs = ',KOWE)
      ENDIF
C
C     _______________________________________________________
C
C*    Section 2. eliminate output negative  precipitation
C     _______________________________________________________
C
      IF (KPR.GE.1) CALL INTLOG(JP_DEBUG,'IRPREC: Section 2.',JPQUIET)
C
       CALL CHKPREC()
C
      DO 360 JOLAT = 1, KONS
C
         DO 210 JOLON = 1, KOWE
C
            IF (POFELD (JOLON, JOLAT) .LT. ZPRECIP) THEN
               POFELD (JOLON, JOLAT) = PPZERO
            ENDIF
C
  210    CONTINUE
C
C
  360 CONTINUE
C
C     _______________________________________________________
C
C
C*    Section 3. Return to calling routine. Format statements
C     _______________________________________________________
C
C
      IF (KPR.GE.1) CALL INTLOG(JP_DEBUG,'ZPREC: Section 3.',JPQUIET)
C
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE NEXTPRT (KBUFL,YBUFF,I,J,KERR )
C
C**** *NEXTPRT*
C
C
C     PURPOSE.
C     --------
C         SCANS BULLETIN IN 'KCHAR' FOR NEXT CHARACTER WHICH
C         IS NOT 'SOH' , 'CR' , 'LF' , 'SPACE' OR 'GS' .
C
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *NEXTPRT(KBUFL,YBUFF,I,J,KERR*
C
C         INPUT     : KBUFL - length of YBUFF in bytes
C                     YBUFF - charcter string
C                     I     - SCAN STARTS AT WORD I.
C                     J     - SCAN STOPS AT WORD J .
C
C         OUTPUT    : I     - POSITION OF REQUIRED CHARACTER
C                     KERR  - ERROR CODE
C

C     METHOD.
C     -------
C
C          NONE.
C
C
C     EXTERNALS.
C     ----------
C
C         NONE.
C
C     REFERENCE.
C     ----------
C
C          NONE.
C
C     AUTHOR.
C     -------
C
C
C
C     MODIFICATIONS.
C     --------------
C
C          M. D. DRAGOSAVAC    *ECMWF*       07/01/2004.
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
      CHARACTER*(*) YBUFF
      CHARACTER*1 soh,lf,cr,space,gs,plus,minus
C
C     ------------------------------------------------------------------
C
C*          1.   SCAN BULLETIN.
C                --------------
 100  CONTINUE
C
C     'SOH' = 1 , 'LF' = 10 , 'CR' = 13 , SPACE = 32 , 'GS' = 29.
C     '+' = 43, 'MINUS'='-'
c
      kerr=0
      soh=char(1)
      lf=char(10)
      cr=char(13)
      space=char(32)
      gs=char(29)
      plus=char(43)
      minus='-'
C
      i = iabs(i)
      K = I
      do 101 i=k,j
         if(ybuff(i:i).ne.soh.and.
     1      ybuff(i:i).ne.lf.and.
     2      ybuff(i:i).ne.cr.and.
     3      ybuff(i:i).ne.space.and.
     4      ybuff(i:i).ne.gs.and.
     4      ybuff(i:i).ne.minus.and.
     5      ybuff(i:i).ne.plus)  then
            return
         end if
  101 continue
C
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities
C granted to it by virtue of its status as an intergovernmental organisation
C nor does it submit to any jurisdiction.
C

      LOGICAL FUNCTION ISSAME()
C
C---->
C**** ISSAME
C
C     Purpose
C     -------
C
C     Check if output field will be the same as the input field.
C
C
C     Interface
C     ---------
C
C     LSAME = ISSAME()
C
C     Input
C     -----
C
C     Values in common block.
C
C
C     Output
C     ------
C
C     Returns .TRUE. if the fields will be the same.
C
C
C     Method
C     ------
C
C     Checks interpolation request flags in common blocks.
C
C
C     Externals
C     ---------
C
C     None.
C
C
C     Author
C     ------
C
C     J.D.Chambers     ECMWF
C
C----<
C     -----------------------------------------------------------------|
C
      IMPLICIT NONE
C
#include "parim.h"
#include "nifld.common"
#include "nofld.common"
#include "grfixed.h"
C
C     Local variables
C
      INTEGER IDIFF
      LOGICAL LDEFIN, LDEFOUT, LSUBAREA
C
C     Externals
C
      LOGICAL ISSAMEIARRAY, ISSAMERARRAY
      EXTERNAL ISSAMEIARRAY, ISSAMERARRAY
C
C     -----------------------------------------------------------------|
C
      ISSAME = .TRUE.
C
C     Exit if no postprocessing specified.
C
      IF( .NOT.LINTOUT ) THEN
        CALL INTLOG(JP_DEBUG,
     X    'ISSAME: No postprocessing specified.',JPQUIET)
        RETURN
      ENDIF

C
C     Set logicals true if default input/output areas specified.
C
      LDEFIN  = ( (NIAREA(1).EQ.0) .AND. (NIAREA(2).EQ.0) .AND.
     X            (NIAREA(3).EQ.0) .AND. (NIAREA(4).EQ.0) )
      LDEFOUT = ( (NOAREA(1).EQ.0) .AND. (NOAREA(2).EQ.0) .AND.
     X            (NOAREA(3).EQ.0) .AND. (NOAREA(4).EQ.0) )
C
C     Set flag if a subarea has been requested
C
      LSUBAREA = (.NOT.LDEFIN .AND. .NOT.LDEFOUT) .AND.
     X           ( (NOAREA(1).LT.NIAREA(1)).OR.
     X             (NOAREA(2).GT.NIAREA(2)).OR.
     X             (NOAREA(3).GT.NIAREA(3)).OR.
     X             (NOAREA(4).LT.NIAREA(4)) )
C
C
C     Check for rotation
C
      IF( (NOROTA(1).NE.0) .OR. (NOROTA(2).NE.0) ) ISSAME = .FALSE.
C
C     Check for same formats, representation and bit packing accuracy.
C
cs      IF( NIFORM.NE.NOFORM) ISSAME = .FALSE.
      IF( NIREPR.NE.NOREPR) ISSAME = .FALSE.

      IF( (NOREPR.EQ.JPQUASI).AND.(NIREPR.EQ.JPQUASI) ) THEN
        ISSAME = ISSAMEIARRAY(NIGAUSS,MILLEN, NOGAUSS,NOLPTS)
     X     .AND. ISSAMERARRAY(NIGAUSS,RIGAUSS,NOGAUSS,ROGAUSS)
        IF (ISSAME) THEN
          CALL INTLOG(JP_DEBUG,
     X      'ISSAME: Input and output are Reduced Gaussian',JPQUIET)
          CALL INTLOG(JP_DEBUG,
     X      'ISSAME: with the same PL and latitudes arrays;',JPQUIET)
          CALL INTLOG(JP_DEBUG,
     X      'ISSAME: no postprocessing required.',JPQUIET)
          RETURN
        ENDIF
      ENDIF

      IF( (NOREPR.EQ.JPGAUSSIAN) .AND. (NIREPR.EQ.JPGAUSSIAN) ) THEN
        IF( (NIGAUSS.EQ.NOGAUSS) .AND. (.NOT.LSUBAREA) ) THEN
          ISSAME = .TRUE.
          CALL INTLOG(JP_DEBUG,
     X      'ISSAME: Input and output are Regular Gaussian',JPQUIET)
          CALL INTLOG(JP_DEBUG,
     X      'ISSAME: with the same resolution and area;',JPQUIET)
          CALL INTLOG(JP_DEBUG,
     X      'ISSAME: no postprocessing required.',JPQUIET)
          RETURN
        ENDIF
      ENDIF
C
C     If input is quasi gaussian and output required to be the same (ie
C     'gaussian' specified via CALL INTOUT('gaussian', ...) ), change
C     output to regular gaussian unless same resolution requested.
C
      IF( (NOREPR.EQ.JPNOTYPE) .AND.
     X    (NIGAUSS.NE.NOGAUSS) ) THEN
        CALL INTLOG(JP_DEBUG,
     X    'ISSAME: Input is quasi gaussian and output required',JPQUIET)
        CALL INTLOG(JP_DEBUG,
     X    'ISSAME: not the same resolution;',JPQUIET)
        CALL INTLOG(JP_DEBUG,
     X    'ISSAME: change output to regular gaussian.',JPQUIET)
        NOREPR = JPGAUSSIAN
      ENDIF
C
C     If input is quasi gaussian and output required to be the same (ie
C     'gaussian' specified via CALL INTOUT('gaussian', ...) ), change
C     output to regular gaussian if subarea requested.
C
      IF( (NOREPR.EQ.JPNOTYPE) .AND. LSUBAREA ) THEN
        CALL INTLOG(JP_DEBUG,
     X    'ISSAME: Input is quasi gaussian and output required',JPQUIET)
        CALL INTLOG(JP_DEBUG,
     X    'ISSAME: has a subarea;',JPQUIET)
        CALL INTLOG(JP_DEBUG,
     X    'ISSAME: change output to regular gaussian.',JPQUIET)
        NOREPR = JPGAUSSIAN
      ENDIF
C
C     Exit if both input and output are regular gaussian with
C     the same resolution and area, since no
C     postprocessing is required.
C
      IF( (NIREPR.EQ.JPGAUSSIAN) .AND.
     X    (NOREPR.EQ.JPGAUSSIAN) .AND.
     X    (NIGAUSS.EQ.NOGAUSS)   .AND.
     X    (.NOT.LSUBAREA)       ) THEN
        CALL INTLOG(JP_DEBUG,
     X    'ISSAME: Input and output are regular gaussian with',JPQUIET)
        CALL INTLOG(JP_DEBUG,
     X    'ISSAME: the same resolution and area;',JPQUIET)
        CALL INTLOG(JP_DEBUG,
     X    'ISSAME: no postprocessing is required.',JPQUIET)
        RETURN
      ENDIF
C
C     If spherical, check for same truncation.
C
      IF( (NIREPR.EQ.JPSPHERE) .AND.
     X    (NOREPR.EQ.JPSPHERE) .AND.
     X    (NIRESO.NE.NORESO)   ) ISSAME = .FALSE.
C
C     If lat.long, check for same grid intervals and area.
C
      IF( (NIREPR.EQ.JPREGULAR) .AND.
     X    (NOREPR.EQ.JPREGULAR) .AND.
     X    (NOGRID(1).NE.0)      ) THEN
        IF( NIGRID(1).NE.NOGRID(1)) ISSAME = .FALSE.
        IF( NIGRID(2).NE.NOGRID(2)) ISSAME = .FALSE.
      ENDIF
      IF( LSUBAREA ) ISSAME = .FALSE.
C
cs      IF( (NIREPR.EQ.JPREDLL) .AND.
cs     X    (NOREPR.EQ.JPREDLL)
cs     X    (NIGRID(2).NE.NOGRID(2)) ) ISSAME = .FALSE.
C
C     Check if areas are same unless defaults given.
C
      IF( (.NOT.LDEFIN) .AND. (.NOT.LDEFOUT) ) THEN
        IF( (NOGRID(1).NE.0) .OR. (NOGRID(2).NE.0) ) THEN
C
          IF( NIAREA(1).NE.NOAREA(1)) ISSAME = .FALSE.
C
          IDIFF = NIAREA(2) - NOAREA(2)
          IF( (IDIFF.NE.0) .AND. (IDIFF.NE.JP360) ) ISSAME = .FALSE.
C
          IF( NIAREA(3).NE.NOAREA(3) ) ISSAME = .FALSE.
C
          IDIFF = NIAREA(4) - NOAREA(4)
          IF( (IDIFF.NE.0) .AND. (IDIFF.NE.JP360) ) ISSAME = .FALSE.
        ENDIF
      ENDIF
C
C     If gaussian, check for same grid specification.
C
      IF( (NIREPR.EQ.JPGAUSSIAN) .AND. (NOREPR.EQ.JPGAUSSIAN) ) THEN
        ISSAME = (NIGAUSS.EQ.NOGAUSS)
      ENDIF
      IF( (NIREPR.EQ.JPQUASI) .AND. (NOREPR.EQ.JPQUASI) ) THEN
        ISSAME = ISSAMEIARRAY(NIGAUSS,MILLEN, NOGAUSS,NOLPTS)
     X     .AND. ISSAMERARRAY(NIGAUSS,RIGAUSS,NOGAUSS,ROGAUSS)
      ENDIF
C
C     Check for same scanning mode.
C
C Sinisa commented scanning mode checking because of UK fields
c      IF( NISCNM.NE.NOSCNM) ISSAME = .FALSE.
C
C     Check for same table number, parameter number, level number and
C     level type.
C
cs      IF( NITABLE.NE.NOTABLE) ISSAME = .FALSE.
cs      IF( NIPARAM.NE.NOPARAM) ISSAME = .FALSE.
cs      IF( NILEVEL.NE.NOLEVEL) ISSAME = .FALSE.
cs      IF( NILEVT .NE.NOLEVT ) ISSAME = .FALSE.
C
      IF( ISSAME ) RETURN
C
C     -----------------------------------------------------------------|
C
      RETURN
      END

      PROGRAM BUFRKEY
C
C**** *BUFRKEY*
C
C
C     PURPOSE.
C     --------
C         PRINTS BUFR SECTION 2 RDB KEY CONTENT.
C
C
C**   INTERFACE.
C     ----------
C
C          NONE.
C
C     METHOD.
C     -------
C
C          NONE.
C
C
C     EXTERNALS.
C     ----------
C
C         CALL BUSEL
C         CALL BUFREX
C         CALL BUFREN
C         CALL BUPRS0
C         CALL BUPRS1
C         CALL BUPRS2
C         CALL BUPRS3
C         CALL BUPRT
C         CALL BUUKEY
C
C     REFERENCE.
C     ----------
C
C          NONE.
C
C     AUTHOR.
C     -------
C
C          M. DRAGOSAVAC    *ECMWF*       15/09/87.
C
C
C     MODIFICATIONS.
C     --------------
C
C          NONE.
C
C
      IMPLICIT LOGICAL(L,O,G), CHARACTER*8(C,H,Y)
C
      PARAMETER(JSUP =   9,JSEC0=   3,JSEC1= 40,JSEC2=4096 ,JSEC3= 4,
     1       JSEC4=   2,JELEM=160000,JSUBS=400,JCVAL=150 ,JBUFL=512000,
#ifdef JBPW_64
     2       JBPW =  64,JTAB =3000,JCTAB=120,JCTST=1800,JCTEXT=1200,
#else
     2       JBPW =  32,JTAB =3000,JCTAB=120,JCTST=1800,JCTEXT=1200,
#endif
     3       JWORK=4096000,JKEY=46,JBYTE=512000)
C
      PARAMETER (KELEM=160000)
      PARAMETER (KVALS=4096000)
C 
      DIMENSION KBUFF(JBUFL)
      DIMENSION KSUP(JSUP)  ,KSEC0(JSEC0),KSEC1(JSEC1)
      DIMENSION KSEC2(JSEC2),KSEC3(JSEC3),KSEC4(JSEC4)
      DIMENSION KEY  (JKEY),KREQ(2)
C
      REAL*8 VALUES(KVALS),VALUE(KVALS),VALS(KVALS),RQV(KELEM)
      REAL*8 RVIND,EPS
C
      DIMENSION KTDLST(KELEM),KTDEXP(KELEM),KRQ(KELEM)
      DIMENSION KDATA(200),KBOXR(KELEM*4)
C
      CHARACTER*256 CF,CARG(2)
      CHARACTER*64 CNAMES(KELEM),CBOXN(KELEM*4)
      CHARACTER*24 CUNITS(KELEM),CBOXU(KELEM*4)
      CHARACTER*80 CVALS(KVALS)
      CHARACTER*80 CVAL(KVALS)
      CHARACTER*80 YENC
C
cs      EXTERNAL GETARG
C                                                                       
C     ------------------------------------------------------------------
C*          1. INITIALIZE CONSTANTS AND VARIABLES.
C              -----------------------------------
 100  CONTINUE
C
C     MISSING VALUE INDICATOR
C 
      NBYTPW=JBPW/8
      RVIND=1.7D38
      NVIND=2147483647
      IOBS=0
      EPS=1.0D-8
      NPACK=0
C
C     INPUT FILE NAME
C
C
C     GET INPUT AND OUTPUT FILE NAME.
C
      NARG=IARGC()
C
      IF(NARG.NE.2) THEN
         PRINT*,'USAGE -- bufr_key -i infile '
         STOP
      END IF
C
      DO 101 J=1,NARG
      CALL GETARG(J,CARG(J))
 101  CONTINUE
C
      IF(CARG(1).EQ.'-i') THEN
         CF=CARG(2)
      ELSE
          PRINT*,'USAGE -- bufr_key -i infile '
          STOP
      END IF
C
      II=INDEX(CF,' ')
      KRQL=0
      NR=0
      KREQ(1)=0
      KREQ(2)=0
      DO 103 I=1,KELEM
      RQV(I)=RVIND
      KRQ(I)=NVIND
 103  CONTINUE
C
C*          1.2 OPEN FILE CONTAINING BUFR DATA.
C               -------------------------------
 120  CONTINUE
C
      IRET=0 
      CALL PBOPEN(IUNIT,CF(1:II),'R',IRET)
      IF(IRET.EQ.-1) STOP 'OPEN FAILED'
      IF(IRET.EQ.-2) STOP 'INVALID FILE NAME'
      IF(IRET.EQ.-3) STOP 'INVALID OPEN MODE SPECIFIED'
C
C     ----------------------------------------------------------------- 
C*          3.  READ BUFR MESSAGE.
C               ------------------
 300  CONTINUE
C
      IERR=0
      KBUFL=0
C
      IRET=0
      CALL PBBUFR(IUNIT,KBUFF,JBYTE,KBUFL,IRET) 
      IF(IRET.EQ.-1) THEN
C         IF(N.NE.0) GO TO 600
         PRINT*,'NUMBER OF SUBSETS     ',IOBS
         PRINT*,'NUMBER OF MESSAGES    ',N
         STOP 'EOF'
      END IF
      IF(IRET.EQ.-2) STOP 'FILE HANDLING PROBLEM' 
      IF(IRET.EQ.-3) STOP 'ARRAY TOO SMALL FOR PRODUCT'
C
      N=N+1
C      PRINT*,'----------------------------------',N
      KBUFL=KBUFL/NBYTPW+1
      IF(N.LT.NR) GO TO 300
C
C     -----------------------------------------------------------------
C*          4. EXPAND BUFR MESSAGE.
C              --------------------
 400  CONTINUE
C
      CALL BUS012(KBUFL,KBUFF,KSUP,KSEC0,KSEC1,KSEC2,KERR)
      IF(KERR.NE.0) THEN
         PRINT*,'ERROR IN BUS012: ',KERR
         PRINT*,' BUFR MESSAGE NUMBER ',N,' CORRUPTED.'
         KERR=0
         GO TO 300
      END IF
C
 440  CONTINUE
C
C              AT ECMWF SECTION 2 CONTAINS RDB KEY.
C              SO UNPACK KEY
C
      IF(KSEC1(9).NE.96.OR.KSEC1(10).NE.4.OR.
     1   KSEC1(11).NE.8) THEN
         PRINT*,'----------------------------------',N

      CALL BUUKEY(KSEC1,KSEC2,KEY,KSUP,KERR)
C
C              PRINT KEY
C
      CALL BUPRS2(KSUP ,KEY)
      END IF
C
      GO TO 300
C     -----------------------------------------------------------------
C
 900  CONTINUE
C
      CALL PBCLOSE(IUNIT,IRET)
      CALL PBCLOSE(IUNIT1,IRET)
C
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C


      SUBROUTINE CHEKNUM (VALU,LVAL,NUM)
C
C---->
C*
C*    NAME      : CHEKNUM
C*
C*    FUNCTION  : CHECKS THAT A CHARACTER STRING CORRECTLY
C*                REPRESENTS A NUMBER.
C*
C*    INPUT     : VALU = CHARACTER STRING TO BE CHECKED
C*                LVAL = NUMBER OF CHARACTERS IN THIS STRING
C*
C*    OUTPUT    : NUM  = 0, IF STRING REPRESENTS A NUMBER.
C*                       1, IF INVALID CHARACTER FOUND.
C*
C*       JOHN HENNESSY, ECMWF, 16TH APRIL 1985
C
C----<
C     ---------------------------------------------------------------
C
      IMPLICIT INTEGER (A-Z)
C
      CHARACTER*(*) VALU
      NUM = 0
C
C     CHECK ONE CHARACTER STRING FOR VALID DIGIT.
C
      IF (VALU(1:1).LT.'0'.OR.VALU(1:1).GT.'9') NUM=1
      IF (LVAL.EQ.1)  RETURN
C
C     CHECK FOR SIGN OR DECIMAL POINT AS FIRST CHARACTER IN STRING.
C
      IF (VALU(1:1).EQ.'+') NUM = 0
      IF (VALU(1:1).EQ.'-') NUM = 0
      IF (VALU(1:1).EQ.'.') NUM = 0
      IF (NUM.EQ.1) RETURN
C
      TOTAL = 1
      POINT = 0
      IF (VALU(1:1).EQ.'.') POINT = 1
C
      DO 100 I=2,LVAL
         IF (VALU(I:I).EQ.'.') POINT = POINT + 1
         IF (VALU(I:I).GE.'0'.AND.VALU(I:I).LE.'9')
     C      TOTAL = TOTAL + 1
  100 CONTINUE
C
      TOTAL = TOTAL + POINT
      IF (VALU(1:1).EQ.'.') TOTAL = TOTAL - 1
      IF (TOTAL.NE.LVAL) NUM = 1
      IF (POINT.GT.1) NUM = 1
C
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

C
      COMMON /BCOMREQ/ RQVAL(JELEM),NREQ(2),NRQ(JELEM),NRQL
C
C             *NREQ*    -  FLAG
C                          BIT NUMBER     MEANING
C
C                              1        - 0 NO BIT MAP DELIVERED TO USER
C                                         1    BIT MAP DELIVERED TO USER
C                              2        - 0 NO PARTIAL EXPANSION
C                                         1    PARTIAL EXPANSION
C                              3        - 0 NO Q/C REQUIRED
C                                       - 1    Q/C REQUIRED
C                              4        - 0 NO STATISTICS REQUIRED
C                                       - 1    STATISTICS
C                              5        - 0 NO DIFFRENCE STATISTICS
C                                       - 1    DIFFERENCE STATISTICS
C                              6        - 0 NO SUBSTITUTED VALUES
C                                       - 1    SUBSTITUTED VALUES
C             *NRQL*    -  NUMBER OF REQUESTED ELEMENTS
C             *NRQ*     -  LIST OF REQUESTED TABLE B REFERENCE
C             *RQVAL*   -  LIST OF VALUES SIGNIFYING REQUESTED ELEMENT
C                          (SAY PRESSURE  AT 50000 PA)
C

#ifdef IBM
@PROCESS HOT(NOVECTOR) NOSTRICT
#endif
C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities
C granted to it by virtue of its status as an intergovernmental organisation
C nor does it submit to any jurisdiction.
C

      SUBROUTINE JSYMLL( PSHUP, KTRUNC, PSTART, PBUILD, PINTVL, KLUNIT,
     X                   KLATO,KLONO,PLEG,PTRIGS,KMFAX,PZFA,KRET)
C
C---->
C**** JSYMLL
C
C     PURPOSE
C     _______
C
C     This routine converts spectral input fields to standard
C     lat/long grid fields.
C
C     INTERFACE
C     _________
C
C     CALL JSYMLL( PSHUP, KTRUNC, PSTART, PBUILD, PINTVL, KLUNIT,
C    X             KLATO,KLONO,PLEG,PTRIGS,KMFAX,PZFA,KRET)
C
C     Input parameters
C     ________________
C
C     PSHUP    - Spherical harmonics field, unpacked
C     KTRUNC   - Truncation number of spherical harmonics field
C     PSTART   - Start latitude (northernmost) for output field
C                (must be positive - see comments below)
C     PBUILD   - Grid interval used to build the legendre coefficients
C                file
C     PINTVL   - Grid interval in degrees
C     KLUNIT   - stream number of the legendre function file
C     KLATO    - Number of latitude points in output field
C     KLONO    - Number of longitude points in output field
C     PLEG     - Array used to hold legendre functions
C     PTRIGS   - Initialized array of trig.functions (setup by JJSET99)
C     KMFAX    - Initialized array of prime factors (setup by JJSET99)
C
C     Output parameters
C     ________________
C
C     PZFA    - Output grid point field; contains upto 32 each
C               of North and South latitude rows symmetrically.
C     KRET     - Return status code
C                0 = OK
C
C     Common block usage
C     __________________
C
C     JDCNDBG
C
C     Method
C     ______
C
C     None.
C
C     Externals
C     _________
C
C     JREADLL - Reads the legendre functions for a latitude
C     FFT99   - Carries out FFT
C     INTLOG  - Output log message
C     INTLOGR - Output log message (with real value)
C     NMAKLL  - Make interpolation coefficients one latitude at a time
C
C     Reference
C     _________
C
C     E.C.M.W.F. Research Department technical memorandum no. 56
C                "The forecast and analysis post-processing package"
C                May 1982. J.Haseler.
C
C     Comments
C     ________
C
C     This is a redesign, based on SPECGP.F
C
C     It handles transformation to a regular lat/long grid.
C     The generated grid is symmetrical about the equator, so
C     PSTART must be positive.
C
C     It is not for U and V fields (no correction is applied at the
C     poles).
C
C
C     AUTHOR
C     ______
C
C     J.D.Chambers      *ECMWF*      Nov 1993
C
C     MODIFICATIONS
C     _____________
C
C     J.D.Chambers     ECMWF        Feb 1997
C     Allow for 64-bit pointers
C
C----<
C     _______________________________________________________
C
C
      IMPLICIT NONE
#include "jparams.h"
#include "parim.h"
#include "nifld.common"
C
C     Parameters
      INTEGER JPROUTINE
      PARAMETER ( JPROUTINE = 31300 )
C
C     Subroutine arguments
      COMPLEX   PSHUP
      DIMENSION PSHUP(*)
      INTEGER   KTRUNC
      REAL      PSTART, PBUILD, PINTVL
      INTEGER   KLUNIT, KLATO, KLONO, KMFAX, KRET
      REAL PLEG, PTRIGS, PZFA
      DIMENSION PZFA(JPLONO+2, 64)
      DIMENSION KMFAX(*), PLEG(*), PTRIGS(*)
C
C     Local variables
      REAL ZLAT
      INTEGER ILIM, IMLIM, ILN
      INTEGER ITAL, ITALA, ITALS, IMN, IMP
      INTEGER INORTH, ISOUTH
      INTEGER JM, J, JNEXTLAT, JF
      INTEGER NERR
      INTEGER*8 JDCLOOP
      INTEGER*8 IOFF
      !Integer Itimer,timer1,timer280,timerFFT
      !Integer timer246,timer244,time
C
#ifndef _CRAYFTN
#ifdef POINTER_64
      INTEGER*8 IWORK
#endif
#endif
      REAL WORK
      DIMENSION WORK(1)
      POINTER ( IWORK, WORK )
      COMPLEX   ZSUMS(JPTRNC + 1), ZSUMA(JPTRNC + 1)
      COMPLEX*16 CHOLD
C
      INTEGER ISIZE
      DATA ISIZE/0/
      SAVE ISIZE, IWORK
C
C     _______________________________________________________
C
C*    Section 1.    Initialization.
C     _______________________________________________________
C
  100 CONTINUE
      IOFF = 0
cs      timer1=Itimer(0)
C
C     First time through, dynamically allocate memory for workspace
C
      IF( ISIZE.EQ.0 ) THEN
        ISIZE =  2*JPFFT*64
        CALL JMEMHAN( 9, IWORK, ISIZE, 1, KRET)
        IF( KRET.NE.0 ) THEN
          CALL INTLOG(JP_ERROR,'JSYMLL: memory allocation error.',IWORK)
          KRET = JPROUTINE + 1
          GOTO 990
        ENDIF
      ENDIF
C
      IF ( NDBG .GT. 1) THEN
        CALL INTLOG(JP_DEBUG,
     X    'JSYMLL: Spherical harmonic coeffs(first 20):',JPQUIET)
        DO 101 NDBGLP = 1, 20
          CALL INTLOGR(JP_DEBUG,' ',PSHUP( NDBGLP ))
  101   CONTINUE
        CALL INTLOG(JP_DEBUG,'JSYMLL: Input parameters:',JPQUIET)
        CALL INTLOG(JP_DEBUG,
     X    'JSYMLL: Spherical harmonic truncation = ', KTRUNC)
        CALL INTLOGR(JP_DEBUG,
     X    'JSYMLL: Start latitude(northernmost) = ', PSTART)
        CALL INTLOGR(JP_DEBUG,
     X    'JSYMLL: Grid lat. interval(leg. file) = ', PBUILD)
        CALL INTLOGR(JP_DEBUG,
     X    'JSYMLL: Grid lat. interval(degrees) = ', PINTVL)
        CALL INTLOG(JP_DEBUG,
     X    'JSYMLL: Stream number of leg. file = ', KLUNIT)
        CALL INTLOG(JP_DEBUG,
     X    'JSYMLL: Number of lat. rows in output = ', KLATO)
        CALL INTLOG(JP_DEBUG,
     X    'JSYMLL: Number of long. pts per row = ', KLONO)
        CALL INTLOG(JP_DEBUG,
     X    'JSYMLL: Trig.functions (setup by JJSET99):',JPQUIET)
        DO 102 NDBGLP = 1, 10
          CALL INTLOGR(JP_DEBUG,' ',PTRIGS( NDBGLP ))
  102   CONTINUE
        CALL INTLOG(JP_DEBUG,
     X    'JSYMLL: Prime factors (setup by JJSET99):',JPQUIET)
        DO 103 NDBGLP = 1, 10
          CALL INTLOG(JP_DEBUG,' ',KMFAX( NDBGLP ))
  103   CONTINUE
      ENDIF
      ILIM   = KTRUNC + 1
      IMLIM  = KTRUNC + 1
      INORTH = -1
      ILN    = KLONO + 2
C
C     _______________________________________________________
C
C*    Section 2.    Main loop through latitude rows to
C*                  calculate fourier coefficients
C     _______________________________________________________
C
 200  CONTINUE
C     timer280=Itimer(0)
C
C     For each latitude, the north and corresponding south latitude row
C     are calculated at the same time from the same legendre functions.
C
      DO 280 JNEXTLAT = 1, KLATO
        ZLAT  = ( PSTART - (PINTVL * REAL(JNEXTLAT - 1)) )
C
        IF ( NDBG .GT. 1)
     X    CALL INTLOGR(JP_DEBUG,'JSYMLL: Next latitude = ', ZLAT)
C
C       If required, generate the coefficients 'on the fly'
C
        IF( LON_FLY ) THEN
          CALL NMAKLL( KTRUNC, PBUILD, ZLAT, 1, PLEG, NERR)
          IOFF = 0
        ELSE IF(LFILEIO ) THEN
          CALL JREADLL( KLUNIT, KTRUNC, PBUILD, ZLAT, PLEG, NERR)
          IF ( NERR .NE. 0 ) THEN
            CALL INTLOG(JP_ERROR,'JSYMLL: JREADLL error',NERR)
            KRET = JPROUTINE + 2
            GOTO 990
          ENDIF
        ELSE
          IOFF = NINT( (90.0 - ZLAT)/PBUILD )
          IOFF = IOFF *(KTRUNC+1)
          IOFF = IOFF *(KTRUNC+4)
          IOFF = IOFF/2
        ENDIF
C
C       Clear unused slots in array.
C       Note there are two slots in the array - one for north latitude
C       and one for the corresponding south latitude.
        INORTH = INORTH + 2
        ISOUTH = INORTH + 1
        DO 241 JF = 2*IMLIM + 1, ILN
          PZFA(JF, INORTH) = 0.0
          PZFA(JF, ISOUTH) = 0.0
 241    CONTINUE
C
C       Now fill slots which are used
        IMN = 0
        IMP = 0
C
C       timer244=Itimer(0)
        DO JM = 1, IMLIM
          ITAL = ILIM - JM + 1
          ITALS = (ITAL + 1)/2
          ITALA = ITAL/2
          CHOLD=(0.0D0, 0.0D0)
          DO J = 1, 2*ITALS, 2
            IF( LFILEIO ) THEN
              CHOLD=CHOLD+PLEG(IMP+J)*PSHUP(IMN+J)
            ELSE
              JDCLOOP = IMP + J + IOFF
              CHOLD=CHOLD+PLEG(JDCLOOP)*PSHUP(IMN+J)
            ENDIF
          ENDDO
          ZSUMS(JM)=CHOLD
          CHOLD = (0.0D0, 0.0D0)
          DO J = 2, 2*ITALA, 2
            IF( LFILEIO ) THEN
              CHOLD=CHOLD+PLEG(IMP+J)*PSHUP(IMN+J)
            ELSE
              JDCLOOP = IMP + J + IOFF
              CHOLD=CHOLD+PLEG(JDCLOOP)*PSHUP(IMN+J)
            ENDIF
          ENDDO
          ZSUMA(JM)=CHOLD
          IMP = IMP + ITAL + 1
          IMN = IMN + ITAL
        ENDDO
C       timer244=Itimer(timer244)
C
C       For the southern hemisphere row, the legendre functions are
C       the complex conjugates of the corresponding northern row -
C       hence the juggling with the signs in the next loop.
C
C       Note that PZFA is REAL, but the coefficients being calculated
C       are COMPLEX.  There are pairs of values for each coefficient
C       (real and imaginary parts) and pairs of values for each
C       latitude (north and south).
C
C       timer246=Itimer(0)
        DO 246 JM = 1, IMLIM
          PZFA(2*JM -1, INORTH) = REAL(ZSUMS(JM))  + REAL(ZSUMA(JM))
          PZFA(2*JM   , INORTH) = AIMAG(ZSUMS(JM)) + AIMAG(ZSUMA(JM))
          PZFA(2*JM -1, ISOUTH) = REAL(ZSUMS(JM))  - REAL(ZSUMA(JM))
          PZFA(2*JM   , ISOUTH) = AIMAG(ZSUMS(JM)) - AIMAG(ZSUMA(JM))
 246    CONTINUE
C       timer246=Itimer(timer246)
C
C*    End of main loop through latitude rows.
C
 280  CONTINUE
C     timer280=Itimer(timer280)
C     print*,'JSYMLL: legendre functions klat=',KLATO,' time:',timer280,
C    X    ' seconds loop 246:',timer246,' loop 244:',timer244
C
C     _______________________________________________________
C
C*    Section 3.    Fast fourier transform
C     _______________________________________________________
C
 300  CONTINUE
C     timerFFT=Itimer(0)
C
      IF ( NDBG .GT. 1) CALL INTLOG(JP_DEBUG,
     X  'JSYMLL: FFT, no.of rows (N and S) = ', ISOUTH)
C
      CALL FFT99(PZFA,WORK,PTRIGS,KMFAX,1,JPLONO+2,KLONO,ISOUTH,1)
C
      IF ( NDBG .GT. 1) THEN
        CALL INTLOG(JP_DEBUG,
     X    'JSYMLL: Values calculated by FFT:',JPQUIET)
        DO 301 NDBGLP = 1, 20
        CALL INTLOGR(JP_DEBUG,' ', PZFA( 1, NDBGLP ))
        CALL INTLOGR(JP_DEBUG,' ', PZFA( 2, NDBGLP ))
  301   CONTINUE
      ENDIF
C     timerFFT=Itimer(timerFFT)
C     timer1=Itimer(timer1)
C     print*,'JSYMLL: legendre functions Total:',timer1,' sec first:',
C    X    timerMEM,' FFT99: ',timerFFT
C
C     _______________________________________________________
C
C*    Section 9. Return to calling routine. Format statements
C     _______________________________________________________
C
C
 900  CONTINUE
C
      KRET = 0
C
 990  CONTINUE
      RETURN
      END

C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C
C
C
      COMMON /BCOMTABLOADC / CCTABBEN(JTAB,JTMAX),CCTABBU (JTAB,JTMAX),
     1                       CTABLE_LIST(JTMAX),CCTEXT(JCTEXT,JTMAX)
C
C             CTABBEN      -  TABLE B, ELEMENT NAME           ARRAY
C             CTABBU       -  TABLE B, UNIT                   ARRAY
C             CTABLE_LIST  -  LIST OF TABLES                  ARRAY
C             CCTEXT       -  CODE/FLAG TABLES TEXT           ARRAY
C

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE CREXETAB(KSEC1,KERR)
C
C**** *CREXETAB*
C
C
C     PURPOSE.
C     --------
C          Load Crex table B and  D  according to Edition and version
C     of Crex code.
C
C
C**   INTERFACE.
C     ----------
C
C          *CALL* *CREXETAB(KSEC1,KERR)*
C
C        OUTPUT:
C               *KSEC1*   -  Integer array of at least 40 words
C                            containing CREX section 1 information
C                            KSEC1( 1)-- Reserved
C                            KSEC1( 2)-- CREX Edition number
C                            KSEC1( 3)-- Reserved
C                            KSEC1( 4)-- Reserved
C                            KSEC1( 5)-- Reserved
C                            KSEC1( 6)-- CREX message type
C                            KSEC1( 7)-- Reserved
C                            KSEC1( 8)-- version number of local table used
C                            KSEC1( 9)-- Reserved
C                            KSEC1(10)-- Reserved
C                            KSEC1(11)-- Reserved
C                            KSEC1(12)-- Reserved
C                            KSEC1(13)-- Reserved
C                            KSEC1(14)-- CREX Master table
C                            KSEC1(15)-- version number of Master table used
C                            KSEC1(16) - KSEC1(40) -- Reserved
C
C
C                            Crex Edition 2
C
C               *KSEC1*   -  Integer array of at least 40 words
C                            containing CREX section 1 information
C                            KSEC1( 1)-- Reserved
C                            KSEC1( 2)-- CREX Edition number
C                            KSEC1( 3)-- Originating Centre ( oooo)
C                            KSEC1( 4)-- Update sequence number (uu)
C                            KSEC1( 5)-- Number of subsets (sss)
C                            KSEC1( 6)-- CREX data category (nnn)
C                            KSEC1( 7)-- International data sub-category (mmm)
C                            KSEC1( 8)-- version number of local table used
C                            KSEC1( 9)-- Year (yyyy)
C                            KSEC1(10)-- Month (mm)
C                            KSEC1(11)-- Day (dd)
C                            KSEC1(12)-- Hour (hh)
C                            KSEC1(13)-- Minute (mm)
C                            KSEC1(14)-- CREX Master table (tt)
C                            KSEC1(15)-- version number of Master table used (vv)
C                            KSEC1(16)-- Originating sub-centre (ppp)
C                            KSEC1(17)-- Bufr master table version number
C                            KSEC1(18)-- Bufr version number of local table used
C                            KSEC1(19) - KSEC1(40) -- Reserved
C
C               *KERR*    -  returned error code
C
C     METHOD.
C     -------
C
C          NONE.
C
C
C     EXTERNALS.
C     ----------
C
C          NONE.
C
C     REFERENCE.
C     ----------
C
C          NONE.
C
C     AUTHOR.
C     -------
C
C          MILAN DRAGOSAVAC    *ECMWF*       06/11/2003.
C
C
C     MODIFICATIONS.
C     --------------
C
C          NONE.
C
C
      IMPLICIT LOGICAL(L,O,G), CHARACTER*8(C,H,Y)
C
C
C
      PARAMETER(JSUP =   9,JSEC0=   3,JSEC1= 40,JSEC2= 64 ,JSEC3=    4,
     1          JSEC4=   2,JELEM=40000,JSUBS=400,JCVAL=150 ,JBUFL=40000,
     2          JBPW =  32,JTAB =3000,JCTAB=120,JCTST=1800,JCTEXT= 200,
     3          JWORK=360000,JKEY=46)
C
      PARAMETER(JP=3000,JL=20)
C
      COMMON/CRTAB/ NCREXBR(JTAB),NCREXBS(JTAB)    , NCREXBDW(JTAB),
     1              NCREXDR(JTAB),NCREXDST(JTAB)   ,
     2              NCREXDL(JTAB),NCREXDSQ(JTAB*20),NCREXP(64,255)

C
C             NCREXBR     - table B,  table reference              array
C             NCREXBS     - table B,  scale                        array
C             NCREXBDW    - table B,  data width                   array
C             NCREXDR    - table D,  table reference              array
C             NCREXDST    - table D,  starting pointers            array
C             NCREXDL     - table D,  lengths                      array
C             NCREXDSQ    - table D,  list of sequence descriptors array
C
       COMMON /CRTABC/ CREXNAME(JTAB),CREXUNIT(JTAB)
C
C             CREXNAME      -  table B, ELEMENT NAME           array
C             CREXUNIT      -  table B, unit                   array
C
C
      COMMON /CRROOT/ CROOT
C
C            croot    -  path for Crex tables
C
      CHARACTER*64 CREXNAME
      CHARACTER*24 CREXUNIT
      CHARACTER*6  CREXLST
C
      CHARACTER*256 YNAME
      CHARACTER*256  YFNAME
      CHARACTER*160 YENTRY
C
      CHARACTER*256 YTAB ,YTAC ,YTAD
      CHARACTER*7  YTABB,YTABC,YTABD
      CHARACTER*256 CROOT
      CHARACTER*6 CNCREXBR
C
      DIMENSION KSEC1(*)
C
C     EXTERNAL FUNCTIONS
C
      INTEGER EMOSNUM
      EXTERNAL EMOSNUM

      SAVE OFIRST, NXXP, NYYP, NZZP
C
C     ------------------------------------------------------------------
C
C*          1.   GET CREX TABLES/LOCAL CREX TABLES.
C                ----------------------------------
 100  CONTINUE
C
      IF( KERR.NE.0) RETURN
C
C
C*          2.   SET UP CREX TABLE FILE NAME.
C                ----------------------------
 200  CONTINUE
C
C
C             CREX EDITION 1 NAMING CONVENTION
C
C             BXXYYZZ , DXXYYZZ
C
C             B      - CREX TABLE 'B'
C             D      - CREX TABLE 'D'
C             XX     - Crex Master table used '00'
C             YY     - Crex Edition number used '01'
C             ZZ     - Crex Table version number '01'
C
            IXX=0
            IYY=KSEC1( 2)
            IZZ=KSEC1(15)
C
         IF(OFIRST) THEN
            IF(IXX.EQ.NXXP.AND.IYY.EQ.NYYP.AND.
     1         IZZ.EQ.NZZP) RETURN
         END IF
C
      J=0
      ICLASS0=0
      IVIND=2147483647
C
      DO 101 I=1,64
      do 101 ii=1,255
      NCREXP(I,ii)=0
 101  CONTINUE
C
      DO 102 i=1,JP
      NCREXBR(I)=IVIND
      NCREXBS (I)=IVIND
      NCREXBDW(I)=IVIND
      CREXNAME(I)=' '
      CREXUNIT(I)=' '
 102  CONTINUE
C
      J  =0
      IST=1
C
      DO 103 I=1,JP
      NCREXDR(I)=999999
      NCREXDL (I)=0
      NCREXDST(I)=0
 103  CONTINUE
C
      DO 104 I=1,JP*20
      NCREXDSQ(I)=0
 104  CONTINUE

      OFIRST=.TRUE.
C
      NXXP=IXX
      NYYP=IYY
      NZZP=IZZ
C
      WRITE(YTABB,'(A1,I2.2,I2.2,I2.2)') 'B',IXX,IYY,IZZ
C     WRITE(YTABC,'(A1,I2.2,I2.2,I2.2)') 'C',IXX,IYY,IZZ
      WRITE(YTABD,'(A1,I2.2,I2.2,I2.2)') 'D',IXX,IYY,IZZ
C
      PRINT*,'CREX Tables to be loaded ',YTABB,',',YTABD
C
C     ----------------------------------------------------------------
C*          3. OPEN AND READ FILES CONTAINING CREX TABLES.
C              -------------------------------------------
 300  CONTINUE
C
      CROOT=' '
      CALL GETENV('CREX_TABLES',CROOT)
      ILNG=INDEX(CROOT,' ')
      IF(ILNG.EQ.1) THEN
C
C       SGI/HP/SUN CREX TABLES PATH
C
        CROOT='/home/ma/emos/tables/crex/'
C
C       ADD VERSION NUMBER
C
        ILNG=INDEX(CROOT,' ')
        IEMOSNM = EMOSNUM(1)
        WRITE(CROOT(ILNG:ILNG+5),'(I6.6)') IEMOSNM
        CROOT(ILNG+6:) = '/'
      ENDIF

      I=INDEX(CROOT,' ')
      IF(I.NE.0) I=I-1
      PRINT*,'Path for CREX tables:',CROOT(1:I)
C
C*          3.1 READ CREX TABLE B.
C               ------------------
 310  CONTINUE
C
      YTAB=CROOT(1:I)//YTABB
      II=I+7
C
      OPEN(UNIT=38,IOSTAT=IOS,ERR=311,FILE=YTAB(1:II),
     1     FORM='FORMATTED',
     2     recl=160,
     5     STATUS='OLD')
C
      J=0
      GO TO 312
C
 311  CONTINUE
C
      CLOSE(38)
C
      print*,'Open error on ',YTAB(1:II)
C
      KERR=9    
      CALL CREXERR(KERR)
      RETURN

C
 312  CONTINUE
C
      J=J+1
      READ(38,ERR=400,IOSTAT=IOS,END=329,
     1  FMT='(1x,A,1x,A64,47x,A24,I3,7x,I3)')
     2  CNCREXBR,CREXNAME(J),CREXUNIT(J),NCREXBS(J),NCREXBDW(J)
C
      CNCREXBR(1:1)='0'
C
      READ(CNCREXBR,'(I6.6)',IOSTAT=IOS) NCREXBR(J)
      IF(IOS.NE.0) THEN
         print*,'Internal read error.'
         print*,CNCREXBR
         KERR=35
         RETURN
      end if
C
C
      ICLASS=NCREXBR(J)/1000
      IYYY  =NCREXBR(J)-ICLASS*1000+1
C
      ICLASS=ICLASS+1
      NCREXP(ICLASS,IYYY)=J

      GO TO 312
C
 329  CONTINUE
C
      CLOSE(UNIT=38,IOSTAT=IOS,ERR=420)
C
C*          3.3 READ CREX TABLE D.
CC               ------------------
 330  CONTINUE
C
      YTAD=CROOT(1:I)//YTABD
C
      OPEN(UNIT=40,IOSTAT=IOS,ERR=331,FILE=YTAD(1:II),
     1     FORM='FORMATTED',
     2     recl=160,
     5     STATUS='OLD')
C
      GO TO 332
C
 331  CONTINUE
C
      CLOSE(40)
C
      print*,'Open error on ',YTAD
C
      kerr=9
      CALL CREXERR(KERR)
      return
C
 332  CONTINUE
C
      j=0
 340  continue
c
      YENTRY=' '
      READ(40,'(a)',iostat=ios,end=390) yentry
      if(ios.ne.0) then
         print*,'Read error on CREX table D.'
         KERR=35
         RETURN
      end if
      if(yentry(2:2).eq.'D') yentry(2:2)='3'
c
      j=j+1
      READ(YENTRY,'(1X,I6,1X,I2)',iostat=ios) NCREXDR(J),NCREXDL(J)
      if(ios.ne.0) then
         print*,'Internal read error.'
         print*,YENTRY
         KERR=35
         RETURN
      end if
      IF(J.GT.JP) THEN
         PRINT*,' DIMENSION TOO SMALL J=',J
         kerr=13
         CALL CREXERR(KERR)
         RETURN
      END IF
C
      IF(J.EQ.1) THEN
         IST=1
         NCREXDST(J)=IST
      ELSE
         IST=IST + NCREXDL(J-1)
         NCREXDST(J)=IST
      END IF
C
      IF(NCREXDL(J).GT.1) THEN
         if(YENTRY(12:12).eq.'D') YENTRY(12:12)='3'
         if(YENTRY(12:12).eq.'C') then
            YENTRY(12:12)='2'
c           checkif negative scale is present
            iminus=0
            iminus=index(YENTRY(12:16),'-')
            if(iminus.ne.0) YENTRY(iminus:iminus)='9'
         end if
         if(YENTRY(12:12).eq.'R') YENTRY(12:12)='1'
         if(YENTRY(12:12).eq.'B') YENTRY(12:12)='0'
         READ(YENTRY,'(11X,I6)',iostat=ios) NCREXDSQ(IST)
         if(ios.ne.0) then
            print*,YENTRY
            KERR=35
            CALL CREXERR(KERR)
            RETURN
         end if
c
         IIST=IST
C
         DO 220 JA=1,NCREXDL(J)-1
         IIST=IIST+1
         READ(40,'(A)',END=300,iostat=ios) YENTRY
         if(ios.ne.0) then
            print*,YENTRY
            KERR=35
            CALL CREXERR(KERR)
            RETURN
         end if
c
         if(YENTRY(12:12).eq.'D') YENTRY(12:12)='3'
         if(YENTRY(12:12).eq.'C') YENTRY(12:12)='2'
         if(YENTRY(12:12).eq.'R') YENTRY(12:12)='1'
         if(YENTRY(12:12).eq.'B') YENTRY(12:12)='0'
         READ(YENTRY,'(11X,I6)',iostat=ios) NCREXDSQ(IIST)
         if(ios.ne.0) then
            print*,YENTRY
            KERR=35
            CALL CREXERR(KERR)
            RETURN
         end if
 220     CONTINUE
C
      ELSE
         if(YENTRY(12:12).eq.'D') YENTRY(12:12)='3'
         if(YENTRY(12:12).eq.'C') YENTRY(12:12)='2'
         if(YENTRY(12:12).eq.'R') YENTRY(12:12)='1'
         if(YENTRY(12:12).eq.'B') YENTRY(12:12)='0'
         READ(YENTRY,'(11X,I6)',iostat=ios) NCREXDSQ(IST)
         if(ios.ne.0) then
            print*,'Internal read error.'
            print*,YENTRY
            KERR=35
            RETURN
         end if
      END IF
C
      go to 340
c
 390  continue
C
      CLOSE(UNIT=40,IOSTAT=IOS,ERR=620)
C
C
      RETURN
C     ----------------------------------------------------------------
 400  CONTINUE
C
      KERR=6
      PRINT*,'CREXETAB: IOS ',IOS
      CALL CREXERR(KERR)
      OFIRST=.FALSE.
      RETURN
C
 410  CONTINUE
C
      KERR=9
      PRINT*,'CREXETAB: IOS ',IOS
      CALL CREXERR(KERR)
      OFIRST=.FALSE.
      RETURN
C
 420  CONTINUE
C
      KERR=10
      PRINT*,'CREXETAB: IOS ',IOS
      CALL CREXERR(KERR)
      OFIRST=.FALSE.
      RETURN
C     ----------------------------------------------------------------
 500  CONTINUE
C
      KERR=7
      PRINT*,'CREXETAB: IOS ',IOS
      CALL CREXERR(KERR)
      OFIRST=.FALSE.
      RETURN
C
 510  CONTINUE
C
      KERR=9
      PRINT*,'CREXETAB: IOS ',IOS
      CALL CREXERR(KERR)
      OFIRST=.FALSE.
      RETURN
C
 520  CONTINUE
C
      KERR=11
      PRINT*,'CREXETAB: IOS ',IOS
      CALL CREXERR(KERR)
      OFIRST=.FALSE.
      RETURN
C     -----------------------------------------------------------------
 600  CONTINUE
C
      KERR=8
      PRINT*,'CREXETAB: IOS ',IOS
      CALL CREXERR(KERR)
      OFIRST=.FALSE.
      RETURN
C
 610  CONTINUE
C
      KERR=9
      PRINT*,'CREXETAB: IOS ',IOS
      CALL CREXERR(KERR)
      OFIRST=.FALSE.
      RETURN
C
 620  CONTINUE
C
      KERR=12
      PRINT*,'CREXETAB: IOS ',IOS
      CALL CREXERR(KERR)
      OFIRST=.FALSE.
      RETURN
C     -----------------------------------------------------------------
C
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE MAXMIN(PARRAY,KLEN,PMAX,PMIN)
C
C---->
C**** MAXMIN - Get maximum and minimum values.
C
C     Purpose.
C     --------
C
C     Get maximum and minimum values from an array of
C     floating point numbers..
C
C**   Interface.
C     ----------
C
C     CALL MAXMIN(PARRAY,KLEN,PMAX,PMIN)
C
C     Input Parameters.
C     -----------------
C
C     PARRAY - Array of numbers.
C     KLEN   - Last word of this array.
C
C     Output Parameters.
C     ------------------
C
C     PMAX   - Maximum value.
C     PMIN   - Minimum value.
C
C     Method.
C     -------
C
C     Intrinsic functions MAX and MIN are used.
C
C     Externals.
C     ----------
C
C     None.
C
C     Reference.
C     ----------
C
C     None.
C
C     Comments.
C     ---------
C
C     None.
C
C     Author.
C     -------
C
C     J. Hennessy      ECMWF      18:06:91
C
C     Modifications.
C     --------------
C
C     J. Clochard, Meteo France, for ECMWF - January 1998.
C     Start loop from index 2.
C     Inhibits use of DMAX1/DMIN1 on CRAY (SMP) systems.
C
C----<
C     ----------------------------------------------------------------
C*    Section 0 . Definition of variables. Data statements.
C     ----------------------------------------------------------------
C
      IMPLICIT NONE
C
C     Subroutine arguments
C
      INTEGER KLEN
      REAL   PARRAY, PMAX, PMIN, VSMALL
      DIMENSION PARRAY(KLEN)
#ifndef __uxp__
C
C     Parameters
C
      REAL JPSMALL
#ifdef __alpha
#ifdef REAL_8
      PARAMETER (JPSMALL = 1E-307)
#else
      PARAMETER (JPSMALL = 1E-37)
#endif
#else
      PARAMETER (JPSMALL = 1E-38)
#endif
#endif
C
C     Local variables
C
      INTEGER JLOOP
C
C     ----------------------------------------------------------------
C*    Section 1 . Get maximum and minimum values.
C     ----------------------------------------------------------------
C
  100 CONTINUE
C
C     Set initial values.
C
      PMAX = PARRAY(1)
      PMIN = PARRAY(1)
C
C     Extract maximum and minimum values.
C
      DO 110 JLOOP = 2 , KLEN
        PMAX = MAX(PMAX,PARRAY(JLOOP))
        PMIN = MIN(PMIN,PARRAY(JLOOP))
  110 CONTINUE
C
C     Adjust to an acceptable 'tiny' minimum
C
#ifdef __uxp__
      VSMALL = TINY(PMIN)
#else
      VSMALL = JPSMALL
#endif
      IF( (PMIN.NE.0.0).AND.(ABS(PMIN).LT.VSMALL) )
     X   PMIN = SIGN(VSMALL,PMIN)
C
C     ----------------------------------------------------------------
C*    Section 9. Return to calling routine.
C     ----------------------------------------------------------------
C
  900 CONTINUE
C
      RETURN
C
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities
C granted to it by virtue of its status as an intergovernmental organisation
C nor does it submit to any jurisdiction.
C

      SUBROUTINE JSLLGP( PSHUP, KTRUNC, PNORTH, PSOUTH, PWEST, PEAST,
     X                    PLATINC, PLONINC, POUTF, KRET)
C
C---->
C**** JSLLGP
C
C     PURPOSE
C     _______
C
C     This routine converts stretched spectral input fields to
C     standard lat/long grid fields.
C
C     INTERFACE
C     _________
C
C     CALL JSLLGP( PSHUP, KTRUNC, PNORTH, PSOUTH, PWEST, PEAST,
C    X                    PLATINC, PLONINC, POUTF, KRET)
C
C     Input parameters
C     ________________
C
C     PSHUP    - Spherical harmonics field, unpacked
C     KTRUNC   - Truncation number of spherical harmonics field
C     PNORTH   - Northernmost latitude for output field (degrees)
C     PSOUTH   - Southernmost latitude for output field (degrees)
C     PWEST    - Westernmost longitude for output field (degrees)
C     PEAST    - Easternmost longitude for output field (degrees)
C     PLATINC  - Grid interval between latitudes in degrees
C     PLONINC  - Grid interval between longitudes in degrees
C     INTLOG   - Output log message
C     INTLOGR  - Output log message (with real value)
C
C     Output parameters
C     ________________
C
C     POUTF    - Output grid point field
C     KRET     - Return status code
C                0 = OK
C
C     Common block usage
C     __________________
C
C     JDCNDBG
C
C     Method
C     ______
C
C     Generates one latitude at a time.
C
C     Externals
C     _________
C
C     JJSET99   - Sets up FFT
C     JSTRLL    - Generate latitude line from spherical harmonics
C     JSTRWLL   - Generate latitude line from spherical harmonics (wind)
C     JDEBUG    - Checks environment variable to switch on/off debug
C     INTLOG    - Logs output messages
C     INTLOGR   - Logs output messages
C
C
C     Reference
C     _________
C
C     E.C.M.W.F. Research Department technical memorandum no. 56
C                "The forecast and analysis post-processing package"
C                May 1982. J.Haseler.
C
C
C     Comments
C     ________
C
C     None
C
C
C     AUTHOR
C     ______
C
C     J.D.Chambers      ECMWF      July 1999
C
C     MODIFICATIONS
C     _____________
C
C     None
C
C----<
C     _______________________________________________________
C
C*    Section 0. Definition of variables.
C     _______________________________________________________
C
      IMPLICIT NONE
#include "jparams.h"
#include "parim.h"
#include "nifld.common"
C
C     Parameters
C
      INTEGER JPROUTINE
      PARAMETER ( JPROUTINE = 30000 )
C
C     Subroutine arguments
C
      COMPLEX   PSHUP
      DIMENSION PSHUP(*)
      INTEGER   KTRUNC
      REAL      PNORTH, PSOUTH, PWEST, PEAST, PLATINC, PLONINC
      REAL      POUTF
      DIMENSION POUTF(*)
      INTEGER   KRET
C
C     Local variables
C
      REAL PSTART, PNORMX, PDIFF
      REAL DEG2RAD, ZBUILD
      INTEGER ILON, IOLON, ITOUP1, IJPWR, NEXT, NROWS, NUMLON
      INTEGER IOFFN, LONGIT, N360, NSTART, INEXT, LOOPCL
C
      INTEGER IMFAX
      REAL ATRIGS
      DIMENSION IMFAX(10),ATRIGS(JPLONO*2)
#ifndef _CRAYFTN
#ifdef POINTER_64
      INTEGER*8 IALEG, IZFA
#endif
#endif
      REAL ALEG
      DIMENSION ALEG(1)
      POINTER ( IALEG, ALEG )
      REAL ZFA
      DIMENSION ZFA(1)
      POINTER ( IZFA, ZFA )
C
      INTEGER ISIZE, ISIZE2
      DATA ISIZE/0/, ISIZE2/0/
      SAVE ISIZE, ISIZE2, IZFA
C
      SAVE IMFAX, ATRIGS, IALEG
C
C     _______________________________________________________
C
C*    Section 1.    Initialization.
C     _______________________________________________________
C
  100 CONTINUE
C
      CALL JDEBUG( )
C
C     First time through, dynamically allocate memory for workspace
C
      IF( ISIZE.EQ.0 ) THEN
        ISIZE = (JPLONO+2) * 2
        CALL JMEMHAN( 10, IZFA, ISIZE, 1, KRET)
        IF( KRET.NE.0 ) THEN
          CALL INTLOG(JP_ERROR,'JSLLGP: memory allocation error.',IZFA)
          KRET = JPROUTINE + 1
          GOTO 900
        ENDIF
      ENDIF
C
      IF( NDBG.GT.0 ) THEN
        CALL INTLOG(JP_DEBUG,'JSLLGP: Input parameters:', JPQUIET)
        CALL INTLOG(JP_DEBUG,
     X    'JSLLGP: Spherical harmonic coeffs(first 20):', JPQUIET)
        DO 101 NDBGLP = 1, 20
          CALL INTLOGR(JP_DEBUG,' ', PSHUP( NDBGLP ))
  101   CONTINUE
        CALL INTLOG(JP_DEBUG,
     X    'JSLLGP: Spherical harmonic truncation = ', KTRUNC)
        CALL INTLOGR(JP_DEBUG,
     X    'JSLLGP: Northern latitude for output = ', PNORTH)
        CALL INTLOGR(JP_DEBUG,
     X    'JSLLGP: Southern latitude for output = ', PSOUTH)
        CALL INTLOGR(JP_DEBUG,
     X    'JSLLGP: Western longitude for output = ', PWEST)
        CALL INTLOGR(JP_DEBUG,
     X    'JSLLGP: Eastern longitude for output = ', PEAST)
        CALL INTLOGR(JP_DEBUG,
     X    'JSLLGP: Latitude grid interval (deg) = ', PLATINC)
        CALL INTLOGR(JP_DEBUG,
     X    'JSLLGP: Longitude grid interval (deg) = ', PLONINC)
      ENDIF
C
C     Coefficients are to generated 'on the fly',
C
      ISIZE2 =  (KTRUNC+1)*(KTRUNC+2)
      CALL JMEMHAN( 14, IALEG, ISIZE2, 1, KRET)
      IF( KRET.NE.0 ) THEN
        CALL INTLOG(JP_ERROR,'JSLLGP: memory allocate error.',IALEG)
        KRET = JPROUTINE + 2
        GOTO 900
      ENDIF
C
      DEG2RAD = PPI / 180.0
      IOLON   = NINT( 360.0 / PLATINC )
      ILON    = NINT( 360.0 / PLONINC )
      ITOUP1  = KTRUNC
C
C     For calculation purposes, ILON, the number of longitude points,
C     has to be greater than 2*(output truncation) to ensure that the
C     fourier transform is exact (see Reference, page 10).
C     The following loop increases ILON*IJPWR until ILON=>2*ITOUP1.
C     Later, when filling the output array POUTF, the longitude points
C     have to be taken selectively to avoid the intermediate generated
C     points, picking up values only at the required longitudes.
C
      IJPWR = 1
 110  CONTINUE
        IF( ILON.GT.2*ITOUP1 ) GOTO 120
        IJPWR = IJPWR*2
        ILON  = ILON*2
        GOTO 110
 120  CONTINUE
C
C     Initialise FFT constants
C
      IF( NDBG.GT.0 ) THEN
        CALL INTLOG(JP_DEBUG,
     X    'JSLLGP: Initialise FFT constants with ', ILON)
        CALL INTLOG(JP_DEBUG,
     X    'JSLLGP: longitude points.', JPQUIET)
      ENDIF
C
      CALL JJSET99( ATRIGS, IMFAX, ILON, KRET)
      IF( KRET.NE.0 ) GOTO 900
C
C     _______________________________________________________
C
C*    Section 2.    Work out geometry of the request
C     _______________________________________________________
C
 200  CONTINUE
C
      PNORMX = PNORTH
      PDIFF  = PNORTH - PSOUTH
      NROWS = NINT( PDIFF/PLATINC )  + 1
      IF( ((NROWS-1)*PLATINC).GT.PDIFF ) NROWS = NROWS - 1
C
      NUMLON = NINT( (PEAST - PWEST)/PLONINC ) + 1
      ZBUILD = PLATINC
C
      IF( NDBG.GT.0 ) THEN
        CALL INTLOG(JP_DEBUG,'JSLLGP: Number of longitudes = ', NUMLON)
        CALL INTLOGR(JP_DEBUG,
     X    'JSLLGP: North latitude used for calc = ', PNORMX)
        CALL INTLOG(JP_DEBUG,'JSLLGP: No.lats used in calc = ', NROWS)
      ENDIF
C     _______________________________________________________
C
C*    Section 4.    Process one row at a time.
C     _______________________________________________________
C
 400  CONTINUE
C
      DO NEXT = 1, NROWS
        PSTART = PNORMX - REAL(NEXT-1)*PLATINC
C
        IF( NDBG.GT.0 )
     X    CALL INTLOGR(JP_DEBUG, 'JSLLGP: Next latitude = ', PSTART)
C
C       Generate the next row
C
        IF( LWIND ) THEN
          CALL JSTRWLL(PSHUP, KTRUNC, PSTART, ZBUILD, ILON,
     X                ALEG, ATRIGS, IMFAX, ZFA, KRET)
        ELSE
          CALL JSTRLL(PSHUP, KTRUNC, PSTART, ZBUILD, ILON,
     X                ALEG, ATRIGS, IMFAX, ZFA, KRET)
        ENDIF
        IF( KRET.NE.0 ) GOTO 900
C
C       Find start offset in storage array
C
        IOFFN  = NINT( (PNORTH - PSTART)/PLATINC ) + 1
        LONGIT = NINT( (360.0 + PWEST)/PLONINC )
        N360 = NINT( 360.0/PLONINC )
        NSTART = MOD( LONGIT, N360)*IJPWR
C
        DO LOOPCL = 1, NUMLON
          INEXT = 2 + MOD( NSTART + (LOOPCL-1)*IJPWR , ILON)
          POUTF( LOOPCL + (IOFFN-1)*NUMLON ) = ZFA( INEXT)
        ENDDO
C
      ENDDO
C
      KRET = 0
C
C     _______________________________________________________
C
C*    Section 9. Return to calling routine. Format statements
C     _______________________________________________________
C
 900  CONTINUE
C
      RETURN
      END

C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE BUPKS(KBPW,KDEST,KSOURC,KWPT,KBPT,KSIZE,KSKIPB,K,KERR)
C
C**** *BUPKS*
C
C
C     PURPOSE.
C     --------
C          PURPOSE OF THIS ROUTINE IS TO PACK BIT STRING OF
C     KSIZE BITS, STARTED AT WORD KWPT OF ARRAY KSOURC AFTER
C     SKIPPINH KBPT BITS. RESULT IS PUT INTO KDEST. AT THE END
C     POINTERS KWPT AND KBPT ARE ADJUSTED.
C
C**   INTERFACE.
C     ----------
C
C          *CALL* *BUPKS(KBPW,KDEST,KSOURC,KWPT,KBPT,KSIZE,KSKIPB,K,KERR)*
C
C
C        INPUT :
C            KBPW      - NUMBER OF BITS PER COMPUTER WORD
C            KSOURC    - SOURCE (CONTINUOUS BIT STRING OF
C                          ARBITRARY LENGTH)
C            KWPT      - WORD POINTER
C            KBPT      - BIT POINTER
C            KSIZE     - NUMBER OF BITS USED FOR PACKING
C            KSKIPB    - NUMBER OF BITS TO SKIP BETWEEN ELEMENTS
C            K         - ITERATION
C
C        OUTPUT :
C            KDEST     - DESTINATION
C            KERR      - RETURN ERROR CODE
C
C     METHOD.
C     -------
C
C            NONE.
C
C
C     EXTERNALS.
C     ----------
C
C
C          SBYTES     - PACK BIT PATHERN
C
C
C     REFERENCE.
C     ----------
C
C          NONE.
C
C     AUTHOR.
C     -------
C
C          M. DRAGOSAVAC    *ECMWF*       15/01/91.
C
C
C     MODIFICATIONS.
C     --------------
C
C          NONE.
C
C
      IMPLICIT LOGICAL(L,O,G), CHARACTER*8(C,H,Y)
C
      DIMENSION KDEST(*),KSOURC(*)
C
C     ------------------------------------------------------------------
C*          1.   EXTRACT BIT PATTERN.
C                --------------------
 100  CONTINUE
C
      IF(KERR.GT.0) RETURN
C
      IF(KSIZE.GT.KBPW) THEN
         KERR= 34
         WRITE(KNTN,*)  'BUPKS :'
         CALL BUERR(KERR)
         RETURN
      END IF
C
      CALL SBYTES(KDEST,KSOURC,KBPT,KSIZE,KSKIPB,K)
C
C     ------------------------------------------------------------------
C*          1.1  UPDATE WORD AND BIT POINTERS.
C                -----------------------------
 110  CONTINUE
C
      KBPT = KBPT + K*(KSIZE+KSKIPB)
C
      IF(KBPT.GE.KBPW) THEN
         IW  = KBPT/ KBPW
         KBPT= KBPT - IW * KBPW
         KWPT= KWPT +IW
      END IF
C
      RETURN
      END

C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      INTEGER FUNCTION NGROTAT(OLDFLD, NEWFLD, NUMPTS, POLELAT, POLELON,
     X                         TYPE, NGAUSS)
C
C---->
C**** NGROTAT
C
C     PURPOSE
C     _______
C
C     Generates a rotated gaussian grid.
C
C     INTERFACE
C     _________
C
C     IRET = NGROTAT(OLDFLD,NEWFLD,NUMPTS,POLELAT,POLELON,TYPE,NGAUSS)
C
C
C     Input parameters
C     ________________
C
C     OLDFLD  = Original gaussian grid field.
C     NUMPTS  = Total number of points in the original field.
C     POLELAT = Latitude of the South Pole of rotation.
C     POLELON = Longitude of the South Pole of rotation.
C     TYPE    = 'R' if the gaussian field is reduced (quasi) gaussian.
C             = 'F' if the gaussian field is regular (full) gaussian.
C     NGAUSS  = Gaussian grid number (number of latitude rows between
C               the pole and the equator).
C
C     Output parameters
C     ________________
C    
C     NEWFLD  = New gaussian grid field.
C               (This can be the same array as OLDFLD).
C
C     Function returns zero if interpolation ran OK.
C
C
C     METHOD
C     ______
C
C     The nearest gaussian latitude row is found.
C
C     Work space is dynamically allocated. It is retained for future
C     calls.
C
C     EXTERNALS
C     _________
C
C     IGGLAT  - Compute Gaussian latitudes for a given truncation.
C     NGVALUE - Calculates the interpolated value at a point of the new
C               gaussian grid.
C     INTLOG  - Logs output messages
C     INTLOGR - Logs output messages
C     JMEMHAN - Dynamically allocate work array
C
C
C     REFERENCE
C     _________
C
C     None
C
C
C     COMMENTS
C     ________
C
C     The input field is assumed to be global in extent, and a known
C     definition, either N160 or N80 (reduced or regular).
C     The output field has the same type and dimensions as the input
C     field.
C
C
C     AUTHOR
C     ______
C
C     J.D.Chambers      ECMWF       April 1996
C
C
C     MODIFICATIONS
C     _____________
C
C     None.
C
C
C----<
C     _______________________________________________________
C
C*    Section 0. Definition of variables.
C     _______________________________________________________
C
      IMPLICIT NONE
C
#include "parim.h"
#include "intf.h"
C
C     Parameters
C
      INTEGER JPROUTINE, JPMAXGG
      PARAMETER( JPROUTINE = 38500 )
      PARAMETER (JPMAXGG = 1280)
C
C     Subroutine arguments
C
      REAL OLDFLD, NEWFLD, POLELAT, POLELON
      INTEGER NUMPTS, NGAUSS
      DIMENSION OLDFLD(NUMPTS), NEWFLD(NUMPTS)
      CHARACTER*1 TYPE
C
C     Local variables
C
      REAL GLATS(JPMAXGG)
      INTEGER NGPTS(JPMAXGG)
      INTEGER OLDGAUS
      DATA OLDGAUS/0/
      CHARACTER*1 OLDTYPE
      DATA OLDTYPE/' '/
      SAVE GLATS, NGPTS, OLDGAUS, OLDTYPE
C
      INTEGER NEXT, NEXLAT, INROW, LOOP, KRET
      REAL STEPLON, CUTOFF, RLAT, RLON
      DIMENSION RLON(JPMAXGG*2)
C
      INTEGER ISIZE
      DATA ISIZE/0/
      REAL DUMI
      POINTER (IDUMI, DUMI)
      DIMENSION DUMI(1)
      SAVE IDUMI, ISIZE
C
C     Externals
C
      INTEGER IGGLAT
C
C     _______________________________________________________
C
C*    Section 1. Initialization.
C     _______________________________________________________
C
  100 CONTINUE
C
      NGROTAT = 0
C
      CALL INTLOG(JP_DEBUG,
     X  'NGROTAT: Number of pts in original field = ',NUMPTS)
      CALL INTLOGR(JP_DEBUG,
     X  'NGROTAT: Latitude of the South Pole of rotation = ',POLELAT)
      CALL INTLOGR(JP_DEBUG,
     X  'NGROTAT: Longitude of the South Pole of rotation = ',POLELON)
      CALL INTLOG(JP_DEBUG,'NGROTAT: Get gaussian grid type:',JPQUIET)
      CALL INTLOG(JP_DEBUG,TYPE,JPQUIET)
      CALL INTLOG(JP_DEBUG,'NGROTAT: grid number:',NGAUSS)
C
C     Get gaussian grid definition (first time only)
C
      IF( (OLDGAUS.NE.NGAUSS).OR.(OLDTYPE.NE.TYPE)) THEN
        CALL INTLOG(JP_DEBUG,
     X    'NGROTAT: Get definitions for gaussian grid type:',JPQUIET)
        CALL INTLOG(JP_DEBUG,TYPE,JPQUIET)
        CALL INTLOG(JP_DEBUG,'NGROTAT: grid number:',NGAUSS)
C
        KRET = IGGLAT(NGAUSS*2, GLATS, 0, 1)
        IF( KRET.NE.0 ) THEN
          CALL INTLOG(JP_ERROR, 'NGROTAT: IGGLAT call failed',KRET)
          NGROTAT = JPROUTINE + 2
          GOTO 900
        ENDIF
        DO LOOP = 1, NGAUSS
          NGPTS(LOOP) = ISEC2(22+LOOP)
          NGPTS(2*NGAUSS+1-LOOP) = NGPTS(LOOP)
        ENDDO
        OLDGAUS = NGAUSS
        OLDTYPE = TYPE
      ENDIF
C
C     Allocate work space if not already done.
C
      IF( ISIZE.LT.NUMPTS ) THEN
        ISIZE = NUMPTS
        CALL JMEMHAN(18,IDUMI,ISIZE,1,KRET)
        IF( KRET.NE.0 ) THEN
          CALL INTLOG(JP_ERROR,
     X      'NGROTAT: Memory allocation failed: status = ',KRET)
          NGROTAT = JPROUTINE + 2
          GOTO 900
        ENDIF
      ENDIF
C
C     Move the original field to the work array
C
      DO LOOP = 1, NUMPTS
        DUMI(LOOP) = OLDFLD(LOOP)
      ENDDO
C     _______________________________________________________
C
C*    Section 2. Work through latitude lines from north to south
C     _______________________________________________________
C
  200 CONTINUE
C
      NEXT = 1
C
      DO NEXLAT = 1, NGAUSS*2
        INROW = NGPTS(NEXLAT)
        STEPLON = 360.0/INROW
        RLAT = GLATS(NEXLAT)
C
C       Fill in longitudes along current line of latitude
C
        DO LOOP = 1, INROW
          RLON(LOOP) = (LOOP-1)*STEPLON
        ENDDO
C
C       Rotate the current line of latitude
C
        CALL NGVALUE(NEWFLD,NEXT,INROW,RLAT,RLON,
     X               POLELAT,POLELON,NGAUSS,TYPE,DUMI,GLATS,NGPTS)
C
        NEXT = NEXT + INROW
C
      ENDDO
C
C     _______________________________________________________
C
C*    Section 9. Return to calling routine.
C     _______________________________________________________
C
  900 CONTINUE
C
      CALL INTLOG(JP_DEBUG,'NGROTAT: Return from NGROTAT:',JPQUIET)
C
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      INTEGER FUNCTION IGLSMB( OISTAND, HIFILE, KIREC, KIGRID, KILINE,
     X   OOSTAND, HOFILE, KOREC, KOGRID, KOLINE, KPR, KERR)
C
C---->
C**** *IGLSMB*
C
C     PURPOSE
C     -------
C
C     Calculate the effects of the land-sea masks on the unnormalised
C     interpolation weights for regular input and output fields.
C
C
C     INTERFACE
C     ---------
C
C     IERR = IGLSMB( OISTAND, HIFILE, KIREC, KIGRID, KILINE, OOSTAND,
C    X   HOFILE, KOREC, KOGRID, KOLINE, KPR, KERR)
C
C
C     Input parameters
C     ----------------
C
C     OISTAND - Flag indicating whether the input land-sea mask
C               is a pre-stored "standard" field.
C
C     HIFILE  - The filename for the input land-sea mask.
C
C     KIREC   - The length of one latitude record in the input file.
C
C     KIGRID  - An array of length 2 giving the row and column
C               strides in a pre-stored land sea mask file for the
C               input grid.
C
C     KILINE  - An array of length 2 giving the offsets of the
C               Northern and Western starting points in a
C               pre-stored land sea mask file for the input grid.
C
C     OOSTAND - Flag indicating whether the output land-sea mask
C               is a prestored "standard" field.
C
C     HOFILE  - The filename for the output land-sea mask.
C
C     KOREC   - The length of one latitude record in the output file.
C
C     KOGRID  - An array of length 2 giving the row and column
C               strides in a pre-stored land sea mask file for the
C               output grid.
C
C     KOLINE  - An array of length 2 giving the offsets of the
C               Northern and Western starting points in a
C               pre-stored land sea mask file for the output grid.
C
C     KPR     - The debug print switch.
C               0  , No debugging output.
C               1  , Produce debugging output.
C
C     KERR    - The error control flag.
C               -ve, No error message. Return error code.
C               0  , Hard failure with error message.
C               +ve, Print error message. Return error code.
C
C
C     Output parameters
C     -----------------
C
C     The common variable WFACT is modified by this routine.
C
C     An error indicator
C
C     22401 An error exit was returned from the I/O routine PBOPEN.
C     22402 An error exit was returned from the I/O routine PBCLOSE.
C
C
C     Common block usage
C     ------------------
C
C     nifld.common - This file contains all the input field
C                    definition variables.
C
C     NINS         - Number of grid points in NS direction for input
C                    field (used in grspace.h).
C     NIWE         - Number of grid points in WE direction for input
C                    field is used.
C
C     nofld.common - This file contains all the output field
C                    definition variables.
C
C     NONS         - Number of grid points in NS direction for output
C                    field is used.
C     NOWE         - Number of grid points in WE direction for output
C                    field is used.
C
C     grspace.h    - This file contains all the work space array
C                    definitions for grid point to grid point
C                    interpolation.
C
C     MEXPAND      - Array of length JPLG01 (see parim.h) used to
C                    expand one latitude line of the 10 minute land
C                    sea mask file to have one word per bit for
C                    improved efficiency.
C     MWORK        - Array of length JPLONG (see parim.h) used to
C                    read one latitude line of a standard land sea
C                    mask file.
C
C     MILATG       - The input field latitudes.
C     MILONG       - The input field longitudes.
C     MILSM        - Work array used in calculating the effects of
C                    the land sea mask on interpolation.
C     MNSIND       - The latitude line numbers (array offset) of the
C                    input field associated with each line of
C                    latitude in the output field.
C     MOLATG       - The output field latitudes.
C     MOLONG       - The output field longitudes.
C     MOLSM        - Work array used in calculating the effects of
C                    the land sea mask on interpolation.
C     MWEIND       - This array holds the longitude points (array
C                    offset) from the input field associated with
C                    each longitude point in the output field.
C     WFACT        - The interpolation weights for each point in the
C                    output field.
C
C
C     Externals
C     ---------
C
C     ABORTX    - Standard routine to kill task.
C     IGLSM01   - Read and process one latitude row from the 10
C                 minute land sea mask.
C     IGLSMR    - Calculate the effects of the land-sea masks for one
C                 line of latitude on the unnormalised interpolation
C                 weights.
C     IGLSMST   - Read and process one line of latitude from a
C                 standard land sea mask file.
C     PBCLOSE   - Close a land sea mask file after processing.
C     PBOPEN    - Open a land sea mask file for processing.
C     INTLOG(R) - Logs messages.
C     JINDEX    - Returns length of character string
C
C
C     Method
C     ------
C
C     All the land sea mask data is in (0-1) form. If a point in the
C     input field has a different land sea mask value from the
C     corresponding point in the output field then its interpolating
C     weight is multiplied by a scaling factor. This scaling factor
C     is currently 0.2 so that the effect of such points in the final
C     interpolation is reduced.
C
C     The land-sea mask files are kept open between calls to this
C     routine.
C
C
C     Reference
C     ---------
C     None
C
C
C     Comments
C     --------
C     None
C
C
C     AUTHOR
C     ------
C     K. Fielding      *ECMWF*      Oct 1993
C
C
C     Modifications
C     -------------
C
C     J.D.Chambers      ECMWF       Oct 1996
C     Reduced number of parameters in call to IGLSMST and IGLSM01
C
C----<
C
C     -----------------------------------------------------------------|
C*    Section 0. Definition of variables.
C     -----------------------------------------------------------------|
C
C
      IMPLICIT NONE
C
#include "parim.h"
#include "nifld.common"
#include "nofld.common"
#include "grspace.h"
C
C     Dummy arguments
      LOGICAL OISTAND, OOSTAND
      CHARACTER *(*) HIFILE, HOFILE
      INTEGER KIREC, KOREC, KPR, KERR
      INTEGER KIGRID(2), KILINE(2), KOGRID(2), KOLINE(2)
C
C     Local variables
      INTEGER IIUNIT, IOUNIT, IIFILE, IOFILE
      INTEGER ILATN, ILATS, IISTRIDE, IOSTRIDE, IOFF, IPR, IERR
      INTEGER JOLAT
      CHARACTER*256 XHIFILE, XHOFILE
      CHARACTER*2 NEWFILE, MSKFILE
      INTEGER XIIUNIT, XIOUNIT, II
      DATA XIIUNIT/0/
      DATA XIOUNIT/0/
      SAVE  XHIFILE, XHOFILE, XIIUNIT, XIOUNIT
C
      INTEGER JPROUTINE
      PARAMETER (JPROUTINE = 22400)
C
C     External functions
      INTEGER IGLSMR, IGLSMST, IGLSM01, JINDEX
C
C     -----------------------------------------------------------------|
C*    Section 1. Initialisation
C     -----------------------------------------------------------------|
C
  100 CONTINUE
C
      IF( KPR.GE.1 ) CALL INTLOG(JP_DEBUG,'IGLSMB: Section 1.',JPQUIET)
C
      IGLSMB = 0
C
      IIFILE = JINDEX(HIFILE)
      IOFILE = JINDEX(HOFILE)
C
      IF( KPR.GE.1 ) THEN
        CALL INTLOG(JP_DEBUG,'IGLSMB: Input parameters are:',JPQUIET)
        CALL INTLOG(JP_DEBUG,'IGLSMB: Land sea mask file name:',JPQUIET)
        CALL INTLOG(JP_DEBUG,HIFILE(1: IIFILE),JPQUIET)
        IF( OISTAND ) THEN
          CALL INTLOG(JP_DEBUG,'IGLSMB: Stnd fld flag = TRUE',JPQUIET)
        ELSE
          CALL INTLOG(JP_DEBUG,'IGLSMB: Stnd fld flag = FALSE',JPQUIET)
        ENDIF
        CALL INTLOG(JP_DEBUG,'IGLSMB: LSM file rec len = ',KIREC)
        CALL INTLOG(JP_DEBUG,'IGLSMB: The grid stride WE = ',KIGRID(1))
        CALL INTLOG(JP_DEBUG,'IGLSMB: The grid stride NS = ',KIGRID(2))
        CALL INTLOG(JP_DEBUG,'IGLSMB: The grid start N = ',KILINE(1))
        CALL INTLOG(JP_DEBUG,'IGLSMB: The grid start W = ',KILINE(2))
C
        CALL INTLOG(JP_DEBUG,'IGLSMB: Output parameters are:',JPQUIET)
        CALL INTLOG(JP_DEBUG,'IGLSMB: Land sea mask file name:',JPQUIET)
        CALL INTLOG(JP_DEBUG,HOFILE(1: IIFILE),JPQUIET)
        IF( OOSTAND ) THEN
          CALL INTLOG(JP_DEBUG,'IGLSMB: Stnd fld flag = TRUE',JPQUIET)
        ELSE
          CALL INTLOG(JP_DEBUG,'IGLSMB: Stnd fld flag = FALSE',JPQUIET)
        ENDIF
        CALL INTLOG(JP_DEBUG,'IGLSMB: LSM file rec len = ',KOREC)
        CALL INTLOG(JP_DEBUG,'IGLSMB: The grid stride WE = ',KOGRID(1))
        CALL INTLOG(JP_DEBUG,'IGLSMB: The grid stride NS = ',KOGRID(2))
        CALL INTLOG(JP_DEBUG,'IGLSMB: The grid start N = ',KOLINE(1))
        CALL INTLOG(JP_DEBUG,'IGLSMB: The grid start W = ',KOLINE(2))
      ENDIF
C
      IF( MILONG(2).GE.MILONG(1) ) THEN
        IISTRIDE = MILONG(2) - MILONG(1)
      ELSE
        IISTRIDE = MILONG(2) + JP360 - MILONG(1)
      ENDIF
C
      IF( MOLONG(2).GE.MOLONG(1) ) THEN
        IOSTRIDE = MOLONG(2) - MOLONG(1)
      ELSE
        IOSTRIDE = MOLONG(2) + JP360 - MOLONG(1)
      ENDIF
C
C     -----------------------------------------------------------------|
C*    Section 2. Open files for input and output land sea masks
C     -----------------------------------------------------------------|
C
  200 CONTINUE
C
      IF( KPR.GE.1 ) CALL INTLOG(JP_DEBUG,'IGLSMB: Section 2.',JPQUIET)
C
C     See if first time through or input land sea mask filename has
C     changed since last access
C
      II = JINDEX(HIFILE)
      IF( XHIFILE(1:II).NE.HIFILE(1:II) ) THEN
C
C       Open input land sea mask file
C
        IF( XIIUNIT.NE.0 ) CALL PBCLOSE(XIIUNIT,IERR)
        CALL PBOPEN(IIUNIT, HIFILE, 'r', IERR)
        IF( IERR.NE.0 ) THEN
          IGLSMB = JPROUTINE + 1
C
          IF( KERR.GE.0 ) THEN
            CALL INTLOG(JP_ERROR,'IGLSMB: PBOPEN error = ',IERR)
            CALL INTLOG(JP_ERROR,'IGLSMB: trying to open file:',JPQUIET)
            CALL INTLOG(JP_ERROR, HIFILE(1:IIFILE) ,JPQUIET)
C
            IF( KERR.EQ.0 ) CALL INTLOG(JP_FATAL,
     X        'IGLSMB: Interpolation failed.',JPQUIET)
          ENDIF
          GOTO 900
        ENDIF
        XIIUNIT = IIUNIT
        XHIFILE(1:II) = HIFILE(1:II)
        NEWFILE(1:1) = 'Y'
C
C     Just rewind if same file still in use
C
      ELSE
        IIUNIT = XIIUNIT
        NEWFILE(1:1) = 'N'
      ENDIF
C
C     See if first time through or output land sea mask filename has
C     changed since last access
C
      II = JINDEX(HOFILE)
      IF( XHOFILE(1:II).NE.HOFILE(1:II) ) THEN
C
C       Open output land sea mask file
C
        IF( XIOUNIT.NE.0 ) CALL PBCLOSE(XIOUNIT,IERR)
        CALL PBOPEN(IOUNIT, HOFILE, 'r', IERR)
        IF( IERR.NE.0 ) THEN
          IGLSMB = JPROUTINE + 1
C
          IF( KERR.GE.0 ) THEN
            CALL INTLOG(JP_ERROR,'IGLSMB: PBOPEN error = ',IERR)
            CALL INTLOG(JP_ERROR,'IGLSMB: trying to open file:',JPQUIET)
            CALL INTLOG(JP_ERROR, HOFILE(1:IOFILE) ,JPQUIET)
C
            IF( KERR.EQ.0 ) CALL INTLOG(JP_FATAL,
     X        'IGLSMB: Interpolation failed.',JPQUIET)
            GOTO 900
          ENDIF
        ENDIF
        XIOUNIT = IOUNIT
        XHOFILE(1:II) = HOFILE(1:II)
        NEWFILE(2:2) = 'Y'
C
C     Just rewind if same file still in use
C
      ELSE
        IOUNIT = XIOUNIT
        NEWFILE(2:2) = 'N'
      ENDIF
C     -----------------------------------------------------------------|
C*    Section 3. Calculate arrays of weights
C     -----------------------------------------------------------------|
C
  300 CONTINUE
C
      IF( KPR.GE.1 ) CALL INTLOG(JP_DEBUG,'IGLSMB: Section 3.',JPQUIET)
C
      IPR = KPR
C
      DO JOLAT = 1, NONS
C
C       Get line for output array
C
        IF( OOSTAND ) THEN
C
          IOFF = (KOLINE(JPNORTH) + (JOLAT - 1) * KOGRID(JPNSSTEP)
     X         - 1) * KOREC
C
          MSKFILE(2:2) = 'O'
          MSKFILE(1:1) = NEWFILE(2:2)
          IERR = IGLSMST(IOUNIT, IOFF, NOWE, KOLINE(JPWEST),
     X                   KOGRID(JPWESTEP), KOREC, MOLSM, MSKFILE)
          NEWFILE(2:2) = 'N'
C
        ELSE
          IERR = IGLSM01(IOUNIT, NOWE, MOLONG, MOLATG(JOLAT),
     X                   MEXPAND, KOREC, MOLSM)
        ENDIF
C
        IF( IERR.GT.0 ) THEN
          IGLSMB = IERR
          GOTO 900
        ENDIF
C
        ILATN = MNSIND(JP_I_N, JOLAT)
        ILATS = MNSIND(JP_I_S, JOLAT)
C
C       Get lines for input array
C
        IF( OISTAND ) THEN
C
          IOFF = (KILINE(JPNORTH) + (ILATN - 1) * KIGRID(JPNSSTEP)
     X             - 1) * KIREC
C
          MSKFILE(2:2) = 'I'
          MSKFILE(1:1) = NEWFILE(1:1)
          IERR = IGLSMST(IIUNIT, IOFF, NIWE, KILINE(JPWEST),
     X         KIGRID(JPWESTEP), KIREC, MILSM(1, JP_I_N), MSKFILE)
          NEWFILE(1:1) = 'N'
C
          IF( IERR.GT.0 ) THEN
            IGLSMB = IERR
            GOTO 900
          ENDIF
C
          IOFF = (KILINE(JPNORTH) + (ILATS - 1) * KIGRID(JPNSSTEP)
     X         - 1) * KIREC
C
          MSKFILE(2:2) = 'I'
          MSKFILE(1:1) = NEWFILE(1:1)
          IERR = IGLSMST(IIUNIT, IOFF, NIWE, KILINE(JPWEST),
     X         KIGRID(JPWESTEP), KIREC, MILSM(1, JP_I_S), MSKFILE)
          NEWFILE(1:1) = 'N'
C
        ELSE
C
          IERR = IGLSM01(IIUNIT, NIWE, MILONG, MILATG(ILATN),
     X         MEXPAND, KIREC, MILSM(1, JP_I_N))
C
          IF( IERR.GT.0 ) THEN
            IGLSMB = IERR
            GOTO 900
          ENDIF
C
          IERR = IGLSM01(IIUNIT, NIWE, MILONG, MILATG(ILATS),
     X         MEXPAND, KIREC, MILSM(1, JP_I_S))
C
        ENDIF
C
        IF( IERR.GT.0 ) THEN
          IGLSMB = IERR
          GOTO 900
        ENDIF
C
C       Now modify the unormalised weight for land-sea mask
C
        IERR = IGLSMR(MILSM(1, JP_I_N), MILSM(1, JP_I_S), MOLSM,
     X      MWEIND, MWEIND, NOWE, WFACT(1,(JOLAT - 1) * NOWE + 1),
     X      IPR, KERR)
C
        IF( IERR.GT.0 ) THEN
          IGLSMB = IERR
          GOTO 900
        ENDIF
C
        IPR = KPR - 1
C
      ENDDO
C
C     -----------------------------------------------------------------|
C*    Section 9. Return to calling routine. Format statements
C     -----------------------------------------------------------------|
C
  900 CONTINUE
C
      IF( KPR.GE.1 ) CALL INTLOG(JP_DEBUG,'IGLSMB: Section 9.',JPQUIET)
C
 9001 FORMAT(' IGLSMB ERROR', I6, ' - ', A, ' returned code', I6 /
     1   21X, ' when ', A, 'ing file - ', A)
C
C
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE INTLOGR(KLEVEL, MESSAGE, PNUM)
C
C---->
C**** INTLOGR
C
C     PURPOSE
C     _______
C
C     This routine logs error messages.
C
C
C     INTERFACE
C     _________
C
C     CALL INTLOGR(KLEVEL, MESSAGE, PNUM)
C
C
C     Input parameters
C     ________________
C
C     KLEVEL   - Severity level for reported message
C                = 0 for debug
C                = 1 for information
C                = 2 for warning
C                = 3 for error
C                = 4 for fatal
C     MESSAGE  - Message text
C     PNUM     - Message number
C
C
C     Output parameters
C     ________________
C
C     None.
C
C
C     Common block usage
C     __________________
C
C     LDEBUG in /INTLOGC/ controls display of message
C                 = 0 for no display
C                 = 1 to display
C
C
C     Method
C     ______
C
C     Prints message and number if debug flag is 'on'.
C
C
C     Externals
C     _________
C
C     INTLOGT  - sends any ERROR, FATAL or WARN message to the
C                MARS server.
C
C
C     Comments
C     ________
C
C     LDEBUG is toggled by a call to INTLOGD.
C
C
C     AUTHOR
C     ______
C
C     J.D.Chambers      *ECMWF*      Jul 1995
C
C
C     MODIFICATIONS
C     _____________
C
C     J.D.Chambers      *ECMWF*      March 1996
C     Prepare error message for MARS server.
C
C
C----<
C     _______________________________________________________
C
      IMPLICIT NONE
C
#include "parim.h"
C
C     Subroutine arguments.
C
      INTEGER KLEVEL
      REAL PNUM
      CHARACTER *(*) MESSAGE

#ifdef MPI_DEBUG
#include "mpif.h"
#endif

C
C     Local variables.
C
      CHARACTER*120 NEWMESS
      INTEGER NLEV, LOOP
      CHARACTER*5 TITLE(JP_FATAL+1)
      DATA TITLE/'DEBUG',
     X           'INFO ',
     X           'WARN ',
     X           'ERROR',
     X           'FATAL'/
      INTEGER ILEN

#ifdef MPI_DEBUG
      INTEGER my_id, ierr
      Data my_id /-1/
      Save my_id
#endif

C
C ------------------------------------------------------------------
C*    Section 1.   Initialise
C ------------------------------------------------------------------
C
  100 CONTINUE
C
C     Ensure valid level is used.
      NLEV = KLEVEL + 1
      IF ( KLEVEL .GT. JP_FATAL) NLEV = JP_FATAL + 1
C
      DO LOOP = 1, 120
        NEWMESS(LOOP:LOOP) = ' '
      ENDDO
C
C ------------------------------------------------------------------
C*    Section 2.   Prepare ERROR or FATAL message for MARS server.
C ------------------------------------------------------------------
C
  200 CONTINUE
C
      ILEN = LEN(MESSAGE)
      IF( ILEN.GT.95 ) ILEN = 95

#ifdef MPI_DEBUG
      if (my_id.eq.-1) Then
      call MPI_COMM_RANK (MPI_COMM_WORLD, my_id, ierr)
      my_id = my_id + 1
      end if
#endif

      NEWMESS(1:ILEN) = MESSAGE(1:ILEN)
      ILEN = ILEN + 1
      IF( ABS(PNUM).LT.100000.0 ) THEN
        WRITE(NEWMESS(ILEN:),'(F25.15)') PNUM
      ELSE IF ( ABS(PNUM).LT.10000000000.0 ) THEN
        WRITE(NEWMESS(ILEN:),'(F25.10)') PNUM
      ELSE IF ( ABS(PNUM).LT.10000000000000.0 ) THEN
        WRITE(NEWMESS(ILEN:),'(F25.7)') PNUM
      ELSE
        WRITE(NEWMESS(ILEN:),'(F25.2)') PNUM
      ENDIF
C
C     Send the message
C
      IF( KLEVEL.GE.JP_WARN ) CALL INTLOGT(NEWMESS)
C

#ifdef MPI_DEBUG
      IF( LDEBUG ) WRITE(*,9001) my_id,TITLE(NLEV),NEWMESS
 9001 FORMAT(i4,' INTLOG ',A5,': ',A120)
#else
cc      IF( LDEBUG ) WRITE(*,9001) TITLE(NLEV),NEWMESS
cc 9001 FORMAT('INTLOG ',A5,': ',A120)
#endif

C
C ------------------------------------------------------------------
C*    Section 9.   Closedown.
C ------------------------------------------------------------------
C
  900 CONTINUE
C
      RETURN
      END

C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE JINTEND
C
C---->
C**** JINTEND
C
C     PURPOSE
C     _______
C
C     This routine deallocates heap memory (if any) allocated
C     by JINTLL, JINTGG and/or INTF.
C
C     INTERFACE
C     _________
C
C     CALL JINTEND( )
C
C
C     Input parameters
C     ________________
C
C     None.
C
C
C     Output parameters
C     ________________
C
C     None.
C
C
C     Common block usage
C     __________________
C
C     None.
C
C
C     Method
C     ______
C
C     None.
C
C
C     Externals
C     _________
C
C     None.
C
C
C     Reference
C     _________
C
C     None.
C
C
C     Comments
C     ________
C
C     None.
C
C
C     AUTHOR
C     ______
C
C     J.D.Chambers      *ECMWF*      May 1994
C
C
C     MODIFICATIONS
C     _____________
C
C     None.
C
C----<
C     _______________________________________________________
C
C*    Section 0. Definition of variables.
C     _______________________________________________________
C
      IMPLICIT NONE
C
C     Local variables
C
#ifdef POINTER_64
      INTEGER*8 IZERO
#else
      INTEGER IZERO
#endif
      INTEGER IRET
      DATA IZERO/0/
C
C     _______________________________________________________
C
C*    Section 1.    Deallocate heap memory.
C     _______________________________________________________
C
  100 CONTINUE
C
C     Lat/long (JINTLL)
C
      CALL JMEMHAN( 1, IZERO, 0, 0, IRET )
C
C     Gaussian (JINTGG)
C
      CALL JMEMHAN( 2, IZERO, 0, 0, IRET )
C
C     Scratch (INTF)
C
      CALL JMEMHAN( 3, IZERO, 0, 0, IRET )
      CALL JMEMHAN( 4, IZERO, 0, 0, IRET )
      CALL JMEMHAN( 5, IZERO, 0, 0, IRET )
C
C     _______________________________________________________
C
C*    Section 9. Return to calling routine.
C     _______________________________________________________
C
 900  CONTINUE
C
      RETURN
C
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE ECDEF9( HFUNC, KSEC1, KGRIB, KLENG, KNSPT, KBITS,
     X                   KPR, KRET)
C
C---->
C**** ECDEF9
C
C     Purpose.
C     --------
C
C     GRIB coding/decoding of ECMWF local use definition 9.
C
C**   Interface.
C     ----------
C
C     CALL ECDEF9( HFUNC, KSEC1, KGRIB, KLENG, KNSPT, KBITS, KPR, KRET)
C
C
C     Input Parameters.
C     -----------------
C
C     HFUNC      - Requested function.
C                  'C' to code data.
C                  'D' to decode data.
C
C     KSEC1      - Array containing Grib Section 1 data.
C
C     KGRIB      - Array containing Grib coded data.
C
C     KLENG      - Length (words) of KGRIB.
C
C     KNSPT      - Bit number after which insertion/extraction starts.
C
C     KBITS      - Number of bits in computer word.
C
C     KPR        - Debug print switch.
C                  0  , No printout.
C                  >0 , Debug printout.
C
C     KRET       - Response to error indicator.
C                  0        , Abort if error encountered.
C                  Non-zero , Return to calling routine
C                             even if error encountered.
C
C     Output Parameters.
C     ------------------
C
C     KSEC1      - Array containing Grib Section 1 data.(Updated)
C
C     KGRIB      - Array containing Grib coded data.(Updated)
C
C     KNSPT      - Number of bit after last one inserted/extracted.
C                  (Updated)
C
C     KRET       - Return code.
C                  0   , No error encountered.
C                  2   , Error reported by routine INXBIT.
C
C
C     Method.
C     -------
C
C     Input data packed/unpacked in accordance with ECMWF usage of
C     local part of section 1 of Grib code, definition 9.
C
C
C     Externals.
C     ----------
C
C     INXBIT  - insert/extract bits
C     ABORTX  - abort the program
C     CSGNBT  - code a signed value
C     DSGNBT  - decode a signed value
C
C
C     Reference.
C     ----------
C
C     WMO Manual On Codes for Grib Code.
C
C
C     Comments.
C     ---------
C
#include "ecdef9.h"
C
C
C     Author.
C     -------
C
C     J.D.Chambers     ECMWF      June 1996
C
C
C     Modifications.
C     --------------
C
C     None
C
C
C----<
C     ------------------------------------------------------------------
C*    Section 0 . Definition of variables. Data statements.
C     ------------------------------------------------------------------
C
      IMPLICIT NONE
C
#include "common/grprs.h"
C
C     Parameters
      CHARACTER*1   HFUNC
      INTEGER KSEC1, KGRIB, KLENG, KNSPT, KBITS, KPR, KRET
      DIMENSION KGRIB(*)
      DIMENSION KSEC1(*)
C
C     Local variables
      INTEGER IRET, IZERO, JLOOP, ITEMP, IRETA
C
      LOGICAL LENCODE, LDECODE
C
C     ------------------------------------------------------------------
C*    Section 1 . Set initial values.
C     ------------------------------------------------------------------
C
  100 CONTINUE
C
      IRET = KRET
      LENCODE = ( HFUNC .EQ. 'C' )
      LDECODE = .NOT. LENCODE
C
C     ------------------------------------------------------------------
C*    Section 2 . Handle singular vector.
C     ------------------------------------------------------------------
C
  200   CONTINUE
C
      IF( KSEC1(39).EQ.62 ) THEN
C
C       Octets 50-51 : Singular vector number.
C       Octets 52-53 : Number of iterations.
C       Octets 54-55 : Number of singular vectors computed.
C       Three 16 bit fields.
C
        CALL INXBIT(KGRIB,KLENG,KNSPT,KSEC1(42),3,KBITS,16,HFUNC,KRET)
        IF (KRET.NE.0) THEN
          KRET = 2
          WRITE(GRPRSM,*) 'ECDEF9: Error reported by routine INXBIT:'
          IF( LENCODE ) THEN
            WRITE(GRPRSM,*)
     X  '      encoding section 1, elements 42 - 44.'
          ELSE
            WRITE(GRPRSM,*) '      decoding section 1, octets 50 - 55.'
          ENDIF
        ENDIF
C
C       Octet 56 : Norm used at initial time.
C       Octet 57 : Norm used at final time.
C       Two 8 bit fields.
C
        CALL INXBIT(KGRIB,KLENG,KNSPT,KSEC1(45),2,KBITS,8,HFUNC,KRET)
        IF (KRET.NE.0) THEN
          KRET = 2
          WRITE(GRPRSM,*) 'ECDEF9: Error reported by routine INXBIT:'
          IF( LENCODE ) THEN
            WRITE(GRPRSM,*)
     X  '      encoding section 1, elements 45 - 46.'
          ELSE
            WRITE(GRPRSM,*) '      decoding section 1, octets 56 - 57.'
          ENDIF
        ENDIF
C
C       Octets 58-61 : Multiplication factor.
C       One 32 bit field.
C
        CALL INXBIT(KGRIB,KLENG,KNSPT,KSEC1(47),1,KBITS,32,HFUNC,KRET)
        IF (KRET.NE.0) THEN
          KRET = 2
          WRITE(GRPRSM,*) 'ECDEF9: Error reported by routine INXBIT:'
          IF( LENCODE ) THEN
            WRITE(GRPRSM,*) '      encoding section 1, element 47.'
          ELSE
            WRITE(GRPRSM,*) '      decoding section 1, octets 58 - 61.'
          ENDIF
        ENDIF
C
C       Octets 62-65 : Latitude of north-west corner of LPO area.
C       Octets 66-69 : Longitude of north-west corner of LPO area.
C       Octets 70-73 : Latitude of south-east corner of LPO area.
C       Octets 74-77 : Longitude of south-east corner of LPO area.
C       Four signed 32 bit fields.
C
        DO 210 JLOOP = 48, 51
          IF ( LENCODE ) CALL CSGNBT( ITEMP, KSEC1(JLOOP), 32, IRETA)
          CALL INXBIT(KGRIB,KLENG,KNSPT,ITEMP,1,KBITS,32,HFUNC,KRET)
          IF ( LDECODE ) CALL DSGNBT( KSEC1(JLOOP), ITEMP, 32, IRETA)
          IF ( (IRETA.NE.0) .OR. (KRET.NE.0) ) THEN
            KRET = 2
            WRITE(GRPRSM,*) 'ECDEF9: Error reported by routine INXBIT:'
            WRITE(GRPRSM,*)
     X  'encoding/decoding section 1, element ', JLOOP
          ENDIF
  210   CONTINUE
C
C       Octets 78-81 : Accuracy.
C       One 32 bit field.
C
        CALL INXBIT(KGRIB,KLENG,KNSPT,KSEC1(52),1,KBITS,32,HFUNC,KRET)
        IF (KRET.NE.0) THEN
          KRET = 2
          WRITE(GRPRSM,*) 'ECDEF9: Error reported by routine INXBIT:'
          IF( LENCODE ) THEN
            WRITE(GRPRSM,*) '      encoding section 1, element 52.'
          ELSE
            WRITE(GRPRSM,*) '      decoding section 1, octets 78 - 81.'
          ENDIF
        ENDIF
C
C       Octets 82-83 : Number of singular vectors evolved.
C       One 16 bit field.
C
        CALL INXBIT(KGRIB,KLENG,KNSPT,KSEC1(53),1,KBITS,16,HFUNC,KRET)
        IF (KRET.NE.0) THEN
          KRET = 2
          WRITE(GRPRSM,*) 'ECDEF9: Error reported by routine INXBIT:'
          IF( LENCODE ) THEN
            WRITE(GRPRSM,*) '      encoding section 1, element 53.'
          ELSE
            WRITE(GRPRSM,*) '      decoding section 1, octets 82 - 83.'
          ENDIF
        ENDIF
C
C       Octets 84-87 : Ritz number.
C       Octets 88-91 : Ritz number.
C       Two signed 32 bit fields.
C
        DO 220 JLOOP = 54, 55
          IF ( LENCODE ) CALL CSGNBT( ITEMP, KSEC1(JLOOP), 32, IRETA)
          CALL INXBIT(KGRIB,KLENG,KNSPT,ITEMP,1,KBITS,32,HFUNC,KRET)
          IF ( LDECODE ) CALL DSGNBT( KSEC1(JLOOP), ITEMP, 32, IRETA)
          IF ( (IRETA.NE.0) .OR. (KRET.NE.0) ) THEN
            KRET = 2
            WRITE(GRPRSM,*) 'ECDEF9: Error reported by routine INXBIT:'
            WRITE(GRPRSM,*)
     X  'encoding/decoding section 1, element ', JLOOP
          ENDIF
  220   CONTINUE
C
C       Octet 92 : Reserved.
C       Set to 0.
C
        IF ( LENCODE ) THEN
          IZERO = 0
          CALL INXBIT(KGRIB,KLENG,KNSPT,IZERO,1,KBITS,8,HFUNC,KRET)
          IF (KRET.NE.0) THEN
            KRET = 2
            WRITE(GRPRSM,*) 'ECDEF9: Error reported by routine INXBIT:'
            IF( LENCODE ) THEN
              WRITE(GRPRSM,*)
     X  '      encoding section 1, reserved element.'
            ELSE
              WRITE(GRPRSM,*) '      decoding section 1, octets 92.'
            ENDIF
          ENDIF
        ELSE
          KNSPT = KNSPT + 8
        ENDIF
C
C     ------------------------------------------------------------------
C*    Section 3 . Handle perturbation analysis or perturbation.
C     ------------------------------------------------------------------
C
      ELSE
C
  300   CONTINUE
C
C       Octets 50-51 : Perturbation analysis or perturbation number.
C       One 16 bit field.
C
        CALL INXBIT(KGRIB,KLENG,KNSPT,KSEC1(42),1,KBITS,16,HFUNC,KRET)
        IF (KRET.NE.0) THEN
          KRET = 2
          WRITE(GRPRSM,*) 'ECDEF9: Error reported by routine INXBIT:'
          IF( LENCODE ) THEN
            WRITE(GRPRSM,*) '      encoding section 1, element 42.'
          ELSE
            WRITE(GRPRSM,*) '      decoding section 1, octets 50 - 51.'
          ENDIF
        ENDIF
C
        IF ( LENCODE ) THEN
C
C         Octets 52-92 set to zero
          DO 310 JLOOP = 52,92
            IZERO = 0
            CALL INXBIT(KGRIB,KLENG,KNSPT,IZERO,1,KBITS,8,HFUNC,KRET)
            IF (KRET.NE.0) THEN
              KRET = 2
              WRITE(GRPRSM,*)
     X  'ECDEF9: Error reported by routine INXBIT:'
              WRITE(GRPRSM,*)
     X  '        encoding section 1, element ',JLOOP
            ENDIF
  310     CONTINUE
C
        ELSE
C
C         KSEC1(43-55) set to zero.
          DO 320 JLOOP = 43, 55
            KSEC1(JLOOP) = 0
  320     CONTINUE
          KNSPT = KNSPT + 328
          KRET = 0
        ENDIF
C
C     ------------------------------------------------------------------
C*    Section 9 . Abort/return to calling routine. Format statements.
C     ------------------------------------------------------------------
C
      ENDIF
C
  900 CONTINUE
C
      IF( KPR.GE.1 ) THEN
        WRITE(GRPRSM,*) 'ECDEF9: Section 9.'
        WRITE(GRPRSM,*) '        Output values set, KNSPT = ', KNSPT
      ENDIF
C
C     Abort if requested to do so when an error has been encountered.
C
      IF (IRET.EQ.0.AND.KRET.NE.0) THEN
        CALL ABORTX ('ECDEF9')
      ELSE
        RETURN
      ENDIF
C
C
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities
C granted to it by virtue of its status as an intergovernmental organisation
C nor does it submit to any jurisdiction.
C


      SUBROUTINE PARVAL (KCSP,KNSP,HLINE,HPAR,KLPAR,HVAL,KLVAL)
C
C---->
C**** PARVAL - Extract next parameter and value pair.
C
C     Purpose.
C     --------
C
C         Get next parameter and value from line.
C
C**   Interface.
C     ----------
C
C         CALL PARVAL (KCSP,KNSP,HLINE,HPAR,KLPAR,HVAL,KLVAL)
C
C         INTEGER     K.
C         REAL        P.
C         LOGICAL     O.
C         CHARACTER   H.
C
C             Input Parameters.
C             -----------------
C
C                KCSP  = Current search start position
C                HLINE = Line being examined
C
C             Output Parameters.
C             -----------------
C
C                KNSP   = Next search position (for next call)
C                         It is set to zero if the last set of
C                         PARAMETER=VALUE pairs is found, and
C                         to -1 if further parameters and values
C                         are to be read from a continuation line.
C
C                KLPAR  = Length of parameter string
C
C                HPAR   = Parameter
C
C                KLVAL  = Length of value string
C
C                HVAL   = Value
C
C     Method.
C     -------
C
C          The separators / , = and " are found to identify
C          the parameters and values.
C
C     Externals.
C     ----------
C
C          RTB
C          REMSP
C          DELSP
C          REPCHR
C
C     Reference.
C     ----------
C
C          MARS User Guide for information on parameters and
C          value pairs.
C
C     Comments.
C     ---------
C
C          Routine contains sections 0-4 and section 9.
C
C     Author.
C     -------
C
C          J. Hennessy 16.04.85
C
C     Modifications.
C     --------------
C
C          J. Hennessy 08.04.86
C
C                "     15.09.86
C
C          J. Hennessy 03.07.90
C          Character variable HVAL made to agree in length with
C          that in calling routine.
C
C          J. Hennessy 23.11.90
C          Allow COMMENT values to include commas.
C
C          J. Hennessy 18.02.91
C          Adjust YLINE length to match HLINE. Allow for / in error
C          at start of list of parameters.
C
C          J. Hennessy 15.10.92
C          Check on input string length added.
C
C----<
C     ---------------------------------------------------------------
C
C
C*    Section 0 . Definition of variables.
C     ---------------------------------------------------------------
C
      IMPLICIT LOGICAL     ( L, O, G )
      IMPLICIT CHARACTER*8 ( C, H, Y )
      IMPLICIT INTEGER     ( I, J, K, M, N )
C
      PARAMETER (JPMAX=960)
C
      INTEGER RTB
C
      CHARACTER*(*) HLINE
      CHARACTER*8   HPAR
      CHARACTER*(*) HVAL
      CHARACTER*(JPMAX) YLINE
C
C     ---------------------------------------------------------------
C
C
C*    Section 1 . Set initial values.
C     ---------------------------------------------------------------
C
 1000 CONTINUE
C
C     Check length of input string.
C
      ILEN = LEN (HLINE)
      IF (ILEN.GT.JPMAX)
     C   THEN
             WRITE (*,9001) ILEN , JPMAX
             CALL ABORTX ('PARVAL')
         ENDIF
C
C     Set parameter and value to 'space' and their lengths to 0.
C
      HPAR  = ' '
      HVAL  = ' '
      KLPAR = 0
      KLVAL = 0
C
C
C
C*    Section 2 . Handle request from HELP facility.
C     ---------------------------------------------------------------
C
 2000 CONTINUE
C
C     First check if help is being requested by use of ?.
C
      IF (HLINE(KCSP:KCSP).EQ.'?')
     C     THEN
               HPAR  = '?'
               KLPAR = 1
               KNSP  = KCSP + 1
               GO TO 9000
           ENDIF
C
C*     Go to section 9.
C
C     ---------------------------------------------------------------
C
C
C
C*    Section 3 . Tidy up input format a little.
C     ---------------------------------------------------------------
C
 3000 CONTINUE
C
C     Change any ' characters to " characters.
C
c--      CALL REPCHR (HLINE,'''','"')
C
C     Remove any spaces before or after / separators.
C
c--      CALL DELSP (HLINE)
C
C     ---------------------------------------------------------------
C
C
C
C*    Section 4 . Extract next parameter and its value.
C     ---------------------------------------------------------------
C
 4000 CONTINUE
C
C     Look for next '=' and ',' in line. Examine
C     the last character in the line. If this is a ',' a
C     continuation line will follow. Otherwise the last
C     PARAMETER=VALUE pair for the current command has been
C     read.
C
      II = INDEX (HLINE(KCSP:),'=')
      IJ = INDEX (HLINE(KCSP:),',')
      IK = RTB(HLINE)
      KNSP = 0
      IF (HLINE(IK:IK).EQ.',') KNSP = -1
C
      IF (II.EQ.0.AND.IJ.EQ.0)
C
C*    No = or , found. Go to section 9.
C
     C    THEN
C
C             Check that no entry with missing = has been made.
C             Set parameter and value to unrecognised string,
C
              IF (IK.GT.KCSP)
     C        THEN
                  HPAR = HLINE(KCSP:IK)
                  CALL REMSP (HPAR)
                  IF (HPAR(1:1).NE.' ')
     C                      THEN
                                HPAR = HLINE(KCSP:IK)
                                KLPAR = IK - KCSP + 1
                                HVAL = HLINE(KCSP:IK)
                                KLVAL = IK - KCSP + 1
                                KNSP = IK + 1
                            ENDIF
              ENDIF
C
              GO TO 9000
          ENDIF
C
      IF (II.EQ.0.AND.IJ.NE.0)
C
C*    , found but no = found. Check that no erroneous entry
C     has been made. Go to section 9.
C
     C     THEN
C
C              Check that no erroneous entry with missing =
C              exists.
C
               HPAR = HLINE(KCSP:KCSP+IJ-2)
               CALL REMSP (HPAR)
               IF (HPAR(1:1).NE.' ')
     C             THEN
                       KLPAR = RTB(HPAR)
                       HVAL = HPAR
                       KLVAL = KLPAR
                       KNSP = KCSP + IJ- 1
                   ENDIF
               GO TO 9000
           ENDIF
C
C     Extract parameter entry and its length.
C
      KLPAR = II - 1
      HPAR = HLINE(KCSP:KCSP+KLPAR-1)
C
C     Remove any leading/trailing spaces.
C
      IF (HPAR(1:1).EQ.' ') THEN
                               CALL REMSP(HPAR)
                               KLPAR = RTB (HPAR)
                           ENDIF
C
C     Find end of value entry. This can be a comma, space or
C     a full stop.
C     If none is found the remaining characters are taken as
C     the value, and treated as the last entry for this command.
C
      KCSP = KCSP + II
C
C     Remove any spaces between = and value.
C     Remove any / put at the start of a list of values.
C
      YLINE(1:) = HLINE(KCSP:)
      IF (YLINE(1:1).EQ.'/') YLINE(1:1) = ' '
      CALL REMSP (YLINE)
      HLINE (KCSP:) = YLINE
C
      II = INDEX(HLINE(KCSP:),',')
C
C     If the value is a character string it may contain a ",".
C     Currently only the COMMENT parameter in a CREATE command
C     can validly have an embedded , .
C
      CALL L2U1CR (HPAR)
      IF (HLINE(KCSP:KCSP).EQ.'"'.AND.HPAR(1:7).EQ.'COMMENT')
     C   THEN
             ISTR = INDEX(HLINE(KCSP+1:),'"')
             IF (ISTR.GE.II) II = ISTR + 2
         ENDIF
C
C     Extract value entry and length
C
      IF (II.EQ.0)
     C    THEN
              II = RTB (HLINE)
              IF (HLINE(II:II).EQ.'.') II = II - 1
              KLVAL = II - KCSP + 1
          ELSE
              KLVAL = II - 1
          ENDIF
C
C     Handle missing value (eg date=, entered) where length is 0.
C
      KNSP = KCSP + KLVAL + 1
C
      IF (KLVAL.GT.0)
     C   THEN
             HVAL = HLINE(KCSP:KCSP+KLVAL-1)
         ELSE
             HVAL = ' '
             KLVAL = 1
         ENDIF
C
C     ---------------------------------------------------------------
C
C
C
C*    Section 9. Return to calling routine.
C     ---------------------------------------------------------------
C
 9000 CONTINUE
C
 9001 FORMAT (1H ,'PARVAL : String length is ',I3,'. Maximum',
     C            ' allowed is ',I3,'.')
      RETURN
C
      END

PROGRAM MODIFY_GRIB
!
!     CHANGES THE HEADERS OF ALL GRIB FIELDS CONTAINED IN A FILE
!
!     Written by D.Dent  (20/11/2001)

!     Interface:  modify_grib -i input_file -o output_file -n namelist_file [-d]

!     Parameters:
!                 -i   input_file, containing GRIB fields
!                 -o   output_file, contains the same GRIB fields
!                                   with modified headers
!                 -n   namelist_file, containing Fortran namelist format data
!                      namelist USHEAD
!                      allows details ofchanges to header fields to be specified
!                 -d   optional flag to force decoding/recoding

!     This program is derived from:
!        change_grib    (Pedro Viterbo)
!        changeGrib     (John Chambers)
!        fix_local_grib (Jan Haseler)
!     and combines all of the requirements in one application.
!
!     Features:
!      (1) Do not decode/encode unless necessary
!          This is achieved by calling the C-coded routine 'chgrib'
!      (2) The input fields are decode/recoded:
!            if the namelist input requires a change in packing density
!            if a command line flag is provided (-d)
!          This option also imposes an ECMWF local GRIB definition
!          The output is GRIB coded using option 'M' to ensure that
!          fields which contain missing data are kept to a constant length
!          

PARAMETER(JPPKLEN=0,JPUNPKLEN=2000000, &
    JPMAXLEV=200,JD1=1024,JD2=4096,JD4=1024,JLV=10+JPMAXLEV)

!  IMPLICIT NONE

INTEGER :: IOPTVAL
LOGICAL :: LLDECODE
CHARACTER*16  :: CLOPTP='i:o:n:d'
CHARACTER*64  :: CL_USAGE
CHARACTER*128 :: CLARG
CHARACTER*128 :: CL_NAMELIST_FILE,CL_INPUT_FILE,CL_OUTPUT_FILE
CHARACTER*1   :: CLOPT

INTEGER ISEC0(2),ISEC1(JD1),ISEC2(JD2),ISEC3(2),ISEC4(JD4)
INTEGER IUSEC0(2),IUSEC1(JD1),IUSEC2(JD2),IUSEC3(2), IUSEC4(JD4)
INTEGER,ALLOCATABLE :: IGRIB(:)
INTEGER :: IPPKLEN=JPPKLEN
INTEGER :: IUNPKLEN=JPUNPKLEN
INTEGER GETOPT
INTEGER CHGRIB

REAL*8,ALLOCATABLE :: ZUNP(:)
REAL*8  ZSEC2(JLV),ZSEC3(2)

CHARACTER*4 CNMEXP
NAMELIST /USHEAD/IUSEC0,IUSEC1,IUSEC2,IUSEC3,IUSEC4,CNMEXP

!
!    read input parameters
!
CL_NAMELIST_FILE=""
CL_INPUT_FILE=""
CL_OUTPUT_FILE=""
CL_USAGE='Usage: modify_grib -i input_file -o output_file -n namelist_file [-d]'
IBYTES=4
LLDECODE=.FALSE.
IOPTVAL=GETOPT(CLOPTP,CLARG)

DO WHILE (IOPTVAL > 0)
  CLOPT=CHAR(IOPTVAL)
  IF(CLOPT == 'n') THEN
    CL_NAMELIST_FILE=CLARG
  ELSEIF(CLOPT == 'i') THEN
    CL_INPUT_FILE=CLARG
  ELSEIF(CLOPT == 'o') THEN
    CL_OUTPUT_FILE=CLARG
  ELSEIF(CLOPT == 'd') THEN
    LLDECODE=.TRUE.
  ELSE
    WRITE(0,'(A,A)') 'Invalid parameter ',CLOPT
    CALL ABORT
  ENDIF
  IOPTVAL=GETOPT(CLOPTP,CLARG)
ENDDO

IF(CL_NAMELIST_FILE == "") THEN
  WRITE(0, *) 'namelist file missing'
  WRITE(0, *) CL_USAGE
  CALL ABORT
ENDIF
IF(CL_INPUT_FILE == "") THEN
  WRITE(0, *) 'input file missing'
  WRITE(0, *) CL_USAGE
  CALL ABORT
ENDIF
IF(CL_OUTPUT_FILE == "") THEN
  WRITE(0, *) 'output file missing'
  WRITE(0, *) CL_USAGE
  CALL ABORT
ENDIF
IF(CL_INPUT_FILE == CL_OUTPUT_FILE) THEN
  WRITE(0, *) 'modify_grib: output file cannot be the same as the input file'
  WRITE(0, *) CL_USAGE
  CALL ABORT
ENDIF

!  Initialize namelist, and read namelist file
!
DO JP =1,2
  IUSEC3(JP)=-999
ENDDO
!
DO JP=1,JD1
  IUSEC1(JP)=-999
ENDDO
!
DO JP=1,JD2
  IUSEC2(JP)=-999
ENDDO
!
DO JP=1,JD4
  IUSEC4(JP)=-999
ENDDO
!
CNMEXP='9999'
!
OPEN(12,FILE=CL_NAMELIST_FILE,FORM='FORMATTED',STATUS='OLD',ERR=900)
!
READ(12,USHEAD)
!
DO JP=1,JD1
  IF(IUSEC1(JP).NE.-999) THEN
    WRITE(*,*) &
   "Element ",JP," of header 1 changed to ",IUSEC1(JP)
  ENDIF
ENDDO
!
IF (CNMEXP(1:4).NE.'9999') THEN
  WRITE(*,*) &
    "EXPVER (element 41 of header 1) changed to ",CNMEXP(1:4)
ENDIF
!
DO JP=1,JD2
  IF(IUSEC2(JP).NE.-999) THEN
    WRITE(*,*) &
      "Element ",JP," of header 2 changed to ",IUSEC2(JP)
  ENDIF
ENDDO
DO JP=1,2
  IF(IUSEC3(JP).NE.-999) THEN
    WRITE(*,*) &
    "Element ",JP," of header 3 changed to ",IUSEC3(JP)
  ENDIF
ENDDO
!
DO JP=1,JD4
  IF(IUSEC4(JP).NE.-999) THEN
    WRITE(*,*) &
      "Element ",JP," of header 4 changed to ",IUSEC4(JP)
   ENDIF
ENDDO
!
IF(IUSEC4(2) /= -999) LLDECODE=.TRUE.

IF(LLDECODE) THEN

  WRITE(*, *) 'Grib fields will be re-coded '
!
!      Open input GRIB file
!
  CALL PBOPEN(FILE1, CL_INPUT_FILE, "R", IRET)
  IF( IRET.NE.0 ) THEN
    WRITE(*, *) 'Return code from PBOPEN = ',IRET,' for file ',CL_INPUT_FILE
    CALL ABORT
  ENDIF
!
!      Open output GRIB file
!
  CALL PBOPEN(FILE2, CL_OUTPUT_FILE, "w", IRET)
  IF( IRET.NE.0 ) THEN
    WRITE (*, *) 'Return code from PBOPEN = ',IRET,' for file ',CL_OUTPUT_FILE
    CALL ABORT
  ENDIF

!    allocate space

  IF(IPPKLEN > 0) ALLOCATE(IGRIB(IPPKLEN))
  IF(IUNPKLEN > 0) ALLOCATE(ZUNP(IUNPKLEN))

!    decode and recode each field

  IFLD=0
  READ_LOOP:DO

!     Read packed field
!
    CALL PBSIZE(FILE1, IRET )
    IF( IRET <= 0 ) THEN
      IF(IRET < 0)  write(*,*)'PBSIZE RETURNED ',IRET
      EXIT READ_LOOP
    ELSE
      IF(IRET > IPPKLEN) THEN
!     write(*,*) ' re-allocate IGRIB from ',IPPKLEN,' to ',IRET
        IF(ALLOCATED(IGRIB)) DEALLOCATE(IGRIB)
        IPPKLEN=IRET
        ALLOCATE(IGRIB(IPPKLEN))
      ENDIF
    ENDIF
    CALL PBGRIB(FILE1, IGRIB, IBYTES*IPPKLEN , ILENOUT, IRET )
!
    IF(IRET == -3 ) THEN
!     IGRIB array is too small

      write(*,*)' IGRIB array too small ',IPPKLEN
      CALL ABORT
  
    ELSE IF(IRET < -1 ) THEN
      write(*,*) ' problems reading the grib file  iret= ',iret
      CALL ABORT
    ENDIF
!
    IFLD = IFLD + 1

!     find size of field to be decoded and allocate space for it

!     Unpack GRIB headers
!
    IRET = 0
    CALL GRIBEX (ISEC0,ISEC1,ISEC2,ZSEC2,ISEC3,ZSEC3,ISEC4, &
                 ZUNP,IUNPKLEN,IGRIB,IPPKLEN,IWORD,'J',IRET)
    IF( IRET.GT.0 ) THEN
        WRITE(0,*) 'GRIBEX problem decoding headers for ',IFLD
        WRITE(0,*) 'GRIBEX return code = ',IRET
        CALL ABORT
    ENDIF
!
    IFIELD_SIZE=ABS(ISEC4(1))
    IF(SIZE(ZUNP) < IFIELD_SIZE) THEN
      IUNPKLEN=IFIELD_SIZE
!     write(*,*)' ZUNP too small ',SIZE(ZUNP),IFIELD_SIZE
    ENDIF
    IF(ALLOCATED(ZUNP) .AND. SIZE(ZUNP) < IFIELD_SIZE) THEN
      DEALLOCATE(ZUNP)
!     write(*,*)' ZUNP de-allocated ',IUNPKLEN
    ENDIF
    IF(.NOT.ALLOCATED(ZUNP)) THEN
      ALLOCATE(ZUNP(IUNPKLEN))
!     write(*,*)' ZUNP allocated ',IUNPKLEN
    ENDIF
!
!     The missing data value must be specified in case the field
!     contains a bit mask

    ISEC3(2) = -999999999
    ZSEC3(2) = -999999999.0

!     Unpack GRIB message.
!
    IRET = 0
    CALL GRIBEX (ISEC0,ISEC1,ISEC2,ZSEC2,ISEC3,ZSEC3,ISEC4, &
                 ZUNP,IUNPKLEN,IGRIB,IPPKLEN,IWORD,'D',IRET)
    IF( IRET.GT.0 ) THEN
        WRITE(0,*) 'GRIBEX problem decoding product ',IFLD
        WRITE(0,*) 'GRIBEX return code = ',IRET
        CALL ABORT
    ENDIF
!
!     -----------------------------------------------------------------|
!
!     Repack the field and write to results file
!
!
!     Changes the header, according to user requests
!
    DO JP=1,JD1
      IF(IUSEC1(JP).NE.-999) THEN
        ISEC1(JP)=IUSEC1(JP)
      ENDIF
    ENDDO
!
    IF (CNMEXP(1:4).NE.'9999') THEN
        READ(CNMEXP,'(A4)') ISEC1(41)
    ENDIF
!
    DO JP=1,JD2
      IF(IUSEC2(JP).NE.-999) THEN
        ISEC2(JP)=IUSEC2(JP)
      ENDIF
    ENDDO
    DO JP=1,2
      IF(IUSEC3(JP).NE.-999) THEN
        ISEC3(JP)=IUSEC3(JP)
      ENDIF
    ENDDO
!
    DO JP=1,JD4
      IF(IUSEC4(JP).NE.-999) THEN
        ISEC4(JP)=IUSEC4(JP)
       ENDIF
    ENDDO

!     Add local GRIB definition, if it is missing for invariant fields
!
    IF (ISEC1(24) == 0) then
      WRITE(*,*) ' Add local GRIB definition for parameter',ISEC1(6)
      ISEC1(24)=1
     
      DO J=25,36
        IF(IUSEC1(J).NE.-999) THEN
          ISEC1(J)=IUSEC1(J)
        ELSE
          ISEC1(J)=0
        ENDIF
      ENDDO

      DO J=37,43
        IF (IUSEC1(j) == -999) then
          localdef:  SELECT CASE(J)
            CASE(37)            !  local definition type 1
              ISEC1(37)=1
            CASE(38)            !  class (default rd)
              ISEC1(38)=2
            CASE(39)            !  type (default an)
              ISEC1(39)=2
            CASE(40)            !  stream (default daily archive)
              ISEC1(40)=1025
            CASE(41)            !  expver
              IF (CNMEXP(1:4).NE.'9999') THEN
                READ(CNMEXP,'(A4)') ISEC1(41)
              ENDIF
            CASE(42)            !  mars labelling (default simple)
              ISEC1(42)=0
            CASE(43)            !  ensemble (default no)
              ISEC1(43)=0
          END SELECT localdef
        ELSE
          ISEC1(J)=IUSEC1(J)
        ENDIF
      ENDDO

      DO J=44,JD1
        IF(IUSEC1(J).NE.-999) THEN
          ISEC1(J)=IUSEC1(J)
        ELSE
          ISEC1(J)=0
        ENDIF
      ENDDO

    ENDIF
!
    IRET = 1
    IPUNP = ISEC4(1)
    CALL GRIBEX (ISEC0,ISEC1,ISEC2,ZSEC2,ISEC3,ZSEC3,ISEC4, &
      ZUNP,IPUNP,IGRIB,IPPKLEN,IWORD,'M',IRET)
    IF( IRET.GT.0 ) THEN
      WRITE(*,*) 'GRIBEX problem encoding product ',IFLD
      WRITE(*,*) 'GRIBEX return code = ',IRET
      CALL ABORT
    ENDIF
!
    ILENOUT = IWORD * IBYTES
    CALL PBWRITE(FILE2, IGRIB, ILENOUT, IRET)
    IF( IRET.LT.ILENOUT ) THEN
      WRITE(*,*) 'Problem writing product ',IFLD
      WRITE(*,*) 'Return code from PBWRITE = ',IRET
      CALL ABORT
    ENDIF

  ENDDO READ_LOOP

  CALL PBCLOSE(FILE2, IRET)
  IF( IRET.LT.0 ) THEN
    WRITE(*, *) 'Return code from PBCLOSE = ',IRET
    CALL ABORT
  ENDIF
!
  WRITE(*, *) 'Number of GRIB products changed = ',IFLD
  CALL PBCLOSE(FILE1, IRET)
  IF( IRET.LT.0 ) THEN
    WRITE (*, *) 'Return code from PBGRIB = ',IRET
    CALL PBCLOSE(FILE1, IRET)
    WRITE(*,*) 'Fault in PBGRIB reading product number ', IFLD
    CALL ABORT
  ENDIF

  STOP

ELSE

!   no decoding/encoding

  WRITE(*, *) 'Grib fields will NOT be re-coded '
  IRET = CHGRIB(CL_NAMELIST_FILE,CL_INPUT_FILE,CL_OUTPUT_FILE)
  WRITE(0,'(A,I4)') ' CHGRIB return code ',IRET
  IF(IRET /= 0) THEN
    WRITE(0,'(A,I4)') ' CHGRIB return code ',IRET
    CALL ABORT
  ENDIF
ENDIF

STOP

900 CONTINUE
WRITE(*, *) 'Namelist OPEN failed for file ',CL_NAMELIST_FILE
CALL ABORT
!
END

C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE U2L1CR (HSTRNG)
C
C---->
C**** U2L1CR - Convert Upper case letters to Lower case.
C
C     Purpose.
C     --------
C
C           Convert character string to all lower case.
C
C**   Interface.
C     ----------
C
C           CALL U2L1CR (HSTRNG)
C
C           INTEGER    K.
C           REAL       P.
C           LOGICAL    O.
C           CHARACTER  H.
C
C               Input parameters.
C               -----------------
C
C               HSTRNG     - String in upper and/or lower case.
C
C               Output parameters.
C               ------------------
C
C               HSTRNG     - Character string in all lower case.
C
C     Method.
C     -------
C
C           Numeric values of each byte examined and altered if in the
C           range of lower case letters.
C
C     Externals.
C     ----------
C
C           ICHAR
C           CHAR
C
C     Reference.
C     ----------
C
C           Cray Programmer's Library Reference Manual.
C
C     Comments.
C     ---------
C
C           Routine contains sections 0 to 1 and section 9.
C
C     Author.
C     -------
C
C           J. Hennessy      ECMWF      09:08:90.
C
C     Modifications
C     --------------
C
C           None.
C
C     ----------------------------------------------------------------
C----<
C
C
C
C
C
C
C
C
C
C
C*    Section 0 . Definition of variables.
C     ----------------------------------------------------------------
C
      IMPLICIT LOGICAL     ( L, O, G )
      IMPLICIT CHARACTER*8 ( C, H, Y )
      IMPLICIT INTEGER     ( I, J, K, M, N )
C
      CHARACTER*(*) HSTRNG
C
C     ASCII Representation of upper case characters A and Z.
C
      DATA IA  /65/
      DATA IZ  /90/
C
C     ASCII Representation of NULL and BLANK characters.
C
      DATA INULL /0/
C
C     ----------------------------------------------------------------
C
C
C
C
C
C
C
C
C
C*    Section 1 . Change any necessary letters.
C     ----------------------------------------------------------------
C
 1000 CONTINUE
C
C
      ILEN = LEN (HSTRNG)
C
      DO 1100 J=1,ILEN
         ICH = ICHAR (HSTRNG(J:J))
         IF ( (ICH.GE.IA).AND.(ICH.LE.IZ) ) HSTRNG (J:J) = CHAR (ICH+32)
         IF (ICH.EQ.INULL) HSTRNG (J:J) = CHAR (32)
 1100 CONTINUE
C
C     ----------------------------------------------------------------
C
C
C
c
C
C
C
C*    Section 9 . Return to calling routine.
C     ----------------------------------------------------------------
C
 9000 CONTINUE
C
      RETURN
      END

C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE HWTSLL
     X  (KLEN,KSCHEME,KLA,PDLAT,PLATINC,PDLO0,PDLO1,PDLO2,PDLO3,NEIGH,
     X   PWTS)
C
C---->
C**** HWTSLL
C
C     Purpose
C     -------
C
C     This routine accepts a vector of points and calculates the
C     interpolation weightings for each point suitable for the
C     horizontal interpolation.
C
C
C     Interface
C     ---------
C
C     CALL HWTSLL
C    X  (KLEN,KSCHEME,KLA,PDLAT,PLATINC,PDLO0,PDLO1,PDLO2,PDLO3,NEIGH,
C    X   PWTS)
C
C
C     Input parameters
C     ----------------
C
C     KLEN    - Number of points along the vector.
C     KSCHEME - Flag showing interpolation scheme to use for point
C               0 = 12-point
C               1 = 4-point bilinear
C               2 = nearest neighbour
C     KLA     - Latitude number in original field of latitude north of
C               point in the vector.
C     PDLAT   - Meridian linear weight.
C     PLATINC - Increment between latitudes.
C     PDLO0   - Zonal linear weight for the latitude of point 5.
C     PDLO1   - Zonal linear weight for the latitude of point 1.
C     PDLO2   - Zonal linear weight for the latitude of point 3.
C     PDLO3   - Zonal linear weight for the latitude of point 11.
C     NEIGH   - List of indices in the original field of neighbouring
C               point values.
C
C
C     Output parameters
C     -----------------
C
C     PWTS   - Weights for interpolation.
C
C     Common block usage
C     ------------------
C
C     None.
C
C
C     Method
C     ------
C
C     Numbering of the points (I is the interpolation point):
C
C                   13       5       6      14
C
C                    7       1       2       8
C                               (I)
C                    9       3       4      10
C
C                   15      11      12      16
C
C
C     Externals
C     ---------
C
C     None.
C
C
C     Reference
C     ---------
C
C     ECMWF Meteorological Bulletin M1.6/7
C     IFS Documentation
C     Part VI: Technical and Computational Procedures (CY21R4)
C     March 2000
C     Section 2.3
C
C
C     Comments
C     --------
C
C     None.
C
C
C     Author
C     ------
C
C     J.D.Chambers      ECMWF      January 2001
C
C
C     Modifications
C     -------------
C
C     None.
C
C----<
C     -----------------------------------------------------------------|
C*    Definition of variables.
C     -----------------------------------------------------------------|
C
      IMPLICIT NONE
C
C     Parameters
C
      INTEGER JP12PT, JP4PT, JPNEARN
      PARAMETER (JP12PT  = 0)
      PARAMETER (JP4PT   = 1)
      PARAMETER (JPNEARN = 2)
C
C     Function arguments
C
      INTEGER KLEN, KSCHEME(KLEN), KLA(KLEN)
      REAL PDLAT(KLEN), PLATINC
      REAL PDLO0(KLEN), PDLO1(KLEN), PDLO2(KLEN), PDLO3(KLEN)
      INTEGER NEIGH(12,*)
      REAL PWTS(12,*)
C
C     Local variables
C
      INTEGER NEXT, LOOP
      INTEGER ILA0G, ILA1G, ILA2G, ILA3G
      REAL ZDLAT, ZDY, ZDY10, ZDY21, ZDY32
      REAL ZDLO1, ZDLO2, ZWXN0, ZWXN1, ZWXN2, ZWXN3
      REAL ZWY0, ZWY1, ZWY2, ZWY3
      REAL ZWXNN, ZCXNN, ZWXSS, ZCXSS
      REAL ZWXS0, ZWXS1, ZWXS2, ZWXS3
C
C     Inline functions
C
      REAL ALPHA, F2, F3, F4
C
      F2(ALPHA) = ((ALPHA+1.0) * (ALPHA-2.0) * (ALPHA-1.0))/2.0
C
      F3(ALPHA) = - ((ALPHA+1.0) * (ALPHA-2.0) * ALPHA)/2.0
C
      F4(ALPHA) = (ALPHA * (ALPHA-1.0) * (ALPHA+1.0))/6.0
C
C     -----------------------------------------------------------------|
C     Process each point in the vector.
C     -----------------------------------------------------------------|
C
      DO NEXT = 1,KLEN
C
C       Clear the weights for the current point
C
        DO LOOP = 1, 12
          PWTS(LOOP,NEXT) = 0.0
        ENDDO
C
C       Use appropriate interpolation scheme for the current point
C
C     -----------------------------------------------------------------|
C       Nearest point selection
C     -----------------------------------------------------------------|
C
        IF( KSCHEME(NEXT).EQ.JPNEARN ) THEN
C
          DO LOOP = 1, 4
            IF( NEIGH(LOOP,NEXT).NE.0 ) PWTS(LOOP,NEXT) = 1.0
          ENDDO
C
          GOTO 900
C
C     -----------------------------------------------------------------|
C       4-point interpolation
C     -----------------------------------------------------------------|
C
        ELSE IF( KSCHEME(NEXT).EQ.JP4PT ) THEN
C
          PWTS(1,NEXT) = (1.0 - PDLO2(NEXT)) * (1.0 - PDLAT(NEXT))
          PWTS(2,NEXT) = PDLO2(NEXT) * (1.0 - PDLAT(NEXT))
          PWTS(3,NEXT) = (1.0 - PDLO1(NEXT)) * PDLAT(NEXT)
          PWTS(4,NEXT) = PDLO1(NEXT) * PDLAT(NEXT)
C
          GOTO 900
C
C     -----------------------------------------------------------------|
C       12-point interpolation
C     -----------------------------------------------------------------|
C
        ELSE
C
C         Setup latitude numbers for the 4 rows.
C
          ILA1G = KLA(NEXT)
          ILA0G = ILA1G - 1
          ILA2G = ILA1G + 1
          ILA3G = ILA1G + 2
C
C         Setup the weights between rows.
C
          ZDLAT = PDLAT(NEXT)
          ZDY   = ZDLAT * PLATINC
          ZDY10 = PLATINC
          ZDY21 = PLATINC
          ZDY32 = PLATINC
C
C     -----------------------------------------------------------------|
C         Polynomial in x-direction.
C     -----------------------------------------------------------------|
C
C         Northern parallel
C
          ZDLO1 = PDLO1(NEXT)
          ZWXN1 = F2(ZDLO1)
          ZWXN2 = F3(ZDLO1)
          ZWXN3 = F4(ZDLO1)
          ZWXN0 = 1.0 - ZWXN1 - ZWXN2 - ZWXN3
C
C         Southern parallel
C
          ZDLO2 = PDLO2(NEXT)
          ZWXS1 = F2(ZDLO2)
          ZWXS2 = F3(ZDLO2)
          ZWXS3 = F4(ZDLO2)
          ZWXS0 = 1.0 - ZWXS1 - ZWXS2 - ZWXS3
C
C     -----------------------------------------------------------------|
C         Polynomial in y-direction.
C     -----------------------------------------------------------------|
C
          ZWY3 = ((ZDY+ZDY10) * (ZDY) * (ZDY-ZDY21)) /
     X           ((ZDY10+ZDY21+ZDY32) * (ZDY21+ZDY32) * (ZDY32))
          ZWY2 = ((ZDY+ZDY10) * (ZDY) * (ZDY-ZDY21-ZDY32)) /
     X           ((ZDY10+ZDY21) * (ZDY21) * (-ZDY32))
          ZWY1 = ((ZDY+ZDY10) * (ZDY-ZDY21) * (ZDY-ZDY21-ZDY32)) /
     X           ((ZDY10) * (-ZDY21) * (-ZDY21-ZDY32))
          ZWY0 = 1.0 - ZWY1 - ZWY2 - ZWY3
C
C     -----------------------------------------------------------------|
C         Linear parts for extreme rows.
C     -----------------------------------------------------------------|
C
C         Northernmost
C
          ZWXNN = PDLO0(NEXT)
          ZCXNN = 1.0 - PDLO0(NEXT)
C
C         Southernmost
C
          ZWXSS = PDLO3(NEXT)
          ZCXSS = 1.0 - PDLO3(NEXT)
C
C     -----------------------------------------------------------------|
C         Weights for 12 points interpolation.
C     -----------------------------------------------------------------|
C
          PWTS( 1,NEXT) = ZWXN1 * ZWY1
          PWTS( 2,NEXT) = ZWXN2 * ZWY1
          PWTS( 3,NEXT) = ZWXS1 * ZWY2
          PWTS( 4,NEXT) = ZWXS2 * ZWY2
          PWTS( 5,NEXT) = ZCXNN * ZWY0
          PWTS( 6,NEXT) = ZWXNN * ZWY0
          PWTS( 7,NEXT) = ZWXN0 * ZWY1
          PWTS( 8,NEXT) = ZWXN3 * ZWY1
          PWTS( 9,NEXT) = ZWXS0 * ZWY2
          PWTS(10,NEXT) = ZWXS3 * ZWY2
          PWTS(11,NEXT) = ZCXSS * ZWY3
          PWTS(12,NEXT) = ZWXSS * ZWY3
C
          GOTO 900
C
        ENDIF
C
C     -----------------------------------------------------------------|
C       End of processing for current point in vector.
C     -----------------------------------------------------------------|
C
  900   CONTINUE
C
      ENDDO
C
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities
C granted to it by virtue of its status as an intergovernmental organisation
C nor does it submit to any jurisdiction.
C

      INTEGER FUNCTION KRG2RGZ(OLDFLD, NEWFLD, NUMGGO, NUMGGN)
C
C---->
C**** KRG2RGZ
C
C     Purpose
C     -------
C
C     Interpolate a field based on one reduced gaussian grid to a
C     field based on a different reduced gaussian grid.
C
C
C     Interface
C     ---------
C
C     IRET = KRG2RGZ(OLDFLD, NEWFLD, NUMGGO, NUMGGN)
C
C     Input
C     -----
C
C     OLDFLD - Old field as array of values
C     NUMGGO - Number of the old gaussian field
C     NUMGGN - Number of the new gaussian field
C
C
C     Output
C     ------
C
C     NEWFLD - New field as array of values
C
C     Function returns:
C       - the size in bytes of the new GRIB product if all is well
C       - -1, otherwise.
C
C
C     Method
C     ------
C
C     Create new field and leave it unpacked.
C
C
C     Externals
C     ---------
C
C     KINTRG  - Interpolate reduced gaussian field to reduced gaussian
C     INTLOG  - Log messages
C
C
C     Author
C     ------
C
C     J.D.Chambers     ECMWF     February 2002
C
C----<
C
      IMPLICIT NONE
C
C     Function arguments
C
      INTEGER NUMGGO, NUMGGN
      REAL OLDFLD(*), NEWFLD(*)
C
#include "parim.h"
#include "nifld.common"
#include "nofld.common"
#include "grfixed.h"
C
C     Parameters
C
      INTEGER JPINTB
      INTEGER JSEC2
      PARAMETER (JSEC2 = 5000)
#ifdef INTEGER_8
      PARAMETER (JPINTB = 8)
#else
      PARAMETER (JPINTB = 4)
#endif
C
C     Local variables
C
      INTEGER OLDGEO(JSEC2), NEWGEO(JSEC2)
      INTEGER LOOP
      CHARACTER*1 HTYPE
      REAL PLAT(JPMAXNG)
C
      INTEGER IRET
C
C     Externals
C
      INTEGER KINTRG
      EXTERNAL KINTRG
C
C     -----------------------------------------------------------------|
C*    Section 1.   Initialise
C     -----------------------------------------------------------------|
C
  100 CONTINUE
C
      KRG2RGZ = 0
C
      IF( (NUMGGN*2).GT.JPMAXNG ) THEN
        CALL INTLOG(JP_ERROR,'KRG2RGZ: Gaussian N too big = ',NUMGGN)
        CALL INTLOG(JP_ERROR,'KRG2RGZ: Maximum handled = ',(JPMAXNG/2))
        KRG2RGZ = -1
        GOTO 900
      ENDIF
C
C     -----------------------------------------------------------------|
C*    Section 2.   Create new field.
C     -----------------------------------------------------------------|
C
  200 CONTINUE
C
      DO LOOP = 1, JPMAXNG
cs        OLDGEO(LOOP) = 0
        OLDGEO(LOOP+22) = MILLEN(LOOP)
      ENDDO
cs      HTYPE = 'R'
cs      CALL JGETGG(NUMGGO,HTYPE,PLAT,OLDGEO(23),IRET)
cs      IF( IRET.NE.0 ) THEN
cs        WRITE(*,*) 'KRG2RGZ: Problem calling JGETGG, status = ',IRET
cs        KRG2RGZ = -1
cs      RETURN
cs      ENDIF

C
      OLDGEO(3)  = NUMGGO * 2
      OLDGEO(4)  = NINT(PLAT(1)*1000.0)
      OLDGEO(5)  = 0
      OLDGEO(7)  = NINT(PLAT(NUMGGO*2)*1000.0)
c     EMOS-199: adjusted for reduced_gg/octahedral
c     OLDGEO(8)  = NINT((360.0-(360.0/REAL(NUMGGO*4)))*1000.0)
      OLDGEO(8)  = NINT((360.0-(360.0/REAL(OLDGEO(23+NUMGGO))))*1000.0)
      OLDGEO(10) = NUMGGO
C
      DO LOOP = 1, JPMAXNG
        NEWGEO(LOOP) = 0
      ENDDO
      HTYPE = 'R'
      IF( LOCTAHEDRAL ) HTYPE = 'O'
      CALL JGETGG(NUMGGN,HTYPE,PLAT,NEWGEO(23),IRET)
      IF( IRET.NE.0 ) THEN
        WRITE(*,*) 'KRG2RGZ: Problem calling JGETGG, status = ',IRET
        KRG2RGZ = -1
        RETURN
      ENDIF
      NEWGEO(3)  = NUMGGN * 2
      NEWGEO(4)  = NINT(PLAT(1)*1000.0)
      NEWGEO(5)  = 0
      NEWGEO(7)  = NINT(PLAT(NUMGGN*2)*1000.0)
c     EMOS-199: adjusted for reduced_gg/octahedral
c     NEWGEO(8)  = NINT((360.0-(360.0/REAL(NUMGGN*4)))*1000.0)
      NEWGEO(8)  = NINT((360.0-(360.0/REAL(NEWGEO(23+NUMGGN))))*1000.0)
      NEWGEO(10) = NUMGGN
C
      IRET = KINTRG(OLDGEO, NEWGEO, OLDFLD, NEWFLD)
C
      IF( IRET.LE.0 ) THEN
        WRITE(*,*) 'KRG2RGZ: New field creation failed'
        KRG2RGZ = -1
        RETURN
      ENDIF
C
cs      KRG2RGZ = IRET * JPINTB
cs this is the outlen
      KRG2RGZ = IRET

      IF( LDOUBLE ) THEN
c filing of millen for double interpolation
         DO LOOP = 1, JPMAXNG
           MILLEN(LOOP) = NEWGEO(LOOP+22)
         ENDDO
         CALL INTLOG(JP_DEBUG,
     X   'KRG2RGZ: Set NIAREA - double interpolation',JPQUIET)
         NIAREA(1)  = 0
         NIAREA(2)  = 0
         NIAREA(3)  = 0
         NIAREA(4)  = 0
         NIGAUSS    = NUMGGN
cs        DO LOOP = 1, NINS
cs          RIGAUSS(LOOP) = 0
cs          MILLEN(LOOP) = 0
cs        ENDDO
         NINS       = NUMGGN*2
      ELSE
c sinisa for merging with grib_api
         NONS      = 2 * NUMGGN
         NOWE      = 0
         NOAAPI(1) = NEWGEO(4)*JPMICRO
         NOAAPI(2) = NEWGEO(5)*JPMICRO
         NOAAPI(3) = NEWGEO(7)*JPMICRO
         NOAAPI(4) = NEWGEO(8)*JPMICRO
         NOAREA(1) = NEWGEO(4)*JPMICRO
         NOAREA(2) = NEWGEO(5)*JPMICRO
         NOAREA(3) = NEWGEO(7)*JPMICRO
         NOAREA(4) = NEWGEO(8)*JPMICRO
      ENDIF
C
C     -----------------------------------------------------------------|
C*    Section 9.   Return
C     -----------------------------------------------------------------|
C
  900 CONTINUE
C
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE MBUFR_MARS_FILTER(KSIZE,KREQUEST,KBUFL,
     1                             KBUFF,FOUND,KERR)
C
C**** *MBUFR_MARS_FILTER*
C
C
C     PURPOSE.
C     --------
C         FILTER BUFR MESSAGES FROM kbuff array
C         ACCORDING TO REQUEST and returning requested bufr message 
C         in kbuff array if repacking is not needed or kbufr otherwise.
C
C
C**   INTERFACE.
C     ----------
C
C          NONE.
C
C     METHOD.
C     -------
C
C
C     EXTERNALS.
C     ----------
C
C         CALL MBUSEL
C         CALL MBUFREX
C         CALL MBUFREN
C         CALL MBUPRS0
C         CALL MBUPRS1
C         CALL MBUPRS2
C         CALL MBUPRS3
C         CALL MBUPRT
C         CALL MBUUKEY
C
C     REFERENCE.
C     ----------
C
C          NONE.
C
C     AUTHOR.
C     -------
C
C          M. DRAGOSAVAC    *ECMWF*       12/09/2002
C
C
C     MODIFICATIONS.
C     --------------
C
C          NONE.
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
      PARAMETER(JSUP =   9,JSEC0=   3,JSEC1= 40,JSEC2=4096,JSEC3=   4,
     1          JSEC4=2,JELEM=160000,JSUBS=400,JCVAL=150 ,JBUFL=512000,
#ifdef JBPW_64
     2          JBPW =  64,JTAB =3000,JCTAB=3000,JCTST=3000,JCTEXT=6000,
#else
     2          JBPW =  32,JTAB =3000,JCTAB=3000,JCTST=3000,JCTEXT=6000,
#endif
     3          JWORK=4096000,JKEY=46, JTMAX=10,JTCLAS=64,JTEL=255)
C
      PARAMETER (KELEM=200)
      PARAMETER (KVALS=200000)
C 
      DIMENSION KBUFF(JBUFL)
      DIMENSION KSUP(JSUP)  ,KSEC0(JSEC0),KSEC1(JSEC1)
      DIMENSION KSEC2(JSEC2),KSEC3(JSEC3),KSEC4(JSEC4)
      DIMENSION KEY(JKEY),KEY1(JKEY),KEY2(JKEY)
      REAL*8 VALUES(KVALS)
      REAL*8 RQV(KELEM)
      REAL*8 RVIND
      REAL*8 EPS
      DIMENSION KTDLST(KELEM),KTDEXP(KELEM)
      DIMENSION KDATA(200)
      DIMENSION KREQ(2),KRQ(KELEM)
C
      CHARACTER*64 CNAMES(KELEM)
      CHARACTER*24 CUNITS(KELEM)
      CHARACTER*80 CVALS(KVALS)
      CHARACTER*9  CIDENTS
      LOGICAL      FOUND
      DIMENSION KREQUEST(KSIZE)
C                                                                       
C
C     ------------------------------------------------------------------
C*          1. GET FILE NAMES.
C              ---------------
 100  CONTINUE
C
      RVIND=1.7D38
      NBYTES=JBPW/8
      EPS=10.D-7
C
      
      KBUFL1=KBUFL/NBYTES+1
C
C
C     -----------------------------------------------------------------
C*          2.1 EXPAND BUFR MESSAGE SECTION 0,1,2
C               ---------------------------------
 210  CONTINUE
C
      IERR=0
      CALL BUS0123( KBUFL,KBUFF,KSUP,KSEC0,KSEC1,KSEC2,KSEC3,IERR)
      IF(KERR.NE.0) RETURN
C
      IF(KSEC3(3).EQ.1.OR.KSEC3(3).GT.1.AND.
     1   KSEC3(4).EQ.192.OR.KSEC3(4).EQ.64) THEN
C       Expand first 9 elements
         CALL BUSTOP(9)
      END IF

C            2.1.1  UNPACK KEY
C
C     CALL BUUKEY(KSEC1,KSEC2,KEY,KSUP,KERR)
C
C              PRINT KEY
C
C      CALL BUPRS2(KSUP ,KEY)
C
C----------------------------------------------------------------
C
C            2.3 MULTI-SUBSET MESSAGE
C
 230  CONTINUE
C
      IF(KSUP(6).GT.1)  THEN
         KEL=KVALS/KSUP(6)
         IF(KEL.GT.KELEM) KEL=KELEM
      ELSE
         KEL=KELEM
      END IF
C
      KREQ(1)=1
      KREQ(2)=2
      KRQ (1)=002048
      KRQ (2)=002019
      RQV (1)=RVIND
      RQV (2)=RVIND
      KRQL=2

      KERR=0
      CALL BUSRQ(KREQ,KRQL,KRQ,RQV,KERR)
      IF(KERR.NE.0) RETURN
C
      CALL BUFREX(KBUFL1,KBUFF,KSUP,KSEC0 ,KSEC1,KSEC2 ,KSEC3 ,KSEC4,
     1            KEL,CNAMES,CUNITS,KVALS,VALUES,CVALS,KERR)
C
      IF(KERR.NE.0) RETURN
C
C*          2.4 PRINT EXPANDED BUFR MESSAGE.
C               ----------------------------
 240  CONTINUE
C
C      CALL BUPRS0(KSEC0)
C      CALL BUPRS1(KSEC1)
C      CALL BUUKEY(KSEC1,KSEC2,KEY,KSUP,KERR)
C      CALL BUPRS2(KSUP ,KEY)
C
      CALL BUSEL(KTDLEN,KTDLST,KTDEXL,KTDEXP,KERR)
      IF(KERR.NE.0) RETURN
C
C      CALL BUPRS3(KSEC3,KTDLEN,KTDLST,KTDEXL,KTDEXP,KEL,CNAMES)
C      IST=1
C      IEND=KSUP(6)
C      CALL BUPRT(ICODE,IST,IEND,KEL,CNAMES,CUNITS,CVALS,
C     1           KVALS,VALUES,KSUP,KSEC1,IERR)
C
C
C
      i_002048=0
      i_002019=0
      DO I=1,KTDEXL
        IF(KTDEXP(i).EQ.002048) i_002048=i
        IF(KTDEXP(i).EQ.002019) i_002019=i
      END DO
C
      if(i_002048.ne.0) then
         do i=1,ksize
         if(krequest(i).eq.605) then
            krequest(i)=0
         elseif(krequest(i).eq.623) then
            krequest(i)=1
         elseif(krequest(i).eq.627) then
            krequest(i)=2
         elseif(krequest(i).eq.570) then
            krequest(i)=3
         elseif(krequest(i).eq.574) then
            krequest(i)=4
         elseif(krequest(i).eq.590) then
            krequest(i)=5
         elseif(krequest(i).eq.905) then
            krequest(i)=6
         elseif(krequest(i).eq.312) then
            krequest(i)=7
         elseif(krequest(i).eq.313) then
            krequest(i)=8
         elseif(krequest(i).eq.203) then
            krequest(i)=11
         end if
         end do
      end if
C
      FOUND=.FALSE.
C     
      if(i_002048.ne.0) then
         do i=1,ksize
           do j=1,ksec3(3)
             ij=i_002048+(j-1)*kel
             if(abs(values(ij)-rvind)/rvind.gt.eps) then
             if(nint(values(ij)).eq.krequest(i)) FOUND =.TRUE.
             end if
           end do 
         end do
      elseif(i_002019.ne.0) then
         do i=1,ksize
           do j=1,ksec3(3)
             ij=i_002019+(j-1)*kel
             if(abs(values(ij)-rvind)/rvind.gt.eps) then
             if(nint(values(ij)).eq.krequest(i)) FOUND =.TRUE.
             end if
           end do
         end do
      else
         FOUND =.FALSE.
      end if

C     -----------------------------------------------------------------
      KERR=0
C
      RETURN
C
C      
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

       INTEGER FUNCTION C2ORDR ( KDATA, KLENP, KSEC1, KSEC2, KSEC3, 
     X                          KSEC4, KGRIB, KLENG, KNSPT, KBITS,
     X                          HOPER, KBMAP, KVALS, PREF,  PMAX,
     X                          KLEN,  KDEBUG )
C
C---->
C**** C2ORDR
C
C     Purpose.
C     --------
C
C     Encode GRIB section 4 for complex packing of grid-point
C     values ("second-order packing").
C
C
C**   Interface.
C     ----------
C
C     KRET = C2ORDR ( KDATA, KLENP, KSEC1, KSEC2, KSEC3, KSEC4,
C    X                KGRIB, KLENG, KNSPT, KBITS, HOPER, KBMAP,
C    X                KVALS, PREF,  PMAX , KLEN,  KDEBUG )
C
C
C     Input Parameters.
C     -----------------
C
C     KDATA      - Array of normalized values.
C     KLENP      - Length of array KDATA.
C     KSEC1      - Array of GRIB section 1 integer descriptors.
C     KSEC2      - Array of GRIB section 2 integer descriptors.
C     KSEC3      - Array of GRIB section 3 integer descriptors.
C     KSEC4      - Array of GRIB section 4 integer descriptors.
C     KLENG      - Length of GRIB product array.
C     KNSPT      - Bit pointer for next value in GRIB product.
C     KBITS      - Number of bits per computer word.
C     HOPER      - Requested function:
C                  'C' for coding, following input descriptors,
C                  'K' for "aggressive pacKing" (choose a solution
C                  that leads to minimum size).
C     KBMAP      - Bit pointer for start of explicit primary bit-map
C                  (if any).
C     KVALS      - Number of bits in primary bit-map.
C     PREF       - Reference of field.
C     PMAX       - Maximum value of field.
C     KLEN       - Exact number of points to handle.
C     KDEBUG     - >0 for some debug printout.
C
C
C     Output Parameters.
C     -----------------
C
C     KDATA      - Used (indirectly) as work array.
C     KSEC4      - Array of GRIB section 4 integer descriptors
C                  (updated).
C     KGRIB      - Array containing GRIB product.
C     KNSPT      - Bit pointer for next value in GRIB product
C                  (updated).
C
C
C     Method.
C     -------
C
C     Follows WMO Manual of Codes, and also CSECT4 structure.
C
C
C     If ordinary packing is requested (HOPER='C'), then the relevant
C     method described through KSEC4 descriptors is applied:
C
C     1) Row by row: KSEC4(9)=0, KSEC4(10)=16 and KSEC4(12)=0;
C
C     2) Constant width: KSEC4(9)=32, KSEC4(10)=0, KSEC4(12)=0,
C        width in KSEC4(11) -see "Comments" paragraph below, at the end.
C
C     3) General WMO 2nd-order: KSEC4(9)=32, KSEC4(10)=16, KSEC4(12)=0.
C
C     4) General extended  "  : KSEC4(9)=32, KSEC4(10)=16, KSEC4(12)=8.
C
C     For constant width and general methods, boustrophedonic ordering
C     is requested by KSEC4(13)=4, provided extensions have been
C     alllowed (disabled by default), and is explicitly inhibited
C     by KSEC4(13)=0.
C     Boustrophedonic ordering has no interest for row by row packing.
C     If explicitly requested a warning message is issued and option
C     set to off.
C
C     For the general extended method, a spatial differencing may be
C     requested through KSEC4(14) and/or KSEC4(15) different from zero:
C
C     -explicitly: KSEC4(14)=0 or 2, KSEC4(15)=0 or 1, order being then
C                  IORDER=KSEC4(14)+KSEC4(15) ;
C
C     -implicitly: KSEC4(14)=-1 and/or KSEC4(15)=-1; in such a case
C                  a diagnostic is performed to estimate which order
C                  should lead to minimaum size.
C
C
C     If aggressive packing (HOPER='K') is selected:
C
C     1) in a first scan, all allowed sub-functions (see Comments
C        below) are called to compute the length of section 4 they
C        would give, but no coding occurs;
C
C     2) in a second phase the most efficient method is applied.
C
C        If no "complex" method is efficient -or applicable-, then a
C        simple packing is performed.
C
C        If the field is constant, a simple packing  with 0 as number
C        of bits (and no data) is applied, without having to perform
C        the steps mentioned above.
C
C     Externals.
C     ----------
C
C     INXBIT    - Insert bits into GRIB product.
C     CONFP3    - Convert to IBM floating point format.
C
C     C2ROWS    - Row by row packing.
C     C2CWID    - Constant width packing.
C     C2GENE    - General WMO second-order packing.
C                + general extended second-order packing.
C     REVERO    - Reverse order of even rank rows.
C     C2DOSD    - Diagnose/compute order of spatial differencing.
C     D2ROSD    - Rebuild original values from spatial differencing.
C
C
C     Reference.
C     ----------
C
C     None.
C
C
C     Comments.
C     --------
C
C     On entry, KNSPT points to the first bit of section 4 
C               in the GRIB product.
C     On exit,  KNSPT points to the first unused bit of section 4,
C               (or to the first bit of section 5, if unused bit count
C                is zero) in the GRIB product.
C
C     KDATA is overwritten. This is coherent with GRIBEX coding.
C
C     When aggressive packing is selected (HOPER='K') :
C
C     1) If exhaustive second-order packing is on, then all possible
C        methods are attempted; note this may lead to expensive CPU
C        cost. Constant width packing will use iterative search of
C        optimal width, starting from (KSEC4(2)-1), regardless of
C        KSEC4(11) value.
C
C        Notes:
C
C        -if extensions switch is not set (disabled by default), then
C         none of the extensions on methods will be promoted;
C
C        -if extensions switch is on, boustrophedonic ordering is then
C         used in conjunction with relevant methods (all 2nd-order but
C         row by row), provided there is a section 2 and no implicit
C         primary bit-map;
C
C        -if both extensions and non-local switches are on (both are
C         disabled by default), estimation of best order of spatial
C         differencing is activated for general extended packing.
C
C     2) If exhaustive second-order packing is off (default), then
C        only explicitly requested methods are tried. More precisely:
C
C        -row by row packing (cheapest method, but least effective)
C         is always attempted, except without a section 2
C         or with an implicit primary bit-map;
C
C        -constant width packing is attempted if KSEC4(10)=0 in input;
C         (with iterative search of optimal width only if KSEC4(11) is
C          negative, using -KSEC4(11) as initial and maximum width)
C
C        -general 2nd-order packing is attempted if KSEC4(9)=32 in
C         input, or if there is no section 2 or in case of an implicit
C         primary bit-map.
C
C        -general extended second-order packing is attempted if
C         extensions switch has been set and KSEC4(12)=8 in input.
C
C        Boustrophedonic ordering is attempted if extensions switch
C        has been set and if KSEC4(13)=4 in input,
C        systematically in conjunction with relevant selected
C        method(s), and provided there is a section 2.
C
C        Spatial differencing is activated for general extended method
C        if this last method is selected (see above), if non-local
C        switch has been set, and if KSEC4(14) and/or KSEC4(15) is not
C        null. Tuning of order is as described earlier for HOPER='C'.
C
C     Iterative method used in C2CWID to find an optimal width (that
C     minimise length of section 4) may also be used with HOPER='C',
C     using a negative value for KSEC4(11) in input; -KSEC4(11) is then
C     used as initial and maximum width.
C
C     Author.
C     -------
C
C     J. Clochard, Meteo France, for ECMWF - January 1998.
C
C
C     Modifications.
C     _____________
C
C     J. Clochard, April 1998.
C     Update comments.
C     For constant width packing, interpret KSEC4(11) negative as
C     request for optimal width search, starting from -KSEC4(11) .
C     When both aggressive mode (HOPER='K') is requested and exhaustive
C     use of 2nd-order packing methods is set, initial width is set to
C     (KSEC4(2)-1) .
C     Fix double computing of work arrays for General WMO 2nd-order,
C     when General extended method is not requested.
C     Introduce spatial differencing.
C     Simplify management of boustrophedonic ordering.
C
C     J. Clochard, August 1998.
C     Raise JPMXGR from 131071 to 220000 to enable proper processing
C     of satellite images for general method.
C     (i.e. METEOSAT full-disk products, 2500x2500)
C
C     J. Clochard, September 1998.
C     Suppress KSEC1/KSEC2/KSEC3 arguments in C2CWID/C2GENE calls.
C     Suppress KSEC1/KSEC3 arguments in C2ROWS call.
C     Fix definition of LGENXT to be able to select both general methods
C     in non-exhaustive use of 2nd-order methods.
C     Fix to enforce re-computation of work arrays when general extended
C     method is not worth and spatial differencing is used.
C     Inhibit boustrophedonic ordering also for aggressive packing,
C     when there is no section 2 and/or an implicit bit-map.
C     If dynamical estimation of spatial differencing leads to greater
C     message length than general WMO 2nd-order, retry general exten-
C     ded method without spatial differencing.
C     Adjustment of granularity parameters for general methods and small
C     grids.
C
C     J. Clochard, June 1999.
C     Simple packing method always available as backup, even in explicit
C     encoding cases (HOPER='C') . 
C     Use precomputed array to determine widths . Arguments IPCWID and
C     JPXWID added in C2GENE/C2DOSD/C2ROWS calls .
C
C----<
C     -----------------------------------------------------------------
C*    Section 0. Definition of variables.
C     -----------------------------------------------------------------
C
      IMPLICIT NONE
C
#include "common/grprs.h"
C
C     Parameters
C
      INTEGER JP16SET, JPMXGR, JPXPWR, JPMXGF, JPMETH, JPVSE4, JPWORK
      INTEGER JPORDR, JPXWID, JPCWID
C
C     Number of possible packing methods.
C
      PARAMETER ( JPMETH=4, JPORDR=3 )
      PARAMETER ( JP16SET= 2**16-1 )
C                            `---> 65535    =   FFFF(hex)
#ifdef JBPW_64
      PARAMETER ( JPMXGR= 220000, JPXPWR=47, JPVSE4=20 )
#else
      PARAMETER ( JPMXGR= 220000, JPXPWR=31, JPVSE4=20 )
#endif
      PARAMETER ( JPXWID=(JPXPWR+1)/2 )
      PARAMETER ( JPCWID=2**JPXWID )
C
C     Size of work array. Must be at least JPMXGF*4 .
C
      PARAMETER ( JPWORK=JPMXGR*4 )
#ifndef wmogrp2o
      PARAMETER ( JPMXGF= JPMXGR )
#else
C
C     Limit maximum number of groups/first-order values to WMO
C     standard upper limit (descriptor is 16-bit wide).
C
      PARAMETER ( JPMXGF=
     X          ( JPMXGR*(JP16SET/JPMXGR) + JP16SET*(JPMXGR/JP16SET) )
     X           /     ( (JP16SET/JPMXGR) + (JPMXGR/JP16SET) )       )
#endif
C
C     Subroutine arguments.
C
      INTEGER KLENP, KLENG, KNSPT, KBITS, KBMAP, KVALS, KLEN, KDEBUG
      INTEGER KDATA (KLENP), KSEC1 (*), KSEC2 (*), KSEC3 (*), KSEC4 (*)
      INTEGER KGRIB (KLENG)
C
      CHARACTER HOPER * (*)
C
      REAL PREF, PMAX
C
C     Global variables.
C
#include "grbcom.h"
C
C     Local variables.
C
      INTEGER IRET, INROWS, J, IROWMK, INSPTA, ILOWMK, IHIGMK, IRETFN
      INTEGER ILSIMP, IL4OPT, ILMETH, IZERO, ICWORK, IROWBF, ICWIMK, J2
      INTEGER ICWIBF, ICWIFO, IHWM, INCMIN, IOFF, IROWL4, ICWIL4
      INTEGER IGENMK, IGENBF, IGENFO, IGENL4, IMINPK, IMETHO, JMETHO
      INTEGER IMTROW, IMTCWI, IMTGEN, IMTMIN, IMTMAX, ILREFR
C
      INTEGER IWORK (JPWORK), IPOWER (0:JPXPWR), ISEC4 (JPVSE4,JPMETH)
      INTEGER IPCWID (0:JPCWID-1)
C
      INTEGER C2ROWS, C2CWID, C2GENE
      EXTERNAL C2ROWS, C2CWID, C2GENE
C
      CHARACTER YOPER*1, YMETHO*30, YREFER*30
C
      LOGICAL LROW, LQUASI, LCTWID, LSECBI, LPRIBI, LAGGPK, LSIMPK
      LOGICAL L1CALL, LSECT2, LLONLY, LCOMGR, LFIRST, LGEN2O, LDEBUG
      LOGICAL LOPTLN, LGPREC
      LOGICAL LGENXT, LBOUST, LREVER, LPRCLN, LNLOCP, LNLOCF, LDYNOR
      LOGICAL LCOMSD, LCBIAS, LVECTD
C
      INTEGER IWIDSD, INDCLN, IGXTMK, IGXTBF, IGXTFO, IGXTL4, IBOUST
      INTEGER IMTGXT, IORDER, ILWORX, IBIAS, IXBITS
C
      INTEGER REVERO, C2DOSD, D2ROSD
      EXTERNAL REVERO, C2DOSD, D2ROSD
C
      INTRINSIC ABS
C
      REAL ZGAIN
C
      SAVE L1CALL, IPOWER, IMTROW, IMTCWI, IMTGEN, IPCWID
      SAVE IMTGXT
C
C     Function used to adress 4 sub-parts of array IWORK, using
C     first and last argument to specify sub-part.
C     (4 work arrays are joined together to enable use of a single big
C      work array)
C
      INTEGER IXIND, IABCDE, IFGHIJ, IKLMNO
C
      IXIND ( IABCDE, IFGHIJ, IKLMNO ) =
C
     X        IFGHIJ + JPMXGF * ( IKLMNO - 1 + 2 * ( IABCDE - 1 ) )
C
      DATA L1CALL / .TRUE. /
      DATA IMTROW / 1 /
      DATA IMTCWI / 2 /
      DATA IMTGEN / 3 /
      DATA IMTGXT / 4 /
C
C     -----------------------------------------------------------------
C*    Section 1 . Performs initial checks.
C     -----------------------------------------------------------------
C
  100 CONTINUE
C
      IF (L1CALL) THEN
C
        DO 111 J=0,JPXPWR-1
C
          IPOWER(J)=2**J-1
C
  111   CONTINUE
#ifdef JBPW_64
        IPOWER(JPXPWR)=140737488355327
#else
        IPOWER(JPXPWR)=2147483647
#endif
C
        IPCWID(0)=0
        IOFF=1
C
        DO 113 J=1,JPXWID
C
          DO 112 J2=0,IPOWER(J-1)
C
            IPCWID(IOFF+J2)=J
C
  112     CONTINUE
C
          IOFF=IOFF+IPOWER(J-1)+1
C
  113   CONTINUE
C
        L1CALL=.FALSE.
C
      ENDIF
C
      IRETFN = 0
      IMETHO=0
      INSPTA=KNSPT
      LAGGPK=HOPER.EQ.'K'
      ILSIMP=11+(1+(KLEN*KSEC4(2)-1)/8)
      ILSIMP=2*(1+(ILSIMP-1)/2)
      IL4OPT=ILSIMP
      LSIMPK=LAGGPK
      LDEBUG=KDEBUG.GE.1
      IMINPK=MIN ( 15, MAX ( 2, NINT ( SQRT ( REAL (KLEN/3) ) ) ) )
C     IMINPK=12
      INCMIN=MIN (  3, 1 + KLEN/1000 )
C     INCMIN=1
C
      LSECT2=KSEC1(5).GE.128
      LPRIBI=MOD (KSEC1(5),128).GE.64
#ifndef ebug2o
C
      IF (LDEBUG) THEN
#endif
        WRITE(GRPRSM,FMT=9100) HOPER(:1), KNSPT, KSEC4(2), LSECT2,
     X                          LPRIBI
        YREFER='simple packing'
#ifndef ebug2o
      ENDIF
C
#endif
      LSECBI=KSEC4(9).NE.0
      LROW=.NOT.LSECBI.AND.KSEC4(12).EQ.0
      LGENXT=(.NOT.LSECBI.OR.LAGGPK).AND.KSEC4(12).NE.0
      LBOUST=KSEC4(13).NE.0
      IORDER=IABS (KSEC4(14))+IABS (KSEC4(15))
      LNLOCP=IORDER.NE.0
      LREVER=.FALSE.
      LGPREC=.FALSE.
#if (defined CRAY) || (defined FUJITSU)
      LVECTD=.TRUE.
#else
      LVECTD=.FALSE.
#endif
      LQUASI=KSEC2(17).EQ.1
      LCTWID=KSEC4(10).EQ.0
      LGEN2O=LSECBI.AND.(.NOT.LCTWID.OR.LAGGPK)
C
      IF (KSEC4(8).NE.0) THEN
        IRETFN = 18110
        WRITE(GRPRSM,FMT=9110)
        GO TO 900
      ELSEIF (LROW.OR.LAGGPK) THEN
C
        IF (.NOT.LSECT2) THEN
C
          IF (LAGGPK) THEN
            LROW=.FALSE.
            LGEN2O=.TRUE.
          ELSE
            IRETFN = 18120
            WRITE(GRPRSM,FMT=9120) 'Row by row packing'
            GO TO 900
          ENDIF
C
        ELSEIF (LPRIBI.AND.KSEC3(1).NE.0) THEN
C
          IF (LAGGPK) THEN
            LROW=.FALSE.
            LGEN2O=.TRUE.
          ELSE
            IRETFN = 18130
            WRITE(GRPRSM,FMT=9130)
     S       'Row by row', 'implicit primary bit-map'
            GO TO 900
          ENDIF
C
        ELSE
C
          LROW=LROW.OR.LAGGPK
C
        ENDIF
C
      ENDIF
C
      IF (LCTWID) THEN
C
        IF (LROW.AND..NOT.LAGGPK) THEN
          IRETFN = 18135
          WRITE(GRPRSM,FMT=9130)
     S       'Row by row', 'constant width'
          GO TO 900
        ENDIF
C
      ENDIF
C
      LCTWID=LCTWID.OR.(LAGGPK.AND.NUM2OK.EQ.1)
      LGEN2O=LGEN2O.OR.(LAGGPK.AND.NUM2OK.EQ.1)
C
      IF (KSEC4(12).NE.0.AND.NEXT2O.EQ.1.AND..NOT.LAGGPK) THEN
C
C            General extended second-order packing explicitly requested.
C
        IF (KSEC4(12).NE.8) THEN
          IRETFN = 18140
          WRITE(GRPRSM,FMT=9140) 12, 8
          GO TO 900
        ELSEIF (LSECBI) THEN
          IRETFN = 18145
          WRITE(GRPRSM,FMT=9150) 'no secondary bit-map'
          GO TO 900
        ELSEIF (LCTWID) THEN
          IRETFN = 18150
          WRITE(GRPRSM,FMT=9150) 'variable group widthes'
          GO TO 900
        ENDIF
C
      ENDIF
C
      LGENXT=NEXT2O.EQ.1.AND.(LGENXT.OR.(LAGGPK.AND.NUM2OK.EQ.1))
C
      IF (KSEC4(13).NE.0.AND.NEXT2O.EQ.1.AND..NOT.LAGGPK) THEN
C
C               Boustrophedonic ordering explicitly requested.
C
        IF (KSEC4(13).NE.4) THEN
          IRETFN = 18151
          WRITE(GRPRSM,FMT=9140) 13, 4
          GO TO 900
        ELSEIF (.NOT.LSECT2) THEN
          IRETFN = 18152
          WRITE(GRPRSM,FMT=9120) 'Boustrophedonic ordering'
          GO TO 900
        ELSEIF (LROW) THEN
          WRITE(GRPRSM,FMT=9153)
          KSEC4(13)=0
          LBOUST=.FALSE.
        ELSEIF (LPRIBI.AND.KSEC3(1).NE.0) THEN
          IRETFN = 18154
          WRITE(GRPRSM,FMT=9130)
     S       'Boustrophedonic ordering', 'implicit primary bit-map'
          GO TO 900
        ENDIF
C
      ENDIF
C
      LBOUST=NEXT2O.EQ.1.AND.(LBOUST.OR.(LAGGPK.AND.NUM2OK.EQ.1)).AND.
     S   LSECT2.AND.(.NOT.LPRIBI.OR.KSEC3(1).EQ.0)
C
#ifndef ebug2o
      IF (LDEBUG) THEN
#endif
        PRINT *,'C2ORDR: LBOUST/LNLOCP/LAGGPK=',
     S                 LBOUST, LNLOCP, LAGGPK
#ifndef ebug2o
      ENDIF
C
#endif
      IF (LNLOCP.AND.NEXT2O.EQ.1.AND.NLOC2O.EQ.1.AND..NOT.LAGGPK) THEN
C
C               Spatial differencing explicitly requested.
C
        IF (KSEC4(14).NE.2.AND.KSEC4(14).NE.0.AND.KSEC4(14).NE.-1) THEN
          IRETFN = 18154
          WRITE(GRPRSM,FMT=9155) 14, 2
          GO TO 900
        ELSEIF (ABS (KSEC4(15)).NE.1.AND.KSEC4(15).NE.0) THEN
          IRETFN = 18155
          WRITE(GRPRSM,FMT=9155) 15, 1
          GO TO 900
        ELSEIF (.NOT.LGENXT) THEN
          WRITE(GRPRSM,FMT=9156)
          KSEC4(14)=0
          KSEC4(15)=0
          IORDER=0
          LNLOCP=.FALSE.
        ENDIF
C
      ENDIF
C
      LNLOCF=NEXT2O.EQ.1.AND.NLOC2O.EQ.1.AND.
     S      (LNLOCP.OR.(LGENXT.AND.LAGGPK.AND.NUM2OK.EQ.1))
C
      IF (LNLOCF.AND..NOT.LNLOCP) THEN
C
C       Spatial differencing implicitly requested.
C       Activation of iterative search for best order.
C
        KSEC4(14)=-1
        KSEC4(15)=-1
      ENDIF
C
      LNLOCP=LNLOCF
C
      IF (.NOT.LNLOCP) THEN
        IORDER=0
      ENDIF
C
      IF (KSEC4(2).GT.JPXPWR) THEN
C
        IRETFN = 18160
        WRITE(GRPRSM,FMT=9160) KSEC4(2), JPXPWR
        GO TO 900
C
      ELSEIF (LCTWID) THEN
C
        IF (ABS (KSEC4(11)).GE.KSEC4(2)) THEN
C
          IF (LAGGPK) THEN
            KSEC4(11)=-(KSEC4(2)-1)
          ELSE
            IRETFN = 18170
            WRITE(GRPRSM,FMT=9170) KSEC4(11), KSEC4(2)-1
            GO TO 900
          ENDIF
C
        ENDIF
C
      ENDIF
C
      IF (PMAX.LE.PREF.AND.LAGGPK) THEN
C
C       Field is constant... code it with zero as bit-number,
C                            and nothing else!              
C
C     Enforce right values for flags.
C
        KSEC4(4)=0
        KSEC4(6)=0
C
C*    Octet 11 : Number of bits containing each first-order value.
C     One 8 bit field.
C
#ifndef ebug2o
        IF (LDEBUG) THEN
C
#endif
          WRITE(GRPRSM,FMT=9175) PMAX
          IL4OPT=12
          YREFER='direct method'
C
C              Switch off LSIMPK to enable printout of gain.
C
          LSIMPK=.FALSE.
#ifndef ebug2o
        ENDIF
C
#endif
        IZERO=0        
        YOPER='C'
        KNSPT=KNSPT+10*8
        CALL INXBIT(KGRIB,KLENG,KNSPT,IZERO,1,KBITS, 8,YOPER,IRET)
C
        IF (IRET.NE.0) THEN
          IRETFN = 18180
          WRITE(GRPRSM,FMT=9001) 'bit number'
        ENDIF
C
        GO TO 900
C
      ENDIF
C
      IF (LSECT2) THEN
C
        IF (MOD (KSEC2(11),64).LT.32) THEN
          INROWS=KSEC2(3)
        ELSE
          INROWS=KSEC2(2)
        ENDIF
C
#ifndef ebug2o
        IF (LDEBUG) THEN
#endif
          WRITE(GRPRSM,FMT=9180) INROWS, KLEN, LQUASI
#ifndef ebug2o
        ENDIF
C
#endif
        IF (.NOT.LPRIBI.AND.KLEN.NE.KSEC4(1)) THEN
          IRETFN = 18185
          WRITE(GRPRSM,FMT=9185) KLEN, KSEC4(1)
          GO TO 900
        ELSEIF (LPRIBI.AND.(KLEN.LE.0.OR.KLEN.GT.KSEC4(1))) THEN
          IRETFN = 18187
          WRITE(GRPRSM,FMT=9187) KLEN, KSEC4(1)
          GO TO 900
        ELSEIF (LROW.AND.INROWS.GT.JPMXGF) THEN
C
          IF (LAGGPK) THEN
            LROW=.FALSE.
          ELSE
            IRETFN = 18190
            WRITE(GRPRSM,FMT=9190) INROWS, JPMXGF
            GO TO 900
          ENDIF
#ifndef wmogrp2o
C
        ELSEIF (LPRIBI.AND.KSEC3(1).NE.0.AND.KLEN.GT.JP16SET) THEN
C
C     Such a case would lead to no possibility to recover the right
C     number of grid points when decoding through D2ORDR routine.
C
          IRETFN = 18192
          WRITE(GRPRSM,FMT=9192) JP16SET
          GO TO 900
#endif
C
        ENDIF
C
      ENDIF
C
      IF (.NOT.(LROW.OR.LCTWID.OR.LGEN2O.OR.LGENXT.OR.LSIMPK)) THEN
        WRITE(GRPRSM,FMT=9195)
        LSIMPK=.TRUE.
        GO TO 600
      ENDIF
C
      LLONLY=LAGGPK
      ILOWMK=JPMXGF+1
      IHIGMK=0
      IROWMK=0
      ICWIMK=1
      IGENMK=1
      IGXTMK=1
      LFIRST=.TRUE.

C          Copy KSEC4 for all possible methods. 
C
      IF (LROW) THEN
        IMTMIN=IMTROW
        IMTMAX=IMTROW
      ELSE
        IMTMIN=JPMETH
        IMTMAX=1
      ENDIF
C
      IF (LCTWID) THEN
        IMTMIN=MIN (IMTCWI,IMTMIN)
        IMTMAX=MAX (IMTCWI,IMTMAX)
      ENDIF
C
      IF (LGEN2O) THEN
        IMTMIN=MIN (IMTGEN,IMTMIN)
        IMTMAX=MAX (IMTGEN,IMTMAX)
      ENDIF
C
      IF (LGENXT) THEN
        IMTMIN=MIN (IMTGXT,IMTMIN)
        IMTMAX=MAX (IMTGXT,IMTMAX)
      ENDIF
C
      DO 122 JMETHO=IMTMIN,IMTMAX
C
      DO 121 J=1,JPVSE4
      ISEC4(J,JMETHO)=KSEC4(J)
  121 CONTINUE
C
  122 CONTINUE
C
      IF (LBOUST.AND.IMTMIN.EQ.IMTROW.AND.IMTMAX.EQ.IMTROW) THEN
C
C         This might be the case in aggressive packing mode.
C
        WRITE(GRPRSM,FMT=9153)
        KSEC4(13)=0
        LBOUST=.FALSE.
      ENDIF
C
      IF (LBOUST) THEN
C
        IBOUST=4
C
C         Reverse field ordering for even rank rows.
C
C         This is done before trying any method or sub-method,
C         for better prognosis of non-local packing interest
C         (if requested). It allows also more simple source code.
C
C         There is no influence on trial of row by row packing,
C         because work arrays computed through C2ROWS with LLONLY set
C         to .TRUE. do not depend on field ordering within each row.
C
C         The only case where field ordering might have to be restored
C         would be in aggressive packing mode, if either row by row
C         or simple packing was found more efficient than all the other
C         2nd-order methods selected/allowed... Probability of such a
C         case is low, but source code enables it.
C
C         Apart from that, the only side effect of this anticipated call
C         to REVERO is, when row by row packing is enabled
C         (as in exhaustive mode), to compute twice the lengths of rows.
C         This is considered as a cheap overhead.
C
        LPRCLN=.FALSE.
C
        IRETFN = REVERO ( KDATA,  KLENP,  KSEC2,  KGRIB,  KLENG,
     X                    KBITS,  KBMAP,  KVALS,  LPRIBI, LQUASI,
     X                    INROWS, KLEN,   IWORK(IXIND (2,1,2)),
     X                    JPMXGF, LDEBUG, LPRCLN, IWORK(IXIND (2,1,1)) )
C
        IF (IRETFN.NE.0) THEN
          GO TO 900
        ENDIF
C
        LREVER=.TRUE.
C
      ELSE
C
        IBOUST=0
C
      ENDIF
C
      DO 123 JMETHO=IMTMIN,IMTMAX
      ISEC4(13,JMETHO)=IBOUST
  123 CONTINUE
C
      LDYNOR=LNLOCP.AND.(KSEC4(14).EQ.-1.OR.KSEC4(15).EQ.-1)
C
      IF (LDYNOR) THEN
C
C         Estimate interest of non-local packing use, and order
C         associated to.
C
C         In non-agressive mode (HOPER='C'), field is also transformed.
C
        LCOMSD=.NOT.LAGGPK
        LCBIAS=.TRUE.
        IORDER = C2DOSD ( KDATA,  KLENP,  KSEC4,  LCOMSD, KLEN,
     X                    IWORK,  JPWORK, IPOWER, JPXPWR, IPCWID,
     X                    JPXWID, IMINPK, ILWORX, IBIAS,  IWIDSD,
     X                    IXBITS, LCBIAS, LDEBUG )
        LCBIAS=.FALSE.    
C
      ELSE
C
        LCOMSD=.FALSE.
        LCBIAS=.TRUE.
C
      ENDIF
C
C     -----------------------------------------------------------------
C*    Section 2 . Row by row packing method applied, or tried.
C     -----------------------------------------------------------------
C
  200 CONTINUE
C
#ifndef ebug2o
      IF (LDEBUG) THEN
#endif
        WRITE(GRPRSM,FMT=9200) LROW, LCTWID, LGEN2O, LGENXT, LBOUST,
     X                          IORDER, LSIMPK
#ifndef ebug2o
      ENDIF
C
#endif
      IF (LROW) THEN
C
C       Upper part of work sub-arrays IWORK(IXIND (1,.,1)),
C       IWORK(IXIND (2,.,1)), IWORK(IXIND (1,.,2))
C       -reference values, effective row lengths, row widths- is used;
C       useful for aggressive packing, if row by row packing turns
C       to be selected as the appropriate method to apply, and if total
C       work space needed by the other methods do not overlap.
C
        IMETHO=IMTROW
        IROWMK=JPMXGF-INROWS+1
        ILOWMK=IROWMK
        LCOMGR=LFIRST.OR.IROWMK.LE.IHIGMK
C
        IF (LREVER.AND..NOT.LFIRST) THEN
C
C         Restore initial field ordering.
C
          LPRCLN=.NOT.LCOMGR
C
          IRETFN = REVERO ( KDATA,  KLENP,  KSEC2,  KGRIB,  KLENG,
     X                      KBITS,  KBMAP,  KVALS,  LPRIBI, LQUASI,
     X                      INROWS, KLEN,   IWORK(IXIND (2,1,2)),
     X                      JPMXGF, LDEBUG, LPRCLN,
     X                      IWORK(IXIND (2,IROWMK,1)) )
C
          IF (IRETFN.NE.0) THEN
            GO TO 900
          ENDIF
C
          LREVER=.FALSE.
C
        ENDIF
C
C         Enforce no extension at all, and especially 
C         no boustrophedonic ordering for row by row (useless).
C
        DO 201 J=12,15
        ISEC4(J,IMETHO)=0
  201   CONTINUE
C
        IRET = C2ROWS ( KDATA,  KLENP,  KSEC2,  ISEC4(1,IMETHO),KGRIB,
     X                  KLENG,  KNSPT,  KBITS,  LCOMGR, LLONLY, IROWL4,
     X                  KBMAP,  KVALS,  LPRIBI, LQUASI, INROWS, KLEN,
     X                  IWORK(IXIND (1,IROWMK,1)),
     X                  IWORK(IXIND (2,IROWMK,1)),
     X                  IWORK(IXIND (1,IROWMK,2)),
     X                  IWORK(IXIND (2,1,2)),   JPMXGF, IPOWER, JPXPWR,
     X                  IPCWID, JPXWID, IROWBF, LDEBUG )
C
        IF (LLONLY) THEN
C
#ifndef ebug2o
          IF (LDEBUG) THEN
#endif
            WRITE(GRPRSM,FMT=9210) IRET, IROWBF, IROWL4, IL4OPT
#ifndef ebug2o
          ENDIF
C
#endif
          IF (IRET.NE.0.OR.IROWL4.GE.IL4OPT) THEN
            LROW=.FALSE.
C
            IF (IRET.NE.0.AND.LBOUST) THEN
C
C               Reset IROWMK to avoid possible misuse of length array
C               in REVERO.
C
              IROWMK=0
            ENDIF
C
          ELSE
            IL4OPT=IROWL4
            LSIMPK=.FALSE.
          ENDIF
C
        ELSEIF (IRET.NE.0) THEN
C
          IRETFN = IRET
          GO TO 900
C
        ENDIF
C
#ifdef ebug2o
        IF (.NOT.LLONLY) THEN
#else
        IF (LDEBUG.AND..NOT.LLONLY) THEN
#endif
C
          YMETHO='Row by row'
          IL4OPT=IROWL4
C
        ENDIF
C
      ENDIF
C
C     -----------------------------------------------------------------
C*    Section 3 . Constant width packing method applied, or tried.
C     -----------------------------------------------------------------
C
      IF (LCTWID) THEN
C
        IMETHO=IMTCWI
        ILOWMK=MIN (ICWIMK,ILOWMK)
        LCOMGR=LFIRST.OR.ICWIMK.LE.IHIGMK
C
        IF (LCOMGR) THEN
          ICWIMK=1
          ICWORK=1
        ENDIF
C
        IF (LLONLY.AND.NUM2OK.EQ.1) THEN
C
C           Modulates width use, regardless of KSEC4(11).
C
          IF (LGENXT) THEN
C
C     Experience shows that the only cases where constant width packing
C     may compress data better than general extended method are for a
C     null width.
C
            ISEC4(11,IMETHO)=0
          ELSE
            ISEC4(11,IMETHO)=-(ISEC4(2,IMETHO)-1)
          ENDIF
C
        ENDIF
C
        LOPTLN=LFIRST.AND.ISEC4(11,IMETHO).LT.0
C
C         Enforce no extension flag, except boustrophedonic ordering.
C
        ISEC4(12,IMETHO)=0
        ISEC4(14,IMETHO)=0
        ISEC4(15,IMETHO)=0
C
        IRET = C2CWID ( KDATA,  KLENP,  ISEC4(1,IMETHO),KGRIB,  KLENG,
     X                  KNSPT,  KBITS,  LCOMGR, LLONLY, ICWIL4, ICWIFO,
     X                  KLEN,   IWORK(IXIND(1,1,1)),
     X                  IWORK(IXIND(2,1,1)),    JPMXGF, ICWIMK, IPOWER,
     X                  JPXPWR, ICWIBF, INCMIN, IHWM,   ICWORK, LDEBUG,
     X                  LOPTLN )
C
        IF (LLONLY) THEN
C
#ifndef ebug2o
          IF (LDEBUG) THEN
#endif
            WRITE(GRPRSM,FMT=9310) IRET, ICWIBF, ICWIL4, IL4OPT,
     X                              ICWIFO, IHWM, ICWORK
#ifndef ebug2o
          ENDIF
C
#endif
          IF (IRET.NE.0.OR.ICWIL4.GE.IL4OPT) THEN
            LCTWID=.FALSE.
            IHIGMK=MAX (IHIGMK,IHWM)
          ELSE
C
C     Constant width packing better than simple packing,
C     and possibly row by row.
C
            IL4OPT=ICWIL4
            LSIMPK=.FALSE.
            LROW=.FALSE.
C
            IF (LGEN2O.OR.LGENXT) THEN
C
C     Push up useful work arrays, trying to keep data if further
C     method(s) tried are not better.
C
              IOFF=JPMXGF-ICWIFO
              ICWIMK=IOFF+1
              IHIGMK=0
C
#ifdef CRAY
CDIR$ IVDEP
#endif
#ifdef FUJITSU
!OCL NOVREC
#endif
              DO 311 J=ICWIFO,1,-1
              IWORK(IXIND (1,IOFF+J,ICWORK))=IWORK(IXIND (1,J,ICWORK))
              IWORK(IXIND (2,IOFF+J,ICWORK))=IWORK(IXIND (2,J,ICWORK))
  311         CONTINUE
C
            ENDIF
C
          ENDIF
C
        ELSEIF (IRET.NE.0) THEN
C
          IRETFN = IRET
          GO TO 900
C
        ENDIF
C
#ifdef ebug2o
        IF (.NOT.LLONLY) THEN
#else
        IF (LDEBUG.AND..NOT.LLONLY) THEN
#endif
C
          WRITE (UNIT=YMETHO,FMT=9320) ISEC4(11,IMETHO)
          IL4OPT=ICWIL4
C
        ENDIF
C
      ENDIF
C
C     -----------------------------------------------------------------
C*    Section 4 . General 2nd-order packing method applied, or tried.
C     -----------------------------------------------------------------
C
      IF (LGEN2O) THEN
C
        IMETHO=IMTGEN
        ILOWMK=MIN (IGENMK,ILOWMK)
        LCOMGR=.NOT.LGPREC
C
        IF (LCOMGR) THEN
          IGENMK=1
        ENDIF
C
C         Enforce no extension flag, except boustrophedonic ordering.
C
        ISEC4(12,IMETHO)=0
        ISEC4(14,IMETHO)=0
        ISEC4(15,IMETHO)=0
C
        IRET = C2GENE ( KDATA,  KLENP,  ISEC4(1,IMETHO),KGRIB,  KLENG,
     X                  KNSPT,  KBITS,  LCOMGR, LLONLY, IGENL4, IGENFO,
     X                  KLEN,   IWORK(IXIND (1,1,1)),
     X                  IWORK(IXIND (2,1,1)),   IWORK(IXIND (1,1,2)),
     X                  IWORK(IXIND (2,1,2)),   JPMXGF, IGENMK, IPOWER,
     X                  JPXPWR, IPCWID, JPXWID, IGENBF, INCMIN, IMINPK,
     X                  IHWM,   LDEBUG )
C
        IF (LLONLY) THEN
C
#ifndef ebug2o
          IF (LDEBUG) THEN
#endif
            WRITE(GRPRSM,FMT=9410) IRET, IGENBF, IGENL4, IL4OPT,
     X                              IGENFO, IHWM
#ifndef ebug2o
          ENDIF
C
#endif
          IF (IRET.NE.0.OR.IGENL4.GE.IL4OPT) THEN
            LGEN2O=.FALSE.
          ELSE
C
C     General 2nd-order packing better than simple packing,
C     and possibly row by row and/or constant width.
C
            IL4OPT=IGENL4
            LSIMPK=.FALSE.
            LROW=.FALSE.
            LCTWID=.FALSE.
C
          ENDIF
C
          IHIGMK=MAX (IHIGMK,IHWM)
          LGPREC=IRET.EQ.0
C
          IF (LGPREC.AND.LGENXT) THEN
C
C              Duplicate descriptors for further use by
C              general extended packing trial.
C
            IGXTBF=IGENBF
            IGXTFO=IGENFO
            IGXTMK=IGENMK
C
          ENDIF
C
        ELSEIF (IRET.NE.0) THEN
C
          IRETFN = IRET
          GO TO 900
C
        ENDIF
C
#ifdef ebug2o
        IF (.NOT.LLONLY) THEN
#else
        IF (LDEBUG.AND..NOT.LLONLY) THEN
#endif
C
          YMETHO='General second-order'
          IL4OPT=IGENL4
C
        ENDIF
C
      ENDIF
C
C     -----------------------------------------------------------------
C*    Section 5 . General extended 2nd-order packing method applied,
C                 or tried.
C     -----------------------------------------------------------------
C
      IF (LGENXT) THEN
C
        IMETHO=IMTGXT
        ILOWMK=MIN (IGXTMK,ILOWMK)
        LCOMGR=.NOT.LGPREC.OR.(LFIRST.AND.LNLOCP)
C
  510   CONTINUE
C
        IF (LCOMGR) THEN
          IGXTMK=1
        ELSEIF (LFIRST) THEN
C
C         Inherit total length of second-order values from general WMO
C         second-order packing, performed just previously.
C
          ISEC4(19,IMETHO)=ISEC4(19,IMTGEN)
        ENDIF
C
        ISEC4(12,IMETHO)=8
        ISEC4(14,IMETHO)=2*(IORDER/2)
        ISEC4(15,IMETHO)=MOD (IORDER,2)
C
        IF (IORDER.NE.0.AND..NOT.LCOMSD) THEN
C
C           Spatial differencing has to be applied to field.
C
          LCOMSD=.TRUE.
          IORDER = C2DOSD ( KDATA,  KLENP,  ISEC4(1,IMETHO), LCOMSD,
     S                      KLEN,   IWORK,  JPWORK, IPOWER,  JPXPWR,
     S                      IPCWID, JPXWID, IMINPK, ILWORX,  IBIAS,
     S                      IWIDSD, IXBITS, LCBIAS, LDEBUG )     
C
C           Reset ISEC4, because C2DOSD may have reset IORDER.
C
          ISEC4(14,IMETHO)=2*(IORDER/2)
          ISEC4(15,IMETHO)=MOD (IORDER,2)
C
        ENDIF
C
        IF (IORDER.NE.0) THEN
          ISEC4( 2,IMETHO)=IXBITS
          ISEC4(11,IMETHO)=IWIDSD
          ISEC4(16,IMETHO)=IBIAS
        ENDIF
C
        IRET = C2GENE ( KDATA,  KLENP,  ISEC4(1,IMETHO),KGRIB,  KLENG,
     X                  KNSPT,  KBITS,  LCOMGR, LLONLY, IGXTL4, IGXTFO,
     X                  KLEN,   IWORK(IXIND (1,1,1)),
     X                  IWORK(IXIND (2,1,1)),   IWORK(IXIND (1,1,2)),
     X                  IWORK(IXIND (2,1,2)),   JPMXGF, IGXTMK, IPOWER,
     X                  JPXPWR, IPCWID, JPXWID, IGXTBF, INCMIN, IMINPK,
     X                  IHWM,   LDEBUG )
C
        IF (LLONLY) THEN
C
#ifndef ebug2o
          IF (LDEBUG) THEN
#endif
            WRITE(GRPRSM,FMT=9510) IRET, IGXTBF, IGXTL4, IL4OPT,
     X                              IGXTFO, IHWM, IORDER
#ifndef ebug2o
          ENDIF
C
#endif
          IF (IRET.NE.0.OR.IGXTL4.GE.IL4OPT) THEN
C
C             Current method is not successful, and has to be discarded.
C
            LGENXT=.FALSE.
C
            IF (IRET.NE.0.OR..NOT.LGEN2O) THEN
              LGPREC=.FALSE.
            ELSE
              LGPREC=IGXTFO.EQ.IGENFO.AND.IORDER.EQ.0
            ENDIF
C
            IF (LCOMSD.AND.IORDER.NE.0) THEN
C
C              Spatial differencing has to be reversed.
C
              IRETFN = D2ROSD ( KDATA,  KLEN,   IORDER, IPOWER, JPXPWR,
     S                          IBIAS,  LVECTD, LDEBUG )     
C
              IF (IRETFN.NE.0) THEN
                GO TO 900
              ENDIF
C
              LCOMSD=.FALSE.
C
              IF (LGEN2O.AND.LDYNOR) THEN
C
C    General WMO 2nd-order packing was also selected/promoted, and is
C    the best method. This indicates moreless wrong diagnostic for
C    spatial differencing order.
C    Retry then general extended packing without spatial differencing,
C    that in almost all cases behaves better than general WMO method.
C
#ifndef ebug2o
                IF (LDEBUG) THEN
#endif
                  WRITE(GRPRSM,FMT=9520) IORDER
#ifndef ebug2o
                ENDIF
C
                IORDER=0
                LGENXT=.TRUE.
                LGPREC=.FALSE.
                LCOMGR=.TRUE.
                ISEC4(2,IMETHO)=KSEC4(2)
                GOTO 510
C
              ENDIF
C
            ENDIF
C
          ELSE
C
C     General extended 2nd-order packing better than simple packing,
C     and possibly other methods.
C
            IL4OPT=IGXTL4
            LSIMPK=.FALSE.
            LROW=.FALSE.
            LCTWID=.FALSE.
            LGEN2O=.FALSE.
            LGPREC=.TRUE.
C
          ENDIF
C
          IHIGMK=MAX (IHIGMK,IHWM)
C
        ELSEIF (IRET.NE.0) THEN
C
          IRETFN = IRET
          GO TO 900
C
        ENDIF
C
#ifdef ebug2o
        IF (.NOT.LLONLY) THEN
#else
        IF (LDEBUG.AND..NOT.LLONLY) THEN
#endif
C
          YMETHO='Gen.extend.2nd-order'
          IL4OPT=IGXTL4
C
        ENDIF
C
      ENDIF
#endif
C
C     -----------------------------------------------------------------
C*    Section 6 . Effective in case of aggressive packing only.
C     -----------------------------------------------------------------
C
  600 CONTINUE
C
      IF (LSIMPK) THEN
C
C       Simple packing by default: complex packing not efficient,
C                                  or not applicable.
C
C     The first 10 octets have already been coded by GRIBEX, or will
C     be in a further step of GRIBEX:
C     Length of section, flags+unused bit count, binary scale factor,
C     reference value.
C
C     Enforce right values for flags.
C
        KSEC4(4)=0
        KSEC4(6)=0
        IMETHO=0
        YMETHO='Simple'
C
C*    Octet 11 : Number of bits containing each first-order value.
C     One 8 bit field.
C
        YOPER='C'
        KNSPT=KNSPT+10*8
        CALL INXBIT(KGRIB,KLENG,KNSPT,KSEC4(2),1,KBITS, 8,YOPER,IRET)
C
        IF (IRET.NE.0) THEN
          IRETFN = 18610
          WRITE(GRPRSM,FMT=9001) 'bit number'
          GO TO 900
        ENDIF
C
        IF (LREVER) THEN
C
C         Restore initial field ordering.
C
          LPRCLN=(LFIRST.AND.LROW).OR.IROWMK.GT.IHIGMK
          INDCLN=MAX (IROWMK,1)
C
          IRETFN = REVERO ( KDATA,  KLENP,  KSEC2,  KGRIB,  KLENG,
     X                      KBITS,  KBMAP,  KVALS,  LPRIBI, LQUASI,
     X                      INROWS, KLEN,   IWORK(IXIND (2,1,2)),
     X                      JPMXGF, LDEBUG, LPRCLN,
     X                      IWORK(IXIND (2,INDCLN,1)) )
C
          IF (IRETFN.NE.0) THEN
            GO TO 900
          ENDIF
C
          LREVER=.NOT.LREVER
        ENDIF
C
C*    Octet 12 - onwards: Data.
C
        CALL INXBIT(KGRIB,KLENG,KNSPT,KDATA,KLEN,KBITS,KSEC4(2),
     X              YOPER,IRET)
C
        IF (IRET.NE.0) THEN
          IRETFN = 18620
          WRITE(GRPRSM,FMT=9001) 'normalized data'
          GO TO 900
        ENDIF
C
      ELSEIF (LLONLY) THEN
C
C       Loop back to apply the most efficient second-order method,
C       as previously diagnosed. And hoping work arrays have not
C       been overwritten, to avoid computing them again.
C
        LLONLY=.FALSE.
        LFIRST=.FALSE.
        GOTO 200
C
      ENDIF
C
C     -----------------------------------------------------------------
C*    Section 7 . Debugging printout.
C     -----------------------------------------------------------------
C
  700 CONTINUE
C
#ifndef ebug2o
      IF (LDEBUG) THEN
C
#endif
        ILMETH=INDEX (YMETHO//'  ','  ')-1
        WRITE(GRPRSM,FMT=9710) HOPER(:1), YMETHO(:ILMETH), IL4OPT
C
        IF (.NOT.LSIMPK) THEN
C
          IF (LBOUST.AND..NOT.LROW) THEN
            WRITE(GRPRSM,FMT=9720)
          ENDIF
C
          IF (LGENXT.AND.IORDER.NE.0) THEN
            WRITE(GRPRSM,FMT=9730) IORDER
          ENDIF
C
          ZGAIN=REAL (100*(ILSIMP-IL4OPT)) / REAL (ILSIMP)
          ILREFR=INDEX (YREFER//'  ','  ')-1
          WRITE(GRPRSM,FMT=9002) YREFER(:ILREFR), ZGAIN
C
#ifndef ebug2o
        ENDIF
C
#endif
      ENDIF
C
C     -----------------------------------------------------------------
C*    Section 9. Return to calling routine.
C     -----------------------------------------------------------------
C
  900 CONTINUE
C
C     If second-order method was effectively and successfully used,
C     copy back information of section 4 descriptors to KSEC4.
C
      IF (IRETFN.NE.0.AND.IMETHO.NE.0) THEN
C
        DO 901 J=1,JPVSE4
        KSEC4(J)=ISEC4(J,IMETHO)
  901   CONTINUE
C
      ENDIF
C
      C2ORDR = IRETFN
#ifndef ebug2o
C
      IF (LDEBUG) THEN
#endif
        WRITE(GRPRSM,FMT=9900) IRETFN, HOPER(:1), KNSPT
#ifndef ebug2o
      ENDIF
#endif
C
      RETURN
C
 9001 FORMAT (' C2ORDR: Problem inserting ',A,'.')
C
 9002 FORMAT (' C2ORDR: Gain on section 4 length against ',A,':',
     X        F5.1,' %.')
C
 9100 FORMAT (' C2ORDR: Function start, HOPER = ',A1,', KNSPT =',I10,
     X  '.',/,' C2ORDR: Original number of bits =',I3,'.',/,
     X        ' C2ORDR: Presence of sections 2 and 3 = ',L1,' and ',
     X        L1,'.')
C
 9110 FORMAT (' C2ORDR: Matrix of values invalid here.')
C
 9120 FORMAT (' C2ORDR: ',A,' only supported with a section 2.')
 9130 FORMAT (' C2ORDR: ',A,'/',A,': not supported.')
 9131 FORMAT (' C2ORDR: Approx. s4 length, ',A,',',I3,
     X        '-length groups:',I9,'.')
 9132 FORMAT (' C2ORDR: Range diagnostic is ',A,
     X        ' of spatial differences, order',I2,'.')
 9133 FORMAT (' C2ORDR: Selected order:',I2,', range diagnostics:',
     X        4I8,'.')
 9140 FORMAT (' C2ORDR: KSEC4(',I2,') must be 0 or ',I2,'.')
 9150 FORMAT (' C2ORDR: General extended packing implies ',A,'.')
 9153 FORMAT (' C2ORDR: Boustrophedonic ordering ignored with ',
     X        'row by row packing.')
 9155 FORMAT (' C2ORDR: KSEC4(',I2,') must be 0, -1 or ',I2,'.')
 9156 FORMAT (' C2ORDR: Spatial differencing ignored without ',
     X        'general extended 2nd-order packing.')
 9160 FORMAT (' C2ORDR: Bits number =',I3,' - maximum allowed =',I3,
     X        '.')
 9170 FORMAT (' C2ORDR: Constant width =',I3,
     X        ' - out of range [-/+',I2,'(=KSEC4(2)-1)].')
 9175 FORMAT (' C2ORDR: Constant field, value = ',F30.20,'.')
 9180 FORMAT (' C2ORDR: INROWS =',I6,', KLEN =',I9,', LQUASI = ',L1,
     X        '.')
 9185 FORMAT (' C2ORDR: Inconsistency: total g.p. number =',I9,
     X        ' expected =',I9,'.')
 9187 FORMAT (' C2ORDR: ',I9,' bits set in primary bit-map -',
     X        ' not in range [1,KSEC4(1)=',I9,'].')
 9190 FORMAT (' C2ORDR: Too much rows:',I6,' exceeds work space:',I6,
     X        '.')
#ifndef wmogrp2o
 9192 FORMAT (' C2ORDR: Implicit 1ary bit-map/g.p. number >',I6,
     X        ': unsupported.')
#endif
 9195 FORMAT (' C2ORDR: No packing method selected or applicable.',
     X        ' C2ORDR: Simple packing applied as backup.')
C
 9200 FORMAT (' C2ORDR: LROW=',L1,', LCTWID=',L1,', LGEN2O=',L1,
     X        ', LGENXT=',L1,', LBOUST=',L1,', IORDER=',I1,
     X        ', LSIMPK=',L1,'.')
C
 9210 FORMAT (' C2ORDR: (row by row) IRET, IROWBF, IROWL4, IL4OPT=',
     X        I6,I3,I9,I9,'.')
C
 9310 FORMAT (' C2ORDR: (cons.width) IRET, ICWIBF, ICWIL4, IL4OPT=',
     X        I6,I3,I9,I9,'.',/,
     X        ' C2ORDR:              ICWIFO, IHWM, ICWORK=',2I8,I2,'.')
C
 9320 FORMAT ('Constant width (',I2,')')
C
 9410 FORMAT (' C2ORDR: (general 2o) IRET, IGENBF, IGENL4, IL4OPT=',
     X        I6,I3,I9,I9,'.',/,
     X        ' C2ORDR:              IGENFO, IHWM=',2I8,'.')
C
 9510 FORMAT (' C2ORDR: (gen.extend) IRET, IGXTBF, IGXTL4, IL4OPT=',
     X        I6,I3,I9,I9,'.',/,
     X        ' C2ORDR:              IGXTFO, IHWM, IORDER=',2I8,I2,'.')
 9520 FORMAT (' C2ORDR: Non-optimal spatial differencing at order',I2,
     X        ', general 2o is better...',/,
     X' C2ORDR: .. retrying gen.extend. without spatial differencing.')
C
 9710 FORMAT (' C2ORDR: HOPER = ',A1,' - ',A,
     X        ' packing applied, IL4OPT =',I9,'.')
 9720 FORMAT (' C2ORDR: Boustrophedonic ordering has been used.')
 9730 FORMAT (' C2ORDR: Spatial differencing applied, order is',I2,'.')
C
 9900 FORMAT (' C2ORDR: Function return code =',I6,' HOPER = ',A,
     X        ', KNSPT =',I10,'.')
C
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities
C granted to it by virtue of its status as an intergovernmental organisation
C nor does it submit to any jurisdiction.
C

      SUBROUTINE JMKOFGG( HTYPE,
     X                    KNORTH,KSOUTH,PWEST,PEAST,KNUM,KPTS,KOFSET)
C
C---->
C**** JMKOFGG
C
C     Purpose
C     _______
C
C     This routine builds up the offsets into the storage array for
C     every row in the gaussian grid.
C
C
C     Interface
C     _________
C
C     CALL JMKOFGG(HTYPE,KNORTH,KSOUTH,PWEST,PEAST,KNUM,KPTS,KOFSET)
C
C
C     Input parameters
C     ________________
C
C     KNUM    - Gaussian grid number
C     HTYPE   - Gaussian grid type
C               = 'R' for reduced ("quasi-regular"),
C               = 'O' for reduced/octahedral,
C               = 'F' for full,
C               = 'U' for user-defined reduced gaussian grid
C     KNORTH  - Northern latitude row number
C     KSOUTH  - Southern latitude row number
C     PWEST   - Westernmost longitude for output field (degrees)
C     PEAST   - Easternmost longitude for output field (degrees)
C     KPTS    - Array giving the number of points in each row for the
C               gaussian grid
C
C
C     Output parameters
C     ________________
C
C     KOFSET  - Array of offsets for storing each row of the grid
C               values in an output buffer
C
C
C     Common block usage
C     __________________
C
C     None
C
C
C     Method
C     ______
C
C     Build up the offsets allowing for latitudes which are not in the
C     requested latitude band.  All offsets outside the latitude band
C     are set to zero.
C
C
C     Externals
C     _________
C
C     None
C
C
C     Reference
C     _________
C
C     None
C
C
C     Comments
C     ________
C
C
C
C     Author
C     ______
C
C     J.D.Chambers      ECMWF       Jan 1994
C
C
C     Modifications
C     _____________
C
C     None
C
C
C----<
C     _______________________________________________________
C
C*    Section 0. Definition of variables.
C     _______________________________________________________
C
      IMPLICIT NONE
C
C     Subroutine arguments
C
      CHARACTER*1 HTYPE
      INTEGER KNORTH, KSOUTH, KNUM, KPTS, KOFSET
      REAL    PWEST, PEAST
Cjdc  DIMENSION KPTS(*), KOFSET(*)
      DIMENSION KPTS(320), KOFSET(320)
C
C     Local variables
C
      INTEGER LAT, NUMPTS
      REAL RINTVL
C
C     _______________________________________________________
C
C*    Section 1. Fill in array of offsets
C     _______________________________________________________
C
  200 CONTINUE
C
C     Loop through all possible latitudes
      DO LAT = 1, 2*KNUM
        IF ( (LAT .LT. KNORTH) .OR. (LAT .GT. KSOUTH) ) THEN
          KOFSET(LAT) = 0
        ELSE
          IF ( LAT .EQ. KNORTH ) THEN
            KOFSET(LAT) = 1
          ELSE
            IF( HTYPE.EQ.'R' .OR. HTYPE.EQ.'r' .OR.
     X          HTYPE.EQ.'O' .OR. HTYPE.EQ.'o' .OR.
     X          HTYPE.EQ.'U' .OR. HTYPE.EQ.'u' ) THEN
              NUMPTS = KPTS(LAT -1)
            ELSE
              RINTVL = (PEAST - PWEST)*FLOAT( KPTS(LAT -1) ) / 360.0
              NUMPTS = NINT( RINTVL ) + 1
            ENDIF
            KOFSET(LAT) = KOFSET(LAT -1) + NUMPTS
          ENDIF
        ENDIF
      ENDDO
C
C     _______________________________________________________
C
C*    Section 9. Return to calling routine. Format statements
C     _______________________________________________________
C
  900 CONTINUE
C
      RETURN
      END

C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      INTEGER FUNCTION INTVECT(PUFIELD,PVFIELD,KASIZE,
     X                         KUGRIB,KVGRIB,OUTLEN)
C
C---->
C**** INTVECT
C
C     Purpose
C     -------
C     Interpolate U or V component fields to grid point.
C
C
C     Interface
C     ---------
C     IRET = INTVECT(PUFIELD,PVFIELD,KASIZE,
C    X               KUGRIB,KVGRIB,OUTLEN)
C
C     Input
C     -----
C     PUFIELD - U values.
C     PVFIELD - V values.
C     KASIZE  - Size of input arrays
C
C
C     Output
C     ------
C     KUGRIB - Output wind U component field (GRIB format).
C     KVGRIB - Output wind V component field (GRIB format).
C     OUTLEN - Output U field length (words).
C
C
C     Method
C     ------
C     None.
C
C
C     Externals
C     ---------
C     RESET_C - Reset interpolation handling options using GRIB product.
C     IBASINI - Ensure basic interpolation setup is done.
C     ISCRSZ  - Calculate number of values in generated field.
C     INTUVDH - Encode/decode data into/from GRIB code.
C     INTFAU  - Prepare to interpolate unpacked input field.
C     INTFBU  - Interpolate unpacked input field.
C     INTLOG  - Log error message.
C     MKFRAME - Create a 'frame' from a rectangular field.
C     INTUVGH - Interpolate GRIB U and V reduced gaussian to rotated GRIB
C               U and V.
C
C
C     Author
C     ------
C     J.D.Chambers     ECMWF     September 2004
C
C
C----<
C     -----------------------------------------------------------------|
C
      IMPLICIT NONE
C
#include "parim.h"
#include "nifld.common"
#include "nofld.common"
#include "intf.h"
#include "current.h"
C
C     Parameters
C
      INTEGER JPROUTINE
      PARAMETER (JPROUTINE = 40170 )
C
C     Function arguments
C
      INTEGER KPARAM, KASIZE, KUGRIB(*), KVGRIB(*), OUTLEN
      REAL PUFIELD(KASIZE), PVFIELD(KASIZE)
C
C     Local variables
C
      LOGICAL LFRAME, LOLDWIND, LOMISSV
      INTEGER NPARAM, IRET, ILENF, NTRUNC, NGAUSS, ISIZE, NCOUNT
      INTEGER NUVFLAG, NLON, NLAT, NBYTES, NSIZE
      INTEGER ISZVD, IHOLD, ISAME
      INTEGER IN_U, IN_V
      REAL DUMMY
      REAL AREA(4), GRID(2), POLE(2), EAST, WEST
      CHARACTER*1 HOLDTYP
      INTEGER LOOP
      INTEGER OUTLENO
C
      REAL RGGRID, SWORK, TWORK
      POINTER (IRGGRID, RGGRID(1) )
      POINTER (ISWORK, SWORK(1) )
      POINTER (ITWORK, TWORK(1) )
C
      INTEGER KPTS(JPGTRUNC*2)
      REAL GLATS(JPGTRUNC*2)

      LOGICAL LFIRST, LNEWUV, LSPECUV
      CHARACTER*3 EXTRA
C
C     Externals
C
      INTEGER FIXAREA, INTFAU, INTFBU, INTUVDH, HSP2GG, IBASINI
      INTEGER HIRLAMW, ISCRSZ, RESET_C, INSANE, INTUVGH
C
      DATA IRGGRID/0/, ISWORK/0/, ITWORK/0/
      SAVE IRGGRID, ISWORK, ITWORK
      DATA LFIRST/.TRUE./, LNEWUV/.TRUE./, EXTRA/'NO '/
      SAVE LFIRST, LNEWUV
C
C     -----------------------------------------------------------------|
C*    Section 1.   Initialise.
C     -----------------------------------------------------------------|
C
  100 CONTINUE
C
      INTVECT = 0


      IF( LFIRST ) THEN
        CALL GETENV('IGNORE_UV_EXTRA_MODE', EXTRA)
        IF((EXTRA(1:1).EQ.'Y').OR.(EXTRA(1:1).EQ.'y')) LNEWUV = .FALSE.
        IF( LNEWUV ) THEN
          CALL INTLOG(JP_DEBUG,
     X      'INTVECT: IGNORE_UV_EXTRA_MODE not turned on',JPQUIET)
        ELSE
          CALL INTLOG(JP_DEBUG,
     X      'INTVECT: IGNORE_UV_EXTRA_MODE turned on',JPQUIET)
        ENDIF
        LFIRST = .FALSE.
      ENDIF
C
      LOLDWIND = LWINDSET
C
C     Ensure that basic initialisation has been done
C
      IRET = IBASINI(0)
      IF( IRET.NE.0 ) THEN
        CALL INTLOG(JP_ERROR,'INTVECT: basic initialise failed',JPQUIET)
        INTVECT = IRET
        GOTO 900
      ENDIF
C
C     Unpack GRIB sections 1 and 2.
C
      ISZVD = 1
      IRET = INTUVDH(DUMMY,ISZVD,PUFIELD,KASIZE,'J',IN_U)
      IF( IRET.NE.0 ) THEN
        CALL INTLOG(JP_ERROR,'INTVECT: GRIB header decode failed',IRET)
        INTVECT = IRET
        GOTO 900
      ENDIF
      NSIZE = ISEC4(1)
      NIREPR = ISEC2(1)
      LSPECUV = (NIREPR.EQ.JPSPHERE).OR.(NIREPR.EQ.JPSPHROT)
      IF( LSPECUV ) NIRESO = ISEC2(2)
C
C     Setup interpolation options from input GRIB characteristics.
C
      IRET = RESET_C(ISEC1, ISEC2, ZSEC2, ISEC4)
      IF( IRET.NE.0 ) THEN
        CALL INTLOG(JP_ERROR,
     X    'INTVECT: Setup interp. options from GRIB failed.',JPQUIET)
        INTVECT = IRET
        GOTO 900
      ENDIF

      IF(NIREPR.EQ.JPREGROT) THEN
        OUTLEN = 0
        IRET   = 0
        CALL INTLOG(JP_DEBUG,
     X    'INTF: Input U and V rotated lat/long fields ...',JPQUIET)
        CALL INTLOG(JP_DEBUG,
     X    'INTF: ... no interpolation has been done',JPQUIET)
        GOTO 900
      ENDIF
C
C       Only allowed rotations are:
C        - spectral to regular lat/long
C        - reduced gaussian to regular lat/long
C
      IF( LNOROTA ) THEN
        IF( ((NOREPR.NE.JPREGROT).AND.(NOREPR.NE.JPREGULAR)).OR.
     X      ((NIREPR.NE.JPSPHERE).AND.(NIREPR.NE.JPQUASI)) ) THEN
          CALL INTLOG(JP_ERROR,
     X      'INTVECT: For vector fields, only allowed rotations are:',
     X      JPQUIET)
          CALL INTLOG(JP_ERROR,
     X      'INTVECT: spectral to regular lat/long, or',JPQUIET)
          CALL INTLOG(JP_ERROR,
     X      'INTVECT: reduced gaussian to regular lat/long',JPQUIET)
          INTVECT = JPROUTINE + 1
          GOTO 900
        ENDIF
      ENDIF
C
C     Check that no outrageous values given for interpolation
C
      ISAME = INSANE()
      IF( (ISAME.GT.0).AND.(ISAME.NE.27261) ) THEN
        CALL INTLOG(JP_ERROR,
     X    'INTVECT: Interpolation cannot use given values.',JPQUIET)
        INTVECT = ISAME
        GOTO 900
      ENDIF
C
      LFRAME = LNOFRAME.AND.
     X         ((NOREPR.EQ.JPREGULAR).OR.(NOREPR.EQ.JPGAUSSIAN).OR.
     X          (NOREPR.EQ.JPREGROT ).OR.(NOREPR.EQ.JPFGGROT  ) )
C
C     Fill area limits (handles case when default 0/0/0/0 given)
C
      IRET = FIXAREA()
      IF( IRET.NE.0 ) THEN
        CALL INTLOG(JP_ERROR,'INTVECT: area fixup failed',JPQUIET)
        INTVECT = JPROUTINE + 3
        GOTO 900
      ENDIF
C
      AREA(1) = REAL(NOAREA(1))/PPMULT
      AREA(2) = REAL(NOAREA(2))/PPMULT
      AREA(3) = REAL(NOAREA(3))/PPMULT
      AREA(4) = REAL(NOAREA(4))/PPMULT
C
      GRID(1) = REAL(NOGRID(1))/PPMULT
      GRID(2) = REAL(NOGRID(2))/PPMULT
C
      IF( LNOROTA ) THEN
        POLE(1) = REAL(NOROTA(1))/PPMULT
        POLE(2) = REAL(NOROTA(2))/PPMULT
        CALL INTLOG(JP_DEBUG,'INTVECT: Rotate the U & V fields',JPQUIET)
        CALL INTLOG(JP_DEBUG,'INTVECT: South pole lat  ',NOROTA(1))
        CALL INTLOG(JP_DEBUG,'INTVECT: South pole long ',NOROTA(2))
      ELSE
        NOROTA(1) = -9000000
        NOROTA(2) = 0
      ENDIF
C
      IF( .NOT. LSPECUV ) GOTO 500
C
C     Get some scratch memory for the U and V fields
C
      ILENF = NSIZE
      ISIZE = ILENF * 2
      CALL JMEMHAN( 11, ISWORK, NSIZE*2, 1, IRET)
      IF( IRET.NE.0 ) THEN
        CALL INTLOG(JP_ERROR,
     X    'INTVECT: memory alloc for scratch memory failed',JPQUIET)
        INTVECT = JPROUTINE + 2
        GOTO 900
      ENDIF
C
C     Unpack U field
C
      NIFORM = 0
      NIPARAM = IN_U
      LWIND = .TRUE.
      LOLDWIND = LWINDSET
      LWINDSET = .TRUE.
C
      IRET = INTUVDH(SWORK,NSIZE,PUFIELD,KASIZE,'D',NIPARAM)
      IF( IRET.NE.0 ) THEN
        CALL INTLOG(JP_ERROR,'INTVECT: Vorticity decoding failed',IRET)
        INTVECT = IRET
        GOTO 900
      ENDIF
      IN_U = ISEC1(6)
C
C     Unpack V field
C
      NIPARAM = IN_V
C
      IRET = INTUVDH(SWORK(1+NSIZE),NSIZE,PVFIELD,KASIZE,'D',NIPARAM)
      IF( IRET.NE.0 ) THEN
        CALL INTLOG(JP_ERROR,'INTVECT: Vorticity decoding failed',IRET)
        INTVECT = IRET
        GOTO 900
      ENDIF
      IN_V = ISEC1(6)
C
      IF( LNOROTA ) GOTO 300
C
C     -----------------------------------------------------------------|
C*    Section 2.   Spectral to grid-point with no rotation
C     -----------------------------------------------------------------|
C
  200 CONTINUE
C
      CALL INTLOG(JP_DEBUG,
     X  'INTVECT: Interpolate U & V fields with no rotation',JPQUIET)
C
      CALL JMEMHAN( 18, ITWORK, ISIZE, 1, IRET)
      IF( IRET.NE.0 ) THEN
        CALL INTLOG(JP_ERROR,
     X    'INTVECT: memory alloc for scratch memory failed',JPQUIET)
        INTVECT = JPROUTINE + 2
        GOTO 900
      ENDIF
C
C     Interpolate U field
C
      IRET = INTFAU(SWORK, NSIZE)
      IF( IRET.NE.0 ) THEN
        CALL INTLOG(JP_ERROR,
     X    'INTVECT: Prepare to interpolate failed.',JPQUIET)
        INTVECT = JPROUTINE + 2
        GOTO 900
      ENDIF
C
      IRET = INTFBU(SWORK, NSIZE, TWORK, ILENF)
      IF( IRET.NE.0 ) THEN
        CALL INTLOG(JP_ERROR,'INTVECT: Interpolation failed.',JPQUIET)
        INTVECT = JPROUTINE + 2
        GOTO 900
      ENDIF
C
C     Interpolate V field
C
      IRET = INTFAU(SWORK(1+NSIZE),NSIZE)
      IF( IRET.NE.0 ) THEN
        CALL INTLOG(JP_ERROR,
     X    'INTVECT: Prepare to interpolate failed.',JPQUIET)
        INTVECT = JPROUTINE + 2
        GOTO 900
      ENDIF
C
      IRET = INTFBU(SWORK(1+NSIZE),NSIZE, TWORK(1+ILENF), ILENF)
      IF( IRET.NE.0 ) THEN
        CALL INTLOG(JP_ERROR,'INTVECT: Interpolation failed.',JPQUIET)
        INTVECT = JPROUTINE + 2
        GOTO 900
      ENDIF
C
      GOTO 700
C
C     -----------------------------------------------------------------|
C*    Section 3.   Spectral to grid-point with rotation
C     -----------------------------------------------------------------|
C
  300 CONTINUE
C
      IF( .NOT.LUSEHIR ) THEN
        CALL INTLOG(JP_ERROR,
     X    'INTVECT : Unable to rotate spectral U or V:',JPQUIET)
        INTVECT  = JPROUTINE + 3
        GOTO 900
      ENDIF
C
C     Convert spectral to suitable global reduced gaussian
C
      NTRUNC = NIRESO
      IRET = HSP2GG(NTRUNC,NGAUSS,KPTS,GLATS,ISIZE)
      IF( IRET.NE.0 ) THEN
        CALL INTLOG(JP_ERROR,
     X    'INTVECT: problem getting data for reduced grid',NTRUNC)
        INTVECT = JPROUTINE + 4
        GOTO 900
      ENDIF
      NCOUNT = ISIZE
C
C     Dynamically allocate memory for global reduced gaussian grid
C
      CALL JMEMHAN( 18, IRGGRID, (NCOUNT*2), 1, IRET)
      IF( IRET.NE.0 ) THEN
        CALL INTLOG(JP_ERROR,
     X    'INTVECT: memory alloc for reduced grid fail',JPQUIET)
        INTVECT = JPROUTINE + 4
        GOTO 900
      ENDIF
C
C     Set flag to show field is a wind component
C
      NUVFLAG = 1
C
C     Create the reduced gaussian grid
C
      HOLDTYP = HOGAUST
      WEST = 0.0
      EAST = 360.0 - (360.0/(NGAUSS*4))
C
C     U component spectral -> reduced gaussian
C
      CALL JAGGGP(SWORK,NTRUNC,GLATS(1),GLATS(NGAUSS*2),WEST,
     X            EAST,NGAUSS,'R',KPTS,RGGRID,NUVFLAG,IRET)
      IF( IRET.NE.0 ) THEN
        CALL INTLOG(JP_ERROR,
     X    'INTVECT: spectral to reduced gaussian failed',JPQUIET)
        INTVECT = JPROUTINE + 4
        GOTO 900
      ENDIF
C
      HOGAUST = HOLDTYP
C
C     V component spectral -> reduced gaussian
C
      CALL JAGGGP(SWORK(1+NSIZE),NTRUNC,GLATS(1),GLATS(NGAUSS*2),WEST,
     X            EAST,NGAUSS,'R',KPTS,RGGRID(1+NCOUNT),NUVFLAG,IRET)
      IF( IRET.NE.0 ) THEN
        CALL INTLOG(JP_ERROR,
     X    'INTVECT: spectral to reduced gaussian failed',JPQUIET)
        INTVECT = JPROUTINE + 4
        GOTO 900
      ENDIF
C
      HOGAUST = HOLDTYP
C
C     Rotate using 12-point horizontal interpolation
C
C     Dynamically allocate memory for rotated lat/long grid
C
      NLON = 1 + NINT((AREA(JPEAST)  - AREA(JPWEST)) /
     X       GRID(JPWESTEP))                  ! SC
      NLAT = 1 + NINT((AREA(JPNORTH) - AREA(JPSOUTH)) /
     X       GRID(JPNSSTEP))                  ! SC
C
      ILENF = NLON * NLAT
      ISIZE  = ILENF * 2
      CALL JMEMHAN( 17, ITWORK, ISIZE, 1, IRET)
      IF( IRET.NE.0 ) THEN
        CALL INTLOG(JP_ERROR,
     X    'INTVECT: memory alloc for lat/long grid fail',JPQUIET)
        INTVECT = JPROUTINE + 6
        GOTO 900
      ENDIF
C
      IRET = HIRLAMW(LO12PT,RGGRID,RGGRID(1+NCOUNT),NCOUNT,NGAUSS,AREA,
     X               POLE,GRID,TWORK,TWORK(1+ILENF),ILENF,NLON,NLAT)
C
      IF( IRET.NE.0 ) THEN
        CALL INTLOG(JP_ERROR,
     X    'INTVECT: HIRLAMW rotation failed',JPQUIET)
        INTVECT = JPROUTINE + 6
        GOTO 900
      ENDIF
C
C     Set the components flag for rotated U and V coefficients
C
      ISEC2(19) = 8
      NOWE = NLON
      NONS = NLAT
C
      GOTO 700
C
C     -----------------------------------------------------------------|
C*    Section 5.   Reduced gaussian to grid-point
C     -----------------------------------------------------------------|
C
  500 CONTINUE
C
      INTVECT =
     X       INTUVGH(PUFIELD,PVFIELD,KASIZE,KUGRIB,KVGRIB,OUTLEN,OUTLEN)
C
      GOTO 900
C
C     -----------------------------------------------------------------|
C*    Section 7.   Pack the fields into GRIB format
C     -----------------------------------------------------------------|
C
  700 CONTINUE
C
C     Reset the input format flag
C
      NIFORM = 1
C
C     If a 'frame' has been specified, build the frame
C
      IF( LFRAME ) THEN
        LOMISSV = LIMISSV
        LIMISSV = .TRUE.
        CALL MKFRAME(NLON,NLAT,TWORK,RMISSGV,NOFRAME)
        CALL MKFRAME(NLON,NLAT,TWORK(1+ILENF),RMISSGV,NOFRAME)
      ENDIF
C
      OUTLENO = OUTLEN
      IRET = INTUVDH(TWORK,ILENF,KUGRIB,OUTLEN,'C',IN_U)
      IF( IRET.NE.0 ) THEN
        CALL INTLOG(JP_ERROR,
     X    'INTVECT: Wind component into GRIB encoding fail',IRET)
        INTVECT = JPROUTINE + 7
        GOTO 900
      ENDIF

C
      OUTLEN = OUTLENO
      IRET = INTUVDH(TWORK(1+ILENF),ILENF,KVGRIB,OUTLEN,'C',IN_V)
      IF( IRET.NE.0 ) THEN
        CALL INTLOG(JP_ERROR,
     X    'INTVECT: Wind component into GRIB encoding fail',IRET)
        INTVECT = JPROUTINE + 7
        GOTO 900
      ENDIF
C
      IF( LFRAME ) LIMISSV = LOMISSV
C
C     -----------------------------------------------------------------|
C*    Section 9.   Return
C     -----------------------------------------------------------------|
C
  900 CONTINUE
C
      RETURN
      END

C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

       SUBROUTINE RPHI( DATA, NM, WORK, SLON)
C
C---->
C**** RPHI
C
C     Purpose
C     -------
C
C     Rotates spectral coefficients by longitude.
C
C
C     Interface
C     ---------
C
C     CALL RPHI(DATA,NM,WORK,SLON)
C
C     Input
C     -----
C
C     DATA   = Input spectral field of REAL*8s of size (NM+1)*(NM+2).
C     NM     = Triangular truncation (e.g. 106)
C     WORK   = Work space of size at least 2*(NM+1).
C     SLON   = Rotation angle (REAL*8).
C              (degrees, positive => rotate west to east). 
C
C     Output
C     ------
C
C     Transformed fields are returned in data.
C
C
C     Method
C     ------
C
C     See reference below.
C
C
C     Externals
C     ---------
C
C     None.
C
C
C     Author
C     ------
C
C     R.McGrath and P.Lynch    HIRLAM
C
C
C     Reference.
C     ----------
C
C     "Spectral synthesis on rotated and regular grids"
C     by P.Lynch and R.McGrath (Irish Meteorological Service).
C
C
C     Modifications
C     -------------
C
C     J.D.Chambers       ECMWF     October 1995
C     Reformat and put into clearcase.
C
C ------------------------------------------------------------------
C----<
C
      IMPLICIT NONE
C
#include "jparams.h"
C
C     Function arguments
      COMPLEX*16 DATA
      COMPLEX*16 WORK
      DIMENSION DATA(*), WORK(*)
      REAL*8 SLON
      INTEGER NM
C
C     Parameters
      INTEGER JPROUTINE
      PARAMETER (JPROUTINE = 26000 )
C
C     Local variables
      COMPLEX*16 CC
      INTEGER I, IPMN, NS, M, J
      REAL*8 RAD, XLON
C
C ------------------------------------------------------------------
C*    Section 1.   Initialise
C ------------------------------------------------------------------
C
  100 CONTINUE
C
      IPMN = ((NM+1)*(NM+2))/2
      RAD  = 180.0/PPI
      XLON = -SLON/RAD
C
C ------------------------------------------------------------------
C*    Section 2.   Transform the fields.
C ------------------------------------------------------------------
C
  200 CONTINUE
C
      NS = 1
      CC = (1.0,0.0)
C
      DO 215 M = 1,NM+1
        DO 210 J = NS,NS+NM-M+1
          WORK(J) = CC
  210   CONTINUE
C
        NS = J
        CC = CEXP(CMPLX(0.0,REAL(XLON*M)))
  215 CONTINUE
C
C     Transform fields in output array.
        DO 220 J = 1,IPMN
          DATA(J) = WORK(J)*DATA(J)
  220   CONTINUE
C
C ------------------------------------------------------------------
C*    Section 9.   Return.
C ------------------------------------------------------------------
C
  900 CONTINUE
C
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE UNCMPCK(PSPEC,KTRUNC,KTRUNCNP)
C
C---->
C**** UNCMPCK
C
C     Purpose.
C     --------
C
C     Puts spectral coefficients in contiguous locations.
C
C
C**   Interface.
C     ----------
C
C     CALL UNCMPCK(PSPEC,KTRUNC,KTRUNCNP)
C
C
C     Input Parameters.
C     -----------------
C
C     PSPEC      - Array of spectral coefficients.
C     KTRUNC     - Truncation of the spherical harmonic coefficients.
C     KTRUNCNP   - Truncation of the subset of spherical harmonic
C                  coefficients to be re-inserted..
C
C
C     Output Parameters.
C     -----------------
C
C     PSPEC      - Array of spectral coefficients rearranged.
C
C
C     Method.
C     -------
C
C     Given the values CCCCCC...C , contiguous in array PSPEC,
C     rearranges them to leave slots for the subset of spectral
C     coefficients to be re-inserted..
C
C                            <subset>|
C
C     Thus:                  cccccccc|CCCCCC
C                              cccccc|CCCCCC
C                                cccc|CCCCCC
C                                  cc|CCCCCC
C                                    |CCCCCC
C                                       CCCC
C                                         CC
C
C     Externals.
C     ----------
C
C     None.
C
C
C     Reference.
C     ----------
C
C     None.
C
C
C     Comments.
C     --------
C
C     None.
C
C
C     Author.
C     -------
C
C     M.Hamrut         ECMWF      09:05:94
C
C
C     Modifications.
C     _____________
C
C     None.
C
C
C----<
C     -----------------------------------------------------------------
C*    Section 0. Definition of variables.
C     -----------------------------------------------------------------
C
      IMPLICIT NONE
C
C     Subroutine arguments
      INTEGER KTRUNC,KTRUNCNP
      REAL PSPEC((KTRUNC+1)*(KTRUNC+2))
C
C     Local variables.
      INTEGER IMAXP, IMAXUP, IUC, IC, JM, JN, IL2, IL1, ILEN
C
C     -----------------------------------------------------------------
C*    Section 1. Rearrange the values.
C     -----------------------------------------------------------------
C
      IMAXP  = (KTRUNC+1)*(KTRUNC+2)
      IMAXUP = (KTRUNC+1)*(KTRUNC+2)-(KTRUNCNP+1)*(KTRUNCNP+2) 
      IUC = IMAXP+1
      IC  = IMAXUP+1
C
C     Loop through rows, starting at end and working backwards.
      DO 102 JM=KTRUNC,0,-1
C
C       In each row calculate value to start with.
C       For early rows, there are some values to skip to leave slots
C       for the subset being re-instated.
        IL2=MAX(JM,KTRUNCNP+1)
        IL1=IL2-1
        ILEN=2*(KTRUNC-IL2+1)
C
C       Move values for the row.
CDIR$ IVDEP      
        DO 104 JN=1,ILEN
          IUC = IUC-1
          IC  = IC-1
          PSPEC(IUC) = PSPEC(IC)
 104    CONTINUE     
C
        IUC = IUC-MAX((IL1-JM+1)*2,0)
 102  CONTINUE
C
C     -----------------------------------------------------------------
C*    Section 9. Return.
C     -----------------------------------------------------------------
C
  900 CONTINUE
C
      RETURN
      END        

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

#ifdef CRAY
      SUBROUTINE UNBLOCK (UN1,UN2,IRET)
C
C---->
C**********************************************************************
C*                                                                    *
C*    NAME      : UNBLOCK                                             *
C*                                                                    *
C*    FUNCTION  : CONVERTS CRAY BLOCKED DATASET OF GRIB DATA INTO AN  *
C*                UNBLOCKED DATASET                                   *
C*                                                                    *
C*    INPUT     : UN1   = INPUT  LUN                                  *
C*                UN2   = OUTPUT LUN                                  *
C*                                                                    *
C*    OUTPUT    : IRET  = -100   BUFFER IN  ERROR                     *
C*                      = -200   BUFFER OUT ERROR                     *
C*                      > 0      NO. OF BLOCKS WRITTEN                *
C*                                                                    *
C*    GENERAL   : UNBLOCK CALLS   -----                               *
C*                                                                    *
C*    AUTHOR    : B.V. GURETZKY     V.E. DAY                          *
C*                                                                    *
C*    MODIFIED  : J. HENNESSY       26.11.85                          *
C*                                                                    *
C**********************************************************************
C----<
C
      IMPLICIT INTEGER (B,U)
      PARAMETER (BLEN=25088)
      DIMENSION BUF(BLEN+512)
C
C     NO OF WORDS PER BLOCK (UNBLOCKED DATASET ICB = 512 )
      DATA ICB /512/
C
      IRET = 0
      IRES = 0
C
      DO 5000 J = 1,10000
C
C        READ INPUT FILE RECORD.
C
         BUFFER IN (UN1,0) (BUF(IRES+1),BUF(BLEN+ICB))
         IUNIT = UNIT(UN1)
         IF (UNIT(UN1)) 1000,5500,10000
 1000    CONTINUE

         LEN  = IRES + LENGTH(UN1)
         K    = LEN  / ICB
         IE   = K    * ICB
         IRES = LEN  - IE
C
         IF (K.NE.0)
     C      THEN
C
C               WRITE FIRST CHUNK OF ICB-BLOCKS
C
                BUFFER OUT (UN2,0) (BUF(1),BUF(IE))
                IUNIT = UNIT(UN2)
                IF (IUNIT.GT.0) GO TO 10100
                IRET = IRET + K
C
C               MOVE REMAINDER OF BLOCK TO FRONT AND GET NEXT RECORD.
C
                DO 4000 I = 1,IRES
                   BUF(I) = BUF(IE+I)
 4000           CONTINUE
C
            ENDIF
C
 5000 CONTINUE
C
C
C     HANDLE LAST BLOCK, SETTING UNUSED WORDS OF LAST BLOCK TO 0.
C
 5500 IF (IRES.NE.0)
     C   THEN
             IRES = IRES + 1
             DO 6000 I = IRES,ICB
                BUF(I) = 0
 6000        CONTINUE
             BUFFER OUT (UN2,0)(BUF(1),BUF(ICB))
             IUNIT = UNIT(UN2)
             IF (IUNIT.GT.0) GO TO 10100
             IRET = IRET + 1
         ENDIF
C
      RETURN
C
10000 CONTINUE
      IRET = -100
      WRITE (*,*) 'UNBLOCK : BUFFER IN ERROR'
      RETURN
C
10100 CONTINUE
      IRET = -200
      WRITE (*,*) 'UNBLOCK : BUFFER OUT ERROR'
      RETURN
C
      END
#endif

C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C


      SUBROUTINE PRTBK2 (IB2PAR)
C
C---->
C
C     NAME      : PRTBK2
C
C     FUNCTION  : PRINT THE INFORMATION IN THE GRDI DEFINITION
C                 BLOCK (BLOCK 2) OF DECODED GRIB DATA.
C
C     INPUT     : IB2PAR - ARRAY OF DECODED PARAMETERS FROM BLOCK 2.
C
C     OUTPUT    : FLAG FIELDS ARE PRINTED IN BINARY REPRESENTATION.
C                 OTHER FIELDS AS INTEGERS.
C
C     JOHN HENNESSY  ECMWF OCTOBER 1985
C
C     Modifications.
C     --------------
C
C         J. Hennessy   ECMWF  23:11:90
C         Output changed from all upper-case.
C
C     ---------------------------------------------------------------
C----<
C
      IMPLICIT INTEGER (A-Z)
C
      DIMENSION IB2PAR(*)
C
      WRITE (*,'(1H )')
      WRITE (*,9000)
 9000 FORMAT (1H ,'Section 2 - Grid definition section.')
C
      WRITE (*,'(1H )')
      WRITE (*,9001) IB2PAR(1)
 9001 FORMAT (1H ,'Data representation type (Table 6)   ',I9)
C
C     SPHERICAL HARMONIC DATA
C
      IF (IB2PAR(1).EQ.50)
     C   THEN
C
             WRITE (*,9002) IB2PAR(2)
 9002        FORMAT (1H ,'J - Pentagonal resolution parameter. ',I9)
             WRITE (*,9003) IB2PAR(3)
 9003        FORMAT (1H ,'K - Pentagonal resolution parameter. ',I9)
             WRITE (*,9004) IB2PAR(4)
 9004        FORMAT (1H ,'M - Pentagonal resolution parameter. ',I9)
             WRITE (*,9005) IB2PAR(5)
 9005        FORMAT (1H ,'Representation type (Table 9)        ',I9)
             WRITE (*,9006) IB2PAR(6)
 9006        FORMAT (1H ,'Representation mode (Table 10).      ',I9)
             WRITE (*,9007) (IB2PAR(I),I=7,11)
 9007        FORMAT (1H ,'Not used.                            ',I9)
C
             RETURN
C
         ENDIF
C
C     GAUSSIAN AND REGULAR LATITUDE / LONGITUDE GRIDS.
C
      IF (IB2PAR(1).EQ.0.OR.IB2PAR(1).EQ.4)
     C   THEN
C
             WRITE (*,9102) IB2PAR(2)
 9102        FORMAT (1H ,'No. of points along a latitude.      ',I9)
             WRITE (*,9103) IB2PAR(3)
 9103        FORMAT (1H ,'No. of points along a meridian.      ',I9)
             WRITE (*,9104) IB2PAR(4)
 9104        FORMAT (1H ,'Latitude of origin.                  ',I9)
	     WRITE (*,9200)
 9200        FORMAT (1H ,'(Southern latitudes are negative.)')
             WRITE (*,9105) IB2PAR(5)
 9105        FORMAT (1H ,'Longitude of origin.                 ',I9)
	     WRITE (*,9201)
 9201        FORMAT (1H ,'(Western longitudes are negative.)')
             NBIT = 8
             CALL PRTBIN (IB2PAR(6),NBIT,OUT,ERR)
             WRITE (*,9106) OUT
 9106        FORMAT (1H ,'Resolution flag.                      ',I8.8)
             WRITE (*,9107) IB2PAR(7)
 9107        FORMAT (1H ,'Latitude of extreme point.           ',I9)
	     WRITE (*,9200)
             WRITE (*,9108) IB2PAR(8)
 9108        FORMAT (1H ,'Longitude of extreme point.          ',I9)
	     WRITE (*,9201)
             WRITE (*,9109) IB2PAR(9)
 9109        FORMAT (1H ,'East-West increment.                 ',I9)
             IF (IB2PAR(1).EQ.0)
     C          THEN
                    WRITE (*,9110) IB2PAR(10)
 9110               FORMAT (1H ,'North-South increment.               ',
     C                         I9)
                ENDIF
             IF (IB2PAR(1).EQ.4)
     C          THEN
                    WRITE (*,8110) IB2PAR(10)
 8110               FORMAT(1H ,'No. of latitude lines pole / equator.',
     C                         I9)
                ENDIF
             NBIT = 8
             CALL PRTBIN (IB2PAR(11),NBIT,OUT,ERR)
             WRITE (*,9111) OUT
 9111        FORMAT (1H ,'Scanning mode flags (Code Table 8)    ',I8.8)
C
             RETURN
C
         ENDIF
C
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE GET_TABLES1(K)
C
C**** *GET_TABLES1*
C
C
C     PURPOSE.
C     --------
C          GET TABLES FROM THE ARRAY OF TABLES FOR
C          ENCODING
C
C**   INTERFACE.
C     ----------
C          NONE.
C
C
C     *METHOD.
C      -------
C          NONE.
C
C
C     EXTERNALS.
C     ----------
C          NONE.
C
C
C
C
C     REFERENCE.
C     ----------
C
C          BINARY UNIVERSAL FORM FOR DATA REPRESENTATION, FM 94 BUFR.
C
C          J.K.GIBSON AND M.DRAGOSAVAC,1987: DECODING DATA 
C          REPRESENTATION FM 94 BUFR,TECHNICAL MEMORANDUM NO.
C
C          J.K.GIBSON,1986:EMOS 2 - STANDARDS FOR SOFTWARE DEVELOPMENT
C          AND MAINTANANCE ,TECHICAL MEMORANDUM NO.       ECMWF.
C
C
C     AUTHOR.
C     -------
C
C          M. DRAGOSAVAC       *ECMWF*       JANUARY 2007
C
C
C     MODIFICATIONS.
C     --------------
C
C          NONE.
C
C
      IMPLICIT LOGICAL(L,O,G), CHARACTER*8(C,H,Y)
C
#     include "parameter.F"
#     include "bcmtab.F"
#     include "bcmtabc.F"
#     include "bcmtabload.F"
#     include "bcmtabloadc.F"

C
      CHARACTER*64 CTABBEN,CCTABBEN
      CHARACTER*24 CTABBU,CCTABBU,CTABLE_LIST
C
C     ------------------------------------------------------------------
C*          1.   INITIALIZE CONSTANTS AND VARIABLES.
C                -----------------------------------
 100  CONTINUE
C
C
      IF(K.LT.1.OR.K.GT.JTMAX) THEN
         print*,'Table number > JTMAX'
         call exit(2)
      END IF
      DO 101 I=1,64
      DO 101 ii=1,255
      NTABP(I,II)=MTABP(I,II,K)
 101  CONTINUE
C
      DO 102 I=1,JTAB
      NTABBTR(I)=MTABBTR(I,K)
      NTABBS (I)=MTABBS (I,K)
      NTABBRV(I)=MTABBRV(I,K)
      NTABBDW(I)=MTABBDW(I,K)
      CTABBEN(I)=CCTABBEN(I,K)
      CTABBU (I)=CCTABBU(I,K)
      NTABDTR(I)=MTABDTR(I,K)
      NTABDL (I)=MTABDL(I,K)
      NTABDST(I)=MTABDST(I,K)
 102  CONTINUE

      DO I=1,JTAB*20
      NTABDSQ(I)=MTABDSQ(I,K)
      END DO
C
C     ------------------------------------------------------------------
      RETURN
      END

C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      INTEGER FUNCTION IRGMEM (KPR, KERR)
C
C---->
C**** *IRGMEM*
C
C     PURPOSE
C     _______
C
C     This routine acquires heap space for quasi regular to regular
C     interpolation.
C
C     INTERFACE
C     _________
C
C     IERR = IRGMEM (KPR, KERR)
C
C     Input parameters
C     ________________
C
C     KPR        - The debug print switch.
C                  0  , No debugging output.
C                  1  , Produce debugging output.
C
C     KERR       - The error control flag.
C                  -ve, No error message. Return error code.
C                  0  , Hard failure with error message.
C                  +ve, Print error message. Return error code.
C
C     Output parameters
C     ________________
C
C     None
C
C     Return value
C     ____________
C
C     The error indicator (INTEGER).
C
C     Error and Warning Return Values
C     _______________________________
C
C     None
C
C     Common block usage
C     __________________
C
C     nifld.common - This file contains all the input field
C                    definition variables.
C
C     NINS         - Number of grid points in NS direction for input
C                    field (used in grspace.h).
C     NIWE         - Number of grid points in WE direction for input
C                    field (used in grspace.h).
C
C     nofld.common - This file contains all the output field
C                    definition variables.
C
C     NONS         - Number of grid points in NS direction for output
C                    field (used in grspace.h).
C     NOWE         - Number of grid points in WE direction for output
C                    field (used in grspace.h).
C
C     grspace.h    - This file contains all the work space array
C                    definitions for grid point to grid point
C                    interpolation.
C
C     GRID_POINT
C
C     NILATGP      - POINTER to array MILATG.
C     NILONGP      - POINTER to array MILONG.
C     NILSMP       - POINTER to array MILSM.
C     NINPNTP      - POINTER to array RINPNT.
C     NISTRTP      - POINTER to array MISTRT.
C     NNSDISTP     - POINTER to array MNSDIST.
C     NNSINDP      - POINTER to array MNSIND.
C     NMAXP        - POINTER to array RMAX.
C     NOLATGP      - POINTER to array MOLATG.
C     NOLONGP      - POINTER to array MOLONG.
C     NOLSMP       - POINTER to array MOLSM.
C     NWEDISTP     - POINTER to array MWEDIST.
C     NWEINDP      - POINTER to array MWEIND.
C     NWFACTP      - POINTER to array WFACT.
C
C     MILATG       - Dynamic array of length (NINS) (see nifld.common)
C                    which holds the values of the input field
C                    latitudes.
C     MILONG       - Dynamic array of length (NIWE + 1) (see
C                    nifld.common) which holds the values of the
C                    input field longitudes.
C     MILSM        - Dynamic array of length (NIWE, 2) (see
C                    nifld.common) used in calculating the effects of
C                    the land sea mask on interpolation.
C     MISTRT       - Dynamic array of length (NINS) (see nifld.common)
C                    which holds the array offsets of the start of
C                    each latitude line for a quasi regular Gaussian
C                    input field. No space is assigned to this array
C                    for a regular input field.
C     MNSDIST      - Dynamic array of length (2, NONS) (see
C                    nofld.common) which holds the distances to
C                    neighbouring latitude lines of the input field
C                    from the associated line of latitude in the
C                    output field.
C     MNSIND       - Dynamic array of length (2, NONS) (see
C                    nofld.common) which holds the latitude line
C                    numbers (array offset) of the input field
C                    associated with each line of latitude in the
C                    output field.
C     MOLATG       - Dynamic array of length (NONS) (see nofld.common)
C                    which holds the values of the output field
C                    latitudes.
C     MOLONG       - Dynamic array of length (NOWE) (see nofld.common)
C                    which holds the values of the output field
C                    longitudes.
C     MOLSM        - Dynamic array of length (NOWE) (see nofld.common)
C                    used in calculating the effects of the land sea
C                    mask on interpolation.
C     MWEDIST      - Dynamic array of length (2, NONS) (see
C                    nofld.common) for a regular input field and of
C                    length (2, 2 * NONS * NOWE) (see nofld.common)
C                    for a quasi regular Gaussian input field. This
C                    array holds the distances to neighbouring
C                    longitude points of the input field from the
C                    associated longitude points in the output field.
C     MWEIND       - Dynamic array of length (2, NONS) (see
C                    nofld.common) for a regular input field and of
C                    length (2, 2 * NONS * NOWE) (see nofld.common)
C                    for a quasi regular Gaussian input field. This
C                    array holds the longitude points (array offset)
C                    from the input field associated with each
C                    longitude point in the output field.
C     RINPNT       - Dynamic array of length (NOWE) (see nofld.common)
C                    used to aid vectorisation in processing
C                    precipitation fields.
C     RMAX         - Dynamic array of length (NOWE) (see nofld.common)
C                    used to aid vectorisation in processing
C                    precipitation fields.
C     WFACT        - Dynamic array of length (4, NOWE * NONS) (see
C                    nofld.common) which holds the interpolation
C                    weights for each point in the output field.
C
C     EXTERNALS
C     _________
C
C     IGALLOC    - Get a heap allocation for array space.
C     INTLOG(R)  - Logs messages.
C
C     METHOD
C     ______
C
C     This routine first calculates how much heap space is required.
C     IGALLOC is then used to acquire the required space. Finally the
C     POINTERs are initialised to allow use of the dynamic arrays.
C
C     REFERENCE
C     _________
C
C     None
C
C     COMMENTS
C     ________
C
C     Program contains sections 0 to 3 and 9
C
C     AUTHOR
C     ______
C
C     K. Fielding      *ECMWF*      Jan 1994
C
C     MODIFICATIONS
C     _____________
C
C     None
C
C----<
C     -----------------------------------------------------------------|
C*    Section 0. Definition of variables.
C     -----------------------------------------------------------------|
C
      IMPLICIT NONE
C
#include "parim.h"
#include "nifld.common"
#include "nofld.common"
#include "grspace.h"
C
C     Dummy arguments
C
      INTEGER*8 WORK
      INTEGER*8 DELTA
      INTEGER*8 OFFSET

      INTEGER KPR, KERR
C
C     Local variables
C
#ifdef POINTER_64
      INTEGER*8 IBASE
#else
      INTEGER IBASE
#endif
      INTEGER IREQUEST, IERR
      INTEGER JPROUTINE
      PARAMETER (JPROUTINE = 23100)
C
C     External functions
C
      INTEGER IGALLOC
C
C     -----------------------------------------------------------------|
C*    Section 1. Initialisation
C     -----------------------------------------------------------------|
C
  100 CONTINUE
C
      IF( KPR.GE.1 ) CALL INTLOG(JP_DEBUG,'IRGMEM: Section 1.',JPQUIET)
C
      IRGMEM = 0
C
C     -----------------------------------------------------------------|
C*    Section 2. Calculate memory required and get heap
C     -----------------------------------------------------------------|
C
  200 CONTINUE
C
      IF( KPR.GE.1 ) CALL INTLOG(JP_DEBUG,'IRGMEM: Section 2.',JPQUIET)
C
C     REAL arrays (This may change for double precision version)
C
      IREQUEST = 4 * NOWE * NONS * JPRLEN
C
C     Fields for precipitation calculations
C
      IREQUEST = IREQUEST + 2 * NOWE * JPRLEN
C
C     Fixed integer fields
C
      IREQUEST = IREQUEST + (NIWE + 1 + NINS + NOWE + 5 * NONS) *
     1  JPILEN
C
C     Reduced Gaussian input fields (These change for regular fields)
C
      IREQUEST = IREQUEST + (8 * NOWE * NONS + NINS) * JPILEN
C
C     Fields for LSM calculations
C
      IREQUEST = IREQUEST + (2 * NIWE + NOWE) * JPILEN
C
C     Get the required memory
C
      IERR = IGALLOC (JPINNER, IREQUEST, IBASE, KPR, KERR)
C
      IF( IERR.GT.0 ) THEN
         IRGMEM = IERR
         GOTO 900
      ENDIF
C
C     -----------------------------------------------------------------|
C*    Section 3. Initialise base addresses for POINTER arrays
C     -----------------------------------------------------------------|
C
  300 CONTINUE
C
      IF( KPR.GE.1 ) CALL INTLOG(JP_DEBUG,'IRGMEM: Section 3.',JPQUIET)
C
C     REAL arrays first to ease conversion to DOUBLE PRECISION
C
      NWFACTP = IBASE
C
C     Precipitation REAL arrays
C
C     We are having trouble when using POINTER values in arithmetic
C     where we get overflow when we don't expect it. Like the POINTER
C     is interpreted as a 32-bit length value. For that reason we 
C     calculate an OFFSET and add DELTA values to it before reading
C     its value out into the various base addresses which are then not
C     used again in further calculations.


      OFFSET = NWFACTP + 4 * NOWE * NONS * JPRLEN
      NMAXP = OFFSET
C      NMAXP = NWFACTP + 4 * NOWE * NONS * JPRLEN

      DELTA = NOWE * JPRLEN
      OFFSET = OFFSET + DELTA
      NINPNTP = OFFSET
C      NINPNTP = NMAXP + NOWE * JPRLEN

C
C     This offset may change if DOUBLE PRECISION
C
      DELTA = NOWE * JPRLEN
      OFFSET = OFFSET + DELTA
      NILONGP = OFFSET      
C      NILONGP = NINPNTP + NOWE * JPRLEN

C
      DELTA = (NIWE + 1) * JPILEN
      OFFSET = OFFSET + DELTA
      NILATGP = OFFSET
C      NILATGP  = NILONGP + (NIWE + 1) * JPILEN

      DELTA = NINS * JPILEN
      OFFSET = OFFSET + DELTA
      NOLONGP = OFFSET
C      NOLONGP = NILATGP + NINS * JPILEN

      DELTA = NOWE * JPILEN
      OFFSET = OFFSET + DELTA
      NOLATGP = OFFSET
C      NOLATGP  = NOLONGP + NOWE * JPILEN

      DELTA = NONS * JPILEN
      OFFSET = OFFSET + DELTA
      NNSINDP = OFFSET      
C      NNSINDP = NOLATGP + NONS * JPILEN

      DELTA = 2 * NONS * JPILEN
      OFFSET = OFFSET + DELTA
      NNSDISTP = OFFSET
C      NNSDISTP = NNSINDP + 2 * NONS * JPILEN

C
      DELTA = 2 * NONS * JPILEN
      OFFSET = OFFSET + DELTA
      NWEINDP = OFFSET
C      NWEINDP = NNSDISTP  + 2 * NONS * JPILEN

      DELTA = 4 * NOWE * NONS * JPILEN
      OFFSET = OFFSET + DELTA
      NWEDISTP = OFFSET
C      NWEDISTP = NWEINDP + 4 * NOWE * NONS * JPILEN
      
      DELTA = 4 * NOWE * NONS * JPILEN
      OFFSET = OFFSET + DELTA
      NISTRTP = OFFSET
C      NISTRTP  = NWEDISTP + 4 * NOWE * NONS * JPILEN

C
C     LSM arrays
C
      DELTA = NINS * JPILEN
      OFFSET = OFFSET + DELTA
      NILSMP = OFFSET
c      NILSMP = NISTRTP + NINS * JPILEN

      DELTA = 2 * NIWE * JPILEN
      OFFSET = OFFSET + DELTA
      NOLSMP = OFFSET
c      NOLSMP = NILSMP + 2 * NIWE * JPILEN
         
C
      IF( KPR.GE.1 ) THEN
        CALL INTLOG(JP_DEBUG,'IRGMEM: ************************',JPQUIET)
        CALL INTLOG(JP_DEBUG,'IRGMEM: * Some address values',JPQUIET)
        CALL INTLOG(JP_DEBUG,'IRGMEM: * may display overflowed',JPQUIET)
        CALL INTLOG(JP_DEBUG,'IRGMEM: * when printed to screen',JPQUIET)
        CALL INTLOG(JP_DEBUG,'IRGMEM: ************************',JPQUIET)
        CALL INTLOG(JP_DEBUG,'IRGMEM: Output base addresses.',JPQUIET)
        CALL INTLOG(JP_DEBUG,'IRGMEM: WFACT address = ',NWFACTP)
        CALL INTLOG(JP_DEBUG,'IRGMEM: RMAX address = ',NMAXP)
        CALL INTLOG(JP_DEBUG,'IRGMEM: RINPNT address = ',NINPNTP)
        CALL INTLOG(JP_DEBUG,'IRGMEM: Input long.address = ',NILONGP)
        CALL INTLOG(JP_DEBUG,'IRGMEM: Input lat.address = ',NILATGP)
        CALL INTLOG(JP_DEBUG,'IRGMEM: Output long.address = ',NOLONGP)
        CALL INTLOG(JP_DEBUG,'IRGMEM: Output lat.address = ',NOLATGP)
        CALL INTLOG(JP_DEBUG,'IRGMEM: NS offset address = ',NNSINDP)
        CALL INTLOG(JP_DEBUG,'IRGMEM: NS distance address = ',NNSDISTP)
        CALL INTLOG(JP_DEBUG,'IRGMEM: WE offset address = ',NWEINDP)
        CALL INTLOG(JP_DEBUG,'IRGMEM: WE distance address = ',NWEDISTP)
        CALL INTLOG(JP_DEBUG,'IRGMEM: Line start array addr.= ',NISTRTP)
        CALL INTLOG(JP_DEBUG,'IRGMEM: Input LSM address = ',NILSMP)
        CALL INTLOG(JP_DEBUG,'IRGMEM: Output LSM address = ',NOLSMP)
        
      ENDIF
C

C     -----------------------------------------------------------------|
C*    Section 9. Return to calling routine. Format statements
C     -----------------------------------------------------------------|
C
  900 CONTINUE
C
      IF( KPR.GE.1 ) CALL INTLOG(JP_DEBUG,'IRGMEM: Section 9.',JPQUIET)
C
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities
C granted to it by virtue of its status as an intergovernmental organisation
C nor does it submit to any jurisdiction.
C

      LOGICAL FUNCTION ISSAMERARRAY(N1,AN1,N2,AN2)
C
C---->
C**** *ISSAMERARRAY*
C
C     PURPOSE
C     _______
C
C     Check if two real arrays have the same entries.
C
C
C     Input parameters
C     ________________
C
C     N1   - Array 1 length
C     AN1  - Array 1 entries (real values)
C     N2   - Array 2 length
C     AN2  - Array 2 entries (real values)
C
C----<
      IMPLICIT NONE
      INTEGER N1, AN1(*), N2, AN2(*)
      INTEGER I


C     Cover special cases
      ISSAMERARRAY =
     X  N1.GT.0 .AND.
     X  N2.GT.0 .AND.
     X  N1.EQ.N2


C     Iterate through entries, failing on first difference
      I = 1
      DO WHILE (ISSAMERARRAY .AND. I.LE.N1)
        ISSAMERARRAY = AN1(I).EQ.AN2(I)
        I = I+1
      ENDDO

      END FUNCTION

#define MISSING -55555.0

      PROGRAM CMPGFS
      IMPLICIT NONE
C
      INTEGER JPACK, JPMXOPT
      PARAMETER (JPACK=1080000)
      PARAMETER (JPMXOPT=10)
C
      INTEGER IS0,IS1,IS2,IS3,IS4,IEDITN,LENGTH
      INTEGER JS0,JS1,JS2,JS3,JS4,JEDITN,IZERO
      INTEGER KRET, LENOUT1, LENOUT2, IWORD, LOOP, N, ICOUNT, ILEVEL
      INTEGER NVALS1, NVALS2, ISTATUS, ITOTAL1, ITOTAL2
      INTEGER NFAILS, NFAIL1
      INTEGER NEXT1, NEXT2, ILIST(36)
      INTEGER ISEC0(2), ISEC1(1024), ISEC2(1024), ISEC3(2), ISEC4(1024)
      INTEGER JSEC0(2), JSEC1(1024), JSEC2(1024), JSEC3(2), JSEC4(1024)
      INTEGER INBUFF1(JPACK), INBUFF2(JPACK)
      REAL ZSEC2(1024), ZSEC3(2), ARRAY1(1500000), ARRAY2(1500000)
      REAL WSEC2(1024)
      REAL V1, V2, DIFF
      LOGICAL LLEVEL, LFAIL, LFAIL1, LRANDOM, LPRINT, LDIFF
      LOGICAL LBIT2BT, LBIT4BT
C
      CHARACTER*128 COMPFILE1, COMPFILE2, OPTIONS(JPMXOPT)
      INTEGER IARGC
      EXTERNAL IARGC, GETENV
      INTEGER FILE1, FILE2, JCOUNT, ILENB, IPUNP
      REAL MAXVAL1,MAXVAL2, MAXDIFF, MAXPERC, MEAN, TOLERNC, MARGIN
      REAL MAXDV1, MAXDV2
      REAL MINVAL1,MINVAL2, AVERAGE1, AVERAGE2
C
C     Externals
C
      INTEGER PBXTOTL, PBXGET, PBXXFIND, JMEMCMP, SOFFSET
C
C     Statement function
C
      REAL A, B
      LOGICAL NOTEQ
      NOTEQ(A,B) = (ABS((A)-(B)).GT.1E-3)
C
C     -----------------------------------------------------------------|
C     Handle command line
C     -----------------------------------------------------------------|
C
      JCOUNT = IARGC()
C
C     Help output (and exit)
C
      IF( JCOUNT.EQ.0 ) THEN
        WRITE(*,*) 'Usage: compareGribFiles [options] file1 file2'
        WRITE(*,*) '       where options are:'
        WRITE(*,*) '     -pN      for printout level N,'
        WRITE(*,*) '              N = 0 for no printout'
        WRITE(*,*) '              N = 1, 2, .. for increasing detail'
        WRITE(*,*) '              Default N = 1'
        WRITE(*,*) '     -tX      to specify a tolerance percentage'
        WRITE(*,*) '              for comparing field values. X must'
        WRITE(*,*) '              be a real number, eg 5.0'
        WRITE(*,*) '              Default X = 0.0'
        WRITE(*,*) '     -fail    if compare to stop after a failing'
        WRITE(*,*) '              comparison.'
        WRITE(*,*) '              Default is to continue.'
        WRITE(*,*) '     -bit2bit for a bit to bit comparison between'
        WRITE(*,*) '              GRIBS headers in the two files'
        WRITE(*,*) '     -bit4bit for a bit for bit comparison between'
        WRITE(*,*) '              GRIBS in the two files'
        WRITE(*,*) '     -random  if the GRIB products are in a'
        WRITE(*,*) '              different order on the two files.'
        WRITE(*,*) '              Default is to assume the same order.'
        WRITE(*,*) ' '
        WRITE(*,*) 'The return status is 0 if the values in the GRIBs'
        WRITE(*,*) 'in are within the given tolerance.'
        WRITE(*,*) 'Otherwise, the return status is 1.'
        WRITE(*,*) ' '
        ISTATUS = 1
        GOTO 990
      ENDIF
C
C     Check usage (and exit)
C
      IF( JCOUNT.LT.2 ) THEN
        WRITE(*,*) 'Usage: compare [options] file1 file2'
        ISTATUS = 1
        GOTO 990
      ENDIF
C
      IF( JCOUNT.GT.2 ) THEN
        IF( JCOUNT.GT.(JPMXOPT+2) ) THEN
          WRITE(*,*) 'Too many options on command line, max = ', JPMXOPT
          ISTATUS = 1
          GOTO 990
        ENDIF
        DO LOOP = 1, (JCOUNT-2)
          CALL GETARG(LOOP,OPTIONS(LOOP))
        ENDDO
      ENDIF
C
      CALL GETARG((JCOUNT-1),COMPFILE1)
      CALL GETARG(JCOUNT,COMPFILE2)
C
C     Default tolerance and print output level
C
      TOLERNC = 0.0
      MARGIN = 0.0
      ILEVEL = 1
      LLEVEL = .FALSE.
      LFAIL1 = .FALSE.
      LRANDOM = .FALSE.
      LBIT2BT = .FALSE.
      LBIT4BT = .FALSE.
      NFAILS = 0
      NFAIL1 = 0
C
C     Check options to see if defaults to be overridden
C
      DO LOOP = 1, (JCOUNT-2)
C
C       Print level option
C
        IF( OPTIONS(LOOP)(1:2).EQ.'-p' ) THEN
          ILEVEL = ICHAR(OPTIONS(LOOP)(3:3)) - ICHAR('0')
          IF( (ILEVEL.LT.0).OR.(ILEVEL.GT.9) ) THEN
             WRITE(*,*) 'Invalid -p option: ' // OPTIONS(LOOP)
            ISTATUS = 1
            GOTO 990
          ENDIF
C
C         Set flag if print level set
C
          LLEVEL = .TRUE.
        ENDIF
C
C       Tolerance option
C
        IF( OPTIONS(LOOP)(1:2).EQ.'-t' ) THEN
          READ(OPTIONS(LOOP)(3:23),'(F20.10)') TOLERNC
          IF( TOLERNC.LT.0.0 ) TOLERNC = 0.0
          IF( TOLERNC.GT.100.0 ) TOLERNC = 100.0
        ENDIF
C
C       Bit to bit option
C
        IF( OPTIONS(LOOP)(1:8).EQ.'-bit2bit' ) LBIT2BT = .TRUE.
C
C       Bit for bit option
C
        IF( OPTIONS(LOOP)(1:8).EQ.'-bit4bit' ) LBIT4BT = .TRUE.
C
C       Fail option
C
        IF( OPTIONS(LOOP)(1:5).EQ.'-fail' ) LFAIL1 = .TRUE.
C
C       Random option
C
        IF( OPTIONS(LOOP)(1:7).EQ.'-random' ) LRANDOM = .TRUE.
C
      ENDDO
C
C     -----------------------------------------------------------------|
C     Open the data files
C     -----------------------------------------------------------------|
C
      ITOTAL1 = PBXTOTL(COMPFILE1)
      IF( ITOTAL1.LT.1 ) THEN
        WRITE(*, *) 'No GRIBS found in file: ', COMPFILE1
        ISTATUS = 1
        GOTO 990
      ENDIF
C
      ITOTAL2 = PBXTOTL(COMPFILE2)
      IF( ITOTAL2.LT.1 ) THEN
        WRITE(*, *) 'No GRIBS found in file: ', COMPFILE2
        ISTATUS = 1
        GOTO 990
      ENDIF
C
      IF( ITOTAL1.NE.ITOTAL2 ) THEN
        WRITE(*, *) 'The files have different number of GRIBs'
        WRITE(*, *) ITOTAL1, ' GRIB(s) in '
        WRITE(*, *) COMPFILE1
        WRITE(*, *) ITOTAL2, ' GRIB(s) in '
        WRITE(*, *) COMPFILE2
        IF( LFAIL1 ) THEN
          ISTATUS = 1
          GOTO 990
        ENDIF
      ENDIF
C
C     -----------------------------------------------------------------|
C     Read GRIB products one at a time
C     -----------------------------------------------------------------|
C
      LFAIL = .FALSE.
      ICOUNT = 0
      NEXT1 = 0
C
   50 CONTINUE
C
      NEXT1 = NEXT1 + 1
C
C     Clear arrays to allow clean comparisons
C
      DO LOOP = 1, 1024
        ISEC1(LOOP) = 0
        JSEC1(LOOP) = 0
        ISEC2(LOOP) = 0
        JSEC2(LOOP) = 0
        ISEC4(LOOP) = 0
        JSEC4(LOOP) = 0
        ZSEC2(LOOP) = 0.0
        WSEC2(LOOP) = 0.0
      ENDDO
      DO LOOP = 1, 2
        ISEC0(LOOP) = 0
        JSEC0(LOOP) = 0
        ISEC3(LOOP) = 0
        JSEC3(LOOP) = 0
        ZSEC3(LOOP) = 0.0
      ENDDO
C
C     Read packed field from first file into INBUFF1.
C
      LENOUT1 = PBXGET(COMPFILE1,INBUFF1, JPACK*4, NEXT1)
      IF( LENOUT1.LT.0 ) THEN
        WRITE(*, *) COMPFILE1 // ' read error for GRIB ', NEXT1
        ISTATUS = 1
        GOTO 990
      ENDIF
C
C     Unpack GRIB message headers.
C
      KRET = 1
      IPUNP = 1500000
      ILENB = (LENOUT1+3)/4
      ISEC3(2) = NINT(MISSING)
      ZSEC3(2) = MISSING
      CALL GRIBEX (ISEC0,ISEC1,ISEC2,ZSEC2,ISEC3,ZSEC3,ISEC4,
     X             ARRAY1,IPUNP,INBUFF1,ILENB,IWORD,'I',KRET)
C
      IF( KRET.GT.0 ) THEN
        WRITE(*,*) 'GRIBEX return code = ',KRET
        WRITE(*,*) 'GRIBEX error in product from file: ' // COMPFILE1
        WRITE(*,*) 'Product number = ', NEXT1
        ISTATUS = 1
        GOTO 990
      ENDIF
C
C     Read packed field from second file into INBUFF2.
C
C     Are the fields in a different sequence on the two file?
C
      IF( LRANDOM ) THEN
C
        NEXT2 = PBXXFIND(INBUFF1,COMPFILE2)
        IF( NEXT2.LT.0 ) THEN
          WRITE(*, *) COMPFILE2 // ' error finding matching GRIB'
          WRITE(*,*) 'Product number = ', NEXT1
          ISTATUS = 1
          GOTO 990
        ENDIF
C
C     ... the fields are in the same sequence on the two files
C
      ELSE
        NEXT2 = NEXT1
      ENDIF
C
      LENOUT2 = PBXGET(COMPFILE2,INBUFF2, JPACK*4, NEXT2)
      IF( LENOUT2.LT.0 ) THEN
        WRITE(*, *) COMPFILE2 // ' read error for GRIB ', NEXT2
        ISTATUS = 1
        GOTO 990
      ENDIF
C
      ICOUNT = ICOUNT + 1
C
C     -----------------------------------------------------------------|
C     If requested, compare the GRIBs bit for bit
C     -----------------------------------------------------------------|
C
      IF( LBIT4BT ) THEN
        IF( LENOUT1.NE.LENOUT2) THEN
          WRITE(*,*)
     X    'GRIBs', NEXT1,' and ', NEXT2,' are NOT bit for bit the same'
          LFAIL = .FALSE.
          GOTO 800
        ENDIF
C
        IZERO = 0
        KRET = JMEMCMP(INBUFF1,IZERO,INBUFF2,IZERO,LENOUT1)
        IF( KRET.NE.0 ) THEN
          WRITE(*,*)
     X    'GRIBs', NEXT1,' and ', NEXT2,' are NOT bit for bit the same'
          LFAIL = .FALSE.
        ELSE
          WRITE(*,*)
     X    'GRIBs', NEXT1,' and ', NEXT2,' are  bit for bit the same'
        ENDIF
        GOTO 800
      ENDIF
C
C     -----------------------------------------------------------------|
C     If requested, compare the GRIBs bit to bit
C     -----------------------------------------------------------------|
C
      IF( LBIT2BT ) THEN
        IF( LENOUT1.NE.LENOUT2) THEN
          WRITE(*,*)
     X    'GRIBs', NEXT1,' - ', NEXT2,' are different lengths'
          LFAIL = .FALSE.
Cjdc      GOTO 800
        ENDIF
C
        KRET = SOFFSET(INBUFF1,IS0,IS1,IS2,IS3,IS4,IEDITN)
        KRET = SOFFSET(INBUFF2,JS0,JS1,JS2,JS3,JS4,JEDITN)
C
        LENGTH = IS1 - IS0
        KRET = JMEMCMP(INBUFF1,IS0,INBUFF2,JS0,LENGTH)
        IF( KRET.NE.0 ) THEN
          WRITE(*,*)
     X    'GRIBs', NEXT1,' - ', NEXT2,' sections 0 differ'
          LFAIL = .FALSE.
        ENDIF
C
        LENGTH = IS2 - IS1
        KRET = JMEMCMP(INBUFF1,IS1,INBUFF2,JS1,LENGTH)
        IF( KRET.NE.0 ) THEN
          WRITE(*,*)
     X    'GRIBs', NEXT1,' - ', NEXT2,' sections 1 differ'
          LFAIL = .FALSE.
        ENDIF
C
        IF( IS3.NE.0 ) THEN
          LENGTH = IS3 - IS2
        ELSE
          LENGTH = IS4 - IS2
        ENDIF
        KRET = JMEMCMP(INBUFF1,IS2,INBUFF2,JS2,LENGTH)
        IF( KRET.NE.0 ) THEN
          WRITE(*,*)
     X    'GRIBs', NEXT1,' - ', NEXT2,' sections 2 differ'
          LFAIL = .FALSE.
        ENDIF
C
        IF( IS3.NE.0 ) THEN
          LENGTH = IS4 - IS3
          KRET = JMEMCMP(INBUFF1,IS3,INBUFF2,JS3,LENGTH)
          IF( KRET.NE.0 ) THEN
            WRITE(*,*)
     X      'GRIBs', NEXT1,' - ', NEXT2,' sections 3 differ'
            LFAIL = .FALSE.
          ENDIF
        ENDIF
C
Cjdc    LENGTH = LENOUT1 - IS4
        LENGTH = 11
        KRET = JMEMCMP(INBUFF1,IS4,INBUFF2,JS4,LENGTH)
        IF( KRET.NE.0 ) THEN
          WRITE(*,*)
     X    'GRIBs', NEXT1,' - ', NEXT2,' sections 4 leading bytes differ'
          LFAIL = .FALSE.
        ENDIF
C
        GOTO 800
      ENDIF
C
C     -----------------------------------------------------------------|
C     Otherwise, compare the GRIB values
C     -----------------------------------------------------------------|
C
C     Unpack GRIB messages.
C
      KRET = 1
      IPUNP = 1500000
      ILENB = (LENOUT1+3)/4
      ISEC3(2) = NINT(MISSING)
      ZSEC3(2) = MISSING
      CALL GRIBEX (ISEC0,ISEC1,ISEC2,ZSEC2,ISEC3,ZSEC3,ISEC4,
     X             ARRAY1,IPUNP,INBUFF1,ILENB,IWORD,'D',KRET)
C
      IF( KRET.GT.0 ) THEN
        WRITE(*,*) 'GRIBEX return code = ',KRET
        WRITE(*,*) 'GRIBEX error in product from file: ' // COMPFILE1
        WRITE(*,*) 'Product number = ', NEXT1
        ISTATUS = 1
        GOTO 990
      ENDIF
C
      NVALS1 = ISEC4(1)
C
      KRET = 1
      IPUNP = 1500000
      ILENB = (LENOUT2+3)/4
      CALL GRIBEX (JSEC0,JSEC1,JSEC2,WSEC2,JSEC3,ZSEC3,JSEC4,
     X             ARRAY2,IPUNP,INBUFF2,ILENB,IWORD,'D',KRET)
C
      IF( KRET.GT.0 ) THEN
        WRITE(*,*) 'GRIBEX return code = ',KRET
        WRITE(*,*) 'GRIBEX error in product from file: ' // COMPFILE2
        WRITE(*,*) 'Product number = ', NEXT2
        ISTATUS = 1
        GOTO 990
      ENDIF
C
      NVALS2 = JSEC4(1)
C
      IF( NVALS1.NE.NVALS2 ) THEN
        WRITE(*,*) 'Comparing GRIB ',NEXT1,' from '  // COMPFILE1
        WRITE(*,*) 'with      GRIB ',NEXT2,' from '  // COMPFILE2
        WRITE(*,*) 'The two GRIBs have different number of values'
        WRITE(*,*) NVALS1,' values in the grib from ' // COMPFILE1
        WRITE(*,*) NVALS2,' values in the grib from ' // COMPFILE2
        IF( LFAIL1 ) THEN
          ISTATUS = 1
          GOTO 990
        ENDIF
      ENDIF
C
C     -----------------------------------------------------------------|
C     Compare the GRIB headers
C     -----------------------------------------------------------------|
C
      LDIFF = .TRUE.
      DO LOOP = 1, 1024
        IF( ISEC1(LOOP).NE.JSEC1(LOOP) ) THEN
          IF( LDIFF ) THEN
            WRITE(*,*) 'GRIBs', NEXT1,' and ', NEXT2,': headers differ'
            LDIFF = .FALSE.
          ENDIF
          WRITE(*,*) 'ISEC1(',LOOP,') : ', ISEC1(LOOP), JSEC1(LOOP)
        ENDIF
      ENDDO
C
      DO LOOP = 1, 1024
        IF( ISEC2(LOOP).NE.JSEC2(LOOP) ) THEN
          IF( LDIFF ) THEN
            WRITE(*,*) 'GRIB headers differ:'
            LDIFF = .FALSE.
          ENDIF
          WRITE(*,*) 'ISEC2(',LOOP,') : ', ISEC2(LOOP), JSEC2(LOOP)
        ENDIF
      ENDDO
C
      DO LOOP = 1, 1024
        IF( ISEC4(LOOP).NE.JSEC4(LOOP) ) THEN
          IF( LDIFF ) THEN
            WRITE(*,*) 'GRIB headers differ:'
            LDIFF = .FALSE.
          ENDIF
          WRITE(*,*) 'ISEC4(',LOOP,') : ', ISEC4(LOOP), JSEC4(LOOP)
        ENDIF
      ENDDO
C
      DO LOOP = 1, 1024
        IF( ZSEC2(LOOP).NE.WSEC2(LOOP) ) THEN
          IF( LDIFF ) THEN
            WRITE(*,*) 'GRIB headers differ:'
            LDIFF = .FALSE.
          ENDIF
          WRITE(*,*) 'ZSEC2(',LOOP,') : ', ZSEC2(LOOP), WSEC2(LOOP)
        ENDIF
      ENDDO
C
C     -----------------------------------------------------------------|
C     Compare the arrays
C     -----------------------------------------------------------------|
C
C     Initialize the max/min values for the field
C
      DO LOOP = 1, NVALS1
        V1 = ARRAY1(LOOP)
        IF( NOTEQ(V1,MISSING) ) THEN
          MAXVAL1 = V1
          MINVAL1 = V1
          GOTO 10
        ENDIF
      ENDDO
   10 CONTINUE
C
      DO LOOP = 1, NVALS2
        V2 = ARRAY2(LOOP)
        IF( NOTEQ(V2,MISSING) ) THEN
          MAXVAL2 = V2
          MINVAL2 = V2
          GOTO 20
        ENDIF
      ENDDO
   20 CONTINUE
C
      MAXDIFF= 0.0
      MAXPERC= 0.0
      MAXDV1  = MAXVAL1
      MAXDV2  = MAXVAL2
C
Cjdc  DO LOOP = 1, ISEC4(1)
      DO LOOP = 1, MIN(NVALS1,NVALS2)
        V1 = ARRAY1(LOOP)
        V2 = ARRAY2(LOOP)
        IF( (NOTEQ(V1,MISSING)).AND.(NOTEQ(V2,MISSING)) ) THEN
          IF( MAXVAL1.LT.(V1) ) MAXVAL1 = (V1)
          IF( MAXVAL2.LT.(V2) ) MAXVAL2 = (V2)
          IF( MINVAL1.GT.(V1) ) MINVAL1 = (V1)
          IF( MINVAL2.GT.(V2) ) MINVAL2 = (V2)
          DIFF = ABS((V1-V2))
          IF( MAXDIFF.LT.DIFF ) THEN
            MAXDIFF = DIFF
            MAXDV1 = V1
            MAXDV2 = V2
            IF( V2.NE.0.0 ) THEN
              IF( ABS(V2).LT.ABS(V1) ) THEN
                MAXPERC = (MAXDIFF*100.0)/ABS(V2)
              ELSE IF( V1.NE.0 ) THEN
                MAXPERC = (MAXDIFF*100.0)/ABS(V1)
              ELSE
                MAXPERC = (MAXDIFF*100.0)/ABS(V2)
              ENDIF
            ELSE
              MAXPERC = (MAXDIFF*100.0)/ABS(V1)
            ENDIF
          ENDIF
        ENDIF
      ENDDO
C
C     Margin allowed is percentage of range (max-min) given by tolerance
C
      MARGIN = ABS((MAXVAL1 - MINVAL1)*TOLERNC*0.01)
C
      LPRINT = ILEVEL.GT.0
      IF( MAXDIFF.GT.MARGIN ) THEN
        LPRINT = .TRUE.
        LFAIL = .TRUE.
        NFAILS = NFAILS + 1
        IF( NFAIL1.EQ.0 ) NFAIL1 = ICOUNT
Cjdc    IF( ILEVEL.LT.1 ) ILEVEL = 1
      ENDIF
C
Cjdc  IF( ILEVEL.GT.0 ) THEN
      IF( LPRINT ) THEN
        WRITE(*,*) ' '
        WRITE(*,*) 'GRIB products ', NEXT1, ' : ', NEXT2
        WRITE(*,*) 'Number of data points = ', ISEC4(1)
        WRITE(*,*) 'Parameter  = ', isec1(6)
        WRITE(*,*) 'Level (P1) = ', isec1(8)
        WRITE(*,*) 'Level (P2) = ', isec1(9)
        WRITE(*,*) ' '
        WRITE(*,*) 'MAXVAL1 = ', MAXVAL1
        WRITE(*,*) 'MAXVAL2 = ', MAXVAL2
        WRITE(*,*) ' '
        WRITE(*,*) 'MINVAL1 = ', MINVAL1
        WRITE(*,*) 'MINVAL2 = ', MINVAL2
        WRITE(*,*) ' '
        WRITE(*,*) 'MAXDIFF = ', MAXDIFF, ' (',MAXPERC,' %)'
        IF( MAXDIFF.GT.0.0 )
     X    WRITE(*,*) 'At MAXDIFF: V1 = ', MAXDV1, ', V2 = ', MAXDV2
        WRITE(*,*) ' '
      ENDIF
C
      N = 0
      AVERAGE1 = 0.0
      AVERAGE2 = 0.0
C
      DO LOOP = 1, ISEC4(1)
        V1 = ARRAY1(LOOP)
        V2 = ARRAY2(LOOP)
        IF( (NOTEQ(V1,MISSING)).AND.(NOTEQ(V2,MISSING)) ) THEN
          AVERAGE1 = AVERAGE1 + V1
          AVERAGE2 = AVERAGE2 + V2
          N = N + 1
          DIFF = ABS(V1-V2)
          IF( DIFF .GT. MARGIN ) THEN
            LFAIL = .TRUE.
            IF( ILEVEL.GT.1 ) WRITE(*,*) LOOP, V1, V2, DIFF, (V1/V2)
          ENDIF
        ELSE
          IF( ILEVEL.GT.1 ) THEN
            IF( .NOT.NOTEQ(V1,MISSING) ) THEN
              IF( .NOT.NOTEQ(V2,MISSING) ) THEN
Cjdc            WRITE(*,*) LOOP,'    *** MISSING ***    *** MISSING ***'
              ELSE
                WRITE(*,*) LOOP,'    *** MISSING *** ', V2
              ENDIF
            ELSE
              WRITE(*,*) LOOP, V1,'    *** MISSING ***'
            ENDIF
          ENDIF
        ENDIF
      ENDDO
C
      AVERAGE1 = AVERAGE1 / N
      AVERAGE2 = AVERAGE2 / N
C
      IF( ILEVEL.GT.0 ) THEN
        WRITE(*,*) 'Average of field 1 = ', AVERAGE1
        WRITE(*,*) 'Average of field 2 = ', AVERAGE2
        WRITE(*,*) ' '
      ENDIF
C
  800 CONTINUE
C
      IF( LFAIL.AND.LFAIL1 ) THEN
        ISTATUS = 1
        GOTO 990
      ELSE
        IF( NEXT1.LT.ITOTAL1 ) GOTO 50
      ENDIF
C
C     -----------------------------------------------------------------|
C     Closedown
C     -----------------------------------------------------------------|
  900 CONTINUE
C
      IF( ILEVEL.GT.0 ) THEN
        WRITE(*,*) 'Total number of GRIB products = ', ICOUNT
        WRITE(*,*) ' '
      ENDIF
C
      ISTATUS = 0
C
      IF( NFAILS.GT.0 ) THEN
        WRITE(*,*) 'Total number of mismatched GRIBs = ', NFAILS
        WRITE(*,*) 'First fail in GRIB number ', NFAIL1
        WRITE(*,*) ' '
        ISTATUS = 1
        GOTO 990
      ENDIF
C
  990 CONTINUE
#ifdef FUJITSU
      CALL SETRCD(ISTATUS)
#else
      CALL JDCEXIT(ISTATUS)
#endif
C
      STOP
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C
#define INT_MISSING -2147483647

      INTEGER FUNCTION SETREP(OUTREP)
C
C---->
C*****SEREP*
C
C     PURPOSE
C     -------
C     reset LNOREPR to original value
C     reset some other values in common block
C     LNOREPR      - Flag to say whether or not user specified NOREPR 
C
C     Function argument
C
      INTEGER OUTREP

#include "parim.h"
#include "nifld.common"
#include "nofld.common"

       SETREP = 0
      IF(OUTREP.EQ.1) THEN
         LNOREPR = .FALSE.
        IF(.NOT.LNOAREA) THEN
           NOAREA(1) = 0
           NOAREA(2) = 0
           NOAREA(3) = 0
           NOAREA(4) = 0
         CALL INTLOG(JP_DEBUG,'SETREP: AREA has been reseted'
     X   ,JPQUIET)
        ENDIF
         CALL INTLOG(JP_DEBUG,'SETREP: LNOREPR has been reseted'
     X   ,JPQUIET)
      ENDIF
       NIWE = 0
       NINS = 0
         CALL INTLOG(JP_DEBUG,'SETREP: NIWE,NINS has been reseted'
     X   ,JPQUIET)
cs       NOACC = 0
cs         CALL INTLOG(JP_DEBUG,'SETREP: NOACC has been reseted'
cs     X   ,JPQUIET)
       NOLEVEL = 0
         CALL INTLOG(JP_DEBUG,'SETREP: NOLEVEL has been reseted'
     X   ,JPQUIET)
       LOCEAN = .FALSE.
         CALL INTLOG(JP_DEBUG,'SETREP: LOCEAN has been reseted'
     X   ,JPQUIET)
       LPREC = .FALSE.
         CALL INTLOG(JP_DEBUG,'SETREP: LPREC has been reseted'
     X   ,JPQUIET)
       LIMISSA = .FALSE.
       LIMISSV = .FALSE.
       RMISSGV   = REAL(INT_MISSING)
         CALL INTLOG(JP_DEBUG,'SETREP: LIMISSV has been reseted'
     X   ,JPQUIET)
cs       LNOROTA = .FALSE.
cs         CALL INTLOG(JP_DEBUG,'SETREP: LNOROTA has been reseted'
cs     X   ,JPQUIET)
C
      RETURN
      END

C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE JINTLL( KIBUFF, KLENI, PWEST, PEAST, PNORTH, PSOUTH,
     X                   PLATINC, PLONINC, KOBUFF, KLENO, KBITS, KRET)
C
C---->
C**** JINTLL
C
C     PURPOSE
C     _______
C
C     This routine converts spectral input fields to standard
C     lat/long grid fields.
C
C     INTERFACE
C     _________
C
C     CALL JINTLL( KIBUFF, KLENI, PWEST, PEAST, PNORTH, PSOUTH,
C    X             PLATINC, PLONINC, KOBUFF, KLENO, KBITS, KRET)
C
C     Input parameters
C     ________________
C
C     KIBUFF  - Array containing input spherical harmonic field
C               in GRIB format.
C     KLENI   - Length in words of KIBUFF.
C     PWEST   - Required area, west longitude(degrees)
C     PEAST   - Required area, east longitude(degrees)
C     PNORTH  - Required area, north latitude(degrees)
C     PSOUTH  - Required area, south latitude(degrees)
C     PLATINC - Required latitude interval in degrees.
C     PLONINC - Required longitude interval in degrees.
C     KLENO   - Length in words of KOBUFF.
C     KBITS   - Number of bits to be used for packing values in KOBUFF.
C
C
C     Output parameters
C     ________________
C
C     KOBUFF  - Array containing output spherical harmonic field
C               in GRIB format.
C     KLENO   - Number of words of KOBUFF occupied by GRIB.
C     KRET    - Return status code
C               0 = OK
C
C
C     Common block usage
C     __________________
C
C     JDCNDGB
C
C
C     Method
C     ______
C
C     None.
C
C
C     Externals
C     _________
C
C     JDEBUG    - Checks environment variable to switch on/off debug
C     GRIBEX    - Decodes/encodes GRIB product
C     JALLGP    - Transform from spherical harmonics to regular lat/long
C                 grid.
C     JMEMHAN   - Handles memory allocation.
C     INTLOG   - Output log message
C     INTLOGR  - Output log message (with real value)
C
C
C     Reference
C     _________
C
C     None.
C
C
C     Comments
C     ________
C
C     If PWEST, PEAST, PNORTH, PSOUTH are all 0.0, then the area
C     defaults to global.
C
C     If KBITS, the number of bits to be used for packing values, is
C     0, the number of bits used in the input spectral field is used.
C
C
C     AUTHOR
C     ______
C
C     J.D.Chambers      *ECMWF*      Apr 1994
C
C     MODIFICATIONS
C     _____________
C
C     J.D.Chambers     ECMWF        Feb 1997
C     Allow for 64-bit pointers
C
C----<
C     _______________________________________________________
C
C*    Section 0. Definition of variables.
C     _______________________________________________________
C
C*    Prefix conventions for variable names
C
C     Logical      L (but not LP), global or common.
C                  O, dummy argument
C                  G, local variable
C                  LP, parameter.
C     Character    C, global or common.
C                  H, dummy argument
C                  Y (but not YP), local variable
C                  YP, parameter.
C     Integer      M and N, global or common.
C                  K, dummy argument
C                  I, local variable
C                  J (but not JP), loop control
C                  JP, parameter.
C     Real         A to F and Q to X, global or common.
C                  P (but not PP), dummy argument
C                  Z, local variable
C                  PP, parameter.
C
      IMPLICIT NONE
#include "jparams.h"
#include "parim.h"
C
C     Parameters
      INTEGER JPROUTINE
      PARAMETER ( JPROUTINE = 30300 )
C     Arrays are dimensioned to accommodate spectral T639 data and
C     maximum resolution of (0.5 * 0.5) deg.
      INTEGER JPACK, JPMLAT, JPMLON
      PARAMETER (JPACK=420000)
      PARAMETER (JPMLAT=361)
      PARAMETER (JPMLON=720)
C
C     Subroutine arguments
      INTEGER KIBUFF, KLENI, KOBUFF, KLENO, KBITS, KRET
      DIMENSION KIBUFF(KLENI)
      DIMENSION KOBUFF(*)
      REAL PWEST, PEAST, PNORTH, PSOUTH, PLATINC, PLONINC
C
C     Local variables
      REAL NORTH, SOUTH, EAST, WEST
      INTEGER IPUNP, ITRUNC, NBITS
      INTEGER ISEC0, ISEC1, ISEC2, ISEC3, ISEC4
      REAL ZSEC2, ZSEC3, ZSEC4
#ifndef _CRAYFTN
#ifdef POINTER_64
      INTEGER*8 IZOUTBF
#endif
#endif
      REAL ZOUTBF
      POINTER ( IZOUTBF, ZOUTBF )
      DIMENSION ZOUTBF( 1 )
      INTEGER ILAT, ILON, IWORD
C
C     Array for integer parameters from section 0 of GRIB message.
      DIMENSION ISEC0(JPGRIB_ISEC0)
C
C     Array for integer parameters from section 1 of GRIB message.
      DIMENSION ISEC1(JPGRIB_ISEC1)
C
C     Array for integer parameters from section 2 of GRIB message.
      DIMENSION ISEC2(JPGRIB_ISEC2)
C
C     Array for integer parameters from section 3 of GRIB message.
      DIMENSION ISEC3(JPGRIB_ISEC3)
C
C     Array for integer parameters from section 4 of GRIB message.
      DIMENSION ISEC4(JPGRIB_ISEC4)
C
C     Array for real parameters from section 2 of GRIB message.
      DIMENSION ZSEC2(JPGRIB_RSEC2)
C
C     Array for real parameters from section 3 of GRIB message.
      DIMENSION ZSEC3(JPGRIB_RSEC3)
C
C     Array for real parameters from section 4 of GRIB message.
C     This is the binary data section and the array to hold
C     the unpacked data may need to be 4 times as long as that
C     for the packed data.
C
      DIMENSION ZSEC4(JPACK)
C
C     _______________________________________________________
C
C*    Section 1.    Unpack the input GRIB product.
C     _______________________________________________________
C
  100 CONTINUE
C
      CALL JDEBUG( )
C
      IF ( NDBG .GT. 0) THEN
        CALL INTLOG(JP_DEBUG,'JINTLL - Input parameters:',JPQUIET)
        DO 101 NDBGLP = 1, 20
          CALL INTLOGR(JP_DEBUG,' ',KIBUFF( NDBGLP ))
  101   CONTINUE
        CALL INTLOG(JP_DEBUG,
     X    'JINTLL - Length(words) of input product = ', KLENI)
        CALL INTLOGR(JP_DEBUG,
     X    'JINTLL - Required area, west long(deg) = ', PWEST)
        CALL INTLOGR(JP_DEBUG,
     X    'JINTLL - Required area, east long(deg) = ', PEAST)
        CALL INTLOGR(JP_DEBUG,
     X    'JINTLL - Required area, north lat(deg) = ', PNORTH)
        CALL INTLOGR(JP_DEBUG,
     X    'JINTLL - Required area, south lat(deg) = ', PSOUTH)
        CALL INTLOGR(JP_DEBUG,
     X    'JINTLL - Latitude grid interval (deg) = ', PLATINC)
        CALL INTLOGR(JP_DEBUG,
     X    'JINTLL - Longitude grid interval (deg) = ', PLONINC)
        CALL INTLOG(JP_DEBUG,
     X    'JINTLL - Length in words of KOBUFF = ', KLENO)
        CALL INTLOG(JP_DEBUG,
     X    'JINTLL - Number of bits for packing = ', KBITS)
      ENDIF
C
      IPUNP = JPACK*4
C
      IF ( NDBG .GT. 0) CALL GRSDBG(1)
C
      KRET = 1
      CALL GRIBEX (ISEC0,ISEC1,ISEC2,ZSEC2,ISEC3,ZSEC3,ISEC4,
     X             ZSEC4,IPUNP,KIBUFF,KLENI,IWORD,'D',KRET)
C
      IF ( NDBG .GT. 0) CALL INTLOG(JP_DEBUG,
     X    'JINTLL - Return from GRIBEX decoding = ', KRET)
C
C     Check return code.
      IF (KRET.GT.0) GOTO 900
C
C     Set number of bits to same as input if user did not give a number
      IF ( KBITS .LE. 0 ) THEN
        NBITS = ISEC4(2)
      ELSE
        NBITS = KBITS
      ENDIF
C     _______________________________________________________
C
C*    Section 2.    Interpolate to a latitude/longitude grid.
C     _______________________________________________________
C
 200  CONTINUE
C
C     Setup geographical limits
      IF ( (PWEST.EQ.0.0) .AND. (PEAST.EQ.0.0) .AND.
     X     (PNORTH.EQ.0.0) .AND. (PSOUTH.EQ.0.0) ) THEN
        NORTH = 90.0
        SOUTH = -90.0
        WEST  = 0.0
        EAST  = 360.0 - PLONINC
      ELSE
        WEST  = PWEST
        EAST  = PEAST
        NORTH = PNORTH
        SOUTH = PSOUTH
      ENDIF
C
C     Use input truncation
      ITRUNC = ISEC2(2)
C
      IF ( NDBG .GT. 0) THEN
        CALL INTLOG(JP_DEBUG,'JINTLL - WEST = ', WEST)
        CALL INTLOG(JP_DEBUG,'JINTLL - EAST = ', EAST)
        CALL INTLOG(JP_DEBUG,'JINTLL - NORTH = ', NORTH)
        CALL INTLOG(JP_DEBUG,'JINTLL - SOUTH = ', SOUTH)
        CALL INTLOG(JP_DEBUG,'JINTLL - ITRUNC = ', ITRUNC)
      ENDIF
C
      ILAT = NINT( (EAST - WEST)/PLATINC ) + 1
      ILON = NINT( (NORTH - SOUTH)/PLONINC ) + 1
      IPUNP = ILAT * ILON
C
      IF ( NDBG .GT. 0) THEN
        CALL INTLOG(JP_DEBUG,'JINTLL - Number of lat. points = ', ILAT)
        CALL INTLOG(JP_DEBUG,'JINTLL - Number of long.points = ', ILON)
        CALL INTLOG(JP_DEBUG,'JINTLL - Total no.of grid pnts = ', IPUNP)
      ENDIF
C
C     Allocate memory for scratch array.
      CALL JMEMHAN( 1, IZOUTBF, IPUNP, 1, KRET)
      IF ( KRET .NE. 0 ) THEN
        KRET =  JPROUTINE + 1
        CALL INTLOG(JP_ERROR,'JINTLL - Memory allocation failed',KRET)
        GOTO 900
      ENDIF
C
      CALL JALLGP( ZSEC4, ITRUNC, NORTH, SOUTH, WEST, EAST,
     X                    PLATINC, PLONINC, ZOUTBF, KRET)
C
      IF ( KRET .NE. 0 ) GOTO 900
C
C     _______________________________________________________
C
C*    Section 3.    Pack the output GRIB product.
C     _______________________________________________________
C
  300 CONTINUE
C
C
      ISEC1(4) = 255
      ISEC1(5) = 128
      ISEC1(19) = 0
      ISEC1(20) = 0
C
      ISEC2(1) = 0
      ISEC2(2) = ILAT
      ISEC2(3) = ILON
      ISEC2(4) = ( NORTH * 1000.0 )
      ISEC2(5) = ( WEST * 1000.0 )
      IF ( ISEC2(5) .LT. 0 ) ISEC2(5) = 360000 + ISEC2(5)
      IF ( ISEC2(5) .GT. 360000 ) ISEC2(5) = ISEC2(5) - 360000
      ISEC2(6) = 128
      ISEC2(7) = ( SOUTH * 1000.0 )
      ISEC2(8) = ( EAST * 1000.0 + 0.5 )
      IF ( ISEC2(8) .LT. 0 ) ISEC2(8) = 360000 + ISEC2(8)
      IF ( ISEC2(8) .GT. 360000 ) ISEC2(8) = ISEC2(8) - 360000
      ISEC2(9) = NINT( PLONINC * 1000.0 )
      ISEC2(10) = NINT( PLATINC * 1000.0 )
      ISEC2(11) = 0
      ISEC2(17) = 0
C
      ISEC4(1) = IPUNP
      ISEC4(2) = NBITS
      ISEC4(3) = 0
      ISEC4(4) = 0
      ISEC4(5) = 0
      ISEC4(6) = 0
      ISEC4(8) = 0
      ISEC4(9) = 0
      ISEC4(10) = 0
      ISEC4(11) = 0
C
      IF ( NDBG .GT. 0) CALL GRSDBG(1)
C
      KRET = 1
      CALL GRIBEX (ISEC0,ISEC1,ISEC2,ZSEC2,ISEC3,ZSEC3,ISEC4,
     X             ZOUTBF,IPUNP,KOBUFF,KLENO,KLENO,'C',KRET)
C
C     Check return code.
      IF ( NDBG .GT. 0)
     X  CALL INTLOG(JP_DEBUG,'JINTLL - status GRIBEX coding = ', KRET)
C
C     _______________________________________________________
C
C*    Section 9. Return to calling routine.
C     _______________________________________________________
C
 900  CONTINUE
C
      RETURN
C
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      INTEGER FUNCTION HGENGRW(AREA,POLE,GRID,NLON,NLAT,
     X                         RCLAT,RCLON,RLAT,RLON)
C
C---->
C**** HWTS12
C
C     Purpose
C     -------
C
C     This routine calculates the original latitude and longitude
C     values (before rotation) for a rotated grid for wind fields.
C
C
C     Interface
C     ---------
C
C     IRET = HGENGRW(AREA,POLE,GRID,NLON,NLAT,RCLAT,RCLON,RLAT,RLON)
C
C
C     Input parameters
C     ----------------
C
C     AREA - Limits of area (N/W/S/E)
C     POLE - Pole of rotation (lat/long)
C     GRID - Grid increments (i/j)
C
C
C     Output parameters
C     -----------------
C
C     NLON  - Number of points along a parallel in the rotated grid.
C     NLAT  - Number of points along a meridien in the rotated grid.
C     RCLAT - Vector of latitude values for the points in current grid.
C     RCLON - Vector of longitude values for the points in current grid.
C     RLAT  - Vector of orginal latitude values for the points in
C             the rotated grid.
C     RLON  - Vector of orginal longitude values for the points in
C             the rotated grid.
C
C     Returns 0 if function successful, non-zero otherwise.
C
C     Common block usage
C     ------------------
C
C     None.
C
C
C     Method
C     ------
C
C     The vector of points runs from West to East in rows, the rows
C     run from North to South.
C
C
C     Externals
C     ---------
C
C     INTLOG  - Log error message.
C     JDEBUG  - Tests if debug output required.
C     HLL2XYZ - Converts a latitude/longitude position to (x,y,z)
C               wrt axes through the centre of the globe. The z-axis
C               runs from the south to north pole. The x- and y-axes
C               are in the plane of the equator with the x-axis
C               pointing out through lat/long (0,0).
C     YROTATE - Rotates the globe about the new y-axis.
C     XYZ2LL  - Converts an (x,y,z) position to a latitude/longitude.
C     JMALLOC - Dynamically allocate memory
C     JFREE   - Free dynamically allocated memory
C
C
C     Reference
C     ---------
C
C     None.
C
C
C     Comments
C     --------
C
C     None.
C
C
C     Author
C     ------
C
C     J.D.Chambers      ECMWF      January 2001
C
C
C     Modifications
C     -------------
C
C     None.
C
C----<
C     -----------------------------------------------------------------|
C*    Section 0. Definition of variables.
C     -----------------------------------------------------------------|
C
      IMPLICIT NONE
#include "parim.h"
C
C     Parameters
C
      INTEGER JNORTH, JSOUTH, JWEST, JEAST, JW_E, JN_S, JLAT, JLON
      REAL JSCALE
      PARAMETER (JNORTH = 1 )
      PARAMETER (JWEST  = 2 )
      PARAMETER (JSOUTH = 3 )
      PARAMETER (JEAST  = 4 )
      PARAMETER (JW_E  = 1 )
      PARAMETER (JN_S  = 2 )
      PARAMETER (JLAT  = 1 )
      PARAMETER (JLON  = 2 )
      PARAMETER (JSCALE  = 1000.0 )
C
C     Function arguments
C
      REAL AREA(4),POLE(2),GRID(2), RCLAT(*),RCLON(*),RLAT(*),RLON(*)
      INTEGER NLON,NLAT
C
C     Local variables
C
      INTEGER NEXT, LOOP, LOOPI, LOOPO, IGRIDNI, IGRIDNJ
      INTEGER ISIZE, ISIZOLD, NBYTES
      REAL ZLAT, X(1), Y(1), Z(1)
      REAL RX(1), RY(1), RZ(1)
      POINTER( IPX, X )
      POINTER( IPY, Y )
      POINTER( IPZ, Z )
      POINTER( IPRX, RX )
      POINTER( IPRY, RY )
      POINTER( IPRZ, RZ )
C
      DATA ISIZOLD/-1/
      SAVE ISIZOLD,IPX,IPY,IPZ,IPRX,IPRY,IPRZ
C
C     Externals
C
#ifdef POINTER_64
      INTEGER*8 JMALLOC
#else
      INTEGER JMALLOC
#endif
C
C     -----------------------------------------------------------------|
C     Section 1.  Initialise.
C     -----------------------------------------------------------------|
C
  100 CONTINUE
C
      HGENGRW = 0
C
      CALL JDEBUG()
C
C     -----------------------------------------------------------------|
C     Section 2.  Calculate current grid latitudes and longitudes
C     -----------------------------------------------------------------|
C
  200 CONTINUE
C
      NLON = 1 + NINT((AREA(JEAST) - AREA(JWEST)) / GRID(JW_E))
      NLAT = 1 + NINT((AREA(JNORTH) - AREA(JSOUTH)) / GRID(JN_S))
      IGRIDNI = NINT(GRID(JW_E)*JSCALE)
      IGRIDNJ = NINT(GRID(JN_S)*JSCALE)
C
      NEXT = 1
      DO LOOPO = 1, NLAT
        ZLAT = AREA(JNORTH) - REAL((LOOPO-1)*IGRIDNJ)/JSCALE
        DO LOOPI = 1, NLON
          RCLON(NEXT) = AREA(JWEST) + REAL((LOOPI-1)*IGRIDNI)/JSCALE
          IF( RCLON(NEXT).LT.0.0 ) RCLON(NEXT) = RCLON(NEXT) + 360.0
          RCLAT(NEXT) = ZLAT
          NEXT = NEXT + 1
        ENDDO
      ENDDO
C
C     -----------------------------------------------------------------|
C     Section 3.  Get some space for rotating the lat/longs
C     -----------------------------------------------------------------|
C
  300 CONTINUE
C
      ISIZE = NLAT *NLON
      IF( ISIZE.GT.ISIZOLD ) THEN
C
        IF( ISIZOLD.GT.0 ) CALL JFREE(IPX)
C
        NBYTES = 6*ISIZE*JPRLEN
C
        IPX = JMALLOC(NBYTES)
#ifdef hpR64
        IPX = IPX/(1024*1024*1024*4)
#endif
        IF( IPX.EQ.0 ) THEN
          CALL INTLOG(JP_WARN,'HGENGRW: Memory allocate fail',JPQUIET)
          HGENGRW = 1
          GOTO 900
        ENDIF
C
        IPY  = IPX  + (ISIZE*JPRLEN)
        IPZ  = IPY  + (ISIZE*JPRLEN)
        IPRX = IPZ  + (ISIZE*JPRLEN)
        IPRY = IPRX + (ISIZE*JPRLEN)
        IPRZ = IPRY + (ISIZE*JPRLEN)
C
        ISIZOLD = ISIZE
C
      ENDIF
C
C     -----------------------------------------------------------------|
C     Section 4.  Calculate the lat/longs before rotation
C     -----------------------------------------------------------------|
C
  400 CONTINUE
C
C     Convert the rotated row points lat/longs to (x,y,z) coordinates
C
      CALL HLL2XYZ(RCLAT,RCLON,X,Y,Z,ISIZE)
C
C     Rotate the rotated row points back through the original latitude
C     rotation
C
      CALL YROTATE(-(90.0+POLE(JLAT)),X,Y,Z,RX,RY,RZ,ISIZE)
C
C     Convert the rotated row points adjusted (x,y,z) coordinates to
C     lat/long in the original grid (but still containing the
C     longitude rotation)
C
      CALL XYZ2LL(RX,RY,RZ,RLAT,RLON,ISIZE)
C
C     Adjust the rotated line longitudes to remove the longitude
C     rotation
C
      DO LOOP = 1, ISIZE
        RLON(LOOP) = RLON(LOOP) + POLE(JLON)
        IF( RLON(LOOP).LT.0.0 )   RLON(LOOP) = RLON(LOOP) + 360.0
        IF( RLON(LOOP).GE.360.0 ) RLON(LOOP) = RLON(LOOP) - 360.0
      ENDDO
C
C     -----------------------------------------------------------------|
C     Section 9.  Return
C     -----------------------------------------------------------------|
C
  900 CONTINUE
C
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

       PROGRAM BUFR
C
C**** *BUFR*
C
C
C     PURPOSE.
C     --------
C         EXAMPLE OF USING BUFR UNPACKING/PACKING SOFTWARE.
C
C
C**   INTERFACE.
C     ----------
C
C          NONE.
C
C     METHOD.
C     -------
C
C          NONE.
C
C
C     EXTERNALS.
C     ----------
C
C         CALL BUSEL2
C         CALL BUFREX
C         CALL BUFREN
C         CALL BUPRS0
C         CALL BUPRS1
C         CALL BUPRS2
C         CALL BUPRS3
C         CALL BUPRT
C         CALL BUUKEY
C
C     REFERENCE.
C     ----------
C
C          NONE.
C
C     AUTHOR.
C     -------
C
C          M. DRAGOSAVAC    *ECMWF*       15/09/87.
C
C
C     MODIFICATIONS.
C     --------------
C
C          NONE.
C
C
      IMPLICIT LOGICAL(L,O,G), CHARACTER*8(C,H,Y)
C
      PARAMETER(JSUP =   9,JSEC0=   3,JSEC1= 40,JSEC2=4096 ,JSEC3=    4,
     1        JSEC4= 2,JELEM=3200000,JSUBS=500,JCVAL=150 ,JBUFL=300000,
     2          JBPW =  32,JTAB =3000,JCTAB=120,JCTST=1800,JCTEXT=1200,
     3          JWORK=4096000,JKEY=46,JBYTE=440000)
C
      PARAMETER (KELEM=160000)
      PARAMETER (KVALS=4096000)
C 
      DIMENSION KBUFF(JBUFL)
      DIMENSION KBUFR(JBUFL)
      DIMENSION KSUP(JSUP)  ,KSEC0(JSEC0),KSEC1(JSEC1)
      DIMENSION KSEC2(JSEC2),KSEC3(JSEC3),KSEC4(JSEC4)
      DIMENSION KEY  (JKEY),KREQ(2)
      DIMENSION NREQUEST(2)
C
      REAL*8 VALUES(KVALS),VALUE(KVALS)
      DIMENSION KTDLST(JELEM),KTDEXP(JELEM),KRQ(KELEM)
      REAL*8 RQV(KELEM)
      DIMENSION KDATA(200),KBOXR(JELEM*4)
      REAL*8 VALS(KVALS)
C
      CHARACTER*256 CF,COUT,CARG(4)
      CHARACTER*64 CBOXN(JELEM*4)
      CHARACTER*200 CNAMES(KELEM)
      CHARACTER*24 CUNITS(KELEM),CBOXU(JELEM*4)
      CHARACTER*80 CVALS(kelem)
      CHARACTER*80 CVAL(kelem)
      CHARACTER*80 YENC
      REAL*8 RVIND
      REAL*8 EPS
C
C     ------------------------------------------------------------------
C*          1. INITIALIZE CONSTANTS AND VARIABLES.
C              -----------------------------------
 100  CONTINUE
C
C     MISSING VALUE INDICATOR
C 
      NBYTPW=JBPW/8
      RVIND=1.7E38
      NVIND=2147483647
      IOBS=0
      EPS=10.E-10
      NPACK=0
      IYEAR=NVIND
      N=0
      NCOM=0
      OO=.FALSE.
C
C
C
C     GET INPUT AND OUTPUT FILE NAME.
C
      NARG=IARGC()
C
C
      DO 104 J=1,NARG
      CALL GETARG(J,CARG(J))
 104  CONTINUE

      II=0
      IO=0
      DO 105 J=1,NARG
      IF(CARG(J).EQ.'-i') THEN
         IN=J
      ELSEIF(CARG(J).EQ.'-o') THEN
         IO=J
      END IF
 105  CONTINUE
      IF(IN.EQ.0) THEN
        IF(IO.EQ.0) THEN
          PRINT*,'USAGE -- decode_bufr -i infile -o outfile'
        ELSE
          PRINT*,'USAGE -- decode_bufr -i infile'
        END IF
        CALL EXIT (6)
      END IF

C
      IF(IO.NE.0)  COUT=CARG(IO+1)
C
      IF(IO.LT.IN) THEN
         IST=IN+1
         IEND=NARG
      ELSE
         IST=IN+1
         IEND=IO-1
      END IF
C
C
      IF(IO.NE.0) THEN
         JJ=INDEX(COUT,' ')
         JJ=JJ-1
         CALL PBOPEN(IUNIT1,COUT(1:JJ),'W',IRET)
         IF (IRET.EQ.-1) THEN
           PRINT *, 'OPEN FAILED ON BUFR.DAT'
           CALL EXIT (1)
         ELSE IF (IRET.EQ.-2) THEN
           PRINT *, 'INVALID FILE NAME'
           CALL EXIT (2)
         ELSE IF (IRET.EQ.-3) THEN
           PRINT *, 'INVALID OPEN MODE SPECIFIED'
           CALL EXIT (3)
         END IF
      END IF
C
      DO 101 II=IST,IEND

      CF=CARG(II)
      ILN=INDEX(CF,' ')
      ILN=ILN-1

      KRQL=0
      NR=0
      KREQ(1)=0
      KREQ(2)=0
      DO 103 I=1,KELEM
      RQV(I)=RVIND
      KRQ(I)=NVIND
 103  CONTINUE
C
C*          1.2 OPEN FILE CONTAINING BUFR DATA.
C               -------------------------------
 120  CONTINUE
C
      IRET=0 
      CALL PBOPEN(IUNIT,CF(1:ILN),'R',IRET)
      IF (IRET.EQ.-1) THEN
        PRINT *, 'OPEN FAILED'
        CALL EXIT (1)
      ELSE IF (IRET.EQ.-2) THEN
        PRINT *, 'INVALID FILE NAME'
        CALL EXIT (2)
      ELSE IF (IRET.EQ.-3) THEN
        PRINT *, 'INVALID OPEN MODE SPECIFIED'
        CALL EXIT (3)
      END IF
C
      IF(IO.NE.0) THEN
         CALL PBOPEN(IUNIT1,COUT(1:JJ),'W',IRET)
         IF (IRET.EQ.-1) THEN
           PRINT *, 'OPEN FAILED ON BUFR.DAT'
           CALL EXIT (1)
         ELSE IF (IRET.EQ.-2) THEN
           PRINT *, 'INVALID FILE NAME'
           CALL EXIT (2)
         ELSE IF (IRET.EQ.-3) THEN
           PRINT *, 'INVALID OPEN MODE SPECIFIED'
           CALL EXIT (3)
         END IF
      END IF
C

C
C
C     ----------------------------------------------------------------- 
C*          2. SET REQUEST FOR EXPANSION.
C              --------------------------
 200  CONTINUE
C
      OPRT=.FALSE.
      OENC=.FALSE.
c     READ (*,'(A)') YENC
c     IF(YENC(1:1).EQ.'Y'.OR.YENC(1:1).EQ.'y') THEN
         OPRT=.TRUE.
c     END IF
      ICODE=0
c     WRITE(*,'(A,$)') ' CODE TABLES TO BE PRINTED ( Y/N ) : '
c     READ (*,'(A)') YCODC
c     IF(YCODC(1:1).EQ.'Y'.OR.YCODC(1:1).EQ.'y') THEN
         ICODE=1
c     END IF
c     WRITE(*,'(A,$)') ' DO YOU WANT ENCODING( Y/N ) : '
c     READ (*,'(A)') YENC
c     IF(YENC(1:1).EQ.'Y'.OR.YENC(1:1).EQ.'y') THEN
c         OENC=.TRUE.
c        WRITE(*,'(A,$)') ' NUMBER OF SUBSETS TO PACK : '
c        READ(*,'(BN,I4)')   NCOM
c        OCOMP=.FALSE.
c        WRITE(*,'(A,$)') ' DO YOU WANT COMPRESSION( Y/N ) : '
c        READ (*,'(A)') YCOMP
c        IF(YCOMP(1:1).EQ.'Y'.OR.YCOMP(1:1).EQ.'y') OCOMP=.TRUE.
c     END IF
c     WRITE(*,'(A,$)') ' RECORD NUMBER TO START FROM : '
c     READ(*,'(BN,I6)')   NR
      NR=1
C
 201  CONTINUE
C
c     WRITE(*,'(A,$)') ' REQUESTED ELEMENT : ' 
c     READ(*,'(BN,I6)')   IEL 
c     WRITE(*,'(A,$)') ' REQUESTED VALUE   : '
c     READ(*,'(BN,F12.2)')   VAL
c     IF(IEL.EQ.0) THEN
         KRQL=J
c     ELSE
c        J=J+1
c        KRQ(J)=IEL
c        RQV(J)=VAL
c        IF(VAL.EQ.0.) RQV(J)=RVIND
c        GO TO 201
c     END IF
C
c     WRITE(*,'(A,$)') ' REQUESTED FLAG 1  : '
c     READ(*,'(BN,I6)')  KREQ(1)
C
c     WRITE(*,'(A,$)') ' REQUESTED FLAG 2  : '
c     READ(*,'(BN,I6)')  KREQ(2)
C
c     WRITE(*,'(A,$)') ' DO YOU WANT TO PRINT SECTION 0-3( Y/N ) : '
c     READ (*,'(A,$)') YENC
c     OSEC3=.FALSE.
c     IF(YENC(1:1).EQ.'Y'.OR.YENC(1:1).EQ.'y') OSEC3=.TRUE.
      OSEC3=.TRUE.
C
C*          2.1 SET REQUEST FOR PARTIAL EXPANSION.
C               ----------------------------------
 210  CONTINUE
C
c     IERR=0
      CALL BUSRQ(KREQ,KRQL,KRQ,RQV,IERR)
C
C     SET VARIABLE TO PACK BIG VALUES AS MISSING VALUE INDICATOR
C
      KPMISS=1
      KPRUS=0
      KOKEY=0
      CALL BUPRQ(KPMISS,KPRUS,KOKEY)
C
C     -----------------------------------------------------------------
      IF(NCOM.NE.0) THEN
         KEL1=KVALS/NCOM
         IF(KEL1.GT.KELEM) KEL1=KELEM
      END IF
C
C*          3.  READ BUFR MESSAGE.
C               ------------------
 300  CONTINUE
C
      IERR=0
      KBUFL=0
C
      CALL PBBUFR(IUNIT,KBUFF,JBYTE*4,KBUFL,IERR) 
      IF(IERR.EQ.-1) THEN
         IF(NPACK.NE.0) GO TO 600
         WRITE(*,'(A,I5)')'NUMBER OF SUBSETS     ',IOBS
         WRITE(*,'(A,I4)')'NUMBER OF MESSAGES    ',N
         STOP 'EOF'
      END IF
      IF(IERR.EQ.-2) THEN
        PRINT *, 'FILE HANDLING PROBLEM' 
        CALL EXIT (4)
      ELSE IF(IERR.EQ.-3) THEN
        PRINT *, 'ARRAY TOO SMALL FOR PRODUCT'
        CALL EXIT (5)
      END IF
C
      N=N+1
c     PRINT*,'----------------------------------',N,' ',KBUFL
      KBUFL=KBUFL/NBYTPW+1
      IF(N.LT.NR) GO TO 300
C
C     -----------------------------------------------------------------
C*          4. EXPAND BUFR MESSAGE.
C              --------------------
 400  CONTINUE
C
      CALL BUS0123( KBUFL,KBUFF,KSUP,KSEC0,KSEC1,KSEC2,KSEC3,IERR)
      IF(IERR.NE.0) THEN
         PRINT*,'ERROR IN BUS012: ',IERR
         PRINT*,' BUFR MESSAGE NUMBER ',N,' CORRUPTED.'
         IERR=0
         GO TO 300
      END IF
C
      KEL=KVALS/KSEC3(3)
      IF(KEL.GT.KELEM) KEL=KELEM
C
      CALL BUFREX(KBUFL,KBUFF,KSUP,KSEC0 ,KSEC1,KSEC2 ,KSEC3 ,KSEC4,
     1            KEL,CNAMES,CUNITS,KVALS,VALUES,CVALS,IERR)
C
      IF(IERR.NE.0) CALL EXIT(2)
C
C
      IOBS=IOBS+KSEC3(3)
C
C
      ISUBSET=1
      CALL BUSEL2(ISUBSET,KEL,KTDLEN,KTDLST,KTDEXL,KTDEXP,CNAMES,
     1            CUNITS,IERR)
C     IF(IERR.NE.0) CALL EXIT(2)
C
C
c      DO 401 IK=1,KSEC3(3)
c
c      CALL BUSEL2(IK,KEL,KTDLEN,KTDLST,KTDEXL,KTDEXP,CNAMES,
c    1             CUNITS,IERR)
c      KSUP(5)=KTDEXL
c      CALL BUBOX(IK,KSUP,KEL,KTDEXP,CNAMES,CUNITS,KVALS,VALUES,
c    1            KBOX,KAPP,KLEN,KBOXR,VALS,CBOXN,CBOXU,IERR)
C
c 401  CONTINUE
C
C
C*          4.1 PRINT CONTENT OF EXPANDED DATA.
C               -------------------------------
 410  CONTINUE
C
      IF(.NOT.OPRT) GO TO 500
      IF(.NOT.OSEC3) GO TO 450
C
C*          4.2 PRINT SECTION ZERO OF BUFR MESSAGE.
C               -----------------------------------
 420  CONTINUE
C

      CALL BUPRS0(KSEC0)
C
C*          4.3 PRINT SECTION ONE OF BUFR MESSAGE.
C               -----------------------------------
 430  CONTINUE
C
      CALL BUPRS1(KSEC1)
C
C
C*          4.4 PRINT SECTION TWO OF BUFR MESSAGE.
C               -----------------------------------
 440  CONTINUE
C
C              AT ECMWF SECTION 2 CONTAINS RDB KEY.
C              SO UNPACK KEY
C
      CALL BUUKEY(KSEC1,KSEC2,KEY,KSUP,IERR)
C
C              PRINT KEY
C
      CALL BUPRS2(KSUP ,KEY)
C
C*          4.5 PRINT SECTION 3 OF BUFR MESSAGE.
C               -----------------------------------
 450  CONTINUE
C
C               FIRST GET DATA DESCRIPTORS
C
C     Multi subset uncompressed data descriptors for the 1st subset
C     Each subset can contain completly different list of expanded
C     discriptors
C
      ISUBSET=1
      CALL BUSEL2(ISUBSET,KEL,KTDLEN,KTDLST,KTDEXL,KTDEXP,CNAMES,
     1            CUNITS,IERR)
      IF(IERR.NE.0) CALL EXIT(2)
C
C               PRINT  CONTENT
C
      IF(OSEC3) THEN
         CALL BUPRS3(KSEC3,KTDLEN,KTDLST,KTDEXL,KTDEXP,KEL,CNAMES)
      END IF
C
C*         4.6 PRINT SECTION 4 (DATA).
C              -----------------------
 460  CONTINUE
C
C          IN THE CASE OF MANY SUBSETS DEFINE RANGE OF SUBSETS
C
      IF(.NOT.OO) THEN
c     WRITE(*,'(A,$)') ' STARTING SUBSET TO BE PRINTED : '
c     READ(*,'(BN,I4)')   IST
c     WRITE(*,'(A,$)') ' ENDING SUBSET TO BE PRINTED : '
c     READ(*,'(BN,I4)')   IEND
      IST=1
      IEND=1000
      OO=.FALSE.
      END IF
C
C              PRINT DATA
C
      ICODE=0
 
C     IF(KSEC1(6).EQ.11) THEN
C
C        IST=1
C        IEND=KSEC3(3)
C
         CALL BUPRT(ICODE,IST,IEND,KEL,CNAMES,CUNITS,CVALS,
     1              KVALS,VALUES,KSUP,KSEC1,IERR)
C     ELSE
C
C              RESOLVE BIT MAPS FOR EACH SUBSET
C
C        ist=1
C        iend=ksec3(3)
C
C        IF(IEND.GT.KSEC3(3)) IEND=KSEC3(3)
C
C        DO 461 IK=IST,IEND
C 
C        CALL BUSEL2(IK,KEL,KTDLEN,KTDLST,KTDEXL,KTDEXP,CNAMES,
C    1               CUNITS,IERR)
C
C        KSUP(5)=KTDEXL
C        CALL BUBOX(IK,KSUP,KEL,KTDEXP,CNAMES,CUNITS,KVALS,VALUES,
C    1              KBOX,KAPP,KLEN,KBOXR,VALS,CBOXN,CBOXU,IERR)
C        IF(IERR.NE.0) CALL EXIT(2)
C 
C        CALL BUPRTBOX(KBOX,KAPP,KLEN,KBOXR,VALS,CBOXN,CBOXU)
C
C461     CONTINUE
C     END IF
C
C     -----------------------------------------------------------------
C*          5. COLLECT DATA FOR REPACKING.
C              ---------------------------
 500  CONTINUE
C      
C 
      IF(.NOT.OENC) GO TO 300
C
      ISUBS=KSEC3(3)
      DO J=1,ISUBS
C
      NPACK=NPACK+1
C
C            FIRST GET DATA DESCRIPTORS
C
      CALL BUSEL2(J,KEL,KTDLEN,KTDLST,KTDEXL,KTDEXP,CNAMES,
     1            CUNITS,IERR)
      IF(IERR.NE.0) CALL EXIT(2)
C
      DO I=1,KTDEXL
      IO=I+(NPACK-1)*KEL1
      IN=I+(J-1)*KEL
C
      IF(CUNITS(I).EQ.'CCITTIA5') THEN
         IPOS =VALUES(IN)/1000.
         ICH=NINT(VALUES(IN)-IPOS*1000)
         KKK=KKK+1
         VALUE(IO)=KKK*1000+ICH
         CVAL(KKK)=CVALS(IPOS)
      ELSE
         VALUE(IO)=VALUES(IN)
      END IF
      IF(KTDEXP(I).EQ.31001.OR.KTDEXP(I).EQ.31002) THEN
          KK=KK+1
          KDATA(KK)=NINT(VALUE(IO))
       END IF
       IF(KTDEXP(I).EQ.004001) THEN
          IYEAR=NINT(VALUE(IO))
       END IF

       END DO
C
       KDLEN=KK
       IF(NPACK.EQ.NCOM) THEN
         

          KSEC3(3)=NPACK
          KSEC1(5)=0
          KSEC1(8)=1
          KSEC1(15)=12
          IF(KSEC0(3).LT.4) THEN
             KSEC1(17)=255
             KSEC1(18)=0
          END IF
          KSEC0(3)=3            ! EDITION 4 OF BUFR MESSAGE
          IF(KSEC0(3).GE.4) KSEC1(1)=22
          KSEC3(4)=0            ! NO COMPRESSION
          IF(KSEC0(3).LE.3) THEN
             IF(IYEAR.GT.2000) THEN
                KSEC1(9)=IYEAR-2000
             ELSE
                KSEC1(9)=IYEAR-1900
             END IF
          ELSE
             KSEC1(9)=IYEAR
          END IF
          IF(OCOMP) KSEC3(4)=64  ! COMPRESSION
          KBUFL=JBUFL
          CALL BUFREN( KSEC0,KSEC1,KSEC2,KSEC3,KSEC4,
     1             KTDLEN,KTDLST,KDLEN,KDATA,KEL1,
     2             KVALS,VALUE,CVAL,KBUFL,KBUFR,IERR)
          IF(IERR.NE.0) THEN
             PRINT*,'ERROR IS ',IERR
             PRINT*,'ERROR DURING ENCODING.'
             CALL EXIT(2)
          END IF
C
          ILEN=KBUFL*NBYTPW
C
          IERR=0
C
          CALL PBWRITE(IUNIT1,KBUFR,ILEN,IERR)
          IF(IERR.LT.0) THEN
             PRINT*,'ERROR WRITING INTO TARGET FILE.'
             CALL EXIT(2)
          END IF
          PRINT*,'RECORD WRITTEN INTO FILE '
C
          NPACK=0
          KKK=0
          KK=0
       END IF
C
       END DO
C
       GO TO 300
C     -----------------------------------------------------------------
C*          6. PACK BUFR MESSAGE BACK INTO BUFR.
C              ---------------------------------
 600  CONTINUE
C
     
       KSEC3(3)=NPACK
       KSEC1(8)=1
       KSEC1(15)=12
       KSEC0(3)=4            ! EDITION 4 OF BUFR MESSAGE
       IF(KSEC0(3).GE.4) KSEC1(1)=22
       IF(KSEC0(3).LT.4) THEN
          KSEC1(17)=255
          KSEC1(18)=0
       END IF

       KSEC3(4)=0            ! NO COMPRESSION
       IF(KSEC1(9).LT.101) THEN
          KSEC1(9)=IYEAR
       END IF
       
C      
       IF(OCOMP) KSEC3(4)=64  ! COMPRESSION  
       KBUFL=JBUFL
C
C
C*          6.2 ENCODE DATA INTO BUFR MESSAGE.
C               ------------------------------
 620   CONTINUE
C
       CALL BUFREN( KSEC0,KSEC1,KSEC2,KSEC3,KSEC4,
     1             KTDLEN,KTDLST,KDLEN,KDATA,KEL1,
     2             KVALS,VALUE,CVAL,KBUFL,KBUFR,IERR)
       IF(IERR.NE.0) THEN
          PRINT*,'ERROR IS ',IERR
          PRINT*,'ERROR DURING ENCODING.'
          CALL EXIT(2)
       END IF
C
C           6.3 WRITE PACKED BUFR MESSAGE INTO FILE.
C               ------------------------------------
 630   CONTINUE
C
       ILEN=KBUFL*NBYTPW
C    
       CALL PBWRITE(IUNIT1,KBUFR,ILEN,IERR)
       IF(IERR.LT.0) THEN
          PRINT*,'ERROR WRITING INTO TARGET FILE.'
          CALL EXIT(2)
       END IF
       PRINT*,'RECORD WRITTEN INTO FILE ' 
C
       NPACK=0
       KKK=0
C
       GO TO 300
C     -----------------------------------------------------------------
C
 810  CONTINUE
C
      WRITE(*,'(1H ,A)') 'OPEN ERROR ON INPUT FILE'
      GO TO 900
C      
 800  CONTINUE
C
      IF(IRET.EQ.-1) THEN
         PRINT*,'NUMBER OF RECORDS PROCESSED ',N
         PRINT*,'NUMBER OF OBSERVATIONS      ',IOBS
      ELSE
         PRINT*,' BUFR : ERROR= ',IERR
      END IF
C
 900  CONTINUE
C
      CALL PBCLOSE(IUNIT,IRET)
 101  CONTINUE
      CALL PBCLOSE(IUNIT1,IRET)
C
      END

C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      LOGICAL FUNCTION PPALLOW(NM,SLAT)
C
C---->
C**** PPALLOW
C
C     Purpose
C     -------
C
C     
C     ---------
C
C     LFOUND = PPALLOW(NM,SLAT) 
C
C
C     Input
C     -----
C
C     NM      - Triangular truncation number of the field..
C     SLAT    - Rotation angle (degrees, REAL*8)
C              (degrees, negative => rotate counter-clockwise about the
C                                    new Z-axis).
C
C
C     Output
C     ------
C
C     Function returns .TRUE. if coefficients are in the list of
C     'standard' rotations and allowed in mrfs.
C
C
C     Method
C     ------
C
C     Checks a configuration file to find the allowed rotations.
C     This file may have its pathname given by the environment variable
C     PP_ALLOWED_ROTATIONS or may be in a standard directory.
C     Only picks up configuration values on first call.
C
C     The configuration file is read by Fortran and has format
C     (I4,1X,F8). Eg.
C
C      159 -14.0000
C      319  60.0000
C      319 -60.0000
C
C     Externals
C     ---------
C
C     GETENV - Gets value in an environment variable.
C     INTLOG - Output log message.
C     JDEBUG - Checks environment to switch on/off debug.
C
C
C     Author
C     ------
C
C     J.D.Chambers     ECMWF       June 2000
C
C
C----<
C     -----------------------------------------------------------------|
C
      IMPLICIT NONE
C
#include "jparams.h"
#include "parim.h"
C
C     Function arguments.
C
      INTEGER NM
      REAL*8 SLAT
C
C     Parameters.
C
      INTEGER JPLIST, JPDEFL
      PARAMETER (JPLIST = 20 )
C                       = number of values which can be read
C
      PARAMETER (JPDEFL = 3 )
C                       = number of values in default list
C
C     Local variables.
C
      INTEGER FILENM, LOOP, LISTLEN
      INTEGER NMDEF(JPDEFL), INM(JPLIST)
      REAL*8 SLATDEF(JPDEFL), XLAT(JPLIST)
      CHARACTER*256 FILENAME
      CHARACTER*256 STANDARD
      CHARACTER*16 HOST
      LOGICAL LDEBUG, LFOUND
C
C     Externals
C
      DATA NMDEF/159,319,319/, SLATDEF/-14.0,60.0,-60.0/
      DATA LDEBUG/.FALSE./, LFOUND/.FALSE./
      DATA FILENM/65/
C
      SAVE LDEBUG, LFOUND, INM, XLAT, LISTLEN
C
C     -----------------------------------------------------------------|
C*    Section 1.   Initialise
C     -----------------------------------------------------------------|
C
  100 CONTINUE
C
      PPALLOW = .FALSE.
C
C     Only pick up configuration values on first call
C
      IF( LFOUND ) GOTO 400
C
      LFOUND = .TRUE.
C
      CALL JDEBUG()
      LDEBUG = NDBG.GT.0
C
C     -----------------------------------------------------------------|
C*    Section 2.   Open the configuration file
C     -----------------------------------------------------------------|
C
  200 CONTINUE
C
C     If the environment variable points to a file, try to open it.
C     Otherwise, get the file from a standard directory.
C
      CALL GETENV('PP_ALLOWED_ROTATIONS', FILENAME)
      IF( FILENAME(1:1).NE.' ' ) THEN
        IF( LDEBUG) CALL INTLOG(JP_DEBUG,
     X    'PPALLOW: Trying to open file '//FILENAME,JPQUIET)
        OPEN( FILENM, FILE=FILENAME, STATUS='OLD', ERR=300)
C
      ELSE
C
        CALL GETENV('HOST',HOST)
        IF( HOST(1:7).EQ.'vpp5000') THEN
          STANDARD = '/vpp5000/mrfs/postproc/pp_allowed_rotations'
        ELSE IF (HOST(1:7).EQ.'vpp700e') THEN
          STANDARD = '/vpp700e/mrfs/postproc/pp_allowed_rotations'
        ELSE IF (HOST(1:6).EQ.'vpp700') THEN
          STANDARD = '/vpp700/mrfs/postproc/pp_allowed_rotations'
        ELSE
          STANDARD = '/home/ma/emos/data/pp_allowed_rotations'
        ENDIF
        IF( LDEBUG) CALL INTLOG(JP_DEBUG,
     X    'PPALLOW: Trying to open file '//STANDARD,JPQUIET)
        OPEN( FILENM, FILE=STANDARD, STATUS='OLD', ERR=300)
      ENDIF
C
      IF( LDEBUG) CALL INTLOG(JP_DEBUG, 'PPALLOW: Open OK.',JPQUIET)
      LISTLEN = 0
C
  210 CONTINUE
C
      LISTLEN = LISTLEN + 1
      READ(FILENM,'(I4,1X,F8.4)',END=220) INM(LISTLEN), XLAT(LISTLEN)
      GOTO 210
C
  220 CONTINUE
      CLOSE(FILENM)
      LISTLEN = LISTLEN - 1
C
      GOTO 400
C
C     -----------------------------------------------------------------|
C*    Section 3.   Use the internally defined values.
C     -----------------------------------------------------------------|
C
  300 CONTINUE
C
      IF( LDEBUG) THEN
        CALL INTLOG(JP_DEBUG,
     X    'PPALLOW: No configuration file available.',JPQUIET)
        CALL INTLOG(JP_DEBUG,
     X  'PPALLOW: Using internally defined values.',JPQUIET)
      ENDIF
C
      DO LOOP = 1, JPDEFL
        INM(LOOP)  = NMDEF(LOOP)
        XLAT(LOOP) = SLATDEF(LOOP)
      ENDDO
      LISTLEN = JPDEFL
C
C     -----------------------------------------------------------------|
C*    Section 4.   Check the current values against the list.
C     -----------------------------------------------------------------|
C
  400 CONTINUE
C
      DO LOOP = 1, LISTLEN
        IF( (NM.EQ.INM(LOOP)).AND.(SLAT.EQ.XLAT(LOOP)) ) THEN
          IF( LDEBUG) THEN
            CALL INTLOG(JP_DEBUG,
     X      'PPALLOW: Rotation allowed in mrfs.',JPQUIET)
            CALL INTLOG(JP_DEBUG, 'PPALLOW: Truncation = ',NM)
            CALL INTLOGR(JP_DEBUG,'PPALLOW: Rotation = ', SLAT)
          ENDIF
          PPALLOW = .TRUE.
          GOTO 900
        ENDIF
      ENDDO
C
      IF( LDEBUG ) THEN
        CALL INTLOG(JP_DEBUG,
     X    'PPALLOW: Rotation NOT allowed in mrfs.',JPQUIET)
        CALL INTLOG(JP_DEBUG, 'PPALLOW: Truncation = ',NM)
        CALL INTLOGR(JP_DEBUG,'PPALLOW: Rotation = ', SLAT)
      ENDIF
C
C     -----------------------------------------------------------------|
C*    Section 9.   Return.
C     -----------------------------------------------------------------|
C
  900 CONTINUE
C
      RETURN
      END

C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      INTEGER FUNCTION KRG2RGU(OLDFLD, NEWFLD, NUMGGO, NUMGGN)
C
C---->
C**** KRG2RGU
C
C     Purpose
C     -------
C
C     Interpolate a field based on one reduced gaussian grid to a
C     field based on a different reduced gaussian grid.
C
C
C     Interface
C     ---------
C
C     IRET = KRG2RGU(OLDFLD, NEWFLD, NUMGGO, NUMGGN)
C
C     Input
C     -----
C
C     OLDFLD - Old field as array of values
C     NUMGGO - Number of the old gaussian field
C     NUMGGN - Number of the new gaussian field
C
C
C     Output
C     ------
C
C     NEWFLD - New field as array of values
C
C     Function returns:
C       - the size in bytes of the new GRIB product if all is well
C       - -1, otherwise.
C
C
C     Method
C     ------
C
C     Create new field and leave it unpacked.
C
C
C     Externals
C     ---------
C
C     KINTRG  - Interpolate reduced gaussian field to reduced gaussian
C     JMALLOC - Dynamically allocate memory
C     INTLOG  - Log messages
C
C
C     Author
C     ------
C
C     J.D.Chambers     ECMWF     February 2002
C
C     Modifications
C     -------------
C
C     Use grid definistion from input GRIB header to
C     cater for octahedral grid
C     S.Siemen         ECMWF     April 2015
C
C----<
C
      IMPLICIT NONE
C
C     Function arguments
C
      INTEGER NUMGGO, NUMGGN
      REAL OLDFLD(*), NEWFLD(*)
C
#include "parim.h"
#include "intisl.h"
#include "nifld.common"
#include "nofld.common"
#include "grfixed.h"
C
C     Parameters
C
      INTEGER JPINTB, JPREALB, JPMAXNG
      INTEGER JSEC2
      PARAMETER (JSEC2 = 5000)
#ifdef INTEGER_8
      PARAMETER (JPINTB = 8)
#else
      PARAMETER (JPINTB = 4)
#endif
      PARAMETER (JPMAXNG=4000)
#ifdef REAL_8
      PARAMETER (JPREALB = 8)
#else
      PARAMETER (JPREALB = 8)
#endif
C
C     Local variables
C
      INTEGER OLDGEO(JSEC2), NEWGEO(JSEC2)
      INTEGER LOOP
C
      REAL PLAT(JPMAXNG)
      REAL PFSEC3(2)
C
      INTEGER IRET
C
C     Externals
C
      INTEGER KINTRG
      EXTERNAL KINTRG
C
C     -----------------------------------------------------------------|
C*    Section 1.   Initialise
C     -----------------------------------------------------------------|
C
  100 CONTINUE
C
      KRG2RGU = 0
C
      IF( (NUMGGN*2).GT.JPMAXNG ) THEN
        CALL INTLOG(JP_ERROR,'KRG2RGU: Gaussian N too big = ',NUMGGN)
        CALL INTLOG(JP_ERROR,'KRG2RGU: Maximum handled = ',(JPMAXNG/2))
        KRG2RGU = -1
        GOTO 900
      ENDIF
C
C     -----------------------------------------------------------------|
C*    Section 2.   Create input and new field.
C     -----------------------------------------------------------------|
C
  200 CONTINUE
C
      DO LOOP = 1, JPMAXNG
        OLDGEO(LOOP) = 0
      ENDDO
      DO LOOP = 1, 2*NUMGGO
            OLDGEO(22+LOOP) = MILLEN(LOOP)
      ENDDO
      CALL JGETGG( NUMGGO, 'U', PLAT, OLDGEO(23), IRET)
      IF( IRET.NE.0 ) THEN
        WRITE(*,*) 'KRG2RGU: Problem calling JGETGG, status = ',IRET
        KRG2RGU = -1
      RETURN
      ENDIF
C      DO LOOP = 1, NUMGGO
C        WRITE(*,*) 'KRG2RGU: >>>>> ',LOOP,' = ',OLDGEO(22+LOOP),'',MILLEN(LOOP)
C      ENDDO

C
      OLDGEO(3)  = NUMGGO * 2
      OLDGEO(4)  = NINT(PLAT(1)*1000.0)
      OLDGEO(5)  = 0
      OLDGEO(7)  = NINT(PLAT(NUMGGO*2)*1000.0)
      OLDGEO(8)  = NINT((360.0-(360.0/REAL(NUMGGO*4)))*1000.0)
      OLDGEO(10) = NUMGGO
C
      DO LOOP = 1, JPMAXNG
        NEWGEO(LOOP) = 0
      ENDDO
      CALL JGETGG( NUMGGN, 'R', PLAT, NEWGEO(23), IRET)
      IF( IRET.NE.0 ) THEN
        WRITE(*,*) 'KRG2RGU: Problem calling JGETGG, status = ',IRET
        KRG2RGU = -1
        RETURN
      ENDIF
      NEWGEO(3)  = NUMGGN * 2
      NEWGEO(4)  = NINT(PLAT(1)*1000.0)
      NEWGEO(5)  = 0
      NEWGEO(7)  = NINT(PLAT(NUMGGN*2)*1000.0)
      NEWGEO(8)  = NINT((360.0-(360.0/REAL(NUMGGN*4)))*1000.0)
      NEWGEO(10) = NUMGGN
C
      IRET = KINTRG(OLDGEO, NEWGEO, OLDFLD, NEWFLD)
C
      IF( IRET.LE.0 ) THEN
        WRITE(*,*) 'KRG2RGU: New field creation failed'
        KRG2RGU = -1
        RETURN
      ENDIF
c sinisa for merging with grib_api
      NONS = 2*NOGAUSS
      NOAAPI(1) = NOAREA(1)
      NOAAPI(2) = NOAREA(2)
      NOAAPI(3) = NOAREA(3)
      NOAAPI(4) = NOAREA(4)
C
cs      KRG2RGU = IRET * JPINTB
cs this is the outlen
      KRG2RGU = IRET
C
C     -----------------------------------------------------------------|
C*    Section 9.   Return
C     -----------------------------------------------------------------|
C
  900 CONTINUE
C
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE ROWINA3( P, KO, KI, PW, KCODE, PMSVAL, KRET,
     X                    OMISNG, OPERIO, OVEGGY)
C
C---->
C**** ROWINA3 - Interpolation of row of values.
C
C     Purpose.
C     --------
C
C     Interpolate a row of values.
C
C
C**   Interface.
C     ----------
C
C     CALL ROWINA3( P, KO, KI, PW, KCODE, PMSVAL, KRET, OMISNG, OPERIO)
C
C
C     Input Parameters.
C     -----------------
C
C     P      - Row of values to be interpolated.
C              Dimension must be at least KO.
C
C     KO     - Number of values required.
C
C     KI     - Number of values in P on input.
C
C     PW     - Working array.
C              Dimension must be at least (0:KO+2,3).
C
C     KCODE  - Interpolation required.
C              1 , linear.
C              3 , cubic.
C
C     PMSVAL - Value used for missing data indicator.
C
C     OMISNG - True if missing values are present in field.
C
C     OPERIO - True if input field is periodic.
C
C     OVEGGY     - True if 'nearest neighbour' processing must be used
C                  for interpolation
C
C     Output Parameters.
C     ------------------
C
C     P     - Now contains KO values.
C     KRET  - Return code
C             0, OK
C             Non-zero, error
C
C
C     Method.
C     -------
C
C     Linear or cubic interpolation performed as required.
C
C
C     Externals.
C     ----------
C
C     SCM0
C
C
C     Reference.
C     ----------
C
C     None.
C
C
C     Comments.
C     ---------
C
C     This is a version of ROWINA which allows for missing data
C     values and hence for bitmapped fields.
C
C
C     Author.
C     -------
C
C     J.D.Chambers    ECMWF     22.07.94
C
C
C     Modifications.
C     --------------
C
C     J.D.Chambers    ECMWF     13.09.94
C     Add return code KRET and remove calls to ABORT.
C
C     J. Clochard, Meteo France, for ECMWF - January 1998.
C     Addition of OMISNG and OPERIO arguments.
C
C
C     -----------------------------------------------------------------
C----<
C
C*******************************************************************
C     Section 0.  Declarations.
C*******************************************************************
C
      IMPLICIT NONE
C
#include "common/grprs.h"
C
C     Subroutine arguments
      REAL P, PW, PMSVAL
      INTEGER KO,KI,KCODE, KRET
      DIMENSION P(KO),PW(0:KO+2,3)
C
C     Local variables
      INTEGER JL, IP
      REAL ZRDI, ZDO, ZPOS, ZWT, ZWT1
C
      LOGICAL OMISNG, OPERIO, OVEGGY
C
C*******************************************************************
C     Section 1.  Linear interpolation ..
C*******************************************************************
C
  100 CONTINUE
      IP = 0
C
      KRET = 0
C
      IF( KCODE.EQ.1 ) THEN
C
C        Move input values to work array
         DO 110 JL = 1, KI
            PW(JL,1) = P(JL)
  110    CONTINUE
C
         IF (OPERIO) THEN
C
C        Arrange wrap-around value in work array
           PW(KI+1,1) = P(1)
C
C          Set up constants to be used to figure out weighting for
C          values in interpolation.
           ZRDI = REAL(KI)
           ZDO  = 1.0 / REAL(KO)
         ELSE
C
C        Repeat last value, to cope with "implicit truncation" below
           PW(KI+1,1) = P(KI)
C
C          Set up constants to be used to figure out weighting for
C          values in interpolation.
           ZRDI = REAL(KI-1)
           ZDO  = 1.0 / REAL(KO-1)
         ENDIF
C
C        Loop through the output points
         IF ( .NOT. OMISNG ) THEN
C
            DO 120 JL = 1, KO
C
C           Calculate weight from the start of row
            ZPOS = (JL-1) * ZDO
            ZWT  = ZPOS * ZRDI
C
C           Get the current array position(minus 1) from the weight -
C           note the implicit truncation.
            IP   = ZWT
C
C           Adjust the weight to range (0.0 to 1.0)
            ZWT  = ZWT - IP
C
C           If 'nearest neighbour' processing must be used
C
            IF( OVEGGY ) THEN
C
              IF( ZWT.LT.0.5 ) THEN
                P(JL) = PW(IP+1,1)
              ELSE
                P(JL) = PW(IP+2,1)
              ENDIF
            ELSE
C
C             Interpolate using the weighted values on either side
C             of the output point position
              P(JL) = (1.0-ZWT) * PW(IP+1,1) + ZWT * PW(IP+2,1)
C
            ENDIF
C
  120       CONTINUE
C
         ELSE
C
         DO 130 JL = 1, KO
C
C           Calculate weight from the start of row
            ZPOS = (JL-1) * ZDO
            ZWT  = ZPOS * ZRDI
C
C           If 'nearest neighbour' processing must be used
C
            IF( OVEGGY ) THEN
C
              IF( ZWT.LT.0.5 ) THEN
                P(JL) = PW(IP+1,1)
              ELSE
                P(JL) = PW(IP+2,1)
              ENDIF
            ELSE
C
C             Get the current array position(minus 1) from the weight -
C             note the implicit truncation.
              IP   = ZWT
C
C             If the left value is missing, use the right value
              IF ( PW(IP+1,1) .EQ. PMSVAL ) THEN
                 P(JL) = PW(IP+2,1)
C
C             If the right value is missing, use the left value
              ELSE IF ( PW(IP+2,1) .EQ. PMSVAL ) THEN
                 P(JL) = PW(IP+1,1)
C
C             If neither missing, interpolate ...
              ELSE
C
C               Adjust the weight to range (0.0 to 1.0)
                ZWT  = ZWT - IP
C
C               Interpolate using the weighted values on either side
C               of the output point position
                P(JL) = (1.0-ZWT) * PW(IP+1,1) + ZWT * PW(IP+2,1)
              ENDIF
C
            ENDIF
C
  130    CONTINUE
C
       ENDIF
C
C*******************************************************************
C     Section 2.  Cubic interpolation ..
C*******************************************************************
C
  200 CONTINUE
C
      ELSEIF(KCODE.EQ.3) THEN
C
         IF ( OMISNG ) THEN
            WRITE(GRPRSM,*)
     X        'ROWINA3: Cubic interpolation not supported'
            WRITE(GRPRSM,*)
     X        'ROWINA3: for fields containing missing data.'
            WRITE(GRPRSM,*) ' Sorry!'
            KRET = 1
            GOTO 900
         ENDIF
C
         DO 210 JL = 1,KI
            IF ( P(JL) .EQ. PMSVAL ) THEN
              WRITE(GRPRSM,*) 
     X          'ROWINA3: Cubic interpolation not supported'
              WRITE(GRPRSM,*) 
     X          'ROWINA3: for fields containing missing data.'
              WRITE(GRPRSM,*) ' Sorry!'
              KRET = 1
              GOTO 900
            ENDIF
            PW(JL,1) = P(JL)
  210    CONTINUE
         PW(0,1) = P(KI)
         PW(KI+1,1) = P(1)
         PW(KI+2,1) = P(2)
         DO 220 JL = 1,KI
            PW(JL,2) =  - PW(JL-1,1)/3.0 - 0.5*PW(JL,1)
     1             + PW(JL+1,1)    - PW(JL+2,1)/6.0
            PW(JL+1,3) =    PW(JL-1,1)/6.0 - PW(JL,1)
     1             + 0.5*PW(JL+1,1) + PW(JL+2,1)/3.0
  220    CONTINUE
         CALL SCM0(PW(1,2),PW(2,3),PW(1,1),PW(2,1),KI)
         ZRDI = REAL(KI)
         ZDO = 1.0/REAL(KO)
         DO 230 JL = 1,KO
            ZPOS = (JL-1)*ZDO
            ZWT = ZPOS*ZRDI
            IP = ZWT+1
            ZWT = ZWT+1.0-IP
            ZWT1  =  1.0 - ZWT
            P(JL) = ((3.0-2.0*ZWT1)*PW(IP,1) + ZWT*PW(IP,2))*ZWT1*ZWT1
     1       + ((3.0-2.0*ZWT) *PW(IP+1,1) - ZWT1*PW(IP+1,3))*ZWT*ZWT
  230    CONTINUE
C
      ELSE
C
C*******************************************************************
C     Section 3.  Invalid interpolation code ..
C*******************************************************************
C
  300   CONTINUE
C
        WRITE(GRPRSM,9001) KCODE
        KRET = 2
      ENDIF
C
C*******************************************************************
C     Section 9.  Closedown.
C*******************************************************************
C
900   CONTINUE
      RETURN
C
 9001 FORMAT (1H ,'ROWINA3 : Invalid interpolation code = ',I4)
C
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      INTEGER FUNCTION REVERO ( KDATA,  KLENP,  KSEC2,  KGRIB,  KLENG,
     X                          KBITS,  KBMAP,  KVALS,  OPRIBI, OQUASI,
     X                          KNROWS, KLEN,   KWORK,  KLWORK, ODEBUG,
     X                          OPRCLN, KLENGR )
C
C---->
C**** REVERO
C
C     Purpose.
C     --------
C
C     Reverse order of even rows in a field of integer values.
C     This function is used for handling of boustrophedonic ordering
C     in extended second-order packing methods.
C
C
C**   Interface.
C     ----------
C
C     KRET = REVERO ( KDATA,  KLENP,  KSEC2,  KGRIB,  KLENG,  KBITS,
C    X                KBMAP,  KVALS,  OPRIBI, OQUASI, KNROWS, KLEN,
C    X                KWORK,  KLWORK, ODEBUG, OPRCLN, KLENGR )
C
C     Input Parameters.
C     ----------------
C
C     KDATA      - Array of normalized values.
C     KLENP      - Length of array KDATA.
C     KSEC2      - Array of GRIB section 2 integer descriptors.
C     KGRIB      - Array containing GRIB product (for bit-map).
C     KLENG      - Length of GRIB product array.
C     KBITS      - Number of bits per computer word.
C     KBMAP      - Bit pointer for start of explicit primary Bit-MAP
C                  (if any).
C     KVALS      - Number of bits in primary bit-map.
C     OPRIBI     - True if a PRImary BIt-map is present.
C     OQUASI     - True if the grid is QUASI-regular.
C     KNROWS     - Number of ROWS (or lines) in the grid.
C     KLEN       - Exact number of grid-points to handle.
C     KLWORK     - Length of work array KWORK.
C     ODEBUG     - True for some debug printout.
C     OPRCLN     - True if row lengthes have been pre-computed.
C
C     Input Parameters if OPRCLN is TRUE.
C     ------------------------------------
C     KLENGR     - Effective LENGth of Rows array.
C
C     Output Parameters if OPRCLN is FALSE.
C     ------------------------------------
C
C     KWORK      - Work array, used to unpack a primary bit-map, if any.
C
C     Method.
C     -------
C
C     Determines effective row length(es), and swaps fields values
C     for rows with an even rank.
C
C     Externals.
C     ----------
C
C     None.
C
C
C     Reference.
C     ----------
C
C     None.
C
C
C     Comments.
C     --------
C
C     Note that arrays KLENGR and KWORK are not used in the same call,
C     so they may overlap.
C
C
C     Author.
C     -------
C
C     J. Clochard, Meteo France, for ECMWF - January 1998.
C
C
C     Modifications.
C     _____________
C
C     None.
C
C
C----<
C     -----------------------------------------------------------------
C*    Section 0. Definition of variables.
C     -----------------------------------------------------------------
C
      IMPLICIT NONE
C
#include "common/grprs.h"
C
C
C     Subroutine arguments
C
      INTEGER KLENP, KBMAP, KVALS, KNROWS, KLEN, KLWORK, KLENG, KBITS
      INTEGER KDATA (KLENP), KSEC2 (*), KWORK (KLWORK), KGRIB (KLENG)
      INTEGER KLENGR (KNROWS)
C
      LOGICAL OPRIBI, OQUASI, ODEBUG, OPRCLN
C
C     Local variables.
C
      INTEGER IREFLN, IPTRBM, IRETFN, JROW, IPTOFF, ILNGTX, INBSEQ, J
      INTEGER JSEQ, IPTNBR, ICOUNT, ILNGTH, ILEN, INDEX1, INDEX2, IRET
      INTEGER IAUXIL
C
      CHARACTER YOPER*1
C
C     -----------------------------------------------------------------
C*    Section 1 . Performs initial computations.
C     -----------------------------------------------------------------
C
  100 CONTINUE
C
#ifndef ebug2o
      IF (ODEBUG) THEN
#endif
        WRITE(GRPRSM,FMT=9100) OPRCLN
#ifndef ebug2o
      ENDIF
#endif
C
      YOPER='D'
C
      IRETFN = 0
      IREFLN=22
      ICOUNT=0
C
      IF (OPRIBI) THEN
        IPTRBM=KBMAP
        ILEN=KVALS
      ELSE
        ILEN=KLEN
      ENDIF
C
      ILNGTX=ILEN/KNROWS
C
C     -----------------------------------------------------------------
C*    Section 2 . Loop on rows, wuth values swap for even rank rows.
C     -----------------------------------------------------------------
C
  200 CONTINUE
C
      DO 222 JROW=1,KNROWS
C
      IF (OQUASI) THEN
        ILNGTX=KSEC2(IREFLN+JROW)
      ENDIF
C
      IF (.NOT.OPRIBI.OR.ILNGTX.EQ.0) THEN
C
C         Effective length of row = full length.
C
        ILNGTH=ILNGTX
C
      ELSEIF (OPRCLN) THEN
C
        ILNGTH=KLENGR (JROW)
C
      ELSE
C
C         An (explicit) bit-map is included.
C         The number of values in current row has to be computed.
C
        ILNGTH=0
        INBSEQ=1+(ILNGTX-1)/KLWORK
C
        DO 212 JSEQ=1,INBSEQ
        IPTOFF=(JSEQ-1)*KLWORK
        IPTNBR=MIN (KLWORK,ILNGTX-IPTOFF)
        CALL INXBIT (KGRIB,KLENG,IPTRBM,KWORK,IPTNBR,KBITS,1,
     X               YOPER,IRET)
C
        IF (IRET.NE.0) THEN
          IRETFN = 23210
          WRITE(GRPRSM,FMT=9210) JROW, IPTOFF+1, IPTOFF+IPTNBR
          GOTO 900
        ENDIF
C
        DO 211 J=1,IPTNBR
        ILNGTH=ILNGTH+KWORK(J)
  211   CONTINUE
C
  212   CONTINUE
C
      ENDIF
C
      IF (MOD (JROW,2).EQ.0.AND.ILNGTH.GT.1) THEN
C
C             Swap field values within row.
C
#ifdef CRAY
CDIR$ IVDEP
#endif
#ifdef FUJITSU
!OCL NOVREC
#endif
        DO 221 J=1,ILNGTH/2
        INDEX1=ICOUNT+J
        INDEX2=ICOUNT+ILNGTH+1-J
        IAUXIL=KDATA(INDEX1)
        KDATA(INDEX1)=KDATA(INDEX2)
        KDATA(INDEX2)=IAUXIL
  221   CONTINUE
C
      ENDIF
C
      ICOUNT=ICOUNT+ILNGTH
C
  222 CONTINUE
C
      IF (ICOUNT.NE.KLEN) THEN
        IRETFN = 23220
        WRITE(GRPRSM,FMT=9220) ICOUNT, KLEN
        GOTO 900
      ENDIF      
C
C     -----------------------------------------------------------------
C*    Section 9. Return to calling routine.
C     -----------------------------------------------------------------
C
  900 CONTINUE
C
      REVERO = IRETFN
#ifndef ebug2o
C
      IF (ODEBUG) THEN
#endif
        WRITE(GRPRSM,FMT=9900) IRETFN
#ifndef ebug2o
      ENDIF
#endif
C
      RETURN
C
 9100 FORMAT (' REVERO: Function start, OPRCLN = ',L1,'.')
C
 9210 FORMAT (' REVERO: Problem unpacking primary bit-map,row',I6,
     X        ' points ',I8,'..',I8,'.')
C
 9220 FORMAT (' REVERO: Inconsistency: computed g.p. number =',I8,
     X        ', expected =',I8,'.')
C
 9900 FORMAT (' REVERO: Function return code =',I6,'.')
C
      END

C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE BUPKEY( KEY,KSEC1,KSEC2,KERR )
C
C**** *BUPKEY*
C
C
C     PURPOSE.
C     --------
C          PACK LOCAL ECMWF INFORMATION (RDB KEY) INTO KSEC2 ARRAY.
C
C
C**   INTERFACE.
C     ----------
C          *CALL* *BUPKEY(KEY,KSEC1,KSEC2,KERR)*
C
C        INPUT :
C               *KEY*     -  ARRAY CONTAINING RDB INFORMATION
C                            KEY( 1)-- LENGTH OF SECTION 2 (BYTES)
C                            KEY( 2)-- RDB TYPE
C                            KEY( 3)-- RDB SUBTYPE
C                            KEY( 4)-- YEAR
C                            KEY( 5)-- MONTH
C                            KEY( 6)-- DAY
C                            KEY( 7)-- HOUR
C                            KEY( 8)-- MINUTE
C                            KEY( 9)-- SECOND
C                            KEY(10)-- LONGITUDE1
C                            KEY(11)-- LATITUDE1
C                            KEY(12)-- LONGITUDE2
C                            KEY(13)-- LATITUDE2
C                            KEY(14)-- NUMBER OF SUBSETS
C                            KEY(15)-- IDENT (NUMERIC)
C                            KEY(16)-- IDENT ( CCITTIA5) ONE CHARACTER
C                            KEY(17)-- IDENT ( CCITTIA5) ONE CHARACTER
C                            KEY(18)-- IDENT ( CCITTIA5) ONE CHARACTER
C                            KEY(19)-- IDENT ( CCITTIA5) ONE CHARACTER
C                            KEY(20)-- IDENT ( CCITTIA5) ONE CHARACTER
C                            KEY(21)-- IDENT ( CCITTIA5) ONE CHARACTER
C                            KEY(22)-- IDENT ( CCITTIA5) ONE CHARACTER
C                            KEY(23)-- IDENT ( CCITTIA5) ONE CHARACTER
C                            KEY(24)-- IDENT ( CCITTIA5) ONE CHARACTER
C                            KEY(25)-- TOTAL BUFR MESSAGE LENGTH
C                            KEY(26)-- DAY    (RDB INSERTION)
C                            KEY(27)-- HOUR   (RDB INSERTION)
C                            KEY(28)-- MINUTE (RDB INSERTION)
C                            KEY(29)-- SECOND (RDB INSERTION)
C                            KEY(30)-- DAY    (MDB INSERTION)
C                            KEY(31)-- HOUR   (MDB INSERTION)
C                            KEY(32)-- MINUTE (MDB INSERTION)
C                            KEY(33)-- SECOND (MDB INSERTION)
C                            KEY(34)-- CORRECTION NUMBER
C                            KEY(35)-- PART
C                            KEY(36)-- 0
C                            KEY(37)-- CORRECTION NUMBER
C                            KEY(38)-- PART
C                            KEY(39)-- 0
C                            KEY(40)-- CORRECTION NUMBER
C                            KEY(41)-- PART
C                            KEY(42)-- 0
C                            KEY(43)-- CORRECTION NUMBER
C                            KEY(44)-- PART
C                            KEY(45)-- 0
C                            KEY(46)-- THE LOWEST Q/C % CONFIDENCE
C               *KSEC1*   -  ARRAY CONTAINING SECTION 1 INFORMATION
C                            KSEC1( 1)-- LENGTH OF SECTION 1 (BYTES)
C                            KSEC1( 2)-- BUFR EDITION NUMBER
C                            KSEC1( 3)-- ORIGINATING CENTRE
C                            KSEC1( 4)-- UPDATE SEQUENCE NUMBER
C                            KSEC1( 5)-- FLAG (PRESENCE OF SECTION 2)
C                            KSEC1( 6)-- BUFR MESSAGE TYPE
C                            KSEC1( 7)-- BUFR MESSAGE SUBTYPE
C                            KSEC1( 8)-- VERSION NUMBER OF LOCAL TABLE USED
C                            KSEC1( 9)-- YEAR
C                            KSEC1(10)-- MONTH
C                            KSEC1(11)-- DAY
C                            KSEC1(12)-- HOUR
C                            KSEC1(13)-- MINUTE
C                            KSEC1(14)-- BUFR MASTER TABLE
C                            KSEC1(15)-- VERSION NUMBER OF MASTER TABLE USED
C                            KSEC1(16) TO KSEC1(JSEC1) - LOCAL ADP CENTRE
C                                        INFORMATION(PACKED FORM)
C
C                            FOR BUFR EDITION 3 ONWARD
C
C                            KSEC1(16)-- ORIGINATING SUB-CENTRE
C                            KSEC1(17)-- NOT USED
C                            KSEC1(18) TO KSEC1(JSEC1) - LOCAL ADP CENTRE
C                                        INFORMATION(PACKED FORM)
C
C                            FOR BUFR EDITION 4 ONWARD
C
C                            KSEC1(16)-- ORIGINATING SUB-CENTRE
C                            KSEC1(17)-- INTERNATIONAL SUB-CATEGORY (SEE COMMON TABLE C-13
C                            KSEC1(18)-- SECOND
C                            KSEC1(19)-- YEAR
C                            KSEC1(20)-- MONTH
C                            KSEC1(21)-- DAY
C                            KSEC1(22)-- HOUR
C                            KSEC1(23)-- MINUTE
C                            KSEC1(24)-- SECOND
C                            KSEC1(25)-- YEAR
C                            KSEC1(26)-- MONTH
C                            KSEC1(27)-- DAY
C                            KSEC1(28)-- HOUR
C                            KSEC1(29)-- MINUTE
C                            KSEC1(30)-- SECOND
C                            KSEC1(31)-- MOST SOUTHERN LATITUDE  (-90 to 90)
C                            KSEC1(32)-- MOST WESTERN LONGITUDE  ( 0-360)
C                            KSEC1(33)-- MOST NORTHEN LATITUDE   (-90 to 90)
C                            KSEC1(34)-- MOST EASTERN LONGITUDE  ( 0-360)
C                            KSEC1(35) TO KSEC1(JSEC1) - LOCAL ADP CENTRE INFORMATION(PACKED FORM)
C
C        OUTPUT:
C               *KSEC2*   -  ARRAY CONTAINING SECTION 2 INFORMATION
C                            KSEC2( 1)-- LENGTH OF SECTION 2 (BYTES)
C                            KSEC2( 2) TO KSEC2(JSEC2) LOCAL ADP CENTRE
C                                        INFORMATION(PACKED FORM)
C               *KERR*    -  RETURNED ERROR CODE
C
C     METHOD.
C     -------
C
C          NONE.
C
C
C     EXTERNALS.
C     ----------
C
C
C     REFERENCE.
C     ----------
C
C          NONE.
C
C     AUTHOR.
C     -------
C
C          M. DRAGOSAVAC    *ECMWF*       17/01/91.
C
C
C     MODIFICATIONS.
C     --------------
C
C          NONE.
C
C
      IMPLICIT LOGICAL(L,O,G), CHARACTER*8(C,H,Y)
C
C
#     include "parameter.F"
#     include "bcomunit.F"
#     include "bcmwork.F"
#     include "bcmdefc.F"
C
      CHARACTER*4 CECMWF,CUSER
C
#ifndef R_4
      REAL*8 RVIND
      REAL*8 EPS
#else
      REAL   RVIND
      REAL   EPS
#endif
      DIMENSION KSEC1(JSEC1),KSEC2(JSEC2),KEY(JKEY)
      DIMENSION IDUM(8),KSEC3(JSEC3)
C
      DATA IDUM/8*0/

C
C*          1.  PACK LOCAL ADP CENTRE INFORMATION INTO KSEC2 ARRAY.
C                --------------------------------------------------
C
      KERR=0
C     
      IF(CECMWF.NE.'ECMF') THEN
         CALL BUIVAR(KERR)
         CECMWF='ECMF'
      END IF

C
C      IF(KSEC1(3).EQ.98) THEN
         IW=2
         IB=0
         CALL BUPCK(NBPW,KSEC2(IW),KEY(2)       ,IW,IB, 8,KERR)
         IF(KERR.GT.0) THEN
            WRITE(KNTN,*)  'ERROR PACKING KEY(2).'
            RETURN
         END IF
         CALL BUPCK(NBPW,KSEC2(IW),KEY(3)       ,IW,IB, 8,KERR)
         IF(KERR.GT.0) THEN
            WRITE(KNTN,*)  'ERROR PACKING KEY(3).'
            RETURN
         END IF
         CALL BUPCK(NBPW,KSEC2(IW),KEY(4)       ,IW,IB,12,KERR)
         IF(KERR.GT.0) THEN
            WRITE(KNTN,*)  'ERROR PACKING KEY(4).'
            RETURN
         END IF
         CALL BUPCK(NBPW,KSEC2(IW),KEY(5)       ,IW,IB, 4,KERR)
         IF(KERR.GT.0) THEN
            WRITE(KNTN,*)  'ERROR PACKING KEY(5).'
            RETURN
         END IF
         CALL BUPCK(NBPW,KSEC2(IW),KEY(6)       ,IW,IB, 6,KERR)
         IF(KERR.GT.0) THEN
            WRITE(KNTN,*)  'ERROR PACKING KEY(6).'
            RETURN
         END IF
         CALL BUPCK(NBPW,KSEC2(IW),KEY(7)       ,IW,IB, 5,KERR)
         IF(KERR.GT.0) THEN
            WRITE(KNTN,*)  'ERROR PACKING KEY(7).'
            RETURN
         END IF
         CALL BUPCK(NBPW,KSEC2(IW),KEY(8)       ,IW,IB, 6,KERR)
         IF(KERR.GT.0) THEN
            WRITE(KNTN,*)  'ERROR PACKING KEY(8).'
            RETURN
         END IF
         CALL BUPCK(NBPW,KSEC2(IW),KEY(9)       ,IW,IB, 6,KERR)
         IF(KERR.GT.0) THEN
            WRITE(KNTN,*)  'ERROR PACKING KEY(9).'
            RETURN
         END IF
         CALL BUPCK(NBPW,KSEC2(IW),0            ,IW,IB, 1,KERR)
         IF(KERR.GT.0) RETURN
         CALL BUPCK(NBPW,KSEC2(IW),KEY(10)      ,IW,IB,26,KERR)
         IF(KERR.GT.0) THEN
            WRITE(KNTN,*)  'ERROR PACKING KEY(10).'
            RETURN
         END IF
         CALL BUPCK(NBPW,KSEC2(IW),0            ,IW,IB, 6,KERR)
         IF(KERR.GT.0) RETURN
         CALL BUPCK(NBPW,KSEC2(IW),KEY(11)      ,IW,IB,25,KERR)
         IF(KERR.GT.0) THEN
            WRITE(KNTN,*)  'ERROR PACKING KEY(11).'
            RETURN
         END IF
         CALL BUPCK(NBPW,KSEC2(IW),0            ,IW,IB, 7,KERR)
         IF(KERR.GT.0) RETURN
C
         IF(KEY(14).GT.1.OR.KEY(2).EQ.2.OR.KEY(2).EQ.3.OR.
     1      KEY(2).EQ.12.OR.KEY(2).EQ.8) THEN
            CALL BUPCK(NBPW,KSEC2(IW),KEY(12)   ,IW,IB,26,KERR)
            IF(KERR.GT.0) THEN
               WRITE(KNTN,*)  'ERROR PACKING KEY(12).'
               RETURN
            END IF
            CALL BUPCK(NBPW,KSEC2(IW),0         ,IW,IB, 6,KERR)
            IF(KERR.GT.0) RETURN
            CALL BUPCK(NBPW,KSEC2(IW),KEY(13)   ,IW,IB,25,KERR)
            IF(KERR.GT.0) THEN
               WRITE(KNTN,*)  'ERROR PACKING KEY(13).'
               RETURN
            END IF
            CALL BUPCK(NBPW,KSEC2(IW),0         ,IW,IB, 7,KERR)
            IF(KERR.GT.0) RETURN
            IF(KEY(14).GT.255.OR.KEY(3).GE.121.AND.
     1         KEY(3).LE.130.OR.KEY(3).EQ.31) THEN
               CALL BUPCK(NBPW,KSEC2(IW),KEY(14),IW,IB,16,KERR)
               IF(KERR.GT.0) THEN
                  WRITE(KNTN,*)  'ERROR PACKING KEY(14).'
                  RETURN
               END IF
               CALL BUPCK(NBPW,KSEC2(IW),KEY(15),IW,IB,16,KERR)
               IF(KERR.GT.0) THEN
                  WRITE(KNTN,*)  'ERROR PACKING KEY(15).'
                  RETURN
               END IF
               CALL BUPKS(NBPW,KSEC2(IW),IDUM  ,IW,IB,8,0,4,KERR)
               IF(KERR.GT.0) RETURN
               CALL BUPCK(NBPW,KSEC2(IW),0      ,IW,IB, 8,KERR)
               IF(KERR.GT.0) RETURN
            ELSE
               CALL BUPCK(NBPW,KSEC2(IW),KEY(14),IW,IB, 8,KERR)
               IF(KERR.GT.0) THEN
                  WRITE(KNTN,*)  'ERROR PACKING KEY(14).'
                  RETURN
               END IF
               CALL BUPCK(NBPW,KSEC2(IW),KEY(15),IW,IB,16,KERR)
               IF(KERR.GT.0) THEN
                  WRITE(KNTN,*)  'ERROR PACKING KEY(15).'
                  RETURN
               END IF
               CALL BUPKS(NBPW,KSEC2(IW),IDUM      ,IW,IB,8,0,4,KERR)
               IF(KERR.GT.0) RETURN
               CALL BUPCK(NBPW,KSEC2(IW),0      ,IW,IB,16,KERR)
               IF(KERR.GT.0) RETURN
            END IF
            GO TO 140
         ELSE
            CALL BUPKS(NBPW,KSEC2(IW),KEY(16),IW,IB,8,0,9,KERR)
            IF(KERR.GT.0) THEN
               WRITE(KNTN,*)  'ERROR PACKING KEY(16).'
               RETURN
            END IF
            CALL BUPKS(NBPW,KSEC2(IW),IDUM(1),IW,IB,8,0,8,KERR)
            IF(KERR.GT.0) RETURN
         END IF
C
C
C*          1.4 SUB KEY INFORMATION.
C               --------------------
 140  CONTINUE
C
         CALL BUPCK(NBPW,KSEC2(IW),KEY(25),IW,IB,16,KERR)
         IF(KERR.GT.0) THEN
            WRITE(KNTN,*)  'ERROR PACKING KEY(25).'
            RETURN
         END IF
         CALL BUPCK(NBPW,KSEC2(IW),KEY(26),IW,IB, 6,KERR)
         IF(KERR.GT.0) THEN
            WRITE(KNTN,*)  'ERROR PACKING KEY(26).'
            RETURN
         END IF
         CALL BUPCK(NBPW,KSEC2(IW),KEY(27),IW,IB, 5,KERR)
         IF(KERR.GT.0) THEN
            WRITE(KNTN,*)  'ERROR PACKING KEY(27).'
            RETURN
         END IF
         CALL BUPCK(NBPW,KSEC2(IW),KEY(28),IW,IB, 6,KERR)
         IF(KERR.GT.0) THEN
            WRITE(KNTN,*)  'ERROR PACKING KEY(28).'
            RETURN
         END IF
         CALL BUPCK(NBPW,KSEC2(IW),KEY(29),IW,IB, 6,KERR)
         IF(KERR.GT.0) THEN
            WRITE(KNTN,*)  'ERROR PACKING KEY(29).'
            RETURN
         END IF
         CALL BUPCK(NBPW,KSEC2(IW),0      ,IW,IB, 1,KERR)
         IF(KERR.GT.0) RETURN
C
         CALL BUPCK(NBPW,KSEC2(IW),KEY(30),IW,IB, 6,KERR)
         IF(KERR.GT.0) THEN
            WRITE(KNTN,*)  'ERROR PACKING KEY(30).'
            RETURN
         END IF
         CALL BUPCK(NBPW,KSEC2(IW),KEY(31),IW,IB, 5,KERR)
         IF(KERR.GT.0) THEN
            WRITE(KNTN,*)  'ERROR PACKING KEY(31).'
            RETURN
         END IF
         CALL BUPCK(NBPW,KSEC2(IW),KEY(32),IW,IB, 6,KERR)
         IF(KERR.GT.0) THEN
            WRITE(KNTN,*)  'ERROR PACKING KEY(32).'
            RETURN
         END IF
         CALL BUPCK(NBPW,KSEC2(IW),KEY(33),IW,IB, 6,KERR)
         IF(KERR.GT.0) THEN
            WRITE(KNTN,*)  'ERROR PACKING KEY(33).'
            RETURN
         END IF
         CALL BUPCK(NBPW,KSEC2(IW),0      ,IW,IB, 1,KERR)
         IF(KERR.GT.0) RETURN
         CALL BUPCK(NBPW,KSEC2(IW),KEY(34),IW,IB, 6,KERR)
         IF(KERR.GT.0) THEN
            WRITE(KNTN,*)  'ERROR PACKING KEY(34).'
            RETURN
         END IF
         CALL BUPCK(NBPW,KSEC2(IW),KEY(35),IW,IB, 1,KERR)
         IF(KERR.GT.0) THEN
            WRITE(KNTN,*)  'ERROR PACKING KEY(35).'
            RETURN
         END IF
         CALL BUPCK(NBPW,KSEC2(IW),KEY(36),IW,IB, 1,KERR)
         IF(KERR.GT.0) THEN
            WRITE(KNTN,*)  'ERROR PACKING KEY(36).'
            RETURN
         END IF
         CALL BUPCK(NBPW,KSEC2(IW),KEY(37),IW,IB, 6,KERR)
         IF(KERR.GT.0) THEN
            WRITE(KNTN,*)  'ERROR PACKING KEY(37).'
            RETURN
         END IF
         CALL BUPCK(NBPW,KSEC2(IW),KEY(38),IW,IB, 1,KERR)
         IF(KERR.GT.0) THEN
            WRITE(KNTN,*)  'ERROR PACKING KEY(38).'
            RETURN
         END IF
         CALL BUPCK(NBPW,KSEC2(IW),KEY(39),IW,IB, 1,KERR)
         IF(KERR.GT.0) THEN
            WRITE(KNTN,*)  'ERROR PACKING KEY(39).'
            RETURN
         END IF
         CALL BUPCK(NBPW,KSEC2(IW),KEY(40),IW,IB, 6,KERR)
         IF(KERR.GT.0) THEN
            WRITE(KNTN,*)  'ERROR PACKING KEY(40).'
            RETURN
         END IF
         CALL BUPCK(NBPW,KSEC2(IW),KEY(41),IW,IB, 1,KERR)
         IF(KERR.GT.0) THEN
            WRITE(KNTN,*)  'ERROR PACKING KEY(41).'
            RETURN
         END IF
         CALL BUPCK(NBPW,KSEC2(IW),KEY(42),IW,IB, 1,KERR)
         IF(KERR.GT.0) THEN
            WRITE(KNTN,*)  'ERROR PACKING KEY(42).'
            RETURN
         END IF
         CALL BUPCK(NBPW,KSEC2(IW),KEY(43),IW,IB, 6,KERR)
         IF(KERR.GT.0) THEN
            WRITE(KNTN,*)  'ERROR PACKING KEY(43).'
            RETURN
         END IF
         CALL BUPCK(NBPW,KSEC2(IW),KEY(44),IW,IB, 1,KERR)
         IF(KERR.GT.0) THEN
            WRITE(KNTN,*)  'ERROR PACKING KEY(44).'
            RETURN
         END IF
         CALL BUPCK(NBPW,KSEC2(IW),KEY(45),IW,IB, 1,KERR)
         IF(KERR.GT.0) THEN
            WRITE(KNTN,*)  'ERROR PACKING KEY(45).'
            RETURN
         END IF
         CALL BUPCK(NBPW,KSEC2(IW),KEY(46),IW,IB, 8,KERR)
         IF(KERR.GT.0) THEN
            WRITE(KNTN,*)  'ERROR PACKING KEY(46).'
            RETURN
         END IF
C
C      ELSE
C         WRITE(KNTN,'(1H )')
C         WRITE(KNTN,'(1H ,A)') 'BUPKEY : KEY DEFINITION NOT PACKED.'
C         WRITE(KNTN,'(1H )')
C      END IF
C
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      INTEGER FUNCTION OUTREP()
C
C---->
C*****OUTREP*
C
C     PURPOSE
C     -------
C
C     LNOREPR      - Flag to say whether or not user specified NOREPR 

#include "parim.h"
#include "nifld.common"
#include "nofld.common"

      OUTREP = 1

      IF(LNOREPR) OUTREP = 0

      IF( OUTREP.EQ.1 ) THEN
        CALL INTLOG(JP_DEBUG,
     X 'OUTREP: Output Representation is Not specified',JPQUIET)
      ENDIF
C
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE INXBIT (KGRIB,KLENG,KNSPT,KPARM,KNUM,KBIT,
     C                   KBLEN,HFUNC,KRET)
C
C---->
C**** INXBIT - Insert/extract bits consecutively in/from a given array
C
C     Purpose.
C     --------
C
C           Take rightmost KBLEN bits from KNUM words of KPARM
C           and insert them consecutively in KGRIB, starting at
C           bit after KNSPT or vice versa.
C
C**   Interface.
C     ----------
C
C           CALL INXBIT (KGRIB,KLENG,KNSPT,KPARM,KNUM,KBIT,
C    C                   KBLEN,KRET)
C
C           Integer    K.
C           Real       P.
C           Logical    O.
C           Character  H.
C
C               Input Parameters.
C               -----------------
C
C               KGRIB      - Array containing bitstream.
C               KLENG      - Length (words) of this array.
C               KNSPT      - Bit number after which insertion or
C                            extraction starts.
C               KPARM      - Array from which bits are taken for
C                            insertion in the bitstream or to which
C                            bits are extracted from the bitstream.
C               KBIT       - Number of bits in computer word.
C               KNUM       - Number of bit fields inserted/extracted.
C               KBLEN      - Number of bits per bit field.
C               HFUNC      - Requested function.
C                            'C' to insert bits in bitstream,
C                            'D' to extract bits from bitstream.
C
C               Output Parameters.
C               ------------------
C
C               KNSPT      - Bit number of last bit inserted/extracted.
C
C               KRET       - Return code.
C                            0 , No error encountered.
C                            1 , Insertion/extraction exceeded
C                                array boundary.
C
C     Method.
C     -------
C
C           Word and offset pointer calculated before calling
C           insertion/extraction routines.
C
C     Externals.
C     ----------
C
C           SBYTES6
C           GBYTES6
C
C     Reference.
C     ----------
C
C           ECLIB documentation on SBYTES and GBYTES.
C
C     Comments.
C     ---------
C
C           Cyber version of routine.
C           Routine contains Sections 0 to 3 and Section 9.
C
C     Author.
C     -------
C
C           J. Hennessy      ECMWF      18.06.91
C
C     Modifications.
C     --------------
C
C           J. Hennessy      ECMWF      08.11.91
C           Parameter KMACH removed from list of input parameters.
C
C           J. Hennessy      ECMWF      12.10.92
C           Dimension of IMASK changed from 64 to 65.
C
C     ----------------------------------------------------------------
C----<
C
C
C
C
C
C
C
C
C
C
C*    Section 0 . Definition of variables. Data statements.
C     ----------------------------------------------------------------
C
C*    Prefix conventions for variable names.
C
C     Logical      L (but not LP), global or common.
C                  O, dummy arguments.
C                  G, local variable.
C                  LP, parameter.
C     Character    C, Global or common.
C                  H, dummy arguments.
C                  Y (but not YP), local variables.
C                  YP, parameter.
C     Integer      M and N, global or common.
C                  K, dummy arguments.
C                  I, local variables.
C                  J (but not JP), loop control.
C                  JP, parameter.
C     Real         A to F and Q to X, global or common.
C                  P (but not PP), dummy arguments.
C                  Z, local variables.
C                  PP, parameter.
C
      INTEGER IND
      INTEGER INUM
      INTEGER IOFF
      INTEGER IPR
      INTEGER IWORD
C
      INTEGER KBIT
      INTEGER KBLEN
      INTEGER KGRIB
      INTEGER KLENG
      INTEGER KNSPT
      INTEGER KNUM
      INTEGER KPARM
      INTEGER KRET
C
      INTEGER J901
C
      DIMENSION KGRIB(KLENG)
      DIMENSION KPARM(*)
C
      CHARACTER*1 HFUNC
C
C
C     Debug print switch.
C
      DATA IPR /0/
C
C     ----------------------------------------------------------------
C
C
C
C
C
C
C
C
C
C
C*    Section 1 . Set initial values.
C     ----------------------------------------------------------------
C
  100 CONTINUE
C
      IF (IPR.EQ.1)
     C   THEN
             WRITE (*,*) 'INXBIT : Section 1.'
             WRITE (*,*) '         Input values used -'
             WRITE (*,9009) KLENG
             WRITE (*,9002) KNSPT
             WRITE (*,9004) KBIT
             WRITE (*,9005) HFUNC
         ENDIF
C
      KRET = 0
C
C     ----------------------------------------------------------------
C
C
C
C
C
C
C
C
C
C
C*    Section 2 . Bit insertion/extraction.
C     ----------------------------------------------------------------
C
  200 CONTINUE
C
      IF (IPR.EQ.1) WRITE (*,*) 'INXBIT : Section 2.'
C
C*    Calculate word pointer and offset.
C
      IWORD = KNSPT / KBIT
      IOFF  = KNSPT - IWORD * KBIT
      IWORD = IWORD + 1
      IF (IPR.EQ.1) WRITE (*,9003) IWORD , IOFF
C
C     Insert/extract bits.
C
      IF (HFUNC.EQ.'C')
     C   THEN
             CALL SBYTES6 (KGRIB(IWORD),KPARM,IOFF,KBLEN,0,KNUM)
         ELSE
             CALL GBYTES6 (KGRIB(IWORD),KPARM,IOFF,KBLEN,0,KNUM)
         ENDIF
C
C     Update pointer.
C
      KNSPT = KNSPT + KBLEN * KNUM
C
C     ----------------------------------------------------------------
C
C
C
C
C
C
C
C
C
C
C*    Section 3 . Check out of range.
C    -----------------------------------------------------------------
C
  300 CONTINUE
C
      IF (IPR.EQ.1) WRITE (*,*) 'INXBIT : Section 3.'
C
      IND = KNSPT / KBIT
      IF (IND.GT.KLENG)
     C   THEN
             KRET = 1
             WRITE (*,9001) IND , KLENG
         ENDIF
C
C     ----------------------------------------------------------------
C
C
C
C
C
C
C
C
C
C
C*    Section 9 . Return to calling routine. Format statements.
C     ----------------------------------------------------------------
C
  900 CONTINUE
C
      IF (IPR.EQ.1)
     C   THEN
             INUM = KNUM
             IF (INUM.GT.360)
     C          THEN
                    INUM = 360
                    WRITE (*,9007) INUM
                ENDIF
             DO 901 J901=1,INUM
               IF (HFUNC.EQ.'C')
     C             THEN
                       WRITE (*,9006) KPARM(J901)
                   ELSE
                       WRITE (*,9008) KPARM(J901)
                   ENDIF
  901        CONTINUE
             WRITE (*,*) 'INXBIT : Section 9.'
             WRITE (*,*) '         Output values set -'
             WRITE (*,9002) KNSPT
         ENDIF
C
C
 9001 FORMAT (1H ,'INXBIT : Word ',I8,' is outside array bounds ',I8)
C
 9002 FORMAT (1H ,'         KNSPT  = ',I8)
C
 9003 FORMAT (1H ,'INXBIT : Word is',I8,', bit offset is ',I2)
C
 9004 FORMAT (1H ,'         KBIT   = ',I8)
C
 9005 FORMAT (1H ,'         HFUNC  = ',A)
C
 9006 FORMAT (1H ,'         Inserted value = ',I20)
C
 9007 FORMAT (1H ,'         First ',I9,' values.')
C
 9008 FORMAT (1H ,'         Extracted value = ',I20)
C
 9009 FORMAT (1H ,'         KLENG  = ',I20)
C
      RETURN
C
      END
      SUBROUTINE ABORTX (HNAME)
C
C**** ABORTX - Terminates execution of program.
C
C     Purpose.
C     --------
C
C           Terminates execution of program.
C
C**   Interface.
C     ----------
C
C           CALL ABORTX (HNAME)
C
C           Integer    K.
C           Real       P.
C           Logical    O.
C           Character  H.
C
C               Input Parameters.
C               -----------------
C
C               HNAME      - Name of calling routine.
C
C               Output Parameters.
C               ------------------
C
C               None.
C
C     Method.
C     -------
C
C           Prints message and terminates.
C
C     Externals.
C     ----------
C
C           ABORT
C
C     Reference.
C     ----------
C
C           None.
C
C     Comments.
C     ---------
C
C           Cyber version of routine.
C           Routine contains Sections 0 to 1 and Section 9.
C
C     Author.
C     -------
C
C           J. Hennessy      ECMWF      13.11.91
C
C     Modifications.
C     --------------
C
C           None.
C
C     ------------------------------------------------------------------
C
C
C
C
C
C
C
C
C
C
C*    Section 0 . Definition of variables.
C     ------------------------------------------------------------------
C
C*    Prefix conventions for variable names.
C
C     Logical      L (but not LP), global or common.
C                  O, dummy arguments.
C                  G, local variable.
C                  LP, parameter.
C     Character    C, Global or common.
C                  H, dummy arguments.
C                  Y (but not YP), local variables.
C                  YP, parameter.
C     Integer      M and N, global or common.
C                  K, dummy arguments.
C                  I, local variables.
C                  J (but not JP), loop control.
C                  JP, parameter.
C     Real         A to F and Q to X, global or common.
C                  P (but not PP), dummy arguments.
C                  Z, local variables.
C                  PP, parameter.
C
C
      CHARACTER*(*) HNAME
C
C     ------------------------------------------------------------------
C
C
C
C
C
C
C
C
C
C
C*    Section 1 . Print message and terminate.
C     ------------------------------------------------------------------
C
  100 CONTINUE
C
      WRITE (*,9001) HNAME
C
      CALL ABORT ('US',0,' ')
C
C     ------------------------------------------------------------------
C
C
C
C
C
C
C
C
C
C*    Section 9 . Format statements.
C     ------------------------------------------------------------------
C
  900 CONTINUE
C
 9001 FORMAT (1H ,'ABORTX : Routine ',A,' has requested program',
     C               ' termination.')
C
      RETURN
C
      END
      SUBROUTINE SETPAR (KBIT,KNEG,KPR)
C
C**** SETPAR - Set number of bits in word. Set maximum negative integer.
C
C     Purpose.
C     --------
C
C           Set number of bits in word. Set maximum negative integer.
C
C**   Interface.
C     ----------
C
C           CALL SETPAR (KBIT,KNEG,KPR)
C
C           Integer    K.
C           Real       P.
C           Logical    O.
C           Character  H.
C
C               Input Parameters.
C               -----------------
C
C               KPR        - Debug print switch.
C                            1 , print out.
C                            0 , No print out.
C
C               Output Parameters.
C               ------------------
C
C               KBIT       - Number of bits in computer word.
C
C               KNEG       - Maximum negative integer.
C
C     Method.
C     -------
C
C           Values are assigned.
C
C     Externals.
C     ----------
C
C           None.
C
C     Reference.
C     ----------
C
C           None.
C
C     Comments.
C     ---------
C
C           Cyber version of routine.
C           Routine contains Sections 0 to 3 and Section 9.
C
C     Author.
C     -------
C
C           J. Hennessy      ECMWF      28.10.91
C
C     Modifications.
C     --------------
C
C           None.
C
C     ------------------------------------------------------------------
C
C
C
C
C
C
C
C
C
C
C*    Section 0 . Definition of variables. Data statements.
C     ------------------------------------------------------------------
C
C*    Prefix conventions for variable names.
C
C     Logical      L (but not LP), global or common.
C                  O, dummy arguments.
C                  G, local variable.
C                  LP, parameter.
C     Character    C, Global or common.
C                  H, dummy arguments.
C                  Y (but not YP), local variables.
C                  YP, parameter.
C     Integer      M and N, global or common.
C                  K, dummy arguments.
C                  I, local variables.
C                  J (but not JP), loop control.
C                  JP, parameter.
C     Real         A to F and Q to X, global or common.
C                  P (but not PP), dummy arguments.
C                  Z, local variables.
C                  PP, parameter.
C
C
      INTEGER KBIT
      INTEGER KNEG
      INTEGER KPR
C
C     ------------------------------------------------------------------
C
C
C
C
C
C
C
C
C
C
C*    Section 1 . Assign values.
C     ------------------------------------------------------------------
C
  100 CONTINUE
C
      IF (KPR.EQ.1)  WRITE (*,*) ' SETPAR : Section 1.'
C
      KBIT = 64
      KNEG = -9223372036854775807
C
C     ------------------------------------------------------------------
C
C
C
C
C
C
C
C
C
C*    Section 9 . Return to calling routine. Format statements.
C     ------------------------------------------------------------------
C
  900 CONTINUE
C
      IF (KPR.EQ.1)
     C   THEN
             WRITE (*,*) ' SETPAR : Section 9.'
             WRITE (*,*) '          Output values set -'
             WRITE (*,9001) KBIT
             WRITE (*,9002) KNEG
         ENDIF
C
 9001 FORMAT (1H ,'          KBIT = ',I3)
C
 9002 FORMAT (1H ,'          KNEG = ',I22)
C
      RETURN
C
      END
      SUBROUTINE GBYTE(SOURCE,DEST,IOFSET,IBYTSZ)
C
C**** GBYTE - Get a single bit field from SOURCE into DEST on Cyber.
C
C*    INPUT   : SOURCE(1)= WORD CONTAINING START OF BIT FIELD
C*              DEST     = TARGET WORD
C*              IOFSET   = OFFSET IN BITS FOR START OF THE FIELD
C*              IBYTSZ   = LENGTH OF FIELD IN BITS
C*
C*    OUTPUT  : SOURCE,IOFSET,IBYTSZ UNCHANGED
C*              DEST CONTAINS FIELD RIGHT JUSTIFIED
C*
C*    AUTHOR  : M.MIQUEU   08/1981 (REWRITTEN FROM J.MARTELLET'S)
C*
C*****
      INTEGER SOURCE(1),DEST
      INTEGER SH1


      NBPW=64
      SH1=IOFSET+IBYTSZ-NBPW

      IF(SH1.GT.0) GO TO 2


C     BYTES DO NOT SPAN WORDS


      SH1=NBPW+SH1


      DEST=AND(
     1          SHIFT(SOURCE(1),SH1),
     2          SHIFT(MASK(IBYTSZ),IBYTSZ)
     3        )

      RETURN

C     BYTE SPANS WORDS

2     CONTINUE


      DEST=OR(
     1        SHIFT(
     2              AND(SOURCE(1),COMPL(MASK(IOFSET)))
     3              ,SH1),
     4        SHIFT(
     5              AND(SOURCE(2),MASK(SH1))
     6              ,SH1)
     7       )



      RETURN
      END
      SUBROUTINE GBYTES(S,D,ISKIP1,IBSIZ,ISKIP2,NBYTES,KWOFF)
C
C**** GBYTES - Cyber version.
C
C S CONTAINS A BIT STRING OF INDEFINITE LENGTH. GBYTES WILL
C EXTRACT NBYTES BITSTRINGS, IBSIZ BITS LONG, AND STORE THEM
C RIGHT JUSTIFIED 0 FILL, INTO SUCCESSIVE WORDS OF D. THE
C SUCCESSIVE BITSTRINGS START AT BIT POSITIONS
C     ISKIP1+1+(IBYTE-1)*(IBSIZ+ISKIP2)
C IN THE BIT STRING S. I.E. SKIP ISKIP1 BITS AT THE START,
C AND ISKIP2 BITS BETWEEN THE EXTRACTED STRINGS.
C BIT ISKP+1 IN A STRING IS FOUND IN WORD IS=1+ISKIP/NBPW IN S,
C WHERE NBPW IS THE NUMBER OF BITS PER WORD. THE STARTING BIT
C IS FOUND BY SKIPPING MOD(ISKP,NBPW) BITS IN THAT WORD.
C KWOFF IS AN OPTIONAL 7TH PARAMETER, WHICH DEFAULTS TO 0
C IF PRESENT KWOFF BITS ARE TOTALLY IGNORED AT THE START OF A WORD
C THUS IF A PACKED CYBER BIT STRING IS TRANSFERRED TO THE
C CRAY, WITH EACH 60 BIT CYBER WORD PLACED AT THE RIGHT END OF
C A 64 BIT CRAY WORD, A BYTE SEQUENCE WHICH WAS ORIGINALLY
C LOCATED WITH START POINTS IN ARITHMETIC PROGRESSION ON THE
C CYBER, WILL NO LONGER HAVE THIS PROPERTY ON THE CRAY. BY
C USING THE ROUTINE WITH KWOFF=4, THE ELEMENTS OF THE BYTE
C SEQUENCE CAN BE EXTRACTED ON THE CRAY, USING THE SAME SKIPS
C AS WERE USED ON THE CYBER.
      DIMENSION S(2) , D(NBYTES)
      INTEGER SH1
      ENTRY GBYTES7 (S,D,ISKIP1,IBSIZ,ISKIP2,NBYTES,KWOFF)
      IGNORE = KWOFF
      GO TO 10
      ENTRY GBYTES6 (S,D,ISKIP1,IBSIZ,ISKIP2,NBYTES)
      IGNORE = 0
   10 CONTINUE
      NBPW=64
      IS=1+ISKIP1/(NBPW-IGNORE)
      ISKIP = MOD(ISKIP1,NBPW-IGNORE) + IGNORE
      ISTEP = ISKIP2+IBSIZ
      DO 75 IBYTE = 1 , NBYTES
C WITH THE STARTING WORD AND BIT POSITION DETERMINED, THE
C DESIRED EXTRACTION CAN BE DONE BY
C***     CALL GBYTE(S(IS),D(IBYTE),ISKIP,IBSIZ)
C BUT SINCE THE CODE IS SHORT IT IS INSERTED IN-LINE.
         SH1 = ISKIP+IBSIZ
         IF(SH1.GT.NBPW) GO TO 50
C BYTE COMES FROM 1 WORD OF S
         D(IBYTE) = AND( SHIFT(S(IS),SH1),SHIFT(MASK(IBSIZ),IBSIZ))
         GO TO 65
   50    CONTINUE
         SH1 =SH1-NBPW
C BYTE COMES FROM 2 WORDS OF S.
         D(IBYTE) = OR(SHIFT(AND(S(IS),COMPL(MASK(ISKIP))),SH1)
     1                           ,
     2                SHIFT(AND(SHIFT(S(IS+1),IGNORE),MASK(SH1)),SH1)
     3                 )
   65    CONTINUE
C UPDATE STARTING WORD AND BIT POSITION
         ISKIP = ISKIP+ISTEP
         IF(ISKIP.LT.NBPW) GO TO 75
         ISKIP =ISKIP-NBPW
         IS = IS+1+ISKIP/(NBPW-IGNORE)
         ISKIP = MOD(ISKIP,NBPW-IGNORE) + IGNORE
   75 CONTINUE
      RETURN
      END
      SUBROUTINE SBYTE(DEST,SOURCE,IOFSET,IBYTSZ)
C
C**** GBYTE - Store a single bit field from SOURCE into DEST on Cyber.
C
C*    INPUT   : SOURCE   = WORD CONTAINING  BIT FIELD RIGHT JUSTIFIED
C*              DEST(1)  = 1ST TARGET WORD
C*              IOFSET   = OFFSET IN BITS FOR START OF THE FIELD
C*              IBYTSZ   = LENGTH OF FIELD IN BITS ; .LE.WORD SIZE .....
C*
C*    OUTPUT  : SOURCE,IOFSET,IBYTSZ UNCHANGED
C*              DEST(1) AND EVENTUALLY DEST(2) CONTAIN FIELD
C*
C*    AUTHOR  : M.MIQUEU   08/1981 (REWRITTEN FROM J.MARTELLET'S)
C*
C*****
      INTEGER SOURCE,DEST(1)
      INTEGER SH1,SH2,SH3


      NBPW=64
      SH1=IOFSET+IBYTSZ
      IF(SH1.GT.NBPW) GO TO 2

      SH2=NBPW-SH1
      IF(SH2.LT.0) SH2=NBPW-SH2

C     BYTE  DOES NOT SPAN WORDS


      DEST(1)=SHIFT(
     1              OR(
     2                 AND(SHIFT(DEST(1),SH1),
     3                     SHIFT(COMPL(MASK(IBYTSZ)),IBYTSZ) )
     4                 ,
     5                 AND(SOURCE,
     6                     COMPL(SHIFT(COMPL(MASK(IBYTSZ)),IBYTSZ)) )
     7                 )
     8              ,SH2)



      RETURN

2     CONTINUE

C     BYTE SPANS 2 WORDS

      SH3=2*NBPW-SH1


      DEST(1)=OR(
     1           AND(DEST(1),MASK(IOFSET))
     2           ,
     3           AND(SHIFT(SOURCE,SH3) , COMPL(MASK(IOFSET)) )
     4           )

      DEST(2)=OR(
     1           AND(DEST(2) , COMPL(MASK(SH1-NBPW)) )
     2           ,
     3           SHIFT( AND(SOURCE , COMPL(MASK(SH3)) ) ,SH3)
     4           )



      RETURN
      END
      SUBROUTINE SBYTES(D,S,ISKIP1,IBSIZ,ISKIP2,NBYTES,KWOFF)
C
C**** SBYTES - Cyber version.
C
C REVERSES THE ACTION OF GBYTES, TAKING FIELDS FROM S AND
C INSERTING THEM INTO A BIT STRING IN D. SEE GBYTES.
C AUTHOR D. ROBERTSON  AUG,1981
      DIMENSION D(2) , S(NBYTES)
      INTEGER SH1,SH2,SH3
      ENTRY SBYTES7 (D,S,ISKIP1,IBSIZ,ISKIP2,NBYTES,KWOFF)
      IGNORE = KWOFF
      GO TO 10
      ENTRY SBYTES6 (D,S,ISKIP1,IBSIZ,ISKIP2,NBYTES)
      IGNORE = 0
   10 CONTINUE
      NBPW=64
      ID=1+ISKIP1/(NBPW-IGNORE)
      ISKIP = MOD(ISKIP1,NBPW-IGNORE) + IGNORE
      ISTEP = ISKIP2+IBSIZ
      DO 75 IBYTE = 1 , NBYTES
C WITH THE STARTING WORD AND BIT POSITION KNOWN, THE
C DESIRED INSERTION CAN BE DONE BY
C**      CALL SBYTE(D(ID),S(IBYTE),ISKIP,IBSIZ)
C BUT THE CODE IS SHORT ENOUGH TO GO IN-LINE.
         SH1 = ISKIP+IBSIZ
         IF(SH1.GT.NBPW) GO TO 50
         SH2 = NBPW-SH1
         IF(SH2.LT.0) SH2 = NBPW-SH2
C BYTE GOES INTO 1 WORD OF D.
         D(ID) = SHIFT(OR(AND(SHIFT(D(ID),SH1),MASK(NBPW-IBSIZ)),
     1                   AND(S(IBYTE),SHIFT(MASK(IBSIZ),IBSIZ))),SH2)
         GO TO 65
   50    CONTINUE
C BYTE GOES INTO 2 WORDS OF D.
         SH3 = 2*NBPW-SH1
         D(ID)=OR(AND(D(ID),MASK(ISKIP)),
     1               AND(SHIFT(S(IBYTE),SH3),COMPL(MASK(ISKIP))))
         D(ID+1)=OR(AND(D(ID+1),SHIFT(COMPL(MASK(SH1-NBPW)),NBPW-IGNORE)
     1                 ),
     2              SHIFT(AND(S(IBYTE),COMPL(MASK(SH3))),SH3-IGNORE))
   65    CONTINUE
C UPDATE STARTING WORD AND BIT POSITION
         ISKIP = ISKIP+ISTEP
         IF(ISKIP.LT.NBPW) GO TO 75
         ISKIP = ISKIP - NBPW
         ID = ID+1+ISKIP/(NBPW-IGNORE)
         ISKIP = MOD(ISKIP,NBPW-IGNORE) + IGNORE
   75    CONTINUE
      RETURN
      END

C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE CREXS2DATA(KBUFL ,YBUFF ,KSUP  ,KSEC3, KELEM,
     1                      CNAMES,CUNITS,KVALS,VALUES,CVALS,KERR)
C
C**** *CREXS2DATA*
C
C
C     PURPOSE.
C     --------
C          Expand section 2 of Crex (data section)
C
C
C**   INTERFACE.
C     ----------
C
C          *CALL* *CREXS2DATA(KBUFL,YBUFF,KSUP,KSEC3,KELEM,CNAMES,
C                         CUNITS,KVALS,VALUES,CVALS,KERR)*
C
C        INPUT :
C               *KBUFL*   -  length of CREX message (words)
C               *YBUFF*   -  Character string containing data
C               *KELEM*   -  dimension of CNAMES, CUNITS array
C               *KVALS*   -  dimension of VALUES array
C        OUTPUT:
C               *KSUP*    -  Integer array of 9 words containing
C                            suplementary information
C                         -  KSUP( 1) -- IDIM1, dimension of KSEC1
C                         -  KSUP( 2) -- Reserved
C                         -  KSUP( 3) -- IDIM3, dimension of KSEC3
C                         -  KSUP( 4) -- Reserved
C                         -  KSUP( 5) -- M (number of elements in values
C                                           array, first index)
C                         -  KSUP( 6) -- N (number of subsets,second index
C                                           of values array)
C                         -  KSUP( 7) -- JVC (number of elements in CVAL array)
C                         -  KSUP( 8) -- total CREX message length in bytes
C                         -  KSUP( 9) -- IDIM0, dimension of KSEC0
C
C               *KSEC3*   -  array containing section 3 information
C                            KSEC3( 1)-- length of section 3 (bytes)
C                            KSEC3( 2)-- reserved
C                            KSEC3( 3)-- number of subsets
C                            KSEC3( 4)-- flag (data type,data compression)
C               *CNAMES*  -  character array containing element names
C               *CUNITS*  -  character array containig units
C               *VALUES*  -  real*8 array (expanded data values)
C               *CVALS*   -  character array containing text
C               *KERR*    -  returned error code
C
C     METHOD.
C     -------
C
C           NONE.
C
C
C     EXTERNALS.
C     ----------
C
C
C
C     REFERENCE.
C     ----------
C
C          NONE.
C
C     AUTHOR.
C     -------
C
C          MILAN DRAGOSAVAC    *ECMWF*       17/01/2003.
C
C
C     MODIFICATIONS.
C     --------------
C
C          NONE.
C
C--------------------------------------------------------------------------------------------
      IMPLICIT LOGICAL(L,O,G), CHARACTER*8(C,H,Y)
C
C
      PARAMETER(JSUP =   9,JSEC0=   3,JSEC1= 40,JSEC2= 64 ,JSEC3=    4,
     1          JSEC4=   2,JELEM=40000,JSUBS=400,JCVAL=150 ,JBUFL=40000,
     2          JBPW =  32,JTAB =3000,JCTAB=120,JCTST=1800,JCTEXT= 200,
     3          JWORK=360000,JKEY=46)
C
      COMMON /CREXWORK/ NBPT,NGS,NVIND,NBPTSEC2,RVIND,EPS,NE,IEOLD,
     1                  NC07YYY
C
C
      COMMON /CREXWT/ NCREXDWINC,NCREXSCAM,NCREXAFDW,NCREXWT ,ODREPF,
     2               NCREXSTACK(JELEM),NCREXWTEN(JELEM),
     3               NCREXWTR (JELEM),NCREXWTS (JELEM),NCREXWTRV(JELEM),
     4               NCREXWTDW(JELEM),NWTIW(JELEM),NWTIWS(JELEM)
C
C             NCREXDWINC   -  data width increment
C             NCREXSCAM    -  scale multiplier
C             NCREXAFDW    -  augmented field data width
C             NCREXWT      -  pointer to working table
C             NCREXSTACK   -  list of data descriptors
C             ODREPF   -  replication (logical)
C             NCREXWTR     -  working table reference
C             NCREXWTS     -  working scale
C             NCREXWTRV    -  working reference value
C             NCREXWTDW    -  working data width
C             NWTIW    -  working data width of increments
C             NWTIWS   -  working total data width of element set
C
      CHARACTER CREXWTEN*64,CREXWTU*24
C
C
      COMMON /CREXWTC/ CREXWTEN(JELEM),CREXWTU (JELEM)
C
C             CREXWTEN    -  working table element naame
C             CREXWTU     -  working table units
C
C
C
      COMMON /CREXBEF / M,MM,N,JCV
C
C             M       -  Number of elements
C             MM      -  Number of elements
C             N       -  Number of data sub_sets
C             JCV     -  Number of character values
C
C
C
      COMMON /CREXOFF/ NSIZEG(JELEM),NCREXWTRG(JWORK),
     1                 NBP,NSUBSET,OMULTI
C
C
      CHARACTER*64 CNAMES(KELEM)
      CHARACTER*24 CUNITS(KELEM)
      CHARACTER*80 CVALS(KVALS),CH
C
      CHARACTER*(*) YBUFF
C
      DIMENSION ILIST(JELEM),IVALUES(JELEM) 
C
C
      REAL*8 VALUES(KVALS)
      REAL*8 RVIND
      REAL*8 EPS
C
      DIMENSION KSUP(JSUP),KSEC3(JSEC3)
C
C     ------------------------------------------------------------------
C*          1.  EXPAND PRELIMINARY ITEMS FROM SECTION4.
C               ---------------------------------------
 100  CONTINUE
C
C                JCV - POINTER TO CVALS ARRAY
C                JWT - POINTER TO WORKING TABLE ARRAY
C                JNS - POINTER TO VALUES ARRAY FOR SUB-SETS.
C
      IF(KERR.GT.0) RETURN
C
      IF(NSUBSET.EQ.1) THEN
         JCV = 0
      END IF
      OREPF =.FALSE.
      IEOLD=0
C
C     ------------------------------------------------------------------
C
C*          3.  Expand the data
C               ---------------
 300  CONTINUE
C
         IF(KELEM.LT.M) THEN
            KERR=25
            CALL CREXERR(KERR)
            RETURN
         END IF
c
         JNS=NSUBSET
C
         KSEC3(4)=0
         KSUP(5)=NSIZEG(NSUBSET)
C
         CALL NEXTPRT(KBUFL,YBUFF,NBPT,NGS,KERR )
         IF(KERR.NE.0) THEN
            print*,'nextprt: error ',ierr
            RETURN
         END IF
c
         ITEMP=NBPT
         CALL NEXTSEC(KBUFL,YBUFF, ITEMP,NGS,KERR )
         IF(KERR.NE.0) THEN
            print*,'nextsec: error ',ierr
            RETURN
         END IF
c
 301     CONTINUE
C
         KSEC3(3)=JNS
         KSUP(6)=JNS
C
         JNSK=(JNS-1)*KELEM
         IF(JNSK.GT.KVALS) THEN
            KERR=14
            CALL CREXERR(KERR)
            print*,'Size of values array too small.'
            print*,'Number of subsets=',jns
            print*,'Number of elements=',M
            print*,'Kelem=',KELEM

            RETURN
         END IF
C
         DO IZ=JNSK+1,JNSK+M
         VALUES(IZ)=RVIND
         END DO
C
         DO 302 JWT=1,M
C
         JWTJNS=JWT+JNSK
C

         IF(NCREXWTDW(JWT).EQ.0) THEN
            VALUES(JWTJNS)=0.0
            GO TO 302
         END IF
C
         NBPTKEEP=NBPT
c        CALL NEXTSEP(KBUFL,YBUFF,NBPT,ITEMP,KERR)
         CALL NEXTPRT(KBUFL,YBUFF,NBPT,ITEMP,KERR )
         IF(NBPT.GE.ITEMP) GO TO 600
c
c
c        Check for next E
C
         IF(NE.EQ.1) THEN
            IE=ICHAR(YBUFF(NBPT:NBPT))-48
            IF(IE.LT.0.OR.IE.GT.9) THEN
               print*,'E leading character is not a figure',
     1                 'for ',JWT,' element.'
               IEOLD=IEOLD+1
               IF(IEOLD.EQ.10) IEOLD=0
               CALL NEXTSEP(KBUFL,YBUFF,NBPT,ITEMP,KERR)
               VALUES(JWTJNS)=RVIND
               GO TO 302
            END IF
c
            IF((IE-IEOLD).EQ.1.OR.(IE-IEOLD).EQ.-9) THEN
               IEOLD=IE
            ELSE
c              check next group
               IBPT=NBPT
               CALL NEXTSEP(KBUFL,YBUFF,IBPT,ITEMP,KERR)
               CALL NEXTPRT(KBUFL,YBUFF,IBPT,ITEMP,KERR )
               IENEXT=ICHAR(YBUFF(NBPT:NBPT))-48 
               IF((IENEXT-IEOLD).GE.2.OR.(IENEXT-IEOLD).LT.0) THEN
                   print*,JWT,' Group is missing for ',NCREXWTR(JWT),
     1                    ' element.'
                  IEOLD=IEOLD+1
                  IF(IEOLD.EQ.10) IEOLD=0
                  NBPT=NBPTKEEP
                  VALUES(JWTJNS)=RVIND
                  GO TO 302
               END IF
            END IF
            NBPT=NBPT+1
         ELSE
c              check next group
c              nbpt points to first character of next group
               IBPT=NBPT
               CALL NEXTSEP(KBUFL,YBUFF,IBPT,ITEMP,KERR)
               if((IBPT-NBPT).ne.NCREXWTDW(JWT)) THEN
                  if(NCREXWTEN(JWT).eq.658367) THEN
                     izz=NBPT+NCREXWTDW(JWT)
                     if(YBUFF(izz:izz).eq.' ') then
                        IBPT=NBPT+NCREXWTDW(JWT)   
                        go to 305
                     end if
                  end if
                  do iz=JWT-1,1,-1
                  if(NCREXWTDW(JWT).eq.NCREXWTDW(iz)) then
                     print*,iz,'Group is possibly missing ',
     1                      NCREXWTR(iz),
     2               'values replaced with missing value'
                     VALUES(iz)=rvind
                  else
                     go to 111
                  end if
                  end do
c                    
                  
 111              CONTINUE
                  IF(NCREXWTEN(JWT).EQ.658367) THEN
                     JCV=JCV+1
                     VALUES(JWTJNS)=JCV*1000+NCREXWTDW(JWT)
                     CVALS(JCV)=' '
                  ELSE
                     VALUES(JWTJNS)=RVIND
                  END IF
                  NBPT=IBPT
                  GO TO 302
                end if
         END IF
C
 305  CONTINUE
C
         IF(NCREXWTR(JWT).EQ.31011.OR.
     1      NCREXWTR(JWT).EQ.31012) OREPF=.TRUE.
C
C
C     ------------------------------------------------------------------
C*          3.1 CHARACTER DATA ?
C               ----------------
 310  CONTINUE
C
         IF(NCREXWTEN(JWT).EQ.658367) THEN
C
C*          3.2  OBTAIN CHARACTER DATA FROM DATA SECTION.
C                ----------------------------------------
 320  CONTINUE
C
            IY=NCREXWTDW(JWT)
C
            CALL EXTGRPC(KBUFL,YBUFF, NBPT,IY,CH,KERR)
            IF(KERR.NE.0) THEN
               print*,'extgrpc : problem for ',JWT,' th' 
               print*,' element', NCREXWTR(JWT)
               print*,'Element is missing'
            END IF
C
C*          3.3  MOVE CHARACTER DATA TO "CVALS".
C                -------------------------------
 330  CONTINUE
C
            IYLINE=IY/80
            IYOFF =IY-IYLINE*80
            JCVINC=IYLINE
C
            JCV = JCV + 1
            JCVW= JCV
C
            IF(IYLINE.EQ.0) THEN
               CVALS(JCVW)(1:iy)=ch(1:iY)
            ELSE
               DO 332 J=1,IYLINE
               DO 333 JJ=1,80
               CVALS(JCVW)(JJ:JJ)= CH(JJ:JJ)
 333           CONTINUE
C
               JCVW=JCVW+1
C
 332           CONTINUE
C
               DO 334 J=1,IYOFF
               CVALS(JCVW)(J:J)= CH(J:J)
 334           CONTINUE
C
            END IF
C
C*          3.4  COMPUTE POINTER VALUES TO BE STORED IN "VALUES".
C                ------------------------------------------------
 340  CONTINUE
C
            VALUES(JWTJNS) = JCV*1000 + IY
            JCV            = JCV + JCVINC
C
            GO TO 302
C
         END IF
C
C*          3.5  OBTAIN VALUE FROM DATA SECTION.
C                -------------------------------
 350  CONTINUE
C
         CALL EXTGRP(KBUFL,YBUFF, NBPT,NCREXWTDW(JWT),IVAL,KERR)
         IF(KERR.NE.0) THEN
            print*,'extgrp : error ',kerr
            RETURN
         END IF
C
C     -----------------------------------------------------------------
C*          3.6  UPDATE THE ARRAY "VALUES".
C                --------------------------
 360  CONTINUE
C
C
C        CHECK IF DATA IS MISSING
C
         IF(IVAL.EQ.NVIND) THEN
            VALUES(JWTJNS)=RVIND
         ELSE
            IF(CREXWTU(JWT)(1:4).EQ.'FLAG') then
               CALL OCTAL2DEC(IVAL,IIVAL,KERR)
               IVAL=IIVAL
            END IF
            IF(NCREXWTS(JWT).GT.0) THEN
               VALUES(JWTJNS)= IVAL/10.**NCREXWTS(JWT)
            ELSE
               IIWTS=IABS(NCREXWTS(JWT))
               VALUES(JWTJNS)= IVAL*10.**IIWTS
            END IF
         END IF
C
         CALL NEXTSEP(KBUFL,YBUFF,NBPT,ITEMP,KERR)
c
         IF(NBPT.GE.ITEMP) THEN
            OMULTI=.FALSE.
            GO TO 600
         END IF
C
 302     CONTINUE
C
         ITEMP1=NBPT
         CALL NEXTSUBSET(KBUFL,YBUFF, ITEMP1,NGS,KERR )
         IF(ITEMP1.LT.NGS) THEN
c           JNS=JNS+1
            N=JNS
            IEOLD=0
c           GO TO 301
         ELSE
            OMULTI=.FALSE.
         END IF 
C
         KSUP(7)=JCV
C
C     -----------------------------------------------------------------
C*            6.  SET SUPPLEMENTARY INFORMATION.
C                 ------------------------------
C
 600  CONTINUE
C
      NBP=NBPT
      KSUP(4)= 2
C
C     ------------------------------------------------------------------
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE BUEXS1( KBUFL,KBUFF,KSUP,KSEC0,KSEC1,KERR)
C
C**** *BUEXS1*
C
C
C     PURPOSE.
C     --------
C          EXPANDS SECTION 1 OF BUFR MESSAGE. SAVES EXPANDED INFORMATION
C     IN THE ARRAY KSEC1.
C
C**   INTERFACE.
C     ----------
C
C          *CALL* *BUEXS1( KBUFL,KBUFF,KSUP,KSEC0,KSEC1,KERR)*
C
C        INPUT :
C               *KBUFL*   -  LENGTH OF BUFR MESSAGE (WORDS)
C               *KBUFF*   -  ARRAY CONTAINING BUFR MESSAGE
C        OUTPUT:
C               *KSUP*    -  ARRAY CONTAINING SUPLEMENTARY INFORMATION
C                         -  KSUP( 1) -- IDIM1, DIMENSION OF KSEC1
C                         -  KSUP( 2) -- IDIM2, DIMENSION OF KSEC2
C                         -  KSUP( 3) -- IDIM3, DIMENSION OF KSEC3
C                         -  KSUP( 4) -- IDIM4, DIMENSION OF KSEC4
C                         -  KSUP( 5) -- M (NUMBER OF ELEMENTS IN VALUES ARRAY,
C                                           FIRST INDEX)
C                         -  KSUP( 6) -- N (NUMBER OF SUBSETS,SECOND INDEX OF
C                                           VALUES ARRAY)
C                         -  KSUP( 7) -- JVC (NUMBER OF ELEMENTS IN CVAL ARRAY)
C                         -  KSUP( 8) -- TOTAL BUFR MESSAGE LENGTH IN BYTES
C                         -  KSUP( 9) -- IDIM0, DIMENSION OF KSEC0
C               *KSEC0*   -  ARRAY CONTAINING SECTION 0 INFORMATION
C                            KSEC0( 1)-- LENGTH OF SECTION 0 (BYTES)
C                            KSEC0( 2)-- TOTAL LENGTH OF BUFR MESSAGE (BYTES)
C                            KSEC0( 3)-- BUFR EDITION NUMBER
C               *KSEC1*   -  ARRAY CONTAINING SECTION 1 INFORMATION
C                            KSEC1( 1)-- LENGTH OF SECTION 1 (BYTES)
C                            KSEC1( 2)-- BUFR EDITION NUMBER
C                            KSEC1( 3)-- ORIGINATING CENTRE
C                            KSEC1( 4)-- UPDATE SEQUENCE NUMBER
C                            KSEC1( 5)-- FLAG (PRESENCE OF SECTION 2)
C                            KSEC1( 6)-- BUFR MESSAGE TYPE
C                            KSEC1( 7)-- BUFR MESSAGE SUBTYPE
C                            KSEC1( 8)-- VERSION NUMBER OF LOCAL TABLE USED
C                            KSEC1( 9)-- YEAR
C                            KSEC1(10)-- MONTH
C                            KSEC1(11)-- DAY
C                            KSEC1(12)-- HOUR
C                            KSEC1(13)-- MINUTE
C                            KSEC1(14)-- BUFR MASTER TABLE
C                            KSEC1(15)-- VERSION NUMBER OF MASTER TABLE USED
C                            KSEC1(16) - KSEC1(JSEC1) -- LOCAL ADP CENTRE
C                                        INFORMATION(PACKED FORM)
C
C                            FOR BUFR EDITION 3 ONWARD
C
C                            KSEC1(16)-- ORIGINATING SUB-CENTRE
C                            KSEC1(17)-- NOT USED
C                            KSEC1(18) TO KSEC1(JSEC1) - LOCAL ADP CENTRE
C                                        INFORMATION(PACKED FORM)
C                            
C                            FOR BUFR EDITION 4 ONWARD
C
C                            KSEC1(16)-- ORIGINATING SUB-CENTRE
C                            KSEC1(17)-- INTERNATIONAL SUB-CATEGORY (SEE COMMON TABLE C-13
C                            KSEC1(18)-- SECOND
C                            KSEC1(19)-- YEAR
C                            KSEC1(20)-- MONTH
C                            KSEC1(21)-- DAY
C                            KSEC1(22)-- HOUR
C                            KSEC1(23)-- MINUTE
C                            KSEC1(24)-- SECOND
C                            KSEC1(25)-- YEAR
C                            KSEC1(26)-- MONTH
C                            KSEC1(27)-- DAY
C                            KSEC1(28)-- HOUR
C                            KSEC1(29)-- MINUTE
C                            KSEC1(30)-- SECOND
C                            KSEC1(31)-- MOST SOUTHERN LATITUDE  (-90 to 90)
C                            KSEC1(32)-- MOST WESTERN LONGITUDE  ( 0-360)
C                            KSEC1(33)-- MOST NORTHEN LATITUDE   (-90 to 90)
C                            KSEC1(34)-- MOST EASTERN LONGITUDE  ( 0-360)
C                            KSEC1(35) TO KSEC1(JSEC1) - LOCAL ADP CENTRE INFORMATION(PACKED FORM)
C
C
C     *METHOD.
C      -------
C
C           NONE.
C
C
C     EXTERNALS.
C     ----------
C
C          BUNPCK          -  UNPACK BIT PATTERN
C          BUNEXS         -  SET WORD AND BIT POINTERS AT THE BEGINING OF
C                            NEXT SECTION
C
C
C     REFERENCE.
C     ----------
C
C          NONE.
C
C     AUTHOR.
C     -------
C
C          M. DRAGOSAVAC    *ECMWF*       16/01/91.
C
C
C     MODIFICATIONS.
C     --------------
C
C          NONE.
C
C
      IMPLICIT LOGICAL(L,O,G), CHARACTER*8(C,H,Y)
C
C
#     include "parameter.F"
#     include "bcomunit.F"
#     include "bcomwork.F"
C
      DIMENSION KBUFF(KBUFL),KSUP(JSUP),KSEC0(JSEC0),KSEC1(JSEC1)
      DIMENSION ISEC1(JSEC1)
#ifndef R_4
      REAL*8 RVIND
      REAL*8 EPS
#else
      REAL   RVIND
      REAL   EPS
#endif
C
C
C     ------------------------------------------------------------------
C*          1.  EXPAND SECTION 1.
C               ------------------
 100  CONTINUE
C
      IF( KERR.NE.0 ) RETURN
C
C     SAVE WORD AND BIT POINTERS OF THR BRGINING OF SECTION 1.
C
      IWPTB=NWPT
      IBPTB=NBPT
C
C*          1.1 UNPACK LENGTH OF SECTION 1.
C               ----------------------------
 110  CONTINUE
C
      CALL BUNPCK(NBPW,KBUFF,KSEC1(1),NWPT,NBPT,24,KERR)
      IF(KERR.GT.0) THEN
         WRITE(KNTN,*)  'ERROR UNPACKING KSEC1(1).'
         RETURN
      END IF
C     IF(KSEC1(1).GT.18) THEN
C        WRITE(KNTN,*)  'LOCAL ADP CENTRE INFORMATION PRESENT 
C    1 IN THE SECTION 1.'
C     END IF
C
C*          1.1.1 SET THE POINTERS NWPTB AND NBPTB.
C                 ---------------------------------
C                 TO BEGINING OF THE NEXT SECTION.
C                 --------------------------------
 1110 CONTINUE
C
      CALL BUNEXS(KSEC1(1))
C
C
C*          1.2  UNPACK BUFR EDITION NUMBER/MASTER TABLE USED.
C                ---------------------------------------------
 120  CONTINUE
C
      IF(KSEC0(3).LE.1) THEN
         CALL BUNPCK(NBPW,KBUFF,KSEC1(2),NWPT,NBPT, 8,KERR)
         IF(KERR.GT.0) THEN
            WRITE(KNTN,*)  'ERROR UNPACKING KSEC1(2).'
            RETURN
         END IF
      ELSE
         CALL BUNPCK(NBPW,KBUFF,KSEC1(14),NWPT,NBPT, 8,KERR)
         IF(KERR.GT.0) THEN
            WRITE(KNTN,*)  'ERROR UNPACKING KSEC1(14).'
            RETURN
         END IF
C
         KSEC1(2)=KSEC0(3)
      END IF
C
C*          1.3  UNPACK ORIGINATING CENTRE.
C                --------------------------
 130  CONTINUE
C
      IF(KSEC0(3).LT.3) THEN
         CALL BUNPCK(NBPW,KBUFF,KSEC1(3),NWPT,NBPT,16,KERR)
         IF(KERR.GT.0) THEN
            WRITE(KNTN,*)  'ERROR UNPACKING KSEC1(3).'
            RETURN
         END IF
      ELSEIF(KSEC0(3).EQ.3) THEN
C        BUFR Edition 3
         CALL BUNPCK(NBPW,KBUFF,KSEC1(16),NWPT,NBPT,8,KERR)
         IF(KERR.GT.0) THEN
            WRITE(KNTN,*)  'ERROR UNPACKING KSEC1(3).'
            RETURN
         END IF
         CALL BUNPCK(NBPW,KBUFF,KSEC1(3),NWPT,NBPT,8,KERR)
         IF(KERR.GT.0) THEN
            WRITE(KNTN,*)  'ERROR UNPACKING KSEC1(3).'
            RETURN
         END IF
      ELSEIF(KSEC0(3).EQ.4) THEN
C        BUFR Edition 4
         CALL BUNPCK(NBPW,KBUFF,KSEC1(3),NWPT,NBPT,16,KERR)
         IF(KERR.GT.0) THEN
            WRITE(KNTN,*)  'ERROR UNPACKING KSEC1(3).'
            RETURN
         END IF
         CALL BUNPCK(NBPW,KBUFF,KSEC1(16),NWPT,NBPT,16,KERR)
         IF(KERR.GT.0) THEN
            WRITE(KNTN,*)  'ERROR UNPACKING KSEC1(16).'
            RETURN
         END IF
      END IF
      
C
C*          1.4  UNPACK UPDATE SEQUENCE NUMBER.
C                ------------------------------
 140  CONTINUE
C
      CALL BUNPCK(NBPW,KBUFF,KSEC1(4),NWPT,NBPT, 8,KERR)
      IF(KERR.GT.0) THEN
         WRITE(KNTN,*)  'ERROR UNPACKING KSEC1(4).'
         RETURN
      END IF
C
C*          1.5  UNPACK INTEGER VALUE OF THE OCTET CONTAINING
C                --------------------------------------------
C                 FLAG BITS(ZERO IF SECTION TWO IS NOT PRESENT).
C                 ----------------------------------------------
 150  CONTINUE
C
      CALL BUNPCK(NBPW,KBUFF,KSEC1(5),NWPT,NBPT, 8,KERR)
      IF(KERR.GT.0) THEN
         WRITE(KNTN,*)  'ERROR UNPACKING KSEC1(5).'
         RETURN
      END IF
C
C*          1.6  UNPACK *BUFR* MESSAGE TYPE.
C                ---------------------------
 160  CONTINUE
C
      CALL BUNPCK(NBPW,KBUFF,KSEC1(6),NWPT,NBPT, 8,KERR)
      IF(KERR.GT.0) THEN
         WRITE(KNTN,*)  'ERROR UNPACKING KSEC1(6).'
         RETURN
      END IF
C
C*          1.7  UNPACK *BUFR* MESSAGE SUB-TYPE.
C                -------------------------------
 170  CONTINUE
C
      IF(KSEC0(3).EQ.4) THEN
         CALL BUNPCK(NBPW,KBUFF,KSEC1(17),NWPT,NBPT, 8,KERR)
         IF(KERR.GT.0) THEN
            WRITE(KNTN,*)  'ERROR UNPACKING KSEC1(17).'
            RETURN
         END IF
         CALL BUNPCK(NBPW,KBUFF,KSEC1(7),NWPT,NBPT, 8,KERR)
         IF(KERR.GT.0) THEN
            WRITE(KNTN,*)  'ERROR UNPACKING KSEC1(7).'
            RETURN
         END IF
      ELSE
         CALL BUNPCK(NBPW,KBUFF,KSEC1(7),NWPT,NBPT, 8,KERR)
         IF(KERR.GT.0) THEN
            WRITE(KNTN,*)  'ERROR UNPACKING KSEC1(7).'
            RETURN
         END IF
      END IF
C
C*          1.8  UNPACK LOCAL TABLE VERSION NUMBER OR
C                ------------------------------------
C                VERSION NUMBER OF MASTER TABLE USED.
C                 -----------------------------------
 180  CONTINUE
C
      IF(KSEC0(3).LE.1) THEN
         CALL BUNPCK(NBPW,KBUFF,KSEC1(8),NWPT,NBPT,16,KERR)
         IF(KERR.GT.0) THEN
            WRITE(KNTN,*)  'ERROR UNPACKING KSEC1(8).'
            RETURN
         END IF
      ELSE
         CALL BUNPCK(NBPW,KBUFF,KSEC1(15),NWPT,NBPT, 8,KERR)
         IF(KERR.GT.0) THEN
            WRITE(KNTN,*)  'ERROR UNPACKING KSEC1(15).'
            RETURN
         END IF
         CALL BUNPCK(NBPW,KBUFF,KSEC1( 8),NWPT,NBPT, 8,KERR)
         IF(KERR.GT.0) THEN
            WRITE(KNTN,*)  'ERROR UNPACKING KSEC1(8).'
            RETURN
         END IF
      END IF
C
C*          1.9  UNPACK YEAR.
C                ------------
 190  CONTINUE
C
      IF(KSEC0(3).EQ.4) THEN
         CALL BUNPCK(NBPW,KBUFF,KSEC1(9),NWPT,NBPT,16,KERR)
         IF(KERR.GT.0) THEN
            WRITE(KNTN,*)  'ERROR UNPACKING KSEC1(9).'
            RETURN
         END IF
      ELSE
         CALL BUNPCK(NBPW,KBUFF,KSEC1(9),NWPT,NBPT, 8,KERR)
         IF(KERR.GT.0) THEN
            WRITE(KNTN,*)  'ERROR UNPACKING KSEC1(9).'
            RETURN
         END IF
      END IF
C
C*          2. UNPACK MONTH.
C              -------------
 200  CONTINUE
C
      CALL BUNPCK(NBPW,KBUFF,KSEC1(10),NWPT,NBPT, 8,KERR)
      IF(KERR.GT.0) THEN
         WRITE(KNTN,*)  'ERROR UNPACKING KSEC1(10).'
         RETURN
      END IF
C
C*          2.1 UNPACK DAY.
C               -----------
 210  CONTINUE
C
      CALL BUNPCK(NBPW,KBUFF,KSEC1(11),NWPT,NBPT, 8,KERR)
      IF(KERR.GT.0) THEN
         WRITE(KNTN,*)  'ERROR UNPACKING KSEC1(11).'
         RETURN
      END IF
C
C*          2.2 UNPACK HOUR.
C               ------------
 220  CONTINUE
C
      CALL BUNPCK(NBPW,KBUFF,KSEC1(12),NWPT,NBPT, 8,KERR)
      IF(KERR.GT.0) THEN
         WRITE(KNTN,*)  'ERROR UNPACKING KSEC1(12).'
         RETURN
      END IF
C
C*          2.3 UNPACK MINUTE.
C               --------------
 230  CONTINUE
C
      CALL BUNPCK(NBPW,KBUFF,KSEC1(13),NWPT,NBPT, 8,KERR)
      IF(KERR.GT.0) THEN
         WRITE(KNTN,*)  'ERROR UNPACKING KSEC1(13).'
         RETURN
      END IF
C
C           2.3.1 UNPACK SECOND
C                 -------------
      IF(KSEC0(3).EQ.4) THEN
         CALL BUNPCK(NBPW,KBUFF,KSEC1(18),NWPT,NBPT, 8,KERR)
         IF(KERR.GT.0) THEN
            WRITE(KNTN,*)  'ERROR UNPACKING KSEC1(13).'
            RETURN
         END IF
C
C                 METADATA
C
C                 YEAR
C
c        CALL BUNPCK(NBPW,KBUFF,KSEC1(19),NWPT,NBPT,16,KERR)
c        IF(KERR.GT.0) THEN
c           WRITE(KNTN,*)  'ERROR UNPACKING KSEC1(19).'
c           RETURN
c        END IF
C
C*             UNPACK MONTH.
C              -------------
C
c        CALL BUNPCK(NBPW,KBUFF,KSEC1(20),NWPT,NBPT, 8,KERR)
c        IF(KERR.GT.0) THEN
c           WRITE(KNTN,*)  'ERROR UNPACKING KSEC1(20).'
c           RETURN
c        END IF
C
C*              UNPACK DAY.
C               -----------
C
c        CALL BUNPCK(NBPW,KBUFF,KSEC1(21),NWPT,NBPT, 8,KERR)
c        IF(KERR.GT.0) THEN
c           WRITE(KNTN,*)  'ERROR UNPACKING KSEC1(21).'
c           RETURN
c        END IF
C
C*              UNPACK HOUR.
C               ------------
C
c        CALL BUNPCK(NBPW,KBUFF,KSEC1(22),NWPT,NBPT, 8,KERR)
c        IF(KERR.GT.0) THEN
c           WRITE(KNTN,*)  'ERROR UNPACKING KSEC1(22).'
c           RETURN
c        END IF
C
C*              UNPACK MINUTE.
C               --------------
C
c        CALL BUNPCK(NBPW,KBUFF,KSEC1(23),NWPT,NBPT, 8,KERR)
c        IF(KERR.GT.0) THEN
c           WRITE(KNTN,*)  'ERROR UNPACKING KSEC1(23).'
c           RETURN
c        END IF
C
C               UNPACK SECOND
C                 -------------
c        CALL BUNPCK(NBPW,KBUFF,KSEC1(24),NWPT,NBPT, 8,KERR)
c        IF(KERR.GT.0) THEN
c           WRITE(KNTN,*)  'ERROR UNPACKING KSEC1(24).'
c           RETURN
c        END IF
C
C                 YEAR
C
c        CALL BUNPCK(NBPW,KBUFF,KSEC1(25),NWPT,NBPT,16,KERR)
c        IF(KERR.GT.0) THEN
c           WRITE(KNTN,*)  'ERROR UNPACKING KSEC1(25).'
c           RETURN
c        END IF
C
C*             UNPACK MONTH.
C              -------------
C
c        CALL BUNPCK(NBPW,KBUFF,KSEC1(26),NWPT,NBPT, 8,KERR)
c        IF(KERR.GT.0) THEN
c           WRITE(KNTN,*)  'ERROR UNPACKING KSEC1(26).'
c           RETURN
c        END IF
C
C*              UNPACK DAY.
C               -----------
C
c        CALL BUNPCK(NBPW,KBUFF,KSEC1(27),NWPT,NBPT, 8,KERR)
c        IF(KERR.GT.0) THEN
c           WRITE(KNTN,*)  'ERROR UNPACKING KSEC1(27).'
c           RETURN
c        END IF
C
C*              UNPACK HOUR.
C               ------------
C
c        CALL BUNPCK(NBPW,KBUFF,KSEC1(28),NWPT,NBPT, 8,KERR)
c        IF(KERR.GT.0) THEN
c           WRITE(KNTN,*)  'ERROR UNPACKING KSEC1(28).'
c           RETURN
c        END IF
C
C*              UNPACK MINUTE.
C               --------------
C
c        CALL BUNPCK(NBPW,KBUFF,KSEC1(29),NWPT,NBPT, 8,KERR)
c        IF(KERR.GT.0) THEN
c           WRITE(KNTN,*)  'ERROR UNPACKING KSEC1(29).'
c           RETURN
c        END IF
C
C               UNPACK SECOND
C                 -------------
c        CALL BUNPCK(NBPW,KBUFF,KSEC1(30),NWPT,NBPT, 8,KERR)
c        IF(KERR.GT.0) THEN
c           WRITE(KNTN,*)  'ERROR UNPACKING KSEC1(30).'
c           RETURN
c        END IF
C
C
C               UNPACK  MOST SOUTHERN LATITUDE
C               ------------------------------
C        CALL BUNPCK(NBPW,KBUFF,ISG,NWPT,NBPT,1,KERR)
C        IF(KERR.GT.0) THEN
C           WRITE(KNTN,*)  'ERROR UNPACKING KSEC1(31).'
C           RETURN
C        END IF
C
c        CALL BUNPCK(NBPW,KBUFF,KSEC1(31),NWPT,NBPT,32,KERR)
c        IF(KERR.GT.0) THEN
c           WRITE(KNTN,*)  'ERROR UNPACKING KSEC1(31).'
c           RETURN
c        END IF

C        IF(ISG.EQ.1)  KSEC1(31)=-KSEC1(31)
C
C               UNPACK  MOST WESTERN LONGITUDE
C               ------------------------------
c        CALL BUNPCK(NBPW,KBUFF,KSEC1(32),NWPT,NBPT,32,KERR)
c        IF(KERR.GT.0) THEN
c           WRITE(KNTN,*)  'ERROR UNPACKING KSEC1(32).'
c           RETURN
c        END IF
C
C               UNPACK  MOST NORTHERN LATITUDE
C               ------------------------------
C        CALL BUNPCK(NBPW,KBUFF,ISG,NWPT,NBPT,1,KERR)
C        IF(KERR.GT.0) THEN
C           WRITE(KNTN,*)  'ERROR UNPACKING KSEC1(33).'
C           RETURN
C        END IF

c        CALL BUNPCK(NBPW,KBUFF,KSEC1(33),NWPT,NBPT,32,KERR)
c        IF(KERR.GT.0) THEN
c           WRITE(KNTN,*)  'ERROR UNPACKING KSEC1(33).'
c           RETURN
c        END IF

C        IF(ISG.EQ.1) KSEC1(33)=-KSEC1(33)
C
C               UNPACK  MOST EASTERN LONGITUDE
C               ------------------------------
c        CALL BUNPCK(NBPW,KBUFF,KSEC1(34),NWPT,NBPT,32,KERR)
c        IF(KERR.GT.0) THEN
c           WRITE(KNTN,*)  'ERROR UNPACKING KSEC1(34).'
c           RETURN
c        END IF
C
      END IF
C
C*          2.4 UNPACK LOCAL ADP CENTRE INFORMATION IF ANY.
C               -------------------------------------------
 240  CONTINUE
C
      IF(KSEC0(3).LT.3) THEN
         IOFF=KSEC1(1)-17
         IW=16
         IBT=0
      ELSEIF(KSEC0(3).EQ.3) THEN
         IOFF=KSEC1(1)-17
         IW=18
         IBT=0
      ELSEIF(KSEC0(3).EQ.4) THEN
C        IOFF=KSEC1(1)-52
         IOFF=KSEC1(1)-22
c        IW=35     ! index for local info
         IW=19     ! index for local info
         IBT=0
      END IF
      IF(IOFF.LE.JSEC1) THEN
         CALL BUNPKS(NBPW,KBUFF,ISEC1(1),NWPT,NBPT,
     1   8,0,IOFF,KERR)
         IF(KERR.GT.0) THEN
          WRITE(KNTN,*)  'ERROR UNPACKING LOCAL ADP CENTRE INFORMATION'
            WRITE(KNTN,*)  'IN SECTION 1.'
            RETURN
         END IF
C
C                PACK LOCAL ADP CENTRE INFORMATION INTO KSE1(16) ONWARD.
C
         CALL BUPKS(NBPW,KSEC1(IW),ISEC1,IW,IBT,8,0,IOFF,KERR)
         IF(KERR.GT.0) THEN
          WRITE(KNTN,*)  'ERROR PACKING LOCAL ADP CENTRE INFORMATION'
            RETURN
         END IF
      ELSE
         IOFF=0
         KERR=4
         CALL BUERR(KERR)
         GO TO 300
      END IF
C
C
C*          3.  SET SUPPLEMENTARY INFORMATION.
C               ------------------------------
 300  CONTINUE
C
      KSUP(1)=15+IOFF/4+1
C
C     ------------------------------------------------------------------
C
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

C
      COMMON /BCMWT/ NDWINC,NSCAM,NAFDW,NWT ,ODREPF,N40,N07,N08,
     1               NDWINC07,NSCAM07,NAFDWA(100),NFD,NREP,OREP,
     1               N221,MREL,NFCM,NFUCM,MBMP,OMARKER,
     2               MBMPL,NSTACK(JELEM),NWTEN(JELEM),
     3               NWTR (JELEM),NWTS (JELEM),NWTRV (JELEM),
     4               NWTDW(JELEM),NWTIW(JELEM),NWTIWS(JELEM)
C
C             NDWINC   -  DATA WIDTH INCREMENT
C             NSCAM    -  SCALE MULTIPLIER
C             NAFDW    -  AUGMENTED FIELD DATA WIDTH
C             NWT      -  POINTER TO WORKING TABLE
C             NSTACK   -  LIST OF DATA DESCRIPTORS
C             ODREPF   -  REPLICATION (LOGICAL)
C             N221     -  DATA NOT PRESENT FOR N221 ELEMENTS
C             MREL     -  POINTER TO THE LAST DATA ELEMENT
C             NFCM     -  FIRST COMPRESSED MESSAGE
C             MBMP     -  POINTER TO THE BEGINING OF BIT MAP
C             NWTR     -  WORKING TABLE REFERENCE
C             NWTS     -  WORKING SCALE
C             NWTRV    -  WORKING REFERENCE VALUE
C             NWTDW    -  WORKING DATA WIDTH
C             NWTIW    -  WORKING DATA WIDTH OF INCREMENTS
C             NWTIWS   -  WORKING TOTAL DATA WIDTH OF ELEMENT SET
C

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE BUNPCK(KBPW,KSOURC,KDEST,KWPT,KBPT,KSIZE,KERR)
C
C**** *BUNPCK*
C
C
C     PURPOSE.
C     --------
C          PURPOSE OF THIS ROUTINE IS TO UNPACK BIT STRING OF
C     KSIZE BITS, STARTED AT WORD KWPT OF ARRAY KSOURC AFTER
C     SKIPPING KBPT BITS. RESULT IS PUT INTO KDEST. AT THE END
C     POINTERS KWPT AND KBPT ARE ADJUSTED.
C
C**   INTERFACE.
C     ----------
C
C          *CALL* *BUNPCK(KBPW,KSOURC,KDEST,KWPT,KBPT,KSIZE,KERR)*
C
C        INPUT :
C              *KBPW*      - NUMBER OF BITS IN COMPUTER WORD
C              *KSOURC*    - SOURCE (CONTINUOUS BIT STRING OF
C                            ARBITRARY LENGTH)
C              *KWPT*      - WORD POINTER
C              *KBPT*      - BIT POINTER
C              *KSIZE*     - NUMBER OF BITS TO BE EXTRACTED
C        OUTPUT:
C              *KDEST*     - DESTINATION
C              *KERR*      - RETURN ERROR CODE
C
C     METHOD.
C     -------
C
C            NONE.
C
C
C     EXTERNALS.
C     ----------
C
C
C          GBYTE     - UNPACK BIT PATTERN
C
C
C     REFERENCE.
C     ----------
C
C          NONE.
C
C     AUTHOR.
C     -------
C
C          M. DRAGOSAVAC    *ECMWF*       15/01/91.
C
C
C     MODIFICATIONS.
C     --------------
C
C          NONE.
C
C
      IMPLICIT LOGICAL(L,O,G), CHARACTER*8(C,H,Y)
C
      DIMENSION KSOURC(*)
C
C     ------------------------------------------------------------------
C*          1.   EXTRACT BIT PATTERN.
C                --------------------
 100  CONTINUE
C
      IF(KERR.NE.0) RETURN
C
      IF(KSIZE.GT.KBPW) THEN
         KERR=13
         CALL BUERR(KERR)
         RETURN
      END IF
C
      CALL GBYTE(KSOURC(KWPT),KDEST,KBPT,KSIZE)
C
C     ------------------------------------------------------------------
C*          1.1  UPDATE WORD AND BIT POINTERS.
C                -----------------------------
 110  CONTINUE
C
      KBPT = KBPT + KSIZE
C
      IF(KBPT.GE.KBPW) THEN
         KBPT= KBPT -  KBPW
         KWPT= KWPT +1
      END IF
C
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      subroutine swap_bytes4(r1,r2)
c     ---------------------------------
      implicit none

      real*4 r1, r2
      real*4 r14
      real*4 r24
      integer*4 kint14,kint24

      equivalence(r14,kint14)
      equivalence(r24,kint24)



c Reverse order of bytes

      r14=r1

      call mvbits(kint14, 24, 8, kint24, 0)
      call mvbits(kint14, 16, 8, kint24, 8)
      call mvbits(kint14,  8, 8, kint24,16)
      call mvbits(kint14,  0, 8, kint24,24)
      r2=r24

      return
      end

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      INTEGER FUNCTION C2RNGE ( KNPACK, KPKLEN, KXBITS, KDATA,  KDIAGO,
     X                          KWIDTH, KREFER, KPOWER, KMXPWR, KPCWID,
     X                          KXCWID )
C
C---->
C**** C2RNGE
C
C     Purpose.
C     --------
C
C     Utility to assist computing of range diagnostics for spatial
C     differencing.
C
C**   Interface.
C     ----------
C
C     IOFF = C2RNGE ( KNPACK, KPKLEN, KXBITS, KDATA, KDIAGO, KWIDTH,
C    X                KREFER, KPOWER, KMXPWR, KPCWID, KXCWID )
C
C     Function result value is the number of values processed within
C     KDATA during call.
C
C
C     Input Parameters.
C     -----------------
C
C     KNPACK     - Number of packets to process.
C     KPKLEN     - Length of packets.
C     KXBITS     - MaXimum number of BITS estimated.
C     KDATA      - Array containing values to process.
C     KDIAGO     - Diagnostic of cumulated ranges.
C     KWIDTH     - Width of packets.
C     KREFER     - Reference value.
C     KPOWER     - Auxilary array, precomputed (powers of 2)-1.
C     KMXPWR     - Maximum number of bits per original scaled value.
C     KPCWID     - Auxilary array, precomputed widths.
C     KXCWID     - Maximum width associated to KPCWID.
C
C
C     Output Parameters (updates).
C     ------------------
C
C     KDIAGO     - Diagnostic of cumulated ranges.
C     KWIDTH     - Width of packets.
C     KREFER     - Reference value.
C
C
C     Method.
C     -------
C
C     Loop on packets for range diagnostics.
C
C
C
C     Externals.
C     ----------
C
C     None.
C
C
C     Reference.
C     ----------
C
C     None.
C
C
C     Comments.
C     --------
C
C     None.
C
C
C     Author.
C     -------
C
C     J. Clochard, Meteo France, for ECMWF - February 1998.
C
C
C     Modifications.
C     _____________
C
C     J. Clochard, June 1999.
C     Use precomputed array to determine widths . Dummy-arguments
C     KPCWID and KXCWID added . Assumption is made that KXCWID
C     is at least (KMXPWR+1)/2 .
C
C
C----<
C     -----------------------------------------------------------------
C*    Section 0. Definition of variables.
C     -----------------------------------------------------------------
C
      IMPLICIT NONE
C
C     Subroutine arguments
C
      INTEGER KNPACK, KPKLEN, KXBITS, KDIAGO, KWIDTH, KREFER, KMXPWR
      INTEGER KXCWID
      INTEGER KPOWER (0:KMXPWR), KDATA (*), KPCWID (0:*)
C
C     Local variables.
C
      INTEGER IOFF, J, J2, IMAX, IMIN, IRANGE, IPOWER, IWIDTH, ILCWID
C
C     -----------------------------------------------------------------
C*    Section 1 . Direct computing.
C     -----------------------------------------------------------------
C
  100 CONTINUE
C
      IOFF = 0
      ILCWID = KPOWER(KXCWID)+1
C
      DO 104 J2=1,KNPACK
C
      IMAX=KDATA(IOFF+1)
      IMIN=KDATA(IOFF+1)
C
      DO 101 J=2,KPKLEN
      IMAX=MAX (IMAX,KDATA(IOFF+J))
      IMIN=MIN (IMIN,KDATA(IOFF+J))
  101 CONTINUE
C
      IRANGE=IMAX-IMIN
C
      IF (IRANGE.LT.ILCWID) THEN
        IWIDTH=KPCWID(IRANGE)
      ELSE
        IWIDTH=KXCWID+KPCWID(IRANGE/ILCWID)
      ENDIF
C
      IPOWER=KPOWER(IWIDTH)
C
      KDIAGO=KDIAGO+KPKLEN*IWIDTH
      KWIDTH=MAX (KWIDTH,IWIDTH)
      KREFER=MAX (KREFER,IMIN-(IPOWER-IRANGE))
      IOFF=IOFF+KPKLEN
C
  104 CONTINUE
C
C     -----------------------------------------------------------------
C*    Section 9 . Return to calling routine.
C     -----------------------------------------------------------------
C
  900 CONTINUE
C
      C2RNGE = IOFF
C
      RETURN
C
      END

C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE NEXTPRT (KBUFL,YBUFF,I,J,KERR )
C
C**** *NEXTPRT*
C
C
C     PURPOSE.
C     --------
C         SCANS BULLETIN IN 'KCHAR' FOR NEXT CHARACTER WHICH
C         IS NOT 'SOH' , 'CR' , 'LF' , 'SPACE' OR 'GS' .
C
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *NEXTPRT(KBUFL,YBUFF,I,J,KERR*
C
C         INPUT     : KBUFL - length of YBUFF in bytes
C                     YBUFF - charcter string
C                     I     - SCAN STARTS AT WORD I.
C                     J     - SCAN STOPS AT WORD J .
C
C         OUTPUT    : I     - POSITION OF REQUIRED CHARACTER
C                     KERR  - ERROR CODE
C

C     METHOD.
C     -------
C
C          NONE.
C
C
C     EXTERNALS.
C     ----------
C
C         NONE.
C
C     REFERENCE.
C     ----------
C
C          NONE.
C
C     AUTHOR.
C     -------
C
C
C
C     MODIFICATIONS.
C     --------------
C
C          M. D. DRAGOSAVAC    *ECMWF*       07/01/2004.
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
      CHARACTER*(*) YBUFF
      CHARACTER*1 soh,lf,cr,space,gs,plus,minus
C
C     ------------------------------------------------------------------
C
C*          1.   SCAN BULLETIN.
C                --------------
 100  CONTINUE
C
C     'SOH' = 1 , 'LF' = 10 , 'CR' = 13 , SPACE = 32 , 'GS' = 29.
C     '+' = 43, 'MINUS'='-'
c
      kerr=0
      soh=char(1)
      lf=char(10)
      cr=char(13)
      space=char(32)
      gs=char(29)
      plus=char(43)
      minus='-'
C
      i = iabs(i)
      K = I
      do 101 i=k,j
         if(ybuff(i:i).ne.soh.and.
     1      ybuff(i:i).ne.lf.and.
     2      ybuff(i:i).ne.cr.and.
     3      ybuff(i:i).ne.space.and.
     4      ybuff(i:i).ne.gs.and.
     4      ybuff(i:i).ne.minus.and.
     5      ybuff(i:i).ne.plus)  then
            return
         end if
  101 continue
C
      RETURN
      END

C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C


      SUBROUTINE CHEKNUM (VALU,LVAL,NUM)
C
C---->
C*
C*    NAME      : CHEKNUM
C*
C*    FUNCTION  : CHECKS THAT A CHARACTER STRING CORRECTLY
C*                REPRESENTS A NUMBER.
C*
C*    INPUT     : VALU = CHARACTER STRING TO BE CHECKED
C*                LVAL = NUMBER OF CHARACTERS IN THIS STRING
C*
C*    OUTPUT    : NUM  = 0, IF STRING REPRESENTS A NUMBER.
C*                       1, IF INVALID CHARACTER FOUND.
C*
C*       JOHN HENNESSY, ECMWF, 16TH APRIL 1985
C
C----<
C     ---------------------------------------------------------------
C
      IMPLICIT INTEGER (A-Z)
C
      CHARACTER*(*) VALU
      NUM = 0
C
C     CHECK ONE CHARACTER STRING FOR VALID DIGIT.
C
      IF (VALU(1:1).LT.'0'.OR.VALU(1:1).GT.'9') NUM=1
      IF (LVAL.EQ.1)  RETURN
C
C     CHECK FOR SIGN OR DECIMAL POINT AS FIRST CHARACTER IN STRING.
C
      IF (VALU(1:1).EQ.'+') NUM = 0
      IF (VALU(1:1).EQ.'-') NUM = 0
      IF (VALU(1:1).EQ.'.') NUM = 0
      IF (NUM.EQ.1) RETURN
C
      TOTAL = 1
      POINT = 0
      IF (VALU(1:1).EQ.'.') POINT = 1
C
      DO 100 I=2,LVAL
         IF (VALU(I:I).EQ.'.') POINT = POINT + 1
         IF (VALU(I:I).GE.'0'.AND.VALU(I:I).LE.'9')
     C      TOTAL = TOTAL + 1
  100 CONTINUE
C
      TOTAL = TOTAL + POINT
      IF (VALU(1:1).EQ.'.') TOTAL = TOTAL - 1
      IF (TOTAL.NE.LVAL) NUM = 1
      IF (POINT.GT.1) NUM = 1
C
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE BUEXS3(KBUFL,KBUFF,KSUP,KSEC3,KELEM,CNAMES,CUNITS,KERR)
C
C**** *BUEXS3*
C
C
C     PURPOSE.
C     --------
C
C          EXPAND SECTION 3 OF BUFR MESSAGE.
C
C
C**   INTERFACE.
C     ----------
C
C          *CALL* *BUEXS3( KBUFL,KBUFF,KSUP,KSEC3,KELEM,CNAMES,CUNITS,KERR)*
C
C        INPUT :
C               *KBUFL*   -  LENGTH OF BUFR MESSAGE (WORDS)
C               *KBUFF*   -  ARRAY CONTAINING BUFR MESSAGE
C               *KELEM*   -  DIMENSION OF CNAMES, CUNITS ARRAY
C        OUTPUT:
C               *KSUP*    -  ARRAY CONTAINING SUPLEMENTARY INFORMATION
C                         -  KSUP( 1) -- IDIM1, DIMENSION OF KSEC1
C                         -  KSUP( 2) -- IDIM2, DIMENSION OF KSEC2
C                         -  KSUP( 3) -- IDIM3, DIMENSION OF KSEC3
C                         -  KSUP( 4) -- IDIM4, DIMENSION OF KSEC4
C                         -  KSUP( 5) -- M (NUMBER OF ELEMENTS IN VALUES ARRAY,
C                                           FIRST INDEX)
C                         -  KSUP( 6) -- N (NUMBER OF SUBSETS,SECOND INDEX OF
C                                           VALUES ARRAY)
C                         -  KSUP( 7) -- JVC (NUMBER OF ELEMENTS IN CVAL ARRAY)
C                         -  KSUP( 8) -- TOTAL BUFR MESSAGE LENGTH IN BYTES
C                         -  KSUP( 9) -- IDIM0, DIMENSION OF KSEC0
C               *KSEC3*   -  ARRAY CONTAINING SECTION 3 INFORMATION
C                            KSEC3( 1)-- LENGTH OF SECTION 3 (BYTES)
C                            KSEC3( 2)-- RESERVED
C                            KSEC3( 3)-- NUMBER OF SUBSETS
C                            KSEC3( 4)-- FLAG (DATA TYPE,DATA COMPRESSION)
C               *CNAMES*  -  CHARACTER ARRAY CONTAINING ELEMENT NAMES
C               *CUNITS*  -  CHARACTER ARRAY CONTAINIG UNITS
C               *KERR*    -  RETURNED ERROR CODE
C
C     METHOD.
C      -------
C
C          EXPANDS LIST OF DATA DESCRIPTORS PACKED IN SECTION 3
C     OF BUFR MESSAGE. WORKING TABLES FOR FURTHER DATA DECODING ARE SET,
C     LIST OF PACKED BUFR DATA DESCRIPTORS AND LIST OF BUFR DATA DESCRIPTORS
C     EXPANDED ACCORDING TO TABLE D REFERENCE ARE RETURNED RESPECTIVELY.
C
C
C
C     EXTERNALS.
C     ----------
C
C          BUNEXS        - SET WORD AND BIT POINTERS AT THE BEGINING OF
C                          NEXT SECTION
C          BUNPCK        - UNPACKS BIT PATTERN
C          BUSRP         - SOLVES REPLICATION PROBLEM
C          BUSTDR        - SOLVES TABLE D REFERENCE
C          BUPRCO        - PROCESS OPERATOR
C          BUUPWT        - UPDATES WORKING TABLE
C
C     REFERENCE.
C     ----------
C
C          NONE.
C
C     AUTHOR.
C     -------
C
C          M. DRAGOSAVAC    *ECMWF*       01/02/91.
C
C
C     MODIFICATIONS.
C     --------------
C
C          NONE.
C
C
      IMPLICIT LOGICAL(L,O,G), CHARACTER*8(C,H,Y)
C
C
#     include "parameter.F"
#     include "bcomunit.F"
#     include "bcomwork.F"
#     include "bcombef.F"
#     include "bcomwt.F"
#     include "bcomp.F"
#     include "bcomwtc.F"
#     include "bcomrq.F"
#     include "bcomreq.F"
#     include "bcomel.F"
#     include "bcprq.F"
#     include "bcomoff.F"
#     include "bcomcom.F"
C
      CHARACTER*64 CWTEN
      CHARACTER*24 CWTU
      CHARACTER*64 CNAMES(KELEM)
      CHARACTER*24 CUNITS(KELEM)
C
      DIMENSION ISTACK(JELEM),IISTACK(JELEM)
      DIMENSION KBUFF(KBUFL)
      DIMENSION IMASK(8)
C
#ifndef R_4
      REAL*8 RQVAL
      REAL*8 RVIND
      REAL*8 EPS
#else
      REAL   RQVAL
      REAL   RVIND
      REAL   EPS
#endif
C
      DIMENSION KSUP(JSUP),KSEC3(JSEC3)
C
      DATA IMASK/1,2,4,8,16,32,64,128/
C
      SAVE NOLD,KELEMOLD
C     ------------------------------------------------------------------
C
C*          1.   EXPAND PRELIMINARY ITEMS OF SECTION 3.
C                --------------------------------------
 100  CONTINUE
C
      IF( KERR.NE.0 ) RETURN
C
C
C*          1.1   SET THE POINTERS NWPT AND NBPT TO THE
C                 -------------------------------------
C                 BEGINING OF THE SECTION 3.
C                 --------------------------
 110  CONTINUE
C
      NWPT = NWPTB
      NBPT = NBPTB
C
C*          1.2   UNPACK LENGTH OF SECTION 3.
C                 ---------------------------
 120  CONTINUE
C
      CALL BUNPCK(NBPW,KBUFF,KSEC3(1),NWPT,NBPT,24,KERR)
      IF(KERR.GT.0) THEN
         WRITE(KNTN,*)  'ERROR UNPACKING KSEC3(1).'
         RETURN
      END IF
C
C*          1.2.1  SET THE POINTERS NWPTB AND NBPTB TO
C                  -----------------------------------
C                  THE BEGINNING OF THE NEXT SECTION.
C                  ----------------------------------
      CALL BUNEXS(KSEC3(1))
C
C*          1.3    UNPACK ZERO BYTE AND PUT IT IN KSEC3(2).
C                  ----------------------------------------
 130  CONTINUE
C
      CALL BUNPCK(NBPW,KBUFF,KSEC3(2),NWPT,NBPT,8,KERR)
      IF(KERR.GT.0) THEN
         WRITE(KNTN,*)  'ERROR UNPACKING KSEC3(2).'
         RETURN
      END IF
C
C*          1.4    UNPACK NUMBER OF DATA SUB-SETS.
C                  -------------------------------
 140  CONTINUE
C
      CALL BUNPCK(NBPW,KBUFF,KSEC3(3),NWPT,NBPT,16,KERR)
      IF(KERR.GT.0) THEN
         WRITE(KNTN,*)  'ERROR UNPACKING KSEC3(3).'
         RETURN
      END IF
      IF(KSEC3(3).LE.0) THEN
         KERR=32
         WRITE(KNTN,*)  ' BUEXS3 :'
         CALL BUERR(KERR)
         RETURN
      END IF
C
      N = KSEC3(3)
C
C
C*          1.5    UNPACK INTEGER VALUE OF THE OCTET
C                  ---------------------------------
C                  CONTAINING FLAG BITS.
C                  --------------------
 150  CONTINUE
C
      CALL BUNPCK(NBPW,KBUFF,KSEC3(4),NWPT,NBPT,8,KERR)
      IF(KERR.GT.0) THEN
         WRITE(KNTN,*)  'ERROR UNPACKING KSEC3(4).'
         RETURN
      END IF
C
      ICOMP=KSEC3(4)
C     -----------------------------------------------------------------
C
C*          2.   EXPAND DATA DESCRIPTORS.
C                ------------------------
 200  CONTINUE
C
C
C*          2.1  CALCULATE EXPECTED NUMBER OF DATA DESCRIPTORS.
C                ----------------------------------------------
C                AND INITIALIZE NUMBER OF DATA VALUES PER SUB-SET.
C                -------------------------------------------------
 210  CONTINUE
C
      J      = 0
      NWT    = 0
      JMAX   = ( KSEC3(1) - 7)/2
      JMAXNEW=JMAX
C
      IF(JMAX.GT.JELEM) THEN
         WRITE(KNTN,*)  'NUMBER OF ELEMENTS IN SECTION3 TOO BIG.'
         WRITE(KNTN,*)  'PROGRAM CAN NOT HANDLE',JMAX
         WRITE(KNTN,*)  'DATA DESCRIPTORS IN SECTION3.'
         WRITE(KNTN,*)  'MAXIMUM NUMBER OF ELEMENTS IS ',JELEM
         KERR=200
         RETURN
      END IF
C
C*          2.2  UNPACK AND PUT DATA DESCRIPTORS IN STACK.
C                -----------------------------------------
 220  CONTINUE
C
      DO 221 JJ=1,JMAX
C
      CALL BUNPCK(NBPW,KBUFF,IF,NWPT,NBPT,2,KERR)
      IF(KERR.GT.0) THEN
         WRITE(KNTN,*)  'ERROR UNPACKING F PART OF DESCRIPTOR.'
         RETURN
      END IF
      CALL BUNPCK(NBPW,KBUFF,IX,NWPT,NBPT,6,KERR)
      IF(KERR.GT.0) THEN
         WRITE(KNTN,*)  'ERROR UNPACKING X PART OF DESCRIPTOR.'
         RETURN
      END IF
      CALL BUNPCK(NBPW,KBUFF,IY,NWPT,NBPT,8,KERR)
      IF(KERR.GT.0) THEN
         WRITE(KNTN,*)  'ERROR UNPACKING Y PART OF DESCRIPTOR.'
         RETURN
      END IF
C
      ISTACK(JJ)=IF*100000+IX*1000+IY
      IISTACK(JJ)=ISTACK(JJ)
C
 221  CONTINUE
C
C*          2.2.1 CHECK IF IT IS SAME DATA DESCRIPTOR DESCRIPTION.
C                 ------------------------------------------------
C                 TO MAKE MORE EFFICIENT DATA DESCRIPTOR DESCRIPTION
C                 EXPANSION, IN CASE THAT DELAYED REPLICATION FACTOR
C                 IS NOT PRESENT AND DATA DESCRIPTORS ARE THE SAME,
C                 PREVIOUS WORKING TABLE SHOULD BE USED. IT IS POSIBLE
C                 AT THIS PLACE IN THE FUTURE TO MAKE MORE SOPHISTICATED
C                 CONTROL.
C
C
      DO 222 JC=1,JMAX
C
      IF(ISTACK(JC).NE.NSTACK(JC)) THEN
C
         ODREPF=.FALSE.
C
C        SWAP CONTENT OF THE STACKS.
C
         DO 223 JJC=1,JMAX
         NSTACK(JJC)=ISTACK(JJC)
 223     CONTINUE
C
         NTDLEN = JMAX
         M=0
         M0=1
         NOLD=N
         KELEMOLD=KELEM
         NFCM=0
         NFUCM=0
         MREL=0
         OMARKER=.FALSE.
         MBMP=0
         MBMPL=0
C
         GO TO 230
C
      END IF
C
 222  CONTINUE
C
C*    IF MARKER OPERATOR PRESENT EXPAND DESCRIPTORS AGAIN
C
      IF(OMARKER) THEN
         M=0
         M0=1
         NOLD=N
         KELEMOLD=KELEM
         NFCM=0
         NFUCM=0
         MREL=0
         OMARKER=.FALSE.
         NTDLEN=JMAX
         MBMP=0
         MBMPL=0
         GO TO 230
      END IF
C
C*    CHECK IF THE SAME NUMBER OF DESCRIPTORS
C     AS IN A PREVIOUS MESSAGE
C
      IF(JMAX.NE.NTDLEN) THEN
         M=0
         M0=1
         NOLD=N
         KELEMOLD=KELEM
         NFCM=0
         NFUCM=0
         MREL=0
         OMARKER=.FALSE.
         NTDLEN=JMAX
         MBMP=0
         MBMPL=0
         GO TO 230
      END IF
C
C*    RETURN IF DELAYED REPLICATION FACTOR IS NOT PRESENT.
C
      IF(NPRUS.EQ.1) GO TO 229
C
      OB=.FALSE.
      IF(IAND(KSEC3(4),IMASK(7)).NE.0) OB=.TRUE.
C
C     CHECK FOR DELAYED REPLICATION FACTOR
C
      IF(ODREPF) GO TO 229
C
C     CHECK FOR COMPRESSION
C
      IF(OB) THEN
C
C        DATA COMPRESSED =/ PREVIOUS  --> RECALCULATE POINTERS
C
         GO TO 229
      END IF
C
 229  CONTINUE
C
      M=0
      M0=1
      NOLD=N
      KELEMOLD=KELEM
      NFCM=0
      NFUCM=0
      MREL=0
      OMARKER=.FALSE.
      NTDLEN=JMAX
      MBMP=0
      MBMPL=0
C
C     ------------------------------------------------------------------
C*          2.3  GET NEXT DESCRIPTOR FROM THE STACK.
C                -----------------------------------
 230  CONTINUE
C
      J   = J + 1
      IF(J.GT.JMAX) GO TO 270
C
      IDD = ISTACK(J)
      IF(IDD.EQ.0)  GO TO 230
C
      IF = IDD/100000
C
      IF(NWT.GT.NSTOP) GO TO 270
C     ------------------------------------------------------------------
C*          2.4  CHECK IF IT IS REPLICATION DESCRIPTOR.
C                --------------------------------------
 240  CONTINUE
C
      IF( IF.EQ.0) THEN
C
C*          2.6  ELEMENT DESCRIPTOR, SO UPDATE WORKING TABLE.
C                --------------------------------------------
 260     CONTINUE
C
            CALL BUUPWT(IDD,KELEM,KERR)
            IF(KERR.GT.0) RETURN
C       
      ELSEIF( IF.EQ.1) THEN
C
C*          2.4.1     SOLVE REPLICATION PROBLEM.
C                     --------------------------
C
C
         CALL BUSRP(KBUFL,KBUFF,KSEC3,J,JMAX,IDD,ISTACK,KELEM,KERR)
         IF(KERR.GT.0) RETURN
C
      ELSEIF( IF.EQ.2) THEN
C
C*          2.5.3 PROCESS OPERATOR.
C                 -----------------
            CALL BUPRCO(KBUFL,KBUFF,J,IDD,ISTACK,KELEM,KERR)
            IF(KERR.GT.0) RETURN
C
      ELSEIF( IF.EQ.3) THEN
C
C*          2.5.2 REPLACE BY LIST OF DESCRIPTORS FROM TABLE *D.
C                 ---------------------------------------------
            CALL BUSTDR(J,JMAX,IDD,ISTACK,KERR)
            IF(KERR.GT.0) THEN
               DO 252 IQ=1,JELEM
               NSTACK(IQ)=0.
 252           CONTINUE
               RETURN
            END IF
      ELSE
         KERR=37
         CALL BUERR(KERR)
         RETURN
      END IF
C
      GO TO 230
C
C     ------------------------------------------------------------------
C*          2.7 RESOLVE MARKER OPERATOR.
C               ------------------------
 270  CONTINUE
C
      IF(OMARKER) THEN
         CALL BUPMRK(KBUFL,KBUFF,KSEC3,KELEM,KERR)
         IF(KERR.GT.0) RETURN
      END IF
C
C*          2.8 CHECK IF IT IS CORRESPONDING DATA.
C               ----------------------------------
 280  CONTINUE
C
C     CHECK FOR WORKING SPACE.
C
      IF(JWORK/N.LT.KELEM) THEN
         KERR=17
         WRITE(KNTN,*)  'BUEXS3:'
         CALL BUERR(KERR)
         MN=KELEM*N
         WRITE(KNTN,*)  ' SUGGESTED VALUE FOR JWORK ',MN
         WRITE(KNTN,*)  ' CHECK IF TOO BIG KELEM USED.'
         RETURN
      END IF
C
      IF(IAND(KSEC3(4),IMASK(7)).NE.0) THEN
C
C        COMPRESSED DATA
C
         CALL BURQC(KBUFL,KBUFF,KELEM,CNAMES,CUNITS,KSUP ,KSEC3,KERR)
         IF(KERR.GT.0) RETURN
      ELSE
C
C        UNCOMPRESSED DATA
C
         CALL BURQUC(KBUFL,KBUFF,KELEM,CNAMES,CUNITS,KSUP ,KSEC3,KERR)
         IF(KERR.GT.0) RETURN
C
      END IF
C
C     ------------------------------------------------------------------
C
C*          3. COLLECT  SUPPLEMENTARY ITEMS.
C              -----------------------------
 300  CONTINUE
C
      NTDEXL =M
      DO 301 I=1,NTDEXL
      NTDEXP(I)=INWTR(I)
 301  CONTINUE
C
      NTDLEN=JMAXNEW
      DO 302 I=1,NTDLEN
      NTDLST (I)=IISTACK(I)
 302  CONTINUE
C
      DO 303 I=1,NTDEXL
      IJ=I+(NSUBSET-1)*KELEM
      NWTRG(IJ)=INWTR(I)
      NWTDWG(IJ)=INWTDW(I)
 303  CONTINUE
C
      NSIZE(NSUBSET)  =M
C
      KSUP(3)= 4
      KSUP(5)= NSIZE(1)
      KSUP(6)= KSEC3(3)
C
      N07=0
      N08=0
      N40=0
      NDWINC=0
      NSCAM=0
      NSCAM07=0
      NDWINC07=0
      NFD=0
    
      do i=1,100
      NAFDWA(i)=0
      end do
      RETURN
      END

C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

C
      COMMON /BCOMREQ/ RQVAL(JELEM),NREQ(2),NRQ(JELEM),NRQL
C
C             *NREQ*    -  FLAG
C                          BIT NUMBER     MEANING
C
C                              1        - 0 NO BIT MAP DELIVERED TO USER
C                                         1    BIT MAP DELIVERED TO USER
C                              2        - 0 NO PARTIAL EXPANSION
C                                         1    PARTIAL EXPANSION
C                              3        - 0 NO Q/C REQUIRED
C                                       - 1    Q/C REQUIRED
C                              4        - 0 NO STATISTICS REQUIRED
C                                       - 1    STATISTICS
C                              5        - 0 NO DIFFRENCE STATISTICS
C                                       - 1    DIFFERENCE STATISTICS
C                              6        - 0 NO SUBSTITUTED VALUES
C                                       - 1    SUBSTITUTED VALUES
C             *NRQL*    -  NUMBER OF REQUESTED ELEMENTS
C             *NRQ*     -  LIST OF REQUESTED TABLE B REFERENCE
C             *RQVAL*   -  LIST OF VALUES SIGNIFYING REQUESTED ELEMENT
C                          (SAY PRESSURE  AT 50000 PA)
C

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C


      SUBROUTINE VOD2UV(VOR,DIV,KTIN,U,V,KTOUT)
C
C---->
C
CL    CALCULATE SPHERICAL HARMONIC COEFFICIENTS OF U*COS(LAT) AND
CL    V*COS(LAT) AT TRIANGULAR TRUNCATION KTOUT, GIVEN THE COEFFICIENTS
CL    OF DIVERGENCE AND VORTICITY AT TRUNCATION KTIN
CL
CL    WHERE VOR(KDIM1)=INPUT ARRAY OF VORTICITY COEFFICIENTS
CL          DIV(KDIM1)=INPUT ARRAY OF DIVERGENCE COEFFICIENTS
CL          KTIN      =INPUT TRIANGULAR TRUNCATION
CL          KDIM1     =(KTIN+1)*(KTIN+2)
CL          U(KDIM2)  =OUTPUT ARRAY OF U*COS(LAT) COEFFICIENTS
CL          V(KDIM2)  =OUTPUT ARRAY OF V*COS(LAT) COEFFICIENTS
CL          KTOUT     =OUTPUT TRIANGULAR TRUNCATION (KTOUT.LE.KTIN)
CL          KDIM2     =(KTOUT+1)*(KTOUT+4)
C
C     VERSION 1   5/1/81   JAN HASELER   ECMWF
C
C     VERSION 2   5/5/87   MODIFIED BY D. R. ROSKILLY
C     THIS MOD. DOES NOT CALCULATE THE EXTRA VALUES FOR
C     U AND V WINDS TO ALLOW VORT. AND DIV. TO BE RE-CALCULATED
C     IF REQUIRED.
C
C     Version 3  15/2/88   routine renamed VOD2UV from DVTOUV.
C
C     VERSION 4  21/8/91   MODIFIED BY K.RIDER
C
C     THIS MOD. WAS MADE BECAUSE VERSION 2 WAS INCONSISTENTLY
C     TRUNCATING U AND V TO T(ITOUT-1).
C     NOW VORT. AND DIV. ARE CONSISTENTLY TRUNCATED TO T105
C     AND U AND V ARE CALCULATED WITH TRUNCATION T(ITOUT),(WITH
C     ZERO VALUES AT THE CORNER. VORT. AND DIV. CAN BE RECALCULATED
C     IF REQUIRED, BUT ONLY TRUNCATED TO T(ITOUT) SINCE THE HIGHER
C     COEFFICIENTS HAVE BEEN LOST.
C
C----<
C
      COMPLEX VOR(1),DIV(1),U(1),V(1),ZI
C
      DD(PM,PN)=-SQRT((PN*PN-PM*PM)/(4.*PN*PN-1.))/PN
      SS(PM,PN)=-PM/(PN*(PN+1.))
C
      ZI=(0.,1.)
      REARTH=6.371E6
      K=1
      IMN=1
      ITOUT=MIN0(KTOUT,KTIN)
C
CL            1.1       M<ITOUT; N=M
 110  CONTINUE
      DO 155 JM=1,ITOUT
      ZM=JM-1.
      ZN=ZM
      IF (JM.EQ.1) GOTO 115
      U(K)=(-DD(ZM,ZN+1.)*VOR(IMN+1)+ZI*SS(ZM,ZN)*DIV(IMN))*REARTH
      V(K)=( DD(ZM,ZN+1.)*DIV(IMN+1)+ZI*SS(ZM,ZN)*VOR(IMN))*REARTH
      GOTO 120
C
 115  CONTINUE
      U(K)=(-DD(ZM,ZN+1.)*VOR(IMN+1))*REARTH
      V(K)=( DD(ZM,ZN+1.)*DIV(IMN+1))*REARTH
C
 120  CONTINUE
      IMN=IMN+1
      K=K+1
      JMP=JM+1
      IF (JMP.GT.ITOUT) GOTO 140
C
CL            1.3       M<ITOUT; N<ITOUT-1
 130  CONTINUE
      DO 135 JN=JMP,ITOUT-1
      ZN=JN-1.
      U(K)=( DD(ZM,ZN)*VOR(IMN-1)-DD(ZM,ZN+1)*VOR(IMN+1)
     1        +ZI*SS(ZM,ZN)*DIV(IMN))*REARTH
      V(K)=(-DD(ZM,ZN)*DIV(IMN-1)+DD(ZM,ZN+1)*DIV(IMN+1)
     1        +ZI*SS(ZM,ZN)*VOR(IMN))*REARTH
      K=K+1
 135  IMN=IMN+1
C
CL            1.3.1     M<ITOUT; N=ITOUT-1
 136  CONTINUE
      ZN=ITOUT-1
      U(K)=( DD(ZM,ZN)*VOR(IMN-1)+ZI*SS(ZM,ZN)*DIV(IMN))*REARTH
      V(K)=(-DD(ZM,ZN)*DIV(IMN-1)+ZI*SS(ZM,ZN)*VOR(IMN))*REARTH
      K=K+1
      IMN=IMN+1
C
CL            1.4       M<ITOUT; N=ITOUT
 140  CONTINUE
      ZN=ITOUT
      U(K)=( DD(ZM,ZN)*VOR(IMN-1))*REARTH
      V(K)=(-DD(ZM,ZN)*DIV(IMN-1))*REARTH
      K=K+1
C
CL            1.5       M<ITOUT; N=ITOUT+1
 150  CONTINUE
C--   ZN=ITOUT+1
C--   U(K)=( DD(ZM,ZN)*VOR(IMN))*REARTH
C--   V(K)=(-DD(ZM,ZN)*DIV(IMN))*REARTH
C--   K=K+1
      IMN=IMN+1+KTIN-ITOUT
 155  CONTINUE
C
CL            1.6       M=ITOUT; N=ITOUT
 160  CONTINUE
      U(K)=0.
      V(K)=0.
      K=K+1
C
CL            1.7       M=ITOUT; N=ITOUT+1
 170  CONTINUE
C--   ZN=ITOUT+1
C--   U(K)= DD(ZM,ZN)*VOR(IMN)*REARTH
C--   V(K)=-DD(ZM,ZN)*DIV(IMN)*REARTH
C
      RETURN
      END

#ifdef IBM
@PROCESS HOT(NOVECTOR) NOSTRICT
#endif
C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE JSYMLL( PSHUP, KTRUNC, PSTART, PBUILD, PINTVL, KLUNIT, 
     X                   KLATO,KLONO,PLEG,PTRIGS,KMFAX,PZFA,KRET)
C
C---->
C**** JSYMLL
C
C     PURPOSE
C     _______
C
C     This routine converts spectral input fields to standard
C     lat/long grid fields.
C
C     INTERFACE
C     _________
C
C     CALL JSYMLL( PSHUP, KTRUNC, PSTART, PBUILD, PINTVL, KLUNIT, 
C    X             KLATO,KLONO,PLEG,PTRIGS,KMFAX,PZFA,KRET)
C
C     Input parameters
C     ________________
C
C     PSHUP    - Spherical harmonics field, unpacked
C     KTRUNC   - Truncation number of spherical harmonics field
C     PSTART   - Start latitude (northernmost) for output field
C                (must be positive - see comments below)
C     PBUILD   - Grid interval used to build the legendre coefficients
C                file
C     PINTVL   - Grid interval in degrees
C     KLUNIT   - stream number of the legendre function file
C     KLATO    - Number of latitude points in output field
C     KLONO    - Number of longitude points in output field
C     PLEG     - Array used to hold legendre functions
C     PTRIGS   - Initialized array of trig.functions (setup by JJSET99)
C     KMFAX    - Initialized array of prime factors (setup by JJSET99)
C
C     Output parameters
C     ________________
C
C     PZFA    - Output grid point field; contains upto 32 each
C               of North and South latitude rows symmetrically.
C     KRET     - Return status code
C                0 = OK
C
C     Common block usage
C     __________________
C
C     JDCNDBG
C
C     Method
C     ______
C
C     None.
C
C     Externals
C     _________
C
C     JREADLL - Reads the legendre functions for a latitude
C     FFT99   - Carries out FFT
C     INTLOG  - Output log message
C     INTLOGR - Output log message (with real value)
C     NMAKLL  - Make interpolation coefficients one latitude at a time
C
C     Reference
C     _________
C
C     E.C.M.W.F. Research Department technical memorandum no. 56
C                "The forecast and analysis post-processing package"
C                May 1982. J.Haseler.
C
C     Comments
C     ________
C
C     This is a redesign, based on SPECGP.F
C
C     It handles transformation to a regular lat/long grid.
C     The generated grid is symmetrical about the equator, so 
C     PSTART must be positive.
C
C     It is not for U and V fields (no correction is applied at the 
C     poles).
C
C
C     AUTHOR
C     ______
C
C     J.D.Chambers      *ECMWF*      Nov 1993
C
C     MODIFICATIONS
C     _____________
C
C     J.D.Chambers     ECMWF        Feb 1997
C     Allow for 64-bit pointers
C
C----<
C     _______________________________________________________
C
C
      IMPLICIT NONE
#include "jparams.h"
#include "parim.h"
#include "nifld.common"
C
C     Parameters
      INTEGER JPROUTINE
      PARAMETER ( JPROUTINE = 31300 )
C
C     Subroutine arguments
      COMPLEX   PSHUP
      DIMENSION PSHUP(*)
      INTEGER   KTRUNC
      REAL      PSTART, PBUILD, PINTVL
      INTEGER   KLUNIT, KLATO, KLONO, KMFAX, KRET
      REAL PLEG, PTRIGS, PZFA
      DIMENSION PZFA(JPLONO+2, 64)
      DIMENSION KMFAX(*), PLEG(*), PTRIGS(*)
C
C     Local variables
      REAL ZLAT
      INTEGER ILIM, IMLIM, ILN
      INTEGER ITAL, ITALA, ITALS, IMN, IMP
      INTEGER INORTH, ISOUTH
      INTEGER JM, J, JNEXTLAT, JF
      INTEGER NERR
      INTEGER*8 JDCLOOP
      INTEGER*8 IOFF
	  Integer Itimer,timer1,timer280,timerFFT
      Integer timer246,timer244,time
C
#ifndef _CRAYFTN
#ifdef POINTER_64
      INTEGER*8 IWORK
#endif
#endif
      REAL WORK
      DIMENSION WORK(1)
      POINTER ( IWORK, WORK )
      COMPLEX   ZSUMS(JPTRNC + 1), ZSUMA(JPTRNC + 1)
      COMPLEX*16 CHOLD
      INTEGER LOOP
C
      INTEGER ISIZE
      DATA ISIZE/0/
      SAVE ISIZE, IWORK
C
C     _______________________________________________________
C
C*    Section 1.    Initialization.
C     _______________________________________________________
C
  100 CONTINUE
cs      timer1=Itimer(0)
C
C     First time through, dynamically allocate memory for workspace
C
      IF( ISIZE.EQ.0 ) THEN
        ISIZE =  2*JPFFT*64
        CALL JMEMHAN( 9, IWORK, ISIZE, 1, KRET)
        IF( KRET.NE.0 ) THEN
          CALL INTLOG(JP_ERROR,'JSYMLL: memory allocation error.',IWORK)
          KRET = JPROUTINE + 1
          GOTO 990
        ENDIF
      ENDIF
C
      IF ( NDBG .GT. 1) THEN
        CALL INTLOG(JP_DEBUG,
     X    'JSYMLL: Spherical harmonic coeffs(first 20):',JPQUIET)
        DO 101 NDBGLP = 1, 20
          CALL INTLOGR(JP_DEBUG,' ',PSHUP( NDBGLP ))
  101   CONTINUE
        CALL INTLOG(JP_DEBUG,'JSYMLL: Input parameters:',JPQUIET)
        CALL INTLOG(JP_DEBUG,
     X    'JSYMLL: Spherical harmonic truncation = ', KTRUNC)
        CALL INTLOGR(JP_DEBUG,
     X    'JSYMLL: Start latitude(northernmost) = ', PSTART)
        CALL INTLOGR(JP_DEBUG,
     X    'JSYMLL: Grid lat. interval(leg. file) = ', PBUILD)
        CALL INTLOGR(JP_DEBUG,
     X    'JSYMLL: Grid lat. interval(degrees) = ', PINTVL)
        CALL INTLOG(JP_DEBUG,
     X    'JSYMLL: Stream number of leg. file = ', KLUNIT)
        CALL INTLOG(JP_DEBUG,
     X    'JSYMLL: Number of lat. rows in output = ', KLATO)
        CALL INTLOG(JP_DEBUG,
     X    'JSYMLL: Number of long. pts per row = ', KLONO)
        CALL INTLOG(JP_DEBUG,
     X    'JSYMLL: Trig.functions (setup by JJSET99):',JPQUIET)
        DO 102 NDBGLP = 1, 10
          CALL INTLOGR(JP_DEBUG,' ',PTRIGS( NDBGLP ))
  102   CONTINUE
        CALL INTLOG(JP_DEBUG,
     X    'JSYMLL: Prime factors (setup by JJSET99):',JPQUIET)
        DO 103 NDBGLP = 1, 10
          CALL INTLOG(JP_DEBUG,' ',KMFAX( NDBGLP ))
  103   CONTINUE
      ENDIF
      ILIM   = KTRUNC + 1
      IMLIM  = KTRUNC + 1
      INORTH = -1
      ILN    = KLONO + 2
C
C     _______________________________________________________
C
C*    Section 2.    Main loop through latitude rows to
C*                  calculate fourier coefficients
C     _______________________________________________________
C
 200  CONTINUE
C     timer280=Itimer(0)
C
C     For each latitude, the north and corresponding south latitude row
C     are calculated at the same time from the same legendre functions.
C
      DO 280 JNEXTLAT = 1, KLATO
        ZLAT  = ( PSTART - (PINTVL * REAL(JNEXTLAT - 1)) )
C
        IF ( NDBG .GT. 1)
     X    CALL INTLOGR(JP_DEBUG,'JSYMLL: Next latitude = ', ZLAT)
C
C       If required, generate the coefficients 'on the fly'
C
        IF( LON_FLY ) THEN
          CALL NMAKLL( KTRUNC, PBUILD, ZLAT, 1, PLEG, NERR)
          IOFF = 0
        ELSE IF(LFILEIO ) THEN
          CALL JREADLL( KLUNIT, KTRUNC, PBUILD, ZLAT, PLEG, NERR)
          IF ( NERR .NE. 0 ) THEN
            CALL INTLOG(JP_ERROR,'JSYMLL: JREADLL error',NERR)
	    KRET = JPROUTINE + 2
	    GOTO 990
	  ENDIF
        ELSE
          IOFF = NINT( (90.0 - ZLAT)/PBUILD )
          IOFF = IOFF *(KTRUNC+1)
          IOFF = IOFF *(KTRUNC+4)
          IOFF = IOFF/2
	ENDIF
C
C       Clear unused slots in array.
C       Note there are two slots in the array - one for north latitude 
C       and one for the corresponding south latitude.
        INORTH = INORTH + 2
        ISOUTH = INORTH + 1
        DO 241 JF = 2*IMLIM + 1, ILN
          PZFA(JF, INORTH) = 0.0
          PZFA(JF, ISOUTH) = 0.0
 241    CONTINUE
C
C       Now fill slots which are used
        IMN = 0
        IMP = 0
C
C       timer244=Itimer(0)
        DO JM = 1, IMLIM
          ITAL = ILIM - JM + 1
          ITALS = (ITAL + 1)/2
          ITALA = ITAL/2
          CHOLD=(0.0D0, 0.0D0)
          DO J = 1, 2*ITALS, 2
            IF( LFILEIO ) THEN
              CHOLD=CHOLD+PLEG(IMP+J)*PSHUP(IMN+J)
            ELSE
              JDCLOOP = IMP + J + IOFF
              CHOLD=CHOLD+PLEG(JDCLOOP)*PSHUP(IMN+J)
            ENDIF
          ENDDO
          ZSUMS(JM)=CHOLD
          CHOLD = (0.0D0, 0.0D0)
          DO J = 2, 2*ITALA, 2
            IF( LFILEIO ) THEN
              CHOLD=CHOLD+PLEG(IMP+J)*PSHUP(IMN+J)
            ELSE
              JDCLOOP = IMP + J + IOFF
              CHOLD=CHOLD+PLEG(JDCLOOP)*PSHUP(IMN+J)
            ENDIF
          ENDDO
          ZSUMA(JM)=CHOLD
          IMP = IMP + ITAL + 1
          IMN = IMN + ITAL
        ENDDO
C       timer244=Itimer(timer244)
C
C       For the southern hemisphere row, the legendre functions are
C       the complex conjugates of the corresponding northern row -
C       hence the juggling with the signs in the next loop.
C
C       Note that PZFA is REAL, but the coefficients being calculated
C       are COMPLEX.  There are pairs of values for each coefficient
C       (real and imaginary parts) and pairs of values for each
C       latitude (north and south).
C
C       timer246=Itimer(0)
        DO 246 JM = 1, IMLIM
          PZFA(2*JM -1, INORTH) = REAL(ZSUMS(JM))  + REAL(ZSUMA(JM))
          PZFA(2*JM   , INORTH) = AIMAG(ZSUMS(JM)) + AIMAG(ZSUMA(JM))
          PZFA(2*JM -1, ISOUTH) = REAL(ZSUMS(JM))  - REAL(ZSUMA(JM))
          PZFA(2*JM   , ISOUTH) = AIMAG(ZSUMS(JM)) - AIMAG(ZSUMA(JM))
 246    CONTINUE
C       timer246=Itimer(timer246)
C
C*    End of main loop through latitude rows.
C
 280  CONTINUE
C     timer280=Itimer(timer280)
C     print*,'JSYMLL: legendre functions klat=',KLATO,' time:',timer280,
C    X    ' seconds loop 246:',timer246,' loop 244:',timer244
C
C     _______________________________________________________
C
C*    Section 3.    Fast fourier transform
C     _______________________________________________________
C
 300  CONTINUE
C     timerFFT=Itimer(0)
C
      IF ( NDBG .GT. 1) CALL INTLOG(JP_DEBUG,
     X  'JSYMLL: FFT, no.of rows (N and S) = ', ISOUTH)
C
      CALL FFT99(PZFA,WORK,PTRIGS,KMFAX,1,J2NFFT,KLONO,ISOUTH,1)
C
      IF ( NDBG .GT. 1) THEN
        CALL INTLOG(JP_DEBUG,
     X    'JSYMLL: Values calculated by FFT:',JPQUIET)
        DO 301 NDBGLP = 1, 20
        CALL INTLOGR(JP_DEBUG,' ', PZFA( 1, NDBGLP ))
        CALL INTLOGR(JP_DEBUG,' ', PZFA( 2, NDBGLP ))
  301   CONTINUE
      ENDIF
C     timerFFT=Itimer(timerFFT)
C     timer1=Itimer(timer1)
C     print*,'JSYMLL: legendre functions Total:',timer1,' sec first:',
C    X    timerMEM,' FFT99: ',timerFFT
C
C     _______________________________________________________
C
C*    Section 9. Return to calling routine. Format statements
C     _______________________________________________________
C
C
 900  CONTINUE
C
      KRET = 0
C
 990  CONTINUE
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C


      SUBROUTINE GENBIN (IN,NBIT,OUT,ERR)
C
C---->
C**********************************************************************
C*
C*  NAME      : GENBIN
C*
C*  FUNCTION  : PRODUCES A BINARY NUMBER WITH ONES AND ZEROES
C*              CORRESPONDING TO THE ONES AND ZEROES OF THE INPUT
C*              DECIMAL NUMBER.
C*              EG INPUT NUMBER 1010 DECIMAL , OUTPUT 1010 BINARY.
C*
C*  INPUT     : IN   - INTEGER VARIABLE CONTAINING DECIMAL NUMBER.
C*              NBIT - NUMBER OF DIGITS TO BE USED.
C*
C*  OUTPUT    : OUT  - INTEGER VARIABLE CONTAINING BINARY VALUE
C*                     WITH ONES AND ZEROES CORRESPONDING TO THOSE OF
C*                     THE INPUT DECIMAL NUMBER.
C*
C*              ERR  - 0 IF NO ERROR, 1 IF INVALID NUMBER OF BITS.
C*
C*    JOHN HENNESSY     ECMWF, OCTOBER 1985
C*
C**********************************************************************
C----<
C
      IMPLICIT INTEGER (A-Z)
C
      OUT = 0
      INN = IN
C
C     CHECK SIZE OF INTEGER
C
      IF (NBIT.LT.0.OR.NBIT.GT.15)
     C   THEN
             ERR = 1
             RETURN
         ELSE
             ERR = 0
         ENDIF
C
         DO 100 I=1,NBIT
            TEMP = INN / 10
            DIFF = INN - (TEMP*10)
            K    = I - 1
            MASC = 2**K
            IF (DIFF.NE.0) OUT = OR(OUT,MASC)
            INN = TEMP
  100    CONTINUE
C
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      INTEGER FUNCTION IGLSIZE(KSTRIDE, KAREA, KNWE, KNNS, KLN,
     1   OWEGLOBE, ONPOLE, OSPOLE, KPR, KERR)
C
C---->
C**** *IGLSIZE*
C
C     PURPOSE
C     _______
C
C     Evaluate the array sizes for a regular latitude/longitude grid
C     and area.
C
C     INTERFACE
C     _________
C
C     IERR = IGLSIZE(KSTRIDE, KAREA, KNWE, KNNS, KLN, OWEGLOBE,
C    1   ONPOLE, OSPOLE, KPR, KERR)
C
C     Input parameters
C     ________________
C
C     KSTRIDE    - The field grid definition (WE, NS).
C
C     KAREA      - The field area definition (N, W, S, E) provided by
C                  the calling routine.
C
C     KNWE       - The number of points in the West-East direction in
C                  the field. This will be zero for an output field.
C
C     KNNS       - The number of points in the North-South direction
C                  in the field. This will be zero for an output field.
C
C     KPR        - The debug print switch.
C                  0  , No debugging output.
C                  1  , Produce debugging output.
C
C     KERR       - The error control flag.
C                  -ve, No error message. Return error code.
C                  0  , Hard failure with error message.
C                  +ve, Print error message. Return error code.
C
C     Output parameters
C     ________________
C
C     KNWE       - The number of points in the West-East direction in
C                  the field.
C
C     KNNS       - The number of points in the North-South direction
C                  in the field.
C
C     KLN        - The line number of the Northern latitude. This
C                  value is used during land sea mask processing to
C                  evaluate offsets in the "standard" files.
C
C     OWEGLOBE   - This variable will be true if the array of
C                  longitudes spans the globe.
C
C     ONPOLE     - This variable will be true if the North polar line
C                  of latitude is included in the grid.
C
C     OSPOLE     - This variable will be true if the South polar line
C                  of latitude is included in the grid.
C
C     Return value
C     ____________
C
C     The error indicator (INTEGER).
C
C     Error and Warning Return Values
C     _______________________________
C
C     -1    The West-East range does not match the stride and number
C           of points.
C     -2    The North-South range does not match the stride and
C           number of points.
C
C     The two problems above could be caused by known deficiencies
C     in the GRIB representation of ranges and strides. They will be
C     treated as WARNING values.
C
C     25101 A global field is requested with an inappropriate
C           West-East stride.
C     25102 A global field is requested with an inappropriate
C           North-South stride.
C
C     Common block usage
C     __________________
C
C     None
C
C     EXTERNALS
C     _________
C
C     INTLOG(R)    - Logs messages.
C
C     METHOD
C     ______
C
C     If all elements of array KAREA are zero then limits for the
C     appropriate global grid are generated.
C
C     Otherwise it is assumed that all the limits in KAREA have been
C     validated and the sizes of the arrays required are calculated.
C
C     REFERENCE
C     _________
C
C     None
C
C     COMMENTS
C     ________
C
C     Program contains sections 0 to 4 and 9
C
C     AUTHOR
C     ______
C
C     K. Fielding      *ECMWF*      Oct 1993
C
C     MODIFICATIONS
C     _____________
C
C     J.D.Chambers   ECMWF   March 1999
C     Use tolerance when testing E-W and N-S global span.
C
C----<
C     _______________________________________________________
C
C     Section 0. Definition of variables.
C     _______________________________________________________
C
      IMPLICIT NONE
C
#include "parim.h"
C
C     Function arguments
C
      LOGICAL OWEGLOBE, ONPOLE, OSPOLE
      INTEGER KNWE, KNNS, KLN, KPR, KERR
      INTEGER KSTRIDE(2), KAREA(4)
C
C     Parameters
C
      INTEGER JPROUTINE, JPEPSI
      PARAMETER (JPROUTINE = 25100)
      PARAMETER (JPEPSI = 50)
C                          `---> represents 0.5 millidegree to allow for
C                                grid step being off by upto 0.5 millidgrees
C
C
C     Local variables
C
      INTEGER IEAST, IWEST, IREACH, INORTH, ISOUTH
C
C     _______________________________________________________
C
C     Section 1. Initialisation
C     _______________________________________________________
C
  100 CONTINUE
C
      IF( KPR.GE.1 ) CALL INTLOG(JP_DEBUG,'IGLSIZE: Section 1.',JPQUIET)
C
      IGLSIZE = 0
C
      IF( KPR.GE.1 ) THEN
        CALL INTLOG(JP_DEBUG,'IGLSIZE: Input parameters.',JPQUIET)
         IF( KNWE.NE.0 ) CALL INTLOG(JP_DEBUG,
     X     'IGLSIZE: No.long pts = ',KNWE)
         IF( KNNS.NE.0 ) CALL INTLOG(JP_DEBUG,
     X     'IGLSIZE: No.lat. pts = ',KNNS)
        CALL INTLOG(JP_DEBUG,'IGLSIZE: Grid WE stride = ',KSTRIDE(1))
        CALL INTLOG(JP_DEBUG,'IGLSIZE: Grid NS stride = ',KSTRIDE(2))
        CALL INTLOG(JP_DEBUG,'IGLSIZE: Area North = ', KAREA(1))
        CALL INTLOG(JP_DEBUG,'IGLSIZE: Area West  = ', KAREA(2))
        CALL INTLOG(JP_DEBUG,'IGLSIZE: Area South = ', KAREA(3))
        CALL INTLOG(JP_DEBUG,'IGLSIZE: Area East  = ', KAREA(4))
      ENDIF
C
C     _______________________________________________________
C
C     Section 2. Generate global limits if no limits set
C     _______________________________________________________
C
  200 CONTINUE
C
      IF( KPR.GE.1 ) CALL INTLOG(JP_DEBUG,'IGLSIZE: Section 2.',JPQUIET)
C
      IF( (KAREA(JPEAST).EQ.0 )  .AND.
     X    (KAREA(JPWEST).EQ.0 )  .AND.
     X    (KAREA(JPNORTH).EQ.0 ) .AND.
     X    (KAREA(JPSOUTH).EQ.0 ) ) THEN
C
        IF( MOD(JP360,KSTRIDE(JPWESTEP)).NE.0 ) THEN
          IGLSIZE = JPROUTINE + 1
          IF( KERR.GE.0 ) THEN
            CALL INTLOGR(JP_ERROR,
     X        'IGLSIZE: West-East stride for global grid = ',
     X        REAL(KSTRIDE(JPWESTEP))/PPMULT)
            CALL INTLOGR(JP_ERROR,
     X        'IGLSIZE: This is not a factor of ',
     X        REAL(JP360)/PPMULT)
          ENDIF
C
          IF( KERR.EQ.0 ) CALL INTLOG(JP_FATAL,
     X      'IGLSIZE: Interpolation failed.',IGLSIZE)
C
          GO TO 900
        ENDIF
C
        IF( MOD(JP180,KSTRIDE(JPNSSTEP)).NE.0 ) THEN
          IGLSIZE = JPROUTINE + 2
          IF( KERR.GE.0 ) THEN
            CALL INTLOGR(JP_ERROR,
     X        'IGLSIZE: North-South stride for global grid = ',
     X        REAL(KSTRIDE(JPNSSTEP))/PPMULT)
            CALL INTLOGR(JP_ERROR,
     X        'IGLSIZE: This is not a factor of ',
     X        REAL(JP180)/PPMULT)
          ENDIF
C
          IF( KERR.EQ.0 ) CALL INTLOG(JP_FATAL,
     X      'IGLSIZE: Interpolation failed.',IGLSIZE)
C
          GO TO 900
        ENDIF
C
        KAREA(JPNORTH) = JP90
        KAREA(JPWEST) = 0
        KAREA(JPSOUTH) = - JP90
        KAREA(JPEAST) = JP360 - KSTRIDE(JPWESTEP)
C
      ENDIF
C
C     _______________________________________________________
C
C     Section 3. Standardise West-East limits and check for
C                West-East global fields
C     _______________________________________________________
C
  300 CONTINUE
C
      IF( KPR.GE.1 ) CALL INTLOG(JP_DEBUG,'IGLSIZE: Section 3.',JPQUIET)
C
C     Force both KAREA(JPWEST) and KAREA(JPEAST) into standard
C     range (0 to JP360)
C
      IF( KAREA(JPWEST).LT.0 ) KAREA(JPWEST) = KAREA(JPWEST) + JP360
C
      IF( KAREA(JPEAST).LT.0 ) KAREA(JPEAST) = KAREA(JPEAST) + JP360
C
C     Standardise range so that EAST > WEST
C
      IEAST = KAREA(JPEAST)
      IWEST = KAREA(JPWEST)
C
      IF( IEAST.LT.IWEST ) THEN
C
        IF( IEAST.LT.0 ) THEN
          IEAST = IEAST + JP360
          KAREA(JPEAST) = IEAST
        ELSE
          IWEST = IWEST - JP360
          KAREA(JPWEST) = IWEST
        ENDIF
C
      ENDIF
C
      IF( KNWE.EQ.0 ) THEN
C
C       Is it a global grid ?
C
        IREACH = IEAST - IWEST + KSTRIDE(JPWESTEP)
C
        OWEGLOBE = IREACH.GE.JP360
C
C       Number of points along line is
C
        KNWE = NINT( FLOAT(IREACH) / FLOAT(KSTRIDE(JPWESTEP)) )
C
      ELSE
C
C       Number of points is set (input field)
C
        IF( ABS(IWEST+(KNWE-1)*KSTRIDE(JPWESTEP)-IEAST).GT.
     X      ((KNWE-1)*JPEPSI) ) THEN
C
C         WARNING of possible mismatch
C
          IGLSIZE = - 1
          CALL INTLOGR(JP_WARN,
     X      'IGLSIZE: West-East range = ',REAL(KAREA(JPWEST))/PPMULT)
          CALL INTLOGR(JP_WARN,
     X      'IGLSIZE: to = ',REAL(KAREA(JPEAST))/PPMULT)
          CALL INTLOG(JP_WARN,
     X      'IGLSIZE: Does not match no. of pts = ',KNWE)
          CALL INTLOGR(JP_WARN,
     X      'IGLSIZE: and stride = ',REAL(KSTRIDE(JPWESTEP))/PPMULT)
C
        ENDIF
C
        OWEGLOBE = ABS((KNWE * KSTRIDE(JPWESTEP))-JP360).LT.
     X             (KNWE*JPEPSI)
C
      ENDIF
C
C     _______________________________________________________
C
C     Section 4. Generate points along a line of meridian
C     _______________________________________________________
C
  400 CONTINUE
C
      IF( KPR.GE.1 ) CALL INTLOG(JP_DEBUG,'IGLSIZE: Section 4.',JPQUIET)
C
      INORTH = KAREA(JPNORTH)
      ISOUTH = KAREA(JPSOUTH)
      IF( INORTH.LT.ISOUTH ) THEN
        INORTH = KAREA(JPSOUTH)
        ISOUTH = KAREA(JPNORTH)
      ENDIF
C
      IF( KNNS.EQ.0 ) THEN
C
C     Number of lines not set (output field)
C
        IREACH = INORTH - ISOUTH + KSTRIDE(JPNSSTEP)
C
        KNNS = NINT( FLOAT(IREACH) / FLOAT(KSTRIDE(JPNSSTEP)) )
C
      ELSE
C
C       Number of lines is set (input field)
C
        IF(
     X    ABS(INORTH-(KNNS-1)*KSTRIDE(JPNSSTEP)-ISOUTH)
     X    .GT.((KNNS-1)*JPEPSI) ) THEN
C
C     WARNING of possible mismatch
C
          IGLSIZE = - 2
          CALL INTLOGR(JP_WARN,
     X      'IGLSIZE: North-South range = ',REAL(INORTH)/PPMULT)
          CALL INTLOGR(JP_WARN,
     X      'IGLSIZE: to = ',REAL(ISOUTH)/PPMULT)
          CALL INTLOG(JP_WARN,
     X      'IGLSIZE: Does not match no. of pts = ',KNNS)
          CALL INTLOGR(JP_WARN,
     X      'IGLSIZE: and stride = ',REAL(KSTRIDE(JPNSSTEP))/PPMULT)
C
         ENDIF
C
      ENDIF
C
      KLN = (JP90 - INORTH ) / KSTRIDE(JPNSSTEP) + 1
C
C     Check if North and South poles within grid
C
      ONPOLE = INORTH.EQ.JP90
      OSPOLE = ISOUTH.EQ.(- JP90)
C
      IF( KPR.GE.1 ) THEN
        CALL INTLOG(JP_DEBUG,'IGLSIZE: Output parameters.',JPQUIET)
        IF( KNWE.NE.0 ) CALL INTLOG(JP_DEBUG,
     X    'IGLSIZE: No.long pts = ',KNWE)
        IF( KNNS.NE.0 ) CALL INTLOG(JP_DEBUG,
     X    'IGLSIZE: No.lat. pts = ',KNNS)
        CALL INTLOG(JP_DEBUG,'IGLSIZE: Northern line no. =',KLN)
C
        IF( OWEGLOBE ) THEN
          CALL INTLOG(JP_DEBUG,'IGLSIZE: W-E fld is global',JPQUIET)
        ELSE
          CALL INTLOG(JP_DEBUG,'IGLSIZE: W-E fld is NOT global',JPQUIET)
        ENDIF
C
        IF( ONPOLE ) THEN
          CALL INTLOG(JP_DEBUG,'IGLSIZE: N pole is in fld.',JPQUIET)
        ELSE
          CALL INTLOG(JP_DEBUG,'IGLSIZE: N pole is NOT in fld.',JPQUIET)
        ENDIF
C
        IF( OSPOLE ) THEN
          CALL INTLOG(JP_DEBUG,'IGLSIZE: S pole is in fld.',JPQUIET)
        ELSE
          CALL INTLOG(JP_DEBUG,'IGLSIZE: S pole is NOT in fld.',JPQUIET)
        ENDIF
C
      ENDIF
C
C     _______________________________________________________
C
C     Section 9. Return to calling routine. Format statements
C     _______________________________________________________
C
  900 CONTINUE
C
      IF( KPR.GE.1 ) CALL INTLOG(JP_DEBUG,'IGLSIZE: Section 9.',JPQUIET)
C
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      INTEGER FUNCTION UNPKCF( PARRAY, KTRUNC, KSUBSET, KGRIB, KLENG,
     X                          KNSPT, KBITS)
C
C---->
C**** UNPKCF
C
C     Purpose.
C     --------
C
C     Unpacks scaled values from a GRIB product to an array of spherical
C     harmonic coefficients, the first KSUBSET triangle of coefficients
C
C**   Interface.
C     ----------
C
C     IRET = UNPKCF(PARRAY,KTRUNC,KSUBSET,KGRIB,KLENG,KNSPT,KBITS)
C
C
C     Input Parameters.
C     -----------------
C
C     KTRUNC     - Truncation of the spherical harmonic coefficients.
C     KSUBSET    - Number indicating truncation of subset.
C     KGRIB      - Array containing generated GRIB product.
C     KLENG      - Length of KGRIB
C     KNSPT      - Bit pointer for next free position in KGRIB.
C
C
C     Output Parameters.
C     ------------------
C
C     PARRAY     - Array of spherical harmonic coefficients.
C     KNSPT      - Bit pointer for next free position in KGRIB(updated).
C     KBITS      - Number of bits per computer word.
C
C     Returns 0 if OK, otherwise prints an error message and returns
C     an error code.
C
C
C     Method.
C     -------
C                           <KSUBSET>|
C
C     Given numbers:         cccccccc|cccccc
C                              cccccc|cccccc
C                                cccc|cccccc
C                                  cc|cccccc
C                                    |cccccc
C                                       cccc
C                                         cc
C
C      Converts and moves :  cccccccc
C                              cccccc
C                                cccc
C                                  cc
C
C     Externals.
C     ----------
C
C     DECFP2  - Convert to floating point value from storage format
#if (defined CRAY) || (defined __uxp__ ) || (defined IBM_POWER4)
C     GSBITE  - Extract bit pattern (Vectorized Fortran).
#endif
C     GBYTES  - Extract bit pattern
C
C
C
C     Reference.
C     ----------
C
C     None.
C
C
C     Comments.
C     ---------
C
C     KSUBSET must be less than or equal to KTRUNC.
C
C
C     Author.
C     -------
C
C     J.D.Chambers     ECMWF      13:04:94
C
C
C     Modifications.
C     --------------
C
C     None.
C
C
C----<
C     ----------------------------------------------------------------
C*    Section 0 . Definition of variables. Data statements.
C     ----------------------------------------------------------------
C
C
      IMPLICIT NONE
C
#include "common/grprs.h"
C
C     Parameters
      INTEGER JPMAXT
      PARAMETER ( JPMAXT = 2047 + 1 )
C
C     Subroutine arguments
C
      INTEGER KTRUNC, KSUBSET, KNSPT, KGRIB, KLENG, KBITS
C
      REAL PARRAY
      DIMENSION PARRAY(*), KGRIB(KLENG)
C
C     Local variables.
      INTEGER JCOL, JROW, INDEX, ILAST, ITRND, IEXP, IMANT
      INTEGER INSPT, INEXT, IWORD, IOFF
      DIMENSION IEXP(JPMAXT*2), IMANT(JPMAXT*2)
C
#if (defined CRAY) || (defined __uxp__ ) || (defined IBM_POWER4)
C
C     Values in IMASK are set in the first call to routine GSBITE, and
C     are used in subsequent calls.
C
      INTEGER IMASK
      DIMENSION IMASK(65)
      SAVE IMASK
C
C     Force routine GSBITE to calculate bit-masks first time through.
      DATA IMASK(2) /0/
#endif
C
C     ----------------------------------------------------------------
C*    Section 1 . Check for valid truncation and start values.
C     ----------------------------------------------------------------
C
  100 CONTINUE
C
C     Check for valid truncation and start values
C
      UNPKCF = 0
      IF ( KSUBSET .GT. KTRUNC ) THEN
        WRITE(GRPRSM,*) ' UNPKCF - Invalid start/truncation given'
        WRITE(GRPRSM,*) ' UNPKCF - KSUBSET, KTRUNC =', KSUBSET, KTRUNC
        UNPKCF = 16500
        GOTO 900
      ENDIF
C
C     ----------------------------------------------------------------
C*    Section 2. Convert values from IBM format exponent and mantissa.
C                Handle values 2 at a time (real and imaginary parts)
C     ----------------------------------------------------------------
C
  200 CONTINUE
C
      ITRND = 1
      ILAST = KSUBSET+1
      INDEX = -1
C
C     Extract values in pairs and convert to floating point
C
C     Loop through rows in the subset
      DO 590 JROW = 1 , ILAST
        INEXT = 2 * (ILAST - JROW + 1)
C
C     ----------------------------------------------------------------
C*    Section 3. Get exponents from bit array.
C     ----------------------------------------------------------------
C
  300   CONTINUE
C
C*      Calculate word pointer and offset.
        INSPT = KNSPT
        IWORD = INSPT / KBITS
        IOFF  = INSPT - IWORD * KBITS
        IWORD = IWORD + 1
C
#if (defined CRAY) || (defined __uxp__ ) || (defined IBM_POWER4)
        IF (INEXT.GE.8) THEN
C
C         Vectorising routine GSBITE.
          CALL GSBITE( KGRIB(IWORD), IEXP, IOFF, 8, 24, INEXT, KBITS,
     X                 IMASK, 'D')
        ELSE
C
C         Scalar faster.
          CALL GBYTES( KGRIB(IWORD), IEXP, IOFF, 8, 24, INEXT)
        ENDIF
#elif (defined CYBER)
        CALL GBYTES6( KGRIB(IWORD), IEXP, IOFF, 8, 24, INEXT)
#else
        CALL GBYTES( KGRIB(IWORD), IEXP, IOFF, 8, 24, INEXT)
#endif
C
C
C     ----------------------------------------------------------------
C*    Section 4. Get mantissae from bit array.
C     ----------------------------------------------------------------
C
  400   CONTINUE
C
C*      Calculate word pointer and offset.
        INSPT = KNSPT + 8
        IWORD = INSPT / KBITS
        IOFF  = INSPT - IWORD * KBITS
        IWORD = IWORD + 1
C
#if (defined CRAY) || (defined __uxp__ ) || (defined IBM_POWER4)
        IF (INEXT.GE.8) THEN
C
C         Vectorising routine GSBITE.
          CALL GSBITE( KGRIB(IWORD), IMANT, IOFF, 24, 8, INEXT, KBITS,
     X                 IMASK, 'D')
        ELSE
C
C         Scalar faster.
          CALL GBYTES( KGRIB(IWORD), IMANT, IOFF, 24, 8, INEXT)
        ENDIF
#elif (defined CYBER)
        CALL GBYTES6( KGRIB(IWORD), IMANT, IOFF, 24, 8, INEXT)
#else
        CALL GBYTES( KGRIB(IWORD), IMANT, IOFF, 24, 8, INEXT)
#endif
C
C     ----------------------------------------------------------------
C*    Section 5. Convert values from IBM format exponent and mantissa.
C     ----------------------------------------------------------------
C
  500 CONTINUE
C
C       Convert columns in subset
        INEXT = 0
        DO 510 JCOL = JROW , KTRUNC+1
          INDEX = INDEX + 2
          IF ( ILAST .GE. JCOL ) THEN
C
C           Real part ..
            INEXT = INEXT + 1
            CALL DECFP2 (PARRAY(INDEX),IEXP(INEXT),IMANT(INEXT))
C
C           Imaginary part ..
            INEXT = INEXT + 1
            CALL DECFP2 (PARRAY(INDEX+1),IEXP(INEXT),IMANT(INEXT))
          ENDIF
  510   CONTINUE
C
C       Update pointer.
        KNSPT = KNSPT + INEXT*32
C
  590 CONTINUE
C
C     ----------------------------------------------------------------
C*    Section 9. Return to calling routine.
C     ----------------------------------------------------------------
C
  900 CONTINUE
C
      RETURN
C
      END

C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

	subroutine bufrin(kunit,karray,kinlen,koutlen,keof,kret)
C---->
C
C	This subroutine mimics the behaviour of the original BUFRIN 
C	but makes a call to PBBUFR to retrieve BUFR products.
C
C----<
	integer icalls
	data icalls/0/
C
C First time through, print a warning message
	if (icalls .eq. 0) then
	  icalls = icalls + 1
	  write(*,*) ' *********************************************'
	  write(*,*) ' *********************************************'
	  write(*,*) ' You are using an obsolete subroutine (BUFRIN)'
	  write(*,*) ' for retrieving BUFR products.'
	  write(*,*) ' Please change to using PBBUFR.'
	  write(*,*) ' *********************************************'
	  write(*,*) ' *********************************************'
	endif
C
	call pbbufr(kunit,karray,kinlen,koutlen,kret)
	if ( kret .eq. -3) then
	  write(*,*) ' Buffer not big enough for BUFR product'
	  kret = -5
	endif
C
	return
	end

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE OFFSET2(IOFF,NLAST,IWORD,NBIT,ILEN,IERR)
C
C----> OFFSET2
C 
C     Purpose.
C     --------
C
C     Calculates the word and bit offset of the start of the next
C     bit-field in an array of binary data, following the
C     insertion/extraction of one or more consecutive bit-fields.
C
C     Interface.
C     ----------
C
C     CALL OFFSET2(IOFF,NLAST,IWORD,NBIT,ILEN,IERR)
C 
C
C     Input Parameters.
C     -----------------
C
C     IOFF  - Bit offset at which last insertion or extraction started.
C     NLAST - Number of bits in fields inserted or extracted in 
C             previous operation.
C     IWORD - Word number of array at which previous operation started.
C     NBIT  - Number of bits in computer word.
C     ILEN  - Number of words in array.
C
C     Output Parameters.
C     -----------------
C
C     IOFF  - Bit offset at which next insertion or extraction starts.
C     IWORD - Word number of array at which next operation starts.
C 
C     IERR  - = 0 if no error.
C             = -2 if next operation is outside array bounds.

C
C
C     Method.
C     -------
C
C     See below.
C
C
C     Externals.
C     ----------
C
C     None.
C
C
C     Reference.
C     ----------
C
C     None.
C
C
C     Comments.
C     ---------
C
C     Rewrite of offset.F to speed processing.
C
C
C     Author.
C     -------
C
C     J.D.Chambers      ECMWF     September 2001
C
C
C     Modifications.
C     --------------
C
C     None.
C 
C
C     ---------------------------------------------------------------
C----<
C
      IMPLICIT NONE
C
#include "common/grprs.h"
C
C     Subroutine arguments
C
      INTEGER IOFF,NLAST,IWORD,NBIT,ILEN,IERR
C
C     Clear error indicator
C
      IERR = 0
C
C     Calculate next word and bit positions.
C
      IOFF = IOFF + (NLAST-(NLAST/NBIT)*NBIT)
C
      IF( IOFF.GE.NBIT ) THEN
        IWORD = IWORD + (NLAST/NBIT) + 1
        IOFF  = IOFF  - NBIT
      ELSE
        IWORD = IWORD + (NLAST/NBIT)
      ENDIF
C
C     Check that next word to be accessed lies within the array bounds.
C
      IF( IWORD.GT.ILEN ) THEN
        IERR = -2
        WRITE(GRPRSM,*) 'Word ',IWORD,' is outside array bounds ',ILEN
      ENDIF
C
      RETURN
      END

C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE CREXETAB(KSEC1,KERR)
C
C**** *CREXETAB*
C
C
C     PURPOSE.
C     --------
C          Load Crex table B and  D  according to Edition and version
C     of Crex code.
C
C
C**   INTERFACE.
C     ----------
C
C          *CALL* *CREXETAB(KSEC1,KERR)*
C
C        OUTPUT:
C               *KSEC1*   -  Integer array of at least 40 words
C                            containing CREX section 1 information
C                            KSEC1( 1)-- Reserved
C                            KSEC1( 2)-- CREX Edition number
C                            KSEC1( 3)-- Reserved
C                            KSEC1( 4)-- Reserved
C                            KSEC1( 5)-- Reserved
C                            KSEC1( 6)-- CREX message type
C                            KSEC1( 7)-- Reserved
C                            KSEC1( 8)-- version number of local table used
C                            KSEC1( 9)-- Reserved
C                            KSEC1(10)-- Reserved
C                            KSEC1(11)-- Reserved
C                            KSEC1(12)-- Reserved
C                            KSEC1(13)-- Reserved
C                            KSEC1(14)-- CREX Master table
C                            KSEC1(15)-- version number of Master table used
C                            KSEC1(16) - KSEC1(40) -- Reserved
C
C
C                            Crex Edition 2
C
C               *KSEC1*   -  Integer array of at least 40 words
C                            containing CREX section 1 information
C                            KSEC1( 1)-- Reserved
C                            KSEC1( 2)-- CREX Edition number
C                            KSEC1( 3)-- Originating Centre ( oooo)
C                            KSEC1( 4)-- Update sequence number (uu)
C                            KSEC1( 5)-- Number of subsets (sss)
C                            KSEC1( 6)-- CREX data category (nnn)
C                            KSEC1( 7)-- International data sub-category (mmm)
C                            KSEC1( 8)-- version number of local table used
C                            KSEC1( 9)-- Year (yyyy)
C                            KSEC1(10)-- Month (mm)
C                            KSEC1(11)-- Day (dd)
C                            KSEC1(12)-- Hour (hh)
C                            KSEC1(13)-- Minute (mm)
C                            KSEC1(14)-- CREX Master table (tt)
C                            KSEC1(15)-- version number of Master table used (vv)
C                            KSEC1(16)-- Originating sub-centre (ppp)
C                            KSEC1(17)-- Bufr master table version number
C                            KSEC1(18)-- Bufr version number of local table used
C                            KSEC1(19) - KSEC1(40) -- Reserved
C
C               *KERR*    -  returned error code
C
C     METHOD.
C     -------
C
C          NONE.
C
C
C     EXTERNALS.
C     ----------
C
C          NONE.
C
C     REFERENCE.
C     ----------
C
C          NONE.
C
C     AUTHOR.
C     -------
C
C          MILAN DRAGOSAVAC    *ECMWF*       06/11/2003.
C
C
C     MODIFICATIONS.
C     --------------
C
C          NONE.
C
C
      IMPLICIT LOGICAL(L,O,G), CHARACTER*8(C,H,Y)
C
C
C
      PARAMETER(JSUP =   9,JSEC0=   3,JSEC1= 40,JSEC2= 64 ,JSEC3=    4,
     1          JSEC4=   2,JELEM=40000,JSUBS=400,JCVAL=150 ,JBUFL=40000,
     2          JBPW =  32,JTAB =3000,JCTAB=120,JCTST=1800,JCTEXT= 200,
     3          JWORK=360000,JKEY=46)
C
      PARAMETER(JP=3000,JL=20)
C
      COMMON/CRTAB/ NCREXBR(JTAB),NCREXBS(JTAB)    , NCREXBDW(JTAB),
     1              NCREXDR(JTAB),NCREXDST(JTAB)   ,
     2              NCREXDL(JTAB),NCREXDSQ(JTAB*20),NCREXP(64,255)

C
C             NCREXBR     - table B,  table reference              array
C             NCREXBS     - table B,  scale                        array
C             NCREXBDW    - table B,  data width                   array
C             NCREXDR    - table D,  table reference              array
C             NCREXDST    - table D,  starting pointers            array
C             NCREXDL     - table D,  lengths                      array
C             NCREXDSQ    - table D,  list of sequence descriptors array
C
       COMMON /CRTABC/ CREXNAME(JTAB),CREXUNIT(JTAB)
C
C             CREXNAME      -  table B, ELEMENT NAME           array
C             CREXUNIT      -  table B, unit                   array
C
C
      COMMON /CRROOT/ CROOT
C
C            croot    -  path for Crex tables
C
      CHARACTER*64 CREXNAME
      CHARACTER*24 CREXUNIT
      CHARACTER*6  CREXLST
C
      CHARACTER*256 YNAME
      CHARACTER*256  YFNAME
      CHARACTER*160 YENTRY
C
      CHARACTER*256 YTAB ,YTAC ,YTAD
      CHARACTER*7  YTABB,YTABC,YTABD
      CHARACTER*256 CROOT
      CHARACTER*6 CNCREXBR
C
      DIMENSION KSEC1(*)
C
C     EXTERNAL FUNCTIONS
C
      INTEGER EMOSNUM
      EXTERNAL EMOSNUM

      SAVE OFIRST, NXXP, NYYP, NZZP
C
C     ------------------------------------------------------------------
C
C*          1.   GET CREX TABLES/LOCAL CREX TABLES.
C                ----------------------------------
 100  CONTINUE
C
      IF( KERR.NE.0) RETURN
C
C
C*          2.   SET UP CREX TABLE FILE NAME.
C                ----------------------------
 200  CONTINUE
C
C
C             CREX EDITION 1 NAMING CONVENTION
C
C             BXXYYZZ , DXXYYZZ
C
C             B      - CREX TABLE 'B'
C             D      - CREX TABLE 'D'
C             XX     - Crex Master table used '00'
C             YY     - Crex Edition number used '01'
C             ZZ     - Crex Table version number '01'
C
            IXX=0
            IYY=KSEC1( 2)
            IZZ=KSEC1(15)
C
         IF(OFIRST) THEN
            IF(IXX.EQ.NXXP.AND.IYY.EQ.NYYP.AND.
     1         IZZ.EQ.NZZP) RETURN
         END IF
C
      J=0
      ICLASS0=0
      IVIND=2147483647
C
      DO 101 I=1,64
      do 101 ii=1,255
      NCREXP(I,ii)=0
 101  CONTINUE
C
      DO 102 i=1,JP
      NCREXBR(I)=IVIND
      NCREXBS (I)=IVIND
      NCREXBDW(I)=IVIND
      CREXNAME(I)=' '
      CREXUNIT(I)=' '
 102  CONTINUE
C
      J  =0
      IST=1
C
      DO 103 I=1,JP
      NCREXDR(I)=999999
      NCREXDL (I)=0
      NCREXDST(I)=0
 103  CONTINUE
C
      DO 104 I=1,JP*20
      NCREXDSQ(I)=0
 104  CONTINUE

      OFIRST=.TRUE.
C
      NXXP=IXX
      NYYP=IYY
      NZZP=IZZ
C
      WRITE(YTABB,'(A1,I2.2,I2.2,I2.2)') 'B',IXX,IYY,IZZ
C     WRITE(YTABC,'(A1,I2.2,I2.2,I2.2)') 'C',IXX,IYY,IZZ
      WRITE(YTABD,'(A1,I2.2,I2.2,I2.2)') 'D',IXX,IYY,IZZ
C
      PRINT*,'CREX Tables to be loaded ',YTABB,',',YTABD
C
C     ----------------------------------------------------------------
C*          3. OPEN AND READ FILES CONTAINING CREX TABLES.
C              -------------------------------------------
 300  CONTINUE
C
      CROOT=' '
      CALL GETENV('CREX_TABLES',CROOT)
      ILNG=INDEX(CROOT,' ')
      IF(ILNG.EQ.1) THEN
C
C       SGI/HP/SUN CREX TABLES PATH
C
        CROOT='/home/ma/emos/tables/crex/'
C
C       ADD VERSION NUMBER
C
        ILNG=INDEX(CROOT,' ')
        IEMOSNM = EMOSNUM(1)
        WRITE(CROOT(ILNG:ILNG+5),'(I6.6)') IEMOSNM
        CROOT(ILNG+6:) = '/'
      ENDIF

      I=INDEX(CROOT,' ')
      IF(I.NE.0) I=I-1
      PRINT*,'Path for CREX tables:',CROOT(1:I)
C
C*          3.1 READ CREX TABLE B.
C               ------------------
 310  CONTINUE
C
      YTAB=CROOT(1:I)//YTABB
      II=I+7
C
      OPEN(UNIT=38,IOSTAT=IOS,ERR=311,FILE=YTAB(1:II),
     1     FORM='FORMATTED',
     2     recl=160,
     5     STATUS='OLD')
C
      J=0
      GO TO 312
C
 311  CONTINUE
C
      CLOSE(38)
C
      print*,'Open error on ',YTAB(1:II)
C
      KERR=9    
      CALL CREXERR(KERR)
      RETURN

C
 312  CONTINUE
C
      J=J+1
      READ(38,ERR=400,IOSTAT=IOS,END=329,
     1  FMT='(1x,A,1x,A64,47x,A24,I3,7x,I3)')
     2  CNCREXBR,CREXNAME(J),CREXUNIT(J),NCREXBS(J),NCREXBDW(J)
C
      CNCREXBR(1:1)='0'
C
      READ(CNCREXBR,'(I6.6)',IOSTAT=IOS) NCREXBR(J)
      IF(IOS.NE.0) THEN
         print*,'Internal read error.'
         print*,CNCREXBR
         KERR=35
         RETURN
      end if
C
C
      ICLASS=NCREXBR(J)/1000
      IYYY  =NCREXBR(J)-ICLASS*1000+1
C
      ICLASS=ICLASS+1
      NCREXP(ICLASS,IYYY)=J

      GO TO 312
C
 329  CONTINUE
C
      CLOSE(UNIT=38,IOSTAT=IOS,ERR=420)
C
C*          3.3 READ CREX TABLE D.
CC               ------------------
 330  CONTINUE
C
      YTAD=CROOT(1:I)//YTABD
C
      OPEN(UNIT=40,IOSTAT=IOS,ERR=331,FILE=YTAD(1:II),
     1     FORM='FORMATTED',
     2     recl=160,
     5     STATUS='OLD')
C
      GO TO 332
C
 331  CONTINUE
C
      CLOSE(40)
C
      print*,'Open error on ',YTAD
C
      kerr=9
      CALL CREXERR(KERR)
      return
C
 332  CONTINUE
C
      j=0
 340  continue
c
      YENTRY=' '
      READ(40,'(a)',iostat=ios,end=390) yentry
      if(ios.ne.0) then
         print*,'Read error on CREX table D.'
         KERR=35
         RETURN
      end if
      if(yentry(2:2).eq.'D') yentry(2:2)='3'
c
      j=j+1
      READ(YENTRY,'(1X,I6,1X,I2)',iostat=ios) NCREXDR(J),NCREXDL(J)
      if(ios.ne.0) then
         print*,'Internal read error.'
         print*,YENTRY
         KERR=35
         RETURN
      end if
      IF(J.GT.JP) THEN
         PRINT*,' DIMENSION TOO SMALL J=',J
         kerr=13
         CALL CREXERR(KERR)
         RETURN
      END IF
C
      IF(J.EQ.1) THEN
         IST=1
         NCREXDST(J)=IST
      ELSE
         IST=IST + NCREXDL(J-1)
         NCREXDST(J)=IST
      END IF
C
      IF(NCREXDL(J).GT.1) THEN
         if(YENTRY(12:12).eq.'D') YENTRY(12:12)='3'
         if(YENTRY(12:12).eq.'C') then
            YENTRY(12:12)='2'
c           checkif negative scale is present
            iminus=0
            iminus=index(YENTRY(12:16),'-')
            if(iminus.ne.0) YENTRY(iminus:iminus)='9'
         end if
         if(YENTRY(12:12).eq.'R') YENTRY(12:12)='1'
         if(YENTRY(12:12).eq.'B') YENTRY(12:12)='0'
         READ(YENTRY,'(11X,I6)',iostat=ios) NCREXDSQ(IST)
         if(ios.ne.0) then
            print*,YENTRY
            KERR=35
            CALL CREXERR(KERR)
            RETURN
         end if
c
         IIST=IST
C
         DO 220 JA=1,NCREXDL(J)-1
         IIST=IIST+1
         READ(40,'(A)',END=300,iostat=ios) YENTRY
         if(ios.ne.0) then
            print*,YENTRY
            KERR=35
            CALL CREXERR(KERR)
            RETURN
         end if
c
         if(YENTRY(12:12).eq.'D') YENTRY(12:12)='3'
         if(YENTRY(12:12).eq.'C') YENTRY(12:12)='2'
         if(YENTRY(12:12).eq.'R') YENTRY(12:12)='1'
         if(YENTRY(12:12).eq.'B') YENTRY(12:12)='0'
         READ(YENTRY,'(11X,I6)',iostat=ios) NCREXDSQ(IIST)
         if(ios.ne.0) then
            print*,YENTRY
            KERR=35
            CALL CREXERR(KERR)
            RETURN
         end if
 220     CONTINUE
C
      ELSE
         if(YENTRY(12:12).eq.'D') YENTRY(12:12)='3'
         if(YENTRY(12:12).eq.'C') YENTRY(12:12)='2'
         if(YENTRY(12:12).eq.'R') YENTRY(12:12)='1'
         if(YENTRY(12:12).eq.'B') YENTRY(12:12)='0'
         READ(YENTRY,'(11X,I6)',iostat=ios) NCREXDSQ(IST)
         if(ios.ne.0) then
            print*,'Internal read error.'
            print*,YENTRY
            KERR=35
            RETURN
         end if
      END IF
C
      go to 340
c
 390  continue
C
      CLOSE(UNIT=40,IOSTAT=IOS,ERR=620)
C
C
      RETURN
C     ----------------------------------------------------------------
 400  CONTINUE
C
      KERR=6
      PRINT*,'CREXETAB: IOS ',IOS
      CALL CREXERR(KERR)
      OFIRST=.FALSE.
      RETURN
C
 410  CONTINUE
C
      KERR=9
      PRINT*,'CREXETAB: IOS ',IOS
      CALL CREXERR(KERR)
      OFIRST=.FALSE.
      RETURN
C
 420  CONTINUE
C
      KERR=10
      PRINT*,'CREXETAB: IOS ',IOS
      CALL CREXERR(KERR)
      OFIRST=.FALSE.
      RETURN
C     ----------------------------------------------------------------
 500  CONTINUE
C
      KERR=7
      PRINT*,'CREXETAB: IOS ',IOS
      CALL CREXERR(KERR)
      OFIRST=.FALSE.
      RETURN
C
 510  CONTINUE
C
      KERR=9
      PRINT*,'CREXETAB: IOS ',IOS
      CALL CREXERR(KERR)
      OFIRST=.FALSE.
      RETURN
C
 520  CONTINUE
C
      KERR=11
      PRINT*,'CREXETAB: IOS ',IOS
      CALL CREXERR(KERR)
      OFIRST=.FALSE.
      RETURN
C     -----------------------------------------------------------------
 600  CONTINUE
C
      KERR=8
      PRINT*,'CREXETAB: IOS ',IOS
      CALL CREXERR(KERR)
      OFIRST=.FALSE.
      RETURN
C
 610  CONTINUE
C
      KERR=9
      PRINT*,'CREXETAB: IOS ',IOS
      CALL CREXERR(KERR)
      OFIRST=.FALSE.
      RETURN
C
 620  CONTINUE
C
      KERR=12
      PRINT*,'CREXETAB: IOS ',IOS
      CALL CREXERR(KERR)
      OFIRST=.FALSE.
      RETURN
C     -----------------------------------------------------------------
C
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities
C granted to it by virtue of its status as an intergovernmental organisation
C nor does it submit to any jurisdiction.
C

      INTEGER FUNCTION INTWAVU(INFLD,INLEN,OUTFLD,OUTLEN)
C
C---->
C**** INTWAVU
C
C     Purpose
C     -------
C
C     Interpolate an ECMWF wave field wave field or a reduced
C     latitude-longitude field
C
C
C     Interface
C     ---------
C
C     IRET = INTWAVU(INFLD,INLEN,OUTFLD,OUTLEN)
C
C     Input
C     -----
C
C     INFLD  - Input field (packed).
C     INLEN  - Input field length (words).
C
C
C     Output
C     ------
C
C     OUTFLD  - Output field (packed).
C     OUTLEN  - Output field length (words).
C
C
C     Method
C     ------
C
C     Call interpolation routine; then repack into GRIB format.
C
C
C     Externals
C     ---------
C
C     FIXAREA - Fixup area definition to correspond to grid definitions
C     JMEMHAN - Handles memory allocation.
C     JDEBUG  - Checks environment to switch on/off debug
C     INTLOG  - Log error message.
C     WAVEXX2 - Interpolate wave fields (except 2D spectra)
C     WV2DXX2 - Interpolate wave 2D spectra fields
C     MKFRAME - Create a 'frame' from a rectangular field
C     MKBITMP - Apply a bitmap to a rectangular field
C
C
C     Author
C     ------
C
C     S.Curic     ECMWF     Mar 2009
C
C
C----<
C
      IMPLICIT NONE
C
C     Function arguments
      INTEGER INLEN,OUTLEN
      REAL INFLD(*), OUTFLD(*)
C
#include "parim.h"
#include "nifld.common"
#include "nofld.common"
#include "intf.h"
#include "grfixed.h"
#include "jparams.h"
C
C     Parameters
      INTEGER JPROUTINE, JP2DSP, JP2DSPQ, JPMAXLT

      PARAMETER (JPROUTINE = 40200 )
      PARAMETER (JP2DSP  = 250 )  ! for 2D wave spectra (whole)
      PARAMETER (JP2DSPQ = 251 )  ! for 2D wave spectra (single)
      PARAMETER (JPMAXLT = 1801 )
C
C     Local variables
C
      REAL ZMISS
cs      DATA ZMISS/-9999999.0/
      REAL RLATINC, ONORTH, OSOUTH
      INTEGER IRET, NSPEC, LOOP, IERR
      INTEGER KNUM, NUM_E_W, NUM_N_S, NFULLNS, NFULLEW
      REAL GRIDWE, GRIDNS, NORTH, SOUTH, WEST, EAST
      REAL INORTH, ISOUTH, IWEST, IEAST, RNS
      INTEGER NUMPTS,MISSLAT,KOLDNUM
      DIMENSION NUMPTS(JPMAXLT)
      INTEGER KNEWNUM
      LOGICAL LCOEFFS, LFRAME, LBITMP
      LOGICAL LDEBUG
C
C     Externals
      INTEGER WAVEXX2, WV2DXX2, AREACHK, FIXAREA
      INTEGER NUMPTNS, NUMPTWE, JNORSGG, MKBITMP
C
C ------------------------------------------------------------------
C     Section 1.   Initialise
C ------------------------------------------------------------------
C
  100 CONTINUE
C
      INTWAVU = 0
C
      LCOEFFS = .FALSE.
      ZMISS = RMISSGV
      ZSEC3(2) = RMISSGV
      ISEC3(2) = INT(RMISSGV)
      ISEC1(5) = 192

C
C     Check if debug option turned on
      CALL JDEBUG()
      LDEBUG = NDBG.GT.0
C
C
      OUTLEN = 0
      IRET = 1
C
C     Check that the field can be handled
C
C ------------------------------------------------------------------
C     Section 2.   Sort out interpolation area.
C ------------------------------------------------------------------
C
  200 CONTINUE
C
      NSPEC = 1
      INORTH = FLOAT(NIAREA(1))/PPMULT
      IWEST  = FLOAT(NIAREA(2))/PPMULT
      ISOUTH = FLOAT(NIAREA(3))/PPMULT
      IEAST  = FLOAT(NIAREA(4))/PPMULT
      KNUM  = NINS
      RNS = INORTH - ISOUTH
C
C     Adjust (sub-)area limits to suit the grid
C
      IRET = FIXAREA()
      IF ( IRET .NE. 0 ) THEN
        CALL INTLOG(JP_ERROR, 'INTWAVU: FIXAREA failed.',JPQUIET)
        INTWAVU = JPROUTINE + 5
        GOTO 900
      ENDIF
      NORTH = FLOAT(NOAREA(1))/PPMULT
      WEST  = FLOAT(NOAREA(2))/PPMULT
      SOUTH = FLOAT(NOAREA(3))/PPMULT
      EAST  = FLOAT(NOAREA(4))/PPMULT
C
C     Calculate the number of points E-W and N-S in new grid area
C
      IF( (NOREPR.EQ.JPQUASI) .OR. (NOREPR.EQ.JPGAUSSIAN)) THEN
        GRIDWE  = NOGAUSS
        GRIDNS  = 0
      ELSE IF( NOREPR.EQ.JPREDLL ) THEN
        GRIDWE  = 360.0/NOLPTS((NOREDLL/2)+1)
        GRIDNS  = FLOAT(NOGRID(2))/PPMULT
      ELSE
        GRIDWE  = FLOAT(NOGRID(1))/PPMULT
        GRIDNS  = FLOAT(NOGRID(2))/PPMULT
      ENDIF
C
      IRET = AREACHK(GRIDWE,GRIDNS,NORTH,WEST,SOUTH,EAST)
      IF( IRET.NE.0 ) THEN
        INTWAVU = JPROUTINE + 6
        GOTO 900
      ENDIF
      NOAREA(1) = NINT(NORTH*PPMULT)
      NOAREA(2) = NINT(WEST*PPMULT)
      NOAREA(3) = NINT(SOUTH*PPMULT)
      NOAREA(4) = NINT(EAST*PPMULT)
C
      IF( (NOREPR.EQ.JPQUASI) .OR. (NOREPR.EQ.JPGAUSSIAN)) THEN
        GRIDWE  = 360.0/NOLPTS(NOGAUSS)
        NUM_E_W = NUMPTWE(WEST,EAST,GRIDWE)
        NFULLEW = NUMPTWE(0.0,360.0,GRIDWE) - 1
        NUM_N_S = JNORSGG(SOUTH,ROGAUSS,NOGAUSS,1) -
     X            JNORSGG(NORTH,ROGAUSS,NOGAUSS,0) + 1
        NFULLNS = NOGAUSS*2
C
        NONS    = NFULLNS
        IF(NOREPR.EQ.JPQUASI) THEN
          KNEWNUM = NOGAUSS*2
          DO LOOP = 1, KNEWNUM
            OUTLEN  = OUTLEN + NOLPTS(LOOP)
          ENDDO
          NOWE = 0
        ELSE
          NOWE    = NUM_E_W
          OUTLEN  = NOWE*NONS
        ENDIF
      ELSE IF( NOREPR.EQ.JPREDLL ) THEN
        NUM_E_W = NUMPTWE(WEST,EAST,GRIDWE)
        NFULLEW = NUMPTWE(0.0,360.0,GRIDWE) - 1
        NUM_N_S = NUMPTNS(NORTH,SOUTH,GRIDNS)
        NFULLNS = NOREDLL
        CALL INTLOG(JP_ERROR,'INTWAVU: Reduced ll not posible',JPQUIET)
        GOTO 900
      ELSE
        NUM_E_W = NUMPTWE(WEST,EAST,GRIDWE)
        NFULLEW = NUMPTWE(0.0,360.0,GRIDWE) - 1
        NUM_N_S = NUMPTNS(NORTH,SOUTH,GRIDNS)
        NFULLNS = NUM_N_S
cs calculate outlen for regular lat-lon
        OUTLEN  = NUM_E_W*NUM_N_S
        NOWE    = NUM_E_W
        NONS    = NUM_N_S
      ENDIF
C
C
C ------------------------------------------------------------------
C     Section 3.   Interpolate wave fields other than 2D spectra.
C ------------------------------------------------------------------
C
  300 CONTINUE
C
C     Handle if not 2D spectra ..
C
      IF( (NIPARAM.NE.JP2DSP).AND.(NIPARAM.NE.JP2DSPQ) ) THEN
       IF( LDEBUG ) THEN
       CALL INTLOG(JP_DEBUG,
     X 'INTWAVU: Interpolate wave fields other than 2D spectra',JPQUIET)
       ENDIF
C--------------------------------------------------------------------
        KNUM = NINS
      IF(NIREPR.EQ.JPREDLL) THEN
C
C       Input field is a reduced latitude/longitude grid
C
C       .. but it may be 'pseudo-gaussian' in layout
C       (ie global, symmetric about the equator but no latitude
C        at the equator)
          MISSLAT = 0
        ONORTH = FLOAT(NIAREA(1))/PPMULT
        OSOUTH = FLOAT(NIAREA(3))/PPMULT

        RLATINC = FLOAT(NIGRID(2))/PPMULT


        IF( ( NIAREA(1).NE.90000).AND.(MOD(KNUM,2).EQ.0) )  THEN
C
          DO LOOP = 1, KNUM
            NUMPTS(LOOP) = MILLEN(LOOP)
          ENDDO
C
        ELSE
C
cs          MISSLAT = (90000 - NIAREA(1))/NIGRID(2)
          MISSLAT = (90.0 - ONORTH)/RLATINC
          DO LOOP = 1, MISSLAT
            NUMPTS(LOOP)    = 0
          ENDDO
cs          KOLDNUM = 1 + (90000 - NIAREA(3))/NIGRID(2)
          KOLDNUM = 1 + NINT((90.0 - OSOUTH)/RLATINC)
          DO LOOP = 1, (KOLDNUM-MISSLAT)
            NUMPTS(LOOP+MISSLAT) = MILLEN(LOOP)
          ENDDO
          DO LOOP = (KOLDNUM+1), KNUM
            NUMPTS(LOOP)    = 0
          ENDDO
        ENDIF
      ENDIF
C--------------------------------------------------------------------

C
C       Interpolate the field
C
        IRET = WAVEXX2(NIPARAM,KNUM,NUMPTS,NUM_N_S,GRIDNS,GRIDWE,INFLD,
     X               OUTFLD,NORTH,WEST,ZMISS)
        IF( IRET.NE.0 ) THEN
          CALL INTLOG(JP_ERROR,'INTWAVU: Interpolation failed.',JPQUIET)
          INTWAVU = JPROUTINE + 10
          GOTO 900
        ENDIF
C
C ------------------------------------------------------------------
C     Section 4.   Interpolate wave 2D spectra field.
C ------------------------------------------------------------------
C
      ELSE
C
  400   CONTINUE

      IF( LDEBUG ) THEN
      CALL INTLOG(JP_DEBUG,
     X 'INTWAVU: Interpolate wave 2D spectra field',JPQUIET)
      ENDIF
C
        IRET = WV2DXX2(NIMATR,KNUM,MILLEN,NUM_N_S,GRIDNS,GRIDWE,INFLD,
     X               OUTFLD,NORTH,WEST,ZMISS)
        IF( IRET.NE.0 ) THEN
          CALL INTLOG(JP_ERROR,'INTWAVU: Interpolation failed.',JPQUIET)
          INTWAVU = JPROUTINE + 13
          GOTO 900
        ENDIF
C
      ENDIF
C
C ------------------------------------------------------------------
C     Section 5.   Frame and Bitmap
C ------------------------------------------------------------------
C
  500   CONTINUE

C     If a 'bitmap' has been specified, build the bitmap
C
      LBITMP = LNOBITMP.AND.
     X         ((NOREPR.EQ.JPREGROT).OR.(NOREPR.EQ.JPREGULAR).OR.
     X          (NOREPR.EQ.JPGAUSSIAN))

      IF( LBITMP ) THEN
        CALL INTLOG(JP_DEBUG,'INTWAVU: MKBITMP is enabled',JPQUIET)
        IERR = MKBITMP(NUM_E_W,NUM_N_S,OUTFLD,ZMISS)
        IF( IERR.NE.0 ) THEN
        CALL INTLOG(JP_ERROR,'INTWAVU: Problem applying bitmap',JPQUIET)
          GOTO 900
        ENDIF
      ENDIF
C     If a 'frame' has been specified, build the frame
C
       LFRAME = LNOFRAME.AND.
     X         ((NOREPR.EQ.JPREGULAR).OR.(NOREPR.EQ.JPGAUSSIAN).OR.
     X          (NOREPR.EQ.JPREGROT ).OR.(NOREPR.EQ.JPFGGROT  ) )

         CALL INTLOG(JP_DEBUG,'INTWAVU: NUM_E_W ',NUM_E_W)
         CALL INTLOG(JP_DEBUG,'INTWAVU: NUM_N_S ',NUM_N_S)
      IF( LFRAME ) THEN
           CALL INTLOG(JP_DEBUG,'INTWAVU: MKFRAME is enabled',JPQUIET)
           CALL INTLOG(JP_DEBUG,'INTWAVU: NOFRAME ',NOFRAME)
         CALL MKFRAME(NUM_E_W,NUM_N_S,OUTFLD,ZMISS,NOFRAME)
      ENDIF
C
C
C ------------------------------------------------------------------
C*    Section 9.   Closedown.
C ------------------------------------------------------------------
C
  900 CONTINUE
C
C     Clear change flags for next product processing
C
      LCHANGE = .FALSE.
      LSMCHNG = .FALSE.
C
      RETURN
      END

      PROGRAM GRIB2BUFR
!
!**** *GRIB2BUFR*
!
!
!     PURPOSE.
!     --------
!         Convert NCEP GRIB snow cover into BUFR
!         inserting grid point height and position
!
!
!**   INTERFACE.
!     ----------
!
!          NONE.
!
!     METHOD.
!     -------
!
!          NONE.
!
!
!     EXTERNALS.
!     ----------
!
!
!     REFERENCE.
!     ----------
!
!          NONE.
!
!     AUTHOR.
!     -------
!
!          M. DRAGOSAVAC    *ECMWF*       JAN 2004
!
!
!     MODIFICATIONS.
!     --------------
!
!          NONE.
!
!
      IMPLICIT LOGICAL(L,O,G), CHARACTER*8(C,H,Y)
!
      integer, parameter :: is0=2
      integer, parameter :: is1=512
      integer, parameter :: is2=512
      integer, parameter :: ip2=128
      integer, parameter :: is3=2
      integer, parameter :: ip3=2
      integer, parameter :: is4=512
      integer, parameter :: ip4=1200000
      integer, parameter :: ileng=1200000
!
      character(len=1) hoper
!
      integer, dimension(is0) :: isec0
      integer, dimension(is1) :: isec1
      integer, dimension(is2) :: isec2
      real   , dimension(ip2) :: psec2
      integer, dimension(is3) :: isec3
      real   , dimension(ip3) :: psec3
      integer, dimension(is4) :: isec4
      real   , dimension(ip4) :: psec4
      integer, dimension(ileng):: igrib
      real   , dimension(ip4) :: fpdata
!
      character(len=256) carg(4)
      character(len=256) input_file
      character(len=256) out_file
!
      REAL               :: LSM(1024,1024), GPH(1024,1024)
      REAL               :: FDATA(1024,1024)
      INTEGER            :: ILON(1024,1024)
      INTEGER            :: ILAT(1024,1024)

!      external getarg
!                                                                       
!     ------------------------------------------------------------------
!*          1. INITIALIZE CONSTANTS AND VARIABLES.
!              -----------------------------------
 100  CONTINUE
!
!     Missing value indicator
! 
      jbyte=ileng*4
      nbytpw=jbpw/8
      RVIND=1.7E38
      nvind=2147483647
      eps=10.E-10
      n=0
      input_file=' '
      out_file=' '
!
!     Input file name
!
!     Get input and output file name.
!
      narg=IARGC()
!
      IF(narg /=4) THEN
         print*,'Usage -- grib2bufr -i infile -o outfile ' 
         stop
      END IF
!
      do j=1,narg
       call getarg(j,carg(j))
      end do
!
      do j=1,narg
      if(carg(j) == '-i') then
         input_file=carg(j+1)
      elseif(carg(j) == '-o') then
         out_file=carg(j+1)
      end if
      end do
!
!
!*          1.2 Open input and output files
!               ---------------------------
 120  CONTINUE
!
      IRET=0 
      CALL PBOPEN(IUNIT,trim(INPUT_FILE),'r',IRET)
      IF(IRET.EQ.-1) STOP 'open failed'
      IF(IRET.EQ.-2) STOP 'Invalid file name'
      IF(IRET.EQ.-3) STOP 'Invalid open mode specified'
!
      IRET=0
      CALL PBOPEN(IUNIT1,trim(OUT_FILE),'w',IRET)
      IF(IRET.EQ.-1) STOP 'open failed'
      IF(IRET.EQ.-2) STOP 'Invalid file name'
      IF(IRET.EQ.-3) STOP 'Invalid open mode specified'

!     ----------------------------------------------------------------- 
!*          2. SET REQUEST FOR EXPANSION.
!              --------------------------
 200  CONTINUE
!
!
!*          2.1 SET REQUEST FOR PARTIAL EXPANSION.
!               ----------------------------------
 210  CONTINUE
!
      
!
!     -----------------------------------------------------------------
!*          3.  READ GRIB MESSAGE.
!               ------------------
 300  CONTINUE
!
      IERR=0
      KBUFL=0
!
      IRET=0
      CALL PBGRIB(IUNIT,igrib,JBYTE,KBUFL,IRET) 
      IF(IRET.EQ.-1) THEN
         print*,'Number of subsets     ',iobs
         print*,'Number of messages    ',n
         STOP 'EOF'
      END IF
      IF(IRET.EQ.-2) STOP 'File handling problem' 
      IF(IRET.EQ.-3) STOP 'Array too small for product'
!
      N=N+1
      print*,'----------------------------------',n
!
!     -----------------------------------------------------------------
!*          4. EXPAND GRIB MESSAGE.
!              --------------------
 400  CONTINUE
!
      hoper='D'
!      hoper='B'     ! images
      i=1
      call grsdbg(i)
      psec3(2)=1.7E38
      call gribex(isec0,isec1,isec2,psec2,isec3,psec3,isec4,psec4, &
&                  ip4,igrib,ileng,iword,hoper,iret)
!
!     The snow cover is needed only ( NCEP parameter 238)
!
      if(isec1(6) /= 238) go to 300
!
      DO II = 1,1024
       IL = (II-1) * 1024 + 1
       IH = (II) * 1024
       FDATA(1:1024,II) = PSEC4(IL:IH)
      ENDDO

!
!
!           4.1  Read Coordinates
!                ----------------
      CALL READ_COORD(ILON,ILAT)
!
!           4.2 Read Land/Sea Mask on polarstereographic projection
!               based on ECMWF 2'30'' DM data
!
      CALL READ_LSM(LSM)
!
!           4.3 Read topography data on polarstereographic projection
!               based on ECMWF 2'30'' DM data
!
      CALL READ_GPH(GPH)
!
!           4.4 Screen and thin data
!               --------------------

!           5.  Pack into BUFR
!               --------------

      CALL BUFR_ENCODE(IUNIT1,ISEC1,ISEC2,FDATA,ILON,ILAT,LSM,GPH,IERR)
      
      GO TO 300
!     -----------------------------------------------------------------
!
 900  CONTINUE
!
      CALL PBCLOSE(IUNIT,IRET)
      CALL PBCLOSE(IUNIT1,IRET)
!
      END
      SUBROUTINE BUFR_ENCODE(KUNIT,IGSEC1,IGSEC2,GPSEC4,KLON,KLAT,LSM,GPH,IERR)
!
!**** *BUFR_ENCODE*
!
!
!     PURPOSE.
!     --------
!         Pack bufr message
!
!
!**   INTERFACE.
!     ----------
!
!          NONE.
!
!     METHOD.
!     -------
!
!          NONE.
!
!
!     EXTERNALS.
!     ----------
!
!         CALL BUSEL
!         CALL BUFREX
!         CALL BUFREN
!         CALL BUPRS0
!         CALL BUPRS1
!         CALL BUPRS2
!         CALL BUPRS3
!         CALL BUPRT
!         CALL BUUKEY
!
!     REFERENCE.
!     ----------
!
!          NONE.
!
!     AUTHOR.
!     -------
!
!          M. DRAGOSAVAC    *ECMWF*       15/06/93.
!
!
!     MODIFICATIONS.
!     --------------
!
!          NONE.
!
!
      IMPLICIT LOGICAL(O), CHARACTER*8(C,H,Y)
!
      integer, parameter :: JSUP =   9
      integer, parameter :: JSEC0=3
      integer, parameter :: JSEC1=40
      integer, parameter :: JSEC2=4096
      integer, parameter :: JSEC3=4
      integer, parameter :: JSEC4=2
      integer, parameter :: JBUFL=100000
      
      integer, parameter :: KDLEN=100
      integer, parameter :: KELEM=9
      integer, parameter :: kdleng=100
      integer, parameter :: KVALS=360000
!
      integer, dimension(JBUFL) :: KBUFR
      integer, dimension(JSUP)  :: KSUP
      integer, dimension(JSEC0) :: KSEC0
      integer, dimension(JSEC1) :: KSEC1
      integer, dimension(JSEC2) :: KSEC2
      integer, dimension(JSEC3) :: KSEC3
      integer, dimension(JSEC4) :: KSEC4
!

      real*8, dimension(KVALS) :: VALUES
!
      integer, dimension(KELEM) :: KTDLST
      integer, dimension(KELEM) :: KTDEXP
      integer, dimension(KDLEN) :: KDATA
!
      integer, dimension(*) :: igsec1,igsec2
      integer, dimension(1024,1024) :: klon,klat
      real   , dimension(1024,1024) :: gph, gpsec4, lsm
!
      character(len=64) :: CNAMES(KELEM)
      character(len=24) :: CUNITS(KELEM)
      character(len=80) :: CVALS(10),YENC

      integer :: year, month, day, hour, minute
!
      real*8, parameter :: RVIND=1.7E38
!     ------------------------------------------------------------------
!*          1. INITIALIZE CONSTANTS AND VARIABLES.
!              -----------------------------------
 100  CONTINUE
!
!
!     INITIALIZE DELAYED REPLICATION FACTORS OR REFERENCE VALUES ETD.
!
      kdata=0
!
      kdata(1)=0
!
!
!     SET DATA DECSRIPTORS
!
      ktdlst(1)=004001         ! year
      ktdlst(2)=004002         ! month
      ktdlst(3)=004003         ! day
      ktdlst(4)=004004         ! hour
      ktdlst(5)=004005         ! minute
      ktdlst(6)=005001         ! latitude
      ktdlst(7)=006001         ! longitude
      ktdlst(8)=007007         ! height
      ktdlst(9)=020065         ! snow cover
!
      KTDLEN=9
!
!     SET VALUES TO BE PACKED
!
      year=igsec1(10)
      month=igsec1(11)
      day=igsec1(12)
      hour=igsec1(13)
      minute=igsec1(14)
!
      do i=1,1024
         isubs=0
      do j=1,1024
       if(lsm(i,j) > 0.5) then
          isubs=isubs+1
          ivv=(isubs-1)*kelem
          if(year < 30 ) then
             values(1+ivv)=year+2000
          else
             values(1+ivv)=year+1900
          end if
          values(2+ivv)=month
          values(3+ivv)=day
          values(4+ivv)=hour
          values(5+ivv)=minute
          values(6+ivv)=klat(i,j)/100.
          values(7+ivv)=klon(i,j)/100.
          values(8+ivv)=gph(i,j)
          values(9+ivv)=gpsec4(i,j)
       end if
      end do

      print*,'Number of subsets=',isubs
      if(isubs == 0 ) cycle
!
!     set ccittia5 call sign 
!
      cvals(1)=' '
!
!     SECTION 0 CONTENT
!
      KSEC0(1)=0      ! TOTAL LENGTH OF SECTION 0
      KSEC0(2)=0      ! TOTAL LENGTH OF BUFR MESSAGE
      KSEC0(3)=3      ! BUFR EDITION NUMBER
!
!     SECTION 1 CONTENT
!
      KSEC1(1)=18    ! TOTTAL LENGTH OF SECTION 1
      KSEC1(2)=3     ! BUFR EDITION NUMBER
      KSEC1(3)=98    ! ORIGINATING CENTRE
      KSEC1(4)=1     ! UPDATE SEQUENCE NUMBER
      KSEC1(5)=0  !128   ! FLAG (PRESENCE OF SECTION 2)
      KSEC1(6)=12     ! BUFR MESSAGE TYPE
      KSEC1(7)=165     ! BUFR_MESSAGE SUBTYPE
      KSEC1(8)=1     ! VERSION NUMBER OF LOCAL TABLE USED
      KSEC1(9)=year
      KSEC1(10)=month
      KSEC1(11)=day
      KSEC1(12)=hour
      KSEC1(13)=minute
      KSEC1(14)=0    ! BUFR MASTER TABLE( ZERO) FOR METEOROLOGICAL DATA)
      KSEC1(15)=11    ! VERSION NUMBER OF MASTER TABLE USED
      KSEC1(16)=0    ! ORIGINATING SUB-CENTRE
      KSEC1(17)=0    ! 
      KSEC1(18)=0    ! Local ADP centre information
!
!     SECTION 2 CONTENT
!
      KSEC2(1)=52
!
      KSEC2=0
!
!     SECTION 3 CONTENT
!
      KSEC3(1)=0     ! TOTAL LENGTH OF SECTION 3
      KSEC3(2)=0     ! RESERVED
      KSEC3(3)=isubs
      KSEC3(4)=192     ! 192 FOR COMPRESSION/ 128 MANY SUBSETS
!
      IREP=0
!
!
!*          6. PACK BUFR MESSAGE
!              -----------------
 600  CONTINUE
!
      KBUFL=JBUFL
      KERR=0
      CALL BUFREN( KSEC0,KSEC1,KSEC2,KSEC3,KSEC4, &
&                  KTDLEN,KTDLST,KDLENG,KDATA,KELEM, &
&                  KVALS,VALUES,CVALS,KBUFL,KBUFR,KERR)
!
      IF(KERR.GT.0) CALL EXIT(2)
!
!           7. WRITE BUFR OUT
!              --------------
 700  CONTINUE
!
      IBYTES=KBUFL*4
!
      IRET=0
      CALL PBWRITE(KUNIT,KBUFR,IBYTES,IRET)
      IF(IRET < 0) THEN
         print*,'Error during writing bufr data ',iret
         call exit(2)
      END IF
!
      end do
!     -----------------------------------------------------------------
!
 900  CONTINUE
!
      RETURN
      END

      SUBROUTINE READ_COORD(ILON,ILAT)
!-------------------------------------------------------------------------------
!     Read in lat / lon data for stereographic projection, return
!     1024 * 1024 data arrray ILON, ILAT
!-------------------------------------------------------------------------------
IMPLICIT NONE
INTEGER :: ILON(1024,1024),jj,ii
INTEGER :: ILAT(1024,1024)
CHARACTER(LEN=256) :: cppbase
!
cppbase=' '
call getenv('PP_BASE',cppbase)


OPEN(15,file =trim(cppbase)//'/dat/'//'nesdis_lat.dat', status='old', form='formatted')
do ii = 1, 1024
 do jj = 1,1024
  READ(15,'(I10)') ILAT(ii,jj)
 enddo
enddo
CLOSE(15)
!
OPEN(16,file =trim(cppbase)//'/dat/'//'nesdis_lon.dat', status='old', form='formatted')
do ii = 1, 1024
 do jj = 1,1024
  READ(16,'(I10)') ILON(ii,jj)
 enddo
enddo
CLOSE(16)
!
      END SUBROUTINE READ_COORD

      SUBROUTINE READ_LSM(LSM)
!-------------------------------------------------------------------------------
!     Read in lat / lon data for stereographic projection, return
!     1024 * 1024 data arrray LSM
!-------------------------------------------------------------------------------
IMPLICIT NONE
INTEGER :: II,JJ
REAL :: LSM(1024,1024)
CHARACTER(LEN=256) :: cppbase
!
cppbase=' '
call getenv('PP_BASE',cppbase)
OPEN(17,file = trim(cppbase)//'/dat/'//'lsm_polar.dat', status='old', form='formatted')
do ii = 1, 1024
 do jj = 1, 1024
   read(17,'(1x,f10.4)') lsm(ii,jj)
 enddo
enddo

CLOSE(17)
!
      END SUBROUTINE READ_LSM
!
!-------------------------------------------------------------------------------
!-------------------------------------------------------------------------------
      SUBROUTINE READ_GPH(GPH)
!-------------------------------------------------------------------------------
!     Read in lat / lon data for stereographic projection, return
!     1024 * 1024 data arrray GPH
!-------------------------------------------------------------------------------
IMPLICIT NONE
INTEGER :: II,JJ
REAL :: GPH(1024,1024)
CHARACTER(LEN=256) :: cppbase
!
cppbase=' '
call getenv('PP_BASE',cppbase)
OPEN(18,file = trim(cppbase)//'/dat/'//'oro_polar.dat', status='old', form='formatted')
do ii = 1, 1024
 do jj = 1, 1024
   read(18,'(1x,f10.4)') gph(ii,jj)
 enddo
enddo

CLOSE(18)
!
      END SUBROUTINE READ_GPH

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C


      SUBROUTINE DECOGR (FPDATA,ILENF,IBITS,NBIT,IB1PAR,
     C              IB2PAR,FVERT,ILENV,IGRIB,ILENG,IWORD,
     C              JLENV,JLENF,IERR)
C
C
C---->
C*
C*     NAME     : DECOGR
C*
C*     FUNCTION : DECODE WMO GRIB CODED DATA.
C*
C*     INPUT    : NBIT    - NUMBER OF BITS IN COMPUTER WORD
C*
C*                IGRIB   - INTEGER ARRAY CONTAINING DATA IN GRIB CODE.
C*                ILENG   - LENGTH OF ARRAY IGRIB.
C*
C*                FVERT   - REAL ARRAY TO RECEIVE VERTICAL COORDINATE
C*                          PARAMETERS.
C*                ILENV   - LENGTH OF ARRAY FVERT.
C*
C*                FPDATA  - REAL ARRAY TO RECEIVE DECODED DATA VALUES.
C*                ILENF   - LENGTH OF ARRAY FPDATA
C*
C*                IB1PAR  - INTEGER ARRAY (DIMENSION 17) TO RECEIVE
C*                          PRODUCT DEFINITION INFORMATION.
C*
C*                IB2PAR  - INTEGER ARRAY (DIMENSION 11) TO RECEIVE GRID
C*                          DEFINITION INFORMATION.
C*
C*     OUTPUT   : PARAMETERS FROM BLOCK 1 , PRODUCT DEFINITION BLOCK.
C*                --------------------------------------------------
C*                IB1PAR - INTEGER ARRAY (DIMENSION 17) OF PRODUCT
C*                         DEFINITION INFORMATION.
C*
C*                WORD      CONTENTS
C*                ----      --------
C*                  1       ORIGINATING CENTRE IDENTIFIER.
C*                  2       MODEL IDENTIFICATION.
C*                  3       GRID DEFINITION.
C*                  4       FLAG ( CODE TABLE 1)
C*                  5       PARAMETER IDENTIFIER ( CODE TABLE 2 ).
C*                  6       TYPE OF LEVEL (CODE TABLE 3).
C*                 7-8      VALUE(S) OF LEVELS (CODE TABLE 3).
C*                  9       YEAR OF DATA
C*                 10       MONTH OF DATA
C*                 11       DAY OF DATA
C*                 12       HOUR OF DATA
C*                 13       MINUTE OF DATA
C*                 14       TIME UNIT (CODE TABLE 4).
C*                 15       TIME RANGE ONE
C*                 16       TIME RANGE TWO
C*                 17       TIME RANGE FLAG (CODE TABLE 5).
C*
C*                          VALUE(S) OF LEVEL CAN OCCUPY 2 WORDS..
C*                          FOR A LAYER THE FIRST WORD DEFINES THE TOP
C*                          AND THE SECOND THE BOTTOM OF THE LAYER.
C*                          FOR A SINGLE LEVEL, ONLY THE FIRST WORD IS
C*                          USED.
C*
C*                PARAMETERS FROM BLOCK 2 , GRID DEFINITION BLOCK.
C*                -----------------------------------------------
C*                IB2PAR - INTEGER ARRAY (DIMENSION 11) CONTAINING GRID
C*                         DEFINITION INFORMATION.
C*                         USE VARIES WITH DATA REPRESENTATION TYPE.
C*
C*                WORD      LAT/LONG GRID
C*                ----      -------------
C*                 1        DATA REPRESENTATION TYPE (CODE TABLE 6).
C*                 2        NO. OF POINTS ALONG A LATITUDE
C*                 3        NO. OF POINTS ALONG A MERIDIAN.
C*                 4        LATITUDE OF ORIGIN (SOUTH - IVE).
C*                 5        LONGITUDE OF ORIGIN (WEST - IVE).
C*                 6        EXTREME POINT/INCREMENTS FLAG.(CODE TABLE 7)
C*                 7        LATITUDE OF EXTREME POINT (SOUTH - IVE).
C*                 8        LONGITUDE OF EXTREME POINT (WEST - IVE).
C*                 9        LATITUDE INCREMENT
C*                10        LONGITUDE INCREMENT
C*                11        SCANNING MODE (CODE TABLE 8)
C*
C*                WORD      GAUSSIAN GRID
C*                ----      -------------
C*                1-9       AS FOR LAT/LONGITUDE GRID.
C*                10        THE NUMBER OF LATITUDE LINES BETWEEN A POLE
C*                          AND THE EQUATOR.
C*                11        SCANNING MODE (CODE TABLE 8)
C*
C*                WORD      SPHERICAL HARMONICS
C*                ----      -------------------
C*                  1       DATA REPRESENTATION TYPE (CODE TABLE 6)
C*                  2       J - PENTAGONAL RESOLUTION PARAMETER
C*                  3       K - PENTAGONAL RESOLUTION PARAMETER
C*                  4       M - PENTAGONAL RESOLUTION PARAMETER
C*                  5       REPRESENTATION TYPE (CODE TABLE 9)
C*                  6       REPRESENTATION MODE (CODE TABLE 10)
C*                7-11      NOT USED
C*
C*
C*                USE FOR OTHER DATA REPRESENTATION TYPES IS
C*
C*                FVERT  - REAL ARRAY OF VERTICAL COORDINATE PARAMETERS
C*                JLENV  - NUMBER OF VALUES IN THIS ARRAY.
C*
C*                USED FOR HYBRID LEVELS ONLY.
C*
C*                PARAMETERS FROM BLOCK 3 , BIT-MAP DEFINITION BLOCK.
C*                --------------------------------------------------
C*
C*                TO BE DEFINED LATER.
C*
C*                PARAMETERS FROM BLOCK 4 , BINARY DATA BLOCK.
C*                -------------------------------------------
C*                FPDATA  - ARRAY OF FLOATING POINT VALUES.
C*                JLENF   - NUMBER OF VALUES IN THIS ARRAY.
C*                          JLENF IS NEGATIVE IF MISSING DATA CODED
C*
C*                IBITS   - NUMBER OF BITS FOR CODED DATA VALUES.
C*
C*                IERR    - ERROR INDICATOR.
C*
C*                          0, NO ERROR.
C*
C*                         -1, NUMBER OF BITS PER DATA VALUE EXCEEDS
C*                             WORD LENGTH, OR MAXIMUM ALLOWED.
C*                         -2, INPUT ARRAY HOLDS FEWER CODED VALUES
C*                             THAN EXPECTED.
C*                         -3, OUTPUT ARRAY TOO SMALL TO HOLD DECODED
C*                             DATA VALUES.
C*                         -4, CURRENTLY UNDEFINED OPTION SELECTED.
C*
C*                          1, NO BLOCK 5 FOUND.
C*
C*    JOHN HENNESSY , ECMWF , 15TH APRIL 1985
C*
C*
C     ---------------------------------------------------------------
C----<
C
C
C
C
C
C
C
C
C
      DIMENSION FPDATA(ILENF),FVERT(ILENV)
      DIMENSION IBLOCK(24),IGRIB(ILENG)
      DIMENSION IB1PAR(17),IB2PAR(11),ILAT(2)
C
      EQUIVALENCE (ZGRIB,JGRIB)
C
C     SET MAXIMUM NUMBER OF BITS PER DATA FIELD.
C
      DATA IMAX /60/
C
      ZSCALE = 0.
      IERR = 0
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C********************************************************************
C*
C*    BLOCK 1 - PRODUCT DEFINITION BLOCK.
C*
C********************************************************************
C
C
C     EXTRACT OCTETS OF BLOCK 1.
C
      IWORD = 1
      IOFF  = 0
      IBYTE = 8
      NVAL  = 24
C
      CALL GBYTES (IGRIB(1),IBLOCK(1),0,IBYTE,0,NVAL)
      CALL OFFSET (IOFF,NVAL,IWORD,IBYTE,NBIT,ILENG,IERR)
      IF (IERR.NE.0) RETURN
C
C     TRANSFER PRODUCT DEFINITION INFORMATION TO OUTPUT ARRAY.
C
      DO 100 I=1,17
         IB1PAR(I) = IBLOCK(I+4)
  100 CONTINUE
C
C
C
C
C
C***
C*    DESCRIPTION OF LEVEL OR LAYER ( CODE TABLE 3 ).
C***
C
C     CERTAIN LEVEL TYPES REQUIRE THAT THE DESCRIPTION OCCUPY
C     BOTH 8 BIT FIELDS. PUT SINGLE VALUE IN FIRST LEVEL WORD.
C
      IF (IB1PAR(6).EQ.100.OR.IB1PAR(6).EQ.103.OR.IB1PAR(6).EQ.105.
     C    OR.IB1PAR(6).EQ.107.OR.IB1PAR(6).EQ.109)
     C    THEN
              IB1PAR(7) = IB1PAR(7) * 32 + IB1PAR(8)
              IB1PAR(8) = 0
          ENDIF
C
C
C
C
C
C
C
C
C
C***
C*    TIME RANGE.
C***
C
C     ONE TIME RANGE CAN OCCUPY TWO OCTETS.
C
      IF (IB1PAR(17).EQ.10)
     C   THEN
             IB1PAR(15) = IB1PAR(15) * 32 + IB1PAR(16)
             IB1PAR(16) = 0
         ENDIF
C
C***
C*    RESERVED ELEMENTS.
C***
C
C
C
C
C
C********************************************************************
C*
C*    BLOCK 2 - GRID DESCRIPTION BLOCK.
C*
C********************************************************************
C
C***
C*    CHECK IF BLOCK 2 IS INCLUDED IN CODE.
C***
C
      IF (IB1PAR(4).EQ.1.OR.IB1PAR(4).EQ.3)
     C   THEN
C
C
C***
C*           LENGTH OF GRID DESCRIPTION BLOCK.
C***
C
             CALL GBYTE (IGRIB(IWORD),LBLK,IOFF,24)
             CALL OFFSET (IOFF,1,IWORD,24,NBIT,ILENG,IERR)
             IF (IERR.NE.0) RETURN
C
C            LENGTH IS 32 OCTETS FOR LAT/LONG, GAUSSIAN AND SPHERICAL
C            HARMONICS . FOR ANY DATA  ON HYBRID LEVELS THE
C            VERTICAL COORDINATES ARE ADDED.
C            GET NUMBER OF VERTICAL COORDINATE PARAMETERS, IF ANY.
C
             JLENV = (LBLK - 32) / 4
             IF(ILENV.LT.JLENV)
     C          THEN
                    IERR = -3
                    WRITE (*,9001) JLENV,ILENV
 9001               FORMAT (1H ,'NUMBER OF VERTICAL COORDINATES - ',I4,
     C                          ', ARRAY SIZE IS - ',I4)
                    RETURN
                ENDIF
C
C
C***
C*           NUMBER OF UNUSED BITS AT END OF BLOCK.
C***
C
             CALL GBYTE (IGRIB(IWORD),LNIL,IOFF,8)
             CALL OFFSET (IOFF,1,IWORD,8,NBIT,ILENG,IERR)
             IF (IERR.NE.0) RETURN
C
C
C
C
C***
C*           NEXT OCTET IS RESERVED.
C***
C
             CALL OFFSET (IOFF,1,IWORD,8,NBIT,ILENG,IERR)
             IF (IERR.NE.0) RETURN
C
C
C
C
C
C
C
C***
C*           DATA REPRESENTATION TYPE.
C***
C
             CALL GBYTE (IGRIB(IWORD),IB2PAR(1),IOFF,8)
             CALL OFFSET (IOFF,1,IWORD,8,NBIT,ILENG,IERR)
             IF (IERR.NE.0) RETURN
C
C            LAT/LONGITUDE GRID, GAUSSIAN GRID AND SPHERICAL HARMONICS
C            ARE THE ONLY DATA REPRESENTATIONS HANDLED.
C
             IF (IB2PAR(1).NE.0.AND.IB2PAR(1).NE.4.AND.IB2PAR(1).NE.50)
     C          THEN
                     WRITE (*,*)'GRID DESCRIPTION BLOCK NOT YET DEFINED'
                     IERR = -4
                     RETURN
                ENDIF
C
C
C
C
C***
C*           LAT/LONG OR GAUSSIAN GRID.
C***
C
             IF (IB2PAR(1).EQ.0.OR.IB2PAR(1).EQ.4)
     C         THEN
C
C                  NUMBER OF LAT/LONG POINTS.
C
                   CALL GBYTES (IGRIB(IWORD),IB2PAR(2),IOFF,16,0,2)
                   CALL OFFSET (IOFF,2,IWORD,16,NBIT,ILENG,IERR)
                   IF (IERR.NE.0) RETURN
C
C                  LAT/LONG OF ORIGIN.
C
                   CALL GBYTES (IGRIB(IWORD),ILAT(1),IOFF,24,0,2)
                   CALL OFFSET (IOFF,2,IWORD,24,NBIT,ILENG,IERR)
                   IF (IERR.NE.0) RETURN
C
C                  IF SIGN BIT SET TO 1 , VALUES ARE NEGATIVE.
C
                   DO 200 I=1,2
                      IB2PAR(I+3) = ILAT(I)
                      IF (ILAT(I).GT.8388608)
     C                   THEN
                             IB2PAR(I+3) = IB2PAR(I+3) - 8388608
                             IB2PAR(I+3) = - IB2PAR(I+3)
                         ENDIF
  200             CONTINUE
C
C
C                  EXTREME POINT / INCREMENT FLAG.
C
                   CALL GBYTE (IGRIB(IWORD),IB2PAR(6),IOFF,8)
                   CALL OFFSET (IOFF,1,IWORD,8,NBIT,ILENG,IERR)
                   IF (IERR.NE.0) RETURN
C
C
C                  LAT/LONG OF EXTREME POINTS.
C
                   CALL GBYTES (IGRIB(IWORD),ILAT(1),IOFF,24,0,2)
                   CALL OFFSET (IOFF,2,IWORD,24,NBIT,ILENG,IERR)
                   IF (IERR.NE.0) RETURN
C
C                  IF SIGN BIT SET TO 1 , VALUES ARE NEGATIVE.
C
                   DO 300 I=1,2
                      IB2PAR(I+6) = ILAT(I)
                      IF (ILAT(I).GT.8388608)
     C                   THEN
                             IB2PAR(I+6) = IB2PAR(I+6) - 8388608
                             IB2PAR(I+6) = - IB2PAR(I+6)
                         ENDIF
  300             CONTINUE
C
C                 DIRECTION INCREMENTS / NUMBER OF LATITUDE LINES.
C
                  CALL GBYTES (IGRIB(IWORD),IB2PAR(9),IOFF,16,0,2)
                  CALL OFFSET (IOFF,2,IWORD,16,NBIT,ILENG,IERR)
                  IF (IERR.NE.0) RETURN
C
C                 SCANNING MODE.
C
                  CALL GBYTE (IGRIB(IWORD),IB2PAR(11),IOFF,8)
                  CALL OFFSET (IOFF,1,IWORD,8,NBIT,ILENG,IERR)
                  IF (IERR.NE.0) RETURN
C
C                 4 RESERVED OCTETS.
C
                  CALL OFFSET (IOFF,4,IWORD,8,NBIT,ILENG,IERR)
                  IF (IERR.NE.0) RETURN
C
              ENDIF
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C***
C*            SPHERICAL HARMONIC DATA.
C***
C
              IF (IB2PAR(1).EQ.50)
     C           THEN
C
C                    PENTAGONAL RESOLUTION PARAMETERS.
C
                     CALL GBYTES (IGRIB(IWORD),IB2PAR(2),IOFF,16,0,3)
                     CALL OFFSET (IOFF,3,IWORD,16,NBIT,ILENG,IERR)
                     IF (IERR.NE.0) RETURN
C
C                    REPRESENTATION TYPE AND MODE.
C
                     CALL GBYTES (IGRIB(IWORD),IB2PAR(5),IOFF,8,0,2)
                     CALL OFFSET (IOFF,2,IWORD,8,NBIT,ILENG,IERR)
                     IF (IERR.NE.0) RETURN
C
C                    18 RESERVED OCTETS.
C
                     CALL OFFSET (IOFF,18,IWORD,8,NBIT,ILENG,IERR)
                     IF (IERR.NE.0) RETURN
C
                 ENDIF
C
C
C
C
C***
C*               VERTICAL COORDINATE PARAMETERS FOR HYBRID LEVELS.
C***
C
                 IF (JLENV.NE.0)
     C              THEN
                        DO 400 I=1,JLENV
                           CALL GBYTE (IGRIB(IWORD),IEXP,IOFF,8)
                           CALL OFFSET (IOFF,1,IWORD,8,NBIT,ILENG,IERR)
                           IF (IERR.NE.0) RETURN
                           CALL GBYTE (IGRIB(IWORD),IMANT,IOFF,24)
                           CALL OFFSET (IOFF,1,IWORD,24,NBIT,ILENG,IERR)
                           IF (IERR.NE.0) RETURN
                           CALL DECFP (FVERT(I),IEXP,IMANT)
  400                   CONTINUE
                    ENDIF
C
         ENDIF
C
C
C
C
C
C
C
C
C
C
C********************************************************************
C*
C*    BLOCK 3 - BIT MAP BLOCK.
C*
C********************************************************************
C
      IF (IB1PAR(4).EQ.2.OR.IB1PAR(4).EQ.3)
     C     THEN
               WRITE (*,*)'BIT MAP BLOCK NOT YET DEFINED'
               IERR = -4
               RETURN
           ENDIF
C
C
C
C
C
C********************************************************************
C*
C*    BLOCK 4 - BINARY DATA BLOCK.
C*
C********************************************************************
C
C
C
C***
C*    GET LENGTH OF BINARY DATA BLOCK.
C***
C
C
      IPW = IWORD
      IPB = IOFF
C
      CALL GBYTE (IGRIB(IWORD),LBIN,IOFF,24)
      CALL OFFSET (IOFF,1,IWORD,24,NBIT,ILENG,IERR)
      IF (IERR.NE.0) RETURN
C
C
C
C
C***
C*    4 BIT FLAG / 4 BIT COUNT OF UNUSED BITS AT END OF BLOCK OCTET.
C***
C
      CALL GBYTE (IGRIB(IWORD),IFLAG,IOFF,8)
      CALL OFFSET (IOFF,1,IWORD,8,NBIT,ILENG,IERR)
      IF (IERR.NE.0) RETURN
C
      IREP = IFLAG / 16
      LNIL = IFLAG - IREP * 16
C
C
C
C
C
C
C
C***
C*    GET SCALE FACTOR
C***
C
      CALL GBYTE (IGRIB(IWORD),JSCALE,IOFF,16)
      CALL OFFSET (IOFF,1,IWORD,16,NBIT,ILENG,IERR)
      IF (IERR.NE.0) RETURN
C
      ISCALE = JSCALE
      IF (JSCALE.GE.32768)
     C    THEN
              ISCALE = ISCALE - 32768
              ISCALE = - ISCALE
          ENDIF
C
C
C
C
C***
C*    GET REFERENCE VALUE (FMIN) IN GRIB FORMAT (IEXP,IMANT)
C***
C
C
      CALL GBYTE (IGRIB(IWORD),IEXP,IOFF,8)
      CALL OFFSET (IOFF,1,IWORD,8,NBIT,ILENG,IERR)
      IF (IERR.NE.0) RETURN
      CALL GBYTE (IGRIB(IWORD),IMANT,IOFF,24)
      CALL OFFSET (IOFF,1,IWORD,24,NBIT,ILENG,IERR)
      IF (IERR.NE.0) RETURN
C
C
C     CHECK FOR MISSING DATA INDICATORS.
C
      IMISS = 0
      IF (JSCALE.EQ.65535.AND.IEXP.EQ.255.AND.IMANT.EQ.16777215)
     C   IMISS = 1
C
C     CONVERT REFERENCE VALUE AND SCALE FACTOR.
C
      IF (IMISS.EQ.0)
     C   THEN
             CALL DECFP (FMIN,IEXP,IMANT)
             ZSCALE = 2.**ISCALE
         ENDIF
C
C
C
C
C***
C*    GET NUMBER OF BITS IN EACH DATA VALUE.
C***
C
      CALL GBYTE (IGRIB(IWORD),IBITS,IOFF,8)
      CALL OFFSET (IOFF,1,IWORD,8,NBIT,ILENG,IERR)
      IF (IERR.NE.0) RETURN
C
C
C     CHECK NUMBER OF BITS PER DATA FIELD.
C
      IF (IBITS.GT.NBIT.OR.IBITS.GT.IMAX)
     C    THEN
              IERR = -1
              WRITE (*,9002) IBITS,NBIT,IMAX
 9002         FORMAT (1H ,'NUMBER OF BITS PER DATA VALUE, ',I3,
     C                'EXCEEDS WORD LENGTH, ',I3,' OR MAXIMUM ',
     C                ' PERMITTED VALUE, ',I3)
              RETURN
          ENDIF
C
C***
C*    IF DATA IS IN SPHERICAL HARMONIC FORM, NEXT 4 OCTETS
C*    CONTAIN THE REAL (0,0) COEFFICIENT.
C***
C
      IF (IREP.EQ.1)
     C    THEN
C
C            GET REAL (0,0) COEFFICIENT IN GRIB FORMAT AND
C            CONVERT TO FLOATING POINT.
C
             CALL GBYTE (IGRIB(IWORD),IEXP,IOFF,8)
             CALL OFFSET (IOFF,1,IWORD,8,NBIT,ILENG,IERR)
             IF (IERR.NE.0) RETURN
             CALL GBYTE (IGRIB(IWORD),IMANT,IOFF,24)
             CALL OFFSET (IOFF,1,IWORD,24,NBIT,ILENG,IERR)
             IF (IERR.NE.0) RETURN
             IF (IMISS.EQ.1)
     C          THEN
                    FPDATA(1) = 0.0
                ELSE
                    CALL DECFP (FPDATA(1),IEXP,IMANT)
                ENDIF
          ENDIF
C
C
C
C
C*****
C*    DECODE DATA VALUES TO FLOATING POINT AND STORE IN FPDATA.
C*****
C
C     FIRST CALCULATE THE NUMBER OF DATA VALUES.
C
      JLENF = LBIN - 11 - IREP * 4
      JLENF = (JLENF * 8 - LNIL) / IBITS
C
C     CHECK LENGTH OF OUTPUT ARRAY.
C
      IF (JLENF+IREP.GT.ILENF)
     C   THEN
             IERR = -3
             WRITE (*,9003) JLENF,ILENF
 9003        FORMAT (1H ,'NUMBER OF VALUES TO BE DECODED IS - ',I7,
     C                    ', ARRAY SIZE - ',I7)
             RETURN
         ENDIF
C
      CALL GBYTES (IGRIB(IWORD),FPDATA(IREP+1),IOFF,IBITS,0,JLENF)
      CALL OFFSET (IOFF,JLENF,IWORD,IBITS,NBIT,ILENG,IERR)
      IF (IERR.NE.0) RETURN
C
      DO 500 I= IREP+1,IREP+JLENF
            IF (IMISS.EQ.1)
     C         THEN
                   FPDATA(1) = 0.0
               ELSE
                   ZGRIB     = FPDATA (I)
                   FPDATA(I) = FMIN + JGRIB * ZSCALE
               ENDIF
  500 CONTINUE
C
C     INCLUDE (0,0) COEFFICIENT IN COUNT, IF SPHERICAL HARMONIC DATA.
C
      JLENF = IREP + JLENF
C
C
C
C
C***
C*    SKIP ANY ZERO FILL AT END OF DATA BLOCK.
C***
C
      L = (IWORD-IPW) * NBIT + IOFF -IPB
      L = LBIN * 8 - L
      IF (L.NE.0)
     C    THEN
              CALL OFFSET (IOFF,1,IWORD,L,NBIT,ILENG,IERR)
              IF (IERR.NE.0) RETURN
          ENDIF
C
C
C
C
C********************************************************************
C*
C*    BLOCK 5 - END BLOCK.
C*
C********************************************************************
C
C     CHECK 7 7 7 7 AT END OF CODED DATA.
C
      IBLOCK(1) = 55
      IBLOCK(2) = 55
      IBLOCK(3) = 55
      IBLOCK(4) = 55
C
      CALL GBYTES (IGRIB(IWORD),IBLOCK(1),IOFF,8,0,4)
C
      DO 600 I=1,4
         IF (IBLOCK(I).NE.55) IERR = 1
  600 CONTINUE
C
      IF (IERR.EQ.1) WRITE (*,*) ' NO 7777 GROUP FOUND '
C
C
C
C     SET NUMBER OF VALUES NEGATIVE, IF MISSING DATA VALUES.
C
      IF (IMISS.EQ.1) JLENF = - JLENF
C
      RETURN
      END

C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      PROGRAM BUFR2CREX
C
C**** *BUFRCREX*
C
C
C     PURPOSE.
C     --------
C         Bufr to CREX conversion.
C
C
C**   INTERFACE.
C     ----------
C
C          NONE.
C
C     METHOD.
C     -------
C
C          NONE.
C
C
C     EXTERNALS.
C     ----------
C
C
C     REFERENCE.
C     ----------
C
C          NONE.
C
C     AUTHOR.
C     -------
C
C          MILAN DRAGOSAVAC    *ECMWF*       07/01/2004
C
C
C     MODIFICATIONS.
C     --------------
C
C          NONE.
C
C
      IMPLICIT LOGICAL(L,O,G), CHARACTER*8(C,H,Y)
C
      PARAMETER(JSUP =   9,JSEC0=   3,JSEC1= 40,JSEC2=4096,JSEC3=    4,
     1       JSEC4=   2,JELEM=320000,JSUBS=400,JCVAL=150 ,JBUFL=512000,
#ifdef JBPW_64
     2          JBPW =  64,JTAB =3000,JCTAB=120,JCTST=1800,JCTEXT=1200,
#else 
     2          JBPW =  32,JTAB =3000,JCTAB=120,JCTST=1800,JCTEXT=1200,
#endif
     3          JWORK=4096000,JKEY=46,JBYTE=80000)
C
      PARAMETER (KELEM=20000)
      PARAMETER (KVALS=360000)
C 
      DIMENSION KBUFF(JBUFL)
      DIMENSION KBUFR(JBUFL)
      DIMENSION KSUP(JSUP)  ,KSEC0(JSEC0),KSEC1(JSEC1)
      DIMENSION KSEC2(JSEC2),KSEC3(JSEC3),KSEC4(JSEC4)
      DIMENSION KEY  (JKEY),KREQ(2)
C
      REAL*8 VALUES(KVALS)
      REAL*8 RQV(KELEM)
C
      DIMENSION KTDLST(KELEM),KTDEXP(KELEM),KRQ(KELEM)
      DIMENSION KDATA(2000)
C
      CHARACTER*256    COUT,CARG(4),CFIN
      CHARACTER*64     CNAMES(KELEM)
      CHARACTER*24     CUNITS(KELEM)
      CHARACTER*80     CVALS(KVALS)
      CHARACTER*80     YENC
      CHARACTER*160000 YOUT
      CHARACTER*3      CRCRLF
C
C     Common block containing bufr tables
C
      COMMON /BCOMTAB/ NTABBTR(JTAB),NTABBS (JTAB),NTABBRV(JTAB),
     1                 NTABBDW(JTAB),NTABDTR(JTAB),NTABDST(JTAB),
     2                 NTABDL (JTAB),NTABDSQ(JTAB*20),NTABP(64,255)
C
C             NTABBTR    - table B,  table reference              array
C             NTABBS     - table B,  scale                        array
C             NTABBRF    - table B,  reference value              array
C             NTABBDW    - table B,  data width                   array
C             NTABDTR    - table D,  table reference              array
C             NTABDST    - table D,  starting pointers            array
C             NTABDL     - table D,  lengths                      array
C             NTABDSQ    - table D,  list of sequence descriptors array
C
      COMMON /BCOMWT/ NDWINC,NSCAM,NAFDW,NWT ,ODREPF,
     1                N221,MREL,NFCM,NFUCM,MBMP,OMARKER,M0,
     2                MBMPL,NSTACK(JELEM),NWTEN(JELEM),
     3                NWTR (JELEM),NWTS (JELEM),NWTRV (JELEM),
     4                NWTDW(JELEM)
C
C             NDWINC   -  data width increment
C             NSCAM    -  scale multiplier
C             NAFDW    -  augmented field data width
C             NWT      -  pointer to working table
C             NSTACK   -  list of data descriptors
C             ODREPF   -  replication (logical)
C             N221     -  data not present for n221 elements
C             MREL     -  pointer to the last data element
C             NFCM     -  first compressed message
C             MBMP     -  pointer to the begining of bit map
C             NWTR     -  working table reference
C             NWTS     -  working scale
C             NWTRV    -  working reference value
C             NWTDW    -  working data width
C
      COMMON /BCOMWTC/ CWTEN(JELEM),CWTU (JELEM)
C
C             CWTEN    -  working table element naame
C             CWTU     -  working table units
C
c
      PARAMETER(JP=3000)
C
      CHARACTER*120 YENTRY
      CHARACTER*15  YFNAME
      CHARACTER*15  FMT
      CHARACTER*6   CREXKTDLST(KELEM),CREXKTDLST0
C
      INTEGER IVALUE(KELEM)
C
C     Logical switch to use check digit indicator
C
      CHARACTER*4 YUSE_E
C
      INTEGER IVAL,IIVAL
c
      REAL*8 EPS
      REAL*8 RVIND
      REAL*8 VAL
C
      EQUIVALENCE (YOUT,KBUFR(1))
C
C                                                                       
C     ------------------------------------------------------------------
C*          1. INITIALIZE CONSTANTS AND VARIABLES.
C              -----------------------------------
 100  CONTINUE
C
C 
      NBYTPW=JBPW/8
      RVIND=1.7E38
      NVIND=2147483647
      IOBS=0
      EPS=1.0E-8
      NPACK=0
      N=0
      OO=.FALSE.
C
      CRCRLF=CHAR(13)//CHAR(13)//CHAR(10)
C
C     Get input and output file name.
C
      NARG=IARGC()
c
      IF(NARG.LT.4) THEN
         print*,'Usage -- bufr2crex -i infile -o outfile' 
         STOP
      END IF
c
      COUT=' '
      CFIN=' '
c
      DO 101 J=1,NARG
      CALL GETARG(J,CARG(J))
 101  CONTINUE
c
      DO 102 J=1,NARG,2
        IF(CARG(J).EQ.'-i') THEN
           CFIN=CARG(J+1)
        ELSEIF(CARG(J).EQ.'-o') THEN
           COUT=CARG(J+1)
        ELSE
            print*,'Usage -- bufr2crex -i infile -o outfile'
            STOP
        END IF
 102  CONTINUE
C
      II=INDEX(CFIN,' ')
      II=II-1
      JJ=INDEX(COUT,' ')
      JJ=JJ-1
C
      KRQL=0
      NR=0
      KREQ(1)=0
      KREQ(2)=0
C
C
C*          1.2 OPEN FILE CONTAINING BUFR DATA.
C               -------------------------------
 120  CONTINUE
C
      IRET=0 
      CALL PBOPEN(IUNIT,CFIN(1:ii),'r',IRET)
      IF(IRET.EQ.-1) STOP 'open failed'
      IF(IRET.EQ.-2) STOP 'Invalid file name'
      IF(IRET.EQ.-3) STOP 'Invalid open mode specified'
C
      CALL PBOPEN(IUNIT1,cout(1:jj),'w',IRET)
      IF(IRET.EQ.-1) STOP 'open failed on bufr.dat'
      IF(IRET.EQ.-2) STOP 'Invalid file name'
      IF(IRET.EQ.-3) STOP 'Invalid open mode specified'
C
C     ----------------------------------------------------------------- 
C*          2. SET REQUEST FOR EXPANSION.
C              --------------------------
 200  CONTINUE
C
      KREQ(1)=1
      KREQ(2)=0
C
      OSEC3=.FALSE.
      OPRT=.FALSE.
      OENC=.TRUE.
      ICODE=0
      OCOMP=.FALSE.
C
C*          2.1 SET REQUEST FOR PARTIAL EXPANSION.
C               ----------------------------------
 210  CONTINUE
C
      KERR=0
      CALL BUSRQ(KREQ,KRQL,KRQ,RQV,KERR)
C
C     -----------------------------------------------------------------
C*          3.  READ BUFR MESSAGE.
C               ------------------
 300  CONTINUE
C
      IERR=0
      KBUFL=0
C
      IRET=0
      CALL PBBUFR(IUNIT,KBUFF,JBYTE,KBUFL,IRET) 
      IF(IRET.EQ.-1) THEN
c         IF(N.NE.0) GO TO 600
         print*,'Number of subsets     ',iobs
         print*,'Number of messages    ',n
         STOP 'EOF'
      END IF
      IF(IRET.EQ.-2) STOP 'File handling problem' 
      IF(IRET.EQ.-3) STOP 'Array too small for product'
C
      N=N+1
      KBUFL=KBUFL/nbytpw+1
      IF(N.LT.NR) GO TO 300
      print*,'----------------------',n
C
C     -----------------------------------------------------------------
C*          4. EXPAND BUFR MESSAGE.
C              --------------------
 400  CONTINUE
C
      CALL BUS012(KBUFL,KBUFF,KSUP,KSEC0,KSEC1,KSEC2,KERR)
      IF(KERR.NE.0) THEN
         PRINT*,'Error in BUS012: ',KERR
         PRINT*,' BUFR MESSAGE NUMBER ',N,' CORRUPTED.'
         KERR=0
         GO TO 300
      END IF
C
      KEL=KELEM
      IF(KSUP(6).GT.1) THEN
         KEL=KVALS/KSUP(6)
         IF(KEL.GT.KELEM) KEL=KELEM
      END IF
C
      CALL BUFREX(KBUFL,KBUFF,KSUP,KSEC0 ,KSEC1,KSEC2 ,KSEC3 ,KSEC4,
     1            KEL,CNAMES,CUNITS,KVALS,VALUES,CVALS,IERR)
C
      IF(IERR.NE.0) THEN
         IF(IERR.EQ.45) GO TO 300
         IF(IERR.EQ.2) THEN
            IERR=0
            GO TO 300
         END IF
         CALL EXIT(2)
      END IF
c
      IOBS=IOBS+KSEC3(3)
c
      NPACK=NPACK+1 
C
      ISUBSET=1
      CALL BUSEL2(ISUBSET,KEL,KTDLEN,KTDLST,KTDEXL,KTDEXP,CNAMES,
     1            CUNITS,IERR)
      IF(KERR.NE.0) CALL EXIT(2)
C
C*          4.1 PRINT CONTENT OF EXPANDED DATA.
C               -------------------------------
 410  CONTINUE
C
      IF(.NOT.OPRT) GO TO 500
      IF(.NOT.OSEC3) GO TO 450
C
C*          4.2 PRINT SECTION ZERO OF BUFR MESSAGE.
C               -----------------------------------
 420  CONTINUE
C

      CALL BUPRS0(KSEC0)
C
C*          4.3 PRINT SECTION ONE OF BUFR MESSAGE.
C               -----------------------------------
 430  CONTINUE
C
      CALL BUPRS1(KSEC1)
C
C
C*          4.4 PRINT SECTION TWO OF BUFR MESSAGE.
C               -----------------------------------
 440  CONTINUE
c
C              AT ECMWF SECTION 2 CONTAINS RDB KEY.
C              SO UNPACK KEY
C
      CALL BUUKEY(KSEC1,KSEC2,KEY,KSUP,KERR)
C
C              PRINT KEY
C
      CALL BUPRS2(KSUP ,KEY)
C
C*          4.5 PRINT SECTION 3 OF BUFR MESSAGE.
C               -----------------------------------
 450  CONTINUE
C
C               FIRST GET DATA DESCRIPTORS
C
      ISUBSET=1
      CALL BUSEL2(ISUBSET,KEL,KTDLEN,KTDLST,KTDEXL,KTDEXP,CNAMES,
     1            CUNITS,IERR)
      IF(KERR.NE.0) CALL EXIT(2)
C
C               PRINT  CONTENT
C
      IF(OSEC3) THEN
         CALL BUPRS3(KSEC3,KTDLEN,KTDLST,KTDEXL,KTDEXP,KEL,CNAMES)
      END IF
c
C
C*         4.6 PRINT SECTION 4 (DATA).
C              -----------------------
 460  CONTINUE
C
C          IN THE CASE OF MANY SUBSETS DEFINE RANGE OF SUBSETS
C
      IF(.NOT.OO) THEN
      WRITE(*,'(a,$)') ' STARTING SUBSET TO BE PRINTED : '
      READ(*,'(BN,I6)')   IST
      WRITE(*,'(a,$)') ' ENDING SUBSET TO BE PRINTED : '
      READ(*,'(BN,I6)')   IEND
      OO=.FALSE.
      END IF
C
C              PRINT DATA
C
      ICODE=0
      CALL BUPRT(ICODE,IST,IEND,KEL,CNAMES,CUNITS,CVALS,
     1           KVALS,VALUES,KSUP,KSEC1,IERR)
C
C
C     -----------------------------------------------------------------
C*          5. COLLECT DATA FOR REPACKING.
C              ---------------------------
 500  CONTINUE
C      
C               FIRST GET DATA DESCRIPTORS
C
      ISUBSET=1
      CALL BUSEL2(ISUBSET,KEL,KTDLEN,KTDLST,KTDEXL,KTDEXP,CNAMES,
     1            CUNITS,IERR)
      IF(KERR.NE.0) CALL EXIT(2)
C
C     -----------------------------------------------------------------
C*          6. PACK CREX MESSAGE.
C              ------------------
 600  CONTINUE
C
C     Modify BUFR operators
C
      J=0
      DO 602 I=1,KTDLEN
      IF(KTDLST(I).EQ.222000) GO TO 603
      IF(KTDLST(I).EQ.201000) GO TO 602 
      IF(KTDLST(I).EQ.202000) GO TO 602
      IF(KTDLST(I).EQ.204000) GO TO 602
      IF(KTDLST(I).EQ.031000) GO TO 602
      IF(KTDLST(I).EQ.031001) GO TO 602
      IF(KTDLST(I).EQ.031002) GO TO 602
C
      CREXKTDLST0=' '
      WRITE(CREXKTDLST0,'(I6.6)',IOSTAT=IOS) KTDLST(I)
      IF(IOS.NE.0) THEN
         print*,'Internal write error.'
         CALL EXIT(2)
      END IF
      J=J+1
      CREXKTDLST(J)(1:6)=CREXKTDLST0
C
      IF(CREXKTDLST(J)(1:1).EQ.'3') THEN
         CREXKTDLST(J)(1:1)='D'
      ELSEIF(CREXKTDLST(J)(1:1).EQ.'0') THEN
         CREXKTDLST(J)(1:1)='B'
      ELSEIF(CREXKTDLST(J)(1:1).EQ.'1') THEN
         CREXKTDLST(J)(1:1)='R'
c        scan for any 201000,202000 or 201y,202y followed by 206y
         READ(CREXKTDLST(J)(2:3),'(I2.2)',IOSTAT=IOS) IELEMENTS
         IF(IOS.NE.0) THEN
            print*,'Internal read error.'
            CALL EXIT(2)
         END IF
         IEL=IELEMENTS
         DO IN=I,I+IELEMENTS-1
         IF(KTDLST(IN).EQ.201000) IEL=IEL-1
         IF(KTDLST(IN).EQ.202000) IEL=IEL-1
         IF(KTDLST(IN).GE.201001.AND.KTDLST(IN).LE.201999.AND.
     1      KTDLST(IN+1)/1000.EQ.206) IEL=IEL-1
         IF(KTDLST(IN).GE.202001.AND.KTDLST(IN).LE.202999.AND.         
     1      KTDLST(IN+1)/1000.EQ.206) IEL=IEL-1
         END DO
         WRITE(CREXKTDLST(J)(2:3),'(I2.2)',IOSTAT=IOS) IEl
         IF(IOS.NE.0) THEN
            print*,'Internal write error.'
            CALL EXIT(2)
         END IF
      ELSEIF(CREXKTDLST(J)(1:3).EQ.'201') THEN
         IF(KTDLST(I+1)/1000.EQ.206) THEN
            J=J-1
            GO TO 602
         END IF
         READ(CREXKTDLST(J)(4:6),'(I3.3)',IOSTAT=IOS) IY
         IF(IOS.NE.0) THEN
            print*,'Internal read error.'
            CALL EXIT(2)
         END IF
         IBITS=IY-128
         ICLASS=KTDLST(I+1)/1000
         IYYY  =KTDLST(I+1)-ICLASS*1000+1
         ICLASS=ICLASS+1
         III=NTABP(ICLASS,IYYY)
         IDW=NTABBDW(III)+IBITS
         IRES=2.**IDW-1
         JZ=0
         DO WHILE(IRES.GT.0)
         JZ=JZ+1
         IRES=IRES/10
         END DO
         CREXKTDLST(J)(1:3)='C01'
         WRITE(CREXKTDLST(J)(4:6),'(I3.3)',IOSTAT=IOS) JZ
         IF(IOS.NE.0) THEN
            print*,'Internal write error.'
            CALL EXIT(2)
         END IF
      ELSEIF(CREXKTDLST(J)(1:3).EQ.'202') THEN
         GO TO 602
      ELSEIF(CREXKTDLST(J)(1:3).EQ.'205') THEN
          CREXKTDLST(J)(1:3)='C05'
      ELSE
         print*,'Wrong data descriptor ',crexktdlst(j)
         print*,'Data containing above descriptor can',
     1          ' not be converted'
         go to 300
      END IF
 602  CONTINUE
c
 603  CONTINUE
C
      ICREXLEN=J
c
C     Find delayed replications
c
      KDLEN=0
C
      IST=1
      IEND=1
      OMULTI=.FALSE.
      IF(IAND(KSEC3(4),64).NE.0.AND.KSEC3(3).GT.1) THEN
         IEND=KSEC3(3)
         OMULTI=.TRUE.
      END IF
C
      DO ISUBSET=IST, IEND

      JJ=(ISUBSET-1)*KEL
C
      CALL BUSEL2(ISUBSET,KEL,KTDLEN,KTDLST,KTDEXL,KTDEXP,CNAMES,
     1            CUNITS,IERR)
C
      DO I=1,KTDEXL
C
        II=I+JJ
C
        IF(KTDEXP(I).EQ.031001.OR.
     1     KTDEXP(I).EQ.031000.OR.
     2     KTDEXP(I).EQ.031002) THEN
           KDLEN=KDLEN+1
           KDATA(KDLEN)=NINT(VALUES(II))
        END IF
      END DO
C
C*   Make unit conversion from K to Celsius
C
      DO I=1,KTDEXL
        IF(CUNITS(I)(1:2).EQ.'K '.AND.
     1     KTDEXP(I)/1000.EQ.12) THEN
           IF(KTDEXP(I).NE.012064.AND.
     1        KTDEXP(I).NE.012065.AND.
     2        KTDEXP(I).NE.012070.AND.
     2        KTDEXP(I).NE.012071.AND.
     4        KTDEXP(I).NE.012164.AND.
     5        KTDEXP(I).NE.012151.AND.
     6        KTDEXP(I).NE.012051.AND.
     7        KTDEXP(I).NE.022050.AND.
     8        KTDEXP(I).NE.012171) THEN
              IF(OMULTI) THEN
              IJ=I+JJ
              IF(abs(VALUES(IJ)-rvind)/rvind.GT.eps) 
     1           VALUES(IJ)=VALUES(IJ)-273.15 
              ELSE
              DO J=1,KSEC3(3)
              IJ=I+(J-1)*KEL
              IF(abs(VALUES(IJ)-rvind)/rvind.GT.eps)
     1           VALUES(IJ)=VALUES(IJ)-273.15
              END DO
              END IF
           END IF
        END IF
        IF(CUNITS(I)(1:2).EQ.'PA'.AND.
     1     KTDEXP(I).EQ.015003) THEN
           IF(OMULTI) THEN
           IJ=I+JJ
           IF(abs(VALUES(IJ)-rvind)/rvind.GT.eps)
     1        VALUES(IJ)=VALUES(IJ)*10000.
           ELSE
           DO J=1,KSEC3(3)
           IJ=I+(J-1)*KEL
           IF(abs(VALUES(IJ)-rvind)/rvind.GT.eps) 
     1        VALUES(IJ)=VALUES(IJ)*10000.
           END DO
           END IF
        END IF
      END DO
C
      END DO

C
C*          6.2 ENCODE DATA INTO CREX MESSAGE.
C               ------------------------------
 620  CONTINUE
C
      IF(KSEC1(2).EQ.4) THEN         ! Bufr edition number
         KSEC1(2)=2                  ! Crex edition number
         KSEC1(5)=KSEC3(3)           ! Number of subsets
         KSEC1( 7)=KSEC1(17)         ! International sub category
         KSEC1(17)=KSEC1(15)            ! Bufr master table version number
         KSEC1(15)=3                    ! Crex version number used
         KSEC1(18)=KSEC1(8)             ! Bufr version number of local tables
      ELSE
         KSEC1(17)=KSEC1(15)            ! Bufr master table version number
         KSEC1(2)=1                  ! Crex edition number
         KSEC1(15)=3                    ! Crex version number used
         KSEC1(18)=KSEC1(8)             ! Bufr version number of local tables
      END IF
c
      CALL CREXEN(KSEC0,KSEC1,KSEC3,
     1            ICREXLEN,CREXKTDLST,KDLEN,KDATA,KEL,KVALS,
     2            VALUES,CVALS,KBUFL,KBUFR,KERR)
      IF(KERR.GT.0) THEN
         print*,'CREXEN error:',KERR
         go to 300
      END IF
C
C           6.3 WRITE CREX MESSAGE INTO FILE.
C               -----------------------------
 630  CONTINUE
C
      ILEN=KBUFL
C     
      IERR=0
      CALL PBWRITE(IUNIT1,KBUFR,ILEN,IERR)
      IF(IERR.LT.0) THEN
         print*,'Error writing into target file.'
         CALL EXIT(2)
      END IF
C
      GO TO 300
C
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      INTEGER FUNCTION NUMPTNS(NORTH,SOUTH,GRIDSTEP)
C
C---->
C**** NUMPTNS
C
C     Purpose
C     -------
C
C     Calculate number of grid points in the range from north to south.
C
C
C     Interface
C     ---------
C
C     IRET = NUMPTNS(NORTH,SOUTH,GRIDSTEP)
C
C     Input
C     -----
C
C     NORTH    - Northern boundary in degrees
C     SOUTH    - Southern boundary in degrees
C     GRIDSTEP - Grid interval in degrees
C
C
C     Output
C     ------
C
C     Function returns the number of grid points in the north-south
C     interval.
C
C
C     Method
C     ------
C
C     The grid is assumed to be centred on the Equator.
C
C
C     Externals
C     ---------
C
C     None.
C
C     Author
C     ------
C
C     J.D.Chambers     ECMWF     Dec 1997
C
C
C     Modifications
C     -------------
C
C     None.
C
C----<
C
      IMPLICIT NONE
C
C     Function arguments
C
      REAL SOUTH, NORTH, GRIDSTEP
C
C     Local variables
C
      INTEGER N1, N2
      REAL TOP, BOTTOM
C
C ------------------------------------------------------------------
C     Section 1.   Initialise
C ------------------------------------------------------------------
C
  100 CONTINUE
C
      BOTTOM = SOUTH
      TOP    = NORTH
      IF( BOTTOM.GT.TOP) THEN
        BOTTOM = NORTH
        TOP    = SOUTH
      ENDIF
C ------------------------------------------------------------------
C     Section 2.   Calculate the number of points in the interval
C ------------------------------------------------------------------
C
  200 CONTINUE
C
      N1 = NINT(BOTTOM/GRIDSTEP)
      N2 = NINT(TOP/GRIDSTEP)
      NUMPTNS = N2 - N1 + 1
C
C ------------------------------------------------------------------
C     Section 9.   Return
C ------------------------------------------------------------------
C
  900 CONTINUE
C
      RETURN
      END

#define MISSING_VALUE -9999999
      PROGRAM SINGLEPT
      IMPLICIT NONE
C
      INTEGER JPACK, JPBYTES
      PARAMETER (JPACK = 5000000)
      PARAMETER (JPBYTES = 4)
C
      INTEGER ISEC0(2)
      INTEGER ISEC1(1024)
      INTEGER ISEC2(2048)
      INTEGER ISEC3(2)
      INTEGER ISEC4(1024)
      INTEGER INBUFF(JPACK), OUTGRIB(JPACK)
      INTEGER KPTS(1024)
      INTEGER NSIZE, OUTLEN
      INTEGER IRET, FILE1, FILE2
      INTEGER ILENB, LENOUT, IPUNP, IWORD, LOOP, LOOPO
      INTEGER NLON, NLAT, NPTS, NGAUSS, NLATLON
      INTEGER IFILEN, IOS, NARGS

C
      REAL ZSEC2(1024)
      REAL ZSEC3(2)
      REAL ZSEC4(JPACK*4)
      REAL USEC4(JPACK*4)

      LOGICAL ASCII
      CHARACTER*1 HTYPE
C
      REAL AREA(4), GRID(2), POLE(2), LATS(1000), LONS(1000)
      REAL PLATS(1024), REALV(4), DUMMY(1)
C
      CHARACTER*10 CHARV(1)
      CHARACTER*128 POINTS, INFILE, OUTFILE
C
      INTEGER  HRG2LL, HIRLSM, HSH2GG, INTOUT, INTF, IARGC
      EXTERNAL HRG2LL, HIRLSM, HSH2GG, INTOUT, INTF
C
C     Commented out for gfortran
C
CCC      EXTERNAL IARGC
C
C     Fix dummy grid step and Souh pole position
C
      DATA GRID/1.0,1.0/
      DATA POLE/-90.0,0.0/
C
C     -----------------------------------------------------------------|
C     Pick up the command line file names and open the files
C     -----------------------------------------------------------------|
C
      ASCII = .false.
      NARGS = IARGC()
      IF( NARGS.LT.3 ) THEN
        WRITE(*,*) ' '
        WRITE(*,*) 'Usage: singlePointInterpolation  llfile'
     X     ,'  infile  outfile a'
        WRITE(*,*) ' '
        WRITE(*,*) '  latlonfile is a list of latitude/longitude values'
        WRITE(*,*) ' '
        WRITE(*,*) '  inpfile is a file of global GRIB fields'
        WRITE(*,*) ' '
        WRITE(*,*) '  outfile is a file of single-point GRIBs or ascii'
        WRITE(*,*) ' '
        WRITE(*,*) '  a optional ascii output'
        WRITE(*,*) ' '
        STOP 'FAIL'
      ENDIF
C
        CALL GETARG(1,POINTS)
        CALL GETARG(2,INFILE)
        CALL GETARG(3,OUTFILE)

         if(NARGS.eq.4) ASCII = .TRUE.

C
C     Open the input GRIB file
C
      IFILEN = INDEX(INFILE,' ') - 1
      CALL PBOPEN(FILE1, INFILE (1:IFILEN), "r", IRET)
      IF( IRET.NE.0 ) THEN
        WRITE(*, *) 'Return code from PBOPEN = ',IRET
        CALL PBCLOSE(FILE1, IRET)
        STOP 'Fault in PBOPEN for input file'
      ENDIF
C
C     Open the output file of single-point GRIBs
C
       IFILEN = INDEX(OUTFILE,' ') - 1
      IF(ASCII) THEN
       OPEN (UNIT=16,FILE=OUTFILE(1:IFILEN)//'.txt',STATUS='UNKNOWN',
     &          FORM='FORMATTED',IOSTAT=IOS)

            IF (IOS.EQ.0) THEN
                WRITE(*,*)'File:',OUTFILE(1:IFILEN),' opened'
            ELSE
               WRITE(*,*)'File:',OUTFILE(1:IFILEN),' not opened'
               WRITE(*,*)'Input/output status = ',IOS
               WRITE(*,*)'Program will stop'
               STOP
            END IF
      END IF

      CALL PBOPEN(FILE2, outfile, "w", IRET)
      IF( IRET.NE.0 ) THEN
        WRITE (*, *) 'Return code from PBOPEN = ',IRET
        STOP 'Fault in PBOPEN for output file'
      ENDIF
C
C     Open the file of lat/longs
C
      IFILEN = INDEX(POINTS,' ') - 1
      OPEN(UNIT=1,FILE=POINTS(1:IFILEN),STATUS='OLD'
     X ,FORM='FORMATTED',ERR=990)
C
C     Read the latitude/longitude pairs
C
      NLATLON = 0
      DO LOOP = 1, 1000
        READ(1,9000,ERR=980,END=110) LATS(LOOP), LONS(LOOP)
        IF( (LATS(LOOP).GT.90.0).OR.(LATS(LOOP).LT.-90.0) ) THEN
          WRITE (*, *) 'Latitude ',LOOP,' is faulty (',LATS(LOOP),')'
          STOP 'FAIL'
        ENDIF
c        WRITE (*,9000) LATS(LOOP), LONS(LOOP)
C
        IF( (LONS(LOOP).GT.360.0).OR.(LONS(LOOP).LT.-360.0) ) THEN
          WRITE (*, *) 'Longitude ',LOOP,' is faulty (',LONS(LOOP),')'
          STOP 'FAIL'
        ENDIF
C
        NLATLON = NLATLON + 1
C
      ENDDO
C
  110 CONTINUE
      CLOSE(UNIT=1)
      IF( NLATLON.LT.1 ) STOP 'No latitude/longitude pairs given'
C
      WRITE(*,*) 'Number of latitude/longitude pairs = ', NLATLON
C
C     -----------------------------------------------------------------|
C     Read the input GRIB fields one at a time and generate an
C     interpolated value at each latitude/longitude point.
C     -----------------------------------------------------------------|
C
  150 CONTINUE
C
C     Read next GRIB field.
C
      ILENB = JPACK*JPBYTES
      CALL PBGRIB(FILE1, INBUFF, ILENB, LENOUT, IRET )
      IF( IRET.LT.0 ) THEN
        IF( IRET.NE.-1 ) WRITE (*, *) 'Return code from PBGRIB = ',IRET
C
        IF( IRET.EQ.-1 ) THEN
          CALL PBCLOSE(FILE2, IRET)
          IF( IRET.LT.0 ) THEN
            WRITE(*, *) 'Return code from PBCLOSE = ',IRET
            WRITE(*, *) 'Fault in PBCLOSE for output file'
          ENDIF
C
          CALL PBCLOSE(FILE1, IRET)
          STOP 'Interpolation completed'
        ELSE
          CALL PBCLOSE(FILE1, IRET)
          STOP 'Fault in PBCLOSE for input file'
        ENDIF
      ENDIF
C
C     Unpack the GRIB message.
C
      ZSEC3(2) = MISSING_VALUE
      ISEC3(2) = NINT(ZSEC3(2))
      IRET  = 1
      IPUNP = JPACK * JPBYTES
      ILENB = (LENOUT + (JPBYTES-1))/JPBYTES
      CALL GRIBEX(ISEC0,ISEC1,ISEC2,ZSEC2,ISEC3,ZSEC3,ISEC4,
     X            ZSEC4,IPUNP,INBUFF,ILENB,IWORD,'D',IRET)
      IF( IRET.GT.0 ) THEN
        WRITE(*,*) 'GRIBEX return code = ',IRET
        STOP 'GRIBEX error in decoding'
      ENDIF
C
C     If the input GRIB field is spectral, convert to a suitable
C     gaussian grid before interpolation
C
      IF( ISEC2(1).EQ.50 ) THEN
C
        NGAUSS = 0
        HTYPE  = ''
        IRET = HSH2GG(0,0,ISEC2(2),NGAUSS,HTYPE,KPTS,PLATS,NSIZE)
        IF( IRET.NE.0 ) THEN
          WRITE(*,*) 'Failed to find suitable gaussian grid for the'
          WRITE(*,*) 'spectral input GRIB'
          STOP 'FAIL'
        ENDIF
C
        IRET = INTOUT('REDUCED',NGAUSS,REALV,CHARV)
        IF( IRET.NE.0 ) THEN
          WRITE(*,*) 'Failed to setup gaussian grid interpolation'
          STOP 'FAIL'
        ENDIF
C
        OUTLEN = JPACK
        IRET = INTF(INBUFF,ILENB,DUMMY,OUTGRIB,OUTLEN,DUMMY)
        IF( IRET.NE.0 ) THEN
          WRITE(*,*) 'Gaussian grid interpolation failed'
          STOP 'FAIL'
        ENDIF
C
C        Unpack the interpolated GRIB message.
C
         ZSEC3(2) = MISSING_VALUE
         ISEC3(2) = NINT(ZSEC3(2))
         IRET = 1
         IPUNP = JPACK * JPBYTES
         ILENB = (LENOUT + (JPBYTES-1))/JPBYTES
         CALL GRIBEX(ISEC0,ISEC1,ISEC2,ZSEC2,ISEC3,ZSEC3,ISEC4,
     X               ZSEC4,IPUNP,OUTGRIB,OUTLEN,IWORD,'D',IRET)
         IF( IRET.GT.0 ) THEN
           WRITE(*,*) 'GRIBEX return code = ',IRET
           STOP 'GRIBEX error in decoding'
         ENDIF
      ENDIF
C
C     Interpolate the gaussian field to lat/long
C
      NGAUSS = ISEC2(10)
      NPTS   = ISEC4(1)
C
C     Loop through the latitude/longitude points
C
      DO LOOPO = 1, NLATLON
        AREA(1) = LATS(LOOPO)
        AREA(2) = LONS(LOOPO)
        AREA(3) = LATS(LOOPO)
        AREA(4) = LONS(LOOPO)
C
        IRET = HIRLSM(.TRUE.,ZSEC4,NPTS,NGAUSS,AREA,POLE,GRID,USEC4,1,
     X                NLON,NLAT)
        IF( IRET.NE.0 )
     X    STOP 'Interpolation from gaussian grid to lat/lon grid failed'
C
      IF(ASCII) THEN
        WRITE (16,9001)LOOPO, LATS(LOOPO), LONS(LOOPO), USEC4(1)
      ENDIF
C       Repack the field and write to results file
C
        IRET = 1
        IPUNP = ISEC4(1)
        ILENB = JPACK
        DO LOOP = 1, ILENB
          INBUFF(LOOP) = 0
        ENDDO
C
C       Setup output GRIB header information
C
        ISEC2( 1) = 0
        ISEC2( 2) = 1
        ISEC2( 3) = 1
        ISEC2( 4) = NINT(LATS(LOOPO)*1000)
        ISEC2( 5) = NINT(LONS(LOOPO)*1000)
        ISEC2( 6) = 128
        ISEC2( 7) = NINT(LATS(LOOPO)*1000)
        ISEC2( 8) = NINT(LONS(LOOPO)*1000)
        ISEC2( 9) = 1000
        ISEC2(10) = 1000
        ISEC2(11) = 0
        ISEC2(12) = 0
        ISEC2(13) = 0
        ISEC2(14) = 0
        ISEC2(15) = 0
        ISEC2(16) = 0
        ISEC2(17) = 0
        ISEC2(18) = 0
        ISEC2(19) = 0
C
        ZSEC3(2) = MISSING_VALUE
        ISEC3(2) = NINT(ZSEC3(2))
C
        ISEC4( 1) = 1
C
        CALL GRIBEX(ISEC0,ISEC1,ISEC2,ZSEC2,ISEC3,ZSEC3,ISEC4,
     X              USEC4,IPUNP,INBUFF,ILENB,IWORD,'C',IRET)
        IF( IRET.GT.0 ) THEN
          WRITE(*,*) 'GRIBEX return code = ',IRET
          STOP 'GRIBEX error on packing'
        ENDIF
C
        LENOUT = ISEC0(1)
        CALL PBWRITE(FILE2, INBUFF, LENOUT, IRET)
        IF( IRET.LT.LENOUT ) THEN
          WRITE(*, *) 'Return code from PBWRITE = ',IRET
          STOP 'Fault in PBWRITE'
        ENDIF
C
      ENDDO
C
C     Go for next input GRIB field
C
      GOTO 150
C
C     -----------------------------------------------------------------|
C     Problem reports
C     -----------------------------------------------------------------|
C
  980 STOP 'READ error for lat/long file'
C
  990 STOP 'OPEN error for lat/long file'
C
9000  FORMAT(2(F8.2,1X))
9001  FORMAT(1x,i5,2x,2(F8.2,1X),f8.2)
      END

C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C


      SUBROUTINE PARVAL (KCSP,KNSP,HLINE,HPAR,KLPAR,HVAL,KLVAL)
C
C---->
C**** PARVAL - Extract next parameter and value pair.
C
C     Purpose.
C     --------
C
C         Get next parameter and value from line.
C
C**   Interface.
C     ----------
C
C         CALL PARVAL (KCSP,KNSP,HLINE,HPAR,KLPAR,HVAL,KLVAL)
C
C         INTEGER     K.
C         REAL        P.
C         LOGICAL     O.
C         CHARACTER   H.
C
C             Input Parameters.
C             -----------------
C
C                KCSP  = Current search start position
C                HLINE = Line being examined
C
C             Output Parameters.
C             -----------------
C
C                KNSP   = Next search position (for next call)
C                         It is set to zero if the last set of
C                         PARAMETER=VALUE pairs is found, and
C                         to -1 if further parameters and values
C                         are to be read from a continuation line.
C
C                KLPAR  = Length of parameter string
C
C                HPAR   = Parameter
C
C                KLVAL  = Length of value string
C
C                HVAL   = Value
C
C     Method.
C     -------
C
C          The separators / , = and " are found to identify
C          the parameters and values.
C
C     Externals.
C     ----------
C
C          RTB
C          REMSP
C          DELSP
C          REPCHR
C
C     Reference.
C     ----------
C
C          MARS User Guide for information on parameters and
C          value pairs.
C
C     Comments.
C     ---------
C
C          Routine contains sections 0-4 and section 9.
C
C     Author.
C     -------
C
C          J. Hennessy 16.04.85
C
C     Modifications.
C     --------------
C
C          J. Hennessy 08.04.86
C
C                "     15.09.86
C
C          J. Hennessy 03.07.90
C          Character variable HVAL made to agree in length with
C          that in calling routine.
C
C          J. Hennessy 23.11.90
C          Allow COMMENT values to include commas.
C
C          J. Hennessy 18.02.91
C          Adjust YLINE length to match HLINE. Allow for / in error
C          at start of list of parameters.
C
C          J. Hennessy 15.10.92
C          Check on input string length added.
C
C----<
C     ---------------------------------------------------------------
C
C
C*    Section 0 . Definition of variables.
C     ---------------------------------------------------------------
C
      IMPLICIT LOGICAL     ( L, O, G )
      IMPLICIT CHARACTER*8 ( C, H, Y )
      IMPLICIT INTEGER     ( I, J, K, M, N )
C
      PARAMETER (JPMAX=960)
C
      INTEGER RTB
C
      CHARACTER*(*) HLINE
      CHARACTER*8   HPAR
      CHARACTER*(*) HVAL
      CHARACTER*(JPMAX) YLINE
C
C     ---------------------------------------------------------------
C
C
C*    Section 1 . Set initial values.
C     ---------------------------------------------------------------
C
 1000 CONTINUE
C
C     Check length of input string.
C
      ILEN = LEN (HLINE)
      IF (ILEN.GT.JPMAX)
     C   THEN
             WRITE (*,9001) ILEN , JPMAX
             CALL ABORTX ('PARVAL')
         ENDIF
C
C     Set parameter and value to 'space' and their lengths to 0.
C
      HPAR  = ' '
      HVAL  = ' '
      KLPAR = 0
      KLVAL = 0
C
C
C
C*    Section 2 . Handle request from HELP facility.
C     ---------------------------------------------------------------
C
 2000 CONTINUE
C
C     First check if help is being requested by use of ?.
C
      IF (HLINE(KCSP:KCSP).EQ.'?')
     C     THEN
               HPAR  = '?'
               KLPAR = 1
               KNSP  = KCSP + 1
	       GO TO 9000
           ENDIF
C
C*     Go to section 9.
C
C     ---------------------------------------------------------------
C
C
C
C*    Section 3 . Tidy up input format a little.
C     ---------------------------------------------------------------
C
 3000 CONTINUE
C
C     Change any ' characters to " characters.
C
c--      CALL REPCHR (HLINE,'''','"')
C
C     Remove any spaces before or after / separators.
C
c--      CALL DELSP (HLINE)
C
C     ---------------------------------------------------------------
C
C
C
C*    Section 4 . Extract next parameter and its value.
C     ---------------------------------------------------------------
C
 4000 CONTINUE
C
C     Look for next '=' and ',' in line. Examine
C     the last character in the line. If this is a ',' a
C     continuation line will follow. Otherwise the last
C     PARAMETER=VALUE pair for the current command has been
C     read.
C
      II = INDEX (HLINE(KCSP:),'=')
      IJ = INDEX (HLINE(KCSP:),',')
      IK = RTB(HLINE)
      KNSP = 0
      IF (HLINE(IK:IK).EQ.',') KNSP = -1
C
      IF (II.EQ.0.AND.IJ.EQ.0)
C
C*    No = or , found. Go to section 9.
C
     C    THEN
C
C             Check that no entry with missing = has been made.
C             Set parameter and value to unrecognised string,
C
              IF (IK.GT.KCSP)
     C        THEN
                  HPAR = HLINE(KCSP:IK)
                  CALL REMSP (HPAR)
                  IF (HPAR(1:1).NE.' ')
     C                      THEN
                                HPAR = HLINE(KCSP:IK)
                                KLPAR = IK - KCSP + 1
                                HVAL = HLINE(KCSP:IK)
                                KLVAL = IK - KCSP + 1
                                KNSP = IK + 1
                            ENDIF
              ENDIF
C
              GO TO 9000
          ENDIF
C
      IF (II.EQ.0.AND.IJ.NE.0)
C
C*    , found but no = found. Check that no erroneous entry
C     has been made. Go to section 9.
C
     C     THEN
C
C              Check that no erroneous entry with missing =
C              exists.
C
               HPAR = HLINE(KCSP:KCSP+IJ-2)
               CALL REMSP (HPAR)
               IF (HPAR(1:1).NE.' ')
     C             THEN
                       KLPAR = RTB(HPAR)
                       HVAL = HPAR
                       KLVAL = KLPAR
                       KNSP = KCSP + IJ- 1
                   ENDIF
               GO TO 9000
           ENDIF
C
C     Extract parameter entry and its length.
C
      KLPAR = II - 1
      HPAR = HLINE(KCSP:KCSP+KLPAR-1)
C
C     Remove any leading/trailing spaces.
C
      IF (HPAR(1:1).EQ.' ') THEN
                               CALL REMSP(HPAR)
                               KLPAR = RTB (HPAR)
                           ENDIF
C
C     Find end of value entry. This can be a comma, space or
C     a full stop.
C     If none is found the remaining characters are taken as
C     the value, and treated as the last entry for this command.
C
      KCSP = KCSP + II
C
C     Remove any spaces between = and value.
C     Remove any / put at the start of a list of values.
C
      YLINE(1:) = HLINE(KCSP:)
      IF (YLINE(1:1).EQ.'/') YLINE(1:1) = ' '
      CALL REMSP (YLINE)
      HLINE (KCSP:) = YLINE
C
      II = INDEX(HLINE(KCSP:),',')
C
C     If the value is a character string it may contain a ",".
C     Currently only the COMMENT parameter in a CREATE command
C     can validly have an embedded , .
C
      CALL L2U1CR (HPAR)
      IF (HLINE(KCSP:KCSP).EQ.'"'.AND.HPAR(1:7).EQ.'COMMENT')
     C   THEN
	     ISTR = INDEX(HLINE(KCSP+1:),'"')
	     IF (ISTR.GE.II) II = ISTR + 2
         ENDIF
C
C     Extract value entry and length
C
      IF (II.EQ.0)
     C    THEN
              II = RTB (HLINE)
              IF (HLINE(II:II).EQ.'.') II = II - 1
              KLVAL = II - KCSP + 1
          ELSE
              KLVAL = II - 1
          ENDIF
C
C     Handle missing value (eg date=, entered) where length is 0.
C
      KNSP = KCSP + KLVAL + 1
C
      IF (KLVAL.GT.0)
     C   THEN
             HVAL = HLINE(KCSP:KCSP+KLVAL-1)
         ELSE
             HVAL = ' '
             KLVAL = 1
         ENDIF
C
C     ---------------------------------------------------------------
C
C
C
C*    Section 9. Return to calling routine.
C     ---------------------------------------------------------------
C
 9000 CONTINUE
C
 9001 FORMAT (1H ,'PARVAL : String length is ',I3,'. Maximum',
     C            ' allowed is ',I3,'.')
      RETURN
C
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      INTEGER FUNCTION IGDINS (KILATG, KINS, KOLATG, KONS, ONPOLE,
     1   OSPOLE, KNSIND, KNSDIST, KPR, KERR)
C
C---->
C**** *IGDINS*
C
C     PURPOSE
C     _______
C
C     Calculate the distances between points in an output latitude
C     array and its North and South neighbours in the input latitude
C     array.
C
C     INTERFACE
C     _________
C
C     IERR = IGDINS (KILATG, KINS, KOLATG, KONS, ONPOLE, OSPOLE,
C    1   KNSIND, KNSDIST, KPR, KERR)
C
C     Input parameters
C     ________________
C
C     KILATG     - The array of input latitudes.
C
C     KINS       - The number of points in the North-South direction
C                  in the input field.
C
C     KOLATG     - The array of output latitudes.
C
C     KONS       - The number of points in the North-South direction
C                  in the output field.
C
C     ONPOLE     - This variable will be true if the input field
C                  includes the most Northerly line of latitude for
C                  the field type. This means latitude 90 North for
C                  a regular field and the first line of a Gaussian
C                  field.
C
C     OSPOLE     - This variable will be true if the input field
C                  includes the most Southerly line of latitude for
C                  the field type. This means latitude 90 South for
C                  a regular field and the last line of a Gaussian
C                  field.
C
C     KPR        - The debug print switch.
C                  0  , No debugging output.
C                  1  , Produce debugging output.
C
C     KERR       - The error control flag.
C                  -ve, No error message. Return error code.
C                  0  , Hard failure with error message.
C                  +ve, Print error message. Return error code.
C
C     Output parameters
C     ________________
C
C     KNSIND     - This array will contain the array offsets of the
C                  North and South points in the input array required
C                  for interpolation.
C
C     KNSDIST    - This array will contain the distances to lines
C                  in input field from the associated lines of
C                  latitude in the output field.
C
C     Return value
C     ____________
C
C     The error indicator (INTEGER).
C
C     Error and Warning Return Values
C     _______________________________
C
C     24501 An output latitude was found that was outside the area
C           spanned by the input latitudes.
C
C     Common block usage
C     __________________
C
C     None
C
C     EXTERNALS
C     _________
C
C     INTLOG(R)    - Logs messages.
C
C     METHOD
C     ______
C
C     This routine will create the arrays of offsets and distance as
C     two arrays of length (2, Number of output latitudes).
C
C     If an input Gaussian grid includes the "polar" line and the
C     output field includes a line of latitude between this "polar"
C     line and the pole then the position of this "polar" Gaussian
C     line is assumed to be at the pole for that line of latitude only.
C
C     REFERENCE
C     _________
C
C     None
C
C     COMMENTS
C     ________
C
C     Program contains sections 0 to 2 and 9
C
C     AUTHOR
C     ______
C
C     K. Fielding      *ECMWF*      Oct 1993
C
C     MODIFICATIONS
C     _____________
C
C     None
C
C----<
C     _______________________________________________________
C
C
C*    Section 0. Definition of variables.
C     _______________________________________________________
C
C*    Prefix conventions for variable names
C
C     Logical      L (but not LP), global or common.
C                  O, dummy argument
C                  G, local variable
C                  LP, parameter.
C     Character    C, global or common.
C                  H, dummy argument
C                  Y (but not YP), local variable
C                  YP, parameter.
C     Integer      M and N, global or common.
C                  K, dummy argument
C                  I, local variable
C                  J (but not JP), loop control
C                  JP, parameter.
C     REAL         A to F and Q to X, global or common.
C                  P (but not PP), dummy argument
C                  Z, local variable
C                  PP, parameter.
C
C     Implicit statement to force declarations
C
      IMPLICIT NONE
C
#include "parim.h"
C
C     Dummy arguments
      LOGICAL ONPOLE, OSPOLE
      INTEGER KINS, KONS, KPR, KERR
      INTEGER KILATG (KINS), KOLATG (KONS)
      INTEGER KNSIND (2, KONS), KNSDIST (2, KONS)
C
C     Local variables
      INTEGER IBASE
      INTEGER JOUT, JINP
      INTEGER JPROUTINE
      PARAMETER (JPROUTINE = 24500)
C
C     _______________________________________________________
C
C*    Section 1. Initialisation
C     _______________________________________________________
C
  100 CONTINUE
C
      IF (KPR.GE.1) CALL INTLOG(JP_DEBUG,'IGDINS: Section 1.',JPQUIET)
C
      IGDINS = 0
C
      IF (KPR .GE. 1) THEN
        CALL INTLOG(JP_DEBUG,'IGDINS: Input parameters.',JPQUIET)
        CALL INTLOG(JP_DEBUG,'IGDINS: No.input fld lines = ',KINS)
        CALL INTLOG(JP_DEBUG,'IGDINS: No.output fld lines = ',KONS)
        CALL INTLOG(JP_DEBUG,'IGDINS: Input fld spread from ',KILATG(1))
        CALL INTLOG(JP_DEBUG,'IGDINS: to ', KILATG(KINS))
        CALL INTLOG(JP_DEBUG,'IGDINS: Outpt fld spread from ',KOLATG(1))
        CALL INTLOG(JP_DEBUG,'IGDINS: to ', KOLATG(KONS))
C
        IF ( ONPOLE ) THEN
          CALL INTLOG(JP_DEBUG,'IGDINS: N. pole in inpt field.',JPQUIET)
        ELSE
          CALL INTLOG(JP_DEBUG,'IGDINS: N.pole NOT in inpt fld',JPQUIET)
        ENDIF
C
        IF ( OSPOLE ) THEN
          CALL INTLOG(JP_DEBUG,'IGDINS: S. pole in inpt field.',JPQUIET)
        ELSE
          CALL INTLOG(JP_DEBUG,'IGDINS: S.pole NOT in inpt fld',JPQUIET)
        ENDIF
      ENDIF
C
C     _______________________________________________________
C
C*    Section 2. Select points along a line of meridian
C     _______________________________________________________
C
  200 CONTINUE
C
      IF (KPR.GE.1) CALL INTLOG(JP_DEBUG,'IGDINS: Section 2.',JPQUIET)
C
C     Last latitude found to be used as start of search
C     for next latitude
C
      IBASE = 1
C
      DO 220 JOUT = 1, KONS
C
C       Allow special code for points beyond North limit of
C       Gaussian grid which has all points up to pole
C
C       Sinisa remove check for pole - already exist in iagcntl
        IF (IBASE .EQ. 1 .AND. KOLATG(JOUT).GT.KILATG (1) ) THEN
C
          KNSIND (JP_I_N, JOUT) = 1
          KNSIND (JP_I_S, JOUT) = 2
          IBASE = 1
C
          KNSDIST (JP_I_N, JOUT) = JP90 - KOLATG (JOUT)
          KNSDIST (JP_I_S, JOUT) = KOLATG (JOUT) - KILATG (2)
C
          GO TO 220
C
        ENDIF
C
        DO 210 JINP = IBASE, KINS - 1
C
C         This test allows the exact match at both ends to be treated
C         correctly. Although the point is checked for equality at
C         both ends the first test will be used except for the South
C         Gaussian limit.
C
          IF (KOLATG (JOUT) .LE. KILATG (JINP) .AND.
     X         KOLATG (JOUT) .GE. KILATG (JINP + 1) ) THEN
C
            KNSIND (JP_I_N, JOUT) = JINP
            KNSIND (JP_I_S, JOUT) = JINP + 1
            IBASE = JINP
C
            KNSDIST (JP_I_N, JOUT) = KILATG (JINP) -
     X            KOLATG (JOUT)
            KNSDIST (JP_I_S, JOUT) = KOLATG (JOUT) -
     X            KILATG (JINP + 1)
C
            GO TO 220
C
          ENDIF
C
  210   CONTINUE
C
C       Allow special code for points beyond South limit of
C       Gaussian grid which has all points up to pole
C
C       Sinisa remove check for pole - already exist in iagcntl
        IF (KOLATG (JOUT) .LT. KILATG (KINS) ) THEN
C
          KNSIND (JP_I_N, JOUT) = KINS - 1
          KNSIND (JP_I_S, JOUT) = KINS
          IBASE = KINS
C
          KNSDIST (JP_I_N, JOUT) = KILATG (KINS - 1) -
     X         KOLATG (JOUT)
          KNSDIST (JP_I_S, JOUT) = KOLATG (JOUT) - JP90
C
        ELSE
C
          IGDINS = JPROUTINE + 1
          IF (KERR .GE. 0) THEN
            CALL INTLOGR(JP_ERROR,
     X        'IGDINS: Output lat. value ',REAL(KOLATG(JOUT))/PPMULT)
            CALL INTLOGR(JP_ERROR,
     X        'IGDINS: outside input range = ',REAL(KILATG(1))/PPMULT)
            CALL INTLOGR(JP_ERROR,
     X        'IGDINS: to ',REAL(KILATG(KINS))/PPMULT)
          ENDIF
C
          IF (KERR .EQ. 0) CALL INTLOGR(JP_FATAL,
     X      'IGDINS: Interpolation failing.',IGDINS)
C
          GO TO 900
C
        ENDIF
C
  220 CONTINUE
C
C
C     _______________________________________________________
C
C*    Section 9. Return to calling routine. Format statements
C     _______________________________________________________
C
  900 CONTINUE
C
      IF (KPR.GE.1) CALL INTLOG(JP_DEBUG,'IGDINS: Section 9.',JPQUIET)
C
      RETURN
      END

C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE ECDEF11( HFUNC, KSEC1, KGRIB, KLENG, KNSPT, KBITS,
     X                   KPR, KRET)
C
C---->
C**** ECDEF11
C
C     Purpose.
C     --------
C
C     GRIB coding/decoding of ECMWF local use definition 11.
C
C**   Interface.
C     ----------
C
C     CALL ECDEF11( HFUNC, KSEC1, KGRIB, KLENG, KNSPT, KBITS, KPR, KRET)
C
C
C     Input Parameters.
C     -----------------
C
C     HFUNC      - Requested function.
C                  'C' to code data.
C                  'D' to decode data.
C
C     KSEC1      - Array containing Grib Section 1 data.
C
C     KGRIB      - Array containing Grib coded data.
C
C     KLENG      - Length (words) of KGRIB.
C
C     KNSPT      - Bit number after which insertion/extraction starts.
C
C     KBITS      - Number of bits in computer word.
C
C     KPR        - Debug print switch.
C                  0  , No printout.
C                  >0 , Debug printout.
C
C     KRET       - Response to error indicator.
C                  0        , Abort if error encountered.
C                  Non-zero , Return to calling routine
C                             even if error encountered.
C
C     Output Parameters.
C     ------------------
C
C     KSEC1      - Array containing Grib Section 1 data.(Updated)
C
C     KGRIB      - Array containing Grib coded data.(Updated)
C
C     KNSPT      - Number of bit after last one inserted/extracted.
C                  (Updated)
C
C     KRET       - Return code.
C                  0   , No error encountered.
C                  2   , Error reported by routine INXBIT.
C
C
C     Method.
C     -------
C
C     Input data packed/unpacked in accordance with ECMWF usage of
C     local part of section 1 of Grib code, definition 11.
C
C
C     Externals.
C     ----------
C
C     INXBIT  - insert/extract bits
C     ABORTX  - abort the program
C     CSGNBT  - code a signed value
C     DSGNBT  - decode a signed value
C
C
C     Reference.
C     ----------
C
C     WMO Manual On Codes for Grib Code.
C
C
C     Comments.
C     ---------
C
#include "ecdef11.h"
C
C
C     Author.
C     -------
C
C     J.D.Chambers     ECMWF      February 1998
C
C
C     Modifications.
C     --------------
C
C     None
C
C
C----<
C     ------------------------------------------------------------------
C*    Section 0 . Definition of variables. Data statements.
C     ------------------------------------------------------------------
C
      IMPLICIT NONE
C
#include "grprs.h"
C
C     Parameters
C
      CHARACTER*1   HFUNC
      INTEGER KSEC1, KGRIB, KLENG, KNSPT, KBITS, KPR, KRET
      DIMENSION KGRIB(*)
      DIMENSION KSEC1(*)
C
C     Local variables
C
      INTEGER IRET, IZERO, JLOOP
C
      LOGICAL LENCODE, LDECODE
C
      DATA IZERO/0/
C
C     ------------------------------------------------------------------
C*    Section 1 . Set initial values.
C     ------------------------------------------------------------------
C
  100 CONTINUE
C
      IRET = KRET
      LENCODE = ( HFUNC .EQ. 'C' )
      LDECODE = .NOT. LENCODE
C
C     ------------------------------------------------------------------
C*    Section 2 . Handle data for analysis which used the supplementary
C                 data
C     ------------------------------------------------------------------
C
  200 CONTINUE
C
C     Octet 50: Class of analysis
C     Octet 51: Type of analysis
C     Two 8-bit fields.
C
      CALL INXBIT(KGRIB,KLENG,KNSPT,KSEC1(42),2,KBITS,8,HFUNC,KRET)
      IF (KRET.NE.0) THEN
        KRET = 2
        WRITE(GRPRSM,*) 'ECDEF11: Error reported by routine INXBIT:'
        IF( LENCODE ) THEN
          WRITE(GRPRSM,*) '      encoding section 1, elements 42 - 43.'
        ELSE
          WRITE(GRPRSM,*) '      decoding section 1, octets 50 - 51.'
        ENDIF
      ENDIF
C
C     Octets 52-53: Stream of analysis
C     One 16-bit field.
C
      CALL INXBIT(KGRIB,KLENG,KNSPT,KSEC1(44),1,KBITS,16,HFUNC,KRET)
      IF (KRET.NE.0) THEN
        KRET = 2
        WRITE(GRPRSM,*) 'ECDEF11: Error reported by routine INXBIT:'
        IF( LENCODE ) THEN
          WRITE(GRPRSM,*) '      encoding section 1, element 44.'
        ELSE
          WRITE(GRPRSM,*) '      decoding section 1, octets 52 - 53.'
        ENDIF
      ENDIF
C
C     Octets 54-57: Version number/experiment identifier of analysis
C     One 32-bit field.
C
      CALL INXBIT(KGRIB,KLENG,KNSPT,KSEC1(45),1,KBITS,32,HFUNC,KRET)
      IF (KRET.NE.0) THEN
        KRET = 2
        WRITE(GRPRSM,*) 'ECDEF11: Error reported by routine INXBIT:'
        IF( LENCODE ) THEN
          WRITE(GRPRSM,*) '      encoding section 1, element 45.'
        ELSE
          WRITE(GRPRSM,*) '      decoding section 1, octets 54 - 57.'
        ENDIF
      ENDIF
C
C     Octet 58: Year of analysis
C     Octet 59: Month of analysis
C     Octet 60: Day of analysis
C     Octet 61: Hour of analysis
C     Octet 62: Minute of analysis
C     Octet 63: Century of analysis
C     Octet 64: Originating centre of analysis
C     Octet 65: Sub-centre of analysis
C     Eight 8-bit fields.
C
      CALL INXBIT(KGRIB,KLENG,KNSPT,KSEC1(46),8,KBITS,8,HFUNC,KRET)
      IF (KRET.NE.0) THEN
        KRET = 2
        WRITE(GRPRSM,*) 'ECDEF11: Error reported by routine INXBIT:'
        IF( LENCODE ) THEN
          WRITE(GRPRSM,*) '      encoding section 1, elements 46 - 53.'
        ELSE
          WRITE(GRPRSM,*) '      decoding section 1, octets 58 - 65.'
        ENDIF
      ENDIF
C
C     Octets 66-72: Spare - set to zero.
C     Seven 8-bit fields.
C
      IF( LENCODE ) THEN
        DO 210 JLOOP = 1, 7
          CALL INXBIT(KGRIB,KLENG,KNSPT,IZERO,1,KBITS,8,HFUNC,KRET)
          IF (KRET.NE.0) THEN
            KRET = 2
            WRITE(GRPRSM,*) 'ECDEF11: Error reported by routine INXBIT:'
              WRITE(GRPRSM,*)
     X  '      encoding section 1, octets 66 - 72.'
          ENDIF
  210   CONTINUE
      ELSE
        KNSPT = KNSPT + (7*8)
      ENDIF
C
C     ------------------------------------------------------------------
C*    Section 9 . Abort/return to calling routine. Format statements.
C     ------------------------------------------------------------------
C
  900 CONTINUE
C
      IF( KPR.GE.1 ) THEN
        WRITE(GRPRSM,*) 'ECDEF11: Section 9.'
        WRITE(GRPRSM,*) '        Output values set, KNSPT = ', KNSPT
      ENDIF
C
C     Abort if requested to do so when an error has been encountered.
C
      IF (IRET.EQ.0.AND.KRET.NE.0) THEN
        CALL ABORTX ('ECDEF11')
      ELSE
        RETURN
      ENDIF
C
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE BUETD(KPT,KTDLEN,KTDLST,KDLEN,KDATA,KSEC3,
     1                 KVALS,VALUES,KELEM,KERR)
C
C**** *BUETD*
C
C
C     PURPOSE.
C     --------
C
C          EXPAND SECTION 3 OF BUFR MESSAGE.
C
C
C**   INTERFACE.
C     ----------
C
C          *CALL* *BUETD(KPT,KTDLEN,KTDLST,KDLEN,KDATA,KSEC3,
C                        KVALS,VALUES,KELEM,KERR)
C
C        INPUT :
C               *KPT*     -  POINTER TO KDATA ARRAY
C               *KTDLEN*  -  NUMBER OF DATA DESCRIPTORS IN SECTION 3
C               *KTDLST*  -  ARRAY CONTAINING DATA DESCRIPTORS IN SECTION 3
C               *KDLEN*   -  DIMENSION OF KDATA ARRAY
C               *KDATA*   -  ARRAY CONTAINING DATA NEEDED FOR DATA DESCRIPTOR
C                            EXPANSION
C               *KSEC3*   -  ARRAY CONTAINING SECTION 3 INFORMATION
C                            KSEC3( 1)-- LENGTH OF SECTION 3 (BYTES)
C                            KSEC3( 2)-- RESERVED
C                            KSEC3( 3)-- NUMBER OF SUBSETS
C                            KSEC3( 4)-- FLAG (DATA TYPE,DATA COMPRESSION)
C        OUTPUT :
C               *KERR*    -  RETURNED ERROR CODE
C
C     METHOD.
C     -------
C           DATA DESCRIPTOR TAKEN FROM KTDLST ARRAY ARE FULLY
C        EXPANDED USING DATA FROM KDATA ARRAY IF NEEDED.
C        ( DELAYED REPLICATION FACTORS ETC.)
C
C
C     EXTERNALS.
C     ----------
C
C          BUNEXS        - SET WORD AND BIT POINTERS AT THE BEGINING OF
C                          NEXT SECTION
C          BUNPCK        - UNPACKS BIT PATHERN
C          BUREP         - SOLVES REPLICATION PROBLEM
C          BUETDR        - SOLVES TABLE D REFERENCE
C          BUOPER        - PROCESS OPERATOR
C          BUEPWT        - UPDATES WORKING TABLE
C
C     REFERENCE.
C     ----------
C
C          NONE.
C
C     AUTHOR.
C     -------
C
C          M. DRAGOSAVAC    *ECMWF*       01/02/91.
C
C
C     MODIFICATIONS.
C     --------------
C
C          NONE.
C
C
      IMPLICIT LOGICAL(L,O,G), CHARACTER*8(C,H,Y)
C
C
#     include "parameter.F"
#     include "bcomunit.F"
#     include "bcmwork.F"
#     include "bcmbef.F"
#     include "bcmwt.F"
#     include "bcmwtc.F"
#     include "bcmel.F"
#     include "bcmoff.F"
C
      CHARACTER CWTEN*64,CWTU*24
C
#ifndef R_4
      REAL*8 VALUES(KVALS)
      REAL*8 RVIND
      REAL*8 EPS
#else
      REAL   VALUES(KVALS)
      REAL   RVIND
      REAL   EPS
#endif
C
      DIMENSION ISTACK(JELEM),IISTACK(JELEM)
      DIMENSION IMASK(8)
C
      DIMENSION KSEC3(JSEC3)
      DIMENSION KDATA(KDLEN),KTDLST(KTDLEN)
C
      DATA IMASK/1,2,4,8,16,32,64,128/
C     ------------------------------------------------------------------
C
C*          1.
C                --------------------------------------
 100  CONTINUE
C
      IF( KERR.NE.0 ) RETURN
C
      N = KSEC3(3)
C
C
C*          2.   EXPAND DATA DESCRIPTORS.
C                ------------------------
 200  CONTINUE
C
C
C*          2.1  SET EXPECTED NUMBER OF DATA DESCRIPTORS.
C                ----------------------------------------
C                AND INITIALIZE NUMBER OF DATA VALUES PER SUB-SET.
C                -------------------------------------------------
 210  CONTINUE
C
      J      = 0
      IF(OMULTI) THEN
         IF(NSUBSET.EQ.1) KPT    = 0
      ELSE
         KPT    = 0
      END IF
      NWT    = 0
      JMAX   = KTDLEN
      JMAXNEW=JMAX
C
      IF(KTDLEN.GT.JELEM) THEN
         WRITE(KNTN,*)  ' BUETD :'
         KERR=29
         CALL BUERR(KERR)
         RETURN
      END IF
C
C*          2.2  PUT DATA DESCRIPTORS IN STACK.
C                ------------------------------
 220  CONTINUE
C
      DO 221 JJ=1,JMAX
C
      ISTACK(JJ)=KTDLST(JJ)
      IISTACK(JJ)=ISTACK(JJ)
C
 221  CONTINUE
C
C*          2.2.1 CHECK IF IT IS SAME DATA DESCRIPTOR DESCRIOPTION.
C                 -------------------------------------------------
C                 TO MAKE MORE EFFICIENT DATA DESCRIPTOR DESCRIPTION
C                 EXPANSION, IN CASE THAT DELAYED REPLICATION FACTOR
C                 IS NOT PRESENT AND DATA DESCRIPTORS ARE THE SAME,
C                 PREVIOUS WORKING TABLE SHOULD BE USED. IT IS POSIBLE
C                 AT THIS PLACE IN THE FUTURE TO MAKE MORE SOPHISTICATED
C                 CONTROL.
C
C
      DO 222 JC=1,JMAX
C
      IF(ISTACK(JC).NE.NSTACK(JC)) THEN
C
C
         ODREPF=.FALSE.
C
C        SWAP CONTENT OF THE STACKS.
C
         DO 223 JJC=1,JMAX
         NSTACK(JJC)=ISTACK(JJC)
 223     CONTINUE
C
         NTDLEN = JMAX
         M=0
         NOLD=N
         NFCM=0
         MREL=0
         OMARKER=.FALSE.
         MBMP=0
         MBMPL=0
C
         GO TO 230
C
      END IF
C
 222  CONTINUE
C
C
C*    IF MARKER OPERATOR PRESENT EXPAND DESCRIPTORS AGAIN
C
      IF(OMARKER) THEN
         NTDLEN = JMAX
         M=0
         NOLD=N
         NFCM=0
         MREL=0
         OMARKER=.FALSE.
         MBMP=0
         MBMPL=0
         GO TO 230
      END IF
C
C*    RETURN IF DELAYED REPLICATION FACTOR IS NOT PRESENT.
C
      IF(JMAX.NE.NTDLEN) THEN
         M=0
         NOLD=N
         NFCM=0
         MREL=0
         OMARKER=.FALSE.
         NTDLEN=JMAX
         MBMP=0
         MBMPL=0
         GO TO 230
      END IF
C
      OB=.FALSE.
      IF(IAND(KSEC3(4),IMASK(7)).NE.0) OB=.TRUE.
      IF(.NOT.ODREPF) THEN
         IF(N.GT.NOLD) NOLD=N
         IF(OB.AND.NFCM.EQ.1)      GO TO 300
         IF(.NOT.OB.AND.NFCM.EQ.0) GO TO 300
      END IF
C
      M=0
      NOLD=N
      NFCM=0
      MREL=0
      OMARKER=.FALSE.
      NTDLEN=JMAX
      MBMP=0
      MBMPL=0
C
C     ------------------------------------------------------------------
C*          2.3  GET NEXT DESCRIPTOR FROM THE STACK.
C                -----------------------------------
 230  CONTINUE
C
      J   = J + 1
      IF(J.GT.JMAX) GO TO 270
C
      IDD = ISTACK(J)
      IF(IDD.EQ.0)  GO TO 230
C
      IF = IDD/100000
C
C     ------------------------------------------------------------------
C*          2.4  CHECK IF IT IS REPLICATION DESCRIPTOR.
C                --------------------------------------
 240  CONTINUE
C
      IF(IF.EQ.0) THEN
C
C*          2.6  ELEMENT DESCRIPTOR, SO UPDATE WORKING TABLE.
C                --------------------------------------------
 260     CONTINUE
C
            CALL BUEPWT(IDD,KERR)
            IF(KERR.GT.0) RETURN
C
      ELSEIF(IF.EQ.1) THEN
C
C*          2.4.1     SOLVE REPLICATION PROBLEM.
C                     --------------------------
C
         CALL BUREP(KPT,KDLEN,KDATA,J,JMAX,IDD,ISTACK,KERR)
         IF(KERR.GT.0) RETURN
         GO TO 230
C
      ELSEIF(IF.EQ.2) THEN
C
C
C*          2.5.3 PROCESS OPERATOR.
C                 -----------------
         CALL BUOPER(KPT,KDLEN,KDATA,J,IDD,ISTACK,KERR)
         IF(KERR.GT.0) RETURN
C
      ELSEIF(IF.EQ.3) THEN
C
C
C*          2.5.2 REPLACE BY LIST OF DESCRIPTORS FROM TABLE *D.
C                 ---------------------------------------------
         CALL BUETDR(J,JMAX,IDD,ISTACK,KERR)
         IF(KERR.GT.0) THEN
            DO 252 IQ=1,JELEM
            NSTACK(IQ)=0.
 252        CONTINUE
            RETURN
         END IF
      ELSE
         KERR=37
         CALL BUERR(KERR)
         RETURN
      END IF
C
      GO TO 230
C
C     ------------------------------------------------------------------
C*          2.7 RESOLVE MARKER OPERATOR.
C               ------------------------
 270  CONTINUE
C
      IF(OMARKER) THEN
         CALL BUEPMRK(KSEC3,KVALS,VALUES,KELEM,KERR)
         IF(KERR.GT.0) RETURN
      END IF
C
C     ------------------------------------------------------------------
C
C*          3. COLLECT  SUPPLEMENTARY ITEMS.
C              -----------------------------
 300  CONTINUE
C
      N08=0
      N07=0
      N40=0
      NDWINC=0
      NSCAM=0
      NSCAM07=0
      NDWINC07=0
      NFD=0

      DO I=1,100
      NAFDWA(I)=0
      END DO

C
      NFCM=0
      IF(OB) NFCM=1
C
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities
C granted to it by virtue of its status as an intergovernmental organisation
C nor does it submit to any jurisdiction.
C

      INTEGER FUNCTION INTIN( HPARN, INTV, REALV, CHARV)
C
C---->
C**** INTIN
C
C     Purpose
C     -------
C
C     Change input field parameters in common block.
C
C     Interface
C     ---------
C
C     Input
C     -----
C
C     HPARN - MARS parameter name.
C     INTV  - MARS parameter value(s) (Integer).
C     REALV - MARS parameter value(s) (Real).
C     CHARV - MARS parameter value(s) (Character).
C
C
C     Method
C     ------
C
C     Recognise MARS paramter and reset appropriate common
C     variable value(s).
C
C
C     Externals
C     ---------
C
C     JDEBUG   - Check if debug switched on.
C     IBASINI  - Check basic initialisation of common blocks is done.
C     CHEQUAL  - Compare two ASCII strings without regard to case.
C     INTLOG   - Log error message.
C     JMALLOC  - Dynamically allocate memory
C     JFREE    - Free dynamically allocated memory
C     GETENV   - Get value of an environment variable
C
C
C     Author
C     ------
C
C     J.D.Chambers       ECMWF        August 1994.
C
C----<
C
C     IMPLICIT NONE
C
C     Parameters
C
      INTEGER JPROUTINE
      PARAMETER (JPROUTINE = 28100)
C
C     Function arguments
C
      CHARACTER*(*) HPARN
      CHARACTER*(*) CHARV
      REAL REALV(*)
      INTEGER INTV(*)
C
#include "parim.h"
#include "nifld.common"
#include "nifld.extracommon"
#include "nofld.common"
#include "grfixed.h"
#include "current.h"
#include "intf.h"
C
C     Local variables
C
      INTEGER ITEMP, I, IRET, IGSIZE, IASIZE, IBLANK
      INTEGER NEWGRIB(1), OLDGRIB(1)
      POINTER( NIPNGRB, NEWGRIB )
      POINTER( NIPOGRB, OLDGRIB )
      LOGICAL LFOUND
      CHARACTER*256 OLDLSM, ISLDEFL
      CHARACTER*1 CTEMP
      CHARACTER*8 CTEMP8
C
C     Externals
C
#ifdef POINTER_64
      INTEGER*8 JMALLOC
#else
      INTEGER JMALLOC
#endif
      LOGICAL CHEQUAL, ISGGVALID
      EXTERNAL CHEQUAL, ISGGVALID, JMALLOC
C
      DATA ISLDEFL/'/home/ma/emos/data/islscp_old_lsm'/
      SAVE ISLDEFL
C
C     -----------------------------------------------------------------|
C     Section 1.   Initialise
C     -----------------------------------------------------------------|
C
  100 CONTINUE
C
      INTIN = 0
      LFOUND = .FALSE.
C
C     Check if debug turned on
      CALL JDEBUG()
C
C     Ensures basic initialisation of common blocks is done
      CALL IBASINI(0)
C
      CALL INTLOG(JP_DEBUG, 'INTIN: option = ' // HPARN ,JPQUIET)
C
C     -----------------------------------------------------------------|
C     Section 2.   Decode request
C     -----------------------------------------------------------------|
C
  200 CONTINUE
C
C     Input grid name.
C     Note: compared to INTIN('gridname'), no rotation is supported
C
      IF( CHEQUAL( HPARN, 1, 8, 'gridname') ) THEN
        CALL INTLOG(JP_DEBUG, 'INTIN: gridname = '//CHARV,JPQUIET)
        LFOUND = .TRUE.
C
C       Make sure we read a grid type and grid number from input
        I = MIN(8,LEN(CHARV))
        IF( 0.LT.INDEX(CHARV,CHAR(0)) ) I=MIN(I,INDEX(CHARV,CHAR(0))-1)
        IF( 0.LT.INDEX(CHARV,' '    ) ) I=MIN(I,INDEX(CHARV,' '    )-1)
        CTEMP8(1:8) = ' '
        CTEMP8 = CHARV(1:I)
        CTEMP = ' '
        ITEMP = 0
        IF(   .TRUE.   ) READ(CTEMP8,'(A1,I4)',ERR=203) CTEMP, ITEMP
  203   IF( ITEMP.EQ.0 ) READ(CTEMP8,'(A1,I3)',ERR=204) CTEMP, ITEMP
  204   IF( ITEMP.EQ.0 ) READ(CTEMP8,'(A1,I2)',ERR=205) CTEMP, ITEMP
  205   IF( ITEMP.EQ.0 ) READ(CTEMP8,'(A1,I1)',ERR=206) CTEMP, ITEMP
  206   IF( ITEMP.EQ.0 ) THEN
          PRINT *, "INTIN: Invalid gridname (interpreting CHARV)"
          PRINT *, "  CHARV='"//CHARV//"'"
          PRINT *, "  CTEMP8='"//CTEMP8//"'"
          PRINT *, "  CTEMP='"//CTEMP//"'"
          PRINT *, "  ITEMP=", ITEMP
          IRET   = JPROUTINE + 1
          INTIN  = IRET
          CALL INTLOG(JP_ERROR,
     X      'INTIN: Invalid gridname: '//TRIM(CTEMP8), JPQUIET)
          GOTO 900
        ENDIF
C
C       Make sure we have a valid grid type, following JGETGG
C       (possible results are [ROF], uppercase)
        IF(     CHEQUAL(CTEMP,1,1,'N') ) THEN
          CTEMP = 'R'
        ELSEIF( CHEQUAL(CTEMP,1,1,'O') ) THEN
          CTEMP = 'O'
        ELSEIF( CHEQUAL(CTEMP,1,1,'F') ) THEN
          CTEMP = 'F'
        ELSE
          IRET   = JPROUTINE + 2
          INTIN  = IRET
          CALL INTLOG(JP_ERROR,
     X      'INTIN: Invalid gridname: '//TRIM(CTEMP8)//
     X      ' (type "'//TRIM(CTEMP)//'" not recognized)', JPQUIET)
          GOTO 900
        ENDIF
C
C       Make sure we have a valid grid number
        IF( .NOT.ISGGVALID(CTEMP,ITEMP) ) THEN
          IRET   = JPROUTINE + 2
          INTIN  = IRET
          CALL INTLOG(JP_ERROR,
     X      'INTIN: Invalid grid: '//TRIM(CTEMP8)//
     X      ' (number not recognized)', JPQUIET)
          GOTO 900
        ENDIF
C
C       Generate output grid structure if necessary
        I = JPQUASI
        IF( CTEMP.EQ.'F' ) I = JPGAUSSIAN
        LCHANGE = (NIREPR .EQ.JPNOTYPE) .OR.
     X            (NIREPR .NE.I)        .OR.
     X            (NIGAUSO.NE.ITEMP)    .OR.
     X            (NIGAUSS.NE.ITEMP)    .OR.
     X            (HIGAUST.NE.CTEMP)
        IF( LCHANGE ) THEN
          CALL JGETGG( ITEMP, CTEMP, RIGAUSS, MILLEN, IRET)
          IF( IRET .NE. 0 ) THEN
            CALL INTLOG(JP_ERROR,
     X        'INTIN: JGETGG fail for NIGAUSS = ',ITEMP)
            INTIN = IRET
            GOTO 900
          ENDIF
        ENDIF
        NIGAUSO = ITEMP
        NIGAUSS = ITEMP
        HIGAUST = CTEMP
C
C       Compute first and last latlon grid points
        NIAREA(1) = INT( RIGAUSS(1) * PPMULT )
        NIAREA(2) = 0
        NIAREA(3) = INT( RIGAUSS(NIGAUSS*2) * PPMULT )
        NIAREA(4) = JP360 - JP360/MILLEN(NIGAUSS)
        NINS = NIGAUSS*2
        NIPCNT = 0
        DO I= 1, NIGAUSS*2
          NIPCNT = NIPCNT + MILLEN(I)
        ENDDO
C
C       Additional global state variables changes
        NIREPR = JPQUASI
        IF( CTEMP.EQ.'F' ) NIREPR = JPGAUSSIAN
        NIGRID(1:2) = 0
C
        GOTO 900
      ENDIF
C
C     Request ISLSCP processing
C
      IF( CHEQUAL( HPARN, 1, 6, 'islscp') ) THEN
        LFOUND = .TRUE.
        CALL INTLOG(JP_DEBUG, 'INTIN: islscp = ' // CHARV ,JPQUIET)
C
        IF( CHEQUAL( CHARV, 1, 3, 'off' ) ) THEN
          IF( LNIISCL ) THEN
            CALL JFREE(NIPOGRB)
            CALL JFREE(NIPNGRB)
            NIPOGRS = 0
            NIPNGRS = 0
          ENDIF
          LNIISCL = .FALSE.
          GOTO 900
        ENDIF
C
        LNIISCL = .TRUE.
C
C       Pick up the old land-sea mask GRIB product
C
        CALL GETENV('ISLSCP_OLD_LSM',OLDLSM)
        IBLANK = INDEX(OLDLSM, ' ')
        IF( IBLANK.LT.2 ) THEN
          IBLANK = INDEX(ISLDEFL, ' ') - 1
          OLDLSM(1:IBLANK) = ISLDEFL(1:IBLANK)
          IF( INTV(1).GT.0 ) THEN
            OLDLSM(IBLANK+1:IBLANK+2) = '_n'
            WRITE(CTEMP8,'(I3.3)') INTV(1)
            OLDLSM(IBLANK+3:IBLANK+5) = CTEMP8(1:3)
            IBLANK = IBLANK + 5
          ENDIF
        ENDIF
        CALL INTLOG(JP_DEBUG,
     X    'INTIN: old land-sea mask file name:',JPQUIET)
        CALL INTLOG(JP_DEBUG,'INTIN: ' // OLDLSM(1:IBLANK),JPQUIET)
C
        CALL PBOPEN(NISLSCP,OLDLSM,'r',IRET)
        IF( IRET.NE.0 ) THEN
          CALL INTLOG(JP_ERROR,
     X      'INTIN: Problem processing islscp option',JPQUIET)
          CALL INTLOG(JP_ERROR,
     X      'INTIN: PBOPEN fail for old land-sea mask file',IRET)
          CALL INTLOG(JP_ERROR,'INTIN: ' // OLDLSM(1:IBLANK),JPQUIET)
          INTIN = IRET
          GOTO 900
        ENDIF
C
        CALL PBSIZE(NISLSCP,IGSIZE)
        IF( IGSIZE.LE.0 ) THEN
          CALL INTLOG(JP_ERROR,
     X      'INTIN: Problem processing islscp option',JPQUIET)
          CALL INTLOG(JP_ERROR,
     X      'INTIN: PBSIZE fail new land-sea mask GRIB product',IGSIZE)
          INTIN = IGSIZE
          GOTO 900
        ENDIF
C
        IF( NIPOGRS.LT.IGSIZE ) THEN
          IF( NIPOGRB.NE.0 ) CALL JFREE(NIPOGRB)
          NIPOGRS = IGSIZE
          NIPOGRB = JMALLOC(NIPOGRS)
#ifdef hpR64
          NIPOGRB = NIPOGRB/(1024*1024*1024*4)
#endif
          IF( NIPOGRB.EQ.0 ) THEN
            CALL INTLOG(JP_ERROR,
     X        'INTIN: Problem processing islscp option',JPQUIET)
            CALL INTLOG(JP_ERROR,
     X        'INTIN: JMALLOC fail old land-sea mask GRIB',JPQUIET)
            INTIN = JPROUTINE + 2
            GOTO 900
          ENDIF
        ENDIF
C
        CALL PBGRIB(NISLSCP, OLDGRIB, IGSIZE, IASIZE, IRET)
        IF( (IRET.NE.0).OR.(IGSIZE.NE.IASIZE) ) THEN
          CALL INTLOG(JP_ERROR,
     X      'INTIN: Problem processing islscp option',JPQUIET)
          CALL INTLOG(JP_ERROR,
     X      'INTIN: PBREAD fail old land-sea mask GRIB',IRET)
          INTIN = IRET
          GOTO 900
        ENDIF
C
        CALL PBCLOSE(NISLSCP, IRET)
C
C       Pick up the new land-sea mask GRIB product
C
        IBLANK = INDEX(CHARV, ' ') - 1
        CALL INTLOG(JP_DEBUG,
     X    'INTIN: new land-sea mask file name:',JPQUIET)
        CALL INTLOG(JP_DEBUG,'INTIN: ' // CHARV,JPQUIET)
C
        CALL PBOPEN(NISLSCP,CHARV,'r',IRET)
        IF( IRET.NE.0 ) THEN
          CALL INTLOG(JP_ERROR,
     X      'INTIN: Problem processing islscp option',JPQUIET)
          CALL INTLOG(JP_ERROR,
     X      'INTIN: PBOPEN fail for new land-sea mask file',IRET)
          CALL INTLOG(JP_ERROR,'INTIN: ' // CHARV,JPQUIET)
          INTIN = IRET
          GOTO 900
        ENDIF
C
        CALL PBSIZE(NISLSCP,IGSIZE)
        IF( IGSIZE.LE.0 ) THEN
          CALL INTLOG(JP_ERROR,
     X      'INTIN: Problem processing islscp option',JPQUIET)
          CALL INTLOG(JP_ERROR,
     X      'INTIN: PBSIZE fail new land-sea mask GRIB product',IGSIZE)
          INTIN = IGSIZE
          GOTO 900
        ENDIF
C
        IF( NIPNGRS.LT.IGSIZE ) THEN
          IF( NIPNGRB.NE.0 ) CALL JFREE(NIPNGRB)
          NIPNGRS = IGSIZE
          NIPNGRB = JMALLOC(NIPNGRS)
#ifdef hpR64
          NIPNGRB = NIPNGRB/(1024*1024*1024*4)
#endif
          IF( NIPNGRB.EQ.0 ) THEN
            CALL INTLOG(JP_ERROR,
     X        'INTIN: Problem processing islscp option',JPQUIET)
            CALL INTLOG(JP_ERROR,
     X        'INTIN: JMALLOC fail new land-sea mask GRIB',JPQUIET)
            INTIN = JPROUTINE + 2
            GOTO 900
          ENDIF
        ENDIF
C
        CALL PBGRIB(NISLSCP, NEWGRIB, IGSIZE, IASIZE, IRET)
        IF( (IRET.NE.0).OR.(IGSIZE.NE.IASIZE) ) THEN
          CALL INTLOG(JP_ERROR,
     X      'INTIN: Problem processing islscp option',JPQUIET)
          CALL INTLOG(JP_ERROR,
     X      'INTIN: PBREAD fail new land-sea mask GRIB',IRET)
          INTIN = IRET
          GOTO 900
        ENDIF
C
        CALL PBCLOSE(NISLSCP, IRET)
        GOTO 900
C
      ENDIF
C
C     Input or reset value used for missing points in bitmapped field.
C
      IF( CHEQUAL( HPARN, 1, 12, 'missingvalue') ) THEN
        LFOUND = .TRUE.
        CALL INTLOG(JP_DEBUG,'INTIN: missingvalue = ' // CHARV ,JPQUIET)
        IF( CHEQUAL( CHARV, 1, 2, 'no') ) THEN
          IF( LIMISSV ) LCHANGE = .TRUE.
          LIMISSV = .FALSE.
          RMISSGV   = -55555.0
        ELSE
          IF( .NOT.LIMISSV ) LCHANGE = .TRUE.
          LIMISSV = .TRUE.
          RMISSGV = REALV(1)
        ENDIF
        CALL INTLOGR(JP_DEBUG,'INTIN: missingvalue = ',RMISSGV)
        GOTO 900
      ENDIF

C     missingval because can not be applied in Emos lib everywhere...
C
      IF( CHEQUAL( HPARN, 1, 10, 'missingval') ) THEN
        LFOUND = .TRUE.
        LIMISSV = .FALSE.
        CALL INTLOG(JP_DEBUG,'INTIN: missingval = ' // CHARV ,JPQUIET)
        IF( CHEQUAL( CHARV, 1, 2, 'no') ) THEN
          IF( LIMISSV ) LCHANGE = .TRUE.
          RMISSGV   = -55555.0
          LIMISSA = .FALSE.
        ELSE
          IF( .NOT.LIMISSV ) LCHANGE = .TRUE.
          LIMISSA = .TRUE.
          RMISSGV = REALV(1)
        ENDIF
        CALL INTLOGR(JP_DEBUG,'INTIN: missingval = ',RMISSGV)
        ISEC1(5) = 192
        GOTO 900
      ENDIF
C
C     Input uselsm.
C
      IF ( CHEQUAL( HPARN, 1, 6, 'uselsm') ) THEN
        LFOUND = .TRUE.
        CALL INTLOG(JP_DEBUG,'INTIN: uselsm = ' // CHARV ,JPQUIET)
        IF ( CHEQUAL( CHARV, 1, 2, 'no') ) THEN
          IF ( LSM ) THEN
            LCHANGE = .TRUE.
            LSMCHNG = .TRUE.
          ENDIF
          LSM = .FALSE.
        ELSE
          IF ( .NOT. LSM ) THEN
            LCHANGE = .TRUE.
            LSMCHNG = .TRUE.
          ENDIF
          LSM = .TRUE.
        ENDIF
        LSMSET = .TRUE.
        GOTO 900
      ENDIF
C
C     Input useprecip.
C
      IF ( CHEQUAL( HPARN, 1, 9, 'useprecip') ) THEN
        LFOUND = .TRUE.
        CALL INTLOG(JP_DEBUG,'INTIN: useprecip = ' // CHARV ,JPQUIET)
        IF ( CHEQUAL( CHARV, 1, 3, 'yes') ) THEN
          IF ( .NOT. LPREC ) LCHANGE = .TRUE.
          LPREC = .TRUE.
        ELSE
          IF ( LPREC ) LCHANGE = .TRUE.
          LPREC = .FALSE.
        ENDIF
        LPRECSET = .TRUE.
        GOTO 900
      ENDIF
C
C     Input usewind.
C
      IF ( CHEQUAL( HPARN, 1, 7, 'usewind') ) THEN
        LFOUND = .TRUE.
        CALL INTLOG(JP_DEBUG,'INTIN: usewind = ' // CHARV ,JPQUIET)
        IF ( CHEQUAL( CHARV, 1, 3, 'yes') ) THEN
          IF ( .NOT. LWIND ) LCHANGE = .TRUE.
          LWIND = .TRUE.
        ELSE
          IF ( LWIND ) LCHANGE = .TRUE.
          LWIND = .FALSE.
        ENDIF
        LWINDSET = .TRUE.
        GOTO 900
      ENDIF
C
C     Input parameter.
C
      IF ( CHEQUAL( HPARN, 1, 9, 'parameter') ) THEN
        LFOUND = .TRUE.
        CALL INTLOG(JP_DEBUG, 'INTIN: parameter = ',INTV(1))
        IF ( NIPARAM .NE. INTV(1) ) LCHANGE = .TRUE.
        NIPARAM = INTV(1)
        GOTO 900
      ENDIF
C
C     Input truncation.
C
      IF ( CHEQUAL( HPARN, 1, 10, 'truncation') ) THEN
        LFOUND = .TRUE.
        CALL INTLOG(JP_DEBUG, 'INTIN: truncation = ',INTV(1))
        IF ( NIREPR .NE. JPSPHERE)  THEN
          LCHANGE = .TRUE.
          NIGAUSS = 0
          NIGRID(1) = 0
          NIGRID(2) = 0
          NIAREA(1) = 0
          NIAREA(2) = 0
          NIAREA(3) = 0
          NIAREA(4) = 0
        ENDIF
        NIREPR = JPSPHERE
        IF ( NIRESO .NE. INTV(1) ) LCHANGE = .TRUE.
        NIRESO = INTV(1)
        GOTO 900
      ENDIF
C
C     Input reduced.
C
      IF( CHEQUAL( HPARN, 1,  7, 'reduced') ) THEN
        LFOUND = .TRUE.
C
C       (Check for changes to internal interp. request)
        LCHANGE = (NIGAUSS.NE.INTV(1))
C
        CALL INTLOG(JP_DEBUG, 'INTIN: '//TRIM(HPARN)//' = ',INTV(1))
        NIGAUSS = INTV(1)
        LNIGAUS = .TRUE.
        IF ( NIREPR .NE. JPQUASI ) THEN
          LCHANGE = .TRUE.
          NIRESO = 0
          NIGRID(1) = 0
          NIGRID(2) = 0
        ENDIF
        NIREPR = JPQUASI
        IF( (NIGAUSO.NE.NIGAUSS) .OR. (HIGAUST.EQ.'O')
     X      .OR. ((HIGAUST.NE.'R') .AND. (HIGAUST.NE.'O')) ) THEN
          CTEMP = 'R'
          CALL JGETGG( NIGAUSS, CTEMP, RIGAUSS, MILLEN, IRET)
          IF ( IRET .NE. 0 ) THEN
            CALL INTLOG(JP_ERROR,
     X        'INTIN: JGETGG fail for NIGAUSS = ',NIGAUSS)
            INTIN = IRET
            GOTO 900
          ENDIF
          NIGAUSO = NIGAUSS
          HIGAUST = CTEMP
        ENDIF
C
        NIAREA(1) = INT( RIGAUSS(1) * PPMULT )
        NIAREA(2) = 0
        NIAREA(3) = INT( RIGAUSS(NIGAUSS*2) * PPMULT )
c this gives different result from one in the grib header
        NIAREA(4) = JP360 - JP360/MILLEN(NIGAUSS)
C
        NINS = NIGAUSS*2 ! Added by D. Jokic Mar-2005;
        NIPCNT = 0
        DO I= 1, NIGAUSS*2
          NIPCNT = NIPCNT + MILLEN(I)
        ENDDO
        GOTO 900
      ENDIF
C
C     Input grid.
C
      IF ( CHEQUAL( HPARN, 1, 4, 'grid') ) THEN
        LFOUND = .TRUE.
        CALL INTLOGR(JP_DEBUG, 'INTIN: grid e-w = ',REALV(1))
        CALL INTLOGR(JP_DEBUG, 'INTIN: grid n-s = ',REALV(2))
        IF ( NIREPR .NE. JPREGULAR) THEN
          LCHANGE = .TRUE.
          NIGAUSS = 0
          NIRESO = 0
        ENDIF
        NIREPR = JPREGULAR
        DO I = 1, 2
          ITEMP = INT( REALV(I)*PPMULT)
          IF ( NIGRID(I) .NE. ITEMP ) LCHANGE = .TRUE.
          NIGRID(I) = ITEMP
        ENDDO
        GOTO 900
      ENDIF
C
C     Reduced lat-lon Input grid.
C
      IF ( CHEQUAL( HPARN, 1, 7, 'redu_ll') ) THEN
        LFOUND = .TRUE.
cs        CALL INTLOGR(JP_DEBUG, 'INTIN: reduced_ll e-w = ',REALV(1))
        CALL INTLOGR(JP_DEBUG, 'INTIN: reduced_ll n-s = ',REALV(2))
        IF ( NIREPR .NE. JPREGULAR) THEN
          LCHANGE = .TRUE.
          NIGAUSS = 0
          NIRESO = 0
        ENDIF
        NIREPR = JPREDLL
        NINS = INTV(1)
        DO I = 1, 2
          ITEMP = INT( REALV(I)*PPMULT)
          IF ( NIGRID(I) .NE. ITEMP ) LCHANGE = .TRUE.
          NIGRID(I) = ITEMP
        ENDDO
        GOTO 900
      ENDIF
C
      IF ( CHEQUAL( HPARN, 1, 5, 'ocean') ) THEN
        LFOUND = .TRUE.
        LOCEAN = .TRUE.
        CALL INTLOGR(JP_DEBUG, 'INTIN: Ocean field',JPQUIET)
        NIOCO3  = INTV(1)
        NIOCO4  = INTV(2)
        NIOCO4F = INTV(3)
        NIOCO3F = INTV(4)
        NIOCO4L = INTV(5)
        NIOCO3L = INTV(6)
        NIOIINC = INTV(7)
        NIOJINC = INTV(8)
        NIOIRGR = INTV(9)
        NIONOST = INTV(10)
        NICOORN = INTV(11)
        NIVCDEF = INTV(12)
        NILOCAL = 4
        GOTO 900
      ENDIF

      IF ( CHEQUAL( HPARN, 1, 5, 'local') ) THEN
        LFOUND = .TRUE.
        NILOCAL = INTV(1)
        CALL INTLOGR(JP_DEBUG, 'INTIN: Local settings',NILOCAL)
        GOTO 900
      ENDIF
c
      IF ( CHEQUAL( HPARN, 1, 6, 'matrix') ) THEN
        LFOUND = .TRUE.
        NIMATR = INTV(1)
        CALL INTLOGR(JP_DEBUG, 'INTIN: Matrix values',NIMATR)
        GOTO 900
      ENDIF
C
      IF ( CHEQUAL( HPARN, 1, 11, 'coord_ocean') ) THEN
        LFOUND = .TRUE.
        CALL INTLOGR(JP_DEBUG, 'INTIN: Ocean field grid Coordinate'
     X     ,JPQUIET)
        OCCOOR(1:NICOORN) = INTV(1:NICOORN)
        GOTO 900
      ENDIF
C
      IF ( CHEQUAL( HPARN, 1, 6, 'l_npts') ) THEN
        LFOUND = .TRUE.
        MILLEN(1:NINS) = INTV(1:NINS)
        CALL INTLOG(JP_DEBUG, 'INTIN: l_npts (#) = ',NINS)
        GOTO 900
      ENDIF
C
C     Input data format.
C
      IF ( CHEQUAL( HPARN, 1, 4, 'form') ) THEN
        LFOUND = .TRUE.
        CALL INTLOG(JP_DEBUG, 'INTIN: form = ' // CHARV ,JPQUIET)
        IF ( CHEQUAL( CHARV, 1, 4, 'grib') ) THEN
          IF ( NIFORM .EQ. 0 ) LCHANGE = .TRUE.
          NIFORM = 1
        ELSE
          IF ( NIFORM .EQ. 1 ) LCHANGE = .TRUE.
          NIFORM = 0
        ENDIF
        GOTO 900
      ENDIF
C
C     Number of points along latitude and longitude
C
      IF ( CHEQUAL( HPARN, 1, 4, 'npts') ) THEN
        LFOUND = .TRUE.
        CALL INTLOG(JP_DEBUG, 'INTIN: pts along latitude = ',INTV(1))
        CALL INTLOG(JP_DEBUG, 'INTIN: pts along longitude = ',INTV(2))
        NIWE = INTV(1)
        NINS = INTV(2)
        GOTO 900
      ENDIF

      IF( CHEQUAL( HPARN, 1, 8, 'accuracy') ) THEN
        LFOUND = .TRUE.
        CALL INTLOG(JP_DEBUG, 'INTIN: Inpu accuracy = ',INTV(1))
        NIACC = INTV(1)
        GOTO 900
      ENDIF
C
C     Input level.
C
      IF ( CHEQUAL( HPARN, 1, 5, 'level') ) THEN
        LFOUND = .TRUE.
        CALL INTLOG(JP_DEBUG, 'INTIN: level = ',INTV(1))
        IF ( NILEVEL .NE. INTV(1) ) LCHANGE = .TRUE.
        NILEVEL = INTV(1)
        GOTO 900
      ENDIF
C
C     Input Date.
C
      IF ( CHEQUAL( HPARN, 1, 4, 'date') ) THEN
        LFOUND = .TRUE.
        CALL INTLOG(JP_DEBUG, 'INTIN: Date = ',INTV(1))
        IF ( NIDATE .NE. INTV(1) ) LCHANGE = .TRUE.
        NIDATE = INTV(1)
        GOTO 900
      ENDIF
C
C     Input level type.
C
      IF ( CHEQUAL( HPARN, 1, 7, 'levtype') ) THEN
        LFOUND = .TRUE.
        CALL INTLOG(JP_DEBUG, 'INTIN: levtype = ',INTV(1))
        IF ( NILEVT .NE. INTV(1) ) LCHANGE = .TRUE.
        NILEVT  = INTV(1)
        GOTO 900
      ENDIF
C
C     Input table.
C
      IF ( CHEQUAL( HPARN, 1, 5, 'table') ) THEN
        LFOUND = .TRUE.
        CALL INTLOG(JP_DEBUG, 'INTIN: table = ',INTV(1))
        IF ( NITABLE .NE. INTV(1) ) LCHANGE = .TRUE.
        NITABLE = INTV(1)
        GOTO 900
      ENDIF
C
C     Input regular (gaussian).
C
      IF ( CHEQUAL( HPARN, 1, 7, 'regular') ) THEN
        LFOUND = .TRUE.
        CALL INTLOG(JP_DEBUG, 'INTIN: regular = ',INTV(1))
        NIREPR = JPGAUSSIAN
        IF ( NIGAUSS .NE. INTV(1) ) LCHANGE = .TRUE.
        NIGAUSS = INTV(1)
        LNIGAUS = .TRUE.
        IF ( NIREPR .NE. JPGAUSSIAN) THEN
          LCHANGE = .TRUE.
          NIRESO = 0
          NIGRID(1) = 0
          NIGRID(2) = 0
        ENDIF
        NIREPR = JPGAUSSIAN
        IF( (NIGAUSO.NE.NIGAUSS).OR.(HIGAUST.NE.'F') ) THEN
          CTEMP = 'F'
          CALL JGETGG(NIGAUSS,CTEMP,RIGAUSS,MILLEN,IRET)
          IF ( IRET .NE. 0 ) THEN
            CALL INTLOG(JP_ERROR,
     X        'INTIN: JGETGG fail for NIGAUSS',NIGAUSS)
            INTIN = IRET
            GOTO 900
          ENDIF
          NIGAUSO = NIGAUSS
          HIGAUST = CTEMP
        ENDIF
C
        NIAREA(1) = INT( RIGAUSS(1) * PPMULT )
        NIAREA(2) = 0
        NIAREA(3) = INT( RIGAUSS(NIGAUSS*2) * PPMULT )
        NIAREA(4) = JP360 - JP360/MILLEN(NIGAUSS)
C
        NIPCNT = 0
        DO I= 1, NIGAUSS*2
          NIPCNT = NIPCNT + MILLEN(I)
        ENDDO
        GOTO 900
      ENDIF
C
C     Input area.
C
      IF ( CHEQUAL( HPARN, 1, 4, 'area') ) THEN
        LFOUND = .TRUE.
        CALL INTLOGR(JP_DEBUG, 'INTIN: north = ',REALV(1))
        CALL INTLOGR(JP_DEBUG, 'INTIN: west  = ',REALV(2))
        CALL INTLOGR(JP_DEBUG, 'INTIN: south = ',REALV(3))
        CALL INTLOGR(JP_DEBUG, 'INTIN: east  = ',REALV(4))
        DO I = 1, 4
          ITEMP = INT( REALV(I)*PPMULT)
          IF ( NIAREA(I) .NE. ITEMP ) LCHANGE = .TRUE.
          NIAREA(I) = ITEMP
        ENDDO
        GOTO 900
      ENDIF
C
C     Input scan.
C
      IF ( CHEQUAL( HPARN, 1, 4, 'scan') ) THEN
        LFOUND = .TRUE.
        CALL INTLOG(JP_DEBUG, 'INTIN: scan = ',INTV(1))
        IF ( NISCNM .NE. INTV(1) ) LCHANGE = .TRUE.
        NISCNM = INTV(1)
        GOTO 900
      ENDIF
C
C     Input lsm_param.
C
      IF ( CHEQUAL( HPARN, 1, 9, 'lsm_param') ) THEN
        LFOUND = .TRUE.
        CALL INTLOG(JP_DEBUG,'INTIN: lsm_param = ' // CHARV ,JPQUIET)
        IF ( CHEQUAL( CHARV, 1, 3, 'yes') ) THEN
          IF ( .NOT. LSMPAR ) LCHANGE = .TRUE.
          LSMPAR = .TRUE.
        ELSE
          IF ( LSMPAR ) LCHANGE = .TRUE.
          LSMPAR = .FALSE.
        ENDIF
        LSMPARSET = .TRUE.
        GOTO 900
      ENDIF
C
C     Set of LSM - merging with grib_api
      IF ( CHEQUAL( HPARN, 1, 6, 'lsmset') ) THEN
        LFOUND = .TRUE.
        CALL INTLOG(JP_DEBUG,'INTIN: lsmset = ' // CHARV ,JPQUIET)
        IF ( CHEQUAL( CHARV, 1, 2, 'no') ) THEN
          IF ( LSM ) THEN
            LCHANGE = .TRUE.
            LSMCHNG = .TRUE.
          ENDIF
          LSM = .FALSE.
          LSMSET = .TRUE.
        ELSE
          IF ( .NOT. LSM ) THEN
            LCHANGE = .TRUE.
            LSMCHNG = .TRUE.
          ENDIF
          LSM = .TRUE.
          LSMSET = .FALSE.
        ENDIF
        GOTO 900
      ENDIF
C
C
C     Input user_regular_gaussian
C
C     (Ignore the call if the user_regular_gaussian value = 0.)
      IF ( CHEQUAL( HPARN, 1, 21, 'user_regular_gaussian') ) THEN
        LFOUND = .TRUE.
        IF ( NIREPR .NE. JPGAUSSIAN) THEN
          LCHANGE = .TRUE.
          NIRESO = 0
          NIGRID(1) = 0
          NIGRID(2) = 0
        ENDIF
        CALL INTLOG(JP_DEBUG,'INTIN: user_regular_gaussian = ',INTV(1))
        IF ( NIGAUSS .NE. INTV(1) ) LCHANGE = .TRUE.
        NIGAUSS = INTV(1)
        NIREPR  = JPGAUSSIAN
C
        MILLEN(1:NIGAUSS*2) = NOGAUSS*4
        NIGAUSO = NIGAUSS
        HIGAUST = 'U'
        LIGIVEP = .TRUE.
C
        GOTO 900
      ENDIF
C
C     Input user_reduced_gaussian
C     (Ignore the call if the user_reduced_gaussian value = 0.)
C
      IF ( CHEQUAL( HPARN, 1, 21, 'user_reduced_gaussian') ) THEN
        LFOUND = .TRUE.
        IF ( NIREPR .NE. JPQUASI ) THEN
          LCHANGE = .TRUE.
          NIRESO = 0
          NIGRID(1) = 0
          NIGRID(2) = 0
        ENDIF
        IF ( INTV(1) .EQ. 0 ) GOTO 900
        CALL INTLOG(JP_DEBUG,'INTIN: user_reduced_gaussian = ',INTV(1))
        IF ( NIGAUSS .NE. INTV(1) ) LCHANGE = .TRUE.
        NIGAUSS = INTV(1)
        NIREPR  = JPQUASI
        NIGAUSO = NIGAUSS
        HIGAUST = 'U'
        GOTO 900
      ENDIF
C
C     Input g_pnts loading from grib_api.
C
      IF ( CHEQUAL( HPARN, 1, 7, 'ga_pnts') ) THEN
        LFOUND = .TRUE.
        IF ( NIGAUSS .LE. 0 ) THEN
          IRET = JPROUTINE + 2
          CALL INTLOG(JP_ERROR,
     X      'INTIN: Impossible number of gaussian latitudes.',NIGAUSS)
          INTIN = IRET
          GOTO 900
        ENDIF
          CALL INTLOG(JP_DEBUG,
     X      'INTIN: Reduced Gaussian - grib_api ',NIGAUSS)
C
cs        ILAST = NIGAUSS*2 + 1
        MILLEN(1:NIGAUSS*2) = INTV(1:NIGAUSS*2)
C
        NIAREA(4) = JP360 - INT( JP360/MILLEN(NIGAUSS) )
C
        NIPCNT = 0
        DO I= 1, NIGAUSS*2
          NIPCNT = NIPCNT + MILLEN(I)
        ENDDO
        NIGAUSO = NIGAUSS
        HIGAUST = 'U'
        LIGIVEP = .TRUE.
        GOTO 900
      ENDIF
cs end ga

      IF ( CHEQUAL( HPARN, 1, 6, 'g_pnts') ) THEN
        LFOUND = .TRUE.
        IF ( NIGAUSS .LE. 0 ) THEN
          IRET = JPROUTINE + 2
          CALL INTLOG(JP_ERROR,
     X      'INTIN: Impossible number of gaussian latitudes.',NIGAUSS)
          INTIN = IRET
          GOTO 900
        ENDIF
C
        DO I = 1, NIGAUSS
          MILLEN(I)                 = INTV(I)
          MILLEN(NIGAUSS*2 + 1 - I) = INTV(I)
        ENDDO
C
        NIAREA(4) = JP360 - INT( JP360/MILLEN(NIGAUSS) )
C
        NIPCNT = 0
        DO I = 1, NIGAUSS*2
          NIPCNT = NIPCNT + MILLEN(I)
        ENDDO
        NIGAUSO = NIGAUSS
        HIGAUST = 'U'
        LIGIVEP = .TRUE.
        GOTO 900
      ENDIF
C
C     Input g_lats.
C
      IF ( CHEQUAL( HPARN, 1, 6, 'g_lats') ) THEN
        LFOUND = .TRUE.
        IF ( NIGAUSS .LE. 0 ) THEN
          IRET  = JPROUTINE + 2
          CALL INTLOG(JP_ERROR,
     X      'INTIN: Impossible number of gaussian latitudes.',NIGAUSS)
          INTIN = IRET
          GOTO 900
        ENDIF
C
        DO I = 1, NIGAUSS
          RIGAUSS(I)                 =  REALV(I)
          RIGAUSS(NIGAUSS*2 + 1 - I) = -REALV(I)
        ENDDO
C
        NIAREA(1) = INT( RIGAUSS(1) * PPMULT )
        NIAREA(2) = 0
        NIAREA(3) = INT( RIGAUSS(NIGAUSS*2) * PPMULT )
        NIAREA(4) = JP360 - JP360/MILLEN(NIGAUSS)
        NIGAUSO = NIGAUSS
        HIGAUST = 'U'
        LIGIVEL   = .TRUE.
        GOTO 900
      ENDIF
C
C     -----------------------------------------------------------------|
C     Section 9.   Closedown.
C     -----------------------------------------------------------------|
C
  900 CONTINUE
      IF( .NOT. LFOUND ) THEN
        CALL INTLOG(JP_ERROR, 'INTIN: Unknown keyword used:', JPQUIET)
        CALL INTLOG(JP_ERROR, HPARN, JPQUIET)
        INTIN = JPROUTINE + 9
      ENDIF
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      INTEGER FUNCTION LOCAL2(KTABLE, KPARAM, KCENTR,
     X                        HFIRST, HSECOND, HTHIRD, HFOURTH)
C
C---->
C**** LOCAL2
C
C     Purpose
C     -------
C
C     Looks up the description of a parameter in known table 2 versions
C     for WMO code FM 92-X Ext. GRIB.
C
C
C     Interface
C     ---------
C
C     IRET = LOCAL2(KTABLE, KPARAM, KCENTR,
C                   HFIRST, HSECOND, HTHIRD, HFOURTH)
C
C     Input
C     -----
C
C     KTABLE - Local table 2 version number.
C     KPARAM - Parameter number.
C     KCENTR - Centre number.
C
C
C     Output
C     ------
C
C     HFIRST  - First line of descriptor:  MARS mnemonic
C     HSECOND - Second line of descriptor: Parameter description
C     HTHIRD  - Third line of descriptor:  Units for the parameter
C     HFOURTH - Fourth line of descriptor: Description of units
C
C     Function return value is
C            0 if no error detected.
C        20001 if no match found for the parameter number in
C              the given table.
C        20002 if there is an error opening the file holding
C              the given table.
C        20003 if there is an error finding an unused fortran unit
C              number for reading the table.
C
C
C     Method
C     ------
C
C     Checks if environment variable ECMWF_LOCAL_TABLE_PATH exists to
C     define the location of the parameter tables.
C
C     Otherwise, looks for table xxx in:
C       /home/ecmwf/emos_sms/tables/gribex/nnnnnn/local_table_2_version_xxx.
C     where nnnnnn is the current EMOSLIB version.
C
C     Entry for each parameter in table has the format (without quotes):
C        "......................"         Separator
C        "051"                            Paramter number
C        "MX2T24"                         MARS mnemonic
C        "Max 2m temp"                    Parameter description
C        "K"                              Units for the parameter
C        "During previous 24 hours"       Further description
C
C     There is a termination "......................" line in the file
C     and there may be lines of comment before the first parameter entry.
C
C     The parameter definition file is kept open between calls.
C
C
C     Externals
C     ---------
C     TAB2FIL - Builds code table 2 file name.
C
C
C     Author
C     ------
C
C     J.D.Chambers     ECMWF     Sept 1995
C
C
C     MODIFICATIONS
C     _____________
C
C     J. Clochard, Meteo France, for ECMWF - June 1999.
C     Argument KCENTR added for code tables management.
C     Use TAB2FIL function for file name building.
C
C     _______________________________________________________
C----<
C
C
      IMPLICIT NONE
C
C     Parameters
C
      INTEGER JPROUTINE
      PARAMETER ( JPROUTINE = 20000 )
C
C     Function arguments
C
      INTEGER KPARAM, KTABLE, KCENTR
      CHARACTER*(*) HFIRST, HSECOND, HTHIRD, HFOURTH
C
C     Local variables
C
      INTEGER IPR, IRET, ISTATUS, IPARAM, ITABLE
      CHARACTER*256 YFILE, YDUMMY
C
      INTEGER NOLDTAB, NUNIT
      SAVE NOLDTAB, NUNIT
C
C     External functions
C
      INTEGER TAB2FIL
      EXTERNAL TAB2FIL
C
      DATA NOLDTAB/-1/
C
C
C ------------------------------------------------------------------
C*    Section 1.   Initialise
C ------------------------------------------------------------------
C
  100 CONTINUE
C
      LOCAL2 = 0
C
C     Put phoney fields in return parameters
C
      HFIRST  = 'NONE'
      HSECOND = 'Undefined parameter'
      HTHIRD  = 'Undefined parameter'
      HFOURTH = 'Undefined parameter'
C
C     See if a new table is requested.
C
      IF( MAX( KTABLE, KPARAM) .LE. 127 ) THEN
        ITABLE = KTABLE
      ELSE
        ITABLE = 1000*KCENTR + KTABLE
      ENDIF
C
      IF( ITABLE.NE.NOLDTAB ) THEN
        IF( NOLDTAB.NE.-1 ) CLOSE(UNIT=NUNIT)
        NOLDTAB = ITABLE
C
C      Find an unused fortran unit number
C
        IPR = 0
        CALL FTN1CR(NUNIT, IPR, IRET)
        IF( IRET.NE.0 ) THEN
          LOCAL2 = JPROUTINE + 3
          RETURN
        ENDIF
C
C       Build filename
C
        IRET = TAB2FIL( KTABLE, KPARAM, KCENTR, YFILE )
C
C       Open file
C
        OPEN(UNIT=NUNIT, FILE=YFILE, ERR=910, IOSTAT=ISTATUS,
     X       STATUS='OLD',FORM='FORMATTED')
C
C     Otherwise, use the existing open parameter table file.
C
      ELSE
        REWIND NUNIT
      ENDIF
C
C ------------------------------------------------------------------
C*    Section 2.   Search for the parameter in the table.
C ------------------------------------------------------------------
C
  200 CONTINUE
C
C     Skip lines until '......................' separator found
C
  210 CONTINUE
      READ(NUNIT,'(A)',END=230) YDUMMY
      IF( YDUMMY(1:22).EQ.'......................') GOTO 225
      GOTO 210
C
C     Loop through file
C
  220 CONTINUE
        READ(NUNIT,'(A)',END=230) YDUMMY
  225 CONTINUE
        READ(NUNIT,'(I3.3)',END=230) IPARAM
        IF ( IPARAM .EQ. KPARAM ) THEN
          READ(NUNIT,'(A)',END=230) HFIRST
          READ(NUNIT,'(A)',END=230) HSECOND
          READ(NUNIT,'(A)',END=230) HTHIRD
          READ(NUNIT,'(A)',END=230) HFOURTH
          LOCAL2 = 0
          GOTO 900
        ELSE
          READ(NUNIT,'(A)',END=230) YDUMMY
          READ(NUNIT,'(A)',END=230) YDUMMY
          READ(NUNIT,'(A)',END=230) YDUMMY
          READ(NUNIT,'(A)',END=230) YDUMMY
        ENDIF
      GOTO 220
C
C     Dropthrough if no match found
C
 230  CONTINUE
      LOCAL2 = JPROUTINE + 1
      GOTO 900
C
C ------------------------------------------------------------------
C*    Section 9.   Closedown.
C ------------------------------------------------------------------
C
C     Error opening table file
C
 910  CONTINUE
      LOCAL2 = JPROUTINE + 2
      RETURN
C
C     Normal return.
C
 900  CONTINUE
C
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      CHARACTER*1 FUNCTION GGHTYPE(REPR,KNUM,KPTS)
C
C---->
C**** *GGHTYPE*
C
C     PURPOSE
C     _______
C
C     Return Gaussian grid type, from field representation, grid number
C     and array with the number of points at each latitude
C
C
C     Input parameters
C     ________________
C
C     KNUM - Gaussian grid number
C     REPR - Field representation, including:
C              Spherical harmonic
C              Regular Gaussian grid
C              Reduced Gaussian grid
C              Latitude/longitude grid
C     KPTS - Array giving number of points at each gaussian 
C            latitude, both hemispheres (pl array)
C
C
C     Output parameters
C     -----------------
C
C     Returns non-blank if format detected successfully, one of:
C       'R' for reduced ("quasi-regular"),
C       'O' for reduced/octahedral,
C       'F' for full,
C
C----<
      IMPLICIT NONE
#include "parim.h"


C     Arguments
      INTEGER REPR, KNUM, KPTS(*)


C     Local variables
      CHARACTER*1 F, R
      LOGICAL ISOCTAHEDRAL, ISGGVALID
      EXTERNAL ISOCTAHEDRAL, ISGGVALID
      F = 'F'
      R = 'R'


C     Check for validity of combinations (F|[RO]###)
      GGHTYPE = ' '
      IF( (REPR.EQ.JPGAUSSIAN.OR.REPR.EQ.JPFGGROT)
     .  .AND. ISGGVALID(F,KNUM) ) THEN
        GGHTYPE = F
      ELSEIF( (REPR.EQ.JPQUASI.OR.REPR.EQ.JPQGGROT.OR.REPR.EQ.JPSTRGG)
     .  .AND. ISGGVALID(R,KNUM) ) THEN
        GGHTYPE = R
        IF( ISOCTAHEDRAL(KNUM,KPTS) ) GGHTYPE='O'
      ENDIF

      ENDFUNCTION

C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

       PROGRAM CREX2BUFR
C
C**** *CREX2BUFR*
C
C
C     PURPOSE.
C     --------
C         Decode CREX coded data into BUFR format
C
C
C**   INTERFACE.
C     ----------
C
C          NONE.
C
C     METHOD.
C     -------
C
C          NONE.
C
C
C     EXTERNALS.
C     ----------
C
C
C     REFERENCE.
C     ----------
C
C          NONE.
C
C     AUTHOR.
C     -------
C
C          MILAN DRAGOSAVAC    *ECMWF*       07/01/2004.
C
C
C     MODIFICATIONS.
C     --------------
C
C          NONE.
C
C
      IMPLICIT LOGICAL(L,O,G), CHARACTER*8(C,H,Y)
C
      PARAMETER(JSUP =  9,JSEC0=   3,JSEC1= 40,JSEC2=4096,JSEC3=    4,
     1       JSEC4=   2,JELEM=320000,JSUBS=400,JCVAL=150 ,JBUFL=40000,
#ifdef JBPW_64
     2          JBPW =  64,JTAB =3000,JCTAB=120,JCTST=1800,JCTEXT=1200,
#else
     2          JBPW =  32,JTAB =3000,JCTAB=120,JCTST=1800,JCTEXT=1200,
#endif
     3          JWORK=4096000,JKEY=46,JBYTE=80000)
C
      PARAMETER (KELEM=40000)
      PARAMETER (KVALS=360000)
C 
      DIMENSION KBUFF(JBUFL),KBUFR(JBUFL)
      DIMENSION KSUP(JSUP)  ,KSEC0(JSEC0),KSEC1(JSEC1)
      DIMENSION KSEC2(JSEC2),KSEC3(JSEC3),KSEC4(JSEC4)
      DIMENSION KEY  (JKEY),KREQ(2)
C
      REAL*8 VALUES(KVALS), VALUE(KVALS)
      REAL*8 RVIND
      REAL*8 EPS
C
      DIMENSION KTDLST(KELEM),KTDEXP(KELEM),KTDLST1(KELEM)
      DIMENSION KDATA(2000)
C
      CHARACTER*256 CF,COUT,CARG(4)
      CHARACTER*64 CNAMES(KELEM)
      CHARACTER*24 CUNITS(KELEM)
      CHARACTER*80 CVALS(KVALS)
      CHARACTER*80 CVAL(KVALS),CV
      CHARACTER*80 YENC
      CHARACTER*160000 YBUFF
c
      EQUIVALENCE(YBUFF,KBUFF(1))
C                                                                       
C     ------------------------------------------------------------------
C*          1. INITIALIZE CONSTANTS AND VARIABLES.
C              -----------------------------------
 100  CONTINUE
C
      NBYTPW=JBPW/8
      RVIND=1.7D38
      NVIND=2147483647
      IOBS=0
      EPS=10.D-8
      N=0
      OCOMP=.FALSE.
      OO=.FALSE.
      CF=' '
      COUT=' '
      KKK=0
C
C     GET INPUT AND OUTPUT FILE NAME.
C
      NARG=IARGC()
c
      IF(NARG.NE.4) THEN
         print*,'Usage -- crex2bufr -i infile -o outfile' 
         STOP
      END IF
c
      DO 101 J=1,NARG
      CALL GETARG(J,CARG(J))
 101  CONTINUE
c
      IF(CARG(1).NE.'-i'.AND.CARG(1).NE.'-I'.OR.
     1   CARG(2).EQ.' ') THEN
         print*,'Usage -- crex2bufr -i inpfile -o outfile'
         STOP
      END IF
      IF(CARG(3).NE.'-o'.AND.CARG(3).NE.'-O'.OR.
     1   CARG(4).EQ.' ') THEN
         print*,'Usage -- crex2bufr -i inpfile -o outfile'
         STOP
      END IF
c
      CF=CARG(2)
      II=INDEX(CF,' ')
      II=II-1
      COUT=CARG(4)
      I=INDEX(COUT,' ')
      I=I-1
C
C*          1.2 OPEN FILE CONTAINING CREX DATA.
C               -------------------------------
 120  CONTINUE
C
      IRET=0 
      CALL PBOPEN(IUNIT,CF(1:II),'r',IRET)
      IF(IRET.EQ.-1) STOP 'open failed on input file'
      IF(IRET.EQ.-2) STOP 'Invalid file name'
      IF(IRET.EQ.-3) STOP 'Invalid open mode specified'
c
C
C*          1.2.1 OPEN OUTPUT FILE.
C               ------------------
 121  CONTINUE
C

      CALL PBOPEN(IUNIT1,COUT(1:I),'w',IRET)
      IF(IRET.EQ.-1) STOP 'open failed on output file'
      IF(IRET.EQ.-2) STOP 'Invalid output file name'
      IF(IRET.EQ.-3) STOP 'Invalid open mode specified'
C
C     ----------------------------------------------------------------- 
C*          2. SET REQUEST FOR EXPANSION.
C              --------------------------
 200  CONTINUE
C
      NR=1
      OPRT=.TRUE.
      OENC=.FALSE.
C
      OENC=.TRUE.

 210  CONTINUE
C
C
C     -----------------------------------------------------------------
C*          3.  READ CREX MESSAGE.
C               ------------------
 300  CONTINUE
C
      IERR=0
      IRET=0
c
      CALL PBCREX(IUNIT,KBUFF,JBUFL,KBUFL,IRET)
      IF(IRET.LT.0) THEN
         if(iret.eq.-1) stop 'End of file '
         if(iret.eq.-2) stop 'Error in handling the file'
         if(iret.eq.-3) stop 'Error during read CREX file.'
      END IF
c
      N=N+1
      print*,'----------------------------------',n
      IF(N.LT.NR) GO TO 300
      KEL=KELEM
C
C     -----------------------------------------------------------------
C*          4. EXPAND CREX MESSAGE.
C              --------------------
 400  CONTINUE
C
      IERR=0
      CALL CREXEX(KBUFL,YBUFF,KSUP,KSEC0 ,KSEC1,KSEC3 ,
     1            KEL,CNAMES,CUNITS,KVALS,VALUES,CVALS,IERR)
C
      IF(IERR.NE.0) then
         print*,'CREX error ', ierr
         IF(IERR.EQ.20.or.IERR.EQ.14) THEN
            KEL=KVALS/KSUP(6)
            GO TO 400
         ELSE
            CALL EXIT(2)
         END IF
      END IF
C
      
      IOBS=IOBS+KSEC3(3)
C
      ISUBSET=1
      CALL CREXSEL2(ISUBSET,KEL,KTDLEN,KTDLST,KTDEXL,KTDEXP,
     1              CNAMES,CUNITS,KERR)
      IF(KERR.NE.0) then
         print*,'CREXSEL: error.'
         CALL EXIT(2)
      END IF
C
C*          4.1 PRINT CONTENT OF EXPANDED DATA.
C               -------------------------------
 410  CONTINUE
C
      IF(.NOT.OPRT) GO TO 500
C
C*          4.2 PRINT SECTION ZERO OF CREX MESSAGE.
C               -----------------------------------
 420  CONTINUE
C

      CALL CREXPRS0(KSEC0)
C
C*          4.3 PRINT SECTION ONE OF CREX MESSAGE.
C               -----------------------------------
 430  CONTINUE
C
      CALL CREXPRS1(KSEC1,KSEC3,KTDLEN,KTDLST,KTDEXL,
     1              KTDEXP,KEL,CNAMES)
C
C
C
C*         4.6 PRINT SECTION 4 (DATA).
C              -----------------------
 460  CONTINUE
C
C          IN THE CASE OF MANY SUBSETS DEFINE RANGE OF SUBSETS
C
      IF(.NOT.OO) THEN
      WRITE(*,'(a,$)') ' STARTING SUBSET TO BE PRINTED : '
      READ(*,'(BN,I6)')   IST
      WRITE(*,'(a,$)') ' ENDING SUBSET TO BE PRINTED : '
      READ(*,'(BN,I6)')   IEND
      OO=.false.
      END IF
C
C              PRINT DATA
C
      ICODE=0
      CALL CREXPRT(ICODE,IST,KSEC3(3),KEL,CNAMES,CUNITS,CVALS,
     1           KVALS,VALUES,KSUP,KSEC1,IERR)
C
C
C     -----------------------------------------------------------------
C*          5. COLLECT DATA FOR REPACKING.
C              ---------------------------
 500  CONTINUE
C      
      IF(.NOT.OENC) GO TO 300
C
C               FIRST GET DATA DESCRIPTORS
C
      KK=0
      IST=1
      IEND=KSEC3(3)
C
      DO ISUBSET=IST, IEND


      CALL CREXSEL2(ISUBSET,KEL,KTDLEN,KTDLST,KTDEXL,KTDEXP,CNAMES,
     1            CUNITS,IERR)
      IF(KERR.NE.0) THEN
         print*,'CREXSEL: error ',kerr
         CALL EXIT(2)
      END IF
C
      JM1KELEM=(ISUBSET-1)*KEL
C
      DO 501 I=1,KTDEXL
         INV=I+JM1KELEM
         IN =I+JM1KELEM
C
         IF(CUNITS(I).EQ.'CHARACTER') THEN
            IPOS =VALUES(INV)/1000.
            ICH=NINT(VALUES(INV)-IPOS*1000)
            KKK=KKK+1
            VALUE(IN)=KKK*1000+ICH
            IF(CVALS(IPOS)(1:1).EQ.'/') THEN
               CV=' '
               DO II=1,ICH
               CV(II:II)=CHAR(255)
               END DO
               CVAL(KKK)=CV
            ELSE
              CVAL(KKK)=CVALS(IPOS)
            END IF
         ELSEIF(CUNITS(I)(1:2).EQ.'C '.AND.
     1     KTDEXP(I)/1000.eq.12 ) THEN
           VALUE(IN)=VALUES(INV)+273.15
         ELSEIF(CUNITS(I)(1:2).EQ.'NB'.AND.
     1     KTDEXP(I).EQ.015003) THEN
           VALUE(IN)=VALUES(INV)*0.0001
         ELSE
            VALUE(IN)=VALUES(INV)
         END IF
C
         IF(KTDEXP(I).EQ.31001.OR.KTDEXP(I).EQ.31002.OR.
     1      KTDEXP(I).EQ.31000) THEN
            KK=KK+1
            KDATA(KK)=NINT(VALUES(INV))
         END IF
 501  CONTINUE
C
      END DO
C
      KDLEN=2
      IF(KK.NE.0) KDLEN=KK

C     -----------------------------------------------------------------
C*          6. PACK BUFR MESSAGE.
C              -----------------
 600  CONTINUE
C
      KKK=0
C
      IF(KSEC0(3).LE.1) THEN
         KSEC0(3)=3              ! Edition 3  of bufr message
C
         KSEC1(1)=18
         KSEC1(2)=3              ! Bufr edition number
         KSEC1(3)=KSEC1(3)
         KSEC1(4)=1
         KSEC1(5)=0            ! presence od section 2
         KSEC1(7)=0
         KSEC1(8)=0            ! Bufr local tables version number
         KSEC1(9)=0
         KSEC1(10)=0
         KSEC1(11)=0
         KSEC1(12)=0
         KSEC1(13)=0
         KSEC1(14)=0
         KSEC1(15)=0           ! Bufr master table version number
c
         I_004001=0
         I_004002=0
         I_004003=0
         I_004004=0
         I_004005=0
c
         DO I=1,KTDEXL
         IF(KTDEXP(I).EQ.004001) THEN
            IF(I_004001.EQ.0) I_004001=I
         ELSEIF(KTDEXP(I).EQ.004002) THEN
            IF(I_004002.EQ.0) I_004002=I
         ELSEIF(KTDEXP(I).EQ.004003) THEN
            IF(I_004003.EQ.0) I_004003=I
         ELSEIF(KTDEXP(I).EQ.004004) THEN
            IF(I_004004.EQ.0) I_004004=I
         ELSEIF(KTDEXP(I).EQ.004005) THEN
            IF(I_004005.EQ.0) I_004005=I
         END IF
         END DO
c
         KSEC1(9)=NINT(VALUE(I_004001))-1900
         IF(NINT(VALUE(I_004001)).GE.2000) THEN
             KSEC1(9)=NINT(VALUE(I_004001))-2000
         END IF
         KSEC1(10)=NINT(VALUE(I_004002))
         KSEC1(11)=NINT(VALUE(I_004003))
         KSEC1(12)=NINT(VALUE(I_004004))
         KSEC1(13)=NINT(VALUE(I_004005))
c
         KSEC1(14)=0
         KSEC1(15)=13
         KSEC1(16)=0
      ELSEIF(KSEC0(3).EQ.2) THEN
         KSEC0(3)=4              ! Edition 4  of bufr message
c
         KSEC1(1)=22             ! The size of section 1
         KSEC1(2)=4
         KSEC1(3)=KSEC1(3)
         KSEC1(5)=0              ! presence od section 2
         KSEC1(9)=0
         KSEC1(10)=0
         KSEC1(11)=0
         KSEC1(12)=0
         KSEC1(13)=0
c
         I_004001=0
         I_004002=0
         I_004003=0
         I_004004=0
         I_004005=0
c
         DO I=1,KTDEXL
         IF(KTDEXP(I).EQ.004001) THEN
            IF(I_004001.EQ.0) I_004001=I
         ELSEIF(KTDEXP(I).EQ.004002) THEN
            IF(I_004002.EQ.0) I_004002=I
         ELSEIF(KTDEXP(I).EQ.004003) THEN
            IF(I_004003.EQ.0) I_004003=I
         ELSEIF(KTDEXP(I).EQ.004004) THEN
            IF(I_004004.EQ.0) I_004004=I
         ELSEIF(KTDEXP(I).EQ.004005) THEN
            IF(I_004005.EQ.0) I_004005=I
         END IF
         END DO
c
         KSEC1( 9)=NINT(VALUE(I_004001))
         KSEC1(10)=NINT(VALUE(I_004002))
         KSEC1(11)=NINT(VALUE(I_004003))
         KSEC1(12)=NINT(VALUE(I_004004))
         KSEC1(13)=NINT(VALUE(I_004005))
c
         KSEC1(14)=0         ! Bufr master table
         KSEC1(15)=KSEC1(17) ! Bufr master table version number
         KSEC1(16)=KSEC1(16) ! Originating sub-centre
         KSEC1(17)=KSEC1( 7) ! International sub-category
         KSEC1( 7)=0
         KSEC1(18)=0         ! Second
c
         
      END IF
c
      KSEC3(4)=192                    ! No compression
c
      KBUFL=JBUFL
C
C
C*          6.2 ENCODE DATA INTO BUFR MESSAGE.
C               ------------------------------
 620  CONTINUE
C
c              Modify descriptor list for delayed 
c              replication factor
c
      J=0
      DO I=1,KTDLEN
      IIF=KTDLST(I)/100000
      IF(IIF.EQ.1) THEN
         II=KTDLST(I)/1000
         IY=KTDLST(I)-II*1000
         IF(IY.EQ.0) THEN
           J=J+1
           KTDLST1(J)=KTDLST(I)
           J=J+1
           KTDLST1(J)=031002
         ELSE
           j=j+1
           KTDlst1(j)=KTDlst(i)
         END IF
      ELSE
         J=J+1
         KTDLST1(J)=KTDLST(I)
      END IF
      END DO
c
      KTDLEN=J
c 
      KERR=0
c     
      CALL BUFREN( KSEC0,KSEC1,KSEC2,KSEC3,KSEC4,
     1             KTDLEN,KTDLST1,KDLEN,KDATA,KEL,   
     2             KVALS,VALUE,CVAL,KBUFL,KBUFR,KERR)
C
      IF(KERR.gt.0) THEN
         print*,'error is ',kerr
         PRINT*,'ERROR DURING ENCODING.'
         CALL EXIT(2)
      END IF
C
C           6.3 WRITE PACKED BUFR MESSAGE INTO FILE.
C               ------------------------------------
 630  CONTINUE
C
      ILEN=KBUFL*NBYTPW
C     
      IERR=0
      CALL PBWRITE(IUNIT1,KBUFR,ILEN,IERR)
      if(ierr.lt.0) then
         print*,'Error writing into target file.'
         CALL EXIT(2)
      END IF
C
      GO TO 300
C     -----------------------------------------------------------------
C
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C
C
      COMMON /BCOMTABLOAD/ MTABBTR(JTAB,JTMAX),MTABBS (JTAB,JTMAX),
     1                MTABBRV(JTAB,JTMAX),
     1                MTABBDW(JTAB,JTMAX),MTABDTR(JTAB,JTMAX),
     2                MTABDST(JTAB,JTMAX),
     2                MTABDL (JTAB,JTMAX),MTABDSQ(JTAB*20,JTMAX),
     2                MTABP(JTCLAS,JTEL,JTMAX), NTC,NTT,
     3                MNREF(JCTAB,JTMAX),MNSTART(JCTAB,JTMAX),
     3                MNLEN(JCTAB,JTMAX),MNCODNUM(JCTST,JTMAX),
     3                MNSTARTC(JCTST,JTMAX),MNLENC(JCTST,JTMAX)
C     
C             MTABBTR    - TABLE B,  TABLE REFERENCE              ARRAY
C             MTABBS     - TABLE B,  SCALE                        ARRAY
C             MTABBRF    - TABLE B,  REFERENCE VALUE              ARRAY
C             MTABBDW    - TABLE B,  DATA WIDTH                   ARRAY
C             MTABDTR    - TABLE D,  TABLE REFERENCE              ARRAY
C             MTABDST    - TABLE D,  STARTING POINTERS            ARRAY
C             MTABDL     - TABLE D,  LENGTHS                      ARRAY
C             MTABDSQ    - TABLE D,  LIST OF SEQUENCE DESCRIPTORS ARRAY
C             NTT        - NUMBER OF TABLES
C             NTC        - CURRENT TABLE
C             MNREF      - TABLE C   REFERENCE NUMBER             ARRAY
C             MNSTART    - START OF CODES                         ARRAY
C             MNLEN      - NUMBER OF CODES                        ARRAY
C             MNSTARTC   - START OF TEXT                          ARRAY
C             MNLENC     - NUMBER OF CODE STRINGS                 ARRAY
C
C

C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      INTEGER FUNCTION IARMEM (KIMEM, KOMEM, KPR, KERR)
C
C---->
C**** *IARMEM*
C
C     PURPOSE
C     _______
C
C     This routine acquires heap space for expanded REAL fields.
C
C     INTERFACE
C     _________
C
C     IERR = IARMEM (KIMEM, KOMEM, KPR, KERR)
C
C     Input parameters
C     ________________
C
C     KIMEM      - Space required for input field.
C
C     KOMEM      - Space required for output field.
C
C     KPR        - The debug print switch.
C                  0  , No debugging output.
C                  1  , Produce debugging output.
C
C     KERR       - The error control flag.
C                  -ve, No error message. Return error code.
C                  0  , Hard failure with error message.
C                  +ve, Print error message. Return error code.
C
C     Output parameters
C     ________________
C
C     None
C
C     Return value
C     ____________
C
C     The error indicator (INTEGER).
C
C     Error and Warning Return Values
C     _______________________________
C
C     None
C
C     Common block usage
C     __________________
C
C     nifld.common - This file contains all the input field
C                    definition variables.
C
C     NINS         - Number of grid points in NS direction for input
C                    field (used in ouspace.h).
C     NIWE         - Number of grid points in WE direction for input
C                    field (used in ouspace.h).
C
C     nofld.common - This file contains all the output field
C                    definition variables.
C
C     NONS         - Number of grid points in NS direction for output
C                    field (used in ouspace.h).
C     NOWE         - Number of grid points in WE direction for output
C                    field (used in ouspace.h).
C
C     ouspace.h    - This file contains the work space array
C                    definitions for the arrays to hold the unpacked
C                    real data from GRIB fields.
C
C     NIFELD       - POINTER to array RIFELD.
C     NOFELD       - POINTER to array ROFELD.
C
C     RIFELD       - Dynamic array of length (NIWE * NINS)
C                    (see nifld.common) which holds the expanded
C                    input field.
C     ROFELD       - Dynamic array of length (NOWE * NONS)
C                    (see nofld.common) which holds the expanded
C                    output field.
C
C     EXTERNALS
C     _________
C
C     IGALLOC    - Get a heap allocation for array space.
C     INTLOG(R)    - Logs messages.
C
C     METHOD
C     ______
C
C     This routine calculates how much heap space is required. It
C     then calls IGALLOC to acquire the required space. Finally the
C     POINTERs to the arrays in ouspace.h are initialised to allow
C     the use of the dynamic arrays.
C
C     REFERENCE
C     _________
C
C     None
C
C     COMMENTS
C     ________
C
C     Program contains sections 0 to 3 and 9
C
C     AUTHOR
C     ______
C
C     K. Fielding      *ECMWF*      Apr 1994
C
C     MODIFICATIONS
C     _____________
C
C     None
C
C----<
C     _______________________________________________________
C
C
C*    Section 0. Definition of variables.
C     _______________________________________________________
C
C*    Prefix conventions for variable names
C
C     Logical      L (but not LP), global or common.
C                  O, dummy argument
C                  G, local variable
C                  LP, parameter.
C     Character    C, global or common.
C                  H, dummy argument
C                  Y (but not YP), local variable
C                  YP, parameter.
C     Integer      M and N, global or common.
C                  K, dummy argument
C                  I, local variable
C                  J (but not JP), loop control
C                  JP, parameter.
C     REAL         A to F and Q to X, global or common.
C                  P (but not PP), dummy argument
C                  Z, local variable
C                  PP, parameter.
C
C     Implicit statement to force declarations
C
      IMPLICIT NONE
C
#include "parim.h"
#include "nifld.common"
#include "nofld.common"
#include "ouspace.h"
C
C     Dummy arguments
      INTEGER KIMEM, KOMEM, KPR, KERR
C
C     Local variables
      INTEGER IBASE, IERR
      INTEGER JPROUTINE
      PARAMETER (JPROUTINE = 24100)
C
C     External functions
      INTEGER IGALLOC
C
C     _______________________________________________________
C
C*    Section 1. Initialisation
C     _______________________________________________________
C
  100 CONTINUE
C
      IF (KPR.GE.1) CALL INTLOG(JP_DEBUG,'IARMEM: Section 1.',JPQUIET)
C
      IARMEM = 0
C
      IF (KPR .GE. 1) THEN
        CALL INTLOG(JP_DEBUG,'IARMEM: Input parameters.',JPQUIET)
        CALL INTLOG(JP_DEBUG,'IARMEM: Input fld space = ',KIMEM)
        CALL INTLOG(JP_DEBUG,'IARMEM: Output fld space = ',KOMEM)
      ENDIF
C
C     _______________________________________________________
C
C*    Section 2. Calculate memory required and get heap
C     _______________________________________________________
C
  200 CONTINUE
C
      IF (KPR.GE.1) CALL INTLOG(JP_DEBUG,'IARMEM: Section 2.',JPQUIET)
C
C     Get the required memory
C
      IERR = IGALLOC (JPGRIB_SPACE, (KIMEM + KOMEM) * JPRLEN, IBASE,
     1   KPR, KERR)
C
      IF (IERR .GT. 0) THEN
         IARMEM = IERR
         GO TO 900
      ENDIF
C
C     _______________________________________________________
C
C
C*    Section 3. Initialise base addresses for POINTER arrays
C     _______________________________________________________
C
  300 CONTINUE
C
      IF (KPR.GE.1) CALL INTLOG(JP_DEBUG,'IARMEM: Section 3.',JPQUIET)
C
      NIFELD = IBASE
      NOFELD = NIFELD + KIMEM * JPRLEN
C
      IF (KPR .GE. 1) THEN
        CALL INTLOG(JP_DEBUG,'IARMEM: Output base addresses.',JPQUIET)
        CALL INTLOG(JP_DEBUG,'IARMEM: Input fld base address = ',NIFELD)
        CALL INTLOG(JP_DEBUG,'IARMEM: Output fld base address= ',NOFELD)
      ENDIF
C
C     _______________________________________________________
C
C
C*    Section 9. Return to calling routine. Format statements
C     _______________________________________________________
C
  900 CONTINUE
C
      IF (KPR.GE.1) CALL INTLOG(JP_DEBUG,'IARMEM: Section 9.',JPQUIET)
C
      RETURN
      END

       PROGRAM Msort
!
!
!**** *Msort*
!
!
!     Purpose.
!     --------
!
!           Sort input list in ascending order. Search the list
!           for requested value.
!
!**   Interface.
!     ----------
!
!
!     Method.
!     -------
!
!           A quick_sort method is used for sorting, and
!           Binary search is used for matching.
!
!
!     Externals.
!     ----------
!
!          NONE.
!
!     Reference.
!     ----------
!
!          Fortran 90 for Scientist & Engineers : Brian D. Hahn 1994
!
!     Author.
!     -------
!
!          M. Dragosavac    *ECMWF*       15/01/95.
!
!
!     Modifications.
!     --------------
!
!          NONE.
!------------------------------------------------------------------------------------------

       implicit none


       integer, parameter :: jsup =   9
       integer, parameter :: jsec0=   3
       integer, parameter :: jsec1=  40
       integer, parameter :: jsec2= 4096
       integer, parameter :: jsec3=   4
       integer, parameter :: jsec4=   2 
       integer, parameter :: jelem=160000
       integer, parameter :: jbufl=512000
#ifdef JBPW_64
       integer, parameter :: jbpw =  64
#else
       integer, parameter :: jbpw =  32
#endif
       integer, parameter :: jwork=4096000
       integer, parameter :: jkey=46
       integer, parameter :: jbyte=512000
       integer, parameter :: kelem=400
       integer, parameter :: kvals=400
       integer, parameter :: ill=48/(jbpw/8)+1
       
       integer, dimension(jbufl) :: kbuff, kbufr
       integer, dimension(jsup)  :: ksup
       integer, dimension(jsec0) :: ksec0
       integer, dimension(jsec1) :: ksec1
       integer, dimension(jsec2) :: ksec2
       integer, dimension(jsec3) :: ksec3
       integer, dimension(jsec4) :: ksec4
       integer, dimension(jkey)  :: key
       real*8,    dimension(kvals) :: values, value
       integer, dimension(kelem) :: ktdlst,ktdlst1
       integer, dimension(kelem) :: kdata


       integer, parameter :: nnn=100000         ! size of list
       integer, dimension(nnn,ill) :: list    ! list to be sorted
       integer i,j,n,is,iln,iz                 ! counter
       integer ipos, kval,ij,i1,id,ic

       integer narg,nvind,iy,ilen,kel,jx 
       integer ix,ilength , ktdlen, kdlen
       real*8    eps, rvind                              
       real      r                                        ! random number
       integer iunit,iunit1,iret,ierr,iword
       integer nbytpw,kbufl,ioff,istart,iargc

       character(256) cfin, cfout
       character(256), dimension(10)   :: carg
       character(64), dimension(kelem) :: cnames
       character(24), dimension(kelem) :: cunits
       character(80), dimension(kvals) :: cvals

       external bus012,pbbufr,pbwrite
!       external iargc,getarg



!     ----------------------------------------------------------
!     Get input and output file name.

      cfin=' '
      cfout=' '
      narg=iargc()

      if(narg < 4) then
         print*,'Usage -- bufr_merge -i inputfile -o outputfile'
         stop
      end if

      do  j=1,narg
      call getarg(j,carg(j))
      end do

      do j=1,narg,2
         if(carg(j) == '-i') then
            cfin=carg(j+1)
         elseif(carg(j) == '-o') then
            cfout=carg(j+1)
         else
             print*,'Usage -- bufr_merge -i inputfile -o outputfile'
             stop
         end if
      end do

!     Initialize variables and constants
!     ----------------------------------

      nbytpw=jbpw/8           ! number of bytes per word
      rvind=1.7E38            ! missing value indicator
      nvind=2147483647        ! missing value indicator
      n=0
      eps=10.E-10
      ktdlst1( 1)=301042      ! list of descriptors for merged satellite template
      ktdlst1( 2)=303031
      ktdlst1( 3)=303032
      ktdlst1( 4)=101015
      ktdlst1( 5)=303023
      ktdlst1( 6)=101003
      ktdlst1( 7)=303024
      ktdlst1( 8)=222000
      ktdlst1( 9)=101108
      ktdlst1(10)=031031
      ktdlst1(11)=001031
      ktdlst1(12)=001201
      ktdlst1(13)=101108
      ktdlst1(14)=033007
      ktdlen=14

      do i=1,400
         value(i)=rvind
      end do



!     Open input and output files
!     ---------------------------

      ic=index(cfin,' ')
      id=index(cfout,' ')
      iret=0
      call pbopen(iunit,cfin(1:ic),'r',iret)

      if(iret == -1) stop 'Open failed'
      if(iret == -2) stop 'Invalid input file name'
      if(iret == -3) stop 'Invalid open mode specified'

      call pbopen(iunit1,cfout(1:id),'w',iret)

      if(iret == -1) stop 'Open failed'
      if(iret == -2) stop 'Invalid output file name'
      if(iret == -3) stop 'Invalid open mode specified'

      iret=0




!     Read in bufr file and create list of RDB keys
!     ---------------------------------------------



      do while(iret >= 0)

         call pbbufr(iunit,kbuff,jbyte,kbufl,iret)
         if(iret == -1) exit  

         ierr=0
         ksec1(7)=0
         iword=kbufl/nbytpw+1
         call bus012(iword,kbuff,ksup,ksec0,ksec1,ksec2,ierr)
         if(ierr /= 0) then
             print*,'bus012 : ierr=',ierr
             call my_exit(2)
         end if
 
         is=ksec1(7)

         if(is >= 61 .and. is <= 63 .or. is >= 71 .and. is <= 73) then
 
            n=n+1
            if( n > nnn ) then
               print*,'Too many records to be merged.'
               print*,'Maximum is ',nnn
               call my_exit(2)
            end if

!           Get absolute record offset

            call pbseek(iunit,0,1,iln)
            if(iln < 0) then
                print*,'pbseek error :',ierr
                call my_exit(2)
            end if

            ksec2(1)=iln-kbufl      ! offset for record

            do iz=1,ill
            list(n,iz)=ksec2(iz)
            end do

         else

!           Write bufr message in output file
!           ---------------------------------

            iret=0
            call pbwrite(iunit1,kbuff,kbufl,iret)
            if(iret < 0) then
               print*,'Error writing into ',cfout
               call my_exit(2)
            end if


         end if

      end do


!     Make a quick sort of list array containing RDB keys
!     ---------------------------------------------------

      print*,n,' records to be sorted'


      call quick_sort(list,ill,1,n)

      print*,n,' records sorted'




!      Merge satellite data
!      --------------------



      i1=0
      i=1

      do while( i < n)
!
!        set data present indicator to present for all elements.
!
         i1=0

         do iy=1,327
           value(iy)=rvind
           if(iy >= 110 .and. iy <= 217) value(iy)=0.0
         end do
!

         do while (i1 == 0 )

!
           ioff=list(i,1)
!
           istart=0
           call pbseek(iunit,ioff,istart,iret)
           if(iret < 0) then
              print*,'pbseek: error ',iret
           end if
!
           iret=0
           call pbbufr(iunit,kbuff,jbyte,kbufl,iret)
           if(iret == -1) then
             print*,'pbbufr : error ',iret
             stop 'EOF'
           end if
           if(iret == -2) stop 'File handling problem'
           if(iret == -3) stop 'Array too small for product'

           iword=kbufl/nbytpw+1

           kel=kelem
           if(ksup(6) > 1)  kel=jwork/ksup(6)

           ierr=0
           call bufrex(iword,kbuff,ksup,ksec0 ,ksec1,ksec2 ,ksec3 , &
                       ksec4,kel,cnames,cunits,kvals,values,cvals,ierr)

           if(ierr /= 0)  then
              print*,'bufrex : error=',ierr
              call my_exit(2)
           end if

           if(ksec1(7) < 61 .or. ksec1(7) > 73) then
              print*,'subtype ',ksec1(7),' found for record ',n
              call my_exit(2)
           end if

!            5. Merge Satem or 250 km tovs.
!               ---------------------------

!          copy low level data

           if(ksec1(7) == 61 .or. ksec1(7) == 71) then
              jx=0
              do ix=1,63
                jx=jx+1
                value(jx)=values(ix)
              end do

!             copy data present indicator

              jx=109
              do ix=65,127
                jx=jx+1
                value(jx)=values(ix)
              end do

!             % confidence

              jx=219
              do ix=130,192
                jx=jx+1
                value(jx)=values(ix)
              end do

              value(109)=values(64)
              value(218)=values(128)
              value(219)=values(129)

           elseif(ksec1(7) == 62 .or. ksec1(7) == 72) then

!              copy precipitable water

              jx=0
              do ix=1,18
                jx=jx+1
                if(values(ix) /= rvind) value(jx)=values(ix)
              end do 

              jx=93
              do ix=19,33
                jx=jx+1
                value(jx)=values(ix)
              end do

!             copy data present indicator

              jx=109
              do ix=35,52
                jx=jx+1
                value(jx)=values(ix)
              end do

              jx=202
              do ix=53,67
                jx=jx+1
                value(jx)=values(ix)
              end do

!             copy % confidence

              jx=219
              do ix=70,87
                jx=jx+1
                value(jx)=values(ix)
              end do

              jx=312
              do ix=88,102
                jx=jx+1
                value(jx)=values(ix)
              end do

              value(109)=values(34)
              value(218)=values(68)
              value(219)=values(69)

           elseif(ksec1(7) == 63 .or. ksec1(7) == 73) then

!             copy high level data

              jx=0
              do ix=1,18
                jx=jx+1
                if(values(ix) /= rvind) value(jx)=values(ix)
              end do

              jx=63
              do ix=19,48
                jx=jx+1
                value(jx)=values(ix)
              end do

!             copy data present indicator

              jx=109
              do ix=50,67
                jx=jx+1
                value(jx)=values(ix)
              end do

              jx=172
              do ix=68,97
                jx=jx+1
                value(jx)=values(ix)
              end do

!             copy % confidence

              jx=219
              do ix=100,117
                jx=jx+1
                value(jx)=values(ix)
              end do

              jx=282
              do ix=118,147
                jx=jx+1
                value(jx)=values(ix)
              end do

              value(109)=values(49)
              value(218)=values(98)
              value(219)=values(99)
           else
              print*,'File contain other than satem/250 tovs data.'
              print*,'Subtype ',ksec1(7),' found.'
           end if


           i1=keycomp(list(i,1:ill),list(i+1,1:ill))
           
           if( i1 == 0) i=i+1

         end do

!            6. Pack merged bufr message
!               ------------------------

         ierr=0
         call buukey(ksec1,ksec2,key,ksup,ierr)
         if(ierr /= 0) then
            print*,'buukey : error ',ierr
            call my_exit(2)
         end if

         if(ksec1(7) >= 61 .and. ksec1(7) <= 63) key(3)=65
         if(ksec1(7) >= 71 .and. ksec1(7) <= 73) key(3)=75

         call bupkey(key,ksec1,ksec2,ierr)
         if(ierr /= 0) then
            print*,'bupkey : error ',ierr
            call my_exit(2)
         end if

         ksec1(7)=key(3)
         call bufren( ksec0,ksec1,ksec2,ksec3,ksec4,  & 
                      ktdlen,ktdlst1,kdlen,kdata,kel, & 
                      kvals,value,cvals,kbufl,kbufr,ierr)

         if(ierr > 0) then
            print*,'bufren : error ',ierr
            call my_exit(2)
         end if

!            7. Write merged message into target file
!               -------------------------------------

         ilength=kbufl*nbytpw

         ierr=0
         call pbwrite(iunit1,kbufr,ilength,ierr)
         if(ierr < 0) then
            print*,'Error writing into output file.'
            call my_exit(2)
         END IF

         i=i+1
         i1=0

      end do


       contains

       RECURSIVE SUBROUTINE QUICK_SORT(X,Y,L,R)
!
!
!**** *QUICK_SORT*
!
!
!     Purpose.
!     --------
!
!           Sort input list in ascending order.
!
!**   Interface.
!     ----------
!
!
!     Method.
!     -------
!
!           A quick_sort method is used for sorting.
!
!
!     Externals.
!     ----------
!
!          NONE.
!
!     Reference.
!     ----------
!
!          Fortran 90 for Scientist & Engineers : Brian D. Hahn 1994
!
!     Author.
!     -------
!
!          M. Dragosavac    *ECMWF*       15/01/95.
!
!
!     Modifications.
!     --------------
!
!          NONE.
!

       implicit none



      integer, dimension(:,:), intent(inout) :: x    ! list
      integer, intent(in)               :: l,r  ! left,right bounds
      integer, intent(in)               :: Y
      integer l1, r1
      integer icomp

      if( l<r) then
        l1=l
        r1=r

        icomp=keycomp(x(l1,1:Y),x(l,1:Y))
        do
          do while( l1 < r .and. (icomp ==2 .or. icomp == 0))  ! shift l1 right
             l1=l1+1
             icomp=keycomp(x(l1,1:Y),x(l,1:Y))
          end do

          icomp=keycomp(x(r1,1:Y),x(l,1:Y))
          do while ( l< r1 .and. (icomp ==1 .or. icomp == 0))  !  shift r1 left
             r1=r1-1
             icomp= keycomp(x(r1,1:Y),x(l,1:Y))
          end do

          if( l1<r1 ) call swop( x(l1,1:Y),x(r1,1:Y),Y)     ! swop
          if( l1>=r1) exit                        ! crossower_partition
          
        end do

        call swop( x(l,1:Y),x(r1,1:Y),Y)     ! partition with x(l) at r1
        call quick_sort( x,Y,l,r1-1)         ! now attack left subproblem
        call quick_sort( x,Y,r1+1,r)         ! don't forget right subproblem

      end if

      END SUBROUTINE QUICK_SORT

      SUBROUTINE SWOP(A,B,C)
!
!
!**** *SWOP*
!
!
!     Purpose.
!     --------
!
!           Swops content of two variables.
!        
!
!**   Interface.
!     ----------
!
!
!     Method.
!     -------
!
!           None.
!
!     Externals.
!     ----------
!
!          NONE.
!
!     Reference.
!     ----------
!
!          Fortran 90 for Scientist & Engineers : Brian D. Hahn 1994
!
!     Author.
!     -------
!
!          M. Dragosavac    *ECMWF*       15/01/95.
!
!
!     Modifications.
!     --------------
!
!          NONE.
!

      implicit none


#ifdef JBPW_64
      integer, parameter :: jbpw=64
#else
      integer, parameter :: jbpw=32
#endif
      integer, parameter :: ill=48/(jbpw/8)+1

      integer, dimension(:), intent(inout)   :: a,b
      integer, dimension(ill)    :: temp
      integer C

      do i=1,C


      temp(i) = a(i)
      a(i)=b(i)
      b(i)=temp(i)

      end do

      END SUBROUTINE SWOP

      SUBROUTINE SEARCH(KARRAY,K,KVAL,KINDEX)
!
!
!**** *SEARCH*
!
!
!     Purpose.
!     --------
!
!           Search an input  list for the requested value.
!
!**   Interface.
!     ----------
!
!
!     Method.
!     -------
!
!           Binary search is used for matching.
!
!
!     Externals.
!     ----------
!
!          NONE.
!
!     Reference.
!     ----------
!
!          Fortran 90 for Scientist & Engineers : Brian D. Hahn 1994
!
!     Author.
!     -------
!
!          M. Dragosavac    *ECMWF*       15/01/95.
!
!
!     Modifications.
!     --------------
!
!          NONE.
!

       implicit none



      integer, dimension (*)    :: karray
      integer k
      integer kval 
      integer kindex
      integer ihigh
      integer ilow
      integer i
      integer numbis
      integer count
      logical found
      integer mid

!         1.   Binary search. 

      count=0
      found=.false.
      kindex=0
      numbis= int(log(real(k))/log(2.0)) +1    

      ihigh = K+1
      ilow  = 1

      do while(.not.found .and.count /= numbis) 

            mid = (ihigh + ilow)/2
            if(karray(mid).eq.kval) then
               found=.true.
            elseif(kval .lt.karray(mid)) then
               ihigh= mid
            elseif(kval.gt.karray(mid)) then
               ilow= mid
            end if
            count=count+1
      end do

      if(found) kindex=mid

      END SUBROUTINE SEARCH


      INTEGER FUNCTION KEYCOMP(X,Y)

#ifdef JBPW_64
       integer, parameter    :: jbpw=64
#else
       integer, parameter    :: jbpw=32
#endif
       integer, parameter    :: ilast=32/(jbpw/8)
       integer, parameter    :: ifirst=(jbpw/8-2)*8-1
       integer, dimension(:) :: x 
       integer, dimension(:) :: y 
       integer  j,jj

       logical o1,o2


!      keycomp=0  two arrays are equal
!      keycomp=1  array X > array Y
!      keycomp=2  array Y > array X

       keycomp=0

       do j= ifirst,0,-1

       o1 = btest(x(2),j)
       o2 = btest(y(2),j) 

       if(o1.and..not.o2) then
          keycomp=1
          return
       elseif(.not. o1 .and. o2) then
          keycomp=2
          return
       end if
       end do

       if(keycomp.eq.0) then

          do jj=3,ilast

             do j=jbpw-1,0,-1  

             o1 = btest(x(jj),j)
             o2 = btest(y(jj),j)
   
             if(o1 .and. .not. o2) then

                keycomp=1
                return
             elseif(.not. o1 .and. o2) then
                keycomp=2
                return
             end if

             end do
          end do

       end if

       return
       end function
      END PROGRAM Msort

C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE MBUFR_MARS_FILTER(KSIZE,KREQUEST,KBUFL,
     1                             KBUFF,FOUND,KERR)
C
C**** *MBUFR_MARS_FILTER*
C
C
C     PURPOSE.
C     --------
C         FILTER BUFR MESSAGES FROM kbuff array
C         ACCORDING TO REQUEST and returning requested bufr message 
C         in kbuff array if repacking is not needed or kbufr otherwise.
C
C
C**   INTERFACE.
C     ----------
C
C          NONE.
C
C     METHOD.
C     -------
C
C
C     EXTERNALS.
C     ----------
C
C         CALL MBUSEL
C         CALL MBUFREX
C         CALL MBUFREN
C         CALL MBUPRS0
C         CALL MBUPRS1
C         CALL MBUPRS2
C         CALL MBUPRS3
C         CALL MBUPRT
C         CALL MBUUKEY
C
C     REFERENCE.
C     ----------
C
C          NONE.
C
C     AUTHOR.
C     -------
C
C          M. DRAGOSAVAC    *ECMWF*       12/09/2002
C
C
C     MODIFICATIONS.
C     --------------
C
C          NONE.
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
      PARAMETER(JSUP =   9,JSEC0=   3,JSEC1= 40,JSEC2=4096,JSEC3=   4,
     1          JSEC4=2,JELEM=160000,JSUBS=400,JCVAL=150 ,JBUFL=512000,
#ifdef JBPW_64
     2          JBPW =  64,JTAB =3000,JCTAB=3000,JCTST=3000,JCTEXT=6000,
#else
     2          JBPW =  32,JTAB =3000,JCTAB=3000,JCTST=3000,JCTEXT=6000,
#endif
     3          JWORK=4096000,JKEY=46, JTMAX=10,JTCLAS=64,JTEL=255)
C
      PARAMETER (KELEM=200)
      PARAMETER (KVALS=200000)
C 
      DIMENSION KBUFF(JBUFL)
      DIMENSION KSUP(JSUP)  ,KSEC0(JSEC0),KSEC1(JSEC1)
      DIMENSION KSEC2(JSEC2),KSEC3(JSEC3),KSEC4(JSEC4)
      DIMENSION KEY(JKEY),KEY1(JKEY),KEY2(JKEY)
      REAL*8 VALUES(KVALS)
      REAL*8 RQV(KELEM)
      REAL*8 RVIND
      REAL*8 EPS
      DIMENSION KTDLST(KELEM),KTDEXP(KELEM)
      DIMENSION KDATA(200)
      DIMENSION KREQ(2),KRQ(KELEM)
C
      CHARACTER*64 CNAMES(KELEM)
      CHARACTER*24 CUNITS(KELEM)
      CHARACTER*80 CVALS(KVALS)
      CHARACTER*9  CIDENTS
      LOGICAL      FOUND
      DIMENSION KREQUEST(KSIZE)
C                                                                       
C
C     ------------------------------------------------------------------
C*          1. GET FILE NAMES.
C              ---------------
 100  CONTINUE
C
      RVIND=1.7D38
      NBYTES=JBPW/8
      EPS=10.D-7
C
      
      KBUFL1=KBUFL/NBYTES+1
C
C
C     -----------------------------------------------------------------
C*          2.1 EXPAND BUFR MESSAGE SECTION 0,1,2
C               ---------------------------------
 210  CONTINUE
C
      IERR=0
      CALL BUS0123( KBUFL,KBUFF,KSUP,KSEC0,KSEC1,KSEC2,KSEC3,IERR)
      IF(KERR.NE.0) RETURN
C
      IF(KSEC3(3).EQ.1.OR.KSEC3(3).GT.1.AND.
     1   KSEC3(4).EQ.192.OR.KSEC3(4).EQ.64) THEN
C       Expand first 9 elements
         CALL BUSTOP(9)
      END IF

C            2.1.1  UNPACK KEY
C
C     CALL BUUKEY(KSEC1,KSEC2,KEY,KSUP,KERR)
C
C              PRINT KEY
C
C      CALL BUPRS2(KSUP ,KEY)
C
C----------------------------------------------------------------
C
C            2.3 MULTI-SUBSET MESSAGE
C
 230  CONTINUE
C
      IF(KSUP(6).GT.1)  THEN
         KEL=KVALS/KSUP(6)
         IF(KEL.GT.KELEM) KEL=KELEM
      ELSE
         KEL=KELEM
      END IF
C
      KREQ(1)=1
      KREQ(2)=2
      KRQ (1)=002048
      KRQ (2)=002019
      RQV (1)=RVIND
      RQV (2)=RVIND
      KRQL=2

      KERR=0
      CALL BUSRQ(KREQ,KRQL,KRQ,RQV,KERR)
      IF(KERR.NE.0) RETURN
C
      CALL BUFREX(KBUFL1,KBUFF,KSUP,KSEC0 ,KSEC1,KSEC2 ,KSEC3 ,KSEC4,
     1            KEL,CNAMES,CUNITS,KVALS,VALUES,CVALS,KERR)
C
      IF(KERR.NE.0) RETURN
C
C*          2.4 PRINT EXPANDED BUFR MESSAGE.
C               ----------------------------
 240  CONTINUE
C
C      CALL BUPRS0(KSEC0)
C      CALL BUPRS1(KSEC1)
C      CALL BUUKEY(KSEC1,KSEC2,KEY,KSUP,KERR)
C      CALL BUPRS2(KSUP ,KEY)
C
      CALL BUSEL(KTDLEN,KTDLST,KTDEXL,KTDEXP,KERR)
      IF(KERR.NE.0) RETURN
C
C      CALL BUPRS3(KSEC3,KTDLEN,KTDLST,KTDEXL,KTDEXP,KEL,CNAMES)
C      IST=1
C      IEND=KSUP(6)
C      CALL BUPRT(ICODE,IST,IEND,KEL,CNAMES,CUNITS,CVALS,
C     1           KVALS,VALUES,KSUP,KSEC1,IERR)
C
C
C
      i_002048=0
      i_002019=0
      DO I=1,KTDEXL
        IF(KTDEXP(i).EQ.002048) i_002048=i
        IF(KTDEXP(i).EQ.002019) i_002019=i
      END DO
C
      if(i_002048.ne.0) then
         do i=1,ksize
         if(krequest(i).eq.605) then
            krequest(i)=0
         elseif(krequest(i).eq.623) then
            krequest(i)=1
         elseif(krequest(i).eq.627) then
            krequest(i)=2
         elseif(krequest(i).eq.570) then
            krequest(i)=3
         elseif(krequest(i).eq.574) then
            krequest(i)=4
         elseif(krequest(i).eq.590) then
            krequest(i)=5
         elseif(krequest(i).eq.905) then
            krequest(i)=6
         elseif(krequest(i).eq.312) then
            krequest(i)=7
         elseif(krequest(i).eq.313) then
            krequest(i)=8
         elseif(krequest(i).eq.203) then
            krequest(i)=11
         end if
         end do
      end if
C
      FOUND=.FALSE.
C     
      if(i_002048.ne.0) then
         do i=1,ksize
           do j=1,ksec3(3)
             ij=i_002048+(j-1)*kel
             if(abs(values(ij)-rvind)/rvind.gt.eps) then
             if(nint(values(ij)).eq.krequest(i)) FOUND =.TRUE.
             end if
           end do 
         end do
      elseif(i_002019.ne.0) then
         do i=1,ksize
           do j=1,ksec3(3)
             ij=i_002019+(j-1)*kel
             if(abs(values(ij)-rvind)/rvind.gt.eps) then
             if(nint(values(ij)).eq.krequest(i)) FOUND =.TRUE.
             end if
           end do
         end do
      else
         FOUND =.FALSE.
      end if

C     -----------------------------------------------------------------
      KERR=0
C
      RETURN
C
C      
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities
C granted to it by virtue of its status as an intergovernmental organisation
C nor does it submit to any jurisdiction.
C

      SUBROUTINE ECDEF19(HFUNC,KSEC1,KGRIB,KLENG,KNSPT,KBITS,KRET)
C
C---->
C**** ECDEF19
C
C     Purpose.
C     --------
C     GRIB coding/decoding of ECMWF local use definition 19.
C
C     Interface.
C     ----------
C     CALL ECDEF19(HFUNC,KSEC1,KGRIB,KLENG,KNSPT,KBITS,KRET)
C
C
C     Input Parameters.
C     -----------------
C     HFUNC - Requested function.
C              'C' to code data.
C              'D' to decode data.
C     KSEC1 - Array containing Grib Section 1 data.
C     KGRIB - Array containing Grib coded data.
C     KLENG - Length (words) of KGRIB.
C     KNSPT - Bit number after which insertion/extraction starts.
C     KBITS - Number of bits in computer word.
C     KRET  - Response to error indicator.
C              0        , Abort if error encountered.
C              Non-zero , Return to calling routine
C                         even if error encountered.
C
C     Output Parameters.
C     ------------------
C     KSEC1 - Array containing Grib Section 1 data.(Updated)
C     KGRIB - Array containing Grib coded data.(Updated)
C     KNSPT - Number of bit after last one inserted/extracted.(Updated)
C     KRET  - Return code.
C              0   , No error encountered.
C              2   , Error reported by routine INXBIT.
C
C
C     Method.
C     -------
C     Input data packed/unpacked in accordance with ECMWF usage of
C     local part of section 1 of Grib code, definition 19.
C
C
C     Externals.
C     ----------
C     INXBIT
C     ABORTX
C
C
C     Reference.
C     ----------
C     WMO Manual On Codes for Grib Code.
C
C
C     Comments.
C     ---------
C     None
C
C
#include "ecdef19.h"
C
C     Author.
C     -------
C     J.D.Chambers     ECMWF       October 2002
C
C
C     Modifications.
C     --------------
C     None
C
C
C
C----<
C     ------------------------------------------------------------------
C*    Section 0 . Definition of variables. Data statements.
C     ------------------------------------------------------------------
C
      IMPLICIT NONE
C
#include "common/grprs.h"
C
C     Subroutine arguments
C
      CHARACTER*1   HFUNC
      INTEGER KSEC1, KGRIB, KLENG, KNSPT, KBITS, KRET
      DIMENSION KGRIB(*)
      DIMENSION KSEC1(*)
C
C     Local variables
C
      INTEGER IRET, IZERO, LENS1, INSPT, IPLEN, ILOOPO
CC    INTEGER NCLIMON, NEXT, ILOOPI, IFULL
C
      LOGICAL LENCODE
C
C     ------------------------------------------------------------------
C*    Section 1 . Set initial values.
C     ------------------------------------------------------------------
C
  100 CONTINUE
C
      IRET = KRET
      LENCODE = ( HFUNC.EQ.'C' )
      INSPT = KNSPT
C
C     Set bit pointer to start of GRIB section 1
C
      IPLEN = 8*8
C
C     ------------------------------------------------------------------
C*    Section 2 . Handle fixed part of definition 19.
C     ------------------------------------------------------------------
C
  200 CONTINUE
C
C     Octet 50 : Zero, for compatibility with MARS labelling
C
      IF ( LENCODE ) THEN
        IZERO = 0
        CALL INXBIT(KGRIB,KLENG,KNSPT,IZERO,1,KBITS,8,HFUNC,KRET)
        IF( KRET.NE.0 ) THEN
          KRET = 2
          WRITE(GRPRSM,9004)
        ENDIF
      ELSE
        CALL INXBIT(KGRIB,KLENG,KNSPT,KSEC1(42),1,KBITS,8,HFUNC,KRET)
        IF( KRET.NE.0 ) THEN
          KRET = 2
          WRITE(GRPRSM,9004)
        ENDIF
      ENDIF
C
C     Octet 51 : Ensemble size
C
      CALL INXBIT(KGRIB,KLENG,KNSPT,KSEC1(43),1,KBITS,8,HFUNC,KRET)
      IF( KRET.NE.0 ) THEN
        KRET = 2
        WRITE(GRPRSM,9004)
      ENDIF
C
C     Octet 52 : Power of 10 used to scale climate weight = F, say
C
      CALL INXBIT(KGRIB,KLENG,KNSPT,KSEC1(44),1,KBITS,8,HFUNC,KRET)
      IF( KRET.NE.0 ) THEN
        KRET = 2
        WRITE(GRPRSM,9004)
      ENDIF
C
C     Octets 53-56 : Climate weight * 10**F, stored as an integer
C
      CALL INXBIT(KGRIB,KLENG,KNSPT,KSEC1(45),1,KBITS,32,HFUNC,KRET)
      IF( KRET.NE.0 ) THEN
        KRET = 2
        WRITE(GRPRSM,9004)
      ENDIF
C
C     ------------------------------------------------------------------
C*    Section 3 . Handle climate month descriptions
C     ------------------------------------------------------------------
C
  300 CONTINUE
C
C     Octets 57-59 : First month used to build climate month 1, YYYYMM
C     Octets 60-62 : Last month used to build climate month 1, YYYYMM
C     Octets 63-65 : First month used to build climate month 2, YYYYMM
C     Octets 66-68 : Last month used to build climate month 2, YYYYMM
C
      CALL INXBIT(KGRIB,KLENG,KNSPT,KSEC1(46),1,KBITS,24,HFUNC,KRET)
        IF( KRET.NE.0 ) THEN
          KRET = 2
          WRITE(GRPRSM,9004)
        ENDIF
C
      CALL INXBIT(KGRIB,KLENG,KNSPT,KSEC1(47),1,KBITS,24,HFUNC,KRET)
        IF( KRET.NE.0 ) THEN
          KRET = 2
          WRITE(GRPRSM,9004)
        ENDIF
C
      CALL INXBIT(KGRIB,KLENG,KNSPT,KSEC1(48),1,KBITS,24,HFUNC,KRET)
        IF( KRET.NE.0 ) THEN
          KRET = 2
          WRITE(GRPRSM,9004)
        ENDIF
C
      CALL INXBIT(KGRIB,KLENG,KNSPT,KSEC1(49),1,KBITS,24,HFUNC,KRET)
        IF( KRET.NE.0 ) THEN
          KRET = 2
          WRITE(GRPRSM,9004)
        ENDIF
C
C     Handle padding for unused bytes
C
      IF( LENCODE ) THEN
        DO ILOOPO = 69, 80
          IZERO = 0
          CALL INXBIT(KGRIB,KLENG,KNSPT,IZERO,1,KBITS,8,HFUNC,KRET)
          IF( KRET.NE.0 ) THEN
            KRET = 2
            WRITE(GRPRSM,9004)
          ENDIF
        ENDDO
C
      ELSE
        KNSPT = KNSPT + 8*12
      ENDIF
C
C     ------------------------------------------------------------------
C*    Section 4 . Handle length of section 1
C     ------------------------------------------------------------------
C
  400 CONTINUE
C
      LENS1 = 80
C
      IF( LENCODE ) THEN
        CALL INXBIT(KGRIB,KLENG,IPLEN,LENS1,1,KBITS,24,HFUNC,KRET)
        IF( KRET.NE.0 ) THEN
          KRET = 2
          WRITE(GRPRSM,9004)
        ENDIF
C
      ELSE
C
C       If decoding, use length of section 1 to step KNSPT pointer
C       past section 1, past any padding slots if any.
C
        CALL INXBIT(KGRIB,KLENG,IPLEN,LENS1,1,KBITS,24,HFUNC,KRET)
        IF( KRET.NE.0 ) THEN
          KRET = 2
          WRITE(GRPRSM,9004)
        ENDIF
        KNSPT = 8*8 + LENS1*8
      ENDIF
C
C     ------------------------------------------------------------------
C*    Section 9 . Abort/return to calling routine. Format statements.
C     ------------------------------------------------------------------
C
  900 CONTINUE
C
C     Abort if requested to do so when an error has been encountered.
C
      IF( (IRET.EQ.0).AND.(KRET.NE.0) ) THEN
        CALL ABORTX ('ECDEF19')
      ELSE
        RETURN
      ENDIF
C
 9004 FORMAT (' ECDEF19: Error reported by routine INXBIT.')
C
      END

C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

       INTEGER FUNCTION C2ORDR ( KDATA, KLENP, KSEC1, KSEC2, KSEC3, 
     X                          KSEC4, KGRIB, KLENG, KNSPT, KBITS,
     X                          HOPER, KBMAP, KVALS, PREF,  PMAX,
     X                          KLEN,  KDEBUG )
C
C---->
C**** C2ORDR
C
C     Purpose.
C     --------
C
C     Encode GRIB section 4 for complex packing of grid-point
C     values ("second-order packing").
C
C
C**   Interface.
C     ----------
C
C     KRET = C2ORDR ( KDATA, KLENP, KSEC1, KSEC2, KSEC3, KSEC4,
C    X                KGRIB, KLENG, KNSPT, KBITS, HOPER, KBMAP,
C    X                KVALS, PREF,  PMAX , KLEN,  KDEBUG )
C
C
C     Input Parameters.
C     -----------------
C
C     KDATA      - Array of normalized values.
C     KLENP      - Length of array KDATA.
C     KSEC1      - Array of GRIB section 1 integer descriptors.
C     KSEC2      - Array of GRIB section 2 integer descriptors.
C     KSEC3      - Array of GRIB section 3 integer descriptors.
C     KSEC4      - Array of GRIB section 4 integer descriptors.
C     KLENG      - Length of GRIB product array.
C     KNSPT      - Bit pointer for next value in GRIB product.
C     KBITS      - Number of bits per computer word.
C     HOPER      - Requested function:
C                  'C' for coding, following input descriptors,
C                  'K' for "aggressive pacKing" (choose a solution
C                  that leads to minimum size).
C     KBMAP      - Bit pointer for start of explicit primary bit-map
C                  (if any).
C     KVALS      - Number of bits in primary bit-map.
C     PREF       - Reference of field.
C     PMAX       - Maximum value of field.
C     KLEN       - Exact number of points to handle.
C     KDEBUG     - >0 for some debug printout.
C
C
C     Output Parameters.
C     -----------------
C
C     KDATA      - Used (indirectly) as work array.
C     KSEC4      - Array of GRIB section 4 integer descriptors
C                  (updated).
C     KGRIB      - Array containing GRIB product.
C     KNSPT      - Bit pointer for next value in GRIB product
C                  (updated).
C
C
C     Method.
C     -------
C
C     Follows WMO Manual of Codes, and also CSECT4 structure.
C
C
C     If ordinary packing is requested (HOPER='C'), then the relevant
C     method described through KSEC4 descriptors is applied:
C
C     1) Row by row: KSEC4(9)=0, KSEC4(10)=16 and KSEC4(12)=0;
C
C     2) Constant width: KSEC4(9)=32, KSEC4(10)=0, KSEC4(12)=0,
C        width in KSEC4(11) -see "Comments" paragraph below, at the end.
C
C     3) General WMO 2nd-order: KSEC4(9)=32, KSEC4(10)=16, KSEC4(12)=0.
C
C     4) General extended  "  : KSEC4(9)=32, KSEC4(10)=16, KSEC4(12)=8.
C
C     For constant width and general methods, boustrophedonic ordering
C     is requested by KSEC4(13)=4, provided extensions have been
C     alllowed (disabled by default), and is explicitly inhibited
C     by KSEC4(13)=0.
C     Boustrophedonic ordering has no interest for row by row packing.
C     If explicitly requested a warning message is issued and option
C     set to off.
C
C     For the general extended method, a spatial differencing may be
C     requested through KSEC4(14) and/or KSEC4(15) different from zero:
C
C     -explicitly: KSEC4(14)=0 or 2, KSEC4(15)=0 or 1, order being then
C                  IORDER=KSEC4(14)+KSEC4(15) ;
C
C     -implicitly: KSEC4(14)=-1 and/or KSEC4(15)=-1; in such a case
C                  a diagnostic is performed to estimate which order
C                  should lead to minimaum size.
C
C
C     If aggressive packing (HOPER='K') is selected:
C
C     1) in a first scan, all allowed sub-functions (see Comments
C        below) are called to compute the length of section 4 they
C        would give, but no coding occurs;
C
C     2) in a second phase the most efficient method is applied.
C
C        If no "complex" method is efficient -or applicable-, then a
C        simple packing is performed.
C
C        If the field is constant, a simple packing  with 0 as number
C        of bits (and no data) is applied, without having to perform
C        the steps mentioned above.
C
C     Externals.
C     ----------
C
C     INXBIT    - Insert bits into GRIB product.
C     CONFP3    - Convert to IBM floating point format.
C
C     C2ROWS    - Row by row packing.
C     C2CWID    - Constant width packing.
C     C2GENE    - General WMO second-order packing.
C                + general extended second-order packing.
C     REVERO    - Reverse order of even rank rows.
C     C2DOSD    - Diagnose/compute order of spatial differencing.
C     D2ROSD    - Rebuild original values from spatial differencing.
C
C
C     Reference.
C     ----------
C
C     None.
C
C
C     Comments.
C     --------
C
C     On entry, KNSPT points to the first bit of section 4 
C               in the GRIB product.
C     On exit,  KNSPT points to the first unused bit of section 4,
C               (or to the first bit of section 5, if unused bit count
C                is zero) in the GRIB product.
C
C     KDATA is overwritten. This is coherent with GRIBEX coding.
C
C     When aggressive packing is selected (HOPER='K') :
C
C     1) If exhaustive second-order packing is on, then all possible
C        methods are attempted; note this may lead to expensive CPU
C        cost. Constant width packing will use iterative search of
C        optimal width, starting from (KSEC4(2)-1), regardless of
C        KSEC4(11) value.
C
C        Notes:
C
C        -if extensions switch is not set (disabled by default), then
C         none of the extensions on methods will be promoted;
C
C        -if extensions switch is on, boustrophedonic ordering is then
C         used in conjunction with relevant methods (all 2nd-order but
C         row by row), provided there is a section 2 and no implicit
C         primary bit-map;
C
C        -if both extensions and non-local switches are on (both are
C         disabled by default), estimation of best order of spatial
C         differencing is activated for general extended packing.
C
C     2) If exhaustive second-order packing is off (default), then
C        only explicitly requested methods are tried. More precisely:
C
C        -row by row packing (cheapest method, but least effective)
C         is always attempted, except without a section 2
C         or with an implicit primary bit-map;
C
C        -constant width packing is attempted if KSEC4(10)=0 in input;
C         (with iterative search of optimal width only if KSEC4(11) is
C          negative, using -KSEC4(11) as initial and maximum width)
C
C        -general 2nd-order packing is attempted if KSEC4(9)=32 in
C         input, or if there is no section 2 or in case of an implicit
C         primary bit-map.
C
C        -general extended second-order packing is attempted if
C         extensions switch has been set and KSEC4(12)=8 in input.
C
C        Boustrophedonic ordering is attempted if extensions switch
C        has been set and if KSEC4(13)=4 in input,
C        systematically in conjunction with relevant selected
C        method(s), and provided there is a section 2.
C
C        Spatial differencing is activated for general extended method
C        if this last method is selected (see above), if non-local
C        switch has been set, and if KSEC4(14) and/or KSEC4(15) is not
C        null. Tuning of order is as described earlier for HOPER='C'.
C
C     Iterative method used in C2CWID to find an optimal width (that
C     minimise length of section 4) may also be used with HOPER='C',
C     using a negative value for KSEC4(11) in input; -KSEC4(11) is then
C     used as initial and maximum width.
C
C     Author.
C     -------
C
C     J. Clochard, Meteo France, for ECMWF - January 1998.
C
C
C     Modifications.
C     _____________
C
C     J. Clochard, April 1998.
C     Update comments.
C     For constant width packing, interpret KSEC4(11) negative as
C     request for optimal width search, starting from -KSEC4(11) .
C     When both aggressive mode (HOPER='K') is requested and exhaustive
C     use of 2nd-order packing methods is set, initial width is set to
C     (KSEC4(2)-1) .
C     Fix double computing of work arrays for General WMO 2nd-order,
C     when General extended method is not requested.
C     Introduce spatial differencing.
C     Simplify management of boustrophedonic ordering.
C
C     J. Clochard, August 1998.
C     Raise JPMXGR from 131071 to 220000 to enable proper processing
C     of satellite images for general method.
C     (i.e. METEOSAT full-disk products, 2500x2500)
C
C     J. Clochard, September 1998.
C     Suppress KSEC1/KSEC2/KSEC3 arguments in C2CWID/C2GENE calls.
C     Suppress KSEC1/KSEC3 arguments in C2ROWS call.
C     Fix definition of LGENXT to be able to select both general methods
C     in non-exhaustive use of 2nd-order methods.
C     Fix to enforce re-computation of work arrays when general extended
C     method is not worth and spatial differencing is used.
C     Inhibit boustrophedonic ordering also for aggressive packing,
C     when there is no section 2 and/or an implicit bit-map.
C     If dynamical estimation of spatial differencing leads to greater
C     message length than general WMO 2nd-order, retry general exten-
C     ded method without spatial differencing.
C     Adjustment of granularity parameters for general methods and small
C     grids.
C
C     J. Clochard, June 1999.
C     Simple packing method always available as backup, even in explicit
C     encoding cases (HOPER='C') . 
C     Use precomputed array to determine widths . Arguments IPCWID and
C     JPXWID added in C2GENE/C2DOSD/C2ROWS calls .
C
C----<
C     -----------------------------------------------------------------
C*    Section 0. Definition of variables.
C     -----------------------------------------------------------------
C
      IMPLICIT NONE
C
#include "grprs.h"
C
C     Parameters
C
      INTEGER JP16SET, JPMXGR, JPXPWR, JPMXGF, JPMETH, JPVSE4, JPWORK
      INTEGER JPORDR, JPXWID, JPCWID
C
C     Number of possible packing methods.
C
      PARAMETER ( JPMETH=4, JPORDR=3 )
      PARAMETER ( JP16SET= 2**16-1 )
C                            `---> 65535    =   FFFF(hex)
#ifdef JBPW_64
      PARAMETER ( JPMXGR= 220000, JPXPWR=47, JPVSE4=20 )
#else
      PARAMETER ( JPMXGR= 220000, JPXPWR=31, JPVSE4=20 )
#endif
      PARAMETER ( JPXWID=(JPXPWR+1)/2 )
      PARAMETER ( JPCWID=2**JPXWID )
C
C     Size of work array. Must be at least JPMXGF*4 .
C
      PARAMETER ( JPWORK=JPMXGR*4 )
#ifndef wmogrp2o
      PARAMETER ( JPMXGF= JPMXGR )
#else
C
C     Limit maximum number of groups/first-order values to WMO
C     standard upper limit (descriptor is 16-bit wide).
C
      PARAMETER ( JPMXGF=
     X          ( JPMXGR*(JP16SET/JPMXGR) + JP16SET*(JPMXGR/JP16SET) )
     X           /     ( (JP16SET/JPMXGR) + (JPMXGR/JP16SET) )       )
#endif
C
C     Subroutine arguments.
C
      INTEGER KLENP, KLENG, KNSPT, KBITS, KBMAP, KVALS, KLEN, KDEBUG
      INTEGER KDATA (KLENP), KSEC1 (*), KSEC2 (*), KSEC3 (*), KSEC4 (*)
      INTEGER KGRIB (KLENG)
C
      CHARACTER HOPER * (*)
C
      REAL PREF, PMAX
C
C     Global variables.
C
#include "grbcom.h"
C
C     Local variables.
C
      INTEGER IRET, INROWS, J, IROWMK, INSPTA, ILOWMK, IHIGMK, IRETFN
      INTEGER ILSIMP, IL4OPT, ILMETH, IZERO, ICWORK, IROWBF, ICWIMK, J2
      INTEGER ICWIBF, ICWIFO, IHWM, INCMIN, IOFF, IROWL4, ICWIL4
      INTEGER IGENMK, IGENBF, IGENFO, IGENL4, IMINPK, IMETHO, JMETHO
      INTEGER IMTROW, IMTCWI, IMTGEN, IMTMIN, IMTMAX, ILREFR
C
      INTEGER IWORK (JPWORK), IPOWER (0:JPXPWR), ISEC4 (JPVSE4,JPMETH)
      INTEGER IPCWID (0:JPCWID-1)
C
      INTEGER C2ROWS, C2CWID, C2GENE
      EXTERNAL C2ROWS, C2CWID, C2GENE
C
      CHARACTER YOPER*1, YMETHO*30, YREFER*30
C
      LOGICAL LROW, LQUASI, LCTWID, LSECBI, LPRIBI, LAGGPK, LSIMPK
      LOGICAL L1CALL, LSECT2, LLONLY, LCOMGR, LFIRST, LGEN2O, LDEBUG
      LOGICAL LOPTLN, LGPREC
      LOGICAL LGENXT, LBOUST, LREVER, LPRCLN, LNLOCP, LNLOCF, LDYNOR
      LOGICAL LCOMSD, LCBIAS, LVECTD
C
      INTEGER IWIDSD, INDCLN, IGXTMK, IGXTBF, IGXTFO, IGXTL4, IBOUST
      INTEGER IMTGXT, IORDER, ILWORX, IBIAS, IXBITS
C
      INTEGER REVERO, C2DOSD, D2ROSD
      EXTERNAL REVERO, C2DOSD, D2ROSD
C
      INTRINSIC ABS
C
      REAL ZGAIN
C
      SAVE L1CALL, IPOWER, IMTROW, IMTCWI, IMTGEN, IPCWID
      SAVE IMTGXT
C
C     Function used to adress 4 sub-parts of array IWORK, using
C     first and last argument to specify sub-part.
C     (4 work arrays are joined together to enable use of a single big
C      work array)
C
      INTEGER IXIND, IABCDE, IFGHIJ, IKLMNO
C
      IXIND ( IABCDE, IFGHIJ, IKLMNO ) =
C
     X        IFGHIJ + JPMXGF * ( IKLMNO - 1 + 2 * ( IABCDE - 1 ) )
C
      DATA L1CALL / .TRUE. /
      DATA IMTROW / 1 /
      DATA IMTCWI / 2 /
      DATA IMTGEN / 3 /
      DATA IMTGXT / 4 /
C
C     -----------------------------------------------------------------
C*    Section 1 . Performs initial checks.
C     -----------------------------------------------------------------
C
  100 CONTINUE
C
      IF (L1CALL) THEN
C
        DO 111 J=0,JPXPWR-1
C
          IPOWER(J)=2**J-1
C
  111   CONTINUE
#ifdef JBPW_64
        IPOWER(JPXPWR)=140737488355327
#else
        IPOWER(JPXPWR)=2147483647
#endif
C
        IPCWID(0)=0
        IOFF=1
C
        DO 113 J=1,JPXWID
C
          DO 112 J2=0,IPOWER(J-1)
C
            IPCWID(IOFF+J2)=J
C
  112     CONTINUE
C
          IOFF=IOFF+IPOWER(J-1)+1
C
  113   CONTINUE
C
        L1CALL=.FALSE.
C
      ENDIF
C
      IRETFN = 0
      IMETHO=0
      INSPTA=KNSPT
      LAGGPK=HOPER.EQ.'K'
      ILSIMP=11+(1+(KLEN*KSEC4(2)-1)/8)
      ILSIMP=2*(1+(ILSIMP-1)/2)
      IL4OPT=ILSIMP
      LSIMPK=LAGGPK
      LDEBUG=KDEBUG.GE.1
      IMINPK=MIN ( 15, MAX ( 2, NINT ( SQRT ( REAL (KLEN/3) ) ) ) )
C     IMINPK=12
      INCMIN=MIN (  3, 1 + KLEN/1000 )
C     INCMIN=1
C
      LSECT2=KSEC1(5).GE.128
      LPRIBI=MOD (KSEC1(5),128).GE.64
#ifndef ebug2o
C
      IF (LDEBUG) THEN
#endif
        WRITE(GRPRSM,FMT=9100) HOPER(:1), KNSPT, KSEC4(2), LSECT2,
     X                          LPRIBI
        YREFER='simple packing'
#ifndef ebug2o
      ENDIF
C
#endif
      LSECBI=KSEC4(9).NE.0
      LROW=.NOT.LSECBI.AND.KSEC4(12).EQ.0
      LGENXT=(.NOT.LSECBI.OR.LAGGPK).AND.KSEC4(12).NE.0
      LBOUST=KSEC4(13).NE.0
      IORDER=IABS (KSEC4(14))+IABS (KSEC4(15))
      LNLOCP=IORDER.NE.0
      LREVER=.FALSE.
      LGPREC=.FALSE.
#if (defined CRAY) || (defined FUJITSU)
      LVECTD=.TRUE.
#else
      LVECTD=.FALSE.
#endif
      LQUASI=KSEC2(17).EQ.1
      LCTWID=KSEC4(10).EQ.0
      LGEN2O=LSECBI.AND.(.NOT.LCTWID.OR.LAGGPK)
C
      IF (KSEC4(8).NE.0) THEN
        IRETFN = 18110
        WRITE(GRPRSM,FMT=9110)
        GO TO 900
      ELSEIF (LROW.OR.LAGGPK) THEN
C
        IF (.NOT.LSECT2) THEN
C
          IF (LAGGPK) THEN
            LROW=.FALSE.
            LGEN2O=.TRUE.
          ELSE
            IRETFN = 18120
            WRITE(GRPRSM,FMT=9120) 'Row by row packing'
            GO TO 900
          ENDIF
C
        ELSEIF (LPRIBI.AND.KSEC3(1).NE.0) THEN
C
          IF (LAGGPK) THEN
            LROW=.FALSE.
            LGEN2O=.TRUE.
          ELSE
            IRETFN = 18130
            WRITE(GRPRSM,FMT=9130)
     S       'Row by row', 'implicit primary bit-map'
            GO TO 900
          ENDIF
C
        ELSE
C
          LROW=LROW.OR.LAGGPK
C
        ENDIF
C
      ENDIF
C
      IF (LCTWID) THEN
C
        IF (LROW.AND..NOT.LAGGPK) THEN
          IRETFN = 18135
          WRITE(GRPRSM,FMT=9130)
     S       'Row by row', 'constant width'
          GO TO 900
        ENDIF
C
      ENDIF
C
      LCTWID=LCTWID.OR.(LAGGPK.AND.NUM2OK.EQ.1)
      LGEN2O=LGEN2O.OR.(LAGGPK.AND.NUM2OK.EQ.1)
C
      IF (KSEC4(12).NE.0.AND.NEXT2O.EQ.1.AND..NOT.LAGGPK) THEN
C
C            General extended second-order packing explicitly requested.
C
        IF (KSEC4(12).NE.8) THEN
          IRETFN = 18140
          WRITE(GRPRSM,FMT=9140) 12, 8
          GO TO 900
        ELSEIF (LSECBI) THEN
          IRETFN = 18145
          WRITE(GRPRSM,FMT=9150) 'no secondary bit-map'
          GO TO 900
        ELSEIF (LCTWID) THEN
          IRETFN = 18150
          WRITE(GRPRSM,FMT=9150) 'variable group widthes'
          GO TO 900
        ENDIF
C
      ENDIF
C
      LGENXT=NEXT2O.EQ.1.AND.(LGENXT.OR.(LAGGPK.AND.NUM2OK.EQ.1))
C
      IF (KSEC4(13).NE.0.AND.NEXT2O.EQ.1.AND..NOT.LAGGPK) THEN
C
C               Boustrophedonic ordering explicitly requested.
C
        IF (KSEC4(13).NE.4) THEN
          IRETFN = 18151
          WRITE(GRPRSM,FMT=9140) 13, 4
          GO TO 900
        ELSEIF (.NOT.LSECT2) THEN
          IRETFN = 18152
          WRITE(GRPRSM,FMT=9120) 'Boustrophedonic ordering'
          GO TO 900
        ELSEIF (LROW) THEN
          WRITE(GRPRSM,FMT=9153)
          KSEC4(13)=0
          LBOUST=.FALSE.
        ELSEIF (LPRIBI.AND.KSEC3(1).NE.0) THEN
          IRETFN = 18154
          WRITE(GRPRSM,FMT=9130)
     S       'Boustrophedonic ordering', 'implicit primary bit-map'
          GO TO 900
        ENDIF
C
      ENDIF
C
      LBOUST=NEXT2O.EQ.1.AND.(LBOUST.OR.(LAGGPK.AND.NUM2OK.EQ.1)).AND.
     S   LSECT2.AND.(.NOT.LPRIBI.OR.KSEC3(1).EQ.0)
C
#ifndef ebug2o
      IF (LDEBUG) THEN
#endif
        PRINT *,'C2ORDR: LBOUST/LNLOCP/LAGGPK=',
     S                 LBOUST, LNLOCP, LAGGPK
#ifndef ebug2o
      ENDIF
C
#endif
      IF (LNLOCP.AND.NEXT2O.EQ.1.AND.NLOC2O.EQ.1.AND..NOT.LAGGPK) THEN
C
C               Spatial differencing explicitly requested.
C
        IF (KSEC4(14).NE.2.AND.KSEC4(14).NE.0.AND.KSEC4(14).NE.-1) THEN
          IRETFN = 18154
          WRITE(GRPRSM,FMT=9155) 14, 2
          GO TO 900
        ELSEIF (ABS (KSEC4(15)).NE.1.AND.KSEC4(15).NE.0) THEN
          IRETFN = 18155
          WRITE(GRPRSM,FMT=9155) 15, 1
          GO TO 900
        ELSEIF (.NOT.LGENXT) THEN
          WRITE(GRPRSM,FMT=9156)
          KSEC4(14)=0
          KSEC4(15)=0
          IORDER=0
          LNLOCP=.FALSE.
        ENDIF
C
      ENDIF
C
      LNLOCF=NEXT2O.EQ.1.AND.NLOC2O.EQ.1.AND.
     S      (LNLOCP.OR.(LGENXT.AND.LAGGPK.AND.NUM2OK.EQ.1))
C
      IF (LNLOCF.AND..NOT.LNLOCP) THEN
C
C       Spatial differencing implicitly requested.
C       Activation of iterative search for best order.
C
        KSEC4(14)=-1
        KSEC4(15)=-1
      ENDIF
C
      LNLOCP=LNLOCF
C
      IF (.NOT.LNLOCP) THEN
        IORDER=0
      ENDIF
C
      IF (KSEC4(2).GT.JPXPWR) THEN
C
        IRETFN = 18160
        WRITE(GRPRSM,FMT=9160) KSEC4(2), JPXPWR
        GO TO 900
C
      ELSEIF (LCTWID) THEN
C
        IF (ABS (KSEC4(11)).GE.KSEC4(2)) THEN
C
          IF (LAGGPK) THEN
            KSEC4(11)=-(KSEC4(2)-1)
          ELSE
            IRETFN = 18170
            WRITE(GRPRSM,FMT=9170) KSEC4(11), KSEC4(2)-1
            GO TO 900
          ENDIF
C
        ENDIF
C
      ENDIF
C
      IF (PMAX.LE.PREF.AND.LAGGPK) THEN
C
C       Field is constant... code it with zero as bit-number,
C                            and nothing else!              
C
C     Enforce right values for flags.
C
        KSEC4(4)=0
        KSEC4(6)=0
C
C*    Octet 11 : Number of bits containing each first-order value.
C     One 8 bit field.
C
#ifndef ebug2o
        IF (LDEBUG) THEN
C
#endif
          WRITE(GRPRSM,FMT=9175) PMAX
          IL4OPT=12
          YREFER='direct method'
C
C              Switch off LSIMPK to enable printout of gain.
C
          LSIMPK=.FALSE.
#ifndef ebug2o
        ENDIF
C
#endif
        IZERO=0        
        YOPER='C'
        KNSPT=KNSPT+10*8
        CALL INXBIT(KGRIB,KLENG,KNSPT,IZERO,1,KBITS, 8,YOPER,IRET)
C
        IF (IRET.NE.0) THEN
          IRETFN = 18180
          WRITE(GRPRSM,FMT=9001) 'bit number'
        ENDIF
C
        GO TO 900
C
      ENDIF
C
      IF (LSECT2) THEN
C
        IF (MOD (KSEC2(11),64).LT.32) THEN
          INROWS=KSEC2(3)
        ELSE
          INROWS=KSEC2(2)
        ENDIF
C
#ifndef ebug2o
        IF (LDEBUG) THEN
#endif
          WRITE(GRPRSM,FMT=9180) INROWS, KLEN, LQUASI
#ifndef ebug2o
        ENDIF
C
#endif
        IF (.NOT.LPRIBI.AND.KLEN.NE.KSEC4(1)) THEN
          IRETFN = 18185
          WRITE(GRPRSM,FMT=9185) KLEN, KSEC4(1)
          GO TO 900
        ELSEIF (LPRIBI.AND.(KLEN.LE.0.OR.KLEN.GT.KSEC4(1))) THEN
          IRETFN = 18187
          WRITE(GRPRSM,FMT=9187) KLEN, KSEC4(1)
          GO TO 900
        ELSEIF (LROW.AND.INROWS.GT.JPMXGF) THEN
C
          IF (LAGGPK) THEN
            LROW=.FALSE.
          ELSE
            IRETFN = 18190
            WRITE(GRPRSM,FMT=9190) INROWS, JPMXGF
            GO TO 900
          ENDIF
#ifndef wmogrp2o
C
        ELSEIF (LPRIBI.AND.KSEC3(1).NE.0.AND.KLEN.GT.JP16SET) THEN
C
C     Such a case would lead to no possibility to recover the right
C     number of grid points when decoding through D2ORDR routine.
C
          IRETFN = 18192
          WRITE(GRPRSM,FMT=9192) JP16SET
          GO TO 900
#endif
C
        ENDIF
C
      ENDIF
C
      IF (.NOT.(LROW.OR.LCTWID.OR.LGEN2O.OR.LGENXT.OR.LSIMPK)) THEN
        WRITE(GRPRSM,FMT=9195)
        LSIMPK=.TRUE.
        GO TO 600
      ENDIF
C
      LLONLY=LAGGPK
      ILOWMK=JPMXGF+1
      IHIGMK=0
      IROWMK=0
      ICWIMK=1
      IGENMK=1
      IGXTMK=1
      LFIRST=.TRUE.

C          Copy KSEC4 for all possible methods. 
C
      IF (LROW) THEN
        IMTMIN=IMTROW
        IMTMAX=IMTROW
      ELSE
        IMTMIN=JPMETH
        IMTMAX=1
      ENDIF
C
      IF (LCTWID) THEN
        IMTMIN=MIN (IMTCWI,IMTMIN)
        IMTMAX=MAX (IMTCWI,IMTMAX)
      ENDIF
C
      IF (LGEN2O) THEN
        IMTMIN=MIN (IMTGEN,IMTMIN)
        IMTMAX=MAX (IMTGEN,IMTMAX)
      ENDIF
C
      IF (LGENXT) THEN
        IMTMIN=MIN (IMTGXT,IMTMIN)
        IMTMAX=MAX (IMTGXT,IMTMAX)
      ENDIF
C
      DO 122 JMETHO=IMTMIN,IMTMAX
C
      DO 121 J=1,JPVSE4
      ISEC4(J,JMETHO)=KSEC4(J)
  121 CONTINUE
C
  122 CONTINUE
C
      IF (LBOUST.AND.IMTMIN.EQ.IMTROW.AND.IMTMAX.EQ.IMTROW) THEN
C
C         This might be the case in aggressive packing mode.
C
        WRITE(GRPRSM,FMT=9153)
        KSEC4(13)=0
        LBOUST=.FALSE.
      ENDIF
C
      IF (LBOUST) THEN
C
        IBOUST=4
C
C         Reverse field ordering for even rank rows.
C
C         This is done before trying any method or sub-method,
C         for better prognosis of non-local packing interest
C         (if requested). It allows also more simple source code.
C
C         There is no influence on trial of row by row packing,
C         because work arrays computed through C2ROWS with LLONLY set
C         to .TRUE. do not depend on field ordering within each row.
C
C         The only case where field ordering might have to be restored
C         would be in aggressive packing mode, if either row by row
C         or simple packing was found more efficient than all the other
C         2nd-order methods selected/allowed... Probability of such a
C         case is low, but source code enables it.
C
C         Apart from that, the only side effect of this anticipated call
C         to REVERO is, when row by row packing is enabled
C         (as in exhaustive mode), to compute twice the lengths of rows.
C         This is considered as a cheap overhead.
C
        LPRCLN=.FALSE.
C
        IRETFN = REVERO ( KDATA,  KLENP,  KSEC2,  KGRIB,  KLENG,
     X                    KBITS,  KBMAP,  KVALS,  LPRIBI, LQUASI,
     X                    INROWS, KLEN,   IWORK(IXIND (2,1,2)),
     X                    JPMXGF, LDEBUG, LPRCLN, IWORK(IXIND (2,1,1)) )
C
        IF (IRETFN.NE.0) THEN
          GO TO 900
        ENDIF
C
        LREVER=.TRUE.
C
      ELSE
C
        IBOUST=0
C
      ENDIF
C
      DO 123 JMETHO=IMTMIN,IMTMAX
      ISEC4(13,JMETHO)=IBOUST
  123 CONTINUE
C
      LDYNOR=LNLOCP.AND.(KSEC4(14).EQ.-1.OR.KSEC4(15).EQ.-1)
C
      IF (LDYNOR) THEN
C
C         Estimate interest of non-local packing use, and order
C         associated to.
C
C         In non-agressive mode (HOPER='C'), field is also transformed.
C
        LCOMSD=.NOT.LAGGPK
        LCBIAS=.TRUE.
        IORDER = C2DOSD ( KDATA,  KLENP,  KSEC4,  LCOMSD, KLEN,
     X                    IWORK,  JPWORK, IPOWER, JPXPWR, IPCWID,
     X                    JPXWID, IMINPK, ILWORX, IBIAS,  IWIDSD,
     X                    IXBITS, LCBIAS, LDEBUG )
        LCBIAS=.FALSE.    
C
      ELSE
C
        LCOMSD=.FALSE.
        LCBIAS=.TRUE.
C
      ENDIF
C
C     -----------------------------------------------------------------
C*    Section 2 . Row by row packing method applied, or tried.
C     -----------------------------------------------------------------
C
  200 CONTINUE
C
#ifndef ebug2o
      IF (LDEBUG) THEN
#endif
        WRITE(GRPRSM,FMT=9200) LROW, LCTWID, LGEN2O, LGENXT, LBOUST,
     X                          IORDER, LSIMPK
#ifndef ebug2o
      ENDIF
C
#endif
      IF (LROW) THEN
C
C       Upper part of work sub-arrays IWORK(IXIND (1,.,1)),
C       IWORK(IXIND (2,.,1)), IWORK(IXIND (1,.,2))
C       -reference values, effective row lengths, row widths- is used;
C       useful for aggressive packing, if row by row packing turns
C       to be selected as the appropriate method to apply, and if total
C       work space needed by the other methods do not overlap.
C
        IMETHO=IMTROW
        IROWMK=JPMXGF-INROWS+1
        ILOWMK=IROWMK
        LCOMGR=LFIRST.OR.IROWMK.LE.IHIGMK
C
        IF (LREVER.AND..NOT.LFIRST) THEN
C
C         Restore initial field ordering.
C
          LPRCLN=.NOT.LCOMGR
C
          IRETFN = REVERO ( KDATA,  KLENP,  KSEC2,  KGRIB,  KLENG,
     X                      KBITS,  KBMAP,  KVALS,  LPRIBI, LQUASI,
     X                      INROWS, KLEN,   IWORK(IXIND (2,1,2)),
     X                      JPMXGF, LDEBUG, LPRCLN,
     X                      IWORK(IXIND (2,IROWMK,1)) )
C
          IF (IRETFN.NE.0) THEN
            GO TO 900
          ENDIF
C
          LREVER=.FALSE.
C
        ENDIF
C
C         Enforce no extension at all, and especially 
C         no boustrophedonic ordering for row by row (useless).
C
        DO 201 J=12,15
        ISEC4(J,IMETHO)=0
  201   CONTINUE
C
        IRET = C2ROWS ( KDATA,  KLENP,  KSEC2,  ISEC4(1,IMETHO),KGRIB,
     X                  KLENG,  KNSPT,  KBITS,  LCOMGR, LLONLY, IROWL4,
     X                  KBMAP,  KVALS,  LPRIBI, LQUASI, INROWS, KLEN,
     X                  IWORK(IXIND (1,IROWMK,1)),
     X                  IWORK(IXIND (2,IROWMK,1)),
     X                  IWORK(IXIND (1,IROWMK,2)),
     X                  IWORK(IXIND (2,1,2)),   JPMXGF, IPOWER, JPXPWR,
     X                  IPCWID, JPXWID, IROWBF, LDEBUG )
C
        IF (LLONLY) THEN
C
#ifndef ebug2o
          IF (LDEBUG) THEN
#endif
            WRITE(GRPRSM,FMT=9210) IRET, IROWBF, IROWL4, IL4OPT
#ifndef ebug2o
          ENDIF
C
#endif
          IF (IRET.NE.0.OR.IROWL4.GE.IL4OPT) THEN
            LROW=.FALSE.
C
            IF (IRET.NE.0.AND.LBOUST) THEN
C
C               Reset IROWMK to avoid possible misuse of length array
C               in REVERO.
C
              IROWMK=0
            ENDIF
C
          ELSE
            IL4OPT=IROWL4
            LSIMPK=.FALSE.
          ENDIF
C
        ELSEIF (IRET.NE.0) THEN
C
          IRETFN = IRET
          GO TO 900
C
        ENDIF
C
#ifdef ebug2o
        IF (.NOT.LLONLY) THEN
#else
        IF (LDEBUG.AND..NOT.LLONLY) THEN
#endif
C
          YMETHO='Row by row'
          IL4OPT=IROWL4
C
        ENDIF
C
      ENDIF
C
C     -----------------------------------------------------------------
C*    Section 3 . Constant width packing method applied, or tried.
C     -----------------------------------------------------------------
C
      IF (LCTWID) THEN
C
        IMETHO=IMTCWI
        ILOWMK=MIN (ICWIMK,ILOWMK)
        LCOMGR=LFIRST.OR.ICWIMK.LE.IHIGMK
C
        IF (LCOMGR) THEN
          ICWIMK=1
          ICWORK=1
        ENDIF
C
        IF (LLONLY.AND.NUM2OK.EQ.1) THEN
C
C           Modulates width use, regardless of KSEC4(11).
C
          IF (LGENXT) THEN
C
C     Experience shows that the only cases where constant width packing
C     may compress data better than general extended method are for a
C     null width.
C
            ISEC4(11,IMETHO)=0
          ELSE
            ISEC4(11,IMETHO)=-(ISEC4(2,IMETHO)-1)
          ENDIF
C
        ENDIF
C
        LOPTLN=LFIRST.AND.ISEC4(11,IMETHO).LT.0
C
C         Enforce no extension flag, except boustrophedonic ordering.
C
        ISEC4(12,IMETHO)=0
        ISEC4(14,IMETHO)=0
        ISEC4(15,IMETHO)=0
C
        IRET = C2CWID ( KDATA,  KLENP,  ISEC4(1,IMETHO),KGRIB,  KLENG,
     X                  KNSPT,  KBITS,  LCOMGR, LLONLY, ICWIL4, ICWIFO,
     X                  KLEN,   IWORK(IXIND(1,1,1)),
     X                  IWORK(IXIND(2,1,1)),    JPMXGF, ICWIMK, IPOWER,
     X                  JPXPWR, ICWIBF, INCMIN, IHWM,   ICWORK, LDEBUG,
     X                  LOPTLN )
C
        IF (LLONLY) THEN
C
#ifndef ebug2o
          IF (LDEBUG) THEN
#endif
            WRITE(GRPRSM,FMT=9310) IRET, ICWIBF, ICWIL4, IL4OPT,
     X                              ICWIFO, IHWM, ICWORK
#ifndef ebug2o
          ENDIF
C
#endif
          IF (IRET.NE.0.OR.ICWIL4.GE.IL4OPT) THEN
            LCTWID=.FALSE.
            IHIGMK=MAX (IHIGMK,IHWM)
          ELSE
C
C     Constant width packing better than simple packing,
C     and possibly row by row.
C
            IL4OPT=ICWIL4
            LSIMPK=.FALSE.
            LROW=.FALSE.
C
            IF (LGEN2O.OR.LGENXT) THEN
C
C     Push up useful work arrays, trying to keep data if further
C     method(s) tried are not better.
C
              IOFF=JPMXGF-ICWIFO
              ICWIMK=IOFF+1
              IHIGMK=0
C
#ifdef CRAY
CDIR$ IVDEP
#endif
#ifdef FUJITSU
!OCL NOVREC
#endif
              DO 311 J=ICWIFO,1,-1
              IWORK(IXIND (1,IOFF+J,ICWORK))=IWORK(IXIND (1,J,ICWORK))
              IWORK(IXIND (2,IOFF+J,ICWORK))=IWORK(IXIND (2,J,ICWORK))
  311         CONTINUE
C
            ENDIF
C
          ENDIF
C
        ELSEIF (IRET.NE.0) THEN
C
          IRETFN = IRET
          GO TO 900
C
        ENDIF
C
#ifdef ebug2o
        IF (.NOT.LLONLY) THEN
#else
        IF (LDEBUG.AND..NOT.LLONLY) THEN
#endif
C
          WRITE (UNIT=YMETHO,FMT=9320) ISEC4(11,IMETHO)
          IL4OPT=ICWIL4
C
        ENDIF
C
      ENDIF
C
C     -----------------------------------------------------------------
C*    Section 4 . General 2nd-order packing method applied, or tried.
C     -----------------------------------------------------------------
C
      IF (LGEN2O) THEN
C
        IMETHO=IMTGEN
        ILOWMK=MIN (IGENMK,ILOWMK)
        LCOMGR=.NOT.LGPREC
C
        IF (LCOMGR) THEN
          IGENMK=1
        ENDIF
C
C         Enforce no extension flag, except boustrophedonic ordering.
C
        ISEC4(12,IMETHO)=0
        ISEC4(14,IMETHO)=0
        ISEC4(15,IMETHO)=0
C
        IRET = C2GENE ( KDATA,  KLENP,  ISEC4(1,IMETHO),KGRIB,  KLENG,
     X                  KNSPT,  KBITS,  LCOMGR, LLONLY, IGENL4, IGENFO,
     X                  KLEN,   IWORK(IXIND (1,1,1)),
     X                  IWORK(IXIND (2,1,1)),   IWORK(IXIND (1,1,2)),
     X                  IWORK(IXIND (2,1,2)),   JPMXGF, IGENMK, IPOWER,
     X                  JPXPWR, IPCWID, JPXWID, IGENBF, INCMIN, IMINPK,
     X                  IHWM,   LDEBUG )
C
        IF (LLONLY) THEN
C
#ifndef ebug2o
          IF (LDEBUG) THEN
#endif
            WRITE(GRPRSM,FMT=9410) IRET, IGENBF, IGENL4, IL4OPT,
     X                              IGENFO, IHWM
#ifndef ebug2o
          ENDIF
C
#endif
          IF (IRET.NE.0.OR.IGENL4.GE.IL4OPT) THEN
            LGEN2O=.FALSE.
          ELSE
C
C     General 2nd-order packing better than simple packing,
C     and possibly row by row and/or constant width.
C
            IL4OPT=IGENL4
            LSIMPK=.FALSE.
            LROW=.FALSE.
            LCTWID=.FALSE.
C
          ENDIF
C
          IHIGMK=MAX (IHIGMK,IHWM)
          LGPREC=IRET.EQ.0
C
          IF (LGPREC.AND.LGENXT) THEN
C
C              Duplicate descriptors for further use by
C              general extended packing trial.
C
            IGXTBF=IGENBF
            IGXTFO=IGENFO
            IGXTMK=IGENMK
C
          ENDIF
C
        ELSEIF (IRET.NE.0) THEN
C
          IRETFN = IRET
          GO TO 900
C
        ENDIF
C
#ifdef ebug2o
        IF (.NOT.LLONLY) THEN
#else
        IF (LDEBUG.AND..NOT.LLONLY) THEN
#endif
C
          YMETHO='General second-order'
          IL4OPT=IGENL4
C
        ENDIF
C
      ENDIF
C
C     -----------------------------------------------------------------
C*    Section 5 . General extended 2nd-order packing method applied,
C                 or tried.
C     -----------------------------------------------------------------
C
      IF (LGENXT) THEN
C
        IMETHO=IMTGXT
        ILOWMK=MIN (IGXTMK,ILOWMK)
        LCOMGR=.NOT.LGPREC.OR.(LFIRST.AND.LNLOCP)
C
  510   CONTINUE
C
        IF (LCOMGR) THEN
          IGXTMK=1
        ELSEIF (LFIRST) THEN
C
C         Inherit total length of second-order values from general WMO
C         second-order packing, performed just previously.
C
          ISEC4(19,IMETHO)=ISEC4(19,IMTGEN)
        ENDIF
C
        ISEC4(12,IMETHO)=8
        ISEC4(14,IMETHO)=2*(IORDER/2)
        ISEC4(15,IMETHO)=MOD (IORDER,2)
C
        IF (IORDER.NE.0.AND..NOT.LCOMSD) THEN
C
C           Spatial differencing has to be applied to field.
C
          LCOMSD=.TRUE.
          IORDER = C2DOSD ( KDATA,  KLENP,  ISEC4(1,IMETHO), LCOMSD,
     S                      KLEN,   IWORK,  JPWORK, IPOWER,  JPXPWR,
     S                      IPCWID, JPXWID, IMINPK, ILWORX,  IBIAS,
     S                      IWIDSD, IXBITS, LCBIAS, LDEBUG )     
C
C           Reset ISEC4, because C2DOSD may have reset IORDER.
C
          ISEC4(14,IMETHO)=2*(IORDER/2)
          ISEC4(15,IMETHO)=MOD (IORDER,2)
C
        ENDIF
C
        IF (IORDER.NE.0) THEN
          ISEC4( 2,IMETHO)=IXBITS
          ISEC4(11,IMETHO)=IWIDSD
          ISEC4(16,IMETHO)=IBIAS
        ENDIF
C
        IRET = C2GENE ( KDATA,  KLENP,  ISEC4(1,IMETHO),KGRIB,  KLENG,
     X                  KNSPT,  KBITS,  LCOMGR, LLONLY, IGXTL4, IGXTFO,
     X                  KLEN,   IWORK(IXIND (1,1,1)),
     X                  IWORK(IXIND (2,1,1)),   IWORK(IXIND (1,1,2)),
     X                  IWORK(IXIND (2,1,2)),   JPMXGF, IGXTMK, IPOWER,
     X                  JPXPWR, IPCWID, JPXWID, IGXTBF, INCMIN, IMINPK,
     X                  IHWM,   LDEBUG )
C
        IF (LLONLY) THEN
C
#ifndef ebug2o
          IF (LDEBUG) THEN
#endif
            WRITE(GRPRSM,FMT=9510) IRET, IGXTBF, IGXTL4, IL4OPT,
     X                              IGXTFO, IHWM, IORDER
#ifndef ebug2o
          ENDIF
C
#endif
          IF (IRET.NE.0.OR.IGXTL4.GE.IL4OPT) THEN
C
C             Current method is not successful, and has to be discarded.
C
            LGENXT=.FALSE.
C
            IF (IRET.NE.0.OR..NOT.LGEN2O) THEN
              LGPREC=.FALSE.
            ELSE
              LGPREC=IGXTFO.EQ.IGENFO.AND.IORDER.EQ.0
            ENDIF
C
            IF (LCOMSD.AND.IORDER.NE.0) THEN
C
C              Spatial differencing has to be reversed.
C
              IRETFN = D2ROSD ( KDATA,  KLEN,   IORDER, IPOWER, JPXPWR,
     S                          IBIAS,  LVECTD, LDEBUG )     
C
              IF (IRETFN.NE.0) THEN
                GO TO 900
              ENDIF
C
              LCOMSD=.FALSE.
C
              IF (LGEN2O.AND.LDYNOR) THEN
C
C    General WMO 2nd-order packing was also selected/promoted, and is
C    the best method. This indicates moreless wrong diagnostic for
C    spatial differencing order.
C    Retry then general extended packing without spatial differencing,
C    that in almost all cases behaves better than general WMO method.
C
#ifndef ebug2o
                IF (LDEBUG) THEN
#endif
                  WRITE(GRPRSM,FMT=9520) IORDER
#ifndef ebug2o
                ENDIF
C
                IORDER=0
                LGENXT=.TRUE.
                LGPREC=.FALSE.
                LCOMGR=.TRUE.
                ISEC4(2,IMETHO)=KSEC4(2)
                GOTO 510
C
              ENDIF
C
            ENDIF
C
          ELSE
C
C     General extended 2nd-order packing better than simple packing,
C     and possibly other methods.
C
            IL4OPT=IGXTL4
            LSIMPK=.FALSE.
            LROW=.FALSE.
            LCTWID=.FALSE.
            LGEN2O=.FALSE.
            LGPREC=.TRUE.
C
          ENDIF
C
          IHIGMK=MAX (IHIGMK,IHWM)
C
        ELSEIF (IRET.NE.0) THEN
C
          IRETFN = IRET
          GO TO 900
C
        ENDIF
C
#ifdef ebug2o
        IF (.NOT.LLONLY) THEN
#else
        IF (LDEBUG.AND..NOT.LLONLY) THEN
#endif
C
          YMETHO='Gen.extend.2nd-order'
          IL4OPT=IGXTL4
C
        ENDIF
C
      ENDIF
#endif
C
C     -----------------------------------------------------------------
C*    Section 6 . Effective in case of aggressive packing only.
C     -----------------------------------------------------------------
C
  600 CONTINUE
C
      IF (LSIMPK) THEN
C
C       Simple packing by default: complex packing not efficient,
C                                  or not applicable.
C
C     The first 10 octets have already been coded by GRIBEX, or will
C     be in a further step of GRIBEX:
C     Length of section, flags+unused bit count, binary scale factor,
C     reference value.
C
C     Enforce right values for flags.
C
        KSEC4(4)=0
        KSEC4(6)=0
        IMETHO=0
        YMETHO='Simple'
C
C*    Octet 11 : Number of bits containing each first-order value.
C     One 8 bit field.
C
        YOPER='C'
        KNSPT=KNSPT+10*8
        CALL INXBIT(KGRIB,KLENG,KNSPT,KSEC4(2),1,KBITS, 8,YOPER,IRET)
C
        IF (IRET.NE.0) THEN
          IRETFN = 18610
          WRITE(GRPRSM,FMT=9001) 'bit number'
          GO TO 900
        ENDIF
C
        IF (LREVER) THEN
C
C         Restore initial field ordering.
C
          LPRCLN=(LFIRST.AND.LROW).OR.IROWMK.GT.IHIGMK
          INDCLN=MAX (IROWMK,1)
C
          IRETFN = REVERO ( KDATA,  KLENP,  KSEC2,  KGRIB,  KLENG,
     X                      KBITS,  KBMAP,  KVALS,  LPRIBI, LQUASI,
     X                      INROWS, KLEN,   IWORK(IXIND (2,1,2)),
     X                      JPMXGF, LDEBUG, LPRCLN,
     X                      IWORK(IXIND (2,INDCLN,1)) )
C
          IF (IRETFN.NE.0) THEN
            GO TO 900
          ENDIF
C
          LREVER=.NOT.LREVER
        ENDIF
C
C*    Octet 12 - onwards: Data.
C
        CALL INXBIT(KGRIB,KLENG,KNSPT,KDATA,KLEN,KBITS,KSEC4(2),
     X              YOPER,IRET)
C
        IF (IRET.NE.0) THEN
          IRETFN = 18620
          WRITE(GRPRSM,FMT=9001) 'normalized data'
          GO TO 900
        ENDIF
C
      ELSEIF (LLONLY) THEN
C
C       Loop back to apply the most efficient second-order method,
C       as previously diagnosed. And hoping work arrays have not
C       been overwritten, to avoid computing them again.
C
        LLONLY=.FALSE.
        LFIRST=.FALSE.
        GOTO 200
C
      ENDIF
C
C     -----------------------------------------------------------------
C*    Section 7 . Debugging printout.
C     -----------------------------------------------------------------
C
  700 CONTINUE
C
#ifndef ebug2o
      IF (LDEBUG) THEN
C
#endif
        ILMETH=INDEX (YMETHO//'  ','  ')-1
        WRITE(GRPRSM,FMT=9710) HOPER(:1), YMETHO(:ILMETH), IL4OPT
C
        IF (.NOT.LSIMPK) THEN
C
          IF (LBOUST.AND..NOT.LROW) THEN
            WRITE(GRPRSM,FMT=9720)
          ENDIF
C
          IF (LGENXT.AND.IORDER.NE.0) THEN
            WRITE(GRPRSM,FMT=9730) IORDER
          ENDIF
C
          ZGAIN=REAL (100*(ILSIMP-IL4OPT)) / REAL (ILSIMP)
          ILREFR=INDEX (YREFER//'  ','  ')-1
          WRITE(GRPRSM,FMT=9002) YREFER(:ILREFR), ZGAIN
C
#ifndef ebug2o
        ENDIF
C
#endif
      ENDIF
C
C     -----------------------------------------------------------------
C*    Section 9. Return to calling routine.
C     -----------------------------------------------------------------
C
  900 CONTINUE
C
C     If second-order method was effectively and successfully used,
C     copy back information of section 4 descriptors to KSEC4.
C
      IF (IRETFN.NE.0.AND.IMETHO.NE.0) THEN
C
        DO 901 J=1,JPVSE4
        KSEC4(J)=ISEC4(J,IMETHO)
  901   CONTINUE
C
      ENDIF
C
      C2ORDR = IRETFN
#ifndef ebug2o
C
      IF (LDEBUG) THEN
#endif
        WRITE(GRPRSM,FMT=9900) IRETFN, HOPER(:1), KNSPT
#ifndef ebug2o
      ENDIF
#endif
C
      RETURN
C
 9001 FORMAT (' C2ORDR: Problem inserting ',A,'.')
C
 9002 FORMAT (' C2ORDR: Gain on section 4 length against ',A,':',
     X        F5.1,' %.')
C
 9100 FORMAT (' C2ORDR: Function start, HOPER = ',A1,', KNSPT =',I10,
     X  '.',/,' C2ORDR: Original number of bits =',I3,'.',/,
     X        ' C2ORDR: Presence of sections 2 and 3 = ',L1,' and ',
     X        L1,'.')
C
 9110 FORMAT (' C2ORDR: Matrix of values invalid here.')
C
 9120 FORMAT (' C2ORDR: ',A,' only supported with a section 2.')
 9130 FORMAT (' C2ORDR: ',A,'/',A,': not supported.')
 9131 FORMAT (' C2ORDR: Approx. s4 length, ',A,',',I3,
     X        '-length groups:',I9,'.')
 9132 FORMAT (' C2ORDR: Range diagnostic is ',A,
     X        ' of spatial differences, order',I2,'.')
 9133 FORMAT (' C2ORDR: Selected order:',I2,', range diagnostics:',
     X        4I8,'.')
 9140 FORMAT (' C2ORDR: KSEC4(',I2,') must be 0 or ',I2,'.')
 9150 FORMAT (' C2ORDR: General extended packing implies ',A,'.')
 9153 FORMAT (' C2ORDR: Boustrophedonic ordering ignored with ',
     X        'row by row packing.')
 9155 FORMAT (' C2ORDR: KSEC4(',I2,') must be 0, -1 or ',I2,'.')
 9156 FORMAT (' C2ORDR: Spatial differencing ignored without ',
     X        'general extended 2nd-order packing.')
 9160 FORMAT (' C2ORDR: Bits number =',I3,' - maximum allowed =',I3,
     X        '.')
 9170 FORMAT (' C2ORDR: Constant width =',I3,
     X        ' - out of range [-/+',I2,'(=KSEC4(2)-1)].')
 9175 FORMAT (' C2ORDR: Constant field, value = ',F30.20,'.')
 9180 FORMAT (' C2ORDR: INROWS =',I6,', KLEN =',I9,', LQUASI = ',L1,
     X        '.')
 9185 FORMAT (' C2ORDR: Inconsistency: total g.p. number =',I9,
     X        ' expected =',I9,'.')
 9187 FORMAT (' C2ORDR: ',I9,' bits set in primary bit-map -',
     X        ' not in range [1,KSEC4(1)=',I9,'].')
 9190 FORMAT (' C2ORDR: Too much rows:',I6,' exceeds work space:',I6,
     X        '.')
#ifndef wmogrp2o
 9192 FORMAT (' C2ORDR: Implicit 1ary bit-map/g.p. number >',I6,
     X        ': unsupported.')
#endif
 9195 FORMAT (' C2ORDR: No packing method selected or applicable.',
     X        ' C2ORDR: Simple packing applied as backup.')
C
 9200 FORMAT (' C2ORDR: LROW=',L1,', LCTWID=',L1,', LGEN2O=',L1,
     X        ', LGENXT=',L1,', LBOUST=',L1,', IORDER=',I1,
     X        ', LSIMPK=',L1,'.')
C
 9210 FORMAT (' C2ORDR: (row by row) IRET, IROWBF, IROWL4, IL4OPT=',
     X        I6,I3,I9,I9,'.')
C
 9310 FORMAT (' C2ORDR: (cons.width) IRET, ICWIBF, ICWIL4, IL4OPT=',
     X        I6,I3,I9,I9,'.',/,
     X        ' C2ORDR:              ICWIFO, IHWM, ICWORK=',2I8,I2,'.')
C
 9320 FORMAT ('Constant width (',I2,')')
C
 9410 FORMAT (' C2ORDR: (general 2o) IRET, IGENBF, IGENL4, IL4OPT=',
     X        I6,I3,I9,I9,'.',/,
     X        ' C2ORDR:              IGENFO, IHWM=',2I8,'.')
C
 9510 FORMAT (' C2ORDR: (gen.extend) IRET, IGXTBF, IGXTL4, IL4OPT=',
     X        I6,I3,I9,I9,'.',/,
     X        ' C2ORDR:              IGXTFO, IHWM, IORDER=',2I8,I2,'.')
 9520 FORMAT (' C2ORDR: Non-optimal spatial differencing at order',I2,
     X        ', general 2o is better...',/,
     X' C2ORDR: .. retrying gen.extend. without spatial differencing.')
C
 9710 FORMAT (' C2ORDR: HOPER = ',A1,' - ',A,
     X        ' packing applied, IL4OPT =',I9,'.')
 9720 FORMAT (' C2ORDR: Boustrophedonic ordering has been used.')
 9730 FORMAT (' C2ORDR: Spatial differencing applied, order is',I2,'.')
C
 9900 FORMAT (' C2ORDR: Function return code =',I6,' HOPER = ',A,
     X        ', KNSPT =',I10,'.')
C
      END

C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      INTEGER FUNCTION IARESET (KSEC2, KSEC4, KVALUES, KPR, KERR)
C
C---->
C**** *IARESET*
C
C     PURPOSE
C     _______
C
C     Generate the output field definition.
C
C     INTERFACE
C     _________
C
C     IERR = IARESET (KSEC2, KSEC4, KVALUES, KPR, KERR)
C
C     Input parameters
C     ________________
C
C     KSEC2      - The GRIB Section 2 array for the input field.
C
C     KSEC4      - The GRIB Section 4 array for the input field.
C
C     KVALUES    - The number of values in the output field.
C
C     KPR        - The debug print switch.
C                  0  , No debugging output.
C                  1  , Produce debugging output.
C
C     KERR       - The error control flag.
C                  -ve, No error message. Return error code.
C                  0  , Hard failure with error message.
C                  +ve, Print error message. Return error code.
C
C     Output parameters
C     ________________
C
C     KSEC2      - The modified GRIB Section 2 array for the output
C                  field.
C
C     KSEC4      - The modified GRIB Section 4 array for the output
C                  field.
C
C     Return value
C     ____________
C
C     The error indicator (INTEGER).
C
C     Error and Warning Return Values
C     _______________________________
C
C     None
C
C     Common block usage
C     __________________
C
C     nofld.common - This file contains all the output field
C                    definition variables.
C
C     NOACC        - Number of packing bits to be used for output
C                    GRIB field is used.
C     NOAREA       - Output field area definition (N/W/S/E) is used.
C     NOGAUSS      - Output field Gaussian truncation is used.
C     NOGRID       - Output field grid definition (WE/NS) is used.
C     NONS         - Number of grid points in NS direction for output
C                    field is used.
C     NOREPR       - Output field representation is used.
C     NOSCNM       - Output field scanning mode is used.
C     NOWE         - Number of grid points in WE direction for output
C                    field is used.
C
C     EXTERNALS
C     _________
C
C     SETPAR       - Standard routine used to generate "missing" data
C                    values for GRIB fields.
C     INTLOG(R)    - Logs messages.
C
C     METHOD
C     ______
C
C     This routine modifies sections 2 and 4 of the GRIB definition
C     to match the output field.
C
C     REFERENCE
C     _________
C
C     None
C
C     COMMENTS
C     ________
C
C     Program contains sections 0 to 4 and 9
C
C     AUTHOR
C     ______
C
C     K. Fielding      *ECMWF*      Apr 1994
C
C     MODIFICATIONS
C     _____________
C
C     None
C
C----<
C     _______________________________________________________
C
C
C*    Section 0. Definition of variables.
C     _______________________________________________________
C
C*    Prefix conventions for variable names
C
C     Logical      L (but not LP), global or common.
C                  O, dummy argument
C                  G, local variable
C                  LP, parameter.
C     Character    C, global or common.
C                  H, dummy argument
C                  Y (but not YP), local variable
C                  YP, parameter.
C     Integer      M and N, global or common.
C                  K, dummy argument
C                  I, local variable
C                  J (but not JP), loop control
C                  JP, parameter.
C     REAL         A to F and Q to X, global or common.
C                  P (but not PP), dummy argument
C                  Z, local variable
C                  PP, parameter.
C
C     Implicit statement to force declarations
C
      IMPLICIT NONE
C
#include "parim.h"
#include "nofld.common"
C
C     Dummy arguments
      INTEGER KVALUES, KPR, KERR
      INTEGER KSEC2 (JPGRIB_ISEC2), KSEC4 (JPGRIB_ISEC4)
C
C     Local variables
      INTEGER IWEINC, ITEMP, IMISS, IERR
      INTEGER JPROUTINE
      PARAMETER (JPROUTINE = 24200)
C
C     External functions
C
C     Transform definition variables that must be preserved
C
C
C     _______________________________________________________
C
C*    Section 1. Initialisation
C     _______________________________________________________
C
  100 CONTINUE
C
      IF (KPR.GE.1) CALL INTLOG(JP_DEBUG,'IARESET: Section 1.',JPQUIET)
C
      IARESET = 0
      IERR = 0
C
      IF (KPR .GE. 1) THEN
        CALL INTLOG(JP_DEBUG,'IARESET: Input parameters.',JPQUIET)
        CALL INTLOG(JP_DEBUG,
     X    'IARESET: No.bits for output field packing = ',NOACC)
        CALL INTLOG(JP_DEBUG,
     X    'IARESET: No.values to be packed = ',KVALUES)
        IF (NOREPR .EQ. JPREGULAR) THEN
          CALL INTLOG(JP_DEBUG,
     X      'IARESET: West-East stride = ', NOGRID (JPWESTEP))
          CALL INTLOG(JP_DEBUG,
     X      'IARESET: North-South stride = ', NOGRID (JPNSSTEP))
        ELSE
          CALL INTLOG(JP_DEBUG,
     X      'IARESET: Gaussian truncation = ',NOGAUSS)
        ENDIF
      ENDIF
C
C     Get GRIB missing data value
C
      CALL SETPAR (ITEMP, IMISS, KPR)
C
C     Representation
C
      KSEC2 (JPSEC2_REP) = NOREPR
      KSEC2 (JPSEC2_SCAN) = NOSCNM
C
C     _______________________________________________________
C
C*    Section 2. Set Grib Section 2 regular grid variables
C     _______________________________________________________
C
  200 CONTINUE
C
      IF (NOREPR .EQ. JPREGULAR) THEN
C
      IF (KPR.GE.1) CALL INTLOG(JP_DEBUG,'IARESET: Section 2.',JPQUIET)
C
         KSEC2 (JPSEC2_QUASI) = 0
C
         KSEC2 (JPSEC2_NLONG) = NOWE
         KSEC2 (JPSEC2_NLAT) = NONS
C
         KSEC2 (JPSEC2_NORTH) = NOAREA (JPNORTH) / 10
         KSEC2 (JPSEC2_WEST) = NOAREA (JPWEST) / 10
         KSEC2 (JPSEC2_SOUTH) = NOAREA (JPSOUTH) / 10
C
         IF (MOD (NOAREA (JPEAST), 10) .EQ. 5) THEN
            KSEC2 (JPSEC2_EAST) = NOAREA (JPEAST) / 10 + 1
         ELSE
            KSEC2 (JPSEC2_EAST) = NOAREA (JPEAST) / 10
         ENDIF
C
         IF (MOD (NOGRID (JPWESTEP), 10) .EQ. 5 .OR.
     X      MOD (NOGRID (JPNSSTEP), 10) .EQ. 5) THEN
C
            KSEC2 (JPSEC2_RESOL) = 0
            KSEC2 (JPSEC2_DLONG) = IMISS
            KSEC2 (JPSEC2_DLAT) = IMISS
C
         ELSE
C
            KSEC2 (JPSEC2_RESOL) = 128
            KSEC2 (JPSEC2_DLONG) = NOGRID (JPWESTEP) / 10
            KSEC2 (JPSEC2_DLAT) = NOGRID (JPNSSTEP) / 10
C
         ENDIF
C
C     _______________________________________________________
C
C*    Section 3. Set Grib Section 2 Gaussian values
C     _______________________________________________________
C
  300 CONTINUE
C
      ELSE IF (NOREPR .EQ. JPGAUSSIAN) THEN
C
      IF (KPR.GE.1) CALL INTLOG(JP_DEBUG,'IARESET: Section 3.',JPQUIET)
C
         KSEC2 (JPSEC2_QUASI) = 0
C
         KSEC2 (JPSEC2_GTRUNC) = NOGAUSS
         KSEC2 (JPSEC2_NLONG) = NOWE
         KSEC2 (JPSEC2_NLAT) = NONS
C
         KSEC2 (JPSEC2_NORTH) = NOAREA (JPNORTH) / 10
         KSEC2 (JPSEC2_WEST) = NOAREA (JPWEST) / 10
         KSEC2 (JPSEC2_SOUTH) = NOAREA (JPSOUTH) / 10
C
         IF (MOD (NOAREA (JPEAST), 10) .EQ. 5) THEN
            KSEC2 (JPSEC2_EAST) = NOAREA (JPEAST) / 10 + 1
         ELSE
            KSEC2 (JPSEC2_EAST) = NOAREA (JPEAST) / 10
         ENDIF
C
         IWEINC = JP90 / NOGAUSS
C
         IF (MOD (IWEINC, 10) .EQ. 5) THEN
C
            KSEC2 (JPSEC2_RESOL) = 0
            KSEC2 (JPSEC2_DLONG) = IMISS
C
         ELSE
C
            KSEC2 (JPSEC2_RESOL) = 128
            KSEC2 (JPSEC2_DLONG) = IWEINC / 10
C
         ENDIF
C
      ENDIF
C
C     _______________________________________________________
C
C*    Section 4. Set Grib Section 4 values
C     _______________________________________________________
C
  400 CONTINUE
C
      IF (KPR.GE.1) CALL INTLOG(JP_DEBUG,'IARESET: Section 4.',JPQUIET)
C
      KSEC4 (JPSEC4_NVALUE) = KVALUES
C
      IF (NOACC .NE. 0) KSEC4 (JPSEC4_NBITS) = NOACC
C
C     _______________________________________________________
C
C*    Section 9. Return to calling routine. Format statements
C     _______________________________________________________
C
  900 CONTINUE
C
      IF (KPR.GE.1) CALL INTLOG(JP_DEBUG,'IARESET: Section 9.',JPQUIET)
C
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C


      SUBROUTINE LDC1CR (HVERB,HOWN,HEXP,HTYP,HCLS,HSTR,HRUT,KPR,KRC)
C
C
C---->
C**** LDC1CR
C
C     PURPOSE.
C     --------
C
C           LIST ALL NODES AND FILES FOR A GIVEN RESEARCH EXPERIMENT.
C           FILES AND NODES UNDER OPERATIONS TEST ROOT-NODE MATST CAN
C           ALSO BE LISTED. OPERATIONAL ARCHIVES CANNOT BE LISTED -
C           THE VOLUME IS FAR TOO GREAT.
C
C           REMOVE ALL NODES AND FILES FOR A GIVEN RESEARCH EXPERIMENT.
C           FILES AND NODES UNDER OPERATIONS TEST ROOT-NODE MATST CAN
C           ALSO BE REMOVED. OPERATIONAL ARCHIVES CANNOT BE REMOVED.
C
C**   INTERFACE.
C     ----------
C
C           CALL LDC1CR (HVERB,HOWN,HEXP,HTYP,HCLS,HSTR,HRUT,KPR,KRC)
C
C
C           INTEGER    K.
C           REAL       P.
C           LOGICAL    O.
C           CHARACTER  H.
C
C               INPUT PARAMETERS.
C               -----------------
C
C               HVERB      - ACTION REQUIRED. 'LIST' OR 'REMOVE'
C
C               HOWN       - OWNER'S PASSWORD. 6 CHARACTERS FOR
C                            RESEARCH EXPERIMENT, 5 FOR OPERATIONS.
C
C               HEXP       - 4 CHARACTER EXPERIMENT IDENTIFIER.
C
C               HSTR       - ARCHIVE STREAM.
C                            FOR RESEARCH.
C                                DA - DAILY ARCHIVE.
C                            FOR OPERATIONS.
C                                DA - DAILY ARCHIVE.
C                                CH - CHERNOBYL ARCHIVE.
C                                TG - TOGA ARCHIVE.
C                                MO - MONTHLY ARCHIVE.
C
C               HTYP       - DATA TYPE.
C                            AN  - ANALYSIS.
C                            IA  - INITIALISED ANALYSIS.
C                            FG  - FIRST GUESS.
C                            FC  - FORECAST.
C                            EA  - ERRORS IN ANALYSIS.
C                            CL  - CLIMATOLOGY.
C                            ALL - ALL TYPES.
C
C               HCLS       - OD , OPERATIONS.
C                            RD , RESEARCH.
C
C               HRUT       - ROOT NODE TO BE USED.
C                            FOR RESEARCH.
C                               P , PRODUCTION ROOT MARSR.
C                               T , TEST ROOT MATSR.
C                            FOR OPERATIONS.
C                               P , PRODUCTION ROOT MARST.
C                               O , OLD PRODUCTION ROOT MARSO.
C                               T , TEST ROOT MATST.
C
C               KPR        - DEBUG PRINT SWITCH.
C                            0 , NO PRINTOUT.
C                            1 , DEBUG PRINTOUT.
C
C               OUTPUT PARAMETERS.
C               ------------------
C
C               KRC        - ERROR RETURN CODE.
C                        0 - NO ERROR ENCOUNTERED.
C                        1 - EXPERIMENT DOES NOT EXIST
C                        2 - EXPERIMENT IDIDENTIFIER NOT 4 CHARACTERS.
C                        3 - ACTION ATTEMPTED ON OPERATIONAL NODES OR
C                            FILES.
C                        4 - ERROR REPORTED BY ECFILE.
C                        5 - OWNER PASSWORD INCORRECT LENGTH.
C                        6 - NO FREE FORTRAN UNIT NUMBERS.
C
C
C     METHOD.
C     -------
C
C           EXPERIMENT IDENTIFIER , DATA TYPE, CLASS AND ROOT ARE USED
C           TO DETERMINE NODES AND FILES, WHICH ARE THEN LISTED.
C           THE LIST IS USED TO DELETE NODES AND FILES IF REQUESTED.
C
C     EXTERNALS.
C     ----------
C
C           ECFILE
C           L2U1CR
C
C     REFERENCE.
C     ----------
C
C           NONE.
C
C     COMMENTS.
C     ---------
C
C           PROGRAM CONTAINS SECTIONS 0 TO 6 AND SECTION 9.
C
C
C     AUTHOR.
C     -------
C
C           J.HENNESSY       ECMWF      04:07:89.
C
C     MODIFICATIONS
C     --------------
C
C           NONE.
C
C     ----------------------------------------------------------------
C----<
C
C
C
C
C
C
C
C
C
C
C*    SECTION 0 . DEFINITION OF VARIABLES. SET INITIAL VALUES.
C     ----------------------------------------------------------------
C
      IMPLICIT LOGICAL     ( L, O, G )
      IMPLICIT CHARACTER*8 ( C, H, Y )
      IMPLICIT INTEGER     ( I, J, K, M, N )
C
C
C
C
C
      DIMENSION      YPATH(3)
      DIMENSION      YIU(6)
      DIMENSION      IU(6)
      DIMENSION      IREASON(5)
C
      CHARACTER*1    YCOMMA,YSTOP
      CHARACTER*2    YIU
      CHARACTER*5    YPATHC
C
      CHARACTER*8    HVERB
      CHARACTER*6    HOWN
      CHARACTER*4    HEXP
      CHARACTER*2    HSTR
      CHARACTER*4    HTYP
      CHARACTER*2    HCLS
      CHARACTER*1    HRUT
C
      CHARACTER*7    YLFNIN
      CHARACTER*11   YLSTNA
      CHARACTER*15   YNODE
      CHARACTER*17   YPATH
      CHARACTER*80   YLINE1
      CHARACTER*80   YLINE2
      CHARACTER*80   YPATH1
      CHARACTER*80   YPATH2
C
      YLSTNA    = 'FN=LIST,NA,'
      YCOMMA    = ','
      YSTOP     = '.'
C
C     DEFAULT VALUES FOR NODES/FILES ARE RESEARCH PRODUCTION NODES AND
C     FILES.
C
      YPATHC    = 'PATH='
      YPATH(1)  = '/MARSR           '
      YPATH(2)  = '/CACHE/MARSR     '
      YPATH(3)  = '/MARSBACKUP/MARSR'
C
C     CHECK IF ACTION REQUIRED ON RESEARCH TEST ROOT.
C
      IF (HCLS.EQ.'RD'.AND.HRUT.EQ.'T')
     C   THEN
             YPATH(1)  = '/MATSR           '
             YPATH(2)  = '/CACHE/MATSR     '
             YPATH(3)  = '/MARSBACKUP/MATSR'
         ENDIF
C
C     CHECK IF ACTION REQUIRED ON OPERATIONS TEST ROOT.
C
      IF (HCLS.EQ.'OD'.AND.HRUT.EQ.'T')
     C   THEN
             YPATH(1)  = '/MATST           '
             YPATH(2)  = '/CACHE/MATST     '
             YPATH(3)  = '/MARSBACKUP/MATST'
         ENDIF
C
C     CHECK FOR ATTEMPTED ACTION ON OPERATIONS PRODUCTION ROOTS.
C
      IF (HCLS.EQ.'OD'.AND.HRUT.NE.'T')
     C   THEN
             KRC = 3
             WRITE (*,9100)
             GO TO 9000
         ENDIF
C
C     GET 6 UNUSED FORTRAN UNIT NUMBERS.
C
      DO 10 J10 =1,6
         CALL FTN1CR (IU(J10),KPR,ISERR)
         IF (ISERR.NE.0)
     C      THEN
                WRITE (*,9800)
                KRC = 6
                GO TO 9000
            ENDIF
         WRITE (YIU(J10),'(I2.2)') IU(J10)
         OPEN (UNIT=IU(J10),STATUS='SCRATCH')
   10 CONTINUE
C
C
C
      JLOOP  = 0
      KRC    = 0
      IFLAG  = 0
C
C
C
C
C
C
C
C
C
C
C*    SECTION 1 . PREPARE LIST COMMAND USING PATHNAME AND GET NODE1.
C     ----------------------------------------------------------------
C
 1000 CONTINUE
C
      IF (KPR.EQ.1) WRITE (*,*) 'LDC1CR : SECTION 1'
C
C*    GO TO SECTION 9 IF ERROR IN EXPERIMENT IDENTIFIER .
C
      I = INDEX (HEXP,' ')
      IF (I.NE.0)
     C   THEN
             KRC = 2
             WRITE(*,9300) HEXP
             IFLAG = 1
             GO TO 9000
         ENDIF
C
C*    IF ACTION IS 'REMOVE' CHECK PASSWORD LENGTH.
C
      IF (HVERB.EQ.'REMOVE  ')
     C   THEN
             IL = INDEX (HOWN,' ')
             IF (IL.EQ.6) IL = 5
             IF (IL.EQ.0) IL = 6
             IF (IL.EQ.5.AND.HCLS.NE.'OD') KRC = 5
             IF (IL.EQ.6.AND.HCLS.NE.'RD') KRC = 5
             IF (KRC.NE.0)
     C          THEN
                    WRITE (*,9400) HOWN
                    GO TO 9000
                ENDIF
         ENDIF
C
C     LOOP ROUTINE FOR EACH TYPE OF PATHNAME
C
C     IF JLOOP = 1 LOOK FOR NODES BEGINNING WITH /MARSR
C     IF JLOOP = 2 LOOK FOR NODES BEGINNING WITH /CACHE/MARSR
C     IF JLOOP = 3 LOOK FOR NODES BEGINNING WITH /MARSBACKUP/MARSR
C
      JLOOP = JLOOP + 1
      IF (JLOOP.GT.3) GO TO 6000
C
C*    REWIND ALL FILES AT BEGINNING OF EACH LOOP
C
      REWIND IU(1)
      REWIND IU(2)
      REWIND IU(3)
      REWIND IU(4)
C
      YLFNIN        = 'L=FT' // YIU(1)
      YLINE1(1:)    = ' '
      YLINE1(1:11)  = YLSTNA
      YLINE1(12:17) = YLFNIN
      YLINE1(18:18) = YCOMMA
      YLINE1(19:23) = YPATHC
      YLINE1(24:)   = YPATH(JLOOP)
C
      IJ = INDEX(YLINE1,' ')
      YLINE1(IJ:IJ) = YSTOP
C
      IF (KPR.EQ.1) WRITE (*,'(1X,A80)') YLINE1
C
      CALL ECFILE (IERR,IREASON,YLINE1)
C
C*    TRAP CFS RETURN CODES FOR FILE/NODE DOES NOT EXIST.
C
      IF (IERR .EQ. 9.
     C   AND.IREASON(1).EQ.1.
     C   AND.IREASON(2).EQ.1.
     C   AND.IREASON(3).EQ.33) GO TO 1000
C
C*    GO TO SECTION 9 , IF ANY OTHER ERROR REPORTED.
C
      IF (IERR.NE.0)
     C   THEN
C
             KRC = 4
             WRITE (*,9500) IERR, IREASON
             WRITE (*,9600) YLINE1
             GO TO 9000
         ENDIF
C
C     ----------------------------------------------------------------
C
C
C
C
C
C
C
C
C
C*    SECTION 2 . ISSUE LIST COMMAND(S) USING PATHNAME/NODE1/EXPID.
C     ---------------------------------------------------------------
C
C
 2000 CONTINUE
C
      IF (KPR.EQ.1) WRITE (*,*) 'LDC1CR : SECTION 2'
C
C     CREATE EACH PATHNAME + NODE(S)
C     IF TYPE = ALL THEN LIST ALL TYPES
C
      REWIND IU(1)
C
 2100 CONTINUE
      READ (IU(1),'(A80)',END=6000) YLINE1
      CALL L2U1CR (YLINE1)
      IF (YLINE1(19:22).NE.'DESC') GO TO 2100
C
C
 2200 CONTINUE
      READ (IU(1),'(A80)',END=6000) YLINE1
      CALL L2U1CR (YLINE1)
      IF (YLINE1(19:22).EQ.'    ') GO TO 1000
C
      IF (HTYP(1:3).EQ.'ALL') GO TO 2220
      IF (HTYP(1:2).NE.YLINE1(19:20)) GO TO 2200
C
 2220 CONTINUE
      YNODE = '/' // YLINE1(19:20) // '/' // HEXP
      IF (JLOOP .EQ. 1) YPATH1 = YPATH(JLOOP)(1:6) // YNODE
      IF (JLOOP .EQ. 2) YPATH1 = YPATH(JLOOP)(1:12) // YNODE
      IF (JLOOP .EQ. 3) YPATH1 = YPATH(JLOOP) // YNODE
C
C
      YLFNIN         = 'L=FT'//YIU(2)
      YLINE1(1:11)   = YLSTNA
      YLINE1(12:17)  = YLFNIN
      YLINE1(18:18)  = YCOMMA
      YLINE1(19:23)  = YPATHC
      YLINE1(24:)    = YPATH1
      IJ = INDEX (YLINE1,' ')
      YLINE1(IJ:IJ)  = YSTOP
      IPTR = IJ
      IF (KPR.EQ.1) WRITE (*,'(1H ,A80)') YLINE1
C
      CALL ECFILE (IERR,IREASON,YLINE1)
C
C*    TRAP CFS RETURN CODES FOR FILE/NODE DOES NOT EXIST.
C
      IF (IERR.EQ.9.
     C    AND.IREASON(1).EQ.1.
     C    AND.IREASON(2).EQ.1.
     C    AND.IREASON(3).EQ.33) GO TO 2200
C
C*    GO TO SECTION 9 , IF ANY OTHER ERROR REPORTED.
C
      IF (IERR.NE.0)
     C   THEN
             KRC = 4
             WRITE (*,9500) IERR, IREASON
             WRITE (*,9600) YLINE1
             GO TO 9000
         ENDIF
C
C     SET FLAG TO INDICATE NODE FOUND FOR GIVEN EXPERIMENT IDENTIFIER.
C
      IFLAG = 1
C
C     -----------------------------------------------------------------
C
C
C
C
C
C
C
C
C*    SECTION 3 . ISSUE LIST COMMAND USING PATHNAME/NODE1/EXPID/NODE2.
C     ------------------------------------------------------------------
C
 3000 CONTINUE
C
      IF (KPR.EQ.1) WRITE (*,*) 'LDC1CR : SECTION 3'
C
C     CREATE PATHNAME WITH NEXT NODE.
C
      REWIND IU(2)
 3100 CONTINUE
      READ (IU(2),'(A80)',END=2200) YLINE1
      CALL L2U1CR (YLINE1)
      IF (YLINE1(19:22).NE.'DESC')  GO TO 3100
C
      IPT1 = 0
 3200 CONTINUE
      READ (IU(2),'(A80)',END=2200) YLINE1
      CALL L2U1CR (YLINE1)
      IF (YLINE1(19:22).EQ.'    ')  GO TO 2200
      YNODE = '/'//YLINE1(19:22)
      IJ = INDEX (YPATH1,' ')
      IF (IPT1.EQ.0) IPT1 = IJ - 1
      YPATH1 = YPATH1(1:IPT1)//YNODE
C
      YLINE1(1:)     = ' '
      YLFNIN         = 'L=FT'//YIU(3)
      YLINE1(1:11)   = YLSTNA
      YLINE1(12:17)  = YLFNIN
      YLINE1(18:18)  = YCOMMA
      YLINE1(19:23)  = YPATHC
      YLINE1(24:) = YPATH1
      IJ = INDEX (YLINE1,' ')
      YLINE1(IJ:IJ)  = YSTOP
      IF (KPR.EQ.1) WRITE (*,'(1H ,A80)') YLINE1
C
      CALL ECFILE (IERR,IREASON,YLINE1)
C
C*    TRAP CFS RETURN CODES FOR FILE/NODE DOES NOT EXIST.
C
      IF (IERR.EQ.9.
     C   AND.IREASON(1).EQ.1.
     C   AND.IREASON(2).EQ.1.
     C   AND.IREASON(3).EQ.33) GO TO 3200
C
C*    GO TO SECTION 9 , IF ANY OTHER ERROR REPORTED.
C
      IF (IERR.NE.0)
     C   THEN
             KRC = 4
             WRITE (*,9500) IERR, IREASON
             WRITE (*,9600) YLINE1
             GO TO 9000
         ENDIF
C
C    ----------------------------------------------------------------
C
C
C
C
C
C
C
C
C
C
C*    SECTION 4. ISSUE LIST COMMAND PATHNAME/NODE1/EXPID/NODE2/NODE3.
C     ------------------------------------------------------------------
C
 4000 CONTINUE
C
      IF (KPR.EQ.1) WRITE (*,*) 'LDC1CR : SECTION 4'
C
      REWIND IU(3)
C
 4200 CONTINUE
      READ (IU(3),'(A80)',END=3200) YLINE1
      CALL L2U1CR (YLINE1)
      IF (YLINE1(19:22).NE.'DESC')  GO TO 4200
C
 4300 CONTINUE
      READ (IU(3),'(A80)',END=3200) YLINE1
      CALL L2U1CR (YLINE1)
      IF (YLINE1(19:22).EQ.'    ')  GO TO 3200
      YNODE = '/'//YLINE1(19:22)
      IJ = INDEX (YPATH1,' ')
      IPTR = IJ - 1
      YPATH1 = YPATH1(1:IPTR)//YNODE
      YPATH2 = YPATH1
      WRITE (*,'(1H1,''CFS PATHNAME -'')')
      WRITE (*,'(5X,A80)') YPATH1
C
C*    WRITE PATHNAME TO FILE USED IN DELETING NODES .
C
      YLINE2='FN=REMOVE,PW='//HOWN(1:IL)//',NA,PATH='//YPATH2
      IJ = INDEX (YLINE2,' ')
      YLINE2(IJ:) = '.'
      WRITE (IU(6),'(A80)') YLINE2
C
C
      REWIND IU(4)
      YLINE1(1:)     = ' '
      YLFNIN         = 'L=FT'//YIU(4)
      YLINE1(1:11)   = YLSTNA
      YLINE1(12:17)  = YLFNIN
      YLINE1(18:18)  = YCOMMA
      YLINE1(19:23)  = YPATHC
      YLINE1(24:)    = YPATH1
      IJ = INDEX (YLINE1,' ')
      YLINE1(IJ:IJ)  = YSTOP
      YPATH1(IPTR+1: ) = ' '
      IF (KPR.EQ.1) WRITE (*,'(1H ,A80)') YLINE1
C
      CALL ECFILE (IERR,IREASON,YLINE1)
C
C*    TRAP CFS RETURN CODES FOR FILE/NODE DOES NOT EXIST.
C
      IF (IERR.EQ.9.
     C   AND.IREASON(1).EQ.1.
     C   AND.IREASON(2).EQ.1.
     C   AND.IREASON(3).EQ.33) GO TO 4300
C
C*    GO TO SECTION 9 , IF ANY OTHER ERROR REPORTED.
C
      IF (IERR.NE.0)
     C   THEN
             KRC = 4
             WRITE (*,9500) IERR, IREASON
             WRITE (*,9600) YLINE1
             GO TO 9000
         ENDIF
C
C     ---------------------------------------------------------------
C
C
C
C
C
C
C
C
C
C
C*    SECTION 5. PRINT OUT CFS FILE NAMES.
C     ---------------------------------------------------------------
C
 5000 CONTINUE
C
      IF (KPR.EQ.1) WRITE (*,*) 'LDC1CR : SECTION 5.'
C
      REWIND (IU(4))
C
      WRITE (*,'(1H ,''CFS-FILES'')')
 5100 CONTINUE
      READ (IU(4),'(A80)',END=5300) YLINE1
      CALL L2U1CR (YLINE1)
      IF (YLINE1(19:22).NE.'DESC') GO TO 5100
C
 5200 CONTINUE
      READ (IU(4),'(A80)',END=5300) YLINE1
      CALL L2U1CR (YLINE1)
      IF (YLINE1(19:22).EQ.'    ') GO TO 4300
      WRITE (*,'(5X,A14)') YLINE1(19:32)
      YLINE2='FN=DELETE,PW='//HOWN(1:IL)//',NA,PATH='//YPATH2
      IJ = INDEX (YLINE2,' ')
      INOD = IJ
      YLINE2(IJ:) = '/'//YLINE1(19:32)//'.'
C
C*    WRITE PATHNAME TO FILE USED IN DELETING FILES .
C
      WRITE (IU(5),'(A80)') YLINE2
      GO TO 5200
 5300 CONTINUE
      WRITE (*,*) 'HOW DID I GET HERE'
      YLINE2 = YLINE2(1:IJ-1)//'.'
      WRITE (*,'(1H ,A80)') YLINE2
      GO TO 4300
C
C     ---------------------------------------------------------------
C
C
C
C
C
C
C
C
C
C
C*    SECTION 6 . DELETE CFS FILES AND REMOVE NODES . IF REQUIRED.
C     ------------------------------------------------------------------
C
 6000 CONTINUE
C
      IF (KPR.EQ.1) WRITE (*,*) 'LDC1CR : SECTION 6.'
C
C*    GO TO SECTION 9 IF LIST OF NODES AND FILES ONLY.
C
      IF (HVERB.EQ.'LIST    ') GO TO 9000
      IERR=0
C
C     DELETE FILES.
C
      REWIND IU(5)
 6100 CONTINUE
      READ (IU(5),'(A80)',END=6200) YLINE2
C
      IF (KPR.EQ.1) WRITE (*,'(1H ,A80)') YLINE2
      CALL ECFILE (IERR,IREASON,YLINE2)
C
C*    GO TO SECTION 9 , IF ERROR REPORTED.
C
      IF (IERR.NE.0)
     C   THEN
             KRC = 4
             WRITE (*,9700) IERR, IREASON
             WRITE (*,9600) YLINE2
             GO TO 9000
         ENDIF
C
      GO TO 6100
C
 6200 CONTINUE
C
C     REMOVE NODES.
C
      REWIND IU(6)
 6300 CONTINUE
      READ (IU(6),'(A80)',END=6400) YLINE2
 6350 CONTINUE
      IF (KPR.EQ.1) WRITE (*,'(1H ,A80)') YLINE2
      CALL ECFILE (IERR,IREASON,YLINE2)
C
C     TRAP RETURN CODES FOR NODE HAS DESCENDANTS. EXPERIMENT
C     IDENTIFIER NODES CAN HAVE SEVERAL DESCENDANTS, AND ARE
C     REMOVED WHEN ALL DESCENDANTS HAVE BEEN REMOVED.
C
      IF (IERR.EQ.9.
     C    AND.IREASON(1).EQ.1.
     C    AND.IREASON(2).EQ.104.
     C    AND.IREASON(3).EQ.0)   GO TO 6300
C
C*    GO TO SECTION 9 , IF ERROR REPORTED.
C
      IF (IERR.NE.0)
     C   THEN
             KRC = 4
             WRITE (*,9700) IERR, IREASON
             WRITE (*,9600) YLINE2
             GO TO 9000
         ENDIF
C
C     MODIFY COMMAND AS LAST NODE HAS BEEN REMOVED.
C
      I = INDEX (YLINE2,'.')
      DO 6360 J6360 = I,1,-1
         IF (YLINE2(J6360:J6360).EQ.'/')
     C      THEN
                YLINE2(J6360:) = '.'
                GO TO 6370
            ENDIF
 6360 CONTINUE
C
 6370 CONTINUE
C
C     NODES ARE REMOVED ONLY AS FAR AS THE TYPE NODE EG AN,OR FC.
C
      IF (YLINE2(J6360-3:J6360-3).NE.'/') GO TO 6350
C
      GO TO 6300
C
C
 6400 CONTINUE
C
C
C
C     ------------------------------------------------------------------
C
C
C
C
C
C
C
C
C
C
C
C*    SECTION 9 . RETURN TO CALLING ROUTINE.FORMAT STATEMENTS.
C     ------------------------------------------------------------------
C
C
 9000 CONTINUE
C
      IF (KPR.EQ.1) WRITE (*,*) 'LDC1CR : SECTION 9.'
C
C     CLOSE AND RETURN FILES.
C
      DO 9010 J9010=1,6
         CLOSE (UNIT=IU(J9010))
 9010 CONTINUE
C
C     SEE IF THE EXPERIMENT DOES EXIST IN CFS (IE IFLAG =1)
C
      IF (IFLAG .EQ. 0)
     C   THEN
          KRC = 1
          WRITE (*,9200) HEXP
         ENDIF
      RETURN
C
C
 9100 FORMAT (' LDC1CR : ACTION ATTEMPTED ON OPERATIONAL PRODUCTION',
     C          ' NODES OR FILES.')
C
 9500 FORMAT (' LDC1CR : NODE/FILE LISTING ERROR. FAILURE CODE = ',I3,
     C          ' , REASON CODES = ',3I6,'.')
C
 9600 FORMAT (1H ,A)
C
 9700 FORMAT (' LDC1CR : NODE/FILE REMOVAL ERROR. FAILURE CODE = ',I3,
C
     C          ' , REASON CODES = ',3I6,'.')
C
 9800 FORMAT (' LDC1CR : NO FREE FORTRAN UNIT NUMBERS.')
C
 9200 FORMAT (' LDC1CR : EXPERIMENT IDENTIFIER OF ',A5,' NOT IN CFS')
C
 9300 FORMAT (' LDC1CR : EXPERIMENT IDENTIFIER NOT 4 CHARACTERS - ',
     C          A)
 9400 FORMAT (' LDC1CR : OWNER (PASSWORD) INVALID - ',A)
C
C     ------------------------------------------------------------------
C
C
      END

C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

#ifdef CRAY
      SUBROUTINE UNBLOCK (UN1,UN2,IRET)
C
C---->
C**********************************************************************
C*                                                                    *
C*    NAME      : UNBLOCK                                             *
C*                                                                    *
C*    FUNCTION  : CONVERTS CRAY BLOCKED DATASET OF GRIB DATA INTO AN  *
C*                UNBLOCKED DATASET                                   *
C*                                                                    *
C*    INPUT     : UN1   = INPUT  LUN                                  *
C*                UN2   = OUTPUT LUN                                  *
C*                                                                    *
C*    OUTPUT    : IRET  = -100   BUFFER IN  ERROR                     *
C*                      = -200   BUFFER OUT ERROR                     *
C*                      > 0      NO. OF BLOCKS WRITTEN                *
C*                                                                    *
C*    GENERAL   : UNBLOCK CALLS   -----                               *
C*                                                                    *
C*    AUTHOR    : B.V. GURETZKY     V.E. DAY                          *
C*                                                                    *
C*    MODIFIED  : J. HENNESSY       26.11.85                          *
C*                                                                    *
C**********************************************************************
C----<
C
      IMPLICIT INTEGER (B,U)
      PARAMETER (BLEN=25088)
      DIMENSION BUF(BLEN+512)
C
C     NO OF WORDS PER BLOCK (UNBLOCKED DATASET ICB = 512 )
      DATA ICB /512/
C
      IRET = 0
      IRES = 0
C
      DO 5000 J = 1,10000
C
C        READ INPUT FILE RECORD.
C
         BUFFER IN (UN1,0) (BUF(IRES+1),BUF(BLEN+ICB))
         IUNIT = UNIT(UN1)
         IF (UNIT(UN1)) 1000,5500,10000
 1000    CONTINUE

         LEN  = IRES + LENGTH(UN1)
         K    = LEN  / ICB
         IE   = K    * ICB
         IRES = LEN  - IE
C
         IF (K.NE.0)
     C      THEN
C
C               WRITE FIRST CHUNK OF ICB-BLOCKS
C
                BUFFER OUT (UN2,0) (BUF(1),BUF(IE))
                IUNIT = UNIT(UN2)
                IF (IUNIT.GT.0) GO TO 10100
                IRET = IRET + K
C
C               MOVE REMAINDER OF BLOCK TO FRONT AND GET NEXT RECORD.
C
                DO 4000 I = 1,IRES
                   BUF(I) = BUF(IE+I)
 4000           CONTINUE
C
            ENDIF
C
 5000 CONTINUE
C
C
C     HANDLE LAST BLOCK, SETTING UNUSED WORDS OF LAST BLOCK TO 0.
C
 5500 IF (IRES.NE.0)
     C   THEN
             IRES = IRES + 1
             DO 6000 I = IRES,ICB
                BUF(I) = 0
 6000        CONTINUE
             BUFFER OUT (UN2,0)(BUF(1),BUF(ICB))
             IUNIT = UNIT(UN2)
             IF (IUNIT.GT.0) GO TO 10100
             IRET = IRET + 1
         ENDIF
C
      RETURN
C
10000 CONTINUE
      IRET = -100
      WRITE (*,*) 'UNBLOCK : BUFFER IN ERROR'
      RETURN
C
10100 CONTINUE
      IRET = -200
      WRITE (*,*) 'UNBLOCK : BUFFER OUT ERROR'
      RETURN
C
      END
#endif

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE BUENS2( KSEC1,KSEC2,KBUFL,KBUFF,KERR )
C
C**** *BUENS2*
C
C
C     PURPOSE.
C     --------
C          PACK SECTION 2 OF BUFR MESSAGE.
C
C
C**   INTERFACE.
C     ----------
C
C          *CALL* *BUENS2(KSEC1,KSEC2,KBUFL,KBUFF,KERR)*
C
C
C        INPUT :
C               *KSEC1*   -  ARRAY CONTAINING SECTION 1 INFORMATION
C                            KSEC1( 1)-- LENGTH OF SECTION 1 (BYTES)
C                            KSEC1( 2)-- BUFR EDITION NUMBER
C                            KSEC1( 3)-- ORIGINATING CENTRE
C                            KSEC1( 4)-- UPDATE SEQUENCE NUMBER
C                            KSEC1( 5)-- FLAG (PRESENCE OF SECTION 2)
C                            KSEC1( 6)-- BUFR MESSAGE TYPE
C                            KSEC1( 7)-- BUFR MESSAGE SUBTYPE
C                            KSEC1( 8)-- VERSION NUMBER OF LOCAL TABLE USED
C                            KSEC1( 9)-- YEAR
C                            KSEC1(10)-- MONTH
C                            KSEC1(11)-- DAY
C                            KSEC1(12)-- HOUR
C                            KSEC1(13)-- MINUTE
C                            KSEC1(14)-- BUFR MASTER TABLE
C                            KSEC1(15)-- VERSION NUMBER OF MASTER TABLE USED
C                            KSEC1(16) TO KSEC1(JSEC1) - LOCAL ADP CENTRE
C                                        INFORMATION(PACKED FORM)
C
C                            FOR BUFR EDITION 3 ONWARD
C
C                            KSEC1(16)-- ORIGINATING SUB-CENTRE
C                            KSEC1(17)-- NOT USED
C                            KSEC1(18) TO KSEC1(JSEC1) - LOCAL ADP CENTRE
C                                        INFORMATION(PACKED FORM)
C
C                            FOR BUFR EDITION 4 ONWARD
C
C                            KSEC1(16)-- ORIGINATING SUB-CENTRE
C                            KSEC1(17)-- INTERNATIONAL SUB-CATEGORY (SEE COMMON TABLE C-13
C                            KSEC1(18)-- SECOND
C                            KSEC1(19)-- YEAR
C                            KSEC1(20)-- MONTH
C                            KSEC1(21)-- DAY
C                            KSEC1(22)-- HOUR
C                            KSEC1(23)-- MINUTE
C                            KSEC1(24)-- SECOND
C                            KSEC1(25)-- YEAR
C                            KSEC1(26)-- MONTH
C                            KSEC1(27)-- DAY
C                            KSEC1(28)-- HOUR
C                            KSEC1(29)-- MINUTE
C                            KSEC1(30)-- SECOND
C                            KSEC1(31)-- MOST SOUTHERN LATITUDE  (-90 to 90)
C                            KSEC1(32)-- MOST WESTERN LONGITUDE  ( 0-360)
C                            KSEC1(33)-- MOST NORTHEN LATITUDE   (-90 to 90)
C                            KSEC1(34)-- MOST EASTERN LONGITUDE  ( 0-360)
C                            KSEC1(35) TO KSEC1(JSEC1) - LOCAL ADP CENTRE INFORMATION(PACKED FORM)
C
C               *KSEC2*   -  ARRAY CONTAINING SECTION 2 INFORMATION
C                            KSEC2( 1)-- LENGTH OF SECTION 2 (BYTES)
C                            KSEC2( 2) TO KSEC2(JSEC2) LOCAL ADP CENTRE
C                                         INFORMATION (PACKED FORM)
C        OUTPUT :
C               *KBUFL*   -  LENGTH OF BUFR MESSAGE (WORDS)
C               *KBUFF*   -  ARRAY CONTAINING BUFR MESSAGE
C               *KERR*    -  RETURNED ERROR CODE
C
C     METHOD.
C     -------
C
C
C
C     EXTERNALS.
C     ----------
C
C          BUPCK          - PACK BIT PATHERN
C          BUOCTN         - SET LENGTH OF SECTION
C
C     REFERENCE.
C     ----------
C
C          NONE.
C
C     AUTHOR.
C     -------
C
C          M. DRAGOSAVAC    *ECMWF*       17/01/91.
C
C
C     MODIFICATIONS.
C     --------------
C
C          NONE.
C
C
      IMPLICIT LOGICAL(L,O,G), CHARACTER*8(C,H,Y)
C
C
#     include "parameter.F"
#     include "bcomunit.F"
#     include "bcmwork.F"
C
      DIMENSION KBUFF(KBUFL)
      DIMENSION KSEC1(JSEC1),KSEC2(JSEC2)
      DIMENSION IDUM(8),     ISEC2(JSEC2)
#ifndef R_4
      REAL*8 RVIND
      REAL*8 EPS
#else
      REAL   RVIND
      REAL   EPS
#endif
C
      DATA IDUM/8*0/
C
C     ------------------------------------------------------------------
C*          1.  EXPAND SECTION 2.
C               -----------------
 100  CONTINUE
C
      IF( KERR.NE.0 ) RETURN
C
      DO 101 I=1,JSEC2
      ISEC2(I)=0
 101  CONTINUE
C
      IF(KSEC1(5) .NE. 0 .AND. KSEC1(5) .NE.128) THEN
         KERR=50
         CALL BUERR(KERR)
         RETURN
      END IF
C
      IF( KSEC1(5).EQ.0) RETURN
C
C*          1.1  KEEP POINTERS TO THE BEGINING OF THE SECTION.
C                ---------------------------------------------
 110  CONTINUE
C
      IWPTB = NWPT
      IBPTB = NBPT
C
C*          1.2  PACK LENGTH OF SECTION 2.
C                -------------------------
      CALL BUPCK(NBPW,KBUFF(NWPT),0,NWPT,NBPT,24,KERR)
      IF(KERR.GT.0) THEN
         WRITE(KNTN,*) 'ERROR PACKING LENGTH OF SECTION 2.'
         RETURN
      END IF
      CALL BUPCK(NBPW,KBUFF(NWPT),0,NWPT,NBPT, 8,KERR)
      IF(KERR.GT.0) RETURN
C
C
C*          1.3  LOCAL ADP CENTRE INFORMATION.
C                -----------------------------
C
      IOFF=KSEC2(1)-4
      IF(IOFF.GT.0) THEN
         IW=2
         IB=0
         CALL BUNPKS(NBPW,KSEC2,ISEC2,IW,IB,8,0,IOFF,KERR)
         IF(KERR.GT.0) THEN
            WRITE(KNTN,*) 'ERROR PACKING LOCAL ADP CENTRE INFORMATION'
            WRITE(KNTN,*) 'IN SECTION 2.'
            RETURN
         END IF
C
         CALL BUPKS(NBPW,KBUFF(NWPT),ISEC2,NWPT,NBPT,8,0,IOFF,KERR)
         IF(KERR.GT.0) THEN
            WRITE(KNTN,*) 'ERROR PACKING LOCAL ADP CENTRE INFORMATION'
            WRITE(KNTN,*) 'IN SECTION 2.'
            RETURN
         END IF
      END IF
C
C
C*          1.5  SET UP LENGTH OF THE SECTION 2.
C                --------------------------------
 150  CONTINUE
C
      CALL BUOCTN(IWPTB,IBPTB,KBUFL,KBUFF,KERR)
      IF(KERR.GT.0) RETURN
C
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities
C granted to it by virtue of its status as an intergovernmental organisation
C nor does it submit to any jurisdiction.
C

      INTEGER FUNCTION INTUVP( KVGRIB, KDGRIB, INLEN,
     X                         KUGRIBO, KVGRIBO, OUTLEN)
C
C---->
C**** INTUVP
C
C     Purpose
C     -------
C
C     Interpolate GRIB format input vorticity and divergence field to
C     GRIB format U and V fields.
C
C
C     Interface
C     ---------
C
C     IRET = INTUVP(KVGRIB,KDGRIB,INLEN,KUGRIBO,KVGRIBO,OUTLEN)
C
C     Input
C     -----
C
C     KVGRIB - Input vorticity field  (spectral, GRIB format).
C     KDGRIB - Input divergence field (spectral, GRIB format).
C     INLEN  - Input field length (words).
C
C
C     Output
C     ------
C
C     KUGRIBO - Output U field (GRIB format).
C     KVGRIBO - Output V field (GRIB format).
C     OUTLEN  - Length of each output U and V field (words).
C
C
C     Method
C     ------
C
C     Convert spectral vorticity/divergence to spectral U/V and then
C     interpolate U and V to output fields.
C
C     Note that a common block is used in intf.h to hold the U/V
C     fields before interpolation.
C
C     Externals
C     ---------
C
C     IBASINI - Ensure basic interpolation setup is done.
C     INTUVDH - Encodes/decodes data into/from GRIB code.
C     INTUVXH - Interpolate U and V spectral components to grid point.
C     JVOD2UV - Converts spectral vorticity/divergence to spectral U/V.
C     JMEMHAN - Allocate scratch memory.
C     ISCRSZ  - Calculate number of values in generated field.
C     FIXAREA - Fixup area definition to correspond to grid definitions
C     INTLOG  - Log error message.
C     RESET_C - Reset interpolation handling options using GRIB product.
C     INSANE  - Ensure no outrageous values given for interpolation.
C     GRSMKP  - P factor calculation switch for routine GRIBEX.
C
C
C     Author
C     ------
C
C     J.D.Chambers     ECMWF     February 2001
C     Rewritten to use more functions for processing.
C
C
C----<
C     -----------------------------------------------------------------|
C
      IMPLICIT NONE
C
C     Function arguments
C
      INTEGER KVGRIB(*), KDGRIB(*), INLEN
      INTEGER KUGRIBO(*), KVGRIBO(*), OUTLEN
C
#include "parim.h"
#include "nifld.common"
#include "nofld.common"
#include "intf.h"
C
C     Parameters
C
      INTEGER JPROUTINE, JPALLOC, JPSCR3, JPSCR4, JPSCR5
      INTEGER JPVORT, JPDIVE
      PARAMETER (JPROUTINE = 26900 )
      PARAMETER (JPALLOC = 1)
      PARAMETER (JPSCR3 = 3)
      PARAMETER (JPSCR4 = 4)
      PARAMETER (JPSCR5 = 5)
      PARAMETER (JPVORT = 138)
      PARAMETER (JPDIVE = 155)
C
C     Local variables
C
      REAL EW, NS, DUMMY
      LOGICAL LOLDWIND, LSPECUV
      INTEGER IERR, KPR, ISZVD, ISZUV, ISIZE, ISAME, IDIVOFF
      INTEGER LOOP, MTRUNC, NTRUNC, NTROLD, NTROLD2, NPARAM
      INTEGER NOLD, NLEN, NLENU, NLENV, HNORESO
      INTEGER INRESO, IHOLD
      LOGICAL LSTYLE
      REAL NORTH, SOUTH, WEST, EAST
C
      LOGICAL LFIRST, LNEWUV
      CHARACTER*3 EXTRA
      DATA LFIRST/.TRUE./, LNEWUV/.TRUE./, EXTRA/'NO '/
      SAVE LFIRST, LNEWUV
C
      DATA NTROLD/-1/, NTROLD2/-1/
      SAVE NTROLD, NTROLD2
      INTEGER IPVORT, IPDIV, IP_U, IP_V
#ifndef _CRAYFTN
#ifdef POINTER_64
      INTEGER*8 IZNFLDO
#endif
#endif
      REAL ZNFLDO
      POINTER ( IZNFLDO, ZNFLDO )
      DIMENSION ZNFLDO( 1 )
#ifndef _CRAYFTN
#ifdef POINTER_64
      INTEGER*8 IUV, IVD
#endif
#endif
      REAL UV, VD
      POINTER ( IUV, UV )
      POINTER ( IVD, VD )
      DIMENSION UV( 1 ), VD( 1 )
C
C     Externals
C
      INTEGER RESET_C, ISCRSZ, FIXAREA, AURESOL, DSSAREA
      INTEGER IBASINI, INSANE, INTUVDH, INTUVXH
      INTEGER INTUVGH !, INTUVPH
      EXTERNAL RESET_C, ISCRSZ, FIXAREA, AURESOL, DSSAREA
      EXTERNAL IBASINI, INSANE, INTUVDH, INTUVXH
      EXTERNAL INTUVGH !, INTUVPH
C
C     -----------------------------------------------------------------|
C*    Section 1.   Initialise
C     -----------------------------------------------------------------|
C
  100 CONTINUE
      INTUVP = 0
      IERR   = 0
      KPR    = 0
C
      IF( LFIRST ) THEN
        CALL GETENV('IGNORE_UV_EXTRA_MODE', EXTRA)
        IF((EXTRA(1:1).EQ.'Y').OR.(EXTRA(1:1).EQ.'y')) LNEWUV = .FALSE.
        IF( LNEWUV ) THEN
          CALL INTLOG(JP_DEBUG,
     X      'INTUVP: IGNORE_UV_EXTRA_MODE not turned on',JPQUIET)
        ELSE
          CALL INTLOG(JP_DEBUG,
     X      'INTUVP: IGNORE_UV_EXTRA_MODE turned on',JPQUIET)
        ENDIF
        LFIRST = .FALSE.
      ENDIF
C
      LOLDWIND = LWINDSET
cs      LSPECUV = (NOREPR.EQ.JPSPHERE).OR.(NOREPR.EQ.JPSPHROT)
C
C     Ensure that basic initialisation has been done
C
      IERR = IBASINI(0)
      IF( IERR.NE.0 ) THEN
        CALL INTLOG(JP_ERROR,'INTUVP: basic initialise failed',JPQUIET)
        INTUVP = IERR
        GOTO 990
      ENDIF
C
C     Establish truncation of the input vorticity and divergence:
C     unpack GRIB sections 1 and 2.
C
      NPARAM = JPVORT
      ISZVD = 1
      NLEN = INLEN
      IERR = INTUVDH(DUMMY,ISZVD,KVGRIB,NLEN,'I',NPARAM)
      IF( IERR.NE.0 ) THEN
        CALL INTLOG(JP_ERROR,'INTUVP: GRIB header decode failed',IERR)
        INTUVP = IERR
        GOTO 990
      ENDIF
C
C     If a rotation is required, check the input fields and call the
C     appropriate interpolation
C
      IF( LUSEHIR.AND.LNOROTA ) THEN
cs        LWIND = .TRUE.
cs        LWINDSET = .TRUE.
cs        IF( (ISEC1(6).EQ.JPVORT).AND.(ISEC2(1).EQ.JPSPHERE) ) THEN
csC
csC         Spectral vorticity/divergence to rotated U and V
csC
cs          NLEN  = INLEN
cs          NLENU = OUTLEN
cs          NLENV = OUTLEN
cs          IERR = INTUVPH(KVGRIB,KDGRIB,NLEN,KUGRIBO,KVGRIBO,
cs     X                   NLENU,NLENV)
C
cs        ELSE IF( ((ISEC1(6).EQ.JP_U).OR.(ISEC1(6).EQ.JP_10U)).AND.
cs        IF( ((ISEC1(6).EQ.JP_U).OR.(ISEC1(6).EQ.JP_10U)).AND.
        IF( (ISEC1(6).EQ.JP_10U).AND.
     X           (ISEC2(1).EQ.JPGAUSSIAN) ) THEN
C
C         Gaussian U and V to rotated U and V
C
          NLEN  = INLEN
          NLENU = OUTLEN
          NLENV = OUTLEN
          IERR = INTUVGH(KVGRIB,KDGRIB,NLEN,KUGRIBO,KVGRIBO,
     X                   NLENU,NLENV)
         IF( IERR.NE.0 ) THEN
           CALL INTLOG(JP_ERROR,'INTUVP: Rotation failed',IERR)
           GOTO 990
        ENDIF
        INTUVP = IERR
           GOTO 900
C
cs        ELSE
cs          CALL INTLOG(JP_ERROR,'INTUVP: Invalid rotation',IERR)
cs         IERR = JPROUTINE + 1
        ENDIF
C
      ENDIF
C
C     -----------------------------------------------------------------|
C*    Section 2.   Unpack the vorticity/divergence fields.
C     -----------------------------------------------------------------|
C
  200 CONTINUE
C
C     Get scratch memory for vorticity/divergence unpacked fields.
C     Vorticity/divergence memory areas are adjacent.
C
      INRESO = ISEC2(2)
      ISZVD  = (INRESO+1)*(INRESO+4)
      IPVORT = 1
      IPDIV  = IPVORT + ISZVD
      CALL JMEMHAN( JPSCR4, IVD, ISZVD*2, JPALLOC, IERR)
      IF( IERR.NE.0 ) THEN
        CALL INTLOG(JP_ERROR,
     X    'INTUVP: Scratch memory type 4 allocation failed.',JPQUIET)
        INTUVP = IERR
        GOTO 990
      ENDIF
C
C     Decode vorticity and divergence.
C
      NPARAM = JPVORT
      NLEN = INLEN
      IERR = INTUVDH(VD(IPVORT),ISZVD,KVGRIB,NLEN,'D',NPARAM)
      IF( IERR.NE.0 ) THEN
        CALL INTLOG(JP_ERROR,'INTUVP: Vorticity decoding failed',IERR)
        INTUVP = IERR
        GOTO 990
      ENDIF
C
      NPARAM = JPDIVE
      NLEN = INLEN
      IERR = INTUVDH(VD(IPDIV),ISZVD,KDGRIB,NLEN,'D',NPARAM)
      IF( IERR.NE.0 ) THEN
        CALL INTLOG(JP_ERROR,'INTUVP: Divergence decoding failed',IERR)
        INTUVP = IERR
        GOTO 990
      ENDIF
C
C     Setup interpolation options from input GRIB characteristics.
C
      IHOLD = NIRESO
      IERR = RESET_C( ISEC1, ISEC2, ZSEC2, ISEC4)
      IF( IERR.NE.0 ) THEN
        CALL INTLOG(JP_ERROR,
     X    'INTUVP: Setup interp. options from GRIB failed.',JPQUIET)
        INTUVP = IERR
        GOTO 990
      ENDIF
      IF( IHOLD.NE.0 ) NIRESO = IHOLD
C
C     Check that no outrageous values given for interpolation
C
      ISAME = INSANE()
      IF( ISAME.GT.0 ) THEN
        CALL INTLOG(JP_ERROR,
     X    'INTUVP: Interpolation cannot use given values.',JPQUIET)
        INTUVP = ISAME
        GOTO 990
      ENDIF
C
C     -----------------------------------------------------------------|
C*    Section 3. Convert spectral vorticity/divergence to spectral U/V
C     -----------------------------------------------------------------|
C
  300 CONTINUE
C
      LSPECUV = (NOREPR.EQ.JPSPHERE).OR.(NOREPR.EQ.JPSPHROT)
      IF( LSPECUV ) THEN
C
C       Spectral U and V for Tn are to be generated from vorticity
C       and divergence spectral T(n-1)
C
        IF( LARESOL.AND.LNEWUV ) THEN
          IF( (NOGRID(1).NE.0).AND.(NOGRID(2).NE.0) ) THEN
            EW = FLOAT(NOGRID(1))/PPMULT
            NS = FLOAT(NOGRID(2))/PPMULT
            NTRUNC = AURESOL(NS,EW) - 1
          ELSE IF( NOGAUSS.NE.0 ) THEN
            EW = 90.0/FLOAT(NOGAUSS)
            NS = EW
            NTRUNC = AURESOL(NS,EW) - 1
          ELSE IF( LNORESO ) THEN
            NTRUNC = NORESO - 1
          ELSE
            NTRUNC = INRESO - 1
          ENDIF
          IF( NTRUNC.GT.(INRESO-1) ) NTRUNC = INRESO - 1
C
        ELSE IF( LNORESO ) THEN
          NTRUNC = NORESO - 1
        ELSE
          NTRUNC = INRESO - 1
        ENDIF
C
        IF( LNEWUV ) THEN
          MTRUNC = NTRUNC + 1
        ELSE
          NTRUNC = NTRUNC + 1
          MTRUNC = NTRUNC
        ENDIF
C
C     -----------------------------------------------------------------|
C       Use old-style processing if IGNORE_UV_EXTRA_MODE = Y
C     -----------------------------------------------------------------|
C
        IF( .NOT.LNEWUV ) THEN
C
          NIRESO = ISEC2(2)
C
          CALL INTLOG(JP_DEBUG,'INTUVP: vo/div truncation = ', NIRESO)
C
C         Get scratch memory for U and V spectral fields.
C         U and V memory areas are adjacent.
C
          ISZUV = MAX((NIRESO+1)*(NIRESO+4),(NORESO+1)*(NORESO+4))
          IP_U  = 1
          IP_V  = IP_U + ISZUV
C
          ISIZE = ISZUV*2
          CALL JMEMHAN( JPSCR3, IUV, ISIZE, JPALLOC, IERR)
          IF( IERR.NE.0 ) THEN
            CALL INTLOG(JP_ERROR,
     X        'INTUVP: Scratch memory type 3 allocation failed',JPQUIET)
            INTUVP = IERR
            GOTO 900
          ENDIF
C
C         Generate U and V with same truncation as input fields.
C
          CALL INTLOG(JP_DEBUG,
     X      'INTUVP: Make intermediate U/V with truncation = ', NIRESO)
          CALL JVOD2UV(VD(IPVORT),VD(IPDIV),NIRESO,
     X                 UV(IP_U),UV(IP_V),NIRESO)
C
C         Do spectral truncation for spectral output
C
          IF( LNORESO ) THEN
C
            CALL INTLOG(JP_DEBUG,
     X        'INTUVP: Make U/V spectral output with truncation',NORESO)
C
            ISIZE =  (NORESO+1)*(NORESO+4)
            CALL JMEMHAN( JPSCR5, IZNFLDO, ISIZE, JPALLOC, IERR)
            IF( IERR.NE.0 ) THEN
              CALL INTLOG(JP_ERROR,
     X          'INTUVP: Scratch memory type 5 allocn failed',JPQUIET)
              INTUVP = JPROUTINE + 4
              GOTO 900
            ENDIF
C
            CALL SH2SH( UV(IP_U), NIRESO, ZNFLDO, NORESO )
            DO LOOP = 1, (NORESO+1)*(NORESO+2)
              UV(IP_U+LOOP-1) = ZNFLDO(LOOP)
            ENDDO
C
            CALL SH2SH( UV(IP_V), NIRESO, ZNFLDO, NORESO )
            IP_V = 1 + (NORESO+1)*(NORESO+4)
            DO LOOP = 1, (NORESO+1)*(NORESO+2)
              UV(IP_V+LOOP-1) = ZNFLDO(LOOP)
            ENDDO
C
            NIRESO = NORESO
C
          ENDIF
C
C         Set GRIBEX flag to force recalculation of complex packing
C         factor.
C
          CALL GRSMKP(1)
C
C         Code U into GRIB
C
          NPARAM = JP_U
          NLENU = OUTLEN
          IERR = INTUVDH(UV(IP_U),ISZUV,KUGRIBO,NLENU,'C',NPARAM)
          IF( IERR.NE.0 ) THEN
            CALL INTLOG(JP_ERROR,
     X        'INTUVP: U encoding into GRIB failed.',IERR)
            INTUVP = JPROUTINE + 4
            GOTO 380
          ENDIF
C
C         Code V into GRIB
C
          NPARAM = JP_V
          NLENV = OUTLEN
          IERR = INTUVDH(UV(IP_V),ISZUV,KVGRIBO,NLENV,'C',NPARAM)
          IF( IERR.NE.0 ) THEN
            CALL INTLOG(JP_ERROR,
     X        'INTUVP: V encoding into GRIB failed.',IERR)
            INTUVP = JPROUTINE + 4
            GOTO 380
          ENDIF
C
  380     CONTINUE
C
C         Turn off GRIBEX flag which forces recalculation of complex
C         packing factor
C
          CALL GRSMKP(0)
C
          GOTO 900
C
C     -----------------------------------------------------------------|
C       Use new-style processing if IGNORE_UV_EXTRA_MODE not set
C     -----------------------------------------------------------------|
C
        ELSE
C
          CALL INTLOG(JP_DEBUG,'INTUVP: vo/div truncation = ', NTRUNC)
          CALL INTLOG(JP_DEBUG,'INTUVP: U/V truncation    = ', MTRUNC)
C
C         Truncate vorticity and divergence to correspond to U/V
C
          ISIZE =  (MTRUNC+1)*(MTRUNC+4)
          CALL JMEMHAN( JPSCR5, IZNFLDO, ISIZE*2, JPALLOC, IERR)
          IF( IERR.NE.0 ) THEN
            CALL INTLOG(JP_ERROR,
     X        'INTUVP: Scratch memory type 5 allocation failed',JPQUIET)
            INTUVP = JPROUTINE + 4
            GOTO 990
          ENDIF
C
          IPVORT = 1
          IPDIV  = IPVORT + (INRESO+1)*(INRESO+4)
          IDIVOFF = 1 + (NTRUNC+1)*(NTRUNC+4)
C
          CALL SH2SH( VD(IPVORT), INRESO, ZNFLDO, NTRUNC )
C
          CALL SH2SH( VD(IPDIV), INRESO, ZNFLDO(IDIVOFF), NTRUNC )
C
C         Get scratch memory for U and V spectral fields.
C         U and V memory areas are adjacent.
C
          ISZUV = (MTRUNC+1)*(MTRUNC+4)
          IP_U  = 1
          IP_V  = IP_U + ISZUV
C
          ISIZE = ISZUV*2
          CALL JMEMHAN( JPSCR3, IUV, ISIZE, JPALLOC, IERR)
          IF( IERR.NE.0 ) THEN
            CALL INTLOG(JP_ERROR,
     X        'INTUVP: Scratch memory type 3 allocation failed',JPQUIET)
            INTUVP = IERR
            GOTO 990
          ENDIF
C
C         Generate U and V spectral fields
C
          CALL JVOD2UV(ZNFLDO(IPVORT),ZNFLDO(IDIVOFF),NTRUNC,
     X                 UV(IP_U),UV(IP_V),MTRUNC)
C
C         Set GRIBEX flag to force recalculation of complex packing
C         factor.
C         Preserve the original output truncation
C
          CALL GRSMKP(1)
          HNORESO = NORESO
C
C         Code U into GRIB using the new truncation
C
          NORESO = MTRUNC
          NPARAM = JP_U
          NLENU = OUTLEN
          IERR = INTUVDH(UV(IP_U),ISZUV,KUGRIBO,NLENU,'C',NPARAM)
          IF( IERR.NE.0 ) THEN
            CALL INTLOG(JP_ERROR,
     X        'INTUVP: U encoding into GRIB failed.',IERR)
            INTUVP = JPROUTINE + 4
            GOTO 390
          ENDIF
C
C         Code V into GRIB using the new truncation
C
          NPARAM = JP_V
          NLENV = OUTLEN
          IERR = INTUVDH(UV(IP_V),ISZUV,KVGRIBO,NLENV,'C',NPARAM)
          IF( IERR.NE.0 ) THEN
            CALL INTLOG(JP_ERROR,
     X        'INTUVP: V encoding into GRIB failed.',IERR)
            INTUVP = JPROUTINE + 4
            GOTO 390
          ENDIF
C
  390     CONTINUE
C
C         Turn off GRIBEX flag which forces recalculation of complex
C         packing factor
C         Restore the original output truncation
C
          CALL GRSMKP(0)
          NORESO = HNORESO
C
          GOTO 900
        ENDIF
C
      ENDIF
C
C     -----------------------------------------------------------------|
C*    Section 4.   Generate grid point GRIB format U and V fields.
C     -----------------------------------------------------------------|
C
  400 CONTINUE
C
C     Spectral U and V for Tn are to be generated from vorticity
C     and divergence spectral T(n-1)
C
C     See whether or not the 'autoresol' flag is set.
C     If not, use the input truncation.
C
      IF( LARESOL ) THEN
        IF( (NOREPR.EQ.JPREGULAR).OR.(NOREPR.EQ.JPREGROT) ) THEN
          EW = FLOAT(NOGRID(1))/PPMULT
          NS = FLOAT(NOGRID(2))/PPMULT
        ELSE
          EW = 90.0/FLOAT(NOGAUSS)
          NS = EW
        ENDIF
        NTRUNC = AURESOL(EW,NS)
        IF( NTRUNC.NE.NTROLD ) THEN
          NTROLD = NTRUNC
          CALL INTLOG(JP_WARN,
     X      'INTUVP: Resolution automatically set to ', NTRUNC)
        ENDIF
      ELSE IF( LNORESO ) THEN
        NTRUNC = NORESO
      ELSE
        NTRUNC = INRESO
      ENDIF
C
C     Check whether the output resolution is greater than the input
C
      IF( NTRUNC.GT.INRESO ) THEN
C
C       Issue warning if the output resolution was user-supplied
C
        IF( .NOT.LARESOL ) THEN
C
C         Revert to the input truncation
C
          IF( INRESO.NE.NTROLD2 ) THEN
            CALL INTLOG(JP_WARN,
     X        'INTUVP: spectral -> grid point interpolation',JPQUIET)
            CALL INTLOG(JP_WARN,
     X        'INTUVP: User supplied resolution = ',NTRUNC)
            CALL INTLOG(JP_WARN,
     X        'INTUVP: Input field resolution   = ',INRESO)
            CALL INTLOG(JP_WARN,
     X        'INTUVP: User supplied resolution ignored',JPQUIET)
            CALL INTLOG(JP_WARN,
     X        'INTUVP: Input field resolution has been used',JPQUIET)
            NTROLD2 = INRESO
          ENDIF
          NTRUNC = INRESO
C
        ELSE
C
C         Revert to the input truncation
C
          NTRUNC = INRESO
          IF( NTRUNC.NE.NTROLD2 ) THEN
            NTROLD2 = NTRUNC
            CALL INTLOG(JP_WARN,
     X        'INTUVP: Auto-resolution selection too high',JPQUIET)
            CALL INTLOG(JP_WARN,
     X        'INTUVP: Resolution set to input resolution: ',NTRUNC)
          ENDIF
        ENDIF
      ENDIF
C
C     IF extra mode is in use, adjust the calculated truncation.
C
      MTRUNC = NTRUNC
      IF( LNEWUV ) NTRUNC = MTRUNC - 1
C
      CALL INTLOG(JP_DEBUG,'INTUVP: vo/div truncation = ', NTRUNC)
      CALL INTLOG(JP_DEBUG,'INTUVP: U/V truncation    = ', MTRUNC)
C
      ISIZE =  (MTRUNC+1)*(MTRUNC+4)
      CALL JMEMHAN( JPSCR5, IZNFLDO, ISIZE*2, JPALLOC, IERR)
      IF( IERR.NE.0 ) THEN
        CALL INTLOG(JP_ERROR,
     X    'INTUVP: Scratch memory type 5 allocation failed.',JPQUIET)
        INTUVP = JPROUTINE + 4
        GOTO 990
      ENDIF
C
      IPVORT = 1
      IPDIV = 1 + (INRESO+1)*(INRESO+4)
      IDIVOFF = IPVORT + (NTRUNC+1)*(NTRUNC+4)
C
      CALL SH2SH( VD(IPDIV), INRESO, ZNFLDO(IDIVOFF), NTRUNC )
C
      CALL SH2SH( VD(IPVORT), INRESO, ZNFLDO, NTRUNC )
C
C     Get scratch memory for U and V spectral fields.
C     U and V memory areas are adjacent.
C
      ISZUV = (MTRUNC+1)*(MTRUNC+4)
      IP_U  = 1
      IP_V  = IP_U + ISZUV
C
      ISIZE = ISZUV*2
      CALL JMEMHAN( JPSCR3, IUV, ISIZE, JPALLOC, IERR)
      IF( IERR.NE.0 ) THEN
        CALL INTLOG(JP_ERROR,
     X    'INTUVP: Scratch memory type 3 allocation failed.',JPQUIET)
        INTUVP = IERR
        GOTO 990
      ENDIF
C
C     Generate U and V spectral fields
C
      CALL JVOD2UV(ZNFLDO(IPVORT),ZNFLDO(IDIVOFF),NTRUNC,
     X             UV(IP_U),UV(IP_V),MTRUNC)
C
       LSTYLE = LNOSTYLE.AND.
     X         (NOSTYLE.EQ.JPSDISM).AND.
     X         (NOREPR.EQ.JPREGULAR)
C
        IF( LSTYLE ) THEN
            EW    = NOGRID(1) / PPMULT
            NS    = NOGRID(2) / PPMULT
            NORTH = REAL(NOAREA(1)) / PPMULT
            WEST  = REAL(NOAREA(2)) / PPMULT
            SOUTH = REAL(NOAREA(3)) / PPMULT
            EAST  = REAL(NOAREA(4)) / PPMULT
C
            IERR = DSSAREA( EW, NS, NORTH, WEST, SOUTH, EAST)
            IF( IERR.NE.0 ) THEN
              CALL INTLOG(JP_ERROR,'INTUVP: DSSAREA failed:',IERR)
              INTUVP = JPROUTINE + 9
              GOTO 900
            ENDIF
C
            NOAREA(1) = NINT(NORTH * PPMULT)
            NOAREA(2) = NINT(WEST  * PPMULT)
            NOAREA(3) = NINT(SOUTH * PPMULT)
            NOAREA(4) = NINT(EAST  * PPMULT)
         ELSE
C           Fixup area definition to correspond to grid definitions
             IERR = FIXAREA()
             IF ( IERR .NE. 0 ) THEN
               CALL INTLOG(JP_ERROR,
     X           'INTUVP: Fixup area definition failed.',JPQUIET)
               INTUVP = IERR
               GOTO 900
             ENDIF
         ENDIF

cs      IERR = FIXAREA()
cs      IF( IERR.NE.0 ) THEN
cs        CALL INTLOG(JP_ERROR,'INTUVP: Fixarea failed.',JPQUIET)
cs        INTUVP = IERR
cs        GOTO 990
cs      ENDIF
C
C     Get scratch space for interpolation
      ISIZE = ISCRSZ()*2
      IF( ISIZE.LE.0 ) THEN
        CALL INTLOG(JP_ERROR,'INTUVP: Get scratch space failed.',ISIZE)
        INTUVP = JPROUTINE + 5
        GOTO 990
      ENDIF
      CALL JMEMHAN( JPSCR5, IZNFLDO, ISIZE, JPALLOC, IERR)
      IF( IERR.NE.0 ) THEN
        CALL INTLOG(JP_ERROR,
     X    'INTUVP: Scratch memory(5) allocation failed.',JPQUIET)
        INTUVP = JPROUTINE + 5
        GOTO 990
      ENDIF
C
      LWIND = .TRUE.
      LWINDSET = .TRUE.
C
C     Interpolate U and V
C
      NOLD = NIRESO
      NIRESO = MTRUNC
      NLENU = OUTLEN
      NLENV = OUTLEN
      IERR = INTUVXH(UV,ISZUV,ZNFLDO,KUGRIBO,KVGRIBO,NLENU,NLENV)
      IF( IERR.NE.0 ) THEN
        CALL INTLOG(JP_ERROR,
     X    'INTUVP: U/V interpolation failed.',JPQUIET)
        INTUVP = JPROUTINE + 6
        GOTO 990
      ENDIF
C
      NIRESO = NOLD
C
C     -----------------------------------------------------------------|
C*    Section 9.   Return
C     -----------------------------------------------------------------|
C
  900 CONTINUE
C
      OUTLEN = NLENU
C
  990 CONTINUE
C
C     Clear change flags for next product processing and reset wind flag
C
      LCHANGE = .FALSE.
      LSMCHNG = .FALSE.
      LWINDSET  = LOLDWIND
      LWIND = .FALSE.
C
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C


      SUBROUTINE OFFSET  (IOFF,NVAL,IWORD,IBYTE,NBIT,ILEN,IERR)
C
C
C
C
C
C---->
C*
C*    NAME      : OFFSET
C:
C*    FUNCTION  : CALCULATES THE WORD AND BIT OFFSET OF THE START
C*                OF THE NEXT BIT-FIELD IN AN ARRAY OF BINARY
C*                DATA, FOLLOWING THE INSERTION/EXTRACTION OF ONE
C*                OR MORE CONSECUTIVE BIT-FIELDS.
C*
C*    INPUT     : IOFF  - BIT OFFSET AT WHICH LAST INSERTION OR
C*                        EXTRACTION STARTED.
C*                NVAL  - NUMBER OF FIELDS INSERTED OR EXTRACTED IN
C*                        LAST OPERATION.
C*                IWORD - WORD NUMBER OF ARRAY AT WHICH LAST OPERATION
C*                        STARTED.
C*                IBYTE - LENGTH, IN BITS, OF LAST FIELD(S) INSERTED
C*                        OR EXTRACTED.
C*                NBIT  - NUMBER OF BITS IN COMPUTER WORD.
C*                ILEN  - NUMBER OF WORDS IN ARRAY.
C*
C*    OUTPUT    : IOFF  - BIT OFFSET AT WHICH NEXT INSERTION OR
C*                        EXTRACTION STARTS.
C*                NVAL  - UNCHANGED.
C*                IWORD - WORD NUMBER OF ARRAY AT WHICH NEXT OPERATION
C*                        STARTS.
C*                IBYTE - UNCHANGED.
C*                NBIT  - UNCHANGED.
C*                ILEN  - UNCHANGED.
C*
C*                IERR  - EQUAL 0 IF NO ERROR.
C*                        EQUAL -2 IF NEXT OPERATION IS OUTSIDE ARRAY
C*                        BOUNDS.
C*
C*    GENERAL   : OFFSET CALLS -----
C*
C*    AUTHOR    : J.HENNESSY  15.4.85
C*
C*    MODIFIED  : J.HENNESSY  28.11.85
C*
C
C     ---------------------------------------------------------------
C----<
C
C
C
C     CLEAR ERROR INDICATOR
C
      IERR = 0
C
C
C
C
C
C
C
C
C
C
C     CALCULATE NEXT WORD AND BIT POSITIONS.
C
      IBITL = NVAL  * IBYTE
      INTER = IBITL / NBIT
      IOFFS = IBITL - INTER * NBIT
      IWORD = IWORD + INTER
      IOFF  = IOFF  + IOFFS
C
      IF (IOFF.GE.NBIT)
     C   THEN
             IWORD = IWORD + 1
             IOFF  = IOFF  - NBIT
         END IF
C
C
C
C
C
C
C
C
C     CHECK THAT NEXT WORD TO BE ACCESSED LIES WITHIN THE ARRAY BOUNDS.
C
      IF (IWORD.GT.ILEN)
     C   THEN
             IERR = -2
             WRITE (*,9001) IWORD,ILEN
 9001        FORMAT (1H ,'WORD ',I8,' IS OUTSIDE ARRAY BOUNDS ',I8)
         ENDIF
C
C
      RETURN
C
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      INTEGER FUNCTION ELLSEC2(KGRIB,KLENG,INSPT,KSEC0,KSEC2,IBITS,
     X                         LQUASI)
C
C---->
C**** ELLSEC2P
C
C     PURPOSE
C     _______
C
C     Encodes GRIB section 2 values for lat/long grid fields.
C
C     INTERFACE
C     _________
C
C     IRET = ELLSEC2(KGRIB,KLENG,INSPT,KSEC0,KSEC2,IBITS,LQUASI))
C
C     Input parameters
C     ________________
C
C     KGRIB   - GRIB product built so far (upto octet 6). 
C     KLENG   - Length of KGRIB.
C     INSPT   - Bit position of GRIB product built so far.
C     KSEC0   - GRIB section 0 description.
C     KSEC2   - GRIB section 2 description.
C     IBITS   - Number of bits per element in KGRIB.
C     LQUASI  - .TRUE. if gaussian grid is quasi-regular (reduced).
C     
C
C     Output parameters
C     ________________
C
C     KGRIB   - Updated GRIB product to end of section 2.
C     INSPT   - Updated bit position of GRIB product built so far.
C     IRET    - Function return status code, 0 = OK
C
C     Common block usage
C     __________________
C
C     None.
C
C     Method
C     ______
C
C     Packs values given in KSEC2 into KGRIB and updates bit
C     pointer INSPT.
C
C     Externals
C     _________
C
C     CSGNBT  - Set the sign bit.
C     INXBIT  - Insert bit data.
C
C
C     AUTHOR
C     ______
C
C     J.D.Chambers       ECMWF     February 1999
C
C     MODIFICATIONS
C     _____________
C
C     None.
C
C----<
C     _______________________________________________________
C
C     Section 0. Definition of variables.
C     _______________________________________________________
C
      IMPLICIT NONE
C
#include "common/grprs.h"
C
C     Parameters
C
      INTEGER JP16SET
      PARAMETER ( JP16SET = 2**16 - 1 ) 
C                            ^---> 65535    =   FFFF(hex)
C
C     Function arguments
C
      INTEGER KGRIB,KLENG,INSPT,KSEC0,KSEC2,IBITS
      DIMENSION KGRIB(*),KSEC0(*),KSEC2(*)
      LOGICAL LQUASI
C
C     Local variables
C
      INTEGER ILALO(2), IRET, IRESOL
C
C     _______________________________________________________
C
C     Section 1.    Initialization.
C     _______________________________________________________
C
  100 CONTINUE
C
      ELLSEC2 = 0
C
C     _______________________________________________________
C
C     Section 2.    Pack section 2 octets.
C     _______________________________________________________
C
  200 CONTINUE
C
C     Octets 7 - 8  : Ni - number of points along a parallel.
C     Octets 9 - 10 : Nj - number of points along a meridian.
C     Two 16 bit fields.
C
C     WARNING!!
C     For quasi-regular grids, it is here assumed that Ni is variable,
C     i.e. that the number of points along a parallel is variable but
C     that the number of points along a meridian is fixed.
C
C     For quasi-regular grids Ni is set to all 1 bits, as
C     the number of points is different on different parallels.
C
C     Set to all 1 bits.
C
      IF( LQUASI ) KSEC2(2) = JP16SET
C
      CALL INXBIT(KGRIB,KLENG,INSPT,KSEC2(2),2,IBITS, 16,'C',IRET)
      IF( IRET.NE.0) THEN
        ELLSEC2 = 1
        WRITE(GRPRSM,*) 'ELLSEC2: Error inserting/extracting'
        WRITE(GRPRSM,*)
     X    'ELLSEC2: number of pts along parallel or meridian.'
        WRITE(GRPRSM,*) 'ELLSEC2: Return code = ', IRET
        GO TO 900
      ENDIF
C
C     Octets 11 - 13 : La1 - latitude of first grid point.
C     Octets 14 - 16 : Lo1 - longitude of first grid point.
C     Two 24 bit fields.
C
C     Set sign bit to 1, if value is negative.
C
      CALL CSGNBT( ILALO(1), KSEC2(4), 24, IRET)
      CALL CSGNBT( ILALO(2), KSEC2(5), 24, IRET)
C
      CALL INXBIT(KGRIB,KLENG,INSPT,ILALO(1),2,IBITS, 24,'C',IRET)
      IF( IRET.NE.0) THEN
        ELLSEC2 = 1
        WRITE(GRPRSM,*) 'ELLSEC2: Error inserting/extracting'
        WRITE(GRPRSM,*)
     X    'ELLSEC2: latitude or longitude of first grid pt.'
        WRITE(GRPRSM,*) 'ELLSEC2: Return code = ', IRET
        GO TO 900
      ENDIF
C
C     Octet 17 : Resolution and components flag.
C     One 8 bit field.
C
      IRESOL = KSEC2(6)+KSEC2(18)+KSEC2(19)
C
      CALL INXBIT(KGRIB,KLENG,INSPT,IRESOL,1,IBITS, 8,'C',IRET)
      IF( IRET.NE.0) THEN
        ELLSEC2 = 1
        WRITE(GRPRSM,*) 'ELLSEC2: Error inserting/extracting'
        WRITE(GRPRSM,*) 'ELLSEC2: components flag.'
        WRITE(GRPRSM,*) 'ELLSEC2: Return code = ', IRET
        GO TO 900
      ENDIF
C
C     Octets 18 - 20 : La2 - latitude of last grid point.
C     Octets 21 - 23 : Lo2 - longitude of last grid point.
C     Two 24 bit fields.
C
C     Set sign bit to 1, if value is negative.
C
      CALL CSGNBT( ILALO(1), KSEC2(7), 24, IRET)
      CALL CSGNBT( ILALO(2), KSEC2(8), 24, IRET)
C
C     Insert / extract fields.
C
      CALL INXBIT(KGRIB,KLENG,INSPT,ILALO(1),2,IBITS, 24,'C',IRET)
      IF( IRET.NE.0) THEN
        ELLSEC2 = 1
        WRITE(GRPRSM,*) 'ELLSEC2: Error inserting/extracting'
        WRITE(GRPRSM,*)
     X    'ELLSEC2: latitude or longitude of last grid point.'
        WRITE(GRPRSM,*) 'ELLSEC2: Return code = ', IRET
        GO TO 900
      ENDIF
C
C     Octets 24 - 25 : Di - i direction increment.
C     One 16 bit field.
C
C     For quasi-regular grids all Di bits are set to 1, as
C     the increment is different on different parallels.
C
C     If field not given, set to all bits to 1.
C
Ce    Set to all 1 bits.
      IF( LQUASI) KSEC2(9) = JP16SET
Ce
Ce    If increments not given, set all bits to 1.
      IF( KSEC2(6).EQ.0) KSEC2(9) = JP16SET
C
      CALL INXBIT(KGRIB,KLENG,INSPT,KSEC2(9),1,IBITS, 16,'C',IRET)
      IF( IRET.NE.0) THEN
        ELLSEC2 = 1
        WRITE(GRPRSM,*) 'ELLSEC2: Error inserting/extracting'
        WRITE(GRPRSM,*) 'ELLSEC2: i direction increment.'
        WRITE(GRPRSM,*) 'ELLSEC2: Return code = ', IRET
        GO TO 900
      ENDIF
C
C     Octets 26 - 27 : Dj - j direction increment.
C     One 16 bit field.
C
C     If field not given, set to all bits to 1.
C
      IF( KSEC2(6).EQ.0) KSEC2(10) = JP16SET
C
      CALL INXBIT(KGRIB,KLENG,INSPT,KSEC2(10),1,IBITS, 16,'C',IRET)
      IF( IRET.NE.0) THEN
        ELLSEC2 = 1
        WRITE(GRPRSM,*) 'ELLSEC2: Error inserting/extracting'
        WRITE(GRPRSM,*) 'ELLSEC2: j direction increment.'
        WRITE(GRPRSM,*) 'ELLSEC2: Return code = ', IRET
        GO TO 900
      ENDIF
C
C     Octet 28 : Scanning mode flags.
C     One 8 bit field.
C
      CALL INXBIT(KGRIB,KLENG,INSPT,KSEC2(11),1,IBITS, 8,'C',IRET)
      IF( IRET.NE.0) THEN
        ELLSEC2 = 1
        WRITE(GRPRSM,*) 'ELLSEC2: Error inserting/extracting'
        WRITE(GRPRSM,*) 'ELLSEC2: scanning mode flags.'
        WRITE(GRPRSM,*) 'ELLSEC2: Return code = ', IRET
        GO TO 900
      ENDIF
C
C     Fix-up for flag which was different in Experimental Edition.
C
      IF( KSEC0(2).EQ.-1.AND.KSEC2(11).EQ.1) KSEC2(11) = 0
C
C     Octets 29 - 32 : Reserved.
C     Two 16 bit fields.
C
Ce    Set bits to 0.
C
      CALL INXBIT(KGRIB,KLENG,INSPT, 0, 1,IBITS, 32,'C',IRET)
      IF( IRET.NE.0) THEN
        ELLSEC2 = 1
        WRITE(GRPRSM,*) 'ELLSEC2: Error inserting dummy zero.'
        WRITE(GRPRSM,*) 'ELLSEC2: Return code = ', IRET
        GO TO 900
      ENDIF
C
C     _______________________________________________________
C
C     Section 9. Return to calling routine.
C     _______________________________________________________
C
  900 CONTINUE
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      INTEGER FUNCTION IGLSM01 (KUNIT, KNWE, KLONG, KLATV,
     1   KEXPAND, KLEN, KLSM)
C
C---->
C**** *IGLSM01*
C
C     PURPOSE
C     _______
C
C     Read and process one latitude row from the 10 minute land sea
C     mask.
C
C     INTERFACE
C     _________
C
C     IERR = IGLSM01 (KUNIT, KNWE, KLONG, KLATV, KEXPAND,
C    1   KLEN, KLSM)
C
C     Input parameters
C     ________________
C
C     KUNIT      - The unit number of the land sea mask file.
C     KNWE       - The number of points in the West-East direction
C                  for this line of latitude.
C     KLONG      - The array of longitude points for this line of
C                  latitude.
C     KLATV      - The latitude for which the land sea mask is
C                  required.
C     KEXPAND    - Fixed array of length JPLG01 (The number of items
C                  in one latitude of the 10 minute land sea mask).
C                  This is used to improve efficiency.
C     KLEN       - The length of a full line of latitude in the file.
C
C     Output parameters
C     ________________
C
C     KLSM       - The land-sea mask for the specified longitude
C                  points at this line of latitude.
C
C     Return value
C     ____________
C
C     The error indicator (INTEGER).
C     0 + OK
C
C     Error and Warning Return Values
C     _______________________________
C
C     25501 Unexpected end of file found when positioning or reading
C           land sea mask file.
C     25502 Error return code when positioning or reading land sea
C           mask file.
C     25503 Attempt to extract bits beyond array bounds in routine
C           INXBIT.
C       :
C       :
C
C     Any error in this routine should be reported to Meteorological
C     Applications.
C
C     Common block usage
C     __________________
C
C     NONE
C
C     EXTERNALS
C     _________
C
C     INXBIT     - Standard library routine to extract bits from
C                  a packed array.
C     PBREAD     - Standard library routine to read an unstructured
C                  file.
C     PBSEEK     - Standard library routine to position a file
C                  before performing a transfer.
C     INTLOG(R)  - Logs messages.
C
C     METHOD
C     ______
C
C     The latitude value is used to select which line is required
C     from the 10 minute land sea mask file. This line is then read
C     into a buffer and the bit extraction routine used to expand the
C     line to contain one bit per word. The required words are then
C     extracted from this array.
C
C     The 10 minute land sea mask file contains 1080 lines of 2160
C     values with each value stored as one bit. (Each line of latitude
C     is packed in 68*32 = 2176 bits). Each value consists
C     of a 0 for sea or a 1 for land. The bits are assumed to be in
C     the centre of a 10 minute square (e.g. the first value is
C     assumed to be at 0  5' East and 89  55' North).
C
C     To reduce system overheads involved in multiple PBSEEKS and
C     PBREADS, the whole file is read into an array on the first call.
C
C     REFERENCE
C     _________
C
C     None
C
C     COMMENTS
C     ________
C
C     Program contains sections 0 to 3 and 9
C
C     AUTHOR
C     ______
C
C     K. Fielding      *ECMWF*      Nov 1993
C
C     MODIFICATIONS
C     _____________
C
C     J.D.Chambers      ECMWF       Oct 1996
C     The whole file is read into an array on the first call.
C     Number of function arguments reduced.
C
C     J.D.Chambers     ECMWF        Feb 1997
C     Allow for 64-bit pointers
C
C----<
C     _______________________________________________________
C
C*    Section 0. Definition of variables.
C     _______________________________________________________
C
      IMPLICIT NONE
C
#include "parim.h"
#include "jparams.h"
C
C     Parameters
      INTEGER JPROUTINE
      PARAMETER (JPROUTINE = 25500)
      INTEGER JPRAWSZ
      PARAMETER (JPRAWSZ = 73440 )
C
C     Function arguments
      INTEGER KUNIT, KLATV, KLEN, KNWE
      INTEGER KLONG (KNWE), KLSM (KNWE)
      INTEGER KEXPAND (JPLG01)
C
C     Local variables
      INTEGER ILAT, IOFF, IERR, JLON
      INTEGER LENRAW, RAWMASK, RAWSIZE, IFIRST
      INTEGER ISIZE
      DATA ISIZE/0/
      DIMENSION RAWMASK(1)
#ifndef _CRAYFTN
#ifdef POINTER_64
      INTEGER*8 IRAWMSK
#endif
#endif
      POINTER ( IRAWMSK, RAWMASK )
      SAVE IRAWMSK, ISIZE
C
      DATA RAWSIZE/JPRAWSZ/
C
      DATA IFIRST/0/
      SAVE IFIRST
C
C     _______________________________________________________
C
C*    Section 1. Initialisation
C     _______________________________________________________
C
  100 CONTINUE
C
      IGLSM01 = 0
C
      IF( NDBG.GT.2 ) THEN
        CALL INTLOG(JP_DEBUG,'IGLSM01: Section 1.',JPQUIET)
        CALL INTLOG(JP_DEBUG,'IGLSM01: Input parameters.',JPQUIET)
        CALL INTLOG(JP_DEBUG,'IGLSM01: Latitude value = ',KLATV)
        CALL INTLOG(JP_DEBUG,'IGLSM01: Input rec len(words) = ',KLEN)
        CALL INTLOG(JP_DEBUG,'IGLSM01: No.long pts = ',KNWE)
      ENDIF
C
C     If it is the first time through, read in the whole land-sea
C     mask file

      IF( IFIRST.EQ.0 ) THEN
        IFIRST = 10
C
C       Find the file length
C
        CALL PBSEEK (KUNIT, 0, 2, LENRAW)
        IF ( LENRAW.LT.0 ) THEN
          IGLSM01 = JPROUTINE + 1
          CALL INTLOG(JP_FATAL,
     X      'IGLSM01: Error finding length of LSM file',JPQUIET)
          GO TO 900
        ENDIF
C
C       Rewind the file
C
        CALL INTLOG(JP_DEBUG,'IGLSM01: Rewind the LSM file.',JPQUIET)
        CALL PBSEEK (KUNIT, 0, 0, IERR)
        IF (IERR .NE. 0) THEN
          IGLSM01 = JPROUTINE + 2
          CALL INTLOG(JP_FATAL,
     X      'IGLSM01: Error rewinding LSM file',JPQUIET)
          GO TO 900
        ENDIF
C
C       Allocate memory for the array (first time only)
C
          IF( ISIZE.EQ.0 ) THEN
            ISIZE = ((JPRAWSZ*2+JPRLEN-1)*JPILEN)/JPRLEN
            CALL JMEMHAN( 13, IRAWMSK, ISIZE, 1, IERR)
            IF( IERR.NE.0 ) THEN
              CALL INTLOG(JP_ERROR,
     X          'IGLSM01: Memory allocation error.',IRAWMSK)
              IGLSM01 = JPROUTINE + 4
              GOTO 900
            ENDIF
          ENDIF
C
C       Read the file
C
        CALL INTLOG(JP_DEBUG,
     X    'IGLSM01: Read the LSM file of byte size = ',LENRAW)
        CALL PBREAD (KUNIT, RAWMASK, LENRAW, IERR)
        IF (IERR .NE. LENRAW) THEN
          IGLSM01 = JPROUTINE + 3
          CALL INTLOG(JP_FATAL,'IGLSM01: Unexpected EOF while',JPQUIET)
          CALL INTLOG(JP_FATAL,'IGLSM01: reading LSM file.',JPQUIET)
          GO TO 900
        ENDIF
      ENDIF
C     _______________________________________________________
C
C*    Section 2. Read one line of 10 minute land-sea mask
C                and expand into an unpacked array
C     _______________________________________________________
C
  200 CONTINUE
C
      IF(NDBG.GT.2) CALL INTLOG(JP_DEBUG,'IGLSM01: Section 2.',JPQUIET)
C
      ILAT = MIN ( ( (JP90 - KLATV) * JPML01) / JPMULT + 1, JPLT01)
      IOFF = (ILAT - 1)*KLEN*JPBYTES*8
C
      CALL INXBIT (RAWMASK, RAWSIZE, IOFF, KEXPAND, JPLG01, JPBITS, 1,
     X   'D', IERR)
C
      IF (IERR .NE. 0) THEN
        IGLSM01 = JPROUTINE + 5
        CALL INTLOG(JP_FATAL,'IGLSM01: Attempt to extract LSM',JPQUIET)
        CALL INTLOG(JP_FATAL,'IGLSM01: beyond array bounds.',JPQUIET)
        CALL INTLOG(JP_FATAL,'IGLSM01: Interpolation failed.',IGLSM01)
        GO TO 900
      ENDIF
C
C     Transfer expanded bitmask line to land sea mask array
C
      DO 210 JLON = 1, KNWE
        IOFF = (KLONG (JLON) * JPML01) / JPMULT + 1
        KLSM (JLON) = KEXPAND (IOFF)
  210 CONTINUE
C
C     _______________________________________________________
C
C*    Section 9. Return to calling routine.
C     _______________________________________________________
C
  900 CONTINUE
C
      IF(NDBG.GT.2) CALL INTLOG(JP_DEBUG,'IGLSM01: Section 9.',JPQUIET)
C
      RETURN
      END

      PROGRAM INTERPOLATION
C
      IMPLICIT NONE
      INTEGER IPROD
      INTEGER INTV
      REAL REALV
      CHARACTER*20 CHARV
      DIMENSION INTV(4), REALV(4), CHARV(4)
C
      INTEGER JPGRIB, JPEXPAND, JPLONG, JPLAT, JPBYTES
C
C     This should allow an 0.5 degree global grid as input(if required)
C
      PARAMETER(JPGRIB = 2000000)
C
      PARAMETER(JPBYTES = 4)
      PARAMETER(JPLONG = 361)
      PARAMETER(JPLAT  = 720)
      PARAMETER(JPEXPAND = JPLONG * JPLAT)
C
      INTEGER IOGRIB(JPGRIB), INGRIB(JPGRIB)
C
      REAL ZNFELDI(JPEXPAND), ZNFELDO(JPEXPAND)
C
      INTEGER IUNIT1, IUNIT2, IREC, INLENG, IERR, IRET
C
C     Externals
C
      INTEGER INTOUT, INTF2, IARGC
C
      CHARACTER*2 OPTION
      CHARACTER*128 INFILE, OUTFILE
      INTEGER IJDC
      EXTERNAL GETENV
C
      IJDC = IARGC()
      IF( IJDC.LT.3 ) THEN
       print*,'Usage: ./interpolation option inputfile outputfile'
       print*,'Possible options:'
       print*,'ll-spectral to lat-long or any grid to lat long'
       print*,'gg-spectral to regular gaussian or any grid to gaussian'
       print*,'qr-spectral to red gaussian or red gaussian red gaussian'
       STOP
      ENDIF

      CALL GETARG(1,OPTION)
      CALL GETARG(2,INFILE)
      CALL GETARG(3,OUTFILE)
C
      IRET = 0
C
C     Turn on autoresol
C
      INTV(1) = 1
      IRET = INTOUT('autoresol', INTV, REALV, CHARV)
      IF( IRET.NE.0 ) STOP 'autoresol INTOUT failed.'
C
C     Define area to be used for interpolating the new field(s).
C
      REALV(1) = 0.0
      REALV(2) = 0.0
      REALV(3) = 0.0
      REALV(4) = 0.0

      IRET = INTOUT('area', INTV, REALV, CHARV)
      IF( IRET.NE.0 ) STOP 'area INTOUT failed.'
C
C     Define grid to be used for interpolating the new field(s).
C
      IF( OPTION.EQ.'ll' ) THEN
        REALV(1) = 0.5
        REALV(2) = 0.5
        IRET = INTOUT('grid', INTV, REALV, CHARV)
        IF( IRET.NE.0 ) STOP 'grid INTOUT failed.'
      ENDIF
C
      IF( OPTION.EQ.'gg' ) THEN
        INTV(1) = 80
        IRET = INTOUT('regular', INTV, REALV, CHARV)
        IF( IRET.NE.0 ) STOP 'regular INTOUT failed.'
      ENDIF
C
C
      IF( OPTION.EQ.'qr' ) THEN
        INTV(1) = 80
        IRET = INTOUT('reduced', INTV, REALV, CHARV)
        IF( IRET.NE.0 ) STOP 'reduced INTOUT failed.'
      ENDIF
C
C     Open input and output files.
C
      CALL PBOPEN(IUNIT1, infile, 'r', IERR)
      IF( IERR.NE.0 ) STOP 'PBOPEN failed'
      CALL PBOPEN(IUNIT2, outfile, 'w', IERR)
      IF( IERR.NE.0 ) STOP 'PBOPEN failed'
      IPROD = 0
C
C     Start of loop through input GRIB-coded fields
C
 200  CONTINUE
C
        IPROD = IPROD + 1
C
C       READ next product
C
        CALL PBGRIB(IUNIT1, IOGRIB, JPGRIB * JPBYTES, IREC, IERR)
        IF( IERR .EQ. -1 ) GOTO 900
        IF( IERR .NE. 0 ) STOP 'PBGRIB failed'
C
C       Interpolate
C
        WRITE(*,*) ' Interpolate product number ', IPROD
        INLENG = JPGRIB
        IRET = INTF2(IOGRIB,IREC,INGRIB,INLENG)
        IF( IRET.NE.0 ) STOP 'INTF failed.'
C
C       Write the new product to file
C
        IF( INLENG.GT.0 ) THEN
          CALL PBWRITE( IUNIT2, INGRIB, INLENG*JPBYTES, IERR)
        ELSE
          WRITE(*,*) 'Output same as input'
          CALL PBWRITE( IUNIT2, IOGRIB, IREC, IERR)
        ENDIF
        IF( IERR.LT.0 ) STOP 'PBWRITE failed'
C
C       Loop back for next product
C
      GOTO 200
C
C     Closedown
C
 900  CONTINUE
C
      IPROD = IPROD - 1
      WRITE(*,*) ' All done after ', IPROD, ' products.'
C
C     Close input and output files.
C
      CALL PBCLOSE(IUNIT1, IERR)
      CALL PBCLOSE(IUNIT2, IERR)
C
      STOP
      END

C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE ROWINA3( P, KO, KI, PW, KCODE, PMSVAL, KRET,
     X                    OMISNG, OPERIO, OVEGGY)
C
C---->
C**** ROWINA3 - Interpolation of row of values.
C
C     Purpose.
C     --------
C
C     Interpolate a row of values.
C
C
C**   Interface.
C     ----------
C
C     CALL ROWINA3( P, KO, KI, PW, KCODE, PMSVAL, KRET, OMISNG, OPERIO)
C
C
C     Input Parameters.
C     -----------------
C
C     P      - Row of values to be interpolated.
C              Dimension must be at least KO.
C
C     KO     - Number of values required.
C
C     KI     - Number of values in P on input.
C
C     PW     - Working array.
C              Dimension must be at least (0:KO+2,3).
C
C     KCODE  - Interpolation required.
C              1 , linear.
C              3 , cubic.
C
C     PMSVAL - Value used for missing data indicator.
C
C     OMISNG - True if missing values are present in field.
C
C     OPERIO - True if input field is periodic.
C
C     OVEGGY     - True if 'nearest neighbour' processing must be used
C                  for interpolation
C
C     Output Parameters.
C     ------------------
C
C     P     - Now contains KO values.
C     KRET  - Return code
C             0, OK
C             Non-zero, error
C
C
C     Method.
C     -------
C
C     Linear or cubic interpolation performed as required.
C
C
C     Externals.
C     ----------
C
C     SCM0
C
C
C     Reference.
C     ----------
C
C     None.
C
C
C     Comments.
C     ---------
C
C     This is a version of ROWINA which allows for missing data
C     values and hence for bitmapped fields.
C
C
C     Author.
C     -------
C
C     J.D.Chambers    ECMWF     22.07.94
C
C
C     Modifications.
C     --------------
C
C     J.D.Chambers    ECMWF     13.09.94
C     Add return code KRET and remove calls to ABORT.
C
C     J. Clochard, Meteo France, for ECMWF - January 1998.
C     Addition of OMISNG and OPERIO arguments.
C
C
C     -----------------------------------------------------------------
C----<
C
C*******************************************************************
C     Section 0.  Declarations.
C*******************************************************************
C
      IMPLICIT NONE
C
#include "grprs.h"
C
C     Subroutine arguments
      REAL P, PW, PMSVAL
      INTEGER KO,KI,KCODE, KRET
      DIMENSION P(KO),PW(0:KO+2,3)
C
C     Local variables
      INTEGER JL, IP
      REAL ZRDI, ZDO, ZPOS, ZWT, ZWT1
C
      LOGICAL OMISNG, OPERIO, OVEGGY
C
C*******************************************************************
C     Section 1.  Linear interpolation ..
C*******************************************************************
C
  100 CONTINUE
C
      KRET = 0
C
      IF( KCODE.EQ.1 ) THEN
C
C        Move input values to work array
         DO 110 JL = 1, KI
            PW(JL,1) = P(JL)
  110    CONTINUE
C
         IF (OPERIO) THEN
C
C        Arrange wrap-around value in work array
           PW(KI+1,1) = P(1)
C
C          Set up constants to be used to figure out weighting for
C          values in interpolation.
           ZRDI = REAL(KI)
           ZDO  = 1.0 / REAL(KO)
         ELSE
C
C        Repeat last value, to cope with "implicit truncation" below
           PW(KI+1,1) = P(KI)
C
C          Set up constants to be used to figure out weighting for
C          values in interpolation.
           ZRDI = REAL(KI-1)
           ZDO  = 1.0 / REAL(KO-1)
         ENDIF
C
C        Loop through the output points
         IF ( .NOT. OMISNG ) THEN
C
            DO 120 JL = 1, KO
C
C           Calculate weight from the start of row
            ZPOS = (JL-1) * ZDO
            ZWT  = ZPOS * ZRDI
C
C           Get the current array position(minus 1) from the weight -
C           note the implicit truncation.
            IP   = ZWT
C
C           Adjust the weight to range (0.0 to 1.0)
            ZWT  = ZWT - IP
C
C           If 'nearest neighbour' processing must be used
C
            IF( OVEGGY ) THEN
C
              IF( ZWT.LT.0.5 ) THEN
                P(JL) = PW(IP+1,1)
              ELSE
                P(JL) = PW(IP+2,1)
              ENDIF
            ELSE
C
C             Interpolate using the weighted values on either side
C             of the output point position
              P(JL) = (1.0-ZWT) * PW(IP+1,1) + ZWT * PW(IP+2,1)
C
            ENDIF
C
  120       CONTINUE
C
         ELSE
C
         DO 130 JL = 1, KO
C
C           Calculate weight from the start of row
            ZPOS = (JL-1) * ZDO
            ZWT  = ZPOS * ZRDI
C
C           If 'nearest neighbour' processing must be used
C
            IF( OVEGGY ) THEN
C
              IF( ZWT.LT.0.5 ) THEN
                P(JL) = PW(IP+1,1)
              ELSE
                P(JL) = PW(IP+2,1)
              ENDIF
            ELSE
C
C             Get the current array position(minus 1) from the weight -
C             note the implicit truncation.
              IP   = ZWT
C
C             If the left value is missing, use the right value
              IF ( PW(IP+1,1) .EQ. PMSVAL ) THEN
                 P(JL) = PW(IP+2,1)
C
C             If the right value is missing, use the left value
              ELSE IF ( PW(IP+2,1) .EQ. PMSVAL ) THEN
                 P(JL) = PW(IP+1,1)
C
C             If neither missing, interpolate ...
              ELSE
C
C               Adjust the weight to range (0.0 to 1.0)
                ZWT  = ZWT - IP
C
C               Interpolate using the weighted values on either side
C               of the output point position
                P(JL) = (1.0-ZWT) * PW(IP+1,1) + ZWT * PW(IP+2,1)
              ENDIF
C
            ENDIF
C
  130    CONTINUE
C
       ENDIF
C
C*******************************************************************
C     Section 2.  Cubic interpolation ..
C*******************************************************************
C
  200 CONTINUE
C
      ELSEIF(KCODE.EQ.3) THEN
C
         IF ( OMISNG ) THEN
            WRITE(GRPRSM,*)
     X        'ROWINA3: Cubic interpolation not supported'
            WRITE(GRPRSM,*)
     X        'ROWINA3: for fields containing missing data.'
            WRITE(GRPRSM,*) ' Sorry!'
            KRET = 1
            GOTO 900
         ENDIF
C
         DO 210 JL = 1,KI
            IF ( P(JL) .EQ. PMSVAL ) THEN
              WRITE(GRPRSM,*) 
     X          'ROWINA3: Cubic interpolation not supported'
              WRITE(GRPRSM,*) 
     X          'ROWINA3: for fields containing missing data.'
              WRITE(GRPRSM,*) ' Sorry!'
              KRET = 1
              GOTO 900
            ENDIF
            PW(JL,1) = P(JL)
  210    CONTINUE
         PW(0,1) = P(KI)
         PW(KI+1,1) = P(1)
         PW(KI+2,1) = P(2)
         DO 220 JL = 1,KI
            PW(JL,2) =  - PW(JL-1,1)/3.0 - 0.5*PW(JL,1)
     1             + PW(JL+1,1)    - PW(JL+2,1)/6.0
            PW(JL+1,3) =    PW(JL-1,1)/6.0 - PW(JL,1)
     1             + 0.5*PW(JL+1,1) + PW(JL+2,1)/3.0
  220    CONTINUE
         CALL SCM0(PW(1,2),PW(2,3),PW(1,1),PW(2,1),KI)
         ZRDI = REAL(KI)
         ZDO = 1.0/REAL(KO)
         DO 230 JL = 1,KO
            ZPOS = (JL-1)*ZDO
            ZWT = ZPOS*ZRDI
            IP = ZWT+1
            ZWT = ZWT+1.0-IP
            ZWT1  =  1.0 - ZWT
            P(JL) = ((3.0-2.0*ZWT1)*PW(IP,1) + ZWT*PW(IP,2))*ZWT1*ZWT1
     1       + ((3.0-2.0*ZWT) *PW(IP+1,1) - ZWT1*PW(IP+1,3))*ZWT*ZWT
  230    CONTINUE
C
      ELSE
C
C*******************************************************************
C     Section 3.  Invalid interpolation code ..
C*******************************************************************
C
  300   CONTINUE
C
        WRITE(GRPRSM,9001) KCODE
        KRET = 2
      ENDIF
C
C*******************************************************************
C     Section 9.  Closedown.
C*******************************************************************
C
900   CONTINUE
      RETURN
C
 9001 FORMAT (1H ,'ROWINA3 : Invalid interpolation code = ',I4)
C
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE XYZ2LL(X,Y,Z,RLAT,RLONG,INROW)
C---->
C**** XYZ2LL
C
C     Purpose
C     -------
C
C     Converts an array of (x,y,z) coordinates to an
C     array of latitude/longitude values.
C
C
C     Interface
C     ---------
C
C     CALL XYZ2LL(X,Y,Z,RLAT,RLONG,INROW)
C
C     Input
C     -----
C
C     (X,Y,Z) - Array of coordinates.
C     INROW   - Count of coordinates.
C
C
C     Output
C     ------
C
C     RLAT  - Array of latitudes.
C     RLONG - Array of corresponding longitudes.
C
C
C     Method
C     ------
C
C     Z axis is the polar axis directed from south to north.
C     X and Y axes are in the equatorial plane and have origin at the
C     centre of the Earth. The X axis passes through (O north, 0 east).
C     Longitude values are in range (0,360).
C
C
C     Externals
C     ---------
C
C     None.
C
C
C     Author
C     ------
C
C     J.D.Chambers     ECMWF
C
C----<
C
      IMPLICIT NONE
C
C     Subroutine arguments
C
      REAL X,Y,Z,RLAT,RLONG
      DIMENSION X(*),Y(*),Z(*),RLAT(*),RLONG(*)
      INTEGER INROW
C
C     Local variables
C
      REAL*8 FACTOR
      DATA FACTOR/57.2957763671875/
      INTEGER LOOP
C
      DO LOOP = 1, INROW
        RLAT(LOOP)  = ASIN(Z(LOOP)) * FACTOR
      ENDDO
C
      DO LOOP = 1, INROW
        IF( ABS(X(LOOP)).GT.0.0001 ) THEN
          RLONG(LOOP) = ATAN2(Y(LOOP),X(LOOP)) * FACTOR
        ELSE IF ( Y(LOOP).GT.0.0 ) THEN
          RLONG(LOOP) = 90.0
        ELSE
          RLONG(LOOP) = -90.0
        ENDIF
      ENDDO
C
      DO LOOP = 1, INROW
        IF(RLONG(LOOP).LT.0.0) RLONG(LOOP) = RLONG(LOOP) + 360.0
      ENDDO
C
      RETURN
      END

C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      INTEGER FUNCTION REVERO ( KDATA,  KLENP,  KSEC2,  KGRIB,  KLENG,
     X                          KBITS,  KBMAP,  KVALS,  OPRIBI, OQUASI,
     X                          KNROWS, KLEN,   KWORK,  KLWORK, ODEBUG,
     X                          OPRCLN, KLENGR )
C
C---->
C**** REVERO
C
C     Purpose.
C     --------
C
C     Reverse order of even rows in a field of integer values.
C     This function is used for handling of boustrophedonic ordering
C     in extended second-order packing methods.
C
C
C**   Interface.
C     ----------
C
C     KRET = REVERO ( KDATA,  KLENP,  KSEC2,  KGRIB,  KLENG,  KBITS,
C    X                KBMAP,  KVALS,  OPRIBI, OQUASI, KNROWS, KLEN,
C    X                KWORK,  KLWORK, ODEBUG, OPRCLN, KLENGR )
C
C     Input Parameters.
C     ----------------
C
C     KDATA      - Array of normalized values.
C     KLENP      - Length of array KDATA.
C     KSEC2      - Array of GRIB section 2 integer descriptors.
C     KGRIB      - Array containing GRIB product (for bit-map).
C     KLENG      - Length of GRIB product array.
C     KBITS      - Number of bits per computer word.
C     KBMAP      - Bit pointer for start of explicit primary Bit-MAP
C                  (if any).
C     KVALS      - Number of bits in primary bit-map.
C     OPRIBI     - True if a PRImary BIt-map is present.
C     OQUASI     - True if the grid is QUASI-regular.
C     KNROWS     - Number of ROWS (or lines) in the grid.
C     KLEN       - Exact number of grid-points to handle.
C     KLWORK     - Length of work array KWORK.
C     ODEBUG     - True for some debug printout.
C     OPRCLN     - True if row lengthes have been pre-computed.
C
C     Input Parameters if OPRCLN is TRUE.
C     ------------------------------------
C     KLENGR     - Effective LENGth of Rows array.
C
C     Output Parameters if OPRCLN is FALSE.
C     ------------------------------------
C
C     KWORK      - Work array, used to unpack a primary bit-map, if any.
C
C     Method.
C     -------
C
C     Determines effective row length(es), and swaps fields values
C     for rows with an even rank.
C
C     Externals.
C     ----------
C
C     None.
C
C
C     Reference.
C     ----------
C
C     None.
C
C
C     Comments.
C     --------
C
C     Note that arrays KLENGR and KWORK are not used in the same call,
C     so they may overlap.
C
C
C     Author.
C     -------
C
C     J. Clochard, Meteo France, for ECMWF - January 1998.
C
C
C     Modifications.
C     _____________
C
C     None.
C
C
C----<
C     -----------------------------------------------------------------
C*    Section 0. Definition of variables.
C     -----------------------------------------------------------------
C
      IMPLICIT NONE
C
#include "grprs.h"
C
C
C     Subroutine arguments
C
      INTEGER KLENP, KBMAP, KVALS, KNROWS, KLEN, KLWORK, KLENG, KBITS
      INTEGER KDATA (KLENP), KSEC2 (*), KWORK (KLWORK), KGRIB (KLENG)
      INTEGER KLENGR (KNROWS)
C
      LOGICAL OPRIBI, OQUASI, ODEBUG, OPRCLN
C
C     Local variables.
C
      INTEGER IREFLN, IPTRBM, IRETFN, JROW, IPTOFF, ILNGTX, INBSEQ, J
      INTEGER JSEQ, IPTNBR, ICOUNT, ILNGTH, ILEN, INDEX1, INDEX2, IRET
      INTEGER IAUXIL
C
      CHARACTER YOPER*1
C
C     -----------------------------------------------------------------
C*    Section 1 . Performs initial computations.
C     -----------------------------------------------------------------
C
  100 CONTINUE
C
#ifndef ebug2o
      IF (ODEBUG) THEN
#endif
        WRITE(GRPRSM,FMT=9100) OPRCLN
#ifndef ebug2o
      ENDIF
#endif
C
      YOPER='D'
C
      IRETFN = 0
      IREFLN=22
      ICOUNT=0
C
      IF (OPRIBI) THEN
        IPTRBM=KBMAP
        ILEN=KVALS
      ELSE
        ILEN=KLEN
      ENDIF
C
      ILNGTX=ILEN/KNROWS
C
C     -----------------------------------------------------------------
C*    Section 2 . Loop on rows, wuth values swap for even rank rows.
C     -----------------------------------------------------------------
C
  200 CONTINUE
C
      DO 222 JROW=1,KNROWS
C
      IF (OQUASI) THEN
        ILNGTX=KSEC2(IREFLN+JROW)
      ENDIF
C
      IF (.NOT.OPRIBI.OR.ILNGTX.EQ.0) THEN
C
C         Effective length of row = full length.
C
        ILNGTH=ILNGTX
C
      ELSEIF (OPRCLN) THEN
C
        ILNGTH=KLENGR (JROW)
C
      ELSE
C
C         An (explicit) bit-map is included.
C         The number of values in current row has to be computed.
C
        ILNGTH=0
        INBSEQ=1+(ILNGTX-1)/KLWORK
C
        DO 212 JSEQ=1,INBSEQ
        IPTOFF=(JSEQ-1)*KLWORK
        IPTNBR=MIN (KLWORK,ILNGTX-IPTOFF)
        CALL INXBIT (KGRIB,KLENG,IPTRBM,KWORK,IPTNBR,KBITS,1,
     X               YOPER,IRET)
C
        IF (IRET.NE.0) THEN
          IRETFN = 23210
          WRITE(GRPRSM,FMT=9210) JROW, IPTOFF+1, IPTOFF+IPTNBR
          GOTO 900
        ENDIF
C
        DO 211 J=1,IPTNBR
        ILNGTH=ILNGTH+KWORK(J)
  211   CONTINUE
C
  212   CONTINUE
C
      ENDIF
C
      IF (MOD (JROW,2).EQ.0.AND.ILNGTH.GT.1) THEN
C
C             Swap field values within row.
C
#ifdef CRAY
CDIR$ IVDEP
#endif
#ifdef FUJITSU
!OCL NOVREC
#endif
        DO 221 J=1,ILNGTH/2
        INDEX1=ICOUNT+J
        INDEX2=ICOUNT+ILNGTH+1-J
        IAUXIL=KDATA(INDEX1)
        KDATA(INDEX1)=KDATA(INDEX2)
        KDATA(INDEX2)=IAUXIL
  221   CONTINUE
C
      ENDIF
C
      ICOUNT=ICOUNT+ILNGTH
C
  222 CONTINUE
C
      IF (ICOUNT.NE.KLEN) THEN
        IRETFN = 23220
        WRITE(GRPRSM,FMT=9220) ICOUNT, KLEN
        GOTO 900
      ENDIF      
C
C     -----------------------------------------------------------------
C*    Section 9. Return to calling routine.
C     -----------------------------------------------------------------
C
  900 CONTINUE
C
      REVERO = IRETFN
#ifndef ebug2o
C
      IF (ODEBUG) THEN
#endif
        WRITE(GRPRSM,FMT=9900) IRETFN
#ifndef ebug2o
      ENDIF
#endif
C
      RETURN
C
 9100 FORMAT (' REVERO: Function start, OPRCLN = ',L1,'.')
C
 9210 FORMAT (' REVERO: Problem unpacking primary bit-map,row',I6,
     X        ' points ',I8,'..',I8,'.')
C
 9220 FORMAT (' REVERO: Inconsistency: computed g.p. number =',I8,
     X        ', expected =',I8,'.')
C
 9900 FORMAT (' REVERO: Function return code =',I6,'.')
C
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE ECDEF17(HFUNC,KSEC1,KGRIB,KLENG,KNSPT,KBITS,KRET)
C
C---->
C**** ECDEF17
C
C     Purpose.
C     --------
C
C     GRIB coding/decoding of ECMWF local use definition 17.
C
C**   Interface.
C     ----------
C
C     CALL ECDEF17(HFUNC,KSEC1,KGRIB,KLENG,KNSPT,KBITS,KRET)
C
C
C     Input Parameters.
C     -----------------
C
C     HFUNC - Requested function.
C              'C' to code data.
C              'D' to decode data.
C     KSEC1 - Array containing Grib Section 1 data.
C     KGRIB - Array containing Grib coded data.
C     KLENG - Length (words) of KGRIB.
C     KNSPT - Bit number after which insertion/extraction starts.
C     KBITS - Number of bits in computer word.
C     KRET  - Response to error indicator.
C              0        , Abort if error encountered.
C              Non-zero , Return to calling routine
C                         even if error encountered.
C
C     Output Parameters.
C     ------------------
C
C     KSEC1 - Array containing Grib Section 1 data.(Updated)
C     KGRIB - Array containing Grib coded data.(Updated)
C     KNSPT - Number of bit after last one inserted/extracted.(Updated)
C     KRET  - Return code.
C              0   , No error encountered.
C              2   , Error reported by routine INXBIT.
C
C
C     Method.
C     -------
C
C     Input data packed/unpacked in accordance with ECMWF usage of
C     local part of section 1 of Grib code, definition 17.
C
C
C     Externals.
C     ----------
C
C     INXBIT
C     ABORTX
C     CSGNBT
C     DSGNBT
C
C
C     Reference.
C     ----------
C
C     WMO Manual On Codes for Grib Code.
C
C
C     Comments.
C     ---------
C
C     Adapted from ecdef6.F
C
#include "ecdef17.h"
C
C     Author.
C     -------
C
C     J.D.Chambers     ECMWF       May 2000
C
C
C     Modifications.
C     --------------
C
C     Set space used for the list of SEA-ICE dates to a multiple of
C     JPPAD to stabilise the length of section 1 of the GRIB header.
C     (Usually the number of dates will be less than 10).
C
C
C----<
C     ------------------------------------------------------------------
C*    Section 0 . Definition of variables. Data statements.
C     ------------------------------------------------------------------
C
      IMPLICIT NONE
C
#include "common/grprs.h"
C
C     Parameters
C
      INTEGER JPPAD
      PARAMETER( JPPAD = 10 )
C
C     Subroutine arguments
C
      CHARACTER*1   HFUNC
      INTEGER KSEC1, KGRIB, KLENG, KNSPT, KBITS, KRET
      DIMENSION KGRIB(*)
      DIMENSION KSEC1(*)
C
C     Local variables
C
      INTEGER IRET, IZERO, ILOOP, LENS1, INDATE, INSPT, NSEAICE, NEXTRA
      INTEGER IPLEN
C
      LOGICAL LENCODE
C
C     ------------------------------------------------------------------
C*    Section 1 . Set initial values.
C     ------------------------------------------------------------------
C
  100 CONTINUE
C
      IRET = KRET
      LENCODE = ( HFUNC.EQ.'C' )
      INSPT = KNSPT
C
C     Set bit pointer to start of GRIB section 1
C
      IPLEN = 8*8
C
C     ------------------------------------------------------------------
C*    Section 2 . Handle definition 6.
C     ------------------------------------------------------------------
C
  200 CONTINUE
C
C     Octet 50-51 :Reserved.
C     Should be 0 !!
C
      IF ( LENCODE ) THEN
        IZERO = 0
        CALL INXBIT(KGRIB,KLENG,KNSPT,IZERO, 1,KBITS, 16,HFUNC,KRET)
        IF( KRET.NE.0 ) THEN
          KRET = 2
          WRITE(GRPRSM,9004)
        ENDIF
      ELSE
        CALL INXBIT(KGRIB,KLENG,KNSPT,KSEC1(42),2,KBITS,8,HFUNC,KRET)
        IF( KRET.NE.0 ) THEN
          KRET = 2
          WRITE(GRPRSM,9004)
        ENDIF
      ENDIF
C
C     Octet 52-54 : YYMMDD date of the SST field used.
C
      IF( LENCODE) THEN
        INDATE = KSEC1(44)
        IF( INDATE.GT.19000000 ) INDATE = INDATE - 19000000
      ENDIF
      CALL INXBIT(KGRIB,KLENG,KNSPT,INDATE,1,KBITS,24,HFUNC,KRET)
      IF( KRET.NE.0 ) THEN
        KRET = 2
        WRITE(GRPRSM,9004)
      ENDIF
      IF( .NOT. LENCODE) THEN
        IF( (INDATE.LT.19000000).AND.(INDATE.GT.100) )
     X    INDATE = INDATE + 19000000
        KSEC1(44) = INDATE
      ENDIF
C
C     Octet 55 : Type of SST field used.
C
      CALL INXBIT(KGRIB,KLENG,KNSPT,KSEC1(45), 1,KBITS, 8,HFUNC,KRET)
      IF( KRET.NE.0 ) THEN
        KRET = 2
        WRITE(GRPRSM,9004)
      ENDIF
C
C     Octet 56 : Count of ICE fields used (n, say).
C
      CALL INXBIT(KGRIB,KLENG,KNSPT,KSEC1(46), 1,KBITS, 8,HFUNC,KRET)
      IF( KRET.NE.0 ) THEN
        KRET = 2
        WRITE(GRPRSM,9004)
      ENDIF
C
C     Octet 57->54+(n*4) : YYMMDD dates and satellite numbers of the
C                          ICE fields used.
C
      NSEAICE = KSEC1(46)
      DO ILOOP = 1, NSEAICE
C
C       YYMMDD date.
C
        IF( LENCODE) THEN
          INDATE = KSEC1(45+(ILOOP*2))
          IF( INDATE.GT.19000000 ) INDATE = INDATE - 19000000
        ENDIF
        CALL INXBIT(KGRIB,KLENG,KNSPT,INDATE,1,KBITS,24,HFUNC,KRET)
        IF( KRET.NE.0 ) THEN
          KRET = 2
          WRITE(GRPRSM,9004)
        ENDIF
        IF( .NOT. LENCODE) THEN
          IF( (INDATE.LT.19000000).AND.(INDATE.GT.100) )
     X      INDATE = INDATE + 19000000
          KSEC1(45+(ILOOP*2)) = INDATE
        ENDIF
C
C       Satellite number (ICE data).
C
        CALL INXBIT(KGRIB,KLENG,KNSPT,KSEC1(46+(ILOOP*2)),
     X              1,KBITS, 8,HFUNC,KRET)
        IF( KRET.NE.0 ) THEN
          KRET = 2
          WRITE(GRPRSM,9004)
        ENDIF
C
      ENDDO
C
C     ------------------------------------------------------------------
C*    Section 3 . Handle padding of the ICE field slots.
C     ------------------------------------------------------------------
C
  300 CONTINUE
C
C     If the number of ICE fields used is not a multiple of JPPAD,
C     pad the ICE field slots upto a multiple of JPPAD.
C
      NEXTRA = JPPAD - MOD(NSEAICE,JPPAD)
      NSEAICE = NSEAICE + NEXTRA
      IF( LENCODE ) THEN
        DO ILOOP = 1, NEXTRA
          CALL INXBIT(KGRIB,KLENG,KNSPT,IZERO,1,KBITS,32,HFUNC,KRET)
          IF( KRET.NE.0 ) THEN
            KRET = 2
            WRITE(GRPRSM,9004)
          ENDIF
        ENDDO
C
C       If encoding, set length of section 1.
C
        LENS1 = 56 + NSEAICE*4
        CALL INXBIT(KGRIB,KLENG,IPLEN,LENS1, 1,KBITS,24,HFUNC,KRET)
        IF( KRET.NE.0 ) THEN
          KRET = 2
          WRITE(GRPRSM,9004)
        ENDIF      
C
      ELSE
C
C       If decoding, use length of section 1 to step KNSPT pointer
C       past section 1, past any padding slots if any.
C
        CALL INXBIT(KGRIB,KLENG,IPLEN,LENS1, 1,KBITS,24,HFUNC,KRET)
        IF( KRET.NE.0 ) THEN
          KRET = 2
          WRITE(GRPRSM,9004)
        ENDIF      
        KNSPT = INSPT - (49*8) + LENS1*8
      ENDIF
C
C     ------------------------------------------------------------------
C*    Section 9 . Abort/return to calling routine. Format statements.
C     ------------------------------------------------------------------
C
  900 CONTINUE
C
C     Abort if requested to do so when an error has been encountered.
C
      IF( (IRET.EQ.0).AND.(KRET.NE.0) ) THEN
        CALL ABORTX ('ECDEF17')
      ELSE
        RETURN
      ENDIF
C
 9004 FORMAT (' ECDEF17: Error reported by routine INXBIT.')
C
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE SBYTES (D,S,ISKIP1,IBSIZ,ISKIP2,NBYTES,KWOFF)
C
C---->
C**** SBYTES - Insert a number of bit fields. Cray routine.
C
C REVERSES THE ACTION OF GBYTES, TAKING FIELDS FROM S AND
C INSERTING THEM INTO A BIT STRING IN D. SEE GBYTES.
C AUTHOR D. ROBERTSON  AUG,1981
C
C----<
      PARAMETER(NBPW=64)
      DIMENSION D(2) , S(NBYTES)
      INTEGER SH1,SH2,SH3
      IGNORE = 0
#ifdef CRAY
      IF(NUMARG().GT.6) IGNORE = KWOFF
#else
      IF(NUMARG(DUMMY).GT.6) IGNORE = KWOFF
#endif
      ID=1+ISKIP1/(NBPW-IGNORE)
      ISKIP = MOD(ISKIP1,NBPW-IGNORE) + IGNORE
      ISTEP = ISKIP2+IBSIZ
      DO 75 IBYTE = 1 , NBYTES
C WITH THE STARTING WORD AND BIT POSITION KNOWN, THE
C DESIRED INSERTION CAN BE DONE BY
C**      CALL SBYTE(D(ID),S(IBYTE),ISKIP,IBSIZ)
C BUT THE CODE IS SHORT ENOUGH TO GO IN-LINE.
         SH1 = ISKIP+IBSIZ
         IF(SH1.GT.NBPW) GO TO 50
         SH2 = NBPW-SH1
         IF(SH2.LT.0) SH2 = NBPW-SH2
C BYTE GOES INTO 1 WORD OF D.
         D(ID) = SHIFT(OR(AND(SHIFT(D(ID),SH1),MASK(NBPW-IBSIZ)),
     1                   AND(S(IBYTE),SHIFT(MASK(IBSIZ),IBSIZ))),SH2)
         GO TO 65
   50    CONTINUE
C BYTE GOES INTO 2 WORDS OF D.
         SH3 = 2*NBPW-SH1
         D(ID)=OR(AND(D(ID),MASK(ISKIP)),
     1               AND(SHIFT(S(IBYTE),SH3),COMPL(MASK(ISKIP))))
         D(ID+1)=OR(AND(D(ID+1),SHIFT(COMPL(MASK(SH1-NBPW)),NBPW-IGNORE)
     1                 ),
     2              SHIFT(AND(S(IBYTE),COMPL(MASK(SH3))),SH3-IGNORE))
   65    CONTINUE
C UPDATE STARTING WORD AND BIT POSITION
         ISKIP = ISKIP+ISTEP
         IF(ISKIP.LT.NBPW) GO TO 75
         ISKIP = ISKIP - NBPW
         ID = ID+1+ISKIP/(NBPW-IGNORE)
         ISKIP = MOD(ISKIP,NBPW-IGNORE) + IGNORE
   75    CONTINUE
      RETURN
      END

C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE BUEXS1( KBUFL,KBUFF,KSUP,KSEC0,KSEC1,KERR)
C
C**** *BUEXS1*
C
C
C     PURPOSE.
C     --------
C          EXPANDS SECTION 1 OF BUFR MESSAGE. SAVES EXPANDED INFORMATION
C     IN THE ARRAY KSEC1.
C
C**   INTERFACE.
C     ----------
C
C          *CALL* *BUEXS1( KBUFL,KBUFF,KSUP,KSEC0,KSEC1,KERR)*
C
C        INPUT :
C               *KBUFL*   -  LENGTH OF BUFR MESSAGE (WORDS)
C               *KBUFF*   -  ARRAY CONTAINING BUFR MESSAGE
C        OUTPUT:
C               *KSUP*    -  ARRAY CONTAINING SUPLEMENTARY INFORMATION
C                         -  KSUP( 1) -- IDIM1, DIMENSION OF KSEC1
C                         -  KSUP( 2) -- IDIM2, DIMENSION OF KSEC2
C                         -  KSUP( 3) -- IDIM3, DIMENSION OF KSEC3
C                         -  KSUP( 4) -- IDIM4, DIMENSION OF KSEC4
C                         -  KSUP( 5) -- M (NUMBER OF ELEMENTS IN VALUES ARRAY,
C                                           FIRST INDEX)
C                         -  KSUP( 6) -- N (NUMBER OF SUBSETS,SECOND INDEX OF
C                                           VALUES ARRAY)
C                         -  KSUP( 7) -- JVC (NUMBER OF ELEMENTS IN CVAL ARRAY)
C                         -  KSUP( 8) -- TOTAL BUFR MESSAGE LENGTH IN BYTES
C                         -  KSUP( 9) -- IDIM0, DIMENSION OF KSEC0
C               *KSEC0*   -  ARRAY CONTAINING SECTION 0 INFORMATION
C                            KSEC0( 1)-- LENGTH OF SECTION 0 (BYTES)
C                            KSEC0( 2)-- TOTAL LENGTH OF BUFR MESSAGE (BYTES)
C                            KSEC0( 3)-- BUFR EDITION NUMBER
C               *KSEC1*   -  ARRAY CONTAINING SECTION 1 INFORMATION
C                            KSEC1( 1)-- LENGTH OF SECTION 1 (BYTES)
C                            KSEC1( 2)-- BUFR EDITION NUMBER
C                            KSEC1( 3)-- ORIGINATING CENTRE
C                            KSEC1( 4)-- UPDATE SEQUENCE NUMBER
C                            KSEC1( 5)-- FLAG (PRESENCE OF SECTION 2)
C                            KSEC1( 6)-- BUFR MESSAGE TYPE
C                            KSEC1( 7)-- BUFR MESSAGE SUBTYPE
C                            KSEC1( 8)-- VERSION NUMBER OF LOCAL TABLE USED
C                            KSEC1( 9)-- YEAR
C                            KSEC1(10)-- MONTH
C                            KSEC1(11)-- DAY
C                            KSEC1(12)-- HOUR
C                            KSEC1(13)-- MINUTE
C                            KSEC1(14)-- BUFR MASTER TABLE
C                            KSEC1(15)-- VERSION NUMBER OF MASTER TABLE USED
C                            KSEC1(16) - KSEC1(JSEC1) -- LOCAL ADP CENTRE
C                                        INFORMATION(PACKED FORM)
C
C                            FOR BUFR EDITION 3 ONWARD
C
C                            KSEC1(16)-- ORIGINATING SUB-CENTRE
C                            KSEC1(17)-- NOT USED
C                            KSEC1(18) TO KSEC1(JSEC1) - LOCAL ADP CENTRE
C                                        INFORMATION(PACKED FORM)
C                            
C                            FOR BUFR EDITION 4 ONWARD
C
C                            KSEC1(16)-- ORIGINATING SUB-CENTRE
C                            KSEC1(17)-- INTERNATIONAL SUB-CATEGORY (SEE COMMON TABLE C-13
C                            KSEC1(18)-- SECOND
C                            KSEC1(19)-- YEAR
C                            KSEC1(20)-- MONTH
C                            KSEC1(21)-- DAY
C                            KSEC1(22)-- HOUR
C                            KSEC1(23)-- MINUTE
C                            KSEC1(24)-- SECOND
C                            KSEC1(25)-- YEAR
C                            KSEC1(26)-- MONTH
C                            KSEC1(27)-- DAY
C                            KSEC1(28)-- HOUR
C                            KSEC1(29)-- MINUTE
C                            KSEC1(30)-- SECOND
C                            KSEC1(31)-- MOST SOUTHERN LATITUDE  (-90 to 90)
C                            KSEC1(32)-- MOST WESTERN LONGITUDE  ( 0-360)
C                            KSEC1(33)-- MOST NORTHEN LATITUDE   (-90 to 90)
C                            KSEC1(34)-- MOST EASTERN LONGITUDE  ( 0-360)
C                            KSEC1(35) TO KSEC1(JSEC1) - LOCAL ADP CENTRE INFORMATION(PACKED FORM)
C
C
C     *METHOD.
C      -------
C
C           NONE.
C
C
C     EXTERNALS.
C     ----------
C
C          BUNPCK          -  UNPACK BIT PATTERN
C          BUNEXS         -  SET WORD AND BIT POINTERS AT THE BEGINING OF
C                            NEXT SECTION
C
C
C     REFERENCE.
C     ----------
C
C          NONE.
C
C     AUTHOR.
C     -------
C
C          M. DRAGOSAVAC    *ECMWF*       16/01/91.
C
C
C     MODIFICATIONS.
C     --------------
C
C          NONE.
C
C
      IMPLICIT LOGICAL(L,O,G), CHARACTER*8(C,H,Y)
C
C
#     include "parameter.F"
#     include "bcomunit.F"
#     include "bcomwork.F"
C
      DIMENSION KBUFF(KBUFL),KSUP(JSUP),KSEC0(JSEC0),KSEC1(JSEC1)
      DIMENSION ISEC1(JSEC1)
#ifndef R_4
      REAL*8 RVIND
      REAL*8 EPS
#else
      REAL   RVIND
      REAL   EPS
#endif
C
C
C     ------------------------------------------------------------------
C*          1.  EXPAND SECTION 1.
C               ------------------
 100  CONTINUE
C
      IF( KERR.NE.0 ) RETURN
C
C     SAVE WORD AND BIT POINTERS OF THR BRGINING OF SECTION 1.
C
      IWPTB=NWPT
      IBPTB=NBPT
C
C*          1.1 UNPACK LENGTH OF SECTION 1.
C               ----------------------------
 110  CONTINUE
C
      CALL BUNPCK(NBPW,KBUFF,KSEC1(1),NWPT,NBPT,24,KERR)
      IF(KERR.GT.0) THEN
         WRITE(KNTN,*)  'ERROR UNPACKING KSEC1(1).'
         RETURN
      END IF
C     IF(KSEC1(1).GT.18) THEN
C        WRITE(KNTN,*)  'LOCAL ADP CENTRE INFORMATION PRESENT 
C    1 IN THE SECTION 1.'
C     END IF
C
C*          1.1.1 SET THE POINTERS NWPTB AND NBPTB.
C                 ---------------------------------
C                 TO BEGINING OF THE NEXT SECTION.
C                 --------------------------------
 1110 CONTINUE
C
      CALL BUNEXS(KSEC1(1))
C
C
C*          1.2  UNPACK BUFR EDITION NUMBER/MASTER TABLE USED.
C                ---------------------------------------------
 120  CONTINUE
C
      IF(KSEC0(3).LE.1) THEN
         CALL BUNPCK(NBPW,KBUFF,KSEC1(2),NWPT,NBPT, 8,KERR)
         IF(KERR.GT.0) THEN
            WRITE(KNTN,*)  'ERROR UNPACKING KSEC1(2).'
            RETURN
         END IF
      ELSE
         CALL BUNPCK(NBPW,KBUFF,KSEC1(14),NWPT,NBPT, 8,KERR)
         IF(KERR.GT.0) THEN
            WRITE(KNTN,*)  'ERROR UNPACKING KSEC1(14).'
            RETURN
         END IF
C
         KSEC1(2)=KSEC0(3)
      END IF
C
C*          1.3  UNPACK ORIGINATING CENTRE.
C                --------------------------
 130  CONTINUE
C
      IF(KSEC0(3).LT.3) THEN
         CALL BUNPCK(NBPW,KBUFF,KSEC1(3),NWPT,NBPT,16,KERR)
         IF(KERR.GT.0) THEN
            WRITE(KNTN,*)  'ERROR UNPACKING KSEC1(3).'
            RETURN
         END IF
      ELSEIF(KSEC0(3).EQ.3) THEN
C        BUFR Edition 3
         CALL BUNPCK(NBPW,KBUFF,KSEC1(16),NWPT,NBPT,8,KERR)
         IF(KERR.GT.0) THEN
            WRITE(KNTN,*)  'ERROR UNPACKING KSEC1(3).'
            RETURN
         END IF
         CALL BUNPCK(NBPW,KBUFF,KSEC1(3),NWPT,NBPT,8,KERR)
         IF(KERR.GT.0) THEN
            WRITE(KNTN,*)  'ERROR UNPACKING KSEC1(3).'
            RETURN
         END IF
      ELSEIF(KSEC0(3).EQ.4) THEN
C        BUFR Edition 4
         CALL BUNPCK(NBPW,KBUFF,KSEC1(3),NWPT,NBPT,16,KERR)
         IF(KERR.GT.0) THEN
            WRITE(KNTN,*)  'ERROR UNPACKING KSEC1(3).'
            RETURN
         END IF
         CALL BUNPCK(NBPW,KBUFF,KSEC1(16),NWPT,NBPT,16,KERR)
         IF(KERR.GT.0) THEN
            WRITE(KNTN,*)  'ERROR UNPACKING KSEC1(16).'
            RETURN
         END IF
      END IF
      
C
C*          1.4  UNPACK UPDATE SEQUENCE NUMBER.
C                ------------------------------
 140  CONTINUE
C
      CALL BUNPCK(NBPW,KBUFF,KSEC1(4),NWPT,NBPT, 8,KERR)
      IF(KERR.GT.0) THEN
         WRITE(KNTN,*)  'ERROR UNPACKING KSEC1(4).'
         RETURN
      END IF
C
C*          1.5  UNPACK INTEGER VALUE OF THE OCTET CONTAINING
C                --------------------------------------------
C                 FLAG BITS(ZERO IF SECTION TWO IS NOT PRESENT).
C                 ----------------------------------------------
 150  CONTINUE
C
      CALL BUNPCK(NBPW,KBUFF,KSEC1(5),NWPT,NBPT, 8,KERR)
      IF(KERR.GT.0) THEN
         WRITE(KNTN,*)  'ERROR UNPACKING KSEC1(5).'
         RETURN
      END IF
C
C*          1.6  UNPACK *BUFR* MESSAGE TYPE.
C                ---------------------------
 160  CONTINUE
C
      CALL BUNPCK(NBPW,KBUFF,KSEC1(6),NWPT,NBPT, 8,KERR)
      IF(KERR.GT.0) THEN
         WRITE(KNTN,*)  'ERROR UNPACKING KSEC1(6).'
         RETURN
      END IF
C
C*          1.7  UNPACK *BUFR* MESSAGE SUB-TYPE.
C                -------------------------------
 170  CONTINUE
C
      IF(KSEC0(3).EQ.4) THEN
         CALL BUNPCK(NBPW,KBUFF,KSEC1(17),NWPT,NBPT, 8,KERR)
         IF(KERR.GT.0) THEN
            WRITE(KNTN,*)  'ERROR UNPACKING KSEC1(17).'
            RETURN
         END IF
         CALL BUNPCK(NBPW,KBUFF,KSEC1(7),NWPT,NBPT, 8,KERR)
         IF(KERR.GT.0) THEN
            WRITE(KNTN,*)  'ERROR UNPACKING KSEC1(7).'
            RETURN
         END IF
      ELSE
         CALL BUNPCK(NBPW,KBUFF,KSEC1(7),NWPT,NBPT, 8,KERR)
         IF(KERR.GT.0) THEN
            WRITE(KNTN,*)  'ERROR UNPACKING KSEC1(7).'
            RETURN
         END IF
      END IF
C
C*          1.8  UNPACK LOCAL TABLE VERSION NUMBER OR
C                ------------------------------------
C                VERSION NUMBER OF MASTER TABLE USED.
C                 -----------------------------------
 180  CONTINUE
C
      IF(KSEC0(3).LE.1) THEN
         CALL BUNPCK(NBPW,KBUFF,KSEC1(8),NWPT,NBPT,16,KERR)
         IF(KERR.GT.0) THEN
            WRITE(KNTN,*)  'ERROR UNPACKING KSEC1(8).'
            RETURN
         END IF
      ELSE
         CALL BUNPCK(NBPW,KBUFF,KSEC1(15),NWPT,NBPT, 8,KERR)
         IF(KERR.GT.0) THEN
            WRITE(KNTN,*)  'ERROR UNPACKING KSEC1(15).'
            RETURN
         END IF
         CALL BUNPCK(NBPW,KBUFF,KSEC1( 8),NWPT,NBPT, 8,KERR)
         IF(KERR.GT.0) THEN
            WRITE(KNTN,*)  'ERROR UNPACKING KSEC1(8).'
            RETURN
         END IF
      END IF
C
C*          1.9  UNPACK YEAR.
C                ------------
 190  CONTINUE
C
      IF(KSEC0(3).EQ.4) THEN
         CALL BUNPCK(NBPW,KBUFF,KSEC1(9),NWPT,NBPT,16,KERR)
         IF(KERR.GT.0) THEN
            WRITE(KNTN,*)  'ERROR UNPACKING KSEC1(9).'
            RETURN
         END IF
      ELSE
         CALL BUNPCK(NBPW,KBUFF,KSEC1(9),NWPT,NBPT, 8,KERR)
         IF(KERR.GT.0) THEN
            WRITE(KNTN,*)  'ERROR UNPACKING KSEC1(9).'
            RETURN
         END IF
      END IF
C
C*          2. UNPACK MONTH.
C              -------------
 200  CONTINUE
C
      CALL BUNPCK(NBPW,KBUFF,KSEC1(10),NWPT,NBPT, 8,KERR)
      IF(KERR.GT.0) THEN
         WRITE(KNTN,*)  'ERROR UNPACKING KSEC1(10).'
         RETURN
      END IF
C
C*          2.1 UNPACK DAY.
C               -----------
 210  CONTINUE
C
      CALL BUNPCK(NBPW,KBUFF,KSEC1(11),NWPT,NBPT, 8,KERR)
      IF(KERR.GT.0) THEN
         WRITE(KNTN,*)  'ERROR UNPACKING KSEC1(11).'
         RETURN
      END IF
C
C*          2.2 UNPACK HOUR.
C               ------------
 220  CONTINUE
C
      CALL BUNPCK(NBPW,KBUFF,KSEC1(12),NWPT,NBPT, 8,KERR)
      IF(KERR.GT.0) THEN
         WRITE(KNTN,*)  'ERROR UNPACKING KSEC1(12).'
         RETURN
      END IF
C
C*          2.3 UNPACK MINUTE.
C               --------------
 230  CONTINUE
C
      CALL BUNPCK(NBPW,KBUFF,KSEC1(13),NWPT,NBPT, 8,KERR)
      IF(KERR.GT.0) THEN
         WRITE(KNTN,*)  'ERROR UNPACKING KSEC1(13).'
         RETURN
      END IF
C
C           2.3.1 UNPACK SECOND
C                 -------------
      IF(KSEC0(3).EQ.4) THEN
         CALL BUNPCK(NBPW,KBUFF,KSEC1(18),NWPT,NBPT, 8,KERR)
         IF(KERR.GT.0) THEN
            WRITE(KNTN,*)  'ERROR UNPACKING KSEC1(13).'
            RETURN
         END IF
C
C                 METADATA
C
C                 YEAR
C
c        CALL BUNPCK(NBPW,KBUFF,KSEC1(19),NWPT,NBPT,16,KERR)
c        IF(KERR.GT.0) THEN
c           WRITE(KNTN,*)  'ERROR UNPACKING KSEC1(19).'
c           RETURN
c        END IF
C
C*             UNPACK MONTH.
C              -------------
C
c        CALL BUNPCK(NBPW,KBUFF,KSEC1(20),NWPT,NBPT, 8,KERR)
c        IF(KERR.GT.0) THEN
c           WRITE(KNTN,*)  'ERROR UNPACKING KSEC1(20).'
c           RETURN
c        END IF
C
C*              UNPACK DAY.
C               -----------
C
c        CALL BUNPCK(NBPW,KBUFF,KSEC1(21),NWPT,NBPT, 8,KERR)
c        IF(KERR.GT.0) THEN
c           WRITE(KNTN,*)  'ERROR UNPACKING KSEC1(21).'
c           RETURN
c        END IF
C
C*              UNPACK HOUR.
C               ------------
C
c        CALL BUNPCK(NBPW,KBUFF,KSEC1(22),NWPT,NBPT, 8,KERR)
c        IF(KERR.GT.0) THEN
c           WRITE(KNTN,*)  'ERROR UNPACKING KSEC1(22).'
c           RETURN
c        END IF
C
C*              UNPACK MINUTE.
C               --------------
C
c        CALL BUNPCK(NBPW,KBUFF,KSEC1(23),NWPT,NBPT, 8,KERR)
c        IF(KERR.GT.0) THEN
c           WRITE(KNTN,*)  'ERROR UNPACKING KSEC1(23).'
c           RETURN
c        END IF
C
C               UNPACK SECOND
C                 -------------
c        CALL BUNPCK(NBPW,KBUFF,KSEC1(24),NWPT,NBPT, 8,KERR)
c        IF(KERR.GT.0) THEN
c           WRITE(KNTN,*)  'ERROR UNPACKING KSEC1(24).'
c           RETURN
c        END IF
C
C                 YEAR
C
c        CALL BUNPCK(NBPW,KBUFF,KSEC1(25),NWPT,NBPT,16,KERR)
c        IF(KERR.GT.0) THEN
c           WRITE(KNTN,*)  'ERROR UNPACKING KSEC1(25).'
c           RETURN
c        END IF
C
C*             UNPACK MONTH.
C              -------------
C
c        CALL BUNPCK(NBPW,KBUFF,KSEC1(26),NWPT,NBPT, 8,KERR)
c        IF(KERR.GT.0) THEN
c           WRITE(KNTN,*)  'ERROR UNPACKING KSEC1(26).'
c           RETURN
c        END IF
C
C*              UNPACK DAY.
C               -----------
C
c        CALL BUNPCK(NBPW,KBUFF,KSEC1(27),NWPT,NBPT, 8,KERR)
c        IF(KERR.GT.0) THEN
c           WRITE(KNTN,*)  'ERROR UNPACKING KSEC1(27).'
c           RETURN
c        END IF
C
C*              UNPACK HOUR.
C               ------------
C
c        CALL BUNPCK(NBPW,KBUFF,KSEC1(28),NWPT,NBPT, 8,KERR)
c        IF(KERR.GT.0) THEN
c           WRITE(KNTN,*)  'ERROR UNPACKING KSEC1(28).'
c           RETURN
c        END IF
C
C*              UNPACK MINUTE.
C               --------------
C
c        CALL BUNPCK(NBPW,KBUFF,KSEC1(29),NWPT,NBPT, 8,KERR)
c        IF(KERR.GT.0) THEN
c           WRITE(KNTN,*)  'ERROR UNPACKING KSEC1(29).'
c           RETURN
c        END IF
C
C               UNPACK SECOND
C                 -------------
c        CALL BUNPCK(NBPW,KBUFF,KSEC1(30),NWPT,NBPT, 8,KERR)
c        IF(KERR.GT.0) THEN
c           WRITE(KNTN,*)  'ERROR UNPACKING KSEC1(30).'
c           RETURN
c        END IF
C
C
C               UNPACK  MOST SOUTHERN LATITUDE
C               ------------------------------
C        CALL BUNPCK(NBPW,KBUFF,ISG,NWPT,NBPT,1,KERR)
C        IF(KERR.GT.0) THEN
C           WRITE(KNTN,*)  'ERROR UNPACKING KSEC1(31).'
C           RETURN
C        END IF
C
c        CALL BUNPCK(NBPW,KBUFF,KSEC1(31),NWPT,NBPT,32,KERR)
c        IF(KERR.GT.0) THEN
c           WRITE(KNTN,*)  'ERROR UNPACKING KSEC1(31).'
c           RETURN
c        END IF

C        IF(ISG.EQ.1)  KSEC1(31)=-KSEC1(31)
C
C               UNPACK  MOST WESTERN LONGITUDE
C               ------------------------------
c        CALL BUNPCK(NBPW,KBUFF,KSEC1(32),NWPT,NBPT,32,KERR)
c        IF(KERR.GT.0) THEN
c           WRITE(KNTN,*)  'ERROR UNPACKING KSEC1(32).'
c           RETURN
c        END IF
C
C               UNPACK  MOST NORTHERN LATITUDE
C               ------------------------------
C        CALL BUNPCK(NBPW,KBUFF,ISG,NWPT,NBPT,1,KERR)
C        IF(KERR.GT.0) THEN
C           WRITE(KNTN,*)  'ERROR UNPACKING KSEC1(33).'
C           RETURN
C        END IF

c        CALL BUNPCK(NBPW,KBUFF,KSEC1(33),NWPT,NBPT,32,KERR)
c        IF(KERR.GT.0) THEN
c           WRITE(KNTN,*)  'ERROR UNPACKING KSEC1(33).'
c           RETURN
c        END IF

C        IF(ISG.EQ.1) KSEC1(33)=-KSEC1(33)
C
C               UNPACK  MOST EASTERN LONGITUDE
C               ------------------------------
c        CALL BUNPCK(NBPW,KBUFF,KSEC1(34),NWPT,NBPT,32,KERR)
c        IF(KERR.GT.0) THEN
c           WRITE(KNTN,*)  'ERROR UNPACKING KSEC1(34).'
c           RETURN
c        END IF
C
      END IF
C
C*          2.4 UNPACK LOCAL ADP CENTRE INFORMATION IF ANY.
C               -------------------------------------------
 240  CONTINUE
C
      IF(KSEC0(3).LT.3) THEN
         IOFF=KSEC1(1)-17
         IW=16
         IBT=0
      ELSEIF(KSEC0(3).EQ.3) THEN
         IOFF=KSEC1(1)-17
         IW=18
         IBT=0
      ELSEIF(KSEC0(3).EQ.4) THEN
C        IOFF=KSEC1(1)-52
         IOFF=KSEC1(1)-22
c        IW=35     ! index for local info
         IW=19     ! index for local info
         IBT=0
      END IF
      IF(IOFF.LE.JSEC1) THEN
         CALL BUNPKS(NBPW,KBUFF,ISEC1(1),NWPT,NBPT,
     1   8,0,IOFF,KERR)
         IF(KERR.GT.0) THEN
          WRITE(KNTN,*)  'ERROR UNPACKING LOCAL ADP CENTRE INFORMATION'
            WRITE(KNTN,*)  'IN SECTION 1.'
            RETURN
         END IF
C
C                PACK LOCAL ADP CENTRE INFORMATION INTO KSE1(16) ONWARD.
C
         CALL BUPKS(NBPW,KSEC1(IW),ISEC1,IW,IBT,8,0,IOFF,KERR)
         IF(KERR.GT.0) THEN
          WRITE(KNTN,*)  'ERROR PACKING LOCAL ADP CENTRE INFORMATION'
            RETURN
         END IF
      ELSE
         IOFF=0
         KERR=4
         CALL BUERR(KERR)
         GO TO 300
      END IF
C
C
C*          3.  SET SUPPLEMENTARY INFORMATION.
C               ------------------------------
 300  CONTINUE
C
      KSUP(1)=15+IOFF/4+1
C
C     ------------------------------------------------------------------
C
      RETURN
      END

C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE BUNPCK(KBPW,KSOURC,KDEST,KWPT,KBPT,KSIZE,KERR)
C
C**** *BUNPCK*
C
C
C     PURPOSE.
C     --------
C          PURPOSE OF THIS ROUTINE IS TO UNPACK BIT STRING OF
C     KSIZE BITS, STARTED AT WORD KWPT OF ARRAY KSOURC AFTER
C     SKIPPING KBPT BITS. RESULT IS PUT INTO KDEST. AT THE END
C     POINTERS KWPT AND KBPT ARE ADJUSTED.
C
C**   INTERFACE.
C     ----------
C
C          *CALL* *BUNPCK(KBPW,KSOURC,KDEST,KWPT,KBPT,KSIZE,KERR)*
C
C        INPUT :
C              *KBPW*      - NUMBER OF BITS IN COMPUTER WORD
C              *KSOURC*    - SOURCE (CONTINUOUS BIT STRING OF
C                            ARBITRARY LENGTH)
C              *KWPT*      - WORD POINTER
C              *KBPT*      - BIT POINTER
C              *KSIZE*     - NUMBER OF BITS TO BE EXTRACTED
C        OUTPUT:
C              *KDEST*     - DESTINATION
C              *KERR*      - RETURN ERROR CODE
C
C     METHOD.
C     -------
C
C            NONE.
C
C
C     EXTERNALS.
C     ----------
C
C
C          GBYTE     - UNPACK BIT PATTERN
C
C
C     REFERENCE.
C     ----------
C
C          NONE.
C
C     AUTHOR.
C     -------
C
C          M. DRAGOSAVAC    *ECMWF*       15/01/91.
C
C
C     MODIFICATIONS.
C     --------------
C
C          NONE.
C
C
      IMPLICIT LOGICAL(L,O,G), CHARACTER*8(C,H,Y)
C
      DIMENSION KSOURC(*)
C
C     ------------------------------------------------------------------
C*          1.   EXTRACT BIT PATTERN.
C                --------------------
 100  CONTINUE
C
      IF(KERR.NE.0) RETURN
C
      IF(KSIZE.GT.KBPW) THEN
         KERR=13
         CALL BUERR(KERR)
         RETURN
      END IF
C
      CALL GBYTE(KSOURC(KWPT),KDEST,KBPT,KSIZE)
C
C     ------------------------------------------------------------------
C*          1.1  UPDATE WORD AND BIT POINTERS.
C                -----------------------------
 110  CONTINUE
C
      KBPT = KBPT + KSIZE
C
      IF(KBPT.GE.KBPW) THEN
         KBPT= KBPT -  KBPW
         KWPT= KWPT +1
      END IF
C
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE INXBIT (KGRIB,KLENG,KNSPT,KPARM,KNUM,KBIT,
     C                   KBLEN,HFUNC,KRET)
C
C---->
C**** INXBIT - Insert/extract bits consecutively in/from a given array
C
C     Purpose.
C     --------
C
C           Take rightmost KBLEN bits from KNUM words of KPARM
C           and insert them consecutively in KGRIB, starting at
C           bit after KNSPT or vice versa.
C
C**   Interface.
C     ----------
C
C           CALL INXBIT (KGRIB,KLENG,KNSPT,KPARM,KNUM,KBIT,
C    C                   KBLEN,KRET)
C
C           Integer    K.
C           Real       P.
C           Logical    O.
C           Character  H.
C
C               Input Parameters.
C               -----------------
C
C               KGRIB      - Array containing bitstream.
C               KLENG      - Length (words) of this array.
C               KNSPT      - Bit number after which insertion or
C                            extraction starts.
C               KPARM      - Array from which bits are taken for
C                            insertion in the bitstream or to which
C                            bits are extracted from the bitstream.
C               KBIT       - Number of bits in computer word.
C               KNUM       - Number of bit fields inserted/extracted.
C               KBLEN      - Number of bits per bit field.
C               HFUNC      - Requested function.
C                            'C' to insert bits in bitstream,
C                            'D' to extract bits from bitstream.
C
C               Output Parameters.
C               ------------------
C
C               KNSPT      - Bit number of last bit inserted/extracted.
C
C               KRET       - Return code.
C                            0 , No error encountered.
C                            1 , Insertion/extraction exceeded
C                                array boundary.
C
C     Method.
C     -------
C
C           Word and offset pointer calculated before calling
C           insertion/extraction routines.
C
C     Externals.
C     ----------
C
C           SBYTES
C           GBYTES
C
C     Reference.
C     ----------
C
C           ECLIB documentation on SBYTES and GBYTES.
C
C     Comments.
C     ---------
C
C           VAX version of routine.
C           Routine contains Sections 0 to 3 and Section 9.
C
C     Author.
C     -------
C
C           J. Hennessy      ECMWF      18.06.91
C
C     Modifications.
C     --------------
C
C           J. Hennessy      ECMWF      08.11.91
C           Parameter KMACH removed from list of input parameters.
C
C           J. Hennessy      ECMWF      12.10.92
C           Dimension of IMASK changed from 64 to 65.
C
C     ----------------------------------------------------------------
C----<
C
C
C
C
C
C
C
C
C
C
C*    Section 0 . Definition of variables. Data statements.
C     ----------------------------------------------------------------
C
C*    Prefix conventions for variable names.
C
C     Logical      L (but not LP), global or common.
C                  O, dummy arguments.
C                  G, local variable.
C                  LP, parameter.
C     Character    C, Global or common.
C                  H, dummy arguments.
C                  Y (but not YP), local variables.
C                  YP, parameter.
C     Integer      M and N, global or common.
C                  K, dummy arguments.
C                  I, local variables.
C                  J (but not JP), loop control.
C                  JP, parameter.
C     Real         A to F and Q to X, global or common.
C                  P (but not PP), dummy arguments.
C                  Z, local variables.
C                  PP, parameter.
C
      INTEGER IND
      INTEGER INUM
      INTEGER IOFF
      INTEGER IPR
      INTEGER IWORD
C
      INTEGER KBIT
      INTEGER KBLEN
      INTEGER KGRIB
      INTEGER KLENG
      INTEGER KNSPT
      INTEGER KNUM
      INTEGER KPARM
      INTEGER KRET
C
      INTEGER J901
C
      DIMENSION KGRIB(KLENG)
      DIMENSION KPARM(*)
C
      CHARACTER*1 HFUNC
C
C
C     Debug print switch.
C
      DATA IPR /0/
C
C     ----------------------------------------------------------------
C
C
C
C
C
C
C
C
C
C
C*    Section 1 . Set initial values.
C     ----------------------------------------------------------------
C
  100 CONTINUE
C
      IF (IPR.EQ.1)
     C   THEN
             WRITE (*,*) 'INXBIT : Section 1.'
             WRITE (*,*) '         Input values used -'
             WRITE (*,9009) KLENG
             WRITE (*,9002) KNSPT
             WRITE (*,9004) KBIT
             WRITE (*,9005) HFUNC
         ENDIF
C
      KRET = 0
C
C     ----------------------------------------------------------------
C
C
C
C
C
C
C
C
C
C
C*    Section 2 . Bit insertion/extraction.
C     ----------------------------------------------------------------
C
  200 CONTINUE
C
      IF (IPR.EQ.1) WRITE (*,*) 'INXBIT : Section 2.'
C
C*    Calculate word pointer and offset.
C
      IWORD = KNSPT / KBIT
      IOFF  = KNSPT - IWORD * KBIT
      IWORD = IWORD + 1
      IF (IPR.EQ.1) WRITE (*,9003) IWORD , IOFF
C
C     Insert/extract bits.
C
      IF (HFUNC.EQ.'C')
     C   THEN
             CALL SBYTES (KGRIB(IWORD),KPARM,IOFF,KBLEN,0,KNUM)
         ELSE
             CALL GBYTES (KGRIB(IWORD),KPARM,IOFF,KBLEN,0,KNUM)
         ENDIF
C
C     Update pointer.
C
      KNSPT = KNSPT + KBLEN * KNUM
C
C     ----------------------------------------------------------------
C
C
C
C
C
C
C
C
C
C
C*    Section 3 . Check out of range.
C    -----------------------------------------------------------------
C
  300 CONTINUE
C
      IF (IPR.EQ.1) WRITE (*,*) 'INXBIT : Section 3.'
C
      IND = KNSPT / KBIT
      IF (IND.GT.KLENG)
     C   THEN
             KRET = 1
             WRITE (*,9001) IND , KLENG
         ENDIF
C
C     ----------------------------------------------------------------
C
C
C
C
C
C
C
C
C
C
C*    Section 9 . Return to calling routine. Format statements.
C     ----------------------------------------------------------------
C
  900 CONTINUE
C
      IF (IPR.EQ.1)
     C   THEN
             INUM = KNUM
             IF (INUM.GT.360)
     C          THEN
                    INUM = 360
                    WRITE (*,9007) INUM
                ENDIF
             DO 901 J901=1,INUM
               IF (HFUNC.EQ.'C')
     C             THEN
                       WRITE (*,9006) KPARM(J901)
                   ELSE
                       WRITE (*,9008) KPARM(J901)
                   ENDIF
  901        CONTINUE
             WRITE (*,*) 'INXBIT : Section 9.'
             WRITE (*,*) '         Output values set -'
             WRITE (*,9002) KNSPT
         ENDIF
C
C
 9001 FORMAT (1H ,'INXBIT : Word ',I8,' is outside array bounds ',I8)
C
 9002 FORMAT (1H ,'         KNSPT  = ',I8)
C
 9003 FORMAT (1H ,'INXBIT : Word is',I8,', bit offset is ',I2)
C
 9004 FORMAT (1H ,'         KBIT   = ',I8)
C
 9005 FORMAT (1H ,'         HFUNC  = ',A)
C
 9006 FORMAT (1H ,'         Inserted value = ',I20)
C
 9007 FORMAT (1H ,'         First ',I9,' values.')
C
 9008 FORMAT (1H ,'         Extracted value = ',I20)
C
 9009 FORMAT (1H ,'         KLENG  = ',I20)
C
      RETURN
C
      END
      SUBROUTINE ABORTX (HNAME)
C
C**** ABORTX - Terminates execution of program.
C
C     Purpose.
C     --------
C
C           Terminates execution of program.
C
C**   Interface.
C     ----------
C
C           CALL ABORTX (HNAME)
C
C           Integer    K.
C           Real       P.
C           Logical    O.
C           Character  H.
C
C               Input Parameters.
C               -----------------
C
C               HNAME      - Name of calling routine.
C
C               Output Parameters.
C               ------------------
C
C               None.
C
C     Method.
C     -------
C
C           Prints message and terminates.
C
C     Externals.
C     ----------
C
C           EXIT
C
C     Reference.
C     ----------
C
C           None.
C
C     Comments.
C     ---------
C
C           VAX version of routine.
C           Routine contains Sections 0 to 1 and Section 9.
C
C     Author.
C     -------
C
C           J. Hennessy      ECMWF      13.11.91
C
C     Modifications.
C     --------------
C
C           None.
C
C     ------------------------------------------------------------------
C
C
C
C
C
C
C
C
C
C
C*    Section 0 . Definition of variables.
C     ------------------------------------------------------------------
C
C*    Prefix conventions for variable names.
C
C     Logical      L (but not LP), global or common.
C                  O, dummy arguments.
C                  G, local variable.
C                  LP, parameter.
C     Character    C, Global or common.
C                  H, dummy arguments.
C                  Y (but not YP), local variables.
C                  YP, parameter.
C     Integer      M and N, global or common.
C                  K, dummy arguments.
C                  I, local variables.
C                  J (but not JP), loop control.
C                  JP, parameter.
C     Real         A to F and Q to X, global or common.
C                  P (but not PP), dummy arguments.
C                  Z, local variables.
C                  PP, parameter.
C
C
      CHARACTER*(*) HNAME
C
C     ------------------------------------------------------------------
C
C
C
C
C
C
C
C
C
C
C*    Section 1 . Print message and terminate.
C     ------------------------------------------------------------------
C
  100 CONTINUE
C
      WRITE (*,9001) HNAME
C
      CALL EXIT (-1)
C
C     ------------------------------------------------------------------
C
C
C
C
C
C
C
C
C
C*    Section 9 . Format statements.
C     ------------------------------------------------------------------
C
  900 CONTINUE
C
 9001 FORMAT (1H ,'ABORTX : Routine ',A,' has requested program',
     C               ' termination.')
C
      RETURN
C
      END
      SUBROUTINE SETPAR (KBIT,KNEG,KPR)
C
C**** SETPAR - Set number of bits in word. Set maximum negative integer.
C
C     Purpose.
C     --------
C
C           Set number of bits in word. Set maximum negative integer.
C
C**   Interface.
C     ----------
C
C           CALL SETPAR (KBIT,KNEG,KPR)
C
C           Integer    K.
C           Real       P.
C           Logical    O.
C           Character  H.
C
C               Input Parameters.
C               -----------------
C
C               KPR        - Debug print switch.
C                            1 , print out.
C                            0 , No print out.
C
C               Output Parameters.
C               ------------------
C
C               KBIT       - Number of bits in computer word.
C
C               KNEG       - Maximum negative integer.
C
C     Method.
C     -------
C
C           Values are assigned.
C
C     Externals.
C     ----------
C
C           None.
C
C     Reference.
C     ----------
C
C           None.
C
C     Comments.
C     ---------
C
C           VAX version of routine.
C           Routine contains Sections 0 to 3 and Section 9.
C
C     Author.
C     -------
C
C           J. Hennessy      ECMWF      28.10.91
C
C     Modifications.
C     --------------
C
C           None.
C
C     ------------------------------------------------------------------
C
C
C
C
C
C
C
C
C
C
C*    Section 0 . Definition of variables. Data statements.
C     ------------------------------------------------------------------
C
C*    Prefix conventions for variable names.
C
C     Logical      L (but not LP), global or common.
C                  O, dummy arguments.
C                  G, local variable.
C                  LP, parameter.
C     Character    C, Global or common.
C                  H, dummy arguments.
C                  Y (but not YP), local variables.
C                  YP, parameter.
C     Integer      M and N, global or common.
C                  K, dummy arguments.
C                  I, local variables.
C                  J (but not JP), loop control.
C                  JP, parameter.
C     Real         A to F and Q to X, global or common.
C                  P (but not PP), dummy arguments.
C                  Z, local variables.
C                  PP, parameter.
C
C
      INTEGER KBIT
      INTEGER KNEG
      INTEGER KPR
C
C     ------------------------------------------------------------------
C
C
C
C
C
C
C
C
C
C
C*    Section 1 . Assign values.
C     ------------------------------------------------------------------
C
  100 CONTINUE
C
      IF (KPR.EQ.1)  WRITE (*,*) ' SETPAR : Section 1.'
C
      KBIT = 32
      KNEG = -2147483648
C
C     ------------------------------------------------------------------
C
C
C
C
C
C
C
C
C
C*    Section 9 . Return to calling routine. Format statements.
C     ------------------------------------------------------------------
C
  900 CONTINUE
C
      IF (KPR.EQ.1)
     C   THEN
             WRITE (*,*) ' SETPAR : Section 9.'
             WRITE (*,*) '          Output values set -'
             WRITE (*,9001) KBIT
             WRITE (*,9002) KNEG
         ENDIF
C
 9001 FORMAT (1H ,'          KBIT = ',I3)
C
 9002 FORMAT (1H ,'          KNEG = ',I22)
C
      RETURN
C
      END
      SUBROUTINE GBITS(NPACK,ISAM,IBIT,NBITS,NSKIP,ITER)
C
C**** GBITS - VAX routine.
C
      DIMENSION NPACK(*),ISAM(*)
      PARAMETER (LENWRD=32)
C
C     ++++++++++
C     CALL GBITS(NPACK,ISAM,IBIT,NBITS,NSKIP,ITER)
C     ++++++++++
C
C     STARTS UNPACKING BITS AT BIT OFFSET IBIT IN ARRAY
C     NPACK.  IT TAKES NBITS AND STORES THEM IN THE LONGWORD
C     ARRAY STARTING AT ISAM.  THEN NSKIP BITS ARE SKIPPED IN
C     NPACK AND THE NEXT FIELD OF NBITS IS UNPACKED INTO THE
C     NEXT ISAM.  THIS IS DONE A TOTAL OF ITER TIMES.
C
C     THIS ROUTINE EXTRACTS BITS FROM VAX WORDS.
C     IT IS SIMILAR TO NCAR'S GBYTE BUT IT WORKS WITH
C     THE NATURAL UNDERLYING STRUCTURE OF THE VAX.
C     ----------
C
      ISW = 1
      GO TO 8
C
C
      ENTRY SBITS(NPACK,ISAM,IBIT,NBITS,NSKIP,ITER)
C
C     ++++++++++
C     CALL SBITS(NPACK,ISAM,IBIT,NBITS,NSKIP,ITER)
C     ++++++++++
C
C     THIS ROUTINE TAKES THE FIRST LONGWORD LOCATED AT
C     ISAM AND STORES IT INTO THE NBITS OF NPACK STARTING AT
C     BIT OFFSET IBIT.  THEN NSKIP BITS ARE SKIPPED IN
C     NPACK AND THE PROCESS IS REPEATED A TOTAL OF ITER TIMES.
C
C     THIS ROUTINE EXTRACTS BITS FROM VAX WORDS.
C     IT IS SIMILAR TO NCAR'S SBYTE BUT IT WORKS WITH
C     THE NATURAL UNDERLYING STRUCTURE OF THE VAX.
C     ----------
      ISW = 2
      GO TO 8
C
C     ++++++++++
      ENTRY G_BYTES(NPACK,ISAM,IBIT,NBITS,NSKIP,ITER)
C     ++++++++++
C
C     CALL G_BYTES(NPACK,ISAM,IBIT,NBITS,NSKIP,ITER)
C     STARTS UNPACKING BITS AT BIT OFFSET IBIT IN ARRAY
C     NPACK.  IT TAKES NBITS AND STORES THEM IN THE LONGWORD
C     ARRAY STARTING AT ISAM.  THEN NSKIP BITS ARE SKIPPED IN
C     NPACK AND THE NEXT FIELD OF NBITS IS UNPACKED INTO THE
C     NEXT ISAM.  THIS IS DONE A TOTAL OF ITER TIMES.
C
C     THIS ROUTINE DEALS WITH BITS AND BYTES IN THE ORDER
C     THEY ARE NUMBERED ON THE MESA (IE BIGENDIAN).
C     ----------
      ISW = 3
      GO TO 8
C
C     ++++++++++
      ENTRY S_BYTES(NPACK,ISAM,IBIT,NBITS,NSKIP,ITER)
C     ++++++++++
C
C     CALL S_BYTES(NPACK,ISAM,IBIT,NBITS,NSKIP,ITER)
C     THIS ROUTINE TAKES THE FIRST LONGWORD LOCATED AT
C     ISAM AND STORES IT INTO THE NBITS OF NPACK STARTING AT
C     BIT OFFSET IBIT.  THEN NSKIP BITS ARE SKIPPED IN
C     NPACK AND THE PROCESS IS REPEATED A TOTAL OF ITER TIMES.
C
C
C     THIS ROUTINE DEALS WITH BITS AND BYTES IN THE ORDER
C     THEY ARE NUMBERED ON THE MESA (IE BIGENDIAN).
C     ----------
      ISW = 4
      GOTO 8
C
C     ++++++++++
      ENTRY GBYTES(NPACK,ISAM,IBIT,NBITS,NSKIP,ITER)
C     ++++++++++
C
C        THIS ROUTINE IS JUST A REPEATED CALL TO G_BYTE
C        WHERE SUCCESSIVE CALLS SKIP NSKIP BITS
C        AND THE LOOP COUNT IS ITER
      ISW = 5
      GOTO 8
C
C     ++++++++++
      ENTRY SBYTES(NPACK,ISAM,IBIT,NBITS,NSKIP,ITER)
C     ++++++++++
C
C        THIS ROUTINE IS JUST A REPEATED CALL TO S_BYTE
C        WHERE SUCCESSIVE CALLS SKIP NSKIP BITS
C        AND THE LOOP COUNT IS ITER
      ISW = 6
      GO TO 8
C
C     ++++++++++
      ENTRY GBILS(NPACK,ISAM,IBIT,NBITS,NSKIP,ITER)
C     ++++++++++
C
C     GBIL(S)/SBIL(S) ENTRIES ALLOW DIRECT MAINTENANCE OF LEFT TO RIGHT
C     BIT STRINGS IN DEC ENVIRONMENT (VAX). THE MODIFICATION RETAINS FUL
C     COMPATIBILITY WITH ORIGINAL ENTRIES, HOWEVER, VERIFICATION BEYOND
C     GBIL(S)/SBIL(S) WAS VIA GBITS/SBITS ONLY (NOT GBYTES/SBYTES).
C
C     MODIFICATION PROGRAMMED BY A.D.STROUD, COMPASS SYSTEMS, INC.
C     NOVEMBER 1987 UNDER TOGA GRAND FUNDING DURING SOFTWARE DEVELOPMENT
C     FOR WMO PROPOSED STANDARD FM 94 BUFR ON THE VAX STATION II AT THE
C     OAG/NOS/NOAA, MONTEREY, CA.
C
C     FOR GBIL(S)/SBIL(S) THE FOLLOWING PARAMETER USAGE APPLIES
C
C     NPACK   - LEFT MOST(HIGHEST INDEXED) LONGWORD IN PACKED BIT STRING
C               ARRAY SPACE INFERRED BY IBIT(IN LIEU OF LOWEST INDEX FOR
C               NON-DEC, NOTE - SECOND 32 BIT SUBSTRING IN BIT STRING IS
C               NPACK(0), THIRD 32 BIT SUBSTRING IS NPACK(-1), ETC.,...)
C
C     ISAM    - ARRAY HOLDING/TO HOLD UNPACKED ELEMENT(S) (RJZF) FOR
C               SBIL(S)/GBIL(S), RESPECTIVELY.
C
C     IBIT    - INITIAL LEFT TO RIGHT BIT SKIP WITHIN THE NPACK BIT STRI
C               (INCLUDING LEFTMOST BIT OF NPACK, INTERPRET BIT SKIP THE
C                SAME AS IN NON-DEC ENVIRONMENT)
C
C     NBITS   - FIXED BIT WIDTH OF EACH ELEMENT TO BE UNPACKED.
C
C     NSKIP   - FIXED LEFT TO RIGHT BIT SKIP WIDTH BETWEEN ELEMENTS.
C
C     ITER    - NUMBER OF ELEMENTS TO UNPACK(IMPLIED MINIMUM DIMENSIONAL
C               OF ISAM ARRAY).
C
C     !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
C
C     EXAMPLE
C
C  1) PARAMETER (N4=1000 , NB=4000, NL=1000)
C  2) INTEGER I4(N4),UNPACK(99)
C  3) BYTE IB(NB)
C  4) EQUIVALENCE (I4(1),IB(1))
C
C  5) READ(LUI,'(4000A1)') (IB(I),I=NB,1,-1)
C                FORMATTED READ OF ARBITRARY BITSTRING FROM NON-DEC
C                SITE, OR FROM DEC FILE AS WRITTEN AT 9) BELOW.
C
C  6) CALL GBILS(I4(NL),UNPK,67,22,47,95)
C                AFTER INITIALLY SKIPPING 67 BITS TO A POINT BEYOND THE
C                LEFTMOST THREE BITS OF I4(NL-2), GBILS ACQUIRES 95
C                SUBSTRING ELEMENTS OF THE WIDTH 22 BITS(EACH RIGHT JUST
C                WITH HIGH ORDER ZERO FILL) INTO THE RESPECTIVE FIRST
C                95 ARRAY ELEMENTS OF UNPK. SEPARATED BY 47 BITS IN SOUR
C                BITSTRING ARRAY I4, THE EXTRACTED DUPLICATE SUBSTRING
C                ELEMENTS ARE NOW EFFECTIVELY SEPARATED FROM EACH OTHER
C                BY 10 ZERO BITS IN OBJECT BITSTRING ARRAY UNPK.
C
C 7) UNPK(J)=... (J=1,95)
C
C 8) CALL SBILS(I4(NL),UNPK,67,22,47,95)
C                AFTER INITIALLY SKIPPING 67 BITS TO A POINT BEYOND THE
C                LEFTMOST THREE BITS OF I4(NL-2), SBILS STORES IN SUCCES
C                SIVE BITS THE FIRST OF 95 MODIFIED UNPK RIGHTMOST 22 BI
C                WIDTH SUBSTRING ELEMENTS. AFTER SKIPPING 47 BITS BEYOND
C                THE RIGHTMOST OF THE FIRST 22 BITS STORED, THE SECOND 2
C                BIT ELEMENT IS STORED, ETC. THE ORIGINAL SUBSTRING
C                ELEMENTS HAVE BEEN REPLACED BY MODIFIED SUBSRING ELEMEN
C                IN SITU WITHIN THE BITSTRING ARRAY I4 WITHOUT MODIFYING
C                ANY OTHER BITS.
C
C 9) WRITE(LUO,'(4000A1)') (IB(I),I=NB,1,-1)
C                FILE FOR NON-DEC OR FOR READ 5) ABOVE.
C
C
C
      ISW = 7
      GO TO 6
C
C     ++++++++++
      ENTRY SBILS(NPACK,ISAM,IBIT,NBITS,NSKIP,ITER)
C     ++++++++++
C
C
      ISW = 8
      GO TO 6
C
C     ++++++++++
      ENTRY GBIL(NPACK,ISAM,IBIT,NBITS)
C     ++++++++++
C
      ISW = 9
      GO TO 5
C
C     ++++++++++
      ENTRY SBIL(NPACK,ISAM,IBIT,NBITS)
C     ++++++++++
C
      ISW=10
 5    ITER1= 1
      NSKIP1=-NBITS
      GO TO 7
C
 6    NSKIP1=-NSKIP-NBITS
C
 7    JOFF=-IBIT-NBITS
      IF(ISW.LT.9) GO TO 9
      GO TO 10
C
 8    NSKIP1=NSKIP+NBITS
      JOFF=IBIT
C
 9    ITER1=ITER
C
C
 10   DO 30 I = 1 , ITER1
C
         IF(JOFF.GT.0) IBASE=JOFF/LENWRD+1
         IF(JOFF.LE.0) IBASE=(JOFF+1)/LENWRD+1
         IOFF=MOD(JOFF,LENWRD)
         IF(JOFF.LE.0) IOFF=MOD(IOFF+LENWRD,LENWRD)
C
         GO TO(11,12,13,14,15,16,11,12,11,12) ISW
C
11       CALL GBIT(NPACK(IBASE),ISAM(I),IOFF,NBITS)
         GO TO 20
12       CALL SBIT(NPACK(IBASE),ISAM(I),IOFF,NBITS)
         GO TO 20
13       CALL G_BYTe(NPACK(IBASE),ISAM(I),IOFF,NBITS)
         GO TO 20
14       CALL S_BYTE(NPACK(IBASE),ISAM(I),IOFF,NBITS)
         GO TO 20
15       CALL GBYTE(NPACK(IBASE),ISAM(I),IOFF,NBITS)
         GOTO 20
16       CALL SBYTE(NPACK(IBASE),ISAM(I),IOFF,NBITS)
         GOTO 20
20       JOFF = JOFF + NSKIP1
30    CONTINUE
      RETURN
      END
      SUBROUTINE GBYTE(NPACK,ISAM,IBIT,NBITS)
C
C**** GBYTE - VAX routine.
C
C     ++++++++++
C     CALL GBYTE(NPACK,ISAM,IBIT,NBITS)
C     STARTS UNPACKING BITS AT BIT OFFSET IBIT IN ARRAY
C     NPACK.  IT TAKES NBITS AND STORES THEM IN THE LONGWORD
C     ARRAY STARTING AT ISAM.
C
C     THIS ROUTINE DEALS WITH BITS AND BYTES IN THE ORDER
C     THEY ARE NUMBERED ON THE MESA (IE BIGENDIAN).
C     ----------
C
C     GBYTE AND SBYTE ARE SPECIAL ROUTINES TO DO THE SAME
C     THINGS AS THEIR COUNTERPARTS ON THE MESA.
C     THEY DIFFER FROM THE BITS ROUTINES IN THAT BITS
C     ARE COUNTED FROM THE TOP OF THE WORD RATHER THAN
C     THE BOTTOM.  THIS MEANS THAT THE BITS THEY SPECIFY JUMP AROUND
C     WHEN CROSSING BYTE BOUNDARIES.  THERE IS NO ASSUMPTION
C     MADE ABOUT THE WORDSIZE OF THE MACHINE THEY WERE WRITTEN
C     ON.  HOWEVER THE MAXIMUM NUMBER OF BITS EXTRACTED MUST BE
C     LESS THAN OR EQUAL TO 32.
C
      BYTE NPACK(8)
      INTEGER T
      EXTERNAL SS$_ABORT
      IDBIT(I) = 7 - MOD(I,8)
      ISW = 3
      ISAM = 0
      GO TO 10
      ENTRY SBYTE(NPACK,ISAM,IBIT,NBITS)
C     ++++++++++
C     CALL SBYTE(NPACK,ISAM,IBIT,NBITS)
C     THIS ROUTINE TAKES THE FIRST LONGWORD LOCATED AT
C     ISAM AND STORES IT INTO THE NBITS OF NPACK STARTING AT
C     BIT OFFSET IBIT.
C
C
C     THIS ROUTINE DEALS WITH BITS AND BYTES IN THE ORDER
C     THEY ARE NUMBERED ON THE MESA (IE BIGENDIAN).
C     ----------
      ISW = 4
10    IBASE = IBIT/8
C     IBASE POINTS TO THE FIRST BYTE INVOLVED
      IOFF = IBIT - 8*IBASE
C     IOFF IS THE BIT OFFSET WITHIN FIRST BYTE
      M = (IOFF+NBITS-1)/8 + 1
C     M IS THE NUMBER OF BYTES (INCLUDING PARTIALS) INVOLVED
C     IF(M.GT.5)THEN
      IF(NBITS.GT.32)THEN
         TYPE *,'ILLEGAL VALUE FOR NBITS IN S/GBYTE(S) CALL'
         CALL SYS$EXIT(SS$_ABORT)
      END IF
      NN = 0
C     NN IS THE NUMBER OF BITS TRANSFERRED
      DO 20 I = M , 1 , -1
C     LOOP ON BYTES
         IS = IDBIT(0)
C        CALC FIRST BIT WITHIN BYTE
         IE = IDBIT(7)
C        CALC LAST BIT WITHIN BYTE
         IF(I.EQ.1)IS = IDBIT(IOFF)
C        FIRST BIT VARIES FOR FIRST BYTE
         IF(I.EQ.M)IE = IDBIT(IOFF+NBITS-1)
C        LAST BIT VARIES FOR LAST BYTE
         N = IS - IE + 1
C        CALC NUMBER OF BITS WITHIN BYTE TO XFER
         IF(ISW.EQ.4)GO TO 12
         CALL GBIT(NPACK(IBASE+I),T,IE,N)
C        EXTRACT BITS FROM SOURCE
         CALL SBIT(ISAM,T,NN,N)
C        AND LOAD INTO DESTINATION
         GO TO 15
12       CALL GBIT(ISAM,T,NN,N)
C        EXTRACT BITS FROM SOURCE
         CALL SBIT(NPACK(IBASE+I),T,IE,N)
C        AND LOAD INTO DESTINATION
15       NN = NN + N
C        UPDATE BITS XFERRED
20    CONTINUE
      RETURN
      END
      SUBROUTINE G_BYTE(NPACK,ISAM,IBIT,NBITS)
C
C**** G_BYTE - VAX routine.
C
C     G_BYTE AND S_BYTE ARE SPECIAL ROUTINES TO DO THE SAME
C     THINGS AS THEIR COUNTERPARTS ON THE MESA.
C     THEY DIFFER FROM THE BITS ROUTINES IN THAT BITS
C     ARE COUNTED FROM THE TOP OF THE WORD RATHER THAN
C     THE BOTTOM.  THIS MEANS THAT THE BITS THEY SPECIFY JUMP AROUND
C     WHEN CROSSING BYTE BOUNDARIES.  THERE IS NO ASSUMPTION
C     MADE ABOUT THE WORDSIZE OF THE MACHINE THEY WERE WRITTEN
C     ON.  HOWEVER THE MAXIMUM NUMBER OF BITS EXTRACTED MUST BE
C     LESS THAN OR EQUAL TO 32.
C
      BYTE NPACK(8)
      INTEGER T
      EXTERNAL SS$_ABORT
      IDBIT(I) = 7 - MOD(I,8)
      ISW = 3
      ISAM = 0
      GO TO 10
      ENTRY S_BYTE(NPACK,ISAM,IBIT,NBITS)
      ISW = 4
10    IBASE = IBIT/8
C     IBASE POINTS TO THE FIRST BYTE INVOLVED
      IOFF = IBIT - 8*IBASE
C     IOFF IS THE BIT OFFSET WITHIN FIRST BYTE
      M = (IOFF+NBITS-1)/8 + 1
C     M IS THE NUMBER OF BYTES (INCLUDING PARTIALS) INVOLVED
C     IF(M.GT.5)THEN
      IF(NBITS.GT.32)THEN
         TYPE *,'ILLEGAL VALUE FOR NBITS IN S/G_BYTE(S) CALL'
         CALL SYS$EXIT(SS$_ABORT)
      END IF
      NN = 0
C     NN IS THE NUMBER OF BITS TRANSFERRED
      DO 20 I = M , 1 , -1
C     LOOP ON BYTES
         IBB = IBASE + I - 1
         IBC = IBB/4
         IBD = 4*IBC+3-MOD(IBB,4) + 1
C        CALCULATE UNSHIFTED BYTE
         IS = IDBIT(0)
C        CALC FIRST BIT WITHIN BYTE
         IE = IDBIT(7)
C        CALC LAST BIT WITHIN BYTE
         IF(I.EQ.1)IS = IDBIT(IOFF)
C        FIRST BIT VARIES FOR FIRST BYTE
         IF(I.EQ.M)IE = IDBIT(IOFF+NBITS-1)
C        LAST BIT VARIES FOR LAST BYTE
         N = IS - IE + 1
C        CALC NUMBER OF BITS WITHIN BYTE TO XFER
         IF(ISW.EQ.4)GO TO 12
C        CALL GBIT(NPACK(IBASE+I),T,IE,N)
         CALL GBIT(NPACK(IBD),T,IE,N)
C        EXTRACT BITS FROM SOURCE
         CALL SBIT(ISAM,T,NN,N)
C        AND LOAD INTO DESTINATION
         GO TO 15
12       CALL GBIT(ISAM,T,NN,N)
C        EXTRACT BITS FROM SOURCE
C        CALL SBIT(NPACK(IBASE+I),T,IE,N)
         CALL SBIT(NPACK(IBD),T,IE,N)
C        AND LOAD INTO DESTINATION
15       NN = NN + N
C        UPDATE BITS XFERRED
20    CONTINUE
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      INTEGER FUNCTION IGPREC (PIFELD, KIWE, KINS, POFELD, KOWE, KONS,
     1   KWEIND, KNSIND, PWFACT, PMAX, PINPNT, KPR, KERR)
C
C---->
C**** *IGPREC*
C
C     PURPOSE
C     _______
C
C     Perform additional interpolation processes for precipitation
C     fields.
C
C     INTERFACE
C     _________
C
C     IERR = IGPREC (PIFELD, KIWE, KINS, POFELD, KOWE, KONS, KWEIND,
C    1   KNSIND, PWFACT, PMAX, PINPNT, KPR, KERR)
C
C     Input parameters
C     ________________
C
C     PIFELD     - The input field provided by the calling routine.
C
C     KIWE       - The number of points in the West-East direction in
C                  the input field.
C
C     KINS       - The number of points in the North-South direction
C                  in the input field.
C
C     POFELD     - The output field as previously calculated.
C
C     KOWE       - The number of points in the West-East direction in
C                  the output field.
C
C     KONS       - The number of points in the North-South direction
C                  in the output field.
C
C     KWEIND     - This array contains the array offsets of the West
C                  and East points in the input array required for
C                  interpolation.
C
C     KNSIND     - This array contains the array offsets of the North
C                  and South points in the input array required for
C                  interpolation.
C
C     PWFACT     - The array of interpolating weights to the four
C                  neighbouring points for every output point.
C
C     PMAX       - Work array used to aid vectorisation.
C
C     PINPNT     - Work array used to aid vectorisation.
C
C     KPR        - The debug print switch.
C                  0  , No debugging output.
C                  1  , Produce debugging output.
C
C     KERR       - The error control flag.
C                  -ve, No error message. Return error code.
C                  0  , Hard failure with error message.
C                  +ve, Print error message. Return error code.
C
C     Output parameters
C     ________________
C
C     POFELD     - The output field as modified to allow for
C                  precipitation.
C
C     Return value
C     ____________
C
C     The error indicator (INTEGER).
C
C     Error and Warning Return Values
C     _______________________________
C
C     None
C
C     Common block usage
C     __________________
C
C     None
C
C     EXTERNALS
C     _________
C
C     INTLOG(R)  - Logs messages.
C     CHKPREC - Check if precipitation threshold has been redefined
C
C
C     METHOD
C     ______
C
C     The precipitation at a point is set to zero in the following
C     circumstances.
C
C     1  The interpolated precipitation is less than a threshold value.
C
C     2  There is no precipitation at the neighbouring point with the
C        highest interpolating weight.
C
C     NOTE that this operation is performed before the special
C     routines for the poles when interpolating from Gaussian grids
C     to global latitude/longitude fields. The polar values for
C     precipitation, during such interpolations, will always be the
C     average value of the nearest Gaussian line with no threshold
C     check.
C
C     REFERENCE
C     _________
C
C     None
C
C     COMMENTS
C     ________
C
C     Program contains sections 0 to 3 and 9
C
C     AUTHOR
C     ______
C
C     K. Fielding      *ECMWF*      Oct 1993
C
C     MODIFICATIONS
C     _____________
C
C     None
C
C----<
C     _______________________________________________________
C
C
C*    Section 0. Definition of variables.
C     _______________________________________________________
C
C*    Prefix conventions for variable names
C
C     Logical      L (but not LP), global or common.
C                  O, dummy argument
C                  G, local variable
C                  LP, parameter.
C     Character    C, global or common.
C                  H, dummy argument
C                  Y (but not YP), local variable
C                  YP, parameter.
C     Integer      M and N, global or common.
C                  K, dummy argument
C                  I, local variable
C                  J (but not JP), loop control
C                  JP, parameter.
C     REAL         A to F and Q to X, global or common.
C                  P (but not PP), dummy argument
C                  Z, local variable
C                  PP, parameter.
C
C     Implicit statement to force declarations
C
      IMPLICIT NONE
C
#include "parim.h"
#include "nifld.common"
C
C     Dummy arguments
      INTEGER KIWE, KOWE, KINS, KONS, KPR, KERR
      INTEGER KWEIND (2, KOWE), KNSIND (2, KONS)
      REAL PIFELD (KIWE, KINS), POFELD (KOWE, KONS)
      REAL PWFACT (4, KOWE, KONS)
      REAL PMAX (KOWE), PINPNT (KOWE)
C
C     Local variables
      LOGICAL LAT_RAIN
      INTEGER ILAT, IDIR
      INTEGER JOLAT, JOLON, JNS, JWE
      INTEGER JPROUTINE
      PARAMETER (JPROUTINE = 22500)
C
C     _______________________________________________________
C
C*    Section 1. Initialisation
C     _______________________________________________________
C
  100 CONTINUE
C
      IF (KPR.GE.1) CALL INTLOG(JP_DEBUG,'IGPREC: Section 1.',JPQUIET)
C
      IGPREC = 0
C
      IF (KPR .GE. 1) THEN
        CALL INTLOG(JP_ERROR,'IGPREC: Input parameters.',JPQUIET)
        CALL INTLOG(JP_ERROR,'IGPREC: No.input fld longitudes = ',KIWE)
        CALL INTLOG(JP_ERROR,'IGPREC: No.input fld latitudes = ',KINS)
        CALL INTLOG(JP_ERROR,'IGPREC: No.output fld longitudes = ',KOWE)
        CALL INTLOG(JP_ERROR,'IGPREC: No.output fld latitudes = ',KONS)
      ENDIF
C
C     _______________________________________________________
C
C*    Section 2. eliminate output precipitation based on
C                interpolation threshhold
C     _______________________________________________________
C
  200 CONTINUE
C
      IF (KPR.GE.1) CALL INTLOG(JP_DEBUG,'IGPREC: Section 2.',JPQUIET)
C
      CALL CHKPREC()
C
      DO 360 JOLAT = 1, KONS
C
        LAT_RAIN = .FALSE.
C
        DO 210 JOLON = 1, KOWE
C
          IF (POFELD (JOLON, JOLAT) .LT. ZPRECIP) THEN
            POFELD (JOLON, JOLAT) = PPZERO
          ELSE
            LAT_RAIN = .TRUE.
          ENDIF
C
  210   CONTINUE
C
C     _______________________________________________________
C
C*    Section 3. eliminate output precipitation based on
C                "nearest" point.
C
C                Do not bother if there is no precipitation on this
C                line of latitude
C     _______________________________________________________
C
  300   CONTINUE
C
        IF ((KPR.GE.1).AND.(JOLAT.EQ.1)) CALL INTLOG(JP_DEBUG,
     X    'IGPREC: Section 3.',JPQUIET)
C
        IF (LAT_RAIN) THEN
C
          DO 310 JOLON = 1, KOWE
C
            PMAX (JOLON) = PPZERO
C
  310     CONTINUE
C
          DO 340 JNS = 1, 2
C
            ILAT = KNSIND (JNS, JOLAT)
C
            DO 330 JWE = 1, 2
C
              IDIR = (JNS - 1) * 2 + JWE
C
              DO 320 JOLON = 1, KOWE
C
                IF (PWFACT(IDIR, JOLON, JOLAT) .GT.  PMAX(JOLON)) THEN
                  PMAX (JOLON) = PWFACT (IDIR, JOLON, JOLAT)
                  PINPNT (JOLON) = PIFELD (KWEIND (JWE, JOLON), ILAT)
                ENDIF
C
  320         CONTINUE
C
  330       CONTINUE
C
  340     CONTINUE
C
          DO 350 JOLON = 1, KOWE
            IF (PINPNT(JOLON).LT.ZPRECIP) POFELD(JOLON,JOLAT) = PPZERO
  350     CONTINUE
C
        ENDIF
C
  360 CONTINUE
C
C     _______________________________________________________
C
C*    Section 9. Return to calling routine. Format statements
C     _______________________________________________________
C
  900 CONTINUE
C
      IF (KPR.GE.1) CALL INTLOG(JP_DEBUG,'IGPREC: Section 9.',JPQUIET)
C
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE CREXPRCO(KBUFL,YBUFF,KJ,KDD,KSTACK,KELEM,KERR)
C
C**** *CREXPRCO*
C
C
C     PURPOSE.
C     --------
C
C          Process CREX operator.
C
C**   INTERFACE.
C     ----------
C
C          *CALL* *CREXPRCO(KBUFL,YBUFF,KJ,KDD,KSTACK,KELEM,KERR)*
C
C        INPUT :
C               *KBUFL*   -  length of CREX message (words)
C               *YBUFF*   -  array containing CREX message
C               *KJ*      -  pointer to array kstack
C               *KDD*     -  data descriptor
C               *KELEM*   -  dimension of CNAMES, CUNITS array
C        OUTPUT:
C               *KSTACK*  - list of descriptors
C               *KERR*    - return error code
C
C     *METHOD.
C      -------
C
C          NONE.
C
C
C     EXTERNALS.
C     ----------
C
C
C     REFERENCE.
C     ----------
C
C          NONE.
C
C     AUTHOR.
C     -------
C
C          MILAN DRAGOSAVAC    *ECMWF*       07/01/2004.
C
C
C     MODIFICATIONS.
C     --------------
C
C          NONE.
C
C
      IMPLICIT LOGICAL(L,O,G), CHARACTER*8(C,H,Y)
C
C
      PARAMETER(JSUP =   9,JSEC0=   3,JSEC1= 40,JSEC2= 64 ,JSEC3=    4,
     1          JSEC4=   2,JELEM=40000,JSUBS=400,JCVAL=150 ,JBUFL=40000,
     2          JBPW =  32,JTAB =3000,JCTAB=120,JCTST=1800,JCTEXT= 200,
     3          JWORK=360000,JKEY=46)
C
C
C
      COMMON /CREXWORK/ NBPT,NGS,NVIND,NBPTSEC2,RVIND,EPS,NE,IEOLD,
     1                  NC07YYY
C
      COMMON /CREXWT/ NCREXDWINC,NCREXSCAM,NCREXAFDW,NCREXWT ,ODREPF,
     2               NCREXSTACK(JELEM),NCREXWTEN(JELEM),
     3               NCREXWTR (JELEM),NCREXWTS (JELEM),NCREXWTRV(JELEM),
     4               NCREXWTDW(JELEM),NWTIW(JELEM),NWTIWS(JELEM)
C
C             NCREXDWINC   -  data width increment
C             NCREXSCAM    -  scale multiplier
C             NCREXAFDW    -  augmented field data width
C             NCREXWT      -  pointer to working table
C             NCREXSTACK   -  list of data descriptors
C             ODREPF   -  replication (logical)
C             NCREXWTR     -  working table reference
C             NCREXWTS     -  working scale
C             NCREXWTRV    -  working reference value
C             NCREXWTDW    -  working data width
C             NWTIW    -  working data width of increments
C             NWTIWS   -  working total data width of element set
C
C
      COMMON /CREXWTC/ CREXWTEN(JELEM),CREXWTU (JELEM)
C
C             CREXWTEN    -  working table element naame
C             CREXWTU     -  working table units
C
C
      COMMON /CREXBEF / M,MM,N,JCV
C
C             M       -  Number of elements
C             MM      -  Number of elements
C             N       -  Number of data sub_sets
C             JCV     -  Number of character values
C
C
      COMMON /CREXUT/ YUNIT,CUNITNAME,CIA5,CIA2,NCODE,NRECORDS
C
C             NCODE  - array containing unit code number
C             CUNITNAME - array containing unit name
C             CIA5 - array  containing unit CCITTIA5 name
C             CIA2 - array  containing unit CCITTIA2 name
C             NRECORDS - number of entries in the list
C
      DIMENSION NCODE(JCTEXT)
      CHARACTER*30 CUNITNAME(JCTEXT)
      CHARACTER*24 CIA5(JCTEXT)
      CHARACTER*24 CIA2(JCTEXT)
      CHARACTER*24 YUNIT
C
      CHARACTER CREXWTEN*64,CREXWTU*24
      DIMENSION KSTACK(*)
      CHARACTER*(*) YBUFF
      REAL*8 RVIND,EPS
C
C     ------------------------------------------------------------------
C
C*          1.   DETERMINE *F *X AND *Y.
C                -----------------------
 100  CONTINUE
C
      IF( KERR.NE.0 ) RETURN
C
      IF  = KDD / 100000
      IDIF= KDD - IF * 100000
      IX  = IDIF / 1000
      IY  = IDIF - IX * 1000
C
      IF( IF.NE.2 ) THEN
         KERR=21
         PRINT*,' CREXPRCO :'
         CALL CREXERR(KERR)
         GO TO 400
      END IF
C
C*          1.1   CHANGE DATA WIDTH ?
C                 -------------------
 110  CONTINUE
C
      IF(IX.EQ.1) THEN
         NCREXDWINC= IY
         GO TO 400
      END IF
C
C*          1.2   CHANGE SCALE ?
C                 --------------
 120  CONTINUE
C
      IF(IX.EQ.2) THEN
C
C*          1.2.1  UPDATE SCALE MULTIPLIER.
C                  ------------------------
C
         IF(IY.GT.900) IY=-(IY-900)
         NCREXSCAM=IY
         GO TO 400
      END IF
C
C
C*          1.5   SIGNIFY CHARACTER ?
C                 -------------------
 150  CONTINUE
C
      IF(IX.EQ.5) THEN
C
C*          1.5.1  ADD SPECIAL ENTRY TO WORKING TABLE.
C                  -----------------------------------
         NCREXWT = NCREXWT + 1
         CREXWTEN(NCREXWT)='CHARACTERS'
         CREXWTU (NCREXWT)=' '
         NCREXWTR (NCREXWT)= kdd      
         NCREXWTDW(NCREXWT)= IY
         NCREXWTEN(NCREXWT)=658367
         NCREXWTS (NCREXWT)=0
         NCREXWTRV(NCREXWT)=0
         GO TO 400
      END IF
C
C          1.6 CHANGE UNIT
C              -----------
 160  CONTINUE
C
      IERR=0
      IF(IX.EQ.7) THEN
         CALL GET_UNITS(IY,IERR)
         IF(IERR.EQ.0) THEN
            NC07YYY=IY
         END IF
C
         GO TO 400
C
      END IF
C
C     ------------------------------------------------------------------
C
 300  CONTINUE
C
      KERR=22
      PRINT*,'CREXPRCO:'
      CALL CREXERR(KERR)
C
C     ------------------------------------------------------------------
C
 400  CONTINUE
C
      RETURN
      END

c Copyright 1981-2016 ECMWF.
c
c This software is licensed under the terms of the Apache Licence 
c Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
c
c In applying this licence, ECMWF does not waive the privileges and immunities 
c granted to it by virtue of its status as an intergovernmental organisation 
c nor does it submit to any jurisdiction.
c

      SUBROUTINE FFT99(A,WORK,TRIGS,IFAX,INC,JUMP,N,LOT,ISIGN)
      DIMENSION A(N),WORK(N),TRIGS(N),IFAX(*)
C
C     SUBROUTINE 'FFT99' - MULTIPLE FAST REAL PERIODIC TRANSFORM
C     SUPERSEDES PREVIOUS ROUTINE 'FFT99'
C
C     REAL TRANSFORM OF LENGTH N PERFORMED BY REMOVING REDUNDANT
C     OPERATIONS FROM COMPLEX TRANSFORM OF LENGTH N
C
C     A IS THE ARRAY CONTAINING INPUT & OUTPUT DATA
C     WORK IS AN AREA OF SIZE (N+1)*MIN(LOT,64)
C     TRIGS IS A PREVIOUSLY PREPARED LIST OF TRIG FUNCTION VALUES
C     IFAX IS A PREVIOUSLY PREPARED LIST OF FACTORS OF N
C     INC IS THE INCREMENT WITHIN EACH DATA 'VECTOR'
C         (E.G. INC=1 FOR CONSECUTIVELY STORED DATA)
C     JUMP IS THE INCREMENT BETWEEN THE START OF EACH DATA VECTOR
C     N IS THE LENGTH OF THE DATA VECTORS
C     LOT IS THE NUMBER OF DATA VECTORS
C     ISIGN = +1 FOR TRANSFORM FROM SPECTRAL TO GRIDPOINT
C           = -1 FOR TRANSFORM FROM GRIDPOINT TO SPECTRAL
C
C     ORDERING OF COEFFICIENTS:
C         A(0),B(0),A(1),B(1),A(2),B(2),...,A(N/2),B(N/2)
C         WHERE B(0)=B(N/2)=0; (N+2) LOCATIONS REQUIRED
C
C     ORDERING OF DATA:
C         X(N-1),X(0),X(1),X(2),...,X(N-1),X(0)
C         I.E. EXPLICIT CYCLIC CONTINUITY; (N+2) LOCATIONS REQUIRED
C
C     VECTORIZATION IS ACHIEVED ON CRAY BY DOING THE TRANSFORMS
C     IN PARALLEL
C
C     N MUST BE COMPOSED OF FACTORS 2,3 & 5 BUT DOES NOT HAVE TO BE EVEN
C
C     DEFINITION OF TRANSFORMS:
C     -------------------------
C
C     ISIGN=+1: X(J)=SUM(K=0,...,N-1)(C(K)*EXP(2*I*J*K*PI/N))
C         WHERE C(K)=A(K)+I*B(K) AND C(N-K)=A(K)-I*B(K)
C
C     ISIGN=-1: A(K)=(1/N)*SUM(J=0,...,N-1)(X(J)*COS(2*J*K*PI/N))
C               B(K)=-(1/N)*SUM(J=0,...,N-1)(X(J)*SIN(2*J*K*PI/N))
C
      IF(IFAX(10).NE.N) CALL SET99(TRIGS,IFAX,N)
      NFAX=IFAX(1)
      NX=N+1
      IF (MOD(N,2).EQ.1) NX=N
      NBLOX=1+(LOT-1)/64
      NVEX=LOT-(NBLOX-1)*64
      IF (ISIGN.EQ.-1) GO TO 300
C
C     ISIGN=+1, SPECTRAL TO GRIDPOINT TRANSFORM
C     -----------------------------------------
  100 CONTINUE
      ISTART=1
      DO 220 NB=1,NBLOX
      IA=ISTART
      I=ISTART
      DO 110 J=1,NVEX
      A(I+INC)=0.5*A(I)
      I=I+JUMP
  110 CONTINUE
      IF (MOD(N,2).EQ.1) GO TO 130
      I=ISTART+N*INC
      DO 120 J=1,NVEX
      A(I)=0.5*A(I)
      I=I+JUMP
  120 CONTINUE
  130 CONTINUE
      IA=ISTART+INC
      LA=1
      IGO=+1
C
      DO 160 K=1,NFAX
      IFAC=IFAX(K+1)
      IERR=-1
      IF (IGO.EQ.-1) GO TO 140
      CALL RPASSM(A(IA),A(IA+LA*INC),WORK(1),WORK(IFAC*LA+1),TRIGS,
     *    INC,1,JUMP,NX,NVEX,N,IFAC,LA,IERR)
      GO TO 150
  140 CONTINUE
      CALL RPASSM(WORK(1),WORK(LA+1),A(IA),A(IA+IFAC*LA*INC),TRIGS,
     *    1,INC,NX,JUMP,NVEX,N,IFAC,LA,IERR)
  150 CONTINUE
      IF (IERR.NE.0) GO TO 500
      LA=IFAC*LA
      IGO=-IGO
      IA=ISTART+INC
  160 CONTINUE
C
C     IF NECESSARY, COPY RESULTS BACK TO A
C     ------------------------------------
      IF (MOD(NFAX,2).EQ.0) GO TO 190
      IBASE=1
      JBASE=IA
      DO 180 JJ=1,NVEX
      I=IBASE
      J=JBASE
      DO 170 II=1,N
      A(J)=WORK(I)
      I=I+1
      J=J+INC
  170 CONTINUE
      IBASE=IBASE+NX
      JBASE=JBASE+JUMP
  180 CONTINUE
  190 CONTINUE
C
C     FILL IN CYCLIC BOUNDARY VALUES
C     ------------------------------
      IX=ISTART
      IZ=ISTART+N*INC
CDIR$ IVDEP
      DO 200 J=1,NVEX
      A(IX)=A(IZ)
      A(IZ+INC)=A(IX+INC)
      IX=IX+JUMP
      IZ=IZ+JUMP
  200 CONTINUE
C
      ISTART=ISTART+NVEX*JUMP
      NVEX=64
  220 CONTINUE
      RETURN
C
C     ISIGN=-1, GRIDPOINT TO SPECTRAL TRANSFORM
C     -----------------------------------------
  300 CONTINUE
      ISTART=1
      DO 410 NB=1,NBLOX
      IA=ISTART+INC
      LA=N
      IGO=+1
C
      DO 340 K=1,NFAX
      IFAC=IFAX(NFAX+2-K)
      LA=LA/IFAC
      IERR=-1
      IF (IGO.EQ.-1) GO TO 320
      CALL QPASSM(A(IA),A(IA+IFAC*LA*INC),WORK(1),WORK(LA+1),TRIGS,
     *    INC,1,JUMP,NX,NVEX,N,IFAC,LA,IERR)
      GO TO 330
  320 CONTINUE
      CALL QPASSM(WORK(1),WORK(IFAC*LA+1),A(IA),A(IA+LA*INC),TRIGS,
     *    1,INC,NX,JUMP,NVEX,N,IFAC,LA,IERR)
  330 CONTINUE
      IF (IERR.NE.0) GO TO 500
      IGO=-IGO
      IA=ISTART+INC
  340 CONTINUE
C
C     IF NECESSARY, COPY RESULTS BACK TO A
C     ------------------------------------
      IF (MOD(NFAX,2).EQ.0) GO TO 370
      IBASE=1
      JBASE=IA
      DO 360 JJ=1,NVEX
      I=IBASE
      J=JBASE
      DO 350 II=1,N
      A(J)=WORK(I)
      I=I+1
      J=J+INC
  350 CONTINUE
      IBASE=IBASE+NX
      JBASE=JBASE+JUMP
  360 CONTINUE
  370 CONTINUE
C
C     SHIFT A(0) & FILL IN ZERO IMAG PARTS
C     ------------------------------------
      IX=ISTART
      DO 380 J=1,NVEX
      A(IX)=A(IX+INC)
      A(IX+INC)=0.0
      IX=IX+JUMP
  380 CONTINUE
      IF (MOD(N,2).EQ.1) GO TO 400
      IZ=ISTART+(N+1)*INC
      DO 390 J=1,NVEX
      A(IZ)=0.0
      IZ=IZ+JUMP
  390 CONTINUE
  400 CONTINUE
C
      ISTART=ISTART+NVEX*JUMP
      NVEX=64
  410 CONTINUE
      RETURN
C
C     ERROR MESSAGES
C     --------------
  500 CONTINUE
      GO TO (510,530,550) IERR
  510 CONTINUE
      WRITE(6,520) NVEX
  520 FORMAT('1VECTOR LENGTH =',I4,', GREATER THAN 64')
      GO TO 570
  530 CONTINUE
      WRITE(6,540) IFAC
  540 FORMAT( '1FACTOR =',I3,', NOT CATERED FOR')
      GO TO 570
  550 CONTINUE
      WRITE(6,560) IFAC
  560 FORMAT('1FACTOR =',I3,', ONLY CATERED FOR IF LA*IFAC=N')
  570 CONTINUE
      RETURN
      END

C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE BUEXS3(KBUFL,KBUFF,KSUP,KSEC3,KELEM,CNAMES,CUNITS,KERR)
C
C**** *BUEXS3*
C
C
C     PURPOSE.
C     --------
C
C          EXPAND SECTION 3 OF BUFR MESSAGE.
C
C
C**   INTERFACE.
C     ----------
C
C          *CALL* *BUEXS3( KBUFL,KBUFF,KSUP,KSEC3,KELEM,CNAMES,CUNITS,KERR)*
C
C        INPUT :
C               *KBUFL*   -  LENGTH OF BUFR MESSAGE (WORDS)
C               *KBUFF*   -  ARRAY CONTAINING BUFR MESSAGE
C               *KELEM*   -  DIMENSION OF CNAMES, CUNITS ARRAY
C        OUTPUT:
C               *KSUP*    -  ARRAY CONTAINING SUPLEMENTARY INFORMATION
C                         -  KSUP( 1) -- IDIM1, DIMENSION OF KSEC1
C                         -  KSUP( 2) -- IDIM2, DIMENSION OF KSEC2
C                         -  KSUP( 3) -- IDIM3, DIMENSION OF KSEC3
C                         -  KSUP( 4) -- IDIM4, DIMENSION OF KSEC4
C                         -  KSUP( 5) -- M (NUMBER OF ELEMENTS IN VALUES ARRAY,
C                                           FIRST INDEX)
C                         -  KSUP( 6) -- N (NUMBER OF SUBSETS,SECOND INDEX OF
C                                           VALUES ARRAY)
C                         -  KSUP( 7) -- JVC (NUMBER OF ELEMENTS IN CVAL ARRAY)
C                         -  KSUP( 8) -- TOTAL BUFR MESSAGE LENGTH IN BYTES
C                         -  KSUP( 9) -- IDIM0, DIMENSION OF KSEC0
C               *KSEC3*   -  ARRAY CONTAINING SECTION 3 INFORMATION
C                            KSEC3( 1)-- LENGTH OF SECTION 3 (BYTES)
C                            KSEC3( 2)-- RESERVED
C                            KSEC3( 3)-- NUMBER OF SUBSETS
C                            KSEC3( 4)-- FLAG (DATA TYPE,DATA COMPRESSION)
C               *CNAMES*  -  CHARACTER ARRAY CONTAINING ELEMENT NAMES
C               *CUNITS*  -  CHARACTER ARRAY CONTAINIG UNITS
C               *KERR*    -  RETURNED ERROR CODE
C
C     METHOD.
C      -------
C
C          EXPANDS LIST OF DATA DESCRIPTORS PACKED IN SECTION 3
C     OF BUFR MESSAGE. WORKING TABLES FOR FURTHER DATA DECODING ARE SET,
C     LIST OF PACKED BUFR DATA DESCRIPTORS AND LIST OF BUFR DATA DESCRIPTORS
C     EXPANDED ACCORDING TO TABLE D REFERENCE ARE RETURNED RESPECTIVELY.
C
C
C
C     EXTERNALS.
C     ----------
C
C          BUNEXS        - SET WORD AND BIT POINTERS AT THE BEGINING OF
C                          NEXT SECTION
C          BUNPCK        - UNPACKS BIT PATTERN
C          BUSRP         - SOLVES REPLICATION PROBLEM
C          BUSTDR        - SOLVES TABLE D REFERENCE
C          BUPRCO        - PROCESS OPERATOR
C          BUUPWT        - UPDATES WORKING TABLE
C
C     REFERENCE.
C     ----------
C
C          NONE.
C
C     AUTHOR.
C     -------
C
C          M. DRAGOSAVAC    *ECMWF*       01/02/91.
C
C
C     MODIFICATIONS.
C     --------------
C
C          NONE.
C
C
      IMPLICIT LOGICAL(L,O,G), CHARACTER*8(C,H,Y)
C
C
#     include "parameter.F"
#     include "bcomunit.F"
#     include "bcomwork.F"
#     include "bcombef.F"
#     include "bcomwt.F"
#     include "bcomp.F"
#     include "bcomwtc.F"
#     include "bcomrq.F"
#     include "bcomreq.F"
#     include "bcomel.F"
#     include "bcprq.F"
#     include "bcomoff.F"
#     include "bcomcom.F"
C
      CHARACTER*64 CWTEN
      CHARACTER*24 CWTU
      CHARACTER*64 CNAMES(KELEM)
      CHARACTER*24 CUNITS(KELEM)
C
      DIMENSION ISTACK(JELEM),IISTACK(JELEM)
      DIMENSION KBUFF(KBUFL)
      DIMENSION IMASK(8)
C
#ifndef R_4
      REAL*8 RQVAL
      REAL*8 RVIND
      REAL*8 EPS
#else
      REAL   RQVAL
      REAL   RVIND
      REAL   EPS
#endif
C
      DIMENSION KSUP(JSUP),KSEC3(JSEC3)
C
      DATA IMASK/1,2,4,8,16,32,64,128/
C
      SAVE NOLD,KELEMOLD
C     ------------------------------------------------------------------
C
C*          1.   EXPAND PRELIMINARY ITEMS OF SECTION 3.
C                --------------------------------------
 100  CONTINUE
C
      IF( KERR.NE.0 ) RETURN
C
C
C*          1.1   SET THE POINTERS NWPT AND NBPT TO THE
C                 -------------------------------------
C                 BEGINING OF THE SECTION 3.
C                 --------------------------
 110  CONTINUE
C
      NWPT = NWPTB
      NBPT = NBPTB
C
C*          1.2   UNPACK LENGTH OF SECTION 3.
C                 ---------------------------
 120  CONTINUE
C
      CALL BUNPCK(NBPW,KBUFF,KSEC3(1),NWPT,NBPT,24,KERR)
      IF(KERR.GT.0) THEN
         WRITE(KNTN,*)  'ERROR UNPACKING KSEC3(1).'
         RETURN
      END IF
C
C*          1.2.1  SET THE POINTERS NWPTB AND NBPTB TO
C                  -----------------------------------
C                  THE BEGINNING OF THE NEXT SECTION.
C                  ----------------------------------
      CALL BUNEXS(KSEC3(1))
C
C*          1.3    UNPACK ZERO BYTE AND PUT IT IN KSEC3(2).
C                  ----------------------------------------
 130  CONTINUE
C
      CALL BUNPCK(NBPW,KBUFF,KSEC3(2),NWPT,NBPT,8,KERR)
      IF(KERR.GT.0) THEN
         WRITE(KNTN,*)  'ERROR UNPACKING KSEC3(2).'
         RETURN
      END IF
C
C*          1.4    UNPACK NUMBER OF DATA SUB-SETS.
C                  -------------------------------
 140  CONTINUE
C
      CALL BUNPCK(NBPW,KBUFF,KSEC3(3),NWPT,NBPT,16,KERR)
      IF(KERR.GT.0) THEN
         WRITE(KNTN,*)  'ERROR UNPACKING KSEC3(3).'
         RETURN
      END IF
      IF(KSEC3(3).LE.0) THEN
         KERR=32
         WRITE(KNTN,*)  ' BUEXS3 :'
         CALL BUERR(KERR)
         RETURN
      END IF
C
      N = KSEC3(3)
C
C
C*          1.5    UNPACK INTEGER VALUE OF THE OCTET
C                  ---------------------------------
C                  CONTAINING FLAG BITS.
C                  --------------------
 150  CONTINUE
C
      CALL BUNPCK(NBPW,KBUFF,KSEC3(4),NWPT,NBPT,8,KERR)
      IF(KERR.GT.0) THEN
         WRITE(KNTN,*)  'ERROR UNPACKING KSEC3(4).'
         RETURN
      END IF
C
      ICOMP=KSEC3(4)
C     -----------------------------------------------------------------
C
C*          2.   EXPAND DATA DESCRIPTORS.
C                ------------------------
 200  CONTINUE
C
C
C*          2.1  CALCULATE EXPECTED NUMBER OF DATA DESCRIPTORS.
C                ----------------------------------------------
C                AND INITIALIZE NUMBER OF DATA VALUES PER SUB-SET.
C                -------------------------------------------------
 210  CONTINUE
C
      J      = 0
      NWT    = 0
      JMAX   = ( KSEC3(1) - 7)/2
      JMAXNEW=JMAX
C
      IF(JMAX.GT.JELEM) THEN
         WRITE(KNTN,*)  'NUMBER OF ELEMENTS IN SECTION3 TOO BIG.'
         WRITE(KNTN,*)  'PROGRAM CAN NOT HANDLE',JMAX
         WRITE(KNTN,*)  'DATA DESCRIPTORS IN SECTION3.'
         WRITE(KNTN,*)  'MAXIMUM NUMBER OF ELEMENTS IS ',JELEM
         KERR=200
         RETURN
      END IF
C
C*          2.2  UNPACK AND PUT DATA DESCRIPTORS IN STACK.
C                -----------------------------------------
 220  CONTINUE
C
      DO 221 JJ=1,JMAX
C
      CALL BUNPCK(NBPW,KBUFF,IF,NWPT,NBPT,2,KERR)
      IF(KERR.GT.0) THEN
         WRITE(KNTN,*)  'ERROR UNPACKING F PART OF DESCRIPTOR.'
         RETURN
      END IF
      CALL BUNPCK(NBPW,KBUFF,IX,NWPT,NBPT,6,KERR)
      IF(KERR.GT.0) THEN
         WRITE(KNTN,*)  'ERROR UNPACKING X PART OF DESCRIPTOR.'
         RETURN
      END IF
      CALL BUNPCK(NBPW,KBUFF,IY,NWPT,NBPT,8,KERR)
      IF(KERR.GT.0) THEN
         WRITE(KNTN,*)  'ERROR UNPACKING Y PART OF DESCRIPTOR.'
         RETURN
      END IF
C
      ISTACK(JJ)=IF*100000+IX*1000+IY
      IISTACK(JJ)=ISTACK(JJ)
C
 221  CONTINUE
C
C*          2.2.1 CHECK IF IT IS SAME DATA DESCRIPTOR DESCRIPTION.
C                 ------------------------------------------------
C                 TO MAKE MORE EFFICIENT DATA DESCRIPTOR DESCRIPTION
C                 EXPANSION, IN CASE THAT DELAYED REPLICATION FACTOR
C                 IS NOT PRESENT AND DATA DESCRIPTORS ARE THE SAME,
C                 PREVIOUS WORKING TABLE SHOULD BE USED. IT IS POSIBLE
C                 AT THIS PLACE IN THE FUTURE TO MAKE MORE SOPHISTICATED
C                 CONTROL.
C
C
      DO 222 JC=1,JMAX
C
      IF(ISTACK(JC).NE.NSTACK(JC)) THEN
C
         ODREPF=.FALSE.
C
C        SWAP CONTENT OF THE STACKS.
C
         DO 223 JJC=1,JMAX
         NSTACK(JJC)=ISTACK(JJC)
 223     CONTINUE
C
         NTDLEN = JMAX
         M=0
         M0=1
         NOLD=N
         KELEMOLD=KELEM
         NFCM=0
         NFUCM=0
         MREL=0
         OMARKER=.FALSE.
         MBMP=0
         MBMPL=0
C
         GO TO 230
C
      END IF
C
 222  CONTINUE
C
C*    IF MARKER OPERATOR PRESENT EXPAND DESCRIPTORS AGAIN
C
      IF(OMARKER) THEN
         M=0
         M0=1
         NOLD=N
         KELEMOLD=KELEM
         NFCM=0
         NFUCM=0
         MREL=0
         OMARKER=.FALSE.
         NTDLEN=JMAX
         MBMP=0
         MBMPL=0
         GO TO 230
      END IF
C
C*    CHECK IF THE SAME NUMBER OF DESCRIPTORS
C     AS IN A PREVIOUS MESSAGE
C
      IF(JMAX.NE.NTDLEN) THEN
         M=0
         M0=1
         NOLD=N
         KELEMOLD=KELEM
         NFCM=0
         NFUCM=0
         MREL=0
         OMARKER=.FALSE.
         NTDLEN=JMAX
         MBMP=0
         MBMPL=0
         GO TO 230
      END IF
C
C*    RETURN IF DELAYED REPLICATION FACTOR IS NOT PRESENT.
C
      IF(NPRUS.EQ.1) GO TO 229
C
      OB=.FALSE.
      IF(IAND(KSEC3(4),IMASK(7)).NE.0) OB=.TRUE.
C
C     CHECK FOR DELAYED REPLICATION FACTOR
C
      IF(ODREPF) GO TO 229
C
C     CHECK FOR COMPRESSION
C
      IF(OB) THEN
C
C        DATA COMPRESSED =/ PREVIOUS  --> RECALCULATE POINTERS
C
         GO TO 229
      END IF
C
 229  CONTINUE
C
      M=0
      M0=1
      NOLD=N
      KELEMOLD=KELEM
      NFCM=0
      NFUCM=0
      MREL=0
      OMARKER=.FALSE.
      NTDLEN=JMAX
      MBMP=0
      MBMPL=0
C
C     ------------------------------------------------------------------
C*          2.3  GET NEXT DESCRIPTOR FROM THE STACK.
C                -----------------------------------
 230  CONTINUE
C
      J   = J + 1
      IF(J.GT.JMAX) GO TO 270
C
      IDD = ISTACK(J)
      IF(IDD.EQ.0)  GO TO 230
C
      IF = IDD/100000
C
      IF(NWT.GT.NSTOP) GO TO 270
C     ------------------------------------------------------------------
C*          2.4  CHECK IF IT IS REPLICATION DESCRIPTOR.
C                --------------------------------------
 240  CONTINUE
C
      IF( IF.EQ.0) THEN
C
C*          2.6  ELEMENT DESCRIPTOR, SO UPDATE WORKING TABLE.
C                --------------------------------------------
 260     CONTINUE
C
            CALL BUUPWT(IDD,KELEM,KERR)
            IF(KERR.GT.0) RETURN
C       
      ELSEIF( IF.EQ.1) THEN
C
C*          2.4.1     SOLVE REPLICATION PROBLEM.
C                     --------------------------
C
C
         CALL BUSRP(KBUFL,KBUFF,KSEC3,J,JMAX,IDD,ISTACK,KELEM,KERR)
         IF(KERR.GT.0) RETURN
C
      ELSEIF( IF.EQ.2) THEN
C
C*          2.5.3 PROCESS OPERATOR.
C                 -----------------
            CALL BUPRCO(KBUFL,KBUFF,J,IDD,ISTACK,KELEM,KERR)
            IF(KERR.GT.0) RETURN
C
      ELSEIF( IF.EQ.3) THEN
C
C*          2.5.2 REPLACE BY LIST OF DESCRIPTORS FROM TABLE *D.
C                 ---------------------------------------------
            CALL BUSTDR(J,JMAX,IDD,ISTACK,KERR)
            IF(KERR.GT.0) THEN
               DO 252 IQ=1,JELEM
               NSTACK(IQ)=0.
 252           CONTINUE
               RETURN
            END IF
      ELSE
         KERR=37
         CALL BUERR(KERR)
         RETURN
      END IF
C
      GO TO 230
C
C     ------------------------------------------------------------------
C*          2.7 RESOLVE MARKER OPERATOR.
C               ------------------------
 270  CONTINUE
C
      IF(OMARKER) THEN
         CALL BUPMRK(KBUFL,KBUFF,KSEC3,KELEM,KERR)
         IF(KERR.GT.0) RETURN
      END IF
C
C*          2.8 CHECK IF IT IS CORRESPONDING DATA.
C               ----------------------------------
 280  CONTINUE
C
C     CHECK FOR WORKING SPACE.
C
      IF(JWORK/N.LT.KELEM) THEN
         KERR=17
         WRITE(KNTN,*)  'BUEXS3:'
         CALL BUERR(KERR)
         MN=KELEM*N
         WRITE(KNTN,*)  ' SUGGESTED VALUE FOR JWORK ',MN
         WRITE(KNTN,*)  ' CHECK IF TOO BIG KELEM USED.'
         RETURN
      END IF
C
      IF(IAND(KSEC3(4),IMASK(7)).NE.0) THEN
C
C        COMPRESSED DATA
C
         CALL BURQC(KBUFL,KBUFF,KELEM,CNAMES,CUNITS,KSUP ,KSEC3,KERR)
         IF(KERR.GT.0) RETURN
      ELSE
C
C        UNCOMPRESSED DATA
C
         CALL BURQUC(KBUFL,KBUFF,KELEM,CNAMES,CUNITS,KSUP ,KSEC3,KERR)
         IF(KERR.GT.0) RETURN
C
      END IF
C
C     ------------------------------------------------------------------
C
C*          3. COLLECT  SUPPLEMENTARY ITEMS.
C              -----------------------------
 300  CONTINUE
C
      NTDEXL =M
      DO 301 I=1,NTDEXL
      NTDEXP(I)=INWTR(I)
 301  CONTINUE
C
      NTDLEN=JMAXNEW
      DO 302 I=1,NTDLEN
      NTDLST (I)=IISTACK(I)
 302  CONTINUE
C
      DO 303 I=1,NTDEXL
      IJ=I+(NSUBSET-1)*KELEM
      NWTRG(IJ)=INWTR(I)
      NWTDWG(IJ)=INWTDW(I)
 303  CONTINUE
C
      NSIZE(NSUBSET)  =M
C
      KSUP(3)= 4
      KSUP(5)= NSIZE(1)
      KSUP(6)= KSEC3(3)
C
      N07=0
      N08=0
      N40=0
      NDWINC=0
      NSCAM=0
      NSCAM07=0
      NDWINC07=0
      NFD=0
    
      do i=1,100
      NAFDWA(i)=0
      end do
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities
C granted to it by virtue of its status as an intergovernmental organisation
C nor does it submit to any jurisdiction.
C

      SUBROUTINE ABORTX (HNAME)
C
C---->
C**** ABORTX - Terminates execution of program.
C
C     Purpose.
C     --------
C
C     Terminates execution of program.
C
C**   Interface.
C     ----------
C
C     CALL ABORTX (HNAME)
C
C
C     Input Parameters.
C     -----------------
C
C     HNAME      - Name of calling routine.
C
C     Output Parameters.
C     ------------------
C
C     None.
C
C     Method.
C     -------
C
C     Prints message and terminates.
C
C     Externals.
C     ----------
C
#if defined(VAX) || defined(__PGI)
C     EXIT (VAX/PGI Fortran)
#elif (defined IBM) && (!defined rs6000)
C     SYSABN (IBM)
#elif defined(CRAY)
C     ABORT (Cray)
#elif defined(sun) || defined (sgi) || (defined rs6000)
C     ABORT (SUN/SGI)
#elif defined(CYBER)
C     ABORT (Cyber)
#elif defined(__uxp__)
C     ABORT (Fujitsu)
#elif defined(__hpux)
C     JABORT (C)
#endif
C
C     Reference.
C     ----------
C
C     None.
C
C     Comments.
C     ---------
C
C     None.
C
C     Author.
C     -------
C
C     J. Hennessy      ECMWF      13.11.91
C
C     Modifications.
C     --------------
C
C     None.
C
C----<
C
      IMPLICIT NONE
C
#include "common/grprs.h"
C
      CHARACTER*(*) HNAME
C
C     ------------------------------------------------------------------
C*    Section 1 . Print message and terminate.
C     ------------------------------------------------------------------
C
  100 CONTINUE
C
      WRITE(GRPRSM,9001) HNAME
C
#if defined(VAX) || defined(__PGI)
      CALL EXIT (-1)
#elif (defined IBM) && (!defined rs6000)
      CALL SYSABN (1)
#elif defined(CRAY)
      CALL ABORT
#elif defined(sun) || defined (sgi) || (defined rs6000)
      CALL ABORT
#elif defined(CYBER)
      CALL ABORT ('US',0,' ')
#elif defined(__uxp__)
      CALL ABORT
#elif defined(__hpux)
      CALL JABORT
#endif
C     Ensure termination and non-zero return if external doesn't
C     (STOP is intrinsic)
      STOP 1
C
C     ------------------------------------------------------------------
C*    Section 9 . Format statements.
C     ------------------------------------------------------------------
C
  900 CONTINUE
C
 9001 FORMAT (1H ,'ABORTX : Routine ',A,' has requested program',
     C               ' termination.')
C
      RETURN
C
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE CREXEPWT(KDD,KERR)
C
C**** *CREXEPWT*
C
C
C     PURPOSE.
C     --------
C          UPDATES WORKING TABLES SETTING ELEMENT NAME,UNIT,SCALE,
C     REFERENCE VALUE AND DATA WIDTH.
C
C
C**   INTERFACE.
C     ----------
C
C          *CALL* *CREXEPWT(KDD,KELEM,KERR)*
C
C        INPUT :
C               *KDD*     -  DATA DESCRIPTOR
C        OUTPUT:
C               *KERR*    -  RETURN ERROR CODE
C
C     METHOD.
C     -------
C
C          NONE.
C
C
C     EXTERNALS.
C     ----------
C
C          NONE.
C
C     REFERENCE.
C     ----------
C
C          NONE.
C
C     AUTHOR.
C     -------
C
C          MILAN DRAGOSAVAC    *ECMWF*       07/01/2004.
C
C
C     MODIFICATIONS.
C     --------------
C
C          NONE.
C
C
      IMPLICIT LOGICAL(L,O,G), CHARACTER*8(C,H,Y)
C
C
      PARAMETER(JSUP =   9,JSEC0=   3,JSEC1= 40,JSEC2= 64 ,JSEC3=    4,
     1          JSEC4=2,JELEM=40000,JSUBS=400,JCVAL=150 ,JBUFL=40000,
     2          JBPW =  32,JTAB =3000,JCTAB=120,JCTST=1800,JCTEXT= 200,
     3          JWORK=360000,JKEY=46)
C
C
C
      COMMON /CRWORK/ NBPT,NGS,NVIND,NBPTSEC2,RVIND,EPS,NE,IEOLD,
     1                  NC07YYY
C
      COMMON /CRWT/ NCREXDWINC,NCREXSCAM,NCREXAFDW,NCREXWT ,ODREPF,
     2             NCREXSTACK(JELEM),NCREXWTEN(JELEM),
     3             NCREXWTR (JELEM),NCREXWTS (JELEM),
     4             NCREXWTDW(JELEM)
C
C             NCREXDWINC   -  data width increment
C             NCREXSCAM    -  scale multiplier
C             NCREXAFDW    -  augmented field data width
C             NCREXWT      -  pointer to working table
C             NCREXSTACK   -  list of data descriptors
C             ODREPF   -  replication (logical)
C             NCREXWTR     -  working table reference
C             NCREXWTS     -  working scale
C             NCREXWTDW    -  working data width
C
C
C
      COMMON /CRWTC/ CREXWTEN(JELEM),CREXWTU(JELEM)
C
C             CREXWTEN    -  working table element naame
C             CREXWTU     -  working table units
C
      CHARACTER CREXWTEN*64,CREXWTU*24
C
C
C

      COMMON/CRTAB/ NCREXBR(JTAB),NCREXBS(JTAB)    , NCREXBDW(JTAB),
     1              NCREXDR(JTAB),NCREXDST(JTAB)   ,
     2              NCREXDL(JTAB),NCREXDSQ(JTAB*20),NCREXP(64,255)

C
C             NCREXBR     - table B,  table reference              array
C             NCREXBS     - table B,  scale                        array
C             NCREXBDW    - table B,  data width                   array
C             NCREXDR     - table D,  table reference              array
C             NCREXDST    - table D,  starting pointers            array
C             NCREXDL     - table D,  lengths                      array
C             NCREXDSQ    - table D,  list of sequence descriptors array
C
C
C

C      COMMON /CRTABC/ CREXNAME(JTAB),CREXUNIT(JTAB),CREXLST(JELEM)
       COMMON /CRTABC/ CREXNAME(JTAB),CREXUNIT(JTAB)
C
C             CREXNAME      -  table B, ELEMENT NAME           array
C             CREXUNIT      -  table B, unit                   array
C
      COMMON /CRATB/  NJA,NCREXATBTR(JTAB),NCREXATBS (JTAB),
     1                NCREXATBDW(JTAB)
C
C
C             NCREXATBTR      - augmented table B table reference
C             NCREXATBS       - augmented table B scale
C             NCREXATBDW      - augmented table B data width
C
C
      COMMON /CRATBC/ CREXATBEN(JTAB),CREXATBU (JTAB)
C
C             CREXATBEN      - augmented table B element name
C             CREXATBU       - augmented table B units
C
C
      COMMON /CRBEF / M,MM,N,JCV
C
C             M       -  Number of elements
C             MM      -  Number of elements
C             N       -  Number of data sub_sets
C             JCV     -  Number of character values
C
C
C
C
      REAL*8 RVIND,EPS
C
      character*64 CREXNAME, CREXATBEN
      character*24 CREXATBU,CREXUNIT
C
C
C
C     ------------------------------------------------------------------
C*          1.   UPDATE WORKING TABLE.
C                ---------------------
 100  CONTINUE
C
      IF( KERR.NE.0 ) RETURN
C
      ICLASS=KDD/1000
      IYYY  =KDD-ICLASS*1000+1
      ICLASS=ICLASS+1
C
C*          1.1  ASSOCIATED FIELD ?
C                ------------------
 110  CONTINUE
C
      IF(NCREXAFDW.EQ.0) GO TO 140
C
C*          1.2  UNITS ELEMENT DESCRIPTOR ?
C                --------------------------
 120  CONTINUE
C
      I=NCREXP(ICLASS,IYYY)
      IF(I.EQ.0) THEN
         KERR=23
         WRITE(*,*) ' CREXEPWT : ', KDD
         CALL CREXERR(KERR)
         DO IQ=1,JELEM
         NCREXSTACK(IQ)=0.
         END DO
         RETURN
      END IF
C
      IF(CREXUNIT(I)(1:4).EQ.'CODE') GO TO 140
      IF(CREXUNIT(I)(1:4).EQ.'FLAG') GO TO 140
      IF(CREXUNIT(I)(1:3).EQ.'NUM' ) GO TO 140
C
C*          1.3   ADD SPECIAL ENTRY TO WORKING TABLE.
C                 -----------------------------------
 130  CONTINUE
C
      NCREXWT=NCREXWT+1
      CREXWTEN(NCREXWT)='ASSOCIATED FIELD'
      CREXWTU (NCREXWT)=' '
      NCREXWTDW(NCREXWT)=NCREXAFDW
      NCREXWTR (NCREXWT)= 999999
      NCREXWTEN(NCREXWT)= 0
      NCREXWTS (NCREXWT)= 0
      NCREXAFDW=0
C
      M=NCREXWT
C
C     ------------------------------------------------------------------
C*          1.4   SEARCH AUGMENTED TABLE *B ENTRIES .
C                 -----------------------------------
 140  CONTINUE
C
C
C
C*          1.5  GET TABLE *B ENTRY .
C                ---------------------
 150  CONTINUE
C
      I=NCREXP(ICLASS,IYYY)
      IF(I.EQ.0) THEN
         KERR=23
         WRITE(*,*)  'CREXEPWT : ',KDD
         CALL CREXERR(KERR)
         DO 2 IQ=1,JELEM
         NCREXSTACK(IQ)=0.
 2       CONTINUE
         RETURN
      END IF
C
 155  CONTINUE
C
C     -----------------------------------------------------------------
C*          1.6   MODIFY ENTRY FOR OPERATOR IN FORCE.
C                 -----------------------------------
 160  CONTINUE
C
C*                ADD ENTRY TO WORKING TABLE.
C                 ---------------------------
      NCREXWT=NCREXWT+1
      NCREXWTR (NCREXWT) = KDD
      IF(NCREXSCAM.ne.0) THEN
         NCREXWTS (NCREXWT) = NCREXSCAM
      ELSE
         NCREXWTS (NCREXWT) = NCREXBS (I)
      END IF
C
      NCREXSCAM=0
C
      IF(NCREXDWINC.ne.0) THEN
         NCREXWTDW(NCREXWT) = NCREXDWINC
      ELSE
         NCREXWTDW(NCREXWT) = NCREXBDW(I)
      END IF
C
      NCREXDWINC=0
C
      IF(NCREXWTR (NCREXWT).eq.031002) THEN
         NCREXWTDW(NCREXWT)=4
      END IF
C
C     CHECK IF DATA ARE PRESENT IN DATA SECTION.
C
      IF(NCREXWTR(NCREXWT).eq.31011.or.
     1   NCREXWTR(NCREXWT).eq.31012) then
         IF(NCREXWTR(NCREXWT-1).eq.31011.or.
     2      NCREXWTR(NCREXWT-1).eq.31012) THEN
            NCREXWTDW(NCREXWT)=0
         END IF
      END IF

 175  CONTINUE
C
C*          1.8 UPDATE M.
C               ---------
 180  CONTINUE
C
C
      CREXWTEN(NCREXWT) = CREXNAME(I)
      IF(NC07YYY.NE.0) THEN
         CREXWTU (NCREXWT) = YUNIT
         YUNIT=' '
         NC07YYY=0
      else
         CREXWTU (NCREXWT) = CREXUNIT(I)
      END IF
      NCREXWTEN(NCREXWT) = 0
      IF(CREXUNIT(I)(1:3).EQ.'CHA') NCREXWTEN(NCREXWT)=658367
C
       M = M + 1
C
C     ------------------------------------------------------------------
C
 200  CONTINUE
C
      RETURN
C
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities
C granted to it by virtue of its status as an intergovernmental organisation
C nor does it submit to any jurisdiction.
C

      LOGICAL FUNCTION ISGGVALID(HTYPE,KNUM)
C
C---->
C**** ISGGVALID
C
C     PURPOSE
C     _______
C
C     This function checks if a Gaussian grid definition is valid.
C
C
C     Parameters (input)
C     __________________
C
C     KNUM     - Gaussian grid number
C     HTYPE    - Gaussian grid type
C                = 'R' for reduced ("quasi-regular"),
C                = 'O' for reduced/octahedral,
C                = 'F' for full,
C                = 'U' for a user-defined gaussian grid
C
C----<
      IMPLICIT NONE

      INTEGER KNUM
      CHARACTER*1 HTYPE

      ! Condition:
      ! - for regular_gg or user-defined, valid for KNUM>=2
      ! - for reduced_gg, check grid number
      ISGGVALID = ( HTYPE.EQ.'F' .OR. HTYPE.EQ.'f' .OR.
     .              HTYPE.EQ.'O' .OR. HTYPE.EQ.'o' .OR.
     .              HTYPE.EQ.'U' .OR. HTYPE.EQ.'u' ) .AND.
     .            ( KNUM.GE.   2 )
     .            .OR.
     .            ( HTYPE.EQ.'R' .OR. HTYPE.EQ.'r' ) .AND.
     .            ( KNUM.EQ.  32 .OR.
     .              KNUM.EQ.  48 .OR.
     .              KNUM.EQ.  64 .OR.
     .              KNUM.EQ.  80 .OR.
     .              KNUM.EQ.  96 .OR.
     .              KNUM.EQ. 128 .OR.
     .              KNUM.EQ. 160 .OR.
     .              KNUM.EQ. 200 .OR.
     .              KNUM.EQ. 256 .OR.
     .              KNUM.EQ. 320 .OR.
     .              KNUM.EQ. 400 .OR.
     .              KNUM.EQ. 512 .OR.
     .              KNUM.EQ. 640 .OR.
     .              KNUM.EQ.1024 .OR.
     .              KNUM.EQ.1280 .OR.
     .              KNUM.EQ.2000 )

      END

C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

       PROGRAM FIND_T
      IMPLICIT NONE
C
      INTEGER JPACK, JPBYTES
      PARAMETER (JPACK = 300000)
      PARAMETER (JPBYTES = 4)
C
      INTEGER INBUFF
      DIMENSION INBUFF(JPACK)
      INTEGER IRET, NARGS, N, J, ILENB, LENOUT, NTEMPS
      INTEGER IVALUE, NUMBER, ISIZE, IPARAM, ITEMP, IARGC
C
      INTEGER  PBGTOTL, PBGPUT, PBGGET, PBGLENG, PBGPARM
      EXTERNAL PBGTOTL, PBGPUT, PBGGET, PBGLENG, PBGPARM
      EXTERNAL GETENV
C
      CHARACTER*128 INFILE, OUTFILE, CARG(4)
C
C **********************************************************************
C
C     Pick up file names from command line.
C
      NARGS = IARGC()
	  IF( NARGS.LT.4 ) THEN
         print*,'Usage: find_t -i inputfile -o outputfile'
         STOP
      END IF

      DO 101 J=1,NARGS
      CALL GETARG(J,CARG(J))
 101  CONTINUE

      DO 102 J=1,NARGS,2
        IF(CARG(J).EQ.'-i') THEN
           INFILE=CARG(J+1)
        ELSEIF(CARG(J).EQ.'-o') THEN
           OUTFILE=CARG(J+1)
        ELSE
            print*,'Usage: find_t -i inputfile -o outputfile'
            STOP
        END IF
 102  CONTINUE
C
C     Count number of GRIBs in the file
C
      NUMBER = PBGTOTL(INFILE)
      WRITE(*,*) 'Number of GRIBs in the file = ', NUMBER
      IF( NUMBER.EQ.0 ) STOP 'No Gribs found'
C
C     Search for temperature fields.
C     (Temperature is code 130 in table 128.)
C
      NTEMPS = 0
      ITEMP = (128*1000) + 130
      ILENB = JPACK * JPBYTES
C
      DO N = 1, NUMBER
C
        IPARAM = PBGPARM(INFILE,N)
C
C       Handle the GRIB product if it is a temperature field
C
        IF( IPARAM.EQ.ITEMP ) THEN
C
C         Check buffer is big enough for GRIB field.
C
          ISIZE = PBGLENG(INFILE,N)
          IF( ISIZE.GT.ILENB ) THEN
            WRITE(*,*) 'Field size (bytes)  = ', ISIZE
            WRITE(*,*) 'Buffer size (bytes) = ', ILENB
            STOP 'Buffer too small for field'
          ENDIF
C
C         Read temperature field and write it to the output file.
C
          NTEMPS = NTEMPS + 1
          LENOUT = PBGGET(INFILE, INBUFF, ILENB, N)
          IF( LENOUT.LT.0 ) STOP 'Problem reading temperature field'
C
          IRET = PBGPUT(OUTFILE, INBUFF, LENOUT)
          IF( IRET.LT.LENOUT ) STOP 'Problem writing temperature field'
C
        ENDIF
C
      ENDDO
C
      WRITE(*,*) 'Number of temperature fields copied = ', NTEMPS
      IF( NTEMPS.EQ.0 ) WRITE(*,*) 'No output file created'
C
      STOP
      END

C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C


      SUBROUTINE VOD2UV(VOR,DIV,KTIN,U,V,KTOUT)
C
C---->
C
CL    CALCULATE SPHERICAL HARMONIC COEFFICIENTS OF U*COS(LAT) AND
CL    V*COS(LAT) AT TRIANGULAR TRUNCATION KTOUT, GIVEN THE COEFFICIENTS
CL    OF DIVERGENCE AND VORTICITY AT TRUNCATION KTIN
CL
CL    WHERE VOR(KDIM1)=INPUT ARRAY OF VORTICITY COEFFICIENTS
CL          DIV(KDIM1)=INPUT ARRAY OF DIVERGENCE COEFFICIENTS
CL          KTIN      =INPUT TRIANGULAR TRUNCATION
CL          KDIM1     =(KTIN+1)*(KTIN+2)
CL          U(KDIM2)  =OUTPUT ARRAY OF U*COS(LAT) COEFFICIENTS
CL          V(KDIM2)  =OUTPUT ARRAY OF V*COS(LAT) COEFFICIENTS
CL          KTOUT     =OUTPUT TRIANGULAR TRUNCATION (KTOUT.LE.KTIN)
CL          KDIM2     =(KTOUT+1)*(KTOUT+4)
C
C     VERSION 1   5/1/81   JAN HASELER   ECMWF
C
C     VERSION 2   5/5/87   MODIFIED BY D. R. ROSKILLY
C     THIS MOD. DOES NOT CALCULATE THE EXTRA VALUES FOR
C     U AND V WINDS TO ALLOW VORT. AND DIV. TO BE RE-CALCULATED
C     IF REQUIRED.
C
C     Version 3  15/2/88   routine renamed VOD2UV from DVTOUV.
C
C     VERSION 4  21/8/91   MODIFIED BY K.RIDER
C
C     THIS MOD. WAS MADE BECAUSE VERSION 2 WAS INCONSISTENTLY
C     TRUNCATING U AND V TO T(ITOUT-1).
C     NOW VORT. AND DIV. ARE CONSISTENTLY TRUNCATED TO T105
C     AND U AND V ARE CALCULATED WITH TRUNCATION T(ITOUT),(WITH
C     ZERO VALUES AT THE CORNER. VORT. AND DIV. CAN BE RECALCULATED
C     IF REQUIRED, BUT ONLY TRUNCATED TO T(ITOUT) SINCE THE HIGHER
C     COEFFICIENTS HAVE BEEN LOST.
C
C----<
C
      COMPLEX VOR(1),DIV(1),U(1),V(1),ZI
C
      DD(PM,PN)=-SQRT((PN*PN-PM*PM)/(4.*PN*PN-1.))/PN
      SS(PM,PN)=-PM/(PN*(PN+1.))
C
      ZI=(0.,1.)
      REARTH=6.371E6
      K=1
      IMN=1
      ITOUT=MIN0(KTOUT,KTIN)
C
CL            1.1       M<ITOUT; N=M
 110  CONTINUE
      DO 155 JM=1,ITOUT
      ZM=JM-1.
      ZN=ZM
      IF (JM.EQ.1) GOTO 115
      U(K)=(-DD(ZM,ZN+1.)*VOR(IMN+1)+ZI*SS(ZM,ZN)*DIV(IMN))*REARTH
      V(K)=( DD(ZM,ZN+1.)*DIV(IMN+1)+ZI*SS(ZM,ZN)*VOR(IMN))*REARTH
      GOTO 120
C
 115  CONTINUE
      U(K)=(-DD(ZM,ZN+1.)*VOR(IMN+1))*REARTH
      V(K)=( DD(ZM,ZN+1.)*DIV(IMN+1))*REARTH
C
 120  CONTINUE
      IMN=IMN+1
      K=K+1
      JMP=JM+1
      IF (JMP.GT.ITOUT) GOTO 140
C
CL            1.3       M<ITOUT; N<ITOUT-1
 130  CONTINUE
      DO 135 JN=JMP,ITOUT-1
      ZN=JN-1.
      U(K)=( DD(ZM,ZN)*VOR(IMN-1)-DD(ZM,ZN+1)*VOR(IMN+1)
     1        +ZI*SS(ZM,ZN)*DIV(IMN))*REARTH
      V(K)=(-DD(ZM,ZN)*DIV(IMN-1)+DD(ZM,ZN+1)*DIV(IMN+1)
     1        +ZI*SS(ZM,ZN)*VOR(IMN))*REARTH
      K=K+1
 135  IMN=IMN+1
C
CL            1.3.1     M<ITOUT; N=ITOUT-1
 136  CONTINUE
      ZN=ITOUT-1
      U(K)=( DD(ZM,ZN)*VOR(IMN-1)+ZI*SS(ZM,ZN)*DIV(IMN))*REARTH
      V(K)=(-DD(ZM,ZN)*DIV(IMN-1)+ZI*SS(ZM,ZN)*VOR(IMN))*REARTH
      K=K+1
      IMN=IMN+1
C
CL            1.4       M<ITOUT; N=ITOUT
 140  CONTINUE
      ZN=ITOUT
      U(K)=( DD(ZM,ZN)*VOR(IMN-1))*REARTH
      V(K)=(-DD(ZM,ZN)*DIV(IMN-1))*REARTH
      K=K+1
C
CL            1.5       M<ITOUT; N=ITOUT+1
 150  CONTINUE
C--   ZN=ITOUT+1
C--   U(K)=( DD(ZM,ZN)*VOR(IMN))*REARTH
C--   V(K)=(-DD(ZM,ZN)*DIV(IMN))*REARTH
C--   K=K+1
      IMN=IMN+1+KTIN-ITOUT
 155  CONTINUE
C
CL            1.6       M=ITOUT; N=ITOUT
 160  CONTINUE
      U(K)=0.
      V(K)=0.
      K=K+1
C
CL            1.7       M=ITOUT; N=ITOUT+1
 170  CONTINUE
C--   ZN=ITOUT+1
C--   U(K)= DD(ZM,ZN)*VOR(IMN)*REARTH
C--   V(K)=-DD(ZM,ZN)*DIV(IMN)*REARTH
C
      RETURN
      END

C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      INTEGER FUNCTION IGLSIZE(KSTRIDE, KAREA, KNWE, KNNS, KLN,
     1   OWEGLOBE, ONPOLE, OSPOLE, KPR, KERR)
C
C---->
C**** *IGLSIZE*
C
C     PURPOSE
C     _______
C
C     Evaluate the array sizes for a regular latitude/longitude grid
C     and area.
C
C     INTERFACE
C     _________
C
C     IERR = IGLSIZE(KSTRIDE, KAREA, KNWE, KNNS, KLN, OWEGLOBE,
C    1   ONPOLE, OSPOLE, KPR, KERR)
C
C     Input parameters
C     ________________
C
C     KSTRIDE    - The field grid definition (WE, NS).
C
C     KAREA      - The field area definition (N, W, S, E) provided by
C                  the calling routine.
C
C     KNWE       - The number of points in the West-East direction in
C                  the field. This will be zero for an output field.
C
C     KNNS       - The number of points in the North-South direction
C                  in the field. This will be zero for an output field.
C
C     KPR        - The debug print switch.
C                  0  , No debugging output.
C                  1  , Produce debugging output.
C
C     KERR       - The error control flag.
C                  -ve, No error message. Return error code.
C                  0  , Hard failure with error message.
C                  +ve, Print error message. Return error code.
C
C     Output parameters
C     ________________
C
C     KNWE       - The number of points in the West-East direction in
C                  the field.
C
C     KNNS       - The number of points in the North-South direction
C                  in the field.
C
C     KLN        - The line number of the Northern latitude. This
C                  value is used during land sea mask processing to
C                  evaluate offsets in the "standard" files.
C
C     OWEGLOBE   - This variable will be true if the array of
C                  longitudes spans the globe.
C
C     ONPOLE     - This variable will be true if the North polar line
C                  of latitude is included in the grid.
C
C     OSPOLE     - This variable will be true if the South polar line
C                  of latitude is included in the grid.
C
C     Return value
C     ____________
C
C     The error indicator (INTEGER).
C
C     Error and Warning Return Values
C     _______________________________
C
C     -1    The West-East range does not match the stride and number
C           of points.
C     -2    The North-South range does not match the stride and
C           number of points.
C
C     The two problems above could be caused by known deficiencies
C     in the GRIB representation of ranges and strides. They will be
C     treated as WARNING values.
C
C     25101 A global field is requested with an inappropriate
C           West-East stride.
C     25102 A global field is requested with an inappropriate
C           North-South stride.
C
C     Common block usage
C     __________________
C
C     None
C
C     EXTERNALS
C     _________
C
C     INTLOG(R)    - Logs messages.
C
C     METHOD
C     ______
C
C     If all elements of array KAREA are zero then limits for the
C     appropriate global grid are generated.
C
C     Otherwise it is assumed that all the limits in KAREA have been
C     validated and the sizes of the arrays required are calculated.
C
C     REFERENCE
C     _________
C
C     None
C
C     COMMENTS
C     ________
C
C     Program contains sections 0 to 4 and 9
C
C     AUTHOR
C     ______
C
C     K. Fielding      *ECMWF*      Oct 1993
C
C     MODIFICATIONS
C     _____________
C
C     J.D.Chambers   ECMWF   March 1999
C     Use tolerance when testing E-W and N-S global span.
C
C----<
C     _______________________________________________________
C
C     Section 0. Definition of variables.
C     _______________________________________________________
C
      IMPLICIT NONE
C
#include "parim.h"
C
C     Function arguments
C
      LOGICAL OWEGLOBE, ONPOLE, OSPOLE
      INTEGER KNWE, KNNS, KLN, KPR, KERR
      INTEGER KSTRIDE(2), KAREA(4)
C
C     Parameters
C
      INTEGER JPROUTINE, JPEPSI
      PARAMETER (JPROUTINE = 25100)
      PARAMETER (JPEPSI = 50)
C                          `---> represents 0.5 millidegree to allow for
C                                grid step being off by upto 0.5 millidgrees
C
C
C     Local variables
C
      INTEGER IEAST, IWEST, IREACH, INORTH, ISOUTH
C
C     _______________________________________________________
C
C     Section 1. Initialisation
C     _______________________________________________________
C
  100 CONTINUE
C
      IF( KPR.GE.1 ) CALL INTLOG(JP_DEBUG,'IGLSIZE: Section 1.',JPQUIET)
C
      IGLSIZE = 0
C
      IF( KPR.GE.1 ) THEN
        CALL INTLOG(JP_DEBUG,'IGLSIZE: Input parameters.',JPQUIET)
         IF( KNWE.NE.0 ) CALL INTLOG(JP_DEBUG,
     X     'IGLSIZE: No.long pts = ',KNWE)
         IF( KNNS.NE.0 ) CALL INTLOG(JP_DEBUG,
     X     'IGLSIZE: No.lat. pts = ',KNNS)
        CALL INTLOG(JP_DEBUG,'IGLSIZE: Grid WE stride = ',KSTRIDE(1))
        CALL INTLOG(JP_DEBUG,'IGLSIZE: Grid NS stride = ',KSTRIDE(2))
        CALL INTLOG(JP_DEBUG,'IGLSIZE: Area North = ', KAREA(1))
        CALL INTLOG(JP_DEBUG,'IGLSIZE: Area West  = ', KAREA(2))
        CALL INTLOG(JP_DEBUG,'IGLSIZE: Area South = ', KAREA(3))
        CALL INTLOG(JP_DEBUG,'IGLSIZE: Area East  = ', KAREA(4))
      ENDIF
C
C     _______________________________________________________
C
C     Section 2. Generate global limits if no limits set
C     _______________________________________________________
C
  200 CONTINUE
C
      IF( KPR.GE.1 ) CALL INTLOG(JP_DEBUG,'IGLSIZE: Section 2.',JPQUIET)
C
      IF( (KAREA(JPEAST).EQ.0 )  .AND.
     X    (KAREA(JPWEST).EQ.0 )  .AND.
     X    (KAREA(JPNORTH).EQ.0 ) .AND.
     X    (KAREA(JPSOUTH).EQ.0 ) ) THEN
C
        IF( MOD(JP360,KSTRIDE(JPWESTEP)).NE.0 ) THEN
          IGLSIZE = JPROUTINE + 1
          IF( KERR.GE.0 ) THEN
            CALL INTLOGR(JP_ERROR,
     X        'IGLSIZE: West-East stride for global grid = ',
     X        REAL(KSTRIDE(JPWESTEP))/PPMULT)
            CALL INTLOGR(JP_ERROR,
     X        'IGLSIZE: This is not a factor of ',
     X        REAL(JP360)/PPMULT)
          ENDIF
C
          IF( KERR.EQ.0 ) CALL INTLOG(JP_FATAL,
     X      'IGLSIZE: Interpolation failed.',IGLSIZE)
C
          GO TO 900
        ENDIF
C
        IF( MOD(JP180,KSTRIDE(JPNSSTEP)).NE.0 ) THEN
          IGLSIZE = JPROUTINE + 2
          IF( KERR.GE.0 ) THEN
            CALL INTLOGR(JP_ERROR,
     X        'IGLSIZE: North-South stride for global grid = ',
     X        REAL(KSTRIDE(JPNSSTEP))/PPMULT)
            CALL INTLOGR(JP_ERROR,
     X        'IGLSIZE: This is not a factor of ',
     X        REAL(JP180)/PPMULT)
          ENDIF
C
          IF( KERR.EQ.0 ) CALL INTLOG(JP_FATAL,
     X      'IGLSIZE: Interpolation failed.',IGLSIZE)
C
          GO TO 900
        ENDIF
C
        KAREA(JPNORTH) = JP90
        KAREA(JPWEST) = 0
        KAREA(JPSOUTH) = - JP90
        KAREA(JPEAST) = JP360 - KSTRIDE(JPWESTEP)
C
      ENDIF
C
C     _______________________________________________________
C
C     Section 3. Standardise West-East limits and check for
C                West-East global fields
C     _______________________________________________________
C
  300 CONTINUE
C
      IF( KPR.GE.1 ) CALL INTLOG(JP_DEBUG,'IGLSIZE: Section 3.',JPQUIET)
C
C     Force both KAREA(JPWEST) and KAREA(JPEAST) into standard
C     range (0 to JP360)
C
      IF( KAREA(JPWEST).LT.0 ) KAREA(JPWEST) = KAREA(JPWEST) + JP360
C
      IF( KAREA(JPEAST).LT.0 ) KAREA(JPEAST) = KAREA(JPEAST) + JP360
C
C     Standardise range so that EAST > WEST
C
      IEAST = KAREA(JPEAST)
      IWEST = KAREA(JPWEST)
C
      IF( IEAST.LT.IWEST ) THEN
C
        IF( IEAST.LT.0 ) THEN
          IEAST = IEAST + JP360
          KAREA(JPEAST) = IEAST
        ELSE
          IWEST = IWEST - JP360
          KAREA(JPWEST) = IWEST
        ENDIF
C
      ENDIF
C
      IF( KNWE.EQ.0 ) THEN
C
C       Is it a global grid ?
C
        IREACH = IEAST - IWEST + KSTRIDE(JPWESTEP)
C
        OWEGLOBE = IREACH.GE.JP360
C
C       Number of points along line is
C
        KNWE = NINT( FLOAT(IREACH) / FLOAT(KSTRIDE(JPWESTEP)) )
C
      ELSE
C
C       Number of points is set (input field)
C
        IF( ABS(IWEST+(KNWE-1)*KSTRIDE(JPWESTEP)-IEAST).GT.
     X      ((KNWE-1)*JPEPSI) ) THEN
C
C         WARNING of possible mismatch
C
          IGLSIZE = - 1
          CALL INTLOGR(JP_WARN,
     X      'IGLSIZE: West-East range = ',REAL(KAREA(JPWEST))/PPMULT)
          CALL INTLOGR(JP_WARN,
     X      'IGLSIZE: to = ',REAL(KAREA(JPEAST))/PPMULT)
          CALL INTLOG(JP_WARN,
     X      'IGLSIZE: Does not match no. of pts = ',KNWE)
          CALL INTLOGR(JP_WARN,
     X      'IGLSIZE: and stride = ',REAL(KSTRIDE(JPWESTEP))/PPMULT)
C
        ENDIF
C
        OWEGLOBE = ABS((KNWE * KSTRIDE(JPWESTEP))-JP360).LT.
     X             (KNWE*JPEPSI)
C
      ENDIF
C
C     _______________________________________________________
C
C     Section 4. Generate points along a line of meridian
C     _______________________________________________________
C
  400 CONTINUE
C
      IF( KPR.GE.1 ) CALL INTLOG(JP_DEBUG,'IGLSIZE: Section 4.',JPQUIET)
C
      INORTH = KAREA(JPNORTH)
      ISOUTH = KAREA(JPSOUTH)
      IF( INORTH.LT.ISOUTH ) THEN
        INORTH = KAREA(JPSOUTH)
        ISOUTH = KAREA(JPNORTH)
      ENDIF
C
      IF( KNNS.EQ.0 ) THEN
C
C     Number of lines not set (output field)
C
        IREACH = INORTH - ISOUTH + KSTRIDE(JPNSSTEP)
C
        KNNS = NINT( FLOAT(IREACH) / FLOAT(KSTRIDE(JPNSSTEP)) )
C
      ELSE
C
C       Number of lines is set (input field)
C
        IF(
     X    ABS(INORTH-(KNNS-1)*KSTRIDE(JPNSSTEP)-ISOUTH)
     X    .GT.((KNNS-1)*JPEPSI) ) THEN
C
C     WARNING of possible mismatch
C
          IGLSIZE = - 2
          CALL INTLOGR(JP_WARN,
     X      'IGLSIZE: North-South range = ',REAL(INORTH)/PPMULT)
          CALL INTLOGR(JP_WARN,
     X      'IGLSIZE: to = ',REAL(ISOUTH)/PPMULT)
          CALL INTLOG(JP_WARN,
     X      'IGLSIZE: Does not match no. of pts = ',KNNS)
          CALL INTLOGR(JP_WARN,
     X      'IGLSIZE: and stride = ',REAL(KSTRIDE(JPNSSTEP))/PPMULT)
C
         ENDIF
C
      ENDIF
C
      KLN = (JP90 - INORTH ) / KSTRIDE(JPNSSTEP) + 1
C
C     Check if North and South poles within grid
C
      ONPOLE = INORTH.EQ.JP90
      OSPOLE = ISOUTH.EQ.(- JP90)
C
      IF( KPR.GE.1 ) THEN
        CALL INTLOG(JP_DEBUG,'IGLSIZE: Output parameters.',JPQUIET)
        IF( KNWE.NE.0 ) CALL INTLOG(JP_DEBUG,
     X    'IGLSIZE: No.long pts = ',KNWE)
        IF( KNNS.NE.0 ) CALL INTLOG(JP_DEBUG,
     X    'IGLSIZE: No.lat. pts = ',KNNS)
        CALL INTLOG(JP_DEBUG,'IGLSIZE: Northern line no. =',KLN)
C
        IF( OWEGLOBE ) THEN
          CALL INTLOG(JP_DEBUG,'IGLSIZE: W-E fld is global',JPQUIET)
        ELSE
          CALL INTLOG(JP_DEBUG,'IGLSIZE: W-E fld is NOT global',JPQUIET)
        ENDIF
C
        IF( ONPOLE ) THEN
          CALL INTLOG(JP_DEBUG,'IGLSIZE: N pole is in fld.',JPQUIET)
        ELSE
          CALL INTLOG(JP_DEBUG,'IGLSIZE: N pole is NOT in fld.',JPQUIET)
        ENDIF
C
        IF( OSPOLE ) THEN
          CALL INTLOG(JP_DEBUG,'IGLSIZE: S pole is in fld.',JPQUIET)
        ELSE
          CALL INTLOG(JP_DEBUG,'IGLSIZE: S pole is NOT in fld.',JPQUIET)
        ENDIF
C
      ENDIF
C
C     _______________________________________________________
C
C     Section 9. Return to calling routine. Format statements
C     _______________________________________________________
C
  900 CONTINUE
C
      IF( KPR.GE.1 ) CALL INTLOG(JP_DEBUG,'IGLSIZE: Section 9.',JPQUIET)
C
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE DDSTYLE(FIELD,IN_EW,IN_NS,OUT_EW,OUT_NS,KRET)
C
C---->
C**** DDSTYLE
C
C     Purpose
C     -------
C
C     Create a subgrid of an input regular latitude/longitude
C     grid by selecting points (dissemination style).
C
C
C     Interface
C     ---------
C
C     CALL DDSTYLE(FIELD,IN_EW,IN_NS,OUT_EW,OUT_NS,KRET)
C
C     Input
C     -----
C
C     FIELD   - Input regular latitude/longitude gridpoint field.
C     IN_EW   - East-west increment of input field (degrees * 10*5).
C     IN_NS   - North-south increment of input field (degrees * 10*5).
C     OUT_EW  - East-west increment of output field (degrees * 10*5).
C     OUT_NS  - North-south increment of output field (degrees * 10*5).
C
C
C     Output
C     ------
C
C     FIELD   - Output regular latitude/longitude gridpoint field.
C     KRET    - Return status code
C               0 = OK
C
C
C     Method
C     ------
C
C     Area boundaries for output field are adjusted (by shrinking)
C     if necessary to fit the grid.
C
C
C     Externals
C     ---------
C
C     INTLOG  - Logs output messages
C     JDEBUG  - Checks whether the debug flag is to be turned on.
C
C
C     Author
C     ------
C
C     J.D.Chambers     ECMWF     May 1999
C
C----<
C
      IMPLICIT NONE
C
#include "jparams.h"
#include "parim.h"
#include "nofld.common"
C
C     Subroutine arguments
C
      REAL FIELD(*)
      INTEGER IN_EW,IN_NS,OUT_EW,OUT_NS,KRET
C
C     Local variables
C
      INTEGER N, INC_EW,INC_NS,N_EW,N_NS,LOOPO,LOOPI,NEXT
      INTEGER NWEST,NEAST, NUM_EW
      REAL NORTH,WEST,SOUTH,EAST
      LOGICAL LDEBUG
C
C     Externals
C
C ------------------------------------------------------------------
C     Section 1. Initialise
C ------------------------------------------------------------------
C
  100 CONTINUE

      KRET = 0
C
      CALL JDEBUG( )
      LDEBUG = ( NDBG.GT.0 )
C
      IF( LDEBUG ) THEN
        CALL INTLOG(JP_DEBUG,'DDSTYLE: input E-W increment = ', IN_EW)
        CALL INTLOG(JP_DEBUG,'DDSTYLE: input N-S increment = ', IN_NS)
        CALL INTLOG(JP_DEBUG,'DDSTYLE: output E-W increment = ', OUT_EW)
        CALL INTLOG(JP_DEBUG,'DDSTYLE: output N-S increment = ', OUT_NS)
      ENDIF
C
C ------------------------------------------------------------------
C     Section 2. Check that output grid is a subset of the input grid.
C ------------------------------------------------------------------
C
  200 CONTINUE
C
C     Fixup input/output field area definitions according to grid
C     specification.
C
      NORTH = REAL(NOAREA(1)) / PPMULT
      WEST  = REAL(NOAREA(2)) / PPMULT
      SOUTH = REAL(NOAREA(3)) / PPMULT
      EAST  = REAL(NOAREA(4)) / PPMULT
C
      NWEST = NOAREA(2)
      NEAST = NOAREA(4)
      IF( NWEST.LT.0 ) NWEST = NWEST + 36000000
      IF( NEAST.LT.0 ) NEAST = NEAST + 36000000
      IF( NEAST.LT.NWEST ) NEAST = NEAST + 36000000
C
C     Check increments
C
      INC_EW = OUT_EW / IN_EW
      IF( (INC_EW*IN_EW).NE.OUT_EW ) THEN
         KRET = 1
        IF( LDEBUG ) THEN
          CALL INTLOG(JP_ERROR,
     X      'DDSTYLE: East-west step not multiple of input',JPQUIET)
          CALL INTLOG(JP_ERROR,'DDSTYLE: Requested step  = ',OUT_EW)
          CALL INTLOG(JP_ERROR,'DDSTYLE: Input GRIB step = ',IN_EW)
        ENDIF
        GOTO 900
      ENDIF
C
      INC_NS = OUT_NS / IN_NS
      IF( (INC_NS*IN_NS).NE.OUT_NS ) THEN
         KRET = 1
        IF( LDEBUG ) THEN
          CALL INTLOG(JP_ERROR,
     X     'DDSTYLE: North-south step not multiple of input',JPQUIET)
          CALL INTLOG(JP_ERROR,'DDSTYLE: Requested step  = ',OUT_NS)
          CALL INTLOG(JP_ERROR,'DDSTYLE: Input GRIB step = ',IN_NS)
        ENDIF
        GOTO 900
      ENDIF
C
      N_EW = ( (NEAST - NWEST) / OUT_EW ) + 1
      N_NS = ( (NOAREA(1) - NOAREA(3)) / OUT_NS ) + 1
C
      IF( LDEBUG ) THEN
        CALL INTLOG(JP_DEBUG,'DDSTYLE: No. of E_W output pts = ', N_EW)
        CALL INTLOG(JP_DEBUG,'DDSTYLE: No. of N-S output pts = ', N_NS)
      ENDIF
C
C ------------------------------------------------------------------
C     Section 3. Generate new grid.
C ------------------------------------------------------------------
C
  300 CONTINUE
C
C     Select points for new grid.
C
      NUM_EW = NINT((EAST-WEST)*PPMULT)/IN_EW + 1
C
      NEXT = 1
      DO LOOPO = 1, N_NS*INC_NS, INC_NS
        N = (LOOPO-1)*NUM_EW
        DO LOOPI = 1, N_EW*INC_EW, INC_EW
          FIELD(NEXT) = FIELD(N+LOOPI)
          NEXT = NEXT + 1
        ENDDO
      ENDDO
C
C ------------------------------------------------------------------
C     Section 9. Return.
C ------------------------------------------------------------------
C
  900 CONTINUE
C
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities
C granted to it by virtue of its status as an intergovernmental organisation
C nor does it submit to any jurisdiction.
C

      SUBROUTINE JREADGG( KUNIT, KTRUNC, KROW, PLEG, KRET)
C
C---->
C**** JREADGG
C
C     PURPOSE
C     _______
C
C     This routine reads legendre functions for one latitude.
C
C     INTERFACE
C     _________
C
C     CALL JREADGG( KUNIT, KTRUNC, KROW, PLEG, KRET)
C
C     Input parameters
C     ________________
C
C     KUNIT   - Unit number for open file of legendre functions.
C     KTRUNC  - Truncation.
C     KROW    - Latitude row number in the file
C
C     Output parameters
C     ________________
C
C     PLEG     - Array of legendre functions for the latitude.
C     KRET     - Return status code
C                0 = OK
C
C     Common block usage
C     __________________
C
C     None.
C
C     Method
C     ______
C
C     Calculate offset of the legendre functions for the latitude row
C     in the file, skip to the row and read the functions.
C
C     Retries the read upto 3 times if necessary
C
C     Externals
C     _________
C
C     PBSEEK    - Position the coefficients file
C     PBREAD    - Read the coefficients file
C     INTLOG   - Output log message
C
C     Reference
C     _________
C
C     None.
C
C     Comments
C     ________
C
C     Only positive row numbers are allowed.
C
C     AUTHOR
C     ______
C
C     J.D.Chambers      *ECMWF*      Jan 1994
C
C     MODIFICATIONS
C     _____________
C
C     None.
C
C----<
C     _______________________________________________________
C
      IMPLICIT NONE
#include "jparams.h"
#include "parim.h"
C
C     Subroutine arguments
C
      INTEGER KUNIT, KTRUNC, KROW, KRET
      REAL PLEG
      DIMENSION PLEG(*)
C
C     Parameters
      INTEGER JPROUTINE
      PARAMETER ( JPROUTINE = 31000 )
C
C     Local variables
C
      INTEGER NTRIES
      INTEGER   NRET, NSIZE
      INTEGER*8 FRET, FSIZE
      INTEGER*8 NEWPOS, OLDPOS

      DATA OLDPOS/-1/
      SAVE NEWPOS, OLDPOS
C
C     _______________________________________________________
C
C*    Section 1.    Initialization.
C     _______________________________________________________
C
100   CONTINUE
      IF ( KROW .LT. 0 ) THEN
        CALL INTLOG(JP_ERROR,'JREADGG: negative row number given',KROW)
        KRET = JPROUTINE + 1
        GOTO 990
      ENDIF
C
C     Calculate the byte offset into the file where the legendre
C     functions for the latitude should be.
#ifdef REAL_8
      NSIZE   = 8 * (KTRUNC+1)*(KTRUNC+4)/2
      FSIZE   = 8 * (KTRUNC+1)*(KTRUNC+4)/2
#else
      NSIZE   = 4 * (KTRUNC+1)*(KTRUNC+4)/2
      FSIZE   = 4 * (KTRUNC+1)*(KTRUNC+4)/2
#endif
cs      NEWPOS = (KROW - 1) * NSIZE
      NEWPOS = (KROW - 1) * FSIZE
C
C     _______________________________________________________
C
C*    Section 2.    Processing.
C     _______________________________________________________
C
C     Position file unless the previous read left it in the correct
C     position already
C
      NTRIES = 0
 210  CONTINUE
      NTRIES = NTRIES + 1
      IF ( NEWPOS .NE. OLDPOS ) THEN
        CALL PBSEEK64( KUNIT, NEWPOS, 0, FRET)
        IF ( FRET .NE. NEWPOS ) THEN
          CALL INTLOG(JP_ERROR,'JREADGG: PBSEEK64 error.',FRET)
          KRET = JPROUTINE + 2
          GOTO 990
        ENDIF
      ENDIF
C
C     Read the legendre coefficients
      CALL PBREAD( KUNIT, PLEG, NSIZE, NRET)
      IF ( NRET .NE. NSIZE ) THEN
        IF ( NTRIES .EQ. JPMXTRY ) THEN
          CALL INTLOG(JP_ERROR,'JREADGG: PBREAD error.',NRET)
          KRET = JPROUTINE + 3
          GOTO 990
        ELSE
          GOTO 210
        ENDIF
      ENDIF
C
C     Record the current file byte position
      OLDPOS = NEWPOS + NSIZE
C     _______________________________________________________
C
C*    Section 9. Return to calling routine. Format statements
C     _______________________________________________________
C
 900  CONTINUE
      KRET = 0
C
 990  CONTINUE
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities
C granted to it by virtue of its status as an intergovernmental organisation
C nor does it submit to any jurisdiction.
C

      INTEGER FUNCTION HIRLAM(L12PNT,OLDFLD,KOUNT,KGAUSS,
     X  HTYPE,AREA,POLE,GRID,NEWFLD,KSIZE,NLON,NLAT)
C
C---->
C**** HIRLAM
C
C     Purpose
C     -------
C
C     This routine creates a rotated regular lat/long field from a
C     gaussian field using 12-point horizontal interpolation.
C
C
C     Interface
C     ---------
C
C     IRET = HIRLAM(L12PNT,OLDFLD,KOUNT,KGAUSS,HTYPE,AREA,POLE,GRID,
C    X              NEWFLD,KSIZE,NLON,NLAT)
C
C
C     Input parameters
C     ----------------
C
C     L12PNT - Chooses between 12-point and 4-point interpolation
C              = .TRUE. for 12-point horizontal
C              = .FALSE. for 4-point
C     OLDFLD - Array of values from the (old) gaussian field
C     KOUNT  - Number of values in OLDFLD
C     KGAUSS - Gaussian grid number
C     HTYPE  - Gaussian grid type
C              = 'R' for reduced ("quasi-regular"),
C              = 'O' for reduced/octahedral,
C              = 'F' for full,
C              = 'U' for a user-defined gaussian grid
C     AREA   - Limits of output area (N/W/S/E)
C     POLE   - Pole of rotation (lat/long)
C     GRID   - Output lat/long grid increments (we/ns)
C     KSIZE  - The size of the output array to fill with the regular
C              lat/long field
C
C
C     Output parameters
C     -----------------
C
C     NEWFLD - The array of values for the regular lat/long field
C     NLON   - Number of longitudes in the regular lat/long field
C     NLAT   - Number of latitudes in the regular lat/long field
C
C     Returns 0 if function successful, non-zero otherwise.
C
C     Common block usage
C     ------------------
C
C     nifld.common
C     nofld.common
C
C
C     Method
C     ------
C
C     Numbering of the points (I is the interpolation point):
C
C                   13       5       6      14
C
C                    7       1       2       8
C                               (I)
C                    9       3       4      10
C
C                   15      11      12      16
C
C     The 12-point interpolation is not possible if either of the top
C     two rows is above the original field northern latitude. The
C     nearest neighbour is used if both rows are above, and a 4-pt
C     bilinear interpolation is used if the top row is above.
C     Similarily, if either of the bottom two rows is below the original
C     field southern latitude.
C
C
C     Externals
C     ---------
C
C     INTLOG  - Logs messages
C     JGETGG  - Reads the definition of a gaussian grid
C     HGENGRD - Calculates original lat/long (before rotation) for
C               a rotated grid
C     HNEI12  - Finds neighbours for points for interpolation
C     HWTS12  - Calculates weightings for points for interpolation
C     CHKPREC - Check if precipitation threshold has been redefined
C     FORCED_NEAREST_NEIGHBOUR - check forced interpolation method
C     HIRLAM_USERSPACE_1_GET   - HIRLAM userspace memory #1
C     HIRLAM_USERSPACE_2_GET   - HIRLAM userspace memory #2
C     HIRLAM_USERSPACE_3_GET   - HIRLAM userspace memory #3
C
C
C     Reference
C     ---------
C
C     None.
C
C
C     Comments
C     --------
C
C     None.
C
C
C     Author
C     ------
C
C     J.D.Chambers      ECMWF      January 2001
C
C
C     Modifications
C     -------------
C
C     None.
C
C----<
C     -----------------------------------------------------------------|
C*    Section 0. Definition of variables.
C     -----------------------------------------------------------------|
C
      IMPLICIT NONE
C
#include "parim.h"
#include "nifld.common"
#include "nofld.common"
#include "grfixed.h"
C
C     Parameters
C
      INTEGER JNORTH, JSOUTH, JWEST, JEAST, JW_E, JN_S
      INTEGER JP12PT, JP4PT
      PARAMETER (JP12PT = 0)
      PARAMETER (JP4PT  = 1)
      PARAMETER (JNORTH = 1)
      PARAMETER (JWEST  = 2)
      PARAMETER (JSOUTH = 3)
      PARAMETER (JEAST  = 4)
      PARAMETER (JW_E   = 1)
      PARAMETER (JN_S   = 2)
C
C     Function arguments
C
      LOGICAL L12PNT
      INTEGER KOUNT, KGAUSS, KSIZE, NLON, NLAT
      REAL AREA(4), POLE(2), GRID(2)
      REAL OLDFLD(*), NEWFLD(KSIZE)
      CHARACTER*1 HTYPE
C
C     Local variables
C
      INTEGER NEXT, LOOP, IRET, NLEN, NBYTES, NUMBER
      INTEGER NEAREST, NEND, COUNT
      INTEGER NJPR,  NJPB
      INTEGER NGSPEC_TMP
      INTEGER IOGAUSS,IOREPR
      CHARACTER*1 HTYPE_TMP
C
      INTEGER KSCHEME(1),NEIGH(12,1), KLA(1)
      REAL PWTS(12,1)
      POINTER (IPKSCHE, KSCHEME)
      POINTER (IPNEIGH, NEIGH)
      POINTER (IPKLA,   KLA)
      POINTER (IPPWTS,  PWTS)
      LOGICAL LVEGGY
C
      REAL PDLO0(1),PDLO1(1),PDLO2(1),PDLO3(1),PDLAT(1)
      POINTER (IPPDLO0, PDLO0)
      POINTER (IPPDLO1, PDLO1)
      POINTER (IPPDLO2, PDLO2)
      POINTER (IPPDLO3, PDLO3)
      POINTER (IPPDLAT, PDLAT)
C
      INTEGER IGG
      INTEGER KPTS(1)
      REAL GLATS(1)
      INTEGER IOFFS(1)
      POINTER (IPKPTS,  KPTS)
      POINTER (IPIOFFS, IOFFS)
      POINTER (IPGLATS, GLATS)
C
      INTEGER ILL
      REAL RLAT(1),RLON(1)
      POINTER (IPRLAT, RLAT)
      POINTER (IPRLON, RLON)
C
      REAL OLD(KOUNT)
C
      CHARACTER*7 FNAME
      PARAMETER  (FNAME = 'HIRLAM ')
C
      DATA NUMBER/-1/,IOGAUSS/-1/,IOREPR/-1/
C
      SAVE IPKSCHE, IPNEIGH, IPKLA, IPPWTS
      SAVE IPPDLO0, IPPDLO1, IPPDLO2, IPPDLO3, IPPDLAT
      SAVE IPKPTS, IPIOFFS, IPGLATS
      SAVE IPRLAT, IPRLON
      SAVE NUMBER, IOGAUSS, IOREPR
C
C     Externals
C
      LOGICAL FORCED_NEAREST_NEIGHBOUR
      LOGICAL ISOCTAHEDRAL
      INTEGER HNEI12
      INTEGER HGENGRD
#ifdef POINTER_64
      INTEGER*8
#else
      INTEGER
#endif
     X  HIRLAM_USERSPACE_1_GET,
     X  HIRLAM_USERSPACE_2_GET,
     X  HIRLAM_USERSPACE_3_GET
C
C     Statement functions
C
      REAL A, B
      LOGICAL NOTEQ
C
C     Tests that A is not (almost) equal to B
C
      NOTEQ(A,B) = (ABS((A)-(B)).GT.(ABS(A)*1E-3))
C
C     -----------------------------------------------------------------|
C     Section 1.  Initialise.
C     -----------------------------------------------------------------|
C
  100 CONTINUE
C
      HIRLAM = 0
C
      CALL JDEBUG()
C
      IF( L12PNT ) THEN
        CALL INTLOG(JP_DEBUG,FNAME//': 12-pt interpolation',JPQUIET)
      ELSE
        CALL INTLOG(JP_DEBUG,FNAME//': 4-pt interpolation',JPQUIET)
      ENDIF
C
      CALL CHKPREC()
      IF( LPREC )THEN
        CALL INTLOG(JP_DEBUG,
     X    FNAME//': precipitation threshold applied',JPQUIET)
      ELSE
        CALL INTLOG(JP_DEBUG,
     X    FNAME//': precipitation threshold not applied',JPQUIET)
      ENDIF

      IF( HTYPE.NE.'O' .AND. HTYPE.NE.'R' .AND. HTYPE.NE.'U'
     X .AND. HTYPE.NE.'F' ) THEN
        CALL INTLOG(JP_ERROR,
     X    FNAME//': Gaussian type unsupported ('//HTYPE//')',JPQUIET)
        HIRLAM = 1
        GOTO 900
      ENDIF

C     Set interpolation method (use nearest neighbour if required)
      LVEGGY = FORCED_NEAREST_NEIGHBOUR(LMETHOD,NITABLE,NIPARAM)
      IF( LVEGGY ) CALL INTLOG(JP_DEBUG,
     X  FNAME//': nearest neighbour processing',JPQUIET)


C
C     Dynamically allocate memory for gaussian grid information.
C
      IGG = KGAUSS*2
      NBYTES = (IGG*JPRLEN) + (2*IGG+1)*JPBYTES
C
      IPKPTS = HIRLAM_USERSPACE_1_GET(NBYTES)
#ifdef hpR64
      IPKPTS = IPKPTS/(1024*1024*1024*4)
#endif
      IF( IPKPTS.EQ.0 ) THEN
        CALL INTLOG(JP_ERROR,
     X    FNAME//': Memory allocate fail',JPQUIET)
        HIRLAM = 1
        GOTO 900
      ENDIF
C
      IPGLATS = IPKPTS  + (IGG*JPBYTES)
      IPIOFFS = IPGLATS + (IGG*JPRLEN)
C
      IOGAUSS = -1
      IOREPR  = -1
C
C     Build up offsets to start of each latitude in original field(s)
C
      IF( (KGAUSS.NE.IOGAUSS).OR.(IOREPR.NE.NIREPR) ) THEN
        CALL INTLOG(JP_DEBUG,FNAME//': trying Gaussian '//HTYPE,KGAUSS)
        CALL JGETGG(KGAUSS,HTYPE,GLATS,KPTS,IRET)
        IF( IRET.NE.0 ) THEN
          CALL INTLOG(JP_ERROR,
     X      FNAME//': JGETGG failed to get gaussian data',JPQUIET)
          HIRLAM = 2
          GOTO 900
        ENDIF
C
        IOFFS(1) = 1
        DO LOOP = 2, (KGAUSS*2+1)
          IOFFS(LOOP) = IOFFS(LOOP-1) + KPTS(LOOP-1)
        ENDDO
C
C
C       Check whether number of gaussian points agrees with grid specification.
C       If not and grid is N80/N160 non-octahedral, try the 12-pt specification.
C
        NUMBER = (IOFFS(KGAUSS*2+1) - 1)
        IF( NUMBER.NE.KOUNT ) THEN
          IF( (KGAUSS.EQ.80).OR.(KGAUSS.EQ.160) .AND.
     X        (NIREPR.EQ.JPQUASI) .AND.
     X        (.NOT. ISOCTAHEDRAL(NIGAUSS,MILLEN)) ) THEN
            NGSPEC_TMP = NGSPEC
            NGSPEC = 12
            HTYPE_TMP = 'F'
            IF( NIREPR.EQ.JPQUASI ) HTYPE_TMP = 'R'
            CALL INTLOG(JP_DEBUG,
     X        FNAME//': trying 12-pt Gaussian '//HTYPE_TMP,KGAUSS)
            CALL JGETGG(KGAUSS,HTYPE_TMP,GLATS,KPTS,IRET)
            NGSPEC = NGSPEC_TMP
C
            IF( IRET.NE.0 ) THEN
              CALL INTLOG(JP_ERROR,
     X          FNAME//': JGETGG failed to get gaussian data',JPQUIET)
              HIRLAM = 2
              GOTO 900
            ENDIF
C
            IOFFS(1) = 1
            DO LOOP = 2, (KGAUSS*2+1)
              IOFFS(LOOP) = IOFFS(LOOP-1) + KPTS(LOOP-1)
            ENDDO
C
            NUMBER = (IOFFS(KGAUSS*2+1) - 1)
            IF( NUMBER.NE.KOUNT ) THEN
           CALL INTLOG(JP_ERROR,FNAME//': Given no. of points =',KOUNT)
           CALL INTLOG(JP_ERROR,FNAME//': Expected no. of pts =',NUMBER)
              HIRLAM = 4
              GOTO 900
            ENDIF
C
          ELSE
C
           CALL INTLOG(JP_ERROR,FNAME//': Given no. of points =',KOUNT)
           CALL INTLOG(JP_ERROR,FNAME//': Expected no. of pts =',NUMBER)
            HIRLAM = 4
            GOTO 900
          ENDIF
        ENDIF
C
        IOGAUSS = KGAUSS
        IOREPR  = NIREPR
      ENDIF
C
C     Preserve the input field
C     (in case OLDFLD and NEWFLD are the same arrays)
C
      NUMBER = (IOFFS(KGAUSS*2+1) - 1)
      OLD(1:NUMBER) = OLDFLD(1:NUMBER)
C
C     -----------------------------------------------------------------|
C     Section 2.  Generate the lat/long points for the output grid
C     -----------------------------------------------------------------|
C
  200 CONTINUE
C
C (DJ Mar-05)
      NLON = 1 + NINT((AREA(JEAST) - AREA(JWEST)) / GRID(JW_E))
      NLAT = 1 + NINT((AREA(JNORTH) - AREA(JSOUTH)) / GRID(JN_S))
C
      NLEN = NLON * NLAT

      NOWE = NLON
      NONS = NLAT
C
C     Check that given array is big enough for the new field.
C
      IF( NLEN.GT.KSIZE ) THEN
        CALL INTLOG(JP_ERROR,FNAME//': Given array size = ',KSIZE)
        CALL INTLOG(JP_ERROR,FNAME//': Required size = = ',NLEN)
        HIRLAM = 5
        GOTO 900
      ENDIF
C
C     Dynamically allocate memory for lat/long arrays.
C
      ILL = NLEN
      NBYTES = 2*ILL*JPRLEN
C
      IPRLON = HIRLAM_USERSPACE_2_GET(NBYTES)
#ifdef hpR64
      IPRLON = IPRLON/(1024*1024*1024*4)
#endif
      IF( IPRLON.EQ.0 ) THEN
        CALL INTLOG(JP_ERROR,
     X    FNAME//': Memory allocate fail',JPQUIET)
        HIRLAM = 6
        GOTO 900
      ENDIF
C
      IPRLAT  = IPRLON + (ILL*JPRLEN)
C
      IRET = HGENGRD(AREA,POLE,GRID,NLON,NLAT,RLAT,RLON)
      IF( IRET.NE.0 ) THEN
        CALL INTLOG(JP_ERROR,
     X    FNAME//': HGENGRD failed to get lat/lon grid data',JPQUIET)
        HIRLAM = 7
        GOTO 900
      ENDIF
C
C     -----------------------------------------------------------------|
C     Section 3.  Find neighbours for each point for interpolation.
C     -----------------------------------------------------------------|
C
  300 CONTINUE
C
C     Dynamically allocate memory for interpolation arrays.
C
      NJPR=17
      NJPB=14
      NBYTES = (NJPR*JPRLEN + NJPB*JPBYTES) * ILL
C
      IPPDLO0 = HIRLAM_USERSPACE_3_GET(NBYTES)
#ifdef hpR64
      IPPDLO0 = IPPDLO0/(1024*1024*1024*4)
#endif
      IF( IPPDLO0.EQ.0 ) THEN
        CALL INTLOG(JP_ERROR,
     X    FNAME//': Memory allocate fail',JPQUIET)
        HIRLAM = 8
        GOTO 900
      ENDIF
C
      IPPDLO1 = IPPDLO0 + (ILL*JPRLEN)
      IPPDLO2 = IPPDLO1 + (ILL*JPRLEN)
      IPPDLO3 = IPPDLO2 + (ILL*JPRLEN)
      IPPDLAT = IPPDLO3 + (ILL*JPRLEN)
      IPPWTS  = IPPDLAT + (ILL*JPRLEN)
      IPKSCHE = IPPWTS  + (12*ILL*JPRLEN)
      IPKLA   = IPKSCHE + (ILL*JPBYTES)
      IPNEIGH = IPKLA   + (ILL*JPBYTES)
C
C     Find neighbours.
C
      IRET = HNEI12(L12PNT,NLEN,RLAT,RLON,KGAUSS,KPTS,GLATS,
     X              KSCHEME,PDLAT,PDLO0,PDLO1,PDLO2,PDLO3,KLA,NEIGH)
      IF( IRET.NE.0 ) THEN
        CALL INTLOG(JP_ERROR,
     X    FNAME//': HNEI12 failed to find neighbours',JPQUIET)
        HIRLAM = 9
        GOTO 900
      ENDIF
C
C     -----------------------------------------------------------------|
C     Section 4.  Perform the 12-point horizontal interpolation.
C     -----------------------------------------------------------------|
C
  400 CONTINUE
C
C     Setup the 12-point horizontal interpolation weights
C
      CALL HWTS12
     X  (NLEN,KSCHEME,KLA,PDLAT,GLATS,PDLO0,PDLO1,PDLO2,PDLO3,NEIGH,
     X   PWTS)
C
C     Calculate the interpolated grid point values
C
      DO LOOP = 1, NLEN
        IF( KSCHEME(LOOP).EQ.JP12PT ) THEN
C
C     See if any of the neighbours are missing
C
          COUNT = 0
          IF( NOTEQ(OLD(NEIGH( 1,LOOP)),RMISSGV) ) COUNT = COUNT + 1
          IF( NOTEQ(OLD(NEIGH( 2,LOOP)),RMISSGV) ) COUNT = COUNT + 1
          IF( NOTEQ(OLD(NEIGH( 3,LOOP)),RMISSGV) ) COUNT = COUNT + 1
          IF( NOTEQ(OLD(NEIGH( 4,LOOP)),RMISSGV) ) COUNT = COUNT + 1
          IF( NOTEQ(OLD(NEIGH( 5,LOOP)),RMISSGV) ) COUNT = COUNT + 1
          IF( NOTEQ(OLD(NEIGH( 6,LOOP)),RMISSGV) ) COUNT = COUNT + 1
          IF( NOTEQ(OLD(NEIGH( 7,LOOP)),RMISSGV) ) COUNT = COUNT + 1
          IF( NOTEQ(OLD(NEIGH( 8,LOOP)),RMISSGV) ) COUNT = COUNT + 1
          IF( NOTEQ(OLD(NEIGH( 9,LOOP)),RMISSGV) ) COUNT = COUNT + 1
          IF( NOTEQ(OLD(NEIGH(10,LOOP)),RMISSGV) ) COUNT = COUNT + 1
          IF( NOTEQ(OLD(NEIGH(11,LOOP)),RMISSGV) ) COUNT = COUNT + 1
          IF( NOTEQ(OLD(NEIGH(12,LOOP)),RMISSGV) ) COUNT = COUNT + 1
C
C         Interpolate using twelve neighbours if none are missing
C
        IF( LVEGGY) THEN
            NEAREST = 1
            IF( PWTS( 2,LOOP).GT.PWTS(NEAREST,LOOP) ) NEAREST = 2
            IF( PWTS( 3,LOOP).GT.PWTS(NEAREST,LOOP) ) NEAREST = 3
            IF( PWTS( 4,LOOP).GT.PWTS(NEAREST,LOOP) ) NEAREST = 4
            IF( PWTS( 5,LOOP).GT.PWTS(NEAREST,LOOP) ) NEAREST = 5
            IF( PWTS( 6,LOOP).GT.PWTS(NEAREST,LOOP) ) NEAREST = 6
            IF( PWTS( 7,LOOP).GT.PWTS(NEAREST,LOOP) ) NEAREST = 7
            IF( PWTS( 8,LOOP).GT.PWTS(NEAREST,LOOP) ) NEAREST = 8
            IF( PWTS( 9,LOOP).GT.PWTS(NEAREST,LOOP) ) NEAREST = 9
            IF( PWTS(10,LOOP).GT.PWTS(NEAREST,LOOP) ) NEAREST =10
            IF( PWTS(11,LOOP).GT.PWTS(NEAREST,LOOP) ) NEAREST =11
            IF( PWTS(12,LOOP).GT.PWTS(NEAREST,LOOP) ) NEAREST =12
            NEWFLD(LOOP) = OLD(NEIGH( NEAREST,LOOP))
        ELSE
          IF( COUNT.EQ.12) THEN
            NEWFLD(LOOP) =
     X        OLD(NEIGH( 1,LOOP)) * PWTS( 1,LOOP) +
     X        OLD(NEIGH( 2,LOOP)) * PWTS( 2,LOOP) +
     X        OLD(NEIGH( 3,LOOP)) * PWTS( 3,LOOP) +
     X        OLD(NEIGH( 4,LOOP)) * PWTS( 4,LOOP) +
     X        OLD(NEIGH( 5,LOOP)) * PWTS( 5,LOOP) +
     X        OLD(NEIGH( 6,LOOP)) * PWTS( 6,LOOP) +
     X        OLD(NEIGH( 7,LOOP)) * PWTS( 7,LOOP) +
     X        OLD(NEIGH( 8,LOOP)) * PWTS( 8,LOOP) +
     X        OLD(NEIGH( 9,LOOP)) * PWTS( 9,LOOP) +
     X        OLD(NEIGH(10,LOOP)) * PWTS(10,LOOP) +
     X        OLD(NEIGH(11,LOOP)) * PWTS(11,LOOP) +
     X        OLD(NEIGH(12,LOOP)) * PWTS(12,LOOP)
C
C         Set missing if all neighbours are missing
C
          ELSE IF( COUNT.EQ.0 ) THEN
            NEWFLD(LOOP) = RMISSGV
C
C         Otherwise, use the nearest neighbour
C
          ELSE
            NEAREST = 1
            IF( PWTS( 2,LOOP).GT.PWTS(NEAREST,LOOP) ) NEAREST = 2
            IF( PWTS( 3,LOOP).GT.PWTS(NEAREST,LOOP) ) NEAREST = 3
            IF( PWTS( 4,LOOP).GT.PWTS(NEAREST,LOOP) ) NEAREST = 4
            IF( PWTS( 5,LOOP).GT.PWTS(NEAREST,LOOP) ) NEAREST = 5
            IF( PWTS( 6,LOOP).GT.PWTS(NEAREST,LOOP) ) NEAREST = 6
            IF( PWTS( 7,LOOP).GT.PWTS(NEAREST,LOOP) ) NEAREST = 7
            IF( PWTS( 8,LOOP).GT.PWTS(NEAREST,LOOP) ) NEAREST = 8
            IF( PWTS( 9,LOOP).GT.PWTS(NEAREST,LOOP) ) NEAREST = 9
            IF( PWTS(10,LOOP).GT.PWTS(NEAREST,LOOP) ) NEAREST =10
            IF( PWTS(11,LOOP).GT.PWTS(NEAREST,LOOP) ) NEAREST =11
            IF( PWTS(12,LOOP).GT.PWTS(NEAREST,LOOP) ) NEAREST =12
            NEWFLD(LOOP) = OLD(NEIGH( NEAREST,LOOP))
          ENDIF
        ENDIF
C
        ELSE IF( KSCHEME(LOOP).EQ.JP4PT ) THEN
C
C     See if any of the neighbours are missing
C
          COUNT = 0
          IF( NOTEQ(OLD(NEIGH( 1,LOOP)),RMISSGV) ) COUNT = COUNT + 1
          IF( NOTEQ(OLD(NEIGH( 2,LOOP)),RMISSGV) ) COUNT = COUNT + 1
          IF( NOTEQ(OLD(NEIGH( 3,LOOP)),RMISSGV) ) COUNT = COUNT + 1
          IF( NOTEQ(OLD(NEIGH( 4,LOOP)),RMISSGV) ) COUNT = COUNT + 1
C
C         Interpolate using four neighbours if none are missing
C
c          IF( COUNT.EQ.4.AND.LVEGGY.EQV.(.FALSE.) ) THEN
        IF( LVEGGY) THEN

            NEAREST = 1
            IF( PWTS( 2,LOOP).GT.PWTS(NEAREST,LOOP) ) NEAREST = 2
            IF( PWTS( 3,LOOP).GT.PWTS(NEAREST,LOOP) ) NEAREST = 3
            IF( PWTS( 4,LOOP).GT.PWTS(NEAREST,LOOP) ) NEAREST = 4
            NEWFLD(LOOP) = OLD(NEIGH( NEAREST,LOOP))

        ELSE
          IF( COUNT.EQ.4) THEN
            NEWFLD(LOOP) =
     X        OLD(NEIGH( 1,LOOP)) * PWTS( 1,LOOP) +
     X        OLD(NEIGH( 2,LOOP)) * PWTS( 2,LOOP) +
     X        OLD(NEIGH( 3,LOOP)) * PWTS( 3,LOOP) +
     X        OLD(NEIGH( 4,LOOP)) * PWTS( 4,LOOP)
C
C         Set missing if all neighbours are missing
C
          ELSE IF( COUNT.EQ.0 ) THEN
            NEWFLD(LOOP) = RMISSGV
C
C         Otherwise, use the nearest neighbour
C
          ELSE
            NEAREST = 1
            IF( PWTS( 2,LOOP).GT.PWTS(NEAREST,LOOP) ) NEAREST = 2
            IF( PWTS( 3,LOOP).GT.PWTS(NEAREST,LOOP) ) NEAREST = 3
            IF( PWTS( 4,LOOP).GT.PWTS(NEAREST,LOOP) ) NEAREST = 4
            NEWFLD(LOOP) = OLD(NEIGH( NEAREST,LOOP))
          ENDIF
       ENDIF
C
        ELSE
          DO NEXT = 1, 4
            IF( NEIGH(NEXT,LOOP).NE.0 )
     X        NEWFLD(LOOP) = OLD(NEIGH(NEXT,LOOP))
          ENDDO
C
        ENDIF
C
C       Remove precipitation if less than a 'trace' or if nearest
C       neighbour is less than a trace
C
        IF( LPREC ) THEN
          IF( NEWFLD(LOOP).LT.ZPRECIP ) THEN
            NEWFLD(LOOP) = 0.0
          ELSE
            NEAREST = 1
            NEND = 12
            IF( KSCHEME(LOOP).NE.JP12PT ) NEND = 4
            DO NEXT = 2, NEND
              IF( PWTS( NEXT,LOOP).GT.PWTS( NEAREST,LOOP) )
     X          NEAREST = NEXT
            ENDDO
            IF( OLD(NEIGH(NEAREST,LOOP)).LT.ZPRECIP ) NEWFLD(LOOP) = 0.0
          ENDIF
        ENDIF
C
      ENDDO
C
C     -----------------------------------------------------------------|
C     Section 9.  Return.
C     -----------------------------------------------------------------|
C
  900 CONTINUE
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C


      SUBROUTINE GETIB1 (KLIB1,KIB1,KLENG,KARRAY,KPR,KRET)
C
C---->
C**** GETIB1 - Get values from section 1 of GRIB code.
C
C     Purpose.
C     --------
C
C           Get integer values from section 1 of unpacked GRIB or
C           pseudo-GRIB records, retrieved from MARS.
C
C**   Interface.
C     ----------
C
C           CALL GETIB1 (KLIB1,KIB1,KLENG,KARRAY,KPR,KRET)
C
C           INTEGER    K.
C           REAL       P.
C           LOGICAL    O.
C           CHARACTER  H.
C
C               Input parameters.
C               -----------------
C
C               KIB1       - Array to receive section 1 values.
C               KLENG      - Length of this array.
C               KARRAY     - Array containing unpacked record.
C               KPR        - Debug print switch.
C                            0 , No printout.
C                            1 , Debug printout.
C                            2 , Print section 1 values.
C
C               KRET       - Abort/no abort when error found.
C                            0   , Abort if error found.
C                            Non-zero , no abort when error found.
C
C               Output parameters.
C               ------------------
C
C               KIB1       - Array containing values from section 1.
C               KLIB1      - Number of values in this array.
C               KRET       - Error return code.
C                            0   , No error encountered.
C                            1   , Target array too small.
C
C     Method.
C     -------
C
C           Unpacked data is in self defining records. The required
C           values are located and extracted.
C
C     Externals.
C     ----------
C
C           PRTBK1
C
C     Reference.
C     ----------
C
C           See MARS format documentation re GRIB, pseudo-GRIB and
C           unpacked formats.
C
C     Comments.
C     ---------
C
C           Program contains sections 0 to 2 and section 9.
C
C     Author.
C     -------
C
C           J. Hennessy      ECMWF      18:06:86.
C
C     Modifications
C     --------------
C
C           None.
C
C     ---------------------------------------------------------------
C----<
C
C
C
C
C
C
C
C
C
C
C*    Section 0 . Definition of variables.
C     ------------------------------------
C
      IMPLICIT LOGICAL     ( L, O, G )
      IMPLICIT CHARACTER*8 ( C, H, Y )
      IMPLICIT INTEGER     ( I, J, K, M, N )
C
      DIMENSION KARRAY(*)
      DIMENSION KIB1(KLENG)
C
C     ---------------------------------------------------------------
C
C
C
C
C
C
C
C
C
C
C*    Section 1 . Set initial values. Check input parameters.
C     -------------------------------------------------------
C
 1000 CONTINUE
C
      IF (KPR.EQ.1) WRITE (*,*) 'GETIB1 : Section 1.'
C
      IRET = KRET
      KRET = 0
C
C     ----------------------------------------------------------------
C
C
C
C
C
C
C
C
C
C
C*    Section 2 . Extract values . Print if required.
C     -----------------------------------------------
C
 2000 CONTINUE
C
      IF (KPR.EQ.1) WRITE (*,*) 'GETIB1 : Section 2.'
C
      KLIB1 = KARRAY(2)
C
      IF (KLENG.LT.KLIB1)
     C   THEN
             KRET = 1
             WRITE (*,9001) KRET , KLIB1
             GO TO 9000
         ENDIF
C
      DO 2010 J=1,KLIB1
         KIB1(J) = KARRAY(J+2)
 2010 CONTINUE
C
      IF (KPR.GT.0) CALL PRTBK1(KIB1)
C
C     ------------------------------------------------------------------
C
C
C
C
C
C
C
C
C
C
C*    Section 9 . Return to calling routine or abort. Format statements.
C     ------------------------------------------------------------------
C
 9000 CONTINUE
C
      IF (KPR.EQ.1) WRITE (*,*) 'GETIB1 : Section 9.'
C
      IF (KRET.NE.0.AND.IRET.EQ.0) CALL ABORT
C
      RETURN
C
C
 9001 FORMAT (1H ,'GETIB1 : Error code = ',I3,'. Target array must be ',
     C             ' at least ',I5,' words long.')
C
C     ------------------------------------------------------------------
C
C
      END

C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE OFFSET2(IOFF,NLAST,IWORD,NBIT,ILEN,IERR)
C
C----> OFFSET2
C 
C     Purpose.
C     --------
C
C     Calculates the word and bit offset of the start of the next
C     bit-field in an array of binary data, following the
C     insertion/extraction of one or more consecutive bit-fields.
C
C     Interface.
C     ----------
C
C     CALL OFFSET2(IOFF,NLAST,IWORD,NBIT,ILEN,IERR)
C 
C
C     Input Parameters.
C     -----------------
C
C     IOFF  - Bit offset at which last insertion or extraction started.
C     NLAST - Number of bits in fields inserted or extracted in 
C             previous operation.
C     IWORD - Word number of array at which previous operation started.
C     NBIT  - Number of bits in computer word.
C     ILEN  - Number of words in array.
C
C     Output Parameters.
C     -----------------
C
C     IOFF  - Bit offset at which next insertion or extraction starts.
C     IWORD - Word number of array at which next operation starts.
C 
C     IERR  - = 0 if no error.
C             = -2 if next operation is outside array bounds.

C
C
C     Method.
C     -------
C
C     See below.
C
C
C     Externals.
C     ----------
C
C     None.
C
C
C     Reference.
C     ----------
C
C     None.
C
C
C     Comments.
C     ---------
C
C     Rewrite of offset.F to speed processing.
C
C
C     Author.
C     -------
C
C     J.D.Chambers      ECMWF     September 2001
C
C
C     Modifications.
C     --------------
C
C     None.
C 
C
C     ---------------------------------------------------------------
C----<
C
      IMPLICIT NONE
C
#include "grprs.h"
C
C     Subroutine arguments
C
      INTEGER IOFF,NLAST,IWORD,NBIT,ILEN,IERR
C
C     Clear error indicator
C
      IERR = 0
C
C     Calculate next word and bit positions.
C
      IOFF = IOFF + (NLAST-(NLAST/NBIT)*NBIT)
C
      IF( IOFF.GE.NBIT ) THEN
        IWORD = IWORD + (NLAST/NBIT) + 1
        IOFF  = IOFF  - NBIT
      ELSE
        IWORD = IWORD + (NLAST/NBIT)
      ENDIF
C
C     Check that next word to be accessed lies within the array bounds.
C
      IF( IWORD.GT.ILEN ) THEN
        IERR = -2
        WRITE(GRPRSM,*) 'Word ',IWORD,' is outside array bounds ',ILEN
      ENDIF
C
      RETURN
      END

c Copyright 1981-2016 ECMWF.
c
c This software is licensed under the terms of the Apache Licence 
c Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
c
c In applying this licence, ECMWF does not waive the privileges and immunities 
c granted to it by virtue of its status as an intergovernmental organisation 
c nor does it submit to any jurisdiction.
c

      SUBROUTINE SYMINV(A,NDIM,N,COND,V,DEPS)
      DIMENSION A(NDIM,NDIM),V(NDIM)
C     INVERT IN PLACE THE LOWER TRIANGLE OF A (I.E. A(I,J) I.GE.J)
C     A IS A SYMMETRIC POSITIVE DEFINITE MATRIX
C     THE UPPER TRIANGLE OF A (IE. A(I,J) I.LT.J) IS NOT USED OR ALTERED
C
C     THIS VERSION IS OPTIMIZED FOR THE CDC FTN COMPILER.
C     IT REQUIRES THE FUNCTION 'NUMARG' FROM  'ECLIB'
C
      IF(N.LT.1)RETURN
        EPS=0.
c       IF(NUMARG().EQ.6) EPS=DEPS
      NDIA=NDIM+1
      IMX=ISAMAX(N,A(1,1),NDIA)
      ZMX=A(IMX,IMX)*FLOAT(N*N)
C     SECTION 1 & 2 COMBINED IN THIS VERSION
C**** 1. ROOT FREE CHOLESKY DECOMPOSITION  A =L D L(TRANSPOSE)
      J=1
      IF(A(1,1).LE.EPS)GOTO91
      V(1)=1./A(1,1)
      IF(N.EQ.1)GOTO20
      X=A(2,1)*V(1)
      A(2,2)=A(2,2)-X*A(2,1)
      A(2,1)=X
      IF(A(2,2).LE.EPS)GOTO91
      V(2)=1./A(2,2)
      IF(N.EQ.2)GOTO20
      DO 14 I=3,N
      DO 12 J=3,I
      S=A(I,J-1)
      DO 11 K=3,J
 11   S=S-A(I,K-2)*A(J-1,K-2)
      A(I,J-1)=S
 12   CONTINUE
      S=A(I,I)
      DO 13 J=2,I
      X=A(I,J-1)*V(J-1)
      S=S-X*A(I,J-1)
 13   A(I,J-1)=X
      A(I,I)=S
C         CHECK FOR POSITIVE-DEFINITENESS AND INVERT DIAGONAL MATRIX D.
      IF(A(I,I).LE.EPS)GOTO91
      V(I)=1./A(I,I)
 14   CONTINUE
C
C**** 2.  COPY INVERSE OF D WHICH HAS ALREADY BEEN CALCULATED.
 20   DO 21 J=1,N
 21   A(J,J)=V(J)
      IF(N.EQ.1) GO TO 50
C
C**** 3.  INVERSION OF L
 30   A(2,1)=-A(2,1)
      NM1=N-1
      IF(N.EQ.2)GOTO40
      DO 33 I=2,NM1
      DO 32 J=2,I
      S=A(I+1,J-1)
      DO 31 K=J,I
 31   S=S+A(I+1,K)*A(K,J-1)
 32   A(I+1,J-1)=-S
 33   A(I+1,I)=-A(I+1,I)
C
C**** 4.  INV A = INV L(TRANSPOSE) * INV D * INV L
 40   DO 44 J=2,N
      S=A(J-1,J-1)
      DO 41 I=J,N
      X=A(I,I)*A(I,J-1)
      S=S+A(I,J-1)*X
 41   A(I,J-1)=X
      A(J-1,J-1)=S
      IF(J.EQ.N) GO TO 50
      DO 43 I=J,NM1
      S=A(I,J-1)
      DO 42 K=I,NM1
 42   S=S+A(K+1,I)*A(K+1,J-1)
      A(I,J-1)=S
 43   CONTINUE
 44   CONTINUE
C
 50   IMX=ISAMAX(N,A(1,1),NDIA)
      COND=1./ABS(A(IMX,IMX)*ZMX)
      RETURN
C
 91   COND=-FLOAT(J)
      RETURN
      END
      INTEGER FUNCTION ISAMAX(N,A,M)
C
C     FIND THE LARGEST ABSOLUTE ELEMENT OF A , SPACED M WORDS APART
C
      DIMENSION A(*)
C
      LARGE=1
      IF(N.LE.1) GO TO 9
      INDEX=1+M
      DO 1 I=2,N
      IF(ABS(A(INDEX)).GE.ABS(A(LARGE))) LARGE=I
1     INDEX=INDEX+M
9     ISAMAX=LARGE
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities
C granted to it by virtue of its status as an intergovernmental organisation
C nor does it submit to any jurisdiction.
C

      INTEGER FUNCTION INTUVXH(PUVSH,KNVALS,ZNFLDO,KUGRIB,KVGRIB,
     X                         OUTLENU,OUTLENV)
C
C---->
C**** INTUVXH
C
C     Purpose
C     -------
C
C     Interpolate U or V component spectral fields to grid point.
C
C
C     Interface
C     ---------
C
C     IRET = INTUVXH(PUVSH,KNVALS,ZNFLDO,KUGRIB,KVGRIB,OUTLENU,OUTLENV)
C
C     Input
C     -----
C
C     PUVSH  - Spectral U/V values. (U first)
C     KNVALS - Number of values in each wind component field.
C     ZNFLDO - Work array.
C
C
C     Output
C     ------
C
C     KUGRIB  - Output wind U component field (GRIB format).
C     KVGRIB  - Output wind V component field (GRIB format).
C     OUTLENU - Output U field length (words).
C     OUTLENV - Output V field length (words).
C
C
C     Method
C     ------
C
C     None.
C
C
C     Externals
C     ---------
C
C     INTUVDH - Encode/decode data into/from GRIB code.
C     INTFAU  - Prepare to interpolate unpacked input field.
C     INTFBU  - Interpolate unpacked input field.
C     INTLOG  - Log error message.
C     MKFRAME - Create a 'frame' from a rectangular field.
C
C
C     Author
C     ------
C
C     J.D.Chambers     ECMWF     February 2001
C
C
C----<
C     -----------------------------------------------------------------|
C
      IMPLICIT NONE
C
#include "parim.h"
#include "nifld.common"
#include "nofld.common"
#include "intf.h"
#include "current.h"
C
C     Parameters
C
      INTEGER JPROUTINE
      PARAMETER (JPROUTINE = 40170 )
C
C     Function arguments
C
      INTEGER KNVALS, KUGRIB(*), KVGRIB(*), OUTLENU, OUTLENV
      REAL PUVSH(KNVALS*2), ZNFLDO(*)
C
C     Local variables
C
      CHARACTER*1 HOLDTYP
      CHARACTER*1 HTYPE
      INTEGER ILENF
      INTEGER IRET
      INTEGER ISIZE
      INTEGER NCOUNT
      INTEGER NGAUSS
      INTEGER NLAT
      INTEGER NLON
      INTEGER NTRUNC
      INTEGER NUMPTS
      INTEGER NUVFLAG
      LOGICAL LFRAME
      LOGICAL LOLDWIND
      REAL AREA(4)
      REAL EAST
      REAL EW
      REAL GRID(2)
      REAL NS
      REAL POLE(2)
      REAL WEST
C
      REAL RGGRID, SWORK
      POINTER (IRGGRID, RGGRID(1) )
      POINTER (ISWORK, SWORK(1) )
C
      INTEGER KPTS(JPGTRUNC*2)
      REAL GLATS(JPGTRUNC*2)
C
      DATA IRGGRID/0/, ISWORK/0/
      SAVE IRGGRID, ISWORK
C
C     Externals
C
      INTEGER INTFAU, INTFBU, INTUVDH, HSH2GG !, FIXAREA
      INTEGER HIRLAMW
C
C     -----------------------------------------------------------------|
C*    Section 1.   Initialise.
C     -----------------------------------------------------------------|
C
  100 CONTINUE
C
      INTUVXH = 0
C
      LFRAME = LNOFRAME.AND.
     X         ((NOREPR.EQ.JPREGULAR).OR.(NOREPR.EQ.JPGAUSSIAN).OR.
     X          (NOREPR.EQ.JPREGROT ).OR.(NOREPR.EQ.JPFGGROT  ) )
C
      IF( LNOROTA ) GOTO 300
C
C     -----------------------------------------------------------------|
C*    Section 2.   Spectral to grid-point with no rotation
C     -----------------------------------------------------------------|
C
  200 CONTINUE
C
      CALL INTLOG(JP_DEBUG,
     X  'INTUVXH: Interoplate U & V fields with no rotation',JPQUIET)
C
C     Unpack and interpolate U field
C
      NIFORM = 0
      NIPARAM = JP_U
      LWIND = .TRUE.
      LOLDWIND = LWINDSET
      LWINDSET = .TRUE.
C
      IRET = INTFAU( PUVSH, KNVALS)
      IF( IRET.NE.0 ) THEN
        CALL INTLOG(JP_ERROR,
     X    'INTUVXH: Prepare to interpolate failed.',JPQUIET)
        INTUVXH = JPROUTINE + 2
        GOTO 900
      ENDIF
C
      IRET = INTFBU( PUVSH, KNVALS, ZNFLDO, ILENF)
      IF( IRET.NE.0 ) THEN
        CALL INTLOG(JP_ERROR,'INTUVXH: Interpolation failed.',JPQUIET)
        INTUVXH = JPROUTINE + 2
        GOTO 900
      ENDIF
C
C     Unpack and interpolate V field
C
      NIPARAM = JP_V
C
      IRET = INTFAU( PUVSH(1+KNVALS), KNVALS)
      IF( IRET.NE.0 ) THEN
        CALL INTLOG(JP_ERROR,
     X    'INTUVXH: Prepare to interpolate failed.',JPQUIET)
        INTUVXH = JPROUTINE + 2
        GOTO 900
      ENDIF
C
      IRET = INTFBU( PUVSH(1+KNVALS), KNVALS, ZNFLDO(1+ILENF), ILENF)
      IF( IRET.NE.0 ) THEN
        CALL INTLOG(JP_ERROR,'INTUVXH: Interpolation failed.',JPQUIET)
        INTUVXH = JPROUTINE + 2
        GOTO 900
      ENDIF
C
C     Reset the input format flag
C
      NIFORM = 1
C
C     Get some scratch memory for the U fields before interpolation
C     (to prevent overwriting V in ZNFLDO during interpolation)
C
cs      ISIZE  = ILENF
cs      CALL JMEMHAN( 11, ISWORK, ISIZE, 1, IRET)
cs      IF( IRET.NE.0 ) THEN
cs        CALL INTLOG(JP_ERROR,
cs     X    'INTUVXH: memory alloc for scratch memory failed',JPQUIET)
cs        INTUVXH = JPROUTINE + 2
cs        GOTO 900
cs      ENDIF
C
      LWINDSET = LOLDWIND
C
C
C     If a 'frame' has been specified, build the frame
C
      IF( LFRAME ) THEN
        LIMISSV = .TRUE.
        NLON = 1 + NINT(FLOAT(NOAREA(JPEAST)  - NOAREA(JPWEST)) /
     X       NOGRID(JPWESTEP))
        NLAT = 1 + NINT(FLOAT(NOAREA(JPNORTH) - NOAREA(JPSOUTH)) /
     X       NOGRID(JPNSSTEP))
        CALL MKFRAME(NLON,NLAT,ZNFLDO,RMISSGV,NOFRAME)
        CALL MKFRAME(NLON,NLAT,ZNFLDO(1+ILENF),RMISSGV,NOFRAME)
      ENDIF

C     Code data into GRIB
cs      DO LOOP = 1, ILENF
cs        SWORK(LOOP) = ZNFLDO(LOOP)
cs      ENDDO
C
cs      IRET = INTUVDH(SWORK,ILENF,KUGRIB,OUTLENU,'C',JP_U)
      IRET = INTUVDH(ZNFLDO,ILENF,KUGRIB,OUTLENU,'C',JP_U)
      IF( IRET.NE.0 ) THEN
        CALL INTLOG(JP_ERROR,
     X    'INTUVXH: Wind component into GRIB encoding fail',IRET)
        INTUVXH = JPROUTINE + 2
        GOTO 900
      ENDIF
C
      IRET = INTUVDH(ZNFLDO(1+ILENF),ILENF,KVGRIB,OUTLENV,'C',JP_V)
      IF( IRET.NE.0 ) THEN
        CALL INTLOG(JP_ERROR,
     X    'INTUVXH: Wind component into GRIB encoding fail',IRET)
        INTUVXH = JPROUTINE + 2
        GOTO 900
      ENDIF
C
      GOTO 900
C
C     -----------------------------------------------------------------|
C*    Section 3.   Initialise spectral to grid-point with rotation
C     -----------------------------------------------------------------|
C
  300 CONTINUE
C
      IF( .NOT.LUSEHIR ) THEN
        CALL INTLOG(JP_ERROR,
     X    'INTUVXH : Unable to rotate spectral U or V:',JPQUIET)
        INTUVXH  = JPROUTINE + 3
        GOTO 900
      ENDIF
C
      IF( (NOREPR.NE.JPREGROT).AND.(NOREPR.NE.JPREGULAR) ) THEN
        CALL INTLOG(JP_ERROR,
     X    'INTUVXH : For U/V, only regular lat/long',JPQUIET)
        CALL INTLOG(JP_ERROR,
     X    'INTUVXH : output rotated grids allowed',JPQUIET)
        INTUVXH  = JPROUTINE + 3
        GOTO 900
      ENDIF
C
      CALL INTLOG(JP_DEBUG,'INTUVXH: Rotate the U & V fields',JPQUIET)
      CALL INTLOG(JP_DEBUG,'INTUVXH: South pole lat  ',NOROTA(1))
      CALL INTLOG(JP_DEBUG,'INTUVXH: South pole long ',NOROTA(2))
C
C     Fill area limits (handles case when default 0/0/0/0 given)
C
cs      IRET = FIXAREA()
cs      IF( IRET.NE.0 ) THEN
cs        CALL INTLOG(JP_ERROR,'INTUVXH: area fixup failed',JPQUIET)
cs        INTUVXH = JPROUTINE + 3
cs        GOTO 900
cs      ENDIF
C
      AREA(1) = REAL(NOAREA(1))/PPMULT
      AREA(2) = REAL(NOAREA(2))/PPMULT
      AREA(3) = REAL(NOAREA(3))/PPMULT
      AREA(4) = REAL(NOAREA(4))/PPMULT
C
      GRID(1) = REAL(NOGRID(1))/PPMULT
      GRID(2) = REAL(NOGRID(2))/PPMULT
C
      POLE(1) = REAL(NOROTA(1))/PPMULT
      POLE(2) = REAL(NOROTA(2))/PPMULT
C
C     -----------------------------------------------------------------|
C*    Section 4.   Convert spectral to suitable global reduced gaussian
C     -----------------------------------------------------------------|
C
  400 CONTINUE
C
      NTRUNC = NIRESO
      NGAUSS = 0
      HTYPE  = ''
      NS = 0.
      EW = 0.
      IRET = HSH2GG(NS,EW,NTRUNC,NGAUSS,HTYPE,KPTS,GLATS,ISIZE)
      IF( IRET.NE.0 ) THEN
        CALL INTLOG(JP_ERROR,
     X    'INTUVXH: problem getting data for reduced grid',NTRUNC)
        INTUVXH = JPROUTINE + 4
        GOTO 900
      ENDIF
      NCOUNT = ISIZE
C
C     Dynamically allocate memory for global reduced gaussian grid
C
      CALL JMEMHAN( 18, IRGGRID, (NCOUNT*2), 1, IRET)
      IF( IRET.NE.0 ) THEN
        CALL INTLOG(JP_ERROR,
     X    'INTUVXH: memory alloc for reduced grid fail',JPQUIET)
        INTUVXH = JPROUTINE + 4
        GOTO 900
      ENDIF
C
C     Set flag to show field is a wind component
C
      NUVFLAG = 1
C
C     Create the reduced gaussian grid
C
      HOLDTYP = HOGAUST
      WEST = 0.0
      EAST = 360.0 - (360.0/FLOAT(KPTS(NGAUSS)))
C
C     U component
C
      CALL JAGGGP(PUVSH,NTRUNC,GLATS(1),GLATS(NGAUSS*2),WEST,
     X            EAST,NGAUSS,HTYPE,KPTS,RGGRID,NUVFLAG,IRET)
      IF( IRET.NE.0 ) THEN
        CALL INTLOG(JP_ERROR,
     X    'INTUVXH: spectral to reduced gaussian failed',JPQUIET)
        INTUVXH = JPROUTINE + 4
        GOTO 900
      ENDIF
C
      HOGAUST = HOLDTYP
C
C     V component
C
      CALL JAGGGP(PUVSH(1+KNVALS),NTRUNC,GLATS(1),GLATS(NGAUSS*2),WEST,
     X            EAST,NGAUSS,HTYPE,KPTS,RGGRID(1+NCOUNT),NUVFLAG,IRET)
      IF( IRET.NE.0 ) THEN
        CALL INTLOG(JP_ERROR,
     X    'INTUVXH: spectral to reduced gaussian failed',JPQUIET)
        INTUVXH = JPROUTINE + 4
        GOTO 900
      ENDIF
C
      HOGAUST = HOLDTYP
C
C     -----------------------------------------------------------------|
C*    Section 5.   Rotate using 12-point horizontal interpolation
C     -----------------------------------------------------------------|
C
  500 CONTINUE
C
C     Dynamically allocate memory for rotated lat/long grid
C
      NLON = 1 + NINT(FLOAT(NOAREA(JPEAST)  - NOAREA(JPWEST)) /
     X       NOGRID(JPWESTEP))
      NLAT = 1 + NINT(FLOAT(NOAREA(JPNORTH) - NOAREA(JPSOUTH)) /
     X       NOGRID(JPNSSTEP))
C
      NUMPTS = NLON * NLAT
      ISIZE  = NUMPTS * 2
      CALL JMEMHAN( 11, ISWORK, ISIZE, 1, IRET)
      IF( IRET.NE.0 ) THEN
        CALL INTLOG(JP_ERROR,
     X    'INTUVXH: memory alloc for lat/long grid fail',JPQUIET)
        INTUVXH = JPROUTINE + 5
        GOTO 900
      ENDIF
C
      IRET = HIRLAMW(LO12PT,RGGRID,RGGRID(1+NCOUNT),NCOUNT,NGAUSS,HTYPE,
     X               AREA,POLE,GRID,SWORK,SWORK(1+NUMPTS),NUMPTS,NLON,
     X               NLAT)
C
      IF( IRET.NE.0 ) THEN
        CALL INTLOG(JP_ERROR,
     X    'INTUVXH: HIRLAMW rotation failed',JPQUIET)
        INTUVXH = JPROUTINE + 5
        GOTO 900
      ENDIF
C
C     -----------------------------------------------------------------|
C*    Section 6.   Pack the fields into GRIB format
C     -----------------------------------------------------------------|
C
  600 CONTINUE
C
C     Reset the input format flag
C
      NIFORM = 1
C
C     Set the components flag for rotated U and V coefficients
C
      ISEC2(19) = 8
C
C     If a 'frame' has been specified, build the frame
C
      IF( LFRAME ) THEN
        LIMISSV = .TRUE.
        CALL MKFRAME(NLON,NLAT,SWORK,RMISSGV,NOFRAME)
        CALL MKFRAME(NLON,NLAT,SWORK(1+NUMPTS),RMISSGV,NOFRAME)
      ENDIF
C
      IRET = INTUVDH(SWORK,NUMPTS,KUGRIB,OUTLENU,'C',JP_U)
      IF( IRET.NE.0 ) THEN
        CALL INTLOG(JP_ERROR,
     X    'INTUVXH: Wind component into GRIB encoding fail',IRET)
        INTUVXH = JPROUTINE + 6
        GOTO 900
      ENDIF
C
      IRET = INTUVDH(SWORK(1+NUMPTS),NUMPTS,KVGRIB,OUTLENV,'C',JP_V)
      IF( IRET.NE.0 ) THEN
        CALL INTLOG(JP_ERROR,
     X    'INTUVXH: Wind component into GRIB encoding fail',IRET)
        INTUVXH = JPROUTINE + 6
        GOTO 900
      ENDIF
C
C     -----------------------------------------------------------------|
C*    Section 9.   Return
C     -----------------------------------------------------------------|
C
  900 CONTINUE
C
      RETURN
      END

C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      INTEGER FUNCTION INTWAVU(INFLD,INLEN,OUTFLD,OUTLEN)
C
C---->
C**** INTWAVU
C
C     Purpose
C     -------
C
C     Interpolate an ECMWF wave field wave field or a reduced
C     latitude-longitude field
C
C
C     Interface
C     ---------
C
C     IRET = INTWAVU(INFLD,INLEN,OUTFLD,OUTLEN)
C
C     Input
C     -----
C
C     INFLD  - Input field (packed).
C     INLEN  - Input field length (words).
C
C
C     Output
C     ------
C
C     OUTFLD  - Output field (packed).
C     OUTLEN  - Output field length (words).
C
C
C     Method
C     ------
C
C     Call interpolation routine; then repack into GRIB format.
C
C
C     Externals
C     ---------
C
C     FIXAREA - Fixup area definition to correspond to grid definitions
C     JMEMHAN - Handles memory allocation.
C     JDEBUG  - Checks environment to switch on/off debug
C     INTLOG  - Log error message.
C     WAVEXX2 - Interpolate wave fields (except 2D spectra)
C     WV2DXX2 - Interpolate wave 2D spectra fields
C     MKFRAME - Create a 'frame' from a rectangular field
C     MKBITMP - Apply a bitmap to a rectangular field
C
C
C     Author
C     ------
C
C     S.Curic     ECMWF     Mar 2009
C
C
C----<
C
      IMPLICIT NONE
C
C     Function arguments
      INTEGER INLEN,OUTLEN
      REAL INFLD, OUTFLD
      DIMENSION INFLD(*),OUTFLD(*)
C
#include "parim.h"
#include "nifld.common"
#include "nofld.common"
#include "intf.h"
#include "grfixed.h"
#include "jparams.h"
C
C     Parameters
      INTEGER JPROUTINE, JP2DSP, JP2DSPQ, JPMAXLT

      PARAMETER (JPROUTINE = 40200 )
      PARAMETER (JP2DSP  = 250 )
C                           ^---- parameter number for 2D wave spectra (whole)
      PARAMETER (JP2DSPQ = 251 )
C                           ^---- parameter number for 2D wave spectra (single)
      PARAMETER (JPMAXLT = 1801 )
C
C     Local variables
C
      CHARACTER*1 HFUNC

      REAL ZMISS
cs      DATA ZMISS/-9999999.0/
      REAL RLATINC, ONORTH, OSOUTH
      INTEGER IWORD, IRET, ISIZE, NSPEC, LAT1, LOOP, IERR
      INTEGER KNUM, NUM_E_W, NUM_N_S, NFULLNS, NFULLEW
      REAL GRIDWE, GRIDNS, NORTH, SOUTH, WEST, EAST
      REAL INORTH, ISOUTH, IWEST, IEAST, RNS
      INTEGER NUMPTS,MISSLAT,KOLDNUM
      DIMENSION NUMPTS(JPMAXLT)
      INTEGER NUMTABL, NUMPROD
      INTEGER KNEWNUM
      LOGICAL LCOEFFS, L98WAVE, LFRAME, LBITMP
      LOGICAL LDEBUG
C
C     Externals
      INTEGER AREACHK, FIXAREA, WAVEXX2, WV2DXX2
      INTEGER NUMPTNS, NUMPTWE, JNORSGG, MKBITMP
C
C ------------------------------------------------------------------
C     Section 1.   Initialise
C ------------------------------------------------------------------
C
  100 CONTINUE
C
      INTWAVU = 0
C
      LCOEFFS = .FALSE.
      ZMISS = RMISSGV
      ZSEC3(2) = RMISSGV
      ISEC3(2) = INT(RMISSGV)
      ISEC1(5) = 192

C
C     Check if debug option turned on
      CALL JDEBUG()
      LDEBUG = NDBG.GT.0
C
C
      OUTLEN = 0
      IRET = 1
C
C     Check that the field can be handled
C
C ------------------------------------------------------------------
C     Section 2.   Sort out interpolation area.
C ------------------------------------------------------------------
C
  200 CONTINUE
C
      NSPEC = 1
      INORTH = FLOAT(NIAREA(1))/PPMULT
      IWEST  = FLOAT(NIAREA(2))/PPMULT
      ISOUTH = FLOAT(NIAREA(3))/PPMULT
      IEAST  = FLOAT(NIAREA(4))/PPMULT
      KNUM  = NINS
      RNS = INORTH - ISOUTH
C
C     Adjust (sub-)area limits to suit the grid
C
      IRET = FIXAREA()
      IF ( IRET .NE. 0 ) THEN
        CALL INTLOG(JP_ERROR, 'INTWAVU: FIXAREA failed.',JPQUIET)
        INTWAVU = JPROUTINE + 5
        GOTO 900
      ENDIF
      NORTH = FLOAT(NOAREA(1))/PPMULT
      WEST  = FLOAT(NOAREA(2))/PPMULT
      SOUTH = FLOAT(NOAREA(3))/PPMULT
      EAST  = FLOAT(NOAREA(4))/PPMULT
C
C     Calculate the number of points E-W and N-S in new grid area
C
      IF( (NOREPR.EQ.JPQUASI) .OR. (NOREPR.EQ.JPGAUSSIAN)) THEN
        GRIDWE  = NOGAUSS
        GRIDNS  = 0
      ELSE IF( NOREPR.EQ.JPREDLL ) THEN
        GRIDWE  = 360.0/NOLPTS((NOREDLL/2)+1)
        GRIDNS  = FLOAT(NOGRID(2))/PPMULT
      ELSE
        GRIDWE  = FLOAT(NOGRID(1))/PPMULT
        GRIDNS  = FLOAT(NOGRID(2))/PPMULT
      ENDIF
C
      IRET = AREACHK(GRIDWE,GRIDNS,NORTH,WEST,SOUTH,EAST)
      IF( IRET.NE.0 ) THEN
        INTWAVU = JPROUTINE + 6
        GOTO 900
      ENDIF
      NOAREA(1) = NINT(NORTH*PPMULT)
      NOAREA(2) = NINT(WEST*PPMULT)
      NOAREA(3) = NINT(SOUTH*PPMULT)
      NOAREA(4) = NINT(EAST*PPMULT)
C
      IF( (NOREPR.EQ.JPQUASI) .OR. (NOREPR.EQ.JPGAUSSIAN)) THEN
         IF(NOREPR.EQ.JPQUASI) THEN
            GRIDWE  = 360.0/NOLPTS(NOGAUSS)
         ELSE
            GRIDWE  = 360.0/(NOGAUSS*4)
         ENDIF
        NUM_E_W = NUMPTWE(WEST,EAST,GRIDWE)
        NFULLEW = NUMPTWE(0.0,360.0,GRIDWE) - 1
        NUM_N_S = JNORSGG(SOUTH,ROGAUSS,NOGAUSS,1) - 
     X            JNORSGG(NORTH,ROGAUSS,NOGAUSS,0) + 1
        NFULLNS = NOGAUSS*2
        NONS    = NFULLNS
         IF(NOREPR.EQ.JPQUASI) THEN
           KNEWNUM = NOGAUSS*2
           DO LOOP = 1, KNEWNUM
             OUTLEN  = OUTLEN + NOLPTS(LOOP)
           ENDDO
           NOWE = 0
         ELSE
            NOWE    = NUM_E_W
            OUTLEN  = NOWE*NONS
         ENDIF
      ELSE IF( NOREPR.EQ.JPREDLL ) THEN
        NUM_E_W = NUMPTWE(WEST,EAST,GRIDWE)
        NFULLEW = NUMPTWE(0.0,360.0,GRIDWE) - 1
        NUM_N_S = NUMPTNS(NORTH,SOUTH,GRIDNS)
        NFULLNS = NOREDLL
        CALL INTLOG(JP_ERROR,'INTWAVU: Reduced ll not posible',JPQUIET)
        GOTO 900
      ELSE
        NUM_E_W = NUMPTWE(WEST,EAST,GRIDWE)
        NFULLEW = NUMPTWE(0.0,360.0,GRIDWE) - 1
        NUM_N_S = NUMPTNS(NORTH,SOUTH,GRIDNS)
        NFULLNS = NUM_N_S
cs calculate outlen for regular lat-lon
        OUTLEN  = NUM_E_W*NUM_N_S
        NOWE    = NUM_E_W
        NONS    = NUM_N_S
      ENDIF
C
C
C ------------------------------------------------------------------
C     Section 3.   Interpolate wave fields other than 2D spectra.
C ------------------------------------------------------------------
C
  300 CONTINUE
C
C     Handle if not 2D spectra ..
C
      IF( (NIPARAM.NE.JP2DSP).AND.(NIPARAM.NE.JP2DSPQ) ) THEN
       IF( LDEBUG ) THEN
       CALL INTLOG(JP_DEBUG,
     X 'INTWAVU: Interpolate wave fields other than 2D spectra',JPQUIET)
       ENDIF
C--------------------------------------------------------------------
        KNUM = NINS
      IF(NIREPR.EQ.JPREDLL) THEN
C
C       Input field is a reduced latitude/longitude grid
C
C       .. but it may be 'pseudo-gaussian' in layout
C       (ie global, symmetric about the equator but no latitude
C        at the equator)
          MISSLAT = 0
        ONORTH = FLOAT(NIAREA(1))/PPMULT
        OSOUTH = FLOAT(NIAREA(3))/PPMULT

        RLATINC = FLOAT(NIGRID(2))/PPMULT


        IF( ( NIAREA(1).NE.90000).AND.(MOD(KNUM,2).EQ.0) )  THEN
C
          DO LOOP = 1, KNUM
            NUMPTS(LOOP) = MILLEN(LOOP)
          ENDDO
C
        ELSE
C
cs          MISSLAT = (90000 - NIAREA(1))/NIGRID(2)
          MISSLAT = (90.0 - ONORTH)/RLATINC
          DO LOOP = 1, MISSLAT
            NUMPTS(LOOP)    = 0
          ENDDO
cs          KOLDNUM = 1 + (90000 - NIAREA(3))/NIGRID(2)
          KOLDNUM = 1 + NINT((90.0 - OSOUTH)/RLATINC)
          DO LOOP = 1, (KOLDNUM-MISSLAT)
            NUMPTS(LOOP+MISSLAT) = MILLEN(LOOP)
          ENDDO
          DO LOOP = (KOLDNUM+1), KNUM
            NUMPTS(LOOP)    = 0
          ENDDO
        ENDIF
      ENDIF
C--------------------------------------------------------------------

C
C       Interpolate the field
C
        IRET = WAVEXX2(NIPARAM,KNUM,NUMPTS,NUM_N_S,GRIDNS,GRIDWE,INFLD,
     X               OUTFLD,NORTH,WEST,ZMISS)
        IF( IRET.NE.0 ) THEN
          CALL INTLOG(JP_ERROR,'INTWAVU: Interpolation failed.',JPQUIET)
          INTWAVU = JPROUTINE + 10
          GOTO 900
        ENDIF
C
C ------------------------------------------------------------------
C     Section 4.   Interpolate wave 2D spectra field.
C ------------------------------------------------------------------
C
      ELSE
C
      IF( LDEBUG ) THEN
      CALL INTLOG(JP_DEBUG,
     X 'INTWAVU: Interpolate wave 2D spectra field',JPQUIET)
      ENDIF
  400   CONTINUE
C
        IRET = WV2DXX2(NIMATR,KNUM,MILLEN,NUM_N_S,GRIDNS,GRIDWE,INFLD,
     X               OUTFLD,NORTH,WEST,ZMISS)
        IF( IRET.NE.0 ) THEN
          CALL INTLOG(JP_ERROR,'INTWAVU: Interpolation failed.',JPQUIET)
          INTWAVU = JPROUTINE + 13
          GOTO 900
        ENDIF
C
      ENDIF
C
C ------------------------------------------------------------------
C     Section 5.   Frame and Bitmap
C ------------------------------------------------------------------
C
  500   CONTINUE

C     If a 'bitmap' has been specified, build the bitmap
C
      LBITMP = LNOBITMP.AND.
     X         ((NOREPR.EQ.JPREGROT).OR.(NOREPR.EQ.JPREGULAR).OR.
     X          (NOREPR.EQ.JPGAUSSIAN))

      IF( LBITMP ) THEN
        CALL INTLOG(JP_DEBUG,'INTWAVU: MKBITMP is enabled',JPQUIET)
        IERR = MKBITMP(NUM_E_W,NUM_N_S,OUTFLD,ZMISS)
        IF( IERR.NE.0 ) THEN
        CALL INTLOG(JP_ERROR,'INTWAVU: Problem applying bitmap',JPQUIET)
          GOTO 900
        ENDIF
      ENDIF
C     If a 'frame' has been specified, build the frame
C
       LFRAME = LNOFRAME.AND.
     X         ((NOREPR.EQ.JPREGULAR).OR.(NOREPR.EQ.JPGAUSSIAN).OR.
     X          (NOREPR.EQ.JPREGROT ).OR.(NOREPR.EQ.JPFGGROT  ) )

         CALL INTLOG(JP_DEBUG,'INTWAVU: NUM_E_W ',NUM_E_W)
         CALL INTLOG(JP_DEBUG,'INTWAVU: NUM_N_S ',NUM_N_S)
      IF( LFRAME ) THEN
           CALL INTLOG(JP_DEBUG,'INTWAVU: MKFRAME is enabled',JPQUIET)
           CALL INTLOG(JP_DEBUG,'INTWAVU: NOFRAME ',NOFRAME)
         CALL MKFRAME(NUM_E_W,NUM_N_S,OUTFLD,ZMISS,NOFRAME) 
      ENDIF
C
C
C ------------------------------------------------------------------
C*    Section 9.   Closedown.
C ------------------------------------------------------------------
C
  900 CONTINUE
C
C     Clear change flags for next product processing
C
      LCHANGE = .FALSE.
      LSMCHNG = .FALSE.
C
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities
C granted to it by virtue of its status as an intergovernmental organisation
C nor does it submit to any jurisdiction.
C

      INTEGER FUNCTION HNTFAPH(INGRIB,INLEN)
C
C---->
C**** HNTFAPH
C
C     Purpose
C     -------
C
C     Prepare to interpolate to grid point field.
C
C
C     Interface
C     ---------
C
C     IRET = HNTFAPH(INGRIB,INLEN)
C
C     Input
C     -----
C
C     INGRIB - Input field (packed).
C     INLEN  - Input field length (words).
C
C
C     Output
C     ------
C
C     Field unpacked values are in ZNFELDI, rotated if necessary.
C
C     Returns: 0, if OK. Otherwise, an error occured in interpolation.
C
C
C     Method
C     ------
C
C     Unpack field.
C
C     If the input is a spectral field and the output is a rotated
C     grid-point field, create a global reduced gaussian field and
C     then create the rotated grid-point field from it.
C
C
C     Externals
C     ---------
C
C     GRIBEX  - Decode/encode GRIB product.
C     GRSVCK  - Turn off GRIB checking
C     INTLOG  - Log error message.
C     INTLOGR - Log error message.
C     JDEBUG  - Checks environment to switch on/off debug
C     FIXAREA - Fixup input/output field area definitions.
C     HSH2GG  - Find suitable gaussian grid/spectral truncation
C     HIRLAM  - Creates rotated lat/long field from reduced gaussian
C     HIRLSM  - Creates rotated lat/long field from reduced gaussian
C               using land-sea mask
C     HRG2GG  - Creates rotated gaussian field from reduced gaussian
C     HLL2LL  - Creates rotated lat/long field from lat/long field
C     LSMFLD  - Determines whether a field is to be interpolated using
C               a land-sea mask
C
C
C     Author
C     ------
C
C     J.D.Chambers     ECMWF     January 31, 2001
C
C----<
C
C     -----------------------------------------------------------------|
C*    Section 0.   Variables
C     -----------------------------------------------------------------|
C
      IMPLICIT NONE
C
C     Function arguments
C
      INTEGER INGRIB(*),INLEN
C
#include "parim.h"
#include "nifld.common"
#include "nofld.common"
#include "intf.h"
#include "current.h"
#include "grfixed.h"
C
C     Parameters
C
      INTEGER JPROUTINE
      PARAMETER (JPROUTINE = 40110 )
C
C     Local variables
C
      CHARACTER*1 HOLDTYP
      CHARACTER*1 HTYPE
      INTEGER     IERR
      INTEGER     IRET
      INTEGER     ISHIZE
      INTEGER     ISIZE
      INTEGER     ITEMP,K,I,J,IM,JM
      INTEGER     IWORD
      INTEGER     KPTS(JPGTRUNC*2)
      INTEGER     LOOP
      INTEGER     NCOUNT
      INTEGER     NGAUSS
      INTEGER     NLAT
      INTEGER     NLON
      INTEGER     NTRUNC
      INTEGER     NUMPTS
      INTEGER     NUVFLAG
      LOGICAL     LLATOUT
      LOGICAL     LSP2RGG
      LOGICAL     LUSELSM
      REAL        AREA(4)
      REAL        EAST
      REAL        EW
      REAL        GRID(2)
      REAL        NS
      REAL        OLDGRID(2)
      REAL        PLATS(JPGTRUNC*2)
      REAL        POLE(2)
      REAL        RGGRID(1)
      REAL        SWORK(1)
      REAL        TEMP(1440,1440)
      REAL        WEST
      REAL        ZNFLDO(1)
#ifndef _CRAYFTN
#ifdef POINTER_64
      INTEGER*8 IRGGRID
      INTEGER*8 ISWORK
      INTEGER*8 IZNFLDO
#endif
#endif
      POINTER (IRGGRID, RGGRID)
      POINTER (ISWORK,  SWORK)
      POINTER (IZNFLDO, ZNFLDO)
C
      SAVE IRGGRID
      SAVE ISWORK
      SAVE IZNFLDO
C
C     Externals
C
      CHARACTER*1 GGHTYPE
      INTEGER HSH2GG, HIRLAM, HIRLSM, HRG2GG, FIXAREA, PDDEFS
      INTEGER HLL2LL
      LOGICAL LSMFLD
      EXTERNAL GGHTYPE
      EXTERNAL HSH2GG, HIRLAM, HIRLSM, HRG2GG, FIXAREA, PDDEFS
      EXTERNAL HLL2LL
      EXTERNAL LSMFLD
C
C     -----------------------------------------------------------------|
C*    Section 1.   Initialise
C     -----------------------------------------------------------------|
C
  100 CONTINUE
C
      HNTFAPH = 0
      LSP2RGG = .FALSE.
C
C     -----------------------------------------------------------------|
C*    Section 2.   Decode data from the GRIB code
C     -----------------------------------------------------------------|
C
  200 CONTINUE
C
C     Decode data from GRIB code (no checking)
C
      IERR  =  0
      CALL GRSVCK(0)
C
      IERR = 1
      IWORD = INLEN
      ISEC3(2) = NINT(RMISSGV)
      ZSEC3(2) = RMISSGV

      CALL GRIBEX(ISEC0, ISEC1, ISEC2, ZSEC2, ISEC3, ZSEC3, ISEC4,
     X            ZNFELDI, JPEXPAND, INGRIB, INLEN, IWORD, 'D',IERR)

      IF (ISEC2(11).EQ.64) THEN
        CALL INTLOG(JP_DEBUG,
     X    'HNTFAPH: Scanning flag west-east/south-north',ISEC2(11))
        ITEMP = NIAREA(1)
        NIAREA(1) = NIAREA(3)
        NIAREA(3) = ITEMP

        IM = ISEC2(2)
        JM = ISEC2(3)
        K=0
        DO J=JM,1,-1
          DO I=1,IM
            K=K+1
            TEMP(I,J) = ZNFELDI(K)
          END DO
        END DO
        K=0
        DO J=1,JM
          DO I=1,IM
            K=K+1
            ZNFELDI(K) = TEMP(I,J)
          END DO
        END DO

      ENDIF

C
      IF( IERR.LT.0) THEN
        IF( (IERR.EQ.-2).OR.(IERR.EQ.-4) ) THEN
          CALL INTLOG(JP_DEBUG,'HNTFAPH: Use missing value',JPQUIET)
          LIMISSV = .TRUE.
        ELSE
          CALL INTLOG(JP_ERROR,'HNTFAPH: GRIBEX decoding fail.',IERR)
          HNTFAPH = JPROUTINE + 2
          GOTO 900
        ENDIF
      ELSE IF( IERR.GT.0 ) THEN
        CALL INTLOG(JP_ERROR,'HNTFAPH: GRIBEX decoding failed.',IERR)
        HNTFAPH = JPROUTINE + 2
        GOTO 900
      ENDIF
C
      NCOUNT = ISEC4(1)
C
      LLATOUT = (NOREPR.EQ.JPREGROT).OR.(NOREPR.EQ.JPREGULAR)

      IF( .NOT.LNOROTA ) GOTO 900
C
C     -----------------------------------------------------------------|
C*    Section 3.   Handle rotation, if necessary.
C     -----------------------------------------------------------------|
C
  300 CONTINUE
C
      CALL INTLOG(JP_DEBUG,'HNTFAPH: Rotate field.',JPQUIET)
      CALL INTLOG(JP_DEBUG,'HNTFAPH: South pole lat  ',NOROTA(1))
      CALL INTLOG(JP_DEBUG,'HNTFAPH: South pole long ',NOROTA(2))
C
C     Fill area limits (handles case when default 0/0/0/0 given)
C
      IRET = FIXAREA()
      IF( IRET.NE.0 ) THEN
        CALL INTLOG(JP_ERROR,'HNTFAPH: area fixup failed',JPQUIET)
        HNTFAPH = JPROUTINE + 3
        GOTO 900
      ENDIF
C
      AREA(1) = REAL(NOAREA(1))/PPMULT
      AREA(2) = REAL(NOAREA(2))/PPMULT
      AREA(3) = REAL(NOAREA(3))/PPMULT
      AREA(4) = REAL(NOAREA(4))/PPMULT
C
      GRID(1) = REAL(NOGRID(1))/PPMULT
      GRID(2) = REAL(NOGRID(2))/PPMULT
C
      POLE(1) = REAL(NOROTA(1))/PPMULT
      POLE(2) = REAL(NOROTA(2))/PPMULT
C
C     -----------------------------------------------------------------|
C*    Section 4.   Spectral to rotated grid-point
C     -----------------------------------------------------------------|
C
  400 CONTINUE
C
      IF( (NIREPR.EQ.JPSPHERE).OR.(NIREPR.EQ.JPSPHROT) ) THEN
C
C       Convert spectral to suitable global reduced gaussian grid
C
        CALL INTLOG(JP_DEBUG,
     X    'HNTFAPH: Spectral to suitable reduced gaussian',JPQUIET)
C
        NIRESO = ISEC2(2)
        NTRUNC = ISEC2(2)
        IF( LNORESO ) THEN
          NTRUNC = NORESO
          NGAUSS = 0
          HTYPE  = ''
          NS = 0.
          EW = 0.
          IRET = HSH2GG(NS,EW,NTRUNC,NGAUSS,HTYPE,KPTS,PLATS,ISIZE)
          IF( IRET.NE.0 ) THEN
            CALL INTLOG(JP_ERROR,
     X        'HNTFAPH: problem getting data for reduced grid',NTRUNC)
            HNTFAPH = JPROUTINE + 4
            GOTO 900
          ENDIF
          GOTO 401
        ENDIF

        IF( LARESOL ) THEN
          NS = 0.
          EW = 0.
          IF( LLATOUT ) THEN
            NS = GRID(1)
            EW = GRID(2)
            NTRUNC = 0
            NGAUSS = 0
            HTYPE = ''
          ELSE
            HTYPE = 'R'
          ENDIF
          IRET = HSH2GG(NS,EW,NTRUNC,NGAUSS,HTYPE,KPTS,PLATS,ISIZE)
          IF( IRET.NE.0 ) THEN
            CALL INTLOG(JP_ERROR,
     X        'HNTFAPH: problem getting data for reduced grid',NTRUNC)
            HNTFAPH = JPROUTINE + 4
            GOTO 900
          ENDIF
        ENDIF

C       Truncate if a smaller resolution has been requested
C
  401 CONTINUE
      IF( NTRUNC.LT.NIRESO ) THEN
       CALL INTLOG(JP_DEBUG,'HNTFAPH: Truncation changed from:',NIRESO)
       CALL INTLOG(JP_DEBUG,'HNTFAPH: to: ',NTRUNC)
       CALL INTLOG(JP_DEBUG,'HNTFAPH: Gaussian number is:',NGAUSS)
C
        ISHIZE =  (NTRUNC+1)*(NTRUNC+4)
        CALL JMEMHAN( 3, IZNFLDO, ISHIZE, 1, IERR)
        IF( IERR.NE.0 ) THEN
          CALL INTLOG(JP_FATAL,
     X      'HNTFAPH: Get scratch space failed',JPQUIET)
          HNTFAPH = JPROUTINE + 4
          GOTO 900
        ENDIF

C       Generate spherical harmonics with output truncation
        CALL SH2SH( ZNFELDI, NIRESO, ZNFLDO, NTRUNC )

C       Move new spherical harmonics to 'input' array
        ZNFELDI(1:ISHIZE) = ZNFLDO(1:ISHIZE)

      ELSE
          CALL INTLOG(JP_DEBUG,
     X      'HNTFAPH: Spectral to suitable reduced gaussian',JPQUIET)
C
          NTRUNC = ISEC2(2)
          NGAUSS = 0
          HTYPE  = ''
          NS = 0.
          EW = 0.
          IRET = HSH2GG(NS,EW,NTRUNC,NGAUSS,HTYPE,KPTS,PLATS,ISIZE)
          IF( IRET.NE.0 ) THEN
            CALL INTLOG(JP_ERROR,
     X        'HNTFAPH: problem getting data for reduced grid',NTRUNC)
            HNTFAPH = JPROUTINE + 4
            GOTO 900
          ENDIF

        ENDIF

C
C       Dynamically allocate memory for global reduced gaussian grid
C
        CALL JMEMHAN( 18, IRGGRID, ISIZE, 1, IRET)
        IF( IRET.NE.0 ) THEN
          CALL INTLOG(JP_ERROR,
     X      'HNTFAPH: memory alloc for reduced grid fail',JPQUIET)
          HNTFAPH = JPROUTINE + 4
          GOTO 900
        ENDIF

C       Set flag to show field is not a wind component
        NUVFLAG = 0

C       Create the reduced gaussian grid
        HOLDTYP = HOGAUST
        WEST = 0.0
        EAST = 360.0 - (360.0/(NGAUSS*4))
c       EMOS-199: adjusted for reduced_gg/octahedral
        IF (HTYPE.EQ.'O')  EAST = 360.0 - (360.0/FLOAT(KPTS(NGAUSS)))
        IF (HTYPE.NE.'R' .AND. HTYPE.NE.'O' .AND.
     X      HTYPE.NE.'F' .AND. HTYPE.NE.'U') THEN
          HTYPE = 'R'
        ENDIF
        CALL JAGGGP(ZNFELDI,NTRUNC,PLATS(1),PLATS(NGAUSS*2),WEST,
     X              EAST,NGAUSS,HTYPE,KPTS,RGGRID,NUVFLAG,IRET)
        IF( IRET.NE.0 ) THEN
          CALL INTLOG(JP_ERROR,
     X      'HNTFAPH: spectral to reduced gaussian failed',JPQUIET)
          HNTFAPH = JPROUTINE + 4
          GOTO 900
        ENDIF
        HOGAUST = HOLDTYP

        NCOUNT = 0
        DO LOOP = 1, (NGAUSS*2)
          NCOUNT= NCOUNT + KPTS(LOOP)
        ENDDO

        LSP2RGG = .TRUE.

        IF( NOREPR.EQ.JPFGGROT ) THEN
          CALL INTLOG(JP_DEBUG,
     X      'HNTFAPH: Convert gaussian to rotated gaussian',JPQUIET)
          GOTO 600
        ENDIF

      ENDIF
C
C     -----------------------------------------------------------------|
C*    Section 5.   Gaussian to rotated lat/long
C     -----------------------------------------------------------------|
C
  500 CONTINUE
C
      IF( (LLATOUT) .AND. (
     X        (NIREPR.EQ.JPQUASI) .OR.
     X        (NIREPR.EQ.JPGAUSSIAN) .OR.
     X        (LSP2RGG) )) THEN
C
        CALL INTLOG(JP_DEBUG,'HNTFAPH: Gauss to lat/lon',JPQUIET)
C
C       Dynamically allocate memory for rotated lat/long grid
C
        NLON = 1 + NINT((AREA(JPEAST)  - AREA(JPWEST)) /
     X         GRID(JPWESTEP)) !SC
        NLAT = 1 + NINT((AREA(JPNORTH) - AREA(JPSOUTH)) /
     X         GRID(JPNSSTEP)) !SC
C
        NOWE = NLON
        NONS = NLAT
C
        NUMPTS = NLON * NLAT
        ISIZE  = NUMPTS
        CALL JMEMHAN( 11, ISWORK, ISIZE, 1, IRET)
        IF( IRET.NE.0 ) THEN
          CALL INTLOG(JP_ERROR,
     X      'HNTFAPH: memory alloc for lat/long grid fail',JPQUIET)
          HNTFAPH = JPROUTINE + 5
          GOTO 900
        ENDIF
C
        LUSELSM = LSMFLD()
C
C       If original field was spectral, ...
C
        IF( LSP2RGG ) THEN
          IF( LUSELSM ) THEN
            IRET = HIRLSM(LO12PT,RGGRID,NCOUNT,NGAUSS,HTYPE,AREA,POLE,
     X                    GRID,SWORK,ISIZE,NLON,NLAT)
          ELSE
            IRET = HIRLAM(LO12PT,RGGRID,NCOUNT,NGAUSS,HTYPE,AREA,POLE,
     X                    GRID,SWORK,ISIZE,NLON,NLAT)
          ENDIF
C
        ELSE
C
C       If original field was gaussian, ...
C
          IRET = PDDEFS()
          NGAUSS = ISEC2(10)
          HTYPE  = GGHTYPE(NIREPR,NGAUSS,MILLEN)
cs        IF( LUSELSM ) THEN
          IF( LSM ) THEN
            IRET = HIRLSM(LO12PT,ZNFELDI,NCOUNT,NGAUSS,HTYPE,AREA,POLE,
     X                    GRID,SWORK,ISIZE,NLON,NLAT)
          ELSE
            IRET = HIRLAM(LO12PT,ZNFELDI,NCOUNT,NGAUSS,HTYPE,AREA,POLE,
     X                    GRID,SWORK,ISIZE,NLON,NLAT)
          ENDIF
C
        ENDIF
C
        IF( IRET.NE.0 ) THEN
          CALL INTLOG(JP_ERROR,
     X      'HNTFAPH: HIRLAM rotation failed',JPQUIET)
          HNTFAPH = JPROUTINE + 7
          GOTO 900
        ENDIF
C
        ISEC2(1) = JPREGROT
        ISEC4(1) = NOWE * NONS
C
      ENDIF
C
C     -----------------------------------------------------------------|
C*    Section 6.   Gaussian to rotated gaussian
C     -----------------------------------------------------------------|
C
  600 CONTINUE
C
      IF( (LSP2RGG.AND.(NOREPR.EQ.JPFGGROT)) .OR.
     X    (LSP2RGG.AND.(NOREPR.EQ.JPQGGROT)) .OR.
     X    (((NIREPR.EQ.JPQUASI).OR.(NIREPR.EQ.JPGAUSSIAN)) .AND.
     X     (NOREPR.EQ.JPFGGROT).OR.(NOREPR.EQ.JPQGGROT)) ) THEN
        CALL INTLOG(JP_DEBUG,
     X    'HNTFAPH: Gaussian to reduced gaussian',JPQUIET)
C
C       Dynamically allocate memory for rotated lat/long grid
C
C       ISIZE = NOGAUSS * NOGAUSS * 8
        ISIZE = (2*NOGAUSS) * (4*NOGAUSS + 20)  ! account for RGG/octahedral
        CALL JMEMHAN( 11, ISWORK, ISIZE, 1, IRET)
        IF( IRET.NE.0 ) THEN
          CALL INTLOG(JP_ERROR,
     X      'HNTFAPH: memory alloc for gaussian grid fail',JPQUIET)
          HNTFAPH = JPROUTINE + 6
          GOTO 900
        ENDIF
C
C       If original field was spectral, ...
C
        IF( LSP2RGG ) THEN
          IRET = HRG2GG(LO12PT,RGGRID,NGAUSS,AREA,POLE,
     X                  NOGAUSS,HOGAUST,SWORK,ISIZE,NUMPTS)
C
        ELSE
C
C       If original field was gaussian, ...
C
          NGAUSS = ISEC2(10)
          IRET = HRG2GG(LO12PT,ZNFELDI,NGAUSS,AREA,POLE,
     X                  NOGAUSS,HOGAUST,SWORK,ISIZE,NUMPTS)
        ENDIF
        IF( IRET.NE.0 ) THEN
          CALL INTLOG(JP_ERROR,
     X      'HNTFAPH: HRG2GG rotation failed',JPQUIET)
          HNTFAPH = JPROUTINE + 6
          GOTO 900
        ENDIF
C
        IF( (NOREPR.EQ.JPQUASI).OR.
     X      (NOREPR.EQ.JPQGGROT).OR.
     X      (NOREPR.EQ.JPFGGROT).OR.
     X      (NOREPR.EQ.JPGAUSSIAN) ) THEN
          ISEC2(1) = JPFGGROT
        ELSE
          ISEC2(1) = NOREPR
        ENDIF
C
        ISEC4(1) = NUMPTS
C
      ENDIF
C
C     -----------------------------------------------------------------|
C*    Section 7.   Lat/long to rotated lat/long
C     -----------------------------------------------------------------|
C
  700 CONTINUE
C
      IF( (NIREPR.EQ.JPREGULAR) ) THEN
C
C       Dynamically allocate memory for rotated lat/long grid
C
        NLON = 1 + NINT((AREA(JPEAST)  - AREA(JPWEST)) /
     X         GRID(JPWESTEP))
        NLAT = 1 + NINT((AREA(JPNORTH) - AREA(JPSOUTH)) /
     X         GRID(JPNSSTEP))
C
        NOWE = NLON
        NONS = NLAT
C
        NUMPTS = NLON * NLAT
        ISIZE  = NUMPTS
        CALL JMEMHAN( 11, ISWORK, ISIZE, 1, IRET)
        IF( IRET.NE.0 ) THEN
          CALL INTLOG(JP_ERROR,
     X      'HNTFAPH: memory alloc for lat/long grid fail',JPQUIET)
          HNTFAPH = JPROUTINE + 7
          GOTO 900
        ENDIF
C
        OLDGRID(1) = REAL(NIGRID(1))/100000.0
        OLDGRID(2) = REAL(NIGRID(2))/100000.0
        IRET = HLL2LL(LO12PT,ZNFELDI,OLDGRID,AREA,POLE,GRID,SWORK,ISIZE,
     X                NLON,NLAT)
C
        IF( IRET.NE.0 ) THEN
          CALL INTLOG(JP_ERROR,
     X      'HNTFAPH: HLL2LL rotation failed',JPQUIET)
          HNTFAPH = JPROUTINE + 7
          GOTO 900
        ENDIF
C
        ISEC2(1) = JPREGROT
        ISEC4(1) = NOWE * NONS
C
      ENDIF

C     move rotated field back into field original array
      ZNFELDI(1:NUMPTS) = SWORK(1:NUMPTS)

C     -----------------------------------------------------------------|
C*    Section 9.   Closedown.
C     -----------------------------------------------------------------|
C
  900 CONTINUE
C
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE JVOD2UV( VOR, DIV, KTIN, U, V, KTOUT)
C
C---->
C**** JVOD2UV
C
C     Purpose
C     -------
C
C     Calculate spherical harmonic coefficients of U*cos(lat) and
C     V*cos(lat) at triangular truncation KTOUT, given the coefficients
C     of divergence and vorticity at truncation KTIN.
C 
C
C     Interface
C     ---------
C
C     CALL JVOD2UV( VOR, DIV, KTIN, U, V, KTOUT)
C
C     Input
C     -----
C
C     VOR(KDIM1) = array of vorticity coefficients
C     DIV(KDIM1) = array of divergence coefficients
C     KTIN       = triangular truncation
C                  where KDIM1 = (KTIN+1)*(KTIN+2)
C
C
C     Output
C     ------
C
C     U(KDIM2)   = output array of U*cos(lat) coefficients
C     V(KDIM2)   = output array of V*cos(lat) coefficients
C     KTOUT      = output triangular truncation (KTOUT.le.KTIN)
C                  where KDIM2 = (KTOUT+1)*(KTOUT+4)
C
C
C     Method
C     ------
C
C     ??
C
C
C     Externals
C     ---------
C
C     None.
C
C
C     Author
C     ------
C
C     Jan Haseler       ECMWF      5th January 1981
C
C
C     Modifications
C     -------------
C
C     D. R. Roskilly    ECMWF      5th May 1987
C     Avoid calculating the extra values for U and V components so
C     that vorticity and divergence can be re-calculated if required.
C
C     ??                ??         15th February 1988
C     Subroutine renamed VOD2UV from DVTOUV.
C
C     K.Rider           ECMWF      21st August 1991
C     Version 2 inconsistently truncated U and V to T(ITOUT-1).
C     Changed so that vorticity and divergence are consistently truncated
C     to T105 (sic).
C     U and V are calculated with truncation T(ITOUT),with zero values at
C     the corner.
C     Vorticity and divergence can be recalculated if required, but only
C     truncated to T(ITOUT) since the higher coefficients have been lost.
C
C     J.D.Chambers       ECMWF      26th January 1995
C       Cleaned up code (?!)
C
C----<
C
      IMPLICIT NONE
C
C     Subroutine arguments
      COMPLEX VOR(*), DIV(*), U(*), V(*)
      INTEGER KTIN, KTOUT
C
C     Local variables
      INTEGER K, IMN, ITOUT, JM, JN, JMP, LOOP, SIZE
      REAL REARTH, ZM, ZN
      COMPLEX ZI
C
C     Statement functions
      REAL DD, SS
      REAL PM, PN
      DD(PM,PN) = -SQRT((PN*PN-PM*PM)/(4.*PN*PN-1.))/PN
      SS(PM,PN) = -PM/(PN*(PN+1.))
C
C ------------------------------------------------------------------
C*    Section 1.   Initialise
C ------------------------------------------------------------------
C
  100 CONTINUE
C
      ZI     = (0.0, 1.0)
      REARTH = 6.371E6
      K      = 1
      IMN    = 1
Cjdc  ITOUT  = MIN0(KTOUT,KTIN)
      ITOUT  = KTOUT
      SIZE = (ITOUT+1)*(ITOUT+2)/2
      DO LOOP = 1, SIZE
        U(LOOP) = 0.0
        V(LOOP) = 0.0
      ENDDO
C
C ------------------------------------------------------------------
C*    Section 2.   Handle coefficients for M < ITOUT; N = M
C ------------------------------------------------------------------
C
  200 CONTINUE
C
      DO 255 JM = 1,ITOUT
C
        ZM = JM - 1.0
        ZN = ZM
C
        IF ( JM.GT.1 ) THEN
          U(K) = (-DD(ZM,ZN+1.)*VOR(IMN+1)+ZI*SS(ZM,ZN)*DIV(IMN))*REARTH
          V(K) = ( DD(ZM,ZN+1.)*DIV(IMN+1)+ZI*SS(ZM,ZN)*VOR(IMN))*REARTH
        ELSE
          U(K) = (-DD(ZM,ZN+1.)*VOR(IMN+1))*REARTH
          V(K) = ( DD(ZM,ZN+1.)*DIV(IMN+1))*REARTH
        ENDIF
C
        IMN = IMN + 1
          K =   K + 1
        JMP =  JM + 1
C
C       When N < ITOUT-1
C
        IF (JMP.LT.ITOUT) THEN
          DO 235 JN = JMP, ITOUT-1
            ZN   = JN - 1.0
            U(K) = ( DD(ZM,ZN)*VOR(IMN-1)-DD(ZM,ZN+1)*VOR(IMN+1)
     X              +ZI*SS(ZM,ZN)*DIV(IMN))*REARTH
            V(K) = (-DD(ZM,ZN)*DIV(IMN-1)+DD(ZM,ZN+1)*DIV(IMN+1)
     X              +ZI*SS(ZM,ZN)*VOR(IMN))*REARTH
C
              K  =   K + 1
            IMN  = IMN + 1
C
 235      CONTINUE
C
C         When N = ITOUT - 1
C
          ZN   = ITOUT - 1
          U(K) = ( DD(ZM,ZN)*VOR(IMN-1)+ZI*SS(ZM,ZN)*DIV(IMN))*REARTH
          V(K) = (-DD(ZM,ZN)*DIV(IMN-1)+ZI*SS(ZM,ZN)*VOR(IMN))*REARTH
          K    = K + 1
          IMN  = IMN + 1
        ENDIF
C
C       When N = ITOUT
C
        ZN   = ITOUT
        U(K) = ( DD(ZM,ZN)*VOR(IMN-1))*REARTH
        V(K) = (-DD(ZM,ZN)*DIV(IMN-1))*REARTH
        K    = K + 1
C
C       When N = ITOUT + 1
C
        IMN  = IMN + 1 + KTIN-ITOUT
C
 255  CONTINUE
C
C ------------------------------------------------------------------
C*    Section 3.   Handle coefficients for M = ITOUT.
C ------------------------------------------------------------------
C
  300 CONTINUE
C
C     When N = ITOUT
C
      U(K) = 0.0
      V(K) = 0.0
C
C     Ignore M = ITOUT; N = ITOUT + 1
C
C     K    = K + 1
C
      RETURN
      END

      PROGRAM FILTERBUFR
C
C**** *FILTERBUFR*
C
C
C     PURPOSE.
C     --------
C         FILTER BUFR MESSAGES FROM INPUT FILE
C         ACCORDING TO REQUEST.
C
C
C**   INTERFACE.
C     ----------
C
C          NONE.
C
C     METHOD.
C     -------
C
C          THE INPUT FILE IS READ ONE MESSAGE AT A TIME.
C          BUFR MESSAGE IS EXPANDED AND CHECKED AGAINST 
C          REQUEST. IF BUFR MESSAGE IS NEEDED IT IS WRITTEN
C          INTO THE OUTPUT FILE. IF THERE IS MORE THAN ONE 
C          SUBSET IN THE BUFR MESSAGE, ONLY REQUESTED ARE REPACKED
C          AND WRITTEN INTO THE OUTPUT FILE.
C
C
C     EXTERNALS.
C     ----------
C
C         CALL BUSEL
C         CALL BUFREX
C         CALL BUFREN
C         CALL BUPRS0
C         CALL BUPRS1
C         CALL BUPRS2
C         CALL BUPRS3
C         CALL BUPRT
C         CALL BUUKEY
C
C     REFERENCE.
C     ----------
C
C          NONE.
C
C     AUTHOR.
C     -------
C
C          M. DRAGOSAVAC    *ECMWF*       06/12/93.
C
C
C     MODIFICATIONS.
C     --------------
C
C          NONE.
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
      PARAMETER(JSUP =   9,JSEC0=   3,JSEC1= 40,JSEC2= 4096 ,JSEC3= 4,
#ifdef JBPW_64
     1      JSEC4=   2,JBUFL=512000,JBPW =  64,JKEY=46, JELEM=160000,
#else
     1      JSEC4=   2,JBUFL=512000,JBPW =  32,JKEY=46, JELEM=160000,
#endif
     2          JWORK=4096000)
C
      PARAMETER (KELEM=160000)
      PARAMETER (KVALS=4096000)
C 
C
      COMMON /COMRQB/ CTIME,CAREA,CBLOCK,CIDN,CTYPE,CSBTYPE,CRDBT,
     1                CMDBT,CQC,CIDENTS(99),CMETHOD,CSENSOR
C
      COMMON /COMIRQC/ ITR,IDATES(2),ITIMES(2),IAR,FLATS(4),
     1                 IBL,IBLOCK(9999),ITP,ITYPES(9999),
     2                 ISBT,ISBTYPES(9999),IRDBT,IRDBTS(9999),
     3                 IMDBT,IMDBTS(9999),IQC,IQCS(9999),IDN,
     4                 IMT,IMETHOD(9999),ISE,ISENSOR(9999)
C
      DIMENSION KBUFF(JBUFL)
      DIMENSION KBUFR(JBUFL)
      DIMENSION KSUP(JSUP)  ,KSEC0(JSEC0),KSEC1(JSEC1)
      DIMENSION KSEC2(JSEC2),KSEC3(JSEC3),KSEC4(JSEC4)
      DIMENSION KEY(JKEY),KEY1(JKEY),KEY2(JKEY)
      DIMENSION KSEC11(JSEC1), KSEC12(JSEC1),KSEC31(JSEC3),KSEC32(JSEC3)
      REAL*8 VALUES(KVALS),VALUES1(KVALS),VALUES2(KVALS)
      REAL*8 RVIND,EPS
      DIMENSION KTDLST(KELEM),KTDEXP(KELEM)
      DIMENSION KDATA(200)
C
      CHARACTER*64 CNAMES(KELEM)
      CHARACTER*24 CUNITS(KELEM)
      CHARACTER*80 CVALS(KVALS)
      CHARACTER*9  CIDENTS
      CHARACTER*16000 CRECORD
      CHARACTER*256 CARG(8)
C
      CHARACTER*255 CRQFILE,CINFILE,COUTFILE,CREMFILE
      CHARACTER*4   CTIME,CAREA,CBLOCK,CIDN,CTYPE,CSBTYPE
      CHARACTER*4   CRDBT,CMDBT,CQC,CKIND,CMETHOD,CSENSOR
C
cs      EXTERNAL GETARG
C                                                                       
C
C     ------------------------------------------------------------------
C*          1. GET FILE NAMES.
C              ---------------
 100  CONTINUE
C
      IREAD=0
      ISING=0
      IMULTI=0
      IFILTER=0
      ITOTAL=0
      irem=0
C
      NBYTES=JBPW/8
      RVIND=1.7D38
      JBYTE=JBUFL*NBYTES
      ITR=0
      IAR=0
      IBL=0
      ITP=0
      ISBT=0
      IRDBT=0
      IMDBT=0
      IQC=0
      IDN=0
C
      CRQFILE=' '
      CINFILE=' '
      COUTFILE=' '
      CREMFILE=' '
      ocremfile=.false.
C
C              GET ARGUMENTS
C
C              1)  REQUEST FILE NAME
C              2)  INPUT FILE NAME
C              3)  OUTPUT FILE NAME
C
      NARG=IARGC()
      IF(NARG.lt.6) THEN
         PRINT*,'USAGE -- bufr_filter -r request -i infile -o outfile'
         PRINT*,'                     -t remfile'
         print*,'Keywords '
         print*,'AREA-___4  30.4 , -10.7, -20.3, 10.05'
         print*,'BLOK-___2 06,13'
         print*,'TIME-___2 yyyymmdd,hhmmss,yyyymmdd,hhmmss'
         print*,"IDEN-___2 '06100', '13275' "
         print*,'TYPE-___1 0'
         print*,'STYP-___2 1,3'
         print*,'RDBT-___2 ddhhmmss,ddhhmmss'
         print*,'MDBT-___2 ddhhmmss,ddhhmmss'
         print*,'LQCT-___1 70'
         print*,'IMET-___1  2'
         print*,'SENS-___2  3,4'
         STOP
      END IF
      DO 101 J=1,NARG
      CARG(J)=' '
      CALL GETARG(J,CARG(J))
 101  CONTINUE
C
      DO 102 J=1,NARG,2
      IF(CARG(J).EQ.'-i') THEN
         CINFILE=CARG(J+1)
         icin=index(CINFILE,' ')
         icin=icin-1
      ELSEIF(CARG(J).EQ.'-o') THEN
         COUTFILE=CARG(J+1)
         iout=index(COUTFILE,' ')
         iout=iout-1
      ELSEIF(CARG(J).EQ.'-r') THEN
         CRQFILE=CARG(J+1) 
         icrq=index(CRQFILE,' ')
         icrq=icrq-1
      ELSEIF(CARG(J).EQ.'-t') THEN
         CREMFILE=CARG(J+1)
         icrem=index(CREMFILE,' ')
         icrem=icrem-1
         ocremfile=.true.
      ELSE
          PRINT*,'USAGE -- bufr_filter -r request -i infile -o outfile'
          PRINT*,'                     -t remfile'
          STOP
      END IF
 102  CONTINUE
C
C
C*          1.1 OPEN IN REQUEST
C               ---------------
 110  CONTINUE
C
      OPEN(47,FILE=CRQFILE(1:icrq),IOSTAT=IOS,ERR=111,
     1        STATUS='OLD')
C
      CALL PBOPEN(IUN,COUTFILE(1:iout),'W',IRET)
      IF(IRET.NE.0) THEN
         PRINT*,'OPEN ERROR ',IOS,' ON FILE ',COUTFILE
         CALL MY_EXIT(2)
      END IF
C
      GO TO 120
C
 111  CONTINUE
C
      PRINT*,'OPEN ERROR ',IOS,' ON FILE ',CRQFILE
      CALL MY_EXIT(2)
C
C
C*          1.2 READ IN REQUEST
C               ---------------
 120  CONTINUE
C
C               TIME RANGE
C
      READ(47,'(A)',IOSTAT=IOS,ERR=121,END=130) CRECORD
      CKIND=CRECORD(1:4)
C
      IF(CKIND.EQ.'TIME') THEN
         READ(CRECORD,'(A4,1X,I4)',
     1         IOSTAT=IOS,ERR=121) CTIME,ITR
         READ(CRECORD(10:),*) (IDATES(I),ITIMES(I),I=1,ITR)
         PRINT*,CTIME,ITR,(IDATES(I),ITIMES(I),I=1,ITR)
         GO TO 120
      END IF
C
C               AREA
C
      IF(CKIND.EQ.'AREA') THEN
        READ(CRECORD,'(A4,1X,I4)',
     1         IOSTAT=IOS,ERR=121) CAREA,IAR
        READ(CRECORD(10:),*) (FLATS(I),I=1,IAR)
        PRINT*,CAREA,IAR,(FLATS(I),I=1,IAR)
        GO TO 120
      END IF
C
C               BLOCK 
C
      IF(CKIND.EQ.'BLOK') THEN
        READ(CRECORD,'(A4,1X,I4)',
     1         IOSTAT=IOS,ERR=121)  CBLOCK,IBL
        READ(CRECORD(10:),*) (IBLOCK(I),I=1,IBL)
        PRINT*,CBLOCK,IBL,(IBLOCK(I),I=1,IBL)
        GO TO 120
      END IF
C
C
C               METHOD
C
      IF(CKIND.EQ.'METH') THEN
        READ(CRECORD,'(A4,1X,I4)',
     1         IOSTAT=IOS,ERR=121)  CMETHOD,IMT
         READ(CRECORD(10:),*)  (IMETHOD(I),I=1,IMT)
        PRINT*,CMETHOD,IMT,(IMETHOD(I),I=1,IMT)
        GO TO 120
      END IF

      IF(CKIND.EQ.'SENS') THEN
        READ(CRECORD,'(A4,1X,I4)',
     1         IOSTAT=IOS,ERR=121)  CSENSOR,ISE
        READ(CRECORD(10:),*) (ISENSOR(I),I=1,ISE)
        PRINT*,CSENSOR,ISE,(ISENSOR(I),I=1,ISE)
        GO TO 120
      END IF

C
C               IDENT
C
      IF(CKIND.EQ.'IDEN') THEN
        READ(CRECORD,'(A4,1X,I4)',
     1         IOSTAT=IOS,ERR=121) CIDN,IDN
         READ(CRECORD(10:),*) (CIDENTS(I),I=1,IDN)
        PRINT*,CIDN,IDN,' ',(CIDENTS(I),I=1,IDN)
        GO TO 120
      END IF
C
C               TYPES
C
      IF(CKIND.EQ.'TYPE') THEN
        READ(CRECORD,'(A4,1X,I4)',
     1         IOSTAT=IOS,ERR=121)  CTYPE,ITP
         READ(CRECORD(10:),*) (ITYPES(I),I=1,ITP)
        PRINT*,CTYPE,ITP,(ITYPES(I),I=1,ITP)
        GO TO 120
      END IF
C
C               SUBTYPES
C
      IF(CKIND.EQ.'STYP') THEN
        READ(CRECORD,'(A4,1X,I4)',
     1         IOSTAT=IOS,ERR=121) CSBTYPE,ISBT
         READ(CRECORD(10:),*) (ISBTYPES(I),I=1,ISBT)
        print*, CSBTYPE,ISBT,(ISBTYPES(I),I=1,ISBT)
        GO TO 120
      END IF
C
C               RDB TIME
C
      IF(CKIND.EQ.'RDBT') THEN
        READ(CRECORD,'(A4,1X,I4)',
     1         IOSTAT=IOS,ERR=121) CRDBT,IRDBT
         READ(CRECORD(10:),*) (IRDBTS(I),I=1,IRDBT)
        PRINT*,CRDBT,IRDBT,(IRDBTS(I),I=1,IRDBT)
        GO TO 120
      END IF
C
C               MDB TIME
C
      IF(CKIND.EQ.'MDBT') THEN
        READ(CRECORD,'(A4,1X,I4)',
     1         IOSTAT=IOS,ERR=121)  CMDBT,IMDBT
        READ(CRECORD(10:),*) (IMDBTS(I),I=1,IMDBT)
        PRINT*,CMDBT,IMDBT,(IMDBTS(I),I=1,IMDBT)
        GO TO 120
      END IF
C
C               LOWEST QUALITY CONTROL
C
      IF(CKIND.EQ.'LQCT') THEN
        READ(CRECORD,'(A4,1X,I4)',
     1         IOSTAT=IOS,ERR=121) CQC,IQC
        READ(CRECORD(10:),*) (IQCS(I),I=1,IQC)
        PRINT*,CQC,IQC,(IQCS(I),I=1,IQC)
        GO TO 120
      END IF
C
C      GO TO 130
C
 121  CONTINUE
C
      PRINT*,'READ ERROR ',IOS,' ON ',CRQFILE(1:I),' FILE.'
      CALL MY_EXIT(2)
C---------------------------------------------------------------------
C*          1.3 OPEN FILE CONTAINING BUFR DATA.
C               -------------------------------
 130  CONTINUE
C
      IRET=0 
C
      CALL PBOPEN(IUNIT,CINFILE(1:icin),'R',IRET)
      IF(IRET.EQ.-1) STOP 'OPEN FAILED'
      IF(IRET.EQ.-2) STOP 'INVALID FILE NAME'
      IF(IRET.EQ.-3) STOP 'INVALID OPEN MODE SPECIFIED'
c
      IF(CREMFILE.NE.' ') then
         CALL PBOPEN(IUNIT2,CREMFILE(1:icrem),'W',IRET)
         IF(IRET.EQ.-1) STOP 'OPEN FAILED'
         IF(IRET.EQ.-2) STOP 'INVALID FILE NAME'
         IF(IRET.EQ.-3) STOP 'INVALID OPEN MODE SPECIFIED'
      end if

C
C     ----------------------------------------------------------------- 
C*          2.  READ BUFR MESSAGE.
C               ------------------
 200  CONTINUE
C
      IERR=0
      KBUFL=0
c     DO 201 I=1,JBUFL
c     KBUFF(I)=0
c201  CONTINUE
C
      IRET=0
      CALL PBBUFR(IUNIT,KBUFF,JBYTE,KBUFL,IRET) 
      IF(IRET.EQ.-1) THEN
         PRINT*,'NUMBER OF MESSAGES READ          ',IREAD
         PRINT*,'NUMBER OF OBSERVATIONS READ      ',ITOTAL
         PRINT*,'NUMBER OF SINGLE SUBSET MESSAGES ',ISING
         PRINT*,'NUMBER OF MULTISUBSET MESSAGES   ',IMULTI
         PRINT*,'NUMBER OF FILTERED OBSERVATIONS  ',IFILTER
         STOP 'EOF'
      END IF
      IF(IRET.EQ.-2) STOP 'FILE HANDLING PROBLEM' 
      IF(IRET.EQ.-3) STOP 'ARRAY TOO SMALL FOR PRODUCT'
C
      IREAD=IREAD+1
      JLEN=KBUFL
      KBUFL=KBUFL/NBYTES
C
C
C     -----------------------------------------------------------------
C*          2.1 EXPAND BUFR MESSAGE SECTION 0,1,2
C               ---------------------------------
 210  CONTINUE
C
      IERR=0
      CALL BUS012(KBUFL,KBUFF,KSUP,KSEC0,KSEC1,KSEC2,IERR)
      IF(IERR.NE.0) GO TO 200
C
      ITOTAL=ITOTAL+KSUP(6)
C
C            2.1.1  UNPACK KEY
C
      CALL BUUKEY(KSEC1,KSEC2,KEY,KSUP,KERR)
C
C              PRINT KEY
C
C      CALL BUPRS2(KSUP ,KEY)
C
C*           2.2 CHECK IF MESSAGE CONTAIN SUBSETS
C                --------------------------------
 220  CONTINUE
C
      IF(KSUP(6).EQ.1.AND.KSEC1(7).NE.87.and.
     1   KSEC1(7).NE.82.and.KSEC1(7).NE.83) THEN
C
C        CHECK IF MESSAGE IS REQUESTED
C
         OREQ=.FALSE.
         CALL KEYCHK(KSEC1,KEY,OREQ)
C
C        WRITE MESSAGE ON OUTPUT
C
         IF(OREQ)  THEN
           CALL PBWRITE(IUN,KBUFF,JLEN,IRET)
           IF(IRET.EQ.-1) THEN
              WRITE(*,'(A,A)') 'WRITE ERROR ON ',COUTFILE(1:K)
              CALL MY_EXIT(2)
           END IF
           IFILTER=IFILTER+1
           ISING=ISING+1
C
         else
           if(ocremfile) then
           CALL PBWRITE(IUNIT2,KBUFF,JLEN,IRET)
           IF(IRET.EQ.-1) THEN
              WRITE(*,'(A,A)') 'WRITE ERROR ON ',CREMFILE(1:K)
              CALL MY_EXIT(2)
           END IF
           irem=irem+1
           end if
         END IF
C
         GO TO 200
C
      END IF
C----------------------------------------------------------------
C
C            2.3 MULTI-SUBSET MESSAGE
C
 230  CONTINUE
C
      IF(KSUP(6).GT.1)  THEN
         KEL=KVALS/KSUP(6)
         IF(KEL.GT.JELEM) KEL=JELEM
      ELSE
         KEL=KELEM
      END IF
C
      CALL BUFREX(KBUFL,KBUFF,KSUP,KSEC0 ,KSEC1,KSEC2 ,KSEC3 ,KSEC4,
     1            KEL,CNAMES,CUNITS,KVALS,VALUES,CVALS,IERR)
C
      IF(IERR.NE.0) CALL MY_EXIT(2) 
C
C*          2.4 PRINT EXPANDED BUFR MESSAGE.
C               ----------------------------
 240  CONTINUE
C
C      CALL BUPRS0(KSEC0)
C      CALL BUPRS1(KSEC1)
C      CALL BUUKEY(KSEC1,KSEC2,KEY,KSUP,KERR)
C      CALL BUPRS2(KSUP ,KEY)
      CALL BUSEL(KTDLEN,KTDLST,KTDEXL,KTDEXP,KERR)
      IF(KERR.NE.0) CALL MY_EXIT(2)
C      CALL BUPRS3(KSEC3,KTDLEN,KTDLST,KTDEXL,KTDEXP,KEL,CNAMES)
C      IST=1
C      IEND=KSUP(6)
C      CALL BUPRT(ICODE,IST,IEND,KEL,CNAMES,CUNITS,CVALS,
C     1           KVALS,VALUES,KSUP,KSEC1,IERR)
C
C
C            2.5 COLLECT REQUESTED MESSAGES.
C
 250  CONTINUE
C
      IERR=0
C
      OREQ=.FALSE.
      CALL MESSCHCK(OREQ,KEY,KTDEXL,KTDEXP,
     1              KSUP,KSEC0 ,KSEC1,KSEC2 ,KSEC3 ,KSEC4,
     1              KEL,CNAMES,CUNITS,KVALS,VALUES,CVALS,
     3                    ksec11,ksec12,ksec31,ksec32,
     4                    key1,key2,values1,values2)
C
C     IF(.NOT.OREQ.AND.OCREMFILE) THEN
      IF(ksec31(3).eq.0.AND.OCREMFILE) THEN
C
           CALL PBWRITE(IUNIT2,KBUFF,JLEN,IRET)
           IF(IRET.EQ.-1) THEN
              WRITE(*,'(A,A)') 'WRITE ERROR ON ',CREMFILE(1:K)
              CALL MY_EXIT(2)
           END IF
           IREM=IREM+1
         GO TO 200
C
      END IF
C     -----------------------------------------------------------------
C*          3. PACK BUFR MESSAGE BACK INTO BUFR.
C              ---------------------------------
 300  CONTINUE
C
      KBUFL=JBUFL
C
C     GET REPLICATION FACTORS
C
      if(ksec31(3).ne.0) then
         KK=0
         DO 301 K=1,KSUP(5)
         IF(KTDEXP(K).EQ.31001.OR.KTDEXP(K).EQ.31002.OR.
     1      KTDEXP(K).EQ.31011.OR.KTDEXP(K).EQ.31012) THEN
            KK=KK+1
            KDATA(KK)=NINT(VALUES1(K))
         END IF
 301     CONTINUE
C
         KDLEN=2
         IF(KK.NE.0) KDLEN=KK
C
C*          3.2 ENCODE DATA INTO BUFR MESSAGE.
C               ------------------------------
 320  CONTINUE
C
C        Create key if multi subset data
C
         CALL BUPKEY(KEY1,KSEC11,KSEC2,IERR)
         IERR=0
         CALL BUFREN( KSEC0,KSEC11,KSEC2,KSEC31,KSEC4,
     1                KTDLEN,KTDLST,KDLEN,KDATA,KEL,
     2                KVALS,VALUES1,CVALS,KBUFL,KBUFR,IERR)
C
         IF(IERR.NE.0) then
           print*,'filter'
            print*,'----------------',iread
            CALL MY_EXIT(2)
         end if
C
         ILNGTH=KBUFL*NBYTES
C
C        IF(OREQ) THEN
            CALL PBWRITE(IUN,KBUFR,ILNGTH,IRET)
            IF(IRET.EQ.-1) THEN
               PRINT*,'WRITE ERROR ON FILE ',COUTFILE(1:K)
               CALL MY_EXIT(2)
            END IF
            IFILTER=IFILTER+KSEC3(3)
c        END IF
C
         IMULTI=IMULTI+1
c
      END IF
C
      IF(KSEC32(3).NE.0.AND. OCREMFILE) THEN

         KK=0
         DO  K=1,KSUP(5)
         IF(KTDEXP(K).EQ.31001.OR.KTDEXP(K).EQ.31002.OR.
     1      KTDEXP(K).EQ.31011.OR.KTDEXP(K).EQ.31012) THEN
            KK=KK+1
            KDATA(KK)=NINT(VALUES2(K))
         END IF
         END DO
C
         KDLEN=2
         IF(KK.NE.0) KDLEN=KK
C
C*          3.2 ENCODE DATA INTO BUFR MESSAGE.
C               ------------------------------
C
C        Create key if multi subset data
C
         CALL BUPKEY(KEY2,KSEC12,KSEC2,IERR)
         IERR=0
         CALL BUFREN( KSEC0,KSEC12,KSEC2,KSEC32,KSEC4,
     1                KTDLEN,KTDLST,KDLEN,KDATA,KEL,
     2                KVALS,VALUES2,CVALS,KBUFL,KBUFR,IERR)
C
         IF(IERR.NE.0) then
            print*,'reminder'
            print*,'----------------',iread
            CALL MY_EXIT(2)
         end if
C
         ILNGTH=KBUFL*NBYTES
C
c        IF(OREQ) THEN
            CALL PBWRITE(IUNIT2,KBUFR,ILNGTH,IRET)
            IF(IRET.EQ.-1) THEN
               PRINT*,'WRITE ERROR ON FILE ',COUTFILE(1:K)
               CALL MY_EXIT(2)
            END IF
c        END IF
C
      END IF
C
      GO TO 200
C
 321  CONTINUE
C
      WRITE(*,'(A)') 'ERROR WRITING INTO ',COUTFILE
      CALL MY_EXIT(2)
C     -----------------------------------------------------------------
C      
 400  CONTINUE
C
      END
      SUBROUTINE KEYCHK(KSEC1,KEY,OREQ)
C
C**** *KEYCHK*
C
C
C     PURPOSE.
C     --------
C         FILTER BUFR MESSAGES FROM INPUT FILE
C         ACCORDING TO REQUEST.
C
C
C**   INTERFACE.
C     ----------
C
C          NONE.
C
C     METHOD.
C     -------
C
C         RDB KEY IN UNPACKED FORM IS USED TO CHECK AGAINST
C         USER REQUEST. IF REQUST IS MEETED LOGICAL VARIABLE
C         IS SET TO TRUE.
C          
C
C     EXTERNALS.
C     ----------
C
C         NONE.
C
C     REFERENCE.
C     ----------
C
C          NONE.
C
C     AUTHOR.
C     -------
C
C          M. DRAGOSAVAC    *ECMWF*       06/12/93.
C
C
C     MODIFICATIONS.
C     --------------
C
C          NONE.
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
      COMMON /COMRQB/ CTIME,CAREA,CBLOCK,CIDN,CTYPE,CSBTYPE,CRDBT,
     1                CMDBT,CQC,CIDENTS(99), CMETHOD, CSENSOR
C
      COMMON /COMIRQC/ ITR,IDATES(2),ITIMES(2),IAR,FLATS(4),
     1                 IBL,IBLOCK(9999),ITP,ITYPES(9999),
     2                 ISBT,ISBTYPES(9999),IRDBT,IRDBTS(9999),
     3                 IMDBT,IMDBTS(9999),IQC,IQCS(9999),IDN,
     4                 IMT,IMETHOD(9999),ISE,ISENSOR(9999)
C
      CHARACTER*4 CTIME,CAREA,CBLOCK,CTYPE,CSBTYPE,CRDBT,CMDBT,CQC
      CHARACTER*4 CIDN,CMETHOD,CSENSOR
      CHARACTER*9 CIDENTS,CIDENT
      DIMENSION KSEC1(*),KEY(*)
      character*14 cdate_first,cdate_last,cdate_current
C
C     -----------------------------------------------------------------
C*                  1. RDB KEY DEFINITION
C
 100  CONTINUE
C
C
C            KEY( 1)-- LENGTH OF SECTION 2 (BYTES)
C            KEY( 2)-- RDB TYPE
C            KEY( 3)-- RDB SUBTYPE
C            KEY( 4)-- YEAR
C            KEY( 5)-- MONTH
C            KEY( 6)-- DAY
C            KEY( 7)-- HOUR
C            KEY( 8)-- MINUTE
C            KEY( 9)-- SECOND
C            KEY(10)-- LONGITUDE1
C            KEY(11)-- LATITUDE1
C            KEY(12)-- LONGITUDE2
C            KEY(13)-- LATITUDE2
C            KEY(14)-- NUMBER OF SUBSETS
C            KEY(15)-- IDENT (NUMERIC)
C            KEY(16)-- IDENT ( CCITTIA5) ONE CHARACTER
C            KEY(17)-- IDENT ( CCITTIA5) ONE CHARACTER
C            KEY(18)-- IDENT ( CCITTIA5) ONE CHARACTER
C            KEY(19)-- IDENT ( CCITTIA5) ONE CHARACTER
C            KEY(20)-- IDENT ( CCITTIA5) ONE CHARACTER
C            KEY(21)-- IDENT ( CCITTIA5) ONE CHARACTER
C            KEY(22)-- IDENT ( CCITTIA5) ONE CHARACTER
C            KEY(23)-- IDENT ( CCITTIA5) ONE CHARACTER
C            KEY(24)-- IDENT ( CCITTIA5) ONE CHARACTER
C            KEY(25)-- TOTAL BUFR MESSAGE LENGTH
C            KEY(26)-- DAY    (RDB INSERTION)
C            KEY(27)-- HOUR   (RDB INSERTION)
C            KEY(28)-- MINUTE (RDB INSERTION)
C            KEY(29)-- SECOND (RDB INSERTION)
C            KEY(30)-- DAY    (MDB INSERTION)
C            KEY(31)-- HOUR   (MDB INSERTION)
C            KEY(32)-- MINUTE (MDB INSERTION)
C            KEY(33)-- SECOND (MDB INSERTION)
C            KEY(34)-- CORRECTION NUMBER
C            KEY(35)-- PART
C            KEY(36)-- 0
C            KEY(37)-- CORRECTION NUMBER
C            KEY(38)-- PART
C            KEY(39)-- 0
C            KEY(40)-- CORRECTION NUMBER
C            KEY(41)-- PART
C            KEY(42)-- 0
C            KEY(43)-- CORRECTION NUMBER
C            KEY(44)-- PART
C            KEY(45)-- 0
C            KEY(46)-- THE LOWEST Q/C % CONFIDENCE
C
C     -----------------------------------------------------------------
C
C*               1.1 GET TIME,LATITUDE,LONGITUDE,IDENT,TYPE,SUBTYPE
C                    AND RECEPTION TIMES
C
 110  CONTINUE
C
C                    TIME
C
          write(cdate_current(1:4),'(i4.4)') KEY(4)
          write(cdate_current(5:6),'(i2.2)') KEY(5)
          write(cdate_current(7:8),'(i2.2)') KEY(6)
          write(cdate_current(9:10),'(i2.2)') KEY(7)
          write(cdate_current(11:12),'(i2.2)') KEY(8)
          cdate_current(13:14)='00'
c         write(cdate_current(13:14),'(i2.2)') KEY(9)
c
          write(cdate_first(1:8),'(i8.8)') IDATES(1)
          write(cdate_first(9:14),'(i6.6)') ITIMES(1)
c
          write(cdate_last(1:8),'(i8.8)') IDATES(2)
          write(cdate_last(9:14),'(i6.6)') ITIMES(2)
c
C
C                    LAT AND LONG
C
      RKLAT=(KEY(11)-9000000)/100000.
      RKLON=(KEY(10)-18000000)/100000.
      if(KEY(11).eq.0) RKLAT=-90.0
      if(KEY(10).eq.0) RKLON=-180.0
C
C                    IDENT
C
 105  CONTINUE
C
      CIDENT=' '
      IF(KEY(3).EQ.51.OR.KEY(3).EQ.61.OR.
     1   KEY(3).EQ.62.OR.KEY(3).EQ.63.OR.
     1   KEY(3).EQ.71.OR.KEY(3).EQ.72.OR.
     1   KEY(3).EQ.73.OR.KEY(3).EQ.82.OR.
     1   KEY(3).EQ.83.OR.KEY(3).EQ.84.OR.
     1   KEY(3).EQ.85.OR.KEY(3).EQ.121.OR.
     1   KEY(3).EQ.86.OR.KEY(3).EQ.87.OR.
     1   KEY(3).EQ.88.OR.KEY(3).EQ.89.OR.
     1   KEY(3).EQ.122.OR.KEY(3).EQ.123.OR.
     1   KEY(3).EQ.124.OR.KEY(3).EQ.125.OR.
     1   KEY(3).EQ.65.OR.KEY(3).EQ.75) THEN
         WRITE(CIDENT(1:3),'(I3)',IOSTAT=IOS) KEY(15)
         IF(IOS.NE.0) THEN
            PRINT*,'INTERNAL WRITE ERROR.'
            CALL MY_EXIT(2)
         END IF
         IF(CIDENT(1:1).EQ.' ') THEN
            CIDENT(1:1)=CIDENT(2:2)
            CIDENT(2:2)=CIDENT(3:3)
            CIDENT(3:3)=' '
         END IF
         IF(CIDENT(1:1).EQ.' ') THEN
            CIDENT(1:1)=CIDENT(2:2)
            CIDENT(2:2)=CIDENT(3:3)
            CIDENT(3:3)=' '
         END IF
         IDL=INDEX(CIDENT,' ')
         IDL=IDL-1
      ELSE
         J=0
         DO 101 I=16,24
         J=J+1
         CIDENT(J:J)=CHAR(KEY(I))
 101     CONTINUE
         IDL=INDEX(CIDENT,' ')
         IDL=IDL-1
C         IF(IDL.EQ.0) THEN
C            J=15
C            DO 102 I=16,24
C            IF(KEY(I).EQ.32) THEN 
C               GO TO 102
C            ELSE
C               J=J+1
C               KEY(J)=KEY(I)
C               KEY(I)=32
C            END IF
C 102      CONTINUE
C          GO TO 105
C          END IF
      END IF
C
C                    TYPE AND SUBTYPE
C
      IKTYPE=KEY(2)
      IKSBTYPE=KEY(3)
C
C                    LOWEST QUALITY CONTROL
      IKQC=KEY(46)
C
C                    RECEPTION TIME
C
      IKRDB=KEY(26)*10**6+KEY(27)*10**4+KEY(28)*10**2+KEY(29)
      IKMDB=KEY(30)*10**6+KEY(31)*10**4+KEY(32)*10**2+KEY(33)
C     ------------------------------------------------------------------
C*                   2. CHECK MATCHING
C
 200  CONTINUE
C
C     CHECK TIME
C
      IF(ITR.NE.0) THEN
          IF(ITR.EQ.1) THEN
             if(cdate_current.ne.cdate_first) then
                OREQ=.FALSE.
                RETURN
             END IF
          ELSE
             if(cdate_current.lt.cdate_first.or.
     1          cdate_current.gt.cdate_last) then
                OREQ=.FALSE.
                RETURN
             END IF
          END IF
      END IF
C
C     CHECK AREA
C
      IF(IAR.NE.0) THEN
         IF(RKLAT.GT.FLATS(1).OR.RKLAT.LT.FLATS(3)) THEN
            OREQ=.FALSE.
            RETURN
         ELSE
            IF(FLATS(4).LT.FLATS(2)) THEN
               RLO3=180.00000
               RLO4=-180.00000
               IF(RKLON.LT.FLATS(2).OR.RKLON.GT.RLO3) THEN
                  IF(RKLON.LT.RLO4.OR.RKLON.GT.FLATS(4)) THEN
                     OREQ=.FALSE.
                     RETURN
                  END IF
               END IF
            ELSE
               IF(RKLON.LT.FLATS(2).OR.RKLON.GT.FLATS(4)) THEN
                  OREQ=.FALSE.
                  RETURN
               END IF
            END IF
         END IF
      END IF
C
C     CHECK BLOCK
C
      IF(IBL.NE.0) THEN
         IKBLOCK=(KEY(16)-48)*10+KEY(17)-48
         OBLOCK=.FALSE.
         DO 202 I=1,IBL
         IF(IKBLOCK.EQ.IBLOCK(I)) OBLOCK=.TRUE. 
 202     CONTINUE
         IF(.NOT.OBLOCK) THEN
            OREQ=.FALSE.
            RETURN
         END IF
      END IF
C
C     IDENT
C
      IF(IDN.NE.0) THEN
         OCIDENT=.FALSE.
         DO 203 I=1,IDN
         IF(CIDENT(1:IDL).EQ.CIDENTS(I)(1:IDL)) OCIDENT=.TRUE.
 203     CONTINUE
         IF(.NOT.OCIDENT) THEN
            OREQ=.FALSE.
            RETURN
         END IF
      END IF
C
C     TYPE
C
      IF(ITP.NE.0) THEN
         OTYPE=.FALSE.
         DO 204 I=1,ITP
         IF(KSEC1(6).EQ.ITYPES(I)) OTYPE=.TRUE.
 204     CONTINUE
         IF(.NOT.OTYPE) THEN
           OREQ=.FALSE.
           RETURN
         END IF
      END IF
C
C     SUBTYPE
C
      IF(ISBT.NE.0) THEN
         OSBT=.FALSE.
         DO 205 I=1,ISBT
         IF(ISBTYPES(I).EQ.KSEC1(7)) OSBT=.TRUE.
 205     CONTINUE
         IF(.NOT.OSBT) THEN
           OREQ=.FALSE.
           RETURN
         END IF
      END IF
C
C     LOWEST QUALITY 
C
      IF(IQC.NE.0) THEN
         IF(IQC.EQ.1) THEN
            IF(IKQC.NE.IQCS(1)) THEN
               OREQ=.FALSE.
               RETURN
            END IF
         ELSE
            IF(IKQC.LT.IQCS(1).OR.IKQC.GT.IQCS(2)) THEN
               OREQ=.FALSE.
               RETURN
            END IF
         END IF
      END IF
C
C     RDB TIME 
C
      IF(IRDBT.NE.0) THEN
         IF(IRDBT.EQ.1) THEN
            IF(IKRDB.NE.IRDBTS(1)) THEN
               OREQ=.FALSE.
               RETURN
            END IF
         ELSE
            IF(IKRDB.LT.IRDBTS(1).OR.IKRDB.GT.IRDBTS(2)) THEN
               OREQ=.FALSE.
               RETURN
            END IF
         END IF
      END IF
C
C     MDB TIME 
C
      IF(IMDBT.NE.0) THEN
         IF(IMDBT.EQ.1) THEN
            IF(IKMDB.NE.IMDBTS(1)) THEN
               OREQ=.FALSE.
               RETURN
            END IF
         ELSE
            IF(IKMDB.LT.IMDBTS(1).OR.IKMDB.GT.IMDBTS(2)) THEN
               OREQ=.FALSE.
               RETURN
            END IF
         END IF
      END IF

C
C     Computational method
C
      if(imt.ne.0) then
         oreq=.false.
         return
      end if
C     -----------------------------------------------------------------
      OREQ=.TRUE.
C
      RETURN
C
 401  CONTINUE
C
      PRINT*,'INTERNAL READ ERROR.'
      CALL MY_EXIT(2)
      END
      SUBROUTINE MESSCHCK(OREQ,KEY,KTDEXL,KTDEXP,
     1                    KSUP,KSEC0 ,KSEC1,KSEC2 ,KSEC3 ,
     1                    KSEC4,KEL,CNAMES,CUNITS,KVALS,VALUES,CVALS,
     3                    ksec11,ksec12,ksec31,ksec32,
     4                    key1,key2,values1,values2)
C
C**** *MESSCHK*
C
C
C     PURPOSE.
C     --------
C         FILTER BUFR MESSAGES FROM INPUT FILE
C         ACCORDING TO REQUEST.
C
C
C**   INTERFACE.
C     ----------
C
C          NONE.
C
C     METHOD.
C     -------
C
C          IN THE CASE OF MULTI-SUBSET BUFR MESSAGES TO FIND REQUESTED
C          OBSERVATION IT IS NEEDED TO USE FULLY EXPANDED MESSAGE.
C          EVERY SUBSET IS CHECKED AGAINST REQUEST. NEEDED MESSAGES ARE
C          COLLECTED AND RETURNED, AND LOGICAL VARIABLE OREQ SET TO 
C          TRUE.
C          
C
C     EXTERNALS.
C     ----------
C
C         NONE.
C
C     REFERENCE.
C     ----------
C
C          NONE.
C
C     AUTHOR.
C     -------
C
C          M. DRAGOSAVAC    *ECMWF*       06/12/93.
C
C
C     MODIFICATIONS.
C     --------------
C
C          NONE.
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
      COMMON /COMRQB/ CTIME,CAREA,CBLOCK,CIDN,CTYPE,CSBTYPE,CRDBT,
     1                CMDBT,CQC,CIDENTS(99),CMETHOD, CSENSOR
C
      COMMON /COMIRQC/ ITR,IDATES(2),ITIMES(2),IAR,FLATS(4),
     1                 IBL,IBLOCK(9999),ITP,ITYPES(9999),
     2                 ISBT,ISBTYPES(9999),IRDBT,IRDBTS(9999),
     3                 IMDBT,IMDBTS(9999),IQC,IQCS(9999),IDN,
     3                 IMT,IMETHOD(9999),ISE,ISENSOR(9999)
C
      CHARACTER*4 CTIME,CAREA,CBLOCK,CTYPE,CSBTYPE,CRDBT,CMDBT,CQC
      CHARACTER*4 CIDN,CMETHOD , CSENSOR
      CHARACTER*9 CIDENTS,CIDENT
      DIMENSION KSEC1(*),KSUP(*),KSEC2(*),KSEC3(*),KSEC4(*)
      REAL*8 VALUES(*),VALUES1(*),VALUES2(*)
      REAL*8 RVIND,EPS
      DIMENSION KTDEXP(*),KEY(*)
      CHARACTER*(*) CVALS(*),CNAMES(*),CUNITS(*)
      DIMENSION KSEC11(*),KSEC12(*),KSEC31(*),KSEC32(*)
      DIMENSION KEY1(*),KEY2(*)
      CHARACTER*14 CDATE_FIRST,CDATE_LAST,CDATE_CURRENT
C
C     -----------------------------------------------------------------
C
C                1. FIND TIME,LAT,LONG,IDENT,TYPE,SUBTYPE E.T.C.
C
 100  CONTINUE
C
      NN1=0                   ! NUMBER OF SUBSETS
      NN2=0
      ksec31(3)=0
      ksec32(3)=0
C
      IPAID=0                ! AICRAFT ID
      IPSID=0                ! SATELLITE ID
      IPBUOY=0               ! BUOY/PLATFORM ID
      IPARN=0                ! AIRCRAFT REGISTRATION NUMBER
      IPSHIP=0               ! SHIP CALL SIGN
      IPBLOK=0               ! BLOCK NUMBER
      IPSTAT=0               ! STATION NUMBER
      IPYEAR=0
      IPMONTH=0
      IPDAY=0
      IPHOUR=0
      IPMINUTE=0
      IPSECOND=0
      IPLAT=0
      IPLON=0
      IMETH=0                ! Wind computational method
      ISENS=0                ! Satellite sensor indicator
C
      OREQ1=.FALSE.
C
      do i=1,26
        IF(KTDEXP(I).EQ.001006) IPAID=I
        IF(KTDEXP(I).EQ.001007) IPSID=I
        IF(KTDEXP(I).EQ.001005) IPBUOY=I
        IF(KTDEXP(I).EQ.001008) IPARN=I
        IF(KTDEXP(I).EQ.001011) IPSHIP=I
        IF(KTDEXP(I).EQ.001001) IPBLOK=I
        IF(KTDEXP(I).EQ.001002) IPSTAT=I
        IF(KTDEXP(I).EQ.004001) IPYEAR=I
        IF(KTDEXP(I).EQ.004002) IPMONTH=I
        IF(KTDEXP(I).EQ.004003) IPDAY=I
        IF(KTDEXP(I).EQ.004004) IPHOUR=I
        IF(KTDEXP(I).EQ.004005) IPMINUTE=I
        IF(KTDEXP(I).EQ.004006) IPSECOND=I
        IF(KTDEXP(I).EQ.005001) IPLAT=I
        IF(KTDEXP(I).EQ.006001) IPLON=I
        IF(KTDEXP(I).EQ.005002) IPLAT=I
        IF(KTDEXP(I).EQ.006002) IPLON=I
        IF(KTDEXP(I).EQ.002023) IMETH=I
        IF(KTDEXP(I).EQ.002048) ISENS=I
      end do
C
C
C                    IDENT
C
      CIDENT=' '
C
C                    TYPE AND SUBTYPE
C
      IKTYPE=KEY(2)
      IKSBTYPE=KEY(3)
C
C
C                    LOWEST QUALITY CONTROL
      IKQC=KEY(46)
C
C                    RECEPTION TIME
C
      IKRDB=KEY(26)*10**6+KEY(27)*10**4+KEY(28)*10**2+KEY(29)
      IKMDB=KEY(30)*10**6+KEY(31)*10**4+KEY(32)*10**2+KEY(33)
C     ------------------------------------------------------------------
C*                   2. CHECK MATCHING
C
 200  CONTINUE
C
C
C     TYPE
C
      IF(ITP.NE.0) THEN
         OTYPE=.FALSE.
         DO 204 IX=1,ITP
         IF(KSEC1(6).EQ.ITYPES(IX)) OTYPE=.TRUE.
 204     CONTINUE
         IF(.NOT.OTYPE) THEN
           OREQ=.FALSE.
           RETURN
         ELSE
           OREQ=.TRUE.
         END IF
      END IF
C
C     SUBTYPE
C
      IF(ISBT.NE.0) THEN
         OSBT=.FALSE.
         DO 205 IX=1,ISBT
         IF(ISBTYPES(IX).EQ.KSEC1(7)) OSBT=.TRUE.
 205     CONTINUE
         IF(.NOT.OSBT) THEN
           OREQ=.FALSE.
           RETURN
         ELSE
           OREQ=.TRUE.
         END IF
      END IF
C
C     LOWEST QUALITY
C
      IF(IQC.NE.0) THEN
         IF(IQC.EQ.1) THEN
            IF(IKQC.NE.IQCS(1)) THEN
               OREQ=.FALSE.
               RETURN
            ELSE
               OREQ=.TRUE.
            END IF
         ELSE
            IF(IKQC.LT.IQCS(1).AND.IKQC.GT.IQCS(2)) THEN
               OREQ=.FALSE.
               RETURN
            ELSE
               OREQ=.TRUE.
            END IF
         END IF
      END IF
C
C     RDB TIME
C
      IF(IRDBT.NE.0) THEN
         IF(IRDBT.EQ.1) THEN
            IF(IKRDB.NE.IRDBTS(1)) THEN
               OREQ=.FALSE.
               RETURN
            ELSE
               OREQ=.TRUE.
            END IF
         ELSE
            IF(IKRDB.LT.IRDBTS(1).OR.IKRDB.GT.IRDBTS(2)) THEN
               OREQ=.FALSE.
               RETURN
            ELSE
               OREQ=.TRUE.
            END IF
         END IF
      END IF
C
C     MDB TIME
C
      IF(IMDBT.NE.0) THEN
         IF(IMDBT.EQ.1) THEN
            IF(IKMDB.NE.IMDBTS(1)) THEN
               OREQ=.FALSE.
               RETURN
            ELSE
               OREQ=.TRUE.
            END IF
         ELSE
            IF(IKMDB.LT.IMDBTS(1).OR.IKMDB.GT.IMDBTS(2)) THEN
               OREQ=.FALSE.
               RETURN
            ELSE
               OREQ=.TRUE.
            END IF
         END IF
      END IF
C
C
      DO 201 I=1,KSEC3(3)
C
C     CHECK TIME
C
      OREQ1=.false.
c
      IKEL=(I-1)*KEL
      IF(ITR.NE.0) THEN
          IY=IPYEAR+IKEL
          IM=IPMONTH+IKEL
          ID=IPDAY+IKEL
          IH=IPHOUR+IKEL
          IMM=IPMINUTE+IKEL
          IS=IPSECOND+IKEL
          write(cdate_current(1:4),'(i4.4)') NINT(VALUES(IY))
          write(cdate_current(5:6),'(i2.2)') NINT(VALUES(IM))
          write(cdate_current(7:8),'(i2.2)') NINT(VALUES(ID))
          write(cdate_current(9:10),'(i2.2)') NINT(VALUES(IH))
          write(cdate_current(11:12),'(i2.2)') NINT(VALUES(IMM))
          if(IS.eq.0) then
             cdate_current(13:14)='00'
          else
          write(cdate_current(13:14),'(i2.2)') NINT(VALUES(IS))
          end if
c
          write(cdate_first(1:8),'(i8.8)') IDATES(1)
          write(cdate_first(9:14),'(i6.6)') ITIMES(1)
c
          write(cdate_last(1:8),'(i8.8)') IDATES(2)
          write(cdate_last(9:14),'(i6.6)') ITIMES(2)
c
          IF(ITR.EQ.1) THEN
             if(cdate_current.ne.cdate_first) then
                OREQ=.FALSE.
                GO TO 2011
             else
                OREQ1=.TRUE.
             END IF
          ELSE
             if(cdate_current.lt.cdate_first.or.
     1          cdate_current.gt.cdate_last) then
                   OREQ=.FALSE.
                   GO TO 2011
             else
                OREQ1=.TRUE.
             END IF
          END IF
      END IF
C
C     CHECK AREA
C
      IF(IAR.NE.0.and.IPLAT.ne.0.and.IPLON.ne.0) THEN
         ILA=IPLAT+IKEL
         ILO=IPLON+IKEL
         RKLAT=VALUES(ILA)
         RKLON=VALUES(ILO)
C
         IF(RKLAT.GT.FLATS(1).OR.RKLAT.LT.FLATS(3).OR.
     1      RKLON.LT.FLATS(2).OR.RKLON.GT.FLATS(4)) THEN
            OREQ=.FALSE.
            GO TO 2011
         ELSE
             OREQ1=.TRUE.
         END IF
      END IF
C
C     CHECK BLOCK
C
      IF(IBL.NE.0.and.IPBLOK.ne.0) THEN
         IB=IPBLOK+IKEL
         IKBLOCK=NINT(VALUES(IB))
         OBLOCK=.FALSE.
         DO 202 IX=1,IBL
         IF(IKBLOCK.EQ.IBLOCK(IX)) OBLOCK=.TRUE. 
 202     CONTINUE
         IF(.NOT.OBLOCK) THEN
            OREQ=.FALSE.
            GO TO 2011
         ELSE
            OREQ1=.TRUE.
         END IF
      END IF
C
C     CHECK COMPUTATIONAL METHOD
C
      IF(IMT.NE.0.AND.IMETH.NE.0) THEN
         IM=IMETH+IKEL
         IKMETHOD=NINT(VALUES(IM))
         OMETHOD=.false.
         do  ix=1,IMT
         IF(IKMETHOD.eq.IMETHOD(ix)) OMETHOD=.true.
         end do
         IF(.NOT.OMETHOD) THEN
            OREQ=.FALSE.
            GO TO 2011
         ELSE
            OREQ1=.TRUE.
         END IF
       END IF
C
C     CHECK SATELLITE SENSOR INDICATOR
C
      IF(ISE.NE.0.AND.ISENS.NE.0) THEN
         IM=ISENS+IKEL
         IKSENSOR=NINT(VALUES(IM))
         OSENSOR=.false.
         do  ix=1,ISE
         IF(IKSENSOR.eq.ISENSOR(ix)) OSENSOR=.true.
         end do
         IF(.NOT.OSENSOR) THEN
            OREQ=.FALSE.
            GO TO 2011
         ELSE
            OREQ1=.TRUE.
         END IF
       END IF

C
C     IDENT
C
      IF(IDN.NE.0) THEN
         IF(IPAID.NE.0) THEN
            II=IPAID+IKEL
            K=NINT(VALUES(II)/1000)
            IDL=NINT(VALUES(II)-K*1000)
            CIDENT(1:IDL)=CVALS(K)(1:IDL)
         END IF
         IF(IPSID.NE.0) THEN
            II=IPSID+IKEL
            WRITE(CIDENT(1:3),'(I3)',iostat=ios) 
     1                          NINT(VALUES(II))
            IF(IOS.NE.0) THEN
               PRINT*,'INTERNAL WRITE ERROR.'
               CALL MY_EXIT(2)
            END IF
            IF(CIDENT(1:1).EQ.' ') THEN
                 CIDENT(1:1)=CIDENT(2:2)
                 CIDENT(2:2)=CIDENT(3:3)
                 CIDENT(3:3)=' '
            END IF
            IF(CIDENT(1:1).EQ.' ') THEN
                 CIDENT(1:1)=CIDENT(2:2)
                 CIDENT(2:2)=CIDENT(3:3)
                 CIDENT(3:3)=' '
            END IF
            IDL=3
         END IF
         IF(IPBUOY.NE.0) THEN
            II=IPBUOY+IKEL
            WRITE(CIDENT(1:9),'(I9)',IOSTAT=IOS)
     1                          NINT(VALUES(II))
            IF(IOS.NE.0) THEN
               PRINT*,'INTERNAL WRITE ERROR.'
               CALL MY_EXIT(2)
            END IF
            IDL=9
         END IF
         IF(IPARN.NE.0) THEN
            II=IPARN+IKEL
            K=NINT(VALUES(II)/1000)
            IDL=NINT(VALUES(II)-K*1000)
            CIDENT(1:IDL)=CVALS(K)(1:IDL)
         END IF
         IF(IPSHIP.NE.0) THEN
            II=IPSHIP+IKEL
            K=NINT(VALUES(II)/1000)
            IDL=NINT(VALUES(II)-K*1000)
            CIDENT(1:IDL)=CVALS(K)(1:IDL)
         END IF
         IF(IPBLOK.NE.0.AND.IPSTAT.NE.0) THEN
            IBB=IPBLOK+IKEL
            IBS=IPSTAT+IKEL
            IBLST=NINT(VALUES(IBB)*1000+VALUES(IBS))
            WRITE(CIDENT(1:5),'(I5.5)',IOSTAT=IOS) IBLST
            IF(IOS.NE.0) THEN
               PRINT*,'INTERNAL WRITE ERROR.'
               CALL MY_EXIT(2)
            END IF
            IDL=5
         END IF
C
         OCIDENT=.FALSE.
         IF(IDL.NE.0) THEN
            DO 203 IX=1,IDN
            IF(CIDENT(1:IDL).EQ.CIDENTS(IX)(1:IDL)) OCIDENT=.TRUE.
 203        CONTINUE
         END IF
         IF(.NOT.OCIDENT) THEN
            OREQ=.FALSE.
            GO TO 2011
         ELSE
            OREQ1=.TRUE.
         END IF
      END IF
C
C     -----------------------------------------------------------------
 2011 continue

      IF(OREQ1) then
C
         NN1=NN1+1
c        PRINT*,'SUBSET MATCHED ',NN1
         DO  K=1,KSUP(5)
           IKK=K+(NN1-1)*KEL
           IKC=K+(I-1)*KEL
           VALUES1(IKK)=VALUES(IKC)
         END DO
      ELSE
         NN2=NN2+1
c        PRINT*,'SUBSET not MATCHED ',NN2
         DO  K=1,ksup(5)
           IKK=K+(NN2-1)*KEL
           IKC=K+(I-1)*KEL
           VALUES2(IKK)=VALUES(IKC)
         END DO
      END IF
C
 201  CONTINUE
C
         KSEC31(3)=NN1
         KSEC31(4)=128
         IF(NN1.GT.1) KSEC31(4)=192

         KSEC32(3)=NN2
         KSEC32(4)=128
         IF(NN2.GT.1) KSEC32(4)=192
C
C              3. CREATE NEW SECTION 1 AND THE RDB KEY.
C                 -------------------------------------
 300  CONTINUE
C
      do k=1,40
        ksec11(k)=ksec1(k)
        ksec12(k)=ksec1(k)
      end do
      do k=1,46
        key1(k)=key(k)
        key2(k)=key(k)
      end do
c
      if(nn1.ne.0) then
      KSEC11(5)=128
      RYYY=1900. 
      IF(NINT(VALUES1(IPYEAR)).GE.2001) RYYY=2000.
      KSEC11( 9)=NINT(VALUES1(IPYEAR)-RYYY)
      KSEC11(10)=NINT(VALUES1(IPMONTH))
      KSEC11(11)=NINT(VALUES1(IPDAY))
      KSEC11(12)=NINT(VALUES1(IPHOUR))
      KSEC11(13)=NINT(VALUES1(IPMINUTE))
c
      CALL BUCRKEY(KEL,KTDEXP,KSUP,KSEC11,KSEC31,KEY1,
     1                     VALUES1,CVALS,KERR)
      end if
c
      if(nn2.ne.0) then
      KSEC12(5)=128
      RYYY=1900.
      IF(NINT(VALUES2(IPYEAR)).GE.2001) RYYY=2000.
      KSEC12( 9)=NINT(VALUES2(IPYEAR)-RYYY)
      KSEC12(10)=NINT(VALUES2(IPMONTH))
      KSEC12(11)=NINT(VALUES2(IPDAY))
      KSEC12(12)=NINT(VALUES2(IPHOUR))
      KSEC12(13)=NINT(VALUES2(IPMINUTE))
c
      CALL BUCRKEY(KEL,KTDEXP,KSUP,KSEC12,KSEC32,KEY2,
     1                     VALUES2,CVALS,KERR)
      end if


      KEY1(46)=70
      KEY2(46)=70
C
c     OREQ=.false.
c     IF(OREQ1) OREQ=.true.
      RETURN

C
 401  CONTINUE
C
      PRINT*,'INTERNAL READ ERROR.'
      CALL MY_EXIT(2)
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE GRPRS4W(KSEC4)
C
C---->
C**** GRPRS4W
C
C     Purpose.
C     --------
C
C     Print the wave coordinate information in the Binary data
C     section Section (Section 4) of decoded GRIB data.
C
C**   Interface.
C     ----------
C
C     CALL GRPRS4W(KSEC4)
C
C
C     Input Parameters.
C     -----------------
C
C     KSEC4 - Array of decoded integers from Section 4.
C
C     Output Parameters.
C     ------------------
C
C     None.
C
C     Method.
C     -------
C
C     Fields printed as reals.
C
C     Externals.
C     ----------
C
C     SETPAR
C     INXBIT.
C
C     Common block GRPRSCM.
C
C     Reference.
C     ----------
C
C     WMO Manual on Codes re GRIB Code.
C     See also routine GRIBEX.
C
C     Comments.
C     ---------
C
C     Wave coordinate information held in KSEC4 are 32-bit REALs,
C     hence the PTEMP and NTEMP used for printing are 4-byte variables.
C
C     Author.
C     -------
C
C     J.D.Chambers   ECMWF 28.10.97
C     Add printout for ECMWF wave 2Dsp first and second dimension
C     coordinate values
C
C     J.D.Chambers   ECMWF    June 2002
C     Add option to set output stream number using environment variable
C     GRPRS_STREAM
C
C----<
C     -----------------------------------------------------------------|
C*    Section 0. Definition of variables.
C     -----------------------------------------------------------------|
C
      IMPLICIT NONE
C
#include "common/grprs.h"
C
C     Subroutine arguments
      INTEGER KSEC4
      DIMENSION KSEC4(*)
C
C     Local variables
C
      INTEGER JLOOP
      REAL*4    PTEMP(100)
      INTEGER*4 NTEMP(100)
      EQUIVALENCE ( PTEMP(1),NTEMP(1) )
C
C     -----------------------------------------------------------------|
C*    Section 1 . Print integer information from KSEC4.
C     -----------------------------------------------------------------|
C
  100 CONTINUE
C
      WRITE(GRPRSM,*)
     X  'Coefficients defining first dimension coordinates:'
      DO 110 JLOOP = 1, KSEC4(53)
        NTEMP(JLOOP) = KSEC4(59 + JLOOP)
        WRITE(GRPRSM,'(F20.10)') PTEMP(JLOOP)
  110 CONTINUE
C
      WRITE(GRPRSM,*)
     X  'Coefficients defining second dimension coordinates:'
      DO 120 JLOOP = 1, KSEC4(55)
        NTEMP(JLOOP) = KSEC4(59 + KSEC4(53) + JLOOP)
        WRITE(GRPRSM,'(F20.10)') PTEMP(JLOOP)
  120 CONTINUE
C
C     -----------------------------------------------------------------|
C     Section 9. Return to calling routine.
C     -----------------------------------------------------------------|
C
  900 CONTINUE
C
      RETURN
      END

#define MISSING_VALUE -9999999
      PROGRAM SINGLEPT
      IMPLICIT NONE
C
      INTEGER JPACK, JPBYTES
      PARAMETER (JPACK = 5000000)
      PARAMETER (JPBYTES = 4)
C
      INTEGER ISEC0(2)
      INTEGER ISEC1(1024)
      INTEGER ISEC2(2048)
      INTEGER ISEC3(2)
      INTEGER ISEC4(1024)
      INTEGER INBUFF(JPACK), OUTGRIB(JPACK)
      INTEGER KPTS(1024)
      INTEGER  NSIZE, OUTLEN
      INTEGER IRET, FILE1, FILE2, JCOUNT
      INTEGER ILENB, LENOUT, IPUNP, IWORD, LOOP, LOOPO
      INTEGER NLON, NLAT, NPTS, NGAUSS, NLATLON, IJDC
      INTEGER  IFILEN, IOS, J, NARGS
    
C
      REAL ZSEC2(1024)
      REAL ZSEC3(2)
      REAL ZSEC4(JPACK*4)
      REAL USEC4(JPACK*4)

      LOGICAL ASCII
C
      REAL AREA(4), GRID(2), POLE(2), LATS(1000), LONS(1000)
      REAL PLATS(1024), REALV(4), DUMMY(1)
C
      CHARACTER*10 CHARV(1)
      CHARACTER*128 POINTS, INFILE, OUTFILE, CARG(4), TEMP
C
      INTEGER  IARGC, HRG2LL, HIRLSM, HSP2GG, INTOUT, INTF
      EXTERNAL HRG2LL, HIRLSM, HSP2GG, INTOUT, INTF
C
C     Commented out for gfortran
C
CCC      EXTERNAL IARGC
C
C     Fix dummy grid step and Souh pole position
C
      DATA GRID/1.0,1.0/
      DATA POLE/-90.0,0.0/
C
C     -----------------------------------------------------------------|
C     Pick up the command line file names and open the files
C     -----------------------------------------------------------------|
C
      ASCII = .false.
      NARGS = IARGC()
      IF( NARGS.LT.3 ) THEN
        WRITE(*,*) ' '
        WRITE(*,*) 'Usage: singlePointInterpolation  llfile'
     X     ,'  infile  outfile a'
        WRITE(*,*) ' '
        WRITE(*,*) '  latlonfile is a list of latitude/longitude values'
        WRITE(*,*) ' '
        WRITE(*,*) '  inpfile is a file of global GRIB fields'
        WRITE(*,*) ' '
        WRITE(*,*) '  outfile is a file of single-point GRIBs or ascii'
        WRITE(*,*) ' '
        WRITE(*,*) '  a optional ascii output'
        WRITE(*,*) ' '
        STOP 'FAIL'
      ENDIF
C
        CALL GETARG(1,POINTS)
        CALL GETARG(2,INFILE)
        CALL GETARG(3,OUTFILE)

         if(NARGS.eq.4) ASCII = .TRUE.
            
C
C     Open the input GRIB file
C
      IFILEN = INDEX(INFILE,' ') - 1
      CALL PBOPEN(FILE1, INFILE (1:IFILEN), "r", IRET)
      IF( IRET.NE.0 ) THEN
        WRITE(*, *) 'Return code from PBOPEN = ',IRET
        CALL PBCLOSE(FILE1, IRET)
        STOP 'Fault in PBOPEN for input file'
      ENDIF
C
C     Open the output file of single-point GRIBs
C
       IFILEN = INDEX(OUTFILE,' ') - 1
      IF(ASCII) THEN
       OPEN (UNIT=16,FILE=OUTFILE(1:IFILEN)//'.txt',STATUS='UNKNOWN',
     &          FORM='FORMATTED',IOSTAT=IOS)

            IF (IOS.EQ.0) THEN
                WRITE(*,*)'File:',OUTFILE(1:IFILEN),' opened'
            ELSE
               WRITE(*,*)'File:',OUTFILE(1:IFILEN),' not opened'
               WRITE(*,*)'Input/output status = ',IOS
               WRITE(*,*)'Program will stop'
               STOP
            END IF
      END IF

       	 CALL PBOPEN(FILE2, outfile, "w", IRET)
         IF( IRET.NE.0 ) THEN
           WRITE (*, *) 'Return code from PBOPEN = ',IRET
           STOP 'Fault in PBOPEN for output file'
         ENDIF
C
C     Open the file of lat/longs
C
      IFILEN = INDEX(POINTS,' ') - 1
      OPEN(UNIT=1,FILE=POINTS(1:IFILEN),STATUS='OLD'
     X ,FORM='FORMATTED',ERR=990)
C
C     Read the latitude/longitude pairs
C
      NLATLON = 0
      DO LOOP = 1, 1000
        READ(1,9000,ERR=980,END=110) LATS(LOOP), LONS(LOOP)
        IF( (LATS(LOOP).GT.90.0).OR.(LATS(LOOP).LT.-90.0) ) THEN
          WRITE (*, *) 'Latitude ',LOOP,' is faulty (',LATS(LOOP),')'
          STOP 'FAIL'
        ENDIF
c        WRITE (*,9000) LATS(LOOP), LONS(LOOP)
C
        IF( (LONS(LOOP).GT.360.0).OR.(LONS(LOOP).LT.-360.0) ) THEN
          WRITE (*, *) 'Longitude ',LOOP,' is faulty (',LONS(LOOP),')'
          STOP 'FAIL'
        ENDIF
C
        NLATLON = NLATLON + 1
C
      ENDDO
C
  110 CONTINUE
      CLOSE(UNIT=1)
      IF( NLATLON.LT.1 ) STOP 'No latitude/longitude pairs given'
C
      WRITE(*,*) 'Number of latitude/longitude pairs = ', NLATLON
C
C     -----------------------------------------------------------------|
C     Read the input GRIB fields one at a time and generate an
C     interpolated value at each latitude/longitude point.
C     -----------------------------------------------------------------|
C
  150 CONTINUE
C
C     Read next GRIB field.
C
      ILENB = JPACK*JPBYTES
      CALL PBGRIB(FILE1, INBUFF, ILENB, LENOUT, IRET )
      IF( IRET.LT.0 ) THEN
        IF( IRET.NE.-1 ) WRITE (*, *) 'Return code from PBGRIB = ',IRET
C
        IF( IRET.EQ.-1 ) THEN
          CALL PBCLOSE(FILE2, IRET)
          IF( IRET.LT.0 ) THEN
            WRITE(*, *) 'Return code from PBCLOSE = ',IRET
            WRITE(*, *) 'Fault in PBCLOSE for output file'
          ENDIF
C
          CALL PBCLOSE(FILE1, IRET)
          STOP 'Interpolation completed'
        ELSE
          CALL PBCLOSE(FILE1, IRET)
          STOP 'Fault in PBCLOSE for input file'
        ENDIF
      ENDIF
C
C     Unpack the GRIB message.
C
      ZSEC3(2) = MISSING_VALUE
      ISEC3(2) = NINT(ZSEC3(2))
      IRET  = 1
      IPUNP = JPACK * JPBYTES
      ILENB = (LENOUT + (JPBYTES-1))/JPBYTES
      CALL GRIBEX(ISEC0,ISEC1,ISEC2,ZSEC2,ISEC3,ZSEC3,ISEC4,
     X            ZSEC4,IPUNP,INBUFF,ILENB,IWORD,'D',IRET)
      IF( IRET.GT.0 ) THEN
        WRITE(*,*) 'GRIBEX return code = ',IRET
        STOP 'GRIBEX error in decoding'
      ENDIF
C
C     If the input GRIB field is spectral, convert to a suitable
C     gaussian grid before interpolation
C
      IF( ISEC2(1).EQ.50 ) THEN
C
        IRET = HSP2GG(ISEC2(2),NGAUSS,KPTS,PLATS,NSIZE)
        IF( IRET.NE.0 ) THEN
          WRITE(*,*) 'Failed to find suitable gaussian grid for the'
          WRITE(*,*) 'spectral input GRIB'
          STOP 'FAIL'
        ENDIF
C
        IRET = INTOUT('REDUCED',NGAUSS,REALV,CHARV)
        IF( IRET.NE.0 ) THEN
          WRITE(*,*) 'Failed to setup gaussian grid interpolation'
          STOP 'FAIL'
        ENDIF
C
        OUTLEN = JPACK
        IRET = INTF(INBUFF,ILENB,DUMMY,OUTGRIB,OUTLEN,DUMMY)
        IF( IRET.NE.0 ) THEN
          WRITE(*,*) 'Gaussian grid interpolation failed'
          STOP 'FAIL'
        ENDIF
C
C        Unpack the interpolated GRIB message.
C
         ZSEC3(2) = MISSING_VALUE
         ISEC3(2) = NINT(ZSEC3(2))
         IRET = 1
         IPUNP = JPACK * JPBYTES
         ILENB = (LENOUT + (JPBYTES-1))/JPBYTES
         CALL GRIBEX(ISEC0,ISEC1,ISEC2,ZSEC2,ISEC3,ZSEC3,ISEC4,
     X               ZSEC4,IPUNP,OUTGRIB,OUTLEN,IWORD,'D',IRET)
         IF( IRET.GT.0 ) THEN
           WRITE(*,*) 'GRIBEX return code = ',IRET
           STOP 'GRIBEX error in decoding'
         ENDIF
      ENDIF
C
C     Interpolate the gaussian field to lat/long
C
      NGAUSS = ISEC2(10)
      NPTS   = ISEC4(1)
C
C     Loop through the latitude/longitude points
C
      DO LOOPO = 1, NLATLON
        AREA(1) = LATS(LOOPO)
        AREA(2) = LONS(LOOPO)
        AREA(3) = LATS(LOOPO)
        AREA(4) = LONS(LOOPO)
C
        IRET = HIRLSM(.TRUE.,ZSEC4,NPTS,NGAUSS,AREA,POLE,GRID,USEC4,1,
     X                NLON,NLAT)
        IF( IRET.NE.0 )
     X    STOP 'Interpolation from gaussian grid to lat/lon grid failed'
C
      IF(ASCII) THEN
        WRITE (16,9001)LOOPO, LATS(LOOPO), LONS(LOOPO), USEC4(1)
      ENDIF
C       Repack the field and write to results file
C
        IRET = 1
        IPUNP = ISEC4(1)
        ILENB = JPACK
        DO LOOP = 1, ILENB
          INBUFF(LOOP) = 0
        ENDDO
C
C       Setup output GRIB header information
C
        ISEC2( 1) = 0
        ISEC2( 2) = 1
        ISEC2( 3) = 1
        ISEC2( 4) = NINT(LATS(LOOPO)*1000)
        ISEC2( 5) = NINT(LONS(LOOPO)*1000)
        ISEC2( 6) = 128
        ISEC2( 7) = NINT(LATS(LOOPO)*1000)
        ISEC2( 8) = NINT(LONS(LOOPO)*1000)
        ISEC2( 9) = 1000
        ISEC2(10) = 1000
        ISEC2(11) = 0
        ISEC2(12) = 0
        ISEC2(13) = 0
        ISEC2(14) = 0
        ISEC2(15) = 0
        ISEC2(16) = 0
        ISEC2(17) = 0
        ISEC2(18) = 0
        ISEC2(19) = 0
C
        ZSEC3(2) = MISSING_VALUE
        ISEC3(2) = NINT(ZSEC3(2))
C
        ISEC4( 1) = 1
C
        CALL GRIBEX(ISEC0,ISEC1,ISEC2,ZSEC2,ISEC3,ZSEC3,ISEC4,
     X              USEC4,IPUNP,INBUFF,ILENB,IWORD,'C',IRET)
        IF( IRET.GT.0 ) THEN
          WRITE(*,*) 'GRIBEX return code = ',IRET
          STOP 'GRIBEX error on packing'
        ENDIF
C
        LENOUT = ISEC0(1)
        CALL PBWRITE(FILE2, INBUFF, LENOUT, IRET)
        IF( IRET.LT.LENOUT ) THEN
          WRITE(*, *) 'Return code from PBWRITE = ',IRET
          STOP 'Fault in PBWRITE'
        ENDIF
C
      ENDDO
C
C     Go for next input GRIB field
C
      GOTO 150
C
C     -----------------------------------------------------------------|
C     Problem reports
C     -----------------------------------------------------------------|
C
  980 STOP 'READ error for lat/long file'
C
  990 STOP 'OPEN error for lat/long file'
C
9000  FORMAT(2(F8.2,1X))
9001  FORMAT(1x,i5,2x,2(F8.2,1X),f8.2)
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      INTEGER FUNCTION IGINTR (KWEDIST, KOWE, KNSDIST, PWFACT, KPR,
     1   KERR)
C
C---->
C**** *IGINTR*
C
C     PURPOSE
C     _______
C
C     Calculate the basic unnormalised interpolation weights for one
C     line of latitude when interpolating between regular grids.
C
C     INTERFACE
C     _________
C
C     IERR = IGINTR (KWEDIST, KOWE, KNSDIST, PWFACT, KPR, KERR)
C
C     Input parameters
C     ________________
C
C     KWEDIST    - This array holds the distances to longitude values
C                  in the input field from the associated longitude
C                  values in the output field.
C
C     KOWE       - The number of points in the West-East direction in
C                  the output field.
C
C     KNSDIST    - This array gives the distances to the latitude of
C                  the lines North and South in the input field from
C                  the line of latitude of the output field.
C
C     KPR        - The debug print switch.
C                  0  , No debugging output.
C                  1  , Produce debugging output.
C
C     KERR       - The error control flag.
C                  -ve, No error message. Return error code.
C                  0  , Hard failure with error message.
C                  +ve, Print error message. Return error code.
C
C     Output parameters
C     ________________
C
C     PWFACT     - The unnormalised array of interpolating weights to
C                  the four neighbouring points for every point of the
C                  output line of latitude.
C
C     Return value
C     ____________
C
C     The error indicator (INTEGER).
C
C     Error and Warning Return Values
C     _______________________________
C
C     None
C
C     Common block usage
C     __________________
C
C     None
C
C     EXTERNALS
C     _________
C
C     INTLOG     - Logs messages.
C
C     METHOD
C     ______
C
C     The weights are evaluated as the size of the opposing rectangle.
C     It is trivial to show that this is equivalent to weighting by
C     the inverse size of the rectangle of which the input point forms
C     part.
C
C     REFERENCE
C     _________
C
C     None
C
C     COMMENTS
C     ________
C
C     Program contains sections 0 to 2 and 9
C
C     AUTHOR
C     ______
C
C     K. Fielding      *ECMWF*      Oct 1993
C
C     MODIFICATIONS
C     _____________
C
C     None
C
C----<
C     _______________________________________________________
C
C
C*    Section 0. Definition of variables.
C     _______________________________________________________
C
C*    Prefix conventions for variable names
C
C     Logical      L (but not LP), global or common.
C                  O, dummy argument
C                  G, local variable
C                  LP, parameter.
C     Character    C, global or common.
C                  H, dummy argument
C                  Y (but not YP), local variable
C                  YP, parameter.
C     Integer      M and N, global or common.
C                  K, dummy argument
C                  I, local variable
C                  J (but not JP), loop control
C                  JP, parameter.
C     REAL         A to F and Q to X, global or common.
C                  P (but not PP), dummy argument
C                  Z, local variable
C                  PP, parameter.
C
C     Implicit statement to force declarations
C
      IMPLICIT NONE
C
#include "parim.h"
C
C     Dummy arguments
      INTEGER KOWE, KPR, KERR
      INTEGER KWEDIST (2, KOWE), KNSDIST (2)
      REAL PWFACT (4, KOWE)
C
C     Local variables
      INTEGER JOLON
      INTEGER JPROUTINE
      PARAMETER (JPROUTINE = 22300)
C
C     _______________________________________________________
C
C*    Section 1. Initialisation
C     _______________________________________________________
C
  100 CONTINUE
C
      IF (KPR.GE.1) CALL INTLOG(JP_DEBUG,'IGINTR: Section 1.',JPQUIET)
C
      IGINTR = 0
C
      IF (KPR .GE. 1) THEN
        CALL INTLOG(JP_DEBUG,'IGINTR: Input parameters.',JPQUIET)
        CALL INTLOG(JP_DEBUG,'IGINTR: No.output longitudes = ',KOWE)
      ENDIF
C
C     _______________________________________________________
C
C*    Section 2. Calculate arrays of weights
C     _______________________________________________________
C
  200 CONTINUE
C
      IF (KPR.GE.1) CALL INTLOG(JP_DEBUG,'IGINTR: Section 2.',JPQUIET)
C
      DO 210 JOLON = 1, KOWE
C
C     The unnormalised weights are the size of the opposing rectangle.
C
         PWFACT (JP_I_NW, JOLON) =
     1      REAL (KWEDIST (JP_I_E, JOLON) ) * REAL (KNSDIST (JP_I_S) )
         PWFACT (JP_I_NE, JOLON) =
     1      REAL (KWEDIST (JP_I_W, JOLON) ) * REAL (KNSDIST (JP_I_S) )
         PWFACT (JP_I_SW, JOLON) =
     1      REAL (KWEDIST (JP_I_E, JOLON) ) * REAL (KNSDIST (JP_I_N) )
         PWFACT (JP_I_SE, JOLON) =
     1      REAL (KWEDIST (JP_I_W, JOLON) ) * REAL (KNSDIST (JP_I_N) )
C
  210 CONTINUE
C
C     _______________________________________________________
C
C*    Section 9. Return to calling routine. Format statements
C     _______________________________________________________
C
  900 CONTINUE
C
      IF (KPR.GE.1) CALL INTLOG(JP_DEBUG,'IGINTR: Section 9.',JPQUIET)
C
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

C
      COMMON /BCOMCT/ NREF(JCTAB)   ,NSTART(JCTAB) ,NLEN(JCTAB),
     1               NCODNUM(JCTST),NSTARTC(JCTST),
     2               NLENC(JCTST)
C
C             NREF      - TABLE C REFERENCE
C             NSTART    - STARTING POINTERS TO ARRAY NCODNUM
C             NLEN      - LENGTHS
C             NCODNUM   - CODE/FLAG TABLE NUMBER
C             NSTARTC   - STARTING POINTERS TO ARRAY CTEXT
C             NLENC     - LENGTHS
C

C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      INTEGER FUNCTION IGDINS (KILATG, KINS, KOLATG, KONS, ONPOLE,
     1   OSPOLE, KNSIND, KNSDIST, KPR, KERR)
C
C---->
C**** *IGDINS*
C
C     PURPOSE
C     _______
C
C     Calculate the distances between points in an output latitude
C     array and its North and South neighbours in the input latitude
C     array.
C
C     INTERFACE
C     _________
C
C     IERR = IGDINS (KILATG, KINS, KOLATG, KONS, ONPOLE, OSPOLE,
C    1   KNSIND, KNSDIST, KPR, KERR)
C
C     Input parameters
C     ________________
C
C     KILATG     - The array of input latitudes.
C
C     KINS       - The number of points in the North-South direction
C                  in the input field.
C
C     KOLATG     - The array of output latitudes.
C
C     KONS       - The number of points in the North-South direction
C                  in the output field.
C
C     ONPOLE     - This variable will be true if the input field
C                  includes the most Northerly line of latitude for
C                  the field type. This means latitude 90 North for
C                  a regular field and the first line of a Gaussian
C                  field.
C
C     OSPOLE     - This variable will be true if the input field
C                  includes the most Southerly line of latitude for
C                  the field type. This means latitude 90 South for
C                  a regular field and the last line of a Gaussian
C                  field.
C
C     KPR        - The debug print switch.
C                  0  , No debugging output.
C                  1  , Produce debugging output.
C
C     KERR       - The error control flag.
C                  -ve, No error message. Return error code.
C                  0  , Hard failure with error message.
C                  +ve, Print error message. Return error code.
C
C     Output parameters
C     ________________
C
C     KNSIND     - This array will contain the array offsets of the
C                  North and South points in the input array required
C                  for interpolation.
C
C     KNSDIST    - This array will contain the distances to lines
C                  in input field from the associated lines of
C                  latitude in the output field.
C
C     Return value
C     ____________
C
C     The error indicator (INTEGER).
C
C     Error and Warning Return Values
C     _______________________________
C
C     24501 An output latitude was found that was outside the area
C           spanned by the input latitudes.
C
C     Common block usage
C     __________________
C
C     None
C
C     EXTERNALS
C     _________
C
C     INTLOG(R)    - Logs messages.
C
C     METHOD
C     ______
C
C     This routine will create the arrays of offsets and distance as
C     two arrays of length (2, Number of output latitudes).
C
C     If an input Gaussian grid includes the "polar" line and the
C     output field includes a line of latitude between this "polar"
C     line and the pole then the position of this "polar" Gaussian
C     line is assumed to be at the pole for that line of latitude only.
C
C     REFERENCE
C     _________
C
C     None
C
C     COMMENTS
C     ________
C
C     Program contains sections 0 to 2 and 9
C
C     AUTHOR
C     ______
C
C     K. Fielding      *ECMWF*      Oct 1993
C
C     MODIFICATIONS
C     _____________
C
C     None
C
C----<
C     _______________________________________________________
C
C
C*    Section 0. Definition of variables.
C     _______________________________________________________
C
C*    Prefix conventions for variable names
C
C     Logical      L (but not LP), global or common.
C                  O, dummy argument
C                  G, local variable
C                  LP, parameter.
C     Character    C, global or common.
C                  H, dummy argument
C                  Y (but not YP), local variable
C                  YP, parameter.
C     Integer      M and N, global or common.
C                  K, dummy argument
C                  I, local variable
C                  J (but not JP), loop control
C                  JP, parameter.
C     REAL         A to F and Q to X, global or common.
C                  P (but not PP), dummy argument
C                  Z, local variable
C                  PP, parameter.
C
C     Implicit statement to force declarations
C
      IMPLICIT NONE
C
#include "parim.h"
C
C     Dummy arguments
      LOGICAL ONPOLE, OSPOLE
      INTEGER KINS, KONS, KPR, KERR
      INTEGER KILATG (KINS), KOLATG (KONS)
      INTEGER KNSIND (2, KONS), KNSDIST (2, KONS)
C
C     Local variables
      INTEGER IBASE
      INTEGER JOUT, JINP
      INTEGER JPROUTINE
      PARAMETER (JPROUTINE = 24500)
C
C     _______________________________________________________
C
C*    Section 1. Initialisation
C     _______________________________________________________
C
  100 CONTINUE
C
      IF (KPR.GE.1) CALL INTLOG(JP_DEBUG,'IGDINS: Section 1.',JPQUIET)
C
      IGDINS = 0
C
      IF (KPR .GE. 1) THEN
        CALL INTLOG(JP_DEBUG,'IGDINS: Input parameters.',JPQUIET)
        CALL INTLOG(JP_DEBUG,'IGDINS: No.input fld lines = ',KINS)
        CALL INTLOG(JP_DEBUG,'IGDINS: No.output fld lines = ',KONS)
        CALL INTLOG(JP_DEBUG,'IGDINS: Input fld spread from ',KILATG(1))
        CALL INTLOG(JP_DEBUG,'IGDINS: to ', KILATG(KINS))
        CALL INTLOG(JP_DEBUG,'IGDINS: Outpt fld spread from ',KOLATG(1))
        CALL INTLOG(JP_DEBUG,'IGDINS: to ', KOLATG(KONS))
C
        IF ( ONPOLE ) THEN
          CALL INTLOG(JP_DEBUG,'IGDINS: N. pole in inpt field.',JPQUIET)
        ELSE
          CALL INTLOG(JP_DEBUG,'IGDINS: N.pole NOT in inpt fld',JPQUIET)
        ENDIF
C
        IF ( OSPOLE ) THEN
          CALL INTLOG(JP_DEBUG,'IGDINS: S. pole in inpt field.',JPQUIET)
        ELSE
          CALL INTLOG(JP_DEBUG,'IGDINS: S.pole NOT in inpt fld',JPQUIET)
        ENDIF
      ENDIF
C
C     _______________________________________________________
C
C*    Section 2. Select points along a line of meridian
C     _______________________________________________________
C
  200 CONTINUE
C
      IF (KPR.GE.1) CALL INTLOG(JP_DEBUG,'IGDINS: Section 2.',JPQUIET)
C
C     Last latitude found to be used as start of search
C     for next latitude
C
      IBASE = 1
C
      DO 220 JOUT = 1, KONS
C
C       Allow special code for points beyond North limit of
C       Gaussian grid which has all points up to pole
C
C       Sinisa remove check for pole - already exist in iagcntl
        IF (IBASE .EQ. 1 .AND. KOLATG(JOUT).GT.KILATG (1) ) THEN
C
          KNSIND (JP_I_N, JOUT) = 1
          KNSIND (JP_I_S, JOUT) = 2
          IBASE = 1
C
          KNSDIST (JP_I_N, JOUT) = JP90 - KOLATG (JOUT)
          KNSDIST (JP_I_S, JOUT) = KOLATG (JOUT) - KILATG (2)
C
          GO TO 220
C
        ENDIF
C
        DO 210 JINP = IBASE, KINS - 1
C
C         This test allows the exact match at both ends to be treated
C         correctly. Although the point is checked for equality at
C         both ends the first test will be used except for the South
C         Gaussian limit.
C
          IF (KOLATG (JOUT) .LE. KILATG (JINP) .AND.
     X         KOLATG (JOUT) .GE. KILATG (JINP + 1) ) THEN
C
            KNSIND (JP_I_N, JOUT) = JINP
            KNSIND (JP_I_S, JOUT) = JINP + 1
            IBASE = JINP
C
            KNSDIST (JP_I_N, JOUT) = KILATG (JINP) -
     X            KOLATG (JOUT)
            KNSDIST (JP_I_S, JOUT) = KOLATG (JOUT) -
     X            KILATG (JINP + 1)
C
            GO TO 220
C
          ENDIF
C
  210   CONTINUE
C
C       Allow special code for points beyond South limit of
C       Gaussian grid which has all points up to pole
C
C       Sinisa remove check for pole - already exist in iagcntl
        IF (KOLATG (JOUT) .LT. KILATG (KINS) ) THEN
C
          KNSIND (JP_I_N, JOUT) = KINS - 1
          KNSIND (JP_I_S, JOUT) = KINS
          IBASE = KINS
C
          KNSDIST (JP_I_N, JOUT) = KILATG (KINS - 1) -
     X         KOLATG (JOUT)
          KNSDIST (JP_I_S, JOUT) = KOLATG (JOUT) - JP90
C
        ELSE
C
          IGDINS = JPROUTINE + 1
          IF (KERR .GE. 0) THEN
            CALL INTLOGR(JP_ERROR,
     X        'IGDINS: Output lat. value ',REAL(KOLATG(JOUT))/PPMULT)
            CALL INTLOGR(JP_ERROR,
     X        'IGDINS: outside input range = ',REAL(KILATG(1))/PPMULT)
            CALL INTLOGR(JP_ERROR,
     X        'IGDINS: to ',REAL(KILATG(KINS))/PPMULT)
          ENDIF
C
          IF (KERR .EQ. 0) CALL INTLOGR(JP_FATAL,
     X      'IGDINS: Interpolation failing.',IGDINS)
C
          GO TO 900
C
        ENDIF
C
  220 CONTINUE
C
C
C     _______________________________________________________
C
C*    Section 9. Return to calling routine. Format statements
C     _______________________________________________________
C
  900 CONTINUE
C
      IF (KPR.GE.1) CALL INTLOG(JP_DEBUG,'IGDINS: Section 9.',JPQUIET)
C
      RETURN
      END

        program JGETGG
C      SUBROUTINE JGETGG( KNUM, HTYPE, PLAT, KPTS, KRET)
C
C---->
C**** JGETGG
C
C     PURPOSE
C     _______
C
C     This routine reads the definition of a gaussian grid.
C
C
C     INTERFACE
C     _________
C
C     CALL JGETGG( KNUM, HTYPE, PLAT, KPTS, KRET)
C
C
C     Input parameters
C     ________________
C
C     KNUM     - Gaussian grid number
C     HTYPE    - Gaussian grid type
C                = 'R' for reduced, 
C                = 'F' for full
C                = 'U' for a user defined gaussian grid
C     KPTS     - Array giving users definition of the number of points
C                at each gaussian latitude if HTYPE  = 'U'
C
C
C     Output parameters
C     ________________
C
C     PLAT     - Array of gaussian latitudes (both hemispheres)
C     KPTS     - Array giving number of points at each gaussian 
C                latitude, both hemispheres
C                ( unchanged from input if HTYPE  = 'U' )
C     KRET      - Return status code
C                0 = OK
C
C
C     Common block usage
C     __________________
C
C     None.
C
C     Method
C     ______
C
C     If HTYPE = 'U', the users definition of the grid is used.
C     Latitudes values are calculated corresponding to KNUM.
C
C     An array of predefined values is used.
C
C
C     Externals
C     _________
C
C     GETENV   - Get value of an environment variable
C     INTLOG   - Output log message
C     IGGLAT   - Computes Gaussian latitude lines for given truncation.
C     EMOSNUM  - Gives current EMOSLIB version number.
C
C
C     Reference
C     _________
C
C     None
C
C
C     Comments
C     ________
C
C     None
C
C
C     AUTHOR
C     ______
C
C     J.D.Chambers      ECMWF      Jan 1994
C
C
C     MODIFICATIONS
C     _____________
C
C     J.D.Chambers      ECMWF      Apr 1995
C     Use predefined definition file for N80 and N160 to cope with
C     changes in the 'standard' definition.
C
C     J.D.Chambers      ECMWF      Apr 1996
C     Call JGGLAT if regular grid but not N80 or N160
C
C     J.D.Chambers      ECMWF      Apr 1996
C     Fixup standard pathnames for VPPs.
C     Read array of values from file if possible (once only).
C
C----<
C     -----------------------------------------------------------------|
C*    Section 0. Definition of variables.
C     -----------------------------------------------------------------|
C
      IMPLICIT NONE
C
C     Parameters
C
      INTEGER JPROUTINE, JPMAXN,I,II
      PARAMETER ( JPROUTINE = 30100 )
      PARAMETER ( JPMAXN = 2048 )
C                           `---> dimension for internal array for
C                                 gaussian grid definitions
C
C     Subroutine arguments
C
      INTEGER KNUM, KPTS, KRET
      CHARACTER*1 HTYPE
c      DIMENSION KPTS(*)
      DIMENSION KPTS(JPMAXN)
      REAL PLAT
cs      DIMENSION  PLAT(*)
      DIMENSION  PLAT(JPMAXN)
c      REAL QG400, QG512, QG1024
c      DIMENSION QG400(400),QG512(512),QG1024(1024)
C
C     Local variables
C
#include "parim.h"
#include "grfixed.h"
#include "intf.h"
#include "rgauss_200.h"
#include "rgauss_320.h"
#include "rgauss_400.h"
#include "rgauss_640.h"
#include "rgauss_512.h"
#include "rgauss_1024.h"
C
      CHARACTER*6 YEMOSNM
      CHARACTER*4 CARG
      INTEGER IERR, JJPR, JJERR,PUN
      INTEGER LOOP, NLAT, IOFFSET
      INTEGER IMAGE, K1, INUM, NGOT
C
C     Externals
C
      INTEGER  IGGLAT
      EXTERNAL IGGLAT
C
C     -----------------------------------------------------------------|
C*    Section 1.    Set up standard latitudes
C     -----------------------------------------------------------------|
C
        CALL GETARG(1,CARG)
        READ(CARG,'(I4)')KNUM
csinisa
cs           HTYPE='R'
css           KNUM=512
csinisa
C
      IF( KNUM.GT.JPMAXN) THEN
        CALL INTLOG(JP_ERROR,
     X    'JGETGG: Grid too big for internal array dimension ',JPMAXN)
        GOTO 990
      ENDIF
C
      INUM = KNUM*2
C
c      IF( (HTYPE.EQ.'R').OR.(HTYPE.EQ.'r') ) GOTO 200
C
C     If a regular gaussian grid, calculate the gaussian latitudes
C
      CALL INTLOG(JP_DEBUG,
     X  'JGETGG: Calculate the gaussian latitudes for N = ',KNUM)
C
      JJPR  = 1
      JJERR = 1
      IERR  = IGGLAT(INUM, PLAT, JJPR, JJERR)
      IF( IERR.NE.0 ) THEN
        CALL INTLOG(JP_ERROR, 'JGETGG: IGGLAT call failed',IERR)
        KRET = IERR
        GOTO 990
      ENDIF
C
C     Fill in the number of points at each latitude
C
      CALL INTLOG(JP_DEBUG,'JGETGG: Regular gaussian grid N ',KNUM)
C
c      DO LOOP = 1, INUM
c        KPTS(LOOP) = KNUM*4
c      ENDDO

C
CS      GOTO 930
C
C     -----------------------------------------------------------------|
C*    Section 2.    Read REDUCED gaussian definitions from array
C     -----------------------------------------------------------------|
C
  200 CONTINUE
C
C     Check that the definition is known
C
      IF( (KNUM.NE. 32 ).AND.
     X    (KNUM.NE. 48 ).AND.
     X    (KNUM.NE. 80 ).AND.
     X    (KNUM.NE.128 ).AND.
     X    (KNUM.NE.160 ).AND.
     X    (KNUM.NE.200 ).AND.
     X    (KNUM.NE.256 ).AND.
     X    (KNUM.NE.320 ).AND.
     X    (KNUM.NE.400 ).AND.
     X    (KNUM.NE.512 ).AND.
     X    (KNUM.NE.640 ).AND.
     X    (KNUM.NE.1024 ) ) THEN
        CALL INTLOG(JP_ERROR,
     X    'JGETGG: unknown reduced gaussian grid definition: ', KNUM)
        GOTO 990
      ENDIF
C
C     Fill in the gaussian latitudes
C
      JJPR  = 1
      JJERR = 1
      IERR  = IGGLAT(INUM, PLAT, JJPR, JJERR)
       PUN = KNUM*4
      IF( IERR.NE.0 ) THEN
        CALL INTLOG(JP_ERROR, 'JGETGG: IGGLAT call failed',IERR)
        KRET = IERR
        GOTO 990
      ENDIF
C
C
      IF( KNUM.EQ.400 ) THEN
        DO LOOP = 1, KNUM
          IMAGE       = INUM - LOOP +1
          KPTS(LOOP)  = QG400(LOOP)
          KPTS(IMAGE) = KPTS(LOOP)
        ENDDO
C
      ELSE IF( KNUM.EQ.200 ) THEN
        DO LOOP = 1, KNUM
          IMAGE       = INUM - LOOP +1
          KPTS(LOOP)  = QG200(LOOP)
          KPTS(IMAGE) = KPTS(LOOP)
        ENDDO
      ELSE IF( KNUM.EQ.320 ) THEN
        DO LOOP = 1, KNUM
          IMAGE       = INUM - LOOP +1
          KPTS(LOOP)  = QG320(LOOP)
          KPTS(IMAGE) = KPTS(LOOP)
        ENDDO
      ELSE IF( KNUM.EQ.512 ) THEN
        DO LOOP = 1, KNUM
          IMAGE       = INUM - LOOP +1
          KPTS(LOOP)  = QG512(LOOP)
          KPTS(IMAGE) = KPTS(LOOP)
        ENDDO
      ELSE IF( KNUM.EQ.640 ) THEN
        DO LOOP = 1, KNUM
          IMAGE       = INUM - LOOP +1
          KPTS(LOOP)  = QG640(LOOP)
          KPTS(IMAGE) = KPTS(LOOP)
        ENDDO
C
      ELSE
        DO LOOP = 1, KNUM
          IMAGE       = INUM - LOOP +1
          KPTS(LOOP)  = QG1024(LOOP)
          KPTS(IMAGE) = KPTS(LOOP)
        ENDDO
      ENDIF
C
C
77      format(8x,i4,8x,i4,8x,i4,3x,f9.5)
          write(*,*)'       latitude   reduced     regular  latitude'
          write(*,*)'        number     points      points'
          write(*,*)'       -------    -------     -------  --------'
        DO I = 1, KNUM
          write(*,77)I,KPTS(I),PUN,PLAT(I)
cs          write(*,*)I,KPTS(I),PUN,PLAT(I)
        ENDDO
        DO II = KNUM, 1,-1
          write(*,77)I,KPTS(II),PUN,-(PLAT(II))
           I=I+1
        ENDDO
      KRET = 0
C
 990  CONTINUE
cs      RETURN
      stop
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      INTEGER FUNCTION IRLSMB (OISTAND, HIFILE, KIREC, KIGRID, KILINE,
     X   OOSTAND, HOFILE, KOREC, KOGRID, KOLINE, KPR, KERR)
C
C---->
C**** *IRLSMB*
C
C     Purpose
C     -------
C
C     Calculate the effects of the land-sea masks on the unnormalised
C     interpolation weights for a quasi regular input field and a
C     regular output field.
C
C
C     Interface
C     ---------
C
C     IERR = IRLSMB (OISTAND, HIFILE, KIREC, KIGRID, KILINE,
C    X   OOSTAND, HOFILE, KOREC, KOGRID, KOLINE, KPR, KERR)
C
C
C     Input parameters
C     ----------------
C
C     OISTAND - Flag indicating whether the input land-sea mask
C               is a pre-stored "standard" field.
C
C     HIFILE  - The filename for the input land-sea mask.
C
C     KIREC   - The length of one latitude record in the input file.
C
C     KIGRID  - An array of length 2 giving the row and column
C               strides in a pre-stored land sea mask file for the
C               input grid.
C
C     KILINE  - An array of length 2 giving the offsets of the
C               Northern and Western starting points in a
C               pre-stored land sea mask file for the input grid.
C
C     OOSTAND - Flag indicating whether the output land-sea mask
C               is a prestored "standard" field.
C
C     HOFILE  - The filename for the output land-sea mask.
C
C     KOREC   - The length of one latitude record in the output file.
C
C     KOGRID  - An array of length 2 giving the row and column
C               strides in a pre-stored land sea mask file for the
C               output grid.
C
C     KOLINE  - An array of length 2 giving the offsets of the
C               Northern and Western starting points in a
C               pre-stored land sea mask file for the output grid.
C
C     KPR     - The debug print switch.
C               0  , No debugging output.
C               1  , Produce debugging output.
C
C     KERR    - The error control flag.
C               -ve, No error message. Return error code.
C               0  , Hard failure with error message.
C               +ve, Print error message. Return error code.
C
C
C     Output parameters
C     -----------------
C
C     The common variable WFACT is modified by this routine.
C
C     An error indicator
C
C     23401 An error exit was returned from the I/O routine PBOPEN.
C     23402 An error exit was returned from the I/O routine PBCLOSE.
C
C
C     Common block usage
C     ------------------
C
C     nifld.common - This file contains all the input field
C                    definition variables.
C
C     NINS         - Number of grid points in NS direction for input
C                    field (used in grspace.h).
C     NIWE         - Number of grid points in WE direction for input
C                    field (used in grspace.h).
C
C     nofld.common - This file contains all the output field
C                    definition variables.
C
C     NONS         - Number of grid points in NS direction for output
C                    field is used.
C     NOWE         - Number of grid points in WE direction for output
C                    field is used.
C
C     grspace.h    - This file contains all the work space array
C                    definitions for grid point to grid point
C                    interpolation.
C
C     MEXPAND      - Array used to expand one latitude line of the
C                    10 minute land sea mask file to have one word
C                    per bit for improved efficiency.
C     MILLEN       - Array containing a quasi regular line length
C                    definition.
C     MWORK        - Array used to read one latitude line of a
C                    standard land sea mask file.
C
C     MILATG       - The input field latitudes.
C     MILONG       - The input field longitudes.
C     MILSM        - Work array used in calculating the effects of
C                    the land sea mask on interpolation.
C     MISTRT       - The array offsets of the start of each latitude
C                    line for a quasi regular Gaussian input field.
C     MNSIND       - The latitude line numbers (array offset) of the
C                    input field associated with each line of
C                    latitude in the output field.
C     MOLATG       - The output field latitudes.
C     MOLONG       - The output field longitudes.
C     MOLSM        - Work array used in calculating the effects of
C                    the land sea mask on interpolation.
C     MWEIND       - This array holds the longitude points (array
C                    offset) from the input field associated with
C                    each longitude point in the output field.
C     WFACT        - The interpolation weights for each point in the
C                    output field.
C
C
C     Externals
C     ---------
C
C     IGLSM01   - Read and process one latitude row from the 10
C                 minute land sea mask.
C     IGLSMR    - Calculate the effects of the land-sea masks for
C                 one line of latitude on the unnormalised
C                 interpolation weights.
C     IGLSMST   - Read and process one line of latitude from a
C                 standard land sea mask file.
C     PBCLOSE   - Close a land sea mask file after processing.
C     PBOPEN    - Open a land sea mask file for processing.
C     INTLOG(R) - Log messages.
C     JINDEX    - Returns length of character string
C
C
C     Method
C     ------
C
C     All the land sea mask data is in (0-1) form. If a point in the
C     input field has a different land sea mask value from the
C     corresponding point in the output field then its interpolating
C     weight is multiplied by a scaling factor. This scaling factor
C     is currently 0.2 so that the effect of such points in the final
C     interpolation is reduced.
C
C     The land-sea mask files are kept open between calls to this
C     routine.
C
C
C     Reference
C     ---------
C
C     None
C
C
C     Comments
C     --------
C
C     None
C
C
C     Author
C     ------
C     K. Fielding      *ECMWF*      Nov 1993
C
C     Modifications
C     -------------
C
C     J.D.Chambers      ECMWF       Oct 1996
C     Reduced number of parameters in call to IGLSMST and IGLSM01
C
C----<
C     -----------------------------------------------------------------|
C*    Section 0. Definition of variables.
C     -----------------------------------------------------------------|
C
      IMPLICIT NONE
C
#include "parim.h"
#include "nifld.common"
#include "nofld.common"
#include "grspace.h"
C
C     Function arguments
C
      LOGICAL OISTAND, OOSTAND
      CHARACTER *(*) HIFILE, HOFILE
      INTEGER KIREC, KOREC, KPR, KERR
      INTEGER KIGRID (2), KILINE (2), KOGRID (2), KOLINE (2)
C
C     Local variables
C
      INTEGER IIUNIT, IOUNIT, IIFILE, IOFILE
      INTEGER ILATN, ILATS, ILINEN, ILINES, ISTRIDEN, ISTRIDES
      INTEGER IOSTRIDE, INDEXN, INDEXS, IZERO, IOFF, IPR, IERR
      INTEGER JLON, JOLAT
      CHARACTER*256 XHIFILE, XHOFILE
      CHARACTER*2 NEWFILE, MSKFILE
      INTEGER XIIUNIT, XIOUNIT, II
      DATA XIIUNIT/0/
      DATA XIOUNIT/0/
      SAVE  XHIFILE, XHOFILE, XIIUNIT, XIOUNIT
C
      INTEGER JPROUTINE
      PARAMETER (JPROUTINE = 23400)
C
C     External functions
C
      INTEGER IGLSMR, IGLSMST, IGLSM01, JINDEX
C
C     -----------------------------------------------------------------|
C*    Section 1. Initialisation
C     -----------------------------------------------------------------|
C
  100 CONTINUE
C
      IF( KPR.GE.1 ) CALL INTLOG(JP_DEBUG,'IRLSMB: Section 1.',JPQUIET)
C
      IRLSMB = 0
C
      IIFILE = JINDEX(HIFILE)
      IOFILE = JINDEX(HOFILE)
C
      IF( KPR.GE.1 ) THEN
        CALL INTLOG(JP_DEBUG,'IRLSMB: Input field parameters.',JPQUIET)
        CALL INTLOG(JP_DEBUG,'IRLSMB: LSM filename is.',JPQUIET)
        CALL INTLOG(JP_DEBUG, HIFILE(1:IIFILE), JPQUIET)
        IF( OISTAND ) THEN
            CALL INTLOG(JP_DEBUG,'IRLSMB: Standard fld: TRUE',JPQUIET)
        ELSE
            CALL INTLOG(JP_DEBUG,'IRLSMB: Standard fld: FALSE',JPQUIET)
        ENDIF
        CALL INTLOG(JP_DEBUG,'IRLSMB: LSM file rec len = ',KIREC)
        CALL INTLOG(JP_DEBUG,'IRLSMB: Grid stride WE = ',KIGRID(1))
        CALL INTLOG(JP_DEBUG,'IRLSMB: Grid stride NS = ',KIGRID(2))
        CALL INTLOG(JP_DEBUG,'IRLSMB: Grid start N = ',KILINE(1))
        CALL INTLOG(JP_DEBUG,'IRLSMB: Grid start W = ',KILINE(2))
C
        CALL INTLOG(JP_DEBUG,'IRLSMB: Output field parameters.',JPQUIET)
        CALL INTLOG(JP_DEBUG, HOFILE(1:IOFILE),JPQUIET)
        IF( OOSTAND ) THEN
            CALL INTLOG(JP_DEBUG,'IRLSMB: Standard fld: TRUE',JPQUIET)
        ELSE
            CALL INTLOG(JP_DEBUG,'IRLSMB: Standard fld: FALSE',JPQUIET)
        ENDIF
        CALL INTLOG(JP_DEBUG,'IRLSMB: LSM file rec len = ',KOREC)
        CALL INTLOG(JP_DEBUG,'IRLSMB: Grid stride WE = ',KOGRID(1))
        CALL INTLOG(JP_DEBUG,'IRLSMB: Grid stride NS = ',KOGRID(2))
        CALL INTLOG(JP_DEBUG,'IRLSMB: Grid start N = ',KOLINE(1))
        CALL INTLOG(JP_DEBUG,'IRLSMB: Grid start W = ',KOLINE(2))
      ENDIF
C
      IF( MOLONG(2).GE.MOLONG(1) ) THEN
         IOSTRIDE = MOLONG(2) - MOLONG(1)
      ELSE
         IOSTRIDE = MOLONG(2) + JP360 - MOLONG(1)
      ENDIF
C
C     -----------------------------------------------------------------|
C*    Section 2. Open files for input and output land sea masks
C     -----------------------------------------------------------------|
C
  200 CONTINUE
C
      IF( KPR.GE.1 ) CALL INTLOG(JP_DEBUG,'IRLSMB: Section 2.',JPQUIET)
C
C     See if first time through or input land sea mask filename has
C     changed since last access
C
      II = JINDEX(HIFILE)
      IF( XHIFILE(1:II).NE.HIFILE(1:II) ) THEN
C
C       Open input land sea mask file
C
        IF(XIIUNIT.NE.0) CALL PBCLOSE(XIIUNIT,IERR)
        CALL PBOPEN(IIUNIT, HIFILE, 'r', IERR)
        IF( IERR.NE.0 ) THEN
          IRLSMB = JPROUTINE + 1
C
          IF( KERR.GE.0 ) THEN
            CALL INTLOG(JP_ERROR,'IRLSMB: PBOPEN return code = ',IERR)
            CALL INTLOG(JP_ERROR,'IRLSMB: trying to open file',JPQUIET)
            CALL INTLOG(JP_ERROR, HIFILE(1:IIFILE),JPQUIET)
          ENDIF
C
          IF( KERR.EQ.0 ) CALL INTLOG(JP_FATAL,
     X      'IRLSMB: Interpolation failed.',JPQUIET)
          GOTO 900
        ENDIF
        XIIUNIT = IIUNIT
        XHIFILE(1:II) = HIFILE(1:II)
        NEWFILE(1:1) = 'Y'
C
C     Just rewind if same file still in use
C
      ELSE
        IIUNIT = XIIUNIT
        NEWFILE(1:1) = 'N'
      ENDIF
C
C     See if first time through or output land sea mask filename has
C     changed since last access
C
      II = JINDEX(HOFILE)
      IF( XHOFILE(1:II).NE.HOFILE(1:II) ) THEN
C
C       Open output land sea mask file
C
        IF(XIOUNIT.NE.0) CALL PBCLOSE(XIOUNIT,IERR)
        CALL PBOPEN(IOUNIT, HOFILE, 'r', IERR)
        IF( IERR.NE.0 ) THEN
          IRLSMB = JPROUTINE + 1
C
          IF( KERR.GE.0 ) THEN
            CALL INTLOG(JP_ERROR,'IRLSMB: PBOPEN return code = ',IERR)
            CALL INTLOG(JP_ERROR,'IRLSMB: trying to open file',JPQUIET)
            CALL INTLOG(JP_ERROR, HOFILE(1:IOFILE),JPQUIET)
          ENDIF
C
          IF( KERR.EQ.0 ) CALL INTLOG(JP_FATAL,
     X      'IRLSMB: Interpolation failed.',JPQUIET)
          GOTO 900
        ENDIF
        XIOUNIT = IOUNIT
        XHOFILE(1:II) = HOFILE(1:II)
        NEWFILE(2:2) = 'Y'
C
C     Just rewind if same file still in use
C
      ELSE
        IOUNIT = XIOUNIT
        NEWFILE(2:2) = 'N'
      ENDIF
C
C     -----------------------------------------------------------------|
C*    Section 3. Calculate arrays of weights
C     -----------------------------------------------------------------|
C
  300 CONTINUE
C
      IF( KPR.GE.1 ) CALL INTLOG(JP_DEBUG,'IRLSMB: Section 3.',JPQUIET)
C
      IPR = KPR
C
      DO JOLAT = 1, NONS
C
        INDEXN = ( (JOLAT - 1) * 2 + JP_I_N - 1) * NOWE + 1
        INDEXS = ( (JOLAT - 1) * 2 + JP_I_S - 1) * NOWE + 1
C
C       Get line for output array
C
        IF( OOSTAND ) THEN
C
          IOFF = (KOLINE(JPNORTH) + (JOLAT - 1) * KOGRID(JPNSSTEP)
     X         - 1) * KOREC
C
          MSKFILE(2:2) = 'O'
          MSKFILE(1:1) = NEWFILE(2:2)
          IERR = IGLSMST(IOUNIT, IOFF, NOWE, KOLINE(JPWEST),
     X         KOGRID(JPWESTEP), KOREC, MOLSM, MSKFILE)
          NEWFILE(2:2) = 'N'
C
        ELSE
          IERR = IGLSM01(IOUNIT, NOWE, MOLONG, MOLATG(JOLAT),
     X         MEXPAND, KOREC, MOLSM)
        ENDIF
C
        IF( IERR.GT.0 ) THEN
          IRLSMB = IERR
          GOTO 900
        ENDIF
C
        ILATN = MNSIND(JP_I_N, JOLAT)
        ILATS = MNSIND(JP_I_S, JOLAT)
C
        ILINEN = MILLEN(ILATN)
        ISTRIDEN = JP360 / ILINEN
C
        ILINES = MILLEN(ILATS)
        ISTRIDES = JP360 / ILINES
C
        IZERO = 0
C
C       Get lines for input array
C
        IF( OISTAND ) THEN
C
          MSKFILE(2:2) = 'I'
          MSKFILE(1:1) = NEWFILE(1:1)
          IERR = IGLSMST(IIUNIT, MISTRT(ILATN) - 1, ILINEN,
     X         KILINE(JPWEST), KIGRID(JPWESTEP), ILINEN,
     X         MILSM(1, JP_I_N), MSKFILE)
          NEWFILE(1:1) = 'N'
C
          IF( IERR.GT.0 ) THEN
            IRLSMB = IERR
            GOTO 900
          ENDIF
C
          MSKFILE(2:2) = 'I'
          MSKFILE(1:1) = NEWFILE(1:1)
          IERR = IGLSMST(IIUNIT, MISTRT(ILATS) - 1, ILINES,
     X         KILINE(JPWEST), KIGRID(JPWESTEP), ILINES,
     X         MILSM(1, JP_I_S), MSKFILE)
          NEWFILE(1:1) = 'N'
C
        ELSE
C
          DO JLON = 0, ILINEN - 1
            MILONG(JLON + 1) = ISTRIDEN * JLON
          ENDDO
C
          IERR = IGLSM01(IIUNIT, ILINEN, MILONG, MILATG(ILATN),
     X         MEXPAND, KIREC, MILSM(1, JP_I_N))
C
          IF( IERR.GT.0 ) THEN
            IRLSMB = IERR
            GOTO 900
          ENDIF
C
          DO JLON = 0, ILINES - 1
            MILONG(JLON + 1) = ISTRIDES * JLON
          ENDDO
C
          IERR = IGLSM01(IIUNIT, ILINES, MILONG, MILATG(ILATS),
     X         MEXPAND, KIREC, MILSM(1, JP_I_S))
C
        ENDIF
C
        IF( IERR.GT.0 ) THEN
          IRLSMB = IERR
          GOTO 900
        ENDIF
C
C       Now modify the unormalised weight for land-sea mask
C
        IERR = IGLSMR(MILSM(1, JP_I_N), MILSM(1, JP_I_S),
     X      MOLSM, MWEIND(1, INDEXN), MWEIND(1, INDEXS), NOWE,
     X      WFACT(1,(JOLAT - 1) * NOWE + 1), IPR, KERR)
C
        IF( IERR.GT.0 ) THEN
          IRLSMB = IERR
          GOTO 900
        ENDIF
C
        IPR = KPR - 1
C
      ENDDO
C
C     -----------------------------------------------------------------|
C*    Section 9. Return to calling routine. Format statements
C     -----------------------------------------------------------------|
C
  900 CONTINUE
C
      IF( KPR.GE.1 ) CALL INTLOG(JP_DEBUG,'IRLSMB: Section 9.',JPQUIET)
C
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C


      SUBROUTINE DECFP (FVAL,IEXP,IMANT)
C---->
C
C*
C*    NAME      : DECFP
C*
C*    FUNCTION  : DECODE GRIB CODE REPRESENTATION TO
C*                FLOATING POINT NUMBER.
C*
C*    INPUT     : IEXP  - 8 BIT SIGNED EXPONENT
C*                IMANT - 24 BIT MANTISSA
C*
C*    OUTPUT    : FVAL  - FLOATING POINT NUMBER
C*                IEXP  - UNCHANGED
C*                IMANT - UNCHANGED
C*
C*    JOHN HENNESSY , ECMWF , 15TH APRIL 1985
C*
C     ---------------------------------------------------------------
C----<
C
C
      IF (IEXP.EQ.128.AND.IMANT.EQ.0)
     C   THEN
             FVAL = 0.0
             RETURN
         ENDIF
C
C
C
C     SIGN OF VALUE
C
      JEXP  = IEXP
      ISIGN = 1
C
      IF (JEXP.GE.128)
     C     THEN
               JEXP  = JEXP - 128
               ISIGN = -1
           END IF
C
C     DECODE VALUE.
C
      FVAL = ISIGN*2.**(-24)*IMANT*16.**(JEXP-64)
C
C
      RETURN
      END

C
C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities
C granted to it by virtue of its status as an intergovernmental organisation
C nor does it submit to any jurisdiction.
C

      INTEGER FUNCTION WVQLIN2(KNUM,NUMPTS,KE_W,KN_S,RESON,OLDWAVE,
     X                         NEWWAVE,NORTH,WEST,KPARAM,PMISS)
C
C---->
C*****WVQLIN2*
C
C     PURPOSE
C     -------
C
C     To interpolate a wave field quasi-regular latitude
C     longitude grid to a regular latitude/longitude grid.
C
C
C     INTERFACE
C     ---------
C
C     IRET = WVQLIN2(KNUM,NUMPTS,KE_W,KN_S,RESON,OLDWAVE,
C    X               NEWWAVE,NORTH,WEST,KPARAM,PMISS)
C
C     Input arguments
C     ---------------
C
C     KNUM    - No. of meridians from North to South pole (input field)
C     NUMPTS  - Array giving number of points along each latitude
C               (empty latitudes have entry 0)
C     KE_W    - First dimension of new array
C               = Number of points E-W in new grid
C     KN_S    - Second dimension of new array
C               = Number of points N-S in new grid
C     RESON   - Output grid resolution (degrees)
C     OLDWAVE - Original wave field
C     NORTH   - Input and output grid northernmost latitude (degree)
C     WEST    - Input and output grid westernmost  longitude (degree)
C     KPARAM  - Field parameter code
C     PMISS   - Missing value indicator
C
C     Output arguments
C     ----------------
C
C     NEWWAVE - New wave field
C
C     Function returns 0 if the interpolation was OK.
C
C
C     METHOD
C     ------
C
C     A bi-linear interpolation is only done if all four neighbouring
C     points are sea.
C     The nearest neighbouring grid point value is taken if one of the
C     neighbouring points is missing.
C     The interpolated point value is set to the 'missing' indicator
C     value if the point is outside the input grid.
C
C     A field representing a 'direction' is resolved into components
C     each of which is interpolated separately.
C
C     The output area is the same as the input area.
C
C
C     EXTERNALS
C     ---------
C
C     WVQLID2 - Calculate the indices of neighbouring points
C     INTLOG  - Log error message.
C
C
C     REFERENCE
C     ---------
C
C     Based on:
C         SUBROUTINE INTERPOLATE
C         Peter Janssen     ECMWF    September 1995
C     and:
C         SUBROUTINE EXPOINT
C         Heinz Gunther     ECMWF    December  1989
C
C
C     Author.
C     -------
C
C     J.D.Chambers      ECMWF    September 1996
C
C     J.D.Chambers      ECMWF    September 1998
C     Modified to handle subarea input/output.
C     The output area is the same as the input area.
C
C     J.D.Chambers      ECMWF    November 2000
C     Modified to input grid resolution to be different from the
C     output grid resolution.
C
C----<
C
      IMPLICIT NONE
C
#include "parim.h"
C
C     Parameters
C
      INTEGER JPROUTINE, JPLLMAX, JPNMOUT,
     X        JPNW, JPNE, JPSW, JPSE, JPN, JPS,
     X        JPDISNW, JPDISNE, JPDISSW, JPDISSE
      PARAMETER( JPROUTINE = 19400 )
      PARAMETER( JPLLMAX   =  1801 ) ! allow up to 0.1 degree resolution
      PARAMETER( JPNMOUT   =  1800 ) ! allow up to 0.1 degree resolution
      PARAMETER( JPNW=1, JPNE=2, JPSW=3, JPSE=4, JPN=5, JPS=6,
     X           JPDISNW=7, JPDISNE=8, JPDISSW=9, JPDISSE=10 )
C
C     Arguments
C
      INTEGER KNUM, NUMPTS(*), KE_W, KN_S, KPARAM
      REAL RESON, NORTH, WEST, PMISS
      REAL RNS !FIXME: Unused! Difference in degrees in NS disrection
      REAL OLDWAVE(*), NEWWAVE(*)
C
C     Local variables
C
      INTEGER NLAT, K, I, NEWROW, NEWCOL, I1N, I1S, I_N, I_S, I2N, I2S
      REAL*4 DELONGN, DELONGS, DELAT, DI1N, DI1S, DI2N, DI2S
      REAL*4 DIST_N, DIST_S
      REAL*4 DISNW, DISNE, DISSW, DISSE
      REAL*4 U1, U2, ZXIN, ZXIS
      REAL LON(JPNMOUT*2), LAT(JPNMOUT+1)
      LOGICAL INGRID, LDIREC
      INTEGER NW_PT, NE_PT, SW_PT, SE_PT
      REAL*4 NWVALUE, NEVALUE, SWVALUE, SEVALUE
      REAL*4 RAD
      REAL*4 CNW_PT, CNE_PT, CSW_PT, CSE_PT
      REAL*4 SNW_PT, SNE_PT, SSW_PT, SSE_PT
      REAL*4 C1, C2, S1, S2, CC, SS
C
      DATA RAD/0.017453293/
C
      REAL OLDLATS(JPLLMAX), OLDEAST
      REAL OLDNS
      INTEGER ISTART, IEND
      INTEGER LOCATE
      INTEGER NEXT, NUMNEW(JPLLMAX)
      INTEGER IRET
      INTEGER XKNUM,XKE_W,XKN_S
      DATA XKNUM/-1/,XKE_W/-1/,XKN_S/-1/
      REAL XRESON,XNORTH,XWEST
      DATA XRESON/-999.0/,XNORTH/-999.0/,XWEST/-999.0/
      INTEGER IFIRST, NEWIDX(4,3600*1801)
      DATA IFIRST/0/
      REAL*4 DISTNEW(10,3600*1801)
C
      INTEGER IOS
      INTEGER OLDKNUM
      DATA OLDKNUM/0/
      INTEGER INDEX(JPLLMAX)
      REAL DEPS
      DATA DEPS/0.00005/
C     Inline function - tests TRUE if A is a missing value
C     EPS      Tolerance on missing data flag
      REAL EPS
      DATA EPS/0.1/
      LOGICAL LSW,LSE,LNE,LNW,LTEMP
C
      SAVE IFIRST,XKNUM,XKE_W,XKN_S,XRESON,XNORTH,XWEST,NEWIDX,DISTNEW
C
C     Externals
C
      INTEGER WVQLID2
      LOGICAL IS_WAVE_DIRECTION
      EXTERNAL WVQLID2, IS_WAVE_DIRECTION
C
C     -----------------------------------------------------------------|
C*    Section 1. Initalisation.
C     -----------------------------------------------------------------|
C
  100 CONTINUE
C
      WVQLIN2 = 0
      CALL INTLOG(JP_DEBUG,
     X   'WVQLIN2: Wave interpolation requested.',JPQUIET)
C
C     Check reduced latitude/longitude grid specification
C
      IF( KNUM.GT.JPLLMAX ) THEN
        CALL INTLOG(JP_ERROR,
     X    'WVQLIN2: Number of latitudes in input lat/long grid = ',KNUM)
        CALL INTLOG(JP_ERROR,
     X    'WVQLIN2: And is greater than allowed maximum = ',JPLLMAX)
        WVQLIN2 = JPROUTINE + 1
        GOTO 900
      ENDIF
C
C     Ensure working array dimensions are adequate for required output.
C
      IF( (KE_W.GT.JPNMOUT*2).OR.(KN_S.GT.JPNMOUT+1) ) THEN
        CALL INTLOG(JP_ERROR,
     X    'WVQLIN2: Internal array dimensions are too small',JPQUIET)
        CALL INTLOG(JP_ERROR,
     X    'WVQLIN2: for given lat/long output field.',JPQUIET)
        WVQLIN2 = JPROUTINE + 3
        GOTO 900
      ENDIF
C
C     Set up index for latitude lines in the input reduced lat/lon array
C
      INDEX(1) = 0
      DO K = 2, KNUM
        INDEX(K) = INDEX(K-1) + NUMPTS(K-1)
      ENDDO

      DO K = 1, KN_S
        LAT(K)     = NORTH - FLOAT(K-1)*RESON
        NUMNEW(K)  = KE_W
      ENDDO
C
C     Calculate latitudes and longitudes of output grid points.
C
      DO I = 1,KE_W
        LON(I) = FLOAT(I-1)*RESON
      ENDDO
C
C     Calculate latitudes for input (old) grid.
C     (Input and output area are same)
C
      OLDNS =  RNS/REAL(KNUM-1)
      DO K = 1, KNUM
        OLDLATS(K) = NORTH - FLOAT(K-1)*OLDNS
      ENDDO
C
C     Find first and last latitudes in input grid which are not empty
C
      ISTART = 1
      DO K = 1, KNUM/2
        IF( NUMPTS(K).EQ.0 ) ISTART = ISTART + 1
      ENDDO
C
      IEND = KNUM
      DO K = KNUM, (KNUM/2) + 1, -1
        IF( NUMPTS(K).EQ.0 ) IEND = IEND - 1
      ENDDO
C
C     For the regular output grid, calculate its latitudes and fill
C     in the number of points along each latitude.
C
C
C     Setup East depending on whether or not there is wrap-around
C
      IF( ABS((KE_W*RESON)-360.0).LT.DEPS ) THEN
        OLDEAST = WEST + KE_W*RESON
      ELSE
        OLDEAST = WEST + (KE_W-1)*RESON
      ENDIF
C
C     Initialise all points with 'missing data' indicator
C
      NEXT  = 0
      DO NEWROW = 1, KN_S
        DO NEWCOL = 1, KE_W
          NEXT = NEXT + 1
          NEWWAVE(NEXT) = PMISS
        ENDDO
      ENDDO
C
C     Wave direction parameters need special handling
      LDIREC = IS_WAVE_DIRECTION(KPARAM)
C
C     -----------------------------------------------------------------|
C*    Section 2. Interpolation.
C     -----------------------------------------------------------------|
C
  200 CONTINUE
C
C     Only calculate the indices on the first time through
C
      IF( (IFIRST.EQ.0 )     .OR.
     X    ( KNUM.NE.XKNUM )  .OR.
     X    ( KE_W.NE.XKE_W )  .OR.
     X    ( KN_S.NE.XKN_S )  .OR.
     X    ( RESON.NE.XRESON ).OR.
     X    ( NORTH.NE.XNORTH ).OR.
     X    ( WEST.NE.XWEST ) ) THEN
C
        IRET =  WVQLID2(KNUM,NUMPTS,OLDLATS,WEST,OLDEAST,
     X                  KN_S,NUMNEW,LAT,NEWIDX,DISTNEW)
        IFIRST = 1
        XKNUM  = KNUM
        XKE_W  = KE_W
        XKN_S  = KN_S
        XRESON = RESON
        XNORTH = NORTH
        XWEST  = WEST
      ENDIF
C
      DELAT = OLDNS
      NEXT  = 0
C
      DO 220 NEWROW = 1, KN_S
C
C       Set up the distance between new row and the old rows to N and S.
C
        NLAT  = NINT((NORTH - LAT(NEWROW))/DELAT) + 1
        I_N   = NLAT
        I_S   = MIN(I_N+1,KNUM*2)
        DIST_N  = ((NORTH - DELAT*(I_N-1)) - LAT(NEWROW)) / DELAT
        DIST_S  = 1.0 - DIST_N
C
C       Check if the new interpolated row lies between 2 old rows which
C       have data points
C
        IF( (NUMPTS(I_N).GT.0).AND.(NUMPTS(I_S).GT.0) ) THEN
C
C         Yes, use the calculated indices
C
          DO 210 NEWCOL = 1, KE_W
C
            NEXT = NEXT + 1
C
            NW_PT = NEWIDX(JPNW,NEXT)
            NE_PT = NEWIDX(JPNE,NEXT)
            SW_PT = NEWIDX(JPSW,NEXT)
            SE_PT = NEWIDX(JPSE,NEXT)
            NWVALUE = OLDWAVE(NW_PT)
            NEVALUE = OLDWAVE(NE_PT)
            SWVALUE = OLDWAVE(SW_PT)
            SEVALUE = OLDWAVE(SE_PT)
C
C           Test if any one of the four neighbouring points is missing.
C
              LTEMP = .FALSE.
              LSE = .FALSE.
             IF(ABS(SEVALUE-PMISS) .LT. EPS)   LSE = .TRUE.
              LSW = .FALSE.
             IF(ABS(SWVALUE-PMISS) .LT. EPS)   LSW = .TRUE.
              LNE = .FALSE.
             IF(ABS(NEVALUE-PMISS) .LT. EPS)   LNE = .TRUE.
              LNW = .FALSE.
             IF(ABS(NWVALUE-PMISS) .LT. EPS)   LNW = .TRUE.
C
            IF( (NW_PT.EQ.0 .OR. LNW) .OR.
     X          (NE_PT.EQ.0 .OR. LNE) .OR.
     X          (SW_PT.EQ.0 .OR. LSW) .OR.
     X          (SE_PT.EQ.0 .OR. LSE) ) THEN
C             If so, take nearest grid point value.
C
              DISNW = DISTNEW(JPDISNW,NEXT)
              DISNE = DISTNEW(JPDISNE,NEXT)
              DISSW = DISTNEW(JPDISSW,NEXT)
              DISSE = DISTNEW(JPDISSE,NEXT)
C
              IF( (DISNW.LE.DISNE).AND.
     X            (DISNW.LE.DISSW).AND.
     X            (DISNW.LE.DISSE) ) THEN
cs                NEWWAVE(NEXT) = NWVALUE
                LOCATE = NW_PT
                LTEMP  = LNW
C
              ELSE IF( (DISNE.LE.DISSW).AND.
     X                 (DISNE.LE.DISSE) ) THEN
cs                NEWWAVE(NEXT) = NEVALUE
                LOCATE = NE_PT
                LTEMP  = LNE
C
              ELSE IF( (DISSW.LE.DISSE) ) THEN
cs                NEWWAVE(NEXT) = SWVALUE
                LOCATE = SW_PT
                LTEMP  = LSW
C
              ELSE
cs                NEWWAVE(NEXT) = SEVALUE
                LOCATE = SE_PT
                LTEMP  = LSE
C
              ENDIF

              IF( .NOT.LTEMP.AND.LOCATE.NE.0) THEN
c              IF( LOCATE.NE.0) THEN
                  NEWWAVE(NEXT) = OLDWAVE(LOCATE)
              ENDIF

C
            ELSE
C
C             Use bi-linear interpolation from four
C             neighbouring sea points.
C
              DI1N = DISTNEW(JPNW,NEXT)
              DI2N = DISTNEW(JPNE,NEXT)
              DI1S = DISTNEW(JPSW,NEXT)
              DI2S = DISTNEW(JPSE,NEXT)
              DIST_N  = DISTNEW(JPN,NEXT)
              DIST_S  = DISTNEW(JPS,NEXT)
C
              NW_PT = OLDWAVE(NW_PT)
              NE_PT = OLDWAVE(NE_PT)
              SW_PT = OLDWAVE(SW_PT)
              SE_PT = OLDWAVE(SE_PT)
C
              IF( .NOT. LDIREC ) THEN
                U1 = NWVALUE*DI2N + NEVALUE*DI1N
                U2 = SWVALUE*DI2S + SEVALUE*DI1S
                NEWWAVE(NEXT) = U1*DIST_S + U2*DIST_N
C
              ELSE
C
C               Fields representing a 'direction': resolve into
C               components and interpolate each separately.
C
                CNW_PT = COS(NWVALUE*RAD)
                CNE_PT = COS(NEVALUE*RAD)
                CSW_PT = COS(SWVALUE*RAD)
                CSE_PT = COS(SEVALUE*RAD)
                SNW_PT = SIN(NWVALUE*RAD)
                SNE_PT = SIN(NEVALUE*RAD)
                SSW_PT = SIN(SWVALUE*RAD)
                SSE_PT = SIN(SEVALUE*RAD)
                C1 = CNW_PT*DI2N + CNE_PT*DI1N
                C2 = CSW_PT*DI2S + CSE_PT*DI1S
                CC = C1*DIST_S + C2*DIST_N
                S1 = SNW_PT*DI2N + SNE_PT*DI1N
                S2 = SSW_PT*DI2S + SSE_PT*DI1S
                SS = S1*DIST_S + S2*DIST_N
                IF( SS.LT.0.0 ) THEN
                  NEWWAVE(NEXT) = ATAN2(SS,CC)/RAD + 360.0
                ELSE
                  NEWWAVE(NEXT) = ATAN2(SS,CC)/RAD
                ENDIF
              ENDIF
            ENDIF
  210     CONTINUE
        ELSE
           NEXT = NEXT + KE_W
        ENDIF
C
  220 CONTINUE
C
C     -----------------------------------------------------------------|
C*    Section 9. Closedown.
C     -----------------------------------------------------------------|
C
  900 CONTINUE
C
      IF( WVQLIN2.EQ.0 ) THEN
        CALL INTLOG(JP_DEBUG,
     X    'WVQLIN2: Wave interpolation successful.',JPQUIET)
      ELSE
        CALL INTLOG(JP_DEBUG,
     X    'WVQLIN2: Wave interpolation failed.',JPQUIET)
      ENDIF
c     call abort()
C
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities
C granted to it by virtue of its status as an intergovernmental organisation
C nor does it submit to any jurisdiction.
C

      INTEGER FUNCTION INTUVGH(KUGRIBI, KVGRIBI, INLEN,
     X                         KUGRIBO, KVGRIBO,
     X                         OUTLENU, OUTLENV)
C
C---->
C**** INTUVGH
C
C     Purpose
C     -------
C
C     Interpolate GRIB format input U and V component reduced gaussian
C     fields to rotated GRIB format U and V fields.
C
C
C     Interface
C     ---------
C
C     IRET = INTUVGH(KUGRIBI,KVGRIBI,INLEN,KUGRIBO,KVGRIBO,OUTLENU,OUTLENV)
C
C     Input
C     -----
C
C     KUGRIBI - Input U component field (reduced gaussian, GRIB format).
C     KVGRIBI - Input V component field (reduced gaussian, GRIB format).
C     INLEN   - Input field length (words).
C
C
C     Output
C     ------
C
C     KUGRIBO - Output U field (GRIB format).
C     KVGRIBO - Output V field (GRIB format).
C     OUTLENU - Output U field length (words).
C     OUTLENV - Output V field length (words).
C
C
C     Method
C     ------
C
C     Use HIRLAM rotation scheme.
C
C     Note that a common block is used in intf.h to hold the U/V
C     fields before interpolation.
C
C     Externals
C     ---------
C
C     IBASINI - Ensure basic interpolation setup is done.
C     INTUVDH - Encodes/decodes data into/from GRIB code.
C     JMEMHAN - Allocate scratch memory.
C     FIXAREA - Fixup area definition to correspond to grid definitions
C     INTLOG  - Log error message.
C     MKFRAME - Create a 'frame' from a rectangular field.
C     RESET_C - Reset interpolation handling options using GRIB product.
C     INSANE  - Ensure no outrageous values given for interpolation.
C     HRG2GGW - Creates rotated gaussian U and V from reduced gaussian
C     HLL2LLW - Creates rotated lat/long U and V from lat/long
C
C
C     Author
C     ------
C
C     J.D.Chambers     ECMWF     October 2001
C
C
C----<
C     -----------------------------------------------------------------|
C
      IMPLICIT NONE
C
C     Function arguments
C
      INTEGER KUGRIBI(*), KVGRIBI(*), INLEN
      INTEGER KUGRIBO(*), KVGRIBO(*), OUTLENU, OUTLENV
C
#include "parim.h"
#include "nifld.common"
#include "nofld.common"
#include "intf.h"
#include "intlog.h"
#include "current.h"
C
C     Parameters
C
      INTEGER JPROUTINE, JPALLOC, JPSCR4
      PARAMETER (JPROUTINE = 40170 )
      PARAMETER (JPALLOC = 1)
      PARAMETER (JPSCR4 = 4)
C
C     Local variables
C
      REAL OLDGRID(2), AREA(4), GRID(2), POLE(2)
      LOGICAL LOLDWIND, LFRAME
      INTEGER IRET, KPR, ISZOUV, ISIZE, ISAME, IPARAM
      INTEGER LOOP, NGAUSS
      INTEGER IPINU, IPINV, NUMPTS, NLON, NLAT, IN_U, IN_V
#ifndef _CRAYFTN
#ifdef POINTER_64
      INTEGER*8 IOUV, ISWORK
#endif
#endif
      REAL OLDUV, SWORK
      POINTER ( IOUV, OLDUV(1) )
      POINTER (ISWORK, SWORK(1) )
C
C     Externals
C
      INTEGER RESET_C, FIXAREA, IBASINI, INSANE, INTUVDH, HIRLAMW
      INTEGER HRG2GGW, HLL2LLW
      EXTERNAL RESET_C, FIXAREA, IBASINI, INSANE, INTUVDH, HIRLAMW
      EXTERNAL HRG2GGW, HLL2LLW
C
C     -----------------------------------------------------------------|
C*    Section 1.   Initialise
C     -----------------------------------------------------------------|
C
  100 CONTINUE
      IRET     = 0
      KPR      = 0
      LOLDWIND = .FALSE.
      INTUVGH  = 0
C
      LFRAME = LNOFRAME.AND.
     X         ((NOREPR.EQ.JPREGULAR).OR.(NOREPR.EQ.JPREGROT))
C
C     Ensure that basic initialisation has been done
C
      IRET = IBASINI(0)
      IF( IRET.NE.0 ) THEN
        CALL INTLOG(JP_ERROR,'INTUVGH: basic initialise failed',JPQUIET)
        INTUVGH = IRET
        GOTO 900
      ENDIF
C
C     -----------------------------------------------------------------|
C*    Section 2.   Unpack the U/V fields.
C     -----------------------------------------------------------------|
C
  200 CONTINUE
C
C     Need to establish input characteristics, so unpack GRIB sections 1
C     and 2.
C
      IPARAM = 0
      IPINU  = 1
      IRET = INTUVDH(OLDUV(IPINU),ISZOUV,KUGRIBI,INLEN,'I',IPARAM)
      IF( IRET.NE.0 ) THEN
        CALL INTLOG(JP_ERROR,'INTUVGH: GRIB header decode failed',IRET)
        INTUVGH = IRET
        GOTO 900
      ENDIF
C
C     Check whether the input field is an ECMWF reduced gaussian or
C     lat/long U field
C
      IF( (ISEC1(1).NE.128).OR.
     X    ((ISEC1(6).NE.JP_U).AND.(ISEC1(6).NE.JP_10U)) ) THEN
        CALL INTLOG(JP_ERROR,
     X    'INTUVGH: Input is not ECMWF U field.',JPQUIET)
        INTUVGH = JPROUTINE + 2
        GOTO 900
      ENDIF
      IF( (ISEC2(1).NE.4).AND.
     X    ((ISEC2(17).NE.0) .OR.(ISEC2(1).NE.0)) ) THEN
        CALL INTLOG(JP_ERROR,
     X    'INTUVGH: Input not gaussian or lat/long.',JPQUIET)
        INTUVGH = JPROUTINE + 2
        GOTO 900
      ENDIF
C
C     Get scratch memory for U/V unpacked fields.
C     U/V memory areas are adjacent.
C
      IF( ISEC2(17).EQ.1 ) THEN
        ISZOUV  = 0
        DO LOOP = 1, ISEC2(3)
          ISZOUV = ISZOUV + ISEC2(22+LOOP)
        ENDDO
      ELSE
        ISZOUV = ISEC2(2) * ISEC2(3)
      ENDIF
C
      IPINU = 1
      IPINV = 1 + ISZOUV
      CALL JMEMHAN( JPSCR4, IOUV, ISZOUV*2, JPALLOC, IRET)
      IF( IRET.NE.0 ) THEN
        CALL INTLOG(JP_ERROR,
     X    'INTUVGH: Scratch memory type 4 allocation failed.',JPQUIET)
        INTUVGH = IRET
        GOTO 900
      ENDIF
C
C     Decode input U and V
C
      IRET = INTUVDH(OLDUV(IPINU),ISZOUV,KUGRIBI,INLEN,'D',IPARAM)
      IF( IRET.NE.0 ) THEN
        CALL INTLOG(JP_ERROR,'INTUVGH: Vorticity decoding failed',IRET)
        INTUVGH = IRET
        GOTO 900
      ENDIF
      IN_U = ISEC1(6)
C
      IRET = INTUVDH(OLDUV(IPINV),ISZOUV,KVGRIBI,INLEN,'D',IPARAM)
      IF( IRET.NE.0 ) THEN
        CALL INTLOG(JP_ERROR,'INTUVGH: Divergence decoding failed',IRET)
        INTUVGH = IRET
        GOTO 900
      ENDIF
      IN_V = ISEC1(6)
C
C     Setup interpolation options from input GRIB characteristics.
C
      IRET = RESET_C( ISEC1, ISEC2, ZSEC2, ISEC4)
      IF( IRET.NE.0 ) THEN
        CALL INTLOG(JP_ERROR,
     X    'INTUVGH: Setup interp. options from GRIB failed.',JPQUIET)
        INTUVGH = IRET
        GOTO 900
      ENDIF
C
C     Check that no outrageous values given for interpolation
C
      ISAME = INSANE()
      IF( ISAME.GT.0 ) THEN
        CALL INTLOG(JP_ERROR,
     X    'INTUVGH: Interpolation cannot use given values.',JPQUIET)
        INTUVGH = ISAME
        GOTO 900
      ENDIF
C
      IRET = FIXAREA()
      IF( IRET.NE.0 ) THEN
        CALL INTLOG(JP_ERROR,'INTUVGH: Fixarea failed.',JPQUIET)
        INTUVGH = IRET
        GOTO 900
      ENDIF
C
      LWIND = .TRUE.
      LOLDWIND = LWINDSET
      LWINDSET = .TRUE.
C
      DO LOOP = 1, 4
        AREA(LOOP) = REAL(NOAREA(LOOP))/PPMULT
      ENDDO
      DO LOOP = 1, 2
        GRID(LOOP) = REAL(NOGRID(LOOP))/PPMULT
        POLE(LOOP) = REAL(NOROTA(LOOP))/PPMULT
      ENDDO
C
C     -----------------------------------------------------------------|
C*    Section 3.   Generate interpolated lat/long U and V fields.
C     -----------------------------------------------------------------|
C
  300 CONTINUE
C
      IF( (NOREPR.EQ.JPREGULAR).OR.(NOREPR.EQ.JPREGROT) ) THEN
C
C       Dynamically allocate scrath space for rotated lat/long grid
C
        NLON = 1 + NINT(FLOAT(NOAREA(JPEAST)  - NOAREA(JPWEST)) /
     X         NOGRID(JPWESTEP))
        NLAT = 1 + NINT(FLOAT(NOAREA(JPNORTH) - NOAREA(JPSOUTH)) /
     X         NOGRID(JPNSSTEP))
C
        NOWE = NLON
        NONS = NLAT
        NUMPTS = NLON * NLAT
        ISIZE  = NUMPTS * 2
        CALL JMEMHAN( 11, ISWORK, ISIZE, 1, IRET)
        IF( IRET.NE.0 ) THEN
          CALL INTLOG(JP_ERROR,
     X      'INTUVGH: memory alloc for lat/long grid fail',JPQUIET)
          INTUVGH = JPROUTINE + 3
          GOTO 900
        ENDIF
C
C       Rotate reduced gaussian to lat/long
C
        IF( (NIREPR.EQ.JPGAUSSIAN).OR.(NIREPR.EQ.JPQUASI) ) THEN
          IRET = HIRLAMW(LO12PT,
     X                   OLDUV(IPINU),OLDUV(IPINV),ISZOUV,
     X                   NOGAUSS,AREA,POLE,GRID,
     X                   SWORK,SWORK(1+NUMPTS),NUMPTS,NLON,NLAT)
          IF( IRET.NE.0 ) THEN
            CALL INTLOG(JP_ERROR,
     X        'INTUVGH: HIRLAMW rotation failed',JPQUIET)
            INTUVGH = JPROUTINE + 3
            GOTO 900
          ENDIF
C
C       Rotate lat/long to lat/long
C
        ELSE
          OLDGRID(1) = REAL(NIGRID(1)) / PPMULT
          OLDGRID(2) = REAL(NIGRID(2)) / PPMULT
          IRET = HLL2LLW(LO12PT,OLDUV(IPINU),OLDUV(IPINV),
     X                   OLDGRID,AREA,POLE,GRID,
     X                   SWORK,SWORK(1+NUMPTS),NUMPTS,NLON,NLAT)
          IF( IRET.NE.0 ) THEN
            CALL INTLOG(JP_ERROR,
     X        'INTUVGH: HLL2LLW rotation failed',JPQUIET)
            INTUVGH = JPROUTINE + 3
            GOTO 900
          ENDIF
        ENDIF
C
C       If a 'frame' has been specified, build the frame
C
        IF( LFRAME ) THEN
          LIMISSV = .TRUE.
          CALL MKFRAME(NLON,NLAT,SWORK,RMISSGV,NOFRAME)
          CALL MKFRAME(NLON,NLAT,SWORK(1+NUMPTS),RMISSGV,NOFRAME)
        ENDIF
C
      ELSE
C
C     -----------------------------------------------------------------|
C*    Section 4.   Generate interpolated gaussian U and V fields.
C     -----------------------------------------------------------------|
C
  400   CONTINUE
C
        IF( LDEBUG ) CALL INTLOG(JP_DEBUG,
     X    'INTUVGH: Gaussian to gaussian',JPQUIET)
C
C       Dynamically allocate memory for rotated gaussian grids
C
        NUMPTS = 0
        DO LOOP = 1, NOGAUSS*2
          NUMPTS = NUMPTS + NOLPTS(LOOP)
        ENDDO
        ISIZE = 2 * NUMPTS
        CALL JMEMHAN( 11, ISWORK, ISIZE, 1, IRET)
        IF( IRET.NE.0 ) THEN
          IF( LDEBUG ) CALL INTLOG(JP_ERROR,
     X      'INTUVGH: memory alloc for gaussian grid fail',JPQUIET)
          INTUVGH = JPROUTINE + 4
          GOTO 900
        ENDIF
C
        NGAUSS = ISEC2(10)
        IRET = HRG2GGW(LO12PT,
     X                 OLDUV(IPINU),OLDUV(IPINV),ISZOUV,
     X                 NGAUSS,AREA,POLE,NOGAUSS,HOGAUST,
     X                 SWORK,SWORK(1+ISIZE/2),ISIZE,NUMPTS)
        IF( IRET.NE.0 ) THEN
          IF( LDEBUG ) CALL INTLOG(JP_ERROR,
     X        'INTUVGH: HRG2GGW rotation failed',JPQUIET)
            INTUVGH = JPROUTINE + 4
            GOTO 900
          ENDIF
C
      ENDIF
C
C     -----------------------------------------------------------------|
C*    Section 5.   Pack the fields into GRIB format
C     -----------------------------------------------------------------|
C
  500 CONTINUE
C
      IF( ((NOREPR.EQ.JPQUASI).OR.
     X     (NOREPR.EQ.JPQGGROT).OR.
     X     (NOREPR.EQ.JPFGGROT).OR.
     X     (NOREPR.EQ.JPGAUSSIAN)).AND.
     X    ( (NOROTA(1).NE.9000000).AND.(NOROTA(2).NE.0) ) ) THEN
        ISEC2(1) = JPFGGROT
      ELSE
        ISEC2(1) = NOREPR
      ENDIF
C
      ISEC4(1) = NUMPTS
C
C     Reset the input format flag
C
      NIFORM = 1
C
C     Set the components flag for rotated U and V coefficients
C
      ISEC2(19) = 8
C
      IRET = INTUVDH(SWORK,NUMPTS,KUGRIBO,OUTLENU,'C',IN_U)
      IF( IRET.NE.0 ) THEN
        CALL INTLOG(JP_ERROR,
     X    'INTUVGH: Wind component into GRIB encoding fail',IRET)
        INTUVGH = JPROUTINE + 4
        GOTO 900
      ENDIF
C
      IRET = INTUVDH(SWORK(1+(ISIZE/2)),NUMPTS,KVGRIBO,OUTLENV,'C',IN_V)
      IF( IRET.NE.0 ) THEN
        CALL INTLOG(JP_ERROR,
     X    'INTUVGH: Wind component into GRIB encoding fail',IRET)
        INTUVGH = JPROUTINE + 4
        GOTO 900
      ENDIF
C
C     -----------------------------------------------------------------|
C*    Section 9.   Return
C     -----------------------------------------------------------------|
C
  900 CONTINUE
C
C     Clear change flags for next product processing and reset wind flag
C
      LCHANGE = .FALSE.
      LSMCHNG = .FALSE.
      LWINDSET  = LOLDWIND
C
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE CREXERR(KERR)
C**** *CREXERR*
C
C
C     PURPOSE.
C     --------
C         PRINT ERROR CODE.
C
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *CREXERR(KERR)*
C
C         INPUT:  *NONE*
C
C         OUTPUT: *KERR* - Return error code
C
C     METHOD.
C     -------
C
C          NONE.
C
C
C     EXTERNALS.
C     ----------
C
C          NONE.
C
C     REFERENCE.
C     ----------
C
C          NONE.
C
C     AUTHOR.
C     -------
C
C          MILAN DRAGOSAVAC    *ECMWF*       07/01/2004.
C
C
C     MODIFICATIONS.
C     --------------
C
C          NONE.
C
C
      IMPLICIT LOGICAL(L,O,G), CHARACTER*8(C,H,Y)
C
C
      CHARACTER*80 CERROR(100)
C
      DATA CERROR/100*' '/
C
C     ------------------------------------------------------------------
C
C*          1.   INITIALIZE MESSAGES.
C                --------------------
 100  CONTINUE
C
      CERROR( 1)=' Start of CREX message not found.'
      CERROR( 2)=' End of CREX message not found.'
      CERROR( 3)=' Array to receive CREX message too small.'
      CERROR( 6)=' Error during read CREX table B.'
      CERROR( 7)=' Error during read CREX table C.'
      CERROR( 8)=' Error during read CREX table D.'
      CERROR( 9)=' Open error.'
      CERROR(10)=' Error during close CREX table B.'
      CERROR(11)=' Error during close CREX table C.'
      CERROR(12)=' Error during close CREX table D.'
      CERROR(13)=' Too many elements in the table'
      CERROR(14)=' Argument KVALS too small.'
      CERROR(19)=' Delayed replication factor too big.'
      CERROR(20)=' Table D reference not found.'
      CERROR(21)=' Data descriptor operator not found.'
      CERROR(22)=' CREX Opeartor name not found.'
      CERROR(23)=' Table B reference not found.'
      CERROR(25)=' KELEM argument too small.'
      CERROR(26)=' Word pointer out of range.'
      CERROR(30)=' Number of elements greater than JELEM.'
      CERROR(31)=' Too few elements in KDATA array.'
      CERROR(32)=' Number of subsets equal to zero.'
      CERROR(33)=' Internal write error'
      CERROR(34)=' Decimal to octal conversion error'
      CERROR(35)=' Internal read error'
      CERROR(36)=' Bad order of data descriptors.'
      CERROR(37)=' Wrong data descriptor.'
      CERROR(38)=' Open error on units.cinfig.dat file'
      CERROR(39)=' Read error on units.cinfig.dat file'
      CERROR(40)=' Could not find next section'
      CERROR(41)=' '
      CERROR(42)=' Wrong start of section 1 of CREX message '
      CERROR(43)=' Could not find the end of section 1'
      CERROR(44)=' Error during extraction of Master table'
      CERROR(45)=' Error during extraction of Edition number'
      CERROR(46)=' Error during extraction of version number'
      CERROR(47)=' Unit not found'
C
      IF(KERR.GE.0.AND.KERR.LE.100) THEN
        WRITE(*,'(1h ,A)') CERROR(KERR)
      ELSE
        WRITE(*,'(1h ,A)') ' Error number out of range !'
      END IF
C
      RETURN
      END

C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      INTEGER FUNCTION INTIN( HPARN, INTV, REALV, CHARV)
C  
C---->
C**** INTIN
C  
C     Purpose
C     -------
C
C     Change input field parameters in common block.
C  
C     Interface
C     ---------
C
C     Input
C     -----
C
C     HPARN - MARS parameter name.
C     INTV  - MARS parameter value(s) (Integer).
C     REALV - MARS parameter value(s) (Real).
C     CHARV - MARS parameter value(s) (Character).
C  
C  
C     Method
C     ------
C
C     Recognise MARS paramter and reset appropriate common
C     variable value(s).
C
C     Uses environment variable ISLSCP_OLD_LSM to locate old
C     land-sea mask GRIB product file. If the variable is not set,
C     uses /home/ma/emos/data/islscp_old_lsm.
C  
C
C     Externals
C     ---------
C
C     JDEBUG   - Check if debug switched on.
C     IBASINI  - Check basic initialisation of common blocks is done
C     CHEQUAL  - Compare two ASCII strings without regard to case.
C     INTLOG   - Log error message.
C     JMALLOC  - Dynamically allocate memory
C     JFREE    - Free dynamically allocated memory
C     GETENV   - Get value of an environment variable
C  
C  
C     Author
C     ------
C
C     J.D.Chambers       ECMWF        August 1994.
C  
C----<
C
C     IMPLICIT NONE
C
C     Parameters
C
      INTEGER JPROUTINE
      PARAMETER (JPROUTINE = 28100)
C
C     Function arguments
C
      CHARACTER*(*) HPARN
      CHARACTER*(*) CHARV
      REAL REALV(*)
      INTEGER INTV(*)
C
#include "parim.h"
#include "nifld.common"
#include "nifld.extracommon"
#include "nofld.common"
#include "grfixed.h"
#include "current.h"
#include "intf.h"
C
C     Local variables
C
      INTEGER ITEMP, I, IRET, ILOOP, ILAST, IGSIZE, IASIZE, IBLANK
      INTEGER NEWGRIB(1), OLDGRIB(1)
      POINTER( NIPNGRB, NEWGRIB )
      POINTER( NIPOGRB, OLDGRIB )
      LOGICAL LFOUND
      CHARACTER*256 OLDLSM, ISLDEFL
      CHARACTER*3 NUMBER
C
C     Externals
C
#ifdef POINTER_64
      INTEGER*8 JMALLOC
#else
      INTEGER JMALLOC
#endif
      LOGICAL CHEQUAL
      EXTERNAL CHEQUAL, JMALLOC
C
      DATA ISLDEFL/'/home/ma/emos/data/islscp_old_lsm'/
      SAVE ISLDEFL
C
C     -----------------------------------------------------------------|
C*    Section 1.   Initialise
C     -----------------------------------------------------------------|
C
  100 CONTINUE
C
      INTIN = 0
      LFOUND = .FALSE.
C
C     Check if debug turned on
      CALL JDEBUG()
C
C     Ensures basic initialisation of common blocks is done
      CALL IBASINI(0)
C
      CALL INTLOG(JP_DEBUG, 'INTIN: option = ' // HPARN ,JPQUIET)
C
C     -----------------------------------------------------------------|
C*    Section 2.   Decode request
C     -----------------------------------------------------------------|
C
  200 CONTINUE
C
C     Request ISLSCP processing
C
      IF( CHEQUAL( HPARN, 1, 6, 'islscp') ) THEN
        LFOUND = .TRUE.
        CALL INTLOG(JP_DEBUG, 'INTIN: islscp = ' // CHARV ,JPQUIET)
C
        IF( CHEQUAL( CHARV, 1, 3, 'off' ) ) THEN
          IF( LNIISCL ) THEN
            CALL JFREE(NIPOGRB)
            CALL JFREE(NIPNGRB) 
            NIPOGRS = 0
            NIPNGRS = 0
          ENDIF
          LNIISCL = .FALSE.
          GOTO 900
        ENDIF
C
        LNIISCL = .TRUE.
C
C       Pick up the old land-sea mask GRIB product
C
        CALL GETENV('ISLSCP_OLD_LSM',OLDLSM)
        IBLANK = INDEX(OLDLSM, ' ')
        IF( IBLANK.LT.2 ) THEN
          IBLANK = INDEX(ISLDEFL, ' ') - 1
          OLDLSM(1:IBLANK) = ISLDEFL(1:IBLANK)
          IF( INTV(1).GT.0 ) THEN
            OLDLSM(IBLANK+1:IBLANK+2) = '_n'
            WRITE(NUMBER,'(I3.3)') INTV(1)
            OLDLSM(IBLANK+3:IBLANK+5) = NUMBER(1:3)
            IBLANK = IBLANK + 5
          ENDIF
        ENDIF
        CALL INTLOG(JP_DEBUG,
     X    'INTIN: old land-sea mask file name:',JPQUIET)
        CALL INTLOG(JP_DEBUG,'INTIN: ' // OLDLSM(1:IBLANK),JPQUIET)
C
        CALL PBOPEN(NISLSCP,OLDLSM,'r',IRET)
        IF( IRET.NE.0 ) THEN
          CALL INTLOG(JP_ERROR,
     X      'INTIN: Problem processing islscp option',JPQUIET)
          CALL INTLOG(JP_ERROR,
     X      'INTIN: PBOPEN fail for old land-sea mask file',IRET)
          CALL INTLOG(JP_ERROR,'INTIN: ' // OLDLSM(1:IBLANK),JPQUIET)
          INTIN = IRET
          GOTO 900
        ENDIF
C
        CALL PBSIZE(NISLSCP,IGSIZE)
        IF( IGSIZE.LE.0 ) THEN
          CALL INTLOG(JP_ERROR,
     X      'INTIN: Problem processing islscp option',JPQUIET)
          CALL INTLOG(JP_ERROR,
     X      'INTIN: PBSIZE fail new land-sea mask GRIB product',IGSIZE)
          INTIN = IGSIZE
          GOTO 900
        ENDIF
C
        IF( NIPOGRS.LT.IGSIZE ) THEN
          IF( NIPOGRB.NE.0 ) CALL JFREE(NIPOGRB)
          NIPOGRS = IGSIZE 
          NIPOGRB = JMALLOC(NIPOGRS)
#ifdef hpR64
          NIPOGRB = NIPOGRB/(1024*1024*1024*4)
#endif
          IF( NIPOGRB.EQ.0 ) THEN
            CALL INTLOG(JP_ERROR,
     X        'INTIN: Problem processing islscp option',JPQUIET)
            CALL INTLOG(JP_ERROR,
     X        'INTIN: JMALLOC fail old land-sea mask GRIB',JPQUIET)
            INTIN = JPROUTINE + 3
            GOTO 900
          ENDIF
        ENDIF
C
        CALL PBGRIB(NISLSCP, OLDGRIB, IGSIZE, IASIZE, IRET)
        IF( (IRET.NE.0).OR.(IGSIZE.NE.IASIZE) ) THEN
          CALL INTLOG(JP_ERROR,
     X      'INTIN: Problem processing islscp option',JPQUIET)
          CALL INTLOG(JP_ERROR,
     X      'INTIN: PBREAD fail old land-sea mask GRIB',IRET)
          INTIN = IRET
          GOTO 900
        ENDIF
C
        CALL PBCLOSE(NISLSCP, IRET)
C
C       Pick up the new land-sea mask GRIB product
C
        IBLANK = INDEX(CHARV, ' ') - 1
        CALL INTLOG(JP_DEBUG,
     X    'INTIN: new land-sea mask file name:',JPQUIET)
        CALL INTLOG(JP_DEBUG,'INTIN: ' // CHARV,JPQUIET)
C
        CALL PBOPEN(NISLSCP,CHARV,'r',IRET)
        IF( IRET.NE.0 ) THEN
          CALL INTLOG(JP_ERROR,
     X      'INTIN: Problem processing islscp option',JPQUIET)
          CALL INTLOG(JP_ERROR,
     X      'INTIN: PBOPEN fail for new land-sea mask file',IRET)
          CALL INTLOG(JP_ERROR,'INTIN: ' // CHARV,JPQUIET)
          INTIN = IRET
          GOTO 900
        ENDIF
C
        CALL PBSIZE(NISLSCP,IGSIZE)
        IF( IGSIZE.LE.0 ) THEN
          CALL INTLOG(JP_ERROR,
     X      'INTIN: Problem processing islscp option',JPQUIET)
          CALL INTLOG(JP_ERROR,
     X      'INTIN: PBSIZE fail new land-sea mask GRIB product',IGSIZE)
          INTIN = IGSIZE
          GOTO 900
        ENDIF
C
        IF( NIPNGRS.LT.IGSIZE ) THEN
          IF( NIPNGRB.NE.0 ) CALL JFREE(NIPNGRB)
          NIPNGRS = IGSIZE
          NIPNGRB = JMALLOC(NIPNGRS)
#ifdef hpR64
          NIPNGRB = NIPNGRB/(1024*1024*1024*4)
#endif
          IF( NIPNGRB.EQ.0 ) THEN
            CALL INTLOG(JP_ERROR,
     X        'INTIN: Problem processing islscp option',JPQUIET)
            CALL INTLOG(JP_ERROR,
     X        'INTIN: JMALLOC fail new land-sea mask GRIB',JPQUIET)
            INTIN = JPROUTINE + 3
            GOTO 900
          ENDIF
        ENDIF
C
        CALL PBGRIB(NISLSCP, NEWGRIB, IGSIZE, IASIZE, IRET)
        IF( (IRET.NE.0).OR.(IGSIZE.NE.IASIZE) ) THEN
          CALL INTLOG(JP_ERROR,
     X      'INTIN: Problem processing islscp option',JPQUIET)
          CALL INTLOG(JP_ERROR,
     X      'INTIN: PBREAD fail new land-sea mask GRIB',IRET)
          INTIN = IRET
          GOTO 900
        ENDIF
C
        CALL PBCLOSE(NISLSCP, IRET)
        GOTO 900
C
      ENDIF
C
C     Input or reset value used for missing points in bitmapped field.
C
      IF( CHEQUAL( HPARN, 1, 12, 'missingvalue') ) THEN
        LFOUND = .TRUE.
        CALL INTLOG(JP_DEBUG,'INTIN: missingvalue = ' // CHARV ,JPQUIET)
        IF( CHEQUAL( CHARV, 1, 2, 'no') ) THEN
          IF( LIMISSV ) LCHANGE = .TRUE.
          LIMISSV = .FALSE.
          RMISSGV   = -55555.0
        ELSE
          IF( .NOT.LIMISSV ) LCHANGE = .TRUE.
          LIMISSV = .TRUE.
          RMISSGV = REALV(1)
        ENDIF
        CALL INTLOGR(JP_DEBUG,'INTIN: missingvalue = ',RMISSGV)
        GOTO 900
      ENDIF

C     missingval because can not be applied in Emos lib everywhere... 
C
      IF( CHEQUAL( HPARN, 1, 10, 'missingval') ) THEN
        LFOUND = .TRUE.
        LIMISSV = .FALSE.
        CALL INTLOG(JP_DEBUG,'INTIN: missingval = ' // CHARV ,JPQUIET)
        IF( CHEQUAL( CHARV, 1, 2, 'no') ) THEN
          IF( LIMISSV ) LCHANGE = .TRUE.
          RMISSGV   = -55555.0
          LIMISSA = .FALSE.
        ELSE
          IF( .NOT.LIMISSV ) LCHANGE = .TRUE.
          LIMISSA = .TRUE.
          RMISSGV = REALV(1)
        ENDIF
        CALL INTLOGR(JP_DEBUG,'INTIN: missingval = ',RMISSGV)
        ISEC1(5) = 192
        GOTO 900
      ENDIF
C
C     Input uselsm.
C
      IF ( CHEQUAL( HPARN, 1, 6, 'uselsm') ) THEN
        LFOUND = .TRUE.
        CALL INTLOG(JP_DEBUG,'INTIN: uselsm = ' // CHARV ,JPQUIET)
        IF ( CHEQUAL( CHARV, 1, 2, 'no') ) THEN
          IF ( LSM ) THEN
            LCHANGE = .TRUE.
            LSMCHNG = .TRUE.
          ENDIF
          LSM = .FALSE.
        ELSE
          IF ( .NOT. LSM ) THEN
            LCHANGE = .TRUE.
            LSMCHNG = .TRUE.
          ENDIF
          LSM = .TRUE.
        ENDIF
        LSMSET = .TRUE.
        GOTO 900
      ENDIF
C
C     Input useprecip.
C
      IF ( CHEQUAL( HPARN, 1, 9, 'useprecip') ) THEN
        LFOUND = .TRUE.
        CALL INTLOG(JP_DEBUG,'INTIN: useprecip = ' // CHARV ,JPQUIET)
        IF ( CHEQUAL( CHARV, 1, 3, 'yes') ) THEN
          IF ( .NOT. LPREC ) LCHANGE = .TRUE.
          LPREC = .TRUE.
        ELSE
          IF ( LPREC ) LCHANGE = .TRUE.
          LPREC = .FALSE.
        ENDIF
        LPRECSET = .TRUE.
        GOTO 900
      ENDIF
C
C     Input usewind.
C
      IF ( CHEQUAL( HPARN, 1, 7, 'usewind') ) THEN
        LFOUND = .TRUE.
        CALL INTLOG(JP_DEBUG,'INTIN: usewind = ' // CHARV ,JPQUIET)
        IF ( CHEQUAL( CHARV, 1, 3, 'yes') ) THEN
          IF ( .NOT. LWIND ) LCHANGE = .TRUE.
          LWIND = .TRUE.
        ELSE
          IF ( LWIND ) LCHANGE = .TRUE.
          LWIND = .FALSE.
        ENDIF
        LWINDSET = .TRUE.
        GOTO 900
      ENDIF
C
C     Input parameter.
C
      IF ( CHEQUAL( HPARN, 1, 9, 'parameter') ) THEN
        LFOUND = .TRUE.
        CALL INTLOG(JP_DEBUG, 'INTIN: parameter = ',INTV(1))
        IF ( NIPARAM .NE. INTV(1) ) LCHANGE = .TRUE.
        NIPARAM = INTV(1)
        GOTO 900
      ENDIF
C
C     Input truncation.
C
      IF ( CHEQUAL( HPARN, 1, 10, 'truncation') ) THEN
        LFOUND = .TRUE.
        CALL INTLOG(JP_DEBUG, 'INTIN: truncation = ',INTV(1))
        IF ( NIREPR .NE. JPSPHERE)  THEN
          LCHANGE = .TRUE.
          NIGAUSS = 0
          NIGRID(1) = 0
          NIGRID(2) = 0
          NIAREA(1) = 0
          NIAREA(2) = 0
          NIAREA(3) = 0
          NIAREA(4) = 0
        ENDIF
        NIREPR = JPSPHERE
        IF ( NIRESO .NE. INTV(1) ) LCHANGE = .TRUE.
        NIRESO = INTV(1)
        GOTO 900
      ENDIF
C
C     Input reduced.
C
      IF ( CHEQUAL( HPARN, 1, 7, 'reduced') ) THEN
        LFOUND = .TRUE.
        CALL INTLOG(JP_DEBUG, 'INTIN: reduced = ',INTV(1))
        IF ( NIGAUSS .NE. INTV(1) ) LCHANGE = .TRUE.
        NIGAUSS = INTV(1)
        LNIGAUS = .TRUE.
        IF ( NIREPR .NE. JPQUASI ) THEN
          LCHANGE = .TRUE.
          NIRESO = 0
          NIGRID(1) = 0
          NIGRID(2) = 0
        ENDIF
        NIREPR = JPQUASI
        IF( (NIGAUSO.NE.NIGAUSS).OR.(HIGAUST.NE.'R') ) THEN
          CALL JGETGG( NIGAUSS, 'R', RIGAUSS, MILLEN, IRET)
          IF ( IRET .NE. 0 ) THEN
            CALL INTLOG(JP_ERROR,'INTIN: JGETGG fail - NIGAUSS',JPQUIET)
            INTIN = IRET
            GOTO 900
          ENDIF
          NIGAUSO = NIGAUSS
          HIGAUST = 'R'
        ENDIF
C
        NIAREA(1) = INT( RIGAUSS(1) * PPMULT )
        NIAREA(2) = 0
        NIAREA(3) = INT( RIGAUSS(NIGAUSS*2) * PPMULT )
c this gives differnt result from one in the grib header
        NIAREA(4) = JP360 - JP360/MILLEN(NIGAUSS)
C
        NIPCNT = 0
        Nins = NIGAUSS*2 ! Added by D. Jokic Mar-2005;
        DO 230 ILOOP = 1, NIGAUSS*2
          NIPCNT = NIPCNT + MILLEN(ILOOP)
 230    CONTINUE
        GOTO 900
      ENDIF
C
C     Input grid.
C
      IF ( CHEQUAL( HPARN, 1, 4, 'grid') ) THEN
        LFOUND = .TRUE.
        CALL INTLOGR(JP_DEBUG, 'INTIN: grid e-w = ',REALV(1))
        CALL INTLOGR(JP_DEBUG, 'INTIN: grid n-s = ',REALV(2))
        IF ( NIREPR .NE. JPREGULAR) THEN
          LCHANGE = .TRUE.
          NIGAUSS = 0
          NIRESO = 0
        ENDIF
        NIREPR = JPREGULAR
        DO 210 I = 1, 2
          ITEMP = INT( REALV(I)*PPMULT)
          IF ( NIGRID(I) .NE. ITEMP ) LCHANGE = .TRUE.
          NIGRID(I) = ITEMP
 210    CONTINUE
        GOTO 900
      ENDIF
C
C     Reduced lat-lon Input grid.
C
      IF ( CHEQUAL( HPARN, 1, 7, 'redu_ll') ) THEN
        LFOUND = .TRUE.
cs        CALL INTLOGR(JP_DEBUG, 'INTIN: reduced_ll e-w = ',REALV(1))
        CALL INTLOGR(JP_DEBUG, 'INTIN: reduced_ll n-s = ',REALV(2))
        IF ( NIREPR .NE. JPREGULAR) THEN
          LCHANGE = .TRUE.
          NIGAUSS = 0
          NIRESO = 0
        ENDIF
        NIREPR = JPREDLL
        NINS = INTV(1)
        DO 217 I = 1, 2
          ITEMP = INT( REALV(I)*PPMULT)
          IF ( NIGRID(I) .NE. ITEMP ) LCHANGE = .TRUE.
          NIGRID(I) = ITEMP
 217    CONTINUE
        GOTO 900
      ENDIF
C
      IF ( CHEQUAL( HPARN, 1, 5, 'ocean') ) THEN
        LFOUND = .TRUE.
        LOCEAN = .TRUE.
        CALL INTLOGR(JP_DEBUG, 'INTIN: Ocean field',JPQUIET)
        NIOCO3  = INTV(1)
        NIOCO4  = INTV(2)
        NIOCO4F = INTV(3)
        NIOCO3F = INTV(4)
        NIOCO4L = INTV(5)
        NIOCO3L = INTV(6)
        NIOIINC = INTV(7)
        NIOJINC = INTV(8)
        NIOIRGR = INTV(9)
        NIONOST = INTV(10)
        NICOORN = INTV(11)
        NIVCDEF = INTV(12)
        NILOCAL = 4
        GOTO 900
      ENDIF

      IF ( CHEQUAL( HPARN, 1, 5, 'local') ) THEN
        LFOUND = .TRUE.
        NILOCAL = INTV(1)
        CALL INTLOGR(JP_DEBUG, 'INTIN: Local settings',NILOCAL)
        GOTO 900
      ENDIF
c	  
      IF ( CHEQUAL( HPARN, 1, 6, 'matrix') ) THEN
        LFOUND = .TRUE.
        NIMATR = INTV(1)
        CALL INTLOGR(JP_DEBUG, 'INTIN: Matrix values',NIMATR)
        GOTO 900
      ENDIF
C
      IF ( CHEQUAL( HPARN, 1, 11, 'coord_ocean') ) THEN
        LFOUND = .TRUE.
        CALL INTLOGR(JP_DEBUG, 'INTIN: Ocean field grid Coordinate'
     X     ,JPQUIET)
        DO 249 ILOOP = 1, NICOORN
          OCCOOR(ILOOP) = INTV(ILOOP)
 249    CONTINUE
        GOTO 900
      ENDIF
C
      IF ( CHEQUAL( HPARN, 1, 6, 'l_npts') ) THEN
        LFOUND = .TRUE.
C
        DO 247 ILOOP = 1, NINS
          MILLEN(ILOOP) = INTV(ILOOP)
 247    CONTINUE
        GOTO 900
      ENDIF
C
C     Input data format.
C
      IF ( CHEQUAL( HPARN, 1, 4, 'form') ) THEN
        LFOUND = .TRUE.
        CALL INTLOG(JP_DEBUG, 'INTIN: form = ' // CHARV ,JPQUIET)
        IF ( CHEQUAL( CHARV, 1, 4, 'grib') ) THEN
          IF ( NIFORM .EQ. 0 ) LCHANGE = .TRUE.
          NIFORM = 1
        ELSE
          IF ( NIFORM .EQ. 1 ) LCHANGE = .TRUE.
          NIFORM = 0
        ENDIF
        GOTO 900
      ENDIF
C
C     Number of points along latitude and longitude
C
      IF ( CHEQUAL( HPARN, 1, 4, 'npts') ) THEN
        LFOUND = .TRUE.
        CALL INTLOG(JP_DEBUG, 'INTIN: pts along latitude = ',INTV(1))
        CALL INTLOG(JP_DEBUG, 'INTIN: pts along longitude = ',INTV(2))
        NIWE = INTV(1)
        NINS = INTV(2)
        GOTO 900
      ENDIF

      IF( CHEQUAL( HPARN, 1, 8, 'accuracy') ) THEN
        LFOUND = .TRUE.
        CALL INTLOG(JP_DEBUG, 'INTIN: Inpu accuracy = ',INTV(1))
        NIACC = INTV(1)
        GOTO 900
      ENDIF
C
C     Input level.
C
      IF ( CHEQUAL( HPARN, 1, 5, 'level') ) THEN
        LFOUND = .TRUE.
        CALL INTLOG(JP_DEBUG, 'INTIN: level = ',INTV(1))
        IF ( NILEVEL .NE. INTV(1) ) LCHANGE = .TRUE.
        NILEVEL = INTV(1)
        GOTO 900
      ENDIF
C
C     Input Date.
C
      IF ( CHEQUAL( HPARN, 1, 4, 'date') ) THEN
        LFOUND = .TRUE.
        CALL INTLOG(JP_DEBUG, 'INTIN: Date = ',INTV(1))
        IF ( NIDATE .NE. INTV(1) ) LCHANGE = .TRUE.
        NIDATE = INTV(1)
        GOTO 900
      ENDIF
C
C     Input level type.
C
      IF ( CHEQUAL( HPARN, 1, 7, 'levtype') ) THEN
        LFOUND = .TRUE.
        CALL INTLOG(JP_DEBUG, 'INTIN: levtype = ',INTV(1))
        IF ( NILEVT .NE. INTV(1) ) LCHANGE = .TRUE.
        NILEVT  = INTV(1)
        GOTO 900
      ENDIF
C
C     Input table.
C
      IF ( CHEQUAL( HPARN, 1, 5, 'table') ) THEN
        LFOUND = .TRUE.
        CALL INTLOG(JP_DEBUG, 'INTIN: table = ',INTV(1))
        IF ( NITABLE .NE. INTV(1) ) LCHANGE = .TRUE.
        NITABLE = INTV(1)
        GOTO 900
      ENDIF
C
C     Input regular (gaussian).
C
      IF ( CHEQUAL( HPARN, 1, 7, 'regular') ) THEN
        LFOUND = .TRUE.
        CALL INTLOG(JP_DEBUG, 'INTIN: regular = ',INTV(1))
        NIREPR = JPGAUSSIAN
        IF ( NIGAUSS .NE. INTV(1) ) LCHANGE = .TRUE.
        NIGAUSS = INTV(1)
        LNIGAUS = .TRUE.
        IF ( NIREPR .NE. JPGAUSSIAN) THEN
          LCHANGE = .TRUE.
          NIRESO = 0
          NIGRID(1) = 0
          NIGRID(2) = 0
        ENDIF
        NIREPR = JPGAUSSIAN
        IF( (NIGAUSO.NE.NIGAUSS).OR.(HIGAUST.NE.'F') ) THEN
          CALL JGETGG( NIGAUSS, 'F', RIGAUSS, MILLEN, IRET)
          IF ( IRET .NE. 0 ) THEN
            CALL INTLOG(JP_ERROR,'INTIN: JGETGG fail - NIGAUSS',JPQUIET)
            INTIN = IRET
            GOTO 900
          ENDIF
          NIGAUSO = NIGAUSS
          HIGAUST = 'F'
        ENDIF
C
        NIAREA(1) = INT( RIGAUSS(1) * PPMULT )
        NIAREA(2) = 0
        NIAREA(3) = INT( RIGAUSS(NIGAUSS*2) * PPMULT )
        NIAREA(4) = JP360 - JP360/MILLEN(NIGAUSS)
C
        NIPCNT = 0
        DO ILOOP = 1, NIGAUSS*2
          NIPCNT = NIPCNT + MILLEN(ILOOP)
        ENDDO
        GOTO 900
      ENDIF
C
C     Input area.
C
      IF ( CHEQUAL( HPARN, 1, 4, 'area') ) THEN
        LFOUND = .TRUE.
        CALL INTLOGR(JP_DEBUG, 'INTIN: north = ',REALV(1))
        CALL INTLOGR(JP_DEBUG, 'INTIN: west  = ',REALV(2))
        CALL INTLOGR(JP_DEBUG, 'INTIN: south = ',REALV(3))
        CALL INTLOGR(JP_DEBUG, 'INTIN: east  = ',REALV(4))
        DO 220 I = 1, 4
          ITEMP = INT( REALV(I)*PPMULT)
          IF ( NIAREA(I) .NE. ITEMP ) LCHANGE = .TRUE.
          NIAREA(I) = ITEMP
 220    CONTINUE
        GOTO 900
      ENDIF
C
C     Input scan.
C
      IF ( CHEQUAL( HPARN, 1, 4, 'scan') ) THEN
        LFOUND = .TRUE.
        CALL INTLOG(JP_DEBUG, 'INTIN: scan = ',INTV(1))
        IF ( NISCNM .NE. INTV(1) ) LCHANGE = .TRUE.
        NISCNM = INTV(1)
        GOTO 900
      ENDIF
C
C     Input lsm_param.
C
      IF ( CHEQUAL( HPARN, 1, 9, 'lsm_param') ) THEN
        LFOUND = .TRUE.
        CALL INTLOG(JP_DEBUG,'INTIN: lsm_param = ' // CHARV ,JPQUIET)
        IF ( CHEQUAL( CHARV, 1, 3, 'yes') ) THEN
          IF ( .NOT. LSMPAR ) LCHANGE = .TRUE.
          LSMPAR = .TRUE.
        ELSE
          IF ( LSMPAR ) LCHANGE = .TRUE.
          LSMPAR = .FALSE.
        ENDIF
        LSMPARSET = .TRUE.
        GOTO 900
      ENDIF
C
C     Set of LSM - merging with grib_api
      IF ( CHEQUAL( HPARN, 1, 6, 'lsmset') ) THEN
        LFOUND = .TRUE.
        CALL INTLOG(JP_DEBUG,'INTIN: lsmset = ' // CHARV ,JPQUIET)
        IF ( CHEQUAL( CHARV, 1, 2, 'no') ) THEN
          IF ( LSM ) THEN
            LCHANGE = .TRUE.
            LSMCHNG = .TRUE.
          ENDIF
          LSM = .FALSE.
          LSMSET = .TRUE.
        ELSE
          IF ( .NOT. LSM ) THEN
            LCHANGE = .TRUE.
            LSMCHNG = .TRUE.
          ENDIF
          LSM = .TRUE.
          LSMSET = .FALSE.
        ENDIF
        GOTO 900
      ENDIF
C
C
C     Input user_regular_gaussian
C
C     (Ignore the call if the user_regular_gaussian value = 0.)
      IF ( CHEQUAL( HPARN, 1, 21, 'user_regular_gaussian') ) THEN
        LFOUND = .TRUE.
        IF ( NIREPR .NE. JPGAUSSIAN) THEN
          LCHANGE = .TRUE.
          NIRESO = 0
          NIGRID(1) = 0
          NIGRID(2) = 0
        ENDIF
        CALL INTLOG(JP_DEBUG,'INTIN: user_regular_gaussian = ',INTV(1))
        IF ( NIGAUSS .NE. INTV(1) ) LCHANGE = .TRUE.
        NIGAUSS = INTV(1)
        NIREPR  = JPGAUSSIAN
C
        ILAST = NIGAUSS*2
        DO 235 ILOOP = 1, ILAST
          MILLEN(ILOOP) = NOGAUSS*4
 235    CONTINUE
        NIGAUSO = NIGAUSS
        HIGAUST = 'U'
        LIGIVEP   = .TRUE.
C
        GOTO 900
      ENDIF
C
C     Input user_reduced_gaussian
C     (Ignore the call if the user_reduced_gaussian value = 0.)
C
      IF ( CHEQUAL( HPARN, 1, 21, 'user_reduced_gaussian') ) THEN
        LFOUND = .TRUE.
        IF ( NIREPR .NE. JPQUASI ) THEN
          LCHANGE = .TRUE.
          NIRESO = 0
          NIGRID(1) = 0
          NIGRID(2) = 0
        ENDIF
        IF ( INTV(1) .EQ. 0 ) GOTO 900
        CALL INTLOG(JP_DEBUG,'INTIN: user_reduced_gaussian = ',INTV(1))
        IF ( NIGAUSS .NE. INTV(1) ) LCHANGE = .TRUE.
        NIGAUSS = INTV(1)
        NIREPR  = JPQUASI
        NIGAUSO = NIGAUSS
        HIGAUST = 'U'
        GOTO 900
      ENDIF
C
C     Input g_pnts loading from grib_api.
C
      IF ( CHEQUAL( HPARN, 1, 7, 'ga_pnts') ) THEN
        LFOUND = .TRUE.
        IF ( NIGAUSS .LE. 0 ) THEN
          IRET = JPROUTINE + 1
          CALL INTLOG(JP_ERROR,
     X      'INTIN: Impossible number of gaussian latitudes.',NIGAUSS)
          INTIN = IRET
          GOTO 900
        ENDIF
          CALL INTLOG(JP_DEBUG,
     X      'INTIN: Reduced Gaussian - grib_api ',NIGAUSS)
C
cs        ILAST = NIGAUSS*2 + 1
        ILAST = NIGAUSS*2
        DO 241 ILOOP = 1, ILAST
          MILLEN(ILOOP) = INTV(ILOOP)
 241    CONTINUE
C
        NIAREA(4) = JP360 - INT( JP360/MILLEN(NIGAUSS) )
C
        NIPCNT = 0
        DO 251 ILOOP = 1, ILAST
          NIPCNT = NIPCNT + MILLEN(ILOOP)
 251    CONTINUE
        NIGAUSO = NIGAUSS
        HIGAUST = 'U'
        LIGIVEP = .TRUE.
        GOTO 900
      ENDIF
cs end ga

      IF ( CHEQUAL( HPARN, 1, 6, 'g_pnts') ) THEN
        LFOUND = .TRUE.
        IF ( NIGAUSS .LE. 0 ) THEN
          IRET = JPROUTINE + 1
          CALL INTLOG(JP_ERROR,
     X      'INTIN: Impossible number of gaussian latitudes.',NIGAUSS)
          INTIN = IRET
          GOTO 900
        ENDIF
C
        ILAST = NIGAUSS*2 + 1
        DO 240 ILOOP = 1, NIGAUSS
          MILLEN(ILOOP) = INTV(ILOOP)
          ILAST = ILAST - 1
          MILLEN(ILAST) = INTV(ILOOP)
 240    CONTINUE
C
        NIAREA(4) = JP360 - INT( JP360/MILLEN(NIGAUSS) )
C
        NIPCNT = 0
        DO 250 ILOOP = 1, NIGAUSS*2
          NIPCNT = NIPCNT + MILLEN(ILOOP)
 250    CONTINUE
        NIGAUSO = NIGAUSS
        HIGAUST = 'U'
        LIGIVEP = .TRUE.
        GOTO 900
      ENDIF
C
C     Input g_lats.
C
      IF ( CHEQUAL( HPARN, 1, 6, 'g_lats') ) THEN
        LFOUND = .TRUE.
        IF ( NIGAUSS .LE. 0 ) THEN
          IRET  = JPROUTINE + 1
          CALL INTLOG(JP_ERROR,
     X      'INTIN: Impossible number of gaussian latitudes.',NIGAUSS)
          INTIN = IRET
          GOTO 900
        ENDIF
C
        ILAST = NIGAUSS*2 + 1
        DO 260 ILOOP = 1, NIGAUSS
          RIGAUSS(ILOOP) = REALV(ILOOP)
          ILAST = ILAST - 1
          RIGAUSS(ILAST) = -REALV(ILOOP)
 260    CONTINUE
C
        NIAREA(1) = INT( RIGAUSS(1) * PPMULT )
        NIAREA(2) = 0
        NIAREA(3) = INT( RIGAUSS(NIGAUSS*2) * PPMULT )
        NIAREA(4) = JP360 - JP360/MILLEN(NIGAUSS)
        NIGAUSO = NIGAUSS
        HIGAUST = 'U'
        LIGIVEL   = .TRUE.
        GOTO 900
      ENDIF
C
C     ------------------------------------------------------------------
C*     Section 9.   Closedown.
C     ------------------------------------------------------------------
C
  900 CONTINUE
      IF( .NOT. LFOUND ) THEN
        CALL INTLOG(JP_ERROR, 'INTIN: Unknown keyword used:', JPQUIET)
        CALL INTLOG(JP_ERROR, HPARN, JPQUIET)
        INTIN = JPROUTINE + 2
      ENDIF
      RETURN
      END

C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      INTEGER FUNCTION LOCAL2(KTABLE, KPARAM, KCENTR,
     X                        HFIRST, HSECOND, HTHIRD, HFOURTH)
C
C---->
C**** LOCAL2
C
C     Purpose
C     -------
C
C     Looks up the description of a parameter in known table 2 versions
C     for WMO code FM 92-X Ext. GRIB.
C
C
C     Interface
C     ---------
C
C     IRET = LOCAL2(KTABLE, KPARAM, KCENTR,
C                   HFIRST, HSECOND, HTHIRD, HFOURTH)
C
C     Input
C     -----
C
C     KTABLE - Local table 2 version number.
C     KPARAM - Parameter number.
C     KCENTR - Centre number.
C
C
C     Output
C     ------
C
C     HFIRST  - First line of descriptor:  MARS mnemonic
C     HSECOND - Second line of descriptor: Parameter description
C     HTHIRD  - Third line of descriptor:  Units for the parameter
C     HFOURTH - Fourth line of descriptor: Description of units
C
C     Function return value is
C            0 if no error detected.
C        20001 if no match found for the parameter number in
C              the given table.
C        20002 if there is an error opening the file holding
C              the given table.
C        20003 if there is an error finding an unused fortran unit
C              number for reading the table.
C
C
C     Method
C     ------
C
C     Checks if environment variable ECMWF_LOCAL_TABLE_PATH exists to
C     define the location of the parameter tables.
C
C     Otherwise, looks for table xxx in:
C       /home/ecmwf/emos_sms/tables/gribex/nnnnnn/local_table_2_version_xxx.
C     where nnnnnn is the current EMOSLIB version.
C
C     Entry for each parameter in table has the format (without quotes):
C        "......................"         Separator
C        "051"                            Paramter number
C        "MX2T24"                         MARS mnemonic
C        "Max 2m temp"                    Parameter description
C        "K"                              Units for the parameter
C        "During previous 24 hours"       Further description
C
C     There is a termination "......................" line in the file
C     and there may be lines of comment before the first parameter entry.
C
C     The parameter definition file is kept open between calls.
C
C
C     Externals
C     ---------
C     TAB2FIL - Builds code table 2 file name.
C
C
C     Author
C     ------
C
C     J.D.Chambers     ECMWF     Sept 1995
C
C
C     MODIFICATIONS
C     _____________
C
C     J. Clochard, Meteo France, for ECMWF - June 1999.
C     Argument KCENTR added for code tables management.
C     Use TAB2FIL function for file name building.
C
C     _______________________________________________________
C----<
C
C
      IMPLICIT NONE
C
C     Parameters
C
      INTEGER JPROUTINE
      PARAMETER ( JPROUTINE = 20000 )
C
C     Function arguments
C
      INTEGER KPARAM, KTABLE, KCENTR
      CHARACTER*(*) HFIRST, HSECOND, HTHIRD, HFOURTH
C
C     Local variables
C
      INTEGER IPR, IRET, ISTATUS, IPARAM, ITABLE
      CHARACTER*256 YFILE, YDUMMY
C
      INTEGER NOLDTAB, NUNIT
      SAVE NOLDTAB, NUNIT
C
C     External functions
C
      INTEGER TAB2FIL
      EXTERNAL TAB2FIL
C
      DATA NOLDTAB/-1/
C
C
C ------------------------------------------------------------------
C*    Section 1.   Initialise
C ------------------------------------------------------------------
C
  100 CONTINUE
C
      LOCAL2 = 0
C
C     Put phoney fields in return parameters
C
      HFIRST  = 'NONE'
      HSECOND = 'Undefined parameter'
      HTHIRD  = 'Undefined parameter'
      HFOURTH = 'Undefined parameter'
C
C     See if a new table is requested.
C
      IF( MAX( KTABLE, KPARAM) .LE. 127 ) THEN
        ITABLE = KTABLE
      ELSE
        ITABLE = 1000*KCENTR + KTABLE
      ENDIF
C
      IF( ITABLE.NE.NOLDTAB ) THEN
        IF( NOLDTAB.NE.-1 ) CLOSE(UNIT=NUNIT)
        NOLDTAB = ITABLE
C
C      Find an unused fortran unit number
C
        IPR = 0
        CALL FTN1CR(NUNIT, IPR, IRET)
        IF( IRET.NE.0 ) THEN
          LOCAL2 = JPROUTINE + 3
          RETURN
        ENDIF
C
C       Build filename
C
        IRET = TAB2FIL( KTABLE, KPARAM, KCENTR, YFILE )
C
C       Open file
C
        OPEN(UNIT=NUNIT, FILE=YFILE, ERR=910, IOSTAT=ISTATUS,
     X       STATUS='OLD',FORM='FORMATTED')
C
C     Otherwise, use the existing open parameter table file.
C
      ELSE
        REWIND NUNIT
      ENDIF
C
C ------------------------------------------------------------------
C*    Section 2.   Search for the parameter in the table.
C ------------------------------------------------------------------
C
  200 CONTINUE
C
C     Skip lines until '......................' separator found
C
  210 CONTINUE
      READ(NUNIT,'(A)',END=230) YDUMMY
      IF( YDUMMY(1:22).EQ.'......................') GOTO 225
      GOTO 210
C
C     Loop through file
C
  220 CONTINUE
        READ(NUNIT,'(A)',END=230) YDUMMY
  225 CONTINUE
        READ(NUNIT,'(I3.3)',END=230) IPARAM
        IF ( IPARAM .EQ. KPARAM ) THEN
          READ(NUNIT,'(A)',END=230) HFIRST
          READ(NUNIT,'(A)',END=230) HSECOND
          READ(NUNIT,'(A)',END=230) HTHIRD
          READ(NUNIT,'(A)',END=230) HFOURTH
          LOCAL2 = 0
          GOTO 900
        ELSE
          READ(NUNIT,'(A)',END=230) YDUMMY
          READ(NUNIT,'(A)',END=230) YDUMMY
          READ(NUNIT,'(A)',END=230) YDUMMY
          READ(NUNIT,'(A)',END=230) YDUMMY
        ENDIF
      GOTO 220
C
C     Dropthrough if no match found
C
 230  CONTINUE
      LOCAL2 = JPROUTINE + 1
      GOTO 900
C
C ------------------------------------------------------------------
C*    Section 9.   Closedown.
C ------------------------------------------------------------------
C
C     Error opening table file
C
 910  CONTINUE
      LOCAL2 = JPROUTINE + 2
      RETURN
C
C     Normal return.
C
 900  CONTINUE
C
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities
C granted to it by virtue of its status as an intergovernmental organisation
C nor does it submit to any jurisdiction.
C


      SUBROUTINE LNBFCR (KARRAY,KLENB)
C
C---->
C**** LNBFCR - Calculate length of BUFR message on Cray.
C
C     Purpose.
C     --------
C
C           Calculate length of BUFR message.
C
C**   Interface.
C     ----------
C
C           CALL LNBFCR (KARRAY,KLENB)
C
C           Integer    K.
C           Real       P.
C           Logical    O.
C           Character  H.
C
C               Input parameters.
C               -----------------
C
C               KARRAY     - Array containing BUFR message.
C
C               KLENB      - 0, abort if error.
C                            1, return to calling routine even if error,
C                               unless array limits exceeded.
C
C               Output parameters.
C               ------------------
C
C               KLENB      - Length of BUFR message in bytes.
C                            -1, error in calculating length.
C
C     Method.
C     -------
C
C           The length of each BUFR message is calculated
C           from the BUFR header Sections.
C
C     Externals.
C     ----------
C
C           UNPACK
C
C     Reference.
C     ----------
C
C           WMO BUFR Code Documentation.
C
C     Comments.
C     ---------
C
C           Routine contains Sections 0 to 1 and Section 9.
C
C     Author.
C     -------
C
C           J. Hennessy      ECMWF      20:06:90.
C
C     Modifications.
C     --------------
C
C           J. Hennessy      ECMWF      18:12:90.
C           Soft fail option added.
C
C           J. Hennessy      ECMWF      04:02:92.
C           Modified to cater for Edition 2 of BUFR code.
C
C     ----------------------------------------------------------------
C----<
C
C
C
C
C
C
C
C
C
C
C*    Section 0 . Definition of variables.
C     ----------------------------------------------------------------
C
      IMPLICIT LOGICAL     ( L, O, G )
      IMPLICIT CHARACTER*8 ( C, H, Y )
      IMPLICIT INTEGER     ( I, J, K, M, N )
C
      PARAMETER (JPBYT=2056)
C
      DIMENSION KARRAY(*)
      DIMENSION ISCATR(JPBYT)
C
C     ----------------------------------------------------------------
C
C
C
C
C
C
C
C
C
C*    Section 1 . Calculate BUFR length.
C     ----------------------------------------------------------------
C
 1000 CONTINUE
C
      IABORT = KLENB
C
C     Unpack first JPBYT bytes of data.
C
      CALL UNPACK (KARRAY,8,ISCATR,JPBYT)
C
C     BUFR Edition 2 or greater has full message length in
C     bytes 5-7. ( Edition number is in byte 8)
C
      IF (ISCATR(8).GE.2)
     C   THEN
             KLENB = SHIFTL(ISCATR(5),16) + SHIFTL(ISCATR(6),8)
     C                 + ISCATR(7)
             GO TO 9000
         ENDIF
C
C     Length not in message, so calculate.
C     Count of octets in Section 0.
C
      KLENB = 4
C
C     Count of octets in Section 1.
C
      KLENB = KLENB + SHIFTL(ISCATR(5),16) + SHIFTL(ISCATR(6),8)
     C                 + ISCATR(7)
C
C     Check if optional Section 2 is present.
C
      IFLAG = ISCATR(12)
C
C     Check flag value.
C
      IF (IFLAG.NE.0.AND.IFLAG.NE.128)
     C   THEN
             WRITE (*,9002) IFLAG
             IF (IABORT.EQ.0) CALL ABORT
             KLENB = -1
             GO TO 9000
         ENDIF
C
      IF (IFLAG.EQ.128)
     C        KLENB = KLENB + SHIFTL(ISCATR(KLENB+1),16) +
     C                SHIFTL(ISCATR(KLENB+2),8) + ISCATR(KLENB+3)
C
C     Check on array length.
C
      IF (KLENB.GT.JPBYT)
     C   THEN
             WRITE (*,9001)
             IF (IABORT.EQ.0) CALL ABORT
             KLENB = -1
             GO TO 9000
         ENDIF
C
C     Length of Section 3.
C
      KLENB = KLENB + SHIFTL(ISCATR(KLENB+1),16) +
     C                SHIFTL(ISCATR(KLENB+2),8) + ISCATR(KLENB+3)
C
C     Check on array length.
C
      IF ((KLENB+3).GT.JPBYT)
     C   THEN
             WRITE (*,9001)
             IF (IABORT.EQ.0) CALL ABORT
             KLENB = -1
             GO TO 9000
         ENDIF
C
C     Length of binary data Section 4.
C
      KLENB = KLENB + SHIFTL(ISCATR(KLENB+1),16) +
     C                SHIFTL(ISCATR(KLENB+2),8) + ISCATR(KLENB+3)
C
C     Length of Section 5.
C
      KLENB = KLENB + 4
C
C    ----------------------------------------------------------------
C
C
C
C
C
C
C
C
C
C*    Section 9 . Return to calling routine.
C     ------------------------------------------------------------------
C
 9000 CONTINUE
C
 9001 FORMAT (1H ,'LNBFCR : Array ISCATR limits exceeded.')
C
 9002 FORMAT (1H ,'LNBFCR : Error in section 2 flag - ',I4)
C
      RETURN
C
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      INTEGER FUNCTION HNEILL
     X  (L12PNT,KLEN,RLAT,RLON,OLDGRID,
     X   KSCHEME,PDLAT,PDLO0,PDLO1,PDLO2,PDLO3,KLA,NEIGH)
C
C---->
C**** HNEILL
C
C     Purpose
C     -------
C
C     This routine accepts a vector of points and finds the 12
C     neighbours for each point suitable for horizontal interpolation.
C
C
C     Interface
C     ---------
C
C     IRET = HNEILL(L12PNT,KLEN,RLAT,RLON,OLDGRID,
C    X              KSCHEME,PDLAT,PDLO0,PDLO1,PDLO2,PDLO3,KLA,NEIGH)
C
C
C     Input parameters
C     ----------------
C
C     L12PNT  - Chooses between 12-point and 4-point interpolation
C               = .TRUE. for 12-point horizontal
C               = .FALSE. for 4-point
C     KLEN    - Number of points along the vector
C     RLAT    - List of latitudes for points.
C     RLON    - List of longitudes for points.
C     OLDGRID - Grid increments (i/j) for the global lat/long field
C
C
C     Output parameters
C     -----------------
C
C     KSCHEME - Flag showing interpolation scheme to use for point
C               0 = 12-point
C               1 = 4-point bilinear
C               2 = nearest neighbour
C     PDLAT   - Meridian linear weight.
C     PDLO0   - Zonal linear weight for the latitude of point 5.
C     PDLO1   - Zonal linear weight for the latitude of point 1.
C     PDLO2   - Zonal linear weight for the latitude of point 3.
C     PDLO3   - Zonal linear weight for the latitude of point 11.
C     KLA     - Latitude number in original field of latitude north of
C               each point in the vector.
C     NEIGH   - List of indices in the original field of neighbouring
C               point values for each point in the vector.
C
C     Returns 0 if function successful, non-zero otherwise.
C
C     Common block usage
C     ------------------
C
C     None.
C
C
C     Method
C     ------
C
C     Numbering of the points (I is the interpolation point):
C
C                   13       5       6      14
C
C                    7       1       2       8
C                               (I)
C                    9       3       4      10
C
C                   15      11      12      16
C
C     The 12-point interpolation is not possible if either of the top
C     two rows is above the original field northern latitude. The
C     nearest neighbour is used if both rows are above, and a 4-pt
C     bilinear interpolation is used if the top row is above.
C     Similarily, if either of the bottom two rows is below the original
C     field southern latitude.
C
C
C     Externals
C     ---------
C
C     INTLOG  - Log error message.
C     JDEBUG  - Tests if debug output required.
C     JFREE   - Free dynamically allocated memory
C
C
C     Reference
C     ---------
C
C     ECMWF Meteorological Bulletin M1.6/7
C     IFS Documentation
C     Part VI: Technical and Computational Procedures (CY21R4)
C     March 2000
C     Section 2.3
C
C
C     Comments
C     --------
C
C     None.
C
C
C     Author
C     ------
C
C     J.D.Chambers      ECMWF      January 2001
C
C
C     Modifications
C     -------------
C
C     None.
C
C----<
C     -----------------------------------------------------------------|
C*    Section 0. Definition of variables.
C     -----------------------------------------------------------------|
C
      IMPLICIT NONE
#include "parim.h"
C
C     Parameters
C
      INTEGER JP12PT, JP4PT, JPNEARN
      PARAMETER (JP12PT  = 0)
      PARAMETER (JP4PT   = 1)
      PARAMETER (JPNEARN = 2)
C
C     Function arguments
C
      LOGICAL L12PNT
      INTEGER KLEN
      REAL OLDGRID(2), RLAT(KLEN), RLON(KLEN)
C
      INTEGER KLA(KLEN), KSCHEME(KLEN)
      REAL PDLAT(KLEN),PDLO0(KLEN),PDLO1(KLEN),PDLO2(KLEN),PDLO3(KLEN)
      INTEGER NEIGH(12,*)
C
C     Local variables
C
      INTEGER NEXT, LOOP, NOLDLAT, NOLDLON
      INTEGER NLAT0, NLAT1, NLAT2, NLAT3, NLAT(12), NLONG(12)
      INTEGER NLONG1, NLONG2, NLONG5
      REAL PLATINC, PLONINC
C
C     Statement functions
C
      INTEGER ILAT, NUMLAT, NUMLON
      REAL LAT, LON, PLATIN, LATSTEP, LONSTEP
C
      PLATIN(ILAT,LATSTEP) = 90.0 - REAL(ILAT-1)*LATSTEP
      NUMLAT(LAT,LATSTEP)  = 1 + NINT((90.0 - LAT)/LATSTEP)
      NUMLON(LON,LONSTEP)  = 1 + NINT(LON/LONSTEP )
C
C     -----------------------------------------------------------------|
C     Section 1.  Initialise.
C     -----------------------------------------------------------------|
C
  100 CONTINUE
C
      HNEILL = 0
C
      CALL JDEBUG()
C
      PLATINC = OLDGRID(1)
      PLONINC = OLDGRID(2)
      NOLDLAT = 1 + NINT(180.0/PLATINC)
      NOLDLON = NINT(360.0/PLONINC)
C
C     -----------------------------------------------------------------|
C       Section 2.  Loop through points along the vector.
C     -----------------------------------------------------------------|
C
  200 CONTINUE
C
      DO NEXT = 1,KLEN
C
C       Clear current neighbour indices
C
        DO LOOP = 1, 12
          NEIGH(LOOP,NEXT) = 0
        ENDDO
C
C     -----------------------------------------------------------------|
C       Section 3. Find latitude numbers for neighbours.
C     -----------------------------------------------------------------|
C
  300   CONTINUE
C
C       First find latitude numbers to north and south of the point
C
        NLAT1 = NUMLAT(RLAT(NEXT),PLATINC)
        NLAT2 = NLAT1 + 1
C
C       Find outer latitude numbers further north and south of the point
C
        NLAT0 = NLAT1 - 1
        NLAT3 = NLAT2 + 1
C
C     -----------------------------------------------------------------|
C       Section 4. Nearest neighbour to be used.
C     -----------------------------------------------------------------|
C
  400   CONTINUE
C
        IF( (NLAT1.LT.1).OR.(NLAT2.GT.NOLDLAT) ) THEN
C
C         On northern/southern latitude of original field, so use
C         nearest neighbours (point 1 or 2)
C
          IF( NLAT1.LT.1 ) NLAT1 = 1
C
          IF( NLAT2.GT.NOLDLAT ) NLAT1 = NOLDLAT
C
          NLONG(1) = NUMLON(RLON(NEXT),PLONINC)
          NLONG1   = NLONG(1)
          IF( NLONG(1).GT.NOLDLON ) NLONG(1) = 1
          NLONG(2) = NLONG(1) + 1
          NLONG2   = NLONG(2)
          IF( NLONG(2).GT.NOLDLON ) NLONG(2) = 1
C
          IF( ABS((RLON(NEXT) - REAL(NLONG1-1)*PLONINC )) .LE.
     X        ABS((RLON(NEXT) - REAL(NLONG2-1)*PLONINC )) ) THEN
            NEIGH(1,NEXT) = (NLAT1-1)*NOLDLON + NLONG(1)
          ELSE
            NEIGH(1,NEXT) = (NLAT1-1)*NOLDLON + NLONG(2)
          ENDIF
          KSCHEME(NEXT) = JPNEARN
          GOTO 700
        ENDIF
C
C     -----------------------------------------------------------------|
C       Section 5. 4-point bilinear to be used.
C     -----------------------------------------------------------------|
C
  500   CONTINUE
C
        IF( (NLAT0.LT.1).OR.(NLAT3.GT.NOLDLAT).OR.
     X      (.NOT.L12PNT) ) THEN
C
          CALL INTLOG(JP_DEBUG,
     X      'HNEILL: 4-pt bilinear interpolation used for point ',NEXT)
C
C         Between two northern latitudes or two southern latitudes of
C         original field, so use 4-point bilinear interpolation
C         (points 1, 2, 3 and 4)
C
C         Points 1 and 2
C
          NLONG(1) = NUMLON(RLON(NEXT),PLONINC)
          NLONG1   = NLONG(1)
          IF( NLONG(1).GT.NOLDLON ) NLONG(1) = 1
C
          NEIGH(1,NEXT) = (NLAT1-1)*NOLDLON + NLONG(1) + 1
          NEIGH(2,NEXT) = NEIGH(1,NEXT) + 1
C
C         Points 3 and 4
C
          NLONG( 3) = NLONG(1)
C
          NEIGH(3,NEXT) = (NLAT2-1)*NOLDLON + NLONG(3) + 1
          NEIGH(4,NEXT) = NEIGH(3,NEXT) + 1
C
C         Calculate zonal linear weights for the latitudes.
C
          PDLO1(NEXT) = (RLON(NEXT)-REAL(NLONG1-1)*PLONINC) / PLONINC
          PDLO2(NEXT) = PDLO1(NEXT)
C
          KLA(NEXT) = NLAT1
          PDLAT(NEXT) = (PLATIN(NLAT1,PLATINC)-RLAT(NEXT)) / PLATINC
C
          KSCHEME(NEXT) = JP4PT
          GOTO 700
        ENDIF
C
C     -----------------------------------------------------------------|
C       Section 6. 12-point interpolation to be used.
C     -----------------------------------------------------------------|
C
  600   CONTINUE
C
        KSCHEME(NEXT) = JP12PT
C
        KLA(NEXT) = NLAT1
        PDLAT(NEXT) = (PLATIN(NLAT1,PLATINC)-RLAT(NEXT)) / PLATINC
C
C       Northernmost
C
        NLAT(5) = NLAT0
        NLAT(6) = NLAT0
C
C       Northern
C
        NLAT(7) = NLAT1
        NLAT(1) = NLAT1
        NLAT(2) = NLAT1
        NLAT(8) = NLAT1
C
C       Southern
C
        NLAT( 9) = NLAT2
        NLAT( 3) = NLAT2
        NLAT( 4) = NLAT2
        NLAT(10) = NLAT2
C
C       Southernmost
C
        NLAT(11) = NLAT3
        NLAT(12) = NLAT3
C
C       Find longitude numbers for neighbours.
C
C       Northernmost
C
        NLONG(5) = NUMLON(RLON(NEXT),PLONINC)
        NLONG5 = NLONG(5)
        IF( NLONG(5).GT.NOLDLON ) NLONG(5) = 1
        NLONG(6) = NLONG(5) + 1
        IF( NLONG(6).GT.NOLDLON ) NLONG(6) = 1
C
C       Northern
C
        NLONG(1) = NLONG(5)
        NLONG(7) = NLONG(1) - 1
        IF( NLONG(7).LT.1 ) NLONG(7) = NOLDLON
        NLONG(2) = NLONG(1) + 1
        IF( NLONG(2).GT.NOLDLON ) NLONG(2) = 1
        NLONG(8) = NLONG(2) + 1
        IF( NLONG(8).GT.NOLDLON ) NLONG(8) = 1
C
C       Southern
C
        NLONG( 3) = NLONG(1)
        NLONG( 9) = NLONG(7)
        NLONG( 4) = NLONG(2)
        NLONG(10) = NLONG(8)
C
C       Southernmost
C
        NLONG(11) = NLONG(5)
        NLONG(12) = NLONG(11) + 1
        IF( NLONG(12).GT.NOLDLON ) NLONG(12) = 1
C
C       Calculate zonal linear weights for the latitudes.
C
        PDLO0(NEXT) = (RLON(NEXT)-REAL(NLONG5-1)*PLONINC) / PLONINC
        PDLO1(NEXT) = PDLO0(NEXT)
        PDLO2(NEXT) = PDLO0(NEXT)
        PDLO3(NEXT) = PDLO0(NEXT)
C
C       Store indices of the neighbours.
C
        DO LOOP = 1, 12
          NEIGH(LOOP,NEXT) = NOLDLON*(NLAT(LOOP)-1) + NLONG(LOOP)
        ENDDO
C
  700  CONTINUE
C
      ENDDO
C
C     End of loop along vector of points.
C
C     -----------------------------------------------------------------|
C     Section 9.  Return
C     -----------------------------------------------------------------|
C
  900 CONTINUE
C
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE MAXMNI(KARRAY,KLEN,KMAX,KMIN)
C
C---->
C**** MAXMNI - Get maximum and minimum values.
C
C     Purpose.
C     --------
C
C     Get maximum and minimum values from an array of integer numbers.
C
C**   Interface.
C     ----------
C
C     CALL MAXMNI (KARRAY,KLEN,KMAX,KMIN)
C
C     Input Parameters.
C     -----------------
C
C     KARRAY - Array of numbers.
C     KLEN   - Last word of this array.
C
C     Output Parameters.
C     ------------------
C
C     KMAX   - Maximum value.
C     KMIN   - Minimum value.
C
C     Method.
C     -------
C
C     Intrinsic functions MAX and MIN are used.
C
C     Externals.
C     ----------
C
C     None.
C
C     Reference.
C     ----------
C
C     None.
C
C     Comments.
C     ---------
C
C     Routine contains Sections 0 to 1 and Section 9.
C
C     Author.
C     -------
C
C     J. Clochard, Meteo France, for ECMWF - January 1998.
C
C     Modifications.
C     --------------
C
C     None.
C
C----<
C     ----------------------------------------------------------------
C*    Section 0 . Definition of variables. Data statements.
C     ----------------------------------------------------------------
C
      IMPLICIT NONE
C
C     Subroutine arguments
C
      INTEGER KARRAY, KLEN, KMAX, KMIN
      DIMENSION KARRAY(*)
C
C     Local variables
C
      INTEGER JLOOP
C
C     ----------------------------------------------------------------
C*    Section 1 . Get maximum and minimum values.
C     ----------------------------------------------------------------
C
  100 CONTINUE
C
C     Set initial values.
C
      KMAX = KARRAY(1)
      KMIN = KARRAY(1)
C
C     Extract maximum and minimum values.
C
      DO 110 JLOOP = 2 , KLEN
        KMAX = MAX(KMAX,KARRAY(JLOOP))
        KMIN = MIN(KMIN,KARRAY(JLOOP))
  110 CONTINUE
C
C     ----------------------------------------------------------------
C*    Section 9. Return to calling routine.
C     ----------------------------------------------------------------
C
  900 CONTINUE
C
      RETURN
C
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C


      SUBROUTINE CONFP2 (PVAL,KEXP,KMANT,KBITS)
C
C---->
C**** CONFP2 - Convert floating point number to GRIb representation.
C
C     Purpose.
C     --------
C
C           Convert floating point number from machine
C           representation to GRIB representation.
C
C**   Interface.
C     ----------
C
C           CALL CONFP2 (PVAL,KEXP,KMANT,KBITS)
C
C           INTEGER    K.
C           REAL       P.
C           LOGICAL    O.
C           CHARACTER  H.
C
C               Input Parameters.
C               -----------------
C
C               PVAL    - Floating point number to be converted.
C
C               KBITS   - Number of bits in computer word.
C
C               Output Parameters.
C               -----------------
C
C               KEXP    - 8 Bit signed exponent.
C
C               KMANT   - 24 Bit mantissa.
C
C     Method.
C     -------
C
C           Floating point number represented as 8 bit exponent
C           and 24 bit mantissa in integer values.
C
C     Externals.
C     ----------
C
C           None.
C
C     Reference.
C     ----------
C
C           WMO Manual on Codes re GRIB representation.
C
C     Comments.
C     ---------
C
C           Rewritten from CONFP, to include number of bits per
C           computer word, to unite slightly different versions of
C           CONFP.
C
C           Routine contains sections 0 to 2 and section 9.
C
C     Author.
C     -------
C
C           John Hennessy   ECMWF   19.03.91
C
C     Modifications.
C     --------------
C
C           None.
C
C     -----------------------------------------------------------------
C----<
C
C
C
C
C
C
C
C
C
C
C*    Section 0 . Definition of variables.
C     -----------------------------------------------------------------
C
      IMPLICIT LOGICAL     ( L , O , G )
      IMPLICIT CHARACTER*8 ( C , H , Y )
      IMPLICIT INTEGER     ( I , J , K , M , N )
C
C     -----------------------------------------------------------------
C
C
C
C
C
C
C
C
C
C
C*    Section 1 . Convert value of 0.0.
C     -----------------------------------------------------------------
C
  100 CONTINUE
C
      IF (PVAL.EQ.0.0)
     C   THEN
             KEXP  = 0
             KMANT = 0
             GO TO 900
         ENDIF
C
C     -----------------------------------------------------------------
C
C
C
C
C
C
C
C
C
C
C*    Section 2 . Convert other values.
C     -----------------------------------------------------------------
C
  200 CONTINUE
C
      ZEPS = 1.0E-12
      IF (KBITS.EQ.32) ZEPS = 1.0E-8
      ZREF = PVAL
C
C     Sign of value.
C
      ISIGN = 0
      IF (ZREF.LT.0.)
     C   THEN
             ISIGN = 128
             ZREF  = - ZREF
         ENDIF
C
C     Exponent.
C
      KEXP = INT(ALOG(ZREF)*(1.0/ALOG(16.0))+64.0+1.0+ZEPS)
C
      IF (KEXP.LT.0  ) KEXP = 0
      IF (KEXP.GT.127) KEXP = 127
C
C     Mantissa.
C
      KMANT = INT (ZREF/16.0**(KEXP-70))
C
C     Add sign bit to exponent.
C
      KEXP = KEXP + ISIGN
C
C     -----------------------------------------------------------------
C
C
C
C
C
C
C
C
C
C
C*    Section 9. Return to calling routine.
C     -----------------------------------------------------------------
C
  900 CONTINUE
C
      RETURN
C
      END

C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      INTEGER FUNCTION INTFA( INGRIB,INLEN,FLDIN,OUTGRIB,OUTLEN,FLDOUT)
C
C---->
C**** INTFA
C
C     Purpose
C     -------
C
C     Prepare to interpolate input field...
C
C
C     Interface
C     ---------
C
C     IRET = INTFA( INGRIB,INLEN,FLDIN,OUTGRIB,OUTLEN,FLDOUT)
C
C     Input
C     -----
C
C     INGRIB - Input field (packed).
C     INLEN  - Input field length (words).
C     FLDIN  - Input field (unpacked).
C
C
C     Output
C     ------
C
C     OUTGRIB - Output field (packed).
C     OUTLEN  - Output field length (words).
C     FLDOUT  - Output field (unpacked).
C
C
C     Method
C     ------
C
C     Unpack field if GRIB).
C
C
C     Externals
C     ---------
C
C     IBASINI - Ensure basic interpolation setup is done.
C     GRIBEX  - Decode/encode GRIB product.
C     GRSVCK  - Turn off GRIB checking
C     RESET_C - Reset interpolation handling options using GRIB product.
C     PDDEFS  - Setup interpolation using parameter dependent options.
C     INTLOG  - Log error message.
C
C
C     Author
C     ------
C
C     J.D.Chambers     ECMWF     Jan 1995
C
C----<
C
      IMPLICIT NONE
C
C     Function arguments
      INTEGER INGRIB(*),OUTGRIB(*),INLEN,OUTLEN
      REAL FLDIN(*),FLDOUT(*)
C
#include "parim.h"
#include "nifld.common"
#include "nofld.common"
#include "grfixed.h"
#include "intf.h"
C
C     Parameters
      INTEGER JPROUTINE
      PARAMETER (JPROUTINE = 26100 )
C
C     Local variables
C
      INTEGER IWORD, IERR
      INTEGER KPR
      INTEGER LOOP
C
C     Externals
      INTEGER IBASINI, RESET_C, PDDEFS
C
C ------------------------------------------------------------------
C*    Section 1.   Initialise
C ------------------------------------------------------------------
C
  100 CONTINUE
      INTFA = 0
      IERR = 0
      KPR = 0
C
C     Check that basic initialisation has been done
      IERR = IBASINI(0)
      IF ( IERR .NE. 0 ) THEN
        CALL INTLOG(JP_ERROR,'INTFA: basic initialisation fail',JPQUIET)
        INTFA = IERR
        GOTO 900
      ENDIF
C
C ------------------------------------------------------------------
C*    Section 2.   Decode data from the GRIB code
C ------------------------------------------------------------------
C
  200 CONTINUE
C
C     Allocate work array ZNFELDI if not already done.
C
      IF( IZNJDCI.NE.1952999238 ) THEN
        CALL JMEMHAN( 19, IZNFLDI, JPEXPAND, 1, IERR)
        IF( IERR.NE.0 ) THEN
          CALL INTLOG(JP_WARN,'INTFA: ZNFELDI allocation fail',JPQUIET)
          INTFA = IERR
          GOTO 900
        ENDIF
        IZNJDCI = 1952999238
      ENDIF
C
C     If input is a GRIB product
      If (NIFORM .EQ. 1) THEN
C
C       Decode data from GRIB code (no checking)
C
        IWORD = INLEN
        IERR  =  0
        CALL GRSVCK(0)
        IERR = 1
        ISEC3(2) = NINT(RMISSGV)
        ZSEC3(2) = RMISSGV
        CALL GRIBEX(ISEC0, ISEC1, ISEC2, ZSEC2, ISEC3, ZSEC3, ISEC4,
     X              ZNFELDI, JPEXPAND, INGRIB, INLEN, IWORD, 'D',IERR)
        IF ( IERR .NE. 0) THEN
          CALL INTLOG(JP_ERROR, 'INTFA: GRIBEX decoding failed.',IERR)
          INTFA = IERR
          GOTO 900
        ENDIF
C
C       Setup interpolation options from GRIB product characteristics
        IERR = RESET_C( ISEC1, ISEC2, ZSEC2, ISEC4)
        IF ( IERR .NE. 0 ) THEN
          CALL INTLOG(JP_ERROR,
     X      'INTFA: Setup interp. options from GRIB failed.',JPQUIET)
          INTFA = IERR
          GOTO 900
        ENDIF
C
C     Otherwise, move unpacked values in from user array
      ELSE
        DO 210 LOOP = 1, INLEN
          ZNFELDI( LOOP ) = FLDIN( LOOP )
 210    CONTINUE
C
      ENDIF
C
C     Setup interpolation options based on parameter in field.
      IERR = PDDEFS()
      IF ( IERR .NE. 0 ) THEN
        CALL INTLOG(JP_ERROR,
     X    'INTFA: Setup interp. options from parameter failed.',JPQUIET)
        INTFA = IERR
        GOTO 900
      ENDIF
C
C
C ------------------------------------------------------------------
C*    Section 9.   Closedown.
C ------------------------------------------------------------------
C
  900 CONTINUE
C
C     Clear change flags for next product processing
C
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities
C granted to it by virtue of its status as an intergovernmental organisation
C nor does it submit to any jurisdiction.
C
      INTEGER FUNCTION JBESS (KTRUNC, PBESJ0)
C
C**** *JBESS* - Routine to return zeros of the J0 Bessel function.
C
C     PURPOSE
C     _______
C
C     This routine returns up to JPLOOK zeros of the J0 Bessel function.
C     If more than JPLOOK zeros are required then approximate zeros are
C     returned after the JPLOOK-th.
C
C     INTERFACE
C     _________
C
C     IERR = JBESS (KTRUNC, PBESJ0)
C
C     Input parameters
C     ________________
C
C     KTRUNC     - This is the number of zeros of the J0 Bessel
C                  function required.
C
C     Output parameters
C     ________________
C
C     PBESJ0     - The output array of zeros of the J0 Bessel function.
C
C     Return Value
C     ____________
C
C     The error indicator (INTEGER).
C
C     Error and Warning Return Values
C     _______________________________
C
C     None
C
C     Common block usage
C     __________________
C
C     None
C
C     EXTERNALS
C     _________
C
C     None
C
C     METHOD
C     ______
C
C     The first JPLOOK values are obtained from a look-up table (ZPBES).
C     Any additional values requested are approximated by adding
C     PI (3.14159...) to the previous value.
C
C     REFERENCE
C     _________
C
C     None
C
C     COMMENTS
C     ________
C
C     This routine is adapted from that in the old Marsint library.
C     The interface and the variable names have been modified.
C
C     Program contains sections 0 to 2 and 9
C
C     AUTHOR
C     ______
C
C     K. Fielding      *ECMWF*      Oct 1993
C
C     MODIFICATIONS
C     _____________
C
C     None
C
C     _______________________________________________________
C
C
C*    Section 0. Definition of variables.
C     _______________________________________________________
C
C*    Prefix conventions for variable names
C
C     Logical      L (but not LP), global or common.
C                  O, dummy argument
C                  G, local variable
C                  LP, parameter.
C     Character    C, global or common.
C                  H, dummy argument
C                  Y (but not YP), local variable
C                  YP, parameter.
C     Integer      M and N, global or common.
C                  K, dummy argument
C                  I, local variable
C                  J (but not JP), loop control
C                  JP, parameter.
C     REAL         A to F and Q to X, global or common.
C                  P (but not PP), dummy argument
C                  Z, local variable
C                  PP, parameter.
C
C     Implicit statement to force declarations
C
      IMPLICIT NONE
C
#include "jparams.h"
C
C     Dummy arguments
C
      INTEGER KTRUNC
C
      REAL PBESJ0 (*)
C
C     Local variables
C
C
      INTEGER ILOOK
      INTEGER JAPPRX, JLOOK
C
      REAL ZPBES (JPLOOK)
C
      DATA ZPBES        /   2.4048255577E0,   5.5200781103E0,
     1    8.6537279129E0,  11.7915344391E0,  14.9309177086E0,
     2   18.0710639679E0,  21.2116366299E0,  24.3524715308E0,
     3   27.4934791320E0,  30.6346064684E0,  33.7758202136E0,
     4   36.9170983537E0,  40.0584257646E0,  43.1997917132E0,
     5   46.3411883717E0,  49.4826098974E0,  52.6240518411E0,
     6   55.7655107550E0,  58.9069839261E0,  62.0484691902E0,
     7   65.1899648002E0,  68.3314693299E0,  71.4729816036E0,
     8   74.6145006437E0,  77.7560256304E0,  80.8975558711E0,
     9   84.0390907769E0,  87.1806298436E0,  90.3221726372E0,
     A   93.4637187819E0,  96.6052679510E0,  99.7468198587E0,
     1  102.8883742542E0, 106.0299309165E0, 109.1714896498E0,
     2  112.3130502805E0, 115.4546126537E0, 118.5961766309E0,
     3  121.7377420880E0, 124.8793089132E0, 128.0208770059E0,
     4  131.1624462752E0, 134.3040166383E0, 137.4455880203E0,
     5  140.5871603528E0, 143.7287335737E0, 146.8703076258E0,
     6  150.0118824570E0, 153.1534580192E0, 156.2950342685E0 /
C
C     _______________________________________________________
C
C
C*    Section 1. Extract initial values from look up table
C
C     _______________________________________________________
C
  100 CONTINUE
C
      JBESS = 0
C
      ILOOK = MIN(KTRUNC, JPLOOK)
C
      DO 110 JLOOK = 1, ILOOK
         PBESJ0(JLOOK) = ZPBES(JLOOK)
  110 CONTINUE
C
C     _______________________________________________________
C
C*    Section 2. Approximate any extra values required
C     _______________________________________________________
C
  200 CONTINUE
C
      DO 210 JAPPRX = ILOOK + 1, KTRUNC
         PBESJ0(JAPPRX) = PBESJ0(JPLOOK) + PPI * (JAPPRX - ILOOK)
  210 CONTINUE
C
C     _______________________________________________________
C
C*    Section 9. Return to calling routine.
C     _______________________________________________________
C
  900 CONTINUE
C
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE BUOCTN(KWPTB,KBPTB,KBUFL,KBUFF,KERR)
C
C**** *BUOCTN*
C
C
C     PURPOSE.
C     --------
C             CALCULATE NUMBER OF OCTETS FROM BIT POSITION DEFINED BY
C     KWPT,KBPT  AND KWPTB,KBPTB; NUMBER OF OCTETS MUST BE EVEN. IF IT IS
C     NEEDED PADING WITH 0 BIT PERFORMS. NUMBER OF OCTETS IS WRITTEN AT
C     BEGINIG OF THE SECTION.
C
C**   INTERFACE.
C     ----------
C
C          *CALL* *BUOCTN(KWPTB,KBPTB,KBUFL,KBUFF,KERR)*
C
C        INPUT :
C               *KWPTB*    - WORD POINTER TO THE BEGINING OF SECTION
C               *KBPTB*    - BIT  POINTER TO THE BEGINING OF SECTION
C        OUTPUT :
C               *KBUFL*   -  LENGTH OF BUFR MESSAGE (WORDS)
C               *KBUFF*   -  ARRAY CONTAINING BUFR MESSAGE
C               *KERR*    -  RETURNED ERROR CODE
C
C
C     *METHOD.
C      -------
C
C          NONE.
C
C     EXTERNALS.
C     ----------
C
C          BUPCK       - PACK BIT PATHERN AND RESETS POINTERS
C          SBYTE       - PACK BIT PATHERN
C
C
C     REFERENCE.
C     ----------
C
C          NONE.
C
C     AUTHOR.
C     -------
C
C          M. DRAGOSAVAC    *ECMWF*       07/10/87.
C
C
C     MODIFICATIONS.
C     --------------
C
C          NONE.
C
C
      IMPLICIT LOGICAL(L,O,G), CHARACTER*8(C,H,Y)
C
C
C
#     include "parameter.F"
#     include "bcomunit.F"
#     include "bcmwork.F"
C
      DIMENSION KBUFF(KBUFL)
#ifndef R_4
      REAL*8 RVIND
      REAL*8 EPS
#else
      REAL   RVIND
      REAL   EPS
#endif
C
C     ------------------------------------------------------------------
C*          1.    CALCULATE NUMBER OF OCTETS.
C                 ---------------------------
 100  CONTINUE
C
      IF(KERR.GT.0) RETURN
C
      IB   =(NWPT-1) * NBPW + NBPT
      IBB  =(KWPTB-1)* NBPW + KBPTB
C
      IDIFB= IB - IBB
C
      NOCT = IDIFB/8
      IBDW = IDIFB - NOCT*8
C
      IF(IBDW .NE.0)THEN
         NOCT=NOCT+1
         IBDW=8-IBDW
         CALL BUPCK(NBPW,KBUFF(NWPT),0,NWPT,NBPT,IBDW,KERR)
         IF(KERR.GT.0) THEN
            CALL BUERR(KERR)
            RETURN
         END IF
      END IF
C
C     ------------------------------------------------------------------
C*          2.  CHECK IF THERE ARE EVEN NUMBER OF OCTETS IN BLOCK.
C               --------------------------------------------------
 200  CONTINUE
C
      IF(NEDN.LE.3) THEN
         IF(MOD(NOCT,2).NE.0) THEN
             IBDW = 8
             CALL BUPCK(NBPW,KBUFF(NWPT),0,NWPT,NBPT,IBDW,KERR)
             IF(KERR.GT.0) THEN
               CALL BUERR(KERR)
               RETURN
             END IF
             NOCT = NOCT+1
         END IF
      END IF
C     ------------------------------------------------------------------
C*          3.  WRITE NUMBER OF OCTETS AT BEGINING OF BLOCK.
C               --------------------------------------------
 300  CONTINUE
C
      IBDW  = 24
      CALL SBYTE(KBUFF(KWPTB),NOCT,KBPTB,IBDW)
C
      RETURN
      END

C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C


      SUBROUTINE GETCHD (KLCHD,HCHD,KLENG,KARRAY,KPR,KRET)
C
C---->
C     ----------------------------------------------------------------
C
C****
C
C     PURPOSE.
C     --------
C
C           GET CHARACTER DATA FROM UNPACKED GRIB OR
C           PSEUDO-GRIB RECORDS, RETRIEVED FROM MARS.
C
C**   INTERFACE.
C     ----------
C
C           CALL GETCHD (KLCHD,HCHD,KLENG,KARRAY,KPR,KRET)
C
C           INTEGER    K.
C           REAL       P.
C           LOGICAL    O.
C           CHARACTER  H.
C
C               INPUT PARAMETERS.
C               -----------------
C
C               HCHD       - STRING TO RECEIVE CHARACTER DATA.
C               KLENG      - LENGTH OF THIS STRING.
C               KARRAY     - ARRAY CONTAINING UNPACKED RECORD.
C               KPR        - DEBUG PRINT SWITCH.
C                            0 , NO PRINTOUT.
C                            1 , DEBUG PRINTOUT.
C
C               KRET       - ABORT/NO ABORT WHEN ERROR FOUND.
C                            0   , ABORT IF ERROR FOUND.
C                            NON-ZERO , NO ABORT IF ERROR FOUND.
C
C               OUTPUT PARAMETERS.
C               ------------------
C
C               HCHD       - STRING OF CHARACTER DATA.
C               KLCHD      - NUMBER OF CHARACTERS IN THIS STRING.
C               KRET       - ERROR RETURN CODE.
C                            0   , NO ERROR ENCOUNTERED.
C                            1   , TARGET STRING TOO SHORT.
C
C     METHOD.
C     -------
C
C           UNPACKED DATA IS IN SELF DEFINING RECORDS. THE REQUIRED
C           VALUES ARE LOCATED AND EXTRACTED.
C
C     EXTERNALS.
C     ----------
C
C           NONE.
C
C     REFERENCE.
C     ----------
C
C           SEE MARS FORMAT DOCUMENTATION RE GRIB, PSEUDO-GRIB AND
C           UNPACKED FORMATS.
C
C     COMMENTS.
C     ---------
C
C           PROGRAM CONTAINS SECTIONS 0 TO 2 AND SECTION 9.
C
C     AUTHOR.
C     -------
C
C           J. HENNESSY      ECMWF      18:06:86.
C
C     MODIFICATIONS
C     --------------
C           NONE.
C
C     ---------------------------------------------------------------
C----<
C
C
C
C
C
C
C
C
C
C
C*    SECTION 0 . DEFINITION OF VARIABLES.
C     ------------------------------------
C
      IMPLICIT LOGICAL     ( L, O, G )
      IMPLICIT CHARACTER*8 ( C, H, Y )
      IMPLICIT INTEGER     ( I, J, K, M, N )
C
      DIMENSION KARRAY(*)
C
      CHARACTER*(*) HCHD
C
C
C     ---------------------------------------------------------------
C
C
C
C
C
C
C
C
C
C
C
C*    SECTION 1 . SET INITIAL VALUES. CHECK INPUT PARAMETERS.
C     -------------------------------------------------------
C
 1000 CONTINUE
C
      IF (KPR.EQ.1) WRITE (*,*) 'GETCHD : SECTION 1.'
C
      IRET = KRET
      KRET = 0
C
C     --------------------------------------------------------------
C
C
C
C
C
C
C
C
C
C
C*    SECTION 2 . EXTRACT VALUES . PRINT IF REQUIRED.
C     -----------------------------------------------
C
 2000 CONTINUE
C
      IF (KPR.EQ.1) WRITE (*,*) 'GETCHD : SECTION 2.'
C
      ILIB1 = KARRAY(2)
      ILIB2 = KARRAY(2+ILIB1+1)
      ILFB2 = KARRAY(2+ILIB1+1+ILIB2+1)
      ILIB3 = KARRAY(2+ILIB1+1+ILIB2+1+ILFB2+1)
      KLCHD = KARRAY(2+ILIB1+1+ILIB2+1+ILFB2+1+ILIB3+1)
C
      IF (KLENG.LT.KLCHD)
     C   THEN
             KRET = 1
             WRITE (*,9001) KRET , KLCHD
             GO TO 9000
         ENDIF
C
      DO 2010 J=1,KLCHD
         IVAL    = KARRAY(J+2+ILIB1+1+ILIB2+1+ILFB2+1+ILIB3+1)
         READ (IVAL,'(A1)') HCHD(J:J)
 2010 CONTINUE
C
C
C     ------------------------------------------------------------------
C
C
C
C
C
C
C
C
C
C
C
C*    SECTION 9 . RETURN TO CALLING ROUTINE OR ABORT. FORMAT STATEMENTS.
C     ------------------------------------------------------------------
C
 9000 CONTINUE
C
      IF (KPR.EQ.1) WRITE (*,*) 'GETCHD : SECTION 9.'
C
      IF (KRET.NE.0.AND.IRET.EQ.0) CALL ABORT
C
      RETURN
C
C
 9001 FORMAT (1H ,'GETCHD : ERROR CODE = ',I3,'. TARGET STRING MUST BE',
     C             ' AT LEAST ',I5,' CHARACTERS LONG.')
C
C     ------------------------------------------------------------------
C
C
      END

C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      INTEGER FUNCTION GRIBNUM(KONOFF)
C
C---->
C**** GRIBNUM
C
C     Purpose
C     -------
C
C     Returns current GRIB_CYCLE version number.
C
C
C     Interface
C     ---------
C
C     INUM = GRIBNUM(KONOFF)
C
C     Input
C     -----
C
C     KONOFF - switch for displayed message
C              = 0 if display is required on the first call
C              = non-zero if display is not required
C
C
C     Output
C     ------
C
C     Returns a 6-digit version number, aaabbc, where:
C       aaa = 3-digit major number
C       bb  = 2-digit minor number
C       c   = 1-digit spare number (normally 0)
C     
C
C     Method
C     ------
C
C     Reads a 6-digit version number from the environment variable
C     GRIB_CYCLE. If this does not give a 6-digit number, an internal
C     hard-coded default value is used.
C
C     On the first call, the function (optionally) displays a message:
C
C       **************************************
C       * GRIB_CYCLE version number = aaabbc *
C       **************************************
C     
C
C     Externals
C     ---------
C
C     None.
C     
C
C     Author
C     ------
C
C     J.D.Chambers     ECMWF     May 1998
C
C
C----<
C ------------------------------------------------------------------
C*    Section 0.   Variables.
C ------------------------------------------------------------------
C
C
      IMPLICIT NONE
C
#include "grprs.h"
C
C     Function arguments
C
      INTEGER KONOFF
C
C     Local variables
C
      INTEGER INUMBER, ICOUNT, IOFFSET
      SAVE INUMBER, ICOUNT
      CHARACTER*38 CMESS
      CHARACTER*20 YNUMBER
C
      DATA INUMBER/000010/, ICOUNT/0/
      DATA CMESS/'* GRIB_CYCLE version number = ****** *'/
C
C ------------------------------------------------------------------
C*    Section 1.   Initialise
C ------------------------------------------------------------------
C
  100 CONTINUE
C
      IF( ICOUNT.EQ.0 ) THEN
C
C       See if the environment variable has an override value
C
        CALL GETENV( 'GRIB_CYCLE', YNUMBER)
        IOFFSET = INDEX( YNUMBER, ' ')
        IF( IOFFSET.EQ.7 ) THEN
          READ(YNUMBER,'(I6.6)') INUMBER
        ENDIF
C
C       First time through, display the message if required
C
        IF( KONOFF.EQ.0 ) THEN
          WRITE(CMESS(31:36),'(I6.6)') INUMBER
          WRITE(GRPRSM,*) '**************************************'
          WRITE(GRPRSM,*) CMESS
          WRITE(GRPRSM,*) '**************************************'
        ENDIF
        ICOUNT = 1
      ENDIF
C
      GRIBNUM = INUMBER
C
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities
C granted to it by virtue of its status as an intergovernmental organisation
C nor does it submit to any jurisdiction.
C

      SUBROUTINE GRPRS2 (KSEC0,KSEC2,PSEC2)
C
C---->
C**** GRPRS2 - Print information from Section 2 of GRIB code.
C
C     Purpose.
C     --------
C
C     Print the information in the Grid Description
C     Section (Section 2) of decoded GRIB data.
C
C**   Interface.
C     ----------
C
C     CALL GRPRS2 (KSEC0,KSEC2,PSEC2)
C
C
C     Input Parameters.
C     -----------------
C
C     KSEC0 - Array of decoded integers from Section 0.
C
C     KSEC2 - Array of decoded integers from Section 2.
C
C     PSEC2 - Array of decoded reals from Section 2.
C
C
C     Output Parameters.
C     ------------------
C
C     None.
C
C
C     Method.
C     -------
C
C     Flag fields are printed in binary representation
C     Other fields as integers or reals, as appropriate.
C     Fields printed depend on GRIB Edition.
C
C
C     Externals.
C     ----------
C
C     PRTBIN   - Print binary representation of value.
C     PTQUASI  - Print quasi-grid data.
C
C     Common block GRPRSCM.
C
C
C     Reference.
C     ----------
C
C     WMO Manual on Codes re GRIB Code.
C
C
C     Comments.
C     ---------
C
C     Only data representation types catered for are Gaussian
C     grid, latitude/longitude grid, Spherical Harmonics,
C     Polar stereographic and Space view perspective.
C
C
C     Author.
C     -------
C
C     J. Hennessy    ECMWF 18.06.91
C
C
C     Modifications.
C     --------------
C
C     J. Hennessy    ECMWF        02.09.91
C     Polar stereographic print added.
C
C     J. Hennessy    ECMWF        25.09.91
C     Space view perspective print added.
C
C     J.D.Chambers   ECMWF        21.02.95
C     Quasi-regular lat/long grids added.
C
C     J.D.Chambers     ECMWF      03.04.95
C     Allow Lambert conformal.
C
C     J.D.Chambers   ECMWF    June 2002
C     Add option to set output stream number using environment variable
C     GRPRS_STREAM
C
C     J.D.Chambers     ECMWF      July 2004
C     Allow Mercator
C
C
C----<
C     -----------------------------------------------------------------
C*    Section 0. Definition of variables.
C     -----------------------------------------------------------------
C
      IMPLICIT NONE
C
#include "common/grprs.h"
C
C     Subroutine arguments
C
      INTEGER KSEC0,KSEC2
      DIMENSION KSEC0(*)
      DIMENSION KSEC2(*)
      REAL PSEC2
      DIMENSION PSEC2(*)
C
C     Local variables
C
      INTEGER I, IBIT, IEDIT, IERR, IOUT, IRESOL
C
C
C     -----------------------------------------------------------------|
C*    Section 1 . Print GRIB Edition number.
C     -----------------------------------------------------------------|
C
  100 CONTINUE
C
      IEDIT = KSEC0(2)
      WRITE(GRPRSM,9000)
      WRITE(GRPRSM,9001)
      WRITE(GRPRSM,9002)
C
C     -----------------------------------------------------------------|
C*    Section 2 . Print spherical harmonic data.
C     -----------------------------------------------------------------|
C
  200 CONTINUE
C
      IF (KSEC2(1).EQ.50 .OR. KSEC2(1).EQ.60 .OR.
     X    KSEC2(1).EQ.70 .OR. KSEC2(1).EQ.80) THEN
        WRITE(GRPRSM,9111) KSEC2(1)
        WRITE(GRPRSM,9102) KSEC2(2)
        WRITE(GRPRSM,9103) KSEC2(3)
        WRITE(GRPRSM,9104) KSEC2(4)
        WRITE(GRPRSM,9105) KSEC2(5)
        WRITE(GRPRSM,9106) KSEC2(6)
        DO I = 7, 11
          WRITE(GRPRSM,9107) KSEC2(I)
        ENDDO
        WRITE(GRPRSM,9212) KSEC2(12)
        GO TO 800
C
      ENDIF
C
C     -----------------------------------------------------------------|
C*    Section 3 . Print Gaussian grid data.
C     -----------------------------------------------------------------|
C
  300 CONTINUE
C
      IF (KSEC2(1).EQ.4 .OR. KSEC2(1).EQ.14 .OR.
     X    KSEC2(1).EQ.24 .OR. KSEC2(1).EQ.34) THEN
        WRITE(GRPRSM,9200)
        WRITE(GRPRSM,9112) KSEC2(1)
C
C       Quasi-regular grids introduced in Edition 1.
C
        IF (KSEC2(17).EQ.0.OR.IEDIT.LT.1) THEN
          WRITE(GRPRSM,9201) KSEC2(2)
        ELSE
          CALL PTQUASI(KSEC2)
        ENDIF
        WRITE(GRPRSM,9202) KSEC2(3)
        WRITE(GRPRSM,9203) KSEC2(4)
        WRITE(GRPRSM,9204) KSEC2(5)
        IBIT = 8
        IRESOL = KSEC2(6) + KSEC2(18) + KSEC2(19)
        CALL PRTBIN (IRESOL,IBIT,IOUT,IERR)
        WRITE(GRPRSM,9205) IOUT
        WRITE(GRPRSM,9206) KSEC2(7)
        WRITE(GRPRSM,9207) KSEC2(8)
C
C       Print increment if given.
C
        IF (KSEC2(6).EQ.128) THEN
          WRITE(GRPRSM,9208) KSEC2(9)
        ELSE
          WRITE(GRPRSM,9236)
        ENDIF
        WRITE(GRPRSM,9210) KSEC2(10)
        IBIT = 8
        CALL PRTBIN (KSEC2(11),IBIT,IOUT,IERR)
        WRITE(GRPRSM,9211) IOUT
        WRITE(GRPRSM,9212) KSEC2(12)
        GO TO 800
C
      ENDIF
C
C     -----------------------------------------------------------------|
C*    Section 4 . Print Latitude / longitude grid data.
C     -----------------------------------------------------------------|
C
  400 CONTINUE
C
      IF (KSEC2(1).EQ.0 .OR. KSEC2(1).EQ.10 .OR.
     X    KSEC2(1).EQ.20 .OR. KSEC2(1).EQ.30) THEN
        WRITE(GRPRSM,9200)
        WRITE(GRPRSM,9113) KSEC2(1)
C
C       Quasi-regular lat/long grids also possible.
C
        IF (KSEC2(17).EQ.0) THEN
          WRITE(GRPRSM,9201) KSEC2(2)
        ELSE
          CALL PTQUASI(KSEC2)
        ENDIF
        WRITE(GRPRSM,9202) KSEC2(3)
        WRITE(GRPRSM,9203) KSEC2(4)
        WRITE(GRPRSM,9204) KSEC2(5)
        IBIT = 8
        IRESOL = KSEC2(6) + KSEC2(18) + KSEC2(19)
        CALL PRTBIN (IRESOL,IBIT,IOUT,IERR)
        WRITE(GRPRSM,9205) IOUT
        WRITE(GRPRSM,9206) KSEC2(7)
        WRITE(GRPRSM,9207) KSEC2(8)
C
C       Print increment if given.
C
        IF ( KSEC2(9) .LT. 0) THEN
          WRITE(GRPRSM,9236)
        ELSE
          WRITE(GRPRSM,9208) KSEC2(9)
        ENDIF
        IF ( KSEC2(10) .LT. 0) THEN
          WRITE(GRPRSM,9237)
        ELSE
          WRITE(GRPRSM,9209) KSEC2(10)
        ENDIF
        IBIT = 8
        CALL PRTBIN (KSEC2(11),IBIT,IOUT,IERR)
        WRITE(GRPRSM,9211) IOUT
        WRITE(GRPRSM,9212) KSEC2(12)
        GO TO 800
C
      ENDIF
C
C     -----------------------------------------------------------------|
C*    Section 5 . Print polar stereographic data.
C     -----------------------------------------------------------------|
C
  500 CONTINUE
C
      IF (KSEC2(1).EQ.5) THEN
        WRITE(GRPRSM,9200)
        WRITE(GRPRSM,9114) KSEC2(1)
        WRITE(GRPRSM,9301) KSEC2(2)
        WRITE(GRPRSM,9302) KSEC2(3)
        WRITE(GRPRSM,9203) KSEC2(4)
        WRITE(GRPRSM,9204) KSEC2(5)
        IBIT = 8
        IRESOL = KSEC2(18) + KSEC2(19)
        CALL PRTBIN (IRESOL,IBIT,IOUT,IERR)
        WRITE(GRPRSM,9205) IOUT
        WRITE(GRPRSM,9303) KSEC2(7)
        WRITE(GRPRSM,9304) KSEC2(9)
        WRITE(GRPRSM,9305) KSEC2(10)
        IBIT = 8
        CALL PRTBIN (KSEC2(11),IBIT,IOUT,IERR)
        WRITE(GRPRSM,9211) IOUT
        WRITE(GRPRSM,9212) KSEC2(12)
        WRITE(GRPRSM,9306) KSEC2(13)
        GO TO 800
C
      ENDIF
C
C     -----------------------------------------------------------------|
C*    Section 6 . Print Lambert conformal data.
C     -----------------------------------------------------------------|
C
  600 CONTINUE
C
      IF (KSEC2(1).EQ.3) THEN
C
        WRITE(GRPRSM,9200)
        WRITE(GRPRSM,9115) KSEC2(1)
        WRITE(GRPRSM,9301) KSEC2(2)
        WRITE(GRPRSM,9302) KSEC2(3)
        WRITE(GRPRSM,9203) KSEC2(4)
        WRITE(GRPRSM,9204) KSEC2(5)
        IBIT = 8
        IRESOL = KSEC2(18) + KSEC2(19) + KSEC2(6)
        CALL PRTBIN (IRESOL,IBIT,IOUT,IERR)
        WRITE(GRPRSM,9205) IOUT
        WRITE(GRPRSM,9303) KSEC2(7)
        WRITE(GRPRSM,9304) KSEC2(9)
        WRITE(GRPRSM,9305) KSEC2(10)
        IBIT = 8
        CALL PRTBIN (KSEC2(11),IBIT,IOUT,IERR)
        WRITE(GRPRSM,9211) IOUT
        WRITE(GRPRSM,9212) KSEC2(12)
        WRITE(GRPRSM,9306) KSEC2(13)
        WRITE(GRPRSM,9214) KSEC2(14)
        WRITE(GRPRSM,9215) KSEC2(15)
        WRITE(GRPRSM,9216) KSEC2(20)
        WRITE(GRPRSM,9217) KSEC2(21)
        GO TO 800
C
      ENDIF
C
C     -----------------------------------------------------------------|
C*    Section 7 . Print space view perspective or orthographic data.
C     -----------------------------------------------------------------|
C
  700 CONTINUE
C
      IF (KSEC2(1).EQ.90) THEN
        WRITE(GRPRSM,9200)
        WRITE(GRPRSM,9116) KSEC2(1)
        WRITE(GRPRSM,9301) KSEC2(2)
        WRITE(GRPRSM,9302) KSEC2(3)
        WRITE(GRPRSM,9310) KSEC2(4)
        WRITE(GRPRSM,9311) KSEC2(5)
        IBIT = 8
        IRESOL = KSEC2(18) + KSEC2(19)
        WRITE(GRPRSM,9312) KSEC2(7)
        WRITE(GRPRSM,9313) KSEC2(8)
        WRITE(GRPRSM,9314) KSEC2(9)
        WRITE(GRPRSM,9315) KSEC2(10)
        IBIT = 8
        CALL PRTBIN (KSEC2(11),IBIT,IOUT,IERR)
        WRITE(GRPRSM,9211) IOUT
        WRITE(GRPRSM,9212) KSEC2(12)
        WRITE(GRPRSM,9303) KSEC2(13)
        WRITE(GRPRSM,9316) KSEC2(14)
        WRITE(GRPRSM,9317) KSEC2(15)
        WRITE(GRPRSM,9318) KSEC2(16)
        WRITE(GRPRSM,9319) KSEC2(18)
        WRITE(GRPRSM,9320) KSEC2(19)
        GO TO 800
C
      ENDIF
C
C     -----------------------------------------------------------------|
C*    Section 7.5 . Print ocean data
C     -----------------------------------------------------------------|
C
  750 CONTINUE
C
      IF( KSEC2(1).EQ.192 ) THEN
        WRITE(GRPRSM,9117) KSEC2(1)
        IF( KSEC2(2).EQ. 32767 ) THEN
          WRITE(GRPRSM,9501) KSEC2(2)
        ELSE
          WRITE(GRPRSM,9502) KSEC2(2)
        ENDIF
C
        IF( KSEC2(3).EQ. 32767 ) THEN
          WRITE(GRPRSM,9503) KSEC2(3)
        ELSE
          WRITE(GRPRSM,9504) KSEC2(3)
        ENDIF
C
        IBIT = 8
        CALL PRTBIN (KSEC2(11),IBIT,IOUT,IERR)
        WRITE(GRPRSM,9211) IOUT
        GO TO 800
      ENDIF
C
C     -----------------------------------------------------------------|
C*    Section 7.6 . Print mercator data
C     -----------------------------------------------------------------|
C
  760 CONTINUE
C
      IF (KSEC2(1).EQ.1) THEN
        WRITE(GRPRSM,9200)
        WRITE(GRPRSM,9118) KSEC2(1)
        WRITE(GRPRSM,9201) KSEC2(2)
        WRITE(GRPRSM,9202) KSEC2(3)
        WRITE(GRPRSM,9203) KSEC2(4)
        WRITE(GRPRSM,9204) KSEC2(5)
        IBIT = 8
        IRESOL = KSEC2(6) + KSEC2(18) + KSEC2(19)
        CALL PRTBIN (IRESOL,IBIT,IOUT,IERR)
        WRITE(GRPRSM,9205) IOUT
        WRITE(GRPRSM,9206) KSEC2(7)
        WRITE(GRPRSM,9207) KSEC2(8)
        WRITE(GRPRSM,9218) KSEC2(9)
        WRITE(GRPRSM,9208) KSEC2(13)
        WRITE(GRPRSM,9209) KSEC2(14)
        IBIT = 8
        CALL PRTBIN (KSEC2(11),IBIT,IOUT,IERR)
        WRITE(GRPRSM,9211) IOUT
        WRITE(GRPRSM,9212) KSEC2(12)
        GO TO 800
      ENDIF
C
C     -----------------------------------------------------------------|
C     Drop through to here => representation type not catered for.
C     -----------------------------------------------------------------|
C
      WRITE(GRPRSM,*)
     X  'GRPRS2 :Data representation type not catered for -', KSEC2(1)
C
      GO TO 900
C
C     -----------------------------------------------------------------|
C*    Section 8 . Print vertical coordinate parameters,
C                 rotated grid information,
C                 stretched grid information, if any.
C     -----------------------------------------------------------------|
C
  800 CONTINUE
C
C     Vertical coordinate parameters ...
C
      IF (KSEC2(12).NE.0) THEN
        WRITE(GRPRSM,9000)
        WRITE(GRPRSM,9400)
        WRITE(GRPRSM,9401)
        DO I = 11, (KSEC2(12)+10)
          WRITE(GRPRSM,9402) PSEC2(I)
        ENDDO
      ENDIF
C
C     Rotated and stretched grids introduced in Edition 1.
C
      IF (IEDIT.LT.1) GO TO 900
C
C*    Rotated grid information ...
C
      IF (KSEC2(1).EQ.10 .OR. KSEC2(1).EQ.30 .OR.
     X    KSEC2(1).EQ.14 .OR. KSEC2(1).EQ.34 .OR.
     X    KSEC2(1).EQ.60 .OR. KSEC2(1).EQ.80 .OR.
     X    KSEC2(1).EQ.30) THEN
        WRITE(GRPRSM,9000)
        WRITE(GRPRSM,9220) KSEC2(13)
        WRITE(GRPRSM,9221) KSEC2(14)
        WRITE(GRPRSM,9222) PSEC2(1)
      ENDIF
C
C*    Stretched grid information ...
C
      IF (KSEC2(1).EQ.20 .OR. KSEC2(1).EQ.30 .OR.
     X    KSEC2(1).EQ.24 .OR. KSEC2(1).EQ.34 .OR.
     X    KSEC2(1).EQ.70 .OR. KSEC2(1).EQ.80) THEN
        WRITE(GRPRSM,9000)
        WRITE(GRPRSM,9230) KSEC2(15)
        WRITE(GRPRSM,9231) KSEC2(16)
        WRITE(GRPRSM,9232) PSEC2(2)
      ENDIF
C
C     -----------------------------------------------------------------|
C*    Section 9 . Format statements. Return to calling routine.
C     -----------------------------------------------------------------|
C
  900 CONTINUE
C
      RETURN
C
 9000 FORMAT (1H )
 9001 FORMAT (1H ,'Section 2 - Grid Description Section.')
 9002 FORMAT (1H ,'-------------------------------------')
 9102 FORMAT (1H ,'J - Pentagonal resolution parameter.         ',I9)
 9103 FORMAT (1H ,'K - Pentagonal resolution parameter.         ',I9)
 9104 FORMAT (1H ,'M - Pentagonal resolution parameter.         ',I9)
 9105 FORMAT (1H ,'Representation type (Table 9)                ',I9)
 9106 FORMAT (1H ,'Representation mode (Table 10).              ',I9)
 9107 FORMAT (1H ,'Not used.                                    ',I9)
 9111 FORMAT (1H ,'Data represent type = spectral     (Table 6) ',I9)
 9112 FORMAT (1H ,'Data represent type = gaussian     (Table 6) ',I9)
 9113 FORMAT (1H ,'Data represent type = lat/long     (Table 6) ',I9)
 9114 FORMAT (1H ,'Data represent type = polar stereo (Table 6) ',I9)
 9115 FORMAT (1H ,'Data represent type = Lambert      (Table 6) ',I9)
 9116 FORMAT (1H ,'Data represent type = space/ortho  (Table 6) ',I9)
 9117 FORMAT (1H ,'Data represent type = ECMWF ocean  (Table 6) ',I9)
 9118 FORMAT (1H ,'Data represent type = Mercator  (Table 6)    ',I9)
C
 9200 FORMAT (1H ,'(Southern latitudes and Western longitudes',
     C            ' are negative.)')
 9201 FORMAT (1H ,'Number of points along a parallel.           ',I9)
 9202 FORMAT (1H ,'Number of points along a meridian.           ',I9)
 9203 FORMAT (1H ,'Latitude of first grid point.                ',I9)
 9204 FORMAT (1H ,'Longitude of first grid point.               ',I9)
 9205 FORMAT (1H ,'Resolution and components flag.               ',I8.8)
 9206 FORMAT (1H ,'Latitude of last grid point.                 ',I9)
 9207 FORMAT (1H ,'Longitude of last grid point.                ',I9)
 9208 FORMAT (1H ,'i direction (East-West) increment.           ',I9)
 9209 FORMAT (1H ,'j direction (North-South) increment.         ',I9)
 9210 FORMAT (1H ,'Number of parallels between pole and equator.',I9)
 9211 FORMAT (1H ,'Scanning mode flags (Code Table 8)            ',I8.8)
 9212 FORMAT (1H ,'Number of vertical coordinate parameters.    ',I9)
C
 9214 FORMAT (1H ,'Latitude intersection 1 - Latin 1 -.         ',I9)
 9215 FORMAT (1H ,'Latitude intersection 2 - Latin 2 -.         ',I9)
 9216 FORMAT (1H ,'Latitude of Southern Pole.                   ',I9)
 9217 FORMAT (1H ,'Longitude of Southern Pole.                  ',I9)
 9218 FORMAT (1H ,'Latitude projection intersects Earth(Latin)  ',I9)
C
 9220 FORMAT (1H ,'Latitude of southern pole of rotation.       ',I9)
 9221 FORMAT (1H ,'Longitude of southern pole of rotation.      ',I9)
 9222 FORMAT (1H ,'Angle of rotation.                     ',F20.10)
C
 9230 FORMAT (1H ,'Latitude of pole of stretching.              ',I9)
 9231 FORMAT (1H ,'Longitude of pole of stretching.             ',I9)
 9232 FORMAT (1H ,'Stretching factor.                     ',F20.10)
 9233 FORMAT (1H ,'Number of points along a parallel varies.')
 9235 FORMAT (1H , I5,16X,A10)
 9236 FORMAT (1H ,'i direction (East-West) increment',
     X        '            Not given')
 9237 FORMAT (1H ,'j direction (North-South) increment',
     X        '          Not given')
C
 9301 FORMAT (1H ,'Number of points along X axis.               ',I9)
 9302 FORMAT (1H ,'Number of points along Y axis.               ',I9)
 9303 FORMAT (1H ,'Orientation of the grid.                     ',I9)
 9304 FORMAT (1H ,'X direction increment.                       ',I9)
 9305 FORMAT (1H ,'Y direction increment.                       ',I9)
 9306 FORMAT (1H ,'Projection centre flag.                      ',I9)
C
 9310 FORMAT (1H ,'Latitude of sub-satellite point.             ',I9)
 9311 FORMAT (1H ,'Longitude of sub-satellite point.            ',I9)
 9312 FORMAT (1H ,'Diameter of the earth in x direction.        ',I9)
 9313 FORMAT (1H ,'Diameter of the earth in y direction.        ',I9)
 9314 FORMAT (1H ,'X coordinate of sub-satellite point.         ',I9)
 9315 FORMAT (1H ,'Y coordinate of sub-satellite point.         ',I9)
 9316 FORMAT (1H ,'Altitude of the camera.                      ',I9)
 9317 FORMAT (1H ,'Y coordinate of origin of sector image.      ',I9)
 9318 FORMAT (1H ,'X coordinate of origin of sector image.      ',I9)
 9319 FORMAT (1H ,'Earth flag                                   ',I9)
 9320 FORMAT (1H ,'Components flag                              ',I9)
C
 9400 FORMAT (1H ,'Vertical Coordinate Parameters.')
 9401 FORMAT (1H ,'-------------------------------')
 9402 FORMAT (4X,F20.12,4X,F20.12)
C
 9501 FORMAT(' Number of points along the first axis.       Not used')
 9502 FORMAT (' Number of points along the first axis.       ',I9)
 9503 FORMAT(' Number of points along the second axis.      Not used')
 9504 FORMAT (' Number of points along the second axis.      ',I9)
C
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      INTEGER FUNCTION LOCAL2K(KSEC1, HFIRST, HSECOND, HTHIRD, HFOURTH)
C
C---->
C**** LOCAL2K
C
C     Purpose
C     -------
C
C     Looks up the description of a parameter in known table 2 versions
C     for WMO code FM 92-X Ext. GRIB.
C
C
C     Interface
C     ---------
C
C     IRET = LOCAL2K(KSEC1, HFIRST, HSECOND, HTHIRD, HFOURTH)
C
C     Input
C     -----
C
C     KSEC1  - Section 1 values for a GRIB product.
C
C
C     Output
C     ------
C
C     HFIRST  - First line of descriptor:  MARS mnemonic
C     HSECOND - Second line of descriptor: Parameter description
C     HTHIRD  - Third line of descriptor:  Units for the parameter
C     HFOURTH - Fourth line of descriptor: Description of units
C
C     Function return value is
C            0 if no error detected.
C        20001 if no match found for the parameter number in
C              the given table.
C        20002 if there is an error opening the file holding
C              the given table.
C
C
C     Method
C     ------
C
C     Calls LOCAL2.
C
C
C     Externals
C     ---------
C     LOCAL2  - looks up information in standard tables.
C
C
C     Author
C     ------
C
C     J.D.Chambers     ECMWF     Sept 1995
C
C
C     MODIFICATIONS
C     _____________
C
C     J. Clochard, Meteo France, for ECMWF - June 1999.
C     Argument KCENTR added to LOCAL2 call for code tables management.
C
C     _______________________________________________________
C----<
C
C
      IMPLICIT NONE
C
C     Function arguments
      INTEGER KSEC1
      DIMENSION KSEC1(*)
      CHARACTER*(*) HFIRST, HSECOND, HTHIRD, HFOURTH
C
C     Externals
      INTEGER LOCAL2
C
C
C ------------------------------------------------------------------
C*    Section 1.   Initialise
C ------------------------------------------------------------------
C
  100 CONTINUE
C
      LOCAL2K = LOCAL2(KSEC1(1), KSEC1(6), KSEC1(2),
     X                 HFIRST, HSECOND, HTHIRD, HFOURTH)
C
C ------------------------------------------------------------------
C*    Section 9.   Closedown.
C ------------------------------------------------------------------
C
C     Normal return.
 900  CONTINUE
C
      RETURN
      END

C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE BUENS2( KSEC1,KSEC2,KBUFL,KBUFF,KERR )
C
C**** *BUENS2*
C
C
C     PURPOSE.
C     --------
C          PACK SECTION 2 OF BUFR MESSAGE.
C
C
C**   INTERFACE.
C     ----------
C
C          *CALL* *BUENS2(KSEC1,KSEC2,KBUFL,KBUFF,KERR)*
C
C
C        INPUT :
C               *KSEC1*   -  ARRAY CONTAINING SECTION 1 INFORMATION
C                            KSEC1( 1)-- LENGTH OF SECTION 1 (BYTES)
C                            KSEC1( 2)-- BUFR EDITION NUMBER
C                            KSEC1( 3)-- ORIGINATING CENTRE
C                            KSEC1( 4)-- UPDATE SEQUENCE NUMBER
C                            KSEC1( 5)-- FLAG (PRESENCE OF SECTION 2)
C                            KSEC1( 6)-- BUFR MESSAGE TYPE
C                            KSEC1( 7)-- BUFR MESSAGE SUBTYPE
C                            KSEC1( 8)-- VERSION NUMBER OF LOCAL TABLE USED
C                            KSEC1( 9)-- YEAR
C                            KSEC1(10)-- MONTH
C                            KSEC1(11)-- DAY
C                            KSEC1(12)-- HOUR
C                            KSEC1(13)-- MINUTE
C                            KSEC1(14)-- BUFR MASTER TABLE
C                            KSEC1(15)-- VERSION NUMBER OF MASTER TABLE USED
C                            KSEC1(16) TO KSEC1(JSEC1) - LOCAL ADP CENTRE
C                                        INFORMATION(PACKED FORM)
C
C                            FOR BUFR EDITION 3 ONWARD
C
C                            KSEC1(16)-- ORIGINATING SUB-CENTRE
C                            KSEC1(17)-- NOT USED
C                            KSEC1(18) TO KSEC1(JSEC1) - LOCAL ADP CENTRE
C                                        INFORMATION(PACKED FORM)
C
C                            FOR BUFR EDITION 4 ONWARD
C
C                            KSEC1(16)-- ORIGINATING SUB-CENTRE
C                            KSEC1(17)-- INTERNATIONAL SUB-CATEGORY (SEE COMMON TABLE C-13
C                            KSEC1(18)-- SECOND
C                            KSEC1(19)-- YEAR
C                            KSEC1(20)-- MONTH
C                            KSEC1(21)-- DAY
C                            KSEC1(22)-- HOUR
C                            KSEC1(23)-- MINUTE
C                            KSEC1(24)-- SECOND
C                            KSEC1(25)-- YEAR
C                            KSEC1(26)-- MONTH
C                            KSEC1(27)-- DAY
C                            KSEC1(28)-- HOUR
C                            KSEC1(29)-- MINUTE
C                            KSEC1(30)-- SECOND
C                            KSEC1(31)-- MOST SOUTHERN LATITUDE  (-90 to 90)
C                            KSEC1(32)-- MOST WESTERN LONGITUDE  ( 0-360)
C                            KSEC1(33)-- MOST NORTHEN LATITUDE   (-90 to 90)
C                            KSEC1(34)-- MOST EASTERN LONGITUDE  ( 0-360)
C                            KSEC1(35) TO KSEC1(JSEC1) - LOCAL ADP CENTRE INFORMATION(PACKED FORM)
C
C               *KSEC2*   -  ARRAY CONTAINING SECTION 2 INFORMATION
C                            KSEC2( 1)-- LENGTH OF SECTION 2 (BYTES)
C                            KSEC2( 2) TO KSEC2(JSEC2) LOCAL ADP CENTRE
C                                         INFORMATION (PACKED FORM)
C        OUTPUT :
C               *KBUFL*   -  LENGTH OF BUFR MESSAGE (WORDS)
C               *KBUFF*   -  ARRAY CONTAINING BUFR MESSAGE
C               *KERR*    -  RETURNED ERROR CODE
C
C     METHOD.
C     -------
C
C
C
C     EXTERNALS.
C     ----------
C
C          BUPCK          - PACK BIT PATHERN
C          BUOCTN         - SET LENGTH OF SECTION
C
C     REFERENCE.
C     ----------
C
C          NONE.
C
C     AUTHOR.
C     -------
C
C          M. DRAGOSAVAC    *ECMWF*       17/01/91.
C
C
C     MODIFICATIONS.
C     --------------
C
C          NONE.
C
C
      IMPLICIT LOGICAL(L,O,G), CHARACTER*8(C,H,Y)
C
C
#     include "parameter.F"
#     include "bcomunit.F"
#     include "bcmwork.F"
C
      DIMENSION KBUFF(KBUFL)
      DIMENSION KSEC1(JSEC1),KSEC2(JSEC2)
      DIMENSION IDUM(8),     ISEC2(JSEC2)
#ifndef R_4
      REAL*8 RVIND
      REAL*8 EPS
#else
      REAL   RVIND
      REAL   EPS
#endif
C
      DATA IDUM/8*0/
C
C     ------------------------------------------------------------------
C*          1.  EXPAND SECTION 2.
C               -----------------
 100  CONTINUE
C
      IF( KERR.NE.0 ) RETURN
C
      DO 101 I=1,JSEC2
      ISEC2(I)=0
 101  CONTINUE
C
      IF(KSEC1(5) .NE. 0 .AND. KSEC1(5) .NE.128) THEN
         KERR=50
         CALL BUERR(KERR)
         RETURN
      END IF
C
      IF( KSEC1(5).EQ.0) RETURN
C
C*          1.1  KEEP POINTERS TO THE BEGINING OF THE SECTION.
C                ---------------------------------------------
 110  CONTINUE
C
      IWPTB = NWPT
      IBPTB = NBPT
C
C*          1.2  PACK LENGTH OF SECTION 2.
C                -------------------------
      CALL BUPCK(NBPW,KBUFF(NWPT),0,NWPT,NBPT,24,KERR)
      IF(KERR.GT.0) THEN
         WRITE(KNTN,*) 'ERROR PACKING LENGTH OF SECTION 2.'
         RETURN
      END IF
      CALL BUPCK(NBPW,KBUFF(NWPT),0,NWPT,NBPT, 8,KERR)
      IF(KERR.GT.0) RETURN
C
C
C*          1.3  LOCAL ADP CENTRE INFORMATION.
C                -----------------------------
C
      IOFF=KSEC2(1)-4
      IF(IOFF.GT.0) THEN
         IW=2
         IB=0
         CALL BUNPKS(NBPW,KSEC2,ISEC2,IW,IB,8,0,IOFF,KERR)
         IF(KERR.GT.0) THEN
            WRITE(KNTN,*) 'ERROR PACKING LOCAL ADP CENTRE INFORMATION'
            WRITE(KNTN,*) 'IN SECTION 2.'
            RETURN
         END IF
C
         CALL BUPKS(NBPW,KBUFF(NWPT),ISEC2,NWPT,NBPT,8,0,IOFF,KERR)
         IF(KERR.GT.0) THEN
            WRITE(KNTN,*) 'ERROR PACKING LOCAL ADP CENTRE INFORMATION'
            WRITE(KNTN,*) 'IN SECTION 2.'
            RETURN
         END IF
      END IF
C
C
C*          1.5  SET UP LENGTH OF THE SECTION 2.
C                --------------------------------
 150  CONTINUE
C
      CALL BUOCTN(IWPTB,IBPTB,KBUFL,KBUFF,KERR)
      IF(KERR.GT.0) RETURN
C
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE BUPRS2(KSUP,KEY)
C
C**** *BUPRS2*
C
C
C     PURPOSE.
C     --------
C           PRINT SECTION 2 OF BUFR MESSAGE (EXPANDED RDB KEY).
C
C
C**   INTERFACE.
C     ----------
C
C           *CALL* *BUPRS2(KSUP,KEY)*
C
C        INPUT :
C               *KSUP*    -  ARRAY CONTAINING SUPLEMENTARY INFORMATION
C                         -  KSUP( 1) -- IDIM1, DIMENSION OF KSEC1
C                         -  KSUP( 2) -- IDIM2, DIMENSION OF KSEC2
C                         -  KSUP( 3) -- IDIM3, DIMENSION OF KSEC3
C                         -  KSUP( 4) -- IDIM4, DIMENSION OF KSEC4
C                         -  KSUP( 5) -- M (NUMBER OF ELEMENTS IN VALUES ARRAY,
C                                           FIRST INDEX)
C                         -  KSUP( 6) -- N (NUMBER OF SUBSETS,SECOND INDEX OF
C                                           VALUES ARRAY)
C                         -  KSUP( 7) -- JVC (NUMBER OF ELEMENTS IN CVAL ARRAY)
C                         -  KSUP( 8) -- TOTAL BUFR MESSAGE LENGTH IN BYTES
C                         -  KSUP( 9) -- IDIM0, DIMENSION OF KSEC0
C               *KEY*     -  ARRAY CONTAINING SECTION 2 INFORMATION
C                            KEY( 1)-- LENGTH OF SECTION 2 (BYTES)
C                            KEY( 2)-- RDB TYPE
C                            KEY( 3)-- RDB SUBTYPE
C                            KEY( 4)-- YEAR
C                            KEY( 5)-- MONTH
C                            KEY( 6)-- DAY
C                            KEY( 7)-- HOUR
C                            KEY( 8)-- MINUTE
C                            KEY( 9)-- SECOND
C                            KEY(10)-- LONGITUDE1
C                            KEY(11)-- LATITUDE1
C                            KEY(12)-- LONGITUDE2
C                            KEY(13)-- LATITUDE2
C                            KEY(14)-- NUMBER OF SUBSETS
C                            KEY(15)-- IDENT (NUMERIC)
C                            KEY(16)-- IDENT ( CCITTIA5) ONE CHARACTER
C                            KEY(17)-- IDENT ( CCITTIA5) ONE CHARACTER
C                            KEY(18)-- IDENT ( CCITTIA5) ONE CHARACTER
C                            KEY(19)-- IDENT ( CCITTIA5) ONE CHARACTER
C                            KEY(20)-- IDENT ( CCITTIA5) ONE CHARACTER
C                            KEY(21)-- IDENT ( CCITTIA5) ONE CHARACTER
C                            KEY(22)-- IDENT ( CCITTIA5) ONE CHARACTER
C                            KEY(23)-- IDENT ( CCITTIA5) ONE CHARACTER
C                            KEY(24)-- IDENT ( CCITTIA5) ONE CHARACTER
C                            KEY(25)-- TOTAL BUFR MESSAGE LENGTH
C                            KEY(26)-- DAY    (RDB INSERTION)
C                            KEY(27)-- HOUR   (RDB INSERTION)
C                            KEY(28)-- MINUTE (RDB INSERTION)
C                            KEY(29)-- SECOND (RDB INSERTION)
C                            KEY(30)-- DAY    (MDB INSERTION)
C                            KEY(31)-- HOUR   (MDB INSERTION)
C                            KEY(32)-- MINUTE (MDB INSERTION)
C                            KEY(33)-- SECOND (MDB INSERTION)
C                            KEY(34)-- CORRECTION NUMBER
C                            KEY(35)-- PART
C                            KEY(36)-- 0
C                            KEY(37)-- CORRECTION NUMBER
C                            KEY(38)-- PART
C                            KEY(39)-- 0
C                            KEY(40)-- CORRECTION NUMBER
C                            KEY(41)-- PART
C                            KEY(42)-- 0
C                            KEY(43)-- CORRECTION NUMBER
C                            KEY(44)-- PART
C                            KEY(45)-- 0
C                            KEY(46)-- THE LOWEST Q/C % CONFIDENCE
C
C
C
C
C     METHOD.
C     -------
C
C            NONE
C
C     EXTERNALS.
C     ----------
C
C            NONE.
C
C     REFERENCE.
C     ----------
C
C          NONE.
C
C     AUTHOR.
C     -------
C
C          M. DRAGOSAVAC    *ECMWF*       04/02/91.
C
C     MODIFICATIONS.
C     --------------
C
C          NONE.
C
      IMPLICIT LOGICAL(L,O,G), CHARACTER*8(C,H,Y)
C
C
#     include "parameter.F"
#     include "bcomunit.F"
C
      DIMENSION KSUP(JSUP),KEY(JKEY)
C
#ifndef R_4
      REAL*8 RLAT1
      REAL*8 RLON1
      REAL*8 RLAT2
      REAL*8 RLON2
#else
      REAL   RLAT1
      REAL   RLON1
      REAL   RLAT2
      REAL   RLON2
#endif
C
      CHARACTER*9  CIDENT
      CHARACTER*13 YFM
C
C     ------------------------------------------------------------------
C
C*          1.   PRINT SECTION 2.
C                ----------------
 100  CONTINUE
C
      YFM='(1H ,A,TR0,A)'
C
      IF(KSUP(2).LE.1) THEN
         WRITE(KNTN,*)  'PRTKEY : RDB KEY NOT DEFINED IN SECTION 2.'
         RETURN
      END IF
C
      WRITE(KNTN,'(1H1)')
C
      WRITE(KNTN,'(1H ,A)')       '        BUFR SECTION 2    '
      WRITE(KNTN,'(1H )')
      WRITE(KNTN,'(1H ,A,I9)')    'LENGTH OF SECTION 2       ', KEY(1)
      WRITE(KNTN,'(1H )')
      WRITE(KNTN,'(1H ,A)')       '      REPORT DATA BASE KEY  '
      WRITE(KNTN,'(1H )')
C
      IKTYPE=0
      IF(KEY(2).EQ.2) IKTYPE=2
      IF(KEY(2).EQ.3) IKTYPE=2
      IF(KEY(2).EQ.12)IKTYPE=2
      IF(KEY(2).EQ.08)IKTYPE=2
      IF(IKTYPE.EQ.0.AND.KSUP(6).GT.1) IKTYPE=2
C
      IF(IKTYPE.EQ.2) THEN
C      IF(KEY(2).EQ.2.OR.KEY(2).EQ.3.OR.KEY(2).EQ.12) THEN
C
         WRITE(KNTN,'(1H ,A,I9)') 'RDB DATA TYPE             ', KEY(2)
         WRITE(KNTN,'(1H ,A,I9)') 'RDB DATA SUBTYPE          ', KEY(3)
         WRITE(KNTN,'(1H ,A,I9)') 'YEAR                      ', KEY(4)
         WRITE(KNTN,'(1H ,A,I9)') 'MONTH                     ', KEY(5)
         WRITE(KNTN,'(1H ,A,I9)') 'DAY                       ', KEY(6)
         WRITE(KNTN,'(1H ,A,I9)') 'HOUR                      ', KEY(7)
         WRITE(KNTN,'(1H ,A,I9)') 'MINUTE                    ', KEY(8)
         WRITE(KNTN,'(1H ,A,I9)') 'SECOND                    ', KEY(9)
         RLAT1=(KEY(11)-9000000)/100000.
         RLON1=(KEY(10)-18000000)/100000.
         WRITE(KNTN,'(1H ,A,F9.2)')'LATITUDE  1               ', RLAT1
         WRITE(KNTN,'(1H ,A,F9.2)')'LONGITUDE 1               ', RLON1
         RLAT2=(KEY(13)-9000000)/100000.
         RLON2=(KEY(12)-18000000)/100000.
         WRITE(KNTN,'(1H ,A,F9.2)')'LATITUDE  2               ', RLAT2
         WRITE(KNTN,'(1H ,A,F9.2)')'LONGITUDE 2               ', RLON2
         WRITE(KNTN,'(1H ,A,I9)') 'NUMBER OF OBSERVATIONS    ', KEY(14)
         WRITE(KNTN,'(1H ,A,I9)') 'IDENTIFIER                ', KEY(15)
         WRITE(KNTN,'(1H ,A,I9)') 'TOTAL BUFR MESSAGE LENGTH ', KEY(25)
         WRITE(KNTN,'(1H ,A,I9)') 'DAY    (RDB INSERTION)    ', KEY(26)
         WRITE(KNTN,'(1H ,A,I9)') 'HOUR   (RDB INSERTION)    ', KEY(27)
         WRITE(KNTN,'(1H ,A,I9)') 'MINUTE( (RDB INSERTION)   ', KEY(28)
         WRITE(KNTN,'(1H ,A,I9)') 'SECOND (RDB INSERTION)    ', KEY(29)
         WRITE(KNTN,'(1H ,A,I9)') 'DAY    (MDB ARRIVAL)      ', KEY(30)
         WRITE(KNTN,'(1H ,A,I9)') 'HOUR   (MDB ARRIVAL)      ', KEY(31)
         WRITE(KNTN,'(1H ,A,I9)') 'MINUTE (MDB ARRIVAL)      ', KEY(32)
         WRITE(KNTN,'(1H ,A,I9)') 'SECOND (MDB ARRIVAL       ', KEY(33)
         WRITE(KNTN,'(1H ,A,I9)') 'CORRECTION NUMBER         ', KEY(34)
         WRITE(KNTN,'(1H ,A,I9)') 'PART OF MESSAGE           ', KEY(35)
         WRITE(KNTN,'(1H ,A,I9)') 'CORRECTION NUMBER         ', KEY(37)
         WRITE(KNTN,'(1H ,A,I9)') 'PART OF MESSAGE           ', KEY(38)
         WRITE(KNTN,'(1H ,A,I9)') 'CORRECTION NUMBER         ', KEY(40)
         WRITE(KNTN,'(1H ,A,I9)') 'PART OF MESSAGE           ', KEY(41)
         WRITE(KNTN,'(1H ,A,I9)') 'CORRECTION NUMBER         ', KEY(43)
         WRITE(KNTN,'(1H ,A,I9)') 'PART OF MESSAGE           ', KEY(44)
         WRITE(KNTN,'(1H ,A,I9)') 'QUALITY CONTROL % CONF    ', KEY(46)
      ELSE
         WRITE(KNTN,'(1H ,A,I9)') 'RDB DATA TYPE             ', KEY(2)
         WRITE(KNTN,'(1H ,A,I9)') 'RDB DATA SUBTYPE          ', KEY(3)
         WRITE(KNTN,'(1H ,A,I9)') 'YEAR                      ', KEY(4)
         WRITE(KNTN,'(1H ,A,I9)') 'MONTH                     ', KEY(5)
         WRITE(KNTN,'(1H ,A,I9)') 'DAY                       ', KEY(6)
         WRITE(KNTN,'(1H ,A,I9)') 'HOUR                      ', KEY(7)
         WRITE(KNTN,'(1H ,A,I9)') 'MINUTE                    ', KEY(8)
         WRITE(KNTN,'(1H ,A,I9)') 'SECOND                    ', KEY(9)
         RLAT1=(KEY(11)-9000000)/100000.
         RLON1=(KEY(10)-18000000)/100000.
         WRITE(KNTN,'(1H ,A,F9.2)')'LATITUDE  1               ', RLAT1
         WRITE(KNTN,'(1H ,A,F9.2)')'LONGITUDE 1               ', RLON1
         IDD=0
         CIDENT=' '
         DO 201 ID=16,24
         IDD=IDD+1
         CIDENT(IDD:IDD)=CHAR(KEY(ID))
 201     CONTINUE
         IDD=INDEX(CIDENT,' ')
         IF(IDD.EQ.0) THEN
            YFM='(1H ,A,TR1,A)'
            GO TO 203
         END IF
         IDD=10-IDD
         WRITE(YFM(10:10),'(I1)',ERR=202) IDD
         GO TO 203
 202     YFM(10:10)='9'
 203     WRITE(KNTN,FMT=YFM)      'IDENTIFER                 ', CIDENT
         WRITE(KNTN,'(1H ,A,I9)') 'TOTAL BUFR MESSAGE LENGTH ', KEY(25)
         WRITE(KNTN,'(1H ,A,I9)') 'DAY    (RDB INSERTION)    ', KEY(26)
         WRITE(KNTN,'(1H ,A,I9)') 'HOUR   (RDB INSERTION)    ', KEY(27)
         WRITE(KNTN,'(1H ,A,I9)') 'MINUTE (RDB INSERTION)    ', KEY(28)
         WRITE(KNTN,'(1H ,A,I9)') 'SECOND (RDB INSERTION)    ', KEY(29)
         WRITE(KNTN,'(1H ,A,I9)') 'DAY    (MDB ARRIVAL)      ', KEY(30)
         WRITE(KNTN,'(1H ,A,I9)') 'HOUR   (MDB ARRIVAL)      ', KEY(31)
         WRITE(KNTN,'(1H ,A,I9)') 'MINUTE (MDB ARRIVAL)      ', KEY(32)
         WRITE(KNTN,'(1H ,A,I9)') 'SECOND (MDB ARRIVAL       ', KEY(33)
         WRITE(KNTN,'(1H ,A,I9)') 'CORRECTION NUMBER         ', KEY(34)
         WRITE(KNTN,'(1H ,A,I9)') 'PART OF MESSAGE           ', KEY(35)
         WRITE(KNTN,'(1H ,A,I9)') 'CORRECTION NUMBER         ', KEY(37)
         WRITE(KNTN,'(1H ,A,I9)') 'PART OF MESSAGE           ', KEY(38)
         WRITE(KNTN,'(1H ,A,I9)') 'CORRECTION NUMBER         ', KEY(40)
         WRITE(KNTN,'(1H ,A,I9)') 'PART OF MESSAGE           ', KEY(41)
         WRITE(KNTN,'(1H ,A,I9)') 'CORRECTION NUMBER         ', KEY(43)
         WRITE(KNTN,'(1H ,A,I9)') 'PART OF MESSAGE           ', KEY(44)
         WRITE(KNTN,'(1H ,A,I9)') 'QUALITY CONTROL % CONF    ', KEY(46)
      END IF
C
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities
C granted to it by virtue of its status as an intergovernmental organisation
C nor does it submit to any jurisdiction.
C

      SUBROUTINE ROWINA2( P, KO, KI, PW, KCODE, PMSVAL, KRET)
C
C---->
C**** ROWINA2 - Interpolation of row of values.
C
C     Purpose.
C     --------
C
C     Interpolate a row of values.
C
C
C**   Interface.
C     ----------
C
C     CALL ROWINA2( P, KO, KI, PW, KCODE, PMSVAL, KRET)
C
C
C     Input Parameters.
C     -----------------
C
C     P      - Row of values to be interpolated.
C              Dimension must be at least KO.
C
C     KO     - Number of values required.
C
C     KI     - Number of values in P on input.
C
C     PW     - Working array.
C              Dimension must be at least (0:KO+2,3).
C
C     KCODE  - Interpolation required.
C              1 , linear.
C              3 , cubic.
C
C     PMSVAL - Value used for missing data indicator.
C
C
C     Output Parameters.
C     ------------------
C
C     P     - Now contains KO values.
C     KRET  - Return code
C             0, OK
C             Non-zero, error
C
C
C     Method.
C     -------
C
C     Linear or cubic interpolation performed as required.
C
C
C     Externals.
C     ----------
C
C     SCM0
C
C
C     Reference.
C     ----------
C
C     None.
C
C
C     Comments.
C     ---------
C
C     This is a version of ROWINA which allows for missing data
C     values and hence for bitmapped fields.
C
C
C     Author.
C     -------
C
C     J.D.Chambers    ECMWF     22.07.94
C
C
C     Modifications.
C     --------------
C
C     J.D.Chambers    ECMWF     13.09.94
C     Add return code KRET and remove calls to ABORT.
C
C
C     -----------------------------------------------------------------
C----<
C
C*******************************************************************
C     Section 0.  Declarations.
C*******************************************************************
C
      IMPLICIT NONE
C
C     Subroutine arguments
      REAL P, PW, PMSVAL
      INTEGER KO,KI,KCODE, KRET
      DIMENSION P(KO),PW(0:KO+2,3)
C
C     Local variables
      INTEGER JL, IP
      REAL ZRDI, ZDO, ZPOS, ZWT, ZWT1
C
C*******************************************************************
C     Section 1.  Linear interpolation ..
C*******************************************************************
C
  100 CONTINUE
C
      KRET = 0
C
      IF( KCODE.EQ.1 ) THEN
C
C        Move input values to work array
         DO 110 JL = 1, KI
            PW(JL,1) = P(JL)
  110    CONTINUE
C
C        Arrange wrap-around value in work array
         PW(KI+1,1) = P(1)
C
C        Set up constants to be used to figure out weighting for
C        values in interpolation.
         ZRDI = FLOAT(KI)
         ZDO  = 1.0 / FLOAT(KO)
C
C        Loop through the output points
         DO 120 JL = 1, KO
C
C           Calculate weight from the start of row
            ZPOS = (JL-1) * ZDO
            ZWT  = ZPOS * ZRDI
C
C           Get the current array position(minus 1) from the weight -
C           note the implicit truncation.
            IP   = ZWT
C
C           If the left value is missing, use the right value
            IF ( PW(IP+1,1) .EQ. PMSVAL ) THEN
               P(JL) = PW(IP+2,1)
C
C           If the right value is missing, use the left value
            ELSE IF ( PW(IP+2,1) .EQ. PMSVAL ) THEN
               P(JL) = PW(IP+1,1)
C
C           If neither missing, interpolate ...
            ELSE
C
C             Adjust the weight to range (0.0 to 1.0)
              ZWT  = ZWT - IP
C
C             Interpolate using the weighted values on either side
C             of the output point position
              P(JL) = (1.0-ZWT) * PW(IP+1,1) + ZWT * PW(IP+2,1)
            ENDIF
C
  120    CONTINUE
C
C*******************************************************************
C     Section 2.  Cubic interpolation ..
C*******************************************************************
C
  200 CONTINUE
C
      ELSEIF(KCODE.EQ.3) THEN
         DO 210 JL = 1,KI
            IF ( P(JL) .EQ. PMSVAL ) THEN
              WRITE(*,*) ' ROWINA2: Cubic interpolation not supported'
              WRITE(*,*) ' ROWINA2: for fields containing missing data.'
              WRITE(*,*) ' Sorry!'
              KRET = 1
              GOTO 900
            ENDIF
            PW(JL,1) = P(JL)
  210    CONTINUE
         PW(0,1) = P(KI)
         PW(KI+1,1) = P(1)
         PW(KI+2,1) = P(2)
         DO 220 JL = 1,KI
            PW(JL,2) =  - PW(JL-1,1)/3.0 - 0.5*PW(JL,1)
     1             + PW(JL+1,1)    - PW(JL+2,1)/6.0
            PW(JL+1,3) =    PW(JL-1,1)/6.0 - PW(JL,1)
     1             + 0.5*PW(JL+1,1) + PW(JL+2,1)/3.0
  220    CONTINUE
         CALL SCM0(PW(1,2),PW(2,3),PW(1,1),PW(2,1),KI)
         ZRDI = FLOAT(KI)
         ZDO = 1.0/FLOAT(KO)
         DO 230 JL = 1,KO
            ZPOS = (JL-1)*ZDO
            ZWT = ZPOS*ZRDI
            IP = ZWT+1
            ZWT = ZWT+1.0-IP
            ZWT1  =  1.0 - ZWT
            P(JL) = ((3.0-2.0*ZWT1)*PW(IP,1) + ZWT*PW(IP,2))*ZWT1*ZWT1
     1       + ((3.0-2.0*ZWT) *PW(IP+1,1) - ZWT1*PW(IP+1,3))*ZWT*ZWT
  230    CONTINUE
C
      ELSE
C
C*******************************************************************
C     Section 3.  Invalid interpolation code ..
C*******************************************************************
C
  300   CONTINUE
C
        WRITE (*,9001) KCODE
        KRET = 2
      ENDIF
C
C*******************************************************************
C     Section 9.  Closedown.
C*******************************************************************
C
900   CONTINUE
      RETURN
C
 9001 FORMAT (1H ,'ROWINA2 : Invalid interpolation code = ',I4)
C
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C


      SUBROUTINE PRTBL1 (IB1PAR)
C
C---->
C**************************************************************
C*
C*    NAME      : PRTBL1
C*
C*    FUNCTION  : PRINT THE INFORMATION IN THE PRODUCT DEFINITION
C*                BLOCK (BLOCK 1) OF DECODED GRIB DATA.
C*
C*    INPUT     : IB1PAR - ARRAY OF DECODED PARAMETERS FROM BLOCK 1.
C*
C*    JOHN HENNESSY  ECMWF 28 MAY 1985
C*
C*
C**************************************************************
C----<
C
      DIMENSION IB1PAR(*)
C
      WRITE (*,9000)
 9000 FORMAT (1H0,'BLOCK 1 - PRODUCT DEFINITION BLOCK',/)
C
      WRITE (*,9001) IB1PAR(1)
 9001 FORMAT (1H0,'ORIGINATING CENTRE IDENTIFIER.       ',I9)
      WRITE (*,9002) IB1PAR(2)
 9002 FORMAT (1H ,'MODEL IDENTIFICATION.                ',I9)
      WRITE (*,9003) IB1PAR(3)
 9003 FORMAT (1H ,'GRID DEFINITION.                     ',I9)
      WRITE (*,9004) IB1PAR(4)
 9004 FORMAT (1H ,'FLAG (CODE TABLE 1)                  ',I9)
      WRITE (*,9005) IB1PAR(5)
 9005 FORMAT (1H ,'PARAMETER IDENTIFIER (CODE TABLE 2). ',I9)
      WRITE (*,9006) IB1PAR(6)
 9006 FORMAT (1H ,'TYPE OF LEVEL (CODE TABLE 3).        ',I9)
      WRITE (*,9007) IB1PAR(7)
 9007 FORMAT (1H ,'VALUE 1 OF LEVEL (CODE TABLE 3).     ',I9)
      WRITE (*,9008) IB1PAR(8)
 9008 FORMAT (1H ,'VALUE 2 OF LEVEL (CODE TABLE 3).     ',I9)
      WRITE (*,9009) IB1PAR(9)
 9009 FORMAT (1H ,'YEAR OF DATA.                        ',I9)
      WRITE (*,9010) IB1PAR(10)
 9010 FORMAT (1H ,'MONTH OF DATA.                       ',I9)
      WRITE (*,9011) IB1PAR(11)
 9011 FORMAT (1H ,'DAY OF DATA.                         ',I9)
      WRITE (*,9012) IB1PAR(12)
 9012 FORMAT (1H ,'HOUR OF DATA.                        ',I9)
      WRITE (*,9013) IB1PAR(13)
 9013 FORMAT (1H ,'MINUTE OF DATA.                      ',I9)
      WRITE (*,9014) IB1PAR(14)
 9014 FORMAT (1H ,'TIME UNIT (CODE TABLE 4).            ',I9)
      WRITE (*,9015) IB1PAR(15)
 9015 FORMAT (1H ,'TIME RANGE ONE.                      ',I9)
      WRITE (*,9016) IB1PAR(16)
 9016 FORMAT (1H ,'TIME RANGE TWO.                      ',I9)
      WRITE (*,9017) IB1PAR(17)
 9017 FORMAT (1H ,'TIME RANGE FLAG (CODE TABLE 5).      ',I9)
C
      RETURN
C
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities
C granted to it by virtue of its status as an intergovernmental organisation
C nor does it submit to any jurisdiction.
C

      SUBROUTINE JNUMGG( KNUM, HTYPE, KPTS, KRET)
C
C---->
C**** JNUMGG
C
C     PURPOSE
C     _______
C
C     This routine returns the number of points in each latitude of
C     a gaussian grid.
C
C
C     INTERFACE
C     _________
C
C     CALL JNUMGG( KNUM, HTYPE, KPTS, KRET)
C
C
C     Input parameters
C     ________________
C
C     KNUM     - Gaussian grid number
C     HTYPE    - Gaussian grid type
C                = 'R' for reduced ("quasi-regular"),
C                = 'O' for reduced/octahedral,
C                = 'F' for full,
C                = 'U' for user-defined reduced gaussian grid
C
C
C     Output parameters
C     ________________
C
C     KPTS    - Array giving number of points at each gaussian latitude
C               (both hemispheres)
C     KRET     - Return status code
C                0 = OK
C
C     Common block usage
C     __________________
C
C     None.
C
C     Method
C     ______
C
C     Simplified interface to JGETGG.
C
C
C     Externals
C     _________
C
C     JGETGG     - Get the gaussian grid definition.
C     INTLOG   - Output log message
C
C
C     Reference
C     _________
C
C     None
C
C
C     Comments
C     ________
C
C     None
C
C
C     AUTHOR
C     ______
C
C     J.D.Chambers      *ECMWF*      Feb 1994
C
C
C     MODIFICATIONS
C     _____________
C
C     None.
C
C----<
C
      IMPLICIT NONE
#include "jparams.h"
#include "parim.h"
C
C     Subroutine arguments
C
      INTEGER KNUM, KPTS, KRET
      CHARACTER*1 HTYPE
      DIMENSION KPTS(*)
C
C     Parameters
      INTEGER JPROUTINE
      PARAMETER ( JPROUTINE = 30700 )
C
C     Local variables
C
      REAL ZLAT
      DIMENSION ZLAT(JPMAX)
C     _______________________________________________________
C
C*    Section 1.    Get the information.
C     _______________________________________________________
C
  100 CONTINUE
C
      KRET = 0
C
C     Make sure local array is big enough for return values.
C
      IF( KNUM .GT. (JPMAX/2) ) THEN
        CALL INTLOG(JP_ERROR,
     X    'JNUMGG - Local array too small for return values.',JPMAX/2)
        KRET = JPROUTINE + 1
        GOTO 900
      ENDIF
C
      CALL JGETGG(KNUM, HTYPE, ZLAT, KPTS, KRET)
C
C     _______________________________________________________
C
C*    Section 9. Return to calling routine. Format statements
C     _______________________________________________________
C
 900  CONTINUE
C
      RETURN
      END

C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C


      SUBROUTINE OFFSET  (IOFF,NVAL,IWORD,IBYTE,NBIT,ILEN,IERR)
C
C
C
C
C
C---->
C*
C*    NAME      : OFFSET
C:
C*    FUNCTION  : CALCULATES THE WORD AND BIT OFFSET OF THE START
C*                OF THE NEXT BIT-FIELD IN AN ARRAY OF BINARY
C*                DATA, FOLLOWING THE INSERTION/EXTRACTION OF ONE
C*                OR MORE CONSECUTIVE BIT-FIELDS.
C*
C*    INPUT     : IOFF  - BIT OFFSET AT WHICH LAST INSERTION OR
C*                        EXTRACTION STARTED.
C*                NVAL  - NUMBER OF FIELDS INSERTED OR EXTRACTED IN
C*                        LAST OPERATION.
C*                IWORD - WORD NUMBER OF ARRAY AT WHICH LAST OPERATION
C*                        STARTED.
C*                IBYTE - LENGTH, IN BITS, OF LAST FIELD(S) INSERTED
C*                        OR EXTRACTED.
C*                NBIT  - NUMBER OF BITS IN COMPUTER WORD.
C*                ILEN  - NUMBER OF WORDS IN ARRAY.
C*
C*    OUTPUT    : IOFF  - BIT OFFSET AT WHICH NEXT INSERTION OR
C*                        EXTRACTION STARTS.
C*                NVAL  - UNCHANGED.
C*                IWORD - WORD NUMBER OF ARRAY AT WHICH NEXT OPERATION
C*                        STARTS.
C*                IBYTE - UNCHANGED.
C*                NBIT  - UNCHANGED.
C*                ILEN  - UNCHANGED.
C*
C*                IERR  - EQUAL 0 IF NO ERROR.
C*                        EQUAL -2 IF NEXT OPERATION IS OUTSIDE ARRAY
C*                        BOUNDS.
C*
C*    GENERAL   : OFFSET CALLS -----
C*
C*    AUTHOR    : J.HENNESSY  15.4.85
C*
C*    MODIFIED  : J.HENNESSY  28.11.85
C*
C
C     ---------------------------------------------------------------
C----<
C
C
C
C     CLEAR ERROR INDICATOR
C
      IERR = 0
C
C
C
C
C
C
C
C
C
C
C     CALCULATE NEXT WORD AND BIT POSITIONS.
C
      IBITL = NVAL  * IBYTE
      INTER = IBITL / NBIT
      IOFFS = IBITL - INTER * NBIT
      IWORD = IWORD + INTER
      IOFF  = IOFF  + IOFFS
C
      IF (IOFF.GE.NBIT)
     C   THEN
             IWORD = IWORD + 1
             IOFF  = IOFF  - NBIT
         END IF
C
C
C
C
C
C
C
C
C     CHECK THAT NEXT WORD TO BE ACCESSED LIES WITHIN THE ARRAY BOUNDS.
C
      IF (IWORD.GT.ILEN)
     C   THEN
             IERR = -2
             WRITE (*,9001) IWORD,ILEN
 9001        FORMAT (1H ,'WORD ',I8,' IS OUTSIDE ARRAY BOUNDS ',I8)
         ENDIF
C
C
      RETURN
C
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      INTEGER FUNCTION NEWISL(OLDGEO,NEWGEO,OLDLSM,OLDFLD,MASTER,NEWFLD)
C
C---->
C**** NEWISL
C
C     Purpose
C     -------
C
C     Interpolate a field based on an old land-sea mask to a field
C     based on a different land-sea mask.
C
C
C     Interface
C     ---------
C
C     IRET = NEWISL(OLDGEO,NEWGEO,OLDLSM,OLDFLD,MASTER,NEWFLD)
C
C     Input
C     -----
C
C     OLDGEO - GRIB section 2 describing grid of old field.
C     NEWGEO - GRIB section 2 describing grid of new field.
C     OLDLSM - Array of land-sea mask values for old field.
C     OLDFLD - Array of values for old field.
C     MASTER - Array of land-sea mask values for new field.
C
C
C     Output
C     ------
C
C     NEWFLD - Array of values for new field.
C
C     Function returns:
C       - 0 if all is well
C       - 1, otherwise.
C
C
C     Method
C     ------
C
C     Build up field offsets from input geometries.
C     For each point of the new field, find in the old field the four
C     nearest neighbours' positions, values and types.
C     Calculate new value from the neighbours.
C
C
C     Externals
C     ---------
C
C     IGGLAT  - Compute gaussian lines of latitude.
C     JNORSGG - Find gaussian latitudes to north and south of latitude.
C     ISLPROC - Calculate value of new field point.
C     INTLOG  - Log messages
C
C
C     Author
C     ------
C
C     J.D.Chambers     ECMWF     August 2000
C
C----<
C
      IMPLICIT NONE
C
C     Function arguments
C
      INTEGER OLDGEO(*),NEWGEO(*)
      REAL OLDLSM(*),OLDFLD(*),MASTER(*),NEWFLD(*)
C
#include "intisl.h"
#include "parim.h"
C
C     Parameters
C
      INTEGER JPMAXLT, JPGAUSS, JP1000
      PARAMETER (JPMAXLT=721)
      PARAMETER (JPGAUSS=4)
      PARAMETER (JP1000=1000)
C
C     Local variables
C
      INTEGER TOTAL, NEXT, LOOP, NEWOFF(JPMAXLT), OLDOFF(JPMAXLT)
      INTEGER LATIT, LONG, NEWTYPE, IRET, NPTS
      INTEGER LAT(2), LON(4)
      INTEGER PT(4), TYPE(4)
      REAL OLAT(2), OLON(4)
      REAL RLATOLD(JPMAXLT), RLATNEW(JPMAXLT), RLAT, RLON
C
C     Externals
C
      INTEGER IGGLAT, JNORSGG
      REAL ISLPROC
      EXTERNAL IGGLAT, JNORSGG, ISLPROC
C
C     -----------------------------------------------------------------|
C*    Section 1.   Build working values using input geometries.
C     -----------------------------------------------------------------|
C
  100 CONTINUE
C
      NEWISL = 0
C
C     -----------------------------------------------------------------|
C*    Section 2.   Calculate number of points in new field and offset
C                  to start of each latitude in the new grid
C     -----------------------------------------------------------------|
C
  200 CONTINUE
C
      IF( NEWGEO(1).EQ.JPGAUSS ) THEN
C
C       New field is gaussian
C
        CALL INTLOG(JP_DEBUG,'NEWISL: New field is gaussian',JPQUIET)
C
        IF( NEWGEO(17).EQ.0 ) THEN
          CALL INTLOG(JP_DEBUG,'NEWISL: New field is regular',JPQUIET)
          TOTAL = NEWGEO(2)*NEWGEO(3)
          NEWOFF(1) = 0
          DO LOOP = 2, NEWGEO(NJ)
            NEWOFF(LOOP) = NEWOFF(LOOP-1) + NEWGEO(2)
          ENDDO
        ELSE
          CALL INTLOG(JP_DEBUG,'NEWISL: New field is reduced',JPQUIET)
          NEWOFF(1) = 0
          TOTAL = NEWGEO(NPOINTS)
          DO LOOP = 2, NEWGEO(NJ)
            NEWOFF(LOOP) = NEWOFF(LOOP-1) + NEWGEO(NPOINTS-2+LOOP)
            TOTAL = TOTAL + NEWGEO(NPOINTS-1+LOOP)
          ENDDO
        ENDIF
C
C       Get the gaussian latitudes for the new field
C
        IRET = IGGLAT(NEWGEO(NGAUSS)*2,RLATNEW,0,-1)
        IF( IRET.NE.0 ) THEN
          WRITE(*,*) 'NEWISL: Problem call igglat for new grid'
          NEWISL = 1
          RETURN
        ENDIF
C
      ELSE
C
C       New field is lat/long
C
        CALL INTLOG(JP_DEBUG,'NEWISL: New field is lat/long',JPQUIET)
        TOTAL = NEWGEO(2)*NEWGEO(3)
        DO LOOP = 1, NEWGEO(3)
          NEWOFF(LOOP) = NEWGEO(2)*(LOOP-1)
          RLATNEW(LOOP) = 90.0 - (REAL((LOOP-1)*NEWGEO(10))/JP1000)
        ENDDO
C
      ENDIF
C
      CALL INTLOG(JP_DEBUG,'NEWISL: No. of pts in new field = ',TOTAL)
C
C     -----------------------------------------------------------------|
C*    Section 3.   Get the gaussian latitudes for the old field and
C                  setup the offsets to the start of each latitude.
C     -----------------------------------------------------------------|
C
  300 CONTINUE
C
      OLDOFF(1) = 0
      DO LOOP = 2, OLDGEO(NJ)
        OLDOFF(LOOP) = OLDOFF(LOOP-1) + OLDGEO(NPOINTS-2+LOOP)
      ENDDO
C
      IRET = IGGLAT(OLDGEO(NGAUSS)*2,RLATOLD,0,-1)
      IF( IRET.NE.0 ) THEN
        WRITE(*,*) 'NEWISL: Problem call igglat for old grid'
        NEWISL = 1
        RETURN
      ENDIF
C
C     -----------------------------------------------------------------|
C*    Section 4.   Work through the points in the new field.
C     -----------------------------------------------------------------|
C
  400 CONTINUE
C
      DO NEXT = 1, TOTAL
C
C       Calculate lat/long
C
        DO LOOP = 1, NEWGEO(NJ)
          IF( NEWOFF(LOOP).GE.NEXT ) THEN
            LATIT = LOOP - 1
            GOTO 410
          ENDIF
        ENDDO
        LATIT = NEWGEO(NJ)
C
  410   CONTINUE
C
        LONG = NEXT - NEWOFF(LATIT)
C
        RLAT = RLATNEW(LATIT)
        IF( NEWGEO(1).EQ.JPGAUSS ) THEN
          IF( NEWGEO(17).EQ.0 ) THEN
            RLON = REAL((LONG-1)*NEWGEO(9))/JP1000
          ELSE
            RLON = (REAL(LONG-1)*360.0)/REAL(NEWGEO(NPOINTS+LATIT-1))
          ENDIF
        ELSE
          RLON = REAL((LONG-1)*NEWGEO(9))/JP1000
        ENDIF
C
C       Find type of point (land or sea)
C
        IF( MASTER(NEXT).GT.MASTERTHRESHOLD ) THEN
          NEWTYPE = LAND
        ELSE
          NEWTYPE = SEA
        ENDIF
C
C       Find four neighbours in the old field with their types
C       (Find NW neighbour and deduce the others).
C
        LAT(NORTH) = JNORSGG(RLAT,RLATOLD,OLDGEO(NGAUSS),1)
        LAT(SOUTH) = JNORSGG(RLAT,RLATOLD,OLDGEO(NGAUSS),0)
C
        OLAT(NORTH) = RLATOLD(LAT(NORTH))
        OLAT(SOUTH) = RLATOLD(LAT(SOUTH))
C
        NPTS = OLDGEO(NPOINTS-1+LAT(NORTH))
        LON(NWEST) = 1 + INT(RLON/(360.0/REAL(NPTS)))
        LON(NEAST) = LON(NWEST) + 1
        IF( LON(NEAST).GT.NPTS ) LON(NEAST) = 1
C
        OLON(NWEST) = (REAL(LON(NWEST)-1)*360.0)/REAL(NPTS)
        IF( LON(NEAST).EQ.1 ) THEN
          OLON(NEAST) = 360.0
        ELSE
          OLON(NEAST) = (REAL(LON(NEAST)-1)*360.0)/REAL(NPTS)
        ENDIF
C
        NPTS = OLDGEO(NPOINTS-1+LAT(SOUTH))
        LON(SWEST) = 1 + INT(RLON/(360.0/REAL(NPTS)))
        LON(SEAST) = LON(SWEST) + 1
        IF( LON(SEAST).GT.NPTS ) LON(SEAST) = 1
C
        OLON(SWEST) = (REAL(LON(SWEST)-1)*360.0)/REAL(NPTS)
        IF( LON(SEAST).EQ.1 ) THEN
          OLON(SEAST) = 360.0
        ELSE
          OLON(SEAST) = (REAL(LON(SEAST)-1)*360.0)/REAL(NPTS)
        ENDIF
C
        PT(NWEST) = OLDOFF(LAT(NORTH)) + LON(NWEST)
        IF( OLDLSM(PT(NWEST)).GT.OLDLSMTHRESHOLD ) THEN
          TYPE(NWEST) = LAND
        ELSE
          TYPE(NWEST) = SEA
        ENDIF
C
        PT(NEAST) = OLDOFF(LAT(NORTH)) + LON(NEAST)
        IF( OLDLSM(PT(NEAST)).GT.OLDLSMTHRESHOLD ) THEN
          TYPE(NEAST) = LAND
        ELSE
          TYPE(NEAST) = SEA
        ENDIF
C
        PT(SWEST) = OLDOFF(LAT(SOUTH)) + LON(SWEST)
        IF( OLDLSM(PT(SWEST)).GT.OLDLSMTHRESHOLD ) THEN
          TYPE(SWEST) = LAND
        ELSE
          TYPE(SWEST) = SEA
        ENDIF
C
        PT(SEAST) = OLDOFF(LAT(SOUTH)) + LON(SEAST)
        IF( OLDLSM(PT(SEAST)).GT.OLDLSMTHRESHOLD ) THEN
          TYPE(SEAST) = LAND
        ELSE
          TYPE(SEAST) = SEA
        ENDIF
C
C       Interpolate the new value
C
        NEWFLD(NEXT) =
     X    ISLPROC(RLAT,RLON,NEWTYPE,OLAT,OLON,TYPE,PT,OLDFLD)
C
      ENDDO
C
C     -----------------------------------------------------------------|
C*    Section 9.   Return
C     -----------------------------------------------------------------|
C
  900 CONTINUE
C
C
      RETURN
      END

program ginout_c2
    use grib_api

    implicit none
    integer IARGC


    integer, parameter :: JPRLEN=8  ! for -DREAL_8, otherwise should be JPRLEN=4
    integer       F1, F2, r, IG
    character*256 N1, N2

    integer (kind=4) :: valuesN
    real    (kind=8) :: missingValue  ! TODO: nothing is done about the missing values
    real    (kind=8), dimension(:), allocatable :: values


    ! Get input/output files
    if (IARGC().lt.2) stop 'Usage: ginout_c2 inputfile outputfile'
    call getarg(1,N1)
    call getarg(2,N2)


    ! Open input file, get the 'values' array and close the file
    call grib_open_file(F1,N1,'r')
    call grib_new_from_file(F1,IG)

    call grib_get_size(IG,'values',valuesN)
    allocate(values(valuesN))
    call grib_get(IG,'values',values)

    call grib_get(IG,'missingValue',missingValue)
!   print *, 'missingValue=', missingValue

    call grib_release(IG)
    call grib_close_file(F1)


    ! Open output file
    open (unit=16, file=N2, status='UNKNOWN', form='UNFORMATTED', iostat=R)
    if (R.ne.0) stop 'Error: OPEN'


    ! Write the unpacked values
    R=1;  call pbopen  (F2,N2(1:index(N2,' ')-1), "W", R);  if (R.ne.0) stop 'Error: PBOPEN'
    R=0;  call pbwrite (F2,values,valuesN*JPRLEN,R);        if (R.lt.0) stop 'Error: PBWRITE'
    R=1;  call pbclose (F2,R);                              if (R.ne.0) stop 'Error: PBCLOSE'


    ! Cleanup
    deallocate(values)

end program

C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

       PROGRAM CREXEXP
C
C**** *CREXEXP*
C
C
C     PURPOSE.
C     --------
C         Expands list of CREX data descriptors.
C
C
C**   INTERFACE.
C     ----------
C
C          NONE.
C
C     METHOD.
C     -------
C
C          NONE.
C
C
C     EXTERNALS.
C     ----------
C
C
C     REFERENCE.
C     ----------
C
C          NONE.
C
C     AUTHOR.
C     -------
C
C          M. DRAGOSAVAC    *ECMWF*       07/01/2004.
C
C
C     MODIFICATIONS.
C     --------------
C
C          NONE.
C
C
      IMPLICIT LOGICAL(L,O,G), CHARACTER*8(C,H,Y)
C
      PARAMETER(JSEC1=40,JSEC3=4)
      PARAMETER (KDLEN=200,KELEM=4000)
C 
      DIMENSION KSEC1(JSEC1) 
C
      DIMENSION KDATA(KDLEN)
C
      CHARACTER*64 CNAMES(KELEM)
      CHARACTER*24 CUNITS(KELEM)
      CHARACTER*6  CREXKTDLST(KELEM)
      CHARACTER*6  CREXKTDEXP(KELEM)
C
      REAL*8 RVIND
C                                                                       
C
C     ------------------------------------------------------------------
C*          1. INITIALIZE CONSTANTS AND VARIABLES.
C              -----------------------------------
 100  CONTINUE
C
C
      RVIND=1.7E38
C
C     INITIALIZE DELAYED REPLICATION FACTORS 
C
      DO I=1,KDLEN
      KDATA(I)=1
      END DO
C
C     SET DATA DECSRIPTORS
C
      N=1
      CREXKTDLST( N)="D01090"
      N=N+1
      CREXKTDLST( N)="D02031"
      N=N+1
      CREXKTDLST( N)="D02032"
      N=N+1
      CREXKTDLST( N)="D02033"
      N=N+1
      CREXKTDLST( N)="D02004"
      N=N+1
      CREXKTDLST( N)="R01000"
      N=N+1
      CREXKTDLST( N)="D02005"
      N=N+1
      CREXKTDLST( N)="D02038"
      N=N+1
      CREXKTDLST( N)="D02044"
      N=N+1
      CREXKTDLST( N)="R01002"
      N=N+1
      CREXKTDLST( N)="D02039"
      N=N+1
      CREXKTDLST( N)="R02002"
      N=N+1
      CREXKTDLST( N)="B04024"
      N=N+1
      CREXKTDLST( N)="B13011"
      N=N+1
      CREXKTDLST( N)="B07032"
      N=N+1
      CREXKTDLST( N)="B04024"
      N=N+1
      CREXKTDLST( N)="B12111"
      N=N+1
      CREXKTDLST( N)="B04024"
      N=N+1
      CREXKTDLST( N)="B12112"
      N=N+1
      CREXKTDLST( N)="B07032"
      N=N+1
      CREXKTDLST( N)="B02002"
      N=N+1
      CREXKTDLST( N)="B08021"
      N=N+1
      CREXKTDLST( N)="B04025"
      N=N+1
      CREXKTDLST( N)="B11001"
      N=N+1
      CREXKTDLST( N)="B11002"
      N=N+1
      CREXKTDLST( N)="B08021"

      KTDLEN=N
C
C     SECTION 1 CONTENT
C
      KSEC1(2)=2     ! CREX EDITION NUMBER
      KSEC1(3)=98    ! Originating Centre ( oooo)
      KSEC1(4)=0     ! Update sequence number (uu)
      KSEC1(5)=1     ! Number of subsets ( sss)
      KSEC1(6)=0     ! CREX data category (nnn)
      KSEC1(7)=1     ! International data sub-category (mmm)
      KSEC1(8)=1     ! Version number of local table used
      KSEC1(9)=2004  ! Year
      KSEC1(10)=11   ! Month
      KSEC1(11)=29   ! Daay
      KSEC1(12)=12   ! Hour
      KSEC1(13)=00   ! Minute
      KSEC1(14)=0    ! CREX Master table (tt)
      KSEC1(15)=3    ! Version number of Master table used (vv)
      KSEC1(16)=0    ! Originating sub-centre (ppp)
      KSEC1(17)=12   ! Bufr master table version number
      KSEC1(18)=0    ! Bufr version number of local table used
C
C     SECTION 3 CONTENT
C
      K=1
      CALL CREXDES(K,KSEC1,KTDLEN,CREXKTDLST,KDLEN,KDATA,KELEM,
     1            KTDEXL,CREXKTDEXP,CNAMES,CUNITS,KERR)
C
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C


      SUBROUTINE ANALSW(IBLOCKS,LOGICS,ILENGL,INTEGS,ILENGI,
     S                  REALSW,ILENGR)
C---->
C
C     G.K.SAKELLARIDES  ECMWF        15/10/85.
C
C     PURPOSE.
C     --------
C
C          TO GET AS OUTPUT THE NAME AND CONTENT OF VARIABLES WHICH
C          APPEAR IN THE DECODED MARS MODEL SWITCH RECORD
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *ALALSW(IBLOCKS,LOGICS,ILENGL,INTEGS,ILENGI,REALSW,
C                        ILENGR)
C        WHERE:
C              INPUT PARAMETERS
C              1.*IBLOCKS* INTEGER ARRAY OF LENGTH 29 CONTAINING
C                          THE FOLLOWING INFORMATIONS OF BLOCK1.
C              2.*LOGICS* LOGICAL ARRAY  WHICH CONTAINS THE LOGICALS.
C              3.*ILENGL* ACTUAL LENGTH OF LOGICALS
C              4.*INSOUT* INTEGER ARRAY WHICH CONTAINS THE INTEGER
C              5.*ILENGI* ACTUAL LENGTH OF INTEGER
C              6.*REALSW* REAL ARRAY WHICH CONTAINS THE REALS.
C              7.*ILENGR* ACTUAL LENGTH OF REALS
C
C     EXTERNALS.
C     ----------
C
C         *NONE*
C----<
C
      CHARACTER *45,Y1(26),YL(26)
      CHARACTER *12,YY
      CHARACTER *45,YI1(6),YI2,YI3(14),YI4,YI5,YI6(10),YI7,YI8,YI9
      CHARACTER *45,YR1(2),YR2,YR3(53),YR4,YR5,YR6,YR7,YR8(26)
      DIMENSION INTEGS(*),REALSW(*),IBLOCKS(*)
      LOGICAL LOGICS(*)
      DATA YY/'   POSITION='/
      DATA (Y1(I),I=1,14)
     D       /'               G                            =',
     D        '               R                            =',
     D        '               I                            =',
     D        '               B                            =',
     D        'IDENTIFICATION OF CENTRE.                   =',
     D        'MODEL IDENTIFICATION                        =',
     D        'GRID DEFINITION                             =',
     D        'FLAG (CODE TABLE 1)                         =',
     D        'PARAM. INDICATING THE MARS MODEL SWITCH REC.=',
     D        'TYPE OF LEVEL (CODE TABLE 3)                =',
     D        'VALUE 1 OF LEVEL (CODE TABLE 3)             =',
     D        'VALUE 2 OF LEVEL (CODE TABLE 3)             =',
     D        'YEAR    OF INITIAL DATA                     =',
     D        'MONTH   OF INITIAL DATA                     ='/
      DATA (Y1(I),I=15,26)
     D       /'DAY     OF INITIAL DATA                     =',
     D        'HOUR    OF INITIAL DATA                     =',
     D        'MINUTE  OF INITIAL DATA                     =',
     D        'TIME UNIT (CODE TABLE 4)                    =',
     D        'TIME RANGE 1                                =',
     D        'TIME RANGE 2                                =',
     D        'TIME RANGE FLAG (CODE TABLE 5)              =',
     D        'LENGTH OF DATA BLOCK (OCTET)                =',
     D        'STARTING ADDRESS OF LOGICAL SECTION(OCTET)  =',
     D        'STARTING ADDRESS OF INTEGER SECTION(OCTET)  =',
     D        'STARTING ADDRESS OF REAL    SECTION(OCTET)  =',
     D        'LENGTH           OF REAL    SECTION(OCTET)  ='/
      DATA (YL(I),I=1,15)
     D       /'LZLS       LOGICAL FROM COMMON *COMDIZ*     =',
     D        'LSIMDT     LOGICAL FROM COMMON *COMDSW*     =',
     D        'LSIMZQ     LOGICAL FROM COMMON *COMDSW*     =',
     D        'LVTMPC1    LOGICAL FROM COMMON *COMDSW*     =',
     D        'LVTMPC2    LOGICAL FROM COMMON *COMDSW*     =',
     D        'LLDIFF     LOGICAL FROM COMMON *COMNMI*     =',
     D        'LLROSS     LOGICAL FROM COMMON *COMNMI*     =',
     D        'LLPROJ     LOGICAL FROM COMMON *COMNMI*     =',
     D        'LLZA       LOGICAL FROM COMMON *COMNMI*     =',
     D        'LLPSRS     LOGICAL FROM COMMON *COMNMI*     =',
     D        'LLTEND     LOGICAL FROM COMMON *COMNMI*     =',
     D        'LLDIAB     LOGICAL FROM COMMON *COMNMI*     =',
     D        'LLFILT     LOGICAL FROM COMMON *COMNMI*     =',
     D        'LPHYS      LOGICAL FROM COMMON *COMPSW*     =',
     D        'LVDIFF     LOGICAL FROM COMMON *COMPSW*     ='/
      DATA (YL(I),I=16,26)
     D       /'LKUO       LOGICAL FROM COMMON *COMPSW*     =',
     D        'LCOND      LOGICAL FROM COMMON *COMPSW*     =',
     D        'LQNEGAT    LOGICAL FROM COMMON *COMPSW*     =',
     D        'LSURF      LOGICAL FROM COMMON *COMPSW*     =',
     D        'LSCV       LOGICAL FROM COMMON *COMPSW*     =',
     D        'LKUO0      LOGICAL FROM COMMON *COMPSW*     =',
     D        'LESFT      LOGICAL FROM COMMON *COMPSW*     =',
     D        'LEVAP      LOGICAL FROM COMMON *COMPSW*     =',
     D        'LSNRN      LOGICAL FROM COMMON *COMPSW*     =',
     D        'LRAD       LOGICAL FROM COMMON *COMRSW*     =',
     D        'LDIUR      LOGICAL FROM COMMON *COMRSW*     ='/
      DATA YI1/'NCYCLE     INTEGER FROM COMMON *COMDOC*     =',
     D         'NVERS      INTEGER FROM COMMON *COMDOC*     =',
     D         'NM         INTEGER FROM COMMON *COMCTL*     =',
     D         'NN         INTEGER FROM COMMON *COMCTL*     =',
     D         'NK         INTEGER FROM COMMON *COMCTL*     =',
     D         'NGL        INTEGER FROM COMMON *COMCTL*     ='/
      DATA YI2/'NLON( )    INTEGER FROM COMMON *COMCTL*     ='/
      DATA YI3/'NLEV       INTEGER FROM COMMON *COMCTL*     =',
     D         'NVCLEV     INTEGER FROM COMMON *COMCTL*     =',
     D         'NUMZLS     INTEGER FROM COMMON *COMDIZ*     =',
     D         'NFRZLS     INTEGER FROM COMMON *COMDIZ*     =',
     D         'NDTSCVL    INTEGER FROM COMMON *COMDIZ*     =',
     D         'NDTSCVS    INTEGER FROM COMMON *COMDIZ*     =',
     D         'NDQSCVL    INTEGER FROM COMMON *COMDIZ*     =',
     D         'NDQSCVS    INTEGER FROM COMMON *COMDIZ*     =',
     D         'NDUSCVL    INTEGER FROM COMMON *COMDIZ*     =',
     D         'NDUSCVS    INTEGER FROM COMMON *COMDIZ*     =',
     D         'NDVSCVL    INTEGER FROM COMMON *COMDIZ*     =',
     D         'NDVSCVS    INTEGER FROM COMMON *COMDIZ*     =',
     D         'NDESCVL    INTEGER FROM COMMON *COMDIZ*     =',
     D         'NDESCVS    INTEGER FROM COMMON *COMDIZ*     ='/
      DATA YI4/'NLANDP( )  INTEGER FROM COMMON *COMDIZ*     ='/
      DATA YI5/'NSEAP( )   INTEGER FROM COMMON *COMDIZ*     ='/
      DATA YI6/'NMASKA     INTEGER FROM COMMON *COMMSK*     =',
     D         'NMASKV     INTEGER FROM COMMON *COMMSK*     =',
     D         'NFRMSK     INTEGER FROM COMMON *COMMSK*     =',
     D         'NFRMSKP    INTEGER FROM COMMON *COMMSK*     =',
     D         'NRSLT      INTEGER FROM COMMON *COMMSK*     =',
     D         'NITNINI    INTEGER FROM COMMON *COMNMI*     =',
     D         'NDIFFST    INTEGER FROM COMMON *COMNMI*     =',
     D         'NVM        INTEGER FROM COMMON *COMNMI*     =',
     D         'NRADFR     INTEGER FROM COMMON *COMRSW*     =',
     D         'NRINT      INTEGER FROM COMMON *COMRSW*     ='/
      DATA YI7/'NTRM( )    INTEGER FROM COMMON *COMTRU*     ='/
      DATA YI8/'NTRN( )    INTEGER FROM COMMON *COMTRU*     ='/
      DATA YI9/'NTRK( )    INTEGER FROM COMMON *COMTRU*     ='/
      DATA YR1/'DTIME      REAL    FROM COMMON *COMCTL*     =',
     D         'EPS        REAL    FROM COMMON *COMCTL*     ='/
      DATA YR2/'VCT( )     REAL    FROM COMMON *COMCTL*     ='/
      DATA (YR3(I),I=1,15)
     D        /'CDIATS     REAL    FROM COMMON *COMDIA*     =',
     D         'CDIATD     REAL    FROM COMMON *COMDIA*     =',
     D         'CDIAWD     REAL    FROM COMMON *COMDIA*     =',
     D         'GPEO       REAL    FROM COMMON *COMDIA*     =',
     D         'GKEO       REAL    FROM COMMON *COMDIA*     =',
     D         'GQMO       REAL    FROM COMMON *COMDIA*     =',
     D         'GTSO       REAL    FROM COMMON *COMDIA*     =',
     D         'GTDO       REAL    FROM COMMON *COMDIA*     =',
     D         'GWSO       REAL    FROM COMMON *COMDIA*     =',
     D         'GWDO       REAL    FROM COMMON *COMDIA*     =',
     D         'GSNO       REAL    FROM COMMON *COMDIA*     =',
     D         'DSRADO     REAL    FROM COMMON *COMDIA*     =',
     D         'DTRADO     REAL    FROM COMMON *COMDIA*     =',
     D         'DSRADS     REAL    FROM COMMON *COMDIA*     =',
     D         'DTRADS     REAL    FROM COMMON *COMDIA*     ='/
      DATA (YR3(I),I=16,30)
     D        /'DVDIS      REAL    FROM COMMON *COMDIA*     =',
     D         'DHFS       REAL    FROM COMMON *COMDIA*     =',
     D         'DEVAP      REAL    FROM COMMON *COMDIA*     =',
     D         'DCVFR      REAL    FROM COMMON *COMDIA*     =',
     D         'DCVQAC     REAL    FROM COMMON *COMDIA*     =',
     D         'DCVMOI     REAL    FROM COMMON *COMDIA*     =',
     D         'DCVGR      REAL    FROM COMMON *COMDIA*     =',
     D         'DCVGS      REAL    FROM COMMON *COMDIA*     =',
     D         'DCVMS      REAL    FROM COMMON *COMDIA*     =',
     D         'DCVER      REAL    FROM COMMON *COMDIA*     =',
     D         'DCVES      REAL    FROM COMMON *COMDIA*     =',
     D         'DLSGR      REAL    FROM COMMON *COMDIA*     =',
     D         'DLSGS      REAL    FROM COMMON *COMDIA*     =',
     D         'DLSMS      REAL    FROM COMMON *COMDIA*     =',
     D         'DLSER      REAL    FROM COMMON *COMDIA*     ='/
      DATA (YR3(I),I=31,45)
     D        /'DLSES      REAL    FROM COMMON *COMDIA*     =',
     D         'DSSRAD     REAL    FROM COMMON *COMDIA*     =',
     D         'DSTRAD     REAL    FROM COMMON *COMDIA*     =',
     D         'DSHFL      REAL    FROM COMMON *COMDIA*     =',
     D         'DSDTFL     REAL    FROM COMMON *COMDIA*     =',
     D         'DSLSR      REAL    FROM COMMON *COMDIA*     =',
     D         'DSLSS      REAL    FROM COMMON *COMDIA*     =',
     D         'DSCVR      REAL    FROM COMMON *COMDIA*     =',
     D         'DSCVS      REAL    FROM COMMON *COMDIA*     =',
     D         'DSEVW      REAL    FROM COMMON *COMDIA*     =',
     D         'DSEVI      REAL    FROM COMMON *COMDIA*     =',
     D         'DSDWFL     REAL    FROM COMMON *COMDIA*     =',
     D         'DSSNMT     REAL    FROM COMMON *COMDIA*     =',
     D         'DDCTFL     REAL    FROM COMMON *COMDIA*     =',
     D         'DDCWFL     REAL    FROM COMMON *COMDIA*     ='/
      DATA (YR3(I),I=46,53)
     D        /'DSROS      REAL    FROM COMMON *COMDIA*     =',
     D         'DSROD      REAL    FROM COMMON *COMDIA*     =',
     D         'DADCON     REAL    FROM COMMON *COMDIA*     =',
     D         'DIFVO      REAL    FROM COMMON *COMHDI*     =',
     D         'DIFD       REAL    FROM COMMON *COMHDI*     =',
     D         'DIFT       REAL    FROM COMMON *COMHDI*     =',
     D         'DIFQ       REAL    FROM COMMON *COMHDI*     =',
     D         'CDRAG      REAL    FROM COMMON *COMHDI*     ='/
      DATA YR4/'ALATN( )   REAL    FROM COMMON *COMMSK*     ='/
      DATA YR5/'ALATS( )   REAL    FROM COMMON *COMMSK*     ='/
      DATA YR6/'ALONE( )   REAL    FROM COMMON *COMMSK*     ='/
      DATA YR7/'ALONW( )   REAL    FROM COMMON *COMMSK*     ='/
      DATA (YR8(I),I=1,15)
     D        /'DTINIT )   REAL    FROM COMMON *COMNMI*     =',
     D         'DTDIFF )   REAL    FROM COMMON *COMNMI*     =',
     D         'PHYFIL     REAL    FROM COMMON *COMNMI*     =',
     D         'WSMAX      REAL    FROM COMMON *COMPSW*     =',
     D         'BETADT     REAL    FROM COMMON *COMSIM*     =',
     D         'BETAZQ     REAL    FROM COMMON *COMSIM*     =',
     D         'APR        REAL    FROM COMMON *COMSIM*     =',
     D         'TR         REAL    FROM COMMON *COMSIM*     =',
     D         'VCRIT      REAL    FROM COMMON *COMSIM*     =',
     D         'HDAMP      REAL    FROM COMMON *COMSIM*     =',
     D         'GVO        REAL    FROM COMMON *COMSTA*     =',
     D         'GD         REAL    FROM COMMON *COMSTA*     =',
     D         'GQ         REAL    FROM COMMON *COMSTA*     =',
     D         'GT         REAL    FROM COMMON *COMSTA*     =',
     D         'GPS        REAL    FROM COMMON *COMSTA*     ='/
      DATA (YR8(I),I=16,26)
     D        /'GKE        REAL    FROM COMMON *COMSTA*     =',
     D         'GPE        REAL    FROM COMMON *COMSTA*     =',
     D         'GTE        REAL    FROM COMMON *COMSTA*     =',
     D         'GLQ        REAL    FROM COMMON *COMSTA*     =',
     D         'GTPE       REAL    FROM COMMON *COMSTA*     =',
     D         'GQM        REAL    FROM COMMON *COMSTA*     =',
     D         'GTS        REAL    FROM COMMON *COMSTA*     =',
     D         'GTD        REAL    FROM COMMON *COMSTA*     =',
     D         'GWS        REAL    FROM COMMON *COMSTA*     =',
     D         'GWD        REAL    FROM COMMON *COMSTA*     =',
     D         'GSN        REAL    FROM COMMON *COMSTA*     ='/
C
C*               1. LOCAL VARIABLES
C
  100 CONTINUE
      INGL=INTEGS(6)
      INVCLEV=INTEGS(6+INGL+2)
      INLEV=INTEGS(6+INGL+1)
C      INDEX FOR INTEGERS
      J1A=1
      J1T=6
      J2A=J1T+1
      J2T=J2A+INGL-1
      J3A=J2T+1
      J3T=J3A+14-1
      J4A=J3T+1
      J4T=J4A+INGL-1
      J5A=J4T+1
      J5T=J5A+INGL-1
      J6A=J5T+1
      J6T=J6A+10-1
      J7A=J6T+1
      J7T=J7A+INLEV-1
      J8A=J7T+1
      J8T=J8A+INLEV-1
      J9A=J8T+1
      J9T=J9A+INLEV-1
C        INDEX FOR REALS
      I1A=1
      I1T=I1A+2-1
      I2A=I1T+1
      I2T=I2A+2*INVCLEV-1
      I3A=I2T+1
      I3T=I3A+53-1
      I4A=I3T+1
      I4T=I4A+32-1
      I5A=I4T+1
      I5T=I5A+32-1
      I6A=I5T+1
      I6T=I6A+32-1
      I7A=I6T+1
      I7T=I7A+32-1
      I8A=I7T+1
      I8T=I8A+26-1
      PRINT*,' J9T=',J9T,'INTL=',ILENGI,'I8T=',I8T,'REAL=',ILENGR
      IF (I8T.NE.ILENGR) THEN
         GO TO 900
      ENDIF
C
C*               2.BLOCK 0 AND 1
C
  200 CONTINUE
      IMET=0
      WRITE(*,1100)
      DO 210 I=1,29
      IF (I.EQ.22.OR.I.EQ.23.OR.I.EQ.24) THEN
         GO TO 210
      ENDIF
      IMET=IMET+1
      WRITE(*,'(1X,A,I6,1X,A,I4)') Y1(IMET),IBLOCKS(I),YY,I
  210 CONTINUE
C
C*               3.LOGICALS
C
  300 CONTINUE
      WRITE(*,1200)
      DO 310 I=1,ILENGL
      WRITE(*,'(1X,A,L6,1X,A,I4)') YL(I),LOGICS(I),YY,I
  310 CONTINUE
C
C*               4.INTEGER
C
  400 CONTINUE
      WRITE(*,1300)
      DO 410 I=J1A,J1T
      WRITE(*,'(1X,A,I6,1X,A,I4)') YI1(I),INTEGS(I),YY,I
  410 CONTINUE
      DO 420 I=J2A,J2T
      WRITE(*,'(1X,A,I6,1X,A,I4)') YI2,INTEGS(I),YY,I
  420 CONTINUE
      META3=0
      DO 430 I=J3A,J3T
      META3=META3+1
      WRITE(*,'(1X,A,I6,1X,A,I4)') YI3(META3),INTEGS(I),YY,I
  430 CONTINUE
      DO 440 I=J4A,J4T
      WRITE(*,'(1X,A,I6,1X,A,I4)') YI4,INTEGS(I),YY,I
  440 CONTINUE
      DO 450 I=J5A,J5T
      WRITE(*,'(1X,A,I6,1X,A,I4)') YI5,INTEGS(I),YY,I
  450 CONTINUE
      META6=0
      DO 460 I=J6A,J6T
      META6=META6+1
      WRITE(*,'(1X,A,I6,1X,A,I4)') YI6(META6),INTEGS(I),YY,I
  460 CONTINUE
      DO 470 I=J7A,J7T
      WRITE(*,'(1X,A,I6,1X,A,I4)') YI7,INTEGS(I),YY,I
  470 CONTINUE
      DO 480 I=J8A,J8T
      WRITE(*,'(1X,A,I6,1X,A,I4)') YI8,INTEGS(I),YY,I
  480 CONTINUE
      DO 490 I=J9A,J9T
      WRITE(*,'(1X,A,I6,1X,A,I4)') YI9,INTEGS(I),YY,I
  490 CONTINUE
C
C*               5. REALS
C
  500 CONTINUE
      WRITE(*,1400)
      DO 510 I=I1A,I1T
      WRITE(*,'(1X,A,G12.6,1X,A,I4)') YR1(I),REALSW(I),YY,I
  510 CONTINUE
      DO 520 I=I2A,I2T
      WRITE(*,'(1X,A,G12.6,1X,A,I4)') YR2,REALSW(I),YY,I
  520 CONTINUE
      METR3=0
      DO 530 I=I3A,I3T
      METR3=METR3+1
      WRITE(*,'(1X,A,G12.6,1X,A,I4)') YR3(METR3),REALSW(I),YY,I
  530 CONTINUE
      DO 540 I=I4A,I4T
      WRITE(*,'(1X,A,G12.6,1X,A,I4)') YR4,REALSW(I),YY,I
  540 CONTINUE
      DO 550 I=I5A,I5T
      WRITE(*,'(1X,A,G12.6,1X,A,I4)') YR5,REALSW(I),YY,I
  550 CONTINUE
      DO 560 I=I6A,I6T
      WRITE(*,'(1X,A,G12.6,1X,A,I4)') YR6,REALSW(I),YY,I
  560 CONTINUE
      DO 570 I=I7A,I7T
      WRITE(*,'(1X,A,G12.6,1X,A,I4)') YR7,REALSW(I),YY,I
  570 CONTINUE
      METR8=0
      DO 580 I=I8A,I8T
      METR8=METR8+1
      WRITE(*,'(1X,A,G12.6,1X,A,I4)') YR8(METR8),REALSW(I),YY,I
  580 CONTINUE
C
C*                6. RETURN
C
  600 CONTINUE
C
      RETURN
C
C
C*                9.ERRORS
C
  900 CONTINUE
      WRITE(*,9901)
      WRITE(*,'(A)') 'ERROR IN THE LENGTH OF REALS'
      CALL ENDRUN
      STOP
 9901 FORMAT('ERROR IN SUBROUTINE ANALSW')
C
C*
C
 1100 FORMAT('1',20X,'VARIABLES OF BLOCK 0 AND 1')
 1200 FORMAT('1',20X,'LOGICAL')
 1300 FORMAT('1',20X,'INTEGER')
 1400 FORMAT('1',20X,'REAL   ')
      END

#ifdef IBM
@PROCESS HOT(NOVECTOR) NOSTRICT
#endif
C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities
C granted to it by virtue of its status as an intergovernmental organisation
C nor does it submit to any jurisdiction.
C

      SUBROUTINE JSYMGG( PSHUP,KTRUNC,KSTART,KLUNIT,KLATO,KLONO,
     X                    PLAT,PLEG,PTRIGS,KMFAX,LUSEFFTW,PZFA,KRET)
C
C---->
C**** JSYMGG
C
C     PURPOSE
C     _______
C
C     This routine converts spectral input fields to standard
C     lat/long grid fields.
C
C     INTERFACE
C     _________
C
C     CALL JSYMGG( PSHUP, KTRUNC, KSTART, KLUNIT, KLATO, KLONO,
C    X             PLAT, PLEG, PTRIGS, KMFAX, PZFA, KRET)
C
C     Input parameters
C     ________________
C
C     PSHUP    - Spherical harmonics field, unpacked
C     KTRUNC   - Truncation number of spherical harmonics field
C     KSTART   - Number of start latitude row (northernmost) for output
C                field (must be positive - see comments below)
C     KLUNIT   - stream number of the legendre function file
C     KLATO    - Number of latitude rows in output field
C     KLONO    - Number of longitude points in output field
C     PLAT     - Array of gaussian latitudes
C     PLEG     - Array used to hold legendre functions
C     PTRIGS   - Initialized array of trig.functions (setup by JJSET99)
C     KMFAX    - Initialized array of prime factors (setup by JJSET99)
C     LUSEFFTW - Use FFTW instead of FFT99
C
C     Output parameters
C     ________________
C
C     PZFA     - Output grid point field; contains up to 32 each of
C                North and South latitude rows symmetrically.
C     KRET     - Return status code
C                0 = OK
C
C     Common block usage
C     __________________
C
C     JDCNDBG
C
C     Method
C     ______
C
C     None.
C
C     Externals
C     _________
C
C     JREADGG - Reads the legendre functions for a latitude
C     FFT99   - Carries out FFT
C     INTLOG  - Output log message
C     INTLOGR - Output log message (with real value)
C     NMAKGG  - Make interpolation coefficients one latitude at a time
C
C     Reference
C     _________
C
C     E.C.M.W.F. Research Department technical memorandum no. 56
C                "The forecast and analysis post-processing package"
C                May 1982. J.Haseler.
C
C     Comments
C     ________
C
C     This is a redesign, based on SPECGP.F
C
C     It handles transformation to a gaussian grid.
C     The generated grid is symmetrical about the equator, so
C     KSTART must be positive.
C
C     It is not for U and V fields (no correction is applied at the
C     poles).
C
C
C     AUTHOR
C     ______
C
C     J.D.Chambers      *ECMWF*      Jan 1994
C
C     MODIFICATIONS
C     _____________
C
C     J.D.Chambers     ECMWF        Feb 1997
C     Allow for 64-bit pointers
C
C----<
C     _______________________________________________________
C
C
      IMPLICIT NONE
#include "jparams.h"
#include "parim.h"
#include "nifld.common"
C
C     Parameters
      INTEGER JPROUTINE
      PARAMETER ( JPROUTINE = 31200 )
C
C     Subroutine arguments
      COMPLEX   PSHUP
      DIMENSION PSHUP(*)
      INTEGER   KTRUNC
      INTEGER   KSTART
      INTEGER   KLUNIT, KLATO, KLONO, KMFAX, KRET
      REAL      PLEG, PTRIGS, PZFA
      LOGICAL   LUSEFFTW
      DIMENSION PZFA(JPLONO + 2, 64)
      DIMENSION KMFAX(*), PLEG(*), PTRIGS(*)
      REAL      PLAT
      DIMENSION PLAT(*)
C
C     Local variables
      INTEGER   ILIM, IMLIM, ILN
      INTEGER   ITAL, ITALA, ITALS, IMN, IMP
      INTEGER   INORTH, ISOUTH
      INTEGER   JM, J, JNEXTLAT, JF
      INTEGER   NERR
      INTEGER*8 JDCLOOP
      INTEGER*8 IOFF
C
#ifndef _CRAYFTN
#ifdef POINTER_64
      INTEGER*8 IWORK
#endif
#endif
#ifdef HAVE_FFTW
      INTEGER*8 PLAN
      INTEGER   N(64), IDIST, ODIST
      REAL      X1, XN
#include "fftw3.f"
#endif
      REAL WORK
      DIMENSION WORK(1)
      POINTER ( IWORK, WORK )
      COMPLEX   ZSUMS(JPTRNC + 1), ZSUMA(JPTRNC + 1)
      COMPLEX*16 CHOLD
C
      INTEGER ISIZE
      DATA ISIZE/0/
      SAVE ISIZE, IWORK
C
C     _______________________________________________________
C
C*    Section 1.    Initialization.
C     _______________________________________________________
C
  100 CONTINUE
      IOFF = 0
C
C     First time through, dynamically allocate memory for workspace
C
      IF( ISIZE.EQ.0 .AND. .NOT. LUSEFFTW ) THEN
        ISIZE =  2*JPFFT*64
        CALL JMEMHAN( 9, IWORK, ISIZE, 1, KRET)
        IF( KRET.NE.0 ) THEN
          CALL INTLOG(JP_ERROR,'JSYMGG: memory allocation error.',IWORK)
          KRET = JPROUTINE + 1
          GOTO 990
        ENDIF
      ENDIF
C
      IF ( NDBG .GT. 1) THEN
        CALL INTLOG(JP_DEBUG,
     X    'JSYMGG: Spherical harmonic coeffs(first 20):',JPQUIET)
        DO NDBGLP = 1, 20
          CALL INTLOGR(JP_DEBUG,' ',PSHUP( NDBGLP ))
        ENDDO
        CALL INTLOG(JP_DEBUG,'JSYMGG: Input parameters:',JPQUIET)
        CALL INTLOG(JP_DEBUG,
     X    'JSYMGG: Spherical harmonic truncation = ', KTRUNC)
        CALL INTLOG(JP_DEBUG,
     X    'JSYMGG: Start latitude(northernmost) = ', KSTART)
        CALL INTLOG(JP_DEBUG,
     X    'JSYMGG: Stream number of leg. file = ', KLUNIT)
        CALL INTLOG(JP_DEBUG,
     X    'JSYMGG: Number of lat. rows in output = ', KLATO)
        CALL INTLOG(JP_DEBUG,
     X    'JSYMGG: Number of long. pts per row = ', KLONO)
        IF( .NOT. LUSEFFTW ) THEN
          CALL INTLOG(JP_DEBUG,
     X      'JSYMGG: Trig.functions (setup by JJSET99):',JPQUIET)
          DO NDBGLP = 1, 10
            CALL INTLOGR(JP_DEBUG,' ',PTRIGS( NDBGLP ))
          ENDDO
          CALL INTLOG(JP_DEBUG,
     X      'JSYMGG: Prime factors (setup by JJSET99):',JPQUIET)
          DO NDBGLP = 1, 10
            CALL INTLOG(JP_DEBUG,' ',KMFAX( NDBGLP ))
          ENDDO
        ENDIF
      ENDIF
C
      ILIM   = KTRUNC + 1
      IMLIM  = KTRUNC + 1
      INORTH = -1
      ILN    = KLONO + 2
C
C     _______________________________________________________
C
C*    Section 2.    Main loop through latitude rows to
C*                  calculate fourier coefficients
C     _______________________________________________________
C
 200  CONTINUE
C
C     For each latitude, the north and corresponding south latitude row
C     are calculated at the same time from the same legendre functions.
C
      DO JNEXTLAT = KSTART, KSTART+KLATO-1
C
        IF ( NDBG .GT. 1)
     X    CALL INTLOG(JP_DEBUG,'JSYMGG: Next latitude = ', JNEXTLAT)
C
C       If required, generate the coefficients 'on the fly'
C
        IF( LON_FLY ) THEN
          CALL NMAKGG( KTRUNC, JNEXTLAT, PLAT, 1, PLEG, NERR)
          IOFF = 0
        ELSE IF( LFILEIO ) THEN
          CALL JREADGG( KLUNIT, KTRUNC, JNEXTLAT, PLEG, NERR)
          IF ( NERR .NE. 0 ) THEN
            CALL INTLOG(JP_ERROR,'JSYMGG: JREADGG error',NERR)
            KRET = JPROUTINE + 2
            GOTO 990
          ENDIF
        ELSE
C         IOFF = (JNEXTLAT-1)*(KTRUNC+1)*(KTRUNC+4)/2
          IOFF = (JNEXTLAT-1)
          IOFF = (KTRUNC+1) * IOFF
          IOFF = (KTRUNC+4) * IOFF
          IOFF = IOFF/2
        ENDIF
C
C       Clear unused slots in array.
C       Note there are two slots in the array - one for north latitude
C       and one for the corresponding south latitude.
C
        INORTH = INORTH + 2
        ISOUTH = INORTH + 1
        DO JF = 2*IMLIM + 1, ILN
          PZFA(JF, INORTH) = 0.0
          PZFA(JF, ISOUTH) = 0.0
        ENDDO
C
C       Now fill slots which are used
C
        IMN = 0
        IMP = 0
C
        DO JM = 1, IMLIM
          ITAL = ILIM - JM + 1
          ITALS = (ITAL + 1)/2
          ITALA = ITAL/2
          CHOLD=(0.0D0, 0.0D0)
          DO J = 1, 2*ITALS, 2
            IF( LFILEIO ) THEN
              CHOLD=CHOLD+PLEG(IMP+J)*PSHUP(IMN+J)
            ELSE
              JDCLOOP = IMP + J + IOFF
              CHOLD=CHOLD+PLEG(JDCLOOP)*PSHUP(IMN+J)
            ENDIF
          ENDDO
          ZSUMS(JM)=CHOLD
          CHOLD = (0.0D0, 0.0D0)
          DO J = 2, 2*ITALA, 2
            IF( LFILEIO ) THEN
              CHOLD=CHOLD+PLEG(IMP+J)*PSHUP(IMN+J)
            ELSE
              JDCLOOP = IMP + J + IOFF
              CHOLD=CHOLD+PLEG(JDCLOOP)*PSHUP(IMN+J)
            ENDIF
          ENDDO
          ZSUMA(JM)=CHOLD
          IMP = IMP + ITAL + 1
          IMN = IMN + ITAL
        ENDDO
C
C       For the southern hemisphere row, the legendre functions are
C       the complex conjugates of the corresponding northern row -
C       hence the juggling with the signs in the next loop.
C
C       Note that PZFA is REAL, but the coefficients being calculated
C       are COMPLEX.  There are pairs of values for each coefficient
C       (real and imaginary parts) and pairs of values for each
C       latitude (north and south).
C
        DO JM = 1, IMLIM
          PZFA(2*JM -1, INORTH) = REAL(ZSUMS(JM))  + REAL(ZSUMA(JM))
          PZFA(2*JM   , INORTH) = AIMAG(ZSUMS(JM)) + AIMAG(ZSUMA(JM))
          PZFA(2*JM -1, ISOUTH) = REAL(ZSUMS(JM))  - REAL(ZSUMA(JM))
          PZFA(2*JM   , ISOUTH) = AIMAG(ZSUMS(JM)) - AIMAG(ZSUMA(JM))
        ENDDO
C
C*    End of main loop through latitude rows.
C
      ENDDO
C
C     _______________________________________________________
C
C*    Section 3.    Fast fourier transform
C     _______________________________________________________
C
 300  CONTINUE
C
      IF ( NDBG .GT. 1) CALL INTLOG(JP_DEBUG,
     X  'JSYMGG: FFT, no.of rows (N and S) = ',ISOUTH)
C
#ifdef HAVE_FFTW
      IF( LUSEFFTW ) THEN
        N    = 0
        N(1) = KLONO
        IDIST = (JPLONO+2)/2
        ODIST = (JPLONO+2)
#ifdef REAL_8
C       double precision fftw
        CALL DFFTW_PLAN_MANY_DFT_C2R( PLAN, 1, N, ISOUTH,
     X         PZFA, 0, 1, IDIST,  ! in,  inembed, istride, idist
     X         PZFA, 0, 1, ODIST,  ! out, onembed, ostride, odist
     X         FFTW_ESTIMATE + FFTW_UNALIGNED + FFTW_NO_SIMD +
     X         FFTW_DESTROY_INPUT )
        CALL DFFTW_EXECUTE( PLAN )
        CALL DFFTW_DESTROY_PLAN( PLAN )
#else
C       single precision fftw
        CALL SFFTW_PLAN_MANY_DFT_C2R( PLAN, 1, N, ISOUTH,
     X         PZFA, 0, 1, IDIST,
     X         PZFA, 0, 1, ODIST,
     X         FFTW_ESTIMATE + FFTW_UNALIGNED + FFTW_NO_SIMD )
        CALL SFFTW_EXECUTE( PLAN )
        CALL SFFTW_DESTROY_PLAN( PLAN )
#endif
C
C       shift right and enforce periodicity (see FFT99 documentation):
C         from [ x1, x2, ..., xN-1, xN,   0,  0,  (0...) ]
C         to   [ xN, x1, x2, ...,   xN-1, xN, x1, (0...) ]
        DO J=1, ISOUTH
          X1 = PZFA(   1,   J )
          XN = PZFA( KLONO, J )
          PZFA( 2:KLONO+1, J ) = PZFA(1:KLONO,J)
          PZFA(     1,     J ) = XN
          PZFA(  KLONO+2,  J ) = X1
        ENDDO
      ELSE
        CALL FFT99(PZFA,WORK,PTRIGS,KMFAX,1,JPLONO+2,KLONO,ISOUTH,1)
      ENDIF
#else
      CALL FFT99(PZFA,WORK,PTRIGS,KMFAX,1,JPLONO+2,KLONO,ISOUTH,1)
#endif
C
      IF ( NDBG .GT. 1) THEN
        CALL INTLOG(JP_DEBUG,
     X    'JSYMGG: Values calculated by FFT:',JPQUIET)
        DO NDBGLP = 1, 20
          CALL INTLOGR(JP_DEBUG,' ',PZFA( 1, NDBGLP ))
          CALL INTLOGR(JP_DEBUG,' ',PZFA( 2, NDBGLP ))
        ENDDO
      ENDIF
C
C     _______________________________________________________
C
C*    Section 9. Return to calling routine. Format statements
C     _______________________________________________________
C
C
 900  CONTINUE
C
      KRET = 0
C
 990  CONTINUE
      RETURN
      END

C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      INTEGER FUNCTION IAOGDEF (PWEST, PEAST, PNORTH, PSOUTH,
     1   KGAUSS, KAREA, OCHNG, OIWEGLOBE, OINPOLE, OISPOLE,
     2   KIAREA, KPR, KERR)
C
C---->
C**** *IAOGDEF*
C
C     PURPOSE
C     _______
C
C     Set the output field definition variables.
C
C     INTERFACE
C     _________
C
C     IERR = IAOGDEF (PWEST, PEAST, PNORTH, PSOUTH, KGAUSS, KAREA,
C    1   OCHNG, OIWEGLOBE, OINPOLE, OISPOLE, KIAREA, KPR, KERR)
C
C     Input parameters
C     ________________
C
C     PWEST      - The Western limit of the output field area.
C
C     PEAST      - The Eastern limit of the output field area.
C
C     PNORTH     - The Northern limit of the output field area.
C
C     PSOUTH     - The Southern limit of the output field area.
C
C     KGAUSS     - The Gaussian truncation for the output field.
C
C     KAREA      - The previous output field area used for checking
C                  for definition changes.
C
C     OIWEGLOBE  - Flag indicating whether the INPUT field spans the
C                  globe in the West-East direction.
C
C     OINPOLE    - Flag indicating whether the INPUT field includes
C                  the North polar line of latitude.
C
C     OISPOLE    - Flag indicating whether the INPUT field includes
C                  the South polar line of latitude.
C
C     KIAREA     - The input field area which will be used for an
C                  uninitialised output field area when the input
C                  field is not global.
C
C     KPR        - The debug print switch.
C                  0  , No debugging output.
C                  1  , Produce debugging output.
C
C     KERR       - The error control flag.
C                  -ve, No error message. Return error code.
C                  0  , Hard failure with error message.
C                  +ve, Print error message. Return error code.
C
C     Output parameters
C     ________________
C
C     KAREA      - The output field area if the definition has changed.
C
C     OCHNG      - A flag variable indicating whether the definition
C                  has changed.
C
C     Return value
C     ____________
C
C     The error indicator (INTEGER).
C
C     Error and Warning Return Values
C     _______________________________
C
C     21601 An illegal Gaussian truncation was requested.
C     21602 The default West-East output limits for a non-global
C           input field did not match the increment.
C     21603 Default North-South limits were specified for a
C           non-global input field. This is not allowed for a
C           Gaussian output field.
C
C     Common block usage
C     __________________
C
C     nofld.common - This file contains all the output field
C                    definition variables.
C
C     NOGAUSS      - Output field Gaussian truncation is set.
C     NOREPR       - Output field representation is set.
C     NOSCNM       - Output field scanning mode is set.
C
C     EXTERNALS
C     _________
C
C     INTLOG     - Logs messages.
C
C     METHOD
C     ______
C
C     Check the output definition against the previous definition and
C     update appropriate definition variables.
C
C     REFERENCE
C     _________
C
C     None
C
C     COMMENTS
C     ________
C
C     Program contains sections 0 to 3 and 9
C
C     AUTHOR
C     ______
C
C     K. Fielding      *ECMWF*      Apr 1994
C
C     MODIFICATIONS
C     _____________
C
C     None
C
C----<
C     _______________________________________________________
C
C
C*    Section 0. Definition of variables.
C     _______________________________________________________
C
C*    Prefix conventions for variable names
C
C     Logical      L (but not LP), global or common.
C                  O, dummy argument
C                  G, local variable
C                  LP, parameter.
C     Character    C, global or common.
C                  H, dummy argument
C                  Y (but not YP), local variable
C                  YP, parameter.
C     Integer      M and N, global or common.
C                  K, dummy argument
C                  I, local variable
C                  J (but not JP), loop control
C                  JP, parameter.
C     REAL         A to F and Q to X, global or common.
C                  P (but not PP), dummy argument
C                  Z, local variable
C                  PP, parameter.
C
C     Implicit statement to force declarations
C
      IMPLICIT NONE
C
#include "parim.h"
#include "nofld.common"
C
C     Subroutine arguments
C
      LOGICAL OCHNG, OIWEGLOBE, OINPOLE, OISPOLE
      INTEGER KGAUSS, KPR, KERR
      INTEGER KAREA (4), KIAREA (4)
      REAL PWEST, PEAST, PNORTH, PSOUTH
C
C     Local variables
      LOGICAL GLOBE, GNS
      INTEGER INORTH, ISOUTH, IWEST, IEAST, IWEINC, IWETMP, ITEMP
      INTEGER IERR
      INTEGER JPROUTINE
      PARAMETER (JPROUTINE = 21600)
C
C     External functions
C
C     Transform definition variables that must be preserved
C
C
C     _______________________________________________________
C
C*    Section 1. Initialisation
C     _______________________________________________________
C
  100 CONTINUE
C
      IF (KPR.GE.1) CALL INTLOG(JP_DEBUG,'IAOGDEF: Section 1.',JPQUIET)
C
      IAOGDEF = 0
C
      IERR = 0
C
      OCHNG = .FALSE.
C
      GNS = OINPOLE .AND. OISPOLE
C
      GLOBE = OIWEGLOBE .AND. GNS
C
      IF (KPR .GE. 1) THEN
         CALL INTLOG(JP_DEBUG,'IAOGDEF: Input parameters',JPQUIET)
         CALL INTLOG(JP_DEBUG,'IAOGDEF: Gaussian truncation = ',KGAUSS)
         CALL INTLOGR(JP_DEBUG,'IAOGDEF: Area North = ',PNORTH)
         CALL INTLOGR(JP_DEBUG,'IAOGDEF: Area West = ',PWEST)
         CALL INTLOGR(JP_DEBUG,'IAOGDEF: Area South = ',PSOUTH)
         CALL INTLOGR(JP_DEBUG,'IAOGDEF: Area East = ',PEAST)
      ENDIF
C
C     _______________________________________________________
C
C
C*    Section 2. Convert parameters to integer
C     _______________________________________________________
C
  200 CONTINUE
C
      IF (KPR.GE.1) CALL INTLOG(JP_DEBUG,'IAOGDEF: Section 2.',JPQUIET)
C
C     Representation
C
      IF (NOREPR .NE. JPGAUSSIAN) THEN
         NOREPR = JPGAUSSIAN
         OCHNG = .TRUE.
      ENDIF
C
      NOSCNM = 0
C
C     North, South, West and East limits
C
      INORTH = NINT (PNORTH * PPMULT)
      ISOUTH = NINT (PSOUTH * PPMULT)
      IWEST = NINT (PWEST * PPMULT)
      IEAST = NINT (PEAST * PPMULT)
C
C     Direction increments for regular grids
C
      IWEINC = JP90 / KGAUSS
C
      IF (IWEINC * KGAUSS .NE. JP90) THEN
        IAOGDEF = JPROUTINE + 1
        IF (KERR .GE. 0) THEN
          CALL INTLOG(JP_ERROR,
     X      'IAOGDEF: Illegal gaussian truncation = ',KGAUSS)
          IF (KERR .EQ. 0) CALL INTLOG(JP_FATAL,
     X      'IAOGDEF: Interpolation failing.',JPQUIET)
        ENDIF
        GO TO 900
      ENDIF
C
C
C     _______________________________________________________
C
C
C*    Section 3. Adjust grid stride and area
C     _______________________________________________________
C
  300 CONTINUE
C
      IF (KPR.GE.1) CALL INTLOG(JP_DEBUG,'IAOGDEF: Section 3.',JPQUIET)
C
C     Global field if all area limits are 0
C
      IF (INORTH .EQ. 0 .AND. ISOUTH .EQ. 0 .AND.
     X  IWEST .EQ. 0 .AND. IEAST .EQ. 0) THEN
C
        INORTH = JP90
        ISOUTH = - JP90
C
        IF (GLOBE) THEN
C
          IWEST = 0
          IEAST = JP360 - IWEINC
C
        ELSE
          IF (GNS) THEN
C
            IWEST = KIAREA (JPWEST)
            IEAST = KIAREA (JPEAST)
C
            IF (MOD (IEAST - IWEST, IWEINC) .NE. 0) THEN
              IAOGDEF = JPROUTINE + 2
              IF (KERR .GE. 0) THEN
                CALL INTLOG(JP_ERROR,
     X            'IAOGDEF: West-East increment ', IWEINC)
                CALL INTLOG(JP_ERROR,
     X            'IAOGDEF: does not match the range from ',IWEST)
                CALL INTLOG(JP_ERROR,
     X            'IAOGDEF: to ',IEAST)
                IF (KERR .EQ. 0) CALL INTLOG(JP_FATAL,
     X            'IAOGDEF: Interpolation failing.',JPQUIET)
              ENDIF
              GO TO 900
            ENDIF
          ELSE
            IAOGDEF = JPROUTINE + 3
              IF (KERR .GE. 0) THEN
                CALL INTLOG(JP_ERROR,
     X            'IAOGDEF: Must specify a range if Gaussian',JPQUIET)
                CALL INTLOG(JP_ERROR,
     X            'IAOGDEF: output and non-global input.',JPQUIET)
                IF (KERR .EQ. 0) CALL INTLOG(JP_FATAL,
     X            'IAOGDEF: Interpolation failing.',JPQUIET)
              ENDIF
              GO TO 900
          ENDIF
        ENDIF
C
      ELSE
C
C     Try to produce fields representable in GRIB for 0.5625 degree
C     strides
C
        IF (IEAST .LT. IWEST) THEN
          IF (IEAST .LE. 0) THEN
            IEAST = IEAST + JP360
          ELSE
            IWEST = IWEST - JP360
          ENDIF
        ENDIF
C
        GLOBE = IEAST - IWEST + IWEINC .EQ. JP360 .OR.
     X      IEAST - IWEST + IWEINC .EQ. 0
C
        IF (MOD (IWEINC, 10) .EQ. 5 .AND. .NOT. GLOBE) THEN
          IWETMP = IWEINC * 2
        ELSE
          IWETMP = IWEINC
        ENDIF
C
        IF (MOD (IEAST - IWEST, IWETMP) .NE. 0) THEN
C
          IF (MOD (IEAST, IWETMP) .NE. 0) THEN
C
            ITEMP = ABS (IEAST) / IWETMP
C
            IF (IEAST .GT. 0) THEN
              IEAST = (ITEMP + 1) * IWETMP
              IF (IEAST .GT. JP360) IEAST = IEAST - IWETMP
            ELSE
              IEAST = - ITEMP * IWETMP
            ENDIF
          ENDIF
C
          IF (MOD (IWEST, IWETMP) .NE. 0) THEN
C
            ITEMP = ABS (IWEST) / IWETMP
C
            IF (IWEST .LT. 0) THEN
              IWEST = - (ITEMP + 1) * IWETMP
              IF (IWEST .LT. - JP360) IWEST = IWEST + IWETMP
            ELSE
              IWEST = ITEMP * IWETMP
            ENDIF
          ENDIF
        ENDIF
      ENDIF
C
      IF (NOGAUSS .NE. KGAUSS) THEN
        NOGAUSS = KGAUSS
        OCHNG = .TRUE.
      ENDIF
C
      IF (KAREA (JPNORTH) .NE. INORTH) THEN
        KAREA (JPNORTH) = INORTH
        OCHNG = .TRUE.
      ENDIF
C
      IF (KAREA (JPSOUTH) .NE. ISOUTH) THEN
        KAREA (JPSOUTH) = ISOUTH
        OCHNG = .TRUE.
      ENDIF
C
      IF (IWEST .NE. KAREA (JPWEST) ) THEN
        KAREA (JPWEST) = IWEST
        OCHNG = .TRUE.
      ENDIF
C
      IF (IEAST .NE. KAREA (JPEAST) ) THEN
        KAREA (JPEAST) = IEAST
        OCHNG = .TRUE.
      ENDIF
C
      IF (KPR .GE. 1) THEN
        CALL INTLOG(JP_DEBUG,
     X    'IAOGDEF: Output field definition parameters.',JPQUIET)
        CALL INTLOG(JP_DEBUG,
     X    'IAOGDEF: Representation is ',NOREPR)
        CALL INTLOG(JP_DEBUG,
     X    'IAOGDEF: Gaussian truncation is ',NOGAUSS)
        CALL INTLOG(JP_DEBUG,
     X    'IAOGDEF: Area North is ',KAREA(1))
        CALL INTLOG(JP_DEBUG,
     X    'IAOGDEF: Area West  is ',KAREA(2))
        CALL INTLOG(JP_DEBUG,
     X    'IAOGDEF: Area South is ',KAREA(3))
        CALL INTLOG(JP_DEBUG,
     X    'IAOGDEF: Area East  is ',KAREA(4))
        IF( OCHNG ) THEN
          CALL INTLOG(JP_DEBUG,
     X      'IAOGDEF: Output field change is TRUE.',JPQUIET)
        ELSE
          CALL INTLOG(JP_DEBUG,
     X      'IAOGDEF: Output field change is TRUE.',JPQUIET)
        ENDIF
C
      ENDIF
C
C     _______________________________________________________
C
C*    Section 9. Return to calling routine. Format statements
C     _______________________________________________________
C
  900 CONTINUE
C
      IF (KPR.GE.1) CALL INTLOG(JP_DEBUG,'IAOGDEF: Section 9.',JPQUIET)
C
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities
C granted to it by virtue of its status as an intergovernmental organisation
C nor does it submit to any jurisdiction.
C

      SUBROUTINE GETSYS (HSYS)
      IMPLICIT LOGICAL     ( L , O , G )
      IMPLICIT CHARACTER*8 ( C , H , Y )
      IMPLICIT INTEGER     ( I , J , K , M , N )
C
C---->
C*    MARS common areas containing job environment information,
C     parameter settings etc.
C
C     NFTNOS - 12 Fortran unit numbers used by MARS.
C              NFTNOS(1) is MARSLOG file. Cracked MARS directives.
C              NFTNOS(2) is MARSPAR file. MARS directives in
C                        network transmission format.
C              NFTNOS(5) is unit 5 , standard input.
C              NFTNOS(6) is unit 6 , standard output.
C              NFTNOS(7) is MARSDEF or MARSDEFNEXT, language
C                        definition, operational or test.
C              Set by routine JENVXX.
C     NUMREQ - Total number of requests.
C     NUMFIL - Numbers of different files to be accessed.
C              NUMFIL(1) , Total number of files to accessed.
C              NUMFIL(2) , Number of IBM disk files to accessed.
C              NUMFIL(3) , Number of IBM MSS files to be accessed.
C              NUMFIL(4) , Number of IBM tape files to be accessed.
C              NUMFIL(5) , Number of worker machine files to accessed.
C     NCNDAY - Century day.
C              Set by routine JENVXX.
C     NJMODE - Mode in which MARS job is running.
C              -1, Quit issued.
C              0 , Checkout directives only.
C              1 , Connected mode (normal mode retains connection
C                  with IBM at all times).
C              2 , Disconnected mode (send requests to IBM and
C                  terminate).
C                  Not yet implemented.
C     NJOBSQ - Unique number identifying job or process.
C              Set by routine JENVXX.
C     NUMBIT - Number of bits in computer word.
C              Set by routine JENVXX.
C     NDBUGS - Debug print switch for IBM.
C              0 , No debug printout.     .
C              8 , Debug print on IBM.
C              Set by routine JENVXX.
C     NDBUGL - Debug level indicator for worker machine.
C              0 , No debug print.
C              4 , Trace through subroutine sections and
C                  values of parameters on entry as well as
C                  other print statements used when actually
C                  debugging.
C              Set by routine JENVXX.
C     NJBCAT - Category assigned to job by MARS.
C              0 , Archive request.
C              1 , Manage request.
C              2 , Checkout request.
C              3 , Costonly request.
C              4 , Retrieval from online Operational database on the
C                  worker machine.
C              5 , Retrieve guaranteed online (on IBM ) data.
C              6 , Retrieve online (on IBM ) data.
C                  Not yet implemented. Treated as category 7.
C              7 , Retrieve off-line (on IBM ) data.
C              8 , Retrieval of research department data from
C                  online Research database on worker machine.
C     NPRITY - Priority assigned to job by MARS.
C              1 , High.
C              2 , Normal.
C              3 , Low.
C     NIAORB - 0 , Current job is an active mode job.
C              1 , Current job is in interactive edit mode.
C              Set by routine JENVXX.
C
C----<
      INTEGER NFTNOS
      INTEGER NCNDAY
      INTEGER NJMODE
      INTEGER NJOBSQ
      INTEGER NUMBIT
      INTEGER NDBUGS
      INTEGER NDBUGL
      INTEGER NJBCAT
      INTEGER NPRITY
      INTEGER NIAORB
      INTEGER NFLTYP
      INTEGER NUMFIL
      INTEGER NUMREQ
C
      DIMENSION NFTNOS(12)
      DIMENSION NUMFIL(5)
C
      COMMON /INTGCOM/ NFTNOS , NCNDAY , NJMODE , NJOBSQ , NUMBIT ,
     C                 NDBUGS , NDBUGL , NJBCAT , NPRITY , NIAORB ,
     C                 NFLTYP , NUMFIL , NUMREQ
C
C     COPSYS - Name of computer operating system.
C              UNICOS
C              COS
C              NOS/VE
C              VMS
C              MVS/XA
C              Set by routine calling MARSXX.
C     CWMACH - Name of machine on which MARS is running.
C              CRAY
C              CYBER
C              VAX
C              IBM
C              Set by routine JENVXX.
C     CCDATE - Date at start of job in yymmdd format.
C              Set by routine JENVXX.
C     CCTIME - Time at start of job in hhmmss format.
C              Set by routine JENVXX.
C     CJNAME - Name of job or process.
C              Set by routine JENVXX.
C     CACCNT - Account under which job is running.
C     CWMARS - Connect to test or operational MARS/IBM.
C              MATS , Test version.
C              MARS , Operational version.
C              Set by routine JENVXX.
C     CWLANG - Use test or operational version of MARS language.
C              MARSDEF - Operational version.
C              MATSDEF - Test version.
C              Set by routine JENVCO for COS version.
C     CWLAPA - Use test or operational version of MARS language.
C              .../.../marsdef - Operational version.
C              .../.../matsdef - Test version.
C              Set by routine JENVUN for UNICOS version.
C     CWTMDR - Temporary file directory.
C              Set by JENVUN.
C     CWUSER - User name.
C              Set by JENVUN.
C     CUSFDB - FDB Usage indicator.
C              NEVER , Never attempt to access FDB.
C              ALWAYS, Always attempt to access FDB.
C              DEFAULT, Analyse request before deciding usage.
C              Set by JENVUN.
C     CWEDNO - GRIB Code Edition indicator.
C              OFF , use current edition.
C              ON  , use edition 0.
C
      CHARACTER*8   COPSYS
      CHARACTER*8   CWMACH
      CHARACTER*3   CWUSER
      CHARACTER*6   CCDATE
      CHARACTER*6   CCTIME
      CHARACTER*4   CWMARS
      CHARACTER*7   CWLANG
      CHARACTER*7   CUSFDB
      CHARACTER*48  CWLAPA
      CHARACTER*48  CWTMDR
      CHARACTER*16  CJNAME
      CHARACTER*16  CACCNT
      CHARACTER*3   CWEDNO
C
      COMMON /CHARCOM/ COPSYS , CWMACH , CCDATE , CCTIME , CJNAME ,
     C                 CACCNT , CWMARS , CWLANG , CWLAPA , CWTMDR ,
     C                 CWUSER , CUSFDB , CWEDNO
C
      CHARACTER*6 HSYS
      HSYS = COPSYS(1:6)
      RETURN
      END

C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      INTEGER FUNCTION IGTOGR (PIFELDN, PIFELDS, KNINDEX, KSINDEX,
     1   PWFACT, KOWE, POFELD, KPR, KERR)
C
C---->
C**** *IGTOGR*
C
C     Purpose
C     -------
C
C     Perform basic interpolation for one line of latitude of the
C     output field using its two neighbouring input field lines of
C     latitude.
C
C     Interface
C     ---------
C
C     IERR = IGTOGR (PIFELDN, PIFELDS, KNINDEX, KSINDEX, PWFACT,
C    1   KOWE, POFELD, KPR, KERR)
C
C     Input parameters
C     ----------------
C
C     PIFELDN    - The line of latitude of the input field North of
C                  the output row.
C
C     PIFELDS    - The line of latitude of the input field South of
C                  the output row.
C
C     KNINDEX    - This array contains the array offsets of the West
C                  and East points in the input array North of the
C                  output row.
C
C     KSINDEX    - This array contains the array offsets of the West
C                  and East points in the input array South of the
C                  output row.
C
C     PWFACT     - The array of interpolating weights to the four
C                  neighbouring points for every output point of this
C                  line of latitude.
C
C     KOWE       - The number of points in the West-East direction in
C                  the output field.
C
C     KPR        - The debug print switch.
C                  0  , No debugging output.
C                  1  , Produce debugging output.
C
C     KERR       - The error control flag.
C                  -ve, No error message. Return error code.
C                  0  , Hard failure with error message.
C                  +ve, Print error message. Return error code.
C
C     Output parameters
C     -----------------
C
C     POFELD     - The interpolated output field line of latitude
C                  returned to the calling routine.
C
C     Return value
C     ------------
C
C     The error indicator (INTEGER).
C
C     Error and Warning Return Values
C     -------------------------------
C
C     None
C
C     Common block usage
C     ------------------
C
C     None
C
C     Externals
C     ---------
C
C     INTLOG   - Logs messages.
C
C     Method
C     ------
C
C     This routine performs basic linear interpolation using the four
C     neighbouring points in the input array to generate the output
C     array.
C
C     The parameter list is designed to allow for quasi regular input
C     fields with different grid spacing in the Northern and Southern
C     lines of latitude.
C
C     Reference
C     ---------
C
C     None
C
C     Comments
C     --------
C
C     Program contains sections 0 to 2 and 9
C
C     Author
C     ------
C
C     K. Fielding      *ECMWF*      Oct 1993
C
C     Modifications
C     -------------
C
C     Allow for missing data values
C     J.D.Chambers      ECMWF       August 2000
C
C     Force nearest neighbour processing with env variable or
C     INTOUT parameter
C     S.Curic           ECMWF       September 2005
C
C----<
C     -----------------------------------------------------------------|
C
      IMPLICIT NONE
C
#include "parim.h"
#include "nifld.common"
#include "nofld.common"
C
C     Function arguments
C
      INTEGER KOWE, KPR, KERR
      INTEGER KNINDEX (2, KOWE), KSINDEX (2, KOWE)
      REAL PIFELDN (*), PIFELDS (*), POFELD (KOWE)
      REAL PWFACT (4, KOWE)
C
C     Local variables
C
      INTEGER JOLON, COUNT
      CHARACTER*12 YFLAG
      REAL NEAREST
      LOGICAL LVEGGY
C
C     Statement function
C
      REAL A, B
      LOGICAL NOTEQ
      NOTEQ(A,B) = (ABS((A)-(B)).GT.(ABS(A)*1E-3))
C
C     -----------------------------------------------------------------|
C*    Section 1. Initialisation
C     -----------------------------------------------------------------|
C
  100 CONTINUE
C
      IGTOGR = 0
C
      IF( KPR.GE.1 ) THEN
         CALL INTLOG(JP_DEBUG,'IGTOGR: Section 1.',JPQUIET)
         CALL INTLOG(JP_DEBUG,'IGTOGR: Input parameters.',JPQUIET)
         CALL INTLOG(JP_DEBUG,
     X     'IGTOGR:  Number of output field longitudes is -',KOWE)
      ENDIF
C
      LVEGGY = (NITABLE.EQ.128).AND.
     X         ((NIPARAM.EQ.27).OR.
     X          (NIPARAM.EQ.28).OR.
     X          (NIPARAM.EQ.29).OR.
     X          (NIPARAM.EQ.30).OR.
     X          (NIPARAM.EQ.43) )
C     Force nearest neighbour processing with env variable
        CALL GETENV('NEAREST_NEIGHBOUR', YFLAG)
        IF( YFLAG(1:1).EQ.'1' ) LVEGGY = .TRUE.

C     Force nearest neighbour processing with INTOUT parameter
        IF( LMETHOD ) LVEGGY = .TRUE.

      IF( LVEGGY ) CALL INTLOG(JP_DEBUG,
     X  'IGTOGR: nearest neighbour processing (vegetation)',JPQUIET)
C
C     -----------------------------------------------------------------|
C*    Section 2. Basic interpolation
C     -----------------------------------------------------------------|
C
  200 CONTINUE
C
      IF( KPR.GE.1 ) CALL INTLOG(JP_DEBUG,'IGTOGR: Section 2.',JPQUIET)
C
      DO JOLON = 1, KOWE
C
C       Count non-missing data values
C
        IF( LIMISSV ) THEN
          COUNT = 0
          IF( NOTEQ(PIFELDN(KNINDEX(JP_I_W,JOLON)),RMISSGV) )
     X      COUNT = COUNT + 1
          IF( NOTEQ(PIFELDN(KNINDEX(JP_I_E,JOLON)),RMISSGV) )
     X      COUNT = COUNT + 1
          IF( NOTEQ(PIFELDN(KSINDEX(JP_I_W,JOLON)),RMISSGV) )
     X      COUNT = COUNT + 1
          IF( NOTEQ(PIFELDN(KSINDEX(JP_I_E,JOLON)),RMISSGV) )
     X      COUNT = COUNT + 1
        ELSE
          COUNT = 4
        ENDIF
C
C       Interpolate using four neighbours if none are missing
C
        IF( (COUNT.EQ.4).AND.(.NOT.LVEGGY) ) THEN
          POFELD(JOLON) =
     X      PIFELDN(KNINDEX(JP_I_W,JOLON)) * PWFACT(JP_I_NW,JOLON) +
     X      PIFELDN(KNINDEX(JP_I_E,JOLON)) * PWFACT(JP_I_NE,JOLON) +
     X      PIFELDS(KSINDEX(JP_I_W,JOLON)) * PWFACT(JP_I_SW,JOLON) +
     X      PIFELDS(KSINDEX(JP_I_E,JOLON)) * PWFACT(JP_I_SE,JOLON)
C
C       Set missing if all neighbours are missing
C
        ELSE IF( COUNT.EQ.0 ) THEN
          POFELD(JOLON) = RMISSGV
C
C       Otherwise, use the nearest neighbour
C
        ELSE
          NEAREST = PWFACT(JP_I_NW,JOLON)
          POFELD(JOLON) = PIFELDN(KNINDEX(JP_I_W,JOLON))
C
          IF( PWFACT(JP_I_NE,JOLON).GT.NEAREST ) THEN
            NEAREST = PWFACT(JP_I_NE,JOLON)
            POFELD(JOLON) = PIFELDN(KNINDEX(JP_I_E,JOLON))
          ENDIF
C
          IF( PWFACT(JP_I_SW,JOLON).GT.NEAREST ) THEN
            NEAREST = PWFACT(JP_I_SW,JOLON)
            POFELD(JOLON) = PIFELDS(KSINDEX(JP_I_W,JOLON))
          ENDIF
C
          IF( PWFACT(JP_I_SE,JOLON).GT.NEAREST ) THEN
            NEAREST = PWFACT(JP_I_SE,JOLON)
            POFELD(JOLON) = PIFELDS(KSINDEX(JP_I_E,JOLON))
          ENDIF
        ENDIF
C
      ENDDO
C
C     -----------------------------------------------------------------|
C*    Section 9. Return to calling routine. Format statements
C     -----------------------------------------------------------------|
C
  900 CONTINUE
C
      IF( KPR.GE.1 ) CALL INTLOG(JP_DEBUG,'IGTOGR: Section 9.',JPQUIET)
C
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE BUSRQ(KREQ,KRQL,KRQ,RQV,KERR)
C
C**** *BUSRQ*
C
C
C     PURPOSE.
C     --------
C          SET LIST OF BUFR TABLE B ELEMENT REFERENCES
C     FOR PARTIAL EXPANSION.
C
C
C**   INTERFACE.
C     ----------
C
C          *CALL* *BUSRQ(KREQ,KRQL,KRQ,RQV,KERR)*
C
C        INPUT :
C               *KREQ*    -  FLAG
C                            BIT NUMBER     MEANING
C                                1        - 0 NO BIT MAP DELIVERED TO USER
C                                           1    BIT MAP DELIVERED TO USER
C                                2        - 0 NO PARTIAL EXPANSION
C                                           1    PARTIAL EXPANSION
C                                3        - 0 NO Q/C REQUIRED
C                                         - 1    Q/C REQUIRED
C                                4        - 0 NO STATISTICS REQUIRED
C                                         - 1    STATISTICS
C                                5        - 0 NO DIFFRENCE STATISTICS
C                                         - 1    DIFFERENCE STATISTICS
C                                6        - 0 NO SUBSTITUTED VALUES
C                                         - 1    SUBSTITUTED VALUES
C               *KRQL*    -  NUMBER OF REQUESTED ELEMENTS
C               *KRQ*     -  LIST OF REQUESTED TABLE B REFERENCE
C               *RQV*     -  LIST OF VALUES SIGNIFYING REQUESTED ELEMENT
C                            (SAY PRESSURE  AT 50000 PA)
C        OUTPUT:
C               *KERR*    -  RETURNED ERROR CODE
C
C
C     METHOD.
C     -------
C
C          NONE.
C
C
C     EXTERNALS.
C     ----------
C
C          NONE.
C
C     REFERENCE.
C     ----------
C
C          NONE.
C
C     AUTHOR.
C     -------
C
C          M. DRAGOSAVAC    *ECMWF*       15/01/91.
C
C
C     MODIFICATIONS.
C     --------------
C
C          NONE.
C
C
      IMPLICIT LOGICAL(L,O,G), CHARACTER*8(C,H,Y)
C
C
#     include "parameter.F"
#     include "bcomunit.F"
#     include "bcomreq.F"
#     include "bcomdefc.F"
C
      CHARACTER*4 CUSER,CECMWF
      DIMENSION KRQ(*),KREQ(*)
#ifndef R_4
      REAL*8 RQV(*)
      REAL*8 RQVAL
#else
      REAL   RQV(*)
      REAL   RQVAL
#endif
C
C     ------------------------------------------------------------------
C*          1. MOVE REQUESTED ELEMENTS INTO COMMON BLOCK /COMREQ/.
C              ---------------------------------------------------
 100  CONTINUE
C
      IF(KERR.GT.0) RETURN
C
      CUSER='USER'
C
      NRQL=KRQL
      NREQ(1)=KREQ(1)
      NREQ(2)=KREQ(2)
C
      DO 101 I=1,KRQL
      NRQ(I)=KRQ(I)
      RQVAL(I)=RQV(I)
 101  CONTINUE
C
      RETURN
      END

C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE XYZ2LL(X,Y,Z,RLAT,RLONG,INROW)
C---->
C**** XYZ2LL
C
C     Purpose
C     -------
C
C     Converts an array of (x,y,z) coordinates to an
C     array of latitude/longitude values.
C
C
C     Interface
C     ---------
C
C     CALL XYZ2LL(X,Y,Z,RLAT,RLONG,INROW)
C
C     Input
C     -----
C
C     (X,Y,Z) - Array of coordinates.
C     INROW   - Count of coordinates.
C
C
C     Output
C     ------
C
C     RLAT  - Array of latitudes.
C     RLONG - Array of corresponding longitudes.
C
C
C     Method
C     ------
C
C     Z axis is the polar axis directed from south to north.
C     X and Y axes are in the equatorial plane and have origin at the
C     centre of the Earth. The X axis passes through (O north, 0 east).
C     Longitude values are in range (0,360).
C
C
C     Externals
C     ---------
C
C     None.
C
C
C     Author
C     ------
C
C     J.D.Chambers     ECMWF
C
C----<
C
      IMPLICIT NONE
C
C     Subroutine arguments
C
      REAL X,Y,Z,RLAT,RLONG
      DIMENSION X(*),Y(*),Z(*),RLAT(*),RLONG(*)
      INTEGER INROW
C
C     Local variables
C
      REAL*8 FACTOR
      DATA FACTOR/57.2957763671875/
      INTEGER LOOP
C
      DO LOOP = 1, INROW
        RLAT(LOOP)  = ASIN(Z(LOOP)) * FACTOR
      ENDDO
C
      DO LOOP = 1, INROW
        IF( ABS(X(LOOP)).GT.0.0001 ) THEN
          RLONG(LOOP) = ATAN2(Y(LOOP),X(LOOP)) * FACTOR
        ELSE IF ( Y(LOOP).GT.0.0 ) THEN
          RLONG(LOOP) = 90.0
        ELSE
          RLONG(LOOP) = -90.0
        ENDIF
      ENDDO
C
      DO LOOP = 1, INROW
        IF(RLONG(LOOP).LT.0.0) RLONG(LOOP) = RLONG(LOOP) + 360.0
      ENDDO
C
      RETURN
      END

C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE SBYTES (D,S,ISKIP1,IBSIZ,ISKIP2,NBYTES,KWOFF)
C
C---->
C**** SBYTES - Insert a number of bit fields. Cray routine.
C
C REVERSES THE ACTION OF GBYTES, TAKING FIELDS FROM S AND
C INSERTING THEM INTO A BIT STRING IN D. SEE GBYTES.
C AUTHOR D. ROBERTSON  AUG,1981
C
C----<
      PARAMETER(NBPW=64)
      DIMENSION D(2) , S(NBYTES)
      INTEGER SH1,SH2,SH3
      IGNORE = 0
#ifdef CRAY
      IF(NUMARG().GT.6) IGNORE = KWOFF
#else
      IF(NUMARG(DUMMY).GT.6) IGNORE = KWOFF
#endif
      ID=1+ISKIP1/(NBPW-IGNORE)
      ISKIP = MOD(ISKIP1,NBPW-IGNORE) + IGNORE
      ISTEP = ISKIP2+IBSIZ
      DO 75 IBYTE = 1 , NBYTES
C WITH THE STARTING WORD AND BIT POSITION KNOWN, THE
C DESIRED INSERTION CAN BE DONE BY
C**      CALL SBYTE(D(ID),S(IBYTE),ISKIP,IBSIZ)
C BUT THE CODE IS SHORT ENOUGH TO GO IN-LINE.
         SH1 = ISKIP+IBSIZ
         IF(SH1.GT.NBPW) GO TO 50
         SH2 = NBPW-SH1
         IF(SH2.LT.0) SH2 = NBPW-SH2
C BYTE GOES INTO 1 WORD OF D.
         D(ID) = SHIFT(OR(AND(SHIFT(D(ID),SH1),MASK(NBPW-IBSIZ)),
     1                   AND(S(IBYTE),SHIFT(MASK(IBSIZ),IBSIZ))),SH2)
         GO TO 65
   50    CONTINUE
C BYTE GOES INTO 2 WORDS OF D.
         SH3 = 2*NBPW-SH1
         D(ID)=OR(AND(D(ID),MASK(ISKIP)),
     1               AND(SHIFT(S(IBYTE),SH3),COMPL(MASK(ISKIP))))
         D(ID+1)=OR(AND(D(ID+1),SHIFT(COMPL(MASK(SH1-NBPW)),NBPW-IGNORE)
     1                 ),
     2              SHIFT(AND(S(IBYTE),COMPL(MASK(SH3))),SH3-IGNORE))
   65    CONTINUE
C UPDATE STARTING WORD AND BIT POSITION
         ISKIP = ISKIP+ISTEP
         IF(ISKIP.LT.NBPW) GO TO 75
         ISKIP = ISKIP - NBPW
         ID = ID+1+ISKIP/(NBPW-IGNORE)
         ISKIP = MOD(ISKIP,NBPW-IGNORE) + IGNORE
   75    CONTINUE
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities
C granted to it by virtue of its status as an intergovernmental organisation
C nor does it submit to any jurisdiction.
C

      INTEGER FUNCTION IAGCNTL(PIFELD, KILEN, POFELD, KOLEN, KILN,
     X   OIWEGLOBE, OINPOLE, OISPOLE, KOLN, OOWEGLOBE, OONPOLE,
     X   OOSPOLE, KPR, KERR)
C
C---->
C**** *IAGCNTL*
C
C     PURPOSE
C     _______
C
C     The global controlling routine for interpolating between
C     regular Gaussian or latitude/longitude fields.
C
C     INTERFACE
C     _________
C
C     IERR = IAGCNTL(PIFELD, KILEN, POFELD, KOLEN, KILN, OIWEGLOBE,
C    X   OINPOLE, OISPOLE, KOLN, OOWEGLOBE, OONPOLE, OOSPOLE, KPR,
C    X   KERR)
C
C     Input parameters
C     ________________
C
C     PIFELD     - The input field provided by the calling routine.
C
C     KILEN      - The length of the input field.
C
C     KOLEN      - The length of the output field.
C
C     KILN       - The Northern line number of the input field within
C                  its Gaussian field.
C
C     OIWEGLOBE  - A flag indicating whether the input field is
C                  global West to East.
C
C     OINPOLE    - A flag indicating whether the North pole is
C                  included in the input field.
C
C     OISPOLE    - A flag indicating whether the South pole is
C                  include in the input field.
C
C     KOLN       - The Northern line number of the output field
C                  within its Gaussian field.
C
C     OOWEGLOBE  - A flag indicating whether the output field is
C                  global West to East.
C
C     OONPOLE    - A flag indicating whether the North pole is
C                  include in the output field.
C
C     OOSPOLE    - A flag indicating whether the South pole is
C                  include in the output field.
C
C     KPR        - The debug print switch.
C                  0  , No debugging output.
C                  1  , Produce debugging output.
C
C     KERR       - The error control flag.
C                  -ve, No error message. Return error code.
C                  0  , Hard failure with error message.
C                  +ve, Print error message. Return error code.
C
C     Output parameters
C     ________________
C
C     POFELD     - The output field returned to the calling routine.
C
C     Return value
C     ____________
C
C     The error indicator (INTEGER).
C
C     Error and Warning Return Values
C     _______________________________
C
C     21801 The input data representation was not valid when the
C           grid was generated. This should not happen as the data
C           representation has been previously validated.
C     21802 The output data representation was not valid when the
C           grid was generated. This should not happen as the data
C           representation has been previously validated.
C     21803 Attempt to produce global West-East field where the input
C           field was not global.
C     21804 Attempt to produce global North-South field where the
C           input field was not global.
C
C     Common block usage
C     __________________
C
C     grspace.h    - The include file contains all the array space
C                    for grid to grid interpolation.
C
C     RIGAUSS      - Real array of input field Gaussian latitudes is
C                    used.
C     ROGAUSS      - Real array of output field Gaussian latitudes is
C                    used.
C
C     MILATG       - The input field latitudes.
C     MILONG       - The input field longitudes.
C     MNSDIST      - The distances to neighbouring latitude lines of
C                    the input field from the associated line of
C                    latitude in the output field.
C     MNSIND       - The latitude line numbers (array offset) of the
C                    input field associated with each line of
C                    latitude in the output field.
C     MOLATG       - The output field latitudes.
C     MOLONG       - The output field longitudes.
C     MWEDIST      - This array holds the distances to neighbouring
C                    longitude points of the input field from the
C                    associated longitude points in the output field.
C     MWEIND       - This array holds the longitude points (array
C                    offset) from the input field associated with
C                    each longitude point in the output field.
C     RINPNT       - Array used to aid vectorisation in processing
C                    precipitation fields.
C     RMAX         - Array used to aid vectorisation in normalising
C                    interpolation weights and processing
C                    precipitation fields.
C     WFACT        - The array of interpolation weights for each
C                    point in the output field.
C
C     nifld.common - This file contains all the input field
C                    definition variables.
C
C     LCHANGE      - Process change flag is used and set.
C     LSMCHNG      - LSM change flag is used and set.
C     LSM          - LSM usage flag is used.
C     LSMPAR       - LSM parameter flag is used.
C     LPREC        - Precipitation flag is used.
C     LWIND        - Wind flag is used.
C     LSTAGGL      - Staggered grid flag
C
C     NIAREA       - Input field area definition (N/W/S/E) is used.
C     NIGAUSS      - Input field Gaussian truncation is used.
C     NIGRID       - Input field grid definition (WE/NS) is used.
C     NINS         - Number of grid points in NS direction for input
C                    field is used.
C     NIREPR       - Input field representation is used.
C     NIWE         - Number of grid points in WE direction for input
C                    field is used.
C
C     nofld.common - This file contains all the output field
C                    definition variables.
C
C     NOAREA       - Output field area definition (N/W/S/E) is used.
C     NOGAUSS      - Output field Gaussian truncation is used.
C     NOGRID       - Output field grid definition (WE/NS) is used.
C     NONS         - Number of grid points in NS direction for output
C                    field is used.
C     NOREPR       - Output field representation is used.
C     NOWE         - Number of grid points in WE direction for output
C                    field is used.
C
C     EXTERNALS
C     _________
C
C     IGDINS     - Calculate the distances between points in an
C                  output latitude array and its North and South
C                  neighbours in the input latitude array.
C     IGDIWE     - Calculate the distances between points in an
C                  output longitude array and its West and East
C                  neighbours in the input longitude array.
C     IGGMEM     - This routine acquires heap space.
C     IGGRID     - Generate the arrays of latitude and longitude
C                  points for a Gaussian truncation and area.
C     IGINT      - Calculate the basic unnormalised interpolation
C                  weights.
C     IGLGRID    - Generate the arrays of latitude and longitude
C                  points for a regular latitude/longitude grid.
C     IGLSMB     - Calculate the effects of the land-sea masks on
C                  the unnormalised interpolation weights.
C     IGLSMD     - Generate the land sea mask file information.
C     IGNORM     - Normalise the array of interpolation weights.
C     IGPLSM     - Force an interpolated land sea mask field back
C                  to a real 0-1 field.
C     IGPOLEG    - Calculates the values at the pole of a regular
C                  latitude/longitude field when the input is a
C                  Gaussian field.
C     IGPOLEW    - Calculates the values at the pole of a regular
C                  latitude/longitude wind field when the input is
C                  a Gaussian field.
C     IGPREC     - Perform additional interpolation for
C                  precipitation fields.
C     ZPREC      - Perform additional interpolation processes
C                  for precipitation
C     IGTOG      - Perform basic interpolation between regular input
C                  and output fields.
C     INTLOG       - Logs messages.
C
C     METHOD
C     ______
C
C     This is purely a controlling routine with all the work being
C     performed in the external routines.
C
C     REFERENCE
C     _________
C
C     None
C
C     COMMENTS
C     ________
C
C     None
C
C     AUTHOR
C     ______
C
C     K. Fielding      *ECMWF*      May 1994
C
C     MODIFICATIONS
C     _____________
C
C     J.Chambers        ECMWF       Oct 1998
C     Allow field type for rotated grids.
C
C     S.Curic           ECMWF       Oct 2005
C     Add zprec routine that Perform checking
C     of precipitation

C----<
C     -----------------------------------------------------------------|
C*    Section 0. Definition of variables.
C     -----------------------------------------------------------------|
C
      IMPLICIT NONE
C
#include "parim.h"
#include "nifld.common"
#include "nofld.common"
#include "grspace.h"
C
C     Parameters
C
      INTEGER JPROUTINE
      PARAMETER (JPROUTINE = 21800)
C
C     Function arguments
C
      LOGICAL OIWEGLOBE, OINPOLE, OISPOLE, OOWEGLOBE, OONPOLE, OOSPOLE
      INTEGER KILEN, KOLEN, KILN, KOLN, KPR, KERR
      REAL PIFELD(KILEN), POFELD(KOLEN)
C
C     Local variables
C
      LOGICAL LFAIL, LERROR, LDEBUG, LREGIN, LREGOUT
      LOGICAL GINSPOLE, GIGLOBE, GISTAND, GONSPOLE, GOGLOBE, GOSTAND
      LOGICAL GPREC,LSM_VALUES
      CHARACTER*256 YIFILE, YOFILE
      CHARACTER*12 YFLAG
      INTEGER IIOFF, IIREC, IOOFF, IOREC, IERR
C
C     Working copies of area and grid arrays that may be changed
C
      INTEGER IILGRID(2), IILLINE(2), IOLGRID(2), IOLLINE(2)
C
C     External functions
C
      INTEGER IGDINS, IGDIWE, IGGMEM, IGGRID, IGINT, IGLGRID,
     X   IGLSMB, IGLSMD, IGNORM, IGPLSM, IGPOLEG, IGPOLEW, IGPREC,
     X   IGTOG, ZPREC
C
C     -----------------------------------------------------------------|
C*    Section 1. Initialisation
C     -----------------------------------------------------------------|
C
  100 CONTINUE
C
      IAGCNTL = 0
      IERR = 0
C
C     Set all flag variables
C
      LDEBUG  = (KPR.GE.1)
      LFAIL   = (KERR.EQ.0)
      LERROR  = (KERR.GE.0)
      LREGIN  = (NIREPR.EQ.JPREGULAR).OR.(NIREPR.EQ.JPREGROT)
      LREGOUT = (NOREPR.EQ.JPREGULAR).OR.(NOREPR.EQ.JPREGROT)
C
      IF( LDEBUG ) THEN
        CALL INTLOG(JP_DEBUG,'IAGCNTL: Section 1.',JPQUIET)
        CALL INTLOG(JP_DEBUG,
     X    'IAGCNTL: Input field definition parameters.',JPQUIET)
        CALL INTLOG(JP_DEBUG,'IAGCNTL: Representation = ',NIREPR)
        IF( NIWE.NE.0 ) CALL INTLOG(JP_DEBUG,
     X    'IAGCNTL: Number W-E = ',NIWE)
        IF( NINS.NE.0 ) CALL INTLOG(JP_DEBUG,
     X    'IAGCNTL: Number N-S = ',NINS)
        IF( (NIREPR.EQ.JPGAUSSIAN).OR.(NIREPR.EQ.JPQUASI) )
     X    CALL INTLOG(JP_DEBUG,'IAGCNTL: Gaussian truncation= ',NIGAUSS)
        IF( LREGIN.AND.(NIGRID(1).NE.0) ) THEN
          CALL INTLOG(JP_DEBUG,'IAGCNTL: Grid WE = ',NIGRID(1))
          CALL INTLOG(JP_DEBUG,'IAGCNTL: Grid NS = ',NIGRID(2))
        ENDIF
        IF( NIAREA(1).NE.0 ) THEN
          CALL INTLOG(JP_DEBUG,'IAGCNTL: Area North = ',NIAREA(1))
          CALL INTLOG(JP_DEBUG,'IAGCNTL: Area West  = ',NIAREA(2))
          CALL INTLOG(JP_DEBUG,'IAGCNTL: Area South = ',NIAREA(3))
          CALL INTLOG(JP_DEBUG,'IAGCNTL: Area East  = ',NIAREA(4))
        ENDIF
C
        CALL INTLOG(JP_DEBUG,
     X    'IAGCNTL: Output field definition parameters.',JPQUIET)
        CALL INTLOG(JP_DEBUG,'IAGCNTL: Representation = ',NOREPR)
        IF( NOWE.NE.0 ) CALL INTLOG(JP_DEBUG,
     X    'IAGCNTL: Number W-E = ',NOWE)
        IF( NONS.NE.0 ) CALL INTLOG(JP_DEBUG,
     X    'IAGCNTL: Number N-S = ',NONS)
        IF( (NOREPR.EQ.JPGAUSSIAN).OR.(NOREPR.EQ.JPQUASI) )
     X    CALL INTLOG(JP_DEBUG,'IAGCNTL: Gaussian truncation= ',NOGAUSS)
        IF( LREGOUT.AND.(NOGRID(1).NE.0) ) THEN
          CALL INTLOG(JP_DEBUG,'IAGCNTL: Grid WE = ',NOGRID(1))
          CALL INTLOG(JP_DEBUG,'IAGCNTL: Grid NS = ',NOGRID(2))
        ENDIF
        IF( NOAREA(1).NE.0 ) THEN
          CALL INTLOG(JP_DEBUG,'IAGCNTL: Area North = ',NOAREA(1))
          CALL INTLOG(JP_DEBUG,'IAGCNTL: Area West  = ',NOAREA(2))
          CALL INTLOG(JP_DEBUG,'IAGCNTL: Area South = ',NOAREA(3))
          CALL INTLOG(JP_DEBUG,'IAGCNTL: Area East  = ',NOAREA(4))
        ENDIF
C
        CALL INTLOG(JP_DEBUG,'IAGCNTL: Control flag status:',JPQUIET)
C
        IF( LSMCHNG ) THEN
          CALL INTLOG(JP_DEBUG,'IAGCNTL: LSM change TRUE',JPQUIET)
        ELSE
          CALL INTLOG(JP_DEBUG,'IAGCNTL: LSM change FALSE',JPQUIET)
        ENDIF
C
        IF( LSM ) THEN
          CALL INTLOG(JP_DEBUG,'IAGCNTL: LSM flag TRUE',JPQUIET)
        ELSE
          CALL INTLOG(JP_DEBUG,'IAGCNTL: LSM flag FALSE',JPQUIET)
        ENDIF
C
        IF( LWIND ) THEN
          CALL INTLOG(JP_DEBUG,'IAGCNTL: Wind flag TRUE',JPQUIET)
        ELSE
          CALL INTLOG(JP_DEBUG,'IAGCNTL: Wind flag FALSE',JPQUIET)
        ENDIF
C
        IF( LPREC ) THEN
          CALL INTLOG(JP_DEBUG,'IAGCNTL: Precipitn flag TRUE',JPQUIET)
        ELSE
          CALL INTLOG(JP_DEBUG,'IAGCNTL: Precipitn flag FALSE',JPQUIET)
        ENDIF
C
        IF( LSMPAR ) THEN
          CALL INTLOG(JP_DEBUG,'IAGCNTL: LSM param flag TRUE',JPQUIET)
        ELSE
          CALL INTLOG(JP_DEBUG,'IAGCNTL: LSM param flag FALSE',JPQUIET)
        ENDIF
        IF( LSTAGGL ) THEN
          CALL INTLOG(JP_DEBUG,'IAGCNTL: Staggered flag TRUE',JPQUIET)
        ELSE
          CALL INTLOG(JP_DEBUG,'IAGCNTL: Staggered flag FALSE',JPQUIET)
        ENDIF
      ENDIF
C
C     The change of definition option spans sections 2 to 3
C
      IF( LCHANGE ) THEN
C
C     -----------------------------------------------------------------|
C*    Section 2. Calculate space requirement.
C     -----------------------------------------------------------------|
C
  200   CONTINUE
C
        IF( LDEBUG ) CALL INTLOG(JP_DEBUG,'IAGCNTL: Section 2.',JPQUIET)
C
C       Get the required memory
C
        IAGCNTL = IGGMEM(KPR, KERR)
        IF( IAGCNTL.GT.0 ) GOTO 900
C
C       Input grid definition
C
        IF( NIREPR.EQ.JPGAUSSIAN ) THEN
C
          IAGCNTL = IGGRID(NIGAUSS, NIAREA, KILN, RIGAUSS,
     X                     MILONG,NIWE,MILATG,NINS,OIWEGLOBE,KPR,KERR)
          IF( IAGCNTL.GT.0 ) GOTO 900
C
        ELSEIF( LREGIN ) THEN
C
          IAGCNTL = IGLGRID(NIGRID, NIAREA, MILONG, NIWE, MILATG,
     X                      NINS,OIWEGLOBE,KPR,KERR)
          IF( IAGCNTL.GT.0 ) GOTO 900
C
        ELSE
C
          IAGCNTL = JPROUTINE + 1
          IF( LERROR ) THEN
            CALL INTLOG(JP_ERROR,
     X        'IAGCNTL: Illegal input representation = ',NIREPR)
            IF( LFAIL ) CALL INTLOG(JP_FATAL,
     X        'IAGCNTL: Interpolation failing.',JPQUIET)
          ENDIF
          GOTO 900
C
        ENDIF
C
C       Is the input field global
C
        GINSPOLE = OINPOLE.AND.OISPOLE
        GIGLOBE  = OIWEGLOBE.AND.GINSPOLE
C
C       Output grid definition
C
C       Is the output field global North South
C
        GONSPOLE = OONPOLE.AND.OOSPOLE
        GOGLOBE  = OOWEGLOBE.AND.GONSPOLE
        LGLOBL   = (GOGLOBE.AND.NOAREA(2).EQ.0)
C
        IF( NOREPR.EQ.JPGAUSSIAN ) THEN
C
          IAGCNTL = IGGRID(NOGAUSS, NOAREA, KOLN, ROGAUSS,
     X                     MOLONG,NOWE,MOLATG,NONS,OOWEGLOBE,KPR,KERR)
          IF( IAGCNTL.GT.0 ) GOTO 900
C
        ELSEIF( LREGOUT ) THEN
C
          IAGCNTL = IGLGRID(NOGRID, NOAREA, MOLONG, NOWE, MOLATG,
     X                      NONS,OOWEGLOBE,KPR,KERR)
          IF( IAGCNTL.GT.0 ) GOTO 900
C
        ELSE
C
          IAGCNTL = JPROUTINE + 2
          IF( LERROR ) THEN
            CALL INTLOG(JP_ERROR,
     X        'IAGCNTL: Illegal output representation = ',NOREPR)
            IF( LFAIL ) CALL INTLOG(JP_FATAL,
     X        'IAGCNTL: Interpolation failing.',JPQUIET)
          ENDIF
          GOTO 900
C
        ENDIF
C
C     -----------------------------------------------------------------|
C*    Section 3. Create output to input grid mapping and distance arrays
C     -----------------------------------------------------------------|
C
  300   CONTINUE
C
        IF( LDEBUG )
     X    CALL INTLOG(JP_DEBUG,'IAGCNTL: Section 3.',JPQUIET)
C
C       First check that the input and output fields are compatible.
C
        IF( .NOT.GIGLOBE ) THEN
C
          IF( .NOT.OIWEGLOBE ) THEN
C
C           Cannot produce global output field if input not global
C
            IF( OOWEGLOBE ) THEN
              IAGCNTL = JPROUTINE + 3
              IF( LERROR ) THEN
                CALL INTLOG(JP_ERROR,
     X           'IAGCNTL: Cannot produce global output from',JPQUIET)
                CALL INTLOG(JP_ERROR,
     X            'IAGCNTL: non-global input.  The W-E input',JPQUIET)
                CALL INTLOG(JP_ERROR,
     X            'IAGCNTL: direction was not global.',JPQUIET)
                IF( LFAIL ) CALL INTLOG(JP_FATAL,
     X            'IAGCNTL: Interpolation failing.',JPQUIET)
              ENDIF
              GOTO 900
            ENDIF
C
          ENDIF
C
c Sinisa added NOT.LSTAGGL just for the sake of staggered grids
C
          IF( .NOT.GINSPOLE.AND.(.NOT.LSTAGGL) ) THEN
C
C           Cannot produce global output field if input not global
C
            IF( GONSPOLE ) THEN
              IAGCNTL = JPROUTINE + 4
              IF( LERROR ) THEN
                CALL INTLOG(JP_ERROR,
     X           'IAGCNTL: Cannot produce global output from',JPQUIET)
                CALL INTLOG(JP_ERROR,
     X            'IAGCNTL: non-global input.  The N-S input',JPQUIET)
                CALL INTLOG(JP_ERROR,
     X            'IAGCNTL: direction was not global.',JPQUIET)
                IF( LFAIL ) CALL INTLOG(JP_FATAL,
     X            'IAGCNTL: Interpolation failing.',JPQUIET)
              ENDIF
              GOTO 900
            ENDIF
C
          ENDIF
C
        ENDIF
C
        IAGCNTL = IGDINS(MILATG, NINS, MOLATG, NONS, OINPOLE, OISPOLE,
     X                   MNSIND, MNSDIST, KPR, KERR)
        IF( IAGCNTL.GT.0 ) GOTO 900
C
        IAGCNTL = IGDIWE(NIWE, NOWE, MWEIND, MWEDIST, NIAREA, NOAREA,
     X    MILONG, MOLONG, OIWEGLOBE )  ! FIXME: remove
        IF( IAGCNTL.GT.0 ) GOTO 900
C
C       The end of primary initialisation
C
      ENDIF
C
C     -----------------------------------------------------------------|
C*    Section 4. Create normalised weight arrays
C     -----------------------------------------------------------------|
C
  400 CONTINUE
C
      IF( LDEBUG ) CALL INTLOG(JP_DEBUG,'IAGCNTL: Section 4.',JPQUIET)
C
C     The following code is affected by the Land Sea mask flag
C
      IF( LCHANGE.OR.LSMCHNG ) THEN
C
        IAGCNTL = IGINT(MWEDIST, NOWE, MNSDIST, NONS, WFACT, KPR, KERR)
        IF( IAGCNTL.GT.0 ) GOTO 900
C
        IF( LSM ) THEN
C
          IAGCNTL = IGLSMD(NIDATE,NIREPR,NIGRID,NIGAUSS,NIAREA,KILN,
     X                    YIFILE,GISTAND,IILGRID,IILLINE,IIREC,KPR,KERR)
          IF( IAGCNTL.GT.0 ) GOTO 900
C
          IAGCNTL = IGLSMD(NODATE,NOREPR,NOGRID,NOGAUSS,NOAREA,KOLN,
     X                    YOFILE,GOSTAND,IOLGRID,IOLLINE,IOREC,KPR,KERR)
          IF( IAGCNTL.GT.0 ) GOTO 900
C
          IAGCNTL = IGLSMB(GISTAND, YIFILE, IIREC, IILGRID, IILLINE,
     X                    GOSTAND,YOFILE,IOREC,IOLGRID,IOLLINE,KPR,KERR)
          IF( IAGCNTL.GT.0 ) GOTO 900
C
        ENDIF
C
C     Normalise the weights
C
        IAGCNTL = IGNORM(WFACT, RMAX, NOWE, NONS, KPR, KERR)
        IF( IAGCNTL.GT.0 ) GOTO 900
C
C     This marks the end of a change to the specification
C     Clear the Change flags LCHANGE and LSMCHNG
C
        LCHANGE = .FALSE.
        LSMCHNG = .FALSE.
C
      ENDIF
C
C     -----------------------------------------------------------------|
C*    Section 5. Basic interpolation from input to output field
C     -----------------------------------------------------------------|
C
  500 CONTINUE
C
      IF( LDEBUG ) CALL INTLOG(JP_DEBUG,'IAGCNTL: Section 5.',JPQUIET)
C
      IAGCNTL = IGTOG(PIFELD, NIWE, NINS, NOWE, NONS, MWEIND, MNSIND,
     X                WFACT, POFELD, KPR, KERR)
      IF( IAGCNTL.GT.0 ) GOTO 900
C
C     -----------------------------------------------------------------|
C*    Section 6. Additional interpolations from input to output field
C     -----------------------------------------------------------------|
C
  600 CONTINUE
C
      IF( LDEBUG ) CALL INTLOG(JP_DEBUG,'IAGCNTL: Section 6.',JPQUIET)
C
C     Precipitation field
C
C     Force processing without neighbour check
        GPREC = .FALSE.
        CALL GETENV('PRECIPITATION_NEIGHBOUR_CHECK', YFLAG)
        IF( YFLAG(1:1).EQ.'0' ) GPREC = .TRUE.

      IF( LPREC ) THEN
C
        IF( GPREC ) THEN
          IAGCNTL = ZPREC(POFELD, NOWE, NONS, KPR, KERR)
        ELSE
          IAGCNTL = IGPREC(PIFELD, NIWE, NINS, POFELD, NOWE, NONS,
     X                   MWEIND, MNSIND, WFACT, RMAX, RINPNT, KPR, KERR)
        ENDIF
C
        IF( IAGCNTL.GT.0 ) GOTO 900
      ENDIF
C
C     Special code for poles if Gaussian input and regular output
C
C     North pole
C
C    Sinisa add pole point for staggerd lat-lon grids
      IF( (NIREPR.EQ.JPREGULAR.AND.LSTAGGL).AND.
     X    LREGOUT               .AND.
     X    OINPOLE               .AND.
     X    OONPOLE ) THEN
C
        IIOFF = 1
        IOOFF = 1
C
        IF( LWIND ) THEN
          IAGCNTL = IGPOLEW(PIFELD(IIOFF), NIWE, POFELD(IOOFF),
     X                      NOWE, MWEIND, MWEDIST, KPR, KERR)
        ELSE
           IAGCNTL = IGPOLEG(PIFELD(IIOFF), NIWE, POFELD(IOOFF),
     X                       NOWE, KPR, KERR)
        ENDIF
      ENDIF

      IF( (NIREPR.EQ.JPGAUSSIAN).AND.
     X    LREGOUT               .AND.
     X    OINPOLE               .AND.
     X    OONPOLE ) THEN
C
        IIOFF = 1
        IOOFF = 1
C
        IF( LWIND ) THEN
          IAGCNTL = IGPOLEW(PIFELD(IIOFF), NIWE, POFELD(IOOFF),
     X                      NOWE, MWEIND, MWEDIST, KPR, KERR)
        ELSE
           IAGCNTL = IGPOLEG(PIFELD(IIOFF), NIWE, POFELD(IOOFF),
     X                       NOWE, KPR, KERR)
        ENDIF
        IF( IAGCNTL.GT.0 ) GOTO 900
C
      ENDIF
C
C     South pole
C
C    Sinisa add south pole point for staggerd lat-lon grids
      IF( (NIREPR.EQ.JPREGULAR.AND.LSTAGGL).AND.
     X    LREGOUT               .AND.
     X    OISPOLE               .AND.
     X    OOSPOLE ) THEN
C
        IIOFF = (NINS - 1) * NIWE + 1
        IOOFF = (NONS - 1) * NOWE + 1
C
        IF( LWIND ) THEN
          IAGCNTL = IGPOLEW(PIFELD(IIOFF), NIWE, POFELD(IOOFF),
     X                      NOWE, MWEIND, MWEDIST, KPR, KERR)
        ELSE
          IAGCNTL = IGPOLEG(PIFELD(IIOFF), NIWE, POFELD(IOOFF),
     X                      NOWE, KPR, KERR)
C
        ENDIF
      ENDIF
      IF( (NIREPR.EQ.JPGAUSSIAN).AND.
     X    LREGOUT               .AND.
     X    OISPOLE               .AND.
     X    OOSPOLE ) THEN
C
        IIOFF = (NINS - 1) * NIWE + 1
        IOOFF = (NONS - 1) * NOWE + 1
C
        IF( LWIND ) THEN
          IAGCNTL = IGPOLEW(PIFELD(IIOFF), NIWE, POFELD(IOOFF),
     X                      NOWE, MWEIND, MWEDIST, KPR, KERR)
        ELSE
          IAGCNTL = IGPOLEG(PIFELD(IIOFF), NIWE, POFELD(IOOFF),
     X                      NOWE, KPR, KERR)
        ENDIF
        IF( IAGCNTL.GT.0 ) GOTO 900
C
      ENDIF
C
C     LSM field - must be 0 or 1
C
C     Force processing real LSM
        LSM_VALUES = .FALSE.
        CALL GETENV('LSM_VALUES', YFLAG)
        IF( YFLAG(1:1).EQ.'1' ) LSM_VALUES = .TRUE.

      IF( .NOT.LSM_VALUES.AND.LSMPAR ) THEN
        IAGCNTL = IGPLSM(POFELD, NOWE * NONS, KPR, KERR)
        IF( IAGCNTL.GT.0 ) GOTO 900
      ENDIF
C
C     -----------------------------------------------------------------|
C*    Section 9. Return to calling routine. Format statements
C     -----------------------------------------------------------------|
C
  900 CONTINUE
C
      IF( LDEBUG ) CALL INTLOG(JP_DEBUG,'IAGCNTL: Section 9.',JPQUIET)
C
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      INTEGER FUNCTION IRGRID (KAREA, KLLEN, KLN, PGAUSS, KSTART,
     1   KLATG, KNNS, OWEGLOBE, KPR, KERR)
C
C---->
C**** *IRGRID*
C
C     PURPOSE
C     _______
C
C     Generate the arrays of latitude points and the starting points
C     of the lines of latitude for a quasi regular Gaussian grid.
C
C     INTERFACE
C     _________
C
C     IERR = IRGRID (KAREA, KLLEN, KLN, PGAUSS, KSTART,
C    1   KLATG, KNNS, OWEGLOBE, KPR, KERR)
C
C     Input parameters
C     ________________
C
C     KAREA      - The area definition (N, W, S, E) provided by the
C                  calling routine. (Currently unused).
C
C     KLLEN   - This quasi regular Gaussian line length definition
C                  is for the full grid and not just the North and
C                  South limits selected.
C
C     KLN        - The Northern Gaussian latitude number for this area.
C
C     PGAUSS     - The full list of Gaussian latitudes for this
C                  truncation.
C
C     KNNS       - The number of points in the North-South direction
C                  in this field.
C
C     OWEGLOBE   - This variable will be true if the array of
C                  longitudes spans the globe and it is an input grid.
C                  (Currently unused)
C
C     KPR        - The debug print switch.
C                  0  , No debugging output.
C                  1  , Produce debugging output.
C
C     KERR       - The error control flag.
C                  -ve, No error message. Return error code.
C                  0  , Hard failure with error message.
C                  +ve, Print error message. Return error code.
C
C     Output parameters
C     ________________
C
C     KSTART     - The array offset for each line of latitude within
C                  the quasi regular field.
C
C     KLATG      - The array of latitudes for this Gaussian
C                  truncation and area.
C
C     Return value
C     ____________
C
C     The error indicator (INTEGER).
C
C     Error and Warning Return Values
C     _______________________________
C
C     None
C
C     Common block usage
C     __________________
C
C     None
C
C     EXTERNALS
C     _________
C
C     INTLOG(R)    - Logs messages.
C
C     METHOD
C     ______
C
C     The array KLATG is generated using the information provided by
C     the other parameters. The array KSTART is generated using the
C     array KLLEN. Note that Gaussian latitudes will be stored as
C     NINT (PGAUSS * 1.0E4).
C
C     REFERENCE
C     _________
C
C     None
C
C     COMMENTS
C     ________
C
C     Program contains sections 0 to 3 and 9
C
C     AUTHOR
C     ______
C
C     K. Fielding      *ECMWF*      Nov 1993
C
C     MODIFICATIONS
C     _____________
C
C     None
C
C----<
C     _______________________________________________________
C
C*    Section 0. Definition of variables.
C     _______________________________________________________
C
      IMPLICIT NONE
C
#include "parim.h"
#include "nifld.common"
C
C     Parameters
C
      INTEGER JPROUTINE
      PARAMETER (JPROUTINE = 23700)
C
C     Dummy arguments
C
      LOGICAL OWEGLOBE
      INTEGER KNNS, KLN, KPR, KERR
      INTEGER KAREA (4), KLLEN (KNNS)
      INTEGER KLATG (KNNS), KSTART (KNNS)
      REAL PGAUSS (*)
C
C     Local variables
C
      LOGICAL LPRINT
      INTEGER JLAT
      REAL PNLAT, ZNLAT, MFACTOR
C
C     Function externals
C
C     _______________________________________________________
C
C*    Section 1. Initialisation
C     _______________________________________________________
C
  100 CONTINUE
C
      LPRINT = KPR.NE.0
C
      IF( LPRINT ) CALL INTLOG(JP_DEBUG,'IRGRID: Section 1.',JPQUIET)
C
      IRGRID = 0
C
      IF( LPRINT ) THEN
        CALL INTLOG(JP_DEBUG,'IRGRID: Input parameters.',JPQUIET)
        CALL INTLOG(JP_DEBUG,'IRGRID: N Gaussian line = ',KLN)
        CALL INTLOG(JP_DEBUG,'IRGRID: No. of lat lines = ',KNNS)
        CALL INTLOG(JP_DEBUG,'IRGRID: Area North = ', KAREA(1))
        CALL INTLOG(JP_DEBUG,'IRGRID: Area West  = ', KAREA(2))
        CALL INTLOG(JP_DEBUG,'IRGRID: Area South = ', KAREA(3))
        CALL INTLOG(JP_DEBUG,'IRGRID: Area East  = ', KAREA(4))
        IF( OWEGLOBE ) THEN
          CALL INTLOG(JP_DEBUG,
     X      'IRGRID: Input W-E fld is global.',JPQUIET)
        ELSE
          CALL INTLOG(JP_DEBUG,
     X      'IRGRID: Input W-E fld is NOT global.',JPQUIET)
        ENDIF
      ENDIF
C
C     _______________________________________________________
C
C*    Section 2. Generate start position of lines of latitude
C     _______________________________________________________
C
  200 CONTINUE
C
      IF( LPRINT ) CALL INTLOG(JP_DEBUG,'IRGRID: Section 2.',JPQUIET)
C
      KSTART(1) = 1
      DO JLAT = KLN, KLN + KNNS - 2
        KSTART(JLAT+1) = KSTART(JLAT) + KLLEN(JLAT)
      ENDDO
C
C     _______________________________________________________
C
C*    Section 3. Generate points along a line of meridian
C     _______________________________________________________
C
  300 CONTINUE
C
      IF( LPRINT ) CALL INTLOG(JP_DEBUG,'IRGRID: Section 3.',JPQUIET)
C
      DO JLAT = KLN, KLN + KNNS - 1
C
C       If it is a stretched field, calculate the true latitude and
C       the map factor.
C
        PNLAT = PGAUSS(JLAT)
        IF( RISTRET.NE.0 ) THEN
          CALL STRLAT(PNLAT, RISTRET, 0, ZNLAT, MFACTOR)
        ELSE
          ZNLAT = PNLAT
        ENDIF
        KLATG(JLAT-KLN+1) = NINT(ZNLAT * PPMULT)
      ENDDO
      KAREA(1)   =  KLATG(1)
      KAREA(KLN) =  KLATG(KLN)
      IF( LPRINT ) THEN
        CALL INTLOG(JP_DEBUG,'IRGRID: Modified North = ', KAREA(1))
        CALL INTLOG(JP_DEBUG,'IRGRID: Modified South = ', KAREA(3))
      ENDIF
C
C     _______________________________________________________
C
C*    Section 9. Return to calling routine. Format statements
C     _______________________________________________________
C
  900 CONTINUE
C
      IF( LPRINT ) CALL INTLOG(JP_DEBUG,'IRGRID: Section 9.',JPQUIET)
C
      RETURN
      END

C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      INTEGER FUNCTION INTUVF( KVGRIB, KDGRIB, INLEN,
     X                         KUGRIBO, KVGRIBO, OUTLEN)
C
C---->
C**** INTUVF
C
C     Purpose
C     -------
C
C     Interpolate input vorticity and divergence field to
C     U and V fields.
C
C
C     Interface
C     ---------
C
C     IRET = INTUVF( KVGRIB, KDGRIB, INLEN, KUGRIBO,KVGRIBO,OUTLEN)
C
C     Input
C     -----
C
C     KVGRIB - Input vorticity field  (spectral, GRIB format).
C     KDGRIB - Input divergence field (spectral, GRIB format).
C     INLEN  - Input field length (words).
C
C
C     Output
C     ------
C
C     KUGRIBO - Output U field (GRIB format).
C     KVGRIBO - Output V field (GRIB format).
C     OUTLEN  - Output field length (words).
C
C
C     Method
C     ------
C
C     Convert spectral vorticity/divergence to spectral U/V and then
C     interpolate U and V to output fields.
C
C
C     Externals
C     ---------
C
C     IBASINI - Ensure basic interpolation setup is done.
C     JVOD2UV - Converts spectral vorticity/divergence to spectral U/V.
C     JMEMHAN - Allocate/deallocate scratch memory.
C     INTFAU  - Prepare to interpolate unpacked input field.
C     INTFBU  - Interpolate unpacked input field.
C     INTLOG  - Log error message.
C     RESET_C - Reset interpolation handling options using GRIB product.
C     INSANE  - Ensure no outrageous values given for interpolation.
C
C
C     Author
C     ------
C
C     J.D.Chambers     ECMWF     Jan 1995
C
C     J.D.Chambers     ECMWF        Feb 1997
C     Allow for 64-bit pointers
C
C----<
C     -----------------------------------------------------------------|
C
      IMPLICIT NONE
C
C     Function arguments
C
      INTEGER KVGRIB(*), KDGRIB(*), INLEN
      INTEGER KUGRIBO(*), KVGRIBO(*), OUTLEN
C
#include "parim.h"
#include "nifld.common"
#include "nofld.common"
#include "grfixed.h"
#include "intf.h"
C
C     Parameters
C
      INTEGER JPROUTINE, JPALLOC, JPDEALL, JPSCR3, JPSCR4
      PARAMETER (JPROUTINE = 26800 )
      PARAMETER (JPALLOC = 1) 
      PARAMETER (JPDEALL = 0) 
      PARAMETER (JPSCR3 = 3) 
      PARAMETER (JPSCR4 = 4) 
C
C     Local variables
C
      INTEGER IERR, KPR, ISZVD, ISZUV, IWORD, ISAME
      INTEGER IPVORT, IPDIV, IP_U, IP_V
#ifndef _CRAYFTN
#ifdef POINTER_64
      INTEGER*8 IUV
      INTEGER*8 IVD
#endif
#endif
      REAL UV, VD
      POINTER ( IUV, UV )
      POINTER ( IVD, VD )
      DIMENSION UV( 1 ), VD( 1 )
C
C     Externals
C
      INTEGER INTFAU, INTFBU, RESET_C
      INTEGER IBASINI, INSANE
C
C     -----------------------------------------------------------------|
C*    Section 1.   Initialise
C     -----------------------------------------------------------------|
C
  100 CONTINUE
      INTUVF = 0
      IERR = 0
      KPR = 0
C
C     Ensure that basic initialisation has been done
C
      IERR = IBASINI(0)
      IF( IERR.NE.0 ) THEN
        CALL INTLOG(JP_ERROR,'INTUVF: basic initialise failed',JPQUIET)
        INTUVF = IERR
        GOTO 900
      ENDIF
C
C     -----------------------------------------------------------------|
C*    Section 2.   Unpack the vorticity/divergence fields.
C     -----------------------------------------------------------------|
C
  200 CONTINUE
C
C     Get scratch memory for vorticity/divergence unpacked fields.
C     Vorticity/divergence memory areas are adjacent.
C
C     Need to establish input truncation, so unpack GRIB sections 1
C     and 2.
C
      IERR = 1
      CALL GRIBEX(ISEC0, ISEC1, ISEC2, ZSEC2, ISEC3, ZSEC3, ISEC4,
     X            VD(IPVORT), ISZVD, KVGRIB, INLEN, IWORD, 'I',IERR)
      IF( IERR.NE.0 ) THEN
        CALL INTLOG(JP_ERROR,'INTUVF: GRIBEX decoding failed.',IERR)
        INTUVF = IERR
        GOTO 900
      ENDIF
C
      NIRESO = ISEC2(2)
      ISZVD = (NIRESO+1)*(NIRESO+2)
      IPVORT = 1
      IPDIV  = 1 + ISZVD
      CALL JMEMHAN( JPSCR4, IVD, ISZVD*2, JPALLOC, IERR)
      IF( IERR.NE.0 ) THEN
        CALL INTLOG(JP_ERROR,'INTUVF: Memory allocation fail.',JPQUIET)
        INTUVF = IERR
        GOTO 900
      ENDIF
C
C     Decode data from GRIB code (no checking)
C     Vorticity ...
C
      IWORD = INLEN
      IERR  =  0
      CALL GRSVCK(0)
      IERR = 1
      ISEC3(2) = NINT(RMISSGV)
      ZSEC3(2) = RMISSGV
      CALL GRIBEX(ISEC0, ISEC1, ISEC2, ZSEC2, ISEC3, ZSEC3, ISEC4,
     X            VD(IPVORT), ISZVD, KVGRIB, INLEN, IWORD, 'D',IERR)
      IF( IERR.NE.0 ) THEN
        CALL INTLOG(JP_ERROR,'INTUVF: GRIBEX decoding failed.',IERR)
        INTUVF = IERR
        GOTO 900
      ENDIF
C
C     Divergence ...
C
      IERR = 1
      ISEC3(2) = NINT(RMISSGV)
      ZSEC3(2) = RMISSGV
      CALL GRIBEX(ISEC0, ISEC1, ISEC2, ZSEC2, ISEC3, ZSEC3, ISEC4,
     X            VD(IPDIV), ISZVD, KDGRIB, INLEN, IWORD, 'D',IERR)
      IF( IERR.NE.0 ) THEN
        CALL INTLOG(JP_ERROR,'INTUVF: GRIBEX decoding failed.',IERR)
        INTUVF = IERR
        GOTO 900
      ENDIF
C
C     Setup interpolation options from input GRIB characteristics.
C
      IERR = RESET_C( ISEC1, ISEC2, ZSEC2, ISEC4)
      IF( IERR.NE.0 ) THEN
        CALL INTLOG(JP_ERROR,
     X    'INTUVF: Setup interp. options from GRIB failed.',JPQUIET)
        INTUVF = IERR
        GOTO 900
      ENDIF
C
C     Check that no outrageous values given for interpolation
C
      ISAME = INSANE()
      IF( ISAME.GT.0 ) THEN
        CALL INTLOG(JP_ERROR,
     X    'INTUVF: Interpolation cannot use given values.',JPQUIET)
        INTUVF = ISAME
        GOTO 900
      ENDIF
C
C     -----------------------------------------------------------------|
C*    Section 3.   Convert spectral vorticity/divergence
C                  to spectral U/V
C     -----------------------------------------------------------------|
C
  300 CONTINUE
C
C     Get scratch memory for U and V spectral fields.
C     U and V memory areas are adjacent.
C
      ISZUV = (NIRESO+1)*(NIRESO+4)
      IP_U = 1
      IP_V = 1 + ISZUV
      CALL JMEMHAN( JPSCR3, IUV, ISZUV*2, JPALLOC, IERR)
      IF( IERR.NE.0 ) THEN
        CALL INTLOG(JP_ERROR,'INTUVF: Memory allocation fail.',JPQUIET)
        INTUVF = IERR
        GOTO 900
      ENDIF
C
C     Generate U and V with same truncation as input fields.
C
      CALL JVOD2UV( VD(IPVORT), VD(IPDIV), NIRESO,
     X              UV(IP_U), UV(IP_V), NIRESO)
C
C     -----------------------------------------------------------------|
C*    Section 4.   Interpolate U field.
C     -----------------------------------------------------------------|
C
  400 CONTINUE
C
C     Prepare to interpolate U field.
C
      NIFORM = 0
      IERR = INTFAU( UV(IP_U), ISZUV, KUGRIBO, OUTLEN)
      IF( IERR.NE.0 ) THEN
        CALL INTLOG(JP_ERROR,
     X    'INTUVF: Prepare to interpolate failed.',IERR)
        INTUVF = IERR
        GOTO 900
      ENDIF
C
C     Interpolate U field.
C
      IERR = INTFBU( UV(IP_U), ISZUV, KUGRIBO, OUTLEN)
C
      IF( IERR.NE.0 ) THEN
        CALL INTLOG(JP_ERROR,'INTUVF: Interpolation failed.',JPQUIET)
        INTUVF = IERR
        GOTO 900
      ENDIF
C
C     -----------------------------------------------------------------|
C*    Section 5.   Interpolate V field.
C     -----------------------------------------------------------------|
C
  500 CONTINUE
C
C     Prepare to interpolate V field.
C
      IERR = INTFAU( UV(IP_V), ISZUV, KVGRIBO, OUTLEN)
      IF( IERR.NE.0 ) THEN
        CALL INTLOG(JP_ERROR,
     X    'INTUVF: Prepare to interpolate failed.',JPQUIET)
        INTUVF = IERR
        GOTO 900
      ENDIF
C
C     Interpolate V field.
C
      IERR = INTFBU( UV(IP_V), ISZUV, KVGRIBO, OUTLEN)
C
      IF( IERR.NE.0 ) THEN
        CALL INTLOG(JP_ERROR,
     X    'INTUVF: Prepare to interpolate failed.',JPQUIET)
        INTUVF = IERR
        GOTO 900
      ENDIF
C
C     -----------------------------------------------------------------|
C*    Section 9.   Closedown.
C     -----------------------------------------------------------------|
C
  900 CONTINUE
C
C     Clear change flags for next product processing
C
      LCHANGE = .FALSE.
      LSMCHNG = .FALSE.
C
C     Return the scratch memory.
C
      CALL JMEMHAN( JPSCR3, IUV, ISZUV*2, JPDEALL, IERR)
      IF( IERR.NE.0 ) THEN
        CALL INTLOG(JP_ERROR,'INTUVF: Memory deallocation fail',JPQUIET)
        INTUVF = IERR
      ENDIF
C
      CALL JMEMHAN( JPSCR4, IVD, ISZVD*2, JPDEALL, IERR)
      IF( IERR.NE.0 ) THEN
        CALL INTLOG(JP_ERROR,'INTUVF: Memory deallocation fail',JPQUIET)
        INTUVF = IERR
      ENDIF
C
      RETURN
      END

C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE INXBIT (KGRIB,KLENG,KNSPT,KPARM,KNUM,KBIT,
     C                   KBLEN,HFUNC,KRET)
C
C---->
C**** INXBIT - Insert/extract bits consecutively in/from a given array
C
C     Purpose.
C     --------
C
C           Take rightmost KBLEN bits from KNUM words of KPARM
C           and insert them consecutively in KGRIB, starting at
C           bit after KNSPT or vice versa.
C
C**   Interface.
C     ----------
C
C           CALL INXBIT (KGRIB,KLENG,KNSPT,KPARM,KNUM,KBIT,
C    C                   KBLEN,KRET)
C
C           Integer    K.
C           Real       P.
C           Logical    O.
C           Character  H.
C
C               Input Parameters.
C               -----------------
C
C               KGRIB      - Array containing bitstream.
C               KLENG      - Length (words) of this array.
C               KNSPT      - Bit number after which insertion or
C                            extraction starts.
C               KPARM      - Array from which bits are taken for
C                            insertion in the bitstream or to which
C                            bits are extracted from the bitstream.
C               KBIT       - Number of bits in computer word.
C               KNUM       - Number of bit fields inserted/extracted.
C               KBLEN      - Number of bits per bit field.
C               HFUNC      - Requested function.
C                            'C' to insert bits in bitstream,
C                            'D' to extract bits from bitstream.
C
C               Output Parameters.
C               ------------------
C
C               KNSPT      - Bit number of last bit inserted/extracted.
C
C               KRET       - Return code.
C                            0 , No error encountered.
C                            1 , Insertion/extraction exceeded
C                                array boundary.
C
C     Method.
C     -------
C
C           Word and offset pointer calculated before calling
C           insertion/extraction routines.
C
C     Externals.
C     ----------
C
C           SBYTES
C           GBYTES
C
C     Reference.
C     ----------
C
C           ECLIB documentation on SBYTES and GBYTES.
C
C     Comments.
C     ---------
C
C           VAX version of routine.
C           Routine contains Sections 0 to 3 and Section 9.
C
C     Author.
C     -------
C
C           J. Hennessy      ECMWF      18.06.91
C
C     Modifications.
C     --------------
C
C           J. Hennessy      ECMWF      08.11.91
C           Parameter KMACH removed from list of input parameters.
C
C           J. Hennessy      ECMWF      12.10.92
C           Dimension of IMASK changed from 64 to 65.
C
C     ----------------------------------------------------------------
C----<
C
C
C
C
C
C
C
C
C
C
C*    Section 0 . Definition of variables. Data statements.
C     ----------------------------------------------------------------
C
C*    Prefix conventions for variable names.
C
C     Logical      L (but not LP), global or common.
C                  O, dummy arguments.
C                  G, local variable.
C                  LP, parameter.
C     Character    C, Global or common.
C                  H, dummy arguments.
C                  Y (but not YP), local variables.
C                  YP, parameter.
C     Integer      M and N, global or common.
C                  K, dummy arguments.
C                  I, local variables.
C                  J (but not JP), loop control.
C                  JP, parameter.
C     Real         A to F and Q to X, global or common.
C                  P (but not PP), dummy arguments.
C                  Z, local variables.
C                  PP, parameter.
C
      INTEGER IND
      INTEGER INUM
      INTEGER IOFF
      INTEGER IPR
      INTEGER IWORD
C
      INTEGER KBIT
      INTEGER KBLEN
      INTEGER KGRIB
      INTEGER KLENG
      INTEGER KNSPT
      INTEGER KNUM
      INTEGER KPARM
      INTEGER KRET
C
      INTEGER J901
C
      DIMENSION KGRIB(KLENG)
      DIMENSION KPARM(*)
C
      CHARACTER*1 HFUNC
C
C
C     Debug print switch.
C
      DATA IPR /0/
C
C     ----------------------------------------------------------------
C
C
C
C
C
C
C
C
C
C
C*    Section 1 . Set initial values.
C     ----------------------------------------------------------------
C
  100 CONTINUE
C
      IF (IPR.EQ.1)
     C   THEN
             WRITE (*,*) 'INXBIT : Section 1.'
             WRITE (*,*) '         Input values used -'
             WRITE (*,9009) KLENG
             WRITE (*,9002) KNSPT
             WRITE (*,9004) KBIT
             WRITE (*,9005) HFUNC
         ENDIF
C
      KRET = 0
C
C     ----------------------------------------------------------------
C
C
C
C
C
C
C
C
C
C
C*    Section 2 . Bit insertion/extraction.
C     ----------------------------------------------------------------
C
  200 CONTINUE
C
      IF (IPR.EQ.1) WRITE (*,*) 'INXBIT : Section 2.'
C
C*    Calculate word pointer and offset.
C
      IWORD = KNSPT / KBIT
      IOFF  = KNSPT - IWORD * KBIT
      IWORD = IWORD + 1
      IF (IPR.EQ.1) WRITE (*,9003) IWORD , IOFF
C
C     Insert/extract bits.
C
      IF (HFUNC.EQ.'C')
     C   THEN
             CALL SBYTES (KGRIB(IWORD),KPARM,IOFF,KBLEN,0,KNUM)
         ELSE
             CALL GBYTES (KGRIB(IWORD),KPARM,IOFF,KBLEN,0,KNUM)
         ENDIF
C
C     Update pointer.
C
      KNSPT = KNSPT + KBLEN * KNUM
C
C     ----------------------------------------------------------------
C
C
C
C
C
C
C
C
C
C
C*    Section 3 . Check out of range.
C    -----------------------------------------------------------------
C
  300 CONTINUE
C
      IF (IPR.EQ.1) WRITE (*,*) 'INXBIT : Section 3.'
C
      IND = KNSPT / KBIT
      IF (IND.GT.KLENG)
     C   THEN
             KRET = 1
             WRITE (*,9001) IND , KLENG
         ENDIF
C
C     ----------------------------------------------------------------
C
C
C
C
C
C
C
C
C
C
C*    Section 9 . Return to calling routine. Format statements.
C     ----------------------------------------------------------------
C
  900 CONTINUE
C
      IF (IPR.EQ.1)
     C   THEN
             INUM = KNUM
             IF (INUM.GT.360)
     C          THEN
                    INUM = 360
                    WRITE (*,9007) INUM
                ENDIF
             DO 901 J901=1,INUM
               IF (HFUNC.EQ.'C')
     C             THEN
                       WRITE (*,9006) KPARM(J901)
                   ELSE
                       WRITE (*,9008) KPARM(J901)
                   ENDIF
  901        CONTINUE
             WRITE (*,*) 'INXBIT : Section 9.'
             WRITE (*,*) '         Output values set -'
             WRITE (*,9002) KNSPT
         ENDIF
C
C
 9001 FORMAT (1H ,'INXBIT : Word ',I8,' is outside array bounds ',I8)
C
 9002 FORMAT (1H ,'         KNSPT  = ',I8)
C
 9003 FORMAT (1H ,'INXBIT : Word is',I8,', bit offset is ',I2)
C
 9004 FORMAT (1H ,'         KBIT   = ',I8)
C
 9005 FORMAT (1H ,'         HFUNC  = ',A)
C
 9006 FORMAT (1H ,'         Inserted value = ',I20)
C
 9007 FORMAT (1H ,'         First ',I9,' values.')
C
 9008 FORMAT (1H ,'         Extracted value = ',I20)
C
 9009 FORMAT (1H ,'         KLENG  = ',I20)
C
      RETURN
C
      END
      SUBROUTINE ABORTX (HNAME)
C
C**** ABORTX - Terminates execution of program.
C
C     Purpose.
C     --------
C
C           Terminates execution of program.
C
C**   Interface.
C     ----------
C
C           CALL ABORTX (HNAME)
C
C           Integer    K.
C           Real       P.
C           Logical    O.
C           Character  H.
C
C               Input Parameters.
C               -----------------
C
C               HNAME      - Name of calling routine.
C
C               Output Parameters.
C               ------------------
C
C               None.
C
C     Method.
C     -------
C
C           Prints message and terminates.
C
C     Externals.
C     ----------
C
C           EXIT
C
C     Reference.
C     ----------
C
C           None.
C
C     Comments.
C     ---------
C
C           VAX version of routine.
C           Routine contains Sections 0 to 1 and Section 9.
C
C     Author.
C     -------
C
C           J. Hennessy      ECMWF      13.11.91
C
C     Modifications.
C     --------------
C
C           None.
C
C     ------------------------------------------------------------------
C
C
C
C
C
C
C
C
C
C
C*    Section 0 . Definition of variables.
C     ------------------------------------------------------------------
C
C*    Prefix conventions for variable names.
C
C     Logical      L (but not LP), global or common.
C                  O, dummy arguments.
C                  G, local variable.
C                  LP, parameter.
C     Character    C, Global or common.
C                  H, dummy arguments.
C                  Y (but not YP), local variables.
C                  YP, parameter.
C     Integer      M and N, global or common.
C                  K, dummy arguments.
C                  I, local variables.
C                  J (but not JP), loop control.
C                  JP, parameter.
C     Real         A to F and Q to X, global or common.
C                  P (but not PP), dummy arguments.
C                  Z, local variables.
C                  PP, parameter.
C
C
      CHARACTER*(*) HNAME
C
C     ------------------------------------------------------------------
C
C
C
C
C
C
C
C
C
C
C*    Section 1 . Print message and terminate.
C     ------------------------------------------------------------------
C
  100 CONTINUE
C
      WRITE (*,9001) HNAME
C
      CALL EXIT (-1)
C
C     ------------------------------------------------------------------
C
C
C
C
C
C
C
C
C
C*    Section 9 . Format statements.
C     ------------------------------------------------------------------
C
  900 CONTINUE
C
 9001 FORMAT (1H ,'ABORTX : Routine ',A,' has requested program',
     C               ' termination.')
C
      RETURN
C
      END
      SUBROUTINE SETPAR (KBIT,KNEG,KPR)
C
C**** SETPAR - Set number of bits in word. Set maximum negative integer.
C
C     Purpose.
C     --------
C
C           Set number of bits in word. Set maximum negative integer.
C
C**   Interface.
C     ----------
C
C           CALL SETPAR (KBIT,KNEG,KPR)
C
C           Integer    K.
C           Real       P.
C           Logical    O.
C           Character  H.
C
C               Input Parameters.
C               -----------------
C
C               KPR        - Debug print switch.
C                            1 , print out.
C                            0 , No print out.
C
C               Output Parameters.
C               ------------------
C
C               KBIT       - Number of bits in computer word.
C
C               KNEG       - Maximum negative integer.
C
C     Method.
C     -------
C
C           Values are assigned.
C
C     Externals.
C     ----------
C
C           None.
C
C     Reference.
C     ----------
C
C           None.
C
C     Comments.
C     ---------
C
C           VAX version of routine.
C           Routine contains Sections 0 to 3 and Section 9.
C
C     Author.
C     -------
C
C           J. Hennessy      ECMWF      28.10.91
C
C     Modifications.
C     --------------
C
C           None.
C
C     ------------------------------------------------------------------
C
C
C
C
C
C
C
C
C
C
C*    Section 0 . Definition of variables. Data statements.
C     ------------------------------------------------------------------
C
C*    Prefix conventions for variable names.
C
C     Logical      L (but not LP), global or common.
C                  O, dummy arguments.
C                  G, local variable.
C                  LP, parameter.
C     Character    C, Global or common.
C                  H, dummy arguments.
C                  Y (but not YP), local variables.
C                  YP, parameter.
C     Integer      M and N, global or common.
C                  K, dummy arguments.
C                  I, local variables.
C                  J (but not JP), loop control.
C                  JP, parameter.
C     Real         A to F and Q to X, global or common.
C                  P (but not PP), dummy arguments.
C                  Z, local variables.
C                  PP, parameter.
C
C
      INTEGER KBIT
      INTEGER KNEG
      INTEGER KPR
C
C     ------------------------------------------------------------------
C
C
C
C
C
C
C
C
C
C
C*    Section 1 . Assign values.
C     ------------------------------------------------------------------
C
  100 CONTINUE
C
      IF (KPR.EQ.1)  WRITE (*,*) ' SETPAR : Section 1.'
C
      KBIT = 32
      KNEG = -2147483648
C
C     ------------------------------------------------------------------
C
C
C
C
C
C
C
C
C
C*    Section 9 . Return to calling routine. Format statements.
C     ------------------------------------------------------------------
C
  900 CONTINUE
C
      IF (KPR.EQ.1)
     C   THEN
             WRITE (*,*) ' SETPAR : Section 9.'
             WRITE (*,*) '          Output values set -'
             WRITE (*,9001) KBIT
             WRITE (*,9002) KNEG
         ENDIF
C
 9001 FORMAT (1H ,'          KBIT = ',I3)
C
 9002 FORMAT (1H ,'          KNEG = ',I22)
C
      RETURN
C
      END
      SUBROUTINE GBITS(NPACK,ISAM,IBIT,NBITS,NSKIP,ITER)
C
C**** GBITS - VAX routine.
C
      DIMENSION NPACK(*),ISAM(*)
      PARAMETER (LENWRD=32)
C
C     ++++++++++
C     CALL GBITS(NPACK,ISAM,IBIT,NBITS,NSKIP,ITER)
C     ++++++++++
C
C     STARTS UNPACKING BITS AT BIT OFFSET IBIT IN ARRAY
C     NPACK.  IT TAKES NBITS AND STORES THEM IN THE LONGWORD
C     ARRAY STARTING AT ISAM.  THEN NSKIP BITS ARE SKIPPED IN
C     NPACK AND THE NEXT FIELD OF NBITS IS UNPACKED INTO THE
C     NEXT ISAM.  THIS IS DONE A TOTAL OF ITER TIMES.
C
C     THIS ROUTINE EXTRACTS BITS FROM VAX WORDS.
C     IT IS SIMILAR TO NCAR'S GBYTE BUT IT WORKS WITH
C     THE NATURAL UNDERLYING STRUCTURE OF THE VAX.
C     ----------
C
      ISW = 1
      GO TO 8
C
C
      ENTRY SBITS(NPACK,ISAM,IBIT,NBITS,NSKIP,ITER)
C
C     ++++++++++
C     CALL SBITS(NPACK,ISAM,IBIT,NBITS,NSKIP,ITER)
C     ++++++++++
C
C     THIS ROUTINE TAKES THE FIRST LONGWORD LOCATED AT
C     ISAM AND STORES IT INTO THE NBITS OF NPACK STARTING AT
C     BIT OFFSET IBIT.  THEN NSKIP BITS ARE SKIPPED IN
C     NPACK AND THE PROCESS IS REPEATED A TOTAL OF ITER TIMES.
C
C     THIS ROUTINE EXTRACTS BITS FROM VAX WORDS.
C     IT IS SIMILAR TO NCAR'S SBYTE BUT IT WORKS WITH
C     THE NATURAL UNDERLYING STRUCTURE OF THE VAX.
C     ----------
      ISW = 2
      GO TO 8
C
C     ++++++++++
      ENTRY G_BYTES(NPACK,ISAM,IBIT,NBITS,NSKIP,ITER)
C     ++++++++++
C
C     CALL G_BYTES(NPACK,ISAM,IBIT,NBITS,NSKIP,ITER)
C     STARTS UNPACKING BITS AT BIT OFFSET IBIT IN ARRAY
C     NPACK.  IT TAKES NBITS AND STORES THEM IN THE LONGWORD
C     ARRAY STARTING AT ISAM.  THEN NSKIP BITS ARE SKIPPED IN
C     NPACK AND THE NEXT FIELD OF NBITS IS UNPACKED INTO THE
C     NEXT ISAM.  THIS IS DONE A TOTAL OF ITER TIMES.
C
C     THIS ROUTINE DEALS WITH BITS AND BYTES IN THE ORDER
C     THEY ARE NUMBERED ON THE MESA (IE BIGENDIAN).
C     ----------
      ISW = 3
      GO TO 8
C
C     ++++++++++
      ENTRY S_BYTES(NPACK,ISAM,IBIT,NBITS,NSKIP,ITER)
C     ++++++++++
C
C     CALL S_BYTES(NPACK,ISAM,IBIT,NBITS,NSKIP,ITER)
C     THIS ROUTINE TAKES THE FIRST LONGWORD LOCATED AT
C     ISAM AND STORES IT INTO THE NBITS OF NPACK STARTING AT
C     BIT OFFSET IBIT.  THEN NSKIP BITS ARE SKIPPED IN
C     NPACK AND THE PROCESS IS REPEATED A TOTAL OF ITER TIMES.
C
C
C     THIS ROUTINE DEALS WITH BITS AND BYTES IN THE ORDER
C     THEY ARE NUMBERED ON THE MESA (IE BIGENDIAN).
C     ----------
      ISW = 4
      GOTO 8
C
C     ++++++++++
      ENTRY GBYTES(NPACK,ISAM,IBIT,NBITS,NSKIP,ITER)
C     ++++++++++
C
C        THIS ROUTINE IS JUST A REPEATED CALL TO G_BYTE
C        WHERE SUCCESSIVE CALLS SKIP NSKIP BITS
C        AND THE LOOP COUNT IS ITER
      ISW = 5
      GOTO 8
C
C     ++++++++++
      ENTRY SBYTES(NPACK,ISAM,IBIT,NBITS,NSKIP,ITER)
C     ++++++++++
C
C        THIS ROUTINE IS JUST A REPEATED CALL TO S_BYTE
C        WHERE SUCCESSIVE CALLS SKIP NSKIP BITS
C        AND THE LOOP COUNT IS ITER
      ISW = 6
      GO TO 8
C
C     ++++++++++
      ENTRY GBILS(NPACK,ISAM,IBIT,NBITS,NSKIP,ITER)
C     ++++++++++
C
C     GBIL(S)/SBIL(S) ENTRIES ALLOW DIRECT MAINTENANCE OF LEFT TO RIGHT
C     BIT STRINGS IN DEC ENVIRONMENT (VAX). THE MODIFICATION RETAINS FUL
C     COMPATIBILITY WITH ORIGINAL ENTRIES, HOWEVER, VERIFICATION BEYOND
C     GBIL(S)/SBIL(S) WAS VIA GBITS/SBITS ONLY (NOT GBYTES/SBYTES).
C
C     MODIFICATION PROGRAMMED BY A.D.STROUD, COMPASS SYSTEMS, INC.
C     NOVEMBER 1987 UNDER TOGA GRAND FUNDING DURING SOFTWARE DEVELOPMENT
C     FOR WMO PROPOSED STANDARD FM 94 BUFR ON THE VAX STATION II AT THE
C     OAG/NOS/NOAA, MONTEREY, CA.
C
C     FOR GBIL(S)/SBIL(S) THE FOLLOWING PARAMETER USAGE APPLIES
C
C     NPACK   - LEFT MOST(HIGHEST INDEXED) LONGWORD IN PACKED BIT STRING
C               ARRAY SPACE INFERRED BY IBIT(IN LIEU OF LOWEST INDEX FOR
C               NON-DEC, NOTE - SECOND 32 BIT SUBSTRING IN BIT STRING IS
C               NPACK(0), THIRD 32 BIT SUBSTRING IS NPACK(-1), ETC.,...)
C
C     ISAM    - ARRAY HOLDING/TO HOLD UNPACKED ELEMENT(S) (RJZF) FOR
C               SBIL(S)/GBIL(S), RESPECTIVELY.
C
C     IBIT    - INITIAL LEFT TO RIGHT BIT SKIP WITHIN THE NPACK BIT STRI
C               (INCLUDING LEFTMOST BIT OF NPACK, INTERPRET BIT SKIP THE
C                SAME AS IN NON-DEC ENVIRONMENT)
C
C     NBITS   - FIXED BIT WIDTH OF EACH ELEMENT TO BE UNPACKED.
C
C     NSKIP   - FIXED LEFT TO RIGHT BIT SKIP WIDTH BETWEEN ELEMENTS.
C
C     ITER    - NUMBER OF ELEMENTS TO UNPACK(IMPLIED MINIMUM DIMENSIONAL
C               OF ISAM ARRAY).
C
C     !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
C
C     EXAMPLE
C
C  1) PARAMETER (N4=1000 , NB=4000, NL=1000)
C  2) INTEGER I4(N4),UNPACK(99)
C  3) BYTE IB(NB)
C  4) EQUIVALENCE (I4(1),IB(1))
C
C  5) READ(LUI,'(4000A1)') (IB(I),I=NB,1,-1)
C                FORMATTED READ OF ARBITRARY BITSTRING FROM NON-DEC
C                SITE, OR FROM DEC FILE AS WRITTEN AT 9) BELOW.
C
C  6) CALL GBILS(I4(NL),UNPK,67,22,47,95)
C                AFTER INITIALLY SKIPPING 67 BITS TO A POINT BEYOND THE
C                LEFTMOST THREE BITS OF I4(NL-2), GBILS ACQUIRES 95
C                SUBSTRING ELEMENTS OF THE WIDTH 22 BITS(EACH RIGHT JUST
C                WITH HIGH ORDER ZERO FILL) INTO THE RESPECTIVE FIRST
C                95 ARRAY ELEMENTS OF UNPK. SEPARATED BY 47 BITS IN SOUR
C                BITSTRING ARRAY I4, THE EXTRACTED DUPLICATE SUBSTRING
C                ELEMENTS ARE NOW EFFECTIVELY SEPARATED FROM EACH OTHER
C                BY 10 ZERO BITS IN OBJECT BITSTRING ARRAY UNPK.
C
C 7) UNPK(J)=... (J=1,95)
C
C 8) CALL SBILS(I4(NL),UNPK,67,22,47,95)
C                AFTER INITIALLY SKIPPING 67 BITS TO A POINT BEYOND THE
C                LEFTMOST THREE BITS OF I4(NL-2), SBILS STORES IN SUCCES
C                SIVE BITS THE FIRST OF 95 MODIFIED UNPK RIGHTMOST 22 BI
C                WIDTH SUBSTRING ELEMENTS. AFTER SKIPPING 47 BITS BEYOND
C                THE RIGHTMOST OF THE FIRST 22 BITS STORED, THE SECOND 2
C                BIT ELEMENT IS STORED, ETC. THE ORIGINAL SUBSTRING
C                ELEMENTS HAVE BEEN REPLACED BY MODIFIED SUBSRING ELEMEN
C                IN SITU WITHIN THE BITSTRING ARRAY I4 WITHOUT MODIFYING
C                ANY OTHER BITS.
C
C 9) WRITE(LUO,'(4000A1)') (IB(I),I=NB,1,-1)
C                FILE FOR NON-DEC OR FOR READ 5) ABOVE.
C
C
C
      ISW = 7
      GO TO 6
C
C     ++++++++++
      ENTRY SBILS(NPACK,ISAM,IBIT,NBITS,NSKIP,ITER)
C     ++++++++++
C
C
      ISW = 8
      GO TO 6
C
C     ++++++++++
      ENTRY GBIL(NPACK,ISAM,IBIT,NBITS)
C     ++++++++++
C
      ISW = 9
      GO TO 5
C
C     ++++++++++
      ENTRY SBIL(NPACK,ISAM,IBIT,NBITS)
C     ++++++++++
C
      ISW=10
 5    ITER1= 1
      NSKIP1=-NBITS
      GO TO 7
C
 6    NSKIP1=-NSKIP-NBITS
C
 7    JOFF=-IBIT-NBITS
      IF(ISW.LT.9) GO TO 9
      GO TO 10
C
 8    NSKIP1=NSKIP+NBITS
      JOFF=IBIT
C
 9    ITER1=ITER
C
C
 10   DO 30 I = 1 , ITER1
C
         IF(JOFF.GT.0) IBASE=JOFF/LENWRD+1
         IF(JOFF.LE.0) IBASE=(JOFF+1)/LENWRD+1
         IOFF=MOD(JOFF,LENWRD)
         IF(JOFF.LE.0) IOFF=MOD(IOFF+LENWRD,LENWRD)
C
         GO TO(11,12,13,14,15,16,11,12,11,12) ISW
C
11       CALL GBIT(NPACK(IBASE),ISAM(I),IOFF,NBITS)
         GO TO 20
12       CALL SBIT(NPACK(IBASE),ISAM(I),IOFF,NBITS)
         GO TO 20
13       CALL G_BYTe(NPACK(IBASE),ISAM(I),IOFF,NBITS)
         GO TO 20
14       CALL S_BYTE(NPACK(IBASE),ISAM(I),IOFF,NBITS)
         GO TO 20
15       CALL GBYTE(NPACK(IBASE),ISAM(I),IOFF,NBITS)
         GOTO 20
16       CALL SBYTE(NPACK(IBASE),ISAM(I),IOFF,NBITS)
         GOTO 20
20       JOFF = JOFF + NSKIP1
30    CONTINUE
      RETURN
      END
      SUBROUTINE GBYTE(NPACK,ISAM,IBIT,NBITS)
C
C**** GBYTE - VAX routine.
C
C     ++++++++++
C     CALL GBYTE(NPACK,ISAM,IBIT,NBITS)
C     STARTS UNPACKING BITS AT BIT OFFSET IBIT IN ARRAY
C     NPACK.  IT TAKES NBITS AND STORES THEM IN THE LONGWORD
C     ARRAY STARTING AT ISAM.
C
C     THIS ROUTINE DEALS WITH BITS AND BYTES IN THE ORDER
C     THEY ARE NUMBERED ON THE MESA (IE BIGENDIAN).
C     ----------
C
C     GBYTE AND SBYTE ARE SPECIAL ROUTINES TO DO THE SAME
C     THINGS AS THEIR COUNTERPARTS ON THE MESA.
C     THEY DIFFER FROM THE BITS ROUTINES IN THAT BITS
C     ARE COUNTED FROM THE TOP OF THE WORD RATHER THAN
C     THE BOTTOM.  THIS MEANS THAT THE BITS THEY SPECIFY JUMP AROUND
C     WHEN CROSSING BYTE BOUNDARIES.  THERE IS NO ASSUMPTION
C     MADE ABOUT THE WORDSIZE OF THE MACHINE THEY WERE WRITTEN
C     ON.  HOWEVER THE MAXIMUM NUMBER OF BITS EXTRACTED MUST BE
C     LESS THAN OR EQUAL TO 32.
C
      BYTE NPACK(8)
      INTEGER T
      EXTERNAL SS$_ABORT
      IDBIT(I) = 7 - MOD(I,8)
      ISW = 3
      ISAM = 0
      GO TO 10
      ENTRY SBYTE(NPACK,ISAM,IBIT,NBITS)
C     ++++++++++
C     CALL SBYTE(NPACK,ISAM,IBIT,NBITS)
C     THIS ROUTINE TAKES THE FIRST LONGWORD LOCATED AT
C     ISAM AND STORES IT INTO THE NBITS OF NPACK STARTING AT
C     BIT OFFSET IBIT.
C
C
C     THIS ROUTINE DEALS WITH BITS AND BYTES IN THE ORDER
C     THEY ARE NUMBERED ON THE MESA (IE BIGENDIAN).
C     ----------
      ISW = 4
10    IBASE = IBIT/8
C     IBASE POINTS TO THE FIRST BYTE INVOLVED
      IOFF = IBIT - 8*IBASE
C     IOFF IS THE BIT OFFSET WITHIN FIRST BYTE
      M = (IOFF+NBITS-1)/8 + 1
C     M IS THE NUMBER OF BYTES (INCLUDING PARTIALS) INVOLVED
C     IF(M.GT.5)THEN
      IF(NBITS.GT.32)THEN
         TYPE *,'ILLEGAL VALUE FOR NBITS IN S/GBYTE(S) CALL'
         CALL SYS$EXIT(SS$_ABORT)
      END IF
      NN = 0
C     NN IS THE NUMBER OF BITS TRANSFERRED
      DO 20 I = M , 1 , -1
C     LOOP ON BYTES
         IS = IDBIT(0)
C        CALC FIRST BIT WITHIN BYTE
         IE = IDBIT(7)
C        CALC LAST BIT WITHIN BYTE
         IF(I.EQ.1)IS = IDBIT(IOFF)
C        FIRST BIT VARIES FOR FIRST BYTE
         IF(I.EQ.M)IE = IDBIT(IOFF+NBITS-1)
C        LAST BIT VARIES FOR LAST BYTE
         N = IS - IE + 1
C        CALC NUMBER OF BITS WITHIN BYTE TO XFER
         IF(ISW.EQ.4)GO TO 12
         CALL GBIT(NPACK(IBASE+I),T,IE,N)
C        EXTRACT BITS FROM SOURCE
         CALL SBIT(ISAM,T,NN,N)
C        AND LOAD INTO DESTINATION
         GO TO 15
12       CALL GBIT(ISAM,T,NN,N)
C        EXTRACT BITS FROM SOURCE
         CALL SBIT(NPACK(IBASE+I),T,IE,N)
C        AND LOAD INTO DESTINATION
15       NN = NN + N
C        UPDATE BITS XFERRED
20    CONTINUE
      RETURN
      END
      SUBROUTINE G_BYTE(NPACK,ISAM,IBIT,NBITS)
C
C**** G_BYTE - VAX routine.
C
C     G_BYTE AND S_BYTE ARE SPECIAL ROUTINES TO DO THE SAME
C     THINGS AS THEIR COUNTERPARTS ON THE MESA.
C     THEY DIFFER FROM THE BITS ROUTINES IN THAT BITS
C     ARE COUNTED FROM THE TOP OF THE WORD RATHER THAN
C     THE BOTTOM.  THIS MEANS THAT THE BITS THEY SPECIFY JUMP AROUND
C     WHEN CROSSING BYTE BOUNDARIES.  THERE IS NO ASSUMPTION
C     MADE ABOUT THE WORDSIZE OF THE MACHINE THEY WERE WRITTEN
C     ON.  HOWEVER THE MAXIMUM NUMBER OF BITS EXTRACTED MUST BE
C     LESS THAN OR EQUAL TO 32.
C
      BYTE NPACK(8)
      INTEGER T
      EXTERNAL SS$_ABORT
      IDBIT(I) = 7 - MOD(I,8)
      ISW = 3
      ISAM = 0
      GO TO 10
      ENTRY S_BYTE(NPACK,ISAM,IBIT,NBITS)
      ISW = 4
10    IBASE = IBIT/8
C     IBASE POINTS TO THE FIRST BYTE INVOLVED
      IOFF = IBIT - 8*IBASE
C     IOFF IS THE BIT OFFSET WITHIN FIRST BYTE
      M = (IOFF+NBITS-1)/8 + 1
C     M IS THE NUMBER OF BYTES (INCLUDING PARTIALS) INVOLVED
C     IF(M.GT.5)THEN
      IF(NBITS.GT.32)THEN
         TYPE *,'ILLEGAL VALUE FOR NBITS IN S/G_BYTE(S) CALL'
         CALL SYS$EXIT(SS$_ABORT)
      END IF
      NN = 0
C     NN IS THE NUMBER OF BITS TRANSFERRED
      DO 20 I = M , 1 , -1
C     LOOP ON BYTES
         IBB = IBASE + I - 1
         IBC = IBB/4
         IBD = 4*IBC+3-MOD(IBB,4) + 1
C        CALCULATE UNSHIFTED BYTE
         IS = IDBIT(0)
C        CALC FIRST BIT WITHIN BYTE
         IE = IDBIT(7)
C        CALC LAST BIT WITHIN BYTE
         IF(I.EQ.1)IS = IDBIT(IOFF)
C        FIRST BIT VARIES FOR FIRST BYTE
         IF(I.EQ.M)IE = IDBIT(IOFF+NBITS-1)
C        LAST BIT VARIES FOR LAST BYTE
         N = IS - IE + 1
C        CALC NUMBER OF BITS WITHIN BYTE TO XFER
         IF(ISW.EQ.4)GO TO 12
C        CALL GBIT(NPACK(IBASE+I),T,IE,N)
         CALL GBIT(NPACK(IBD),T,IE,N)
C        EXTRACT BITS FROM SOURCE
         CALL SBIT(ISAM,T,NN,N)
C        AND LOAD INTO DESTINATION
         GO TO 15
12       CALL GBIT(ISAM,T,NN,N)
C        EXTRACT BITS FROM SOURCE
C        CALL SBIT(NPACK(IBASE+I),T,IE,N)
         CALL SBIT(NPACK(IBD),T,IE,N)
C        AND LOAD INTO DESTINATION
15       NN = NN + N
C        UPDATE BITS XFERRED
20    CONTINUE
      RETURN
      END

C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      INTEGER FUNCTION HRG2LLW(L12PNT,OLDFLDU,OLDFLDV,KGAUSS,AREA,POLE,
     X                         GRID,NEWFLDU,NEWFLDV,KSIZE,NLON,NLAT)
C
C---->
C**** HRG2LLW
C
C     Purpose
C     -------
C
C     This routine creates a rotated regular lat/long field from a
C     reduced gaussian field using 12-point horizontal interpolation.
C
C
C     Interface
C     ---------
C
C     IRET = HRG2LLW(L12PNT,OLDFLDU,OLDFLDV,KGAUSS,AREA,POLE,GRID,
C    X               NEWFLDU,NEWFLDV,KSIZE,NLON,NLAT)
C
C
C     Input parameters
C     ----------------
C
C     L12PNT - Chooses between 12-point and 4-point interpolation
C     OLDFLDU - The array of values from the reduced gaussian U field
C     OLDFLDV - The array of values from the reduced gaussian V field
C     KGAUSS  - Gaussian number for the reduced gaussian field
C     AREA    - Limits of area (N/W/S/E)
C     POLE    - Pole of rotation (lat/long)
C     GRID    - Grid increments (i/j)
C     KSIZE   - The size of the array to fill with the regular
C               lat/long field
C
C
C     Output parameters
C     -----------------
C
C     NEWFLDU - The array of values for the regular lat/long U field 
C     NEWFLDV - The array of values for the regular lat/long V field 
C     NLON    - Number of longitudes in the regular lat/long field
C     NLAT    - Number of latitudes in the regular lat/long field
C
C     Returns 0 if function successful, non-zero otherwise.
C
C     Common block usage
C     ------------------
C
C     nifld.common
C     nofld.common
C
C
C     Method
C     ------
C
C     Numbering of the points (I is the interpolation point):
C
C                   13       5       6      14
C
C                    7       1       2       8
C                               (I)
C                    9       3       4      10
C
C                   15      11      12      16
C
C     The 12-point interpolation is not possible if either of the top
C     two rows is above the original field northern latitude. The
C     nearest neighbour is used if both rows are above, and a 4-pt
C     bilinear interpolation is used if the top row is above.
C     Similarily, if either of the bottom two rows is below the original
C     field southern latitude.
C
C
C     Externals
C     ---------
C
C     INTLOG  - Log error message.
C     JMALLOC - Dynamically allocate memory
C     JFREE   - Free dynamically allocated memory
C     JGETGG  - Reads the definition of a gaussian grid
C     HGENLLW - Calculates original lat/long (before rotation) for
C               a rotated grid for wind fields.
C     HNEI12  - Finds neighbours for points for interpolation
C     HWTS12  - Calculates weightings for points for interpolation
C
C
C     Reference
C     ---------
C
C     None.
C
C
C     Comments
C     --------
C
C     None.
C
C
C     Author
C     ------
C
C     J.D.Chambers      ECMWF      January 2001
C
C
C     Modifications
C     -------------
C
C     None.
C
C----<
C     -----------------------------------------------------------------|
C*    Section 0. Definition of variables.
C     -----------------------------------------------------------------|
C
      IMPLICIT NONE
C
#include "parim.h"
#include "nifld.common"
#include "nofld.common"
C
C     Parameters
C
      INTEGER JNORTH, JSOUTH, JWEST, JEAST, JW_E, JN_S, JLAT, JLON
      INTEGER JP12PT, JP4PT, JPNEARN
      PARAMETER (JP12PT  = 0)
      PARAMETER (JP4PT   = 1)
      PARAMETER (JPNEARN = 2)
      PARAMETER (JNORTH = 1 )
      PARAMETER (JWEST  = 2 )
      PARAMETER (JSOUTH = 3 )
      PARAMETER (JEAST  = 4 )
      PARAMETER (JW_E  = 1 )
      PARAMETER (JN_S  = 2 )
      PARAMETER (JLAT  = 1 )
      PARAMETER (JLON  = 2 )
C
C     Function arguments
C
      LOGICAL L12PNT
      INTEGER KGAUSS, KSIZE, NLON, NLAT
      REAL AREA(4), POLE(2), GRID(2)
      REAL OLDFLDU(*), OLDFLDV(*)
      REAL NEWFLDU(KSIZE), NEWFLDV(KSIZE)
C
C     Local variables
C
      INTEGER NEXT, LOOP, IRET, NLEN, NPREV, NBYTES, NUMBER
C
      LOGICAL LNEW, LFIRST
      INTEGER KSCHEME(1),NEIGH(12,1), KLA(1)
      REAL PWTS(12,1)
      POINTER (IPKSCHE, KSCHEME)
      POINTER (IPNEIGH, NEIGH)
      POINTER (IPKLA,   KLA)
      POINTER (IPPWTS,  PWTS)
C
      REAL PDLO0(1),PDLO1(1),PDLO2(1),PDLO3(1),PDLAT(1)
      POINTER (IPPDLO0, PDLO0)
      POINTER (IPPDLO1, PDLO1)
      POINTER (IPPDLO2, PDLO2)
      POINTER (IPPDLO3, PDLO3)
      POINTER (IPPDLAT, PDLAT)
C
      INTEGER IGG, IGGOLD
      INTEGER KPTS(1)
      REAL GLATS(1)
      INTEGER IOFFS(1)
      POINTER (IPKPTS,  KPTS)
      POINTER (IPIOFFS, IOFFS)
      POINTER (IPGLATS, GLATS)
C
      INTEGER ILL, ILLOLD
      REAL RCLAT(1),RCLON(1),RLAT(1),RLON(1),RDIR(1),C(1),S(1),U(1),V(1)
      POINTER (IPRCLAT, RCLAT)
      POINTER (IPRCLON, RCLON)
      POINTER (IPRLAT, RLAT)
      POINTER (IPRLON, RLON)
      POINTER (IPRDIR, RDIR)
      POINTER (IPC, C)
      POINTER (IPS, S)
      POINTER (IPU, U)
      POINTER (IPV, V)
C
      REAL OLDU(1), OLDV(1)
      POINTER (IOLDU, OLDU)
      POINTER (IOLDV, OLDV)
C
      DATA NPREV/-1/
      DATA LNEW/.FALSE./, LFIRST/.TRUE./
      DATA IGGOLD/-1/, ILLOLD/-1/, IOLDU/0/, IOLDV/0/
C
      SAVE LNEW, LFIRST
      SAVE IPKSCHE, IPNEIGH, IPKLA, IPPWTS
      SAVE IPPDLO0, IPPDLO1, IPPDLO2, IPPDLO3, IPPDLAT
      SAVE NPREV, IGGOLD, IPKPTS, IPIOFFS, IPGLATS
      SAVE ILLOLD,IPRCLAT,IPRCLON,IPRLAT,IPRLON,IPRDIR,IOLDU,IOLDV
      SAVE IPC, IPS, IPU, IPV
C
C     Externals
C
      INTEGER HNEI12, HGENLLW
#ifdef POINTER_64
      INTEGER*8 JMALLOC
#else
      INTEGER JMALLOC
#endif
C
C     Statement function
C
      REAL A, RADIAN
C
C     Convert degrees to radians
C
      RADIAN(A) = (A) * 0.0174532925
C
C     -----------------------------------------------------------------|
C     Section 1.  Initialise.
C     -----------------------------------------------------------------|
C
  100 CONTINUE
C
      HRG2LLW = 0
C
      CALL JDEBUG()
C
C     Dynamically allocate memory for gaussian grid information.
C
      IGG = KGAUSS*2
C
      IF( IGG.GT.IGGOLD ) THEN
C
        IF( IGGOLD.GT.0 ) CALL JFREE(IPKPTS)
C
        NBYTES = (IGG*JPRLEN) + (2*IGG+1)*JPBYTES
C
        IPKPTS = JMALLOC(NBYTES)
#ifdef hpR64
        IPKPTS = IPKPTS/(1024*1024*1024*4)
#endif
        IF( IPKPTS.EQ.0 ) THEN
          CALL INTLOG(JP_ERROR,'HRG2LLW: Memory allocate fail',JPQUIET)
          HRG2LLW = 1
          GOTO 900
        ENDIF
C
        IPGLATS = IPKPTS  + (IGG*JPBYTES)
        IPIOFFS = IPGLATS + (IGG*JPRLEN)
C
        IGGOLD = IGG
        NPREV = -1
C
      ENDIF
C
C     Build up offsets to start of each latitude in original fields.
C
      IF( KGAUSS.NE.NPREV ) THEN
        CALL JGETGG(KGAUSS,'R',GLATS,KPTS,IRET)
        IF( IRET.NE.0 ) THEN
          CALL INTLOG(JP_ERROR,
     X      'HRG2LLW: JGETGG failed to get gaussian data',JPQUIET)
          HRG2LLW = 2
          GOTO 900
        ENDIF
C
        IOFFS(1) = 1
        DO LOOP = 2, (KGAUSS*2+1)
          IOFFS(LOOP) = IOFFS(LOOP-1) + KPTS(LOOP-1)
        ENDDO
C
C       Allocate memory to preserve the input fields
C       (in case OLDFLDx and NEWFLDx are the same arrays)
C
        IF( IOLDU.GT.0 ) CALL JFREE(IOLDU)
C
        NUMBER = (IOFFS(KGAUSS*2+1) - 1)
        NBYTES = 2 * NUMBER * JPRLEN
C
        IOLDU = JMALLOC(NBYTES)
#ifdef hpR64
        IOLDU = IOLDU/(1024*1024*1024*4)
#endif
        IF( IOLDU.EQ.0 ) THEN
          CALL INTLOG(JP_ERROR,'HRG2LLW: Memory allocate fail',JPQUIET)
          HRG2LLW = 3
          GOTO 900
        ENDIF
        IOLDV = IOLDU + (NUMBER * JPRLEN)
C
        NPREV = KGAUSS
      ENDIF
C
C     Preserve the input fields
C
      DO LOOP = 1, NUMBER
        OLDU(LOOP) = OLDFLDU(LOOP)
        OLDV(LOOP) = OLDFLDV(LOOP)
      ENDDO
C
C     -----------------------------------------------------------------|
C     Section 2.  Generate the lat/long points for the output grid
C     -----------------------------------------------------------------|
C
  200 CONTINUE
C
      NLON = 1 + INT((AREA(JEAST) - AREA(JWEST)) / GRID(JW_E))
      NLAT = 1 + INT((AREA(JNORTH) - AREA(JSOUTH)) / GRID(JN_S))
C
      NLEN = NLON * NLAT

      NOWE = NLON
      NONS = NLAT
C
C     Check that given array is big enough for the new field.
C
      IF( NLEN.GT.KSIZE ) THEN
        CALL INTLOG(JP_ERROR,'HRG2LLW: Given array size = ',KSIZE)
        CALL INTLOG(JP_ERROR,'HRG2LLW: Required size = ',NLEN)
        HRG2LLW = 4
        GOTO 900
      ENDIF
C
C     Dynamically allocate memory for lat/long arrays.
C
      ILL = NLEN
      IF( ILL.GT.ILLOLD ) THEN
C
        LNEW = .TRUE.
C
        IF( ILLOLD.GT.0 ) CALL JFREE(IPRLON)
C
        NBYTES = 9*ILL*JPRLEN
C
        IPRLON = JMALLOC(NBYTES)
#ifdef hpR64
        IPRLON = IPRLON/(1024*1024*1024*4)
#endif
        IF( IPRLON.EQ.0 ) THEN
          CALL INTLOG(JP_ERROR,'HRG2LLW: Memory allocate fail',JPQUIET)
          HRG2LLW = 5
          GOTO 900
        ENDIF
C
        IPRLAT  = IPRLON + (ILL*JPRLEN)
        IPRCLON = IPRLAT + (ILL*JPRLEN)
        IPRCLAT = IPRCLON + (ILL*JPRLEN)
        IPRDIR  = IPRCLAT + (ILL*JPRLEN)
        IPC     = IPRDIR + (ILL*JPRLEN)
        IPS     = IPC    + (ILL*JPRLEN)
        IPU     = IPS    + (ILL*JPRLEN)
        IPV     = IPU    + (ILL*JPRLEN)
C
        ILLOLD = ILL
C
      ENDIF
C
      IRET = HGENLLW(AREA,POLE,GRID,NLON,NLAT,RCLAT,RCLON,RLAT,RLON)
      IF( IRET.NE.0 ) THEN
        CALL INTLOG(JP_ERROR,
     X    'HRG2LLW: HGENLLW failed to get lat/lon grid data',JPQUIET)
        HRG2LLW = 6
        GOTO 900
      ENDIF
C
C     -----------------------------------------------------------------|
C     Section 3.  Find neighbours for each point for interpolation.
C     -----------------------------------------------------------------|
C
  300 CONTINUE
C
C     Dynamically allocate memory for interpolation arrays.
C
      IF( LNEW ) THEN
C
        IF( .NOT.LFIRST ) CALL JFREE(IPPDLO0)
C
        NBYTES = (17*JPRLEN + 14*JPBYTES) * ILL
C
        IPPDLO0 = JMALLOC(NBYTES)
#ifdef hpR64
        IPPDLO0 = IPPDLO0/(1024*1024*1024*4)
#endif
        IF( IPPDLO0.EQ.0 ) THEN
          CALL INTLOG(JP_ERROR,'HRG2LLW: Memory allocate fail',JPQUIET)
          HRG2LLW = 7
          GOTO 900
        ENDIF
C
        IPPDLO1 = IPPDLO0 + (ILL*JPRLEN)
        IPPDLO2 = IPPDLO1 + (ILL*JPRLEN)
        IPPDLO3 = IPPDLO2 + (ILL*JPRLEN)
        IPPDLAT = IPPDLO3 + (ILL*JPRLEN)
        IPPWTS  = IPPDLAT + (ILL*JPRLEN)
        IPKSCHE = IPPWTS  + (12*ILL*JPRLEN)
        IPKLA   = IPKSCHE + (ILL*JPBYTES)
        IPNEIGH = IPKLA   + (ILL*JPBYTES)
C
        LFIRST = .FALSE.
C
      ENDIF
C
C     Find neighbours.
C
      IRET = HNEI12(L12PNT,NLEN,RLAT,RLON,KGAUSS,KPTS,GLATS,
     X              KSCHEME,PDLAT,PDLO0,PDLO1,PDLO2,PDLO3,KLA,NEIGH)
      IF( IRET.NE.0 ) THEN
        CALL INTLOG(JP_ERROR,
     X    'HRG2LLW: HNEI12 failed to find neighbours',JPQUIET)
        HRG2LLW = 8
        GOTO 900
      ENDIF
C
C     -----------------------------------------------------------------|
C     Section 4.  Perform the 12-point horizontal interpolation.
C     -----------------------------------------------------------------|
C
  400 CONTINUE
C
C     Setup the 12-point horizontal interpolation weights
C
      CALL HWTS12
     X  (NLEN,KSCHEME,KLA,PDLAT,GLATS,PDLO0,PDLO1,PDLO2,PDLO3,NEIGH,
     X   PWTS)
C
C     Calculate the interpolated grid point values
C
      DO LOOP = 1, NLEN
        IF( KSCHEME(LOOP).EQ.JP12PT ) THEN
          U(LOOP) =
     X      OLDU(NEIGH( 1,LOOP)) * PWTS( 1,LOOP) +
     X      OLDU(NEIGH( 2,LOOP)) * PWTS( 2,LOOP) +
     X      OLDU(NEIGH( 3,LOOP)) * PWTS( 3,LOOP) +
     X      OLDU(NEIGH( 4,LOOP)) * PWTS( 4,LOOP) +
     X      OLDU(NEIGH( 5,LOOP)) * PWTS( 5,LOOP) +
     X      OLDU(NEIGH( 6,LOOP)) * PWTS( 6,LOOP) +
     X      OLDU(NEIGH( 7,LOOP)) * PWTS( 7,LOOP) +
     X      OLDU(NEIGH( 8,LOOP)) * PWTS( 8,LOOP) +
     X      OLDU(NEIGH( 9,LOOP)) * PWTS( 9,LOOP) +
     X      OLDU(NEIGH(10,LOOP)) * PWTS(10,LOOP) +
     X      OLDU(NEIGH(11,LOOP)) * PWTS(11,LOOP) +
     X      OLDU(NEIGH(12,LOOP)) * PWTS(12,LOOP)
          V(LOOP) =
     X      OLDV(NEIGH( 1,LOOP)) * PWTS( 1,LOOP) +
     X      OLDV(NEIGH( 2,LOOP)) * PWTS( 2,LOOP) +
     X      OLDV(NEIGH( 3,LOOP)) * PWTS( 3,LOOP) +
     X      OLDV(NEIGH( 4,LOOP)) * PWTS( 4,LOOP) +
     X      OLDV(NEIGH( 5,LOOP)) * PWTS( 5,LOOP) +
     X      OLDV(NEIGH( 6,LOOP)) * PWTS( 6,LOOP) +
     X      OLDV(NEIGH( 7,LOOP)) * PWTS( 7,LOOP) +
     X      OLDV(NEIGH( 8,LOOP)) * PWTS( 8,LOOP) +
     X      OLDV(NEIGH( 9,LOOP)) * PWTS( 9,LOOP) +
     X      OLDV(NEIGH(10,LOOP)) * PWTS(10,LOOP) +
     X      OLDV(NEIGH(11,LOOP)) * PWTS(11,LOOP) +
     X      OLDV(NEIGH(12,LOOP)) * PWTS(12,LOOP)
C
        ELSE IF( KSCHEME(LOOP).EQ.JP4PT ) THEN
          U(LOOP) =
     X      OLDU(NEIGH( 1,LOOP)) * PWTS( 1,LOOP) +
     X      OLDU(NEIGH( 2,LOOP)) * PWTS( 2,LOOP) +
     X      OLDU(NEIGH( 3,LOOP)) * PWTS( 3,LOOP) +
     X      OLDU(NEIGH( 4,LOOP)) * PWTS( 4,LOOP)
          V(LOOP) =
     X      OLDV(NEIGH( 1,LOOP)) * PWTS( 1,LOOP) +
     X      OLDV(NEIGH( 2,LOOP)) * PWTS( 2,LOOP) +
     X      OLDV(NEIGH( 3,LOOP)) * PWTS( 3,LOOP) +
     X      OLDV(NEIGH( 4,LOOP)) * PWTS( 4,LOOP)
C
        ELSE
          DO NEXT = 1, 4
            IF( NEIGH(NEXT,LOOP).NE.0 ) THEN
              U(LOOP) = OLDU(NEIGH(NEXT,LOOP))
              V(LOOP) = OLDV(NEIGH(NEXT,LOOP))
            ENDIF
          ENDDO
C
        ENDIF
      ENDDO
C
C     -----------------------------------------------------------------|
C     Section 5.  Adjust the U and V components to new (rotated) axes
C     -----------------------------------------------------------------|
C
  500 CONTINUE
C
      DO LOOP = 1, NLEN
        RDIR(LOOP) = 0.0
      ENDDO
C
      CALL HPSHGPW(RCLON,RCLAT,RLON,RLAT,RDIR,NLEN,POLE)
C
      DO LOOP = 1, NLEN
        RDIR(LOOP) = RADIAN(RDIR(LOOP))
      ENDDO
C
      DO LOOP = 1, NLEN
        C(LOOP) = COS(RDIR(LOOP))
        S(LOOP) = SIN(RDIR(LOOP))
      ENDDO
C
      DO LOOP = 1, NLEN
        NEWFLDU(LOOP) = U(LOOP)*C(LOOP) - V(LOOP)*S(LOOP)
        NEWFLDV(LOOP) = U(LOOP)*S(LOOP) + V(LOOP)*C(LOOP)
      ENDDO
C
C     -----------------------------------------------------------------|
C     Section 9.  Return.
C     -----------------------------------------------------------------|
C
  900 CONTINUE
C
      RETURN
      END

      PROGRAM BUFRREPACK
C
C**** *BUFRREPACK*
C
C
C     PURPOSE.
C     --------
C         REPACKS BUFR  DATA.
C
C
C**   INTERFACE.
C     ----------
C
C          NONE.
C
C     METHOD.
C     -------
C
C          NONE.
C
C
C     EXTERNALS.
C     ----------
C
C         CALL BUSEL
C         CALL BUFREX
C         CALL BUFREN
C         CALL BUPRS0
C         CALL BUPRS1
C         CALL BUPRS2
C         CALL BUPRS3
C         CALL BUPRT
C         CALL BUUKEY
C
C     REFERENCE.
C     ----------
C
C          NONE.
C
C     AUTHOR.
C     -------
C
C          M. DRAGOSAVAC    *ECMWF*       15/02/95.
C
C
C     MODIFICATIONS.
C     --------------
C
C          NONE.
C
C
      IMPLICIT LOGICAL(L,O,G), CHARACTER*8(C,H,Y)
C
      PARAMETER(JSUP =   9,JSEC0=   3,JSEC1= 40,JSEC2=4096 ,JSEC3= 4,
     1       JSEC4=   2,JELEM=160000,JSUBS=400,JCVAL=150 ,JBUFL=512000,
#ifdef JBPW_64
     2          JBPW =  64,JTAB =3000,JCTAB=120,JCTST=1800,JCTEXT=1200,
#else
     2          JBPW =  32,JTAB =3000,JCTAB=120,JCTST=1800,JCTEXT=1200,
#endif
     3          JWORK=4096000,JKEY=46,JBYTE=512000)
C
      PARAMETER (KELEM=40000)
      PARAMETER (KVALS=360000)
C 
      DIMENSION KBUFF(JBUFL)
      DIMENSION KBUFR(JBUFL)
      DIMENSION KSUP(JSUP)  ,KSEC0(JSEC0),KSEC1(JSEC1)
      DIMENSION KSEC2(JSEC2),KSEC3(JSEC3),KSEC4(JSEC4)
      DIMENSION KEY  (JKEY),KREQ(2)
C
      REAL*8 VALUES(KVALS),VALUE(KVALS),RQV(KELEM)
      REAL*8 RVIND,EPS
      DIMENSION KTDLST(KELEM),KTDEXP(KELEM),KRQ(KELEM)
      DIMENSION KTDLST1(KELEM),KTDEXP1(KELEM)
      DIMENSION KDATA(200)
      DIMENSION IOUT(12800)
      dimension iheight(10000)
C
      character*9   callsn(10000),csgn
      CHARACTER*256 CF(100),COUT,CFIN,clist
      CHARACTER*64 CNAMES(KELEM)
      CHARACTER*24 CUNITS(KELEM)
      CHARACTER*80 CVALS(KVALS)
      CHARACTER*80 YENC
      CHARACTER*256 CARG(10)
C
      logical olist
cs      EXTERNAL GETARG
C                                                                       
C     ------------------------------------------------------------------
C*          1. INITIALIZE CONSTANTS AND VARIABLES.
C              -----------------------------------
 100  CONTINUE
C
C     MISSING VALUE INDICATOR
C 
      olist=.false.
      callsn(1)=' '
      iunit2=55
      ITLEN=6400
      ITL=0
      IL=0
      JZ=0
      NW=0
      N=0
      NBYTES=JBPW/8
      RVIND=1.7D38
      NVIND=2147483647
      IOBS=0
      KRQL=0
      NR=2555
      KREQ(1)=0
      KREQ(2)=0
      DO 102 I=1,KELEM
      RQV(I)=RVIND
      KRQ(I)=NVIND
 102  CONTINUE
C
C     INPUT FILE NAMES
C
      NARG=IARGC()
      IF(NARG.LT.4) THEN
      PRINT*,'USAGE - bufr_ship_anmh_ERA -f list -i infile -o outfile'
         STOP
      END IF
      NFILE=NARG
C
      DO 104 J=1,NARG
      CALL GETARG(J,CARG(J))
 104  CONTINUE

      IL=0
      II=0
      IO=0
      DO 105 J=1,NARG
      IF(CARG(J).EQ.'-i') THEN
         IN=J
      ELSEIF(CARG(J).EQ.'-o') THEN
         IO=J
      ELSEIF(CARG(J).EQ.'-f') THEN
         IL=J
      END IF
 105  CONTINUE
C
      IF(IO.EQ.0.OR.IN.EQ.0) THEN
      PRINT*,'USAGE - bufr_ship_anmh_ERA -f list -i infile -o outfile'
         STOP
      END IF
C
      COUT=CARG(IO+1)
C
      if(IL.ne.0) then
         olist=.true.
         clist=carg(IL+1)
C
         jjl=INDEX(clist,' ')
         jjl=jjl-1
      end if
C
C
      JJ=INDEX(COUT,' ')
      JJ=JJ-1
C
      CALL PBOPEN(IUNIT1,COUT(1:JJ),'W',IRET)
      IF(IRET.EQ.-1) STOP 'OPEN FAILED ON BUFR.DAT'
      IF(IRET.EQ.-2) STOP 'INVALID FILE NAME'
      IF(IRET.EQ.-3) STOP 'INVALID OPEN MODE SPECIFIED'
C
      CFIN=CARG(IN+1) 
      ILN=INDEX(CFIN,' ')
      iln=iln-1
C
C*          1.2 OPEN FILE CONTAINING BUFR DATA.
C               -------------------------------
 120  CONTINUE
C
      IRET=0 
      CALL PBOPEN(IUNIT,CFIN(1:ILN),'R',IRET)
      IF(IRET.EQ.-1) STOP 'OPEN FAILED'
      IF(IRET.EQ.-2) STOP 'INVALID FILE NAME'
      IF(IRET.EQ.-3) STOP 'INVALID OPEN MODE SPECIFIED'
C
      IF(OLIST) THEN
         open(iunit2,file=clist(1:jjl),iostat=ios,status='old')
         if(ios.ne.0) then
            stop 'Open error on list'
         end if
C
         I=0
         DO WHILE(IOS.EQ.0)
         I=I+1
         READ(IUNIT2,'(A,1X,I5)',IOSTAT=IOS) CALLSN(I),IHEIGHT(I)
         END DO
C
         close(IUNIT2)
C
      END IF
      NHEIGHT=I-1

C
C     ----------------------------------------------------------------- 
C*          2. SET REQUEST FOR EXPANSION.
C              --------------------------
 200  CONTINUE
C
      OPRT=.FALSE.
      OENC=.TRUE.
      NCOM=1
      OCOMP=.FALSE.
      NR=0
      OSEC3=.FALSE.
C
C*          2.1 SET REQUEST FOR PARTIAL EXPANSION.
C               ----------------------------------
 210  CONTINUE
C
C     SET VARIABLE TO PACK BIG VALUES AS MISSING VALUE INDICATOR
C
      KPMISS=1
      KPRUS=0
      NOKEY=0
      CALL BUPRQ(KPMISS,KPRUS,NOKEY)
C
C     -----------------------------------------------------------------
C*          3.  READ BUFR MESSAGE.
C               ------------------
 300  CONTINUE
C
      IERR=0
      KBUFL=0
C
      IRET=0
      CALL PBBUFR(IUNIT,KBUFF,JBYTE,KBUFL,IRET) 
      IF(IRET.EQ.-1) THEN
          GO TO 900
      END IF
      IF(IRET.EQ.-2) STOP 'FILE HANDLING PROBLEM' 
      IF(IRET.EQ.-3) STOP 'ARRAY TOO SMALL FOR PRODUCT'
C
      N=N+1
      IKBUFL=KBUFL
      KBUFL=KBUFL/NBYTES+1
      IF(N.LT.NR) GO TO 300
C
C     -----------------------------------------------------------------
C*          4. EXPAND BUFR MESSAGE.
C              --------------------
 400  CONTINUE
C
      CALL BUS012(KBUFL,KBUFF,KSUP,KSEC0,KSEC1,KSEC2,KERR)
      IF(KERR.NE.0) THEN
         PRINT*,'ERROR IN BUS012: ',KERR
         PRINT*,' BUFR MESSAGE NUMBER ',N,' CORRUPTED.'
         KERR=0
         CALL EXIT(2)
      END IF
C
      oheight=.false.
       if(ksec1(7).ne.9.and.ksec1(7).ne.11.and.
     1    ksec1(7).ne.13.and.ksec1(7).ne.19.and.
     2    ksec1(7).ne.21) go to 630
c
      IF(KSUP(6).GT.1) THEN
         KEL=JWORK/KSUP(6)
         IF(KEL.GT.JELEM) KEL=JELEM
      ELSE
         KEL=KELEM
      END IF
C
      CALL BUFREX(KBUFL,KBUFF,KSUP,KSEC0 ,KSEC1,KSEC2 ,KSEC3 ,KSEC4,
     1            KEL,CNAMES,CUNITS,KVALS,VALUES,CVALS,IERR)
C
      IF(IERR.NE.0) THEN
         CALL EXIT(2)
      END IF
      IOBS=IOBS+KSEC3(3)
C
      CALL BUSEL(KTDLEN,KTDLST,KTDEXL,KTDEXP,KERR)
      IF(KERR.NE.0) CALL EXIT(2)
C
C*          4.1 PRINT CONTENT OF EXPANDED DATA.
C               -------------------------------
 410  CONTINUE
C
      IF(.NOT.OPRT) GO TO 500
      IF(.NOT.OSEC3) GO TO 450
C
C*          4.2 PRINT SECTION ZERO OF BUFR MESSAGE.
C               -----------------------------------
 420  CONTINUE
C

      CALL BUPRS0(KSEC0)
C
C*          4.3 PRINT SECTION ONE OF BUFR MESSAGE.
C               -----------------------------------
 430  CONTINUE
C
      CALL BUPRS1(KSEC1)
C
C
C*          4.4 PRINT SECTION TWO OF BUFR MESSAGE.
C               -----------------------------------
 440  CONTINUE
C
C              AT ECMWF SECTION 2 CONTAINS RDB KEY.
C              SO UNPACK KEY
C
      CALL BUUKEY(KSEC1,KSEC2,KEY,KSUP,KERR)
C
C              PRINT KEY
C
      CALL BUPRS2(KSUP ,KEY)
C
C*          4.5 PRINT SECTION 3 OF BUFR MESSAGE.
C               -----------------------------------
 450  CONTINUE
C
C               FIRST GET DATA DESCRIPTORS
C
      CALL BUSEL(KTDLEN,KTDLST,KTDEXL,KTDEXP,KERR)
      IF(KERR.NE.0) CALL EXIT(2)
C
C               PRINT  CONTENT
C
      IF(OSEC3) THEN
         CALL BUPRS3(KSEC3,KTDLEN,KTDLST,KTDEXL,KTDEXP,KEL,CNAMES)
      END IF
C
C*         4.6 PRINT SECTION 4 (DATA).
C              -----------------------
 460  CONTINUE
C
C          IN THE CASE OF MANY SUBSETS DEFINE RANGE OF SUBSETS
C
      IF(.NOT.OO) THEN
      WRITE(*,'(A,$)') ' STARTING SUBSET TO BE PRINTED : '
      READ(*,'(BN,I4)')   IST
      WRITE(*,'(A,$)') ' ENDING SUBSET TO BE PRINTED : '
      READ(*,'(BN,I4)')   IEND
      OO=.FALSE.
      END IF
C
C              PRINT DATA
C
      ICODE=0
      CALL BUPRT(ICODE,IST,IEND,KEL,CNAMES,CUNITS,CVALS,
     1           KVALS,VALUES,KSUP,KSEC1,IERR)
C
C              RESOLVE BIT MAPS 
C
      IF(IEND.GT.KSEC3(3)) IEND=KSEC3(3)
C
      DO 461 IK=IST,IEND
C 
      CALL BUBOX(IK,KSUP,KEL,KTDEXP,CNAMES,CUNITS,KVALS,VALUES,
     1           KBOX,KAPP,KLEN,KBOXR,VALS,CBOXN,CBOXU,IERR)
C
      CALL BUPRTBOX(KBOX,KAPP,KLEN,KBOXR,VALS,CBOXN,CBOXU)
C
 461  CONTINUE
C
C     -----------------------------------------------------------------
C*          5. COLLECT DATA FOR REPACKING.
C              ---------------------------
 500  CONTINUE
C      
C     IF(.NOT.OENC) GO TO 300
C
C               FIRST GET DATA DESCRIPTORS
C
      CALL BUSEL(KTDLEN,KTDLST,KTDEXL,KTDEXP,KERR)
      IF(KERR.NE.0) CALL EXIT(2)
C
C     -----------------------------------------------------------------
C*          6. PACK BUFR MESSAGE BACK INTO BUFR.
C              ---------------------------------
 600  CONTINUE
C
    
      KKK=0
      KBUFL=JBUFL
C
C     GET REPLICATION FACTORS
C
      KK=0
      DO 601 K=1,KSUP(5)
      IF(KTDEXP(K).EQ.31001.OR.KTDEXP(K).EQ.31002.OR.
     1   KTDEXP(K).EQ.31000) THEN
         KK=KK+1
         KDATA(KK)=NINT(VALUES(K))
      END IF
 601  CONTINUE
C
      KDLEN=2
      IF(KK.NE.0) KDLEN=KK
C
C     --------------------------------
C     |Modification to sections error|
C     --------------------------------
C
C     If ship already got ship anemometer height 
c     write data to target file
c
      oheight=.false.
      do i=1,ktdlen
       if(KTDLST(i).eq.010197) then
          do j=1,ktdexl
            if(ktdexp(j).eq.010197) then
               jj=j
            end if
          end do
          oheight=.true.
          ist=i
          iend=i
         do iii=1,ksup(6)
           icsgn=1+(iii-1)*kel
           ia=jj+(iii-1)*kel
           ifound=0
           csgn=' '
           if(ksec1(7).eq.21) then
              write(csgn(1:5),'(i5.5)') nint(values(icsgn))
           else
              ipt=nint(values(icsgn))/1000 
              csgn=cvals(ipt)(1:9)
           end if
           call search(callsn,nheight,csgn,ifound)
           if(ifound.ne.0) then
              values(ia)=iheight(ifound)
           else
              values(ia)=rvind
           end if
         end do

          go to 620
       end if
      end do
c
      j=0
      iend=2
      if(ksec1(7).eq.21) iend=1
      do i=1,iend
       j=j+1
       ktdlst1(j)=ktdlst(i)
      end do
c     
      j=j+1
      ktdlst1(j)=010197
      j=j+1
      ktdlst1(j)=222000
      j=j+1
      ktdlst1(j)=101034
      if(ksec1(7).eq.21) ktdlst1(j)=101033
      j=j+1
      ktdlst1(j)=031031
      j=j+1
      ktdlst1(j)=001031
      j=j+1
      ktdlst1(j)=001032
      j=j+1
      ktdlst1(j)=101034
      if(ksec1(7).eq.21) ktdlst1(j)=101033
      j=j+1
      ktdlst1(j)=033007

      ktdlen1=j
      
C
C    ----------------------------------------
C    ! Modification to data section         !
C    ----------------------------------------
C
      ib=0
      do iii=1,ksup(6)
      iend=33
      if(ksec1(7).eq.21) iend=32
      do iiii=1,iend
        ia=iiii+(iii-1)*kel
        ib=ib+1
        ibb=ib+(iii-1)*kel
        value(ibb)=values(ia)
      end do
      end do
c
      iend=34
      if(ksec1(7).eq.21) iend=33
      if(olist) then
         do iii=1,ksup(6)
            icsgn=1+(iii-1)*kel
         do iiii=iend,iend
           ia=iiii+(iii-1)*kel
           ib=ib+1
           ibb=ib+(iii-1)*kel
           ifound=0
           csgn=' '
           if(ksec1(7).eq.21) then
              write(csgn(1:5),'(i5.5)') nint(value(icsgn))
           else
              ipt=nint(value(icsgn))/1000
              csgn=cvals(ipt)(1:9)
           end if
           ifound=0
           call search(callsn,nheight,csgn,ifound)
           if(ifound.ne.0) then
              value(ibb)=iheight(ifound)
           else
              value(ibb)=rvind
           end if
         end do
         end do
      else
         do iii=1,ksup(6)
         do iiii=iend,iend
           ia=iiii+(iii-1)*kel
           ib=ib+1
           ibb=ib+(iii-1)*kel
           value(ibb)=rvind
         end do
         end do
      end if
c
      ist=34
      iend=67
      if(ksec1(7).eq.21) then
         ist=33
         iend=65
      end if
      do iii=1,ksup(6)
      do iiii=ist,iend
        ia=iiii+(iii-1)*kel
        ib=ib+1
        ibb=ib+(iii-1)*kel
        value(ibb)=values(ia)
      end do
      end do
c
c     insert data present indicator
c
      ib=ib+1
      do iii=1,ksup(6)
        ibb=ib+(iii-1)*kel
        value(ibb)=0.
      end do
      ist=68
      iend=102
      if(ksec1(7).eq.21) then
         ist=66
         iend=99
      end if
c
      do iii=1,ksup(6)
      do iiii=ist,iend
        ia=iiii+(iii-1)*kel
        ib=ib+1
        ibb=ib+(iii-1)*kel
        value(ibb)=values(ia)
      end do
      end do
c
c     insert% confidance
c
      ib=ib+1
      do iii=1,ksup(6)
        ibb=ib+(iii-1)*kel
        value(ibb)=70.
      end do
c
      kdata(1)=kdata(1)+1
      kdata(2)=kdata(2)+1
C
C     -----------------------------------------------------------------------
C
C*          6.2 ENCODE DATA INTO BUFR MESSAGE.
C               ------------------------------
 620  CONTINUE
C
      IF(KSEC1(5).NE.0) THEN
         CALL BUUKEY(KSEC1,KSEC2,KEY,KSUP,KERR)
         IF(KERR.NE.0) THEN
            PRINT*,'BUUKEY: ERROR ',KERR
            CALL EXIT(2)
         END IF
      END IF
C
      IF(KSUP(6).EQ.0) THEN
         PRINT*,'ZERO SUBSETS'
         CALL EXIT(2)
      END IF
C
C
C     GET INFORMATION FOR RDB KEY
C
C     CALL BUCREKEY(KEL,KTDEXP,KSUP,KSEC1,KSEC3,KEY,
C    1              VALUES,CVALS,KERR)
C     IF(KERR.NE.0) THEN
C        PRINT*,'ERROR IN BUCREKEY.'
C        CALL EXIT(2)
C     END IF
C
C     PACK NEW RDB KEY
C
      ksec1(5)=128
      ksec2(1)=52
C
      CALL BUPKEY(KEY,KSEC1,KSEC2,KERR)
      IF(KERR.NE.0) CALL EXIT(2)
C
c     KSEC3(4)=128
c     IF(KSEC3(3).GT.1) KSEC3(4)=192
c     IF(KSEC3(4).EQ.0) KSEC3(4)=192
C
      if(oheight) then
      CALL BUFREN( KSEC0,KSEC1,KSEC2,KSEC3,KSEC4,
     1             KTDLEN,KTDLST,KDLEN,KDATA,KEL,        !KSUP(5),
     2             KVALS,VALUES,CVALS,KBUFL,KBUFR,KERR)

      else
      CALL BUFREN( KSEC0,KSEC1,KSEC2,KSEC3,KSEC4,
     1             KTDLEN1,KTDLST1,KDLEN,KDATA,KEL,        !KSUP(5),
     2             KVALS,VALUE,CVALS,KBUFL,KBUFR,KERR)
C
      end if
      IF(KERR.GT.0) THEN
         PRINT*,'ERROR DURING ENCODING.'
         CALL EXIT(2)
      END IF
C
      oheight=.true.
C
C           6.3 WRITE PACKED BUFR MESSAGE INTO FILE.
C               ------------------------------------
 630  CONTINUE
C
      if((ksec1(7).eq.9.or.ksec1(7).eq.11.or.
     1   ksec1(7).eq.13.or.ksec1(7).eq.19.or.
     2   ksec1(7).eq.21).and.oheight) then
         IKBUFL=KBUFL*4
         CALL PBWRITE(IUNIT1,KBUFR,IKBUFL,IERR)
         IF(IERR.LT.0) THEN
            PRINT*,'ERROR WRITING INTO TARGET FILE.'
            CALL EXIT(2)
         END IF
      else
         CALL PBWRITE(IUNIT1,KBUFF,IKBUFL,IERR)
         IF(IERR.LT.0) THEN
            PRINT*,'ERROR WRITING INTO TARGET FILE.'
            CALL EXIT(2)
         END IF
      end if
C
      NW=NW+1
C
      GO TO 300
C     -----------------------------------------------------------------
C
 810  CONTINUE
C
      WRITE(*,'(1H ,A)') 'OPEN ERROR ON INPUT FILE'
      GO TO 900
C      
 800  CONTINUE
C
      IF(IRET.EQ.-1) THEN
         PRINT*,'NUMBER OF RECORDS PROCESSED ',N
         PRINT*,'NUMBER OF RECORDS CONVERTED ',NW
c
      ELSE
         PRINT*,' BUFR : ERROR= ',IERR
      END IF
C
 900  CONTINUE
C
      PRINT*,'NUMBER OF RECORDS PROCESSED ',N
      PRINT*,'NUMBER OF RECORDS CONVERTED ',NW
C
      CALL PBCLOSE(IUNIT,IRET)
C
      CALL PBCLOSE(IUNIT1,IRET)
C
      END
      SUBROUTINE CUTZERO(CHARPAR,KMIN)
C
C**** CUTZERO - SUBROUTINE TO REMOVE ZERO CHARACTERS.
C
C**   PURPOSE
C     -------
C
C     TO REMOVE ZERO-FILL CHARACTERS FROM THE END OF A CHARACTER
C     VARIABLE.
C
C     INTERFACE
C     ---------
C
C     CALL CUTZERO(CHARPAR,KMIN)
C
C          CHARPAR  - CHARACTER VARIABLE WHICH MAY HAVE ZEROS AT THE
C                     END OF THE VALID CHARACTERS, WHICH NEED TO BE
C                     REMOVED;
C                     RETURNED WITH THE ZERO CHARACTERS CONVERTED TO
C                     BLANK.
C
C          KMIN     - INTEGER VARIABLE INDICATING A MINIMUM NUMBER OF
C                     CHARACTERS AT THE BEGINNING OF THE STRING WHICH
C                     MUST NOT BE CHANGED
C
C     THUS:
C
C     CHARPAR='ABC0000'
C     CALL CUTZERO(CHARPAR,4)
C
C     WOULD RETURN THE VALUE 'ABC0   ' IN CHAR, AND WOULD NOT
C     ALTER THE FIRST 4 CHARACTERS.
C
C     METHOD
C     ------
C
C     THE STRIG IS TESTED FOR THE EXISTANCE OF A ZERO CHARACTER.
C     IF NONE IS FOUND, NO CHANGE TAKES PLACE.
C     IF ONE OR MORE ZERO CHARACTERS ARE PRESENT, THE END OF THE
C     STRING IS LOCATED. WORKING BACKWARDS FROM THE END TO THE
C     KMIN-1 POSITION, CHARACTERS ARE TESTED FOR ZERO. IF A ZERO
C     IS FOUND, IT IS REPLACED BY BLANK. IF A NON-ZERO IS FOUND,
C     THE REPLACEMENT LOOP TERMINATES.
C
C     MODIFICATIONS
C     -------------
C
C     ORIGINAL VERSION - 25.01.95 - REX GIBSON - ECMWF.
C
      CHARACTER*(*) CHARPAR
      CHARACTER*1   YZERO
      INTEGER LEN
C
C     -----------------------------------------------------------
C
C*     1.     FIND AND REPLACE THE ZERO CHARACTERS.
C
  100 CONTINUE
      YZERO=CHAR(0)
      I1=INDEX(CHARPAR,'0')
      IF (I1.GT.0) THEN
         I2=MAX(I1,KMIN+1)
         I3=INDEX(CHARPAR,' ')-1
         IF (I3.LE.0) THEN
            I3=LEN(CHARPAR)
         ENDIF
         DO 112 J=I3,I2,-1
         IF (CHARPAR(J:J).EQ.'0') THEN
             CHARPAR(J:J)=' '
         ELSEIF (CHARPAR(J:J).EQ.YZERO) THEN
             GO TO 112
         ELSE
             GO TO 114
         ENDIF
  112    CONTINUE
C
  114    CONTINUE
      ENDIF
C
C     -----------------------------------------------------------
C
C*     2.     RETURN.
C
  200 CONTINUE
C
      END
      SUBROUTINE SEARCH(KARRAY,K,KVAL,KINDEX)
C
C**** *SEARCH*
C
C
C     PURPOSE.
C     --------
C         
C
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *SEARCH(KARRAY,K,KVAL,KINDEX)*
C             KARRAY  - list
C             K       - number of elements in the list
C             KVAL    - value to be searched for
C             KINDEX  - index of matched value
C
C     METHOD.
C     -------
C
C          NONE.
C
C
C     EXTERNALS.
C     ----------
C
C          NONE.
C
C     REFERENCE.
C     ----------
C
C          NONE.
C
C     AUTHOR.
C     -------
C
C          M. DRAGOSAVAC    *ECMWF*       15/01/92.
C
C
C     MODIFICATIONS.
C     --------------
C
C          NONE.
C
C
      IMPLICIT LOGICAL(L,O,G), CHARACTER*8(C,H,Y)
C
C
      character*(*)  KARRAY(*)
      character*(*)  KVAL
      logical found
      integer count
C
C     ------------------------------------------------------------------
C*          1.   Binary search. 
C                _____________
 100  CONTINUE
C
      IHIGH = K
      ILOW  = 1
C
      count=0
      found=.false.
      kindex=0
      numbis= int(log(real(k))/log(2.0)) +1

      ihigh = K+1
      ilow  = 1

      do while(.not.found .and.count .ne. numbis)

            mid = (ihigh + ilow)/2
            if(karray(mid).eq.kval) then
               found=.true.
            elseif(kval .lt.karray(mid)) then
               ihigh= mid
            elseif(kval.gt.karray(mid)) then
               ilow= mid
            end if
            count=count+1
      end do

      if(found) kindex=mid

C
      RETURN
      END

C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE BUETAB( KSEC1,KERR )
C
C**** *BUETAB*
C
C
C     PURPOSE.
C     --------
C          LOAD BUFR TABLE B, D AND C ACCORDING TO EDITION AND VERSION
C     OF BUFR CODE.
C
C
C**   INTERFACE.
C     ----------
C
C          *CALL* *BUETAB(KSEC1,KERR)*
C
C        OUTPUT:
C               *KSEC1*   -  ARRAY CONTAINING SECTION 1 INFORMATION
C                            KSEC1( 1)-- LENGTH OF SECTION 1 (BYTES)
C                            KSEC1( 2)-- BUFR EDITION NUMBER
C                            KSEC1( 3)-- ORIGINATING CENTRE
C                            KSEC1( 4)-- UPDATE SEQUENCE NUMBER
C                            KSEC1( 5)-- FLAG (PRESENCE OF SECTION 2)
C                            KSEC1( 6)-- BUFR MESSAGE TYPE
C                            KSEC1( 7)-- BUFR MESSAGE SUBTYPE
C                            KSEC1( 8)-- VERSION NUMBER OF LOCAL TABLE USED
C                            KSEC1( 9)-- YEAR
C                            KSEC1(10)-- MONTH
C                            KSEC1(11)-- DAY
C                            KSEC1(12)-- HOUR
C                            KSEC1(13)-- MINUTE
C                            KSEC1(14)-- BUFR MASTER TABLE
C                            KSEC1(15)-- VERSION NUMBER OF MASTER TABLE USED
C                            KSEC1(16) - KSEC1(JSEC1) -- LOCAL ADP CENTRE
C                                        INFORMATION(BYTE BY BYTE)
C
C                            FOR BUFR EDITION 3 ONWARD
C
C                            KSEC1(16)-- ORIGINATING SUB-CENTRE
C                            KSEC1(17)-- NOT USED
C                            KSEC1(18) TO KSEC1(JSEC1) - LOCAL ADP CENTRE
C                                        INFORMATION(PACKED FORM)
C
C                            FOR BUFR EDITION 4 ONWARD
C
C                            KSEC1(16)-- ORIGINATING SUB-CENTRE
C                            KSEC1(17)-- INTERNATIONAL SUB-CATEGORY (SEE COMMON TABLE C-13
C                            KSEC1(18)-- SECOND
C                            KSEC1(19)-- YEAR
C                            KSEC1(20)-- MONTH
C                            KSEC1(21)-- DAY
C                            KSEC1(22)-- HOUR
C                            KSEC1(23)-- MINUTE
C                            KSEC1(24)-- SECOND
C                            KSEC1(25)-- YEAR
C                            KSEC1(26)-- MONTH
C                            KSEC1(27)-- DAY
C                            KSEC1(28)-- HOUR
C                            KSEC1(29)-- MINUTE
C                            KSEC1(30)-- SECOND
C                            KSEC1(31)-- MOST SOUTHERN LATITUDE  (-90 to 90)
C                            KSEC1(32)-- MOST WESTERN LONGITUDE  ( 0-360)
C                            KSEC1(33)-- MOST NORTHEN LATITUDE   (-90 to 90)
C                            KSEC1(34)-- MOST EASTERN LONGITUDE  ( 0-360)
C                            KSEC1(35) TO KSEC1(JSEC1) - LOCAL ADP CENTRE INFORMATION(PACKED FORM)
C
C               *KERR*    -  RETURNED ERROR CODE
C
C     METHOD.
C     -------
C
C          NONE.
C
C
C     EXTERNALS.
C     ----------
C
C          NONE.
C
C     REFERENCE.
C     ----------
C
C          NONE.
C
C     AUTHOR.
C     -------
C
C          M. DRAGOSAVAC    *ECMWF*       17/01/91.
C
C
C     MODIFICATIONS.
C     --------------
C
C          NONE.
C
C
      IMPLICIT LOGICAL(L,O,G), CHARACTER*8(C,H,Y)
C
C
#     include "parameter.F"
#     include "bcomunit.F"
#     include "bcmwork.F"
#     include "bcmtab.F"
#     include "bcmtabc.F"
#     include "bcmct.F"
#     include "bcmctc.F"
#     include "bcmroot.F"
#     include "bcmtabload.F"
#     include "bcmtabloadc.F"
C
      CHARACTER*256 YTAB ,YTAC ,YTAD
      CHARACTER*24  YTABB,YTABC,YTABD,CTABLE_LIST
      CHARACTER*64  CTABBEN,CTEXT
      CHARACTER*64  CCTABBEN
      CHARACTER*24  CTABBU , CCTABBU
      CHARACTER*256 CROOT
C
      LOGICAL*4  OPN
#ifndef R_4
      REAL*8 RVIND
      REAL*8 EPS
#else
      REAL   RVIND
      REAL   EPS
#endif
C
      DIMENSION KSEC1(JSEC1)
C
      SAVE OFIRST
C
C     ------------------------------------------------------------------
C
C*          1.   GET BUFR TABLES/LOCAL BUFR TABLES.
C                ----------------------------------
 100  CONTINUE
C
      IF( KERR.NE.0) RETURN
C
C*          2.   SET UP BUFR TABLE FILE NAME.
C                ----------------------------
 200  CONTINUE
C
C
C             BUFR EDITION 2 NAMING CONVENTION
C
C             BXXXXXYYZZ , CXXXXXYYZZ , DXXXXXYYZZ
C
C             B      - BUFR TABLE 'B'
C             C      - BUFR TABLE 'C'
C             D      - BUFR TABLE 'D'
C             XXXXX  - ORIGINATING CENTRE
C             YY     - VERSION NUMBER OF MASTER TABLE
C                      USED( CURRENTLY 2 )
C             ZZ     - VERSION NUMBER OF LOCAL TABLE USED
C
C             BUFR EDITION 3 NAMING CONVENTION
C
C             BWWWXXXYYZZ , CWWWXXXYYZZ , DWWWXXXYYZZ
C
C             B      - BUFR TABLE 'B'
C             C      - BUFR TABLE 'C'
C             D      - BUFR TABLE 'D'
C             WWW    - ORIGINATING SUB-CENTRE
C             XXX    - ORIGINATING CENTRE
C             YY     - VERSION NUMBER OF MASTER TABLE
C                      USED( CURRENTLY 2 )
C             ZZ     - VERSION NUMBER OF LOCAL TABLE USED
C
C
C             BUFR EDITION 4 NAMING CONVENTION
C
C             BSSSWWWWWXXXXXYYYZZZ , CSSSWWWWWXXXXXYYYZZZ , DSSSWWWWWXXXXXYYYZZZ
C
C             B      - BUFR TABLE 'B'
C             C      - BUFR TABLE 'C'
C             D      - BUFR TABLE 'D'
C             SSS    - MASTER TABLE NUMBER ( zero for WMO tables)
C             WWWWWW - ORIGINATING SUB-CENTRE
C             XXXXXX - ORIGINATING CENTRE
C             YYY    - VERSION NUMBER OF MASTER
C                      TABLE USED( CURRENTLY 12 )
C             ZZZ    - VERSION NUMBER OF LOCAL TABLE USED
C
            IXX=KSEC1(3)
            IYY=KSEC1(15)
            IZZ=KSEC1(08)
C           
            IF(KSEC1(2).EQ.3) THEN
               IWW=KSEC1(16)
               ISS=KSEC1(14)
            ELSEIF(KSEC1(2).EQ.4) THEN
               IWW=KSEC1(16)
               ISS=KSEC1(14)
            ELSE
               IWW=0
               ISS=0
            END IF
C
C        IF STANDARD TABLES USED, USE WMO ORIGINATING CENTRE ID
C
         IF(KSEC1(8).EQ.0.OR.KSEC1(8).EQ.255) THEN
            IXX=0
            IWW=0
            IZZ=0
         ENDIF
C
         IF(OFIRST) THEN
            IF(IWW.EQ.NWWP.AND.IXX.EQ.NXXP.AND.IYY.EQ.NYYP.AND.
     1         IZZ.EQ.NZZP.AND.ISS.EQ.NSSP) RETURN
         END IF
C
         OFIRST=.TRUE.
C
         NSSP=ISS
         NXXP=IXX
         NYYP=IYY
         NZZP=IZZ
         NWWP=IWW
C
       WRITE(YTABB,'(A1,I3.3,2(I5.5),2(I3.3),A4)') 
     1              'B',ISS,IWW,IXX,IYY,IZZ,'.TXT'
c      WRITE(YTABC,'(A1,I3.3,2(I5.5),2(I3.3),A4)')
c    1              'C',ISS,IWW,IXX,IYY,IZZ,'.TXT'
       WRITE(YTABD,'(A1,I3.3,2(I5.5),2(I3.3),A4)')
     1              'D',ISS,IWW,IXX,IYY,IZZ,'.TXT'
C
C      Find if table is already used
C
       DO I=1,JTMAX
       IF(CTABLE_LIST(I).EQ.YTABB) THEN
          CALL GET_TABLES1(I)
          RETURN
       END IF
       END DO
       IF(OPRINT) THEN
       WRITE(KNTN,'(A,1X,A,A,A,A))') 'BUFR TABLES TO BE LOADED ',
     1    YTABB,',',YTABD
       END IF
c      WRITE(KNTN,'(A,1X,A,A,A,A))') 'BUFR TABLES TO BE LOADED ',
c    1    YTABB,',',YTABC,',',YTABD

C     ----------------------------------------------------------------
C*          3. OPEN AND READ FILES CONTAINING BUFR TABLES.
C              -------------------------------------------
 300  CONTINUE
C
      I=INDEX(CROOT,' ')
      IF(I.NE.0) I=I-1
C
C*          3.1 READ BUFR TABLE B.
C               ------------------
 310  CONTINUE
C
      YTAB=CROOT(1:I)//YTABB
C
      CALL BTABLE1(YTAB,YTABB,KERR)
      IF(KERR.NE.0) RETURN
C
C
C*          3.2 READ BUFR TABLE C.
C               ------------------
 320  CONTINUE
C
c      YTAC=CROOT(1:I)//YTABC
C
c      CALL CTABLE1(YTAC,KERR)
c      IF(KERR.NE.0) RETURN
C
C
C*          3.3 READ BUFR TABLE D.
C               ------------------
 330  CONTINUE
C
      YTAD=CROOT(1:I)//YTABD
C
      CALL DTABLE1(YTAD,KERR)
      IF(KERR.NE.0) RETURN
C
      RETURN
C
      END

C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE CREXPRCO(KBUFL,YBUFF,KJ,KDD,KSTACK,KELEM,KERR)
C
C**** *CREXPRCO*
C
C
C     PURPOSE.
C     --------
C
C          Process CREX operator.
C
C**   INTERFACE.
C     ----------
C
C          *CALL* *CREXPRCO(KBUFL,YBUFF,KJ,KDD,KSTACK,KELEM,KERR)*
C
C        INPUT :
C               *KBUFL*   -  length of CREX message (words)
C               *YBUFF*   -  array containing CREX message
C               *KJ*      -  pointer to array kstack
C               *KDD*     -  data descriptor
C               *KELEM*   -  dimension of CNAMES, CUNITS array
C        OUTPUT:
C               *KSTACK*  - list of descriptors
C               *KERR*    - return error code
C
C     *METHOD.
C      -------
C
C          NONE.
C
C
C     EXTERNALS.
C     ----------
C
C
C     REFERENCE.
C     ----------
C
C          NONE.
C
C     AUTHOR.
C     -------
C
C          MILAN DRAGOSAVAC    *ECMWF*       07/01/2004.
C
C
C     MODIFICATIONS.
C     --------------
C
C          NONE.
C
C
      IMPLICIT LOGICAL(L,O,G), CHARACTER*8(C,H,Y)
C
C
      PARAMETER(JSUP =   9,JSEC0=   3,JSEC1= 40,JSEC2= 64 ,JSEC3=    4,
     1          JSEC4=   2,JELEM=40000,JSUBS=400,JCVAL=150 ,JBUFL=40000,
     2          JBPW =  32,JTAB =3000,JCTAB=120,JCTST=1800,JCTEXT= 200,
     3          JWORK=360000,JKEY=46)
C
C
C
      COMMON /CREXWORK/ NBPT,NGS,NVIND,NBPTSEC2,RVIND,EPS,NE,IEOLD,
     1                  NC07YYY
C
      COMMON /CREXWT/ NCREXDWINC,NCREXSCAM,NCREXAFDW,NCREXWT ,ODREPF,
     2               NCREXSTACK(JELEM),NCREXWTEN(JELEM),
     3               NCREXWTR (JELEM),NCREXWTS (JELEM),NCREXWTRV(JELEM),
     4               NCREXWTDW(JELEM),NWTIW(JELEM),NWTIWS(JELEM)
C
C             NCREXDWINC   -  data width increment
C             NCREXSCAM    -  scale multiplier
C             NCREXAFDW    -  augmented field data width
C             NCREXWT      -  pointer to working table
C             NCREXSTACK   -  list of data descriptors
C             ODREPF   -  replication (logical)
C             NCREXWTR     -  working table reference
C             NCREXWTS     -  working scale
C             NCREXWTRV    -  working reference value
C             NCREXWTDW    -  working data width
C             NWTIW    -  working data width of increments
C             NWTIWS   -  working total data width of element set
C
C
      COMMON /CREXWTC/ CREXWTEN(JELEM),CREXWTU (JELEM)
C
C             CREXWTEN    -  working table element naame
C             CREXWTU     -  working table units
C
C
      COMMON /CREXBEF / M,MM,N,JCV
C
C             M       -  Number of elements
C             MM      -  Number of elements
C             N       -  Number of data sub_sets
C             JCV     -  Number of character values
C
C
      COMMON /CREXUT/ YUNIT,CUNITNAME,CIA5,CIA2,NCODE,NRECORDS
C
C             NCODE  - array containing unit code number
C             CUNITNAME - array containing unit name
C             CIA5 - array  containing unit CCITTIA5 name
C             CIA2 - array  containing unit CCITTIA2 name
C             NRECORDS - number of entries in the list
C
      DIMENSION NCODE(JCTEXT)
      CHARACTER*30 CUNITNAME(JCTEXT)
      CHARACTER*24 CIA5(JCTEXT)
      CHARACTER*24 CIA2(JCTEXT)
      CHARACTER*24 YUNIT
C
      CHARACTER CREXWTEN*64,CREXWTU*24
      DIMENSION KSTACK(*)
      CHARACTER*(*) YBUFF
      REAL*8 RVIND,EPS
C
C     ------------------------------------------------------------------
C
C*          1.   DETERMINE *F *X AND *Y.
C                -----------------------
 100  CONTINUE
C
      IF( KERR.NE.0 ) RETURN
C
      IF  = KDD / 100000
      IDIF= KDD - IF * 100000
      IX  = IDIF / 1000
      IY  = IDIF - IX * 1000
C
      IF( IF.NE.2 ) THEN
         KERR=21
         PRINT*,' CREXPRCO :'
         CALL CREXERR(KERR)
         GO TO 400
      END IF
C
C*          1.1   CHANGE DATA WIDTH ?
C                 -------------------
 110  CONTINUE
C
      IF(IX.EQ.1) THEN
         NCREXDWINC= IY
         GO TO 400
      END IF
C
C*          1.2   CHANGE SCALE ?
C                 --------------
 120  CONTINUE
C
      IF(IX.EQ.2) THEN
C
C*          1.2.1  UPDATE SCALE MULTIPLIER.
C                  ------------------------
C
         IF(IY.GT.900) IY=-(IY-900)
         NCREXSCAM=IY
         GO TO 400
      END IF
C
C
C*          1.5   SIGNIFY CHARACTER ?
C                 -------------------
 150  CONTINUE
C
      IF(IX.EQ.5) THEN
C
C*          1.5.1  ADD SPECIAL ENTRY TO WORKING TABLE.
C                  -----------------------------------
         NCREXWT = NCREXWT + 1
         CREXWTEN(NCREXWT)='CHARACTERS'
         CREXWTU (NCREXWT)=' '
         NCREXWTR (NCREXWT)= kdd      
         NCREXWTDW(NCREXWT)= IY
         NCREXWTEN(NCREXWT)=658367
         NCREXWTS (NCREXWT)=0
         NCREXWTRV(NCREXWT)=0
         GO TO 400
      END IF
C
C          1.6 CHANGE UNIT
C              -----------
 160  CONTINUE
C
      IERR=0
      IF(IX.EQ.7) THEN
         CALL GET_UNITS(IY,IERR)
         IF(IERR.EQ.0) THEN
            NC07YYY=IY
         END IF
C
         GO TO 400
C
      END IF
C
C     ------------------------------------------------------------------
C
 300  CONTINUE
C
      KERR=22
      PRINT*,'CREXPRCO:'
      CALL CREXERR(KERR)
C
C     ------------------------------------------------------------------
C
 400  CONTINUE
C
      RETURN
      END

C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      INTEGER FUNCTION INTOCN(HICODE,HSCODE,RTOP,RBOTT,RRIGHT,RLEFT,
     *            RYRES,RXRES,
     *            KSEC1,KSEC2,PSEC4,KLENP,KLENI,TARRAY,
     *            XARR,YARR,NXP,NYP,PARRAY,IINTPOL,ISTAGP)
C
C---->
C****  INTOCN  - interpolates grib ocean data
C
C
C     PURPOSE
C     -------
C     Interpolates data to new grid, according to instructions.
C     Missing data is flagged with -999.9; this information is
C     passed to the new field.
C
C
C     Interface.
C     ----------
C
C     IRET = INTOCN(....)
C
C     Input parameters.
C     -----------------
C
C     HICODE   Interpolation code
C               'N'  No interpolation
C               'R'  Interpolate only to make grid Regular
C               'X'  Interpolate in x only
C               'Y'  Interpolate in y only
C               'F'  Interpolate in x and y (Full)
C     HSCODE   Staggered grid code
C               'D'  Drop every second row ('even' points)
C               'X'  Augment to standard grid by x interpolation
C               'Y'  Augment to standard grid by y interpolation
C               'F'  Augment to standard grid by x-y interpolation
C     RTOP     Top of output field domain        (degrees/metres/days)
C     RBOTT    Bottom of output field domain              ( " )
C     RRIGHT   Right of output field domain               ( " )
C     RLEFT    Left of output field domain                ( " )
C     RYRES    Resolution for y-interpolation     ( " )
C     RXRES    Resolution for x-interpolation     ( " )
C     KSEC1    Product definition block (+ high res. grid data)
C     KSEC2    Grid description block
C     PSEC4    Input data array
C     KLENP    Size of input array
C     KLENI    Size of scratch array (and also output array PARRAY)
C     TARRAY   Scratch array for use during interpolation
C
C     Output parameters.
C     ------------------
C
C     Returns 0 if the interpolation is successful, otherwise non-zero.
C
C     XARR     x cordinates of data values, or XO,XSTEP,
C              0.0 for regular spacing
C     YARR     y cordinates of data values, or YO,YSTEP,
C              0.0 for regular spacing
C     NXP      x dimension of output field
C     NYP      y dimension of output field
C     PARRAY   output field array
C     IINTPOL  Flag for interpolation done
C              = 0 if none,
C              = 1 if x only,
C              = 2 if y only,
C              = 3 if x and y.
C     ISTAGP   Flag to show processing done for staggered grid:
C              = 0 if none
C              = 2 if every second row dropped.
C              = 3 if interpolated in x only.
C              = 4 if interpolated in y only.
C              = 5 if interpolated in x and y.
C
C
C     Method.
C     -------
C     Convention is always to have output field array starting in bottom
C     left hand corner of the field. The positional information for the
C     data and for the axes is also given starting in the bottom left
C     hand corner.  This means YARR and PSEC4 must be inverted for the
C     default grib scanning, which starts in the top left hand corner.
C
C
C     Externals.
C     ----------
C
C     INTLOG  - Logs warning messages.
C     INTLOGR - Logs warning messages.
C
C
C     Reference.
C     ----------
C
C     None.
C
C
C     Author.
C     -------
C
C     T. Stockdale    ECMWF  23.02.93
C
C
C     Modifications.
C     --------------
C
C     T. Stockdale    ECMWF  20.05.93
C     Revised for local grib.
C
C     J.D.Chambers    ECMWF  04.10.95
C     Make into a function (remove STOPs).
C
C     T. Stockdale    ECMWF  26.09.02
C     Drop odd points (not even) from E grid, for better land sea mask
C
C     T. Stockdale    ECMWF  07.10.02
C     New standard code (matches latest rd version)
C
C----<
C     ------------------------------------------------------------------
C*    Section 0 . Definition of variables. Data statements.
C     ------------------------------------------------------------------
C
      IMPLICIT NONE
C
C     Parameters
      INTEGER JPROUTINE, JP_LONG
      PARAMETER (JPROUTINE = 33300 )
      PARAMETER (JP_LONG = 3 )
C
#include "parim.h"
C
C     Subroutine arguments.
      CHARACTER*1 HICODE,HSCODE
      REAL RTOP, RBOTT, RRIGHT, RLEFT, RYRES, RXRES
      INTEGER KSEC1, KSEC2, KLENP, KLENI, NXP, NYP, IINTPOL, ISTAGP
      DIMENSION KSEC1(*)
      DIMENSION KSEC2(*)
      REAL PSEC4, TARRAY, XARR, YARR, PARRAY
      DIMENSION PSEC4(KLENP)
      DIMENSION XARR(*), YARR(*)
      DIMENSION TARRAY(KLENI), PARRAY(KLENI)
C
C     Local variables
      INTEGER NX, NY, KLAT1, KLAT2, KLON1, KXINC, KYINC, ISTAG
      INTEGER IIRREG, JGCL, J, I, JSKIP, NXLEFT, NXRIGH, IWRAP, JI
      INTEGER JIP, JJ, IOFFSET, NEWPTS, JN, IPOS, IPOSM, JPOS
      INTEGER IPOSP1M, JMIN, JMAX, JLEFT, JJP, JJEFF
      INTEGER NYLEFTI, NYLEFT, NYRIGH
      REAL XUNIT, YUNIT, RRVAL, RLVAL, RUVAL, RDVAL, RXIRES
      REAL XSIGN, XRSIGN, XFPREV, XFPOSN, RPOS, RVALL, RVALR 
      REAL XVAL, XOWEST, XORES, XPSIGN, RVAL, RYIRES, YFPREV, YFPOSN
      REAL YSIGN, YPSIGN, YRSIGN, RMISS, EPS
      REAL RVALB, RVALT, XOSOUT
      LOGICAL LNEAREST
C
C     YSIGN    Flag for direction of y co-ords in data:
C              +1 if co-ords are increasing with index of PSEC4,
C              -1 if decreasing. 
C     YPSIGN   Flag for direction of y co-ords in output field:
C              +1 if co-ords are increasing up the page,
C              -1 if decreasing. 
C     YRSIGN   Flag for direction of y co-ords in output field relative
C              to that in data: YSIGN*YPSIGN 
C     IINTPOL  Flag for interpolation:
C              0 = none,
C              1 = x only,
C              2 = y only,
C              3 = x and y
C     RMISS    Value for missing data
C     EPS      Tolerance on missing data flag
C
C
      EXTERNAL INTUP, INTDN, LENA, HDEGS, HMETRES
      INTEGER  INTUP, INTDN, LENA
      CHARACTER*6 HDEGS, HMETRES
C
C     Inline function - tests TRUE if A is a missing value
      REAL A
      LOGICAL MISSING
      MISSING(A) = ( ABS(A-RMISS) .LT. EPS )
C
C     ------------------------------------------------------------------
C*    Section 1 . Set initial values.
C     ------------------------------------------------------------------
C
  100 CONTINUE
C
      INTOCN = 0
C
C     Set key variables from GRIB header blocks.
C
      NX     = KSEC2(2)
      NY     = KSEC2(3)
C
      KLAT1  = KSEC1(62)
      KLAT2  = KSEC1(64)
      KLON1  = KSEC1(63)
      KXINC  = KSEC1(66)
      KYINC  = KSEC1(67)
C
      ISTAG  = KSEC1(69)
      IIRREG = KSEC1(68)
      JGCL   = 74+KSEC1(71)+KSEC1(72)
C
      IF(KSEC1(60).EQ.1) THEN
         XUNIT = 1.0/3600.0
      ELSE
         XUNIT = 1.0E-6
      ENDIF
C
      IF(KSEC1(61).EQ.2) THEN
         YUNIT = 1.0E-3
      ELSE IF(KSEC1(61).EQ.1) THEN
         YUNIT = 1.0/3600.0
      ELSE
         YUNIT = 1.0E-6
      ENDIF
C
      IINTPOL = 0
      RMISS   = -999.9
      EPS     = 0.01
C
C     ------------------------------------------------------------------
C*    Section 2 . Deal with staggered grid if present.
C     ------------------------------------------------------------------
C
  200 CONTINUE
C
C     The approach in this section is to replace the staggered grid by 
C     a non-staggered version, either by interpolating the data onto new
C     grid points or by simply dropping half of the data points. A new 
C     version of PSEC4 is created, and parts of KSEC1 are modified.
C     This enables the rest of INTOCN to treat the field in a consistent
C     manner, BUT it means that KSEC1 and PSEC4 will be altered on
C     leaving this subroutine (and presently in an inconsistent way).
C 
C     The interpolations coded in this section ignore the metric of the
C     staggered grid, that is they simply average neighbouring values to
C     find a new grid point value. The more general case can be added 
C     later if desired.
C
C     Note: we prefer to drop odd points and keep even points, because
C     the standard version of HOPE2 uses an external mask to define the
C     land-sea mask of its even points. The mask for odd points then has
C     to be interpolated, which is less accurate, so the plots look
C     better if the even points are kept.
C
C
      IF(ISTAG.EQ.1) THEN
C
C       Drop odd row points ...
C
        IF(HSCODE.EQ.'D') THEN
          ISTAGP = 2
          NY     = NY/2
          KYINC  = KYINC*2
          DO 210 J = 1,NY
            DO 210 I = 1,NX
              PSEC4(I+NX*(J-1)) = PSEC4(I+NX*((J-1)*2+1))
  210     CONTINUE
C
C         Reset the grid coordinate list.
C         Remove the y coordinates of the even rows,
C         the x coordinates of the even rows, and also the first x
C         coordinate of an even regular row.
C
          IF(IIRREG.EQ.2) THEN
            KLON1=KSEC1(JGCL+1)
            DO 212 J = 1,NY
              KSEC1(JGCL+J) = KSEC1(JGCL+1+2*J)
  212       CONTINUE
C
          ELSE IF(IIRREG.EQ.3) THEN
            KLON1=KSEC1(JGCL+1)
            JSKIP = JGCL+NX
            DO 214 J = 1,NY
              KSEC1(JSKIP+J) = KSEC1(JSKIP+NX+2*J)
  214       CONTINUE
          ENDIF
C
C*      Staggered grid: interpolation in x.
C
        ELSE IF(HSCODE.EQ.'X') THEN
          ISTAGP = 3
          NX     = NX*2
          KXINC  = KXINC/2
          IF(((NX*NY).GT.KLENI).OR.((NX*NY).GT.KLENP)) THEN
            CALL INTLOG(JP_ERROR,'INTOCN: Array too small.',JPQUIET)
            CALL INTLOG(JP_ERROR,'INTOCN: Required = ',NXP*NY)
            CALL INTLOG(JP_ERROR,'INTOCN: Available = ',KLENP)
            CALL INTLOG(JP_ERROR,'INTOCN: Available = ',KLENI)
            INTOCN = JPROUTINE + 17
            GOTO 900
          ENDIF
C
C         Expand the data into a temporary array, and then copy back
C         into PSEC4. Note the treatment of the end points, which
C         assumes a longitude wrap-round. Remember to mask land points
C         so that either both points are missing or neither.
C
          DO 220 J = 1,NY,2
            RRVAL = PSEC4(1+(J-1)*NX/2)
            RLVAL = PSEC4(NX/2+(J-1)*NX/2)
            IF(MISSING(RRVAL)) RLVAL = RMISS
            IF(MISSING(RLVAL)) RRVAL = RMISS
            TARRAY(1+(J-1)*NX) = (RRVAL+RLVAL)*0.5
            TARRAY(2+(J-1)*NX) = PSEC4(1+(J-1)*NX/2)
            DO 220 I = 2,NX/2
              RRVAL = PSEC4(I  +(J-1)*NX/2)
              RLVAL = PSEC4(I-1+(J-1)*NX/2)
              IF(MISSING(RRVAL)) RLVAL = RMISS
              IF(MISSING(RLVAL)) RRVAL = RMISS
              TARRAY(I*2-1+(J-1)*NX) = (RRVAL+RLVAL)*0.5
              TARRAY(I*2  +(J-1)*NX) = PSEC4(I  +(J-1)*NX/2)
  220     CONTINUE
C
          DO 222 J = 2,NY,2
            RRVAL = PSEC4(1+(J-1)*NX/2)
            RLVAL = PSEC4(NX/2+(J-1)*NX/2)
            IF(MISSING(RRVAL)) RLVAL = RMISS
            IF(MISSING(RLVAL)) RRVAL = RMISS
            TARRAY(NX+(J-1)*NX) = (RLVAL+RRVAL)*0.5
            TARRAY(NX-1+(J-1)*NX) = PSEC4(NX/2+(J-1)*NX/2)
            DO 222 I = 1,NX/2-1
              RRVAL = PSEC4(I+1+(J-1)*NX/2)
              RLVAL = PSEC4(I  +(J-1)*NX/2)
              IF(MISSING(RRVAL)) RLVAL = RMISS
              IF(MISSING(RLVAL)) RRVAL = RMISS
              TARRAY(I*2  +(J-1)*NX) = (RLVAL+RRVAL)*0.5
              TARRAY(I*2-1+(J-1)*NX) = PSEC4(I  +(J-1)*NX/2)
  222     CONTINUE
          DO 224 J = 1,NY
            DO 224 I = 1,NX
              PSEC4(I+(J-1)*NX) = TARRAY(I+(J-1)*NX)
  224     CONTINUE
C
C         Reset the grid coordinate list if necessary, again making
C         use of a temporary array. Expand the x-coordinate list,
C         and remove the x coordinate of the first even point if grid
C         is regular in x.
C
          KLON1 = KSEC1(JGCL+1)
          IF((IIRREG.EQ.1).OR.(IIRREG.EQ.3)) THEN
            JSKIP = JGCL
            DO 226 J = 1,NX/2
              TARRAY(J*2-1) = KSEC1(JSKIP+J)
              TARRAY(J*2)   = KSEC1(JSKIP+NX/2+J)
  226       CONTINUE
            DO 227 J = 1,NX
              KSEC1(JSKIP+J) = TARRAY(J)
  227       CONTINUE
          ELSE IF((IIRREG.EQ.2)) THEN
            DO 228 J = 1,NY
              KSEC1(JGCL+J) = KSEC1(JGCL+1+J)
  228       CONTINUE
          ENDIF
C
C       Staggered grid: interpolation in y.
C
        ELSE IF(HSCODE.EQ.'Y') THEN
          ISTAGP = 4
          NX     = NX*2
          KXINC  = KXINC/2
          IF(((NX*NY).GT.KLENI).OR.((NX*NY).GT.KLENP)) THEN
            CALL INTLOG(JP_ERROR,'INTOCN: Array too small.',JPQUIET)
            CALL INTLOG(JP_ERROR,'INTOCN: Required = ',NXP*NY)
            CALL INTLOG(JP_ERROR,'INTOCN: Available = ',KLENP)
            CALL INTLOG(JP_ERROR,'INTOCN: Available = ',KLENI)
            INTOCN = JPROUTINE + 18
            GOTO 900
          ENDIF
C
C         Expand the data into a temporary array, and then copy back
C         into PSEC4. For the polarmost rows, use X interpolation.
C
C         First the even rows...
          DO 230 J = 2,NY-1,2
            DO 230 I = 1,NX/2
              RUVAL = PSEC4(I+(J-2)*NX/2)
              RDVAL = PSEC4(I+(J  )*NX/2)
              IF(MISSING(RUVAL)) RDVAL = RMISS
              IF(MISSING(RDVAL)) RUVAL = RMISS
              TARRAY(I*2  +(J-1)*NX) = (RDVAL+RUVAL)*0.5
              TARRAY(I*2-1+(J-1)*NX) =  PSEC4(I+(J-1)*NX/2)
  230     CONTINUE
          RRVAL = PSEC4(1+(NY-1)*NX/2)
          RLVAL = PSEC4(NX/2+(NY-1)*NX/2)
          IF(MISSING(RRVAL)) RLVAL = RMISS
          IF(MISSING(RLVAL)) RRVAL = RMISS
          TARRAY(NX+(NY-1)*NX) = (RLVAL+RRVAL)*0.5
          TARRAY(NX-1+(NY-1)*NX) = PSEC4(NX/2+(NY-1)*NX/2)
          DO 231 I = 2,NX/2
            RRVAL = PSEC4(I+1+(NY-1)*NX/2)
            RLVAL = PSEC4(I+(NY-1)*NX/2)
            IF(MISSING(RRVAL)) RLVAL = RMISS
            IF(MISSING(RLVAL)) RRVAL = RMISS
            TARRAY(I*2+(NY-1)*NX) = (RRVAL+RLVAL)*0.5
            TARRAY(I*2-1+(NY-1)*NX) = PSEC4(I+(NY-1)*NX/2)
  231     CONTINUE
C   
C         Then the odd rows
          DO 232 J = 3,NY-1,2
            RUVAL = PSEC4(NX/2+(J-2)*NX/2)
            RDVAL = PSEC4(NX/2+(J  )*NX/2)
            IF(MISSING(RUVAL)) RDVAL = RMISS
            IF(MISSING(RDVAL)) RUVAL = RMISS
            TARRAY(1+(J-1)*NX) = (RRVAL+RLVAL)*0.5
            TARRAY(2+(J-1)*NX) = PSEC4(1+(J-1)*NX/2)
            DO 232 I = 1,NX/2
              RUVAL = PSEC4(I+(J-2)*NX/2)
              RDVAL = PSEC4(I+(J  )*NX/2)
              IF(MISSING(RUVAL)) RDVAL = RMISS
              IF(MISSING(RDVAL)) RUVAL = RMISS
              TARRAY(I*2-1+(J-1)*NX) = (RDVAL+RUVAL)*0.5
              TARRAY(I*2  +(J-1)*NX) =  PSEC4(I+(J-1)*NX/2)
  232     CONTINUE
C
          RRVAL = PSEC4(1+(1-1)*NX/2)
          RLVAL = PSEC4(NX/2+(1-1)*NX/2)
          IF(MISSING(RRVAL)) RLVAL = RMISS
          IF(MISSING(RLVAL)) RRVAL = RMISS
          TARRAY(1+(1-1)*NX) = (RRVAL+RLVAL)*0.5
          TARRAY(2+(1-1)*NX) = PSEC4(1+(1-1)*NX/2)
          DO 233 I = 2,NX/2
            RRVAL = PSEC4(I+(1-1)*NX/2)
            RLVAL = PSEC4(I-1+(1-1)*NX/2)
            IF(MISSING(RRVAL)) RLVAL = RMISS
            IF(MISSING(RLVAL)) RRVAL = RMISS
            TARRAY(I*2-1+(1-1)*NX) = (RRVAL+RLVAL)*0.5
            TARRAY(I*2+(1-1)*NX) = PSEC4(I+(1-1)*NX/2)
  233     CONTINUE

          DO 234 J = 1,NY
            DO 234 I = 1,NX
              PSEC4(I+(J-1)*NX) = TARRAY(I+(J-1)*NX)
  234     CONTINUE
C
C         Reset the grid coordinate list if necessary, again making
C         use of a temporary array. Expand the x-coordinate list,
C         and remove the x coordinate of the first even point if
C         grid is regular in x.
C
          IF((IIRREG.EQ.1).OR.(IIRREG.EQ.3)) THEN
            JSKIP = JGCL
            DO 235 J = 1,NX/2
              TARRAY(J*2-1) = KSEC1(JSKIP+J)
              TARRAY(J*2)   = KSEC1(JSKIP+NX/2+J)
  235       CONTINUE
            DO 236 J = 1,NX
              KSEC1(JSKIP+J) = TARRAY(J)
  236       CONTINUE
          ELSE IF((IIRREG.EQ.2)) THEN
            DO 237 J = 1,NY
              KSEC1(JGCL+J) = KSEC1(JGCL+1+J)
  237       CONTINUE
          ENDIF
C
C       Staggered grid: interpolation in x and y.
C
        ELSE IF(HSCODE.EQ.'F') THEN
          ISTAGP = 5
          CALL INTLOG(JP_ERROR,'INTOCN: Staggered grid opt. F',JPQUIET)
          CALL INTLOG(JP_ERROR,'INTOCN: (interpolate x and y)',JPQUIET)
          CALL INTLOG(JP_ERROR,'INTOCN: not yet implemented.',JPQUIET)
          INTOCN = JPROUTINE + 1
          GOTO 900
        ELSE
          CALL INTLOG(JP_ERROR,'INTOCN: Staggered grid option',JPQUIET)
          CALL INTLOG(JP_ERROR,HSCODE,JPQUIET)
          CALL INTLOG(JP_ERROR,'INTOCN: not known.',JPQUIET)
          INTOCN = JPROUTINE + 2
          GOTO 900
        ENDIF
C
        ISTAG = 0
C
      ELSE
         ISTAGP = 0
      ENDIF
C
C     ------------------------------------------------------------------
C*    Section 3 . Set X coordinates and interpolate in X.
C     ------------------------------------------------------------------
C
  300 CONTINUE
C
C     The procedure is first to do the x interpolation (if any), and
C     copy the result into a temporary array. The y interpolation is
C     done in the next section.
C
C     The one complication here is to ensure proper longitude wrap-round
C     where appropriate.
C
C     Some plot systems have difficulty controlling the data within the
C     viewport. Because of this, and in the interests of efficiency, the
C     data arrays are truncated even if no interpolation is being done.
C
C
C     No interpolation in X.
C
      IF((HICODE.EQ.'N').OR.
     *   ((HICODE.EQ.'R').AND.((IIRREG.EQ.0).OR.(IIRREG.EQ.2))).OR.
     *   (HICODE.EQ.'Y') )  THEN
C
C       If x is longitude, set parameters up for wrap-round
C       Wrap-round activated only if longitude range of data > 350 deg.
C
        IF((IIRREG.EQ.0).OR.(IIRREG.EQ.2)) THEN
          RXIRES = KXINC*XUNIT
          NXLEFT = INTDN((RLEFT-KLON1*XUNIT)/RXIRES+1)
          NXRIGH = INTUP((RRIGHT-KLON1*XUNIT)/RXIRES+1)
          NXP    = NXRIGH-NXLEFT+1
          IF(NXP.LE.1) THEN
            CALL INTLOG(JP_ERROR,'INTOCN: NXP negative = ',NXP)
            INTOCN = JPROUTINE + 3
            GOTO 900
          ENDIF
          XARR(1) = KLON1*XUNIT+(NXLEFT-1)*RXIRES
          XARR(2) = KXINC*XUNIT
          XARR(3) = 0.0
          IF( (KSEC1(60).EQ.3) .AND. (KXINC*NX*XUNIT.GT.350.0) ) THEN
            IWRAP = 1
          ELSE
            IWRAP = 0
          ENDIF
C
        ELSE IF( (IIRREG.EQ.1) .OR. (IIRREG.EQ.3) ) THEN
          NXP    = NX
          NXLEFT = 1
          JSKIP  = JGCL
          DO 312 JI = 1,NXP
            XARR(JI) = KSEC1(JSKIP+JI)*XUNIT
  312     CONTINUE
          IF( (KSEC1(60).EQ.3) .AND. (KXINC*NX*XUNIT.GT.350.0) ) THEN
            IWRAP  = 1
            INTOCN = JPROUTINE + 4
            GOTO 900
          ELSE
            IWRAP  = 0
          ENDIF
        ENDIF
C
        IF((NXP*NY).GT.KLENI) THEN
          CALL INTLOG(JP_ERROR,'INTOCN: Array too small.',JPQUIET)
          CALL INTLOG(JP_ERROR,'INTOCN: Required = ',NXP*NY)
          CALL INTLOG(JP_ERROR,'INTOCN: Available = ',KLENI)
          INTOCN = JPROUTINE + 5
          GOTO 900
        ENDIF
C
C       Copy the data into the temporary array
C
        DO 318 JI = 1,NXP
          JIP = JI+NXLEFT-1
          IF(IWRAP.EQ.1) THEN
            IF(JIP.LE.0)  JIP = JIP+NX
            IF(JIP.GT.NX) JIP = JIP-NX
          ENDIF
          IF((JIP.GE.1).AND.(JIP.LE.NX)) THEN
            DO 316 JJ = 1,NY
              TARRAY(JI+(JJ-1)*NXP) = PSEC4(JIP+(JJ-1)*NX)
  316       CONTINUE
          ELSE
            DO 317 JJ = 1,NY
              TARRAY(JI+(JJ-1)*NXP) = RMISS
  317       CONTINUE
          ENDIF
  318   CONTINUE
C
C       Interpolation from a grid irregular in X.
C     ---------------------------------------------
C
      ELSE IF(((HICODE.EQ.'R').OR.
     *        (HICODE.EQ.'X').OR.
     *        (HICODE.EQ.'F')    ).AND.
     *       ((IIRREG.EQ.1).OR.(IIRREG.EQ.3))  ) THEN

        XPSIGN = SIGN(1.0,(RRIGHT-RLEFT))
        NXP    = NINT((RRIGHT-RLEFT)/RXRES*XPSIGN)+1
        IF((NXP*NY).GT.KLENI) THEN
          CALL INTLOG(JP_ERROR,'INTOCN: Array too small.',JPQUIET)
          CALL INTLOG(JP_ERROR,'INTOCN: Required = ',NXP*NY)
          CALL INTLOG(JP_ERROR,'INTOCN: Available = ',KLENI)
          INTOCN = JPROUTINE + 6
          GOTO 900
        ENDIF
        RRIGHT  = RLEFT+RXRES*XPSIGN*(NXP-1)
        XARR(1) = RLEFT
        XARR(2) = RXRES*XPSIGN
        XARR(3) = 0.0
        IINTPOL = IINTPOL+1
        IOFFSET = JGCL
        XSIGN   = SIGN(1.0,((KSEC1(IOFFSET+2)-KSEC1(IOFFSET+1))*1.0))
        XRSIGN  = XSIGN*XPSIGN
        DO 321 JI = 1,NXP*NY
          TARRAY(JI) = RMISS
  321   CONTINUE
C
C       Work through the known (irregular) data points.
C       Calculate the position of the point as a fractional number of
C       points on the new regular grid
C       (XFPOSN). If there are any points on the new grid between this
C       point and the previous one (XFPREV), then set these points by
C       interpolation between the two known points.
        XFPREV= (KSEC1(IOFFSET+1)*XUNIT-RLEFT)/RXRES*XPSIGN - 0.5*XRSIGN
        DO 324 JI = 1,NX
          XFPOSN = (KSEC1(IOFFSET+JI)*XUNIT-RLEFT)/(RXRES*XPSIGN)
          NEWPTS = INTDN((XFPOSN*XRSIGN))-INTDN((XFPREV*XRSIGN))
          DO 323 JN = 1,NEWPTS
            IPOS = (INTDN(XFPREV*XRSIGN)+JN)*XRSIGN+1
            RPOS = (IPOS-1)*1.0
            IF((IPOS.GE.1).AND.(IPOS.LE.NXP)) THEN
              DO 322 JJ = 1,NY
                RVALL = PSEC4(JI-1+NX*(JJ-1))
                RVALR = PSEC4(JI+NX*(JJ-1))
                IF(.NOT.MISSING(RVALL) .AND. .NOT.MISSING(RVALR) ) THEN
                  XVAL = (XFPOSN-RPOS)/(XFPOSN-XFPREV)*RVALL
     *                      +(RPOS-XFPREV)/(XFPOSN-XFPREV)*RVALR
                ELSE
                  XVAL = RMISS
                ENDIF
                TARRAY(IPOS+NXP*(JJ-1)) = XVAL
  322         CONTINUE
            ENDIF
  323     CONTINUE
          XFPREV = XFPOSN
  324   CONTINUE

C
C     Interpolation from a grid regular in X.
C
      ELSE IF(((HICODE.EQ.'X').OR.(HICODE.EQ.'F')).AND.
     *       ((IIRREG.EQ.0).OR.(IIRREG.EQ.2))    ) THEN

        XPSIGN = SIGN(1.0,(RRIGHT-RLEFT))
        NXP    = NINT((RRIGHT-RLEFT)/RXRES*XPSIGN)+1
        IF((NXP*NY).GT.KLENI) THEN
          CALL INTLOG(JP_ERROR,'INTOCN: Array too small.',JPQUIET)
          CALL INTLOG(JP_ERROR,'INTOCN: Required = ',NXP*NY)
          CALL INTLOG(JP_ERROR,'INTOCN: Available = ',KLENI)
          INTOCN = JPROUTINE + 7
          GOTO 900
        ENDIF
        RRIGHT  = RLEFT+RXRES*XPSIGN*(NXP-1)
        XARR(1) = RLEFT
        XARR(2) = RXRES*XPSIGN
        XARR(3) = 0.0
        IINTPOL = IINTPOL+1
C
C       Work through the new regular grid points. Calculate the position
C       of the point as a fractional number of points on the old grid.
C       Use this fractional number to estimate the value of the field
C       at the new point
C
C       (Note that just to the right of the first point, RPOS will be
C        eg 1.1, not 0.1)
C
        DO 330 JI = 1,NXP*NY
          TARRAY(JI) = RMISS
  330   CONTINUE
C
        XOWEST = KLON1*XUNIT
        XORES  = KXINC*XUNIT
        DO 3320 JI = 1,NXP
          RPOS = (RLEFT+(JI-1)*RXRES-XOWEST)/XORES + 1
          IPOS = INTDN(RPOS)
C
C         Check for out of bounds, and set to zero unless x is
C         longitude, in which case attempt to wrap round.
          IF( (IPOS.GE.1) .AND. ((IPOS+1).LE.NX) ) THEN
            DO 3310 JJ = 1,NY
              RVALL = PSEC4(IPOS+(JJ-1)*NX)
              RVALR = PSEC4(IPOS+1+(JJ-1)*NX)
              IF(.NOT. MISSING(RVALL) .AND. .NOT. MISSING(RVALR) ) THEN
                RVAL = (IPOS+1-RPOS)*RVALL + (RPOS-IPOS)*RVALR
C
C             Do not set to missing if there is good data close by.
              ELSEIF( (.NOT.MISSING(RVALL)) .AND.
     X                ((IPOS+1-RPOS).GT.0.5) ) THEN
                RVAL = RVALL
              ELSEIF( (.NOT. MISSING(RVALR)).AND.
     X                ((RPOS-IPOS).GT.0.5)) THEN
                RVAL = RVALR
              ELSE
                RVAL = RMISS
              ENDIF
              TARRAY(JI+(JJ-1)*NXP) = RVAL
 3310       CONTINUE
C
          ELSEIF( KSEC1(60).EQ.JP_LONG ) THEN
C
C           This works only if the longitude points are equally spaced
C           around the globe, ie the gap between the first and last
C           points is equal to the gap between any other pair of
C           adjacent points.
C
            IPOSM   = MOD(IPOS,NX)
            IPOSP1M = MOD((IPOS+1),NX)
            IF(IPOSM.LE.0)   IPOSM   = IPOSM+NX
            IF(IPOSP1M.LE.0) IPOSP1M = IPOSP1M+NX
            DO 3313 JJ = 1,NY
              RVALL = PSEC4(IPOSM+(JJ-1)*NX)
              RVALR = PSEC4(IPOSP1M+(JJ-1)*NX)
              IF(.NOT. MISSING(RVALL) .AND. .NOT. MISSING(RVALR) ) THEN
                RVAL = (IPOS+1-RPOS)*RVALL + (RPOS-IPOS)*RVALR
C
C             Do not set to missing if there is good data close by.
              ELSEIF( (.NOT.MISSING(RVALL)) .AND.
     X               ((IPOS+1-RPOS).GT.0.5) ) THEN
                RVAL = RVALL
              ELSEIF( (.NOT. MISSING(RVALR)).AND.
     X                ((RPOS-IPOS).GT.0.5) ) THEN
                RVAL = RVALR
              ELSE
                RVAL = RMISS
              ENDIF
              IF(RVAL.GT.1E6) THEN
                RVAL = RMISS
              ENDIF
              TARRAY(JI+(JJ-1)*NXP) = RVAL
 3313       CONTINUE
          ELSE
            DO 3316 JJ = 1,NY
              TARRAY(JI+(JJ-1)*NXP) = RMISS
 3316       CONTINUE
          ENDIF
 3320    CONTINUE
C
      ELSE
        CALL INTLOG(JP_ERROR,'INTOCN: Error in logic.',JPQUIET)
        CALL INTLOG(JP_ERROR,'INTOCN: HICODE = ',JPQUIET)
        CALL INTLOG(JP_ERROR,HICODE,JPQUIET)
        CALL INTLOG(JP_ERROR,'INTOCN: IIRREG = ',IIRREG)
        INTOCN = JPROUTINE + 8
        GOTO 900
      ENDIF
C
C     ------------------------------------------------------------------
C*    Section 4 . Set Y coordinates and interpolate in Y.
C     ------------------------------------------------------------------
C
  400 CONTINUE
C
C     The x-interpolated field in the temporary array is interpolated in
C     y into the final output field array. Note that the field and the
C     coordinate array are both inverted in the y direction during this
C     section.
C
C     Some plot systems have difficulty controlling the data within the
C     viewport. Because of this, and in the interests of efficiency, the
C     data arrays are truncated even if no interpolation is being done.
C
C
C     No interpolation in Y.
C
      IF((HICODE.EQ.'N').OR.
     *   ((HICODE.EQ.'R').AND.((IIRREG.EQ.0).OR.(IIRREG.EQ.1))).OR.
     *   (HICODE.EQ.'X') )  THEN
C
C       If y is longitude, set parameters up for wrap-round
C       Wrap-round activated only if longitude range of data > 350 deg.
C
        IF((IIRREG.EQ.0).OR.(IIRREG.EQ.1)) THEN
C
C         Remember to invert calc of NYP if RYIRES -ve ... 22.04.94
          RYIRES =  KYINC*YUNIT
          IF(RYIRES.GT.0) THEN
            NYLEFT = INTDN((RBOTT-KLAT1*YUNIT)/RYIRES+1)
            NYRIGH = INTUP((RTOP-KLAT1*YUNIT)/RYIRES+1)
            NYP = NYRIGH-NYLEFT+1
          ELSE
            NYRIGH = INTUP((RBOTT-KLAT1*YUNIT)/RYIRES+1)
            NYLEFT = INTDN((RTOP-KLAT1*YUNIT)/RYIRES+1)
            NYP = NYRIGH-NYLEFT+1
          ENDIF
          IF(NYP.LE.1) THEN
            CALL INTLOG(JP_ERROR,'INTOCN: NYP negative = ',NYP)
            INTOCN = JPROUTINE + 9
            GOTO 900
          ENDIF
C
C         Remember to invert yarr coordinates ... 06.07.93
          YARR(1) = KLAT1*YUNIT+(NYRIGH-1)*RYIRES
          YARR(2) = -KYINC*YUNIT
          YARR(3) = 0.0
C
C         Remember NYLEFT is relative to the inverted array ... 19.01.96
C         ... but be careful to do this exactly.   01.04.97
          NYLEFTI=NYLEFT
          NYLEFT=NY+1-NYRIGH
          NYRIGH=NY+1-NYLEFTI
C
          IF((KSEC1(61).EQ.3) .AND. (KYINC*NY*YUNIT.GT.350.0) ) THEN
            IWRAP = 1
          ELSE
            IWRAP = 0
          ENDIF
C
        ELSE IF(IIRREG.EQ.2) THEN
          IOFFSET = JGCL
          YPSIGN  = SIGN(1.0,(RTOP-RBOTT))
          YSIGN   = SIGN(1.0,((KSEC1(IOFFSET+2)-KSEC1(IOFFSET+1))*1.0))
          YRSIGN  = YSIGN*YPSIGN
          JMIN    = 0
          DO 410 JI = 1,NY
            YARR(JI) = KSEC1(IOFFSET+(NY+1-JI))*YUNIT
            IF(YRSIGN.LT.0.0) THEN
              IF((YARR(JI)-RBOTT)*YSIGN .GT. 0.0) JMIN = JI
              IF((YARR(JI)-RTOP )*YSIGN .GT. 0.0) JMAX = JI+1
            ELSE
              IF((YARR(JI)-RTOP )*YSIGN .GT. 0.0) JMIN = JI
              IF((YARR(JI)-RBOTT)*YSIGN .GT. 0.0) JMAX = JI+1
            ENDIF
  410     CONTINUE
          IF(JMIN.EQ.0) THEN
            CALL INTLOG(JP_ERROR,'INTOCN: Domain out of range.',JPQUIET)
            CALL INTLOGR(JP_ERROR,'INTOCN: Requested Y = ',RBOTT)
            CALL INTLOGR(JP_ERROR,'INTOCN: Data limit of Y = ',YARR(1))
            INTOCN = JPROUTINE + 10
            GOTO 900
          ENDIF
          IF(JMAX.EQ.NY+1) THEN
            CALL INTLOG(JP_ERROR,'INTOCN: Domain out of range.',JPQUIET)
            CALL INTLOGR(JP_ERROR,'INTOCN: Requested Y = ',RTOP)
            CALL INTLOGR(JP_ERROR,'INTOCN: Data limit of Y = ',YARR(NY))
            INTOCN = JPROUTINE + 11
            GOTO 900
          ENDIF
C 
          NYP    = (JMAX-JMIN)+1
          NYLEFT = JMIN
          DO 411 JI = 1,NYP
            YARR(JI) = YARR(JI+(NYLEFT-1))
  411     CONTINUE
C
          IF((KSEC1(61).EQ.3) .AND. (KYINC*NY*YUNIT.GT.350.0) ) THEN
            IWRAP = 1
            CALL INTLOG(JP_ERROR,'INTOCN: Irregular wrap-round',JPQUIET)
            CALL INTLOG(JP_ERROR,'INTOCN: not yet implemented.',JPQUIET)
            INTOCN = JPROUTINE + 12
            GOTO 900
          ELSE
            IWRAP = 0
          ENDIF
C
        ELSE IF(IIRREG.EQ.3) THEN
          NYP    = NY
          NYLEFT = 1
          JSKIP  = JGCL+NX
          DO 412 JI = 1,NYP
            YARR(JI) = KSEC1(JSKIP+(NY+1-JI))*YUNIT
  412     CONTINUE
          IF((KSEC1(61).EQ.3) .AND. (KYINC*NY*YUNIT.GT.350.0) ) THEN
            IWRAP = 1
            CALL INTLOG(JP_ERROR,'INTOCN: Irregular wrap-round',JPQUIET)
            CALL INTLOG(JP_ERROR,'INTOCN: not yet implemented.',JPQUIET)
            INTOCN = JPROUTINE + 13
            GOTO 900
          ELSE
            IWRAP = 0
          ENDIF
        ENDIF
C
        IF((NXP*NYP).GT.KLENI) THEN
          CALL INTLOG(JP_ERROR,'INTOCN: Array too small.',JPQUIET)
          CALL INTLOG(JP_ERROR,'INTOCN: Required = ',NXP*NYP)
          CALL INTLOG(JP_ERROR,'INTOCN: Available = ',KLENI)
          INTOCN = JPROUTINE + 14
          GOTO 900
        ENDIF
C
C       Copy the data into the temporary array, and invert it at
C       same time.
C       Note: NYLEFT is the starting index in the inverted data array.
C
c       DO 416 JJ = 1,NYP
c         DO 414 JI = 1,NXP
c           PARRAY(JI+(JJ-1)*NXP) = TARRAY(JI+(NY-JJ)*NXP)
c 414     CONTINUE
c 416   CONTINUE
C
        DO 418 JJ = 1,NYP
cc        JJP   = JJ+NYLEFT-1
          JLEFT = NY-(NYLEFT-1)
          JJP   = JLEFT-JJ+1
          IF(IWRAP.EQ.1) THEN
            IF(JJP.LE.0)  JJP = JJP+NY
            IF(JJP.GT.NY) JJP = JJP-NY
          ENDIF
          IF((JJP.GE.1).AND.(JJP.LE.NY)) THEN
            DO 416 JI = 1,NXP
cc            PARRAY(JI+(NYP-JJ)*NXP) = TARRAY(JI+(JJP-1)*NXP)
              PARRAY(JI+(JJ-1)*NXP)   = TARRAY(JI+(JJP-1)*NXP)
  416       CONTINUE
          ELSE
            DO 417 JI = 1,NXP
              PARRAY(JI+(NYP-JJ)*NXP) = RMISS
  417       CONTINUE
          ENDIF
  418   CONTINUE
C
C     Interpolation from a grid irregular in Y.
C
      ELSE IF(((HICODE.EQ.'R').OR.
     *        (HICODE.EQ.'Y').OR.
     *        (HICODE.EQ.'F')    ).AND.
     *       ((IIRREG.EQ.2).OR.(IIRREG.EQ.3))  ) THEN
        YPSIGN = SIGN(1.0,(RTOP-RBOTT))
        IF( YPSIGN.GT.0 ) THEN
          NYP = NINT((RTOP-RBOTT+ 0.0001)/RYRES)+1 
        ELSE
          NYP = NINT((RBOTT-RTOP + 0.0001)/RYRES)+1 
        ENDIF
Cjdc    NYP = NINT((RTOP-RBOTT)/RYRES*YPSIGN)+1
        IF((NXP*NYP).GT.KLENI) THEN
          CALL INTLOG(JP_ERROR,'INTOCN: Array too small.',JPQUIET)
          CALL INTLOG(JP_ERROR,'INTOCN: Required = ',NXP*NYP)
          CALL INTLOG(JP_ERROR,'INTOCN: Available = ',KLENI)
          INTOCN = JPROUTINE + 15
          GOTO 900
        ENDIF
        RTOP    = RBOTT+RYRES*YPSIGN*(NYP-1)
        YARR(1) = RBOTT
        YARR(2) = RYRES*YPSIGN
        YARR(3) = 0.0
        IINTPOL = IINTPOL+2
        IF(IIRREG.EQ.2) THEN
            IOFFSET = JGCL
        ELSE IF(IIRREG.EQ.3) THEN
            IOFFSET = JGCL+NX
        ENDIF
        YSIGN  = SIGN(1.0,((KSEC1(IOFFSET+2)-KSEC1(IOFFSET+1))*1.0))
        YRSIGN = YSIGN*YPSIGN
        DO 420 JI = 1,NXP*NYP
          PARRAY(JI) = RMISS
  420   CONTINUE
C
C       Work through the known (irregular) data points. Calculate the
C       position of the point as a fractional number of points on the
C       new regular grid (YFPOSN). If there are any points on the new
C       grid between this point and the previous one (YFPREV), then set
C       these points by interpolation between the two known points.
C       Check that the points are in range.
C       Note that we are willing to overlap slightly at the start, but
C       must fiddle the array arguments to do this.
C
        YFPREV= (KSEC1(IOFFSET+1)*YUNIT-RBOTT)/RYRES*YPSIGN - 0.5*YRSIGN
        DO 428 JJ = 1,NY
          YFPOSN = (KSEC1(IOFFSET+JJ)*YUNIT-RBOTT)/RYRES*YPSIGN
          NEWPTS =  INTDN((YFPOSN*YRSIGN)) -INTDN((YFPREV*YRSIGN))
C
C         INT truncates toward zero;
C         INTDN truncates downwards in all cases
C
          DO 426 JN = 1,NEWPTS
            IPOS = (INTDN(YFPREV*YRSIGN)+JN)*YRSIGN+1
            RPOS = (IPOS-1)*1.0
            IF((IPOS.GE.1).AND.(IPOS.LE.NYP)) THEN
              JJEFF = JJ
              IF(JJ.EQ.1) JJEFF = 2
              DO 424 JI = 1,NXP
                RVALL = TARRAY(JI+NXP*(JJEFF-2))
                RVALR = TARRAY(JI+NXP*(JJ-1))
                IF(.NOT.MISSING(RVALL) .AND. .NOT.MISSING(RVALR) ) THEN
                  XVAL = (YFPOSN-RPOS)/(YFPOSN-YFPREV)*RVALL
     *                      +(RPOS-YFPREV)/(YFPOSN-YFPREV)*RVALR
                ELSE
                  XVAL = RMISS
                ENDIF
                PARRAY(JI+NXP*(IPOS-1)) = XVAL
  424         CONTINUE
            ENDIF
  426     CONTINUE
          YFPREV = YFPOSN
  428   CONTINUE
C
C
C
C     4.3  INTERPOLATION FROM A GRID REGULAR IN Y
C     -------------------------------------------
C
      ELSEIF(((HICODE.EQ.'Y').OR.(HICODE.EQ.'F')).AND.
     *       ((IIRREG.EQ.0).OR.(IIRREG.EQ.1))    ) THEN

            LNEAREST=.TRUE.

            YPSIGN=SIGN(1.,(RTOP-RBOTT))
            NYP=NINT((RTOP-RBOTT)/RYRES*YPSIGN)+1
            IF((NXP*NYP).GT.KLENI) THEN
              CALL INTLOG(JP_ERROR,'INTOCN: Array too small.',JPQUIET)
              CALL INTLOG(JP_ERROR,'INTOCN: Required = ',NXP*NYP)
              CALL INTLOG(JP_ERROR,'INTOCN: Available = ',KLENI)
              INTOCN = JPROUTINE + 19
              GOTO 900
            ENDIF
            RTOP=RBOTT+RYRES*(NYP-1)*YPSIGN
            YARR(1)=RBOTT
            YARR(2)=RYRES*YPSIGN
            YARR(3)=0.0
C  Work through the new regular grid points. Calculate the position of
C  the point as a fractional number of points on the old grid. Use this
C  fractional number to estimate the value of the field at the new point
            IINTPOL=IINTPOL+2
            DO 335 JI=1,NXP*NYP
               PARRAY(JI)=RMISS
  335       CONTINUE
            XOSOUT=KLAT1*YUNIT
            XORES =KYINC*YUNIT
            DO 3370 JJ=1,NYP
               RPOS=(RBOTT+(JJ-1)*RYRES*YPSIGN-XOSOUT)/XORES + 1
               JPOS=INTDN(RPOS)
C  Check for out of bounds, and set to missing if this is the case
               IF((JPOS.GE.1).AND.(JPOS+1.LE.NY)) THEN
                 DO 3360 JI=1,NXP
                    RVALB = TARRAY(JI+(JPOS-1)*NXP)
                    RVALT = TARRAY(JI+(JPOS+1-1)*NXP)
                    IF(.NOT.MISSING(RVALB).AND.
     *                 .NOT.MISSING(RVALT)       ) THEN
                       RVAL=(JPOS+1-RPOS)*RVALB
     *                      +(RPOS-JPOS)*RVALT
                    ELSEIF(LNEAREST) THEN
                      IF((.NOT.MISSING(RVALB)) .AND.
     *                   ((JPOS+1-RPOS).GT.0.5)  ) THEN
                        RVAL=RVALB
                      ELSEIF((.NOT.MISSING(RVALT)).AND.
     *                   ((RPOS-JPOS).GT.0.5)  ) THEN
                        RVAL=RVALT
                      ELSE
                        RVAL=RMISS
                      ENDIF
                    ELSE
                      RVAL=RMISS
                    ENDIF
                    PARRAY(JI+(JJ-1)*NXP)=RVAL
 3360            CONTINUE
               ELSE
                  DO 3365 JI=1,NXP
                     PARRAY(JI+(JJ-1)*NXP)=RMISS
 3365             CONTINUE
               ENDIF
 3370       CONTINUE
C
C
      ELSE
        CALL INTLOG(JP_ERROR,'INTOCN: Error in logic.',JPQUIET)
        CALL INTLOG(JP_ERROR,'INTOCN: HICODE = ',JPQUIET)
        CALL INTLOG(JP_ERROR,HICODE,JPQUIET)
        CALL INTLOG(JP_ERROR,'INTOCN: IIRREG = ',IIRREG)
        INTOCN = JPROUTINE + 16
        GOTO 900
      ENDIF
C
C     ------------------------------------------------------------------
C*    Section 9 . Return.
C     ------------------------------------------------------------------
C
  900 CONTINUE
C
C
      RETURN
      END

C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE CREXEPWT(KDD,KERR)
C
C**** *CREXEPWT*
C
C
C     PURPOSE.
C     --------
C          UPDATES WORKING TABLES SETTING ELEMENT NAME,UNIT,SCALE,
C     REFERENCE VALUE AND DATA WIDTH.
C
C
C**   INTERFACE.
C     ----------
C
C          *CALL* *CREXEPWT(KDD,KELEM,KERR)*
C
C        INPUT :
C               *KDD*     -  DATA DESCRIPTOR
C        OUTPUT:
C               *KERR*    -  RETURN ERROR CODE
C
C     METHOD.
C     -------
C
C          NONE.
C
C
C     EXTERNALS.
C     ----------
C
C          NONE.
C
C     REFERENCE.
C     ----------
C
C          NONE.
C
C     AUTHOR.
C     -------
C
C          MILAN DRAGOSAVAC    *ECMWF*       07/01/2004.
C
C
C     MODIFICATIONS.
C     --------------
C
C          NONE.
C
C
      IMPLICIT LOGICAL(L,O,G), CHARACTER*8(C,H,Y)
C
C
      PARAMETER(JSUP =   9,JSEC0=   3,JSEC1= 40,JSEC2= 64 ,JSEC3=    4,
     1          JSEC4=2,JELEM=40000,JSUBS=400,JCVAL=150 ,JBUFL=40000,
     2          JBPW =  32,JTAB =3000,JCTAB=120,JCTST=1800,JCTEXT= 200,
     3          JWORK=360000,JKEY=46)
C
C
C
      COMMON /CRWORK/ NBPT,NGS,NVIND,NBPTSEC2,RVIND,EPS,NE,IEOLD,
     1                  NC07YYY
C
      COMMON /CRWT/ NCREXDWINC,NCREXSCAM,NCREXAFDW,NCREXWT ,ODREPF,
     2             NCREXSTACK(JELEM),NCREXWTEN(JELEM),
     3             NCREXWTR (JELEM),NCREXWTS (JELEM),
     4             NCREXWTDW(JELEM)
C
C             NCREXDWINC   -  data width increment
C             NCREXSCAM    -  scale multiplier
C             NCREXAFDW    -  augmented field data width
C             NCREXWT      -  pointer to working table
C             NCREXSTACK   -  list of data descriptors
C             ODREPF   -  replication (logical)
C             NCREXWTR     -  working table reference
C             NCREXWTS     -  working scale
C             NCREXWTDW    -  working data width
C
C
C
      COMMON /CRWTC/ CREXWTEN(JELEM),CREXWTU(JELEM)
C
C             CREXWTEN    -  working table element naame
C             CREXWTU     -  working table units
C
      CHARACTER CREXWTEN*64,CREXWTU*24
C
C
C

      COMMON/CRTAB/ NCREXBR(JTAB),NCREXBS(JTAB)    , NCREXBDW(JTAB),
     1              NCREXDR(JTAB),NCREXDST(JTAB)   ,
     2              NCREXDL(JTAB),NCREXDSQ(JTAB*20),NCREXP(64,255)

C
C             NCREXBR     - table B,  table reference              array
C             NCREXBS     - table B,  scale                        array
C             NCREXBDW    - table B,  data width                   array
C             NCREXDR     - table D,  table reference              array
C             NCREXDST    - table D,  starting pointers            array
C             NCREXDL     - table D,  lengths                      array
C             NCREXDSQ    - table D,  list of sequence descriptors array
C
C
C

C      COMMON /CRTABC/ CREXNAME(JTAB),CREXUNIT(JTAB),CREXLST(JELEM)
       COMMON /CRTABC/ CREXNAME(JTAB),CREXUNIT(JTAB)
C
C             CREXNAME      -  table B, ELEMENT NAME           array
C             CREXUNIT      -  table B, unit                   array
C
      COMMON /CRATB/  NJA,NCREXATBTR(JTAB),NCREXATBS (JTAB),
     1                NCREXATBDW(JTAB)
C
C
C             NCREXATBTR      - augmented table B table reference
C             NCREXATBS       - augmented table B scale
C             NCREXATBDW      - augmented table B data width
C
C
      COMMON /CRATBC/ CREXATBEN(JTAB),CREXATBU (JTAB)
C
C             CREXATBEN      - augmented table B element name
C             CREXATBU       - augmented table B units
C
C
      COMMON /CRBEF / M,MM,N,JCV
C
C             M       -  Number of elements
C             MM      -  Number of elements
C             N       -  Number of data sub_sets
C             JCV     -  Number of character values
C
C
C
C
      REAL*8 RVIND,EPS
C
      character*64 CREXNAME, CREXATBEN
      character*24 CREXATBU,CREXUNIT
C
C
C
C     ------------------------------------------------------------------
C*          1.   UPDATE WORKING TABLE.
C                ---------------------
 100  CONTINUE
C
      IF( KERR.NE.0 ) RETURN
C
      ICLASS=KDD/1000
      IYYY  =KDD-ICLASS*1000+1
      ICLASS=ICLASS+1
C
C*          1.1  ASSOCIATED FIELD ?
C                ------------------
 110  CONTINUE
C
      IF(NCREXAFDW.EQ.0) GO TO 140
C
C*          1.2  UNITS ELEMENT DESCRIPTOR ?
C                --------------------------
 120  CONTINUE
C
      I=NCREXP(ICLASS,IYYY)
      IF(I.EQ.0) THEN
         KERR=23
         WRITE(*,*) ' CREXEPWT : ', KDD
         CALL CREXERR(KERR)
         DO IQ=1,JELEM
         NCREXSTACK(IQ)=0.
         END DO
         RETURN
      END IF
C
      IF(CREXUNIT(I)(1:4).EQ.'CODE') GO TO 140
      IF(CREXUNIT(I)(1:4).EQ.'FLAG') GO TO 140
      IF(CREXUNIT(I)(1:3).EQ.'NUM' ) GO TO 140
C
C*          1.3   ADD SPECIAL ENTRY TO WORKING TABLE.
C                 -----------------------------------
 130  CONTINUE
C
      NCREXWT=NCREXWT+1
      CREXWTEN(NCREXWT)='ASSOCIATED FIELD'
      CREXWTU (NCREXWT)=' '
      NCREXWTDW(NCREXWT)=NCREXAFDW
      NCREXWTR (NCREXWT)= 999999
      NCREXWTEN(NCREXWT)= 0
      NCREXWTS (NCREXWT)= 0
      NCREXAFDW=0
C
      M=NCREXWT
C
C     ------------------------------------------------------------------
C*          1.4   SEARCH AUGMENTED TABLE *B ENTRIES .
C                 -----------------------------------
 140  CONTINUE
C
C
C
C*          1.5  GET TABLE *B ENTRY .
C                ---------------------
 150  CONTINUE
C
      I=NCREXP(ICLASS,IYYY)
      IF(I.EQ.0) THEN
         KERR=23
         WRITE(*,*)  'CREXEPWT : ',KDD
         CALL CREXERR(KERR)
         DO 2 IQ=1,JELEM
         NCREXSTACK(IQ)=0.
 2       CONTINUE
         RETURN
      END IF
C
 155  CONTINUE
C
C     -----------------------------------------------------------------
C*          1.6   MODIFY ENTRY FOR OPERATOR IN FORCE.
C                 -----------------------------------
 160  CONTINUE
C
C*                ADD ENTRY TO WORKING TABLE.
C                 ---------------------------
      NCREXWT=NCREXWT+1
      NCREXWTR (NCREXWT) = KDD
      IF(NCREXSCAM.ne.0) THEN
         NCREXWTS (NCREXWT) = NCREXSCAM
      ELSE
         NCREXWTS (NCREXWT) = NCREXBS (I)
      END IF
C
      NCREXSCAM=0
C
      IF(NCREXDWINC.ne.0) THEN
         NCREXWTDW(NCREXWT) = NCREXDWINC
      ELSE
         NCREXWTDW(NCREXWT) = NCREXBDW(I)
      END IF
C
      NCREXDWINC=0
C
      IF(NCREXWTR (NCREXWT).eq.031002) THEN
         NCREXWTDW(NCREXWT)=4
      END IF
C
C     CHECK IF DATA ARE PRESENT IN DATA SECTION.
C
      IF(NCREXWTR(NCREXWT).eq.31011.or.
     1   NCREXWTR(NCREXWT).eq.31012) then
         IF(NCREXWTR(NCREXWT-1).eq.31011.or.
     2      NCREXWTR(NCREXWT-1).eq.31012) THEN
            NCREXWTDW(NCREXWT)=0
         END IF
      END IF

 175  CONTINUE
C
C*          1.8 UPDATE M.
C               ---------
 180  CONTINUE
C
C
      CREXWTEN(NCREXWT) = CREXNAME(I)
      IF(NC07YYY.NE.0) THEN
         CREXWTU (NCREXWT) = YUNIT
         YUNIT=' '
         NC07YYY=0
      else
         CREXWTU (NCREXWT) = CREXUNIT(I)
      END IF
      NCREXWTEN(NCREXWT) = 0
      IF(CREXUNIT(I)(1:3).EQ.'CHA') NCREXWTEN(NCREXWT)=658367
C
       M = M + 1
C
C     ------------------------------------------------------------------
C
 200  CONTINUE
C
      RETURN
C
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE CREXDES(K,KSEC1,KTDLEN,CREXKTDLST,KDLEN,KDATA,KELEM,
     1                   KTDEXL,CREXKTDEXP,CNAMES,CUNITS,KERR)
C
C**** *CREXDES*
C
C
C     PURPOSE.
C     --------
C           EXPAND DATA DESCRIPTORS TO SHOW USER TEMPLATE 
C           DESCRIBED BY ARRAY KTDLST AND KDATA
C
C
C**   INTERFACE.
C     ----------
C
C           *CALL* *CREXDES(K,KSEC1,KTDLEN,CREXKTDLST,KDLEN,KDATA,KELEM,
C                           KTDEXL,CREXKTDEXP,CNAMES,CUNITS,KERR)*
C
C
C
C        INPUT :
C               *K*       -   AN INTEGER, PRINTING SWITCH 0 - NO PRINT
C                                                         1 - PRINT
C               *KSEC1*   -  Integer array of at least 40 words
C                            containing CREX section 1 information
C                            KSEC1( 1)-- Reserved
C                            KSEC1( 2)-- CREX Edition number
C                            KSEC1( 3)-- Reserved
C                            KSEC1( 4)-- Reserved
C                            KSEC1( 5)-- Reserved
C                            KSEC1( 6)-- CREX message type
C                            KSEC1( 7)-- Reserved
C                            KSEC1( 8)-- version number of local table used
C                            KSEC1( 9)-- Reserved
C                            KSEC1(10)-- Reserved
C                            KSEC1(11)-- Reserved
C                            KSEC1(12)-- Reserved
C                            KSEC1(13)-- Reserved
C                            KSEC1(14)-- CREX Master table
C                            KSEC1(15)-- version number of Master table used
C                            KSEC1(16) - KSEC1(40) -- Reserved
C                           
C                            Crex Edition 2
C
C                            
C               *KSEC1*   -  Integer array of at least 40 words
C                            containing CREX section 1 information
C                            KSEC1( 1)-- Reserved
C                            KSEC1( 2)-- CREX Edition number
C                            KSEC1( 3)-- Originating Centre ( oooo)
C                            KSEC1( 4)-- Update sequence number (uu)
C                            KSEC1( 5)-- Number of subsets (sss)
C                            KSEC1( 6)-- CREX data category (nnn)
C                            KSEC1( 7)-- International data sub-category (mmm)
C                            KSEC1( 8)-- version number of local table used
C                            KSEC1( 9)-- Year (yyyy)
C                            KSEC1(10)-- Month (mm)
C                            KSEC1(11)-- Day (dd)
C                            KSEC1(12)-- Hour (hh)
C                            KSEC1(13)-- Minute (mm)
C                            KSEC1(14)-- CREX Master table (tt)
C                            KSEC1(15)-- version number of Master table used (vv)
C                            KSEC1(16)-- Originating sub-centre (ppp)
C                            KSEC1(17)-- Bufr master table version number
C                            KSEC1(18)-- Bufr version number of local table used
C                            KSEC1(19) - KSEC1(40) -- Reserved
C
C
C               *KTDLEN*  -  Integer number of data descriptors in the list
C               *CREXKTDLST* Integer array of at least ktdlen words
C               *KDLEN*   -  Integer (dimension of kdata array)
C               *KDATA*   -  Integer array containing data needed for data
C                            descriptor expansion (delayed replication factors)
C                            which appear in the values array
C               *KELEM*   -
C        OUTPUT:
C
C               *KTDEXL   -  An integer containing number of expanded elements
C
C               *KTDEXP*  -  An integer array containing expanded list of descriptors
C
C               *CNAMES*  -  Character*64  array of KELEM containing
C                            CREX Table B element names
C               *CUNITS*  -  Character*24 array of KELEM containig
C                            CREX Table B units
C               *VALUES*  -  Real*8 array of KVALS containing expanded
C                            data values
C               *KERR*    -  returned error code
C
C
C
C
C     METHOD.
C     -------
C
C            NONE
C
C     EXTERNALS.
C     ----------
C
C            NONE.
C
C     REFERENCE.
C     ----------
C
C          NONE.
C
C     AUTHOR.
C     -------
C
C          M. DRAGOSAVAC    *ECMWF*       04/02/2003.
C
C     MODIFICATIONS.
C     --------------
C
C          NONE.
C
      IMPLICIT LOGICAL(L,O,G), CHARACTER*8(C,H,Y)


      PARAMETER(JSUP =   9,JSEC0=   3,JSEC1= 40,JSEC2= 64 ,JSEC3=    4,
     1          JSEC4=   2,JELEM=40000,JSUBS=400,JCVAL=150 ,JBUFL=40000,
     2          JBPW =  32,JTAB =3000,JCTAB=120,JCTST=1800,JCTEXT= 200,
     3          JWORK=360000,JKEY=46)
C
C
      COMMON /CRWORK/ NBPT,NGS,NVIND,NBPTSEC2,RVIND,EPS,NE,IEOLD,
     1                  NC07YYY
C
      COMMON /CRWT/ NCREXDWINC,NCREXSCAM,NCREXAFDW,NCREXWT ,ODREPF,
     2             NCREXSTACK(JELEM),NCREXWTEN(JELEM),
     3             NCREXWTR (JELEM),NCREXWTS (JELEM),
     4             NCREXWTDW(JELEM)
C
C             NCREXDWINC   -  data width increment
C             NCREXSCAM    -  scale multiplier
C             NCREXAFDW    -  augmented field data width
C             NCREXWT      -  pointer to working table
C             NCREXSTACK   -  list of data descriptors
C             ODREPF   -  replication (logical)
C             NCREXWTR     -  working table reference
C             NCREXWTS     -  working scale
C             NCREXWTDW    -  working data width
C
C
C
      COMMON /CRWTC/ CREXWTEN(JELEM),CREXWTU(JELEM)
C
C             CREXWTEN    -  working table element naame
C             CREXWTU     -  working table units
C
      CHARACTER CREXWTEN*64,CREXWTU*24
C
      COMMON /CREL/ NCREXTDLEN,NCREXTDLST(JELEM),NCREXTDEXL,
     1              NCREXTDEXP(JELEM)
C
C             NCREXTDLEN - number of Data descriptors in section 3
C             NCREXTDLST - list of Data descriptors
C             NCREXTDEXL - number of expanded Data Descriptors
C             NCREXTDEXP - list of expanded Data descriptors
C
      COMMON /CRBEF / M,MM,N,JCV
C
C             M       -  Number of elements
C             MM      -  Number of elements
C             N       -  Number of data sub_sets
C             JCV     -  Number of character values

      CHARACTER*15  FMT
      CHARACTER*6  CREXKTDLST(KELEM)
      CHARACTER*6 CREXKTDEXP(KELEM)
C
      INTEGER IVALUE(KELEM)
C
      INTEGER IVAL,IIVAL
c
      REAL*8 EPS
      REAL*8 RVIND
      REAL*8 VAL
C
      CHARACTER*64 CNAMES(kelem)
      CHARACTER*24 CUNITS(kelem)

      DIMENSION KSEC0(JSEC0),KSEC1(JSEC1)
C
      CHARACTER*4 CECMWF
C
C     ------------------------------------------------------------------
C
c*         1. Set Constants
c             ----------------
 100  CONTINUE
c
      KERR=0
      IF(CECMWF.NE.'ECMF') THEN
         CALL CREXIVAR(KERR)
         CECMWF='ECMF'
      END IF
c
c*         2. Load Crex Tables
c             ----------------
 200  CONTINUE
c
      CALL CREXETAB(KSEC1,KERR)
      IF(KERR.GT.0) RETURN

c
c*         3.1 Expand Data Descriptors
c              -----------------------
c
 310  CONTINUE
c
      KPT=0
      CALL CREXEDD(KPT,KTDLEN,CREXKTDLST,KDLEN,KDATA,KSEC3,
     1             KELEM,CNAMES,CUNITS,KERR)
      IF(KERR.GT.0) RETURN
C
      KTDEXL =M
      DO 301 I=1,KTDEXL
      WRITE(CREXKTDEXP(I),'(i6.6)') NCREXWTR(I)
      IF(CREXKTDEXP(I)(1:1).EQ.'0') CREXKTDEXP(I)(1:1)="B"
 301  CONTINUE
C
      IF(K.EQ.1) THEN
C
         WRITE(*,'(1H ,//)')
         WRITE(*,'(1H ,A)')    '       DATA DESCRIPTORS (UNEXPANDED)'
C
         WRITE(*,'(1H )')
         DO 110 I=1,KTDLEN
          IF(CREXKTDLST(I)(1:1).EQ.'3') CREXKTDLST(I)(1:1)="D"
          IF(CREXKTDLST(I)(1:1).EQ.'2') CREXKTDLST(I)(1:1)="C"
          IF(CREXKTDLST(I)(1:1).EQ.'1') CREXKTDLST(I)(1:1)="R"
          IF(CREXKTDLST(I)(1:1).EQ.'0') CREXKTDLST(I)(1:1)="B"
          WRITE(*,'(1H ,I4,2X,A)') I,CREXKTDLST(I)
 110     CONTINUE
C
         WRITE(*,'(1H ,/)')
         WRITE(*,'(1H ,A)')    '       DATA DESCRIPTORS (EXPANDED)'
         WRITE(*,'(1H )')
         WRITE(*,'(1H ,A,A)')'                ELEMENT NAME',
     1   '                            UNIT'
         WRITE(*,'(1H )')
C
         DO 120 I=1,KTDEXL
          WRITE(*,'(1H ,I5,2X,A,2X,A,2X,A)') I,CREXKTDEXP(I),
     1                      CNAMES(I)(1:40),CUNITS(I)(1:18)
 120     CONTINUE
      END IF
C
C
C     -----------------------------------------------------------------
      RETURN
C
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      INTEGER FUNCTION EMOSCYC(KONOFF,KCYCLES)
C
C---->
C**** EMOSCYC
C
C     Purpose
C     -------
C
C     Returns current EMOS_CYCLE version number.
C
C
C     Interface
C     ---------
C
C     INUM = EMOSCYC(KONOFF,KCYCLES)
C
C     Input
C     -----
C
C     KONOFF - switch for displayed message
C              = 0 if display is required on the first call
C              = non-zero if display is not required
C
C
C     Output
C     ------
C
C     Returns a 6-digit version number, aaabbc, where:
C       aaa = 3-digit major number
C       bb  = 2-digit minor number
C       c   = 1-digit spare number (normally 0)
C
C     KCYCLES(1) = INTP_CYCLE number
C     KCYCLES(2) = BUFR_CYCLE number
C     KCYCLES(3) = GRIB_CYCLE number
C     KCYCLES(4) = PBIO_CYCLE number
C     
C
C     Method
C     ------
C
C     Reads a 6-digit version number from the environment variable
C     EMOS_CYCLE. If this does not give a 6-digit number, an internal
C     hard-coded default value is used.
C
C     On the first call, the function (optionally) displays a message:
C
C       **************************************
C       * EMOS_CYCLE version number = nnnnnn *
C       * INTP_CYCLE = iiiiii
C       * BUFR_CYCLE = bbbbbb
C       * GRIB_CYCLE = gggggg
C       * PBIO_CYCLE = pppppp
C       **************************************
C     
C
C     Externals
C     ---------
C
C     None.
C     
C
C     Author
C     ------
C
C     J.D.Chambers     ECMWF     May 1998
C
C
C----<
C ------------------------------------------------------------------
C*    Section 0.   Variables.
C ------------------------------------------------------------------
C
C
      IMPLICIT NONE
C
#include "common/grprs.h"
C
C     Function arguments
C
      INTEGER KONOFF, KCYCLES(4)
C
C     Local variables
C
      INTEGER INUMBER, ICOUNT, IOFFSET
      SAVE INUMBER, ICOUNT
      CHARACTER*38 CMESS
      CHARACTER*20 YNUMBER
C
C     Externals
C
      INTEGER INTPNUM, BUFRNUM, GRIBNUM, PBIONUM
C
      DATA INUMBER/100000/, ICOUNT/0/
      DATA CMESS/'* EMOS_CYCLE version number = ****** *'/
C
C ------------------------------------------------------------------
C*    Section 1.   Initialise
C ------------------------------------------------------------------
C
  100 CONTINUE
C
      IF( ICOUNT.EQ.0 ) THEN
C
C       See if the environment variable has an override value
C
        CALL GETENV( 'EMOS_CYCLE', YNUMBER)
        IOFFSET = INDEX( YNUMBER, ' ')
        IF( IOFFSET.EQ.7 ) THEN
          READ(YNUMBER,'(I6.6)') INUMBER
        ENDIF
C
      KCYCLES(1) = INTPNUM(1)
      KCYCLES(2) = BUFRNUM(1)
      KCYCLES(3) = GRIBNUM(1)
      KCYCLES(4) = PBIONUM(1)
C
C       First time through, display the message if required
C
        IF( KONOFF.EQ.0 ) THEN
          WRITE(CMESS(31:36),'(I6.6)') INUMBER
          WRITE(GRPRSM,*) '**************************************'
          WRITE(GRPRSM,*) CMESS
          CMESS(3:6) = 'INTP'
          WRITE(CMESS(31:36),'(I6.6)') KCYCLES(1)
          WRITE(GRPRSM,*) CMESS
          CMESS(3:6) = 'BUFR'
          WRITE(CMESS(31:36),'(I6.6)') KCYCLES(2)
          WRITE(GRPRSM,*) CMESS
          CMESS(3:6) = 'GRIB'
          WRITE(CMESS(31:36),'(I6.6)') KCYCLES(3)
          WRITE(GRPRSM,*) CMESS
          CMESS(3:6) = 'PBIO'
          WRITE(CMESS(31:36),'(I6.6)') KCYCLES(4)
          WRITE(GRPRSM,*) CMESS
          WRITE(GRPRSM,*) '**************************************'
        ENDIF
        ICOUNT = 1
      ENDIF
C
      EMOSCYC = INUMBER
C
      RETURN
      END

c Copyright 1981-2012 ECMWF.
c
c This software is licensed under the terms of the Apache Licence 
c Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
c
c In applying this licence, ECMWF does not waive the privileges and immunities 
c granted to it by virtue of its status as an intergovernmental organisation 
c nor does it submit to any jurisdiction.
c

      SUBROUTINE SYMINV(A,NDIM,N,COND,V,DEPS)
      DIMENSION A(NDIM,NDIM),V(NDIM)
C     INVERT IN PLACE THE LOWER TRIANGLE OF A (I.E. A(I,J) I.GE.J)
C     A IS A SYMMETRIC POSITIVE DEFINITE MATRIX
C     THE UPPER TRIANGLE OF A (IE. A(I,J) I.LT.J) IS NOT USED OR ALTERED
C
C     THIS VERSION IS OPTIMIZED FOR THE CDC FTN COMPILER.
C     IT REQUIRES THE FUNCTION 'NUMARG' FROM  'ECLIB'
C
      IF(N.LT.1)RETURN
        EPS=0.
c       IF(NUMARG().EQ.6) EPS=DEPS
      NDIA=NDIM+1
      IMX=ISAMAX(N,A(1,1),NDIA)
      ZMX=A(IMX,IMX)*FLOAT(N*N)
C     SECTION 1 & 2 COMBINED IN THIS VERSION
C**** 1. ROOT FREE CHOLESKY DECOMPOSITION  A =L D L(TRANSPOSE)
      J=1
      IF(A(1,1).LE.EPS)GOTO91
      V(1)=1./A(1,1)
      IF(N.EQ.1)GOTO20
      X=A(2,1)*V(1)
      A(2,2)=A(2,2)-X*A(2,1)
      A(2,1)=X
      IF(A(2,2).LE.EPS)GOTO91
      V(2)=1./A(2,2)
      IF(N.EQ.2)GOTO20
      DO 14 I=3,N
      DO 12 J=3,I
      S=A(I,J-1)
      DO 11 K=3,J
 11   S=S-A(I,K-2)*A(J-1,K-2)
      A(I,J-1)=S
 12   CONTINUE
      S=A(I,I)
      DO 13 J=2,I
      X=A(I,J-1)*V(J-1)
      S=S-X*A(I,J-1)
 13   A(I,J-1)=X
      A(I,I)=S
C         CHECK FOR POSITIVE-DEFINITENESS AND INVERT DIAGONAL MATRIX D.
      IF(A(I,I).LE.EPS)GOTO91
      V(I)=1./A(I,I)
 14   CONTINUE
C
C**** 2.  COPY INVERSE OF D WHICH HAS ALREADY BEEN CALCULATED.
 20   DO 21 J=1,N
 21   A(J,J)=V(J)
      IF(N.EQ.1) GO TO 50
C
C**** 3.  INVERSION OF L
 30   A(2,1)=-A(2,1)
      NM1=N-1
      IF(N.EQ.2)GOTO40
      DO 33 I=2,NM1
      DO 32 J=2,I
      S=A(I+1,J-1)
      DO 31 K=J,I
 31   S=S+A(I+1,K)*A(K,J-1)
 32   A(I+1,J-1)=-S
 33   A(I+1,I)=-A(I+1,I)
C
C**** 4.  INV A = INV L(TRANSPOSE) * INV D * INV L
 40   DO 44 J=2,N
      S=A(J-1,J-1)
      DO 41 I=J,N
      X=A(I,I)*A(I,J-1)
      S=S+A(I,J-1)*X
 41   A(I,J-1)=X
      A(J-1,J-1)=S
      IF(J.EQ.N) GO TO 50
      DO 43 I=J,NM1
      S=A(I,J-1)
      DO 42 K=I,NM1
 42   S=S+A(K+1,I)*A(K+1,J-1)
      A(I,J-1)=S
 43   CONTINUE
 44   CONTINUE
C
 50   IMX=ISAMAX(N,A(1,1),NDIA)
      COND=1./ABS(A(IMX,IMX)*ZMX)
      RETURN
C
 91   COND=-FLOAT(J)
      RETURN
      END
      INTEGER FUNCTION ISAMAX(N,A,M)
C
C     FIND THE LARGEST ABSOLUTE ELEMENT OF A , SPACED M WORDS APART
C
      DIMENSION A(*)
C
      LARGE=1
      IF(N.LE.1) GO TO 9
      INDEX=1+M
      DO 1 I=2,N
      IF(ABS(A(INDEX)).GE.ABS(A(LARGE))) LARGE=I
1     INDEX=INDEX+M
9     ISAMAX=LARGE
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE CMPCK(PSPEC,KTRUNC,KTRUNCNP)
C
C---->
C**** CMPCK
C
C     Purpose.
C     --------
C
C     Puts spectral coefficients in contiguous locations.
C
C
C**   Interface.
C     ----------
C
C     CALL CMPCK(PSPEC,KTRUNC,KTRUNCNP)
C
C
C     Input Parameters.
C     -----------------
C
C     PSPEC      - Array of spectral coefficients.
C     KTRUNC     - Truncation of the spherical harmonic coefficients.
C     KTRUNCNP   - Truncation of the subset of spherical harmonic
C                  coefficients to be ignored.
C
C
C     Output Parameters.
C     -----------------
C
C     PSPEC      - Array of spectral coefficients rearranged.
C
C
C     Method.
C     -------
C
C                            <subset>|
C
C     Given numbers:         cccccccc|CCCCCC
C                              cccccc|CCCCCC
C                                cccc|CCCCCC
C                                  cc|CCCCCC
C                                    |CCCCCC
C                                       CCCC
C                                         CC
C
C    Removes the subset and makes the CCCCCC...C values contiguous
C    in array PSPEC.
C
C     Externals.
C     ----------
C
C     None.
C
C
C     Reference.
C     ----------
C
C     None.
C
C
C     Comments.
C     --------
C
C     None.
C
C
C     Author.
C     -------
C
C     M.Hamrut         ECMWF      09:05:94
C
C
C     Modifications.
C     _____________
C
C     None.
C
C
C----<
C     -----------------------------------------------------------------
C*    Section 0. Definition of variables.
C     -----------------------------------------------------------------
C
      IMPLICIT NONE
C
C     Subroutine arguments
C
      INTEGER KTRUNC, KTRUNCNP
      REAL PSPEC
      DIMENSION PSPEC((KTRUNC+1)*(KTRUNC+2))
C
C     Local variables.
      INTEGER IUC, IC, JM, JN, IL2, IL1, ILEN
C
C
C     -----------------------------------------------------------------
C*    Section 1. Move only the required values (overwriting).
C     -----------------------------------------------------------------
C
      IUC=0
      IC =0
C
C     Loop through rows.
      DO 102 JM=0,KTRUNC
C
C       In each row calculate value to start with.
C       For early rows there are some value to skip (in the subset
C       being ignored).
        IL2=MAX(JM,KTRUNCNP+1)
        IL1=IL2-1
        IUC=IUC+MAX((IL1-JM+1)*2,0)
        ILEN=2*(KTRUNC-IL2+1)
C
C       Move values for the row.
CDIR$ IVDEP      
!OCL NOVREC
        DO 104 JN=1,ILEN
          IUC = IUC+1
          IC  = IC+1
          PSPEC(IC) = PSPEC(IUC)
 104    CONTINUE     
 102  CONTINUE
C
C     -----------------------------------------------------------------
C*    Section 9. Return.
C     -----------------------------------------------------------------
C
 900  CONTINUE
      RETURN
      END        

      PROGRAM BUFRNTM
C
C**** *BUFRNTM*
C
C
C     PURPOSE.
C     --------
C        CONVERT BUFR EDITION N TO BUFR EDITION M MESSAGES.
C        BY DEFAULT CONVERSION WILL BE THE LATEST.
C
C
C**   INTERFACE.
C     ----------
C
C          NONE.
C
C     METHOD.
C     -------
C
C          NONE.
C
C
C     EXTERNALS.
C     ----------
C
C         CALL BUSEL
C         CALL BUFREX
C         CALL BUFREN
C         CALL BUPRS0
C         CALL BUPRS1
C         CALL BUPRS2
C         CALL BUPRS3
C         CALL BUPRT
C         CALL BUUKEY
C
C     REFERENCE.
C     ----------
C
C          NONE.
C
C     AUTHOR.
C     -------
C
C          M. DRAGOSAVAC    *ECMWF*       15/09/94
C
C
C     MODIFICATIONS.
C     --------------
C
C          NONE.
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
      PARAMETER(JSUP =   9,JSEC0=   3,JSEC1= 40,JSEC2=4096 ,JSEC3= 4,
     1       JSEC4=   2,JELEM=160000,JSUBS=400,JCVAL=150 ,JBUFL=512000,
#ifdef JBPW_64
     2          JBPW =  64,JTAB =3000,JCTAB=120,JCTST=1800,JCTEXT=1200,
#else
     2          JBPW =  32,JTAB =3000,JCTAB=120,JCTST=1800,JCTEXT=1200,
#endif
     3          JWORK=4096000,JKEY=46,JBYTE=512000)
C
      PARAMETER (KELEM=160000)
      PARAMETER (KVALS=4096000)
      PARAMETER (ISUBEN=5)
C 
      DIMENSION KBUFF(JBUFL)
      DIMENSION KBUFR(JBUFL)
      DIMENSION KSUP(JSUP),KSEC0(JSEC0),KSEC1(JSEC1)
      DIMENSION KSEC1_TEMP(JSEC1+2)
      DIMENSION KSEC2(JSEC2),KSEC3(JSEC3),KSEC4(JSEC4)
      DIMENSION KEY  (JKEY)
C
      REAL*8  VALUES(KVALS),VALUE(KVALS),VALS(KVALS)
      REAL*8  RVIND,EPS
      DIMENSION KTDLST(KELEM),KTDEXP(KELEM)
      DIMENSION KTDLST1(KELEM),KTDEXP1(KELEM)
      DIMENSION KDATA(200)
      DIMENSION ISUBTYPES(ISUBEN)
C
      CHARACTER*256 CF,CF1
      CHARACTER*64 CNAMES(KELEM)
      CHARACTER*24 CUNITS(KELEM)
      CHARACTER*80 CVALS(KVALS)
      CHARACTER*80 CVAL(KVALS)
      CHARACTER*80 YENC
      CHARACTER*9  CSHIP
      CHARACTER*256 CINFILE,COUTFILE,CARG(10)
      CHARACTER*2 CEDITION,CBMTVN,CVNMTU,CVNLTU
C
      DATA ISUBTYPES/2,4,12,14,104/
C
cs      EXTERNAL GETARG
C                                                                       
C     ------------------------------------------------------------------
C*          1. INITIALIZE CONSTANTS AND VARIABLES.
C              -----------------------------------
 100  CONTINUE
C
C     MISSING VALUE INDICATOR
C 
      print*,'The following subtypes will be skipped by bufr_ntm:'
      print*,'2,4,12,14,104'
c
      RVIND=1.7D38
      EPS=10.D-8
      NREAD=0 
      NBYTPW=JBPW/8
      N=0
      IERROR=0
C
C     GET INPUT AND OUTPUT FILE NAME.
C
      NARG=IARGC()
C
      IF(NARG.LT.4) THEN
          PRINT*,'USAGE -- bufr_ntm -i infile -o outfile'
          PRINT*,'OTHER OPTIONS:'
          PRINT*,'               -e BUFR EDITION NUMBER'
          PRINT*,'               -f VERSION NUMBER OF MASTER TABLE USED'
          PRINT*,'               -g VERSION NUMBER OF LOCAL TABLE USED'
          PRINT*,'               -h TOLERATED NUMBER OF ERRORS'
          PRINT*,'               DEFAULT - LAST AVAILABLE'
          call exit(2)
      END IF
C
      DO 101 J=1,NARG
      CALL GETARG(J,CARG(J))
 101  CONTINUE
C
      CINFILE=' '
      COUTFILE=' '
      CEDITION=' '
      CVNMTU=' '
      CVNLTU=' '
      CERROR=' '
C
      DO 102 J=1,NARG,2
      IF(CARG(J).EQ.'-i') THEN
         CINFILE=CARG(J+1)
      ELSEIF(CARG(J).EQ.'-o') THEN
         COUTFILE=CARG(J+1)
      ELSEIF(CARG(J).EQ.'-e') THEN
         CEDITION=CARG(J+1)
      ELSEIF(CARG(J).EQ.'-f') THEN
         CVNMTU=CARG(J+1)
      ELSEIF(CARG(J).EQ.'-g') THEN
         CVNLTU=CARG(J+1)
      ELSEIF(CARG(J).EQ.'-h') THEN
         CERROR=CARG(J+1)
      ELSE
          PRINT*,'USAGE -- bufr_ntm  -i infile -o outfile'
          PRINT*,'OTHER OPTIONS:'
          PRINT*,'               -e BUFR EDITION NUMBER'
          PRINT*,'               -f VERSION NUMBER OF MASTER TABLE USED'
          PRINT*,'               -g VERSION NUMBER OF LOCAL TABLE USED'
          PRINT*,'               -h TOLERATED NUMBER OF ERRORS'
          PRINT*,'               DEFAULT - LAST AVAILABLE'
          CALL EXIT(2)
      END IF
 102  CONTINUE
C
      IZ=INDEX(CEDITION,' ')
      IF(IZ.EQ.1) THEN
C
C        THIS IS THE LAST AVAILABLE BUFR EDITION NUMBER
C
         IBED=3
         PRINT*,'DEFAULT EDITION NUMBER                 -->',IBED
      ELSE
         READ(CEDITION,'(I2)') IBED
      END IF
      IZ=INDEX(CVNMTU,' ')
      IF(IZ.EQ.1) THEN
C
C        THIS IS THE LAST AVAILABLE VERSION NUMBER OF MASTER TABLE USED
C
         IVNMTU=13
         PRINT*,'DEFAULT VERSION OF MASTER TABLES USED  -->',IVNMTU
      ELSE
         READ(CVNMTU,'(I2)') IVNMTU
      END IF
C
      IZ=INDEX(CVNLTU,' ')
      IF(IZ.EQ.1) THEN
C   
C        THIS IS THE LAST AVAILABLE VERSION NUMBER OF LOCAL TABLE USED
C
         IVNLTU=1
         PRINT*,'DEFAULT VERSION OF LOCAL TABLES USED   -->',IVNLTU
      ELSE
         READ(CVNLTU,'(I2)') IVNLTU
      END IF
C
      IZ=INDEX(CERROR,' ')
      IF(IZ.EQ.1) THEN
         NERROR=0
      ELSE    
         READ(CERROR,'(I3)') NERROR
      END IF
C
      II=INDEX(CINFILE,' ')
      JJ=INDEX(COUTFILE,' ')
      IF(II.EQ.1.OR.JJ.EQ.1) THEN
          PRINT*,'USAGE -- BUFR_NTM  -I INFILE -O OUTFILE'
          PRINT*,'OTHER OPTIONS:'
          PRINT*,'               -E BUFR EDITION NUMBER'
          PRINT*,'               -F VERSION NUMBER OF MASTER TABLE USED'
          PRINT*,'               -G VERSION NUMBER OF LOCAL TABLE USED'
          PRINT*,'               -h TOLERATED NUMBER OF ERRORS'
          PRINT*,'               DEFAULT - LAST AVAILABLE'
          CALL EXIT(2)
      END IF
      II=II-1
      JJ=JJ-1
      KRQL=0
      NW=0
      NR=0
C
C*          1.2 OPEN FILE CONTAINING BUFR DATA.
C               -------------------------------
 120  CONTINUE
C
      IRET=0 
      CALL PBOPEN(IUNIT,CINFILE(1:II),'R',IRET)
      IF(IRET.EQ.-1) then
         PRINT*,'OPEN FAILED'
         CALL EXIT(2)
      END IF
      IF(IRET.EQ.-2) THEN
         PRINT*,'INVALID FILE NAME'
         CALL EXIT(2)
      END IF
      IF(IRET.EQ.-3) THEN
        PRINT*,'INVALID OPEN MODE SPECIFIED'
        CALL EXIT(2)
      END IF
C
      CALL PBOPEN(IUNIT1,COUTFILE(1:JJ),'W',IRET)
      IF(IRET.EQ.-1) THEN
         PRINT*,'OPEN FAILED ON BUFR.DAT'
         CALL EXIT(2)
      END IF
      IF(IRET.EQ.-2) THEN
         PRINT*,'INVALID FILE NAME'
         CALL EXIT(2)
      END IF
      IF(IRET.EQ.-3) THEN
         PRINT*,'INVALID OPEN MODE SPECIFIED'
         CALL EXIT(2)
      END IF
C
C     ----------------------------------------------------------------- 
C*          2. SET REQUEST FOR EXPANSION.
C              --------------------------
 200  CONTINUE
C
      OPRT=.FALSE.
      ICODE=0
      OENC=.TRUE.
      OCOMP=.FALSE.
      NR=1
C
 201  CONTINUE
C
      OSEC3=.FALSE.
C
C*          2.1 SET REQUEST FOR PARTIAL EXPANSION.
C               ----------------------------------
 210  CONTINUE
C
C     -----------------------------------------------------------------
C*          3.  READ BUFR MESSAGE.
C               ------------------
 300  CONTINUE
C
      IERR=0
      KBUFL=0
C
      IRET=0
      CALL PBBUFR(IUNIT,KBUFF,JBYTE,KBUFL,IRET) 
      IF(IRET.EQ.-1) THEN
          PRINT*,'NUMBER OF ORIGINAL  MESSAGES  ',NREAD
          PRINT*,'NUMBER OF CONVERTED MESSAGES  ',NW
          GO TO 900
      END IF
      IF(IRET.EQ.-2) THEN
         PRINT*,'FILE HANDLING PROBLEM' 
         CALL EXIT(2)
      END IF
      IF(IRET.EQ.-3) THEN
         PRINT*,'ARRAY TOO SMALL FOR PRODUCT'
         CALL EXIT(2)
      END If
C
      NREAD=NREAD+1
      N=N+1
      NBYTES=KBUFL
      KBUFL=KBUFL/NBYTPW+1
      IF(NREAD.LT.NR) GO TO 300
C
C     -----------------------------------------------------------------
C*          4. EXPAND BUFR MESSAGE.
C              --------------------
 400  CONTINUE
C
      KERR=0
      CALL BUS012(KBUFL,KBUFF,KSUP,KSEC0,KSEC1,KSEC2,KERR)
      IF(KERR.NE.0) THEN
         PRINT*,'ERROR IN BUS012: ',KERR
         PRINT*,' BUFR MESSAGE NUMBER ',N,' CORRUPTED.'
         IERROR=IERROR+1
         IF(IERROR.GT.NERROR)  CALL MY_EXIT(2)
         GO TO 300
      END IF
C
C     CHECK IF SUBTYPE NEEDED FOR ANALYSIS
C
      DO IS=1,ISUBEN   
      IF(KSEC1(7).EQ.ISUBTYPES(IS)) GO TO 300
      END DO
C
      IERR=0
      KEL=KELEM
      IF(KSUP(6).GT.1) THEN
         KEL=KVALS/KSUP(6)
         IF(KEL.GT.KELEM) KEL=KELEM
      END IF
C
      CALL BUFREX(KBUFL,KBUFF,KSUP,KSEC0 ,KSEC1,KSEC2 ,
     1            KSEC3 ,KSEC4,KEL,CNAMES,CUNITS,KVALS,
     2            VALUES,CVALS,IERR)
C
      IF(IERR.NE.0)  THEN
         PRINT*,'BUFREX: ERROR ', IERR
         IERROR=IERROR+1
         IF(IERROR.GT.NERROR)  CALL MY_EXIT(2)
         GO TO 300
      END IF
C
C
C*          4.1 PRINT CONTENT OF EXPANDED DATA.
C               -------------------------------
 410  CONTINUE
C
      IF(.NOT.OPRT) GO TO 500
      IF(.NOT.OSEC3) GO TO 450
C
C*          4.2 PRINT SECTION ZERO OF BUFR MESSAGE.
C               -----------------------------------
 420  CONTINUE
C

      CALL BUPRS0(KSEC0)
C
C*          4.3 PRINT SECTION ONE OF BUFR MESSAGE.
C               -----------------------------------
 430  CONTINUE
C
      CALL BUPRS1(KSEC1)
C
C
C*          4.4 PRINT SECTION TWO OF BUFR MESSAGE.
C               -----------------------------------
 440  CONTINUE
C
C              AT ECMWF SECTION 2 CONTAINS RDB KEY.
C              SO UNPACK KEY
C
      CALL BUUKEY(KSEC1,KSEC2,KEY,KSUP,KERR)
C
C              PRINT KEY
C
      CALL BUPRS2(KSUP ,KEY)
C
C*          4.5 PRINT SECTION 3 OF BUFR MESSAGE.
C               -----------------------------------
 450  CONTINUE
C
C               FIRST GET DATA DESCRIPTORS
C

      CALL BUSEL(KTDLEN,KTDLST,KTDEXL,KTDEXP,KERR)
      IF(KERR.NE.0) THEN
       PRINT*,'BUSEL : ERROR ',KERR
       CALL MY_EXIT(2)
      END IF
C
C               PRINT  CONTENT
C
      IF(OSEC3) THEN
         CALL BUPRS3(KSEC3,KTDLEN,KTDLST,KTDEXL,KTDEXP,KEL,CNAMES)
      END IF
C
C*         4.6 PRINT SECTION 4 (DATA).
C              -----------------------
 460  CONTINUE
C
C     -----------------------------------------------------------------
C*          5. COLLECT DATA FOR REPACKING.
C              ---------------------------
 500  CONTINUE
C      
      IF(.NOT.OENC) GO TO 300
C
C               FIRST GET DATA DESCRIPTORS
C
      KERR=0
      CALL BUSEL(KTDLEN,KTDLST,KTDEXL,KTDEXP,KERR)
      IF(KERR.NE.0) THEN
         PRINT*,'BUSEL : ERROR ',KERR
         CALL MY_EXIT(2)
      END IF
C
      KERR=0
      CALL BUUKEY(KSEC1,KSEC2,KEY,KSUP,KERR)
      IF(KERR.NE.0) THEN
         PRINT*,'BUUKEY:ERROR ',KERR
         CALL MY_EXIT(2)
      END IF
C
C     ERS1 DATA ORIGINATING CENTRE IS 97
C
      KSEC1(3)=98
C
C     HIGH RESOLUTION TOVS 120 KM GOT WRONG SUBTYPE
C     AND RDB TYPE
C
      ISUBTYPE=0
      IF(KSEC1(2).EQ.0.AND.KSEC1(6).EQ.3.AND.KSEC1(7).EQ.0) THEN
         KSEC1(3)=98
         KSEC1(7)=51
         KSEC1(6)=3
         KEY(2)=2
         KEY(3)=51
         ISUBTYPE=51
      END IF
C
C     IF HIGH LEVEL STATION CHANGE SUBTYPE TO 5 LOCALLY
C
      IF(KTDLST(1).EQ.307007) THEN
         KSEC17= KSEC1(7)
         KSEC1(7)=5
      END IF
C
C     SOME SHIP CALL SIGNS HAVE ZERO APPEND
C
      IF(KSEC1(7).GE.11.AND.KSEC1(7).LE.14.OR.KSEC1(7).EQ.19.OR.
     1   KSEC1(7).EQ.92.OR.KSEC1(7).EQ.102) THEN
         IF(CVALS(1)(9:9).EQ.'0') THEN
            CSHIP=' '
            CALL CUTZERO(CVALS(1),1)
            DO 505 IC=1,9
            CSHIP(IC:IC)=CHAR(KEY(IC+15))
 505        CONTINUE
            CALL CUTZERO(CSHIP,1)
            DO 506 IC=1,9
            KEY(IC+15)=ICHAR(CSHIP(IC:IC))
 506        CONTINUE 
         END IF
      END IF
C
      IF(KSEC1(7).GE.132.AND.KSEC1(7).LE.133) THEN
          IF(CVALS(1)(9:9).EQ.'0') THEN
             CSHIP=' '
             CALL CUTZERO(CVALS(1),1)
             DO 507 IC=1,9
             CSHIP(IC:IC)=CHAR(KEY(IC+15))
 507         CONTINUE
             CALL CUTZERO(CSHIP,1)
             DO 508 IC=1,9
             KEY(IC+15)=ICHAR(CSHIP(IC:IC))
 508         CONTINUE
          END IF
      END IF
C
      IERR=0
      if(KSEC1(12).eq.24) then
         print*,'Date hour is 24'
      end if
      CALL DATE_TIME_CHECK(KTDEXP,KSEC1,KSEC3,KEY,KEL,VALUES,IERR)
      IF(IERR.NE.0) THEN
         IERR=0
         GO TO 300
      END IF

      KERR=0
C
C            EDITION 0,1 TO >=2
C
      IF(KSEC0(3).LE.1.AND.IBED.GT.1) THEN
         CALL BUCON0(KSEC1(7),KSUP,KTDLEN,KTDLST,
     1              KTDLST1,KTDEXL,KTDEXP,KEL,KVALS,
     2              VALUES,VALUE,KDLEN,KDATA,KERR)
C
C            EDITION 2 TO 2
C
      ELSEIF(KSEC0(3).EQ.2.AND.IBED.EQ.2) THEN
         CALL BUCON3(KSEC1(7),KSUP,KTDLEN,KTDLST,
     1               KTDLST1,KTDEXL,KTDEXP,KEL,KVALS,
     2               VALUES,VALUE,KDLEN,KDATA,KERR)
C
C            EDITION 2 TO 3
C
      ELSEIF(KSEC0(3).EQ.2.AND.IBED.EQ.3) THEN
         CALL BUCON3(KSEC1(7),KSUP,KTDLEN,KTDLST,
     1               KTDLST1,KTDEXL,KTDEXP,KEL,KVALS,
     2               VALUES,VALUE,KDLEN,KDATA,KERR)
C
C            EDITION 3 TO 2
C
      ELSEIF(KSEC0(3).EQ.3.AND.IBED.EQ.2) THEN
         CALL BUCON3(KSEC1(7),KSUP,KTDLEN,KTDLST,
     1               KTDLST1,KTDEXL,KTDEXP,KEL,KVALS,
     2               VALUES,VALUE,KDLEN,KDATA,KERR)
C
C            EDITION 3 TO 3
C
      ELSEIF(KSEC0(3).EQ.3.AND.IBED.EQ.3) THEN
         CALL BUCON3(KSEC1(7),KSUP,KTDLEN,KTDLST,
     1               KTDLST1,KTDEXL,KTDEXP,KEL,KVALS,
     2               VALUES,VALUE,KDLEN,KDATA,KERR)
      ELSE
         PRINT*,'THIS CONVERSION IS NOT SUPPORTED.'
         CALL MY_EXIT(2)
      END IF
C
      IF(KERR.NE.0) THEN
         PRINT*,'BAD CONVERSION FOR SUBTYPE -',KSEC1(7)
         PRINT*,'MESSAGE NUMBER IS ',N
         CALL MY_EXIT(2)
      END IF
C
C     CREATE RDB KEY FOR TOVS 120 km
C
      if(ksec1(7).eq.51) then
         if(isubtype.eq.51) then
           do iii=26,46
           key(iii)=0
           end do
           key(46)=70
         end if
         call BUCRKEY(KEL,KTDEXP,KSUP,KSEC1,KSEC3,KEY,
     1                     VALUE,CVALS,KERR)
      end if
C
C     CHANGE BACK SYNOP HIGH LEVEL STATION SUBTYPE
C
      IF(KSEC1(7).EQ.5) KSEC1(7)=KSEC17
C
C     FIX old drop sondes
C
      if(ksec1(7).eq.103.and.ksec0(3).eq.0) then
         if(key(4).gt.2000) then
            ksec1( 9)=key(4)-2000
         else   
            ksec1( 9)=key(4)-1900.
         end if
         ksec1(10)=key(5)
         ksec1(11)=key(6)
         ksec1(12)=key(7)
         ksec1(13)=key(8)
         value( 6)=key(4)
         value( 7)=key(5)
         value( 8)=key(6)
         value( 9)=key(7)
         value(10)=key(8)
         value(11)=(key(11)-9000000)/100000.
         value(12)=(key(10)-18000000)/100000.
         cvals(1)=char(key(16))//char(key(17))//
     1            char(key(18))//char(key(19))//
     2            char(key(20))//char(key(21))//
     3            char(key(22))//char(key(23))//
     4            char(key(24))
      end if
C
      if(ksec1(7).eq.91) then
c        some pilots got hour diff in the key and sec1 
         key(4)=int(values(5))
         key(5)=int(values(6))
         key(6)=int(values(7))
         key(7)=int(values(8))
         key(8)=int(values(9))
      end if
c
c     Fix oceanographic data 131,132,133
c
      if(ksec1(7).ge.131.and.ksec1(7).le.133) then
c        some section 1 dates are wrong
         if(key(4).gt.2000) then
            ksec1( 9)=key(4)-2000
         else   
            ksec1( 9)=key(4)-1900.
         end if
         ksec1(10)=key(5)
         ksec1(11)=key(6)
         ksec1(12)=key(7)
         ksec1(13)=key(8)

      end if

C
C     -----------------------------------------------------------------
C*          6. PACK BUFR MESSAGE BACK INTO BUFR.
C              ---------------------------------
 600  CONTINUE
C
    
      KKK=0
      KSEC1(2)=IBED
      KSEC1(8)=IVNLTU
      KSEC1(15)=IVNMTU
      KSEC1(3)=98
      if(ksec1(1).gt.18.and.KSEC0(3).le.2) then
         do iii=1,15
          ksec1_temp(iii)=ksec1(iii)
         end do
C
         ksec1_temp(16)=0   ! Originating sub-centre
         ksec1_temp(17)=0
C
C        move for 2 bytes local info
C
         do iii=16,jsec1
         ksec1_temp(iii+2)=ksec1(iii)
         end do
C
         do iii=1,jsec1
         ksec1(iii)=ksec1_temp(iii)
         end do
C
         ksec1(1)=ksec1(1) 
      else
         KSEC1(16)=0
      end if
C
      KSEC0(3)=IBED
C     KSEC3(4)=128            ! NO COMPRESSION
C     IF(KSEC3(3).GT.1) KSEC3(4)=192
C
C*          6.2 ENCODE DATA INTO BUFR MESSAGE.
C               ------------------------------
 620  CONTINUE
C
      KERR=0
      KEY(1)=52
      KSEC1(14)=0
      KSEC2(1)=52
      KERR=0
      CALL BUPKEY(KEY,KSEC1,KSEC2,KERR)
      IF(KERR.NE.0) THEN
        PRINT*,'BUPKEY: ERROR',KERR
        CALL MY_EXIT(2)
      END IF
C
      KERR=0
      KBUFL=JBUFL
      CALL BUFREN( KSEC0,KSEC1,KSEC2,KSEC3,KSEC4,
     1             KTDLEN,KTDLST1,KDLEN,KDATA,KEL,
     2             KVALS,VALUE,CVALS,KBUFL,KBUFR,KERR)
C
      IF(KERR.GT.0) THEN
         PRINT*,'MESSAGE NUMBER ',N
         PRINT*,'BUFR SUBTYPE ',KSEC1(7)
         IERROR=IERROR+1
         IF(IERROR.GT.NERROR) CALL MY_EXIT(2)
         GO TO 300
      END IF
C
C           6.3 WRITE PACKED BUFR MESSAGE INTO FILE.
C               ------------------------------------
 630  CONTINUE
C
      ILEN=KBUFL*NBYTPW
      KBUFL=0
      CALL PBWRITE(IUNIT1,KBUFR,ILEN,IRET)
      IF(IRET.EQ.-1) THEN
         PRINT*,'ERROR DURING WRITE INTO OUTPUT FILE.'
         CALL MY_EXIT(2)
      END IF
      IRET=0
C
      NW=NW+1
C
      GO TO 300
C     -----------------------------------------------------------------
C
C      
 900  CONTINUE
C
      CALL PBCLOSE(IUNIT,IRET)
      CALL PBCLOSE(IUNIT1,IRET)
C
      END
      SUBROUTINE BUCON0(KST,KSUP,KTDLEN,KTDLST,KTDLST1,KTDEXL,KTDEXP,
     1                  KELEM,KVALS,VALUES,VALUE,KDLEN,KDATA,KERR)
C
C**** *BUCON0*
C
C
C     PURPOSE.
C     --------
C         CONVERTS BUFR EDITION 0 TO EDITION 2 DATA.
C         
C
C
C**   INTERFACE.
C     ----------
C
C              *CALL BUCONV(KST,KTDLEN,KTDLST,KTDLST1,KTDEXL,KTDEXP,
C                           KELEM,KVALS,VALUES,VALUE,KERR)*
C
C     METHOD.
C     -------
C
C          NONE.
C
C
C     EXTERNALS.
C     ----------
C
C
C     REFERENCE.
C     ----------
C
C          NONE.
C
C     AUTHOR.
C     -------
C
C          M. DRAGOSAVAC    *ECMWF*       15/09/94
C
C
C     MODIFICATIONS.
C     --------------
C
C          NONE.
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
      DIMENSION KTDLST(*),KTDEXP(*)
      DIMENSION KTDLST1(*),KSUP(*),KDATA(*)
      REAL*8 VALUES(*),VALUE(*)
      REAL*8 RVIND,EPS
C
C     ------------------------------------------------------------------
C*          1. INITIALIZE CONSTANTS AND VARIABLES.
C              -----------------------------------
 100  CONTINUE
C
C     MISSING VALUE INDICATOR
C
      RVIND=1.7D38
      EPS=10.D-8
C
      IF(KST.EQ.1.OR.KST.EQ.3.OR.KST.EQ.5) THEN
C
C        SYNOP LAND SUBTYPES 1 AND 3 AND 5 HIGH LEVEL STATION
C
C
C        CHANGE OPERATOR
C
         J=0
C
         DO 101 I=1,KTDLEN
C
         IF(KTDLST(I).GT.262000.AND.KTDLST(I).LT.300000) THEN
            J=J+1
            KTDLST1(J)=222000
         ELSEIF(KTDLST(I).EQ.262000) THEN
               GO TO 101
         ELSEIF(KTDLST(I).GT.101000.AND.KTDLST(I).LE.101049) THEN
            J=J+1
            IF(KST.LE.3) KTDLST1(J)=101049
            IF(KST.EQ.5) KTDLST1(J)=101033
         ELSEIF(KTDLST(I).EQ.063191) THEN
            J=J+1
            KTDLST1(J)=001201
         ELSEIF(KTDLST(I).EQ.063192) THEN
            J=J+1
            KTDLST1(J)=033007
         ELSEIF(KTDLST(I).EQ.031192) THEN
            J=J+1
            KTDLST1(J)=031031
            J=J+1
            KTDLST1(J)=001031
         ELSE
            J=J+1
            KTDLST1(J)=KTDLST(I)
         END IF
C
 101     CONTINUE
C
         KTDLEN=J
C
C        FIND FIRST AND LAST POINTER TO DATA PRESENT INDICATOR
C
         ODPF=.FALSE.
C
         DO 102 I=1,KTDEXL
         IF(KTDEXP(I).EQ.31192) THEN
            IF(.NOT.ODPF) IDPF=I
            ODPF=.TRUE.
         ELSE
            IF(ODPF) THEN
               IDPL=I-1
               GO TO 103
            END IF
         END IF
 102     CONTINUE
C
 103     CONTINUE
C
C        FIND START OF % CONFIDENCE
C
         DO 104 I=IDPL,KTDEXL
         IF(KTDEXP(I).EQ.63192) THEN
            IPCF=I
            GO TO 105
         END IF
 104     CONTINUE
C
 105     CONTINUE
C
C        MAKE DATA SUITABLE FOR COMPRESSION
C
         J=0
         KDLEN=0
         IPC=IPCF-1
C
         DO 106 I=1,KTDEXL
         J=J+1
         IF(KTDEXP(I).EQ.031001.OR.KTDEXP(I).EQ.031002) THEN
            KDLEN=KDLEN+1
            KDATA(KDLEN)=NINT(VALUES(I))
            GO TO 106
         END IF
C
         IF(KTDEXP(I).EQ.063191) THEN    ! GENERATING APPLICATION
            VALUE(J)=98.                 ! GENERATING CENTRE
            J=J+1
            VALUE(J)=1.
            GO TO 106
         END IF
C
         IF(KTDEXP(I).EQ.031192) THEN
            VALUE(J)=0.    ! DATA PRESENT
            GO TO 106
         END IF
C
         IF(KTDEXP(I).EQ.063192) THEN            ! % CONF
            DO 107 K=IDPF,IDPL
            IF(VALUES(K).GT.0.) THEN
               VALUE(J)=RVIND
               J=J+1
            ELSE
               IPC=IPC+1
               VALUE(J)=VALUES(IPC)
               J=J+1
            END IF
 107        CONTINUE
            GO TO 110
         END IF
C
         IF(KTDEXP(I).GE.13019.AND.KTDEXP(I).LE.13023) THEN
            IF(ABS(VALUES(I)-RVIND)/RVIND.LT.EPS) THEN
               VALUE(J)=VALUES(I)
            ELSE
               VALUE(J)=VALUES(I)*1000.
            END IF
         ELSE
            VALUE(J)=VALUES(I)
         END IF
C
 106     CONTINUE
C
 110     CONTINUE
C
         KERR=0
         RETURN
      END IF
C
      IF(KST.EQ.2.OR.KST.EQ.4) THEN
C
C        SYNOP LAND SECOND RECORD 2,4
C
C        CHANGE OPERATOR
C
         J=0
C
         DO 901 I=1,KTDLEN
C
         IF(KTDLST(I).GT.262000.AND.KTDLST(I).LT.300000) THEN
            J=J+1
            KTDLST1(J)=222000
         ELSEIF(KTDLST(I).EQ.262000) THEN
               GO TO 901
         ELSEIF(KTDLST(I).GT.101000.AND.KTDLST(I).LE.101022) THEN
            J=J+1
            IF(KST.EQ.2) KTDLST1(J)=101022
            IF(KST.EQ.4) KTDLST1(J)=101022
         ELSEIF(KTDLST(I).EQ.063191) THEN
            J=J+1
            KTDLST1(J)=001201
         ELSEIF(KTDLST(I).EQ.063192) THEN
            J=J+1
            KTDLST1(J)=033007
         ELSEIF(KTDLST(I).EQ.031192) THEN
            J=J+1
            KTDLST1(J)=031031
            J=J+1
            KTDLST1(J)=001031
         ELSEIF(KTDLST(I).EQ.14011) THEN
            J=J+1
            KTDLST1(J)=14015
         ELSEIF(KTDLST(I).EQ.14032) THEN
            J=J+1
            KTDLST1(J)=14031
         ELSEIF(KTDLST(I).EQ.20063) THEN
            J=J+1
            KTDLST1(J)=20192
         ELSE
            J=J+1
            KTDLST1(J)=KTDLST(I)
         END IF
C
 901     CONTINUE
C
         KTDLEN=J
C
C        FIND FIRST AND LAST POINTER TO DATA PRESENT INDICATOR
C
         ODPF=.FALSE.
C
         DO 902 I=1,KTDEXL
         IF(KTDEXP(I).EQ.31192) THEN
            IF(.NOT.ODPF) IDPF=I
            ODPF=.TRUE.
         ELSE
            IF(ODPF) THEN
               IDPL=I-1
               GO TO 903
            END IF
         END IF
 902     CONTINUE
C
 903     CONTINUE
C
C        FIND START OF % CONFIDENCE
C
         DO 904 I=IDPL,KTDEXL
         IF(KTDEXP(I).EQ.63192) THEN
            IPCF=I
            GO TO 905
         END IF
 904     CONTINUE
C
 905     CONTINUE
C
C        MAKE DATA SUITABLE FOR COMPRESSION
C
         J=0
         KDLEN=0
         IPC=IPCF-1
C
         DO 906 I=1,KTDEXL
         J=J+1
         IF(KTDEXP(I).EQ.031001.OR.KTDEXP(I).EQ.031002) THEN
            KDLEN=KDLEN+1
            KDATA(KDLEN)=NINT(VALUES(I))
         END IF
C
         IF(KTDEXP(I).EQ.063191) THEN    ! GENERATING APPLICATION
            VALUE(J)=98.                 ! GENERATING CENTRE
            J=J+1
            VALUE(J)=1.
            GO TO 906
         END IF
C
         IF(KTDEXP(I).EQ.031192) THEN
            VALUE(J)=0.    ! DATA PRESENT
            GO TO 906
         END IF
C
         IF(KTDEXP(I).EQ.063192) THEN            ! % CONF
            DO 907 K=IDPF,IDPL
            IF(VALUES(K).GT.0.) THEN
               VALUE(J)=RVIND
               J=J+1
            ELSE
               IPC=IPC+1
               VALUE(J)=VALUES(IPC)
               J=J+1
            END IF
 907        CONTINUE
            GO TO 910
         END IF
C
         IF(KTDEXP(I).GE.13019.AND.KTDEXP(I).LE.13023) THEN
            IF(ABS(VALUES(I)-RVIND)/RVIND.LT.EPS) THEN
               VALUE(J)=VALUES(I)
            ELSE
               VALUE(J)=VALUES(I)*1000.
            END IF
         ELSE
            VALUE(J)=VALUES(I)
         END IF
C
 906     CONTINUE
C
 910     CONTINUE
C
         KERR=0
         RETURN
      END IF
C
      IF(KST.EQ.09.OR.KST.EQ.11.OR.
     1   KST.EQ.13.OR.KST.EQ.19) THEN
C
C        SYNOP SHIP 9,11,13,19
C        ---------------------
C
C        CHANGE OPERATOR
C
         J=0
C
         DO 201 I=1,KTDLEN
C
         IF(KTDLST(I).GT.262000.AND.KTDLST(I).LT.300000) THEN
            J=J+1
            KTDLST1(J)=222000
         ELSEIF(KTDLST(I).EQ.262000) THEN
               GO TO 201
         ELSEIF(KTDLST(I).GT.101000.AND.KTDLST(I).LT.101033) THEN
            J=J+1
            KTDLST1(J)=101033
         ELSEIF(KTDLST(I).EQ.063191) THEN
            J=J+1
            KTDLST1(J)=001201
         ELSEIF(KTDLST(I).EQ.063192) THEN
            J=J+1
            KTDLST1(J)=033007
         ELSEIF(KTDLST(I).EQ.031192) THEN
            J=J+1
            KTDLST1(J)=031031
            J=J+1
            KTDLST1(J)=001031
         ELSE
            J=J+1
            IF(KTDLST(I).EQ.308004) THEN
               KTDLST1(J)=KTDLST(I)
               J=J+1
               KTDLST1(J)=12005
            ELSE
               KTDLST1(J)=KTDLST(I)
            END IF
         END IF
C
 201     CONTINUE
C
         KTDLEN=J
C
C
C        FIND FIRST AND LAST POINTER TO DATA PRESENT INDICATOR
C
         ODPF=.FALSE.
C
         DO 202 I=1,KTDEXL
         IF(KTDEXP(I).EQ.31192) THEN
            IF(.NOT.ODPF) IDPF=I
            ODPF=.TRUE.
         ELSE
            IF(ODPF) THEN
               IDPL=I-1
               GO TO 203
            END IF
         END IF
 202     CONTINUE
C
 203     CONTINUE
C
C        FIND START OF % CONFIDENCE
C
         DO 204 I=IDPL,KTDEXL
         IF(KTDEXP(I).EQ.63192) THEN
            IPCF=I
            GO TO 205
         END IF
 204     CONTINUE
C
 205     CONTINUE
C
C        MAKE DATA SUITABLE FOR COMPRESSION
C
         J=0
         KDLEN=0
         IPC=IPCF-1
C
         DO 206 I=1,KTDEXL
         J=J+1
         IF(KTDEXP(I).EQ.031001.OR.KTDEXP(I).EQ.031002) THEN
            KDLEN=KDLEN+1
            KDATA(KDLEN)=NINT(VALUES(I))
         END IF
C
         IF(KTDEXP(I).EQ.063191) THEN    ! GENERATING APPLICATION
            VALUE(J)=0.                  ! ONE MORE DATA PRESENT INDICATOR
            J=J+1 
            VALUE(J)=98.                 ! GENERATING CENTRE
            J=J+1
            VALUE(J)=1.
            GO TO 206
         END IF
C
         IF(KTDEXP(I).EQ.031192) THEN
            VALUE(J)=0.    ! DATA PRESENT
            GO TO 206
         END IF
C
         IF(KTDEXP(I).EQ.063192) THEN            ! % CONF
            DO 207 K=IDPF,IDPL
            IF(VALUES(K).GT.0.) THEN
               VALUE(J)=RVIND
               J=J+1
            ELSE
               IPC=IPC+1
               VALUE(J)=VALUES(IPC)
               J=J+1
            END IF
 207        CONTINUE
            VALUE(J)=RVIND
            GO TO 210
         END IF
C
         IF(KTDEXP(I).EQ.022042) THEN
            VALUE(J)=VALUES(I)
C
C           ADD 012005 DEW POINT TEMPERATURE AT 2M
C
            J=J+1
            VALUE(J)=RVIND
         ELSE
            VALUE(J)=VALUES(I)
         END IF
C
 206     CONTINUE
C
 210     CONTINUE
C
         KERR=0
         RETURN
      END IF
      IF(KST.EQ.12.OR.KST.EQ.14) THEN
C
C         SYNOP SHIP SECOND RECORD
C
C        CHANGE OPERATOR
C
         J=0
C
         DO 701 I=1,KTDLEN
C
         IF(KTDLST(I).GT.262000.AND.KTDLST(I).LT.300000) THEN
            J=J+1
            KTDLST1(J)=222000
         ELSEIF(KTDLST(I).EQ.262000) THEN
               GO TO 701
         ELSEIF(KTDLST(I).GT.101000.AND.KTDLST(I).LE.101039) THEN
            J=J+1
            IF(KST.EQ.12) KTDLST1(J)=101039
            IF(KST.EQ.14) KTDLST1(J)=101039
         ELSEIF(KTDLST(I).EQ.063191) THEN
            J=J+1
            KTDLST1(J)=001201
         ELSEIF(KTDLST(I).EQ.063192) THEN
            J=J+1
            KTDLST1(J)=033007
         ELSEIF(KTDLST(I).EQ.031192) THEN
            J=J+1
            KTDLST1(J)=031031
            J=J+1
            KTDLST1(J)=001031
         ELSEIF(KTDLST(I).EQ.13031) THEN
            J=J+1
            KTDLST1(J)=22001
            J=J+1
            KTDLST1(J)=22011
            J=J+1
            KTDLST1(J)=22021
            J=J+1
            KTDLST1(J)=13031
         ELSEIF(KTDLST(I).EQ.14011) THEN
            J=J+1
            KTDLST1(J)=14015
         ELSEIF(KTDLST(I).EQ.14032) THEN
            J=J+1
            KTDLST1(J)=14031
         ELSEIF(KTDLST(I).EQ.20063) THEN
            J=J+1
            KTDLST1(J)=20192
         ELSE
            J=J+1
            KTDLST1(J)=KTDLST(I)
         END IF
C
 701     CONTINUE
C
         KTDLEN=J
C
C        FIND FIRST AND LAST POINTER TO DATA PRESENT INDICATOR
C
         ODPF=.FALSE.
C
         DO 702 I=1,KTDEXL
         IF(KTDEXP(I).EQ.31192) THEN
            IF(.NOT.ODPF) IDPF=I
            ODPF=.TRUE.
         ELSE
            IF(ODPF) THEN
               IDPL=I-1
               GO TO 703
            END IF
         END IF
 702     CONTINUE
C
 703     CONTINUE
C
C        FIND START OF % CONFIDENCE
C
         DO 704 I=IDPL,KTDEXL
         IF(KTDEXP(I).EQ.63192) THEN
            IPCF=I
            GO TO 705
         END IF
 704     CONTINUE
C
 705     CONTINUE
C
C        MAKE DATA SUITABLE FOR COMPRESSION
C
         J=0
         KDLEN=0
         ISTAT=0
         IPC=IPCF-1
C
         DO 706 I=1,KTDEXL
         J=J+1
         IF(KTDEXP(I).EQ.031001.OR.KTDEXP(I).EQ.031002) THEN
            KDLEN=KDLEN+1
            KDATA(KDLEN)=NINT(VALUES(I))
         END IF
C
         IF(KTDEXP(I).EQ.063191) THEN    ! GENERATING APPLICATION
            VALUE(J)=98.                 ! GENERATING CENTRE
            J=J+1
            VALUE(J)=1.
            GO TO 706
         END IF
C
         IF(KTDEXP(I).EQ.031192) THEN
            ISTAT=ISTAT+1
            IF(ISTAT.EQ.23) THEN
               VALUE(J)=0.
               J=J+1
               VALUE(J)=0.
               J=J+1
               VALUE(J)=0.
               J=J+1
               VALUE(J)=0.
               GO TO 706
            END IF
            VALUE(J)=0.    ! DATA PRESENT
            GO TO 706
         END IF
C
         IF(KTDEXP(I).EQ.063192) THEN            ! % CONF
            IC=0
            DO 707 K=IDPF,IDPL
            IC=IC+1
            IF(IC.EQ.23) THEN
               IF(VALUES(K).GT.0.) THEN
                  VALUE(J)=RVIND
                  J=J+1
                  VALUE(J)=RVIND
                  J=J+1
                  VALUE(J)=RVIND
                  J=J+1
                  VALUE(J)=RVIND
                  J=J+1
                  GO TO 707
               ELSE
                  IPC=IPC+1
                  VALUE(J)=VALUES(IPC)
                  J=J+1
                  VALUE(J)=RVIND
                  J=J+1
                  VALUE(J)=RVIND
                  J=J+1
                  VALUE(J)=RVIND
                  J=J+1
                  GO TO 707
               END IF
            END IF
            IF(VALUES(K).GT.0.) THEN
               VALUE(J)=RVIND
               J=J+1
            ELSE
               IPC=IPC+1
               VALUE(J)=VALUES(IPC)
               J=J+1
            END IF
 707        CONTINUE
            GO TO 710
         END IF
C
         IF(KTDEXP(I).EQ.13031) THEN
            VALUE(J)=RVIND
            J=J+1
            VALUE(J)=RVIND
            J=J+1
            VALUE(J)=RVIND
            J=J+1
            VALUE(J)=VALUES(I)
            GO TO 706
         END IF
C
         IF(KTDEXP(I).GE.22021.AND.KTDEXP(I).LE.22023) THEN
            IF(ABS(VALUES(I)-RVIND)/RVIND.LT.EPS) THEN
               VALUE(J)=VALUES(I)
            ELSE
               VALUE(J)=VALUES(I)/10.
            END IF
            GO TO 706
         END IF
C
         IF(KTDEXP(I).GE.13019.AND.KTDEXP(I).LE.13023) THEN
            IF(ABS(VALUES(I)-RVIND)/RVIND.LT.EPS) THEN
               VALUE(J)=VALUES(I)
            ELSE
               VALUE(J)=VALUES(I)*1000.
            END IF
         ELSE
            VALUE(J)=VALUES(I)
         END IF
C
 706     CONTINUE
C
 710     CONTINUE
C
         KERR=0
         RETURN
      END IF
C
      IF(KST.GE.21.AND.KST.LE.23) THEN
C
C        DRIBU BATHY TESA 21,22,23
C        -------------------------
C
C        CHANGE OPERATOR
C
         J=0
C
         DO 301 I=1,KTDLEN
C
         IF(KTDLST(I).GT.262000.AND.KTDLST(I).LT.300000) THEN
            J=J+1
            KTDLST1(J)=222000
         ELSEIF(KTDLST(I).EQ.262000) THEN
               GO TO 301
         ELSEIF(KTDLST(I).GT.101000.AND.KTDLST(I).LT.101032) THEN
            J=J+1
            KTDLST1(J)=101032
         ELSEIF(KTDLST(I).EQ.063191) THEN
            J=J+1
            KTDLST1(J)=001201
         ELSEIF(KTDLST(I).EQ.063192) THEN
            J=J+1
            KTDLST1(J)=033007
         ELSEIF(KTDLST(I).EQ.031192) THEN
            J=J+1
            KTDLST1(J)=031031
            J=J+1
            KTDLST1(J)=001031
         ELSE
            J=J+1
            KTDLST1(J)=KTDLST(I)
         END IF
C
 301     CONTINUE
C
         KTDLEN=J
C
C        FIND FIRST AND LAST POINTER TO DATA PRESENT INDICATOR
C
         ODPF=.FALSE.
C
         DO 302 I=1,KTDEXL
         IF(KTDEXP(I).EQ.31192) THEN
            IF(.NOT.ODPF) IDPF=I
            ODPF=.TRUE.
         ELSE
            IF(ODPF) THEN
               IDPL=I-1
               GO TO 303
            END IF
         END IF
 302     CONTINUE
C
 303     CONTINUE
C
C        FIND START OF % CONFIDENCE
C
         DO 304 I=IDPL,KTDEXL
         IF(KTDEXP(I).EQ.63192) THEN
            IPCF=I
            GO TO 305
         END IF
 304     CONTINUE
C
 305     CONTINUE
C
C        MAKE DATA SUITABLE FOR COMPRESSION
C
         J=0
         KDLEN=0
         IPC=IPCF-1
C
         DO 306 I=1,KTDEXL
         J=J+1
         IF(KTDEXP(I).EQ.031001.OR.KTDEXP(I).EQ.031002) THEN
            KDLEN=KDLEN+1
            KDATA(KDLEN)=NINT(VALUES(I))
         END IF
C
         IF(KTDEXP(I).EQ.063191) THEN    ! GENERATING APPLICATION
            VALUE(J)=98.                 ! GENERATING CENTRE
            J=J+1
            VALUE(J)=1.
            GO TO 306
         END IF
C
         IF(KTDEXP(I).EQ.031192) THEN
            VALUE(J)=0.    ! DATA PRESENT
            GO TO 306
         END IF
C
         IF(KTDEXP(I).EQ.063192) THEN            ! % CONF
            DO 307 K=IDPF,IDPL
            IF(VALUES(K).GT.0.) THEN
               VALUE(J)=RVIND
               J=J+1
            ELSE
               IPC=IPC+1
               VALUE(J)=VALUES(IPC)
               J=J+1
            END IF
 307        CONTINUE
            GO TO 310
         END IF
C
         VALUE(J)=VALUES(I)
C
 306     CONTINUE
C
 310     CONTINUE
C
         KERR=0
         RETURN
      END IF
      IF(KST.EQ.51.OR.KST.EQ.52) THEN
C
C        MOVE FIRST 12 ELEMENTS
C
         DO 854 J=1,12
         DO 851 I=1,KSUP(6)
         IJ=J+(I-1)*KELEM
         VALUE(IJ)=VALUES(IJ)
 851     CONTINUE
 854     CONTINUE
C
C        INSERT SATELLITE LOCATION COUNTER
C
         DO 856 I=1,KSUP(6)
         IJ=13+(I-1)*KELEM
         VALUE(IJ)=RVIND
 856     CONTINUE
C
C        MOVE THE REST OF THE DATA
C
         JJ=13
         DO 858 J=13,KSUP(5)
         JJ=JJ+1
         DO 857 I=1,KSUP(6)
         IJ=J+(I-1)*KELEM
         IZ=JJ+(I-1)*KELEM
         VALUE(IZ)=VALUES(IJ)
 857     CONTINUE
 858     CONTINUE
C
         DO 853 I=1,12
         KTDLST1(I)=KTDLST(I)
 853     CONTINUE
         KTDLST1(13)=027020
         J=13
         DO 852 I=13,KTDLEN
         J=J+1
         KTDLST1(J)=KTDLST(I)
         IF(J.EQ.21) KTDLST1(J)=010001
         IF(J.GT.24.AND.J.LT.42) THEN
            IF(KTDLST1(J).EQ.010004) KTDLST1(J)=007004
         END IF
 852     CONTINUE
         KTDLEN=KTDLEN+1
         KERR=0
         RETURN
      END IF
C
      IF(KST.GE.61.AND.KST.LE.63.OR.
     1   KST.GE.71.AND.KST.LE.73.OR.
     2   KST.GE.82.AND.KST.LE.85 ) THEN
C
C        SATEM 500 KM 61,62,63 AND TOVS 250 KM. 71,72,73
C        ------------------------------------------------
C        CHANGE OPERATOR
C
         J=0
C
         DO 501 I=1,KTDLEN
C
         IF(KTDLST(I).GT.262000.AND.KTDLST(I).LT.300000) THEN
            J=J+1
            KTDLST1(J)=222000
         ELSEIF(KTDLST(I).EQ.262000) THEN
               GO TO 501
         ELSEIF(KTDLST(I).GT.101000.AND.KTDLST(I).LT.101063) THEN
            J=J+1
            IF(KST.EQ.61) KTDLST1(J)=101063
            IF(KST.EQ.62) KTDLST1(J)=101033
            IF(KST.EQ.63) KTDLST1(J)=101048
            IF(KST.EQ.71) KTDLST1(J)=101063
            IF(KST.EQ.72) KTDLST1(J)=101033
            IF(KST.EQ.73) KTDLST1(J)=101048
            IF(KST.EQ.82) KTDLST1(J)=101015
            IF(KST.EQ.83) KTDLST1(J)=101014
            IF(KST.EQ.84) KTDLST1(J)=101012
            IF(KST.EQ.85) KTDLST1(J)=101014
         ELSEIF(KTDLST(I).EQ.063191) THEN
            J=J+1
            KTDLST1(J)=001201
         ELSEIF(KTDLST(I).EQ.063192) THEN
            J=J+1
            KTDLST1(J)=033007
         ELSEIF(KTDLST(I).EQ.031192) THEN
            J=J+1
            KTDLST1(J)=031031
            J=J+1
            KTDLST1(J)=001031
         ELSE
            J=J+1
            KTDLST1(J)=KTDLST(I)
         END IF
C
 501     CONTINUE
C
         KTDLEN=J
C
C        FIND FIRST AND LAST POINTER TO DATA PRESENT INDICATOR
C
         ODPF=.FALSE.
C
         DO 502 I=1,KTDEXL
         IF(KTDEXP(I).EQ.31192) THEN
            IF(.NOT.ODPF) IDPF=I
            ODPF=.TRUE.
         ELSE
            IF(ODPF) THEN
               IDPL=I-1
               GO TO 503
            END IF
         END IF
 502     CONTINUE
C
 503     CONTINUE
C
C        FIND START OF % CONFIDENCE
C
         DO 504 I=IDPL,KTDEXL
         IF(KTDEXP(I).EQ.63192) THEN
            IPCF=I
            GO TO 505
         END IF
 504     CONTINUE
C
 505     CONTINUE
C
C        MAKE DATA SUITABLE FOR COMPRESSION
C
         J=0
         KDLEN=0
         IPC=IPCF-1
C
         DO 506 I=1,KTDEXL
         J=J+1
         IF(KTDEXP(I).EQ.031001.OR.KTDEXP(I).EQ.031002) THEN
            KDLEN=KDLEN+1
            KDATA(KDLEN)=NINT(VALUES(I))
         END IF
C
         IF(KTDEXP(I).EQ.063191) THEN    ! GENERATING APPLICATION
            DO 5061 I5061=1,KSUP(6)
            IV=J+(I5061-1)*KELEM
 5061       VALUE(IV)=98.                 ! GENERATING CENTRE
            J=J+1
            DO 5062 I5062=1,KSUP(6)
            IV=J+(I5062-1)*KELEM
 5062       VALUE(IV)=1.
            GO TO 506
         END IF
C
         IF(KTDEXP(I).EQ.031192) THEN
            DO 5063 I5063=1,KSUP(6)
            IV=J+(I5063-1)*KELEM
 5063       VALUE(IV)=0.                         ! DATA PRESENT
            GO TO 506
         END IF
C
         IF(KTDEXP(I).EQ.063192) THEN            ! % CONF
            DO 507 K=IDPF,IDPL
            IF(VALUES(K).GT.0.) THEN
               IPC=IPC+1
               DO 5071 I5071=1,KSUP(6)
               IV=J+(I5071-1)*KELEM
               VALUE(IV)=RVIND
 5071          CONTINUE
               J=J+1
            ELSE
               IPC=IPC+1
               DO 5072 I5072=1,KSUP(6)
               IPP=IPC+(I5072-1)*KELEM
               IV =J  +(I5072-1)*KELEM
               VALUE(IV)=VALUES(IPP)
 5072          CONTINUE
               J=J+1
            END IF
 507        CONTINUE
            GO TO 510
         END IF
C
         IF(KTDEXP(I).EQ.13016) THEN
C
C           CHANGE UNITS FOR PRECIPITABLE WATER
C
            DO 5081 I5081=1,KSUP(6)
            IN=I+(I5081-1)*KELEM
            IV=J+(I5081-1)*KELEM
            IF(ABS(VALUES(IN)-RVIND)/RVIND.LT.EPS) THEN
               VALUE(IV)=RVIND
            ELSE
               VALUE(IV)=VALUES(IN)*1000.
            END IF
 5081       CONTINUE
         ELSE
            DO 5082 I5082=1,KSUP(6)
            IN=I+(I5082-1)*KELEM
            IV=J+(I5082-1)*KELEM
 5082       VALUE(IV)=VALUES(IN)
         END IF
C
 506     CONTINUE
C
 510     CONTINUE
C
         KERR=0
         RETURN
      END IF
      IF(KST.EQ.101.OR.KST.eq.91.OR.
     1   KST.GE.131.AND.KST.LE.133) THEN
C
C         TEMP LAND STATIONS AND PILOT 91,92
C         ----------------------------------
         J=0
C
         DO 601 I=1,KTDLEN
C
         IF(KTDLST(I).GT.262000.AND.KTDLST(I).LT.300000) THEN
            J=J+1
            KTDLST1(J)=222000
         ELSEIF(KTDLST(I).EQ.262000) THEN
               GO TO 601
         ELSEIF(KTDLST(I).EQ.063191) THEN
            J=J+1
            KTDLST1(J)=001201
         ELSEIF(KTDLST(I).EQ.063192) THEN
            J=J+1
            KTDLST1(J)=033007
         ELSEIF(KTDLST(I).EQ.031192) THEN
            J=J+1
            KTDLST1(J)=031031
            J=J+1
            KTDLST1(J)=001031
         ELSE
            J=J+1
            KTDLST1(J)=KTDLST(I)
         END IF
C
 601     CONTINUE
C
         KTDLEN=J
C
C        FIND FIRST AND LAST POINTER TO DATA PRESENT INDICATOR
C
         ODPF=.FALSE.
C
         DO 602 I=1,KTDEXL
         IF(KTDEXP(I).EQ.31192) THEN
            IF(.NOT.ODPF) IDPF=I
            ODPF=.TRUE.
         ELSE
            IF(ODPF) THEN
               IDPL=I-1
               GO TO 603
            END IF
         END IF
 602     CONTINUE
C
 603     CONTINUE
C
C        FIND START OF % CONFIDENCE
C
         DO 604 I=IDPL,KTDEXL
         IF(KTDEXP(I).EQ.63192) THEN
            IPCF=I
            GO TO 605
         END IF
 604     CONTINUE
C
 605     CONTINUE
C
C        MAKE DATA SUITABLE FOR COMPRESSION
C
         J=0
         KDLEN=0
         IPC=IPCF-1
C
         DO 606 I=1,KTDEXL
         J=J+1
         IF(KTDEXP(I).EQ.031001.OR.KTDEXP(I).EQ.031002) THEN
            KDLEN=KDLEN+1
            KDATA(KDLEN)=NINT(VALUES(I))
         END IF
C
         IF(KTDEXP(I).EQ.063191) THEN    ! GENERATING APPLICATION
            VALUE(J)=98.                 ! GENERATING CENTRE
            J=J+1
            VALUE(J)=1.
            GO TO 606
         END IF
C
         IF(KTDEXP(I).EQ.031192) THEN
            VALUE(J)=VALUES(I)             !0.    ! DATA PRESENT
            GO TO 606
         END IF
C
         IF(KTDEXP(I).EQ.063192) THEN            ! % CONF
            VALUE(J)=VALUES(I)
            GO TO 606
         END IF
C
         IF(KTDEXP(I).EQ.10003.OR.KTDEXP(I).EQ.10008) THEN
            IF(ABS(VALUES(I)-RVIND)/RVIND.GT.EPS) THEN
               VALUE(J)=(VALUES(I)/9.8)*9.80665
            ELSE
               VALUE(J)=VALUES(I)
            END IF
         ELSE
            VALUE(J)=VALUES(I)
         END IF
C
 606     CONTINUE
C
 610     CONTINUE
C
         KERR=0
         RETURN
      END IF
      IF(KST.EQ.102.or.kst.eq.92) THEN
C
C        TEMP SHIP 102
C        -------------
         J=0
         OSHEAR=.FALSE.
C
         DO 801 I=1,KTDLEN
C
         IF(KTDLST(I).GT.262000.AND.KTDLST(I).LT.300000) THEN
            J=J+1
            KTDLST1(J)=222000
         ELSEIF(KTDLST(I).EQ.262000) THEN
               GO TO 801
         ELSEIF(KTDLST(I).EQ.063191) THEN
            J=J+1
            KTDLST1(J)=001201
         ELSEIF(KTDLST(I).EQ.063192) THEN
            J=J+1
            KTDLST1(J)=033007
         ELSEIF(KTDLST(I).EQ.031192) THEN
            J=J+1
            KTDLST1(J)=031031
            J=J+1
            KTDLST1(J)=001031
         ELSEIF(KTDLST(I).EQ.309014) THEN
            J=J+1
            KTDLST1(J)=309196
         ELSEIF(KTDLST(I).EQ.301023) THEN
            J=J+1
            KTDLST1(J)=301024
         ELSE
            J=J+1
            KTDLST1(J)=KTDLST(I)
            IF(KTDLST(I).EQ.11061.OR.KTDLST(I).EQ.11062) OSHEAR=.TRUE.
         END IF
C
 801     CONTINUE
C
         KTDLEN=J
C
C        FIND FIRST AND LAST POINTER TO DATA PRESENT INDICATOR
C
         ODPF=.FALSE.
C
         DO 802 I=1,KTDEXL
         IF(KTDEXP(I).EQ.31192) THEN
            IF(.NOT.ODPF) IDPF=I
            ODPF=.TRUE.
         ELSE
            IF(ODPF) THEN
               IDPL=I-1
               GO TO 803
            END IF
         END IF
 802     CONTINUE
C
 803     CONTINUE
C
C        FIND START OF % CONFIDENCE
C
         DO 804 I=IDPL,KTDEXL
         IF(KTDEXP(I).EQ.63192) THEN
            IPCF=I
            GO TO 805
         END IF
 804     CONTINUE
C
 805     CONTINUE
C
C        MAKE DATA SUITABLE FOR COMPRESSION
C
         J=0
         KDLEN=0
         ISTAT=0
         IPC=IPCF-1
C
         DO 806 I=1,KTDEXL
         J=J+1
         IF(KTDEXP(I).EQ.031001.OR.KTDEXP(I).EQ.031002) THEN
            KDLEN=KDLEN+1
            KDATA(KDLEN)=NINT(VALUES(I))
            IF(KDLEN.EQ.2.AND..NOT.OSHEAR) THEN
               KDATA(KDLEN)=NINT(VALUES(I))+1
            END IF
            IF(KDLEN.EQ.3.AND.OSHEAR) THEN
               KDATA(KDLEN)=NINT(VALUES(I))+1
            END IF
         END IF
C
         IF(KTDEXP(I).EQ.063191) THEN    ! GENERATING APPLICATION
            VALUE(J)=98.                 ! GENERATING CENTRE
            J=J+1
            VALUE(J)=1.
            GO TO 806
         END IF
C
         IF(KTDEXP(I).EQ.031192) THEN
            ISTAT=ISTAT+1
            IF(ISTAT.EQ.12) THEN
               VALUE(J)=VALUES(I)
               J=J+1
               VALUE(J)=1.
               VALUE(IDPF)=VALUES(IDPF-1)+1
            ELSE
               VALUE(J)=VALUES(I)
            END IF
            GO TO 806
         END IF
C
         IF(KTDEXP(I).EQ.063192) THEN            ! % CONF
            VALUE(J)=VALUES(I)
            GO TO 806
         END IF
C
         IF(KTDEXP(I).EQ.006002) THEN
            VALUE(J)=VALUES(I)
            J=J+1
            VALUE(J)=RVIND                    ! INSERT STATION HEIGHT
            GO TO 806
         END IF
C
         IF(KTDEXP(I).EQ.10003.OR.KTDEXP(I).EQ.10008) THEN
            IF(ABS(VALUES(I)-RVIND)/RVIND.GT.EPS) THEN
               VALUE(J)=(VALUES(I)/9.8)*9.80665
            ELSE
               VALUE(J)=VALUES(I)
            END IF
         ELSE
            VALUE(J)=VALUES(I)
         END IF
C
 806     CONTINUE
C
 810     CONTINUE
C
         KERR=0
         RETURN
      END IF
C
      IF(KST.EQ.103) THEN
C
C        TEMP DROP 103
C        -------------
         J=0
C
         DO 8013 I=1,KTDLEN
C
         IF(KTDLST(I).GT.262000.AND.KTDLST(I).LT.300000) THEN
            J=J+1
            KTDLST1(J)=222000
         ELSEIF(KTDLST(I).EQ.262000) THEN
               GO TO 8013
         ELSEIF(KTDLST(I).EQ.063191) THEN
            J=J+1
            KTDLST1(J)=001032
         ELSEIF(KTDLST(I).EQ.063192) THEN
            J=J+1
            KTDLST1(J)=033007
         ELSEIF(KTDLST(I).EQ.031192) THEN
            J=J+1
            KTDLST1(J)=031031
            J=J+1
            KTDLST1(J)=001031
         ELSEIF(KTDLST(I).EQ.309007) THEN
            J=J+1
            KTDLST1(J)=309194
         ELSE
            J=J+1
            KTDLST1(J)=KTDLST(I)
            IF(KTDLST(I).EQ.11061.OR.KTDLST(I).EQ.11062) OSHEAR=.TRUE.
         END IF
C
 8013    CONTINUE
C
         KTDLEN=J
C
         ODPF=.FALSE.
C
         DO 8023 I=1,KTDEXL
         IF(KTDEXP(I).EQ.31192) THEN
            IF(.NOT.ODPF) IDPF=I
            ODPF=.TRUE.
         ELSE
            IF(ODPF) THEN
               IDPL=I-1
               GO TO 8033
            END IF
         END IF
 8023    CONTINUE
C
 8033    CONTINUE

C
C        FIND START OF % CONFIDENCE
C
         DO 8043 I=IDPL,KTDEXL
         IF(KTDEXP(I).EQ.63192) THEN
            IPCF=I
            GO TO 8053
         END IF
 8043    CONTINUE
C
 8053    CONTINUE
C
         J=0
         KDLEN=0
         j=0
C
         DO 8063 I=1,KTDEXL
         J=J+1
         IF(KTDEXP(I).EQ.031001.OR.KTDEXP(I).EQ.031002) THEN
            KDLEN=KDLEN+1
            KDATA(KDLEN)=NINT(VALUES(I))
            value(j)=NINT(VALUES(I))
            if(KDLEN.eq.2) then
               KDATA(KDLEN)=NINT(VALUES(I))+1
               value(j)=KDATA(KDLEN)
            end if
            if(KDLEN.eq.3) then
               KDATA(KDLEN)=NINT(VALUES(I))
               value(j)=KDATA(KDLEN)-1
            end if
            go to 8063
         END IF

C
         IF(KTDEXP(I).EQ.063191) THEN    ! GENERATING APPLICATION
            VALUE(J)=98.                 ! INSERT GENERATING CENTRE
            J=J+1
            VALUE(J)=1.
            GO TO 8063
         END IF
C
         IF(KTDEXP(I).EQ.031192) THEN
               if(i.eq.idpf) then
                  VALUE(J)=rvind
               elseif(i.eq.(idpf+13)) then
                  VALUE(J)=rvind
                  j=j+1
                  VALUE(J)=rvind
               else
                  VALUE(J)=VALUES(I)
               end if
               GO TO 8063
         END IF
C
         IF(KTDEXP(I).EQ.063192) THEN            ! % CONF
            if(i.eq.ipcf) then
               j=j-1
               GO TO 8063
            else 
               VALUE(J)=VALUES(I)
            end if
            GO TO 8063
         END IF
C
         IF(KTDEXP(I).EQ.10003.OR.KTDEXP(I).EQ.10008) THEN
            IF(ABS(VALUES(I)-RVIND)/RVIND.GT.EPS) THEN
               VALUE(J)=(VALUES(I)/9.8)*9.80665
            ELSE
               VALUE(J)=VALUES(I)
            END IF
         ELSE
            if(j.eq.1) then
               value(j)=rvind
               j=j+1
               value(j)=rvind
            else
               VALUE(J)=VALUES(I)
            end if
         END IF
C
 8063    CONTINUE
C
 8103    CONTINUE
C
         value(1)=1009.
         do i=2,13
         value(i)=rvind
         end do
c
         KERR=0
         RETURN
      END IF
C
C
      IF(KST.EQ.142.OR.KST.EQ.144.OR.KST.EQ.164) THEN
C
C        AIREP DATA 142 , AMDAR DATA 144, PAOB 164
C
C        CHANGE OPERATOR
C
         J=0
C
         DO 401 I=1,KTDLEN
C
         IF(KTDLST(I).GT.262000.AND.KTDLST(I).LT.300000) THEN
            J=J+1
            KTDLST1(J)=222000
         ELSEIF(KTDLST(I).EQ.262000) THEN
               GO TO 401
         ELSEIF(KTDLST(I).GT.101000.AND.KTDLST(I).LE.101018) THEN
            J=J+1
            IF(KST.EQ.164) KTDLST1(J)=101011
            IF(KST.EQ.142) KTDLST1(J)=101018
            IF(KST.EQ.144) KTDLST1(J)=101018
         ELSEIF(KTDLST(I).EQ.063191) THEN
            J=J+1
            KTDLST1(J)=001032
         ELSEIF(KTDLST(I).EQ.063192) THEN
            J=J+1
            KTDLST1(J)=033007
         ELSEIF(KTDLST(I).EQ.031192) THEN
            J=J+1
            KTDLST1(J)=031031
            J=J+1
            KTDLST1(J)=001031
         ELSE
            J=J+1
            KTDLST1(J)=KTDLST(I)
         END IF
C
 401     CONTINUE
C
         KTDLEN=J
C
C        FIND FIRST AND LAST POINTER TO DATA PRESENT INDICATOR
C
         ODPF=.FALSE.
C
         DO 402 I=1,KTDEXL
         IF(KTDEXP(I).EQ.31192.OR.KTDEXP(I).EQ.31031) THEN
            IF(.NOT.ODPF) IDPF=I
            ODPF=.TRUE.
         ELSE
            IF(ODPF) THEN
               IDPL=I-1
               GO TO 403
            END IF
         END IF
 402     CONTINUE
C
 403     CONTINUE
C
C        FIND START OF % CONFIDENCE
C
         DO 404 I=IDPL,KTDEXL
         IF(KTDEXP(I).EQ.63192.OR.KTDEXP(I).EQ.33007) THEN
            IPCF=I
            GO TO 405
         END IF
 404     CONTINUE
C
 405     CONTINUE
C
C        MAKE DATA SUITABLE FOR COMPRESSION
C
         J=0
         KDLEN=0
         IPC=IPCF-1
C
         DO 406 I=1,KTDEXL
         J=J+1
         IF(KTDEXP(I).EQ.031001.OR.KTDEXP(I).EQ.031002) THEN
            KDLEN=KDLEN+1
            KDATA(KDLEN)=NINT(VALUES(I))
         END IF
C
         IF(KTDEXP(I).EQ.063191) THEN    ! GENERATING APPLICATION
            VALUE(J)=98.                 ! GENERATING CENTRE
            J=J+1
            VALUE(J)=1.
            GO TO 406
         END IF
C
         IF(KTDEXP(I).EQ.031192) THEN
            VALUE(J)=0.    ! DATA PRESENT
            GO TO 406
         END IF
C
         IF(KTDEXP(I).EQ.063192) THEN            ! % CONF
            DO 407 K=IDPF,IDPL
            IF(VALUES(K).GT.0.) THEN
               VALUE(J)=RVIND
               J=J+1
            ELSE
               IPC=IPC+1
               VALUE(J)=VALUES(IPC)
               J=J+1
            END IF
 407        CONTINUE
            GO TO 410
         END IF
C
         VALUE(J)=VALUES(I)
C
 406     CONTINUE
C
 410     CONTINUE
C
         KERR=0
         RETURN
      END IF
C
      IF(KST.GE.121.AND.KST.LE.123) THEN
C
C        IRS1 DATA
C
         DO 7501 I=1,KTDLEN
         KTDLST1(I)=KTDLST(I)
 7501    CONTINUE
C
         DO 7502 I=1,KSUP(6)
         II=(I-1)*KELEM 
         DO 7503 J=1,KSUP(5)
         IJ=J+II
         VALUE(IJ)=VALUES(IJ)
 7503    CONTINUE
 7502    CONTINUE
C
         RETURN
      END IF
C
      KERR=1
C
      RETURN
      END
      SUBROUTINE BUCON2(KST,KSUP,KTDLEN,KTDLST,KTDLST1,KTDEXL,KTDEXP,
     1                  KELEM,KVALS,VALUES,VALUE,KDLEN,KDATA,KERR)
C
C**** *BUCON2*
C
C
C     PURPOSE.
C     --------
C         CONVERTS BUFR EDITION N TO EDITION M  DATA.
C         
C
C
C**   INTERFACE.
C     ----------
C
C              *CALL BUCON2(KST,KTDLEN,KTDLST,KTDLST1,KTDEXL,KTDEXP,
C                           KELEM,KVALS,VALUES,VALUE,KERR)*
C
C     METHOD.
C     -------
C
C          NONE.
C
C
C     EXTERNALS.
C     ----------
C
C
C     REFERENCE.
C     ----------
C
C          NONE.
C
C     AUTHOR.
C     -------
C
C          M. DRAGOSAVAC    *ECMWF*       15/09/94
C
C
C     MODIFICATIONS.
C     --------------
C
C          NONE.
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
      DIMENSION KTDLST(*),KTDEXP(*)
      DIMENSION KTDLST1(*),KSUP(*),KDATA(*)
      REAL*8 VALUES(*),VALUE(*)
      REAL*8 RVIND,EPS
C
C     ------------------------------------------------------------------
C*          1. INITIALIZE CONSTANTS AND VARIABLES.
C              -----------------------------------
 100  CONTINUE
C
C     MISSING VALUE INDICATOR
C
      RVIND=1.7D38
      EPS=10.D-8
C
      IF(KST.EQ.142) THEN
C
C        AIREP OBSERVATION (ERA PROJECT)
C
C
C        CHANGE OPERATOR
C
         J=0
C
         DO 101 I=1,KTDLEN
C
         IF(KTDLST(I).EQ.101000) THEN
            J=J+1
            KTDLST1(J)=101018
         ELSEIF(KTDLST(I).EQ.31002) THEN
               GO TO 101
         ELSE
            J=J+1
            KTDLST1(J)=KTDLST(I)
         END IF
C
 101     CONTINUE
C
         KTDLEN=J
C
C        FIND FIRST AND LAST POINTER TO DATA PRESENT INDICATOR
C
         ODPF=.FALSE.
C
         DO 102 I=1,KTDEXL
         IF(KTDEXP(I).EQ.31031) THEN
            IF(.NOT.ODPF) IDPF=I
            ODPF=.TRUE.
         ELSE
            IF(ODPF) THEN
               IDPL=I-1
               GO TO 103
            END IF
         END IF
 102     CONTINUE
C
 103     CONTINUE
C
C        FIND START OF % CONFIDENCE
C
         DO 104 I=IDPL,KTDEXL
         IF(KTDEXP(I).EQ.033007) THEN
            IPCF=I
            GO TO 105
         END IF
 104     CONTINUE
C
 105     CONTINUE
C
C        MAKE DATA SUITABLE FOR COMPRESSION
C
         J=0
         KDLEN=0
         IPC=IPCF-1
C
         DO 106 I=1,KTDEXL
         J=J+1
C
         IF(KTDEXP(I).EQ.031002) THEN
            J=J-1
            GO TO 106
         END IF
C
         IF(KTDEXP(I).EQ.031031) THEN
            VALUE(J)=0.    ! DATA PRESENT
            GO TO 106
         END IF
C
         IF(KTDEXP(I).EQ.033007) THEN            ! % CONF
            DO 107 K=IDPF,IDPL
            IF(VALUES(K).GT.0.) THEN
               VALUE(J)=70   !RVIND
               J=J+1
            ELSE
               IPC=IPC+1
               VALUE(J)=VALUES(IPC)
               J=J+1
            END IF
 107        CONTINUE
            GO TO 110
         END IF
C
         VALUE(J)=VALUES(I)
C
 106     CONTINUE
C
 110     CONTINUE
C
         KERR=0
         RETURN
      END IF
      IF(KST.GT.0.AND.KST.LE.255) THEN
C
C        FIND % CONF
C
         ICNF=0
         DO 210 I=1,KTDEXL
         IF(KTDEXP(I).EQ.33007) THEN
            ICNF=I
            GO TO 211
         END IF
 210     CONTINUE
C
 211     CONTINUE
         DO 212 J=ICNF+1,KTDEXL
         IF(KTDEXP(J).NE.33007) THEN
            JCNF=J-1
            GO TO 213
         END IF
 212     CONTINUE
C
 213     CONTINUE
C
         DO 201 I=1,KSUP(5)
         DO 202 J=1,KSUP(6)
         IJ=I+(J-1)*KELEM
         IF(ICNF.NE.0) THEN
         IF(I.GE.ICNF.AND.I.LE.JCNF) THEN
         IF(ABS(VALUES(IJ)-RVIND)/RVIND.LT.EPS) VALUES(IJ)=70.
         END IF
         END IF
         VALUE(IJ)=VALUES(IJ)
 202     CONTINUE
 201     CONTINUE
C
         DO 203 I=1,KTDLEN
         KTDLST1(I)=KTDLST(I)
 203     CONTINUE
C
         KDLEN=0
         DO 204 I=1,KTDEXL
         IF(KTDEXP(I).EQ.031001.OR.
     1      KTDEXP(I).EQ.031002) THEN
            KDLEN=KDLEN+1
            KDATA(KDLEN)=NINT(VALUES(I))
         END IF
 204     CONTINUE
         KERR=0
         RETURN
      END IF
C
      KERR=1
      PRINT*,'NO CONVERTION FOR ',KST,' SUBTYPE.'
C
      END
      SUBROUTINE CUTZERO(CHARPAR,KMIN)
C
C**** CUTZERO - SUBROUTINE TO REMOVE ZERO CHARACTERS.
C
C**   PURPOSE
C     -------
C
C     TO REMOVE ZERO-FILL CHARACTERS FROM THE END OF A CHARACTER
C     VARIABLE.
C
C     INTERFACE
C     ---------
C
C     CALL CUTZERO(CHARPAR,KMIN)
C
C          CHARPAR  - CHARACTER VARIABLE WHICH MAY HAVE ZEROS AT THE
C                     END OF THE VALID CHARACTERS, WHICH NEED TO BE
C                     REMOVED;
C                     RETURNED WITH THE ZERO CHARACTERS CONVERTED TO
C                     BLANK.
C
C          KMIN     - INTEGER VARIABLE INDICATING A MINIMUM NUMBER OF
C                     CHARACTERS AT THE BEGINNING OF THE STRING WHICH
C                     MUST NOT BE CHANGED
C
C     THUS:
C
C     CHARPAR='ABC0000'
C     CALL CUTZERO(CHARPAR,4)
C
C     WOULD RETURN THE VALUE 'ABC0   ' IN CHAR, AND WOULD NOT
C     ALTER THE FIRST 4 CHARACTERS.
C
C     METHOD
C     ------
C
C     THE STRIG IS TESTED FOR THE EXISTANCE OF A ZERO CHARACTER.
C     IF NONE IS FOUND, NO CHANGE TAKES PLACE.
C     IF ONE OR MORE ZERO CHARACTERS ARE PRESENT, THE END OF THE
C     STRING IS LOCATED. WORKING BACKWARDS FROM THE END TO THE
C     KMIN-1 POSITION, CHARACTERS ARE TESTED FOR ZERO. IF A ZERO
C     IS FOUND, IT IS REPLACED BY BLANK. IF A NON-ZERO IS FOUND,
C     THE REPLACEMENT LOOP TERMINATES.
C
C     MODIFICATIONS
C     -------------
C
C     ORIGINAL VERSION - 25.01.95 - REX GIBSON - ECMWF.
C
      CHARACTER*(*) CHARPAR
      CHARACTER*1   YZERO
      INTEGER LEN
C
C     -----------------------------------------------------------
C
C*     1.     FIND AND REPLACE THE ZERO CHARACTERS.
C
  100 CONTINUE
      YZERO=CHAR(0)
      I1=INDEX(CHARPAR,'0')
      IF (I1.GT.0) THEN
         I2=MAX(I1,KMIN+1)
         I3=INDEX(CHARPAR,' ')-1
         IF (I3.LE.0) THEN
            I3=LEN(CHARPAR)
         ENDIF
         DO 112 J=I3,I2,-1
         IF (CHARPAR(J:J).EQ.'0') THEN
             CHARPAR(J:J)=' '
         ELSEIF (CHARPAR(J:J).EQ.YZERO) THEN
             GO TO 112
         ELSE
             GO TO 114
         ENDIF
  112    CONTINUE
C
  114    CONTINUE
      ENDIF
C
C     -----------------------------------------------------------
C
C*     2.     RETURN.
C
  200 CONTINUE
C
      END
      SUBROUTINE BUCON3(KST,KSUP,KTDLEN,KTDLST,KTDLST1,KTDEXL,KTDEXP,
     1                  KELEM,KVALS,VALUES,VALUE,KDLEN,KDATA,KERR)
C
C**** *BUCON3*
C
C
C     PURPOSE.
C     --------
C         CONVERTS BUFR EDITION N TO EDITION M  DATA.
C
C
C
C**   INTERFACE.
C     ----------
C
C              *CALL BUCON3(KST,KTDLEN,KTDLST,KTDLST1,KTDEXL,KTDEXP,
C                           KELEM,KVALS,VALUES,VALUE,KDLEN,KDATA,KERR)*
C
C     METHOD.
C     -------
C
C          NONE.
C
C
C     EXTERNALS.
C     ----------
C
C
C     REFERENCE.
C     ----------
C
C          NONE.
C
C     AUTHOR.
C     -------
C
C          M. DRAGOSAVAC    *ECMWF*       15/09/94
C
C
C     MODIFICATIONS.
C     --------------
C
C          NONE.
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
      DIMENSION KTDLST(*),KTDEXP(*)
      DIMENSION KTDLST1(*),KSUP(*),KDATA(*)
      REAL*8 VALUES(*),VALUE(*)
      REAL*8 RVIND,EPS
C
C     ------------------------------------------------------------------
C*          1. INITIALIZE CONSTANTS AND VARIABLES.
C              -----------------------------------
 100  CONTINUE
C
C     MISSING VALUE INDICATOR
C
      RVIND=1.7D38
      EPS=10.D-8
C
      IF(KST.EQ.142.AND.KSUP(6).EQ.1) THEN
C
C        AIREP OBSERVATION (ERA PROJECT)
C
C
C        CHANGE OPERATOR
C
         J=0
C
         DO 101 I=1,KTDLEN
C
         IF(KTDLST(I).EQ.101000) THEN
            J=J+1
            KTDLST1(J)=101018
         ELSEIF(KTDLST(I).EQ.31002) THEN
               GO TO 101
         ELSE
            J=J+1
            KTDLST1(J)=KTDLST(I)
         END IF
C
 101     CONTINUE
C
         KTDLST1(7)=101018
C
         KTDLEN=J
C
C        FIND FIRST AND LAST POINTER TO DATA PRESENT INDICATOR
C
         ODPF=.FALSE.
C
         DO 102 I=1,KTDEXL
         IF(KTDEXP(I).EQ.31031) THEN
            IF(.NOT.ODPF) IDPF=I
            ODPF=.TRUE.
         ELSE
            IF(ODPF) THEN
               IDPL=I-1
               GO TO 103
            END IF
         END IF
 102     CONTINUE
C
 103     CONTINUE
C
C        FIND START OF % CONFIDENCE
C
         DO 104 I=IDPL,KTDEXL
         IF(KTDEXP(I).EQ.033007) THEN
            IPCF=I
            GO TO 105
         END IF
 104     CONTINUE
C
 105     CONTINUE
C
C        MAKE DATA SUITABLE FOR COMPRESSION
C
         J=0
         KDLEN=0
         IPC=IPCF-1
C
         DO 106 I=1,KTDEXL
         J=J+1
C
         IF(KTDEXP(I).EQ.031002) THEN
            J=J-1
            GO TO 106
         END IF
C
         IF(KTDEXP(I).EQ.031031) THEN
            VALUE(J)=0.    ! DATA PRESENT
            GO TO 106
         END IF
C
         IF(KTDEXP(I).EQ.033007) THEN            ! % CONF
            DO 107 K=IDPF,IDPL
            IF(VALUES(K).GT.0.) THEN
               VALUE(J)=70.   !RVIND
               J=J+1
            ELSE
               IPC=IPC+1
               VALUE(J)=VALUES(IPC)
               J=J+1
            END IF
 107        CONTINUE
            GO TO 110
         END IF
C
         VALUE(J)=VALUES(I)
C
 106     CONTINUE
C
 110     CONTINUE
C
         KERR=0
         RETURN
      END IF
C
      IF(KST.EQ.9.OR.KST.EQ.11.OR.KST.EQ.13.OR.KST.EQ.19) THEN
C
C        SYNOP SHIP OBSERVATION (ERA PROJECT)
C        SOME SHIP HAS NOT GOT 012005 AFTER 308004
C
C
C        CHANGE OPERATOR
C
         IF(KTDLST(1).EQ.308004.AND.KTDLST(2).EQ.12005) go to 300
C
         J=0
C
         DO I=1,KTDLEN
C
         IF(KTDLST(I).EQ.308004) THEN
            J=J+1
            KTDLST1(J)=KTDLST(I)
            IF(KTDLST(I+1).NE.012005) THEN
               J=J+1
               KTDLST1(J)=012005
            END IF
         ELSEIF(KTDLST(I).EQ.101032) THEN
            J=J+1
            KTDLST1(J)=101033
         ELSEIF(KTDLST(I).EQ.001201) THEN
            J=J+1
            KTDLST1(J)=001032
         ELSE
            J=J+1
            KTDLST1(J)=KTDLST(I)
         END IF
         END DO
C
         KTDLST1(8)=101033
C
         KTDLEN=J
C
C        FIND FIRST AND LAST POINTER TO DATA PRESENT INDICATOR
C
         ODPF=.FALSE.
C
         DO I=1,KTDEXL
         IF(KTDEXP(I).EQ.31031) THEN
            IF(.NOT.ODPF) IDPF=I
            ODPF=.TRUE.
         ELSE
            IF(ODPF) THEN
               IDPL=I-1
               GO TO 113
            END IF
         END IF
         END DO
C
 113     CONTINUE
C
C        FIND START OF % CONFIDENCE
C
         DO I=IDPL,KTDEXL
         IF(KTDEXP(I).EQ.033007) THEN
            IPCF=I
            GO TO 115
         END IF
         END DO
C
 115     CONTINUE
C
C        MAKE DATA SUITABLE FOR COMPRESSION
C
         J=0
         KDLEN=0
         IPC=IPCF-1
C
         DO  I=1,IDPF-2
         J=J+1
         VALUE(J)=VALUES(I)
         END DO
C
C        FOR 012005 ELEMENT
C
         J=J+1
         VALUE(J)=RVIND
C
C        FOR 222000 OPERATOR
C
         J=J+1
         VALUE(J)=0.0
C
C        DATA PRESENT
C
         DO I=IDPF,IDPL+1
         J=J+1
         VALUE(J)=0.
         END DO
C
C        GENERATING CENTRE AND APPLICATION
         J=J+1
         VALUE(J)=98.
         J=J+1
         VALUE(J)=1.
C
         IPC=IPCF-1
         DO I=IDPF,IDPL
         IF(VALUES(I).GT.0.) THEN
            J=J+1
            VALUE(J)=70.
         ELSE
            IPC=IPC+1
            J=J+1
            VALUE(J)=VALUES(IPC)
         END IF
         END DO
C
C        FOR 012005 ELEMENT
C
         J=J+1
         VALUE(J)=70.
C
         KERR=0
         RETURN
      END IF
C
      IF(KST.EQ.145) THEN
C
C        ERA CREATED ACARS HAVE MISSING VALUES FOR QC AND 
C        ZERO FOR ORIGINATING CENTRE. BIT MAP IS SET WRONG.
C
         ICNF=0
         DO 131 I=1,KTDEXL
         IF(KTDEXP(I).EQ.33007) THEN
            ICNF=I
            GO TO 132
         END IF
 131     CONTINUE
 132     CONTINUE
         DO 133 J=ICNF-1,KTDEXL
         IF(KTDEXP(J).EQ.33007) THEN
            JCNF=J
         END IF
 133     CONTINUE
 134     CONTINUE
C
         DO 231 I=1,KSUP(5)
         DO 232 J=1,KSUP(6)
         IJ=I+(J-1)*KELEM
         IF(ICNF.NE.0) THEN
           IF(I.GE.ICNF.AND.I.LE.JCNF) THEN
             IF(ABS(VALUES(IJ)-RVIND)/RVIND.LT.EPS) VALUES(IJ)=70.
           END IF
         END IF
         IF(KTDEXP(I).EQ.001031) THEN
            VALUE(IJ)=98.
         ELSEIF(KTDEXP(I).EQ.031031) THEN
            VALUE(IJ)=0.
         ELSE
            VALUE(IJ)=VALUES(IJ)
         END IF
         CONTINUE
 232     CONTINUE
 231     CONTINUE
C
         DO 233 I=1,KTDLEN
         IF(KTDLST(I).EQ.001201) THEN
            KTDLST1(I)=001032
         ELSE
            KTDLST1(I)=KTDLST(I)
         END IF
 233     CONTINUE
         KERR=0
C
         KDLEN=0
         DO 234 I=1,KTDEXL
         IF(KTDEXP(I).EQ.01001.OR.
     1      KTDEXP(I).EQ.031000.OR.
     1      KTDEXP(I).EQ.031002) THEN
            KDLEN=KDLEN+1
            KDATA(KDLEN)=NINT(VALUES(I))
         END IF
 234     CONTINUE
C
         KERR=0
         RETURN
      END IF
C
 300  CONTINUE
C
      IF(KST.EQ.92.and.KTDLST(6).eq.301023) THEN
C
C        PILOT 92
C        ----------------------
         J=0
         OSHEAR=.FALSE.
C
         DO 801 I=1,KTDLEN
C
         IF(KTDLST(I).GT.262000.AND.KTDLST(I).LT.300000) THEN
            J=J+1
            KTDLST1(J)=222000
         ELSEIF(KTDLST(I).EQ.301023) THEN
            J=J+1
            KTDLST1(J)=301024
         ELSE
            J=J+1
            KTDLST1(J)=KTDLST(I)
            IF(KTDLST(I).EQ.11061.OR.KTDLST(I).EQ.11062) OSHEAR=.TRUE.
         END IF
C
 801     CONTINUE
C
         KTDLEN=J
C
C        FIND FIRST AND LAST POINTER TO DATA PRESENT INDICATOR
C
         ODPF=.FALSE.
C
         DO 802 I=1,KTDEXL
         IF(KTDEXP(I).EQ.31031) THEN
            IF(.NOT.ODPF) IDPF=I
            ODPF=.TRUE.
         ELSE
            IF(ODPF) THEN
               IDPL=I-1
               GO TO 803
            END IF
         END IF
 802     CONTINUE
C
 803     CONTINUE
C
C        FIND START OF % CONFIDENCE
C
         DO 804 I=IDPL,KTDEXL
         IF(KTDEXP(I).EQ.033007) THEN
            IPCF=I
            GO TO 805
         END IF
 804     CONTINUE
C
 805     CONTINUE
C
C        MAKE DATA SUITABLE FOR COMPRESSION
C
         J=0
         KDLEN=0
         ISTAT=0
         IPC=IPCF-1
C
         DO 806 I=1,KTDEXL
         J=J+1
         IF(KTDEXP(I).EQ.031001.OR.KTDEXP(I).EQ.031002) THEN
            KDLEN=KDLEN+1
            KDATA(KDLEN)=NINT(VALUES(I))
            IF(KDLEN.EQ.2.AND..NOT.OSHEAR) THEN
               KDATA(KDLEN)=NINT(VALUES(I))+1
            END IF
            IF(KDLEN.EQ.3.AND.OSHEAR) THEN
               KDATA(KDLEN)=NINT(VALUES(I))+1
            END IF
         END IF
C
         IF(KTDEXP(I).EQ.031031) THEN
            ISTAT=ISTAT+1
            IF(ISTAT.EQ.12) THEN
               VALUE(J)=VALUES(I)
               J=J+1
               VALUE(J)=1.
               VALUE(IDPF)=VALUES(IDPF-1)+1
            ELSE
               VALUE(J)=VALUES(I)
            END IF
            GO TO 806
         END IF
C
         IF(KTDEXP(I).EQ.033007) THEN            ! % CONF
            VALUE(J)=VALUES(I)
            GO TO 806
         END IF
C
         IF(KTDEXP(I).EQ.006002) THEN
            VALUE(J)=VALUES(I)
            J=J+1
            VALUE(J)=RVIND                    ! INSERT STATION HEIGHT
            GO TO 806
         END IF
C
         IF(KTDEXP(I).EQ.10003.OR.KTDEXP(I).EQ.10008) THEN
            IF(ABS(VALUES(I)-RVIND)/RVIND.GT.EPS) THEN
               VALUE(J)=(VALUES(I)/9.8)*9.80665
            ELSE
               VALUE(J)=VALUES(I)
            END IF
         ELSE
            VALUE(J)=VALUES(I)
         END IF
C
 806     CONTINUE
C
 810     CONTINUE
C
         KERR=0
         RETURN
      END IF

      ICNF=0
      DO 121 I=1,KTDEXL
      IF(KTDEXP(I).EQ.33007) THEN
         ICNF=I
         GO TO 122
      END IF
 121  CONTINUE
 122  CONTINUE
      DO 123 J=ICNF-1,KTDEXL
      IF(KTDEXP(J).EQ.33007) THEN
         JCNF=J
      END IF
 123  CONTINUE
 124  CONTINUE
C
      IF(KST.eq.86) then
         if(KTDLST(1).eq.310195) then
            ktdlst1(1)=301043
            ktdlst1(2)=304001
            ktdlen=2 
c
            DO 2211 I=1,KSUP(5)
            DO 2222 J=1,KSUP(6)
            jm1k=(J-1)*KELEM
            value(1+jm1k)=values(1+jm1k)
            value(2+jm1k)=values(15+jm1k)
            value(3+jm1k)=values(5+jm1k)
            value(4+jm1k)=values(6+jm1k)
            value(5+jm1k)=values(7+jm1k)
            value(6+jm1k)=values(8+jm1k)
            value(7+jm1k)=values(9+jm1k)
            value(8+jm1k)=values(10+jm1k)
            value(9+jm1k)=values(11+jm1k)
            value(10+jm1k)=values(12+jm1k)
            value(11+jm1k)=2.
            value(12+jm1k)=values(16+jm1k)
            value(13+jm1k)=values(21+jm1k)
            value(14+jm1k)=values(17+jm1k)
            value(15+jm1k)=values(18+jm1k)
 2222       continue
 2211       continue
C
            return
         end if
      end if
c
      IF(KST.GT.0.AND.KST.LE.255) THEN
         if(kst.eq.87) ICNF=0
         DO 221 I=1,KSUP(5)
         DO 222 J=1,KSUP(6)
         IJ=I+(J-1)*KELEM
         IF(ICNF.NE.0) THEN
         IF(I.GE.ICNF.AND.I.LE.JCNF) THEN
           IF(ABS(VALUES(IJ)-RVIND)/RVIND.LT.EPS) VALUES(IJ)=70.
         END IF
         END IF
         VALUE(IJ)=VALUES(IJ)
 222     CONTINUE
 221     CONTINUE
C
         DO 223 I=1,KTDLEN
         IF(KTDLST(I).EQ.001201) THEN
            KTDLST1(I)=001032
         ELSE
         KTDLST1(I)=KTDLST(I)
         END IF
 223     CONTINUE
         KERR=0
C
         KDLEN=0
         DO 224 I=1,KTDEXL
         IF(KTDEXP(I).EQ.031001.OR.
     1      KTDEXP(I).EQ.031000.OR.
     1      KTDEXP(I).EQ.031002) THEN
            KDLEN=KDLEN+1
            KDATA(KDLEN)=NINT(VALUES(I))
         END IF
 224     CONTINUE
         RETURN
C
      END IF
C
      KERR=1
      PRINT*,'NO CONVERTION FOR ',KST,' SUBTYPE.'
C
      END
      SUBROUTINE DATE_TIME_CHECK(KTDEXP,KSEC1,KSEC3,KEY,KEL,VALUES,KERR)
C
C**** *DATE_TIME_CHECK*
C
C
C     PURPOSE.
C     --------
C         Check date time consistency in the bufr section1,
C         Key and data section.
C
C
C
C**   INTERFACE.
C     ----------
C
C              *CALL DATE_TIME_CHECK(KTDEXP,
C                        KSEC1,KSEC3,KEY,KEL,VALUES,KERR)
C
C     METHOD.
C     -------
C
C          NONE.
C
C
C     EXTERNALS.
C     ----------
C
C
C     REFERENCE.
C     ----------
C
C          NONE.
C
C     AUTHOR.
C     -------
C
C          M. DRAGOSAVAC    *ECMWF*       15/09/94
C
C
C     MODIFICATIONS.
C     --------------
C
C          NONE.
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
      DIMENSION KTDEXP(*), KSEC1(*),KSEC3(*), KEY(*)
      REAL*8 VALUES(*)
C
C     ------------------------------------------------------------------
C*          1. INITIALIZE CONSTANTS AND VARIABLES.
C              -----------------------------------
 100  CONTINUE
C
C     MISSING VALUE INDICATOR
C

      IPYEAR=0
      osec1=.true.
      okey=.true.
      odata=.true.
c
      DO 101 I=1,36
      IF(KTDEXP(I).EQ.004001.AND.IPYEAR.eq.0) IPYEAR=I
 101  CONTINUE
c
      IF(IPYEAR.NE.0) THEN
c       Determine date time differences
c
        if(ksec1(9).gt.100) then
           osec1=.false.
        elseif(ksec1(9).lt.20) then
           iys1=ksec1(9)+2000
        else
           iys1=ksec1(9)+1900
        end if
c
        if(ksec1(10).le.0.or.ksec1(10).gt.12) then
           osec1=.false.
        end if
c
        if(ksec1(11).le.0.or.ksec1(11).gt.31) then
           osec1=.false.
        end if
        if(ksec1(12).lt.0.or.ksec1(12).gt.23) then
           osec1=.false.
        end if
        if(ksec1(13).lt.0.or.ksec1(13).gt.59) then
           osec1=.false.
        end if
c
        if(osec1) then
          isdate=iys1*10000+ksec1(10)*100+ksec1(11)
          istime=ksec1(12)*100+ksec1(13)
        else
          isdate=-1
          istime=-1
        end if
c
        if(key(4).le.1940.or.key(4).gt.2020) then
           okey=.false.
        end if  
        if(key(5).le.0.or.key(5).gt.12) then
           okey=.false.
        end if
        if(key(6).le.0.or.key(6).gt.31) then
           okey=.false.
        end if
        if(key(7).lt.0.or.key(7).gt.23) then
           okey=.false.
        end if
        if(key(8).lt.0.or.key(8).gt.59) then
           okey=.false.
        end if
c
        if(okey) then
           ikdate=key(4)*10000+key(5)*100+key(6)
           iktime=key(7)*100+key(8)
        else
           ikdate=-2
           iktime=-2
        end if
c
        if(values(ipyear).le.1940.or.values(ipyear).gt.2020) then  
           odata=.false.
        end if
        if(values(ipyear+1).le.0.or.values(ipyear+1).gt.12) then
           odata=.false.
        end if
        if(values(ipyear+2).le.0.or.values(ipyear+2).gt.31) then
           odata=.false.
        end if
        if(values(ipyear+3).lt.0.or.values(ipyear+3).gt.23) then
           odata=.false.
        end if
        if(values(ipyear+4).lt.0.or.values(ipyear+4).gt.59) then
           odata=.false.
        end if
c
        if(odata) then
           iddate=values(ipyear)*10000+values(ipyear+1)*100+
     1            values(ipyear+2)
           idtime=values(ipyear+3)*100+values(ipyear+4)
        else
           iddate=-3
           idtime=-3
        end if
c
        if(isdate.lt.0.and.ikdate.lt.0.and.iddate.lt.0) then
c          some subtype 84 got wrong year as 3999
           if(values(ipyear).gt.3000) then
              values(ipyear)=values(ipyear)-2000.
              key(4)=key(4)-2000
           else
              kerr=1
              print*,'Date-time is wrong in the bufr message.'
              return
           end if
           return
        elseif(istime.lt.0.and.idtime.lt.0.and.iktime.ge.0) then
           kerr=1
           print*,'Date-time is wrong in the bufr message.'
           return
        end if
c
        if(isdate.eq.ikdate.and.isdate.ne.iddate.or.
     1     istime.eq.iktime.and.istime.ne.idtime) then
c
c          set the date of the first subset from the key
C
c          do ii=1,ksec3(3)
c          iii=ipyear+(ii-1)*kel
           iii=ipyear
           values(iii  )=key(4)
           values(iii+1)=key(5)
           values(iii+2)=key(6)
           values(iii+3)=key(7)
           values(iii+4)=key(8)
c          end do 
        elseif(isdate.eq.iddate.and.isdate.ne.ikdate.or.
     1     istime.eq.idtime.and.istime.ne.iktime) then
           key(4)=nint(values(ipyear))
           key(5)=nint(values(ipyear+1))
           key(6)=nint(values(ipyear+2))
           key(7)=nint(values(ipyear+3))
           key(8)=nint(values(ipyear+4))
        else 
           if(odata) then
              key(4)=nint(values(ipyear))
              key(5)=nint(values(ipyear+1))
              key(6)=nint(values(ipyear+2))
              key(7)=nint(values(ipyear+3))
              key(8)=nint(values(ipyear+4))
c
              ksec1(9)=nint(values(ipyear))-1900
              if(values(ipyear).gt.2001.) then
                  ksec1(9)=nint(values(ipyear))-2000
              end if
              ksec1(10)=nint(values(ipyear+1))
              ksec1(11)=nint(values(ipyear+2))
              ksec1(12)=nint(values(ipyear+3))
              ksec1(13)=nint(values(ipyear+4))
           else
c             do ii=1,ksec3(3)
c             iii=ipyear+(ii-1)*kel
              iii=ipyear
              values(iii  )=key(4)
              values(iii+1)=key(5)
              values(iii+2)=key(6)
              values(iii+3)=key(7)
              values(iii+4)=key(8)
c             end do
c
              ksec1(9)=nint(values(ipyear))-1900
              if(values(ipyear).gt.2001.) then
                  ksec1(9)=nint(values(ipyear))-2000
              end if
              ksec1(10)=nint(values(ipyear+1))
              ksec1(11)=nint(values(ipyear+2))
              ksec1(12)=nint(values(ipyear+3))
              ksec1(13)=nint(values(ipyear+4))
           end if
         end if
      else
        print*,'There is no year in the data.'
        kerr=1
        return
      end if
c
      return
      end

C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      INTEGER FUNCTION HNTFAPH(INGRIB,INLEN)
C
C---->
C**** HNTFAPH
C
C     Purpose
C     -------
C
C     Prepare to interpolate to grid point field.
C
C
C     Interface
C     ---------
C
C     IRET = HNTFAPH(INGRIB,INLEN)
C
C     Input
C     -----
C
C     INGRIB - Input field (packed).
C     INLEN  - Input field length (words).
C
C
C     Output
C     ------
C
C     Field unpacked values are in ZNFELDI, rotated if necessary.
C
C     Returns: 0, if OK. Otherwise, an error occured in interpolation.
C
C
C     Method
C     ------
C
C     Unpack field.
C
C     If the input is a spectral field and the output is a rotated
C     grid-point field, create a global reduced gaussian field and
C     then create the rotated grid-point field from it.
C
C
C     Externals
C     ---------
C
C     GRIBEX  - Decode/encode GRIB product.
C     GRSVCK  - Turn off GRIB checking
C     INTLOG  - Log error message.
C     INTLOGR - Log error message.
C     JDEBUG  - Checks environment to switch on/off debug
C     FIXAREA - Fixup input/output field area definitions.
C     HSP2GG  - Find suitable gaussian grid for spectral truncation
C     HIRLAM  - Creates rotated lat/long field from reduced gaussian
C     HIRLSM  - Creates rotated lat/long field from reduced gaussian
C               using land-sea mask
C     HRG2GG  - Creates rotated gaussian field from reduced gaussian
C     HLL2LL  - Creates rotated lat/long field from lat/long field
C     LSMFLD  - Determines whether a field is to be interpolated using
C               a land-sea mask
C
C
C     Author
C     ------
C
C     J.D.Chambers     ECMWF     January 31, 2001
C
C
C----<
C
C     -----------------------------------------------------------------|
C*    Section 0.   Variables
C     -----------------------------------------------------------------|
C
      IMPLICIT NONE
C
C     Function arguments
C
      INTEGER INGRIB(*),INLEN
C
#include "parim.h"
#include "nifld.common"
#include "nofld.common"
#include "grfixed.h"
#include "intf.h"
#include "jparams.h"
#include "current.h"
C
C     Parameters
C
      INTEGER JPROUTINE
      PARAMETER (JPROUTINE = 40110 )
C
C     Local variables
C
      LOGICAL LUSELSM, LDEBUG, LSP2RGG, LLATOUT
      INTEGER NUMPTS, NGAUSS, NLON, NLAT, NUVFLAG, NTRUNC, NCOUNT
      INTEGER IWORD, IERR, LOOP, IRET, ISIZE, KPTS(JPGTRUNC*2)
      INTEGER ISHIZE
      INTEGER ITEMP,K,I,J,IM,JM
      REAL PLATS(JPGTRUNC*2),AREA(4),GRID(2),POLE(2),WEST,EAST
      REAL OLDGRID(2)
      REAL TEMP(1440,1440)
      CHARACTER*1 HOLDTYP
C
      REAL SWORK(1), RGGRID(1), ZNFLDO(1)
#ifndef _CRAYFTN
#ifdef POINTER_64
      INTEGER*8 ISWORK, IRGGRID, IZNFLDO
#endif
#endif
      POINTER ( ISWORK, SWORK)
      POINTER ( IRGGRID, RGGRID)
      POINTER ( IZNFLDO, ZNFLDO )
C
      SAVE IZNFLDO,ISWORK, IRGGRID
C
C     Externals
C
      INTEGER HSP2GG, HIRLAM, HIRLSM, HRG2GG, HLL2LL, FIXAREA,PDDEFS
      INTEGER HSP2GG2,HSP2GG3
      LOGICAL LSMFLD
C
C     -----------------------------------------------------------------|
C*    Section 1.   Initialise
C     -----------------------------------------------------------------|
C
  100 CONTINUE
C
      HNTFAPH = 0
C
C     Check if debug option turned on
C
      CALL JDEBUG()
      LDEBUG = ( NDBG.NE.0 )
C
      LSP2RGG = .FALSE.
C
C     -----------------------------------------------------------------|
C*    Section 2.   Decode data from the GRIB code
C     -----------------------------------------------------------------|
C
  200 CONTINUE
C
C     Decode data from GRIB code (no checking)
C
      IERR  =  0
      CALL GRSVCK(0)
C
      IERR = 1
      IWORD = INLEN
      ISEC3(2) = NINT(RMISSGV)
      ZSEC3(2) = RMISSGV

      CALL GRIBEX(ISEC0, ISEC1, ISEC2, ZSEC2, ISEC3, ZSEC3, ISEC4,
     X            ZNFELDI, JPEXPAND, INGRIB, INLEN, IWORD, 'D',IERR)

      IF (ISEC2(11).EQ.64) THEN
        CALL INTLOG(JP_DEBUG,
     X    'HNTFAPH: Scanning flag west-east/south-north',ISEC2(11))
        ITEMP = NIAREA(1)
        NIAREA(1) = NIAREA(3)
        NIAREA(3) = ITEMP

        IM = ISEC2(2)
        JM = ISEC2(3)
         K=0
         DO J=JM,1,-1
           DO I=1,IM
              K=K+1
              TEMP(I,J) = ZNFELDI(K)
           END DO
         END DO
         K=0
         DO J=1,JM
           DO I=1,IM
              K=K+1
              ZNFELDI(K) = TEMP(I,J)
           END DO
         END DO

      ENDIF

C
      IF( IERR.LT.0) THEN
        IF( (IERR.EQ.-2).OR.(IERR.EQ.-4) ) THEN
          CALL INTLOG(JP_DEBUG,'HNTFAPH: Use missing value',JPQUIET)
          LIMISSV = .TRUE.
        ELSE
          CALL INTLOG(JP_ERROR,'HNTFAPH: GRIBEX decoding fail.',IERR)
          HNTFAPH = JPROUTINE + 2
          GOTO 900
        ENDIF
      ELSE IF( IERR.GT.0 ) THEN
        CALL INTLOG(JP_ERROR,'HNTFAPH: GRIBEX decoding failed.',IERR)
        HNTFAPH = JPROUTINE + 2
        GOTO 900
      ENDIF
C
      NCOUNT = ISEC4(1)
C
      LLATOUT = (NOREPR.EQ.JPREGROT).OR.(NOREPR.EQ.JPREGULAR)
C
      IF( .NOT.LNOROTA ) GOTO 900
C
C     -----------------------------------------------------------------|
C*    Section 3.   Handle rotation, if necessary.
C     -----------------------------------------------------------------|
C
  300 CONTINUE
C
      IF( LDEBUG ) THEN
        CALL INTLOG(JP_DEBUG,'HNTFAPH: Rotate field.',JPQUIET)
        CALL INTLOG(JP_DEBUG,'HNTFAPH: South pole lat  ',NOROTA(1))
        CALL INTLOG(JP_DEBUG,'HNTFAPH: South pole long ',NOROTA(2))
      ENDIF
C
C     Fill area limits (handles case when default 0/0/0/0 given)
C
      IRET = FIXAREA()
      IF( IRET.NE.0 ) THEN
        IF( LDEBUG ) CALL INTLOG(JP_ERROR,
     X    'HNTFAPH: area fixup failed',JPQUIET)
        HNTFAPH = JPROUTINE + 3
        GOTO 900
      ENDIF
C
      AREA(1) = REAL(NOAREA(1))/PPMULT
      AREA(2) = REAL(NOAREA(2))/PPMULT
      AREA(3) = REAL(NOAREA(3))/PPMULT
      AREA(4) = REAL(NOAREA(4))/PPMULT
C
      GRID(1) = REAL(NOGRID(1))/PPMULT
      GRID(2) = REAL(NOGRID(2))/PPMULT
C
      POLE(1) = REAL(NOROTA(1))/PPMULT
      POLE(2) = REAL(NOROTA(2))/PPMULT
C
C     -----------------------------------------------------------------|
C*    Section 4.   Spectral to rotated grid-point
C     -----------------------------------------------------------------|
C
  400 CONTINUE
C

      IF( (NIREPR.EQ.JPSPHERE).OR.(NIREPR.EQ.JPSPHROT) ) THEN
C
C       Convert spectral to suitable global reduced gaussian grid
C
        IF( LDEBUG ) CALL INTLOG(JP_DEBUG,
     X    'HNTFAPH: Spectral to suitable reduced gaussian',JPQUIET)
C
        NIRESO = ISEC2(2)
        NTRUNC = ISEC2(2)
      IF(LNORESO) THEN
         NTRUNC = NORESO
         IRET = HSP2GG(NTRUNC,NGAUSS,KPTS,PLATS,ISIZE)
          IF( IRET.NE.0 ) THEN
            IF( LDEBUG ) CALL INTLOG(JP_ERROR,
     X        'HNTFAPH: problem getting data for reduced grid',NTRUNC)
            HNTFAPH = JPROUTINE + 4
            GOTO 900
          ENDIF
         IF( LDEBUG ) THEN
          CALL INTLOG(JP_DEBUG,'HNTFAPH: Spectral truncation:', NTRUNC)
          CALL INTLOG(JP_DEBUG,'HNTFAPH: Gaussian number : ',NGAUSS)
         ENDIF
        GOTO 401
       ENDIF
       IF(LARESOL ) THEN
        IF(LLATOUT) THEN
         IRET = HSP2GG2(NTRUNC,GRID(1),GRID(2),NGAUSS,KPTS,PLATS,ISIZE)
        ELSE
         IRET = HSP2GG3(NTRUNC,NGAUSS,KPTS,PLATS,ISIZE)
        ENDIF
         IF( IRET.NE.0 ) THEN
           IF( LDEBUG ) CALL INTLOG(JP_ERROR,
     X       'HNTFAPH: problem getting data for reduced grid',NTRUNC)
           HNTFAPH = JPROUTINE + 4
           GOTO 900
         ENDIF
       ENDIF
c---------------------------------------------------------------------
C       Truncate if a smaller resolution has been requested
C
  401 CONTINUE
      IF( NTRUNC.LT.NIRESO ) THEN
       IF( LDEBUG ) THEN
       CALL INTLOG(JP_DEBUG,'HNTFAPH: Truncation changed from: ',NIRESO)
       CALL INTLOG(JP_DEBUG,'HNTFAPH: to: ',NTRUNC)
       CALL INTLOG(JP_DEBUG,'HNTFAPH: Gaussian number is : ',NGAUSS)
       ENDIF
C
            ISHIZE =  (NTRUNC+1)*(NTRUNC+4)
              CALL JMEMHAN( 3, IZNFLDO, ISHIZE, 1, IERR)
              IF( IERR.NE.0 ) THEN
                CALL INTLOG(JP_FATAL,
     X            'HNTFAPH: Get scratch space failed',JPQUIET)
                HNTFAPH = JPROUTINE + 4
                GOTO 900
              ENDIF
C
C         Generate spherical harmonics with output truncation
C
          CALL SH2SH( ZNFELDI, NIRESO, ZNFLDO, NTRUNC )
C
C         Move new spherical harmonics to 'input' array
C
          DO LOOP = 1, ISHIZE
            ZNFELDI(LOOP) = ZNFLDO(LOOP)
          ENDDO

      ELSE
C
          IF( LDEBUG ) CALL INTLOG(JP_DEBUG,
     X      'HNTFAPH: Spectral to suitable reduced gaussian',JPQUIET)
C
          NTRUNC = ISEC2(2)
          IRET = HSP2GG(NTRUNC,NGAUSS,KPTS,PLATS,ISIZE)
          IF( IRET.NE.0 ) THEN
            IF( LDEBUG ) CALL INTLOG(JP_ERROR,
     X        'HNTFAPH: problem getting data for reduced grid',NTRUNC)
            HNTFAPH = JPROUTINE + 4
            GOTO 900
          ENDIF
         IF( LDEBUG ) THEN
          CALL INTLOG(JP_DEBUG,'HNTFAPH: Spectral truncation:', NTRUNC)
          CALL INTLOG(JP_DEBUG,'HNTFAPH: Gaussian number : ',NGAUSS)
         ENDIF
      ENDIF
C
C       Dynamically allocate memory for global reduced gaussian grid
C
        CALL JMEMHAN( 18, IRGGRID, ISIZE, 1, IRET)
        IF( IRET.NE.0 ) THEN
          IF( LDEBUG ) CALL INTLOG(JP_ERROR,
     X      'HNTFAPH: memory alloc for reduced grid fail',JPQUIET)
          HNTFAPH = JPROUTINE + 4
          GOTO 900
        ENDIF
C
C       Set flag to show field is not a wind component
C
        NUVFLAG = 0
C
C       Create the reduced gaussian grid
C
        HOLDTYP = HOGAUST
        WEST = 0.0
        EAST = 360.0 - (360.0/(NGAUSS*4))
        CALL JAGGGP(ZNFELDI,NTRUNC,PLATS(1),PLATS(NGAUSS*2),WEST,
     X              EAST,NGAUSS,'R',KPTS,RGGRID,NUVFLAG,IRET)
        IF( IRET.NE.0 ) THEN
          IF( LDEBUG ) CALL INTLOG(JP_ERROR,
     X      'HNTFAPH: spectral to reduced gaussian failed',JPQUIET)
          HNTFAPH = JPROUTINE + 4
          GOTO 900
        ENDIF
        HOGAUST = HOLDTYP
C
        NCOUNT = 0
        DO LOOP = 1, (NGAUSS*2)
          NCOUNT= NCOUNT + KPTS(LOOP)
        ENDDO
C
        LSP2RGG = .TRUE.
C
        IF( NOREPR.EQ.JPFGGROT ) THEN
          IF( LDEBUG ) CALL INTLOG(JP_DEBUG,
     X      'HNTFAPH: Convert gaussian to rotated gaussian',JPQUIET)
C
          GOTO 600
C
        ENDIF
      ENDIF
C
C     -----------------------------------------------------------------|
C*    Section 5.   Gaussian to rotated lat/long
C     -----------------------------------------------------------------|
C
  500 CONTINUE
C
      IF( (LSP2RGG.AND.LLATOUT) .OR.
     X    ( (NIREPR.EQ.JPGAUSSIAN).AND.LLATOUT) .OR.
     X    ( (NIREPR.EQ.JPQUASI).AND.LLATOUT)    ) THEN
C
        IF( LDEBUG )
     X    CALL INTLOG(JP_DEBUG,'HNTFAPH: Gauss to lat/lon',JPQUIET)
C
C       Dynamically allocate memory for rotated lat/long grid
C
        NLON = 1 + NINT((AREA(JPEAST)  - AREA(JPWEST)) /
     X         GRID(JPWESTEP)) !SC
        NLAT = 1 + NINT((AREA(JPNORTH) - AREA(JPSOUTH)) /
     X         GRID(JPNSSTEP)) !SC
C
        NOWE = NLON
        NONS = NLAT
C
        NUMPTS = NLON * NLAT
        ISIZE  = NUMPTS
        CALL JMEMHAN( 11, ISWORK, ISIZE, 1, IRET)
        IF( IRET.NE.0 ) THEN
          IF( LDEBUG ) CALL INTLOG(JP_ERROR,
     X      'HNTFAPH: memory alloc for lat/long grid fail',JPQUIET)
          HNTFAPH = JPROUTINE + 7
          GOTO 900
        ENDIF
C
        LUSELSM = LSMFLD()
C
C       If original field was spectral, ...
C
        IF( LSP2RGG ) THEN
          IF( LUSELSM ) THEN
            IRET = HIRLSM(LO12PT,RGGRID,NCOUNT,NGAUSS,AREA,POLE,GRID,
     X                    SWORK,ISIZE,NLON,NLAT)
          ELSE
            IRET = HIRLAM(LO12PT,RGGRID,NCOUNT,NGAUSS,AREA,POLE,GRID,
     X                    SWORK,ISIZE,NLON,NLAT)
          ENDIF
C
        ELSE
C
C       If original field was gaussian, ...
C
          IRET = PDDEFS()
          NGAUSS = ISEC2(10)
cs          IF( LUSELSM ) THEN
          IF( LSM ) THEN
            IRET = HIRLSM(LO12PT,ZNFELDI,NCOUNT,NGAUSS,AREA,POLE,GRID,
     X                    SWORK,ISIZE,NLON,NLAT)
          ELSE
            IRET = HIRLAM(LO12PT,ZNFELDI,NCOUNT,NGAUSS,AREA,POLE,GRID,
     X                    SWORK,ISIZE,NLON,NLAT)
          ENDIF
C
        ENDIF
C
        IF( IRET.NE.0 ) THEN
          IF( LDEBUG ) CALL INTLOG(JP_ERROR,
     X      'HNTFAPH: HIRLAM rotation failed',JPQUIET)
          HNTFAPH = JPROUTINE + 7
          GOTO 900
        ENDIF
C
        ISEC2(1) = JPREGROT
        ISEC4(1) = NOWE * NONS
C
      ENDIF
C
C     -----------------------------------------------------------------|
C*    Section 6.   Gaussian to rotated gaussian
C     -----------------------------------------------------------------|
C
  600 CONTINUE
C
      IF( (LSP2RGG.AND.(NOREPR.EQ.JPFGGROT)) .OR.
     X    (LSP2RGG.AND.(NOREPR.EQ.JPQGGROT)) .OR.
     X    (((NIREPR.EQ.JPQUASI).OR.(NIREPR.EQ.JPGAUSSIAN)) .AND.
     X     (NOREPR.EQ.JPFGGROT).OR.(NOREPR.EQ.JPQGGROT)) ) THEN
        IF( LDEBUG ) CALL INTLOG(JP_DEBUG,
     X    'HNTFAPH: Gaussian to reduced gaussian',JPQUIET)
C
C       Dynamically allocate memory for rotated lat/long grid
C
        ISIZE = NOGAUSS * NOGAUSS * 8 
        CALL JMEMHAN( 11, ISWORK, ISIZE, 1, IRET)
        IF( IRET.NE.0 ) THEN
          IF( LDEBUG ) CALL INTLOG(JP_ERROR,
     X      'HNTFAPH: memory alloc for gaussian grid fail',JPQUIET)
          HNTFAPH = JPROUTINE + 8
          GOTO 900
        ENDIF
C
C       If original field was spectral, ...
C
        IF( LSP2RGG ) THEN
          IRET = HRG2GG(LO12PT,RGGRID,NGAUSS,AREA,POLE,
     X                  NOGAUSS,HOGAUST,SWORK,ISIZE,NUMPTS)
C
        ELSE
C
C       If original field was gaussian, ...
C
          NGAUSS = ISEC2(10)
          IRET = HRG2GG(LO12PT,ZNFELDI,NGAUSS,AREA,POLE,
     X                  NOGAUSS,HOGAUST,SWORK,ISIZE,NUMPTS)
        ENDIF
        IF( IRET.NE.0 ) THEN
          IF( LDEBUG ) CALL INTLOG(JP_ERROR,
     X      'HNTFAPH: HRG2GG rotation failed',JPQUIET)
          HNTFAPH = JPROUTINE + 8
          GOTO 900
        ENDIF
C
        IF( (NOREPR.EQ.JPQUASI).OR.
     X      (NOREPR.EQ.JPQGGROT).OR.
     X      (NOREPR.EQ.JPFGGROT).OR.
     X      (NOREPR.EQ.JPGAUSSIAN) ) THEN
          ISEC2(1) = JPFGGROT
        ELSE
          ISEC2(1) = NOREPR
        ENDIF
C
        ISEC4(1) = NUMPTS
C
      ENDIF
C
C     -----------------------------------------------------------------|
C*    Section 7.   Lat/long to rotated lat/long
C     -----------------------------------------------------------------|
C
  700 CONTINUE
C
      IF( (NIREPR.EQ.JPREGULAR) ) THEN
C
C       Dynamically allocate memory for rotated lat/long grid
C
        NLON = 1 + NINT((AREA(JPEAST)  - AREA(JPWEST)) /
     X         GRID(JPWESTEP))
        NLAT = 1 + NINT((AREA(JPNORTH) - AREA(JPSOUTH)) /
     X         GRID(JPNSSTEP))
C
        NOWE = NLON
        NONS = NLAT
C
        NUMPTS = NLON * NLAT
        ISIZE  = NUMPTS
        CALL JMEMHAN( 11, ISWORK, ISIZE, 1, IRET)
        IF( IRET.NE.0 ) THEN
          IF( LDEBUG ) CALL INTLOG(JP_ERROR,
     X      'HNTFAPH: memory alloc for lat/long grid fail',JPQUIET)
          HNTFAPH = JPROUTINE + 7
          GOTO 900
        ENDIF
C
        OLDGRID(1) = REAL(NIGRID(1))/100000.0
        OLDGRID(2) = REAL(NIGRID(2))/100000.0
        IRET = HLL2LL(LO12PT,ZNFELDI,OLDGRID,AREA,POLE,GRID,SWORK,ISIZE,
     X                NLON,NLAT)
C
        IF( IRET.NE.0 ) THEN
          IF( LDEBUG ) CALL INTLOG(JP_ERROR,
     X      'HNTFAPH: HLL2LL rotation failed',JPQUIET)
          HNTFAPH = JPROUTINE + 7
          GOTO 900
        ENDIF
C
        ISEC2(1) = JPREGROT
        ISEC4(1) = NOWE * NONS
C
      ENDIF
C
C     -----------------------------------------------------------------|
C*    Section 8.   Move rotated field back into field original array.
C     -----------------------------------------------------------------|
C
  800 CONTINUE
C
      DO LOOP = 1, NUMPTS
        ZNFELDI(LOOP) = SWORK(LOOP)
      ENDDO
C
C     -----------------------------------------------------------------|
C*    Section 9.   Closedown.
C     -----------------------------------------------------------------|
C
  900 CONTINUE
C
      RETURN
      END

C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE JVOD2UV( VOR, DIV, KTIN, U, V, KTOUT)
C
C---->
C**** JVOD2UV
C
C     Purpose
C     -------
C
C     Calculate spherical harmonic coefficients of U*cos(lat) and
C     V*cos(lat) at triangular truncation KTOUT, given the coefficients
C     of divergence and vorticity at truncation KTIN.
C 
C
C     Interface
C     ---------
C
C     CALL JVOD2UV( VOR, DIV, KTIN, U, V, KTOUT)
C
C     Input
C     -----
C
C     VOR(KDIM1) = array of vorticity coefficients
C     DIV(KDIM1) = array of divergence coefficients
C     KTIN       = triangular truncation
C                  where KDIM1 = (KTIN+1)*(KTIN+2)
C
C
C     Output
C     ------
C
C     U(KDIM2)   = output array of U*cos(lat) coefficients
C     V(KDIM2)   = output array of V*cos(lat) coefficients
C     KTOUT      = output triangular truncation (KTOUT.le.KTIN)
C                  where KDIM2 = (KTOUT+1)*(KTOUT+4)
C
C
C     Method
C     ------
C
C     ??
C
C
C     Externals
C     ---------
C
C     None.
C
C
C     Author
C     ------
C
C     Jan Haseler       ECMWF      5th January 1981
C
C
C     Modifications
C     -------------
C
C     D. R. Roskilly    ECMWF      5th May 1987
C     Avoid calculating the extra values for U and V components so
C     that vorticity and divergence can be re-calculated if required.
C
C     ??                ??         15th February 1988
C     Subroutine renamed VOD2UV from DVTOUV.
C
C     K.Rider           ECMWF      21st August 1991
C     Version 2 inconsistently truncated U and V to T(ITOUT-1).
C     Changed so that vorticity and divergence are consistently truncated
C     to T105 (sic).
C     U and V are calculated with truncation T(ITOUT),with zero values at
C     the corner.
C     Vorticity and divergence can be recalculated if required, but only
C     truncated to T(ITOUT) since the higher coefficients have been lost.
C
C     J.D.Chambers       ECMWF      26th January 1995
C       Cleaned up code (?!)
C
C----<
C
      IMPLICIT NONE
C
C     Subroutine arguments
      COMPLEX VOR(*), DIV(*), U(*), V(*)
      INTEGER KTIN, KTOUT
C
C     Local variables
      INTEGER K, IMN, ITOUT, JM, JN, JMP, LOOP, SIZE
      REAL REARTH, ZM, ZN
      COMPLEX ZI
C
C     Statement functions
      REAL DD, SS
      REAL PM, PN
      DD(PM,PN) = -SQRT((PN*PN-PM*PM)/(4.*PN*PN-1.))/PN
      SS(PM,PN) = -PM/(PN*(PN+1.))
C
C ------------------------------------------------------------------
C*    Section 1.   Initialise
C ------------------------------------------------------------------
C
  100 CONTINUE
C
      ZI     = (0.0, 1.0)
      REARTH = 6.371E6
      K      = 1
      IMN    = 1
Cjdc  ITOUT  = MIN0(KTOUT,KTIN)
      ITOUT  = KTOUT
      SIZE = (ITOUT+1)*(ITOUT+2)/2
      DO LOOP = 1, SIZE
        U(LOOP) = 0.0
        V(LOOP) = 0.0
      ENDDO
C
C ------------------------------------------------------------------
C*    Section 2.   Handle coefficients for M < ITOUT; N = M
C ------------------------------------------------------------------
C
  200 CONTINUE
C
      DO 255 JM = 1,ITOUT
C
        ZM = JM - 1.0
        ZN = ZM
C
        IF ( JM.GT.1 ) THEN
          U(K) = (-DD(ZM,ZN+1.)*VOR(IMN+1)+ZI*SS(ZM,ZN)*DIV(IMN))*REARTH
          V(K) = ( DD(ZM,ZN+1.)*DIV(IMN+1)+ZI*SS(ZM,ZN)*VOR(IMN))*REARTH
        ELSE
          U(K) = (-DD(ZM,ZN+1.)*VOR(IMN+1))*REARTH
          V(K) = ( DD(ZM,ZN+1.)*DIV(IMN+1))*REARTH
        ENDIF
C
        IMN = IMN + 1
          K =   K + 1
        JMP =  JM + 1
C
C       When N < ITOUT-1
C
        IF (JMP.LT.ITOUT) THEN
          DO 235 JN = JMP, ITOUT-1
            ZN   = JN - 1.0
            U(K) = ( DD(ZM,ZN)*VOR(IMN-1)-DD(ZM,ZN+1)*VOR(IMN+1)
     X              +ZI*SS(ZM,ZN)*DIV(IMN))*REARTH
            V(K) = (-DD(ZM,ZN)*DIV(IMN-1)+DD(ZM,ZN+1)*DIV(IMN+1)
     X              +ZI*SS(ZM,ZN)*VOR(IMN))*REARTH
C
              K  =   K + 1
            IMN  = IMN + 1
C
 235      CONTINUE
C
C         When N = ITOUT - 1
C
          ZN   = ITOUT - 1
          U(K) = ( DD(ZM,ZN)*VOR(IMN-1)+ZI*SS(ZM,ZN)*DIV(IMN))*REARTH
          V(K) = (-DD(ZM,ZN)*DIV(IMN-1)+ZI*SS(ZM,ZN)*VOR(IMN))*REARTH
          K    = K + 1
          IMN  = IMN + 1
        ENDIF
C
C       When N = ITOUT
C
        ZN   = ITOUT
        U(K) = ( DD(ZM,ZN)*VOR(IMN-1))*REARTH
        V(K) = (-DD(ZM,ZN)*DIV(IMN-1))*REARTH
        K    = K + 1
C
C       When N = ITOUT + 1
C
        IMN  = IMN + 1 + KTIN-ITOUT
C
 255  CONTINUE
C
C ------------------------------------------------------------------
C*    Section 3.   Handle coefficients for M = ITOUT.
C ------------------------------------------------------------------
C
  300 CONTINUE
C
C     When N = ITOUT
C
      U(K) = 0.0
      V(K) = 0.0
C
C     Ignore M = ITOUT; N = ITOUT + 1
C
C     K    = K + 1
C
      RETURN
      END

C Copyright 1981-2016 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE FREECF(KFLAG)
C
C---->
C**** FREECF
C
C     PURPOSE
C     _______
C
C     This routine sets the flag controlling handling of spectral
C     to grid interpolation coefficients memory.
C
C
C     INTERFACE
C     _________
C
C     CALL FREECF(KFLAG)
C
C     Input parameters
C     ________________
C
C     KFLAG - Flag indicating whether flushing of memory is done or not
C              = 1 to turn on flushing
C              = any other value to turn off flushing (default)
C
C
C     Output parameters
C     ________________
C
C     None
C
C
C     Common block usage
C     __________________
C
C     JDCSPGP - flag LFREECF
C
C
C     Method
C     ______
C
C     Sets flags LFREECF and NFREECF
C
C
C     Externals
C     _________
C
C     None
C
C
C     Reference
C     _________
C
C     None
C
C
C     Comments
C     ________
C
C     None.
C
C
C     AUTHOR
C     ______
C
C     J.D.Chambers       ECMWF       March 1998
C
C
C     MODIFICATIONS
C     _____________
C
C     None
C
C----<
C
      IMPLICIT NONE
C
#include "jparam2.h"
C
C     Subroutine arguments
C
      INTEGER KFLAG
C
      IF( KFLAG.EQ.1 ) THEN
        LFREECF = .TRUE.
        NFREECF = 11041967
      ELSE
        LFREECF = .FALSE.
        NFREECF = 11041967
      ENDIF
C
      RETURN
      END

       PROGRAM MAKESTATION
C
C**** *MAKESTATION*
C
C
C     PURPOSE.
C     --------
c
C         Extract data from Empress WMO VOL A DB
c         to create binary station list for preprocessing.
c
C**   INTERFACE.
C     ----------
C
C         none.
C
C     METHOD.
C     -------
C
C          NONE.
C
C
C     EXTERNALS.
C     ----------
C
C
C     REFERENCE.
C     ----------
C
C          NONE.
C
C     AUTHOR.
C     -------
C
C          M. DRAGOSAVAC    *ECMWF*       15/01/94.
C
C
C     MODIFICATIONS.
C     --------------
C
C          NONE.
C
C
c     ------------------------------------------------------------------
c           1. Initialize Empress Data Base.
c              -----------------------------
 100  continue
c
c
c*          2. Select data for analysis.
c              -------------------------
 200  continue
c
      call station
c
c*          3. Clean up.
c              ---------
 300  continue
c
c
c     stop
      end
      SUBROUTINE STATION
C
C
C**** *STATION*
C
C
C     PURPOSE.
C     --------
c
C         CREATE PACKED FORM OF WMO STATION LIST
C         FOR PREPROCESSING. 
c
C**   INTERFACE.
C     ----------
C
C         none.
C
C     METHOD.
C     -------
C
C          NONE.
C
C
C     EXTERNALS.
C     ----------
C
C          *Empress data base routines*
C
C     REFERENCE.
C     ----------
C
C          NONE.
C
C     AUTHOR.
C     -------
C
C          M. DRAGOSAVAC    *ECMWF*       03/02/94.
C
C
C     MODIFICATIONS.
C     --------------
C
C          NONE.
C
C
      IMPLICIT LOGICAL(L,O,G), CHARACTER*8(C,H,Y)
C
      character*12 ctabname
c
      character*2 cwsbn,csp00,csp03,csp06,csp09,csp12,csp15
      character*2 csp18,csp21
      character*1 cpef,cgef,cps
      character*4 cstha,csthp
      character*1 cuat00,cuat06,cuat12,cuat18
c
      character*120 cline
      dimension iclist(50),implis(2000),in(10) 
      dimension iparams(39000),ipoints(128)
c
      integer*2 ipcode,iblock
      integer*4 isthp,istha
c
c              list of countries reporting wind in m/S.
c
      data iclist/2070,6250,2200,2250,4300,3010,6190,4110,1170,1200,
     1            6164,6210,4070,4240,3030,2060,2050,2230,1460,2126,
     2            2140,4040,1440,4190,5420,6200,2176,6240,1260,6320,
     3            2010,6310,3020,2220,6220,4170,14*0/
C 
      data ipoints/128*0/,iparams/39000*0/,implis/2000*0/
c
C     ------------------------------------------------------------------
c
c*          1.  Open target file and input files required
c               for station list creation.
 100  continue
c
c     Get return code from Empress under user control.
c
      ncount=50
c
c*          1.1 Open file containing list of important stations.
c               ------------------------------------------------
 110  continue
c
      open(unit=20,file='important_stations.dat',iostat=ios,
     1             form='formatted',
     2             recl=80,status='old')
      if(ios .ne.0) then
         print*,'Error opening important_stations file.'
         call exit(2)
      end if
c
c
c*          1.2 Open station file for binary station list.
c               ------------------------------------------
 120  continue
c
      open(unit=24,file='station_amend.dat',iostat=ios,
     1             form='unformatted',status='new')
c
      if(ios .ne.0) then
         print*,'Error opening station_amend.dat file.'
         call exit(2)
      end if
c
c           1.2.1 Open wmo station list
c                 ---------------------
      open(unit=28,file='wmo.txt',iostat=ios,
     1             form='formatted',
     2             recl=120,status='old')
      if(ios .ne.0) then
         print*,'Error opening wmo.txt file.'
         call exit(2)
      end if

c
C*           1.3 Read in important station list.
C                ------------------------------
 130  continue
c
      J=0
c
 131  continue
      read(20,'(10(1x,i5))',iostat=ios,err=133,end=134) (in(i),i=1,10)
C
      DO 132 i=1,10
      j=j+1 
      implis(j)=in(i)
 132  continue
C
      go to 131
C
 133  continue
C
      print*,'Read error ',ios,'  on file important_stations.dat'
      call exit(2)
C
 134  continue 

      nimp=j
      icount=0
C   
      nwpt=1
      nbpt=0
C
      ipoints(1)=1
c
c*           2. Open WMO database.
c               ------------------
 200  continue
c
c
      iblockold=0
      i=0
      read(28,'(a)') cline
c
c*            2.2 Read data
c                 --------------
 220  continue
c
      isthp=0
      istha=0
      read(28,fmt=8888,iostat=ios,end=300) irgcoun, iblock,
     1                                     istno, rlat, rlon,
     2                                     isthp, istha ,ipcode,
     3                                     csp00,csp03,csp06,
     4                                     csp09,csp12,csp15,
     5                                     csp18,csp21,
     6                                     cuat00,cuat06,cuat12,
     7                                     cuat18
c
 8888 format(i4,1x,i2,1x,i3,1x,f7.2,1x,f7.2,1x,i4,1x,i4,1x,i1,
     1       1x,8(a2,1x),4(a,1x))
c
          if(iblockold.ne.iblock) then
             i=iblock
             ipoints(i)=nwpt
             do ii=i,1,-1
             if(ipoints(ii).eq.0) ipoints(ii)=nwpt
             end do
             iblockold=iblock
          end if
c
c         wmo region and country
c
          print*,'region_country=',irgcoun
c
c         Wmo region and country number
c
          irn=irgcoun/1000
          icoun=irgcoun-irn*1000
c
c         wmo block number
c
          print*,'block=',iblock
c
c         wmo station number
c
c
          print*,'block/station ',iblock,istno
c
c         type of station
c
c
c         latitude
c
c         latitude in hundreds of degree. All values positive.Sign
c         given by isglat 0-positive 1-negative
c
          isglat=0
          ilat=nint(rlat*100)
          if(ilat.lt.0) then
             isglat=1
             ilat=iabs(ilat)
          end if
c
c         longitude
c
c         longitude in hundreds of degree from 0-360
c
          ilon=nint(rlon*100)
          if(ilon.lt.0) ilon=36000-iabs(ilon)
c
c         check if pole
c
          if(ilat.eq.9000) ilon=0
c
c         pressure elevation
c
c
c         pressure elevation flag
c
c         ground elevation
c
          if(istha.gt.9000) then
             print*,'istha > 9000 error'
             call exit(2)
          end if
c
c         ground elevation flag
c
c
c         pressure level
c
c         observing practice
c
c
          icount=icount+1
c
c
c
c         knms - 0    wind in knots
c              - 1    wind in m/s       
C
          knms=0
          do 221 j=1,ncount
          if(iclist(j).eq.irgcoun) knms=1
 221      continuE
c     
c         station pressure elevation.
c         ---------------------------
c
c         h/p station pressure elevation or ground elevation if h/p
c         does not exist. if both are missing 9999 is given.
c
          ist_height=9999
c
          if(isthp.ne.0) then
             ist_height=isthp
          else 
             if(istha.ne.0) then
                ist_height=istha
             end if
          end if
c
c         sign of station heigth
c
          idsign=0
          if(ist_height.lt.0) then
            ist_height=iabs(ist_height)
            idsign=1
          end if
c
          istind=0
c
          if(iblock.ge.60.and.iblock.le.68) istind=1
          if(iblock.ge.80.and.iblock.le.89) istind=1
c
          if(istind.eq.1) go to 230
c
          do 222 jj=1,nimp
          if(istno.eq.implis(jj)) istind=1
 222      continue
c     
c         type of station.
c         ----------------
c 
 230      continue
c
          itype1=0
          itype2=0
          itype3=0
c
          if(csp00.eq.'X') itype3=1
          if(csp03.eq.'X') itype3=1
          if(csp06.eq.'X') itype3=1
          if(csp09.eq.'X') itype3=1
          if(csp12.eq.'X') itype3=1
          if(csp15.eq.'X') itype3=1
          if(csp18.eq.'X') itype3=1
          if(csp21.eq.'X') itype3=1
c
          if(cuat00.eq.'1'.or.cuat00.eq.'3'.or.
     1       cuat00.eq.'5'.or.cuat00.eq.'6') itype2=1
          if(cuat06.eq.'1'.or.cuat06.eq.'3'.or.
     1       cuat06.eq.'5'.or.cuat06.eq.'6') itype2=1
          if(cuat12.eq.'1'.or.cuat12.eq.'3'.or.
     1       cuat12.eq.'5'.or.cuat12.eq.'6') itype2=1
          if(cuat18.eq.'1'.or.cuat18.eq.'3'.or.
     1       cuat18.eq.'5'.or.cuat18.eq.'6') itype2=1
c
          if(cuat00.eq.'2'.or.cuat00.eq.'4') itype1=1
          if(cuat06.eq.'2'.or.cuat06.eq.'4') itype1=1
          if(cuat12.eq.'2'.or.cuat12.eq.'4') itype1=1
          if(cuat18.eq.'2'.or.cuat18.eq.'4') itype1=1

c
c 
c         pack information into iparams array.
c         every station informatio into three 32 bit words.
c
c
          ipp=ipcode
          call pack(32,iparams(nwpt),istno ,nwpt,nbpt,10)
          call pack(32,iparams(nwpt),0     ,nwpt,nbpt,06)
          call pack(32,iparams(nwpt),ipp   ,nwpt,nbpt,04)
          call pack(32,iparams(nwpt),knms  ,nwpt,nbpt,01)
          call pack(32,iparams(nwpt),0     ,nwpt,nbpt,03)
          call pack(32,iparams(nwpt),ist_height,nwpt,nbpt,14)
c-------------------------------------------------------------2/6
          call pack(32,iparams(nwpt),idsign,nwpt,nbpt,02)
          call pack(32,iparams(nwpt),ilon  ,nwpt,nbpt,16)
          call pack(32,iparams(nwpt),ilat  ,nwpt,nbpt,14)
c-------------------------------------------------------------3/6
          call pack(32,iparams(nwpt),isglat,nwpt,nbpt,01)
          call pack(32,iparams(nwpt),0     ,nwpt,nbpt,01)
          call pack(32,iparams(nwpt),irn   ,nwpt,nbpt,03)
          call pack(32,iparams(nwpt),icoun ,nwpt,nbpt,10)
          call pack(32,iparams(nwpt),0     ,nwpt,nbpt,03)
          call pack(32,iparams(nwpt),1     ,nwpt,nbpt,01)
          call pack(32,iparams(nwpt),istind,nwpt,nbpt,01)
          call pack(32,iparams(nwpt),itype1,nwpt,nbpt,01)
          call pack(32,iparams(nwpt),itype2,nwpt,nbpt,01)
          call pack(32,iparams(nwpt),itype3,nwpt,nbpt,01)
          call pack(32,iparams(nwpt),0     ,nwpt,nbpt,03)
c
          print*,'istno   =',istno
          print*,'ipcode  =',ipcode
          print*,'knms    =',knms
          print*,'id      =',ist_height
          print*,'ilon    =',ilon
          print*,'ilat    =',ilat
          print*,'isglat  =',isglat
          print*,'irn     =',irn
          print*,'icoun   =',icoun
          print*,'istind  =',istind 
          print*,'itype1  =',itype1
          print*,'itype2  =',itype2
          print*,'itype3  =',itype3
          print*,'--------------------------end'
c
          go to 220
c
c*          3. Clean table request.
c              --------------------
 300  continue
c
c
      print*,'Number of stations retreived ',icount
c
c
c     -------------------------------------------------------------------
c*          4.  write amended stations and close the file.
c               ------------------------------------------
 400  continue
c
c     open(unit=24,err=401,iostat=ios,
c    1             file='station_amend.dat',
c    1             form='unformatted',status='new')
c
      print*,ipoints 
      write(24) iparams,ipoints
c
      close(24)
c
      go to 410
c
 401  continue
c
      print*,'Error opening station_amend.dat'
      call exit(2)
c     -------------------------------------------------------------------
c*          4.1 close the file.
c               ---------------
 410  continue
c
      close(24)
c
c 
c
      return
      end
      SUBROUTINE PACK(KBPW,KD,KS,KWPT,KBPT,KSI)
C
C
C**** *PACK*
C
C
C     PURPOSE.
C     --------
C            PURPOSE OF THIS ROUTINE IS TO PACK VALUE *KS* IN
C         *KSI* BITS, STARTED AT WORD KWPT OF ARRAY *KD* AFTER
C         SKIPPING NBPT BITS.  AT THE END
C         POINTERS *NWPT* AND *NBPT* ARE ADJUSTED.
C
C**   INTERFACE.
C     ----------
C
C     *CALL* *PACK(KBPW,KD,KS,KWPT,KBPT,KSI)*
C
C            *KD*    - DESTINATION ARRAY.
C            *KS*    - SOURCE
C            *KSI*   - NUMBER OF BITS ACCUPIED BY KS.
C
C     *METHOD.
C      -------
C
C            NONE.
C
C
C     EXTERNALS.
C     ----------
C
C
C            *CALL SBYTE(KD,KS,KBPT,KSI)*
C
C            *KD*    - DESTINATION ARRAY.
C            *KS*    - SOURCE
C            *KBPT*  - POINTER TO BIT IN THE KD(KWPT)
C            *KSI*   - NUMBER OF BITS ACCUPIED BY KS.
C
C
C
C
C     REFERENCE.
C     ----------
C
C          NONE.
C
C     AUTHOR.
C     -------
C
C          M. D. DRAGOSAVAC    *ECMWF*       09/06/86.
C
C
C     MODIFICATIONS.
C     --------------
C
C          NONE.
C
C
      IMPLICIT LOGICAL(L,O,G), CHARACTER*8(C,H,Y)
C
C
      DIMENSION KD(*)
C
C     ------------------------------------------------------------------
C*          1.   SET UP BIT PATTERN.
C                -------------------
C
 100  CONTINUE
C
      CALL SBYTE(KD,KS,KBPT,KSI)
C
C     ------------------------------------------------------------------
C*          1.1  UPDATE WORD AND BIT POINTERS.
C                -----------------------------
 110  CONTINUE
C
      KBPT = KBPT + KSI
C
      IF(KBPT.GE.KBPW) THEN
                          KW  = KBPT/ KBPW
                          KBPT= KBPT - KW * KBPW
                          KWPT= KWPT +KW
                       END IF
C
      RETURN
      END

C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      INTEGER FUNCTION IAOLDEF (PWEST, PEAST, PNORTH, PSOUTH,
     1   PNSINC, PWEINC, KAREA, OCHNG, OIWEGLOBE, OINPOLE, OISPOLE,
     2   KIAREA, KPR, KERR)
C
C---->
C**** *IAOLDEF*
C
C     PURPOSE
C     _______
C
C     Set the output field definition variables for a regular
C     latitude longitude field.
C
C     INTERFACE
C     _________
C
C     IERR = IAOLDEF (PWEST, PEAST, PNORTH, PSOUTH, PNSINC, PWEINC,
C    1   KAREA, OCHNG, OIWEGLOBE, OINPOLE, OISPOLE, KIAREA, KPR, KERR)
C
C     Input parameters
C     ________________
C
C     PWEST      - The Western limit of the output field area.
C
C     PEAST      - The Eastern limit of the output field area.
C
C     PNORTH     - The Northern limit of the output field area.
C
C     PSOUTH     - The Southern limit of the output field area.
C
C     PNSINC     - The North-South stride for the output field.
C
C     PWEINC     - The West-East stride for the output field.
C
C     KAREA      - The previous output field area used for checking
C                  for definition changes.
C
C     OIWEGLOBE  - Flag indicating whether the INPUT field spans the
C                  globe in the West-East direction.
C
C     OINPOLE    - Flag indicating whether the INPUT field includes
C                  the North polar line of latitude.
C
C     OISPOLE    - Flag indicating whether the INPUT field includes
C                  the South polar line of latitude.
C
C     KIAREA     - The input field area which will be used for an
C                  uninitialised output field area when the input
C                  field is not global.
C
C     KPR        - The debug print switch.
C                  0  , No debugging output.
C                  1  , Produce debugging output.
C
C     KERR       - The error control flag.
C                  -ve, No error message. Return error code.
C                  0  , Hard failure with error message.
C                  +ve, Print error message. Return error code.
C
C     Output parameters
C     ________________
C
C     KAREA      - The output field area if the definition has changed.
C
C     OCHNG      - A flag variable indicating whether the definition
C                  has changed.
C
C     Return value
C     ____________
C
C     The error indicator (INTEGER).
C
C     Error and Warning Return Values
C     _______________________________
C
C     None
C
C     Common block usage
C     __________________
C
C     nofld.common - This file contains all the output field
C                    definition variables.
C
C     NOGRID       - Output field grid definition (WE/NS) is set.
C     NOREPR       - Output field representation is set.
C     NOSCNM       - Output field scanning mode is set.
C
C     EXTERNALS
C     _________
C
C     INTLOG     - Logs messages.
C
C     METHOD
C     ______
C
C     Check the output definition against the previous definition and
C     update appropriate definition variables.
C
C     REFERENCE
C     _________
C
C     None
C
C     COMMENTS
C     ________
C
C     Program contains sections 0 to 3 and 9
C
C     AUTHOR
C     ______
C
C     K. Fielding      *ECMWF*      Apr 1994
C
C     MODIFICATIONS
C     _____________
C
C     None
C
C----<
C     _______________________________________________________
C
C
C*    Section 0. Definition of variables.
C     _______________________________________________________
C
C*    Prefix conventions for variable names
C
C     Logical      L (but not LP), global or common.
C                  O, dummy argument
C                  G, local variable
C                  LP, parameter.
C     Character    C, global or common.
C                  H, dummy argument
C                  Y (but not YP), local variable
C                  YP, parameter.
C     Integer      M and N, global or common.
C                  K, dummy argument
C                  I, local variable
C                  J (but not JP), loop control
C                  JP, parameter.
C     REAL         A to F and Q to X, global or common.
C                  P (but not PP), dummy argument
C                  Z, local variable
C                  PP, parameter.
C
C     Implicit statement to force declarations
C
      IMPLICIT NONE
C
#include "parim.h"
#include "nofld.common"
C
C     Subroutine arguments
      LOGICAL OCHNG, OIWEGLOBE, OINPOLE, OISPOLE
      INTEGER KPR, KERR
      INTEGER KAREA (4), KIAREA (4)
      REAL PWEST, PEAST, PNORTH, PSOUTH, PNSINC, PWEINC
C
C     Local variables
      LOGICAL GLOBE
      INTEGER INORTH, ISOUTH, IWEST, IEAST, IWEINC, INSINC, IWETMP,
     1   INSTMP, ITEMP
      INTEGER IERR
      INTEGER JPROUTINE
      PARAMETER (JPROUTINE = 21400)
C
C     External functions
C
C     Transform definition variables that must be preserved
C
C     _______________________________________________________
C
C*    Section 1. Initialisation
C     _______________________________________________________
C
  100 CONTINUE
C
      IF (KPR.GE.1) CALL INTLOG(JP_DEBUG,'IAOLDEF: Section 1.',JPQUIET)
C
      IAOLDEF = 0
C
      IERR = 0
C
      OCHNG = .FALSE.
C
      GLOBE = OIWEGLOBE .AND. OINPOLE .AND. OISPOLE
C
      IF (KPR .GE. 1) THEN
        CALL INTLOG(JP_DEBUG,'IAOLDEF: Input parameters.',JPQUIET)
        CALL INTLOGR(JP_DEBUG,'IAOLDEF: W-E increment is ',PWEINC)
        CALL INTLOGR(JP_DEBUG,'IAOLDEF: N-S increment is ',PNSINC)
        CALL INTLOGR(JP_DEBUG,'IAOLDEF: AREA North ',PNORTH)
        CALL INTLOGR(JP_DEBUG,'IAOLDEF: AREA West ',PWEST)
        CALL INTLOGR(JP_DEBUG,'IAOLDEF: AREA South ',PSOUTH)
        CALL INTLOGR(JP_DEBUG,'IAOLDEF: AREA East ',PEAST)
      ENDIF
C
C     _______________________________________________________
C
C
C*    Section 2. Convert parameters to integer
C     _______________________________________________________
C
  200 CONTINUE
C
      IF (KPR.GE.1) CALL INTLOG(JP_DEBUG,'IAOLDEF: Section 2.',JPQUIET)
C
C     Representation
C
      IF (NOREPR .NE. JPREGULAR) THEN
         NOREPR = JPREGULAR
         OCHNG = .TRUE.
      ENDIF
C
      NOSCNM = 0
C
C     North, South, West and East limits
C
      INORTH = NINT (PNORTH * PPMULT)
      ISOUTH = NINT (PSOUTH * PPMULT)
      IWEST = NINT (PWEST * PPMULT)
      IEAST = NINT (PEAST * PPMULT)
C
C     Direction increments for regular grids
C
      IWEINC = NINT (ABS (PWEINC) * PPMULT)
      IWEINC = MAX (IWEINC, JPMIN)
C
      INSINC = NINT (ABS (PNSINC) * PPMULT)
      INSINC = MAX (INSINC, JPMIN)
C
C     _______________________________________________________
C
C
C*    Section 3. Adjust grid stride and area
C     _______________________________________________________
C
  300 CONTINUE
C
      IF (KPR.GE.1) CALL INTLOG(JP_DEBUG,'IAOLDEF: Section 3.',JPQUIET)
C
C     Global field if all area limits are 0
C
      IF (INORTH .EQ. 0 .AND. ISOUTH .EQ. 0 .AND.
     1   IWEST .EQ. 0 .AND. IEAST .EQ. 0) THEN
C
         IF (GLOBE) THEN
C
  310 CONTINUE
            IF (MOD (JP90, IWEINC) .EQ. 0) GO TO 320
               IWEINC = IWEINC - 1
               GO TO 310
  320 CONTINUE
C
            IF (MOD (JP90, INSINC) .EQ. 0) GO TO 330
               INSINC = INSINC - 1
               GO TO 320
  330 CONTINUE
C
            INORTH = JP90
            ISOUTH = - JP90
            IWEST = 0
            IEAST = JP360 - IWEINC
C
         ELSE
C
            IF (OINPOLE) THEN
               INORTH = JP90
            ELSE
               INORTH = KIAREA (JPNORTH)
            ENDIF
C
            IF (OISPOLE) THEN
               ISOUTH = - JP90
            ELSE
               ISOUTH = KIAREA (JPSOUTH)
            ENDIF
C
            IF (OIWEGLOBE) THEN
C
  340 CONTINUE
               IF (MOD (JP90, IWEINC) .EQ. 0) GO TO 350
                  IWEINC = IWEINC - 1
                  GO TO 340
  350 CONTINUE
C
               IWEST = 0
               IEAST = JP360 - IWEINC
            ELSE
               IWEST = KIAREA (JPWEST)
               IEAST = KIAREA (JPEAST)
C
  360 CONTINUE
               IF (MOD (IEAST - IWEST, IWEINC) .EQ. 0) GO TO 370
                  IWEINC = IWEINC - 1
                  GO TO 360
  370 CONTINUE
C
            ENDIF
C
  380 CONTINUE
            IF (MOD (INORTH - ISOUTH, INSINC) .EQ. 0) GO TO 390
               INSINC = INSINC - 1
               GO TO 380
  390 CONTINUE
C
         ENDIF
      ELSE
C
C     Try to produce fields representable in GRIB for 0.5625 degree
C     strides
C
         IF (IEAST .LT. IWEST) THEN
            IF (IEAST .LE. 0) THEN
               IEAST = IEAST + JP360
            ELSE
               IWEST = IWEST - JP360
            ENDIF
         ENDIF
C
         GLOBE = IEAST - IWEST + IWEINC .EQ. JP360 .OR.
     1      IEAST - IWEST + IWEINC .EQ. 0
C
         IF (MOD (IWEINC, 10) .EQ. 5 .AND. .NOT. GLOBE) THEN
            IWETMP = IWEINC * 2
         ELSE
            IWETMP = IWEINC
         ENDIF
C
         IF (MOD (IEAST - IWEST, IWETMP) .NE. 0) THEN
C
            IF (MOD (IEAST, IWETMP) .NE. 0) THEN
C
               ITEMP = ABS (IEAST) / IWETMP
C
               IF (IEAST .GT. 0) THEN
                  IEAST = (ITEMP + 1) * IWETMP
                  IF (IEAST .GT. JP360) IEAST = IEAST - IWETMP
               ELSE
                  IEAST = - ITEMP * IWETMP
               ENDIF
            ENDIF
C
            IF (MOD (IWEST, IWETMP) .NE. 0) THEN
C
               ITEMP = ABS (IWEST) / IWETMP
C
               IF (IWEST .LT. 0) THEN
                  IWEST = - (ITEMP + 1) * IWETMP
                  IF (IWEST .LT. - JP360) IWEST = IWEST + IWETMP
               ELSE
                  IWEST = ITEMP * IWETMP
               ENDIF
            ENDIF
         ENDIF
C
         IF (MOD (INSINC, 10) .EQ. 5) THEN
            INSTMP = INSINC * 2
         ELSE
            INSTMP = INSINC
         ENDIF
C
         IF (MOD (INORTH - ISOUTH, INSTMP) .NE. 0) THEN
C
            IF (MOD (INORTH, INSTMP) .NE. 0) THEN
C
               ITEMP = ABS (INORTH) / INSTMP
C
               IF (INORTH .GT. 0) THEN
                  INORTH = (ITEMP + 1) * INSTMP
                  IF (INORTH .GT. JP90) INORTH = INORTH - INSTMP
               ELSE
                  INORTH = - ITEMP * INSTMP
               ENDIF
            ENDIF
C
            IF (MOD (ISOUTH, INSTMP) .NE. 0) THEN
C
               ITEMP = ABS (ISOUTH) / INSTMP
C
               IF (ISOUTH .LT. 0) THEN
                  ISOUTH = - (ITEMP + 1) * INSTMP
                  IF (ISOUTH .LT. - JP90) ISOUTH = ISOUTH + INSTMP
               ELSE
                  ISOUTH = ITEMP * INSTMP
               ENDIF
            ENDIF
         ENDIF
C
      ENDIF
C
      IF (NOGRID (JPWESTEP) .NE. IWEINC) THEN
         NOGRID (JPWESTEP) = IWEINC
         OCHNG = .TRUE.
      ENDIF
C
      IF (NOGRID (JPNSSTEP) .NE. INSINC) THEN
         NOGRID (JPNSSTEP) = INSINC
         OCHNG = .TRUE.
      ENDIF
C
      IF (KAREA (JPNORTH) .NE. INORTH) THEN
         KAREA (JPNORTH) = INORTH
         OCHNG = .TRUE.
      ENDIF
C
      IF (KAREA (JPSOUTH) .NE. ISOUTH) THEN
         KAREA (JPSOUTH) = ISOUTH
         OCHNG = .TRUE.
      ENDIF
C
      IF (IWEST .NE. KAREA (JPWEST) ) THEN
         KAREA (JPWEST) = IWEST
         OCHNG = .TRUE.
      ENDIF
C
      IF (IEAST .NE. KAREA (JPEAST) ) THEN
         KAREA (JPEAST) = IEAST
         OCHNG = .TRUE.
      ENDIF
C
      IF (KPR .GE. 1) THEN
        CALL INTLOG(JP_DEBUG,
     X    'IAOLDEF: Output field definition parameters.',JPQUIET)
        CALL INTLOG(JP_DEBUG,
     X    'IAOLDEF: Representation is ',NOREPR)
        CALL INTLOG(JP_DEBUG,
     X    'IAOLDEF: Grid W-E is ', NOGRID(1))
        CALL INTLOG(JP_DEBUG,
     X    'IAOLDEF: Grid N-S is ', NOGRID(2))
        CALL INTLOG(JP_DEBUG,
     X    'IAOLDEF: Area North is ',KAREA(1))
        CALL INTLOG(JP_DEBUG,
     X    'IAOLDEF: Area West  is ',KAREA(2))
        CALL INTLOG(JP_DEBUG,
     X    'IAOLDEF: Area South is ',KAREA(3))
        CALL INTLOG(JP_DEBUG,
     X    'IAOLDEF: Area East  is ',KAREA(4))
C
        IF ( OCHNG ) THEN
          CALL INTLOG(JP_DEBUG,
     X      'IAOLDEF: Output field change is TRUE.',JPQUIET)
        ELSE
          CALL INTLOG(JP_DEBUG,
     X      'IAOLDEF: Output field change is FALSE.',JPQUIET)
        ENDIF
C
      ENDIF
C
C     _______________________________________________________
C
C
C*    Section 9. Return to calling routine. Format statements
C     _______________________________________________________
C
  900 CONTINUE
C
      IF (KPR.GE.1) CALL INTLOG(JP_DEBUG,'IAOLDEF: Section 9.',JPQUIET)
C
      RETURN
      END

C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      INTEGER FUNCTION INTUVP( KVGRIB, KDGRIB, INLEN,
     X                         KUGRIBO, KVGRIBO, OUTLEN)
C
C---->
C**** INTUVP
C
C     Purpose
C     -------
C
C     Interpolate GRIB format input vorticity and divergence field to
C     GRIB format U and V fields.
C
C
C     Interface
C     ---------
C
C     IRET = INTUVP(KVGRIB,KDGRIB,INLEN,KUGRIBO,KVGRIBO,OUTLEN)
C
C     Input
C     -----
C
C     KVGRIB - Input vorticity field  (spectral, GRIB format).
C     KDGRIB - Input divergence field (spectral, GRIB format).
C     INLEN  - Input field length (words).
C
C
C     Output
C     ------
C
C     KUGRIBO - Output U field (GRIB format).
C     KVGRIBO - Output V field (GRIB format).
C     OUTLEN  - Length of each output U and V field (words).
C
C
C     Method
C     ------
C
C     Convert spectral vorticity/divergence to spectral U/V and then
C     interpolate U and V to output fields.
C
C     Note that a common block is used in intf.h to hold the U/V
C     fields before interpolation.
C
C     Externals
C     ---------
C
C     IBASINI - Ensure basic interpolation setup is done.
C     INTUVDH - Encodes/decodes data into/from GRIB code.
C     INTUVXH - Interpolate U and V spectral components to grid point.
C     JVOD2UV - Converts spectral vorticity/divergence to spectral U/V.
C     JMEMHAN - Allocate scratch memory.
C     ISCRSZ  - Calculate number of values in generated field.
C     FIXAREA - Fixup area definition to correspond to grid definitions
C     INTLOG  - Log error message.
C     RESET_C - Reset interpolation handling options using GRIB product.
C     INSANE  - Ensure no outrageous values given for interpolation.
C     GRSMKP  - P factor calculation switch for routine GRIBEX.
C
C
C     Author
C     ------
C
C     J.D.Chambers     ECMWF     February 2001
C     Rewritten to use more functions for processing.
C
C
C----<
C     -----------------------------------------------------------------|
C
      IMPLICIT NONE
C
C     Function arguments
C
      INTEGER KVGRIB(*), KDGRIB(*), INLEN
      INTEGER KUGRIBO(*), KVGRIBO(*), OUTLEN
C
#include "parim.h"
#include "nifld.common"
#include "nofld.common"
#include "grfixed.h"
#include "intf.h"
C
C     Parameters
C
      INTEGER JPROUTINE, JPALLOC, JPDEALL, JPSCR3, JPSCR4,JPSCR5
      INTEGER JPVORT, JPDIVE
      PARAMETER (JPROUTINE = 26900 )
      PARAMETER (JPALLOC = 1) 
      PARAMETER (JPDEALL = 0) 
      PARAMETER (JPSCR3 = 3) 
      PARAMETER (JPSCR4 = 4) 
      PARAMETER (JPSCR5 = 5) 
      PARAMETER (JPVORT = 138) 
      PARAMETER (JPDIVE = 155) 
C
C     Local variables
C
      CHARACTER*1 HFUNC
      REAL EW, NS, DUMMY
      LOGICAL LOLDWIND, LSPECUV
      INTEGER IERR,KPR,ISZVD,ISZUV,IWORD,ISIZE,ILENF,ISAME,IDIVOFF
      INTEGER NEXT, LOOP, MTRUNC, NTRUNC, NTROLD, NTROLD2, NPARAM
      INTEGER NOLD, NLEN, NLENU, NLENV, HNORESO
      INTEGER INRESO, IHOLD
      LOGICAL LSTYLE
      REAL NORTH, SOUTH, WEST, EAST
C
      LOGICAL LFIRST, LNEWUV
      CHARACTER*3 EXTRA
      DATA LFIRST/.TRUE./, LNEWUV/.TRUE./, EXTRA/'NO '/
      SAVE LFIRST, LNEWUV
C
      DATA NTROLD/-1/, NTROLD2/-1/
      SAVE NTROLD, NTROLD2
      INTEGER IPVORT, IPDIV, IP_U, IP_V
#ifndef _CRAYFTN
#ifdef POINTER_64
      INTEGER*8 IZNFLDO
#endif
#endif
      REAL ZNFLDO
      POINTER ( IZNFLDO, ZNFLDO )
      DIMENSION ZNFLDO( 1 )
#ifndef _CRAYFTN
#ifdef POINTER_64
      INTEGER*8 IUV, IVD
#endif
#endif
      REAL UV, VD
      POINTER ( IUV, UV )
      POINTER ( IVD, VD )
      DIMENSION UV( 1 ), VD( 1 )
C
C     Externals
C
      INTEGER RESET_C,ISCRSZ,FIXAREA,AURESOL,DSSAREA
      INTEGER IBASINI, INSANE, INTUVDH, INTUVXH
      INTEGER INTUVPH, INTUVGH
C
C     -----------------------------------------------------------------|
C*    Section 1.   Initialise
C     -----------------------------------------------------------------|
C
  100 CONTINUE
      INTUVP = 0
      IERR    = 0
      KPR     = 0
C
      IF( LFIRST ) THEN
        CALL GETENV('IGNORE_UV_EXTRA_MODE', EXTRA)
        IF((EXTRA(1:1).EQ.'Y').OR.(EXTRA(1:1).EQ.'y')) LNEWUV = .FALSE.
        IF( LNEWUV ) THEN
          CALL INTLOG(JP_DEBUG,
     X      'INTUVP: IGNORE_UV_EXTRA_MODE not turned on',JPQUIET)
        ELSE
          CALL INTLOG(JP_DEBUG,
     X      'INTUVP: IGNORE_UV_EXTRA_MODE turned on',JPQUIET)
        ENDIF
        LFIRST = .FALSE.
      ENDIF
C
      LOLDWIND = LWINDSET
cs      LSPECUV = (NOREPR.EQ.JPSPHERE).OR.(NOREPR.EQ.JPSPHROT)
C
C     Ensure that basic initialisation has been done
C
      IERR = IBASINI(0)
      IF( IERR.NE.0 ) THEN
        CALL INTLOG(JP_ERROR,'INTUVP: basic initialise failed',JPQUIET)
        INTUVP = IERR
        GOTO 990
      ENDIF
C
C     Establish truncation of the input vorticity and divergence:
C     unpack GRIB sections 1 and 2.
C
      NPARAM = JPVORT
      ISZVD = 1
      NLEN = INLEN
      IERR = INTUVDH(DUMMY,ISZVD,KVGRIB,NLEN,'I',NPARAM)
      IF( IERR.NE.0 ) THEN
        CALL INTLOG(JP_ERROR,'INTUVP: GRIB header decode failed',IERR)
        INTUVP = IERR
        GOTO 990
      ENDIF
C
C     If a rotation is required, check the input fields and call the
C     appropriate interpolation
C
      IF( LUSEHIR.AND.LNOROTA ) THEN
cs        LWIND = .TRUE.
cs        LWINDSET = .TRUE.
cs        IF( (ISEC1(6).EQ.JPVORT).AND.(ISEC2(1).EQ.JPSPHERE) ) THEN
csC
csC         Spectral vorticity/divergence to rotated U and V
csC
cs          NLEN  = INLEN
cs          NLENU = OUTLEN
cs          NLENV = OUTLEN
cs          IERR = INTUVPH(KVGRIB,KDGRIB,NLEN,KUGRIBO,KVGRIBO,
cs     X                   NLENU,NLENV)
C
cs        ELSE IF( ((ISEC1(6).EQ.JP_U).OR.(ISEC1(6).EQ.JP_10U)).AND.
cs        IF( ((ISEC1(6).EQ.JP_U).OR.(ISEC1(6).EQ.JP_10U)).AND.
        IF( (ISEC1(6).EQ.JP_10U).AND.
     X           (ISEC2(1).EQ.JPGAUSSIAN) ) THEN
C
C         Gaussian U and V to rotated U and V
C
          NLEN  = INLEN
          NLENU = OUTLEN
          NLENV = OUTLEN
          IERR = INTUVGH(KVGRIB,KDGRIB,NLEN,KUGRIBO,KVGRIBO,
     X                   NLENU,NLENV)
         IF( IERR.NE.0 ) THEN
           CALL INTLOG(JP_ERROR,'INTUVP: Rotation failed',IERR)
           GOTO 990
        ENDIF
        INTUVP = IERR
           GOTO 900
C
cs        ELSE
cs          CALL INTLOG(JP_ERROR,'INTUVP: Invalid rotation',IERR)
cs         IERR = JPROUTINE + 1
        ENDIF
C
      ENDIF
C
C     -----------------------------------------------------------------|
C*    Section 2.   Unpack the vorticity/divergence fields.
C     -----------------------------------------------------------------|
C
  200 CONTINUE
C
C     Get scratch memory for vorticity/divergence unpacked fields.
C     Vorticity/divergence memory areas are adjacent.
C
      INRESO = ISEC2(2)
      ISZVD  = (INRESO+1)*(INRESO+4)
      IPVORT = 1
      IPDIV  = IPVORT + ISZVD
      CALL JMEMHAN( JPSCR4, IVD, ISZVD*2, JPALLOC, IERR)
      IF( IERR.NE.0 ) THEN
        CALL INTLOG(JP_ERROR,
     X    'INTUVP: Scratch memory type 4 allocation failed.',JPQUIET)
        INTUVP = IERR
        GOTO 990
      ENDIF
C
C     Decode vorticity and divegence.
C
      NPARAM = JPVORT
      NLEN = INLEN
      IERR = INTUVDH(VD(IPVORT),ISZVD,KVGRIB,NLEN,'D',NPARAM)
      IF( IERR.NE.0 ) THEN
        CALL INTLOG(JP_ERROR,'INTUVP: Vorticity decoding failed',IERR)
        INTUVP = IERR
        GOTO 990
      ENDIF
C
      NPARAM = JPDIVE
      NLEN = INLEN
      IERR = INTUVDH(VD(IPDIV),ISZVD,KDGRIB,NLEN,'D',NPARAM)
      IF( IERR.NE.0 ) THEN
        CALL INTLOG(JP_ERROR,'INTUVP: Divergence decoding failed',IERR)
        INTUVP = IERR
        GOTO 990
      ENDIF
C
C     Setup interpolation options from input GRIB characteristics.
C
      IHOLD = NIRESO
      IERR = RESET_C( ISEC1, ISEC2, ZSEC2, ISEC4)
      IF( IERR.NE.0 ) THEN
        CALL INTLOG(JP_ERROR,
     X    'INTUVP: Setup interp. options from GRIB failed.',JPQUIET)
        INTUVP = IERR
        GOTO 990
      ENDIF
      IF( IHOLD.NE.0 ) NIRESO = IHOLD
C
C     Check that no outrageous values given for interpolation
C
      ISAME = INSANE()
      IF( ISAME.GT.0 ) THEN
        CALL INTLOG(JP_ERROR,
     X    'INTUVP: Interpolation cannot use given values.',JPQUIET)
        INTUVP = ISAME
        GOTO 990
      ENDIF
C
C     -----------------------------------------------------------------|
C*    Section 3. Convert spectral vorticity/divergence to spectral U/V
C     -----------------------------------------------------------------|
C
  300 CONTINUE
C
      LSPECUV = (NOREPR.EQ.JPSPHERE).OR.(NOREPR.EQ.JPSPHROT)
      IF( LSPECUV ) THEN
C
C       Spectral U and V for Tn are to be generated from vorticity
C       and divergence spectral T(n-1)
C
        IF( LARESOL.AND.LNEWUV ) THEN
          IF( (NOGRID(1).NE.0).AND.(NOGRID(2).NE.0) ) THEN
            EW = FLOAT(NOGRID(1))/PPMULT
            NS = FLOAT(NOGRID(2))/PPMULT
            NTRUNC = AURESOL(NS,EW) - 1
          ELSE IF( NOGAUSS.NE.0 ) THEN
            EW = 90.0/FLOAT(NOGAUSS)
            NS = EW
            NTRUNC = AURESOL(NS,EW) - 1
          ELSE IF( LNORESO ) THEN
            NTRUNC = NORESO - 1
          ELSE
            NTRUNC = INRESO - 1
          ENDIF
          IF( NTRUNC.GT.(INRESO-1) ) NTRUNC = INRESO - 1
C
        ELSE IF( LNORESO ) THEN
          NTRUNC = NORESO - 1
        ELSE
          NTRUNC = INRESO - 1
        ENDIF
C
        IF( LNEWUV ) THEN
          MTRUNC = NTRUNC + 1
        ELSE
          NTRUNC = NTRUNC + 1
          MTRUNC = NTRUNC
        ENDIF
C
C     -----------------------------------------------------------------|
C       Use old-style processing if IGNORE_UV_EXTRA_MODE = Y
C     -----------------------------------------------------------------|
C
        IF( .NOT.LNEWUV ) THEN
C
          NIRESO = ISEC2(2)
C
          CALL INTLOG(JP_DEBUG,'INTUVP: vo/div truncation = ', NIRESO)
C
C         Get scratch memory for U and V spectral fields.
C         U and V memory areas are adjacent.
C
          ISZUV = MAX((NIRESO+1)*(NIRESO+4),(NORESO+1)*(NORESO+4))
          IP_U  = 1
          IP_V  = IP_U + ISZUV
C
          ISIZE = ISZUV*2
          CALL JMEMHAN( JPSCR3, IUV, ISIZE, JPALLOC, IERR)
          IF( IERR.NE.0 ) THEN
            CALL INTLOG(JP_ERROR,
     X        'INTUVP: Scratch memory type 3 allocation failed',JPQUIET)
            INTUVP = IERR
            GOTO 900
          ENDIF
C
C         Generate U and V with same truncation as input fields.
C
          CALL INTLOG(JP_DEBUG,
     X      'INTUVP: Make intermediate U/V with truncation = ', NIRESO)
          CALL JVOD2UV(VD(IPVORT),VD(IPDIV),NIRESO,
     X                 UV(IP_U),UV(IP_V),NIRESO)
C
C         Do spectral truncation for spectral output
C
          IF( LNORESO ) THEN
C
            CALL INTLOG(JP_DEBUG,
     X        'INTUVP: Make U/V spectral output with truncation',NORESO)
C
            ISIZE =  (NORESO+1)*(NORESO+4)
            CALL JMEMHAN( JPSCR5, IZNFLDO, ISIZE, JPALLOC, IERR)
            IF( IERR.NE.0 ) THEN
              CALL INTLOG(JP_ERROR,
     X          'INTUVP: Scratch memory type 5 allocn failed',JPQUIET)
              INTUVP = JPROUTINE + 4
              GOTO 900
            ENDIF
C
            CALL SH2SH( UV(IP_U), NIRESO, ZNFLDO, NORESO )
            DO LOOP = 1, (NORESO+1)*(NORESO+2)
              UV(IP_U+LOOP-1) = ZNFLDO(LOOP)
            ENDDO
C
            CALL SH2SH( UV(IP_V), NIRESO, ZNFLDO, NORESO )
            IP_V = 1 + (NORESO+1)*(NORESO+4)
            DO LOOP = 1, (NORESO+1)*(NORESO+2)
              UV(IP_V+LOOP-1) = ZNFLDO(LOOP)
            ENDDO
C
            NIRESO = NORESO
C
          ENDIF
C
C         Set GRIBEX flag to force recalculation of complex packing
C         factor.
C
          CALL GRSMKP(1)
C
C         Code U into GRIB
C
          NPARAM = JP_U
          NLENU = OUTLEN
          IERR = INTUVDH(UV(IP_U),ISZUV,KUGRIBO,NLENU,'C',NPARAM)
          IF( IERR.NE.0 ) THEN
            CALL INTLOG(JP_ERROR,
     X        'INTUVP: U encoding into GRIB failed.',IERR)
            INTUVP = JPROUTINE + 4
            GOTO 380
          ENDIF
C
C         Code V into GRIB
C
          NPARAM = JP_V
          NLENV = OUTLEN
          IERR = INTUVDH(UV(IP_V),ISZUV,KVGRIBO,NLENV,'C',NPARAM)
          IF( IERR.NE.0 ) THEN
            CALL INTLOG(JP_ERROR,
     X        'INTUVP: V encoding into GRIB failed.',IERR)
            INTUVP = JPROUTINE + 4
            GOTO 380
          ENDIF
C
  380     CONTINUE
C
C         Turn off GRIBEX flag which forces recalculation of complex
C         packing factor
C
          CALL GRSMKP(0)
C
          GOTO 900
C
C     -----------------------------------------------------------------|
C       Use new-style processing if IGNORE_UV_EXTRA_MODE not set
C     -----------------------------------------------------------------|
C
        ELSE
C
          CALL INTLOG(JP_DEBUG,'INTUVP: vo/div truncation = ', NTRUNC)
          CALL INTLOG(JP_DEBUG,'INTUVP: U/V truncation    = ', MTRUNC)
C
C         Truncate vorticity and divergence to correspond to U/V
C
          ISIZE =  (MTRUNC+1)*(MTRUNC+4)
          CALL JMEMHAN( JPSCR5, IZNFLDO, ISIZE*2, JPALLOC, IERR)
          IF( IERR.NE.0 ) THEN
            CALL INTLOG(JP_ERROR,
     X        'INTUVP: Scratch memory type 5 allocation failed',JPQUIET)
            INTUVP = JPROUTINE + 4
            GOTO 990
          ENDIF
C
          IPVORT = 1
          IPDIV  = IPVORT + (INRESO+1)*(INRESO+4)
          IDIVOFF = 1 + (NTRUNC+1)*(NTRUNC+4)
C
          CALL SH2SH( VD(IPVORT), INRESO, ZNFLDO, NTRUNC )
C
          CALL SH2SH( VD(IPDIV), INRESO, ZNFLDO(IDIVOFF), NTRUNC )
C
C         Get scratch memory for U and V spectral fields.
C         U and V memory areas are adjacent.
C
          ISZUV = (MTRUNC+1)*(MTRUNC+4)
          IP_U  = 1
          IP_V  = IP_U + ISZUV
C
          ISIZE = ISZUV*2
          CALL JMEMHAN( JPSCR3, IUV, ISIZE, JPALLOC, IERR)
          IF( IERR.NE.0 ) THEN
            CALL INTLOG(JP_ERROR,
     X        'INTUVP: Scratch memory type 3 allocation failed',JPQUIET)
            INTUVP = IERR
            GOTO 990
          ENDIF
C
C         Generate U and V spectral fields
C
          CALL JVOD2UV(ZNFLDO(IPVORT),ZNFLDO(IDIVOFF),NTRUNC,
     X                 UV(IP_U),UV(IP_V),MTRUNC)
C
C         Set GRIBEX flag to force recalculation of complex packing
C         factor.
C         Preserve the original output truncation
C
          CALL GRSMKP(1)
          HNORESO = NORESO
C
C         Code U into GRIB using the new truncation
C
          NORESO = MTRUNC
          NPARAM = JP_U
          NLENU = OUTLEN
          IERR = INTUVDH(UV(IP_U),ISZUV,KUGRIBO,NLENU,'C',NPARAM)
          IF( IERR.NE.0 ) THEN
            CALL INTLOG(JP_ERROR,
     X        'INTUVP: U encoding into GRIB failed.',IERR)
            INTUVP = JPROUTINE + 4
            GOTO 390
          ENDIF
C
C         Code V into GRIB using the new truncation
C
          NPARAM = JP_V
          NLENV = OUTLEN
          IERR = INTUVDH(UV(IP_V),ISZUV,KVGRIBO,NLENV,'C',NPARAM)
          IF( IERR.NE.0 ) THEN
            CALL INTLOG(JP_ERROR,
     X        'INTUVP: V encoding into GRIB failed.',IERR)
            INTUVP = JPROUTINE + 4
            GOTO 390
          ENDIF
C
  390     CONTINUE
C
C         Turn off GRIBEX flag which forces recalculation of complex
C         packing factor
C         Restore the original output truncation
C
          CALL GRSMKP(0)
          NORESO = HNORESO
C
          GOTO 900
        ENDIF
C
      ENDIF
C
C     -----------------------------------------------------------------|
C*    Section 4.   Generate grid point GRIB format U and V fields.
C     -----------------------------------------------------------------|
C
  400 CONTINUE
C
C     Spectral U and V for Tn are to be generated from vorticity
C     and divergence spectral T(n-1)
C
C     See whether or not the 'autoresol' flag is set.
C     If not, use the input truncation.
C
      IF( LARESOL ) THEN
        IF( (NOREPR.EQ.JPREGULAR).OR.(NOREPR.EQ.JPREGROT) ) THEN
          EW = FLOAT(NOGRID(1))/PPMULT
          NS = FLOAT(NOGRID(2))/PPMULT
        ELSE
          EW = 90.0/FLOAT(NOGAUSS)
          NS = EW
        ENDIF
        NTRUNC = AURESOL(EW,NS)
        IF( NTRUNC.NE.NTROLD ) THEN
          NTROLD = NTRUNC
          CALL INTLOG(JP_WARN,
     X      'INTUVP: Resolution automatically set to ', NTRUNC)
        ENDIF
      ELSE IF( LNORESO ) THEN
        NTRUNC = NORESO
      ELSE
        NTRUNC = INRESO
      ENDIF
C
C     Check whether the output resolution is greater than the input
C
      IF( NTRUNC.GT.INRESO ) THEN
C
C       Issue warning if the output resolution was user-supplied
C
        IF( .NOT.LARESOL ) THEN
C
C         Revert to the input truncation
C
          IF( INRESO.NE.NTROLD2 ) THEN
            CALL INTLOG(JP_WARN,
     X        'INTUVP: spectral -> grid point interpolation',JPQUIET)
            CALL INTLOG(JP_WARN,
     X        'INTUVP: User supplied resolution = ',NTRUNC)
            CALL INTLOG(JP_WARN,
     X        'INTUVP: Input field resolution   = ',INRESO)
            CALL INTLOG(JP_WARN,
     X        'INTUVP: User supplied resolution ignored',JPQUIET)
            CALL INTLOG(JP_WARN,
     X        'INTUVP: Input field resolution has been used',JPQUIET)
            NTROLD2 = INRESO
          ENDIF
          NTRUNC = INRESO
C
        ELSE
C
C         Revert to the input truncation
C
          NTRUNC = INRESO
          IF( NTRUNC.NE.NTROLD2 ) THEN
            NTROLD2 = NTRUNC
            CALL INTLOG(JP_WARN,
     X        'INTUVP: Auto-resolution selection too high',JPQUIET)
            CALL INTLOG(JP_WARN,
     X        'INTUVP: Resolution set to input resolution: ',NTRUNC)
          ENDIF
        ENDIF
      ENDIF
C
C     IF extra mode is in use, adjust the calculated truncation.
C
      MTRUNC = NTRUNC
      IF( LNEWUV ) NTRUNC = MTRUNC - 1
C
      CALL INTLOG(JP_DEBUG,'INTUVP: vo/div truncation = ', NTRUNC)
      CALL INTLOG(JP_DEBUG,'INTUVP: U/V truncation    = ', MTRUNC)
C
      ISIZE =  (MTRUNC+1)*(MTRUNC+4)
      CALL JMEMHAN( JPSCR5, IZNFLDO, ISIZE*2, JPALLOC, IERR)
      IF( IERR.NE.0 ) THEN
        CALL INTLOG(JP_ERROR,
     X    'INTUVP: Scratch memory type 5 allocation failed.',JPQUIET)
        INTUVP = JPROUTINE + 4
        GOTO 990
      ENDIF
C
      IPVORT = 1
      IPDIV = 1 + (INRESO+1)*(INRESO+4)
      IDIVOFF = IPVORT + (NTRUNC+1)*(NTRUNC+4)
C
      CALL SH2SH( VD(IPDIV), INRESO, ZNFLDO(IDIVOFF), NTRUNC )
C
      CALL SH2SH( VD(IPVORT), INRESO, ZNFLDO, NTRUNC )
C
C     Get scratch memory for U and V spectral fields.
C     U and V memory areas are adjacent.
C
      ISZUV = (MTRUNC+1)*(MTRUNC+4)
      IP_U  = 1
      IP_V  = IP_U + ISZUV
C
      ISIZE = ISZUV*2
      CALL JMEMHAN( JPSCR3, IUV, ISIZE, JPALLOC, IERR)
      IF( IERR.NE.0 ) THEN
        CALL INTLOG(JP_ERROR,
     X    'INTUVP: Scratch memory type 3 allocation failed.',JPQUIET)
        INTUVP = IERR
        GOTO 990
      ENDIF
C
C     Generate U and V spectral fields
C
      CALL JVOD2UV(ZNFLDO(IPVORT),ZNFLDO(IDIVOFF),NTRUNC,
     X             UV(IP_U),UV(IP_V),MTRUNC)
C
       LSTYLE = LNOSTYLE.AND.
     X         (NOSTYLE.EQ.JPSDISM).AND.
     X         (NOREPR.EQ.JPREGULAR)
C
        IF( LSTYLE ) THEN
            EW    = NOGRID(1) / PPMULT
            NS    = NOGRID(2) / PPMULT
            NORTH = REAL(NOAREA(1)) / PPMULT
            WEST  = REAL(NOAREA(2)) / PPMULT
            SOUTH = REAL(NOAREA(3)) / PPMULT
            EAST  = REAL(NOAREA(4)) / PPMULT
C
            IERR = DSSAREA( EW, NS, NORTH, WEST, SOUTH, EAST)
            IF( IERR.NE.0 ) THEN
              CALL INTLOG(JP_ERROR,'INTUVP: DSSAREA failed:',IERR)
              INTUVP = JPROUTINE + 9
              GOTO 900
            ENDIF
C
            NOAREA(1) = NINT(NORTH * PPMULT)
            NOAREA(2) = NINT(WEST  * PPMULT)
            NOAREA(3) = NINT(SOUTH * PPMULT)
            NOAREA(4) = NINT(EAST  * PPMULT)
         ELSE
C           Fixup area definition to correspond to grid definitions
             IERR = FIXAREA()
             IF ( IERR .NE. 0 ) THEN
               CALL INTLOG(JP_ERROR,
     X           'INTUVP: Fixup area definition failed.',JPQUIET)
               INTUVP = IERR
               GOTO 900
             ENDIF
         ENDIF

cs      IERR = FIXAREA()
cs      IF( IERR.NE.0 ) THEN
cs        CALL INTLOG(JP_ERROR,'INTUVP: Fixarea failed.',JPQUIET)
cs        INTUVP = IERR
cs        GOTO 990
cs      ENDIF
C
C     Get scratch space for interpolation
      ISIZE = ISCRSZ()*2
      IF( ISIZE.LE.0 ) THEN
        CALL INTLOG(JP_ERROR,'INTUVP: Get scratch space failed.',ISIZE)
        INTUVP = JPROUTINE + 5
        GOTO 990
      ENDIF
      CALL JMEMHAN( JPSCR5, IZNFLDO, ISIZE, JPALLOC, IERR)
      IF( IERR.NE.0 ) THEN
        CALL INTLOG(JP_ERROR,
     X    'INTUVP: Scratch memory(5) allocation failed.',JPQUIET)
        INTUVP = JPROUTINE + 5
        GOTO 990
      ENDIF
C
      LWIND = .TRUE.
      LWINDSET = .TRUE.
C
C     Interpolate U and V
C
      NOLD = NIRESO
      NIRESO = MTRUNC
      NLENU = OUTLEN
      NLENV = OUTLEN
      IERR = INTUVXH(UV,ISZUV,ZNFLDO,KUGRIBO,KVGRIBO,NLENU,NLENV)
      IF( IERR.NE.0 ) THEN
        CALL INTLOG(JP_ERROR,
     X    'INTUVP: U/V interpolation failed.',JPQUIET)
        INTUVP = JPROUTINE + 6
        GOTO 990
      ENDIF
C
      NIRESO = NOLD
C
C     -----------------------------------------------------------------|
C*    Section 9.   Return
C     -----------------------------------------------------------------|
C
  900 CONTINUE
C
      OUTLEN = NLENU
C
  990 CONTINUE
C
C     Clear change flags for next product processing and reset wind flag
C
      LCHANGE = .FALSE.
      LSMCHNG = .FALSE.
      LWINDSET  = LOLDWIND
      LWIND = .FALSE.
C
      RETURN
      END

C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      INTEGER FUNCTION WVQLIN2(KNUM,NUMPTS,KE_W,KN_S,RESON,OLDWAVE,
     X                         NEWWAVE,NORTH,WEST,KPARAM,PMISS)
C
C---->
C*****WVQLIN2*
C
C     PURPOSE
C     -------
C
C     To interpolate a wave field quasi-regular latitude
C     longitude grid to a regular latitude/longitude grid.
C
C
C     INTERFACE
C     ---------
C
C     IRET = WVQLIN2(KNUM,NUMPTS,KE_W,KN_S,RESON,OLDWAVE,
C    X               NEWWAVE,NORTH,WEST,KPARAM,PMISS)
C
C     Input arguments
C     ---------------
C
C     KNUM    - No. of meridians from North to South pole (input field)
C     NUMPTS  - Array giving number of points along each latitude
C               (empty latitudes have entry 0)
C     KE_W    - First dimension of new array
C               = Number of points E-W in new grid
C     KN_S    - Second dimension of new array
C               = Number of points N-S in new grid
C     RESON   - Output grid resolution (degrees)
C     OLDWAVE - Original wave field
C     NORTH   - Input and output grid northernmost latitude (degree)
C     WEST    - Input and output grid westernmost  longitude (degree)
C     KPARAM  - Field parameter code
C     PMISS   - Missing value indicator
C     RNS     - Difference in degrees in NS disrection
C
C     Output arguments
C     ----------------

C     NEWWAVE - New wave field
C
C     Function returns 0 if the interpolation was OK.
C
C
C     METHOD
C     ------
C
C     A bi-linear interpolation is only done if all four neighbouring
C     points are sea.
C     The nearest neighbouring grid point value is taken if one of the
C     neighbouring points is missing.
C     The interpolated point value is set to the 'missing' indicator
C     value if the point is outside the input grid.
C
C     A field representing a 'direction' is resolved into components
C     each of which is interpolated separately.
C
C     The output area is the same as the input area.
C
C
C     EXTERNALS
C     ---------
C
C     WVQLID2 - Calculate the indices of neighbouring points
C     INTLOG  - Log error message.
C
C
C     REFERENCE
C     ---------
C
C     Based on:
C         SUBROUTINE INTERPOLATE
C         Peter Janssen     ECMWF    September 1995
C     and:
C         SUBROUTINE EXPOINT
C         Heinz Gunther     ECMWF    December  1989 
C
C
C     Author.
C     -------
C
C     J.D.Chambers      ECMWF    September 1996
C
C     J.D.Chambers      ECMWF    September 1998
C     Modified to handle subarea input/output.
C     The output area is the same as the input area.
C
C     J.D.Chambers      ECMWF    November 2000
C     Modified to input grid resolution to be different from the
C     output grid resolution.
C
C----<
C
C     -----------------------------------------------------------------|
C*    Section 0. Arguments and variable
C     -----------------------------------------------------------------|
C
C
      IMPLICIT NONE
C
#include "parim.h"
C
C     Parameters
C
      INTEGER JPROUTINE
      PARAMETER ( JPROUTINE = 19400 )
      INTEGER JPLLMAX
      PARAMETER ( JPLLMAX = 1801 )
C                             `--> allow upto 0.1 degree resolution
      INTEGER JPNMOUT
      PARAMETER ( JPNMOUT = 1800 )
C                             `--> allow upto 0.1 degree resolution
C
      INTEGER JPNW, JPNE, JPSW, JPSE, JPN, JPS
      INTEGER JPDISNW, JPDISNE, JPDISSW, JPDISSE
      PARAMETER (JPNW = 1)
      PARAMETER (JPNE = 2)
      PARAMETER (JPSW = 3)
      PARAMETER (JPSE = 4)
      PARAMETER (JPN  = 5)
      PARAMETER (JPS  = 6)
      PARAMETER (JPDISNW = 7)
      PARAMETER (JPDISNE = 8)
      PARAMETER (JPDISSW = 9)
      PARAMETER (JPDISSE = 10)
C
C     Subroutine arguments
C
      INTEGER KNUM, NUMPTS, KE_W, KN_S, KPARAM
      DIMENSION NUMPTS(*)
      REAL RESON, NORTH, WEST, PMISS
      REAL RNS
      REAL OLDWAVE, NEWWAVE
      DIMENSION OLDWAVE(*),  NEWWAVE(*)
C
C     Local arguments
C
      INTEGER NLAT, K, I, NEWROW, NEWCOL, I1N, I1S, I_N, I_S, I2N, I2S
      REAL*4 DELONGN, DELONGS, DELAT, DI1N, DI1S, DI2N, DI2S
      REAL*4 DIST_N, DIST_S
      REAL*4 DISNW, DISNE, DISSW, DISSE
      REAL*4 U1, U2, ZXIN, ZXIS
      REAL LON, LAT
      DIMENSION LON(JPNMOUT*2),LAT(JPNMOUT+1)
      LOGICAL INGRID, LDIREC
      INTEGER NW_PT, NE_PT, SW_PT, SE_PT
      REAL*4 NWVALUE, NEVALUE, SWVALUE, SEVALUE
      REAL*4 RAD
      DATA RAD/0.017453293/
      REAL*4 CNW_PT, CNE_PT, CSW_PT, CSE_PT
      REAL*4 SNW_PT, SNE_PT, SSW_PT, SSE_PT
      REAL*4 C1, C2, S1, S2, CC, SS
C
      REAL OLDLATS(JPLLMAX), OLDEAST
      REAL OLDNS
      INTEGER ISTART, IEND
      INTEGER LOCATE
      INTEGER NEXT, NUMNEW(JPLLMAX)
      INTEGER IRET, WVQLID2
      EXTERNAL WVQLID2
      INTEGER XKNUM,XKE_W,XKN_S
      DATA XKNUM/-1/,XKE_W/-1/,XKN_S/-1/
      REAL XRESON,XNORTH,XWEST
      DATA XRESON/-999.0/,XNORTH/-999.0/,XWEST/-999.0/
      INTEGER IFIRST, NEWIDX(4,3600*1801)
      DATA IFIRST/0/
      REAL*4 DISTNEW(10,3600*1801)
C
      INTEGER IOS
      INTEGER OLDKNUM
      DATA OLDKNUM/0/
      INTEGER INDEX(JPLLMAX)
      REAL DEPS
      DATA DEPS/0.00005/
C     Inline function - tests TRUE if A is a missing value
C     EPS      Tolerance on missing data flag
      REAL EPS
      DATA EPS/0.1/
      LOGICAL LSW,LSE,LNE,LNW,LTEMP
C
      SAVE IFIRST,XKNUM,XKE_W,XKN_S,XRESON,XNORTH,XWEST,NEWIDX,DISTNEW

C
C     -----------------------------------------------------------------|
C*    Section 1. Initalisation.
C     -----------------------------------------------------------------|
C
  100 CONTINUE
C
      WVQLIN2 = 0
      CALL INTLOG(JP_DEBUG,
     X   'WVQLIN2: Wave interpolation requested.',JPQUIET)
C
C     Check reduced latitude/longitude grid specification
C
      IF( KNUM.GT.JPLLMAX ) THEN
        CALL INTLOG(JP_ERROR,
     X    'WVQLIN2: Number of latitudes in input lat/long grid = ',KNUM)
        CALL INTLOG(JP_ERROR,
     X    'WVQLIN2: And is greater than allowed maximum = ',JPLLMAX)
        WVQLIN2 = JPROUTINE + 1
        GOTO 900
      ENDIF
C
C     Ensure working array dimensions are adequate for required output.
C
      IF( (KE_W.GT.JPNMOUT*2).OR.(KN_S.GT.JPNMOUT+1) ) THEN
        CALL INTLOG(JP_ERROR,
     X    'WVQLIN2: Internal array dimensions are too small',JPQUIET)
        CALL INTLOG(JP_ERROR,
     X    'WVQLIN2: for given lat/long output field.',JPQUIET)
        WVQLIN2 = JPROUTINE + 3
        GOTO 900
      ENDIF
C
C     Set up index for latitude lines in the input reduced lat/lon array
C
      INDEX(1) = 0
      DO K = 2, KNUM
        INDEX(K) = INDEX(K-1) + NUMPTS(K-1)
      ENDDO

      DO K = 1, KN_S
        LAT(K)     = NORTH - FLOAT(K-1)*RESON
        NUMNEW(K)  = KE_W
      ENDDO
C
C     Calculate latitudes and longitudes of output grid points.
C
      DO I = 1,KE_W
        LON(I) = FLOAT(I-1)*RESON
      ENDDO
C
C     Calculate latitudes for input (old) grid.
C     (Input and output area are same)
C
      OLDNS =  RNS/REAL(KNUM-1)
      DO K = 1, KNUM
        OLDLATS(K) = NORTH - FLOAT(K-1)*OLDNS
      ENDDO
C
C     Find first and last latitudes in input grid which are not empty
C
      ISTART = 1
      DO K = 1, KNUM/2
        IF( NUMPTS(K).EQ.0 ) ISTART = ISTART + 1
      ENDDO
C
      IEND = KNUM
      DO K = KNUM, (KNUM/2) + 1, -1
        IF( NUMPTS(K).EQ.0 ) IEND = IEND - 1
      ENDDO
C
C     For the regular output grid, calculate its latitudes and fill
C     in the number of points along each latitude.
C
C
C     Setup East depending on whether or not there is wrap-around
C
      IF( ABS((KE_W*RESON)-360.0).LT.DEPS ) THEN
        OLDEAST = WEST + KE_W*RESON
      ELSE
        OLDEAST = WEST + (KE_W-1)*RESON
      ENDIF
C
C     Initialise all points with 'missing data' indicator
C
      NEXT  = 0
      DO NEWROW = 1, KN_S
        DO NEWCOL = 1, KE_W
          NEXT = NEXT + 1
          NEWWAVE(NEXT) = PMISS
        ENDDO
      ENDDO
C
C     Wave direction parameters need special handling
C     (MWD, MDWW, MDPS, MDWI)
C
      LDIREC = ( (KPARAM.EQ.230) .OR.
     X           (KPARAM.EQ.235) .OR.
     X           (KPARAM.EQ.238) .OR.
     X           (KPARAM.EQ.242) )
C
cs	  print*,KNUM,KE_W,KN_S,RESON,NORTH,WEST,KPARAM,PMISS,RNS
C     -----------------------------------------------------------------|
C*    Section 2. Interpolation.
C     -----------------------------------------------------------------|
C
  200 CONTINUE
C
C     Only calculate the indices on the first time through
C
      IF( (IFIRST.EQ.0 )     .OR.
     X    ( KNUM.NE.XKNUM )  .OR.
     X    ( KE_W.NE.XKE_W )  .OR.
     X    ( KN_S.NE.XKN_S )  .OR.
     X    ( RESON.NE.XRESON ).OR.
     X    ( NORTH.NE.XNORTH ).OR.
     X    ( WEST.NE.XWEST ) ) THEN
C
c        print*,'DISS KNUM ', KNUM,' WEST ',WEST, 'KN_S ',KN_S
c        print*,'DISS OLDEAST ', OLDEAST
        IRET =  WVQLID2(KNUM,NUMPTS,OLDLATS,WEST,OLDEAST,
     X                  KN_S,NUMNEW,LAT,NEWIDX,DISTNEW)
        IFIRST = 1
        XKNUM  = KNUM
        XKE_W  = KE_W
        XKN_S  = KN_S
        XRESON = RESON
        XNORTH = NORTH
        XWEST  = WEST
      ENDIF
C
      DELAT = OLDNS
      NEXT  = 0
C
      DO 220 NEWROW = 1, KN_S
C
C       Set up the distance between new row and the old rows to N and S.
C
        NLAT  = NINT((NORTH - LAT(NEWROW))/DELAT) + 1
        I_N   = NLAT
        I_S   = MIN(I_N+1,KNUM*2)
        DIST_N  = ((NORTH - DELAT*(I_N-1)) - LAT(NEWROW)) / DELAT
        DIST_S  = 1.0 - DIST_N
C
C       Check if the new interpolated row lies between 2 old rows which
C       have data points
C

        IF( (NUMPTS(I_N).GT.0).AND.(NUMPTS(I_S).GT.0) ) THEN
C
C         Yes, use the calculated indices
C
          DO 210 NEWCOL = 1, KE_W

            NEXT = NEXT + 1
C
            NW_PT = NEWIDX(JPNW,NEXT)
            NE_PT = NEWIDX(JPNE,NEXT)
            SW_PT = NEWIDX(JPSW,NEXT)
            SE_PT = NEWIDX(JPSE,NEXT)
            NWVALUE = OLDWAVE(NW_PT)
            NEVALUE = OLDWAVE(NE_PT)
            SWVALUE = OLDWAVE(SW_PT)
            SEVALUE = OLDWAVE(SE_PT)
C
C           Test if any one of the four neighbouring points is missing.
C
              LTEMP = .FALSE.
              LSE = .FALSE.
             IF(ABS(SEVALUE-PMISS) .LT. EPS)   LSE = .TRUE.
              LSW = .FALSE.
             IF(ABS(SWVALUE-PMISS) .LT. EPS)   LSW = .TRUE.
              LNE = .FALSE.
             IF(ABS(NEVALUE-PMISS) .LT. EPS)   LNE = .TRUE.
              LNW = .FALSE.
             IF(ABS(NWVALUE-PMISS) .LT. EPS)   LNW = .TRUE.
C
            IF( (NW_PT.EQ.0 .OR. LNW) .OR.
     X          (NE_PT.EQ.0 .OR. LNE) .OR.
     X          (SW_PT.EQ.0 .OR. LSW) .OR.
     X          (SE_PT.EQ.0 .OR. LSE) ) THEN
C             If so, take nearest grid point value.
C
              DISNW = DISTNEW(JPDISNW,NEXT)
              DISNE = DISTNEW(JPDISNE,NEXT)
              DISSW = DISTNEW(JPDISSW,NEXT)
              DISSE = DISTNEW(JPDISSE,NEXT)
C
              IF( (DISNW.LE.DISNE).AND.
     X            (DISNW.LE.DISSW).AND.
     X            (DISNW.LE.DISSE) ) THEN
cs                NEWWAVE(NEXT) = NWVALUE
                LOCATE = NW_PT
                LTEMP  = LNW
C
              ELSE IF( (DISNE.LE.DISSW).AND.
     X                 (DISNE.LE.DISSE) ) THEN
cs                NEWWAVE(NEXT) = NEVALUE
                LOCATE = NE_PT
                LTEMP  = LNE
C
              ELSE IF( (DISSW.LE.DISSE) ) THEN
cs                NEWWAVE(NEXT) = SWVALUE
                LOCATE = SW_PT
                LTEMP  = LSW
C
              ELSE 
cs                NEWWAVE(NEXT) = SEVALUE
                LOCATE = SE_PT
                LTEMP  = LSE
C
              ENDIF

              IF( .NOT.LTEMP.AND.LOCATE.NE.0) THEN 
c              IF( LOCATE.NE.0) THEN 
                  NEWWAVE(NEXT) = OLDWAVE(LOCATE)
              ENDIF

C
            ELSE
C
C             Use bi-linear interpolation from four
C             neighbouring sea points.
C
              DI1N = DISTNEW(JPNW,NEXT)
              DI2N = DISTNEW(JPNE,NEXT)
              DI1S = DISTNEW(JPSW,NEXT)
              DI2S = DISTNEW(JPSE,NEXT)
              DIST_N  = DISTNEW(JPN,NEXT)
              DIST_S  = DISTNEW(JPS,NEXT)
C
              NW_PT = OLDWAVE(NW_PT)
              NE_PT = OLDWAVE(NE_PT)
              SW_PT = OLDWAVE(SW_PT)
              SE_PT = OLDWAVE(SE_PT)
C
              IF( .NOT. LDIREC ) THEN
                U1 = NWVALUE*DI2N + NEVALUE*DI1N
                U2 = SWVALUE*DI2S + SEVALUE*DI1S
                NEWWAVE(NEXT) = U1*DIST_S + U2*DIST_N
C
              ELSE
C
C               Fields representing a 'direction': resolve into
C               components and interpolate each separately.
C
                CNW_PT = COS(NWVALUE*RAD)
                CNE_PT = COS(NEVALUE*RAD)
                CSW_PT = COS(SWVALUE*RAD)
                CSE_PT = COS(SEVALUE*RAD)
                SNW_PT = SIN(NWVALUE*RAD)
                SNE_PT = SIN(NEVALUE*RAD)
                SSW_PT = SIN(SWVALUE*RAD)
                SSE_PT = SIN(SEVALUE*RAD)
                C1 = CNW_PT*DI2N + CNE_PT*DI1N
                C2 = CSW_PT*DI2S + CSE_PT*DI1S
                CC = C1*DIST_S + C2*DIST_N
                S1 = SNW_PT*DI2N + SNE_PT*DI1N
                S2 = SSW_PT*DI2S + SSE_PT*DI1S
                SS = S1*DIST_S + S2*DIST_N
                IF( SS.LT.0.0 ) THEN
                  NEWWAVE(NEXT) = ATAN2(SS,CC)/RAD + 360.0
                ELSE
                  NEWWAVE(NEXT) = ATAN2(SS,CC)/RAD
                ENDIF
              ENDIF
            ENDIF
  210     CONTINUE
        ELSE
           NEXT = NEXT + KE_W
        ENDIF
C
  220 CONTINUE
C
C     -----------------------------------------------------------------|
C*    Section 9. Closedown.
C     -----------------------------------------------------------------|
C
  900 CONTINUE
C
      IF( WVQLIN2.EQ.0 ) THEN
        CALL INTLOG(JP_DEBUG,
     X    'WVQLIN2: Wave interpolation successful.',JPQUIET)
      ELSE
        CALL INTLOG(JP_DEBUG,
     X    'WVQLIN2: Wave interpolation failed.',JPQUIET)
      ENDIF
c     call abort()
C
      RETURN
      END

C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      INTEGER FUNCTION INTUVGH(KUGRIBI, KVGRIBI, INLEN,
     X                         KUGRIBO, KVGRIBO,
     X                         OUTLENU, OUTLENV)
C
C---->
C**** INTUVGH
C
C     Purpose
C     -------
C
C     Interpolate GRIB format input U and V component reduced gaussian
C     fields to rotated GRIB format U and V fields.
C
C
C     Interface
C     ---------
C
C     IRET = INTUVGH(KUGRIBI,KVGRIBI,INLEN,KUGRIBO,KVGRIBO,OUTLENU,OUTLENV)
C
C     Input
C     -----
C
C     KUGRIBI - Input U component field (reduced gaussian, GRIB format).
C     KVGRIBI - Input V component field (reduced gaussian, GRIB format).
C     INLEN   - Input field length (words).
C
C
C     Output
C     ------
C
C     KUGRIBO - Output U field (GRIB format).
C     KVGRIBO - Output V field (GRIB format).
C     OUTLENU - Output U field length (words).
C     OUTLENV - Output V field length (words).
C
C
C     Method
C     ------
C
C     Use HIRLAM rotation scheme.
C
C     Note that a common block is used in intf.h to hold the U/V
C     fields before interpolation.
C
C     Externals
C     ---------
C
C     IBASINI - Ensure basic interpolation setup is done.
C     INTUVDH - Encodes/decodes data into/from GRIB code.
C     JMEMHAN - Allocate scratch memory.
C     GRIBEX  - GRIB decoding/encoding.
C     ISCRSZ  - Calculate number of values in generated field.
C     FIXAREA - Fixup area definition to correspond to grid definitions
C     INTLOG  - Log error message.
C     MKFRAME - Create a 'frame' from a rectangular field.
C     RESET_C - Reset interpolation handling options using GRIB product.
C     INSANE  - Ensure no outrageous values given for interpolation.
C     HRG2GGW - Creates rotated gaussian U and V from reduced gaussian
C     HLL2LLW - Creates rotated lat/long U and V from lat/long
C
C
C     Author
C     ------
C
C     J.D.Chambers     ECMWF     October 2001
C
C
C----<
C     -----------------------------------------------------------------|
C
      IMPLICIT NONE
C
C     Function arguments
C
      INTEGER KUGRIBI(*), KVGRIBI(*), INLEN
      INTEGER KUGRIBO(*), KVGRIBO(*), OUTLENU, OUTLENV
C
#include "parim.h"
#include "nifld.common"
#include "nofld.common"
#include "grfixed.h"
#include "intf.h"
#include "intlog.h"
#include "current.h"
C
C     Parameters
C
      INTEGER JPROUTINE, JPALLOC, JPDEALL, JPSCR3, JPSCR4,JPSCR5
      PARAMETER (JPROUTINE = 40170 )
      PARAMETER (JPALLOC = 1) 
      PARAMETER (JPDEALL = 0) 
      PARAMETER (JPSCR3 = 3) 
      PARAMETER (JPSCR4 = 4) 
      PARAMETER (JPSCR5 = 5) 
C
C     Local variables
C
      CHARACTER*1 HFUNC
      REAL OLDGRID(2), AREA(4), GRID(2), POLE(2)
      LOGICAL LOLDWIND, LFRAME
      INTEGER IRET,KPR,ISZOUV,ISIZE,ISAME,IPARAM
      INTEGER LOOP, NGAUSS
      INTEGER IPINU, IPINV, NUMPTS, NLON, NLAT, IN_U, IN_V
#ifndef _CRAYFTN
#ifdef POINTER_64
      INTEGER*8 IOLDUV, ISWORK
#endif
#endif
      REAL OLDUV, SWORK
      POINTER ( IOUV, OLDUV(1) )
      POINTER (ISWORK, SWORK(1) )
C
C     Externals
C
      INTEGER RESET_C,ISCRSZ,FIXAREA,IBASINI,INSANE,INTUVDH,HIRLAMW
      INTEGER HRG2GGW, HLL2LLW
C
C     -----------------------------------------------------------------|
C*    Section 1.   Initialise
C     -----------------------------------------------------------------|
C
  100 CONTINUE
      INTUVGH = 0
      IRET    = 0
      KPR     = 0
C
      LFRAME = LNOFRAME.AND.
     X         ((NOREPR.EQ.JPREGULAR).OR.(NOREPR.EQ.JPREGROT))
C
C     Ensure that basic initialisation has been done
C
      IRET = IBASINI(0)
      IF( IRET.NE.0 ) THEN
        CALL INTLOG(JP_ERROR,'INTUVGH: basic initialise failed',JPQUIET)
        INTUVGH = IRET
        GOTO 900
      ENDIF
C
C     -----------------------------------------------------------------|
C*    Section 2.   Unpack the U/V fields.
C     -----------------------------------------------------------------|
C
  200 CONTINUE
C
C     Need to establish input characteristics, so unpack GRIB sections 1
C     and 2.
C
      IPARAM = 0
      IPINU  = 1
      IRET = INTUVDH(OLDUV(IPINU),ISZOUV,KUGRIBI,INLEN,'I',IPARAM)
      IF( IRET.NE.0 ) THEN
        CALL INTLOG(JP_ERROR,'INTUVGH: GRIB header decode failed',IRET)
        INTUVGH = IRET
        GOTO 900
      ENDIF
C
C     Check whether the input field is an ECMWF reduced gaussian or
C     lat/long U field
C
      IF( (ISEC1(1).NE.128).OR.
     X    ((ISEC1(6).NE.JP_U).AND.(ISEC1(6).NE.JP_10U)) ) THEN
        CALL INTLOG(JP_ERROR,
     X    'INTUVGH: Input is not ECMWF U field.',JPQUIET)
        INTUVGH = JPROUTINE + 2
        GOTO 900
      ENDIF
      IF( (ISEC2(1).NE.4).AND.
     X    ((ISEC2(17).NE.0) .OR.(ISEC2(1).NE.0)) ) THEN
        CALL INTLOG(JP_ERROR,
     X    'INTUVGH: Input not gaussian or lat/long.',JPQUIET)
        INTUVGH = JPROUTINE + 2
        GOTO 900
      ENDIF
C
C     Get scratch memory for U/V unpacked fields.
C     U/V memory areas are adjacent.
C
      IF( ISEC2(17).EQ.1 ) THEN
        ISZOUV  = 0
        DO LOOP = 1, ISEC2(3)
          ISZOUV = ISZOUV + ISEC2(22+LOOP)
        ENDDO
      ELSE
        ISZOUV = ISEC2(2) * ISEC2(3)
      ENDIF
C
      IPINU = 1
      IPINV = 1 + ISZOUV
      CALL JMEMHAN( JPSCR4, IOUV, ISZOUV*2, JPALLOC, IRET)
      IF( IRET.NE.0 ) THEN
        CALL INTLOG(JP_ERROR,
     X    'INTUVGH: Scratch memory type 4 allocation failed.',JPQUIET)
        INTUVGH = IRET
        GOTO 900
      ENDIF
C
C     Decode input U and V
C
      IRET = INTUVDH(OLDUV(IPINU),ISZOUV,KUGRIBI,INLEN,'D',IPARAM)
      IF( IRET.NE.0 ) THEN
        CALL INTLOG(JP_ERROR,'INTUVGH: Vorticity decoding failed',IRET)
        INTUVGH = IRET
        GOTO 900
      ENDIF
      IN_U = ISEC1(6)
C
      IRET = INTUVDH(OLDUV(IPINV),ISZOUV,KVGRIBI,INLEN,'D',IPARAM)
      IF( IRET.NE.0 ) THEN
        CALL INTLOG(JP_ERROR,'INTUVGH: Divergence decoding failed',IRET)
        INTUVGH = IRET
        GOTO 900
      ENDIF
      IN_V = ISEC1(6)
C
C     Setup interpolation options from input GRIB characteristics.
C
      IRET = RESET_C( ISEC1, ISEC2, ZSEC2, ISEC4)
      IF( IRET.NE.0 ) THEN
        CALL INTLOG(JP_ERROR,
     X    'INTUVGH: Setup interp. options from GRIB failed.',JPQUIET)
        INTUVGH = IRET
        GOTO 900
      ENDIF
C
C     Check that no outrageous values given for interpolation
C
      ISAME = INSANE()
      IF( ISAME.GT.0 ) THEN
        CALL INTLOG(JP_ERROR,
     X    'INTUVGH: Interpolation cannot use given values.',JPQUIET)
        INTUVGH = ISAME
        GOTO 900
      ENDIF
C
      IRET = FIXAREA()
      IF( IRET.NE.0 ) THEN
        CALL INTLOG(JP_ERROR,'INTUVGH: Fixarea failed.',JPQUIET)
        INTUVGH = IRET
        GOTO 900
      ENDIF
C
      LWIND = .TRUE.
      LOLDWIND = LWINDSET
      LWINDSET = .TRUE.
C
      DO LOOP = 1, 4
        AREA(LOOP) = REAL(NOAREA(LOOP))/PPMULT
      ENDDO
      DO LOOP = 1, 2
        GRID(LOOP) = REAL(NOGRID(LOOP))/PPMULT
        POLE(LOOP) = REAL(NOROTA(LOOP))/PPMULT
      ENDDO
C
C     -----------------------------------------------------------------|
C*    Section 3.   Generate interpolated lat/long U and V fields.
C     -----------------------------------------------------------------|
C
  300 CONTINUE
C
      IF( (NOREPR.EQ.JPREGULAR).OR.(NOREPR.EQ.JPREGROT) ) THEN
C
C       Dynamically allocate scrath space for rotated lat/long grid
C
        NLON = 1 + NINT(FLOAT(NOAREA(JPEAST)  - NOAREA(JPWEST)) /
     X         NOGRID(JPWESTEP))
        NLAT = 1 + NINT(FLOAT(NOAREA(JPNORTH) - NOAREA(JPSOUTH)) /
     X         NOGRID(JPNSSTEP))
C
        NOWE = NLON
        NONS = NLAT
        NUMPTS = NLON * NLAT
        ISIZE  = NUMPTS * 2
        CALL JMEMHAN( 11, ISWORK, ISIZE, 1, IRET)
        IF( IRET.NE.0 ) THEN
          CALL INTLOG(JP_ERROR,
     X      'INTUVGH: memory alloc for lat/long grid fail',JPQUIET)
          INTUVGH = JPROUTINE + 3
          GOTO 900
        ENDIF
C
C       Rotate reduced gaussian to lat/long
C
        IF( (NIREPR.EQ.JPGAUSSIAN).OR.(NIREPR.EQ.JPQUASI) ) THEN
          IRET = HIRLAMW(LO12PT,
     X                   OLDUV(IPINU),OLDUV(IPINV),ISZOUV,
     X                   NOGAUSS,AREA,POLE,GRID,
     X                   SWORK,SWORK(1+NUMPTS),NUMPTS,NLON,NLAT)
          IF( IRET.NE.0 ) THEN
            CALL INTLOG(JP_ERROR,
     X        'INTUVGH: HIRLAMW rotation failed',JPQUIET)
            INTUVGH = JPROUTINE + 3
            GOTO 900
          ENDIF
C
C       Rotate lat/long to lat/long
C
        ELSE
          OLDGRID(1) = REAL(NIGRID(1)) / PPMULT
          OLDGRID(2) = REAL(NIGRID(2)) / PPMULT
          IRET = HLL2LLW(LO12PT,OLDUV(IPINU),OLDUV(IPINV),
     X                   OLDGRID,AREA,POLE,GRID,
     X                   SWORK,SWORK(1+NUMPTS),NUMPTS,NLON,NLAT)
          IF( IRET.NE.0 ) THEN
            CALL INTLOG(JP_ERROR,
     X        'INTUVGH: HLL2LLW rotation failed',JPQUIET)
            INTUVGH = JPROUTINE + 3
            GOTO 900
          ENDIF
        ENDIF
C
C       If a 'frame' has been specified, build the frame
C
        IF( LFRAME ) THEN
          LIMISSV = .TRUE.
          CALL MKFRAME(NLON,NLAT,SWORK,RMISSGV,NOFRAME)
          CALL MKFRAME(NLON,NLAT,SWORK(1+NUMPTS),RMISSGV,NOFRAME)
        ENDIF
C
      ELSE
C
C     -----------------------------------------------------------------|
C*    Section 4.   Generate interpolated gaussian U and V fields.
C     -----------------------------------------------------------------|
C
  400   CONTINUE
C
        IF( LDEBUG ) CALL INTLOG(JP_DEBUG,
     X    'INTUVGH: Gaussian to gaussian',JPQUIET)
C
C       Dynamically allocate memory for rotated gaussian grids
C
        NUMPTS = NOGAUSS * NOGAUSS
        ISIZE = 2 * NUMPTS * 8 
        CALL JMEMHAN( 11, ISWORK, ISIZE, 1, IRET)
        IF( IRET.NE.0 ) THEN
          IF( LDEBUG ) CALL INTLOG(JP_ERROR,
     X      'INTUVGH: memory alloc for gaussian grid fail',JPQUIET)
          INTUVGH = JPROUTINE + 4
          GOTO 900
        ENDIF
C
        NGAUSS = ISEC2(10)
        IRET = HRG2GGW(LO12PT,
     X                 OLDUV(IPINU),OLDUV(IPINV),ISZOUV,
     X                 NGAUSS,AREA,POLE,NOGAUSS,HOGAUST,
     X                 SWORK,SWORK(1+ISIZE/2),ISIZE,NUMPTS)
        IF( IRET.NE.0 ) THEN
          IF( LDEBUG ) CALL INTLOG(JP_ERROR,
     X        'INTUVGH: HRG2GGW rotation failed',JPQUIET)
            INTUVGH = JPROUTINE + 4
            GOTO 900
          ENDIF
C
      ENDIF
C
C     -----------------------------------------------------------------|
C*    Section 5.   Pack the fields into GRIB format
C     -----------------------------------------------------------------|
C
  500 CONTINUE
C
      IF( ((NOREPR.EQ.JPQUASI).OR.
     X     (NOREPR.EQ.JPQGGROT).OR.
     X     (NOREPR.EQ.JPFGGROT).OR.
     X     (NOREPR.EQ.JPGAUSSIAN)).AND.
     X    ( (NOROTA(1).NE.9000000).AND.(NOROTA(2).NE.0) ) ) THEN
        ISEC2(1) = JPFGGROT
      ELSE
        ISEC2(1) = NOREPR
      ENDIF
C
      ISEC4(1) = NUMPTS
C
C     Reset the input format flag
C
      NIFORM = 1
C
C     Set the components flag for rotated U and V coefficients
C
      ISEC2(19) = 8
C
      IRET = INTUVDH(SWORK,NUMPTS,KUGRIBO,OUTLENU,'C',IN_U)
      IF( IRET.NE.0 ) THEN
        CALL INTLOG(JP_ERROR,
     X    'INTUVGH: Wind component into GRIB encoding fail',IRET)
        INTUVGH = JPROUTINE + 4
        GOTO 900
      ENDIF
C
      IRET = INTUVDH(SWORK(1+(ISIZE/2)),NUMPTS,KVGRIBO,OUTLENV,'C',IN_V)
      IF( IRET.NE.0 ) THEN
        CALL INTLOG(JP_ERROR,
     X    'INTUVGH: Wind component into GRIB encoding fail',IRET)
        INTUVGH = JPROUTINE + 4
        GOTO 900
      ENDIF
C
C     -----------------------------------------------------------------|
C*    Section 9.   Return
C     -----------------------------------------------------------------|
C
  900 CONTINUE
C
C     Clear change flags for next product processing and reset wind flag
C
      LCHANGE = .FALSE.
      LSMCHNG = .FALSE.
      LWINDSET  = LOLDWIND
C
      RETURN
      END

C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      INTEGER FUNCTION HNTFBU( FLDIN,INLEN,FLDOUT,OUTLEN)
C
C---->
C**** HNTFBU
C
C     Purpose
C     -------
C
C     Interpolate input field...
C
C
C     Interface
C     ---------
C
C     IRET = HNTFBU( FLDIN,INLEN,FLDOUT,OUTLEN)
C
C     Input
C     -----
C
C     FLDIN  - Input field (unpacked).
C     INLEN  - Input field length (words).
C
C
C     Output
C     ------
C
C     FLDOUT  - Output field (unpacked).
C     OUTLEN  - Output field length (words).
C
C
C     Method
C     ------
C
C     Call interpolation routines; then repack if GRIB output.
C
C     Currently, subareas are not supported for reduced gaussian fields.
C     (Works OK; but need to setup values in GRIB product for number of
C      points in each latitude row)
C
C
C     Externals
C     ---------
C
C     IARCNTL - Control interp. quasi reg.Gauss -> Gaussian or lat/long
C     IAGCNTL - Control interpolation reg.Gaussian or lat/long fields.
C     JSH2SH  - Changes resolution of a field of spectral coefficients.
C     JALLGP  - Converts spectral input fields to lat/long grid fields.
C     JALLWN  - Converts spectral input wind fields to lat/long grids.
C     JAGGGP  - Converts spectral input fields to a gaussian grid field.
C     IBASINI - Ensure basic interpolation setup is done.
C     RESET_C - Reset interpolation handling options using GRIB product.
C     JMEMHAN - Handles memory allocation.
C     IGLSIZE - Evaluate array sizes for reg. lat/long and area.
C     IGSIZE  - Evaluate array sizes for a regular Gaussian.
C     IRSIZE  - Evaluate array sizes for a quasi reg Gaussian.
C     FIXAREA - Fixup area definition to correspond to grid definitions
C     ISCRSZ  - Calculate number of values in generated field.
C     INTLOG  - Log error message.
C
C
C     Author
C     ------
C
C     J.D.Chambers     ECMWF     Aug 1994
C
C     J.D.Chambers     ECMWF        Feb 1997
C     Allow for 64-bit pointers
C
C----<
C
      IMPLICIT NONE
C
C     Function arguments
      INTEGER INLEN,OUTLEN
      REAL FLDIN(*),FLDOUT(*)
C
#include "parim.h"
#include "nifld.common"
#include "nofld.common"
#include "grfixed.h"
#include "intf.h"
C
C     Parameters
      INTEGER JPROUTINE
      INTEGER JPALLOC, JPSCR16
      PARAMETER (JPROUTINE = 26600 )
      PARAMETER (JPALLOC = 1 )
      PARAMETER (JPSCR16 = 16 )
C
C     Local variables
C
      INTEGER IERR, ISIZE, IUV
      REAL PNORTH, PSOUTH, PWEST, PEAST, PLATINC, PLONINC
      LOGICAL OIWEGLOBE, OINPOLE, OISPOLE
      LOGICAL OOWEGLOBE, OONPOLE, OOSPOLE
      INTEGER KILN, KITOTAL, KOLN, KOTOTAL, KPR, KERR
      INTEGER LOOP
#ifndef _CRAYFTN
#ifdef POINTER_64
      INTEGER*8 IZNFLDO
#endif
#endif
      REAL ZNFLDO
      POINTER ( IZNFLDO, ZNFLDO )
      DIMENSION ZNFLDO( 1 )
C
C     Externals
      INTEGER IGLSIZE, IGSIZE, IRSIZE, IARCNTL, IAGCNTL
      INTEGER FIXAREA, ISCRSZ
C
C ------------------------------------------------------------------
C*    Section 1.   Initialise
C ------------------------------------------------------------------
C
  100 CONTINUE
      HNTFBU = 0
      IERR = 0
      KPR = 0
C
C     Allocate work array ZNFELDI if not already done.
C
      IF( IZNJDCI.NE.1952999238 ) THEN
        CALL JMEMHAN( 19, IZNFLDI, JPEXPAND, 1, IERR)
        IF( IERR.NE.0 ) THEN
          CALL INTLOG(JP_WARN,'HNTFBU: znfeldi allocate fail',JPQUIET)
          HNTFBU = IERR
          GOTO 900
        ENDIF
        IZNJDCI = 1952999238
      ENDIF
C
C ------------------------------------------------------------------
C*    Section 3.   Interpolation spherical harmonics to spherical
C                  harmonics
C ------------------------------------------------------------------
C
  300 CONTINUE
C
      IF ( ((NIREPR.EQ.JPSPHERE).OR.(NIREPR.EQ.JPSPHROT)) .AND.
     X     ((NOREPR.EQ.JPSPHERE).OR.(NOREPR.EQ.JPSPHROT)) ) THEN
C
C       Get scratch space for interpolation
C
        ISIZE = ISCRSZ()
        IF ( ISIZE .LE. 0 ) THEN
          CALL INTLOG(JP_ERROR,'HNTFBU: Get scratch space failed',ISIZE)
          HNTFBU = JPROUTINE + 2
          GOTO 900
        ENDIF
        CALL JMEMHAN( JPSCR16, IZNFLDO, ISIZE, JPALLOC, IERR)
        IF ( IERR .NE. 0 ) THEN
          CALL INTLOG(JP_ERROR,'HNTFBU: Get scratch space fail',JPQUIET)
          HNTFBU = JPROUTINE + 2
          GOTO 900
        ENDIF
C
        CALL SH2SH( ZNFELDI, NIRESO, ZNFLDO, NORESO )
C
        GOTO 700
C
C     If not spectral -> spectral transformation, make sure the input
C     and output area definitions have been setup.
C
      ELSE
C
C       Fixup area definition to correspond to grid definitions
C
        IERR = FIXAREA()
        IF ( IERR .NE. 0 ) THEN
          CALL INTLOG(JP_ERROR,
     X      'HNTFBU: Fixup area definition failed.',JPQUIET)
          HNTFBU = JPROUTINE + 9
          GOTO 900
        ENDIF
C
C       Setup geographical limits
C
        PNORTH = FLOAT( NOAREA(1) ) / PPMULT
        PWEST  = FLOAT( NOAREA(2) ) / PPMULT
        PSOUTH = FLOAT( NOAREA(3) ) / PPMULT
        PEAST  = FLOAT( NOAREA(4) ) / PPMULT
C
      ENDIF
C
C ------------------------------------------------------------------
C     Section 4.   Interpolation spherical harmonics to grid point.
C ------------------------------------------------------------------
C
  400 CONTINUE
C
      IF ( (NIREPR.EQ.JPSPHERE).OR.(NIREPR.EQ.JPSPHROT) ) THEN
C
        ISIZE = ISCRSZ()
        IF ( ISIZE .LE. 0 ) THEN
          CALL INTLOG(JP_ERROR,'HNTFBU: Get scratch space failed',ISIZE)
          HNTFBU = JPROUTINE + 2
          GOTO 900
        ENDIF
C
        CALL JMEMHAN( JPSCR16, IZNFLDO, ISIZE, JPALLOC, IERR)
        IF ( IERR .NE. 0 ) THEN
          CALL INTLOG(JP_ERROR,'HNTFBU: Get scratch space fail',JPQUIET)
          HNTFBU = JPROUTINE + 2
          GOTO 900
        ENDIF
C
C       If rotation involved, it has already been done (in hntfau)
C       and values are in znfeldi.
C
        IF( LNOROTA ) THEN
          DO LOOP = 1, ISIZE
            FLDOUT(LOOP) = ZNFELDI(LOOP)
          ENDDO
          OUTLEN = ISIZE
          GOTO 900
        ENDIF
C
C       Get scratch space for interpolation
C
C
C       Setup wind flag
        IF ( LWIND ) THEN
          IUV = 1
        ELSE
          IUV = 0
        ENDIF
C
C ------------------------------------------------------------------
C*    Section 4.1  Interpolation spherical harmonics to grid point.
C ------------------------------------------------------------------
C
  410 CONTINUE
C
        IF ( NOREPR.EQ.JPREGULAR ) THEN
C
C         -> latitude/longitude grid
C
          PLONINC = FLOAT( NOGRID(1) ) / PPMULT
          PLATINC = FLOAT( NOGRID(2) ) / PPMULT
          IF ( LWIND ) THEN
            CALL JALLWN( ZNFELDI, NIRESO, PNORTH, PSOUTH, PWEST, PEAST,
     X                   PLATINC, PLONINC, ZNFLDO, IERR)
          ELSE
            CALL JALLGP( ZNFELDI, NIRESO, PNORTH, PSOUTH, PWEST, PEAST,
     X                   PLATINC, PLONINC, ZNFLDO, IERR)
          ENDIF
          IF ( IERR .NE. 0 ) THEN
            CALL INTLOG(JP_ERROR,
     X        'HNTFBU: Interpolation of gaussian field failed.',JPQUIET)
            HNTFBU = JPROUTINE + 3
            GOTO 900
          ENDIF
C
          GOTO 700
C
        ENDIF
C
C
        IF ( NOREPR .EQ. JPGAUSSIAN) THEN
C
C         -> regular gaussian grid
C
          CALL JAGGGP( ZNFELDI, NIRESO, PNORTH, PSOUTH, PWEST, PEAST,
     X                 NOGAUSS, 'U', NOLPTS, ZNFLDO, IUV, IERR)
          IF ( IERR .NE. 0 ) THEN
            CALL INTLOG(JP_ERROR,
     X        'HNTFBU: Interpolation of gaussian field failed.',JPQUIET)
            HNTFBU = JPROUTINE + 4
            GOTO 900
          ENDIF
C
          GOTO 700
C
        ENDIF
C
C
        IF ( NOREPR .EQ. JPQUASI) THEN
C
C         -> reduced gaussian grid
C
          CALL JAGGGP( ZNFELDI, NIRESO, PNORTH, PSOUTH, PWEST, PEAST,
     X                 NOGAUSS, 'U', NOLPTS, ZNFLDO, IUV, IERR)
          IF ( IERR .NE. 0 ) THEN
            CALL INTLOG(JP_ERROR,
     X        'HNTFBU: Interpolation of gaussian field failed.',JPQUIET)
            HNTFBU = JPROUTINE + 4
            GOTO 900
          ENDIF
C
          GOTO 700
C
        ENDIF
C
C       Dropthrough => unrecognized output field type
C
        IERR   = JPROUTINE + 1
        CALL INTLOG(JP_ERROR,
     X    'HNTFBU: Unrecognized output field type.',NOREPR)
        HNTFBU = IERR
        GOTO 900
C
      ENDIF
C
C ------------------------------------------------------------------
C     Section 5.   Interpolate Gaussian grid to grid point.
C ------------------------------------------------------------------
C
  500 CONTINUE
C
C     Setup flags for input and output fields
C
      KERR = 1
      IF (NIREPR .EQ. JPQUASI) THEN
        IERR = IRSIZE( NIGAUSS, NIAREA, MILLEN, NIWE, NINS, KILN,
     X                 KITOTAL, RIGAUSS, OIWEGLOBE, OINPOLE, OISPOLE,
     X                 KPR, KERR)
      ELSE IF ( NIREPR .EQ. JPGAUSSIAN ) THEN
          IERR = IGSIZE( NIGAUSS, NIAREA, NIWE, NINS, KILN, RIGAUSS,
     X                    OIWEGLOBE, OINPOLE, OISPOLE, KPR, KERR)
      ELSE
        IERR = IGLSIZE( NIGRID, NIAREA, NIWE, NINS, KILN, OIWEGLOBE,
     X                  OINPOLE, OISPOLE, KPR, KERR)
      ENDIF
C
      NONS = 0
      NOWE = 0
      IF (NOREPR .EQ. JPQUASI) THEN
        IERR = IRSIZE( NOGAUSS, NOAREA, NOLPTS, NOWE, NONS, KOLN,
     X                 KOTOTAL, ROGAUSS, OOWEGLOBE, OONPOLE, OOSPOLE,
     X                 KPR, KERR)
      ELSE IF ( NOREPR .EQ. JPGAUSSIAN ) THEN
          IERR = IGSIZE( NOGAUSS, NOAREA, NOWE, NONS, KOLN, ROGAUSS,
     X                    OOWEGLOBE, OONPOLE, OOSPOLE, KPR, KERR)
      ELSE
        IERR = IGLSIZE( NOGRID, NOAREA, NOWE, NONS, KOLN, OOWEGLOBE,
     X                  OONPOLE, OOSPOLE, KPR, KERR)
      ENDIF
C
      IF ( IERR .NE. 0 ) THEN
        CALL INTLOG(JP_ERROR,
     X    'HNTFBU: Interpolation of gaussian field failed.',IERR)
        HNTFBU = JPROUTINE + 6
        GOTO 900
      ENDIF
C
C
C ------------------------------------------------------------------
C     Section 5.1  Interpolate reduced Gaussian grid to grid point.
C ------------------------------------------------------------------
C
  510 CONTINUE
C
C
      ISIZE = ISCRSZ()
      IF ( ISIZE .LE. 0 ) THEN
        CALL INTLOG(JP_ERROR,'HNTFBU: Get scratch space failed.',ISIZE)
        HNTFBU = JPROUTINE + 2
        GOTO 900
      ENDIF
      CALL JMEMHAN( JPSCR16, IZNFLDO, ISIZE, JPALLOC, IERR)
      IF ( IERR .NE. 0 ) THEN
        CALL INTLOG(JP_ERROR,'HNTFBU: Get scratch space fail.',JPQUIET)
        HNTFBU = JPROUTINE + 2
        GOTO 900
      ENDIF
C
      IF (NIREPR .EQ. JPQUASI) THEN
        IERR = IARCNTL( ZNFELDI, JPEXPAND, ZNFLDO, ISIZE, KILN,
     X                  OIWEGLOBE, OINPOLE, OISPOLE, KOLN, OOWEGLOBE,
     X                  OONPOLE, OOSPOLE, KPR ,KERR)
        IF ( IERR .NE. 0 ) THEN
          CALL INTLOG(JP_ERROR,
     X      'HNTFBU: Interpolation of gaussian field failed.',IERR)
          HNTFBU = JPROUTINE + 7
          GOTO 900
        ENDIF
C
        GOTO 700
C
      ENDIF
C
C ------------------------------------------------------------------
C*    Section 6.   Interpolate regular grid point to grid point.
C ------------------------------------------------------------------
C
  600 CONTINUE
C
      IERR = IAGCNTL( ZNFELDI, JPEXPAND, ZNFLDO, ISIZE, KILN,
     X                OIWEGLOBE, OINPOLE, OISPOLE, KOLN, OOWEGLOBE,
     X                OONPOLE, OOSPOLE, KPR, KERR)
      IF ( IERR .NE. 0 ) THEN
        CALL INTLOG(JP_ERROR,
     X    'HNTFBU: Interpolation of gaussian field failed.',IERR)
        HNTFBU = JPROUTINE + 8
        GOTO 900
      ENDIF
C
C ------------------------------------------------------------------
C*    Section 7.   Move unpacked values to user array.
C ------------------------------------------------------------------
C
  700 CONTINUE
C
      DO 710 LOOP = 1, ISIZE
        FLDOUT( LOOP ) = ZNFLDO( LOOP )
 710  CONTINUE
C
C     Return the number of values, the unpacked array length
C
      OUTLEN = ISIZE
C
C ------------------------------------------------------------------
C*    Section 9.   Closedown.
C ------------------------------------------------------------------
C
  900 CONTINUE
C
C     Clear change flags for next product processing
C
      LCHANGE = .FALSE.
      LSMCHNG = .FALSE.
C
      RETURN
      END

C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      INTEGER FUNCTION HNEILL
     X  (L12PNT,KLEN,RLAT,RLON,OLDGRID,
     X   KSCHEME,PDLAT,PDLO0,PDLO1,PDLO2,PDLO3,KLA,NEIGH)
C
C---->
C**** HNEILL
C
C     Purpose
C     -------
C
C     This routine accepts a vector of points and finds the 12
C     neighbours for each point suitable for horizontal interpolation.
C
C
C     Interface
C     ---------
C
C     IRET = HNEILL(L12PNT,KLEN,RLAT,RLON,OLDGRID,
C    X              KSCHEME,PDLAT,PDLO0,PDLO1,PDLO2,PDLO3,KLA,NEIGH)
C
C
C     Input parameters
C     ----------------
C
C     L12PNT  - Chooses between 12-point and 4-point interpolation
C               = .TRUE. for 12-point horizontal
C               = .FALSE. for 4-point
C     KLEN    - Number of points along the vector
C     RLAT    - List of latitudes for points.
C     RLON    - List of longitudes for points.
C     OLDGRID - Grid increments (i/j) for the global lat/long field
C
C
C     Output parameters
C     -----------------
C
C     KSCHEME - Flag showing interpolation scheme to use for point
C               0 = 12-point
C               1 = 4-point bilinear
C               2 = nearest neighbour
C     PDLAT   - Meridian linear weight.
C     PDLO0   - Zonal linear weight for the latitude of point 5.
C     PDLO1   - Zonal linear weight for the latitude of point 1.
C     PDLO2   - Zonal linear weight for the latitude of point 3.
C     PDLO3   - Zonal linear weight for the latitude of point 11.
C     KLA     - Latitude number in original field of latitude north of
C               each point in the vector.
C     NEIGH   - List of indices in the original field of neighbouring
C               point values for each point in the vector.
C
C     Returns 0 if function successful, non-zero otherwise.
C
C     Common block usage
C     ------------------
C
C     None.
C
C
C     Method
C     ------
C
C     Numbering of the points (I is the interpolation point):
C
C                   13       5       6      14
C
C                    7       1       2       8
C                               (I)
C                    9       3       4      10
C
C                   15      11      12      16
C
C     The 12-point interpolation is not possible if either of the top
C     two rows is above the original field northern latitude. The
C     nearest neighbour is used if both rows are above, and a 4-pt
C     bilinear interpolation is used if the top row is above.
C     Similarily, if either of the bottom two rows is below the original
C     field southern latitude.
C
C
C     Externals
C     ---------
C
C     INTLOG  - Log error message.
C     JDEBUG  - Tests if debug output required.
C     JMALLOC - Dynamically allocate memory
C     JFREE   - Free dynamically allocated memory
C
C
C     Reference
C     ---------
C
C     ECMWF Meteorological Bulletin M1.6/7
C     IFS Documentation
C     Part VI: Technical and Computational Procedures (CY21R4)
C     March 2000
C     Section 2.3
C
C
C     Comments
C     --------
C
C     None.
C
C
C     Author
C     ------
C
C     J.D.Chambers      ECMWF      January 2001
C
C
C     Modifications
C     -------------
C
C     None.
C
C----<
C     -----------------------------------------------------------------|
C*    Section 0. Definition of variables.
C     -----------------------------------------------------------------|
C
      IMPLICIT NONE
#include "parim.h"
C
C     Parameters
C
      INTEGER JP12PT, JP4PT, JPNEARN
      PARAMETER (JP12PT  = 0)
      PARAMETER (JP4PT   = 1)
      PARAMETER (JPNEARN = 2)
C
C     Function arguments
C
      LOGICAL L12PNT
      INTEGER KLEN
      REAL OLDGRID(2), RLAT(KLEN), RLON(KLEN)
C
      INTEGER KLA(KLEN), KSCHEME(KLEN)
      REAL PDLAT(KLEN),PDLO0(KLEN),PDLO1(KLEN),PDLO2(KLEN),PDLO3(KLEN)
      INTEGER NEIGH(12,*)
C
C     Local variables
C
      INTEGER NEXT, LOOP, NBYTES, NOLDLAT, NOLDLON
      INTEGER NLAT0, NLAT1, NLAT2, NLAT3, NLAT(12), NLONG(12)
      INTEGER NLONG1, NLONG2, NLONG5
      REAL PLATINC, PLONINC
      INTEGER NPREV, ISIZE, ISIZOLD
C
      DATA ISIZOLD/-1/, NPREV/-1/
      SAVE ISIZOLD,NPREV
C
C     Externals
C
      INTEGER JNORSGG
#ifdef POINTER_64
      INTEGER*8 JMALLOC
#else
      INTEGER JMALLOC
#endif
C
C     Statement functions
C
      INTEGER ILAT, NUMLAT, NUMLON
      REAL LAT, LON, PLATIN, LATSTEP, LONSTEP
C
      PLATIN(ILAT,LATSTEP) = 90.0 - REAL(ILAT-1)*LATSTEP
      NUMLAT(LAT,LATSTEP)  = 1 + NINT((90.0 - LAT)/LATSTEP)
      NUMLON(LON,LONSTEP)  = 1 + NINT(LON/LONSTEP )
C
C     -----------------------------------------------------------------|
C     Section 1.  Initialise.
C     -----------------------------------------------------------------|
C
  100 CONTINUE
C
      HNEILL = 0
C
      CALL JDEBUG()
C
      PLATINC = OLDGRID(1)
      PLONINC = OLDGRID(2)
      NOLDLAT = 1 + NINT(180.0/PLATINC)
      NOLDLON = NINT(360.0/PLONINC)
C
C     -----------------------------------------------------------------|
C       Section 2.  Loop through points along the vector.
C     -----------------------------------------------------------------|
C
  200 CONTINUE
C
      DO NEXT = 1,KLEN
C
C       Clear current neighbour indices
C
        DO LOOP = 1, 12
          NEIGH(LOOP,NEXT) = 0
        ENDDO
C
C     -----------------------------------------------------------------|
C       Section 3. Find latitude numbers for neighbours.
C     -----------------------------------------------------------------|
C
  300   CONTINUE
C
C       First find latitude numbers to north and south of the point
C
        NLAT1 = NUMLAT(RLAT(NEXT),PLATINC)
        NLAT2 = NLAT1 + 1
C
C       Find outer latitude numbers further north and south of the point
C
        NLAT0 = NLAT1 - 1
        NLAT3 = NLAT2 + 1
C
C     -----------------------------------------------------------------|
C       Section 4. Nearest neighbour to be used.
C     -----------------------------------------------------------------|
C
  400   CONTINUE
C
        IF( (NLAT1.LT.1).OR.(NLAT2.GT.NOLDLAT) ) THEN
C
C         On northern/southern latitude of original field, so use
C         nearest neighbours (point 1 or 2)
C
          IF( NLAT1.LT.1 ) NLAT1 = 1
C
          IF( NLAT2.GT.NOLDLAT ) NLAT1 = NOLDLAT
C
          NLONG(1) = NUMLON(RLON(NEXT),PLONINC)
          NLONG1   = NLONG(1)
          IF( NLONG(1).GT.NOLDLON ) NLONG(1) = 1
          NLONG(2) = NLONG(1) + 1
          NLONG2   = NLONG(2)
          IF( NLONG(2).GT.NOLDLON ) NLONG(2) = 1
C
          IF( ABS((RLON(NEXT) - REAL(NLONG1-1)*PLONINC )) .LE.
     X        ABS((RLON(NEXT) - REAL(NLONG2-1)*PLONINC )) ) THEN
            NEIGH(1,NEXT) = (NLAT1-1)*NOLDLON + NLONG(1)
          ELSE
            NEIGH(1,NEXT) = (NLAT1-1)*NOLDLON + NLONG(2)
          ENDIF
          KSCHEME(NEXT) = JPNEARN
          GOTO 700
        ENDIF
C
C     -----------------------------------------------------------------|
C       Section 5. 4-point bilinear to be used.
C     -----------------------------------------------------------------|
C
  500   CONTINUE
C
        IF( (NLAT0.LT.1).OR.(NLAT3.GT.NOLDLAT).OR.
     X      (.NOT.L12PNT) ) THEN
C
          CALL INTLOG(JP_DEBUG,
     X      'HNEILL: 4-pt bilinear interpolation used for point ',NEXT)
C
C         Between two northern latitudes or two southern latitudes of
C         original field, so use 4-point bilinear interpolation
C         (points 1, 2, 3 and 4)
C
C         Points 1 and 2
C
          NLONG(1) = NUMLON(RLON(NEXT),PLONINC)
          NLONG1   = NLONG(1)
          IF( NLONG(1).GT.NOLDLON ) NLONG(1) = 1
C
          NEIGH(1,NEXT) = (NLAT1-1)*NOLDLON + NLONG(1) + 1
          NEIGH(2,NEXT) = NEIGH(1,NEXT) + 1
C
C         Points 3 and 4
C
          NLONG( 3) = NLONG(1)
C
          NEIGH(3,NEXT) = (NLAT2-1)*NOLDLON + NLONG(3) + 1
          NEIGH(4,NEXT) = NEIGH(3,NEXT) + 1
C
C         Calculate zonal linear weights for the latitudes.
C
          PDLO1(NEXT) = (RLON(NEXT)-REAL(NLONG1-1)*PLONINC) / PLONINC
          PDLO2(NEXT) = PDLO1(NEXT)
C
          KLA(NEXT) = NLAT1
          PDLAT(NEXT) = (PLATIN(NLAT1,PLATINC)-RLAT(NEXT)) / PLATINC
C
          KSCHEME(NEXT) = JP4PT
          GOTO 700
        ENDIF
C
C     -----------------------------------------------------------------|
C       Section 6. 12-point interpolation to be used.
C     -----------------------------------------------------------------|
C
  600   CONTINUE
C
        KSCHEME(NEXT) = JP12PT
C
        KLA(NEXT) = NLAT1
        PDLAT(NEXT) = (PLATIN(NLAT1,PLATINC)-RLAT(NEXT)) / PLATINC
C
C       Northernmost
C
        NLAT(5) = NLAT0
        NLAT(6) = NLAT0
C
C       Northern
C
        NLAT(7) = NLAT1
        NLAT(1) = NLAT1
        NLAT(2) = NLAT1
        NLAT(8) = NLAT1
C
C       Southern
C
        NLAT( 9) = NLAT2
        NLAT( 3) = NLAT2
        NLAT( 4) = NLAT2
        NLAT(10) = NLAT2
C
C       Southernmost
C
        NLAT(11) = NLAT3
        NLAT(12) = NLAT3
C
C       Find longitude numbers for neighbours.
C
C       Northernmost
C
        NLONG(5) = NUMLON(RLON(NEXT),PLONINC)
        NLONG5 = NLONG(5)
        IF( NLONG(5).GT.NOLDLON ) NLONG(5) = 1
        NLONG(6) = NLONG(5) + 1
        IF( NLONG(6).GT.NOLDLON ) NLONG(6) = 1
C
C       Northern
C
        NLONG(1) = NLONG(5)
        NLONG(7) = NLONG(1) - 1
        IF( NLONG(7).LT.1 ) NLONG(7) = NOLDLON
        NLONG(2) = NLONG(1) + 1
        IF( NLONG(2).GT.NOLDLON ) NLONG(2) = 1
        NLONG(8) = NLONG(2) + 1
        IF( NLONG(8).GT.NOLDLON ) NLONG(8) = 1
C
C       Southern
C
        NLONG( 3) = NLONG(1)
        NLONG( 9) = NLONG(7)
        NLONG( 4) = NLONG(2)
        NLONG(10) = NLONG(8)
C
C       Southernmost
C
        NLONG(11) = NLONG(5)
        NLONG(12) = NLONG(11) + 1
        IF( NLONG(12).GT.NOLDLON ) NLONG(12) = 1
C
C       Calculate zonal linear weights for the latitudes.
C
        PDLO0(NEXT) = (RLON(NEXT)-REAL(NLONG5-1)*PLONINC) / PLONINC
        PDLO1(NEXT) = PDLO0(NEXT)
        PDLO2(NEXT) = PDLO0(NEXT)
        PDLO3(NEXT) = PDLO0(NEXT)
C
C       Store indices of the neighbours.
C
        DO LOOP = 1, 12
          NEIGH(LOOP,NEXT) = NOLDLON*(NLAT(LOOP)-1) + NLONG(LOOP)
        ENDDO
C
  700  CONTINUE
C
      ENDDO
C
C     End of loop along vector of points.
C
C     -----------------------------------------------------------------|
C     Section 9.  Return
C     -----------------------------------------------------------------|
C
  900 CONTINUE
C
      RETURN
      END

C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C


      SUBROUTINE CONFP2 (PVAL,KEXP,KMANT,KBITS)
C
C---->
C**** CONFP2 - Convert floating point number to GRIb representation.
C
C     Purpose.
C     --------
C
C           Convert floating point number from machine
C           representation to GRIB representation.
C
C**   Interface.
C     ----------
C
C           CALL CONFP2 (PVAL,KEXP,KMANT,KBITS)
C
C           INTEGER    K.
C           REAL       P.
C           LOGICAL    O.
C           CHARACTER  H.
C
C               Input Parameters.
C               -----------------
C
C               PVAL    - Floating point number to be converted.
C
C               KBITS   - Number of bits in computer word.
C
C               Output Parameters.
C               -----------------
C
C               KEXP    - 8 Bit signed exponent.
C
C               KMANT   - 24 Bit mantissa.
C
C     Method.
C     -------
C
C           Floating point number represented as 8 bit exponent
C           and 24 bit mantissa in integer values.
C
C     Externals.
C     ----------
C
C           None.
C
C     Reference.
C     ----------
C
C           WMO Manual on Codes re GRIB representation.
C
C     Comments.
C     ---------
C
C           Rewritten from CONFP, to include number of bits per
C           computer word, to unite slightly different versions of
C           CONFP.
C
C           Routine contains sections 0 to 2 and section 9.
C
C     Author.
C     -------
C
C           John Hennessy   ECMWF   19.03.91
C
C     Modifications.
C     --------------
C
C           None.
C
C     -----------------------------------------------------------------
C----<
C
C
C
C
C
C
C
C
C
C
C*    Section 0 . Definition of variables.
C     -----------------------------------------------------------------
C
      IMPLICIT LOGICAL     ( L , O , G )
      IMPLICIT CHARACTER*8 ( C , H , Y )
      IMPLICIT INTEGER     ( I , J , K , M , N )
C
C     -----------------------------------------------------------------
C
C
C
C
C
C
C
C
C
C
C*    Section 1 . Convert value of 0.0.
C     -----------------------------------------------------------------
C
  100 CONTINUE
C
      IF (PVAL.EQ.0.0)
     C   THEN
             KEXP  = 0
             KMANT = 0
             GO TO 900
         ENDIF
C
C     -----------------------------------------------------------------
C
C
C
C
C
C
C
C
C
C
C*    Section 2 . Convert other values.
C     -----------------------------------------------------------------
C
  200 CONTINUE
C
      ZEPS = 1.0E-12
      IF (KBITS.EQ.32) ZEPS = 1.0E-8
      ZREF = PVAL
C
C     Sign of value.
C
      ISIGN = 0
      IF (ZREF.LT.0.)
     C   THEN
             ISIGN = 128
             ZREF  = - ZREF
         ENDIF
C
C     Exponent.
C
      KEXP = INT(ALOG(ZREF)*(1.0/ALOG(16.0))+64.0+1.0+ZEPS)
C
      IF (KEXP.LT.0  ) KEXP = 0
      IF (KEXP.GT.127) KEXP = 127
C
C     Mantissa.
C
      KMANT = INT (ZREF/16.0**(KEXP-70))
C
C     Add sign bit to exponent.
C
      KEXP = KEXP + ISIGN
C
C     -----------------------------------------------------------------
C
C
C
C
C
C
C
C
C
C
C*    Section 9. Return to calling routine.
C     -----------------------------------------------------------------
C
  900 CONTINUE
C
      RETURN
C
      END

C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE BUOCTN(KWPTB,KBPTB,KBUFL,KBUFF,KERR)
C
C**** *BUOCTN*
C
C
C     PURPOSE.
C     --------
C             CALCULATE NUMBER OF OCTETS FROM BIT POSITION DEFINED BY
C     KWPT,KBPT  AND KWPTB,KBPTB; NUMBER OF OCTETS MUST BE EVEN. IF IT IS
C     NEEDED PADING WITH 0 BIT PERFORMS. NUMBER OF OCTETS IS WRITTEN AT
C     BEGINIG OF THE SECTION.
C
C**   INTERFACE.
C     ----------
C
C          *CALL* *BUOCTN(KWPTB,KBPTB,KBUFL,KBUFF,KERR)*
C
C        INPUT :
C               *KWPTB*    - WORD POINTER TO THE BEGINING OF SECTION
C               *KBPTB*    - BIT  POINTER TO THE BEGINING OF SECTION
C        OUTPUT :
C               *KBUFL*   -  LENGTH OF BUFR MESSAGE (WORDS)
C               *KBUFF*   -  ARRAY CONTAINING BUFR MESSAGE
C               *KERR*    -  RETURNED ERROR CODE
C
C
C     *METHOD.
C      -------
C
C          NONE.
C
C     EXTERNALS.
C     ----------
C
C          BUPCK       - PACK BIT PATHERN AND RESETS POINTERS
C          SBYTE       - PACK BIT PATHERN
C
C
C     REFERENCE.
C     ----------
C
C          NONE.
C
C     AUTHOR.
C     -------
C
C          M. DRAGOSAVAC    *ECMWF*       07/10/87.
C
C
C     MODIFICATIONS.
C     --------------
C
C          NONE.
C
C
      IMPLICIT LOGICAL(L,O,G), CHARACTER*8(C,H,Y)
C
C
C
#     include "parameter.F"
#     include "bcomunit.F"
#     include "bcmwork.F"
C
      DIMENSION KBUFF(KBUFL)
#ifndef R_4
      REAL*8 RVIND
      REAL*8 EPS
#else
      REAL   RVIND
      REAL   EPS
#endif
C
C     ------------------------------------------------------------------
C*          1.    CALCULATE NUMBER OF OCTETS.
C                 ---------------------------
 100  CONTINUE
C
      IF(KERR.GT.0) RETURN
C
      IB   =(NWPT-1) * NBPW + NBPT
      IBB  =(KWPTB-1)* NBPW + KBPTB
C
      IDIFB= IB - IBB
C
      NOCT = IDIFB/8
      IBDW = IDIFB - NOCT*8
C
      IF(IBDW .NE.0)THEN
         NOCT=NOCT+1
         IBDW=8-IBDW
         CALL BUPCK(NBPW,KBUFF(NWPT),0,NWPT,NBPT,IBDW,KERR)
         IF(KERR.GT.0) THEN
            CALL BUERR(KERR)
            RETURN
         END IF
      END IF
C
C     ------------------------------------------------------------------
C*          2.  CHECK IF THERE ARE EVEN NUMBER OF OCTETS IN BLOCK.
C               --------------------------------------------------
 200  CONTINUE
C
      IF(NEDN.LE.3) THEN
         IF(MOD(NOCT,2).NE.0) THEN
             IBDW = 8
             CALL BUPCK(NBPW,KBUFF(NWPT),0,NWPT,NBPT,IBDW,KERR)
             IF(KERR.GT.0) THEN
               CALL BUERR(KERR)
               RETURN
             END IF
             NOCT = NOCT+1
         END IF
      END IF
C     ------------------------------------------------------------------
C*          3.  WRITE NUMBER OF OCTETS AT BEGINING OF BLOCK.
C               --------------------------------------------
 300  CONTINUE
C
      IBDW  = 24
      CALL SBYTE(KBUFF(KWPTB),NOCT,KBPTB,IBDW)
C
      RETURN
      END

C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE GRPRS2 (KSEC0,KSEC2,PSEC2)
C
C---->
C**** GRPRS2 - Print information from Section 2 of GRIB code.
C
C     Purpose.
C     --------
C
C     Print the information in the Grid Description
C     Section (Section 2) of decoded GRIB data.
C
C**   Interface.
C     ----------
C
C     CALL GRPRS2 (KSEC0,KSEC2,PSEC2)
C
C
C     Input Parameters.
C     -----------------
C
C     KSEC0 - Array of decoded integers from Section 0.
C
C     KSEC2 - Array of decoded integers from Section 2.
C
C     PSEC2 - Array of decoded reals from Section 2.
C
C
C     Output Parameters.
C     ------------------
C
C     None.
C
C
C     Method.
C     -------
C
C     Flag fields are printed in binary representation
C     Other fields as integers or reals, as appropriate.
C     Fields printed depend on GRIB Edition.
C
C
C     Externals.
C     ----------
C
C     PRTBIN   - Print binary representation of value.
C     PTQUASI  - Print quasi-grid data.
C
C     Common block GRPRSCM.
C
C
C     Reference.
C     ----------
C
C     WMO Manual on Codes re GRIB Code.
C
C
C     Comments.
C     ---------
C
C     Only data representation types catered for are Gaussian
C     grid, latitude/longitude grid, Spherical Harmonics,
C     Polar stereographic and Space view perspective.
C
C
C     Author.
C     -------
C
C     J. Hennessy    ECMWF 18.06.91
C
C
C     Modifications.
C     --------------
C
C     J. Hennessy    ECMWF        02.09.91
C     Polar stereographic print added.
C
C     J. Hennessy    ECMWF        25.09.91
C     Space view perspective print added.
C
C     J.D.Chambers   ECMWF        21.02.95
C     Quasi-regular lat/long grids added.
C
C     J.D.Chambers     ECMWF      03.04.95
C     Allow Lambert conformal.
C
C     J.D.Chambers   ECMWF    June 2002
C     Add option to set output stream number using environment variable
C     GRPRS_STREAM
C
C     J.D.Chambers     ECMWF      July 2004
C     Allow Mercator
C
C
C----<
C     -----------------------------------------------------------------
C*    Section 0. Definition of variables.
C     -----------------------------------------------------------------
C
      IMPLICIT NONE
C
#include "grprs.h"
C
C     Subroutine arguments
C
      INTEGER KSEC0,KSEC2
      DIMENSION KSEC0(*)
      DIMENSION KSEC2(*)
      REAL PSEC2
      DIMENSION PSEC2(*)
C
C     Local variables
C
      INTEGER I, IBIT, IEDIT, IERR, IOUT, IRESOL
C
C
C     -----------------------------------------------------------------|
C*    Section 1 . Print GRIB Edition number.
C     -----------------------------------------------------------------|
C
  100 CONTINUE
C
      IEDIT = KSEC0(2)
      WRITE(GRPRSM,9000)
      WRITE(GRPRSM,9001)
      WRITE(GRPRSM,9002)
C
C     -----------------------------------------------------------------|
C*    Section 2 . Print spherical harmonic data.
C     -----------------------------------------------------------------|
C
  200 CONTINUE
C
      IF (KSEC2(1).EQ.50 .OR. KSEC2(1).EQ.60 .OR.
     X    KSEC2(1).EQ.70 .OR. KSEC2(1).EQ.80) THEN
        WRITE(GRPRSM,9111) KSEC2(1)
        WRITE(GRPRSM,9102) KSEC2(2)
        WRITE(GRPRSM,9103) KSEC2(3)
        WRITE(GRPRSM,9104) KSEC2(4)
        WRITE(GRPRSM,9105) KSEC2(5)
        WRITE(GRPRSM,9106) KSEC2(6)
        DO I = 7, 11
          WRITE(GRPRSM,9107) KSEC2(I)
        ENDDO
        WRITE(GRPRSM,9212) KSEC2(12)
	GO TO 800
C
      ENDIF
C
C     -----------------------------------------------------------------|
C*    Section 3 . Print Gaussian grid data.
C     -----------------------------------------------------------------|
C
  300 CONTINUE
C
      IF (KSEC2(1).EQ.4 .OR. KSEC2(1).EQ.14 .OR.
     X    KSEC2(1).EQ.24 .OR. KSEC2(1).EQ.34) THEN
	WRITE(GRPRSM,9200)
        WRITE(GRPRSM,9112) KSEC2(1)
C
C       Quasi-regular grids introduced in Edition 1.
C
	IF (KSEC2(17).EQ.0.OR.IEDIT.LT.1) THEN
          WRITE(GRPRSM,9201) KSEC2(2)
	ELSE
          CALL PTQUASI(KSEC2)
        ENDIF
        WRITE(GRPRSM,9202) KSEC2(3)
        WRITE(GRPRSM,9203) KSEC2(4)
        WRITE(GRPRSM,9204) KSEC2(5)
        IBIT = 8
	IRESOL = KSEC2(6) + KSEC2(18) + KSEC2(19)
        CALL PRTBIN (IRESOL,IBIT,IOUT,IERR)
        WRITE(GRPRSM,9205) IOUT
        WRITE(GRPRSM,9206) KSEC2(7)
        WRITE(GRPRSM,9207) KSEC2(8)
C
C       Print increment if given.
C
        IF (KSEC2(6).EQ.128) THEN
          WRITE(GRPRSM,9208) KSEC2(9)
	ELSE
	  WRITE(GRPRSM,9236)
        ENDIF
        WRITE(GRPRSM,9210) KSEC2(10)
        IBIT = 8
        CALL PRTBIN (KSEC2(11),IBIT,IOUT,IERR)
        WRITE(GRPRSM,9211) IOUT
        WRITE(GRPRSM,9212) KSEC2(12)
	GO TO 800
C
      ENDIF
C
C     -----------------------------------------------------------------|
C*    Section 4 . Print Latitude / longitude grid data.
C     -----------------------------------------------------------------|
C
  400 CONTINUE
C
      IF (KSEC2(1).EQ.0 .OR. KSEC2(1).EQ.10 .OR.
     X    KSEC2(1).EQ.20 .OR. KSEC2(1).EQ.30) THEN
	WRITE(GRPRSM,9200)
        WRITE(GRPRSM,9113) KSEC2(1)
C
C       Quasi-regular lat/long grids also possible.
C
	IF (KSEC2(17).EQ.0) THEN
          WRITE(GRPRSM,9201) KSEC2(2)
	ELSE
          CALL PTQUASI(KSEC2)
        ENDIF
        WRITE(GRPRSM,9202) KSEC2(3)
        WRITE(GRPRSM,9203) KSEC2(4)
        WRITE(GRPRSM,9204) KSEC2(5)
        IBIT = 8
	IRESOL = KSEC2(6) + KSEC2(18) + KSEC2(19)
        CALL PRTBIN (IRESOL,IBIT,IOUT,IERR)
        WRITE(GRPRSM,9205) IOUT
        WRITE(GRPRSM,9206) KSEC2(7)
        WRITE(GRPRSM,9207) KSEC2(8)
C
C       Print increment if given.
C
        IF ( KSEC2(9) .LT. 0) THEN
          WRITE(GRPRSM,9236)
        ELSE
          WRITE(GRPRSM,9208) KSEC2(9)
        ENDIF
        IF ( KSEC2(10) .LT. 0) THEN
          WRITE(GRPRSM,9237)
        ELSE
          WRITE(GRPRSM,9209) KSEC2(10)
        ENDIF
        IBIT = 8
        CALL PRTBIN (KSEC2(11),IBIT,IOUT,IERR)
        WRITE(GRPRSM,9211) IOUT
        WRITE(GRPRSM,9212) KSEC2(12)
	GO TO 800
C
      ENDIF
C
C     -----------------------------------------------------------------|
C*    Section 5 . Print polar stereographic data.
C     -----------------------------------------------------------------|
C
  500 CONTINUE
C
      IF (KSEC2(1).EQ.5) THEN
	WRITE(GRPRSM,9200)
        WRITE(GRPRSM,9114) KSEC2(1)
        WRITE(GRPRSM,9301) KSEC2(2)
        WRITE(GRPRSM,9302) KSEC2(3)
        WRITE(GRPRSM,9203) KSEC2(4)
        WRITE(GRPRSM,9204) KSEC2(5)
        IBIT = 8
	IRESOL = KSEC2(18) + KSEC2(19)
        CALL PRTBIN (IRESOL,IBIT,IOUT,IERR)
        WRITE(GRPRSM,9205) IOUT
        WRITE(GRPRSM,9303) KSEC2(7)
        WRITE(GRPRSM,9304) KSEC2(9)
        WRITE(GRPRSM,9305) KSEC2(10)
        IBIT = 8
        CALL PRTBIN (KSEC2(11),IBIT,IOUT,IERR)
        WRITE(GRPRSM,9211) IOUT
        WRITE(GRPRSM,9212) KSEC2(12)
        WRITE(GRPRSM,9306) KSEC2(13)
	GO TO 800
C
      ENDIF
C
C     -----------------------------------------------------------------|
C*    Section 6 . Print Lambert conformal data.
C     -----------------------------------------------------------------|
C
  600 CONTINUE
C
      IF (KSEC2(1).EQ.3) THEN
C
        WRITE(GRPRSM,9200)
        WRITE(GRPRSM,9115) KSEC2(1)
        WRITE(GRPRSM,9301) KSEC2(2)
        WRITE(GRPRSM,9302) KSEC2(3)
        WRITE(GRPRSM,9203) KSEC2(4)
        WRITE(GRPRSM,9204) KSEC2(5)
        IBIT = 8
        IRESOL = KSEC2(18) + KSEC2(19) + KSEC2(6)
        CALL PRTBIN (IRESOL,IBIT,IOUT,IERR)
        WRITE(GRPRSM,9205) IOUT
        WRITE(GRPRSM,9303) KSEC2(7)
        WRITE(GRPRSM,9304) KSEC2(9)
        WRITE(GRPRSM,9305) KSEC2(10)
        IBIT = 8
        CALL PRTBIN (KSEC2(11),IBIT,IOUT,IERR)
        WRITE(GRPRSM,9211) IOUT
        WRITE(GRPRSM,9212) KSEC2(12)
        WRITE(GRPRSM,9306) KSEC2(13)
        WRITE(GRPRSM,9214) KSEC2(14)
        WRITE(GRPRSM,9215) KSEC2(15)
        WRITE(GRPRSM,9216) KSEC2(20)
        WRITE(GRPRSM,9217) KSEC2(21)
        GO TO 800
C
      ENDIF
C
C     -----------------------------------------------------------------|
C*    Section 7 . Print space view perspective or orthographic data.
C     -----------------------------------------------------------------|
C
  700 CONTINUE
C
      IF (KSEC2(1).EQ.90) THEN
        WRITE(GRPRSM,9200)
        WRITE(GRPRSM,9116) KSEC2(1)
        WRITE(GRPRSM,9301) KSEC2(2)
        WRITE(GRPRSM,9302) KSEC2(3)
        WRITE(GRPRSM,9310) KSEC2(4)
        WRITE(GRPRSM,9311) KSEC2(5)
        IBIT = 8
	IRESOL = KSEC2(18) + KSEC2(19)
        WRITE(GRPRSM,9312) KSEC2(7)
        WRITE(GRPRSM,9313) KSEC2(8)
        WRITE(GRPRSM,9314) KSEC2(9)
        WRITE(GRPRSM,9315) KSEC2(10)
        IBIT = 8
        CALL PRTBIN (KSEC2(11),IBIT,IOUT,IERR)
        WRITE(GRPRSM,9211) IOUT
        WRITE(GRPRSM,9212) KSEC2(12)
        WRITE(GRPRSM,9303) KSEC2(13)
        WRITE(GRPRSM,9316) KSEC2(14)
        WRITE(GRPRSM,9317) KSEC2(15)
        WRITE(GRPRSM,9318) KSEC2(16)
        WRITE(GRPRSM,9319) KSEC2(18)
        WRITE(GRPRSM,9320) KSEC2(19)
	GO TO 800
C
      ENDIF
C
C     -----------------------------------------------------------------|
C*    Section 7.5 . Print ocean data
C     -----------------------------------------------------------------|
C
  750 CONTINUE
C
      IF( KSEC2(1).EQ.192 ) THEN
        WRITE(GRPRSM,9117) KSEC2(1)
        IF( KSEC2(2).EQ. 32767 ) THEN
          WRITE(GRPRSM,9501) KSEC2(2)
        ELSE
          WRITE(GRPRSM,9502) KSEC2(2)
        ENDIF
C
        IF( KSEC2(3).EQ. 32767 ) THEN
          WRITE(GRPRSM,9503) KSEC2(3)
        ELSE
          WRITE(GRPRSM,9504) KSEC2(3)
        ENDIF
C
        IBIT = 8
        CALL PRTBIN (KSEC2(11),IBIT,IOUT,IERR)
        WRITE(GRPRSM,9211) IOUT
	GO TO 800
      ENDIF
C
C     -----------------------------------------------------------------|
C*    Section 7.6 . Print mercator data
C     -----------------------------------------------------------------|
C
  760 CONTINUE
C
      IF (KSEC2(1).EQ.1) THEN
	WRITE(GRPRSM,9200)
        WRITE(GRPRSM,9118) KSEC2(1)
        WRITE(GRPRSM,9201) KSEC2(2)
        WRITE(GRPRSM,9202) KSEC2(3)
        WRITE(GRPRSM,9203) KSEC2(4)
        WRITE(GRPRSM,9204) KSEC2(5)
        IBIT = 8
	IRESOL = KSEC2(6) + KSEC2(18) + KSEC2(19)
        CALL PRTBIN (IRESOL,IBIT,IOUT,IERR)
        WRITE(GRPRSM,9205) IOUT
        WRITE(GRPRSM,9206) KSEC2(7)
        WRITE(GRPRSM,9207) KSEC2(8)
        WRITE(GRPRSM,9218) KSEC2(9)
        WRITE(GRPRSM,9208) KSEC2(13)
        WRITE(GRPRSM,9209) KSEC2(14)
        IBIT = 8
        CALL PRTBIN (KSEC2(11),IBIT,IOUT,IERR)
        WRITE(GRPRSM,9211) IOUT
        WRITE(GRPRSM,9212) KSEC2(12)
	GO TO 800
      ENDIF
C
C     -----------------------------------------------------------------|
C     Drop through to here => representation type not catered for.
C     -----------------------------------------------------------------|
C
      WRITE(GRPRSM,*)
     X  'GRPRS2 :Data representation type not catered for -', KSEC2(1)
C
      GO TO 900
C
C     -----------------------------------------------------------------|
C*    Section 8 . Print vertical coordinate parameters,
C                 rotated grid information,
C                 stretched grid information, if any.
C     -----------------------------------------------------------------|
C
  800 CONTINUE
C
C     Vertical coordinate parameters ...
C
      IF (KSEC2(12).NE.0) THEN
        WRITE(GRPRSM,9000)
        WRITE(GRPRSM,9400)
        WRITE(GRPRSM,9401)
        DO I = 11, (KSEC2(12)+10)
          WRITE(GRPRSM,9402) PSEC2(I)
        ENDDO
      ENDIF
C
C     Rotated and stretched grids introduced in Edition 1.
C
      IF (IEDIT.LT.1) GO TO 900
C
C*    Rotated grid information ...
C
      IF (KSEC2(1).EQ.10 .OR. KSEC2(1).EQ.30 .OR.
     X    KSEC2(1).EQ.14 .OR. KSEC2(1).EQ.34 .OR.
     X    KSEC2(1).EQ.60 .OR. KSEC2(1).EQ.80 .OR.
     X    KSEC2(1).EQ.30) THEN
        WRITE(GRPRSM,9000)
        WRITE(GRPRSM,9220) KSEC2(13)
        WRITE(GRPRSM,9221) KSEC2(14)
        WRITE(GRPRSM,9222) PSEC2(1)
      ENDIF
C
C*    Stretched grid information ...
C
      IF (KSEC2(1).EQ.20 .OR. KSEC2(1).EQ.30 .OR.
     X    KSEC2(1).EQ.24 .OR. KSEC2(1).EQ.34 .OR.
     X    KSEC2(1).EQ.70 .OR. KSEC2(1).EQ.80) THEN
        WRITE(GRPRSM,9000)
        WRITE(GRPRSM,9230) KSEC2(15)
        WRITE(GRPRSM,9231) KSEC2(16)
        WRITE(GRPRSM,9232) PSEC2(2)
      ENDIF
C
C     -----------------------------------------------------------------|
C*    Section 9 . Format statements. Return to calling routine.
C     -----------------------------------------------------------------|
C
  900 CONTINUE
C
      RETURN
C
 9000 FORMAT (1H )
 9001 FORMAT (1H ,'Section 2 - Grid Description Section.')
 9002 FORMAT (1H ,'-------------------------------------')
 9102 FORMAT (1H ,'J - Pentagonal resolution parameter.         ',I9)
 9103 FORMAT (1H ,'K - Pentagonal resolution parameter.         ',I9)
 9104 FORMAT (1H ,'M - Pentagonal resolution parameter.         ',I9)
 9105 FORMAT (1H ,'Representation type (Table 9)                ',I9)
 9106 FORMAT (1H ,'Representation mode (Table 10).              ',I9)
 9107 FORMAT (1H ,'Not used.                                    ',I9)
 9111 FORMAT (1H ,'Data represent type = spectral     (Table 6) ',I9)
 9112 FORMAT (1H ,'Data represent type = gaussian     (Table 6) ',I9)
 9113 FORMAT (1H ,'Data represent type = lat/long     (Table 6) ',I9)
 9114 FORMAT (1H ,'Data represent type = polar stereo (Table 6) ',I9)
 9115 FORMAT (1H ,'Data represent type = Lambert      (Table 6) ',I9)
 9116 FORMAT (1H ,'Data represent type = space/ortho  (Table 6) ',I9)
 9117 FORMAT (1H ,'Data represent type = ECMWF ocean  (Table 6) ',I9)
 9118 FORMAT (1H ,'Data represent type = Mercator  (Table 6)    ',I9)
C
 9200 FORMAT (1H ,'(Southern latitudes and Western longitudes',
     C            ' are negative.)')
 9201 FORMAT (1H ,'Number of points along a parallel.           ',I9)
 9202 FORMAT (1H ,'Number of points along a meridian.           ',I9)
 9203 FORMAT (1H ,'Latitude of first grid point.                ',I9)
 9204 FORMAT (1H ,'Longitude of first grid point.               ',I9)
 9205 FORMAT (1H ,'Resolution and components flag.               ',I8.8)
 9206 FORMAT (1H ,'Latitude of last grid point.                 ',I9)
 9207 FORMAT (1H ,'Longitude of last grid point.                ',I9)
 9208 FORMAT (1H ,'i direction (East-West) increment.           ',I9)
 9209 FORMAT (1H ,'j direction (North-South) increment.         ',I9)
 9210 FORMAT (1H ,'Number of parallels between pole and equator.',I9)
 9211 FORMAT (1H ,'Scanning mode flags (Code Table 8)            ',I8.8)
 9212 FORMAT (1H ,'Number of vertical coordinate parameters.    ',I9)
C
 9214 FORMAT (1H ,'Latitude intersection 1 - Latin 1 -.         ',I9)
 9215 FORMAT (1H ,'Latitude intersection 2 - Latin 2 -.         ',I9)
 9216 FORMAT (1H ,'Latitude of Southern Pole.                   ',I9)
 9217 FORMAT (1H ,'Longitude of Southern Pole.                  ',I9)
 9218 FORMAT (1H ,'Latitude projection intersects Earth(Latin)  ',I9)
C
 9220 FORMAT (1H ,'Latitude of southern pole of rotation.       ',I9)
 9221 FORMAT (1H ,'Longitude of southern pole of rotation.      ',I9)
 9222 FORMAT (1H ,'Angle of rotation.                     ',F20.10)
C
 9230 FORMAT (1H ,'Latitude of pole of stretching.              ',I9)
 9231 FORMAT (1H ,'Longitude of pole of stretching.             ',I9)
 9232 FORMAT (1H ,'Stretching factor.                     ',F20.10)
 9233 FORMAT (1H ,'Number of points along a parallel varies.')
 9235 FORMAT (1H , I5,16X,A10)
 9236 FORMAT (1H ,'i direction (East-West) increment',
     X        '            Not given')
 9237 FORMAT (1H ,'j direction (North-South) increment',
     X        '          Not given')
C
 9301 FORMAT (1H ,'Number of points along X axis.               ',I9)
 9302 FORMAT (1H ,'Number of points along Y axis.               ',I9)
 9303 FORMAT (1H ,'Orientation of the grid.                     ',I9)
 9304 FORMAT (1H ,'X direction increment.                       ',I9)
 9305 FORMAT (1H ,'Y direction increment.                       ',I9)
 9306 FORMAT (1H ,'Projection centre flag.                      ',I9)
C
 9310 FORMAT (1H ,'Latitude of sub-satellite point.             ',I9)
 9311 FORMAT (1H ,'Longitude of sub-satellite point.            ',I9)
 9312 FORMAT (1H ,'Diameter of the earth in x direction.        ',I9)
 9313 FORMAT (1H ,'Diameter of the earth in y direction.        ',I9)
 9314 FORMAT (1H ,'X coordinate of sub-satellite point.         ',I9)
 9315 FORMAT (1H ,'Y coordinate of sub-satellite point.         ',I9)
 9316 FORMAT (1H ,'Altitude of the camera.                      ',I9)
 9317 FORMAT (1H ,'Y coordinate of origin of sector image.      ',I9)
 9318 FORMAT (1H ,'X coordinate of origin of sector image.      ',I9)
 9319 FORMAT (1H ,'Earth flag                                   ',I9)
 9320 FORMAT (1H ,'Components flag                              ',I9)
C
 9400 FORMAT (1H ,'Vertical Coordinate Parameters.')
 9401 FORMAT (1H ,'-------------------------------')
 9402 FORMAT (4X,F20.12,4X,F20.12)
C
 9501 FORMAT(' Number of points along the first axis.       Not used')
 9502 FORMAT (' Number of points along the first axis.       ',I9)
 9503 FORMAT(' Number of points along the second axis.      Not used')
 9504 FORMAT (' Number of points along the second axis.      ',I9)
C
      END

C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      INTEGER FUNCTION LOCAL2K(KSEC1, HFIRST, HSECOND, HTHIRD, HFOURTH)
C
C---->
C**** LOCAL2K
C
C     Purpose
C     -------
C
C     Looks up the description of a parameter in known table 2 versions
C     for WMO code FM 92-X Ext. GRIB.
C
C
C     Interface
C     ---------
C
C     IRET = LOCAL2K(KSEC1, HFIRST, HSECOND, HTHIRD, HFOURTH)
C
C     Input
C     -----
C
C     KSEC1  - Section 1 values for a GRIB product.
C
C
C     Output
C     ------
C
C     HFIRST  - First line of descriptor:  MARS mnemonic
C     HSECOND - Second line of descriptor: Parameter description
C     HTHIRD  - Third line of descriptor:  Units for the parameter
C     HFOURTH - Fourth line of descriptor: Description of units
C
C     Function return value is
C            0 if no error detected.
C        20001 if no match found for the parameter number in
C              the given table.
C        20002 if there is an error opening the file holding
C              the given table.
C
C
C     Method
C     ------
C
C     Calls LOCAL2.
C
C
C     Externals
C     ---------
C     LOCAL2  - looks up information in standard tables.
C
C
C     Author
C     ------
C
C     J.D.Chambers     ECMWF     Sept 1995
C
C
C     MODIFICATIONS
C     _____________
C
C     J. Clochard, Meteo France, for ECMWF - June 1999.
C     Argument KCENTR added to LOCAL2 call for code tables management.
C
C     _______________________________________________________
C----<
C
C
      IMPLICIT NONE
C
C     Function arguments
      INTEGER KSEC1
      DIMENSION KSEC1(*)
      CHARACTER*(*) HFIRST, HSECOND, HTHIRD, HFOURTH
C
C     Externals
      INTEGER LOCAL2
C
C
C ------------------------------------------------------------------
C*    Section 1.   Initialise
C ------------------------------------------------------------------
C
  100 CONTINUE
C
      LOCAL2K = LOCAL2(KSEC1(1), KSEC1(6), KSEC1(2),
     X                 HFIRST, HSECOND, HTHIRD, HFOURTH)
C
C ------------------------------------------------------------------
C*    Section 9.   Closedown.
C ------------------------------------------------------------------
C
C     Normal return.
 900  CONTINUE
C
      RETURN
      END

C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE ROWINA2( P, KO, KI, PW, KCODE, PMSVAL, KRET)
C
C---->
C**** ROWINA2 - Interpolation of row of values.
C
C     Purpose.
C     --------
C
C     Interpolate a row of values.
C
C
C**   Interface.
C     ----------
C
C     CALL ROWINA2( P, KO, KI, PW, KCODE, PMSVAL, KRET)
C
C
C     Input Parameters.
C     -----------------
C
C     P      - Row of values to be interpolated.
C              Dimension must be at least KO.
C
C     KO     - Number of values required.
C
C     KI     - Number of values in P on input.
C
C     PW     - Working array.
C              Dimension must be at least (0:KO+2,3).
C
C     KCODE  - Interpolation required.
C              1 , linear.
C              3 , cubic.
C
C     PMSVAL - Value used for missing data indicator.
C
C
C     Output Parameters.
C     ------------------
C
C     P     - Now contains KO values.
C     KRET  - Return code
C             0, OK
C             Non-zero, error
C
C
C     Method.
C     -------
C
C     Linear or cubic interpolation performed as required.
C
C
C     Externals.
C     ----------
C
C     SCM0
C
C
C     Reference.
C     ----------
C
C     None.
C
C
C     Comments.
C     ---------
C
C     This is a version of ROWINA which allows for missing data
C     values and hence for bitmapped fields.
C
C
C     Author.
C     -------
C
C     J.D.Chambers    ECMWF     22.07.94
C
C
C     Modifications.
C     --------------
C
C     J.D.Chambers    ECMWF     13.09.94
C     Add return code KRET and remove calls to ABORT.
C
C
C     -----------------------------------------------------------------
C----<
C
C*******************************************************************
C     Section 0.  Declarations.
C*******************************************************************
C
      IMPLICIT NONE
C
C     Subroutine arguments
      REAL P, PW, PMSVAL
      INTEGER KO,KI,KCODE, KRET
      DIMENSION P(KO),PW(0:KO+2,3)
C
C     Local variables
      INTEGER JL, IP
      REAL ZRDI, ZDO, ZPOS, ZWT, ZWT1
C
C*******************************************************************
C     Section 1.  Linear interpolation ..
C*******************************************************************
C
  100 CONTINUE
C
      KRET = 0
C
      IF( KCODE.EQ.1 ) THEN
C
C        Move input values to work array
         DO 110 JL = 1, KI
            PW(JL,1) = P(JL)
  110    CONTINUE
C
C        Arrange wrap-around value in work array
         PW(KI+1,1) = P(1)
C
C        Set up constants to be used to figure out weighting for
C        values in interpolation.
         ZRDI = FLOAT(KI)
         ZDO  = 1.0 / FLOAT(KO)
C
C        Loop through the output points
         DO 120 JL = 1, KO
C
C           Calculate weight from the start of row
            ZPOS = (JL-1) * ZDO
            ZWT  = ZPOS * ZRDI
C
C           Get the current array position(minus 1) from the weight -
C           note the implicit truncation.
            IP   = ZWT
C
C           If the left value is missing, use the right value
            IF ( PW(IP+1,1) .EQ. PMSVAL ) THEN
               P(JL) = PW(IP+2,1)
C
C           If the right value is missing, use the left value
            ELSE IF ( PW(IP+2,1) .EQ. PMSVAL ) THEN
               P(JL) = PW(IP+1,1)
C
C           If neither missing, interpolate ...
            ELSE
C
C             Adjust the weight to range (0.0 to 1.0)
              ZWT  = ZWT - IP
C
C             Interpolate using the weighted values on either side
C             of the output point position
              P(JL) = (1.0-ZWT) * PW(IP+1,1) + ZWT * PW(IP+2,1)
            ENDIF
C
  120    CONTINUE
C
C*******************************************************************
C     Section 2.  Cubic interpolation ..
C*******************************************************************
C
  200 CONTINUE
C
      ELSEIF(KCODE.EQ.3) THEN
         DO 210 JL = 1,KI
            IF ( P(JL) .EQ. PMSVAL ) THEN
              WRITE(*,*) ' ROWINA2: Cubic interpolation not supported'
              WRITE(*,*) ' ROWINA2: for fields containing missing data.'
              WRITE(*,*) ' Sorry!'
	      KRET = 1
              GOTO 900
            ENDIF
            PW(JL,1) = P(JL)
  210    CONTINUE
         PW(0,1) = P(KI)
         PW(KI+1,1) = P(1)
         PW(KI+2,1) = P(2)
         DO 220 JL = 1,KI
            PW(JL,2) =  - PW(JL-1,1)/3.0 - 0.5*PW(JL,1)
     1             + PW(JL+1,1)    - PW(JL+2,1)/6.0
            PW(JL+1,3) =    PW(JL-1,1)/6.0 - PW(JL,1)
     1             + 0.5*PW(JL+1,1) + PW(JL+2,1)/3.0
  220    CONTINUE
         CALL SCM0(PW(1,2),PW(2,3),PW(1,1),PW(2,1),KI)
         ZRDI = FLOAT(KI)
         ZDO = 1.0/FLOAT(KO)
         DO 230 JL = 1,KO
            ZPOS = (JL-1)*ZDO
            ZWT = ZPOS*ZRDI
            IP = ZWT+1
            ZWT = ZWT+1.0-IP
            ZWT1  =  1.0 - ZWT
            P(JL) = ((3.0-2.0*ZWT1)*PW(IP,1) + ZWT*PW(IP,2))*ZWT1*ZWT1
     1       + ((3.0-2.0*ZWT) *PW(IP+1,1) - ZWT1*PW(IP+1,3))*ZWT*ZWT
  230    CONTINUE
C
      ELSE
C
C*******************************************************************
C     Section 3.  Invalid interpolation code ..
C*******************************************************************
C
  300   CONTINUE
C
        WRITE (*,9001) KCODE
        KRET = 2
      ENDIF
C
C*******************************************************************
C     Section 9.  Closedown.
C*******************************************************************
C
900   CONTINUE
      RETURN
C
 9001 FORMAT (1H ,'ROWINA2 : Invalid interpolation code = ',I4)
C
      END

C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C


      SUBROUTINE PRTBL1 (IB1PAR)
C
C---->
C**************************************************************
C*
C*    NAME      : PRTBL1
C*
C*    FUNCTION  : PRINT THE INFORMATION IN THE PRODUCT DEFINITION
C*                BLOCK (BLOCK 1) OF DECODED GRIB DATA.
C*
C*    INPUT     : IB1PAR - ARRAY OF DECODED PARAMETERS FROM BLOCK 1.
C*
C*    JOHN HENNESSY  ECMWF 28 MAY 1985
C*
C*
C**************************************************************
C----<
C
      DIMENSION IB1PAR(*)
C
      WRITE (*,9000)
 9000 FORMAT (1H0,'BLOCK 1 - PRODUCT DEFINITION BLOCK',/)
C
      WRITE (*,9001) IB1PAR(1)
 9001 FORMAT (1H0,'ORIGINATING CENTRE IDENTIFIER.       ',I9)
      WRITE (*,9002) IB1PAR(2)
 9002 FORMAT (1H ,'MODEL IDENTIFICATION.                ',I9)
      WRITE (*,9003) IB1PAR(3)
 9003 FORMAT (1H ,'GRID DEFINITION.                     ',I9)
      WRITE (*,9004) IB1PAR(4)
 9004 FORMAT (1H ,'FLAG (CODE TABLE 1)                  ',I9)
      WRITE (*,9005) IB1PAR(5)
 9005 FORMAT (1H ,'PARAMETER IDENTIFIER (CODE TABLE 2). ',I9)
      WRITE (*,9006) IB1PAR(6)
 9006 FORMAT (1H ,'TYPE OF LEVEL (CODE TABLE 3).        ',I9)
      WRITE (*,9007) IB1PAR(7)
 9007 FORMAT (1H ,'VALUE 1 OF LEVEL (CODE TABLE 3).     ',I9)
      WRITE (*,9008) IB1PAR(8)
 9008 FORMAT (1H ,'VALUE 2 OF LEVEL (CODE TABLE 3).     ',I9)
      WRITE (*,9009) IB1PAR(9)
 9009 FORMAT (1H ,'YEAR OF DATA.                        ',I9)
      WRITE (*,9010) IB1PAR(10)
 9010 FORMAT (1H ,'MONTH OF DATA.                       ',I9)
      WRITE (*,9011) IB1PAR(11)
 9011 FORMAT (1H ,'DAY OF DATA.                         ',I9)
      WRITE (*,9012) IB1PAR(12)
 9012 FORMAT (1H ,'HOUR OF DATA.                        ',I9)
      WRITE (*,9013) IB1PAR(13)
 9013 FORMAT (1H ,'MINUTE OF DATA.                      ',I9)
      WRITE (*,9014) IB1PAR(14)
 9014 FORMAT (1H ,'TIME UNIT (CODE TABLE 4).            ',I9)
      WRITE (*,9015) IB1PAR(15)
 9015 FORMAT (1H ,'TIME RANGE ONE.                      ',I9)
      WRITE (*,9016) IB1PAR(16)
 9016 FORMAT (1H ,'TIME RANGE TWO.                      ',I9)
      WRITE (*,9017) IB1PAR(17)
 9017 FORMAT (1H ,'TIME RANGE FLAG (CODE TABLE 5).      ',I9)
C
      RETURN
C
      END

C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE JNUMGG( KNUM, HTYPE, KPTS, KRET)
C
C---->
C**** JNUMGG
C
C     PURPOSE
C     _______
C
C     This routine returns the number of points in each latitude of 
C     a gaussian grid.
C
C
C     INTERFACE
C     _________
C
C     CALL JNUMGG( KNUM, HTYPE, KPTS, KRET)
C
C
C     Input parameters
C     ________________
C
C     KNUM     - Gaussian grid number
C     HTYPE    - Gaussian grid type
C                = 'R' for reduced, = 'F' for full
C
C
C     Output parameters
C     ________________
C
C     KPTS    - Array giving number of points at each gaussian latitude 
C               (both hemispheres)
C     KRET     - Return status code
C                0 = OK
C
C     Common block usage
C     __________________
C
C     None.
C
C     Method
C     ______
C
C     Simplified interface to JGETGG.
C
C
C     Externals
C     _________
C
C     JGETGG     - Get the gaussian grid definition.
C     INTLOG   - Output log message
C
C
C     Reference
C     _________
C
C     None
C
C
C     Comments
C     ________
C
C     None
C
C
C     AUTHOR
C     ______
C
C     J.D.Chambers      *ECMWF*      Feb 1994
C
C
C     MODIFICATIONS
C     _____________
C
C     None.
C
C----<
C
      IMPLICIT NONE
#include "jparams.h"
#include "parim.h"
C
C     Subroutine arguments
C
      INTEGER KNUM, KPTS, KRET
      CHARACTER*1 HTYPE
      DIMENSION KPTS(*)
C
C     Parameters
      INTEGER JPROUTINE
      PARAMETER ( JPROUTINE = 30700 )
C
C     Local variables
C
      REAL ZLAT
      DIMENSION  ZLAT(JPMAX)
C     _______________________________________________________
C
C*    Section 1.    Get the information.
C     _______________________________________________________
C
  100 CONTINUE
C
      KRET = 0
C
C     Make sure local array is big enough for return values.
C
      IF ( KNUM .GT. (JPMAX/2) ) THEN
        CALL INTLOG(JP_ERROR,
     X    'JNUMGG - Local array too small for return values.',JPMAX/2)
        KRET = JPROUTINE + 1
        GOTO 900
      ENDIF
C
      CALL JGETGG( KNUM, HTYPE, ZLAT, KPTS, KRET)
C
C     _______________________________________________________
C
C*    Section 9. Return to calling routine. Format statements
C     _______________________________________________________
C
 900  CONTINUE
C
      RETURN
      END

C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      INTEGER FUNCTION INTFBP( INGRIB,INLEN,OUTGRIB,OUTLEN)
C
C---->
C**** INTFBP
C
C     Purpose
C     -------
C
C     Interpolate input field...
C
C
C     Interface
C     ---------
C
C     IRET = INTFBP( INGRIB,INLEN,OUTGRIB,OUTLEN)
C
C     Input
C     -----
C
C     INGRIB - Input field (packed).
C     INLEN  - Input field length (words).
C
C
C     Output
C     ------
C
C     OUTGRIB - Output field (packed).
C     OUTLEN  - Output field length (words).
C
C
C     Method
C     ------
C
C     Call interpolation routines; then repack if GRIB output.
C
C     Currently, subareas are not supported for reduced gaussian fields.
C     (Works OK; but need to setup values in GRIB product for number of
C      points in each latitude row)
C
C
C     Externals
C     ---------
C
C     IARCNTL - Control interp. quasi reg.Gauss -> Gaussian or lat/long
C     IAGCNTL - Control interpolation reg.Gaussian or lat/long fields.
C     JSH2SH  - Changes resolution of a field of spectral coefficients.
C     JALLGP  - Converts spectral input fields to lat/long grid fields.
C     JALLWN  - Converts spectral input wind fields to lat/long grids.
C     JAGGGP  - Converts spectral input fields to a gaussian grid field.
C     IBASINI - Ensure basic interpolation setup is done.
C     GRIBEX  - Decode/encode GRIB product.
C     GRSVCK  - Turn off GRIB checking
C     RESET_C - Reset interpolation handling options using GRIB product.
C     IGSETUP - Setup GRIB sections for the output product.
C     JMEMHAN - Handles memory allocation.
C     IGLSIZE - Evaluate array sizes for reg. lat/long and area.
C     IGSIZE  - Evaluate array sizes for a regular Gaussian.
C     IRSIZE  - Evaluate array sizes for a quasi reg Gaussian.
C     FIXAREA - Fixup area definition to correspond to grid definitions
C     ISCRSZ  - Calculate number of values in generated field.
C     INTLOG  - Log error message.
C
C
C     Author
C     ------
C
C     J.D.Chambers     ECMWF     Aug 1994
C
C     J.D.Chambers     ECMWF        Feb 1997
C     Allow for 64-bit pointers
C
C----<
C
      IMPLICIT NONE
C
C     Function arguments
      INTEGER INGRIB(*),OUTGRIB(*),INLEN,OUTLEN
C
#include "parim.h"
#include "nifld.common"
#include "nofld.common"
#include "grfixed.h"
#include "intf.h"
C
C     Parameters
      INTEGER JPROUTINE
      PARAMETER (JPROUTINE = 26500 )
C
C     Local variables
C
      CHARACTER*1 HFUNC
      INTEGER IWORD, IERR, ILENF, ISIZE, IUV
      REAL PNORTH, PSOUTH, PWEST, PEAST, PLATINC, PLONINC
      LOGICAL OIWEGLOBE, OINPOLE, OISPOLE
      LOGICAL OOWEGLOBE, OONPOLE, OOSPOLE
      INTEGER KILN, KITOTAL, KOLN, KOTOTAL, KPR, KERR
#ifndef _CRAYFTN
#ifdef POINTER_64
      INTEGER*8 IZNFLDO
#endif
#endif
      REAL ZNFLDO
      POINTER ( IZNFLDO, ZNFLDO )
      DIMENSION ZNFLDO( 1 )
C
C     Externals
C
      INTEGER IGLSIZE, IGSIZE, IRSIZE, IARCNTL, IAGCNTL
      INTEGER IGSETUP, FIXAREA, ISCRSZ
C
C ------------------------------------------------------------------
C*    Section 1.   Initialise
C ------------------------------------------------------------------
C
  100 CONTINUE
      INTFBP = 0
      IERR = 0
      KPR = 0
C
C     Allocate work array ZNFELDI if not already done.
C
      IF( IZNJDCI.NE.1952999238 ) THEN
        CALL JMEMHAN( 19, IZNFLDI, JPEXPAND, 1, IERR)
        IF( IERR.NE.0 ) THEN
          CALL INTLOG(JP_WARN,'INTFBP: ZNFELDI allocation fail',JPQUIET)
          INTFBP = IERR
          GOTO 900
        ENDIF
        IZNJDCI = 1952999238
      ENDIF
C
C ------------------------------------------------------------------
C*    Section 3.   Interpolation spherical harmonics to spherical
C                  harmonics
C ------------------------------------------------------------------
C
  300 CONTINUE
C
      IF ( ((NIREPR.EQ.JPSPHERE).OR.(NIREPR.EQ.JPSPHROT)) .AND.
     X     ((NOREPR.EQ.JPSPHERE).OR.(NOREPR.EQ.JPSPHROT)) ) THEN
C
C       Get scratch space for interpolation
        ISIZE = ISCRSZ()
        IF ( ISIZE .LE. 0 ) THEN
          CALL INTLOG(JP_ERROR,'INTFBP: Get scratch space failed',ISIZE)
          INTFBP = JPROUTINE + 2
          GOTO 900
        ENDIF
        CALL JMEMHAN( 3, IZNFLDO, ISIZE, 1, IERR)
        IF ( IERR .NE. 0 ) THEN
          CALL INTLOG(JP_ERROR,'INTFBP: Get scratch space fail',JPQUIET)
          INTFBP = JPROUTINE + 2
          GOTO 900
        ENDIF
C
        CALL SH2SH( ZNFELDI, NIRESO, ZNFLDO, NORESO )
C
        GOTO 700
C
C     If not spectral -> spectral transformation, make sure the input
C     and output area definitions have been setup.
C
      ELSE
C
C       Fixup area definition to correspond to grid definitions
        IERR = FIXAREA()
        IF ( IERR .NE. 0 ) THEN
          CALL INTLOG(JP_ERROR,
     X      'INTFBP: Fixup area definition failed.',JPQUIET)
          INTFBP = JPROUTINE + 9
          GOTO 900
        ENDIF
C
C       Setup geographical limits
        PNORTH = FLOAT( NOAREA(1) ) / PPMULT
        PWEST  = FLOAT( NOAREA(2) ) / PPMULT
        PSOUTH = FLOAT( NOAREA(3) ) / PPMULT
        PEAST  = FLOAT( NOAREA(4) ) / PPMULT
C
      ENDIF
C
C ------------------------------------------------------------------
C     Section 4.   Interpolation spherical harmonics to grid point.
C ------------------------------------------------------------------
C
  400 CONTINUE
C
      IF ( (NIREPR.EQ.JPSPHERE).OR.(NIREPR.EQ.JPSPHROT) ) THEN
C
C       Get scratch space for interpolation
C
        ISIZE = ISCRSZ()
        IF ( ISIZE .LE. 0 ) THEN
          CALL INTLOG(JP_ERROR,'INTFBP: Get scratch space failed',ISIZE)
          INTFBP = JPROUTINE + 2
          GOTO 900
        ENDIF
C
        CALL JMEMHAN( 3, IZNFLDO, ISIZE, 1, IERR)
        IF ( IERR .NE. 0 ) THEN
          CALL INTLOG(JP_ERROR,'INTFBP: Get scratch space fail',JPQUIET)
          INTFBP = JPROUTINE + 2
          GOTO 900
        ENDIF
C
C       Setup wind flag
C
        IF( .NOT.LWINDSET ) THEN
          LWIND = ( ( NOTABLE.EQ.128 ).AND.
     X            ((NOPARAM.EQ.131).OR.(NOPARAM.EQ.132)) )
        ENDIF
        CALL INTLOG(JP_DEBUG,'INTFBP: Wind flag = ', LWIND)
        IF ( LWIND ) THEN
          IUV = 1
        ELSE
          IUV = 0
        ENDIF
C
C ------------------------------------------------------------------
C*    Section 4.1  Interpolation spherical harmonics to grid point.
C ------------------------------------------------------------------
C
  410 CONTINUE
C
        IF ( (NOREPR.EQ.JPREGULAR).OR.(NOREPR.EQ.JPREGROT) ) THEN
C
C         -> latitude/longitude grid
C
          PLONINC = FLOAT( NOGRID(1) ) / PPMULT
          PLATINC = FLOAT( NOGRID(2) ) / PPMULT
          IF ( LWIND ) THEN
            CALL JALLWN( ZNFELDI, NIRESO, PNORTH, PSOUTH, PWEST, PEAST,
     X                   PLATINC, PLONINC, ZNFLDO, IERR)
          ELSE
            CALL JALLGP( ZNFELDI, NIRESO, PNORTH, PSOUTH, PWEST, PEAST,
     X                   PLATINC, PLONINC, ZNFLDO, IERR)
          ENDIF
          IF ( IERR .NE. 0 ) THEN
            CALL INTLOG(JP_ERROR,
     X        'INTFBP: Interpolation of gaussian field failed.',JPQUIET)
            INTFBP = JPROUTINE + 3
            GOTO 900
          ENDIF
C
          GOTO 700
C
        ENDIF
C
C
        IF ( NOREPR .EQ. JPGAUSSIAN) THEN
C
C         -> regular gaussian grid
C
          CALL JAGGGP( ZNFELDI, NIRESO, PNORTH, PSOUTH, PWEST, PEAST,
     X                 NOGAUSS, 'U', NOLPTS, ZNFLDO, IUV, IERR)
          IF ( IERR .NE. 0 ) THEN
            CALL INTLOG(JP_ERROR,
     X        'INTFBP: Interpolation of gaussian field failed.',JPQUIET)
            INTFBP = JPROUTINE + 4
            GOTO 900
          ENDIF
C
          GOTO 700
C
        ENDIF
C
C
        IF ( NOREPR .EQ. JPQUASI) THEN
C
C         -> reduced gaussian grid
          CALL JAGGGP( ZNFELDI, NIRESO, PNORTH, PSOUTH, PWEST, PEAST,
     X                 NOGAUSS, 'U', NOLPTS, ZNFLDO, IUV, IERR)
          IF ( IERR .NE. 0 ) THEN
            CALL INTLOG(JP_ERROR,
     X        'INTFBP: Interpolation of gaussian field failed.',JPQUIET)
            INTFBP = JPROUTINE + 4
            GOTO 900
          ENDIF
C
          GOTO 700
C
        ENDIF
C
C       Dropthrough => unrecognized output field type
        IERR   = JPROUTINE + 1
        CALL INTLOG(JP_ERROR,
     X    'INTFBP: Unrecognized output field type.',NOREPR)
        INTFBP = IERR
        GOTO 900
C
      ENDIF
C
C ------------------------------------------------------------------
C     Section 5.   Interpolate Gaussian grid to grid point.
C ------------------------------------------------------------------
C
  500 CONTINUE
C
C     Setup flags for input and output fields
      KERR = 1
      IF (NIREPR .EQ. JPQUASI) THEN
        IERR = IRSIZE( NIGAUSS, NIAREA, MILLEN, NIWE, NINS, KILN,
     X                 KITOTAL, RIGAUSS, OIWEGLOBE, OINPOLE, OISPOLE,
     X                 KPR, KERR)
      ELSE IF ( NIREPR .EQ. JPGAUSSIAN ) THEN
          IERR = IGSIZE( NIGAUSS, NIAREA, NIWE, NINS, KILN, RIGAUSS,
     X                    OIWEGLOBE, OINPOLE, OISPOLE, KPR, KERR)
      ELSE
        IERR = IGLSIZE( NIGRID, NIAREA, NIWE, NINS, KILN, OIWEGLOBE,
     X                  OINPOLE, OISPOLE, KPR, KERR)
      ENDIF
C
      NONS = 0
      NOWE = 0
      IF (NOREPR .EQ. JPQUASI) THEN
        IERR = IRSIZE( NOGAUSS, NOAREA, NOLPTS, NOWE, NONS, KOLN,
     X                 KOTOTAL, ROGAUSS, OOWEGLOBE, OONPOLE, OOSPOLE,
     X                 KPR, KERR)
      ELSE IF ( NOREPR .EQ. JPGAUSSIAN ) THEN
          IERR = IGSIZE( NOGAUSS, NOAREA, NOWE, NONS, KOLN, ROGAUSS,
     X                    OOWEGLOBE, OONPOLE, OOSPOLE, KPR, KERR)
      ELSE
        IERR = IGLSIZE( NOGRID, NOAREA, NOWE, NONS, KOLN, OOWEGLOBE,
     X                  OONPOLE, OOSPOLE, KPR, KERR)
      ENDIF
C
      IF ( IERR .NE. 0 ) THEN
        CALL INTLOG(JP_ERROR,
     X    'INTFBP: Setup of gaussian field flags failed.',IERR)
        INTFBP = JPROUTINE + 6
        GOTO 900
      ENDIF
C
C
C ------------------------------------------------------------------
C     Section 5.1  Interpolate reduced Gaussian grid to grid point.
C ------------------------------------------------------------------
C
  510 CONTINUE
C
C
      ISIZE = ISCRSZ()
      IF ( ISIZE .LE. 0 ) THEN
        CALL INTLOG(JP_ERROR,'INTFBP: Get scratch space failed.',ISIZE)
        INTFBP = JPROUTINE + 2
        GOTO 900
      ENDIF
      CALL JMEMHAN( 3, IZNFLDO, ISIZE, 1, IERR)
      IF ( IERR .NE. 0 ) THEN
        CALL INTLOG(JP_ERROR,'INTFBP: Get scratch space fail.',JPQUIET)
        INTFBP = JPROUTINE + 2
        GOTO 900
      ENDIF
C
      IF (NIREPR .EQ. JPQUASI) THEN
        IERR = IARCNTL( ZNFELDI, JPEXPAND, ZNFLDO, ISIZE, KILN,
     X                  OIWEGLOBE, OINPOLE, OISPOLE, KOLN, OOWEGLOBE,
     X                  OONPOLE, OOSPOLE, KPR ,KERR)
        IF ( IERR .NE. 0 ) THEN
          CALL INTLOG(JP_ERROR,
     X      'INTFBP: Interpolation of gaussian field failed.',IERR)
          INTFBP = JPROUTINE + 7
          GOTO 900
        ENDIF
C
        GOTO 700
C
      ENDIF
C
C ------------------------------------------------------------------
C*    Section 6.   Interpolate regular grid point to grid point.
C ------------------------------------------------------------------
C
  600 CONTINUE
C
      IERR = IAGCNTL( ZNFELDI, JPEXPAND, ZNFLDO, ISIZE, KILN,
     X                OIWEGLOBE, OINPOLE, OISPOLE, KOLN, OOWEGLOBE,
     X                OONPOLE, OOSPOLE, KPR, KERR)
      IF ( IERR .NE. 0 ) THEN
        CALL INTLOG(JP_ERROR,
     X    'INTFBP: Interpolation of gaussian field failed.',IERR)
        INTFBP = JPROUTINE + 8
        GOTO 900
      ENDIF
C
C ------------------------------------------------------------------
C*    Section 7.   Pack field into GRIB if necessary.
C ------------------------------------------------------------------
C
  700 CONTINUE
C
C     Setup GRIB sections for the output product
      IERR = IGSETUP( ISEC1, ISEC2, ISEC4 )
      IF ( IERR .NE. 0 ) THEN
        CALL INTLOG(JP_ERROR,'INTFBP: Setup GRIB sections failed.',IERR)
        INTFBP = IERR
        GOTO 900
      ENDIF
C
C     Code data into GRIB
C
      ILENF = ISIZE
      IERR = 1
C
C     If grid-point output, setup for 2nd order packing if requested.
C
      IF( (NOREPR.NE.JPSPHERE) .AND. (NOREPR.NE.JPSPHROT) ) THEN
        HFUNC = 'C'
        IF( NOHFUNC.EQ.'K' ) THEN
          HFUNC = 'K'
          ISEC4(4)  = 64
          ISEC4(6)  = 16
          ISEC4(9)  = 32
          ISEC4(10) = 16
          ISEC4(12) = 8
          ISEC4(13) = 4
          ISEC4(14) = 0
          ISEC4(15) = -1
        ELSE IF( NOHFUNC.EQ.'S' ) THEN
          ISEC4(4)  = 0
          ISEC4(6)  = 0
        ENDIF
      ELSE
        HFUNC = 'C'
        IF( NOHFUNC.EQ.'C' ) THEN
          ISEC2(6) = 2
          ISEC4(4) = 64
        ELSE IF( NOHFUNC.EQ.'S' ) THEN
          ISEC2(6) = 1
          ISEC4(4) = 0
        ENDIF
      ENDIF
C
      IF( LIMISSV ) THEN
        ISEC1(5) = 192
        ISEC3(2) = NINT(RMISSGV)
        ZSEC3(2) = RMISSGV
      ENDIF
      CALL GRIBEX( ISEC0, ISEC1, ISEC2, ZSEC2, ISEC3, ZSEC3, ISEC4,
     X             ZNFLDO,ILENF,OUTGRIB,OUTLEN,IWORD,HFUNC,IERR)
      IF ( IERR .NE. 0 ) THEN
        CALL INTLOG(JP_ERROR,'INTFBP: GRIBEX encoding failed.',IERR)
        INTFBP = JPROUTINE + 5
        GOTO 900
      ENDIF
      OUTLEN = IWORD
C
C ------------------------------------------------------------------
C*    Section 9.   Closedown.
C ------------------------------------------------------------------
C
  900 CONTINUE
C
C     Clear change flags for next product processing
      LCHANGE = .FALSE.
      LSMCHNG = .FALSE.
C
      RETURN
      END

C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      INTEGER FUNCTION NEWISL(OLDGEO,NEWGEO,OLDLSM,OLDFLD,MASTER,NEWFLD)
C
C---->
C**** NEWISL
C
C     Purpose
C     -------
C
C     Interpolate a field based on an old land-sea mask to a field
C     based on a different land-sea mask.
C
C
C     Interface
C     ---------
C
C     IRET = NEWISL(OLDGEO,NEWGEO,OLDLSM,OLDFLD,MASTER,NEWFLD)
C
C     Input
C     -----
C
C     OLDGEO - GRIB section 2 describing grid of old field.
C     NEWGEO - GRIB section 2 describing grid of new field.
C     OLDLSM - Array of land-sea mask values for old field.
C     OLDFLD - Array of values for old field.
C     MASTER - Array of land-sea mask values for new field.
C
C
C     Output
C     ------
C
C     NEWFLD - Array of values for new field.
C
C     Function returns:
C       - 0 if all is well
C       - 1, otherwise.
C
C
C     Method
C     ------
C
C     Build up field offsets from input geometries.
C     For each point of the new field, find in the old field the four
C     nearest neighbours' positions, values and types.
C     Calculate new value from the neighbours.
C
C
C     Externals
C     ---------
C
C     IGGLAT  - Compute gaussian lines of latitude.
C     JNORSGG - Find gaussian latitudes to north and south of latitude.
C     ISLPROC - Calculate value of new field point.
C     INTLOG  - Log messages
C
C
C     Author
C     ------
C
C     J.D.Chambers     ECMWF     August 2000
C
C----<
C
      IMPLICIT NONE
C
C     Function arguments
C
      INTEGER OLDGEO(*),NEWGEO(*)
      REAL OLDLSM(*),OLDFLD(*),MASTER(*),NEWFLD(*)
C
#include "intisl.h"
#include "parim.h"
C
C     Parameters
C
      INTEGER JPMAXLT, JPGAUSS, JP1000
      PARAMETER (JPMAXLT=721)
      PARAMETER (JPGAUSS=4)
      PARAMETER (JP1000=1000)
C
C     Local variables
C
      INTEGER TOTAL, NEXT, LOOP, NEWOFF(JPMAXLT), OLDOFF(JPMAXLT)
      INTEGER LATIT, LONG, NEWTYPE, IRET, NPTS
      INTEGER LAT(2), LON(4)
      INTEGER PT(4), TYPE(4)
      REAL OLAT(2), OLON(4)
      REAL RLATOLD(JPMAXLT), RLATNEW(JPMAXLT), RLAT, RLON
C
C     Externals
C
      INTEGER IGGLAT, JNORSGG
      REAL ISLPROC
      EXTERNAL IGGLAT, JNORSGG, ISLPROC
C
C     -----------------------------------------------------------------|
C*    Section 1.   Build working values using input geometries.
C     -----------------------------------------------------------------|
C
  100 CONTINUE
C
      NEWISL = 0
C
C     -----------------------------------------------------------------|
C*    Section 2.   Calculate number of points in new field and offset
C                  to start of each latitude in the new grid
C     -----------------------------------------------------------------|
C
  200 CONTINUE
C
      IF( NEWGEO(1).EQ.JPGAUSS ) THEN
C
C       New field is gaussian
C
        CALL INTLOG(JP_DEBUG,'NEWISL: New field is gaussian',JPQUIET)
C
        IF( NEWGEO(17).EQ.0 ) THEN
          CALL INTLOG(JP_DEBUG,'NEWISL: New field is regular',JPQUIET)
          TOTAL = NEWGEO(2)*NEWGEO(3)
          NEWOFF(1) = 0
          DO LOOP = 2, NEWGEO(NJ)
            NEWOFF(LOOP) = NEWOFF(LOOP-1) + NEWGEO(2)
          ENDDO
        ELSE
          CALL INTLOG(JP_DEBUG,'NEWISL: New field is reduced',JPQUIET)
          NEWOFF(1) = 0
          TOTAL = NEWGEO(NPOINTS)
          DO LOOP = 2, NEWGEO(NJ)
            NEWOFF(LOOP) = NEWOFF(LOOP-1) + NEWGEO(NPOINTS-2+LOOP)
            TOTAL = TOTAL + NEWGEO(NPOINTS-1+LOOP)
          ENDDO
        ENDIF
C
C       Get the gaussian latitudes for the new field
C
        IRET = IGGLAT(NEWGEO(NGAUSS)*2,RLATNEW,0,-1)
        IF( IRET.NE.0 ) THEN
          WRITE(*,*) 'NEWISL: Problem call igglat for new grid'
          NEWISL = 1
          RETURN
        ENDIF
C
      ELSE
C
C       New field is lat/long
C
        CALL INTLOG(JP_DEBUG,'NEWISL: New field is lat/long',JPQUIET)
        TOTAL = NEWGEO(2)*NEWGEO(3)
        DO LOOP = 1, NEWGEO(3)
          NEWOFF(LOOP) = NEWGEO(2)*(LOOP-1)
          RLATNEW(LOOP) = 90.0 - (REAL((LOOP-1)*NEWGEO(10))/JP1000)
        ENDDO
C
      ENDIF
C
      CALL INTLOG(JP_DEBUG,'NEWISL: No. of pts in new field = ',TOTAL)
C
C     -----------------------------------------------------------------|
C*    Section 3.   Get the gaussian latitudes for the old field and
C                  setup the offsets to the start of each latitude.
C     -----------------------------------------------------------------|
C
  300 CONTINUE
C
      OLDOFF(1) = 0
      DO LOOP = 2, OLDGEO(NJ)
        OLDOFF(LOOP) = OLDOFF(LOOP-1) + OLDGEO(NPOINTS-2+LOOP)
      ENDDO
C
      IRET = IGGLAT(OLDGEO(NGAUSS)*2,RLATOLD,0,-1)
      IF( IRET.NE.0 ) THEN
        WRITE(*,*) 'NEWISL: Problem call igglat for old grid'
        NEWISL = 1
        RETURN
      ENDIF
C
C     -----------------------------------------------------------------|
C*    Section 4.   Work through the points in the new field.
C     -----------------------------------------------------------------|
C
  400 CONTINUE
C
      DO NEXT = 1, TOTAL
C
C       Calculate lat/long
C
        DO LOOP = 1, NEWGEO(NJ)
          IF( NEWOFF(LOOP).GE.NEXT ) THEN
            LATIT = LOOP - 1
            GOTO 410
          ENDIF
        ENDDO
        LATIT = NEWGEO(NJ)
C
  410   CONTINUE
C
        LONG = NEXT - NEWOFF(LATIT)
C
        RLAT = RLATNEW(LATIT)
        IF( NEWGEO(1).EQ.JPGAUSS ) THEN
          IF( NEWGEO(17).EQ.0 ) THEN
            RLON = REAL((LONG-1)*NEWGEO(9))/JP1000
          ELSE
            RLON = (REAL(LONG-1)*360.0)/REAL(NEWGEO(NPOINTS+LATIT-1))
          ENDIF
        ELSE
          RLON = REAL((LONG-1)*NEWGEO(9))/JP1000
        ENDIF
C
C       Find type of point (land or sea)
C
        IF( MASTER(NEXT).GT.MASTERTHRESHOLD ) THEN
          NEWTYPE = LAND
        ELSE
          NEWTYPE = SEA
        ENDIF
C
C       Find four neighbours in the old field with their types
C       (Find NW neighbour and deduce the others).
C
        LAT(NORTH) = JNORSGG(RLAT,RLATOLD,OLDGEO(NGAUSS),1)
        LAT(SOUTH) = JNORSGG(RLAT,RLATOLD,OLDGEO(NGAUSS),0)
C
        OLAT(NORTH) = RLATOLD(LAT(NORTH))
        OLAT(SOUTH) = RLATOLD(LAT(SOUTH))
C
        NPTS = OLDGEO(NPOINTS-1+LAT(NORTH))
        LON(NWEST) = 1 + INT(RLON/(360.0/REAL(NPTS)))
        LON(NEAST) = LON(NWEST) + 1
        IF( LON(NEAST).GT.NPTS ) LON(NEAST) = 1
C
        OLON(NWEST) = (REAL(LON(NWEST)-1)*360.0)/REAL(NPTS)
        IF( LON(NEAST).EQ.1 ) THEN
          OLON(NEAST) = 360.0
        ELSE
          OLON(NEAST) = (REAL(LON(NEAST)-1)*360.0)/REAL(NPTS)
        ENDIF
C
        NPTS = OLDGEO(NPOINTS-1+LAT(SOUTH))
        LON(SWEST) = 1 + INT(RLON/(360.0/REAL(NPTS)))
        LON(SEAST) = LON(SWEST) + 1
        IF( LON(SEAST).GT.NPTS ) LON(SEAST) = 1
C
        OLON(SWEST) = (REAL(LON(SWEST)-1)*360.0)/REAL(NPTS)
        IF( LON(SEAST).EQ.1 ) THEN
          OLON(SEAST) = 360.0
        ELSE
          OLON(SEAST) = (REAL(LON(SEAST)-1)*360.0)/REAL(NPTS)
        ENDIF
C
        PT(NWEST) = OLDOFF(LAT(NORTH)) + LON(NWEST)
        IF( OLDLSM(PT(NWEST)).GT.OLDLSMTHRESHOLD ) THEN
          TYPE(NWEST) = LAND
        ELSE
          TYPE(NWEST) = SEA
        ENDIF
C
        PT(NEAST) = OLDOFF(LAT(NORTH)) + LON(NEAST)
        IF( OLDLSM(PT(NEAST)).GT.OLDLSMTHRESHOLD ) THEN
          TYPE(NEAST) = LAND
        ELSE
          TYPE(NEAST) = SEA
        ENDIF
C
        PT(SWEST) = OLDOFF(LAT(SOUTH)) + LON(SWEST)
        IF( OLDLSM(PT(SWEST)).GT.OLDLSMTHRESHOLD ) THEN
          TYPE(SWEST) = LAND
        ELSE
          TYPE(SWEST) = SEA
        ENDIF
C
        PT(SEAST) = OLDOFF(LAT(SOUTH)) + LON(SEAST)
        IF( OLDLSM(PT(SEAST)).GT.OLDLSMTHRESHOLD ) THEN
          TYPE(SEAST) = LAND
        ELSE
          TYPE(SEAST) = SEA
        ENDIF
C
C       Interpolate the new value
C
        NEWFLD(NEXT) =
     X    ISLPROC(RLAT,RLON,NEWTYPE,OLAT,OLON,TYPE,PT,OLDFLD)
C
      ENDDO
C
C     -----------------------------------------------------------------|
C*    Section 9.   Return
C     -----------------------------------------------------------------|
C
  900 CONTINUE
C
C
      RETURN
      END

C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities
C granted to it by virtue of its status as an intergovernmental organisation
C nor does it submit to any jurisdiction.
C

      SUBROUTINE ABORTX (HNAME)
C
C---->
C**** ABORTX - Terminates execution of program.
C
C     Purpose.
C     --------
C
C     Terminates execution of program.
C
C**   Interface.
C     ----------
C
C     CALL ABORTX (HNAME)
C
C
C     Input Parameters.
C     -----------------
C
C     HNAME      - Name of calling routine.
C
C     Output Parameters.
C     ------------------
C
C     None.
C
C     Method.
C     -------
C
C     Prints message and terminates.
C
C     Externals.
C     ----------
C
#ifdef VAX
C     EXIT
#endif
#if (defined IBM) && (!defined rs6000)
C     SYSABN
#endif
#ifdef CRAY
C     ABORT
#endif
#if defined(sun) || defined (sgi) || (defined rs6000)
C     ABORT
#endif
#ifdef CYBER
C     ABORT
#endif
#ifdef __uxp__
C     ABORT
#endif
#ifdef __hpux
C     JABORT
#endif
C
C     Reference.
C     ----------
C
C     None.
C
C     Comments.
C     ---------
C
#ifdef VAX
C     VAX version of routine.
#endif
#if (defined IBM) && (!defined rs6000)
C     IBM version of routine.
#endif
#ifdef CRAY
C     Cray version of routine.
#endif
#if defined(sun) || defined (sgi)
C     SUN/SGI version of routine.
#endif
#ifdef CYBER
C     Cyber version of routine.
#endif
#ifdef __uxp__
C     Fujitsu version of routine.
#endif
C
C     Author.
C     -------
C
C     J. Hennessy      ECMWF      13.11.91
C
C     Modifications.
C     --------------
C
C     None.
C
C----<
C
      IMPLICIT NONE
C
#include "grprs.h"
C
      CHARACTER*(*) HNAME
C
C     ------------------------------------------------------------------
C*    Section 1 . Print message and terminate.
C     ------------------------------------------------------------------
C
  100 CONTINUE
C
      WRITE(GRPRSM,9001) HNAME
C
#ifdef VAX
      CALL EXIT (-1)
#endif
#if (defined IBM) && (!defined rs6000)
      CALL SYSABN (1)
#endif
#ifdef CRAY
      CALL ABORT
#endif
#ifdef CYBER
      CALL ABORT ('US',0,' ')
#endif
#if defined(__uxp__)
      CALL ABORT
#endif
#if defined(sun) || defined (sgi) || (defined rs6000)
      CALL ABORT
#endif
#ifdef __hpux
      CALL JABORT
#endif
CC    ensure a return (STOP is F77 and sets a return value)
      STOP 1
C
C     ------------------------------------------------------------------
C*    Section 9 . Format statements.
C     ------------------------------------------------------------------
C
  900 CONTINUE
C
 9001 FORMAT (1H ,'ABORTX : Routine ',A,' has requested program',
     C               ' termination.')
C
      RETURN
C
      END

C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C


      SUBROUTINE ANALSW(IBLOCKS,LOGICS,ILENGL,INTEGS,ILENGI,
     S                  REALSW,ILENGR)
C---->
C
C     G.K.SAKELLARIDES  ECMWF        15/10/85.
C
C     PURPOSE.
C     --------
C
C          TO GET AS OUTPUT THE NAME AND CONTENT OF VARIABLES WHICH
C          APPEAR IN THE DECODED MARS MODEL SWITCH RECORD
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *ALALSW(IBLOCKS,LOGICS,ILENGL,INTEGS,ILENGI,REALSW,
C                        ILENGR)
C        WHERE:
C              INPUT PARAMETERS
C              1.*IBLOCKS* INTEGER ARRAY OF LENGTH 29 CONTAINING
C                          THE FOLLOWING INFORMATIONS OF BLOCK1.
C              2.*LOGICS* LOGICAL ARRAY  WHICH CONTAINS THE LOGICALS.
C              3.*ILENGL* ACTUAL LENGTH OF LOGICALS
C              4.*INSOUT* INTEGER ARRAY WHICH CONTAINS THE INTEGER
C              5.*ILENGI* ACTUAL LENGTH OF INTEGER
C              6.*REALSW* REAL ARRAY WHICH CONTAINS THE REALS.
C              7.*ILENGR* ACTUAL LENGTH OF REALS
C
C     EXTERNALS.
C     ----------
C
C         *NONE*
C----<
C
      CHARACTER *45,Y1(26),YL(26)
      CHARACTER *12,YY
      CHARACTER *45,YI1(6),YI2,YI3(14),YI4,YI5,YI6(10),YI7,YI8,YI9
      CHARACTER *45,YR1(2),YR2,YR3(53),YR4,YR5,YR6,YR7,YR8(26)
      DIMENSION INTEGS(*),REALSW(*),IBLOCKS(*)
      LOGICAL LOGICS(*)
      DATA YY/'   POSITION='/
      DATA (Y1(I),I=1,14)
     D       /'               G                            =',
     D        '               R                            =',
     D        '               I                            =',
     D        '               B                            =',
     D        'IDENTIFICATION OF CENTRE.                   =',
     D        'MODEL IDENTIFICATION                        =',
     D        'GRID DEFINITION                             =',
     D        'FLAG (CODE TABLE 1)                         =',
     D        'PARAM. INDICATING THE MARS MODEL SWITCH REC.=',
     D        'TYPE OF LEVEL (CODE TABLE 3)                =',
     D        'VALUE 1 OF LEVEL (CODE TABLE 3)             =',
     D        'VALUE 2 OF LEVEL (CODE TABLE 3)             =',
     D        'YEAR    OF INITIAL DATA                     =',
     D        'MONTH   OF INITIAL DATA                     ='/
      DATA (Y1(I),I=15,26)
     D       /'DAY     OF INITIAL DATA                     =',
     D        'HOUR    OF INITIAL DATA                     =',
     D        'MINUTE  OF INITIAL DATA                     =',
     D        'TIME UNIT (CODE TABLE 4)                    =',
     D        'TIME RANGE 1                                =',
     D        'TIME RANGE 2                                =',
     D        'TIME RANGE FLAG (CODE TABLE 5)              =',
     D        'LENGTH OF DATA BLOCK (OCTET)                =',
     D        'STARTING ADDRESS OF LOGICAL SECTION(OCTET)  =',
     D        'STARTING ADDRESS OF INTEGER SECTION(OCTET)  =',
     D        'STARTING ADDRESS OF REAL    SECTION(OCTET)  =',
     D        'LENGTH           OF REAL    SECTION(OCTET)  ='/
      DATA (YL(I),I=1,15)
     D       /'LZLS       LOGICAL FROM COMMON *COMDIZ*     =',
     D        'LSIMDT     LOGICAL FROM COMMON *COMDSW*     =',
     D        'LSIMZQ     LOGICAL FROM COMMON *COMDSW*     =',
     D        'LVTMPC1    LOGICAL FROM COMMON *COMDSW*     =',
     D        'LVTMPC2    LOGICAL FROM COMMON *COMDSW*     =',
     D        'LLDIFF     LOGICAL FROM COMMON *COMNMI*     =',
     D        'LLROSS     LOGICAL FROM COMMON *COMNMI*     =',
     D        'LLPROJ     LOGICAL FROM COMMON *COMNMI*     =',
     D        'LLZA       LOGICAL FROM COMMON *COMNMI*     =',
     D        'LLPSRS     LOGICAL FROM COMMON *COMNMI*     =',
     D        'LLTEND     LOGICAL FROM COMMON *COMNMI*     =',
     D        'LLDIAB     LOGICAL FROM COMMON *COMNMI*     =',
     D        'LLFILT     LOGICAL FROM COMMON *COMNMI*     =',
     D        'LPHYS      LOGICAL FROM COMMON *COMPSW*     =',
     D        'LVDIFF     LOGICAL FROM COMMON *COMPSW*     ='/
      DATA (YL(I),I=16,26)
     D       /'LKUO       LOGICAL FROM COMMON *COMPSW*     =',
     D        'LCOND      LOGICAL FROM COMMON *COMPSW*     =',
     D        'LQNEGAT    LOGICAL FROM COMMON *COMPSW*     =',
     D        'LSURF      LOGICAL FROM COMMON *COMPSW*     =',
     D        'LSCV       LOGICAL FROM COMMON *COMPSW*     =',
     D        'LKUO0      LOGICAL FROM COMMON *COMPSW*     =',
     D        'LESFT      LOGICAL FROM COMMON *COMPSW*     =',
     D        'LEVAP      LOGICAL FROM COMMON *COMPSW*     =',
     D        'LSNRN      LOGICAL FROM COMMON *COMPSW*     =',
     D        'LRAD       LOGICAL FROM COMMON *COMRSW*     =',
     D        'LDIUR      LOGICAL FROM COMMON *COMRSW*     ='/
      DATA YI1/'NCYCLE     INTEGER FROM COMMON *COMDOC*     =',
     D         'NVERS      INTEGER FROM COMMON *COMDOC*     =',
     D         'NM         INTEGER FROM COMMON *COMCTL*     =',
     D         'NN         INTEGER FROM COMMON *COMCTL*     =',
     D         'NK         INTEGER FROM COMMON *COMCTL*     =',
     D         'NGL        INTEGER FROM COMMON *COMCTL*     ='/
      DATA YI2/'NLON( )    INTEGER FROM COMMON *COMCTL*     ='/
      DATA YI3/'NLEV       INTEGER FROM COMMON *COMCTL*     =',
     D         'NVCLEV     INTEGER FROM COMMON *COMCTL*     =',
     D         'NUMZLS     INTEGER FROM COMMON *COMDIZ*     =',
     D         'NFRZLS     INTEGER FROM COMMON *COMDIZ*     =',
     D         'NDTSCVL    INTEGER FROM COMMON *COMDIZ*     =',
     D         'NDTSCVS    INTEGER FROM COMMON *COMDIZ*     =',
     D         'NDQSCVL    INTEGER FROM COMMON *COMDIZ*     =',
     D         'NDQSCVS    INTEGER FROM COMMON *COMDIZ*     =',
     D         'NDUSCVL    INTEGER FROM COMMON *COMDIZ*     =',
     D         'NDUSCVS    INTEGER FROM COMMON *COMDIZ*     =',
     D         'NDVSCVL    INTEGER FROM COMMON *COMDIZ*     =',
     D         'NDVSCVS    INTEGER FROM COMMON *COMDIZ*     =',
     D         'NDESCVL    INTEGER FROM COMMON *COMDIZ*     =',
     D         'NDESCVS    INTEGER FROM COMMON *COMDIZ*     ='/
      DATA YI4/'NLANDP( )  INTEGER FROM COMMON *COMDIZ*     ='/
      DATA YI5/'NSEAP( )   INTEGER FROM COMMON *COMDIZ*     ='/
      DATA YI6/'NMASKA     INTEGER FROM COMMON *COMMSK*     =',
     D         'NMASKV     INTEGER FROM COMMON *COMMSK*     =',
     D         'NFRMSK     INTEGER FROM COMMON *COMMSK*     =',
     D         'NFRMSKP    INTEGER FROM COMMON *COMMSK*     =',
     D         'NRSLT      INTEGER FROM COMMON *COMMSK*     =',
     D         'NITNINI    INTEGER FROM COMMON *COMNMI*     =',
     D         'NDIFFST    INTEGER FROM COMMON *COMNMI*     =',
     D         'NVM        INTEGER FROM COMMON *COMNMI*     =',
     D         'NRADFR     INTEGER FROM COMMON *COMRSW*     =',
     D         'NRINT      INTEGER FROM COMMON *COMRSW*     ='/
      DATA YI7/'NTRM( )    INTEGER FROM COMMON *COMTRU*     ='/
      DATA YI8/'NTRN( )    INTEGER FROM COMMON *COMTRU*     ='/
      DATA YI9/'NTRK( )    INTEGER FROM COMMON *COMTRU*     ='/
      DATA YR1/'DTIME      REAL    FROM COMMON *COMCTL*     =',
     D         'EPS        REAL    FROM COMMON *COMCTL*     ='/
      DATA YR2/'VCT( )     REAL    FROM COMMON *COMCTL*     ='/
      DATA (YR3(I),I=1,15)
     D        /'CDIATS     REAL    FROM COMMON *COMDIA*     =',
     D         'CDIATD     REAL    FROM COMMON *COMDIA*     =',
     D         'CDIAWD     REAL    FROM COMMON *COMDIA*     =',
     D         'GPEO       REAL    FROM COMMON *COMDIA*     =',
     D         'GKEO       REAL    FROM COMMON *COMDIA*     =',
     D         'GQMO       REAL    FROM COMMON *COMDIA*     =',
     D         'GTSO       REAL    FROM COMMON *COMDIA*     =',
     D         'GTDO       REAL    FROM COMMON *COMDIA*     =',
     D         'GWSO       REAL    FROM COMMON *COMDIA*     =',
     D         'GWDO       REAL    FROM COMMON *COMDIA*     =',
     D         'GSNO       REAL    FROM COMMON *COMDIA*     =',
     D         'DSRADO     REAL    FROM COMMON *COMDIA*     =',
     D         'DTRADO     REAL    FROM COMMON *COMDIA*     =',
     D         'DSRADS     REAL    FROM COMMON *COMDIA*     =',
     D         'DTRADS     REAL    FROM COMMON *COMDIA*     ='/
      DATA (YR3(I),I=16,30)
     D        /'DVDIS      REAL    FROM COMMON *COMDIA*     =',
     D         'DHFS       REAL    FROM COMMON *COMDIA*     =',
     D         'DEVAP      REAL    FROM COMMON *COMDIA*     =',
     D         'DCVFR      REAL    FROM COMMON *COMDIA*     =',
     D         'DCVQAC     REAL    FROM COMMON *COMDIA*     =',
     D         'DCVMOI     REAL    FROM COMMON *COMDIA*     =',
     D         'DCVGR      REAL    FROM COMMON *COMDIA*     =',
     D         'DCVGS      REAL    FROM COMMON *COMDIA*     =',
     D         'DCVMS      REAL    FROM COMMON *COMDIA*     =',
     D         'DCVER      REAL    FROM COMMON *COMDIA*     =',
     D         'DCVES      REAL    FROM COMMON *COMDIA*     =',
     D         'DLSGR      REAL    FROM COMMON *COMDIA*     =',
     D         'DLSGS      REAL    FROM COMMON *COMDIA*     =',
     D         'DLSMS      REAL    FROM COMMON *COMDIA*     =',
     D         'DLSER      REAL    FROM COMMON *COMDIA*     ='/
      DATA (YR3(I),I=31,45)
     D        /'DLSES      REAL    FROM COMMON *COMDIA*     =',
     D         'DSSRAD     REAL    FROM COMMON *COMDIA*     =',
     D         'DSTRAD     REAL    FROM COMMON *COMDIA*     =',
     D         'DSHFL      REAL    FROM COMMON *COMDIA*     =',
     D         'DSDTFL     REAL    FROM COMMON *COMDIA*     =',
     D         'DSLSR      REAL    FROM COMMON *COMDIA*     =',
     D         'DSLSS      REAL    FROM COMMON *COMDIA*     =',
     D         'DSCVR      REAL    FROM COMMON *COMDIA*     =',
     D         'DSCVS      REAL    FROM COMMON *COMDIA*     =',
     D         'DSEVW      REAL    FROM COMMON *COMDIA*     =',
     D         'DSEVI      REAL    FROM COMMON *COMDIA*     =',
     D         'DSDWFL     REAL    FROM COMMON *COMDIA*     =',
     D         'DSSNMT     REAL    FROM COMMON *COMDIA*     =',
     D         'DDCTFL     REAL    FROM COMMON *COMDIA*     =',
     D         'DDCWFL     REAL    FROM COMMON *COMDIA*     ='/
      DATA (YR3(I),I=46,53)
     D        /'DSROS      REAL    FROM COMMON *COMDIA*     =',
     D         'DSROD      REAL    FROM COMMON *COMDIA*     =',
     D         'DADCON     REAL    FROM COMMON *COMDIA*     =',
     D         'DIFVO      REAL    FROM COMMON *COMHDI*     =',
     D         'DIFD       REAL    FROM COMMON *COMHDI*     =',
     D         'DIFT       REAL    FROM COMMON *COMHDI*     =',
     D         'DIFQ       REAL    FROM COMMON *COMHDI*     =',
     D         'CDRAG      REAL    FROM COMMON *COMHDI*     ='/
      DATA YR4/'ALATN( )   REAL    FROM COMMON *COMMSK*     ='/
      DATA YR5/'ALATS( )   REAL    FROM COMMON *COMMSK*     ='/
      DATA YR6/'ALONE( )   REAL    FROM COMMON *COMMSK*     ='/
      DATA YR7/'ALONW( )   REAL    FROM COMMON *COMMSK*     ='/
      DATA (YR8(I),I=1,15)
     D        /'DTINIT )   REAL    FROM COMMON *COMNMI*     =',
     D         'DTDIFF )   REAL    FROM COMMON *COMNMI*     =',
     D         'PHYFIL     REAL    FROM COMMON *COMNMI*     =',
     D         'WSMAX      REAL    FROM COMMON *COMPSW*     =',
     D         'BETADT     REAL    FROM COMMON *COMSIM*     =',
     D         'BETAZQ     REAL    FROM COMMON *COMSIM*     =',
     D         'APR        REAL    FROM COMMON *COMSIM*     =',
     D         'TR         REAL    FROM COMMON *COMSIM*     =',
     D         'VCRIT      REAL    FROM COMMON *COMSIM*     =',
     D         'HDAMP      REAL    FROM COMMON *COMSIM*     =',
     D         'GVO        REAL    FROM COMMON *COMSTA*     =',
     D         'GD         REAL    FROM COMMON *COMSTA*     =',
     D         'GQ         REAL    FROM COMMON *COMSTA*     =',
     D         'GT         REAL    FROM COMMON *COMSTA*     =',
     D         'GPS        REAL    FROM COMMON *COMSTA*     ='/
      DATA (YR8(I),I=16,26)
     D        /'GKE        REAL    FROM COMMON *COMSTA*     =',
     D         'GPE        REAL    FROM COMMON *COMSTA*     =',
     D         'GTE        REAL    FROM COMMON *COMSTA*     =',
     D         'GLQ        REAL    FROM COMMON *COMSTA*     =',
     D         'GTPE       REAL    FROM COMMON *COMSTA*     =',
     D         'GQM        REAL    FROM COMMON *COMSTA*     =',
     D         'GTS        REAL    FROM COMMON *COMSTA*     =',
     D         'GTD        REAL    FROM COMMON *COMSTA*     =',
     D         'GWS        REAL    FROM COMMON *COMSTA*     =',
     D         'GWD        REAL    FROM COMMON *COMSTA*     =',
     D         'GSN        REAL    FROM COMMON *COMSTA*     ='/
C
C*               1. LOCAL VARIABLES
C
  100 CONTINUE
      INGL=INTEGS(6)
      INVCLEV=INTEGS(6+INGL+2)
      INLEV=INTEGS(6+INGL+1)
C      INDEX FOR INTEGERS
      J1A=1
      J1T=6
      J2A=J1T+1
      J2T=J2A+INGL-1
      J3A=J2T+1
      J3T=J3A+14-1
      J4A=J3T+1
      J4T=J4A+INGL-1
      J5A=J4T+1
      J5T=J5A+INGL-1
      J6A=J5T+1
      J6T=J6A+10-1
      J7A=J6T+1
      J7T=J7A+INLEV-1
      J8A=J7T+1
      J8T=J8A+INLEV-1
      J9A=J8T+1
      J9T=J9A+INLEV-1
C        INDEX FOR REALS
      I1A=1
      I1T=I1A+2-1
      I2A=I1T+1
      I2T=I2A+2*INVCLEV-1
      I3A=I2T+1
      I3T=I3A+53-1
      I4A=I3T+1
      I4T=I4A+32-1
      I5A=I4T+1
      I5T=I5A+32-1
      I6A=I5T+1
      I6T=I6A+32-1
      I7A=I6T+1
      I7T=I7A+32-1
      I8A=I7T+1
      I8T=I8A+26-1
      PRINT*,' J9T=',J9T,'INTL=',ILENGI,'I8T=',I8T,'REAL=',ILENGR
      IF (I8T.NE.ILENGR) THEN
         GO TO 900
      ENDIF
C
C*               2.BLOCK 0 AND 1
C
  200 CONTINUE
      IMET=0
      WRITE(*,1100)
      DO 210 I=1,29
      IF (I.EQ.22.OR.I.EQ.23.OR.I.EQ.24) THEN
         GO TO 210
      ENDIF
      IMET=IMET+1
      WRITE(*,'(1X,A,I6,1X,A,I4)') Y1(IMET),IBLOCKS(I),YY,I
  210 CONTINUE
C
C*               3.LOGICALS
C
  300 CONTINUE
      WRITE(*,1200)
      DO 310 I=1,ILENGL
      WRITE(*,'(1X,A,L6,1X,A,I4)') YL(I),LOGICS(I),YY,I
  310 CONTINUE
C
C*               4.INTEGER
C
  400 CONTINUE
      WRITE(*,1300)
      DO 410 I=J1A,J1T
      WRITE(*,'(1X,A,I6,1X,A,I4)') YI1(I),INTEGS(I),YY,I
  410 CONTINUE
      DO 420 I=J2A,J2T
      WRITE(*,'(1X,A,I6,1X,A,I4)') YI2,INTEGS(I),YY,I
  420 CONTINUE
      META3=0
      DO 430 I=J3A,J3T
      META3=META3+1
      WRITE(*,'(1X,A,I6,1X,A,I4)') YI3(META3),INTEGS(I),YY,I
  430 CONTINUE
      DO 440 I=J4A,J4T
      WRITE(*,'(1X,A,I6,1X,A,I4)') YI4,INTEGS(I),YY,I
  440 CONTINUE
      DO 450 I=J5A,J5T
      WRITE(*,'(1X,A,I6,1X,A,I4)') YI5,INTEGS(I),YY,I
  450 CONTINUE
      META6=0
      DO 460 I=J6A,J6T
      META6=META6+1
      WRITE(*,'(1X,A,I6,1X,A,I4)') YI6(META6),INTEGS(I),YY,I
  460 CONTINUE
      DO 470 I=J7A,J7T
      WRITE(*,'(1X,A,I6,1X,A,I4)') YI7,INTEGS(I),YY,I
  470 CONTINUE
      DO 480 I=J8A,J8T
      WRITE(*,'(1X,A,I6,1X,A,I4)') YI8,INTEGS(I),YY,I
  480 CONTINUE
      DO 490 I=J9A,J9T
      WRITE(*,'(1X,A,I6,1X,A,I4)') YI9,INTEGS(I),YY,I
  490 CONTINUE
C
C*               5. REALS
C
  500 CONTINUE
      WRITE(*,1400)
      DO 510 I=I1A,I1T
      WRITE(*,'(1X,A,G12.6,1X,A,I4)') YR1(I),REALSW(I),YY,I
  510 CONTINUE
      DO 520 I=I2A,I2T
      WRITE(*,'(1X,A,G12.6,1X,A,I4)') YR2,REALSW(I),YY,I
  520 CONTINUE
      METR3=0
      DO 530 I=I3A,I3T
      METR3=METR3+1
      WRITE(*,'(1X,A,G12.6,1X,A,I4)') YR3(METR3),REALSW(I),YY,I
  530 CONTINUE
      DO 540 I=I4A,I4T
      WRITE(*,'(1X,A,G12.6,1X,A,I4)') YR4,REALSW(I),YY,I
  540 CONTINUE
      DO 550 I=I5A,I5T
      WRITE(*,'(1X,A,G12.6,1X,A,I4)') YR5,REALSW(I),YY,I
  550 CONTINUE
      DO 560 I=I6A,I6T
      WRITE(*,'(1X,A,G12.6,1X,A,I4)') YR6,REALSW(I),YY,I
  560 CONTINUE
      DO 570 I=I7A,I7T
      WRITE(*,'(1X,A,G12.6,1X,A,I4)') YR7,REALSW(I),YY,I
  570 CONTINUE
      METR8=0
      DO 580 I=I8A,I8T
      METR8=METR8+1
      WRITE(*,'(1X,A,G12.6,1X,A,I4)') YR8(METR8),REALSW(I),YY,I
  580 CONTINUE
C
C*                6. RETURN
C
  600 CONTINUE
C
      RETURN
C
C
C*                9.ERRORS
C
  900 CONTINUE
      WRITE(*,9901)
      WRITE(*,'(A)') 'ERROR IN THE LENGTH OF REALS'
      CALL ENDRUN
      STOP
 9901 FORMAT('ERROR IN SUBROUTINE ANALSW')
C
C*
C
 1100 FORMAT('1',20X,'VARIABLES OF BLOCK 0 AND 1')
 1200 FORMAT('1',20X,'LOGICAL')
 1300 FORMAT('1',20X,'INTEGER')
 1400 FORMAT('1',20X,'REAL   ')
      END

#ifdef IBM
@PROCESS HOT(NOVECTOR) NOSTRICT
#endif
C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE JSYMGG( PSHUP, KTRUNC, KSTART, KLUNIT, KLATO, KLONO,
     X                    PLAT, PLEG, PTRIGS, KMFAX, PZFA, KRET)
C
C---->
C**** JSYMGG
C
C     PURPOSE
C     _______
C
C     This routine converts spectral input fields to standard
C     lat/long grid fields.
C
C     INTERFACE
C     _________
C
C     CALL JSYMGG( PSHUP, KTRUNC, KSTART, KLUNIT, KLATO, KLONO,
C    X             PLAT, PLEG, PTRIGS, KMFAX, PZFA, KRET)
C
C     Input parameters
C     ________________
C
C     PSHUP    - Spherical harmonics field, unpacked
C     KTRUNC   - Truncation number of spherical harmonics field
C     KSTART   - Number of start latitude row (northernmost) for output 
C                field (must be positive - see comments below)
C     KLUNIT   - stream number of the legendre function file
C     KLATO    - Number of latitude rows in output field
C     KLONO    - Number of longitude points in output field
C     PLAT     - Array of gaussian latitudes
C     PLEG     - Array used to hold legendre functions
C     PTRIGS   - Initialized array of trig.functions (setup by JJSET99)
C     KMFAX    - Initialized array of prime factors (setup by JJSET99)
C
C     Output parameters
C     ________________
C
C     PZFA    - Output grid point field; contains upto 32 each of
C               North and South latitude rows symmetrically.
C     KRET     - Return status code
C                0 = OK
C
C     Common block usage
C     __________________
C
C     JDCNDBG
C
C     Method
C     ______
C
C     None.
C
C     Externals
C     _________
C
C     JREADGG - Reads the legendre functions for a latitude
C     FFT99   - Carries out FFT
C     INTLOG  - Output log message
C     INTLOGR - Output log message (with real value)
C     NMAKGG  - Make interpolation coefficients one latitude at a time
C
C     Reference
C     _________
C
C     E.C.M.W.F. Research Department technical memorandum no. 56
C                "The forecast and analysis post-processing package"
C                May 1982. J.Haseler.
C
C     Comments
C     ________
C
C     This is a redesign, based on SPECGP.F
C
C     It handles transformation to a gaussian grid.
C     The generated grid is symmetrical about the equator, so 
C     KSTART must be positive.
C
C     It is not for U and V fields (no correction is applied at the 
C     poles).
C
C
C     AUTHOR
C     ______
C
C     J.D.Chambers      *ECMWF*      Jan 1994
C
C     MODIFICATIONS
C     _____________
C
C     J.D.Chambers     ECMWF        Feb 1997
C     Allow for 64-bit pointers
C
C----<
C     _______________________________________________________
C
      IMPLICIT NONE
#include "jparams.h"
#include "parim.h"
#include "nifld.common"
C
C     Subroutine arguments
      COMPLEX   PSHUP
      DIMENSION PSHUP(*)
      INTEGER   KTRUNC
      INTEGER   KSTART
      INTEGER   KLUNIT, KLATO, KLONO, KMFAX, KRET
      REAL PLAT, PLEG, PTRIGS, PZFA
      DIMENSION PZFA(JPLONO + 2, 64)
      DIMENSION KMFAX(*), PLAT(*), PLEG(*), PTRIGS(*)
C
C     Parameters
      INTEGER JPROUTINE
      PARAMETER ( JPROUTINE = 31200 )
C
C     Local variables
      INTEGER   ILIM, IMLIM, ILN
      INTEGER   ITAL, ITALA, ITALS, IMN, IMP
      INTEGER   INORTH, ISOUTH
      INTEGER   JM, J, JNEXTLAT, JF
      INTEGER   NERR
      INTEGER*8 IOFF
      INTEGER*8 JDCLOOP
C
#ifndef _CRAYFTN
#ifdef POINTER_64
      INTEGER*8 IWORK
#endif
#endif
      REAL WORK
      DIMENSION WORK(1)
      POINTER ( IWORK, WORK )
      COMPLEX   ZSUMS(JPTRNC + 1), ZSUMA(JPTRNC + 1)
      COMPLEX*16 CHOLD
C
      INTEGER ISIZE
      DATA ISIZE/0/
      SAVE ISIZE, IWORK
C
C     _______________________________________________________
C
C*    Section 1.    Initialization.
C     _______________________________________________________
C
  100 CONTINUE
C
C     First time through, dynamically allocate memory for workspace
C
      IF( ISIZE.EQ.0 ) THEN
        ISIZE =  2*JPFFT*64
        CALL JMEMHAN( 9, IWORK, ISIZE, 1, KRET)
        IF( KRET.NE.0 ) THEN
          CALL INTLOG(JP_ERROR,'JSYMGG: memory allocation error.',IWORK)
          KRET = JPROUTINE + 1
          GOTO 990
        ENDIF
      ENDIF
C
      IF ( NDBG .GT. 1) THEN
        CALL INTLOG(JP_DEBUG,
     X    'JSYMGG: Spherical harmonic coeffs(first 20):',JPQUIET)
        DO 101 NDBGLP = 1, 20
          CALL INTLOGR(JP_DEBUG,' ',PSHUP( NDBGLP ))
  101   CONTINUE
        CALL INTLOG(JP_DEBUG,'JSYMGG: Input parameters:',JPQUIET)
        CALL INTLOG(JP_DEBUG,
     X    'JSYMGG: Spherical harmonic truncation = ', KTRUNC)
        CALL INTLOG(JP_DEBUG,
     X    'JSYMGG: Start latitude(northernmost) = ', KSTART)
        CALL INTLOG(JP_DEBUG,
     X    'JSYMGG: Stream number of leg. file = ', KLUNIT)
        CALL INTLOG(JP_DEBUG,
     X    'JSYMGG: Number of lat. rows in output = ', KLATO)
        CALL INTLOG(JP_DEBUG,
     X    'JSYMGG: Number of long. pts per row = ', KLONO)
        CALL INTLOG(JP_DEBUG,
     X    'JSYMGG: Trig.functions (setup by JJSET99):',JPQUIET)
        DO 102 NDBGLP = 1, 10
          CALL INTLOGR(JP_DEBUG,' ',PTRIGS( NDBGLP ))
  102   CONTINUE
        CALL INTLOG(JP_DEBUG,
     X    'JSYMGG: Prime factors (setup by JJSET99):',JPQUIET)
        DO 103 NDBGLP = 1, 10
          CALL INTLOG(JP_DEBUG,' ',KMFAX( NDBGLP ))
  103   CONTINUE
      ENDIF
C
      ILIM   = KTRUNC + 1
      IMLIM  = KTRUNC + 1
      INORTH = -1
      ILN    = KLONO + 2
C
C     _______________________________________________________
C
C*    Section 2.    Main loop through latitude rows to
C*                  calculate fourier coefficients
C     _______________________________________________________
C
 200  CONTINUE
C
C     For each latitude, the north and corresponding south latitude row
C     are calculated at the same time from the same legendre functions.
C
      DO 280 JNEXTLAT = KSTART, KSTART+KLATO-1
C
        IF ( NDBG .GT. 1)
     X    CALL INTLOG(JP_DEBUG,'JSYMGG: Next latitude = ', JNEXTLAT)
C
C       If required, generate the coefficients 'on the fly'
C
        IF( LON_FLY ) THEN
          CALL NMAKGG( KTRUNC, JNEXTLAT, PLAT, 1, PLEG, NERR)
          IOFF = 0
        ELSE IF( LFILEIO ) THEN
          CALL JREADGG( KLUNIT, KTRUNC, JNEXTLAT, PLEG, NERR)
          IF ( NERR .NE. 0 ) THEN
            CALL INTLOG(JP_ERROR,'JSYMGG: JREADGG error',NERR)
            KRET = JPROUTINE + 2
            GOTO 990
          ENDIF
        ELSE
C          IOFF = (JNEXTLAT-1)*(KTRUNC+1)*(KTRUNC+4)/2

           IOFF = (JNEXTLAT-1)
           IOFF = (KTRUNC+1) * IOFF
           IOFF = (KTRUNC+4) * IOFF
           IOFF = IOFF / 2

        ENDIF
C
C       Clear unused slots in array.
C       and one for the corresponding south latitude.
C
        INORTH = INORTH + 2
        ISOUTH = INORTH + 1
        DO 241 JF = 2*IMLIM + 1, ILN
          PZFA(JF, INORTH) = 0.0
          PZFA(JF, ISOUTH) = 0.0
 241    CONTINUE
C
C      Now fill slots which are used
C
        IMN = 0
        IMP = 0
C
        DO JM = 1, IMLIM
          ITAL = ILIM - JM + 1
          ITALS = (ITAL + 1)/2
          ITALA = ITAL/2
          CHOLD=(0.0D0, 0.0D0)
          DO J = 1, 2*ITALS, 2
            IF( LFILEIO ) THEN
              CHOLD=CHOLD+PLEG(IMP+J)*PSHUP(IMN+J)
            ELSE
              JDCLOOP = IOFF + IMP + J
              CHOLD=CHOLD+PLEG(JDCLOOP)*PSHUP(IMN+J)
            ENDIF
          ENDDO
          ZSUMS(JM)=CHOLD
          CHOLD = (0.0D0, 0.0D0)
          DO J = 2, 2*ITALA, 2
            IF( LFILEIO ) THEN
              CHOLD=CHOLD+PLEG(IMP+J)*PSHUP(IMN+J)
            ELSE
              JDCLOOP = IOFF + IMP + J
              CHOLD=CHOLD+PLEG(JDCLOOP)*PSHUP(IMN+J)
            ENDIF
          ENDDO
          ZSUMA(JM)=CHOLD
          IMP = IMP + ITAL + 1
          IMN = IMN + ITAL
        ENDDO
C
C       For the southern hemisphere row, the legendre functions are
C       the complex conjugates of the corresponding northern row -
C       hence the juggling with the signs in the next loop.
C
C       Note that PZFA is REAL, but the coefficients being calculated
C       are COMPLEX.  There are pairs of values for each coefficient
C       (real and imaginary parts) and pairs of values for each
C       latitude (north and south).
C
        DO 246 JM = 1, IMLIM
          PZFA(2*JM -1, INORTH) = REAL(ZSUMS(JM))  + REAL(ZSUMA(JM))
          PZFA(2*JM   , INORTH) = AIMAG(ZSUMS(JM)) + AIMAG(ZSUMA(JM))
          PZFA(2*JM -1, ISOUTH) = REAL(ZSUMS(JM))  - REAL(ZSUMA(JM))
          PZFA(2*JM   , ISOUTH) = AIMAG(ZSUMS(JM)) - AIMAG(ZSUMA(JM))
 246    CONTINUE
C
C*    End of main loop through latitude rows.
C
 280  CONTINUE
C
C     _______________________________________________________
C
C*    Section 3.    Fast fourier transform
C     _______________________________________________________
C
 300  CONTINUE
C
      IF ( NDBG .GT. 1) CALL INTLOG(JP_DEBUG,
     X  'JSYMGG: FFT, no.of rows (N and S) = ',ISOUTH)
C
      CALL FFT99(PZFA,WORK,PTRIGS,KMFAX,1,J2NFFT,KLONO,ISOUTH,1)
C
      IF ( NDBG .GT. 1) THEN
        CALL INTLOG(JP_DEBUG,
     X    'JSYMGG: Values calculated by FFT:',JPQUIET)
        DO 301 NDBGLP = 1, 20
          CALL INTLOGR(JP_DEBUG,' ',PZFA( 1, NDBGLP ))
          CALL INTLOGR(JP_DEBUG,' ',PZFA( 2, NDBGLP ))
  301   CONTINUE
      ENDIF
C
C     _______________________________________________________
C
C*    Section 9. Return to calling routine. Format statements
C     _______________________________________________________
C
C
  900 CONTINUE
C
      KRET = 0
C
  990 CONTINUE
      RETURN
      END

C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      INTEGER FUNCTION WAVEXXX(ISEC2, ISEC4, NLATS, STEPNS, STEPWE,
     X                         OLDWAVE, NEWIDX, DISTNEW,
     X                         NEWWAVE, NORTH, WEST, PMISS)
C
C---->
C*****WAVEXXX*
C
C     PURPOSE
C     -------
C
C     Interpolates wave fields (except 2D spectra).
C
C
C     INTERFACE
C     ---------
C
C     IRET = WAVEXXX(ISEC2, ISEC4, NLATS, STEPNS, STEPWE,
C    X               OLDWAVE, NEWIDX, DISTNEW,
C    X               NEWWAVE, NORTH, WEST, PMISS)
C
C     Input arguments
C     ---------------
C
C     ISEC2   - Unpacked section 2 header from 2D wave spectra field
C     ISEC4   - Unpacked section 4 header from 2D wave spectra field
C     NLATS   - Number of points N-S in new grid
C     STEPNS  - Output grid north-south resolution (degrees)
C     STEPWE  - Output grid west-east resolution (degrees)
C     OLDWAVE - Original wave field
C     NORTH   - Output grid northernmost latitude (degrees)
C     WEST    - Output grid westernmost longitude (degrees)
C     PMISS   - Missing data value 
C
C     Output arguments
C     ----------------
C
C     NEWIDX  - Indices of four neighbouring old grid points used for
C               new grid points
C     DISTNEW - Distances of surrounding box edges from new grid points
C     NEWWAVE - New wave field
C
C     Function returns 0 if the interpolation was OK.
C
C
C     METHOD
C     ------
C
C     Builds the index of neighbouring points for the output grid.
C     Then works through the output grid points, checking for subarea
C     boundaries and looking up neighbouring point values and weights.
C     (Neighbours may have missing data).
C
C
C     EXTERNALS
C     ---------
C
C     WAVEIDX - determines which nearest-neighbour values to use for
C               interpolating to new output grid point
C     NUMPTWE - Calculates number of grid points between west/east
C               area boundaries
C     VALPINA - Looks up bitmap value
C     SOFFSET - Finds the section offsets in GRIB message
C     INTLOG  - Log error message
C
C
C     REFERENCE
C     ---------
C
C     None.
C
C
C     Author.
C     -------
C
C     J.D.Chambers      ECMWF    January 1998
C
C
C     Modifications
C     -------------
C     Handle reduced lat/long grid in 'pseudo-gaussian' layout
C     J.D.Chambers      ECMWF    November 2003
C
C
C----<
C
      IMPLICIT NONE
C
C     Parameters
C
      INTEGER JPROUTINE, JPMXLAT
      PARAMETER (JPROUTINE = 40100)
      PARAMETER (JPMXLAT = 1801)
      INTEGER JPNW, JPNE, JPSW, JPSE, JPN, JPS
      INTEGER JPDISNW, JPDISNE, JPDISSW, JPDISSE
      PARAMETER (JPNW = 1)
      PARAMETER (JPNE = 2)
      PARAMETER (JPSW = 3)
      PARAMETER (JPSE = 4)
      PARAMETER (JPN  = 5)
      PARAMETER (JPS  = 6)
      PARAMETER (JPDISNW = 7)
      PARAMETER (JPDISNE = 8)
      PARAMETER (JPDISSW = 9)
      PARAMETER (JPDISSE = 10)
C
C     Subroutine arguments
C
      INTEGER ISEC2, ISEC4, NLATS
      DIMENSION ISEC2(*), ISEC4(*)
      REAL STEPNS, STEPWE, OLDWAVE, NEWWAVE, NORTH, WEST, PMISS
      REAL ONORTH
      DIMENSION OLDWAVE(*), NEWWAVE(*)
      INTEGER NEWIDX
      DIMENSION NEWIDX(4,*)
      REAL*4 DISTNEW
      DIMENSION DISTNEW(10,*)
C
C     Local arguments
C
      INTEGER IEOFSET, IWOFSET, ISTART, IWEST
      REAL SOUTH, PTLAT, AWEST, EAST, PTLONG, OLDWEST, OLDEAST
      REAL REFVAL, SCALE
      INTEGER NSPT1, INSPT, NEXP, NMANT, NRETA, NRETB, NLENG, NBIT
      INTEGER NPARAM, ISCALE, NSCALE, IBITS, ITEMP
      INTEGER IRET, IS0, IS1, IS2, IS3, IS4, IEDITN
      INTEGER NEXT, NEXTWV, NROW, NCOL, INDEX, ILOCATE
      INTEGER MISSLAT, LOOP, NPTS, NUMLATS, NUMNEW, KOLDNUM, KNEWNUM
      DIMENSION NPTS(JPMXLAT), NUMNEW(JPMXLAT)
      REAL RLATINC, OLDLATS, NEWLATS, ROWINC
      DIMENSION OLDLATS(JPMXLAT), NEWLATS(JPMXLAT)
      LOGICAL LDIREC
      REAL*4 DISNW, DISNE, DISSW, DISSE
      REAL*4 NW_PT, NE_PT, SW_PT, SE_PT
      REAL*4 RAD
      DATA RAD/0.017453293/
      REAL*4 DI1N, DI1S, DI2N, DI2S, DK1, DK2
      REAL*4 CNW_PT, CNE_PT, CSW_PT, CSE_PT
      REAL*4 SNW_PT, SNE_PT, SSW_PT, SSE_PT
      REAL*4 U1, U2, C1, C2, S1, S2, CC, SS
      INTEGER INW, INE, ISW, ISE, JNW, JNE, JSW, JSE
C
C     Externals
C
      INTEGER WAVEIDX, SOFFSET, VALPINA, NUMPTWE
      EXTERNAL WAVEIDX, SOFFSET, VALPINA, NUMPTWE
C
#include "parim.h"
#include "nifld.common"
#include "nofld.common"
#include "grspace.h"
C
C ---------------------------------------------------------------------
C*    Section 1. Initalisation.
C ---------------------------------------------------------------------
C
  100 CONTINUE
C
      WAVEXXX = 0

C
C     Initialise the bitmap value lookup function
C
      IRET = VALPINA(0,0,0)
C
      MISSLAT = 0
C
C     Calculate number of latitudes if grid had been full from
C     North pole to South pole
C
      NUMLATS = (180000/ISEC2(10)) + 1
      IF( NUMLATS.GT.JPMXLAT ) THEN
        CALL INTLOG(JP_ERROR,
     X    'WAVEXXX: Number of latitudes in input grid = ',NUMLATS)
        CALL INTLOG(JP_ERROR,
     X    'WAVEXXX: And is greater than allowed maximum = ',JPMXLAT)
        WAVEXXX = JPROUTINE + 1
        GOTO 900
      ENDIF
C
      RLATINC = FLOAT(ISEC2(10))
cs      RLATINC = FLOAT(ISEC2(10)/1000)
C
C     Fill an array with the number of points at each latitude for the
C     input field.
C
      IF( ISEC2(17).EQ.1 ) THEN
C
C       Input field is a reduced latitude/longitude grid
C
C       .. but it may be 'pseudo-gaussian' in layout
C       (ie global, symmetric about the equator but no latitude
C        at the equator)
C
        IF( (ISEC2(4).NE.90000).AND.(MOD(ISEC2(3),2).EQ.0) ) THEN
C
          NUMLATS = ISEC2(3)
cs          RLATINC = FLOAT(ISEC2(10))/1000
cs          ONORTH = FLOAT(ISEC2(4))/1000
          ONORTH = FLOAT(ISEC2(4))
C
          DO LOOP = 1, NUMLATS
cs            OLDLATS(LOOP) = ONORTH - (LOOP-1)*RLATINC
            OLDLATS(LOOP) = (ONORTH - (LOOP-1)*RLATINC)/1000
          ENDDO
C
          DO LOOP = 1, ISEC2(3)
            NPTS(LOOP+MISSLAT) = ISEC2(22+LOOP)
          ENDDO
C
        ELSE
C
          DO LOOP = 1, NUMLATS
            OLDLATS(LOOP) = (90000.0 - (LOOP-1)*RLATINC)/1000
cs            OLDLATS(LOOP) = 90.0 - (LOOP-1)*RLATINC
          ENDDO
C
          MISSLAT = (90000 - ISEC2(4))/ISEC2(10)
          DO LOOP = 1, MISSLAT
            NPTS(LOOP)    = 0
          ENDDO
          KOLDNUM = 1 + (90000 - ISEC2(7))/ISEC2(10)
          DO LOOP = 1, (KOLDNUM-MISSLAT)
            NPTS(LOOP+MISSLAT) = ISEC2(22+LOOP)
          ENDDO
          DO LOOP = (KOLDNUM+1), NUMLATS
            NPTS(LOOP)    = 0
          ENDDO
        ENDIF
C
      ELSE
C
C       Input field is a regular latitude/longitude grid
C
C
        DO LOOP = 1, NUMLATS
cs          OLDLATS(LOOP) = 90.0 - (LOOP-1)*RLATINC
            OLDLATS(LOOP) = (90000.0 - (LOOP-1)*RLATINC)/1000
        ENDDO
C
        MISSLAT = (90000 - ISEC2(4))/ISEC2(10)
        DO LOOP = 1, MISSLAT
          NPTS(LOOP)    = 0
        ENDDO
        KOLDNUM = 1 + (90000 - ISEC2(7))/ISEC2(10)
        DO LOOP = 1, (KOLDNUM-MISSLAT)
          NPTS(LOOP+MISSLAT) = ISEC2(2)
        ENDDO
        DO LOOP = (KOLDNUM+1), NUMLATS
          NPTS(LOOP)    = 0
        ENDDO
      ENDIF
C
C ---------------------------------------------------------------------
C*    Section 2. Setup number of points at each latitude for the
C                output latitude/longitude field.
C ---------------------------------------------------------------------
C
  200 CONTINUE
C
      IF( (NOREPR.EQ.JPQUASI) .OR. (NOREPR.EQ.JPGAUSSIAN) ) THEN
C
C       Reduced (quasi-regular) gaussian output
C
        KNEWNUM = NOGAUSS*2
        DO LOOP = 1, KNEWNUM
          NUMNEW(LOOP)  = NOLPTS(LOOP)
          NEWLATS(LOOP) = ROGAUSS(LOOP)
        ENDDO
C
      ELSE IF( NOREPR.EQ.JPREDLL ) THEN
C
C       Reduced (quasi-regular) lat/long output
C
        KNEWNUM = NOREDLL
        DO LOOP = 1, KNEWNUM
          NUMNEW(LOOP)  = NOLPTS(LOOP)
          NEWLATS(LOOP) = ROREDLL(LOOP)
        ENDDO
C
      ELSE
C
C       Regular output
C
        MISSLAT = NINT((90.0 - NORTH)/STEPNS)
        DO LOOP = 1, MISSLAT
          NUMNEW(LOOP)    = 0
        ENDDO
        DO LOOP = 1, NLATS
          NUMNEW(LOOP+MISSLAT) = NINT(360.0/STEPWE)
        ENDDO
C
        KNEWNUM = MISSLAT + NLATS
        DO LOOP = 1, KNEWNUM
          NEWLATS(LOOP) = 90.0 - (LOOP-1)*STEPNS
        ENDDO
C
      ENDIF
C
C ---------------------------------------------------------------------
C*    Section 3. Get the input GRIB field characteristics.
C ---------------------------------------------------------------------
C
  300 CONTINUE
C
C     Calculate the indices of the input grid points to be used for
C     the output points
C
      OLDWEST = FLOAT(NIAREA(2))/PPMULT
      OLDEAST = FLOAT(NIAREA(4))/PPMULT

      WAVEXXX = WAVEIDX(NUMLATS,NPTS,OLDLATS,OLDWEST,OLDEAST,
     X                  KNEWNUM, NUMNEW, NEWLATS,
     X                  NEWIDX, DISTNEW)
      IF( WAVEXXX.NE.0 ) THEN
        CALL INTLOG(JP_ERROR,
     X    'WAVEXXX: Unable to calculate output grid indices',JPQUIET)
        WAVEXXX = JPROUTINE + 2
        GOTO 900
      ENDIF
C
C     Find bitmap (section 3) offset the GRIB product
C
      IRET = SOFFSET(OLDWAVE, IS0, IS1, IS2, IS3, IS4, IEDITN)
C
C     Get the overall length of OLDWAVE
C
#ifdef INTEGER_8
      NBIT = 64
#else
      NBIT = 32
#endif
      INSPT = (IS0 + 4) * 8
      CALL INXBIT(OLDWAVE,10,INSPT,NLENG,1,NBIT,24,'D',NRETA)
      IF( NRETA.NE.0 ) THEN
        CALL INTLOG(JP_ERROR,
     X    'WAVEXXX: Problem extracting overall length of GRIB',JPQUIET)
        WAVEXXX = JPROUTINE + 3
        GOTO 900
      ENDIF
C
C     Get parameter identifier
C
      INSPT = (IS1 + 8) * 8
      CALL INXBIT(OLDWAVE,10,INSPT,NPARAM,1,NBIT,8,'D',NRETA)
      IF( NRETA.NE.0 ) THEN
        CALL INTLOG(JP_ERROR,
     X    'WAVEXXX: Problem getting parameter identifier',JPQUIET)
        WAVEXXX = JPROUTINE + 4
        GOTO 900
      ENDIF
C
C     Wave direction parameters need special handling
C     (MWD, MDWW, MDPS, MDWI)
C
      LDIREC = ( (NPARAM.EQ.230) .OR.
     X           (NPARAM.EQ.235) .OR.
     X           (NPARAM.EQ.238) .OR.
     X           (NPARAM.EQ.242) )
C
C     Get the scale factor
C
      INSPT = (IS4 + 4) * 8
      CALL INXBIT(OLDWAVE,NLENG,INSPT,NSCALE,1,NBIT,16,'D',NRETA)
      IF( NRETA.NE.0 ) THEN
        CALL INTLOG(JP_ERROR,
     X    'WAVEXXX: Problem extracting scale factor in GRIB',JPQUIET)
        WAVEXXX = JPROUTINE + 5
        GOTO 900
      ENDIF
      CALL DSGNBT(ISCALE,NSCALE,16,NRETA)
      IF( NRETA.NE.0 ) THEN
        CALL INTLOG(JP_ERROR,
     X    'WAVEXXX: Problem setting sign of scale factor',JPQUIET)
        WAVEXXX = JPROUTINE + 6
        GOTO 900
      ENDIF
      SCALE = 2.0**(FLOAT(ISCALE))
C
C     Get the reference value
C
      CALL INXBIT(OLDWAVE,NLENG,INSPT,NEXP,1,NBIT,8,'D',NRETA)
      CALL INXBIT(OLDWAVE,NLENG,INSPT,NMANT,1,NBIT,24,'D',NRETB)
      IF( (NRETA.NE.0) .OR. (NRETB.NE.0) ) THEN
        CALL INTLOG(JP_ERROR,
     X    'WAVEXXX: Problem getting reference value from GRIB',JPQUIET)
        WAVEXXX = JPROUTINE + 7
        GOTO 900
      ENDIF
      CALL DECFP2(REFVAL,NEXP,NMANT)
C
C     Get number of bits per packed value
C
      CALL INXBIT(OLDWAVE,NLENG,INSPT,IBITS,1,NBIT,8,'D',NRETA)
      IF( NRETA.NE.0 ) THEN
        CALL INTLOG(JP_ERROR,
     X    'WAVEXXX: Problem getting number of bits per word',JPQUIET)
        WAVEXXX = JPROUTINE + 8
        GOTO 900
      ENDIF
      NSPT1 = INSPT
C
C ---------------------------------------------------------------------
C*    Section 4. Work through the output subarea.
C ---------------------------------------------------------------------
C
  400 CONTINUE
C
C     Fill in the wave spectra values
C
      NEXT = 0
      NEXTWV = 0
C
      SOUTH = NOAREA(3)/PPMULT
      EAST  = NOAREA(4)/PPMULT
      ISTART = 0
C
C     Work down through latitudes from north to south.
C


      DO NROW = 1, KNEWNUM
C
C       If inside north-south (subarea) boundaries ..
C
        IF( (NOREPR.EQ.JPGAUSSIAN).OR.(NOREPR.EQ.JPQUASI) ) THEN
          PTLAT = ROGAUSS(NROW)
        ELSE
          PTLAT = 90.0 - (NROW-1)*STEPNS
        ENDIF
        IF( (PTLAT.LE.NORTH).AND.(ABS(PTLAT-SOUTH).GT.-0.0005) ) THEN
C
C         Calculate number of points between west boundary of area and
C         Greenwich
C
          ROWINC = 360.0/NUMNEW(NROW)
C
          IWEST = INT(WEST/ROWINC)
          IF( (WEST.GT.0.0).AND.(WEST.NE.(IWEST*ROWINC)) )
     X      IWEST = IWEST + 1
          AWEST = IWEST * ROWINC
          IWOFSET = NUMPTWE(AWEST,0.0,ROWINC)
          IEOFSET = NUMPTWE(AWEST,EAST,ROWINC)
C
C         Work through subarea longitudes from west to east.
C
          DO NCOL = 1, NUMNEW(NROW)
            PTLONG = AWEST + (NCOL-1)*ROWINC
            NEXT = NUMPTWE(AWEST,PTLONG,ROWINC)
            IF( (NEXT.LE.IEOFSET).AND.(NEXT.GE.0) ) THEN
C
C             .. and inside west-east (subarea) boundaries
C
              NEXT = 1 + NEXT - IWOFSET
              IF( NEXT.LE.0) NEXT = NEXT + NUMNEW(NROW)
              NEXT = NEXT + ISTART
              NEXTWV = NEXTWV + 1
C
              INW = NEWIDX(JPNW,NEXT)
              INE = NEWIDX(JPNE,NEXT)
              ISW = NEWIDX(JPSW,NEXT)
              ISE = NEWIDX(JPSE,NEXT)
C
C             If there is a bitmap, ...
C
              IF( IS3.NE.0 ) THEN
                IF(INW.NE.0) JNW = VALPINA(OLDWAVE, IS3+6, INW)
                IF(INE.NE.0) JNE = VALPINA(OLDWAVE, IS3+6, INE)
                IF(ISW.NE.0) JSW = VALPINA(OLDWAVE, IS3+6, ISW)
                IF(ISE.NE.0) JSE = VALPINA(OLDWAVE, IS3+6, ISE)
              ELSE
                JNW = INW
                JNE = INE
                JSW = ISW
                JSE = ISE
              ENDIF
C
C             Test if any of the four neighbouring points is missing.
C
              IF( (INW.EQ.0) .OR. (INE.EQ.0) .OR.
     X            (ISW.EQ.0) .OR. (ISE.EQ.0) .OR.
     X            (JNW.EQ.0) .OR. (JNE.EQ.0) .OR.
     X            (JSW.EQ.0) .OR. (JSE.EQ.0) ) THEN
c 
C
C               If so, take nearest grid point value.
C
                DISNW = DISTNEW(JPDISNW,NEXT)
                DISNE = DISTNEW(JPDISNE,NEXT)
                DISSW = DISTNEW(JPDISSW,NEXT)
                DISSE = DISTNEW(JPDISSE,NEXT)
C
                IF( (DISNW.LE.DISNE).AND.
     X              (DISNW.LE.DISSW).AND.
     X              (DISNW.LE.DISSE)) THEN
                  INDEX = INW
                  ILOCATE  = JNW
C
                ELSE IF( (DISNE.LE.DISSW).AND.
     X                   (DISNE.LE.DISSE) ) THEN
                  INDEX = INE
                  ILOCATE  = JNE
C
                ELSE IF( (DISSW.LE.DISSE) ) THEN
                  INDEX = ISW
                  ILOCATE  = JSW
C
                ELSE
                  INDEX = ISE
                  ILOCATE  = JSE
                ENDIF
C
                IF( (INDEX.EQ.0).OR.(ILOCATE.EQ.0) ) THEN
C
C                 Nearest point is missing
C
                  NEWWAVE(NEXTWV) = PMISS
C
                ELSE
                  INSPT = NSPT1 + (ILOCATE - 1)*IBITS
                  CALL INXBIT(OLDWAVE,NLENG,INSPT,ITEMP,1,
     X                        NBIT,IBITS,'D',NRETA)
                  IF( NRETA.NE.0 ) THEN
                    CALL INTLOG(JP_ERROR,
     X              'WAVEXXX: Problem getting nearest neighbour value',
     X              JPQUIET)
                    WAVEXXX = JPROUTINE + 9
                  GOTO 900
                  ENDIF
                  NEWWAVE(NEXTWV) = REFVAL + FLOAT(ITEMP)*SCALE
                ENDIF
C
              ELSE
C
C               Use bi-linear interpolation from four
C               neighbouring sea points.
C
                INSPT = NSPT1 + (JNW - 1)*IBITS
                CALL INXBIT(OLDWAVE,NLENG,INSPT,ITEMP,1,
     X                      NBIT,IBITS,'D',NRETA)
                IF( NRETA.NE.0 ) THEN
                  CALL INTLOG(JP_ERROR,
     X            'WAVEXXX: Problem getting NW neighbour value',
     X            JPQUIET)
                  WAVEXXX = JPROUTINE + 10
                  GOTO 900
                ENDIF
                NW_PT = REFVAL + FLOAT(ITEMP)*SCALE
C
                INSPT = NSPT1 + (JNE - 1)*IBITS
                CALL INXBIT(OLDWAVE,NLENG,INSPT,ITEMP,1,
     X                      NBIT,IBITS,'D',NRETA)
                IF( NRETA.NE.0 ) THEN
                  CALL INTLOG(JP_ERROR,
     X            'WAVEXXX: Problem getting NE neighbour value',
     X            JPQUIET)
                  WAVEXXX = JPROUTINE + 10
                  GOTO 900
                ENDIF
                NE_PT = REFVAL + FLOAT(ITEMP)*SCALE
C
                INSPT = NSPT1 + (JSW - 1)*IBITS
                CALL INXBIT(OLDWAVE,NLENG,INSPT,ITEMP,1,
     X                      NBIT,IBITS,'D',NRETA)
                IF( NRETA.NE.0 ) THEN
                  CALL INTLOG(JP_ERROR,
     X            'WAVEXXX: Problem getting SW neighbour value',
     X            JPQUIET)
                  WAVEXXX = JPROUTINE + 10
                  GOTO 900
                ENDIF
                SW_PT = REFVAL + FLOAT(ITEMP)*SCALE
C
                INSPT = NSPT1 + (JSE - 1)*IBITS
                CALL INXBIT(OLDWAVE,NLENG,INSPT,ITEMP,1,
     X                      NBIT,IBITS,'D',NRETA)
                IF( NRETA.NE.0 ) THEN
                  CALL INTLOG(JP_ERROR,
     X            'WAVEXXX: Problem getting SE neighbour value',
     X            JPQUIET)
                  WAVEXXX = JPROUTINE + 10
                  GOTO 900
                ENDIF
                SE_PT = REFVAL + FLOAT(ITEMP)*SCALE
C
                DI1N = DISTNEW(JPNW,NEXT)
                DI2N = DISTNEW(JPNE,NEXT)
                DI1S = DISTNEW(JPSW,NEXT)
                DI2S = DISTNEW(JPSE,NEXT)
                DK1  = DISTNEW(JPN,NEXT)
                DK2  = DISTNEW(JPS,NEXT)
C
                IF( .NOT. LDIREC ) THEN
                  U1 = NW_PT*DI2N + NE_PT*DI1N
                  U2 = SW_PT*DI2S + SE_PT*DI1S
                  NEWWAVE(NEXTWV) = U1*DK2 + U2*DK1
                ELSE
C
C                 Fields representing a 'direction': resolve into
C                 components and interpolate each separately.
C
                  CNW_PT = COS(NW_PT*RAD)
                  CNE_PT = COS(NE_PT*RAD)
                  CSW_PT = COS(SW_PT*RAD)
                  CSE_PT = COS(SE_PT*RAD)
                  SNW_PT = SIN(NW_PT*RAD)
                  SNE_PT = SIN(NE_PT*RAD)
                  SSW_PT = SIN(SW_PT*RAD)
                  SSE_PT = SIN(SE_PT*RAD)
                  C1 = CNW_PT*DI2N + CNE_PT*DI1N
                  C2 = CSW_PT*DI2S + CSE_PT*DI1S
                  CC = C1*DK2 + C2*DK1
                  S1 = SNW_PT*DI2N + SNE_PT*DI1N
                  S2 = SSW_PT*DI2S + SSE_PT*DI1S
                  SS = S1*DK2 + S2*DK1
                  IF( SS.LT.0.0 ) THEN
                    NEWWAVE(NEXTWV) = ATAN2(SS,CC)/RAD + 360.0
                  ELSE
                    NEWWAVE(NEXTWV) = ATAN2(SS,CC)/RAD
                  ENDIF
                ENDIF
              ENDIF
            ENDIF
          ENDDO
C
        ENDIF
        ISTART = ISTART + NUMNEW(NROW)
      ENDDO
C
C ---------------------------------------------------------------------
C*    Section 9. Closedown.
C ---------------------------------------------------------------------
C
  900 CONTINUE
      RETURN
      END

C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE BUSRQ(KREQ,KRQL,KRQ,RQV,KERR)
C
C**** *BUSRQ*
C
C
C     PURPOSE.
C     --------
C          SET LIST OF BUFR TABLE B ELEMENT REFERENCES
C     FOR PARTIAL EXPANSION.
C
C
C**   INTERFACE.
C     ----------
C
C          *CALL* *BUSRQ(KREQ,KRQL,KRQ,RQV,KERR)*
C
C        INPUT :
C               *KREQ*    -  FLAG
C                            BIT NUMBER     MEANING
C                                1        - 0 NO BIT MAP DELIVERED TO USER
C                                           1    BIT MAP DELIVERED TO USER
C                                2        - 0 NO PARTIAL EXPANSION
C                                           1    PARTIAL EXPANSION
C                                3        - 0 NO Q/C REQUIRED
C                                         - 1    Q/C REQUIRED
C                                4        - 0 NO STATISTICS REQUIRED
C                                         - 1    STATISTICS
C                                5        - 0 NO DIFFRENCE STATISTICS
C                                         - 1    DIFFERENCE STATISTICS
C                                6        - 0 NO SUBSTITUTED VALUES
C                                         - 1    SUBSTITUTED VALUES
C               *KRQL*    -  NUMBER OF REQUESTED ELEMENTS
C               *KRQ*     -  LIST OF REQUESTED TABLE B REFERENCE
C               *RQV*     -  LIST OF VALUES SIGNIFYING REQUESTED ELEMENT
C                            (SAY PRESSURE  AT 50000 PA)
C        OUTPUT:
C               *KERR*    -  RETURNED ERROR CODE
C
C
C     METHOD.
C     -------
C
C          NONE.
C
C
C     EXTERNALS.
C     ----------
C
C          NONE.
C
C     REFERENCE.
C     ----------
C
C          NONE.
C
C     AUTHOR.
C     -------
C
C          M. DRAGOSAVAC    *ECMWF*       15/01/91.
C
C
C     MODIFICATIONS.
C     --------------
C
C          NONE.
C
C
      IMPLICIT LOGICAL(L,O,G), CHARACTER*8(C,H,Y)
C
C
#     include "parameter.F"
#     include "bcomunit.F"
#     include "bcomreq.F"
#     include "bcomdefc.F"
C
      CHARACTER*4 CUSER,CECMWF
      DIMENSION KRQ(*),KREQ(*)
#ifndef R_4
      REAL*8 RQV(*)
      REAL*8 RQVAL
#else
      REAL   RQV(*)
      REAL   RQVAL
#endif
C
C     ------------------------------------------------------------------
C*          1. MOVE REQUESTED ELEMENTS INTO COMMON BLOCK /COMREQ/.
C              ---------------------------------------------------
 100  CONTINUE
C
      IF(KERR.GT.0) RETURN
C
      CUSER='USER'
C
      NRQL=KRQL
      NREQ(1)=KREQ(1)
      NREQ(2)=KREQ(2)
C
      DO 101 I=1,KRQL
      NRQ(I)=KRQ(I)
      RQVAL(I)=RQV(I)
 101  CONTINUE
C
      RETURN
      END

C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      INTEGER FUNCTION INTUVXH(PUVSH,KNVALS,ZNFLDO,KUGRIB,KVGRIB,
     X                         OUTLENU,OUTLENV)
C
C---->
C**** INTUVXH
C
C     Purpose
C     -------
C
C     Interpolate U or V component spectral fields to grid point.
C
C
C     Interface
C     ---------
C
C     IRET = INTUVXH(PUVSH,KNVALS,ZNFLDO,KUGRIB,KVGRIB,OUTLENU,OUTLENV)
C
C     Input
C     -----
C
C     PUVSH  - Spectral U/V values. (U first)
C     KNVALS - Number of values in each wind component field.
C     ZNFLDO - Work array.
C
C
C     Output
C     ------
C
C     KUGRIB  - Output wind U component field (GRIB format).
C     KVGRIB  - Output wind V component field (GRIB format).
C     OUTLENU - Output U field length (words).
C     OUTLENV - Output V field length (words).
C
C
C     Method
C     ------
C
C     None.
C
C
C     Externals
C     ---------
C
C     INTUVDH - Encode/decode data into/from GRIB code.
C     INTFAU  - Prepare to interpolate unpacked input field.
C     INTFBU  - Interpolate unpacked input field.
C     INTLOG  - Log error message.
C     MKFRAME - Create a 'frame' from a rectangular field.
C
C
C     Author
C     ------
C
C     J.D.Chambers     ECMWF     February 2001
C
C
C----<
C     -----------------------------------------------------------------|
C
      IMPLICIT NONE
C
#include "parim.h"
#include "nifld.common"
#include "nofld.common"
#include "intf.h"
#include "current.h"
C
C     Parameters
C
      INTEGER JPROUTINE
      PARAMETER (JPROUTINE = 40170 )
C
C     Function arguments
C
      INTEGER KPARAM, KNVALS, KUGRIB(*), KVGRIB(*), OUTLENU, OUTLENV
      REAL PUVSH(KNVALS*2), ZNFLDO(*)
C
C     Local variables
C
      LOGICAL LFRAME, LOLDWIND
      INTEGER NPARAM, IRET, ILENF, NTRUNC, NGAUSS, ISIZE, NCOUNT
      INTEGER NUVFLAG, NLON, NLAT, NUMPTS, NBYTES
      REAL AREA(4), GRID(2), POLE(2), EAST, WEST
      CHARACTER*1 HOLDTYP
      INTEGER LOOP
C
      REAL RGGRID, SWORK
      POINTER (IRGGRID, RGGRID(1) )
      POINTER (ISWORK, SWORK(1) )
C
      INTEGER KPTS(JPGTRUNC*2)
      REAL GLATS(JPGTRUNC*2)
C
C     Externals
C
      INTEGER FIXAREA, INTFAU, INTFBU, INTUVDH, HSP2GG
      INTEGER HIRLAMW, JMALLOC
C
      DATA IRGGRID/0/, ISWORK/0/
      SAVE IRGGRID, ISWORK
C
C     -----------------------------------------------------------------|
C*    Section 1.   Initialise.
C     -----------------------------------------------------------------|
C
  100 CONTINUE
C
      INTUVXH = 0
C
      LFRAME = LNOFRAME.AND.
     X         ((NOREPR.EQ.JPREGULAR).OR.(NOREPR.EQ.JPGAUSSIAN).OR.
     X          (NOREPR.EQ.JPREGROT ).OR.(NOREPR.EQ.JPFGGROT  ) )
C
      IF( LNOROTA ) GOTO 300
C
C     -----------------------------------------------------------------|
C*    Section 2.   Spectral to grid-point with no rotation
C     -----------------------------------------------------------------|
C
  200 CONTINUE
C
      CALL INTLOG(JP_DEBUG,
     X  'INTUVXH: Interoplate U & V fields with no rotation',JPQUIET)
C
C     Unpack and interpolate U field
C
      NIFORM = 0
      NIPARAM = JP_U
      LWIND = .TRUE.
      LOLDWIND = LWINDSET
      LWINDSET = .TRUE.
C
      IRET = INTFAU( PUVSH, KNVALS)
      IF( IRET.NE.0 ) THEN
        CALL INTLOG(JP_ERROR,
     X    'INTUVXH: Prepare to interpolate failed.',JPQUIET)
        INTUVXH = JPROUTINE + 2
        GOTO 900
      ENDIF
C
      IRET = INTFBU( PUVSH, KNVALS, ZNFLDO, ILENF)
      IF( IRET.NE.0 ) THEN
        CALL INTLOG(JP_ERROR,'INTUVXH: Interpolation failed.',JPQUIET)
        INTUVXH = JPROUTINE + 2
        GOTO 900
      ENDIF
C
C     Unpack and interpolate V field
C
      NIPARAM = JP_V
C
      IRET = INTFAU( PUVSH(1+KNVALS), KNVALS)
      IF( IRET.NE.0 ) THEN
        CALL INTLOG(JP_ERROR,
     X    'INTUVXH: Prepare to interpolate failed.',JPQUIET)
        INTUVXH = JPROUTINE + 2
        GOTO 900
      ENDIF
C
      IRET = INTFBU( PUVSH(1+KNVALS), KNVALS, ZNFLDO(1+ILENF), ILENF)
      IF( IRET.NE.0 ) THEN
        CALL INTLOG(JP_ERROR,'INTUVXH: Interpolation failed.',JPQUIET)
        INTUVXH = JPROUTINE + 2
        GOTO 900
      ENDIF
C
C     Reset the input format flag
C
      NIFORM = 1
C
C     Get some scratch memory for the U fields before interpolation
C     (to prevent overwriting V in ZNFLDO during interpolation)
C
cs      ISIZE  = ILENF
cs      CALL JMEMHAN( 11, ISWORK, ISIZE, 1, IRET)
cs      IF( IRET.NE.0 ) THEN
cs        CALL INTLOG(JP_ERROR,
cs     X    'INTUVXH: memory alloc for scratch memory failed',JPQUIET)
cs        INTUVXH = JPROUTINE + 2
cs        GOTO 900
cs      ENDIF
C
      LWINDSET = LOLDWIND
C
C
C     If a 'frame' has been specified, build the frame
C
      IF( LFRAME ) THEN
        LIMISSV = .TRUE.
        NLON = 1 + NINT(FLOAT(NOAREA(JPEAST)  - NOAREA(JPWEST)) /
     X       NOGRID(JPWESTEP))
        NLAT = 1 + NINT(FLOAT(NOAREA(JPNORTH) - NOAREA(JPSOUTH)) /
     X       NOGRID(JPNSSTEP))
        CALL MKFRAME(NLON,NLAT,ZNFLDO,RMISSGV,NOFRAME)
        CALL MKFRAME(NLON,NLAT,ZNFLDO(1+ILENF),RMISSGV,NOFRAME)
      ENDIF

C     Code data into GRIB
cs      DO LOOP = 1, ILENF
cs        SWORK(LOOP) = ZNFLDO(LOOP)
cs      ENDDO
C
cs      IRET = INTUVDH(SWORK,ILENF,KUGRIB,OUTLENU,'C',JP_U)
      IRET = INTUVDH(ZNFLDO,ILENF,KUGRIB,OUTLENU,'C',JP_U)
      IF( IRET.NE.0 ) THEN
        CALL INTLOG(JP_ERROR,
     X    'INTUVXH: Wind component into GRIB encoding fail',IRET)
        INTUVXH = JPROUTINE + 2
        GOTO 900
      ENDIF
C
      IRET = INTUVDH(ZNFLDO(1+ILENF),ILENF,KVGRIB,OUTLENV,'C',JP_V)
      IF( IRET.NE.0 ) THEN
        CALL INTLOG(JP_ERROR,
     X    'INTUVXH: Wind component into GRIB encoding fail',IRET)
        INTUVXH = JPROUTINE + 2
        GOTO 900
      ENDIF
C
      GOTO 900
C
C     -----------------------------------------------------------------|
C*    Section 3.   Initialise spectral to grid-point with rotation
C     -----------------------------------------------------------------|
C
  300 CONTINUE
C
      IF( .NOT.LUSEHIR ) THEN
        CALL INTLOG(JP_ERROR,
     X    'INTUVXH : Unable to rotate spectral U or V:',JPQUIET)
        INTUVXH  = JPROUTINE + 3
        GOTO 900
      ENDIF
C
      IF( (NOREPR.NE.JPREGROT).AND.(NOREPR.NE.JPREGULAR) ) THEN
        CALL INTLOG(JP_ERROR,
     X    'INTUVXH : For U/V, only regular lat/long',JPQUIET)
        CALL INTLOG(JP_ERROR,
     X    'INTUVXH : output rotated grids allowed',JPQUIET)
        INTUVXH  = JPROUTINE + 3
        GOTO 900
      ENDIF
C
      CALL INTLOG(JP_DEBUG,'INTUVXH: Rotate the U & V fields',JPQUIET)
      CALL INTLOG(JP_DEBUG,'INTUVXH: South pole lat  ',NOROTA(1))
      CALL INTLOG(JP_DEBUG,'INTUVXH: South pole long ',NOROTA(2))
C
C     Fill area limits (handles case when default 0/0/0/0 given)
C
cs      IRET = FIXAREA()
cs      IF( IRET.NE.0 ) THEN
cs        CALL INTLOG(JP_ERROR,'INTUVXH: area fixup failed',JPQUIET)
cs        INTUVXH = JPROUTINE + 3
cs        GOTO 900
cs      ENDIF
C
      AREA(1) = REAL(NOAREA(1))/PPMULT
      AREA(2) = REAL(NOAREA(2))/PPMULT
      AREA(3) = REAL(NOAREA(3))/PPMULT
      AREA(4) = REAL(NOAREA(4))/PPMULT
C
      GRID(1) = REAL(NOGRID(1))/PPMULT
      GRID(2) = REAL(NOGRID(2))/PPMULT
C
      POLE(1) = REAL(NOROTA(1))/PPMULT
      POLE(2) = REAL(NOROTA(2))/PPMULT
C
C     -----------------------------------------------------------------|
C*    Section 4.   Convert spectral to suitable global reduced gaussian
C     -----------------------------------------------------------------|
C
  400 CONTINUE
C
      NTRUNC = NIRESO
      IRET = HSP2GG(NTRUNC,NGAUSS,KPTS,GLATS,ISIZE)
      IF( IRET.NE.0 ) THEN
        CALL INTLOG(JP_ERROR,
     X    'INTUVXH: problem getting data for reduced grid',NTRUNC)
        INTUVXH = JPROUTINE + 4
        GOTO 900
      ENDIF
      NCOUNT = ISIZE
C
C     Dynamically allocate memory for global reduced gaussian grid
C
      CALL JMEMHAN( 18, IRGGRID, (NCOUNT*2), 1, IRET)
      IF( IRET.NE.0 ) THEN
        CALL INTLOG(JP_ERROR,
     X    'INTUVXH: memory alloc for reduced grid fail',JPQUIET)
        INTUVXH = JPROUTINE + 4
        GOTO 900
      ENDIF
C
C     Set flag to show field is a wind component
C
      NUVFLAG = 1
C
C     Create the reduced gaussian grid
C
      HOLDTYP = HOGAUST
      WEST = 0.0
      EAST = 360.0 - (360.0/(NGAUSS*4))
C
C     U component
C
      CALL JAGGGP(PUVSH,NTRUNC,GLATS(1),GLATS(NGAUSS*2),WEST,
     X            EAST,NGAUSS,'R',KPTS,RGGRID,NUVFLAG,IRET)
      IF( IRET.NE.0 ) THEN
        CALL INTLOG(JP_ERROR,
     X    'INTUVXH: spectral to reduced gaussian failed',JPQUIET)
        INTUVXH = JPROUTINE + 4
        GOTO 900
      ENDIF
C
      HOGAUST = HOLDTYP
C
C     V component
C
      CALL JAGGGP(PUVSH(1+KNVALS),NTRUNC,GLATS(1),GLATS(NGAUSS*2),WEST,
     X            EAST,NGAUSS,'R',KPTS,RGGRID(1+NCOUNT),NUVFLAG,IRET)
      IF( IRET.NE.0 ) THEN
        CALL INTLOG(JP_ERROR,
     X    'INTUVXH: spectral to reduced gaussian failed',JPQUIET)
        INTUVXH = JPROUTINE + 4
        GOTO 900
      ENDIF
C
      HOGAUST = HOLDTYP
C
C     -----------------------------------------------------------------|
C*    Section 5.   Rotate using 12-point horizontal interpolation
C     -----------------------------------------------------------------|
C
  500 CONTINUE
C
C     Dynamically allocate memory for rotated lat/long grid
C
      NLON = 1 + NINT(FLOAT(NOAREA(JPEAST)  - NOAREA(JPWEST)) /
     X       NOGRID(JPWESTEP))
      NLAT = 1 + NINT(FLOAT(NOAREA(JPNORTH) - NOAREA(JPSOUTH)) /
     X       NOGRID(JPNSSTEP))
C
      NUMPTS = NLON * NLAT
      ISIZE  = NUMPTS * 2
      CALL JMEMHAN( 11, ISWORK, ISIZE, 1, IRET)
      IF( IRET.NE.0 ) THEN
        CALL INTLOG(JP_ERROR,
     X    'INTUVXH: memory alloc for lat/long grid fail',JPQUIET)
        INTUVXH = JPROUTINE + 5
        GOTO 900
      ENDIF
C
      IRET = HIRLAMW(LO12PT,RGGRID,RGGRID(1+NCOUNT),NCOUNT,NGAUSS,AREA,
     X               POLE,GRID,SWORK,SWORK(1+NUMPTS),NUMPTS,NLON,NLAT)
C
      IF( IRET.NE.0 ) THEN
        CALL INTLOG(JP_ERROR,
     X    'INTUVXH: HIRLAMW rotation failed',JPQUIET)
        INTUVXH = JPROUTINE + 5
        GOTO 900
      ENDIF
C
C     -----------------------------------------------------------------|
C*    Section 6.   Pack the fields into GRIB format
C     -----------------------------------------------------------------|
C
  600 CONTINUE
C
C     Reset the input format flag
C
      NIFORM = 1
C
C     Set the components flag for rotated U and V coefficients
C
      ISEC2(19) = 8
C
C     If a 'frame' has been specified, build the frame
C
      IF( LFRAME ) THEN
        LIMISSV = .TRUE.
        CALL MKFRAME(NLON,NLAT,SWORK,RMISSGV,NOFRAME)
        CALL MKFRAME(NLON,NLAT,SWORK(1+NUMPTS),RMISSGV,NOFRAME)
      ENDIF
C
      IRET = INTUVDH(SWORK,NUMPTS,KUGRIB,OUTLENU,'C',JP_U)
      IF( IRET.NE.0 ) THEN
        CALL INTLOG(JP_ERROR,
     X    'INTUVXH: Wind component into GRIB encoding fail',IRET)
        INTUVXH = JPROUTINE + 6
        GOTO 900
      ENDIF
C
      IRET = INTUVDH(SWORK(1+NUMPTS),NUMPTS,KVGRIB,OUTLENV,'C',JP_V)
      IF( IRET.NE.0 ) THEN
        CALL INTLOG(JP_ERROR,
     X    'INTUVXH: Wind component into GRIB encoding fail',IRET)
        INTUVXH = JPROUTINE + 6
        GOTO 900
      ENDIF
C
C     -----------------------------------------------------------------|
C*    Section 9.   Return
C     -----------------------------------------------------------------|
C
  900 CONTINUE
C
      RETURN
      END

C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      INTEGER FUNCTION IAGCNTL(PIFELD, KILEN, POFELD, KOLEN, KILN,
     X   OIWEGLOBE, OINPOLE, OISPOLE, KOLN, OOWEGLOBE, OONPOLE,
     X   OOSPOLE, KPR, KERR)
C
C---->
C**** *IAGCNTL*
C
C     PURPOSE
C     _______
C
C     The global controlling routine for interpolating between
C     regular Gaussian or latitude/longitude fields.
C
C     INTERFACE
C     _________
C
C     IERR = IAGCNTL(PIFELD, KILEN, POFELD, KOLEN, KILN, OIWEGLOBE,
C    X   OINPOLE, OISPOLE, KOLN, OOWEGLOBE, OONPOLE, OOSPOLE, KPR,
C    X   KERR)
C
C     Input parameters
C     ________________
C
C     PIFELD     - The input field provided by the calling routine.
C
C     KILEN      - The length of the input field.
C
C     KOLEN      - The length of the output field.
C
C     KILN       - The Northern line number of the input field within
C                  its Gaussian field.
C
C     OIWEGLOBE  - A flag indicating whether the input field is
C                  global West to East.
C
C     OINPOLE    - A flag indicating whether the North pole is
C                  included in the input field.
C
C     OISPOLE    - A flag indicating whether the South pole is
C                  include in the input field.
C
C     KOLN       - The Northern line number of the output field
C                  within its Gaussian field.
C
C     OOWEGLOBE  - A flag indicating whether the output field is
C                  global West to East.
C
C     OONPOLE    - A flag indicating whether the North pole is
C                  include in the output field.
C
C     OOSPOLE    - A flag indicating whether the South pole is
C                  include in the output field.
C
C     KPR        - The debug print switch.
C                  0  , No debugging output.
C                  1  , Produce debugging output.
C
C     KERR       - The error control flag.
C                  -ve, No error message. Return error code.
C                  0  , Hard failure with error message.
C                  +ve, Print error message. Return error code.
C
C     Output parameters
C     ________________
C
C     POFELD     - The output field returned to the calling routine.
C
C     Return value
C     ____________
C
C     The error indicator (INTEGER).
C
C     Error and Warning Return Values
C     _______________________________
C
C     21801 The input data representation was not valid when the
C           grid was generated. This should not happen as the data
C           representation has been previously validated.
C     21802 The output data representation was not valid when the
C           grid was generated. This should not happen as the data
C           representation has been previously validated.
C     21803 Attempt to produce global West-East field where the input
C           field was not global.
C     21804 Attempt to produce global North-South field where the
C           input field was not global.
C
C     Common block usage
C     __________________
C
C     grspace.h    - The include file contains all the array space
C                    for grid to grid interpolation.
C
C     RIGAUSS      - Real array of input field Gaussian latitudes is
C                    used.
C     ROGAUSS      - Real array of output field Gaussian latitudes is
C                    used.
C
C     MILATG       - The input field latitudes.
C     MILONG       - The input field longitudes.
C     MNSDIST      - The distances to neighbouring latitude lines of
C                    the input field from the associated line of
C                    latitude in the output field.
C     MNSIND       - The latitude line numbers (array offset) of the
C                    input field associated with each line of
C                    latitude in the output field.
C     MOLATG       - The output field latitudes.
C     MOLONG       - The output field longitudes.
C     MWEDIST      - This array holds the distances to neighbouring
C                    longitude points of the input field from the
C                    associated longitude points in the output field.
C     MWEIND       - This array holds the longitude points (array
C                    offset) from the input field associated with
C                    each longitude point in the output field.
C     RINPNT       - Array used to aid vectorisation in processing
C                    precipitation fields.
C     RMAX         - Array used to aid vectorisation in normalising
C                    interpolation weights and processing
C                    precipitation fields.
C     WFACT        - The array of interpolation weights for each
C                    point in the output field.
C
C     nifld.common - This file contains all the input field
C                    definition variables.
C
C     LCHANGE      - Process change flag is used and set.
C     LSMCHNG      - LSM change flag is used and set.
C     LSM          - LSM usage flag is used.
C     LSMPAR       - LSM parameter flag is used.
C     LPREC        - Precipitation flag is used.
C     LWIND        - Wind flag is used.
C     LSTAGGL      - Staggered grid flag
C
C     NIAREA       - Input field area definition (N/W/S/E) is used.
C     NIGAUSS      - Input field Gaussian truncation is used.
C     NIGRID       - Input field grid definition (WE/NS) is used.
C     NINS         - Number of grid points in NS direction for input
C                    field is used.
C     NIREPR       - Input field representation is used.
C     NIWE         - Number of grid points in WE direction for input
C                    field is used.
C
C     nofld.common - This file contains all the output field
C                    definition variables.
C
C     NOAREA       - Output field area definition (N/W/S/E) is used.
C     NOGAUSS      - Output field Gaussian truncation is used.
C     NOGRID       - Output field grid definition (WE/NS) is used.
C     NONS         - Number of grid points in NS direction for output
C                    field is used.
C     NOREPR       - Output field representation is used.
C     NOWE         - Number of grid points in WE direction for output
C                    field is used.
C
C     EXTERNALS
C     _________
C
C     ABORTX     - Standard routine to kill task.
C     IGDINS     - Calculate the distances between points in an
C                  output latitude array and its North and South
C                  neighbours in the input latitude array.
C     IGDIWE     - Calculate the distances between points in an
C                  output longitude array and its West and East
C                  neighbours in the input longitude array.
C     IGGMEM     - This routine acquires heap space.
C     IGGRID     - Generate the arrays of latitude and longitude
C                  points for a Gaussian truncation and area.
C     IGINT      - Calculate the basic unnormalised interpolation
C                  weights.
C     IGLGRID    - Generate the arrays of latitude and longitude
C                  points for a regular latitude/longitude grid.
C     IGLSIZE    - Evaluate the array sizes for a regular
C                  latitude/longitude grid and area.
C     IGLSMB     - Calculate the effects of the land-sea masks on
C                  the unnormalised interpolation weights.
C     IGLSMD     - Generate the land sea mask file information.
C     IGNORM     - Normalise the array of interpolation weights.
C     IGPLSM     - Force an interpolated land sea mask field back
C                  to a real 0-1 field.
C     IGPOLEG    - Calculates the values at the pole of a regular
C                  latitude/longitude field when the input is a
C                  Gaussian field.
C     IGPOLEW    - Calculates the values at the pole of a regular
C                  latitude/longitude wind field when the input is
C                  a Gaussian field.
C     IGPREC     - Perform additional interpolation for
C                  precipitation fields.
C     ZPREC      - Perform additional interpolation processes
C                  for precipitation
C     IGSIZE     - Evaluate the array sizes for a Gaussian
C                  truncation and area.
C     IGTOG      - Perform basic interpolation between regular input
C                  and output fields.
C     INTLOG       - Logs messages.
C
C     METHOD
C     ______
C
C     This is purely a controlling routine with all the work being
C     performed in the external routines.
C
C     REFERENCE
C     _________
C
C     None
C
C     COMMENTS
C     ________
C
C     None
C
C     AUTHOR
C     ______
C
C     K. Fielding      *ECMWF*      May 1994
C
C     MODIFICATIONS
C     _____________
C
C     J.Chambers        ECMWF       Oct 1998
C     Allow field type for rotated grids.
C
C     S.Curic           ECMWF       Oct 2005
C     Add zprec routine that Perform checking
C     of precipitation

C----<
C     -----------------------------------------------------------------|
C*    Section 0. Definition of variables.
C     -----------------------------------------------------------------|
C
      IMPLICIT NONE
C
#include "parim.h"
#include "nifld.common"
#include "nofld.common"
#include "grspace.h"
C
C     Parameters
C
      INTEGER JPROUTINE
      PARAMETER (JPROUTINE = 21800)
C
C     Function arguments
C
      LOGICAL OIWEGLOBE, OINPOLE, OISPOLE, OOWEGLOBE, OONPOLE, OOSPOLE
      INTEGER KILEN, KOLEN, KILN, KOLN, KPR, KERR
      REAL PIFELD(KILEN), POFELD(KOLEN)
C
C     Local variables
C
      LOGICAL LFAIL, LERROR, LDEBUG, LREGIN, LREGOUT
      LOGICAL GINSPOLE, GIGLOBE, GISTAND, GONSPOLE, GOGLOBE, GOSTAND
      LOGICAL GPREC,LSM_VALUES
      CHARACTER*120 YIFILE, YOFILE
      CHARACTER*12 YFLAG
      INTEGER IIOFF, IIREC, IOOFF, IOREC, IERR
C
C     Working copies of area and grid arrays that may be changed
C
      INTEGER IILGRID(2), IILLINE(2), IOLGRID(2), IOLLINE(2)
C
C     External functions
C
      INTEGER IGDINS, IGDIWE, IGGMEM, IGGRID, IGINT, IGLGRID,
     X   IGLSMB, IGLSMD, IGNORM, IGPLSM, IGPOLEG, IGPOLEW, IGPREC,
     X   IGTOG, ZPREC
C
C     -----------------------------------------------------------------|
C*    Section 1. Initialisation
C     -----------------------------------------------------------------|
C
  100 CONTINUE
C
      IAGCNTL = 0
      IERR = 0
C
C     Set all flag variables
C
      LDEBUG  = (KPR.GE.1)
      LFAIL   = (KERR.EQ.0)
      LERROR  = (KERR.GE.0)
      LREGIN  = (NIREPR.EQ.JPREGULAR).OR.(NIREPR.EQ.JPREGROT)
      LREGOUT = (NOREPR.EQ.JPREGULAR).OR.(NOREPR.EQ.JPREGROT)
C
      IF( LDEBUG ) THEN
        CALL INTLOG(JP_DEBUG,'IAGCNTL: Section 1.',JPQUIET)
        CALL INTLOG(JP_DEBUG,
     X    'IAGCNTL: Input field definition parameters.',JPQUIET)
        CALL INTLOG(JP_DEBUG,'IAGCNTL: Representation = ',NIREPR)
        IF( NIWE.NE.0 ) CALL INTLOG(JP_DEBUG,
     X    'IAGCNTL: Number W-E = ',NIWE)
        IF( NINS.NE.0 ) CALL INTLOG(JP_DEBUG,
     X    'IAGCNTL: Number N-S = ',NINS)
        IF( (NIREPR.EQ.JPGAUSSIAN).OR.(NIREPR.EQ.JPQUASI) )
     X    CALL INTLOG(JP_DEBUG,'IAGCNTL: Gaussian truncation= ',NIGAUSS)
        IF( LREGIN.AND.(NIGRID(1).NE.0) ) THEN
          CALL INTLOG(JP_DEBUG,'IAGCNTL: Grid WE = ',NIGRID(1))
          CALL INTLOG(JP_DEBUG,'IAGCNTL: Grid NS = ',NIGRID(2))
        ENDIF
        IF( NIAREA(1).NE.0 ) THEN
          CALL INTLOG(JP_DEBUG,'IAGCNTL: Area North = ',NIAREA(1))
          CALL INTLOG(JP_DEBUG,'IAGCNTL: Area West  = ',NIAREA(2))
          CALL INTLOG(JP_DEBUG,'IAGCNTL: Area South = ',NIAREA(3))
          CALL INTLOG(JP_DEBUG,'IAGCNTL: Area East  = ',NIAREA(4))
        ENDIF
C
        CALL INTLOG(JP_DEBUG,
     X    'IAGCNTL: Output field definition parameters.',JPQUIET)
        CALL INTLOG(JP_DEBUG,'IAGCNTL: Representation = ',NOREPR)
        IF( NOWE.NE.0 ) CALL INTLOG(JP_DEBUG,
     X    'IAGCNTL: Number W-E = ',NOWE)
        IF( NONS.NE.0 ) CALL INTLOG(JP_DEBUG,
     X    'IAGCNTL: Number N-S = ',NONS)
        IF( (NOREPR.EQ.JPGAUSSIAN).OR.(NOREPR.EQ.JPQUASI) )
     X    CALL INTLOG(JP_DEBUG,'IAGCNTL: Gaussian truncation= ',NOGAUSS)
        IF( LREGOUT.AND.(NOGRID(1).NE.0) ) THEN
          CALL INTLOG(JP_DEBUG,'IAGCNTL: Grid WE = ',NOGRID(1))
          CALL INTLOG(JP_DEBUG,'IAGCNTL: Grid NS = ',NOGRID(2))
        ENDIF
        IF( NOAREA(1).NE.0 ) THEN
          CALL INTLOG(JP_DEBUG,'IAGCNTL: Area North = ',NOAREA(1))
          CALL INTLOG(JP_DEBUG,'IAGCNTL: Area West  = ',NOAREA(2))
          CALL INTLOG(JP_DEBUG,'IAGCNTL: Area South = ',NOAREA(3))
          CALL INTLOG(JP_DEBUG,'IAGCNTL: Area East  = ',NOAREA(4))
        ENDIF
C
        CALL INTLOG(JP_DEBUG,'IAGCNTL: Control flag status:',JPQUIET)
C
        IF( LSMCHNG ) THEN
          CALL INTLOG(JP_DEBUG,'IAGCNTL: LSM change TRUE',JPQUIET)
        ELSE
          CALL INTLOG(JP_DEBUG,'IAGCNTL: LSM change FALSE',JPQUIET)
        ENDIF
C
        IF( LSM ) THEN
          CALL INTLOG(JP_DEBUG,'IAGCNTL: LSM flag TRUE',JPQUIET)
        ELSE
          CALL INTLOG(JP_DEBUG,'IAGCNTL: LSM flag FALSE',JPQUIET)
        ENDIF
C
        IF( LWIND ) THEN
          CALL INTLOG(JP_DEBUG,'IAGCNTL: Wind flag TRUE',JPQUIET)
        ELSE
          CALL INTLOG(JP_DEBUG,'IAGCNTL: Wind flag FALSE',JPQUIET)
        ENDIF
C
        IF( LPREC ) THEN
          CALL INTLOG(JP_DEBUG,'IAGCNTL: Precipitn flag TRUE',JPQUIET)
        ELSE
          CALL INTLOG(JP_DEBUG,'IAGCNTL: Precipitn flag FALSE',JPQUIET)
        ENDIF
C
        IF( LSMPAR ) THEN
          CALL INTLOG(JP_DEBUG,'IAGCNTL: LSM param flag TRUE',JPQUIET)
        ELSE
          CALL INTLOG(JP_DEBUG,'IAGCNTL: LSM param flag FALSE',JPQUIET)
        ENDIF
        IF( LSTAGGL ) THEN
          CALL INTLOG(JP_DEBUG,'IAGCNTL: Staggered flag TRUE',JPQUIET)
        ELSE
          CALL INTLOG(JP_DEBUG,'IAGCNTL: Staggered flag FALSE',JPQUIET)
        ENDIF
      ENDIF
C
C     The change of definition option spans sections 2 to 3
C
      IF( LCHANGE ) THEN
C
C     -----------------------------------------------------------------|
C*    Section 2. Calculate space requirement.
C     -----------------------------------------------------------------|
C
  200   CONTINUE
C
        IF( LDEBUG ) CALL INTLOG(JP_DEBUG,'IAGCNTL: Section 2.',JPQUIET)
C
C       Get the required memory
C
        IAGCNTL = IGGMEM(KPR, KERR)
        IF( IAGCNTL.GT.0 ) GOTO 900
C
C       Input grid definition
C
        IF( NIREPR.EQ.JPGAUSSIAN ) THEN
C
          IAGCNTL = IGGRID(NIGAUSS, NIAREA, KILN, RIGAUSS,
     X                     MILONG,NIWE,MILATG,NINS,OIWEGLOBE,KPR,KERR)
          IF( IAGCNTL.GT.0 ) GOTO 900
C
        ELSEIF( LREGIN ) THEN
C
          IAGCNTL = IGLGRID(NIGRID, NIAREA, MILONG, NIWE, MILATG,
     X                      NINS,OIWEGLOBE,KPR,KERR)
          IF( IAGCNTL.GT.0 ) GOTO 900
C
        ELSE
C
          IAGCNTL = JPROUTINE + 1
          IF( LERROR ) THEN
            CALL INTLOG(JP_ERROR,
     X        'IAGCNTL: Illegal input representation = ',NIREPR)
            IF( LFAIL ) CALL INTLOG(JP_FATAL,
     X        'IAGCNTL: Interpolation failing.',JPQUIET)
          ENDIF
          GOTO 900
C
        ENDIF
C
C       Is the input field global
C
        GINSPOLE = OINPOLE.AND.OISPOLE
        GIGLOBE  = OIWEGLOBE.AND.GINSPOLE
C
C       Is the output field global North South
C
        GONSPOLE = OONPOLE.AND.OOSPOLE
        GOGLOBE  = OOWEGLOBE.AND.GONSPOLE

        IF(GOGLOBE.AND.NOAREA(2).EQ.0) THEN
            LGLOBL = .TRUE.
        ELSE
            LGLOBL = .FALSE.
        ENDIF
C
C       Output grid definition
C
        IF( NOREPR.EQ.JPGAUSSIAN ) THEN
C
          IAGCNTL = IGGRID(NOGAUSS, NOAREA, KOLN, ROGAUSS,
     X                     MOLONG,NOWE,MOLATG,NONS,OOWEGLOBE,KPR,KERR)
          IF( IAGCNTL.GT.0 ) GOTO 900
C
        ELSEIF( LREGOUT ) THEN
C
          IAGCNTL = IGLGRID(NOGRID, NOAREA, MOLONG, NOWE, MOLATG,
     X                      NONS,OOWEGLOBE,KPR,KERR)
          IF( IAGCNTL.GT.0 ) GOTO 900
C
        ELSE
C
          IAGCNTL = JPROUTINE + 2
          IF( LERROR ) THEN
            CALL INTLOG(JP_ERROR,
     X        'IAGCNTL: Illegal output representation = ',NOREPR)
            IF( LFAIL ) CALL INTLOG(JP_FATAL,
     X        'IAGCNTL: Interpolation failing.',JPQUIET)
          ENDIF
          GOTO 900
C
        ENDIF
C
C     -----------------------------------------------------------------|
C*    Section 3. Create output to input grid mapping and distance arrays
C     -----------------------------------------------------------------|
C
  300   CONTINUE
C
        IF( LDEBUG )
     X    CALL INTLOG(JP_DEBUG,'IAGCNTL: Section 3.',JPQUIET)
C
C       First check that the input and output fields are compatible.
C
        IF( .NOT.GIGLOBE ) THEN
C
          IF( .NOT.OIWEGLOBE ) THEN
C
C           Cannot produce global output field if input not global
C
            IF( OOWEGLOBE ) THEN
              IAGCNTL = JPROUTINE + 3
              IF( LERROR ) THEN
                CALL INTLOG(JP_ERROR,
     X           'IAGCNTL: Cannot produce global output from',JPQUIET)
                CALL INTLOG(JP_ERROR,
     X            'IAGCNTL: non-global input.  The W-E input',JPQUIET)
                CALL INTLOG(JP_ERROR,
     X            'IAGCNTL: direction was not global.',JPQUIET)
                IF( LFAIL ) CALL INTLOG(JP_FATAL,
     X            'IAGCNTL: Interpolation failing.',JPQUIET)
              ENDIF
              GOTO 900
            ENDIF
C
          ENDIF
C
c Sinisa added NOT.LSTAGGL just for the sake of staggered grids
C
          IF( .NOT.GINSPOLE.AND.(.NOT.LSTAGGL) ) THEN
C
C           Cannot produce global output field if input not global
C
            IF( GONSPOLE ) THEN
              IAGCNTL = JPROUTINE + 4
              IF( LERROR ) THEN
                CALL INTLOG(JP_ERROR,
     X           'IAGCNTL: Cannot produce global output from',JPQUIET)
                CALL INTLOG(JP_ERROR,
     X            'IAGCNTL: non-global input.  The N-S input',JPQUIET)
                CALL INTLOG(JP_ERROR,
     X            'IAGCNTL: direction was not global.',JPQUIET)
                IF( LFAIL ) CALL INTLOG(JP_FATAL,
     X            'IAGCNTL: Interpolation failing.',JPQUIET)
              ENDIF
              GOTO 900
            ENDIF
C
          ENDIF
C
        ENDIF
C
        IAGCNTL = IGDINS(MILATG, NINS, MOLATG, NONS, OINPOLE, OISPOLE,
     X                   MNSIND, MNSDIST, KPR, KERR)
        IF( IAGCNTL.GT.0 ) GOTO 900
C
        IAGCNTL = IGDIWE(MILONG, NIWE, MOLONG, NOWE, OIWEGLOBE,
     X                   MWEIND, MWEDIST, KPR, KERR)
        IF( IAGCNTL.GT.0 ) GOTO 900
C
C       The end of primary initialisation
C
      ENDIF
C
C     -----------------------------------------------------------------|
C*    Section 4. Create normalised weight arrays
C     -----------------------------------------------------------------|
C
  400 CONTINUE
C
      IF( LDEBUG ) CALL INTLOG(JP_DEBUG,'IAGCNTL: Section 4.',JPQUIET)
C
C     The following code is affected by the Land Sea mask flag
C
      IF( LCHANGE.OR.LSMCHNG ) THEN
C
        IAGCNTL = IGINT(MWEDIST, NOWE, MNSDIST, NONS, WFACT, KPR, KERR)
        IF( IAGCNTL.GT.0 ) GOTO 900
C
        IF( LSM ) THEN
C
          IAGCNTL = IGLSMD(NIDATE,NIREPR,NIGRID,NIGAUSS,NIAREA,KILN,
     X                    YIFILE,GISTAND,IILGRID,IILLINE,IIREC,KPR,KERR)
          IF( IAGCNTL.GT.0 ) GOTO 900
C
          IAGCNTL = IGLSMD(NODATE,NOREPR,NOGRID,NOGAUSS,NOAREA,KOLN,
     X                    YOFILE,GOSTAND,IOLGRID,IOLLINE,IOREC,KPR,KERR)
          IF( IAGCNTL.GT.0 ) GOTO 900
C
          IAGCNTL = IGLSMB(GISTAND, YIFILE, IIREC, IILGRID, IILLINE,
     X                    GOSTAND,YOFILE,IOREC,IOLGRID,IOLLINE,KPR,KERR)
          IF( IAGCNTL.GT.0 ) GOTO 900
C
        ENDIF
C
C     Normalise the weights
C
        IAGCNTL = IGNORM(WFACT, RMAX, NOWE, NONS, KPR, KERR)
        IF( IAGCNTL.GT.0 ) GOTO 900
C
C     This marks the end of a change to the specification
C     Clear the Change flags LCHANGE and LSMCHNG
C
        LCHANGE = .FALSE.
        LSMCHNG = .FALSE.
C
      ENDIF
C
C     -----------------------------------------------------------------|
C*    Section 5. Basic interpolation from input to output field
C     -----------------------------------------------------------------|
C
  500 CONTINUE
C
      IF( LDEBUG ) CALL INTLOG(JP_DEBUG,'IAGCNTL: Section 5.',JPQUIET)
C
      IAGCNTL = IGTOG(PIFELD, NIWE, NINS, NOWE, NONS, MWEIND, MNSIND,
     X                WFACT, POFELD, KPR, KERR)
      IF( IAGCNTL.GT.0 ) GOTO 900
C
C     -----------------------------------------------------------------|
C*    Section 6. Additional interpolations from input to output field
C     -----------------------------------------------------------------|
C
  600 CONTINUE
C
      IF( LDEBUG ) CALL INTLOG(JP_DEBUG,'IAGCNTL: Section 6.',JPQUIET)
C
C     Precipitation field
C
C     Force processing without neighbour check
        GPREC = .FALSE.
        CALL GETENV('PRECIPITATION_NEIGHBOUR_CHECK', YFLAG)
        IF( YFLAG(1:1).EQ.'0' ) GPREC = .TRUE.

      IF( LPREC ) THEN
C
        IF( GPREC ) THEN
          IAGCNTL = ZPREC(POFELD, NOWE, NONS, KPR, KERR)
        ELSE
          IAGCNTL = IGPREC(PIFELD, NIWE, NINS, POFELD, NOWE, NONS,
     X                   MWEIND, MNSIND, WFACT, RMAX, RINPNT, KPR, KERR)
        ENDIF
C
        IF( IAGCNTL.GT.0 ) GOTO 900
      ENDIF
C
C     Special code for poles if Gaussian input and regular output
C
C     North pole
C
C    Sinisa add pole point for staggerd lat-lon grids
      IF( (NIREPR.EQ.JPREGULAR.AND.LSTAGGL).AND.
     X    LREGOUT               .AND.
     X    OINPOLE               .AND.
     X    OONPOLE ) THEN
C
        IIOFF = 1
        IOOFF = 1
C
        IF( LWIND ) THEN
          IAGCNTL = IGPOLEW(PIFELD(IIOFF), NIWE, POFELD(IOOFF),
     X                      NOWE, MWEIND, MWEDIST, KPR, KERR)
        ELSE
           IAGCNTL = IGPOLEG(PIFELD(IIOFF), NIWE, POFELD(IOOFF),
     X                       NOWE, KPR, KERR)
        ENDIF
      ENDIF

      IF( (NIREPR.EQ.JPGAUSSIAN).AND.
     X    LREGOUT               .AND.
     X    OINPOLE               .AND.
     X    OONPOLE ) THEN
C
        IIOFF = 1
        IOOFF = 1
C
        IF( LWIND ) THEN
          IAGCNTL = IGPOLEW(PIFELD(IIOFF), NIWE, POFELD(IOOFF),
     X                      NOWE, MWEIND, MWEDIST, KPR, KERR)
        ELSE
           IAGCNTL = IGPOLEG(PIFELD(IIOFF), NIWE, POFELD(IOOFF),
     X                       NOWE, KPR, KERR)
        ENDIF
        IF( IAGCNTL.GT.0 ) GOTO 900
C
      ENDIF
C
C     South pole
C
C    Sinisa add south pole point for staggerd lat-lon grids
      IF( (NIREPR.EQ.JPREGULAR.AND.LSTAGGL).AND.
     X    LREGOUT               .AND.
     X    OISPOLE               .AND.
     X    OOSPOLE ) THEN
C
        IIOFF = (NINS - 1) * NIWE + 1
        IOOFF = (NONS - 1) * NOWE + 1
C
        IF( LWIND ) THEN
          IAGCNTL = IGPOLEW(PIFELD(IIOFF), NIWE, POFELD(IOOFF),
     X                      NOWE, MWEIND, MWEDIST, KPR, KERR)
        ELSE
          IAGCNTL = IGPOLEG(PIFELD(IIOFF), NIWE, POFELD(IOOFF),
     X                      NOWE, KPR, KERR)
C
        ENDIF
      ENDIF
      IF( (NIREPR.EQ.JPGAUSSIAN).AND.
     X    LREGOUT               .AND.
     X    OISPOLE               .AND.
     X    OOSPOLE ) THEN
C
        IIOFF = (NINS - 1) * NIWE + 1
        IOOFF = (NONS - 1) * NOWE + 1
C
        IF( LWIND ) THEN
          IAGCNTL = IGPOLEW(PIFELD(IIOFF), NIWE, POFELD(IOOFF),
     X                      NOWE, MWEIND, MWEDIST, KPR, KERR)
        ELSE
          IAGCNTL = IGPOLEG(PIFELD(IIOFF), NIWE, POFELD(IOOFF),
     X                      NOWE, KPR, KERR)
        ENDIF
        IF( IAGCNTL.GT.0 ) GOTO 900
C
      ENDIF
C
C     LSM field - must be 0 or 1
C
C     Force processing real LSM
        LSM_VALUES = .FALSE.
        CALL GETENV('LSM_VALUES', YFLAG)
        IF( YFLAG(1:1).EQ.'1' ) LSM_VALUES = .TRUE.

      IF( .NOT.LSM_VALUES.AND.LSMPAR ) THEN
        IAGCNTL = IGPLSM(POFELD, NOWE * NONS, KPR, KERR)
        IF( IAGCNTL.GT.0 ) GOTO 900
      ENDIF
C
C     -----------------------------------------------------------------|
C*    Section 9. Return to calling routine. Format statements
C     -----------------------------------------------------------------|
C
  900 CONTINUE
C
      IF( LDEBUG ) CALL INTLOG(JP_DEBUG,'IAGCNTL: Section 9.',JPQUIET)
C
      RETURN
      END

C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      INTEGER FUNCTION IRGRID (KAREA, KLLEN, KLN, PGAUSS, KSTART,
     1   KLATG, KNNS, OWEGLOBE, KPR, KERR)
C
C---->
C**** *IRGRID*
C
C     PURPOSE
C     _______
C
C     Generate the arrays of latitude points and the starting points
C     of the lines of latitude for a quasi regular Gaussian grid.
C
C     INTERFACE
C     _________
C
C     IERR = IRGRID (KAREA, KLLEN, KLN, PGAUSS, KSTART,
C    1   KLATG, KNNS, OWEGLOBE, KPR, KERR)
C
C     Input parameters
C     ________________
C
C     KAREA      - The area definition (N, W, S, E) provided by the
C                  calling routine. (Currently unused).
C
C     KLLEN   - This quasi regular Gaussian line length definition
C                  is for the full grid and not just the North and
C                  South limits selected.
C
C     KLN        - The Northern Gaussian latitude number for this area.
C
C     PGAUSS     - The full list of Gaussian latitudes for this
C                  truncation.
C
C     KNNS       - The number of points in the North-South direction
C                  in this field.
C
C     OWEGLOBE   - This variable will be true if the array of
C                  longitudes spans the globe and it is an input grid.
C                  (Currently unused)
C
C     KPR        - The debug print switch.
C                  0  , No debugging output.
C                  1  , Produce debugging output.
C
C     KERR       - The error control flag.
C                  -ve, No error message. Return error code.
C                  0  , Hard failure with error message.
C                  +ve, Print error message. Return error code.
C
C     Output parameters
C     ________________
C
C     KSTART     - The array offset for each line of latitude within
C                  the quasi regular field.
C
C     KLATG      - The array of latitudes for this Gaussian
C                  truncation and area.
C
C     Return value
C     ____________
C
C     The error indicator (INTEGER).
C
C     Error and Warning Return Values
C     _______________________________
C
C     None
C
C     Common block usage
C     __________________
C
C     None
C
C     EXTERNALS
C     _________
C
C     INTLOG(R)    - Logs messages.
C
C     METHOD
C     ______
C
C     The array KLATG is generated using the information provided by
C     the other parameters. The array KSTART is generated using the
C     array KLLEN. Note that Gaussian latitudes will be stored as
C     NINT (PGAUSS * 1.0E4).
C
C     REFERENCE
C     _________
C
C     None
C
C     COMMENTS
C     ________
C
C     Program contains sections 0 to 3 and 9
C
C     AUTHOR
C     ______
C
C     K. Fielding      *ECMWF*      Nov 1993
C
C     MODIFICATIONS
C     _____________
C
C     None
C
C----<
C     _______________________________________________________
C
C*    Section 0. Definition of variables.
C     _______________________________________________________
C
      IMPLICIT NONE
C
#include "parim.h"
#include "nifld.common"
C
C     Parameters
C
      INTEGER JPROUTINE
      PARAMETER (JPROUTINE = 23700)
C
C     Dummy arguments
C
      LOGICAL OWEGLOBE
      INTEGER KNNS, KLN, KPR, KERR
      INTEGER KAREA (4), KLLEN (KNNS)
      INTEGER KLATG (KNNS), KSTART (KNNS)
      REAL PGAUSS (*)
C
C     Local variables
C
      LOGICAL LPRINT
      INTEGER JLAT
      REAL PNLAT, ZNLAT, MFACTOR
C
C     Function externals
C
C     _______________________________________________________
C
C*    Section 1. Initialisation
C     _______________________________________________________
C
  100 CONTINUE
C
      LPRINT = KPR.NE.0
C
      IF( LPRINT ) CALL INTLOG(JP_DEBUG,'IRGRID: Section 1.',JPQUIET)
C
      IRGRID = 0
C
      IF( LPRINT ) THEN
        CALL INTLOG(JP_DEBUG,'IRGRID: Input parameters.',JPQUIET)
        CALL INTLOG(JP_DEBUG,'IRGRID: N Gaussian line = ',KLN)
        CALL INTLOG(JP_DEBUG,'IRGRID: No. of lat lines = ',KNNS)
        CALL INTLOG(JP_DEBUG,'IRGRID: Area North = ', KAREA(1))
        CALL INTLOG(JP_DEBUG,'IRGRID: Area West  = ', KAREA(2))
        CALL INTLOG(JP_DEBUG,'IRGRID: Area South = ', KAREA(3))
        CALL INTLOG(JP_DEBUG,'IRGRID: Area East  = ', KAREA(4))
        IF( OWEGLOBE ) THEN
          CALL INTLOG(JP_DEBUG,
     X      'IRGRID: Input W-E fld is global.',JPQUIET)
        ELSE
          CALL INTLOG(JP_DEBUG,
     X      'IRGRID: Input W-E fld is NOT global.',JPQUIET)
        ENDIF
      ENDIF
C
C     _______________________________________________________
C
C*    Section 2. Generate start position of lines of latitude
C     _______________________________________________________
C
  200 CONTINUE
C
      IF( LPRINT ) CALL INTLOG(JP_DEBUG,'IRGRID: Section 2.',JPQUIET)
C
      KSTART(1) = 1
      DO JLAT = KLN, KLN + KNNS - 2
        KSTART(JLAT+1) = KSTART(JLAT) + KLLEN(JLAT)
      ENDDO
C
C     _______________________________________________________
C
C*    Section 3. Generate points along a line of meridian
C     _______________________________________________________
C
  300 CONTINUE
C
      IF( LPRINT ) CALL INTLOG(JP_DEBUG,'IRGRID: Section 3.',JPQUIET)
C
      DO JLAT = KLN, KLN + KNNS - 1
C
C       If it is a stretched field, calculate the true latitude and
C       the map factor.
C
        PNLAT = PGAUSS(JLAT)
        IF( RISTRET.NE.0 ) THEN
          CALL STRLAT(PNLAT, RISTRET, 0, ZNLAT, MFACTOR)
        ELSE
          ZNLAT = PNLAT
        ENDIF
        KLATG(JLAT-KLN+1) = NINT(ZNLAT * PPMULT)
      ENDDO
      KAREA(1)   =  KLATG(1)
      KAREA(KLN) =  KLATG(KLN)
      IF( LPRINT ) THEN
        CALL INTLOG(JP_DEBUG,'IRGRID: Modified North = ', KAREA(1))
        CALL INTLOG(JP_DEBUG,'IRGRID: Modified South = ', KAREA(3))
      ENDIF
C
C     _______________________________________________________
C
C*    Section 9. Return to calling routine. Format statements
C     _______________________________________________________
C
  900 CONTINUE
C
      IF( LPRINT ) CALL INTLOG(JP_DEBUG,'IRGRID: Section 9.',JPQUIET)
C
      RETURN
      END

C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      INTEGER FUNCTION INTUVPH( KFIELD1, KFIELD2, INLEN,
     X                          KUGRIBO, KVGRIBO,
     X                          OUTLENU, OUTLENV)
C
C---->
C**** INTUVPH
C
C     Purpose
C     -------
C
C     Interpolate GRIB format input spectral vorticity and divergence,
C     or spectral U and V, fields to GRIB format U and V fields.
C
C
C     Interface
C     ---------
C
C     IRET = INTUVPH(KFIELD1,KFIELD2,INLEN,
C                    KUGRIBO,KVGRIBO,OUTLENU,OUTLENV)
C
C     Input
C     -----
C
C     KFIELD1 - Input vorticity or U field  (spectral, GRIB format).
C     KFIELD2 - Input divergence or V field (spectral, GRIB format).
C     INLEN  - Input field length (words).
C
C
C     Output
C     ------
C
C     KUGRIBO - Output U field (GRIB format).
C     KVGRIBO - Output V field (GRIB format).
C     OUTLENU - Output U field length (words).
C     OUTLENV - Output V field length (words).
C
C
C     Method
C     ------
C
C     Convert spectral vorticity/divergence to spectral U/V and then
C     interpolate U and V to output fields.
C
C     Note that a common block is used in intf.h to hold the U/V
C     fields before interpolation.
C
C     Externals
C     ---------
C
C     IBASINI - Ensure basic interpolation setup is done.
C     INTUVDH - Encodes/decodes data into/from GRIB code.
C     INTUVXH - Interpolate U or V component spectral field to grid point.
C     JVOD2UV - Converts spectral vorticity/divergence to spectral U/V.
C     JMEMHAN - Allocate scratch memory.
C     GRIBEX  - GRIB decoding/encoding.
C     ISCRSZ  - Calculate number of values in generated field.
C     FIXAREA - Fixup area definition to correspond to grid definitions
C     INTLOG  - Log error message.
C     RESET_C - Reset interpolation handling options using GRIB product.
C     INSANE  - Ensure no outrageous values given for interpolation.
C     GRSMKP  - P factor calculation switch for routine GRIBEX.
C
C
C     Author
C     ------
C
C     J.D.Chambers     ECMWF     February 2001
C
C
C----<
C     -----------------------------------------------------------------|
C
      IMPLICIT NONE
C
C     Function arguments
C
      INTEGER KFIELD1(*), KFIELD2(*), INLEN
      INTEGER KUGRIBO(*), KVGRIBO(*), OUTLENU, OUTLENV
C
#include "parim.h"
#include "nifld.common"
#include "nofld.common"
#include "grfixed.h"
#include "intf.h"
C
C     Parameters
C
      INTEGER JPROUTINE, JPALLOC, JPDEALL, JPSCR3, JPSCR4,JPSCR5
      PARAMETER (JPROUTINE = 40160 )
      PARAMETER (JPALLOC = 1) 
      PARAMETER (JPDEALL = 0) 
      PARAMETER (JPSCR3 = 3) 
      PARAMETER (JPSCR4 = 4) 
      PARAMETER (JPSCR5 = 5) 
C
C     Local variables
C
      CHARACTER*1 HFUNC
      REAL EW, NS
      LOGICAL LOLDWIND, LSPECUV
      INTEGER IERR,KPR,ISZVD,ISZUV,IWORD,ISIZE,ILENF,ISAME,IPARAM
      INTEGER NEXT, LOOP, MTRUNC, NTRUNC, NTROLD, NTROLD2, NPARAM
      INTEGER MIRESO, MORESO, NOLD, NLEN
C
      LOGICAL LFIRST, LNEWUV
      CHARACTER*3 EXTRA
      DATA LFIRST/.TRUE./, LNEWUV/.TRUE./, EXTRA/'NO '/
      SAVE LFIRST, LNEWUV
C
      DATA NTROLD/-1/, NTROLD2/-1/
      SAVE NTROLD, NTROLD2
      INTEGER IPVORT, IPDIV, IP_U, IP_V, IDIVOFF
#ifndef _CRAYFTN
#ifdef POINTER_64
      INTEGER*8 IZNFLDO
#endif
#endif
      REAL ZNFLDO
      POINTER ( IZNFLDO, ZNFLDO )
      DIMENSION ZNFLDO( 1 )
#ifndef _CRAYFTN
#ifdef POINTER_64
      INTEGER*8 IUV, IVD
#endif
#endif
      REAL UV, VD
      POINTER ( IUV, UV )
      POINTER ( IVD, VD )
      DIMENSION UV( 1 ), VD( 1 )
C
C     Externals
C
      INTEGER RESET_C,ISCRSZ,FIXAREA,AURESOL
      INTEGER IBASINI, INSANE, INTUVDH, INTUVXH
C
C     -----------------------------------------------------------------|
C*    Section 1.   Initialise
C     -----------------------------------------------------------------|
C
  100 CONTINUE
C
      INTUVPH = 0
      IERR    = 0
      KPR     = 0
C
      IF( LFIRST ) THEN
        CALL GETENV('IGNORE_UV_EXTRA_MODE', EXTRA)
        IF((EXTRA(1:1).EQ.'Y').OR.(EXTRA(1:1).EQ.'y')) LNEWUV = .FALSE.
        IF( LNEWUV ) THEN
          CALL INTLOG(JP_DEBUG,
     X      'INTUVPH: IGNORE_UV_EXTRA_MODE not turned on',JPQUIET)
        ELSE
          CALL INTLOG(JP_DEBUG,
     X      'INTUVPH: IGNORE_UV_EXTRA_MODE turned on',JPQUIET)
        ENDIF
        LFIRST = .FALSE.
      ENDIF
C
      MIRESO = NIRESO
      MORESO = NORESO
C
      LOLDWIND = LWINDSET
C
C     Ensure that basic initialisation has been done
C
      IERR = IBASINI(0)
      IF( IERR.NE.0 ) THEN
        CALL INTLOG(JP_ERROR,'INTUVPH: basic initialise failed',JPQUIET)
        INTUVPH = IERR
        GOTO 900
      ENDIF
C
C     -----------------------------------------------------------------|
C*    Section 2.   Unpack the input fields.
C     -----------------------------------------------------------------|
C
  200 CONTINUE
C
C     Need to establish input truncation, so unpack GRIB sections 1
C     and 2.
C
      IPARAM = 0
      ISZVD = 1
      IERR = INTUVDH(VD(IPVORT),ISZVD,KFIELD1,INLEN,'I',IPARAM)
      IF( IERR.NE.0 ) THEN
        CALL INTLOG(JP_ERROR,'INTUVPH: GRIB header decode failed',IERR)
        INTUVPH = IERR
        GOTO 900
      ENDIF
C
C     Check that the input is an ECMWF spectral field
C
      IF( (ISEC1(1).NE.128).OR.(ISEC2(1).NE.50) ) THEN
        CALL INTLOG(JP_ERROR,
     X    'INTUVPH: Input is not ECMWF spectral field.',JPQUIET)
        INTUVPH = JPROUTINE + 2
        GOTO 900
      ENDIF
C
C     Get scratch memory for input unpacked fields.
C     Unpacked field memory areas are adjacent.
C
      NIRESO = ISEC2(2)
      ISZVD  = (NIRESO+1)*(NIRESO+2)
      IPVORT = 1
      IPDIV  = 1 + ISZVD
      CALL JMEMHAN( JPSCR4, IVD, ISZVD*2, JPALLOC, IERR)
      IF( IERR.NE.0 ) THEN
        CALL INTLOG(JP_ERROR,
     X    'INTUVPH: Scratch memory type 4 allocation failed.',JPQUIET)
        INTUVPH = IERR
        GOTO 900
      ENDIF
C
C     Decode input fields..
C
      IERR = INTUVDH(VD(IPVORT),ISZVD,KFIELD1,INLEN,'D',IPARAM)
      IF( IERR.NE.0 ) THEN
        CALL INTLOG(JP_ERROR,'INTUVPH: Vorticity decoding failed',IERR)
        INTUVPH = IERR
        GOTO 900
      ENDIF
C
      IERR = INTUVDH(VD(IPDIV),ISZVD,KFIELD2,INLEN,'D',IPARAM)
      IF( IERR.NE.0 ) THEN
        CALL INTLOG(JP_ERROR,'INTUVPH: Divergence decoding failed',IERR)
        INTUVPH = IERR
        GOTO 900
      ENDIF
C
C     Setup interpolation options from input GRIB characteristics.
C
      IERR = RESET_C( ISEC1, ISEC2, ZSEC2, ISEC4)
      IF( IERR.NE.0 ) THEN
        CALL INTLOG(JP_ERROR,
     X    'INTUVPH: Setup interp. options from GRIB failed.',JPQUIET)
        INTUVPH = IERR
        GOTO 900
      ENDIF
C
C     Check that no outrageous values given for interpolation
C
      ISAME = INSANE()
      IF( (ISAME.GT.0).AND.(ISAME.NE.27261) ) THEN
        CALL INTLOG(JP_ERROR,
     X    'INTUVPH: Interpolation cannot use given values.',JPQUIET)
        INTUVPH = ISAME
        GOTO 900
      ENDIF
C
C     -----------------------------------------------------------------|
C*    Section 3.   Convert spectral vorticity/divergence
C                  to spectral U/V
C     -----------------------------------------------------------------|
C
  300 CONTINUE
C
C     Spectral U and V for Tn are to be generated from vorticity
C     and divergence spectral T(n-1)
C
C     Get scratch memory for U and V spectral fields.
C     The memory areas are adjacent.
C
      IF( ISEC1(6).EQ.155 ) THEN
C
C       Truncate vorticity and divergence to correspond to U/V
C
C
        IF( LARESOL.AND.LNEWUV ) THEN
          IF( (NOGRID(1).NE.0).AND.(NOGRID(2).NE.0) ) THEN
            EW = FLOAT(NOGRID(1))/PPMULT
            NS = FLOAT(NOGRID(2))/PPMULT
            NTRUNC = AURESOL(NS,EW) - 1
          ELSE IF( NOGAUSS.NE.0 ) THEN
            EW = 90.0/FLOAT(NOGAUSS)
            NS = EW
            NTRUNC = AURESOL(NS,EW) - 1
          ELSE IF( LNORESO ) THEN
            NTRUNC = NORESO - 1
          ELSE
            NTRUNC = NIRESO - 1
          ENDIF
          IF( NTRUNC.GT.(NIRESO-1) ) NTRUNC = NIRESO - 1
C
        ELSE IF( LNORESO ) THEN
          NTRUNC = NORESO - 1
        ELSE
          NTRUNC = NIRESO - 1
        ENDIF
C
        IF( LNEWUV ) THEN
          MTRUNC = NTRUNC + 1
        ELSE
          NTRUNC = NTRUNC + 1
          MTRUNC = NTRUNC
        ENDIF

C
C       Check whether the output resolution is greater than the input
C
        IF( NTRUNC.GT.NIRESO ) THEN
C
C         Issue warning if the output resolution was user-supplied
C
          IF( .NOT.LARESOL ) THEN
C
C           Revert to the input truncation
C
            IF( NIRESO.NE.NTROLD2 ) THEN
              CALL INTLOG(JP_WARN,
     X          'INTUVPH: spectral -> grid point interpolation',JPQUIET)
              CALL INTLOG(JP_WARN,
     X          'INTUVPH: User supplied resolution = ',NTRUNC)
              CALL INTLOG(JP_WARN,
     X          'INTUVPH: Input field resolution   = ',NIRESO)
              CALL INTLOG(JP_WARN,
     X          'INTUVPH: User supplied resolution ignored',JPQUIET)
              CALL INTLOG(JP_WARN,
     X          'INTUVPH: Input field resolution has been used',JPQUIET)
              NTROLD2 = NIRESO
            ENDIF
            NTRUNC = NIRESO
C
          ELSE
C
C           Revert to the input truncation
C
            NTRUNC = NIRESO
            IF( NTRUNC.NE.NTROLD2 ) THEN
              NTROLD2 = NTRUNC
              CALL INTLOG(JP_WARN,
     X          'INTUVPH: Auto-resolution selection too high',JPQUIET)
              CALL INTLOG(JP_WARN,
     X          'INTUVPH: Resolution set to input resolution: ',NTRUNC)
            ENDIF
          ENDIF
        ENDIF
C
C
        CALL INTLOG(JP_DEBUG,'INTUVPH: vo/div truncation = ', NTRUNC)
        CALL INTLOG(JP_DEBUG,'INTUVPH: U/V truncation    = ', MTRUNC)
C
        ISIZE =  (NTRUNC+1)*(NTRUNC+2)
        CALL JMEMHAN( JPSCR5, IZNFLDO, ISIZE*2, JPALLOC, IERR)
        IF( IERR.NE.0 ) THEN
          CALL INTLOG(JP_ERROR,
     X      'INTUVP: Scratch memory type 5 allocation failed.',JPQUIET)
          INTUVPH = JPROUTINE + 4
          GOTO 900
        ENDIF
C
        CALL SH2SH( VD(IPVORT), NIRESO, ZNFLDO, NTRUNC )
C
        IDIVOFF = IPVORT + (NTRUNC+1)*(NTRUNC+2)
        CALL SH2SH( VD(IPDIV), NIRESO, ZNFLDO(IDIVOFF), NTRUNC )
C
        NEXT = 0
        DO LOOP = NTRUNC, 0, -1
          NEXT = NEXT + LOOP + 1
          ZNFLDO(IDIVOFF+NEXT*2-2) = 0
          ZNFLDO(IDIVOFF+NEXT*2-1) = 0
          ZNFLDO(IPVORT +NEXT*2-2) = 0
          ZNFLDO(IPVORT +NEXT*2-1) = 0
        ENDDO
C
        ISZUV = (MTRUNC+1)*(MTRUNC+2)
        IP_U  = 1
        IP_V  = 1 + ISZUV
        CALL JMEMHAN( JPSCR3, IUV, ISZUV*2, JPALLOC, IERR)
        IF( IERR.NE.0 ) THEN
          CALL INTLOG(JP_ERROR,
     X      'INTUVPH: Scratch memory type 3 allocation failed.',JPQUIET)
            INTUVPH = IERR
          GOTO 900
        ENDIF
C
C       Generate U and V from vorticity and divergence,
C
        CALL JVOD2UV(ZNFLDO(IPVORT),ZNFLDO(IDIVOFF),NTRUNC,
     X               UV(IP_U),UV(IP_V),MTRUNC)
C
      ELSE
C
C       Get scratch memory for U and V spectral fields.
C       The memory areas are adjacent.
C
        NTRUNC = NIRESO
        ISZUV = (NIRESO+1)*(NIRESO+2)
        IP_U  = 1
        IP_V  = 1 + ISZUV
        CALL JMEMHAN( JPSCR3, IUV, ISZUV*2, JPALLOC, IERR)
        IF( IERR.NE.0 ) THEN
          CALL INTLOG(JP_ERROR,
     X      'INTUVPH: Scratch memory type 3 allocation failed.',JPQUIET)
          INTUVPH = IERR
          GOTO 900
        ENDIF
C
C       Transfer input spectral U and V to the memory areas.
C
        DO LOOP = 0, ISZUV-1
          UV(IP_U + LOOP) = VD(IPVORT + LOOP)
          UV(IP_V + LOOP) = VD(IPDIV  + LOOP)
        ENDDO
C
      ENDIF
C
C     -----------------------------------------------------------------|
C*    Section 4. Handle spectral output.
C     -----------------------------------------------------------------|
C
  400 CONTINUE
C
      IF( (LNORESO)            .AND.
     X    ((NOREPR.EQ.JPSPHERE).OR.(NOREPR.EQ.JPSPHROT)) ) THEN
C
        CALL INTLOG(JP_DEBUG,
     X    'INTUVPH: Produce spectral output with truncation',NORESO)
C
C       Set GRIBEX flag to force recalculation of complex packing factor
C
        CALL GRSMKP(1)
C
        ISIZE =  (NORESO+1)*(NORESO+2)
        CALL JMEMHAN( JPSCR5, IZNFLDO, ISIZE*2, JPALLOC, IERR)
        IF( IERR.NE.0 ) THEN
          CALL INTLOG(JP_ERROR,
     X      'INTUVPH: Scratch memory type 5 allocation failed.',JPQUIET)
          INTUVPH = JPROUTINE + 4
          GOTO 900
        ENDIF
C
        IP_U = 1
        CALL SH2SH( UV(1), NIRESO, ZNFLDO(IP_U), NORESO )
C
        IP_V = 1 + (NORESO+1)*(NORESO+2)
        CALL SH2SH( UV(1+ISZUV), NIRESO, ZNFLDO(IP_V), NORESO )
C
        NIRESO = NORESO
C
      ENDIF
C
C     Has all processing been done (ie is the output spectral)?
C
      IF( (NOREPR.EQ.JPSPHERE).OR.(NOREPR.EQ.JPSPHROT) ) THEN
C
C       Code U into GRIB
C
        IERR = INTUVDH(ZNFLDO(IP_U),ISZUV,KUGRIBO,OUTLENU,'C',JP_U)
        IF( IERR.NE.0 ) THEN
          CALL INTLOG(JP_ERROR,
     X      'INTUVPH: U encoding into GRIB failed.',IERR)
          INTUVPH = JPROUTINE + 4
          GOTO 900
        ENDIF
C
C       Code V into GRIB
C
        IERR = INTUVDH(ZNFLDO(IP_V),ISZUV,KVGRIBO,OUTLENV,'C',JP_V)
        IF( IERR.NE.0 ) THEN
          CALL INTLOG(JP_ERROR,
     X      'INTUVPH: V encoding into GRIB failed.',IERR)
          INTUVPH = JPROUTINE + 4
          GOTO 490
        ENDIF
C
  490   CONTINUE
C
C       Turn off GRIBEX flag which forces recalculation of complex
C       packing factor
C
        CALL GRSMKP(0)
C
        GOTO 900
C
      ENDIF
C
C     -----------------------------------------------------------------|
C*    Section 6.   Generate interpolated GRIB format U and V fields.
C     -----------------------------------------------------------------|
C
  600 CONTINUE
C
C     Get scratch space for interpolation
C
      IERR = FIXAREA()
      IF( IERR.NE.0 ) THEN
        CALL INTLOG(JP_ERROR,'INTUVPH: Fixarea failed.',JPQUIET)
        INTUVPH = IERR
        GOTO 900
      ENDIF
C
      ISIZE = ISCRSZ()*2
      IF( ISIZE.LE.0 ) THEN
        CALL INTLOG(JP_ERROR,'INTUVPH: Get scratch space failed.',ISIZE)
        INTUVPH = JPROUTINE + 5
        GOTO 900
      ENDIF
      CALL JMEMHAN( JPSCR5, IZNFLDO, ISIZE, JPALLOC, IERR)
      IF( IERR.NE.0 ) THEN
        CALL INTLOG(JP_ERROR,
     X    'INTUVPH: Scratch memory(5) allocation failed.',JPQUIET)
        INTUVPH = JPROUTINE + 5
        GOTO 900
      ENDIF
C
      LWIND = .TRUE.
      LWINDSET = .TRUE.
C
C     Interpolate U and V
C
      NOLD = NIRESO
      NIRESO = MTRUNC
      IERR = INTUVXH(UV,ISZUV,ZNFLDO,KUGRIBO,KVGRIBO,OUTLENU,OUTLENV)
      IF( IERR.NE.0 ) THEN
        CALL INTLOG(JP_ERROR,
     X    'INTUVPH: U/V interpolation failed.',JPQUIET)
        INTUVPH = JPROUTINE + 6
        GOTO 900
      ENDIF
C
      NIRESO = NOLD
C
C     -----------------------------------------------------------------|
C*    Section 9.   Return
C     -----------------------------------------------------------------|
C
  900 CONTINUE
C
C     Clear change flags for next product processing and reset wind flag
C
      LCHANGE = .FALSE.
      LSMCHNG = .FALSE.
      LWINDSET  = LOLDWIND
      LWIND = .FALSE.
C
      NIRESO = MIRESO
      NORESO = MORESO
C
      RETURN
      END

C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

       PROGRAM DECODE_CREX
C
C**** *DECODE_CREX*
C
C
C     PURPOSE.
C     --------
C         DECODE CREX CODED DATA
C
C
C**   INTERFACE.
C     ----------
C
C          NONE.
C
C     METHOD.
C     -------
C
C          NONE.
C
C
C     EXTERNALS.
C     ----------
C
C          CREXEX    
C          CREXSEL 
C          CREXPRS0 
C          CREXPRT
C          PBOPEN
C          PBCLOSE 
C          PBCREX
C          GETARG    
C         
C         
C         
C
C     REFERENCE.
C     ----------
C
C          NONE.
C
C     AUTHOR.
C     -------
C
C          M. DRAGOSAVAC    *ECMWF*       15/09/2003.
C
C
C     MODIFICATIONS.
C     --------------
C
C          NONE.
C
C
      IMPLICIT LOGICAL(L,O,G), CHARACTER*8(C,H,Y)
C
      PARAMETER(JSUP =   9,JSEC0=   3,JSEC1= 40,JSEC2=4096,JSEC3=    4,
     1          JSEC4=   2,JELEM=40000,JSUBS=400,JCVAL=150 ,JBUFL=80000,
#ifdef JBPW_64
     2          JBPW =  64,JTAB =3000,JCTAB=120,JCTST=1800,JCTEXT=1200,
#else
     2          JBPW =  32,JTAB =3000,JCTAB=120,JCTST=1800,JCTEXT=1200,
#endif
     3          JWORK=360000,JKEY=46,JBYTE=80000)
C
      PARAMETER (KELEM=8000)
      PARAMETER (KVALS=360000)
C 
      DIMENSION KBUFF(JBUFL)
      DIMENSION KSUP(JSUP)  ,KSEC0(JSEC0),KSEC1(JSEC1)
      DIMENSION KSEC3(JSEC3)
C
      REAL*8 VALUES(KVALS)
      REAL*8 RVIND
      REAL*8 EPS
C
      DIMENSION KTDLST(JELEM),KTDEXP(JELEM)
      DIMENSION KDATA(200)
C
      CHARACTER*256 CF,CARG(4)
      CHARACTER*64 CNAMES(KELEM)
      CHARACTER*24 CUNITS(KELEM)
      CHARACTER*80 CVALS(KVALS)
      CHARACTER*80 YENC
      CHARACTER*320000 YBUFF
C
      EQUIVALENCE(YBUFF,KBUFF(1))
C                                                                       
C     ------------------------------------------------------------------
C*          1. INITIALIZE CONSTANTS AND VARIABLES.
C              -----------------------------------
 100  CONTINUE
C
      NBYTPW=JBPW/8
      RVIND=1.7D38
      NVIND=2147483647
      IOBS=0
      EPS=1.D-8
      N=0
      OO=.FALSE.
      CF=' '
C
C     INPUT FILE NAME
C
C     GET INPUT AND OUTPUT FILE NAME.
C
      NARG=IARGC()
C
      IF(NARG.NE.2) THEN
         PRINT*,'USAGE -- decode_crex -i infile ' 
         STOP
      END IF
C
      DO 101 J=1,NARG
      CALL GETARG(J,CARG(J))
 101  CONTINUE
C
      IF(CARG(1).NE.'-I'.AND.CARG(1).NE.'-i'.OR.
     1   CARG(2).EQ.' ') THEN
         PRINT*,'USAGE -- decode_crex -i inpfile '
         STOP
      END IF

C
      CF=CARG(2)
      II=INDEX(CF,' ')
      II=II-1
C
C*          1.2 OPEN FILE CONTAINING CREX DATA.
C               -------------------------------
 120  CONTINUE
C
      IRET=0 
      CALL PBOPEN(IUNIT,CF(1:II),'R',IRET)
      IF(IRET.EQ.-1) STOP 'OPEN FAILED ON INPUT FILE'
      IF(IRET.EQ.-2) STOP 'INVALID FILE NAME'
      IF(IRET.EQ.-3) STOP 'INVALID OPEN MODE SPECIFIED'
C
C     ----------------------------------------------------------------- 
C*          2. SET REQUEST FOR EXPANSION.
C              --------------------------
 200  CONTINUE
C
      OPRT=.FALSE.
      OENC=.FALSE.
      WRITE(*,'(A,$)') ' DO YOU WANT TO PRINT( Y/N ) : '
      READ (*,'(A)') YENC
      IF(YENC(1:1).EQ.'Y'.OR.YENC(1:1).EQ.'y') THEN
         OPRT=.TRUE.
      END IF
C
 201  CONTINUE
C
      WRITE(*,'(A,$)') ' DO YOU WANT TO PRINT SECTION 0-3( Y/N ) : '
      READ (*,'(A,$)') YENC
      OSEC3=.FALSE.
      IF(YENC(1:1).EQ.'Y'.OR.YENC(1:1).EQ.'y') OSEC3=.TRUE.
C
 210  CONTINUE
C
C
C     -----------------------------------------------------------------
C*          3.  READ CREX MESSAGE.
C               ------------------
 300  CONTINUE
C
      IERR=0
      IRET=0
C
      YBUFF(1:15000)=' '
      CALL PBCREX(IUNIT,KBUFF,JBUFL,KBUFL,IRET)
      IF(IRET.LT.0) THEN
         IF(IRET.EQ.-1) THEN
            PRINT*,'NUMBER OF CREX MESSAGES PROCESSED ',N
            PRINT*,'NUMBER OF CREX OBSERVATIONS       ',IOBS
            STOP 'END OF FILE '
         END IF
         IF(IRET.EQ.-2) STOP 'ERROR IN HANDLING THE FILE'
         IF(IRET.EQ.-3) STOP 'ERROR DURING READ CREX FILE.'
      END IF
C
      N=N+1
      PRINT*,'----------------------------------',N
      print*,YBUFF(1:KBUFL)
C
C     -----------------------------------------------------------------
C*          4. EXPAND CREX MESSAGE.
C              --------------------
 400  CONTINUE
C
     
      IERR=0
      CALL CREXEX(KBUFL,YBUFF,KSUP,KSEC0 ,KSEC1,KSEC3 ,
     1            KELEM,CNAMES,CUNITS,KVALS,VALUES,CVALS,IERR)
C
      IF(IERR.NE.0) THEN
         PRINT*,'CREX ERROR ', IERR
         GO TO 300
      END IF
C
C
      IOBS=IOBS+KSEC3(3)
C
      ISUBSET=1
      CALL CREXSEL2(ISUBSET,KELEM,KTDLEN,KTDLST,KTDEXL,KTDEXP,
     1              CNAMES,CUNITS,KERR)
      IF(KERR.NE.0) THEN
         PRINT*,'CREXSEL: ERROR.'
         CALL EXIT(2)
      END IF
C
C*          4.1 PRINT CONTENT OF EXPANDED DATA.
C               -------------------------------
 410  CONTINUE
C
      IF(.NOT.OPRT) GO TO 300
      IF(.NOT.OSEC3) GO TO 450
C
C*          4.2 PRINT SECTION ZERO OF CREX MESSAGE.
C               -----------------------------------
 420  CONTINUE
C
      CALL CREXPRS0(KSEC0)
C
C*          4.3 PRINT SECTION ONE OF CREX MESSAGE.
C               -----------------------------------
 430  CONTINUE
C
      ISUBSET=1
      CALL CREXSEL2(ISUBSET,KELEM,KTDLEN,KTDLST,KTDEXL,KTDEXP,
     1              CNAMES,CUNITS,KERR)
      IF(KERR.NE.0) CALL EXIT(2)
C
      CALL CREXPRS1(KSEC1,KSEC3,KTDLEN,KTDLST,KTDEXL,
     1              KTDEXP,KELEM,CNAMES)
C
C
C
C*          4.5 PRINT SECTION 2 OF CREX MESSAGE.
C               -----------------------------------
 450  CONTINUE
C
C
C*         4.6 PRINT SECTION 2 (DATA).
C              -----------------------
 460  CONTINUE
C
C          IN THE CASE OF MANY SUBSETS DEFINE RANGE OF SUBSETS
C
      IF(.NOT.OO) THEN
      WRITE(*,'(A,$)') ' STARTING SUBSET TO BE PRINTED : '
      READ(*,'(BN,I4)')   IST
      WRITE(*,'(A,$)') ' ENDING SUBSET TO BE PRINTED : '
      READ(*,'(BN,I4)')   IEND
      OO=.FALSE.
      END IF
C
C              PRINT DATA
C
      ICODE=0
      CALL CREXPRT(ICODE,IST,IEND,KELEM,CNAMES,CUNITS,CVALS,
     1             KVALS,VALUES,KSUP,KSEC1,IERR)
C
C
      GO TO 300
C
    
C     -----------------------------------------------------------------
 900  CONTINUE
C
      END

      INTEGER FUNCTION IGGLAT(KLAT, PGAUSS, KPR, KERR)
C
C---->
C**** *IGGLAT*
C
C     PURPOSE
C     _______
C
C     Compute Gaussian lines of latitude for a given truncation.
C
C
C     INTERFACE
C     _________
C
C     IERR = IGGLAT(KLAT, PGAUSS, KPR, KERR)
C
C
C     Input parameters
C     ________________
C
C     KLAT - The number of lines of latitude from pole to pole.
C
C     KPR  - Debug print switch:
C            0, No debugging output.
C            1, Produce debugging output.
C
C     KERR - Error control flag.
C            -ve, No error message. Return error code.
C            0  , Hard failure with error message.
C            +ve, Print error message. Return error code.
C
C
C     Output parameters
C     ________________
C
C     PGAUSS - The Gaussian lines of latitude for truncation KLAT/2
C
C
C     Return value
C     ____________
C
C     0     - OK
C     24701 - The calculation of Gaussian lines of latitude failed.
C
C
C     Common block usage
C     __________________
C
C     None
C
C
C     EXTERNALS
C     _________
C
C     INTLOG(R) - Logs messages.
C     IGBESS    - This routine is used to generate initial
C                 approximations to the Gaussian latitudes.
C
C
C     METHOD
C     ______
C
C     IGBESS is used to provide zeros of the Bessel function J0,
C     which are used as starting approximations to the Gaussian
C     latitudes. Newton iteration is used to generate the latitudes
C     from these approximations.
C
C     Calculated latitudes are stored internally and reused if a
C     later call asks for the same calculation.
C
C
C     REFERENCE
C     _________
C
C     None
C
C
C     COMMENTS
C     ________
C
C     This routine is adapted from that in the old Marsint library.
C     The interface and the variable names have been modified.
C
C
C     AUTHOR
C     ______
C
C     K. Fielding      *ECMWF*      Oct 1993
C
C
C     MODIFICATIONS
C     _____________
C
C     J.Chambers        ECMWF       Aug 1998
C     Add reuse of calculated latitudes.
C
C----<
C     -------------------------------------------------------
C*    Section 0. Definition of variables.
C     -------------------------------------------------------
C
      IMPLICIT NONE
C
#include "jparams.h"
#include "parim.h"
C
C     Function arguments
C
      INTEGER KLAT, KPR, KERR
      REAL PGAUSS (*)
C
C     Parameters
C
      INTEGER JPROUTINE
      PARAMETER (JPROUTINE = 24700)
C     -------------------------------------------------------
C     The convergence criteria is machine dependent
C     -------------------------------------------------------
C
      REAL PACRCY
#ifdef REAL_8
      PARAMETER (PACRCY = 1.0E-14)
#else
      PARAMETER (PACRCY = 1.0E-7)
#endif
C
C     Local variables
C
      LOGICAL LDEBUG
      INTEGER ITRUNC, IERR
      INTEGER JLAT, JITER, JLN, LOOP, JOLDLAT
      REAL ZRADDEG, ZCON, ZLAT, ZROOT
      REAL ZKM1, ZKM2, ZLN, ZFUNC, ZDERIV, ZMOVE
      REAL ROLDGS
      DIMENSION ROLDGS(JPGTRUNC*2)
C
      SAVE JOLDLAT, ROLDGS
C
C     Externals
C
      INTEGER IGBESS
C
C     -------------------------------------------------------
C*    Section 1. Set constants and get initial approximation.
C     -------------------------------------------------------
C
  100 CONTINUE
C
      IGGLAT = 0
      LDEBUG = ( KPR.GE.1 )
C
      IF( LDEBUG ) THEN
        CALL INTLOG(JP_DEBUG,'IGGLAT: Section 1.',JPQUIET)
        CALL INTLOG(JP_DEBUG,
     X  'IGGLAT: No.lines lat from pole to pole = ',KLAT)
      ENDIF
C
C     Using previously calculated values if truncation is the same.
C
      IF( KLAT.EQ.JOLDLAT ) THEN
        IF( LDEBUG ) CALL INTLOG(JP_DEBUG,
     X    'IGGLAT: Using previously calculated values',JPQUIET)
        DO LOOP = 1, KLAT
          PGAUSS(LOOP) = ROLDGS(LOOP)
        ENDDO
        GOTO 900
      ENDIF
C
      JOLDLAT = KLAT
C
      ZRADDEG = 180.0/PPI
C
      ZCON   = (PPONE - (PPTWO / PPI) ** 2) * PPQUART
C
      ZLAT   = KLAT
      ITRUNC = KLAT/2
C
      IERR = IGBESS(ITRUNC, PGAUSS, KPR, KERR)
C
      IF( IERR.GT.0 ) THEN
         IGGLAT = IERR
         GOTO 900
      ENDIF
C
C     -------------------------------------------------------
C*    Section 2. Compute abscissae
C     -------------------------------------------------------
C
  200 CONTINUE
C
      IF( LDEBUG ) CALL INTLOG(JP_DEBUG,'IGGLAT: Section 2.',JPQUIET)
C
      DO 240 JLAT = 1, ITRUNC
C
C       First approximation for ZROOT
C
        ZROOT = COS(PGAUSS(JLAT) / SQRT( (ZLAT+PPHALF)**2 + ZCON) )
C
C       Perform loop of Newton iterations
C
        DO 220 JITER = 1, JPMAXITER
C
          ZKM2 = PPONE
          ZKM1 = ZROOT
C
C         Compute Legendre polynomial
C
          DO 210 JLN = 2, KLAT
C
            ZLN = JLN
C
            ZFUNC = ( (PPTWO * ZLN - PPONE) * ZROOT * ZKM1 -
     1              (ZLN - PPONE) * ZKM2) / ZLN
C
            ZKM2 = ZKM1
            ZKM1 = ZFUNC
C
  210     CONTINUE
C
C         Perform Newton iteration
C
          ZDERIV = (ZLAT * (ZKM2 - ZROOT * ZFUNC) ) /
     1             (PPONE - ZROOT ** 2)
C
          ZMOVE = ZFUNC / ZDERIV
          ZROOT = ZROOT - ZMOVE
C
C         Leave iteration loop when sufficient accuracy achieved.
C
          IF( ABS(ZMOVE).LE.PACRCY ) GOTO 230
C
  220   CONTINUE
C
C       Routine fails if no convergence after JPMAXITER iterations.
C
        IGGLAT = JPROUTINE + 1
C
        IF( KERR.GE.0 ) CALL INTLOG(JP_ERROR,
     X    'IGGLAT: Calculation of Gaussian lats failed.',JPQUIET)
C
        IF( KERR.EQ.0 ) CALL INTLOG(JP_FATAL,
     X    'IGGLAT: interpolation failed.',IGGLAT)
C
        GOTO 900
C
  230   CONTINUE
C
C*      Set North and South values using symmetry.
C
        PGAUSS(JLAT) = ASIN(ZROOT) * ZRADDEG
        PGAUSS(KLAT + 1 - JLAT) = - PGAUSS(JLAT)
C
  240 CONTINUE
C
      IF( KLAT.NE.(ITRUNC*2) ) PGAUSS(ITRUNC + 1) = PPZERO
C
C     Store calculated values for re-use
C
      DO LOOP = 1, KLAT
        ROLDGS(LOOP) = PGAUSS(LOOP)
      ENDDO
C
C     -------------------------------------------------------
C*    Section 9. Return to calling routine.
C     -------------------------------------------------------
C
  900 CONTINUE
C
      IF( LDEBUG ) CALL INTLOG(JP_DEBUG,'IGGLAT: Section 9.',JPQUIET)
C
      RETURN
      END

C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE CREXDES(K,KSEC1,KTDLEN,CREXKTDLST,KDLEN,KDATA,KELEM,
     1                   KTDEXL,CREXKTDEXP,CNAMES,CUNITS,KERR)
C
C**** *CREXDES*
C
C
C     PURPOSE.
C     --------
C           EXPAND DATA DESCRIPTORS TO SHOW USER TEMPLATE 
C           DESCRIBED BY ARRAY KTDLST AND KDATA
C
C
C**   INTERFACE.
C     ----------
C
C           *CALL* *CREXDES(K,KSEC1,KTDLEN,CREXKTDLST,KDLEN,KDATA,KELEM,
C                           KTDEXL,CREXKTDEXP,CNAMES,CUNITS,KERR)*
C
C
C
C        INPUT :
C               *K*       -   AN INTEGER, PRINTING SWITCH 0 - NO PRINT
C                                                         1 - PRINT
C               *KSEC1*   -  Integer array of at least 40 words
C                            containing CREX section 1 information
C                            KSEC1( 1)-- Reserved
C                            KSEC1( 2)-- CREX Edition number
C                            KSEC1( 3)-- Reserved
C                            KSEC1( 4)-- Reserved
C                            KSEC1( 5)-- Reserved
C                            KSEC1( 6)-- CREX message type
C                            KSEC1( 7)-- Reserved
C                            KSEC1( 8)-- version number of local table used
C                            KSEC1( 9)-- Reserved
C                            KSEC1(10)-- Reserved
C                            KSEC1(11)-- Reserved
C                            KSEC1(12)-- Reserved
C                            KSEC1(13)-- Reserved
C                            KSEC1(14)-- CREX Master table
C                            KSEC1(15)-- version number of Master table used
C                            KSEC1(16) - KSEC1(40) -- Reserved
C                           
C                            Crex Edition 2
C
C                            
C               *KSEC1*   -  Integer array of at least 40 words
C                            containing CREX section 1 information
C                            KSEC1( 1)-- Reserved
C                            KSEC1( 2)-- CREX Edition number
C                            KSEC1( 3)-- Originating Centre ( oooo)
C                            KSEC1( 4)-- Update sequence number (uu)
C                            KSEC1( 5)-- Number of subsets (sss)
C                            KSEC1( 6)-- CREX data category (nnn)
C                            KSEC1( 7)-- International data sub-category (mmm)
C                            KSEC1( 8)-- version number of local table used
C                            KSEC1( 9)-- Year (yyyy)
C                            KSEC1(10)-- Month (mm)
C                            KSEC1(11)-- Day (dd)
C                            KSEC1(12)-- Hour (hh)
C                            KSEC1(13)-- Minute (mm)
C                            KSEC1(14)-- CREX Master table (tt)
C                            KSEC1(15)-- version number of Master table used (vv)
C                            KSEC1(16)-- Originating sub-centre (ppp)
C                            KSEC1(17)-- Bufr master table version number
C                            KSEC1(18)-- Bufr version number of local table used
C                            KSEC1(19) - KSEC1(40) -- Reserved
C
C
C               *KTDLEN*  -  Integer number of data descriptors in the list
C               *CREXKTDLST* Integer array of at least ktdlen words
C               *KDLEN*   -  Integer (dimension of kdata array)
C               *KDATA*   -  Integer array containing data needed for data
C                            descriptor expansion (delayed replication factors)
C                            which appear in the values array
C               *KELEM*   -
C        OUTPUT:
C
C               *KTDEXL   -  An integer containing number of expanded elements
C
C               *KTDEXP*  -  An integer array containing expanded list of descriptors
C
C               *CNAMES*  -  Character*64  array of KELEM containing
C                            CREX Table B element names
C               *CUNITS*  -  Character*24 array of KELEM containig
C                            CREX Table B units
C               *VALUES*  -  Real*8 array of KVALS containing expanded
C                            data values
C               *KERR*    -  returned error code
C
C
C
C
C     METHOD.
C     -------
C
C            NONE
C
C     EXTERNALS.
C     ----------
C
C            NONE.
C
C     REFERENCE.
C     ----------
C
C          NONE.
C
C     AUTHOR.
C     -------
C
C          M. DRAGOSAVAC    *ECMWF*       04/02/2003.
C
C     MODIFICATIONS.
C     --------------
C
C          NONE.
C
      IMPLICIT LOGICAL(L,O,G), CHARACTER*8(C,H,Y)


      PARAMETER(JSUP =   9,JSEC0=   3,JSEC1= 40,JSEC2= 64 ,JSEC3=    4,
     1          JSEC4=   2,JELEM=40000,JSUBS=400,JCVAL=150 ,JBUFL=40000,
     2          JBPW =  32,JTAB =3000,JCTAB=120,JCTST=1800,JCTEXT= 200,
     3          JWORK=360000,JKEY=46)
C
C
      COMMON /CRWORK/ NBPT,NGS,NVIND,NBPTSEC2,RVIND,EPS,NE,IEOLD,
     1                  NC07YYY
C
      COMMON /CRWT/ NCREXDWINC,NCREXSCAM,NCREXAFDW,NCREXWT ,ODREPF,
     2             NCREXSTACK(JELEM),NCREXWTEN(JELEM),
     3             NCREXWTR (JELEM),NCREXWTS (JELEM),
     4             NCREXWTDW(JELEM)
C
C             NCREXDWINC   -  data width increment
C             NCREXSCAM    -  scale multiplier
C             NCREXAFDW    -  augmented field data width
C             NCREXWT      -  pointer to working table
C             NCREXSTACK   -  list of data descriptors
C             ODREPF   -  replication (logical)
C             NCREXWTR     -  working table reference
C             NCREXWTS     -  working scale
C             NCREXWTDW    -  working data width
C
C
C
      COMMON /CRWTC/ CREXWTEN(JELEM),CREXWTU(JELEM)
C
C             CREXWTEN    -  working table element naame
C             CREXWTU     -  working table units
C
      CHARACTER CREXWTEN*64,CREXWTU*24
C
      COMMON /CREL/ NCREXTDLEN,NCREXTDLST(JELEM),NCREXTDEXL,
     1              NCREXTDEXP(JELEM)
C
C             NCREXTDLEN - number of Data descriptors in section 3
C             NCREXTDLST - list of Data descriptors
C             NCREXTDEXL - number of expanded Data Descriptors
C             NCREXTDEXP - list of expanded Data descriptors
C
      COMMON /CRBEF / M,MM,N,JCV
C
C             M       -  Number of elements
C             MM      -  Number of elements
C             N       -  Number of data sub_sets
C             JCV     -  Number of character values

      CHARACTER*15  FMT
      CHARACTER*6  CREXKTDLST(KELEM)
      CHARACTER*6 CREXKTDEXP(KELEM)
C
      INTEGER IVALUE(KELEM)
C
      INTEGER IVAL,IIVAL
c
      REAL*8 EPS
      REAL*8 RVIND
      REAL*8 VAL
C
      CHARACTER*64 CNAMES(kelem)
      CHARACTER*24 CUNITS(kelem)

      DIMENSION KSEC0(JSEC0),KSEC1(JSEC1)
C
      CHARACTER*4 CECMWF
C
C     ------------------------------------------------------------------
C
c*         1. Set Constants
c             ----------------
 100  CONTINUE
c
      KERR=0
      IF(CECMWF.NE.'ECMF') THEN
         CALL CREXIVAR(KERR)
         CECMWF='ECMF'
      END IF
c
c*         2. Load Crex Tables
c             ----------------
 200  CONTINUE
c
      CALL CREXETAB(KSEC1,KERR)
      IF(KERR.GT.0) RETURN

c
c*         3.1 Expand Data Descriptors
c              -----------------------
c
 310  CONTINUE
c
      KPT=0
      CALL CREXEDD(KPT,KTDLEN,CREXKTDLST,KDLEN,KDATA,KSEC3,
     1             KELEM,CNAMES,CUNITS,KERR)
      IF(KERR.GT.0) RETURN
C
      KTDEXL =M
      DO 301 I=1,KTDEXL
      WRITE(CREXKTDEXP(I),'(i6.6)') NCREXWTR(I)
      IF(CREXKTDEXP(I)(1:1).EQ.'0') CREXKTDEXP(I)(1:1)="B"
 301  CONTINUE
C
      IF(K.EQ.1) THEN
C
         WRITE(*,'(1H ,//)')
         WRITE(*,'(1H ,A)')    '       DATA DESCRIPTORS (UNEXPANDED)'
C
         WRITE(*,'(1H )')
         DO 110 I=1,KTDLEN
          IF(CREXKTDLST(I)(1:1).EQ.'3') CREXKTDLST(I)(1:1)="D"
          IF(CREXKTDLST(I)(1:1).EQ.'2') CREXKTDLST(I)(1:1)="C"
          IF(CREXKTDLST(I)(1:1).EQ.'1') CREXKTDLST(I)(1:1)="R"
          IF(CREXKTDLST(I)(1:1).EQ.'0') CREXKTDLST(I)(1:1)="B"
          WRITE(*,'(1H ,I4,2X,A)') I,CREXKTDLST(I)
 110     CONTINUE
C
         WRITE(*,'(1H ,/)')
         WRITE(*,'(1H ,A)')    '       DATA DESCRIPTORS (EXPANDED)'
         WRITE(*,'(1H )')
         WRITE(*,'(1H ,A,A)')'                ELEMENT NAME',
     1   '                            UNIT'
         WRITE(*,'(1H )')
C
         DO 120 I=1,KTDEXL
          WRITE(*,'(1H ,I5,2X,A,2X,A,2X,A)') I,CREXKTDEXP(I),
     1                      CNAMES(I)(1:40),CUNITS(I)(1:18)
 120     CONTINUE
      END IF
C
C
C     -----------------------------------------------------------------
      RETURN
C
      END

#define MISSING_VALUE -9999999

      PROGRAM GINOUT
      IMPLICIT NONE
C
      INTEGER JPACK, JPBYTES
      PARAMETER (JPACK = 500000)
C
C     JPBYTES is the number of bytes per INTEGER
C
      PARAMETER (JPBYTES = 4)
C
      INTEGER ISEC0, ISEC1, ISEC2, ISEC3, ISEC4, INBUFF, IOS, ISTR 
      DIMENSION ISEC0(2)
      DIMENSION ISEC1(1024)
      DIMENSION ISEC2(1024)
      DIMENSION ISEC3(2)
      DIMENSION ISEC4(1024)
C
      REAL ZSEC2, ZSEC3, ZSEC4, USEC4
      DIMENSION ZSEC2(1024)
      DIMENSION ZSEC3(2)
      DIMENSION ZSEC4(JPACK*4)
      DIMENSION USEC4(JPACK*4)
      DIMENSION INBUFF(JPACK)
      INTEGER IRET, FILE1, FILE2, JCOUNT
      INTEGER ILENB, LENOUT, IPUNP, IWORD, loop, NUMBER
C
      CHARACTER*128 INFILE, OUTFILE
      INTEGER IJDC, IARGC, PBGTOTL
      EXTERNAL GETENV, PBGTOTL
C
      IJDC = IARGC()
      IF( IJDC.LT.2 ) STOP 'Usage: ginout inputfile outputfile'
      CALL GETARG(1,INFILE)
      CALL GETARG(2,OUTFILE)
C
C     Open the input file
C
      CALL PBOPEN(FILE1, INFILE(1:INDEX(INFILE,' ')-1), "R", IRET)
      IF( IRET.NE.0 ) THEN
        WRITE(*, *) 'Return code from PBOPEN = ',IRET
        CALL PBCLOSE(FILE1, IRET)
        STOP 'Fault in PBOPEN'
      ENDIF

      NUMBER = PBGTOTL(INFILE(1:INDEX(INFILE,' ')-1))
      WRITE(*,*) '****************************************'
      WRITE(*,*) 'Number of GRIBs in the file = ', NUMBER
      WRITE(*,*) '****************************************'
      IF( NUMBER.EQ.0 ) STOP 'No Gribs found'
        
C     Open the output file to write decoded products
        ISTR=INDEX(OUTFILE,' ')
      OPEN (UNIT=16,FILE=OUTFILE(1:ISTR-1),STATUS='UNKNOWN',
     &          FORM='UNFORMATTED',IOSTAT=IOS)
            IF (IOS.EQ.0) THEN
                WRITE(*,*)'File:',OUTFILE(1:ISTR-1),' opened'
            ELSE
               WRITE(*,*)'File:',OUTFILE(1:ISTR-1),' not opened'
               WRITE(*,*)'Input/output status = ',IOS
               WRITE(*,*)'Program will stop'
               STOP
            END IF

C     Lengths of INBUFF and PSEC4
      ILENB = JPACK*JPBYTES
C
C     Start of loop through products
      JCOUNT = 0

   50 CONTINUE
      JCOUNT = JCOUNT + 1
C
C     Read packed field into INBUFF.
C
      CALL PBGRIB(FILE1, INBUFF, ILENB, LENOUT, IRET )
      IF( IRET.LT.0 ) THEN
           WRITE (*, *) 'Return code from pbgrib = ',IRET

           IF( IRET.EQ.-1 ) THEN
             WRITE(*, *) 'End of file. Number of products decoded ='
     &          , (JCOUNT-1)
             CALL PBCLOSE(FILE1, IRET)
             CLOSE(16)
             STOP 'EOF'
           ELSE
             CALL PBCLOSE(FILE1, IRET)
             CLOSE(16)
             WRITE(*, *) 'Fault in PBGRIB. trying with product:', JCOUNT
             WRITE(*, *) 'Number of products decoded =', (JCOUNT-1)
             STOP 'Fault in PBGRIB'
           ENDIF
      ENDIF
C
C     Unpack GRIB message.
C
      ZSEC3(2) = MISSING_VALUE
      ISEC3(2) = NINT(ZSEC3(2))
      IRET     = 1
      IPUNP    = JPACK * JPBYTES
      ILENB    = (LENOUT + (JPBYTES-1))/JPBYTES
      CALL GRIBEX( ISEC0,ISEC1,ISEC2,ZSEC2,ISEC3,ZSEC3,ISEC4,
     X             ZSEC4,IPUNP,INBUFF,ILENB,IWORD,'D',IRET)

      WRITE (*,*) ' GRDEMO : GRIBEX return code = ', IRET
      WRITE (*,*) ' Product number= ', JCOUNT
      WRITE (*,*) '-------------------------------' 
      IF (IRET .EQ. - 6) WRITE (*,*) ' GRDEMO : Pseudo-grib data found.'
      IF( IRET.GT.0 ) THEN
        WRITE(*,*) 'GRIBEX return code = ',IRET
        STOP 'GRIBEX error'
      ENDIF
C
C
cs  Number of data values in array PSEC4
      IPUNP = ISEC4(1)
cs write decoded values to outfile
      WRITE (16)(ZSEC4(LOOP),LOOP=1,IPUNP)
C
C     Go back for more products
C
      GOTO 50
C
      END

C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE DEC2OCTAL(KOCTAL,KDECIMAL,KERR)
C**** *DEC2OCTAL*
C
C
C     PURPOSE.
C     --------
C         Convert decomal integer into octal value
C
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *DEC2OCTAL(KOCTAL,KDECIMAL,KERR)
C
C     METHOD.
C     -------
C
C          NONE.
C
C
C     EXTERNALS.
C     ----------
C
C          NONE.
C
C     REFERENCE.
C     ----------
C
C          NONE.
C
C     AUTHOR.
C     -------
C
C          MILAN DRAGOSAVAC    *ECMWF*       07/01/2004.
C
C
C     MODIFICATIONS.
C     --------------
C
C          NONE.
C
C
      IMPLICIT LOGICAL(L,O,G), CHARACTER*8(C,H,Y)
C

      INTEGER KOCTAL
      INTEGER KDECIMAL
      CHARACTER*10 C
c
      KERR=0
      WRITE(C,'(O10)',IOSTAT=IOS) KDECIMAL
      IF(IOS.NE.0) then
        Print*,'DEC2OCTAL: internal write error ',ios
        KERR=33
        RETURN
      ENDIF
C
      READ(C, '(I10)',IOSTAT=IOS) KOCTAL
      IF(IOS.NE.0) then
        Print*,'DEC2OCTAL: internal read error ',ios
        KERR=35
        RETURN
      ENDIF

c     
      RETURN
      END

C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE CMPCK(PSPEC,KTRUNC,KTRUNCNP)
C
C---->
C**** CMPCK
C
C     Purpose.
C     --------
C
C     Puts spectral coefficients in contiguous locations.
C
C
C**   Interface.
C     ----------
C
C     CALL CMPCK(PSPEC,KTRUNC,KTRUNCNP)
C
C
C     Input Parameters.
C     -----------------
C
C     PSPEC      - Array of spectral coefficients.
C     KTRUNC     - Truncation of the spherical harmonic coefficients.
C     KTRUNCNP   - Truncation of the subset of spherical harmonic
C                  coefficients to be ignored.
C
C
C     Output Parameters.
C     -----------------
C
C     PSPEC      - Array of spectral coefficients rearranged.
C
C
C     Method.
C     -------
C
C                            <subset>|
C
C     Given numbers:         cccccccc|CCCCCC
C                              cccccc|CCCCCC
C                                cccc|CCCCCC
C                                  cc|CCCCCC
C                                    |CCCCCC
C                                       CCCC
C                                         CC
C
C    Removes the subset and makes the CCCCCC...C values contiguous
C    in array PSPEC.
C
C     Externals.
C     ----------
C
C     None.
C
C
C     Reference.
C     ----------
C
C     None.
C
C
C     Comments.
C     --------
C
C     None.
C
C
C     Author.
C     -------
C
C     M.Hamrut         ECMWF      09:05:94
C
C
C     Modifications.
C     _____________
C
C     None.
C
C
C----<
C     -----------------------------------------------------------------
C*    Section 0. Definition of variables.
C     -----------------------------------------------------------------
C
      IMPLICIT NONE
C
C     Subroutine arguments
C
      INTEGER KTRUNC, KTRUNCNP
      REAL PSPEC
      DIMENSION PSPEC((KTRUNC+1)*(KTRUNC+2))
C
C     Local variables.
      INTEGER IUC, IC, JM, JN, IL2, IL1, ILEN
C
C
C     -----------------------------------------------------------------
C*    Section 1. Move only the required values (overwriting).
C     -----------------------------------------------------------------
C
      IUC=0
      IC =0
C
C     Loop through rows.
      DO 102 JM=0,KTRUNC
C
C       In each row calculate value to start with.
C       For early rows there are some value to skip (in the subset
C       being ignored).
        IL2=MAX(JM,KTRUNCNP+1)
        IL1=IL2-1
        IUC=IUC+MAX((IL1-JM+1)*2,0)
        ILEN=2*(KTRUNC-IL2+1)
C
C       Move values for the row.
CDIR$ IVDEP      
!OCL NOVREC
        DO 104 JN=1,ILEN
          IUC = IUC+1
          IC  = IC+1
          PSPEC(IC) = PSPEC(IUC)
 104    CONTINUE     
 102  CONTINUE
C
C     -----------------------------------------------------------------
C*    Section 9. Return.
C     -----------------------------------------------------------------
C
 900  CONTINUE
      RETURN
      END        

C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      INTEGER FUNCTION MAKERL(SHCIN,KTRUNC,SHCOUT,RANGLES)
C
C---->
C**** MAKERL
C
C     Purpose
C     -------
C
C     Rotates a spherical harmonic field.
C
C
C     Interface
C     ---------
C
C     IRET = MAKERL(SHCIN,KTRUNC,SHCOUT,RANGLES)
C
C     Input
C     -----
C
C     SHCIN   - Input array of spherical harmonics.
C     KTRUNC  - Truncation of the spherical harmonics.
C     RANGLES - Coordinates of the south pole of rotation:
C               latitude/longitude.
C
C
C     Output
C     ------
C
C     SHCOUT  - Output array of rotated spherical harmonics.
C
C     Function returns 0 if all OK, otherwise the rotations failed.
C
C
C     Method
C     ------
C
C     None.
C
C
C     Externals
C     ---------
C
C     RPHI    - Rotates spectral coefficients by longitude.
C     JACOBI  - Rotates spectral coefficients by latitude.
C     INTLOG  - Logs messages.
C
C     Author
C     ------
C
C     J.D.Chambers         ECMWF     October, 1995.
C
C
C----<
C---------------------------------------------------------------------
C
C
      IMPLICIT NONE
#include "parim.h"
#include "nofld.common"
C
C     Parameters
C
      INTEGER JPROUTINE
      PARAMETER (JPROUTINE = 28300)
      INTEGER JPLEN, JPNM
      PARAMETER ( JPNM = JPSTRUNC )
      PARAMETER ( JPLEN = (JPNM+1)*(JPNM+2) )
C
C     Function arguments.
C
      REAL SHCIN, SHCOUT, RANGLES
      DIMENSION SHCIN(*), SHCOUT(*), RANGLES(*)
      INTEGER KTRUNC
C
C     Local variables
C
      REAL*8 DLON, DLAT
      REAL*8 WORK
      DIMENSION WORK(2*(JPNM+1)*(JPNM+6))
      LOGICAL LOK
      INTEGER NBYTES, LOOP
#if (defined REAL_8)
      DATA NBYTES/8/
#else
      DATA NBYTES/4/
      REAL*8 DATA
      DIMENSION DATA(JPLEN)
#endif
C
C     Externals
C
      LOGICAL JACOBI
      EXTERNAL JACOBI
C
C     _______________________________________________________
C
C*    Section 1. Initialise.
C     _______________________________________________________
C
  100 CONTINUE
C
      MAKERL = 0
C
C     Check truncation not too big to handle.
C
      IF( KTRUNC .GT. JPSTRUNC ) THEN
        CALL INTLOG(JP_FATAL,'MAKERL: Truncation max exceeded', JPQUIET)
        CALL INTLOG(JP_FATAL,'MAKERL: Truncation = ', KTRUNC)
        CALL INTLOG(JP_FATAL,'MAKERL: Allowed maximum = ', JPSTRUNC)
        MAKERL = JPROUTINE + 1
         GOTO 900
      ENDIF
C
C     _______________________________________________________
C
C*    Section 2. Rotate the spectral coefficients.
C     _______________________________________________________
C
  200 CONTINUE
C
#if (defined REAL_8)
      DLAT = -90.0 - RANGLES(1)
      DLON = -RANGLES(2)
C
C     Rotate the spectral field by longitude.
C     Positive DLON => frame rotated from west to east.
C
      DO 210 LOOP = 1, (KTRUNC+1)*(KTRUNC+2)
        SHCOUT(LOOP) = SHCIN(LOOP)
  210 CONTINUE
      CALL RPHI( SHCOUT, KTRUNC, WORK, DLON)
C
C     Rotate the spectral field by latitude.
C     Negative DLAT => rotate counter-clockwise about new polar axis.
C
      LOK = JACOBI( SHCOUT, KTRUNC, WORK, DLAT)
      IF(.NOT.LOK) THEN
        CALL INTLOG(JP_FATAL,'MAKERL: JACOBI failed.', JPQUIET)
        MAKERL = JPROUTINE + 2
         GOTO 900
      ENDIF
#else
      DLAT = -90.0 - DBLE(RANGLES(1))
      DLON = -DBLE(RANGLES(2))
C
C     Expand spectral coefficients to REAL*8
C
      DO 210 LOOP = 1, (KTRUNC+1)*(KTRUNC+2)
        DATA(LOOP) = DBLE(SHCIN(LOOP))
  210 CONTINUE
C
C     Rotate the spectral field by longitude.
C     Positive DLON => frame rotated from west to east.
C
      CALL RPHI( DATA, KTRUNC, WORK, DLON)
C
C     Rotate the spectral field by latitude.
C     Negative DLAT => rotate counter-clockwise about new polar axis.
C
      LOK = JACOBI( DATA, KTRUNC, WORK, DLAT)
      IF(.NOT.LOK) THEN
        CALL INTLOG(JP_FATAL,'MAKERL: JACOBI failed.', JPQUIET)
        MAKERL = JPROUTINE + 2
         GOTO 900
      ENDIF
C
C     Repack spectral coefficients to REAL*4.
C
      DO 220 LOOP = 1, (KTRUNC+1)*(KTRUNC+2)
        SHCOUT(LOOP) = SNGL(DATA(LOOP))
  220 CONTINUE
#endif
C
C     _______________________________________________________
C
C*    Section 9. Return.
C     _______________________________________________________
C
  900 CONTINUE
C
      RETURN
      END

C Copyright 1981-2012 ECMWF.
C
C This software is licensed under the terms of the Apache Licence 
C Version 2.0 which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C
C In applying this licence, ECMWF does not waive the privileges and immunities 
C granted to it by virtue of its status as an intergovernmental organisation 
C nor does it submit to any jurisdiction.
C

      SUBROUTINE FREECF(KFLAG)
C
C---->
C**** FREECF
C
C     PURPOSE
C     _______
C
C     This routine sets the flag controlling handling of spectral
C     to grid interpolation coefficients memory.
C
C
C     INTERFACE
C     _________
C
C     CALL FREECF(KFLAG)
C
C     Input parameters
C     ________________
C
C     KFLAG - Flag indicating whether flushing of memory is done or not
C              = 1 to turn on flushing
C              = any other value to turn off flushing (default)
C
C
C     Output parameters
C     ________________
C
C     None
C
C
C     Common block usage
C     __________________
C
C     JDCSPGP - flag LFREECF
C
C
C     Method
C     ______
C
C     Sets flags LFREECF and NFREECF
C
C
C     Externals
C     _________
C
C     None
C
C
C     Reference
C     _________
C
C     None
C
C
C     Comments
C     ________
C
C     None.
C
C
C     AUTHOR
C     ______
C
C     J.D.Chambers       ECMWF       March 1998
C
C
C     MODIFICATIONS
C     _____________
C
C     None
C
C----<
C
      IMPLICIT NONE
C
#include "jparam2.h"
C
C     Subroutine arguments
C
      INTEGER KFLAG
C
      IF( KFLAG.EQ.1 ) THEN
        LFREECF = .TRUE.
        NFREECF = 11041967
      ELSE
        LFREECF = .FALSE.
        NFREECF = 11041967
      ENDIF
C
      RETURN
      END

      PROGRAM BFDEMO
!                                                                       
!     BFDEMO - Program to demonstrate use of BUFREX routine.            
!                                                                       
!     Purpose.                                                          
!     --------                                                          
!                                                                       
!     Demonstrates use of BUFREX routine to unpack                      
!     BUFR coded data.                                                  
!                                                                       
!     Interface.                                                        
!     ----------                                                        
!                                                                       
!     File of BUFR coded data attached as 'input_datafile'              
!                                                                       
!     Method.                                                           
!     -------                                                           
!                                                                       
!     Read BUFR messages and print sections 0, 1, 2, 3 and 4.                 
!                                                                       
!                                                                       
!     Externals.                                                        
!     ----------     
!
!     PBOPEN
!     PBCLOSE
!     PBBUFR
!     BUS012
!     BUFREX
!     BUPRS0
!     BUPRS1
!     BUPRS2
!     BUPRS3
!     BUUKEY
!     BUSEL
!     BUPRT
!
!                                                                       
!     WMO Manual on Codes, Volume I, International Codes, PartB-Binary Codes  
!     WMO No. 306, FM 94-IX Ext BUFR.      
!                                                                       
!     Comments.                                                         
!     ---------                                                         
!                                                                       
!     BUFREX provides a number of packing/unpacking options.       
!     See documentation in routine BUFREX for details.                  
!                                                                       
!     Author.                                                           
!     -------                                                           
!                                                                       
!     M. Dragosavac                                 
!                                                                       
!     Modifications.                                                    
!     --------------
!     
!     U. Modigliani     ECMWF   08.97
!                       rewritten in Fortran 90
!
!-----------------------------------------------------------------
!                                         
      IMPLICIT NONE     
!
      EXTERNAL PBOPEN, PBCLOSE, PBBUFR, BUS012, BUFREX, BUPRS0, BUPRS1, &
               BUPRS2, BUPRS3, BUUKEY, BUSEL, BUPRT    
!                                                                       
!     This parameter holds the 'number of bytes per integer'    
!   
      INTEGER, PARAMETER :: I4B = SELECTED_INT_KIND(9)   
!
!     These parameters hold the 'number of bytes per single/double precision real'    
!   
      INTEGER(KIND=I4B), PARAMETER :: NBYTES_SP = KIND(1.0)           
!
      INTEGER(KIND=I4B), PARAMETER :: NBYTES_DP = KIND(1.0D0)
!
      INTEGER(KIND=I4B), PARAMETER :: JSUP = 9, JSEC0 = 3, JSEC1 = 40, &
                         JSEC2 = 4096, JSEC3 = 4, JSEC4 = 2, JKEY = 46

!     The default size of the Section 1 is 18 octets and 22 octets for
!     Bufr Edition 4, if there are no local entries.
!                                                                       
      INTEGER(KIND=I4B), PARAMETER :: & ! These paramters depend on the input data!
        KELEM =  80000,  &              ! expected number of expanded elements
        KVALS = 360000,  &              ! expected number of data values
        JBUFL =  20000                  ! length of bufr message (words)
!
      INTEGER(KIND=I4B), DIMENSION(JBUFL) :: KBUFF
!                                                                       
!      CHARACTER(LEN=*), PARAMETER :: INPUT_FILE='../data/synop_4.bufr'
      CHARACTER(LEN=*), PARAMETER :: OPEN_MODE='r'
!
      CHARACTER(LEN=64), DIMENSION(KELEM)  :: CNAMES
      CHARACTER(LEN=24), DIMENSION(KELEM)  :: CUNITS
      CHARACTER(LEN=80), DIMENSION(KVALS)  :: CVALS
!                                                                       
      INTEGER(KIND=I4B), DIMENSION(JSUP)  :: KSUP 
      INTEGER(KIND=I4B), DIMENSION(JSEC0) :: KSEC0 
      INTEGER(KIND=I4B), DIMENSION(JSEC1) :: KSEC1 
      INTEGER(KIND=I4B), DIMENSION(JSEC2) :: KSEC2
      INTEGER(KIND=I4B), DIMENSION(JSEC3) :: KSEC3
      INTEGER(KIND=I4B), DIMENSION(JSEC4) :: KSEC4
       
      INTEGER(KIND=I4B), DIMENSION(JKEY) :: KEY 
!                                                                       
!     The array VALUES (and the missing value indicator RVIND) are
!     declared as REAL*8 from emoslib version 370 onwards.
!
      REAL(KIND=NBYTES_DP), DIMENSION(KVALS)  :: VALUES
!      
      INTEGER(KIND=I4B), DIMENSION(KELEM) :: KTDLST, KTDEXP
!                                                                       
!     DATA CNAMES / KELEM * ' ' / , CUNITS / KELEM * ' ' / 
!                                                                       
!     Clear error counter.
!                                              
      INTEGER(KIND=I4B) :: NUMERR = 0    
!                                                                       
!     Set message counter.
!                                               
      INTEGER(KIND=I4B) :: NMESSAGE = 0   
      INTEGER(KIND=I4B) :: ISTATUS = 0 
      INTEGER(KIND=I4B) :: KUNIT, KBUFL, KEL, KTDLEN, KTDEXL
      INTEGER(KIND=I4B) :: IONE = 1
      INTEGER(KIND=I4B) :: ONE = 1 
!
      INTEGER :: i
      CHARACTER(len=255) :: arg
      CALL getarg(1, arg)
      CNAMES = ' '
      CUNITS = ' '
      CVALS = ' ' 
!                                                                       
!     Open input file for reading.   
!                                    
      CALL PBOPEN (KUNIT, arg, OPEN_MODE, ISTATUS) 
!
!     Check return code.
!      
      WRITE ( * , * ) ' ' 
      WRITE ( * , * ) 'BFDEMO: After PBOPEN, status code   = ', ISTATUS 
      WRITE ( * , * ) ' ' 
      IF (ISTATUS .NE. 0) THEN 
          CALL PBCLOSE (KUNIT, ISTATUS)
          STOP 'BFDEMO: PBOPEN failed.'
      END IF       
!                                                                       
!     This is the beginning of a loop through BUFR records
!     reading one field at a time from the input datafile. 
!                                                                       
LOOP: DO WHILE (.TRUE.)     
!                                                               
         WRITE ( * , * ) '****************************************************' 
         WRITE ( * , * ) ' ' 
         CALL PBBUFR (KUNIT, KBUFF, JBUFL * NBYTES_SP, KBUFL, ISTATUS) 
         WRITE ( * , * ) 'BFDEMO: After PBBUFR, status code   = ', ISTATUS 
!                                                                       
         IF (ISTATUS .EQ. - 1) THEN
!
!        Exit the DO loop.
!
	        EXIT LOOP
         END IF
!        
!        It can be more specific: see PBBUFR error codes.
!                                                                      
         IF (ISTATUS .LT. - 1) THEN  
            CALL PBCLOSE (KUNIT, ISTATUS)
            STOP 'BFDEMO: Error reading file.' 
         END IF
!                                                                       
         NMESSAGE = NMESSAGE + 1 
!      
         WRITE ( * , * ) 'BFDEMO: BUFR message number         = ', NMESSAGE 
         WRITE ( * , * ) 'BFDEMO: Length of message           = ', KBUFL 
         WRITE ( * , * ) ' ' 
         WRITE ( * , * ) '****************************************************'
         WRITE ( * , * ) ' ' 
!                                                                       
         KBUFL = KBUFL / NBYTES_SP + 1 
!
!        Expands only section 0, 1 and 2 of Bufr message.
!                                                                  
         CALL BUS012 (KBUFL, KBUFF, KSUP, KSEC0, KSEC1, KSEC2, ISTATUS)       
!              
         IF(ISTATUS .NE. 0) THEN
            WRITE ( * , * ) 'Error in BUS012: ', ISTATUS
            CYCLE LOOP
         END IF
!
!        Decode Bufr message into fully expanded form; returning
!        information relevant for all Bufr sections, expanded values,
!        their names and units.
!      
         KEL=KELEM
         IF(KSUP(6).GT.1) THEN 
           KEL=KVALS/KSUP(6)
           IF (KEL.GT.KELEM) KEL=KELEM
         END IF
!
         CALL BUFREX (KBUFL, KBUFF, KSUP, KSEC0, KSEC1, KSEC2, KSEC3, KSEC4,   &
                      KEL, CNAMES, CUNITS, KVALS, VALUES, CVALS, ISTATUS)    
!                    
!        Check return code.
!                                                                       
         IF (ISTATUS .GT. 0) THEN
!
!           Increase the number of errors' counter.
! 
            NUMERR = NUMERR + 1 
            CYCLE LOOP
         END IF       
!
!        Print section 0 of Bufr message.
!            
         CALL BUPRS0 (KSEC0)      
!
!        Print section 1 of Bufr message.
!       
         CALL BUPRS1 (KSEC1) 
!
!        Expands local ECMWF information from section 2.
!    
         CALL BUUKEY (KSEC1, KSEC2, KEY, KSUP, ISTATUS) 
!
!        Print section 2 of Bufr message (expanded RDB key).
!
         CALL BUPRS2 (KSUP, KEY) 
!     
!        Returns list of Data Descriptors as in Section 3  of Bufr
!        message and total/requested list of elements.
!
         CALL BUSEL (KTDLEN, KTDLST, KTDEXL, KTDEXP, ISTATUS) 
!
!        Print section 3 of Bufr message.
!  
         CALL BUPRS3 (KSEC3, KTDLEN, KTDLST, KTDEXL, KTDEXP, KELEM, CNAMES) 
!                                                                       
!        Print expanded Bufr message.
!                                                                  
         CALL BUPRT (IONE, ONE, KSUP(6), KEL, CNAMES, CUNITS, CVALS, KVALS, &
	             VALUES, KSUP, KSEC1, ISTATUS)
!                                                                       
!        Loop back for next BUFR record.                                   
!                                                                       
      END DO LOOP
!                                                                       
!     End-of-file on input.                                             
!
      WRITE ( * , * ) 'BFDEMO: End-of-file on input.'  
      WRITE ( * , * ) ' ' 
      WRITE ( * , * ) '****************************************************' 
      WRITE ( * , * ) ' ' 
      WRITE ( * , * ) 'BFDEMO: Number of records processed = ', NMESSAGE 
      WRITE ( * , * ) 'BFDEMO: Number of decoding errors   = ', NUMERR 
      WRITE ( * , * ) ' ' 
      WRITE ( * , * ) '****************************************************'
! 
      CALL PBCLOSE (KUNIT, ISTATUS)
!                         
	  STOP 'BFDEMO: Terminated'
!                                       
      END PROGRAM BFDEMO                            

#!/bin/sh

cd ../
path=`pwd`

ECMWF_LOCAL_TABLE_PATH=$path/gribtables
export ECMWF_LOCAL_TABLE_PATH

LOCAL_DEFINITION_TEMPLATES=$path/gribtemplates
export LOCAL_DEFINITION_TEMPLATES

cd examples

./agrdemo -i ../data/latlon.grib

#!/bin/bash

# CRAY/82
./compile.sh

# CRAY/83
module load cray-mpich-compat/v7
./compile.sh 

# INTEL/140
module switch PrgEnv-cray PrgEnv-intel
./compile.sh 

# GNU/48
module switch PrgEnv-intel PrgEnv-gnu 
./compile.sh

#!/bin/bash
set -eux


#./ginout_c lsmN$1 LSM_GG_0$1
##./ginout lsm.N$1 LSM_GG_0$1


#for grib in LSM_GG_0640*.grib
#do
#  out="$(basename $grib .grib)_CY41R1"
#  ./ginout_c "$grib" "$out"
#done
#
#md5sum /usr/local/apps/libemos/tables/interpolation/LSM_GG_* LSM_GG_0640* | sort


#for T in 95 159 255 319 399 511 639 799 1279 2047
#do
#  N=$(( $(grib_get -p Nj "41r1/climate.v012/${T}l_2/lsm")/2 ))
#  in="41r1/climate.v012/${T}l_2/lsm"
#  out="LSM_GG_"$(printf "%04d" $N)"_CY41R1"
#  ./ginout_c "$in" "$out"
#done


./ginout_c2 40/climate/1023l_2/lsm            40/LSM_GG_0510
./ginout_c2 40/climate/1279l_2/lsm            40/LSM_GG_0640
./ginout_c2 40/climate/159l_2/lsm             40/LSM_GG_0080
./ginout_c2 40/climate/2047l_2/lsm            40/LSM_GG_1024
./ginout_c2 40/climate/255l_2/lsm             40/LSM_GG_0128
./ginout_c2 40/climate/319l_2/lsm             40/LSM_GG_0160
./ginout_c2 40/climate/3999l_2/lsm            40/LSM_GG_2000
./ginout_c2 40/climate/399l_2/lsm             40/LSM_GG_0200
./ginout_c2 40/climate/511l_2/lsm             40/LSM_GG_0256
./ginout_c2 40/climate/639l_2/lsm             40/LSM_GG_0320
./ginout_c2 40/climate/799l_2/lsm             40/LSM_GG_0400
./ginout_c2 40/climate/95l_2/lsm              40/LSM_GG_0048
./ginout_c2 41r1/climate.v012/1279l_2/lsm   41r1/LSM_GG_0640
./ginout_c2 41r1/climate.v012/159l_2/lsm    41r1/LSM_GG_0080
./ginout_c2 41r1/climate.v012/2047l_2/lsm   41r1/LSM_GG_1024
./ginout_c2 41r1/climate.v012/255l_2/lsm    41r1/LSM_GG_0128
./ginout_c2 41r1/climate.v012/319l_2/lsm    41r1/LSM_GG_0160
./ginout_c2 41r1/climate.v012/399l_2/lsm    41r1/LSM_GG_0200
./ginout_c2 41r1/climate.v012/511l_2/lsm    41r1/LSM_GG_0256
./ginout_c2 41r1/climate.v012/639l_2/lsm    41r1/LSM_GG_0320
./ginout_c2 41r1/climate.v012/799l_2/lsm    41r1/LSM_GG_0400
./ginout_c2 41r1/climate.v012/95l_2/lsm     41r1/LSM_GG_0048

#!/bin/ksh

set -e

in=$1
out=$2
# read grib message and write to file land mask as bit values

if [[ $# != 2 ]]
then
	echo "Syntax: $0 <infile> <outfile>"
	echo "Example: $0 /scratch/ma/mas/lsm.0.25 lsm.0.25.data"
	exit 1
fi

touch $out
p=./bitPack
grib_get_data -F "%g" $in | grep -v Value | less | awk '{print $3;}' | $p > $out

#!/bin/sh

. ./include.sh

#export JDCNDBG=1
#export INTF2_DEBUG=1

EMOSLIB_FILES=${src_dir}/tables/interpol
export EMOSLIB_FILES

compare="$grib_compare -P -T 2 -f"

tool=./interpolation
data=${src_dir}/tests/data_in
out=./data_out
ref=${src_dir}/tests/data_ref

mkdir -p $out

option=ll
x=spectral-ll.grib
file=spectral.grib

echo "******************************"
echo "     SH to LL             ****"
echo "******************************"
$tool $option $data/$file $out/$x
$compare ${ref}/$x $out/$x

option=qr
x=spectral-rg.grib

echo "******************************"
echo "     SH to RG             ****"
echo "******************************"
$tool $option $data/$file $out/$x
$compare ${ref}/$x $out/$x

#!/bin/sh
set -e

. ./include.sh

#rm -f tracks_05W_PEIPAH_2014041000.eps.bufr4 tracks_05W_PEIPAH_2014041000.eps.bufr

echo "${tools_dir}/tc_tracks_eps -i ${tests_dir}/tc_tracks/tracks_05W_PEIPAH_2014041000.fm -o ${tests_bin_dir}/tracks_05W_PEIPAH_2014041000.eps.bufr"

${tools_dir}/tc_tracks_eps -i ${tests_dir}/tc_tracks/tracks_05W_PEIPAH_2014041000.fm -o ${tests_bin_dir}/tracks_05W_PEIPAH_2014041000.eps.bufr
${tools_dir}/tc_tracks_eps -4 -i ${tests_dir}/tc_tracks/tracks_05W_PEIPAH_2014041000.fm -o ${tests_bin_dir}/tracks_05W_PEIPAH_2014041000.eps.bufr4
cmp ${tests_bin_dir}/tracks_05W_PEIPAH_2014041000.eps.bufr4 ${tests_dir}/tc_tracks/tracks_05W_PEIPAH_2014041000.eps.bufr4
cmp ${tests_bin_dir}/tracks_05W_PEIPAH_2014041000.eps.bufr ${tests_dir}/tc_tracks/tracks_05W_PEIPAH_2014041000.eps.bufr


${tools_dir}/tc_tracks_det -i ${tests_dir}/tc_tracks/tracks_15U_ITA_2014041012.fm -o ${tests_bin_dir}/tracks_15U_ITA_2014041012.det.bufr
${tools_dir}/tc_tracks_det -4 -i ${tests_dir}/tc_tracks/tracks_15U_ITA_2014041012.fm -o ${tests_bin_dir}/tracks_15U_ITA_2014041012.det.bufr4

cmp ${tests_bin_dir}/tracks_15U_ITA_2014041012.det.bufr ${tests_dir}/tc_tracks/tracks_15U_ITA_2014041012.det.bufr
cmp ${tests_bin_dir}/tracks_15U_ITA_2014041012.det.bufr4 ${tests_dir}/tc_tracks/tracks_15U_ITA_2014041012.det.bufr4

#!/bin/bash

# Initialise module environment if it is not
if [[ ! $(command -v module > /dev/null 2>&1) ]]; then
  . /usr/local/apps/module/init/bash
fi
# grib_api module conflicts with intel module
module unload grib_api
module switch gnu intel/15.0.2
